var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a, prop, b2[prop]);
    }
  return a;
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import * as React from "react";
import React__default, { useState, useMemo as useMemo$1, useRef, useEffect, createContext, useContext, useLayoutEffect as useLayoutEffect$1, forwardRef, useImperativeHandle, useCallback, Component } from "react";
var __read$3 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useToggle(defaultValue, reverseValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$3(useState(defaultValue), 2), state = _a2[0], setState = _a2[1];
  var actions2 = useMemo$1(function() {
    var reverseValueOrigin = reverseValue === void 0 ? !defaultValue : reverseValue;
    var toggle = function toggle2() {
      return setState(function(s) {
        return s === defaultValue ? reverseValueOrigin : defaultValue;
      });
    };
    var set2 = function set3(value) {
      return setState(value);
    };
    var setLeft = function setLeft2() {
      return setState(defaultValue);
    };
    var setRight = function setRight2() {
      return setState(reverseValueOrigin);
    };
    return {
      toggle,
      set: set2,
      setLeft,
      setRight
    };
  }, []);
  return [state, actions2];
}
var __read$2 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useBoolean(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$2(useToggle(defaultValue), 2), state = _a2[0], _b2 = _a2[1], toggle = _b2.toggle, _set = _b2.set;
  var actions2 = useMemo$1(function() {
    var setTrue = function setTrue2() {
      return _set(true);
    };
    var setFalse = function setFalse2() {
      return _set(false);
    };
    return {
      toggle,
      set: function set2(v4) {
        return _set(!!v4);
      },
      setTrue,
      setFalse
    };
  }, []);
  return [state, actions2];
}
function useLatest(value) {
  var ref = useRef(value);
  ref.current = value;
  return ref;
}
var isBrowser$1 = !!(typeof window !== "undefined" && window.document && window.document.createElement);
var isBrowser$2 = isBrowser$1;
function getTargetElement(target, defaultElement) {
  if (!isBrowser$2) {
    return void 0;
  }
  if (!target) {
    return defaultElement;
  }
  var targetElement;
  if (typeof target === "function") {
    targetElement = target();
  } else if ("current" in target) {
    targetElement = target.current;
  } else {
    targetElement = target;
  }
  return targetElement;
}
var useUnmount = function useUnmount2(fn) {
  var fnRef = useLatest(fn);
  useEffect(function() {
    return function() {
      fnRef.current();
    };
  }, []);
};
var useUnmount$1 = useUnmount;
function depsAreSame(oldDeps, deps) {
  if (oldDeps === deps)
    return true;
  for (var i = 0; i < oldDeps.length; i++) {
    if (!Object.is(oldDeps[i], deps[i]))
      return false;
  }
  return true;
}
var createEffectWithTarget = function createEffectWithTarget2(useEffectType) {
  var useEffectWithTarget2 = function useEffectWithTarget3(effect, deps, target) {
    var hasInitRef = useRef(false);
    var lastElementRef = useRef([]);
    var lastDepsRef = useRef([]);
    var unLoadRef = useRef();
    useEffectType(function() {
      var _a2;
      var targets = Array.isArray(target) ? target : [target];
      var els = targets.map(function(item) {
        return getTargetElement(item);
      });
      if (!hasInitRef.current) {
        hasInitRef.current = true;
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
        return;
      }
      if (els.length !== lastElementRef.current.length || !depsAreSame(els, lastElementRef.current) || !depsAreSame(deps, lastDepsRef.current)) {
        (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
      }
    });
    useUnmount$1(function() {
      var _a2;
      (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
      hasInitRef.current = false;
    });
  };
  return useEffectWithTarget2;
};
var createEffectWithTarget$1 = createEffectWithTarget;
var useEffectWithTarget = createEffectWithTarget$1(useEffect);
var useEffectWithTarget$1 = useEffectWithTarget;
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x2) {
  return x2 && x2.__esModule && Object.prototype.hasOwnProperty.call(x2, "default") ? x2["default"] : x2;
}
function isObject$9(value) {
  var type4 = typeof value;
  return value != null && (type4 == "object" || type4 == "function");
}
var isObject_1 = isObject$9;
var freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var _freeGlobal = freeGlobal$1;
var freeGlobal = _freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root$9 = freeGlobal || freeSelf || Function("return this")();
var _root = root$9;
var root$8 = _root;
var now$1 = function() {
  return root$8.Date.now();
};
var now_1 = now$1;
var reWhitespace = /\s/;
function trimmedEndIndex$1(string3) {
  var index2 = string3.length;
  while (index2-- && reWhitespace.test(string3.charAt(index2))) {
  }
  return index2;
}
var _trimmedEndIndex = trimmedEndIndex$1;
var trimmedEndIndex = _trimmedEndIndex;
var reTrimStart = /^\s+/;
function baseTrim$1(string3) {
  return string3 ? string3.slice(0, trimmedEndIndex(string3) + 1).replace(reTrimStart, "") : string3;
}
var _baseTrim = baseTrim$1;
var root$7 = _root;
var Symbol$5 = root$7.Symbol;
var _Symbol = Symbol$5;
var Symbol$4 = _Symbol;
var objectProto$b = Object.prototype;
var hasOwnProperty$9 = objectProto$b.hasOwnProperty;
var nativeObjectToString$1 = objectProto$b.toString;
var symToStringTag$1 = Symbol$4 ? Symbol$4.toStringTag : void 0;
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$9.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e2) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var _getRawTag = getRawTag$1;
var objectProto$a = Object.prototype;
var nativeObjectToString = objectProto$a.toString;
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}
var _objectToString = objectToString$1;
var Symbol$3 = _Symbol, getRawTag = _getRawTag, objectToString = _objectToString;
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$3 ? Symbol$3.toStringTag : void 0;
function baseGetTag$5(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
var _baseGetTag = baseGetTag$5;
function isObjectLike$5(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_1 = isObjectLike$5;
var baseGetTag$4 = _baseGetTag, isObjectLike$4 = isObjectLike_1;
var symbolTag$1 = "[object Symbol]";
function isSymbol$1(value) {
  return typeof value == "symbol" || isObjectLike$4(value) && baseGetTag$4(value) == symbolTag$1;
}
var isSymbol_1 = isSymbol$1;
var baseTrim = _baseTrim, isObject$8 = isObject_1, isSymbol = isSymbol_1;
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber$1(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject$8(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject$8(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var toNumber_1 = toNumber$1;
var isObject$7 = isObject_1, now = now_1, toNumber = toNumber_1;
var FUNC_ERROR_TEXT = "Expected a function";
var nativeMax = Math.max, nativeMin = Math.min;
function debounce(func, wait, options) {
  var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject$7(options)) {
    leading = !!options.leading;
    maxing = "maxWait" in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs, thisArg = lastThis;
    lastArgs = lastThis = void 0;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    lastInvokeTime = time;
    timerId = setTimeout(timerExpired, wait);
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
    return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
    return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = void 0;
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = void 0;
    return result;
  }
  function cancel2() {
    if (timerId !== void 0) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = void 0;
  }
  function flush() {
    return timerId === void 0 ? result : trailingEdge(now());
  }
  function debounced() {
    var time = now(), isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === void 0) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === void 0) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel2;
  debounced.flush = flush;
  return debounced;
}
var debounce_1 = debounce;
var __read$1 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
var __spread = globalThis && globalThis.__spread || function() {
  for (var ar = [], i = 0; i < arguments.length; i++) {
    ar = ar.concat(__read$1(arguments[i]));
  }
  return ar;
};
function useDebounceFn(fn, options) {
  var _a2;
  var fnRef = useLatest(fn);
  var wait = (_a2 = options === null || options === void 0 ? void 0 : options.wait) !== null && _a2 !== void 0 ? _a2 : 1e3;
  var debounced = useMemo$1(function() {
    return debounce_1(function() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return fnRef.current.apply(fnRef, __spread(args));
    }, wait, options);
  }, []);
  useUnmount$1(function() {
    debounced.cancel();
  });
  return {
    run: debounced,
    cancel: debounced.cancel,
    flush: debounced.flush
  };
}
var createUpdateEffect = function createUpdateEffect2(hook) {
  return function(effect, deps) {
    var isMounted = useRef(false);
    hook(function() {
      return function() {
        isMounted.current = false;
      };
    }, []);
    hook(function() {
      if (!isMounted.current) {
        isMounted.current = true;
      } else {
        return effect();
      }
    }, deps);
  };
};
var useUpdateEffect = createUpdateEffect(useEffect);
var __read = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useDebounceEffect(effect, deps, options) {
  var _a2 = __read(useState({}), 2), flag = _a2[0], setFlag = _a2[1];
  var _b2 = useDebounceFn(function() {
    setFlag({});
  }, options), run = _b2.run, cancel2 = _b2.cancel;
  useEffect(function() {
    return run();
  }, deps);
  useUnmount$1(cancel2);
  useUpdateEffect(effect, [flag]);
}
function listCacheClear$1() {
  this.__data__ = [];
  this.size = 0;
}
var _listCacheClear = listCacheClear$1;
function eq$2(value, other) {
  return value === other || value !== value && other !== other;
}
var eq_1 = eq$2;
var eq$1 = eq_1;
function assocIndexOf$4(array4, key) {
  var length = array4.length;
  while (length--) {
    if (eq$1(array4[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var _assocIndexOf = assocIndexOf$4;
var assocIndexOf$3 = _assocIndexOf;
var arrayProto$1 = Array.prototype;
var splice = arrayProto$1.splice;
function listCacheDelete$1(key) {
  var data = this.__data__, index2 = assocIndexOf$3(data, key);
  if (index2 < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index2 == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index2, 1);
  }
  --this.size;
  return true;
}
var _listCacheDelete = listCacheDelete$1;
var assocIndexOf$2 = _assocIndexOf;
function listCacheGet$2(key) {
  var data = this.__data__, index2 = assocIndexOf$2(data, key);
  return index2 < 0 ? void 0 : data[index2][1];
}
var _listCacheGet = listCacheGet$2;
var assocIndexOf$1 = _assocIndexOf;
function listCacheHas$1(key) {
  return assocIndexOf$1(this.__data__, key) > -1;
}
var _listCacheHas = listCacheHas$1;
var assocIndexOf = _assocIndexOf;
function listCacheSet$2(key, value) {
  var data = this.__data__, index2 = assocIndexOf(data, key);
  if (index2 < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index2][1] = value;
  }
  return this;
}
var _listCacheSet = listCacheSet$2;
var listCacheClear = _listCacheClear, listCacheDelete = _listCacheDelete, listCacheGet$1 = _listCacheGet, listCacheHas = _listCacheHas, listCacheSet$1 = _listCacheSet;
function ListCache$4(entries) {
  var index2 = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index2 < length) {
    var entry = entries[index2];
    this.set(entry[0], entry[1]);
  }
}
ListCache$4.prototype.clear = listCacheClear;
ListCache$4.prototype["delete"] = listCacheDelete;
ListCache$4.prototype.get = listCacheGet$1;
ListCache$4.prototype.has = listCacheHas;
ListCache$4.prototype.set = listCacheSet$1;
var _ListCache = ListCache$4;
var ListCache$3 = _ListCache;
function stackClear$1() {
  this.__data__ = new ListCache$3();
  this.size = 0;
}
var _stackClear = stackClear$1;
function stackDelete$1(key) {
  var data = this.__data__, result = data["delete"](key);
  this.size = data.size;
  return result;
}
var _stackDelete = stackDelete$1;
function stackGet$1(key) {
  return this.__data__.get(key);
}
var _stackGet = stackGet$1;
function stackHas$1(key) {
  return this.__data__.has(key);
}
var _stackHas = stackHas$1;
var baseGetTag$3 = _baseGetTag, isObject$6 = isObject_1;
var asyncTag = "[object AsyncFunction]", funcTag$1 = "[object Function]", genTag = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
function isFunction$3(value) {
  if (!isObject$6(value)) {
    return false;
  }
  var tag = baseGetTag$3(value);
  return tag == funcTag$1 || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var isFunction_1 = isFunction$3;
var root$6 = _root;
var coreJsData$1 = root$6["__core-js_shared__"];
var _coreJsData = coreJsData$1;
var coreJsData = _coreJsData;
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked$1(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var _isMasked = isMasked$1;
var funcProto$1 = Function.prototype;
var funcToString$1 = funcProto$1.toString;
function toSource$2(func) {
  if (func != null) {
    try {
      return funcToString$1.call(func);
    } catch (e2) {
    }
    try {
      return func + "";
    } catch (e2) {
    }
  }
  return "";
}
var _toSource = toSource$2;
var isFunction$2 = isFunction_1, isMasked = _isMasked, isObject$5 = isObject_1, toSource$1 = _toSource;
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto = Function.prototype, objectProto$9 = Object.prototype;
var funcToString = funcProto.toString;
var hasOwnProperty$8 = objectProto$9.hasOwnProperty;
var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty$8).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function baseIsNative$1(value) {
  if (!isObject$5(value) || isMasked(value)) {
    return false;
  }
  var pattern4 = isFunction$2(value) ? reIsNative : reIsHostCtor;
  return pattern4.test(toSource$1(value));
}
var _baseIsNative = baseIsNative$1;
function getValue$4(object4, key) {
  return object4 == null ? void 0 : object4[key];
}
var _getValue = getValue$4;
var baseIsNative = _baseIsNative, getValue$3 = _getValue;
function getNative$6(object4, key) {
  var value = getValue$3(object4, key);
  return baseIsNative(value) ? value : void 0;
}
var _getNative = getNative$6;
var getNative$5 = _getNative, root$5 = _root;
var Map$4 = getNative$5(root$5, "Map");
var _Map = Map$4;
var getNative$4 = _getNative;
var nativeCreate$4 = getNative$4(Object, "create");
var _nativeCreate = nativeCreate$4;
var nativeCreate$3 = _nativeCreate;
function hashClear$1() {
  this.__data__ = nativeCreate$3 ? nativeCreate$3(null) : {};
  this.size = 0;
}
var _hashClear = hashClear$1;
function hashDelete$1(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var _hashDelete = hashDelete$1;
var nativeCreate$2 = _nativeCreate;
var HASH_UNDEFINED$2 = "__lodash_hash_undefined__";
var objectProto$8 = Object.prototype;
var hasOwnProperty$7 = objectProto$8.hasOwnProperty;
function hashGet$1(key) {
  var data = this.__data__;
  if (nativeCreate$2) {
    var result = data[key];
    return result === HASH_UNDEFINED$2 ? void 0 : result;
  }
  return hasOwnProperty$7.call(data, key) ? data[key] : void 0;
}
var _hashGet = hashGet$1;
var nativeCreate$1 = _nativeCreate;
var objectProto$7 = Object.prototype;
var hasOwnProperty$6 = objectProto$7.hasOwnProperty;
function hashHas$1(key) {
  var data = this.__data__;
  return nativeCreate$1 ? data[key] !== void 0 : hasOwnProperty$6.call(data, key);
}
var _hashHas = hashHas$1;
var nativeCreate = _nativeCreate;
var HASH_UNDEFINED$1 = "__lodash_hash_undefined__";
function hashSet$1(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED$1 : value;
  return this;
}
var _hashSet = hashSet$1;
var hashClear = _hashClear, hashDelete = _hashDelete, hashGet = _hashGet, hashHas = _hashHas, hashSet = _hashSet;
function Hash$1(entries) {
  var index2 = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index2 < length) {
    var entry = entries[index2];
    this.set(entry[0], entry[1]);
  }
}
Hash$1.prototype.clear = hashClear;
Hash$1.prototype["delete"] = hashDelete;
Hash$1.prototype.get = hashGet;
Hash$1.prototype.has = hashHas;
Hash$1.prototype.set = hashSet;
var _Hash = Hash$1;
var Hash = _Hash, ListCache$2 = _ListCache, Map$3 = _Map;
function mapCacheClear$1() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash(),
    "map": new (Map$3 || ListCache$2)(),
    "string": new Hash()
  };
}
var _mapCacheClear = mapCacheClear$1;
function isKeyable$1(value) {
  var type4 = typeof value;
  return type4 == "string" || type4 == "number" || type4 == "symbol" || type4 == "boolean" ? value !== "__proto__" : value === null;
}
var _isKeyable = isKeyable$1;
var isKeyable = _isKeyable;
function getMapData$4(map2, key) {
  var data = map2.__data__;
  return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
var _getMapData = getMapData$4;
var getMapData$3 = _getMapData;
function mapCacheDelete$1(key) {
  var result = getMapData$3(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
var _mapCacheDelete = mapCacheDelete$1;
var getMapData$2 = _getMapData;
function mapCacheGet$1(key) {
  return getMapData$2(this, key).get(key);
}
var _mapCacheGet = mapCacheGet$1;
var getMapData$1 = _getMapData;
function mapCacheHas$1(key) {
  return getMapData$1(this, key).has(key);
}
var _mapCacheHas = mapCacheHas$1;
var getMapData = _getMapData;
function mapCacheSet$1(key, value) {
  var data = getMapData(this, key), size = data.size;
  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}
var _mapCacheSet = mapCacheSet$1;
var mapCacheClear = _mapCacheClear, mapCacheDelete = _mapCacheDelete, mapCacheGet = _mapCacheGet, mapCacheHas = _mapCacheHas, mapCacheSet = _mapCacheSet;
function MapCache$2(entries) {
  var index2 = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index2 < length) {
    var entry = entries[index2];
    this.set(entry[0], entry[1]);
  }
}
MapCache$2.prototype.clear = mapCacheClear;
MapCache$2.prototype["delete"] = mapCacheDelete;
MapCache$2.prototype.get = mapCacheGet;
MapCache$2.prototype.has = mapCacheHas;
MapCache$2.prototype.set = mapCacheSet;
var _MapCache = MapCache$2;
var ListCache$1 = _ListCache, Map$2 = _Map, MapCache$1 = _MapCache;
var LARGE_ARRAY_SIZE = 200;
function stackSet$1(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache$1) {
    var pairs = data.__data__;
    if (!Map$2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache$1(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}
var _stackSet = stackSet$1;
var ListCache = _ListCache, stackClear = _stackClear, stackDelete = _stackDelete, stackGet = _stackGet, stackHas = _stackHas, stackSet = _stackSet;
function Stack$1(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}
Stack$1.prototype.clear = stackClear;
Stack$1.prototype["delete"] = stackDelete;
Stack$1.prototype.get = stackGet;
Stack$1.prototype.has = stackHas;
Stack$1.prototype.set = stackSet;
var _Stack = Stack$1;
var HASH_UNDEFINED = "__lodash_hash_undefined__";
function setCacheAdd$1(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}
var _setCacheAdd = setCacheAdd$1;
function setCacheHas$1(value) {
  return this.__data__.has(value);
}
var _setCacheHas = setCacheHas$1;
var MapCache = _MapCache, setCacheAdd = _setCacheAdd, setCacheHas = _setCacheHas;
function SetCache$1(values) {
  var index2 = -1, length = values == null ? 0 : values.length;
  this.__data__ = new MapCache();
  while (++index2 < length) {
    this.add(values[index2]);
  }
}
SetCache$1.prototype.add = SetCache$1.prototype.push = setCacheAdd;
SetCache$1.prototype.has = setCacheHas;
var _SetCache = SetCache$1;
function arraySome$1(array4, predicate) {
  var index2 = -1, length = array4 == null ? 0 : array4.length;
  while (++index2 < length) {
    if (predicate(array4[index2], index2, array4)) {
      return true;
    }
  }
  return false;
}
var _arraySome = arraySome$1;
function cacheHas$1(cache, key) {
  return cache.has(key);
}
var _cacheHas = cacheHas$1;
var SetCache = _SetCache, arraySome = _arraySome, cacheHas = _cacheHas;
var COMPARE_PARTIAL_FLAG$3 = 1, COMPARE_UNORDERED_FLAG$1 = 2;
function equalArrays$2(array4, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3, arrLength = array4.length, othLength = other.length;
  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  var arrStacked = stack.get(array4);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array4;
  }
  var index2 = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG$1 ? new SetCache() : void 0;
  stack.set(array4, other);
  stack.set(other, array4);
  while (++index2 < arrLength) {
    var arrValue = array4[index2], othValue = other[index2];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, arrValue, index2, other, array4, stack) : customizer(arrValue, othValue, index2, array4, other, stack);
    }
    if (compared !== void 0) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    if (seen) {
      if (!arraySome(other, function(othValue2, othIndex) {
        if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
          return seen.push(othIndex);
        }
      })) {
        result = false;
        break;
      }
    } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
      result = false;
      break;
    }
  }
  stack["delete"](array4);
  stack["delete"](other);
  return result;
}
var _equalArrays = equalArrays$2;
var root$4 = _root;
var Uint8Array$2 = root$4.Uint8Array;
var _Uint8Array = Uint8Array$2;
function mapToArray$1(map2) {
  var index2 = -1, result = Array(map2.size);
  map2.forEach(function(value, key) {
    result[++index2] = [key, value];
  });
  return result;
}
var _mapToArray = mapToArray$1;
function setToArray$1(set2) {
  var index2 = -1, result = Array(set2.size);
  set2.forEach(function(value) {
    result[++index2] = value;
  });
  return result;
}
var _setToArray = setToArray$1;
var Symbol$2 = _Symbol, Uint8Array$1 = _Uint8Array, eq = eq_1, equalArrays$1 = _equalArrays, mapToArray = _mapToArray, setToArray = _setToArray;
var COMPARE_PARTIAL_FLAG$2 = 1, COMPARE_UNORDERED_FLAG = 2;
var boolTag$1 = "[object Boolean]", dateTag$1 = "[object Date]", errorTag$1 = "[object Error]", mapTag$2 = "[object Map]", numberTag$1 = "[object Number]", regexpTag$1 = "[object RegExp]", setTag$2 = "[object Set]", stringTag$1 = "[object String]", symbolTag = "[object Symbol]";
var arrayBufferTag$1 = "[object ArrayBuffer]", dataViewTag$2 = "[object DataView]";
var symbolProto = Symbol$2 ? Symbol$2.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
function equalByTag$1(object4, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag$2:
      if (object4.byteLength != other.byteLength || object4.byteOffset != other.byteOffset) {
        return false;
      }
      object4 = object4.buffer;
      other = other.buffer;
    case arrayBufferTag$1:
      if (object4.byteLength != other.byteLength || !equalFunc(new Uint8Array$1(object4), new Uint8Array$1(other))) {
        return false;
      }
      return true;
    case boolTag$1:
    case dateTag$1:
    case numberTag$1:
      return eq(+object4, +other);
    case errorTag$1:
      return object4.name == other.name && object4.message == other.message;
    case regexpTag$1:
    case stringTag$1:
      return object4 == other + "";
    case mapTag$2:
      var convert = mapToArray;
    case setTag$2:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$2;
      convert || (convert = setToArray);
      if (object4.size != other.size && !isPartial) {
        return false;
      }
      var stacked = stack.get(object4);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;
      stack.set(object4, other);
      var result = equalArrays$1(convert(object4), convert(other), bitmask, customizer, equalFunc, stack);
      stack["delete"](object4);
      return result;
    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object4) == symbolValueOf.call(other);
      }
  }
  return false;
}
var _equalByTag = equalByTag$1;
function arrayPush$1(array4, values) {
  var index2 = -1, length = values.length, offset2 = array4.length;
  while (++index2 < length) {
    array4[offset2 + index2] = values[index2];
  }
  return array4;
}
var _arrayPush = arrayPush$1;
var isArray$5 = Array.isArray;
var isArray_1 = isArray$5;
var arrayPush = _arrayPush, isArray$4 = isArray_1;
function baseGetAllKeys$1(object4, keysFunc, symbolsFunc) {
  var result = keysFunc(object4);
  return isArray$4(object4) ? result : arrayPush(result, symbolsFunc(object4));
}
var _baseGetAllKeys = baseGetAllKeys$1;
function arrayFilter$1(array4, predicate) {
  var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result = [];
  while (++index2 < length) {
    var value = array4[index2];
    if (predicate(value, index2, array4)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var _arrayFilter = arrayFilter$1;
function stubArray$1() {
  return [];
}
var stubArray_1 = stubArray$1;
var arrayFilter = _arrayFilter, stubArray = stubArray_1;
var objectProto$6 = Object.prototype;
var propertyIsEnumerable$1 = objectProto$6.propertyIsEnumerable;
var nativeGetSymbols = Object.getOwnPropertySymbols;
var getSymbols$1 = !nativeGetSymbols ? stubArray : function(object4) {
  if (object4 == null) {
    return [];
  }
  object4 = Object(object4);
  return arrayFilter(nativeGetSymbols(object4), function(symbol) {
    return propertyIsEnumerable$1.call(object4, symbol);
  });
};
var _getSymbols = getSymbols$1;
function baseTimes$1(n2, iteratee) {
  var index2 = -1, result = Array(n2);
  while (++index2 < n2) {
    result[index2] = iteratee(index2);
  }
  return result;
}
var _baseTimes = baseTimes$1;
var baseGetTag$2 = _baseGetTag, isObjectLike$3 = isObjectLike_1;
var argsTag$2 = "[object Arguments]";
function baseIsArguments$1(value) {
  return isObjectLike$3(value) && baseGetTag$2(value) == argsTag$2;
}
var _baseIsArguments = baseIsArguments$1;
var baseIsArguments = _baseIsArguments, isObjectLike$2 = isObjectLike_1;
var objectProto$5 = Object.prototype;
var hasOwnProperty$5 = objectProto$5.hasOwnProperty;
var propertyIsEnumerable = objectProto$5.propertyIsEnumerable;
var isArguments$1 = baseIsArguments(function() {
  return arguments;
}()) ? baseIsArguments : function(value) {
  return isObjectLike$2(value) && hasOwnProperty$5.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
};
var isArguments_1 = isArguments$1;
var isBuffer$2 = { exports: {} };
function stubFalse() {
  return false;
}
var stubFalse_1 = stubFalse;
(function(module, exports) {
  var root2 = _root, stubFalse2 = stubFalse_1;
  var freeExports = exports && !exports.nodeType && exports;
  var freeModule = freeExports && true && module && !module.nodeType && module;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var Buffer2 = moduleExports ? root2.Buffer : void 0;
  var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
  var isBuffer2 = nativeIsBuffer || stubFalse2;
  module.exports = isBuffer2;
})(isBuffer$2, isBuffer$2.exports);
var MAX_SAFE_INTEGER$2 = 9007199254740991;
var reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex$1(value, length) {
  var type4 = typeof value;
  length = length == null ? MAX_SAFE_INTEGER$2 : length;
  return !!length && (type4 == "number" || type4 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
var _isIndex = isIndex$1;
var MAX_SAFE_INTEGER$1 = 9007199254740991;
function isLength$2(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$1;
}
var isLength_1 = isLength$2;
var baseGetTag$1 = _baseGetTag, isLength$1 = isLength_1, isObjectLike$1 = isObjectLike_1;
var argsTag$1 = "[object Arguments]", arrayTag$1 = "[object Array]", boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", funcTag = "[object Function]", mapTag$1 = "[object Map]", numberTag = "[object Number]", objectTag$2 = "[object Object]", regexpTag = "[object RegExp]", setTag$1 = "[object Set]", stringTag = "[object String]", weakMapTag$1 = "[object WeakMap]";
var arrayBufferTag = "[object ArrayBuffer]", dataViewTag$1 = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag$1] = typedArrayTags[arrayTag$1] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag$1] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag$1] = typedArrayTags[numberTag] = typedArrayTags[objectTag$2] = typedArrayTags[regexpTag] = typedArrayTags[setTag$1] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag$1] = false;
function baseIsTypedArray$1(value) {
  return isObjectLike$1(value) && isLength$1(value.length) && !!typedArrayTags[baseGetTag$1(value)];
}
var _baseIsTypedArray = baseIsTypedArray$1;
function baseUnary$1(func) {
  return function(value) {
    return func(value);
  };
}
var _baseUnary = baseUnary$1;
var _nodeUtil = { exports: {} };
(function(module, exports) {
  var freeGlobal2 = _freeGlobal;
  var freeExports = exports && !exports.nodeType && exports;
  var freeModule = freeExports && true && module && !module.nodeType && module;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var freeProcess = moduleExports && freeGlobal2.process;
  var nodeUtil2 = function() {
    try {
      var types2 = freeModule && freeModule.require && freeModule.require("util").types;
      if (types2) {
        return types2;
      }
      return freeProcess && freeProcess.binding && freeProcess.binding("util");
    } catch (e2) {
    }
  }();
  module.exports = nodeUtil2;
})(_nodeUtil, _nodeUtil.exports);
var baseIsTypedArray = _baseIsTypedArray, baseUnary = _baseUnary, nodeUtil = _nodeUtil.exports;
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
var isTypedArray$3 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
var isTypedArray_1 = isTypedArray$3;
var baseTimes = _baseTimes, isArguments = isArguments_1, isArray$3 = isArray_1, isBuffer$1 = isBuffer$2.exports, isIndex = _isIndex, isTypedArray$2 = isTypedArray_1;
var objectProto$4 = Object.prototype;
var hasOwnProperty$4 = objectProto$4.hasOwnProperty;
function arrayLikeKeys$1(value, inherited) {
  var isArr = isArray$3(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer$1(value), isType = !isArr && !isArg && !isBuff && isTypedArray$2(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty$4.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
var _arrayLikeKeys = arrayLikeKeys$1;
var objectProto$3 = Object.prototype;
function isPrototype$1(value) {
  var Ctor = value && value.constructor, proto2 = typeof Ctor == "function" && Ctor.prototype || objectProto$3;
  return value === proto2;
}
var _isPrototype = isPrototype$1;
function overArg$1(func, transform2) {
  return function(arg) {
    return func(transform2(arg));
  };
}
var _overArg = overArg$1;
var overArg = _overArg;
var nativeKeys$1 = overArg(Object.keys, Object);
var _nativeKeys = nativeKeys$1;
var isPrototype = _isPrototype, nativeKeys = _nativeKeys;
var objectProto$2 = Object.prototype;
var hasOwnProperty$3 = objectProto$2.hasOwnProperty;
function baseKeys$1(object4) {
  if (!isPrototype(object4)) {
    return nativeKeys(object4);
  }
  var result = [];
  for (var key in Object(object4)) {
    if (hasOwnProperty$3.call(object4, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
var _baseKeys = baseKeys$1;
var isFunction$1 = isFunction_1, isLength = isLength_1;
function isArrayLike$2(value) {
  return value != null && isLength(value.length) && !isFunction$1(value);
}
var isArrayLike_1 = isArrayLike$2;
var arrayLikeKeys = _arrayLikeKeys, baseKeys = _baseKeys, isArrayLike$1 = isArrayLike_1;
function keys$2(object4) {
  return isArrayLike$1(object4) ? arrayLikeKeys(object4) : baseKeys(object4);
}
var keys_1 = keys$2;
var baseGetAllKeys = _baseGetAllKeys, getSymbols = _getSymbols, keys$1 = keys_1;
function getAllKeys$1(object4) {
  return baseGetAllKeys(object4, keys$1, getSymbols);
}
var _getAllKeys = getAllKeys$1;
var getAllKeys = _getAllKeys;
var COMPARE_PARTIAL_FLAG$1 = 1;
var objectProto$1 = Object.prototype;
var hasOwnProperty$2 = objectProto$1.hasOwnProperty;
function equalObjects$1(object4, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$1, objProps = getAllKeys(object4), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index2 = objLength;
  while (index2--) {
    var key = objProps[index2];
    if (!(isPartial ? key in other : hasOwnProperty$2.call(other, key))) {
      return false;
    }
  }
  var objStacked = stack.get(object4);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object4;
  }
  var result = true;
  stack.set(object4, other);
  stack.set(other, object4);
  var skipCtor = isPartial;
  while (++index2 < objLength) {
    key = objProps[index2];
    var objValue = object4[key], othValue = other[key];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, objValue, key, other, object4, stack) : customizer(objValue, othValue, key, object4, other, stack);
    }
    if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == "constructor");
  }
  if (result && !skipCtor) {
    var objCtor = object4.constructor, othCtor = other.constructor;
    if (objCtor != othCtor && ("constructor" in object4 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack["delete"](object4);
  stack["delete"](other);
  return result;
}
var _equalObjects = equalObjects$1;
var getNative$3 = _getNative, root$3 = _root;
var DataView$3 = getNative$3(root$3, "DataView");
var _DataView = DataView$3;
var getNative$2 = _getNative, root$2 = _root;
var Promise$2 = getNative$2(root$2, "Promise");
var _Promise = Promise$2;
var getNative$1 = _getNative, root$1 = _root;
var Set$2 = getNative$1(root$1, "Set");
var _Set = Set$2;
var getNative = _getNative, root = _root;
var WeakMap$4 = getNative(root, "WeakMap");
var _WeakMap = WeakMap$4;
var DataView$2 = _DataView, Map$1 = _Map, Promise$1 = _Promise, Set$1 = _Set, WeakMap$3 = _WeakMap, baseGetTag = _baseGetTag, toSource = _toSource;
var mapTag = "[object Map]", objectTag$1 = "[object Object]", promiseTag = "[object Promise]", setTag = "[object Set]", weakMapTag = "[object WeakMap]";
var dataViewTag = "[object DataView]";
var dataViewCtorString = toSource(DataView$2), mapCtorString = toSource(Map$1), promiseCtorString = toSource(Promise$1), setCtorString = toSource(Set$1), weakMapCtorString = toSource(WeakMap$3);
var getTag$1 = baseGetTag;
if (DataView$2 && getTag$1(new DataView$2(new ArrayBuffer(1))) != dataViewTag || Map$1 && getTag$1(new Map$1()) != mapTag || Promise$1 && getTag$1(Promise$1.resolve()) != promiseTag || Set$1 && getTag$1(new Set$1()) != setTag || WeakMap$3 && getTag$1(new WeakMap$3()) != weakMapTag) {
  getTag$1 = function(value) {
    var result = baseGetTag(value), Ctor = result == objectTag$1 ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag;
        case mapCtorString:
          return mapTag;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag;
        case weakMapCtorString:
          return weakMapTag;
      }
    }
    return result;
  };
}
var _getTag = getTag$1;
var Stack = _Stack, equalArrays = _equalArrays, equalByTag = _equalByTag, equalObjects = _equalObjects, getTag = _getTag, isArray$2 = isArray_1, isBuffer = isBuffer$2.exports, isTypedArray$1 = isTypedArray_1;
var COMPARE_PARTIAL_FLAG = 1;
var argsTag = "[object Arguments]", arrayTag = "[object Array]", objectTag = "[object Object]";
var objectProto = Object.prototype;
var hasOwnProperty$1 = objectProto.hasOwnProperty;
function baseIsEqualDeep$1(object4, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray$2(object4), othIsArr = isArray$2(other), objTag = objIsArr ? arrayTag : getTag(object4), othTag = othIsArr ? arrayTag : getTag(other);
  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;
  var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
  if (isSameTag && isBuffer(object4)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack());
    return objIsArr || isTypedArray$1(object4) ? equalArrays(object4, other, bitmask, customizer, equalFunc, stack) : equalByTag(object4, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty$1.call(object4, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty$1.call(other, "__wrapped__");
    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object4.value() : object4, othUnwrapped = othIsWrapped ? other.value() : other;
      stack || (stack = new Stack());
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack());
  return equalObjects(object4, other, bitmask, customizer, equalFunc, stack);
}
var _baseIsEqualDeep = baseIsEqualDeep$1;
var baseIsEqualDeep = _baseIsEqualDeep, isObjectLike = isObjectLike_1;
function baseIsEqual$1(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual$1, stack);
}
var _baseIsEqual = baseIsEqual$1;
var baseIsEqual = _baseIsEqual;
function isEqual(value, other) {
  return baseIsEqual(value, other);
}
var isEqual_1 = isEqual;
function useEventListener(eventName, handler, options) {
  if (options === void 0) {
    options = {};
  }
  var handlerRef = useLatest(handler);
  useEffectWithTarget$1(function() {
    var targetElement = getTargetElement(options.target, window);
    if (!(targetElement === null || targetElement === void 0 ? void 0 : targetElement.addEventListener)) {
      return;
    }
    var eventListener = function eventListener2(event) {
      return handlerRef.current(event);
    };
    targetElement.addEventListener(eventName, eventListener, {
      capture: options.capture,
      once: options.once,
      passive: options.passive
    });
    return function() {
      targetElement.removeEventListener(eventName, eventListener, {
        capture: options.capture
      });
    };
  }, [eventName, options.capture, options.once, options.passive], options.target);
}
var MapShim = function() {
  if (typeof Map !== "undefined") {
    return Map;
  }
  function getIndex(arr, key) {
    var result = -1;
    arr.some(function(entry, index2) {
      if (entry[0] === key) {
        result = index2;
        return true;
      }
      return false;
    });
    return result;
  }
  return function() {
    function class_1() {
      this.__entries__ = [];
    }
    Object.defineProperty(class_1.prototype, "size", {
      get: function() {
        return this.__entries__.length;
      },
      enumerable: true,
      configurable: true
    });
    class_1.prototype.get = function(key) {
      var index2 = getIndex(this.__entries__, key);
      var entry = this.__entries__[index2];
      return entry && entry[1];
    };
    class_1.prototype.set = function(key, value) {
      var index2 = getIndex(this.__entries__, key);
      if (~index2) {
        this.__entries__[index2][1] = value;
      } else {
        this.__entries__.push([key, value]);
      }
    };
    class_1.prototype.delete = function(key) {
      var entries = this.__entries__;
      var index2 = getIndex(entries, key);
      if (~index2) {
        entries.splice(index2, 1);
      }
    };
    class_1.prototype.has = function(key) {
      return !!~getIndex(this.__entries__, key);
    };
    class_1.prototype.clear = function() {
      this.__entries__.splice(0);
    };
    class_1.prototype.forEach = function(callback, ctx) {
      if (ctx === void 0) {
        ctx = null;
      }
      for (var _i = 0, _a2 = this.__entries__; _i < _a2.length; _i++) {
        var entry = _a2[_i];
        callback.call(ctx, entry[1], entry[0]);
      }
    };
    return class_1;
  }();
}();
var isBrowser = typeof window !== "undefined" && typeof document !== "undefined" && window.document === document;
var global$1 = function() {
  if (typeof global !== "undefined" && global.Math === Math) {
    return global;
  }
  if (typeof self !== "undefined" && self.Math === Math) {
    return self;
  }
  if (typeof window !== "undefined" && window.Math === Math) {
    return window;
  }
  return Function("return this")();
}();
var requestAnimationFrame$1$1 = function() {
  if (typeof requestAnimationFrame === "function") {
    return requestAnimationFrame.bind(global$1);
  }
  return function(callback) {
    return setTimeout(function() {
      return callback(Date.now());
    }, 1e3 / 60);
  };
}();
var trailingTimeout = 2;
function throttle$1(callback, delay) {
  var leadingCall = false, trailingCall = false, lastCallTime = 0;
  function resolvePending() {
    if (leadingCall) {
      leadingCall = false;
      callback();
    }
    if (trailingCall) {
      proxy();
    }
  }
  function timeoutCallback() {
    requestAnimationFrame$1$1(resolvePending);
  }
  function proxy() {
    var timeStamp = Date.now();
    if (leadingCall) {
      if (timeStamp - lastCallTime < trailingTimeout) {
        return;
      }
      trailingCall = true;
    } else {
      leadingCall = true;
      trailingCall = false;
      setTimeout(timeoutCallback, delay);
    }
    lastCallTime = timeStamp;
  }
  return proxy;
}
var REFRESH_DELAY = 20;
var transitionKeys = ["top", "right", "bottom", "left", "width", "height", "size", "weight"];
var mutationObserverSupported = typeof MutationObserver !== "undefined";
var ResizeObserverController = function() {
  function ResizeObserverController2() {
    this.connected_ = false;
    this.mutationEventsAdded_ = false;
    this.mutationsObserver_ = null;
    this.observers_ = [];
    this.onTransitionEnd_ = this.onTransitionEnd_.bind(this);
    this.refresh = throttle$1(this.refresh.bind(this), REFRESH_DELAY);
  }
  ResizeObserverController2.prototype.addObserver = function(observer) {
    if (!~this.observers_.indexOf(observer)) {
      this.observers_.push(observer);
    }
    if (!this.connected_) {
      this.connect_();
    }
  };
  ResizeObserverController2.prototype.removeObserver = function(observer) {
    var observers2 = this.observers_;
    var index2 = observers2.indexOf(observer);
    if (~index2) {
      observers2.splice(index2, 1);
    }
    if (!observers2.length && this.connected_) {
      this.disconnect_();
    }
  };
  ResizeObserverController2.prototype.refresh = function() {
    var changesDetected = this.updateObservers_();
    if (changesDetected) {
      this.refresh();
    }
  };
  ResizeObserverController2.prototype.updateObservers_ = function() {
    var activeObservers = this.observers_.filter(function(observer) {
      return observer.gatherActive(), observer.hasActive();
    });
    activeObservers.forEach(function(observer) {
      return observer.broadcastActive();
    });
    return activeObservers.length > 0;
  };
  ResizeObserverController2.prototype.connect_ = function() {
    if (!isBrowser || this.connected_) {
      return;
    }
    document.addEventListener("transitionend", this.onTransitionEnd_);
    window.addEventListener("resize", this.refresh);
    if (mutationObserverSupported) {
      this.mutationsObserver_ = new MutationObserver(this.refresh);
      this.mutationsObserver_.observe(document, {
        attributes: true,
        childList: true,
        characterData: true,
        subtree: true
      });
    } else {
      document.addEventListener("DOMSubtreeModified", this.refresh);
      this.mutationEventsAdded_ = true;
    }
    this.connected_ = true;
  };
  ResizeObserverController2.prototype.disconnect_ = function() {
    if (!isBrowser || !this.connected_) {
      return;
    }
    document.removeEventListener("transitionend", this.onTransitionEnd_);
    window.removeEventListener("resize", this.refresh);
    if (this.mutationsObserver_) {
      this.mutationsObserver_.disconnect();
    }
    if (this.mutationEventsAdded_) {
      document.removeEventListener("DOMSubtreeModified", this.refresh);
    }
    this.mutationsObserver_ = null;
    this.mutationEventsAdded_ = false;
    this.connected_ = false;
  };
  ResizeObserverController2.prototype.onTransitionEnd_ = function(_a2) {
    var _b2 = _a2.propertyName, propertyName = _b2 === void 0 ? "" : _b2;
    var isReflowProperty = transitionKeys.some(function(key) {
      return !!~propertyName.indexOf(key);
    });
    if (isReflowProperty) {
      this.refresh();
    }
  };
  ResizeObserverController2.getInstance = function() {
    if (!this.instance_) {
      this.instance_ = new ResizeObserverController2();
    }
    return this.instance_;
  };
  ResizeObserverController2.instance_ = null;
  return ResizeObserverController2;
}();
var defineConfigurable = function(target, props) {
  for (var _i = 0, _a2 = Object.keys(props); _i < _a2.length; _i++) {
    var key = _a2[_i];
    Object.defineProperty(target, key, {
      value: props[key],
      enumerable: false,
      writable: false,
      configurable: true
    });
  }
  return target;
};
var getWindowOf = function(target) {
  var ownerGlobal = target && target.ownerDocument && target.ownerDocument.defaultView;
  return ownerGlobal || global$1;
};
var emptyRect = createRectInit(0, 0, 0, 0);
function toFloat(value) {
  return parseFloat(value) || 0;
}
function getBordersSize(styles2) {
  var positions = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    positions[_i - 1] = arguments[_i];
  }
  return positions.reduce(function(size, position2) {
    var value = styles2["border-" + position2 + "-width"];
    return size + toFloat(value);
  }, 0);
}
function getPaddings(styles2) {
  var positions = ["top", "right", "bottom", "left"];
  var paddings = {};
  for (var _i = 0, positions_1 = positions; _i < positions_1.length; _i++) {
    var position2 = positions_1[_i];
    var value = styles2["padding-" + position2];
    paddings[position2] = toFloat(value);
  }
  return paddings;
}
function getSVGContentRect(target) {
  var bbox = target.getBBox();
  return createRectInit(0, 0, bbox.width, bbox.height);
}
function getHTMLElementContentRect(target) {
  var clientWidth = target.clientWidth, clientHeight = target.clientHeight;
  if (!clientWidth && !clientHeight) {
    return emptyRect;
  }
  var styles2 = getWindowOf(target).getComputedStyle(target);
  var paddings = getPaddings(styles2);
  var horizPad = paddings.left + paddings.right;
  var vertPad = paddings.top + paddings.bottom;
  var width = toFloat(styles2.width), height = toFloat(styles2.height);
  if (styles2.boxSizing === "border-box") {
    if (Math.round(width + horizPad) !== clientWidth) {
      width -= getBordersSize(styles2, "left", "right") + horizPad;
    }
    if (Math.round(height + vertPad) !== clientHeight) {
      height -= getBordersSize(styles2, "top", "bottom") + vertPad;
    }
  }
  if (!isDocumentElement(target)) {
    var vertScrollbar = Math.round(width + horizPad) - clientWidth;
    var horizScrollbar = Math.round(height + vertPad) - clientHeight;
    if (Math.abs(vertScrollbar) !== 1) {
      width -= vertScrollbar;
    }
    if (Math.abs(horizScrollbar) !== 1) {
      height -= horizScrollbar;
    }
  }
  return createRectInit(paddings.left, paddings.top, width, height);
}
var isSVGGraphicsElement = function() {
  if (typeof SVGGraphicsElement !== "undefined") {
    return function(target) {
      return target instanceof getWindowOf(target).SVGGraphicsElement;
    };
  }
  return function(target) {
    return target instanceof getWindowOf(target).SVGElement && typeof target.getBBox === "function";
  };
}();
function isDocumentElement(target) {
  return target === getWindowOf(target).document.documentElement;
}
function getContentRect(target) {
  if (!isBrowser) {
    return emptyRect;
  }
  if (isSVGGraphicsElement(target)) {
    return getSVGContentRect(target);
  }
  return getHTMLElementContentRect(target);
}
function createReadOnlyRect(_a2) {
  var x2 = _a2.x, y2 = _a2.y, width = _a2.width, height = _a2.height;
  var Constr = typeof DOMRectReadOnly !== "undefined" ? DOMRectReadOnly : Object;
  var rect = Object.create(Constr.prototype);
  defineConfigurable(rect, {
    x: x2,
    y: y2,
    width,
    height,
    top: y2,
    right: x2 + width,
    bottom: height + y2,
    left: x2
  });
  return rect;
}
function createRectInit(x2, y2, width, height) {
  return { x: x2, y: y2, width, height };
}
var ResizeObservation = function() {
  function ResizeObservation2(target) {
    this.broadcastWidth = 0;
    this.broadcastHeight = 0;
    this.contentRect_ = createRectInit(0, 0, 0, 0);
    this.target = target;
  }
  ResizeObservation2.prototype.isActive = function() {
    var rect = getContentRect(this.target);
    this.contentRect_ = rect;
    return rect.width !== this.broadcastWidth || rect.height !== this.broadcastHeight;
  };
  ResizeObservation2.prototype.broadcastRect = function() {
    var rect = this.contentRect_;
    this.broadcastWidth = rect.width;
    this.broadcastHeight = rect.height;
    return rect;
  };
  return ResizeObservation2;
}();
var ResizeObserverEntry = function() {
  function ResizeObserverEntry2(target, rectInit) {
    var contentRect = createReadOnlyRect(rectInit);
    defineConfigurable(this, { target, contentRect });
  }
  return ResizeObserverEntry2;
}();
var ResizeObserverSPI = function() {
  function ResizeObserverSPI2(callback, controller, callbackCtx) {
    this.activeObservations_ = [];
    this.observations_ = new MapShim();
    if (typeof callback !== "function") {
      throw new TypeError("The callback provided as parameter 1 is not a function.");
    }
    this.callback_ = callback;
    this.controller_ = controller;
    this.callbackCtx_ = callbackCtx;
  }
  ResizeObserverSPI2.prototype.observe = function(target) {
    if (!arguments.length) {
      throw new TypeError("1 argument required, but only 0 present.");
    }
    if (typeof Element === "undefined" || !(Element instanceof Object)) {
      return;
    }
    if (!(target instanceof getWindowOf(target).Element)) {
      throw new TypeError('parameter 1 is not of type "Element".');
    }
    var observations = this.observations_;
    if (observations.has(target)) {
      return;
    }
    observations.set(target, new ResizeObservation(target));
    this.controller_.addObserver(this);
    this.controller_.refresh();
  };
  ResizeObserverSPI2.prototype.unobserve = function(target) {
    if (!arguments.length) {
      throw new TypeError("1 argument required, but only 0 present.");
    }
    if (typeof Element === "undefined" || !(Element instanceof Object)) {
      return;
    }
    if (!(target instanceof getWindowOf(target).Element)) {
      throw new TypeError('parameter 1 is not of type "Element".');
    }
    var observations = this.observations_;
    if (!observations.has(target)) {
      return;
    }
    observations.delete(target);
    if (!observations.size) {
      this.controller_.removeObserver(this);
    }
  };
  ResizeObserverSPI2.prototype.disconnect = function() {
    this.clearActive();
    this.observations_.clear();
    this.controller_.removeObserver(this);
  };
  ResizeObserverSPI2.prototype.gatherActive = function() {
    var _this = this;
    this.clearActive();
    this.observations_.forEach(function(observation) {
      if (observation.isActive()) {
        _this.activeObservations_.push(observation);
      }
    });
  };
  ResizeObserverSPI2.prototype.broadcastActive = function() {
    if (!this.hasActive()) {
      return;
    }
    var ctx = this.callbackCtx_;
    var entries = this.activeObservations_.map(function(observation) {
      return new ResizeObserverEntry(observation.target, observation.broadcastRect());
    });
    this.callback_.call(ctx, entries, ctx);
    this.clearActive();
  };
  ResizeObserverSPI2.prototype.clearActive = function() {
    this.activeObservations_.splice(0);
  };
  ResizeObserverSPI2.prototype.hasActive = function() {
    return this.activeObservations_.length > 0;
  };
  return ResizeObserverSPI2;
}();
var observers = typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : new MapShim();
var ResizeObserver$1 = function() {
  function ResizeObserver2(callback) {
    if (!(this instanceof ResizeObserver2)) {
      throw new TypeError("Cannot call a class as a function.");
    }
    if (!arguments.length) {
      throw new TypeError("1 argument required, but only 0 present.");
    }
    var controller = ResizeObserverController.getInstance();
    var observer = new ResizeObserverSPI(callback, controller, this);
    observers.set(this, observer);
  }
  return ResizeObserver2;
}();
[
  "observe",
  "unobserve",
  "disconnect"
].forEach(function(method4) {
  ResizeObserver$1.prototype[method4] = function() {
    var _a2;
    return (_a2 = observers.get(this))[method4].apply(_a2, arguments);
  };
});
var index$8 = function() {
  if (typeof global$1.ResizeObserver !== "undefined") {
    return global$1.ResizeObserver;
  }
  return ResizeObserver$1;
}();
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var extendStatics = function(d2, b2) {
  extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b3) {
    d3.__proto__ = b3;
  } || function(d3, b3) {
    for (var p2 in b3)
      if (Object.prototype.hasOwnProperty.call(b3, p2))
        d3[p2] = b3[p2];
  };
  return extendStatics(d2, b2);
};
function __extends(d2, b2) {
  if (typeof b2 !== "function" && b2 !== null)
    throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
  extendStatics(d2, b2);
  function __() {
    this.constructor = d2;
  }
  d2.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
}
var Browser = function() {
  function Browser2() {
    this.firefox = false;
    this.ie = false;
    this.edge = false;
    this.newEdge = false;
    this.weChat = false;
  }
  return Browser2;
}();
var Env = function() {
  function Env2() {
    this.browser = new Browser();
    this.node = false;
    this.wxa = false;
    this.worker = false;
    this.svgSupported = false;
    this.touchEventsSupported = false;
    this.pointerEventsSupported = false;
    this.domSupported = false;
    this.transformSupported = false;
    this.transform3dSupported = false;
    this.hasGlobalWindow = typeof window !== "undefined";
  }
  return Env2;
}();
var env = new Env();
if (typeof wx === "object" && typeof wx.getSystemInfoSync === "function") {
  env.wxa = true;
  env.touchEventsSupported = true;
} else if (typeof document === "undefined" && typeof self !== "undefined") {
  env.worker = true;
} else if (typeof navigator === "undefined") {
  env.node = true;
  env.svgSupported = true;
} else {
  detect(navigator.userAgent, env);
}
function detect(ua2, env2) {
  var browser = env2.browser;
  var firefox = ua2.match(/Firefox\/([\d.]+)/);
  var ie2 = ua2.match(/MSIE\s([\d.]+)/) || ua2.match(/Trident\/.+?rv:(([\d.]+))/);
  var edge = ua2.match(/Edge?\/([\d.]+)/);
  var weChat = /micromessenger/i.test(ua2);
  if (firefox) {
    browser.firefox = true;
    browser.version = firefox[1];
  }
  if (ie2) {
    browser.ie = true;
    browser.version = ie2[1];
  }
  if (edge) {
    browser.edge = true;
    browser.version = edge[1];
    browser.newEdge = +edge[1].split(".")[0] > 18;
  }
  if (weChat) {
    browser.weChat = true;
  }
  env2.svgSupported = typeof SVGRect !== "undefined";
  env2.touchEventsSupported = "ontouchstart" in window && !browser.ie && !browser.edge;
  env2.pointerEventsSupported = "onpointerdown" in window && (browser.edge || browser.ie && +browser.version >= 11);
  env2.domSupported = typeof document !== "undefined";
  var style2 = document.documentElement.style;
  env2.transform3dSupported = (browser.ie && "transition" in style2 || browser.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in style2) && !("OTransition" in style2);
  env2.transformSupported = env2.transform3dSupported || browser.ie && +browser.version >= 9;
}
var env$1 = env;
var DEFAULT_FONT_SIZE = 12;
var DEFAULT_FONT_FAMILY = "sans-serif";
var DEFAULT_FONT = DEFAULT_FONT_SIZE + "px " + DEFAULT_FONT_FAMILY;
var OFFSET = 20;
var SCALE = 100;
var defaultWidthMapStr = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
function getTextWidthMap(mapStr) {
  var map2 = {};
  if (typeof JSON === "undefined") {
    return map2;
  }
  for (var i = 0; i < mapStr.length; i++) {
    var char = String.fromCharCode(i + 32);
    var size = (mapStr.charCodeAt(i) - OFFSET) / SCALE;
    map2[char] = size;
  }
  return map2;
}
var DEFAULT_TEXT_WIDTH_MAP = getTextWidthMap(defaultWidthMapStr);
var platformApi = {
  createCanvas: function() {
    return typeof document !== "undefined" && document.createElement("canvas");
  },
  measureText: function() {
    var _ctx;
    var _cachedFont;
    return function(text, font) {
      if (!_ctx) {
        var canvas = platformApi.createCanvas();
        _ctx = canvas && canvas.getContext("2d");
      }
      if (_ctx) {
        if (_cachedFont !== font) {
          _cachedFont = _ctx.font = font || DEFAULT_FONT;
        }
        return _ctx.measureText(text);
      } else {
        text = text || "";
        font = font || DEFAULT_FONT;
        var res = /^([0-9]*?)px$/.exec(font);
        var fontSize = +(res && res[1]) || DEFAULT_FONT_SIZE;
        var width = 0;
        if (font.indexOf("mono") >= 0) {
          width = fontSize * text.length;
        } else {
          for (var i = 0; i < text.length; i++) {
            var preCalcWidth = DEFAULT_TEXT_WIDTH_MAP[text[i]];
            width += preCalcWidth == null ? fontSize : preCalcWidth * fontSize;
          }
        }
        return { width };
      }
    };
  }(),
  loadImage: function(src, onload, onerror) {
    var image = new Image();
    image.onload = onload;
    image.onerror = onerror;
    image.src = src;
    return image;
  }
};
var BUILTIN_OBJECT = reduce([
  "Function",
  "RegExp",
  "Date",
  "Error",
  "CanvasGradient",
  "CanvasPattern",
  "Image",
  "Canvas"
], function(obj, val) {
  obj["[object " + val + "]"] = true;
  return obj;
}, {});
var TYPED_ARRAY = reduce([
  "Int8",
  "Uint8",
  "Uint8Clamped",
  "Int16",
  "Uint16",
  "Int32",
  "Uint32",
  "Float32",
  "Float64"
], function(obj, val) {
  obj["[object " + val + "Array]"] = true;
  return obj;
}, {});
var objToString = Object.prototype.toString;
var arrayProto = Array.prototype;
var nativeForEach = arrayProto.forEach;
var nativeFilter = arrayProto.filter;
var nativeSlice = arrayProto.slice;
var nativeMap = arrayProto.map;
var ctorFunction = function() {
}.constructor;
var protoFunction = ctorFunction ? ctorFunction.prototype : null;
var protoKey = "__proto__";
var idStart = 2311;
function guid() {
  return idStart++;
}
function logError() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  if (typeof console !== "undefined") {
    console.error.apply(console, args);
  }
}
function clone$4(source) {
  if (source == null || typeof source !== "object") {
    return source;
  }
  var result = source;
  var typeStr = objToString.call(source);
  if (typeStr === "[object Array]") {
    if (!isPrimitive(source)) {
      result = [];
      for (var i = 0, len2 = source.length; i < len2; i++) {
        result[i] = clone$4(source[i]);
      }
    }
  } else if (TYPED_ARRAY[typeStr]) {
    if (!isPrimitive(source)) {
      var Ctor = source.constructor;
      if (Ctor.from) {
        result = Ctor.from(source);
      } else {
        result = new Ctor(source.length);
        for (var i = 0, len2 = source.length; i < len2; i++) {
          result[i] = source[i];
        }
      }
    }
  } else if (!BUILTIN_OBJECT[typeStr] && !isPrimitive(source) && !isDom(source)) {
    result = {};
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        result[key] = clone$4(source[key]);
      }
    }
  }
  return result;
}
function merge(target, source, overwrite) {
  if (!isObject$4(source) || !isObject$4(target)) {
    return overwrite ? clone$4(source) : target;
  }
  for (var key in source) {
    if (source.hasOwnProperty(key) && key !== protoKey) {
      var targetProp = target[key];
      var sourceProp = source[key];
      if (isObject$4(sourceProp) && isObject$4(targetProp) && !isArray$1(sourceProp) && !isArray$1(targetProp) && !isDom(sourceProp) && !isDom(targetProp) && !isBuiltInObject(sourceProp) && !isBuiltInObject(targetProp) && !isPrimitive(sourceProp) && !isPrimitive(targetProp)) {
        merge(targetProp, sourceProp, overwrite);
      } else if (overwrite || !(key in target)) {
        target[key] = clone$4(source[key]);
      }
    }
  }
  return target;
}
function mergeAll(targetAndSources, overwrite) {
  var result = targetAndSources[0];
  for (var i = 1, len2 = targetAndSources.length; i < len2; i++) {
    result = merge(result, targetAndSources[i], overwrite);
  }
  return result;
}
function extend(target, source) {
  if (Object.assign) {
    Object.assign(target, source);
  } else {
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        target[key] = source[key];
      }
    }
  }
  return target;
}
function defaults(target, source, overlay) {
  var keysArr = keys(source);
  for (var i = 0; i < keysArr.length; i++) {
    var key = keysArr[i];
    if (overlay ? source[key] != null : target[key] == null) {
      target[key] = source[key];
    }
  }
  return target;
}
platformApi.createCanvas;
function indexOf(array4, value) {
  if (array4) {
    if (array4.indexOf) {
      return array4.indexOf(value);
    }
    for (var i = 0, len2 = array4.length; i < len2; i++) {
      if (array4[i] === value) {
        return i;
      }
    }
  }
  return -1;
}
function inherits(clazz, baseClazz) {
  var clazzPrototype = clazz.prototype;
  function F2() {
  }
  F2.prototype = baseClazz.prototype;
  clazz.prototype = new F2();
  for (var prop in clazzPrototype) {
    if (clazzPrototype.hasOwnProperty(prop)) {
      clazz.prototype[prop] = clazzPrototype[prop];
    }
  }
  clazz.prototype.constructor = clazz;
  clazz.superClass = baseClazz;
}
function mixin(target, source, override) {
  target = "prototype" in target ? target.prototype : target;
  source = "prototype" in source ? source.prototype : source;
  if (Object.getOwnPropertyNames) {
    var keyList = Object.getOwnPropertyNames(source);
    for (var i = 0; i < keyList.length; i++) {
      var key = keyList[i];
      if (key !== "constructor") {
        if (override ? source[key] != null : target[key] == null) {
          target[key] = source[key];
        }
      }
    }
  } else {
    defaults(target, source, override);
  }
}
function isArrayLike(data) {
  if (!data) {
    return false;
  }
  if (typeof data === "string") {
    return false;
  }
  return typeof data.length === "number";
}
function each$g(arr, cb2, context) {
  if (!(arr && cb2)) {
    return;
  }
  if (arr.forEach && arr.forEach === nativeForEach) {
    arr.forEach(cb2, context);
  } else if (arr.length === +arr.length) {
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      cb2.call(context, arr[i], i, arr);
    }
  } else {
    for (var key in arr) {
      if (arr.hasOwnProperty(key)) {
        cb2.call(context, arr[key], key, arr);
      }
    }
  }
}
function map$1(arr, cb2, context) {
  if (!arr) {
    return [];
  }
  if (!cb2) {
    return slice(arr);
  }
  if (arr.map && arr.map === nativeMap) {
    return arr.map(cb2, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      result.push(cb2.call(context, arr[i], i, arr));
    }
    return result;
  }
}
function reduce(arr, cb2, memo, context) {
  if (!(arr && cb2)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    memo = cb2.call(context, memo, arr[i], i, arr);
  }
  return memo;
}
function filter(arr, cb2, context) {
  if (!arr) {
    return [];
  }
  if (!cb2) {
    return slice(arr);
  }
  if (arr.filter && arr.filter === nativeFilter) {
    return arr.filter(cb2, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      if (cb2.call(context, arr[i], i, arr)) {
        result.push(arr[i]);
      }
    }
    return result;
  }
}
function find(arr, cb2, context) {
  if (!(arr && cb2)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    if (cb2.call(context, arr[i], i, arr)) {
      return arr[i];
    }
  }
}
function keys(obj) {
  if (!obj) {
    return [];
  }
  if (Object.keys) {
    return Object.keys(obj);
  }
  var keyList = [];
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      keyList.push(key);
    }
  }
  return keyList;
}
function bindPolyfill(func, context) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return function() {
    return func.apply(context, args.concat(nativeSlice.call(arguments)));
  };
}
var bind$1 = protoFunction && isFunction(protoFunction.bind) ? protoFunction.call.bind(protoFunction.bind) : bindPolyfill;
function curry$1(func) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return function() {
    return func.apply(this, args.concat(nativeSlice.call(arguments)));
  };
}
function isArray$1(value) {
  if (Array.isArray) {
    return Array.isArray(value);
  }
  return objToString.call(value) === "[object Array]";
}
function isFunction(value) {
  return typeof value === "function";
}
function isString$1(value) {
  return typeof value === "string";
}
function isStringSafe(value) {
  return objToString.call(value) === "[object String]";
}
function isNumber(value) {
  return typeof value === "number";
}
function isObject$4(value) {
  var type4 = typeof value;
  return type4 === "function" || !!value && type4 === "object";
}
function isBuiltInObject(value) {
  return !!BUILTIN_OBJECT[objToString.call(value)];
}
function isTypedArray(value) {
  return !!TYPED_ARRAY[objToString.call(value)];
}
function isDom(value) {
  return typeof value === "object" && typeof value.nodeType === "number" && typeof value.ownerDocument === "object";
}
function isGradientObject(value) {
  return value.colorStops != null;
}
function isImagePatternObject(value) {
  return value.image != null;
}
function isRegExp(value) {
  return objToString.call(value) === "[object RegExp]";
}
function eqNaN(value) {
  return value !== value;
}
function retrieve() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  for (var i = 0, len2 = args.length; i < len2; i++) {
    if (args[i] != null) {
      return args[i];
    }
  }
}
function retrieve2(value0, value1) {
  return value0 != null ? value0 : value1;
}
function retrieve3(value0, value1, value2) {
  return value0 != null ? value0 : value1 != null ? value1 : value2;
}
function slice(arr) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return nativeSlice.apply(arr, args);
}
function normalizeCssArray$1(val) {
  if (typeof val === "number") {
    return [val, val, val, val];
  }
  var len2 = val.length;
  if (len2 === 2) {
    return [val[0], val[1], val[0], val[1]];
  } else if (len2 === 3) {
    return [val[0], val[1], val[2], val[1]];
  }
  return val;
}
function assert(condition, message) {
  if (!condition) {
    throw new Error(message);
  }
}
function trim$1(str) {
  if (str == null) {
    return null;
  } else if (typeof str.trim === "function") {
    return str.trim();
  } else {
    return str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
}
var primitiveKey = "__ec_primitive__";
function setAsPrimitive(obj) {
  obj[primitiveKey] = true;
}
function isPrimitive(obj) {
  return obj[primitiveKey];
}
var HashMap = function() {
  function HashMap2(obj) {
    this.data = {};
    var isArr = isArray$1(obj);
    this.data = {};
    var thisMap = this;
    obj instanceof HashMap2 ? obj.each(visit) : obj && each$g(obj, visit);
    function visit(value, key) {
      isArr ? thisMap.set(value, key) : thisMap.set(key, value);
    }
  }
  HashMap2.prototype.get = function(key) {
    return this.data.hasOwnProperty(key) ? this.data[key] : null;
  };
  HashMap2.prototype.set = function(key, value) {
    return this.data[key] = value;
  };
  HashMap2.prototype.each = function(cb2, context) {
    for (var key in this.data) {
      if (this.data.hasOwnProperty(key)) {
        cb2.call(context, this.data[key], key);
      }
    }
  };
  HashMap2.prototype.keys = function() {
    return keys(this.data);
  };
  HashMap2.prototype.removeKey = function(key) {
    delete this.data[key];
  };
  return HashMap2;
}();
function createHashMap(obj) {
  return new HashMap(obj);
}
function concatArray(a, b2) {
  var newArray = new a.constructor(a.length + b2.length);
  for (var i = 0; i < a.length; i++) {
    newArray[i] = a[i];
  }
  var offset2 = a.length;
  for (var i = 0; i < b2.length; i++) {
    newArray[i + offset2] = b2[i];
  }
  return newArray;
}
function createObject(proto2, properties) {
  var obj;
  if (Object.create) {
    obj = Object.create(proto2);
  } else {
    var StyleCtor = function() {
    };
    StyleCtor.prototype = proto2;
    obj = new StyleCtor();
  }
  if (properties) {
    extend(obj, properties);
  }
  return obj;
}
function disableUserSelect(dom) {
  var domStyle = dom.style;
  domStyle.webkitUserSelect = "none";
  domStyle.userSelect = "none";
  domStyle.webkitTapHighlightColor = "rgba(0,0,0,0)";
  domStyle["-webkit-touch-callout"] = "none";
}
function hasOwn(own, prop) {
  return own.hasOwnProperty(prop);
}
function noop$1() {
}
var RADIAN_TO_DEGREE = 180 / Math.PI;
function create$2(x2, y2) {
  if (x2 == null) {
    x2 = 0;
  }
  if (y2 == null) {
    y2 = 0;
  }
  return [x2, y2];
}
function copy$1(out2, v4) {
  out2[0] = v4[0];
  out2[1] = v4[1];
  return out2;
}
function clone$3(v4) {
  return [v4[0], v4[1]];
}
function set$2(out2, a, b2) {
  out2[0] = a;
  out2[1] = b2;
  return out2;
}
function add(out2, v12, v22) {
  out2[0] = v12[0] + v22[0];
  out2[1] = v12[1] + v22[1];
  return out2;
}
function scaleAndAdd$1(out2, v12, v22, a) {
  out2[0] = v12[0] + v22[0] * a;
  out2[1] = v12[1] + v22[1] * a;
  return out2;
}
function sub(out2, v12, v22) {
  out2[0] = v12[0] - v22[0];
  out2[1] = v12[1] - v22[1];
  return out2;
}
function len(v4) {
  return Math.sqrt(lenSquare(v4));
}
function lenSquare(v4) {
  return v4[0] * v4[0] + v4[1] * v4[1];
}
function scale$2(out2, v4, s) {
  out2[0] = v4[0] * s;
  out2[1] = v4[1] * s;
  return out2;
}
function normalize$4(out2, v4) {
  var d2 = len(v4);
  if (d2 === 0) {
    out2[0] = 0;
    out2[1] = 0;
  } else {
    out2[0] = v4[0] / d2;
    out2[1] = v4[1] / d2;
  }
  return out2;
}
function distance(v12, v22) {
  return Math.sqrt((v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]));
}
var dist$1 = distance;
function distanceSquare(v12, v22) {
  return (v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]);
}
var distSquare = distanceSquare;
function lerp$1(out2, v12, v22, t2) {
  out2[0] = v12[0] + t2 * (v22[0] - v12[0]);
  out2[1] = v12[1] + t2 * (v22[1] - v12[1]);
  return out2;
}
function applyTransform$1(out2, v4, m2) {
  var x2 = v4[0];
  var y2 = v4[1];
  out2[0] = m2[0] * x2 + m2[2] * y2 + m2[4];
  out2[1] = m2[1] * x2 + m2[3] * y2 + m2[5];
  return out2;
}
function min$1(out2, v12, v22) {
  out2[0] = Math.min(v12[0], v22[0]);
  out2[1] = Math.min(v12[1], v22[1]);
  return out2;
}
function max$1(out2, v12, v22) {
  out2[0] = Math.max(v12[0], v22[0]);
  out2[1] = Math.max(v12[1], v22[1]);
  return out2;
}
var Param = function() {
  function Param2(target, e2) {
    this.target = target;
    this.topTarget = e2 && e2.topTarget;
  }
  return Param2;
}();
var Draggable = function() {
  function Draggable2(handler) {
    this.handler = handler;
    handler.on("mousedown", this._dragStart, this);
    handler.on("mousemove", this._drag, this);
    handler.on("mouseup", this._dragEnd, this);
  }
  Draggable2.prototype._dragStart = function(e2) {
    var draggingTarget = e2.target;
    while (draggingTarget && !draggingTarget.draggable) {
      draggingTarget = draggingTarget.parent || draggingTarget.__hostTarget;
    }
    if (draggingTarget) {
      this._draggingTarget = draggingTarget;
      draggingTarget.dragging = true;
      this._x = e2.offsetX;
      this._y = e2.offsetY;
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragstart", e2.event);
    }
  };
  Draggable2.prototype._drag = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      var x2 = e2.offsetX;
      var y2 = e2.offsetY;
      var dx = x2 - this._x;
      var dy = y2 - this._y;
      this._x = x2;
      this._y = y2;
      draggingTarget.drift(dx, dy, e2);
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "drag", e2.event);
      var dropTarget = this.handler.findHover(x2, y2, draggingTarget).target;
      var lastDropTarget = this._dropTarget;
      this._dropTarget = dropTarget;
      if (draggingTarget !== dropTarget) {
        if (lastDropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(lastDropTarget, e2), "dragleave", e2.event);
        }
        if (dropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(dropTarget, e2), "dragenter", e2.event);
        }
      }
    }
  };
  Draggable2.prototype._dragEnd = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      draggingTarget.dragging = false;
    }
    this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragend", e2.event);
    if (this._dropTarget) {
      this.handler.dispatchToElement(new Param(this._dropTarget, e2), "drop", e2.event);
    }
    this._draggingTarget = null;
    this._dropTarget = null;
  };
  return Draggable2;
}();
var Draggable$1 = Draggable;
var Eventful = function() {
  function Eventful2(eventProcessors) {
    if (eventProcessors) {
      this._$eventProcessor = eventProcessors;
    }
  }
  Eventful2.prototype.on = function(event, query, handler, context) {
    if (!this._$handlers) {
      this._$handlers = {};
    }
    var _h = this._$handlers;
    if (typeof query === "function") {
      context = handler;
      handler = query;
      query = null;
    }
    if (!handler || !event) {
      return this;
    }
    var eventProcessor = this._$eventProcessor;
    if (query != null && eventProcessor && eventProcessor.normalizeQuery) {
      query = eventProcessor.normalizeQuery(query);
    }
    if (!_h[event]) {
      _h[event] = [];
    }
    for (var i = 0; i < _h[event].length; i++) {
      if (_h[event][i].h === handler) {
        return this;
      }
    }
    var wrap = {
      h: handler,
      query,
      ctx: context || this,
      callAtLast: handler.zrEventfulCallAtLast
    };
    var lastIndex = _h[event].length - 1;
    var lastWrap = _h[event][lastIndex];
    lastWrap && lastWrap.callAtLast ? _h[event].splice(lastIndex, 0, wrap) : _h[event].push(wrap);
    return this;
  };
  Eventful2.prototype.isSilent = function(eventName) {
    var _h = this._$handlers;
    return !_h || !_h[eventName] || !_h[eventName].length;
  };
  Eventful2.prototype.off = function(eventType, handler) {
    var _h = this._$handlers;
    if (!_h) {
      return this;
    }
    if (!eventType) {
      this._$handlers = {};
      return this;
    }
    if (handler) {
      if (_h[eventType]) {
        var newList = [];
        for (var i = 0, l2 = _h[eventType].length; i < l2; i++) {
          if (_h[eventType][i].h !== handler) {
            newList.push(_h[eventType][i]);
          }
        }
        _h[eventType] = newList;
      }
      if (_h[eventType] && _h[eventType].length === 0) {
        delete _h[eventType];
      }
    } else {
      delete _h[eventType];
    }
    return this;
  };
  Eventful2.prototype.trigger = function(eventType) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[eventType];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(eventType, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(hItem.ctx);
            break;
          case 1:
            hItem.h.call(hItem.ctx, args[0]);
            break;
          case 2:
            hItem.h.call(hItem.ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(hItem.ctx, args);
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(eventType);
    return this;
  };
  Eventful2.prototype.triggerWithContext = function(type4) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[type4];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var ctx = args[argLen - 1];
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(type4, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(ctx);
            break;
          case 1:
            hItem.h.call(ctx, args[0]);
            break;
          case 2:
            hItem.h.call(ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(ctx, args.slice(1, argLen - 1));
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(type4);
    return this;
  };
  return Eventful2;
}();
var Eventful$1 = Eventful;
var LN2 = Math.log(2);
function determinant(rows, rank, rowStart, rowMask, colMask, detCache) {
  var cacheKey = rowMask + "-" + colMask;
  var fullRank = rows.length;
  if (detCache.hasOwnProperty(cacheKey)) {
    return detCache[cacheKey];
  }
  if (rank === 1) {
    var colStart = Math.round(Math.log((1 << fullRank) - 1 & ~colMask) / LN2);
    return rows[rowStart][colStart];
  }
  var subRowMask = rowMask | 1 << rowStart;
  var subRowStart = rowStart + 1;
  while (rowMask & 1 << subRowStart) {
    subRowStart++;
  }
  var sum2 = 0;
  for (var j = 0, colLocalIdx = 0; j < fullRank; j++) {
    var colTag = 1 << j;
    if (!(colTag & colMask)) {
      sum2 += (colLocalIdx % 2 ? -1 : 1) * rows[rowStart][j] * determinant(rows, rank - 1, subRowStart, subRowMask, colMask | colTag, detCache);
      colLocalIdx++;
    }
  }
  detCache[cacheKey] = sum2;
  return sum2;
}
function buildTransformer(src, dest) {
  var mA = [
    [src[0], src[1], 1, 0, 0, 0, -dest[0] * src[0], -dest[0] * src[1]],
    [0, 0, 0, src[0], src[1], 1, -dest[1] * src[0], -dest[1] * src[1]],
    [src[2], src[3], 1, 0, 0, 0, -dest[2] * src[2], -dest[2] * src[3]],
    [0, 0, 0, src[2], src[3], 1, -dest[3] * src[2], -dest[3] * src[3]],
    [src[4], src[5], 1, 0, 0, 0, -dest[4] * src[4], -dest[4] * src[5]],
    [0, 0, 0, src[4], src[5], 1, -dest[5] * src[4], -dest[5] * src[5]],
    [src[6], src[7], 1, 0, 0, 0, -dest[6] * src[6], -dest[6] * src[7]],
    [0, 0, 0, src[6], src[7], 1, -dest[7] * src[6], -dest[7] * src[7]]
  ];
  var detCache = {};
  var det = determinant(mA, 8, 0, 0, 0, detCache);
  if (det === 0) {
    return;
  }
  var vh2 = [];
  for (var i = 0; i < 8; i++) {
    for (var j = 0; j < 8; j++) {
      vh2[j] == null && (vh2[j] = 0);
      vh2[j] += ((i + j) % 2 ? -1 : 1) * determinant(mA, 7, i === 0 ? 1 : 0, 1 << i, 1 << j, detCache) / det * dest[i];
    }
  }
  return function(out2, srcPointX, srcPointY) {
    var pk2 = srcPointX * vh2[6] + srcPointY * vh2[7] + 1;
    out2[0] = (srcPointX * vh2[0] + srcPointY * vh2[1] + vh2[2]) / pk2;
    out2[1] = (srcPointX * vh2[3] + srcPointY * vh2[4] + vh2[5]) / pk2;
  };
}
var EVENT_SAVED_PROP = "___zrEVENTSAVED";
var _calcOut$1 = [];
function transformLocalCoord(out2, elFrom, elTarget, inX, inY) {
  return transformCoordWithViewport(_calcOut$1, elFrom, inX, inY, true) && transformCoordWithViewport(out2, elTarget, _calcOut$1[0], _calcOut$1[1]);
}
function transformCoordWithViewport(out2, el, inX, inY, inverse) {
  if (el.getBoundingClientRect && env$1.domSupported && !isCanvasEl(el)) {
    var saved = el[EVENT_SAVED_PROP] || (el[EVENT_SAVED_PROP] = {});
    var markers = prepareCoordMarkers(el, saved);
    var transformer = preparePointerTransformer(markers, saved, inverse);
    if (transformer) {
      transformer(out2, inX, inY);
      return true;
    }
  }
  return false;
}
function prepareCoordMarkers(el, saved) {
  var markers = saved.markers;
  if (markers) {
    return markers;
  }
  markers = saved.markers = [];
  var propLR = ["left", "right"];
  var propTB = ["top", "bottom"];
  for (var i = 0; i < 4; i++) {
    var marker = document.createElement("div");
    var stl = marker.style;
    var idxLR = i % 2;
    var idxTB = (i >> 1) % 2;
    stl.cssText = [
      "position: absolute",
      "visibility: hidden",
      "padding: 0",
      "margin: 0",
      "border-width: 0",
      "user-select: none",
      "width:0",
      "height:0",
      propLR[idxLR] + ":0",
      propTB[idxTB] + ":0",
      propLR[1 - idxLR] + ":auto",
      propTB[1 - idxTB] + ":auto",
      ""
    ].join("!important;");
    el.appendChild(marker);
    markers.push(marker);
  }
  return markers;
}
function preparePointerTransformer(markers, saved, inverse) {
  var transformerName = inverse ? "invTrans" : "trans";
  var transformer = saved[transformerName];
  var oldSrcCoords = saved.srcCoords;
  var srcCoords = [];
  var destCoords = [];
  var oldCoordTheSame = true;
  for (var i = 0; i < 4; i++) {
    var rect = markers[i].getBoundingClientRect();
    var ii2 = 2 * i;
    var x2 = rect.left;
    var y2 = rect.top;
    srcCoords.push(x2, y2);
    oldCoordTheSame = oldCoordTheSame && oldSrcCoords && x2 === oldSrcCoords[ii2] && y2 === oldSrcCoords[ii2 + 1];
    destCoords.push(markers[i].offsetLeft, markers[i].offsetTop);
  }
  return oldCoordTheSame && transformer ? transformer : (saved.srcCoords = srcCoords, saved[transformerName] = inverse ? buildTransformer(destCoords, srcCoords) : buildTransformer(srcCoords, destCoords));
}
function isCanvasEl(el) {
  return el.nodeName.toUpperCase() === "CANVAS";
}
var MOUSE_EVENT_REG = /^(?:mouse|pointer|contextmenu|drag|drop)|click/;
var _calcOut = [];
var firefoxNotSupportOffsetXY = env$1.browser.firefox && +env$1.browser.version.split(".")[0] < 39;
function clientToLocal(el, e2, out2, calculate) {
  out2 = out2 || {};
  if (calculate) {
    calculateZrXY(el, e2, out2);
  } else if (firefoxNotSupportOffsetXY && e2.layerX != null && e2.layerX !== e2.offsetX) {
    out2.zrX = e2.layerX;
    out2.zrY = e2.layerY;
  } else if (e2.offsetX != null) {
    out2.zrX = e2.offsetX;
    out2.zrY = e2.offsetY;
  } else {
    calculateZrXY(el, e2, out2);
  }
  return out2;
}
function calculateZrXY(el, e2, out2) {
  if (env$1.domSupported && el.getBoundingClientRect) {
    var ex = e2.clientX;
    var ey = e2.clientY;
    if (isCanvasEl(el)) {
      var box2 = el.getBoundingClientRect();
      out2.zrX = ex - box2.left;
      out2.zrY = ey - box2.top;
      return;
    } else {
      if (transformCoordWithViewport(_calcOut, el, ex, ey)) {
        out2.zrX = _calcOut[0];
        out2.zrY = _calcOut[1];
        return;
      }
    }
  }
  out2.zrX = out2.zrY = 0;
}
function getNativeEvent(e2) {
  return e2 || window.event;
}
function normalizeEvent(el, e2, calculate) {
  e2 = getNativeEvent(e2);
  if (e2.zrX != null) {
    return e2;
  }
  var eventType = e2.type;
  var isTouch = eventType && eventType.indexOf("touch") >= 0;
  if (!isTouch) {
    clientToLocal(el, e2, e2, calculate);
    var wheelDelta = getWheelDeltaMayPolyfill(e2);
    e2.zrDelta = wheelDelta ? wheelDelta / 120 : -(e2.detail || 0) / 3;
  } else {
    var touch = eventType !== "touchend" ? e2.targetTouches[0] : e2.changedTouches[0];
    touch && clientToLocal(el, touch, e2, calculate);
  }
  var button = e2.button;
  if (e2.which == null && button !== void 0 && MOUSE_EVENT_REG.test(e2.type)) {
    e2.which = button & 1 ? 1 : button & 2 ? 3 : button & 4 ? 2 : 0;
  }
  return e2;
}
function getWheelDeltaMayPolyfill(e2) {
  var rawWheelDelta = e2.wheelDelta;
  if (rawWheelDelta) {
    return rawWheelDelta;
  }
  var deltaX = e2.deltaX;
  var deltaY = e2.deltaY;
  if (deltaX == null || deltaY == null) {
    return rawWheelDelta;
  }
  var delta = deltaY !== 0 ? Math.abs(deltaY) : Math.abs(deltaX);
  var sign = deltaY > 0 ? -1 : deltaY < 0 ? 1 : deltaX > 0 ? -1 : 1;
  return 3 * delta * sign;
}
function addEventListener$1(el, name, handler, opt) {
  el.addEventListener(name, handler, opt);
}
function removeEventListener$1(el, name, handler, opt) {
  el.removeEventListener(name, handler, opt);
}
var stop = function(e2) {
  e2.preventDefault();
  e2.stopPropagation();
  e2.cancelBubble = true;
};
function isMiddleOrRightButtonOnMouseUpDown(e2) {
  return e2.which === 2 || e2.which === 3;
}
var GestureMgr = function() {
  function GestureMgr2() {
    this._track = [];
  }
  GestureMgr2.prototype.recognize = function(event, target, root2) {
    this._doTrack(event, target, root2);
    return this._recognize(event);
  };
  GestureMgr2.prototype.clear = function() {
    this._track.length = 0;
    return this;
  };
  GestureMgr2.prototype._doTrack = function(event, target, root2) {
    var touches = event.touches;
    if (!touches) {
      return;
    }
    var trackItem = {
      points: [],
      touches: [],
      target,
      event
    };
    for (var i = 0, len2 = touches.length; i < len2; i++) {
      var touch = touches[i];
      var pos = clientToLocal(root2, touch, {});
      trackItem.points.push([pos.zrX, pos.zrY]);
      trackItem.touches.push(touch);
    }
    this._track.push(trackItem);
  };
  GestureMgr2.prototype._recognize = function(event) {
    for (var eventName in recognizers) {
      if (recognizers.hasOwnProperty(eventName)) {
        var gestureInfo = recognizers[eventName](this._track, event);
        if (gestureInfo) {
          return gestureInfo;
        }
      }
    }
  };
  return GestureMgr2;
}();
function dist(pointPair) {
  var dx = pointPair[1][0] - pointPair[0][0];
  var dy = pointPair[1][1] - pointPair[0][1];
  return Math.sqrt(dx * dx + dy * dy);
}
function center$1(pointPair) {
  return [
    (pointPair[0][0] + pointPair[1][0]) / 2,
    (pointPair[0][1] + pointPair[1][1]) / 2
  ];
}
var recognizers = {
  pinch: function(tracks, event) {
    var trackLen = tracks.length;
    if (!trackLen) {
      return;
    }
    var pinchEnd = (tracks[trackLen - 1] || {}).points;
    var pinchPre = (tracks[trackLen - 2] || {}).points || pinchEnd;
    if (pinchPre && pinchPre.length > 1 && pinchEnd && pinchEnd.length > 1) {
      var pinchScale = dist(pinchEnd) / dist(pinchPre);
      !isFinite(pinchScale) && (pinchScale = 1);
      event.pinchScale = pinchScale;
      var pinchCenter = center$1(pinchEnd);
      event.pinchX = pinchCenter[0];
      event.pinchY = pinchCenter[1];
      return {
        type: "pinch",
        target: tracks[0].target,
        event
      };
    }
  }
};
var SILENT = "silent";
function makeEventPacket(eveType, targetInfo, event) {
  return {
    type: eveType,
    event,
    target: targetInfo.target,
    topTarget: targetInfo.topTarget,
    cancelBubble: false,
    offsetX: event.zrX,
    offsetY: event.zrY,
    gestureEvent: event.gestureEvent,
    pinchX: event.pinchX,
    pinchY: event.pinchY,
    pinchScale: event.pinchScale,
    wheelDelta: event.zrDelta,
    zrByTouch: event.zrByTouch,
    which: event.which,
    stop: stopEvent
  };
}
function stopEvent() {
  stop(this.event);
}
var EmptyProxy = function(_super) {
  __extends(EmptyProxy2, _super);
  function EmptyProxy2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.handler = null;
    return _this;
  }
  EmptyProxy2.prototype.dispose = function() {
  };
  EmptyProxy2.prototype.setCursor = function() {
  };
  return EmptyProxy2;
}(Eventful$1);
var HoveredResult = function() {
  function HoveredResult2(x2, y2) {
    this.x = x2;
    this.y = y2;
  }
  return HoveredResult2;
}();
var handlerNames = [
  "click",
  "dblclick",
  "mousewheel",
  "mouseout",
  "mouseup",
  "mousedown",
  "mousemove",
  "contextmenu"
];
var Handler = function(_super) {
  __extends(Handler2, _super);
  function Handler2(storage2, painter, proxy, painterRoot) {
    var _this = _super.call(this) || this;
    _this._hovered = new HoveredResult(0, 0);
    _this.storage = storage2;
    _this.painter = painter;
    _this.painterRoot = painterRoot;
    proxy = proxy || new EmptyProxy();
    _this.proxy = null;
    _this.setHandlerProxy(proxy);
    _this._draggingMgr = new Draggable$1(_this);
    return _this;
  }
  Handler2.prototype.setHandlerProxy = function(proxy) {
    if (this.proxy) {
      this.proxy.dispose();
    }
    if (proxy) {
      each$g(handlerNames, function(name) {
        proxy.on && proxy.on(name, this[name], this);
      }, this);
      proxy.handler = this;
    }
    this.proxy = proxy;
  };
  Handler2.prototype.mousemove = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var lastHovered = this._hovered;
    var lastHoveredTarget = lastHovered.target;
    if (lastHoveredTarget && !lastHoveredTarget.__zr) {
      lastHovered = this.findHover(lastHovered.x, lastHovered.y);
      lastHoveredTarget = lastHovered.target;
    }
    var hovered = this._hovered = isOutside ? new HoveredResult(x2, y2) : this.findHover(x2, y2);
    var hoveredTarget = hovered.target;
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(hoveredTarget ? hoveredTarget.cursor : "default");
    if (lastHoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(lastHovered, "mouseout", event);
    }
    this.dispatchToElement(hovered, "mousemove", event);
    if (hoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(hovered, "mouseover", event);
    }
  };
  Handler2.prototype.mouseout = function(event) {
    var eventControl = event.zrEventControl;
    if (eventControl !== "only_globalout") {
      this.dispatchToElement(this._hovered, "mouseout", event);
    }
    if (eventControl !== "no_globalout") {
      this.trigger("globalout", { type: "globalout", event });
    }
  };
  Handler2.prototype.resize = function() {
    this._hovered = new HoveredResult(0, 0);
  };
  Handler2.prototype.dispatch = function(eventName, eventArgs) {
    var handler = this[eventName];
    handler && handler.call(this, eventArgs);
  };
  Handler2.prototype.dispose = function() {
    this.proxy.dispose();
    this.storage = null;
    this.proxy = null;
    this.painter = null;
  };
  Handler2.prototype.setCursorStyle = function(cursorStyle) {
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(cursorStyle);
  };
  Handler2.prototype.dispatchToElement = function(targetInfo, eventName, event) {
    targetInfo = targetInfo || {};
    var el = targetInfo.target;
    if (el && el.silent) {
      return;
    }
    var eventKey = "on" + eventName;
    var eventPacket = makeEventPacket(eventName, targetInfo, event);
    while (el) {
      el[eventKey] && (eventPacket.cancelBubble = !!el[eventKey].call(el, eventPacket));
      el.trigger(eventName, eventPacket);
      el = el.__hostTarget ? el.__hostTarget : el.parent;
      if (eventPacket.cancelBubble) {
        break;
      }
    }
    if (!eventPacket.cancelBubble) {
      this.trigger(eventName, eventPacket);
      if (this.painter && this.painter.eachOtherLayer) {
        this.painter.eachOtherLayer(function(layer) {
          if (typeof layer[eventKey] === "function") {
            layer[eventKey].call(layer, eventPacket);
          }
          if (layer.trigger) {
            layer.trigger(eventName, eventPacket);
          }
        });
      }
    }
  };
  Handler2.prototype.findHover = function(x2, y2, exclude) {
    var list = this.storage.getDisplayList();
    var out2 = new HoveredResult(x2, y2);
    for (var i = list.length - 1; i >= 0; i--) {
      var hoverCheckResult = void 0;
      if (list[i] !== exclude && !list[i].ignore && (hoverCheckResult = isHover(list[i], x2, y2))) {
        !out2.topTarget && (out2.topTarget = list[i]);
        if (hoverCheckResult !== SILENT) {
          out2.target = list[i];
          break;
        }
      }
    }
    return out2;
  };
  Handler2.prototype.processGesture = function(event, stage) {
    if (!this._gestureMgr) {
      this._gestureMgr = new GestureMgr();
    }
    var gestureMgr = this._gestureMgr;
    stage === "start" && gestureMgr.clear();
    var gestureInfo = gestureMgr.recognize(event, this.findHover(event.zrX, event.zrY, null).target, this.proxy.dom);
    stage === "end" && gestureMgr.clear();
    if (gestureInfo) {
      var type4 = gestureInfo.type;
      event.gestureEvent = type4;
      var res = new HoveredResult();
      res.target = gestureInfo.target;
      this.dispatchToElement(res, type4, gestureInfo.event);
    }
  };
  return Handler2;
}(Eventful$1);
each$g(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(name) {
  Handler.prototype[name] = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var hovered;
    var hoveredTarget;
    if (name !== "mouseup" || !isOutside) {
      hovered = this.findHover(x2, y2);
      hoveredTarget = hovered.target;
    }
    if (name === "mousedown") {
      this._downEl = hoveredTarget;
      this._downPoint = [event.zrX, event.zrY];
      this._upEl = hoveredTarget;
    } else if (name === "mouseup") {
      this._upEl = hoveredTarget;
    } else if (name === "click") {
      if (this._downEl !== this._upEl || !this._downPoint || dist$1(this._downPoint, [event.zrX, event.zrY]) > 4) {
        return;
      }
      this._downPoint = null;
    }
    this.dispatchToElement(hovered, name, event);
  };
});
function isHover(displayable, x2, y2) {
  if (displayable[displayable.rectHover ? "rectContain" : "contain"](x2, y2)) {
    var el = displayable;
    var isSilent = void 0;
    var ignoreClip = false;
    while (el) {
      if (el.ignoreClip) {
        ignoreClip = true;
      }
      if (!ignoreClip) {
        var clipPath = el.getClipPath();
        if (clipPath && !clipPath.contain(x2, y2)) {
          return false;
        }
        if (el.silent) {
          isSilent = true;
        }
      }
      var hostEl = el.__hostTarget;
      el = hostEl ? hostEl : el.parent;
    }
    return isSilent ? SILENT : true;
  }
  return false;
}
function isOutsideBoundary(handlerInstance, x2, y2) {
  var painter = handlerInstance.painter;
  return x2 < 0 || x2 > painter.getWidth() || y2 < 0 || y2 > painter.getHeight();
}
var Handler$1 = Handler;
var DEFAULT_MIN_MERGE = 32;
var DEFAULT_MIN_GALLOPING = 7;
function minRunLength(n2) {
  var r2 = 0;
  while (n2 >= DEFAULT_MIN_MERGE) {
    r2 |= n2 & 1;
    n2 >>= 1;
  }
  return n2 + r2;
}
function makeAscendingRun(array4, lo, hi2, compare2) {
  var runHi = lo + 1;
  if (runHi === hi2) {
    return 1;
  }
  if (compare2(array4[runHi++], array4[lo]) < 0) {
    while (runHi < hi2 && compare2(array4[runHi], array4[runHi - 1]) < 0) {
      runHi++;
    }
    reverseRun(array4, lo, runHi);
  } else {
    while (runHi < hi2 && compare2(array4[runHi], array4[runHi - 1]) >= 0) {
      runHi++;
    }
  }
  return runHi - lo;
}
function reverseRun(array4, lo, hi2) {
  hi2--;
  while (lo < hi2) {
    var t2 = array4[lo];
    array4[lo++] = array4[hi2];
    array4[hi2--] = t2;
  }
}
function binaryInsertionSort(array4, lo, hi2, start2, compare2) {
  if (start2 === lo) {
    start2++;
  }
  for (; start2 < hi2; start2++) {
    var pivot = array4[start2];
    var left = lo;
    var right = start2;
    var mid;
    while (left < right) {
      mid = left + right >>> 1;
      if (compare2(pivot, array4[mid]) < 0) {
        right = mid;
      } else {
        left = mid + 1;
      }
    }
    var n2 = start2 - left;
    switch (n2) {
      case 3:
        array4[left + 3] = array4[left + 2];
      case 2:
        array4[left + 2] = array4[left + 1];
      case 1:
        array4[left + 1] = array4[left];
        break;
      default:
        while (n2 > 0) {
          array4[left + n2] = array4[left + n2 - 1];
          n2--;
        }
    }
    array4[left] = pivot;
  }
}
function gallopLeft(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset2 = 1;
  if (compare2(value, array4[start2 + hint]) > 0) {
    maxOffset = length - hint;
    while (offset2 < maxOffset && compare2(value, array4[start2 + hint + offset2]) > 0) {
      lastOffset = offset2;
      offset2 = (offset2 << 1) + 1;
      if (offset2 <= 0) {
        offset2 = maxOffset;
      }
    }
    if (offset2 > maxOffset) {
      offset2 = maxOffset;
    }
    lastOffset += hint;
    offset2 += hint;
  } else {
    maxOffset = hint + 1;
    while (offset2 < maxOffset && compare2(value, array4[start2 + hint - offset2]) <= 0) {
      lastOffset = offset2;
      offset2 = (offset2 << 1) + 1;
      if (offset2 <= 0) {
        offset2 = maxOffset;
      }
    }
    if (offset2 > maxOffset) {
      offset2 = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset2;
    offset2 = hint - tmp;
  }
  lastOffset++;
  while (lastOffset < offset2) {
    var m2 = lastOffset + (offset2 - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) > 0) {
      lastOffset = m2 + 1;
    } else {
      offset2 = m2;
    }
  }
  return offset2;
}
function gallopRight(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset2 = 1;
  if (compare2(value, array4[start2 + hint]) < 0) {
    maxOffset = hint + 1;
    while (offset2 < maxOffset && compare2(value, array4[start2 + hint - offset2]) < 0) {
      lastOffset = offset2;
      offset2 = (offset2 << 1) + 1;
      if (offset2 <= 0) {
        offset2 = maxOffset;
      }
    }
    if (offset2 > maxOffset) {
      offset2 = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset2;
    offset2 = hint - tmp;
  } else {
    maxOffset = length - hint;
    while (offset2 < maxOffset && compare2(value, array4[start2 + hint + offset2]) >= 0) {
      lastOffset = offset2;
      offset2 = (offset2 << 1) + 1;
      if (offset2 <= 0) {
        offset2 = maxOffset;
      }
    }
    if (offset2 > maxOffset) {
      offset2 = maxOffset;
    }
    lastOffset += hint;
    offset2 += hint;
  }
  lastOffset++;
  while (lastOffset < offset2) {
    var m2 = lastOffset + (offset2 - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) < 0) {
      offset2 = m2;
    } else {
      lastOffset = m2 + 1;
    }
  }
  return offset2;
}
function TimSort(array4, compare2) {
  var minGallop = DEFAULT_MIN_GALLOPING;
  var runStart;
  var runLength;
  var stackSize = 0;
  var tmp = [];
  runStart = [];
  runLength = [];
  function pushRun(_runStart, _runLength) {
    runStart[stackSize] = _runStart;
    runLength[stackSize] = _runLength;
    stackSize += 1;
  }
  function mergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 >= 1 && runLength[n2 - 1] <= runLength[n2] + runLength[n2 + 1] || n2 >= 2 && runLength[n2 - 2] <= runLength[n2] + runLength[n2 - 1]) {
        if (runLength[n2 - 1] < runLength[n2 + 1]) {
          n2--;
        }
      } else if (runLength[n2] > runLength[n2 + 1]) {
        break;
      }
      mergeAt(n2);
    }
  }
  function forceMergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 > 0 && runLength[n2 - 1] < runLength[n2 + 1]) {
        n2--;
      }
      mergeAt(n2);
    }
  }
  function mergeAt(i) {
    var start1 = runStart[i];
    var length1 = runLength[i];
    var start2 = runStart[i + 1];
    var length2 = runLength[i + 1];
    runLength[i] = length1 + length2;
    if (i === stackSize - 3) {
      runStart[i + 1] = runStart[i + 2];
      runLength[i + 1] = runLength[i + 2];
    }
    stackSize--;
    var k2 = gallopRight(array4[start2], array4, start1, length1, 0, compare2);
    start1 += k2;
    length1 -= k2;
    if (length1 === 0) {
      return;
    }
    length2 = gallopLeft(array4[start1 + length1 - 1], array4, start2, length2, length2 - 1, compare2);
    if (length2 === 0) {
      return;
    }
    if (length1 <= length2) {
      mergeLow(start1, length1, start2, length2);
    } else {
      mergeHigh(start1, length1, start2, length2);
    }
  }
  function mergeLow(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length1; i++) {
      tmp[i] = array4[start1 + i];
    }
    var cursor1 = 0;
    var cursor2 = start2;
    var dest = start1;
    array4[dest++] = array4[cursor2++];
    if (--length2 === 0) {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
      return;
    }
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
      return;
    }
    var _minGallop = minGallop;
    var count1;
    var count2;
    var exit;
    while (1) {
      count1 = 0;
      count2 = 0;
      exit = false;
      do {
        if (compare2(array4[cursor2], tmp[cursor1]) < 0) {
          array4[dest++] = array4[cursor2++];
          count2++;
          count1 = 0;
          if (--length2 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest++] = tmp[cursor1++];
          count1++;
          count2 = 0;
          if (--length1 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = gallopRight(array4[cursor2], tmp, cursor1, length1, 0, compare2);
        if (count1 !== 0) {
          for (i = 0; i < count1; i++) {
            array4[dest + i] = tmp[cursor1 + i];
          }
          dest += count1;
          cursor1 += count1;
          length1 -= count1;
          if (length1 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest++] = array4[cursor2++];
        if (--length2 === 0) {
          exit = true;
          break;
        }
        count2 = gallopLeft(tmp[cursor1], array4, cursor2, length2, 0, compare2);
        if (count2 !== 0) {
          for (i = 0; i < count2; i++) {
            array4[dest + i] = array4[cursor2 + i];
          }
          dest += count2;
          cursor2 += count2;
          length2 -= count2;
          if (length2 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest++] = tmp[cursor1++];
        if (--length1 === 1) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    minGallop < 1 && (minGallop = 1);
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
    } else if (length1 === 0) {
      throw new Error();
    } else {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
    }
  }
  function mergeHigh(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length2; i++) {
      tmp[i] = array4[start2 + i];
    }
    var cursor1 = start1 + length1 - 1;
    var cursor2 = length2 - 1;
    var dest = start2 + length2 - 1;
    var customCursor = 0;
    var customDest = 0;
    array4[dest--] = array4[cursor1--];
    if (--length1 === 0) {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
      return;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
      return;
    }
    var _minGallop = minGallop;
    while (true) {
      var count1 = 0;
      var count2 = 0;
      var exit = false;
      do {
        if (compare2(tmp[cursor2], array4[cursor1]) < 0) {
          array4[dest--] = array4[cursor1--];
          count1++;
          count2 = 0;
          if (--length1 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest--] = tmp[cursor2--];
          count2++;
          count1 = 0;
          if (--length2 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = length1 - gallopRight(tmp[cursor2], array4, start1, length1, length1 - 1, compare2);
        if (count1 !== 0) {
          dest -= count1;
          cursor1 -= count1;
          length1 -= count1;
          customDest = dest + 1;
          customCursor = cursor1 + 1;
          for (i = count1 - 1; i >= 0; i--) {
            array4[customDest + i] = array4[customCursor + i];
          }
          if (length1 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest--] = tmp[cursor2--];
        if (--length2 === 1) {
          exit = true;
          break;
        }
        count2 = length2 - gallopLeft(array4[cursor1], tmp, 0, length2, length2 - 1, compare2);
        if (count2 !== 0) {
          dest -= count2;
          cursor2 -= count2;
          length2 -= count2;
          customDest = dest + 1;
          customCursor = cursor2 + 1;
          for (i = 0; i < count2; i++) {
            array4[customDest + i] = tmp[customCursor + i];
          }
          if (length2 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest--] = array4[cursor1--];
        if (--length1 === 0) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    if (minGallop < 1) {
      minGallop = 1;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
    } else if (length2 === 0) {
      throw new Error();
    } else {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
    }
  }
  return {
    mergeRuns,
    forceMergeRuns,
    pushRun
  };
}
function sort$2(array4, compare2, lo, hi2) {
  if (!lo) {
    lo = 0;
  }
  if (!hi2) {
    hi2 = array4.length;
  }
  var remaining = hi2 - lo;
  if (remaining < 2) {
    return;
  }
  var runLength = 0;
  if (remaining < DEFAULT_MIN_MERGE) {
    runLength = makeAscendingRun(array4, lo, hi2, compare2);
    binaryInsertionSort(array4, lo, hi2, lo + runLength, compare2);
    return;
  }
  var ts = TimSort(array4, compare2);
  var minRun = minRunLength(remaining);
  do {
    runLength = makeAscendingRun(array4, lo, hi2, compare2);
    if (runLength < minRun) {
      var force = remaining;
      if (force > minRun) {
        force = minRun;
      }
      binaryInsertionSort(array4, lo, lo + force, lo + runLength, compare2);
      runLength = force;
    }
    ts.pushRun(lo, runLength);
    ts.mergeRuns();
    remaining -= runLength;
    lo += runLength;
  } while (remaining !== 0);
  ts.forceMergeRuns();
}
var REDRAW_BIT = 1;
var STYLE_CHANGED_BIT = 2;
var SHAPE_CHANGED_BIT = 4;
var invalidZErrorLogged = false;
function logInvalidZError() {
  if (invalidZErrorLogged) {
    return;
  }
  invalidZErrorLogged = true;
  console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors");
}
function shapeCompareFunc(a, b2) {
  if (a.zlevel === b2.zlevel) {
    if (a.z === b2.z) {
      return a.z2 - b2.z2;
    }
    return a.z - b2.z;
  }
  return a.zlevel - b2.zlevel;
}
var Storage = function() {
  function Storage2() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    this.displayableSortFunc = shapeCompareFunc;
  }
  Storage2.prototype.traverse = function(cb2, context) {
    for (var i = 0; i < this._roots.length; i++) {
      this._roots[i].traverse(cb2, context);
    }
  };
  Storage2.prototype.getDisplayList = function(update, includeIgnore) {
    includeIgnore = includeIgnore || false;
    var displayList = this._displayList;
    if (update || !displayList.length) {
      this.updateDisplayList(includeIgnore);
    }
    return displayList;
  };
  Storage2.prototype.updateDisplayList = function(includeIgnore) {
    this._displayListLen = 0;
    var roots2 = this._roots;
    var displayList = this._displayList;
    for (var i = 0, len2 = roots2.length; i < len2; i++) {
      this._updateAndAddDisplayable(roots2[i], null, includeIgnore);
    }
    displayList.length = this._displayListLen;
    sort$2(displayList, shapeCompareFunc);
  };
  Storage2.prototype._updateAndAddDisplayable = function(el, clipPaths, includeIgnore) {
    if (el.ignore && !includeIgnore) {
      return;
    }
    el.beforeUpdate();
    el.update();
    el.afterUpdate();
    var userSetClipPath = el.getClipPath();
    if (el.ignoreClip) {
      clipPaths = null;
    } else if (userSetClipPath) {
      if (clipPaths) {
        clipPaths = clipPaths.slice();
      } else {
        clipPaths = [];
      }
      var currentClipPath = userSetClipPath;
      var parentClipPath = el;
      while (currentClipPath) {
        currentClipPath.parent = parentClipPath;
        currentClipPath.updateTransform();
        clipPaths.push(currentClipPath);
        parentClipPath = currentClipPath;
        currentClipPath = currentClipPath.getClipPath();
      }
    }
    if (el.childrenRef) {
      var children = el.childrenRef();
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if (el.__dirty) {
          child.__dirty |= REDRAW_BIT;
        }
        this._updateAndAddDisplayable(child, clipPaths, includeIgnore);
      }
      el.__dirty = 0;
    } else {
      var disp = el;
      if (clipPaths && clipPaths.length) {
        disp.__clipPaths = clipPaths;
      } else if (disp.__clipPaths && disp.__clipPaths.length > 0) {
        disp.__clipPaths = [];
      }
      if (isNaN(disp.z)) {
        logInvalidZError();
        disp.z = 0;
      }
      if (isNaN(disp.z2)) {
        logInvalidZError();
        disp.z2 = 0;
      }
      if (isNaN(disp.zlevel)) {
        logInvalidZError();
        disp.zlevel = 0;
      }
      this._displayList[this._displayListLen++] = disp;
    }
    var decalEl = el.getDecalElement && el.getDecalElement();
    if (decalEl) {
      this._updateAndAddDisplayable(decalEl, clipPaths, includeIgnore);
    }
    var textGuide = el.getTextGuideLine();
    if (textGuide) {
      this._updateAndAddDisplayable(textGuide, clipPaths, includeIgnore);
    }
    var textEl = el.getTextContent();
    if (textEl) {
      this._updateAndAddDisplayable(textEl, clipPaths, includeIgnore);
    }
  };
  Storage2.prototype.addRoot = function(el) {
    if (el.__zr && el.__zr.storage === this) {
      return;
    }
    this._roots.push(el);
  };
  Storage2.prototype.delRoot = function(el) {
    if (el instanceof Array) {
      for (var i = 0, l2 = el.length; i < l2; i++) {
        this.delRoot(el[i]);
      }
      return;
    }
    var idx = indexOf(this._roots, el);
    if (idx >= 0) {
      this._roots.splice(idx, 1);
    }
  };
  Storage2.prototype.delAllRoots = function() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    return;
  };
  Storage2.prototype.getRoots = function() {
    return this._roots;
  };
  Storage2.prototype.dispose = function() {
    this._displayList = null;
    this._roots = null;
  };
  return Storage2;
}();
var Storage$1 = Storage;
var requestAnimationFrame$1;
requestAnimationFrame$1 = env$1.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(func) {
  return setTimeout(func, 16);
};
var requestAnimationFrame$2 = requestAnimationFrame$1;
var easingFuncs = {
  linear: function(k2) {
    return k2;
  },
  quadraticIn: function(k2) {
    return k2 * k2;
  },
  quadraticOut: function(k2) {
    return k2 * (2 - k2);
  },
  quadraticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2;
    }
    return -0.5 * (--k2 * (k2 - 2) - 1);
  },
  cubicIn: function(k2) {
    return k2 * k2 * k2;
  },
  cubicOut: function(k2) {
    return --k2 * k2 * k2 + 1;
  },
  cubicInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 + 2);
  },
  quarticIn: function(k2) {
    return k2 * k2 * k2 * k2;
  },
  quarticOut: function(k2) {
    return 1 - --k2 * k2 * k2 * k2;
  },
  quarticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2;
    }
    return -0.5 * ((k2 -= 2) * k2 * k2 * k2 - 2);
  },
  quinticIn: function(k2) {
    return k2 * k2 * k2 * k2 * k2;
  },
  quinticOut: function(k2) {
    return --k2 * k2 * k2 * k2 * k2 + 1;
  },
  quinticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 * k2 * k2 + 2);
  },
  sinusoidalIn: function(k2) {
    return 1 - Math.cos(k2 * Math.PI / 2);
  },
  sinusoidalOut: function(k2) {
    return Math.sin(k2 * Math.PI / 2);
  },
  sinusoidalInOut: function(k2) {
    return 0.5 * (1 - Math.cos(Math.PI * k2));
  },
  exponentialIn: function(k2) {
    return k2 === 0 ? 0 : Math.pow(1024, k2 - 1);
  },
  exponentialOut: function(k2) {
    return k2 === 1 ? 1 : 1 - Math.pow(2, -10 * k2);
  },
  exponentialInOut: function(k2) {
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if ((k2 *= 2) < 1) {
      return 0.5 * Math.pow(1024, k2 - 1);
    }
    return 0.5 * (-Math.pow(2, -10 * (k2 - 1)) + 2);
  },
  circularIn: function(k2) {
    return 1 - Math.sqrt(1 - k2 * k2);
  },
  circularOut: function(k2) {
    return Math.sqrt(1 - --k2 * k2);
  },
  circularInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return -0.5 * (Math.sqrt(1 - k2 * k2) - 1);
    }
    return 0.5 * (Math.sqrt(1 - (k2 -= 2) * k2) + 1);
  },
  elasticIn: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return -(a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
  },
  elasticOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return a * Math.pow(2, -10 * k2) * Math.sin((k2 - s) * (2 * Math.PI) / p2) + 1;
  },
  elasticInOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    if ((k2 *= 2) < 1) {
      return -0.5 * (a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
    }
    return a * Math.pow(2, -10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2) * 0.5 + 1;
  },
  backIn: function(k2) {
    var s = 1.70158;
    return k2 * k2 * ((s + 1) * k2 - s);
  },
  backOut: function(k2) {
    var s = 1.70158;
    return --k2 * k2 * ((s + 1) * k2 + s) + 1;
  },
  backInOut: function(k2) {
    var s = 1.70158 * 1.525;
    if ((k2 *= 2) < 1) {
      return 0.5 * (k2 * k2 * ((s + 1) * k2 - s));
    }
    return 0.5 * ((k2 -= 2) * k2 * ((s + 1) * k2 + s) + 2);
  },
  bounceIn: function(k2) {
    return 1 - easingFuncs.bounceOut(1 - k2);
  },
  bounceOut: function(k2) {
    if (k2 < 1 / 2.75) {
      return 7.5625 * k2 * k2;
    } else if (k2 < 2 / 2.75) {
      return 7.5625 * (k2 -= 1.5 / 2.75) * k2 + 0.75;
    } else if (k2 < 2.5 / 2.75) {
      return 7.5625 * (k2 -= 2.25 / 2.75) * k2 + 0.9375;
    } else {
      return 7.5625 * (k2 -= 2.625 / 2.75) * k2 + 0.984375;
    }
  },
  bounceInOut: function(k2) {
    if (k2 < 0.5) {
      return easingFuncs.bounceIn(k2 * 2) * 0.5;
    }
    return easingFuncs.bounceOut(k2 * 2 - 1) * 0.5 + 0.5;
  }
};
var easingFuncs$1 = easingFuncs;
var mathPow$2 = Math.pow;
var mathSqrt$3 = Math.sqrt;
var EPSILON$4 = 1e-8;
var EPSILON_NUMERIC = 1e-4;
var THREE_SQRT = mathSqrt$3(3);
var ONE_THIRD = 1 / 3;
var _v0 = create$2();
var _v1 = create$2();
var _v2 = create$2();
function isAroundZero$1(val) {
  return val > -EPSILON$4 && val < EPSILON$4;
}
function isNotAroundZero$1(val) {
  return val > EPSILON$4 || val < -EPSILON$4;
}
function cubicAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return onet * onet * (onet * p0 + 3 * t2 * p1) + t2 * t2 * (t2 * p3 + 3 * onet * p2);
}
function cubicDerivativeAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return 3 * (((p1 - p0) * onet + 2 * (p2 - p1) * t2) * onet + (p3 - p2) * t2 * t2);
}
function cubicRootAt(p0, p1, p2, p3, val, roots2) {
  var a = p3 + 3 * (p1 - p2) - p0;
  var b2 = 3 * (p2 - p1 * 2 + p0);
  var c2 = 3 * (p1 - p0);
  var d2 = p0 - val;
  var A2 = b2 * b2 - 3 * a * c2;
  var B2 = b2 * c2 - 9 * a * d2;
  var C = c2 * c2 - 3 * b2 * d2;
  var n2 = 0;
  if (isAroundZero$1(A2) && isAroundZero$1(B2)) {
    if (isAroundZero$1(b2)) {
      roots2[0] = 0;
    } else {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = B2 * B2 - 4 * A2 * C;
    if (isAroundZero$1(disc)) {
      var K = B2 / A2;
      var t1 = -b2 / a + K;
      var t2 = -K / 2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var Y1 = A2 * b2 + 1.5 * a * (-B2 + discSqrt);
      var Y2 = A2 * b2 + 1.5 * a * (-B2 - discSqrt);
      if (Y1 < 0) {
        Y1 = -mathPow$2(-Y1, ONE_THIRD);
      } else {
        Y1 = mathPow$2(Y1, ONE_THIRD);
      }
      if (Y2 < 0) {
        Y2 = -mathPow$2(-Y2, ONE_THIRD);
      } else {
        Y2 = mathPow$2(Y2, ONE_THIRD);
      }
      var t1 = (-b2 - (Y1 + Y2)) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else {
      var T2 = (2 * A2 * b2 - 3 * a * B2) / (2 * mathSqrt$3(A2 * A2 * A2));
      var theta = Math.acos(T2) / 3;
      var ASqrt = mathSqrt$3(A2);
      var tmp = Math.cos(theta);
      var t1 = (-b2 - 2 * ASqrt * tmp) / (3 * a);
      var t2 = (-b2 + ASqrt * (tmp + THREE_SQRT * Math.sin(theta))) / (3 * a);
      var t3 = (-b2 + ASqrt * (tmp - THREE_SQRT * Math.sin(theta))) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
      if (t3 >= 0 && t3 <= 1) {
        roots2[n2++] = t3;
      }
    }
  }
  return n2;
}
function cubicExtrema(p0, p1, p2, p3, extrema2) {
  var b2 = 6 * p2 - 12 * p1 + 6 * p0;
  var a = 9 * p1 + 3 * p3 - 3 * p0 - 9 * p2;
  var c2 = 3 * p1 - 3 * p0;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      extrema2[0] = -b2 / (2 * a);
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        extrema2[n2++] = t2;
      }
    }
  }
  return n2;
}
function cubicSubdivide(p0, p1, p2, p3, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p23 = (p3 - p2) * t2 + p2;
  var p012 = (p12 - p01) * t2 + p01;
  var p123 = (p23 - p12) * t2 + p12;
  var p0123 = (p123 - p012) * t2 + p012;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p0123;
  out2[4] = p0123;
  out2[5] = p123;
  out2[6] = p23;
  out2[7] = p3;
}
function cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  var prev;
  var next;
  var d1;
  var d22;
  _v0[0] = x4;
  _v0[1] = y4;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = cubicAt(x0, x1, x2, x3, _t);
    _v1[1] = cubicAt(y0, y1, y2, y3, _t);
    d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    prev = t2 - interval;
    next = t2 + interval;
    _v1[0] = cubicAt(x0, x1, x2, x3, prev);
    _v1[1] = cubicAt(y0, y1, y2, y3, prev);
    d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = cubicAt(x0, x1, x2, x3, next);
      _v2[1] = cubicAt(y0, y1, y2, y3, next);
      d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = cubicAt(x0, x1, x2, x3, t2);
    out2[1] = cubicAt(y0, y1, y2, y3, t2);
  }
  return mathSqrt$3(d2);
}
function cubicLength(x0, y0, x1, y1, x2, y2, x3, y3, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x4 = cubicAt(x0, x1, x2, x3, t2);
    var y4 = cubicAt(y0, y1, y2, y3, t2);
    var dx = x4 - px;
    var dy = y4 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x4;
    py = y4;
  }
  return d2;
}
function quadraticAt$1(p0, p1, p2, t2) {
  var onet = 1 - t2;
  return onet * (onet * p0 + 2 * t2 * p1) + t2 * t2 * p2;
}
function quadraticDerivativeAt(p0, p1, p2, t2) {
  return 2 * ((1 - t2) * (p1 - p0) + t2 * (p2 - p1));
}
function quadraticRootAt(p0, p1, p2, val, roots2) {
  var a = p0 - 2 * p1 + p2;
  var b2 = 2 * (p1 - p0);
  var c2 = p0 - val;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      var t1 = -b2 / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    }
  }
  return n2;
}
function quadraticExtremum(p0, p1, p2) {
  var divider = p0 + p2 - 2 * p1;
  if (divider === 0) {
    return 0.5;
  } else {
    return (p0 - p1) / divider;
  }
}
function quadraticSubdivide(p0, p1, p2, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p012 = (p12 - p01) * t2 + p01;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p012;
  out2[4] = p12;
  out2[5] = p2;
}
function quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  _v0[0] = x3;
  _v0[1] = y3;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = quadraticAt$1(x0, x1, x2, _t);
    _v1[1] = quadraticAt$1(y0, y1, y2, _t);
    var d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    var prev = t2 - interval;
    var next = t2 + interval;
    _v1[0] = quadraticAt$1(x0, x1, x2, prev);
    _v1[1] = quadraticAt$1(y0, y1, y2, prev);
    var d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = quadraticAt$1(x0, x1, x2, next);
      _v2[1] = quadraticAt$1(y0, y1, y2, next);
      var d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = quadraticAt$1(x0, x1, x2, t2);
    out2[1] = quadraticAt$1(y0, y1, y2, t2);
  }
  return mathSqrt$3(d2);
}
function quadraticLength(x0, y0, x1, y1, x2, y2, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x3 = quadraticAt$1(x0, x1, x2, t2);
    var y3 = quadraticAt$1(y0, y1, y2, t2);
    var dx = x3 - px;
    var dy = y3 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x3;
    py = y3;
  }
  return d2;
}
var regexp$1 = /cubic-bezier\(([0-9,\.e ]+)\)/;
function createCubicEasingFunc(cubicEasingStr) {
  var cubic = cubicEasingStr && regexp$1.exec(cubicEasingStr);
  if (cubic) {
    var points2 = cubic[1].split(",");
    var a_1 = +trim$1(points2[0]);
    var b_1 = +trim$1(points2[1]);
    var c_1 = +trim$1(points2[2]);
    var d_1 = +trim$1(points2[3]);
    if (isNaN(a_1 + b_1 + c_1 + d_1)) {
      return;
    }
    var roots_1 = [];
    return function(p2) {
      return p2 <= 0 ? 0 : p2 >= 1 ? 1 : cubicRootAt(0, a_1, c_1, 1, p2, roots_1) && cubicAt(0, b_1, d_1, 1, roots_1[0]);
    };
  }
}
var Clip = function() {
  function Clip2(opts) {
    this._inited = false;
    this._startTime = 0;
    this._pausedTime = 0;
    this._paused = false;
    this._life = opts.life || 1e3;
    this._delay = opts.delay || 0;
    this.loop = opts.loop || false;
    this.onframe = opts.onframe || noop$1;
    this.ondestroy = opts.ondestroy || noop$1;
    this.onrestart = opts.onrestart || noop$1;
    opts.easing && this.setEasing(opts.easing);
  }
  Clip2.prototype.step = function(globalTime, deltaTime) {
    if (!this._inited) {
      this._startTime = globalTime + this._delay;
      this._inited = true;
    }
    if (this._paused) {
      this._pausedTime += deltaTime;
      return;
    }
    var life = this._life;
    var elapsedTime = globalTime - this._startTime - this._pausedTime;
    var percent = elapsedTime / life;
    if (percent < 0) {
      percent = 0;
    }
    percent = Math.min(percent, 1);
    var easingFunc = this.easingFunc;
    var schedule = easingFunc ? easingFunc(percent) : percent;
    this.onframe(schedule);
    if (percent === 1) {
      if (this.loop) {
        var remainder = elapsedTime % life;
        this._startTime = globalTime - remainder;
        this._pausedTime = 0;
        this.onrestart();
      } else {
        return true;
      }
    }
    return false;
  };
  Clip2.prototype.pause = function() {
    this._paused = true;
  };
  Clip2.prototype.resume = function() {
    this._paused = false;
  };
  Clip2.prototype.setEasing = function(easing) {
    this.easing = easing;
    this.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
  };
  return Clip2;
}();
var Clip$1 = Clip;
var Entry = function() {
  function Entry2(val) {
    this.value = val;
  }
  return Entry2;
}();
var LinkedList = function() {
  function LinkedList2() {
    this._len = 0;
  }
  LinkedList2.prototype.insert = function(val) {
    var entry = new Entry(val);
    this.insertEntry(entry);
    return entry;
  };
  LinkedList2.prototype.insertEntry = function(entry) {
    if (!this.head) {
      this.head = this.tail = entry;
    } else {
      this.tail.next = entry;
      entry.prev = this.tail;
      entry.next = null;
      this.tail = entry;
    }
    this._len++;
  };
  LinkedList2.prototype.remove = function(entry) {
    var prev = entry.prev;
    var next = entry.next;
    if (prev) {
      prev.next = next;
    } else {
      this.head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this.tail = prev;
    }
    entry.next = entry.prev = null;
    this._len--;
  };
  LinkedList2.prototype.len = function() {
    return this._len;
  };
  LinkedList2.prototype.clear = function() {
    this.head = this.tail = null;
    this._len = 0;
  };
  return LinkedList2;
}();
var LRU = function() {
  function LRU2(maxSize) {
    this._list = new LinkedList();
    this._maxSize = 10;
    this._map = {};
    this._maxSize = maxSize;
  }
  LRU2.prototype.put = function(key, value) {
    var list = this._list;
    var map2 = this._map;
    var removed = null;
    if (map2[key] == null) {
      var len2 = list.len();
      var entry = this._lastRemovedEntry;
      if (len2 >= this._maxSize && len2 > 0) {
        var leastUsedEntry = list.head;
        list.remove(leastUsedEntry);
        delete map2[leastUsedEntry.key];
        removed = leastUsedEntry.value;
        this._lastRemovedEntry = leastUsedEntry;
      }
      if (entry) {
        entry.value = value;
      } else {
        entry = new Entry(value);
      }
      entry.key = key;
      list.insertEntry(entry);
      map2[key] = entry;
    }
    return removed;
  };
  LRU2.prototype.get = function(key) {
    var entry = this._map[key];
    var list = this._list;
    if (entry != null) {
      if (entry !== list.tail) {
        list.remove(entry);
        list.insertEntry(entry);
      }
      return entry.value;
    }
  };
  LRU2.prototype.clear = function() {
    this._list.clear();
    this._map = {};
  };
  LRU2.prototype.len = function() {
    return this._list.len();
  };
  return LRU2;
}();
var LRU$1 = LRU;
var kCSSColorTable = {
  "transparent": [0, 0, 0, 0],
  "aliceblue": [240, 248, 255, 1],
  "antiquewhite": [250, 235, 215, 1],
  "aqua": [0, 255, 255, 1],
  "aquamarine": [127, 255, 212, 1],
  "azure": [240, 255, 255, 1],
  "beige": [245, 245, 220, 1],
  "bisque": [255, 228, 196, 1],
  "black": [0, 0, 0, 1],
  "blanchedalmond": [255, 235, 205, 1],
  "blue": [0, 0, 255, 1],
  "blueviolet": [138, 43, 226, 1],
  "brown": [165, 42, 42, 1],
  "burlywood": [222, 184, 135, 1],
  "cadetblue": [95, 158, 160, 1],
  "chartreuse": [127, 255, 0, 1],
  "chocolate": [210, 105, 30, 1],
  "coral": [255, 127, 80, 1],
  "cornflowerblue": [100, 149, 237, 1],
  "cornsilk": [255, 248, 220, 1],
  "crimson": [220, 20, 60, 1],
  "cyan": [0, 255, 255, 1],
  "darkblue": [0, 0, 139, 1],
  "darkcyan": [0, 139, 139, 1],
  "darkgoldenrod": [184, 134, 11, 1],
  "darkgray": [169, 169, 169, 1],
  "darkgreen": [0, 100, 0, 1],
  "darkgrey": [169, 169, 169, 1],
  "darkkhaki": [189, 183, 107, 1],
  "darkmagenta": [139, 0, 139, 1],
  "darkolivegreen": [85, 107, 47, 1],
  "darkorange": [255, 140, 0, 1],
  "darkorchid": [153, 50, 204, 1],
  "darkred": [139, 0, 0, 1],
  "darksalmon": [233, 150, 122, 1],
  "darkseagreen": [143, 188, 143, 1],
  "darkslateblue": [72, 61, 139, 1],
  "darkslategray": [47, 79, 79, 1],
  "darkslategrey": [47, 79, 79, 1],
  "darkturquoise": [0, 206, 209, 1],
  "darkviolet": [148, 0, 211, 1],
  "deeppink": [255, 20, 147, 1],
  "deepskyblue": [0, 191, 255, 1],
  "dimgray": [105, 105, 105, 1],
  "dimgrey": [105, 105, 105, 1],
  "dodgerblue": [30, 144, 255, 1],
  "firebrick": [178, 34, 34, 1],
  "floralwhite": [255, 250, 240, 1],
  "forestgreen": [34, 139, 34, 1],
  "fuchsia": [255, 0, 255, 1],
  "gainsboro": [220, 220, 220, 1],
  "ghostwhite": [248, 248, 255, 1],
  "gold": [255, 215, 0, 1],
  "goldenrod": [218, 165, 32, 1],
  "gray": [128, 128, 128, 1],
  "green": [0, 128, 0, 1],
  "greenyellow": [173, 255, 47, 1],
  "grey": [128, 128, 128, 1],
  "honeydew": [240, 255, 240, 1],
  "hotpink": [255, 105, 180, 1],
  "indianred": [205, 92, 92, 1],
  "indigo": [75, 0, 130, 1],
  "ivory": [255, 255, 240, 1],
  "khaki": [240, 230, 140, 1],
  "lavender": [230, 230, 250, 1],
  "lavenderblush": [255, 240, 245, 1],
  "lawngreen": [124, 252, 0, 1],
  "lemonchiffon": [255, 250, 205, 1],
  "lightblue": [173, 216, 230, 1],
  "lightcoral": [240, 128, 128, 1],
  "lightcyan": [224, 255, 255, 1],
  "lightgoldenrodyellow": [250, 250, 210, 1],
  "lightgray": [211, 211, 211, 1],
  "lightgreen": [144, 238, 144, 1],
  "lightgrey": [211, 211, 211, 1],
  "lightpink": [255, 182, 193, 1],
  "lightsalmon": [255, 160, 122, 1],
  "lightseagreen": [32, 178, 170, 1],
  "lightskyblue": [135, 206, 250, 1],
  "lightslategray": [119, 136, 153, 1],
  "lightslategrey": [119, 136, 153, 1],
  "lightsteelblue": [176, 196, 222, 1],
  "lightyellow": [255, 255, 224, 1],
  "lime": [0, 255, 0, 1],
  "limegreen": [50, 205, 50, 1],
  "linen": [250, 240, 230, 1],
  "magenta": [255, 0, 255, 1],
  "maroon": [128, 0, 0, 1],
  "mediumaquamarine": [102, 205, 170, 1],
  "mediumblue": [0, 0, 205, 1],
  "mediumorchid": [186, 85, 211, 1],
  "mediumpurple": [147, 112, 219, 1],
  "mediumseagreen": [60, 179, 113, 1],
  "mediumslateblue": [123, 104, 238, 1],
  "mediumspringgreen": [0, 250, 154, 1],
  "mediumturquoise": [72, 209, 204, 1],
  "mediumvioletred": [199, 21, 133, 1],
  "midnightblue": [25, 25, 112, 1],
  "mintcream": [245, 255, 250, 1],
  "mistyrose": [255, 228, 225, 1],
  "moccasin": [255, 228, 181, 1],
  "navajowhite": [255, 222, 173, 1],
  "navy": [0, 0, 128, 1],
  "oldlace": [253, 245, 230, 1],
  "olive": [128, 128, 0, 1],
  "olivedrab": [107, 142, 35, 1],
  "orange": [255, 165, 0, 1],
  "orangered": [255, 69, 0, 1],
  "orchid": [218, 112, 214, 1],
  "palegoldenrod": [238, 232, 170, 1],
  "palegreen": [152, 251, 152, 1],
  "paleturquoise": [175, 238, 238, 1],
  "palevioletred": [219, 112, 147, 1],
  "papayawhip": [255, 239, 213, 1],
  "peachpuff": [255, 218, 185, 1],
  "peru": [205, 133, 63, 1],
  "pink": [255, 192, 203, 1],
  "plum": [221, 160, 221, 1],
  "powderblue": [176, 224, 230, 1],
  "purple": [128, 0, 128, 1],
  "red": [255, 0, 0, 1],
  "rosybrown": [188, 143, 143, 1],
  "royalblue": [65, 105, 225, 1],
  "saddlebrown": [139, 69, 19, 1],
  "salmon": [250, 128, 114, 1],
  "sandybrown": [244, 164, 96, 1],
  "seagreen": [46, 139, 87, 1],
  "seashell": [255, 245, 238, 1],
  "sienna": [160, 82, 45, 1],
  "silver": [192, 192, 192, 1],
  "skyblue": [135, 206, 235, 1],
  "slateblue": [106, 90, 205, 1],
  "slategray": [112, 128, 144, 1],
  "slategrey": [112, 128, 144, 1],
  "snow": [255, 250, 250, 1],
  "springgreen": [0, 255, 127, 1],
  "steelblue": [70, 130, 180, 1],
  "tan": [210, 180, 140, 1],
  "teal": [0, 128, 128, 1],
  "thistle": [216, 191, 216, 1],
  "tomato": [255, 99, 71, 1],
  "turquoise": [64, 224, 208, 1],
  "violet": [238, 130, 238, 1],
  "wheat": [245, 222, 179, 1],
  "white": [255, 255, 255, 1],
  "whitesmoke": [245, 245, 245, 1],
  "yellow": [255, 255, 0, 1],
  "yellowgreen": [154, 205, 50, 1]
};
function clampCssByte(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 255 ? 255 : i;
}
function clampCssAngle(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 360 ? 360 : i;
}
function clampCssFloat(f2) {
  return f2 < 0 ? 0 : f2 > 1 ? 1 : f2;
}
function parseCssInt(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssByte(parseFloat(str) / 100 * 255);
  }
  return clampCssByte(parseInt(str, 10));
}
function parseCssFloat(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssFloat(parseFloat(str) / 100);
  }
  return clampCssFloat(parseFloat(str));
}
function cssHueToRgb(m1, m2, h) {
  if (h < 0) {
    h += 1;
  } else if (h > 1) {
    h -= 1;
  }
  if (h * 6 < 1) {
    return m1 + (m2 - m1) * h * 6;
  }
  if (h * 2 < 1) {
    return m2;
  }
  if (h * 3 < 2) {
    return m1 + (m2 - m1) * (2 / 3 - h) * 6;
  }
  return m1;
}
function lerpNumber(a, b2, p2) {
  return a + (b2 - a) * p2;
}
function setRgba(out2, r2, g2, b2, a) {
  out2[0] = r2;
  out2[1] = g2;
  out2[2] = b2;
  out2[3] = a;
  return out2;
}
function copyRgba(out2, a) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  return out2;
}
var colorCache = new LRU$1(20);
var lastRemovedArr = null;
function putToCache(colorStr, rgbaArr) {
  if (lastRemovedArr) {
    copyRgba(lastRemovedArr, rgbaArr);
  }
  lastRemovedArr = colorCache.put(colorStr, lastRemovedArr || rgbaArr.slice());
}
function parse(colorStr, rgbaArr) {
  if (!colorStr) {
    return;
  }
  rgbaArr = rgbaArr || [];
  var cached2 = colorCache.get(colorStr);
  if (cached2) {
    return copyRgba(rgbaArr, cached2);
  }
  colorStr = colorStr + "";
  var str = colorStr.replace(/ /g, "").toLowerCase();
  if (str in kCSSColorTable) {
    copyRgba(rgbaArr, kCSSColorTable[str]);
    putToCache(colorStr, rgbaArr);
    return rgbaArr;
  }
  var strLen = str.length;
  if (str.charAt(0) === "#") {
    if (strLen === 4 || strLen === 5) {
      var iv = parseInt(str.slice(1, 4), 16);
      if (!(iv >= 0 && iv <= 4095)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 3840) >> 4 | (iv & 3840) >> 8, iv & 240 | (iv & 240) >> 4, iv & 15 | (iv & 15) << 4, strLen === 5 ? parseInt(str.slice(4), 16) / 15 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    } else if (strLen === 7 || strLen === 9) {
      var iv = parseInt(str.slice(1, 7), 16);
      if (!(iv >= 0 && iv <= 16777215)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 16711680) >> 16, (iv & 65280) >> 8, iv & 255, strLen === 9 ? parseInt(str.slice(7), 16) / 255 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    }
    return;
  }
  var op = str.indexOf("(");
  var ep = str.indexOf(")");
  if (op !== -1 && ep + 1 === strLen) {
    var fname = str.substr(0, op);
    var params = str.substr(op + 1, ep - (op + 1)).split(",");
    var alpha = 1;
    switch (fname) {
      case "rgba":
        if (params.length !== 4) {
          return params.length === 3 ? setRgba(rgbaArr, +params[0], +params[1], +params[2], 1) : setRgba(rgbaArr, 0, 0, 0, 1);
        }
        alpha = parseCssFloat(params.pop());
      case "rgb":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        setRgba(rgbaArr, parseCssInt(params[0]), parseCssInt(params[1]), parseCssInt(params[2]), alpha);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsla":
        if (params.length !== 4) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        params[3] = parseCssFloat(params[3]);
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsl":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      default:
        return;
    }
  }
  setRgba(rgbaArr, 0, 0, 0, 1);
  return;
}
function hsla2rgba(hsla, rgba) {
  var h = (parseFloat(hsla[0]) % 360 + 360) % 360 / 360;
  var s = parseCssFloat(hsla[1]);
  var l2 = parseCssFloat(hsla[2]);
  var m2 = l2 <= 0.5 ? l2 * (s + 1) : l2 + s - l2 * s;
  var m1 = l2 * 2 - m2;
  rgba = rgba || [];
  setRgba(rgba, clampCssByte(cssHueToRgb(m1, m2, h + 1 / 3) * 255), clampCssByte(cssHueToRgb(m1, m2, h) * 255), clampCssByte(cssHueToRgb(m1, m2, h - 1 / 3) * 255), 1);
  if (hsla.length === 4) {
    rgba[3] = hsla[3];
  }
  return rgba;
}
function rgba2hsla(rgba) {
  if (!rgba) {
    return;
  }
  var R2 = rgba[0] / 255;
  var G2 = rgba[1] / 255;
  var B2 = rgba[2] / 255;
  var vMin = Math.min(R2, G2, B2);
  var vMax = Math.max(R2, G2, B2);
  var delta = vMax - vMin;
  var L = (vMax + vMin) / 2;
  var H2;
  var S2;
  if (delta === 0) {
    H2 = 0;
    S2 = 0;
  } else {
    if (L < 0.5) {
      S2 = delta / (vMax + vMin);
    } else {
      S2 = delta / (2 - vMax - vMin);
    }
    var deltaR = ((vMax - R2) / 6 + delta / 2) / delta;
    var deltaG = ((vMax - G2) / 6 + delta / 2) / delta;
    var deltaB = ((vMax - B2) / 6 + delta / 2) / delta;
    if (R2 === vMax) {
      H2 = deltaB - deltaG;
    } else if (G2 === vMax) {
      H2 = 1 / 3 + deltaR - deltaB;
    } else if (B2 === vMax) {
      H2 = 2 / 3 + deltaG - deltaR;
    }
    if (H2 < 0) {
      H2 += 1;
    }
    if (H2 > 1) {
      H2 -= 1;
    }
  }
  var hsla = [H2 * 360, S2, L];
  if (rgba[3] != null) {
    hsla.push(rgba[3]);
  }
  return hsla;
}
function lift(color, level) {
  var colorArr = parse(color);
  if (colorArr) {
    for (var i = 0; i < 3; i++) {
      if (level < 0) {
        colorArr[i] = colorArr[i] * (1 - level) | 0;
      } else {
        colorArr[i] = (255 - colorArr[i]) * level + colorArr[i] | 0;
      }
      if (colorArr[i] > 255) {
        colorArr[i] = 255;
      } else if (colorArr[i] < 0) {
        colorArr[i] = 0;
      }
    }
    return stringify(colorArr, colorArr.length === 4 ? "rgba" : "rgb");
  }
}
function fastLerp(normalizedValue, colors, out2) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  out2 = out2 || [];
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = colors[leftIndex];
  var rightColor = colors[rightIndex];
  var dv = value - leftIndex;
  out2[0] = clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv));
  out2[1] = clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv));
  out2[2] = clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv));
  out2[3] = clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv));
  return out2;
}
function lerp(normalizedValue, colors, fullOutput) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = parse(colors[leftIndex]);
  var rightColor = parse(colors[rightIndex]);
  var dv = value - leftIndex;
  var color = stringify([
    clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv)),
    clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv)),
    clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv)),
    clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv))
  ], "rgba");
  return fullOutput ? {
    color,
    leftIndex,
    rightIndex,
    value
  } : color;
}
function modifyHSL(color, h, s, l2) {
  var colorArr = parse(color);
  if (color) {
    colorArr = rgba2hsla(colorArr);
    h != null && (colorArr[0] = clampCssAngle(h));
    s != null && (colorArr[1] = parseCssFloat(s));
    l2 != null && (colorArr[2] = parseCssFloat(l2));
    return stringify(hsla2rgba(colorArr), "rgba");
  }
}
function modifyAlpha(color, alpha) {
  var colorArr = parse(color);
  if (colorArr && alpha != null) {
    colorArr[3] = clampCssFloat(alpha);
    return stringify(colorArr, "rgba");
  }
}
function stringify(arrColor, type4) {
  if (!arrColor || !arrColor.length) {
    return;
  }
  var colorStr = arrColor[0] + "," + arrColor[1] + "," + arrColor[2];
  if (type4 === "rgba" || type4 === "hsva" || type4 === "hsla") {
    colorStr += "," + arrColor[3];
  }
  return type4 + "(" + colorStr + ")";
}
function lum(color, backgroundLum) {
  var arr = parse(color);
  return arr ? (0.299 * arr[0] + 0.587 * arr[1] + 0.114 * arr[2]) * arr[3] / 255 + (1 - arr[3]) * backgroundLum : 0;
}
var mathRound$1 = Math.round;
function normalizeColor(color) {
  var opacity;
  if (!color || color === "transparent") {
    color = "none";
  } else if (typeof color === "string" && color.indexOf("rgba") > -1) {
    var arr = parse(color);
    if (arr) {
      color = "rgb(" + arr[0] + "," + arr[1] + "," + arr[2] + ")";
      opacity = arr[3];
    }
  }
  return {
    color,
    opacity: opacity == null ? 1 : opacity
  };
}
var EPSILON$3 = 1e-4;
function isAroundZero(transform2) {
  return transform2 < EPSILON$3 && transform2 > -EPSILON$3;
}
function round3(transform2) {
  return mathRound$1(transform2 * 1e3) / 1e3;
}
function round4(transform2) {
  return mathRound$1(transform2 * 1e4) / 1e4;
}
function getMatrixStr(m2) {
  return "matrix(" + round3(m2[0]) + "," + round3(m2[1]) + "," + round3(m2[2]) + "," + round3(m2[3]) + "," + round4(m2[4]) + "," + round4(m2[5]) + ")";
}
var TEXT_ALIGN_TO_ANCHOR = {
  left: "start",
  right: "end",
  center: "middle",
  middle: "middle"
};
function adjustTextY$1(y2, lineHeight, textBaseline) {
  if (textBaseline === "top") {
    y2 += lineHeight / 2;
  } else if (textBaseline === "bottom") {
    y2 -= lineHeight / 2;
  }
  return y2;
}
function hasShadow(style2) {
  return style2 && (style2.shadowBlur || style2.shadowOffsetX || style2.shadowOffsetY);
}
function getShadowKey(displayable) {
  var style2 = displayable.style;
  var globalScale = displayable.getGlobalScale();
  return [
    style2.shadowColor,
    (style2.shadowBlur || 0).toFixed(2),
    (style2.shadowOffsetX || 0).toFixed(2),
    (style2.shadowOffsetY || 0).toFixed(2),
    globalScale[0],
    globalScale[1]
  ].join(",");
}
function isImagePattern(val) {
  return val && !!val.image;
}
function isSVGPattern(val) {
  return val && !!val.svgElement;
}
function isPattern(val) {
  return isImagePattern(val) || isSVGPattern(val);
}
function isLinearGradient(val) {
  return val.type === "linear";
}
function isRadialGradient(val) {
  return val.type === "radial";
}
function isGradient(val) {
  return val && (val.type === "linear" || val.type === "radial");
}
function getIdURL(id2) {
  return "url(#" + id2 + ")";
}
function getPathPrecision(el) {
  var scale2 = el.getGlobalScale();
  var size = Math.max(scale2[0], scale2[1]);
  return Math.max(Math.ceil(Math.log(size) / Math.log(10)), 1);
}
function getSRTTransformString(transform2) {
  var x2 = transform2.x || 0;
  var y2 = transform2.y || 0;
  var rotation = (transform2.rotation || 0) * RADIAN_TO_DEGREE;
  var scaleX = retrieve2(transform2.scaleX, 1);
  var scaleY = retrieve2(transform2.scaleY, 1);
  var skewX = transform2.skewX || 0;
  var skewY = transform2.skewY || 0;
  var res = [];
  if (x2 || y2) {
    res.push("translate(" + x2 + "px," + y2 + "px)");
  }
  if (rotation) {
    res.push("rotate(" + rotation + ")");
  }
  if (scaleX !== 1 || scaleY !== 1) {
    res.push("scale(" + scaleX + "," + scaleY + ")");
  }
  if (skewX || skewY) {
    res.push("skew(" + mathRound$1(skewX * RADIAN_TO_DEGREE) + "deg, " + mathRound$1(skewY * RADIAN_TO_DEGREE) + "deg)");
  }
  return res.join(" ");
}
var encodeBase64 = function() {
  if (env$1.hasGlobalWindow && isFunction(window.btoa)) {
    return function(str) {
      return window.btoa(unescape(str));
    };
  }
  if (typeof Buffer !== "undefined") {
    return function(str) {
      return Buffer.from(str).toString("base64");
    };
  }
  return function(str) {
    return null;
  };
}();
var arraySlice = Array.prototype.slice;
function interpolateNumber$1(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
function interpolate1DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = interpolateNumber$1(p0[i], p1[i], percent);
  }
  return out2;
}
function interpolate2DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = interpolateNumber$1(p0[i][j], p1[i][j], percent);
    }
  }
  return out2;
}
function add1DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = p0[i] + p1[i] * sign;
  }
  return out2;
}
function add2DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = p0[i][j] + p1[i][j] * sign;
    }
  }
  return out2;
}
function fillColorStops(val0, val1) {
  var len0 = val0.length;
  var len1 = val1.length;
  var shorterArr = len0 > len1 ? val1 : val0;
  var shorterLen = Math.min(len0, len1);
  var last = shorterArr[shorterLen - 1] || { color: [0, 0, 0, 0], offset: 0 };
  for (var i = shorterLen; i < Math.max(len0, len1); i++) {
    shorterArr.push({
      offset: last.offset,
      color: last.color.slice()
    });
  }
}
function fillArray(val0, val1, arrDim) {
  var arr0 = val0;
  var arr1 = val1;
  if (!arr0.push || !arr1.push) {
    return;
  }
  var arr0Len = arr0.length;
  var arr1Len = arr1.length;
  if (arr0Len !== arr1Len) {
    var isPreviousLarger = arr0Len > arr1Len;
    if (isPreviousLarger) {
      arr0.length = arr1Len;
    } else {
      for (var i = arr0Len; i < arr1Len; i++) {
        arr0.push(arrDim === 1 ? arr1[i] : arraySlice.call(arr1[i]));
      }
    }
  }
  var len2 = arr0[0] && arr0[0].length;
  for (var i = 0; i < arr0.length; i++) {
    if (arrDim === 1) {
      if (isNaN(arr0[i])) {
        arr0[i] = arr1[i];
      }
    } else {
      for (var j = 0; j < len2; j++) {
        if (isNaN(arr0[i][j])) {
          arr0[i][j] = arr1[i][j];
        }
      }
    }
  }
}
function cloneValue(value) {
  if (isArrayLike(value)) {
    var len2 = value.length;
    if (isArrayLike(value[0])) {
      var ret = [];
      for (var i = 0; i < len2; i++) {
        ret.push(arraySlice.call(value[i]));
      }
      return ret;
    }
    return arraySlice.call(value);
  }
  return value;
}
function rgba2String(rgba) {
  rgba[0] = Math.floor(rgba[0]) || 0;
  rgba[1] = Math.floor(rgba[1]) || 0;
  rgba[2] = Math.floor(rgba[2]) || 0;
  rgba[3] = rgba[3] == null ? 1 : rgba[3];
  return "rgba(" + rgba.join(",") + ")";
}
function guessArrayDim(value) {
  return isArrayLike(value && value[0]) ? 2 : 1;
}
var VALUE_TYPE_NUMBER = 0;
var VALUE_TYPE_1D_ARRAY = 1;
var VALUE_TYPE_2D_ARRAY = 2;
var VALUE_TYPE_COLOR = 3;
var VALUE_TYPE_LINEAR_GRADIENT = 4;
var VALUE_TYPE_RADIAL_GRADIENT = 5;
var VALUE_TYPE_UNKOWN = 6;
function isGradientValueType(valType) {
  return valType === VALUE_TYPE_LINEAR_GRADIENT || valType === VALUE_TYPE_RADIAL_GRADIENT;
}
function isArrayValueType(valType) {
  return valType === VALUE_TYPE_1D_ARRAY || valType === VALUE_TYPE_2D_ARRAY;
}
var tmpRgba = [0, 0, 0, 0];
var Track = function() {
  function Track2(propName) {
    this.keyframes = [];
    this.discrete = false;
    this._invalid = false;
    this._needsSort = false;
    this._lastFr = 0;
    this._lastFrP = 0;
    this.propName = propName;
  }
  Track2.prototype.isFinished = function() {
    return this._finished;
  };
  Track2.prototype.setFinished = function() {
    this._finished = true;
    if (this._additiveTrack) {
      this._additiveTrack.setFinished();
    }
  };
  Track2.prototype.needsAnimate = function() {
    return this.keyframes.length >= 1;
  };
  Track2.prototype.getAdditiveTrack = function() {
    return this._additiveTrack;
  };
  Track2.prototype.addKeyframe = function(time, rawValue, easing) {
    this._needsSort = true;
    var keyframes = this.keyframes;
    var len2 = keyframes.length;
    var discrete = false;
    var valType = VALUE_TYPE_UNKOWN;
    var value = rawValue;
    if (isArrayLike(rawValue)) {
      var arrayDim = guessArrayDim(rawValue);
      valType = arrayDim;
      if (arrayDim === 1 && !isNumber(rawValue[0]) || arrayDim === 2 && !isNumber(rawValue[0][0])) {
        discrete = true;
      }
    } else {
      if (isNumber(rawValue) && !eqNaN(rawValue)) {
        valType = VALUE_TYPE_NUMBER;
      } else if (isString$1(rawValue)) {
        if (!isNaN(+rawValue)) {
          valType = VALUE_TYPE_NUMBER;
        } else {
          var colorArray = parse(rawValue);
          if (colorArray) {
            value = colorArray;
            valType = VALUE_TYPE_COLOR;
          }
        }
      } else if (isGradientObject(rawValue)) {
        var parsedGradient = extend({}, value);
        parsedGradient.colorStops = map$1(rawValue.colorStops, function(colorStop) {
          return {
            offset: colorStop.offset,
            color: parse(colorStop.color)
          };
        });
        if (isLinearGradient(rawValue)) {
          valType = VALUE_TYPE_LINEAR_GRADIENT;
        } else if (isRadialGradient(rawValue)) {
          valType = VALUE_TYPE_RADIAL_GRADIENT;
        }
        value = parsedGradient;
      }
    }
    if (len2 === 0) {
      this.valType = valType;
    } else if (valType !== this.valType || valType === VALUE_TYPE_UNKOWN) {
      discrete = true;
    }
    this.discrete = this.discrete || discrete;
    var kf2 = {
      time,
      value,
      rawValue,
      percent: 0
    };
    if (easing) {
      kf2.easing = easing;
      kf2.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
    }
    keyframes.push(kf2);
    return kf2;
  };
  Track2.prototype.prepare = function(maxTime, additiveTrack) {
    var kfs = this.keyframes;
    if (this._needsSort) {
      kfs.sort(function(a, b2) {
        return a.time - b2.time;
      });
    }
    var valType = this.valType;
    var kfsLen = kfs.length;
    var lastKf = kfs[kfsLen - 1];
    var isDiscrete = this.discrete;
    var isArr = isArrayValueType(valType);
    var isGradient2 = isGradientValueType(valType);
    for (var i = 0; i < kfsLen; i++) {
      var kf2 = kfs[i];
      var value = kf2.value;
      var lastValue = lastKf.value;
      kf2.percent = kf2.time / maxTime;
      if (!isDiscrete) {
        if (isArr && i !== kfsLen - 1) {
          fillArray(value, lastValue, valType);
        } else if (isGradient2) {
          fillColorStops(value.colorStops, lastValue.colorStops);
        }
      }
    }
    if (!isDiscrete && valType !== VALUE_TYPE_RADIAL_GRADIENT && additiveTrack && this.needsAnimate() && additiveTrack.needsAnimate() && valType === additiveTrack.valType && !additiveTrack._finished) {
      this._additiveTrack = additiveTrack;
      var startValue = kfs[0].value;
      for (var i = 0; i < kfsLen; i++) {
        if (valType === VALUE_TYPE_NUMBER) {
          kfs[i].additiveValue = kfs[i].value - startValue;
        } else if (valType === VALUE_TYPE_COLOR) {
          kfs[i].additiveValue = add1DArray([], kfs[i].value, startValue, -1);
        } else if (isArrayValueType(valType)) {
          kfs[i].additiveValue = valType === VALUE_TYPE_1D_ARRAY ? add1DArray([], kfs[i].value, startValue, -1) : add2DArray([], kfs[i].value, startValue, -1);
        }
      }
    }
  };
  Track2.prototype.step = function(target, percent) {
    if (this._finished) {
      return;
    }
    if (this._additiveTrack && this._additiveTrack._finished) {
      this._additiveTrack = null;
    }
    var isAdditive = this._additiveTrack != null;
    var valueKey = isAdditive ? "additiveValue" : "value";
    var valType = this.valType;
    var keyframes = this.keyframes;
    var kfsNum = keyframes.length;
    var propName = this.propName;
    var isValueColor = valType === VALUE_TYPE_COLOR;
    var frameIdx;
    var lastFrame = this._lastFr;
    var mathMin2 = Math.min;
    var frame;
    var nextFrame;
    if (kfsNum === 1) {
      frame = nextFrame = keyframes[0];
    } else {
      if (percent < 0) {
        frameIdx = 0;
      } else if (percent < this._lastFrP) {
        var start2 = mathMin2(lastFrame + 1, kfsNum - 1);
        for (frameIdx = start2; frameIdx >= 0; frameIdx--) {
          if (keyframes[frameIdx].percent <= percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx, kfsNum - 2);
      } else {
        for (frameIdx = lastFrame; frameIdx < kfsNum; frameIdx++) {
          if (keyframes[frameIdx].percent > percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx - 1, kfsNum - 2);
      }
      nextFrame = keyframes[frameIdx + 1];
      frame = keyframes[frameIdx];
    }
    if (!(frame && nextFrame)) {
      return;
    }
    this._lastFr = frameIdx;
    this._lastFrP = percent;
    var interval = nextFrame.percent - frame.percent;
    var w2 = interval === 0 ? 1 : mathMin2((percent - frame.percent) / interval, 1);
    if (nextFrame.easingFunc) {
      w2 = nextFrame.easingFunc(w2);
    }
    var targetArr = isAdditive ? this._additiveValue : isValueColor ? tmpRgba : target[propName];
    if ((isArrayValueType(valType) || isValueColor) && !targetArr) {
      targetArr = this._additiveValue = [];
    }
    if (this.discrete) {
      target[propName] = w2 < 1 ? frame.rawValue : nextFrame.rawValue;
    } else if (isArrayValueType(valType)) {
      valType === VALUE_TYPE_1D_ARRAY ? interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2) : interpolate2DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
    } else if (isGradientValueType(valType)) {
      var val = frame[valueKey];
      var nextVal_1 = nextFrame[valueKey];
      var isLinearGradient_1 = valType === VALUE_TYPE_LINEAR_GRADIENT;
      target[propName] = {
        type: isLinearGradient_1 ? "linear" : "radial",
        x: interpolateNumber$1(val.x, nextVal_1.x, w2),
        y: interpolateNumber$1(val.y, nextVal_1.y, w2),
        colorStops: map$1(val.colorStops, function(colorStop, idx) {
          var nextColorStop = nextVal_1.colorStops[idx];
          return {
            offset: interpolateNumber$1(colorStop.offset, nextColorStop.offset, w2),
            color: rgba2String(interpolate1DArray([], colorStop.color, nextColorStop.color, w2))
          };
        }),
        global: nextVal_1.global
      };
      if (isLinearGradient_1) {
        target[propName].x2 = interpolateNumber$1(val.x2, nextVal_1.x2, w2);
        target[propName].y2 = interpolateNumber$1(val.y2, nextVal_1.y2, w2);
      } else {
        target[propName].r = interpolateNumber$1(val.r, nextVal_1.r, w2);
      }
    } else if (isValueColor) {
      interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
      if (!isAdditive) {
        target[propName] = rgba2String(targetArr);
      }
    } else {
      var value = interpolateNumber$1(frame[valueKey], nextFrame[valueKey], w2);
      if (isAdditive) {
        this._additiveValue = value;
      } else {
        target[propName] = value;
      }
    }
    if (isAdditive) {
      this._addToTarget(target);
    }
  };
  Track2.prototype._addToTarget = function(target) {
    var valType = this.valType;
    var propName = this.propName;
    var additiveValue = this._additiveValue;
    if (valType === VALUE_TYPE_NUMBER) {
      target[propName] = target[propName] + additiveValue;
    } else if (valType === VALUE_TYPE_COLOR) {
      parse(target[propName], tmpRgba);
      add1DArray(tmpRgba, tmpRgba, additiveValue, 1);
      target[propName] = rgba2String(tmpRgba);
    } else if (valType === VALUE_TYPE_1D_ARRAY) {
      add1DArray(target[propName], target[propName], additiveValue, 1);
    } else if (valType === VALUE_TYPE_2D_ARRAY) {
      add2DArray(target[propName], target[propName], additiveValue, 1);
    }
  };
  return Track2;
}();
var Animator = function() {
  function Animator2(target, loop, allowDiscreteAnimation, additiveTo) {
    this._tracks = {};
    this._trackKeys = [];
    this._maxTime = 0;
    this._started = 0;
    this._clip = null;
    this._target = target;
    this._loop = loop;
    if (loop && additiveTo) {
      logError("Can' use additive animation on looped animation.");
      return;
    }
    this._additiveAnimators = additiveTo;
    this._allowDiscrete = allowDiscreteAnimation;
  }
  Animator2.prototype.getMaxTime = function() {
    return this._maxTime;
  };
  Animator2.prototype.getDelay = function() {
    return this._delay;
  };
  Animator2.prototype.getLoop = function() {
    return this._loop;
  };
  Animator2.prototype.getTarget = function() {
    return this._target;
  };
  Animator2.prototype.changeTarget = function(target) {
    this._target = target;
  };
  Animator2.prototype.when = function(time, props, easing) {
    return this.whenWithKeys(time, props, keys(props), easing);
  };
  Animator2.prototype.whenWithKeys = function(time, props, propNames, easing) {
    var tracks = this._tracks;
    for (var i = 0; i < propNames.length; i++) {
      var propName = propNames[i];
      var track = tracks[propName];
      if (!track) {
        track = tracks[propName] = new Track(propName);
        var initialValue = void 0;
        var additiveTrack = this._getAdditiveTrack(propName);
        if (additiveTrack) {
          var addtiveTrackKfs = additiveTrack.keyframes;
          var lastFinalKf = addtiveTrackKfs[addtiveTrackKfs.length - 1];
          initialValue = lastFinalKf && lastFinalKf.value;
          if (additiveTrack.valType === VALUE_TYPE_COLOR && initialValue) {
            initialValue = rgba2String(initialValue);
          }
        } else {
          initialValue = this._target[propName];
        }
        if (initialValue == null) {
          continue;
        }
        if (time > 0) {
          track.addKeyframe(0, cloneValue(initialValue), easing);
        }
        this._trackKeys.push(propName);
      }
      track.addKeyframe(time, cloneValue(props[propName]), easing);
    }
    this._maxTime = Math.max(this._maxTime, time);
    return this;
  };
  Animator2.prototype.pause = function() {
    this._clip.pause();
    this._paused = true;
  };
  Animator2.prototype.resume = function() {
    this._clip.resume();
    this._paused = false;
  };
  Animator2.prototype.isPaused = function() {
    return !!this._paused;
  };
  Animator2.prototype.duration = function(duration) {
    this._maxTime = duration;
    this._force = true;
    return this;
  };
  Animator2.prototype._doneCallback = function() {
    this._setTracksFinished();
    this._clip = null;
    var doneList = this._doneCbs;
    if (doneList) {
      var len2 = doneList.length;
      for (var i = 0; i < len2; i++) {
        doneList[i].call(this);
      }
    }
  };
  Animator2.prototype._abortedCallback = function() {
    this._setTracksFinished();
    var animation = this.animation;
    var abortedList = this._abortedCbs;
    if (animation) {
      animation.removeClip(this._clip);
    }
    this._clip = null;
    if (abortedList) {
      for (var i = 0; i < abortedList.length; i++) {
        abortedList[i].call(this);
      }
    }
  };
  Animator2.prototype._setTracksFinished = function() {
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < tracksKeys.length; i++) {
      tracks[tracksKeys[i]].setFinished();
    }
  };
  Animator2.prototype._getAdditiveTrack = function(trackName) {
    var additiveTrack;
    var additiveAnimators = this._additiveAnimators;
    if (additiveAnimators) {
      for (var i = 0; i < additiveAnimators.length; i++) {
        var track = additiveAnimators[i].getTrack(trackName);
        if (track) {
          additiveTrack = track;
        }
      }
    }
    return additiveTrack;
  };
  Animator2.prototype.start = function(easing) {
    if (this._started > 0) {
      return;
    }
    this._started = 1;
    var self2 = this;
    var tracks = [];
    var maxTime = this._maxTime || 0;
    for (var i = 0; i < this._trackKeys.length; i++) {
      var propName = this._trackKeys[i];
      var track = this._tracks[propName];
      var additiveTrack = this._getAdditiveTrack(propName);
      var kfs = track.keyframes;
      var kfsNum = kfs.length;
      track.prepare(maxTime, additiveTrack);
      if (track.needsAnimate()) {
        if (!this._allowDiscrete && track.discrete) {
          var lastKf = kfs[kfsNum - 1];
          if (lastKf) {
            self2._target[track.propName] = lastKf.rawValue;
          }
          track.setFinished();
        } else {
          tracks.push(track);
        }
      }
    }
    if (tracks.length || this._force) {
      var clip2 = new Clip$1({
        life: maxTime,
        loop: this._loop,
        delay: this._delay || 0,
        onframe: function(percent) {
          self2._started = 2;
          var additiveAnimators = self2._additiveAnimators;
          if (additiveAnimators) {
            var stillHasAdditiveAnimator = false;
            for (var i2 = 0; i2 < additiveAnimators.length; i2++) {
              if (additiveAnimators[i2]._clip) {
                stillHasAdditiveAnimator = true;
                break;
              }
            }
            if (!stillHasAdditiveAnimator) {
              self2._additiveAnimators = null;
            }
          }
          for (var i2 = 0; i2 < tracks.length; i2++) {
            tracks[i2].step(self2._target, percent);
          }
          var onframeList = self2._onframeCbs;
          if (onframeList) {
            for (var i2 = 0; i2 < onframeList.length; i2++) {
              onframeList[i2](self2._target, percent);
            }
          }
        },
        ondestroy: function() {
          self2._doneCallback();
        }
      });
      this._clip = clip2;
      if (this.animation) {
        this.animation.addClip(clip2);
      }
      if (easing) {
        clip2.setEasing(easing);
      }
    } else {
      this._doneCallback();
    }
    return this;
  };
  Animator2.prototype.stop = function(forwardToLast) {
    if (!this._clip) {
      return;
    }
    var clip2 = this._clip;
    if (forwardToLast) {
      clip2.onframe(1);
    }
    this._abortedCallback();
  };
  Animator2.prototype.delay = function(time) {
    this._delay = time;
    return this;
  };
  Animator2.prototype.during = function(cb2) {
    if (cb2) {
      if (!this._onframeCbs) {
        this._onframeCbs = [];
      }
      this._onframeCbs.push(cb2);
    }
    return this;
  };
  Animator2.prototype.done = function(cb2) {
    if (cb2) {
      if (!this._doneCbs) {
        this._doneCbs = [];
      }
      this._doneCbs.push(cb2);
    }
    return this;
  };
  Animator2.prototype.aborted = function(cb2) {
    if (cb2) {
      if (!this._abortedCbs) {
        this._abortedCbs = [];
      }
      this._abortedCbs.push(cb2);
    }
    return this;
  };
  Animator2.prototype.getClip = function() {
    return this._clip;
  };
  Animator2.prototype.getTrack = function(propName) {
    return this._tracks[propName];
  };
  Animator2.prototype.getTracks = function() {
    var _this = this;
    return map$1(this._trackKeys, function(key) {
      return _this._tracks[key];
    });
  };
  Animator2.prototype.stopTracks = function(propNames, forwardToLast) {
    if (!propNames.length || !this._clip) {
      return true;
    }
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < propNames.length; i++) {
      var track = tracks[propNames[i]];
      if (track && !track.isFinished()) {
        if (forwardToLast) {
          track.step(this._target, 1);
        } else if (this._started === 1) {
          track.step(this._target, 0);
        }
        track.setFinished();
      }
    }
    var allAborted = true;
    for (var i = 0; i < tracksKeys.length; i++) {
      if (!tracks[tracksKeys[i]].isFinished()) {
        allAborted = false;
        break;
      }
    }
    if (allAborted) {
      this._abortedCallback();
    }
    return allAborted;
  };
  Animator2.prototype.saveTo = function(target, trackKeys, firstOrLast) {
    if (!target) {
      return;
    }
    trackKeys = trackKeys || this._trackKeys;
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track || track.isFinished()) {
        continue;
      }
      var kfs = track.keyframes;
      var kf2 = kfs[firstOrLast ? 0 : kfs.length - 1];
      if (kf2) {
        target[propName] = cloneValue(kf2.rawValue);
      }
    }
  };
  Animator2.prototype.__changeFinalValue = function(finalProps, trackKeys) {
    trackKeys = trackKeys || keys(finalProps);
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track) {
        continue;
      }
      var kfs = track.keyframes;
      if (kfs.length > 1) {
        var lastKf = kfs.pop();
        track.addKeyframe(lastKf.time, finalProps[propName]);
        track.prepare(this._maxTime, track.getAdditiveTrack());
      }
    }
  };
  return Animator2;
}();
function getTime() {
  return new Date().getTime();
}
var Animation = function(_super) {
  __extends(Animation2, _super);
  function Animation2(opts) {
    var _this = _super.call(this) || this;
    _this._running = false;
    _this._time = 0;
    _this._pausedTime = 0;
    _this._pauseStart = 0;
    _this._paused = false;
    opts = opts || {};
    _this.stage = opts.stage || {};
    return _this;
  }
  Animation2.prototype.addClip = function(clip2) {
    if (clip2.animation) {
      this.removeClip(clip2);
    }
    if (!this._head) {
      this._head = this._tail = clip2;
    } else {
      this._tail.next = clip2;
      clip2.prev = this._tail;
      clip2.next = null;
      this._tail = clip2;
    }
    clip2.animation = this;
  };
  Animation2.prototype.addAnimator = function(animator) {
    animator.animation = this;
    var clip2 = animator.getClip();
    if (clip2) {
      this.addClip(clip2);
    }
  };
  Animation2.prototype.removeClip = function(clip2) {
    if (!clip2.animation) {
      return;
    }
    var prev = clip2.prev;
    var next = clip2.next;
    if (prev) {
      prev.next = next;
    } else {
      this._head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this._tail = prev;
    }
    clip2.next = clip2.prev = clip2.animation = null;
  };
  Animation2.prototype.removeAnimator = function(animator) {
    var clip2 = animator.getClip();
    if (clip2) {
      this.removeClip(clip2);
    }
    animator.animation = null;
  };
  Animation2.prototype.update = function(notTriggerFrameAndStageUpdate) {
    var time = getTime() - this._pausedTime;
    var delta = time - this._time;
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      var finished = clip2.step(time, delta);
      if (finished) {
        clip2.ondestroy();
        this.removeClip(clip2);
        clip2 = nextClip;
      } else {
        clip2 = nextClip;
      }
    }
    this._time = time;
    if (!notTriggerFrameAndStageUpdate) {
      this.trigger("frame", delta);
      this.stage.update && this.stage.update();
    }
  };
  Animation2.prototype._startLoop = function() {
    var self2 = this;
    this._running = true;
    function step() {
      if (self2._running) {
        requestAnimationFrame$2(step);
        !self2._paused && self2.update();
      }
    }
    requestAnimationFrame$2(step);
  };
  Animation2.prototype.start = function() {
    if (this._running) {
      return;
    }
    this._time = getTime();
    this._pausedTime = 0;
    this._startLoop();
  };
  Animation2.prototype.stop = function() {
    this._running = false;
  };
  Animation2.prototype.pause = function() {
    if (!this._paused) {
      this._pauseStart = getTime();
      this._paused = true;
    }
  };
  Animation2.prototype.resume = function() {
    if (this._paused) {
      this._pausedTime += getTime() - this._pauseStart;
      this._paused = false;
    }
  };
  Animation2.prototype.clear = function() {
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      clip2.prev = clip2.next = clip2.animation = null;
      clip2 = nextClip;
    }
    this._head = this._tail = null;
  };
  Animation2.prototype.isFinished = function() {
    return this._head == null;
  };
  Animation2.prototype.animate = function(target, options) {
    options = options || {};
    this.start();
    var animator = new Animator(target, options.loop);
    this.addAnimator(animator);
    return animator;
  };
  return Animation2;
}(Eventful$1);
var Animation$1 = Animation;
var TOUCH_CLICK_DELAY = 300;
var globalEventSupported = env$1.domSupported;
var localNativeListenerNames = function() {
  var mouseHandlerNames = [
    "click",
    "dblclick",
    "mousewheel",
    "wheel",
    "mouseout",
    "mouseup",
    "mousedown",
    "mousemove",
    "contextmenu"
  ];
  var touchHandlerNames = [
    "touchstart",
    "touchend",
    "touchmove"
  ];
  var pointerEventNameMap = {
    pointerdown: 1,
    pointerup: 1,
    pointermove: 1,
    pointerout: 1
  };
  var pointerHandlerNames = map$1(mouseHandlerNames, function(name) {
    var nm = name.replace("mouse", "pointer");
    return pointerEventNameMap.hasOwnProperty(nm) ? nm : name;
  });
  return {
    mouse: mouseHandlerNames,
    touch: touchHandlerNames,
    pointer: pointerHandlerNames
  };
}();
var globalNativeListenerNames = {
  mouse: ["mousemove", "mouseup"],
  pointer: ["pointermove", "pointerup"]
};
var wheelEventSupported = false;
function isPointerFromTouch(event) {
  var pointerType = event.pointerType;
  return pointerType === "pen" || pointerType === "touch";
}
function setTouchTimer(scope) {
  scope.touching = true;
  if (scope.touchTimer != null) {
    clearTimeout(scope.touchTimer);
    scope.touchTimer = null;
  }
  scope.touchTimer = setTimeout(function() {
    scope.touching = false;
    scope.touchTimer = null;
  }, 700);
}
function markTouch(event) {
  event && (event.zrByTouch = true);
}
function normalizeGlobalEvent(instance, event) {
  return normalizeEvent(instance.dom, new FakeGlobalEvent(instance, event), true);
}
function isLocalEl(instance, el) {
  var elTmp = el;
  var isLocal = false;
  while (elTmp && elTmp.nodeType !== 9 && !(isLocal = elTmp.domBelongToZr || elTmp !== el && elTmp === instance.painterRoot)) {
    elTmp = elTmp.parentNode;
  }
  return isLocal;
}
var FakeGlobalEvent = function() {
  function FakeGlobalEvent2(instance, event) {
    this.stopPropagation = noop$1;
    this.stopImmediatePropagation = noop$1;
    this.preventDefault = noop$1;
    this.type = event.type;
    this.target = this.currentTarget = instance.dom;
    this.pointerType = event.pointerType;
    this.clientX = event.clientX;
    this.clientY = event.clientY;
  }
  return FakeGlobalEvent2;
}();
var localDOMHandlers = {
  mousedown: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__mayPointerCapture = [event.zrX, event.zrY];
    this.trigger("mousedown", event);
  },
  mousemove: function(event) {
    event = normalizeEvent(this.dom, event);
    var downPoint = this.__mayPointerCapture;
    if (downPoint && (event.zrX !== downPoint[0] || event.zrY !== downPoint[1])) {
      this.__togglePointerCapture(true);
    }
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
  },
  mouseout: function(event) {
    event = normalizeEvent(this.dom, event);
    var element = event.toElement || event.relatedTarget;
    if (!isLocalEl(this, element)) {
      if (this.__pointerCapturing) {
        event.zrEventControl = "no_globalout";
      }
      this.trigger("mouseout", event);
    }
  },
  wheel: function(event) {
    wheelEventSupported = true;
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  mousewheel: function(event) {
    if (wheelEventSupported) {
      return;
    }
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  touchstart: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.__lastTouchMoment = new Date();
    this.handler.processGesture(event, "start");
    localDOMHandlers.mousemove.call(this, event);
    localDOMHandlers.mousedown.call(this, event);
  },
  touchmove: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "change");
    localDOMHandlers.mousemove.call(this, event);
  },
  touchend: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "end");
    localDOMHandlers.mouseup.call(this, event);
    if (+new Date() - +this.__lastTouchMoment < TOUCH_CLICK_DELAY) {
      localDOMHandlers.click.call(this, event);
    }
  },
  pointerdown: function(event) {
    localDOMHandlers.mousedown.call(this, event);
  },
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    localDOMHandlers.mouseup.call(this, event);
  },
  pointerout: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mouseout.call(this, event);
    }
  }
};
each$g(["click", "dblclick", "contextmenu"], function(name) {
  localDOMHandlers[name] = function(event) {
    event = normalizeEvent(this.dom, event);
    this.trigger(name, event);
  };
});
var globalDOMHandlers = {
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      globalDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    globalDOMHandlers.mouseup.call(this, event);
  },
  mousemove: function(event) {
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    var pointerCaptureReleasing = this.__pointerCapturing;
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
    if (pointerCaptureReleasing) {
      event.zrEventControl = "only_globalout";
      this.trigger("mouseout", event);
    }
  }
};
function mountLocalDOMEventListeners(instance, scope) {
  var domHandlers = scope.domHandlers;
  if (env$1.pointerEventsSupported) {
    each$g(localNativeListenerNames.pointer, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        domHandlers[nativeEventName].call(instance, event);
      });
    });
  } else {
    if (env$1.touchEventsSupported) {
      each$g(localNativeListenerNames.touch, function(nativeEventName) {
        mountSingleDOMEventListener(scope, nativeEventName, function(event) {
          domHandlers[nativeEventName].call(instance, event);
          setTouchTimer(scope);
        });
      });
    }
    each$g(localNativeListenerNames.mouse, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        event = getNativeEvent(event);
        if (!scope.touching) {
          domHandlers[nativeEventName].call(instance, event);
        }
      });
    });
  }
}
function mountGlobalDOMEventListeners(instance, scope) {
  if (env$1.pointerEventsSupported) {
    each$g(globalNativeListenerNames.pointer, mount);
  } else if (!env$1.touchEventsSupported) {
    each$g(globalNativeListenerNames.mouse, mount);
  }
  function mount(nativeEventName) {
    function nativeEventListener(event) {
      event = getNativeEvent(event);
      if (!isLocalEl(instance, event.target)) {
        event = normalizeGlobalEvent(instance, event);
        scope.domHandlers[nativeEventName].call(instance, event);
      }
    }
    mountSingleDOMEventListener(scope, nativeEventName, nativeEventListener, { capture: true });
  }
}
function mountSingleDOMEventListener(scope, nativeEventName, listener, opt) {
  scope.mounted[nativeEventName] = listener;
  scope.listenerOpts[nativeEventName] = opt;
  addEventListener$1(scope.domTarget, nativeEventName, listener, opt);
}
function unmountDOMEventListeners(scope) {
  var mounted = scope.mounted;
  for (var nativeEventName in mounted) {
    if (mounted.hasOwnProperty(nativeEventName)) {
      removeEventListener$1(scope.domTarget, nativeEventName, mounted[nativeEventName], scope.listenerOpts[nativeEventName]);
    }
  }
  scope.mounted = {};
}
var DOMHandlerScope = function() {
  function DOMHandlerScope2(domTarget, domHandlers) {
    this.mounted = {};
    this.listenerOpts = {};
    this.touching = false;
    this.domTarget = domTarget;
    this.domHandlers = domHandlers;
  }
  return DOMHandlerScope2;
}();
var HandlerDomProxy = function(_super) {
  __extends(HandlerDomProxy2, _super);
  function HandlerDomProxy2(dom, painterRoot) {
    var _this = _super.call(this) || this;
    _this.__pointerCapturing = false;
    _this.dom = dom;
    _this.painterRoot = painterRoot;
    _this._localHandlerScope = new DOMHandlerScope(dom, localDOMHandlers);
    if (globalEventSupported) {
      _this._globalHandlerScope = new DOMHandlerScope(document, globalDOMHandlers);
    }
    mountLocalDOMEventListeners(_this, _this._localHandlerScope);
    return _this;
  }
  HandlerDomProxy2.prototype.dispose = function() {
    unmountDOMEventListeners(this._localHandlerScope);
    if (globalEventSupported) {
      unmountDOMEventListeners(this._globalHandlerScope);
    }
  };
  HandlerDomProxy2.prototype.setCursor = function(cursorStyle) {
    this.dom.style && (this.dom.style.cursor = cursorStyle || "default");
  };
  HandlerDomProxy2.prototype.__togglePointerCapture = function(isPointerCapturing) {
    this.__mayPointerCapture = null;
    if (globalEventSupported && +this.__pointerCapturing ^ +isPointerCapturing) {
      this.__pointerCapturing = isPointerCapturing;
      var globalHandlerScope = this._globalHandlerScope;
      isPointerCapturing ? mountGlobalDOMEventListeners(this, globalHandlerScope) : unmountDOMEventListeners(globalHandlerScope);
    }
  };
  return HandlerDomProxy2;
}(Eventful$1);
var HandlerProxy = HandlerDomProxy;
var dpr = 1;
if (env$1.hasGlobalWindow) {
  dpr = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1);
}
var devicePixelRatio = dpr;
var DARK_MODE_THRESHOLD = 0.4;
var DARK_LABEL_COLOR = "#333";
var LIGHT_LABEL_COLOR = "#ccc";
var LIGHTER_LABEL_COLOR = "#eee";
function create$1() {
  return [1, 0, 0, 1, 0, 0];
}
function identity(out2) {
  out2[0] = 1;
  out2[1] = 0;
  out2[2] = 0;
  out2[3] = 1;
  out2[4] = 0;
  out2[5] = 0;
  return out2;
}
function copy(out2, m2) {
  out2[0] = m2[0];
  out2[1] = m2[1];
  out2[2] = m2[2];
  out2[3] = m2[3];
  out2[4] = m2[4];
  out2[5] = m2[5];
  return out2;
}
function mul(out2, m1, m2) {
  var out0 = m1[0] * m2[0] + m1[2] * m2[1];
  var out1 = m1[1] * m2[0] + m1[3] * m2[1];
  var out22 = m1[0] * m2[2] + m1[2] * m2[3];
  var out3 = m1[1] * m2[2] + m1[3] * m2[3];
  var out4 = m1[0] * m2[4] + m1[2] * m2[5] + m1[4];
  var out5 = m1[1] * m2[4] + m1[3] * m2[5] + m1[5];
  out2[0] = out0;
  out2[1] = out1;
  out2[2] = out22;
  out2[3] = out3;
  out2[4] = out4;
  out2[5] = out5;
  return out2;
}
function translate(out2, a, v4) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  out2[4] = a[4] + v4[0];
  out2[5] = a[5] + v4[1];
  return out2;
}
function rotate(out2, a, rad) {
  var aa2 = a[0];
  var ac2 = a[2];
  var atx = a[4];
  var ab2 = a[1];
  var ad2 = a[3];
  var aty = a[5];
  var st = Math.sin(rad);
  var ct = Math.cos(rad);
  out2[0] = aa2 * ct + ab2 * st;
  out2[1] = -aa2 * st + ab2 * ct;
  out2[2] = ac2 * ct + ad2 * st;
  out2[3] = -ac2 * st + ct * ad2;
  out2[4] = ct * atx + st * aty;
  out2[5] = ct * aty - st * atx;
  return out2;
}
function scale$1(out2, a, v4) {
  var vx = v4[0];
  var vy = v4[1];
  out2[0] = a[0] * vx;
  out2[1] = a[1] * vy;
  out2[2] = a[2] * vx;
  out2[3] = a[3] * vy;
  out2[4] = a[4] * vx;
  out2[5] = a[5] * vy;
  return out2;
}
function invert(out2, a) {
  var aa2 = a[0];
  var ac2 = a[2];
  var atx = a[4];
  var ab2 = a[1];
  var ad2 = a[3];
  var aty = a[5];
  var det = aa2 * ad2 - ab2 * ac2;
  if (!det) {
    return null;
  }
  det = 1 / det;
  out2[0] = ad2 * det;
  out2[1] = -ab2 * det;
  out2[2] = -ac2 * det;
  out2[3] = aa2 * det;
  out2[4] = (ac2 * aty - ad2 * atx) * det;
  out2[5] = (ab2 * atx - aa2 * aty) * det;
  return out2;
}
function clone$2(a) {
  var b2 = create$1();
  copy(b2, a);
  return b2;
}
var mIdentity = identity;
var EPSILON$2 = 5e-5;
function isNotAroundZero(val) {
  return val > EPSILON$2 || val < -EPSILON$2;
}
var scaleTmp = [];
var tmpTransform = [];
var originTransform = create$1();
var abs = Math.abs;
var Transformable = function() {
  function Transformable2() {
  }
  Transformable2.prototype.getLocalTransform = function(m2) {
    return Transformable2.getLocalTransform(this, m2);
  };
  Transformable2.prototype.setPosition = function(arr) {
    this.x = arr[0];
    this.y = arr[1];
  };
  Transformable2.prototype.setScale = function(arr) {
    this.scaleX = arr[0];
    this.scaleY = arr[1];
  };
  Transformable2.prototype.setSkew = function(arr) {
    this.skewX = arr[0];
    this.skewY = arr[1];
  };
  Transformable2.prototype.setOrigin = function(arr) {
    this.originX = arr[0];
    this.originY = arr[1];
  };
  Transformable2.prototype.needLocalTransform = function() {
    return isNotAroundZero(this.rotation) || isNotAroundZero(this.x) || isNotAroundZero(this.y) || isNotAroundZero(this.scaleX - 1) || isNotAroundZero(this.scaleY - 1) || isNotAroundZero(this.skewX) || isNotAroundZero(this.skewY);
  };
  Transformable2.prototype.updateTransform = function() {
    var parentTransform = this.parent && this.parent.transform;
    var needLocalTransform = this.needLocalTransform();
    var m2 = this.transform;
    if (!(needLocalTransform || parentTransform)) {
      m2 && mIdentity(m2);
      return;
    }
    m2 = m2 || create$1();
    if (needLocalTransform) {
      this.getLocalTransform(m2);
    } else {
      mIdentity(m2);
    }
    if (parentTransform) {
      if (needLocalTransform) {
        mul(m2, parentTransform, m2);
      } else {
        copy(m2, parentTransform);
      }
    }
    this.transform = m2;
    this._resolveGlobalScaleRatio(m2);
  };
  Transformable2.prototype._resolveGlobalScaleRatio = function(m2) {
    var globalScaleRatio = this.globalScaleRatio;
    if (globalScaleRatio != null && globalScaleRatio !== 1) {
      this.getGlobalScale(scaleTmp);
      var relX = scaleTmp[0] < 0 ? -1 : 1;
      var relY = scaleTmp[1] < 0 ? -1 : 1;
      var sx = ((scaleTmp[0] - relX) * globalScaleRatio + relX) / scaleTmp[0] || 0;
      var sy = ((scaleTmp[1] - relY) * globalScaleRatio + relY) / scaleTmp[1] || 0;
      m2[0] *= sx;
      m2[1] *= sx;
      m2[2] *= sy;
      m2[3] *= sy;
    }
    this.invTransform = this.invTransform || create$1();
    invert(this.invTransform, m2);
  };
  Transformable2.prototype.getComputedTransform = function() {
    var transformNode = this;
    var ancestors = [];
    while (transformNode) {
      ancestors.push(transformNode);
      transformNode = transformNode.parent;
    }
    while (transformNode = ancestors.pop()) {
      transformNode.updateTransform();
    }
    return this.transform;
  };
  Transformable2.prototype.setLocalTransform = function(m2) {
    if (!m2) {
      return;
    }
    var sx = m2[0] * m2[0] + m2[1] * m2[1];
    var sy = m2[2] * m2[2] + m2[3] * m2[3];
    var rotation = Math.atan2(m2[1], m2[0]);
    var shearX = Math.PI / 2 + rotation - Math.atan2(m2[3], m2[2]);
    sy = Math.sqrt(sy) * Math.cos(shearX);
    sx = Math.sqrt(sx);
    this.skewX = shearX;
    this.skewY = 0;
    this.rotation = -rotation;
    this.x = +m2[4];
    this.y = +m2[5];
    this.scaleX = sx;
    this.scaleY = sy;
    this.originX = 0;
    this.originY = 0;
  };
  Transformable2.prototype.decomposeTransform = function() {
    if (!this.transform) {
      return;
    }
    var parent = this.parent;
    var m2 = this.transform;
    if (parent && parent.transform) {
      mul(tmpTransform, parent.invTransform, m2);
      m2 = tmpTransform;
    }
    var ox = this.originX;
    var oy = this.originY;
    if (ox || oy) {
      originTransform[4] = ox;
      originTransform[5] = oy;
      mul(tmpTransform, m2, originTransform);
      tmpTransform[4] -= ox;
      tmpTransform[5] -= oy;
      m2 = tmpTransform;
    }
    this.setLocalTransform(m2);
  };
  Transformable2.prototype.getGlobalScale = function(out2) {
    var m2 = this.transform;
    out2 = out2 || [];
    if (!m2) {
      out2[0] = 1;
      out2[1] = 1;
      return out2;
    }
    out2[0] = Math.sqrt(m2[0] * m2[0] + m2[1] * m2[1]);
    out2[1] = Math.sqrt(m2[2] * m2[2] + m2[3] * m2[3]);
    if (m2[0] < 0) {
      out2[0] = -out2[0];
    }
    if (m2[3] < 0) {
      out2[1] = -out2[1];
    }
    return out2;
  };
  Transformable2.prototype.transformCoordToLocal = function(x2, y2) {
    var v22 = [x2, y2];
    var invTransform = this.invTransform;
    if (invTransform) {
      applyTransform$1(v22, v22, invTransform);
    }
    return v22;
  };
  Transformable2.prototype.transformCoordToGlobal = function(x2, y2) {
    var v22 = [x2, y2];
    var transform2 = this.transform;
    if (transform2) {
      applyTransform$1(v22, v22, transform2);
    }
    return v22;
  };
  Transformable2.prototype.getLineScale = function() {
    var m2 = this.transform;
    return m2 && abs(m2[0] - 1) > 1e-10 && abs(m2[3] - 1) > 1e-10 ? Math.sqrt(abs(m2[0] * m2[3] - m2[2] * m2[1])) : 1;
  };
  Transformable2.prototype.copyTransform = function(source) {
    copyTransform(this, source);
  };
  Transformable2.getLocalTransform = function(target, m2) {
    m2 = m2 || [];
    var ox = target.originX || 0;
    var oy = target.originY || 0;
    var sx = target.scaleX;
    var sy = target.scaleY;
    var ax = target.anchorX;
    var ay = target.anchorY;
    var rotation = target.rotation || 0;
    var x2 = target.x;
    var y2 = target.y;
    var skewX = target.skewX ? Math.tan(target.skewX) : 0;
    var skewY = target.skewY ? Math.tan(-target.skewY) : 0;
    if (ox || oy || ax || ay) {
      var dx = ox + ax;
      var dy = oy + ay;
      m2[4] = -dx * sx - skewX * dy * sy;
      m2[5] = -dy * sy - skewY * dx * sx;
    } else {
      m2[4] = m2[5] = 0;
    }
    m2[0] = sx;
    m2[3] = sy;
    m2[1] = skewY * sx;
    m2[2] = skewX * sy;
    rotation && rotate(m2, m2, rotation);
    m2[4] += ox + x2;
    m2[5] += oy + y2;
    return m2;
  };
  Transformable2.initDefaultProps = function() {
    var proto2 = Transformable2.prototype;
    proto2.scaleX = proto2.scaleY = proto2.globalScaleRatio = 1;
    proto2.x = proto2.y = proto2.originX = proto2.originY = proto2.skewX = proto2.skewY = proto2.rotation = proto2.anchorX = proto2.anchorY = 0;
  }();
  return Transformable2;
}();
var TRANSFORMABLE_PROPS = [
  "x",
  "y",
  "originX",
  "originY",
  "anchorX",
  "anchorY",
  "rotation",
  "scaleX",
  "scaleY",
  "skewX",
  "skewY"
];
function copyTransform(target, source) {
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var propName = TRANSFORMABLE_PROPS[i];
    target[propName] = source[propName];
  }
}
var Transformable$1 = Transformable;
var Point = function() {
  function Point2(x2, y2) {
    this.x = x2 || 0;
    this.y = y2 || 0;
  }
  Point2.prototype.copy = function(other) {
    this.x = other.x;
    this.y = other.y;
    return this;
  };
  Point2.prototype.clone = function() {
    return new Point2(this.x, this.y);
  };
  Point2.prototype.set = function(x2, y2) {
    this.x = x2;
    this.y = y2;
    return this;
  };
  Point2.prototype.equal = function(other) {
    return other.x === this.x && other.y === this.y;
  };
  Point2.prototype.add = function(other) {
    this.x += other.x;
    this.y += other.y;
    return this;
  };
  Point2.prototype.scale = function(scalar) {
    this.x *= scalar;
    this.y *= scalar;
  };
  Point2.prototype.scaleAndAdd = function(other, scalar) {
    this.x += other.x * scalar;
    this.y += other.y * scalar;
  };
  Point2.prototype.sub = function(other) {
    this.x -= other.x;
    this.y -= other.y;
    return this;
  };
  Point2.prototype.dot = function(other) {
    return this.x * other.x + this.y * other.y;
  };
  Point2.prototype.len = function() {
    return Math.sqrt(this.x * this.x + this.y * this.y);
  };
  Point2.prototype.lenSquare = function() {
    return this.x * this.x + this.y * this.y;
  };
  Point2.prototype.normalize = function() {
    var len2 = this.len();
    this.x /= len2;
    this.y /= len2;
    return this;
  };
  Point2.prototype.distance = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return Math.sqrt(dx * dx + dy * dy);
  };
  Point2.prototype.distanceSquare = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return dx * dx + dy * dy;
  };
  Point2.prototype.negate = function() {
    this.x = -this.x;
    this.y = -this.y;
    return this;
  };
  Point2.prototype.transform = function(m2) {
    if (!m2) {
      return;
    }
    var x2 = this.x;
    var y2 = this.y;
    this.x = m2[0] * x2 + m2[2] * y2 + m2[4];
    this.y = m2[1] * x2 + m2[3] * y2 + m2[5];
    return this;
  };
  Point2.prototype.toArray = function(out2) {
    out2[0] = this.x;
    out2[1] = this.y;
    return out2;
  };
  Point2.prototype.fromArray = function(input) {
    this.x = input[0];
    this.y = input[1];
  };
  Point2.set = function(p2, x2, y2) {
    p2.x = x2;
    p2.y = y2;
  };
  Point2.copy = function(p2, p22) {
    p2.x = p22.x;
    p2.y = p22.y;
  };
  Point2.len = function(p2) {
    return Math.sqrt(p2.x * p2.x + p2.y * p2.y);
  };
  Point2.lenSquare = function(p2) {
    return p2.x * p2.x + p2.y * p2.y;
  };
  Point2.dot = function(p0, p1) {
    return p0.x * p1.x + p0.y * p1.y;
  };
  Point2.add = function(out2, p0, p1) {
    out2.x = p0.x + p1.x;
    out2.y = p0.y + p1.y;
  };
  Point2.sub = function(out2, p0, p1) {
    out2.x = p0.x - p1.x;
    out2.y = p0.y - p1.y;
  };
  Point2.scale = function(out2, p0, scalar) {
    out2.x = p0.x * scalar;
    out2.y = p0.y * scalar;
  };
  Point2.scaleAndAdd = function(out2, p0, p1, scalar) {
    out2.x = p0.x + p1.x * scalar;
    out2.y = p0.y + p1.y * scalar;
  };
  Point2.lerp = function(out2, p0, p1, t2) {
    var onet = 1 - t2;
    out2.x = onet * p0.x + t2 * p1.x;
    out2.y = onet * p0.y + t2 * p1.y;
  };
  return Point2;
}();
var Point$1 = Point;
var mathMin$a = Math.min;
var mathMax$a = Math.max;
var lt = new Point$1();
var rb$1 = new Point$1();
var lb$1 = new Point$1();
var rt = new Point$1();
var minTv$1 = new Point$1();
var maxTv$1 = new Point$1();
var BoundingRect = function() {
  function BoundingRect2(x2, y2, width, height) {
    if (width < 0) {
      x2 = x2 + width;
      width = -width;
    }
    if (height < 0) {
      y2 = y2 + height;
      height = -height;
    }
    this.x = x2;
    this.y = y2;
    this.width = width;
    this.height = height;
  }
  BoundingRect2.prototype.union = function(other) {
    var x2 = mathMin$a(other.x, this.x);
    var y2 = mathMin$a(other.y, this.y);
    if (isFinite(this.x) && isFinite(this.width)) {
      this.width = mathMax$a(other.x + other.width, this.x + this.width) - x2;
    } else {
      this.width = other.width;
    }
    if (isFinite(this.y) && isFinite(this.height)) {
      this.height = mathMax$a(other.y + other.height, this.y + this.height) - y2;
    } else {
      this.height = other.height;
    }
    this.x = x2;
    this.y = y2;
  };
  BoundingRect2.prototype.applyTransform = function(m2) {
    BoundingRect2.applyTransform(this, this, m2);
  };
  BoundingRect2.prototype.calculateTransform = function(b2) {
    var a = this;
    var sx = b2.width / a.width;
    var sy = b2.height / a.height;
    var m2 = create$1();
    translate(m2, m2, [-a.x, -a.y]);
    scale$1(m2, m2, [sx, sy]);
    translate(m2, m2, [b2.x, b2.y]);
    return m2;
  };
  BoundingRect2.prototype.intersect = function(b2, mtv) {
    if (!b2) {
      return false;
    }
    if (!(b2 instanceof BoundingRect2)) {
      b2 = BoundingRect2.create(b2);
    }
    var a = this;
    var ax0 = a.x;
    var ax1 = a.x + a.width;
    var ay0 = a.y;
    var ay1 = a.y + a.height;
    var bx0 = b2.x;
    var bx1 = b2.x + b2.width;
    var by0 = b2.y;
    var by1 = b2.y + b2.height;
    var overlap = !(ax1 < bx0 || bx1 < ax0 || ay1 < by0 || by1 < ay0);
    if (mtv) {
      var dMin = Infinity;
      var dMax = 0;
      var d0 = Math.abs(ax1 - bx0);
      var d1 = Math.abs(bx1 - ax0);
      var d2 = Math.abs(ay1 - by0);
      var d3 = Math.abs(by1 - ay0);
      var dx = Math.min(d0, d1);
      var dy = Math.min(d2, d3);
      if (ax1 < bx0 || bx1 < ax0) {
        if (dx > dMax) {
          dMax = dx;
          if (d0 < d1) {
            Point$1.set(maxTv$1, -d0, 0);
          } else {
            Point$1.set(maxTv$1, d1, 0);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d0 < d1) {
            Point$1.set(minTv$1, d0, 0);
          } else {
            Point$1.set(minTv$1, -d1, 0);
          }
        }
      }
      if (ay1 < by0 || by1 < ay0) {
        if (dy > dMax) {
          dMax = dy;
          if (d2 < d3) {
            Point$1.set(maxTv$1, 0, -d2);
          } else {
            Point$1.set(maxTv$1, 0, d3);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d2 < d3) {
            Point$1.set(minTv$1, 0, d2);
          } else {
            Point$1.set(minTv$1, 0, -d3);
          }
        }
      }
    }
    if (mtv) {
      Point$1.copy(mtv, overlap ? minTv$1 : maxTv$1);
    }
    return overlap;
  };
  BoundingRect2.prototype.contain = function(x2, y2) {
    var rect = this;
    return x2 >= rect.x && x2 <= rect.x + rect.width && y2 >= rect.y && y2 <= rect.y + rect.height;
  };
  BoundingRect2.prototype.clone = function() {
    return new BoundingRect2(this.x, this.y, this.width, this.height);
  };
  BoundingRect2.prototype.copy = function(other) {
    BoundingRect2.copy(this, other);
  };
  BoundingRect2.prototype.plain = function() {
    return {
      x: this.x,
      y: this.y,
      width: this.width,
      height: this.height
    };
  };
  BoundingRect2.prototype.isFinite = function() {
    return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
  };
  BoundingRect2.prototype.isZero = function() {
    return this.width === 0 || this.height === 0;
  };
  BoundingRect2.create = function(rect) {
    return new BoundingRect2(rect.x, rect.y, rect.width, rect.height);
  };
  BoundingRect2.copy = function(target, source) {
    target.x = source.x;
    target.y = source.y;
    target.width = source.width;
    target.height = source.height;
  };
  BoundingRect2.applyTransform = function(target, source, m2) {
    if (!m2) {
      if (target !== source) {
        BoundingRect2.copy(target, source);
      }
      return;
    }
    if (m2[1] < 1e-5 && m2[1] > -1e-5 && m2[2] < 1e-5 && m2[2] > -1e-5) {
      var sx = m2[0];
      var sy = m2[3];
      var tx = m2[4];
      var ty = m2[5];
      target.x = source.x * sx + tx;
      target.y = source.y * sy + ty;
      target.width = source.width * sx;
      target.height = source.height * sy;
      if (target.width < 0) {
        target.x += target.width;
        target.width = -target.width;
      }
      if (target.height < 0) {
        target.y += target.height;
        target.height = -target.height;
      }
      return;
    }
    lt.x = lb$1.x = source.x;
    lt.y = rt.y = source.y;
    rb$1.x = rt.x = source.x + source.width;
    rb$1.y = lb$1.y = source.y + source.height;
    lt.transform(m2);
    rt.transform(m2);
    rb$1.transform(m2);
    lb$1.transform(m2);
    target.x = mathMin$a(lt.x, rb$1.x, lb$1.x, rt.x);
    target.y = mathMin$a(lt.y, rb$1.y, lb$1.y, rt.y);
    var maxX = mathMax$a(lt.x, rb$1.x, lb$1.x, rt.x);
    var maxY = mathMax$a(lt.y, rb$1.y, lb$1.y, rt.y);
    target.width = maxX - target.x;
    target.height = maxY - target.y;
  };
  return BoundingRect2;
}();
var BoundingRect$1 = BoundingRect;
var textWidthCache = {};
function getWidth(text, font) {
  font = font || DEFAULT_FONT;
  var cacheOfFont = textWidthCache[font];
  if (!cacheOfFont) {
    cacheOfFont = textWidthCache[font] = new LRU$1(500);
  }
  var width = cacheOfFont.get(text);
  if (width == null) {
    width = platformApi.measureText(text, font).width;
    cacheOfFont.put(text, width);
  }
  return width;
}
function innerGetBoundingRect(text, font, textAlign, textBaseline) {
  var width = getWidth(text, font);
  var height = getLineHeight(font);
  var x2 = adjustTextX(0, width, textAlign);
  var y2 = adjustTextY(0, height, textBaseline);
  var rect = new BoundingRect$1(x2, y2, width, height);
  return rect;
}
function getBoundingRect(text, font, textAlign, textBaseline) {
  var textLines = ((text || "") + "").split("\n");
  var len2 = textLines.length;
  if (len2 === 1) {
    return innerGetBoundingRect(textLines[0], font, textAlign, textBaseline);
  } else {
    var uniondRect = new BoundingRect$1(0, 0, 0, 0);
    for (var i = 0; i < textLines.length; i++) {
      var rect = innerGetBoundingRect(textLines[i], font, textAlign, textBaseline);
      i === 0 ? uniondRect.copy(rect) : uniondRect.union(rect);
    }
    return uniondRect;
  }
}
function adjustTextX(x2, width, textAlign) {
  if (textAlign === "right") {
    x2 -= width;
  } else if (textAlign === "center") {
    x2 -= width / 2;
  }
  return x2;
}
function adjustTextY(y2, height, verticalAlign) {
  if (verticalAlign === "middle") {
    y2 -= height / 2;
  } else if (verticalAlign === "bottom") {
    y2 -= height;
  }
  return y2;
}
function getLineHeight(font) {
  return getWidth("\u56FD", font);
}
function parsePercent$1(value, maxValue) {
  if (typeof value === "string") {
    if (value.lastIndexOf("%") >= 0) {
      return parseFloat(value) / 100 * maxValue;
    }
    return parseFloat(value);
  }
  return value;
}
function calculateTextPosition(out2, opts, rect) {
  var textPosition = opts.position || "inside";
  var distance2 = opts.distance != null ? opts.distance : 5;
  var height = rect.height;
  var width = rect.width;
  var halfHeight = height / 2;
  var x2 = rect.x;
  var y2 = rect.y;
  var textAlign = "left";
  var textVerticalAlign = "top";
  if (textPosition instanceof Array) {
    x2 += parsePercent$1(textPosition[0], rect.width);
    y2 += parsePercent$1(textPosition[1], rect.height);
    textAlign = null;
    textVerticalAlign = null;
  } else {
    switch (textPosition) {
      case "left":
        x2 -= distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "right":
        x2 += distance2 + width;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "top":
        x2 += width / 2;
        y2 -= distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "bottom":
        x2 += width / 2;
        y2 += height + distance2;
        textAlign = "center";
        break;
      case "inside":
        x2 += width / 2;
        y2 += halfHeight;
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "insideLeft":
        x2 += distance2;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "insideRight":
        x2 += width - distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideTop":
        x2 += width / 2;
        y2 += distance2;
        textAlign = "center";
        break;
      case "insideBottom":
        x2 += width / 2;
        y2 += height - distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideTopLeft":
        x2 += distance2;
        y2 += distance2;
        break;
      case "insideTopRight":
        x2 += width - distance2;
        y2 += distance2;
        textAlign = "right";
        break;
      case "insideBottomLeft":
        x2 += distance2;
        y2 += height - distance2;
        textVerticalAlign = "bottom";
        break;
      case "insideBottomRight":
        x2 += width - distance2;
        y2 += height - distance2;
        textAlign = "right";
        textVerticalAlign = "bottom";
        break;
    }
  }
  out2 = out2 || {};
  out2.x = x2;
  out2.y = y2;
  out2.align = textAlign;
  out2.verticalAlign = textVerticalAlign;
  return out2;
}
var PRESERVED_NORMAL_STATE = "__zr_normal__";
var PRIMARY_STATES_KEYS$1 = TRANSFORMABLE_PROPS.concat(["ignore"]);
var DEFAULT_ANIMATABLE_MAP = reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = true;
  return obj;
}, { ignore: false });
var tmpTextPosCalcRes = {};
var tmpBoundingRect = new BoundingRect$1(0, 0, 0, 0);
var Element$1 = function() {
  function Element2(props) {
    this.id = guid();
    this.animators = [];
    this.currentStates = [];
    this.states = {};
    this._init(props);
  }
  Element2.prototype._init = function(props) {
    this.attr(props);
  };
  Element2.prototype.drift = function(dx, dy, e2) {
    switch (this.draggable) {
      case "horizontal":
        dy = 0;
        break;
      case "vertical":
        dx = 0;
        break;
    }
    var m2 = this.transform;
    if (!m2) {
      m2 = this.transform = [1, 0, 0, 1, 0, 0];
    }
    m2[4] += dx;
    m2[5] += dy;
    this.decomposeTransform();
    this.markRedraw();
  };
  Element2.prototype.beforeUpdate = function() {
  };
  Element2.prototype.afterUpdate = function() {
  };
  Element2.prototype.update = function() {
    this.updateTransform();
    if (this.__dirty) {
      this.updateInnerText();
    }
  };
  Element2.prototype.updateInnerText = function(forceUpdate) {
    var textEl = this._textContent;
    if (textEl && (!textEl.ignore || forceUpdate)) {
      if (!this.textConfig) {
        this.textConfig = {};
      }
      var textConfig = this.textConfig;
      var isLocal = textConfig.local;
      var innerTransformable = textEl.innerTransformable;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var textStyleChanged = false;
      innerTransformable.parent = isLocal ? this : null;
      var innerOrigin = false;
      innerTransformable.copyTransform(textEl);
      if (textConfig.position != null) {
        var layoutRect = tmpBoundingRect;
        if (textConfig.layoutRect) {
          layoutRect.copy(textConfig.layoutRect);
        } else {
          layoutRect.copy(this.getBoundingRect());
        }
        if (!isLocal) {
          layoutRect.applyTransform(this.transform);
        }
        if (this.calculateTextPosition) {
          this.calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        } else {
          calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        }
        innerTransformable.x = tmpTextPosCalcRes.x;
        innerTransformable.y = tmpTextPosCalcRes.y;
        textAlign = tmpTextPosCalcRes.align;
        textVerticalAlign = tmpTextPosCalcRes.verticalAlign;
        var textOrigin = textConfig.origin;
        if (textOrigin && textConfig.rotation != null) {
          var relOriginX = void 0;
          var relOriginY = void 0;
          if (textOrigin === "center") {
            relOriginX = layoutRect.width * 0.5;
            relOriginY = layoutRect.height * 0.5;
          } else {
            relOriginX = parsePercent$1(textOrigin[0], layoutRect.width);
            relOriginY = parsePercent$1(textOrigin[1], layoutRect.height);
          }
          innerOrigin = true;
          innerTransformable.originX = -innerTransformable.x + relOriginX + (isLocal ? 0 : layoutRect.x);
          innerTransformable.originY = -innerTransformable.y + relOriginY + (isLocal ? 0 : layoutRect.y);
        }
      }
      if (textConfig.rotation != null) {
        innerTransformable.rotation = textConfig.rotation;
      }
      var textOffset = textConfig.offset;
      if (textOffset) {
        innerTransformable.x += textOffset[0];
        innerTransformable.y += textOffset[1];
        if (!innerOrigin) {
          innerTransformable.originX = -textOffset[0];
          innerTransformable.originY = -textOffset[1];
        }
      }
      var isInside = textConfig.inside == null ? typeof textConfig.position === "string" && textConfig.position.indexOf("inside") >= 0 : textConfig.inside;
      var innerTextDefaultStyle = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {});
      var textFill = void 0;
      var textStroke = void 0;
      var autoStroke = void 0;
      if (isInside && this.canBeInsideText()) {
        textFill = textConfig.insideFill;
        textStroke = textConfig.insideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getInsideTextFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getInsideTextStroke(textFill);
          autoStroke = true;
        }
      } else {
        textFill = textConfig.outsideFill;
        textStroke = textConfig.outsideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getOutsideFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getOutsideStroke(textFill);
          autoStroke = true;
        }
      }
      textFill = textFill || "#000";
      if (textFill !== innerTextDefaultStyle.fill || textStroke !== innerTextDefaultStyle.stroke || autoStroke !== innerTextDefaultStyle.autoStroke || textAlign !== innerTextDefaultStyle.align || textVerticalAlign !== innerTextDefaultStyle.verticalAlign) {
        textStyleChanged = true;
        innerTextDefaultStyle.fill = textFill;
        innerTextDefaultStyle.stroke = textStroke;
        innerTextDefaultStyle.autoStroke = autoStroke;
        innerTextDefaultStyle.align = textAlign;
        innerTextDefaultStyle.verticalAlign = textVerticalAlign;
        textEl.setDefaultTextStyle(innerTextDefaultStyle);
      }
      textEl.__dirty |= REDRAW_BIT;
      if (textStyleChanged) {
        textEl.dirtyStyle(true);
      }
    }
  };
  Element2.prototype.canBeInsideText = function() {
    return true;
  };
  Element2.prototype.getInsideTextFill = function() {
    return "#fff";
  };
  Element2.prototype.getInsideTextStroke = function(textFill) {
    return "#000";
  };
  Element2.prototype.getOutsideFill = function() {
    return this.__zr && this.__zr.isDarkMode() ? LIGHT_LABEL_COLOR : DARK_LABEL_COLOR;
  };
  Element2.prototype.getOutsideStroke = function(textFill) {
    var backgroundColor2 = this.__zr && this.__zr.getBackgroundColor();
    var colorArr = typeof backgroundColor2 === "string" && parse(backgroundColor2);
    if (!colorArr) {
      colorArr = [255, 255, 255, 1];
    }
    var alpha = colorArr[3];
    var isDark = this.__zr.isDarkMode();
    for (var i = 0; i < 3; i++) {
      colorArr[i] = colorArr[i] * alpha + (isDark ? 0 : 255) * (1 - alpha);
    }
    colorArr[3] = 1;
    return stringify(colorArr, "rgba");
  };
  Element2.prototype.traverse = function(cb2, context) {
  };
  Element2.prototype.attrKV = function(key, value) {
    if (key === "textConfig") {
      this.setTextConfig(value);
    } else if (key === "textContent") {
      this.setTextContent(value);
    } else if (key === "clipPath") {
      this.setClipPath(value);
    } else if (key === "extra") {
      this.extra = this.extra || {};
      extend(this.extra, value);
    } else {
      this[key] = value;
    }
  };
  Element2.prototype.hide = function() {
    this.ignore = true;
    this.markRedraw();
  };
  Element2.prototype.show = function() {
    this.ignore = false;
    this.markRedraw();
  };
  Element2.prototype.attr = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.attrKV(keyOrObj, value);
    } else if (isObject$4(keyOrObj)) {
      var obj = keyOrObj;
      var keysArr = keys(obj);
      for (var i = 0; i < keysArr.length; i++) {
        var key = keysArr[i];
        this.attrKV(key, keyOrObj[key]);
      }
    }
    this.markRedraw();
    return this;
  };
  Element2.prototype.saveCurrentToNormalState = function(toState) {
    this._innerSaveToNormal(toState);
    var normalState = this._normalState;
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      var fromStateTransition = animator.__fromStateTransition;
      if (animator.getLoop() || fromStateTransition && fromStateTransition !== PRESERVED_NORMAL_STATE) {
        continue;
      }
      var targetName = animator.targetName;
      var target = targetName ? normalState[targetName] : normalState;
      animator.saveTo(target);
    }
  };
  Element2.prototype._innerSaveToNormal = function(toState) {
    var normalState = this._normalState;
    if (!normalState) {
      normalState = this._normalState = {};
    }
    if (toState.textConfig && !normalState.textConfig) {
      normalState.textConfig = this.textConfig;
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS$1);
  };
  Element2.prototype._savePrimaryToNormal = function(toState, normalState, primaryKeys) {
    for (var i = 0; i < primaryKeys.length; i++) {
      var key = primaryKeys[i];
      if (toState[key] != null && !(key in normalState)) {
        normalState[key] = this[key];
      }
    }
  };
  Element2.prototype.hasState = function() {
    return this.currentStates.length > 0;
  };
  Element2.prototype.getState = function(name) {
    return this.states[name];
  };
  Element2.prototype.ensureState = function(name) {
    var states = this.states;
    if (!states[name]) {
      states[name] = {};
    }
    return states[name];
  };
  Element2.prototype.clearStates = function(noAnimation) {
    this.useState(PRESERVED_NORMAL_STATE, false, noAnimation);
  };
  Element2.prototype.useState = function(stateName, keepCurrentStates, noAnimation, forceUseHoverLayer) {
    var toNormalState = stateName === PRESERVED_NORMAL_STATE;
    var hasStates = this.hasState();
    if (!hasStates && toNormalState) {
      return;
    }
    var currentStates = this.currentStates;
    var animationCfg = this.stateTransition;
    if (indexOf(currentStates, stateName) >= 0 && (keepCurrentStates || currentStates.length === 1)) {
      return;
    }
    var state;
    if (this.stateProxy && !toNormalState) {
      state = this.stateProxy(stateName);
    }
    if (!state) {
      state = this.states && this.states[stateName];
    }
    if (!state && !toNormalState) {
      logError("State " + stateName + " not exists.");
      return;
    }
    if (!toNormalState) {
      this.saveCurrentToNormalState(state);
    }
    var useHoverLayer = !!(state && state.hoverLayer || forceUseHoverLayer);
    if (useHoverLayer) {
      this._toggleHoverLayerFlag(true);
    }
    this._applyStateObj(stateName, state, this._normalState, keepCurrentStates, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (textGuide) {
      textGuide.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (toNormalState) {
      this.currentStates = [];
      this._normalState = {};
    } else {
      if (!keepCurrentStates) {
        this.currentStates = [stateName];
      } else {
        this.currentStates.push(stateName);
      }
    }
    this._updateAnimationTargets();
    this.markRedraw();
    if (!useHoverLayer && this.__inHover) {
      this._toggleHoverLayerFlag(false);
      this.__dirty &= ~REDRAW_BIT;
    }
    return state;
  };
  Element2.prototype.useStates = function(states, noAnimation, forceUseHoverLayer) {
    if (!states.length) {
      this.clearStates();
    } else {
      var stateObjects = [];
      var currentStates = this.currentStates;
      var len2 = states.length;
      var notChange = len2 === currentStates.length;
      if (notChange) {
        for (var i = 0; i < len2; i++) {
          if (states[i] !== currentStates[i]) {
            notChange = false;
            break;
          }
        }
      }
      if (notChange) {
        return;
      }
      for (var i = 0; i < len2; i++) {
        var stateName = states[i];
        var stateObj = void 0;
        if (this.stateProxy) {
          stateObj = this.stateProxy(stateName, states);
        }
        if (!stateObj) {
          stateObj = this.states[stateName];
        }
        if (stateObj) {
          stateObjects.push(stateObj);
        }
      }
      var lastStateObj = stateObjects[len2 - 1];
      var useHoverLayer = !!(lastStateObj && lastStateObj.hoverLayer || forceUseHoverLayer);
      if (useHoverLayer) {
        this._toggleHoverLayerFlag(true);
      }
      var mergedState = this._mergeStates(stateObjects);
      var animationCfg = this.stateTransition;
      this.saveCurrentToNormalState(mergedState);
      this._applyStateObj(states.join(","), mergedState, this._normalState, false, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
      var textContent = this._textContent;
      var textGuide = this._textGuide;
      if (textContent) {
        textContent.useStates(states, noAnimation, useHoverLayer);
      }
      if (textGuide) {
        textGuide.useStates(states, noAnimation, useHoverLayer);
      }
      this._updateAnimationTargets();
      this.currentStates = states.slice();
      this.markRedraw();
      if (!useHoverLayer && this.__inHover) {
        this._toggleHoverLayerFlag(false);
        this.__dirty &= ~REDRAW_BIT;
      }
    }
  };
  Element2.prototype._updateAnimationTargets = function() {
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      if (animator.targetName) {
        animator.changeTarget(this[animator.targetName]);
      }
    }
  };
  Element2.prototype.removeState = function(state) {
    var idx = indexOf(this.currentStates, state);
    if (idx >= 0) {
      var currentStates = this.currentStates.slice();
      currentStates.splice(idx, 1);
      this.useStates(currentStates);
    }
  };
  Element2.prototype.replaceState = function(oldState, newState, forceAdd) {
    var currentStates = this.currentStates.slice();
    var idx = indexOf(currentStates, oldState);
    var newStateExists = indexOf(currentStates, newState) >= 0;
    if (idx >= 0) {
      if (!newStateExists) {
        currentStates[idx] = newState;
      } else {
        currentStates.splice(idx, 1);
      }
    } else if (forceAdd && !newStateExists) {
      currentStates.push(newState);
    }
    this.useStates(currentStates);
  };
  Element2.prototype.toggleState = function(state, enable) {
    if (enable) {
      this.useState(state, true);
    } else {
      this.removeState(state);
    }
  };
  Element2.prototype._mergeStates = function(states) {
    var mergedState = {};
    var mergedTextConfig;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      extend(mergedState, state);
      if (state.textConfig) {
        mergedTextConfig = mergedTextConfig || {};
        extend(mergedTextConfig, state.textConfig);
      }
    }
    if (mergedTextConfig) {
      mergedState.textConfig = mergedTextConfig;
    }
    return mergedState;
  };
  Element2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    var needsRestoreToNormal = !(state && keepCurrentStates);
    if (state && state.textConfig) {
      this.textConfig = extend({}, keepCurrentStates ? this.textConfig : normalState.textConfig);
      extend(this.textConfig, state.textConfig);
    } else if (needsRestoreToNormal) {
      if (normalState.textConfig) {
        this.textConfig = normalState.textConfig;
      }
    }
    var transitionTarget = {};
    var hasTransition = false;
    for (var i = 0; i < PRIMARY_STATES_KEYS$1.length; i++) {
      var key = PRIMARY_STATES_KEYS$1[i];
      var propNeedsTransition = transition && DEFAULT_ANIMATABLE_MAP[key];
      if (state && state[key] != null) {
        if (propNeedsTransition) {
          hasTransition = true;
          transitionTarget[key] = state[key];
        } else {
          this[key] = state[key];
        }
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          if (propNeedsTransition) {
            hasTransition = true;
            transitionTarget[key] = normalState[key];
          } else {
            this[key] = normalState[key];
          }
        }
      }
    }
    if (!transition) {
      for (var i = 0; i < this.animators.length; i++) {
        var animator = this.animators[i];
        var targetName = animator.targetName;
        if (!animator.getLoop()) {
          animator.__changeFinalValue(targetName ? (state || normalState)[targetName] : state || normalState);
        }
      }
    }
    if (hasTransition) {
      this._transitionState(stateName, transitionTarget, animationCfg);
    }
  };
  Element2.prototype._attachComponent = function(componentEl) {
    if (componentEl.__zr && !componentEl.__hostTarget) {
      return;
    }
    if (componentEl === this) {
      return;
    }
    var zr = this.__zr;
    if (zr) {
      componentEl.addSelfToZr(zr);
    }
    componentEl.__zr = zr;
    componentEl.__hostTarget = this;
  };
  Element2.prototype._detachComponent = function(componentEl) {
    if (componentEl.__zr) {
      componentEl.removeSelfFromZr(componentEl.__zr);
    }
    componentEl.__zr = null;
    componentEl.__hostTarget = null;
  };
  Element2.prototype.getClipPath = function() {
    return this._clipPath;
  };
  Element2.prototype.setClipPath = function(clipPath) {
    if (this._clipPath && this._clipPath !== clipPath) {
      this.removeClipPath();
    }
    this._attachComponent(clipPath);
    this._clipPath = clipPath;
    this.markRedraw();
  };
  Element2.prototype.removeClipPath = function() {
    var clipPath = this._clipPath;
    if (clipPath) {
      this._detachComponent(clipPath);
      this._clipPath = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextContent = function() {
    return this._textContent;
  };
  Element2.prototype.setTextContent = function(textEl) {
    var previousTextContent = this._textContent;
    if (previousTextContent === textEl) {
      return;
    }
    if (previousTextContent && previousTextContent !== textEl) {
      this.removeTextContent();
    }
    textEl.innerTransformable = new Transformable$1();
    this._attachComponent(textEl);
    this._textContent = textEl;
    this.markRedraw();
  };
  Element2.prototype.setTextConfig = function(cfg) {
    if (!this.textConfig) {
      this.textConfig = {};
    }
    extend(this.textConfig, cfg);
    this.markRedraw();
  };
  Element2.prototype.removeTextConfig = function() {
    this.textConfig = null;
    this.markRedraw();
  };
  Element2.prototype.removeTextContent = function() {
    var textEl = this._textContent;
    if (textEl) {
      textEl.innerTransformable = null;
      this._detachComponent(textEl);
      this._textContent = null;
      this._innerTextDefaultStyle = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextGuideLine = function() {
    return this._textGuide;
  };
  Element2.prototype.setTextGuideLine = function(guideLine) {
    if (this._textGuide && this._textGuide !== guideLine) {
      this.removeTextGuideLine();
    }
    this._attachComponent(guideLine);
    this._textGuide = guideLine;
    this.markRedraw();
  };
  Element2.prototype.removeTextGuideLine = function() {
    var textGuide = this._textGuide;
    if (textGuide) {
      this._detachComponent(textGuide);
      this._textGuide = null;
      this.markRedraw();
    }
  };
  Element2.prototype.markRedraw = function() {
    this.__dirty |= REDRAW_BIT;
    var zr = this.__zr;
    if (zr) {
      if (this.__inHover) {
        zr.refreshHover();
      } else {
        zr.refresh();
      }
    }
    if (this.__hostTarget) {
      this.__hostTarget.markRedraw();
    }
  };
  Element2.prototype.dirty = function() {
    this.markRedraw();
  };
  Element2.prototype._toggleHoverLayerFlag = function(inHover) {
    this.__inHover = inHover;
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.__inHover = inHover;
    }
    if (textGuide) {
      textGuide.__inHover = inHover;
    }
  };
  Element2.prototype.addSelfToZr = function(zr) {
    if (this.__zr === zr) {
      return;
    }
    this.__zr = zr;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.addAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.addSelfToZr(zr);
    }
    if (this._textContent) {
      this._textContent.addSelfToZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.addSelfToZr(zr);
    }
  };
  Element2.prototype.removeSelfFromZr = function(zr) {
    if (!this.__zr) {
      return;
    }
    this.__zr = null;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.removeAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.removeSelfFromZr(zr);
    }
    if (this._textContent) {
      this._textContent.removeSelfFromZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.removeSelfFromZr(zr);
    }
  };
  Element2.prototype.animate = function(key, loop, allowDiscreteAnimation) {
    var target = key ? this[key] : this;
    var animator = new Animator(target, loop, allowDiscreteAnimation);
    key && (animator.targetName = key);
    this.addAnimator(animator, key);
    return animator;
  };
  Element2.prototype.addAnimator = function(animator, key) {
    var zr = this.__zr;
    var el = this;
    animator.during(function() {
      el.updateDuringAnimation(key);
    }).done(function() {
      var animators = el.animators;
      var idx = indexOf(animators, animator);
      if (idx >= 0) {
        animators.splice(idx, 1);
      }
    });
    this.animators.push(animator);
    if (zr) {
      zr.animation.addAnimator(animator);
    }
    zr && zr.wakeUp();
  };
  Element2.prototype.updateDuringAnimation = function(key) {
    this.markRedraw();
  };
  Element2.prototype.stopAnimation = function(scope, forwardToLast) {
    var animators = this.animators;
    var len2 = animators.length;
    var leftAnimators = [];
    for (var i = 0; i < len2; i++) {
      var animator = animators[i];
      if (!scope || scope === animator.scope) {
        animator.stop(forwardToLast);
      } else {
        leftAnimators.push(animator);
      }
    }
    this.animators = leftAnimators;
    return this;
  };
  Element2.prototype.animateTo = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps);
  };
  Element2.prototype.animateFrom = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps, true);
  };
  Element2.prototype._transitionState = function(stateName, target, cfg, animationProps) {
    var animators = animateTo(this, target, cfg, animationProps);
    for (var i = 0; i < animators.length; i++) {
      animators[i].__fromStateTransition = stateName;
    }
  };
  Element2.prototype.getBoundingRect = function() {
    return null;
  };
  Element2.prototype.getPaintRect = function() {
    return null;
  };
  Element2.initDefaultProps = function() {
    var elProto = Element2.prototype;
    elProto.type = "element";
    elProto.name = "";
    elProto.ignore = elProto.silent = elProto.isGroup = elProto.draggable = elProto.dragging = elProto.ignoreClip = elProto.__inHover = false;
    elProto.__dirty = REDRAW_BIT;
    function createLegacyProperty(key, privateKey, xKey, yKey) {
      Object.defineProperty(elProto, key, {
        get: function() {
          if (!this[privateKey]) {
            var pos = this[privateKey] = [];
            enhanceArray(this, pos);
          }
          return this[privateKey];
        },
        set: function(pos) {
          this[xKey] = pos[0];
          this[yKey] = pos[1];
          this[privateKey] = pos;
          enhanceArray(this, pos);
        }
      });
      function enhanceArray(self2, pos) {
        Object.defineProperty(pos, 0, {
          get: function() {
            return self2[xKey];
          },
          set: function(val) {
            self2[xKey] = val;
          }
        });
        Object.defineProperty(pos, 1, {
          get: function() {
            return self2[yKey];
          },
          set: function(val) {
            self2[yKey] = val;
          }
        });
      }
    }
    if (Object.defineProperty) {
      createLegacyProperty("position", "_legacyPos", "x", "y");
      createLegacyProperty("scale", "_legacyScale", "scaleX", "scaleY");
      createLegacyProperty("origin", "_legacyOrigin", "originX", "originY");
    }
  }();
  return Element2;
}();
mixin(Element$1, Eventful$1);
mixin(Element$1, Transformable$1);
function animateTo(animatable, target, cfg, animationProps, reverse2) {
  cfg = cfg || {};
  var animators = [];
  animateToShallow(animatable, "", animatable, target, cfg, animationProps, animators, reverse2);
  var finishCount = animators.length;
  var doneHappened = false;
  var cfgDone = cfg.done;
  var cfgAborted = cfg.aborted;
  var doneCb = function() {
    doneHappened = true;
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  var abortedCb = function() {
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  if (!finishCount) {
    cfgDone && cfgDone();
  }
  if (animators.length > 0 && cfg.during) {
    animators[0].during(function(target2, percent) {
      cfg.during(percent);
    });
  }
  for (var i = 0; i < animators.length; i++) {
    var animator = animators[i];
    if (doneCb) {
      animator.done(doneCb);
    }
    if (abortedCb) {
      animator.aborted(abortedCb);
    }
    if (cfg.force) {
      animator.duration(cfg.duration);
    }
    animator.start(cfg.easing);
  }
  return animators;
}
function copyArrShallow(source, target, len2) {
  for (var i = 0; i < len2; i++) {
    source[i] = target[i];
  }
}
function is2DArray(value) {
  return isArrayLike(value[0]);
}
function copyValue(target, source, key) {
  if (isArrayLike(source[key])) {
    if (!isArrayLike(target[key])) {
      target[key] = [];
    }
    if (isTypedArray(source[key])) {
      var len2 = source[key].length;
      if (target[key].length !== len2) {
        target[key] = new source[key].constructor(len2);
        copyArrShallow(target[key], source[key], len2);
      }
    } else {
      var sourceArr = source[key];
      var targetArr = target[key];
      var len0 = sourceArr.length;
      if (is2DArray(sourceArr)) {
        var len1 = sourceArr[0].length;
        for (var i = 0; i < len0; i++) {
          if (!targetArr[i]) {
            targetArr[i] = Array.prototype.slice.call(sourceArr[i]);
          } else {
            copyArrShallow(targetArr[i], sourceArr[i], len1);
          }
        }
      } else {
        copyArrShallow(targetArr, sourceArr, len0);
      }
      targetArr.length = sourceArr.length;
    }
  } else {
    target[key] = source[key];
  }
}
function isValueSame(val1, val2) {
  return val1 === val2 || isArrayLike(val1) && isArrayLike(val2) && is1DArraySame(val1, val2);
}
function is1DArraySame(arr0, arr1) {
  var len2 = arr0.length;
  if (len2 !== arr1.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    if (arr0[i] !== arr1[i]) {
      return false;
    }
  }
  return true;
}
function animateToShallow(animatable, topKey, animateObj, target, cfg, animationProps, animators, reverse2) {
  var targetKeys = keys(target);
  var duration = cfg.duration;
  var delay = cfg.delay;
  var additive = cfg.additive;
  var setToFinal = cfg.setToFinal;
  var animateAll = !isObject$4(animationProps);
  var existsAnimators = animatable.animators;
  var animationKeys = [];
  for (var k2 = 0; k2 < targetKeys.length; k2++) {
    var innerKey = targetKeys[k2];
    var targetVal = target[innerKey];
    if (targetVal != null && animateObj[innerKey] != null && (animateAll || animationProps[innerKey])) {
      if (isObject$4(targetVal) && !isArrayLike(targetVal) && !isGradientObject(targetVal)) {
        if (topKey) {
          if (!reverse2) {
            animateObj[innerKey] = targetVal;
            animatable.updateDuringAnimation(topKey);
          }
          continue;
        }
        animateToShallow(animatable, innerKey, animateObj[innerKey], targetVal, cfg, animationProps && animationProps[innerKey], animators, reverse2);
      } else {
        animationKeys.push(innerKey);
      }
    } else if (!reverse2) {
      animateObj[innerKey] = targetVal;
      animatable.updateDuringAnimation(topKey);
      animationKeys.push(innerKey);
    }
  }
  var keyLen = animationKeys.length;
  if (!additive && keyLen) {
    for (var i = 0; i < existsAnimators.length; i++) {
      var animator = existsAnimators[i];
      if (animator.targetName === topKey) {
        var allAborted = animator.stopTracks(animationKeys);
        if (allAborted) {
          var idx = indexOf(existsAnimators, animator);
          existsAnimators.splice(idx, 1);
        }
      }
    }
  }
  if (!cfg.force) {
    animationKeys = filter(animationKeys, function(key) {
      return !isValueSame(target[key], animateObj[key]);
    });
    keyLen = animationKeys.length;
  }
  if (keyLen > 0 || cfg.force && !animators.length) {
    var revertedSource = void 0;
    var reversedTarget = void 0;
    var sourceClone = void 0;
    if (reverse2) {
      reversedTarget = {};
      if (setToFinal) {
        revertedSource = {};
      }
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        reversedTarget[innerKey] = animateObj[innerKey];
        if (setToFinal) {
          revertedSource[innerKey] = target[innerKey];
        } else {
          animateObj[innerKey] = target[innerKey];
        }
      }
    } else if (setToFinal) {
      sourceClone = {};
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        sourceClone[innerKey] = cloneValue(animateObj[innerKey]);
        copyValue(animateObj, target, innerKey);
      }
    }
    var animator = new Animator(animateObj, false, false, additive ? filter(existsAnimators, function(animator2) {
      return animator2.targetName === topKey;
    }) : null);
    animator.targetName = topKey;
    if (cfg.scope) {
      animator.scope = cfg.scope;
    }
    if (setToFinal && revertedSource) {
      animator.whenWithKeys(0, revertedSource, animationKeys);
    }
    if (sourceClone) {
      animator.whenWithKeys(0, sourceClone, animationKeys);
    }
    animator.whenWithKeys(duration == null ? 500 : duration, reverse2 ? reversedTarget : target, animationKeys).delay(delay || 0);
    animatable.addAnimator(animator, topKey);
    animators.push(animator);
  }
}
var Element$2 = Element$1;
var Group$5 = function(_super) {
  __extends(Group2, _super);
  function Group2(opts) {
    var _this = _super.call(this) || this;
    _this.isGroup = true;
    _this._children = [];
    _this.attr(opts);
    return _this;
  }
  Group2.prototype.childrenRef = function() {
    return this._children;
  };
  Group2.prototype.children = function() {
    return this._children.slice();
  };
  Group2.prototype.childAt = function(idx) {
    return this._children[idx];
  };
  Group2.prototype.childOfName = function(name) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].name === name) {
        return children[i];
      }
    }
  };
  Group2.prototype.childCount = function() {
    return this._children.length;
  };
  Group2.prototype.add = function(child) {
    if (child) {
      if (child !== this && child.parent !== this) {
        this._children.push(child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.addBefore = function(child, nextSibling2) {
    if (child && child !== this && child.parent !== this && nextSibling2 && nextSibling2.parent === this) {
      var children = this._children;
      var idx = children.indexOf(nextSibling2);
      if (idx >= 0) {
        children.splice(idx, 0, child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.replace = function(oldChild, newChild) {
    var idx = indexOf(this._children, oldChild);
    if (idx >= 0) {
      this.replaceAt(newChild, idx);
    }
    return this;
  };
  Group2.prototype.replaceAt = function(child, index2) {
    var children = this._children;
    var old = children[index2];
    if (child && child !== this && child.parent !== this && child !== old) {
      children[index2] = child;
      old.parent = null;
      var zr = this.__zr;
      if (zr) {
        old.removeSelfFromZr(zr);
      }
      this._doAdd(child);
    }
    return this;
  };
  Group2.prototype._doAdd = function(child) {
    if (child.parent) {
      child.parent.remove(child);
    }
    child.parent = this;
    var zr = this.__zr;
    if (zr && zr !== child.__zr) {
      child.addSelfToZr(zr);
    }
    zr && zr.refresh();
  };
  Group2.prototype.remove = function(child) {
    var zr = this.__zr;
    var children = this._children;
    var idx = indexOf(children, child);
    if (idx < 0) {
      return this;
    }
    children.splice(idx, 1);
    child.parent = null;
    if (zr) {
      child.removeSelfFromZr(zr);
    }
    zr && zr.refresh();
    return this;
  };
  Group2.prototype.removeAll = function() {
    var children = this._children;
    var zr = this.__zr;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (zr) {
        child.removeSelfFromZr(zr);
      }
      child.parent = null;
    }
    children.length = 0;
    return this;
  };
  Group2.prototype.eachChild = function(cb2, context) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      cb2.call(context, child, i);
    }
    return this;
  };
  Group2.prototype.traverse = function(cb2, context) {
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      var stopped = cb2.call(context, child);
      if (child.isGroup && !stopped) {
        child.traverse(cb2, context);
      }
    }
    return this;
  };
  Group2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.addSelfToZr(zr);
    }
  };
  Group2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.removeSelfFromZr(zr);
    }
  };
  Group2.prototype.getBoundingRect = function(includeChildren) {
    var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
    var children = includeChildren || this._children;
    var tmpMat = [];
    var rect = null;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child.ignore || child.invisible) {
        continue;
      }
      var childRect = child.getBoundingRect();
      var transform2 = child.getLocalTransform(tmpMat);
      if (transform2) {
        BoundingRect$1.applyTransform(tmpRect2, childRect, transform2);
        rect = rect || tmpRect2.clone();
        rect.union(tmpRect2);
      } else {
        rect = rect || childRect.clone();
        rect.union(childRect);
      }
    }
    return rect || tmpRect2;
  };
  return Group2;
}(Element$2);
Group$5.prototype.type = "group";
var Group$6 = Group$5;
/*!
* ZRender, a high performance 2d drawing library.
*
* Copyright (c) 2013, Baidu Inc.
* All rights reserved.
*
* LICENSE
* https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
*/
var painterCtors = {};
var instances$1 = {};
function delInstance(id2) {
  delete instances$1[id2];
}
function isDarkMode(backgroundColor2) {
  if (!backgroundColor2) {
    return false;
  }
  if (typeof backgroundColor2 === "string") {
    return lum(backgroundColor2, 1) < DARK_MODE_THRESHOLD;
  } else if (backgroundColor2.colorStops) {
    var colorStops = backgroundColor2.colorStops;
    var totalLum = 0;
    var len2 = colorStops.length;
    for (var i = 0; i < len2; i++) {
      totalLum += lum(colorStops[i].color, 1);
    }
    totalLum /= len2;
    return totalLum < DARK_MODE_THRESHOLD;
  }
  return false;
}
var ZRender = function() {
  function ZRender2(id2, dom, opts) {
    var _this = this;
    this._sleepAfterStill = 10;
    this._stillFrameAccum = 0;
    this._needsRefresh = true;
    this._needsRefreshHover = true;
    this._darkMode = false;
    opts = opts || {};
    this.dom = dom;
    this.id = id2;
    var storage2 = new Storage$1();
    var rendererType = opts.renderer || "canvas";
    if (!painterCtors[rendererType]) {
      rendererType = keys(painterCtors)[0];
    }
    opts.useDirtyRect = opts.useDirtyRect == null ? false : opts.useDirtyRect;
    var painter = new painterCtors[rendererType](dom, storage2, opts, id2);
    var ssrMode = opts.ssr || painter.ssrOnly;
    this.storage = storage2;
    this.painter = painter;
    var handerProxy = !env$1.node && !env$1.worker && !ssrMode ? new HandlerProxy(painter.getViewportRoot(), painter.root) : null;
    this.handler = new Handler$1(storage2, painter, handerProxy, painter.root);
    this.animation = new Animation$1({
      stage: {
        update: ssrMode ? null : function() {
          return _this._flush(true);
        }
      }
    });
    if (!ssrMode) {
      this.animation.start();
    }
  }
  ZRender2.prototype.add = function(el) {
    if (!el) {
      return;
    }
    this.storage.addRoot(el);
    el.addSelfToZr(this);
    this.refresh();
  };
  ZRender2.prototype.remove = function(el) {
    if (!el) {
      return;
    }
    this.storage.delRoot(el);
    el.removeSelfFromZr(this);
    this.refresh();
  };
  ZRender2.prototype.configLayer = function(zLevel, config) {
    if (this.painter.configLayer) {
      this.painter.configLayer(zLevel, config);
    }
    this.refresh();
  };
  ZRender2.prototype.setBackgroundColor = function(backgroundColor2) {
    if (this.painter.setBackgroundColor) {
      this.painter.setBackgroundColor(backgroundColor2);
    }
    this.refresh();
    this._backgroundColor = backgroundColor2;
    this._darkMode = isDarkMode(backgroundColor2);
  };
  ZRender2.prototype.getBackgroundColor = function() {
    return this._backgroundColor;
  };
  ZRender2.prototype.setDarkMode = function(darkMode) {
    this._darkMode = darkMode;
  };
  ZRender2.prototype.isDarkMode = function() {
    return this._darkMode;
  };
  ZRender2.prototype.refreshImmediately = function(fromInside) {
    if (!fromInside) {
      this.animation.update(true);
    }
    this._needsRefresh = false;
    this.painter.refresh();
    this._needsRefresh = false;
  };
  ZRender2.prototype.refresh = function() {
    this._needsRefresh = true;
    this.animation.start();
  };
  ZRender2.prototype.flush = function() {
    this._flush(false);
  };
  ZRender2.prototype._flush = function(fromInside) {
    var triggerRendered;
    var start2 = getTime();
    if (this._needsRefresh) {
      triggerRendered = true;
      this.refreshImmediately(fromInside);
    }
    if (this._needsRefreshHover) {
      triggerRendered = true;
      this.refreshHoverImmediately();
    }
    var end2 = getTime();
    if (triggerRendered) {
      this._stillFrameAccum = 0;
      this.trigger("rendered", {
        elapsedTime: end2 - start2
      });
    } else if (this._sleepAfterStill > 0) {
      this._stillFrameAccum++;
      if (this._stillFrameAccum > this._sleepAfterStill) {
        this.animation.stop();
      }
    }
  };
  ZRender2.prototype.setSleepAfterStill = function(stillFramesCount) {
    this._sleepAfterStill = stillFramesCount;
  };
  ZRender2.prototype.wakeUp = function() {
    this.animation.start();
    this._stillFrameAccum = 0;
  };
  ZRender2.prototype.refreshHover = function() {
    this._needsRefreshHover = true;
  };
  ZRender2.prototype.refreshHoverImmediately = function() {
    this._needsRefreshHover = false;
    if (this.painter.refreshHover && this.painter.getType() === "canvas") {
      this.painter.refreshHover();
    }
  };
  ZRender2.prototype.resize = function(opts) {
    opts = opts || {};
    this.painter.resize(opts.width, opts.height);
    this.handler.resize();
  };
  ZRender2.prototype.clearAnimation = function() {
    this.animation.clear();
  };
  ZRender2.prototype.getWidth = function() {
    return this.painter.getWidth();
  };
  ZRender2.prototype.getHeight = function() {
    return this.painter.getHeight();
  };
  ZRender2.prototype.setCursorStyle = function(cursorStyle) {
    this.handler.setCursorStyle(cursorStyle);
  };
  ZRender2.prototype.findHover = function(x2, y2) {
    return this.handler.findHover(x2, y2);
  };
  ZRender2.prototype.on = function(eventName, eventHandler, context) {
    this.handler.on(eventName, eventHandler, context);
    return this;
  };
  ZRender2.prototype.off = function(eventName, eventHandler) {
    this.handler.off(eventName, eventHandler);
  };
  ZRender2.prototype.trigger = function(eventName, event) {
    this.handler.trigger(eventName, event);
  };
  ZRender2.prototype.clear = function() {
    var roots2 = this.storage.getRoots();
    for (var i = 0; i < roots2.length; i++) {
      if (roots2[i] instanceof Group$6) {
        roots2[i].removeSelfFromZr(this);
      }
    }
    this.storage.delAllRoots();
    this.painter.clear();
  };
  ZRender2.prototype.dispose = function() {
    this.animation.stop();
    this.clear();
    this.storage.dispose();
    this.painter.dispose();
    this.handler.dispose();
    this.animation = this.storage = this.painter = this.handler = null;
    delInstance(this.id);
  };
  return ZRender2;
}();
function init$2(dom, opts) {
  var zr = new ZRender(guid(), dom, opts);
  instances$1[zr.id] = zr;
  return zr;
}
function registerPainter(name, Ctor) {
  painterCtors[name] = Ctor;
}
var RADIAN_EPSILON = 1e-4;
var ROUND_SUPPORTED_PRECISION_MAX = 20;
function _trim(str) {
  return str.replace(/^\s+|\s+$/g, "");
}
function linearMap$2(val, domain, range3, clamp2) {
  var d0 = domain[0];
  var d1 = domain[1];
  var r0 = range3[0];
  var r1 = range3[1];
  var subDomain = d1 - d0;
  var subRange = r1 - r0;
  if (subDomain === 0) {
    return subRange === 0 ? r0 : (r0 + r1) / 2;
  }
  if (clamp2) {
    if (subDomain > 0) {
      if (val <= d0) {
        return r0;
      } else if (val >= d1) {
        return r1;
      }
    } else {
      if (val >= d0) {
        return r0;
      } else if (val <= d1) {
        return r1;
      }
    }
  } else {
    if (val === d0) {
      return r0;
    }
    if (val === d1) {
      return r1;
    }
  }
  return (val - d0) / subDomain * subRange + r0;
}
function parsePercent(percent, all) {
  switch (percent) {
    case "center":
    case "middle":
      percent = "50%";
      break;
    case "left":
    case "top":
      percent = "0%";
      break;
    case "right":
    case "bottom":
      percent = "100%";
      break;
  }
  if (isString$1(percent)) {
    if (_trim(percent).match(/%$/)) {
      return parseFloat(percent) / 100 * all;
    }
    return parseFloat(percent);
  }
  return percent == null ? NaN : +percent;
}
function round$3(x2, precision, returnStr) {
  if (precision == null) {
    precision = 10;
  }
  precision = Math.min(Math.max(0, precision), ROUND_SUPPORTED_PRECISION_MAX);
  x2 = (+x2).toFixed(precision);
  return returnStr ? x2 : +x2;
}
function asc$2(arr) {
  arr.sort(function(a, b2) {
    return a - b2;
  });
  return arr;
}
function getPrecision(val) {
  val = +val;
  if (isNaN(val)) {
    return 0;
  }
  if (val > 1e-14) {
    var e2 = 1;
    for (var i = 0; i < 15; i++, e2 *= 10) {
      if (Math.round(val * e2) / e2 === val) {
        return i;
      }
    }
  }
  return getPrecisionSafe(val);
}
function getPrecisionSafe(val) {
  var str = val.toString().toLowerCase();
  var eIndex = str.indexOf("e");
  var exp = eIndex > 0 ? +str.slice(eIndex + 1) : 0;
  var significandPartLen = eIndex > 0 ? eIndex : str.length;
  var dotIndex = str.indexOf(".");
  var decimalPartLen = dotIndex < 0 ? 0 : significandPartLen - 1 - dotIndex;
  return Math.max(0, decimalPartLen - exp);
}
function getPixelPrecision(dataExtent, pixelExtent) {
  var log = Math.log;
  var LN10 = Math.LN10;
  var dataQuantity = Math.floor(log(dataExtent[1] - dataExtent[0]) / LN10);
  var sizeQuantity = Math.round(log(Math.abs(pixelExtent[1] - pixelExtent[0])) / LN10);
  var precision = Math.min(Math.max(-dataQuantity + sizeQuantity, 0), 20);
  return !isFinite(precision) ? 20 : precision;
}
function getPercentWithPrecision(valueList, idx, precision) {
  if (!valueList[idx]) {
    return 0;
  }
  var sum2 = reduce(valueList, function(acc, val) {
    return acc + (isNaN(val) ? 0 : val);
  }, 0);
  if (sum2 === 0) {
    return 0;
  }
  var digits = Math.pow(10, precision);
  var votesPerQuota = map$1(valueList, function(val) {
    return (isNaN(val) ? 0 : val) / sum2 * digits * 100;
  });
  var targetSeats = digits * 100;
  var seats = map$1(votesPerQuota, function(votes) {
    return Math.floor(votes);
  });
  var currentSum = reduce(seats, function(acc, val) {
    return acc + val;
  }, 0);
  var remainder = map$1(votesPerQuota, function(votes, idx2) {
    return votes - seats[idx2];
  });
  while (currentSum < targetSeats) {
    var max3 = Number.NEGATIVE_INFINITY;
    var maxId = null;
    for (var i = 0, len2 = remainder.length; i < len2; ++i) {
      if (remainder[i] > max3) {
        max3 = remainder[i];
        maxId = i;
      }
    }
    ++seats[maxId];
    remainder[maxId] = 0;
    ++currentSum;
  }
  return seats[idx] / digits;
}
function addSafe(val0, val1) {
  var maxPrecision = Math.max(getPrecision(val0), getPrecision(val1));
  var sum2 = val0 + val1;
  return maxPrecision > ROUND_SUPPORTED_PRECISION_MAX ? sum2 : round$3(sum2, maxPrecision);
}
var MAX_SAFE_INTEGER = 9007199254740991;
function remRadian(radian) {
  var pi2 = Math.PI * 2;
  return (radian % pi2 + pi2) % pi2;
}
function isRadianAroundZero(val) {
  return val > -RADIAN_EPSILON && val < RADIAN_EPSILON;
}
var TIME_REG = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
function parseDate(value) {
  if (value instanceof Date) {
    return value;
  } else if (isString$1(value)) {
    var match = TIME_REG.exec(value);
    if (!match) {
      return new Date(NaN);
    }
    if (!match[8]) {
      return new Date(+match[1], +(match[2] || 1) - 1, +match[3] || 1, +match[4] || 0, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0);
    } else {
      var hour = +match[4] || 0;
      if (match[8].toUpperCase() !== "Z") {
        hour -= +match[8].slice(0, 3);
      }
      return new Date(Date.UTC(+match[1], +(match[2] || 1) - 1, +match[3] || 1, hour, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0));
    }
  } else if (value == null) {
    return new Date(NaN);
  }
  return new Date(Math.round(value));
}
function quantity(val) {
  return Math.pow(10, quantityExponent(val));
}
function quantityExponent(val) {
  if (val === 0) {
    return 0;
  }
  var exp = Math.floor(Math.log(val) / Math.LN10);
  if (val / Math.pow(10, exp) >= 10) {
    exp++;
  }
  return exp;
}
function nice(val, round2) {
  var exponent = quantityExponent(val);
  var exp10 = Math.pow(10, exponent);
  var f2 = val / exp10;
  var nf2;
  if (round2) {
    if (f2 < 1.5) {
      nf2 = 1;
    } else if (f2 < 2.5) {
      nf2 = 2;
    } else if (f2 < 4) {
      nf2 = 3;
    } else if (f2 < 7) {
      nf2 = 5;
    } else {
      nf2 = 10;
    }
  } else {
    if (f2 < 1) {
      nf2 = 1;
    } else if (f2 < 2) {
      nf2 = 2;
    } else if (f2 < 3) {
      nf2 = 3;
    } else if (f2 < 5) {
      nf2 = 5;
    } else {
      nf2 = 10;
    }
  }
  val = nf2 * exp10;
  return exponent >= -20 ? +val.toFixed(exponent < 0 ? -exponent : 0) : val;
}
function quantile(ascArr, p2) {
  var H2 = (ascArr.length - 1) * p2 + 1;
  var h = Math.floor(H2);
  var v4 = +ascArr[h - 1];
  var e2 = H2 - h;
  return e2 ? v4 + e2 * (ascArr[h] - v4) : v4;
}
function reformIntervals(list) {
  list.sort(function(a, b2) {
    return littleThan2(a, b2, 0) ? -1 : 1;
  });
  var curr = -Infinity;
  var currClose = 1;
  for (var i = 0; i < list.length; ) {
    var interval = list[i].interval;
    var close_1 = list[i].close;
    for (var lg2 = 0; lg2 < 2; lg2++) {
      if (interval[lg2] <= curr) {
        interval[lg2] = curr;
        close_1[lg2] = !lg2 ? 1 - currClose : 1;
      }
      curr = interval[lg2];
      currClose = close_1[lg2];
    }
    if (interval[0] === interval[1] && close_1[0] * close_1[1] !== 1) {
      list.splice(i, 1);
    } else {
      i++;
    }
  }
  return list;
  function littleThan2(a, b2, lg3) {
    return a.interval[lg3] < b2.interval[lg3] || a.interval[lg3] === b2.interval[lg3] && (a.close[lg3] - b2.close[lg3] === (!lg3 ? 1 : -1) || !lg3 && littleThan2(a, b2, 1));
  }
}
function numericToNumber(val) {
  var valFloat = parseFloat(val);
  return valFloat == val && (valFloat !== 0 || !isString$1(val) || val.indexOf("x") <= 0) ? valFloat : NaN;
}
function isNumeric$1(val) {
  return !isNaN(numericToNumber(val));
}
function getRandomIdBase() {
  return Math.round(Math.random() * 9);
}
function getGreatestCommonDividor(a, b2) {
  if (b2 === 0) {
    return a;
  }
  return getGreatestCommonDividor(b2, a % b2);
}
function getLeastCommonMultiple(a, b2) {
  if (a == null) {
    return b2;
  }
  if (b2 == null) {
    return a;
  }
  return a * b2 / getGreatestCommonDividor(a, b2);
}
function throwError(msg) {
  throw new Error(msg);
}
function interpolateNumber(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
var DUMMY_COMPONENT_NAME_PREFIX = "series\0";
var INTERNAL_COMPONENT_ID_PREFIX = "\0_ec_\0";
function normalizeToArray(value) {
  return value instanceof Array ? value : value == null ? [] : [value];
}
function defaultEmphasis(opt, key, subOpts) {
  if (opt) {
    opt[key] = opt[key] || {};
    opt.emphasis = opt.emphasis || {};
    opt.emphasis[key] = opt.emphasis[key] || {};
    for (var i = 0, len2 = subOpts.length; i < len2; i++) {
      var subOptName = subOpts[i];
      if (!opt.emphasis[key].hasOwnProperty(subOptName) && opt[key].hasOwnProperty(subOptName)) {
        opt.emphasis[key][subOptName] = opt[key][subOptName];
      }
    }
  }
}
var TEXT_STYLE_OPTIONS = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
function getDataItemValue(dataItem) {
  return isObject$4(dataItem) && !isArray$1(dataItem) && !(dataItem instanceof Date) ? dataItem.value : dataItem;
}
function isDataItemOption(dataItem) {
  return isObject$4(dataItem) && !(dataItem instanceof Array);
}
function mappingToExists(existings, newCmptOptions, mode) {
  var isNormalMergeMode = mode === "normalMerge";
  var isReplaceMergeMode = mode === "replaceMerge";
  var isReplaceAllMode = mode === "replaceAll";
  existings = existings || [];
  newCmptOptions = (newCmptOptions || []).slice();
  var existingIdIdxMap = createHashMap();
  each$g(newCmptOptions, function(cmptOption, index2) {
    if (!isObject$4(cmptOption)) {
      newCmptOptions[index2] = null;
      return;
    }
  });
  var result = prepareResult(existings, existingIdIdxMap, mode);
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingById(result, existings, existingIdIdxMap, newCmptOptions);
  }
  if (isNormalMergeMode) {
    mappingByName(result, newCmptOptions);
  }
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingByIndex(result, newCmptOptions, isReplaceMergeMode);
  } else if (isReplaceAllMode) {
    mappingInReplaceAllMode(result, newCmptOptions);
  }
  makeIdAndName(result);
  return result;
}
function prepareResult(existings, existingIdIdxMap, mode) {
  var result = [];
  if (mode === "replaceAll") {
    return result;
  }
  for (var index2 = 0; index2 < existings.length; index2++) {
    var existing = existings[index2];
    if (existing && existing.id != null) {
      existingIdIdxMap.set(existing.id, index2);
    }
    result.push({
      existing: mode === "replaceMerge" || isComponentIdInternal(existing) ? null : existing,
      newOption: null,
      keyInfo: null,
      brandNew: null
    });
  }
  return result;
}
function mappingById(result, existings, existingIdIdxMap, newCmptOptions) {
  each$g(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.id == null) {
      return;
    }
    var optionId = makeComparableKey(cmptOption.id);
    var existingIdx = existingIdIdxMap.get(optionId);
    if (existingIdx != null) {
      var resultItem = result[existingIdx];
      assert(!resultItem.newOption, 'Duplicated option on id "' + optionId + '".');
      resultItem.newOption = cmptOption;
      resultItem.existing = existings[existingIdx];
      newCmptOptions[index2] = null;
    }
  });
}
function mappingByName(result, newCmptOptions) {
  each$g(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.name == null) {
      return;
    }
    for (var i = 0; i < result.length; i++) {
      var existing = result[i].existing;
      if (!result[i].newOption && existing && (existing.id == null || cmptOption.id == null) && !isComponentIdInternal(cmptOption) && !isComponentIdInternal(existing) && keyExistAndEqual("name", existing, cmptOption)) {
        result[i].newOption = cmptOption;
        newCmptOptions[index2] = null;
        return;
      }
    }
  });
}
function mappingByIndex(result, newCmptOptions, brandNew) {
  each$g(newCmptOptions, function(cmptOption) {
    if (!cmptOption) {
      return;
    }
    var resultItem;
    var nextIdx = 0;
    while ((resultItem = result[nextIdx]) && (resultItem.newOption || isComponentIdInternal(resultItem.existing) || resultItem.existing && cmptOption.id != null && !keyExistAndEqual("id", cmptOption, resultItem.existing))) {
      nextIdx++;
    }
    if (resultItem) {
      resultItem.newOption = cmptOption;
      resultItem.brandNew = brandNew;
    } else {
      result.push({
        newOption: cmptOption,
        brandNew,
        existing: null,
        keyInfo: null
      });
    }
    nextIdx++;
  });
}
function mappingInReplaceAllMode(result, newCmptOptions) {
  each$g(newCmptOptions, function(cmptOption) {
    result.push({
      newOption: cmptOption,
      brandNew: true,
      existing: null,
      keyInfo: null
    });
  });
}
function makeIdAndName(mapResult) {
  var idMap = createHashMap();
  each$g(mapResult, function(item) {
    var existing = item.existing;
    existing && idMap.set(existing.id, item);
  });
  each$g(mapResult, function(item) {
    var opt = item.newOption;
    assert(!opt || opt.id == null || !idMap.get(opt.id) || idMap.get(opt.id) === item, "id duplicates: " + (opt && opt.id));
    opt && opt.id != null && idMap.set(opt.id, item);
    !item.keyInfo && (item.keyInfo = {});
  });
  each$g(mapResult, function(item, index2) {
    var existing = item.existing;
    var opt = item.newOption;
    var keyInfo = item.keyInfo;
    if (!isObject$4(opt)) {
      return;
    }
    keyInfo.name = opt.name != null ? makeComparableKey(opt.name) : existing ? existing.name : DUMMY_COMPONENT_NAME_PREFIX + index2;
    if (existing) {
      keyInfo.id = makeComparableKey(existing.id);
    } else if (opt.id != null) {
      keyInfo.id = makeComparableKey(opt.id);
    } else {
      var idNum = 0;
      do {
        keyInfo.id = "\0" + keyInfo.name + "\0" + idNum++;
      } while (idMap.get(keyInfo.id));
    }
    idMap.set(keyInfo.id, item);
  });
}
function keyExistAndEqual(attr, obj1, obj2) {
  var key1 = convertOptionIdName(obj1[attr], null);
  var key2 = convertOptionIdName(obj2[attr], null);
  return key1 != null && key2 != null && key1 === key2;
}
function makeComparableKey(val) {
  return convertOptionIdName(val, "");
}
function convertOptionIdName(idOrName, defaultValue) {
  if (idOrName == null) {
    return defaultValue;
  }
  return isString$1(idOrName) ? idOrName : isNumber(idOrName) || isStringSafe(idOrName) ? idOrName + "" : defaultValue;
}
function isNameSpecified(componentModel) {
  var name = componentModel.name;
  return !!(name && name.indexOf(DUMMY_COMPONENT_NAME_PREFIX));
}
function isComponentIdInternal(cmptOption) {
  return cmptOption && cmptOption.id != null && makeComparableKey(cmptOption.id).indexOf(INTERNAL_COMPONENT_ID_PREFIX) === 0;
}
function makeInternalComponentId(idSuffix) {
  return INTERNAL_COMPONENT_ID_PREFIX + idSuffix;
}
function setComponentTypeToKeyInfo(mappingResult, mainType, componentModelCtor) {
  each$g(mappingResult, function(item) {
    var newOption = item.newOption;
    if (isObject$4(newOption)) {
      item.keyInfo.mainType = mainType;
      item.keyInfo.subType = determineSubType(mainType, newOption, item.existing, componentModelCtor);
    }
  });
}
function determineSubType(mainType, newCmptOption, existComponent, componentModelCtor) {
  var subType = newCmptOption.type ? newCmptOption.type : existComponent ? existComponent.subType : componentModelCtor.determineSubType(mainType, newCmptOption);
  return subType;
}
function compressBatches(batchA, batchB) {
  var mapA = {};
  var mapB = {};
  makeMap(batchA || [], mapA);
  makeMap(batchB || [], mapB, mapA);
  return [mapToArray2(mapA), mapToArray2(mapB)];
  function makeMap(sourceBatch, map2, otherMap) {
    for (var i = 0, len2 = sourceBatch.length; i < len2; i++) {
      var seriesId = convertOptionIdName(sourceBatch[i].seriesId, null);
      if (seriesId == null) {
        return;
      }
      var dataIndices = normalizeToArray(sourceBatch[i].dataIndex);
      var otherDataIndices = otherMap && otherMap[seriesId];
      for (var j = 0, lenj = dataIndices.length; j < lenj; j++) {
        var dataIndex = dataIndices[j];
        if (otherDataIndices && otherDataIndices[dataIndex]) {
          otherDataIndices[dataIndex] = null;
        } else {
          (map2[seriesId] || (map2[seriesId] = {}))[dataIndex] = 1;
        }
      }
    }
  }
  function mapToArray2(map2, isData) {
    var result = [];
    for (var i in map2) {
      if (map2.hasOwnProperty(i) && map2[i] != null) {
        if (isData) {
          result.push(+i);
        } else {
          var dataIndices = mapToArray2(map2[i], true);
          dataIndices.length && result.push({
            seriesId: i,
            dataIndex: dataIndices
          });
        }
      }
    }
    return result;
  }
}
function queryDataIndex(data, payload) {
  if (payload.dataIndexInside != null) {
    return payload.dataIndexInside;
  } else if (payload.dataIndex != null) {
    return isArray$1(payload.dataIndex) ? map$1(payload.dataIndex, function(value) {
      return data.indexOfRawIndex(value);
    }) : data.indexOfRawIndex(payload.dataIndex);
  } else if (payload.name != null) {
    return isArray$1(payload.name) ? map$1(payload.name, function(value) {
      return data.indexOfName(value);
    }) : data.indexOfName(payload.name);
  }
}
function makeInner() {
  var key = "__ec_inner_" + innerUniqueIndex++;
  return function(hostObj) {
    return hostObj[key] || (hostObj[key] = {});
  };
}
var innerUniqueIndex = getRandomIdBase();
function parseFinder$1(ecModel, finderInput, opt) {
  var _a2 = preParseFinder(finderInput, opt), mainTypeSpecified = _a2.mainTypeSpecified, queryOptionMap = _a2.queryOptionMap, others = _a2.others;
  var result = others;
  var defaultMainType = opt ? opt.defaultMainType : null;
  if (!mainTypeSpecified && defaultMainType) {
    queryOptionMap.set(defaultMainType, {});
  }
  queryOptionMap.each(function(queryOption, mainType) {
    var queryResult = queryReferringComponents(ecModel, mainType, queryOption, {
      useDefault: defaultMainType === mainType,
      enableAll: opt && opt.enableAll != null ? opt.enableAll : true,
      enableNone: opt && opt.enableNone != null ? opt.enableNone : true
    });
    result[mainType + "Models"] = queryResult.models;
    result[mainType + "Model"] = queryResult.models[0];
  });
  return result;
}
function preParseFinder(finderInput, opt) {
  var finder;
  if (isString$1(finderInput)) {
    var obj = {};
    obj[finderInput + "Index"] = 0;
    finder = obj;
  } else {
    finder = finderInput;
  }
  var queryOptionMap = createHashMap();
  var others = {};
  var mainTypeSpecified = false;
  each$g(finder, function(value, key) {
    if (key === "dataIndex" || key === "dataIndexInside") {
      others[key] = value;
      return;
    }
    var parsedKey = key.match(/^(\w+)(Index|Id|Name)$/) || [];
    var mainType = parsedKey[1];
    var queryType = (parsedKey[2] || "").toLowerCase();
    if (!mainType || !queryType || opt && opt.includeMainTypes && indexOf(opt.includeMainTypes, mainType) < 0) {
      return;
    }
    mainTypeSpecified = mainTypeSpecified || !!mainType;
    var queryOption = queryOptionMap.get(mainType) || queryOptionMap.set(mainType, {});
    queryOption[queryType] = value;
  });
  return {
    mainTypeSpecified,
    queryOptionMap,
    others
  };
}
var SINGLE_REFERRING = {
  useDefault: true,
  enableAll: false,
  enableNone: false
};
var MULTIPLE_REFERRING = {
  useDefault: false,
  enableAll: true,
  enableNone: true
};
function queryReferringComponents(ecModel, mainType, userOption, opt) {
  opt = opt || SINGLE_REFERRING;
  var indexOption = userOption.index;
  var idOption = userOption.id;
  var nameOption = userOption.name;
  var result = {
    models: null,
    specified: indexOption != null || idOption != null || nameOption != null
  };
  if (!result.specified) {
    var firstCmpt = void 0;
    result.models = opt.useDefault && (firstCmpt = ecModel.getComponent(mainType)) ? [firstCmpt] : [];
    return result;
  }
  if (indexOption === "none" || indexOption === false) {
    assert(opt.enableNone, '`"none"` or `false` is not a valid value on index option.');
    result.models = [];
    return result;
  }
  if (indexOption === "all") {
    assert(opt.enableAll, '`"all"` is not a valid value on index option.');
    indexOption = idOption = nameOption = null;
  }
  result.models = ecModel.queryComponents({
    mainType,
    index: indexOption,
    id: idOption,
    name: nameOption
  });
  return result;
}
function setAttribute(dom, key, value) {
  dom.setAttribute ? dom.setAttribute(key, value) : dom[key] = value;
}
function getAttribute(dom, key) {
  return dom.getAttribute ? dom.getAttribute(key) : dom[key];
}
function getTooltipRenderMode(renderModeOption) {
  if (renderModeOption === "auto") {
    return env$1.domSupported ? "html" : "richText";
  } else {
    return renderModeOption || "html";
  }
}
function groupData(array4, getKey2) {
  var buckets = createHashMap();
  var keys2 = [];
  each$g(array4, function(item) {
    var key = getKey2(item);
    (buckets.get(key) || (keys2.push(key), buckets.set(key, []))).push(item);
  });
  return {
    keys: keys2,
    buckets
  };
}
function interpolateRawValues(data, precision, sourceValue, targetValue, percent) {
  var isAutoPrecision = precision == null || precision === "auto";
  if (targetValue == null) {
    return targetValue;
  }
  if (isNumber(targetValue)) {
    var value = interpolateNumber(sourceValue || 0, targetValue, percent);
    return round$3(value, isAutoPrecision ? Math.max(getPrecision(sourceValue || 0), getPrecision(targetValue)) : precision);
  } else if (isString$1(targetValue)) {
    return percent < 1 ? sourceValue : targetValue;
  } else {
    var interpolated = [];
    var leftArr = sourceValue;
    var rightArr = targetValue;
    var length_1 = Math.max(leftArr ? leftArr.length : 0, rightArr.length);
    for (var i = 0; i < length_1; ++i) {
      var info = data.getDimensionInfo(i);
      if (info && info.type === "ordinal") {
        interpolated[i] = (percent < 1 && leftArr ? leftArr : rightArr)[i];
      } else {
        var leftVal = leftArr && leftArr[i] ? leftArr[i] : 0;
        var rightVal = rightArr[i];
        var value = interpolateNumber(leftVal, rightVal, percent);
        interpolated[i] = round$3(value, isAutoPrecision ? Math.max(getPrecision(leftVal), getPrecision(rightVal)) : precision);
      }
    }
    return interpolated;
  }
}
var TYPE_DELIMITER = ".";
var IS_CONTAINER = "___EC__COMPONENT__CONTAINER___";
var IS_EXTENDED_CLASS = "___EC__EXTENDED_CLASS___";
function parseClassType(componentType) {
  var ret = {
    main: "",
    sub: ""
  };
  if (componentType) {
    var typeArr = componentType.split(TYPE_DELIMITER);
    ret.main = typeArr[0] || "";
    ret.sub = typeArr[1] || "";
  }
  return ret;
}
function checkClassType(componentType) {
  assert(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(componentType), 'componentType "' + componentType + '" illegal');
}
function isExtendedClass(clz) {
  return !!(clz && clz[IS_EXTENDED_CLASS]);
}
function enableClassExtend(rootClz, mandatoryMethods) {
  rootClz.$constructor = rootClz;
  rootClz.extend = function(proto2) {
    var superClass = this;
    var ExtendedClass;
    if (isESClass(superClass)) {
      ExtendedClass = function(_super) {
        __extends(class_1, _super);
        function class_1() {
          return _super.apply(this, arguments) || this;
        }
        return class_1;
      }(superClass);
    } else {
      ExtendedClass = function() {
        (proto2.$constructor || superClass).apply(this, arguments);
      };
      inherits(ExtendedClass, this);
    }
    extend(ExtendedClass.prototype, proto2);
    ExtendedClass[IS_EXTENDED_CLASS] = true;
    ExtendedClass.extend = this.extend;
    ExtendedClass.superCall = superCall;
    ExtendedClass.superApply = superApply;
    ExtendedClass.superClass = superClass;
    return ExtendedClass;
  };
}
function isESClass(fn) {
  return isFunction(fn) && /^class\s/.test(Function.prototype.toString.call(fn));
}
function mountExtend(SubClz, SupperClz) {
  SubClz.extend = SupperClz.extend;
}
var classBase = Math.round(Math.random() * 10);
function enableClassCheck(target) {
  var classAttr = ["__\0is_clz", classBase++].join("_");
  target.prototype[classAttr] = true;
  target.isInstance = function(obj) {
    return !!(obj && obj[classAttr]);
  };
}
function superCall(context, methodName) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return this.superClass.prototype[methodName].apply(context, args);
}
function superApply(context, methodName, args) {
  return this.superClass.prototype[methodName].apply(context, args);
}
function enableClassManagement(target) {
  var storage2 = {};
  target.registerClass = function(clz) {
    var componentFullType = clz.type || clz.prototype.type;
    if (componentFullType) {
      checkClassType(componentFullType);
      clz.prototype.type = componentFullType;
      var componentTypeInfo = parseClassType(componentFullType);
      if (!componentTypeInfo.sub) {
        storage2[componentTypeInfo.main] = clz;
      } else if (componentTypeInfo.sub !== IS_CONTAINER) {
        var container2 = makeContainer(componentTypeInfo);
        container2[componentTypeInfo.sub] = clz;
      }
    }
    return clz;
  };
  target.getClass = function(mainType, subType, throwWhenNotFound) {
    var clz = storage2[mainType];
    if (clz && clz[IS_CONTAINER]) {
      clz = subType ? clz[subType] : null;
    }
    if (throwWhenNotFound && !clz) {
      throw new Error(!subType ? mainType + ".type should be specified." : "Component " + mainType + "." + (subType || "") + " is used but not imported.");
    }
    return clz;
  };
  target.getClassesByMainType = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var result = [];
    var obj = storage2[componentTypeInfo.main];
    if (obj && obj[IS_CONTAINER]) {
      each$g(obj, function(o, type4) {
        type4 !== IS_CONTAINER && result.push(o);
      });
    } else {
      result.push(obj);
    }
    return result;
  };
  target.hasClass = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    return !!storage2[componentTypeInfo.main];
  };
  target.getAllClassMainTypes = function() {
    var types2 = [];
    each$g(storage2, function(obj, type4) {
      types2.push(type4);
    });
    return types2;
  };
  target.hasSubTypes = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var obj = storage2[componentTypeInfo.main];
    return obj && obj[IS_CONTAINER];
  };
  function makeContainer(componentTypeInfo) {
    var container2 = storage2[componentTypeInfo.main];
    if (!container2 || !container2[IS_CONTAINER]) {
      container2 = storage2[componentTypeInfo.main] = {};
      container2[IS_CONTAINER] = true;
    }
    return container2;
  }
}
function makeStyleMapper(properties, ignoreParent) {
  for (var i = 0; i < properties.length; i++) {
    if (!properties[i][1]) {
      properties[i][1] = properties[i][0];
    }
  }
  ignoreParent = ignoreParent || false;
  return function(model, excludes, includes) {
    var style2 = {};
    for (var i2 = 0; i2 < properties.length; i2++) {
      var propName = properties[i2][1];
      if (excludes && indexOf(excludes, propName) >= 0 || includes && indexOf(includes, propName) < 0) {
        continue;
      }
      var val = model.getShallow(propName, ignoreParent);
      if (val != null) {
        style2[properties[i2][0]] = val;
      }
    }
    return style2;
  };
}
var AREA_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["opacity"],
  ["shadowColor"]
];
var getAreaStyle = makeStyleMapper(AREA_STYLE_KEY_MAP);
var AreaStyleMixin = function() {
  function AreaStyleMixin2() {
  }
  AreaStyleMixin2.prototype.getAreaStyle = function(excludes, includes) {
    return getAreaStyle(this, excludes, includes);
  };
  return AreaStyleMixin2;
}();
var globalImageCache = new LRU$1(50);
function findExistImage(newImageOrSrc) {
  if (typeof newImageOrSrc === "string") {
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    return cachedImgObj && cachedImgObj.image;
  } else {
    return newImageOrSrc;
  }
}
function createOrUpdateImage(newImageOrSrc, image, hostEl, onload, cbPayload) {
  if (!newImageOrSrc) {
    return image;
  } else if (typeof newImageOrSrc === "string") {
    if (image && image.__zrImageSrc === newImageOrSrc || !hostEl) {
      return image;
    }
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    var pendingWrap = { hostEl, cb: onload, cbPayload };
    if (cachedImgObj) {
      image = cachedImgObj.image;
      !isImageReady(image) && cachedImgObj.pending.push(pendingWrap);
    } else {
      var image_1 = platformApi.loadImage(newImageOrSrc, imageOnLoad, imageOnLoad);
      image_1.__zrImageSrc = newImageOrSrc;
      globalImageCache.put(newImageOrSrc, image_1.__cachedImgObj = {
        image: image_1,
        pending: [pendingWrap]
      });
    }
    return image;
  } else {
    return newImageOrSrc;
  }
}
function imageOnLoad() {
  var cachedImgObj = this.__cachedImgObj;
  this.onload = this.onerror = this.__cachedImgObj = null;
  for (var i = 0; i < cachedImgObj.pending.length; i++) {
    var pendingWrap = cachedImgObj.pending[i];
    var cb2 = pendingWrap.cb;
    cb2 && cb2(this, pendingWrap.cbPayload);
    pendingWrap.hostEl.dirty();
  }
  cachedImgObj.pending.length = 0;
}
function isImageReady(image) {
  return image && image.width && image.height;
}
var STYLE_REG = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
function truncateText(text, containerWidth, font, ellipsis, options) {
  if (!containerWidth) {
    return "";
  }
  var textLines = (text + "").split("\n");
  options = prepareTruncateOptions(containerWidth, font, ellipsis, options);
  for (var i = 0, len2 = textLines.length; i < len2; i++) {
    textLines[i] = truncateSingleLine(textLines[i], options);
  }
  return textLines.join("\n");
}
function prepareTruncateOptions(containerWidth, font, ellipsis, options) {
  options = options || {};
  var preparedOpts = extend({}, options);
  preparedOpts.font = font;
  ellipsis = retrieve2(ellipsis, "...");
  preparedOpts.maxIterations = retrieve2(options.maxIterations, 2);
  var minChar = preparedOpts.minChar = retrieve2(options.minChar, 0);
  preparedOpts.cnCharWidth = getWidth("\u56FD", font);
  var ascCharWidth = preparedOpts.ascCharWidth = getWidth("a", font);
  preparedOpts.placeholder = retrieve2(options.placeholder, "");
  var contentWidth = containerWidth = Math.max(0, containerWidth - 1);
  for (var i = 0; i < minChar && contentWidth >= ascCharWidth; i++) {
    contentWidth -= ascCharWidth;
  }
  var ellipsisWidth = getWidth(ellipsis, font);
  if (ellipsisWidth > contentWidth) {
    ellipsis = "";
    ellipsisWidth = 0;
  }
  contentWidth = containerWidth - ellipsisWidth;
  preparedOpts.ellipsis = ellipsis;
  preparedOpts.ellipsisWidth = ellipsisWidth;
  preparedOpts.contentWidth = contentWidth;
  preparedOpts.containerWidth = containerWidth;
  return preparedOpts;
}
function truncateSingleLine(textLine, options) {
  var containerWidth = options.containerWidth;
  var font = options.font;
  var contentWidth = options.contentWidth;
  if (!containerWidth) {
    return "";
  }
  var lineWidth = getWidth(textLine, font);
  if (lineWidth <= containerWidth) {
    return textLine;
  }
  for (var j = 0; ; j++) {
    if (lineWidth <= contentWidth || j >= options.maxIterations) {
      textLine += options.ellipsis;
      break;
    }
    var subLength = j === 0 ? estimateLength(textLine, contentWidth, options.ascCharWidth, options.cnCharWidth) : lineWidth > 0 ? Math.floor(textLine.length * contentWidth / lineWidth) : 0;
    textLine = textLine.substr(0, subLength);
    lineWidth = getWidth(textLine, font);
  }
  if (textLine === "") {
    textLine = options.placeholder;
  }
  return textLine;
}
function estimateLength(text, contentWidth, ascCharWidth, cnCharWidth) {
  var width = 0;
  var i = 0;
  for (var len2 = text.length; i < len2 && width < contentWidth; i++) {
    var charCode = text.charCodeAt(i);
    width += 0 <= charCode && charCode <= 127 ? ascCharWidth : cnCharWidth;
  }
  return i;
}
function parsePlainText(text, style2) {
  text != null && (text += "");
  var overflow = style2.overflow;
  var padding = style2.padding;
  var font = style2.font;
  var truncate = overflow === "truncate";
  var calculatedLineHeight = getLineHeight(font);
  var lineHeight = retrieve2(style2.lineHeight, calculatedLineHeight);
  var bgColorDrawn = !!style2.backgroundColor;
  var truncateLineOverflow = style2.lineOverflow === "truncate";
  var width = style2.width;
  var lines;
  if (width != null && (overflow === "break" || overflow === "breakAll")) {
    lines = text ? wrapText(text, style2.font, width, overflow === "breakAll", 0).lines : [];
  } else {
    lines = text ? text.split("\n") : [];
  }
  var contentHeight = lines.length * lineHeight;
  var height = retrieve2(style2.height, contentHeight);
  if (contentHeight > height && truncateLineOverflow) {
    var lineCount = Math.floor(height / lineHeight);
    lines = lines.slice(0, lineCount);
  }
  if (text && truncate && width != null) {
    var options = prepareTruncateOptions(width, font, style2.ellipsis, {
      minChar: style2.truncateMinChar,
      placeholder: style2.placeholder
    });
    for (var i = 0; i < lines.length; i++) {
      lines[i] = truncateSingleLine(lines[i], options);
    }
  }
  var outerHeight = height;
  var contentWidth = 0;
  for (var i = 0; i < lines.length; i++) {
    contentWidth = Math.max(getWidth(lines[i], font), contentWidth);
  }
  if (width == null) {
    width = contentWidth;
  }
  var outerWidth = contentWidth;
  if (padding) {
    outerHeight += padding[0] + padding[2];
    outerWidth += padding[1] + padding[3];
    width += padding[1] + padding[3];
  }
  if (bgColorDrawn) {
    outerWidth = width;
  }
  return {
    lines,
    height,
    outerWidth,
    outerHeight,
    lineHeight,
    calculatedLineHeight,
    contentWidth,
    contentHeight,
    width
  };
}
var RichTextToken = function() {
  function RichTextToken2() {
  }
  return RichTextToken2;
}();
var RichTextLine = function() {
  function RichTextLine2(tokens) {
    this.tokens = [];
    if (tokens) {
      this.tokens = tokens;
    }
  }
  return RichTextLine2;
}();
var RichTextContentBlock = function() {
  function RichTextContentBlock2() {
    this.width = 0;
    this.height = 0;
    this.contentWidth = 0;
    this.contentHeight = 0;
    this.outerWidth = 0;
    this.outerHeight = 0;
    this.lines = [];
  }
  return RichTextContentBlock2;
}();
function parseRichText(text, style2) {
  var contentBlock = new RichTextContentBlock();
  text != null && (text += "");
  if (!text) {
    return contentBlock;
  }
  var topWidth = style2.width;
  var topHeight = style2.height;
  var overflow = style2.overflow;
  var wrapInfo = (overflow === "break" || overflow === "breakAll") && topWidth != null ? { width: topWidth, accumWidth: 0, breakAll: overflow === "breakAll" } : null;
  var lastIndex = STYLE_REG.lastIndex = 0;
  var result;
  while ((result = STYLE_REG.exec(text)) != null) {
    var matchedIndex = result.index;
    if (matchedIndex > lastIndex) {
      pushTokens(contentBlock, text.substring(lastIndex, matchedIndex), style2, wrapInfo);
    }
    pushTokens(contentBlock, result[2], style2, wrapInfo, result[1]);
    lastIndex = STYLE_REG.lastIndex;
  }
  if (lastIndex < text.length) {
    pushTokens(contentBlock, text.substring(lastIndex, text.length), style2, wrapInfo);
  }
  var pendingList = [];
  var calculatedHeight = 0;
  var calculatedWidth = 0;
  var stlPadding = style2.padding;
  var truncate = overflow === "truncate";
  var truncateLine = style2.lineOverflow === "truncate";
  function finishLine(line2, lineWidth2, lineHeight2) {
    line2.width = lineWidth2;
    line2.lineHeight = lineHeight2;
    calculatedHeight += lineHeight2;
    calculatedWidth = Math.max(calculatedWidth, lineWidth2);
  }
  outer:
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var lineHeight = 0;
      var lineWidth = 0;
      for (var j = 0; j < line.tokens.length; j++) {
        var token = line.tokens[j];
        var tokenStyle = token.styleName && style2.rich[token.styleName] || {};
        var textPadding = token.textPadding = tokenStyle.padding;
        var paddingH = textPadding ? textPadding[1] + textPadding[3] : 0;
        var font = token.font = tokenStyle.font || style2.font;
        token.contentHeight = getLineHeight(font);
        var tokenHeight = retrieve2(tokenStyle.height, token.contentHeight);
        token.innerHeight = tokenHeight;
        textPadding && (tokenHeight += textPadding[0] + textPadding[2]);
        token.height = tokenHeight;
        token.lineHeight = retrieve3(tokenStyle.lineHeight, style2.lineHeight, tokenHeight);
        token.align = tokenStyle && tokenStyle.align || style2.align;
        token.verticalAlign = tokenStyle && tokenStyle.verticalAlign || "middle";
        if (truncateLine && topHeight != null && calculatedHeight + token.lineHeight > topHeight) {
          if (j > 0) {
            line.tokens = line.tokens.slice(0, j);
            finishLine(line, lineWidth, lineHeight);
            contentBlock.lines = contentBlock.lines.slice(0, i + 1);
          } else {
            contentBlock.lines = contentBlock.lines.slice(0, i);
          }
          break outer;
        }
        var styleTokenWidth = tokenStyle.width;
        var tokenWidthNotSpecified = styleTokenWidth == null || styleTokenWidth === "auto";
        if (typeof styleTokenWidth === "string" && styleTokenWidth.charAt(styleTokenWidth.length - 1) === "%") {
          token.percentWidth = styleTokenWidth;
          pendingList.push(token);
          token.contentWidth = getWidth(token.text, font);
        } else {
          if (tokenWidthNotSpecified) {
            var textBackgroundColor = tokenStyle.backgroundColor;
            var bgImg = textBackgroundColor && textBackgroundColor.image;
            if (bgImg) {
              bgImg = findExistImage(bgImg);
              if (isImageReady(bgImg)) {
                token.width = Math.max(token.width, bgImg.width * tokenHeight / bgImg.height);
              }
            }
          }
          var remainTruncWidth = truncate && topWidth != null ? topWidth - lineWidth : null;
          if (remainTruncWidth != null && remainTruncWidth < token.width) {
            if (!tokenWidthNotSpecified || remainTruncWidth < paddingH) {
              token.text = "";
              token.width = token.contentWidth = 0;
            } else {
              token.text = truncateText(token.text, remainTruncWidth - paddingH, font, style2.ellipsis, { minChar: style2.truncateMinChar });
              token.width = token.contentWidth = getWidth(token.text, font);
            }
          } else {
            token.contentWidth = getWidth(token.text, font);
          }
        }
        token.width += paddingH;
        lineWidth += token.width;
        tokenStyle && (lineHeight = Math.max(lineHeight, token.lineHeight));
      }
      finishLine(line, lineWidth, lineHeight);
    }
  contentBlock.outerWidth = contentBlock.width = retrieve2(topWidth, calculatedWidth);
  contentBlock.outerHeight = contentBlock.height = retrieve2(topHeight, calculatedHeight);
  contentBlock.contentHeight = calculatedHeight;
  contentBlock.contentWidth = calculatedWidth;
  if (stlPadding) {
    contentBlock.outerWidth += stlPadding[1] + stlPadding[3];
    contentBlock.outerHeight += stlPadding[0] + stlPadding[2];
  }
  for (var i = 0; i < pendingList.length; i++) {
    var token = pendingList[i];
    var percentWidth = token.percentWidth;
    token.width = parseInt(percentWidth, 10) / 100 * contentBlock.width;
  }
  return contentBlock;
}
function pushTokens(block, str, style2, wrapInfo, styleName) {
  var isEmptyStr = str === "";
  var tokenStyle = styleName && style2.rich[styleName] || {};
  var lines = block.lines;
  var font = tokenStyle.font || style2.font;
  var newLine = false;
  var strLines;
  var linesWidths;
  if (wrapInfo) {
    var tokenPadding = tokenStyle.padding;
    var tokenPaddingH = tokenPadding ? tokenPadding[1] + tokenPadding[3] : 0;
    if (tokenStyle.width != null && tokenStyle.width !== "auto") {
      var outerWidth_1 = parsePercent$1(tokenStyle.width, wrapInfo.width) + tokenPaddingH;
      if (lines.length > 0) {
        if (outerWidth_1 + wrapInfo.accumWidth > wrapInfo.width) {
          strLines = str.split("\n");
          newLine = true;
        }
      }
      wrapInfo.accumWidth = outerWidth_1;
    } else {
      var res = wrapText(str, font, wrapInfo.width, wrapInfo.breakAll, wrapInfo.accumWidth);
      wrapInfo.accumWidth = res.accumWidth + tokenPaddingH;
      linesWidths = res.linesWidths;
      strLines = res.lines;
    }
  } else {
    strLines = str.split("\n");
  }
  for (var i = 0; i < strLines.length; i++) {
    var text = strLines[i];
    var token = new RichTextToken();
    token.styleName = styleName;
    token.text = text;
    token.isLineHolder = !text && !isEmptyStr;
    if (typeof tokenStyle.width === "number") {
      token.width = tokenStyle.width;
    } else {
      token.width = linesWidths ? linesWidths[i] : getWidth(text, font);
    }
    if (!i && !newLine) {
      var tokens = (lines[lines.length - 1] || (lines[0] = new RichTextLine())).tokens;
      var tokensLen = tokens.length;
      tokensLen === 1 && tokens[0].isLineHolder ? tokens[0] = token : (text || !tokensLen || isEmptyStr) && tokens.push(token);
    } else {
      lines.push(new RichTextLine([token]));
    }
  }
}
function isLatin(ch2) {
  var code = ch2.charCodeAt(0);
  return code >= 33 && code <= 383;
}
var breakCharMap = reduce(",&?/;] ".split(""), function(obj, ch2) {
  obj[ch2] = true;
  return obj;
}, {});
function isWordBreakChar(ch2) {
  if (isLatin(ch2)) {
    if (breakCharMap[ch2]) {
      return true;
    }
    return false;
  }
  return true;
}
function wrapText(text, font, lineWidth, isBreakAll, lastAccumWidth) {
  var lines = [];
  var linesWidths = [];
  var line = "";
  var currentWord = "";
  var currentWordWidth = 0;
  var accumWidth = 0;
  for (var i = 0; i < text.length; i++) {
    var ch2 = text.charAt(i);
    if (ch2 === "\n") {
      if (currentWord) {
        line += currentWord;
        accumWidth += currentWordWidth;
      }
      lines.push(line);
      linesWidths.push(accumWidth);
      line = "";
      currentWord = "";
      currentWordWidth = 0;
      accumWidth = 0;
      continue;
    }
    var chWidth = getWidth(ch2, font);
    var inWord = isBreakAll ? false : !isWordBreakChar(ch2);
    if (!lines.length ? lastAccumWidth + accumWidth + chWidth > lineWidth : accumWidth + chWidth > lineWidth) {
      if (!accumWidth) {
        if (inWord) {
          lines.push(currentWord);
          linesWidths.push(currentWordWidth);
          currentWord = ch2;
          currentWordWidth = chWidth;
        } else {
          lines.push(ch2);
          linesWidths.push(chWidth);
        }
      } else if (line || currentWord) {
        if (inWord) {
          if (!line) {
            line = currentWord;
            currentWord = "";
            currentWordWidth = 0;
            accumWidth = currentWordWidth;
          }
          lines.push(line);
          linesWidths.push(accumWidth - currentWordWidth);
          currentWord += ch2;
          currentWordWidth += chWidth;
          line = "";
          accumWidth = currentWordWidth;
        } else {
          if (currentWord) {
            line += currentWord;
            currentWord = "";
            currentWordWidth = 0;
          }
          lines.push(line);
          linesWidths.push(accumWidth);
          line = ch2;
          accumWidth = chWidth;
        }
      }
      continue;
    }
    accumWidth += chWidth;
    if (inWord) {
      currentWord += ch2;
      currentWordWidth += chWidth;
    } else {
      if (currentWord) {
        line += currentWord;
        currentWord = "";
        currentWordWidth = 0;
      }
      line += ch2;
    }
  }
  if (!lines.length && !line) {
    line = text;
    currentWord = "";
    currentWordWidth = 0;
  }
  if (currentWord) {
    line += currentWord;
  }
  if (line) {
    lines.push(line);
    linesWidths.push(accumWidth);
  }
  if (lines.length === 1) {
    accumWidth += lastAccumWidth;
  }
  return {
    accumWidth,
    lines,
    linesWidths
  };
}
var STYLE_MAGIC_KEY = "__zr_style_" + Math.round(Math.random() * 10);
var DEFAULT_COMMON_STYLE = {
  shadowBlur: 0,
  shadowOffsetX: 0,
  shadowOffsetY: 0,
  shadowColor: "#000",
  opacity: 1,
  blend: "source-over"
};
var DEFAULT_COMMON_ANIMATION_PROPS = {
  style: {
    shadowBlur: true,
    shadowOffsetX: true,
    shadowOffsetY: true,
    shadowColor: true,
    opacity: true
  }
};
DEFAULT_COMMON_STYLE[STYLE_MAGIC_KEY] = true;
var PRIMARY_STATES_KEYS = ["z", "z2", "invisible"];
var PRIMARY_STATES_KEYS_IN_HOVER_LAYER = ["invisible"];
var Displayable = function(_super) {
  __extends(Displayable2, _super);
  function Displayable2(props) {
    return _super.call(this, props) || this;
  }
  Displayable2.prototype._init = function(props) {
    var keysArr = keys(props);
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      if (key === "style") {
        this.useStyle(props[key]);
      } else {
        _super.prototype.attrKV.call(this, key, props[key]);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Displayable2.prototype.beforeBrush = function() {
  };
  Displayable2.prototype.afterBrush = function() {
  };
  Displayable2.prototype.innerBeforeBrush = function() {
  };
  Displayable2.prototype.innerAfterBrush = function() {
  };
  Displayable2.prototype.shouldBePainted = function(viewWidth, viewHeight, considerClipPath, considerAncestors) {
    var m2 = this.transform;
    if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && isDisplayableCulled(this, viewWidth, viewHeight) || m2 && !m2[0] && !m2[3]) {
      return false;
    }
    if (considerClipPath && this.__clipPaths) {
      for (var i = 0; i < this.__clipPaths.length; ++i) {
        if (this.__clipPaths[i].isZeroArea()) {
          return false;
        }
      }
    }
    if (considerAncestors && this.parent) {
      var parent_1 = this.parent;
      while (parent_1) {
        if (parent_1.ignore) {
          return false;
        }
        parent_1 = parent_1.parent;
      }
    }
    return true;
  };
  Displayable2.prototype.contain = function(x2, y2) {
    return this.rectContain(x2, y2);
  };
  Displayable2.prototype.traverse = function(cb2, context) {
    cb2.call(context, this);
  };
  Displayable2.prototype.rectContain = function(x2, y2) {
    var coord = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    return rect.contain(coord[0], coord[1]);
  };
  Displayable2.prototype.getPaintRect = function() {
    var rect = this._paintRect;
    if (!this._paintRect || this.__dirty) {
      var transform2 = this.transform;
      var elRect = this.getBoundingRect();
      var style2 = this.style;
      var shadowSize = style2.shadowBlur || 0;
      var shadowOffsetX = style2.shadowOffsetX || 0;
      var shadowOffsetY = style2.shadowOffsetY || 0;
      rect = this._paintRect || (this._paintRect = new BoundingRect$1(0, 0, 0, 0));
      if (transform2) {
        BoundingRect$1.applyTransform(rect, elRect, transform2);
      } else {
        rect.copy(elRect);
      }
      if (shadowSize || shadowOffsetX || shadowOffsetY) {
        rect.width += shadowSize * 2 + Math.abs(shadowOffsetX);
        rect.height += shadowSize * 2 + Math.abs(shadowOffsetY);
        rect.x = Math.min(rect.x, rect.x + shadowOffsetX - shadowSize);
        rect.y = Math.min(rect.y, rect.y + shadowOffsetY - shadowSize);
      }
      var tolerance = this.dirtyRectTolerance;
      if (!rect.isZero()) {
        rect.x = Math.floor(rect.x - tolerance);
        rect.y = Math.floor(rect.y - tolerance);
        rect.width = Math.ceil(rect.width + 1 + tolerance * 2);
        rect.height = Math.ceil(rect.height + 1 + tolerance * 2);
      }
    }
    return rect;
  };
  Displayable2.prototype.setPrevPaintRect = function(paintRect) {
    if (paintRect) {
      this._prevPaintRect = this._prevPaintRect || new BoundingRect$1(0, 0, 0, 0);
      this._prevPaintRect.copy(paintRect);
    } else {
      this._prevPaintRect = null;
    }
  };
  Displayable2.prototype.getPrevPaintRect = function() {
    return this._prevPaintRect;
  };
  Displayable2.prototype.animateStyle = function(loop) {
    return this.animate("style", loop);
  };
  Displayable2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else {
      this.markRedraw();
    }
  };
  Displayable2.prototype.attrKV = function(key, value) {
    if (key !== "style") {
      _super.prototype.attrKV.call(this, key, value);
    } else {
      if (!this.style) {
        this.useStyle(value);
      } else {
        this.setStyle(value);
      }
    }
  };
  Displayable2.prototype.setStyle = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.style[keyOrObj] = value;
    } else {
      extend(this.style, keyOrObj);
    }
    this.dirtyStyle();
    return this;
  };
  Displayable2.prototype.dirtyStyle = function(notRedraw) {
    if (!notRedraw) {
      this.markRedraw();
    }
    this.__dirty |= STYLE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
  };
  Displayable2.prototype.dirty = function() {
    this.dirtyStyle();
  };
  Displayable2.prototype.styleChanged = function() {
    return !!(this.__dirty & STYLE_CHANGED_BIT);
  };
  Displayable2.prototype.styleUpdated = function() {
    this.__dirty &= ~STYLE_CHANGED_BIT;
  };
  Displayable2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_COMMON_STYLE, obj);
  };
  Displayable2.prototype.useStyle = function(obj) {
    if (!obj[STYLE_MAGIC_KEY]) {
      obj = this.createStyle(obj);
    }
    if (this.__inHover) {
      this.__hoverStyle = obj;
    } else {
      this.style = obj;
    }
    this.dirtyStyle();
  };
  Displayable2.prototype.isStyleObject = function(obj) {
    return obj[STYLE_MAGIC_KEY];
  };
  Displayable2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.style && !normalState.style) {
      normalState.style = this._mergeStyle(this.createStyle(), this.style);
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS);
  };
  Displayable2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetStyle;
    if (state && state.style) {
      if (transition) {
        if (keepCurrentStates) {
          targetStyle = state.style;
        } else {
          targetStyle = this._mergeStyle(this.createStyle(), normalState.style);
          this._mergeStyle(targetStyle, state.style);
        }
      } else {
        targetStyle = this._mergeStyle(this.createStyle(), keepCurrentStates ? this.style : normalState.style);
        this._mergeStyle(targetStyle, state.style);
      }
    } else if (needsRestoreToNormal) {
      targetStyle = normalState.style;
    }
    if (targetStyle) {
      if (transition) {
        var sourceStyle = this.style;
        this.style = this.createStyle(needsRestoreToNormal ? {} : sourceStyle);
        if (needsRestoreToNormal) {
          var changedKeys = keys(sourceStyle);
          for (var i = 0; i < changedKeys.length; i++) {
            var key = changedKeys[i];
            if (key in targetStyle) {
              targetStyle[key] = targetStyle[key];
              this.style[key] = sourceStyle[key];
            }
          }
        }
        var targetKeys = keys(targetStyle);
        for (var i = 0; i < targetKeys.length; i++) {
          var key = targetKeys[i];
          this.style[key] = this.style[key];
        }
        this._transitionState(stateName, {
          style: targetStyle
        }, animationCfg, this.getAnimationStyleProps());
      } else {
        this.useStyle(targetStyle);
      }
    }
    var statesKeys = this.__inHover ? PRIMARY_STATES_KEYS_IN_HOVER_LAYER : PRIMARY_STATES_KEYS;
    for (var i = 0; i < statesKeys.length; i++) {
      var key = statesKeys[i];
      if (state && state[key] != null) {
        this[key] = state[key];
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          this[key] = normalState[key];
        }
      }
    }
  };
  Displayable2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedStyle;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.style) {
        mergedStyle = mergedStyle || {};
        this._mergeStyle(mergedStyle, state.style);
      }
    }
    if (mergedStyle) {
      mergedState.style = mergedStyle;
    }
    return mergedState;
  };
  Displayable2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    extend(targetStyle, sourceStyle);
    return targetStyle;
  };
  Displayable2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_COMMON_ANIMATION_PROPS;
  };
  Displayable2.initDefaultProps = function() {
    var dispProto = Displayable2.prototype;
    dispProto.type = "displayable";
    dispProto.invisible = false;
    dispProto.z = 0;
    dispProto.z2 = 0;
    dispProto.zlevel = 0;
    dispProto.culling = false;
    dispProto.cursor = "pointer";
    dispProto.rectHover = false;
    dispProto.incremental = false;
    dispProto._rect = null;
    dispProto.dirtyRectTolerance = 0;
    dispProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT;
  }();
  return Displayable2;
}(Element$2);
var tmpRect = new BoundingRect$1(0, 0, 0, 0);
var viewRect = new BoundingRect$1(0, 0, 0, 0);
function isDisplayableCulled(el, width, height) {
  tmpRect.copy(el.getBoundingRect());
  if (el.transform) {
    tmpRect.applyTransform(el.transform);
  }
  viewRect.width = width;
  viewRect.height = height;
  return !tmpRect.intersect(viewRect);
}
var Displayable$1 = Displayable;
var mathMin$9 = Math.min;
var mathMax$9 = Math.max;
var mathSin$4 = Math.sin;
var mathCos$4 = Math.cos;
var PI2$9 = Math.PI * 2;
var start = create$2();
var end = create$2();
var extremity = create$2();
function fromPoints(points2, min3, max3) {
  if (points2.length === 0) {
    return;
  }
  var p2 = points2[0];
  var left = p2[0];
  var right = p2[0];
  var top = p2[1];
  var bottom = p2[1];
  for (var i = 1; i < points2.length; i++) {
    p2 = points2[i];
    left = mathMin$9(left, p2[0]);
    right = mathMax$9(right, p2[0]);
    top = mathMin$9(top, p2[1]);
    bottom = mathMax$9(bottom, p2[1]);
  }
  min3[0] = left;
  min3[1] = top;
  max3[0] = right;
  max3[1] = bottom;
}
function fromLine(x0, y0, x1, y1, min3, max3) {
  min3[0] = mathMin$9(x0, x1);
  min3[1] = mathMin$9(y0, y1);
  max3[0] = mathMax$9(x0, x1);
  max3[1] = mathMax$9(y0, y1);
}
var xDim = [];
var yDim = [];
function fromCubic(x0, y0, x1, y1, x2, y2, x3, y3, min3, max3) {
  var cubicExtrema$1 = cubicExtrema;
  var cubicAt$1 = cubicAt;
  var n2 = cubicExtrema$1(x0, x1, x2, x3, xDim);
  min3[0] = Infinity;
  min3[1] = Infinity;
  max3[0] = -Infinity;
  max3[1] = -Infinity;
  for (var i = 0; i < n2; i++) {
    var x4 = cubicAt$1(x0, x1, x2, x3, xDim[i]);
    min3[0] = mathMin$9(x4, min3[0]);
    max3[0] = mathMax$9(x4, max3[0]);
  }
  n2 = cubicExtrema$1(y0, y1, y2, y3, yDim);
  for (var i = 0; i < n2; i++) {
    var y4 = cubicAt$1(y0, y1, y2, y3, yDim[i]);
    min3[1] = mathMin$9(y4, min3[1]);
    max3[1] = mathMax$9(y4, max3[1]);
  }
  min3[0] = mathMin$9(x0, min3[0]);
  max3[0] = mathMax$9(x0, max3[0]);
  min3[0] = mathMin$9(x3, min3[0]);
  max3[0] = mathMax$9(x3, max3[0]);
  min3[1] = mathMin$9(y0, min3[1]);
  max3[1] = mathMax$9(y0, max3[1]);
  min3[1] = mathMin$9(y3, min3[1]);
  max3[1] = mathMax$9(y3, max3[1]);
}
function fromQuadratic(x0, y0, x1, y1, x2, y2, min3, max3) {
  var quadraticExtremum$1 = quadraticExtremum;
  var quadraticAt2 = quadraticAt$1;
  var tx = mathMax$9(mathMin$9(quadraticExtremum$1(x0, x1, x2), 1), 0);
  var ty = mathMax$9(mathMin$9(quadraticExtremum$1(y0, y1, y2), 1), 0);
  var x3 = quadraticAt2(x0, x1, x2, tx);
  var y3 = quadraticAt2(y0, y1, y2, ty);
  min3[0] = mathMin$9(x0, x2, x3);
  min3[1] = mathMin$9(y0, y2, y3);
  max3[0] = mathMax$9(x0, x2, x3);
  max3[1] = mathMax$9(y0, y2, y3);
}
function fromArc(x2, y2, rx, ry, startAngle, endAngle, anticlockwise, min3, max3) {
  var vec2Min = min$1;
  var vec2Max = max$1;
  var diff = Math.abs(startAngle - endAngle);
  if (diff % PI2$9 < 1e-4 && diff > 1e-4) {
    min3[0] = x2 - rx;
    min3[1] = y2 - ry;
    max3[0] = x2 + rx;
    max3[1] = y2 + ry;
    return;
  }
  start[0] = mathCos$4(startAngle) * rx + x2;
  start[1] = mathSin$4(startAngle) * ry + y2;
  end[0] = mathCos$4(endAngle) * rx + x2;
  end[1] = mathSin$4(endAngle) * ry + y2;
  vec2Min(min3, start, end);
  vec2Max(max3, start, end);
  startAngle = startAngle % PI2$9;
  if (startAngle < 0) {
    startAngle = startAngle + PI2$9;
  }
  endAngle = endAngle % PI2$9;
  if (endAngle < 0) {
    endAngle = endAngle + PI2$9;
  }
  if (startAngle > endAngle && !anticlockwise) {
    endAngle += PI2$9;
  } else if (startAngle < endAngle && anticlockwise) {
    startAngle += PI2$9;
  }
  if (anticlockwise) {
    var tmp = endAngle;
    endAngle = startAngle;
    startAngle = tmp;
  }
  for (var angle = 0; angle < endAngle; angle += Math.PI / 2) {
    if (angle > startAngle) {
      extremity[0] = mathCos$4(angle) * rx + x2;
      extremity[1] = mathSin$4(angle) * ry + y2;
      vec2Min(min3, extremity, min3);
      vec2Max(max3, extremity, max3);
    }
  }
}
var CMD$4 = {
  M: 1,
  L: 2,
  C: 3,
  Q: 4,
  A: 5,
  Z: 6,
  R: 7
};
var tmpOutX = [];
var tmpOutY = [];
var min = [];
var max = [];
var min2 = [];
var max2 = [];
var mathMin$8 = Math.min;
var mathMax$8 = Math.max;
var mathCos$3 = Math.cos;
var mathSin$3 = Math.sin;
var mathAbs$2 = Math.abs;
var PI$8 = Math.PI;
var PI2$8 = PI$8 * 2;
var hasTypedArray = typeof Float32Array !== "undefined";
var tmpAngles = [];
function modPI2(radian) {
  var n2 = Math.round(radian / PI$8 * 1e8) / 1e8;
  return n2 % 2 * PI$8;
}
function normalizeArcAngles(angles, anticlockwise) {
  var newStartAngle = modPI2(angles[0]);
  if (newStartAngle < 0) {
    newStartAngle += PI2$8;
  }
  var delta = newStartAngle - angles[0];
  var newEndAngle = angles[1];
  newEndAngle += delta;
  if (!anticlockwise && newEndAngle - newStartAngle >= PI2$8) {
    newEndAngle = newStartAngle + PI2$8;
  } else if (anticlockwise && newStartAngle - newEndAngle >= PI2$8) {
    newEndAngle = newStartAngle - PI2$8;
  } else if (!anticlockwise && newStartAngle > newEndAngle) {
    newEndAngle = newStartAngle + (PI2$8 - modPI2(newStartAngle - newEndAngle));
  } else if (anticlockwise && newStartAngle < newEndAngle) {
    newEndAngle = newStartAngle - (PI2$8 - modPI2(newEndAngle - newStartAngle));
  }
  angles[0] = newStartAngle;
  angles[1] = newEndAngle;
}
var PathProxy = function() {
  function PathProxy2(notSaveData) {
    this.dpr = 1;
    this._xi = 0;
    this._yi = 0;
    this._x0 = 0;
    this._y0 = 0;
    this._len = 0;
    if (notSaveData) {
      this._saveData = false;
    }
    if (this._saveData) {
      this.data = [];
    }
  }
  PathProxy2.prototype.increaseVersion = function() {
    this._version++;
  };
  PathProxy2.prototype.getVersion = function() {
    return this._version;
  };
  PathProxy2.prototype.setScale = function(sx, sy, segmentIgnoreThreshold) {
    segmentIgnoreThreshold = segmentIgnoreThreshold || 0;
    if (segmentIgnoreThreshold > 0) {
      this._ux = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sx) || 0;
      this._uy = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sy) || 0;
    }
  };
  PathProxy2.prototype.setDPR = function(dpr2) {
    this.dpr = dpr2;
  };
  PathProxy2.prototype.setContext = function(ctx) {
    this._ctx = ctx;
  };
  PathProxy2.prototype.getContext = function() {
    return this._ctx;
  };
  PathProxy2.prototype.beginPath = function() {
    this._ctx && this._ctx.beginPath();
    this.reset();
    return this;
  };
  PathProxy2.prototype.reset = function() {
    if (this._saveData) {
      this._len = 0;
    }
    if (this._pathSegLen) {
      this._pathSegLen = null;
      this._pathLen = 0;
    }
    this._version++;
  };
  PathProxy2.prototype.moveTo = function(x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.M, x2, y2);
    this._ctx && this._ctx.moveTo(x2, y2);
    this._x0 = x2;
    this._y0 = y2;
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.lineTo = function(x2, y2) {
    var dx = mathAbs$2(x2 - this._xi);
    var dy = mathAbs$2(y2 - this._yi);
    var exceedUnit = dx > this._ux || dy > this._uy;
    this.addData(CMD$4.L, x2, y2);
    if (this._ctx && exceedUnit) {
      this._ctx.lineTo(x2, y2);
    }
    if (exceedUnit) {
      this._xi = x2;
      this._yi = y2;
      this._pendingPtDist = 0;
    } else {
      var d2 = dx * dx + dy * dy;
      if (d2 > this._pendingPtDist) {
        this._pendingPtX = x2;
        this._pendingPtY = y2;
        this._pendingPtDist = d2;
      }
    }
    return this;
  };
  PathProxy2.prototype.bezierCurveTo = function(x1, y1, x2, y2, x3, y3) {
    this._drawPendingPt();
    this.addData(CMD$4.C, x1, y1, x2, y2, x3, y3);
    if (this._ctx) {
      this._ctx.bezierCurveTo(x1, y1, x2, y2, x3, y3);
    }
    this._xi = x3;
    this._yi = y3;
    return this;
  };
  PathProxy2.prototype.quadraticCurveTo = function(x1, y1, x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.Q, x1, y1, x2, y2);
    if (this._ctx) {
      this._ctx.quadraticCurveTo(x1, y1, x2, y2);
    }
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this._drawPendingPt();
    tmpAngles[0] = startAngle;
    tmpAngles[1] = endAngle;
    normalizeArcAngles(tmpAngles, anticlockwise);
    startAngle = tmpAngles[0];
    endAngle = tmpAngles[1];
    var delta = endAngle - startAngle;
    this.addData(CMD$4.A, cx, cy, r2, r2, startAngle, delta, 0, anticlockwise ? 0 : 1);
    this._ctx && this._ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
    this._xi = mathCos$3(endAngle) * r2 + cx;
    this._yi = mathSin$3(endAngle) * r2 + cy;
    return this;
  };
  PathProxy2.prototype.arcTo = function(x1, y1, x2, y2, radius) {
    this._drawPendingPt();
    if (this._ctx) {
      this._ctx.arcTo(x1, y1, x2, y2, radius);
    }
    return this;
  };
  PathProxy2.prototype.rect = function(x2, y2, w2, h) {
    this._drawPendingPt();
    this._ctx && this._ctx.rect(x2, y2, w2, h);
    this.addData(CMD$4.R, x2, y2, w2, h);
    return this;
  };
  PathProxy2.prototype.closePath = function() {
    this._drawPendingPt();
    this.addData(CMD$4.Z);
    var ctx = this._ctx;
    var x0 = this._x0;
    var y0 = this._y0;
    if (ctx) {
      ctx.closePath();
    }
    this._xi = x0;
    this._yi = y0;
    return this;
  };
  PathProxy2.prototype.fill = function(ctx) {
    ctx && ctx.fill();
    this.toStatic();
  };
  PathProxy2.prototype.stroke = function(ctx) {
    ctx && ctx.stroke();
    this.toStatic();
  };
  PathProxy2.prototype.len = function() {
    return this._len;
  };
  PathProxy2.prototype.setData = function(data) {
    var len2 = data.length;
    if (!(this.data && this.data.length === len2) && hasTypedArray) {
      this.data = new Float32Array(len2);
    }
    for (var i = 0; i < len2; i++) {
      this.data[i] = data[i];
    }
    this._len = len2;
  };
  PathProxy2.prototype.appendPath = function(path) {
    if (!(path instanceof Array)) {
      path = [path];
    }
    var len2 = path.length;
    var appendSize = 0;
    var offset2 = this._len;
    for (var i = 0; i < len2; i++) {
      appendSize += path[i].len();
    }
    if (hasTypedArray && this.data instanceof Float32Array) {
      this.data = new Float32Array(offset2 + appendSize);
    }
    for (var i = 0; i < len2; i++) {
      var appendPathData = path[i].data;
      for (var k2 = 0; k2 < appendPathData.length; k2++) {
        this.data[offset2++] = appendPathData[k2];
      }
    }
    this._len = offset2;
  };
  PathProxy2.prototype.addData = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    if (!this._saveData) {
      return;
    }
    var data = this.data;
    if (this._len + arguments.length > data.length) {
      this._expandData();
      data = this.data;
    }
    for (var i = 0; i < arguments.length; i++) {
      data[this._len++] = arguments[i];
    }
  };
  PathProxy2.prototype._drawPendingPt = function() {
    if (this._pendingPtDist > 0) {
      this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY);
      this._pendingPtDist = 0;
    }
  };
  PathProxy2.prototype._expandData = function() {
    if (!(this.data instanceof Array)) {
      var newData = [];
      for (var i = 0; i < this._len; i++) {
        newData[i] = this.data[i];
      }
      this.data = newData;
    }
  };
  PathProxy2.prototype.toStatic = function() {
    if (!this._saveData) {
      return;
    }
    this._drawPendingPt();
    var data = this.data;
    if (data instanceof Array) {
      data.length = this._len;
      if (hasTypedArray && this._len > 11) {
        this.data = new Float32Array(data);
      }
    }
  };
  PathProxy2.prototype.getBoundingRect = function() {
    min[0] = min[1] = min2[0] = min2[1] = Number.MAX_VALUE;
    max[0] = max[1] = max2[0] = max2[1] = -Number.MAX_VALUE;
    var data = this.data;
    var xi2 = 0;
    var yi2 = 0;
    var x0 = 0;
    var y0 = 0;
    var i;
    for (i = 0; i < this._len; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi2 = data[i];
        yi2 = data[i + 1];
        x0 = xi2;
        y0 = yi2;
      }
      switch (cmd) {
        case CMD$4.M:
          xi2 = x0 = data[i++];
          yi2 = y0 = data[i++];
          min2[0] = x0;
          min2[1] = y0;
          max2[0] = x0;
          max2[1] = y0;
          break;
        case CMD$4.L:
          fromLine(xi2, yi2, data[i], data[i + 1], min2, max2);
          xi2 = data[i++];
          yi2 = data[i++];
          break;
        case CMD$4.C:
          fromCubic(xi2, yi2, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi2 = data[i++];
          yi2 = data[i++];
          break;
        case CMD$4.Q:
          fromQuadratic(xi2, yi2, data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi2 = data[i++];
          yi2 = data[i++];
          break;
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var endAngle = data[i++] + startAngle;
          i += 1;
          var anticlockwise = !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          fromArc(cx, cy, rx, ry, startAngle, endAngle, anticlockwise, min2, max2);
          xi2 = mathCos$3(endAngle) * rx + cx;
          yi2 = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R:
          x0 = xi2 = data[i++];
          y0 = yi2 = data[i++];
          var width = data[i++];
          var height = data[i++];
          fromLine(x0, y0, x0 + width, y0 + height, min2, max2);
          break;
        case CMD$4.Z:
          xi2 = x0;
          yi2 = y0;
          break;
      }
      min$1(min, min, min2);
      max$1(max, max, max2);
    }
    if (i === 0) {
      min[0] = min[1] = max[0] = max[1] = 0;
    }
    return new BoundingRect$1(min[0], min[1], max[0] - min[0], max[1] - min[1]);
  };
  PathProxy2.prototype._calculateLength = function() {
    var data = this.data;
    var len2 = this._len;
    var ux = this._ux;
    var uy = this._uy;
    var xi2 = 0;
    var yi2 = 0;
    var x0 = 0;
    var y0 = 0;
    if (!this._pathSegLen) {
      this._pathSegLen = [];
    }
    var pathSegLen = this._pathSegLen;
    var pathTotalLen = 0;
    var segCount = 0;
    for (var i = 0; i < len2; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi2 = data[i];
        yi2 = data[i + 1];
        x0 = xi2;
        y0 = yi2;
      }
      var l2 = -1;
      switch (cmd) {
        case CMD$4.M:
          xi2 = x0 = data[i++];
          yi2 = y0 = data[i++];
          break;
        case CMD$4.L: {
          var x2 = data[i++];
          var y2 = data[i++];
          var dx = x2 - xi2;
          var dy = y2 - yi2;
          if (mathAbs$2(dx) > ux || mathAbs$2(dy) > uy || i === len2 - 1) {
            l2 = Math.sqrt(dx * dx + dy * dy);
            xi2 = x2;
            yi2 = y2;
          }
          break;
        }
        case CMD$4.C: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          var x3 = data[i++];
          var y3 = data[i++];
          l2 = cubicLength(xi2, yi2, x1, y1, x2, y2, x3, y3, 10);
          xi2 = x3;
          yi2 = y3;
          break;
        }
        case CMD$4.Q: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          l2 = quadraticLength(xi2, yi2, x1, y1, x2, y2, 10);
          xi2 = x2;
          yi2 = y2;
          break;
        }
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var delta = data[i++];
          var endAngle = delta + startAngle;
          i += 1;
          !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          l2 = mathMax$8(rx, ry) * mathMin$8(PI2$8, Math.abs(delta));
          xi2 = mathCos$3(endAngle) * rx + cx;
          yi2 = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R: {
          x0 = xi2 = data[i++];
          y0 = yi2 = data[i++];
          var width = data[i++];
          var height = data[i++];
          l2 = width * 2 + height * 2;
          break;
        }
        case CMD$4.Z: {
          var dx = x0 - xi2;
          var dy = y0 - yi2;
          l2 = Math.sqrt(dx * dx + dy * dy);
          xi2 = x0;
          yi2 = y0;
          break;
        }
      }
      if (l2 >= 0) {
        pathSegLen[segCount++] = l2;
        pathTotalLen += l2;
      }
    }
    this._pathLen = pathTotalLen;
    return pathTotalLen;
  };
  PathProxy2.prototype.rebuildPath = function(ctx, percent) {
    var d2 = this.data;
    var ux = this._ux;
    var uy = this._uy;
    var len2 = this._len;
    var x0;
    var y0;
    var xi2;
    var yi2;
    var x2;
    var y2;
    var drawPart = percent < 1;
    var pathSegLen;
    var pathTotalLen;
    var accumLength = 0;
    var segCount = 0;
    var displayedLength;
    var pendingPtDist = 0;
    var pendingPtX;
    var pendingPtY;
    if (drawPart) {
      if (!this._pathSegLen) {
        this._calculateLength();
      }
      pathSegLen = this._pathSegLen;
      pathTotalLen = this._pathLen;
      displayedLength = percent * pathTotalLen;
      if (!displayedLength) {
        return;
      }
    }
    lo:
      for (var i = 0; i < len2; ) {
        var cmd = d2[i++];
        var isFirst = i === 1;
        if (isFirst) {
          xi2 = d2[i];
          yi2 = d2[i + 1];
          x0 = xi2;
          y0 = yi2;
        }
        if (cmd !== CMD$4.L && pendingPtDist > 0) {
          ctx.lineTo(pendingPtX, pendingPtY);
          pendingPtDist = 0;
        }
        switch (cmd) {
          case CMD$4.M:
            x0 = xi2 = d2[i++];
            y0 = yi2 = d2[i++];
            ctx.moveTo(xi2, yi2);
            break;
          case CMD$4.L: {
            x2 = d2[i++];
            y2 = d2[i++];
            var dx = mathAbs$2(x2 - xi2);
            var dy = mathAbs$2(y2 - yi2);
            if (dx > ux || dy > uy) {
              if (drawPart) {
                var l2 = pathSegLen[segCount++];
                if (accumLength + l2 > displayedLength) {
                  var t2 = (displayedLength - accumLength) / l2;
                  ctx.lineTo(xi2 * (1 - t2) + x2 * t2, yi2 * (1 - t2) + y2 * t2);
                  break lo;
                }
                accumLength += l2;
              }
              ctx.lineTo(x2, y2);
              xi2 = x2;
              yi2 = y2;
              pendingPtDist = 0;
            } else {
              var d22 = dx * dx + dy * dy;
              if (d22 > pendingPtDist) {
                pendingPtX = x2;
                pendingPtY = y2;
                pendingPtDist = d22;
              }
            }
            break;
          }
          case CMD$4.C: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            var x3 = d2[i++];
            var y3 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                cubicSubdivide(xi2, x1, x22, x3, t2, tmpOutX);
                cubicSubdivide(yi2, y1, y22, y3, t2, tmpOutY);
                ctx.bezierCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2], tmpOutX[3], tmpOutY[3]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.bezierCurveTo(x1, y1, x22, y22, x3, y3);
            xi2 = x3;
            yi2 = y3;
            break;
          }
          case CMD$4.Q: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                quadraticSubdivide(xi2, x1, x22, t2, tmpOutX);
                quadraticSubdivide(yi2, y1, y22, t2, tmpOutY);
                ctx.quadraticCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.quadraticCurveTo(x1, y1, x22, y22);
            xi2 = x22;
            yi2 = y22;
            break;
          }
          case CMD$4.A:
            var cx = d2[i++];
            var cy = d2[i++];
            var rx = d2[i++];
            var ry = d2[i++];
            var startAngle = d2[i++];
            var delta = d2[i++];
            var psi = d2[i++];
            var anticlockwise = !d2[i++];
            var r2 = rx > ry ? rx : ry;
            var isEllipse = mathAbs$2(rx - ry) > 1e-3;
            var endAngle = startAngle + delta;
            var breakBuild = false;
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                endAngle = startAngle + delta * (displayedLength - accumLength) / l2;
                breakBuild = true;
              }
              accumLength += l2;
            }
            if (isEllipse && ctx.ellipse) {
              ctx.ellipse(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise);
            } else {
              ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
            }
            if (breakBuild) {
              break lo;
            }
            if (isFirst) {
              x0 = mathCos$3(startAngle) * rx + cx;
              y0 = mathSin$3(startAngle) * ry + cy;
            }
            xi2 = mathCos$3(endAngle) * rx + cx;
            yi2 = mathSin$3(endAngle) * ry + cy;
            break;
          case CMD$4.R:
            x0 = xi2 = d2[i];
            y0 = yi2 = d2[i + 1];
            x2 = d2[i++];
            y2 = d2[i++];
            var width = d2[i++];
            var height = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var d_1 = displayedLength - accumLength;
                ctx.moveTo(x2, y2);
                ctx.lineTo(x2 + mathMin$8(d_1, width), y2);
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + width, y2 + mathMin$8(d_1, height));
                }
                d_1 -= height;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + mathMax$8(width - d_1, 0), y2 + height);
                }
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2, y2 + mathMax$8(height - d_1, 0));
                }
                break lo;
              }
              accumLength += l2;
            }
            ctx.rect(x2, y2, width, height);
            break;
          case CMD$4.Z:
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                ctx.lineTo(xi2 * (1 - t2) + x0 * t2, yi2 * (1 - t2) + y0 * t2);
                break lo;
              }
              accumLength += l2;
            }
            ctx.closePath();
            xi2 = x0;
            yi2 = y0;
        }
      }
  };
  PathProxy2.prototype.clone = function() {
    var newProxy = new PathProxy2();
    var data = this.data;
    newProxy.data = data.slice ? data.slice() : Array.prototype.slice.call(data);
    newProxy._len = this._len;
    return newProxy;
  };
  PathProxy2.CMD = CMD$4;
  PathProxy2.initDefaultProps = function() {
    var proto2 = PathProxy2.prototype;
    proto2._saveData = true;
    proto2._ux = 0;
    proto2._uy = 0;
    proto2._pendingPtDist = 0;
    proto2._version = 0;
  }();
  return PathProxy2;
}();
var PathProxy$1 = PathProxy;
function containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  var _a2 = 0;
  var _b2 = x0;
  if (y2 > y0 + _l && y2 > y1 + _l || y2 < y0 - _l && y2 < y1 - _l || x2 > x0 + _l && x2 > x1 + _l || x2 < x0 - _l && x2 < x1 - _l) {
    return false;
  }
  if (x0 !== x1) {
    _a2 = (y0 - y1) / (x0 - x1);
    _b2 = (x0 * y1 - x1 * y0) / (x0 - x1);
  } else {
    return Math.abs(x2 - x0) <= _l / 2;
  }
  var tmp = _a2 * x2 - y2 + _b2;
  var _s = tmp * tmp / (_a2 * _a2 + 1);
  return _s <= _l / 2 * _l / 2;
}
function containStroke$3(x0, y0, x1, y1, x2, y2, x3, y3, lineWidth, x4, y4) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y4 > y0 + _l && y4 > y1 + _l && y4 > y2 + _l && y4 > y3 + _l || y4 < y0 - _l && y4 < y1 - _l && y4 < y2 - _l && y4 < y3 - _l || x4 > x0 + _l && x4 > x1 + _l && x4 > x2 + _l && x4 > x3 + _l || x4 < x0 - _l && x4 < x1 - _l && x4 < x2 - _l && x4 < x3 - _l) {
    return false;
  }
  var d2 = cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, null);
  return d2 <= _l / 2;
}
function containStroke$2(x0, y0, x1, y1, x2, y2, lineWidth, x3, y3) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y3 > y0 + _l && y3 > y1 + _l && y3 > y2 + _l || y3 < y0 - _l && y3 < y1 - _l && y3 < y2 - _l || x3 > x0 + _l && x3 > x1 + _l && x3 > x2 + _l || x3 < x0 - _l && x3 < x1 - _l && x3 < x2 - _l) {
    return false;
  }
  var d2 = quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, null);
  return d2 <= _l / 2;
}
var PI2$7 = Math.PI * 2;
function normalizeRadian(angle) {
  angle %= PI2$7;
  if (angle < 0) {
    angle += PI2$7;
  }
  return angle;
}
var PI2$6 = Math.PI * 2;
function containStroke$1(cx, cy, r2, startAngle, endAngle, anticlockwise, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  if (d2 - _l > r2 || d2 + _l < r2) {
    return false;
  }
  if (Math.abs(startAngle - endAngle) % PI2$6 < 1e-4) {
    return true;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$6;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$6;
  }
  return angle >= startAngle && angle <= endAngle || angle + PI2$6 >= startAngle && angle + PI2$6 <= endAngle;
}
function windingLine(x0, y0, x1, y1, x2, y2) {
  if (y2 > y0 && y2 > y1 || y2 < y0 && y2 < y1) {
    return 0;
  }
  if (y1 === y0) {
    return 0;
  }
  var t2 = (y2 - y0) / (y1 - y0);
  var dir3 = y1 < y0 ? 1 : -1;
  if (t2 === 1 || t2 === 0) {
    dir3 = y1 < y0 ? 0.5 : -0.5;
  }
  var x_ = t2 * (x1 - x0) + x0;
  return x_ === x2 ? Infinity : x_ > x2 ? dir3 : 0;
}
var CMD$3 = PathProxy$1.CMD;
var PI2$5 = Math.PI * 2;
var EPSILON$1 = 1e-4;
function isAroundEqual$1(a, b2) {
  return Math.abs(a - b2) < EPSILON$1;
}
var roots = [-1, -1, -1];
var extrema = [-1, -1];
function swapExtrema() {
  var tmp = extrema[0];
  extrema[0] = extrema[1];
  extrema[1] = tmp;
}
function windingCubic(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4) {
  if (y4 > y0 && y4 > y1 && y4 > y2 && y4 > y3 || y4 < y0 && y4 < y1 && y4 < y2 && y4 < y3) {
    return 0;
  }
  var nRoots = cubicRootAt(y0, y1, y2, y3, y4, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var w2 = 0;
    var nExtrema = -1;
    var y0_ = void 0;
    var y1_ = void 0;
    for (var i = 0; i < nRoots; i++) {
      var t2 = roots[i];
      var unit = t2 === 0 || t2 === 1 ? 0.5 : 1;
      var x_ = cubicAt(x0, x1, x2, x3, t2);
      if (x_ < x4) {
        continue;
      }
      if (nExtrema < 0) {
        nExtrema = cubicExtrema(y0, y1, y2, y3, extrema);
        if (extrema[1] < extrema[0] && nExtrema > 1) {
          swapExtrema();
        }
        y0_ = cubicAt(y0, y1, y2, y3, extrema[0]);
        if (nExtrema > 1) {
          y1_ = cubicAt(y0, y1, y2, y3, extrema[1]);
        }
      }
      if (nExtrema === 2) {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else if (t2 < extrema[1]) {
          w2 += y1_ < y0_ ? unit : -unit;
        } else {
          w2 += y3 < y1_ ? unit : -unit;
        }
      } else {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else {
          w2 += y3 < y0_ ? unit : -unit;
        }
      }
    }
    return w2;
  }
}
function windingQuadratic(x0, y0, x1, y1, x2, y2, x3, y3) {
  if (y3 > y0 && y3 > y1 && y3 > y2 || y3 < y0 && y3 < y1 && y3 < y2) {
    return 0;
  }
  var nRoots = quadraticRootAt(y0, y1, y2, y3, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var t2 = quadraticExtremum(y0, y1, y2);
    if (t2 >= 0 && t2 <= 1) {
      var w2 = 0;
      var y_ = quadraticAt$1(y0, y1, y2, t2);
      for (var i = 0; i < nRoots; i++) {
        var unit = roots[i] === 0 || roots[i] === 1 ? 0.5 : 1;
        var x_ = quadraticAt$1(x0, x1, x2, roots[i]);
        if (x_ < x3) {
          continue;
        }
        if (roots[i] < t2) {
          w2 += y_ < y0 ? unit : -unit;
        } else {
          w2 += y2 < y_ ? unit : -unit;
        }
      }
      return w2;
    } else {
      var unit = roots[0] === 0 || roots[0] === 1 ? 0.5 : 1;
      var x_ = quadraticAt$1(x0, x1, x2, roots[0]);
      if (x_ < x3) {
        return 0;
      }
      return y2 < y0 ? unit : -unit;
    }
  }
}
function windingArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2) {
  y2 -= cy;
  if (y2 > r2 || y2 < -r2) {
    return 0;
  }
  var tmp = Math.sqrt(r2 * r2 - y2 * y2);
  roots[0] = -tmp;
  roots[1] = tmp;
  var dTheta = Math.abs(startAngle - endAngle);
  if (dTheta < 1e-4) {
    return 0;
  }
  if (dTheta >= PI2$5 - 1e-4) {
    startAngle = 0;
    endAngle = PI2$5;
    var dir3 = anticlockwise ? 1 : -1;
    if (x2 >= roots[0] + cx && x2 <= roots[1] + cx) {
      return dir3;
    } else {
      return 0;
    }
  }
  if (startAngle > endAngle) {
    var tmp_1 = startAngle;
    startAngle = endAngle;
    endAngle = tmp_1;
  }
  if (startAngle < 0) {
    startAngle += PI2$5;
    endAngle += PI2$5;
  }
  var w2 = 0;
  for (var i = 0; i < 2; i++) {
    var x_ = roots[i];
    if (x_ + cx > x2) {
      var angle = Math.atan2(y2, x_);
      var dir3 = anticlockwise ? 1 : -1;
      if (angle < 0) {
        angle = PI2$5 + angle;
      }
      if (angle >= startAngle && angle <= endAngle || angle + PI2$5 >= startAngle && angle + PI2$5 <= endAngle) {
        if (angle > Math.PI / 2 && angle < Math.PI * 1.5) {
          dir3 = -dir3;
        }
        w2 += dir3;
      }
    }
  }
  return w2;
}
function containPath(path, lineWidth, isStroke, x2, y2) {
  var data = path.data;
  var len2 = path.len();
  var w2 = 0;
  var xi2 = 0;
  var yi2 = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (cmd === CMD$3.M && i > 1) {
      if (!isStroke) {
        w2 += windingLine(xi2, yi2, x0, y0, x2, y2);
      }
    }
    if (isFirst) {
      xi2 = data[i];
      yi2 = data[i + 1];
      x0 = xi2;
      y0 = yi2;
    }
    switch (cmd) {
      case CMD$3.M:
        x0 = data[i++];
        y0 = data[i++];
        xi2 = x0;
        yi2 = y0;
        break;
      case CMD$3.L:
        if (isStroke) {
          if (containStroke$4(xi2, yi2, data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi2, yi2, data[i], data[i + 1], x2, y2) || 0;
        }
        xi2 = data[i++];
        yi2 = data[i++];
        break;
      case CMD$3.C:
        if (isStroke) {
          if (containStroke$3(xi2, yi2, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingCubic(xi2, yi2, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi2 = data[i++];
        yi2 = data[i++];
        break;
      case CMD$3.Q:
        if (isStroke) {
          if (containStroke$2(xi2, yi2, data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingQuadratic(xi2, yi2, data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi2 = data[i++];
        yi2 = data[i++];
        break;
      case CMD$3.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (!isFirst) {
          w2 += windingLine(xi2, yi2, x1, y1, x2, y2);
        } else {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        if (isStroke) {
          if (containStroke$1(cx, cy, ry, theta, theta + dTheta, anticlockwise, lineWidth, _x, y2)) {
            return true;
          }
        } else {
          w2 += windingArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2);
        }
        xi2 = Math.cos(theta + dTheta) * rx + cx;
        yi2 = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$3.R:
        x0 = xi2 = data[i++];
        y0 = yi2 = data[i++];
        var width = data[i++];
        var height = data[i++];
        x1 = x0 + width;
        y1 = y0 + height;
        if (isStroke) {
          if (containStroke$4(x0, y0, x1, y0, lineWidth, x2, y2) || containStroke$4(x1, y0, x1, y1, lineWidth, x2, y2) || containStroke$4(x1, y1, x0, y1, lineWidth, x2, y2) || containStroke$4(x0, y1, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(x1, y0, x1, y1, x2, y2);
          w2 += windingLine(x0, y1, x0, y0, x2, y2);
        }
        break;
      case CMD$3.Z:
        if (isStroke) {
          if (containStroke$4(xi2, yi2, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi2, yi2, x0, y0, x2, y2);
        }
        xi2 = x0;
        yi2 = y0;
        break;
    }
  }
  if (!isStroke && !isAroundEqual$1(yi2, y0)) {
    w2 += windingLine(xi2, yi2, x0, y0, x2, y2) || 0;
  }
  return w2 !== 0;
}
function contain$2(pathProxy, x2, y2) {
  return containPath(pathProxy, 0, false, x2, y2);
}
function containStroke(pathProxy, lineWidth, x2, y2) {
  return containPath(pathProxy, lineWidth, true, x2, y2);
}
var DEFAULT_PATH_STYLE = defaults({
  fill: "#000",
  stroke: null,
  strokePercent: 1,
  fillOpacity: 1,
  strokeOpacity: 1,
  lineDashOffset: 0,
  lineWidth: 1,
  lineCap: "butt",
  miterLimit: 10,
  strokeNoScale: false,
  strokeFirst: false
}, DEFAULT_COMMON_STYLE);
var DEFAULT_PATH_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    strokePercent: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineDashOffset: true,
    lineWidth: true,
    miterLimit: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var pathCopyParams = TRANSFORMABLE_PROPS.concat([
  "invisible",
  "culling",
  "z",
  "z2",
  "zlevel",
  "parent"
]);
var Path = function(_super) {
  __extends(Path2, _super);
  function Path2(opts) {
    return _super.call(this, opts) || this;
  }
  Path2.prototype.update = function() {
    var _this = this;
    _super.prototype.update.call(this);
    var style2 = this.style;
    if (style2.decal) {
      var decalEl = this._decalEl = this._decalEl || new Path2();
      if (decalEl.buildPath === Path2.prototype.buildPath) {
        decalEl.buildPath = function(ctx) {
          _this.buildPath(ctx, _this.shape);
        };
      }
      decalEl.silent = true;
      var decalElStyle = decalEl.style;
      for (var key in style2) {
        if (decalElStyle[key] !== style2[key]) {
          decalElStyle[key] = style2[key];
        }
      }
      decalElStyle.fill = style2.fill ? style2.decal : null;
      decalElStyle.decal = null;
      decalElStyle.shadowColor = null;
      style2.strokeFirst && (decalElStyle.stroke = null);
      for (var i = 0; i < pathCopyParams.length; ++i) {
        decalEl[pathCopyParams[i]] = this[pathCopyParams[i]];
      }
      decalEl.__dirty |= REDRAW_BIT;
    } else if (this._decalEl) {
      this._decalEl = null;
    }
  };
  Path2.prototype.getDecalElement = function() {
    return this._decalEl;
  };
  Path2.prototype._init = function(props) {
    var keysArr = keys(props);
    this.shape = this.getDefaultShape();
    var defaultStyle = this.getDefaultStyle();
    if (defaultStyle) {
      this.useStyle(defaultStyle);
    }
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      var value = props[key];
      if (key === "style") {
        if (!this.style) {
          this.useStyle(value);
        } else {
          extend(this.style, value);
        }
      } else if (key === "shape") {
        extend(this.shape, value);
      } else {
        _super.prototype.attrKV.call(this, key, value);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Path2.prototype.getDefaultStyle = function() {
    return null;
  };
  Path2.prototype.getDefaultShape = function() {
    return {};
  };
  Path2.prototype.canBeInsideText = function() {
    return this.hasFill();
  };
  Path2.prototype.getInsideTextFill = function() {
    var pathFill = this.style.fill;
    if (pathFill !== "none") {
      if (isString$1(pathFill)) {
        var fillLum = lum(pathFill, 0);
        if (fillLum > 0.5) {
          return DARK_LABEL_COLOR;
        } else if (fillLum > 0.2) {
          return LIGHTER_LABEL_COLOR;
        }
        return LIGHT_LABEL_COLOR;
      } else if (pathFill) {
        return LIGHT_LABEL_COLOR;
      }
    }
    return DARK_LABEL_COLOR;
  };
  Path2.prototype.getInsideTextStroke = function(textFill) {
    var pathFill = this.style.fill;
    if (isString$1(pathFill)) {
      var zr = this.__zr;
      var isDarkMode2 = !!(zr && zr.isDarkMode());
      var isDarkLabel = lum(textFill, 0) < DARK_MODE_THRESHOLD;
      if (isDarkMode2 === isDarkLabel) {
        return pathFill;
      }
    }
  };
  Path2.prototype.buildPath = function(ctx, shapeCfg, inBatch) {
  };
  Path2.prototype.pathUpdated = function() {
    this.__dirty &= ~SHAPE_CHANGED_BIT;
  };
  Path2.prototype.getUpdatedPathProxy = function(inBatch) {
    !this.path && this.createPathProxy();
    this.path.beginPath();
    this.buildPath(this.path, this.shape, inBatch);
    return this.path;
  };
  Path2.prototype.createPathProxy = function() {
    this.path = new PathProxy$1(false);
  };
  Path2.prototype.hasStroke = function() {
    var style2 = this.style;
    var stroke = style2.stroke;
    return !(stroke == null || stroke === "none" || !(style2.lineWidth > 0));
  };
  Path2.prototype.hasFill = function() {
    var style2 = this.style;
    var fill = style2.fill;
    return fill != null && fill !== "none";
  };
  Path2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    var style2 = this.style;
    var needsUpdateRect = !rect;
    if (needsUpdateRect) {
      var firstInvoke = false;
      if (!this.path) {
        firstInvoke = true;
        this.createPathProxy();
      }
      var path = this.path;
      if (firstInvoke || this.__dirty & SHAPE_CHANGED_BIT) {
        path.beginPath();
        this.buildPath(path, this.shape, false);
        this.pathUpdated();
      }
      rect = path.getBoundingRect();
    }
    this._rect = rect;
    if (this.hasStroke() && this.path && this.path.len() > 0) {
      var rectStroke = this._rectStroke || (this._rectStroke = rect.clone());
      if (this.__dirty || needsUpdateRect) {
        rectStroke.copy(rect);
        var lineScale = style2.strokeNoScale ? this.getLineScale() : 1;
        var w2 = style2.lineWidth;
        if (!this.hasFill()) {
          var strokeContainThreshold = this.strokeContainThreshold;
          w2 = Math.max(w2, strokeContainThreshold == null ? 4 : strokeContainThreshold);
        }
        if (lineScale > 1e-10) {
          rectStroke.width += w2 / lineScale;
          rectStroke.height += w2 / lineScale;
          rectStroke.x -= w2 / lineScale / 2;
          rectStroke.y -= w2 / lineScale / 2;
        }
      }
      return rectStroke;
    }
    return rect;
  };
  Path2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    var style2 = this.style;
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var pathProxy = this.path;
      if (this.hasStroke()) {
        var lineWidth = style2.lineWidth;
        var lineScale = style2.strokeNoScale ? this.getLineScale() : 1;
        if (lineScale > 1e-10) {
          if (!this.hasFill()) {
            lineWidth = Math.max(lineWidth, this.strokeContainThreshold);
          }
          if (containStroke(pathProxy, lineWidth / lineScale, x2, y2)) {
            return true;
          }
        }
      }
      if (this.hasFill()) {
        return contain$2(pathProxy, x2, y2);
      }
    }
    return false;
  };
  Path2.prototype.dirtyShape = function() {
    this.__dirty |= SHAPE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
    if (this._decalEl) {
      this._decalEl.dirtyShape();
    }
    this.markRedraw();
  };
  Path2.prototype.dirty = function() {
    this.dirtyStyle();
    this.dirtyShape();
  };
  Path2.prototype.animateShape = function(loop) {
    return this.animate("shape", loop);
  };
  Path2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else if (targetKey === "shape") {
      this.dirtyShape();
    } else {
      this.markRedraw();
    }
  };
  Path2.prototype.attrKV = function(key, value) {
    if (key === "shape") {
      this.setShape(value);
    } else {
      _super.prototype.attrKV.call(this, key, value);
    }
  };
  Path2.prototype.setShape = function(keyOrObj, value) {
    var shape = this.shape;
    if (!shape) {
      shape = this.shape = {};
    }
    if (typeof keyOrObj === "string") {
      shape[keyOrObj] = value;
    } else {
      extend(shape, keyOrObj);
    }
    this.dirtyShape();
    return this;
  };
  Path2.prototype.shapeChanged = function() {
    return !!(this.__dirty & SHAPE_CHANGED_BIT);
  };
  Path2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_PATH_STYLE, obj);
  };
  Path2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.shape && !normalState.shape) {
      normalState.shape = extend({}, this.shape);
    }
  };
  Path2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetShape;
    if (state && state.shape) {
      if (transition) {
        if (keepCurrentStates) {
          targetShape = state.shape;
        } else {
          targetShape = extend({}, normalState.shape);
          extend(targetShape, state.shape);
        }
      } else {
        targetShape = extend({}, keepCurrentStates ? this.shape : normalState.shape);
        extend(targetShape, state.shape);
      }
    } else if (needsRestoreToNormal) {
      targetShape = normalState.shape;
    }
    if (targetShape) {
      if (transition) {
        this.shape = extend({}, this.shape);
        var targetShapePrimaryProps = {};
        var shapeKeys = keys(targetShape);
        for (var i = 0; i < shapeKeys.length; i++) {
          var key = shapeKeys[i];
          if (typeof targetShape[key] === "object") {
            this.shape[key] = targetShape[key];
          } else {
            targetShapePrimaryProps[key] = targetShape[key];
          }
        }
        this._transitionState(stateName, {
          shape: targetShapePrimaryProps
        }, animationCfg);
      } else {
        this.shape = targetShape;
        this.dirtyShape();
      }
    }
  };
  Path2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedShape;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.shape) {
        mergedShape = mergedShape || {};
        this._mergeStyle(mergedShape, state.shape);
      }
    }
    if (mergedShape) {
      mergedState.shape = mergedShape;
    }
    return mergedState;
  };
  Path2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_PATH_ANIMATION_PROPS;
  };
  Path2.prototype.isZeroArea = function() {
    return false;
  };
  Path2.extend = function(defaultProps) {
    var Sub = function(_super2) {
      __extends(Sub2, _super2);
      function Sub2(opts) {
        var _this = _super2.call(this, opts) || this;
        defaultProps.init && defaultProps.init.call(_this, opts);
        return _this;
      }
      Sub2.prototype.getDefaultStyle = function() {
        return clone$4(defaultProps.style);
      };
      Sub2.prototype.getDefaultShape = function() {
        return clone$4(defaultProps.shape);
      };
      return Sub2;
    }(Path2);
    for (var key in defaultProps) {
      if (typeof defaultProps[key] === "function") {
        Sub.prototype[key] = defaultProps[key];
      }
    }
    return Sub;
  };
  Path2.initDefaultProps = function() {
    var pathProto = Path2.prototype;
    pathProto.type = "path";
    pathProto.strokeContainThreshold = 5;
    pathProto.segmentIgnoreThreshold = 0;
    pathProto.subPixelOptimize = false;
    pathProto.autoBatch = false;
    pathProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT | SHAPE_CHANGED_BIT;
  }();
  return Path2;
}(Displayable$1);
var Path$1 = Path;
var DEFAULT_TSPAN_STYLE = defaults({
  strokeFirst: true,
  font: DEFAULT_FONT,
  x: 0,
  y: 0,
  textAlign: "left",
  textBaseline: "top",
  miterLimit: 2
}, DEFAULT_PATH_STYLE);
var TSpan = function(_super) {
  __extends(TSpan2, _super);
  function TSpan2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  TSpan2.prototype.hasStroke = function() {
    var style2 = this.style;
    var stroke = style2.stroke;
    return stroke != null && stroke !== "none" && style2.lineWidth > 0;
  };
  TSpan2.prototype.hasFill = function() {
    var style2 = this.style;
    var fill = style2.fill;
    return fill != null && fill !== "none";
  };
  TSpan2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_TSPAN_STYLE, obj);
  };
  TSpan2.prototype.setBoundingRect = function(rect) {
    this._rect = rect;
  };
  TSpan2.prototype.getBoundingRect = function() {
    var style2 = this.style;
    if (!this._rect) {
      var text = style2.text;
      text != null ? text += "" : text = "";
      var rect = getBoundingRect(text, style2.font, style2.textAlign, style2.textBaseline);
      rect.x += style2.x || 0;
      rect.y += style2.y || 0;
      if (this.hasStroke()) {
        var w2 = style2.lineWidth;
        rect.x -= w2 / 2;
        rect.y -= w2 / 2;
        rect.width += w2;
        rect.height += w2;
      }
      this._rect = rect;
    }
    return this._rect;
  };
  TSpan2.initDefaultProps = function() {
    var tspanProto = TSpan2.prototype;
    tspanProto.dirtyRectTolerance = 10;
  }();
  return TSpan2;
}(Displayable$1);
TSpan.prototype.type = "tspan";
var TSpan$1 = TSpan;
var DEFAULT_IMAGE_STYLE = defaults({
  x: 0,
  y: 0
}, DEFAULT_COMMON_STYLE);
var DEFAULT_IMAGE_ANIMATION_PROPS = {
  style: defaults({
    x: true,
    y: true,
    width: true,
    height: true,
    sx: true,
    sy: true,
    sWidth: true,
    sHeight: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
function isImageLike$1(source) {
  return !!(source && typeof source !== "string" && source.width && source.height);
}
var ZRImage = function(_super) {
  __extends(ZRImage2, _super);
  function ZRImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ZRImage2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_IMAGE_STYLE, obj);
  };
  ZRImage2.prototype._getSize = function(dim) {
    var style2 = this.style;
    var size = style2[dim];
    if (size != null) {
      return size;
    }
    var imageSource = isImageLike$1(style2.image) ? style2.image : this.__image;
    if (!imageSource) {
      return 0;
    }
    var otherDim = dim === "width" ? "height" : "width";
    var otherDimSize = style2[otherDim];
    if (otherDimSize == null) {
      return imageSource[dim];
    } else {
      return imageSource[dim] / imageSource[otherDim] * otherDimSize;
    }
  };
  ZRImage2.prototype.getWidth = function() {
    return this._getSize("width");
  };
  ZRImage2.prototype.getHeight = function() {
    return this._getSize("height");
  };
  ZRImage2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_IMAGE_ANIMATION_PROPS;
  };
  ZRImage2.prototype.getBoundingRect = function() {
    var style2 = this.style;
    if (!this._rect) {
      this._rect = new BoundingRect$1(style2.x || 0, style2.y || 0, this.getWidth(), this.getHeight());
    }
    return this._rect;
  };
  return ZRImage2;
}(Displayable$1);
ZRImage.prototype.type = "image";
var ZRImage$1 = ZRImage;
function buildPath$2(ctx, shape) {
  var x2 = shape.x;
  var y2 = shape.y;
  var width = shape.width;
  var height = shape.height;
  var r2 = shape.r;
  var r1;
  var r22;
  var r3;
  var r4;
  if (width < 0) {
    x2 = x2 + width;
    width = -width;
  }
  if (height < 0) {
    y2 = y2 + height;
    height = -height;
  }
  if (typeof r2 === "number") {
    r1 = r22 = r3 = r4 = r2;
  } else if (r2 instanceof Array) {
    if (r2.length === 1) {
      r1 = r22 = r3 = r4 = r2[0];
    } else if (r2.length === 2) {
      r1 = r3 = r2[0];
      r22 = r4 = r2[1];
    } else if (r2.length === 3) {
      r1 = r2[0];
      r22 = r4 = r2[1];
      r3 = r2[2];
    } else {
      r1 = r2[0];
      r22 = r2[1];
      r3 = r2[2];
      r4 = r2[3];
    }
  } else {
    r1 = r22 = r3 = r4 = 0;
  }
  var total;
  if (r1 + r22 > width) {
    total = r1 + r22;
    r1 *= width / total;
    r22 *= width / total;
  }
  if (r3 + r4 > width) {
    total = r3 + r4;
    r3 *= width / total;
    r4 *= width / total;
  }
  if (r22 + r3 > height) {
    total = r22 + r3;
    r22 *= height / total;
    r3 *= height / total;
  }
  if (r1 + r4 > height) {
    total = r1 + r4;
    r1 *= height / total;
    r4 *= height / total;
  }
  ctx.moveTo(x2 + r1, y2);
  ctx.lineTo(x2 + width - r22, y2);
  r22 !== 0 && ctx.arc(x2 + width - r22, y2 + r22, r22, -Math.PI / 2, 0);
  ctx.lineTo(x2 + width, y2 + height - r3);
  r3 !== 0 && ctx.arc(x2 + width - r3, y2 + height - r3, r3, 0, Math.PI / 2);
  ctx.lineTo(x2 + r4, y2 + height);
  r4 !== 0 && ctx.arc(x2 + r4, y2 + height - r4, r4, Math.PI / 2, Math.PI);
  ctx.lineTo(x2, y2 + r1);
  r1 !== 0 && ctx.arc(x2 + r1, y2 + r1, r1, Math.PI, Math.PI * 1.5);
}
var round$2 = Math.round;
function subPixelOptimizeLine$1(outputShape, inputShape, style2) {
  if (!inputShape) {
    return;
  }
  var x1 = inputShape.x1;
  var x2 = inputShape.x2;
  var y1 = inputShape.y1;
  var y2 = inputShape.y2;
  outputShape.x1 = x1;
  outputShape.x2 = x2;
  outputShape.y1 = y1;
  outputShape.y2 = y2;
  var lineWidth = style2 && style2.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  if (round$2(x1 * 2) === round$2(x2 * 2)) {
    outputShape.x1 = outputShape.x2 = subPixelOptimize$1(x1, lineWidth, true);
  }
  if (round$2(y1 * 2) === round$2(y2 * 2)) {
    outputShape.y1 = outputShape.y2 = subPixelOptimize$1(y1, lineWidth, true);
  }
  return outputShape;
}
function subPixelOptimizeRect$1(outputShape, inputShape, style2) {
  if (!inputShape) {
    return;
  }
  var originX = inputShape.x;
  var originY = inputShape.y;
  var originWidth = inputShape.width;
  var originHeight = inputShape.height;
  outputShape.x = originX;
  outputShape.y = originY;
  outputShape.width = originWidth;
  outputShape.height = originHeight;
  var lineWidth = style2 && style2.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  outputShape.x = subPixelOptimize$1(originX, lineWidth, true);
  outputShape.y = subPixelOptimize$1(originY, lineWidth, true);
  outputShape.width = Math.max(subPixelOptimize$1(originX + originWidth, lineWidth, false) - outputShape.x, originWidth === 0 ? 0 : 1);
  outputShape.height = Math.max(subPixelOptimize$1(originY + originHeight, lineWidth, false) - outputShape.y, originHeight === 0 ? 0 : 1);
  return outputShape;
}
function subPixelOptimize$1(position2, lineWidth, positiveOrNegative) {
  if (!lineWidth) {
    return position2;
  }
  var doubledPosition = round$2(position2 * 2);
  return (doubledPosition + round$2(lineWidth)) % 2 === 0 ? doubledPosition / 2 : (doubledPosition + (positiveOrNegative ? 1 : -1)) / 2;
}
var RectShape = function() {
  function RectShape2() {
    this.x = 0;
    this.y = 0;
    this.width = 0;
    this.height = 0;
  }
  return RectShape2;
}();
var subPixelOptimizeOutputShape$1 = {};
var Rect$2 = function(_super) {
  __extends(Rect2, _super);
  function Rect2(opts) {
    return _super.call(this, opts) || this;
  }
  Rect2.prototype.getDefaultShape = function() {
    return new RectShape();
  };
  Rect2.prototype.buildPath = function(ctx, shape) {
    var x2;
    var y2;
    var width;
    var height;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeRect$1(subPixelOptimizeOutputShape$1, shape, this.style);
      x2 = optimizedShape.x;
      y2 = optimizedShape.y;
      width = optimizedShape.width;
      height = optimizedShape.height;
      optimizedShape.r = shape.r;
      shape = optimizedShape;
    } else {
      x2 = shape.x;
      y2 = shape.y;
      width = shape.width;
      height = shape.height;
    }
    if (!shape.r) {
      ctx.rect(x2, y2, width, height);
    } else {
      buildPath$2(ctx, shape);
    }
  };
  Rect2.prototype.isZeroArea = function() {
    return !this.shape.width || !this.shape.height;
  };
  return Rect2;
}(Path$1);
Rect$2.prototype.type = "rect";
var Rect$3 = Rect$2;
var DEFAULT_RICH_TEXT_COLOR = {
  fill: "#000"
};
var DEFAULT_STROKE_LINE_WIDTH = 2;
var DEFAULT_TEXT_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineWidth: true,
    fontSize: true,
    lineHeight: true,
    width: true,
    height: true,
    textShadowColor: true,
    textShadowBlur: true,
    textShadowOffsetX: true,
    textShadowOffsetY: true,
    backgroundColor: true,
    padding: true,
    borderColor: true,
    borderWidth: true,
    borderRadius: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var ZRText = function(_super) {
  __extends(ZRText2, _super);
  function ZRText2(opts) {
    var _this = _super.call(this) || this;
    _this.type = "text";
    _this._children = [];
    _this._defaultStyle = DEFAULT_RICH_TEXT_COLOR;
    _this.attr(opts);
    return _this;
  }
  ZRText2.prototype.childrenRef = function() {
    return this._children;
  };
  ZRText2.prototype.update = function() {
    _super.prototype.update.call(this);
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.zlevel = this.zlevel;
      child.z = this.z;
      child.z2 = this.z2;
      child.culling = this.culling;
      child.cursor = this.cursor;
      child.invisible = this.invisible;
    }
  };
  ZRText2.prototype.updateTransform = function() {
    var innerTransformable = this.innerTransformable;
    if (innerTransformable) {
      innerTransformable.updateTransform();
      if (innerTransformable.transform) {
        this.transform = innerTransformable.transform;
      }
    } else {
      _super.prototype.updateTransform.call(this);
    }
  };
  ZRText2.prototype.getLocalTransform = function(m2) {
    var innerTransformable = this.innerTransformable;
    return innerTransformable ? innerTransformable.getLocalTransform(m2) : _super.prototype.getLocalTransform.call(this, m2);
  };
  ZRText2.prototype.getComputedTransform = function() {
    if (this.__hostTarget) {
      this.__hostTarget.getComputedTransform();
      this.__hostTarget.updateInnerText(true);
    }
    return _super.prototype.getComputedTransform.call(this);
  };
  ZRText2.prototype._updateSubTexts = function() {
    this._childCursor = 0;
    normalizeTextStyle(this.style);
    this.style.rich ? this._updateRichTexts() : this._updatePlainTexts();
    this._children.length = this._childCursor;
    this.styleUpdated();
  };
  ZRText2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = zr;
    }
  };
  ZRText2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = null;
    }
  };
  ZRText2.prototype.getBoundingRect = function() {
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    if (!this._rect) {
      var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
      var children = this._children;
      var tmpMat = [];
      var rect = null;
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        var childRect = child.getBoundingRect();
        var transform2 = child.getLocalTransform(tmpMat);
        if (transform2) {
          tmpRect2.copy(childRect);
          tmpRect2.applyTransform(transform2);
          rect = rect || tmpRect2.clone();
          rect.union(tmpRect2);
        } else {
          rect = rect || childRect.clone();
          rect.union(childRect);
        }
      }
      this._rect = rect || tmpRect2;
    }
    return this._rect;
  };
  ZRText2.prototype.setDefaultTextStyle = function(defaultTextStyle) {
    this._defaultStyle = defaultTextStyle || DEFAULT_RICH_TEXT_COLOR;
  };
  ZRText2.prototype.setTextContent = function(textContent) {
  };
  ZRText2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    if (!sourceStyle) {
      return targetStyle;
    }
    var sourceRich = sourceStyle.rich;
    var targetRich = targetStyle.rich || sourceRich && {};
    extend(targetStyle, sourceStyle);
    if (sourceRich && targetRich) {
      this._mergeRich(targetRich, sourceRich);
      targetStyle.rich = targetRich;
    } else if (targetRich) {
      targetStyle.rich = targetRich;
    }
    return targetStyle;
  };
  ZRText2.prototype._mergeRich = function(targetRich, sourceRich) {
    var richNames = keys(sourceRich);
    for (var i = 0; i < richNames.length; i++) {
      var richName = richNames[i];
      targetRich[richName] = targetRich[richName] || {};
      extend(targetRich[richName], sourceRich[richName]);
    }
  };
  ZRText2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_TEXT_ANIMATION_PROPS;
  };
  ZRText2.prototype._getOrCreateChild = function(Ctor) {
    var child = this._children[this._childCursor];
    if (!child || !(child instanceof Ctor)) {
      child = new Ctor();
    }
    this._children[this._childCursor++] = child;
    child.__zr = this.__zr;
    child.parent = this;
    return child;
  };
  ZRText2.prototype._updatePlainTexts = function() {
    var style2 = this.style;
    var textFont = style2.font || DEFAULT_FONT;
    var textPadding = style2.padding;
    var text = getStyleText(style2);
    var contentBlock = parsePlainText(text, style2);
    var needDrawBg = needDrawBackground(style2);
    var bgColorDrawn = !!style2.backgroundColor;
    var outerHeight = contentBlock.outerHeight;
    var outerWidth = contentBlock.outerWidth;
    var contentWidth = contentBlock.contentWidth;
    var textLines = contentBlock.lines;
    var lineHeight = contentBlock.lineHeight;
    var defaultStyle = this._defaultStyle;
    var baseX = style2.x || 0;
    var baseY = style2.y || 0;
    var textAlign = style2.align || defaultStyle.align || "left";
    var verticalAlign = style2.verticalAlign || defaultStyle.verticalAlign || "top";
    var textX = baseX;
    var textY = adjustTextY(baseY, contentBlock.contentHeight, verticalAlign);
    if (needDrawBg || textPadding) {
      var boxX = adjustTextX(baseX, outerWidth, textAlign);
      var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
      needDrawBg && this._renderBackground(style2, style2, boxX, boxY, outerWidth, outerHeight);
    }
    textY += lineHeight / 2;
    if (textPadding) {
      textX = getTextXForPadding(baseX, textAlign, textPadding);
      if (verticalAlign === "top") {
        textY += textPadding[0];
      } else if (verticalAlign === "bottom") {
        textY -= textPadding[2];
      }
    }
    var defaultLineWidth = 0;
    var useDefaultFill = false;
    var textFill = getFill("fill" in style2 ? style2.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in style2 ? style2.stroke : !bgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = style2.textShadowBlur > 0;
    var fixedBoundingRect = style2.width != null && (style2.overflow === "truncate" || style2.overflow === "break" || style2.overflow === "breakAll");
    var calculatedLineHeight = contentBlock.calculatedLineHeight;
    for (var i = 0; i < textLines.length; i++) {
      var el = this._getOrCreateChild(TSpan$1);
      var subElStyle = el.createStyle();
      el.useStyle(subElStyle);
      subElStyle.text = textLines[i];
      subElStyle.x = textX;
      subElStyle.y = textY;
      if (textAlign) {
        subElStyle.textAlign = textAlign;
      }
      subElStyle.textBaseline = "middle";
      subElStyle.opacity = style2.opacity;
      subElStyle.strokeFirst = true;
      if (hasShadow2) {
        subElStyle.shadowBlur = style2.textShadowBlur || 0;
        subElStyle.shadowColor = style2.textShadowColor || "transparent";
        subElStyle.shadowOffsetX = style2.textShadowOffsetX || 0;
        subElStyle.shadowOffsetY = style2.textShadowOffsetY || 0;
      }
      subElStyle.stroke = textStroke;
      subElStyle.fill = textFill;
      if (textStroke) {
        subElStyle.lineWidth = style2.lineWidth || defaultLineWidth;
        subElStyle.lineDash = style2.lineDash;
        subElStyle.lineDashOffset = style2.lineDashOffset || 0;
      }
      subElStyle.font = textFont;
      setSeparateFont(subElStyle, style2);
      textY += lineHeight;
      if (fixedBoundingRect) {
        el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, style2.width, subElStyle.textAlign), adjustTextY(subElStyle.y, calculatedLineHeight, subElStyle.textBaseline), contentWidth, calculatedLineHeight));
      }
    }
  };
  ZRText2.prototype._updateRichTexts = function() {
    var style2 = this.style;
    var text = getStyleText(style2);
    var contentBlock = parseRichText(text, style2);
    var contentWidth = contentBlock.width;
    var outerWidth = contentBlock.outerWidth;
    var outerHeight = contentBlock.outerHeight;
    var textPadding = style2.padding;
    var baseX = style2.x || 0;
    var baseY = style2.y || 0;
    var defaultStyle = this._defaultStyle;
    var textAlign = style2.align || defaultStyle.align;
    var verticalAlign = style2.verticalAlign || defaultStyle.verticalAlign;
    var boxX = adjustTextX(baseX, outerWidth, textAlign);
    var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
    var xLeft = boxX;
    var lineTop = boxY;
    if (textPadding) {
      xLeft += textPadding[3];
      lineTop += textPadding[0];
    }
    var xRight = xLeft + contentWidth;
    if (needDrawBackground(style2)) {
      this._renderBackground(style2, style2, boxX, boxY, outerWidth, outerHeight);
    }
    var bgColorDrawn = !!style2.backgroundColor;
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var tokens = line.tokens;
      var tokenCount = tokens.length;
      var lineHeight = line.lineHeight;
      var remainedWidth = line.width;
      var leftIndex = 0;
      var lineXLeft = xLeft;
      var lineXRight = xRight;
      var rightIndex = tokenCount - 1;
      var token = void 0;
      while (leftIndex < tokenCount && (token = tokens[leftIndex], !token.align || token.align === "left")) {
        this._placeToken(token, style2, lineHeight, lineTop, lineXLeft, "left", bgColorDrawn);
        remainedWidth -= token.width;
        lineXLeft += token.width;
        leftIndex++;
      }
      while (rightIndex >= 0 && (token = tokens[rightIndex], token.align === "right")) {
        this._placeToken(token, style2, lineHeight, lineTop, lineXRight, "right", bgColorDrawn);
        remainedWidth -= token.width;
        lineXRight -= token.width;
        rightIndex--;
      }
      lineXLeft += (contentWidth - (lineXLeft - xLeft) - (xRight - lineXRight) - remainedWidth) / 2;
      while (leftIndex <= rightIndex) {
        token = tokens[leftIndex];
        this._placeToken(token, style2, lineHeight, lineTop, lineXLeft + token.width / 2, "center", bgColorDrawn);
        lineXLeft += token.width;
        leftIndex++;
      }
      lineTop += lineHeight;
    }
  };
  ZRText2.prototype._placeToken = function(token, style2, lineHeight, lineTop, x2, textAlign, parentBgColorDrawn) {
    var tokenStyle = style2.rich[token.styleName] || {};
    tokenStyle.text = token.text;
    var verticalAlign = token.verticalAlign;
    var y2 = lineTop + lineHeight / 2;
    if (verticalAlign === "top") {
      y2 = lineTop + token.height / 2;
    } else if (verticalAlign === "bottom") {
      y2 = lineTop + lineHeight - token.height / 2;
    }
    var needDrawBg = !token.isLineHolder && needDrawBackground(tokenStyle);
    needDrawBg && this._renderBackground(tokenStyle, style2, textAlign === "right" ? x2 - token.width : textAlign === "center" ? x2 - token.width / 2 : x2, y2 - token.height / 2, token.width, token.height);
    var bgColorDrawn = !!tokenStyle.backgroundColor;
    var textPadding = token.textPadding;
    if (textPadding) {
      x2 = getTextXForPadding(x2, textAlign, textPadding);
      y2 -= token.height / 2 - textPadding[0] - token.innerHeight / 2;
    }
    var el = this._getOrCreateChild(TSpan$1);
    var subElStyle = el.createStyle();
    el.useStyle(subElStyle);
    var defaultStyle = this._defaultStyle;
    var useDefaultFill = false;
    var defaultLineWidth = 0;
    var textFill = getFill("fill" in tokenStyle ? tokenStyle.fill : "fill" in style2 ? style2.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in tokenStyle ? tokenStyle.stroke : "stroke" in style2 ? style2.stroke : !bgColorDrawn && !parentBgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = tokenStyle.textShadowBlur > 0 || style2.textShadowBlur > 0;
    subElStyle.text = token.text;
    subElStyle.x = x2;
    subElStyle.y = y2;
    if (hasShadow2) {
      subElStyle.shadowBlur = tokenStyle.textShadowBlur || style2.textShadowBlur || 0;
      subElStyle.shadowColor = tokenStyle.textShadowColor || style2.textShadowColor || "transparent";
      subElStyle.shadowOffsetX = tokenStyle.textShadowOffsetX || style2.textShadowOffsetX || 0;
      subElStyle.shadowOffsetY = tokenStyle.textShadowOffsetY || style2.textShadowOffsetY || 0;
    }
    subElStyle.textAlign = textAlign;
    subElStyle.textBaseline = "middle";
    subElStyle.font = token.font || DEFAULT_FONT;
    subElStyle.opacity = retrieve3(tokenStyle.opacity, style2.opacity, 1);
    setSeparateFont(subElStyle, tokenStyle);
    if (textStroke) {
      subElStyle.lineWidth = retrieve3(tokenStyle.lineWidth, style2.lineWidth, defaultLineWidth);
      subElStyle.lineDash = retrieve2(tokenStyle.lineDash, style2.lineDash);
      subElStyle.lineDashOffset = style2.lineDashOffset || 0;
      subElStyle.stroke = textStroke;
    }
    if (textFill) {
      subElStyle.fill = textFill;
    }
    var textWidth = token.contentWidth;
    var textHeight = token.contentHeight;
    el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, textWidth, subElStyle.textAlign), adjustTextY(subElStyle.y, textHeight, subElStyle.textBaseline), textWidth, textHeight));
  };
  ZRText2.prototype._renderBackground = function(style2, topStyle, x2, y2, width, height) {
    var textBackgroundColor = style2.backgroundColor;
    var textBorderWidth = style2.borderWidth;
    var textBorderColor = style2.borderColor;
    var isImageBg = textBackgroundColor && textBackgroundColor.image;
    var isPlainOrGradientBg = textBackgroundColor && !isImageBg;
    var textBorderRadius = style2.borderRadius;
    var self2 = this;
    var rectEl;
    var imgEl;
    if (isPlainOrGradientBg || style2.lineHeight || textBorderWidth && textBorderColor) {
      rectEl = this._getOrCreateChild(Rect$3);
      rectEl.useStyle(rectEl.createStyle());
      rectEl.style.fill = null;
      var rectShape = rectEl.shape;
      rectShape.x = x2;
      rectShape.y = y2;
      rectShape.width = width;
      rectShape.height = height;
      rectShape.r = textBorderRadius;
      rectEl.dirtyShape();
    }
    if (isPlainOrGradientBg) {
      var rectStyle = rectEl.style;
      rectStyle.fill = textBackgroundColor || null;
      rectStyle.fillOpacity = retrieve2(style2.fillOpacity, 1);
    } else if (isImageBg) {
      imgEl = this._getOrCreateChild(ZRImage$1);
      imgEl.onload = function() {
        self2.dirtyStyle();
      };
      var imgStyle = imgEl.style;
      imgStyle.image = textBackgroundColor.image;
      imgStyle.x = x2;
      imgStyle.y = y2;
      imgStyle.width = width;
      imgStyle.height = height;
    }
    if (textBorderWidth && textBorderColor) {
      var rectStyle = rectEl.style;
      rectStyle.lineWidth = textBorderWidth;
      rectStyle.stroke = textBorderColor;
      rectStyle.strokeOpacity = retrieve2(style2.strokeOpacity, 1);
      rectStyle.lineDash = style2.borderDash;
      rectStyle.lineDashOffset = style2.borderDashOffset || 0;
      rectEl.strokeContainThreshold = 0;
      if (rectEl.hasFill() && rectEl.hasStroke()) {
        rectStyle.strokeFirst = true;
        rectStyle.lineWidth *= 2;
      }
    }
    var commonStyle = (rectEl || imgEl).style;
    commonStyle.shadowBlur = style2.shadowBlur || 0;
    commonStyle.shadowColor = style2.shadowColor || "transparent";
    commonStyle.shadowOffsetX = style2.shadowOffsetX || 0;
    commonStyle.shadowOffsetY = style2.shadowOffsetY || 0;
    commonStyle.opacity = retrieve3(style2.opacity, topStyle.opacity, 1);
  };
  ZRText2.makeFont = function(style2) {
    var font = "";
    if (hasSeparateFont(style2)) {
      font = [
        style2.fontStyle,
        style2.fontWeight,
        parseFontSize(style2.fontSize),
        style2.fontFamily || "sans-serif"
      ].join(" ");
    }
    return font && trim$1(font) || style2.textFont || style2.font;
  };
  return ZRText2;
}(Displayable$1);
var VALID_TEXT_ALIGN = { left: true, right: 1, center: 1 };
var VALID_TEXT_VERTICAL_ALIGN = { top: 1, bottom: 1, middle: 1 };
var FONT_PARTS = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
function parseFontSize(fontSize) {
  if (typeof fontSize === "string" && (fontSize.indexOf("px") !== -1 || fontSize.indexOf("rem") !== -1 || fontSize.indexOf("em") !== -1)) {
    return fontSize;
  } else if (!isNaN(+fontSize)) {
    return fontSize + "px";
  } else {
    return DEFAULT_FONT_SIZE + "px";
  }
}
function setSeparateFont(targetStyle, sourceStyle) {
  for (var i = 0; i < FONT_PARTS.length; i++) {
    var fontProp = FONT_PARTS[i];
    var val = sourceStyle[fontProp];
    if (val != null) {
      targetStyle[fontProp] = val;
    }
  }
}
function hasSeparateFont(style2) {
  return style2.fontSize != null || style2.fontFamily || style2.fontWeight;
}
function normalizeTextStyle(style2) {
  normalizeStyle(style2);
  each$g(style2.rich, normalizeStyle);
  return style2;
}
function normalizeStyle(style2) {
  if (style2) {
    style2.font = ZRText.makeFont(style2);
    var textAlign = style2.align;
    textAlign === "middle" && (textAlign = "center");
    style2.align = textAlign == null || VALID_TEXT_ALIGN[textAlign] ? textAlign : "left";
    var verticalAlign = style2.verticalAlign;
    verticalAlign === "center" && (verticalAlign = "middle");
    style2.verticalAlign = verticalAlign == null || VALID_TEXT_VERTICAL_ALIGN[verticalAlign] ? verticalAlign : "top";
    var textPadding = style2.padding;
    if (textPadding) {
      style2.padding = normalizeCssArray$1(style2.padding);
    }
  }
}
function getStroke(stroke, lineWidth) {
  return stroke == null || lineWidth <= 0 || stroke === "transparent" || stroke === "none" ? null : stroke.image || stroke.colorStops ? "#000" : stroke;
}
function getFill(fill) {
  return fill == null || fill === "none" ? null : fill.image || fill.colorStops ? "#000" : fill;
}
function getTextXForPadding(x2, textAlign, textPadding) {
  return textAlign === "right" ? x2 - textPadding[1] : textAlign === "center" ? x2 + textPadding[3] / 2 - textPadding[1] / 2 : x2 + textPadding[3];
}
function getStyleText(style2) {
  var text = style2.text;
  text != null && (text += "");
  return text;
}
function needDrawBackground(style2) {
  return !!(style2.backgroundColor || style2.lineHeight || style2.borderWidth && style2.borderColor);
}
var ZRText$1 = ZRText;
var getECData = makeInner();
var setCommonECData = function(seriesIndex, dataType, dataIdx, el) {
  if (el) {
    var ecData = getECData(el);
    ecData.dataIndex = dataIdx;
    ecData.dataType = dataType;
    ecData.seriesIndex = seriesIndex;
    if (el.type === "group") {
      el.traverse(function(child) {
        var childECData = getECData(child);
        childECData.seriesIndex = seriesIndex;
        childECData.dataIndex = dataIdx;
        childECData.dataType = dataType;
      });
    }
  }
};
var _highlightNextDigit = 1;
var _highlightKeyMap = {};
var getSavedStates = makeInner();
var getComponentStates = makeInner();
var HOVER_STATE_NORMAL = 0;
var HOVER_STATE_BLUR = 1;
var HOVER_STATE_EMPHASIS = 2;
var SPECIAL_STATES = ["emphasis", "blur", "select"];
var DISPLAY_STATES = ["normal", "emphasis", "blur", "select"];
var Z2_EMPHASIS_LIFT = 10;
var Z2_SELECT_LIFT = 9;
var HIGHLIGHT_ACTION_TYPE = "highlight";
var DOWNPLAY_ACTION_TYPE = "downplay";
var SELECT_ACTION_TYPE = "select";
var UNSELECT_ACTION_TYPE = "unselect";
var TOGGLE_SELECT_ACTION_TYPE = "toggleSelect";
function hasFillOrStroke(fillOrStroke) {
  return fillOrStroke != null && fillOrStroke !== "none";
}
var liftedColorCache = new LRU$1(100);
function liftColor(color) {
  if (isString$1(color)) {
    var liftedColor = liftedColorCache.get(color);
    if (!liftedColor) {
      liftedColor = lift(color, -0.1);
      liftedColorCache.put(color, liftedColor);
    }
    return liftedColor;
  } else if (isGradientObject(color)) {
    var ret = extend({}, color);
    ret.colorStops = map$1(color.colorStops, function(stop2) {
      return {
        offset: stop2.offset,
        color: lift(stop2.color, -0.1)
      };
    });
    return ret;
  }
  return color;
}
function doChangeHoverState(el, stateName, hoverStateEnum) {
  if (el.onHoverStateChange && (el.hoverState || 0) !== hoverStateEnum) {
    el.onHoverStateChange(stateName);
  }
  el.hoverState = hoverStateEnum;
}
function singleEnterEmphasis(el) {
  doChangeHoverState(el, "emphasis", HOVER_STATE_EMPHASIS);
}
function singleLeaveEmphasis(el) {
  if (el.hoverState === HOVER_STATE_EMPHASIS) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterBlur(el) {
  doChangeHoverState(el, "blur", HOVER_STATE_BLUR);
}
function singleLeaveBlur(el) {
  if (el.hoverState === HOVER_STATE_BLUR) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterSelect(el) {
  el.selected = true;
}
function singleLeaveSelect(el) {
  el.selected = false;
}
function updateElementState(el, updater, commonParam) {
  updater(el, commonParam);
}
function traverseUpdateState(el, updater, commonParam) {
  updateElementState(el, updater, commonParam);
  el.isGroup && el.traverse(function(child) {
    updateElementState(child, updater, commonParam);
  });
}
function setStatesFlag(el, stateName) {
  switch (stateName) {
    case "emphasis":
      el.hoverState = HOVER_STATE_EMPHASIS;
      break;
    case "normal":
      el.hoverState = HOVER_STATE_NORMAL;
      break;
    case "blur":
      el.hoverState = HOVER_STATE_BLUR;
      break;
    case "select":
      el.selected = true;
  }
}
function getFromStateStyle(el, props, toStateName, defaultValue) {
  var style2 = el.style;
  var fromState = {};
  for (var i = 0; i < props.length; i++) {
    var propName = props[i];
    var val = style2[propName];
    fromState[propName] = val == null ? defaultValue && defaultValue[propName] : val;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.__fromStateTransition && animator.__fromStateTransition.indexOf(toStateName) < 0 && animator.targetName === "style") {
      animator.saveTo(fromState, props);
    }
  }
  return fromState;
}
function createEmphasisDefaultState(el, stateName, targetStates, state) {
  var hasSelect = targetStates && indexOf(targetStates, "select") >= 0;
  var cloned = false;
  if (el instanceof Path$1) {
    var store = getSavedStates(el);
    var fromFill = hasSelect ? store.selectFill || store.normalFill : store.normalFill;
    var fromStroke = hasSelect ? store.selectStroke || store.normalStroke : store.normalStroke;
    if (hasFillOrStroke(fromFill) || hasFillOrStroke(fromStroke)) {
      state = state || {};
      var emphasisStyle = state.style || {};
      if (emphasisStyle.fill === "inherit") {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = fromFill;
      } else if (!hasFillOrStroke(emphasisStyle.fill) && hasFillOrStroke(fromFill)) {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = liftColor(fromFill);
      } else if (!hasFillOrStroke(emphasisStyle.stroke) && hasFillOrStroke(fromStroke)) {
        if (!cloned) {
          state = extend({}, state);
          emphasisStyle = extend({}, emphasisStyle);
        }
        emphasisStyle.stroke = liftColor(fromStroke);
      }
      state.style = emphasisStyle;
    }
  }
  if (state) {
    if (state.z2 == null) {
      if (!cloned) {
        state = extend({}, state);
      }
      var z2EmphasisLift = el.z2EmphasisLift;
      state.z2 = el.z2 + (z2EmphasisLift != null ? z2EmphasisLift : Z2_EMPHASIS_LIFT);
    }
  }
  return state;
}
function createSelectDefaultState(el, stateName, state) {
  if (state) {
    if (state.z2 == null) {
      state = extend({}, state);
      var z2SelectLift = el.z2SelectLift;
      state.z2 = el.z2 + (z2SelectLift != null ? z2SelectLift : Z2_SELECT_LIFT);
    }
  }
  return state;
}
function createBlurDefaultState(el, stateName, state) {
  var hasBlur = indexOf(el.currentStates, stateName) >= 0;
  var currentOpacity = el.style.opacity;
  var fromState = !hasBlur ? getFromStateStyle(el, ["opacity"], stateName, {
    opacity: 1
  }) : null;
  state = state || {};
  var blurStyle = state.style || {};
  if (blurStyle.opacity == null) {
    state = extend({}, state);
    blurStyle = extend({
      opacity: hasBlur ? currentOpacity : fromState.opacity * 0.1
    }, blurStyle);
    state.style = blurStyle;
  }
  return state;
}
function elementStateProxy(stateName, targetStates) {
  var state = this.states[stateName];
  if (this.style) {
    if (stateName === "emphasis") {
      return createEmphasisDefaultState(this, stateName, targetStates, state);
    } else if (stateName === "blur") {
      return createBlurDefaultState(this, stateName, state);
    } else if (stateName === "select") {
      return createSelectDefaultState(this, stateName, state);
    }
  }
  return state;
}
function setDefaultStateProxy(el) {
  el.stateProxy = elementStateProxy;
  var textContent = el.getTextContent();
  var textGuide = el.getTextGuideLine();
  if (textContent) {
    textContent.stateProxy = elementStateProxy;
  }
  if (textGuide) {
    textGuide.stateProxy = elementStateProxy;
  }
}
function enterEmphasisWhenMouseOver(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasisWhenMouseOut(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterEmphasis(el, highlightDigit) {
  el.__highByOuter |= 1 << (highlightDigit || 0);
  traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasis(el, highlightDigit) {
  !(el.__highByOuter &= ~(1 << (highlightDigit || 0))) && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterBlur(el) {
  traverseUpdateState(el, singleEnterBlur);
}
function leaveBlur(el) {
  traverseUpdateState(el, singleLeaveBlur);
}
function enterSelect(el) {
  traverseUpdateState(el, singleEnterSelect);
}
function leaveSelect(el) {
  traverseUpdateState(el, singleLeaveSelect);
}
function shouldSilent(el, e2) {
  return el.__highDownSilentOnTouch && e2.zrByTouch;
}
function allLeaveBlur(api) {
  var model = api.getModel();
  model.eachComponent(function(componentType, componentModel) {
    var componentStates = getComponentStates(componentModel);
    if (componentStates.isBlured) {
      var view = componentType === "series" ? api.getViewOfSeriesModel(componentModel) : api.getViewOfComponentModel(componentModel);
      view.group.traverse(function(child) {
        singleLeaveBlur(child);
      });
    }
    componentStates.isBlured = false;
  });
}
function blurSeries(targetSeriesIndex, focus, blurScope, api) {
  var ecModel = api.getModel();
  blurScope = blurScope || "coordinateSystem";
  function leaveBlurOfIndices(data, dataIndices) {
    for (var i = 0; i < dataIndices.length; i++) {
      var itemEl = data.getItemGraphicEl(dataIndices[i]);
      itemEl && leaveBlur(itemEl);
    }
  }
  if (targetSeriesIndex == null) {
    return;
  }
  if (!focus || focus === "none") {
    return;
  }
  var targetSeriesModel = ecModel.getSeriesByIndex(targetSeriesIndex);
  var targetCoordSys = targetSeriesModel.coordinateSystem;
  if (targetCoordSys && targetCoordSys.master) {
    targetCoordSys = targetCoordSys.master;
  }
  var blurredSeries = [];
  ecModel.eachSeries(function(seriesModel) {
    var sameSeries = targetSeriesModel === seriesModel;
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.master) {
      coordSys = coordSys.master;
    }
    var sameCoordSys = coordSys && targetCoordSys ? coordSys === targetCoordSys : sameSeries;
    if (!(blurScope === "series" && !sameSeries || blurScope === "coordinateSystem" && !sameCoordSys || focus === "series" && sameSeries)) {
      var view = api.getViewOfSeriesModel(seriesModel);
      view.group.traverse(function(child) {
        singleEnterBlur(child);
      });
      if (isArrayLike(focus)) {
        leaveBlurOfIndices(seriesModel.getData(), focus);
      } else if (isObject$4(focus)) {
        var dataTypes = keys(focus);
        for (var d2 = 0; d2 < dataTypes.length; d2++) {
          leaveBlurOfIndices(seriesModel.getData(dataTypes[d2]), focus[dataTypes[d2]]);
        }
      }
      blurredSeries.push(seriesModel);
      getComponentStates(seriesModel).isBlured = true;
    }
  });
  ecModel.eachComponent(function(componentType, componentModel) {
    if (componentType === "series") {
      return;
    }
    var view = api.getViewOfComponentModel(componentModel);
    if (view && view.blurSeries) {
      view.blurSeries(blurredSeries, ecModel);
    }
  });
}
function blurComponent(componentMainType, componentIndex, api) {
  if (componentMainType == null || componentIndex == null) {
    return;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return;
  }
  getComponentStates(componentModel).isBlured = true;
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.focusBlurEnabled) {
    return;
  }
  view.group.traverse(function(child) {
    singleEnterBlur(child);
  });
}
function blurSeriesFromHighlightPayload(seriesModel, payload, api) {
  var seriesIndex = seriesModel.seriesIndex;
  var data = seriesModel.getData(payload.dataType);
  if (!data) {
    return;
  }
  var dataIndex = queryDataIndex(data, payload);
  dataIndex = (isArray$1(dataIndex) ? dataIndex[0] : dataIndex) || 0;
  var el = data.getItemGraphicEl(dataIndex);
  if (!el) {
    var count2 = data.count();
    var current = 0;
    while (!el && current < count2) {
      el = data.getItemGraphicEl(current++);
    }
  }
  if (el) {
    var ecData = getECData(el);
    blurSeries(seriesIndex, ecData.focus, ecData.blurScope, api);
  } else {
    var focus_1 = seriesModel.get(["emphasis", "focus"]);
    var blurScope = seriesModel.get(["emphasis", "blurScope"]);
    if (focus_1 != null) {
      blurSeries(seriesIndex, focus_1, blurScope, api);
    }
  }
}
function findComponentHighDownDispatchers(componentMainType, componentIndex, name, api) {
  var ret = {
    focusSelf: false,
    dispatchers: null
  };
  if (componentMainType == null || componentMainType === "series" || componentIndex == null || name == null) {
    return ret;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return ret;
  }
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.findHighDownDispatchers) {
    return ret;
  }
  var dispatchers = view.findHighDownDispatchers(name);
  var focusSelf;
  for (var i = 0; i < dispatchers.length; i++) {
    if (getECData(dispatchers[i]).focus === "self") {
      focusSelf = true;
      break;
    }
  }
  return {
    focusSelf,
    dispatchers
  };
}
function handleGlobalMouseOverForHighDown(dispatcher, e2, api) {
  var ecData = getECData(dispatcher);
  var _a2 = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api), dispatchers = _a2.dispatchers, focusSelf = _a2.focusSelf;
  if (dispatchers) {
    if (focusSelf) {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    each$g(dispatchers, function(dispatcher2) {
      return enterEmphasisWhenMouseOver(dispatcher2, e2);
    });
  } else {
    blurSeries(ecData.seriesIndex, ecData.focus, ecData.blurScope, api);
    if (ecData.focus === "self") {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    enterEmphasisWhenMouseOver(dispatcher, e2);
  }
}
function handleGlobalMouseOutForHighDown(dispatcher, e2, api) {
  allLeaveBlur(api);
  var ecData = getECData(dispatcher);
  var dispatchers = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api).dispatchers;
  if (dispatchers) {
    each$g(dispatchers, function(dispatcher2) {
      return leaveEmphasisWhenMouseOut(dispatcher2, e2);
    });
  } else {
    leaveEmphasisWhenMouseOut(dispatcher, e2);
  }
}
function toggleSelectionFromPayload(seriesModel, payload, api) {
  if (!isSelectChangePayload(payload)) {
    return;
  }
  var dataType = payload.dataType;
  var data = seriesModel.getData(dataType);
  var dataIndex = queryDataIndex(data, payload);
  if (!isArray$1(dataIndex)) {
    dataIndex = [dataIndex];
  }
  seriesModel[payload.type === TOGGLE_SELECT_ACTION_TYPE ? "toggleSelect" : payload.type === SELECT_ACTION_TYPE ? "select" : "unselect"](dataIndex, dataType);
}
function updateSeriesElementSelection(seriesModel) {
  var allData = seriesModel.getAllData();
  each$g(allData, function(_a2) {
    var data = _a2.data, type4 = _a2.type;
    data.eachItemGraphicEl(function(el, idx) {
      seriesModel.isSelected(idx, type4) ? enterSelect(el) : leaveSelect(el);
    });
  });
}
function getAllSelectedIndices(ecModel) {
  var ret = [];
  ecModel.eachSeries(function(seriesModel) {
    var allData = seriesModel.getAllData();
    each$g(allData, function(_a2) {
      _a2.data;
      var type4 = _a2.type;
      var dataIndices = seriesModel.getSelectedDataIndices();
      if (dataIndices.length > 0) {
        var item = {
          dataIndex: dataIndices,
          seriesIndex: seriesModel.seriesIndex
        };
        if (type4 != null) {
          item.dataType = type4;
        }
        ret.push(item);
      }
    });
  });
  return ret;
}
function enableHoverEmphasis(el, focus, blurScope) {
  setAsHighDownDispatcher(el, true);
  traverseUpdateState(el, setDefaultStateProxy);
  enableHoverFocus(el, focus, blurScope);
}
function disableHoverEmphasis(el) {
  setAsHighDownDispatcher(el, false);
}
function toggleHoverEmphasis(el, focus, blurScope, isDisabled) {
  isDisabled ? disableHoverEmphasis(el) : enableHoverEmphasis(el, focus, blurScope);
}
function enableHoverFocus(el, focus, blurScope) {
  var ecData = getECData(el);
  if (focus != null) {
    ecData.focus = focus;
    ecData.blurScope = blurScope;
  } else if (ecData.focus) {
    ecData.focus = null;
  }
}
var OTHER_STATES = ["emphasis", "blur", "select"];
var defaultStyleGetterMap = {
  itemStyle: "getItemStyle",
  lineStyle: "getLineStyle",
  areaStyle: "getAreaStyle"
};
function setStatesStylesFromModel(el, itemModel, styleType, getter) {
  styleType = styleType || "itemStyle";
  for (var i = 0; i < OTHER_STATES.length; i++) {
    var stateName = OTHER_STATES[i];
    var model = itemModel.getModel([stateName, styleType]);
    var state = el.ensureState(stateName);
    state.style = getter ? getter(model) : model[defaultStyleGetterMap[styleType]]();
  }
}
function setAsHighDownDispatcher(el, asDispatcher) {
  var disable = asDispatcher === false;
  var extendedEl = el;
  if (el.highDownSilentOnTouch) {
    extendedEl.__highDownSilentOnTouch = el.highDownSilentOnTouch;
  }
  if (!disable || extendedEl.__highDownDispatcher) {
    extendedEl.__highByOuter = extendedEl.__highByOuter || 0;
    extendedEl.__highDownDispatcher = !disable;
  }
}
function isHighDownDispatcher(el) {
  return !!(el && el.__highDownDispatcher);
}
function enableComponentHighDownFeatures(el, componentModel, componentHighDownName) {
  var ecData = getECData(el);
  ecData.componentMainType = componentModel.mainType;
  ecData.componentIndex = componentModel.componentIndex;
  ecData.componentHighDownName = componentHighDownName;
}
function getHighlightDigit(highlightKey) {
  var highlightDigit = _highlightKeyMap[highlightKey];
  if (highlightDigit == null && _highlightNextDigit <= 32) {
    highlightDigit = _highlightKeyMap[highlightKey] = _highlightNextDigit++;
  }
  return highlightDigit;
}
function isSelectChangePayload(payload) {
  var payloadType = payload.type;
  return payloadType === SELECT_ACTION_TYPE || payloadType === UNSELECT_ACTION_TYPE || payloadType === TOGGLE_SELECT_ACTION_TYPE;
}
function isHighDownPayload(payload) {
  var payloadType = payload.type;
  return payloadType === HIGHLIGHT_ACTION_TYPE || payloadType === DOWNPLAY_ACTION_TYPE;
}
function savePathStates(el) {
  var store = getSavedStates(el);
  store.normalFill = el.style.fill;
  store.normalStroke = el.style.stroke;
  var selectState = el.states.select || {};
  store.selectFill = selectState.style && selectState.style.fill || null;
  store.selectStroke = selectState.style && selectState.style.stroke || null;
}
var CMD$2 = PathProxy$1.CMD;
var points$2 = [[], [], []];
var mathSqrt$2 = Math.sqrt;
var mathAtan2 = Math.atan2;
function transformPath(path, m2) {
  if (!m2) {
    return;
  }
  var data = path.data;
  var len2 = path.len();
  var cmd;
  var nPoint;
  var i;
  var j;
  var k2;
  var p2;
  var M2 = CMD$2.M;
  var C = CMD$2.C;
  var L = CMD$2.L;
  var R2 = CMD$2.R;
  var A2 = CMD$2.A;
  var Q = CMD$2.Q;
  for (i = 0, j = 0; i < len2; ) {
    cmd = data[i++];
    j = i;
    nPoint = 0;
    switch (cmd) {
      case M2:
        nPoint = 1;
        break;
      case L:
        nPoint = 1;
        break;
      case C:
        nPoint = 3;
        break;
      case Q:
        nPoint = 2;
        break;
      case A2:
        var x2 = m2[4];
        var y2 = m2[5];
        var sx = mathSqrt$2(m2[0] * m2[0] + m2[1] * m2[1]);
        var sy = mathSqrt$2(m2[2] * m2[2] + m2[3] * m2[3]);
        var angle = mathAtan2(-m2[1] / sy, m2[0] / sx);
        data[i] *= sx;
        data[i++] += x2;
        data[i] *= sy;
        data[i++] += y2;
        data[i++] *= sx;
        data[i++] *= sy;
        data[i++] += angle;
        data[i++] += angle;
        i += 2;
        j = i;
        break;
      case R2:
        p2[0] = data[i++];
        p2[1] = data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
        p2[0] += data[i++];
        p2[1] += data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
    }
    for (k2 = 0; k2 < nPoint; k2++) {
      var p_1 = points$2[k2];
      p_1[0] = data[i++];
      p_1[1] = data[i++];
      applyTransform$1(p_1, p_1, m2);
      data[j++] = p_1[0];
      data[j++] = p_1[1];
    }
  }
  path.increaseVersion();
}
var mathSqrt$1 = Math.sqrt;
var mathSin$2 = Math.sin;
var mathCos$2 = Math.cos;
var PI$7 = Math.PI;
function vMag(v4) {
  return Math.sqrt(v4[0] * v4[0] + v4[1] * v4[1]);
}
function vRatio(u, v4) {
  return (u[0] * v4[0] + u[1] * v4[1]) / (vMag(u) * vMag(v4));
}
function vAngle(u, v4) {
  return (u[0] * v4[1] < u[1] * v4[0] ? -1 : 1) * Math.acos(vRatio(u, v4));
}
function processArc(x1, y1, x2, y2, fa2, fs, rx, ry, psiDeg, cmd, path) {
  var psi = psiDeg * (PI$7 / 180);
  var xp = mathCos$2(psi) * (x1 - x2) / 2 + mathSin$2(psi) * (y1 - y2) / 2;
  var yp = -1 * mathSin$2(psi) * (x1 - x2) / 2 + mathCos$2(psi) * (y1 - y2) / 2;
  var lambda = xp * xp / (rx * rx) + yp * yp / (ry * ry);
  if (lambda > 1) {
    rx *= mathSqrt$1(lambda);
    ry *= mathSqrt$1(lambda);
  }
  var f2 = (fa2 === fs ? -1 : 1) * mathSqrt$1((rx * rx * (ry * ry) - rx * rx * (yp * yp) - ry * ry * (xp * xp)) / (rx * rx * (yp * yp) + ry * ry * (xp * xp))) || 0;
  var cxp = f2 * rx * yp / ry;
  var cyp = f2 * -ry * xp / rx;
  var cx = (x1 + x2) / 2 + mathCos$2(psi) * cxp - mathSin$2(psi) * cyp;
  var cy = (y1 + y2) / 2 + mathSin$2(psi) * cxp + mathCos$2(psi) * cyp;
  var theta = vAngle([1, 0], [(xp - cxp) / rx, (yp - cyp) / ry]);
  var u = [(xp - cxp) / rx, (yp - cyp) / ry];
  var v4 = [(-1 * xp - cxp) / rx, (-1 * yp - cyp) / ry];
  var dTheta = vAngle(u, v4);
  if (vRatio(u, v4) <= -1) {
    dTheta = PI$7;
  }
  if (vRatio(u, v4) >= 1) {
    dTheta = 0;
  }
  if (dTheta < 0) {
    var n2 = Math.round(dTheta / PI$7 * 1e6) / 1e6;
    dTheta = PI$7 * 2 + n2 % 2 * PI$7;
  }
  path.addData(cmd, cx, cy, rx, ry, theta, dTheta, psi, fs);
}
var commandReg = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig;
var numberReg$1 = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function createPathProxyFromString(data) {
  var path = new PathProxy$1();
  if (!data) {
    return path;
  }
  var cpx = 0;
  var cpy = 0;
  var subpathX = cpx;
  var subpathY = cpy;
  var prevCmd;
  var CMD2 = PathProxy$1.CMD;
  var cmdList = data.match(commandReg);
  if (!cmdList) {
    return path;
  }
  for (var l2 = 0; l2 < cmdList.length; l2++) {
    var cmdText = cmdList[l2];
    var cmdStr = cmdText.charAt(0);
    var cmd = void 0;
    var p2 = cmdText.match(numberReg$1) || [];
    var pLen = p2.length;
    for (var i = 0; i < pLen; i++) {
      p2[i] = parseFloat(p2[i]);
    }
    var off = 0;
    while (off < pLen) {
      var ctlPtx = void 0;
      var ctlPty = void 0;
      var rx = void 0;
      var ry = void 0;
      var psi = void 0;
      var fa2 = void 0;
      var fs = void 0;
      var x1 = cpx;
      var y1 = cpy;
      var len2 = void 0;
      var pathData = void 0;
      switch (cmdStr) {
        case "l":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "L":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "m":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "l";
          break;
        case "M":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "L";
          break;
        case "h":
          cpx += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "H":
          cpx = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "v":
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "V":
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "C":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++], p2[off++], p2[off++], p2[off++], p2[off++], p2[off++]);
          cpx = p2[off - 2];
          cpy = p2[off - 1];
          break;
        case "c":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy);
          cpx += p2[off - 2];
          cpy += p2[off - 1];
          break;
        case "S":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "s":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = cpx + p2[off++];
          y1 = cpy + p2[off++];
          cpx += p2[off++];
          cpy += p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "Q":
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "q":
          x1 = p2[off++] + cpx;
          y1 = p2[off++] + cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "T":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "t":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "A":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa2 = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa2, fs, rx, ry, psi, cmd, path);
          break;
        case "a":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa2 = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa2, fs, rx, ry, psi, cmd, path);
          break;
      }
    }
    if (cmdStr === "z" || cmdStr === "Z") {
      cmd = CMD2.Z;
      path.addData(cmd);
      cpx = subpathX;
      cpy = subpathY;
    }
    prevCmd = cmd;
  }
  path.toStatic();
  return path;
}
var SVGPath = function(_super) {
  __extends(SVGPath2, _super);
  function SVGPath2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SVGPath2.prototype.applyTransform = function(m2) {
  };
  return SVGPath2;
}(Path$1);
function isPathProxy(path) {
  return path.setData != null;
}
function createPathOptions(str, opts) {
  var pathProxy = createPathProxyFromString(str);
  var innerOpts = extend({}, opts);
  innerOpts.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.setData(pathProxy.data);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    } else {
      var ctx = path;
      pathProxy.rebuildPath(ctx, 1);
    }
  };
  innerOpts.applyTransform = function(m2) {
    transformPath(pathProxy, m2);
    this.dirtyShape();
  };
  return innerOpts;
}
function createFromString(str, opts) {
  return new SVGPath(createPathOptions(str, opts));
}
function extendFromString(str, defaultOpts) {
  var innerOpts = createPathOptions(str, defaultOpts);
  var Sub = function(_super) {
    __extends(Sub2, _super);
    function Sub2(opts) {
      var _this = _super.call(this, opts) || this;
      _this.applyTransform = innerOpts.applyTransform;
      _this.buildPath = innerOpts.buildPath;
      return _this;
    }
    return Sub2;
  }(SVGPath);
  return Sub;
}
function mergePath$1(pathEls, opts) {
  var pathList = [];
  var len2 = pathEls.length;
  for (var i = 0; i < len2; i++) {
    var pathEl = pathEls[i];
    pathList.push(pathEl.getUpdatedPathProxy(true));
  }
  var pathBundle = new Path$1(opts);
  pathBundle.createPathProxy();
  pathBundle.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.appendPath(pathList);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    }
  };
  return pathBundle;
}
function clonePath(sourcePath, opts) {
  opts = opts || {};
  var path = new Path$1();
  if (sourcePath.shape) {
    path.setShape(sourcePath.shape);
  }
  path.setStyle(sourcePath.style);
  if (opts.bakeTransform) {
    transformPath(path.path, sourcePath.getComputedTransform());
  } else {
    if (opts.toLocal) {
      path.setLocalTransform(sourcePath.getComputedTransform());
    } else {
      path.copyTransform(sourcePath);
    }
  }
  path.buildPath = sourcePath.buildPath;
  path.applyTransform = path.applyTransform;
  path.z = sourcePath.z;
  path.z2 = sourcePath.z2;
  path.zlevel = sourcePath.zlevel;
  return path;
}
var CircleShape = function() {
  function CircleShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
  }
  return CircleShape2;
}();
var Circle = function(_super) {
  __extends(Circle2, _super);
  function Circle2(opts) {
    return _super.call(this, opts) || this;
  }
  Circle2.prototype.getDefaultShape = function() {
    return new CircleShape();
  };
  Circle2.prototype.buildPath = function(ctx, shape) {
    ctx.moveTo(shape.cx + shape.r, shape.cy);
    ctx.arc(shape.cx, shape.cy, shape.r, 0, Math.PI * 2);
  };
  return Circle2;
}(Path$1);
Circle.prototype.type = "circle";
var Circle$1 = Circle;
var EllipseShape = function() {
  function EllipseShape2() {
    this.cx = 0;
    this.cy = 0;
    this.rx = 0;
    this.ry = 0;
  }
  return EllipseShape2;
}();
var Ellipse = function(_super) {
  __extends(Ellipse2, _super);
  function Ellipse2(opts) {
    return _super.call(this, opts) || this;
  }
  Ellipse2.prototype.getDefaultShape = function() {
    return new EllipseShape();
  };
  Ellipse2.prototype.buildPath = function(ctx, shape) {
    var k2 = 0.5522848;
    var x2 = shape.cx;
    var y2 = shape.cy;
    var a = shape.rx;
    var b2 = shape.ry;
    var ox = a * k2;
    var oy = b2 * k2;
    ctx.moveTo(x2 - a, y2);
    ctx.bezierCurveTo(x2 - a, y2 - oy, x2 - ox, y2 - b2, x2, y2 - b2);
    ctx.bezierCurveTo(x2 + ox, y2 - b2, x2 + a, y2 - oy, x2 + a, y2);
    ctx.bezierCurveTo(x2 + a, y2 + oy, x2 + ox, y2 + b2, x2, y2 + b2);
    ctx.bezierCurveTo(x2 - ox, y2 + b2, x2 - a, y2 + oy, x2 - a, y2);
    ctx.closePath();
  };
  return Ellipse2;
}(Path$1);
Ellipse.prototype.type = "ellipse";
var Ellipse$1 = Ellipse;
var PI$6 = Math.PI;
var PI2$4 = PI$6 * 2;
var mathSin$1 = Math.sin;
var mathCos$1 = Math.cos;
var mathACos = Math.acos;
var mathATan2 = Math.atan2;
var mathAbs$1 = Math.abs;
var mathSqrt = Math.sqrt;
var mathMax$7 = Math.max;
var mathMin$7 = Math.min;
var e$1 = 1e-4;
function intersect(x0, y0, x1, y1, x2, y2, x3, y3) {
  var dx10 = x1 - x0;
  var dy10 = y1 - y0;
  var dx32 = x3 - x2;
  var dy32 = y3 - y2;
  var t2 = dy32 * dx10 - dx32 * dy10;
  if (t2 * t2 < e$1) {
    return;
  }
  t2 = (dx32 * (y0 - y2) - dy32 * (x0 - x2)) / t2;
  return [x0 + t2 * dx10, y0 + t2 * dy10];
}
function computeCornerTangents(x0, y0, x1, y1, radius, cr, clockwise) {
  var x01 = x0 - x1;
  var y01 = y0 - y1;
  var lo = (clockwise ? cr : -cr) / mathSqrt(x01 * x01 + y01 * y01);
  var ox = lo * y01;
  var oy = -lo * x01;
  var x11 = x0 + ox;
  var y11 = y0 + oy;
  var x10 = x1 + ox;
  var y10 = y1 + oy;
  var x00 = (x11 + x10) / 2;
  var y00 = (y11 + y10) / 2;
  var dx = x10 - x11;
  var dy = y10 - y11;
  var d2 = dx * dx + dy * dy;
  var r2 = radius - cr;
  var s = x11 * y10 - x10 * y11;
  var d3 = (dy < 0 ? -1 : 1) * mathSqrt(mathMax$7(0, r2 * r2 * d2 - s * s));
  var cx0 = (s * dy - dx * d3) / d2;
  var cy0 = (-s * dx - dy * d3) / d2;
  var cx1 = (s * dy + dx * d3) / d2;
  var cy1 = (-s * dx + dy * d3) / d2;
  var dx0 = cx0 - x00;
  var dy0 = cy0 - y00;
  var dx1 = cx1 - x00;
  var dy1 = cy1 - y00;
  if (dx0 * dx0 + dy0 * dy0 > dx1 * dx1 + dy1 * dy1) {
    cx0 = cx1;
    cy0 = cy1;
  }
  return {
    cx: cx0,
    cy: cy0,
    x0: -ox,
    y0: -oy,
    x1: cx0 * (radius / r2 - 1),
    y1: cy0 * (radius / r2 - 1)
  };
}
function normalizeCornerRadius(cr) {
  var arr;
  if (isArray$1(cr)) {
    var len2 = cr.length;
    if (!len2) {
      return cr;
    }
    if (len2 === 1) {
      arr = [cr[0], cr[0], 0, 0];
    } else if (len2 === 2) {
      arr = [cr[0], cr[0], cr[1], cr[1]];
    } else if (len2 === 3) {
      arr = cr.concat(cr[2]);
    } else {
      arr = cr;
    }
  } else {
    arr = [cr, cr, cr, cr];
  }
  return arr;
}
function buildPath$1(ctx, shape) {
  var _a2;
  var radius = mathMax$7(shape.r, 0);
  var innerRadius = mathMax$7(shape.r0 || 0, 0);
  var hasRadius = radius > 0;
  var hasInnerRadius = innerRadius > 0;
  if (!hasRadius && !hasInnerRadius) {
    return;
  }
  if (!hasRadius) {
    radius = innerRadius;
    innerRadius = 0;
  }
  if (innerRadius > radius) {
    var tmp = radius;
    radius = innerRadius;
    innerRadius = tmp;
  }
  var startAngle = shape.startAngle, endAngle = shape.endAngle;
  if (isNaN(startAngle) || isNaN(endAngle)) {
    return;
  }
  var cx = shape.cx, cy = shape.cy;
  var clockwise = !!shape.clockwise;
  var arc = mathAbs$1(endAngle - startAngle);
  var mod = arc > PI2$4 && arc % PI2$4;
  mod > e$1 && (arc = mod);
  if (!(radius > e$1)) {
    ctx.moveTo(cx, cy);
  } else if (arc > PI2$4 - e$1) {
    ctx.moveTo(cx + radius * mathCos$1(startAngle), cy + radius * mathSin$1(startAngle));
    ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    if (innerRadius > e$1) {
      ctx.moveTo(cx + innerRadius * mathCos$1(endAngle), cy + innerRadius * mathSin$1(endAngle));
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  } else {
    var icrStart = void 0;
    var icrEnd = void 0;
    var ocrStart = void 0;
    var ocrEnd = void 0;
    var ocrs = void 0;
    var ocre = void 0;
    var icrs = void 0;
    var icre = void 0;
    var ocrMax = void 0;
    var icrMax = void 0;
    var limitedOcrMax = void 0;
    var limitedIcrMax = void 0;
    var xre = void 0;
    var yre = void 0;
    var xirs = void 0;
    var yirs = void 0;
    var xrs = radius * mathCos$1(startAngle);
    var yrs = radius * mathSin$1(startAngle);
    var xire = innerRadius * mathCos$1(endAngle);
    var yire = innerRadius * mathSin$1(endAngle);
    var hasArc = arc > e$1;
    if (hasArc) {
      var cornerRadius = shape.cornerRadius;
      if (cornerRadius) {
        _a2 = normalizeCornerRadius(cornerRadius), icrStart = _a2[0], icrEnd = _a2[1], ocrStart = _a2[2], ocrEnd = _a2[3];
      }
      var halfRd = mathAbs$1(radius - innerRadius) / 2;
      ocrs = mathMin$7(halfRd, ocrStart);
      ocre = mathMin$7(halfRd, ocrEnd);
      icrs = mathMin$7(halfRd, icrStart);
      icre = mathMin$7(halfRd, icrEnd);
      limitedOcrMax = ocrMax = mathMax$7(ocrs, ocre);
      limitedIcrMax = icrMax = mathMax$7(icrs, icre);
      if (ocrMax > e$1 || icrMax > e$1) {
        xre = radius * mathCos$1(endAngle);
        yre = radius * mathSin$1(endAngle);
        xirs = innerRadius * mathCos$1(startAngle);
        yirs = innerRadius * mathSin$1(startAngle);
        if (arc < PI$6) {
          var it_1 = intersect(xrs, yrs, xirs, yirs, xre, yre, xire, yire);
          if (it_1) {
            var x0 = xrs - it_1[0];
            var y0 = yrs - it_1[1];
            var x1 = xre - it_1[0];
            var y1 = yre - it_1[1];
            var a = 1 / mathSin$1(mathACos((x0 * x1 + y0 * y1) / (mathSqrt(x0 * x0 + y0 * y0) * mathSqrt(x1 * x1 + y1 * y1))) / 2);
            var b2 = mathSqrt(it_1[0] * it_1[0] + it_1[1] * it_1[1]);
            limitedOcrMax = mathMin$7(ocrMax, (radius - b2) / (a + 1));
            limitedIcrMax = mathMin$7(icrMax, (innerRadius - b2) / (a - 1));
          }
        }
      }
    }
    if (!hasArc) {
      ctx.moveTo(cx + xrs, cy + yrs);
    } else if (limitedOcrMax > e$1) {
      var crStart = mathMin$7(ocrStart, limitedOcrMax);
      var crEnd = mathMin$7(ocrEnd, limitedOcrMax);
      var ct0 = computeCornerTangents(xirs, yirs, xrs, yrs, radius, crStart, clockwise);
      var ct1 = computeCornerTangents(xre, yre, xire, yire, radius, crEnd, clockwise);
      ctx.moveTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedOcrMax < ocrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedOcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crStart > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crStart, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, radius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), !clockwise);
        crEnd > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crEnd, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.moveTo(cx + xrs, cy + yrs);
      ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    }
    if (!(innerRadius > e$1) || !hasArc) {
      ctx.lineTo(cx + xire, cy + yire);
    } else if (limitedIcrMax > e$1) {
      var crStart = mathMin$7(icrStart, limitedIcrMax);
      var crEnd = mathMin$7(icrEnd, limitedIcrMax);
      var ct0 = computeCornerTangents(xire, yire, xre, yre, innerRadius, -crEnd, clockwise);
      var ct1 = computeCornerTangents(xrs, yrs, xirs, yirs, innerRadius, -crStart, clockwise);
      ctx.lineTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedIcrMax < icrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedIcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crEnd > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crEnd, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, innerRadius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), clockwise);
        crStart > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crStart, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.lineTo(cx + xire, cy + yire);
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  }
  ctx.closePath();
}
var SectorShape = function() {
  function SectorShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
    this.cornerRadius = 0;
  }
  return SectorShape2;
}();
var Sector = function(_super) {
  __extends(Sector2, _super);
  function Sector2(opts) {
    return _super.call(this, opts) || this;
  }
  Sector2.prototype.getDefaultShape = function() {
    return new SectorShape();
  };
  Sector2.prototype.buildPath = function(ctx, shape) {
    buildPath$1(ctx, shape);
  };
  Sector2.prototype.isZeroArea = function() {
    return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
  };
  return Sector2;
}(Path$1);
Sector.prototype.type = "sector";
var Sector$1 = Sector;
var RingShape = function() {
  function RingShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.r0 = 0;
  }
  return RingShape2;
}();
var Ring = function(_super) {
  __extends(Ring2, _super);
  function Ring2(opts) {
    return _super.call(this, opts) || this;
  }
  Ring2.prototype.getDefaultShape = function() {
    return new RingShape();
  };
  Ring2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var PI22 = Math.PI * 2;
    ctx.moveTo(x2 + shape.r, y2);
    ctx.arc(x2, y2, shape.r, 0, PI22, false);
    ctx.moveTo(x2 + shape.r0, y2);
    ctx.arc(x2, y2, shape.r0, 0, PI22, true);
  };
  return Ring2;
}(Path$1);
Ring.prototype.type = "ring";
var Ring$1 = Ring;
function smoothBezier(points2, smooth, isLoop, constraint) {
  var cps = [];
  var v4 = [];
  var v12 = [];
  var v22 = [];
  var prevPoint;
  var nextPoint;
  var min3;
  var max3;
  if (constraint) {
    min3 = [Infinity, Infinity];
    max3 = [-Infinity, -Infinity];
    for (var i = 0, len2 = points2.length; i < len2; i++) {
      min$1(min3, min3, points2[i]);
      max$1(max3, max3, points2[i]);
    }
    min$1(min3, min3, constraint[0]);
    max$1(max3, max3, constraint[1]);
  }
  for (var i = 0, len2 = points2.length; i < len2; i++) {
    var point = points2[i];
    if (isLoop) {
      prevPoint = points2[i ? i - 1 : len2 - 1];
      nextPoint = points2[(i + 1) % len2];
    } else {
      if (i === 0 || i === len2 - 1) {
        cps.push(clone$3(points2[i]));
        continue;
      } else {
        prevPoint = points2[i - 1];
        nextPoint = points2[i + 1];
      }
    }
    sub(v4, nextPoint, prevPoint);
    scale$2(v4, v4, smooth);
    var d0 = distance(point, prevPoint);
    var d1 = distance(point, nextPoint);
    var sum2 = d0 + d1;
    if (sum2 !== 0) {
      d0 /= sum2;
      d1 /= sum2;
    }
    scale$2(v12, v4, -d0);
    scale$2(v22, v4, d1);
    var cp0 = add([], point, v12);
    var cp1 = add([], point, v22);
    if (constraint) {
      max$1(cp0, cp0, min3);
      min$1(cp0, cp0, max3);
      max$1(cp1, cp1, min3);
      min$1(cp1, cp1, max3);
    }
    cps.push(cp0);
    cps.push(cp1);
  }
  if (isLoop) {
    cps.push(cps.shift());
  }
  return cps;
}
function buildPath(ctx, shape, closePath) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (points2 && points2.length >= 2) {
    if (smooth) {
      var controlPoints = smoothBezier(points2, smooth, closePath, shape.smoothConstraint);
      ctx.moveTo(points2[0][0], points2[0][1]);
      var len2 = points2.length;
      for (var i = 0; i < (closePath ? len2 : len2 - 1); i++) {
        var cp1 = controlPoints[i * 2];
        var cp2 = controlPoints[i * 2 + 1];
        var p2 = points2[(i + 1) % len2];
        ctx.bezierCurveTo(cp1[0], cp1[1], cp2[0], cp2[1], p2[0], p2[1]);
      }
    } else {
      ctx.moveTo(points2[0][0], points2[0][1]);
      for (var i = 1, l2 = points2.length; i < l2; i++) {
        ctx.lineTo(points2[i][0], points2[i][1]);
      }
    }
    closePath && ctx.closePath();
  }
}
var PolygonShape = function() {
  function PolygonShape2() {
    this.points = null;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolygonShape2;
}();
var Polygon = function(_super) {
  __extends(Polygon2, _super);
  function Polygon2(opts) {
    return _super.call(this, opts) || this;
  }
  Polygon2.prototype.getDefaultShape = function() {
    return new PolygonShape();
  };
  Polygon2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, true);
  };
  return Polygon2;
}(Path$1);
Polygon.prototype.type = "polygon";
var Polygon$1 = Polygon;
var PolylineShape = function() {
  function PolylineShape2() {
    this.points = null;
    this.percent = 1;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolylineShape2;
}();
var Polyline$2 = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(opts) {
    return _super.call(this, opts) || this;
  }
  Polyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Polyline2.prototype.getDefaultShape = function() {
    return new PolylineShape();
  };
  Polyline2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, false);
  };
  return Polyline2;
}(Path$1);
Polyline$2.prototype.type = "polyline";
var Polyline$3 = Polyline$2;
var subPixelOptimizeOutputShape = {};
var LineShape = function() {
  function LineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return LineShape2;
}();
var Line$2 = function(_super) {
  __extends(Line2, _super);
  function Line2(opts) {
    return _super.call(this, opts) || this;
  }
  Line2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Line2.prototype.getDefaultShape = function() {
    return new LineShape();
  };
  Line2.prototype.buildPath = function(ctx, shape) {
    var x1;
    var y1;
    var x2;
    var y2;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeLine$1(subPixelOptimizeOutputShape, shape, this.style);
      x1 = optimizedShape.x1;
      y1 = optimizedShape.y1;
      x2 = optimizedShape.x2;
      y2 = optimizedShape.y2;
    } else {
      x1 = shape.x1;
      y1 = shape.y1;
      x2 = shape.x2;
      y2 = shape.y2;
    }
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (percent < 1) {
      x2 = x1 * (1 - percent) + x2 * percent;
      y2 = y1 * (1 - percent) + y2 * percent;
    }
    ctx.lineTo(x2, y2);
  };
  Line2.prototype.pointAt = function(p2) {
    var shape = this.shape;
    return [
      shape.x1 * (1 - p2) + shape.x2 * p2,
      shape.y1 * (1 - p2) + shape.y2 * p2
    ];
  };
  return Line2;
}(Path$1);
Line$2.prototype.type = "line";
var Line$3 = Line$2;
var out = [];
var BezierCurveShape = function() {
  function BezierCurveShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.percent = 1;
  }
  return BezierCurveShape2;
}();
function someVectorAt(shape, t2, isTangent) {
  var cpx2 = shape.cpx2;
  var cpy2 = shape.cpy2;
  if (cpx2 != null || cpy2 != null) {
    return [
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.x1, shape.cpx1, shape.cpx2, shape.x2, t2),
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.y1, shape.cpy1, shape.cpy2, shape.y2, t2)
    ];
  } else {
    return [
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.x1, shape.cpx1, shape.x2, t2),
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.y1, shape.cpy1, shape.y2, t2)
    ];
  }
}
var BezierCurve = function(_super) {
  __extends(BezierCurve2, _super);
  function BezierCurve2(opts) {
    return _super.call(this, opts) || this;
  }
  BezierCurve2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  BezierCurve2.prototype.getDefaultShape = function() {
    return new BezierCurveShape();
  };
  BezierCurve2.prototype.buildPath = function(ctx, shape) {
    var x1 = shape.x1;
    var y1 = shape.y1;
    var x2 = shape.x2;
    var y2 = shape.y2;
    var cpx1 = shape.cpx1;
    var cpy1 = shape.cpy1;
    var cpx2 = shape.cpx2;
    var cpy2 = shape.cpy2;
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (cpx2 == null || cpy2 == null) {
      if (percent < 1) {
        quadraticSubdivide(x1, cpx1, x2, percent, out);
        cpx1 = out[1];
        x2 = out[2];
        quadraticSubdivide(y1, cpy1, y2, percent, out);
        cpy1 = out[1];
        y2 = out[2];
      }
      ctx.quadraticCurveTo(cpx1, cpy1, x2, y2);
    } else {
      if (percent < 1) {
        cubicSubdivide(x1, cpx1, cpx2, x2, percent, out);
        cpx1 = out[1];
        cpx2 = out[2];
        x2 = out[3];
        cubicSubdivide(y1, cpy1, cpy2, y2, percent, out);
        cpy1 = out[1];
        cpy2 = out[2];
        y2 = out[3];
      }
      ctx.bezierCurveTo(cpx1, cpy1, cpx2, cpy2, x2, y2);
    }
  };
  BezierCurve2.prototype.pointAt = function(t2) {
    return someVectorAt(this.shape, t2, false);
  };
  BezierCurve2.prototype.tangentAt = function(t2) {
    var p2 = someVectorAt(this.shape, t2, true);
    return normalize$4(p2, p2);
  };
  return BezierCurve2;
}(Path$1);
BezierCurve.prototype.type = "bezier-curve";
var BezierCurve$1 = BezierCurve;
var ArcShape = function() {
  function ArcShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return ArcShape2;
}();
var Arc = function(_super) {
  __extends(Arc2, _super);
  function Arc2(opts) {
    return _super.call(this, opts) || this;
  }
  Arc2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Arc2.prototype.getDefaultShape = function() {
    return new ArcShape();
  };
  Arc2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var r2 = Math.max(shape.r, 0);
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var unitX = Math.cos(startAngle);
    var unitY = Math.sin(startAngle);
    ctx.moveTo(unitX * r2 + x2, unitY * r2 + y2);
    ctx.arc(x2, y2, r2, startAngle, endAngle, !clockwise);
  };
  return Arc2;
}(Path$1);
Arc.prototype.type = "arc";
var Arc$1 = Arc;
var CompoundPath = function(_super) {
  __extends(CompoundPath2, _super);
  function CompoundPath2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "compound";
    return _this;
  }
  CompoundPath2.prototype._updatePathDirty = function() {
    var paths = this.shape.paths;
    var dirtyPath = this.shapeChanged();
    for (var i = 0; i < paths.length; i++) {
      dirtyPath = dirtyPath || paths[i].shapeChanged();
    }
    if (dirtyPath) {
      this.dirtyShape();
    }
  };
  CompoundPath2.prototype.beforeBrush = function() {
    this._updatePathDirty();
    var paths = this.shape.paths || [];
    var scale2 = this.getGlobalScale();
    for (var i = 0; i < paths.length; i++) {
      if (!paths[i].path) {
        paths[i].createPathProxy();
      }
      paths[i].path.setScale(scale2[0], scale2[1], paths[i].segmentIgnoreThreshold);
    }
  };
  CompoundPath2.prototype.buildPath = function(ctx, shape) {
    var paths = shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].buildPath(ctx, paths[i].shape, true);
    }
  };
  CompoundPath2.prototype.afterBrush = function() {
    var paths = this.shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].pathUpdated();
    }
  };
  CompoundPath2.prototype.getBoundingRect = function() {
    this._updatePathDirty.call(this);
    return Path$1.prototype.getBoundingRect.call(this);
  };
  return CompoundPath2;
}(Path$1);
var CompoundPath$1 = CompoundPath;
var Gradient = function() {
  function Gradient2(colorStops) {
    this.colorStops = colorStops || [];
  }
  Gradient2.prototype.addColorStop = function(offset2, color) {
    this.colorStops.push({
      offset: offset2,
      color
    });
  };
  return Gradient2;
}();
var Gradient$1 = Gradient;
var LinearGradient = function(_super) {
  __extends(LinearGradient2, _super);
  function LinearGradient2(x2, y2, x22, y22, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0 : x2;
    _this.y = y2 == null ? 0 : y2;
    _this.x2 = x22 == null ? 1 : x22;
    _this.y2 = y22 == null ? 0 : y22;
    _this.type = "linear";
    _this.global = globalCoord || false;
    return _this;
  }
  return LinearGradient2;
}(Gradient$1);
var LinearGradient$1 = LinearGradient;
var RadialGradient = function(_super) {
  __extends(RadialGradient2, _super);
  function RadialGradient2(x2, y2, r2, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0.5 : x2;
    _this.y = y2 == null ? 0.5 : y2;
    _this.r = r2 == null ? 0.5 : r2;
    _this.type = "radial";
    _this.global = globalCoord || false;
    return _this;
  }
  return RadialGradient2;
}(Gradient$1);
var RadialGradient$1 = RadialGradient;
var extent = [0, 0];
var extent2 = [0, 0];
var minTv = new Point$1();
var maxTv = new Point$1();
var OrientedBoundingRect = function() {
  function OrientedBoundingRect2(rect, transform2) {
    this._corners = [];
    this._axes = [];
    this._origin = [0, 0];
    for (var i = 0; i < 4; i++) {
      this._corners[i] = new Point$1();
    }
    for (var i = 0; i < 2; i++) {
      this._axes[i] = new Point$1();
    }
    if (rect) {
      this.fromBoundingRect(rect, transform2);
    }
  }
  OrientedBoundingRect2.prototype.fromBoundingRect = function(rect, transform2) {
    var corners = this._corners;
    var axes = this._axes;
    var x2 = rect.x;
    var y2 = rect.y;
    var x22 = x2 + rect.width;
    var y22 = y2 + rect.height;
    corners[0].set(x2, y2);
    corners[1].set(x22, y2);
    corners[2].set(x22, y22);
    corners[3].set(x2, y22);
    if (transform2) {
      for (var i = 0; i < 4; i++) {
        corners[i].transform(transform2);
      }
    }
    Point$1.sub(axes[0], corners[1], corners[0]);
    Point$1.sub(axes[1], corners[3], corners[0]);
    axes[0].normalize();
    axes[1].normalize();
    for (var i = 0; i < 2; i++) {
      this._origin[i] = axes[i].dot(corners[0]);
    }
  };
  OrientedBoundingRect2.prototype.intersect = function(other, mtv) {
    var overlapped = true;
    var noMtv = !mtv;
    minTv.set(Infinity, Infinity);
    maxTv.set(0, 0);
    if (!this._intersectCheckOneSide(this, other, minTv, maxTv, noMtv, 1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!this._intersectCheckOneSide(other, this, minTv, maxTv, noMtv, -1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!noMtv) {
      Point$1.copy(mtv, overlapped ? minTv : maxTv);
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._intersectCheckOneSide = function(self2, other, minTv2, maxTv2, noMtv, inverse) {
    var overlapped = true;
    for (var i = 0; i < 2; i++) {
      var axis = this._axes[i];
      this._getProjMinMaxOnAxis(i, self2._corners, extent);
      this._getProjMinMaxOnAxis(i, other._corners, extent2);
      if (extent[1] < extent2[0] || extent[0] > extent2[1]) {
        overlapped = false;
        if (noMtv) {
          return overlapped;
        }
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) > maxTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(maxTv2, axis, -dist0 * inverse);
          } else {
            Point$1.scale(maxTv2, axis, dist1 * inverse);
          }
        }
      } else if (minTv2) {
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) < minTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(minTv2, axis, dist0 * inverse);
          } else {
            Point$1.scale(minTv2, axis, -dist1 * inverse);
          }
        }
      }
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._getProjMinMaxOnAxis = function(dim, corners, out2) {
    var axis = this._axes[dim];
    var origin = this._origin;
    var proj = corners[0].dot(axis) + origin[dim];
    var min3 = proj;
    var max3 = proj;
    for (var i = 1; i < corners.length; i++) {
      var proj_1 = corners[i].dot(axis) + origin[dim];
      min3 = Math.min(proj_1, min3);
      max3 = Math.max(proj_1, max3);
    }
    out2[0] = min3;
    out2[1] = max3;
  };
  return OrientedBoundingRect2;
}();
var OrientedBoundingRect$1 = OrientedBoundingRect;
var m$3 = [];
var IncrementalDisplayable = function(_super) {
  __extends(IncrementalDisplayable2, _super);
  function IncrementalDisplayable2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.notClear = true;
    _this.incremental = true;
    _this._displayables = [];
    _this._temporaryDisplayables = [];
    _this._cursor = 0;
    return _this;
  }
  IncrementalDisplayable2.prototype.traverse = function(cb2, context) {
    cb2.call(context, this);
  };
  IncrementalDisplayable2.prototype.useStyle = function() {
    this.style = {};
  };
  IncrementalDisplayable2.prototype.getCursor = function() {
    return this._cursor;
  };
  IncrementalDisplayable2.prototype.innerAfterBrush = function() {
    this._cursor = this._displayables.length;
  };
  IncrementalDisplayable2.prototype.clearDisplaybles = function() {
    this._displayables = [];
    this._temporaryDisplayables = [];
    this._cursor = 0;
    this.markRedraw();
    this.notClear = false;
  };
  IncrementalDisplayable2.prototype.clearTemporalDisplayables = function() {
    this._temporaryDisplayables = [];
  };
  IncrementalDisplayable2.prototype.addDisplayable = function(displayable, notPersistent) {
    if (notPersistent) {
      this._temporaryDisplayables.push(displayable);
    } else {
      this._displayables.push(displayable);
    }
    this.markRedraw();
  };
  IncrementalDisplayable2.prototype.addDisplayables = function(displayables, notPersistent) {
    notPersistent = notPersistent || false;
    for (var i = 0; i < displayables.length; i++) {
      this.addDisplayable(displayables[i], notPersistent);
    }
  };
  IncrementalDisplayable2.prototype.getDisplayables = function() {
    return this._displayables;
  };
  IncrementalDisplayable2.prototype.getTemporalDisplayables = function() {
    return this._temporaryDisplayables;
  };
  IncrementalDisplayable2.prototype.eachPendingDisplayable = function(cb2) {
    for (var i = this._cursor; i < this._displayables.length; i++) {
      cb2 && cb2(this._displayables[i]);
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      cb2 && cb2(this._temporaryDisplayables[i]);
    }
  };
  IncrementalDisplayable2.prototype.update = function() {
    this.updateTransform();
    for (var i = this._cursor; i < this._displayables.length; i++) {
      var displayable = this._displayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      var displayable = this._temporaryDisplayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
  };
  IncrementalDisplayable2.prototype.getBoundingRect = function() {
    if (!this._rect) {
      var rect = new BoundingRect$1(Infinity, Infinity, -Infinity, -Infinity);
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        var childRect = displayable.getBoundingRect().clone();
        if (displayable.needLocalTransform()) {
          childRect.applyTransform(displayable.getLocalTransform(m$3));
        }
        rect.union(childRect);
      }
      this._rect = rect;
    }
    return this._rect;
  };
  IncrementalDisplayable2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    if (rect.contain(localPos[0], localPos[1])) {
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        if (displayable.contain(x2, y2)) {
          return true;
        }
      }
    }
    return false;
  };
  return IncrementalDisplayable2;
}(Displayable$1);
var IncrementalDisplayable$1 = IncrementalDisplayable;
var transitionStore = makeInner();
function getAnimationConfig(animationType, animatableModel, dataIndex, extraOpts, extraDelayParams) {
  var animationPayload;
  if (animatableModel && animatableModel.ecModel) {
    var updatePayload = animatableModel.ecModel.getUpdatePayload();
    animationPayload = updatePayload && updatePayload.animation;
  }
  var animationEnabled = animatableModel && animatableModel.isAnimationEnabled();
  var isUpdate = animationType === "update";
  if (animationEnabled) {
    var duration = void 0;
    var easing = void 0;
    var delay = void 0;
    if (extraOpts) {
      duration = retrieve2(extraOpts.duration, 200);
      easing = retrieve2(extraOpts.easing, "cubicOut");
      delay = 0;
    } else {
      duration = animatableModel.getShallow(isUpdate ? "animationDurationUpdate" : "animationDuration");
      easing = animatableModel.getShallow(isUpdate ? "animationEasingUpdate" : "animationEasing");
      delay = animatableModel.getShallow(isUpdate ? "animationDelayUpdate" : "animationDelay");
    }
    if (animationPayload) {
      animationPayload.duration != null && (duration = animationPayload.duration);
      animationPayload.easing != null && (easing = animationPayload.easing);
      animationPayload.delay != null && (delay = animationPayload.delay);
    }
    if (isFunction(delay)) {
      delay = delay(dataIndex, extraDelayParams);
    }
    if (isFunction(duration)) {
      duration = duration(dataIndex);
    }
    var config = {
      duration: duration || 0,
      delay,
      easing
    };
    return config;
  } else {
    return null;
  }
}
function animateOrSetProps(animationType, el, props, animatableModel, dataIndex, cb2, during) {
  var isFrom = false;
  var removeOpt;
  if (isFunction(dataIndex)) {
    during = cb2;
    cb2 = dataIndex;
    dataIndex = null;
  } else if (isObject$4(dataIndex)) {
    cb2 = dataIndex.cb;
    during = dataIndex.during;
    isFrom = dataIndex.isFrom;
    removeOpt = dataIndex.removeOpt;
    dataIndex = dataIndex.dataIndex;
  }
  var isRemove = animationType === "leave";
  if (!isRemove) {
    el.stopAnimation("leave");
  }
  var animationConfig = getAnimationConfig(animationType, animatableModel, dataIndex, isRemove ? removeOpt || {} : null, animatableModel && animatableModel.getAnimationDelayParams ? animatableModel.getAnimationDelayParams(el, dataIndex) : null);
  if (animationConfig && animationConfig.duration > 0) {
    var duration = animationConfig.duration;
    var animationDelay = animationConfig.delay;
    var animationEasing = animationConfig.easing;
    var animateConfig = {
      duration,
      delay: animationDelay || 0,
      easing: animationEasing,
      done: cb2,
      force: !!cb2 || !!during,
      setToFinal: !isRemove,
      scope: animationType,
      during
    };
    isFrom ? el.animateFrom(props, animateConfig) : el.animateTo(props, animateConfig);
  } else {
    el.stopAnimation();
    !isFrom && el.attr(props);
    during && during(1);
    cb2 && cb2();
  }
}
function updateProps$1(el, props, animatableModel, dataIndex, cb2, during) {
  animateOrSetProps("update", el, props, animatableModel, dataIndex, cb2, during);
}
function initProps(el, props, animatableModel, dataIndex, cb2, during) {
  animateOrSetProps("enter", el, props, animatableModel, dataIndex, cb2, during);
}
function isElementRemoved(el) {
  if (!el.__zr) {
    return true;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.scope === "leave") {
      return true;
    }
  }
  return false;
}
function removeElement(el, props, animatableModel, dataIndex, cb2, during) {
  if (isElementRemoved(el)) {
    return;
  }
  animateOrSetProps("leave", el, props, animatableModel, dataIndex, cb2, during);
}
function fadeOutDisplayable(el, animatableModel, dataIndex, done) {
  el.removeTextContent();
  el.removeTextGuideLine();
  removeElement(el, {
    style: {
      opacity: 0
    }
  }, animatableModel, dataIndex, done);
}
function removeElementWithFadeOut(el, animatableModel, dataIndex) {
  function doRemove() {
    el.parent && el.parent.remove(el);
  }
  if (!el.isGroup) {
    fadeOutDisplayable(el, animatableModel, dataIndex, doRemove);
  } else {
    el.traverse(function(disp) {
      if (!disp.isGroup) {
        fadeOutDisplayable(disp, animatableModel, dataIndex, doRemove);
      }
    });
  }
}
function saveOldStyle(el) {
  transitionStore(el).oldStyle = el.style;
}
function getOldStyle(el) {
  return transitionStore(el).oldStyle;
}
var mathMax$6 = Math.max;
var mathMin$6 = Math.min;
var _customShapeMap = {};
function extendShape(opts) {
  return Path$1.extend(opts);
}
var extendPathFromString = extendFromString;
function extendPath(pathData, opts) {
  return extendPathFromString(pathData, opts);
}
function registerShape(name, ShapeClass) {
  _customShapeMap[name] = ShapeClass;
}
function getShapeClass(name) {
  if (_customShapeMap.hasOwnProperty(name)) {
    return _customShapeMap[name];
  }
}
function makePath(pathData, opts, rect, layout2) {
  var path = createFromString(pathData, opts);
  if (rect) {
    if (layout2 === "center") {
      rect = centerGraphic(rect, path.getBoundingRect());
    }
    resizePath(path, rect);
  }
  return path;
}
function makeImage(imageUrl, rect, layout2) {
  var zrImg = new ZRImage$1({
    style: {
      image: imageUrl,
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    onload: function(img) {
      if (layout2 === "center") {
        var boundingRect = {
          width: img.width,
          height: img.height
        };
        zrImg.setStyle(centerGraphic(rect, boundingRect));
      }
    }
  });
  return zrImg;
}
function centerGraphic(rect, boundingRect) {
  var aspect = boundingRect.width / boundingRect.height;
  var width = rect.height * aspect;
  var height;
  if (width <= rect.width) {
    height = rect.height;
  } else {
    width = rect.width;
    height = width / aspect;
  }
  var cx = rect.x + rect.width / 2;
  var cy = rect.y + rect.height / 2;
  return {
    x: cx - width / 2,
    y: cy - height / 2,
    width,
    height
  };
}
var mergePath = mergePath$1;
function resizePath(path, rect) {
  if (!path.applyTransform) {
    return;
  }
  var pathRect = path.getBoundingRect();
  var m2 = pathRect.calculateTransform(rect);
  path.applyTransform(m2);
}
function subPixelOptimizeLine(param) {
  subPixelOptimizeLine$1(param.shape, param.shape, param.style);
  return param;
}
function subPixelOptimizeRect(param) {
  subPixelOptimizeRect$1(param.shape, param.shape, param.style);
  return param;
}
var subPixelOptimize = subPixelOptimize$1;
function getTransform$1(target, ancestor) {
  var mat = identity([]);
  while (target && target !== ancestor) {
    mul(mat, target.getLocalTransform(), mat);
    target = target.parent;
  }
  return mat;
}
function applyTransform(target, transform2, invert$1) {
  if (transform2 && !isArrayLike(transform2)) {
    transform2 = Transformable$1.getLocalTransform(transform2);
  }
  if (invert$1) {
    transform2 = invert([], transform2);
  }
  return applyTransform$1([], target, transform2);
}
function transformDirection(direction, transform2, invert2) {
  var hBase = transform2[4] === 0 || transform2[5] === 0 || transform2[0] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[0]);
  var vBase = transform2[4] === 0 || transform2[5] === 0 || transform2[2] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[2]);
  var vertex = [direction === "left" ? -hBase : direction === "right" ? hBase : 0, direction === "top" ? -vBase : direction === "bottom" ? vBase : 0];
  vertex = applyTransform(vertex, transform2, invert2);
  return Math.abs(vertex[0]) > Math.abs(vertex[1]) ? vertex[0] > 0 ? "right" : "left" : vertex[1] > 0 ? "bottom" : "top";
}
function isNotGroup(el) {
  return !el.isGroup;
}
function isPath$1(el) {
  return el.shape != null;
}
function groupTransition(g1, g2, animatableModel) {
  if (!g1 || !g2) {
    return;
  }
  function getElMap(g3) {
    var elMap = {};
    g3.traverse(function(el) {
      if (isNotGroup(el) && el.anid) {
        elMap[el.anid] = el;
      }
    });
    return elMap;
  }
  function getAnimatableProps(el) {
    var obj = {
      x: el.x,
      y: el.y,
      rotation: el.rotation
    };
    if (isPath$1(el)) {
      obj.shape = extend({}, el.shape);
    }
    return obj;
  }
  var elMap1 = getElMap(g1);
  g2.traverse(function(el) {
    if (isNotGroup(el) && el.anid) {
      var oldEl = elMap1[el.anid];
      if (oldEl) {
        var newProp = getAnimatableProps(el);
        el.attr(getAnimatableProps(oldEl));
        updateProps$1(el, newProp, animatableModel, getECData(el).dataIndex);
      }
    }
  });
}
function clipPointsByRect(points2, rect) {
  return map$1(points2, function(point) {
    var x2 = point[0];
    x2 = mathMax$6(x2, rect.x);
    x2 = mathMin$6(x2, rect.x + rect.width);
    var y2 = point[1];
    y2 = mathMax$6(y2, rect.y);
    y2 = mathMin$6(y2, rect.y + rect.height);
    return [x2, y2];
  });
}
function clipRectByRect(targetRect, rect) {
  var x2 = mathMax$6(targetRect.x, rect.x);
  var x22 = mathMin$6(targetRect.x + targetRect.width, rect.x + rect.width);
  var y2 = mathMax$6(targetRect.y, rect.y);
  var y22 = mathMin$6(targetRect.y + targetRect.height, rect.y + rect.height);
  if (x22 >= x2 && y22 >= y2) {
    return {
      x: x2,
      y: y2,
      width: x22 - x2,
      height: y22 - y2
    };
  }
}
function createIcon(iconStr, opt, rect) {
  var innerOpts = extend({
    rectHover: true
  }, opt);
  var style2 = innerOpts.style = {
    strokeNoScale: true
  };
  rect = rect || {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  };
  if (iconStr) {
    return iconStr.indexOf("image://") === 0 ? (style2.image = iconStr.slice(8), defaults(style2, rect), new ZRImage$1(innerOpts)) : makePath(iconStr.replace("path://", ""), innerOpts, rect, "center");
  }
}
function linePolygonIntersect(a1x, a1y, a2x, a2y, points2) {
  for (var i = 0, p2 = points2[points2.length - 1]; i < points2.length; i++) {
    var p3 = points2[i];
    if (lineLineIntersect$1(a1x, a1y, a2x, a2y, p3[0], p3[1], p2[0], p2[1])) {
      return true;
    }
    p2 = p3;
  }
}
function lineLineIntersect$1(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d$1(nx, ny, mx, my);
  if (nearZero(nmCrossProduct)) {
    return false;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var q2 = crossProduct2d$1(b1a1x, b1a1y, mx, my) / nmCrossProduct;
  if (q2 < 0 || q2 > 1) {
    return false;
  }
  var p2 = crossProduct2d$1(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return false;
  }
  return true;
}
function crossProduct2d$1(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function nearZero(val) {
  return val <= 1e-6 && val >= -1e-6;
}
function setTooltipConfig(opt) {
  var itemTooltipOption = opt.itemTooltipOption;
  var componentModel = opt.componentModel;
  var itemName = opt.itemName;
  var itemTooltipOptionObj = isString$1(itemTooltipOption) ? {
    formatter: itemTooltipOption
  } : itemTooltipOption;
  var mainType = componentModel.mainType;
  var componentIndex = componentModel.componentIndex;
  var formatterParams = {
    componentType: mainType,
    name: itemName,
    $vars: ["name"]
  };
  formatterParams[mainType + "Index"] = componentIndex;
  var formatterParamsExtra = opt.formatterParamsExtra;
  if (formatterParamsExtra) {
    each$g(keys(formatterParamsExtra), function(key) {
      if (!hasOwn(formatterParams, key)) {
        formatterParams[key] = formatterParamsExtra[key];
        formatterParams.$vars.push(key);
      }
    });
  }
  var ecData = getECData(opt.el);
  ecData.componentMainType = mainType;
  ecData.componentIndex = componentIndex;
  ecData.tooltipConfig = {
    name: itemName,
    option: defaults({
      content: itemName,
      formatterParams
    }, itemTooltipOptionObj)
  };
}
function traverseElement(el, cb2) {
  var stopped;
  if (el.isGroup) {
    stopped = cb2(el);
  }
  if (!stopped) {
    el.traverse(cb2);
  }
}
function traverseElements(els, cb2) {
  if (els) {
    if (isArray$1(els)) {
      for (var i = 0; i < els.length; i++) {
        traverseElement(els[i], cb2);
      }
    } else {
      traverseElement(els, cb2);
    }
  }
}
registerShape("circle", Circle$1);
registerShape("ellipse", Ellipse$1);
registerShape("sector", Sector$1);
registerShape("ring", Ring$1);
registerShape("polygon", Polygon$1);
registerShape("polyline", Polyline$3);
registerShape("rect", Rect$3);
registerShape("line", Line$3);
registerShape("bezierCurve", BezierCurve$1);
registerShape("arc", Arc$1);
var graphic = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  updateProps: updateProps$1,
  initProps,
  removeElement,
  removeElementWithFadeOut,
  isElementRemoved,
  extendShape,
  extendPath,
  registerShape,
  getShapeClass,
  makePath,
  makeImage,
  mergePath,
  resizePath,
  subPixelOptimizeLine,
  subPixelOptimizeRect,
  subPixelOptimize,
  getTransform: getTransform$1,
  applyTransform,
  transformDirection,
  groupTransition,
  clipPointsByRect,
  clipRectByRect,
  createIcon,
  linePolygonIntersect,
  lineLineIntersect: lineLineIntersect$1,
  setTooltipConfig,
  traverseElements,
  Group: Group$6,
  Image: ZRImage$1,
  Text: ZRText$1,
  Circle: Circle$1,
  Ellipse: Ellipse$1,
  Sector: Sector$1,
  Ring: Ring$1,
  Polygon: Polygon$1,
  Polyline: Polyline$3,
  Rect: Rect$3,
  Line: Line$3,
  BezierCurve: BezierCurve$1,
  Arc: Arc$1,
  IncrementalDisplayable: IncrementalDisplayable$1,
  CompoundPath: CompoundPath$1,
  LinearGradient: LinearGradient$1,
  RadialGradient: RadialGradient$1,
  BoundingRect: BoundingRect$1,
  OrientedBoundingRect: OrientedBoundingRect$1,
  Point: Point$1,
  Path: Path$1
}, Symbol.toStringTag, { value: "Module" }));
var EMPTY_OBJ = {};
function setLabelText(label, labelTexts) {
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var text = labelTexts[stateName];
    var state = label.ensureState(stateName);
    state.style = state.style || {};
    state.style.text = text;
  }
  var oldStates = label.currentStates.slice();
  label.clearStates(true);
  label.setStyle({
    text: labelTexts.normal
  });
  label.useStates(oldStates, true);
}
function getLabelText(opt, stateModels, interpolatedValue) {
  var labelFetcher = opt.labelFetcher;
  var labelDataIndex = opt.labelDataIndex;
  var labelDimIndex = opt.labelDimIndex;
  var normalModel = stateModels.normal;
  var baseText;
  if (labelFetcher) {
    baseText = labelFetcher.getFormattedLabel(labelDataIndex, "normal", null, labelDimIndex, normalModel && normalModel.get("formatter"), interpolatedValue != null ? {
      interpolatedValue
    } : null);
  }
  if (baseText == null) {
    baseText = isFunction(opt.defaultText) ? opt.defaultText(labelDataIndex, opt, interpolatedValue) : opt.defaultText;
  }
  var statesText = {
    normal: baseText
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var stateModel = stateModels[stateName];
    statesText[stateName] = retrieve2(labelFetcher ? labelFetcher.getFormattedLabel(labelDataIndex, stateName, null, labelDimIndex, stateModel && stateModel.get("formatter")) : null, baseText);
  }
  return statesText;
}
function setLabelStyle(targetEl, labelStatesModels, opt, stateSpecified) {
  opt = opt || EMPTY_OBJ;
  var isSetOnText = targetEl instanceof ZRText$1;
  var needsCreateText = false;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateModel = labelStatesModels[DISPLAY_STATES[i]];
    if (stateModel && stateModel.getShallow("show")) {
      needsCreateText = true;
      break;
    }
  }
  var textContent = isSetOnText ? targetEl : targetEl.getTextContent();
  if (needsCreateText) {
    if (!isSetOnText) {
      if (!textContent) {
        textContent = new ZRText$1();
        targetEl.setTextContent(textContent);
      }
      if (targetEl.stateProxy) {
        textContent.stateProxy = targetEl.stateProxy;
      }
    }
    var labelStatesTexts = getLabelText(opt, labelStatesModels);
    var normalModel = labelStatesModels.normal;
    var showNormal = !!normalModel.getShallow("show");
    var normalStyle = createTextStyle(normalModel, stateSpecified && stateSpecified.normal, opt, false, !isSetOnText);
    normalStyle.text = labelStatesTexts.normal;
    if (!isSetOnText) {
      targetEl.setTextConfig(createTextConfig(normalModel, opt, false));
    }
    for (var i = 0; i < SPECIAL_STATES.length; i++) {
      var stateName = SPECIAL_STATES[i];
      var stateModel = labelStatesModels[stateName];
      if (stateModel) {
        var stateObj = textContent.ensureState(stateName);
        var stateShow = !!retrieve2(stateModel.getShallow("show"), showNormal);
        if (stateShow !== showNormal) {
          stateObj.ignore = !stateShow;
        }
        stateObj.style = createTextStyle(stateModel, stateSpecified && stateSpecified[stateName], opt, true, !isSetOnText);
        stateObj.style.text = labelStatesTexts[stateName];
        if (!isSetOnText) {
          var targetElEmphasisState = targetEl.ensureState(stateName);
          targetElEmphasisState.textConfig = createTextConfig(stateModel, opt, true);
        }
      }
    }
    textContent.silent = !!normalModel.getShallow("silent");
    if (textContent.style.x != null) {
      normalStyle.x = textContent.style.x;
    }
    if (textContent.style.y != null) {
      normalStyle.y = textContent.style.y;
    }
    textContent.ignore = !showNormal;
    textContent.useStyle(normalStyle);
    textContent.dirty();
    if (opt.enableTextSetter) {
      labelInner(textContent).setLabelText = function(interpolatedValue) {
        var labelStatesTexts2 = getLabelText(opt, labelStatesModels, interpolatedValue);
        setLabelText(textContent, labelStatesTexts2);
      };
    }
  } else if (textContent) {
    textContent.ignore = true;
  }
  targetEl.dirty();
}
function getLabelStatesModels(itemModel, labelName) {
  labelName = labelName || "label";
  var statesModels = {
    normal: itemModel.getModel(labelName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelName]);
  }
  return statesModels;
}
function createTextStyle(textStyleModel, specifiedTextStyle, opt, isNotNormal, isAttached) {
  var textStyle = {};
  setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached);
  specifiedTextStyle && extend(textStyle, specifiedTextStyle);
  return textStyle;
}
function createTextConfig(textStyleModel, opt, isNotNormal) {
  opt = opt || {};
  var textConfig = {};
  var labelPosition;
  var labelRotate = textStyleModel.getShallow("rotate");
  var labelDistance = retrieve2(textStyleModel.getShallow("distance"), isNotNormal ? null : 5);
  var labelOffset = textStyleModel.getShallow("offset");
  labelPosition = textStyleModel.getShallow("position") || (isNotNormal ? null : "inside");
  labelPosition === "outside" && (labelPosition = opt.defaultOutsidePosition || "top");
  if (labelPosition != null) {
    textConfig.position = labelPosition;
  }
  if (labelOffset != null) {
    textConfig.offset = labelOffset;
  }
  if (labelRotate != null) {
    labelRotate *= Math.PI / 180;
    textConfig.rotation = labelRotate;
  }
  if (labelDistance != null) {
    textConfig.distance = labelDistance;
  }
  textConfig.outsideFill = textStyleModel.get("color") === "inherit" ? opt.inheritColor || null : "auto";
  return textConfig;
}
function setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached) {
  opt = opt || EMPTY_OBJ;
  var ecModel = textStyleModel.ecModel;
  var globalTextStyle = ecModel && ecModel.option.textStyle;
  var richItemNames = getRichItemNames(textStyleModel);
  var richResult;
  if (richItemNames) {
    richResult = {};
    for (var name_1 in richItemNames) {
      if (richItemNames.hasOwnProperty(name_1)) {
        var richTextStyle = textStyleModel.getModel(["rich", name_1]);
        setTokenTextStyle(richResult[name_1] = {}, richTextStyle, globalTextStyle, opt, isNotNormal, isAttached, false, true);
      }
    }
  }
  if (richResult) {
    textStyle.rich = richResult;
  }
  var overflow = textStyleModel.get("overflow");
  if (overflow) {
    textStyle.overflow = overflow;
  }
  var margin = textStyleModel.get("minMargin");
  if (margin != null) {
    textStyle.margin = margin;
  }
  setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, true, false);
}
function getRichItemNames(textStyleModel) {
  var richItemNameMap;
  while (textStyleModel && textStyleModel !== textStyleModel.ecModel) {
    var rich = (textStyleModel.option || EMPTY_OBJ).rich;
    if (rich) {
      richItemNameMap = richItemNameMap || {};
      var richKeys = keys(rich);
      for (var i = 0; i < richKeys.length; i++) {
        var richKey = richKeys[i];
        richItemNameMap[richKey] = 1;
      }
    }
    textStyleModel = textStyleModel.parentModel;
  }
  return richItemNameMap;
}
var TEXT_PROPS_WITH_GLOBAL = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"];
var TEXT_PROPS_SELF = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"];
var TEXT_PROPS_BOX = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
function setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, isBlock, inRich) {
  globalTextStyle = !isNotNormal && globalTextStyle || EMPTY_OBJ;
  var inheritColor = opt && opt.inheritColor;
  var fillColor = textStyleModel.getShallow("color");
  var strokeColor = textStyleModel.getShallow("textBorderColor");
  var opacity = retrieve2(textStyleModel.getShallow("opacity"), globalTextStyle.opacity);
  if (fillColor === "inherit" || fillColor === "auto") {
    if (inheritColor) {
      fillColor = inheritColor;
    } else {
      fillColor = null;
    }
  }
  if (strokeColor === "inherit" || strokeColor === "auto") {
    if (inheritColor) {
      strokeColor = inheritColor;
    } else {
      strokeColor = null;
    }
  }
  if (!isAttached) {
    fillColor = fillColor || globalTextStyle.color;
    strokeColor = strokeColor || globalTextStyle.textBorderColor;
  }
  if (fillColor != null) {
    textStyle.fill = fillColor;
  }
  if (strokeColor != null) {
    textStyle.stroke = strokeColor;
  }
  var textBorderWidth = retrieve2(textStyleModel.getShallow("textBorderWidth"), globalTextStyle.textBorderWidth);
  if (textBorderWidth != null) {
    textStyle.lineWidth = textBorderWidth;
  }
  var textBorderType = retrieve2(textStyleModel.getShallow("textBorderType"), globalTextStyle.textBorderType);
  if (textBorderType != null) {
    textStyle.lineDash = textBorderType;
  }
  var textBorderDashOffset = retrieve2(textStyleModel.getShallow("textBorderDashOffset"), globalTextStyle.textBorderDashOffset);
  if (textBorderDashOffset != null) {
    textStyle.lineDashOffset = textBorderDashOffset;
  }
  if (!isNotNormal && opacity == null && !inRich) {
    opacity = opt && opt.defaultOpacity;
  }
  if (opacity != null) {
    textStyle.opacity = opacity;
  }
  if (!isNotNormal && !isAttached) {
    if (textStyle.fill == null && opt.inheritColor) {
      textStyle.fill = opt.inheritColor;
    }
  }
  for (var i = 0; i < TEXT_PROPS_WITH_GLOBAL.length; i++) {
    var key = TEXT_PROPS_WITH_GLOBAL[i];
    var val = retrieve2(textStyleModel.getShallow(key), globalTextStyle[key]);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  for (var i = 0; i < TEXT_PROPS_SELF.length; i++) {
    var key = TEXT_PROPS_SELF[i];
    var val = textStyleModel.getShallow(key);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  if (textStyle.verticalAlign == null) {
    var baseline = textStyleModel.getShallow("baseline");
    if (baseline != null) {
      textStyle.verticalAlign = baseline;
    }
  }
  if (!isBlock || !opt.disableBox) {
    for (var i = 0; i < TEXT_PROPS_BOX.length; i++) {
      var key = TEXT_PROPS_BOX[i];
      var val = textStyleModel.getShallow(key);
      if (val != null) {
        textStyle[key] = val;
      }
    }
    var borderType = textStyleModel.getShallow("borderType");
    if (borderType != null) {
      textStyle.borderDash = borderType;
    }
    if ((textStyle.backgroundColor === "auto" || textStyle.backgroundColor === "inherit") && inheritColor) {
      textStyle.backgroundColor = inheritColor;
    }
    if ((textStyle.borderColor === "auto" || textStyle.borderColor === "inherit") && inheritColor) {
      textStyle.borderColor = inheritColor;
    }
  }
}
function getFont(opt, ecModel) {
  var gTextStyleModel = ecModel && ecModel.getModel("textStyle");
  return trim$1([
    opt.fontStyle || gTextStyleModel && gTextStyleModel.getShallow("fontStyle") || "",
    opt.fontWeight || gTextStyleModel && gTextStyleModel.getShallow("fontWeight") || "",
    (opt.fontSize || gTextStyleModel && gTextStyleModel.getShallow("fontSize") || 12) + "px",
    opt.fontFamily || gTextStyleModel && gTextStyleModel.getShallow("fontFamily") || "sans-serif"
  ].join(" "));
}
var labelInner = makeInner();
function setLabelValueAnimation(label, labelStatesModels, value, getDefaultText) {
  if (!label) {
    return;
  }
  var obj = labelInner(label);
  obj.prevValue = obj.value;
  obj.value = value;
  var normalLabelModel = labelStatesModels.normal;
  obj.valueAnimation = normalLabelModel.get("valueAnimation");
  if (obj.valueAnimation) {
    obj.precision = normalLabelModel.get("precision");
    obj.defaultInterpolatedText = getDefaultText;
    obj.statesModels = labelStatesModels;
  }
}
function animateLabelValue(textEl, dataIndex, data, animatableModel, labelFetcher) {
  var labelInnerStore = labelInner(textEl);
  if (!labelInnerStore.valueAnimation || labelInnerStore.prevValue === labelInnerStore.value) {
    return;
  }
  var defaultInterpolatedText = labelInnerStore.defaultInterpolatedText;
  var currValue = retrieve2(labelInnerStore.interpolatedValue, labelInnerStore.prevValue);
  var targetValue = labelInnerStore.value;
  function during(percent) {
    var interpolated = interpolateRawValues(data, labelInnerStore.precision, currValue, targetValue, percent);
    labelInnerStore.interpolatedValue = percent === 1 ? null : interpolated;
    var labelText = getLabelText({
      labelDataIndex: dataIndex,
      labelFetcher,
      defaultText: defaultInterpolatedText ? defaultInterpolatedText(interpolated) : interpolated + ""
    }, labelInnerStore.statesModels, interpolated);
    setLabelText(textEl, labelText);
  }
  textEl.percent = 0;
  (labelInnerStore.prevValue == null ? initProps : updateProps$1)(textEl, {
    percent: 1
  }, animatableModel, dataIndex, null, during);
}
var PATH_COLOR = ["textStyle", "color"];
var textStyleParams = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"];
var tmpText = new ZRText$1();
var TextStyleMixin = function() {
  function TextStyleMixin2() {
  }
  TextStyleMixin2.prototype.getTextColor = function(isEmphasis) {
    var ecModel = this.ecModel;
    return this.getShallow("color") || (!isEmphasis && ecModel ? ecModel.get(PATH_COLOR) : null);
  };
  TextStyleMixin2.prototype.getFont = function() {
    return getFont({
      fontStyle: this.getShallow("fontStyle"),
      fontWeight: this.getShallow("fontWeight"),
      fontSize: this.getShallow("fontSize"),
      fontFamily: this.getShallow("fontFamily")
    }, this.ecModel);
  };
  TextStyleMixin2.prototype.getTextRect = function(text) {
    var style2 = {
      text,
      verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline")
    };
    for (var i = 0; i < textStyleParams.length; i++) {
      style2[textStyleParams[i]] = this.getShallow(textStyleParams[i]);
    }
    tmpText.useStyle(style2);
    tmpText.update();
    return tmpText.getBoundingRect();
  };
  return TextStyleMixin2;
}();
var TextStyleMixin$1 = TextStyleMixin;
var LINE_STYLE_KEY_MAP = [
  ["lineWidth", "width"],
  ["stroke", "color"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "type"],
  ["lineDashOffset", "dashOffset"],
  ["lineCap", "cap"],
  ["lineJoin", "join"],
  ["miterLimit"]
];
var getLineStyle = makeStyleMapper(LINE_STYLE_KEY_MAP);
var LineStyleMixin = function() {
  function LineStyleMixin2() {
  }
  LineStyleMixin2.prototype.getLineStyle = function(excludes) {
    return getLineStyle(this, excludes);
  };
  return LineStyleMixin2;
}();
var ITEM_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["stroke", "borderColor"],
  ["lineWidth", "borderWidth"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "borderType"],
  ["lineDashOffset", "borderDashOffset"],
  ["lineCap", "borderCap"],
  ["lineJoin", "borderJoin"],
  ["miterLimit", "borderMiterLimit"]
];
var getItemStyle = makeStyleMapper(ITEM_STYLE_KEY_MAP);
var ItemStyleMixin = function() {
  function ItemStyleMixin2() {
  }
  ItemStyleMixin2.prototype.getItemStyle = function(excludes, includes) {
    return getItemStyle(this, excludes, includes);
  };
  return ItemStyleMixin2;
}();
var Model = function() {
  function Model2(option, parentModel, ecModel) {
    this.parentModel = parentModel;
    this.ecModel = ecModel;
    this.option = option;
  }
  Model2.prototype.init = function(option, parentModel, ecModel) {
    var rest = [];
    for (var _i = 3; _i < arguments.length; _i++) {
      rest[_i - 3] = arguments[_i];
    }
  };
  Model2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
  };
  Model2.prototype.get = function(path, ignoreParent) {
    if (path == null) {
      return this.option;
    }
    return this._doGet(this.parsePath(path), !ignoreParent && this.parentModel);
  };
  Model2.prototype.getShallow = function(key, ignoreParent) {
    var option = this.option;
    var val = option == null ? option : option[key];
    if (val == null && !ignoreParent) {
      var parentModel = this.parentModel;
      if (parentModel) {
        val = parentModel.getShallow(key);
      }
    }
    return val;
  };
  Model2.prototype.getModel = function(path, parentModel) {
    var hasPath = path != null;
    var pathFinal = hasPath ? this.parsePath(path) : null;
    var obj = hasPath ? this._doGet(pathFinal) : this.option;
    parentModel = parentModel || this.parentModel && this.parentModel.getModel(this.resolveParentPath(pathFinal));
    return new Model2(obj, parentModel, this.ecModel);
  };
  Model2.prototype.isEmpty = function() {
    return this.option == null;
  };
  Model2.prototype.restoreData = function() {
  };
  Model2.prototype.clone = function() {
    var Ctor = this.constructor;
    return new Ctor(clone$4(this.option));
  };
  Model2.prototype.parsePath = function(path) {
    if (typeof path === "string") {
      return path.split(".");
    }
    return path;
  };
  Model2.prototype.resolveParentPath = function(path) {
    return path;
  };
  Model2.prototype.isAnimationEnabled = function() {
    if (!env$1.node && this.option) {
      if (this.option.animation != null) {
        return !!this.option.animation;
      } else if (this.parentModel) {
        return this.parentModel.isAnimationEnabled();
      }
    }
  };
  Model2.prototype._doGet = function(pathArr, parentModel) {
    var obj = this.option;
    if (!pathArr) {
      return obj;
    }
    for (var i = 0; i < pathArr.length; i++) {
      if (!pathArr[i]) {
        continue;
      }
      obj = obj && typeof obj === "object" ? obj[pathArr[i]] : null;
      if (obj == null) {
        break;
      }
    }
    if (obj == null && parentModel) {
      obj = parentModel._doGet(this.resolveParentPath(pathArr), parentModel.parentModel);
    }
    return obj;
  };
  return Model2;
}();
enableClassExtend(Model);
enableClassCheck(Model);
mixin(Model, LineStyleMixin);
mixin(Model, ItemStyleMixin);
mixin(Model, AreaStyleMixin);
mixin(Model, TextStyleMixin$1);
var Model$1 = Model;
var base = Math.round(Math.random() * 10);
function getUID(type4) {
  return [type4 || "", base++].join("_");
}
function enableSubTypeDefaulter(target) {
  var subTypeDefaulters = {};
  target.registerSubTypeDefaulter = function(componentType, defaulter) {
    var componentTypeInfo = parseClassType(componentType);
    subTypeDefaulters[componentTypeInfo.main] = defaulter;
  };
  target.determineSubType = function(componentType, option) {
    var type4 = option.type;
    if (!type4) {
      var componentTypeMain = parseClassType(componentType).main;
      if (target.hasSubTypes(componentType) && subTypeDefaulters[componentTypeMain]) {
        type4 = subTypeDefaulters[componentTypeMain](option);
      }
    }
    return type4;
  };
}
function enableTopologicalTravel(entity, dependencyGetter) {
  entity.topologicalTravel = function(targetNameList, fullNameList, callback, context) {
    if (!targetNameList.length) {
      return;
    }
    var result = makeDepndencyGraph(fullNameList);
    var graph = result.graph;
    var noEntryList = result.noEntryList;
    var targetNameSet = {};
    each$g(targetNameList, function(name) {
      targetNameSet[name] = true;
    });
    while (noEntryList.length) {
      var currComponentType = noEntryList.pop();
      var currVertex = graph[currComponentType];
      var isInTargetNameSet = !!targetNameSet[currComponentType];
      if (isInTargetNameSet) {
        callback.call(context, currComponentType, currVertex.originalDeps.slice());
        delete targetNameSet[currComponentType];
      }
      each$g(currVertex.successor, isInTargetNameSet ? removeEdgeAndAdd : removeEdge);
    }
    each$g(targetNameSet, function() {
      var errMsg = "";
      throw new Error(errMsg);
    });
    function removeEdge(succComponentType) {
      graph[succComponentType].entryCount--;
      if (graph[succComponentType].entryCount === 0) {
        noEntryList.push(succComponentType);
      }
    }
    function removeEdgeAndAdd(succComponentType) {
      targetNameSet[succComponentType] = true;
      removeEdge(succComponentType);
    }
  };
  function makeDepndencyGraph(fullNameList) {
    var graph = {};
    var noEntryList = [];
    each$g(fullNameList, function(name) {
      var thisItem = createDependencyGraphItem(graph, name);
      var originalDeps = thisItem.originalDeps = dependencyGetter(name);
      var availableDeps = getAvailableDependencies(originalDeps, fullNameList);
      thisItem.entryCount = availableDeps.length;
      if (thisItem.entryCount === 0) {
        noEntryList.push(name);
      }
      each$g(availableDeps, function(dependentName) {
        if (indexOf(thisItem.predecessor, dependentName) < 0) {
          thisItem.predecessor.push(dependentName);
        }
        var thatItem = createDependencyGraphItem(graph, dependentName);
        if (indexOf(thatItem.successor, dependentName) < 0) {
          thatItem.successor.push(name);
        }
      });
    });
    return {
      graph,
      noEntryList
    };
  }
  function createDependencyGraphItem(graph, name) {
    if (!graph[name]) {
      graph[name] = {
        predecessor: [],
        successor: []
      };
    }
    return graph[name];
  }
  function getAvailableDependencies(originalDeps, fullNameList) {
    var availableDeps = [];
    each$g(originalDeps, function(dep) {
      indexOf(fullNameList, dep) >= 0 && availableDeps.push(dep);
    });
    return availableDeps;
  }
}
function inheritDefaultOption(superOption, subOption) {
  return merge(merge({}, superOption, true), subOption, true);
}
var langEN = {
  time: {
    month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
    monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
    dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]
  },
  legend: {
    selector: {
      all: "All",
      inverse: "Inv"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "Box Select",
        polygon: "Lasso Select",
        lineX: "Horizontally Select",
        lineY: "Vertically Select",
        keep: "Keep Selections",
        clear: "Clear Selections"
      }
    },
    dataView: {
      title: "Data View",
      lang: ["Data View", "Close", "Refresh"]
    },
    dataZoom: {
      title: {
        zoom: "Zoom",
        back: "Zoom Reset"
      }
    },
    magicType: {
      title: {
        line: "Switch to Line Chart",
        bar: "Switch to Bar Chart",
        stack: "Stack",
        tiled: "Tile"
      }
    },
    restore: {
      title: "Restore"
    },
    saveAsImage: {
      title: "Save as Image",
      lang: ["Right Click to Save Image"]
    }
  },
  series: {
    typeNames: {
      pie: "Pie chart",
      bar: "Bar chart",
      line: "Line chart",
      scatter: "Scatter plot",
      effectScatter: "Ripple scatter plot",
      radar: "Radar chart",
      tree: "Tree",
      treemap: "Treemap",
      boxplot: "Boxplot",
      candlestick: "Candlestick",
      k: "K line chart",
      heatmap: "Heat map",
      map: "Map",
      parallel: "Parallel coordinate map",
      lines: "Line graph",
      graph: "Relationship graph",
      sankey: "Sankey diagram",
      funnel: "Funnel chart",
      gauge: "Gauge",
      pictorialBar: "Pictorial bar",
      themeRiver: "Theme River Map",
      sunburst: "Sunburst"
    }
  },
  aria: {
    general: {
      withTitle: 'This is a chart about "{title}"',
      withoutTitle: "This is a chart"
    },
    series: {
      single: {
        prefix: "",
        withName: " with type {seriesType} named {seriesName}.",
        withoutName: " with type {seriesType}."
      },
      multiple: {
        prefix: ". It consists of {seriesCount} series count.",
        withName: " The {seriesId} series is a {seriesType} representing {seriesName}.",
        withoutName: " The {seriesId} series is a {seriesType}.",
        separator: {
          middle: "",
          end: ""
        }
      }
    },
    data: {
      allData: "The data is as follows: ",
      partialData: "The first {displayCnt} items are: ",
      withName: "the data for {name} is {value}",
      withoutName: "{value}",
      separator: {
        middle: ", ",
        end: ". "
      }
    }
  }
};
var langZH = {
  time: {
    month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"],
    monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"],
    dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"],
    dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"]
  },
  legend: {
    selector: {
      all: "\u5168\u9009",
      inverse: "\u53CD\u9009"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "\u77E9\u5F62\u9009\u62E9",
        polygon: "\u5708\u9009",
        lineX: "\u6A2A\u5411\u9009\u62E9",
        lineY: "\u7EB5\u5411\u9009\u62E9",
        keep: "\u4FDD\u6301\u9009\u62E9",
        clear: "\u6E05\u9664\u9009\u62E9"
      }
    },
    dataView: {
      title: "\u6570\u636E\u89C6\u56FE",
      lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"]
    },
    dataZoom: {
      title: {
        zoom: "\u533A\u57DF\u7F29\u653E",
        back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F"
      }
    },
    magicType: {
      title: {
        line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE",
        bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE",
        stack: "\u5207\u6362\u4E3A\u5806\u53E0",
        tiled: "\u5207\u6362\u4E3A\u5E73\u94FA"
      }
    },
    restore: {
      title: "\u8FD8\u539F"
    },
    saveAsImage: {
      title: "\u4FDD\u5B58\u4E3A\u56FE\u7247",
      lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"]
    }
  },
  series: {
    typeNames: {
      pie: "\u997C\u56FE",
      bar: "\u67F1\u72B6\u56FE",
      line: "\u6298\u7EBF\u56FE",
      scatter: "\u6563\u70B9\u56FE",
      effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE",
      radar: "\u96F7\u8FBE\u56FE",
      tree: "\u6811\u56FE",
      treemap: "\u77E9\u5F62\u6811\u56FE",
      boxplot: "\u7BB1\u578B\u56FE",
      candlestick: "K\u7EBF\u56FE",
      k: "K\u7EBF\u56FE",
      heatmap: "\u70ED\u529B\u56FE",
      map: "\u5730\u56FE",
      parallel: "\u5E73\u884C\u5750\u6807\u56FE",
      lines: "\u7EBF\u56FE",
      graph: "\u5173\u7CFB\u56FE",
      sankey: "\u6851\u57FA\u56FE",
      funnel: "\u6F0F\u6597\u56FE",
      gauge: "\u4EEA\u8868\u76D8\u56FE",
      pictorialBar: "\u8C61\u5F62\u67F1\u56FE",
      themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE",
      sunburst: "\u65ED\u65E5\u56FE"
    }
  },
  aria: {
    general: {
      withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002",
      withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C"
    },
    series: {
      single: {
        prefix: "",
        withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002",
        withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002"
      },
      multiple: {
        prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002",
        withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C",
        withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C",
        separator: {
          middle: "\uFF1B",
          end: "\u3002"
        }
      }
    },
    data: {
      allData: "\u5176\u6570\u636E\u662F\u2014\u2014",
      partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014",
      withName: "{name}\u7684\u6570\u636E\u662F{value}",
      withoutName: "{value}",
      separator: {
        middle: "\uFF0C",
        end: ""
      }
    }
  }
};
var LOCALE_ZH = "ZH";
var LOCALE_EN = "EN";
var DEFAULT_LOCALE = LOCALE_EN;
var localeStorage = {};
var localeModels = {};
var SYSTEM_LANG = !env$1.domSupported ? DEFAULT_LOCALE : function() {
  var langStr = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
  return langStr.indexOf(LOCALE_ZH) > -1 ? LOCALE_ZH : DEFAULT_LOCALE;
}();
function registerLocale(locale2, localeObj) {
  locale2 = locale2.toUpperCase();
  localeModels[locale2] = new Model$1(localeObj);
  localeStorage[locale2] = localeObj;
}
function createLocaleObject(locale2) {
  if (isString$1(locale2)) {
    var localeObj = localeStorage[locale2.toUpperCase()] || {};
    if (locale2 === LOCALE_ZH || locale2 === LOCALE_EN) {
      return clone$4(localeObj);
    } else {
      return merge(clone$4(localeObj), clone$4(localeStorage[DEFAULT_LOCALE]), false);
    }
  } else {
    return merge(clone$4(locale2), clone$4(localeStorage[DEFAULT_LOCALE]), false);
  }
}
function getLocaleModel(lang) {
  return localeModels[lang];
}
function getDefaultLocaleModel() {
  return localeModels[DEFAULT_LOCALE];
}
registerLocale(LOCALE_EN, langEN);
registerLocale(LOCALE_ZH, langZH);
var ONE_SECOND = 1e3;
var ONE_MINUTE = ONE_SECOND * 60;
var ONE_HOUR = ONE_MINUTE * 60;
var ONE_DAY = ONE_HOUR * 24;
var ONE_YEAR = ONE_DAY * 365;
var defaultLeveledFormatter = {
  year: "{yyyy}",
  month: "{MMM}",
  day: "{d}",
  hour: "{HH}:{mm}",
  minute: "{HH}:{mm}",
  second: "{HH}:{mm}:{ss}",
  millisecond: "{HH}:{mm}:{ss} {SSS}",
  none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}"
};
var fullDayFormatter = "{yyyy}-{MM}-{dd}";
var fullLeveledFormatter = {
  year: "{yyyy}",
  month: "{yyyy}-{MM}",
  day: fullDayFormatter,
  hour: fullDayFormatter + " " + defaultLeveledFormatter.hour,
  minute: fullDayFormatter + " " + defaultLeveledFormatter.minute,
  second: fullDayFormatter + " " + defaultLeveledFormatter.second,
  millisecond: defaultLeveledFormatter.none
};
var primaryTimeUnits = ["year", "month", "day", "hour", "minute", "second", "millisecond"];
var timeUnits = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
function pad(str, len2) {
  str += "";
  return "0000".substr(0, len2 - str.length) + str;
}
function getPrimaryTimeUnit(timeUnit) {
  switch (timeUnit) {
    case "half-year":
    case "quarter":
      return "month";
    case "week":
    case "half-week":
      return "day";
    case "half-day":
    case "quarter-day":
      return "hour";
    default:
      return timeUnit;
  }
}
function isPrimaryTimeUnit(timeUnit) {
  return timeUnit === getPrimaryTimeUnit(timeUnit);
}
function getDefaultFormatPrecisionOfInterval(timeUnit) {
  switch (timeUnit) {
    case "year":
    case "month":
      return "day";
    case "millisecond":
      return "millisecond";
    default:
      return "second";
  }
}
function format$1(time, template, isUTC, lang) {
  var date4 = parseDate(time);
  var y2 = date4[fullYearGetterName(isUTC)]();
  var M2 = date4[monthGetterName(isUTC)]() + 1;
  var q2 = Math.floor((M2 - 1) / 4) + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var e2 = date4["get" + (isUTC ? "UTC" : "") + "Day"]();
  var H2 = date4[hoursGetterName(isUTC)]();
  var h = (H2 - 1) % 12 + 1;
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S2 = date4[millisecondsGetterName(isUTC)]();
  var localeModel = lang instanceof Model$1 ? lang : getLocaleModel(lang || SYSTEM_LANG) || getDefaultLocaleModel();
  var timeModel = localeModel.getModel("time");
  var month = timeModel.get("month");
  var monthAbbr = timeModel.get("monthAbbr");
  var dayOfWeek = timeModel.get("dayOfWeek");
  var dayOfWeekAbbr = timeModel.get("dayOfWeekAbbr");
  return (template || "").replace(/{yyyy}/g, y2 + "").replace(/{yy}/g, y2 % 100 + "").replace(/{Q}/g, q2 + "").replace(/{MMMM}/g, month[M2 - 1]).replace(/{MMM}/g, monthAbbr[M2 - 1]).replace(/{MM}/g, pad(M2, 2)).replace(/{M}/g, M2 + "").replace(/{dd}/g, pad(d2, 2)).replace(/{d}/g, d2 + "").replace(/{eeee}/g, dayOfWeek[e2]).replace(/{ee}/g, dayOfWeekAbbr[e2]).replace(/{e}/g, e2 + "").replace(/{HH}/g, pad(H2, 2)).replace(/{H}/g, H2 + "").replace(/{hh}/g, pad(h + "", 2)).replace(/{h}/g, h + "").replace(/{mm}/g, pad(m2, 2)).replace(/{m}/g, m2 + "").replace(/{ss}/g, pad(s, 2)).replace(/{s}/g, s + "").replace(/{SSS}/g, pad(S2, 3)).replace(/{S}/g, S2 + "");
}
function leveledFormat(tick, idx, formatter, lang, isUTC) {
  var template = null;
  if (isString$1(formatter)) {
    template = formatter;
  } else if (isFunction(formatter)) {
    template = formatter(tick.value, idx, {
      level: tick.level
    });
  } else {
    var defaults$1 = extend({}, defaultLeveledFormatter);
    if (tick.level > 0) {
      for (var i = 0; i < primaryTimeUnits.length; ++i) {
        defaults$1[primaryTimeUnits[i]] = "{primary|" + defaults$1[primaryTimeUnits[i]] + "}";
      }
    }
    var mergedFormatter = formatter ? formatter.inherit === false ? formatter : defaults(formatter, defaults$1) : defaults$1;
    var unit = getUnitFromValue(tick.value, isUTC);
    if (mergedFormatter[unit]) {
      template = mergedFormatter[unit];
    } else if (mergedFormatter.inherit) {
      var targetId = timeUnits.indexOf(unit);
      for (var i = targetId - 1; i >= 0; --i) {
        if (mergedFormatter[unit]) {
          template = mergedFormatter[unit];
          break;
        }
      }
      template = template || defaults$1.none;
    }
    if (isArray$1(template)) {
      var levelId = tick.level == null ? 0 : tick.level >= 0 ? tick.level : template.length + tick.level;
      levelId = Math.min(levelId, template.length - 1);
      template = template[levelId];
    }
  }
  return format$1(new Date(tick.value), template, isUTC, lang);
}
function getUnitFromValue(value, isUTC) {
  var date4 = parseDate(value);
  var M2 = date4[monthGetterName(isUTC)]() + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var h = date4[hoursGetterName(isUTC)]();
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S2 = date4[millisecondsGetterName(isUTC)]();
  var isSecond = S2 === 0;
  var isMinute = isSecond && s === 0;
  var isHour = isMinute && m2 === 0;
  var isDay = isHour && h === 0;
  var isMonth = isDay && d2 === 1;
  var isYear = isMonth && M2 === 1;
  if (isYear) {
    return "year";
  } else if (isMonth) {
    return "month";
  } else if (isDay) {
    return "day";
  } else if (isHour) {
    return "hour";
  } else if (isMinute) {
    return "minute";
  } else if (isSecond) {
    return "second";
  } else {
    return "millisecond";
  }
}
function getUnitValue(value, unit, isUTC) {
  var date4 = isNumber(value) ? parseDate(value) : value;
  unit = unit || getUnitFromValue(value, isUTC);
  switch (unit) {
    case "year":
      return date4[fullYearGetterName(isUTC)]();
    case "half-year":
      return date4[monthGetterName(isUTC)]() >= 6 ? 1 : 0;
    case "quarter":
      return Math.floor((date4[monthGetterName(isUTC)]() + 1) / 4);
    case "month":
      return date4[monthGetterName(isUTC)]();
    case "day":
      return date4[dateGetterName(isUTC)]();
    case "half-day":
      return date4[hoursGetterName(isUTC)]() / 24;
    case "hour":
      return date4[hoursGetterName(isUTC)]();
    case "minute":
      return date4[minutesGetterName(isUTC)]();
    case "second":
      return date4[secondsGetterName(isUTC)]();
    case "millisecond":
      return date4[millisecondsGetterName(isUTC)]();
  }
}
function fullYearGetterName(isUTC) {
  return isUTC ? "getUTCFullYear" : "getFullYear";
}
function monthGetterName(isUTC) {
  return isUTC ? "getUTCMonth" : "getMonth";
}
function dateGetterName(isUTC) {
  return isUTC ? "getUTCDate" : "getDate";
}
function hoursGetterName(isUTC) {
  return isUTC ? "getUTCHours" : "getHours";
}
function minutesGetterName(isUTC) {
  return isUTC ? "getUTCMinutes" : "getMinutes";
}
function secondsGetterName(isUTC) {
  return isUTC ? "getUTCSeconds" : "getSeconds";
}
function millisecondsGetterName(isUTC) {
  return isUTC ? "getUTCMilliseconds" : "getMilliseconds";
}
function fullYearSetterName(isUTC) {
  return isUTC ? "setUTCFullYear" : "setFullYear";
}
function monthSetterName(isUTC) {
  return isUTC ? "setUTCMonth" : "setMonth";
}
function dateSetterName(isUTC) {
  return isUTC ? "setUTCDate" : "setDate";
}
function hoursSetterName(isUTC) {
  return isUTC ? "setUTCHours" : "setHours";
}
function minutesSetterName(isUTC) {
  return isUTC ? "setUTCMinutes" : "setMinutes";
}
function secondsSetterName(isUTC) {
  return isUTC ? "setUTCSeconds" : "setSeconds";
}
function millisecondsSetterName(isUTC) {
  return isUTC ? "setUTCMilliseconds" : "setMilliseconds";
}
function addCommas(x2) {
  if (!isNumeric$1(x2)) {
    return isString$1(x2) ? x2 : "-";
  }
  var parts = (x2 + "").split(".");
  return parts[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (parts.length > 1 ? "." + parts[1] : "");
}
function toCamelCase(str, upperCaseFirst) {
  str = (str || "").toLowerCase().replace(/-(.)/g, function(match, group1) {
    return group1.toUpperCase();
  });
  if (upperCaseFirst && str) {
    str = str.charAt(0).toUpperCase() + str.slice(1);
  }
  return str;
}
var normalizeCssArray = normalizeCssArray$1;
var replaceReg = /([&<>"'])/g;
var replaceMap = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': "&quot;",
  "'": "&#39;"
};
function encodeHTML(source) {
  return source == null ? "" : (source + "").replace(replaceReg, function(str, c2) {
    return replaceMap[c2];
  });
}
function makeValueReadable(value, valueType, useUTC) {
  var USER_READABLE_DEFUALT_TIME_PATTERN = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
  function stringToUserReadable(str) {
    return str && trim$1(str) ? str : "-";
  }
  function isNumberUserReadable(num) {
    return !!(num != null && !isNaN(num) && isFinite(num));
  }
  var isTypeTime = valueType === "time";
  var isValueDate = value instanceof Date;
  if (isTypeTime || isValueDate) {
    var date4 = isTypeTime ? parseDate(value) : value;
    if (!isNaN(+date4)) {
      return format$1(date4, USER_READABLE_DEFUALT_TIME_PATTERN, useUTC);
    } else if (isValueDate) {
      return "-";
    }
  }
  if (valueType === "ordinal") {
    return isStringSafe(value) ? stringToUserReadable(value) : isNumber(value) ? isNumberUserReadable(value) ? value + "" : "-" : "-";
  }
  var numericResult = numericToNumber(value);
  return isNumberUserReadable(numericResult) ? addCommas(numericResult) : isStringSafe(value) ? stringToUserReadable(value) : typeof value === "boolean" ? value + "" : "-";
}
var TPL_VAR_ALIAS = ["a", "b", "c", "d", "e", "f", "g"];
var wrapVar = function(varName, seriesIdx) {
  return "{" + varName + (seriesIdx == null ? "" : seriesIdx) + "}";
};
function formatTpl(tpl, paramsList, encode) {
  if (!isArray$1(paramsList)) {
    paramsList = [paramsList];
  }
  var seriesLen = paramsList.length;
  if (!seriesLen) {
    return "";
  }
  var $vars = paramsList[0].$vars || [];
  for (var i = 0; i < $vars.length; i++) {
    var alias = TPL_VAR_ALIAS[i];
    tpl = tpl.replace(wrapVar(alias), wrapVar(alias, 0));
  }
  for (var seriesIdx = 0; seriesIdx < seriesLen; seriesIdx++) {
    for (var k2 = 0; k2 < $vars.length; k2++) {
      var val = paramsList[seriesIdx][$vars[k2]];
      tpl = tpl.replace(wrapVar(TPL_VAR_ALIAS[k2], seriesIdx), encode ? encodeHTML(val) : val);
    }
  }
  return tpl;
}
function formatTplSimple(tpl, param, encode) {
  each$g(param, function(value, key) {
    tpl = tpl.replace("{" + key + "}", encode ? encodeHTML(value) : value);
  });
  return tpl;
}
function getTooltipMarker(inOpt, extraCssText) {
  var opt = isString$1(inOpt) ? {
    color: inOpt,
    extraCssText
  } : inOpt || {};
  var color = opt.color;
  var type4 = opt.type;
  extraCssText = opt.extraCssText;
  var renderMode = opt.renderMode || "html";
  if (!color) {
    return "";
  }
  if (renderMode === "html") {
    return type4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>';
  } else {
    var markerId = opt.markerId || "markerX";
    return {
      renderMode,
      content: "{" + markerId + "|}  ",
      style: type4 === "subItem" ? {
        width: 4,
        height: 4,
        borderRadius: 2,
        backgroundColor: color
      } : {
        width: 10,
        height: 10,
        borderRadius: 5,
        backgroundColor: color
      }
    };
  }
}
function convertToColorString(color, defaultColor) {
  defaultColor = defaultColor || "transparent";
  return isString$1(color) ? color : isObject$4(color) ? color.colorStops && (color.colorStops[0] || {}).color || defaultColor : defaultColor;
}
function windowOpen(link, target) {
  if (target === "_blank" || target === "blank") {
    var blank = window.open();
    blank.opener = null;
    blank.location.href = link;
  } else {
    window.open(link, target);
  }
}
var each$f = each$g;
var LOCATION_PARAMS = ["left", "right", "top", "bottom", "width", "height"];
var HV_NAMES = [["width", "left", "right"], ["height", "top", "bottom"]];
function boxLayout(orient, group, gap, maxWidth, maxHeight) {
  var x2 = 0;
  var y2 = 0;
  if (maxWidth == null) {
    maxWidth = Infinity;
  }
  if (maxHeight == null) {
    maxHeight = Infinity;
  }
  var currentLineMaxSize = 0;
  group.eachChild(function(child, idx) {
    var rect = child.getBoundingRect();
    var nextChild = group.childAt(idx + 1);
    var nextChildRect = nextChild && nextChild.getBoundingRect();
    var nextX;
    var nextY;
    if (orient === "horizontal") {
      var moveX = rect.width + (nextChildRect ? -nextChildRect.x + rect.x : 0);
      nextX = x2 + moveX;
      if (nextX > maxWidth || child.newline) {
        x2 = 0;
        nextX = moveX;
        y2 += currentLineMaxSize + gap;
        currentLineMaxSize = rect.height;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.height);
      }
    } else {
      var moveY = rect.height + (nextChildRect ? -nextChildRect.y + rect.y : 0);
      nextY = y2 + moveY;
      if (nextY > maxHeight || child.newline) {
        x2 += currentLineMaxSize + gap;
        y2 = 0;
        nextY = moveY;
        currentLineMaxSize = rect.width;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.width);
      }
    }
    if (child.newline) {
      return;
    }
    child.x = x2;
    child.y = y2;
    child.markRedraw();
    orient === "horizontal" ? x2 = nextX + gap : y2 = nextY + gap;
  });
}
var box = boxLayout;
curry$1(boxLayout, "vertical");
curry$1(boxLayout, "horizontal");
function getAvailableSize(positionInfo, containerRect, margin) {
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var x2 = parsePercent(positionInfo.left, containerWidth);
  var y2 = parsePercent(positionInfo.top, containerHeight);
  var x22 = parsePercent(positionInfo.right, containerWidth);
  var y22 = parsePercent(positionInfo.bottom, containerHeight);
  (isNaN(x2) || isNaN(parseFloat(positionInfo.left))) && (x2 = 0);
  (isNaN(x22) || isNaN(parseFloat(positionInfo.right))) && (x22 = containerWidth);
  (isNaN(y2) || isNaN(parseFloat(positionInfo.top))) && (y2 = 0);
  (isNaN(y22) || isNaN(parseFloat(positionInfo.bottom))) && (y22 = containerHeight);
  margin = normalizeCssArray(margin || 0);
  return {
    width: Math.max(x22 - x2 - margin[1] - margin[3], 0),
    height: Math.max(y22 - y2 - margin[0] - margin[2], 0)
  };
}
function getLayoutRect(positionInfo, containerRect, margin) {
  margin = normalizeCssArray(margin || 0);
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var left = parsePercent(positionInfo.left, containerWidth);
  var top = parsePercent(positionInfo.top, containerHeight);
  var right = parsePercent(positionInfo.right, containerWidth);
  var bottom = parsePercent(positionInfo.bottom, containerHeight);
  var width = parsePercent(positionInfo.width, containerWidth);
  var height = parsePercent(positionInfo.height, containerHeight);
  var verticalMargin = margin[2] + margin[0];
  var horizontalMargin = margin[1] + margin[3];
  var aspect = positionInfo.aspect;
  if (isNaN(width)) {
    width = containerWidth - right - horizontalMargin - left;
  }
  if (isNaN(height)) {
    height = containerHeight - bottom - verticalMargin - top;
  }
  if (aspect != null) {
    if (isNaN(width) && isNaN(height)) {
      if (aspect > containerWidth / containerHeight) {
        width = containerWidth * 0.8;
      } else {
        height = containerHeight * 0.8;
      }
    }
    if (isNaN(width)) {
      width = aspect * height;
    }
    if (isNaN(height)) {
      height = width / aspect;
    }
  }
  if (isNaN(left)) {
    left = containerWidth - right - width - horizontalMargin;
  }
  if (isNaN(top)) {
    top = containerHeight - bottom - height - verticalMargin;
  }
  switch (positionInfo.left || positionInfo.right) {
    case "center":
      left = containerWidth / 2 - width / 2 - margin[3];
      break;
    case "right":
      left = containerWidth - width - horizontalMargin;
      break;
  }
  switch (positionInfo.top || positionInfo.bottom) {
    case "middle":
    case "center":
      top = containerHeight / 2 - height / 2 - margin[0];
      break;
    case "bottom":
      top = containerHeight - height - verticalMargin;
      break;
  }
  left = left || 0;
  top = top || 0;
  if (isNaN(width)) {
    width = containerWidth - horizontalMargin - left - (right || 0);
  }
  if (isNaN(height)) {
    height = containerHeight - verticalMargin - top - (bottom || 0);
  }
  var rect = new BoundingRect$1(left + margin[3], top + margin[0], width, height);
  rect.margin = margin;
  return rect;
}
function positionElement(el, positionInfo, containerRect, margin, opt, out2) {
  var h = !opt || !opt.hv || opt.hv[0];
  var v4 = !opt || !opt.hv || opt.hv[1];
  var boundingMode = opt && opt.boundingMode || "all";
  out2 = out2 || el;
  out2.x = el.x;
  out2.y = el.y;
  if (!h && !v4) {
    return false;
  }
  var rect;
  if (boundingMode === "raw") {
    rect = el.type === "group" ? new BoundingRect$1(0, 0, +positionInfo.width || 0, +positionInfo.height || 0) : el.getBoundingRect();
  } else {
    rect = el.getBoundingRect();
    if (el.needLocalTransform()) {
      var transform2 = el.getLocalTransform();
      rect = rect.clone();
      rect.applyTransform(transform2);
    }
  }
  var layoutRect = getLayoutRect(defaults({
    width: rect.width,
    height: rect.height
  }, positionInfo), containerRect, margin);
  var dx = h ? layoutRect.x - rect.x : 0;
  var dy = v4 ? layoutRect.y - rect.y : 0;
  if (boundingMode === "raw") {
    out2.x = dx;
    out2.y = dy;
  } else {
    out2.x += dx;
    out2.y += dy;
  }
  if (out2 === el) {
    el.markRedraw();
  }
  return true;
}
function sizeCalculable(option, hvIdx) {
  return option[HV_NAMES[hvIdx][0]] != null || option[HV_NAMES[hvIdx][1]] != null && option[HV_NAMES[hvIdx][2]] != null;
}
function fetchLayoutMode(ins) {
  var layoutMode = ins.layoutMode || ins.constructor.layoutMode;
  return isObject$4(layoutMode) ? layoutMode : layoutMode ? {
    type: layoutMode
  } : null;
}
function mergeLayoutParam(targetOption, newOption, opt) {
  var ignoreSize = opt && opt.ignoreSize;
  !isArray$1(ignoreSize) && (ignoreSize = [ignoreSize, ignoreSize]);
  var hResult = merge3(HV_NAMES[0], 0);
  var vResult = merge3(HV_NAMES[1], 1);
  copy2(HV_NAMES[0], targetOption, hResult);
  copy2(HV_NAMES[1], targetOption, vResult);
  function merge3(names2, hvIdx) {
    var newParams = {};
    var newValueCount = 0;
    var merged = {};
    var mergedValueCount = 0;
    var enoughParamNumber = 2;
    each$f(names2, function(name) {
      merged[name] = targetOption[name];
    });
    each$f(names2, function(name) {
      hasProp(newOption, name) && (newParams[name] = merged[name] = newOption[name]);
      hasValue(newParams, name) && newValueCount++;
      hasValue(merged, name) && mergedValueCount++;
    });
    if (ignoreSize[hvIdx]) {
      if (hasValue(newOption, names2[1])) {
        merged[names2[2]] = null;
      } else if (hasValue(newOption, names2[2])) {
        merged[names2[1]] = null;
      }
      return merged;
    }
    if (mergedValueCount === enoughParamNumber || !newValueCount) {
      return merged;
    } else if (newValueCount >= enoughParamNumber) {
      return newParams;
    } else {
      for (var i = 0; i < names2.length; i++) {
        var name_1 = names2[i];
        if (!hasProp(newParams, name_1) && hasProp(targetOption, name_1)) {
          newParams[name_1] = targetOption[name_1];
          break;
        }
      }
      return newParams;
    }
  }
  function hasProp(obj, name) {
    return obj.hasOwnProperty(name);
  }
  function hasValue(obj, name) {
    return obj[name] != null && obj[name] !== "auto";
  }
  function copy2(names2, target, source) {
    each$f(names2, function(name) {
      target[name] = source[name];
    });
  }
}
function getLayoutParams(source) {
  return copyLayoutParams({}, source);
}
function copyLayoutParams(target, source) {
  source && target && each$f(LOCATION_PARAMS, function(name) {
    source.hasOwnProperty(name) && (target[name] = source[name]);
  });
  return target;
}
var inner$l = makeInner();
var ComponentModel = function(_super) {
  __extends(ComponentModel2, _super);
  function ComponentModel2(option, parentModel, ecModel) {
    var _this = _super.call(this, option, parentModel, ecModel) || this;
    _this.uid = getUID("ec_cpt_model");
    return _this;
  }
  ComponentModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  ComponentModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeModel = ecModel.getTheme();
    merge(option, themeModel.get(this.mainType));
    merge(option, this.getDefaultOption());
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  ComponentModel2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, option, layoutMode);
    }
  };
  ComponentModel2.prototype.optionUpdated = function(newCptOption, isInit) {
  };
  ComponentModel2.prototype.getDefaultOption = function() {
    var ctor = this.constructor;
    if (!isExtendedClass(ctor)) {
      return ctor.defaultOption;
    }
    var fields = inner$l(this);
    if (!fields.defaultOption) {
      var optList = [];
      var clz = ctor;
      while (clz) {
        var opt = clz.prototype.defaultOption;
        opt && optList.push(opt);
        clz = clz.superClass;
      }
      var defaultOption2 = {};
      for (var i = optList.length - 1; i >= 0; i--) {
        defaultOption2 = merge(defaultOption2, optList[i], true);
      }
      fields.defaultOption = defaultOption2;
    }
    return fields.defaultOption;
  };
  ComponentModel2.prototype.getReferringComponents = function(mainType, opt) {
    var indexKey = mainType + "Index";
    var idKey = mainType + "Id";
    return queryReferringComponents(this.ecModel, mainType, {
      index: this.get(indexKey, true),
      id: this.get(idKey, true)
    }, opt);
  };
  ComponentModel2.prototype.getBoxLayoutParams = function() {
    var boxLayoutModel = this;
    return {
      left: boxLayoutModel.get("left"),
      top: boxLayoutModel.get("top"),
      right: boxLayoutModel.get("right"),
      bottom: boxLayoutModel.get("bottom"),
      width: boxLayoutModel.get("width"),
      height: boxLayoutModel.get("height")
    };
  };
  ComponentModel2.prototype.getZLevelKey = function() {
    return "";
  };
  ComponentModel2.prototype.setZLevel = function(zlevel) {
    this.option.zlevel = zlevel;
  };
  ComponentModel2.protoInitialize = function() {
    var proto2 = ComponentModel2.prototype;
    proto2.type = "component";
    proto2.id = "";
    proto2.name = "";
    proto2.mainType = "";
    proto2.subType = "";
    proto2.componentIndex = 0;
  }();
  return ComponentModel2;
}(Model$1);
mountExtend(ComponentModel, Model$1);
enableClassManagement(ComponentModel);
enableSubTypeDefaulter(ComponentModel);
enableTopologicalTravel(ComponentModel, getDependencies);
function getDependencies(componentType) {
  var deps = [];
  each$g(ComponentModel.getClassesByMainType(componentType), function(clz) {
    deps = deps.concat(clz.dependencies || clz.prototype.dependencies || []);
  });
  deps = map$1(deps, function(type4) {
    return parseClassType(type4).main;
  });
  if (componentType !== "dataset" && indexOf(deps, "dataset") <= 0) {
    deps.unshift("dataset");
  }
  return deps;
}
var ComponentModel$1 = ComponentModel;
var platform = "";
if (typeof navigator !== "undefined") {
  platform = navigator.platform || "";
}
var decalColor = "rgba(0, 0, 0, 0.2)";
var globalDefault = {
  darkMode: "auto",
  colorBy: "series",
  color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"],
  gradientColor: ["#f6efa6", "#d88273", "#bf444c"],
  aria: {
    decal: {
      decals: [{
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [2, 5],
        symbolSize: 1,
        rotation: Math.PI / 6
      }, {
        color: decalColor,
        symbol: "circle",
        dashArrayX: [[8, 8], [0, 8, 8, 0]],
        dashArrayY: [6, 0],
        symbolSize: 0.8
      }, {
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [4, 3],
        rotation: -Math.PI / 4
      }, {
        color: decalColor,
        dashArrayX: [[6, 6], [0, 6, 6, 0]],
        dashArrayY: [6, 0]
      }, {
        color: decalColor,
        dashArrayX: [[1, 0], [1, 6]],
        dashArrayY: [1, 0, 6, 0],
        rotation: Math.PI / 4
      }, {
        color: decalColor,
        symbol: "triangle",
        dashArrayX: [[9, 9], [0, 9, 9, 0]],
        dashArrayY: [7, 2],
        symbolSize: 0.75
      }]
    }
  },
  textStyle: {
    fontFamily: platform.match(/^Win/) ? "Microsoft YaHei" : "sans-serif",
    fontSize: 12,
    fontStyle: "normal",
    fontWeight: "normal"
  },
  blendMode: null,
  stateAnimation: {
    duration: 300,
    easing: "cubicOut"
  },
  animation: "auto",
  animationDuration: 1e3,
  animationDurationUpdate: 500,
  animationEasing: "cubicInOut",
  animationEasingUpdate: "cubicInOut",
  animationThreshold: 2e3,
  progressiveThreshold: 3e3,
  progressive: 400,
  hoverLayerThreshold: 3e3,
  useUTC: false
};
var VISUAL_DIMENSIONS = createHashMap(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]);
var SOURCE_FORMAT_ORIGINAL = "original";
var SOURCE_FORMAT_ARRAY_ROWS = "arrayRows";
var SOURCE_FORMAT_OBJECT_ROWS = "objectRows";
var SOURCE_FORMAT_KEYED_COLUMNS = "keyedColumns";
var SOURCE_FORMAT_TYPED_ARRAY = "typedArray";
var SOURCE_FORMAT_UNKNOWN = "unknown";
var SERIES_LAYOUT_BY_COLUMN = "column";
var SERIES_LAYOUT_BY_ROW = "row";
var BE_ORDINAL = {
  Must: 1,
  Might: 2,
  Not: 3
};
var innerGlobalModel = makeInner();
function resetSourceDefaulter(ecModel) {
  innerGlobalModel(ecModel).datasetMap = createHashMap();
}
function makeSeriesEncodeForAxisCoordSys(coordDimensions, seriesModel, source) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel || !coordDimensions) {
    return encode;
  }
  var encodeItemName = [];
  var encodeSeriesName = [];
  var ecModel = seriesModel.ecModel;
  var datasetMap = innerGlobalModel(ecModel).datasetMap;
  var key = datasetModel.uid + "_" + source.seriesLayoutBy;
  var baseCategoryDimIndex;
  var categoryWayValueDimStart;
  coordDimensions = coordDimensions.slice();
  each$g(coordDimensions, function(coordDimInfoLoose, coordDimIdx) {
    var coordDimInfo = isObject$4(coordDimInfoLoose) ? coordDimInfoLoose : coordDimensions[coordDimIdx] = {
      name: coordDimInfoLoose
    };
    if (coordDimInfo.type === "ordinal" && baseCategoryDimIndex == null) {
      baseCategoryDimIndex = coordDimIdx;
      categoryWayValueDimStart = getDataDimCountOnCoordDim(coordDimInfo);
    }
    encode[coordDimInfo.name] = [];
  });
  var datasetRecord = datasetMap.get(key) || datasetMap.set(key, {
    categoryWayDim: categoryWayValueDimStart,
    valueWayDim: 0
  });
  each$g(coordDimensions, function(coordDimInfo, coordDimIdx) {
    var coordDimName = coordDimInfo.name;
    var count2 = getDataDimCountOnCoordDim(coordDimInfo);
    if (baseCategoryDimIndex == null) {
      var start2 = datasetRecord.valueWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.valueWayDim += count2;
    } else if (baseCategoryDimIndex === coordDimIdx) {
      pushDim(encode[coordDimName], 0, count2);
      pushDim(encodeItemName, 0, count2);
    } else {
      var start2 = datasetRecord.categoryWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.categoryWayDim += count2;
    }
  });
  function pushDim(dimIdxArr, idxFrom, idxCount) {
    for (var i = 0; i < idxCount; i++) {
      dimIdxArr.push(idxFrom + i);
    }
  }
  function getDataDimCountOnCoordDim(coordDimInfo) {
    var dimsDef = coordDimInfo.dimsDef;
    return dimsDef ? dimsDef.length : 1;
  }
  encodeItemName.length && (encode.itemName = encodeItemName);
  encodeSeriesName.length && (encode.seriesName = encodeSeriesName);
  return encode;
}
function makeSeriesEncodeForNameBased(seriesModel, source, dimCount) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel) {
    return encode;
  }
  var sourceFormat = source.sourceFormat;
  var dimensionsDefine = source.dimensionsDefine;
  var potentialNameDimIndex;
  if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    each$g(dimensionsDefine, function(dim, idx) {
      if ((isObject$4(dim) ? dim.name : dim) === "name") {
        potentialNameDimIndex = idx;
      }
    });
  }
  var idxResult = function() {
    var idxRes0 = {};
    var idxRes1 = {};
    var guessRecords = [];
    for (var i = 0, len2 = Math.min(5, dimCount); i < len2; i++) {
      var guessResult = doGuessOrdinal(source.data, sourceFormat, source.seriesLayoutBy, dimensionsDefine, source.startIndex, i);
      guessRecords.push(guessResult);
      var isPureNumber = guessResult === BE_ORDINAL.Not;
      if (isPureNumber && idxRes0.v == null && i !== potentialNameDimIndex) {
        idxRes0.v = i;
      }
      if (idxRes0.n == null || idxRes0.n === idxRes0.v || !isPureNumber && guessRecords[idxRes0.n] === BE_ORDINAL.Not) {
        idxRes0.n = i;
      }
      if (fulfilled(idxRes0) && guessRecords[idxRes0.n] !== BE_ORDINAL.Not) {
        return idxRes0;
      }
      if (!isPureNumber) {
        if (guessResult === BE_ORDINAL.Might && idxRes1.v == null && i !== potentialNameDimIndex) {
          idxRes1.v = i;
        }
        if (idxRes1.n == null || idxRes1.n === idxRes1.v) {
          idxRes1.n = i;
        }
      }
    }
    function fulfilled(idxResult2) {
      return idxResult2.v != null && idxResult2.n != null;
    }
    return fulfilled(idxRes0) ? idxRes0 : fulfilled(idxRes1) ? idxRes1 : null;
  }();
  if (idxResult) {
    encode.value = [idxResult.v];
    var nameDimIndex = potentialNameDimIndex != null ? potentialNameDimIndex : idxResult.n;
    encode.itemName = [nameDimIndex];
    encode.seriesName = [nameDimIndex];
  }
  return encode;
}
function querySeriesUpstreamDatasetModel(seriesModel) {
  var thisData = seriesModel.get("data", true);
  if (!thisData) {
    return queryReferringComponents(seriesModel.ecModel, "dataset", {
      index: seriesModel.get("datasetIndex", true),
      id: seriesModel.get("datasetId", true)
    }, SINGLE_REFERRING).models[0];
  }
}
function queryDatasetUpstreamDatasetModels(datasetModel) {
  if (!datasetModel.get("transform", true) && !datasetModel.get("fromTransformResult", true)) {
    return [];
  }
  return queryReferringComponents(datasetModel.ecModel, "dataset", {
    index: datasetModel.get("fromDatasetIndex", true),
    id: datasetModel.get("fromDatasetId", true)
  }, SINGLE_REFERRING).models;
}
function guessOrdinal(source, dimIndex) {
  return doGuessOrdinal(source.data, source.sourceFormat, source.seriesLayoutBy, source.dimensionsDefine, source.startIndex, dimIndex);
}
function doGuessOrdinal(data, sourceFormat, seriesLayoutBy, dimensionsDefine, startIndex, dimIndex) {
  var result;
  var maxLoop = 5;
  if (isTypedArray(data)) {
    return BE_ORDINAL.Not;
  }
  var dimName;
  var dimType;
  if (dimensionsDefine) {
    var dimDefItem = dimensionsDefine[dimIndex];
    if (isObject$4(dimDefItem)) {
      dimName = dimDefItem.name;
      dimType = dimDefItem.type;
    } else if (isString$1(dimDefItem)) {
      dimName = dimDefItem;
    }
  }
  if (dimType != null) {
    return dimType === "ordinal" ? BE_ORDINAL.Must : BE_ORDINAL.Not;
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
      var sample = dataArrayRows[dimIndex];
      for (var i = 0; i < (sample || []).length && i < maxLoop; i++) {
        if ((result = detectValue(sample[startIndex + i])) != null) {
          return result;
        }
      }
    } else {
      for (var i = 0; i < dataArrayRows.length && i < maxLoop; i++) {
        var row = dataArrayRows[startIndex + i];
        if (row && (result = detectValue(row[dimIndex])) != null) {
          return result;
        }
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var dataObjectRows = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < dataObjectRows.length && i < maxLoop; i++) {
      var item = dataObjectRows[i];
      if (item && (result = detectValue(item[dimName])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    var dataKeyedColumns = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    var sample = dataKeyedColumns[dimName];
    if (!sample || isTypedArray(sample)) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < sample.length && i < maxLoop; i++) {
      if ((result = detectValue(sample[i])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var dataOriginal = data;
    for (var i = 0; i < dataOriginal.length && i < maxLoop; i++) {
      var item = dataOriginal[i];
      var val = getDataItemValue(item);
      if (!isArray$1(val)) {
        return BE_ORDINAL.Not;
      }
      if ((result = detectValue(val[dimIndex])) != null) {
        return result;
      }
    }
  }
  function detectValue(val2) {
    var beStr = isString$1(val2);
    if (val2 != null && isFinite(val2) && val2 !== "") {
      return beStr ? BE_ORDINAL.Might : BE_ORDINAL.Not;
    } else if (beStr && val2 !== "-") {
      return BE_ORDINAL.Must;
    }
  }
  return BE_ORDINAL.Not;
}
var internalOptionCreatorMap = createHashMap();
function registerInternalOptionCreator(mainType, creator) {
  assert(internalOptionCreatorMap.get(mainType) == null && creator);
  internalOptionCreatorMap.set(mainType, creator);
}
function concatInternalOptions(ecModel, mainType, newCmptOptionList) {
  var internalOptionCreator = internalOptionCreatorMap.get(mainType);
  if (!internalOptionCreator) {
    return newCmptOptionList;
  }
  var internalOptions = internalOptionCreator(ecModel);
  if (!internalOptions) {
    return newCmptOptionList;
  }
  return newCmptOptionList.concat(internalOptions);
}
var innerColor = makeInner();
var innerDecal = makeInner();
var PaletteMixin = function() {
  function PaletteMixin2() {
  }
  PaletteMixin2.prototype.getColorFromPalette = function(name, scope, requestNum) {
    var defaultPalette = normalizeToArray(this.get("color", true));
    var layeredPalette = this.get("colorLayer", true);
    return getFromPalette(this, innerColor, defaultPalette, layeredPalette, name, scope, requestNum);
  };
  PaletteMixin2.prototype.clearColorPalette = function() {
    clearPalette(this, innerColor);
  };
  return PaletteMixin2;
}();
function getDecalFromPalette(ecModel, name, scope, requestNum) {
  var defaultDecals = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  return getFromPalette(ecModel, innerDecal, defaultDecals, null, name, scope, requestNum);
}
function getNearestPalette(palettes, requestColorNum) {
  var paletteNum = palettes.length;
  for (var i = 0; i < paletteNum; i++) {
    if (palettes[i].length > requestColorNum) {
      return palettes[i];
    }
  }
  return palettes[paletteNum - 1];
}
function getFromPalette(that, inner2, defaultPalette, layeredPalette, name, scope, requestNum) {
  scope = scope || that;
  var scopeFields = inner2(scope);
  var paletteIdx = scopeFields.paletteIdx || 0;
  var paletteNameMap = scopeFields.paletteNameMap = scopeFields.paletteNameMap || {};
  if (paletteNameMap.hasOwnProperty(name)) {
    return paletteNameMap[name];
  }
  var palette = requestNum == null || !layeredPalette ? defaultPalette : getNearestPalette(layeredPalette, requestNum);
  palette = palette || defaultPalette;
  if (!palette || !palette.length) {
    return;
  }
  var pickedPaletteItem = palette[paletteIdx];
  if (name) {
    paletteNameMap[name] = pickedPaletteItem;
  }
  scopeFields.paletteIdx = (paletteIdx + 1) % palette.length;
  return pickedPaletteItem;
}
function clearPalette(that, inner2) {
  inner2(that).paletteIdx = 0;
  inner2(that).paletteNameMap = {};
}
var reCreateSeriesIndices;
var assertSeriesInitialized;
var initBase;
var OPTION_INNER_KEY = "\0_ec_inner";
var OPTION_INNER_VALUE = 1;
var GlobalModel = function(_super) {
  __extends(GlobalModel2, _super);
  function GlobalModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GlobalModel2.prototype.init = function(option, parentModel, ecModel, theme2, locale2, optionManager) {
    theme2 = theme2 || {};
    this.option = null;
    this._theme = new Model$1(theme2);
    this._locale = new Model$1(locale2);
    this._optionManager = optionManager;
  };
  GlobalModel2.prototype.setOption = function(option, opts, optionPreprocessorFuncs2) {
    var innerOpt = normalizeSetOptionInput(opts);
    this._optionManager.setOption(option, optionPreprocessorFuncs2, innerOpt);
    this._resetOption(null, innerOpt);
  };
  GlobalModel2.prototype.resetOption = function(type4, opt) {
    return this._resetOption(type4, normalizeSetOptionInput(opt));
  };
  GlobalModel2.prototype._resetOption = function(type4, opt) {
    var optionChanged = false;
    var optionManager = this._optionManager;
    if (!type4 || type4 === "recreate") {
      var baseOption = optionManager.mountOption(type4 === "recreate");
      if (!this.option || type4 === "recreate") {
        initBase(this, baseOption);
      } else {
        this.restoreData();
        this._mergeOption(baseOption, opt);
      }
      optionChanged = true;
    }
    if (type4 === "timeline" || type4 === "media") {
      this.restoreData();
    }
    if (!type4 || type4 === "recreate" || type4 === "timeline") {
      var timelineOption = optionManager.getTimelineOption(this);
      if (timelineOption) {
        optionChanged = true;
        this._mergeOption(timelineOption, opt);
      }
    }
    if (!type4 || type4 === "recreate" || type4 === "media") {
      var mediaOptions = optionManager.getMediaOption(this);
      if (mediaOptions.length) {
        each$g(mediaOptions, function(mediaOption) {
          optionChanged = true;
          this._mergeOption(mediaOption, opt);
        }, this);
      }
    }
    return optionChanged;
  };
  GlobalModel2.prototype.mergeOption = function(option) {
    this._mergeOption(option, null);
  };
  GlobalModel2.prototype._mergeOption = function(newOption, opt) {
    var option = this.option;
    var componentsMap = this._componentsMap;
    var componentsCount = this._componentsCount;
    var newCmptTypes = [];
    var newCmptTypeMap = createHashMap();
    var replaceMergeMainTypeMap = opt && opt.replaceMergeMainTypeMap;
    resetSourceDefaulter(this);
    each$g(newOption, function(componentOption, mainType) {
      if (componentOption == null) {
        return;
      }
      if (!ComponentModel$1.hasClass(mainType)) {
        option[mainType] = option[mainType] == null ? clone$4(componentOption) : merge(option[mainType], componentOption, true);
      } else if (mainType) {
        newCmptTypes.push(mainType);
        newCmptTypeMap.set(mainType, true);
      }
    });
    if (replaceMergeMainTypeMap) {
      replaceMergeMainTypeMap.each(function(val, mainTypeInReplaceMerge) {
        if (ComponentModel$1.hasClass(mainTypeInReplaceMerge) && !newCmptTypeMap.get(mainTypeInReplaceMerge)) {
          newCmptTypes.push(mainTypeInReplaceMerge);
          newCmptTypeMap.set(mainTypeInReplaceMerge, true);
        }
      });
    }
    ComponentModel$1.topologicalTravel(newCmptTypes, ComponentModel$1.getAllClassMainTypes(), visitComponent, this);
    function visitComponent(mainType) {
      var newCmptOptionList = concatInternalOptions(this, mainType, normalizeToArray(newOption[mainType]));
      var oldCmptList = componentsMap.get(mainType);
      var mergeMode = !oldCmptList ? "replaceAll" : replaceMergeMainTypeMap && replaceMergeMainTypeMap.get(mainType) ? "replaceMerge" : "normalMerge";
      var mappingResult = mappingToExists(oldCmptList, newCmptOptionList, mergeMode);
      setComponentTypeToKeyInfo(mappingResult, mainType, ComponentModel$1);
      option[mainType] = null;
      componentsMap.set(mainType, null);
      componentsCount.set(mainType, 0);
      var optionsByMainType = [];
      var cmptsByMainType = [];
      var cmptsCountByMainType = 0;
      var tooltipExists;
      each$g(mappingResult, function(resultItem, index2) {
        var componentModel = resultItem.existing;
        var newCmptOption = resultItem.newOption;
        if (!newCmptOption) {
          if (componentModel) {
            componentModel.mergeOption({}, this);
            componentModel.optionUpdated({}, false);
          }
        } else {
          var isSeriesType = mainType === "series";
          var ComponentModelClass = ComponentModel$1.getClass(mainType, resultItem.keyInfo.subType, !isSeriesType);
          if (!ComponentModelClass) {
            return;
          }
          if (mainType === "tooltip") {
            if (tooltipExists) {
              return;
            }
            tooltipExists = true;
          }
          if (componentModel && componentModel.constructor === ComponentModelClass) {
            componentModel.name = resultItem.keyInfo.name;
            componentModel.mergeOption(newCmptOption, this);
            componentModel.optionUpdated(newCmptOption, false);
          } else {
            var extraOpt = extend({
              componentIndex: index2
            }, resultItem.keyInfo);
            componentModel = new ComponentModelClass(newCmptOption, this, this, extraOpt);
            extend(componentModel, extraOpt);
            if (resultItem.brandNew) {
              componentModel.__requireNewView = true;
            }
            componentModel.init(newCmptOption, this, this);
            componentModel.optionUpdated(null, true);
          }
        }
        if (componentModel) {
          optionsByMainType.push(componentModel.option);
          cmptsByMainType.push(componentModel);
          cmptsCountByMainType++;
        } else {
          optionsByMainType.push(void 0);
          cmptsByMainType.push(void 0);
        }
      }, this);
      option[mainType] = optionsByMainType;
      componentsMap.set(mainType, cmptsByMainType);
      componentsCount.set(mainType, cmptsCountByMainType);
      if (mainType === "series") {
        reCreateSeriesIndices(this);
      }
    }
    if (!this._seriesIndices) {
      reCreateSeriesIndices(this);
    }
  };
  GlobalModel2.prototype.getOption = function() {
    var option = clone$4(this.option);
    each$g(option, function(optInMainType, mainType) {
      if (ComponentModel$1.hasClass(mainType)) {
        var opts = normalizeToArray(optInMainType);
        var realLen = opts.length;
        var metNonInner = false;
        for (var i = realLen - 1; i >= 0; i--) {
          if (opts[i] && !isComponentIdInternal(opts[i])) {
            metNonInner = true;
          } else {
            opts[i] = null;
            !metNonInner && realLen--;
          }
        }
        opts.length = realLen;
        option[mainType] = opts;
      }
    });
    delete option[OPTION_INNER_KEY];
    return option;
  };
  GlobalModel2.prototype.getTheme = function() {
    return this._theme;
  };
  GlobalModel2.prototype.getLocaleModel = function() {
    return this._locale;
  };
  GlobalModel2.prototype.setUpdatePayload = function(payload) {
    this._payload = payload;
  };
  GlobalModel2.prototype.getUpdatePayload = function() {
    return this._payload;
  };
  GlobalModel2.prototype.getComponent = function(mainType, idx) {
    var list = this._componentsMap.get(mainType);
    if (list) {
      var cmpt = list[idx || 0];
      if (cmpt) {
        return cmpt;
      } else if (idx == null) {
        for (var i = 0; i < list.length; i++) {
          if (list[i]) {
            return list[i];
          }
        }
      }
    }
  };
  GlobalModel2.prototype.queryComponents = function(condition) {
    var mainType = condition.mainType;
    if (!mainType) {
      return [];
    }
    var index2 = condition.index;
    var id2 = condition.id;
    var name = condition.name;
    var cmpts = this._componentsMap.get(mainType);
    if (!cmpts || !cmpts.length) {
      return [];
    }
    var result;
    if (index2 != null) {
      result = [];
      each$g(normalizeToArray(index2), function(idx) {
        cmpts[idx] && result.push(cmpts[idx]);
      });
    } else if (id2 != null) {
      result = queryByIdOrName("id", id2, cmpts);
    } else if (name != null) {
      result = queryByIdOrName("name", name, cmpts);
    } else {
      result = filter(cmpts, function(cmpt) {
        return !!cmpt;
      });
    }
    return filterBySubType(result, condition);
  };
  GlobalModel2.prototype.findComponents = function(condition) {
    var query = condition.query;
    var mainType = condition.mainType;
    var queryCond = getQueryCond(query);
    var result = queryCond ? this.queryComponents(queryCond) : filter(this._componentsMap.get(mainType), function(cmpt) {
      return !!cmpt;
    });
    return doFilter(filterBySubType(result, condition));
    function getQueryCond(q2) {
      var indexAttr = mainType + "Index";
      var idAttr = mainType + "Id";
      var nameAttr = mainType + "Name";
      return q2 && (q2[indexAttr] != null || q2[idAttr] != null || q2[nameAttr] != null) ? {
        mainType,
        index: q2[indexAttr],
        id: q2[idAttr],
        name: q2[nameAttr]
      } : null;
    }
    function doFilter(res) {
      return condition.filter ? filter(res, condition.filter) : res;
    }
  };
  GlobalModel2.prototype.eachComponent = function(mainType, cb2, context) {
    var componentsMap = this._componentsMap;
    if (isFunction(mainType)) {
      var ctxForAll_1 = cb2;
      var cbForAll_1 = mainType;
      componentsMap.each(function(cmpts2, componentType) {
        for (var i2 = 0; cmpts2 && i2 < cmpts2.length; i2++) {
          var cmpt2 = cmpts2[i2];
          cmpt2 && cbForAll_1.call(ctxForAll_1, componentType, cmpt2, cmpt2.componentIndex);
        }
      });
    } else {
      var cmpts = isString$1(mainType) ? componentsMap.get(mainType) : isObject$4(mainType) ? this.findComponents(mainType) : null;
      for (var i = 0; cmpts && i < cmpts.length; i++) {
        var cmpt = cmpts[i];
        cmpt && cb2.call(context, cmpt, cmpt.componentIndex);
      }
    }
  };
  GlobalModel2.prototype.getSeriesByName = function(name) {
    var nameStr = convertOptionIdName(name, null);
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && nameStr != null && oneSeries.name === nameStr;
    });
  };
  GlobalModel2.prototype.getSeriesByIndex = function(seriesIndex) {
    return this._componentsMap.get("series")[seriesIndex];
  };
  GlobalModel2.prototype.getSeriesByType = function(subType) {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && oneSeries.subType === subType;
    });
  };
  GlobalModel2.prototype.getSeries = function() {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries;
    });
  };
  GlobalModel2.prototype.getSeriesCount = function() {
    return this._componentsCount.get("series");
  };
  GlobalModel2.prototype.eachSeries = function(cb2, context) {
    assertSeriesInitialized(this);
    each$g(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      cb2.call(context, series, rawSeriesIndex);
    }, this);
  };
  GlobalModel2.prototype.eachRawSeries = function(cb2, context) {
    each$g(this._componentsMap.get("series"), function(series) {
      series && cb2.call(context, series, series.componentIndex);
    });
  };
  GlobalModel2.prototype.eachSeriesByType = function(subType, cb2, context) {
    assertSeriesInitialized(this);
    each$g(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      if (series.subType === subType) {
        cb2.call(context, series, rawSeriesIndex);
      }
    }, this);
  };
  GlobalModel2.prototype.eachRawSeriesByType = function(subType, cb2, context) {
    return each$g(this.getSeriesByType(subType), cb2, context);
  };
  GlobalModel2.prototype.isSeriesFiltered = function(seriesModel) {
    assertSeriesInitialized(this);
    return this._seriesIndicesMap.get(seriesModel.componentIndex) == null;
  };
  GlobalModel2.prototype.getCurrentSeriesIndices = function() {
    return (this._seriesIndices || []).slice();
  };
  GlobalModel2.prototype.filterSeries = function(cb2, context) {
    assertSeriesInitialized(this);
    var newSeriesIndices = [];
    each$g(this._seriesIndices, function(seriesRawIdx) {
      var series = this._componentsMap.get("series")[seriesRawIdx];
      cb2.call(context, series, seriesRawIdx) && newSeriesIndices.push(seriesRawIdx);
    }, this);
    this._seriesIndices = newSeriesIndices;
    this._seriesIndicesMap = createHashMap(newSeriesIndices);
  };
  GlobalModel2.prototype.restoreData = function(payload) {
    reCreateSeriesIndices(this);
    var componentsMap = this._componentsMap;
    var componentTypes = [];
    componentsMap.each(function(components, componentType) {
      if (ComponentModel$1.hasClass(componentType)) {
        componentTypes.push(componentType);
      }
    });
    ComponentModel$1.topologicalTravel(componentTypes, ComponentModel$1.getAllClassMainTypes(), function(componentType) {
      each$g(componentsMap.get(componentType), function(component) {
        if (component && (componentType !== "series" || !isNotTargetSeries(component, payload))) {
          component.restoreData();
        }
      });
    });
  };
  GlobalModel2.internalField = function() {
    reCreateSeriesIndices = function(ecModel) {
      var seriesIndices = ecModel._seriesIndices = [];
      each$g(ecModel._componentsMap.get("series"), function(series) {
        series && seriesIndices.push(series.componentIndex);
      });
      ecModel._seriesIndicesMap = createHashMap(seriesIndices);
    };
    assertSeriesInitialized = function(ecModel) {
    };
    initBase = function(ecModel, baseOption) {
      ecModel.option = {};
      ecModel.option[OPTION_INNER_KEY] = OPTION_INNER_VALUE;
      ecModel._componentsMap = createHashMap({
        series: []
      });
      ecModel._componentsCount = createHashMap();
      var airaOption = baseOption.aria;
      if (isObject$4(airaOption) && airaOption.enabled == null) {
        airaOption.enabled = true;
      }
      mergeTheme(baseOption, ecModel._theme.option);
      merge(baseOption, globalDefault, false);
      ecModel._mergeOption(baseOption, null);
    };
  }();
  return GlobalModel2;
}(Model$1);
function isNotTargetSeries(seriesModel, payload) {
  if (payload) {
    var index2 = payload.seriesIndex;
    var id2 = payload.seriesId;
    var name_1 = payload.seriesName;
    return index2 != null && seriesModel.componentIndex !== index2 || id2 != null && seriesModel.id !== id2 || name_1 != null && seriesModel.name !== name_1;
  }
}
function mergeTheme(option, theme2) {
  var notMergeColorLayer = option.color && !option.colorLayer;
  each$g(theme2, function(themeItem, name) {
    if (name === "colorLayer" && notMergeColorLayer) {
      return;
    }
    if (!ComponentModel$1.hasClass(name)) {
      if (typeof themeItem === "object") {
        option[name] = !option[name] ? clone$4(themeItem) : merge(option[name], themeItem, false);
      } else {
        if (option[name] == null) {
          option[name] = themeItem;
        }
      }
    }
  });
}
function queryByIdOrName(attr, idOrName, cmpts) {
  if (isArray$1(idOrName)) {
    var keyMap_1 = createHashMap();
    each$g(idOrName, function(idOrNameItem) {
      if (idOrNameItem != null) {
        var idName = convertOptionIdName(idOrNameItem, null);
        idName != null && keyMap_1.set(idOrNameItem, true);
      }
    });
    return filter(cmpts, function(cmpt) {
      return cmpt && keyMap_1.get(cmpt[attr]);
    });
  } else {
    var idName_1 = convertOptionIdName(idOrName, null);
    return filter(cmpts, function(cmpt) {
      return cmpt && idName_1 != null && cmpt[attr] === idName_1;
    });
  }
}
function filterBySubType(components, condition) {
  return condition.hasOwnProperty("subType") ? filter(components, function(cmpt) {
    return cmpt && cmpt.subType === condition.subType;
  }) : components;
}
function normalizeSetOptionInput(opts) {
  var replaceMergeMainTypeMap = createHashMap();
  opts && each$g(normalizeToArray(opts.replaceMerge), function(mainType) {
    replaceMergeMainTypeMap.set(mainType, true);
  });
  return {
    replaceMergeMainTypeMap
  };
}
mixin(GlobalModel, PaletteMixin);
var GlobalModel$1 = GlobalModel;
var availableMethods = [
  "getDom",
  "getZr",
  "getWidth",
  "getHeight",
  "getDevicePixelRatio",
  "dispatchAction",
  "isSSR",
  "isDisposed",
  "on",
  "off",
  "getDataURL",
  "getConnectedDataURL",
  "getOption",
  "getId",
  "updateLabelLayout"
];
var ExtensionAPI = function() {
  function ExtensionAPI2(ecInstance) {
    each$g(availableMethods, function(methodName) {
      this[methodName] = bind$1(ecInstance[methodName], ecInstance);
    }, this);
  }
  return ExtensionAPI2;
}();
var ExtensionAPI$1 = ExtensionAPI;
var coordinateSystemCreators = {};
var CoordinateSystemManager = function() {
  function CoordinateSystemManager2() {
    this._coordinateSystems = [];
  }
  CoordinateSystemManager2.prototype.create = function(ecModel, api) {
    var coordinateSystems = [];
    each$g(coordinateSystemCreators, function(creater, type4) {
      var list = creater.create(ecModel, api);
      coordinateSystems = coordinateSystems.concat(list || []);
    });
    this._coordinateSystems = coordinateSystems;
  };
  CoordinateSystemManager2.prototype.update = function(ecModel, api) {
    each$g(this._coordinateSystems, function(coordSys) {
      coordSys.update && coordSys.update(ecModel, api);
    });
  };
  CoordinateSystemManager2.prototype.getCoordinateSystems = function() {
    return this._coordinateSystems.slice();
  };
  CoordinateSystemManager2.register = function(type4, creator) {
    coordinateSystemCreators[type4] = creator;
  };
  CoordinateSystemManager2.get = function(type4) {
    return coordinateSystemCreators[type4];
  };
  return CoordinateSystemManager2;
}();
var CoordinateSystem = CoordinateSystemManager;
var QUERY_REG = /^(min|max)?(.+)$/;
var OptionManager = function() {
  function OptionManager2(api) {
    this._timelineOptions = [];
    this._mediaList = [];
    this._currentMediaIndices = [];
    this._api = api;
  }
  OptionManager2.prototype.setOption = function(rawOption, optionPreprocessorFuncs2, opt) {
    if (rawOption) {
      each$g(normalizeToArray(rawOption.series), function(series) {
        series && series.data && isTypedArray(series.data) && setAsPrimitive(series.data);
      });
      each$g(normalizeToArray(rawOption.dataset), function(dataset) {
        dataset && dataset.source && isTypedArray(dataset.source) && setAsPrimitive(dataset.source);
      });
    }
    rawOption = clone$4(rawOption);
    var optionBackup = this._optionBackup;
    var newParsedOption = parseRawOption(rawOption, optionPreprocessorFuncs2, !optionBackup);
    this._newBaseOption = newParsedOption.baseOption;
    if (optionBackup) {
      if (newParsedOption.timelineOptions.length) {
        optionBackup.timelineOptions = newParsedOption.timelineOptions;
      }
      if (newParsedOption.mediaList.length) {
        optionBackup.mediaList = newParsedOption.mediaList;
      }
      if (newParsedOption.mediaDefault) {
        optionBackup.mediaDefault = newParsedOption.mediaDefault;
      }
    } else {
      this._optionBackup = newParsedOption;
    }
  };
  OptionManager2.prototype.mountOption = function(isRecreate) {
    var optionBackup = this._optionBackup;
    this._timelineOptions = optionBackup.timelineOptions;
    this._mediaList = optionBackup.mediaList;
    this._mediaDefault = optionBackup.mediaDefault;
    this._currentMediaIndices = [];
    return clone$4(isRecreate ? optionBackup.baseOption : this._newBaseOption);
  };
  OptionManager2.prototype.getTimelineOption = function(ecModel) {
    var option;
    var timelineOptions = this._timelineOptions;
    if (timelineOptions.length) {
      var timelineModel = ecModel.getComponent("timeline");
      if (timelineModel) {
        option = clone$4(timelineOptions[timelineModel.getCurrentIndex()]);
      }
    }
    return option;
  };
  OptionManager2.prototype.getMediaOption = function(ecModel) {
    var ecWidth = this._api.getWidth();
    var ecHeight = this._api.getHeight();
    var mediaList = this._mediaList;
    var mediaDefault = this._mediaDefault;
    var indices = [];
    var result = [];
    if (!mediaList.length && !mediaDefault) {
      return result;
    }
    for (var i = 0, len2 = mediaList.length; i < len2; i++) {
      if (applyMediaQuery(mediaList[i].query, ecWidth, ecHeight)) {
        indices.push(i);
      }
    }
    if (!indices.length && mediaDefault) {
      indices = [-1];
    }
    if (indices.length && !indicesEquals(indices, this._currentMediaIndices)) {
      result = map$1(indices, function(index2) {
        return clone$4(index2 === -1 ? mediaDefault.option : mediaList[index2].option);
      });
    }
    this._currentMediaIndices = indices;
    return result;
  };
  return OptionManager2;
}();
function parseRawOption(rawOption, optionPreprocessorFuncs2, isNew) {
  var mediaList = [];
  var mediaDefault;
  var baseOption;
  var declaredBaseOption = rawOption.baseOption;
  var timelineOnRoot = rawOption.timeline;
  var timelineOptionsOnRoot = rawOption.options;
  var mediaOnRoot = rawOption.media;
  var hasMedia = !!rawOption.media;
  var hasTimeline = !!(timelineOptionsOnRoot || timelineOnRoot || declaredBaseOption && declaredBaseOption.timeline);
  if (declaredBaseOption) {
    baseOption = declaredBaseOption;
    if (!baseOption.timeline) {
      baseOption.timeline = timelineOnRoot;
    }
  } else {
    if (hasTimeline || hasMedia) {
      rawOption.options = rawOption.media = null;
    }
    baseOption = rawOption;
  }
  if (hasMedia) {
    if (isArray$1(mediaOnRoot)) {
      each$g(mediaOnRoot, function(singleMedia) {
        if (singleMedia && singleMedia.option) {
          if (singleMedia.query) {
            mediaList.push(singleMedia);
          } else if (!mediaDefault) {
            mediaDefault = singleMedia;
          }
        }
      });
    }
  }
  doPreprocess(baseOption);
  each$g(timelineOptionsOnRoot, function(option) {
    return doPreprocess(option);
  });
  each$g(mediaList, function(media) {
    return doPreprocess(media.option);
  });
  function doPreprocess(option) {
    each$g(optionPreprocessorFuncs2, function(preProcess) {
      preProcess(option, isNew);
    });
  }
  return {
    baseOption,
    timelineOptions: timelineOptionsOnRoot || [],
    mediaDefault,
    mediaList
  };
}
function applyMediaQuery(query, ecWidth, ecHeight) {
  var realMap = {
    width: ecWidth,
    height: ecHeight,
    aspectratio: ecWidth / ecHeight
  };
  var applicatable = true;
  each$g(query, function(value, attr) {
    var matched = attr.match(QUERY_REG);
    if (!matched || !matched[1] || !matched[2]) {
      return;
    }
    var operator = matched[1];
    var realAttr = matched[2].toLowerCase();
    if (!compare(realMap[realAttr], value, operator)) {
      applicatable = false;
    }
  });
  return applicatable;
}
function compare(real, expect, operator) {
  if (operator === "min") {
    return real >= expect;
  } else if (operator === "max") {
    return real <= expect;
  } else {
    return real === expect;
  }
}
function indicesEquals(indices1, indices2) {
  return indices1.join(",") === indices2.join(",");
}
var OptionManager$1 = OptionManager;
var each$e = each$g;
var isObject$3 = isObject$4;
var POSSIBLE_STYLES = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
function compatEC2ItemStyle(opt) {
  var itemStyleOpt = opt && opt.itemStyle;
  if (!itemStyleOpt) {
    return;
  }
  for (var i = 0, len2 = POSSIBLE_STYLES.length; i < len2; i++) {
    var styleName = POSSIBLE_STYLES[i];
    var normalItemStyleOpt = itemStyleOpt.normal;
    var emphasisItemStyleOpt = itemStyleOpt.emphasis;
    if (normalItemStyleOpt && normalItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].normal) {
        opt[styleName].normal = normalItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].normal, normalItemStyleOpt[styleName]);
      }
      normalItemStyleOpt[styleName] = null;
    }
    if (emphasisItemStyleOpt && emphasisItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].emphasis) {
        opt[styleName].emphasis = emphasisItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].emphasis, emphasisItemStyleOpt[styleName]);
      }
      emphasisItemStyleOpt[styleName] = null;
    }
  }
}
function convertNormalEmphasis(opt, optType, useExtend) {
  if (opt && opt[optType] && (opt[optType].normal || opt[optType].emphasis)) {
    var normalOpt = opt[optType].normal;
    var emphasisOpt = opt[optType].emphasis;
    if (normalOpt) {
      if (useExtend) {
        opt[optType].normal = opt[optType].emphasis = null;
        defaults(opt[optType], normalOpt);
      } else {
        opt[optType] = normalOpt;
      }
    }
    if (emphasisOpt) {
      opt.emphasis = opt.emphasis || {};
      opt.emphasis[optType] = emphasisOpt;
      if (emphasisOpt.focus) {
        opt.emphasis.focus = emphasisOpt.focus;
      }
      if (emphasisOpt.blurScope) {
        opt.emphasis.blurScope = emphasisOpt.blurScope;
      }
    }
  }
}
function removeEC3NormalStatus(opt) {
  convertNormalEmphasis(opt, "itemStyle");
  convertNormalEmphasis(opt, "lineStyle");
  convertNormalEmphasis(opt, "areaStyle");
  convertNormalEmphasis(opt, "label");
  convertNormalEmphasis(opt, "labelLine");
  convertNormalEmphasis(opt, "upperLabel");
  convertNormalEmphasis(opt, "edgeLabel");
}
function compatTextStyle(opt, propName) {
  var labelOptSingle = isObject$3(opt) && opt[propName];
  var textStyle = isObject$3(labelOptSingle) && labelOptSingle.textStyle;
  if (textStyle) {
    for (var i = 0, len2 = TEXT_STYLE_OPTIONS.length; i < len2; i++) {
      var textPropName = TEXT_STYLE_OPTIONS[i];
      if (textStyle.hasOwnProperty(textPropName)) {
        labelOptSingle[textPropName] = textStyle[textPropName];
      }
    }
  }
}
function compatEC3CommonStyles(opt) {
  if (opt) {
    removeEC3NormalStatus(opt);
    compatTextStyle(opt, "label");
    opt.emphasis && compatTextStyle(opt.emphasis, "label");
  }
}
function processSeries(seriesOpt) {
  if (!isObject$3(seriesOpt)) {
    return;
  }
  compatEC2ItemStyle(seriesOpt);
  removeEC3NormalStatus(seriesOpt);
  compatTextStyle(seriesOpt, "label");
  compatTextStyle(seriesOpt, "upperLabel");
  compatTextStyle(seriesOpt, "edgeLabel");
  if (seriesOpt.emphasis) {
    compatTextStyle(seriesOpt.emphasis, "label");
    compatTextStyle(seriesOpt.emphasis, "upperLabel");
    compatTextStyle(seriesOpt.emphasis, "edgeLabel");
  }
  var markPoint = seriesOpt.markPoint;
  if (markPoint) {
    compatEC2ItemStyle(markPoint);
    compatEC3CommonStyles(markPoint);
  }
  var markLine = seriesOpt.markLine;
  if (markLine) {
    compatEC2ItemStyle(markLine);
    compatEC3CommonStyles(markLine);
  }
  var markArea = seriesOpt.markArea;
  if (markArea) {
    compatEC3CommonStyles(markArea);
  }
  var data = seriesOpt.data;
  if (seriesOpt.type === "graph") {
    data = data || seriesOpt.nodes;
    var edgeData = seriesOpt.links || seriesOpt.edges;
    if (edgeData && !isTypedArray(edgeData)) {
      for (var i = 0; i < edgeData.length; i++) {
        compatEC3CommonStyles(edgeData[i]);
      }
    }
    each$g(seriesOpt.categories, function(opt) {
      removeEC3NormalStatus(opt);
    });
  }
  if (data && !isTypedArray(data)) {
    for (var i = 0; i < data.length; i++) {
      compatEC3CommonStyles(data[i]);
    }
  }
  markPoint = seriesOpt.markPoint;
  if (markPoint && markPoint.data) {
    var mpData = markPoint.data;
    for (var i = 0; i < mpData.length; i++) {
      compatEC3CommonStyles(mpData[i]);
    }
  }
  markLine = seriesOpt.markLine;
  if (markLine && markLine.data) {
    var mlData = markLine.data;
    for (var i = 0; i < mlData.length; i++) {
      if (isArray$1(mlData[i])) {
        compatEC3CommonStyles(mlData[i][0]);
        compatEC3CommonStyles(mlData[i][1]);
      } else {
        compatEC3CommonStyles(mlData[i]);
      }
    }
  }
  if (seriesOpt.type === "gauge") {
    compatTextStyle(seriesOpt, "axisLabel");
    compatTextStyle(seriesOpt, "title");
    compatTextStyle(seriesOpt, "detail");
  } else if (seriesOpt.type === "treemap") {
    convertNormalEmphasis(seriesOpt.breadcrumb, "itemStyle");
    each$g(seriesOpt.levels, function(opt) {
      removeEC3NormalStatus(opt);
    });
  } else if (seriesOpt.type === "tree") {
    removeEC3NormalStatus(seriesOpt.leaves);
  }
}
function toArr(o) {
  return isArray$1(o) ? o : o ? [o] : [];
}
function toObj(o) {
  return (isArray$1(o) ? o[0] : o) || {};
}
function globalCompatStyle(option, isTheme) {
  each$e(toArr(option.series), function(seriesOpt) {
    isObject$3(seriesOpt) && processSeries(seriesOpt);
  });
  var axes = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
  isTheme && axes.push("valueAxis", "categoryAxis", "logAxis", "timeAxis");
  each$e(axes, function(axisName) {
    each$e(toArr(option[axisName]), function(axisOpt) {
      if (axisOpt) {
        compatTextStyle(axisOpt, "axisLabel");
        compatTextStyle(axisOpt.axisPointer, "label");
      }
    });
  });
  each$e(toArr(option.parallel), function(parallelOpt) {
    var parallelAxisDefault = parallelOpt && parallelOpt.parallelAxisDefault;
    compatTextStyle(parallelAxisDefault, "axisLabel");
    compatTextStyle(parallelAxisDefault && parallelAxisDefault.axisPointer, "label");
  });
  each$e(toArr(option.calendar), function(calendarOpt) {
    convertNormalEmphasis(calendarOpt, "itemStyle");
    compatTextStyle(calendarOpt, "dayLabel");
    compatTextStyle(calendarOpt, "monthLabel");
    compatTextStyle(calendarOpt, "yearLabel");
  });
  each$e(toArr(option.radar), function(radarOpt) {
    compatTextStyle(radarOpt, "name");
    if (radarOpt.name && radarOpt.axisName == null) {
      radarOpt.axisName = radarOpt.name;
      delete radarOpt.name;
    }
    if (radarOpt.nameGap != null && radarOpt.axisNameGap == null) {
      radarOpt.axisNameGap = radarOpt.nameGap;
      delete radarOpt.nameGap;
    }
  });
  each$e(toArr(option.geo), function(geoOpt) {
    if (isObject$3(geoOpt)) {
      compatEC3CommonStyles(geoOpt);
      each$e(toArr(geoOpt.regions), function(regionObj) {
        compatEC3CommonStyles(regionObj);
      });
    }
  });
  each$e(toArr(option.timeline), function(timelineOpt) {
    compatEC3CommonStyles(timelineOpt);
    convertNormalEmphasis(timelineOpt, "label");
    convertNormalEmphasis(timelineOpt, "itemStyle");
    convertNormalEmphasis(timelineOpt, "controlStyle", true);
    var data = timelineOpt.data;
    isArray$1(data) && each$g(data, function(item) {
      if (isObject$4(item)) {
        convertNormalEmphasis(item, "label");
        convertNormalEmphasis(item, "itemStyle");
      }
    });
  });
  each$e(toArr(option.toolbox), function(toolboxOpt) {
    convertNormalEmphasis(toolboxOpt, "iconStyle");
    each$e(toolboxOpt.feature, function(featureOpt) {
      convertNormalEmphasis(featureOpt, "iconStyle");
    });
  });
  compatTextStyle(toObj(option.axisPointer), "label");
  compatTextStyle(toObj(option.tooltip).axisPointer, "label");
}
function get$1(opt, path) {
  var pathArr = path.split(",");
  var obj = opt;
  for (var i = 0; i < pathArr.length; i++) {
    obj = obj && obj[pathArr[i]];
    if (obj == null) {
      break;
    }
  }
  return obj;
}
function set$1(opt, path, val, overwrite) {
  var pathArr = path.split(",");
  var obj = opt;
  var key;
  var i = 0;
  for (; i < pathArr.length - 1; i++) {
    key = pathArr[i];
    if (obj[key] == null) {
      obj[key] = {};
    }
    obj = obj[key];
  }
  if (overwrite || obj[pathArr[i]] == null) {
    obj[pathArr[i]] = val;
  }
}
function compatLayoutProperties(option) {
  option && each$g(LAYOUT_PROPERTIES, function(prop) {
    if (prop[0] in option && !(prop[1] in option)) {
      option[prop[1]] = option[prop[0]];
    }
  });
}
var LAYOUT_PROPERTIES = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]];
var COMPATITABLE_COMPONENTS = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"];
var BAR_ITEM_STYLE_MAP = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
function compatBarItemStyle(option) {
  var itemStyle = option && option.itemStyle;
  if (itemStyle) {
    for (var i = 0; i < BAR_ITEM_STYLE_MAP.length; i++) {
      var oldName = BAR_ITEM_STYLE_MAP[i][1];
      var newName = BAR_ITEM_STYLE_MAP[i][0];
      if (itemStyle[oldName] != null) {
        itemStyle[newName] = itemStyle[oldName];
      }
    }
  }
}
function compatPieLabel(option) {
  if (!option) {
    return;
  }
  if (option.alignTo === "edge" && option.margin != null && option.edgeDistance == null) {
    option.edgeDistance = option.margin;
  }
}
function compatSunburstState(option) {
  if (!option) {
    return;
  }
  if (option.downplay && !option.blur) {
    option.blur = option.downplay;
  }
}
function compatGraphFocus(option) {
  if (!option) {
    return;
  }
  if (option.focusNodeAdjacency != null) {
    option.emphasis = option.emphasis || {};
    if (option.emphasis.focus == null) {
      option.emphasis.focus = "adjacency";
    }
  }
}
function traverseTree(data, cb2) {
  if (data) {
    for (var i = 0; i < data.length; i++) {
      cb2(data[i]);
      data[i] && traverseTree(data[i].children, cb2);
    }
  }
}
function globalBackwardCompat(option, isTheme) {
  globalCompatStyle(option, isTheme);
  option.series = normalizeToArray(option.series);
  each$g(option.series, function(seriesOpt) {
    if (!isObject$4(seriesOpt)) {
      return;
    }
    var seriesType2 = seriesOpt.type;
    if (seriesType2 === "line") {
      if (seriesOpt.clipOverflow != null) {
        seriesOpt.clip = seriesOpt.clipOverflow;
      }
    } else if (seriesType2 === "pie" || seriesType2 === "gauge") {
      if (seriesOpt.clockWise != null) {
        seriesOpt.clockwise = seriesOpt.clockWise;
      }
      compatPieLabel(seriesOpt.label);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          compatPieLabel(data[i]);
        }
      }
      if (seriesOpt.hoverOffset != null) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (seriesOpt.emphasis.scaleSize = null) {
          seriesOpt.emphasis.scaleSize = seriesOpt.hoverOffset;
        }
      }
    } else if (seriesType2 === "gauge") {
      var pointerColor = get$1(seriesOpt, "pointer.color");
      pointerColor != null && set$1(seriesOpt, "itemStyle.color", pointerColor);
    } else if (seriesType2 === "bar") {
      compatBarItemStyle(seriesOpt);
      compatBarItemStyle(seriesOpt.backgroundStyle);
      compatBarItemStyle(seriesOpt.emphasis);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          if (typeof data[i] === "object") {
            compatBarItemStyle(data[i]);
            compatBarItemStyle(data[i] && data[i].emphasis);
          }
        }
      }
    } else if (seriesType2 === "sunburst") {
      var highlightPolicy = seriesOpt.highlightPolicy;
      if (highlightPolicy) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (!seriesOpt.emphasis.focus) {
          seriesOpt.emphasis.focus = highlightPolicy;
        }
      }
      compatSunburstState(seriesOpt);
      traverseTree(seriesOpt.data, compatSunburstState);
    } else if (seriesType2 === "graph" || seriesType2 === "sankey") {
      compatGraphFocus(seriesOpt);
    } else if (seriesType2 === "map") {
      if (seriesOpt.mapType && !seriesOpt.map) {
        seriesOpt.map = seriesOpt.mapType;
      }
      if (seriesOpt.mapLocation) {
        defaults(seriesOpt, seriesOpt.mapLocation);
      }
    }
    if (seriesOpt.hoverAnimation != null) {
      seriesOpt.emphasis = seriesOpt.emphasis || {};
      if (seriesOpt.emphasis && seriesOpt.emphasis.scale == null) {
        seriesOpt.emphasis.scale = seriesOpt.hoverAnimation;
      }
    }
    compatLayoutProperties(seriesOpt);
  });
  if (option.dataRange) {
    option.visualMap = option.dataRange;
  }
  each$g(COMPATITABLE_COMPONENTS, function(componentName) {
    var options = option[componentName];
    if (options) {
      if (!isArray$1(options)) {
        options = [options];
      }
      each$g(options, function(option2) {
        compatLayoutProperties(option2);
      });
    }
  });
}
function dataStack(ecModel) {
  var stackInfoMap = createHashMap();
  ecModel.eachSeries(function(seriesModel) {
    var stack = seriesModel.get("stack");
    if (stack) {
      var stackInfoList = stackInfoMap.get(stack) || stackInfoMap.set(stack, []);
      var data = seriesModel.getData();
      var stackInfo = {
        stackResultDimension: data.getCalculationInfo("stackResultDimension"),
        stackedOverDimension: data.getCalculationInfo("stackedOverDimension"),
        stackedDimension: data.getCalculationInfo("stackedDimension"),
        stackedByDimension: data.getCalculationInfo("stackedByDimension"),
        isStackedByIndex: data.getCalculationInfo("isStackedByIndex"),
        data,
        seriesModel
      };
      if (!stackInfo.stackedDimension || !(stackInfo.isStackedByIndex || stackInfo.stackedByDimension)) {
        return;
      }
      stackInfoList.length && data.setCalculationInfo("stackedOnSeries", stackInfoList[stackInfoList.length - 1].seriesModel);
      stackInfoList.push(stackInfo);
    }
  });
  stackInfoMap.each(calculateStack);
}
function calculateStack(stackInfoList) {
  each$g(stackInfoList, function(targetStackInfo, idxInStack) {
    var resultVal = [];
    var resultNaN = [NaN, NaN];
    var dims = [targetStackInfo.stackResultDimension, targetStackInfo.stackedOverDimension];
    var targetData = targetStackInfo.data;
    var isStackedByIndex = targetStackInfo.isStackedByIndex;
    targetData.modify(dims, function(v0, v12, dataIndex) {
      var sum2 = targetData.get(targetStackInfo.stackedDimension, dataIndex);
      if (isNaN(sum2)) {
        return resultNaN;
      }
      var byValue;
      var stackedDataRawIndex;
      if (isStackedByIndex) {
        stackedDataRawIndex = targetData.getRawIndex(dataIndex);
      } else {
        byValue = targetData.get(targetStackInfo.stackedByDimension, dataIndex);
      }
      var stackedOver = NaN;
      for (var j = idxInStack - 1; j >= 0; j--) {
        var stackInfo = stackInfoList[j];
        if (!isStackedByIndex) {
          stackedDataRawIndex = stackInfo.data.rawIndexOf(stackInfo.stackedByDimension, byValue);
        }
        if (stackedDataRawIndex >= 0) {
          var val = stackInfo.data.getByRawIndex(stackInfo.stackResultDimension, stackedDataRawIndex);
          if (sum2 >= 0 && val > 0 || sum2 <= 0 && val < 0) {
            sum2 = addSafe(sum2, val);
            stackedOver = val;
            break;
          }
        }
      }
      resultVal[0] = sum2;
      resultVal[1] = stackedOver;
      return resultVal;
    });
  });
}
var SourceImpl = function() {
  function SourceImpl2(fields) {
    this.data = fields.data || (fields.sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS ? {} : []);
    this.sourceFormat = fields.sourceFormat || SOURCE_FORMAT_UNKNOWN;
    this.seriesLayoutBy = fields.seriesLayoutBy || SERIES_LAYOUT_BY_COLUMN;
    this.startIndex = fields.startIndex || 0;
    this.dimensionsDetectedCount = fields.dimensionsDetectedCount;
    this.metaRawOption = fields.metaRawOption;
    var dimensionsDefine = this.dimensionsDefine = fields.dimensionsDefine;
    if (dimensionsDefine) {
      for (var i = 0; i < dimensionsDefine.length; i++) {
        var dim = dimensionsDefine[i];
        if (dim.type == null) {
          if (guessOrdinal(this, i) === BE_ORDINAL.Must) {
            dim.type = "ordinal";
          }
        }
      }
    }
  }
  return SourceImpl2;
}();
function isSourceInstance(val) {
  return val instanceof SourceImpl;
}
function createSource(sourceData, thisMetaRawOption, sourceFormat) {
  sourceFormat = sourceFormat || detectSourceFormat(sourceData);
  var seriesLayoutBy = thisMetaRawOption.seriesLayoutBy;
  var determined = determineSourceDimensions(sourceData, sourceFormat, seriesLayoutBy, thisMetaRawOption.sourceHeader, thisMetaRawOption.dimensions);
  var source = new SourceImpl({
    data: sourceData,
    sourceFormat,
    seriesLayoutBy,
    dimensionsDefine: determined.dimensionsDefine,
    startIndex: determined.startIndex,
    dimensionsDetectedCount: determined.dimensionsDetectedCount,
    metaRawOption: clone$4(thisMetaRawOption)
  });
  return source;
}
function createSourceFromSeriesDataOption(data) {
  return new SourceImpl({
    data,
    sourceFormat: isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL
  });
}
function cloneSourceShallow(source) {
  return new SourceImpl({
    data: source.data,
    sourceFormat: source.sourceFormat,
    seriesLayoutBy: source.seriesLayoutBy,
    dimensionsDefine: clone$4(source.dimensionsDefine),
    startIndex: source.startIndex,
    dimensionsDetectedCount: source.dimensionsDetectedCount
  });
}
function detectSourceFormat(data) {
  var sourceFormat = SOURCE_FORMAT_UNKNOWN;
  if (isTypedArray(data)) {
    sourceFormat = SOURCE_FORMAT_TYPED_ARRAY;
  } else if (isArray$1(data)) {
    if (data.length === 0) {
      sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
    }
    for (var i = 0, len2 = data.length; i < len2; i++) {
      var item = data[i];
      if (item == null) {
        continue;
      } else if (isArray$1(item)) {
        sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
        break;
      } else if (isObject$4(item)) {
        sourceFormat = SOURCE_FORMAT_OBJECT_ROWS;
        break;
      }
    }
  } else if (isObject$4(data)) {
    for (var key in data) {
      if (hasOwn(data, key) && isArrayLike(data[key])) {
        sourceFormat = SOURCE_FORMAT_KEYED_COLUMNS;
        break;
      }
    }
  }
  return sourceFormat;
}
function determineSourceDimensions(data, sourceFormat, seriesLayoutBy, sourceHeader, dimensionsDefine) {
  var dimensionsDetectedCount;
  var startIndex;
  if (!data) {
    return {
      dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
      startIndex,
      dimensionsDetectedCount
    };
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (sourceHeader === "auto" || sourceHeader == null) {
      arrayRowsTravelFirst(function(val) {
        if (val != null && val !== "-") {
          if (isString$1(val)) {
            startIndex == null && (startIndex = 1);
          } else {
            startIndex = 0;
          }
        }
      }, seriesLayoutBy, dataArrayRows, 10);
    } else {
      startIndex = isNumber(sourceHeader) ? sourceHeader : sourceHeader ? 1 : 0;
    }
    if (!dimensionsDefine && startIndex === 1) {
      dimensionsDefine = [];
      arrayRowsTravelFirst(function(val, index2) {
        dimensionsDefine[index2] = val != null ? val + "" : "";
      }, seriesLayoutBy, dataArrayRows, Infinity);
    }
    dimensionsDetectedCount = dimensionsDefine ? dimensionsDefine.length : seriesLayoutBy === SERIES_LAYOUT_BY_ROW ? dataArrayRows.length : dataArrayRows[0] ? dataArrayRows[0].length : null;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    if (!dimensionsDefine) {
      dimensionsDefine = objectRowsCollectDimensions(data);
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    if (!dimensionsDefine) {
      dimensionsDefine = [];
      each$g(data, function(colArr, key) {
        dimensionsDefine.push(key);
      });
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var value0 = getDataItemValue(data[0]);
    dimensionsDetectedCount = isArray$1(value0) && value0.length || 1;
  } else
    ;
  return {
    startIndex,
    dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
    dimensionsDetectedCount
  };
}
function objectRowsCollectDimensions(data) {
  var firstIndex = 0;
  var obj;
  while (firstIndex < data.length && !(obj = data[firstIndex++])) {
  }
  if (obj) {
    var dimensions_1 = [];
    each$g(obj, function(value, key) {
      dimensions_1.push(key);
    });
    return dimensions_1;
  }
}
function normalizeDimensionsOption(dimensionsDefine) {
  if (!dimensionsDefine) {
    return;
  }
  var nameMap = createHashMap();
  return map$1(dimensionsDefine, function(rawItem, index2) {
    rawItem = isObject$4(rawItem) ? rawItem : {
      name: rawItem
    };
    var item = {
      name: rawItem.name,
      displayName: rawItem.displayName,
      type: rawItem.type
    };
    if (item.name == null) {
      return item;
    }
    item.name += "";
    if (item.displayName == null) {
      item.displayName = item.name;
    }
    var exist = nameMap.get(item.name);
    if (!exist) {
      nameMap.set(item.name, {
        count: 1
      });
    } else {
      item.name += "-" + exist.count++;
    }
    return item;
  });
}
function arrayRowsTravelFirst(cb2, seriesLayoutBy, data, maxLoop) {
  if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
    for (var i = 0; i < data.length && i < maxLoop; i++) {
      cb2(data[i] ? data[i][0] : null, i);
    }
  } else {
    var value0 = data[0] || [];
    for (var i = 0; i < value0.length && i < maxLoop; i++) {
      cb2(value0[i], i);
    }
  }
}
function shouldRetrieveDataByName(source) {
  var sourceFormat = source.sourceFormat;
  return sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS;
}
var _a, _b, _c;
var providerMethods;
var mountMethods;
var DefaultDataProvider = function() {
  function DefaultDataProvider2(sourceParam, dimSize) {
    var source = !isSourceInstance(sourceParam) ? createSourceFromSeriesDataOption(sourceParam) : sourceParam;
    this._source = source;
    var data = this._data = source.data;
    if (source.sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
      this._offset = 0;
      this._dimSize = dimSize;
      this._data = data;
    }
    mountMethods(this, data, source);
  }
  DefaultDataProvider2.prototype.getSource = function() {
    return this._source;
  };
  DefaultDataProvider2.prototype.count = function() {
    return 0;
  };
  DefaultDataProvider2.prototype.getItem = function(idx, out2) {
    return;
  };
  DefaultDataProvider2.prototype.appendData = function(newData) {
  };
  DefaultDataProvider2.prototype.clean = function() {
  };
  DefaultDataProvider2.protoInitialize = function() {
    var proto2 = DefaultDataProvider2.prototype;
    proto2.pure = false;
    proto2.persistent = true;
  }();
  DefaultDataProvider2.internalField = function() {
    var _a2;
    mountMethods = function(provider, data, source) {
      var sourceFormat = source.sourceFormat;
      var seriesLayoutBy = source.seriesLayoutBy;
      var startIndex = source.startIndex;
      var dimsDef = source.dimensionsDefine;
      var methods = providerMethods[getMethodMapKey(sourceFormat, seriesLayoutBy)];
      extend(provider, methods);
      if (sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
        provider.getItem = getItemForTypedArray;
        provider.count = countForTypedArray;
        provider.fillStorage = fillStorageForTypedArray;
      } else {
        var rawItemGetter = getRawSourceItemGetter(sourceFormat, seriesLayoutBy);
        provider.getItem = bind$1(rawItemGetter, null, data, startIndex, dimsDef);
        var rawCounter = getRawSourceDataCounter(sourceFormat, seriesLayoutBy);
        provider.count = bind$1(rawCounter, null, data, startIndex, dimsDef);
      }
    };
    var getItemForTypedArray = function(idx, out2) {
      idx = idx - this._offset;
      out2 = out2 || [];
      var data = this._data;
      var dimSize = this._dimSize;
      var offset2 = dimSize * idx;
      for (var i = 0; i < dimSize; i++) {
        out2[i] = data[offset2 + i];
      }
      return out2;
    };
    var fillStorageForTypedArray = function(start2, end2, storage2, extent3) {
      var data = this._data;
      var dimSize = this._dimSize;
      for (var dim = 0; dim < dimSize; dim++) {
        var dimExtent = extent3[dim];
        var min3 = dimExtent[0] == null ? Infinity : dimExtent[0];
        var max3 = dimExtent[1] == null ? -Infinity : dimExtent[1];
        var count2 = end2 - start2;
        var arr = storage2[dim];
        for (var i = 0; i < count2; i++) {
          var val = data[i * dimSize + dim];
          arr[start2 + i] = val;
          val < min3 && (min3 = val);
          val > max3 && (max3 = val);
        }
        dimExtent[0] = min3;
        dimExtent[1] = max3;
      }
    };
    var countForTypedArray = function() {
      return this._data ? this._data.length / this._dimSize : 0;
    };
    providerMethods = (_a2 = {}, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = {
      pure: true,
      appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      }
    }, _a2[SOURCE_FORMAT_OBJECT_ROWS] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_KEYED_COLUMNS] = {
      pure: true,
      appendData: function(newData) {
        var data = this._data;
        each$g(newData, function(newCol, key) {
          var oldCol = data[key] || (data[key] = []);
          for (var i = 0; i < (newCol || []).length; i++) {
            oldCol.push(newCol[i]);
          }
        });
      }
    }, _a2[SOURCE_FORMAT_ORIGINAL] = {
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_TYPED_ARRAY] = {
      persistent: false,
      pure: true,
      appendData: function(newData) {
        this._data = newData;
      },
      clean: function() {
        this._offset += this.count();
        this._data = null;
      }
    }, _a2);
    function appendDataSimply(newData) {
      for (var i = 0; i < newData.length; i++) {
        this._data.push(newData[i]);
      }
    }
  }();
  return DefaultDataProvider2;
}();
var getItemSimply = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx];
};
var rawSourceItemGetterMap = (_a = {}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx + startIndex];
}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef, idx, out2) {
  idx += startIndex;
  var item = out2 || [];
  var data = rawData;
  for (var i = 0; i < data.length; i++) {
    var row = data[i];
    item[i] = row ? row[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_OBJECT_ROWS] = getItemSimply, _a[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef, idx, out2) {
  var item = out2 || [];
  for (var i = 0; i < dimsDef.length; i++) {
    var dimName = dimsDef[i].name;
    var col = rawData[dimName];
    item[i] = col ? col[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_ORIGINAL] = getItemSimply, _a);
function getRawSourceItemGetter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceItemGetterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var countSimply = function(rawData, startIndex, dimsDef) {
  return rawData.length;
};
var rawSourceDataCounterMap = (_b = {}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef) {
  return Math.max(0, rawData.length - startIndex);
}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef) {
  var row = rawData[0];
  return row ? Math.max(0, row.length - startIndex) : 0;
}, _b[SOURCE_FORMAT_OBJECT_ROWS] = countSimply, _b[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef) {
  var dimName = dimsDef[0].name;
  var col = rawData[dimName];
  return col ? col.length : 0;
}, _b[SOURCE_FORMAT_ORIGINAL] = countSimply, _b);
function getRawSourceDataCounter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceDataCounterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var getRawValueSimply = function(dataItem, dimIndex, property) {
  return dataItem[dimIndex];
};
var rawSourceValueGetterMap = (_c = {}, _c[SOURCE_FORMAT_ARRAY_ROWS] = getRawValueSimply, _c[SOURCE_FORMAT_OBJECT_ROWS] = function(dataItem, dimIndex, property) {
  return dataItem[property];
}, _c[SOURCE_FORMAT_KEYED_COLUMNS] = getRawValueSimply, _c[SOURCE_FORMAT_ORIGINAL] = function(dataItem, dimIndex, property) {
  var value = getDataItemValue(dataItem);
  return !(value instanceof Array) ? value : value[dimIndex];
}, _c[SOURCE_FORMAT_TYPED_ARRAY] = getRawValueSimply, _c);
function getRawSourceValueGetter(sourceFormat) {
  var method4 = rawSourceValueGetterMap[sourceFormat];
  return method4;
}
function getMethodMapKey(sourceFormat, seriesLayoutBy) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS ? sourceFormat + "_" + seriesLayoutBy : sourceFormat;
}
function retrieveRawValue(data, dataIndex, dim) {
  if (!data) {
    return;
  }
  var dataItem = data.getRawDataItem(dataIndex);
  if (dataItem == null) {
    return;
  }
  var store = data.getStore();
  var sourceFormat = store.getSource().sourceFormat;
  if (dim != null) {
    var dimIndex = data.getDimensionIndex(dim);
    var property = store.getDimensionProperty(dimIndex);
    return getRawSourceValueGetter(sourceFormat)(dataItem, dimIndex, property);
  } else {
    var result = dataItem;
    if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
      result = getDataItemValue(dataItem);
    }
    return result;
  }
}
var DIMENSION_LABEL_REG = /\{@(.+?)\}/g;
var DataFormatMixin = function() {
  function DataFormatMixin2() {
  }
  DataFormatMixin2.prototype.getDataParams = function(dataIndex, dataType) {
    var data = this.getData(dataType);
    var rawValue = this.getRawValue(dataIndex, dataType);
    var rawDataIndex = data.getRawIndex(dataIndex);
    var name = data.getName(dataIndex);
    var itemOpt = data.getRawDataItem(dataIndex);
    var style2 = data.getItemVisual(dataIndex, "style");
    var color = style2 && style2[data.getItemVisual(dataIndex, "drawType") || "fill"];
    var borderColor = style2 && style2.stroke;
    var mainType = this.mainType;
    var isSeries2 = mainType === "series";
    var userOutput = data.userOutput && data.userOutput.get();
    return {
      componentType: mainType,
      componentSubType: this.subType,
      componentIndex: this.componentIndex,
      seriesType: isSeries2 ? this.subType : null,
      seriesIndex: this.seriesIndex,
      seriesId: isSeries2 ? this.id : null,
      seriesName: isSeries2 ? this.name : null,
      name,
      dataIndex: rawDataIndex,
      data: itemOpt,
      dataType,
      value: rawValue,
      color,
      borderColor,
      dimensionNames: userOutput ? userOutput.fullDimensions : null,
      encode: userOutput ? userOutput.encode : null,
      $vars: ["seriesName", "name", "value"]
    };
  };
  DataFormatMixin2.prototype.getFormattedLabel = function(dataIndex, status, dataType, labelDimIndex, formatter, extendParams) {
    status = status || "normal";
    var data = this.getData(dataType);
    var params = this.getDataParams(dataIndex, dataType);
    if (extendParams) {
      params.value = extendParams.interpolatedValue;
    }
    if (labelDimIndex != null && isArray$1(params.value)) {
      params.value = params.value[labelDimIndex];
    }
    if (!formatter) {
      var itemModel = data.getItemModel(dataIndex);
      formatter = itemModel.get(status === "normal" ? ["label", "formatter"] : [status, "label", "formatter"]);
    }
    if (isFunction(formatter)) {
      params.status = status;
      params.dimensionIndex = labelDimIndex;
      return formatter(params);
    } else if (isString$1(formatter)) {
      var str = formatTpl(formatter, params);
      return str.replace(DIMENSION_LABEL_REG, function(origin, dimStr) {
        var len2 = dimStr.length;
        var dimLoose = dimStr;
        if (dimLoose.charAt(0) === "[" && dimLoose.charAt(len2 - 1) === "]") {
          dimLoose = +dimLoose.slice(1, len2 - 1);
        }
        var val = retrieveRawValue(data, dataIndex, dimLoose);
        if (extendParams && isArray$1(extendParams.interpolatedValue)) {
          var dimIndex = data.getDimensionIndex(dimLoose);
          if (dimIndex >= 0) {
            val = extendParams.interpolatedValue[dimIndex];
          }
        }
        return val != null ? val + "" : "";
      });
    }
  };
  DataFormatMixin2.prototype.getRawValue = function(idx, dataType) {
    return retrieveRawValue(this.getData(dataType), idx);
  };
  DataFormatMixin2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return;
  };
  return DataFormatMixin2;
}();
function normalizeTooltipFormatResult(result) {
  var markupText;
  var markupFragment;
  if (isObject$4(result)) {
    if (result.type) {
      markupFragment = result;
    }
  } else {
    markupText = result;
  }
  return {
    text: markupText,
    frag: markupFragment
  };
}
function createTask(define) {
  return new Task(define);
}
var Task = function() {
  function Task2(define) {
    define = define || {};
    this._reset = define.reset;
    this._plan = define.plan;
    this._count = define.count;
    this._onDirty = define.onDirty;
    this._dirty = true;
  }
  Task2.prototype.perform = function(performArgs) {
    var upTask = this._upstream;
    var skip = performArgs && performArgs.skip;
    if (this._dirty && upTask) {
      var context = this.context;
      context.data = context.outputData = upTask.context.outputData;
    }
    if (this.__pipeline) {
      this.__pipeline.currentTask = this;
    }
    var planResult;
    if (this._plan && !skip) {
      planResult = this._plan(this.context);
    }
    var lastModBy = normalizeModBy(this._modBy);
    var lastModDataCount = this._modDataCount || 0;
    var modBy = normalizeModBy(performArgs && performArgs.modBy);
    var modDataCount = performArgs && performArgs.modDataCount || 0;
    if (lastModBy !== modBy || lastModDataCount !== modDataCount) {
      planResult = "reset";
    }
    function normalizeModBy(val) {
      !(val >= 1) && (val = 1);
      return val;
    }
    var forceFirstProgress;
    if (this._dirty || planResult === "reset") {
      this._dirty = false;
      forceFirstProgress = this._doReset(skip);
    }
    this._modBy = modBy;
    this._modDataCount = modDataCount;
    var step = performArgs && performArgs.step;
    if (upTask) {
      this._dueEnd = upTask._outputDueEnd;
    } else {
      this._dueEnd = this._count ? this._count(this.context) : Infinity;
    }
    if (this._progress) {
      var start2 = this._dueIndex;
      var end2 = Math.min(step != null ? this._dueIndex + step : Infinity, this._dueEnd);
      if (!skip && (forceFirstProgress || start2 < end2)) {
        var progress = this._progress;
        if (isArray$1(progress)) {
          for (var i = 0; i < progress.length; i++) {
            this._doProgress(progress[i], start2, end2, modBy, modDataCount);
          }
        } else {
          this._doProgress(progress, start2, end2, modBy, modDataCount);
        }
      }
      this._dueIndex = end2;
      var outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : end2;
      this._outputDueEnd = outputDueEnd;
    } else {
      this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
    }
    return this.unfinished();
  };
  Task2.prototype.dirty = function() {
    this._dirty = true;
    this._onDirty && this._onDirty(this.context);
  };
  Task2.prototype._doProgress = function(progress, start2, end2, modBy, modDataCount) {
    iterator.reset(start2, end2, modBy, modDataCount);
    this._callingProgress = progress;
    this._callingProgress({
      start: start2,
      end: end2,
      count: end2 - start2,
      next: iterator.next
    }, this.context);
  };
  Task2.prototype._doReset = function(skip) {
    this._dueIndex = this._outputDueEnd = this._dueEnd = 0;
    this._settedOutputEnd = null;
    var progress;
    var forceFirstProgress;
    if (!skip && this._reset) {
      progress = this._reset(this.context);
      if (progress && progress.progress) {
        forceFirstProgress = progress.forceFirstProgress;
        progress = progress.progress;
      }
      if (isArray$1(progress) && !progress.length) {
        progress = null;
      }
    }
    this._progress = progress;
    this._modBy = this._modDataCount = null;
    var downstream = this._downstream;
    downstream && downstream.dirty();
    return forceFirstProgress;
  };
  Task2.prototype.unfinished = function() {
    return this._progress && this._dueIndex < this._dueEnd;
  };
  Task2.prototype.pipe = function(downTask) {
    if (this._downstream !== downTask || this._dirty) {
      this._downstream = downTask;
      downTask._upstream = this;
      downTask.dirty();
    }
  };
  Task2.prototype.dispose = function() {
    if (this._disposed) {
      return;
    }
    this._upstream && (this._upstream._downstream = null);
    this._downstream && (this._downstream._upstream = null);
    this._dirty = false;
    this._disposed = true;
  };
  Task2.prototype.getUpstream = function() {
    return this._upstream;
  };
  Task2.prototype.getDownstream = function() {
    return this._downstream;
  };
  Task2.prototype.setOutputEnd = function(end2) {
    this._outputDueEnd = this._settedOutputEnd = end2;
  };
  return Task2;
}();
var iterator = function() {
  var end2;
  var current;
  var modBy;
  var modDataCount;
  var winCount;
  var it = {
    reset: function(s, e2, sStep, sCount) {
      current = s;
      end2 = e2;
      modBy = sStep;
      modDataCount = sCount;
      winCount = Math.ceil(modDataCount / modBy);
      it.next = modBy > 1 && modDataCount > 0 ? modNext : sequentialNext;
    }
  };
  return it;
  function sequentialNext() {
    return current < end2 ? current++ : null;
  }
  function modNext() {
    var dataIndex = current % winCount * modBy + Math.ceil(current / winCount);
    var result = current >= end2 ? null : dataIndex < modDataCount ? dataIndex : current;
    current++;
    return result;
  }
}();
function parseDataValue(value, opt) {
  var dimType = opt && opt.type;
  if (dimType === "ordinal") {
    return value;
  }
  if (dimType === "time" && !isNumber(value) && value != null && value !== "-") {
    value = +parseDate(value);
  }
  return value == null || value === "" ? NaN : +value;
}
var valueParserMap = createHashMap({
  "number": function(val) {
    return parseFloat(val);
  },
  "time": function(val) {
    return +parseDate(val);
  },
  "trim": function(val) {
    return isString$1(val) ? trim$1(val) : val;
  }
});
function getRawValueParser(type4) {
  return valueParserMap.get(type4);
}
var ORDER_COMPARISON_OP_MAP = {
  lt: function(lval, rval) {
    return lval < rval;
  },
  lte: function(lval, rval) {
    return lval <= rval;
  },
  gt: function(lval, rval) {
    return lval > rval;
  },
  gte: function(lval, rval) {
    return lval >= rval;
  }
};
var FilterOrderComparator = function() {
  function FilterOrderComparator2(op, rval) {
    if (!isNumber(rval)) {
      var errMsg = "";
      throwError(errMsg);
    }
    this._opFn = ORDER_COMPARISON_OP_MAP[op];
    this._rvalFloat = numericToNumber(rval);
  }
  FilterOrderComparator2.prototype.evaluate = function(lval) {
    return isNumber(lval) ? this._opFn(lval, this._rvalFloat) : this._opFn(numericToNumber(lval), this._rvalFloat);
  };
  return FilterOrderComparator2;
}();
var SortOrderComparator = function() {
  function SortOrderComparator2(order, incomparable) {
    var isDesc = order === "desc";
    this._resultLT = isDesc ? 1 : -1;
    if (incomparable == null) {
      incomparable = isDesc ? "min" : "max";
    }
    this._incomparable = incomparable === "min" ? -Infinity : Infinity;
  }
  SortOrderComparator2.prototype.evaluate = function(lval, rval) {
    var lvalFloat = isNumber(lval) ? lval : numericToNumber(lval);
    var rvalFloat = isNumber(rval) ? rval : numericToNumber(rval);
    var lvalNotNumeric = isNaN(lvalFloat);
    var rvalNotNumeric = isNaN(rvalFloat);
    if (lvalNotNumeric) {
      lvalFloat = this._incomparable;
    }
    if (rvalNotNumeric) {
      rvalFloat = this._incomparable;
    }
    if (lvalNotNumeric && rvalNotNumeric) {
      var lvalIsStr = isString$1(lval);
      var rvalIsStr = isString$1(rval);
      if (lvalIsStr) {
        lvalFloat = rvalIsStr ? lval : 0;
      }
      if (rvalIsStr) {
        rvalFloat = lvalIsStr ? rval : 0;
      }
    }
    return lvalFloat < rvalFloat ? this._resultLT : lvalFloat > rvalFloat ? -this._resultLT : 0;
  };
  return SortOrderComparator2;
}();
var FilterEqualityComparator = function() {
  function FilterEqualityComparator2(isEq, rval) {
    this._rval = rval;
    this._isEQ = isEq;
    this._rvalTypeof = typeof rval;
    this._rvalFloat = numericToNumber(rval);
  }
  FilterEqualityComparator2.prototype.evaluate = function(lval) {
    var eqResult = lval === this._rval;
    if (!eqResult) {
      var lvalTypeof = typeof lval;
      if (lvalTypeof !== this._rvalTypeof && (lvalTypeof === "number" || this._rvalTypeof === "number")) {
        eqResult = numericToNumber(lval) === this._rvalFloat;
      }
    }
    return this._isEQ ? eqResult : !eqResult;
  };
  return FilterEqualityComparator2;
}();
function createFilterComparator(op, rval) {
  return op === "eq" || op === "ne" ? new FilterEqualityComparator(op === "eq", rval) : hasOwn(ORDER_COMPARISON_OP_MAP, op) ? new FilterOrderComparator(op, rval) : null;
}
var ExternalSource = function() {
  function ExternalSource2() {
  }
  ExternalSource2.prototype.getRawData = function() {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.getRawDataItem = function(dataIndex) {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.cloneRawData = function() {
    return;
  };
  ExternalSource2.prototype.getDimensionInfo = function(dim) {
    return;
  };
  ExternalSource2.prototype.cloneAllDimensionInfo = function() {
    return;
  };
  ExternalSource2.prototype.count = function() {
    return;
  };
  ExternalSource2.prototype.retrieveValue = function(dataIndex, dimIndex) {
    return;
  };
  ExternalSource2.prototype.retrieveValueFromItem = function(dataItem, dimIndex) {
    return;
  };
  ExternalSource2.prototype.convertValue = function(rawVal, dimInfo) {
    return parseDataValue(rawVal, dimInfo);
  };
  return ExternalSource2;
}();
function createExternalSource(internalSource, externalTransform) {
  var extSource = new ExternalSource();
  var data = internalSource.data;
  var sourceFormat = extSource.sourceFormat = internalSource.sourceFormat;
  var sourceHeaderCount = internalSource.startIndex;
  var errMsg = "";
  if (internalSource.seriesLayoutBy !== SERIES_LAYOUT_BY_COLUMN) {
    throwError(errMsg);
  }
  var dimensions = [];
  var dimsByName = {};
  var dimsDef = internalSource.dimensionsDefine;
  if (dimsDef) {
    each$g(dimsDef, function(dimDef, idx) {
      var name = dimDef.name;
      var dimDefExt = {
        index: idx,
        name,
        displayName: dimDef.displayName
      };
      dimensions.push(dimDefExt);
      if (name != null) {
        var errMsg_1 = "";
        if (hasOwn(dimsByName, name)) {
          throwError(errMsg_1);
        }
        dimsByName[name] = dimDefExt;
      }
    });
  } else {
    for (var i = 0; i < internalSource.dimensionsDetectedCount || 0; i++) {
      dimensions.push({
        index: i
      });
    }
  }
  var rawItemGetter = getRawSourceItemGetter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  if (externalTransform.__isBuiltIn) {
    extSource.getRawDataItem = function(dataIndex) {
      return rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    };
    extSource.getRawData = bind$1(getRawData, null, internalSource);
  }
  extSource.cloneRawData = bind$1(cloneRawData, null, internalSource);
  var rawCounter = getRawSourceDataCounter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  extSource.count = bind$1(rawCounter, null, data, sourceHeaderCount, dimensions);
  var rawValueGetter = getRawSourceValueGetter(sourceFormat);
  extSource.retrieveValue = function(dataIndex, dimIndex) {
    var rawItem = rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    return retrieveValueFromItem(rawItem, dimIndex);
  };
  var retrieveValueFromItem = extSource.retrieveValueFromItem = function(dataItem, dimIndex) {
    if (dataItem == null) {
      return;
    }
    var dimDef = dimensions[dimIndex];
    if (dimDef) {
      return rawValueGetter(dataItem, dimIndex, dimDef.name);
    }
  };
  extSource.getDimensionInfo = bind$1(getDimensionInfo, null, dimensions, dimsByName);
  extSource.cloneAllDimensionInfo = bind$1(cloneAllDimensionInfo, null, dimensions);
  return extSource;
}
function getRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  return upstream.data;
}
function cloneRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  var data = upstream.data;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(data[i].slice());
    }
    return result;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(extend({}, data[i]));
    }
    return result;
  }
}
function getDimensionInfo(dimensions, dimsByName, dim) {
  if (dim == null) {
    return;
  }
  if (isNumber(dim) || !isNaN(dim) && !hasOwn(dimsByName, dim)) {
    return dimensions[dim];
  } else if (hasOwn(dimsByName, dim)) {
    return dimsByName[dim];
  }
}
function cloneAllDimensionInfo(dimensions) {
  return clone$4(dimensions);
}
var externalTransformMap = createHashMap();
function registerExternalTransform(externalTransform) {
  externalTransform = clone$4(externalTransform);
  var type4 = externalTransform.type;
  var errMsg = "";
  if (!type4) {
    throwError(errMsg);
  }
  var typeParsed = type4.split(":");
  if (typeParsed.length !== 2) {
    throwError(errMsg);
  }
  var isBuiltIn = false;
  if (typeParsed[0] === "echarts") {
    type4 = typeParsed[1];
    isBuiltIn = true;
  }
  externalTransform.__isBuiltIn = isBuiltIn;
  externalTransformMap.set(type4, externalTransform);
}
function applyDataTransform(rawTransOption, sourceList, infoForPrint) {
  var pipedTransOption = normalizeToArray(rawTransOption);
  var pipeLen = pipedTransOption.length;
  var errMsg = "";
  if (!pipeLen) {
    throwError(errMsg);
  }
  for (var i = 0, len2 = pipeLen; i < len2; i++) {
    var transOption = pipedTransOption[i];
    sourceList = applySingleDataTransform(transOption, sourceList);
    if (i !== len2 - 1) {
      sourceList.length = Math.max(sourceList.length, 1);
    }
  }
  return sourceList;
}
function applySingleDataTransform(transOption, upSourceList, infoForPrint, pipeIndex) {
  var errMsg = "";
  if (!upSourceList.length) {
    throwError(errMsg);
  }
  if (!isObject$4(transOption)) {
    throwError(errMsg);
  }
  var transType = transOption.type;
  var externalTransform = externalTransformMap.get(transType);
  if (!externalTransform) {
    throwError(errMsg);
  }
  var extUpSourceList = map$1(upSourceList, function(upSource) {
    return createExternalSource(upSource, externalTransform);
  });
  var resultList = normalizeToArray(externalTransform.transform({
    upstream: extUpSourceList[0],
    upstreamList: extUpSourceList,
    config: clone$4(transOption.config)
  }));
  return map$1(resultList, function(result, resultIndex) {
    var errMsg2 = "";
    if (!isObject$4(result)) {
      throwError(errMsg2);
    }
    if (!result.data) {
      throwError(errMsg2);
    }
    var sourceFormat = detectSourceFormat(result.data);
    if (!isSupportedSourceFormat(sourceFormat)) {
      throwError(errMsg2);
    }
    var resultMetaRawOption;
    var firstUpSource = upSourceList[0];
    if (firstUpSource && resultIndex === 0 && !result.dimensions) {
      var startIndex = firstUpSource.startIndex;
      if (startIndex) {
        result.data = firstUpSource.data.slice(0, startIndex).concat(result.data);
      }
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: startIndex,
        dimensions: firstUpSource.metaRawOption.dimensions
      };
    } else {
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: 0,
        dimensions: result.dimensions
      };
    }
    return createSource(result.data, resultMetaRawOption, null);
  });
}
function isSupportedSourceFormat(sourceFormat) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS || sourceFormat === SOURCE_FORMAT_OBJECT_ROWS;
}
var UNDEFINED$1 = "undefined";
var CtorUint32Array = typeof Uint32Array === UNDEFINED$1 ? Array : Uint32Array;
var CtorUint16Array = typeof Uint16Array === UNDEFINED$1 ? Array : Uint16Array;
var CtorInt32Array$1 = typeof Int32Array === UNDEFINED$1 ? Array : Int32Array;
var CtorFloat64Array = typeof Float64Array === UNDEFINED$1 ? Array : Float64Array;
var dataCtors = {
  "float": CtorFloat64Array,
  "int": CtorInt32Array$1,
  "ordinal": Array,
  "number": Array,
  "time": CtorFloat64Array
};
var defaultDimValueGetters;
function getIndicesCtor(rawCount) {
  return rawCount > 65535 ? CtorUint32Array : CtorUint16Array;
}
function getInitialExtent() {
  return [Infinity, -Infinity];
}
function cloneChunk(originalChunk) {
  var Ctor = originalChunk.constructor;
  return Ctor === Array ? originalChunk.slice() : new Ctor(originalChunk);
}
function prepareStore(store, dimIdx, dimType, end2, append) {
  var DataCtor = dataCtors[dimType || "float"];
  if (append) {
    var oldStore = store[dimIdx];
    var oldLen = oldStore && oldStore.length;
    if (!(oldLen === end2)) {
      var newStore = new DataCtor(end2);
      for (var j = 0; j < oldLen; j++) {
        newStore[j] = oldStore[j];
      }
      store[dimIdx] = newStore;
    }
  } else {
    store[dimIdx] = new DataCtor(end2);
  }
}
var DataStore = function() {
  function DataStore2() {
    this._chunks = [];
    this._rawExtent = [];
    this._extent = [];
    this._count = 0;
    this._rawCount = 0;
    this._calcDimNameToIdx = createHashMap();
  }
  DataStore2.prototype.initData = function(provider, inputDimensions, dimValueGetter) {
    this._provider = provider;
    this._chunks = [];
    this._indices = null;
    this.getRawIndex = this._getRawIdxIdentity;
    var source = provider.getSource();
    var defaultGetter = this.defaultDimValueGetter = defaultDimValueGetters[source.sourceFormat];
    this._dimValueGetter = dimValueGetter || defaultGetter;
    this._rawExtent = [];
    shouldRetrieveDataByName(source);
    this._dimensions = map$1(inputDimensions, function(dim) {
      return {
        type: dim.type,
        property: dim.property
      };
    });
    this._initDataFromProvider(0, provider.count());
  };
  DataStore2.prototype.getProvider = function() {
    return this._provider;
  };
  DataStore2.prototype.getSource = function() {
    return this._provider.getSource();
  };
  DataStore2.prototype.ensureCalculationDimension = function(dimName, type4) {
    var calcDimNameToIdx = this._calcDimNameToIdx;
    var dimensions = this._dimensions;
    var calcDimIdx = calcDimNameToIdx.get(dimName);
    if (calcDimIdx != null) {
      if (dimensions[calcDimIdx].type === type4) {
        return calcDimIdx;
      }
    } else {
      calcDimIdx = dimensions.length;
    }
    dimensions[calcDimIdx] = {
      type: type4
    };
    calcDimNameToIdx.set(dimName, calcDimIdx);
    this._chunks[calcDimIdx] = new dataCtors[type4 || "float"](this._rawCount);
    this._rawExtent[calcDimIdx] = getInitialExtent();
    return calcDimIdx;
  };
  DataStore2.prototype.collectOrdinalMeta = function(dimIdx, ordinalMeta) {
    var chunk = this._chunks[dimIdx];
    var dim = this._dimensions[dimIdx];
    var rawExtents = this._rawExtent;
    var offset2 = dim.ordinalOffset || 0;
    var len2 = chunk.length;
    if (offset2 === 0) {
      rawExtents[dimIdx] = getInitialExtent();
    }
    var dimRawExtent = rawExtents[dimIdx];
    for (var i = offset2; i < len2; i++) {
      var val = chunk[i] = ordinalMeta.parseAndCollect(chunk[i]);
      dimRawExtent[0] = Math.min(val, dimRawExtent[0]);
      dimRawExtent[1] = Math.max(val, dimRawExtent[1]);
    }
    dim.ordinalMeta = ordinalMeta;
    dim.ordinalOffset = len2;
    dim.type = "ordinal";
  };
  DataStore2.prototype.getOrdinalMeta = function(dimIdx) {
    var dimInfo = this._dimensions[dimIdx];
    var ordinalMeta = dimInfo.ordinalMeta;
    return ordinalMeta;
  };
  DataStore2.prototype.getDimensionProperty = function(dimIndex) {
    var item = this._dimensions[dimIndex];
    return item && item.property;
  };
  DataStore2.prototype.appendData = function(data) {
    var provider = this._provider;
    var start2 = this.count();
    provider.appendData(data);
    var end2 = provider.count();
    if (!provider.persistent) {
      end2 += start2;
    }
    if (start2 < end2) {
      this._initDataFromProvider(start2, end2, true);
    }
    return [start2, end2];
  };
  DataStore2.prototype.appendValues = function(values, minFillLen) {
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var start2 = this.count();
    var end2 = start2 + Math.max(values.length, minFillLen || 0);
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      prepareStore(chunks, i, dim.type, end2, true);
    }
    var emptyDataItem = [];
    for (var idx = start2; idx < end2; idx++) {
      var sourceIdx = idx - start2;
      for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
        var dim = dimensions[dimIdx];
        var val = defaultDimValueGetters.arrayRows.call(this, values[sourceIdx] || emptyDataItem, dim.property, sourceIdx, dimIdx);
        chunks[dimIdx][idx] = val;
        var dimRawExtent = rawExtent[dimIdx];
        val < dimRawExtent[0] && (dimRawExtent[0] = val);
        val > dimRawExtent[1] && (dimRawExtent[1] = val);
      }
    }
    this._rawCount = this._count = end2;
    return {
      start: start2,
      end: end2
    };
  };
  DataStore2.prototype._initDataFromProvider = function(start2, end2, append) {
    var provider = this._provider;
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var dimNames = map$1(dimensions, function(dim2) {
      return dim2.property;
    });
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      if (!rawExtent[i]) {
        rawExtent[i] = getInitialExtent();
      }
      prepareStore(chunks, i, dim.type, end2, append);
    }
    if (provider.fillStorage) {
      provider.fillStorage(start2, end2, chunks, rawExtent);
    } else {
      var dataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        dataItem = provider.getItem(idx, dataItem);
        for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
          var dimStorage = chunks[dimIdx];
          var val = this._dimValueGetter(dataItem, dimNames[dimIdx], idx, dimIdx);
          dimStorage[idx] = val;
          var dimRawExtent = rawExtent[dimIdx];
          val < dimRawExtent[0] && (dimRawExtent[0] = val);
          val > dimRawExtent[1] && (dimRawExtent[1] = val);
        }
      }
    }
    if (!provider.persistent && provider.clean) {
      provider.clean();
    }
    this._rawCount = this._count = end2;
    this._extent = [];
  };
  DataStore2.prototype.count = function() {
    return this._count;
  };
  DataStore2.prototype.get = function(dim, idx) {
    if (!(idx >= 0 && idx < this._count)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[this.getRawIndex(idx)] : NaN;
  };
  DataStore2.prototype.getValues = function(dimensions, idx) {
    var values = [];
    var dimArr = [];
    if (idx == null) {
      idx = dimensions;
      dimensions = [];
      for (var i = 0; i < this._dimensions.length; i++) {
        dimArr.push(i);
      }
    } else {
      dimArr = dimensions;
    }
    for (var i = 0, len2 = dimArr.length; i < len2; i++) {
      values.push(this.get(dimArr[i], idx));
    }
    return values;
  };
  DataStore2.prototype.getByRawIndex = function(dim, rawIdx) {
    if (!(rawIdx >= 0 && rawIdx < this._rawCount)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[rawIdx] : NaN;
  };
  DataStore2.prototype.getSum = function(dim) {
    var dimData = this._chunks[dim];
    var sum2 = 0;
    if (dimData) {
      for (var i = 0, len2 = this.count(); i < len2; i++) {
        var value = this.get(dim, i);
        if (!isNaN(value)) {
          sum2 += value;
        }
      }
    }
    return sum2;
  };
  DataStore2.prototype.getMedian = function(dim) {
    var dimDataArray = [];
    this.each([dim], function(val) {
      if (!isNaN(val)) {
        dimDataArray.push(val);
      }
    });
    var sortedDimDataArray = dimDataArray.sort(function(a, b2) {
      return a - b2;
    });
    var len2 = this.count();
    return len2 === 0 ? 0 : len2 % 2 === 1 ? sortedDimDataArray[(len2 - 1) / 2] : (sortedDimDataArray[len2 / 2] + sortedDimDataArray[len2 / 2 - 1]) / 2;
  };
  DataStore2.prototype.indexOfRawIndex = function(rawIndex) {
    if (rawIndex >= this._rawCount || rawIndex < 0) {
      return -1;
    }
    if (!this._indices) {
      return rawIndex;
    }
    var indices = this._indices;
    var rawDataIndex = indices[rawIndex];
    if (rawDataIndex != null && rawDataIndex < this._count && rawDataIndex === rawIndex) {
      return rawIndex;
    }
    var left = 0;
    var right = this._count - 1;
    while (left <= right) {
      var mid = (left + right) / 2 | 0;
      if (indices[mid] < rawIndex) {
        left = mid + 1;
      } else if (indices[mid] > rawIndex) {
        right = mid - 1;
      } else {
        return mid;
      }
    }
    return -1;
  };
  DataStore2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    var chunks = this._chunks;
    var dimData = chunks[dim];
    var nearestIndices = [];
    if (!dimData) {
      return nearestIndices;
    }
    if (maxDistance == null) {
      maxDistance = Infinity;
    }
    var minDist = Infinity;
    var minDiff = -1;
    var nearestIndicesLen = 0;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var dataIndex = this.getRawIndex(i);
      var diff = value - dimData[dataIndex];
      var dist2 = Math.abs(diff);
      if (dist2 <= maxDistance) {
        if (dist2 < minDist || dist2 === minDist && diff >= 0 && minDiff < 0) {
          minDist = dist2;
          minDiff = diff;
          nearestIndicesLen = 0;
        }
        if (diff === minDiff) {
          nearestIndices[nearestIndicesLen++] = i;
        }
      }
    }
    nearestIndices.length = nearestIndicesLen;
    return nearestIndices;
  };
  DataStore2.prototype.getIndices = function() {
    var newIndices;
    var indices = this._indices;
    if (indices) {
      var Ctor = indices.constructor;
      var thisCount = this._count;
      if (Ctor === Array) {
        newIndices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          newIndices[i] = indices[i];
        }
      } else {
        newIndices = new Ctor(indices.buffer, 0, thisCount);
      }
    } else {
      var Ctor = getIndicesCtor(this._rawCount);
      newIndices = new Ctor(this.count());
      for (var i = 0; i < newIndices.length; i++) {
        newIndices[i] = i;
      }
    }
    return newIndices;
  };
  DataStore2.prototype.filter = function(dims, cb2) {
    if (!this._count) {
      return this;
    }
    var newStore = this.clone();
    var count2 = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(count2);
    var value = [];
    var dimSize = dims.length;
    var offset2 = 0;
    var dim0 = dims[0];
    var chunks = newStore._chunks;
    for (var i = 0; i < count2; i++) {
      var keep = void 0;
      var rawIdx = newStore.getRawIndex(i);
      if (dimSize === 0) {
        keep = cb2(i);
      } else if (dimSize === 1) {
        var val = chunks[dim0][rawIdx];
        keep = cb2(val, i);
      } else {
        var k2 = 0;
        for (; k2 < dimSize; k2++) {
          value[k2] = chunks[dims[k2]][rawIdx];
        }
        value[k2] = i;
        keep = cb2.apply(null, value);
      }
      if (keep) {
        newIndices[offset2++] = rawIdx;
      }
    }
    if (offset2 < count2) {
      newStore._indices = newIndices;
    }
    newStore._count = offset2;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.selectRange = function(range3) {
    var newStore = this.clone();
    var len2 = newStore._count;
    if (!len2) {
      return this;
    }
    var dims = keys(range3);
    var dimSize = dims.length;
    if (!dimSize) {
      return this;
    }
    var originalCount = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(originalCount);
    var offset2 = 0;
    var dim0 = dims[0];
    var min3 = range3[dim0][0];
    var max3 = range3[dim0][1];
    var storeArr = newStore._chunks;
    var quickFinished = false;
    if (!newStore._indices) {
      var idx = 0;
      if (dimSize === 1) {
        var dimStorage = storeArr[dims[0]];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset2++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      } else if (dimSize === 2) {
        var dimStorage = storeArr[dims[0]];
        var dimStorage2 = storeArr[dims[1]];
        var min22 = range3[dims[1]][0];
        var max22 = range3[dims[1]][1];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          var val2 = dimStorage2[i];
          if ((val >= min3 && val <= max3 || isNaN(val)) && (val2 >= min22 && val2 <= max22 || isNaN(val2))) {
            newIndices[offset2++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      }
    }
    if (!quickFinished) {
      if (dimSize === 1) {
        for (var i = 0; i < originalCount; i++) {
          var rawIndex = newStore.getRawIndex(i);
          var val = storeArr[dims[0]][rawIndex];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset2++] = rawIndex;
          }
        }
      } else {
        for (var i = 0; i < originalCount; i++) {
          var keep = true;
          var rawIndex = newStore.getRawIndex(i);
          for (var k2 = 0; k2 < dimSize; k2++) {
            var dimk = dims[k2];
            var val = storeArr[dimk][rawIndex];
            if (val < range3[dimk][0] || val > range3[dimk][1]) {
              keep = false;
            }
          }
          if (keep) {
            newIndices[offset2++] = newStore.getRawIndex(i);
          }
        }
      }
    }
    if (offset2 < originalCount) {
      newStore._indices = newIndices;
    }
    newStore._count = offset2;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.map = function(dims, cb2) {
    var target = this.clone(dims);
    this._updateDims(target, dims, cb2);
    return target;
  };
  DataStore2.prototype.modify = function(dims, cb2) {
    this._updateDims(this, dims, cb2);
  };
  DataStore2.prototype._updateDims = function(target, dims, cb2) {
    var targetChunks = target._chunks;
    var tmpRetValue = [];
    var dimSize = dims.length;
    var dataCount = target.count();
    var values = [];
    var rawExtent = target._rawExtent;
    for (var i = 0; i < dims.length; i++) {
      rawExtent[dims[i]] = getInitialExtent();
    }
    for (var dataIndex = 0; dataIndex < dataCount; dataIndex++) {
      var rawIndex = target.getRawIndex(dataIndex);
      for (var k2 = 0; k2 < dimSize; k2++) {
        values[k2] = targetChunks[dims[k2]][rawIndex];
      }
      values[dimSize] = dataIndex;
      var retValue = cb2 && cb2.apply(null, values);
      if (retValue != null) {
        if (typeof retValue !== "object") {
          tmpRetValue[0] = retValue;
          retValue = tmpRetValue;
        }
        for (var i = 0; i < retValue.length; i++) {
          var dim = dims[i];
          var val = retValue[i];
          var rawExtentOnDim = rawExtent[dim];
          var dimStore = targetChunks[dim];
          if (dimStore) {
            dimStore[rawIndex] = val;
          }
          if (val < rawExtentOnDim[0]) {
            rawExtentOnDim[0] = val;
          }
          if (val > rawExtentOnDim[1]) {
            rawExtentOnDim[1] = val;
          }
        }
      }
    }
  };
  DataStore2.prototype.lttbDownSample = function(valueDimension, rate) {
    var target = this.clone([valueDimension], true);
    var targetStorage = target._chunks;
    var dimStore = targetStorage[valueDimension];
    var len2 = this.count();
    var sampledIndex = 0;
    var frameSize = Math.floor(1 / rate);
    var currentRawIndex = this.getRawIndex(0);
    var maxArea;
    var area;
    var nextRawIndex;
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.min((Math.ceil(len2 / frameSize) + 2) * 2, len2));
    newIndices[sampledIndex++] = currentRawIndex;
    for (var i = 1; i < len2 - 1; i += frameSize) {
      var nextFrameStart = Math.min(i + frameSize, len2 - 1);
      var nextFrameEnd = Math.min(i + frameSize * 2, len2);
      var avgX = (nextFrameEnd + nextFrameStart) / 2;
      var avgY = 0;
      for (var idx = nextFrameStart; idx < nextFrameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          continue;
        }
        avgY += y2;
      }
      avgY /= nextFrameEnd - nextFrameStart;
      var frameStart = i;
      var frameEnd = Math.min(i + frameSize, len2);
      var pointAX = i - 1;
      var pointAY = dimStore[currentRawIndex];
      maxArea = -1;
      nextRawIndex = frameStart;
      var firstNaNIndex = -1;
      var countNaN = 0;
      for (var idx = frameStart; idx < frameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          countNaN++;
          if (firstNaNIndex < 0) {
            firstNaNIndex = rawIndex;
          }
          continue;
        }
        area = Math.abs((pointAX - avgX) * (y2 - pointAY) - (pointAX - idx) * (avgY - pointAY));
        if (area > maxArea) {
          maxArea = area;
          nextRawIndex = rawIndex;
        }
      }
      if (countNaN > 0 && countNaN < frameEnd - frameStart) {
        newIndices[sampledIndex++] = Math.min(firstNaNIndex, nextRawIndex);
        nextRawIndex = Math.max(firstNaNIndex, nextRawIndex);
      }
      newIndices[sampledIndex++] = nextRawIndex;
      currentRawIndex = nextRawIndex;
    }
    newIndices[sampledIndex++] = this.getRawIndex(len2 - 1);
    target._count = sampledIndex;
    target._indices = newIndices;
    target.getRawIndex = this._getRawIdx;
    return target;
  };
  DataStore2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var target = this.clone([dimension], true);
    var targetStorage = target._chunks;
    var frameValues = [];
    var frameSize = Math.floor(1 / rate);
    var dimStore = targetStorage[dimension];
    var len2 = this.count();
    var rawExtentOnDim = target._rawExtent[dimension] = getInitialExtent();
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.ceil(len2 / frameSize));
    var offset2 = 0;
    for (var i = 0; i < len2; i += frameSize) {
      if (frameSize > len2 - i) {
        frameSize = len2 - i;
        frameValues.length = frameSize;
      }
      for (var k2 = 0; k2 < frameSize; k2++) {
        var dataIdx = this.getRawIndex(i + k2);
        frameValues[k2] = dimStore[dataIdx];
      }
      var value = sampleValue(frameValues);
      var sampleFrameIdx = this.getRawIndex(Math.min(i + sampleIndex(frameValues, value) || 0, len2 - 1));
      dimStore[sampleFrameIdx] = value;
      if (value < rawExtentOnDim[0]) {
        rawExtentOnDim[0] = value;
      }
      if (value > rawExtentOnDim[1]) {
        rawExtentOnDim[1] = value;
      }
      newIndices[offset2++] = sampleFrameIdx;
    }
    target._count = offset2;
    target._indices = newIndices;
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype.each = function(dims, cb2) {
    if (!this._count) {
      return;
    }
    var dimSize = dims.length;
    var chunks = this._chunks;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var rawIdx = this.getRawIndex(i);
      switch (dimSize) {
        case 0:
          cb2(i);
          break;
        case 1:
          cb2(chunks[dims[0]][rawIdx], i);
          break;
        case 2:
          cb2(chunks[dims[0]][rawIdx], chunks[dims[1]][rawIdx], i);
          break;
        default:
          var k2 = 0;
          var value = [];
          for (; k2 < dimSize; k2++) {
            value[k2] = chunks[dims[k2]][rawIdx];
          }
          value[k2] = i;
          cb2.apply(null, value);
      }
    }
  };
  DataStore2.prototype.getDataExtent = function(dim) {
    var dimData = this._chunks[dim];
    var initialExtent = getInitialExtent();
    if (!dimData) {
      return initialExtent;
    }
    var currEnd = this.count();
    var useRaw = !this._indices;
    var dimExtent;
    if (useRaw) {
      return this._rawExtent[dim].slice();
    }
    dimExtent = this._extent[dim];
    if (dimExtent) {
      return dimExtent.slice();
    }
    dimExtent = initialExtent;
    var min3 = dimExtent[0];
    var max3 = dimExtent[1];
    for (var i = 0; i < currEnd; i++) {
      var rawIdx = this.getRawIndex(i);
      var value = dimData[rawIdx];
      value < min3 && (min3 = value);
      value > max3 && (max3 = value);
    }
    dimExtent = [min3, max3];
    this._extent[dim] = dimExtent;
    return dimExtent;
  };
  DataStore2.prototype.getRawDataItem = function(idx) {
    var rawIdx = this.getRawIndex(idx);
    if (!this._provider.persistent) {
      var val = [];
      var chunks = this._chunks;
      for (var i = 0; i < chunks.length; i++) {
        val.push(chunks[i][rawIdx]);
      }
      return val;
    } else {
      return this._provider.getItem(rawIdx);
    }
  };
  DataStore2.prototype.clone = function(clonedDims, ignoreIndices) {
    var target = new DataStore2();
    var chunks = this._chunks;
    var clonedDimsMap = clonedDims && reduce(clonedDims, function(obj, dimIdx) {
      obj[dimIdx] = true;
      return obj;
    }, {});
    if (clonedDimsMap) {
      for (var i = 0; i < chunks.length; i++) {
        target._chunks[i] = !clonedDimsMap[i] ? chunks[i] : cloneChunk(chunks[i]);
      }
    } else {
      target._chunks = chunks;
    }
    this._copyCommonProps(target);
    if (!ignoreIndices) {
      target._indices = this._cloneIndices();
    }
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype._copyCommonProps = function(target) {
    target._count = this._count;
    target._rawCount = this._rawCount;
    target._provider = this._provider;
    target._dimensions = this._dimensions;
    target._extent = clone$4(this._extent);
    target._rawExtent = clone$4(this._rawExtent);
  };
  DataStore2.prototype._cloneIndices = function() {
    if (this._indices) {
      var Ctor = this._indices.constructor;
      var indices = void 0;
      if (Ctor === Array) {
        var thisCount = this._indices.length;
        indices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          indices[i] = this._indices[i];
        }
      } else {
        indices = new Ctor(this._indices);
      }
      return indices;
    }
    return null;
  };
  DataStore2.prototype._getRawIdxIdentity = function(idx) {
    return idx;
  };
  DataStore2.prototype._getRawIdx = function(idx) {
    if (idx < this._count && idx >= 0) {
      return this._indices[idx];
    }
    return -1;
  };
  DataStore2.prototype._updateGetRawIdx = function() {
    this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
  };
  DataStore2.internalField = function() {
    function getDimValueSimply(dataItem, property, dataIndex, dimIndex) {
      return parseDataValue(dataItem[dimIndex], this._dimensions[dimIndex]);
    }
    defaultDimValueGetters = {
      arrayRows: getDimValueSimply,
      objectRows: function(dataItem, property, dataIndex, dimIndex) {
        return parseDataValue(dataItem[property], this._dimensions[dimIndex]);
      },
      keyedColumns: getDimValueSimply,
      original: function(dataItem, property, dataIndex, dimIndex) {
        var value = dataItem && (dataItem.value == null ? dataItem : dataItem.value);
        return parseDataValue(value instanceof Array ? value[dimIndex] : value, this._dimensions[dimIndex]);
      },
      typedArray: function(dataItem, property, dataIndex, dimIndex) {
        return dataItem[dimIndex];
      }
    };
  }();
  return DataStore2;
}();
var SourceManager = function() {
  function SourceManager2(sourceHost) {
    this._sourceList = [];
    this._storeList = [];
    this._upstreamSignList = [];
    this._versionSignBase = 0;
    this._dirty = true;
    this._sourceHost = sourceHost;
  }
  SourceManager2.prototype.dirty = function() {
    this._setLocalSource([], []);
    this._storeList = [];
    this._dirty = true;
  };
  SourceManager2.prototype._setLocalSource = function(sourceList, upstreamSignList) {
    this._sourceList = sourceList;
    this._upstreamSignList = upstreamSignList;
    this._versionSignBase++;
    if (this._versionSignBase > 9e10) {
      this._versionSignBase = 0;
    }
  };
  SourceManager2.prototype._getVersionSign = function() {
    return this._sourceHost.uid + "_" + this._versionSignBase;
  };
  SourceManager2.prototype.prepareSource = function() {
    if (this._isDirty()) {
      this._createSource();
      this._dirty = false;
    }
  };
  SourceManager2.prototype._createSource = function() {
    this._setLocalSource([], []);
    var sourceHost = this._sourceHost;
    var upSourceMgrList = this._getUpstreamSourceManagers();
    var hasUpstream = !!upSourceMgrList.length;
    var resultSourceList;
    var upstreamSignList;
    if (isSeries(sourceHost)) {
      var seriesModel = sourceHost;
      var data = void 0;
      var sourceFormat = void 0;
      var upSource = void 0;
      if (hasUpstream) {
        var upSourceMgr = upSourceMgrList[0];
        upSourceMgr.prepareSource();
        upSource = upSourceMgr.getSource();
        data = upSource.data;
        sourceFormat = upSource.sourceFormat;
        upstreamSignList = [upSourceMgr._getVersionSign()];
      } else {
        data = seriesModel.get("data", true);
        sourceFormat = isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL;
        upstreamSignList = [];
      }
      var newMetaRawOption = this._getSourceMetaRawOption() || {};
      var upMetaRawOption = upSource && upSource.metaRawOption || {};
      var seriesLayoutBy = retrieve2(newMetaRawOption.seriesLayoutBy, upMetaRawOption.seriesLayoutBy) || null;
      var sourceHeader = retrieve2(newMetaRawOption.sourceHeader, upMetaRawOption.sourceHeader);
      var dimensions = retrieve2(newMetaRawOption.dimensions, upMetaRawOption.dimensions);
      var needsCreateSource = seriesLayoutBy !== upMetaRawOption.seriesLayoutBy || !!sourceHeader !== !!upMetaRawOption.sourceHeader || dimensions;
      resultSourceList = needsCreateSource ? [createSource(data, {
        seriesLayoutBy,
        sourceHeader,
        dimensions
      }, sourceFormat)] : [];
    } else {
      var datasetModel = sourceHost;
      if (hasUpstream) {
        var result = this._applyTransform(upSourceMgrList);
        resultSourceList = result.sourceList;
        upstreamSignList = result.upstreamSignList;
      } else {
        var sourceData = datasetModel.get("source", true);
        resultSourceList = [createSource(sourceData, this._getSourceMetaRawOption(), null)];
        upstreamSignList = [];
      }
    }
    this._setLocalSource(resultSourceList, upstreamSignList);
  };
  SourceManager2.prototype._applyTransform = function(upMgrList) {
    var datasetModel = this._sourceHost;
    var transformOption = datasetModel.get("transform", true);
    var fromTransformResult = datasetModel.get("fromTransformResult", true);
    if (fromTransformResult != null) {
      var errMsg = "";
      if (upMgrList.length !== 1) {
        doThrow(errMsg);
      }
    }
    var sourceList;
    var upSourceList = [];
    var upstreamSignList = [];
    each$g(upMgrList, function(upMgr) {
      upMgr.prepareSource();
      var upSource = upMgr.getSource(fromTransformResult || 0);
      var errMsg2 = "";
      if (fromTransformResult != null && !upSource) {
        doThrow(errMsg2);
      }
      upSourceList.push(upSource);
      upstreamSignList.push(upMgr._getVersionSign());
    });
    if (transformOption) {
      sourceList = applyDataTransform(transformOption, upSourceList, {
        datasetIndex: datasetModel.componentIndex
      });
    } else if (fromTransformResult != null) {
      sourceList = [cloneSourceShallow(upSourceList[0])];
    }
    return {
      sourceList,
      upstreamSignList
    };
  };
  SourceManager2.prototype._isDirty = function() {
    if (this._dirty) {
      return true;
    }
    var upSourceMgrList = this._getUpstreamSourceManagers();
    for (var i = 0; i < upSourceMgrList.length; i++) {
      var upSrcMgr = upSourceMgrList[i];
      if (upSrcMgr._isDirty() || this._upstreamSignList[i] !== upSrcMgr._getVersionSign()) {
        return true;
      }
    }
  };
  SourceManager2.prototype.getSource = function(sourceIndex) {
    sourceIndex = sourceIndex || 0;
    var source = this._sourceList[sourceIndex];
    if (!source) {
      var upSourceMgrList = this._getUpstreamSourceManagers();
      return upSourceMgrList[0] && upSourceMgrList[0].getSource(sourceIndex);
    }
    return source;
  };
  SourceManager2.prototype.getSharedDataStore = function(seriesDimRequest) {
    var schema = seriesDimRequest.makeStoreSchema();
    return this._innerGetDataStore(schema.dimensions, seriesDimRequest.source, schema.hash);
  };
  SourceManager2.prototype._innerGetDataStore = function(storeDims, seriesSource, sourceReadKey) {
    var sourceIndex = 0;
    var storeList = this._storeList;
    var cachedStoreMap = storeList[sourceIndex];
    if (!cachedStoreMap) {
      cachedStoreMap = storeList[sourceIndex] = {};
    }
    var cachedStore = cachedStoreMap[sourceReadKey];
    if (!cachedStore) {
      var upSourceMgr = this._getUpstreamSourceManagers()[0];
      if (isSeries(this._sourceHost) && upSourceMgr) {
        cachedStore = upSourceMgr._innerGetDataStore(storeDims, seriesSource, sourceReadKey);
      } else {
        cachedStore = new DataStore();
        cachedStore.initData(new DefaultDataProvider(seriesSource, storeDims.length), storeDims);
      }
      cachedStoreMap[sourceReadKey] = cachedStore;
    }
    return cachedStore;
  };
  SourceManager2.prototype._getUpstreamSourceManagers = function() {
    var sourceHost = this._sourceHost;
    if (isSeries(sourceHost)) {
      var datasetModel = querySeriesUpstreamDatasetModel(sourceHost);
      return !datasetModel ? [] : [datasetModel.getSourceManager()];
    } else {
      return map$1(queryDatasetUpstreamDatasetModels(sourceHost), function(datasetModel2) {
        return datasetModel2.getSourceManager();
      });
    }
  };
  SourceManager2.prototype._getSourceMetaRawOption = function() {
    var sourceHost = this._sourceHost;
    var seriesLayoutBy;
    var sourceHeader;
    var dimensions;
    if (isSeries(sourceHost)) {
      seriesLayoutBy = sourceHost.get("seriesLayoutBy", true);
      sourceHeader = sourceHost.get("sourceHeader", true);
      dimensions = sourceHost.get("dimensions", true);
    } else if (!this._getUpstreamSourceManagers().length) {
      var model = sourceHost;
      seriesLayoutBy = model.get("seriesLayoutBy", true);
      sourceHeader = model.get("sourceHeader", true);
      dimensions = model.get("dimensions", true);
    }
    return {
      seriesLayoutBy,
      sourceHeader,
      dimensions
    };
  };
  return SourceManager2;
}();
function disableTransformOptionMerge(datasetModel) {
  var transformOption = datasetModel.option.transform;
  transformOption && setAsPrimitive(datasetModel.option.transform);
}
function isSeries(sourceHost) {
  return sourceHost.mainType === "series";
}
function doThrow(errMsg) {
  throw new Error(errMsg);
}
var TOOLTIP_LINE_HEIGHT_CSS = "line-height:1";
function getTooltipTextStyle(textStyle, renderMode) {
  var nameFontColor = textStyle.color || "#6e7079";
  var nameFontSize = textStyle.fontSize || 12;
  var nameFontWeight = textStyle.fontWeight || "400";
  var valueFontColor = textStyle.color || "#464646";
  var valueFontSize = textStyle.fontSize || 14;
  var valueFontWeight = textStyle.fontWeight || "900";
  if (renderMode === "html") {
    return {
      nameStyle: "font-size:" + encodeHTML(nameFontSize + "") + "px;color:" + encodeHTML(nameFontColor) + ";font-weight:" + encodeHTML(nameFontWeight + ""),
      valueStyle: "font-size:" + encodeHTML(valueFontSize + "") + "px;color:" + encodeHTML(valueFontColor) + ";font-weight:" + encodeHTML(valueFontWeight + "")
    };
  } else {
    return {
      nameStyle: {
        fontSize: nameFontSize,
        fill: nameFontColor,
        fontWeight: nameFontWeight
      },
      valueStyle: {
        fontSize: valueFontSize,
        fill: valueFontColor,
        fontWeight: valueFontWeight
      }
    };
  }
}
var HTML_GAPS = [0, 10, 20, 30];
var RICH_TEXT_GAPS = ["", "\n", "\n\n", "\n\n\n"];
function createTooltipMarkup(type4, option) {
  option.type = type4;
  return option;
}
function isSectionFragment(frag) {
  return frag.type === "section";
}
function getBuilder(frag) {
  return isSectionFragment(frag) ? buildSection : buildNameValue;
}
function getBlockGapLevel(frag) {
  if (isSectionFragment(frag)) {
    var gapLevel_1 = 0;
    var subBlockLen = frag.blocks.length;
    var hasInnerGap_1 = subBlockLen > 1 || subBlockLen > 0 && !frag.noHeader;
    each$g(frag.blocks, function(subBlock) {
      var subGapLevel = getBlockGapLevel(subBlock);
      if (subGapLevel >= gapLevel_1) {
        gapLevel_1 = subGapLevel + +(hasInnerGap_1 && (!subGapLevel || isSectionFragment(subBlock) && !subBlock.noHeader));
      }
    });
    return gapLevel_1;
  }
  return 0;
}
function buildSection(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var noHeader = fragment.noHeader;
  var gaps = getGap(getBlockGapLevel(fragment));
  var subMarkupTextList = [];
  var subBlocks = fragment.blocks || [];
  assert(!subBlocks || isArray$1(subBlocks));
  subBlocks = subBlocks || [];
  var orderMode = ctx.orderMode;
  if (fragment.sortBlocks && orderMode) {
    subBlocks = subBlocks.slice();
    var orderMap = {
      valueAsc: "asc",
      valueDesc: "desc"
    };
    if (hasOwn(orderMap, orderMode)) {
      var comparator_1 = new SortOrderComparator(orderMap[orderMode], null);
      subBlocks.sort(function(a, b2) {
        return comparator_1.evaluate(a.sortParam, b2.sortParam);
      });
    } else if (orderMode === "seriesDesc") {
      subBlocks.reverse();
    }
  }
  each$g(subBlocks, function(subBlock, idx) {
    var valueFormatter = fragment.valueFormatter;
    var subMarkupText2 = getBuilder(subBlock)(valueFormatter ? extend(extend({}, ctx), {
      valueFormatter
    }) : ctx, subBlock, idx > 0 ? gaps.html : 0, toolTipTextStyle);
    subMarkupText2 != null && subMarkupTextList.push(subMarkupText2);
  });
  var subMarkupText = ctx.renderMode === "richText" ? subMarkupTextList.join(gaps.richText) : wrapBlockHTML(subMarkupTextList.join(""), noHeader ? topMarginForOuterGap : gaps.html);
  if (noHeader) {
    return subMarkupText;
  }
  var displayableHeader = makeValueReadable(fragment.header, "ordinal", ctx.useUTC);
  var nameStyle = getTooltipTextStyle(toolTipTextStyle, ctx.renderMode).nameStyle;
  if (ctx.renderMode === "richText") {
    return wrapInlineNameRichText(ctx, displayableHeader, nameStyle) + gaps.richText + subMarkupText;
  } else {
    return wrapBlockHTML('<div style="' + nameStyle + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodeHTML(displayableHeader) + "</div>" + subMarkupText, topMarginForOuterGap);
  }
}
function buildNameValue(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var renderMode = ctx.renderMode;
  var noName = fragment.noName;
  var noValue = fragment.noValue;
  var noMarker = !fragment.markerType;
  var name = fragment.name;
  var useUTC = ctx.useUTC;
  var valueFormatter = fragment.valueFormatter || ctx.valueFormatter || function(value) {
    value = isArray$1(value) ? value : [value];
    return map$1(value, function(val, idx) {
      return makeValueReadable(val, isArray$1(valueTypeOption) ? valueTypeOption[idx] : valueTypeOption, useUTC);
    });
  };
  if (noName && noValue) {
    return;
  }
  var markerStr = noMarker ? "" : ctx.markupStyleCreator.makeTooltipMarker(fragment.markerType, fragment.markerColor || "#333", renderMode);
  var readableName = noName ? "" : makeValueReadable(name, "ordinal", useUTC);
  var valueTypeOption = fragment.valueType;
  var readableValueList = noValue ? [] : valueFormatter(fragment.value);
  var valueAlignRight = !noMarker || !noName;
  var valueCloseToMarker = !noMarker && noName;
  var _a2 = getTooltipTextStyle(toolTipTextStyle, renderMode), nameStyle = _a2.nameStyle, valueStyle = _a2.valueStyle;
  return renderMode === "richText" ? (noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameRichText(ctx, readableName, nameStyle)) + (noValue ? "" : wrapInlineValueRichText(ctx, readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)) : wrapBlockHTML((noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameHTML(readableName, !noMarker, nameStyle)) + (noValue ? "" : wrapInlineValueHTML(readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)), topMarginForOuterGap);
}
function buildTooltipMarkup(fragment, markupStyleCreator, renderMode, orderMode, useUTC, toolTipTextStyle) {
  if (!fragment) {
    return;
  }
  var builder = getBuilder(fragment);
  var ctx = {
    useUTC,
    renderMode,
    orderMode,
    markupStyleCreator,
    valueFormatter: fragment.valueFormatter
  };
  return builder(ctx, fragment, 0, toolTipTextStyle);
}
function getGap(gapLevel) {
  return {
    html: HTML_GAPS[gapLevel],
    richText: RICH_TEXT_GAPS[gapLevel]
  };
}
function wrapBlockHTML(encodedContent, topGap) {
  var clearfix = '<div style="clear:both"></div>';
  var marginCSS = "margin: " + topGap + "px 0 0";
  return '<div style="' + marginCSS + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodedContent + clearfix + "</div>";
}
function wrapInlineNameHTML(name, leftHasMarker, style2) {
  var marginCss = leftHasMarker ? "margin-left:2px" : "";
  return '<span style="' + style2 + ";" + marginCss + '">' + encodeHTML(name) + "</span>";
}
function wrapInlineValueHTML(valueList, alignRight, valueCloseToMarker, style2) {
  var paddingStr = valueCloseToMarker ? "10px" : "20px";
  var alignCSS = alignRight ? "float:right;margin-left:" + paddingStr : "";
  valueList = isArray$1(valueList) ? valueList : [valueList];
  return '<span style="' + alignCSS + ";" + style2 + '">' + map$1(valueList, function(value) {
    return encodeHTML(value);
  }).join("&nbsp;&nbsp;") + "</span>";
}
function wrapInlineNameRichText(ctx, name, style2) {
  return ctx.markupStyleCreator.wrapRichTextStyle(name, style2);
}
function wrapInlineValueRichText(ctx, values, alignRight, valueCloseToMarker, style2) {
  var styles2 = [style2];
  var paddingLeft = valueCloseToMarker ? 10 : 20;
  alignRight && styles2.push({
    padding: [0, 0, 0, paddingLeft],
    align: "right"
  });
  return ctx.markupStyleCreator.wrapRichTextStyle(isArray$1(values) ? values.join("  ") : values, styles2);
}
function retrieveVisualColorForTooltipMarker(series, dataIndex) {
  var style2 = series.getData().getItemVisual(dataIndex, "style");
  var color = style2[series.visualDrawType];
  return convertToColorString(color);
}
function getPaddingFromTooltipModel(model, renderMode) {
  var padding = model.get("padding");
  return padding != null ? padding : renderMode === "richText" ? [8, 10] : 10;
}
var TooltipMarkupStyleCreator = function() {
  function TooltipMarkupStyleCreator2() {
    this.richTextStyles = {};
    this._nextStyleNameId = getRandomIdBase();
  }
  TooltipMarkupStyleCreator2.prototype._generateStyleName = function() {
    return "__EC_aUTo_" + this._nextStyleNameId++;
  };
  TooltipMarkupStyleCreator2.prototype.makeTooltipMarker = function(markerType, colorStr, renderMode) {
    var markerId = renderMode === "richText" ? this._generateStyleName() : null;
    var marker = getTooltipMarker({
      color: colorStr,
      type: markerType,
      renderMode,
      markerId
    });
    if (isString$1(marker)) {
      return marker;
    } else {
      this.richTextStyles[markerId] = marker.style;
      return marker.content;
    }
  };
  TooltipMarkupStyleCreator2.prototype.wrapRichTextStyle = function(text, styles2) {
    var finalStl = {};
    if (isArray$1(styles2)) {
      each$g(styles2, function(stl) {
        return extend(finalStl, stl);
      });
    } else {
      extend(finalStl, styles2);
    }
    var styleName = this._generateStyleName();
    this.richTextStyles[styleName] = finalStl;
    return "{" + styleName + "|" + text + "}";
  };
  return TooltipMarkupStyleCreator2;
}();
function defaultSeriesFormatTooltip(opt) {
  var series = opt.series;
  var dataIndex = opt.dataIndex;
  var multipleSeries = opt.multipleSeries;
  var data = series.getData();
  var tooltipDims = data.mapDimensionsAll("defaultedTooltip");
  var tooltipDimLen = tooltipDims.length;
  var value = series.getRawValue(dataIndex);
  var isValueArr = isArray$1(value);
  var markerColor = retrieveVisualColorForTooltipMarker(series, dataIndex);
  var inlineValue;
  var inlineValueType;
  var subBlocks;
  var sortParam;
  if (tooltipDimLen > 1 || isValueArr && !tooltipDimLen) {
    var formatArrResult = formatTooltipArrayValue(value, series, dataIndex, tooltipDims, markerColor);
    inlineValue = formatArrResult.inlineValues;
    inlineValueType = formatArrResult.inlineValueTypes;
    subBlocks = formatArrResult.blocks;
    sortParam = formatArrResult.inlineValues[0];
  } else if (tooltipDimLen) {
    var dimInfo = data.getDimensionInfo(tooltipDims[0]);
    sortParam = inlineValue = retrieveRawValue(data, dataIndex, tooltipDims[0]);
    inlineValueType = dimInfo.type;
  } else {
    sortParam = inlineValue = isValueArr ? value[0] : value;
  }
  var seriesNameSpecified = isNameSpecified(series);
  var seriesName = seriesNameSpecified && series.name || "";
  var itemName = data.getName(dataIndex);
  var inlineName = multipleSeries ? seriesName : itemName;
  return createTooltipMarkup("section", {
    header: seriesName,
    noHeader: multipleSeries || !seriesNameSpecified,
    sortParam,
    blocks: [createTooltipMarkup("nameValue", {
      markerType: "item",
      markerColor,
      name: inlineName,
      noName: !trim$1(inlineName),
      value: inlineValue,
      valueType: inlineValueType
    })].concat(subBlocks || [])
  });
}
function formatTooltipArrayValue(value, series, dataIndex, tooltipDims, colorStr) {
  var data = series.getData();
  var isValueMultipleLine = reduce(value, function(isValueMultipleLine2, val, idx) {
    var dimItem = data.getDimensionInfo(idx);
    return isValueMultipleLine2 = isValueMultipleLine2 || dimItem && dimItem.tooltip !== false && dimItem.displayName != null;
  }, false);
  var inlineValues = [];
  var inlineValueTypes = [];
  var blocks = [];
  tooltipDims.length ? each$g(tooltipDims, function(dim) {
    setEachItem(retrieveRawValue(data, dataIndex, dim), dim);
  }) : each$g(value, setEachItem);
  function setEachItem(val, dim) {
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo || dimInfo.otherDims.tooltip === false) {
      return;
    }
    if (isValueMultipleLine) {
      blocks.push(createTooltipMarkup("nameValue", {
        markerType: "subItem",
        markerColor: colorStr,
        name: dimInfo.displayName,
        value: val,
        valueType: dimInfo.type
      }));
    } else {
      inlineValues.push(val);
      inlineValueTypes.push(dimInfo.type);
    }
  }
  return {
    inlineValues,
    inlineValueTypes,
    blocks
  };
}
var inner$k = makeInner();
function getSelectionKey(data, dataIndex) {
  return data.getName(dataIndex) || data.getId(dataIndex);
}
var SERIES_UNIVERSAL_TRANSITION_PROP = "__universalTransitionEnabled";
var SeriesModel = function(_super) {
  __extends(SeriesModel2, _super);
  function SeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._selectedDataIndicesMap = {};
    return _this;
  }
  SeriesModel2.prototype.init = function(option, parentModel, ecModel) {
    this.seriesIndex = this.componentIndex;
    this.dataTask = createTask({
      count: dataTaskCount,
      reset: dataTaskReset
    });
    this.dataTask.context = {
      model: this
    };
    this.mergeDefaultAndTheme(option, ecModel);
    var sourceManager = inner$k(this).sourceManager = new SourceManager(this);
    sourceManager.prepareSource();
    var data = this.getInitialData(option, ecModel);
    wrapData(data, this);
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeSubType = this.subType;
    if (ComponentModel$1.hasClass(themeSubType)) {
      themeSubType += "Series";
    }
    merge(option, ecModel.getTheme().get(this.subType));
    merge(option, this.getDefaultOption());
    defaultEmphasis(option, "label", ["show"]);
    this.fillDataTextStyle(option.data);
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  SeriesModel2.prototype.mergeOption = function(newSeriesOption, ecModel) {
    newSeriesOption = merge(this.option, newSeriesOption, true);
    this.fillDataTextStyle(newSeriesOption.data);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, newSeriesOption, layoutMode);
    }
    var sourceManager = inner$k(this).sourceManager;
    sourceManager.dirty();
    sourceManager.prepareSource();
    var data = this.getInitialData(newSeriesOption, ecModel);
    wrapData(data, this);
    this.dataTask.dirty();
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.fillDataTextStyle = function(data) {
    if (data && !isTypedArray(data)) {
      var props = ["show"];
      for (var i = 0; i < data.length; i++) {
        if (data[i] && data[i].label) {
          defaultEmphasis(data[i], "label", props);
        }
      }
    }
  };
  SeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return;
  };
  SeriesModel2.prototype.appendData = function(params) {
    var data = this.getRawData();
    data.appendData(params.data);
  };
  SeriesModel2.prototype.getData = function(dataType) {
    var task = getCurrentTask(this);
    if (task) {
      var data = task.context.data;
      return dataType == null ? data : data.getLinkedData(dataType);
    } else {
      return inner$k(this).data;
    }
  };
  SeriesModel2.prototype.getAllData = function() {
    var mainData = this.getData();
    return mainData && mainData.getLinkedDataAll ? mainData.getLinkedDataAll() : [{
      data: mainData
    }];
  };
  SeriesModel2.prototype.setData = function(data) {
    var task = getCurrentTask(this);
    if (task) {
      var context = task.context;
      context.outputData = data;
      if (task !== this.dataTask) {
        context.data = data;
      }
    }
    inner$k(this).data = data;
  };
  SeriesModel2.prototype.getEncode = function() {
    var encode = this.get("encode", true);
    if (encode) {
      return createHashMap(encode);
    }
  };
  SeriesModel2.prototype.getSourceManager = function() {
    return inner$k(this).sourceManager;
  };
  SeriesModel2.prototype.getSource = function() {
    return this.getSourceManager().getSource();
  };
  SeriesModel2.prototype.getRawData = function() {
    return inner$k(this).dataBeforeProcessed;
  };
  SeriesModel2.prototype.getColorBy = function() {
    var colorBy = this.get("colorBy");
    return colorBy || "series";
  };
  SeriesModel2.prototype.isColorBySeries = function() {
    return this.getColorBy() === "series";
  };
  SeriesModel2.prototype.getBaseAxis = function() {
    var coordSys = this.coordinateSystem;
    return coordSys && coordSys.getBaseAxis && coordSys.getBaseAxis();
  };
  SeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
  };
  SeriesModel2.prototype.isAnimationEnabled = function() {
    var ecModel = this.ecModel;
    if (env$1.node && !(ecModel && ecModel.ssr)) {
      return false;
    }
    var animationEnabled = this.getShallow("animation");
    if (animationEnabled) {
      if (this.getData().count() > this.getShallow("animationThreshold")) {
        animationEnabled = false;
      }
    }
    return !!animationEnabled;
  };
  SeriesModel2.prototype.restoreData = function() {
    this.dataTask.dirty();
  };
  SeriesModel2.prototype.getColorFromPalette = function(name, scope, requestColorNum) {
    var ecModel = this.ecModel;
    var color = PaletteMixin.prototype.getColorFromPalette.call(this, name, scope, requestColorNum);
    if (!color) {
      color = ecModel.getColorFromPalette(name, scope, requestColorNum);
    }
    return color;
  };
  SeriesModel2.prototype.coordDimToDataDim = function(coordDim) {
    return this.getRawData().mapDimensionsAll(coordDim);
  };
  SeriesModel2.prototype.getProgressive = function() {
    return this.get("progressive");
  };
  SeriesModel2.prototype.getProgressiveThreshold = function() {
    return this.get("progressiveThreshold");
  };
  SeriesModel2.prototype.select = function(innerDataIndices, dataType) {
    this._innerSelect(this.getData(dataType), innerDataIndices);
  };
  SeriesModel2.prototype.unselect = function(innerDataIndices, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return;
    }
    var selectedMode = this.option.selectedMode;
    var data = this.getData(dataType);
    if (selectedMode === "series" || selectedMap === "all") {
      this.option.selectedMap = {};
      this._selectedDataIndicesMap = {};
      return;
    }
    for (var i = 0; i < innerDataIndices.length; i++) {
      var dataIndex = innerDataIndices[i];
      var nameOrId = getSelectionKey(data, dataIndex);
      selectedMap[nameOrId] = false;
      this._selectedDataIndicesMap[nameOrId] = -1;
    }
  };
  SeriesModel2.prototype.toggleSelect = function(innerDataIndices, dataType) {
    var tmpArr2 = [];
    for (var i = 0; i < innerDataIndices.length; i++) {
      tmpArr2[0] = innerDataIndices[i];
      this.isSelected(innerDataIndices[i], dataType) ? this.unselect(tmpArr2, dataType) : this.select(tmpArr2, dataType);
    }
  };
  SeriesModel2.prototype.getSelectedDataIndices = function() {
    if (this.option.selectedMap === "all") {
      return [].slice.call(this.getData().getIndices());
    }
    var selectedDataIndicesMap = this._selectedDataIndicesMap;
    var nameOrIds = keys(selectedDataIndicesMap);
    var dataIndices = [];
    for (var i = 0; i < nameOrIds.length; i++) {
      var dataIndex = selectedDataIndicesMap[nameOrIds[i]];
      if (dataIndex >= 0) {
        dataIndices.push(dataIndex);
      }
    }
    return dataIndices;
  };
  SeriesModel2.prototype.isSelected = function(dataIndex, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return false;
    }
    var data = this.getData(dataType);
    return (selectedMap === "all" || selectedMap[getSelectionKey(data, dataIndex)]) && !data.getItemModel(dataIndex).get(["select", "disabled"]);
  };
  SeriesModel2.prototype.isUniversalTransitionEnabled = function() {
    if (this[SERIES_UNIVERSAL_TRANSITION_PROP]) {
      return true;
    }
    var universalTransitionOpt = this.option.universalTransition;
    if (!universalTransitionOpt) {
      return false;
    }
    if (universalTransitionOpt === true) {
      return true;
    }
    return universalTransitionOpt && universalTransitionOpt.enabled;
  };
  SeriesModel2.prototype._innerSelect = function(data, innerDataIndices) {
    var _a2, _b2;
    var option = this.option;
    var selectedMode = option.selectedMode;
    var len2 = innerDataIndices.length;
    if (!selectedMode || !len2) {
      return;
    }
    if (selectedMode === "series") {
      option.selectedMap = "all";
    } else if (selectedMode === "multiple") {
      if (!isObject$4(option.selectedMap)) {
        option.selectedMap = {};
      }
      var selectedMap = option.selectedMap;
      for (var i = 0; i < len2; i++) {
        var dataIndex = innerDataIndices[i];
        var nameOrId = getSelectionKey(data, dataIndex);
        selectedMap[nameOrId] = true;
        this._selectedDataIndicesMap[nameOrId] = data.getRawIndex(dataIndex);
      }
    } else if (selectedMode === "single" || selectedMode === true) {
      var lastDataIndex = innerDataIndices[len2 - 1];
      var nameOrId = getSelectionKey(data, lastDataIndex);
      option.selectedMap = (_a2 = {}, _a2[nameOrId] = true, _a2);
      this._selectedDataIndicesMap = (_b2 = {}, _b2[nameOrId] = data.getRawIndex(lastDataIndex), _b2);
    }
  };
  SeriesModel2.prototype._initSelectedMapFromData = function(data) {
    if (this.option.selectedMap) {
      return;
    }
    var dataIndices = [];
    if (data.hasItemOption) {
      data.each(function(idx) {
        var rawItem = data.getRawDataItem(idx);
        if (rawItem && rawItem.selected) {
          dataIndices.push(idx);
        }
      });
    }
    if (dataIndices.length > 0) {
      this._innerSelect(data, dataIndices);
    }
  };
  SeriesModel2.registerClass = function(clz) {
    return ComponentModel$1.registerClass(clz);
  };
  SeriesModel2.protoInitialize = function() {
    var proto2 = SeriesModel2.prototype;
    proto2.type = "series.__base__";
    proto2.seriesIndex = 0;
    proto2.ignoreStyleOnData = false;
    proto2.hasSymbolVisual = false;
    proto2.defaultSymbol = "circle";
    proto2.visualStyleAccessPath = "itemStyle";
    proto2.visualDrawType = "fill";
  }();
  return SeriesModel2;
}(ComponentModel$1);
mixin(SeriesModel, DataFormatMixin);
mixin(SeriesModel, PaletteMixin);
mountExtend(SeriesModel, ComponentModel$1);
function autoSeriesName(seriesModel) {
  var name = seriesModel.name;
  if (!isNameSpecified(seriesModel)) {
    seriesModel.name = getSeriesAutoName(seriesModel) || name;
  }
}
function getSeriesAutoName(seriesModel) {
  var data = seriesModel.getRawData();
  var dataDims = data.mapDimensionsAll("seriesName");
  var nameArr = [];
  each$g(dataDims, function(dataDim) {
    var dimInfo = data.getDimensionInfo(dataDim);
    dimInfo.displayName && nameArr.push(dimInfo.displayName);
  });
  return nameArr.join(" ");
}
function dataTaskCount(context) {
  return context.model.getRawData().count();
}
function dataTaskReset(context) {
  var seriesModel = context.model;
  seriesModel.setData(seriesModel.getRawData().cloneShallow());
  return dataTaskProgress;
}
function dataTaskProgress(param, context) {
  if (context.outputData && param.end > context.outputData.count()) {
    context.model.getRawData().cloneShallow(context.outputData);
  }
}
function wrapData(data, seriesModel) {
  each$g(concatArray(data.CHANGABLE_METHODS, data.DOWNSAMPLE_METHODS), function(methodName) {
    data.wrapMethod(methodName, curry$1(onDataChange, seriesModel));
  });
}
function onDataChange(seriesModel, newList) {
  var task = getCurrentTask(seriesModel);
  if (task) {
    task.setOutputEnd((newList || this).count());
  }
  return newList;
}
function getCurrentTask(seriesModel) {
  var scheduler2 = (seriesModel.ecModel || {}).scheduler;
  var pipeline = scheduler2 && scheduler2.getPipeline(seriesModel.uid);
  if (pipeline) {
    var task = pipeline.currentTask;
    if (task) {
      var agentStubMap = task.agentStubMap;
      if (agentStubMap) {
        task = agentStubMap.get(seriesModel.uid);
      }
    }
    return task;
  }
}
var SeriesModel$1 = SeriesModel;
var ComponentView = function() {
  function ComponentView2() {
    this.group = new Group$6();
    this.uid = getUID("viewComponent");
  }
  ComponentView2.prototype.init = function(ecModel, api) {
  };
  ComponentView2.prototype.render = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.dispose = function(ecModel, api) {
  };
  ComponentView2.prototype.updateView = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateLayout = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateVisual = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.blurSeries = function(seriesModels, ecModel) {
  };
  ComponentView2.prototype.eachRendered = function(cb2) {
    var group = this.group;
    if (group) {
      group.traverse(cb2);
    }
  };
  return ComponentView2;
}();
enableClassExtend(ComponentView);
enableClassManagement(ComponentView);
var ComponentView$1 = ComponentView;
function createRenderPlanner() {
  var inner2 = makeInner();
  return function(seriesModel) {
    var fields = inner2(seriesModel);
    var pipelineContext = seriesModel.pipelineContext;
    var originalLarge = !!fields.large;
    var originalProgressive = !!fields.progressiveRender;
    var large = fields.large = !!(pipelineContext && pipelineContext.large);
    var progressive = fields.progressiveRender = !!(pipelineContext && pipelineContext.progressiveRender);
    return !!(originalLarge !== large || originalProgressive !== progressive) && "reset";
  };
}
var inner$j = makeInner();
var renderPlanner = createRenderPlanner();
var ChartView = function() {
  function ChartView2() {
    this.group = new Group$6();
    this.uid = getUID("viewChart");
    this.renderTask = createTask({
      plan: renderTaskPlan,
      reset: renderTaskReset
    });
    this.renderTask.context = {
      view: this
    };
  }
  ChartView2.prototype.init = function(ecModel, api) {
  };
  ChartView2.prototype.render = function(seriesModel, ecModel, api, payload) {
  };
  ChartView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "emphasis");
  };
  ChartView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "normal");
  };
  ChartView2.prototype.remove = function(ecModel, api) {
    this.group.removeAll();
  };
  ChartView2.prototype.dispose = function(ecModel, api) {
  };
  ChartView2.prototype.updateView = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateLayout = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateVisual = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.eachRendered = function(cb2) {
    traverseElements(this.group, cb2);
  };
  ChartView2.markUpdateMethod = function(payload, methodName) {
    inner$j(payload).updateMethod = methodName;
  };
  ChartView2.protoInitialize = function() {
    var proto2 = ChartView2.prototype;
    proto2.type = "chart";
  }();
  return ChartView2;
}();
function elSetState(el, state, highlightDigit) {
  if (el && isHighDownDispatcher(el)) {
    (state === "emphasis" ? enterEmphasis : leaveEmphasis)(el, highlightDigit);
  }
}
function toggleHighlight(data, payload, state) {
  var dataIndex = queryDataIndex(data, payload);
  var highlightDigit = payload && payload.highlightKey != null ? getHighlightDigit(payload.highlightKey) : null;
  if (dataIndex != null) {
    each$g(normalizeToArray(dataIndex), function(dataIdx) {
      elSetState(data.getItemGraphicEl(dataIdx), state, highlightDigit);
    });
  } else {
    data.eachItemGraphicEl(function(el) {
      elSetState(el, state, highlightDigit);
    });
  }
}
enableClassExtend(ChartView);
enableClassManagement(ChartView);
function renderTaskPlan(context) {
  return renderPlanner(context.model);
}
function renderTaskReset(context) {
  var seriesModel = context.model;
  var ecModel = context.ecModel;
  var api = context.api;
  var payload = context.payload;
  var progressiveRender = seriesModel.pipelineContext.progressiveRender;
  var view = context.view;
  var updateMethod = payload && inner$j(payload).updateMethod;
  var methodName = progressiveRender ? "incrementalPrepareRender" : updateMethod && view[updateMethod] ? updateMethod : "render";
  if (methodName !== "render") {
    view[methodName](seriesModel, ecModel, api, payload);
  }
  return progressMethodMap[methodName];
}
var progressMethodMap = {
  incrementalPrepareRender: {
    progress: function(params, context) {
      context.view.incrementalRender(params, context.model, context.ecModel, context.api, context.payload);
    }
  },
  render: {
    forceFirstProgress: true,
    progress: function(params, context) {
      context.view.render(context.model, context.ecModel, context.api, context.payload);
    }
  }
};
var ChartView$1 = ChartView;
var ORIGIN_METHOD = "\0__throttleOriginMethod";
var RATE = "\0__throttleRate";
var THROTTLE_TYPE = "\0__throttleType";
function throttle(fn, delay, debounce2) {
  var currCall;
  var lastCall = 0;
  var lastExec = 0;
  var timer = null;
  var diff;
  var scope;
  var args;
  var debounceNextCall;
  delay = delay || 0;
  function exec() {
    lastExec = new Date().getTime();
    timer = null;
    fn.apply(scope, args || []);
  }
  var cb2 = function() {
    var cbArgs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      cbArgs[_i] = arguments[_i];
    }
    currCall = new Date().getTime();
    scope = this;
    args = cbArgs;
    var thisDelay = debounceNextCall || delay;
    var thisDebounce = debounceNextCall || debounce2;
    debounceNextCall = null;
    diff = currCall - (thisDebounce ? lastCall : lastExec) - thisDelay;
    clearTimeout(timer);
    if (thisDebounce) {
      timer = setTimeout(exec, thisDelay);
    } else {
      if (diff >= 0) {
        exec();
      } else {
        timer = setTimeout(exec, -diff);
      }
    }
    lastCall = currCall;
  };
  cb2.clear = function() {
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
  };
  cb2.debounceNextCall = function(debounceDelay) {
    debounceNextCall = debounceDelay;
  };
  return cb2;
}
function createOrUpdate(obj, fnAttr, rate, throttleType) {
  var fn = obj[fnAttr];
  if (!fn) {
    return;
  }
  var originFn = fn[ORIGIN_METHOD] || fn;
  var lastThrottleType = fn[THROTTLE_TYPE];
  var lastRate = fn[RATE];
  if (lastRate !== rate || lastThrottleType !== throttleType) {
    if (rate == null || !throttleType) {
      return obj[fnAttr] = originFn;
    }
    fn = obj[fnAttr] = throttle(originFn, rate, throttleType === "debounce");
    fn[ORIGIN_METHOD] = originFn;
    fn[THROTTLE_TYPE] = throttleType;
    fn[RATE] = rate;
  }
  return fn;
}
function clear$1(obj, fnAttr) {
  var fn = obj[fnAttr];
  if (fn && fn[ORIGIN_METHOD]) {
    fn.clear && fn.clear();
    obj[fnAttr] = fn[ORIGIN_METHOD];
  }
}
var inner$i = makeInner();
var defaultStyleMappers = {
  itemStyle: makeStyleMapper(ITEM_STYLE_KEY_MAP, true),
  lineStyle: makeStyleMapper(LINE_STYLE_KEY_MAP, true)
};
var defaultColorKey = {
  lineStyle: "stroke",
  itemStyle: "fill"
};
function getStyleMapper(seriesModel, stylePath) {
  var styleMapper = seriesModel.visualStyleMapper || defaultStyleMappers[stylePath];
  if (!styleMapper) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return defaultStyleMappers.itemStyle;
  }
  return styleMapper;
}
function getDefaultColorKey(seriesModel, stylePath) {
  var colorKey = seriesModel.visualDrawType || defaultColorKey[stylePath];
  if (!colorKey) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return "fill";
  }
  return colorKey;
}
var seriesStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var styleModel = seriesModel.getModel(stylePath);
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var globalStyle = getStyle2(styleModel);
    var decalOption = styleModel.getShallow("decal");
    if (decalOption) {
      data.setVisual("decal", decalOption);
      decalOption.dirty = true;
    }
    var colorKey = getDefaultColorKey(seriesModel, stylePath);
    var color = globalStyle[colorKey];
    var colorCallback = isFunction(color) ? color : null;
    var hasAutoColor = globalStyle.fill === "auto" || globalStyle.stroke === "auto";
    if (!globalStyle[colorKey] || colorCallback || hasAutoColor) {
      var colorPalette2 = seriesModel.getColorFromPalette(seriesModel.name, null, ecModel.getSeriesCount());
      if (!globalStyle[colorKey]) {
        globalStyle[colorKey] = colorPalette2;
        data.setVisual("colorFromPalette", true);
      }
      globalStyle.fill = globalStyle.fill === "auto" || isFunction(globalStyle.fill) ? colorPalette2 : globalStyle.fill;
      globalStyle.stroke = globalStyle.stroke === "auto" || isFunction(globalStyle.stroke) ? colorPalette2 : globalStyle.stroke;
    }
    data.setVisual("style", globalStyle);
    data.setVisual("drawType", colorKey);
    if (!ecModel.isSeriesFiltered(seriesModel) && colorCallback) {
      data.setVisual("colorFromPalette", false);
      return {
        dataEach: function(data2, idx) {
          var dataParams = seriesModel.getDataParams(idx);
          var itemStyle = extend({}, globalStyle);
          itemStyle[colorKey] = colorCallback(dataParams);
          data2.setItemVisual(idx, "style", itemStyle);
        }
      };
    }
  }
};
var sharedModel = new Model$1();
var dataStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (seriesModel.ignoreStyleOnData || ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var colorKey = data.getVisual("drawType");
    return {
      dataEach: data.hasItemOption ? function(data2, idx) {
        var rawItem = data2.getRawDataItem(idx);
        if (rawItem && rawItem[stylePath]) {
          sharedModel.option = rawItem[stylePath];
          var style2 = getStyle2(sharedModel);
          var existsStyle = data2.ensureUniqueItemVisual(idx, "style");
          extend(existsStyle, style2);
          if (sharedModel.option.decal) {
            data2.setItemVisual(idx, "decal", sharedModel.option.decal);
            sharedModel.option.decal.dirty = true;
          }
          if (colorKey in style2) {
            data2.setItemVisual(idx, "colorFromPalette", false);
          }
        }
      } : null
    };
  }
};
var dataColorPaletteTask = {
  performRawSeries: true,
  overallReset: function(ecModel) {
    var paletteScopeGroupByType = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var colorBy = seriesModel.getColorBy();
      if (seriesModel.isColorBySeries()) {
        return;
      }
      var key = seriesModel.type + "-" + colorBy;
      var colorScope = paletteScopeGroupByType.get(key);
      if (!colorScope) {
        colorScope = {};
        paletteScopeGroupByType.set(key, colorScope);
      }
      inner$i(seriesModel).scope = colorScope;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.isColorBySeries() || ecModel.isSeriesFiltered(seriesModel)) {
        return;
      }
      var dataAll = seriesModel.getRawData();
      var idxMap = {};
      var data = seriesModel.getData();
      var colorScope = inner$i(seriesModel).scope;
      var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
      var colorKey = getDefaultColorKey(seriesModel, stylePath);
      data.each(function(idx) {
        var rawIdx = data.getRawIndex(idx);
        idxMap[rawIdx] = idx;
      });
      dataAll.each(function(rawIdx) {
        var idx = idxMap[rawIdx];
        var fromPalette = data.getItemVisual(idx, "colorFromPalette");
        if (fromPalette) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          var name_1 = dataAll.getName(rawIdx) || rawIdx + "";
          var dataCount = dataAll.count();
          itemStyle[colorKey] = seriesModel.getColorFromPalette(name_1, colorScope, dataCount);
        }
      });
    });
  }
};
var PI$5 = Math.PI;
function defaultLoading(api, opts) {
  opts = opts || {};
  defaults(opts, {
    text: "loading",
    textColor: "#000",
    fontSize: 12,
    fontWeight: "normal",
    fontStyle: "normal",
    fontFamily: "sans-serif",
    maskColor: "rgba(255, 255, 255, 0.8)",
    showSpinner: true,
    color: "#5470c6",
    spinnerRadius: 10,
    lineWidth: 5,
    zlevel: 0
  });
  var group = new Group$6();
  var mask = new Rect$3({
    style: {
      fill: opts.maskColor
    },
    zlevel: opts.zlevel,
    z: 1e4
  });
  group.add(mask);
  var textContent = new ZRText$1({
    style: {
      text: opts.text,
      fill: opts.textColor,
      fontSize: opts.fontSize,
      fontWeight: opts.fontWeight,
      fontStyle: opts.fontStyle,
      fontFamily: opts.fontFamily
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  var labelRect = new Rect$3({
    style: {
      fill: "none"
    },
    textContent,
    textConfig: {
      position: "right",
      distance: 10
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  group.add(labelRect);
  var arc;
  if (opts.showSpinner) {
    arc = new Arc$1({
      shape: {
        startAngle: -PI$5 / 2,
        endAngle: -PI$5 / 2 + 0.1,
        r: opts.spinnerRadius
      },
      style: {
        stroke: opts.color,
        lineCap: "round",
        lineWidth: opts.lineWidth
      },
      zlevel: opts.zlevel,
      z: 10001
    });
    arc.animateShape(true).when(1e3, {
      endAngle: PI$5 * 3 / 2
    }).start("circularInOut");
    arc.animateShape(true).when(1e3, {
      startAngle: PI$5 * 3 / 2
    }).delay(300).start("circularInOut");
    group.add(arc);
  }
  group.resize = function() {
    var textWidth = textContent.getBoundingRect().width;
    var r2 = opts.showSpinner ? opts.spinnerRadius : 0;
    var cx = (api.getWidth() - r2 * 2 - (opts.showSpinner && textWidth ? 10 : 0) - textWidth) / 2 - (opts.showSpinner && textWidth ? 0 : 5 + textWidth / 2) + (opts.showSpinner ? 0 : textWidth / 2) + (textWidth ? 0 : r2);
    var cy = api.getHeight() / 2;
    opts.showSpinner && arc.setShape({
      cx,
      cy
    });
    labelRect.setShape({
      x: cx - r2,
      y: cy - r2,
      width: r2 * 2,
      height: r2 * 2
    });
    mask.setShape({
      x: 0,
      y: 0,
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  group.resize();
  return group;
}
var Scheduler = function() {
  function Scheduler2(ecInstance, api, dataProcessorHandlers, visualHandlers) {
    this._stageTaskMap = createHashMap();
    this.ecInstance = ecInstance;
    this.api = api;
    dataProcessorHandlers = this._dataProcessorHandlers = dataProcessorHandlers.slice();
    visualHandlers = this._visualHandlers = visualHandlers.slice();
    this._allHandlers = dataProcessorHandlers.concat(visualHandlers);
  }
  Scheduler2.prototype.restoreData = function(ecModel, payload) {
    ecModel.restoreData(payload);
    this._stageTaskMap.each(function(taskRecord) {
      var overallTask = taskRecord.overallTask;
      overallTask && overallTask.dirty();
    });
  };
  Scheduler2.prototype.getPerformArgs = function(task, isBlock) {
    if (!task.__pipeline) {
      return;
    }
    var pipeline = this._pipelineMap.get(task.__pipeline.id);
    var pCtx = pipeline.context;
    var incremental = !isBlock && pipeline.progressiveEnabled && (!pCtx || pCtx.progressiveRender) && task.__idxInPipeline > pipeline.blockIndex;
    var step = incremental ? pipeline.step : null;
    var modDataCount = pCtx && pCtx.modDataCount;
    var modBy = modDataCount != null ? Math.ceil(modDataCount / step) : null;
    return {
      step,
      modBy,
      modDataCount
    };
  };
  Scheduler2.prototype.getPipeline = function(pipelineId) {
    return this._pipelineMap.get(pipelineId);
  };
  Scheduler2.prototype.updateStreamModes = function(seriesModel, view) {
    var pipeline = this._pipelineMap.get(seriesModel.uid);
    var data = seriesModel.getData();
    var dataLen = data.count();
    var progressiveRender = pipeline.progressiveEnabled && view.incrementalPrepareRender && dataLen >= pipeline.threshold;
    var large = seriesModel.get("large") && dataLen >= seriesModel.get("largeThreshold");
    var modDataCount = seriesModel.get("progressiveChunkMode") === "mod" ? dataLen : null;
    seriesModel.pipelineContext = pipeline.context = {
      progressiveRender,
      modDataCount,
      large
    };
  };
  Scheduler2.prototype.restorePipelines = function(ecModel) {
    var scheduler2 = this;
    var pipelineMap = scheduler2._pipelineMap = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var progressive = seriesModel.getProgressive();
      var pipelineId = seriesModel.uid;
      pipelineMap.set(pipelineId, {
        id: pipelineId,
        head: null,
        tail: null,
        threshold: seriesModel.getProgressiveThreshold(),
        progressiveEnabled: progressive && !(seriesModel.preventIncremental && seriesModel.preventIncremental()),
        blockIndex: -1,
        step: Math.round(progressive || 700),
        count: 0
      });
      scheduler2._pipe(seriesModel, seriesModel.dataTask);
    });
  };
  Scheduler2.prototype.prepareStageTasks = function() {
    var stageTaskMap = this._stageTaskMap;
    var ecModel = this.api.getModel();
    var api = this.api;
    each$g(this._allHandlers, function(handler) {
      var record = stageTaskMap.get(handler.uid) || stageTaskMap.set(handler.uid, {});
      var errMsg = "";
      assert(!(handler.reset && handler.overallReset), errMsg);
      handler.reset && this._createSeriesStageTask(handler, record, ecModel, api);
      handler.overallReset && this._createOverallStageTask(handler, record, ecModel, api);
    }, this);
  };
  Scheduler2.prototype.prepareView = function(view, model, ecModel, api) {
    var renderTask = view.renderTask;
    var context = renderTask.context;
    context.model = model;
    context.ecModel = ecModel;
    context.api = api;
    renderTask.__block = !view.incrementalPrepareRender;
    this._pipe(model, renderTask);
  };
  Scheduler2.prototype.performDataProcessorTasks = function(ecModel, payload) {
    this._performStageTasks(this._dataProcessorHandlers, ecModel, payload, {
      block: true
    });
  };
  Scheduler2.prototype.performVisualTasks = function(ecModel, payload, opt) {
    this._performStageTasks(this._visualHandlers, ecModel, payload, opt);
  };
  Scheduler2.prototype._performStageTasks = function(stageHandlers, ecModel, payload, opt) {
    opt = opt || {};
    var unfinished = false;
    var scheduler2 = this;
    each$g(stageHandlers, function(stageHandler, idx) {
      if (opt.visualType && opt.visualType !== stageHandler.visualType) {
        return;
      }
      var stageHandlerRecord = scheduler2._stageTaskMap.get(stageHandler.uid);
      var seriesTaskMap = stageHandlerRecord.seriesTaskMap;
      var overallTask = stageHandlerRecord.overallTask;
      if (overallTask) {
        var overallNeedDirty_1;
        var agentStubMap = overallTask.agentStubMap;
        agentStubMap.each(function(stub) {
          if (needSetDirty(opt, stub)) {
            stub.dirty();
            overallNeedDirty_1 = true;
          }
        });
        overallNeedDirty_1 && overallTask.dirty();
        scheduler2.updatePayload(overallTask, payload);
        var performArgs_1 = scheduler2.getPerformArgs(overallTask, opt.block);
        agentStubMap.each(function(stub) {
          stub.perform(performArgs_1);
        });
        if (overallTask.perform(performArgs_1)) {
          unfinished = true;
        }
      } else if (seriesTaskMap) {
        seriesTaskMap.each(function(task, pipelineId) {
          if (needSetDirty(opt, task)) {
            task.dirty();
          }
          var performArgs = scheduler2.getPerformArgs(task, opt.block);
          performArgs.skip = !stageHandler.performRawSeries && ecModel.isSeriesFiltered(task.context.model);
          scheduler2.updatePayload(task, payload);
          if (task.perform(performArgs)) {
            unfinished = true;
          }
        });
      }
    });
    function needSetDirty(opt2, task) {
      return opt2.setDirty && (!opt2.dirtyMap || opt2.dirtyMap.get(task.__pipeline.id));
    }
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.performSeriesTasks = function(ecModel) {
    var unfinished;
    ecModel.eachSeries(function(seriesModel) {
      unfinished = seriesModel.dataTask.perform() || unfinished;
    });
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.plan = function() {
    this._pipelineMap.each(function(pipeline) {
      var task = pipeline.tail;
      do {
        if (task.__block) {
          pipeline.blockIndex = task.__idxInPipeline;
          break;
        }
        task = task.getUpstream();
      } while (task);
    });
  };
  Scheduler2.prototype.updatePayload = function(task, payload) {
    payload !== "remain" && (task.context.payload = payload);
  };
  Scheduler2.prototype._createSeriesStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler2 = this;
    var oldSeriesTaskMap = stageHandlerRecord.seriesTaskMap;
    var newSeriesTaskMap = stageHandlerRecord.seriesTaskMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    if (stageHandler.createOnAllSeries) {
      ecModel.eachRawSeries(create2);
    } else if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, create2);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(create2);
    }
    function create2(seriesModel) {
      var pipelineId = seriesModel.uid;
      var task = newSeriesTaskMap.set(pipelineId, oldSeriesTaskMap && oldSeriesTaskMap.get(pipelineId) || createTask({
        plan: seriesTaskPlan,
        reset: seriesTaskReset,
        count: seriesTaskCount
      }));
      task.context = {
        model: seriesModel,
        ecModel,
        api,
        useClearVisual: stageHandler.isVisual && !stageHandler.isLayout,
        plan: stageHandler.plan,
        reset: stageHandler.reset,
        scheduler: scheduler2
      };
      scheduler2._pipe(seriesModel, task);
    }
  };
  Scheduler2.prototype._createOverallStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler2 = this;
    var overallTask = stageHandlerRecord.overallTask = stageHandlerRecord.overallTask || createTask({
      reset: overallTaskReset
    });
    overallTask.context = {
      ecModel,
      api,
      overallReset: stageHandler.overallReset,
      scheduler: scheduler2
    };
    var oldAgentStubMap = overallTask.agentStubMap;
    var newAgentStubMap = overallTask.agentStubMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    var overallProgress = true;
    var shouldOverallTaskDirty = false;
    var errMsg = "";
    assert(!stageHandler.createOnAllSeries, errMsg);
    if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, createStub);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(createStub);
    } else {
      overallProgress = false;
      each$g(ecModel.getSeries(), createStub);
    }
    function createStub(seriesModel) {
      var pipelineId = seriesModel.uid;
      var stub = newAgentStubMap.set(pipelineId, oldAgentStubMap && oldAgentStubMap.get(pipelineId) || (shouldOverallTaskDirty = true, createTask({
        reset: stubReset,
        onDirty: stubOnDirty
      })));
      stub.context = {
        model: seriesModel,
        overallProgress
      };
      stub.agent = overallTask;
      stub.__block = overallProgress;
      scheduler2._pipe(seriesModel, stub);
    }
    if (shouldOverallTaskDirty) {
      overallTask.dirty();
    }
  };
  Scheduler2.prototype._pipe = function(seriesModel, task) {
    var pipelineId = seriesModel.uid;
    var pipeline = this._pipelineMap.get(pipelineId);
    !pipeline.head && (pipeline.head = task);
    pipeline.tail && pipeline.tail.pipe(task);
    pipeline.tail = task;
    task.__idxInPipeline = pipeline.count++;
    task.__pipeline = pipeline;
  };
  Scheduler2.wrapStageHandler = function(stageHandler, visualType) {
    if (isFunction(stageHandler)) {
      stageHandler = {
        overallReset: stageHandler,
        seriesType: detectSeriseType(stageHandler)
      };
    }
    stageHandler.uid = getUID("stageHandler");
    visualType && (stageHandler.visualType = visualType);
    return stageHandler;
  };
  return Scheduler2;
}();
function overallTaskReset(context) {
  context.overallReset(context.ecModel, context.api, context.payload);
}
function stubReset(context) {
  return context.overallProgress && stubProgress;
}
function stubProgress() {
  this.agent.dirty();
  this.getDownstream().dirty();
}
function stubOnDirty() {
  this.agent && this.agent.dirty();
}
function seriesTaskPlan(context) {
  return context.plan ? context.plan(context.model, context.ecModel, context.api, context.payload) : null;
}
function seriesTaskReset(context) {
  if (context.useClearVisual) {
    context.data.clearAllVisual();
  }
  var resetDefines = context.resetDefines = normalizeToArray(context.reset(context.model, context.ecModel, context.api, context.payload));
  return resetDefines.length > 1 ? map$1(resetDefines, function(v4, idx) {
    return makeSeriesTaskProgress(idx);
  }) : singleSeriesTaskProgress;
}
var singleSeriesTaskProgress = makeSeriesTaskProgress(0);
function makeSeriesTaskProgress(resetDefineIdx) {
  return function(params, context) {
    var data = context.data;
    var resetDefine = context.resetDefines[resetDefineIdx];
    if (resetDefine && resetDefine.dataEach) {
      for (var i = params.start; i < params.end; i++) {
        resetDefine.dataEach(data, i);
      }
    } else if (resetDefine && resetDefine.progress) {
      resetDefine.progress(params, data);
    }
  };
}
function seriesTaskCount(context) {
  return context.data.count();
}
function detectSeriseType(legacyFunc) {
  seriesType = null;
  try {
    legacyFunc(ecModelMock, apiMock);
  } catch (e2) {
  }
  return seriesType;
}
var ecModelMock = {};
var apiMock = {};
var seriesType;
mockMethods(ecModelMock, GlobalModel$1);
mockMethods(apiMock, ExtensionAPI$1);
ecModelMock.eachSeriesByType = ecModelMock.eachRawSeriesByType = function(type4) {
  seriesType = type4;
};
ecModelMock.eachComponent = function(cond) {
  if (cond.mainType === "series" && cond.subType) {
    seriesType = cond.subType;
  }
};
function mockMethods(target, Clz) {
  for (var name_1 in Clz.prototype) {
    target[name_1] = noop$1;
  }
}
var Scheduler$1 = Scheduler;
var colorAll = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"];
var lightTheme = {
  color: colorAll,
  colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], colorAll]
};
var contrastColor = "#B9B8CE";
var backgroundColor = "#100C2A";
var axisCommon = function() {
  return {
    axisLine: {
      lineStyle: {
        color: contrastColor
      }
    },
    splitLine: {
      lineStyle: {
        color: "#484753"
      }
    },
    splitArea: {
      areaStyle: {
        color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"]
      }
    },
    minorSplitLine: {
      lineStyle: {
        color: "#20203B"
      }
    }
  };
};
var colorPalette = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"];
var theme = {
  darkMode: true,
  color: colorPalette,
  backgroundColor,
  axisPointer: {
    lineStyle: {
      color: "#817f91"
    },
    crossStyle: {
      color: "#817f91"
    },
    label: {
      color: "#fff"
    }
  },
  legend: {
    textStyle: {
      color: contrastColor
    }
  },
  textStyle: {
    color: contrastColor
  },
  title: {
    textStyle: {
      color: "#EEF1FA"
    },
    subtextStyle: {
      color: "#B9B8CE"
    }
  },
  toolbox: {
    iconStyle: {
      borderColor: contrastColor
    }
  },
  dataZoom: {
    borderColor: "#71708A",
    textStyle: {
      color: contrastColor
    },
    brushStyle: {
      color: "rgba(135,163,206,0.3)"
    },
    handleStyle: {
      color: "#353450",
      borderColor: "#C5CBE3"
    },
    moveHandleStyle: {
      color: "#B0B6C3",
      opacity: 0.3
    },
    fillerColor: "rgba(135,163,206,0.2)",
    emphasis: {
      handleStyle: {
        borderColor: "#91B7F2",
        color: "#4D587D"
      },
      moveHandleStyle: {
        color: "#636D9A",
        opacity: 0.7
      }
    },
    dataBackground: {
      lineStyle: {
        color: "#71708A",
        width: 1
      },
      areaStyle: {
        color: "#71708A"
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#87A3CE"
      },
      areaStyle: {
        color: "#87A3CE"
      }
    }
  },
  visualMap: {
    textStyle: {
      color: contrastColor
    }
  },
  timeline: {
    lineStyle: {
      color: contrastColor
    },
    label: {
      color: contrastColor
    },
    controlStyle: {
      color: contrastColor,
      borderColor: contrastColor
    }
  },
  calendar: {
    itemStyle: {
      color: backgroundColor
    },
    dayLabel: {
      color: contrastColor
    },
    monthLabel: {
      color: contrastColor
    },
    yearLabel: {
      color: contrastColor
    }
  },
  timeAxis: axisCommon(),
  logAxis: axisCommon(),
  valueAxis: axisCommon(),
  categoryAxis: axisCommon(),
  line: {
    symbol: "circle"
  },
  graph: {
    color: colorPalette
  },
  gauge: {
    title: {
      color: contrastColor
    },
    axisLine: {
      lineStyle: {
        color: [[1, "rgba(207,212,219,0.2)"]]
      }
    },
    axisLabel: {
      color: contrastColor
    },
    detail: {
      color: "#EEF1FA"
    }
  },
  candlestick: {
    itemStyle: {
      color: "#f64e56",
      color0: "#54ea92",
      borderColor: "#f64e56",
      borderColor0: "#54ea92"
    }
  }
};
theme.categoryAxis.splitLine.show = false;
var darkTheme = theme;
var ECEventProcessor = function() {
  function ECEventProcessor2() {
  }
  ECEventProcessor2.prototype.normalizeQuery = function(query) {
    var cptQuery = {};
    var dataQuery = {};
    var otherQuery = {};
    if (isString$1(query)) {
      var condCptType = parseClassType(query);
      cptQuery.mainType = condCptType.main || null;
      cptQuery.subType = condCptType.sub || null;
    } else {
      var suffixes_1 = ["Index", "Name", "Id"];
      var dataKeys_1 = {
        name: 1,
        dataIndex: 1,
        dataType: 1
      };
      each$g(query, function(val, key) {
        var reserved = false;
        for (var i = 0; i < suffixes_1.length; i++) {
          var propSuffix = suffixes_1[i];
          var suffixPos = key.lastIndexOf(propSuffix);
          if (suffixPos > 0 && suffixPos === key.length - propSuffix.length) {
            var mainType = key.slice(0, suffixPos);
            if (mainType !== "data") {
              cptQuery.mainType = mainType;
              cptQuery[propSuffix.toLowerCase()] = val;
              reserved = true;
            }
          }
        }
        if (dataKeys_1.hasOwnProperty(key)) {
          dataQuery[key] = val;
          reserved = true;
        }
        if (!reserved) {
          otherQuery[key] = val;
        }
      });
    }
    return {
      cptQuery,
      dataQuery,
      otherQuery
    };
  };
  ECEventProcessor2.prototype.filter = function(eventType, query) {
    var eventInfo = this.eventInfo;
    if (!eventInfo) {
      return true;
    }
    var targetEl = eventInfo.targetEl;
    var packedEvent = eventInfo.packedEvent;
    var model = eventInfo.model;
    var view = eventInfo.view;
    if (!model || !view) {
      return true;
    }
    var cptQuery = query.cptQuery;
    var dataQuery = query.dataQuery;
    return check(cptQuery, model, "mainType") && check(cptQuery, model, "subType") && check(cptQuery, model, "index", "componentIndex") && check(cptQuery, model, "name") && check(cptQuery, model, "id") && check(dataQuery, packedEvent, "name") && check(dataQuery, packedEvent, "dataIndex") && check(dataQuery, packedEvent, "dataType") && (!view.filterForExposedEvent || view.filterForExposedEvent(eventType, query.otherQuery, targetEl, packedEvent));
    function check(query2, host, prop, propOnHost) {
      return query2[prop] == null || host[propOnHost || prop] === query2[prop];
    }
  };
  ECEventProcessor2.prototype.afterTrigger = function() {
    this.eventInfo = null;
  };
  return ECEventProcessor2;
}();
var SYMBOL_PROPS_WITH_CB = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"];
var SYMBOL_PROPS = SYMBOL_PROPS_WITH_CB.concat(["symbolKeepAspect"]);
var seriesSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    if (seriesModel.legendIcon) {
      data.setVisual("legendIcon", seriesModel.legendIcon);
    }
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    var symbolOptions = {};
    var symbolOptionsCb = {};
    var hasCallback = false;
    for (var i = 0; i < SYMBOL_PROPS_WITH_CB.length; i++) {
      var symbolPropName = SYMBOL_PROPS_WITH_CB[i];
      var val = seriesModel.get(symbolPropName);
      if (isFunction(val)) {
        hasCallback = true;
        symbolOptionsCb[symbolPropName] = val;
      } else {
        symbolOptions[symbolPropName] = val;
      }
    }
    symbolOptions.symbol = symbolOptions.symbol || seriesModel.defaultSymbol;
    data.setVisual(extend({
      legendIcon: seriesModel.legendIcon || symbolOptions.symbol,
      symbolKeepAspect: seriesModel.get("symbolKeepAspect")
    }, symbolOptions));
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var symbolPropsCb = keys(symbolOptionsCb);
    function dataEach(data2, idx) {
      var rawValue = seriesModel.getRawValue(idx);
      var params = seriesModel.getDataParams(idx);
      for (var i2 = 0; i2 < symbolPropsCb.length; i2++) {
        var symbolPropName2 = symbolPropsCb[i2];
        data2.setItemVisual(idx, symbolPropName2, symbolOptionsCb[symbolPropName2](rawValue, params));
      }
    }
    return {
      dataEach: hasCallback ? dataEach : null
    };
  }
};
var dataSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      for (var i = 0; i < SYMBOL_PROPS.length; i++) {
        var symbolPropName = SYMBOL_PROPS[i];
        var val = itemModel.getShallow(symbolPropName, true);
        if (val != null) {
          data2.setItemVisual(idx, symbolPropName, val);
        }
      }
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
function getItemVisualFromData(data, dataIndex, key) {
  switch (key) {
    case "color":
      var style2 = data.getItemVisual(dataIndex, "style");
      return style2[data.getVisual("drawType")];
    case "opacity":
      return data.getItemVisual(dataIndex, "style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getItemVisual(dataIndex, key);
  }
}
function getVisualFromData(data, key) {
  switch (key) {
    case "color":
      var style2 = data.getVisual("style");
      return style2[data.getVisual("drawType")];
    case "opacity":
      return data.getVisual("style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getVisual(key);
  }
}
function setItemVisualFromData(data, dataIndex, key, value) {
  switch (key) {
    case "color":
      var style2 = data.ensureUniqueItemVisual(dataIndex, "style");
      style2[data.getVisual("drawType")] = value;
      data.setItemVisual(dataIndex, "colorFromPalette", false);
      break;
    case "opacity":
      data.ensureUniqueItemVisual(dataIndex, "style").opacity = value;
      break;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      data.setItemVisual(dataIndex, key, value);
      break;
  }
}
function createLegacyDataSelectAction(seriesType2, ecRegisterAction) {
  function getSeriesIndices(ecModel, payload) {
    var seriesIndices = [];
    ecModel.eachComponent({
      mainType: "series",
      subType: seriesType2,
      query: payload
    }, function(seriesModel) {
      seriesIndices.push(seriesModel.seriesIndex);
    });
    return seriesIndices;
  }
  each$g([[seriesType2 + "ToggleSelect", "toggleSelect"], [seriesType2 + "Select", "select"], [seriesType2 + "UnSelect", "unselect"]], function(eventsMap) {
    ecRegisterAction(eventsMap[0], function(payload, ecModel, api) {
      payload = extend({}, payload);
      api.dispatchAction(extend(payload, {
        type: eventsMap[1],
        seriesIndex: getSeriesIndices(ecModel, payload)
      }));
    });
  });
}
function handleSeriesLegacySelectEvents(type4, eventPostfix, ecIns, ecModel, payload) {
  var legacyEventName = type4 + eventPostfix;
  if (!ecIns.isSilent(legacyEventName)) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "pie"
    }, function(seriesModel) {
      var seriesIndex = seriesModel.seriesIndex;
      var selectedMap = seriesModel.option.selectedMap;
      var selected = payload.selected;
      for (var i = 0; i < selected.length; i++) {
        if (selected[i].seriesIndex === seriesIndex) {
          var data = seriesModel.getData();
          var dataIndex = queryDataIndex(data, payload.fromActionPayload);
          ecIns.trigger(legacyEventName, {
            type: legacyEventName,
            seriesId: seriesModel.id,
            name: isArray$1(dataIndex) ? data.getName(dataIndex[0]) : data.getName(dataIndex),
            selected: isString$1(selectedMap) ? selectedMap : extend({}, selectedMap)
          });
        }
      }
    });
  }
}
function handleLegacySelectEvents(messageCenter, ecIns, api) {
  messageCenter.on("selectchanged", function(params) {
    var ecModel = api.getModel();
    if (params.isFromClick) {
      handleSeriesLegacySelectEvents("map", "selectchanged", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selectchanged", ecIns, ecModel, params);
    } else if (params.fromAction === "select") {
      handleSeriesLegacySelectEvents("map", "selected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selected", ecIns, ecModel, params);
    } else if (params.fromAction === "unselect") {
      handleSeriesLegacySelectEvents("map", "unselected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "unselected", ecIns, ecModel, params);
    }
  });
}
function findEventDispatcher(target, det, returnFirstMatch) {
  var found;
  while (target) {
    if (det(target)) {
      found = target;
      if (returnFirstMatch) {
        break;
      }
    }
    target = target.__hostTarget || target.parent;
  }
  return found;
}
var wmUniqueIndex = Math.round(Math.random() * 9);
var supportDefineProperty = typeof Object.defineProperty === "function";
var WeakMap$1 = function() {
  function WeakMap2() {
    this._id = "__ec_inner_" + wmUniqueIndex++;
  }
  WeakMap2.prototype.get = function(key) {
    return this._guard(key)[this._id];
  };
  WeakMap2.prototype.set = function(key, value) {
    var target = this._guard(key);
    if (supportDefineProperty) {
      Object.defineProperty(target, this._id, {
        value,
        enumerable: false,
        configurable: true
      });
    } else {
      target[this._id] = value;
    }
    return this;
  };
  WeakMap2.prototype["delete"] = function(key) {
    if (this.has(key)) {
      delete this._guard(key)[this._id];
      return true;
    }
    return false;
  };
  WeakMap2.prototype.has = function(key) {
    return !!this._guard(key)[this._id];
  };
  WeakMap2.prototype._guard = function(key) {
    if (key !== Object(key)) {
      throw TypeError("Value of WeakMap is not a non-null object.");
    }
    return key;
  };
  return WeakMap2;
}();
var WeakMap$2 = WeakMap$1;
var Triangle = Path$1.extend({
  type: "triangle",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy + height);
    path.lineTo(cx - width, cy + height);
    path.closePath();
  }
});
var Diamond = Path$1.extend({
  type: "diamond",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy);
    path.lineTo(cx, cy + height);
    path.lineTo(cx - width, cy);
    path.closePath();
  }
});
var Pin = Path$1.extend({
  type: "pin",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var x2 = shape.x;
    var y2 = shape.y;
    var w2 = shape.width / 5 * 3;
    var h = Math.max(w2, shape.height);
    var r2 = w2 / 2;
    var dy = r2 * r2 / (h - r2);
    var cy = y2 - h + r2 + dy;
    var angle = Math.asin(dy / r2);
    var dx = Math.cos(angle) * r2;
    var tanX = Math.sin(angle);
    var tanY = Math.cos(angle);
    var cpLen = r2 * 0.6;
    var cpLen2 = r2 * 0.7;
    path.moveTo(x2 - dx, cy + dy);
    path.arc(x2, cy, r2, Math.PI - angle, Math.PI * 2 + angle);
    path.bezierCurveTo(x2 + dx - tanX * cpLen, cy + dy + tanY * cpLen, x2, y2 - cpLen2, x2, y2);
    path.bezierCurveTo(x2, y2 - cpLen2, x2 - dx + tanX * cpLen, cy + dy + tanY * cpLen, x2 - dx, cy + dy);
    path.closePath();
  }
});
var Arrow = Path$1.extend({
  type: "arrow",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(ctx, shape) {
    var height = shape.height;
    var width = shape.width;
    var x2 = shape.x;
    var y2 = shape.y;
    var dx = width / 3 * 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(x2 + dx, y2 + height);
    ctx.lineTo(x2, y2 + height / 4 * 3);
    ctx.lineTo(x2 - dx, y2 + height);
    ctx.lineTo(x2, y2);
    ctx.closePath();
  }
});
var symbolCtors = {
  line: Line$3,
  rect: Rect$3,
  roundRect: Rect$3,
  square: Rect$3,
  circle: Circle$1,
  diamond: Diamond,
  pin: Pin,
  arrow: Arrow,
  triangle: Triangle
};
var symbolShapeMakers = {
  line: function(x2, y2, w2, h, shape) {
    shape.x1 = x2;
    shape.y1 = y2 + h / 2;
    shape.x2 = x2 + w2;
    shape.y2 = y2 + h / 2;
  },
  rect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
  },
  roundRect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
    shape.r = Math.min(w2, h) / 4;
  },
  square: function(x2, y2, w2, h, shape) {
    var size = Math.min(w2, h);
    shape.x = x2;
    shape.y = y2;
    shape.width = size;
    shape.height = size;
  },
  circle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.r = Math.min(w2, h) / 2;
  },
  diamond: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  pin: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  arrow: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  triangle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  }
};
var symbolBuildProxies = {};
each$g(symbolCtors, function(Ctor, name) {
  symbolBuildProxies[name] = new Ctor();
});
var SymbolClz$1 = Path$1.extend({
  type: "symbol",
  shape: {
    symbolType: "",
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  calculateTextPosition: function(out2, config, rect) {
    var res = calculateTextPosition(out2, config, rect);
    var shape = this.shape;
    if (shape && shape.symbolType === "pin" && config.position === "inside") {
      res.y = rect.y + rect.height * 0.4;
    }
    return res;
  },
  buildPath: function(ctx, shape, inBundle) {
    var symbolType = shape.symbolType;
    if (symbolType !== "none") {
      var proxySymbol = symbolBuildProxies[symbolType];
      if (!proxySymbol) {
        symbolType = "rect";
        proxySymbol = symbolBuildProxies[symbolType];
      }
      symbolShapeMakers[symbolType](shape.x, shape.y, shape.width, shape.height, proxySymbol.shape);
      proxySymbol.buildPath(ctx, proxySymbol.shape, inBundle);
    }
  }
});
function symbolPathSetColor(color, innerColor2) {
  if (this.type !== "image") {
    var symbolStyle = this.style;
    if (this.__isEmptyBrush) {
      symbolStyle.stroke = color;
      symbolStyle.fill = innerColor2 || "#fff";
      symbolStyle.lineWidth = 2;
    } else if (this.shape.symbolType === "line") {
      symbolStyle.stroke = color;
    } else {
      symbolStyle.fill = color;
    }
    this.markRedraw();
  }
}
function createSymbol$1(symbolType, x2, y2, w2, h, color, keepAspect) {
  var isEmpty = symbolType.indexOf("empty") === 0;
  if (isEmpty) {
    symbolType = symbolType.substr(5, 1).toLowerCase() + symbolType.substr(6);
  }
  var symbolPath;
  if (symbolType.indexOf("image://") === 0) {
    symbolPath = makeImage(symbolType.slice(8), new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else if (symbolType.indexOf("path://") === 0) {
    symbolPath = makePath(symbolType.slice(7), {}, new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else {
    symbolPath = new SymbolClz$1({
      shape: {
        symbolType,
        x: x2,
        y: y2,
        width: w2,
        height: h
      }
    });
  }
  symbolPath.__isEmptyBrush = isEmpty;
  symbolPath.setColor = symbolPathSetColor;
  if (color) {
    symbolPath.setColor(color);
  }
  return symbolPath;
}
function normalizeSymbolSize(symbolSize) {
  if (!isArray$1(symbolSize)) {
    symbolSize = [+symbolSize, +symbolSize];
  }
  return [symbolSize[0] || 0, symbolSize[1] || 0];
}
function normalizeSymbolOffset(symbolOffset, symbolSize) {
  if (symbolOffset == null) {
    return;
  }
  if (!isArray$1(symbolOffset)) {
    symbolOffset = [symbolOffset, symbolOffset];
  }
  return [parsePercent(symbolOffset[0], symbolSize[0]) || 0, parsePercent(retrieve2(symbolOffset[1], symbolOffset[0]), symbolSize[1]) || 0];
}
function createLinearGradient(ctx, obj, rect) {
  var x2 = obj.x == null ? 0 : obj.x;
  var x22 = obj.x2 == null ? 1 : obj.x2;
  var y2 = obj.y == null ? 0 : obj.y;
  var y22 = obj.y2 == null ? 0 : obj.y2;
  if (!obj.global) {
    x2 = x2 * rect.width + rect.x;
    x22 = x22 * rect.width + rect.x;
    y2 = y2 * rect.height + rect.y;
    y22 = y22 * rect.height + rect.y;
  }
  x2 = isNaN(x2) ? 0 : x2;
  x22 = isNaN(x22) ? 1 : x22;
  y2 = isNaN(y2) ? 0 : y2;
  y22 = isNaN(y22) ? 0 : y22;
  var canvasGradient = ctx.createLinearGradient(x2, y2, x22, y22);
  return canvasGradient;
}
function createRadialGradient(ctx, obj, rect) {
  var width = rect.width;
  var height = rect.height;
  var min3 = Math.min(width, height);
  var x2 = obj.x == null ? 0.5 : obj.x;
  var y2 = obj.y == null ? 0.5 : obj.y;
  var r2 = obj.r == null ? 0.5 : obj.r;
  if (!obj.global) {
    x2 = x2 * width + rect.x;
    y2 = y2 * height + rect.y;
    r2 = r2 * min3;
  }
  var canvasGradient = ctx.createRadialGradient(x2, y2, 0, x2, y2, r2);
  return canvasGradient;
}
function getCanvasGradient(ctx, obj, rect) {
  var canvasGradient = obj.type === "radial" ? createRadialGradient(ctx, obj, rect) : createLinearGradient(ctx, obj, rect);
  var colorStops = obj.colorStops;
  for (var i = 0; i < colorStops.length; i++) {
    canvasGradient.addColorStop(colorStops[i].offset, colorStops[i].color);
  }
  return canvasGradient;
}
function isClipPathChanged(clipPaths, prevClipPaths) {
  if (clipPaths === prevClipPaths || !clipPaths && !prevClipPaths) {
    return false;
  }
  if (!clipPaths || !prevClipPaths || clipPaths.length !== prevClipPaths.length) {
    return true;
  }
  for (var i = 0; i < clipPaths.length; i++) {
    if (clipPaths[i] !== prevClipPaths[i]) {
      return true;
    }
  }
  return false;
}
function parseInt10(val) {
  return parseInt(val, 10);
}
function getSize$1(root2, whIdx, opts) {
  var wh2 = ["width", "height"][whIdx];
  var cwh = ["clientWidth", "clientHeight"][whIdx];
  var plt = ["paddingLeft", "paddingTop"][whIdx];
  var prb = ["paddingRight", "paddingBottom"][whIdx];
  if (opts[wh2] != null && opts[wh2] !== "auto") {
    return parseFloat(opts[wh2]);
  }
  var stl = document.defaultView.getComputedStyle(root2);
  return (root2[cwh] || parseInt10(stl[wh2]) || parseInt10(root2.style[wh2])) - (parseInt10(stl[plt]) || 0) - (parseInt10(stl[prb]) || 0) | 0;
}
function normalizeLineDash(lineType, lineWidth) {
  if (!lineType || lineType === "solid" || !(lineWidth > 0)) {
    return null;
  }
  return lineType === "dashed" ? [4 * lineWidth, 2 * lineWidth] : lineType === "dotted" ? [lineWidth] : isNumber(lineType) ? [lineType] : isArray$1(lineType) ? lineType : null;
}
function getLineDash(el) {
  var style2 = el.style;
  var lineDash = style2.lineDash && style2.lineWidth > 0 && normalizeLineDash(style2.lineDash, style2.lineWidth);
  var lineDashOffset = style2.lineDashOffset;
  if (lineDash) {
    var lineScale_1 = style2.strokeNoScale && el.getLineScale ? el.getLineScale() : 1;
    if (lineScale_1 && lineScale_1 !== 1) {
      lineDash = map$1(lineDash, function(rawVal) {
        return rawVal / lineScale_1;
      });
      lineDashOffset /= lineScale_1;
    }
  }
  return [lineDash, lineDashOffset];
}
var pathProxyForDraw = new PathProxy$1(true);
function styleHasStroke(style2) {
  var stroke = style2.stroke;
  return !(stroke == null || stroke === "none" || !(style2.lineWidth > 0));
}
function isValidStrokeFillStyle(strokeOrFill) {
  return typeof strokeOrFill === "string" && strokeOrFill !== "none";
}
function styleHasFill(style2) {
  var fill = style2.fill;
  return fill != null && fill !== "none";
}
function doFillPath(ctx, style2) {
  if (style2.fillOpacity != null && style2.fillOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style2.fillOpacity * style2.opacity;
    ctx.fill();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.fill();
  }
}
function doStrokePath(ctx, style2) {
  if (style2.strokeOpacity != null && style2.strokeOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style2.strokeOpacity * style2.opacity;
    ctx.stroke();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.stroke();
  }
}
function createCanvasPattern(ctx, pattern4, el) {
  var image = createOrUpdateImage(pattern4.image, pattern4.__image, el);
  if (isImageReady(image)) {
    var canvasPattern = ctx.createPattern(image, pattern4.repeat || "repeat");
    if (typeof DOMMatrix === "function" && canvasPattern && canvasPattern.setTransform) {
      var matrix = new DOMMatrix();
      matrix.translateSelf(pattern4.x || 0, pattern4.y || 0);
      matrix.rotateSelf(0, 0, (pattern4.rotation || 0) * RADIAN_TO_DEGREE);
      matrix.scaleSelf(pattern4.scaleX || 1, pattern4.scaleY || 1);
      canvasPattern.setTransform(matrix);
    }
    return canvasPattern;
  }
}
function brushPath(ctx, el, style2, inBatch) {
  var _a2;
  var hasStroke = styleHasStroke(style2);
  var hasFill = styleHasFill(style2);
  var strokePercent = style2.strokePercent;
  var strokePart = strokePercent < 1;
  var firstDraw = !el.path;
  if ((!el.silent || strokePart) && firstDraw) {
    el.createPathProxy();
  }
  var path = el.path || pathProxyForDraw;
  var dirtyFlag = el.__dirty;
  if (!inBatch) {
    var fill = style2.fill;
    var stroke = style2.stroke;
    var hasFillGradient = hasFill && !!fill.colorStops;
    var hasStrokeGradient = hasStroke && !!stroke.colorStops;
    var hasFillPattern = hasFill && !!fill.image;
    var hasStrokePattern = hasStroke && !!stroke.image;
    var fillGradient = void 0;
    var strokeGradient = void 0;
    var fillPattern = void 0;
    var strokePattern = void 0;
    var rect = void 0;
    if (hasFillGradient || hasStrokeGradient) {
      rect = el.getBoundingRect();
    }
    if (hasFillGradient) {
      fillGradient = dirtyFlag ? getCanvasGradient(ctx, fill, rect) : el.__canvasFillGradient;
      el.__canvasFillGradient = fillGradient;
    }
    if (hasStrokeGradient) {
      strokeGradient = dirtyFlag ? getCanvasGradient(ctx, stroke, rect) : el.__canvasStrokeGradient;
      el.__canvasStrokeGradient = strokeGradient;
    }
    if (hasFillPattern) {
      fillPattern = dirtyFlag || !el.__canvasFillPattern ? createCanvasPattern(ctx, fill, el) : el.__canvasFillPattern;
      el.__canvasFillPattern = fillPattern;
    }
    if (hasStrokePattern) {
      strokePattern = dirtyFlag || !el.__canvasStrokePattern ? createCanvasPattern(ctx, stroke, el) : el.__canvasStrokePattern;
      el.__canvasStrokePattern = fillPattern;
    }
    if (hasFillGradient) {
      ctx.fillStyle = fillGradient;
    } else if (hasFillPattern) {
      if (fillPattern) {
        ctx.fillStyle = fillPattern;
      } else {
        hasFill = false;
      }
    }
    if (hasStrokeGradient) {
      ctx.strokeStyle = strokeGradient;
    } else if (hasStrokePattern) {
      if (strokePattern) {
        ctx.strokeStyle = strokePattern;
      } else {
        hasStroke = false;
      }
    }
  }
  var scale2 = el.getGlobalScale();
  path.setScale(scale2[0], scale2[1], el.segmentIgnoreThreshold);
  var lineDash;
  var lineDashOffset;
  if (ctx.setLineDash && style2.lineDash) {
    _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
  }
  var needsRebuild = true;
  if (firstDraw || dirtyFlag & SHAPE_CHANGED_BIT) {
    path.setDPR(ctx.dpr);
    if (strokePart) {
      path.setContext(null);
    } else {
      path.setContext(ctx);
      needsRebuild = false;
    }
    path.reset();
    el.buildPath(path, el.shape, inBatch);
    path.toStatic();
    el.pathUpdated();
  }
  if (needsRebuild) {
    path.rebuildPath(ctx, strokePart ? strokePercent : 1);
  }
  if (lineDash) {
    ctx.setLineDash(lineDash);
    ctx.lineDashOffset = lineDashOffset;
  }
  if (!inBatch) {
    if (style2.strokeFirst) {
      if (hasStroke) {
        doStrokePath(ctx, style2);
      }
      if (hasFill) {
        doFillPath(ctx, style2);
      }
    } else {
      if (hasFill) {
        doFillPath(ctx, style2);
      }
      if (hasStroke) {
        doStrokePath(ctx, style2);
      }
    }
  }
  if (lineDash) {
    ctx.setLineDash([]);
  }
}
function brushImage(ctx, el, style2) {
  var image = el.__image = createOrUpdateImage(style2.image, el.__image, el, el.onload);
  if (!image || !isImageReady(image)) {
    return;
  }
  var x2 = style2.x || 0;
  var y2 = style2.y || 0;
  var width = el.getWidth();
  var height = el.getHeight();
  var aspect = image.width / image.height;
  if (width == null && height != null) {
    width = height * aspect;
  } else if (height == null && width != null) {
    height = width / aspect;
  } else if (width == null && height == null) {
    width = image.width;
    height = image.height;
  }
  if (style2.sWidth && style2.sHeight) {
    var sx = style2.sx || 0;
    var sy = style2.sy || 0;
    ctx.drawImage(image, sx, sy, style2.sWidth, style2.sHeight, x2, y2, width, height);
  } else if (style2.sx && style2.sy) {
    var sx = style2.sx;
    var sy = style2.sy;
    var sWidth = width - sx;
    var sHeight = height - sy;
    ctx.drawImage(image, sx, sy, sWidth, sHeight, x2, y2, width, height);
  } else {
    ctx.drawImage(image, x2, y2, width, height);
  }
}
function brushText(ctx, el, style2) {
  var _a2;
  var text = style2.text;
  text != null && (text += "");
  if (text) {
    ctx.font = style2.font || DEFAULT_FONT;
    ctx.textAlign = style2.textAlign;
    ctx.textBaseline = style2.textBaseline;
    var lineDash = void 0;
    var lineDashOffset = void 0;
    if (ctx.setLineDash && style2.lineDash) {
      _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
    }
    if (lineDash) {
      ctx.setLineDash(lineDash);
      ctx.lineDashOffset = lineDashOffset;
    }
    if (style2.strokeFirst) {
      if (styleHasStroke(style2)) {
        ctx.strokeText(text, style2.x, style2.y);
      }
      if (styleHasFill(style2)) {
        ctx.fillText(text, style2.x, style2.y);
      }
    } else {
      if (styleHasFill(style2)) {
        ctx.fillText(text, style2.x, style2.y);
      }
      if (styleHasStroke(style2)) {
        ctx.strokeText(text, style2.x, style2.y);
      }
    }
    if (lineDash) {
      ctx.setLineDash([]);
    }
  }
}
var SHADOW_NUMBER_PROPS = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"];
var STROKE_PROPS = [
  ["lineCap", "butt"],
  ["lineJoin", "miter"],
  ["miterLimit", 10]
];
function bindCommonProps(ctx, style2, prevStyle, forceSetAll, scope) {
  var styleChanged = false;
  if (!forceSetAll) {
    prevStyle = prevStyle || {};
    if (style2 === prevStyle) {
      return false;
    }
  }
  if (forceSetAll || style2.opacity !== prevStyle.opacity) {
    flushPathDrawn(ctx, scope);
    styleChanged = true;
    var opacity = Math.max(Math.min(style2.opacity, 1), 0);
    ctx.globalAlpha = isNaN(opacity) ? DEFAULT_COMMON_STYLE.opacity : opacity;
  }
  if (forceSetAll || style2.blend !== prevStyle.blend) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalCompositeOperation = style2.blend || DEFAULT_COMMON_STYLE.blend;
  }
  for (var i = 0; i < SHADOW_NUMBER_PROPS.length; i++) {
    var propName = SHADOW_NUMBER_PROPS[i];
    if (forceSetAll || style2[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = ctx.dpr * (style2[propName] || 0);
    }
  }
  if (forceSetAll || style2.shadowColor !== prevStyle.shadowColor) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.shadowColor = style2.shadowColor || DEFAULT_COMMON_STYLE.shadowColor;
  }
  return styleChanged;
}
function bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetAll, scope) {
  var style2 = getStyle(el, scope.inHover);
  var prevStyle = forceSetAll ? null : prevEl && getStyle(prevEl, scope.inHover) || {};
  if (style2 === prevStyle) {
    return false;
  }
  var styleChanged = bindCommonProps(ctx, style2, prevStyle, forceSetAll, scope);
  if (forceSetAll || style2.fill !== prevStyle.fill) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style2.fill) && (ctx.fillStyle = style2.fill);
  }
  if (forceSetAll || style2.stroke !== prevStyle.stroke) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style2.stroke) && (ctx.strokeStyle = style2.stroke);
  }
  if (forceSetAll || style2.opacity !== prevStyle.opacity) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalAlpha = style2.opacity == null ? 1 : style2.opacity;
  }
  if (el.hasStroke()) {
    var lineWidth = style2.lineWidth;
    var newLineWidth = lineWidth / (style2.strokeNoScale && el.getLineScale ? el.getLineScale() : 1);
    if (ctx.lineWidth !== newLineWidth) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx.lineWidth = newLineWidth;
    }
  }
  for (var i = 0; i < STROKE_PROPS.length; i++) {
    var prop = STROKE_PROPS[i];
    var propName = prop[0];
    if (forceSetAll || style2[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = style2[propName] || prop[1];
    }
  }
  return styleChanged;
}
function bindImageStyle(ctx, el, prevEl, forceSetAll, scope) {
  return bindCommonProps(ctx, getStyle(el, scope.inHover), prevEl && getStyle(prevEl, scope.inHover), forceSetAll, scope);
}
function setContextTransform(ctx, el) {
  var m2 = el.transform;
  var dpr2 = ctx.dpr || 1;
  if (m2) {
    ctx.setTransform(dpr2 * m2[0], dpr2 * m2[1], dpr2 * m2[2], dpr2 * m2[3], dpr2 * m2[4], dpr2 * m2[5]);
  } else {
    ctx.setTransform(dpr2, 0, 0, dpr2, 0, 0);
  }
}
function updateClipStatus(clipPaths, ctx, scope) {
  var allClipped = false;
  for (var i = 0; i < clipPaths.length; i++) {
    var clipPath = clipPaths[i];
    allClipped = allClipped || clipPath.isZeroArea();
    setContextTransform(ctx, clipPath);
    ctx.beginPath();
    clipPath.buildPath(ctx, clipPath.shape);
    ctx.clip();
  }
  scope.allClipped = allClipped;
}
function isTransformChanged(m0, m1) {
  if (m0 && m1) {
    return m0[0] !== m1[0] || m0[1] !== m1[1] || m0[2] !== m1[2] || m0[3] !== m1[3] || m0[4] !== m1[4] || m0[5] !== m1[5];
  } else if (!m0 && !m1) {
    return false;
  }
  return true;
}
var DRAW_TYPE_PATH = 1;
var DRAW_TYPE_IMAGE = 2;
var DRAW_TYPE_TEXT = 3;
var DRAW_TYPE_INCREMENTAL = 4;
function canPathBatch(style2) {
  var hasFill = styleHasFill(style2);
  var hasStroke = styleHasStroke(style2);
  return !(style2.lineDash || !(+hasFill ^ +hasStroke) || hasFill && typeof style2.fill !== "string" || hasStroke && typeof style2.stroke !== "string" || style2.strokePercent < 1 || style2.strokeOpacity < 1 || style2.fillOpacity < 1);
}
function flushPathDrawn(ctx, scope) {
  scope.batchFill && ctx.fill();
  scope.batchStroke && ctx.stroke();
  scope.batchFill = "";
  scope.batchStroke = "";
}
function getStyle(el, inHover) {
  return inHover ? el.__hoverStyle || el.style : el.style;
}
function brushSingle(ctx, el) {
  brush$1(ctx, el, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
}
function brush$1(ctx, el, scope, isLast) {
  var m2 = el.transform;
  if (!el.shouldBePainted(scope.viewWidth, scope.viewHeight, false, false)) {
    el.__dirty &= ~REDRAW_BIT;
    el.__isRendered = false;
    return;
  }
  var clipPaths = el.__clipPaths;
  var prevElClipPaths = scope.prevElClipPaths;
  var forceSetTransform = false;
  var forceSetStyle = false;
  if (!prevElClipPaths || isClipPathChanged(clipPaths, prevElClipPaths)) {
    if (prevElClipPaths && prevElClipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.restore();
      forceSetStyle = forceSetTransform = true;
      scope.prevElClipPaths = null;
      scope.allClipped = false;
      scope.prevEl = null;
    }
    if (clipPaths && clipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.save();
      updateClipStatus(clipPaths, ctx, scope);
      forceSetTransform = true;
    }
    scope.prevElClipPaths = clipPaths;
  }
  if (scope.allClipped) {
    el.__isRendered = false;
    return;
  }
  el.beforeBrush && el.beforeBrush();
  el.innerBeforeBrush();
  var prevEl = scope.prevEl;
  if (!prevEl) {
    forceSetStyle = forceSetTransform = true;
  }
  var canBatchPath = el instanceof Path$1 && el.autoBatch && canPathBatch(el.style);
  if (forceSetTransform || isTransformChanged(m2, prevEl.transform)) {
    flushPathDrawn(ctx, scope);
    setContextTransform(ctx, el);
  } else if (!canBatchPath) {
    flushPathDrawn(ctx, scope);
  }
  var style2 = getStyle(el, scope.inHover);
  if (el instanceof Path$1) {
    if (scope.lastDrawType !== DRAW_TYPE_PATH) {
      forceSetStyle = true;
      scope.lastDrawType = DRAW_TYPE_PATH;
    }
    bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
    if (!canBatchPath || !scope.batchFill && !scope.batchStroke) {
      ctx.beginPath();
    }
    brushPath(ctx, el, style2, canBatchPath);
    if (canBatchPath) {
      scope.batchFill = style2.fill || "";
      scope.batchStroke = style2.stroke || "";
    }
  } else {
    if (el instanceof TSpan$1) {
      if (scope.lastDrawType !== DRAW_TYPE_TEXT) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_TEXT;
      }
      bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushText(ctx, el, style2);
    } else if (el instanceof ZRImage$1) {
      if (scope.lastDrawType !== DRAW_TYPE_IMAGE) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_IMAGE;
      }
      bindImageStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushImage(ctx, el, style2);
    } else if (el.getTemporalDisplayables) {
      if (scope.lastDrawType !== DRAW_TYPE_INCREMENTAL) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_INCREMENTAL;
      }
      brushIncremental(ctx, el, scope);
    }
  }
  if (canBatchPath && isLast) {
    flushPathDrawn(ctx, scope);
  }
  el.innerAfterBrush();
  el.afterBrush && el.afterBrush();
  scope.prevEl = el;
  el.__dirty = 0;
  el.__isRendered = true;
}
function brushIncremental(ctx, el, scope) {
  var displayables = el.getDisplayables();
  var temporalDisplayables = el.getTemporalDisplayables();
  ctx.save();
  var innerScope = {
    prevElClipPaths: null,
    prevEl: null,
    allClipped: false,
    viewWidth: scope.viewWidth,
    viewHeight: scope.viewHeight,
    inHover: scope.inHover
  };
  var i;
  var len2;
  for (i = el.getCursor(), len2 = displayables.length; i < len2; i++) {
    var displayable = displayables[i];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i === len2 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  for (var i_1 = 0, len_1 = temporalDisplayables.length; i_1 < len_1; i_1++) {
    var displayable = temporalDisplayables[i_1];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i_1 === len_1 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  el.clearTemporalDisplayables();
  el.notClear = true;
  ctx.restore();
}
var decalMap = new WeakMap$2();
var decalCache = new LRU$1(100);
var decalKeys = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
function createOrUpdatePatternFromDecal(decalObject, api) {
  if (decalObject === "none") {
    return null;
  }
  var dpr2 = api.getDevicePixelRatio();
  var zr = api.getZr();
  var isSVG = zr.painter.type === "svg";
  if (decalObject.dirty) {
    decalMap["delete"](decalObject);
  }
  var oldPattern = decalMap.get(decalObject);
  if (oldPattern) {
    return oldPattern;
  }
  var decalOpt = defaults(decalObject, {
    symbol: "rect",
    symbolSize: 1,
    symbolKeepAspect: true,
    color: "rgba(0, 0, 0, 0.2)",
    backgroundColor: null,
    dashArrayX: 5,
    dashArrayY: 5,
    rotation: 0,
    maxTileWidth: 512,
    maxTileHeight: 512
  });
  if (decalOpt.backgroundColor === "none") {
    decalOpt.backgroundColor = null;
  }
  var pattern4 = {
    repeat: "repeat"
  };
  setPatternnSource(pattern4);
  pattern4.rotation = decalOpt.rotation;
  pattern4.scaleX = pattern4.scaleY = isSVG ? 1 : 1 / dpr2;
  decalMap.set(decalObject, pattern4);
  decalObject.dirty = false;
  return pattern4;
  function setPatternnSource(pattern5) {
    var keys2 = [dpr2];
    var isValidKey = true;
    for (var i = 0; i < decalKeys.length; ++i) {
      var value = decalOpt[decalKeys[i]];
      if (value != null && !isArray$1(value) && !isString$1(value) && !isNumber(value) && typeof value !== "boolean") {
        isValidKey = false;
        break;
      }
      keys2.push(value);
    }
    var cacheKey;
    if (isValidKey) {
      cacheKey = keys2.join(",") + (isSVG ? "-svg" : "");
      var cache = decalCache.get(cacheKey);
      if (cache) {
        isSVG ? pattern5.svgElement = cache : pattern5.image = cache;
      }
    }
    var dashArrayX = normalizeDashArrayX(decalOpt.dashArrayX);
    var dashArrayY = normalizeDashArrayY(decalOpt.dashArrayY);
    var symbolArray = normalizeSymbolArray(decalOpt.symbol);
    var lineBlockLengthsX = getLineBlockLengthX(dashArrayX);
    var lineBlockLengthY = getLineBlockLengthY(dashArrayY);
    var canvas = !isSVG && platformApi.createCanvas();
    var svgRoot = isSVG && {
      tag: "g",
      attrs: {},
      key: "dcl",
      children: []
    };
    var pSize = getPatternSize();
    var ctx;
    if (canvas) {
      canvas.width = pSize.width * dpr2;
      canvas.height = pSize.height * dpr2;
      ctx = canvas.getContext("2d");
    }
    brushDecal();
    if (isValidKey) {
      decalCache.put(cacheKey, canvas || svgRoot);
    }
    pattern5.image = canvas;
    pattern5.svgElement = svgRoot;
    pattern5.svgWidth = pSize.width;
    pattern5.svgHeight = pSize.height;
    function getPatternSize() {
      var width = 1;
      for (var i2 = 0, xlen = lineBlockLengthsX.length; i2 < xlen; ++i2) {
        width = getLeastCommonMultiple(width, lineBlockLengthsX[i2]);
      }
      var symbolRepeats = 1;
      for (var i2 = 0, xlen = symbolArray.length; i2 < xlen; ++i2) {
        symbolRepeats = getLeastCommonMultiple(symbolRepeats, symbolArray[i2].length);
      }
      width *= symbolRepeats;
      var height = lineBlockLengthY * lineBlockLengthsX.length * symbolArray.length;
      return {
        width: Math.max(1, Math.min(width, decalOpt.maxTileWidth)),
        height: Math.max(1, Math.min(height, decalOpt.maxTileHeight))
      };
    }
    function brushDecal() {
      if (ctx) {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        if (decalOpt.backgroundColor) {
          ctx.fillStyle = decalOpt.backgroundColor;
          ctx.fillRect(0, 0, canvas.width, canvas.height);
        }
      }
      var ySum = 0;
      for (var i2 = 0; i2 < dashArrayY.length; ++i2) {
        ySum += dashArrayY[i2];
      }
      if (ySum <= 0) {
        return;
      }
      var y2 = -lineBlockLengthY;
      var yId = 0;
      var yIdTotal = 0;
      var xId0 = 0;
      while (y2 < pSize.height) {
        if (yId % 2 === 0) {
          var symbolYId = yIdTotal / 2 % symbolArray.length;
          var x2 = 0;
          var xId1 = 0;
          var xId1Total = 0;
          while (x2 < pSize.width * 2) {
            var xSum = 0;
            for (var i2 = 0; i2 < dashArrayX[xId0].length; ++i2) {
              xSum += dashArrayX[xId0][i2];
            }
            if (xSum <= 0) {
              break;
            }
            if (xId1 % 2 === 0) {
              var size = (1 - decalOpt.symbolSize) * 0.5;
              var left = x2 + dashArrayX[xId0][xId1] * size;
              var top_1 = y2 + dashArrayY[yId] * size;
              var width = dashArrayX[xId0][xId1] * decalOpt.symbolSize;
              var height = dashArrayY[yId] * decalOpt.symbolSize;
              var symbolXId = xId1Total / 2 % symbolArray[symbolYId].length;
              brushSymbol(left, top_1, width, height, symbolArray[symbolYId][symbolXId]);
            }
            x2 += dashArrayX[xId0][xId1];
            ++xId1Total;
            ++xId1;
            if (xId1 === dashArrayX[xId0].length) {
              xId1 = 0;
            }
          }
          ++xId0;
          if (xId0 === dashArrayX.length) {
            xId0 = 0;
          }
        }
        y2 += dashArrayY[yId];
        ++yIdTotal;
        ++yId;
        if (yId === dashArrayY.length) {
          yId = 0;
        }
      }
      function brushSymbol(x3, y3, width2, height2, symbolType) {
        var scale2 = isSVG ? 1 : dpr2;
        var symbol = createSymbol$1(symbolType, x3 * scale2, y3 * scale2, width2 * scale2, height2 * scale2, decalOpt.color, decalOpt.symbolKeepAspect);
        if (isSVG) {
          var symbolVNode = zr.painter.renderOneToVNode(symbol);
          if (symbolVNode) {
            svgRoot.children.push(symbolVNode);
          }
        } else {
          brushSingle(ctx, symbol);
        }
      }
    }
  }
}
function normalizeSymbolArray(symbol) {
  if (!symbol || symbol.length === 0) {
    return [["rect"]];
  }
  if (isString$1(symbol)) {
    return [[symbol]];
  }
  var isAllString = true;
  for (var i = 0; i < symbol.length; ++i) {
    if (!isString$1(symbol[i])) {
      isAllString = false;
      break;
    }
  }
  if (isAllString) {
    return normalizeSymbolArray([symbol]);
  }
  var result = [];
  for (var i = 0; i < symbol.length; ++i) {
    if (isString$1(symbol[i])) {
      result.push([symbol[i]]);
    } else {
      result.push(symbol[i]);
    }
  }
  return result;
}
function normalizeDashArrayX(dash) {
  if (!dash || dash.length === 0) {
    return [[0, 0]];
  }
  if (isNumber(dash)) {
    var dashValue = Math.ceil(dash);
    return [[dashValue, dashValue]];
  }
  var isAllNumber = true;
  for (var i = 0; i < dash.length; ++i) {
    if (!isNumber(dash[i])) {
      isAllNumber = false;
      break;
    }
  }
  if (isAllNumber) {
    return normalizeDashArrayX([dash]);
  }
  var result = [];
  for (var i = 0; i < dash.length; ++i) {
    if (isNumber(dash[i])) {
      var dashValue = Math.ceil(dash[i]);
      result.push([dashValue, dashValue]);
    } else {
      var dashValue = map$1(dash[i], function(n2) {
        return Math.ceil(n2);
      });
      if (dashValue.length % 2 === 1) {
        result.push(dashValue.concat(dashValue));
      } else {
        result.push(dashValue);
      }
    }
  }
  return result;
}
function normalizeDashArrayY(dash) {
  if (!dash || typeof dash === "object" && dash.length === 0) {
    return [0, 0];
  }
  if (isNumber(dash)) {
    var dashValue_1 = Math.ceil(dash);
    return [dashValue_1, dashValue_1];
  }
  var dashValue = map$1(dash, function(n2) {
    return Math.ceil(n2);
  });
  return dash.length % 2 ? dashValue.concat(dashValue) : dashValue;
}
function getLineBlockLengthX(dash) {
  return map$1(dash, function(line) {
    return getLineBlockLengthY(line);
  });
}
function getLineBlockLengthY(dash) {
  var blockLength = 0;
  for (var i = 0; i < dash.length; ++i) {
    blockLength += dash[i];
  }
  if (dash.length % 2 === 1) {
    return blockLength * 2;
  }
  return blockLength;
}
function decalVisual(ecModel, api) {
  ecModel.eachRawSeries(function(seriesModel) {
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    if (data.hasItemVisual()) {
      data.each(function(idx) {
        var decal2 = data.getItemVisual(idx, "decal");
        if (decal2) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          itemStyle.decal = createOrUpdatePatternFromDecal(decal2, api);
        }
      });
    }
    var decal = data.getVisual("decal");
    if (decal) {
      var style2 = data.getVisual("style");
      style2.decal = createOrUpdatePatternFromDecal(decal, api);
    }
  });
}
var lifecycle = new Eventful$1();
var lifecycle$1 = lifecycle;
var implsStore = {};
function registerImpl(name, impl) {
  implsStore[name] = impl;
}
function getImpl(name) {
  return implsStore[name];
}
var hasWindow = typeof window !== "undefined";
var TEST_FRAME_REMAIN_TIME = 1;
var PRIORITY_PROCESSOR_SERIES_FILTER = 800;
var PRIORITY_PROCESSOR_DATASTACK = 900;
var PRIORITY_PROCESSOR_FILTER = 1e3;
var PRIORITY_PROCESSOR_DEFAULT = 2e3;
var PRIORITY_PROCESSOR_STATISTIC = 5e3;
var PRIORITY_VISUAL_LAYOUT = 1e3;
var PRIORITY_VISUAL_PROGRESSIVE_LAYOUT = 1100;
var PRIORITY_VISUAL_GLOBAL = 2e3;
var PRIORITY_VISUAL_CHART = 3e3;
var PRIORITY_VISUAL_COMPONENT = 4e3;
var PRIORITY_VISUAL_CHART_DATA_CUSTOM = 4500;
var PRIORITY_VISUAL_POST_CHART_LAYOUT = 4600;
var PRIORITY_VISUAL_BRUSH = 5e3;
var PRIORITY_VISUAL_ARIA = 6e3;
var PRIORITY_VISUAL_DECAL = 7e3;
var PRIORITY = {
  PROCESSOR: {
    FILTER: PRIORITY_PROCESSOR_FILTER,
    SERIES_FILTER: PRIORITY_PROCESSOR_SERIES_FILTER,
    STATISTIC: PRIORITY_PROCESSOR_STATISTIC
  },
  VISUAL: {
    LAYOUT: PRIORITY_VISUAL_LAYOUT,
    PROGRESSIVE_LAYOUT: PRIORITY_VISUAL_PROGRESSIVE_LAYOUT,
    GLOBAL: PRIORITY_VISUAL_GLOBAL,
    CHART: PRIORITY_VISUAL_CHART,
    POST_CHART_LAYOUT: PRIORITY_VISUAL_POST_CHART_LAYOUT,
    COMPONENT: PRIORITY_VISUAL_COMPONENT,
    BRUSH: PRIORITY_VISUAL_BRUSH,
    CHART_ITEM: PRIORITY_VISUAL_CHART_DATA_CUSTOM,
    ARIA: PRIORITY_VISUAL_ARIA,
    DECAL: PRIORITY_VISUAL_DECAL
  }
};
var IN_MAIN_PROCESS_KEY = "__flagInMainProcess";
var PENDING_UPDATE = "__pendingUpdate";
var STATUS_NEEDS_UPDATE_KEY = "__needsUpdateStatus";
var ACTION_REG = /^[a-zA-Z0-9_]+$/;
var CONNECT_STATUS_KEY = "__connectUpdateStatus";
var CONNECT_STATUS_PENDING = 0;
var CONNECT_STATUS_UPDATING = 1;
var CONNECT_STATUS_UPDATED = 2;
function createRegisterEventWithLowercaseECharts(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    if (this.isDisposed()) {
      disposedWarning(this.id);
      return;
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function createRegisterEventWithLowercaseMessageCenter(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function toLowercaseNameAndCallEventful(host, method4, args) {
  args[0] = args[0] && args[0].toLowerCase();
  return Eventful$1.prototype[method4].apply(host, args);
}
var MessageCenter = function(_super) {
  __extends(MessageCenter2, _super);
  function MessageCenter2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return MessageCenter2;
}(Eventful$1);
var messageCenterProto = MessageCenter.prototype;
messageCenterProto.on = createRegisterEventWithLowercaseMessageCenter("on");
messageCenterProto.off = createRegisterEventWithLowercaseMessageCenter("off");
var prepare;
var prepareView;
var updateDirectly;
var updateMethods;
var doConvertPixel;
var updateStreamModes;
var doDispatchAction;
var flushPendingActions;
var triggerUpdatedEvent;
var bindRenderedEvent;
var bindMouseEvent;
var render;
var renderComponents;
var renderSeries;
var createExtensionAPI;
var enableConnect;
var markStatusToUpdate;
var applyChangedStates;
var ECharts = function(_super) {
  __extends(ECharts2, _super);
  function ECharts2(dom, theme2, opts) {
    var _this = _super.call(this, new ECEventProcessor()) || this;
    _this._chartsViews = [];
    _this._chartsMap = {};
    _this._componentsViews = [];
    _this._componentsMap = {};
    _this._pendingActions = [];
    opts = opts || {};
    if (isString$1(theme2)) {
      theme2 = themeStorage[theme2];
    }
    _this._dom = dom;
    var defaultRenderer = "canvas";
    var defaultUseDirtyRect = false;
    var zr = _this._zr = init$2(dom, {
      renderer: opts.renderer || defaultRenderer,
      devicePixelRatio: opts.devicePixelRatio,
      width: opts.width,
      height: opts.height,
      ssr: opts.ssr,
      useDirtyRect: opts.useDirtyRect == null ? defaultUseDirtyRect : opts.useDirtyRect
    });
    _this._ssr = opts.ssr;
    _this._throttledZrFlush = throttle(bind$1(zr.flush, zr), 17);
    theme2 = clone$4(theme2);
    theme2 && globalBackwardCompat(theme2, true);
    _this._theme = theme2;
    _this._locale = createLocaleObject(opts.locale || SYSTEM_LANG);
    _this._coordSysMgr = new CoordinateSystem();
    var api = _this._api = createExtensionAPI(_this);
    function prioritySortFunc(a, b2) {
      return a.__prio - b2.__prio;
    }
    sort$2(visualFuncs, prioritySortFunc);
    sort$2(dataProcessorFuncs, prioritySortFunc);
    _this._scheduler = new Scheduler$1(_this, api, dataProcessorFuncs, visualFuncs);
    _this._messageCenter = new MessageCenter();
    _this._initEvents();
    _this.resize = bind$1(_this.resize, _this);
    zr.animation.on("frame", _this._onframe, _this);
    bindRenderedEvent(zr, _this);
    bindMouseEvent(zr, _this);
    setAsPrimitive(_this);
    return _this;
  }
  ECharts2.prototype._onframe = function() {
    if (this._disposed) {
      return;
    }
    applyChangedStates(this);
    var scheduler2 = this._scheduler;
    if (this[PENDING_UPDATE]) {
      var silent = this[PENDING_UPDATE].silent;
      this[IN_MAIN_PROCESS_KEY] = true;
      try {
        prepare(this);
        updateMethods.update.call(this, null, this[PENDING_UPDATE].updateParams);
      } catch (e2) {
        this[IN_MAIN_PROCESS_KEY] = false;
        this[PENDING_UPDATE] = null;
        throw e2;
      }
      this._zr.flush();
      this[IN_MAIN_PROCESS_KEY] = false;
      this[PENDING_UPDATE] = null;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    } else if (scheduler2.unfinished) {
      var remainTime = TEST_FRAME_REMAIN_TIME;
      var ecModel = this._model;
      var api = this._api;
      scheduler2.unfinished = false;
      do {
        var startTime = +new Date();
        scheduler2.performSeriesTasks(ecModel);
        scheduler2.performDataProcessorTasks(ecModel);
        updateStreamModes(this, ecModel);
        scheduler2.performVisualTasks(ecModel);
        renderSeries(this, this._model, api, "remain", {});
        remainTime -= +new Date() - startTime;
      } while (remainTime > 0 && scheduler2.unfinished);
      if (!scheduler2.unfinished) {
        this._zr.flush();
      }
    }
  };
  ECharts2.prototype.getDom = function() {
    return this._dom;
  };
  ECharts2.prototype.getId = function() {
    return this.id;
  };
  ECharts2.prototype.getZr = function() {
    return this._zr;
  };
  ECharts2.prototype.isSSR = function() {
    return this._ssr;
  };
  ECharts2.prototype.setOption = function(option, notMerge, lazyUpdate) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var silent;
    var replaceMerge;
    var transitionOpt;
    if (isObject$4(notMerge)) {
      lazyUpdate = notMerge.lazyUpdate;
      silent = notMerge.silent;
      replaceMerge = notMerge.replaceMerge;
      transitionOpt = notMerge.transition;
      notMerge = notMerge.notMerge;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    if (!this._model || notMerge) {
      var optionManager = new OptionManager$1(this._api);
      var theme2 = this._theme;
      var ecModel = this._model = new GlobalModel$1();
      ecModel.scheduler = this._scheduler;
      ecModel.ssr = this._ssr;
      ecModel.init(null, null, null, theme2, this._locale, optionManager);
    }
    this._model.setOption(option, {
      replaceMerge
    }, optionPreprocessorFuncs);
    var updateParams = {
      seriesTransition: transitionOpt,
      optionChanged: true
    };
    if (lazyUpdate) {
      this[PENDING_UPDATE] = {
        silent,
        updateParams
      };
      this[IN_MAIN_PROCESS_KEY] = false;
      this.getZr().wakeUp();
    } else {
      try {
        prepare(this);
        updateMethods.update.call(this, null, updateParams);
      } catch (e2) {
        this[PENDING_UPDATE] = null;
        this[IN_MAIN_PROCESS_KEY] = false;
        throw e2;
      }
      if (!this._ssr) {
        this._zr.flush();
      }
      this[PENDING_UPDATE] = null;
      this[IN_MAIN_PROCESS_KEY] = false;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    }
  };
  ECharts2.prototype.setTheme = function() {
  };
  ECharts2.prototype.getModel = function() {
    return this._model;
  };
  ECharts2.prototype.getOption = function() {
    return this._model && this._model.getOption();
  };
  ECharts2.prototype.getWidth = function() {
    return this._zr.getWidth();
  };
  ECharts2.prototype.getHeight = function() {
    return this._zr.getHeight();
  };
  ECharts2.prototype.getDevicePixelRatio = function() {
    return this._zr.painter.dpr || hasWindow && window.devicePixelRatio || 1;
  };
  ECharts2.prototype.getRenderedCanvas = function(opts) {
    return this.renderToCanvas(opts);
  };
  ECharts2.prototype.renderToCanvas = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.getRenderedCanvas({
      backgroundColor: opts.backgroundColor || this._model.get("backgroundColor"),
      pixelRatio: opts.pixelRatio || this.getDevicePixelRatio()
    });
  };
  ECharts2.prototype.renderToSVGString = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.renderToString({
      useViewBox: opts.useViewBox
    });
  };
  ECharts2.prototype.getSvgDataURL = function() {
    if (!env$1.svgSupported) {
      return;
    }
    var zr = this._zr;
    var list = zr.storage.getDisplayList();
    each$g(list, function(el) {
      el.stopAnimation(null, true);
    });
    return zr.painter.toDataURL();
  };
  ECharts2.prototype.getDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    opts = opts || {};
    var excludeComponents = opts.excludeComponents;
    var ecModel = this._model;
    var excludesComponentViews = [];
    var self2 = this;
    each$g(excludeComponents, function(componentType) {
      ecModel.eachComponent({
        mainType: componentType
      }, function(component) {
        var view = self2._componentsMap[component.__viewId];
        if (!view.group.ignore) {
          excludesComponentViews.push(view);
          view.group.ignore = true;
        }
      });
    });
    var url2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(opts).toDataURL("image/" + (opts && opts.type || "png"));
    each$g(excludesComponentViews, function(view) {
      view.group.ignore = false;
    });
    return url2;
  };
  ECharts2.prototype.getConnectedDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var isSvg = opts.type === "svg";
    var groupId = this.group;
    var mathMin2 = Math.min;
    var mathMax2 = Math.max;
    var MAX_NUMBER = Infinity;
    if (connectedGroups[groupId]) {
      var left_1 = MAX_NUMBER;
      var top_1 = MAX_NUMBER;
      var right_1 = -MAX_NUMBER;
      var bottom_1 = -MAX_NUMBER;
      var canvasList_1 = [];
      var dpr_1 = opts && opts.pixelRatio || this.getDevicePixelRatio();
      each$g(instances, function(chart, id2) {
        if (chart.group === groupId) {
          var canvas = isSvg ? chart.getZr().painter.getSvgDom().innerHTML : chart.renderToCanvas(clone$4(opts));
          var boundingRect = chart.getDom().getBoundingClientRect();
          left_1 = mathMin2(boundingRect.left, left_1);
          top_1 = mathMin2(boundingRect.top, top_1);
          right_1 = mathMax2(boundingRect.right, right_1);
          bottom_1 = mathMax2(boundingRect.bottom, bottom_1);
          canvasList_1.push({
            dom: canvas,
            left: boundingRect.left,
            top: boundingRect.top
          });
        }
      });
      left_1 *= dpr_1;
      top_1 *= dpr_1;
      right_1 *= dpr_1;
      bottom_1 *= dpr_1;
      var width = right_1 - left_1;
      var height = bottom_1 - top_1;
      var targetCanvas = platformApi.createCanvas();
      var zr_1 = init$2(targetCanvas, {
        renderer: isSvg ? "svg" : "canvas"
      });
      zr_1.resize({
        width,
        height
      });
      if (isSvg) {
        var content_1 = "";
        each$g(canvasList_1, function(item) {
          var x2 = item.left - left_1;
          var y2 = item.top - top_1;
          content_1 += '<g transform="translate(' + x2 + "," + y2 + ')">' + item.dom + "</g>";
        });
        zr_1.painter.getSvgRoot().innerHTML = content_1;
        if (opts.connectedBackgroundColor) {
          zr_1.painter.setBackgroundColor(opts.connectedBackgroundColor);
        }
        zr_1.refreshImmediately();
        return zr_1.painter.toDataURL();
      } else {
        if (opts.connectedBackgroundColor) {
          zr_1.add(new Rect$3({
            shape: {
              x: 0,
              y: 0,
              width,
              height
            },
            style: {
              fill: opts.connectedBackgroundColor
            }
          }));
        }
        each$g(canvasList_1, function(item) {
          var img = new ZRImage$1({
            style: {
              x: item.left * dpr_1 - left_1,
              y: item.top * dpr_1 - top_1,
              image: item.dom
            }
          });
          zr_1.add(img);
        });
        zr_1.refreshImmediately();
        return targetCanvas.toDataURL("image/" + (opts && opts.type || "png"));
      }
    } else {
      return this.getDataURL(opts);
    }
  };
  ECharts2.prototype.convertToPixel = function(finder, value) {
    return doConvertPixel(this, "convertToPixel", finder, value);
  };
  ECharts2.prototype.convertFromPixel = function(finder, value) {
    return doConvertPixel(this, "convertFromPixel", finder, value);
  };
  ECharts2.prototype.containPixel = function(finder, value) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var ecModel = this._model;
    var result;
    var findResult = parseFinder$1(ecModel, finder);
    each$g(findResult, function(models, key) {
      key.indexOf("Models") >= 0 && each$g(models, function(model) {
        var coordSys = model.coordinateSystem;
        if (coordSys && coordSys.containPoint) {
          result = result || !!coordSys.containPoint(value);
        } else if (key === "seriesModels") {
          var view = this._chartsMap[model.__viewId];
          if (view && view.containPoint) {
            result = result || view.containPoint(value, model);
          }
        } else
          ;
      }, this);
    }, this);
    return !!result;
  };
  ECharts2.prototype.getVisual = function(finder, visualType) {
    var ecModel = this._model;
    var parsedFinder = parseFinder$1(ecModel, finder, {
      defaultMainType: "series"
    });
    var seriesModel = parsedFinder.seriesModel;
    var data = seriesModel.getData();
    var dataIndexInside = parsedFinder.hasOwnProperty("dataIndexInside") ? parsedFinder.dataIndexInside : parsedFinder.hasOwnProperty("dataIndex") ? data.indexOfRawIndex(parsedFinder.dataIndex) : null;
    return dataIndexInside != null ? getItemVisualFromData(data, dataIndexInside, visualType) : getVisualFromData(data, visualType);
  };
  ECharts2.prototype.getViewOfComponentModel = function(componentModel) {
    return this._componentsMap[componentModel.__viewId];
  };
  ECharts2.prototype.getViewOfSeriesModel = function(seriesModel) {
    return this._chartsMap[seriesModel.__viewId];
  };
  ECharts2.prototype._initEvents = function() {
    var _this = this;
    each$g(MOUSE_EVENT_NAMES, function(eveName) {
      var handler = function(e2) {
        var ecModel = _this.getModel();
        var el = e2.target;
        var params;
        var isGlobalOut = eveName === "globalout";
        if (isGlobalOut) {
          params = {};
        } else {
          el && findEventDispatcher(el, function(parent) {
            var ecData = getECData(parent);
            if (ecData && ecData.dataIndex != null) {
              var dataModel = ecData.dataModel || ecModel.getSeriesByIndex(ecData.seriesIndex);
              params = dataModel && dataModel.getDataParams(ecData.dataIndex, ecData.dataType) || {};
              return true;
            } else if (ecData.eventData) {
              params = extend({}, ecData.eventData);
              return true;
            }
          }, true);
        }
        if (params) {
          var componentType = params.componentType;
          var componentIndex = params.componentIndex;
          if (componentType === "markLine" || componentType === "markPoint" || componentType === "markArea") {
            componentType = "series";
            componentIndex = params.seriesIndex;
          }
          var model = componentType && componentIndex != null && ecModel.getComponent(componentType, componentIndex);
          var view = model && _this[model.mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId];
          params.event = e2;
          params.type = eveName;
          _this._$eventProcessor.eventInfo = {
            targetEl: el,
            packedEvent: params,
            model,
            view
          };
          _this.trigger(eveName, params);
        }
      };
      handler.zrEventfulCallAtLast = true;
      _this._zr.on(eveName, handler, _this);
    });
    each$g(eventActionMap, function(actionType, eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    each$g(["selectchanged"], function(eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    handleLegacySelectEvents(this._messageCenter, this, this._api);
  };
  ECharts2.prototype.isDisposed = function() {
    return this._disposed;
  };
  ECharts2.prototype.clear = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this.setOption({
      series: []
    }, true);
  };
  ECharts2.prototype.dispose = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._disposed = true;
    var dom = this.getDom();
    if (dom) {
      setAttribute(this.getDom(), DOM_ATTRIBUTE_KEY, "");
    }
    var chart = this;
    var api = chart._api;
    var ecModel = chart._model;
    each$g(chart._componentsViews, function(component) {
      component.dispose(ecModel, api);
    });
    each$g(chart._chartsViews, function(chart2) {
      chart2.dispose(ecModel, api);
    });
    chart._zr.dispose();
    chart._dom = chart._model = chart._chartsMap = chart._componentsMap = chart._chartsViews = chart._componentsViews = chart._scheduler = chart._api = chart._zr = chart._throttledZrFlush = chart._theme = chart._coordSysMgr = chart._messageCenter = null;
    delete instances[chart.id];
  };
  ECharts2.prototype.resize = function(opts) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._zr.resize(opts);
    var ecModel = this._model;
    this._loadingFX && this._loadingFX.resize();
    if (!ecModel) {
      return;
    }
    var needPrepare = ecModel.resetOption("media");
    var silent = opts && opts.silent;
    if (this[PENDING_UPDATE]) {
      if (silent == null) {
        silent = this[PENDING_UPDATE].silent;
      }
      needPrepare = true;
      this[PENDING_UPDATE] = null;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    try {
      needPrepare && prepare(this);
      updateMethods.update.call(this, {
        type: "resize",
        animation: extend({
          duration: 0
        }, opts && opts.animation)
      });
    } catch (e2) {
      this[IN_MAIN_PROCESS_KEY] = false;
      throw e2;
    }
    this[IN_MAIN_PROCESS_KEY] = false;
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.showLoading = function(name, cfg) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (isObject$4(name)) {
      cfg = name;
      name = "";
    }
    name = name || "default";
    this.hideLoading();
    if (!loadingEffects[name]) {
      return;
    }
    var el = loadingEffects[name](this._api, cfg);
    var zr = this._zr;
    this._loadingFX = el;
    zr.add(el);
  };
  ECharts2.prototype.hideLoading = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._loadingFX && this._zr.remove(this._loadingFX);
    this._loadingFX = null;
  };
  ECharts2.prototype.makeActionFromEvent = function(eventObj) {
    var payload = extend({}, eventObj);
    payload.type = eventActionMap[eventObj.type];
    return payload;
  };
  ECharts2.prototype.dispatchAction = function(payload, opt) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (!isObject$4(opt)) {
      opt = {
        silent: !!opt
      };
    }
    if (!actions[payload.type]) {
      return;
    }
    if (!this._model) {
      return;
    }
    if (this[IN_MAIN_PROCESS_KEY]) {
      this._pendingActions.push(payload);
      return;
    }
    var silent = opt.silent;
    doDispatchAction.call(this, payload, silent);
    var flush = opt.flush;
    if (flush) {
      this._zr.flush();
    } else if (flush !== false && env$1.browser.weChat) {
      this._throttledZrFlush();
    }
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.updateLabelLayout = function() {
    lifecycle$1.trigger("series:layoutlabels", this._model, this._api, {
      updatedSeries: []
    });
  };
  ECharts2.prototype.appendData = function(params) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var seriesIndex = params.seriesIndex;
    var ecModel = this.getModel();
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    seriesModel.appendData(params);
    this._scheduler.unfinished = true;
    this.getZr().wakeUp();
  };
  ECharts2.internalField = function() {
    prepare = function(ecIns) {
      var scheduler2 = ecIns._scheduler;
      scheduler2.restorePipelines(ecIns._model);
      scheduler2.prepareStageTasks();
      prepareView(ecIns, true);
      prepareView(ecIns, false);
      scheduler2.plan();
    };
    prepareView = function(ecIns, isComponent) {
      var ecModel = ecIns._model;
      var scheduler2 = ecIns._scheduler;
      var viewList = isComponent ? ecIns._componentsViews : ecIns._chartsViews;
      var viewMap = isComponent ? ecIns._componentsMap : ecIns._chartsMap;
      var zr = ecIns._zr;
      var api = ecIns._api;
      for (var i = 0; i < viewList.length; i++) {
        viewList[i].__alive = false;
      }
      isComponent ? ecModel.eachComponent(function(componentType, model) {
        componentType !== "series" && doPrepare(model);
      }) : ecModel.eachSeries(doPrepare);
      function doPrepare(model) {
        var requireNewView = model.__requireNewView;
        model.__requireNewView = false;
        var viewId = "_ec_" + model.id + "_" + model.type;
        var view2 = !requireNewView && viewMap[viewId];
        if (!view2) {
          var classType = parseClassType(model.type);
          var Clazz = isComponent ? ComponentView$1.getClass(classType.main, classType.sub) : ChartView$1.getClass(classType.sub);
          view2 = new Clazz();
          view2.init(ecModel, api);
          viewMap[viewId] = view2;
          viewList.push(view2);
          zr.add(view2.group);
        }
        model.__viewId = view2.__id = viewId;
        view2.__alive = true;
        view2.__model = model;
        view2.group.__ecComponentInfo = {
          mainType: model.mainType,
          index: model.componentIndex
        };
        !isComponent && scheduler2.prepareView(view2, model, ecModel, api);
      }
      for (var i = 0; i < viewList.length; ) {
        var view = viewList[i];
        if (!view.__alive) {
          !isComponent && view.renderTask.dispose();
          zr.remove(view.group);
          view.dispose(ecModel, api);
          viewList.splice(i, 1);
          if (viewMap[view.__id] === view) {
            delete viewMap[view.__id];
          }
          view.__id = view.group.__ecComponentInfo = null;
        } else {
          i++;
        }
      }
    };
    updateDirectly = function(ecIns, method4, payload, mainType, subType) {
      var ecModel = ecIns._model;
      ecModel.setUpdatePayload(payload);
      if (!mainType) {
        each$g([].concat(ecIns._componentsViews).concat(ecIns._chartsViews), callView);
        return;
      }
      var query = {};
      query[mainType + "Id"] = payload[mainType + "Id"];
      query[mainType + "Index"] = payload[mainType + "Index"];
      query[mainType + "Name"] = payload[mainType + "Name"];
      var condition = {
        mainType,
        query
      };
      subType && (condition.subType = subType);
      var excludeSeriesId = payload.excludeSeriesId;
      var excludeSeriesIdMap;
      if (excludeSeriesId != null) {
        excludeSeriesIdMap = createHashMap();
        each$g(normalizeToArray(excludeSeriesId), function(id2) {
          var modelId = convertOptionIdName(id2, null);
          if (modelId != null) {
            excludeSeriesIdMap.set(modelId, true);
          }
        });
      }
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        if (isHighDownPayload(payload)) {
          if (model instanceof SeriesModel$1) {
            if (payload.type === HIGHLIGHT_ACTION_TYPE && !payload.notBlur && !model.get(["emphasis", "disabled"])) {
              blurSeriesFromHighlightPayload(model, payload, ecIns._api);
            }
          } else {
            var _a2 = findComponentHighDownDispatchers(model.mainType, model.componentIndex, payload.name, ecIns._api), focusSelf = _a2.focusSelf, dispatchers = _a2.dispatchers;
            if (payload.type === HIGHLIGHT_ACTION_TYPE && focusSelf && !payload.notBlur) {
              blurComponent(model.mainType, model.componentIndex, ecIns._api);
            }
            if (dispatchers) {
              each$g(dispatchers, function(dispatcher) {
                payload.type === HIGHLIGHT_ACTION_TYPE ? enterEmphasis(dispatcher) : leaveEmphasis(dispatcher);
              });
            }
          }
        } else if (isSelectChangePayload(payload)) {
          if (model instanceof SeriesModel$1) {
            toggleSelectionFromPayload(model, payload, ecIns._api);
            updateSeriesElementSelection(model);
            markStatusToUpdate(ecIns);
          }
        }
      }, ecIns);
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        callView(ecIns[mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId]);
      }, ecIns);
      function callView(view) {
        view && view.__alive && view[method4] && view[method4](view.__model, ecModel, ecIns._api, payload);
      }
    };
    updateMethods = {
      prepareAndUpdate: function(payload) {
        prepare(this);
        updateMethods.update.call(this, payload, {
          optionChanged: payload.newOption != null
        });
      },
      update: function(payload, updateParams) {
        var ecModel = this._model;
        var api = this._api;
        var zr = this._zr;
        var coordSysMgr = this._coordSysMgr;
        var scheduler2 = this._scheduler;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        scheduler2.restoreData(ecModel, payload);
        scheduler2.performSeriesTasks(ecModel);
        coordSysMgr.create(ecModel, api);
        scheduler2.performDataProcessorTasks(ecModel, payload);
        updateStreamModes(this, ecModel);
        coordSysMgr.update(ecModel, api);
        clearColorPalette(ecModel);
        scheduler2.performVisualTasks(ecModel, payload);
        render(this, ecModel, api, payload, updateParams);
        var backgroundColor2 = ecModel.get("backgroundColor") || "transparent";
        var darkMode = ecModel.get("darkMode");
        zr.setBackgroundColor(backgroundColor2);
        if (darkMode != null && darkMode !== "auto") {
          zr.setDarkMode(darkMode);
        }
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateTransform: function(payload) {
        var _this = this;
        var ecModel = this._model;
        var api = this._api;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        var componentDirtyList = [];
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType === "series") {
            return;
          }
          var componentView = _this.getViewOfComponentModel(componentModel);
          if (componentView && componentView.__alive) {
            if (componentView.updateTransform) {
              var result = componentView.updateTransform(componentModel, ecModel, api, payload);
              result && result.update && componentDirtyList.push(componentView);
            } else {
              componentDirtyList.push(componentView);
            }
          }
        });
        var seriesDirtyMap = createHashMap();
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          if (chartView.updateTransform) {
            var result = chartView.updateTransform(seriesModel, ecModel, api, payload);
            result && result.update && seriesDirtyMap.set(seriesModel.uid, 1);
          } else {
            seriesDirtyMap.set(seriesModel.uid, 1);
          }
        });
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true,
          dirtyMap: seriesDirtyMap
        });
        renderSeries(this, ecModel, api, payload, {}, seriesDirtyMap);
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateView: function(payload) {
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ChartView$1.markUpdateMethod(payload, "updateView");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true
        });
        render(this, ecModel, this._api, payload, {});
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateVisual: function(payload) {
        var _this = this;
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ecModel.eachSeries(function(seriesModel) {
          seriesModel.getData().clearAllVisual();
        });
        ChartView$1.markUpdateMethod(payload, "updateVisual");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          visualType: "visual",
          setDirty: true
        });
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType !== "series") {
            var componentView = _this.getViewOfComponentModel(componentModel);
            componentView && componentView.__alive && componentView.updateVisual(componentModel, ecModel, _this._api, payload);
          }
        });
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          chartView.updateVisual(seriesModel, ecModel, _this._api, payload);
        });
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateLayout: function(payload) {
        updateMethods.update.call(this, payload);
      }
    };
    doConvertPixel = function(ecIns, methodName, finder, value) {
      if (ecIns._disposed) {
        disposedWarning(ecIns.id);
        return;
      }
      var ecModel = ecIns._model;
      var coordSysList = ecIns._coordSysMgr.getCoordinateSystems();
      var result;
      var parsedFinder = parseFinder$1(ecModel, finder);
      for (var i = 0; i < coordSysList.length; i++) {
        var coordSys = coordSysList[i];
        if (coordSys[methodName] && (result = coordSys[methodName](ecModel, parsedFinder, value)) != null) {
          return result;
        }
      }
    };
    updateStreamModes = function(ecIns, ecModel) {
      var chartsMap = ecIns._chartsMap;
      var scheduler2 = ecIns._scheduler;
      ecModel.eachSeries(function(seriesModel) {
        scheduler2.updateStreamModes(seriesModel, chartsMap[seriesModel.__viewId]);
      });
    };
    doDispatchAction = function(payload, silent) {
      var _this = this;
      var ecModel = this.getModel();
      var payloadType = payload.type;
      var escapeConnect = payload.escapeConnect;
      var actionWrap = actions[payloadType];
      var actionInfo2 = actionWrap.actionInfo;
      var cptTypeTmp = (actionInfo2.update || "update").split(":");
      var updateMethod = cptTypeTmp.pop();
      var cptType = cptTypeTmp[0] != null && parseClassType(cptTypeTmp[0]);
      this[IN_MAIN_PROCESS_KEY] = true;
      var payloads = [payload];
      var batched = false;
      if (payload.batch) {
        batched = true;
        payloads = map$1(payload.batch, function(item) {
          item = defaults(extend({}, item), payload);
          item.batch = null;
          return item;
        });
      }
      var eventObjBatch = [];
      var eventObj;
      var isSelectChange = isSelectChangePayload(payload);
      var isHighDown = isHighDownPayload(payload);
      if (isHighDown) {
        allLeaveBlur(this._api);
      }
      each$g(payloads, function(batchItem) {
        eventObj = actionWrap.action(batchItem, _this._model, _this._api);
        eventObj = eventObj || extend({}, batchItem);
        eventObj.type = actionInfo2.event || eventObj.type;
        eventObjBatch.push(eventObj);
        if (isHighDown) {
          var _a2 = preParseFinder(payload), queryOptionMap = _a2.queryOptionMap, mainTypeSpecified = _a2.mainTypeSpecified;
          var componentMainType = mainTypeSpecified ? queryOptionMap.keys()[0] : "series";
          updateDirectly(_this, updateMethod, batchItem, componentMainType);
          markStatusToUpdate(_this);
        } else if (isSelectChange) {
          updateDirectly(_this, updateMethod, batchItem, "series");
          markStatusToUpdate(_this);
        } else if (cptType) {
          updateDirectly(_this, updateMethod, batchItem, cptType.main, cptType.sub);
        }
      });
      if (updateMethod !== "none" && !isHighDown && !isSelectChange && !cptType) {
        try {
          if (this[PENDING_UPDATE]) {
            prepare(this);
            updateMethods.update.call(this, payload);
            this[PENDING_UPDATE] = null;
          } else {
            updateMethods[updateMethod].call(this, payload);
          }
        } catch (e2) {
          this[IN_MAIN_PROCESS_KEY] = false;
          throw e2;
        }
      }
      if (batched) {
        eventObj = {
          type: actionInfo2.event || payloadType,
          escapeConnect,
          batch: eventObjBatch
        };
      } else {
        eventObj = eventObjBatch[0];
      }
      this[IN_MAIN_PROCESS_KEY] = false;
      if (!silent) {
        var messageCenter = this._messageCenter;
        messageCenter.trigger(eventObj.type, eventObj);
        if (isSelectChange) {
          var newObj = {
            type: "selectchanged",
            escapeConnect,
            selected: getAllSelectedIndices(ecModel),
            isFromClick: payload.isFromClick || false,
            fromAction: payload.type,
            fromActionPayload: payload
          };
          messageCenter.trigger(newObj.type, newObj);
        }
      }
    };
    flushPendingActions = function(silent) {
      var pendingActions = this._pendingActions;
      while (pendingActions.length) {
        var payload = pendingActions.shift();
        doDispatchAction.call(this, payload, silent);
      }
    };
    triggerUpdatedEvent = function(silent) {
      !silent && this.trigger("updated");
    };
    bindRenderedEvent = function(zr, ecIns) {
      zr.on("rendered", function(params) {
        ecIns.trigger("rendered", params);
        if (zr.animation.isFinished() && !ecIns[PENDING_UPDATE] && !ecIns._scheduler.unfinished && !ecIns._pendingActions.length) {
          ecIns.trigger("finished");
        }
      });
    };
    bindMouseEvent = function(zr, ecIns) {
      zr.on("mouseover", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOverForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("mouseout", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOutForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("click", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, function(target) {
          return getECData(target).dataIndex != null;
        }, true);
        if (dispatcher) {
          var actionType = dispatcher.selected ? "unselect" : "select";
          var ecData = getECData(dispatcher);
          ecIns._api.dispatchAction({
            type: actionType,
            dataType: ecData.dataType,
            dataIndexInside: ecData.dataIndex,
            seriesIndex: ecData.seriesIndex,
            isFromClick: true
          });
        }
      });
    };
    function clearColorPalette(ecModel) {
      ecModel.clearColorPalette();
      ecModel.eachSeries(function(seriesModel) {
        seriesModel.clearColorPalette();
      });
    }
    function allocateZlevels(ecModel) {
      var componentZLevels = [];
      var seriesZLevels = [];
      var hasSeperateZLevel = false;
      ecModel.eachComponent(function(componentType, componentModel) {
        var zlevel = componentModel.get("zlevel") || 0;
        var z2 = componentModel.get("z") || 0;
        var zlevelKey = componentModel.getZLevelKey();
        hasSeperateZLevel = hasSeperateZLevel || !!zlevelKey;
        (componentType === "series" ? seriesZLevels : componentZLevels).push({
          zlevel,
          z: z2,
          idx: componentModel.componentIndex,
          type: componentType,
          key: zlevelKey
        });
      });
      if (hasSeperateZLevel) {
        var zLevels = componentZLevels.concat(seriesZLevels);
        var lastSeriesZLevel_1;
        var lastSeriesKey_1;
        sort$2(zLevels, function(a, b2) {
          if (a.zlevel === b2.zlevel) {
            return a.z - b2.z;
          }
          return a.zlevel - b2.zlevel;
        });
        each$g(zLevels, function(item) {
          var componentModel = ecModel.getComponent(item.type, item.idx);
          var zlevel = item.zlevel;
          var key = item.key;
          if (lastSeriesZLevel_1 != null) {
            zlevel = Math.max(lastSeriesZLevel_1, zlevel);
          }
          if (key) {
            if (zlevel === lastSeriesZLevel_1 && key !== lastSeriesKey_1) {
              zlevel++;
            }
            lastSeriesKey_1 = key;
          } else if (lastSeriesKey_1) {
            if (zlevel === lastSeriesZLevel_1) {
              zlevel++;
            }
            lastSeriesKey_1 = "";
          }
          lastSeriesZLevel_1 = zlevel;
          componentModel.setZLevel(zlevel);
        });
      }
    }
    render = function(ecIns, ecModel, api, payload, updateParams) {
      allocateZlevels(ecModel);
      renderComponents(ecIns, ecModel, api, payload, updateParams);
      each$g(ecIns._chartsViews, function(chart) {
        chart.__alive = false;
      });
      renderSeries(ecIns, ecModel, api, payload, updateParams);
      each$g(ecIns._chartsViews, function(chart) {
        if (!chart.__alive) {
          chart.remove(ecModel, api);
        }
      });
    };
    renderComponents = function(ecIns, ecModel, api, payload, updateParams, dirtyList) {
      each$g(dirtyList || ecIns._componentsViews, function(componentView) {
        var componentModel = componentView.__model;
        clearStates(componentModel, componentView);
        componentView.render(componentModel, ecModel, api, payload);
        updateZ2(componentModel, componentView);
        updateStates(componentModel, componentView);
      });
    };
    renderSeries = function(ecIns, ecModel, api, payload, updateParams, dirtyMap) {
      var scheduler2 = ecIns._scheduler;
      updateParams = extend(updateParams || {}, {
        updatedSeries: ecModel.getSeries()
      });
      lifecycle$1.trigger("series:beforeupdate", ecModel, api, updateParams);
      var unfinished = false;
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        chartView.__alive = true;
        var renderTask = chartView.renderTask;
        scheduler2.updatePayload(renderTask, payload);
        clearStates(seriesModel, chartView);
        if (dirtyMap && dirtyMap.get(seriesModel.uid)) {
          renderTask.dirty();
        }
        if (renderTask.perform(scheduler2.getPerformArgs(renderTask))) {
          unfinished = true;
        }
        chartView.group.silent = !!seriesModel.get("silent");
        updateBlend(seriesModel, chartView);
        updateSeriesElementSelection(seriesModel);
      });
      scheduler2.unfinished = unfinished || scheduler2.unfinished;
      lifecycle$1.trigger("series:layoutlabels", ecModel, api, updateParams);
      lifecycle$1.trigger("series:transition", ecModel, api, updateParams);
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        updateZ2(seriesModel, chartView);
        updateStates(seriesModel, chartView);
      });
      updateHoverLayerStatus(ecIns, ecModel);
      lifecycle$1.trigger("series:afterupdate", ecModel, api, updateParams);
    };
    markStatusToUpdate = function(ecIns) {
      ecIns[STATUS_NEEDS_UPDATE_KEY] = true;
      ecIns.getZr().wakeUp();
    };
    applyChangedStates = function(ecIns) {
      if (!ecIns[STATUS_NEEDS_UPDATE_KEY]) {
        return;
      }
      ecIns.getZr().storage.traverse(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        applyElementStates(el);
      });
      ecIns[STATUS_NEEDS_UPDATE_KEY] = false;
    };
    function applyElementStates(el) {
      var newStates = [];
      var oldStates = el.currentStates;
      for (var i = 0; i < oldStates.length; i++) {
        var stateName = oldStates[i];
        if (!(stateName === "emphasis" || stateName === "blur" || stateName === "select")) {
          newStates.push(stateName);
        }
      }
      if (el.selected && el.states.select) {
        newStates.push("select");
      }
      if (el.hoverState === HOVER_STATE_EMPHASIS && el.states.emphasis) {
        newStates.push("emphasis");
      } else if (el.hoverState === HOVER_STATE_BLUR && el.states.blur) {
        newStates.push("blur");
      }
      el.useStates(newStates);
    }
    function updateHoverLayerStatus(ecIns, ecModel) {
      var zr = ecIns._zr;
      var storage2 = zr.storage;
      var elCount = 0;
      storage2.traverse(function(el) {
        if (!el.isGroup) {
          elCount++;
        }
      });
      if (elCount > ecModel.get("hoverLayerThreshold") && !env$1.node && !env$1.worker) {
        ecModel.eachSeries(function(seriesModel) {
          if (seriesModel.preventUsingHoverLayer) {
            return;
          }
          var chartView = ecIns._chartsMap[seriesModel.__viewId];
          if (chartView.__alive) {
            chartView.eachRendered(function(el) {
              if (el.states.emphasis) {
                el.states.emphasis.hoverLayer = true;
              }
            });
          }
        });
      }
    }
    function updateBlend(seriesModel, chartView) {
      var blendMode = seriesModel.get("blendMode") || null;
      chartView.eachRendered(function(el) {
        if (!el.isGroup) {
          el.style.blend = blendMode;
        }
      });
    }
    function updateZ2(model, view) {
      if (model.preventAutoZ) {
        return;
      }
      var z2 = model.get("z") || 0;
      var zlevel = model.get("zlevel") || 0;
      view.eachRendered(function(el) {
        doUpdateZ(el, z2, zlevel, -Infinity);
        return true;
      });
    }
    function doUpdateZ(el, z2, zlevel, maxZ2) {
      var label = el.getTextContent();
      var labelLine = el.getTextGuideLine();
      var isGroup = el.isGroup;
      if (isGroup) {
        var children = el.childrenRef();
        for (var i = 0; i < children.length; i++) {
          maxZ2 = Math.max(doUpdateZ(children[i], z2, zlevel, maxZ2), maxZ2);
        }
      } else {
        el.z = z2;
        el.zlevel = zlevel;
        maxZ2 = Math.max(el.z2, maxZ2);
      }
      if (label) {
        label.z = z2;
        label.zlevel = zlevel;
        isFinite(maxZ2) && (label.z2 = maxZ2 + 2);
      }
      if (labelLine) {
        var textGuideLineConfig = el.textGuideLineConfig;
        labelLine.z = z2;
        labelLine.zlevel = zlevel;
        isFinite(maxZ2) && (labelLine.z2 = maxZ2 + (textGuideLineConfig && textGuideLineConfig.showAbove ? 1 : -1));
      }
      return maxZ2;
    }
    function clearStates(model, view) {
      view.eachRendered(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        var textContent = el.getTextContent();
        var textGuide = el.getTextGuideLine();
        if (el.stateTransition) {
          el.stateTransition = null;
        }
        if (textContent && textContent.stateTransition) {
          textContent.stateTransition = null;
        }
        if (textGuide && textGuide.stateTransition) {
          textGuide.stateTransition = null;
        }
        if (el.hasState()) {
          el.prevStates = el.currentStates;
          el.clearStates();
        } else if (el.prevStates) {
          el.prevStates = null;
        }
      });
    }
    function updateStates(model, view) {
      var stateAnimationModel = model.getModel("stateAnimation");
      var enableAnimation = model.isAnimationEnabled();
      var duration = stateAnimationModel.get("duration");
      var stateTransition = duration > 0 ? {
        duration,
        delay: stateAnimationModel.get("delay"),
        easing: stateAnimationModel.get("easing")
      } : null;
      view.eachRendered(function(el) {
        if (el.states && el.states.emphasis) {
          if (isElementRemoved(el)) {
            return;
          }
          if (el instanceof Path$1) {
            savePathStates(el);
          }
          if (el.__dirty) {
            var prevStates = el.prevStates;
            if (prevStates) {
              el.useStates(prevStates);
            }
          }
          if (enableAnimation) {
            el.stateTransition = stateTransition;
            var textContent = el.getTextContent();
            var textGuide = el.getTextGuideLine();
            if (textContent) {
              textContent.stateTransition = stateTransition;
            }
            if (textGuide) {
              textGuide.stateTransition = stateTransition;
            }
          }
          if (el.__dirty) {
            applyElementStates(el);
          }
        }
      });
    }
    createExtensionAPI = function(ecIns) {
      return new (function(_super2) {
        __extends(class_1, _super2);
        function class_1() {
          return _super2 !== null && _super2.apply(this, arguments) || this;
        }
        class_1.prototype.getCoordinateSystems = function() {
          return ecIns._coordSysMgr.getCoordinateSystems();
        };
        class_1.prototype.getComponentByElement = function(el) {
          while (el) {
            var modelInfo = el.__ecComponentInfo;
            if (modelInfo != null) {
              return ecIns._model.getComponent(modelInfo.mainType, modelInfo.index);
            }
            el = el.parent;
          }
        };
        class_1.prototype.enterEmphasis = function(el, highlightDigit) {
          enterEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveEmphasis = function(el, highlightDigit) {
          leaveEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterBlur = function(el) {
          enterBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveBlur = function(el) {
          leaveBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterSelect = function(el) {
          enterSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveSelect = function(el) {
          leaveSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.getModel = function() {
          return ecIns.getModel();
        };
        class_1.prototype.getViewOfComponentModel = function(componentModel) {
          return ecIns.getViewOfComponentModel(componentModel);
        };
        class_1.prototype.getViewOfSeriesModel = function(seriesModel) {
          return ecIns.getViewOfSeriesModel(seriesModel);
        };
        return class_1;
      }(ExtensionAPI$1))(ecIns);
    };
    enableConnect = function(chart) {
      function updateConnectedChartsStatus(charts, status) {
        for (var i = 0; i < charts.length; i++) {
          var otherChart = charts[i];
          otherChart[CONNECT_STATUS_KEY] = status;
        }
      }
      each$g(eventActionMap, function(actionType, eventType) {
        chart._messageCenter.on(eventType, function(event) {
          if (connectedGroups[chart.group] && chart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_PENDING) {
            if (event && event.escapeConnect) {
              return;
            }
            var action_1 = chart.makeActionFromEvent(event);
            var otherCharts_1 = [];
            each$g(instances, function(otherChart) {
              if (otherChart !== chart && otherChart.group === chart.group) {
                otherCharts_1.push(otherChart);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_PENDING);
            each$g(otherCharts_1, function(otherChart) {
              if (otherChart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_UPDATING) {
                otherChart.dispatchAction(action_1);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_UPDATED);
          }
        });
      });
    };
  }();
  return ECharts2;
}(Eventful$1);
var echartsProto = ECharts.prototype;
echartsProto.on = createRegisterEventWithLowercaseECharts("on");
echartsProto.off = createRegisterEventWithLowercaseECharts("off");
echartsProto.one = function(eventName, cb2, ctx) {
  var self2 = this;
  function wrapped() {
    var args2 = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args2[_i] = arguments[_i];
    }
    cb2 && cb2.apply && cb2.apply(this, args2);
    self2.off(eventName, wrapped);
  }
  this.on.call(this, eventName, wrapped, ctx);
};
var MOUSE_EVENT_NAMES = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
function disposedWarning(id2) {
}
var actions = {};
var eventActionMap = {};
var dataProcessorFuncs = [];
var optionPreprocessorFuncs = [];
var visualFuncs = [];
var themeStorage = {};
var loadingEffects = {};
var instances = {};
var connectedGroups = {};
var idBase = +new Date() - 0;
var DOM_ATTRIBUTE_KEY = "_echarts_instance_";
function init$1(dom, theme2, opts) {
  var isClient = !(opts && opts.ssr);
  if (isClient) {
    var existInstance = getInstanceByDom(dom);
    if (existInstance) {
      return existInstance;
    }
  }
  var chart = new ECharts(dom, theme2, opts);
  chart.id = "ec_" + idBase++;
  instances[chart.id] = chart;
  isClient && setAttribute(dom, DOM_ATTRIBUTE_KEY, chart.id);
  enableConnect(chart);
  lifecycle$1.trigger("afterinit", chart);
  return chart;
}
function getInstanceByDom(dom) {
  return instances[getAttribute(dom, DOM_ATTRIBUTE_KEY)];
}
function registerTheme(name, theme2) {
  themeStorage[name] = theme2;
}
function registerPreprocessor(preprocessorFunc) {
  if (indexOf(optionPreprocessorFuncs, preprocessorFunc) < 0) {
    optionPreprocessorFuncs.push(preprocessorFunc);
  }
}
function registerProcessor(priority, processor) {
  normalizeRegister(dataProcessorFuncs, priority, processor, PRIORITY_PROCESSOR_DEFAULT);
}
function registerPostInit(postInitFunc) {
  registerUpdateLifecycle("afterinit", postInitFunc);
}
function registerPostUpdate(postUpdateFunc) {
  registerUpdateLifecycle("afterupdate", postUpdateFunc);
}
function registerUpdateLifecycle(name, cb2) {
  lifecycle$1.on(name, cb2);
}
function registerAction(actionInfo2, eventName, action) {
  if (isFunction(eventName)) {
    action = eventName;
    eventName = "";
  }
  var actionType = isObject$4(actionInfo2) ? actionInfo2.type : [actionInfo2, actionInfo2 = {
    event: eventName
  }][0];
  actionInfo2.event = (actionInfo2.event || actionType).toLowerCase();
  eventName = actionInfo2.event;
  if (eventActionMap[eventName]) {
    return;
  }
  assert(ACTION_REG.test(actionType) && ACTION_REG.test(eventName));
  if (!actions[actionType]) {
    actions[actionType] = {
      action,
      actionInfo: actionInfo2
    };
  }
  eventActionMap[eventName] = actionType;
}
function registerCoordinateSystem(type4, coordSysCreator) {
  CoordinateSystem.register(type4, coordSysCreator);
}
function registerLayout(priority, layoutTask) {
  normalizeRegister(visualFuncs, priority, layoutTask, PRIORITY_VISUAL_LAYOUT, "layout");
}
function registerVisual(priority, visualTask) {
  normalizeRegister(visualFuncs, priority, visualTask, PRIORITY_VISUAL_CHART, "visual");
}
var registeredTasks = [];
function normalizeRegister(targetList, priority, fn, defaultPriority, visualType) {
  if (isFunction(priority) || isObject$4(priority)) {
    fn = priority;
    priority = defaultPriority;
  }
  if (indexOf(registeredTasks, fn) >= 0) {
    return;
  }
  registeredTasks.push(fn);
  var stageHandler = Scheduler$1.wrapStageHandler(fn, visualType);
  stageHandler.__prio = priority;
  stageHandler.__raw = fn;
  targetList.push(stageHandler);
}
function registerLoading(name, loadingFx) {
  loadingEffects[name] = loadingFx;
}
function registerMap$1(mapName, geoJson, specialAreas) {
  var registerMap2 = getImpl("registerMap");
  registerMap2 && registerMap2(mapName, geoJson, specialAreas);
}
var registerTransform = registerExternalTransform;
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataColorPaletteTask);
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesSymbolTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataSymbolTask);
registerVisual(PRIORITY_VISUAL_DECAL, decalVisual);
registerPreprocessor(globalBackwardCompat);
registerProcessor(PRIORITY_PROCESSOR_DATASTACK, dataStack);
registerLoading("default", defaultLoading);
registerAction({
  type: HIGHLIGHT_ACTION_TYPE,
  event: HIGHLIGHT_ACTION_TYPE,
  update: HIGHLIGHT_ACTION_TYPE
}, noop$1);
registerAction({
  type: DOWNPLAY_ACTION_TYPE,
  event: DOWNPLAY_ACTION_TYPE,
  update: DOWNPLAY_ACTION_TYPE
}, noop$1);
registerAction({
  type: SELECT_ACTION_TYPE,
  event: SELECT_ACTION_TYPE,
  update: SELECT_ACTION_TYPE
}, noop$1);
registerAction({
  type: UNSELECT_ACTION_TYPE,
  event: UNSELECT_ACTION_TYPE,
  update: UNSELECT_ACTION_TYPE
}, noop$1);
registerAction({
  type: TOGGLE_SELECT_ACTION_TYPE,
  event: TOGGLE_SELECT_ACTION_TYPE,
  update: TOGGLE_SELECT_ACTION_TYPE
}, noop$1);
registerTheme("light", lightTheme);
registerTheme("dark", darkTheme);
var extensions = [];
var extensionRegisters = {
  registerPreprocessor,
  registerProcessor,
  registerPostInit,
  registerPostUpdate,
  registerUpdateLifecycle,
  registerAction,
  registerCoordinateSystem,
  registerLayout,
  registerVisual,
  registerTransform,
  registerLoading,
  registerMap: registerMap$1,
  registerImpl,
  PRIORITY,
  ComponentModel: ComponentModel$1,
  ComponentView: ComponentView$1,
  SeriesModel: SeriesModel$1,
  ChartView: ChartView$1,
  registerComponentModel: function(ComponentModelClass) {
    ComponentModel$1.registerClass(ComponentModelClass);
  },
  registerComponentView: function(ComponentViewClass) {
    ComponentView$1.registerClass(ComponentViewClass);
  },
  registerSeriesModel: function(SeriesModelClass) {
    SeriesModel$1.registerClass(SeriesModelClass);
  },
  registerChartView: function(ChartViewClass) {
    ChartView$1.registerClass(ChartViewClass);
  },
  registerSubTypeDefaulter: function(componentType, defaulter) {
    ComponentModel$1.registerSubTypeDefaulter(componentType, defaulter);
  },
  registerPainter: function(painterType, PainterCtor) {
    registerPainter(painterType, PainterCtor);
  }
};
function use(ext) {
  if (isArray$1(ext)) {
    each$g(ext, function(singleExt) {
      use(singleExt);
    });
    return;
  }
  if (indexOf(extensions, ext) >= 0) {
    return;
  }
  extensions.push(ext);
  if (isFunction(ext)) {
    ext = {
      install: ext
    };
  }
  ext.install(extensionRegisters);
}
function dataIndexMapValueLength(valNumOrArrLengthMoreThan2) {
  return valNumOrArrLengthMoreThan2 == null ? 0 : valNumOrArrLengthMoreThan2.length || 1;
}
function defaultKeyGetter(item) {
  return item;
}
var DataDiffer = function() {
  function DataDiffer2(oldArr, newArr, oldKeyGetter, newKeyGetter, context, diffMode) {
    this._old = oldArr;
    this._new = newArr;
    this._oldKeyGetter = oldKeyGetter || defaultKeyGetter;
    this._newKeyGetter = newKeyGetter || defaultKeyGetter;
    this.context = context;
    this._diffModeMultiple = diffMode === "multiple";
  }
  DataDiffer2.prototype.add = function(func) {
    this._add = func;
    return this;
  };
  DataDiffer2.prototype.update = function(func) {
    this._update = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToOne = function(func) {
    this._updateManyToOne = func;
    return this;
  };
  DataDiffer2.prototype.updateOneToMany = function(func) {
    this._updateOneToMany = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToMany = function(func) {
    this._updateManyToMany = func;
    return this;
  };
  DataDiffer2.prototype.remove = function(func) {
    this._remove = func;
    return this;
  };
  DataDiffer2.prototype.execute = function() {
    this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
  };
  DataDiffer2.prototype._executeOneToOne = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var newDataIndexMap = {};
    var oldDataKeyArr = new Array(oldArr.length);
    var newDataKeyArr = new Array(newArr.length);
    this._initIndexMap(oldArr, null, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (newIdxMapValLen > 1) {
        var newIdx = newIdxMapVal.shift();
        if (newIdxMapVal.length === 1) {
          newDataIndexMap[oldKey] = newIdxMapVal[0];
        }
        this._update && this._update(newIdx, i);
      } else if (newIdxMapValLen === 1) {
        newDataIndexMap[oldKey] = null;
        this._update && this._update(newIdxMapVal, i);
      } else {
        this._remove && this._remove(i);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._executeMultiple = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var oldDataIndexMap = {};
    var newDataIndexMap = {};
    var oldDataKeyArr = [];
    var newDataKeyArr = [];
    this._initIndexMap(oldArr, oldDataIndexMap, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldDataKeyArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var oldIdxMapVal = oldDataIndexMap[oldKey];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var oldIdxMapValLen = dataIndexMapValueLength(oldIdxMapVal);
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (oldIdxMapValLen > 1 && newIdxMapValLen === 1) {
        this._updateManyToOne && this._updateManyToOne(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen > 1) {
        this._updateOneToMany && this._updateOneToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen === 1) {
        this._update && this._update(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1 && newIdxMapValLen > 1) {
        this._updateManyToMany && this._updateManyToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1) {
        for (var i_1 = 0; i_1 < oldIdxMapValLen; i_1++) {
          this._remove && this._remove(oldIdxMapVal[i_1]);
        }
      } else {
        this._remove && this._remove(oldIdxMapVal);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._performRestAdd = function(newDataKeyArr, newDataIndexMap) {
    for (var i = 0; i < newDataKeyArr.length; i++) {
      var newKey = newDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[newKey];
      var idxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (idxMapValLen > 1) {
        for (var j = 0; j < idxMapValLen; j++) {
          this._add && this._add(newIdxMapVal[j]);
        }
      } else if (idxMapValLen === 1) {
        this._add && this._add(newIdxMapVal);
      }
      newDataIndexMap[newKey] = null;
    }
  };
  DataDiffer2.prototype._initIndexMap = function(arr, map2, keyArr, keyGetterName) {
    var cbModeMultiple = this._diffModeMultiple;
    for (var i = 0; i < arr.length; i++) {
      var key = "_ec_" + this[keyGetterName](arr[i], i);
      if (!cbModeMultiple) {
        keyArr[i] = key;
      }
      if (!map2) {
        continue;
      }
      var idxMapVal = map2[key];
      var idxMapValLen = dataIndexMapValueLength(idxMapVal);
      if (idxMapValLen === 0) {
        map2[key] = i;
        if (cbModeMultiple) {
          keyArr.push(key);
        }
      } else if (idxMapValLen === 1) {
        map2[key] = [idxMapVal, i];
      } else {
        idxMapVal.push(i);
      }
    }
  };
  return DataDiffer2;
}();
var DataDiffer$1 = DataDiffer;
var DimensionUserOuput = function() {
  function DimensionUserOuput2(encode, dimRequest) {
    this._encode = encode;
    this._schema = dimRequest;
  }
  DimensionUserOuput2.prototype.get = function() {
    return {
      fullDimensions: this._getFullDimensionNames(),
      encode: this._encode
    };
  };
  DimensionUserOuput2.prototype._getFullDimensionNames = function() {
    if (!this._cachedDimNames) {
      this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : [];
    }
    return this._cachedDimNames;
  };
  return DimensionUserOuput2;
}();
function summarizeDimensions(data, schema) {
  var summary = {};
  var encode = summary.encode = {};
  var notExtraCoordDimMap = createHashMap();
  var defaultedLabel = [];
  var defaultedTooltip = [];
  var userOutputEncode = {};
  each$g(data.dimensions, function(dimName) {
    var dimItem = data.getDimensionInfo(dimName);
    var coordDim = dimItem.coordDim;
    if (coordDim) {
      var coordDimIndex = dimItem.coordDimIndex;
      getOrCreateEncodeArr(encode, coordDim)[coordDimIndex] = dimName;
      if (!dimItem.isExtraCoord) {
        notExtraCoordDimMap.set(coordDim, 1);
        if (mayLabelDimType(dimItem.type)) {
          defaultedLabel[0] = dimName;
        }
        getOrCreateEncodeArr(userOutputEncode, coordDim)[coordDimIndex] = data.getDimensionIndex(dimItem.name);
      }
      if (dimItem.defaultTooltip) {
        defaultedTooltip.push(dimName);
      }
    }
    VISUAL_DIMENSIONS.each(function(v4, otherDim) {
      var encodeArr = getOrCreateEncodeArr(encode, otherDim);
      var dimIndex = dimItem.otherDims[otherDim];
      if (dimIndex != null && dimIndex !== false) {
        encodeArr[dimIndex] = dimItem.name;
      }
    });
  });
  var dataDimsOnCoord = [];
  var encodeFirstDimNotExtra = {};
  notExtraCoordDimMap.each(function(v4, coordDim) {
    var dimArr = encode[coordDim];
    encodeFirstDimNotExtra[coordDim] = dimArr[0];
    dataDimsOnCoord = dataDimsOnCoord.concat(dimArr);
  });
  summary.dataDimsOnCoord = dataDimsOnCoord;
  summary.dataDimIndicesOnCoord = map$1(dataDimsOnCoord, function(dimName) {
    return data.getDimensionInfo(dimName).storeDimIndex;
  });
  summary.encodeFirstDimNotExtra = encodeFirstDimNotExtra;
  var encodeLabel = encode.label;
  if (encodeLabel && encodeLabel.length) {
    defaultedLabel = encodeLabel.slice();
  }
  var encodeTooltip = encode.tooltip;
  if (encodeTooltip && encodeTooltip.length) {
    defaultedTooltip = encodeTooltip.slice();
  } else if (!defaultedTooltip.length) {
    defaultedTooltip = defaultedLabel.slice();
  }
  encode.defaultedLabel = defaultedLabel;
  encode.defaultedTooltip = defaultedTooltip;
  summary.userOutput = new DimensionUserOuput(userOutputEncode, schema);
  return summary;
}
function getOrCreateEncodeArr(encode, dim) {
  if (!encode.hasOwnProperty(dim)) {
    encode[dim] = [];
  }
  return encode[dim];
}
function getDimensionTypeByAxis(axisType) {
  return axisType === "category" ? "ordinal" : axisType === "time" ? "time" : "float";
}
function mayLabelDimType(dimType) {
  return !(dimType === "ordinal" || dimType === "time");
}
var SeriesDimensionDefine = function() {
  function SeriesDimensionDefine2(opt) {
    this.otherDims = {};
    if (opt != null) {
      extend(this, opt);
    }
  }
  return SeriesDimensionDefine2;
}();
var SeriesDimensionDefine$1 = SeriesDimensionDefine;
var inner$h = makeInner();
var dimTypeShort = {
  float: "f",
  int: "i",
  ordinal: "o",
  number: "n",
  time: "t"
};
var SeriesDataSchema = function() {
  function SeriesDataSchema2(opt) {
    this.dimensions = opt.dimensions;
    this._dimOmitted = opt.dimensionOmitted;
    this.source = opt.source;
    this._fullDimCount = opt.fullDimensionCount;
    this._updateDimOmitted(opt.dimensionOmitted);
  }
  SeriesDataSchema2.prototype.isDimensionOmitted = function() {
    return this._dimOmitted;
  };
  SeriesDataSchema2.prototype._updateDimOmitted = function(dimensionOmitted) {
    this._dimOmitted = dimensionOmitted;
    if (!dimensionOmitted) {
      return;
    }
    if (!this._dimNameMap) {
      this._dimNameMap = ensureSourceDimNameMap(this.source);
    }
  };
  SeriesDataSchema2.prototype.getSourceDimensionIndex = function(dimName) {
    return retrieve2(this._dimNameMap.get(dimName), -1);
  };
  SeriesDataSchema2.prototype.getSourceDimension = function(dimIndex) {
    var dimensionsDefine = this.source.dimensionsDefine;
    if (dimensionsDefine) {
      return dimensionsDefine[dimIndex];
    }
  };
  SeriesDataSchema2.prototype.makeStoreSchema = function() {
    var dimCount = this._fullDimCount;
    var willRetrieveDataByName = shouldRetrieveDataByName(this.source);
    var makeHashStrict = !shouldOmitUnusedDimensions(dimCount);
    var dimHash = "";
    var dims = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < dimCount; fullDimIdx++) {
      var property = void 0;
      var type4 = void 0;
      var ordinalMeta = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        property = willRetrieveDataByName ? seriesDimDef.name : null;
        type4 = seriesDimDef.type;
        ordinalMeta = seriesDimDef.ordinalMeta;
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          property = willRetrieveDataByName ? sourceDimDef.name : null;
          type4 = sourceDimDef.type;
        }
      }
      dims.push({
        property,
        type: type4,
        ordinalMeta
      });
      if (willRetrieveDataByName && property != null && (!seriesDimDef || !seriesDimDef.isCalculationCoord)) {
        dimHash += makeHashStrict ? property.replace(/\`/g, "`1").replace(/\$/g, "`2") : property;
      }
      dimHash += "$";
      dimHash += dimTypeShort[type4] || "f";
      if (ordinalMeta) {
        dimHash += ordinalMeta.uid;
      }
      dimHash += "$";
    }
    var source = this.source;
    var hash = [source.seriesLayoutBy, source.startIndex, dimHash].join("$$");
    return {
      dimensions: dims,
      hash
    };
  };
  SeriesDataSchema2.prototype.makeOutputDimensionNames = function() {
    var result = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < this._fullDimCount; fullDimIdx++) {
      var name_1 = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        if (!seriesDimDef.isCalculationCoord) {
          name_1 = seriesDimDef.name;
        }
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          name_1 = sourceDimDef.name;
        }
      }
      result.push(name_1);
    }
    return result;
  };
  SeriesDataSchema2.prototype.appendCalculationDimension = function(dimDef) {
    this.dimensions.push(dimDef);
    dimDef.isCalculationCoord = true;
    this._fullDimCount++;
    this._updateDimOmitted(true);
  };
  return SeriesDataSchema2;
}();
function isSeriesDataSchema(schema) {
  return schema instanceof SeriesDataSchema;
}
function createDimNameMap(dimsDef) {
  var dataDimNameMap = createHashMap();
  for (var i = 0; i < (dimsDef || []).length; i++) {
    var dimDefItemRaw = dimsDef[i];
    var userDimName = isObject$4(dimDefItemRaw) ? dimDefItemRaw.name : dimDefItemRaw;
    if (userDimName != null && dataDimNameMap.get(userDimName) == null) {
      dataDimNameMap.set(userDimName, i);
    }
  }
  return dataDimNameMap;
}
function ensureSourceDimNameMap(source) {
  var innerSource = inner$h(source);
  return innerSource.dimNameMap || (innerSource.dimNameMap = createDimNameMap(source.dimensionsDefine));
}
function shouldOmitUnusedDimensions(dimCount) {
  return dimCount > 30;
}
var isObject$2 = isObject$4;
var map = map$1;
var CtorInt32Array = typeof Int32Array === "undefined" ? Array : Int32Array;
var ID_PREFIX = "e\0\0";
var INDEX_NOT_FOUND = -1;
var TRANSFERABLE_PROPERTIES = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"];
var CLONE_PROPERTIES = ["_approximateExtent"];
var prepareInvertedIndex;
var getId;
var getIdNameFromStore;
var normalizeDimensions;
var transferProperties;
var cloneListForMapAndSample;
var makeIdFromName;
var SeriesData = function() {
  function SeriesData2(dimensionsInput, hostModel) {
    this.type = "list";
    this._dimOmitted = false;
    this._nameList = [];
    this._idList = [];
    this._visual = {};
    this._layout = {};
    this._itemVisuals = [];
    this._itemLayouts = [];
    this._graphicEls = [];
    this._approximateExtent = {};
    this._calculationInfo = {};
    this.hasItemOption = false;
    this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"];
    this.CHANGABLE_METHODS = ["filterSelf", "selectRange"];
    this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
    var dimensions;
    var assignStoreDimIdx = false;
    if (isSeriesDataSchema(dimensionsInput)) {
      dimensions = dimensionsInput.dimensions;
      this._dimOmitted = dimensionsInput.isDimensionOmitted();
      this._schema = dimensionsInput;
    } else {
      assignStoreDimIdx = true;
      dimensions = dimensionsInput;
    }
    dimensions = dimensions || ["x", "y"];
    var dimensionInfos = {};
    var dimensionNames = [];
    var invertedIndicesMap = {};
    var needsHasOwn = false;
    var emptyObj = {};
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfoInput = dimensions[i];
      var dimensionInfo = isString$1(dimInfoInput) ? new SeriesDimensionDefine$1({
        name: dimInfoInput
      }) : !(dimInfoInput instanceof SeriesDimensionDefine$1) ? new SeriesDimensionDefine$1(dimInfoInput) : dimInfoInput;
      var dimensionName = dimensionInfo.name;
      dimensionInfo.type = dimensionInfo.type || "float";
      if (!dimensionInfo.coordDim) {
        dimensionInfo.coordDim = dimensionName;
        dimensionInfo.coordDimIndex = 0;
      }
      var otherDims = dimensionInfo.otherDims = dimensionInfo.otherDims || {};
      dimensionNames.push(dimensionName);
      dimensionInfos[dimensionName] = dimensionInfo;
      if (emptyObj[dimensionName] != null) {
        needsHasOwn = true;
      }
      if (dimensionInfo.createInvertedIndices) {
        invertedIndicesMap[dimensionName] = [];
      }
      if (otherDims.itemName === 0) {
        this._nameDimIdx = i;
      }
      if (otherDims.itemId === 0) {
        this._idDimIdx = i;
      }
      if (assignStoreDimIdx) {
        dimensionInfo.storeDimIndex = i;
      }
    }
    this.dimensions = dimensionNames;
    this._dimInfos = dimensionInfos;
    this._initGetDimensionInfo(needsHasOwn);
    this.hostModel = hostModel;
    this._invertedIndicesMap = invertedIndicesMap;
    if (this._dimOmitted) {
      var dimIdxToName_1 = this._dimIdxToName = createHashMap();
      each$g(dimensionNames, function(dimName) {
        dimIdxToName_1.set(dimensionInfos[dimName].storeDimIndex, dimName);
      });
    }
  }
  SeriesData2.prototype.getDimension = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx == null) {
      return dim;
    }
    dimIdx = dim;
    if (!this._dimOmitted) {
      return this.dimensions[dimIdx];
    }
    var dimName = this._dimIdxToName.get(dimIdx);
    if (dimName != null) {
      return dimName;
    }
    var sourceDimDef = this._schema.getSourceDimension(dimIdx);
    if (sourceDimDef) {
      return sourceDimDef.name;
    }
  };
  SeriesData2.prototype.getDimensionIndex = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx != null) {
      return dimIdx;
    }
    if (dim == null) {
      return -1;
    }
    var dimInfo = this._getDimInfo(dim);
    return dimInfo ? dimInfo.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(dim) : -1;
  };
  SeriesData2.prototype._recognizeDimIndex = function(dim) {
    if (isNumber(dim) || dim != null && !isNaN(dim) && !this._getDimInfo(dim) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(dim) < 0)) {
      return +dim;
    }
  };
  SeriesData2.prototype._getStoreDimIndex = function(dim) {
    var dimIdx = this.getDimensionIndex(dim);
    return dimIdx;
  };
  SeriesData2.prototype.getDimensionInfo = function(dim) {
    return this._getDimInfo(this.getDimension(dim));
  };
  SeriesData2.prototype._initGetDimensionInfo = function(needsHasOwn) {
    var dimensionInfos = this._dimInfos;
    this._getDimInfo = needsHasOwn ? function(dimName) {
      return dimensionInfos.hasOwnProperty(dimName) ? dimensionInfos[dimName] : void 0;
    } : function(dimName) {
      return dimensionInfos[dimName];
    };
  };
  SeriesData2.prototype.getDimensionsOnCoord = function() {
    return this._dimSummary.dataDimsOnCoord.slice();
  };
  SeriesData2.prototype.mapDimension = function(coordDim, idx) {
    var dimensionsSummary = this._dimSummary;
    if (idx == null) {
      return dimensionsSummary.encodeFirstDimNotExtra[coordDim];
    }
    var dims = dimensionsSummary.encode[coordDim];
    return dims ? dims[idx] : null;
  };
  SeriesData2.prototype.mapDimensionsAll = function(coordDim) {
    var dimensionsSummary = this._dimSummary;
    var dims = dimensionsSummary.encode[coordDim];
    return (dims || []).slice();
  };
  SeriesData2.prototype.getStore = function() {
    return this._store;
  };
  SeriesData2.prototype.initData = function(data, nameList, dimValueGetter) {
    var _this = this;
    var store;
    if (data instanceof DataStore) {
      store = data;
    }
    if (!store) {
      var dimensions = this.dimensions;
      var provider = isSourceInstance(data) || isArrayLike(data) ? new DefaultDataProvider(data, dimensions.length) : data;
      store = new DataStore();
      var dimensionInfos = map(dimensions, function(dimName) {
        return {
          type: _this._dimInfos[dimName].type,
          property: dimName
        };
      });
      store.initData(provider, dimensionInfos, dimValueGetter);
    }
    this._store = store;
    this._nameList = (nameList || []).slice();
    this._idList = [];
    this._nameRepeatCount = {};
    this._doInit(0, store.count());
    this._dimSummary = summarizeDimensions(this, this._schema);
    this.userOutput = this._dimSummary.userOutput;
  };
  SeriesData2.prototype.appendData = function(data) {
    var range3 = this._store.appendData(data);
    this._doInit(range3[0], range3[1]);
  };
  SeriesData2.prototype.appendValues = function(values, names2) {
    var _a2 = this._store.appendValues(values, names2.length), start2 = _a2.start, end2 = _a2.end;
    var shouldMakeIdFromName = this._shouldMakeIdFromName();
    this._updateOrdinalMeta();
    if (names2) {
      for (var idx = start2; idx < end2; idx++) {
        var sourceIdx = idx - start2;
        this._nameList[idx] = names2[sourceIdx];
        if (shouldMakeIdFromName) {
          makeIdFromName(this, idx);
        }
      }
    }
  };
  SeriesData2.prototype._updateOrdinalMeta = function() {
    var store = this._store;
    var dimensions = this.dimensions;
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfo = this._dimInfos[dimensions[i]];
      if (dimInfo.ordinalMeta) {
        store.collectOrdinalMeta(dimInfo.storeDimIndex, dimInfo.ordinalMeta);
      }
    }
  };
  SeriesData2.prototype._shouldMakeIdFromName = function() {
    var provider = this._store.getProvider();
    return this._idDimIdx == null && provider.getSource().sourceFormat !== SOURCE_FORMAT_TYPED_ARRAY && !provider.fillStorage;
  };
  SeriesData2.prototype._doInit = function(start2, end2) {
    if (start2 >= end2) {
      return;
    }
    var store = this._store;
    var provider = store.getProvider();
    this._updateOrdinalMeta();
    var nameList = this._nameList;
    var idList = this._idList;
    var sourceFormat = provider.getSource().sourceFormat;
    var isFormatOriginal = sourceFormat === SOURCE_FORMAT_ORIGINAL;
    if (isFormatOriginal && !provider.pure) {
      var sharedDataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        var dataItem = provider.getItem(idx, sharedDataItem);
        if (!this.hasItemOption && isDataItemOption(dataItem)) {
          this.hasItemOption = true;
        }
        if (dataItem) {
          var itemName = dataItem.name;
          if (nameList[idx] == null && itemName != null) {
            nameList[idx] = convertOptionIdName(itemName, null);
          }
          var itemId = dataItem.id;
          if (idList[idx] == null && itemId != null) {
            idList[idx] = convertOptionIdName(itemId, null);
          }
        }
      }
    }
    if (this._shouldMakeIdFromName()) {
      for (var idx = start2; idx < end2; idx++) {
        makeIdFromName(this, idx);
      }
    }
    prepareInvertedIndex(this);
  };
  SeriesData2.prototype.getApproximateExtent = function(dim) {
    return this._approximateExtent[dim] || this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.setApproximateExtent = function(extent3, dim) {
    dim = this.getDimension(dim);
    this._approximateExtent[dim] = extent3.slice();
  };
  SeriesData2.prototype.getCalculationInfo = function(key) {
    return this._calculationInfo[key];
  };
  SeriesData2.prototype.setCalculationInfo = function(key, value) {
    isObject$2(key) ? extend(this._calculationInfo, key) : this._calculationInfo[key] = value;
  };
  SeriesData2.prototype.getName = function(idx) {
    var rawIndex = this.getRawIndex(idx);
    var name = this._nameList[rawIndex];
    if (name == null && this._nameDimIdx != null) {
      name = getIdNameFromStore(this, this._nameDimIdx, rawIndex);
    }
    if (name == null) {
      name = "";
    }
    return name;
  };
  SeriesData2.prototype._getCategory = function(dimIdx, idx) {
    var ordinal = this._store.get(dimIdx, idx);
    var ordinalMeta = this._store.getOrdinalMeta(dimIdx);
    if (ordinalMeta) {
      return ordinalMeta.categories[ordinal];
    }
    return ordinal;
  };
  SeriesData2.prototype.getId = function(idx) {
    return getId(this, this.getRawIndex(idx));
  };
  SeriesData2.prototype.count = function() {
    return this._store.count();
  };
  SeriesData2.prototype.get = function(dim, idx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.get(dimInfo.storeDimIndex, idx);
    }
  };
  SeriesData2.prototype.getByRawIndex = function(dim, rawIdx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.getByRawIndex(dimInfo.storeDimIndex, rawIdx);
    }
  };
  SeriesData2.prototype.getIndices = function() {
    return this._store.getIndices();
  };
  SeriesData2.prototype.getDataExtent = function(dim) {
    return this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getSum = function(dim) {
    return this._store.getSum(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getMedian = function(dim) {
    return this._store.getMedian(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getValues = function(dimensions, idx) {
    var _this = this;
    var store = this._store;
    return isArray$1(dimensions) ? store.getValues(map(dimensions, function(dim) {
      return _this._getStoreDimIndex(dim);
    }), idx) : store.getValues(dimensions);
  };
  SeriesData2.prototype.hasValue = function(idx) {
    var dataDimIndicesOnCoord = this._dimSummary.dataDimIndicesOnCoord;
    for (var i = 0, len2 = dataDimIndicesOnCoord.length; i < len2; i++) {
      if (isNaN(this._store.get(dataDimIndicesOnCoord[i], idx))) {
        return false;
      }
    }
    return true;
  };
  SeriesData2.prototype.indexOfName = function(name) {
    for (var i = 0, len2 = this._store.count(); i < len2; i++) {
      if (this.getName(i) === name) {
        return i;
      }
    }
    return -1;
  };
  SeriesData2.prototype.getRawIndex = function(idx) {
    return this._store.getRawIndex(idx);
  };
  SeriesData2.prototype.indexOfRawIndex = function(rawIndex) {
    return this._store.indexOfRawIndex(rawIndex);
  };
  SeriesData2.prototype.rawIndexOf = function(dim, value) {
    var invertedIndices = dim && this._invertedIndicesMap[dim];
    var rawIndex = invertedIndices[value];
    if (rawIndex == null || isNaN(rawIndex)) {
      return INDEX_NOT_FOUND;
    }
    return rawIndex;
  };
  SeriesData2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    return this._store.indicesOfNearest(this._getStoreDimIndex(dim), value, maxDistance);
  };
  SeriesData2.prototype.each = function(dims, cb2, ctx) {
    if (isFunction(dims)) {
      ctx = cb2;
      cb2 = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.each(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
  };
  SeriesData2.prototype.filterSelf = function(dims, cb2, ctx) {
    if (isFunction(dims)) {
      ctx = cb2;
      cb2 = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store = this._store.filter(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
    return this;
  };
  SeriesData2.prototype.selectRange = function(range3) {
    var _this = this;
    var innerRange = {};
    var dims = keys(range3);
    each$g(dims, function(dim) {
      var dimIdx = _this._getStoreDimIndex(dim);
      innerRange[dimIdx] = range3[dim];
    });
    this._store = this._store.selectRange(innerRange);
    return this;
  };
  SeriesData2.prototype.mapArray = function(dims, cb2, ctx) {
    if (isFunction(dims)) {
      ctx = cb2;
      cb2 = dims;
      dims = [];
    }
    ctx = ctx || this;
    var result = [];
    this.each(dims, function() {
      result.push(cb2 && cb2.apply(this, arguments));
    }, ctx);
    return result;
  };
  SeriesData2.prototype.map = function(dims, cb2, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    var list = cloneListForMapAndSample(this);
    list._store = this._store.map(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
    return list;
  };
  SeriesData2.prototype.modify = function(dims, cb2, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.modify(dimIndices, fCtx ? bind$1(cb2, fCtx) : cb2);
  };
  SeriesData2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.downSample(this._getStoreDimIndex(dimension), rate, sampleValue, sampleIndex);
    return list;
  };
  SeriesData2.prototype.lttbDownSample = function(valueDimension, rate) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.lttbDownSample(this._getStoreDimIndex(valueDimension), rate);
    return list;
  };
  SeriesData2.prototype.getRawDataItem = function(idx) {
    return this._store.getRawDataItem(idx);
  };
  SeriesData2.prototype.getItemModel = function(idx) {
    var hostModel = this.hostModel;
    var dataItem = this.getRawDataItem(idx);
    return new Model$1(dataItem, hostModel, hostModel && hostModel.ecModel);
  };
  SeriesData2.prototype.diff = function(otherList) {
    var thisList = this;
    return new DataDiffer$1(otherList ? otherList.getStore().getIndices() : [], this.getStore().getIndices(), function(idx) {
      return getId(otherList, idx);
    }, function(idx) {
      return getId(thisList, idx);
    });
  };
  SeriesData2.prototype.getVisual = function(key) {
    var visual = this._visual;
    return visual && visual[key];
  };
  SeriesData2.prototype.setVisual = function(kvObj, val) {
    this._visual = this._visual || {};
    if (isObject$2(kvObj)) {
      extend(this._visual, kvObj);
    } else {
      this._visual[kvObj] = val;
    }
  };
  SeriesData2.prototype.getItemVisual = function(idx, key) {
    var itemVisual = this._itemVisuals[idx];
    var val = itemVisual && itemVisual[key];
    if (val == null) {
      return this.getVisual(key);
    }
    return val;
  };
  SeriesData2.prototype.hasItemVisual = function() {
    return this._itemVisuals.length > 0;
  };
  SeriesData2.prototype.ensureUniqueItemVisual = function(idx, key) {
    var itemVisuals = this._itemVisuals;
    var itemVisual = itemVisuals[idx];
    if (!itemVisual) {
      itemVisual = itemVisuals[idx] = {};
    }
    var val = itemVisual[key];
    if (val == null) {
      val = this.getVisual(key);
      if (isArray$1(val)) {
        val = val.slice();
      } else if (isObject$2(val)) {
        val = extend({}, val);
      }
      itemVisual[key] = val;
    }
    return val;
  };
  SeriesData2.prototype.setItemVisual = function(idx, key, value) {
    var itemVisual = this._itemVisuals[idx] || {};
    this._itemVisuals[idx] = itemVisual;
    if (isObject$2(key)) {
      extend(itemVisual, key);
    } else {
      itemVisual[key] = value;
    }
  };
  SeriesData2.prototype.clearAllVisual = function() {
    this._visual = {};
    this._itemVisuals = [];
  };
  SeriesData2.prototype.setLayout = function(key, val) {
    isObject$2(key) ? extend(this._layout, key) : this._layout[key] = val;
  };
  SeriesData2.prototype.getLayout = function(key) {
    return this._layout[key];
  };
  SeriesData2.prototype.getItemLayout = function(idx) {
    return this._itemLayouts[idx];
  };
  SeriesData2.prototype.setItemLayout = function(idx, layout2, merge3) {
    this._itemLayouts[idx] = merge3 ? extend(this._itemLayouts[idx] || {}, layout2) : layout2;
  };
  SeriesData2.prototype.clearItemLayouts = function() {
    this._itemLayouts.length = 0;
  };
  SeriesData2.prototype.setItemGraphicEl = function(idx, el) {
    var seriesIndex = this.hostModel && this.hostModel.seriesIndex;
    setCommonECData(seriesIndex, this.dataType, idx, el);
    this._graphicEls[idx] = el;
  };
  SeriesData2.prototype.getItemGraphicEl = function(idx) {
    return this._graphicEls[idx];
  };
  SeriesData2.prototype.eachItemGraphicEl = function(cb2, context) {
    each$g(this._graphicEls, function(el, idx) {
      if (el) {
        cb2 && cb2.call(context, el, idx);
      }
    });
  };
  SeriesData2.prototype.cloneShallow = function(list) {
    if (!list) {
      list = new SeriesData2(this._schema ? this._schema : map(this.dimensions, this._getDimInfo, this), this.hostModel);
    }
    transferProperties(list, this);
    list._store = this._store;
    return list;
  };
  SeriesData2.prototype.wrapMethod = function(methodName, injectFunction) {
    var originalMethod = this[methodName];
    if (!isFunction(originalMethod)) {
      return;
    }
    this.__wrappedMethods = this.__wrappedMethods || [];
    this.__wrappedMethods.push(methodName);
    this[methodName] = function() {
      var res = originalMethod.apply(this, arguments);
      return injectFunction.apply(this, [res].concat(slice(arguments)));
    };
  };
  SeriesData2.internalField = function() {
    prepareInvertedIndex = function(data) {
      var invertedIndicesMap = data._invertedIndicesMap;
      each$g(invertedIndicesMap, function(invertedIndices, dim) {
        var dimInfo = data._dimInfos[dim];
        var ordinalMeta = dimInfo.ordinalMeta;
        var store = data._store;
        if (ordinalMeta) {
          invertedIndices = invertedIndicesMap[dim] = new CtorInt32Array(ordinalMeta.categories.length);
          for (var i = 0; i < invertedIndices.length; i++) {
            invertedIndices[i] = INDEX_NOT_FOUND;
          }
          for (var i = 0; i < store.count(); i++) {
            invertedIndices[store.get(dimInfo.storeDimIndex, i)] = i;
          }
        }
      });
    };
    getIdNameFromStore = function(data, dimIdx, idx) {
      return convertOptionIdName(data._getCategory(dimIdx, idx), null);
    };
    getId = function(data, rawIndex) {
      var id2 = data._idList[rawIndex];
      if (id2 == null && data._idDimIdx != null) {
        id2 = getIdNameFromStore(data, data._idDimIdx, rawIndex);
      }
      if (id2 == null) {
        id2 = ID_PREFIX + rawIndex;
      }
      return id2;
    };
    normalizeDimensions = function(dimensions) {
      if (!isArray$1(dimensions)) {
        dimensions = dimensions != null ? [dimensions] : [];
      }
      return dimensions;
    };
    cloneListForMapAndSample = function(original) {
      var list = new SeriesData2(original._schema ? original._schema : map(original.dimensions, original._getDimInfo, original), original.hostModel);
      transferProperties(list, original);
      return list;
    };
    transferProperties = function(target, source) {
      each$g(TRANSFERABLE_PROPERTIES.concat(source.__wrappedMethods || []), function(propName) {
        if (source.hasOwnProperty(propName)) {
          target[propName] = source[propName];
        }
      });
      target.__wrappedMethods = source.__wrappedMethods;
      each$g(CLONE_PROPERTIES, function(propName) {
        target[propName] = clone$4(source[propName]);
      });
      target._calculationInfo = extend({}, source._calculationInfo);
    };
    makeIdFromName = function(data, idx) {
      var nameList = data._nameList;
      var idList = data._idList;
      var nameDimIdx = data._nameDimIdx;
      var idDimIdx = data._idDimIdx;
      var name = nameList[idx];
      var id2 = idList[idx];
      if (name == null && nameDimIdx != null) {
        nameList[idx] = name = getIdNameFromStore(data, nameDimIdx, idx);
      }
      if (id2 == null && idDimIdx != null) {
        idList[idx] = id2 = getIdNameFromStore(data, idDimIdx, idx);
      }
      if (id2 == null && name != null) {
        var nameRepeatCount = data._nameRepeatCount;
        var nmCnt = nameRepeatCount[name] = (nameRepeatCount[name] || 0) + 1;
        id2 = name;
        if (nmCnt > 1) {
          id2 += "__ec__" + nmCnt;
        }
        idList[idx] = id2;
      }
    };
  }();
  return SeriesData2;
}();
var SeriesData$1 = SeriesData;
function prepareSeriesDataSchema(source, opt) {
  if (!isSourceInstance(source)) {
    source = createSourceFromSeriesDataOption(source);
  }
  opt = opt || {};
  var sysDims = opt.coordDimensions || [];
  var dimsDef = opt.dimensionsDefine || source.dimensionsDefine || [];
  var coordDimNameMap = createHashMap();
  var resultList = [];
  var dimCount = getDimCount(source, sysDims, dimsDef, opt.dimensionsCount);
  var omitUnusedDimensions = opt.canOmitUnusedDimensions && shouldOmitUnusedDimensions(dimCount);
  var isUsingSourceDimensionsDef = dimsDef === source.dimensionsDefine;
  var dataDimNameMap = isUsingSourceDimensionsDef ? ensureSourceDimNameMap(source) : createDimNameMap(dimsDef);
  var encodeDef = opt.encodeDefine;
  if (!encodeDef && opt.encodeDefaulter) {
    encodeDef = opt.encodeDefaulter(source, dimCount);
  }
  var encodeDefMap = createHashMap(encodeDef);
  var indicesMap = new CtorInt32Array$1(dimCount);
  for (var i = 0; i < indicesMap.length; i++) {
    indicesMap[i] = -1;
  }
  function getResultItem(dimIdx) {
    var idx = indicesMap[dimIdx];
    if (idx < 0) {
      var dimDefItemRaw = dimsDef[dimIdx];
      var dimDefItem = isObject$4(dimDefItemRaw) ? dimDefItemRaw : {
        name: dimDefItemRaw
      };
      var resultItem2 = new SeriesDimensionDefine$1();
      var userDimName = dimDefItem.name;
      if (userDimName != null && dataDimNameMap.get(userDimName) != null) {
        resultItem2.name = resultItem2.displayName = userDimName;
      }
      dimDefItem.type != null && (resultItem2.type = dimDefItem.type);
      dimDefItem.displayName != null && (resultItem2.displayName = dimDefItem.displayName);
      var newIdx = resultList.length;
      indicesMap[dimIdx] = newIdx;
      resultItem2.storeDimIndex = dimIdx;
      resultList.push(resultItem2);
      return resultItem2;
    }
    return resultList[idx];
  }
  if (!omitUnusedDimensions) {
    for (var i = 0; i < dimCount; i++) {
      getResultItem(i);
    }
  }
  encodeDefMap.each(function(dataDimsRaw, coordDim2) {
    var dataDims = normalizeToArray(dataDimsRaw).slice();
    if (dataDims.length === 1 && !isString$1(dataDims[0]) && dataDims[0] < 0) {
      encodeDefMap.set(coordDim2, false);
      return;
    }
    var validDataDims = encodeDefMap.set(coordDim2, []);
    each$g(dataDims, function(resultDimIdxOrName, idx) {
      var resultDimIdx2 = isString$1(resultDimIdxOrName) ? dataDimNameMap.get(resultDimIdxOrName) : resultDimIdxOrName;
      if (resultDimIdx2 != null && resultDimIdx2 < dimCount) {
        validDataDims[idx] = resultDimIdx2;
        applyDim(getResultItem(resultDimIdx2), coordDim2, idx);
      }
    });
  });
  var availDimIdx = 0;
  each$g(sysDims, function(sysDimItemRaw) {
    var coordDim2;
    var sysDimItemDimsDef;
    var sysDimItemOtherDims;
    var sysDimItem;
    if (isString$1(sysDimItemRaw)) {
      coordDim2 = sysDimItemRaw;
      sysDimItem = {};
    } else {
      sysDimItem = sysDimItemRaw;
      coordDim2 = sysDimItem.name;
      var ordinalMeta = sysDimItem.ordinalMeta;
      sysDimItem.ordinalMeta = null;
      sysDimItem = extend({}, sysDimItem);
      sysDimItem.ordinalMeta = ordinalMeta;
      sysDimItemDimsDef = sysDimItem.dimsDef;
      sysDimItemOtherDims = sysDimItem.otherDims;
      sysDimItem.name = sysDimItem.coordDim = sysDimItem.coordDimIndex = sysDimItem.dimsDef = sysDimItem.otherDims = null;
    }
    var dataDims = encodeDefMap.get(coordDim2);
    if (dataDims === false) {
      return;
    }
    dataDims = normalizeToArray(dataDims);
    if (!dataDims.length) {
      for (var i2 = 0; i2 < (sysDimItemDimsDef && sysDimItemDimsDef.length || 1); i2++) {
        while (availDimIdx < dimCount && getResultItem(availDimIdx).coordDim != null) {
          availDimIdx++;
        }
        availDimIdx < dimCount && dataDims.push(availDimIdx++);
      }
    }
    each$g(dataDims, function(resultDimIdx2, coordDimIndex) {
      var resultItem2 = getResultItem(resultDimIdx2);
      if (isUsingSourceDimensionsDef && sysDimItem.type != null) {
        resultItem2.type = sysDimItem.type;
      }
      applyDim(defaults(resultItem2, sysDimItem), coordDim2, coordDimIndex);
      if (resultItem2.name == null && sysDimItemDimsDef) {
        var sysDimItemDimsDefItem = sysDimItemDimsDef[coordDimIndex];
        !isObject$4(sysDimItemDimsDefItem) && (sysDimItemDimsDefItem = {
          name: sysDimItemDimsDefItem
        });
        resultItem2.name = resultItem2.displayName = sysDimItemDimsDefItem.name;
        resultItem2.defaultTooltip = sysDimItemDimsDefItem.defaultTooltip;
      }
      sysDimItemOtherDims && defaults(resultItem2.otherDims, sysDimItemOtherDims);
    });
  });
  function applyDim(resultItem2, coordDim2, coordDimIndex) {
    if (VISUAL_DIMENSIONS.get(coordDim2) != null) {
      resultItem2.otherDims[coordDim2] = coordDimIndex;
    } else {
      resultItem2.coordDim = coordDim2;
      resultItem2.coordDimIndex = coordDimIndex;
      coordDimNameMap.set(coordDim2, true);
    }
  }
  var generateCoord = opt.generateCoord;
  var generateCoordCount = opt.generateCoordCount;
  var fromZero = generateCoordCount != null;
  generateCoordCount = generateCoord ? generateCoordCount || 1 : 0;
  var extra = generateCoord || "value";
  function ifNoNameFillWithCoordName(resultItem2) {
    if (resultItem2.name == null) {
      resultItem2.name = resultItem2.coordDim;
    }
  }
  if (!omitUnusedDimensions) {
    for (var resultDimIdx = 0; resultDimIdx < dimCount; resultDimIdx++) {
      var resultItem = getResultItem(resultDimIdx);
      var coordDim = resultItem.coordDim;
      if (coordDim == null) {
        resultItem.coordDim = genCoordDimName(extra, coordDimNameMap, fromZero);
        resultItem.coordDimIndex = 0;
        if (!generateCoord || generateCoordCount <= 0) {
          resultItem.isExtraCoord = true;
        }
        generateCoordCount--;
      }
      ifNoNameFillWithCoordName(resultItem);
      if (resultItem.type == null && (guessOrdinal(source, resultDimIdx) === BE_ORDINAL.Must || resultItem.isExtraCoord && (resultItem.otherDims.itemName != null || resultItem.otherDims.seriesName != null))) {
        resultItem.type = "ordinal";
      }
    }
  } else {
    each$g(resultList, function(resultItem2) {
      ifNoNameFillWithCoordName(resultItem2);
    });
    resultList.sort(function(item0, item1) {
      return item0.storeDimIndex - item1.storeDimIndex;
    });
  }
  removeDuplication(resultList);
  return new SeriesDataSchema({
    source,
    dimensions: resultList,
    fullDimensionCount: dimCount,
    dimensionOmitted: omitUnusedDimensions
  });
}
function removeDuplication(result) {
  var duplicationMap = createHashMap();
  for (var i = 0; i < result.length; i++) {
    var dim = result[i];
    var dimOriginalName = dim.name;
    var count2 = duplicationMap.get(dimOriginalName) || 0;
    if (count2 > 0) {
      dim.name = dimOriginalName + (count2 - 1);
    }
    count2++;
    duplicationMap.set(dimOriginalName, count2);
  }
}
function getDimCount(source, sysDims, dimsDef, optDimCount) {
  var dimCount = Math.max(source.dimensionsDetectedCount || 1, sysDims.length, dimsDef.length, optDimCount || 0);
  each$g(sysDims, function(sysDimItem) {
    var sysDimItemDimsDef;
    if (isObject$4(sysDimItem) && (sysDimItemDimsDef = sysDimItem.dimsDef)) {
      dimCount = Math.max(dimCount, sysDimItemDimsDef.length);
    }
  });
  return dimCount;
}
function genCoordDimName(name, map2, fromZero) {
  var mapData = map2.data;
  if (fromZero || mapData.hasOwnProperty(name)) {
    var i = 0;
    while (mapData.hasOwnProperty(name + i)) {
      i++;
    }
    name += i;
  }
  map2.set(name, true);
  return name;
}
var CoordSysInfo = function() {
  function CoordSysInfo2(coordSysName) {
    this.coordSysDims = [];
    this.axisMap = createHashMap();
    this.categoryAxisMap = createHashMap();
    this.coordSysName = coordSysName;
  }
  return CoordSysInfo2;
}();
function getCoordSysInfoBySeries(seriesModel) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var result = new CoordSysInfo(coordSysName);
  var fetch = fetchers[coordSysName];
  if (fetch) {
    fetch(seriesModel, result, result.axisMap, result.categoryAxisMap);
    return result;
  }
}
var fetchers = {
  cartesian2d: function(seriesModel, result, axisMap, categoryAxisMap) {
    var xAxisModel = seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["x", "y"];
    axisMap.set("x", xAxisModel);
    axisMap.set("y", yAxisModel);
    if (isCategory(xAxisModel)) {
      categoryAxisMap.set("x", xAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(yAxisModel)) {
      categoryAxisMap.set("y", yAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  singleAxis: function(seriesModel, result, axisMap, categoryAxisMap) {
    var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["single"];
    axisMap.set("single", singleAxisModel);
    if (isCategory(singleAxisModel)) {
      categoryAxisMap.set("single", singleAxisModel);
      result.firstCategoryDimIndex = 0;
    }
  },
  polar: function(seriesModel, result, axisMap, categoryAxisMap) {
    var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
    var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
    var angleAxisModel = polarModel.findAxisModel("angleAxis");
    result.coordSysDims = ["radius", "angle"];
    axisMap.set("radius", radiusAxisModel);
    axisMap.set("angle", angleAxisModel);
    if (isCategory(radiusAxisModel)) {
      categoryAxisMap.set("radius", radiusAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(angleAxisModel)) {
      categoryAxisMap.set("angle", angleAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  geo: function(seriesModel, result, axisMap, categoryAxisMap) {
    result.coordSysDims = ["lng", "lat"];
  },
  parallel: function(seriesModel, result, axisMap, categoryAxisMap) {
    var ecModel = seriesModel.ecModel;
    var parallelModel = ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
    var coordSysDims = result.coordSysDims = parallelModel.dimensions.slice();
    each$g(parallelModel.parallelAxisIndex, function(axisIndex, index2) {
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axisDim = coordSysDims[index2];
      axisMap.set(axisDim, axisModel);
      if (isCategory(axisModel)) {
        categoryAxisMap.set(axisDim, axisModel);
        if (result.firstCategoryDimIndex == null) {
          result.firstCategoryDimIndex = index2;
        }
      }
    });
  }
};
function isCategory(axisModel) {
  return axisModel.get("type") === "category";
}
function enableDataStack(seriesModel, dimensionsInput, opt) {
  opt = opt || {};
  var byIndex = opt.byIndex;
  var stackedCoordDimension = opt.stackedCoordDimension;
  var dimensionDefineList;
  var schema;
  var store;
  if (isLegacyDimensionsInput(dimensionsInput)) {
    dimensionDefineList = dimensionsInput;
  } else {
    schema = dimensionsInput.schema;
    dimensionDefineList = schema.dimensions;
    store = dimensionsInput.store;
  }
  var mayStack = !!(seriesModel && seriesModel.get("stack"));
  var stackedByDimInfo;
  var stackedDimInfo;
  var stackResultDimension;
  var stackedOverDimension;
  each$g(dimensionDefineList, function(dimensionInfo, index2) {
    if (isString$1(dimensionInfo)) {
      dimensionDefineList[index2] = dimensionInfo = {
        name: dimensionInfo
      };
    }
    if (mayStack && !dimensionInfo.isExtraCoord) {
      if (!byIndex && !stackedByDimInfo && dimensionInfo.ordinalMeta) {
        stackedByDimInfo = dimensionInfo;
      }
      if (!stackedDimInfo && dimensionInfo.type !== "ordinal" && dimensionInfo.type !== "time" && (!stackedCoordDimension || stackedCoordDimension === dimensionInfo.coordDim)) {
        stackedDimInfo = dimensionInfo;
      }
    }
  });
  if (stackedDimInfo && !byIndex && !stackedByDimInfo) {
    byIndex = true;
  }
  if (stackedDimInfo) {
    stackResultDimension = "__\0ecstackresult_" + seriesModel.id;
    stackedOverDimension = "__\0ecstackedover_" + seriesModel.id;
    if (stackedByDimInfo) {
      stackedByDimInfo.createInvertedIndices = true;
    }
    var stackedDimCoordDim_1 = stackedDimInfo.coordDim;
    var stackedDimType = stackedDimInfo.type;
    var stackedDimCoordIndex_1 = 0;
    each$g(dimensionDefineList, function(dimensionInfo) {
      if (dimensionInfo.coordDim === stackedDimCoordDim_1) {
        stackedDimCoordIndex_1++;
      }
    });
    var stackedOverDimensionDefine = {
      name: stackResultDimension,
      coordDim: stackedDimCoordDim_1,
      coordDimIndex: stackedDimCoordIndex_1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length
    };
    var stackResultDimensionDefine = {
      name: stackedOverDimension,
      coordDim: stackedOverDimension,
      coordDimIndex: stackedDimCoordIndex_1 + 1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length + 1
    };
    if (schema) {
      if (store) {
        stackedOverDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackedOverDimension, stackedDimType);
        stackResultDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackResultDimension, stackedDimType);
      }
      schema.appendCalculationDimension(stackedOverDimensionDefine);
      schema.appendCalculationDimension(stackResultDimensionDefine);
    } else {
      dimensionDefineList.push(stackedOverDimensionDefine);
      dimensionDefineList.push(stackResultDimensionDefine);
    }
  }
  return {
    stackedDimension: stackedDimInfo && stackedDimInfo.name,
    stackedByDimension: stackedByDimInfo && stackedByDimInfo.name,
    isStackedByIndex: byIndex,
    stackedOverDimension,
    stackResultDimension
  };
}
function isLegacyDimensionsInput(dimensionsInput) {
  return !isSeriesDataSchema(dimensionsInput.schema);
}
function isDimensionStacked(data, stackedDim) {
  return !!stackedDim && stackedDim === data.getCalculationInfo("stackedDimension");
}
function getStackedDimension(data, targetDim) {
  return isDimensionStacked(data, targetDim) ? data.getCalculationInfo("stackResultDimension") : targetDim;
}
function getCoordSysDimDefs(seriesModel, coordSysInfo) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var registeredCoordSys = CoordinateSystem.get(coordSysName);
  var coordSysDimDefs;
  if (coordSysInfo && coordSysInfo.coordSysDims) {
    coordSysDimDefs = map$1(coordSysInfo.coordSysDims, function(dim) {
      var dimInfo = {
        name: dim
      };
      var axisModel = coordSysInfo.axisMap.get(dim);
      if (axisModel) {
        var axisType = axisModel.get("type");
        dimInfo.type = getDimensionTypeByAxis(axisType);
      }
      return dimInfo;
    });
  }
  if (!coordSysDimDefs) {
    coordSysDimDefs = registeredCoordSys && (registeredCoordSys.getDimensionsInfo ? registeredCoordSys.getDimensionsInfo() : registeredCoordSys.dimensions.slice()) || ["x", "y"];
  }
  return coordSysDimDefs;
}
function injectOrdinalMeta(dimInfoList, createInvertedIndices, coordSysInfo) {
  var firstCategoryDimIndex;
  var hasNameEncode;
  coordSysInfo && each$g(dimInfoList, function(dimInfo, dimIndex) {
    var coordDim = dimInfo.coordDim;
    var categoryAxisModel = coordSysInfo.categoryAxisMap.get(coordDim);
    if (categoryAxisModel) {
      if (firstCategoryDimIndex == null) {
        firstCategoryDimIndex = dimIndex;
      }
      dimInfo.ordinalMeta = categoryAxisModel.getOrdinalMeta();
      if (createInvertedIndices) {
        dimInfo.createInvertedIndices = true;
      }
    }
    if (dimInfo.otherDims.itemName != null) {
      hasNameEncode = true;
    }
  });
  if (!hasNameEncode && firstCategoryDimIndex != null) {
    dimInfoList[firstCategoryDimIndex].otherDims.itemName = 0;
  }
  return firstCategoryDimIndex;
}
function createSeriesData(sourceRaw, seriesModel, opt) {
  opt = opt || {};
  var sourceManager = seriesModel.getSourceManager();
  var source;
  var isOriginalSource = false;
  if (sourceRaw) {
    isOriginalSource = true;
    source = createSourceFromSeriesDataOption(sourceRaw);
  } else {
    source = sourceManager.getSource();
    isOriginalSource = source.sourceFormat === SOURCE_FORMAT_ORIGINAL;
  }
  var coordSysInfo = getCoordSysInfoBySeries(seriesModel);
  var coordSysDimDefs = getCoordSysDimDefs(seriesModel, coordSysInfo);
  var useEncodeDefaulter = opt.useEncodeDefaulter;
  var encodeDefaulter = isFunction(useEncodeDefaulter) ? useEncodeDefaulter : useEncodeDefaulter ? curry$1(makeSeriesEncodeForAxisCoordSys, coordSysDimDefs, seriesModel) : null;
  var createDimensionOptions = {
    coordDimensions: coordSysDimDefs,
    generateCoord: opt.generateCoord,
    encodeDefine: seriesModel.getEncode(),
    encodeDefaulter,
    canOmitUnusedDimensions: !isOriginalSource
  };
  var schema = prepareSeriesDataSchema(source, createDimensionOptions);
  var firstCategoryDimIndex = injectOrdinalMeta(schema.dimensions, opt.createInvertedIndices, coordSysInfo);
  var store = !isOriginalSource ? sourceManager.getSharedDataStore(schema) : null;
  var stackCalculationInfo = enableDataStack(seriesModel, {
    schema,
    store
  });
  var data = new SeriesData$1(schema, seriesModel);
  data.setCalculationInfo(stackCalculationInfo);
  var dimValueGetter = firstCategoryDimIndex != null && isNeedCompleteOrdinalData(source) ? function(itemOpt, dimName, dataIndex, dimIndex) {
    return dimIndex === firstCategoryDimIndex ? dataIndex : this.defaultDimValueGetter(itemOpt, dimName, dataIndex, dimIndex);
  } : null;
  data.hasItemOption = false;
  data.initData(isOriginalSource ? source : store, null, dimValueGetter);
  return data;
}
function isNeedCompleteOrdinalData(source) {
  if (source.sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var sampleItem = firstDataNotNull(source.data || []);
    return !isArray$1(getDataItemValue(sampleItem));
  }
}
function firstDataNotNull(arr) {
  var i = 0;
  while (i < arr.length && arr[i] == null) {
    i++;
  }
  return arr[i];
}
var Scale = function() {
  function Scale2(setting) {
    this._setting = setting || {};
    this._extent = [Infinity, -Infinity];
  }
  Scale2.prototype.getSetting = function(name) {
    return this._setting[name];
  };
  Scale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
  };
  Scale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  Scale2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Scale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = start2;
    }
    if (!isNaN(end2)) {
      thisExtent[1] = end2;
    }
  };
  Scale2.prototype.isInExtentRange = function(value) {
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  Scale2.prototype.isBlank = function() {
    return this._isBlank;
  };
  Scale2.prototype.setBlank = function(isBlank) {
    this._isBlank = isBlank;
  };
  return Scale2;
}();
enableClassManagement(Scale);
var Scale$1 = Scale;
var uidBase = 0;
var OrdinalMeta = function() {
  function OrdinalMeta2(opt) {
    this.categories = opt.categories || [];
    this._needCollect = opt.needCollect;
    this._deduplication = opt.deduplication;
    this.uid = ++uidBase;
  }
  OrdinalMeta2.createByAxisModel = function(axisModel) {
    var option = axisModel.option;
    var data = option.data;
    var categories = data && map$1(data, getName);
    return new OrdinalMeta2({
      categories,
      needCollect: !categories,
      deduplication: option.dedplication !== false
    });
  };
  OrdinalMeta2.prototype.getOrdinal = function(category) {
    return this._getOrCreateMap().get(category);
  };
  OrdinalMeta2.prototype.parseAndCollect = function(category) {
    var index2;
    var needCollect = this._needCollect;
    if (!isString$1(category) && !needCollect) {
      return category;
    }
    if (needCollect && !this._deduplication) {
      index2 = this.categories.length;
      this.categories[index2] = category;
      return index2;
    }
    var map2 = this._getOrCreateMap();
    index2 = map2.get(category);
    if (index2 == null) {
      if (needCollect) {
        index2 = this.categories.length;
        this.categories[index2] = category;
        map2.set(category, index2);
      } else {
        index2 = NaN;
      }
    }
    return index2;
  };
  OrdinalMeta2.prototype._getOrCreateMap = function() {
    return this._map || (this._map = createHashMap(this.categories));
  };
  return OrdinalMeta2;
}();
function getName(obj) {
  if (isObject$4(obj) && obj.value != null) {
    return obj.value;
  } else {
    return obj + "";
  }
}
var OrdinalMeta$1 = OrdinalMeta;
function isIntervalOrLogScale(scale2) {
  return scale2.type === "interval" || scale2.type === "log";
}
function intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval) {
  var result = {};
  var span = extent3[1] - extent3[0];
  var interval = result.interval = nice(span / splitNumber, true);
  if (minInterval != null && interval < minInterval) {
    interval = result.interval = minInterval;
  }
  if (maxInterval != null && interval > maxInterval) {
    interval = result.interval = maxInterval;
  }
  var precision = result.intervalPrecision = getIntervalPrecision(interval);
  var niceTickExtent = result.niceTickExtent = [round$3(Math.ceil(extent3[0] / interval) * interval, precision), round$3(Math.floor(extent3[1] / interval) * interval, precision)];
  fixExtent(niceTickExtent, extent3);
  return result;
}
function increaseInterval(interval) {
  var exp10 = Math.pow(10, quantityExponent(interval));
  var f2 = interval / exp10;
  if (!f2) {
    f2 = 1;
  } else if (f2 === 2) {
    f2 = 3;
  } else if (f2 === 3) {
    f2 = 5;
  } else {
    f2 *= 2;
  }
  return round$3(f2 * exp10);
}
function getIntervalPrecision(interval) {
  return getPrecision(interval) + 2;
}
function clamp(niceTickExtent, idx, extent3) {
  niceTickExtent[idx] = Math.max(Math.min(niceTickExtent[idx], extent3[1]), extent3[0]);
}
function fixExtent(niceTickExtent, extent3) {
  !isFinite(niceTickExtent[0]) && (niceTickExtent[0] = extent3[0]);
  !isFinite(niceTickExtent[1]) && (niceTickExtent[1] = extent3[1]);
  clamp(niceTickExtent, 0, extent3);
  clamp(niceTickExtent, 1, extent3);
  if (niceTickExtent[0] > niceTickExtent[1]) {
    niceTickExtent[0] = niceTickExtent[1];
  }
}
function contain$1(val, extent3) {
  return val >= extent3[0] && val <= extent3[1];
}
function normalize$3(val, extent3) {
  if (extent3[1] === extent3[0]) {
    return 0.5;
  }
  return (val - extent3[0]) / (extent3[1] - extent3[0]);
}
function scale(val, extent3) {
  return val * (extent3[1] - extent3[0]) + extent3[0];
}
var OrdinalScale = function(_super) {
  __extends(OrdinalScale2, _super);
  function OrdinalScale2(setting) {
    var _this = _super.call(this, setting) || this;
    _this.type = "ordinal";
    var ordinalMeta = _this.getSetting("ordinalMeta");
    if (!ordinalMeta) {
      ordinalMeta = new OrdinalMeta$1({});
    }
    if (isArray$1(ordinalMeta)) {
      ordinalMeta = new OrdinalMeta$1({
        categories: map$1(ordinalMeta, function(item) {
          return isObject$4(item) ? item.value : item;
        })
      });
    }
    _this._ordinalMeta = ordinalMeta;
    _this._extent = _this.getSetting("extent") || [0, ordinalMeta.categories.length - 1];
    return _this;
  }
  OrdinalScale2.prototype.parse = function(val) {
    return isString$1(val) ? this._ordinalMeta.getOrdinal(val) : Math.round(val);
  };
  OrdinalScale2.prototype.contain = function(rank) {
    rank = this.parse(rank);
    return contain$1(rank, this._extent) && this._ordinalMeta.categories[rank] != null;
  };
  OrdinalScale2.prototype.normalize = function(val) {
    val = this._getTickNumber(this.parse(val));
    return normalize$3(val, this._extent);
  };
  OrdinalScale2.prototype.scale = function(val) {
    val = Math.round(scale(val, this._extent));
    return this.getRawOrdinalNumber(val);
  };
  OrdinalScale2.prototype.getTicks = function() {
    var ticks = [];
    var extent3 = this._extent;
    var rank = extent3[0];
    while (rank <= extent3[1]) {
      ticks.push({
        value: rank
      });
      rank++;
    }
    return ticks;
  };
  OrdinalScale2.prototype.getMinorTicks = function(splitNumber) {
    return;
  };
  OrdinalScale2.prototype.setSortInfo = function(info) {
    if (info == null) {
      this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
      return;
    }
    var infoOrdinalNumbers = info.ordinalNumbers;
    var ordinalsByTick = this._ordinalNumbersByTick = [];
    var ticksByOrdinal = this._ticksByOrdinalNumber = [];
    var tickNum = 0;
    var allCategoryLen = this._ordinalMeta.categories.length;
    for (var len2 = Math.min(allCategoryLen, infoOrdinalNumbers.length); tickNum < len2; ++tickNum) {
      var ordinalNumber = infoOrdinalNumbers[tickNum];
      ordinalsByTick[tickNum] = ordinalNumber;
      ticksByOrdinal[ordinalNumber] = tickNum;
    }
    var unusedOrdinal = 0;
    for (; tickNum < allCategoryLen; ++tickNum) {
      while (ticksByOrdinal[unusedOrdinal] != null) {
        unusedOrdinal++;
      }
      ordinalsByTick.push(unusedOrdinal);
      ticksByOrdinal[unusedOrdinal] = tickNum;
    }
  };
  OrdinalScale2.prototype._getTickNumber = function(ordinal) {
    var ticksByOrdinalNumber = this._ticksByOrdinalNumber;
    return ticksByOrdinalNumber && ordinal >= 0 && ordinal < ticksByOrdinalNumber.length ? ticksByOrdinalNumber[ordinal] : ordinal;
  };
  OrdinalScale2.prototype.getRawOrdinalNumber = function(tickNumber) {
    var ordinalNumbersByTick = this._ordinalNumbersByTick;
    return ordinalNumbersByTick && tickNumber >= 0 && tickNumber < ordinalNumbersByTick.length ? ordinalNumbersByTick[tickNumber] : tickNumber;
  };
  OrdinalScale2.prototype.getLabel = function(tick) {
    if (!this.isBlank()) {
      var ordinalNumber = this.getRawOrdinalNumber(tick.value);
      var cateogry = this._ordinalMeta.categories[ordinalNumber];
      return cateogry == null ? "" : cateogry + "";
    }
  };
  OrdinalScale2.prototype.count = function() {
    return this._extent[1] - this._extent[0] + 1;
  };
  OrdinalScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  OrdinalScale2.prototype.isInExtentRange = function(value) {
    value = this._getTickNumber(value);
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  OrdinalScale2.prototype.getOrdinalMeta = function() {
    return this._ordinalMeta;
  };
  OrdinalScale2.prototype.calcNiceTicks = function() {
  };
  OrdinalScale2.prototype.calcNiceExtent = function() {
  };
  OrdinalScale2.type = "ordinal";
  return OrdinalScale2;
}(Scale$1);
Scale$1.registerClass(OrdinalScale);
var OrdinalScale$1 = OrdinalScale;
var roundNumber = round$3;
var IntervalScale = function(_super) {
  __extends(IntervalScale2, _super);
  function IntervalScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "interval";
    _this._interval = 0;
    _this._intervalPrecision = 2;
    return _this;
  }
  IntervalScale2.prototype.parse = function(val) {
    return val;
  };
  IntervalScale2.prototype.contain = function(val) {
    return contain$1(val, this._extent);
  };
  IntervalScale2.prototype.normalize = function(val) {
    return normalize$3(val, this._extent);
  };
  IntervalScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  IntervalScale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = parseFloat(start2);
    }
    if (!isNaN(end2)) {
      thisExtent[1] = parseFloat(end2);
    }
  };
  IntervalScale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
    this.setExtent(extent3[0], extent3[1]);
  };
  IntervalScale2.prototype.getInterval = function() {
    return this._interval;
  };
  IntervalScale2.prototype.setInterval = function(interval) {
    this._interval = interval;
    this._niceExtent = this._extent.slice();
    this._intervalPrecision = getIntervalPrecision(interval);
  };
  IntervalScale2.prototype.getTicks = function(expandToNicedExtent) {
    var interval = this._interval;
    var extent3 = this._extent;
    var niceTickExtent = this._niceExtent;
    var intervalPrecision = this._intervalPrecision;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    var safeLimit = 1e4;
    if (extent3[0] < niceTickExtent[0]) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(niceTickExtent[0] - interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[0]
        });
      }
    }
    var tick = niceTickExtent[0];
    while (tick <= niceTickExtent[1]) {
      ticks.push({
        value: tick
      });
      tick = roundNumber(tick + interval, intervalPrecision);
      if (tick === ticks[ticks.length - 1].value) {
        break;
      }
      if (ticks.length > safeLimit) {
        return [];
      }
    }
    var lastNiceTick = ticks.length ? ticks[ticks.length - 1].value : niceTickExtent[1];
    if (extent3[1] > lastNiceTick) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(lastNiceTick + interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[1]
        });
      }
    }
    return ticks;
  };
  IntervalScale2.prototype.getMinorTicks = function(splitNumber) {
    var ticks = this.getTicks(true);
    var minorTicks = [];
    var extent3 = this.getExtent();
    for (var i = 1; i < ticks.length; i++) {
      var nextTick = ticks[i];
      var prevTick = ticks[i - 1];
      var count2 = 0;
      var minorTicksGroup = [];
      var interval = nextTick.value - prevTick.value;
      var minorInterval = interval / splitNumber;
      while (count2 < splitNumber - 1) {
        var minorTick = roundNumber(prevTick.value + (count2 + 1) * minorInterval);
        if (minorTick > extent3[0] && minorTick < extent3[1]) {
          minorTicksGroup.push(minorTick);
        }
        count2++;
      }
      minorTicks.push(minorTicksGroup);
    }
    return minorTicks;
  };
  IntervalScale2.prototype.getLabel = function(data, opt) {
    if (data == null) {
      return "";
    }
    var precision = opt && opt.precision;
    if (precision == null) {
      precision = getPrecision(data.value) || 0;
    } else if (precision === "auto") {
      precision = this._intervalPrecision;
    }
    var dataNum = roundNumber(data.value, precision, true);
    return addCommas(dataNum);
  };
  IntervalScale2.prototype.calcNiceTicks = function(splitNumber, minInterval, maxInterval) {
    splitNumber = splitNumber || 5;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      return;
    }
    if (span < 0) {
      span = -span;
      extent3.reverse();
    }
    var result = intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval);
    this._intervalPrecision = result.intervalPrecision;
    this._interval = result.interval;
    this._niceExtent = result.niceTickExtent;
  };
  IntervalScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      if (extent3[0] !== 0) {
        var expandSize = extent3[0];
        if (!opt.fixMax) {
          extent3[1] += expandSize / 2;
          extent3[0] -= expandSize / 2;
        } else {
          extent3[0] -= expandSize / 2;
        }
      } else {
        extent3[1] = 1;
      }
    }
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      extent3[0] = 0;
      extent3[1] = 1;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
    var interval = this._interval;
    if (!opt.fixMin) {
      extent3[0] = roundNumber(Math.floor(extent3[0] / interval) * interval);
    }
    if (!opt.fixMax) {
      extent3[1] = roundNumber(Math.ceil(extent3[1] / interval) * interval);
    }
  };
  IntervalScale2.prototype.setNiceExtent = function(min3, max3) {
    this._niceExtent = [min3, max3];
  };
  IntervalScale2.type = "interval";
  return IntervalScale2;
}(Scale$1);
Scale$1.registerClass(IntervalScale);
var IntervalScale$1 = IntervalScale;
var supportFloat32Array = typeof Float32Array !== "undefined";
var Float32ArrayCtor = !supportFloat32Array ? Array : Float32Array;
function createFloat32Array(arg) {
  if (isArray$1(arg)) {
    return supportFloat32Array ? new Float32Array(arg) : arg;
  }
  return new Float32ArrayCtor(arg);
}
var STACK_PREFIX = "__ec_stack_";
function getSeriesStackId$1(seriesModel) {
  return seriesModel.get("stack") || STACK_PREFIX + seriesModel.seriesIndex;
}
function getAxisKey$1(axis) {
  return axis.dim + axis.index;
}
function getLayoutOnAxis(opt) {
  var params = [];
  var baseAxis = opt.axis;
  var axisKey = "axis0";
  if (baseAxis.type !== "category") {
    return;
  }
  var bandWidth = baseAxis.getBandWidth();
  for (var i = 0; i < opt.count || 0; i++) {
    params.push(defaults({
      bandWidth,
      axisKey,
      stackId: STACK_PREFIX + i
    }, opt));
  }
  var widthAndOffsets = doCalBarWidthAndOffset(params);
  var result = [];
  for (var i = 0; i < opt.count; i++) {
    var item = widthAndOffsets[axisKey][STACK_PREFIX + i];
    item.offsetCenter = item.offset + item.width / 2;
    result.push(item);
  }
  return result;
}
function prepareLayoutBarSeries(seriesType2, ecModel) {
  var seriesModels = [];
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (isOnCartesian(seriesModel)) {
      seriesModels.push(seriesModel);
    }
  });
  return seriesModels;
}
function getValueAxesMinGaps(barSeries) {
  var axisValues = {};
  each$g(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    if (baseAxis.type !== "time" && baseAxis.type !== "value") {
      return;
    }
    var data = seriesModel.getData();
    var key2 = baseAxis.dim + "_" + baseAxis.index;
    var dimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
    var store = data.getStore();
    for (var i = 0, cnt = store.count(); i < cnt; ++i) {
      var value = store.get(dimIdx, i);
      if (!axisValues[key2]) {
        axisValues[key2] = [value];
      } else {
        axisValues[key2].push(value);
      }
    }
  });
  var axisMinGaps = {};
  for (var key in axisValues) {
    if (axisValues.hasOwnProperty(key)) {
      var valuesInAxis = axisValues[key];
      if (valuesInAxis) {
        valuesInAxis.sort(function(a, b2) {
          return a - b2;
        });
        var min3 = null;
        for (var j = 1; j < valuesInAxis.length; ++j) {
          var delta = valuesInAxis[j] - valuesInAxis[j - 1];
          if (delta > 0) {
            min3 = min3 === null ? delta : Math.min(min3, delta);
          }
        }
        axisMinGaps[key] = min3;
      }
    }
  }
  return axisMinGaps;
}
function makeColumnLayout(barSeries) {
  var axisMinGaps = getValueAxesMinGaps(barSeries);
  var seriesInfoList = [];
  each$g(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var axisExtent = baseAxis.getExtent();
    var bandWidth;
    if (baseAxis.type === "category") {
      bandWidth = baseAxis.getBandWidth();
    } else if (baseAxis.type === "value" || baseAxis.type === "time") {
      var key = baseAxis.dim + "_" + baseAxis.index;
      var minGap = axisMinGaps[key];
      var extentSpan = Math.abs(axisExtent[1] - axisExtent[0]);
      var scale2 = baseAxis.scale.getExtent();
      var scaleSpan = Math.abs(scale2[1] - scale2[0]);
      bandWidth = minGap ? extentSpan / scaleSpan * minGap : extentSpan;
    } else {
      var data = seriesModel.getData();
      bandWidth = Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    }
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barMinWidth = parsePercent(seriesModel.get("barMinWidth") || (isInLargeMode(seriesModel) ? 0.5 : 1), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    seriesInfoList.push({
      bandWidth,
      barWidth,
      barMaxWidth,
      barMinWidth,
      barGap,
      barCategoryGap,
      axisKey: getAxisKey$1(baseAxis),
      stackId: getSeriesStackId$1(seriesModel)
    });
  });
  return doCalBarWidthAndOffset(seriesInfoList);
}
function doCalBarWidthAndOffset(seriesInfoList) {
  var columnsMap = {};
  each$g(seriesInfoList, function(seriesInfo, idx) {
    var axisKey = seriesInfo.axisKey;
    var bandWidth = seriesInfo.bandWidth;
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: null,
      gap: "20%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = seriesInfo.stackId;
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = seriesInfo.barWidth;
    if (barWidth && !stacks[stackId].width) {
      stacks[stackId].width = barWidth;
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      columnsOnAxis.remainedWidth -= barWidth;
    }
    var barMaxWidth = seriesInfo.barMaxWidth;
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    var barMinWidth = seriesInfo.barMinWidth;
    barMinWidth && (stacks[stackId].minWidth = barMinWidth);
    var barGap = seriesInfo.barGap;
    barGap != null && (columnsOnAxis.gap = barGap);
    var barCategoryGap = seriesInfo.barCategoryGap;
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$g(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGapPercent = columnsOnAxis.categoryGap;
    if (categoryGapPercent == null) {
      var columnCount = keys(stacks).length;
      categoryGapPercent = Math.max(35 - columnCount * 4, 15) + "%";
    }
    var categoryGap = parsePercent(categoryGapPercent, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$g(stacks, function(column) {
      var maxWidth = column.maxWidth;
      var minWidth = column.minWidth;
      if (!column.width) {
        var finalWidth = autoWidth;
        if (maxWidth && maxWidth < finalWidth) {
          finalWidth = Math.min(maxWidth, remainedWidth);
        }
        if (minWidth && minWidth > finalWidth) {
          finalWidth = minWidth;
        }
        if (finalWidth !== autoWidth) {
          column.width = finalWidth;
          remainedWidth -= finalWidth + barGapPercent * finalWidth;
          autoWidthCount--;
        }
      } else {
        var finalWidth = column.width;
        if (maxWidth) {
          finalWidth = Math.min(finalWidth, maxWidth);
        }
        if (minWidth) {
          finalWidth = Math.max(finalWidth, minWidth);
        }
        column.width = finalWidth;
        remainedWidth -= finalWidth + barGapPercent * finalWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$g(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset2 = -widthSum / 2;
    each$g(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        bandWidth,
        offset: offset2,
        width: column.width
      };
      offset2 += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
function retrieveColumnLayout(barWidthAndOffset, axis, seriesModel) {
  if (barWidthAndOffset && axis) {
    var result = barWidthAndOffset[getAxisKey$1(axis)];
    if (result != null && seriesModel != null) {
      return result[getSeriesStackId$1(seriesModel)];
    }
    return result;
  }
}
function layout$3(seriesType2, ecModel) {
  var seriesModels = prepareLayoutBarSeries(seriesType2, ecModel);
  var barWidthAndOffset = makeColumnLayout(seriesModels);
  each$g(seriesModels, function(seriesModel) {
    var data = seriesModel.getData();
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var stackId = getSeriesStackId$1(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[getAxisKey$1(baseAxis)][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    data.setLayout({
      bandWidth: columnLayoutInfo.bandWidth,
      offset: columnOffset,
      size: columnWidth
    });
  });
}
function createProgressiveLayout(seriesType2) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      if (!isOnCartesian(seriesModel)) {
        return;
      }
      var data = seriesModel.getData();
      var cartesian = seriesModel.coordinateSystem;
      var baseAxis = cartesian.getBaseAxis();
      var valueAxis2 = cartesian.getOtherAxis(baseAxis);
      var valueDimIdx = data.getDimensionIndex(data.mapDimension(valueAxis2.dim));
      var baseDimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
      var drawBackground = seriesModel.get("showBackground", true);
      var valueDim = data.mapDimension(valueAxis2.dim);
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      var stacked = isDimensionStacked(data, valueDim) && !!data.getCalculationInfo("stackedOnSeries");
      var isValueAxisH = valueAxis2.isHorizontal();
      var valueAxisStart = getValueAxisStart(baseAxis, valueAxis2);
      var isLarge = isInLargeMode(seriesModel);
      var barMinHeight = seriesModel.get("barMinHeight") || 0;
      var stackedDimIdx = stackResultDim && data.getDimensionIndex(stackResultDim);
      var columnWidth = data.getLayout("size");
      var columnOffset = data.getLayout("offset");
      return {
        progress: function(params, data2) {
          var count2 = params.count;
          var largePoints = isLarge && createFloat32Array(count2 * 3);
          var largeBackgroundPoints = isLarge && drawBackground && createFloat32Array(count2 * 3);
          var largeDataIndices = isLarge && createFloat32Array(count2);
          var coordLayout = cartesian.master.getRect();
          var bgSize = isValueAxisH ? coordLayout.width : coordLayout.height;
          var dataIndex;
          var store = data2.getStore();
          var idxOffset = 0;
          while ((dataIndex = params.next()) != null) {
            var value = store.get(stacked ? stackedDimIdx : valueDimIdx, dataIndex);
            var baseValue = store.get(baseDimIdx, dataIndex);
            var baseCoord = valueAxisStart;
            var startValue = void 0;
            if (stacked) {
              startValue = +value - store.get(valueDimIdx, dataIndex);
            }
            var x2 = void 0;
            var y2 = void 0;
            var width = void 0;
            var height = void 0;
            if (isValueAxisH) {
              var coord = cartesian.dataToPoint([value, baseValue]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([startValue, baseValue]);
                baseCoord = startCoord[0];
              }
              x2 = baseCoord;
              y2 = coord[1] + columnOffset;
              width = coord[0] - baseCoord;
              height = columnWidth;
              if (Math.abs(width) < barMinHeight) {
                width = (width < 0 ? -1 : 1) * barMinHeight;
              }
            } else {
              var coord = cartesian.dataToPoint([baseValue, value]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([baseValue, startValue]);
                baseCoord = startCoord[1];
              }
              x2 = coord[0] + columnOffset;
              y2 = baseCoord;
              width = columnWidth;
              height = coord[1] - baseCoord;
              if (Math.abs(height) < barMinHeight) {
                height = (height <= 0 ? -1 : 1) * barMinHeight;
              }
            }
            if (!isLarge) {
              data2.setItemLayout(dataIndex, {
                x: x2,
                y: y2,
                width,
                height
              });
            } else {
              largePoints[idxOffset] = x2;
              largePoints[idxOffset + 1] = y2;
              largePoints[idxOffset + 2] = isValueAxisH ? width : height;
              if (largeBackgroundPoints) {
                largeBackgroundPoints[idxOffset] = isValueAxisH ? coordLayout.x : x2;
                largeBackgroundPoints[idxOffset + 1] = isValueAxisH ? y2 : coordLayout.y;
                largeBackgroundPoints[idxOffset + 2] = bgSize;
              }
              largeDataIndices[dataIndex] = dataIndex;
            }
            idxOffset += 3;
          }
          if (isLarge) {
            data2.setLayout({
              largePoints,
              largeDataIndices,
              largeBackgroundPoints,
              valueAxisHorizontal: isValueAxisH
            });
          }
        }
      };
    }
  };
}
function isOnCartesian(seriesModel) {
  return seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "cartesian2d";
}
function isInLargeMode(seriesModel) {
  return seriesModel.pipelineContext && seriesModel.pipelineContext.large;
}
function getValueAxisStart(baseAxis, valueAxis2) {
  return valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(valueAxis2.type === "log" ? 1 : 0));
}
var bisect = function(a, x2, lo, hi2) {
  while (lo < hi2) {
    var mid = lo + hi2 >>> 1;
    if (a[mid][1] < x2) {
      lo = mid + 1;
    } else {
      hi2 = mid;
    }
  }
  return lo;
};
var TimeScale = function(_super) {
  __extends(TimeScale2, _super);
  function TimeScale2(settings) {
    var _this = _super.call(this, settings) || this;
    _this.type = "time";
    return _this;
  }
  TimeScale2.prototype.getLabel = function(tick) {
    var useUTC = this.getSetting("useUTC");
    return format$1(tick.value, fullLeveledFormatter[getDefaultFormatPrecisionOfInterval(getPrimaryTimeUnit(this._minLevelUnit))] || fullLeveledFormatter.second, useUTC, this.getSetting("locale"));
  };
  TimeScale2.prototype.getFormattedLabel = function(tick, idx, labelFormatter) {
    var isUTC = this.getSetting("useUTC");
    var lang = this.getSetting("locale");
    return leveledFormat(tick, idx, labelFormatter, lang, isUTC);
  };
  TimeScale2.prototype.getTicks = function() {
    var interval = this._interval;
    var extent3 = this._extent;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    ticks.push({
      value: extent3[0],
      level: 0
    });
    var useUTC = this.getSetting("useUTC");
    var innerTicks = getIntervalTicks(this._minLevelUnit, this._approxInterval, useUTC, extent3);
    ticks = ticks.concat(innerTicks);
    ticks.push({
      value: extent3[1],
      level: 0
    });
    return ticks;
  };
  TimeScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      extent3[0] -= ONE_DAY;
      extent3[1] += ONE_DAY;
    }
    if (extent3[1] === -Infinity && extent3[0] === Infinity) {
      var d2 = new Date();
      extent3[1] = +new Date(d2.getFullYear(), d2.getMonth(), d2.getDate());
      extent3[0] = extent3[1] - ONE_DAY;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
  };
  TimeScale2.prototype.calcNiceTicks = function(approxTickNum, minInterval, maxInterval) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    this._approxInterval = span / approxTickNum;
    if (minInterval != null && this._approxInterval < minInterval) {
      this._approxInterval = minInterval;
    }
    if (maxInterval != null && this._approxInterval > maxInterval) {
      this._approxInterval = maxInterval;
    }
    var scaleIntervalsLen = scaleIntervals.length;
    var idx = Math.min(bisect(scaleIntervals, this._approxInterval, 0, scaleIntervalsLen), scaleIntervalsLen - 1);
    this._interval = scaleIntervals[idx][1];
    this._minLevelUnit = scaleIntervals[Math.max(idx - 1, 0)][0];
  };
  TimeScale2.prototype.parse = function(val) {
    return isNumber(val) ? val : +parseDate(val);
  };
  TimeScale2.prototype.contain = function(val) {
    return contain$1(this.parse(val), this._extent);
  };
  TimeScale2.prototype.normalize = function(val) {
    return normalize$3(this.parse(val), this._extent);
  };
  TimeScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  TimeScale2.type = "time";
  return TimeScale2;
}(IntervalScale$1);
var scaleIntervals = [
  ["second", ONE_SECOND],
  ["minute", ONE_MINUTE],
  ["hour", ONE_HOUR],
  ["quarter-day", ONE_HOUR * 6],
  ["half-day", ONE_HOUR * 12],
  ["day", ONE_DAY * 1.2],
  ["half-week", ONE_DAY * 3.5],
  ["week", ONE_DAY * 7],
  ["month", ONE_DAY * 31],
  ["quarter", ONE_DAY * 95],
  ["half-year", ONE_YEAR / 2],
  ["year", ONE_YEAR]
];
function isUnitValueSame(unit, valueA, valueB, isUTC) {
  var dateA = parseDate(valueA);
  var dateB = parseDate(valueB);
  var isSame = function(unit2) {
    return getUnitValue(dateA, unit2, isUTC) === getUnitValue(dateB, unit2, isUTC);
  };
  var isSameYear = function() {
    return isSame("year");
  };
  var isSameMonth = function() {
    return isSameYear() && isSame("month");
  };
  var isSameDay = function() {
    return isSameMonth() && isSame("day");
  };
  var isSameHour = function() {
    return isSameDay() && isSame("hour");
  };
  var isSameMinute = function() {
    return isSameHour() && isSame("minute");
  };
  var isSameSecond = function() {
    return isSameMinute() && isSame("second");
  };
  var isSameMilliSecond = function() {
    return isSameSecond() && isSame("millisecond");
  };
  switch (unit) {
    case "year":
      return isSameYear();
    case "month":
      return isSameMonth();
    case "day":
      return isSameDay();
    case "hour":
      return isSameHour();
    case "minute":
      return isSameMinute();
    case "second":
      return isSameSecond();
    case "millisecond":
      return isSameMilliSecond();
  }
}
function getDateInterval(approxInterval, daysInMonth) {
  approxInterval /= ONE_DAY;
  return approxInterval > 16 ? 16 : approxInterval > 7.5 ? 7 : approxInterval > 3.5 ? 4 : approxInterval > 1.5 ? 2 : 1;
}
function getMonthInterval(approxInterval) {
  var APPROX_ONE_MONTH = 30 * ONE_DAY;
  approxInterval /= APPROX_ONE_MONTH;
  return approxInterval > 6 ? 6 : approxInterval > 3 ? 3 : approxInterval > 2 ? 2 : 1;
}
function getHourInterval(approxInterval) {
  approxInterval /= ONE_HOUR;
  return approxInterval > 12 ? 12 : approxInterval > 6 ? 6 : approxInterval > 3.5 ? 4 : approxInterval > 2 ? 2 : 1;
}
function getMinutesAndSecondsInterval(approxInterval, isMinutes) {
  approxInterval /= isMinutes ? ONE_MINUTE : ONE_SECOND;
  return approxInterval > 30 ? 30 : approxInterval > 20 ? 20 : approxInterval > 15 ? 15 : approxInterval > 10 ? 10 : approxInterval > 5 ? 5 : approxInterval > 2 ? 2 : 1;
}
function getMillisecondsInterval(approxInterval) {
  return nice(approxInterval, true);
}
function getFirstTimestampOfUnit(date4, unitName, isUTC) {
  var outDate = new Date(date4);
  switch (getPrimaryTimeUnit(unitName)) {
    case "year":
    case "month":
      outDate[monthSetterName(isUTC)](0);
    case "day":
      outDate[dateSetterName(isUTC)](1);
    case "hour":
      outDate[hoursSetterName(isUTC)](0);
    case "minute":
      outDate[minutesSetterName(isUTC)](0);
    case "second":
      outDate[secondsSetterName(isUTC)](0);
      outDate[millisecondsSetterName(isUTC)](0);
  }
  return outDate.getTime();
}
function getIntervalTicks(bottomUnitName, approxInterval, isUTC, extent3) {
  var safeLimit = 1e4;
  var unitNames = timeUnits;
  var iter = 0;
  function addTicksInSpan(interval, minTimestamp, maxTimestamp, getMethodName, setMethodName, isDate, out2) {
    var date4 = new Date(minTimestamp);
    var dateTime = minTimestamp;
    var d2 = date4[getMethodName]();
    while (dateTime < maxTimestamp && dateTime <= extent3[1]) {
      out2.push({
        value: dateTime
      });
      d2 += interval;
      date4[setMethodName](d2);
      dateTime = date4.getTime();
    }
    out2.push({
      value: dateTime,
      notAdd: true
    });
  }
  function addLevelTicks(unitName, lastLevelTicks, levelTicks2) {
    var newAddedTicks = [];
    var isFirstLevel = !lastLevelTicks.length;
    if (isUnitValueSame(getPrimaryTimeUnit(unitName), extent3[0], extent3[1], isUTC)) {
      return;
    }
    if (isFirstLevel) {
      lastLevelTicks = [{
        value: getFirstTimestampOfUnit(new Date(extent3[0]), unitName, isUTC)
      }, {
        value: extent3[1]
      }];
    }
    for (var i2 = 0; i2 < lastLevelTicks.length - 1; i2++) {
      var startTick = lastLevelTicks[i2].value;
      var endTick = lastLevelTicks[i2 + 1].value;
      if (startTick === endTick) {
        continue;
      }
      var interval = void 0;
      var getterName = void 0;
      var setterName = void 0;
      var isDate = false;
      switch (unitName) {
        case "year":
          interval = Math.max(1, Math.round(approxInterval / ONE_DAY / 365));
          getterName = fullYearGetterName(isUTC);
          setterName = fullYearSetterName(isUTC);
          break;
        case "half-year":
        case "quarter":
        case "month":
          interval = getMonthInterval(approxInterval);
          getterName = monthGetterName(isUTC);
          setterName = monthSetterName(isUTC);
          break;
        case "week":
        case "half-week":
        case "day":
          interval = getDateInterval(approxInterval);
          getterName = dateGetterName(isUTC);
          setterName = dateSetterName(isUTC);
          isDate = true;
          break;
        case "half-day":
        case "quarter-day":
        case "hour":
          interval = getHourInterval(approxInterval);
          getterName = hoursGetterName(isUTC);
          setterName = hoursSetterName(isUTC);
          break;
        case "minute":
          interval = getMinutesAndSecondsInterval(approxInterval, true);
          getterName = minutesGetterName(isUTC);
          setterName = minutesSetterName(isUTC);
          break;
        case "second":
          interval = getMinutesAndSecondsInterval(approxInterval, false);
          getterName = secondsGetterName(isUTC);
          setterName = secondsSetterName(isUTC);
          break;
        case "millisecond":
          interval = getMillisecondsInterval(approxInterval);
          getterName = millisecondsGetterName(isUTC);
          setterName = millisecondsSetterName(isUTC);
          break;
      }
      addTicksInSpan(interval, startTick, endTick, getterName, setterName, isDate, newAddedTicks);
      if (unitName === "year" && levelTicks2.length > 1 && i2 === 0) {
        levelTicks2.unshift({
          value: levelTicks2[0].value - interval
        });
      }
    }
    for (var i2 = 0; i2 < newAddedTicks.length; i2++) {
      levelTicks2.push(newAddedTicks[i2]);
    }
    return newAddedTicks;
  }
  var levelsTicks = [];
  var currentLevelTicks = [];
  var tickCount = 0;
  var lastLevelTickCount = 0;
  for (var i = 0; i < unitNames.length && iter++ < safeLimit; ++i) {
    var primaryTimeUnit = getPrimaryTimeUnit(unitNames[i]);
    if (!isPrimaryTimeUnit(unitNames[i])) {
      continue;
    }
    addLevelTicks(unitNames[i], levelsTicks[levelsTicks.length - 1] || [], currentLevelTicks);
    var nextPrimaryTimeUnit = unitNames[i + 1] ? getPrimaryTimeUnit(unitNames[i + 1]) : null;
    if (primaryTimeUnit !== nextPrimaryTimeUnit) {
      if (currentLevelTicks.length) {
        lastLevelTickCount = tickCount;
        currentLevelTicks.sort(function(a, b2) {
          return a.value - b2.value;
        });
        var levelTicksRemoveDuplicated = [];
        for (var i_1 = 0; i_1 < currentLevelTicks.length; ++i_1) {
          var tickValue = currentLevelTicks[i_1].value;
          if (i_1 === 0 || currentLevelTicks[i_1 - 1].value !== tickValue) {
            levelTicksRemoveDuplicated.push(currentLevelTicks[i_1]);
            if (tickValue >= extent3[0] && tickValue <= extent3[1]) {
              tickCount++;
            }
          }
        }
        var targetTickNum = (extent3[1] - extent3[0]) / approxInterval;
        if (tickCount > targetTickNum * 1.5 && lastLevelTickCount > targetTickNum / 1.5) {
          break;
        }
        levelsTicks.push(levelTicksRemoveDuplicated);
        if (tickCount > targetTickNum || bottomUnitName === unitNames[i]) {
          break;
        }
      }
      currentLevelTicks = [];
    }
  }
  var levelsTicksInExtent = filter(map$1(levelsTicks, function(levelTicks2) {
    return filter(levelTicks2, function(tick) {
      return tick.value >= extent3[0] && tick.value <= extent3[1] && !tick.notAdd;
    });
  }), function(levelTicks2) {
    return levelTicks2.length > 0;
  });
  var ticks = [];
  var maxLevel = levelsTicksInExtent.length - 1;
  for (var i = 0; i < levelsTicksInExtent.length; ++i) {
    var levelTicks = levelsTicksInExtent[i];
    for (var k2 = 0; k2 < levelTicks.length; ++k2) {
      ticks.push({
        value: levelTicks[k2].value,
        level: maxLevel - i
      });
    }
  }
  ticks.sort(function(a, b2) {
    return a.value - b2.value;
  });
  var result = [];
  for (var i = 0; i < ticks.length; ++i) {
    if (i === 0 || ticks[i].value !== ticks[i - 1].value) {
      result.push(ticks[i]);
    }
  }
  return result;
}
Scale$1.registerClass(TimeScale);
var TimeScale$1 = TimeScale;
var scaleProto = Scale$1.prototype;
var intervalScaleProto = IntervalScale$1.prototype;
var roundingErrorFix = round$3;
var mathFloor$1 = Math.floor;
var mathCeil$1 = Math.ceil;
var mathPow$1 = Math.pow;
var mathLog$1 = Math.log;
var LogScale = function(_super) {
  __extends(LogScale2, _super);
  function LogScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "log";
    _this.base = 10;
    _this._originalScale = new IntervalScale$1();
    _this._interval = 0;
    return _this;
  }
  LogScale2.prototype.getTicks = function(expandToNicedExtent) {
    var originalScale = this._originalScale;
    var extent3 = this._extent;
    var originalExtent = originalScale.getExtent();
    var ticks = intervalScaleProto.getTicks.call(this, expandToNicedExtent);
    return map$1(ticks, function(tick) {
      var val = tick.value;
      var powVal = round$3(mathPow$1(this.base, val));
      powVal = val === extent3[0] && this._fixMin ? fixRoundingError(powVal, originalExtent[0]) : powVal;
      powVal = val === extent3[1] && this._fixMax ? fixRoundingError(powVal, originalExtent[1]) : powVal;
      return {
        value: powVal
      };
    }, this);
  };
  LogScale2.prototype.setExtent = function(start2, end2) {
    var base2 = this.base;
    start2 = mathLog$1(start2) / mathLog$1(base2);
    end2 = mathLog$1(end2) / mathLog$1(base2);
    intervalScaleProto.setExtent.call(this, start2, end2);
  };
  LogScale2.prototype.getExtent = function() {
    var base2 = this.base;
    var extent3 = scaleProto.getExtent.call(this);
    extent3[0] = mathPow$1(base2, extent3[0]);
    extent3[1] = mathPow$1(base2, extent3[1]);
    var originalScale = this._originalScale;
    var originalExtent = originalScale.getExtent();
    this._fixMin && (extent3[0] = fixRoundingError(extent3[0], originalExtent[0]));
    this._fixMax && (extent3[1] = fixRoundingError(extent3[1], originalExtent[1]));
    return extent3;
  };
  LogScale2.prototype.unionExtent = function(extent3) {
    this._originalScale.unionExtent(extent3);
    var base2 = this.base;
    extent3[0] = mathLog$1(extent3[0]) / mathLog$1(base2);
    extent3[1] = mathLog$1(extent3[1]) / mathLog$1(base2);
    scaleProto.unionExtent.call(this, extent3);
  };
  LogScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  LogScale2.prototype.calcNiceTicks = function(approxTickNum) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (span === Infinity || span <= 0) {
      return;
    }
    var interval = quantity(span);
    var err = approxTickNum / span * interval;
    if (err <= 0.5) {
      interval *= 10;
    }
    while (!isNaN(interval) && Math.abs(interval) < 1 && Math.abs(interval) > 0) {
      interval *= 10;
    }
    var niceExtent = [round$3(mathCeil$1(extent3[0] / interval) * interval), round$3(mathFloor$1(extent3[1] / interval) * interval)];
    this._interval = interval;
    this._niceExtent = niceExtent;
  };
  LogScale2.prototype.calcNiceExtent = function(opt) {
    intervalScaleProto.calcNiceExtent.call(this, opt);
    this._fixMin = opt.fixMin;
    this._fixMax = opt.fixMax;
  };
  LogScale2.prototype.parse = function(val) {
    return val;
  };
  LogScale2.prototype.contain = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return contain$1(val, this._extent);
  };
  LogScale2.prototype.normalize = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return normalize$3(val, this._extent);
  };
  LogScale2.prototype.scale = function(val) {
    val = scale(val, this._extent);
    return mathPow$1(this.base, val);
  };
  LogScale2.type = "log";
  return LogScale2;
}(Scale$1);
var proto = LogScale.prototype;
proto.getMinorTicks = intervalScaleProto.getMinorTicks;
proto.getLabel = intervalScaleProto.getLabel;
function fixRoundingError(val, originalVal) {
  return roundingErrorFix(val, getPrecision(originalVal));
}
Scale$1.registerClass(LogScale);
var LogScale$1 = LogScale;
var ScaleRawExtentInfo = function() {
  function ScaleRawExtentInfo2(scale2, model, originalExtent) {
    this._prepareParams(scale2, model, originalExtent);
  }
  ScaleRawExtentInfo2.prototype._prepareParams = function(scale2, model, dataExtent) {
    if (dataExtent[1] < dataExtent[0]) {
      dataExtent = [NaN, NaN];
    }
    this._dataMin = dataExtent[0];
    this._dataMax = dataExtent[1];
    var isOrdinal = this._isOrdinal = scale2.type === "ordinal";
    this._needCrossZero = scale2.type === "interval" && model.getNeedCrossZero && model.getNeedCrossZero();
    var modelMinRaw = this._modelMinRaw = model.get("min", true);
    if (isFunction(modelMinRaw)) {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMinRaw !== "dataMin") {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw);
    }
    var modelMaxRaw = this._modelMaxRaw = model.get("max", true);
    if (isFunction(modelMaxRaw)) {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMaxRaw !== "dataMax") {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw);
    }
    if (isOrdinal) {
      this._axisDataLen = model.getCategories().length;
    } else {
      var boundaryGap = model.get("boundaryGap");
      var boundaryGapArr = isArray$1(boundaryGap) ? boundaryGap : [boundaryGap || 0, boundaryGap || 0];
      if (typeof boundaryGapArr[0] === "boolean" || typeof boundaryGapArr[1] === "boolean") {
        this._boundaryGapInner = [0, 0];
      } else {
        this._boundaryGapInner = [parsePercent$1(boundaryGapArr[0], 1), parsePercent$1(boundaryGapArr[1], 1)];
      }
    }
  };
  ScaleRawExtentInfo2.prototype.calculate = function() {
    var isOrdinal = this._isOrdinal;
    var dataMin = this._dataMin;
    var dataMax = this._dataMax;
    var axisDataLen = this._axisDataLen;
    var boundaryGapInner = this._boundaryGapInner;
    var span = !isOrdinal ? dataMax - dataMin || Math.abs(dataMin) : null;
    var min3 = this._modelMinRaw === "dataMin" ? dataMin : this._modelMinNum;
    var max3 = this._modelMaxRaw === "dataMax" ? dataMax : this._modelMaxNum;
    var minFixed = min3 != null;
    var maxFixed = max3 != null;
    if (min3 == null) {
      min3 = isOrdinal ? axisDataLen ? 0 : NaN : dataMin - boundaryGapInner[0] * span;
    }
    if (max3 == null) {
      max3 = isOrdinal ? axisDataLen ? axisDataLen - 1 : NaN : dataMax + boundaryGapInner[1] * span;
    }
    (min3 == null || !isFinite(min3)) && (min3 = NaN);
    (max3 == null || !isFinite(max3)) && (max3 = NaN);
    var isBlank = eqNaN(min3) || eqNaN(max3) || isOrdinal && !axisDataLen;
    if (this._needCrossZero) {
      if (min3 > 0 && max3 > 0 && !minFixed) {
        min3 = 0;
      }
      if (min3 < 0 && max3 < 0 && !maxFixed) {
        max3 = 0;
      }
    }
    var determinedMin = this._determinedMin;
    var determinedMax = this._determinedMax;
    if (determinedMin != null) {
      min3 = determinedMin;
      minFixed = true;
    }
    if (determinedMax != null) {
      max3 = determinedMax;
      maxFixed = true;
    }
    return {
      min: min3,
      max: max3,
      minFixed,
      maxFixed,
      isBlank
    };
  };
  ScaleRawExtentInfo2.prototype.modifyDataMinMax = function(minMaxName, val) {
    this[DATA_MIN_MAX_ATTR[minMaxName]] = val;
  };
  ScaleRawExtentInfo2.prototype.setDeterminedMinMax = function(minMaxName, val) {
    var attr = DETERMINED_MIN_MAX_ATTR[minMaxName];
    this[attr] = val;
  };
  ScaleRawExtentInfo2.prototype.freeze = function() {
    this.frozen = true;
  };
  return ScaleRawExtentInfo2;
}();
var DETERMINED_MIN_MAX_ATTR = {
  min: "_determinedMin",
  max: "_determinedMax"
};
var DATA_MIN_MAX_ATTR = {
  min: "_dataMin",
  max: "_dataMax"
};
function ensureScaleRawExtentInfo(scale2, model, originalExtent) {
  var rawExtentInfo = scale2.rawExtentInfo;
  if (rawExtentInfo) {
    return rawExtentInfo;
  }
  rawExtentInfo = new ScaleRawExtentInfo(scale2, model, originalExtent);
  scale2.rawExtentInfo = rawExtentInfo;
  return rawExtentInfo;
}
function parseAxisModelMinMax(scale2, minMax) {
  return minMax == null ? null : eqNaN(minMax) ? NaN : scale2.parse(minMax);
}
function getScaleExtent(scale2, model) {
  var scaleType = scale2.type;
  var rawExtentResult = ensureScaleRawExtentInfo(scale2, model, scale2.getExtent()).calculate();
  scale2.setBlank(rawExtentResult.isBlank);
  var min3 = rawExtentResult.min;
  var max3 = rawExtentResult.max;
  var ecModel = model.ecModel;
  if (ecModel && scaleType === "time") {
    var barSeriesModels = prepareLayoutBarSeries("bar", ecModel);
    var isBaseAxisAndHasBarSeries_1 = false;
    each$g(barSeriesModels, function(seriesModel) {
      isBaseAxisAndHasBarSeries_1 = isBaseAxisAndHasBarSeries_1 || seriesModel.getBaseAxis() === model.axis;
    });
    if (isBaseAxisAndHasBarSeries_1) {
      var barWidthAndOffset = makeColumnLayout(barSeriesModels);
      var adjustedScale = adjustScaleForOverflow(min3, max3, model, barWidthAndOffset);
      min3 = adjustedScale.min;
      max3 = adjustedScale.max;
    }
  }
  return {
    extent: [min3, max3],
    fixMin: rawExtentResult.minFixed,
    fixMax: rawExtentResult.maxFixed
  };
}
function adjustScaleForOverflow(min3, max3, model, barWidthAndOffset) {
  var axisExtent = model.axis.getExtent();
  var axisLength = axisExtent[1] - axisExtent[0];
  var barsOnCurrentAxis = retrieveColumnLayout(barWidthAndOffset, model.axis);
  if (barsOnCurrentAxis === void 0) {
    return {
      min: min3,
      max: max3
    };
  }
  var minOverflow = Infinity;
  each$g(barsOnCurrentAxis, function(item) {
    minOverflow = Math.min(item.offset, minOverflow);
  });
  var maxOverflow = -Infinity;
  each$g(barsOnCurrentAxis, function(item) {
    maxOverflow = Math.max(item.offset + item.width, maxOverflow);
  });
  minOverflow = Math.abs(minOverflow);
  maxOverflow = Math.abs(maxOverflow);
  var totalOverFlow = minOverflow + maxOverflow;
  var oldRange = max3 - min3;
  var oldRangePercentOfNew = 1 - (minOverflow + maxOverflow) / axisLength;
  var overflowBuffer = oldRange / oldRangePercentOfNew - oldRange;
  max3 += overflowBuffer * (maxOverflow / totalOverFlow);
  min3 -= overflowBuffer * (minOverflow / totalOverFlow);
  return {
    min: min3,
    max: max3
  };
}
function niceScaleExtent(scale2, inModel) {
  var model = inModel;
  var extentInfo = getScaleExtent(scale2, model);
  var extent3 = extentInfo.extent;
  var splitNumber = model.get("splitNumber");
  if (scale2 instanceof LogScale$1) {
    scale2.base = model.get("logBase");
  }
  var scaleType = scale2.type;
  var interval = model.get("interval");
  var isIntervalOrTime = scaleType === "interval" || scaleType === "time";
  scale2.setExtent(extent3[0], extent3[1]);
  scale2.calcNiceExtent({
    splitNumber,
    fixMin: extentInfo.fixMin,
    fixMax: extentInfo.fixMax,
    minInterval: isIntervalOrTime ? model.get("minInterval") : null,
    maxInterval: isIntervalOrTime ? model.get("maxInterval") : null
  });
  if (interval != null) {
    scale2.setInterval && scale2.setInterval(interval);
  }
}
function createScaleByModel$1(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getOrdinalMeta ? model.getOrdinalMeta() : model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new (Scale$1.getClass(axisType) || IntervalScale$1)();
    }
  }
}
function ifAxisCrossZero(axis) {
  var dataExtent = axis.scale.getExtent();
  var min3 = dataExtent[0];
  var max3 = dataExtent[1];
  return !(min3 > 0 && max3 > 0 || min3 < 0 && max3 < 0);
}
function makeLabelFormatter(axis) {
  var labelFormatter = axis.getLabelModel().get("formatter");
  var categoryTickStart = axis.type === "category" ? axis.scale.getExtent()[0] : null;
  if (axis.scale.type === "time") {
    return function(tpl) {
      return function(tick, idx) {
        return axis.scale.getFormattedLabel(tick, idx, tpl);
      };
    }(labelFormatter);
  } else if (isString$1(labelFormatter)) {
    return function(tpl) {
      return function(tick) {
        var label = axis.scale.getLabel(tick);
        var text = tpl.replace("{value}", label != null ? label : "");
        return text;
      };
    }(labelFormatter);
  } else if (isFunction(labelFormatter)) {
    return function(cb2) {
      return function(tick, idx) {
        if (categoryTickStart != null) {
          idx = tick.value - categoryTickStart;
        }
        return cb2(getAxisRawValue(axis, tick), idx, tick.level != null ? {
          level: tick.level
        } : null);
      };
    }(labelFormatter);
  } else {
    return function(tick) {
      return axis.scale.getLabel(tick);
    };
  }
}
function getAxisRawValue(axis, tick) {
  return axis.type === "category" ? axis.scale.getLabel(tick) : tick.value;
}
function estimateLabelUnionRect(axis) {
  var axisModel = axis.model;
  var scale2 = axis.scale;
  if (!axisModel.get(["axisLabel", "show"]) || scale2.isBlank()) {
    return;
  }
  var realNumberScaleTicks;
  var tickCount;
  var categoryScaleExtent = scale2.getExtent();
  if (scale2 instanceof OrdinalScale$1) {
    tickCount = scale2.count();
  } else {
    realNumberScaleTicks = scale2.getTicks();
    tickCount = realNumberScaleTicks.length;
  }
  var axisLabelModel = axis.getLabelModel();
  var labelFormatter = makeLabelFormatter(axis);
  var rect;
  var step = 1;
  if (tickCount > 40) {
    step = Math.ceil(tickCount / 40);
  }
  for (var i = 0; i < tickCount; i += step) {
    var tick = realNumberScaleTicks ? realNumberScaleTicks[i] : {
      value: categoryScaleExtent[0] + i
    };
    var label = labelFormatter(tick, i);
    var unrotatedSingleRect = axisLabelModel.getTextRect(label);
    var singleRect = rotateTextRect(unrotatedSingleRect, axisLabelModel.get("rotate") || 0);
    rect ? rect.union(singleRect) : rect = singleRect;
  }
  return rect;
}
function rotateTextRect(textRect, rotate2) {
  var rotateRadians = rotate2 * Math.PI / 180;
  var beforeWidth = textRect.width;
  var beforeHeight = textRect.height;
  var afterWidth = beforeWidth * Math.abs(Math.cos(rotateRadians)) + Math.abs(beforeHeight * Math.sin(rotateRadians));
  var afterHeight = beforeWidth * Math.abs(Math.sin(rotateRadians)) + Math.abs(beforeHeight * Math.cos(rotateRadians));
  var rotatedRect = new BoundingRect$1(textRect.x, textRect.y, afterWidth, afterHeight);
  return rotatedRect;
}
function getOptionCategoryInterval(model) {
  var interval = model.get("interval");
  return interval == null ? "auto" : interval;
}
function shouldShowAllLabels(axis) {
  return axis.type === "category" && getOptionCategoryInterval(axis.getLabelModel()) === 0;
}
function getDataDimensionsOnAxis(data, axisDim) {
  var dataDimMap = {};
  each$g(data.mapDimensionsAll(axisDim), function(dataDim) {
    dataDimMap[getStackedDimension(data, dataDim)] = true;
  });
  return keys(dataDimMap);
}
function unionAxisExtentFromData(dataExtent, data, axisDim) {
  if (data) {
    each$g(getDataDimensionsOnAxis(data, axisDim), function(dim) {
      var seriesExtent = data.getApproximateExtent(dim);
      seriesExtent[0] < dataExtent[0] && (dataExtent[0] = seriesExtent[0]);
      seriesExtent[1] > dataExtent[1] && (dataExtent[1] = seriesExtent[1]);
    });
  }
}
var AxisModelCommonMixin = function() {
  function AxisModelCommonMixin2() {
  }
  AxisModelCommonMixin2.prototype.getNeedCrossZero = function() {
    var option = this.option;
    return !option.scale;
  };
  AxisModelCommonMixin2.prototype.getCoordSysModel = function() {
    return;
  };
  return AxisModelCommonMixin2;
}();
var EPSILON = 1e-8;
function isAroundEqual(a, b2) {
  return Math.abs(a - b2) < EPSILON;
}
function contain(points2, x2, y2) {
  var w2 = 0;
  var p2 = points2[0];
  if (!p2) {
    return false;
  }
  for (var i = 1; i < points2.length; i++) {
    var p22 = points2[i];
    w2 += windingLine(p2[0], p2[1], p22[0], p22[1], x2, y2);
    p2 = p22;
  }
  var p0 = points2[0];
  if (!isAroundEqual(p2[0], p0[0]) || !isAroundEqual(p2[1], p0[1])) {
    w2 += windingLine(p2[0], p2[1], p0[0], p0[1], x2, y2);
  }
  return w2 !== 0;
}
var TMP_TRANSFORM = [];
function transformPoints(points2, transform2) {
  for (var p2 = 0; p2 < points2.length; p2++) {
    applyTransform$1(points2[p2], points2[p2], transform2);
  }
}
function updateBBoxFromPoints(points2, min3, max3, projection) {
  for (var i = 0; i < points2.length; i++) {
    var p2 = points2[i];
    if (projection) {
      p2 = projection.project(p2);
    }
    if (p2 && isFinite(p2[0]) && isFinite(p2[1])) {
      min$1(min3, min3, p2);
      max$1(max3, max3, p2);
    }
  }
}
function centroid$1(points2) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = points2.length;
  var x0 = points2[len2 - 1][0];
  var y0 = points2[len2 - 1][1];
  for (var i = 0; i < len2; i++) {
    var x1 = points2[i][0];
    var y1 = points2[i][1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
    x0 = x1;
    y0 = y1;
  }
  return signedArea ? [cx / signedArea / 3, cy / signedArea / 3, signedArea] : [points2[0][0] || 0, points2[0][1] || 0];
}
var Region = function() {
  function Region2(name) {
    this.name = name;
  }
  Region2.prototype.setCenter = function(center2) {
    this._center = center2;
  };
  Region2.prototype.getCenter = function() {
    var center2 = this._center;
    if (!center2) {
      center2 = this._center = this.calcCenter();
    }
    return center2;
  };
  return Region2;
}();
var GeoJSONPolygonGeometry = function() {
  function GeoJSONPolygonGeometry2(exterior, interiors) {
    this.type = "polygon";
    this.exterior = exterior;
    this.interiors = interiors;
  }
  return GeoJSONPolygonGeometry2;
}();
var GeoJSONLineStringGeometry = function() {
  function GeoJSONLineStringGeometry2(points2) {
    this.type = "linestring";
    this.points = points2;
  }
  return GeoJSONLineStringGeometry2;
}();
var GeoJSONRegion = function(_super) {
  __extends(GeoJSONRegion2, _super);
  function GeoJSONRegion2(name, geometries, cp) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoJSON";
    _this.geometries = geometries;
    _this._center = cp && [cp[0], cp[1]];
    return _this;
  }
  GeoJSONRegion2.prototype.calcCenter = function() {
    var geometries = this.geometries;
    var largestGeo;
    var largestGeoSize = 0;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      var exterior = geo.exterior;
      var size = exterior && exterior.length;
      if (size > largestGeoSize) {
        largestGeo = geo;
        largestGeoSize = size;
      }
    }
    if (largestGeo) {
      return centroid$1(largestGeo.exterior);
    }
    var rect = this.getBoundingRect();
    return [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.getBoundingRect = function(projection) {
    var rect = this._rect;
    if (rect && !projection) {
      return rect;
    }
    var min3 = [Infinity, Infinity];
    var max3 = [-Infinity, -Infinity];
    var geometries = this.geometries;
    each$g(geometries, function(geo) {
      if (geo.type === "polygon") {
        updateBBoxFromPoints(geo.exterior, min3, max3, projection);
      } else {
        each$g(geo.points, function(points2) {
          updateBBoxFromPoints(points2, min3, max3, projection);
        });
      }
    });
    if (!(isFinite(min3[0]) && isFinite(min3[1]) && isFinite(max3[0]) && isFinite(max3[1]))) {
      min3[0] = min3[1] = max3[0] = max3[1] = 0;
    }
    rect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    if (!projection) {
      this._rect = rect;
    }
    return rect;
  };
  GeoJSONRegion2.prototype.contain = function(coord) {
    var rect = this.getBoundingRect();
    var geometries = this.geometries;
    if (!rect.contain(coord[0], coord[1])) {
      return false;
    }
    loopGeo:
      for (var i = 0, len2 = geometries.length; i < len2; i++) {
        var geo = geometries[i];
        if (geo.type !== "polygon") {
          continue;
        }
        var exterior = geo.exterior;
        var interiors = geo.interiors;
        if (contain(exterior, coord[0], coord[1])) {
          for (var k2 = 0; k2 < (interiors ? interiors.length : 0); k2++) {
            if (contain(interiors[k2], coord[0], coord[1])) {
              continue loopGeo;
            }
          }
          return true;
        }
      }
    return false;
  };
  GeoJSONRegion2.prototype.transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var aspect = rect.width / rect.height;
    if (!width) {
      width = aspect * height;
    } else if (!height) {
      height = width / aspect;
    }
    var target = new BoundingRect$1(x2, y2, width, height);
    var transform2 = rect.calculateTransform(target);
    var geometries = this.geometries;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      if (geo.type === "polygon") {
        transformPoints(geo.exterior, transform2);
        each$g(geo.interiors, function(interior) {
          transformPoints(interior, transform2);
        });
      } else {
        each$g(geo.points, function(points2) {
          transformPoints(points2, transform2);
        });
      }
    }
    rect = this._rect;
    rect.copy(target);
    this._center = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.cloneShallow = function(name) {
    name == null && (name = this.name);
    var newRegion = new GeoJSONRegion2(name, this.geometries, this._center);
    newRegion._rect = this._rect;
    newRegion.transformTo = null;
    return newRegion;
  };
  return GeoJSONRegion2;
}(Region);
var GeoSVGRegion = function(_super) {
  __extends(GeoSVGRegion2, _super);
  function GeoSVGRegion2(name, elOnlyForCalculate) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoSVG";
    _this._elOnlyForCalculate = elOnlyForCalculate;
    return _this;
  }
  GeoSVGRegion2.prototype.calcCenter = function() {
    var el = this._elOnlyForCalculate;
    var rect = el.getBoundingRect();
    var center2 = [rect.x + rect.width / 2, rect.y + rect.height / 2];
    var mat = identity(TMP_TRANSFORM);
    var target = el;
    while (target && !target.isGeoSVGGraphicRoot) {
      mul(mat, target.getLocalTransform(), mat);
      target = target.parent;
    }
    invert(mat, mat);
    applyTransform$1(center2, center2, mat);
    return center2;
  };
  return GeoSVGRegion2;
}(Region);
function decode(json) {
  if (!json.UTF8Encoding) {
    return json;
  }
  var jsonCompressed = json;
  var encodeScale = jsonCompressed.UTF8Scale;
  if (encodeScale == null) {
    encodeScale = 1024;
  }
  var features2 = jsonCompressed.features;
  each$g(features2, function(feature) {
    var geometry = feature.geometry;
    var encodeOffsets = geometry.encodeOffsets;
    var coordinates = geometry.coordinates;
    if (!encodeOffsets) {
      return;
    }
    switch (geometry.type) {
      case "LineString":
        geometry.coordinates = decodeRing(coordinates, encodeOffsets, encodeScale);
        break;
      case "Polygon":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiLineString":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiPolygon":
        each$g(coordinates, function(rings, idx) {
          return decodeRings(rings, encodeOffsets[idx], encodeScale);
        });
    }
  });
  jsonCompressed.UTF8Encoding = false;
  return jsonCompressed;
}
function decodeRings(rings, encodeOffsets, encodeScale) {
  for (var c2 = 0; c2 < rings.length; c2++) {
    rings[c2] = decodeRing(rings[c2], encodeOffsets[c2], encodeScale);
  }
}
function decodeRing(coordinate, encodeOffsets, encodeScale) {
  var result = [];
  var prevX = encodeOffsets[0];
  var prevY = encodeOffsets[1];
  for (var i = 0; i < coordinate.length; i += 2) {
    var x2 = coordinate.charCodeAt(i) - 64;
    var y2 = coordinate.charCodeAt(i + 1) - 64;
    x2 = x2 >> 1 ^ -(x2 & 1);
    y2 = y2 >> 1 ^ -(y2 & 1);
    x2 += prevX;
    y2 += prevY;
    prevX = x2;
    prevY = y2;
    result.push([x2 / encodeScale, y2 / encodeScale]);
  }
  return result;
}
function parseGeoJSON(geoJson, nameProperty) {
  geoJson = decode(geoJson);
  return map$1(filter(geoJson.features, function(featureObj) {
    return featureObj.geometry && featureObj.properties && featureObj.geometry.coordinates.length > 0;
  }), function(featureObj) {
    var properties = featureObj.properties;
    var geo = featureObj.geometry;
    var geometries = [];
    switch (geo.type) {
      case "Polygon":
        var coordinates = geo.coordinates;
        geometries.push(new GeoJSONPolygonGeometry(coordinates[0], coordinates.slice(1)));
        break;
      case "MultiPolygon":
        each$g(geo.coordinates, function(item) {
          if (item[0]) {
            geometries.push(new GeoJSONPolygonGeometry(item[0], item.slice(1)));
          }
        });
        break;
      case "LineString":
        geometries.push(new GeoJSONLineStringGeometry([geo.coordinates]));
        break;
      case "MultiLineString":
        geometries.push(new GeoJSONLineStringGeometry(geo.coordinates));
    }
    var region = new GeoJSONRegion(properties[nameProperty || "name"], geometries, properties.cp);
    region.properties = properties;
    return region;
  });
}
var inner$g = makeInner();
function createAxisLabels(axis) {
  return axis.type === "category" ? makeCategoryLabels(axis) : makeRealNumberLabels(axis);
}
function createAxisTicks(axis, tickModel) {
  return axis.type === "category" ? makeCategoryTicks(axis, tickModel) : {
    ticks: map$1(axis.scale.getTicks(), function(tick) {
      return tick.value;
    })
  };
}
function makeCategoryLabels(axis) {
  var labelModel = axis.getLabelModel();
  var result = makeCategoryLabelsActually(axis, labelModel);
  return !labelModel.get("show") || axis.scale.isBlank() ? {
    labels: [],
    labelCategoryInterval: result.labelCategoryInterval
  } : result;
}
function makeCategoryLabelsActually(axis, labelModel) {
  var labelsCache = getListCache(axis, "labels");
  var optionLabelInterval = getOptionCategoryInterval(labelModel);
  var result = listCacheGet(labelsCache, optionLabelInterval);
  if (result) {
    return result;
  }
  var labels;
  var numericLabelInterval;
  if (isFunction(optionLabelInterval)) {
    labels = makeLabelsByCustomizedCategoryInterval(axis, optionLabelInterval);
  } else {
    numericLabelInterval = optionLabelInterval === "auto" ? makeAutoCategoryInterval(axis) : optionLabelInterval;
    labels = makeLabelsByNumericCategoryInterval(axis, numericLabelInterval);
  }
  return listCacheSet(labelsCache, optionLabelInterval, {
    labels,
    labelCategoryInterval: numericLabelInterval
  });
}
function makeCategoryTicks(axis, tickModel) {
  var ticksCache = getListCache(axis, "ticks");
  var optionTickInterval = getOptionCategoryInterval(tickModel);
  var result = listCacheGet(ticksCache, optionTickInterval);
  if (result) {
    return result;
  }
  var ticks;
  var tickCategoryInterval;
  if (!tickModel.get("show") || axis.scale.isBlank()) {
    ticks = [];
  }
  if (isFunction(optionTickInterval)) {
    ticks = makeLabelsByCustomizedCategoryInterval(axis, optionTickInterval, true);
  } else if (optionTickInterval === "auto") {
    var labelsResult = makeCategoryLabelsActually(axis, axis.getLabelModel());
    tickCategoryInterval = labelsResult.labelCategoryInterval;
    ticks = map$1(labelsResult.labels, function(labelItem) {
      return labelItem.tickValue;
    });
  } else {
    tickCategoryInterval = optionTickInterval;
    ticks = makeLabelsByNumericCategoryInterval(axis, tickCategoryInterval, true);
  }
  return listCacheSet(ticksCache, optionTickInterval, {
    ticks,
    tickCategoryInterval
  });
}
function makeRealNumberLabels(axis) {
  var ticks = axis.scale.getTicks();
  var labelFormatter = makeLabelFormatter(axis);
  return {
    labels: map$1(ticks, function(tick, idx) {
      return {
        level: tick.level,
        formattedLabel: labelFormatter(tick, idx),
        rawLabel: axis.scale.getLabel(tick),
        tickValue: tick.value
      };
    })
  };
}
function getListCache(axis, prop) {
  return inner$g(axis)[prop] || (inner$g(axis)[prop] = []);
}
function listCacheGet(cache, key) {
  for (var i = 0; i < cache.length; i++) {
    if (cache[i].key === key) {
      return cache[i].value;
    }
  }
}
function listCacheSet(cache, key, value) {
  cache.push({
    key,
    value
  });
  return value;
}
function makeAutoCategoryInterval(axis) {
  var result = inner$g(axis).autoInterval;
  return result != null ? result : inner$g(axis).autoInterval = axis.calculateCategoryInterval();
}
function calculateCategoryInterval(axis) {
  var params = fetchAutoCategoryIntervalCalculationParams(axis);
  var labelFormatter = makeLabelFormatter(axis);
  var rotation = (params.axisRotate - params.labelRotate) / 180 * Math.PI;
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var tickCount = ordinalScale.count();
  if (ordinalExtent[1] - ordinalExtent[0] < 1) {
    return 0;
  }
  var step = 1;
  if (tickCount > 40) {
    step = Math.max(1, Math.floor(tickCount / 40));
  }
  var tickValue = ordinalExtent[0];
  var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
  var unitW = Math.abs(unitSpan * Math.cos(rotation));
  var unitH = Math.abs(unitSpan * Math.sin(rotation));
  var maxW = 0;
  var maxH = 0;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    var width = 0;
    var height = 0;
    var rect = getBoundingRect(labelFormatter({
      value: tickValue
    }), params.font, "center", "top");
    width = rect.width * 1.3;
    height = rect.height * 1.3;
    maxW = Math.max(maxW, width, 7);
    maxH = Math.max(maxH, height, 7);
  }
  var dw = maxW / unitW;
  var dh2 = maxH / unitH;
  isNaN(dw) && (dw = Infinity);
  isNaN(dh2) && (dh2 = Infinity);
  var interval = Math.max(0, Math.floor(Math.min(dw, dh2)));
  var cache = inner$g(axis.model);
  var axisExtent = axis.getExtent();
  var lastAutoInterval = cache.lastAutoInterval;
  var lastTickCount = cache.lastTickCount;
  if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval && cache.axisExtent0 === axisExtent[0] && cache.axisExtent1 === axisExtent[1]) {
    interval = lastAutoInterval;
  } else {
    cache.lastTickCount = tickCount;
    cache.lastAutoInterval = interval;
    cache.axisExtent0 = axisExtent[0];
    cache.axisExtent1 = axisExtent[1];
  }
  return interval;
}
function fetchAutoCategoryIntervalCalculationParams(axis) {
  var labelModel = axis.getLabelModel();
  return {
    axisRotate: axis.getRotate ? axis.getRotate() : axis.isHorizontal && !axis.isHorizontal() ? 90 : 0,
    labelRotate: labelModel.get("rotate") || 0,
    font: labelModel.getFont()
  };
}
function makeLabelsByNumericCategoryInterval(axis, categoryInterval, onlyTick) {
  var labelFormatter = makeLabelFormatter(axis);
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var labelModel = axis.getLabelModel();
  var result = [];
  var step = Math.max((categoryInterval || 0) + 1, 1);
  var startTick = ordinalExtent[0];
  var tickCount = ordinalScale.count();
  if (startTick !== 0 && step > 1 && tickCount / step > 2) {
    startTick = Math.round(Math.ceil(startTick / step) * step);
  }
  var showAllLabel = shouldShowAllLabels(axis);
  var includeMinLabel = labelModel.get("showMinLabel") || showAllLabel;
  var includeMaxLabel = labelModel.get("showMaxLabel") || showAllLabel;
  if (includeMinLabel && startTick !== ordinalExtent[0]) {
    addItem(ordinalExtent[0]);
  }
  var tickValue = startTick;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    addItem(tickValue);
  }
  if (includeMaxLabel && tickValue - step !== ordinalExtent[1]) {
    addItem(ordinalExtent[1]);
  }
  function addItem(tickValue2) {
    var tickObj = {
      value: tickValue2
    };
    result.push(onlyTick ? tickValue2 : {
      formattedLabel: labelFormatter(tickObj),
      rawLabel: ordinalScale.getLabel(tickObj),
      tickValue: tickValue2
    });
  }
  return result;
}
function makeLabelsByCustomizedCategoryInterval(axis, categoryInterval, onlyTick) {
  var ordinalScale = axis.scale;
  var labelFormatter = makeLabelFormatter(axis);
  var result = [];
  each$g(ordinalScale.getTicks(), function(tick) {
    var rawLabel = ordinalScale.getLabel(tick);
    var tickValue = tick.value;
    if (categoryInterval(tick.value, rawLabel)) {
      result.push(onlyTick ? tickValue : {
        formattedLabel: labelFormatter(tick),
        rawLabel,
        tickValue
      });
    }
  });
  return result;
}
var NORMALIZED_EXTENT = [0, 1];
var Axis = function() {
  function Axis2(dim, scale2, extent3) {
    this.onBand = false;
    this.inverse = false;
    this.dim = dim;
    this.scale = scale2;
    this._extent = extent3 || [0, 0];
  }
  Axis2.prototype.contain = function(coord) {
    var extent3 = this._extent;
    var min3 = Math.min(extent3[0], extent3[1]);
    var max3 = Math.max(extent3[0], extent3[1]);
    return coord >= min3 && coord <= max3;
  };
  Axis2.prototype.containData = function(data) {
    return this.scale.contain(data);
  };
  Axis2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Axis2.prototype.getPixelPrecision = function(dataExtent) {
    return getPixelPrecision(dataExtent || this.scale.getExtent(), this._extent);
  };
  Axis2.prototype.setExtent = function(start2, end2) {
    var extent3 = this._extent;
    extent3[0] = start2;
    extent3[1] = end2;
  };
  Axis2.prototype.dataToCoord = function(data, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    data = scale2.normalize(data);
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    return linearMap$2(data, NORMALIZED_EXTENT, extent3, clamp2);
  };
  Axis2.prototype.coordToData = function(coord, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    var t2 = linearMap$2(coord, extent3, NORMALIZED_EXTENT, clamp2);
    return this.scale.scale(t2);
  };
  Axis2.prototype.pointToData = function(point, clamp2) {
    return;
  };
  Axis2.prototype.getTicksCoords = function(opt) {
    opt = opt || {};
    var tickModel = opt.tickModel || this.getTickModel();
    var result = createAxisTicks(this, tickModel);
    var ticks = result.ticks;
    var ticksCoords = map$1(ticks, function(tickVal) {
      return {
        coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(tickVal) : tickVal),
        tickValue: tickVal
      };
    }, this);
    var alignWithLabel = tickModel.get("alignWithLabel");
    fixOnBandTicksCoords(this, ticksCoords, alignWithLabel, opt.clamp);
    return ticksCoords;
  };
  Axis2.prototype.getMinorTicksCoords = function() {
    if (this.scale.type === "ordinal") {
      return [];
    }
    var minorTickModel = this.model.getModel("minorTick");
    var splitNumber = minorTickModel.get("splitNumber");
    if (!(splitNumber > 0 && splitNumber < 100)) {
      splitNumber = 5;
    }
    var minorTicks = this.scale.getMinorTicks(splitNumber);
    var minorTicksCoords = map$1(minorTicks, function(minorTicksGroup) {
      return map$1(minorTicksGroup, function(minorTick) {
        return {
          coord: this.dataToCoord(minorTick),
          tickValue: minorTick
        };
      }, this);
    }, this);
    return minorTicksCoords;
  };
  Axis2.prototype.getViewLabels = function() {
    return createAxisLabels(this).labels;
  };
  Axis2.prototype.getLabelModel = function() {
    return this.model.getModel("axisLabel");
  };
  Axis2.prototype.getTickModel = function() {
    return this.model.getModel("axisTick");
  };
  Axis2.prototype.getBandWidth = function() {
    var axisExtent = this._extent;
    var dataExtent = this.scale.getExtent();
    var len2 = dataExtent[1] - dataExtent[0] + (this.onBand ? 1 : 0);
    len2 === 0 && (len2 = 1);
    var size = Math.abs(axisExtent[1] - axisExtent[0]);
    return Math.abs(size) / len2;
  };
  Axis2.prototype.calculateCategoryInterval = function() {
    return calculateCategoryInterval(this);
  };
  return Axis2;
}();
function fixExtentWithBands(extent3, nTick) {
  var size = extent3[1] - extent3[0];
  var len2 = nTick;
  var margin = size / len2 / 2;
  extent3[0] += margin;
  extent3[1] -= margin;
}
function fixOnBandTicksCoords(axis, ticksCoords, alignWithLabel, clamp2) {
  var ticksLen = ticksCoords.length;
  if (!axis.onBand || alignWithLabel || !ticksLen) {
    return;
  }
  var axisExtent = axis.getExtent();
  var last;
  var diffSize;
  if (ticksLen === 1) {
    ticksCoords[0].coord = axisExtent[0];
    last = ticksCoords[1] = {
      coord: axisExtent[0]
    };
  } else {
    var crossLen = ticksCoords[ticksLen - 1].tickValue - ticksCoords[0].tickValue;
    var shift_1 = (ticksCoords[ticksLen - 1].coord - ticksCoords[0].coord) / crossLen;
    each$g(ticksCoords, function(ticksItem) {
      ticksItem.coord -= shift_1 / 2;
    });
    var dataExtent = axis.scale.getExtent();
    diffSize = 1 + dataExtent[1] - ticksCoords[ticksLen - 1].tickValue;
    last = {
      coord: ticksCoords[ticksLen - 1].coord + shift_1 * diffSize
    };
    ticksCoords.push(last);
  }
  var inverse = axisExtent[0] > axisExtent[1];
  if (littleThan2(ticksCoords[0].coord, axisExtent[0])) {
    clamp2 ? ticksCoords[0].coord = axisExtent[0] : ticksCoords.shift();
  }
  if (clamp2 && littleThan2(axisExtent[0], ticksCoords[0].coord)) {
    ticksCoords.unshift({
      coord: axisExtent[0]
    });
  }
  if (littleThan2(axisExtent[1], last.coord)) {
    clamp2 ? last.coord = axisExtent[1] : ticksCoords.pop();
  }
  if (clamp2 && littleThan2(last.coord, axisExtent[1])) {
    ticksCoords.push({
      coord: axisExtent[1]
    });
  }
  function littleThan2(a, b2) {
    a = round$3(a);
    b2 = round$3(b2);
    return inverse ? a > b2 : a < b2;
  }
}
var Axis$1 = Axis;
var PI2$3 = Math.PI * 2;
var CMD$1 = PathProxy$1.CMD;
var DEFAULT_SEARCH_SPACE = ["top", "right", "bottom", "left"];
function getCandidateAnchor(pos, distance2, rect, outPt, outDir) {
  var width = rect.width;
  var height = rect.height;
  switch (pos) {
    case "top":
      outPt.set(rect.x + width / 2, rect.y - distance2);
      outDir.set(0, -1);
      break;
    case "bottom":
      outPt.set(rect.x + width / 2, rect.y + height + distance2);
      outDir.set(0, 1);
      break;
    case "left":
      outPt.set(rect.x - distance2, rect.y + height / 2);
      outDir.set(-1, 0);
      break;
    case "right":
      outPt.set(rect.x + width + distance2, rect.y + height / 2);
      outDir.set(1, 0);
      break;
  }
}
function projectPointToArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2, out2) {
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  x2 /= d2;
  y2 /= d2;
  var ox = x2 * r2 + cx;
  var oy = y2 * r2 + cy;
  if (Math.abs(startAngle - endAngle) % PI2$3 < 1e-4) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$3;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$3;
  }
  if (angle >= startAngle && angle <= endAngle || angle + PI2$3 >= startAngle && angle + PI2$3 <= endAngle) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  var x1 = r2 * Math.cos(startAngle) + cx;
  var y1 = r2 * Math.sin(startAngle) + cy;
  var x22 = r2 * Math.cos(endAngle) + cx;
  var y22 = r2 * Math.sin(endAngle) + cy;
  var d1 = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
  var d22 = (x22 - x2) * (x22 - x2) + (y22 - y2) * (y22 - y2);
  if (d1 < d22) {
    out2[0] = x1;
    out2[1] = y1;
    return Math.sqrt(d1);
  } else {
    out2[0] = x22;
    out2[1] = y22;
    return Math.sqrt(d22);
  }
}
function projectPointToLine(x1, y1, x2, y2, x3, y3, out2, limitToEnds) {
  var dx = x3 - x1;
  var dy = y3 - y1;
  var dx1 = x2 - x1;
  var dy1 = y2 - y1;
  var lineLen = Math.sqrt(dx1 * dx1 + dy1 * dy1);
  dx1 /= lineLen;
  dy1 /= lineLen;
  var projectedLen = dx * dx1 + dy * dy1;
  var t2 = projectedLen / lineLen;
  if (limitToEnds) {
    t2 = Math.min(Math.max(t2, 0), 1);
  }
  t2 *= lineLen;
  var ox = out2[0] = x1 + t2 * dx1;
  var oy = out2[1] = y1 + t2 * dy1;
  return Math.sqrt((ox - x3) * (ox - x3) + (oy - y3) * (oy - y3));
}
function projectPointToRect(x1, y1, width, height, x2, y2, out2) {
  if (width < 0) {
    x1 = x1 + width;
    width = -width;
  }
  if (height < 0) {
    y1 = y1 + height;
    height = -height;
  }
  var x22 = x1 + width;
  var y22 = y1 + height;
  var ox = out2[0] = Math.min(Math.max(x2, x1), x22);
  var oy = out2[1] = Math.min(Math.max(y2, y1), y22);
  return Math.sqrt((ox - x2) * (ox - x2) + (oy - y2) * (oy - y2));
}
var tmpPt = [];
function nearestPointOnRect(pt, rect, out2) {
  var dist2 = projectPointToRect(rect.x, rect.y, rect.width, rect.height, pt.x, pt.y, tmpPt);
  out2.set(tmpPt[0], tmpPt[1]);
  return dist2;
}
function nearestPointOnPath(pt, path, out2) {
  var xi2 = 0;
  var yi2 = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  var minDist = Infinity;
  var data = path.data;
  var x2 = pt.x;
  var y2 = pt.y;
  for (var i = 0; i < data.length; ) {
    var cmd = data[i++];
    if (i === 1) {
      xi2 = data[i];
      yi2 = data[i + 1];
      x0 = xi2;
      y0 = yi2;
    }
    var d2 = minDist;
    switch (cmd) {
      case CMD$1.M:
        x0 = data[i++];
        y0 = data[i++];
        xi2 = x0;
        yi2 = y0;
        break;
      case CMD$1.L:
        d2 = projectPointToLine(xi2, yi2, data[i], data[i + 1], x2, y2, tmpPt, true);
        xi2 = data[i++];
        yi2 = data[i++];
        break;
      case CMD$1.C:
        d2 = cubicProjectPoint(xi2, yi2, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi2 = data[i++];
        yi2 = data[i++];
        break;
      case CMD$1.Q:
        d2 = quadraticProjectPoint(xi2, yi2, data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi2 = data[i++];
        yi2 = data[i++];
        break;
      case CMD$1.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (i <= 1) {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        d2 = projectPointToArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2, tmpPt);
        xi2 = Math.cos(theta + dTheta) * rx + cx;
        yi2 = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$1.R:
        x0 = xi2 = data[i++];
        y0 = yi2 = data[i++];
        var width = data[i++];
        var height = data[i++];
        d2 = projectPointToRect(x0, y0, width, height, x2, y2, tmpPt);
        break;
      case CMD$1.Z:
        d2 = projectPointToLine(xi2, yi2, x0, y0, x2, y2, tmpPt, true);
        xi2 = x0;
        yi2 = y0;
        break;
    }
    if (d2 < minDist) {
      minDist = d2;
      out2.set(tmpPt[0], tmpPt[1]);
    }
  }
  return minDist;
}
var pt0 = new Point$1();
var pt1 = new Point$1();
var pt2 = new Point$1();
var dir = new Point$1();
var dir2 = new Point$1();
function updateLabelLinePoints(target, labelLineModel) {
  if (!target) {
    return;
  }
  var labelLine = target.getTextGuideLine();
  var label = target.getTextContent();
  if (!(label && labelLine)) {
    return;
  }
  var labelGuideConfig = target.textGuideLineConfig || {};
  var points2 = [[0, 0], [0, 0], [0, 0]];
  var searchSpace = labelGuideConfig.candidates || DEFAULT_SEARCH_SPACE;
  var labelRect = label.getBoundingRect().clone();
  labelRect.applyTransform(label.getComputedTransform());
  var minDist = Infinity;
  var anchorPoint = labelGuideConfig.anchor;
  var targetTransform = target.getComputedTransform();
  var targetInversedTransform = targetTransform && invert([], targetTransform);
  var len2 = labelLineModel.get("length2") || 0;
  if (anchorPoint) {
    pt2.copy(anchorPoint);
  }
  for (var i = 0; i < searchSpace.length; i++) {
    var candidate = searchSpace[i];
    getCandidateAnchor(candidate, 0, labelRect, pt0, dir);
    Point$1.scaleAndAdd(pt1, pt0, dir, len2);
    pt1.transform(targetInversedTransform);
    var boundingRect = target.getBoundingRect();
    var dist2 = anchorPoint ? anchorPoint.distance(pt1) : target instanceof Path$1 ? nearestPointOnPath(pt1, target.path, pt2) : nearestPointOnRect(pt1, boundingRect, pt2);
    if (dist2 < minDist) {
      minDist = dist2;
      pt1.transform(targetTransform);
      pt2.transform(targetTransform);
      pt2.toArray(points2[0]);
      pt1.toArray(points2[1]);
      pt0.toArray(points2[2]);
    }
  }
  limitTurnAngle(points2, labelLineModel.get("minTurnAngle"));
  labelLine.setShape({
    points: points2
  });
}
var tmpArr = [];
var tmpProjPoint = new Point$1();
function limitTurnAngle(linePoints, minTurnAngle) {
  if (!(minTurnAngle <= 180 && minTurnAngle > 0)) {
    return;
  }
  minTurnAngle = minTurnAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt0, pt1);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(dir2);
  var minTurnAngleCos = Math.cos(minTurnAngle);
  if (minTurnAngleCos < angleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI - minTurnAngle));
    var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
    if (isNaN(t2)) {
      return;
    }
    if (t2 < 0) {
      Point$1.copy(tmpProjPoint, pt1);
    } else if (t2 > 1) {
      Point$1.copy(tmpProjPoint, pt2);
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function limitSurfaceAngle(linePoints, surfaceNormal, maxSurfaceAngle) {
  if (!(maxSurfaceAngle <= 180 && maxSurfaceAngle > 0)) {
    return;
  }
  maxSurfaceAngle = maxSurfaceAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt1, pt0);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(surfaceNormal);
  var maxSurfaceAngleCos = Math.cos(maxSurfaceAngle);
  if (angleCos < maxSurfaceAngleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    var HALF_PI = Math.PI / 2;
    var angle2 = Math.acos(dir2.dot(surfaceNormal));
    var newAngle = HALF_PI + angle2 - maxSurfaceAngle;
    if (newAngle >= HALF_PI) {
      Point$1.copy(tmpProjPoint, pt2);
    } else {
      tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI / 2 - newAngle));
      var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
      if (isNaN(t2)) {
        return;
      }
      if (t2 < 0) {
        Point$1.copy(tmpProjPoint, pt1);
      } else if (t2 > 1) {
        Point$1.copy(tmpProjPoint, pt2);
      }
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function setLabelLineState(labelLine, ignore, stateName, stateModel) {
  var isNormal = stateName === "normal";
  var stateObj = isNormal ? labelLine : labelLine.ensureState(stateName);
  stateObj.ignore = ignore;
  var smooth = stateModel.get("smooth");
  if (smooth && smooth === true) {
    smooth = 0.3;
  }
  stateObj.shape = stateObj.shape || {};
  if (smooth > 0) {
    stateObj.shape.smooth = smooth;
  }
  var styleObj = stateModel.getModel("lineStyle").getLineStyle();
  isNormal ? labelLine.useStyle(styleObj) : stateObj.style = styleObj;
}
function buildLabelLinePath(path, shape) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (!points2) {
    return;
  }
  path.moveTo(points2[0][0], points2[0][1]);
  if (smooth > 0 && points2.length >= 3) {
    var len1 = dist$1(points2[0], points2[1]);
    var len2 = dist$1(points2[1], points2[2]);
    if (!len1 || !len2) {
      path.lineTo(points2[1][0], points2[1][1]);
      path.lineTo(points2[2][0], points2[2][1]);
      return;
    }
    var moveLen = Math.min(len1, len2) * smooth;
    var midPoint0 = lerp$1([], points2[1], points2[0], moveLen / len1);
    var midPoint2 = lerp$1([], points2[1], points2[2], moveLen / len2);
    var midPoint1 = lerp$1([], midPoint0, midPoint2, 0.5);
    path.bezierCurveTo(midPoint0[0], midPoint0[1], midPoint0[0], midPoint0[1], midPoint1[0], midPoint1[1]);
    path.bezierCurveTo(midPoint2[0], midPoint2[1], midPoint2[0], midPoint2[1], points2[2][0], points2[2][1]);
  } else {
    for (var i = 1; i < points2.length; i++) {
      path.lineTo(points2[i][0], points2[i][1]);
    }
  }
}
function setLabelLineStyle(targetEl, statesModels, defaultStyle) {
  var labelLine = targetEl.getTextGuideLine();
  var label = targetEl.getTextContent();
  if (!label) {
    if (labelLine) {
      targetEl.removeTextGuideLine();
    }
    return;
  }
  var normalModel = statesModels.normal;
  var showNormal = normalModel.get("show");
  var labelIgnoreNormal = label.ignore;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateName = DISPLAY_STATES[i];
    var stateModel = statesModels[stateName];
    var isNormal = stateName === "normal";
    if (stateModel) {
      var stateShow = stateModel.get("show");
      var isLabelIgnored = isNormal ? labelIgnoreNormal : retrieve2(label.states[stateName] && label.states[stateName].ignore, labelIgnoreNormal);
      if (isLabelIgnored || !retrieve2(stateShow, showNormal)) {
        var stateObj = isNormal ? labelLine : labelLine && labelLine.states.normal;
        if (stateObj) {
          stateObj.ignore = true;
        }
        continue;
      }
      if (!labelLine) {
        labelLine = new Polyline$3();
        targetEl.setTextGuideLine(labelLine);
        if (!isNormal && (labelIgnoreNormal || !showNormal)) {
          setLabelLineState(labelLine, true, "normal", statesModels.normal);
        }
        if (targetEl.stateProxy) {
          labelLine.stateProxy = targetEl.stateProxy;
        }
      }
      setLabelLineState(labelLine, false, stateName, stateModel);
    }
  }
  if (labelLine) {
    defaults(labelLine.style, defaultStyle);
    labelLine.style.fill = null;
    var showAbove = normalModel.get("showAbove");
    var labelLineConfig = targetEl.textGuideLineConfig = targetEl.textGuideLineConfig || {};
    labelLineConfig.showAbove = showAbove || false;
    labelLine.buildPath = buildLabelLinePath;
  }
}
function getLabelLineStatesModels(itemModel, labelLineName) {
  labelLineName = labelLineName || "labelLine";
  var statesModels = {
    normal: itemModel.getModel(labelLineName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelLineName]);
  }
  return statesModels;
}
function prepareLayoutList(input) {
  var list = [];
  for (var i = 0; i < input.length; i++) {
    var rawItem = input[i];
    if (rawItem.defaultAttr.ignore) {
      continue;
    }
    var label = rawItem.label;
    var transform2 = label.getComputedTransform();
    var localRect = label.getBoundingRect();
    var isAxisAligned = !transform2 || transform2[1] < 1e-5 && transform2[2] < 1e-5;
    var minMargin = label.style.margin || 0;
    var globalRect = localRect.clone();
    globalRect.applyTransform(transform2);
    globalRect.x -= minMargin / 2;
    globalRect.y -= minMargin / 2;
    globalRect.width += minMargin;
    globalRect.height += minMargin;
    var obb = isAxisAligned ? new OrientedBoundingRect$1(localRect, transform2) : null;
    list.push({
      label,
      labelLine: rawItem.labelLine,
      rect: globalRect,
      localRect,
      obb,
      priority: rawItem.priority,
      defaultAttr: rawItem.defaultAttr,
      layoutOption: rawItem.computedLayoutOption,
      axisAligned: isAxisAligned,
      transform: transform2
    });
  }
  return list;
}
function shiftLayout(list, xyDim, sizeDim, minBound, maxBound, balanceShift) {
  var len2 = list.length;
  if (len2 < 2) {
    return;
  }
  list.sort(function(a, b2) {
    return a.rect[xyDim] - b2.rect[xyDim];
  });
  var lastPos = 0;
  var delta;
  var adjusted = false;
  var totalShifts = 0;
  for (var i = 0; i < len2; i++) {
    var item = list[i];
    var rect = item.rect;
    delta = rect[xyDim] - lastPos;
    if (delta < 0) {
      rect[xyDim] -= delta;
      item.label[xyDim] -= delta;
      adjusted = true;
    }
    var shift = Math.max(-delta, 0);
    totalShifts += shift;
    lastPos = rect[xyDim] + rect[sizeDim];
  }
  if (totalShifts > 0 && balanceShift) {
    shiftList(-totalShifts / len2, 0, len2);
  }
  var first = list[0];
  var last = list[len2 - 1];
  var minGap;
  var maxGap;
  updateMinMaxGap();
  minGap < 0 && squeezeGaps(-minGap, 0.8);
  maxGap < 0 && squeezeGaps(maxGap, 0.8);
  updateMinMaxGap();
  takeBoundsGap(minGap, maxGap, 1);
  takeBoundsGap(maxGap, minGap, -1);
  updateMinMaxGap();
  if (minGap < 0) {
    squeezeWhenBailout(-minGap);
  }
  if (maxGap < 0) {
    squeezeWhenBailout(maxGap);
  }
  function updateMinMaxGap() {
    minGap = first.rect[xyDim] - minBound;
    maxGap = maxBound - last.rect[xyDim] - last.rect[sizeDim];
  }
  function takeBoundsGap(gapThisBound, gapOtherBound, moveDir) {
    if (gapThisBound < 0) {
      var moveFromMaxGap = Math.min(gapOtherBound, -gapThisBound);
      if (moveFromMaxGap > 0) {
        shiftList(moveFromMaxGap * moveDir, 0, len2);
        var remained = moveFromMaxGap + gapThisBound;
        if (remained < 0) {
          squeezeGaps(-remained * moveDir, 1);
        }
      } else {
        squeezeGaps(-gapThisBound * moveDir, 1);
      }
    }
  }
  function shiftList(delta2, start2, end2) {
    if (delta2 !== 0) {
      adjusted = true;
    }
    for (var i2 = start2; i2 < end2; i2++) {
      var item2 = list[i2];
      var rect2 = item2.rect;
      rect2[xyDim] += delta2;
      item2.label[xyDim] += delta2;
    }
  }
  function squeezeGaps(delta2, maxSqeezePercent) {
    var gaps = [];
    var totalGaps = 0;
    for (var i2 = 1; i2 < len2; i2++) {
      var prevItemRect = list[i2 - 1].rect;
      var gap = Math.max(list[i2].rect[xyDim] - prevItemRect[xyDim] - prevItemRect[sizeDim], 0);
      gaps.push(gap);
      totalGaps += gap;
    }
    if (!totalGaps) {
      return;
    }
    var squeezePercent = Math.min(Math.abs(delta2) / totalGaps, maxSqeezePercent);
    if (delta2 > 0) {
      for (var i2 = 0; i2 < len2 - 1; i2++) {
        var movement = gaps[i2] * squeezePercent;
        shiftList(movement, 0, i2 + 1);
      }
    } else {
      for (var i2 = len2 - 1; i2 > 0; i2--) {
        var movement = gaps[i2 - 1] * squeezePercent;
        shiftList(-movement, i2, len2);
      }
    }
  }
  function squeezeWhenBailout(delta2) {
    var dir3 = delta2 < 0 ? -1 : 1;
    delta2 = Math.abs(delta2);
    var moveForEachLabel = Math.ceil(delta2 / (len2 - 1));
    for (var i2 = 0; i2 < len2 - 1; i2++) {
      if (dir3 > 0) {
        shiftList(moveForEachLabel, 0, i2 + 1);
      } else {
        shiftList(-moveForEachLabel, len2 - i2 - 1, len2);
      }
      delta2 -= moveForEachLabel;
      if (delta2 <= 0) {
        return;
      }
    }
  }
  return adjusted;
}
function shiftLayoutOnX(list, leftBound, rightBound, balanceShift) {
  return shiftLayout(list, "x", "width", leftBound, rightBound, balanceShift);
}
function shiftLayoutOnY(list, topBound, bottomBound, balanceShift) {
  return shiftLayout(list, "y", "height", topBound, bottomBound, balanceShift);
}
function hideOverlap(labelList) {
  var displayedLabels = [];
  labelList.sort(function(a, b2) {
    return b2.priority - a.priority;
  });
  var globalRect = new BoundingRect$1(0, 0, 0, 0);
  function hideEl(el) {
    if (!el.ignore) {
      var emphasisState = el.ensureState("emphasis");
      if (emphasisState.ignore == null) {
        emphasisState.ignore = false;
      }
    }
    el.ignore = true;
  }
  for (var i = 0; i < labelList.length; i++) {
    var labelItem = labelList[i];
    var isAxisAligned = labelItem.axisAligned;
    var localRect = labelItem.localRect;
    var transform2 = labelItem.transform;
    var label = labelItem.label;
    var labelLine = labelItem.labelLine;
    globalRect.copy(labelItem.rect);
    globalRect.width -= 0.1;
    globalRect.height -= 0.1;
    globalRect.x += 0.05;
    globalRect.y += 0.05;
    var obb = labelItem.obb;
    var overlapped = false;
    for (var j = 0; j < displayedLabels.length; j++) {
      var existsTextCfg = displayedLabels[j];
      if (!globalRect.intersect(existsTextCfg.rect)) {
        continue;
      }
      if (isAxisAligned && existsTextCfg.axisAligned) {
        overlapped = true;
        break;
      }
      if (!existsTextCfg.obb) {
        existsTextCfg.obb = new OrientedBoundingRect$1(existsTextCfg.localRect, existsTextCfg.transform);
      }
      if (!obb) {
        obb = new OrientedBoundingRect$1(localRect, transform2);
      }
      if (obb.intersect(existsTextCfg.obb)) {
        overlapped = true;
        break;
      }
    }
    if (overlapped) {
      hideEl(label);
      labelLine && hideEl(labelLine);
    } else {
      label.attr("ignore", labelItem.defaultAttr.ignore);
      labelLine && labelLine.attr("ignore", labelItem.defaultAttr.labelGuideIgnore);
      displayedLabels.push(labelItem);
    }
  }
}
function cloneArr(points2) {
  if (points2) {
    var newPoints = [];
    for (var i = 0; i < points2.length; i++) {
      newPoints.push(points2[i].slice());
    }
    return newPoints;
  }
}
function prepareLayoutCallbackParams(labelItem, hostEl) {
  var label = labelItem.label;
  var labelLine = hostEl && hostEl.getTextGuideLine();
  return {
    dataIndex: labelItem.dataIndex,
    dataType: labelItem.dataType,
    seriesIndex: labelItem.seriesModel.seriesIndex,
    text: labelItem.label.style.text,
    rect: labelItem.hostRect,
    labelRect: labelItem.rect,
    align: label.style.align,
    verticalAlign: label.style.verticalAlign,
    labelLinePoints: cloneArr(labelLine && labelLine.shape.points)
  };
}
var LABEL_OPTION_TO_STYLE_KEYS = ["align", "verticalAlign", "width", "height", "fontSize"];
var dummyTransformable = new Transformable$1();
var labelLayoutInnerStore = makeInner();
var labelLineAnimationStore = makeInner();
function extendWithKeys(target, source, keys2) {
  for (var i = 0; i < keys2.length; i++) {
    var key = keys2[i];
    if (source[key] != null) {
      target[key] = source[key];
    }
  }
}
var LABEL_LAYOUT_PROPS = ["x", "y", "rotation"];
var LabelManager = function() {
  function LabelManager2() {
    this._labelList = [];
    this._chartViewList = [];
  }
  LabelManager2.prototype.clearLabels = function() {
    this._labelList = [];
    this._chartViewList = [];
  };
  LabelManager2.prototype._addLabel = function(dataIndex, dataType, seriesModel, label, layoutOption) {
    var labelStyle = label.style;
    var hostEl = label.__hostTarget;
    var textConfig = hostEl.textConfig || {};
    var labelTransform = label.getComputedTransform();
    var labelRect = label.getBoundingRect().plain();
    BoundingRect$1.applyTransform(labelRect, labelRect, labelTransform);
    if (labelTransform) {
      dummyTransformable.setLocalTransform(labelTransform);
    } else {
      dummyTransformable.x = dummyTransformable.y = dummyTransformable.rotation = dummyTransformable.originX = dummyTransformable.originY = 0;
      dummyTransformable.scaleX = dummyTransformable.scaleY = 1;
    }
    var host = label.__hostTarget;
    var hostRect;
    if (host) {
      hostRect = host.getBoundingRect().plain();
      var transform2 = host.getComputedTransform();
      BoundingRect$1.applyTransform(hostRect, hostRect, transform2);
    }
    var labelGuide = hostRect && host.getTextGuideLine();
    this._labelList.push({
      label,
      labelLine: labelGuide,
      seriesModel,
      dataIndex,
      dataType,
      layoutOption,
      computedLayoutOption: null,
      rect: labelRect,
      hostRect,
      priority: hostRect ? hostRect.width * hostRect.height : 0,
      defaultAttr: {
        ignore: label.ignore,
        labelGuideIgnore: labelGuide && labelGuide.ignore,
        x: dummyTransformable.x,
        y: dummyTransformable.y,
        scaleX: dummyTransformable.scaleX,
        scaleY: dummyTransformable.scaleY,
        rotation: dummyTransformable.rotation,
        style: {
          x: labelStyle.x,
          y: labelStyle.y,
          align: labelStyle.align,
          verticalAlign: labelStyle.verticalAlign,
          width: labelStyle.width,
          height: labelStyle.height,
          fontSize: labelStyle.fontSize
        },
        cursor: label.cursor,
        attachedPos: textConfig.position,
        attachedRot: textConfig.rotation
      }
    });
  };
  LabelManager2.prototype.addLabelsOfSeries = function(chartView) {
    var _this = this;
    this._chartViewList.push(chartView);
    var seriesModel = chartView.__model;
    var layoutOption = seriesModel.get("labelLayout");
    if (!(isFunction(layoutOption) || keys(layoutOption).length)) {
      return;
    }
    chartView.group.traverse(function(child) {
      if (child.ignore) {
        return true;
      }
      var textEl = child.getTextContent();
      var ecData = getECData(child);
      if (textEl && !textEl.disableLabelLayout) {
        _this._addLabel(ecData.dataIndex, ecData.dataType, seriesModel, textEl, layoutOption);
      }
    });
  };
  LabelManager2.prototype.updateLayoutConfig = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    function createDragHandler(el, labelLineModel) {
      return function() {
        updateLabelLinePoints(el, labelLineModel);
      };
    }
    for (var i = 0; i < this._labelList.length; i++) {
      var labelItem = this._labelList[i];
      var label = labelItem.label;
      var hostEl = label.__hostTarget;
      var defaultLabelAttr = labelItem.defaultAttr;
      var layoutOption = void 0;
      if (isFunction(labelItem.layoutOption)) {
        layoutOption = labelItem.layoutOption(prepareLayoutCallbackParams(labelItem, hostEl));
      } else {
        layoutOption = labelItem.layoutOption;
      }
      layoutOption = layoutOption || {};
      labelItem.computedLayoutOption = layoutOption;
      var degreeToRadian = Math.PI / 180;
      if (hostEl) {
        hostEl.setTextConfig({
          local: false,
          position: layoutOption.x != null || layoutOption.y != null ? null : defaultLabelAttr.attachedPos,
          rotation: layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.attachedRot,
          offset: [layoutOption.dx || 0, layoutOption.dy || 0]
        });
      }
      var needsUpdateLabelLine = false;
      if (layoutOption.x != null) {
        label.x = parsePercent(layoutOption.x, width);
        label.setStyle("x", 0);
        needsUpdateLabelLine = true;
      } else {
        label.x = defaultLabelAttr.x;
        label.setStyle("x", defaultLabelAttr.style.x);
      }
      if (layoutOption.y != null) {
        label.y = parsePercent(layoutOption.y, height);
        label.setStyle("y", 0);
        needsUpdateLabelLine = true;
      } else {
        label.y = defaultLabelAttr.y;
        label.setStyle("y", defaultLabelAttr.style.y);
      }
      if (layoutOption.labelLinePoints) {
        var guideLine = hostEl.getTextGuideLine();
        if (guideLine) {
          guideLine.setShape({
            points: layoutOption.labelLinePoints
          });
          needsUpdateLabelLine = false;
        }
      }
      var labelLayoutStore = labelLayoutInnerStore(label);
      labelLayoutStore.needsUpdateLabelLine = needsUpdateLabelLine;
      label.rotation = layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.rotation;
      label.scaleX = defaultLabelAttr.scaleX;
      label.scaleY = defaultLabelAttr.scaleY;
      for (var k2 = 0; k2 < LABEL_OPTION_TO_STYLE_KEYS.length; k2++) {
        var key = LABEL_OPTION_TO_STYLE_KEYS[k2];
        label.setStyle(key, layoutOption[key] != null ? layoutOption[key] : defaultLabelAttr.style[key]);
      }
      if (layoutOption.draggable) {
        label.draggable = true;
        label.cursor = "move";
        if (hostEl) {
          var hostModel = labelItem.seriesModel;
          if (labelItem.dataIndex != null) {
            var data = labelItem.seriesModel.getData(labelItem.dataType);
            hostModel = data.getItemModel(labelItem.dataIndex);
          }
          label.on("drag", createDragHandler(hostEl, hostModel.getModel("labelLine")));
        }
      } else {
        label.off("drag");
        label.cursor = defaultLabelAttr.cursor;
      }
    }
  };
  LabelManager2.prototype.layout = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    var labelList = prepareLayoutList(this._labelList);
    var labelsNeedsAdjustOnX = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftX";
    });
    var labelsNeedsAdjustOnY = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftY";
    });
    shiftLayoutOnX(labelsNeedsAdjustOnX, 0, width);
    shiftLayoutOnY(labelsNeedsAdjustOnY, 0, height);
    var labelsNeedsHideOverlap = filter(labelList, function(item) {
      return item.layoutOption.hideOverlap;
    });
    hideOverlap(labelsNeedsHideOverlap);
  };
  LabelManager2.prototype.processLabelsOverall = function() {
    var _this = this;
    each$g(this._chartViewList, function(chartView) {
      var seriesModel = chartView.__model;
      var ignoreLabelLineUpdate = chartView.ignoreLabelLineUpdate;
      var animationEnabled = seriesModel.isAnimationEnabled();
      chartView.group.traverse(function(child) {
        if (child.ignore && !child.forceLabelAnimation) {
          return true;
        }
        var needsUpdateLabelLine = !ignoreLabelLineUpdate;
        var label = child.getTextContent();
        if (!needsUpdateLabelLine && label) {
          needsUpdateLabelLine = labelLayoutInnerStore(label).needsUpdateLabelLine;
        }
        if (needsUpdateLabelLine) {
          _this._updateLabelLine(child, seriesModel);
        }
        if (animationEnabled) {
          _this._animateLabels(child, seriesModel);
        }
      });
    });
  };
  LabelManager2.prototype._updateLabelLine = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var ecData = getECData(el);
    var dataIndex = ecData.dataIndex;
    if (textEl && dataIndex != null) {
      var data = seriesModel.getData(ecData.dataType);
      var itemModel = data.getItemModel(dataIndex);
      var defaultStyle = {};
      var visualStyle = data.getItemVisual(dataIndex, "style");
      var visualType = data.getVisual("drawType");
      defaultStyle.stroke = visualStyle[visualType];
      var labelLineModel = itemModel.getModel("labelLine");
      setLabelLineStyle(el, getLabelLineStatesModels(itemModel), defaultStyle);
      updateLabelLinePoints(el, labelLineModel);
    }
  };
  LabelManager2.prototype._animateLabels = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var guideLine = el.getTextGuideLine();
    if (textEl && (el.forceLabelAnimation || !textEl.ignore && !textEl.invisible && !el.disableLabelAnimation && !isElementRemoved(el))) {
      var layoutStore = labelLayoutInnerStore(textEl);
      var oldLayout = layoutStore.oldLayout;
      var ecData = getECData(el);
      var dataIndex = ecData.dataIndex;
      var newProps = {
        x: textEl.x,
        y: textEl.y,
        rotation: textEl.rotation
      };
      var data = seriesModel.getData(ecData.dataType);
      if (!oldLayout) {
        textEl.attr(newProps);
        if (!labelInner(textEl).valueAnimation) {
          var oldOpacity = retrieve2(textEl.style.opacity, 1);
          textEl.style.opacity = 0;
          initProps(textEl, {
            style: {
              opacity: oldOpacity
            }
          }, seriesModel, dataIndex);
        }
      } else {
        textEl.attr(oldLayout);
        var prevStates = el.prevStates;
        if (prevStates) {
          if (indexOf(prevStates, "select") >= 0) {
            textEl.attr(layoutStore.oldLayoutSelect);
          }
          if (indexOf(prevStates, "emphasis") >= 0) {
            textEl.attr(layoutStore.oldLayoutEmphasis);
          }
        }
        updateProps$1(textEl, newProps, seriesModel, dataIndex);
      }
      layoutStore.oldLayout = newProps;
      if (textEl.states.select) {
        var layoutSelect = layoutStore.oldLayoutSelect = {};
        extendWithKeys(layoutSelect, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutSelect, textEl.states.select, LABEL_LAYOUT_PROPS);
      }
      if (textEl.states.emphasis) {
        var layoutEmphasis = layoutStore.oldLayoutEmphasis = {};
        extendWithKeys(layoutEmphasis, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutEmphasis, textEl.states.emphasis, LABEL_LAYOUT_PROPS);
      }
      animateLabelValue(textEl, dataIndex, data, seriesModel, seriesModel);
    }
    if (guideLine && !guideLine.ignore && !guideLine.invisible) {
      var layoutStore = labelLineAnimationStore(guideLine);
      var oldLayout = layoutStore.oldLayout;
      var newLayout = {
        points: guideLine.shape.points
      };
      if (!oldLayout) {
        guideLine.setShape(newLayout);
        guideLine.style.strokePercent = 0;
        initProps(guideLine, {
          style: {
            strokePercent: 1
          }
        }, seriesModel);
      } else {
        guideLine.attr({
          shape: oldLayout
        });
        updateProps$1(guideLine, {
          shape: newLayout
        }, seriesModel);
      }
      layoutStore.oldLayout = newLayout;
    }
  };
  return LabelManager2;
}();
var LabelManager$1 = LabelManager;
var getLabelManager = makeInner();
function installLabelLayout(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    if (!labelManager) {
      labelManager = getLabelManager(api).labelManager = new LabelManager$1();
    }
    labelManager.clearLabels();
  });
  registers.registerUpdateLifecycle("series:layoutlabels", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    params.updatedSeries.forEach(function(series) {
      labelManager.addLabelsOfSeries(api.getViewOfSeriesModel(series));
    });
    labelManager.updateLayoutConfig(api);
    labelManager.layout(api);
    labelManager.processLabelsOverall();
  });
}
var mathSin = Math.sin;
var mathCos = Math.cos;
var PI$4 = Math.PI;
var PI2$2 = Math.PI * 2;
var degree = 180 / PI$4;
var SVGPathRebuilder = function() {
  function SVGPathRebuilder2() {
  }
  SVGPathRebuilder2.prototype.reset = function(precision) {
    this._start = true;
    this._d = [];
    this._str = "";
    this._p = Math.pow(10, precision || 4);
  };
  SVGPathRebuilder2.prototype.moveTo = function(x2, y2) {
    this._add("M", x2, y2);
  };
  SVGPathRebuilder2.prototype.lineTo = function(x2, y2) {
    this._add("L", x2, y2);
  };
  SVGPathRebuilder2.prototype.bezierCurveTo = function(x2, y2, x22, y22, x3, y3) {
    this._add("C", x2, y2, x22, y22, x3, y3);
  };
  SVGPathRebuilder2.prototype.quadraticCurveTo = function(x2, y2, x22, y22) {
    this._add("Q", x2, y2, x22, y22);
  };
  SVGPathRebuilder2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this.ellipse(cx, cy, r2, r2, 0, startAngle, endAngle, anticlockwise);
  };
  SVGPathRebuilder2.prototype.ellipse = function(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise) {
    var dTheta = endAngle - startAngle;
    var clockwise = !anticlockwise;
    var dThetaPositive = Math.abs(dTheta);
    var isCircle = isAroundZero(dThetaPositive - PI2$2) || (clockwise ? dTheta >= PI2$2 : -dTheta >= PI2$2);
    var unifiedTheta = dTheta > 0 ? dTheta % PI2$2 : dTheta % PI2$2 + PI2$2;
    var large = false;
    if (isCircle) {
      large = true;
    } else if (isAroundZero(dThetaPositive)) {
      large = false;
    } else {
      large = unifiedTheta >= PI$4 === !!clockwise;
    }
    var x0 = cx + rx * mathCos(startAngle);
    var y0 = cy + ry * mathSin(startAngle);
    if (this._start) {
      this._add("M", x0, y0);
    }
    var xRot = Math.round(psi * degree);
    if (isCircle) {
      var p2 = 1 / this._p;
      var dTheta_1 = (clockwise ? 1 : -1) * (PI2$2 - p2);
      this._add("A", rx, ry, xRot, 1, +clockwise, cx + rx * mathCos(startAngle + dTheta_1), cy + ry * mathSin(startAngle + dTheta_1));
      if (p2 > 0.01) {
        this._add("A", rx, ry, xRot, 0, +clockwise, x0, y0);
      }
    } else {
      var x2 = cx + rx * mathCos(endAngle);
      var y2 = cy + ry * mathSin(endAngle);
      this._add("A", rx, ry, xRot, +large, +clockwise, x2, y2);
    }
  };
  SVGPathRebuilder2.prototype.rect = function(x2, y2, w2, h) {
    this._add("M", x2, y2);
    this._add("l", w2, 0);
    this._add("l", 0, h);
    this._add("l", -w2, 0);
    this._add("Z");
  };
  SVGPathRebuilder2.prototype.closePath = function() {
    if (this._d.length > 0) {
      this._add("Z");
    }
  };
  SVGPathRebuilder2.prototype._add = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    var vals = [];
    var p2 = this._p;
    for (var i = 1; i < arguments.length; i++) {
      var val = arguments[i];
      if (isNaN(val)) {
        this._invalid = true;
        return;
      }
      vals.push(Math.round(val * p2) / p2);
    }
    this._d.push(cmd + vals.join(" "));
    this._start = cmd === "Z";
  };
  SVGPathRebuilder2.prototype.generateStr = function() {
    this._str = this._invalid ? "" : this._d.join("");
    this._d = [];
  };
  SVGPathRebuilder2.prototype.getStr = function() {
    return this._str;
  };
  return SVGPathRebuilder2;
}();
var SVGPathRebuilder$1 = SVGPathRebuilder;
var NONE = "none";
var mathRound = Math.round;
function pathHasFill(style2) {
  var fill = style2.fill;
  return fill != null && fill !== NONE;
}
function pathHasStroke(style2) {
  var stroke = style2.stroke;
  return stroke != null && stroke !== NONE;
}
var strokeProps = ["lineCap", "miterLimit", "lineJoin"];
var svgStrokeProps = map$1(strokeProps, function(prop) {
  return "stroke-" + prop.toLowerCase();
});
function mapStyleToAttrs(updateAttr2, style2, el, forceUpdate) {
  var opacity = style2.opacity == null ? 1 : style2.opacity;
  if (el instanceof ZRImage$1) {
    updateAttr2("opacity", opacity);
    return;
  }
  if (pathHasFill(style2)) {
    var fill = normalizeColor(style2.fill);
    updateAttr2("fill", fill.color);
    var fillOpacity = style2.fillOpacity != null ? style2.fillOpacity * fill.opacity * opacity : fill.opacity * opacity;
    if (forceUpdate || fillOpacity < 1) {
      updateAttr2("fill-opacity", fillOpacity);
    }
  } else {
    updateAttr2("fill", NONE);
  }
  if (pathHasStroke(style2)) {
    var stroke = normalizeColor(style2.stroke);
    updateAttr2("stroke", stroke.color);
    var strokeScale = style2.strokeNoScale ? el.getLineScale() : 1;
    var strokeWidth = strokeScale ? (style2.lineWidth || 0) / strokeScale : 0;
    var strokeOpacity = style2.strokeOpacity != null ? style2.strokeOpacity * stroke.opacity * opacity : stroke.opacity * opacity;
    var strokeFirst = style2.strokeFirst;
    if (forceUpdate || strokeWidth !== 1) {
      updateAttr2("stroke-width", strokeWidth);
    }
    if (forceUpdate || strokeFirst) {
      updateAttr2("paint-order", strokeFirst ? "stroke" : "fill");
    }
    if (forceUpdate || strokeOpacity < 1) {
      updateAttr2("stroke-opacity", strokeOpacity);
    }
    if (style2.lineDash) {
      var _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
      if (lineDash) {
        lineDashOffset = mathRound(lineDashOffset || 0);
        updateAttr2("stroke-dasharray", lineDash.join(","));
        if (lineDashOffset || forceUpdate) {
          updateAttr2("stroke-dashoffset", lineDashOffset);
        }
      }
    } else if (forceUpdate) {
      updateAttr2("stroke-dasharray", NONE);
    }
    for (var i = 0; i < strokeProps.length; i++) {
      var propName = strokeProps[i];
      if (forceUpdate || style2[propName] !== DEFAULT_PATH_STYLE[propName]) {
        var val = style2[propName] || DEFAULT_PATH_STYLE[propName];
        val && updateAttr2(svgStrokeProps[i], val);
      }
    }
  } else if (forceUpdate) {
    updateAttr2("stroke", NONE);
  }
}
var SVGNS = "http://www.w3.org/2000/svg";
var XLINKNS = "http://www.w3.org/1999/xlink";
var XMLNS = "http://www.w3.org/2000/xmlns/";
var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
function createElement(name) {
  return document.createElementNS(SVGNS, name);
}
function createVNode(tag, key, attrs, children, text) {
  return {
    tag,
    attrs: attrs || {},
    children,
    text,
    key
  };
}
function createElementOpen(name, attrs) {
  var attrsStr = [];
  if (attrs) {
    for (var key in attrs) {
      var val = attrs[key];
      var part = key;
      if (val === false) {
        continue;
      } else if (val !== true && val != null) {
        part += '="' + val + '"';
      }
      attrsStr.push(part);
    }
  }
  return "<" + name + " " + attrsStr.join(" ") + ">";
}
function createElementClose(name) {
  return "</" + name + ">";
}
function vNodeToString(el, opts) {
  opts = opts || {};
  var S2 = opts.newline ? "\n" : "";
  function convertElToString(el2) {
    var children = el2.children, tag = el2.tag, attrs = el2.attrs;
    return createElementOpen(tag, attrs) + (el2.text || "") + (children ? "" + S2 + map$1(children, function(child) {
      return convertElToString(child);
    }).join(S2) + S2 : "") + createElementClose(tag);
  }
  return convertElToString(el);
}
function getCssString(selectorNodes, animationNodes, opts) {
  opts = opts || {};
  var S2 = opts.newline ? "\n" : "";
  var bracketBegin = " {" + S2;
  var bracketEnd = S2 + "}";
  var selectors = map$1(keys(selectorNodes), function(className) {
    return className + bracketBegin + map$1(keys(selectorNodes[className]), function(attrName) {
      return attrName + ":" + selectorNodes[className][attrName] + ";";
    }).join(S2) + bracketEnd;
  }).join(S2);
  var animations = map$1(keys(animationNodes), function(animationName) {
    return "@keyframes " + animationName + bracketBegin + map$1(keys(animationNodes[animationName]), function(percent) {
      return percent + bracketBegin + map$1(keys(animationNodes[animationName][percent]), function(attrName) {
        var val = animationNodes[animationName][percent][attrName];
        if (attrName === "d") {
          val = 'path("' + val + '")';
        }
        return attrName + ":" + val + ";";
      }).join(S2) + bracketEnd;
    }).join(S2) + bracketEnd;
  }).join(S2);
  if (!selectors && !animations) {
    return "";
  }
  return ["<![CDATA[", selectors, animations, "]]>"].join(S2);
}
function createBrushScope(zrId) {
  return {
    zrId,
    shadowCache: {},
    patternCache: {},
    gradientCache: {},
    clipPathCache: {},
    defs: {},
    cssNodes: {},
    cssAnims: {},
    cssClassIdx: 0,
    cssAnimIdx: 0,
    shadowIdx: 0,
    gradientIdx: 0,
    patternIdx: 0,
    clipPathIdx: 0
  };
}
function createSVGVNode(width, height, children, useViewBox) {
  return createVNode("svg", "root", {
    "width": width,
    "height": height,
    "xmlns": SVGNS,
    "xmlns:xlink": XLINKNS,
    "version": "1.1",
    "baseProfile": "full",
    "viewBox": useViewBox ? "0 0 " + width + " " + height : false
  }, children);
}
var EASING_MAP = {
  cubicIn: "0.32,0,0.67,0",
  cubicOut: "0.33,1,0.68,1",
  cubicInOut: "0.65,0,0.35,1",
  quadraticIn: "0.11,0,0.5,0",
  quadraticOut: "0.5,1,0.89,1",
  quadraticInOut: "0.45,0,0.55,1",
  quarticIn: "0.5,0,0.75,0",
  quarticOut: "0.25,1,0.5,1",
  quarticInOut: "0.76,0,0.24,1",
  quinticIn: "0.64,0,0.78,0",
  quinticOut: "0.22,1,0.36,1",
  quinticInOut: "0.83,0,0.17,1",
  sinusoidalIn: "0.12,0,0.39,0",
  sinusoidalOut: "0.61,1,0.88,1",
  sinusoidalInOut: "0.37,0,0.63,1",
  exponentialIn: "0.7,0,0.84,0",
  exponentialOut: "0.16,1,0.3,1",
  exponentialInOut: "0.87,0,0.13,1",
  circularIn: "0.55,0,1,0.45",
  circularOut: "0,0.55,0.45,1",
  circularInOut: "0.85,0,0.15,1"
};
var transformOriginKey = "transform-origin";
function buildPathString(el, kfShape, path) {
  var shape = extend({}, el.shape);
  extend(shape, kfShape);
  el.buildPath(path, shape);
  var svgPathBuilder = new SVGPathRebuilder$1();
  svgPathBuilder.reset(getPathPrecision(el));
  path.rebuildPath(svgPathBuilder, 1);
  svgPathBuilder.generateStr();
  return svgPathBuilder.getStr();
}
function setTransformOrigin(target, transform2) {
  var originX = transform2.originX, originY = transform2.originY;
  if (originX || originY) {
    target[transformOriginKey] = originX + "px " + originY + "px";
  }
}
var ANIMATE_STYLE_MAP = {
  fill: "fill",
  opacity: "opacity",
  lineWidth: "stroke-width",
  lineDashOffset: "stroke-dashoffset"
};
function addAnimation(cssAnim, scope) {
  var animationName = scope.zrId + "-ani-" + scope.cssAnimIdx++;
  scope.cssAnims[animationName] = cssAnim;
  return animationName;
}
function createCompoundPathCSSAnimation(el, attrs, scope) {
  var paths = el.shape.paths;
  var composedAnim = {};
  var cssAnimationCfg;
  var cssAnimationName;
  each$g(paths, function(path) {
    var subScope = createBrushScope(scope.zrId);
    subScope.animation = true;
    createCSSAnimation(path, {}, subScope, true);
    var cssAnims = subScope.cssAnims;
    var cssNodes = subScope.cssNodes;
    var animNames = keys(cssAnims);
    var len2 = animNames.length;
    if (!len2) {
      return;
    }
    cssAnimationName = animNames[len2 - 1];
    var lastAnim = cssAnims[cssAnimationName];
    for (var percent in lastAnim) {
      var kf2 = lastAnim[percent];
      composedAnim[percent] = composedAnim[percent] || { d: "" };
      composedAnim[percent].d += kf2.d || "";
    }
    for (var className in cssNodes) {
      var val = cssNodes[className].animation;
      if (val.indexOf(cssAnimationName) >= 0) {
        cssAnimationCfg = val;
      }
    }
  });
  if (!cssAnimationCfg) {
    return;
  }
  attrs.d = false;
  var animationName = addAnimation(composedAnim, scope);
  return cssAnimationCfg.replace(cssAnimationName, animationName);
}
function getEasingFunc(easing) {
  return isString$1(easing) ? EASING_MAP[easing] ? "cubic-bezier(" + EASING_MAP[easing] + ")" : createCubicEasingFunc(easing) ? easing : "" : "";
}
function createCSSAnimation(el, attrs, scope, onlyShape) {
  var animators = el.animators;
  var len2 = animators.length;
  var cssAnimations = [];
  if (el instanceof CompoundPath$1) {
    var animationCfg = createCompoundPathCSSAnimation(el, attrs, scope);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    } else if (!len2) {
      return;
    }
  } else if (!len2) {
    return;
  }
  var groupAnimators = {};
  for (var i = 0; i < len2; i++) {
    var animator = animators[i];
    var cfgArr = [animator.getMaxTime() / 1e3 + "s"];
    var easing = getEasingFunc(animator.getClip().easing);
    var delay = animator.getDelay();
    if (easing) {
      cfgArr.push(easing);
    } else {
      cfgArr.push("linear");
    }
    if (delay) {
      cfgArr.push(delay / 1e3 + "s");
    }
    if (animator.getLoop()) {
      cfgArr.push("infinite");
    }
    var cfg = cfgArr.join(" ");
    groupAnimators[cfg] = groupAnimators[cfg] || [cfg, []];
    groupAnimators[cfg][1].push(animator);
  }
  function createSingleCSSAnimation(groupAnimator) {
    var animators2 = groupAnimator[1];
    var len3 = animators2.length;
    var transformKfs = {};
    var shapeKfs = {};
    var finalKfs = {};
    var animationTimingFunctionAttrName = "animation-timing-function";
    function saveAnimatorTrackToCssKfs(animator3, cssKfs, toCssAttrName) {
      var tracks = animator3.getTracks();
      var maxTime = animator3.getMaxTime();
      for (var k2 = 0; k2 < tracks.length; k2++) {
        var track = tracks[k2];
        if (track.needsAnimate()) {
          var kfs = track.keyframes;
          var attrName = track.propName;
          toCssAttrName && (attrName = toCssAttrName(attrName));
          if (attrName) {
            for (var i3 = 0; i3 < kfs.length; i3++) {
              var kf2 = kfs[i3];
              var percent2 = Math.round(kf2.time / maxTime * 100) + "%";
              var kfEasing = getEasingFunc(kf2.easing);
              var rawValue = kf2.rawValue;
              if (isString$1(rawValue) || isNumber(rawValue)) {
                cssKfs[percent2] = cssKfs[percent2] || {};
                cssKfs[percent2][attrName] = kf2.rawValue;
                if (kfEasing) {
                  cssKfs[percent2][animationTimingFunctionAttrName] = kfEasing;
                }
              }
            }
          }
        }
      }
    }
    for (var i2 = 0; i2 < len3; i2++) {
      var animator2 = animators2[i2];
      var targetProp = animator2.targetName;
      if (!targetProp) {
        !onlyShape && saveAnimatorTrackToCssKfs(animator2, transformKfs);
      } else if (targetProp === "shape") {
        saveAnimatorTrackToCssKfs(animator2, shapeKfs);
      }
    }
    for (var percent in transformKfs) {
      var transform2 = {};
      copyTransform(transform2, el);
      extend(transform2, transformKfs[percent]);
      var str = getSRTTransformString(transform2);
      var timingFunction = transformKfs[percent][animationTimingFunctionAttrName];
      finalKfs[percent] = str ? {
        transform: str
      } : {};
      setTransformOrigin(finalKfs[percent], transform2);
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    var path;
    var canAnimateShape = true;
    for (var percent in shapeKfs) {
      finalKfs[percent] = finalKfs[percent] || {};
      var isFirst = !path;
      var timingFunction = shapeKfs[percent][animationTimingFunctionAttrName];
      if (isFirst) {
        path = new PathProxy$1();
      }
      var len_1 = path.len();
      path.reset();
      finalKfs[percent].d = buildPathString(el, shapeKfs[percent], path);
      var newLen = path.len();
      if (!isFirst && len_1 !== newLen) {
        canAnimateShape = false;
        break;
      }
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    if (!canAnimateShape) {
      for (var percent in finalKfs) {
        delete finalKfs[percent].d;
      }
    }
    if (!onlyShape) {
      for (var i2 = 0; i2 < len3; i2++) {
        var animator2 = animators2[i2];
        var targetProp = animator2.targetName;
        if (targetProp === "style") {
          saveAnimatorTrackToCssKfs(animator2, finalKfs, function(propName) {
            return ANIMATE_STYLE_MAP[propName];
          });
        }
      }
    }
    var percents = keys(finalKfs);
    var allTransformOriginSame = true;
    var transformOrigin;
    for (var i2 = 1; i2 < percents.length; i2++) {
      var p0 = percents[i2 - 1];
      var p1 = percents[i2];
      if (finalKfs[p0][transformOriginKey] !== finalKfs[p1][transformOriginKey]) {
        allTransformOriginSame = false;
        break;
      }
      transformOrigin = finalKfs[p0][transformOriginKey];
    }
    if (allTransformOriginSame && transformOrigin) {
      for (var percent in finalKfs) {
        if (finalKfs[percent][transformOriginKey]) {
          delete finalKfs[percent][transformOriginKey];
        }
      }
      attrs[transformOriginKey] = transformOrigin;
    }
    if (filter(percents, function(percent2) {
      return keys(finalKfs[percent2]).length > 0;
    }).length) {
      var animationName = addAnimation(finalKfs, scope);
      return animationName + " " + groupAnimator[0] + " both";
    }
  }
  for (var key in groupAnimators) {
    var animationCfg = createSingleCSSAnimation(groupAnimators[key]);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    }
  }
  if (cssAnimations.length) {
    var className = scope.zrId + "-cls-" + scope.cssClassIdx++;
    scope.cssNodes["." + className] = {
      animation: cssAnimations.join(",")
    };
    attrs["class"] = className;
  }
}
var round$1 = Math.round;
function isImageLike(val) {
  return val && isString$1(val.src);
}
function isCanvasLike(val) {
  return val && isFunction(val.toDataURL);
}
function setStyleAttrs(attrs, style2, el, scope) {
  mapStyleToAttrs(function(key, val) {
    var isFillStroke = key === "fill" || key === "stroke";
    if (isFillStroke && isGradient(val)) {
      setGradient(style2, attrs, key, scope);
    } else if (isFillStroke && isPattern(val)) {
      setPattern(el, attrs, key, scope);
    } else {
      attrs[key] = val;
    }
  }, style2, el, false);
  setShadow(el, attrs, scope);
}
function noRotateScale(m2) {
  return isAroundZero(m2[0] - 1) && isAroundZero(m2[1]) && isAroundZero(m2[2]) && isAroundZero(m2[3] - 1);
}
function noTranslate(m2) {
  return isAroundZero(m2[4]) && isAroundZero(m2[5]);
}
function setTransform$2(attrs, m2, compress) {
  if (m2 && !(noTranslate(m2) && noRotateScale(m2))) {
    var mul2 = compress ? 10 : 1e4;
    attrs.transform = noRotateScale(m2) ? "translate(" + round$1(m2[4] * mul2) / mul2 + " " + round$1(m2[5] * mul2) / mul2 + ")" : getMatrixStr(m2);
  }
}
function convertPolyShape(shape, attrs, mul2) {
  var points2 = shape.points;
  var strArr = [];
  for (var i = 0; i < points2.length; i++) {
    strArr.push(round$1(points2[i][0] * mul2) / mul2);
    strArr.push(round$1(points2[i][1] * mul2) / mul2);
  }
  attrs.points = strArr.join(" ");
}
function validatePolyShape(shape) {
  return !shape.smooth;
}
function createAttrsConvert(desc) {
  var normalizedDesc = map$1(desc, function(item) {
    return typeof item === "string" ? [item, item] : item;
  });
  return function(shape, attrs, mul2) {
    for (var i = 0; i < normalizedDesc.length; i++) {
      var item = normalizedDesc[i];
      var val = shape[item[0]];
      if (val != null) {
        attrs[item[1]] = round$1(val * mul2) / mul2;
      }
    }
  };
}
var buitinShapesDef = {
  circle: [createAttrsConvert(["cx", "cy", "r"])],
  polyline: [convertPolyShape, validatePolyShape],
  polygon: [convertPolyShape, validatePolyShape]
};
function hasShapeAnimation(el) {
  var animators = el.animators;
  for (var i = 0; i < animators.length; i++) {
    if (animators[i].targetName === "shape") {
      return true;
    }
  }
  return false;
}
function brushSVGPath(el, scope) {
  var style2 = el.style;
  var shape = el.shape;
  var builtinShpDef = buitinShapesDef[el.type];
  var attrs = {};
  var needsAnimate = scope.animation;
  var svgElType = "path";
  var strokePercent = el.style.strokePercent;
  var precision = scope.compress && getPathPrecision(el) || 4;
  if (builtinShpDef && !scope.willUpdate && !(builtinShpDef[1] && !builtinShpDef[1](shape)) && !(needsAnimate && hasShapeAnimation(el)) && !(strokePercent < 1)) {
    svgElType = el.type;
    var mul2 = Math.pow(10, precision);
    builtinShpDef[0](shape, attrs, mul2);
  } else {
    if (!el.path) {
      el.createPathProxy();
    }
    var path = el.path;
    if (el.shapeChanged()) {
      path.beginPath();
      el.buildPath(path, el.shape);
      el.pathUpdated();
    }
    var pathVersion = path.getVersion();
    var elExt = el;
    var svgPathBuilder = elExt.__svgPathBuilder;
    if (elExt.__svgPathVersion !== pathVersion || !svgPathBuilder || strokePercent !== elExt.__svgPathStrokePercent) {
      if (!svgPathBuilder) {
        svgPathBuilder = elExt.__svgPathBuilder = new SVGPathRebuilder$1();
      }
      svgPathBuilder.reset(precision);
      path.rebuildPath(svgPathBuilder, strokePercent);
      svgPathBuilder.generateStr();
      elExt.__svgPathVersion = pathVersion;
      elExt.__svgPathStrokePercent = strokePercent;
    }
    attrs.d = svgPathBuilder.getStr();
  }
  setTransform$2(attrs, el.transform);
  setStyleAttrs(attrs, style2, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode(svgElType, el.id + "", attrs);
}
function brushSVGImage(el, scope) {
  var style2 = el.style;
  var image = style2.image;
  if (image && !isString$1(image)) {
    if (isImageLike(image)) {
      image = image.src;
    } else if (isCanvasLike(image)) {
      image = image.toDataURL();
    }
  }
  if (!image) {
    return;
  }
  var x2 = style2.x || 0;
  var y2 = style2.y || 0;
  var dw = style2.width;
  var dh2 = style2.height;
  var attrs = {
    href: image,
    width: dw,
    height: dh2
  };
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform$2(attrs, el.transform);
  setStyleAttrs(attrs, style2, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("image", el.id + "", attrs);
}
function brushSVGTSpan(el, scope) {
  var style2 = el.style;
  var text = style2.text;
  text != null && (text += "");
  if (!text || isNaN(style2.x) || isNaN(style2.y)) {
    return;
  }
  var font = style2.font || DEFAULT_FONT;
  var x2 = style2.x || 0;
  var y2 = adjustTextY$1(style2.y || 0, getLineHeight(font), style2.textBaseline);
  var textAlign = TEXT_ALIGN_TO_ANCHOR[style2.textAlign] || style2.textAlign;
  var attrs = {
    "dominant-baseline": "central",
    "text-anchor": textAlign
  };
  if (hasSeparateFont(style2)) {
    var separatedFontStr = "";
    var fontStyle = style2.fontStyle;
    var fontSize = parseFontSize(style2.fontSize);
    if (!parseFloat(fontSize)) {
      return;
    }
    var fontFamily = style2.fontFamily || DEFAULT_FONT_FAMILY;
    var fontWeight = style2.fontWeight;
    separatedFontStr += "font-size:" + fontSize + ";font-family:" + fontFamily + ";";
    if (fontStyle && fontStyle !== "normal") {
      separatedFontStr += "font-style:" + fontStyle + ";";
    }
    if (fontWeight && fontWeight !== "normal") {
      separatedFontStr += "font-weight:" + fontWeight + ";";
    }
    attrs.style = separatedFontStr;
  } else {
    attrs.style = "font: " + font;
  }
  if (text.match(/\s/)) {
    attrs["xml:space"] = "preserve";
  }
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform$2(attrs, el.transform);
  setStyleAttrs(attrs, style2, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("text", el.id + "", attrs, void 0, text);
}
function brush(el, scope) {
  if (el instanceof Path$1) {
    return brushSVGPath(el, scope);
  } else if (el instanceof ZRImage$1) {
    return brushSVGImage(el, scope);
  } else if (el instanceof TSpan$1) {
    return brushSVGTSpan(el, scope);
  }
}
function setShadow(el, attrs, scope) {
  var style2 = el.style;
  if (hasShadow(style2)) {
    var shadowKey = getShadowKey(el);
    var shadowCache = scope.shadowCache;
    var shadowId = shadowCache[shadowKey];
    if (!shadowId) {
      var globalScale = el.getGlobalScale();
      var scaleX = globalScale[0];
      var scaleY = globalScale[1];
      if (!scaleX || !scaleY) {
        return;
      }
      var offsetX = style2.shadowOffsetX || 0;
      var offsetY = style2.shadowOffsetY || 0;
      var blur_1 = style2.shadowBlur;
      var _a2 = normalizeColor(style2.shadowColor), opacity = _a2.opacity, color = _a2.color;
      var stdDx = blur_1 / 2 / scaleX;
      var stdDy = blur_1 / 2 / scaleY;
      var stdDeviation = stdDx + " " + stdDy;
      shadowId = scope.zrId + "-s" + scope.shadowIdx++;
      scope.defs[shadowId] = createVNode("filter", shadowId, {
        "id": shadowId,
        "x": "-100%",
        "y": "-100%",
        "width": "300%",
        "height": "300%"
      }, [
        createVNode("feDropShadow", "", {
          "dx": offsetX / scaleX,
          "dy": offsetY / scaleY,
          "stdDeviation": stdDeviation,
          "flood-color": color,
          "flood-opacity": opacity
        })
      ]);
      shadowCache[shadowKey] = shadowId;
    }
    attrs.filter = getIdURL(shadowId);
  }
}
function setGradient(style2, attrs, target, scope) {
  var val = style2[target];
  var gradientTag;
  var gradientAttrs = {
    "gradientUnits": val.global ? "userSpaceOnUse" : "objectBoundingBox"
  };
  if (isLinearGradient(val)) {
    gradientTag = "linearGradient";
    gradientAttrs.x1 = val.x;
    gradientAttrs.y1 = val.y;
    gradientAttrs.x2 = val.x2;
    gradientAttrs.y2 = val.y2;
  } else if (isRadialGradient(val)) {
    gradientTag = "radialGradient";
    gradientAttrs.cx = retrieve2(val.x, 0.5);
    gradientAttrs.cy = retrieve2(val.y, 0.5);
    gradientAttrs.r = retrieve2(val.r, 0.5);
  } else {
    return;
  }
  var colors = val.colorStops;
  var colorStops = [];
  for (var i = 0, len2 = colors.length; i < len2; ++i) {
    var offset2 = round4(colors[i].offset) * 100 + "%";
    var stopColor = colors[i].color;
    var _a2 = normalizeColor(stopColor), color = _a2.color, opacity = _a2.opacity;
    var stopsAttrs = {
      "offset": offset2
    };
    stopsAttrs["stop-color"] = color;
    if (opacity < 1) {
      stopsAttrs["stop-opacity"] = opacity;
    }
    colorStops.push(createVNode("stop", i + "", stopsAttrs));
  }
  var gradientVNode = createVNode(gradientTag, "", gradientAttrs, colorStops);
  var gradientKey = vNodeToString(gradientVNode);
  var gradientCache = scope.gradientCache;
  var gradientId = gradientCache[gradientKey];
  if (!gradientId) {
    gradientId = scope.zrId + "-g" + scope.gradientIdx++;
    gradientCache[gradientKey] = gradientId;
    gradientAttrs.id = gradientId;
    scope.defs[gradientId] = createVNode(gradientTag, gradientId, gradientAttrs, colorStops);
  }
  attrs[target] = getIdURL(gradientId);
}
function setPattern(el, attrs, target, scope) {
  var val = el.style[target];
  var patternAttrs = {
    "patternUnits": "userSpaceOnUse"
  };
  var child;
  if (isImagePattern(val)) {
    var imageWidth_1 = val.imageWidth;
    var imageHeight_1 = val.imageHeight;
    var imageSrc = void 0;
    var patternImage = val.image;
    if (isString$1(patternImage)) {
      imageSrc = patternImage;
    } else if (isImageLike(patternImage)) {
      imageSrc = patternImage.src;
    } else if (isCanvasLike(patternImage)) {
      imageSrc = patternImage.toDataURL();
    }
    if (typeof Image === "undefined") {
      var errMsg = "Image width/height must been given explictly in svg-ssr renderer.";
      assert(imageWidth_1, errMsg);
      assert(imageHeight_1, errMsg);
    } else if (imageWidth_1 == null || imageHeight_1 == null) {
      var setSizeToVNode_1 = function(vNode, img) {
        if (vNode) {
          var svgEl = vNode.elm;
          var width = vNode.attrs.width = imageWidth_1 || img.width;
          var height = vNode.attrs.height = imageHeight_1 || img.height;
          if (svgEl) {
            svgEl.setAttribute("width", width);
            svgEl.setAttribute("height", height);
          }
        }
      };
      var createdImage = createOrUpdateImage(imageSrc, null, el, function(img) {
        setSizeToVNode_1(patternVNode, img);
        setSizeToVNode_1(child, img);
      });
      if (createdImage && createdImage.width && createdImage.height) {
        imageWidth_1 = imageWidth_1 || createdImage.width;
        imageHeight_1 = imageHeight_1 || createdImage.height;
      }
    }
    child = createVNode("image", "img", {
      href: imageSrc,
      width: imageWidth_1,
      height: imageHeight_1
    });
    patternAttrs.width = imageWidth_1;
    patternAttrs.height = imageHeight_1;
  } else if (val.svgElement) {
    child = clone$4(val.svgElement);
    patternAttrs.width = val.svgWidth;
    patternAttrs.height = val.svgHeight;
  }
  if (!child) {
    return;
  }
  patternAttrs.patternTransform = getSRTTransformString(val);
  var patternVNode = createVNode("pattern", "", patternAttrs, [child]);
  var patternKey = vNodeToString(patternVNode);
  var patternCache = scope.patternCache;
  var patternId = patternCache[patternKey];
  if (!patternId) {
    patternId = scope.zrId + "-p" + scope.patternIdx++;
    patternCache[patternKey] = patternId;
    patternAttrs.id = patternId;
    patternVNode = scope.defs[patternId] = createVNode("pattern", patternId, patternAttrs, [child]);
  }
  attrs[target] = getIdURL(patternId);
}
function setClipPath(clipPath, attrs, scope) {
  var clipPathCache = scope.clipPathCache, defs = scope.defs;
  var clipPathId = clipPathCache[clipPath.id];
  if (!clipPathId) {
    clipPathId = scope.zrId + "-c" + scope.clipPathIdx++;
    var clipPathAttrs = {
      id: clipPathId
    };
    clipPathCache[clipPath.id] = clipPathId;
    defs[clipPathId] = createVNode("clipPath", clipPathId, clipPathAttrs, [brushSVGPath(clipPath, scope)]);
  }
  attrs["clip-path"] = getIdURL(clipPathId);
}
function createTextNode(text) {
  return document.createTextNode(text);
}
function insertBefore(parentNode2, newNode, referenceNode) {
  parentNode2.insertBefore(newNode, referenceNode);
}
function removeChild(node, child) {
  node.removeChild(child);
}
function appendChild(node, child) {
  node.appendChild(child);
}
function parentNode(node) {
  return node.parentNode;
}
function nextSibling(node) {
  return node.nextSibling;
}
function setTextContent(node, text) {
  node.textContent = text;
}
var colonChar = 58;
var xChar = 120;
var emptyNode = createVNode("", "");
function isUndef(s) {
  return s === void 0;
}
function isDef(s) {
  return s !== void 0;
}
function createKeyToOldIdx(children, beginIdx, endIdx) {
  var map2 = {};
  for (var i = beginIdx; i <= endIdx; ++i) {
    var key = children[i].key;
    if (key !== void 0) {
      map2[key] = i;
    }
  }
  return map2;
}
function sameVnode(vnode1, vnode2) {
  var isSameKey = vnode1.key === vnode2.key;
  var isSameTag = vnode1.tag === vnode2.tag;
  return isSameTag && isSameKey;
}
function createElm(vnode) {
  var i;
  var children = vnode.children;
  var tag = vnode.tag;
  if (isDef(tag)) {
    var elm = vnode.elm = createElement(tag);
    updateAttrs(emptyNode, vnode);
    if (isArray$1(children)) {
      for (i = 0; i < children.length; ++i) {
        var ch2 = children[i];
        if (ch2 != null) {
          appendChild(elm, createElm(ch2));
        }
      }
    } else if (isDef(vnode.text) && !isObject$4(vnode.text)) {
      appendChild(elm, createTextNode(vnode.text));
    }
  } else {
    vnode.elm = createTextNode(vnode.text);
  }
  return vnode.elm;
}
function addVnodes(parentElm, before, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch2 = vnodes[startIdx];
    if (ch2 != null) {
      insertBefore(parentElm, createElm(ch2), before);
    }
  }
}
function removeVnodes(parentElm, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch2 = vnodes[startIdx];
    if (ch2 != null) {
      if (isDef(ch2.tag)) {
        var parent_1 = parentNode(ch2.elm);
        removeChild(parent_1, ch2.elm);
      } else {
        removeChild(parentElm, ch2.elm);
      }
    }
  }
}
function updateAttrs(oldVnode, vnode) {
  var key;
  var elm = vnode.elm;
  var oldAttrs = oldVnode && oldVnode.attrs || {};
  var attrs = vnode.attrs || {};
  if (oldAttrs === attrs) {
    return;
  }
  for (key in attrs) {
    var cur = attrs[key];
    var old = oldAttrs[key];
    if (old !== cur) {
      if (cur === true) {
        elm.setAttribute(key, "");
      } else if (cur === false) {
        elm.removeAttribute(key);
      } else {
        if (key.charCodeAt(0) !== xChar) {
          elm.setAttribute(key, cur);
        } else if (key === "xmlns:xlink" || key === "xmlns") {
          elm.setAttributeNS(XMLNS, key, cur);
        } else if (key.charCodeAt(3) === colonChar) {
          elm.setAttributeNS(XML_NAMESPACE, key, cur);
        } else if (key.charCodeAt(5) === colonChar) {
          elm.setAttributeNS(XLINKNS, key, cur);
        } else {
          elm.setAttribute(key, cur);
        }
      }
    }
  }
  for (key in oldAttrs) {
    if (!(key in attrs)) {
      elm.removeAttribute(key);
    }
  }
}
function updateChildren(parentElm, oldCh, newCh) {
  var oldStartIdx = 0;
  var newStartIdx = 0;
  var oldEndIdx = oldCh.length - 1;
  var oldStartVnode = oldCh[0];
  var oldEndVnode = oldCh[oldEndIdx];
  var newEndIdx = newCh.length - 1;
  var newStartVnode = newCh[0];
  var newEndVnode = newCh[newEndIdx];
  var oldKeyToIdx;
  var idxInOld;
  var elmToMove;
  var before;
  while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
    if (oldStartVnode == null) {
      oldStartVnode = oldCh[++oldStartIdx];
    } else if (oldEndVnode == null) {
      oldEndVnode = oldCh[--oldEndIdx];
    } else if (newStartVnode == null) {
      newStartVnode = newCh[++newStartIdx];
    } else if (newEndVnode == null) {
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newStartVnode)) {
      patchVnode(oldStartVnode, newStartVnode);
      oldStartVnode = oldCh[++oldStartIdx];
      newStartVnode = newCh[++newStartIdx];
    } else if (sameVnode(oldEndVnode, newEndVnode)) {
      patchVnode(oldEndVnode, newEndVnode);
      oldEndVnode = oldCh[--oldEndIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newEndVnode)) {
      patchVnode(oldStartVnode, newEndVnode);
      insertBefore(parentElm, oldStartVnode.elm, nextSibling(oldEndVnode.elm));
      oldStartVnode = oldCh[++oldStartIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldEndVnode, newStartVnode)) {
      patchVnode(oldEndVnode, newStartVnode);
      insertBefore(parentElm, oldEndVnode.elm, oldStartVnode.elm);
      oldEndVnode = oldCh[--oldEndIdx];
      newStartVnode = newCh[++newStartIdx];
    } else {
      if (isUndef(oldKeyToIdx)) {
        oldKeyToIdx = createKeyToOldIdx(oldCh, oldStartIdx, oldEndIdx);
      }
      idxInOld = oldKeyToIdx[newStartVnode.key];
      if (isUndef(idxInOld)) {
        insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
      } else {
        elmToMove = oldCh[idxInOld];
        if (elmToMove.tag !== newStartVnode.tag) {
          insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
        } else {
          patchVnode(elmToMove, newStartVnode);
          oldCh[idxInOld] = void 0;
          insertBefore(parentElm, elmToMove.elm, oldStartVnode.elm);
        }
      }
      newStartVnode = newCh[++newStartIdx];
    }
  }
  if (oldStartIdx <= oldEndIdx || newStartIdx <= newEndIdx) {
    if (oldStartIdx > oldEndIdx) {
      before = newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].elm;
      addVnodes(parentElm, before, newCh, newStartIdx, newEndIdx);
    } else {
      removeVnodes(parentElm, oldCh, oldStartIdx, oldEndIdx);
    }
  }
}
function patchVnode(oldVnode, vnode) {
  var elm = vnode.elm = oldVnode.elm;
  var oldCh = oldVnode.children;
  var ch2 = vnode.children;
  if (oldVnode === vnode) {
    return;
  }
  updateAttrs(oldVnode, vnode);
  if (isUndef(vnode.text)) {
    if (isDef(oldCh) && isDef(ch2)) {
      if (oldCh !== ch2) {
        updateChildren(elm, oldCh, ch2);
      }
    } else if (isDef(ch2)) {
      if (isDef(oldVnode.text)) {
        setTextContent(elm, "");
      }
      addVnodes(elm, null, ch2, 0, ch2.length - 1);
    } else if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    } else if (isDef(oldVnode.text)) {
      setTextContent(elm, "");
    }
  } else if (oldVnode.text !== vnode.text) {
    if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    }
    setTextContent(elm, vnode.text);
  }
}
function patch(oldVnode, vnode) {
  if (sameVnode(oldVnode, vnode)) {
    patchVnode(oldVnode, vnode);
  } else {
    var elm = oldVnode.elm;
    var parent_2 = parentNode(elm);
    createElm(vnode);
    if (parent_2 !== null) {
      insertBefore(parent_2, vnode.elm, nextSibling(elm));
      removeVnodes(parent_2, [oldVnode], 0, 0);
    }
  }
  return vnode;
}
var svgId = 0;
var SVGPainter = function() {
  function SVGPainter2(root2, storage2, opts) {
    this.type = "svg";
    this.refreshHover = createMethodNotSupport();
    this.configLayer = createMethodNotSupport();
    this.storage = storage2;
    this._opts = opts = extend({}, opts);
    this.root = root2;
    this._id = "zr" + svgId++;
    this._oldVNode = createSVGVNode(opts.width, opts.height);
    if (root2 && !opts.ssr) {
      var viewport = this._viewport = document.createElement("div");
      viewport.style.cssText = "position:relative;overflow:hidden";
      var svgDom = this._svgDom = this._oldVNode.elm = createElement("svg");
      updateAttrs(null, this._oldVNode);
      viewport.appendChild(svgDom);
      root2.appendChild(viewport);
    }
    this.resize(opts.width, opts.height);
  }
  SVGPainter2.prototype.getType = function() {
    return this.type;
  };
  SVGPainter2.prototype.getViewportRoot = function() {
    return this._viewport;
  };
  SVGPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  SVGPainter2.prototype.getSvgDom = function() {
    return this._svgDom;
  };
  SVGPainter2.prototype.refresh = function() {
    if (this.root) {
      var vnode = this.renderToVNode({
        willUpdate: true
      });
      vnode.attrs.style = "position:absolute;left:0;top:0;user-select:none";
      patch(this._oldVNode, vnode);
      this._oldVNode = vnode;
    }
  };
  SVGPainter2.prototype.renderOneToVNode = function(el) {
    return brush(el, createBrushScope(this._id));
  };
  SVGPainter2.prototype.renderToVNode = function(opts) {
    opts = opts || {};
    var list = this.storage.getDisplayList(true);
    var bgColor = this._backgroundColor;
    var width = this._width;
    var height = this._height;
    var scope = createBrushScope(this._id);
    scope.animation = opts.animation;
    scope.willUpdate = opts.willUpdate;
    scope.compress = opts.compress;
    var children = [];
    if (bgColor && bgColor !== "none") {
      var _a2 = normalizeColor(bgColor), color = _a2.color, opacity = _a2.opacity;
      this._bgVNode = createVNode("rect", "bg", {
        width,
        height,
        x: "0",
        y: "0",
        id: "0",
        fill: color,
        "fill-opacity": opacity
      });
      children.push(this._bgVNode);
    } else {
      this._bgVNode = null;
    }
    var mainVNode = !opts.compress ? this._mainVNode = createVNode("g", "main", {}, []) : null;
    this._paintList(list, scope, mainVNode ? mainVNode.children : children);
    mainVNode && children.push(mainVNode);
    var defs = map$1(keys(scope.defs), function(id2) {
      return scope.defs[id2];
    });
    if (defs.length) {
      children.push(createVNode("defs", "defs", {}, defs));
    }
    if (opts.animation) {
      var animationCssStr = getCssString(scope.cssNodes, scope.cssAnims, { newline: true });
      if (animationCssStr) {
        var styleNode = createVNode("style", "stl", {}, [], animationCssStr);
        children.push(styleNode);
      }
    }
    return createSVGVNode(width, height, children, opts.useViewBox);
  };
  SVGPainter2.prototype.renderToString = function(opts) {
    opts = opts || {};
    return vNodeToString(this.renderToVNode({
      animation: retrieve2(opts.cssAnimation, true),
      willUpdate: false,
      compress: true,
      useViewBox: retrieve2(opts.useViewBox, true)
    }), { newline: true });
  };
  SVGPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    var bgVNode = this._bgVNode;
    if (bgVNode && bgVNode.elm) {
      var _a2 = normalizeColor(backgroundColor2), color = _a2.color, opacity = _a2.opacity;
      bgVNode.elm.setAttribute("fill", color);
      if (opacity < 1) {
        bgVNode.elm.setAttribute("fill-opacity", opacity);
      }
    }
  };
  SVGPainter2.prototype.getSvgRoot = function() {
    return this._mainVNode && this._mainVNode.elm;
  };
  SVGPainter2.prototype._paintList = function(list, scope, out2) {
    var listLen = list.length;
    var clipPathsGroupsStack = [];
    var clipPathsGroupsStackDepth = 0;
    var currentClipPathGroup;
    var prevClipPaths;
    var clipGroupNodeIdx = 0;
    for (var i = 0; i < listLen; i++) {
      var displayable = list[i];
      if (!displayable.invisible) {
        var clipPaths = displayable.__clipPaths;
        var len2 = clipPaths && clipPaths.length || 0;
        var prevLen = prevClipPaths && prevClipPaths.length || 0;
        var lca = void 0;
        for (lca = Math.max(len2 - 1, prevLen - 1); lca >= 0; lca--) {
          if (clipPaths && prevClipPaths && clipPaths[lca] === prevClipPaths[lca]) {
            break;
          }
        }
        for (var i_1 = prevLen - 1; i_1 > lca; i_1--) {
          clipPathsGroupsStackDepth--;
          currentClipPathGroup = clipPathsGroupsStack[clipPathsGroupsStackDepth - 1];
        }
        for (var i_2 = lca + 1; i_2 < len2; i_2++) {
          var groupAttrs = {};
          setClipPath(clipPaths[i_2], groupAttrs, scope);
          var g2 = createVNode("g", "clip-g-" + clipGroupNodeIdx++, groupAttrs, []);
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(g2);
          clipPathsGroupsStack[clipPathsGroupsStackDepth++] = g2;
          currentClipPathGroup = g2;
        }
        prevClipPaths = clipPaths;
        var ret = brush(displayable, scope);
        if (ret) {
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(ret);
        }
      }
    }
  };
  SVGPainter2.prototype.resize = function(width, height) {
    var opts = this._opts;
    var root2 = this.root;
    var viewport = this._viewport;
    width != null && (opts.width = width);
    height != null && (opts.height = height);
    if (root2 && viewport) {
      viewport.style.display = "none";
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      viewport.style.display = "";
    }
    if (this._width !== width || this._height !== height) {
      this._width = width;
      this._height = height;
      if (viewport) {
        var viewportStyle = viewport.style;
        viewportStyle.width = width + "px";
        viewportStyle.height = height + "px";
      }
      var svgDom = this._svgDom;
      if (svgDom) {
        svgDom.setAttribute("width", width);
        svgDom.setAttribute("height", height);
      }
    }
  };
  SVGPainter2.prototype.getWidth = function() {
    return this._width;
  };
  SVGPainter2.prototype.getHeight = function() {
    return this._height;
  };
  SVGPainter2.prototype.dispose = function() {
    if (this.root) {
      this.root.innerHTML = "";
    }
    this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
  };
  SVGPainter2.prototype.clear = function() {
    if (this._svgDom) {
      this._svgDom.innerHTML = null;
    }
    this._oldVNode = null;
  };
  SVGPainter2.prototype.toDataURL = function(base64) {
    var str = encodeURIComponent(this.renderToString());
    var prefix = "data:image/svg+xml;";
    if (base64) {
      str = encodeBase64(str);
      return str && prefix + "base64," + str;
    }
    return prefix + "charset=UTF-8," + str;
  };
  return SVGPainter2;
}();
function createMethodNotSupport(method4) {
  return function() {
  };
}
var SVGPainter$1 = SVGPainter;
function install$S(registers) {
  registers.registerPainter("svg", SVGPainter$1);
}
function createDom(id2, painter, dpr2) {
  var newDom = platformApi.createCanvas();
  var width = painter.getWidth();
  var height = painter.getHeight();
  var newDomStyle = newDom.style;
  if (newDomStyle) {
    newDomStyle.position = "absolute";
    newDomStyle.left = "0";
    newDomStyle.top = "0";
    newDomStyle.width = width + "px";
    newDomStyle.height = height + "px";
    newDom.setAttribute("data-zr-dom-id", id2);
  }
  newDom.width = width * dpr2;
  newDom.height = height * dpr2;
  return newDom;
}
var Layer = function(_super) {
  __extends(Layer2, _super);
  function Layer2(id2, painter, dpr2) {
    var _this = _super.call(this) || this;
    _this.motionBlur = false;
    _this.lastFrameAlpha = 0.7;
    _this.dpr = 1;
    _this.virtual = false;
    _this.config = {};
    _this.incremental = false;
    _this.zlevel = 0;
    _this.maxRepaintRectCount = 5;
    _this.__dirty = true;
    _this.__firstTimePaint = true;
    _this.__used = false;
    _this.__drawIndex = 0;
    _this.__startIndex = 0;
    _this.__endIndex = 0;
    _this.__prevStartIndex = null;
    _this.__prevEndIndex = null;
    var dom;
    dpr2 = dpr2 || devicePixelRatio;
    if (typeof id2 === "string") {
      dom = createDom(id2, painter, dpr2);
    } else if (isObject$4(id2)) {
      dom = id2;
      id2 = dom.id;
    }
    _this.id = id2;
    _this.dom = dom;
    var domStyle = dom.style;
    if (domStyle) {
      disableUserSelect(dom);
      dom.onselectstart = function() {
        return false;
      };
      domStyle.padding = "0";
      domStyle.margin = "0";
      domStyle.borderWidth = "0";
    }
    _this.painter = painter;
    _this.dpr = dpr2;
    return _this;
  }
  Layer2.prototype.getElementCount = function() {
    return this.__endIndex - this.__startIndex;
  };
  Layer2.prototype.afterBrush = function() {
    this.__prevStartIndex = this.__startIndex;
    this.__prevEndIndex = this.__endIndex;
  };
  Layer2.prototype.initContext = function() {
    this.ctx = this.dom.getContext("2d");
    this.ctx.dpr = this.dpr;
  };
  Layer2.prototype.setUnpainted = function() {
    this.__firstTimePaint = true;
  };
  Layer2.prototype.createBackBuffer = function() {
    var dpr2 = this.dpr;
    this.domBack = createDom("back-" + this.id, this.painter, dpr2);
    this.ctxBack = this.domBack.getContext("2d");
    if (dpr2 !== 1) {
      this.ctxBack.scale(dpr2, dpr2);
    }
  };
  Layer2.prototype.createRepaintRects = function(displayList, prevList, viewWidth, viewHeight) {
    if (this.__firstTimePaint) {
      this.__firstTimePaint = false;
      return null;
    }
    var mergedRepaintRects = [];
    var maxRepaintRectCount = this.maxRepaintRectCount;
    var full = false;
    var pendingRect = new BoundingRect$1(0, 0, 0, 0);
    function addRectToMergePool(rect) {
      if (!rect.isFinite() || rect.isZero()) {
        return;
      }
      if (mergedRepaintRects.length === 0) {
        var boundingRect = new BoundingRect$1(0, 0, 0, 0);
        boundingRect.copy(rect);
        mergedRepaintRects.push(boundingRect);
      } else {
        var isMerged = false;
        var minDeltaArea = Infinity;
        var bestRectToMergeIdx = 0;
        for (var i2 = 0; i2 < mergedRepaintRects.length; ++i2) {
          var mergedRect = mergedRepaintRects[i2];
          if (mergedRect.intersect(rect)) {
            var pendingRect_1 = new BoundingRect$1(0, 0, 0, 0);
            pendingRect_1.copy(mergedRect);
            pendingRect_1.union(rect);
            mergedRepaintRects[i2] = pendingRect_1;
            isMerged = true;
            break;
          } else if (full) {
            pendingRect.copy(rect);
            pendingRect.union(mergedRect);
            var aArea = rect.width * rect.height;
            var bArea = mergedRect.width * mergedRect.height;
            var pendingArea = pendingRect.width * pendingRect.height;
            var deltaArea = pendingArea - aArea - bArea;
            if (deltaArea < minDeltaArea) {
              minDeltaArea = deltaArea;
              bestRectToMergeIdx = i2;
            }
          }
        }
        if (full) {
          mergedRepaintRects[bestRectToMergeIdx].union(rect);
          isMerged = true;
        }
        if (!isMerged) {
          var boundingRect = new BoundingRect$1(0, 0, 0, 0);
          boundingRect.copy(rect);
          mergedRepaintRects.push(boundingRect);
        }
        if (!full) {
          full = mergedRepaintRects.length >= maxRepaintRectCount;
        }
      }
    }
    for (var i = this.__startIndex; i < this.__endIndex; ++i) {
      var el = displayList[i];
      if (el) {
        var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
        var prevRect = el.__isRendered && (el.__dirty & REDRAW_BIT || !shouldPaint) ? el.getPrevPaintRect() : null;
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
        var curRect = shouldPaint && (el.__dirty & REDRAW_BIT || !el.__isRendered) ? el.getPaintRect() : null;
        if (curRect) {
          addRectToMergePool(curRect);
        }
      }
    }
    for (var i = this.__prevStartIndex; i < this.__prevEndIndex; ++i) {
      var el = prevList[i];
      var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
      if (el && (!shouldPaint || !el.__zr) && el.__isRendered) {
        var prevRect = el.getPrevPaintRect();
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
      }
    }
    var hasIntersections;
    do {
      hasIntersections = false;
      for (var i = 0; i < mergedRepaintRects.length; ) {
        if (mergedRepaintRects[i].isZero()) {
          mergedRepaintRects.splice(i, 1);
          continue;
        }
        for (var j = i + 1; j < mergedRepaintRects.length; ) {
          if (mergedRepaintRects[i].intersect(mergedRepaintRects[j])) {
            hasIntersections = true;
            mergedRepaintRects[i].union(mergedRepaintRects[j]);
            mergedRepaintRects.splice(j, 1);
          } else {
            j++;
          }
        }
        i++;
      }
    } while (hasIntersections);
    this._paintRects = mergedRepaintRects;
    return mergedRepaintRects;
  };
  Layer2.prototype.debugGetPaintRects = function() {
    return (this._paintRects || []).slice();
  };
  Layer2.prototype.resize = function(width, height) {
    var dpr2 = this.dpr;
    var dom = this.dom;
    var domStyle = dom.style;
    var domBack = this.domBack;
    if (domStyle) {
      domStyle.width = width + "px";
      domStyle.height = height + "px";
    }
    dom.width = width * dpr2;
    dom.height = height * dpr2;
    if (domBack) {
      domBack.width = width * dpr2;
      domBack.height = height * dpr2;
      if (dpr2 !== 1) {
        this.ctxBack.scale(dpr2, dpr2);
      }
    }
  };
  Layer2.prototype.clear = function(clearAll, clearColor, repaintRects) {
    var dom = this.dom;
    var ctx = this.ctx;
    var width = dom.width;
    var height = dom.height;
    clearColor = clearColor || this.clearColor;
    var haveMotionBLur = this.motionBlur && !clearAll;
    var lastFrameAlpha = this.lastFrameAlpha;
    var dpr2 = this.dpr;
    var self2 = this;
    if (haveMotionBLur) {
      if (!this.domBack) {
        this.createBackBuffer();
      }
      this.ctxBack.globalCompositeOperation = "copy";
      this.ctxBack.drawImage(dom, 0, 0, width / dpr2, height / dpr2);
    }
    var domBack = this.domBack;
    function doClear(x2, y2, width2, height2) {
      ctx.clearRect(x2, y2, width2, height2);
      if (clearColor && clearColor !== "transparent") {
        var clearColorGradientOrPattern = void 0;
        if (isGradientObject(clearColor)) {
          clearColorGradientOrPattern = clearColor.__canvasGradient || getCanvasGradient(ctx, clearColor, {
            x: 0,
            y: 0,
            width: width2,
            height: height2
          });
          clearColor.__canvasGradient = clearColorGradientOrPattern;
        } else if (isImagePatternObject(clearColor)) {
          clearColorGradientOrPattern = createCanvasPattern(ctx, clearColor, {
            dirty: function() {
              self2.setUnpainted();
              self2.__painter.refresh();
            }
          });
        }
        ctx.save();
        ctx.fillStyle = clearColorGradientOrPattern || clearColor;
        ctx.fillRect(x2, y2, width2, height2);
        ctx.restore();
      }
      if (haveMotionBLur) {
        ctx.save();
        ctx.globalAlpha = lastFrameAlpha;
        ctx.drawImage(domBack, x2, y2, width2, height2);
        ctx.restore();
      }
    }
    if (!repaintRects || haveMotionBLur) {
      doClear(0, 0, width, height);
    } else if (repaintRects.length) {
      each$g(repaintRects, function(rect) {
        doClear(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
      });
    }
  };
  return Layer2;
}(Eventful$1);
var Layer$1 = Layer;
var HOVER_LAYER_ZLEVEL = 1e5;
var CANVAS_ZLEVEL = 314159;
var EL_AFTER_INCREMENTAL_INC = 0.01;
var INCREMENTAL_INC = 1e-3;
function isLayerValid(layer) {
  if (!layer) {
    return false;
  }
  if (layer.__builtin__) {
    return true;
  }
  if (typeof layer.resize !== "function" || typeof layer.refresh !== "function") {
    return false;
  }
  return true;
}
function createRoot(width, height) {
  var domRoot = document.createElement("div");
  domRoot.style.cssText = [
    "position:relative",
    "width:" + width + "px",
    "height:" + height + "px",
    "padding:0",
    "margin:0",
    "border-width:0"
  ].join(";") + ";";
  return domRoot;
}
var CanvasPainter = function() {
  function CanvasPainter2(root2, storage2, opts, id2) {
    this.type = "canvas";
    this._zlevelList = [];
    this._prevDisplayList = [];
    this._layers = {};
    this._layerConfig = {};
    this._needsManuallyCompositing = false;
    this.type = "canvas";
    var singleCanvas = !root2.nodeName || root2.nodeName.toUpperCase() === "CANVAS";
    this._opts = opts = extend({}, opts || {});
    this.dpr = opts.devicePixelRatio || devicePixelRatio;
    this._singleCanvas = singleCanvas;
    this.root = root2;
    var rootStyle = root2.style;
    if (rootStyle) {
      disableUserSelect(root2);
      root2.innerHTML = "";
    }
    this.storage = storage2;
    var zlevelList = this._zlevelList;
    this._prevDisplayList = [];
    var layers = this._layers;
    if (!singleCanvas) {
      this._width = getSize$1(root2, 0, opts);
      this._height = getSize$1(root2, 1, opts);
      var domRoot = this._domRoot = createRoot(this._width, this._height);
      root2.appendChild(domRoot);
    } else {
      var rootCanvas = root2;
      var width = rootCanvas.width;
      var height = rootCanvas.height;
      if (opts.width != null) {
        width = opts.width;
      }
      if (opts.height != null) {
        height = opts.height;
      }
      this.dpr = opts.devicePixelRatio || 1;
      rootCanvas.width = width * this.dpr;
      rootCanvas.height = height * this.dpr;
      this._width = width;
      this._height = height;
      var mainLayer = new Layer$1(rootCanvas, this, this.dpr);
      mainLayer.__builtin__ = true;
      mainLayer.initContext();
      layers[CANVAS_ZLEVEL] = mainLayer;
      mainLayer.zlevel = CANVAS_ZLEVEL;
      zlevelList.push(CANVAS_ZLEVEL);
      this._domRoot = root2;
    }
  }
  CanvasPainter2.prototype.getType = function() {
    return "canvas";
  };
  CanvasPainter2.prototype.isSingleCanvas = function() {
    return this._singleCanvas;
  };
  CanvasPainter2.prototype.getViewportRoot = function() {
    return this._domRoot;
  };
  CanvasPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  CanvasPainter2.prototype.refresh = function(paintAll) {
    var list = this.storage.getDisplayList(true);
    var prevList = this._prevDisplayList;
    var zlevelList = this._zlevelList;
    this._redrawId = Math.random();
    this._paintList(list, prevList, paintAll, this._redrawId);
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__ && layer.refresh) {
        var clearColor = i === 0 ? this._backgroundColor : null;
        layer.refresh(clearColor);
      }
    }
    if (this._opts.useDirtyRect) {
      this._prevDisplayList = list.slice();
    }
    return this;
  };
  CanvasPainter2.prototype.refreshHover = function() {
    this._paintHoverList(this.storage.getDisplayList(false));
  };
  CanvasPainter2.prototype._paintHoverList = function(list) {
    var len2 = list.length;
    var hoverLayer = this._hoverlayer;
    hoverLayer && hoverLayer.clear();
    if (!len2) {
      return;
    }
    var scope = {
      inHover: true,
      viewWidth: this._width,
      viewHeight: this._height
    };
    var ctx;
    for (var i = 0; i < len2; i++) {
      var el = list[i];
      if (el.__inHover) {
        if (!hoverLayer) {
          hoverLayer = this._hoverlayer = this.getLayer(HOVER_LAYER_ZLEVEL);
        }
        if (!ctx) {
          ctx = hoverLayer.ctx;
          ctx.save();
        }
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    if (ctx) {
      ctx.restore();
    }
  };
  CanvasPainter2.prototype.getHoverLayer = function() {
    return this.getLayer(HOVER_LAYER_ZLEVEL);
  };
  CanvasPainter2.prototype.paintOne = function(ctx, el) {
    brushSingle(ctx, el);
  };
  CanvasPainter2.prototype._paintList = function(list, prevList, paintAll, redrawId) {
    if (this._redrawId !== redrawId) {
      return;
    }
    paintAll = paintAll || false;
    this._updateLayerStatus(list);
    var _a2 = this._doPaintList(list, prevList, paintAll), finished = _a2.finished, needsRefreshHover = _a2.needsRefreshHover;
    if (this._needsManuallyCompositing) {
      this._compositeManually();
    }
    if (needsRefreshHover) {
      this._paintHoverList(list);
    }
    if (!finished) {
      var self_1 = this;
      requestAnimationFrame$2(function() {
        self_1._paintList(list, prevList, paintAll, redrawId);
      });
    } else {
      this.eachLayer(function(layer) {
        layer.afterBrush && layer.afterBrush();
      });
    }
  };
  CanvasPainter2.prototype._compositeManually = function() {
    var ctx = this.getLayer(CANVAS_ZLEVEL).ctx;
    var width = this._domRoot.width;
    var height = this._domRoot.height;
    ctx.clearRect(0, 0, width, height);
    this.eachBuiltinLayer(function(layer) {
      if (layer.virtual) {
        ctx.drawImage(layer.dom, 0, 0, width, height);
      }
    });
  };
  CanvasPainter2.prototype._doPaintList = function(list, prevList, paintAll) {
    var _this = this;
    var layerList = [];
    var useDirtyRect = this._opts.useDirtyRect;
    for (var zi2 = 0; zi2 < this._zlevelList.length; zi2++) {
      var zlevel = this._zlevelList[zi2];
      var layer = this._layers[zlevel];
      if (layer.__builtin__ && layer !== this._hoverlayer && (layer.__dirty || paintAll)) {
        layerList.push(layer);
      }
    }
    var finished = true;
    var needsRefreshHover = false;
    var _loop_1 = function(k3) {
      var layer2 = layerList[k3];
      var ctx = layer2.ctx;
      var repaintRects = useDirtyRect && layer2.createRepaintRects(list, prevList, this_1._width, this_1._height);
      var start2 = paintAll ? layer2.__startIndex : layer2.__drawIndex;
      var useTimer = !paintAll && layer2.incremental && Date.now;
      var startTime = useTimer && Date.now();
      var clearColor = layer2.zlevel === this_1._zlevelList[0] ? this_1._backgroundColor : null;
      if (layer2.__startIndex === layer2.__endIndex) {
        layer2.clear(false, clearColor, repaintRects);
      } else if (start2 === layer2.__startIndex) {
        var firstEl = list[start2];
        if (!firstEl.incremental || !firstEl.notClear || paintAll) {
          layer2.clear(false, clearColor, repaintRects);
        }
      }
      if (start2 === -1) {
        console.error("For some unknown reason. drawIndex is -1");
        start2 = layer2.__startIndex;
      }
      var i;
      var repaint = function(repaintRect) {
        var scope = {
          inHover: false,
          allClipped: false,
          prevEl: null,
          viewWidth: _this._width,
          viewHeight: _this._height
        };
        for (i = start2; i < layer2.__endIndex; i++) {
          var el = list[i];
          if (el.__inHover) {
            needsRefreshHover = true;
          }
          _this._doPaintEl(el, layer2, useDirtyRect, repaintRect, scope, i === layer2.__endIndex - 1);
          if (useTimer) {
            var dTime = Date.now() - startTime;
            if (dTime > 15) {
              break;
            }
          }
        }
        if (scope.prevElClipPaths) {
          ctx.restore();
        }
      };
      if (repaintRects) {
        if (repaintRects.length === 0) {
          i = layer2.__endIndex;
        } else {
          var dpr2 = this_1.dpr;
          for (var r2 = 0; r2 < repaintRects.length; ++r2) {
            var rect = repaintRects[r2];
            ctx.save();
            ctx.beginPath();
            ctx.rect(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
            ctx.clip();
            repaint(rect);
            ctx.restore();
          }
        }
      } else {
        ctx.save();
        repaint();
        ctx.restore();
      }
      layer2.__drawIndex = i;
      if (layer2.__drawIndex < layer2.__endIndex) {
        finished = false;
      }
    };
    var this_1 = this;
    for (var k2 = 0; k2 < layerList.length; k2++) {
      _loop_1(k2);
    }
    if (env$1.wxa) {
      each$g(this._layers, function(layer2) {
        if (layer2 && layer2.ctx && layer2.ctx.draw) {
          layer2.ctx.draw();
        }
      });
    }
    return {
      finished,
      needsRefreshHover
    };
  };
  CanvasPainter2.prototype._doPaintEl = function(el, currentLayer, useDirtyRect, repaintRect, scope, isLast) {
    var ctx = currentLayer.ctx;
    if (useDirtyRect) {
      var paintRect = el.getPaintRect();
      if (!repaintRect || paintRect && paintRect.intersect(repaintRect)) {
        brush$1(ctx, el, scope, isLast);
        el.setPrevPaintRect(paintRect);
      }
    } else {
      brush$1(ctx, el, scope, isLast);
    }
  };
  CanvasPainter2.prototype.getLayer = function(zlevel, virtual) {
    if (this._singleCanvas && !this._needsManuallyCompositing) {
      zlevel = CANVAS_ZLEVEL;
    }
    var layer = this._layers[zlevel];
    if (!layer) {
      layer = new Layer$1("zr_" + zlevel, this, this.dpr);
      layer.zlevel = zlevel;
      layer.__builtin__ = true;
      if (this._layerConfig[zlevel]) {
        merge(layer, this._layerConfig[zlevel], true);
      } else if (this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC]) {
        merge(layer, this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC], true);
      }
      if (virtual) {
        layer.virtual = virtual;
      }
      this.insertLayer(zlevel, layer);
      layer.initContext();
    }
    return layer;
  };
  CanvasPainter2.prototype.insertLayer = function(zlevel, layer) {
    var layersMap = this._layers;
    var zlevelList = this._zlevelList;
    var len2 = zlevelList.length;
    var domRoot = this._domRoot;
    var prevLayer = null;
    var i = -1;
    if (layersMap[zlevel]) {
      return;
    }
    if (!isLayerValid(layer)) {
      return;
    }
    if (len2 > 0 && zlevel > zlevelList[0]) {
      for (i = 0; i < len2 - 1; i++) {
        if (zlevelList[i] < zlevel && zlevelList[i + 1] > zlevel) {
          break;
        }
      }
      prevLayer = layersMap[zlevelList[i]];
    }
    zlevelList.splice(i + 1, 0, zlevel);
    layersMap[zlevel] = layer;
    if (!layer.virtual) {
      if (prevLayer) {
        var prevDom = prevLayer.dom;
        if (prevDom.nextSibling) {
          domRoot.insertBefore(layer.dom, prevDom.nextSibling);
        } else {
          domRoot.appendChild(layer.dom);
        }
      } else {
        if (domRoot.firstChild) {
          domRoot.insertBefore(layer.dom, domRoot.firstChild);
        } else {
          domRoot.appendChild(layer.dom);
        }
      }
    }
    layer.__painter = this;
  };
  CanvasPainter2.prototype.eachLayer = function(cb2, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      cb2.call(context, this._layers[z2], z2);
    }
  };
  CanvasPainter2.prototype.eachBuiltinLayer = function(cb2, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (layer.__builtin__) {
        cb2.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.eachOtherLayer = function(cb2, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__) {
        cb2.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.getLayers = function() {
    return this._layers;
  };
  CanvasPainter2.prototype._updateLayerStatus = function(list) {
    this.eachBuiltinLayer(function(layer2, z2) {
      layer2.__dirty = layer2.__used = false;
    });
    function updatePrevLayer(idx) {
      if (prevLayer) {
        if (prevLayer.__endIndex !== idx) {
          prevLayer.__dirty = true;
        }
        prevLayer.__endIndex = idx;
      }
    }
    if (this._singleCanvas) {
      for (var i_1 = 1; i_1 < list.length; i_1++) {
        var el = list[i_1];
        if (el.zlevel !== list[i_1 - 1].zlevel || el.incremental) {
          this._needsManuallyCompositing = true;
          break;
        }
      }
    }
    var prevLayer = null;
    var incrementalLayerCount = 0;
    var prevZlevel;
    var i;
    for (i = 0; i < list.length; i++) {
      var el = list[i];
      var zlevel = el.zlevel;
      var layer = void 0;
      if (prevZlevel !== zlevel) {
        prevZlevel = zlevel;
        incrementalLayerCount = 0;
      }
      if (el.incremental) {
        layer = this.getLayer(zlevel + INCREMENTAL_INC, this._needsManuallyCompositing);
        layer.incremental = true;
        incrementalLayerCount = 1;
      } else {
        layer = this.getLayer(zlevel + (incrementalLayerCount > 0 ? EL_AFTER_INCREMENTAL_INC : 0), this._needsManuallyCompositing);
      }
      if (!layer.__builtin__) {
        logError("ZLevel " + zlevel + " has been used by unkown layer " + layer.id);
      }
      if (layer !== prevLayer) {
        layer.__used = true;
        if (layer.__startIndex !== i) {
          layer.__dirty = true;
        }
        layer.__startIndex = i;
        if (!layer.incremental) {
          layer.__drawIndex = i;
        } else {
          layer.__drawIndex = -1;
        }
        updatePrevLayer(i);
        prevLayer = layer;
      }
      if (el.__dirty & REDRAW_BIT && !el.__inHover) {
        layer.__dirty = true;
        if (layer.incremental && layer.__drawIndex < 0) {
          layer.__drawIndex = i;
        }
      }
    }
    updatePrevLayer(i);
    this.eachBuiltinLayer(function(layer2, z2) {
      if (!layer2.__used && layer2.getElementCount() > 0) {
        layer2.__dirty = true;
        layer2.__startIndex = layer2.__endIndex = layer2.__drawIndex = 0;
      }
      if (layer2.__dirty && layer2.__drawIndex < 0) {
        layer2.__drawIndex = layer2.__startIndex;
      }
    });
  };
  CanvasPainter2.prototype.clear = function() {
    this.eachBuiltinLayer(this._clearLayer);
    return this;
  };
  CanvasPainter2.prototype._clearLayer = function(layer) {
    layer.clear();
  };
  CanvasPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    each$g(this._layers, function(layer) {
      layer.setUnpainted();
    });
  };
  CanvasPainter2.prototype.configLayer = function(zlevel, config) {
    if (config) {
      var layerConfig = this._layerConfig;
      if (!layerConfig[zlevel]) {
        layerConfig[zlevel] = config;
      } else {
        merge(layerConfig[zlevel], config, true);
      }
      for (var i = 0; i < this._zlevelList.length; i++) {
        var _zlevel = this._zlevelList[i];
        if (_zlevel === zlevel || _zlevel === zlevel + EL_AFTER_INCREMENTAL_INC) {
          var layer = this._layers[_zlevel];
          merge(layer, layerConfig[zlevel], true);
        }
      }
    }
  };
  CanvasPainter2.prototype.delLayer = function(zlevel) {
    var layers = this._layers;
    var zlevelList = this._zlevelList;
    var layer = layers[zlevel];
    if (!layer) {
      return;
    }
    layer.dom.parentNode.removeChild(layer.dom);
    delete layers[zlevel];
    zlevelList.splice(indexOf(zlevelList, zlevel), 1);
  };
  CanvasPainter2.prototype.resize = function(width, height) {
    if (!this._domRoot.style) {
      if (width == null || height == null) {
        return;
      }
      this._width = width;
      this._height = height;
      this.getLayer(CANVAS_ZLEVEL).resize(width, height);
    } else {
      var domRoot = this._domRoot;
      domRoot.style.display = "none";
      var opts = this._opts;
      var root2 = this.root;
      width != null && (opts.width = width);
      height != null && (opts.height = height);
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      domRoot.style.display = "";
      if (this._width !== width || height !== this._height) {
        domRoot.style.width = width + "px";
        domRoot.style.height = height + "px";
        for (var id2 in this._layers) {
          if (this._layers.hasOwnProperty(id2)) {
            this._layers[id2].resize(width, height);
          }
        }
        this.refresh(true);
      }
      this._width = width;
      this._height = height;
    }
    return this;
  };
  CanvasPainter2.prototype.clearLayer = function(zlevel) {
    var layer = this._layers[zlevel];
    if (layer) {
      layer.clear();
    }
  };
  CanvasPainter2.prototype.dispose = function() {
    this.root.innerHTML = "";
    this.root = this.storage = this._domRoot = this._layers = null;
  };
  CanvasPainter2.prototype.getRenderedCanvas = function(opts) {
    opts = opts || {};
    if (this._singleCanvas && !this._compositeManually) {
      return this._layers[CANVAS_ZLEVEL].dom;
    }
    var imageLayer = new Layer$1("image", this, opts.pixelRatio || this.dpr);
    imageLayer.initContext();
    imageLayer.clear(false, opts.backgroundColor || this._backgroundColor);
    var ctx = imageLayer.ctx;
    if (opts.pixelRatio <= this.dpr) {
      this.refresh();
      var width_1 = imageLayer.dom.width;
      var height_1 = imageLayer.dom.height;
      this.eachLayer(function(layer) {
        if (layer.__builtin__) {
          ctx.drawImage(layer.dom, 0, 0, width_1, height_1);
        } else if (layer.renderToCanvas) {
          ctx.save();
          layer.renderToCanvas(ctx);
          ctx.restore();
        }
      });
    } else {
      var scope = {
        inHover: false,
        viewWidth: this._width,
        viewHeight: this._height
      };
      var displayList = this.storage.getDisplayList(true);
      for (var i = 0, len2 = displayList.length; i < len2; i++) {
        var el = displayList[i];
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    return imageLayer.dom;
  };
  CanvasPainter2.prototype.getWidth = function() {
    return this._width;
  };
  CanvasPainter2.prototype.getHeight = function() {
    return this._height;
  };
  return CanvasPainter2;
}();
var CanvasPainter$1 = CanvasPainter;
function install$R(registers) {
  registers.registerPainter("canvas", CanvasPainter$1);
}
var LineSeriesModel = function(_super) {
  __extends(LineSeriesModel2, _super);
  function LineSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LineSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  LineSeriesModel2.prototype.getInitialData = function(option) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  LineSeriesModel2.prototype.getLegendIcon = function(opt) {
    var group = new Group$6();
    var line = createSymbol$1("line", 0, opt.itemHeight / 2, opt.itemWidth, 0, opt.lineStyle.stroke, false);
    group.add(line);
    line.setStyle(opt.lineStyle);
    var visualType = this.getData().getVisual("symbol");
    var visualRotate = this.getData().getVisual("symbolRotate");
    var symbolType = visualType === "none" ? "circle" : visualType;
    var size = opt.itemHeight * 0.8;
    var symbol = createSymbol$1(symbolType, (opt.itemWidth - size) / 2, (opt.itemHeight - size) / 2, size, size, opt.itemStyle.fill);
    group.add(symbol);
    symbol.setStyle(opt.itemStyle);
    var symbolRotate = opt.iconRotate === "inherit" ? visualRotate : opt.iconRotate || 0;
    symbol.rotation = symbolRotate * Math.PI / 180;
    symbol.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
    if (symbolType.indexOf("empty") > -1) {
      symbol.style.stroke = symbol.style.fill;
      symbol.style.fill = "#fff";
      symbol.style.lineWidth = 2;
    }
    return group;
  };
  LineSeriesModel2.type = "series.line";
  LineSeriesModel2.dependencies = ["grid", "polar"];
  LineSeriesModel2.defaultOption = {
    z: 3,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    clip: true,
    label: {
      position: "top"
    },
    endLabel: {
      show: false,
      valueAnimation: true,
      distance: 8
    },
    lineStyle: {
      width: 2,
      type: "solid"
    },
    emphasis: {
      scale: true
    },
    step: false,
    smooth: false,
    smoothMonotone: null,
    symbol: "emptyCircle",
    symbolSize: 4,
    symbolRotate: null,
    showSymbol: true,
    showAllSymbol: "auto",
    connectNulls: false,
    sampling: "none",
    animationEasing: "linear",
    progressive: 0,
    hoverLayerThreshold: Infinity,
    universalTransition: {
      divideShape: "clone"
    },
    triggerLineEvent: false
  };
  return LineSeriesModel2;
}(SeriesModel$1);
var LineSeries = LineSeriesModel;
function getDefaultLabel(data, dataIndex) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  var len2 = labelDims.length;
  if (len2 === 1) {
    var rawVal = retrieveRawValue(data, dataIndex, labelDims[0]);
    return rawVal != null ? rawVal + "" : null;
  } else if (len2) {
    var vals = [];
    for (var i = 0; i < labelDims.length; i++) {
      vals.push(retrieveRawValue(data, dataIndex, labelDims[i]));
    }
    return vals.join(" ");
  }
}
function getDefaultInterpolatedLabel(data, interpolatedValue) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  if (!isArray$1(interpolatedValue)) {
    return interpolatedValue + "";
  }
  var vals = [];
  for (var i = 0; i < labelDims.length; i++) {
    var dimIndex = data.getDimensionIndex(labelDims[i]);
    if (dimIndex >= 0) {
      vals.push(interpolatedValue[dimIndex]);
    }
  }
  return vals.join(" ");
}
var Symbol$1 = function(_super) {
  __extends(Symbol2, _super);
  function Symbol2(data, idx, seriesScope, opts) {
    var _this = _super.call(this) || this;
    _this.updateData(data, idx, seriesScope, opts);
    return _this;
  }
  Symbol2.prototype._createSymbol = function(symbolType, data, idx, symbolSize, keepAspect) {
    this.removeAll();
    var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2, null, keepAspect);
    symbolPath.attr({
      z2: 100,
      culling: true,
      scaleX: symbolSize[0] / 2,
      scaleY: symbolSize[1] / 2
    });
    symbolPath.drift = driftSymbol;
    this._symbolType = symbolType;
    this.add(symbolPath);
  };
  Symbol2.prototype.stopSymbolAnimation = function(toLastFrame) {
    this.childAt(0).stopAnimation(null, toLastFrame);
  };
  Symbol2.prototype.getSymbolType = function() {
    return this._symbolType;
  };
  Symbol2.prototype.getSymbolPath = function() {
    return this.childAt(0);
  };
  Symbol2.prototype.highlight = function() {
    enterEmphasis(this.childAt(0));
  };
  Symbol2.prototype.downplay = function() {
    leaveEmphasis(this.childAt(0));
  };
  Symbol2.prototype.setZ = function(zlevel, z2) {
    var symbolPath = this.childAt(0);
    symbolPath.zlevel = zlevel;
    symbolPath.z = z2;
  };
  Symbol2.prototype.setDraggable = function(draggable) {
    var symbolPath = this.childAt(0);
    symbolPath.draggable = draggable;
    symbolPath.cursor = draggable ? "move" : symbolPath.cursor;
  };
  Symbol2.prototype.updateData = function(data, idx, seriesScope, opts) {
    this.silent = false;
    var symbolType = data.getItemVisual(idx, "symbol") || "circle";
    var seriesModel = data.hostModel;
    var symbolSize = Symbol2.getSymbolSize(data, idx);
    var isInit = symbolType !== this._symbolType;
    var disableAnimation = opts && opts.disableAnimation;
    if (isInit) {
      var keepAspect = data.getItemVisual(idx, "symbolKeepAspect");
      this._createSymbol(symbolType, data, idx, symbolSize, keepAspect);
    } else {
      var symbolPath = this.childAt(0);
      symbolPath.silent = false;
      var target = {
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2
      };
      disableAnimation ? symbolPath.attr(target) : updateProps$1(symbolPath, target, seriesModel, idx);
      saveOldStyle(symbolPath);
    }
    this._updateCommon(data, idx, symbolSize, seriesScope, opts);
    if (isInit) {
      var symbolPath = this.childAt(0);
      if (!disableAnimation) {
        var target = {
          scaleX: this._sizeX,
          scaleY: this._sizeY,
          style: {
            opacity: symbolPath.style.opacity
          }
        };
        symbolPath.scaleX = symbolPath.scaleY = 0;
        symbolPath.style.opacity = 0;
        initProps(symbolPath, target, seriesModel, idx);
      }
    }
    if (disableAnimation) {
      this.childAt(0).stopAnimation("leave");
    }
  };
  Symbol2.prototype._updateCommon = function(data, idx, symbolSize, seriesScope, opts) {
    var symbolPath = this.childAt(0);
    var seriesModel = data.hostModel;
    var emphasisItemStyle;
    var blurItemStyle;
    var selectItemStyle;
    var focus;
    var blurScope;
    var emphasisDisabled;
    var labelStatesModels;
    var hoverScale;
    var cursorStyle;
    if (seriesScope) {
      emphasisItemStyle = seriesScope.emphasisItemStyle;
      blurItemStyle = seriesScope.blurItemStyle;
      selectItemStyle = seriesScope.selectItemStyle;
      focus = seriesScope.focus;
      blurScope = seriesScope.blurScope;
      labelStatesModels = seriesScope.labelStatesModels;
      hoverScale = seriesScope.hoverScale;
      cursorStyle = seriesScope.cursorStyle;
      emphasisDisabled = seriesScope.emphasisDisabled;
    }
    if (!seriesScope || data.hasItemOption) {
      var itemModel = seriesScope && seriesScope.itemModel ? seriesScope.itemModel : data.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisItemStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      selectItemStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
      blurItemStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      emphasisDisabled = emphasisModel.get("disabled");
      labelStatesModels = getLabelStatesModels(itemModel);
      hoverScale = emphasisModel.getShallow("scale");
      cursorStyle = itemModel.getShallow("cursor");
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    symbolPath.attr("rotation", (symbolRotate || 0) * Math.PI / 180 || 0);
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      symbolPath.x = symbolOffset[0];
      symbolPath.y = symbolOffset[1];
    }
    cursorStyle && symbolPath.attr("cursor", cursorStyle);
    var symbolStyle = data.getItemVisual(idx, "style");
    var visualColor = symbolStyle.fill;
    if (symbolPath instanceof ZRImage$1) {
      var pathStyle = symbolPath.style;
      symbolPath.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolStyle));
    } else {
      if (symbolPath.__isEmptyBrush) {
        symbolPath.useStyle(extend({}, symbolStyle));
      } else {
        symbolPath.useStyle(symbolStyle);
      }
      symbolPath.style.decal = null;
      symbolPath.setColor(visualColor, opts && opts.symbolInnerColor);
      symbolPath.style.strokeNoScale = true;
    }
    var liftZ = data.getItemVisual(idx, "liftZ");
    var z2Origin = this._z2;
    if (liftZ != null) {
      if (z2Origin == null) {
        this._z2 = symbolPath.z2;
        symbolPath.z2 += liftZ;
      }
    } else if (z2Origin != null) {
      symbolPath.z2 = z2Origin;
      this._z2 = null;
    }
    var useNameLabel = opts && opts.useNameLabel;
    setLabelStyle(symbolPath, labelStatesModels, {
      labelFetcher: seriesModel,
      labelDataIndex: idx,
      defaultText: getLabelDefaultText,
      inheritColor: visualColor,
      defaultOpacity: symbolStyle.opacity
    });
    function getLabelDefaultText(idx2) {
      return useNameLabel ? data.getName(idx2) : getDefaultLabel(data, idx2);
    }
    this._sizeX = symbolSize[0] / 2;
    this._sizeY = symbolSize[1] / 2;
    var emphasisState = symbolPath.ensureState("emphasis");
    emphasisState.style = emphasisItemStyle;
    symbolPath.ensureState("select").style = selectItemStyle;
    symbolPath.ensureState("blur").style = blurItemStyle;
    if (hoverScale) {
      var scaleRatio = Math.max(1.1, 3 / this._sizeY);
      emphasisState.scaleX = this._sizeX * scaleRatio;
      emphasisState.scaleY = this._sizeY * scaleRatio;
    }
    this.setSymbolScale(1);
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Symbol2.prototype.setSymbolScale = function(scale2) {
    this.scaleX = this.scaleY = scale2;
  };
  Symbol2.prototype.fadeOut = function(cb2, seriesModel, opt) {
    var symbolPath = this.childAt(0);
    var dataIndex = getECData(this).dataIndex;
    var animationOpt = opt && opt.animation;
    this.silent = symbolPath.silent = true;
    if (opt && opt.fadeLabel) {
      var textContent = symbolPath.getTextContent();
      if (textContent) {
        removeElement(textContent, {
          style: {
            opacity: 0
          }
        }, seriesModel, {
          dataIndex,
          removeOpt: animationOpt,
          cb: function() {
            symbolPath.removeTextContent();
          }
        });
      }
    } else {
      symbolPath.removeTextContent();
    }
    removeElement(symbolPath, {
      style: {
        opacity: 0
      },
      scaleX: 0,
      scaleY: 0
    }, seriesModel, {
      dataIndex,
      cb: cb2,
      removeOpt: animationOpt
    });
  };
  Symbol2.getSymbolSize = function(data, idx) {
    return normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
  };
  return Symbol2;
}(Group$6);
function driftSymbol(dx, dy) {
  this.parent.drift(dx, dy);
}
var SymbolClz = Symbol$1;
function symbolNeedsDraw$1(data, point, idx, opt) {
  return point && !isNaN(point[0]) && !isNaN(point[1]) && !(opt.isIgnore && opt.isIgnore(idx)) && !(opt.clipShape && !opt.clipShape.contain(point[0], point[1])) && data.getItemVisual(idx, "symbol") !== "none";
}
function normalizeUpdateOpt(opt) {
  if (opt != null && !isObject$4(opt)) {
    opt = {
      isIgnore: opt
    };
  }
  return opt || {};
}
function makeSeriesScope$2(data) {
  var seriesModel = data.hostModel;
  var emphasisModel = seriesModel.getModel("emphasis");
  return {
    emphasisItemStyle: emphasisModel.getModel("itemStyle").getItemStyle(),
    blurItemStyle: seriesModel.getModel(["blur", "itemStyle"]).getItemStyle(),
    selectItemStyle: seriesModel.getModel(["select", "itemStyle"]).getItemStyle(),
    focus: emphasisModel.get("focus"),
    blurScope: emphasisModel.get("blurScope"),
    emphasisDisabled: emphasisModel.get("disabled"),
    hoverScale: emphasisModel.get("scale"),
    labelStatesModels: getLabelStatesModels(seriesModel),
    cursorStyle: seriesModel.get("cursor")
  };
}
var SymbolDraw = function() {
  function SymbolDraw2(SymbolCtor) {
    this.group = new Group$6();
    this._SymbolCtor = SymbolCtor || SymbolClz;
  }
  SymbolDraw2.prototype.updateData = function(data, opt) {
    this._progressiveEls = null;
    opt = normalizeUpdateOpt(opt);
    var group = this.group;
    var seriesModel = data.hostModel;
    var oldData = this._data;
    var SymbolCtor = this._SymbolCtor;
    var disableAnimation = opt.disableAnimation;
    var seriesScope = makeSeriesScope$2(data);
    var symbolUpdateOpt = {
      disableAnimation
    };
    var getSymbolPoint = opt.getSymbolPoint || function(idx) {
      return data.getItemLayout(idx);
    };
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      var point = getSymbolPoint(newIdx);
      if (symbolNeedsDraw$1(data, point, newIdx, opt)) {
        var symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      var point = getSymbolPoint(newIdx);
      if (!symbolNeedsDraw$1(data, point, newIdx, opt)) {
        group.remove(symbolEl);
        return;
      }
      var newSymbolType = data.getItemVisual(newIdx, "symbol") || "circle";
      var oldSymbolType = symbolEl && symbolEl.getSymbolType && symbolEl.getSymbolType();
      if (!symbolEl || oldSymbolType && oldSymbolType !== newSymbolType) {
        group.remove(symbolEl);
        symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
      } else {
        symbolEl.updateData(data, newIdx, seriesScope, symbolUpdateOpt);
        var target = {
          x: point[0],
          y: point[1]
        };
        disableAnimation ? symbolEl.attr(target) : updateProps$1(symbolEl, target, seriesModel);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && el.fadeOut(function() {
        group.remove(el);
      }, seriesModel);
    }).execute();
    this._getSymbolPoint = getSymbolPoint;
    this._data = data;
  };
  SymbolDraw2.prototype.updateLayout = function() {
    var _this = this;
    var data = this._data;
    if (data) {
      data.eachItemGraphicEl(function(el, idx) {
        var point = _this._getSymbolPoint(idx);
        el.setPosition(point);
        el.markRedraw();
      });
    }
  };
  SymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._seriesScope = makeSeriesScope$2(data);
    this._data = null;
    this.group.removeAll();
  };
  SymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    this._progressiveEls = [];
    opt = normalizeUpdateOpt(opt);
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var point = data.getItemLayout(idx);
      if (symbolNeedsDraw$1(data, point, idx, opt)) {
        var el = new this._SymbolCtor(data, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        el.setPosition(point);
        this.group.add(el);
        data.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  SymbolDraw2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  SymbolDraw2.prototype.remove = function(enableAnimation) {
    var group = this.group;
    var data = this._data;
    if (data && enableAnimation) {
      data.eachItemGraphicEl(function(el) {
        el.fadeOut(function() {
          group.remove(el);
        }, data.hostModel);
      });
    } else {
      group.removeAll();
    }
  };
  return SymbolDraw2;
}();
var SymbolDraw$1 = SymbolDraw;
function prepareDataCoordInfo(coordSys, data, valueOrigin) {
  var baseAxis = coordSys.getBaseAxis();
  var valueAxis2 = coordSys.getOtherAxis(baseAxis);
  var valueStart = getValueStart(valueAxis2, valueOrigin);
  var baseAxisDim = baseAxis.dim;
  var valueAxisDim = valueAxis2.dim;
  var valueDim = data.mapDimension(valueAxisDim);
  var baseDim = data.mapDimension(baseAxisDim);
  var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
  var dims = map$1(coordSys.dimensions, function(coordDim) {
    return data.mapDimension(coordDim);
  });
  var stacked = false;
  var stackResultDim = data.getCalculationInfo("stackResultDimension");
  if (isDimensionStacked(data, dims[0])) {
    stacked = true;
    dims[0] = stackResultDim;
  }
  if (isDimensionStacked(data, dims[1])) {
    stacked = true;
    dims[1] = stackResultDim;
  }
  return {
    dataDimsForPoint: dims,
    valueStart,
    valueAxisDim,
    baseAxisDim,
    stacked: !!stacked,
    valueDim,
    baseDim,
    baseDataOffset,
    stackedOverDimension: data.getCalculationInfo("stackedOverDimension")
  };
}
function getValueStart(valueAxis2, valueOrigin) {
  var valueStart = 0;
  var extent3 = valueAxis2.scale.getExtent();
  if (valueOrigin === "start") {
    valueStart = extent3[0];
  } else if (valueOrigin === "end") {
    valueStart = extent3[1];
  } else {
    if (extent3[0] > 0) {
      valueStart = extent3[0];
    } else if (extent3[1] < 0) {
      valueStart = extent3[1];
    }
  }
  return valueStart;
}
function getStackedOnPoint(dataCoordInfo, coordSys, data, idx) {
  var value = NaN;
  if (dataCoordInfo.stacked) {
    value = data.get(data.getCalculationInfo("stackedOverDimension"), idx);
  }
  if (isNaN(value)) {
    value = dataCoordInfo.valueStart;
  }
  var baseDataOffset = dataCoordInfo.baseDataOffset;
  var stackedData = [];
  stackedData[baseDataOffset] = data.get(dataCoordInfo.baseDim, idx);
  stackedData[1 - baseDataOffset] = value;
  return coordSys.dataToPoint(stackedData);
}
function diffData(oldData, newData) {
  var diffResult = [];
  newData.diff(oldData).add(function(idx) {
    diffResult.push({
      cmd: "+",
      idx
    });
  }).update(function(newIdx, oldIdx) {
    diffResult.push({
      cmd: "=",
      idx: oldIdx,
      idx1: newIdx
    });
  }).remove(function(idx) {
    diffResult.push({
      cmd: "-",
      idx
    });
  }).execute();
  return diffResult;
}
function lineAnimationDiff(oldData, newData, oldStackedOnPoints, newStackedOnPoints, oldCoordSys, newCoordSys, oldValueOrigin, newValueOrigin) {
  var diff = diffData(oldData, newData);
  var currPoints = [];
  var nextPoints = [];
  var currStackedPoints = [];
  var nextStackedPoints = [];
  var status = [];
  var sortedIndices = [];
  var rawIndices = [];
  var newDataOldCoordInfo = prepareDataCoordInfo(oldCoordSys, newData, oldValueOrigin);
  var oldPoints = oldData.getLayout("points") || [];
  var newPoints = newData.getLayout("points") || [];
  for (var i = 0; i < diff.length; i++) {
    var diffItem = diff[i];
    var pointAdded = true;
    var oldIdx2 = void 0;
    var newIdx2 = void 0;
    switch (diffItem.cmd) {
      case "=":
        oldIdx2 = diffItem.idx * 2;
        newIdx2 = diffItem.idx1 * 2;
        var currentX = oldPoints[oldIdx2];
        var currentY = oldPoints[oldIdx2 + 1];
        var nextX = newPoints[newIdx2];
        var nextY = newPoints[newIdx2 + 1];
        if (isNaN(currentX) || isNaN(currentY)) {
          currentX = nextX;
          currentY = nextY;
        }
        currPoints.push(currentX, currentY);
        nextPoints.push(nextX, nextY);
        currStackedPoints.push(oldStackedOnPoints[oldIdx2], oldStackedOnPoints[oldIdx2 + 1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(diffItem.idx1));
        break;
      case "+":
        var newIdx = diffItem.idx;
        var newDataDimsForPoint = newDataOldCoordInfo.dataDimsForPoint;
        var oldPt = oldCoordSys.dataToPoint([newData.get(newDataDimsForPoint[0], newIdx), newData.get(newDataDimsForPoint[1], newIdx)]);
        newIdx2 = newIdx * 2;
        currPoints.push(oldPt[0], oldPt[1]);
        nextPoints.push(newPoints[newIdx2], newPoints[newIdx2 + 1]);
        var stackedOnPoint = getStackedOnPoint(newDataOldCoordInfo, oldCoordSys, newData, newIdx);
        currStackedPoints.push(stackedOnPoint[0], stackedOnPoint[1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(newIdx));
        break;
      case "-":
        pointAdded = false;
    }
    if (pointAdded) {
      status.push(diffItem);
      sortedIndices.push(sortedIndices.length);
    }
  }
  sortedIndices.sort(function(a, b2) {
    return rawIndices[a] - rawIndices[b2];
  });
  var len2 = currPoints.length;
  var sortedCurrPoints = createFloat32Array(len2);
  var sortedNextPoints = createFloat32Array(len2);
  var sortedCurrStackedPoints = createFloat32Array(len2);
  var sortedNextStackedPoints = createFloat32Array(len2);
  var sortedStatus = [];
  for (var i = 0; i < sortedIndices.length; i++) {
    var idx = sortedIndices[i];
    var i2 = i * 2;
    var idx2 = idx * 2;
    sortedCurrPoints[i2] = currPoints[idx2];
    sortedCurrPoints[i2 + 1] = currPoints[idx2 + 1];
    sortedNextPoints[i2] = nextPoints[idx2];
    sortedNextPoints[i2 + 1] = nextPoints[idx2 + 1];
    sortedCurrStackedPoints[i2] = currStackedPoints[idx2];
    sortedCurrStackedPoints[i2 + 1] = currStackedPoints[idx2 + 1];
    sortedNextStackedPoints[i2] = nextStackedPoints[idx2];
    sortedNextStackedPoints[i2 + 1] = nextStackedPoints[idx2 + 1];
    sortedStatus[i] = status[idx];
  }
  return {
    current: sortedCurrPoints,
    next: sortedNextPoints,
    stackedOnCurrent: sortedCurrStackedPoints,
    stackedOnNext: sortedNextStackedPoints,
    status: sortedStatus
  };
}
var mathMin$5 = Math.min;
var mathMax$5 = Math.max;
function isPointNull$1(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function drawSegment(ctx, points2, start2, segLen, allLen, dir3, smooth, smoothMonotone, connectNulls) {
  var prevX;
  var prevY;
  var cpx0;
  var cpy0;
  var cpx1;
  var cpy1;
  var idx = start2;
  var k2 = 0;
  for (; k2 < segLen; k2++) {
    var x2 = points2[idx * 2];
    var y2 = points2[idx * 2 + 1];
    if (idx >= allLen || idx < 0) {
      break;
    }
    if (isPointNull$1(x2, y2)) {
      if (connectNulls) {
        idx += dir3;
        continue;
      }
      break;
    }
    if (idx === start2) {
      ctx[dir3 > 0 ? "moveTo" : "lineTo"](x2, y2);
      cpx0 = x2;
      cpy0 = y2;
    } else {
      var dx = x2 - prevX;
      var dy = y2 - prevY;
      if (dx * dx + dy * dy < 0.5) {
        idx += dir3;
        continue;
      }
      if (smooth > 0) {
        var nextIdx = idx + dir3;
        var nextX = points2[nextIdx * 2];
        var nextY = points2[nextIdx * 2 + 1];
        while (nextX === x2 && nextY === y2 && k2 < segLen) {
          k2++;
          nextIdx += dir3;
          idx += dir3;
          nextX = points2[nextIdx * 2];
          nextY = points2[nextIdx * 2 + 1];
          x2 = points2[idx * 2];
          y2 = points2[idx * 2 + 1];
          dx = x2 - prevX;
          dy = y2 - prevY;
        }
        var tmpK = k2 + 1;
        if (connectNulls) {
          while (isPointNull$1(nextX, nextY) && tmpK < segLen) {
            tmpK++;
            nextIdx += dir3;
            nextX = points2[nextIdx * 2];
            nextY = points2[nextIdx * 2 + 1];
          }
        }
        var ratioNextSeg = 0.5;
        var vx = 0;
        var vy = 0;
        var nextCpx0 = void 0;
        var nextCpy0 = void 0;
        if (tmpK >= segLen || isPointNull$1(nextX, nextY)) {
          cpx1 = x2;
          cpy1 = y2;
        } else {
          vx = nextX - prevX;
          vy = nextY - prevY;
          var dx0 = x2 - prevX;
          var dx1 = nextX - x2;
          var dy0 = y2 - prevY;
          var dy1 = nextY - y2;
          var lenPrevSeg = void 0;
          var lenNextSeg = void 0;
          if (smoothMonotone === "x") {
            lenPrevSeg = Math.abs(dx0);
            lenNextSeg = Math.abs(dx1);
            var dir_1 = vx > 0 ? 1 : -1;
            cpx1 = x2 - dir_1 * lenPrevSeg * smooth;
            cpy1 = y2;
            nextCpx0 = x2 + dir_1 * lenNextSeg * smooth;
            nextCpy0 = y2;
          } else if (smoothMonotone === "y") {
            lenPrevSeg = Math.abs(dy0);
            lenNextSeg = Math.abs(dy1);
            var dir_2 = vy > 0 ? 1 : -1;
            cpx1 = x2;
            cpy1 = y2 - dir_2 * lenPrevSeg * smooth;
            nextCpx0 = x2;
            nextCpy0 = y2 + dir_2 * lenNextSeg * smooth;
          } else {
            lenPrevSeg = Math.sqrt(dx0 * dx0 + dy0 * dy0);
            lenNextSeg = Math.sqrt(dx1 * dx1 + dy1 * dy1);
            ratioNextSeg = lenNextSeg / (lenNextSeg + lenPrevSeg);
            cpx1 = x2 - vx * smooth * (1 - ratioNextSeg);
            cpy1 = y2 - vy * smooth * (1 - ratioNextSeg);
            nextCpx0 = x2 + vx * smooth * ratioNextSeg;
            nextCpy0 = y2 + vy * smooth * ratioNextSeg;
            nextCpx0 = mathMin$5(nextCpx0, mathMax$5(nextX, x2));
            nextCpy0 = mathMin$5(nextCpy0, mathMax$5(nextY, y2));
            nextCpx0 = mathMax$5(nextCpx0, mathMin$5(nextX, x2));
            nextCpy0 = mathMax$5(nextCpy0, mathMin$5(nextY, y2));
            vx = nextCpx0 - x2;
            vy = nextCpy0 - y2;
            cpx1 = x2 - vx * lenPrevSeg / lenNextSeg;
            cpy1 = y2 - vy * lenPrevSeg / lenNextSeg;
            cpx1 = mathMin$5(cpx1, mathMax$5(prevX, x2));
            cpy1 = mathMin$5(cpy1, mathMax$5(prevY, y2));
            cpx1 = mathMax$5(cpx1, mathMin$5(prevX, x2));
            cpy1 = mathMax$5(cpy1, mathMin$5(prevY, y2));
            vx = x2 - cpx1;
            vy = y2 - cpy1;
            nextCpx0 = x2 + vx * lenNextSeg / lenPrevSeg;
            nextCpy0 = y2 + vy * lenNextSeg / lenPrevSeg;
          }
        }
        ctx.bezierCurveTo(cpx0, cpy0, cpx1, cpy1, x2, y2);
        cpx0 = nextCpx0;
        cpy0 = nextCpy0;
      } else {
        ctx.lineTo(x2, y2);
      }
    }
    prevX = x2;
    prevY = y2;
    idx += dir3;
  }
  return k2;
}
var ECPolylineShape = function() {
  function ECPolylineShape2() {
    this.smooth = 0;
    this.smoothConstraint = true;
  }
  return ECPolylineShape2;
}();
var ECPolyline = function(_super) {
  __extends(ECPolyline2, _super);
  function ECPolyline2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polyline";
    return _this;
  }
  ECPolyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECPolyline2.prototype.getDefaultShape = function() {
    return new ECPolylineShape();
  };
  ECPolyline2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var i = 0;
    var len2 = points2.length / 2;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      i += drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, shape.smoothMonotone, shape.connectNulls) + 1;
    }
  };
  ECPolyline2.prototype.getPointOn = function(xOrY, dim) {
    if (!this.path) {
      this.createPathProxy();
      this.buildPath(this.path, this.shape);
    }
    var path = this.path;
    var data = path.data;
    var CMD2 = PathProxy$1.CMD;
    var x0;
    var y0;
    var isDimX = dim === "x";
    var roots2 = [];
    for (var i = 0; i < data.length; ) {
      var cmd = data[i++];
      var x2 = void 0;
      var y2 = void 0;
      var x22 = void 0;
      var y22 = void 0;
      var x3 = void 0;
      var y3 = void 0;
      var t2 = void 0;
      switch (cmd) {
        case CMD2.M:
          x0 = data[i++];
          y0 = data[i++];
          break;
        case CMD2.L:
          x2 = data[i++];
          y2 = data[i++];
          t2 = isDimX ? (xOrY - x0) / (x2 - x0) : (xOrY - y0) / (y2 - y0);
          if (t2 <= 1 && t2 >= 0) {
            var val = isDimX ? (y2 - y0) * t2 + y0 : (x2 - x0) * t2 + x0;
            return isDimX ? [xOrY, val] : [val, xOrY];
          }
          x0 = x2;
          y0 = y2;
          break;
        case CMD2.C:
          x2 = data[i++];
          y2 = data[i++];
          x22 = data[i++];
          y22 = data[i++];
          x3 = data[i++];
          y3 = data[i++];
          var nRoot = isDimX ? cubicRootAt(x0, x2, x22, x3, xOrY, roots2) : cubicRootAt(y0, y2, y22, y3, xOrY, roots2);
          if (nRoot > 0) {
            for (var i_1 = 0; i_1 < nRoot; i_1++) {
              var t_1 = roots2[i_1];
              if (t_1 <= 1 && t_1 >= 0) {
                var val = isDimX ? cubicAt(y0, y2, y22, y3, t_1) : cubicAt(x0, x2, x22, x3, t_1);
                return isDimX ? [xOrY, val] : [val, xOrY];
              }
            }
          }
          x0 = x3;
          y0 = y3;
          break;
      }
    }
  };
  return ECPolyline2;
}(Path$1);
var ECPolygonShape = function(_super) {
  __extends(ECPolygonShape2, _super);
  function ECPolygonShape2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return ECPolygonShape2;
}(ECPolylineShape);
var ECPolygon = function(_super) {
  __extends(ECPolygon2, _super);
  function ECPolygon2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polygon";
    return _this;
  }
  ECPolygon2.prototype.getDefaultShape = function() {
    return new ECPolygonShape();
  };
  ECPolygon2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var stackedOnPoints = shape.stackedOnPoints;
    var i = 0;
    var len2 = points2.length / 2;
    var smoothMonotone = shape.smoothMonotone;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      var k2 = drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, smoothMonotone, shape.connectNulls);
      drawSegment(ctx, stackedOnPoints, i + k2 - 1, k2, len2, -1, shape.stackedOnSmooth, smoothMonotone, shape.connectNulls);
      i += k2 + 1;
      ctx.closePath();
    }
  };
  return ECPolygon2;
}(Path$1);
function createGridClipPath(cartesian, hasAnimation, seriesModel, done, during) {
  var rect = cartesian.getArea();
  var x2 = rect.x;
  var y2 = rect.y;
  var width = rect.width;
  var height = rect.height;
  var lineWidth = seriesModel.get(["lineStyle", "width"]) || 2;
  x2 -= lineWidth / 2;
  y2 -= lineWidth / 2;
  width += lineWidth;
  height += lineWidth;
  x2 = Math.floor(x2);
  width = Math.round(width);
  var clipPath = new Rect$3({
    shape: {
      x: x2,
      y: y2,
      width,
      height
    }
  });
  if (hasAnimation) {
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var isAxisInversed = baseAxis.inverse;
    if (isHorizontal) {
      if (isAxisInversed) {
        clipPath.shape.x += width;
      }
      clipPath.shape.width = 0;
    } else {
      if (!isAxisInversed) {
        clipPath.shape.y += height;
      }
      clipPath.shape.height = 0;
    }
    var duringCb = isFunction(during) ? function(percent) {
      during(percent, clipPath);
    } : null;
    initProps(clipPath, {
      shape: {
        width,
        height,
        x: x2,
        y: y2
      }
    }, seriesModel, null, done, duringCb);
  }
  return clipPath;
}
function createPolarClipPath(polar, hasAnimation, seriesModel) {
  var sectorArea = polar.getArea();
  var r0 = round$3(sectorArea.r0, 1);
  var r2 = round$3(sectorArea.r, 1);
  var clipPath = new Sector$1({
    shape: {
      cx: round$3(polar.cx, 1),
      cy: round$3(polar.cy, 1),
      r0,
      r: r2,
      startAngle: sectorArea.startAngle,
      endAngle: sectorArea.endAngle,
      clockwise: sectorArea.clockwise
    }
  });
  if (hasAnimation) {
    var isRadial = polar.getBaseAxis().dim === "angle";
    if (isRadial) {
      clipPath.shape.endAngle = sectorArea.startAngle;
    } else {
      clipPath.shape.r = r0;
    }
    initProps(clipPath, {
      shape: {
        endAngle: sectorArea.endAngle,
        r: r2
      }
    }, seriesModel);
  }
  return clipPath;
}
function createClipPath(coordSys, hasAnimation, seriesModel, done, during) {
  if (!coordSys) {
    return null;
  } else if (coordSys.type === "polar") {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  } else if (coordSys.type === "cartesian2d") {
    return createGridClipPath(coordSys, hasAnimation, seriesModel, done, during);
  }
  return null;
}
function isCoordinateSystemType(coordSys, type4) {
  return coordSys.type === type4;
}
function isPointsSame(points1, points2) {
  if (points1.length !== points2.length) {
    return;
  }
  for (var i = 0; i < points1.length; i++) {
    if (points1[i] !== points2[i]) {
      return;
    }
  }
  return true;
}
function bboxFromPoints(points2) {
  var minX = Infinity;
  var minY = Infinity;
  var maxX = -Infinity;
  var maxY = -Infinity;
  for (var i = 0; i < points2.length; ) {
    var x2 = points2[i++];
    var y2 = points2[i++];
    if (!isNaN(x2)) {
      minX = Math.min(x2, minX);
      maxX = Math.max(x2, maxX);
    }
    if (!isNaN(y2)) {
      minY = Math.min(y2, minY);
      maxY = Math.max(y2, maxY);
    }
  }
  return [[minX, minY], [maxX, maxY]];
}
function getBoundingDiff(points1, points2) {
  var _a2 = bboxFromPoints(points1), min1 = _a2[0], max1 = _a2[1];
  var _b2 = bboxFromPoints(points2), min22 = _b2[0], max22 = _b2[1];
  return Math.max(Math.abs(min1[0] - min22[0]), Math.abs(min1[1] - min22[1]), Math.abs(max1[0] - max22[0]), Math.abs(max1[1] - max22[1]));
}
function getSmooth(smooth) {
  return isNumber(smooth) ? smooth : smooth ? 0.5 : 0;
}
function getStackedOnPoints(coordSys, data, dataCoordInfo) {
  if (!dataCoordInfo.valueDim) {
    return [];
  }
  var len2 = data.count();
  var points2 = createFloat32Array(len2 * 2);
  for (var idx = 0; idx < len2; idx++) {
    var pt = getStackedOnPoint(dataCoordInfo, coordSys, data, idx);
    points2[idx * 2] = pt[0];
    points2[idx * 2 + 1] = pt[1];
  }
  return points2;
}
function turnPointsIntoStep(points2, coordSys, stepTurnAt, connectNulls) {
  var baseAxis = coordSys.getBaseAxis();
  var baseIndex = baseAxis.dim === "x" || baseAxis.dim === "radius" ? 0 : 1;
  var stepPoints = [];
  var i = 0;
  var stepPt = [];
  var pt = [];
  var nextPt = [];
  var filteredPoints = [];
  if (connectNulls) {
    for (i = 0; i < points2.length; i += 2) {
      if (!isNaN(points2[i]) && !isNaN(points2[i + 1])) {
        filteredPoints.push(points2[i], points2[i + 1]);
      }
    }
    points2 = filteredPoints;
  }
  for (i = 0; i < points2.length - 2; i += 2) {
    nextPt[0] = points2[i + 2];
    nextPt[1] = points2[i + 3];
    pt[0] = points2[i];
    pt[1] = points2[i + 1];
    stepPoints.push(pt[0], pt[1]);
    switch (stepTurnAt) {
      case "end":
        stepPt[baseIndex] = nextPt[baseIndex];
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        break;
      case "middle":
        var middle = (pt[baseIndex] + nextPt[baseIndex]) / 2;
        var stepPt2 = [];
        stepPt[baseIndex] = stepPt2[baseIndex] = middle;
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPt2[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        stepPoints.push(stepPt2[0], stepPt2[1]);
        break;
      default:
        stepPt[baseIndex] = pt[baseIndex];
        stepPt[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
    }
  }
  stepPoints.push(points2[i++], points2[i++]);
  return stepPoints;
}
function clipColorStops(colorStops, maxSize) {
  var newColorStops = [];
  var len2 = colorStops.length;
  var prevOutOfRangeColorStop;
  var prevInRangeColorStop;
  function lerpStop(stop0, stop1, clippedCoord) {
    var coord0 = stop0.coord;
    var p2 = (clippedCoord - coord0) / (stop1.coord - coord0);
    var color = lerp(p2, [stop0.color, stop1.color]);
    return {
      coord: clippedCoord,
      color
    };
  }
  for (var i = 0; i < len2; i++) {
    var stop_1 = colorStops[i];
    var coord = stop_1.coord;
    if (coord < 0) {
      prevOutOfRangeColorStop = stop_1;
    } else if (coord > maxSize) {
      if (prevInRangeColorStop) {
        newColorStops.push(lerpStop(prevInRangeColorStop, stop_1, maxSize));
      } else if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0), lerpStop(prevOutOfRangeColorStop, stop_1, maxSize));
      }
      break;
    } else {
      if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0));
        prevOutOfRangeColorStop = null;
      }
      newColorStops.push(stop_1);
      prevInRangeColorStop = stop_1;
    }
  }
  return newColorStops;
}
function getVisualGradient(data, coordSys, api) {
  var visualMetaList = data.getVisual("visualMeta");
  if (!visualMetaList || !visualMetaList.length || !data.count()) {
    return;
  }
  if (coordSys.type !== "cartesian2d") {
    return;
  }
  var coordDim;
  var visualMeta;
  for (var i = visualMetaList.length - 1; i >= 0; i--) {
    var dimInfo = data.getDimensionInfo(visualMetaList[i].dimension);
    coordDim = dimInfo && dimInfo.coordDim;
    if (coordDim === "x" || coordDim === "y") {
      visualMeta = visualMetaList[i];
      break;
    }
  }
  if (!visualMeta) {
    return;
  }
  var axis = coordSys.getAxis(coordDim);
  var colorStops = map$1(visualMeta.stops, function(stop2) {
    return {
      coord: axis.toGlobalCoord(axis.dataToCoord(stop2.value)),
      color: stop2.color
    };
  });
  var stopLen = colorStops.length;
  var outerColors = visualMeta.outerColors.slice();
  if (stopLen && colorStops[0].coord > colorStops[stopLen - 1].coord) {
    colorStops.reverse();
    outerColors.reverse();
  }
  var colorStopsInRange = clipColorStops(colorStops, coordDim === "x" ? api.getWidth() : api.getHeight());
  var inRangeStopLen = colorStopsInRange.length;
  if (!inRangeStopLen && stopLen) {
    return colorStops[0].coord < 0 ? outerColors[1] ? outerColors[1] : colorStops[stopLen - 1].color : outerColors[0] ? outerColors[0] : colorStops[0].color;
  }
  var tinyExtent = 10;
  var minCoord = colorStopsInRange[0].coord - tinyExtent;
  var maxCoord = colorStopsInRange[inRangeStopLen - 1].coord + tinyExtent;
  var coordSpan = maxCoord - minCoord;
  if (coordSpan < 1e-3) {
    return "transparent";
  }
  each$g(colorStopsInRange, function(stop2) {
    stop2.offset = (stop2.coord - minCoord) / coordSpan;
  });
  colorStopsInRange.push({
    offset: inRangeStopLen ? colorStopsInRange[inRangeStopLen - 1].offset : 0.5,
    color: outerColors[1] || "transparent"
  });
  colorStopsInRange.unshift({
    offset: inRangeStopLen ? colorStopsInRange[0].offset : 0.5,
    color: outerColors[0] || "transparent"
  });
  var gradient = new LinearGradient$1(0, 0, 0, 0, colorStopsInRange, true);
  gradient[coordDim] = minCoord;
  gradient[coordDim + "2"] = maxCoord;
  return gradient;
}
function getIsIgnoreFunc(seriesModel, data, coordSys) {
  var showAllSymbol = seriesModel.get("showAllSymbol");
  var isAuto = showAllSymbol === "auto";
  if (showAllSymbol && !isAuto) {
    return;
  }
  var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
  if (!categoryAxis2) {
    return;
  }
  if (isAuto && canShowAllSymbolForCategory(categoryAxis2, data)) {
    return;
  }
  var categoryDataDim = data.mapDimension(categoryAxis2.dim);
  var labelMap = {};
  each$g(categoryAxis2.getViewLabels(), function(labelItem) {
    var ordinalNumber = categoryAxis2.scale.getRawOrdinalNumber(labelItem.tickValue);
    labelMap[ordinalNumber] = 1;
  });
  return function(dataIndex) {
    return !labelMap.hasOwnProperty(data.get(categoryDataDim, dataIndex));
  };
}
function canShowAllSymbolForCategory(categoryAxis2, data) {
  var axisExtent = categoryAxis2.getExtent();
  var availSize = Math.abs(axisExtent[1] - axisExtent[0]) / categoryAxis2.scale.count();
  isNaN(availSize) && (availSize = 0);
  var dataLen = data.count();
  var step = Math.max(1, Math.round(dataLen / 5));
  for (var dataIndex = 0; dataIndex < dataLen; dataIndex += step) {
    if (SymbolClz.getSymbolSize(data, dataIndex)[categoryAxis2.isHorizontal() ? 1 : 0] * 1.5 > availSize) {
      return false;
    }
  }
  return true;
}
function isPointNull(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function getLastIndexNotNull(points2) {
  var len2 = points2.length / 2;
  for (; len2 > 0; len2--) {
    if (!isPointNull(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
      break;
    }
  }
  return len2 - 1;
}
function getPointAtIndex(points2, idx) {
  return [points2[idx * 2], points2[idx * 2 + 1]];
}
function getIndexRange(points2, xOrY, dim) {
  var len2 = points2.length / 2;
  var dimIdx = dim === "x" ? 0 : 1;
  var a;
  var b2;
  var prevIndex = 0;
  var nextIndex = -1;
  for (var i = 0; i < len2; i++) {
    b2 = points2[i * 2 + dimIdx];
    if (isNaN(b2) || isNaN(points2[i * 2 + 1 - dimIdx])) {
      continue;
    }
    if (i === 0) {
      a = b2;
      continue;
    }
    if (a <= xOrY && b2 >= xOrY || a >= xOrY && b2 <= xOrY) {
      nextIndex = i;
      break;
    }
    prevIndex = i;
    a = b2;
  }
  return {
    range: [prevIndex, nextIndex],
    t: (xOrY - a) / (b2 - a)
  };
}
function anyStateShowEndLabel(seriesModel) {
  if (seriesModel.get(["endLabel", "show"])) {
    return true;
  }
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    if (seriesModel.get([SPECIAL_STATES[i], "endLabel", "show"])) {
      return true;
    }
  }
  return false;
}
function createLineClipPath(lineView, coordSys, hasAnimation, seriesModel) {
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    var endLabelModel_1 = seriesModel.getModel("endLabel");
    var valueAnimation_1 = endLabelModel_1.get("valueAnimation");
    var data_1 = seriesModel.getData();
    var labelAnimationRecord_1 = {
      lastFrameIndex: 0
    };
    var during = anyStateShowEndLabel(seriesModel) ? function(percent, clipRect) {
      lineView._endLabelOnDuring(percent, clipRect, data_1, labelAnimationRecord_1, valueAnimation_1, endLabelModel_1, coordSys);
    } : null;
    var isHorizontal = coordSys.getBaseAxis().isHorizontal();
    var clipPath = createGridClipPath(coordSys, hasAnimation, seriesModel, function() {
      var endLabel = lineView._endLabel;
      if (endLabel && hasAnimation) {
        if (labelAnimationRecord_1.originalX != null) {
          endLabel.attr({
            x: labelAnimationRecord_1.originalX,
            y: labelAnimationRecord_1.originalY
          });
        }
      }
    }, during);
    if (!seriesModel.get("clip", true)) {
      var rectShape = clipPath.shape;
      var expandSize = Math.max(rectShape.width, rectShape.height);
      if (isHorizontal) {
        rectShape.y -= expandSize;
        rectShape.height += expandSize * 2;
      } else {
        rectShape.x -= expandSize;
        rectShape.width += expandSize * 2;
      }
    }
    if (during) {
      during(1, clipPath);
    }
    return clipPath;
  } else {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  }
}
function getEndLabelStateSpecified(endLabelModel, coordSys) {
  var baseAxis = coordSys.getBaseAxis();
  var isHorizontal = baseAxis.isHorizontal();
  var isBaseInversed = baseAxis.inverse;
  var align = isHorizontal ? isBaseInversed ? "right" : "left" : "center";
  var verticalAlign = isHorizontal ? "middle" : isBaseInversed ? "top" : "bottom";
  return {
    normal: {
      align: endLabelModel.get("align") || align,
      verticalAlign: endLabelModel.get("verticalAlign") || verticalAlign
    }
  };
}
var LineView = function(_super) {
  __extends(LineView2, _super);
  function LineView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  LineView2.prototype.init = function() {
    var lineGroup = new Group$6();
    var symbolDraw = new SymbolDraw$1();
    this.group.add(symbolDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineGroup = lineGroup;
  };
  LineView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var lineStyleModel = seriesModel.getModel("lineStyle");
    var areaStyleModel = seriesModel.getModel("areaStyle");
    var points2 = data.getLayout("points") || [];
    var isCoordSysPolar = coordSys.type === "polar";
    var prevCoordSys = this._coordSys;
    var symbolDraw = this._symbolDraw;
    var polyline = this._polyline;
    var polygon = this._polygon;
    var lineGroup = this._lineGroup;
    var hasAnimation = seriesModel.get("animation");
    var isAreaChart = !areaStyleModel.isEmpty();
    var valueOrigin = areaStyleModel.get("origin");
    var dataCoordInfo = prepareDataCoordInfo(coordSys, data, valueOrigin);
    var stackedOnPoints = isAreaChart && getStackedOnPoints(coordSys, data, dataCoordInfo);
    var showSymbol = seriesModel.get("showSymbol");
    var connectNulls = seriesModel.get("connectNulls");
    var isIgnoreFunc = showSymbol && !isCoordSysPolar && getIsIgnoreFunc(seriesModel, data, coordSys);
    var oldData = this._data;
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    if (!showSymbol) {
      symbolDraw.remove();
    }
    group.add(lineGroup);
    var step = !isCoordSysPolar ? seriesModel.get("step") : false;
    var clipShapeForSymbol;
    if (coordSys && coordSys.getArea && seriesModel.get("clip", true)) {
      clipShapeForSymbol = coordSys.getArea();
      if (clipShapeForSymbol.width != null) {
        clipShapeForSymbol.x -= 0.1;
        clipShapeForSymbol.y -= 0.1;
        clipShapeForSymbol.width += 0.2;
        clipShapeForSymbol.height += 0.2;
      } else if (clipShapeForSymbol.r0) {
        clipShapeForSymbol.r0 -= 0.5;
        clipShapeForSymbol.r += 0.5;
      }
    }
    this._clipShapeForSymbol = clipShapeForSymbol;
    var visualColor = getVisualGradient(data, coordSys, api) || data.getVisual("style")[data.getVisual("drawType")];
    if (!(polyline && prevCoordSys.type === coordSys.type && step === this._step)) {
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      hasAnimation && this._initSymbolLabelAnimation(data, coordSys, clipShapeForSymbol);
      if (step) {
        points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
        if (stackedOnPoints) {
          stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
        }
      }
      polyline = this._newPolyline(points2);
      if (isAreaChart) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
    } else {
      if (isAreaChart && !polygon) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      } else if (polygon && !isAreaChart) {
        lineGroup.remove(polygon);
        polygon = this._polygon = null;
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      var oldClipPath = lineGroup.getClipPath();
      if (oldClipPath) {
        var newClipPath = createLineClipPath(this, coordSys, false, seriesModel);
        initProps(oldClipPath, {
          shape: newClipPath.shape
        }, seriesModel);
      } else {
        lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
      }
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      if (!isPointsSame(this._stackedOnPoints, stackedOnPoints) || !isPointsSame(this._points, points2)) {
        if (hasAnimation) {
          this._doUpdateAnimation(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls);
        } else {
          if (step) {
            points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
            if (stackedOnPoints) {
              stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
            }
          }
          polyline.setShape({
            points: points2
          });
          polygon && polygon.setShape({
            points: points2,
            stackedOnPoints
          });
        }
      }
    }
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    polyline.useStyle(defaults(lineStyleModel.getLineStyle(), {
      fill: "none",
      stroke: visualColor,
      lineJoin: "bevel"
    }));
    setStatesStylesFromModel(polyline, seriesModel, "lineStyle");
    if (polyline.style.lineWidth > 0 && seriesModel.get(["emphasis", "lineStyle", "width"]) === "bolder") {
      var emphasisLineStyle = polyline.getState("emphasis").style;
      emphasisLineStyle.lineWidth = +polyline.style.lineWidth + 1;
    }
    getECData(polyline).seriesIndex = seriesModel.seriesIndex;
    toggleHoverEmphasis(polyline, focus, blurScope, emphasisDisabled);
    var smooth = getSmooth(seriesModel.get("smooth"));
    var smoothMonotone = seriesModel.get("smoothMonotone");
    polyline.setShape({
      smooth,
      smoothMonotone,
      connectNulls
    });
    if (polygon) {
      var stackedOnSeries = data.getCalculationInfo("stackedOnSeries");
      var stackedOnSmooth = 0;
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: visualColor,
        opacity: 0.7,
        lineJoin: "bevel",
        decal: data.getVisual("style").decal
      }));
      if (stackedOnSeries) {
        stackedOnSmooth = getSmooth(stackedOnSeries.get("smooth"));
      }
      polygon.setShape({
        smooth,
        stackedOnSmooth,
        smoothMonotone,
        connectNulls
      });
      setStatesStylesFromModel(polygon, seriesModel, "areaStyle");
      getECData(polygon).seriesIndex = seriesModel.seriesIndex;
      toggleHoverEmphasis(polygon, focus, blurScope, emphasisDisabled);
    }
    var changePolyState = function(toState) {
      _this._changePolyState(toState);
    };
    data.eachItemGraphicEl(function(el) {
      el && (el.onHoverStateChange = changePolyState);
    });
    this._polyline.onHoverStateChange = changePolyState;
    this._data = data;
    this._coordSys = coordSys;
    this._stackedOnPoints = stackedOnPoints;
    this._points = points2;
    this._step = step;
    this._valueOrigin = valueOrigin;
    if (seriesModel.get("triggerLineEvent")) {
      this.packEventData(seriesModel, polyline);
      polygon && this.packEventData(seriesModel, polygon);
    }
  };
  LineView2.prototype.packEventData = function(seriesModel, el) {
    getECData(el).eventData = {
      componentType: "series",
      componentSubType: "line",
      componentIndex: seriesModel.componentIndex,
      seriesIndex: seriesModel.seriesIndex,
      seriesName: seriesModel.name,
      seriesType: "line"
    };
  };
  LineView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("emphasis");
    if (!(dataIndex instanceof Array) && dataIndex != null && dataIndex >= 0) {
      var points2 = data.getLayout("points");
      var symbol = data.getItemGraphicEl(dataIndex);
      if (!symbol) {
        var x2 = points2[dataIndex * 2];
        var y2 = points2[dataIndex * 2 + 1];
        if (isNaN(x2) || isNaN(y2)) {
          return;
        }
        if (this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(x2, y2)) {
          return;
        }
        var zlevel = seriesModel.get("zlevel");
        var z2 = seriesModel.get("z");
        symbol = new SymbolClz(data, dataIndex);
        symbol.x = x2;
        symbol.y = y2;
        symbol.setZ(zlevel, z2);
        var symbolLabel = symbol.getSymbolPath().getTextContent();
        if (symbolLabel) {
          symbolLabel.zlevel = zlevel;
          symbolLabel.z = z2;
          symbolLabel.z2 = this._polyline.z2 + 1;
        }
        symbol.__temp = true;
        data.setItemGraphicEl(dataIndex, symbol);
        symbol.stopSymbolAnimation(true);
        this.group.add(symbol);
      }
      symbol.highlight();
    } else {
      ChartView$1.prototype.highlight.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("normal");
    if (dataIndex != null && dataIndex >= 0) {
      var symbol = data.getItemGraphicEl(dataIndex);
      if (symbol) {
        if (symbol.__temp) {
          data.setItemGraphicEl(dataIndex, null);
          this.group.remove(symbol);
        } else {
          symbol.downplay();
        }
      }
    } else {
      ChartView$1.prototype.downplay.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype._changePolyState = function(toState) {
    var polygon = this._polygon;
    setStatesFlag(this._polyline, toState);
    polygon && setStatesFlag(polygon, toState);
  };
  LineView2.prototype._newPolyline = function(points2) {
    var polyline = this._polyline;
    if (polyline) {
      this._lineGroup.remove(polyline);
    }
    polyline = new ECPolyline({
      shape: {
        points: points2
      },
      segmentIgnoreThreshold: 2,
      z2: 10
    });
    this._lineGroup.add(polyline);
    this._polyline = polyline;
    return polyline;
  };
  LineView2.prototype._newPolygon = function(points2, stackedOnPoints) {
    var polygon = this._polygon;
    if (polygon) {
      this._lineGroup.remove(polygon);
    }
    polygon = new ECPolygon({
      shape: {
        points: points2,
        stackedOnPoints
      },
      segmentIgnoreThreshold: 2
    });
    this._lineGroup.add(polygon);
    this._polygon = polygon;
    return polygon;
  };
  LineView2.prototype._initSymbolLabelAnimation = function(data, coordSys, clipShape) {
    var isHorizontalOrRadial;
    var isCoordSysPolar;
    var baseAxis = coordSys.getBaseAxis();
    var isAxisInverse = baseAxis.inverse;
    if (coordSys.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
      isCoordSysPolar = false;
    } else if (coordSys.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
      isCoordSysPolar = true;
    }
    var seriesModel = data.hostModel;
    var seriesDuration = seriesModel.get("animationDuration");
    if (isFunction(seriesDuration)) {
      seriesDuration = seriesDuration(null);
    }
    var seriesDalay = seriesModel.get("animationDelay") || 0;
    var seriesDalayValue = isFunction(seriesDalay) ? seriesDalay(null) : seriesDalay;
    data.eachItemGraphicEl(function(symbol, idx) {
      var el = symbol;
      if (el) {
        var point = [symbol.x, symbol.y];
        var start2 = void 0;
        var end2 = void 0;
        var current = void 0;
        if (clipShape) {
          if (isCoordSysPolar) {
            var polarClip = clipShape;
            var coord = coordSys.pointToCoord(point);
            if (isHorizontalOrRadial) {
              start2 = polarClip.startAngle;
              end2 = polarClip.endAngle;
              current = -coord[1] / 180 * Math.PI;
            } else {
              start2 = polarClip.r0;
              end2 = polarClip.r;
              current = coord[0];
            }
          } else {
            var gridClip = clipShape;
            if (isHorizontalOrRadial) {
              start2 = gridClip.x;
              end2 = gridClip.x + gridClip.width;
              current = symbol.x;
            } else {
              start2 = gridClip.y + gridClip.height;
              end2 = gridClip.y;
              current = symbol.y;
            }
          }
        }
        var ratio = end2 === start2 ? 0 : (current - start2) / (end2 - start2);
        if (isAxisInverse) {
          ratio = 1 - ratio;
        }
        var delay = isFunction(seriesDalay) ? seriesDalay(idx) : seriesDuration * ratio + seriesDalayValue;
        var symbolPath = el.getSymbolPath();
        var text = symbolPath.getTextContent();
        el.attr({
          scaleX: 0,
          scaleY: 0
        });
        el.animateTo({
          scaleX: 1,
          scaleY: 1
        }, {
          duration: 200,
          setToFinal: true,
          delay
        });
        if (text) {
          text.animateFrom({
            style: {
              opacity: 0
            }
          }, {
            duration: 300,
            delay
          });
        }
        symbolPath.disableLabelAnimation = true;
      }
    });
  };
  LineView2.prototype._initOrUpdateEndLabel = function(seriesModel, coordSys, inheritColor) {
    var endLabelModel = seriesModel.getModel("endLabel");
    if (anyStateShowEndLabel(seriesModel)) {
      var data_2 = seriesModel.getData();
      var polyline = this._polyline;
      var points2 = data_2.getLayout("points");
      if (!points2) {
        polyline.removeTextContent();
        this._endLabel = null;
        return;
      }
      var endLabel = this._endLabel;
      if (!endLabel) {
        endLabel = this._endLabel = new ZRText$1({
          z2: 200
        });
        endLabel.ignoreClip = true;
        polyline.setTextContent(this._endLabel);
        polyline.disableLabelAnimation = true;
      }
      var dataIndex = getLastIndexNotNull(points2);
      if (dataIndex >= 0) {
        setLabelStyle(polyline, getLabelStatesModels(seriesModel, "endLabel"), {
          inheritColor,
          labelFetcher: seriesModel,
          labelDataIndex: dataIndex,
          defaultText: function(dataIndex2, opt, interpolatedValue) {
            return interpolatedValue != null ? getDefaultInterpolatedLabel(data_2, interpolatedValue) : getDefaultLabel(data_2, dataIndex2);
          },
          enableTextSetter: true
        }, getEndLabelStateSpecified(endLabelModel, coordSys));
        polyline.textConfig.position = null;
      }
    } else if (this._endLabel) {
      this._polyline.removeTextContent();
      this._endLabel = null;
    }
  };
  LineView2.prototype._endLabelOnDuring = function(percent, clipRect, data, animationRecord, valueAnimation, endLabelModel, coordSys) {
    var endLabel = this._endLabel;
    var polyline = this._polyline;
    if (endLabel) {
      if (percent < 1 && animationRecord.originalX == null) {
        animationRecord.originalX = endLabel.x;
        animationRecord.originalY = endLabel.y;
      }
      var points2 = data.getLayout("points");
      var seriesModel = data.hostModel;
      var connectNulls = seriesModel.get("connectNulls");
      var precision = endLabelModel.get("precision");
      var distance2 = endLabelModel.get("distance") || 0;
      var baseAxis = coordSys.getBaseAxis();
      var isHorizontal = baseAxis.isHorizontal();
      var isBaseInversed = baseAxis.inverse;
      var clipShape = clipRect.shape;
      var xOrY = isBaseInversed ? isHorizontal ? clipShape.x : clipShape.y + clipShape.height : isHorizontal ? clipShape.x + clipShape.width : clipShape.y;
      var distanceX = (isHorizontal ? distance2 : 0) * (isBaseInversed ? -1 : 1);
      var distanceY = (isHorizontal ? 0 : -distance2) * (isBaseInversed ? -1 : 1);
      var dim = isHorizontal ? "x" : "y";
      var dataIndexRange = getIndexRange(points2, xOrY, dim);
      var indices = dataIndexRange.range;
      var diff = indices[1] - indices[0];
      var value = void 0;
      if (diff >= 1) {
        if (diff > 1 && !connectNulls) {
          var pt = getPointAtIndex(points2, indices[0]);
          endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          valueAnimation && (value = seriesModel.getRawValue(indices[0]));
        } else {
          var pt = polyline.getPointOn(xOrY, dim);
          pt && endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          var startValue = seriesModel.getRawValue(indices[0]);
          var endValue = seriesModel.getRawValue(indices[1]);
          valueAnimation && (value = interpolateRawValues(data, precision, startValue, endValue, dataIndexRange.t));
        }
        animationRecord.lastFrameIndex = indices[0];
      } else {
        var idx = percent === 1 || animationRecord.lastFrameIndex > 0 ? indices[0] : 0;
        var pt = getPointAtIndex(points2, idx);
        valueAnimation && (value = seriesModel.getRawValue(idx));
        endLabel.attr({
          x: pt[0] + distanceX,
          y: pt[1] + distanceY
        });
      }
      if (valueAnimation) {
        labelInner(endLabel).setLabelText(value);
      }
    }
  };
  LineView2.prototype._doUpdateAnimation = function(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls) {
    var polyline = this._polyline;
    var polygon = this._polygon;
    var seriesModel = data.hostModel;
    var diff = lineAnimationDiff(this._data, data, this._stackedOnPoints, stackedOnPoints, this._coordSys, coordSys, this._valueOrigin);
    var current = diff.current;
    var stackedOnCurrent = diff.stackedOnCurrent;
    var next = diff.next;
    var stackedOnNext = diff.stackedOnNext;
    if (step) {
      current = turnPointsIntoStep(diff.current, coordSys, step, connectNulls);
      stackedOnCurrent = turnPointsIntoStep(diff.stackedOnCurrent, coordSys, step, connectNulls);
      next = turnPointsIntoStep(diff.next, coordSys, step, connectNulls);
      stackedOnNext = turnPointsIntoStep(diff.stackedOnNext, coordSys, step, connectNulls);
    }
    if (getBoundingDiff(current, next) > 3e3 || polygon && getBoundingDiff(stackedOnCurrent, stackedOnNext) > 3e3) {
      polyline.stopAnimation();
      polyline.setShape({
        points: next
      });
      if (polygon) {
        polygon.stopAnimation();
        polygon.setShape({
          points: next,
          stackedOnPoints: stackedOnNext
        });
      }
      return;
    }
    polyline.shape.__points = diff.current;
    polyline.shape.points = current;
    var target = {
      shape: {
        points: next
      }
    };
    if (diff.current !== current) {
      target.shape.__points = diff.next;
    }
    polyline.stopAnimation();
    updateProps$1(polyline, target, seriesModel);
    if (polygon) {
      polygon.setShape({
        points: current,
        stackedOnPoints: stackedOnCurrent
      });
      polygon.stopAnimation();
      updateProps$1(polygon, {
        shape: {
          stackedOnPoints: stackedOnNext
        }
      }, seriesModel);
      if (polyline.shape.points !== polygon.shape.points) {
        polygon.shape.points = polyline.shape.points;
      }
    }
    var updatedDataInfo = [];
    var diffStatus = diff.status;
    for (var i = 0; i < diffStatus.length; i++) {
      var cmd = diffStatus[i].cmd;
      if (cmd === "=") {
        var el = data.getItemGraphicEl(diffStatus[i].idx1);
        if (el) {
          updatedDataInfo.push({
            el,
            ptIdx: i
          });
        }
      }
    }
    if (polyline.animators && polyline.animators.length) {
      polyline.animators[0].during(function() {
        polygon && polygon.dirtyShape();
        var points2 = polyline.shape.__points;
        for (var i2 = 0; i2 < updatedDataInfo.length; i2++) {
          var el2 = updatedDataInfo[i2].el;
          var offset2 = updatedDataInfo[i2].ptIdx * 2;
          el2.x = points2[offset2];
          el2.y = points2[offset2 + 1];
          el2.markRedraw();
        }
      });
    }
  };
  LineView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var oldData = this._data;
    this._lineGroup.removeAll();
    this._symbolDraw.remove(true);
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
  };
  LineView2.type = "line";
  return LineView2;
}(ChartView$1);
var LineView$1 = LineView;
function pointsLayout(seriesType2, forceStoreInTypedArray) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var coordSys = seriesModel.coordinateSystem;
      var pipelineContext = seriesModel.pipelineContext;
      var useTypedArray = forceStoreInTypedArray || pipelineContext.large;
      if (!coordSys) {
        return;
      }
      var dims = map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }).slice(0, 2);
      var dimLen = dims.length;
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      if (isDimensionStacked(data, dims[0])) {
        dims[0] = stackResultDim;
      }
      if (isDimensionStacked(data, dims[1])) {
        dims[1] = stackResultDim;
      }
      var store = data.getStore();
      var dimIdx0 = data.getDimensionIndex(dims[0]);
      var dimIdx1 = data.getDimensionIndex(dims[1]);
      return dimLen && {
        progress: function(params, data2) {
          var segCount = params.end - params.start;
          var points2 = useTypedArray && createFloat32Array(segCount * dimLen);
          var tmpIn = [];
          var tmpOut = [];
          for (var i = params.start, offset2 = 0; i < params.end; i++) {
            var point = void 0;
            if (dimLen === 1) {
              var x2 = store.get(dimIdx0, i);
              point = coordSys.dataToPoint(x2, null, tmpOut);
            } else {
              tmpIn[0] = store.get(dimIdx0, i);
              tmpIn[1] = store.get(dimIdx1, i);
              point = coordSys.dataToPoint(tmpIn, null, tmpOut);
            }
            if (useTypedArray) {
              points2[offset2++] = point[0];
              points2[offset2++] = point[1];
            } else {
              data2.setItemLayout(i, point.slice());
            }
          }
          useTypedArray && data2.setLayout("points", points2);
        }
      };
    }
  };
}
var samplers = {
  average: function(frame) {
    var sum2 = 0;
    var count2 = 0;
    for (var i = 0; i < frame.length; i++) {
      if (!isNaN(frame[i])) {
        sum2 += frame[i];
        count2++;
      }
    }
    return count2 === 0 ? NaN : sum2 / count2;
  },
  sum: function(frame) {
    var sum2 = 0;
    for (var i = 0; i < frame.length; i++) {
      sum2 += frame[i] || 0;
    }
    return sum2;
  },
  max: function(frame) {
    var max3 = -Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] > max3 && (max3 = frame[i]);
    }
    return isFinite(max3) ? max3 : NaN;
  },
  min: function(frame) {
    var min3 = Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] < min3 && (min3 = frame[i]);
    }
    return isFinite(min3) ? min3 : NaN;
  },
  nearest: function(frame) {
    return frame[0];
  }
};
var indexSampler = function(frame) {
  return Math.round(frame.length / 2);
};
function dataSample(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel, api) {
      var data = seriesModel.getData();
      var sampling = seriesModel.get("sampling");
      var coordSys = seriesModel.coordinateSystem;
      var count2 = data.count();
      if (count2 > 10 && coordSys.type === "cartesian2d" && sampling) {
        var baseAxis = coordSys.getBaseAxis();
        var valueAxis2 = coordSys.getOtherAxis(baseAxis);
        var extent3 = baseAxis.getExtent();
        var dpr2 = api.getDevicePixelRatio();
        var size = Math.abs(extent3[1] - extent3[0]) * (dpr2 || 1);
        var rate = Math.round(count2 / size);
        if (isFinite(rate) && rate > 1) {
          if (sampling === "lttb") {
            seriesModel.setData(data.lttbDownSample(data.mapDimension(valueAxis2.dim), 1 / rate));
          }
          var sampler = void 0;
          if (isString$1(sampling)) {
            sampler = samplers[sampling];
          } else if (isFunction(sampling)) {
            sampler = sampling;
          }
          if (sampler) {
            seriesModel.setData(data.downSample(data.mapDimension(valueAxis2.dim), 1 / rate, sampler, indexSampler));
          }
        }
      }
    }
  };
}
function install$Q(registers) {
  registers.registerChartView(LineView$1);
  registers.registerSeriesModel(LineSeries);
  registers.registerLayout(pointsLayout("line", true));
  registers.registerVisual({
    seriesType: "line",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var lineStyle = seriesModel.getModel("lineStyle").getLineStyle();
      if (lineStyle && !lineStyle.stroke) {
        lineStyle.stroke = data.getVisual("style").fill;
      }
      data.setVisual("legendLineStyle", lineStyle);
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("line"));
}
var BaseBarSeriesModel = function(_super) {
  __extends(BaseBarSeriesModel2, _super);
  function BaseBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BaseBarSeriesModel2.type;
    return _this;
  }
  BaseBarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  BaseBarSeriesModel2.prototype.getMarkerPosition = function(value) {
    var coordSys = this.coordinateSystem;
    if (coordSys && coordSys.clampData) {
      var pt = coordSys.dataToPoint(coordSys.clampData(value));
      var data = this.getData();
      var offset2 = data.getLayout("offset");
      var size = data.getLayout("size");
      var offsetIndex = coordSys.getBaseAxis().isHorizontal() ? 0 : 1;
      pt[offsetIndex] += offset2 + size / 2;
      return pt;
    }
    return [NaN, NaN];
  };
  BaseBarSeriesModel2.type = "series.__base_bar__";
  BaseBarSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    barMinHeight: 0,
    barMinAngle: 0,
    large: false,
    largeThreshold: 400,
    progressive: 3e3,
    progressiveChunkMode: "mod"
  };
  return BaseBarSeriesModel2;
}(SeriesModel$1);
SeriesModel$1.registerClass(BaseBarSeriesModel);
var BaseBarSeriesModel$1 = BaseBarSeriesModel;
var BarSeriesModel = function(_super) {
  __extends(BarSeriesModel2, _super);
  function BarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BarSeriesModel2.type;
    return _this;
  }
  BarSeriesModel2.prototype.getInitialData = function() {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true,
      createInvertedIndices: !!this.get("realtimeSort", true) || null
    });
  };
  BarSeriesModel2.prototype.getProgressive = function() {
    return this.get("large") ? this.get("progressive") : false;
  };
  BarSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.get("progressiveThreshold");
    var largeThreshold = this.get("largeThreshold");
    if (largeThreshold > progressiveThreshold) {
      progressiveThreshold = largeThreshold;
    }
    return progressiveThreshold;
  };
  BarSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.rect(data.getItemLayout(dataIndex));
  };
  BarSeriesModel2.type = "series.bar";
  BarSeriesModel2.dependencies = ["grid", "polar"];
  BarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    clip: true,
    roundCap: false,
    showBackground: false,
    backgroundStyle: {
      color: "rgba(180, 180, 180, 0.2)",
      borderColor: null,
      borderWidth: 0,
      borderType: "solid",
      borderRadius: 0,
      shadowBlur: 0,
      shadowColor: null,
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    realtimeSort: false
  });
  return BarSeriesModel2;
}(BaseBarSeriesModel$1);
var BarSeries = BarSeriesModel;
var SausageShape = function() {
  function SausageShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return SausageShape2;
}();
var SausagePath = function(_super) {
  __extends(SausagePath2, _super);
  function SausagePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "sausage";
    return _this;
  }
  SausagePath2.prototype.getDefaultShape = function() {
    return new SausageShape();
  };
  SausagePath2.prototype.buildPath = function(ctx, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var r0 = Math.max(shape.r0 || 0, 0);
    var r2 = Math.max(shape.r, 0);
    var dr = (r2 - r0) * 0.5;
    var rCenter = r0 + dr;
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var PI22 = Math.PI * 2;
    var lessThanCircle = clockwise ? endAngle - startAngle < PI22 : startAngle - endAngle < PI22;
    if (!lessThanCircle) {
      startAngle = endAngle - (clockwise ? PI22 : -PI22);
    }
    var unitStartX = Math.cos(startAngle);
    var unitStartY = Math.sin(startAngle);
    var unitEndX = Math.cos(endAngle);
    var unitEndY = Math.sin(endAngle);
    if (lessThanCircle) {
      ctx.moveTo(unitStartX * r0 + cx, unitStartY * r0 + cy);
      ctx.arc(unitStartX * rCenter + cx, unitStartY * rCenter + cy, dr, -Math.PI + startAngle, startAngle, !clockwise);
    } else {
      ctx.moveTo(unitStartX * r2 + cx, unitStartY * r2 + cy);
    }
    ctx.arc(cx, cy, r2, startAngle, endAngle, !clockwise);
    ctx.arc(unitEndX * rCenter + cx, unitEndY * rCenter + cy, dr, endAngle - Math.PI * 2, endAngle - Math.PI, !clockwise);
    if (r0 !== 0) {
      ctx.arc(cx, cy, r0, endAngle, startAngle, clockwise);
    }
  };
  return SausagePath2;
}(Path$1);
var Sausage = SausagePath;
function createSectorCalculateTextPosition(positionMapping, opts) {
  opts = opts || {};
  var isRoundCap = opts.isRoundCap;
  return function(out2, opts2, boundingRect) {
    var textPosition = opts2.position;
    if (!textPosition || textPosition instanceof Array) {
      return calculateTextPosition(out2, opts2, boundingRect);
    }
    var mappedSectorPosition = positionMapping(textPosition);
    var distance2 = opts2.distance != null ? opts2.distance : 5;
    var sector = this.shape;
    var cx = sector.cx;
    var cy = sector.cy;
    var r2 = sector.r;
    var r0 = sector.r0;
    var middleR = (r2 + r0) / 2;
    var startAngle = sector.startAngle;
    var endAngle = sector.endAngle;
    var middleAngle = (startAngle + endAngle) / 2;
    var extraDist = isRoundCap ? Math.abs(r2 - r0) / 2 : 0;
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var x2 = cx + r2 * mathCos2(startAngle);
    var y2 = cy + r2 * mathSin2(startAngle);
    var textAlign = "left";
    var textVerticalAlign = "top";
    switch (mappedSectorPosition) {
      case "startArc":
        x2 = cx + (r0 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "insideStartArc":
        x2 = cx + (r0 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "startAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, distance2 + extraDist, false);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideStartAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, -distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, -distance2 + extraDist, false);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "middle":
        x2 = cx + middleR * mathCos2(middleAngle);
        y2 = cy + middleR * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "endArc":
        x2 = cx + (r2 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideEndArc":
        x2 = cx + (r2 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "endAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, distance2 + extraDist, true);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "insideEndAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, -distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, -distance2 + extraDist, true);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      default:
        return calculateTextPosition(out2, opts2, boundingRect);
    }
    out2 = out2 || {};
    out2.x = x2;
    out2.y = y2;
    out2.align = textAlign;
    out2.verticalAlign = textVerticalAlign;
    return out2;
  };
}
function setSectorTextRotation(sector, textPosition, positionMapping, rotateType) {
  if (isNumber(rotateType)) {
    sector.setTextConfig({
      rotation: rotateType
    });
    return;
  } else if (isArray$1(textPosition)) {
    sector.setTextConfig({
      rotation: 0
    });
    return;
  }
  var shape = sector.shape;
  var startAngle = shape.clockwise ? shape.startAngle : shape.endAngle;
  var endAngle = shape.clockwise ? shape.endAngle : shape.startAngle;
  var middleAngle = (startAngle + endAngle) / 2;
  var anchorAngle;
  var mappedSectorPosition = positionMapping(textPosition);
  switch (mappedSectorPosition) {
    case "startArc":
    case "insideStartArc":
    case "middle":
    case "insideEndArc":
    case "endArc":
      anchorAngle = middleAngle;
      break;
    case "startAngle":
    case "insideStartAngle":
      anchorAngle = startAngle;
      break;
    case "endAngle":
    case "insideEndAngle":
      anchorAngle = endAngle;
      break;
    default:
      sector.setTextConfig({
        rotation: 0
      });
      return;
  }
  var rotate2 = Math.PI * 1.5 - anchorAngle;
  if (mappedSectorPosition === "middle" && rotate2 > Math.PI / 2 && rotate2 < Math.PI * 1.5) {
    rotate2 -= Math.PI;
  }
  sector.setTextConfig({
    rotation: rotate2
  });
}
function adjustAngleDistanceX(angle, distance2, isEnd) {
  return distance2 * Math.sin(angle) * (isEnd ? -1 : 1);
}
function adjustAngleDistanceY(angle, distance2, isEnd) {
  return distance2 * Math.cos(angle) * (isEnd ? 1 : -1);
}
var mathMax$4 = Math.max;
var mathMin$4 = Math.min;
function getClipArea(coord, data) {
  var coordSysClipArea = coord.getArea && coord.getArea();
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var baseAxis = coord.getBaseAxis();
    if (baseAxis.type !== "category" || !baseAxis.onBand) {
      var expandWidth = data.getLayout("bandWidth");
      if (baseAxis.isHorizontal()) {
        coordSysClipArea.x -= expandWidth;
        coordSysClipArea.width += expandWidth * 2;
      } else {
        coordSysClipArea.y -= expandWidth;
        coordSysClipArea.height += expandWidth * 2;
      }
    }
  }
  return coordSysClipArea;
}
var BarView = function(_super) {
  __extends(BarView2, _super);
  function BarView2() {
    var _this = _super.call(this) || this;
    _this.type = BarView2.type;
    _this._isFirstFrame = true;
    return _this;
  }
  BarView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._model = seriesModel;
    this._removeOnRenderedListener(api);
    this._updateDrawMode(seriesModel);
    var coordinateSystemType = seriesModel.get("coordinateSystem");
    if (coordinateSystemType === "cartesian2d" || coordinateSystemType === "polar") {
      this._progressiveEls = null;
      this._isLargeDraw ? this._renderLarge(seriesModel, ecModel, api) : this._renderNormal(seriesModel, ecModel, api, payload);
    }
  };
  BarView2.prototype.incrementalPrepareRender = function(seriesModel) {
    this._clear();
    this._updateDrawMode(seriesModel);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype.incrementalRender = function(params, seriesModel) {
    this._progressiveEls = [];
    this._incrementalRenderLarge(params, seriesModel);
  };
  BarView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  BarView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  BarView2.prototype._renderNormal = function(seriesModel, ecModel, api, payload) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coord = seriesModel.coordinateSystem;
    var baseAxis = coord.getBaseAxis();
    var isHorizontalOrRadial;
    if (coord.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
    } else if (coord.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
    }
    var animationModel = seriesModel.isAnimationEnabled() ? seriesModel : null;
    var realtimeSortCfg = shouldRealtimeSort(seriesModel, coord);
    if (realtimeSortCfg) {
      this._enableRealtimeSort(realtimeSortCfg, data, api);
    }
    var needsClip = seriesModel.get("clip", true) || realtimeSortCfg;
    var coordSysClipArea = getClipArea(coord, data);
    group.removeClipPath();
    var roundCap = seriesModel.get("roundCap", true);
    var drawBackground = seriesModel.get("showBackground", true);
    var backgroundModel = seriesModel.getModel("backgroundStyle");
    var barBorderRadius = backgroundModel.get("borderRadius") || 0;
    var bgEls = [];
    var oldBgEls = this._backgroundEls;
    var isInitSort = payload && payload.isInitSort;
    var isChangeOrder = payload && payload.type === "changeAxisOrder";
    function createBackground(dataIndex) {
      var bgLayout = getLayout[coord.type](data, dataIndex);
      var bgEl = createBackgroundEl(coord, isHorizontalOrRadial, bgLayout);
      bgEl.useStyle(backgroundModel.getItemStyle());
      if (coord.type === "cartesian2d") {
        bgEl.setShape("r", barBorderRadius);
      }
      bgEls[dataIndex] = bgEl;
      return bgEl;
    }
    data.diff(oldData).add(function(dataIndex) {
      var itemModel = data.getItemModel(dataIndex);
      var layout2 = getLayout[coord.type](data, dataIndex, itemModel);
      if (drawBackground) {
        createBackground(dataIndex);
      }
      if (!data.hasValue(dataIndex) || !isValidLayout[coord.type](layout2)) {
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
      }
      var el = elementCreator[coord.type](seriesModel, data, dataIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, false, roundCap);
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, dataIndex, isHorizontalOrRadial, false, false);
      } else {
        initProps(el, {
          shape: layout2
        }, seriesModel, dataIndex);
      }
      data.setItemGraphicEl(dataIndex, el);
      group.add(el);
      el.ignore = isClipped;
    }).update(function(newIndex, oldIndex) {
      var itemModel = data.getItemModel(newIndex);
      var layout2 = getLayout[coord.type](data, newIndex, itemModel);
      if (drawBackground) {
        var bgEl = void 0;
        if (oldBgEls.length === 0) {
          bgEl = createBackground(oldIndex);
        } else {
          bgEl = oldBgEls[oldIndex];
          bgEl.useStyle(backgroundModel.getItemStyle());
          if (coord.type === "cartesian2d") {
            bgEl.setShape("r", barBorderRadius);
          }
          bgEls[newIndex] = bgEl;
        }
        var bgLayout = getLayout[coord.type](data, newIndex);
        var shape = createBackgroundShape(isHorizontalOrRadial, bgLayout, coord);
        updateProps$1(bgEl, {
          shape
        }, animationModel, newIndex);
      }
      var el = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex) || !isValidLayout[coord.type](layout2)) {
        group.remove(el);
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
        if (isClipped) {
          group.remove(el);
        }
      }
      if (!el) {
        el = elementCreator[coord.type](seriesModel, data, newIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, !!el, roundCap);
      } else {
        saveOldStyle(el);
      }
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      if (isChangeOrder) {
        var textEl = el.getTextContent();
        if (textEl) {
          var labelInnerStore = labelInner(textEl);
          if (labelInnerStore.prevValue != null) {
            labelInnerStore.prevValue = labelInnerStore.value;
          }
        }
      } else {
        updateStyle(el, data, newIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      }
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, newIndex, isHorizontalOrRadial, true, isChangeOrder);
      } else {
        updateProps$1(el, {
          shape: layout2
        }, seriesModel, newIndex, null);
      }
      data.setItemGraphicEl(newIndex, el);
      el.ignore = isClipped;
      group.add(el);
    }).remove(function(dataIndex) {
      var el = oldData.getItemGraphicEl(dataIndex);
      el && removeElementWithFadeOut(el, seriesModel, dataIndex);
    }).execute();
    var bgGroup = this._backgroundGroup || (this._backgroundGroup = new Group$6());
    bgGroup.removeAll();
    for (var i = 0; i < bgEls.length; ++i) {
      bgGroup.add(bgEls[i]);
    }
    group.add(bgGroup);
    this._backgroundEls = bgEls;
    this._data = data;
  };
  BarView2.prototype._renderLarge = function(seriesModel, ecModel, api) {
    this._clear();
    createLarge$1(seriesModel, this.group);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    this._removeBackground();
    createLarge$1(seriesModel, this.group, this._progressiveEls, true);
  };
  BarView2.prototype._updateLargeClip = function(seriesModel) {
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    var group = this.group;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
  };
  BarView2.prototype._enableRealtimeSort = function(realtimeSortCfg, data, api) {
    var _this = this;
    if (!data.count()) {
      return;
    }
    var baseAxis = realtimeSortCfg.baseAxis;
    if (this._isFirstFrame) {
      this._dispatchInitSort(data, realtimeSortCfg, api);
      this._isFirstFrame = false;
    } else {
      var orderMapping_1 = function(idx) {
        var el = data.getItemGraphicEl(idx);
        var shape = el && el.shape;
        return shape && Math.abs(baseAxis.isHorizontal() ? shape.height : shape.width) || 0;
      };
      this._onRendered = function() {
        _this._updateSortWithinSameData(data, orderMapping_1, baseAxis, api);
      };
      api.getZr().on("rendered", this._onRendered);
    }
  };
  BarView2.prototype._dataSort = function(data, baseAxis, orderMapping) {
    var info = [];
    data.each(data.mapDimension(baseAxis.dim), function(ordinalNumber, dataIdx) {
      var mappedValue = orderMapping(dataIdx);
      mappedValue = mappedValue == null ? NaN : mappedValue;
      info.push({
        dataIndex: dataIdx,
        mappedValue,
        ordinalNumber
      });
    });
    info.sort(function(a, b2) {
      return b2.mappedValue - a.mappedValue;
    });
    return {
      ordinalNumbers: map$1(info, function(item) {
        return item.ordinalNumber;
      })
    };
  };
  BarView2.prototype._isOrderChangedWithinSameData = function(data, orderMapping, baseAxis) {
    var scale2 = baseAxis.scale;
    var ordinalDataDim = data.mapDimension(baseAxis.dim);
    var lastValue = Number.MAX_VALUE;
    for (var tickNum = 0, len2 = scale2.getOrdinalMeta().categories.length; tickNum < len2; ++tickNum) {
      var rawIdx = data.rawIndexOf(ordinalDataDim, scale2.getRawOrdinalNumber(tickNum));
      var value = rawIdx < 0 ? Number.MIN_VALUE : orderMapping(data.indexOfRawIndex(rawIdx));
      if (value > lastValue) {
        return true;
      }
      lastValue = value;
    }
    return false;
  };
  BarView2.prototype._isOrderDifferentInView = function(orderInfo, baseAxis) {
    var scale2 = baseAxis.scale;
    var extent3 = scale2.getExtent();
    var tickNum = Math.max(0, extent3[0]);
    var tickMax = Math.min(extent3[1], scale2.getOrdinalMeta().categories.length - 1);
    for (; tickNum <= tickMax; ++tickNum) {
      if (orderInfo.ordinalNumbers[tickNum] !== scale2.getRawOrdinalNumber(tickNum)) {
        return true;
      }
    }
  };
  BarView2.prototype._updateSortWithinSameData = function(data, orderMapping, baseAxis, api) {
    if (!this._isOrderChangedWithinSameData(data, orderMapping, baseAxis)) {
      return;
    }
    var sortInfo = this._dataSort(data, baseAxis, orderMapping);
    if (this._isOrderDifferentInView(sortInfo, baseAxis)) {
      this._removeOnRenderedListener(api);
      api.dispatchAction({
        type: "changeAxisOrder",
        componentType: baseAxis.dim + "Axis",
        axisId: baseAxis.index,
        sortInfo
      });
    }
  };
  BarView2.prototype._dispatchInitSort = function(data, realtimeSortCfg, api) {
    var baseAxis = realtimeSortCfg.baseAxis;
    var sortResult = this._dataSort(data, baseAxis, function(dataIdx) {
      return data.get(data.mapDimension(realtimeSortCfg.otherAxis.dim), dataIdx);
    });
    api.dispatchAction({
      type: "changeAxisOrder",
      componentType: baseAxis.dim + "Axis",
      isInitSort: true,
      axisId: baseAxis.index,
      sortInfo: sortResult
    });
  };
  BarView2.prototype.remove = function(ecModel, api) {
    this._clear(this._model);
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype.dispose = function(ecModel, api) {
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype._removeOnRenderedListener = function(api) {
    if (this._onRendered) {
      api.getZr().off("rendered", this._onRendered);
      this._onRendered = null;
    }
  };
  BarView2.prototype._clear = function(model) {
    var group = this.group;
    var data = this._data;
    if (model && model.isAnimationEnabled() && data && !this._isLargeDraw) {
      this._removeBackground();
      this._backgroundEls = [];
      data.eachItemGraphicEl(function(el) {
        removeElementWithFadeOut(el, model, getECData(el).dataIndex);
      });
    } else {
      group.removeAll();
    }
    this._data = null;
    this._isFirstFrame = true;
  };
  BarView2.prototype._removeBackground = function() {
    this.group.remove(this._backgroundGroup);
    this._backgroundGroup = null;
  };
  BarView2.type = "bar";
  return BarView2;
}(ChartView$1);
var clip = {
  cartesian2d: function(coordSysBoundingRect, layout2) {
    var signWidth = layout2.width < 0 ? -1 : 1;
    var signHeight = layout2.height < 0 ? -1 : 1;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    var coordSysX2 = coordSysBoundingRect.x + coordSysBoundingRect.width;
    var coordSysY2 = coordSysBoundingRect.y + coordSysBoundingRect.height;
    var x2 = mathMax$4(layout2.x, coordSysBoundingRect.x);
    var x22 = mathMin$4(layout2.x + layout2.width, coordSysX2);
    var y2 = mathMax$4(layout2.y, coordSysBoundingRect.y);
    var y22 = mathMin$4(layout2.y + layout2.height, coordSysY2);
    var xClipped = x22 < x2;
    var yClipped = y22 < y2;
    layout2.x = xClipped && x2 > coordSysX2 ? x22 : x2;
    layout2.y = yClipped && y2 > coordSysY2 ? y22 : y2;
    layout2.width = xClipped ? 0 : x22 - x2;
    layout2.height = yClipped ? 0 : y22 - y2;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    return xClipped || yClipped;
  },
  polar: function(coordSysClipArea, layout2) {
    var signR = layout2.r0 <= layout2.r ? 1 : -1;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    var r2 = mathMin$4(layout2.r, coordSysClipArea.r);
    var r0 = mathMax$4(layout2.r0, coordSysClipArea.r0);
    layout2.r = r2;
    layout2.r0 = r0;
    var clipped = r2 - r0 < 0;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    return clipped;
  }
};
var elementCreator = {
  cartesian2d: function(seriesModel, data, newIndex, layout2, isHorizontal, animationModel, axisModel, isUpdate, roundCap) {
    var rect = new Rect$3({
      shape: extend({}, layout2),
      z2: 1
    });
    rect.__dataIndex = newIndex;
    rect.name = "item";
    if (animationModel) {
      var rectShape = rect.shape;
      var animateProperty = isHorizontal ? "height" : "width";
      rectShape[animateProperty] = 0;
    }
    return rect;
  },
  polar: function(seriesModel, data, newIndex, layout2, isRadial, animationModel, axisModel, isUpdate, roundCap) {
    var ShapeClass = !isRadial && roundCap ? Sausage : Sector$1;
    var sector = new ShapeClass({
      shape: layout2,
      z2: 1
    });
    sector.name = "item";
    var positionMap = createPolarPositionMapping(isRadial);
    sector.calculateTextPosition = createSectorCalculateTextPosition(positionMap, {
      isRoundCap: ShapeClass === Sausage
    });
    if (animationModel) {
      var sectorShape = sector.shape;
      var animateProperty = isRadial ? "r" : "endAngle";
      var animateTarget = {};
      sectorShape[animateProperty] = isRadial ? 0 : layout2.startAngle;
      animateTarget[animateProperty] = layout2[animateProperty];
      (isUpdate ? updateProps$1 : initProps)(sector, {
        shape: animateTarget
      }, animationModel);
    }
    return sector;
  }
};
function shouldRealtimeSort(seriesModel, coordSys) {
  var realtimeSortOption = seriesModel.get("realtimeSort", true);
  var baseAxis = coordSys.getBaseAxis();
  if (realtimeSortOption && baseAxis.type === "category" && coordSys.type === "cartesian2d") {
    return {
      baseAxis,
      otherAxis: coordSys.getOtherAxis(baseAxis)
    };
  }
}
function updateRealtimeAnimation(realtimeSortCfg, seriesAnimationModel, el, layout2, newIndex, isHorizontal, isUpdate, isChangeOrder) {
  var seriesTarget;
  var axisTarget;
  if (isHorizontal) {
    axisTarget = {
      x: layout2.x,
      width: layout2.width
    };
    seriesTarget = {
      y: layout2.y,
      height: layout2.height
    };
  } else {
    axisTarget = {
      y: layout2.y,
      height: layout2.height
    };
    seriesTarget = {
      x: layout2.x,
      width: layout2.width
    };
  }
  if (!isChangeOrder) {
    (isUpdate ? updateProps$1 : initProps)(el, {
      shape: seriesTarget
    }, seriesAnimationModel, newIndex, null);
  }
  var axisAnimationModel = seriesAnimationModel ? realtimeSortCfg.baseAxis.model : null;
  (isUpdate ? updateProps$1 : initProps)(el, {
    shape: axisTarget
  }, axisAnimationModel, newIndex);
}
function checkPropertiesNotValid(obj, props) {
  for (var i = 0; i < props.length; i++) {
    if (!isFinite(obj[props[i]])) {
      return true;
    }
  }
  return false;
}
var rectPropties = ["x", "y", "width", "height"];
var polarPropties = ["cx", "cy", "r", "startAngle", "endAngle"];
var isValidLayout = {
  cartesian2d: function(layout2) {
    return !checkPropertiesNotValid(layout2, rectPropties);
  },
  polar: function(layout2) {
    return !checkPropertiesNotValid(layout2, polarPropties);
  }
};
var getLayout = {
  cartesian2d: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    var fixedLineWidth = itemModel ? getLineWidth(itemModel, layout2) : 0;
    var signX = layout2.width > 0 ? 1 : -1;
    var signY = layout2.height > 0 ? 1 : -1;
    return {
      x: layout2.x + signX * fixedLineWidth / 2,
      y: layout2.y + signY * fixedLineWidth / 2,
      width: layout2.width - signX * fixedLineWidth,
      height: layout2.height - signY * fixedLineWidth
    };
  },
  polar: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    return {
      cx: layout2.cx,
      cy: layout2.cy,
      r0: layout2.r0,
      r: layout2.r,
      startAngle: layout2.startAngle,
      endAngle: layout2.endAngle,
      clockwise: layout2.clockwise
    };
  }
};
function isZeroOnPolar(layout2) {
  return layout2.startAngle != null && layout2.endAngle != null && layout2.startAngle === layout2.endAngle;
}
function createPolarPositionMapping(isRadial) {
  return function(isRadial2) {
    var arcOrAngle = isRadial2 ? "Arc" : "Angle";
    return function(position2) {
      switch (position2) {
        case "start":
        case "insideStart":
        case "end":
        case "insideEnd":
          return position2 + arcOrAngle;
        default:
          return position2;
      }
    };
  }(isRadial);
}
function updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, isPolar) {
  var style2 = data.getItemVisual(dataIndex, "style");
  if (!isPolar) {
    el.setShape("r", itemModel.get(["itemStyle", "borderRadius"]) || 0);
  }
  el.useStyle(style2);
  var cursorStyle = itemModel.getShallow("cursor");
  cursorStyle && el.attr("cursor", cursorStyle);
  var labelPositionOutside = isPolar ? isHorizontalOrRadial ? layout2.r >= layout2.r0 ? "endArc" : "startArc" : layout2.endAngle >= layout2.startAngle ? "endAngle" : "startAngle" : isHorizontalOrRadial ? layout2.height >= 0 ? "bottom" : "top" : layout2.width >= 0 ? "right" : "left";
  var labelStatesModels = getLabelStatesModels(itemModel);
  setLabelStyle(el, labelStatesModels, {
    labelFetcher: seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(seriesModel.getData(), dataIndex),
    inheritColor: style2.fill,
    defaultOpacity: style2.opacity,
    defaultOutsidePosition: labelPositionOutside
  });
  var label = el.getTextContent();
  if (isPolar && label) {
    var position2 = itemModel.get(["label", "position"]);
    el.textConfig.inside = position2 === "middle" ? true : null;
    setSectorTextRotation(el, position2 === "outside" ? labelPositionOutside : position2, createPolarPositionMapping(isHorizontalOrRadial), itemModel.get(["label", "rotate"]));
  }
  setLabelValueAnimation(label, labelStatesModels, seriesModel.getRawValue(dataIndex), function(value) {
    return getDefaultInterpolatedLabel(data, value);
  });
  var emphasisModel = itemModel.getModel(["emphasis"]);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  setStatesStylesFromModel(el, itemModel);
  if (isZeroOnPolar(layout2)) {
    el.style.fill = "none";
    el.style.stroke = "none";
    each$g(el.states, function(state) {
      if (state.style) {
        state.style.fill = state.style.stroke = "none";
      }
    });
  }
}
function getLineWidth(itemModel, rawLayout) {
  var borderColor = itemModel.get(["itemStyle", "borderColor"]);
  if (!borderColor || borderColor === "none") {
    return 0;
  }
  var lineWidth = itemModel.get(["itemStyle", "borderWidth"]) || 0;
  var width = isNaN(rawLayout.width) ? Number.MAX_VALUE : Math.abs(rawLayout.width);
  var height = isNaN(rawLayout.height) ? Number.MAX_VALUE : Math.abs(rawLayout.height);
  return Math.min(lineWidth, width, height);
}
var LagePathShape = function() {
  function LagePathShape2() {
  }
  return LagePathShape2;
}();
var LargePath = function(_super) {
  __extends(LargePath2, _super);
  function LargePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeBar";
    return _this;
  }
  LargePath2.prototype.getDefaultShape = function() {
    return new LagePathShape();
  };
  LargePath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var baseDimIdx = this.baseDimIdx;
    var valueDimIdx = 1 - this.baseDimIdx;
    var startPoint = [];
    var size = [];
    var barWidth = this.barWidth;
    for (var i = 0; i < points2.length; i += 3) {
      size[baseDimIdx] = barWidth;
      size[valueDimIdx] = points2[i + 2];
      startPoint[baseDimIdx] = points2[i + baseDimIdx];
      startPoint[valueDimIdx] = points2[i + valueDimIdx];
      ctx.rect(startPoint[0], startPoint[1], size[0], size[1]);
    }
  };
  return LargePath2;
}(Path$1);
function createLarge$1(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var baseDimIdx = data.getLayout("valueAxisHorizontal") ? 1 : 0;
  var largeDataIndices = data.getLayout("largeDataIndices");
  var barWidth = data.getLayout("size");
  var backgroundModel = seriesModel.getModel("backgroundStyle");
  var bgPoints = data.getLayout("largeBackgroundPoints");
  if (bgPoints) {
    var bgEl = new LargePath({
      shape: {
        points: bgPoints
      },
      incremental: !!incremental,
      silent: true,
      z2: 0
    });
    bgEl.baseDimIdx = baseDimIdx;
    bgEl.largeDataIndices = largeDataIndices;
    bgEl.barWidth = barWidth;
    bgEl.useStyle(backgroundModel.getItemStyle());
    group.add(bgEl);
    progressiveEls && progressiveEls.push(bgEl);
  }
  var el = new LargePath({
    shape: {
      points: data.getLayout("largePoints")
    },
    incremental: !!incremental,
    z2: 1
  });
  el.baseDimIdx = baseDimIdx;
  el.largeDataIndices = largeDataIndices;
  el.barWidth = barWidth;
  group.add(el);
  el.useStyle(data.getVisual("style"));
  getECData(el).seriesIndex = seriesModel.seriesIndex;
  if (!seriesModel.get("silent")) {
    el.on("mousedown", largePathUpdateDataIndex);
    el.on("mousemove", largePathUpdateDataIndex);
  }
  progressiveEls && progressiveEls.push(el);
}
var largePathUpdateDataIndex = throttle(function(event) {
  var largePath = this;
  var dataIndex = largePathFindDataIndex(largePath, event.offsetX, event.offsetY);
  getECData(largePath).dataIndex = dataIndex >= 0 ? dataIndex : null;
}, 30, false);
function largePathFindDataIndex(largePath, x2, y2) {
  var baseDimIdx = largePath.baseDimIdx;
  var valueDimIdx = 1 - baseDimIdx;
  var points2 = largePath.shape.points;
  var largeDataIndices = largePath.largeDataIndices;
  var startPoint = [];
  var size = [];
  var barWidth = largePath.barWidth;
  for (var i = 0, len2 = points2.length / 3; i < len2; i++) {
    var ii2 = i * 3;
    size[baseDimIdx] = barWidth;
    size[valueDimIdx] = points2[ii2 + 2];
    startPoint[baseDimIdx] = points2[ii2 + baseDimIdx];
    startPoint[valueDimIdx] = points2[ii2 + valueDimIdx];
    if (size[valueDimIdx] < 0) {
      startPoint[valueDimIdx] += size[valueDimIdx];
      size[valueDimIdx] = -size[valueDimIdx];
    }
    if (x2 >= startPoint[0] && x2 <= startPoint[0] + size[0] && y2 >= startPoint[1] && y2 <= startPoint[1] + size[1]) {
      return largeDataIndices[i];
    }
  }
  return -1;
}
function createBackgroundShape(isHorizontalOrRadial, layout2, coord) {
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var rectShape = layout2;
    var coordLayout = coord.getArea();
    return {
      x: isHorizontalOrRadial ? rectShape.x : coordLayout.x,
      y: isHorizontalOrRadial ? coordLayout.y : rectShape.y,
      width: isHorizontalOrRadial ? rectShape.width : coordLayout.width,
      height: isHorizontalOrRadial ? coordLayout.height : rectShape.height
    };
  } else {
    var coordLayout = coord.getArea();
    var sectorShape = layout2;
    return {
      cx: coordLayout.cx,
      cy: coordLayout.cy,
      r0: isHorizontalOrRadial ? coordLayout.r0 : sectorShape.r0,
      r: isHorizontalOrRadial ? coordLayout.r : sectorShape.r,
      startAngle: isHorizontalOrRadial ? sectorShape.startAngle : 0,
      endAngle: isHorizontalOrRadial ? sectorShape.endAngle : Math.PI * 2
    };
  }
}
function createBackgroundEl(coord, isHorizontalOrRadial, layout2) {
  var ElementClz = coord.type === "polar" ? Sector$1 : Rect$3;
  return new ElementClz({
    shape: createBackgroundShape(isHorizontalOrRadial, layout2, coord),
    silent: true,
    z2: 0
  });
}
var BarView$1 = BarView;
function install$P(registers) {
  registers.registerChartView(BarView$1);
  registers.registerSeriesModel(BarSeries);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "bar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("bar"));
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("bar"));
  registers.registerAction({
    type: "changeAxisOrder",
    event: "changeAxisOrder",
    update: "update"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      if (payload.sortInfo) {
        componentModel.axis.setCategorySortInfo(payload.sortInfo);
      }
    });
  });
}
var PI2$1 = Math.PI * 2;
var RADIAN$2 = Math.PI / 180;
function getViewRect$5(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getBasicPieLayout(seriesModel, api) {
  var viewRect2 = getViewRect$5(seriesModel, api);
  var center2 = seriesModel.get("center");
  var radius = seriesModel.get("radius");
  if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  if (!isArray$1(center2)) {
    center2 = [center2, center2];
  }
  var width = parsePercent(viewRect2.width, api.getWidth());
  var height = parsePercent(viewRect2.height, api.getHeight());
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], width) + viewRect2.x;
  var cy = parsePercent(center2[1], height) + viewRect2.y;
  var r0 = parsePercent(radius[0], size / 2);
  var r2 = parsePercent(radius[1], size / 2);
  return {
    cx,
    cy,
    r0,
    r: r2
  };
}
function pieLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var viewRect2 = getViewRect$5(seriesModel, api);
    var _a2 = getBasicPieLayout(seriesModel, api), cx = _a2.cx, cy = _a2.cy, r2 = _a2.r, r0 = _a2.r0;
    var startAngle = -seriesModel.get("startAngle") * RADIAN$2;
    var minAngle = seriesModel.get("minAngle") * RADIAN$2;
    var validDataCount = 0;
    data.each(valueDim, function(value) {
      !isNaN(value) && validDataCount++;
    });
    var sum2 = data.getSum(valueDim);
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var clockwise = seriesModel.get("clockwise");
    var roseType = seriesModel.get("roseType");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var extent3 = data.getDataExtent(valueDim);
    extent3[0] = 0;
    var restAngle = PI2$1;
    var valueSumLargerThanMinAngle = 0;
    var currentAngle = startAngle;
    var dir3 = clockwise ? 1 : -1;
    data.setLayout({
      viewRect: viewRect2,
      r: r2
    });
    data.each(valueDim, function(value, idx) {
      var angle;
      if (isNaN(value)) {
        data.setItemLayout(idx, {
          angle: NaN,
          startAngle: NaN,
          endAngle: NaN,
          clockwise,
          cx,
          cy,
          r0,
          r: roseType ? NaN : r2
        });
        return;
      }
      if (roseType !== "area") {
        angle = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
      } else {
        angle = PI2$1 / validDataCount;
      }
      if (angle < minAngle) {
        angle = minAngle;
        restAngle -= minAngle;
      } else {
        valueSumLargerThanMinAngle += value;
      }
      var endAngle = currentAngle + dir3 * angle;
      data.setItemLayout(idx, {
        angle,
        startAngle: currentAngle,
        endAngle,
        clockwise,
        cx,
        cy,
        r0,
        r: roseType ? linearMap$2(value, extent3, [r0, r2]) : r2
      });
      currentAngle = endAngle;
    });
    if (restAngle < PI2$1 && validDataCount) {
      if (restAngle <= 1e-3) {
        var angle_1 = PI2$1 / validDataCount;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_1 = data.getItemLayout(idx);
            layout_1.angle = angle_1;
            layout_1.startAngle = startAngle + dir3 * idx * angle_1;
            layout_1.endAngle = startAngle + dir3 * (idx + 1) * angle_1;
          }
        });
      } else {
        unitRadian = restAngle / valueSumLargerThanMinAngle;
        currentAngle = startAngle;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_2 = data.getItemLayout(idx);
            var angle = layout_2.angle === minAngle ? minAngle : value * unitRadian;
            layout_2.startAngle = currentAngle;
            layout_2.endAngle = currentAngle + dir3 * angle;
            currentAngle += dir3 * angle;
          }
        });
      }
    }
  });
}
function dataFilter$1(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var legendModels = ecModel.findComponents({
        mainType: "legend"
      });
      if (!legendModels || !legendModels.length) {
        return;
      }
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var name = data.getName(idx);
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(name)) {
            return false;
          }
        }
        return true;
      });
    }
  };
}
var RADIAN$1 = Math.PI / 180;
function adjustSingleSide(list, cx, cy, r2, dir3, viewWidth, viewHeight, viewLeft, viewTop, farthestX) {
  if (list.length < 2) {
    return;
  }
  function recalculateXOnSemiToAlignOnEllipseCurve(semi) {
    var rB = semi.rB;
    var rB2 = rB * rB;
    for (var i2 = 0; i2 < semi.list.length; i2++) {
      var item = semi.list[i2];
      var dy = Math.abs(item.label.y - cy);
      var rA = r2 + item.len;
      var rA2 = rA * rA;
      var dx2 = Math.sqrt((1 - Math.abs(dy * dy / rB2)) * rA2);
      var newX = cx + (dx2 + item.len2) * dir3;
      var deltaX = newX - item.label.x;
      var newTargetWidth = item.targetTextWidth - deltaX * dir3;
      constrainTextWidth(item, newTargetWidth, true);
      item.label.x = newX;
    }
  }
  function recalculateX(items) {
    var topSemi = {
      list: [],
      maxY: 0
    };
    var bottomSemi = {
      list: [],
      maxY: 0
    };
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].labelAlignTo !== "none") {
        continue;
      }
      var item = items[i2];
      var semi = item.label.y > cy ? bottomSemi : topSemi;
      var dy = Math.abs(item.label.y - cy);
      if (dy >= semi.maxY) {
        var dx2 = item.label.x - cx - item.len2 * dir3;
        var rA = r2 + item.len;
        var rB = Math.abs(dx2) < rA ? Math.sqrt(dy * dy / (1 - dx2 * dx2 / rA / rA)) : rA;
        semi.rB = rB;
        semi.maxY = dy;
      }
      semi.list.push(item);
    }
    recalculateXOnSemiToAlignOnEllipseCurve(topSemi);
    recalculateXOnSemiToAlignOnEllipseCurve(bottomSemi);
  }
  var len2 = list.length;
  for (var i = 0; i < len2; i++) {
    if (list[i].position === "outer" && list[i].labelAlignTo === "labelLine") {
      var dx = list[i].label.x - farthestX;
      list[i].linePoints[1][0] += dx;
      list[i].label.x = farthestX;
    }
  }
  if (shiftLayoutOnY(list, viewTop, viewTop + viewHeight)) {
    recalculateX(list);
  }
}
function avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop) {
  var leftList = [];
  var rightList = [];
  var leftmostX = Number.MAX_VALUE;
  var rightmostX = -Number.MAX_VALUE;
  for (var i = 0; i < labelLayoutList.length; i++) {
    var label = labelLayoutList[i].label;
    if (isPositionCenter(labelLayoutList[i])) {
      continue;
    }
    if (label.x < cx) {
      leftmostX = Math.min(leftmostX, label.x);
      leftList.push(labelLayoutList[i]);
    } else {
      rightmostX = Math.max(rightmostX, label.x);
      rightList.push(labelLayoutList[i]);
    }
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      if (layout2.labelStyleWidth != null) {
        continue;
      }
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var targetTextWidth = void 0;
      if (layout2.labelAlignTo === "edge") {
        if (label.x < cx) {
          targetTextWidth = linePoints[2][0] - layout2.labelDistance - viewLeft - layout2.edgeDistance;
        } else {
          targetTextWidth = viewLeft + viewWidth - layout2.edgeDistance - linePoints[2][0] - layout2.labelDistance;
        }
      } else if (layout2.labelAlignTo === "labelLine") {
        if (label.x < cx) {
          targetTextWidth = leftmostX - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - rightmostX - layout2.bleedMargin;
        }
      } else {
        if (label.x < cx) {
          targetTextWidth = label.x - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - label.x - layout2.bleedMargin;
        }
      }
      layout2.targetTextWidth = targetTextWidth;
      constrainTextWidth(layout2, targetTextWidth);
    }
  }
  adjustSingleSide(rightList, cx, cy, r2, 1, viewWidth, viewHeight, viewLeft, viewTop, rightmostX);
  adjustSingleSide(leftList, cx, cy, r2, -1, viewWidth, viewHeight, viewLeft, viewTop, leftmostX);
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var isAlignToEdge = layout2.labelAlignTo === "edge";
      var padding = label.style.padding;
      var paddingH = padding ? padding[1] + padding[3] : 0;
      var extraPaddingH = label.style.backgroundColor ? 0 : paddingH;
      var realTextWidth = layout2.rect.width + extraPaddingH;
      var dist2 = linePoints[1][0] - linePoints[2][0];
      if (isAlignToEdge) {
        if (label.x < cx) {
          linePoints[2][0] = viewLeft + layout2.edgeDistance + realTextWidth + layout2.labelDistance;
        } else {
          linePoints[2][0] = viewLeft + viewWidth - layout2.edgeDistance - realTextWidth - layout2.labelDistance;
        }
      } else {
        if (label.x < cx) {
          linePoints[2][0] = label.x + layout2.labelDistance;
        } else {
          linePoints[2][0] = label.x - layout2.labelDistance;
        }
        linePoints[1][0] = linePoints[2][0] + dist2;
      }
      linePoints[1][1] = linePoints[2][1] = label.y;
    }
  }
}
function constrainTextWidth(layout2, availableWidth, forceRecalculate) {
  if (forceRecalculate === void 0) {
    forceRecalculate = false;
  }
  if (layout2.labelStyleWidth != null) {
    return;
  }
  var label = layout2.label;
  var style2 = label.style;
  var textRect = layout2.rect;
  var bgColor = style2.backgroundColor;
  var padding = style2.padding;
  var paddingH = padding ? padding[1] + padding[3] : 0;
  var overflow = style2.overflow;
  var oldOuterWidth = textRect.width + (bgColor ? 0 : paddingH);
  if (availableWidth < oldOuterWidth || forceRecalculate) {
    var oldHeight = textRect.height;
    if (overflow && overflow.match("break")) {
      label.setStyle("backgroundColor", null);
      label.setStyle("width", availableWidth - paddingH);
      var innerRect = label.getBoundingRect();
      label.setStyle("width", Math.ceil(innerRect.width));
      label.setStyle("backgroundColor", bgColor);
    } else {
      var availableInnerWidth = availableWidth - paddingH;
      var newWidth = availableWidth < oldOuterWidth ? availableInnerWidth : forceRecalculate ? availableInnerWidth > layout2.unconstrainedWidth ? null : availableInnerWidth : null;
      label.setStyle("width", newWidth);
    }
    var newRect = label.getBoundingRect();
    textRect.width = newRect.width;
    var margin = (label.style.margin || 0) + 2.1;
    textRect.height = newRect.height + margin;
    textRect.y -= (textRect.height - oldHeight) / 2;
  }
}
function isPositionCenter(sectorShape) {
  return sectorShape.position === "center";
}
function pieLabelLayout(seriesModel) {
  var data = seriesModel.getData();
  var labelLayoutList = [];
  var cx;
  var cy;
  var hasLabelRotate = false;
  var minShowLabelRadian = (seriesModel.get("minShowLabelAngle") || 0) * RADIAN$1;
  var viewRect2 = data.getLayout("viewRect");
  var r2 = data.getLayout("r");
  var viewWidth = viewRect2.width;
  var viewLeft = viewRect2.x;
  var viewTop = viewRect2.y;
  var viewHeight = viewRect2.height;
  function setNotShow(el) {
    el.ignore = true;
  }
  function isLabelShown(label2) {
    if (!label2.ignore) {
      return true;
    }
    for (var key in label2.states) {
      if (label2.states[key].ignore === false) {
        return true;
      }
    }
    return false;
  }
  data.each(function(idx) {
    var sector = data.getItemGraphicEl(idx);
    var sectorShape = sector.shape;
    var label2 = sector.getTextContent();
    var labelLine2 = sector.getTextGuideLine();
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position") || itemModel.get(["emphasis", "label", "position"]);
    var labelDistance = labelModel.get("distanceToLabelLine");
    var labelAlignTo = labelModel.get("alignTo");
    var edgeDistance = parsePercent(labelModel.get("edgeDistance"), viewWidth);
    var bleedMargin = labelModel.get("bleedMargin");
    var labelLineModel = itemModel.getModel("labelLine");
    var labelLineLen = labelLineModel.get("length");
    labelLineLen = parsePercent(labelLineLen, viewWidth);
    var labelLineLen2 = labelLineModel.get("length2");
    labelLineLen2 = parsePercent(labelLineLen2, viewWidth);
    if (Math.abs(sectorShape.endAngle - sectorShape.startAngle) < minShowLabelRadian) {
      each$g(label2.states, setNotShow);
      label2.ignore = true;
      return;
    }
    if (!isLabelShown(label2)) {
      return;
    }
    var midAngle = (sectorShape.startAngle + sectorShape.endAngle) / 2;
    var nx = Math.cos(midAngle);
    var ny = Math.sin(midAngle);
    var textX;
    var textY;
    var linePoints2;
    var textAlign;
    cx = sectorShape.cx;
    cy = sectorShape.cy;
    var isLabelInside = labelPosition === "inside" || labelPosition === "inner";
    if (labelPosition === "center") {
      textX = sectorShape.cx;
      textY = sectorShape.cy;
      textAlign = "center";
    } else {
      var x1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * nx : sectorShape.r * nx) + cx;
      var y1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * ny : sectorShape.r * ny) + cy;
      textX = x1 + nx * 3;
      textY = y1 + ny * 3;
      if (!isLabelInside) {
        var x2 = x1 + nx * (labelLineLen + r2 - sectorShape.r);
        var y2 = y1 + ny * (labelLineLen + r2 - sectorShape.r);
        var x3 = x2 + (nx < 0 ? -1 : 1) * labelLineLen2;
        var y3 = y2;
        if (labelAlignTo === "edge") {
          textX = nx < 0 ? viewLeft + edgeDistance : viewLeft + viewWidth - edgeDistance;
        } else {
          textX = x3 + (nx < 0 ? -labelDistance : labelDistance);
        }
        textY = y3;
        linePoints2 = [[x1, y1], [x2, y2], [x3, y3]];
      }
      textAlign = isLabelInside ? "center" : labelAlignTo === "edge" ? nx > 0 ? "right" : "left" : nx > 0 ? "left" : "right";
    }
    var PI3 = Math.PI;
    var labelRotate = 0;
    var rotate2 = labelModel.get("rotate");
    if (isNumber(rotate2)) {
      labelRotate = rotate2 * (PI3 / 180);
    } else if (labelPosition === "center") {
      labelRotate = 0;
    } else if (rotate2 === "radial" || rotate2 === true) {
      var radialAngle = nx < 0 ? -midAngle + PI3 : -midAngle;
      labelRotate = radialAngle;
    } else if (rotate2 === "tangential" && labelPosition !== "outside" && labelPosition !== "outer") {
      var rad = Math.atan2(nx, ny);
      if (rad < 0) {
        rad = PI3 * 2 + rad;
      }
      var isDown = ny > 0;
      if (isDown) {
        rad = PI3 + rad;
      }
      labelRotate = rad - PI3;
    }
    hasLabelRotate = !!labelRotate;
    label2.x = textX;
    label2.y = textY;
    label2.rotation = labelRotate;
    label2.setStyle({
      verticalAlign: "middle"
    });
    if (!isLabelInside) {
      var textRect = label2.getBoundingRect().clone();
      textRect.applyTransform(label2.getComputedTransform());
      var margin = (label2.style.margin || 0) + 2.1;
      textRect.y -= margin / 2;
      textRect.height += margin;
      labelLayoutList.push({
        label: label2,
        labelLine: labelLine2,
        position: labelPosition,
        len: labelLineLen,
        len2: labelLineLen2,
        minTurnAngle: labelLineModel.get("minTurnAngle"),
        maxSurfaceAngle: labelLineModel.get("maxSurfaceAngle"),
        surfaceNormal: new Point$1(nx, ny),
        linePoints: linePoints2,
        textAlign,
        labelDistance,
        labelAlignTo,
        edgeDistance,
        bleedMargin,
        rect: textRect,
        unconstrainedWidth: textRect.width,
        labelStyleWidth: label2.style.width
      });
    } else {
      label2.setStyle({
        align: textAlign
      });
      var selectState2 = label2.states.select;
      if (selectState2) {
        selectState2.x += label2.x;
        selectState2.y += label2.y;
      }
    }
    sector.setTextConfig({
      inside: isLabelInside
    });
  });
  if (!hasLabelRotate && seriesModel.get("avoidLabelOverlap")) {
    avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop);
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    var label = layout2.label;
    var labelLine = layout2.labelLine;
    var notShowLabel = isNaN(label.x) || isNaN(label.y);
    if (label) {
      label.setStyle({
        align: layout2.textAlign
      });
      if (notShowLabel) {
        each$g(label.states, setNotShow);
        label.ignore = true;
      }
      var selectState = label.states.select;
      if (selectState) {
        selectState.x += label.x;
        selectState.y += label.y;
      }
    }
    if (labelLine) {
      var linePoints = layout2.linePoints;
      if (notShowLabel || !linePoints) {
        each$g(labelLine.states, setNotShow);
        labelLine.ignore = true;
      } else {
        limitTurnAngle(linePoints, layout2.minTurnAngle);
        limitSurfaceAngle(linePoints, layout2.surfaceNormal, layout2.maxSurfaceAngle);
        labelLine.setShape({
          points: linePoints
        });
        label.__hostTarget.textGuideLineConfig = {
          anchor: new Point$1(linePoints[0][0], linePoints[0][1])
        };
      }
    }
  }
}
function getSectorCornerRadius(model, shape, zeroIfNull) {
  var cornerRadius = model.get("borderRadius");
  if (cornerRadius == null) {
    return zeroIfNull ? {
      cornerRadius: 0
    } : null;
  }
  if (!isArray$1(cornerRadius)) {
    cornerRadius = [cornerRadius, cornerRadius, cornerRadius, cornerRadius];
  }
  var dr = Math.abs(shape.r || 0 - shape.r0 || 0);
  return {
    cornerRadius: map$1(cornerRadius, function(cr) {
      return parsePercent$1(cr, dr);
    })
  };
}
var PiePiece = function(_super) {
  __extends(PiePiece2, _super);
  function PiePiece2(data, idx, startAngle) {
    var _this = _super.call(this) || this;
    _this.z2 = 2;
    var text = new ZRText$1();
    _this.setTextContent(text);
    _this.updateData(data, idx, startAngle, true);
    return _this;
  }
  PiePiece2.prototype.updateData = function(data, idx, startAngle, firstCreate) {
    var sector = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = data.getItemLayout(idx);
    var sectorShape = extend(getSectorCornerRadius(itemModel.getModel("itemStyle"), layout2, true), layout2);
    if (isNaN(sectorShape.startAngle)) {
      sector.setShape(sectorShape);
      return;
    }
    if (firstCreate) {
      sector.setShape(sectorShape);
      var animationType = seriesModel.getShallow("animationType");
      if (seriesModel.ecModel.ssr) {
        initProps(sector, {
          scaleX: 0,
          scaleY: 0
        }, seriesModel, {
          dataIndex: idx,
          isFrom: true
        });
        sector.originX = sectorShape.cx;
        sector.originY = sectorShape.cy;
      } else if (animationType === "scale") {
        sector.shape.r = layout2.r0;
        initProps(sector, {
          shape: {
            r: layout2.r
          }
        }, seriesModel, idx);
      } else {
        if (startAngle != null) {
          sector.setShape({
            startAngle,
            endAngle: startAngle
          });
          initProps(sector, {
            shape: {
              startAngle: layout2.startAngle,
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        } else {
          sector.shape.endAngle = layout2.startAngle;
          updateProps$1(sector, {
            shape: {
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        }
      }
    } else {
      saveOldStyle(sector);
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel, idx);
    }
    sector.useStyle(data.getItemVisual(idx, "style"));
    setStatesStylesFromModel(sector, itemModel);
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var offset2 = seriesModel.get("selectedOffset");
    var dx = Math.cos(midAngle) * offset2;
    var dy = Math.sin(midAngle) * offset2;
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._updateLabel(seriesModel, data, idx);
    sector.ensureState("emphasis").shape = extend({
      r: layout2.r + (emphasisModel.get("scale") ? emphasisModel.get("scaleSize") || 0 : 0)
    }, getSectorCornerRadius(emphasisModel.getModel("itemStyle"), layout2));
    extend(sector.ensureState("select"), {
      x: dx,
      y: dy,
      shape: getSectorCornerRadius(itemModel.getModel(["select", "itemStyle"]), layout2)
    });
    extend(sector.ensureState("blur"), {
      shape: getSectorCornerRadius(itemModel.getModel(["blur", "itemStyle"]), layout2)
    });
    var labelLine = sector.getTextGuideLine();
    var labelText = sector.getTextContent();
    labelLine && extend(labelLine.ensureState("select"), {
      x: dx,
      y: dy
    });
    extend(labelText.ensureState("select"), {
      x: dx,
      y: dy
    });
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  PiePiece2.prototype._updateLabel = function(seriesModel, data, idx) {
    var sector = this;
    var itemModel = data.getItemModel(idx);
    var labelLineModel = itemModel.getModel("labelLine");
    var style2 = data.getItemVisual(idx, "style");
    var visualColor = style2 && style2.fill;
    var visualOpacity = style2 && style2.opacity;
    setLabelStyle(sector, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      defaultText: seriesModel.getFormattedLabel(idx, "normal") || data.getName(idx)
    });
    var labelText = sector.getTextContent();
    sector.setTextConfig({
      position: null,
      rotation: null
    });
    labelText.attr({
      z2: 10
    });
    var labelPosition = seriesModel.get(["label", "position"]);
    if (labelPosition !== "outside" && labelPosition !== "outer") {
      sector.removeTextGuideLine();
    } else {
      var polyline = this.getTextGuideLine();
      if (!polyline) {
        polyline = new Polyline$3();
        this.setTextGuideLine(polyline);
      }
      setLabelLineStyle(this, getLabelLineStatesModels(itemModel), {
        stroke: visualColor,
        opacity: retrieve3(labelLineModel.get(["lineStyle", "opacity"]), visualOpacity, 1)
      });
    }
  };
  return PiePiece2;
}(Sector$1);
var PieView = function(_super) {
  __extends(PieView2, _super);
  function PieView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  PieView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var startAngle;
    if (!oldData && data.count() > 0) {
      var shape = data.getItemLayout(0);
      for (var s = 1; isNaN(shape && shape.startAngle) && s < data.count(); ++s) {
        shape = data.getItemLayout(s);
      }
      if (shape) {
        startAngle = shape.startAngle;
      }
    }
    if (this._emptyCircleSector) {
      group.remove(this._emptyCircleSector);
    }
    if (data.count() === 0 && seriesModel.get("showEmptyCircle")) {
      var sector = new Sector$1({
        shape: getBasicPieLayout(seriesModel, api)
      });
      sector.useStyle(seriesModel.getModel("emptyCircleStyle").getItemStyle());
      this._emptyCircleSector = sector;
      group.add(sector);
    }
    data.diff(oldData).add(function(idx) {
      var piePiece = new PiePiece(data, idx, startAngle);
      data.setItemGraphicEl(idx, piePiece);
      group.add(piePiece);
    }).update(function(newIdx, oldIdx) {
      var piePiece = oldData.getItemGraphicEl(oldIdx);
      piePiece.updateData(data, newIdx, startAngle);
      piePiece.off("click");
      group.add(piePiece);
      data.setItemGraphicEl(newIdx, piePiece);
    }).remove(function(idx) {
      var piePiece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piePiece, seriesModel, idx);
    }).execute();
    pieLabelLayout(seriesModel);
    if (seriesModel.get("animationTypeUpdate") !== "expansion") {
      this._data = data;
    }
  };
  PieView2.prototype.dispose = function() {
  };
  PieView2.prototype.containPoint = function(point, seriesModel) {
    var data = seriesModel.getData();
    var itemLayout = data.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  PieView2.type = "pie";
  return PieView2;
}(ChartView$1);
var PieView$1 = PieView;
function createSeriesDataSimply(seriesModel, opt, nameList) {
  opt = isArray$1(opt) && {
    coordDimensions: opt
  } || extend({
    encodeDefine: seriesModel.getEncode()
  }, opt);
  var source = seriesModel.getSource();
  var dimensions = prepareSeriesDataSchema(source, opt).dimensions;
  var list = new SeriesData$1(dimensions, seriesModel);
  list.initData(source, nameList);
  return list;
}
var LegendVisualProvider = function() {
  function LegendVisualProvider2(getDataWithEncodedVisual, getRawData2) {
    this._getDataWithEncodedVisual = getDataWithEncodedVisual;
    this._getRawData = getRawData2;
  }
  LegendVisualProvider2.prototype.getAllNames = function() {
    var rawData = this._getRawData();
    return rawData.mapArray(rawData.getName);
  };
  LegendVisualProvider2.prototype.containName = function(name) {
    var rawData = this._getRawData();
    return rawData.indexOfName(name) >= 0;
  };
  LegendVisualProvider2.prototype.indexOfName = function(name) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.indexOfName(name);
  };
  LegendVisualProvider2.prototype.getItemVisual = function(dataIndex, key) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.getItemVisual(dataIndex, key);
  };
  return LegendVisualProvider2;
}();
var LegendVisualProvider$1 = LegendVisualProvider;
var PieSeriesModel = function(_super) {
  __extends(PieSeriesModel2, _super);
  function PieSeriesModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PieSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  PieSeriesModel2.prototype.mergeOption = function() {
    _super.prototype.mergeOption.apply(this, arguments);
  };
  PieSeriesModel2.prototype.getInitialData = function() {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  PieSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueList = [];
    data.each(data.mapDimension("value"), function(value) {
      valueList.push(value);
    });
    params.percent = getPercentWithPrecision(valueList, dataIndex, data.hostModel.get("percentPrecision"));
    params.$vars.push("percent");
    return params;
  };
  PieSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  PieSeriesModel2.type = "series.pie";
  PieSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    minShowLabelAngle: 0,
    selectedOffset: 10,
    percentPrecision: 2,
    stillShowZeroSum: true,
    left: 0,
    top: 0,
    right: 0,
    bottom: 0,
    width: null,
    height: null,
    label: {
      rotate: 0,
      show: true,
      overflow: "truncate",
      position: "outer",
      alignTo: "none",
      edgeDistance: "25%",
      bleedMargin: 10,
      distanceToLabelLine: 5
    },
    labelLine: {
      show: true,
      length: 15,
      length2: 15,
      smooth: false,
      minTurnAngle: 90,
      maxSurfaceAngle: 90,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      borderWidth: 1,
      borderJoin: "round"
    },
    showEmptyCircle: true,
    emptyCircleStyle: {
      color: "lightgray",
      opacity: 1
    },
    labelLayout: {
      hideOverlap: true
    },
    emphasis: {
      scale: true,
      scaleSize: 5
    },
    avoidLabelOverlap: true,
    animationType: "expansion",
    animationDuration: 1e3,
    animationTypeUpdate: "transition",
    animationEasingUpdate: "cubicInOut",
    animationDurationUpdate: 500,
    animationEasing: "cubicInOut"
  };
  return PieSeriesModel2;
}(SeriesModel$1);
var PieSeriesModel$1 = PieSeriesModel;
function negativeDataFilter(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var valueDim = data.mapDimension("value");
        var curValue = data.get(valueDim, idx);
        if (isNumber(curValue) && !isNaN(curValue) && curValue < 0) {
          return false;
        }
        return true;
      });
    }
  };
}
function install$O(registers) {
  registers.registerChartView(PieView$1);
  registers.registerSeriesModel(PieSeriesModel$1);
  createLegacyDataSelectAction("pie", registers.registerAction);
  registers.registerLayout(curry$1(pieLayout, "pie"));
  registers.registerProcessor(dataFilter$1("pie"));
  registers.registerProcessor(negativeDataFilter("pie"));
}
var ScatterSeriesModel = function(_super) {
  __extends(ScatterSeriesModel2, _super);
  function ScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  ScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  ScatterSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 5e3 : this.get("progressive");
    }
    return progressive;
  };
  ScatterSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 1e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  ScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  ScatterSeriesModel2.prototype.getZLevelKey = function() {
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
  };
  ScatterSeriesModel2.type = "series.scatter";
  ScatterSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  ScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    symbolSize: 10,
    large: false,
    largeThreshold: 2e3,
    itemStyle: {
      opacity: 0.8
    },
    emphasis: {
      scale: true
    },
    clip: true,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    universalTransition: {
      divideShape: "clone"
    }
  };
  return ScatterSeriesModel2;
}(SeriesModel$1);
var ScatterSeriesModel$1 = ScatterSeriesModel;
var BOOST_SIZE_THRESHOLD = 4;
var LargeSymbolPathShape = function() {
  function LargeSymbolPathShape2() {
  }
  return LargeSymbolPathShape2;
}();
var LargeSymbolPath = function(_super) {
  __extends(LargeSymbolPath2, _super);
  function LargeSymbolPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeSymbolPath2.prototype.getDefaultShape = function() {
    return new LargeSymbolPathShape();
  };
  LargeSymbolPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeSymbolPath2.prototype.buildPath = function(path, shape) {
    var points2 = shape.points;
    var size = shape.size;
    var symbolProxy = this.symbolProxy;
    var symbolProxyShape = symbolProxy.shape;
    var ctx = path.getContext ? path.getContext() : path;
    var canBoost = ctx && size[0] < BOOST_SIZE_THRESHOLD;
    var softClipShape = this.softClipShape;
    var i;
    if (canBoost) {
      this._ctx = ctx;
      return;
    }
    this._ctx = null;
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      symbolProxyShape.x = x2 - size[0] / 2;
      symbolProxyShape.y = y2 - size[1] / 2;
      symbolProxyShape.width = size[0];
      symbolProxyShape.height = size[1];
      symbolProxy.buildPath(path, symbolProxyShape, true);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.afterBrush = function() {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var ctx = this._ctx;
    var softClipShape = this.softClipShape;
    var i;
    if (!ctx) {
      return;
    }
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      ctx.fillRect(x2 - size[0] / 2, y2 - size[1] / 2, size[0], size[1]);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var w2 = Math.max(size[0], 4);
    var h = Math.max(size[1], 4);
    for (var idx = points2.length / 2 - 1; idx >= 0; idx--) {
      var i = idx * 2;
      var x0 = points2[i] - w2 / 2;
      var y0 = points2[i + 1] - h / 2;
      if (x2 >= x0 && y2 >= y0 && x2 <= x0 + w2 && y2 <= y0 + h) {
        return idx;
      }
    }
    return -1;
  };
  LargeSymbolPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeSymbolPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.points;
      var size = shape.size;
      var w2 = size[0];
      var h = size[1];
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX - w2 / 2, minY - h / 2, maxX - minX + w2, maxY - minY + h);
    }
    return rect;
  };
  return LargeSymbolPath2;
}(Path$1);
var LargeSymbolDraw = function() {
  function LargeSymbolDraw2() {
    this.group = new Group$6();
  }
  LargeSymbolDraw2.prototype.updateData = function(data, opt) {
    this._clear();
    var symbolEl = this._create();
    symbolEl.setShape({
      points: data.getLayout("points")
    });
    this._setCommon(symbolEl, data, opt);
  };
  LargeSymbolDraw2.prototype.updateLayout = function(data) {
    var points2 = data.getLayout("points");
    this.group.eachChild(function(child) {
      if (child.startIndex != null) {
        var len2 = (child.endIndex - child.startIndex) * 2;
        var byteOffset = child.startIndex * 4 * 2;
        points2 = new Float32Array(points2.buffer, byteOffset, len2);
      }
      child.setShape("points", points2);
      child.reset();
    });
  };
  LargeSymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._clear();
  };
  LargeSymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    var lastAdded = this._newAdded[0];
    var points2 = data.getLayout("points");
    var oldPoints = lastAdded && lastAdded.shape.points;
    if (oldPoints && oldPoints.length < 2e4) {
      var oldLen = oldPoints.length;
      var newPoints = new Float32Array(oldLen + points2.length);
      newPoints.set(oldPoints);
      newPoints.set(points2, oldLen);
      lastAdded.endIndex = taskParams.end;
      lastAdded.setShape({
        points: newPoints
      });
    } else {
      this._newAdded = [];
      var symbolEl = this._create();
      symbolEl.startIndex = taskParams.start;
      symbolEl.endIndex = taskParams.end;
      symbolEl.incremental = true;
      symbolEl.setShape({
        points: points2
      });
      this._setCommon(symbolEl, data, opt);
    }
  };
  LargeSymbolDraw2.prototype.eachRendered = function(cb2) {
    this._newAdded[0] && cb2(this._newAdded[0]);
  };
  LargeSymbolDraw2.prototype._create = function() {
    var symbolEl = new LargeSymbolPath({
      cursor: "default"
    });
    this.group.add(symbolEl);
    this._newAdded.push(symbolEl);
    return symbolEl;
  };
  LargeSymbolDraw2.prototype._setCommon = function(symbolEl, data, opt) {
    var hostModel = data.hostModel;
    opt = opt || {};
    var size = data.getVisual("symbolSize");
    symbolEl.setShape("size", size instanceof Array ? size : [size, size]);
    symbolEl.softClipShape = opt.clipShape || null;
    symbolEl.symbolProxy = createSymbol$1(data.getVisual("symbol"), 0, 0, 0, 0);
    symbolEl.setColor = symbolEl.symbolProxy.setColor;
    var extrudeShadow = symbolEl.shape.size[0] < BOOST_SIZE_THRESHOLD;
    symbolEl.useStyle(hostModel.getModel("itemStyle").getItemStyle(extrudeShadow ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
    var globalStyle = data.getVisual("style");
    var visualColor = globalStyle && globalStyle.fill;
    if (visualColor) {
      symbolEl.setColor(visualColor);
    }
    var ecData = getECData(symbolEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    symbolEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = symbolEl.hoverDataIdx;
      if (dataIndex >= 0) {
        ecData.dataIndex = dataIndex + (symbolEl.startIndex || 0);
      }
    });
  };
  LargeSymbolDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeSymbolDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeSymbolDraw2;
}();
var LargeSymbolDraw$1 = LargeSymbolDraw;
var ScatterView = function(_super) {
  __extends(ScatterView2, _super);
  function ScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterView2.type;
    return _this;
  }
  ScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = true;
  };
  ScatterView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.incrementalPrepareUpdate(data);
    this._finished = false;
  };
  ScatterView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._symbolDraw.incrementalUpdate(taskParams, seriesModel.getData(), {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  ScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    if (!this._finished || data.count() > 1e4) {
      return {
        update: true
      };
    } else {
      var res = pointsLayout("").reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._symbolDraw.updateLayout(data);
    }
  };
  ScatterView2.prototype.eachRendered = function(cb2) {
    this._symbolDraw && this._symbolDraw.eachRendered(cb2);
  };
  ScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  ScatterView2.prototype._updateSymbolDraw = function(data, seriesModel) {
    var symbolDraw = this._symbolDraw;
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!symbolDraw || isLargeDraw !== this._isLargeDraw) {
      symbolDraw && symbolDraw.remove();
      symbolDraw = this._symbolDraw = isLargeDraw ? new LargeSymbolDraw$1() : new SymbolDraw$1();
      this._isLargeDraw = isLargeDraw;
      this.group.removeAll();
    }
    this.group.add(symbolDraw.group);
    return symbolDraw;
  };
  ScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
    this._symbolDraw = null;
  };
  ScatterView2.prototype.dispose = function() {
  };
  ScatterView2.type = "scatter";
  return ScatterView2;
}(ChartView$1);
var ScatterView$1 = ScatterView;
var GridModel = function(_super) {
  __extends(GridModel2, _super);
  function GridModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GridModel2.type = "grid";
  GridModel2.dependencies = ["xAxis", "yAxis"];
  GridModel2.layoutMode = "box";
  GridModel2.defaultOption = {
    show: false,
    z: 0,
    left: "10%",
    top: 60,
    right: "10%",
    bottom: 70,
    containLabel: false,
    backgroundColor: "rgba(0,0,0,0)",
    borderWidth: 1,
    borderColor: "#ccc"
  };
  return GridModel2;
}(ComponentModel$1);
var GridModel$1 = GridModel;
var CartesianAxisModel = function(_super) {
  __extends(CartesianAxisModel2, _super);
  function CartesianAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("grid", SINGLE_REFERRING).models[0];
  };
  CartesianAxisModel2.type = "cartesian2dAxis";
  return CartesianAxisModel2;
}(ComponentModel$1);
mixin(CartesianAxisModel, AxisModelCommonMixin);
var defaultOption$1 = {
  show: true,
  z: 0,
  inverse: false,
  name: "",
  nameLocation: "end",
  nameRotate: null,
  nameTruncate: {
    maxWidth: null,
    ellipsis: "...",
    placeholder: "."
  },
  nameTextStyle: {},
  nameGap: 15,
  silent: false,
  triggerEvent: false,
  tooltip: {
    show: false
  },
  axisPointer: {},
  axisLine: {
    show: true,
    onZero: true,
    onZeroAxisIndex: null,
    lineStyle: {
      color: "#6E7079",
      width: 1,
      type: "solid"
    },
    symbol: ["none", "none"],
    symbolSize: [10, 15]
  },
  axisTick: {
    show: true,
    inside: false,
    length: 5,
    lineStyle: {
      width: 1
    }
  },
  axisLabel: {
    show: true,
    inside: false,
    rotate: 0,
    showMinLabel: null,
    showMaxLabel: null,
    margin: 8,
    fontSize: 12
  },
  splitLine: {
    show: true,
    lineStyle: {
      color: ["#E0E6F1"],
      width: 1,
      type: "solid"
    }
  },
  splitArea: {
    show: false,
    areaStyle: {
      color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"]
    }
  }
};
var categoryAxis = merge({
  boundaryGap: true,
  deduplication: null,
  splitLine: {
    show: false
  },
  axisTick: {
    alignWithLabel: false,
    interval: "auto"
  },
  axisLabel: {
    interval: "auto"
  }
}, defaultOption$1);
var valueAxis = merge({
  boundaryGap: [0, 0],
  axisLine: {
    show: "auto"
  },
  axisTick: {
    show: "auto"
  },
  splitNumber: 5,
  minorTick: {
    show: false,
    splitNumber: 5,
    length: 3,
    lineStyle: {}
  },
  minorSplitLine: {
    show: false,
    lineStyle: {
      color: "#F4F7FD",
      width: 1
    }
  }
}, defaultOption$1);
var timeAxis = merge({
  splitNumber: 6,
  axisLabel: {
    showMinLabel: false,
    showMaxLabel: false,
    rich: {
      primary: {
        fontWeight: "bold"
      }
    }
  },
  splitLine: {
    show: false
  }
}, valueAxis);
var logAxis = defaults({
  logBase: 10
}, valueAxis);
var axisDefault = {
  category: categoryAxis,
  value: valueAxis,
  time: timeAxis,
  log: logAxis
};
var AXIS_TYPES = {
  value: 1,
  category: 1,
  time: 1,
  log: 1
};
function axisModelCreator(registers, axisName, BaseAxisModelClass, extraDefaultOption) {
  each$g(AXIS_TYPES, function(v4, axisType) {
    var defaultOption2 = merge(merge({}, axisDefault[axisType], true), extraDefaultOption, true);
    var AxisModel = function(_super) {
      __extends(AxisModel2, _super);
      function AxisModel2() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.type = axisName + "Axis." + axisType;
        return _this;
      }
      AxisModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
        var layoutMode = fetchLayoutMode(this);
        var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
        var themeModel = ecModel.getTheme();
        merge(option, themeModel.get(axisType + "Axis"));
        merge(option, this.getDefaultOption());
        option.type = getAxisType(option);
        if (layoutMode) {
          mergeLayoutParam(option, inputPositionParams, layoutMode);
        }
      };
      AxisModel2.prototype.optionUpdated = function() {
        var thisOption = this.option;
        if (thisOption.type === "category") {
          this.__ordinalMeta = OrdinalMeta$1.createByAxisModel(this);
        }
      };
      AxisModel2.prototype.getCategories = function(rawData) {
        var option = this.option;
        if (option.type === "category") {
          if (rawData) {
            return option.data;
          }
          return this.__ordinalMeta.categories;
        }
      };
      AxisModel2.prototype.getOrdinalMeta = function() {
        return this.__ordinalMeta;
      };
      AxisModel2.type = axisName + "Axis." + axisType;
      AxisModel2.defaultOption = defaultOption2;
      return AxisModel2;
    }(BaseAxisModelClass);
    registers.registerComponentModel(AxisModel);
  });
  registers.registerSubTypeDefaulter(axisName + "Axis", getAxisType);
}
function getAxisType(option) {
  return option.type || (option.data ? "category" : "value");
}
var Cartesian = function() {
  function Cartesian2(name) {
    this.type = "cartesian";
    this._dimList = [];
    this._axes = {};
    this.name = name || "";
  }
  Cartesian2.prototype.getAxis = function(dim) {
    return this._axes[dim];
  };
  Cartesian2.prototype.getAxes = function() {
    return map$1(this._dimList, function(dim) {
      return this._axes[dim];
    }, this);
  };
  Cartesian2.prototype.getAxesByScale = function(scaleType) {
    scaleType = scaleType.toLowerCase();
    return filter(this.getAxes(), function(axis) {
      return axis.scale.type === scaleType;
    });
  };
  Cartesian2.prototype.addAxis = function(axis) {
    var dim = axis.dim;
    this._axes[dim] = axis;
    this._dimList.push(dim);
  };
  return Cartesian2;
}();
var Cartesian$1 = Cartesian;
var cartesian2DDimensions = ["x", "y"];
function canCalculateAffineTransform(scale2) {
  return scale2.type === "interval" || scale2.type === "time";
}
var Cartesian2D = function(_super) {
  __extends(Cartesian2D2, _super);
  function Cartesian2D2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "cartesian2d";
    _this.dimensions = cartesian2DDimensions;
    return _this;
  }
  Cartesian2D2.prototype.calcAffineTransform = function() {
    this._transform = this._invTransform = null;
    var xAxisScale = this.getAxis("x").scale;
    var yAxisScale = this.getAxis("y").scale;
    if (!canCalculateAffineTransform(xAxisScale) || !canCalculateAffineTransform(yAxisScale)) {
      return;
    }
    var xScaleExtent = xAxisScale.getExtent();
    var yScaleExtent = yAxisScale.getExtent();
    var start2 = this.dataToPoint([xScaleExtent[0], yScaleExtent[0]]);
    var end2 = this.dataToPoint([xScaleExtent[1], yScaleExtent[1]]);
    var xScaleSpan = xScaleExtent[1] - xScaleExtent[0];
    var yScaleSpan = yScaleExtent[1] - yScaleExtent[0];
    if (!xScaleSpan || !yScaleSpan) {
      return;
    }
    var scaleX = (end2[0] - start2[0]) / xScaleSpan;
    var scaleY = (end2[1] - start2[1]) / yScaleSpan;
    var translateX = start2[0] - xScaleExtent[0] * scaleX;
    var translateY = start2[1] - yScaleExtent[0] * scaleY;
    var m2 = this._transform = [scaleX, 0, 0, scaleY, translateX, translateY];
    this._invTransform = invert([], m2);
  };
  Cartesian2D2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
  };
  Cartesian2D2.prototype.containPoint = function(point) {
    var axisX = this.getAxis("x");
    var axisY = this.getAxis("y");
    return axisX.contain(axisX.toLocalCoord(point[0])) && axisY.contain(axisY.toLocalCoord(point[1]));
  };
  Cartesian2D2.prototype.containData = function(data) {
    return this.getAxis("x").containData(data[0]) && this.getAxis("y").containData(data[1]);
  };
  Cartesian2D2.prototype.dataToPoint = function(data, clamp2, out2) {
    out2 = out2 || [];
    var xVal = data[0];
    var yVal = data[1];
    if (this._transform && xVal != null && isFinite(xVal) && yVal != null && isFinite(yVal)) {
      return applyTransform$1(out2, data, this._transform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.toGlobalCoord(xAxis.dataToCoord(xVal, clamp2));
    out2[1] = yAxis.toGlobalCoord(yAxis.dataToCoord(yVal, clamp2));
    return out2;
  };
  Cartesian2D2.prototype.clampData = function(data, out2) {
    var xScale = this.getAxis("x").scale;
    var yScale = this.getAxis("y").scale;
    var xAxisExtent = xScale.getExtent();
    var yAxisExtent = yScale.getExtent();
    var x2 = xScale.parse(data[0]);
    var y2 = yScale.parse(data[1]);
    out2 = out2 || [];
    out2[0] = Math.min(Math.max(Math.min(xAxisExtent[0], xAxisExtent[1]), x2), Math.max(xAxisExtent[0], xAxisExtent[1]));
    out2[1] = Math.min(Math.max(Math.min(yAxisExtent[0], yAxisExtent[1]), y2), Math.max(yAxisExtent[0], yAxisExtent[1]));
    return out2;
  };
  Cartesian2D2.prototype.pointToData = function(point, clamp2) {
    var out2 = [];
    if (this._invTransform) {
      return applyTransform$1(out2, point, this._invTransform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.coordToData(xAxis.toLocalCoord(point[0]), clamp2);
    out2[1] = yAxis.coordToData(yAxis.toLocalCoord(point[1]), clamp2);
    return out2;
  };
  Cartesian2D2.prototype.getOtherAxis = function(axis) {
    return this.getAxis(axis.dim === "x" ? "y" : "x");
  };
  Cartesian2D2.prototype.getArea = function() {
    var xExtent = this.getAxis("x").getGlobalExtent();
    var yExtent = this.getAxis("y").getGlobalExtent();
    var x2 = Math.min(xExtent[0], xExtent[1]);
    var y2 = Math.min(yExtent[0], yExtent[1]);
    var width = Math.max(xExtent[0], xExtent[1]) - x2;
    var height = Math.max(yExtent[0], yExtent[1]) - y2;
    return new BoundingRect$1(x2, y2, width, height);
  };
  return Cartesian2D2;
}(Cartesian$1);
var Cartesian2D$1 = Cartesian2D;
var Axis2D = function(_super) {
  __extends(Axis2D2, _super);
  function Axis2D2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.index = 0;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  Axis2D2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  Axis2D2.prototype.getGlobalExtent = function(asc2) {
    var ret = this.getExtent();
    ret[0] = this.toGlobalCoord(ret[0]);
    ret[1] = this.toGlobalCoord(ret[1]);
    asc2 && ret[0] > ret[1] && ret.reverse();
    return ret;
  };
  Axis2D2.prototype.pointToData = function(point, clamp2) {
    return this.coordToData(this.toLocalCoord(point[this.dim === "x" ? 0 : 1]), clamp2);
  };
  Axis2D2.prototype.setCategorySortInfo = function(info) {
    if (this.type !== "category") {
      return false;
    }
    this.model.option.categorySortInfo = info;
    this.scale.setSortInfo(info);
  };
  return Axis2D2;
}(Axis$1);
var Axis2D$1 = Axis2D;
function layout$2(gridModel, axisModel, opt) {
  opt = opt || {};
  var grid = gridModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var otherAxisOnZeroOf = axis.getAxesOnZeroOf()[0];
  var rawAxisPosition = axis.position;
  var axisPosition = otherAxisOnZeroOf ? "onZero" : rawAxisPosition;
  var axisDim = axis.dim;
  var rect = grid.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var idx = {
    left: 0,
    right: 1,
    top: 0,
    bottom: 1,
    onZero: 2
  };
  var axisOffset = axisModel.get("offset") || 0;
  var posBound = axisDim === "x" ? [rectBound[2] - axisOffset, rectBound[3] + axisOffset] : [rectBound[0] - axisOffset, rectBound[1] + axisOffset];
  if (otherAxisOnZeroOf) {
    var onZeroCoord = otherAxisOnZeroOf.toGlobalCoord(otherAxisOnZeroOf.dataToCoord(0));
    posBound[idx.onZero] = Math.max(Math.min(onZeroCoord, posBound[1]), posBound[0]);
  }
  layout2.position = [axisDim === "y" ? posBound[idx[axisPosition]] : rectBound[0], axisDim === "x" ? posBound[idx[axisPosition]] : rectBound[3]];
  layout2.rotation = Math.PI / 2 * (axisDim === "x" ? 0 : 1);
  var dirMap = {
    top: -1,
    bottom: 1,
    left: -1,
    right: 1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = dirMap[rawAxisPosition];
  layout2.labelOffset = otherAxisOnZeroOf ? posBound[idx[rawAxisPosition]] - posBound[idx.onZero] : 0;
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotate = axisModel.get(["axisLabel", "rotate"]);
  layout2.labelRotate = axisPosition === "top" ? -labelRotate : labelRotate;
  layout2.z2 = 1;
  return layout2;
}
function isCartesian2DSeries(seriesModel) {
  return seriesModel.get("coordinateSystem") === "cartesian2d";
}
function findAxisModels(seriesModel) {
  var axisModelMap = {
    xAxisModel: null,
    yAxisModel: null
  };
  each$g(axisModelMap, function(v4, key) {
    var axisType = key.replace(/Model$/, "");
    var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
    axisModelMap[key] = axisModel;
  });
  return axisModelMap;
}
var mathLog = Math.log;
function alignScaleTicks(scale2, axisModel, alignToScale) {
  var intervalScaleProto2 = IntervalScale$1.prototype;
  var alignToTicks = intervalScaleProto2.getTicks.call(alignToScale);
  var alignToNicedTicks = intervalScaleProto2.getTicks.call(alignToScale, true);
  var alignToSplitNumber = alignToTicks.length - 1;
  var alignToInterval = intervalScaleProto2.getInterval.call(alignToScale);
  var scaleExtent = getScaleExtent(scale2, axisModel);
  var rawExtent = scaleExtent.extent;
  var isMinFixed = scaleExtent.fixMin;
  var isMaxFixed = scaleExtent.fixMax;
  if (scale2.type === "log") {
    var logBase = mathLog(scale2.base);
    rawExtent = [mathLog(rawExtent[0]) / logBase, mathLog(rawExtent[1]) / logBase];
  }
  scale2.setExtent(rawExtent[0], rawExtent[1]);
  scale2.calcNiceExtent({
    splitNumber: alignToSplitNumber,
    fixMin: isMinFixed,
    fixMax: isMaxFixed
  });
  var extent3 = intervalScaleProto2.getExtent.call(scale2);
  if (isMinFixed) {
    rawExtent[0] = extent3[0];
  }
  if (isMaxFixed) {
    rawExtent[1] = extent3[1];
  }
  var interval = intervalScaleProto2.getInterval.call(scale2);
  var min3 = rawExtent[0];
  var max3 = rawExtent[1];
  if (isMinFixed && isMaxFixed) {
    interval = (max3 - min3) / alignToSplitNumber;
  } else if (isMinFixed) {
    max3 = rawExtent[0] + interval * alignToSplitNumber;
    while (max3 < rawExtent[1] && isFinite(max3) && isFinite(rawExtent[1])) {
      interval = increaseInterval(interval);
      max3 = rawExtent[0] + interval * alignToSplitNumber;
    }
  } else if (isMaxFixed) {
    min3 = rawExtent[1] - interval * alignToSplitNumber;
    while (min3 > rawExtent[0] && isFinite(min3) && isFinite(rawExtent[0])) {
      interval = increaseInterval(interval);
      min3 = rawExtent[1] - interval * alignToSplitNumber;
    }
  } else {
    var nicedSplitNumber = scale2.getTicks().length - 1;
    if (nicedSplitNumber > alignToSplitNumber) {
      interval = increaseInterval(interval);
    }
    var range3 = interval * alignToSplitNumber;
    max3 = Math.ceil(rawExtent[1] / interval) * interval;
    min3 = round$3(max3 - range3);
    if (min3 < 0 && rawExtent[0] >= 0) {
      min3 = 0;
      max3 = round$3(range3);
    } else if (max3 > 0 && rawExtent[1] <= 0) {
      max3 = 0;
      min3 = -round$3(range3);
    }
  }
  var t0 = (alignToTicks[0].value - alignToNicedTicks[0].value) / alignToInterval;
  var t1 = (alignToTicks[alignToSplitNumber].value - alignToNicedTicks[alignToSplitNumber].value) / alignToInterval;
  intervalScaleProto2.setExtent.call(scale2, min3 + interval * t0, max3 + interval * t1);
  intervalScaleProto2.setInterval.call(scale2, interval);
  if (t0 || t1) {
    intervalScaleProto2.setNiceExtent.call(scale2, min3 + interval, max3 - interval);
  }
}
var Grid = function() {
  function Grid2(gridModel, ecModel, api) {
    this.type = "grid";
    this._coordsMap = {};
    this._coordsList = [];
    this._axesMap = {};
    this._axesList = [];
    this.axisPointerEnabled = true;
    this.dimensions = cartesian2DDimensions;
    this._initCartesian(gridModel, ecModel, api);
    this.model = gridModel;
  }
  Grid2.prototype.getRect = function() {
    return this._rect;
  };
  Grid2.prototype.update = function(ecModel, api) {
    var axesMap = this._axesMap;
    this._updateScale(ecModel, this.model);
    function updateAxisTicks(axes) {
      var alignTo;
      var axesIndices = keys(axes);
      var len2 = axesIndices.length;
      if (!len2) {
        return;
      }
      var axisNeedsAlign = [];
      for (var i = len2 - 1; i >= 0; i--) {
        var idx = +axesIndices[i];
        var axis = axes[idx];
        var model = axis.model;
        var scale2 = axis.scale;
        if (isIntervalOrLogScale(scale2) && model.get("alignTicks") && model.get("interval") == null) {
          axisNeedsAlign.push(axis);
        } else {
          niceScaleExtent(scale2, model);
          if (isIntervalOrLogScale(scale2)) {
            alignTo = axis;
          }
        }
      }
      if (axisNeedsAlign.length) {
        if (!alignTo) {
          alignTo = axisNeedsAlign.pop();
          niceScaleExtent(alignTo.scale, alignTo.model);
        }
        each$g(axisNeedsAlign, function(axis2) {
          alignScaleTicks(axis2.scale, axis2.model, alignTo.scale);
        });
      }
    }
    updateAxisTicks(axesMap.x);
    updateAxisTicks(axesMap.y);
    var onZeroRecords = {};
    each$g(axesMap.x, function(xAxis) {
      fixAxisOnZero(axesMap, "y", xAxis, onZeroRecords);
    });
    each$g(axesMap.y, function(yAxis) {
      fixAxisOnZero(axesMap, "x", yAxis, onZeroRecords);
    });
    this.resize(this.model, api);
  };
  Grid2.prototype.resize = function(gridModel, api, ignoreContainLabel) {
    var boxLayoutParams = gridModel.getBoxLayoutParams();
    var isContainLabel = !ignoreContainLabel && gridModel.get("containLabel");
    var gridRect = getLayoutRect(boxLayoutParams, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._rect = gridRect;
    var axesList = this._axesList;
    adjustAxes();
    if (isContainLabel) {
      each$g(axesList, function(axis) {
        if (!axis.model.get(["axisLabel", "inside"])) {
          var labelUnionRect = estimateLabelUnionRect(axis);
          if (labelUnionRect) {
            var dim = axis.isHorizontal() ? "height" : "width";
            var margin = axis.model.get(["axisLabel", "margin"]);
            gridRect[dim] -= labelUnionRect[dim] + margin;
            if (axis.position === "top") {
              gridRect.y += labelUnionRect.height + margin;
            } else if (axis.position === "left") {
              gridRect.x += labelUnionRect.width + margin;
            }
          }
        }
      });
      adjustAxes();
    }
    each$g(this._coordsList, function(coord) {
      coord.calcAffineTransform();
    });
    function adjustAxes() {
      each$g(axesList, function(axis) {
        var isHorizontal = axis.isHorizontal();
        var extent3 = isHorizontal ? [0, gridRect.width] : [0, gridRect.height];
        var idx = axis.inverse ? 1 : 0;
        axis.setExtent(extent3[idx], extent3[1 - idx]);
        updateAxisTransform(axis, isHorizontal ? gridRect.x : gridRect.y);
      });
    }
  };
  Grid2.prototype.getAxis = function(dim, axisIndex) {
    var axesMapOnDim = this._axesMap[dim];
    if (axesMapOnDim != null) {
      return axesMapOnDim[axisIndex || 0];
    }
  };
  Grid2.prototype.getAxes = function() {
    return this._axesList.slice();
  };
  Grid2.prototype.getCartesian = function(xAxisIndex, yAxisIndex) {
    if (xAxisIndex != null && yAxisIndex != null) {
      var key = "x" + xAxisIndex + "y" + yAxisIndex;
      return this._coordsMap[key];
    }
    if (isObject$4(xAxisIndex)) {
      yAxisIndex = xAxisIndex.yAxisIndex;
      xAxisIndex = xAxisIndex.xAxisIndex;
    }
    for (var i = 0, coordList = this._coordsList; i < coordList.length; i++) {
      if (coordList[i].getAxis("x").index === xAxisIndex || coordList[i].getAxis("y").index === yAxisIndex) {
        return coordList[i];
      }
    }
  };
  Grid2.prototype.getCartesians = function() {
    return this._coordsList.slice();
  };
  Grid2.prototype.convertToPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.dataToPoint(value) : target.axis ? target.axis.toGlobalCoord(target.axis.dataToCoord(value)) : null;
  };
  Grid2.prototype.convertFromPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.pointToData(value) : target.axis ? target.axis.coordToData(target.axis.toLocalCoord(value)) : null;
  };
  Grid2.prototype._findConvertTarget = function(finder) {
    var seriesModel = finder.seriesModel;
    var xAxisModel = finder.xAxisModel || seriesModel && seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = finder.yAxisModel || seriesModel && seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    var gridModel = finder.gridModel;
    var coordsList = this._coordsList;
    var cartesian;
    var axis;
    if (seriesModel) {
      cartesian = seriesModel.coordinateSystem;
      indexOf(coordsList, cartesian) < 0 && (cartesian = null);
    } else if (xAxisModel && yAxisModel) {
      cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    } else if (xAxisModel) {
      axis = this.getAxis("x", xAxisModel.componentIndex);
    } else if (yAxisModel) {
      axis = this.getAxis("y", yAxisModel.componentIndex);
    } else if (gridModel) {
      var grid = gridModel.coordinateSystem;
      if (grid === this) {
        cartesian = this._coordsList[0];
      }
    }
    return {
      cartesian,
      axis
    };
  };
  Grid2.prototype.containPoint = function(point) {
    var coord = this._coordsList[0];
    if (coord) {
      return coord.containPoint(point);
    }
  };
  Grid2.prototype._initCartesian = function(gridModel, ecModel, api) {
    var _this = this;
    var grid = this;
    var axisPositionUsed = {
      left: false,
      right: false,
      top: false,
      bottom: false
    };
    var axesMap = {
      x: {},
      y: {}
    };
    var axesCount = {
      x: 0,
      y: 0
    };
    ecModel.eachComponent("xAxis", createAxisCreator("x"), this);
    ecModel.eachComponent("yAxis", createAxisCreator("y"), this);
    if (!axesCount.x || !axesCount.y) {
      this._axesMap = {};
      this._axesList = [];
      return;
    }
    this._axesMap = axesMap;
    each$g(axesMap.x, function(xAxis, xAxisIndex) {
      each$g(axesMap.y, function(yAxis, yAxisIndex) {
        var key = "x" + xAxisIndex + "y" + yAxisIndex;
        var cartesian = new Cartesian2D$1(key);
        cartesian.master = _this;
        cartesian.model = gridModel;
        _this._coordsMap[key] = cartesian;
        _this._coordsList.push(cartesian);
        cartesian.addAxis(xAxis);
        cartesian.addAxis(yAxis);
      });
    });
    function createAxisCreator(dimName) {
      return function(axisModel, idx) {
        if (!isAxisUsedInTheGrid(axisModel, gridModel)) {
          return;
        }
        var axisPosition = axisModel.get("position");
        if (dimName === "x") {
          if (axisPosition !== "top" && axisPosition !== "bottom") {
            axisPosition = axisPositionUsed.bottom ? "top" : "bottom";
          }
        } else {
          if (axisPosition !== "left" && axisPosition !== "right") {
            axisPosition = axisPositionUsed.left ? "right" : "left";
          }
        }
        axisPositionUsed[axisPosition] = true;
        var axis = new Axis2D$1(dimName, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisPosition);
        var isCategory2 = axis.type === "category";
        axis.onBand = isCategory2 && axisModel.get("boundaryGap");
        axis.inverse = axisModel.get("inverse");
        axisModel.axis = axis;
        axis.model = axisModel;
        axis.grid = grid;
        axis.index = idx;
        grid._axesList.push(axis);
        axesMap[dimName][idx] = axis;
        axesCount[dimName]++;
      };
    }
  };
  Grid2.prototype._updateScale = function(ecModel, gridModel) {
    each$g(this._axesList, function(axis) {
      axis.scale.setExtent(Infinity, -Infinity);
      if (axis.type === "category") {
        var categorySortInfo = axis.model.get("categorySortInfo");
        axis.scale.setSortInfo(categorySortInfo);
      }
    });
    ecModel.eachSeries(function(seriesModel) {
      if (isCartesian2DSeries(seriesModel)) {
        var axesModelMap = findAxisModels(seriesModel);
        var xAxisModel = axesModelMap.xAxisModel;
        var yAxisModel = axesModelMap.yAxisModel;
        if (!isAxisUsedInTheGrid(xAxisModel, gridModel) || !isAxisUsedInTheGrid(yAxisModel, gridModel)) {
          return;
        }
        var cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
        var data = seriesModel.getData();
        var xAxis = cartesian.getAxis("x");
        var yAxis = cartesian.getAxis("y");
        unionExtent(data, xAxis);
        unionExtent(data, yAxis);
      }
    }, this);
    function unionExtent(data, axis) {
      each$g(getDataDimensionsOnAxis(data, axis.dim), function(dim) {
        axis.scale.unionExtentFromData(data, dim);
      });
    }
  };
  Grid2.prototype.getTooltipAxes = function(dim) {
    var baseAxes = [];
    var otherAxes = [];
    each$g(this.getCartesians(), function(cartesian) {
      var baseAxis = dim != null && dim !== "auto" ? cartesian.getAxis(dim) : cartesian.getBaseAxis();
      var otherAxis = cartesian.getOtherAxis(baseAxis);
      indexOf(baseAxes, baseAxis) < 0 && baseAxes.push(baseAxis);
      indexOf(otherAxes, otherAxis) < 0 && otherAxes.push(otherAxis);
    });
    return {
      baseAxes,
      otherAxes
    };
  };
  Grid2.create = function(ecModel, api) {
    var grids = [];
    ecModel.eachComponent("grid", function(gridModel, idx) {
      var grid = new Grid2(gridModel, ecModel, api);
      grid.name = "grid_" + idx;
      grid.resize(gridModel, api, true);
      gridModel.coordinateSystem = grid;
      grids.push(grid);
    });
    ecModel.eachSeries(function(seriesModel) {
      if (!isCartesian2DSeries(seriesModel)) {
        return;
      }
      var axesModelMap = findAxisModels(seriesModel);
      var xAxisModel = axesModelMap.xAxisModel;
      var yAxisModel = axesModelMap.yAxisModel;
      var gridModel = xAxisModel.getCoordSysModel();
      var grid = gridModel.coordinateSystem;
      seriesModel.coordinateSystem = grid.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    });
    return grids;
  };
  Grid2.dimensions = cartesian2DDimensions;
  return Grid2;
}();
function isAxisUsedInTheGrid(axisModel, gridModel) {
  return axisModel.getCoordSysModel() === gridModel;
}
function fixAxisOnZero(axesMap, otherAxisDim, axis, onZeroRecords) {
  axis.getAxesOnZeroOf = function() {
    return otherAxisOnZeroOf ? [otherAxisOnZeroOf] : [];
  };
  var otherAxes = axesMap[otherAxisDim];
  var otherAxisOnZeroOf;
  var axisModel = axis.model;
  var onZero = axisModel.get(["axisLine", "onZero"]);
  var onZeroAxisIndex = axisModel.get(["axisLine", "onZeroAxisIndex"]);
  if (!onZero) {
    return;
  }
  if (onZeroAxisIndex != null) {
    if (canOnZeroToAxis(otherAxes[onZeroAxisIndex])) {
      otherAxisOnZeroOf = otherAxes[onZeroAxisIndex];
    }
  } else {
    for (var idx in otherAxes) {
      if (otherAxes.hasOwnProperty(idx) && canOnZeroToAxis(otherAxes[idx]) && !onZeroRecords[getOnZeroRecordKey(otherAxes[idx])]) {
        otherAxisOnZeroOf = otherAxes[idx];
        break;
      }
    }
  }
  if (otherAxisOnZeroOf) {
    onZeroRecords[getOnZeroRecordKey(otherAxisOnZeroOf)] = true;
  }
  function getOnZeroRecordKey(axis2) {
    return axis2.dim + "_" + axis2.index;
  }
}
function canOnZeroToAxis(axis) {
  return axis && axis.type !== "category" && axis.type !== "time" && ifAxisCrossZero(axis);
}
function updateAxisTransform(axis, coordBase) {
  var axisExtent = axis.getExtent();
  var axisExtentSum = axisExtent[0] + axisExtent[1];
  axis.toGlobalCoord = axis.dim === "x" ? function(coord) {
    return coord + coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
  axis.toLocalCoord = axis.dim === "x" ? function(coord) {
    return coord - coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
}
var Grid$1 = Grid;
var PI$3 = Math.PI;
var AxisBuilder = function() {
  function AxisBuilder2(axisModel, opt) {
    this.group = new Group$6();
    this.opt = opt;
    this.axisModel = axisModel;
    defaults(opt, {
      labelOffset: 0,
      nameDirection: 1,
      tickDirection: 1,
      labelDirection: 1,
      silent: true,
      handleAutoShown: function() {
        return true;
      }
    });
    var transformGroup = new Group$6({
      x: opt.position[0],
      y: opt.position[1],
      rotation: opt.rotation
    });
    transformGroup.updateTransform();
    this._transformGroup = transformGroup;
  }
  AxisBuilder2.prototype.hasBuilder = function(name) {
    return !!builders[name];
  };
  AxisBuilder2.prototype.add = function(name) {
    builders[name](this.opt, this.axisModel, this.group, this._transformGroup);
  };
  AxisBuilder2.prototype.getGroup = function() {
    return this.group;
  };
  AxisBuilder2.innerTextLayout = function(axisRotation, textRotation, direction) {
    var rotationDiff = remRadian(textRotation - axisRotation);
    var textAlign;
    var textVerticalAlign;
    if (isRadianAroundZero(rotationDiff)) {
      textVerticalAlign = direction > 0 ? "top" : "bottom";
      textAlign = "center";
    } else if (isRadianAroundZero(rotationDiff - PI$3)) {
      textVerticalAlign = direction > 0 ? "bottom" : "top";
      textAlign = "center";
    } else {
      textVerticalAlign = "middle";
      if (rotationDiff > 0 && rotationDiff < PI$3) {
        textAlign = direction > 0 ? "right" : "left";
      } else {
        textAlign = direction > 0 ? "left" : "right";
      }
    }
    return {
      rotation: rotationDiff,
      textAlign,
      textVerticalAlign
    };
  };
  AxisBuilder2.makeAxisEventDataBase = function(axisModel) {
    var eventData = {
      componentType: axisModel.mainType,
      componentIndex: axisModel.componentIndex
    };
    eventData[axisModel.mainType + "Index"] = axisModel.componentIndex;
    return eventData;
  };
  AxisBuilder2.isLabelSilent = function(axisModel) {
    var tooltipOpt = axisModel.get("tooltip");
    return axisModel.get("silent") || !(axisModel.get("triggerEvent") || tooltipOpt && tooltipOpt.show);
  };
  return AxisBuilder2;
}();
var builders = {
  axisLine: function(opt, axisModel, group, transformGroup) {
    var shown = axisModel.get(["axisLine", "show"]);
    if (shown === "auto" && opt.handleAutoShown) {
      shown = opt.handleAutoShown("axisLine");
    }
    if (!shown) {
      return;
    }
    var extent3 = axisModel.axis.getExtent();
    var matrix = transformGroup.transform;
    var pt12 = [extent3[0], 0];
    var pt22 = [extent3[1], 0];
    if (matrix) {
      applyTransform$1(pt12, pt12, matrix);
      applyTransform$1(pt22, pt22, matrix);
    }
    var lineStyle = extend({
      lineCap: "round"
    }, axisModel.getModel(["axisLine", "lineStyle"]).getLineStyle());
    var line = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: lineStyle,
      strokeContainThreshold: opt.strokeContainThreshold || 5,
      silent: true,
      z2: 1
    });
    line.anid = "line";
    group.add(line);
    var arrows = axisModel.get(["axisLine", "symbol"]);
    if (arrows != null) {
      var arrowSize = axisModel.get(["axisLine", "symbolSize"]);
      if (isString$1(arrows)) {
        arrows = [arrows, arrows];
      }
      if (isString$1(arrowSize) || isNumber(arrowSize)) {
        arrowSize = [arrowSize, arrowSize];
      }
      var arrowOffset = normalizeSymbolOffset(axisModel.get(["axisLine", "symbolOffset"]) || 0, arrowSize);
      var symbolWidth_1 = arrowSize[0];
      var symbolHeight_1 = arrowSize[1];
      each$g([{
        rotate: opt.rotation + Math.PI / 2,
        offset: arrowOffset[0],
        r: 0
      }, {
        rotate: opt.rotation - Math.PI / 2,
        offset: arrowOffset[1],
        r: Math.sqrt((pt12[0] - pt22[0]) * (pt12[0] - pt22[0]) + (pt12[1] - pt22[1]) * (pt12[1] - pt22[1]))
      }], function(point, index2) {
        if (arrows[index2] !== "none" && arrows[index2] != null) {
          var symbol = createSymbol$1(arrows[index2], -symbolWidth_1 / 2, -symbolHeight_1 / 2, symbolWidth_1, symbolHeight_1, lineStyle.stroke, true);
          var r2 = point.r + point.offset;
          symbol.attr({
            rotation: point.rotate,
            x: pt12[0] + r2 * Math.cos(opt.rotation),
            y: pt12[1] - r2 * Math.sin(opt.rotation),
            silent: true,
            z2: 11
          });
          group.add(symbol);
        }
      });
    }
  },
  axisTickLabel: function(opt, axisModel, group, transformGroup) {
    var ticksEls = buildAxisMajorTicks(group, transformGroup, axisModel, opt);
    var labelEls = buildAxisLabel(group, transformGroup, axisModel, opt);
    fixMinMaxLabelShow(axisModel, labelEls, ticksEls);
    buildAxisMinorTicks(group, transformGroup, axisModel, opt.tickDirection);
    if (axisModel.get(["axisLabel", "hideOverlap"])) {
      var labelList = prepareLayoutList(map$1(labelEls, function(label) {
        return {
          label,
          priority: label.z2,
          defaultAttr: {
            ignore: label.ignore
          }
        };
      }));
      hideOverlap(labelList);
    }
  },
  axisName: function(opt, axisModel, group, transformGroup) {
    var name = retrieve(opt.axisName, axisModel.get("name"));
    if (!name) {
      return;
    }
    var nameLocation = axisModel.get("nameLocation");
    var nameDirection = opt.nameDirection;
    var textStyleModel = axisModel.getModel("nameTextStyle");
    var gap = axisModel.get("nameGap") || 0;
    var extent3 = axisModel.axis.getExtent();
    var gapSignal = extent3[0] > extent3[1] ? -1 : 1;
    var pos = [
      nameLocation === "start" ? extent3[0] - gapSignal * gap : nameLocation === "end" ? extent3[1] + gapSignal * gap : (extent3[0] + extent3[1]) / 2,
      isNameLocationCenter(nameLocation) ? opt.labelOffset + nameDirection * gap : 0
    ];
    var labelLayout2;
    var nameRotation = axisModel.get("nameRotate");
    if (nameRotation != null) {
      nameRotation = nameRotation * PI$3 / 180;
    }
    var axisNameAvailableWidth;
    if (isNameLocationCenter(nameLocation)) {
      labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, nameRotation != null ? nameRotation : opt.rotation, nameDirection);
    } else {
      labelLayout2 = endTextLayout(opt.rotation, nameLocation, nameRotation || 0, extent3);
      axisNameAvailableWidth = opt.axisNameAvailableWidth;
      if (axisNameAvailableWidth != null) {
        axisNameAvailableWidth = Math.abs(axisNameAvailableWidth / Math.sin(labelLayout2.rotation));
        !isFinite(axisNameAvailableWidth) && (axisNameAvailableWidth = null);
      }
    }
    var textFont = textStyleModel.getFont();
    var truncateOpt = axisModel.get("nameTruncate", true) || {};
    var ellipsis = truncateOpt.ellipsis;
    var maxWidth = retrieve(opt.nameTruncateMaxWidth, truncateOpt.maxWidth, axisNameAvailableWidth);
    var textEl = new ZRText$1({
      x: pos[0],
      y: pos[1],
      rotation: labelLayout2.rotation,
      silent: AxisBuilder.isLabelSilent(axisModel),
      style: createTextStyle(textStyleModel, {
        text: name,
        font: textFont,
        overflow: "truncate",
        width: maxWidth,
        ellipsis,
        fill: textStyleModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]),
        align: textStyleModel.get("align") || labelLayout2.textAlign,
        verticalAlign: textStyleModel.get("verticalAlign") || labelLayout2.textVerticalAlign
      }),
      z2: 1
    });
    setTooltipConfig({
      el: textEl,
      componentModel: axisModel,
      itemName: name
    });
    textEl.__fullText = name;
    textEl.anid = "name";
    if (axisModel.get("triggerEvent")) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisName";
      eventData.name = name;
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    group.add(textEl);
    textEl.decomposeTransform();
  }
};
function endTextLayout(rotation, textPosition, textRotate, extent3) {
  var rotationDiff = remRadian(textRotate - rotation);
  var textAlign;
  var textVerticalAlign;
  var inverse = extent3[0] > extent3[1];
  var onLeft = textPosition === "start" && !inverse || textPosition !== "start" && inverse;
  if (isRadianAroundZero(rotationDiff - PI$3 / 2)) {
    textVerticalAlign = onLeft ? "bottom" : "top";
    textAlign = "center";
  } else if (isRadianAroundZero(rotationDiff - PI$3 * 1.5)) {
    textVerticalAlign = onLeft ? "top" : "bottom";
    textAlign = "center";
  } else {
    textVerticalAlign = "middle";
    if (rotationDiff < PI$3 * 1.5 && rotationDiff > PI$3 / 2) {
      textAlign = onLeft ? "left" : "right";
    } else {
      textAlign = onLeft ? "right" : "left";
    }
  }
  return {
    rotation: rotationDiff,
    textAlign,
    textVerticalAlign
  };
}
function fixMinMaxLabelShow(axisModel, labelEls, tickEls) {
  if (shouldShowAllLabels(axisModel.axis)) {
    return;
  }
  var showMinLabel = axisModel.get(["axisLabel", "showMinLabel"]);
  var showMaxLabel = axisModel.get(["axisLabel", "showMaxLabel"]);
  labelEls = labelEls || [];
  tickEls = tickEls || [];
  var firstLabel = labelEls[0];
  var nextLabel = labelEls[1];
  var lastLabel = labelEls[labelEls.length - 1];
  var prevLabel = labelEls[labelEls.length - 2];
  var firstTick = tickEls[0];
  var nextTick = tickEls[1];
  var lastTick = tickEls[tickEls.length - 1];
  var prevTick = tickEls[tickEls.length - 2];
  if (showMinLabel === false) {
    ignoreEl(firstLabel);
    ignoreEl(firstTick);
  } else if (isTwoLabelOverlapped(firstLabel, nextLabel)) {
    if (showMinLabel) {
      ignoreEl(nextLabel);
      ignoreEl(nextTick);
    } else {
      ignoreEl(firstLabel);
      ignoreEl(firstTick);
    }
  }
  if (showMaxLabel === false) {
    ignoreEl(lastLabel);
    ignoreEl(lastTick);
  } else if (isTwoLabelOverlapped(prevLabel, lastLabel)) {
    if (showMaxLabel) {
      ignoreEl(prevLabel);
      ignoreEl(prevTick);
    } else {
      ignoreEl(lastLabel);
      ignoreEl(lastTick);
    }
  }
}
function ignoreEl(el) {
  el && (el.ignore = true);
}
function isTwoLabelOverlapped(current, next) {
  var firstRect = current && current.getBoundingRect().clone();
  var nextRect = next && next.getBoundingRect().clone();
  if (!firstRect || !nextRect) {
    return;
  }
  var mRotationBack = identity([]);
  rotate(mRotationBack, mRotationBack, -current.rotation);
  firstRect.applyTransform(mul([], mRotationBack, current.getLocalTransform()));
  nextRect.applyTransform(mul([], mRotationBack, next.getLocalTransform()));
  return firstRect.intersect(nextRect);
}
function isNameLocationCenter(nameLocation) {
  return nameLocation === "middle" || nameLocation === "center";
}
function createTicks(ticksCoords, tickTransform, tickEndCoord, tickLineStyle, anidPrefix) {
  var tickEls = [];
  var pt12 = [];
  var pt22 = [];
  for (var i = 0; i < ticksCoords.length; i++) {
    var tickCoord = ticksCoords[i].coord;
    pt12[0] = tickCoord;
    pt12[1] = 0;
    pt22[0] = tickCoord;
    pt22[1] = tickEndCoord;
    if (tickTransform) {
      applyTransform$1(pt12, pt12, tickTransform);
      applyTransform$1(pt22, pt22, tickTransform);
    }
    var tickEl = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: tickLineStyle,
      z2: 2,
      autoBatch: true,
      silent: true
    });
    tickEl.anid = anidPrefix + "_" + ticksCoords[i].tickValue;
    tickEls.push(tickEl);
  }
  return tickEls;
}
function buildAxisMajorTicks(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var tickModel = axisModel.getModel("axisTick");
  var shown = tickModel.get("show");
  if (shown === "auto" && opt.handleAutoShown) {
    shown = opt.handleAutoShown("axisTick");
  }
  if (!shown || axis.scale.isBlank()) {
    return;
  }
  var lineStyleModel = tickModel.getModel("lineStyle");
  var tickEndCoord = opt.tickDirection * tickModel.get("length");
  var ticksCoords = axis.getTicksCoords();
  var ticksEls = createTicks(ticksCoords, transformGroup.transform, tickEndCoord, defaults(lineStyleModel.getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }), "ticks");
  for (var i = 0; i < ticksEls.length; i++) {
    group.add(ticksEls[i]);
  }
  return ticksEls;
}
function buildAxisMinorTicks(group, transformGroup, axisModel, tickDirection) {
  var axis = axisModel.axis;
  var minorTickModel = axisModel.getModel("minorTick");
  if (!minorTickModel.get("show") || axis.scale.isBlank()) {
    return;
  }
  var minorTicksCoords = axis.getMinorTicksCoords();
  if (!minorTicksCoords.length) {
    return;
  }
  var lineStyleModel = minorTickModel.getModel("lineStyle");
  var tickEndCoord = tickDirection * minorTickModel.get("length");
  var minorTickLineStyle = defaults(lineStyleModel.getLineStyle(), defaults(axisModel.getModel("axisTick").getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }));
  for (var i = 0; i < minorTicksCoords.length; i++) {
    var minorTicksEls = createTicks(minorTicksCoords[i], transformGroup.transform, tickEndCoord, minorTickLineStyle, "minorticks_" + i);
    for (var k2 = 0; k2 < minorTicksEls.length; k2++) {
      group.add(minorTicksEls[k2]);
    }
  }
}
function buildAxisLabel(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var show = retrieve(opt.axisLabelShow, axisModel.get(["axisLabel", "show"]));
  if (!show || axis.scale.isBlank()) {
    return;
  }
  var labelModel = axisModel.getModel("axisLabel");
  var labelMargin = labelModel.get("margin");
  var labels = axis.getViewLabels();
  var labelRotation = (retrieve(opt.labelRotate, labelModel.get("rotate")) || 0) * PI$3 / 180;
  var labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, labelRotation, opt.labelDirection);
  var rawCategoryData = axisModel.getCategories && axisModel.getCategories(true);
  var labelEls = [];
  var silent = AxisBuilder.isLabelSilent(axisModel);
  var triggerEvent = axisModel.get("triggerEvent");
  each$g(labels, function(labelItem, index2) {
    var tickValue = axis.scale.type === "ordinal" ? axis.scale.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
    var formattedLabel = labelItem.formattedLabel;
    var rawLabel = labelItem.rawLabel;
    var itemLabelModel = labelModel;
    if (rawCategoryData && rawCategoryData[tickValue]) {
      var rawCategoryItem = rawCategoryData[tickValue];
      if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
        itemLabelModel = new Model$1(rawCategoryItem.textStyle, labelModel, axisModel.ecModel);
      }
    }
    var textColor = itemLabelModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]);
    var tickCoord = axis.dataToCoord(tickValue);
    var textEl = new ZRText$1({
      x: tickCoord,
      y: opt.labelOffset + opt.labelDirection * labelMargin,
      rotation: labelLayout2.rotation,
      silent,
      z2: 10 + (labelItem.level || 0),
      style: createTextStyle(itemLabelModel, {
        text: formattedLabel,
        align: itemLabelModel.getShallow("align", true) || labelLayout2.textAlign,
        verticalAlign: itemLabelModel.getShallow("verticalAlign", true) || itemLabelModel.getShallow("baseline", true) || labelLayout2.textVerticalAlign,
        fill: isFunction(textColor) ? textColor(axis.type === "category" ? rawLabel : axis.type === "value" ? tickValue + "" : tickValue, index2) : textColor
      })
    });
    textEl.anid = "label_" + tickValue;
    if (triggerEvent) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisLabel";
      eventData.value = rawLabel;
      eventData.tickIndex = index2;
      if (axis.type === "category") {
        eventData.dataIndex = tickValue;
      }
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    labelEls.push(textEl);
    group.add(textEl);
    textEl.decomposeTransform();
  });
  return labelEls;
}
var AxisBuilder$1 = AxisBuilder;
function collect(ecModel, api) {
  var result = {
    axesInfo: {},
    seriesInvolved: false,
    coordSysAxesInfo: {},
    coordSysMap: {}
  };
  collectAxesInfo(result, ecModel, api);
  result.seriesInvolved && collectSeriesInfo(result, ecModel);
  return result;
}
function collectAxesInfo(result, ecModel, api) {
  var globalTooltipModel = ecModel.getComponent("tooltip");
  var globalAxisPointerModel = ecModel.getComponent("axisPointer");
  var linksOption = globalAxisPointerModel.get("link", true) || [];
  var linkGroups = [];
  each$g(api.getCoordinateSystems(), function(coordSys) {
    if (!coordSys.axisPointerEnabled) {
      return;
    }
    var coordSysKey = makeKey(coordSys.model);
    var axesInfoInCoordSys = result.coordSysAxesInfo[coordSysKey] = {};
    result.coordSysMap[coordSysKey] = coordSys;
    var coordSysModel = coordSys.model;
    var baseTooltipModel = coordSysModel.getModel("tooltip", globalTooltipModel);
    each$g(coordSys.getAxes(), curry$1(saveTooltipAxisInfo, false, null));
    if (coordSys.getTooltipAxes && globalTooltipModel && baseTooltipModel.get("show")) {
      var triggerAxis = baseTooltipModel.get("trigger") === "axis";
      var cross = baseTooltipModel.get(["axisPointer", "type"]) === "cross";
      var tooltipAxes = coordSys.getTooltipAxes(baseTooltipModel.get(["axisPointer", "axis"]));
      if (triggerAxis || cross) {
        each$g(tooltipAxes.baseAxes, curry$1(saveTooltipAxisInfo, cross ? "cross" : true, triggerAxis));
      }
      if (cross) {
        each$g(tooltipAxes.otherAxes, curry$1(saveTooltipAxisInfo, "cross", false));
      }
    }
    function saveTooltipAxisInfo(fromTooltip, triggerTooltip, axis) {
      var axisPointerModel = axis.model.getModel("axisPointer", globalAxisPointerModel);
      var axisPointerShow = axisPointerModel.get("show");
      if (!axisPointerShow || axisPointerShow === "auto" && !fromTooltip && !isHandleTrigger(axisPointerModel)) {
        return;
      }
      if (triggerTooltip == null) {
        triggerTooltip = axisPointerModel.get("triggerTooltip");
      }
      axisPointerModel = fromTooltip ? makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) : axisPointerModel;
      var snap = axisPointerModel.get("snap");
      var axisKey = makeKey(axis.model);
      var involveSeries = triggerTooltip || snap || axis.type === "category";
      var axisInfo = result.axesInfo[axisKey] = {
        key: axisKey,
        axis,
        coordSys,
        axisPointerModel,
        triggerTooltip,
        involveSeries,
        snap,
        useHandle: isHandleTrigger(axisPointerModel),
        seriesModels: [],
        linkGroup: null
      };
      axesInfoInCoordSys[axisKey] = axisInfo;
      result.seriesInvolved = result.seriesInvolved || involveSeries;
      var groupIndex = getLinkGroupIndex(linksOption, axis);
      if (groupIndex != null) {
        var linkGroup = linkGroups[groupIndex] || (linkGroups[groupIndex] = {
          axesInfo: {}
        });
        linkGroup.axesInfo[axisKey] = axisInfo;
        linkGroup.mapper = linksOption[groupIndex].mapper;
        axisInfo.linkGroup = linkGroup;
      }
    }
  });
}
function makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) {
  var tooltipAxisPointerModel = baseTooltipModel.getModel("axisPointer");
  var fields = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"];
  var volatileOption = {};
  each$g(fields, function(field) {
    volatileOption[field] = clone$4(tooltipAxisPointerModel.get(field));
  });
  volatileOption.snap = axis.type !== "category" && !!triggerTooltip;
  if (tooltipAxisPointerModel.get("type") === "cross") {
    volatileOption.type = "line";
  }
  var labelOption = volatileOption.label || (volatileOption.label = {});
  labelOption.show == null && (labelOption.show = false);
  if (fromTooltip === "cross") {
    var tooltipAxisPointerLabelShow = tooltipAxisPointerModel.get(["label", "show"]);
    labelOption.show = tooltipAxisPointerLabelShow != null ? tooltipAxisPointerLabelShow : true;
    if (!triggerTooltip) {
      var crossStyle = volatileOption.lineStyle = tooltipAxisPointerModel.get("crossStyle");
      crossStyle && defaults(labelOption, crossStyle.textStyle);
    }
  }
  return axis.model.getModel("axisPointer", new Model$1(volatileOption, globalAxisPointerModel, ecModel));
}
function collectSeriesInfo(result, ecModel) {
  ecModel.eachSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesTooltipTrigger = seriesModel.get(["tooltip", "trigger"], true);
    var seriesTooltipShow = seriesModel.get(["tooltip", "show"], true);
    if (!coordSys || seriesTooltipTrigger === "none" || seriesTooltipTrigger === false || seriesTooltipTrigger === "item" || seriesTooltipShow === false || seriesModel.get(["axisPointer", "show"], true) === false) {
      return;
    }
    each$g(result.coordSysAxesInfo[makeKey(coordSys.model)], function(axisInfo) {
      var axis = axisInfo.axis;
      if (coordSys.getAxis(axis.dim) === axis) {
        axisInfo.seriesModels.push(seriesModel);
        axisInfo.seriesDataCount == null && (axisInfo.seriesDataCount = 0);
        axisInfo.seriesDataCount += seriesModel.getData().count();
      }
    });
  });
}
function getLinkGroupIndex(linksOption, axis) {
  var axisModel = axis.model;
  var dim = axis.dim;
  for (var i = 0; i < linksOption.length; i++) {
    var linkOption = linksOption[i] || {};
    if (checkPropInLink(linkOption[dim + "AxisId"], axisModel.id) || checkPropInLink(linkOption[dim + "AxisIndex"], axisModel.componentIndex) || checkPropInLink(linkOption[dim + "AxisName"], axisModel.name)) {
      return i;
    }
  }
}
function checkPropInLink(linkPropValue, axisPropValue) {
  return linkPropValue === "all" || isArray$1(linkPropValue) && indexOf(linkPropValue, axisPropValue) >= 0 || linkPropValue === axisPropValue;
}
function fixValue(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  if (!axisInfo) {
    return;
  }
  var axisPointerModel = axisInfo.axisPointerModel;
  var scale2 = axisInfo.axis.scale;
  var option = axisPointerModel.option;
  var status = axisPointerModel.get("status");
  var value = axisPointerModel.get("value");
  if (value != null) {
    value = scale2.parse(value);
  }
  var useHandle = isHandleTrigger(axisPointerModel);
  if (status == null) {
    option.status = useHandle ? "show" : "hide";
  }
  var extent3 = scale2.getExtent().slice();
  extent3[0] > extent3[1] && extent3.reverse();
  if (value == null || value > extent3[1]) {
    value = extent3[1];
  }
  if (value < extent3[0]) {
    value = extent3[0];
  }
  option.value = value;
  if (useHandle) {
    option.status = axisInfo.axis.scale.isBlank() ? "hide" : "show";
  }
}
function getAxisInfo$1(axisModel) {
  var coordSysAxesInfo = (axisModel.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
  return coordSysAxesInfo && coordSysAxesInfo.axesInfo[makeKey(axisModel)];
}
function getAxisPointerModel(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  return axisInfo && axisInfo.axisPointerModel;
}
function isHandleTrigger(axisPointerModel) {
  return !!axisPointerModel.get(["handle", "show"]);
}
function makeKey(model) {
  return model.type + "||" + model.id;
}
var axisPointerClazz = {};
var AxisView = function(_super) {
  __extends(AxisView2, _super);
  function AxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisView2.type;
    return _this;
  }
  AxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.axisPointerClass && fixValue(axisModel);
    _super.prototype.render.apply(this, arguments);
    this._doUpdateAxisPointerClass(axisModel, api, true);
  };
  AxisView2.prototype.updateAxisPointer = function(axisModel, ecModel, api, payload) {
    this._doUpdateAxisPointerClass(axisModel, api, false);
  };
  AxisView2.prototype.remove = function(ecModel, api) {
    var axisPointer = this._axisPointer;
    axisPointer && axisPointer.remove(api);
  };
  AxisView2.prototype.dispose = function(ecModel, api) {
    this._disposeAxisPointer(api);
    _super.prototype.dispose.apply(this, arguments);
  };
  AxisView2.prototype._doUpdateAxisPointerClass = function(axisModel, api, forceRender) {
    var Clazz = AxisView2.getAxisPointerClass(this.axisPointerClass);
    if (!Clazz) {
      return;
    }
    var axisPointerModel = getAxisPointerModel(axisModel);
    axisPointerModel ? (this._axisPointer || (this._axisPointer = new Clazz())).render(axisModel, axisPointerModel, api, forceRender) : this._disposeAxisPointer(api);
  };
  AxisView2.prototype._disposeAxisPointer = function(api) {
    this._axisPointer && this._axisPointer.dispose(api);
    this._axisPointer = null;
  };
  AxisView2.registerAxisPointerClass = function(type4, clazz) {
    axisPointerClazz[type4] = clazz;
  };
  AxisView2.getAxisPointerClass = function(type4) {
    return type4 && axisPointerClazz[type4];
  };
  AxisView2.type = "axis";
  return AxisView2;
}(ComponentView$1);
var AxisView$1 = AxisView;
var inner$f = makeInner();
function rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel) {
  var axis = axisModel.axis;
  if (axis.scale.isBlank()) {
    return;
  }
  var splitAreaModel = axisModel.getModel("splitArea");
  var areaStyleModel = splitAreaModel.getModel("areaStyle");
  var areaColors = areaStyleModel.get("color");
  var gridRect = gridModel.coordinateSystem.getRect();
  var ticksCoords = axis.getTicksCoords({
    tickModel: splitAreaModel,
    clamp: true
  });
  if (!ticksCoords.length) {
    return;
  }
  var areaColorsLen = areaColors.length;
  var lastSplitAreaColors = inner$f(axisView).splitAreaColors;
  var newSplitAreaColors = createHashMap();
  var colorIndex = 0;
  if (lastSplitAreaColors) {
    for (var i = 0; i < ticksCoords.length; i++) {
      var cIndex = lastSplitAreaColors.get(ticksCoords[i].tickValue);
      if (cIndex != null) {
        colorIndex = (cIndex + (areaColorsLen - 1) * i) % areaColorsLen;
        break;
      }
    }
  }
  var prev = axis.toGlobalCoord(ticksCoords[0].coord);
  var areaStyle = areaStyleModel.getAreaStyle();
  areaColors = isArray$1(areaColors) ? areaColors : [areaColors];
  for (var i = 1; i < ticksCoords.length; i++) {
    var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
    var x2 = void 0;
    var y2 = void 0;
    var width = void 0;
    var height = void 0;
    if (axis.isHorizontal()) {
      x2 = prev;
      y2 = gridRect.y;
      width = tickCoord - x2;
      height = gridRect.height;
      prev = x2 + width;
    } else {
      x2 = gridRect.x;
      y2 = prev;
      width = gridRect.width;
      height = tickCoord - y2;
      prev = y2 + height;
    }
    var tickValue = ticksCoords[i - 1].tickValue;
    tickValue != null && newSplitAreaColors.set(tickValue, colorIndex);
    axisGroup.add(new Rect$3({
      anid: tickValue != null ? "area_" + tickValue : null,
      shape: {
        x: x2,
        y: y2,
        width,
        height
      },
      style: defaults({
        fill: areaColors[colorIndex]
      }, areaStyle),
      autoBatch: true,
      silent: true
    }));
    colorIndex = (colorIndex + 1) % areaColorsLen;
  }
  inner$f(axisView).splitAreaColors = newSplitAreaColors;
}
function rectCoordAxisHandleRemove(axisView) {
  inner$f(axisView).splitAreaColors = null;
}
var axisBuilderAttrs$3 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$2 = ["splitArea", "splitLine", "minorSplitLine"];
var CartesianAxisView = function(_super) {
  __extends(CartesianAxisView2, _super);
  function CartesianAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianAxisView2.type;
    _this.axisPointerClass = "CartesianAxisPointer";
    return _this;
  }
  CartesianAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$6();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var gridModel = axisModel.getCoordSysModel();
    var layout2 = layout$2(gridModel, axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, extend({
      handleAutoShown: function(elementType) {
        var cartesians = gridModel.coordinateSystem.getCartesians();
        for (var i = 0; i < cartesians.length; i++) {
          if (isIntervalOrLogScale(cartesians[i].getOtherAxis(axisModel.axis).scale)) {
            return true;
          }
        }
        return false;
      }
    }, layout2));
    each$g(axisBuilderAttrs$3, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    each$g(selfBuilderAttrs$2, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders$2[name](this, this._axisGroup, axisModel, gridModel);
      }
    }, this);
    var isInitialSortFromBarRacing = payload && payload.type === "changeAxisOrder" && payload.isInitSort;
    if (!isInitialSortFromBarRacing) {
      groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    }
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  CartesianAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  CartesianAxisView2.type = "cartesianAxis";
  return CartesianAxisView2;
}(AxisView$1);
var axisElementBuilders$2 = {
  splitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = isArray$1(lineColors) ? lineColors : [lineColors];
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < ticksCoords.length; i++) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      var tickValue = ticksCoords[i].tickValue;
      axisGroup.add(new Line$3({
        anid: tickValue != null ? "line_" + ticksCoords[i].tickValue : null,
        subPixelOptimize: true,
        autoBatch: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        style: defaults({
          stroke: lineColors[colorIndex]
        }, lineStyle),
        silent: true
      }));
    }
  },
  minorSplitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    var minorSplitLineModel = axisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var minorTicksCoords = axis.getMinorTicksCoords();
    if (!minorTicksCoords.length) {
      return;
    }
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        var tickCoord = axis.toGlobalCoord(minorTicksCoords[i][k2].coord);
        if (isHorizontal) {
          p1[0] = tickCoord;
          p1[1] = gridRect.y;
          p2[0] = tickCoord;
          p2[1] = gridRect.y + gridRect.height;
        } else {
          p1[0] = gridRect.x;
          p1[1] = tickCoord;
          p2[0] = gridRect.x + gridRect.width;
          p2[1] = tickCoord;
        }
        axisGroup.add(new Line$3({
          anid: "minor_line_" + minorTicksCoords[i][k2].tickValue,
          subPixelOptimize: true,
          autoBatch: true,
          shape: {
            x1: p1[0],
            y1: p1[1],
            x2: p2[0],
            y2: p2[1]
          },
          style: lineStyle,
          silent: true
        }));
      }
    }
  },
  splitArea: function(axisView, axisGroup, axisModel, gridModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel);
  }
};
var CartesianXAxisView = function(_super) {
  __extends(CartesianXAxisView2, _super);
  function CartesianXAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView2.type;
    return _this;
  }
  CartesianXAxisView2.type = "xAxis";
  return CartesianXAxisView2;
}(CartesianAxisView);
var CartesianYAxisView = function(_super) {
  __extends(CartesianYAxisView2, _super);
  function CartesianYAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView.type;
    return _this;
  }
  CartesianYAxisView2.type = "yAxis";
  return CartesianYAxisView2;
}(CartesianAxisView);
var GridView = function(_super) {
  __extends(GridView2, _super);
  function GridView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "grid";
    return _this;
  }
  GridView2.prototype.render = function(gridModel, ecModel) {
    this.group.removeAll();
    if (gridModel.get("show")) {
      this.group.add(new Rect$3({
        shape: gridModel.coordinateSystem.getRect(),
        style: defaults({
          fill: gridModel.get("backgroundColor")
        }, gridModel.getItemStyle()),
        silent: true,
        z2: -1
      }));
    }
  };
  GridView2.type = "grid";
  return GridView2;
}(ComponentView$1);
var extraOption = {
  offset: 0
};
function install$N(registers) {
  registers.registerComponentView(GridView);
  registers.registerComponentModel(GridModel$1);
  registers.registerCoordinateSystem("cartesian2d", Grid$1);
  axisModelCreator(registers, "x", CartesianAxisModel, extraOption);
  axisModelCreator(registers, "y", CartesianAxisModel, extraOption);
  registers.registerComponentView(CartesianXAxisView);
  registers.registerComponentView(CartesianYAxisView);
  registers.registerPreprocessor(function(option) {
    if (option.xAxis && option.yAxis && !option.grid) {
      option.grid = {};
    }
  });
}
function install$M(registers) {
  use(install$N);
  registers.registerSeriesModel(ScatterSeriesModel$1);
  registers.registerChartView(ScatterView$1);
  registers.registerLayout(pointsLayout("scatter"));
}
function radarLayout(ecModel) {
  ecModel.eachSeriesByType("radar", function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var axes = coordSys.getIndicatorAxes();
    each$g(axes, function(axis, axisIndex) {
      data.each(data.mapDimension(axes[axisIndex].dim), function(val, dataIndex) {
        points2[dataIndex] = points2[dataIndex] || [];
        var point = coordSys.dataToPoint(val, axisIndex);
        points2[dataIndex][axisIndex] = isValidPoint(point) ? point : getValueMissingPoint(coordSys);
      });
    });
    data.each(function(idx) {
      var firstPoint = find(points2[idx], function(point) {
        return isValidPoint(point);
      }) || getValueMissingPoint(coordSys);
      points2[idx].push(firstPoint.slice());
      data.setItemLayout(idx, points2[idx]);
    });
  });
}
function isValidPoint(point) {
  return !isNaN(point[0]) && !isNaN(point[1]);
}
function getValueMissingPoint(coordSys) {
  return [coordSys.cx, coordSys.cy];
}
function radarBackwardCompat(option) {
  var polarOptArr = option.polar;
  if (polarOptArr) {
    if (!isArray$1(polarOptArr)) {
      polarOptArr = [polarOptArr];
    }
    var polarNotRadar_1 = [];
    each$g(polarOptArr, function(polarOpt, idx) {
      if (polarOpt.indicator) {
        if (polarOpt.type && !polarOpt.shape) {
          polarOpt.shape = polarOpt.type;
        }
        option.radar = option.radar || [];
        if (!isArray$1(option.radar)) {
          option.radar = [option.radar];
        }
        option.radar.push(polarOpt);
      } else {
        polarNotRadar_1.push(polarOpt);
      }
    });
    option.polar = polarNotRadar_1;
  }
  each$g(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "radar" && seriesOpt.polarIndex) {
      seriesOpt.radarIndex = seriesOpt.polarIndex;
    }
  });
}
var RadarView$2 = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(seriesModel, ecModel, api) {
    var polar = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    function createSymbol2(data2, idx) {
      var symbolType = data2.getItemVisual(idx, "symbol") || "circle";
      if (symbolType === "none") {
        return;
      }
      var symbolSize = normalizeSymbolSize(data2.getItemVisual(idx, "symbolSize"));
      var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2);
      var symbolRotate = data2.getItemVisual(idx, "symbolRotate") || 0;
      symbolPath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 100,
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2,
        rotation: symbolRotate * Math.PI / 180 || 0
      });
      return symbolPath;
    }
    function updateSymbols(oldPoints, newPoints, symbolGroup, data2, idx, isInit) {
      symbolGroup.removeAll();
      for (var i = 0; i < newPoints.length - 1; i++) {
        var symbolPath = createSymbol2(data2, idx);
        if (symbolPath) {
          symbolPath.__dimIdx = i;
          if (oldPoints[i]) {
            symbolPath.setPosition(oldPoints[i]);
            graphic[isInit ? "initProps" : "updateProps"](symbolPath, {
              x: newPoints[i][0],
              y: newPoints[i][1]
            }, seriesModel, idx);
          } else {
            symbolPath.setPosition(newPoints[i]);
          }
          symbolGroup.add(symbolPath);
        }
      }
    }
    function getInitialPoints(points2) {
      return map$1(points2, function(pt) {
        return [polar.cx, polar.cy];
      });
    }
    data.diff(oldData).add(function(idx) {
      var points2 = data.getItemLayout(idx);
      if (!points2) {
        return;
      }
      var polygon = new Polygon$1();
      var polyline = new Polyline$3();
      var target = {
        shape: {
          points: points2
        }
      };
      polygon.shape.points = getInitialPoints(points2);
      polyline.shape.points = getInitialPoints(points2);
      initProps(polygon, target, seriesModel, idx);
      initProps(polyline, target, seriesModel, idx);
      var itemGroup = new Group$6();
      var symbolGroup = new Group$6();
      itemGroup.add(polyline);
      itemGroup.add(polygon);
      itemGroup.add(symbolGroup);
      updateSymbols(polyline.shape.points, points2, symbolGroup, data, idx, true);
      data.setItemGraphicEl(idx, itemGroup);
    }).update(function(newIdx, oldIdx) {
      var itemGroup = oldData.getItemGraphicEl(oldIdx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var target = {
        shape: {
          points: data.getItemLayout(newIdx)
        }
      };
      if (!target.shape.points) {
        return;
      }
      updateSymbols(polyline.shape.points, target.shape.points, symbolGroup, data, newIdx, false);
      saveOldStyle(polygon);
      saveOldStyle(polyline);
      updateProps$1(polyline, target, seriesModel);
      updateProps$1(polygon, target, seriesModel);
      data.setItemGraphicEl(newIdx, itemGroup);
    }).remove(function(idx) {
      group.remove(oldData.getItemGraphicEl(idx));
    }).execute();
    data.eachItemGraphicEl(function(itemGroup, idx) {
      var itemModel = data.getItemModel(idx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var itemStyle = data.getItemVisual(idx, "style");
      var color = itemStyle.fill;
      group.add(itemGroup);
      polyline.useStyle(defaults(itemModel.getModel("lineStyle").getLineStyle(), {
        fill: "none",
        stroke: color
      }));
      setStatesStylesFromModel(polyline, itemModel, "lineStyle");
      setStatesStylesFromModel(polygon, itemModel, "areaStyle");
      var areaStyleModel = itemModel.getModel("areaStyle");
      var polygonIgnore = areaStyleModel.isEmpty() && areaStyleModel.parentModel.isEmpty();
      polygon.ignore = polygonIgnore;
      each$g(["emphasis", "select", "blur"], function(stateName) {
        var stateModel = itemModel.getModel([stateName, "areaStyle"]);
        var stateIgnore = stateModel.isEmpty() && stateModel.parentModel.isEmpty();
        polygon.ensureState(stateName).ignore = stateIgnore && polygonIgnore;
      });
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: color,
        opacity: 0.7,
        decal: itemStyle.decal
      }));
      var emphasisModel = itemModel.getModel("emphasis");
      var itemHoverStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      symbolGroup.eachChild(function(symbolPath) {
        if (symbolPath instanceof ZRImage$1) {
          var pathStyle = symbolPath.style;
          symbolPath.useStyle(extend({
            image: pathStyle.image,
            x: pathStyle.x,
            y: pathStyle.y,
            width: pathStyle.width,
            height: pathStyle.height
          }, itemStyle));
        } else {
          symbolPath.useStyle(itemStyle);
          symbolPath.setColor(color);
          symbolPath.style.strokeNoScale = true;
        }
        var pathEmphasisState = symbolPath.ensureState("emphasis");
        pathEmphasisState.style = clone$4(itemHoverStyle);
        var defaultText = data.getStore().get(data.getDimensionIndex(symbolPath.__dimIdx), idx);
        (defaultText == null || isNaN(defaultText)) && (defaultText = "");
        setLabelStyle(symbolPath, getLabelStatesModels(itemModel), {
          labelFetcher: data.hostModel,
          labelDataIndex: idx,
          labelDimIndex: symbolPath.__dimIdx,
          defaultText,
          inheritColor: color,
          defaultOpacity: itemStyle.opacity
        });
      });
      toggleHoverEmphasis(itemGroup, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    this._data = data;
  };
  RadarView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ChartView$1);
var RadarView$3 = RadarView$2;
var RadarSeriesModel = function(_super) {
  __extends(RadarSeriesModel2, _super);
  function RadarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  RadarSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  RadarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      generateCoord: "indicator_",
      generateCoordCount: Infinity
    });
  };
  RadarSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var coordSys = this.coordinateSystem;
    var indicatorAxes = coordSys.getIndicatorAxes();
    var name = this.getData().getName(dataIndex);
    var nameToDisplay = name === "" ? this.name : name;
    var markerColor = retrieveVisualColorForTooltipMarker(this, dataIndex);
    return createTooltipMarkup("section", {
      header: nameToDisplay,
      sortBlocks: true,
      blocks: map$1(indicatorAxes, function(axis) {
        var val = data.get(data.mapDimension(axis.dim), dataIndex);
        return createTooltipMarkup("nameValue", {
          markerType: "subItem",
          markerColor,
          name: axis.name,
          value: val,
          sortParam: val
        });
      })
    });
  };
  RadarSeriesModel2.prototype.getTooltipPosition = function(dataIndex) {
    if (dataIndex != null) {
      var data_1 = this.getData();
      var coordSys = this.coordinateSystem;
      var values = data_1.getValues(map$1(coordSys.dimensions, function(dim) {
        return data_1.mapDimension(dim);
      }), dataIndex);
      for (var i = 0, len2 = values.length; i < len2; i++) {
        if (!isNaN(values[i])) {
          var indicatorAxes = coordSys.getIndicatorAxes();
          return coordSys.coordToPoint(indicatorAxes[i].dataToCoord(values[i]), i);
        }
      }
    }
  };
  RadarSeriesModel2.type = "series.radar";
  RadarSeriesModel2.dependencies = ["radar"];
  RadarSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "radar",
    legendHoverLink: true,
    radarIndex: 0,
    lineStyle: {
      width: 2,
      type: "solid",
      join: "round"
    },
    label: {
      position: "top"
    },
    symbolSize: 8
  };
  return RadarSeriesModel2;
}(SeriesModel$1);
var RadarSeriesModel$1 = RadarSeriesModel;
var valueAxisDefault = axisDefault.value;
function defaultsShow(opt, show) {
  return defaults({
    show
  }, opt);
}
var RadarModel = function(_super) {
  __extends(RadarModel2, _super);
  function RadarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarModel2.type;
    return _this;
  }
  RadarModel2.prototype.optionUpdated = function() {
    var boundaryGap = this.get("boundaryGap");
    var splitNumber = this.get("splitNumber");
    var scale2 = this.get("scale");
    var axisLine = this.get("axisLine");
    var axisTick = this.get("axisTick");
    var axisLabel = this.get("axisLabel");
    var nameTextStyle = this.get("axisName");
    var showName = this.get(["axisName", "show"]);
    var nameFormatter = this.get(["axisName", "formatter"]);
    var nameGap = this.get("axisNameGap");
    var triggerEvent = this.get("triggerEvent");
    var indicatorModels = map$1(this.get("indicator") || [], function(indicatorOpt) {
      if (indicatorOpt.max != null && indicatorOpt.max > 0 && !indicatorOpt.min) {
        indicatorOpt.min = 0;
      } else if (indicatorOpt.min != null && indicatorOpt.min < 0 && !indicatorOpt.max) {
        indicatorOpt.max = 0;
      }
      var iNameTextStyle = nameTextStyle;
      if (indicatorOpt.color != null) {
        iNameTextStyle = defaults({
          color: indicatorOpt.color
        }, nameTextStyle);
      }
      var innerIndicatorOpt = merge(clone$4(indicatorOpt), {
        boundaryGap,
        splitNumber,
        scale: scale2,
        axisLine,
        axisTick,
        axisLabel,
        name: indicatorOpt.text,
        showName,
        nameLocation: "end",
        nameGap,
        nameTextStyle: iNameTextStyle,
        triggerEvent
      }, false);
      if (!showName) {
        innerIndicatorOpt.name = "";
      }
      if (isString$1(nameFormatter)) {
        var indName = innerIndicatorOpt.name;
        innerIndicatorOpt.name = nameFormatter.replace("{value}", indName != null ? indName : "");
      } else if (isFunction(nameFormatter)) {
        innerIndicatorOpt.name = nameFormatter(innerIndicatorOpt.name, innerIndicatorOpt);
      }
      var model = new Model$1(innerIndicatorOpt, null, this.ecModel);
      mixin(model, AxisModelCommonMixin.prototype);
      model.mainType = "radar";
      model.componentIndex = this.componentIndex;
      return model;
    }, this);
    this._indicatorModels = indicatorModels;
  };
  RadarModel2.prototype.getIndicatorModels = function() {
    return this._indicatorModels;
  };
  RadarModel2.type = "radar";
  RadarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "75%",
    startAngle: 90,
    axisName: {
      show: true
    },
    boundaryGap: [0, 0],
    splitNumber: 5,
    axisNameGap: 15,
    scale: false,
    shape: "polygon",
    axisLine: merge({
      lineStyle: {
        color: "#bbb"
      }
    }, valueAxisDefault.axisLine),
    axisLabel: defaultsShow(valueAxisDefault.axisLabel, false),
    axisTick: defaultsShow(valueAxisDefault.axisTick, false),
    splitLine: defaultsShow(valueAxisDefault.splitLine, true),
    splitArea: defaultsShow(valueAxisDefault.splitArea, true),
    indicator: []
  };
  return RadarModel2;
}(ComponentModel$1);
var RadarModel$1 = RadarModel;
var axisBuilderAttrs$2 = ["axisLine", "axisTickLabel", "axisName"];
var RadarView = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(radarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    this._buildAxes(radarModel);
    this._buildSplitLineAndArea(radarModel);
  };
  RadarView2.prototype._buildAxes = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    var axisBuilders = map$1(indicatorAxes, function(indicatorAxis) {
      var axisName = indicatorAxis.model.get("showName") ? indicatorAxis.name : "";
      var axisBuilder = new AxisBuilder$1(indicatorAxis.model, {
        axisName,
        position: [radar.cx, radar.cy],
        rotation: indicatorAxis.angle,
        labelDirection: -1,
        tickDirection: -1,
        nameDirection: 1
      });
      return axisBuilder;
    });
    each$g(axisBuilders, function(axisBuilder) {
      each$g(axisBuilderAttrs$2, axisBuilder.add, axisBuilder);
      this.group.add(axisBuilder.getGroup());
    }, this);
  };
  RadarView2.prototype._buildSplitLineAndArea = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    if (!indicatorAxes.length) {
      return;
    }
    var shape = radarModel.get("shape");
    var splitLineModel = radarModel.getModel("splitLine");
    var splitAreaModel = radarModel.getModel("splitArea");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var showSplitLine = splitLineModel.get("show");
    var showSplitArea = splitAreaModel.get("show");
    var splitLineColors = lineStyleModel.get("color");
    var splitAreaColors = areaStyleModel.get("color");
    var splitLineColorsArr = isArray$1(splitLineColors) ? splitLineColors : [splitLineColors];
    var splitAreaColorsArr = isArray$1(splitAreaColors) ? splitAreaColors : [splitAreaColors];
    var splitLines = [];
    var splitAreas = [];
    function getColorIndex(areaOrLine, areaOrLineColorList, idx) {
      var colorIndex2 = idx % areaOrLineColorList.length;
      areaOrLine[colorIndex2] = areaOrLine[colorIndex2] || [];
      return colorIndex2;
    }
    if (shape === "circle") {
      var ticksRadius = indicatorAxes[0].getTicksCoords();
      var cx = radar.cx;
      var cy = radar.cy;
      for (var i = 0; i < ticksRadius.length; i++) {
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Circle$1({
            shape: {
              cx,
              cy,
              r: ticksRadius[i].coord
            }
          }));
        }
        if (showSplitArea && i < ticksRadius.length - 1) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i);
          splitAreas[colorIndex].push(new Ring$1({
            shape: {
              cx,
              cy,
              r0: ticksRadius[i].coord,
              r: ticksRadius[i + 1].coord
            }
          }));
        }
      }
    } else {
      var realSplitNumber_1;
      var axesTicksPoints = map$1(indicatorAxes, function(indicatorAxis, idx) {
        var ticksCoords = indicatorAxis.getTicksCoords();
        realSplitNumber_1 = realSplitNumber_1 == null ? ticksCoords.length - 1 : Math.min(ticksCoords.length - 1, realSplitNumber_1);
        return map$1(ticksCoords, function(tickCoord) {
          return radar.coordToPoint(tickCoord.coord, idx);
        });
      });
      var prevPoints = [];
      for (var i = 0; i <= realSplitNumber_1; i++) {
        var points2 = [];
        for (var j = 0; j < indicatorAxes.length; j++) {
          points2.push(axesTicksPoints[j][i]);
        }
        if (points2[0]) {
          points2.push(points2[0].slice());
        }
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Polyline$3({
            shape: {
              points: points2
            }
          }));
        }
        if (showSplitArea && prevPoints) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i - 1);
          splitAreas[colorIndex].push(new Polygon$1({
            shape: {
              points: points2.concat(prevPoints)
            }
          }));
        }
        prevPoints = points2.slice().reverse();
      }
    }
    var lineStyle = lineStyleModel.getLineStyle();
    var areaStyle = areaStyleModel.getAreaStyle();
    each$g(splitAreas, function(splitAreas2, idx) {
      this.group.add(mergePath(splitAreas2, {
        style: defaults({
          stroke: "none",
          fill: splitAreaColorsArr[idx % splitAreaColorsArr.length]
        }, areaStyle),
        silent: true
      }));
    }, this);
    each$g(splitLines, function(splitLines2, idx) {
      this.group.add(mergePath(splitLines2, {
        style: defaults({
          fill: "none",
          stroke: splitLineColorsArr[idx % splitLineColorsArr.length]
        }, lineStyle),
        silent: true
      }));
    }, this);
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ComponentView$1);
var RadarView$1 = RadarView;
var IndicatorAxis = function(_super) {
  __extends(IndicatorAxis2, _super);
  function IndicatorAxis2(dim, scale2, radiusExtent) {
    var _this = _super.call(this, dim, scale2, radiusExtent) || this;
    _this.type = "value";
    _this.angle = 0;
    _this.name = "";
    return _this;
  }
  return IndicatorAxis2;
}(Axis$1);
var IndicatorAxis$1 = IndicatorAxis;
var Radar = function() {
  function Radar2(radarModel, ecModel, api) {
    this.dimensions = [];
    this._model = radarModel;
    this._indicatorAxes = map$1(radarModel.getIndicatorModels(), function(indicatorModel, idx) {
      var dim = "indicator_" + idx;
      var indicatorAxis = new IndicatorAxis$1(dim, new IntervalScale$1());
      indicatorAxis.name = indicatorModel.get("name");
      indicatorAxis.model = indicatorModel;
      indicatorModel.axis = indicatorAxis;
      this.dimensions.push(dim);
      return indicatorAxis;
    }, this);
    this.resize(radarModel, api);
  }
  Radar2.prototype.getIndicatorAxes = function() {
    return this._indicatorAxes;
  };
  Radar2.prototype.dataToPoint = function(value, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    return this.coordToPoint(indicatorAxis.dataToCoord(value), indicatorIndex);
  };
  Radar2.prototype.coordToPoint = function(coord, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    var angle = indicatorAxis.angle;
    var x2 = this.cx + coord * Math.cos(angle);
    var y2 = this.cy - coord * Math.sin(angle);
    return [x2, y2];
  };
  Radar2.prototype.pointToData = function(pt) {
    var dx = pt[0] - this.cx;
    var dy = pt[1] - this.cy;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx);
    var minRadianDiff = Infinity;
    var closestAxis;
    var closestAxisIdx = -1;
    for (var i = 0; i < this._indicatorAxes.length; i++) {
      var indicatorAxis = this._indicatorAxes[i];
      var diff = Math.abs(radian - indicatorAxis.angle);
      if (diff < minRadianDiff) {
        closestAxis = indicatorAxis;
        closestAxisIdx = i;
        minRadianDiff = diff;
      }
    }
    return [closestAxisIdx, +(closestAxis && closestAxis.coordToData(radius))];
  };
  Radar2.prototype.resize = function(radarModel, api) {
    var center2 = radarModel.get("center");
    var viewWidth = api.getWidth();
    var viewHeight = api.getHeight();
    var viewSize = Math.min(viewWidth, viewHeight) / 2;
    this.cx = parsePercent(center2[0], viewWidth);
    this.cy = parsePercent(center2[1], viewHeight);
    this.startAngle = radarModel.get("startAngle") * Math.PI / 180;
    var radius = radarModel.get("radius");
    if (isString$1(radius) || isNumber(radius)) {
      radius = [0, radius];
    }
    this.r0 = parsePercent(radius[0], viewSize);
    this.r = parsePercent(radius[1], viewSize);
    each$g(this._indicatorAxes, function(indicatorAxis, idx) {
      indicatorAxis.setExtent(this.r0, this.r);
      var angle = this.startAngle + idx * Math.PI * 2 / this._indicatorAxes.length;
      angle = Math.atan2(Math.sin(angle), Math.cos(angle));
      indicatorAxis.angle = angle;
    }, this);
  };
  Radar2.prototype.update = function(ecModel, api) {
    var indicatorAxes = this._indicatorAxes;
    var radarModel = this._model;
    each$g(indicatorAxes, function(indicatorAxis) {
      indicatorAxis.scale.setExtent(Infinity, -Infinity);
    });
    ecModel.eachSeriesByType("radar", function(radarSeries, idx) {
      if (radarSeries.get("coordinateSystem") !== "radar" || ecModel.getComponent("radar", radarSeries.get("radarIndex")) !== radarModel) {
        return;
      }
      var data = radarSeries.getData();
      each$g(indicatorAxes, function(indicatorAxis) {
        indicatorAxis.scale.unionExtentFromData(data, data.mapDimension(indicatorAxis.dim));
      });
    }, this);
    var splitNumber = radarModel.get("splitNumber");
    var dummyScale = new IntervalScale$1();
    dummyScale.setExtent(0, splitNumber);
    dummyScale.setInterval(1);
    each$g(indicatorAxes, function(indicatorAxis, idx) {
      alignScaleTicks(indicatorAxis.scale, indicatorAxis.model, dummyScale);
    });
  };
  Radar2.prototype.convertToPixel = function(ecModel, finder, value) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Radar2.create = function(ecModel, api) {
    var radarList = [];
    ecModel.eachComponent("radar", function(radarModel) {
      var radar = new Radar2(radarModel, ecModel, api);
      radarList.push(radar);
      radarModel.coordinateSystem = radar;
    });
    ecModel.eachSeriesByType("radar", function(radarSeries) {
      if (radarSeries.get("coordinateSystem") === "radar") {
        radarSeries.coordinateSystem = radarList[radarSeries.get("radarIndex") || 0];
      }
    });
    return radarList;
  };
  Radar2.dimensions = [];
  return Radar2;
}();
var Radar$1 = Radar;
function install$L(registers) {
  registers.registerCoordinateSystem("radar", Radar$1);
  registers.registerComponentModel(RadarModel$1);
  registers.registerComponentView(RadarView$1);
  registers.registerVisual({
    seriesType: "radar",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      data.each(function(idx) {
        data.setItemVisual(idx, "legendIcon", "roundRect");
      });
      data.setVisual("legendIcon", "roundRect");
    }
  });
}
function install$K(registers) {
  use(install$L);
  registers.registerChartView(RadarView$3);
  registers.registerSeriesModel(RadarSeriesModel$1);
  registers.registerLayout(radarLayout);
  registers.registerProcessor(dataFilter$1("radar"));
  registers.registerPreprocessor(radarBackwardCompat);
}
var ATTR = "\0_ec_interaction_mutex";
function take(zr, resourceKey, userKey) {
  var store = getStore(zr);
  store[resourceKey] = userKey;
}
function release(zr, resourceKey, userKey) {
  var store = getStore(zr);
  var uKey = store[resourceKey];
  if (uKey === userKey) {
    store[resourceKey] = null;
  }
}
function isTaken(zr, resourceKey) {
  return !!getStore(zr)[resourceKey];
}
function getStore(zr) {
  return zr[ATTR] || (zr[ATTR] = {});
}
registerAction({
  type: "takeGlobalCursor",
  event: "globalCursorTaken",
  update: "update"
}, noop$1);
var RoamController = function(_super) {
  __extends(RoamController2, _super);
  function RoamController2(zr) {
    var _this = _super.call(this) || this;
    _this._zr = zr;
    var mousedownHandler = bind$1(_this._mousedownHandler, _this);
    var mousemoveHandler = bind$1(_this._mousemoveHandler, _this);
    var mouseupHandler = bind$1(_this._mouseupHandler, _this);
    var mousewheelHandler = bind$1(_this._mousewheelHandler, _this);
    var pinchHandler = bind$1(_this._pinchHandler, _this);
    _this.enable = function(controlType, opt) {
      this.disable();
      this._opt = defaults(clone$4(opt) || {}, {
        zoomOnMouseWheel: true,
        moveOnMouseMove: true,
        moveOnMouseWheel: false,
        preventDefaultMouseMove: true
      });
      if (controlType == null) {
        controlType = true;
      }
      if (controlType === true || controlType === "move" || controlType === "pan") {
        zr.on("mousedown", mousedownHandler);
        zr.on("mousemove", mousemoveHandler);
        zr.on("mouseup", mouseupHandler);
      }
      if (controlType === true || controlType === "scale" || controlType === "zoom") {
        zr.on("mousewheel", mousewheelHandler);
        zr.on("pinch", pinchHandler);
      }
    };
    _this.disable = function() {
      zr.off("mousedown", mousedownHandler);
      zr.off("mousemove", mousemoveHandler);
      zr.off("mouseup", mouseupHandler);
      zr.off("mousewheel", mousewheelHandler);
      zr.off("pinch", pinchHandler);
    };
    return _this;
  }
  RoamController2.prototype.isDragging = function() {
    return this._dragging;
  };
  RoamController2.prototype.isPinching = function() {
    return this._pinching;
  };
  RoamController2.prototype.setPointerChecker = function(pointerChecker) {
    this.pointerChecker = pointerChecker;
  };
  RoamController2.prototype.dispose = function() {
    this.disable();
  };
  RoamController2.prototype._mousedownHandler = function(e2) {
    if (isMiddleOrRightButtonOnMouseUpDown(e2) || e2.target && e2.target.draggable) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    if (this.pointerChecker && this.pointerChecker(e2, x2, y2)) {
      this._x = x2;
      this._y = y2;
      this._dragging = true;
    }
  };
  RoamController2.prototype._mousemoveHandler = function(e2) {
    if (!this._dragging || !isAvailableBehavior("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || isTaken(this._zr, "globalPan")) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var oldX = this._x;
    var oldY = this._y;
    var dx = x2 - oldX;
    var dy = y2 - oldY;
    this._x = x2;
    this._y = y2;
    this._opt.preventDefaultMouseMove && stop(e2.event);
    trigger$1(this, "pan", "moveOnMouseMove", e2, {
      dx,
      dy,
      oldX,
      oldY,
      newX: x2,
      newY: y2,
      isAvailableBehavior: null
    });
  };
  RoamController2.prototype._mouseupHandler = function(e2) {
    if (!isMiddleOrRightButtonOnMouseUpDown(e2)) {
      this._dragging = false;
    }
  };
  RoamController2.prototype._mousewheelHandler = function(e2) {
    var shouldZoom = isAvailableBehavior("zoomOnMouseWheel", e2, this._opt);
    var shouldMove = isAvailableBehavior("moveOnMouseWheel", e2, this._opt);
    var wheelDelta = e2.wheelDelta;
    var absWheelDeltaDelta = Math.abs(wheelDelta);
    var originX = e2.offsetX;
    var originY = e2.offsetY;
    if (wheelDelta === 0 || !shouldZoom && !shouldMove) {
      return;
    }
    if (shouldZoom) {
      var factor = absWheelDeltaDelta > 3 ? 1.4 : absWheelDeltaDelta > 1 ? 1.2 : 1.1;
      var scale2 = wheelDelta > 0 ? factor : 1 / factor;
      checkPointerAndTrigger(this, "zoom", "zoomOnMouseWheel", e2, {
        scale: scale2,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
    if (shouldMove) {
      var absDelta = Math.abs(wheelDelta);
      var scrollDelta = (wheelDelta > 0 ? 1 : -1) * (absDelta > 3 ? 0.4 : absDelta > 1 ? 0.15 : 0.05);
      checkPointerAndTrigger(this, "scrollMove", "moveOnMouseWheel", e2, {
        scrollDelta,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
  };
  RoamController2.prototype._pinchHandler = function(e2) {
    if (isTaken(this._zr, "globalPan")) {
      return;
    }
    var scale2 = e2.pinchScale > 1 ? 1.1 : 1 / 1.1;
    checkPointerAndTrigger(this, "zoom", null, e2, {
      scale: scale2,
      originX: e2.pinchX,
      originY: e2.pinchY,
      isAvailableBehavior: null
    });
  };
  return RoamController2;
}(Eventful$1);
function checkPointerAndTrigger(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  if (controller.pointerChecker && controller.pointerChecker(e2, contollerEvent.originX, contollerEvent.originY)) {
    stop(e2.event);
    trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent);
  }
}
function trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  contollerEvent.isAvailableBehavior = bind$1(isAvailableBehavior, null, behaviorToCheck, e2);
  controller.trigger(eventName, contollerEvent);
}
function isAvailableBehavior(behaviorToCheck, e2, settings) {
  var setting = settings[behaviorToCheck];
  return !behaviorToCheck || setting && (!isString$1(setting) || e2.event[setting + "Key"]);
}
var RoamController$1 = RoamController;
function updateViewOnPan(controllerHost, dx, dy) {
  var target = controllerHost.target;
  target.x += dx;
  target.y += dy;
  target.dirty();
}
function updateViewOnZoom(controllerHost, zoomDelta, zoomX, zoomY) {
  var target = controllerHost.target;
  var zoomLimit = controllerHost.zoomLimit;
  var newZoom = controllerHost.zoom = controllerHost.zoom || 1;
  newZoom *= zoomDelta;
  if (zoomLimit) {
    var zoomMin = zoomLimit.min || 0;
    var zoomMax = zoomLimit.max || Infinity;
    newZoom = Math.max(Math.min(zoomMax, newZoom), zoomMin);
  }
  var zoomScale = newZoom / controllerHost.zoom;
  controllerHost.zoom = newZoom;
  target.x -= (zoomX - target.x) * (zoomScale - 1);
  target.y -= (zoomY - target.y) * (zoomScale - 1);
  target.scaleX *= zoomScale;
  target.scaleY *= zoomScale;
  target.dirty();
}
var IRRELEVANT_EXCLUDES = {
  "axisPointer": 1,
  "tooltip": 1,
  "brush": 1
};
function onIrrelevantElement(e2, api, targetCoordSysModel) {
  var model = api.getComponentByElement(e2.topTarget);
  var coordSys = model && model.coordinateSystem;
  return model && model !== targetCoordSysModel && !IRRELEVANT_EXCLUDES.hasOwnProperty(model.mainType) && coordSys && coordSys.model !== targetCoordSysModel;
}
function parseXML(svg) {
  if (isString$1(svg)) {
    var parser = new DOMParser();
    svg = parser.parseFromString(svg, "text/xml");
  }
  var svgNode = svg;
  if (svgNode.nodeType === 9) {
    svgNode = svgNode.firstChild;
  }
  while (svgNode.nodeName.toLowerCase() !== "svg" || svgNode.nodeType !== 1) {
    svgNode = svgNode.nextSibling;
  }
  return svgNode;
}
var nodeParsers;
var INHERITABLE_STYLE_ATTRIBUTES_MAP = {
  "fill": "fill",
  "stroke": "stroke",
  "stroke-width": "lineWidth",
  "opacity": "opacity",
  "fill-opacity": "fillOpacity",
  "stroke-opacity": "strokeOpacity",
  "stroke-dasharray": "lineDash",
  "stroke-dashoffset": "lineDashOffset",
  "stroke-linecap": "lineCap",
  "stroke-linejoin": "lineJoin",
  "stroke-miterlimit": "miterLimit",
  "font-family": "fontFamily",
  "font-size": "fontSize",
  "font-style": "fontStyle",
  "font-weight": "fontWeight",
  "text-anchor": "textAlign",
  "visibility": "visibility",
  "display": "display"
};
var INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS = keys(INHERITABLE_STYLE_ATTRIBUTES_MAP);
var SELF_STYLE_ATTRIBUTES_MAP = {
  "alignment-baseline": "textBaseline",
  "stop-color": "stopColor"
};
var SELF_STYLE_ATTRIBUTES_MAP_KEYS = keys(SELF_STYLE_ATTRIBUTES_MAP);
var SVGParser = function() {
  function SVGParser2() {
    this._defs = {};
    this._root = null;
  }
  SVGParser2.prototype.parse = function(xml, opt) {
    opt = opt || {};
    var svg = parseXML(xml);
    this._defsUsePending = [];
    var root2 = new Group$6();
    this._root = root2;
    var named = [];
    var viewBox = svg.getAttribute("viewBox") || "";
    var width = parseFloat(svg.getAttribute("width") || opt.width);
    var height = parseFloat(svg.getAttribute("height") || opt.height);
    isNaN(width) && (width = null);
    isNaN(height) && (height = null);
    parseAttributes(svg, root2, null, true, false);
    var child = svg.firstChild;
    while (child) {
      this._parseNode(child, root2, named, null, false, false);
      child = child.nextSibling;
    }
    applyDefs(this._defs, this._defsUsePending);
    this._defsUsePending = [];
    var viewBoxRect;
    var viewBoxTransform;
    if (viewBox) {
      var viewBoxArr = splitNumberSequence(viewBox);
      if (viewBoxArr.length >= 4) {
        viewBoxRect = {
          x: parseFloat(viewBoxArr[0] || 0),
          y: parseFloat(viewBoxArr[1] || 0),
          width: parseFloat(viewBoxArr[2]),
          height: parseFloat(viewBoxArr[3])
        };
      }
    }
    if (viewBoxRect && width != null && height != null) {
      viewBoxTransform = makeViewBoxTransform(viewBoxRect, { x: 0, y: 0, width, height });
      if (!opt.ignoreViewBox) {
        var elRoot = root2;
        root2 = new Group$6();
        root2.add(elRoot);
        elRoot.scaleX = elRoot.scaleY = viewBoxTransform.scale;
        elRoot.x = viewBoxTransform.x;
        elRoot.y = viewBoxTransform.y;
      }
    }
    if (!opt.ignoreRootClip && width != null && height != null) {
      root2.setClipPath(new Rect$3({
        shape: { x: 0, y: 0, width, height }
      }));
    }
    return {
      root: root2,
      width,
      height,
      viewBoxRect,
      viewBoxTransform,
      named
    };
  };
  SVGParser2.prototype._parseNode = function(xmlNode, parentGroup, named, namedFrom, isInDefs, isInText) {
    var nodeName = xmlNode.nodeName.toLowerCase();
    var el;
    var namedFromForSub = namedFrom;
    if (nodeName === "defs") {
      isInDefs = true;
    }
    if (nodeName === "text") {
      isInText = true;
    }
    if (nodeName === "defs" || nodeName === "switch") {
      el = parentGroup;
    } else {
      if (!isInDefs) {
        var parser_1 = nodeParsers[nodeName];
        if (parser_1 && hasOwn(nodeParsers, nodeName)) {
          el = parser_1.call(this, xmlNode, parentGroup);
          var nameAttr = xmlNode.getAttribute("name");
          if (nameAttr) {
            var newNamed = {
              name: nameAttr,
              namedFrom: null,
              svgNodeTagLower: nodeName,
              el
            };
            named.push(newNamed);
            if (nodeName === "g") {
              namedFromForSub = newNamed;
            }
          } else if (namedFrom) {
            named.push({
              name: namedFrom.name,
              namedFrom,
              svgNodeTagLower: nodeName,
              el
            });
          }
          parentGroup.add(el);
        }
      }
      var parser = paintServerParsers[nodeName];
      if (parser && hasOwn(paintServerParsers, nodeName)) {
        var def = parser.call(this, xmlNode);
        var id2 = xmlNode.getAttribute("id");
        if (id2) {
          this._defs[id2] = def;
        }
      }
    }
    if (el && el.isGroup) {
      var child = xmlNode.firstChild;
      while (child) {
        if (child.nodeType === 1) {
          this._parseNode(child, el, named, namedFromForSub, isInDefs, isInText);
        } else if (child.nodeType === 3 && isInText) {
          this._parseText(child, el);
        }
        child = child.nextSibling;
      }
    }
  };
  SVGParser2.prototype._parseText = function(xmlNode, parentGroup) {
    var text = new TSpan$1({
      style: {
        text: xmlNode.textContent
      },
      silent: true,
      x: this._textX || 0,
      y: this._textY || 0
    });
    inheritStyle(parentGroup, text);
    parseAttributes(xmlNode, text, this._defsUsePending, false, false);
    applyTextAlignment(text, parentGroup);
    var textStyle = text.style;
    var fontSize = textStyle.fontSize;
    if (fontSize && fontSize < 9) {
      textStyle.fontSize = 9;
      text.scaleX *= fontSize / 9;
      text.scaleY *= fontSize / 9;
    }
    var font = (textStyle.fontSize || textStyle.fontFamily) && [
      textStyle.fontStyle,
      textStyle.fontWeight,
      (textStyle.fontSize || 12) + "px",
      textStyle.fontFamily || "sans-serif"
    ].join(" ");
    textStyle.font = font;
    var rect = text.getBoundingRect();
    this._textX += rect.width;
    parentGroup.add(text);
    return text;
  };
  SVGParser2.internalField = function() {
    nodeParsers = {
      "g": function(xmlNode, parentGroup) {
        var g2 = new Group$6();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, false);
        return g2;
      },
      "rect": function(xmlNode, parentGroup) {
        var rect = new Rect$3();
        inheritStyle(parentGroup, rect);
        parseAttributes(xmlNode, rect, this._defsUsePending, false, false);
        rect.setShape({
          x: parseFloat(xmlNode.getAttribute("x") || "0"),
          y: parseFloat(xmlNode.getAttribute("y") || "0"),
          width: parseFloat(xmlNode.getAttribute("width") || "0"),
          height: parseFloat(xmlNode.getAttribute("height") || "0")
        });
        rect.silent = true;
        return rect;
      },
      "circle": function(xmlNode, parentGroup) {
        var circle = new Circle$1();
        inheritStyle(parentGroup, circle);
        parseAttributes(xmlNode, circle, this._defsUsePending, false, false);
        circle.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          r: parseFloat(xmlNode.getAttribute("r") || "0")
        });
        circle.silent = true;
        return circle;
      },
      "line": function(xmlNode, parentGroup) {
        var line = new Line$3();
        inheritStyle(parentGroup, line);
        parseAttributes(xmlNode, line, this._defsUsePending, false, false);
        line.setShape({
          x1: parseFloat(xmlNode.getAttribute("x1") || "0"),
          y1: parseFloat(xmlNode.getAttribute("y1") || "0"),
          x2: parseFloat(xmlNode.getAttribute("x2") || "0"),
          y2: parseFloat(xmlNode.getAttribute("y2") || "0")
        });
        line.silent = true;
        return line;
      },
      "ellipse": function(xmlNode, parentGroup) {
        var ellipse = new Ellipse$1();
        inheritStyle(parentGroup, ellipse);
        parseAttributes(xmlNode, ellipse, this._defsUsePending, false, false);
        ellipse.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          rx: parseFloat(xmlNode.getAttribute("rx") || "0"),
          ry: parseFloat(xmlNode.getAttribute("ry") || "0")
        });
        ellipse.silent = true;
        return ellipse;
      },
      "polygon": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polygon = new Polygon$1({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polygon);
        parseAttributes(xmlNode, polygon, this._defsUsePending, false, false);
        return polygon;
      },
      "polyline": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polyline = new Polyline$3({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polyline);
        parseAttributes(xmlNode, polyline, this._defsUsePending, false, false);
        return polyline;
      },
      "image": function(xmlNode, parentGroup) {
        var img = new ZRImage$1();
        inheritStyle(parentGroup, img);
        parseAttributes(xmlNode, img, this._defsUsePending, false, false);
        img.setStyle({
          image: xmlNode.getAttribute("xlink:href") || xmlNode.getAttribute("href"),
          x: +xmlNode.getAttribute("x"),
          y: +xmlNode.getAttribute("y"),
          width: +xmlNode.getAttribute("width"),
          height: +xmlNode.getAttribute("height")
        });
        img.silent = true;
        return img;
      },
      "text": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x") || "0";
        var y2 = xmlNode.getAttribute("y") || "0";
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        this._textX = parseFloat(x2) + parseFloat(dx);
        this._textY = parseFloat(y2) + parseFloat(dy);
        var g2 = new Group$6();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        return g2;
      },
      "tspan": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x");
        var y2 = xmlNode.getAttribute("y");
        if (x2 != null) {
          this._textX = parseFloat(x2);
        }
        if (y2 != null) {
          this._textY = parseFloat(y2);
        }
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        var g2 = new Group$6();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        this._textX += parseFloat(dx);
        this._textY += parseFloat(dy);
        return g2;
      },
      "path": function(xmlNode, parentGroup) {
        var d2 = xmlNode.getAttribute("d") || "";
        var path = createFromString(d2);
        inheritStyle(parentGroup, path);
        parseAttributes(xmlNode, path, this._defsUsePending, false, false);
        path.silent = true;
        return path;
      }
    };
  }();
  return SVGParser2;
}();
var paintServerParsers = {
  "lineargradient": function(xmlNode) {
    var x1 = parseInt(xmlNode.getAttribute("x1") || "0", 10);
    var y1 = parseInt(xmlNode.getAttribute("y1") || "0", 10);
    var x2 = parseInt(xmlNode.getAttribute("x2") || "10", 10);
    var y2 = parseInt(xmlNode.getAttribute("y2") || "0", 10);
    var gradient = new LinearGradient$1(x1, y1, x2, y2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  },
  "radialgradient": function(xmlNode) {
    var cx = parseInt(xmlNode.getAttribute("cx") || "0", 10);
    var cy = parseInt(xmlNode.getAttribute("cy") || "0", 10);
    var r2 = parseInt(xmlNode.getAttribute("r") || "0", 10);
    var gradient = new RadialGradient$1(cx, cy, r2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  }
};
function parsePaintServerUnit(xmlNode, gradient) {
  var gradientUnits = xmlNode.getAttribute("gradientUnits");
  if (gradientUnits === "userSpaceOnUse") {
    gradient.global = true;
  }
}
function parseGradientColorStops(xmlNode, gradient) {
  var stop2 = xmlNode.firstChild;
  while (stop2) {
    if (stop2.nodeType === 1 && stop2.nodeName.toLocaleLowerCase() === "stop") {
      var offsetStr = stop2.getAttribute("offset");
      var offset2 = void 0;
      if (offsetStr && offsetStr.indexOf("%") > 0) {
        offset2 = parseInt(offsetStr, 10) / 100;
      } else if (offsetStr) {
        offset2 = parseFloat(offsetStr);
      } else {
        offset2 = 0;
      }
      var styleVals = {};
      parseInlineStyle(stop2, styleVals, styleVals);
      var stopColor = styleVals.stopColor || stop2.getAttribute("stop-color") || "#000000";
      gradient.colorStops.push({
        offset: offset2,
        color: stopColor
      });
    }
    stop2 = stop2.nextSibling;
  }
}
function inheritStyle(parent, child) {
  if (parent && parent.__inheritedStyle) {
    if (!child.__inheritedStyle) {
      child.__inheritedStyle = {};
    }
    defaults(child.__inheritedStyle, parent.__inheritedStyle);
  }
}
function parsePoints(pointsString) {
  var list = splitNumberSequence(pointsString);
  var points2 = [];
  for (var i = 0; i < list.length; i += 2) {
    var x2 = parseFloat(list[i]);
    var y2 = parseFloat(list[i + 1]);
    points2.push([x2, y2]);
  }
  return points2;
}
function parseAttributes(xmlNode, el, defsUsePending, onlyInlineStyle, isTextGroup) {
  var disp = el;
  var inheritedStyle = disp.__inheritedStyle = disp.__inheritedStyle || {};
  var selfStyle = {};
  if (xmlNode.nodeType === 1) {
    parseTransformAttribute(xmlNode, el);
    parseInlineStyle(xmlNode, inheritedStyle, selfStyle);
    if (!onlyInlineStyle) {
      parseAttributeStyle(xmlNode, inheritedStyle, selfStyle);
    }
  }
  disp.style = disp.style || {};
  if (inheritedStyle.fill != null) {
    disp.style.fill = getFillStrokeStyle(disp, "fill", inheritedStyle.fill, defsUsePending);
  }
  if (inheritedStyle.stroke != null) {
    disp.style.stroke = getFillStrokeStyle(disp, "stroke", inheritedStyle.stroke, defsUsePending);
  }
  each$g([
    "lineWidth",
    "opacity",
    "fillOpacity",
    "strokeOpacity",
    "miterLimit",
    "fontSize"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = parseFloat(inheritedStyle[propName]);
    }
  });
  each$g([
    "lineDashOffset",
    "lineCap",
    "lineJoin",
    "fontWeight",
    "fontFamily",
    "fontStyle",
    "textAlign"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = inheritedStyle[propName];
    }
  });
  if (isTextGroup) {
    disp.__selfStyle = selfStyle;
  }
  if (inheritedStyle.lineDash) {
    disp.style.lineDash = map$1(splitNumberSequence(inheritedStyle.lineDash), function(str) {
      return parseFloat(str);
    });
  }
  if (inheritedStyle.visibility === "hidden" || inheritedStyle.visibility === "collapse") {
    disp.invisible = true;
  }
  if (inheritedStyle.display === "none") {
    disp.ignore = true;
  }
}
function applyTextAlignment(text, parentGroup) {
  var parentSelfStyle = parentGroup.__selfStyle;
  if (parentSelfStyle) {
    var textBaseline = parentSelfStyle.textBaseline;
    var zrTextBaseline = textBaseline;
    if (!textBaseline || textBaseline === "auto") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "baseline") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "before-edge" || textBaseline === "text-before-edge") {
      zrTextBaseline = "top";
    } else if (textBaseline === "after-edge" || textBaseline === "text-after-edge") {
      zrTextBaseline = "bottom";
    } else if (textBaseline === "central" || textBaseline === "mathematical") {
      zrTextBaseline = "middle";
    }
    text.style.textBaseline = zrTextBaseline;
  }
  var parentInheritedStyle = parentGroup.__inheritedStyle;
  if (parentInheritedStyle) {
    var textAlign = parentInheritedStyle.textAlign;
    var zrTextAlign = textAlign;
    if (textAlign) {
      if (textAlign === "middle") {
        zrTextAlign = "center";
      }
      text.style.textAlign = zrTextAlign;
    }
  }
}
var urlRegex = /^url\(\s*#(.*?)\)/;
function getFillStrokeStyle(el, method4, str, defsUsePending) {
  var urlMatch = str && str.match(urlRegex);
  if (urlMatch) {
    var url2 = trim$1(urlMatch[1]);
    defsUsePending.push([el, method4, url2]);
    return;
  }
  if (str === "none") {
    str = null;
  }
  return str;
}
function applyDefs(defs, defsUsePending) {
  for (var i = 0; i < defsUsePending.length; i++) {
    var item = defsUsePending[i];
    item[0].style[item[1]] = defs[item[2]];
  }
}
var numberReg = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function splitNumberSequence(rawStr) {
  return rawStr.match(numberReg) || [];
}
var transformRegex = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g;
var DEGREE_TO_ANGLE = Math.PI / 180;
function parseTransformAttribute(xmlNode, node) {
  var transform2 = xmlNode.getAttribute("transform");
  if (transform2) {
    transform2 = transform2.replace(/,/g, " ");
    var transformOps_1 = [];
    var mt = null;
    transform2.replace(transformRegex, function(str, type5, value2) {
      transformOps_1.push(type5, value2);
      return "";
    });
    for (var i = transformOps_1.length - 1; i > 0; i -= 2) {
      var value = transformOps_1[i];
      var type4 = transformOps_1[i - 1];
      var valueArr = splitNumberSequence(value);
      mt = mt || create$1();
      switch (type4) {
        case "translate":
          translate(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || "0")]);
          break;
        case "scale":
          scale$1(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || valueArr[0])]);
          break;
        case "rotate":
          rotate(mt, mt, -parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          break;
        case "skewX":
          var sx = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, 0, sx, 1, 0, 0], mt);
          break;
        case "skewY":
          var sy = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, sy, 0, 1, 0, 0], mt);
          break;
        case "matrix":
          mt[0] = parseFloat(valueArr[0]);
          mt[1] = parseFloat(valueArr[1]);
          mt[2] = parseFloat(valueArr[2]);
          mt[3] = parseFloat(valueArr[3]);
          mt[4] = parseFloat(valueArr[4]);
          mt[5] = parseFloat(valueArr[5]);
          break;
      }
    }
    node.setLocalTransform(mt);
  }
}
var styleRegex = /([^\s:;]+)\s*:\s*([^:;]+)/g;
function parseInlineStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  var style2 = xmlNode.getAttribute("style");
  if (!style2) {
    return;
  }
  styleRegex.lastIndex = 0;
  var styleRegResult;
  while ((styleRegResult = styleRegex.exec(style2)) != null) {
    var svgStlAttr = styleRegResult[1];
    var zrInheritableStlAttr = hasOwn(INHERITABLE_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? INHERITABLE_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrInheritableStlAttr) {
      inheritableStyleResult[zrInheritableStlAttr] = styleRegResult[2];
    }
    var zrSelfStlAttr = hasOwn(SELF_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? SELF_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrSelfStlAttr) {
      selfStyleResult[zrSelfStlAttr] = styleRegResult[2];
    }
  }
}
function parseAttributeStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  for (var i = 0; i < INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      inheritableStyleResult[INHERITABLE_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
  for (var i = 0; i < SELF_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = SELF_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      selfStyleResult[SELF_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
}
function makeViewBoxTransform(viewBoxRect, boundingRect) {
  var scaleX = boundingRect.width / viewBoxRect.width;
  var scaleY = boundingRect.height / viewBoxRect.height;
  var scale2 = Math.min(scaleX, scaleY);
  return {
    scale: scale2,
    x: -(viewBoxRect.x + viewBoxRect.width / 2) * scale2 + (boundingRect.x + boundingRect.width / 2),
    y: -(viewBoxRect.y + viewBoxRect.height / 2) * scale2 + (boundingRect.y + boundingRect.height / 2)
  };
}
function parseSVG(xml, opt) {
  var parser = new SVGParser();
  return parser.parse(xml, opt);
}
var REGION_AVAILABLE_SVG_TAG_MAP = createHashMap([
  "rect",
  "circle",
  "line",
  "ellipse",
  "polygon",
  "polyline",
  "path",
  "text",
  "tspan",
  "g"
]);
var GeoSVGResource = function() {
  function GeoSVGResource2(mapName, svg) {
    this.type = "geoSVG";
    this._usedGraphicMap = createHashMap();
    this._freedGraphics = [];
    this._mapName = mapName;
    this._parsedXML = parseXML(svg);
  }
  GeoSVGResource2.prototype.load = function() {
    var firstGraphic = this._firstGraphic;
    if (!firstGraphic) {
      firstGraphic = this._firstGraphic = this._buildGraphic(this._parsedXML);
      this._freedGraphics.push(firstGraphic);
      this._boundingRect = this._firstGraphic.boundingRect.clone();
      var _a2 = createRegions(firstGraphic.named), regions = _a2.regions, regionsMap = _a2.regionsMap;
      this._regions = regions;
      this._regionsMap = regionsMap;
    }
    return {
      boundingRect: this._boundingRect,
      regions: this._regions,
      regionsMap: this._regionsMap
    };
  };
  GeoSVGResource2.prototype._buildGraphic = function(svgXML) {
    var result;
    var rootFromParse;
    try {
      result = svgXML && parseSVG(svgXML, {
        ignoreViewBox: true,
        ignoreRootClip: true
      }) || {};
      rootFromParse = result.root;
      assert(rootFromParse != null);
    } catch (e2) {
      throw new Error("Invalid svg format\n" + e2.message);
    }
    var root2 = new Group$6();
    root2.add(rootFromParse);
    root2.isGeoSVGGraphicRoot = true;
    var svgWidth = result.width;
    var svgHeight = result.height;
    var viewBoxRect = result.viewBoxRect;
    var boundingRect = this._boundingRect;
    if (!boundingRect) {
      var bRectX = void 0;
      var bRectY = void 0;
      var bRectWidth = void 0;
      var bRectHeight = void 0;
      if (svgWidth != null) {
        bRectX = 0;
        bRectWidth = svgWidth;
      } else if (viewBoxRect) {
        bRectX = viewBoxRect.x;
        bRectWidth = viewBoxRect.width;
      }
      if (svgHeight != null) {
        bRectY = 0;
        bRectHeight = svgHeight;
      } else if (viewBoxRect) {
        bRectY = viewBoxRect.y;
        bRectHeight = viewBoxRect.height;
      }
      if (bRectX == null || bRectY == null) {
        var calculatedBoundingRect = rootFromParse.getBoundingRect();
        if (bRectX == null) {
          bRectX = calculatedBoundingRect.x;
          bRectWidth = calculatedBoundingRect.width;
        }
        if (bRectY == null) {
          bRectY = calculatedBoundingRect.y;
          bRectHeight = calculatedBoundingRect.height;
        }
      }
      boundingRect = this._boundingRect = new BoundingRect$1(bRectX, bRectY, bRectWidth, bRectHeight);
    }
    if (viewBoxRect) {
      var viewBoxTransform = makeViewBoxTransform(viewBoxRect, boundingRect);
      rootFromParse.scaleX = rootFromParse.scaleY = viewBoxTransform.scale;
      rootFromParse.x = viewBoxTransform.x;
      rootFromParse.y = viewBoxTransform.y;
    }
    root2.setClipPath(new Rect$3({
      shape: boundingRect.plain()
    }));
    var named = [];
    each$g(result.named, function(namedItem) {
      if (REGION_AVAILABLE_SVG_TAG_MAP.get(namedItem.svgNodeTagLower) != null) {
        named.push(namedItem);
        setSilent(namedItem.el);
      }
    });
    return {
      root: root2,
      boundingRect,
      named
    };
  };
  GeoSVGResource2.prototype.useGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      return svgGraphic;
    }
    svgGraphic = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML);
    usedRootMap.set(hostKey, svgGraphic);
    return svgGraphic;
  };
  GeoSVGResource2.prototype.freeGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      usedRootMap.removeKey(hostKey);
      this._freedGraphics.push(svgGraphic);
    }
  };
  return GeoSVGResource2;
}();
function setSilent(el) {
  el.silent = false;
  if (el.isGroup) {
    el.traverse(function(child) {
      child.silent = false;
    });
  }
}
function createRegions(named) {
  var regions = [];
  var regionsMap = createHashMap();
  each$g(named, function(namedItem) {
    if (namedItem.namedFrom != null) {
      return;
    }
    var region = new GeoSVGRegion(namedItem.name, namedItem.el);
    regions.push(region);
    regionsMap.set(namedItem.name, region);
  });
  return {
    regions,
    regionsMap
  };
}
var geoCoord = [126, 25];
var nanhaiName = "\u5357\u6D77\u8BF8\u5C9B";
var points$1 = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
for (var i = 0; i < points$1.length; i++) {
  for (var k$1 = 0; k$1 < points$1[i].length; k$1++) {
    points$1[i][k$1][0] /= 10.5;
    points$1[i][k$1][1] /= -10.5 / 0.75;
    points$1[i][k$1][0] += geoCoord[0];
    points$1[i][k$1][1] += geoCoord[1];
  }
}
function fixNanhai(mapType, regions) {
  if (mapType === "china") {
    for (var i = 0; i < regions.length; i++) {
      if (regions[i].name === nanhaiName) {
        return;
      }
    }
    regions.push(new GeoJSONRegion(nanhaiName, map$1(points$1, function(exterior) {
      return {
        type: "polygon",
        exterior
      };
    }), geoCoord));
  }
}
var coordsOffsetMap = {
  "\u5357\u6D77\u8BF8\u5C9B": [32, 80],
  "\u5E7F\u4E1C": [0, -10],
  "\u9999\u6E2F": [10, 5],
  "\u6FB3\u95E8": [-10, 10],
  "\u5929\u6D25": [5, 5]
};
function fixTextCoords(mapType, region) {
  if (mapType === "china") {
    var coordFix = coordsOffsetMap[region.name];
    if (coordFix) {
      var cp = region.getCenter();
      cp[0] += coordFix[0] / 10.5;
      cp[1] += -coordFix[1] / (10.5 / 0.75);
      region.setCenter(cp);
    }
  }
}
var points = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
function fixDiaoyuIsland(mapType, region) {
  if (mapType === "china" && region.name === "\u53F0\u6E7E") {
    region.geometries.push({
      type: "polygon",
      exterior: points[0]
    });
  }
}
var DEFAULT_NAME_PROPERTY = "name";
var GeoJSONResource = function() {
  function GeoJSONResource2(mapName, geoJSON, specialAreas) {
    this.type = "geoJSON";
    this._parsedMap = createHashMap();
    this._mapName = mapName;
    this._specialAreas = specialAreas;
    this._geoJSON = parseInput(geoJSON);
  }
  GeoJSONResource2.prototype.load = function(nameMap, nameProperty) {
    nameProperty = nameProperty || DEFAULT_NAME_PROPERTY;
    var parsed = this._parsedMap.get(nameProperty);
    if (!parsed) {
      var rawRegions = this._parseToRegions(nameProperty);
      parsed = this._parsedMap.set(nameProperty, {
        regions: rawRegions,
        boundingRect: calculateBoundingRect(rawRegions)
      });
    }
    var regionsMap = createHashMap();
    var finalRegions = [];
    each$g(parsed.regions, function(region) {
      var regionName = region.name;
      if (nameMap && hasOwn(nameMap, regionName)) {
        region = region.cloneShallow(regionName = nameMap[regionName]);
      }
      finalRegions.push(region);
      regionsMap.set(regionName, region);
    });
    return {
      regions: finalRegions,
      boundingRect: parsed.boundingRect || new BoundingRect$1(0, 0, 0, 0),
      regionsMap
    };
  };
  GeoJSONResource2.prototype._parseToRegions = function(nameProperty) {
    var mapName = this._mapName;
    var geoJSON = this._geoJSON;
    var rawRegions;
    try {
      rawRegions = geoJSON ? parseGeoJSON(geoJSON, nameProperty) : [];
    } catch (e2) {
      throw new Error("Invalid geoJson format\n" + e2.message);
    }
    fixNanhai(mapName, rawRegions);
    each$g(rawRegions, function(region) {
      var regionName = region.name;
      fixTextCoords(mapName, region);
      fixDiaoyuIsland(mapName, region);
      var specialArea = this._specialAreas && this._specialAreas[regionName];
      if (specialArea) {
        region.transformTo(specialArea.left, specialArea.top, specialArea.width, specialArea.height);
      }
    }, this);
    return rawRegions;
  };
  GeoJSONResource2.prototype.getMapForUser = function() {
    return {
      geoJson: this._geoJSON,
      geoJSON: this._geoJSON,
      specialAreas: this._specialAreas
    };
  };
  return GeoJSONResource2;
}();
function calculateBoundingRect(regions) {
  var rect;
  for (var i = 0; i < regions.length; i++) {
    var regionRect = regions[i].getBoundingRect();
    rect = rect || regionRect.clone();
    rect.union(regionRect);
  }
  return rect;
}
function parseInput(source) {
  return !isString$1(source) ? source : typeof JSON !== "undefined" && JSON.parse ? JSON.parse(source) : new Function("return (" + source + ");")();
}
var storage = createHashMap();
var geoSourceManager = {
  registerMap: function(mapName, rawDef, rawSpecialAreas) {
    if (rawDef.svg) {
      var resource = new GeoSVGResource(mapName, rawDef.svg);
      storage.set(mapName, resource);
    } else {
      var geoJSON = rawDef.geoJson || rawDef.geoJSON;
      if (geoJSON && !rawDef.features) {
        rawSpecialAreas = rawDef.specialAreas;
      } else {
        geoJSON = rawDef;
      }
      var resource = new GeoJSONResource(mapName, geoJSON, rawSpecialAreas);
      storage.set(mapName, resource);
    }
  },
  getGeoResource: function(mapName) {
    return storage.get(mapName);
  },
  getMapForUser: function(mapName) {
    var resource = storage.get(mapName);
    return resource && resource.type === "geoJSON" && resource.getMapForUser();
  },
  load: function(mapName, nameMap, nameProperty) {
    var resource = storage.get(mapName);
    if (!resource) {
      return;
    }
    return resource.load(nameMap, nameProperty);
  }
};
var OPTION_STYLE_ENABLED_TAGS = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"];
var OPTION_STYLE_ENABLED_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS);
var STATE_TRIGGER_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var LABEL_HOST_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var mapLabelRaw = makeInner();
function getFixedItemStyle(model) {
  var itemStyle = model.getItemStyle();
  var areaColor = model.get("areaColor");
  if (areaColor != null) {
    itemStyle.fill = areaColor;
  }
  return itemStyle;
}
function fixLineStyle(styleHost) {
  var style2 = styleHost.style;
  if (style2) {
    style2.stroke = style2.stroke || style2.fill;
    style2.fill = null;
  }
}
var MapDraw = function() {
  function MapDraw2(api) {
    var group = new Group$6();
    this.uid = getUID("ec_map_draw");
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    this.group = group;
    group.add(this._regionsGroup = new Group$6());
    group.add(this._svgGroup = new Group$6());
  }
  MapDraw2.prototype.draw = function(mapOrGeoModel, ecModel, api, fromView, payload) {
    var isGeo = mapOrGeoModel.mainType === "geo";
    var data = mapOrGeoModel.getData && mapOrGeoModel.getData();
    isGeo && ecModel.eachComponent({
      mainType: "series",
      subType: "map"
    }, function(mapSeries) {
      if (!data && mapSeries.getHostGeoModel() === mapOrGeoModel) {
        data = mapSeries.getData();
      }
    });
    var geo = mapOrGeoModel.coordinateSystem;
    var regionsGroup = this._regionsGroup;
    var group = this.group;
    var transformInfo = geo.getTransformInfo();
    var transformInfoRaw = transformInfo.raw;
    var transformInfoRoam = transformInfo.roam;
    var isFirstDraw = !regionsGroup.childAt(0) || payload;
    if (isFirstDraw) {
      group.x = transformInfoRoam.x;
      group.y = transformInfoRoam.y;
      group.scaleX = transformInfoRoam.scaleX;
      group.scaleY = transformInfoRoam.scaleY;
      group.dirty();
    } else {
      updateProps$1(group, transformInfoRoam, mapOrGeoModel);
    }
    var isVisualEncodedByVisualMap = data && data.getVisual("visualMeta") && data.getVisual("visualMeta").length > 0;
    var viewBuildCtx = {
      api,
      geo,
      mapOrGeoModel,
      data,
      isVisualEncodedByVisualMap,
      isGeo,
      transformInfoRaw
    };
    if (geo.resourceType === "geoJSON") {
      this._buildGeoJSON(viewBuildCtx);
    } else if (geo.resourceType === "geoSVG") {
      this._buildSVG(viewBuildCtx);
    }
    this._updateController(mapOrGeoModel, ecModel, api);
    this._updateMapSelectHandler(mapOrGeoModel, regionsGroup, api, fromView);
  };
  MapDraw2.prototype._buildGeoJSON = function(viewBuildCtx) {
    var regionsGroupByName = this._regionsGroupByName = createHashMap();
    var regionsInfoByName = createHashMap();
    var regionsGroup = this._regionsGroup;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
    var data = viewBuildCtx.data;
    var projection = viewBuildCtx.geo.projection;
    var projectionStream = projection && projection.stream;
    function transformPoint(point, project) {
      if (project) {
        point = project(point);
      }
      return point && [point[0] * transformInfoRaw.scaleX + transformInfoRaw.x, point[1] * transformInfoRaw.scaleY + transformInfoRaw.y];
    }
    function transformPolygonPoints(inPoints) {
      var outPoints = [];
      var project = !projectionStream && projection && projection.project;
      for (var i = 0; i < inPoints.length; ++i) {
        var newPt = transformPoint(inPoints[i], project);
        newPt && outPoints.push(newPt);
      }
      return outPoints;
    }
    function getPolyShape(points2) {
      return {
        shape: {
          points: transformPolygonPoints(points2)
        }
      };
    }
    regionsGroup.removeAll();
    each$g(viewBuildCtx.geo.regions, function(region) {
      var regionName = region.name;
      var regionGroup = regionsGroupByName.get(regionName);
      var _a2 = regionsInfoByName.get(regionName) || {}, dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      if (!regionGroup) {
        regionGroup = regionsGroupByName.set(regionName, new Group$6());
        regionsGroup.add(regionGroup);
        dataIdx = data ? data.indexOfName(regionName) : null;
        regionModel = viewBuildCtx.isGeo ? mapOrGeoModel.getRegionModel(regionName) : data ? data.getItemModel(dataIdx) : null;
        regionsInfoByName.set(regionName, {
          dataIdx,
          regionModel
        });
      }
      var polygonSubpaths = [];
      var polylineSubpaths = [];
      each$g(region.geometries, function(geometry) {
        if (geometry.type === "polygon") {
          var polys = [geometry.exterior].concat(geometry.interiors || []);
          if (projectionStream) {
            polys = projectPolys(polys, projectionStream);
          }
          each$g(polys, function(poly) {
            polygonSubpaths.push(new Polygon$1(getPolyShape(poly)));
          });
        } else {
          var points2 = geometry.points;
          if (projectionStream) {
            points2 = projectPolys(points2, projectionStream, true);
          }
          each$g(points2, function(points3) {
            polylineSubpaths.push(new Polyline$3(getPolyShape(points3)));
          });
        }
      });
      var centerPt = transformPoint(region.getCenter(), projection && projection.project);
      function createCompoundPath(subpaths, isLine) {
        if (!subpaths.length) {
          return;
        }
        var compoundPath = new CompoundPath$1({
          culling: true,
          segmentIgnoreThreshold: 1,
          shape: {
            paths: subpaths
          }
        });
        regionGroup.add(compoundPath);
        applyOptionStyleForRegion(viewBuildCtx, compoundPath, dataIdx, regionModel);
        resetLabelForRegion(viewBuildCtx, compoundPath, regionName, regionModel, mapOrGeoModel, dataIdx, centerPt);
        if (isLine) {
          fixLineStyle(compoundPath);
          each$g(compoundPath.states, fixLineStyle);
        }
      }
      createCompoundPath(polygonSubpaths);
      createCompoundPath(polylineSubpaths, true);
    });
    regionsGroupByName.each(function(regionGroup, regionName) {
      var _a2 = regionsInfoByName.get(regionName), dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      resetEventTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel, dataIdx);
      resetTooltipForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
      resetStateTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
    }, this);
  };
  MapDraw2.prototype._buildSVG = function(viewBuildCtx) {
    var mapName = viewBuildCtx.geo.map;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    this._svgGroup.x = transformInfoRaw.x;
    this._svgGroup.y = transformInfoRaw.y;
    this._svgGroup.scaleX = transformInfoRaw.scaleX;
    this._svgGroup.scaleY = transformInfoRaw.scaleY;
    if (this._svgResourceChanged(mapName)) {
      this._freeSVG();
      this._useSVG(mapName);
    }
    var svgDispatcherMap = this._svgDispatcherMap = createHashMap();
    var focusSelf = false;
    each$g(this._svgGraphicRecord.named, function(namedItem) {
      var regionName = namedItem.name;
      var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
      var data = viewBuildCtx.data;
      var svgNodeTagLower = namedItem.svgNodeTagLower;
      var el = namedItem.el;
      var dataIdx = data ? data.indexOfName(regionName) : null;
      var regionModel = mapOrGeoModel.getRegionModel(regionName);
      if (OPTION_STYLE_ENABLED_TAG_MAP.get(svgNodeTagLower) != null && el instanceof Displayable$1) {
        applyOptionStyleForRegion(viewBuildCtx, el, dataIdx, regionModel);
      }
      if (el instanceof Displayable$1) {
        el.culling = true;
      }
      el.z2EmphasisLift = 0;
      if (!namedItem.namedFrom) {
        if (LABEL_HOST_MAP.get(svgNodeTagLower) != null) {
          resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, null);
        }
        resetEventTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx);
        resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
        if (STATE_TRIGGER_TAG_MAP.get(svgNodeTagLower) != null) {
          var focus_1 = resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
          if (focus_1 === "self") {
            focusSelf = true;
          }
          var els = svgDispatcherMap.get(regionName) || svgDispatcherMap.set(regionName, []);
          els.push(el);
        }
      }
    }, this);
    this._enableBlurEntireSVG(focusSelf, viewBuildCtx);
  };
  MapDraw2.prototype._enableBlurEntireSVG = function(focusSelf, viewBuildCtx) {
    if (focusSelf && viewBuildCtx.isGeo) {
      var blurStyle = viewBuildCtx.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle();
      var opacity_1 = blurStyle.opacity;
      this._svgGraphicRecord.root.traverse(function(el) {
        if (!el.isGroup) {
          setDefaultStateProxy(el);
          var style2 = el.ensureState("blur").style || {};
          if (style2.opacity == null && opacity_1 != null) {
            style2.opacity = opacity_1;
          }
          el.ensureState("emphasis");
        }
      });
    }
  };
  MapDraw2.prototype.remove = function() {
    this._regionsGroup.removeAll();
    this._regionsGroupByName = null;
    this._svgGroup.removeAll();
    this._freeSVG();
    this._controller.dispose();
    this._controllerHost = null;
  };
  MapDraw2.prototype.findHighDownDispatchers = function(name, geoModel) {
    if (name == null) {
      return [];
    }
    var geo = geoModel.coordinateSystem;
    if (geo.resourceType === "geoJSON") {
      var regionsGroupByName = this._regionsGroupByName;
      if (regionsGroupByName) {
        var regionGroup = regionsGroupByName.get(name);
        return regionGroup ? [regionGroup] : [];
      }
    } else if (geo.resourceType === "geoSVG") {
      return this._svgDispatcherMap && this._svgDispatcherMap.get(name) || [];
    }
  };
  MapDraw2.prototype._svgResourceChanged = function(mapName) {
    return this._svgMapName !== mapName;
  };
  MapDraw2.prototype._useSVG = function(mapName) {
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      var svgGraphic = resource.useGraphic(this.uid);
      this._svgGroup.add(svgGraphic.root);
      this._svgGraphicRecord = svgGraphic;
      this._svgMapName = mapName;
    }
  };
  MapDraw2.prototype._freeSVG = function() {
    var mapName = this._svgMapName;
    if (mapName == null) {
      return;
    }
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      resource.freeGraphic(this.uid);
    }
    this._svgGraphicRecord = null;
    this._svgDispatcherMap = null;
    this._svgGroup.removeAll();
    this._svgMapName = null;
  };
  MapDraw2.prototype._updateController = function(mapOrGeoModel, ecModel, api) {
    var geo = mapOrGeoModel.coordinateSystem;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    controllerHost.zoomLimit = mapOrGeoModel.get("scaleLimit");
    controllerHost.zoom = geo.getZoom();
    controller.enable(mapOrGeoModel.get("roam") || false);
    var mainType = mapOrGeoModel.mainType;
    function makeActionBase() {
      var action = {
        type: "geoRoam",
        componentType: mainType
      };
      action[mainType + "Id"] = mapOrGeoModel.id;
      return action;
    }
    controller.off("pan").on("pan", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction(extend(makeActionBase(), {
        dx: e2.dx,
        dy: e2.dy,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.off("zoom").on("zoom", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction(extend(makeActionBase(), {
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.setPointerChecker(function(e2, x2, y2) {
      return geo.containPoint([x2, y2]) && !onIrrelevantElement(e2, api, mapOrGeoModel);
    });
  };
  MapDraw2.prototype.resetForLabelLayout = function() {
    this.group.traverse(function(el) {
      var label = el.getTextContent();
      if (label) {
        label.ignore = mapLabelRaw(label).ignore;
      }
    });
  };
  MapDraw2.prototype._updateMapSelectHandler = function(mapOrGeoModel, regionsGroup, api, fromView) {
    var mapDraw = this;
    regionsGroup.off("mousedown");
    regionsGroup.off("click");
    if (mapOrGeoModel.get("selectedMode")) {
      regionsGroup.on("mousedown", function() {
        mapDraw._mouseDownFlag = true;
      });
      regionsGroup.on("click", function(e2) {
        if (!mapDraw._mouseDownFlag) {
          return;
        }
        mapDraw._mouseDownFlag = false;
      });
    }
  };
  return MapDraw2;
}();
function applyOptionStyleForRegion(viewBuildCtx, el, dataIndex, regionModel) {
  var normalStyleModel = regionModel.getModel("itemStyle");
  var emphasisStyleModel = regionModel.getModel(["emphasis", "itemStyle"]);
  var blurStyleModel = regionModel.getModel(["blur", "itemStyle"]);
  var selectStyleModel = regionModel.getModel(["select", "itemStyle"]);
  var normalStyle = getFixedItemStyle(normalStyleModel);
  var emphasisStyle = getFixedItemStyle(emphasisStyleModel);
  var selectStyle = getFixedItemStyle(selectStyleModel);
  var blurStyle = getFixedItemStyle(blurStyleModel);
  var data = viewBuildCtx.data;
  if (data) {
    var style2 = data.getItemVisual(dataIndex, "style");
    var decal = data.getItemVisual(dataIndex, "decal");
    if (viewBuildCtx.isVisualEncodedByVisualMap && style2.fill) {
      normalStyle.fill = style2.fill;
    }
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, viewBuildCtx.api);
    }
  }
  el.setStyle(normalStyle);
  el.style.strokeNoScale = true;
  el.ensureState("emphasis").style = emphasisStyle;
  el.ensureState("select").style = selectStyle;
  el.ensureState("blur").style = blurStyle;
  setDefaultStateProxy(el);
}
function resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, labelXY) {
  var data = viewBuildCtx.data;
  var isGeo = viewBuildCtx.isGeo;
  var isDataNaN = data && isNaN(data.get(data.mapDimension("value"), dataIdx));
  var itemLayout = data && data.getItemLayout(dataIdx);
  if (isGeo || isDataNaN || itemLayout && itemLayout.showLabel) {
    var query = !isGeo ? dataIdx : regionName;
    var labelFetcher = void 0;
    if (!data || dataIdx >= 0) {
      labelFetcher = mapOrGeoModel;
    }
    var specifiedTextOpt = labelXY ? {
      normal: {
        align: "center",
        verticalAlign: "middle"
      }
    } : null;
    setLabelStyle(el, getLabelStatesModels(regionModel), {
      labelFetcher,
      labelDataIndex: query,
      defaultText: regionName
    }, specifiedTextOpt);
    var textEl = el.getTextContent();
    if (textEl) {
      mapLabelRaw(textEl).ignore = textEl.ignore;
      if (el.textConfig && labelXY) {
        var rect = el.getBoundingRect().clone();
        el.textConfig.layoutRect = rect;
        el.textConfig.position = [(labelXY[0] - rect.x) / rect.width * 100 + "%", (labelXY[1] - rect.y) / rect.height * 100 + "%"];
      }
    }
    el.disableLabelAnimation = true;
  } else {
    el.removeTextContent();
    el.removeTextConfig();
    el.disableLabelAnimation = null;
  }
}
function resetEventTriggerForRegion(viewBuildCtx, eventTrigger, regionName, regionModel, mapOrGeoModel, dataIdx) {
  if (viewBuildCtx.data) {
    viewBuildCtx.data.setItemGraphicEl(dataIdx, eventTrigger);
  } else {
    getECData(eventTrigger).eventData = {
      componentType: "geo",
      componentIndex: mapOrGeoModel.componentIndex,
      geoIndex: mapOrGeoModel.componentIndex,
      name: regionName,
      region: regionModel && regionModel.option || {}
    };
  }
}
function resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  if (!viewBuildCtx.data) {
    setTooltipConfig({
      el,
      componentModel: mapOrGeoModel,
      itemName: regionName,
      itemTooltipOption: regionModel.get("tooltip")
    });
  }
}
function resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  el.highDownSilentOnTouch = !!mapOrGeoModel.get("selectedMode");
  var emphasisModel = regionModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  toggleHoverEmphasis(el, focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  if (viewBuildCtx.isGeo) {
    enableComponentHighDownFeatures(el, mapOrGeoModel, regionName);
  }
  return focus;
}
function projectPolys(rings, createStream, isLine) {
  var polygons = [];
  var curPoly;
  function startPolygon() {
    curPoly = [];
  }
  function endPolygon() {
    if (curPoly.length) {
      polygons.push(curPoly);
      curPoly = [];
    }
  }
  var stream = createStream({
    polygonStart: startPolygon,
    polygonEnd: endPolygon,
    lineStart: startPolygon,
    lineEnd: endPolygon,
    point: function(x2, y2) {
      if (isFinite(x2) && isFinite(y2)) {
        curPoly.push([x2, y2]);
      }
    },
    sphere: function() {
    }
  });
  !isLine && stream.polygonStart();
  each$g(rings, function(ring) {
    stream.lineStart();
    for (var i = 0; i < ring.length; i++) {
      stream.point(ring[i][0], ring[i][1]);
    }
    stream.lineEnd();
  });
  !isLine && stream.polygonEnd();
  return polygons;
}
var MapDraw$1 = MapDraw;
var MapView = function(_super) {
  __extends(MapView2, _super);
  function MapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapView2.type;
    return _this;
  }
  MapView2.prototype.render = function(mapModel, ecModel, api, payload) {
    if (payload && payload.type === "mapToggleSelect" && payload.from === this.uid) {
      return;
    }
    var group = this.group;
    group.removeAll();
    if (mapModel.getHostGeoModel()) {
      return;
    }
    if (this._mapDraw && payload && payload.type === "geoRoam") {
      this._mapDraw.resetForLabelLayout();
    }
    if (!(payload && payload.type === "geoRoam" && payload.componentType === "series" && payload.seriesId === mapModel.id)) {
      if (mapModel.needsDrawMap) {
        var mapDraw = this._mapDraw || new MapDraw$1(api);
        group.add(mapDraw.group);
        mapDraw.draw(mapModel, ecModel, api, this, payload);
        this._mapDraw = mapDraw;
      } else {
        this._mapDraw && this._mapDraw.remove();
        this._mapDraw = null;
      }
    } else {
      var mapDraw = this._mapDraw;
      mapDraw && group.add(mapDraw.group);
    }
    mapModel.get("showLegendSymbol") && ecModel.getComponent("legend") && this._renderSymbols(mapModel, ecModel, api);
  };
  MapView2.prototype.remove = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
    this.group.removeAll();
  };
  MapView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
  };
  MapView2.prototype._renderSymbols = function(mapModel, ecModel, api) {
    var originalData = mapModel.originalData;
    var group = this.group;
    originalData.each(originalData.mapDimension("value"), function(value, originalDataIndex) {
      if (isNaN(value)) {
        return;
      }
      var layout2 = originalData.getItemLayout(originalDataIndex);
      if (!layout2 || !layout2.point) {
        return;
      }
      var point = layout2.point;
      var offset2 = layout2.offset;
      var circle = new Circle$1({
        style: {
          fill: mapModel.getData().getVisual("style").fill
        },
        shape: {
          cx: point[0] + offset2 * 9,
          cy: point[1],
          r: 3
        },
        silent: true,
        z2: 8 + (!offset2 ? Z2_EMPHASIS_LIFT + 1 : 0)
      });
      if (!offset2) {
        var fullData = mapModel.mainSeries.getData();
        var name_1 = originalData.getName(originalDataIndex);
        var fullIndex_1 = fullData.indexOfName(name_1);
        var itemModel = originalData.getItemModel(originalDataIndex);
        var labelModel = itemModel.getModel("label");
        var regionGroup = fullData.getItemGraphicEl(fullIndex_1);
        setLabelStyle(circle, getLabelStatesModels(itemModel), {
          labelFetcher: {
            getFormattedLabel: function(idx, state) {
              return mapModel.getFormattedLabel(fullIndex_1, state);
            }
          },
          defaultText: name_1
        });
        circle.disableLabelAnimation = true;
        if (!labelModel.get("position")) {
          circle.setTextConfig({
            position: "bottom"
          });
        }
        regionGroup.onHoverStateChange = function(toState) {
          setStatesFlag(circle, toState);
        };
      }
      group.add(circle);
    });
  };
  MapView2.type = "map";
  return MapView2;
}(ChartView$1);
var MapView$1 = MapView;
var MapSeries = function(_super) {
  __extends(MapSeries2, _super);
  function MapSeries2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapSeries2.type;
    _this.needsDrawMap = false;
    _this.seriesGroup = [];
    _this.getTooltipPosition = function(dataIndex) {
      if (dataIndex != null) {
        var name_1 = this.getData().getName(dataIndex);
        var geo = this.coordinateSystem;
        var region = geo.getRegion(name_1);
        return region && geo.dataToPoint(region.getCenter());
      }
    };
    return _this;
  }
  MapSeries2.prototype.getInitialData = function(option) {
    var data = createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
    var dataNameMap = createHashMap();
    var toAppendNames = [];
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      var name_2 = data.getName(i);
      dataNameMap.set(name_2, true);
    }
    var geoSource = geoSourceManager.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
    each$g(geoSource.regions, function(region) {
      var name = region.name;
      if (!dataNameMap.get(name)) {
        toAppendNames.push(name);
      }
    });
    data.appendValues([], toAppendNames);
    return data;
  };
  MapSeries2.prototype.getHostGeoModel = function() {
    var geoIndex = this.option.geoIndex;
    return geoIndex != null ? this.ecModel.getComponent("geo", geoIndex) : null;
  };
  MapSeries2.prototype.getMapType = function() {
    return (this.getHostGeoModel() || this).option.map;
  };
  MapSeries2.prototype.getRawValue = function(dataIndex) {
    var data = this.getData();
    return data.get(data.mapDimension("value"), dataIndex);
  };
  MapSeries2.prototype.getRegionModel = function(regionName) {
    var data = this.getData();
    return data.getItemModel(data.indexOfName(regionName));
  };
  MapSeries2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    var seriesGroup = this.seriesGroup;
    var seriesNames = [];
    for (var i = 0; i < seriesGroup.length; i++) {
      var otherIndex = seriesGroup[i].originalData.indexOfName(name);
      var valueDim = data.mapDimension("value");
      if (!isNaN(seriesGroup[i].originalData.get(valueDim, otherIndex))) {
        seriesNames.push(seriesGroup[i].name);
      }
    }
    return createTooltipMarkup("section", {
      header: seriesNames.join(", "),
      noHeader: !seriesNames.length,
      blocks: [createTooltipMarkup("nameValue", {
        name,
        value
      })]
    });
  };
  MapSeries2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  MapSeries2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  MapSeries2.prototype.getLegendIcon = function(opt) {
    var iconType = opt.icon || "roundRect";
    var icon = createSymbol$1(iconType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill);
    icon.setStyle(opt.itemStyle);
    icon.style.stroke = "none";
    if (iconType.indexOf("empty") > -1) {
      icon.style.stroke = icon.style.fill;
      icon.style.fill = "#fff";
      icon.style.lineWidth = 2;
    }
    return icon;
  };
  MapSeries2.type = "series.map";
  MapSeries2.dependencies = ["geo"];
  MapSeries2.layoutMode = "box";
  MapSeries2.defaultOption = {
    z: 2,
    coordinateSystem: "geo",
    map: "",
    left: "center",
    top: "center",
    aspectScale: null,
    showLegendSymbol: true,
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    selectedMode: true,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444",
      areaColor: "#eee"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        areaColor: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    nameProperty: "name"
  };
  return MapSeries2;
}(SeriesModel$1);
var MapSeries$1 = MapSeries;
function dataStatistics(datas, statisticType) {
  var dataNameMap = {};
  each$g(datas, function(data) {
    data.each(data.mapDimension("value"), function(value, idx) {
      var mapKey = "ec-" + data.getName(idx);
      dataNameMap[mapKey] = dataNameMap[mapKey] || [];
      if (!isNaN(value)) {
        dataNameMap[mapKey].push(value);
      }
    });
  });
  return datas[0].map(datas[0].mapDimension("value"), function(value, idx) {
    var mapKey = "ec-" + datas[0].getName(idx);
    var sum2 = 0;
    var min3 = Infinity;
    var max3 = -Infinity;
    var len2 = dataNameMap[mapKey].length;
    for (var i = 0; i < len2; i++) {
      min3 = Math.min(min3, dataNameMap[mapKey][i]);
      max3 = Math.max(max3, dataNameMap[mapKey][i]);
      sum2 += dataNameMap[mapKey][i];
    }
    var result;
    if (statisticType === "min") {
      result = min3;
    } else if (statisticType === "max") {
      result = max3;
    } else if (statisticType === "average") {
      result = sum2 / len2;
    } else {
      result = sum2;
    }
    return len2 === 0 ? NaN : result;
  });
}
function mapDataStatistic(ecModel) {
  var seriesGroups = {};
  ecModel.eachSeriesByType("map", function(seriesModel) {
    var hostGeoModel = seriesModel.getHostGeoModel();
    var key = hostGeoModel ? "o" + hostGeoModel.id : "i" + seriesModel.getMapType();
    (seriesGroups[key] = seriesGroups[key] || []).push(seriesModel);
  });
  each$g(seriesGroups, function(seriesList, key) {
    var data = dataStatistics(map$1(seriesList, function(seriesModel) {
      return seriesModel.getData();
    }), seriesList[0].get("mapValueCalculation"));
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].originalData = seriesList[i].getData();
    }
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].seriesGroup = seriesList;
      seriesList[i].needsDrawMap = i === 0 && !seriesList[i].getHostGeoModel();
      seriesList[i].setData(data.cloneShallow());
      seriesList[i].mainSeries = seriesList[0];
    }
  });
}
function mapSymbolLayout(ecModel) {
  var processedMapType = {};
  ecModel.eachSeriesByType("map", function(mapSeries) {
    var mapType = mapSeries.getMapType();
    if (mapSeries.getHostGeoModel() || processedMapType[mapType]) {
      return;
    }
    var mapSymbolOffsets = {};
    each$g(mapSeries.seriesGroup, function(subMapSeries) {
      var geo = subMapSeries.coordinateSystem;
      var data2 = subMapSeries.originalData;
      if (subMapSeries.get("showLegendSymbol") && ecModel.getComponent("legend")) {
        data2.each(data2.mapDimension("value"), function(value, idx) {
          var name = data2.getName(idx);
          var region = geo.getRegion(name);
          if (!region || isNaN(value)) {
            return;
          }
          var offset2 = mapSymbolOffsets[name] || 0;
          var point = geo.dataToPoint(region.getCenter());
          mapSymbolOffsets[name] = offset2 + 1;
          data2.setItemLayout(idx, {
            point,
            offset: offset2
          });
        });
      }
    });
    var data = mapSeries.getData();
    data.each(function(idx) {
      var name = data.getName(idx);
      var layout2 = data.getItemLayout(idx) || {};
      layout2.showLabel = !mapSymbolOffsets[name];
      data.setItemLayout(idx, layout2);
    });
    processedMapType[mapType] = true;
  });
}
var v2ApplyTransform = applyTransform$1;
var View = function(_super) {
  __extends(View2, _super);
  function View2(name) {
    var _this = _super.call(this) || this;
    _this.type = "view";
    _this.dimensions = ["x", "y"];
    _this._roamTransformable = new Transformable$1();
    _this._rawTransformable = new Transformable$1();
    _this.name = name;
    return _this;
  }
  View2.prototype.setBoundingRect = function(x2, y2, width, height) {
    this._rect = new BoundingRect$1(x2, y2, width, height);
    return this._rect;
  };
  View2.prototype.getBoundingRect = function() {
    return this._rect;
  };
  View2.prototype.setViewRect = function(x2, y2, width, height) {
    this._transformTo(x2, y2, width, height);
    this._viewRect = new BoundingRect$1(x2, y2, width, height);
  };
  View2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var rawTransform = this._rawTransformable;
    rawTransform.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransform.parent;
    rawTransform.parent = null;
    rawTransform.decomposeTransform();
    rawTransform.parent = rawParent;
    this._updateTransform();
  };
  View2.prototype.setCenter = function(centerCoord) {
    if (!centerCoord) {
      return;
    }
    this._center = centerCoord;
    this._updateCenterAndZoom();
  };
  View2.prototype.setZoom = function(zoom) {
    zoom = zoom || 1;
    var zoomLimit = this.zoomLimit;
    if (zoomLimit) {
      if (zoomLimit.max != null) {
        zoom = Math.min(zoomLimit.max, zoom);
      }
      if (zoomLimit.min != null) {
        zoom = Math.max(zoomLimit.min, zoom);
      }
    }
    this._zoom = zoom;
    this._updateCenterAndZoom();
  };
  View2.prototype.getDefaultCenter = function() {
    var rawRect = this.getBoundingRect();
    var cx = rawRect.x + rawRect.width / 2;
    var cy = rawRect.y + rawRect.height / 2;
    return [cx, cy];
  };
  View2.prototype.getCenter = function() {
    return this._center || this.getDefaultCenter();
  };
  View2.prototype.getZoom = function() {
    return this._zoom || 1;
  };
  View2.prototype.getRoamTransform = function() {
    return this._roamTransformable.getLocalTransform();
  };
  View2.prototype._updateCenterAndZoom = function() {
    var rawTransformMatrix = this._rawTransformable.getLocalTransform();
    var roamTransform = this._roamTransformable;
    var defaultCenter = this.getDefaultCenter();
    var center2 = this.getCenter();
    var zoom = this.getZoom();
    center2 = applyTransform$1([], center2, rawTransformMatrix);
    defaultCenter = applyTransform$1([], defaultCenter, rawTransformMatrix);
    roamTransform.originX = center2[0];
    roamTransform.originY = center2[1];
    roamTransform.x = defaultCenter[0] - center2[0];
    roamTransform.y = defaultCenter[1] - center2[1];
    roamTransform.scaleX = roamTransform.scaleY = zoom;
    this._updateTransform();
  };
  View2.prototype._updateTransform = function() {
    var roamTransformable = this._roamTransformable;
    var rawTransformable = this._rawTransformable;
    rawTransformable.parent = roamTransformable;
    roamTransformable.updateTransform();
    rawTransformable.updateTransform();
    copy(this.transform || (this.transform = []), rawTransformable.transform || create$1());
    this._rawTransform = rawTransformable.getLocalTransform();
    this.invTransform = this.invTransform || [];
    invert(this.invTransform, this.transform);
    this.decomposeTransform();
  };
  View2.prototype.getTransformInfo = function() {
    var rawTransformable = this._rawTransformable;
    var roamTransformable = this._roamTransformable;
    var dummyTransformable2 = new Transformable$1();
    dummyTransformable2.transform = roamTransformable.transform;
    dummyTransformable2.decomposeTransform();
    return {
      roam: {
        x: dummyTransformable2.x,
        y: dummyTransformable2.y,
        scaleX: dummyTransformable2.scaleX,
        scaleY: dummyTransformable2.scaleY
      },
      raw: {
        x: rawTransformable.x,
        y: rawTransformable.y,
        scaleX: rawTransformable.scaleX,
        scaleY: rawTransformable.scaleY
      }
    };
  };
  View2.prototype.getViewRect = function() {
    return this._viewRect;
  };
  View2.prototype.getViewRectAfterRoam = function() {
    var rect = this.getBoundingRect().clone();
    rect.applyTransform(this.transform);
    return rect;
  };
  View2.prototype.dataToPoint = function(data, noRoam, out2) {
    var transform2 = noRoam ? this._rawTransform : this.transform;
    out2 = out2 || [];
    return transform2 ? v2ApplyTransform(out2, data, transform2) : copy$1(out2, data);
  };
  View2.prototype.pointToData = function(point) {
    var invTransform = this.invTransform;
    return invTransform ? v2ApplyTransform([], point, invTransform) : [point[0], point[1]];
  };
  View2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  View2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  View2.prototype.containPoint = function(point) {
    return this.getViewRectAfterRoam().contain(point[0], point[1]);
  };
  View2.dimensions = ["x", "y"];
  return View2;
}(Transformable$1);
function getCoordSys$4(finder) {
  var seriesModel = finder.seriesModel;
  return seriesModel ? seriesModel.coordinateSystem : null;
}
var View$1 = View;
var GEO_DEFAULT_PARAMS = {
  "geoJSON": {
    aspectScale: 0.75,
    invertLongitute: true
  },
  "geoSVG": {
    aspectScale: 1,
    invertLongitute: false
  }
};
var geo2DDimensions = ["lng", "lat"];
var Geo = function(_super) {
  __extends(Geo2, _super);
  function Geo2(name, map2, opt) {
    var _this = _super.call(this, name) || this;
    _this.dimensions = geo2DDimensions;
    _this.type = "geo";
    _this._nameCoordMap = createHashMap();
    _this.map = map2;
    var projection = opt.projection;
    var source = geoSourceManager.load(map2, opt.nameMap, opt.nameProperty);
    var resource = geoSourceManager.getGeoResource(map2);
    _this.resourceType = resource ? resource.type : null;
    var regions = _this.regions = source.regions;
    var defaultParams = GEO_DEFAULT_PARAMS[resource.type];
    _this._regionsMap = source.regionsMap;
    _this.regions = source.regions;
    _this.projection = projection;
    var boundingRect;
    if (projection) {
      for (var i = 0; i < regions.length; i++) {
        var regionRect = regions[i].getBoundingRect(projection);
        boundingRect = boundingRect || regionRect.clone();
        boundingRect.union(regionRect);
      }
    } else {
      boundingRect = source.boundingRect;
    }
    _this.setBoundingRect(boundingRect.x, boundingRect.y, boundingRect.width, boundingRect.height);
    _this.aspectScale = projection ? 1 : retrieve2(opt.aspectScale, defaultParams.aspectScale);
    _this._invertLongitute = projection ? false : defaultParams.invertLongitute;
    return _this;
  }
  Geo2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var invertLongitute = this._invertLongitute;
    rect = rect.clone();
    if (invertLongitute) {
      rect.y = -rect.y - rect.height;
    }
    var rawTransformable = this._rawTransformable;
    rawTransformable.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransformable.parent;
    rawTransformable.parent = null;
    rawTransformable.decomposeTransform();
    rawTransformable.parent = rawParent;
    if (invertLongitute) {
      rawTransformable.scaleY = -rawTransformable.scaleY;
    }
    this._updateTransform();
  };
  Geo2.prototype.getRegion = function(name) {
    return this._regionsMap.get(name);
  };
  Geo2.prototype.getRegionByCoord = function(coord) {
    var regions = this.regions;
    for (var i = 0; i < regions.length; i++) {
      var region = regions[i];
      if (region.type === "geoJSON" && region.contain(coord)) {
        return regions[i];
      }
    }
  };
  Geo2.prototype.addGeoCoord = function(name, geoCoord2) {
    this._nameCoordMap.set(name, geoCoord2);
  };
  Geo2.prototype.getGeoCoord = function(name) {
    var region = this._regionsMap.get(name);
    return this._nameCoordMap.get(name) || region && region.getCenter();
  };
  Geo2.prototype.dataToPoint = function(data, noRoam, out2) {
    if (isString$1(data)) {
      data = this.getGeoCoord(data);
    }
    if (data) {
      var projection = this.projection;
      if (projection) {
        data = projection.project(data);
      }
      return data && this.projectedToPoint(data);
    }
  };
  Geo2.prototype.pointToData = function(point) {
    var projection = this.projection;
    if (projection) {
      point = projection.unproject(point);
    }
    return point && this.pointToProjected(point);
  };
  Geo2.prototype.pointToProjected = function(point) {
    return _super.prototype.pointToData.call(this, point);
  };
  Geo2.prototype.projectedToPoint = function(projected, noRoam, out2) {
    return _super.prototype.dataToPoint.call(this, projected, noRoam, out2);
  };
  Geo2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Geo2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  return Geo2;
}(View$1);
mixin(Geo, View$1);
function getCoordSys$3(finder) {
  var geoModel = finder.geoModel;
  var seriesModel = finder.seriesModel;
  return geoModel ? geoModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem || (seriesModel.getReferringComponents("geo", SINGLE_REFERRING).models[0] || {}).coordinateSystem : null;
}
var Geo$1 = Geo;
function resizeGeo(geoModel, api) {
  var boundingCoords = geoModel.get("boundingCoords");
  if (boundingCoords != null) {
    var leftTop_1 = boundingCoords[0];
    var rightBottom_1 = boundingCoords[1];
    if (!(isFinite(leftTop_1[0]) && isFinite(leftTop_1[1]) && isFinite(rightBottom_1[0]) && isFinite(rightBottom_1[1])))
      ;
    else {
      var projection_1 = this.projection;
      if (projection_1) {
        var xMin = leftTop_1[0];
        var yMin = leftTop_1[1];
        var xMax = rightBottom_1[0];
        var yMax = rightBottom_1[1];
        leftTop_1 = [Infinity, Infinity];
        rightBottom_1 = [-Infinity, -Infinity];
        var sampleLine = function(x0, y0, x1, y1) {
          var dx = x1 - x0;
          var dy = y1 - y0;
          for (var i = 0; i <= 100; i++) {
            var p2 = i / 100;
            var pt = projection_1.project([x0 + dx * p2, y0 + dy * p2]);
            min$1(leftTop_1, leftTop_1, pt);
            max$1(rightBottom_1, rightBottom_1, pt);
          }
        };
        sampleLine(xMin, yMin, xMax, yMin);
        sampleLine(xMax, yMin, xMax, yMax);
        sampleLine(xMax, yMax, xMin, yMax);
        sampleLine(xMin, yMax, xMax, yMin);
      }
      this.setBoundingRect(leftTop_1[0], leftTop_1[1], rightBottom_1[0] - leftTop_1[0], rightBottom_1[1] - leftTop_1[1]);
    }
  }
  var rect = this.getBoundingRect();
  var centerOption = geoModel.get("layoutCenter");
  var sizeOption = geoModel.get("layoutSize");
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  var aspect = rect.width / rect.height * this.aspectScale;
  var useCenterAndSize = false;
  var center2;
  var size;
  if (centerOption && sizeOption) {
    center2 = [parsePercent(centerOption[0], viewWidth), parsePercent(centerOption[1], viewHeight)];
    size = parsePercent(sizeOption, Math.min(viewWidth, viewHeight));
    if (!isNaN(center2[0]) && !isNaN(center2[1]) && !isNaN(size)) {
      useCenterAndSize = true;
    }
  }
  var viewRect2;
  if (useCenterAndSize) {
    viewRect2 = {};
    if (aspect > 1) {
      viewRect2.width = size;
      viewRect2.height = size / aspect;
    } else {
      viewRect2.height = size;
      viewRect2.width = size * aspect;
    }
    viewRect2.y = center2[1] - viewRect2.height / 2;
    viewRect2.x = center2[0] - viewRect2.width / 2;
  } else {
    var boxLayoutOption = geoModel.getBoxLayoutParams();
    boxLayoutOption.aspect = aspect;
    viewRect2 = getLayoutRect(boxLayoutOption, {
      width: viewWidth,
      height: viewHeight
    });
  }
  this.setViewRect(viewRect2.x, viewRect2.y, viewRect2.width, viewRect2.height);
  this.setCenter(geoModel.get("center"));
  this.setZoom(geoModel.get("zoom"));
}
function setGeoCoords(geo, model) {
  each$g(model.get("geoCoord"), function(geoCoord2, name) {
    geo.addGeoCoord(name, geoCoord2);
  });
}
var GeoCreator = function() {
  function GeoCreator2() {
    this.dimensions = geo2DDimensions;
  }
  GeoCreator2.prototype.create = function(ecModel, api) {
    var geoList = [];
    function getCommonGeoProperties(model) {
      return {
        nameProperty: model.get("nameProperty"),
        aspectScale: model.get("aspectScale"),
        projection: model.get("projection")
      };
    }
    ecModel.eachComponent("geo", function(geoModel, idx) {
      var mapName = geoModel.get("map");
      var geo = new Geo$1(mapName + idx, mapName, extend({
        nameMap: geoModel.get("nameMap")
      }, getCommonGeoProperties(geoModel)));
      geo.zoomLimit = geoModel.get("scaleLimit");
      geoList.push(geo);
      geoModel.coordinateSystem = geo;
      geo.model = geoModel;
      geo.resize = resizeGeo;
      geo.resize(geoModel, api);
    });
    ecModel.eachSeries(function(seriesModel) {
      var coordSys = seriesModel.get("coordinateSystem");
      if (coordSys === "geo") {
        var geoIndex = seriesModel.get("geoIndex") || 0;
        seriesModel.coordinateSystem = geoList[geoIndex];
      }
    });
    var mapModelGroupBySeries = {};
    ecModel.eachSeriesByType("map", function(seriesModel) {
      if (!seriesModel.getHostGeoModel()) {
        var mapType = seriesModel.getMapType();
        mapModelGroupBySeries[mapType] = mapModelGroupBySeries[mapType] || [];
        mapModelGroupBySeries[mapType].push(seriesModel);
      }
    });
    each$g(mapModelGroupBySeries, function(mapSeries, mapType) {
      var nameMapList = map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("nameMap");
      });
      var geo = new Geo$1(mapType, mapType, extend({
        nameMap: mergeAll(nameMapList)
      }, getCommonGeoProperties(mapSeries[0])));
      geo.zoomLimit = retrieve.apply(null, map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("scaleLimit");
      }));
      geoList.push(geo);
      geo.resize = resizeGeo;
      geo.resize(mapSeries[0], api);
      each$g(mapSeries, function(singleMapSeries) {
        singleMapSeries.coordinateSystem = geo;
        setGeoCoords(geo, singleMapSeries);
      });
    });
    return geoList;
  };
  GeoCreator2.prototype.getFilledRegions = function(originRegionArr, mapName, nameMap, nameProperty) {
    var regionsArr = (originRegionArr || []).slice();
    var dataNameMap = createHashMap();
    for (var i = 0; i < regionsArr.length; i++) {
      dataNameMap.set(regionsArr[i].name, regionsArr[i]);
    }
    var source = geoSourceManager.load(mapName, nameMap, nameProperty);
    each$g(source.regions, function(region) {
      var name = region.name;
      !dataNameMap.get(name) && regionsArr.push({
        name
      });
    });
    return regionsArr;
  };
  return GeoCreator2;
}();
var geoCreator = new GeoCreator();
var geoCreator$1 = geoCreator;
var GeoModel = function(_super) {
  __extends(GeoModel2, _super);
  function GeoModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoModel2.type;
    return _this;
  }
  GeoModel2.prototype.init = function(option, parentModel, ecModel) {
    var source = geoSourceManager.getGeoResource(option.map);
    if (source && source.type === "geoJSON") {
      var itemStyle = option.itemStyle = option.itemStyle || {};
      if (!("color" in itemStyle)) {
        itemStyle.color = "#eee";
      }
    }
    this.mergeDefaultAndTheme(option, ecModel);
    defaultEmphasis(option, "label", ["show"]);
  };
  GeoModel2.prototype.optionUpdated = function() {
    var _this = this;
    var option = this.option;
    option.regions = geoCreator$1.getFilledRegions(option.regions, option.map, option.nameMap, option.nameProperty);
    var selectedMap = {};
    this._optionModelMap = reduce(option.regions || [], function(optionModelMap, regionOpt) {
      var regionName = regionOpt.name;
      if (regionName) {
        optionModelMap.set(regionName, new Model$1(regionOpt, _this, _this.ecModel));
        if (regionOpt.selected) {
          selectedMap[regionName] = true;
        }
      }
      return optionModelMap;
    }, createHashMap());
    if (!option.selectedMap) {
      option.selectedMap = selectedMap;
    }
  };
  GeoModel2.prototype.getRegionModel = function(name) {
    return this._optionModelMap.get(name) || new Model$1(null, this, this.ecModel);
  };
  GeoModel2.prototype.getFormattedLabel = function(name, status) {
    var regionModel = this.getRegionModel(name);
    var formatter = status === "normal" ? regionModel.get(["label", "formatter"]) : regionModel.get(["emphasis", "label", "formatter"]);
    var params = {
      name
    };
    if (isFunction(formatter)) {
      params.status = status;
      return formatter(params);
    } else if (isString$1(formatter)) {
      return formatter.replace("{a}", name != null ? name : "");
    }
  };
  GeoModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GeoModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GeoModel2.prototype.select = function(name) {
    var option = this.option;
    var selectedMode = option.selectedMode;
    if (!selectedMode) {
      return;
    }
    if (selectedMode !== "multiple") {
      option.selectedMap = null;
    }
    var selectedMap = option.selectedMap || (option.selectedMap = {});
    selectedMap[name] = true;
  };
  GeoModel2.prototype.unSelect = function(name) {
    var selectedMap = this.option.selectedMap;
    if (selectedMap) {
      selectedMap[name] = false;
    }
  };
  GeoModel2.prototype.toggleSelected = function(name) {
    this[this.isSelected(name) ? "unSelect" : "select"](name);
  };
  GeoModel2.prototype.isSelected = function(name) {
    var selectedMap = this.option.selectedMap;
    return !!(selectedMap && selectedMap[name]);
  };
  GeoModel2.type = "geo";
  GeoModel2.layoutMode = "box";
  GeoModel2.defaultOption = {
    z: 0,
    show: true,
    left: "center",
    top: "center",
    aspectScale: null,
    silent: false,
    map: "",
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    regions: []
  };
  return GeoModel2;
}(ComponentModel$1);
var GeoModel$1 = GeoModel;
function getCenterCoord(view, point) {
  return view.pointToProjected ? view.pointToProjected(point) : view.pointToData(point);
}
function updateCenterAndZoom(view, payload, zoomLimit) {
  var previousZoom = view.getZoom();
  var center2 = view.getCenter();
  var zoom = payload.zoom;
  var point = view.projectedToPoint ? view.projectedToPoint(center2) : view.dataToPoint(center2);
  if (payload.dx != null && payload.dy != null) {
    point[0] -= payload.dx;
    point[1] -= payload.dy;
    view.setCenter(getCenterCoord(view, point));
  }
  if (zoom != null) {
    if (zoomLimit) {
      var zoomMin = zoomLimit.min || 0;
      var zoomMax = zoomLimit.max || Infinity;
      zoom = Math.max(Math.min(previousZoom * zoom, zoomMax), zoomMin) / previousZoom;
    }
    view.scaleX *= zoom;
    view.scaleY *= zoom;
    var fixX = (payload.originX - view.x) * (zoom - 1);
    var fixY = (payload.originY - view.y) * (zoom - 1);
    view.x -= fixX;
    view.y -= fixY;
    view.updateTransform();
    view.setCenter(getCenterCoord(view, point));
    view.setZoom(zoom * previousZoom);
  }
  return {
    center: view.getCenter(),
    zoom: view.getZoom()
  };
}
var GeoView = function(_super) {
  __extends(GeoView2, _super);
  function GeoView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoView2.type;
    _this.focusBlurEnabled = true;
    return _this;
  }
  GeoView2.prototype.init = function(ecModel, api) {
    this._api = api;
  };
  GeoView2.prototype.render = function(geoModel, ecModel, api, payload) {
    this._model = geoModel;
    if (!geoModel.get("show")) {
      this._mapDraw && this._mapDraw.remove();
      this._mapDraw = null;
      return;
    }
    if (!this._mapDraw) {
      this._mapDraw = new MapDraw$1(api);
    }
    var mapDraw = this._mapDraw;
    mapDraw.draw(geoModel, ecModel, api, this, payload);
    mapDraw.group.on("click", this._handleRegionClick, this);
    mapDraw.group.silent = geoModel.get("silent");
    this.group.add(mapDraw.group);
    this.updateSelectStatus(geoModel, ecModel, api);
  };
  GeoView2.prototype._handleRegionClick = function(e2) {
    var eventData;
    findEventDispatcher(e2.target, function(current) {
      return (eventData = getECData(current).eventData) != null;
    }, true);
    if (eventData) {
      this._api.dispatchAction({
        type: "geoToggleSelect",
        geoId: this._model.id,
        name: eventData.name
      });
    }
  };
  GeoView2.prototype.updateSelectStatus = function(model, ecModel, api) {
    var _this = this;
    this._mapDraw.group.traverse(function(node) {
      var eventData = getECData(node).eventData;
      if (eventData) {
        _this._model.isSelected(eventData.name) ? api.enterSelect(node) : api.leaveSelect(node);
        return true;
      }
    });
  };
  GeoView2.prototype.findHighDownDispatchers = function(name) {
    return this._mapDraw && this._mapDraw.findHighDownDispatchers(name, this._model);
  };
  GeoView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
  };
  GeoView2.type = "geo";
  return GeoView2;
}(ComponentView$1);
var GeoView$1 = GeoView;
function registerMap(mapName, geoJson, specialAreas) {
  geoSourceManager.registerMap(mapName, geoJson, specialAreas);
}
function install$J(registers) {
  registers.registerCoordinateSystem("geo", geoCreator$1);
  registers.registerComponentModel(GeoModel$1);
  registers.registerComponentView(GeoView$1);
  registers.registerImpl("registerMap", registerMap);
  registers.registerImpl("getMap", function(mapName) {
    return geoSourceManager.getMapForUser(mapName);
  });
  function makeAction(method4, actionInfo2) {
    actionInfo2.update = "geo:updateSelectStatus";
    registers.registerAction(actionInfo2, function(payload, ecModel) {
      var selected = {};
      var allSelected = [];
      ecModel.eachComponent({
        mainType: "geo",
        query: payload
      }, function(geoModel) {
        geoModel[method4](payload.name);
        var geo = geoModel.coordinateSystem;
        each$g(geo.regions, function(region) {
          selected[region.name] = geoModel.isSelected(region.name) || false;
        });
        var names2 = [];
        each$g(selected, function(v4, name) {
          selected[name] && names2.push(name);
        });
        allSelected.push({
          geoIndex: geoModel.componentIndex,
          name: names2
        });
      });
      return {
        selected,
        allSelected,
        name: payload.name
      };
    });
  }
  makeAction("toggleSelected", {
    type: "geoToggleSelect",
    event: "geoselectchanged"
  });
  makeAction("select", {
    type: "geoSelect",
    event: "geoselected"
  });
  makeAction("unSelect", {
    type: "geoUnSelect",
    event: "geounselected"
  });
  registers.registerAction({
    type: "geoRoam",
    event: "geoRoam",
    update: "updateTransform"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      var geo = componentModel.coordinateSystem;
      if (geo.type !== "geo") {
        return;
      }
      var res = updateCenterAndZoom(geo, payload, componentModel.get("scaleLimit"));
      componentModel.setCenter && componentModel.setCenter(res.center);
      componentModel.setZoom && componentModel.setZoom(res.zoom);
      if (componentType === "series") {
        each$g(componentModel.seriesGroup, function(seriesModel) {
          seriesModel.setCenter(res.center);
          seriesModel.setZoom(res.zoom);
        });
      }
    });
  });
}
function install$I(registers) {
  use(install$J);
  registers.registerChartView(MapView$1);
  registers.registerSeriesModel(MapSeries$1);
  registers.registerLayout(mapSymbolLayout);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, mapDataStatistic);
  createLegacyDataSelectAction("map", registers.registerAction);
}
function init(inRoot) {
  var root2 = inRoot;
  root2.hierNode = {
    defaultAncestor: null,
    ancestor: root2,
    prelim: 0,
    modifier: 0,
    change: 0,
    shift: 0,
    i: 0,
    thread: null
  };
  var nodes = [root2];
  var node;
  var children;
  while (node = nodes.pop()) {
    children = node.children;
    if (node.isExpand && children.length) {
      var n2 = children.length;
      for (var i = n2 - 1; i >= 0; i--) {
        var child = children[i];
        child.hierNode = {
          defaultAncestor: null,
          ancestor: child,
          prelim: 0,
          modifier: 0,
          change: 0,
          shift: 0,
          i,
          thread: null
        };
        nodes.push(child);
      }
    }
  }
}
function firstWalk(node, separation2) {
  var children = node.isExpand ? node.children : [];
  var siblings = node.parentNode.children;
  var subtreeW = node.hierNode.i ? siblings[node.hierNode.i - 1] : null;
  if (children.length) {
    executeShifts(node);
    var midPoint = (children[0].hierNode.prelim + children[children.length - 1].hierNode.prelim) / 2;
    if (subtreeW) {
      node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
      node.hierNode.modifier = node.hierNode.prelim - midPoint;
    } else {
      node.hierNode.prelim = midPoint;
    }
  } else if (subtreeW) {
    node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
  }
  node.parentNode.hierNode.defaultAncestor = apportion(node, subtreeW, node.parentNode.hierNode.defaultAncestor || siblings[0], separation2);
}
function secondWalk(node) {
  var nodeX = node.hierNode.prelim + node.parentNode.hierNode.modifier;
  node.setLayout({
    x: nodeX
  }, true);
  node.hierNode.modifier += node.parentNode.hierNode.modifier;
}
function separation(cb2) {
  return arguments.length ? cb2 : defaultSeparation;
}
function radialCoordinate(rad, r2) {
  rad -= Math.PI / 2;
  return {
    x: r2 * Math.cos(rad),
    y: r2 * Math.sin(rad)
  };
}
function getViewRect$4(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function executeShifts(node) {
  var children = node.children;
  var n2 = children.length;
  var shift = 0;
  var change = 0;
  while (--n2 >= 0) {
    var child = children[n2];
    child.hierNode.prelim += shift;
    child.hierNode.modifier += shift;
    change += child.hierNode.change;
    shift += child.hierNode.shift + change;
  }
}
function apportion(subtreeV, subtreeW, ancestor, separation2) {
  if (subtreeW) {
    var nodeOutRight = subtreeV;
    var nodeInRight = subtreeV;
    var nodeOutLeft = nodeInRight.parentNode.children[0];
    var nodeInLeft = subtreeW;
    var sumOutRight = nodeOutRight.hierNode.modifier;
    var sumInRight = nodeInRight.hierNode.modifier;
    var sumOutLeft = nodeOutLeft.hierNode.modifier;
    var sumInLeft = nodeInLeft.hierNode.modifier;
    while (nodeInLeft = nextRight(nodeInLeft), nodeInRight = nextLeft(nodeInRight), nodeInLeft && nodeInRight) {
      nodeOutRight = nextRight(nodeOutRight);
      nodeOutLeft = nextLeft(nodeOutLeft);
      nodeOutRight.hierNode.ancestor = subtreeV;
      var shift = nodeInLeft.hierNode.prelim + sumInLeft - nodeInRight.hierNode.prelim - sumInRight + separation2(nodeInLeft, nodeInRight);
      if (shift > 0) {
        moveSubtree(nextAncestor(nodeInLeft, subtreeV, ancestor), subtreeV, shift);
        sumInRight += shift;
        sumOutRight += shift;
      }
      sumInLeft += nodeInLeft.hierNode.modifier;
      sumInRight += nodeInRight.hierNode.modifier;
      sumOutRight += nodeOutRight.hierNode.modifier;
      sumOutLeft += nodeOutLeft.hierNode.modifier;
    }
    if (nodeInLeft && !nextRight(nodeOutRight)) {
      nodeOutRight.hierNode.thread = nodeInLeft;
      nodeOutRight.hierNode.modifier += sumInLeft - sumOutRight;
    }
    if (nodeInRight && !nextLeft(nodeOutLeft)) {
      nodeOutLeft.hierNode.thread = nodeInRight;
      nodeOutLeft.hierNode.modifier += sumInRight - sumOutLeft;
      ancestor = subtreeV;
    }
  }
  return ancestor;
}
function nextRight(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[children.length - 1] : node.hierNode.thread;
}
function nextLeft(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[0] : node.hierNode.thread;
}
function nextAncestor(nodeInLeft, node, ancestor) {
  return nodeInLeft.hierNode.ancestor.parentNode === node.parentNode ? nodeInLeft.hierNode.ancestor : ancestor;
}
function moveSubtree(wl, wr, shift) {
  var change = shift / (wr.hierNode.i - wl.hierNode.i);
  wr.hierNode.change -= change;
  wr.hierNode.shift += shift;
  wr.hierNode.modifier += shift;
  wr.hierNode.prelim += shift;
  wl.hierNode.change += change;
}
function defaultSeparation(node1, node2) {
  return node1.parentNode === node2.parentNode ? 1 : 2;
}
var TreeEdgeShape = function() {
  function TreeEdgeShape2() {
    this.parentPoint = [];
    this.childPoints = [];
  }
  return TreeEdgeShape2;
}();
var TreePath = function(_super) {
  __extends(TreePath2, _super);
  function TreePath2(opts) {
    return _super.call(this, opts) || this;
  }
  TreePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  TreePath2.prototype.getDefaultShape = function() {
    return new TreeEdgeShape();
  };
  TreePath2.prototype.buildPath = function(ctx, shape) {
    var childPoints = shape.childPoints;
    var childLen = childPoints.length;
    var parentPoint = shape.parentPoint;
    var firstChildPos = childPoints[0];
    var lastChildPos = childPoints[childLen - 1];
    if (childLen === 1) {
      ctx.moveTo(parentPoint[0], parentPoint[1]);
      ctx.lineTo(firstChildPos[0], firstChildPos[1]);
      return;
    }
    var orient = shape.orient;
    var forkDim = orient === "TB" || orient === "BT" ? 0 : 1;
    var otherDim = 1 - forkDim;
    var forkPosition = parsePercent(shape.forkPosition, 1);
    var tmpPoint = [];
    tmpPoint[forkDim] = parentPoint[forkDim];
    tmpPoint[otherDim] = parentPoint[otherDim] + (lastChildPos[otherDim] - parentPoint[otherDim]) * forkPosition;
    ctx.moveTo(parentPoint[0], parentPoint[1]);
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.moveTo(firstChildPos[0], firstChildPos[1]);
    tmpPoint[forkDim] = firstChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    tmpPoint[forkDim] = lastChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.lineTo(lastChildPos[0], lastChildPos[1]);
    for (var i = 1; i < childLen - 1; i++) {
      var point = childPoints[i];
      ctx.moveTo(point[0], point[1]);
      tmpPoint[forkDim] = point[forkDim];
      ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    }
  };
  return TreePath2;
}(Path$1);
var TreeView = function(_super) {
  __extends(TreeView2, _super);
  function TreeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreeView2.type;
    _this._mainGroup = new Group$6();
    return _this;
  }
  TreeView2.prototype.init = function(ecModel, api) {
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: this.group
    };
    this.group.add(this._mainGroup);
  };
  TreeView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var layoutInfo = seriesModel.layoutInfo;
    var group = this._mainGroup;
    var layout2 = seriesModel.get("layout");
    if (layout2 === "radial") {
      group.x = layoutInfo.x + layoutInfo.width / 2;
      group.y = layoutInfo.y + layoutInfo.height / 2;
    } else {
      group.x = layoutInfo.x;
      group.y = layoutInfo.y;
    }
    this._updateViewCoordSys(seriesModel);
    this._updateController(seriesModel, ecModel, api);
    var oldData = this._data;
    data.diff(oldData).add(function(newIdx) {
      if (symbolNeedsDraw(data, newIdx)) {
        updateNode(data, newIdx, null, group, seriesModel);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!symbolNeedsDraw(data, newIdx)) {
        symbolEl && removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
        return;
      }
      updateNode(data, newIdx, symbolEl, group, seriesModel);
    }).remove(function(oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (symbolEl) {
        removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
      }
    }).execute();
    this._nodeScaleRatio = seriesModel.get("nodeScaleRatio");
    this._updateNodeAndLinkScale(seriesModel);
    if (seriesModel.get("expandAndCollapse") === true) {
      data.eachItemGraphicEl(function(el, dataIndex) {
        el.off("click").on("click", function() {
          api.dispatchAction({
            type: "treeExpandAndCollapse",
            seriesId: seriesModel.id,
            dataIndex
          });
        });
      });
    }
    this._data = data;
  };
  TreeView2.prototype._updateViewCoordSys = function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    data.each(function(idx) {
      var layout2 = data.getItemLayout(idx);
      if (layout2 && !isNaN(layout2.x) && !isNaN(layout2.y)) {
        points2.push([+layout2.x, +layout2.y]);
      }
    });
    var min3 = [];
    var max3 = [];
    fromPoints(points2, min3, max3);
    var oldMin = this._min;
    var oldMax = this._max;
    if (max3[0] - min3[0] === 0) {
      min3[0] = oldMin ? oldMin[0] : min3[0] - 1;
      max3[0] = oldMax ? oldMax[0] : max3[0] + 1;
    }
    if (max3[1] - min3[1] === 0) {
      min3[1] = oldMin ? oldMin[1] : min3[1] - 1;
      max3[1] = oldMax ? oldMax[1] : max3[1] + 1;
    }
    var viewCoordSys = seriesModel.coordinateSystem = new View$1();
    viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
    viewCoordSys.setBoundingRect(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    viewCoordSys.setCenter(seriesModel.get("center"));
    viewCoordSys.setZoom(seriesModel.get("zoom"));
    this.group.attr({
      x: viewCoordSys.x,
      y: viewCoordSys.y,
      scaleX: viewCoordSys.scaleX,
      scaleY: viewCoordSys.scaleY
    });
    this._min = min3;
    this._max = max3;
  };
  TreeView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale(seriesModel);
      api.updateLabelLayout();
    });
  };
  TreeView2.prototype._updateNodeAndLinkScale = function(seriesModel) {
    var data = seriesModel.getData();
    var nodeScale = this._getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el.setSymbolScale(nodeScale);
    });
  };
  TreeView2.prototype._getNodeGlobalScale = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type !== "view") {
      return 1;
    }
    var nodeScaleRatio = this._nodeScaleRatio;
    var groupZoom = coordSys.scaleX || 1;
    var roamZoom = coordSys.getZoom();
    var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
    return nodeScale / groupZoom;
  };
  TreeView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  TreeView2.prototype.remove = function() {
    this._mainGroup.removeAll();
    this._data = null;
  };
  TreeView2.type = "tree";
  return TreeView2;
}(ChartView$1);
function symbolNeedsDraw(data, dataIndex) {
  var layout2 = data.getItemLayout(dataIndex);
  return layout2 && !isNaN(layout2.x) && !isNaN(layout2.y);
}
function updateNode(data, dataIndex, symbolEl, group, seriesModel) {
  var isInit = !symbolEl;
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var itemModel = node.getModel();
  var visualColor = node.getVisual("style").fill;
  var symbolInnerColor = node.isExpand === false && node.children.length !== 0 ? visualColor : "#fff";
  var virtualRoot = data.tree.root;
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceLayout = source.getLayout();
  var sourceOldLayout = sourceSymbolEl ? {
    x: sourceSymbolEl.__oldX,
    y: sourceSymbolEl.__oldY,
    rawX: sourceSymbolEl.__radialOldRawX,
    rawY: sourceSymbolEl.__radialOldRawY
  } : sourceLayout;
  var targetLayout = node.getLayout();
  if (isInit) {
    symbolEl = new SymbolClz(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
    symbolEl.x = sourceOldLayout.x;
    symbolEl.y = sourceOldLayout.y;
  } else {
    symbolEl.updateData(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
  }
  symbolEl.__radialOldRawX = symbolEl.__radialRawX;
  symbolEl.__radialOldRawY = symbolEl.__radialRawY;
  symbolEl.__radialRawX = targetLayout.rawX;
  symbolEl.__radialRawY = targetLayout.rawY;
  group.add(symbolEl);
  data.setItemGraphicEl(dataIndex, symbolEl);
  symbolEl.__oldX = symbolEl.x;
  symbolEl.__oldY = symbolEl.y;
  updateProps$1(symbolEl, {
    x: targetLayout.x,
    y: targetLayout.y
  }, seriesModel);
  var symbolPath = symbolEl.getSymbolPath();
  if (seriesModel.get("layout") === "radial") {
    var realRoot = virtualRoot.children[0];
    var rootLayout = realRoot.getLayout();
    var length_1 = realRoot.children.length;
    var rad = void 0;
    var isLeft = void 0;
    if (targetLayout.x === rootLayout.x && node.isExpand === true) {
      var center2 = {
        x: (realRoot.children[0].getLayout().x + realRoot.children[length_1 - 1].getLayout().x) / 2,
        y: (realRoot.children[0].getLayout().y + realRoot.children[length_1 - 1].getLayout().y) / 2
      };
      rad = Math.atan2(center2.y - rootLayout.y, center2.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      isLeft = center2.x < rootLayout.x;
      if (isLeft) {
        rad = rad - Math.PI;
      }
    } else {
      rad = Math.atan2(targetLayout.y - rootLayout.y, targetLayout.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      if (node.children.length === 0 || node.children.length !== 0 && node.isExpand === false) {
        isLeft = targetLayout.x < rootLayout.x;
        if (isLeft) {
          rad = rad - Math.PI;
        }
      } else {
        isLeft = targetLayout.x > rootLayout.x;
        if (!isLeft) {
          rad = rad - Math.PI;
        }
      }
    }
    var textPosition = isLeft ? "left" : "right";
    var normalLabelModel = itemModel.getModel("label");
    var rotate2 = normalLabelModel.get("rotate");
    var labelRotateRadian = rotate2 * (Math.PI / 180);
    var textContent = symbolPath.getTextContent();
    if (textContent) {
      symbolPath.setTextConfig({
        position: normalLabelModel.get("position") || textPosition,
        rotation: rotate2 == null ? -rad : labelRotateRadian,
        origin: "center"
      });
      textContent.setStyle("verticalAlign", "middle");
    }
  }
  var focus = itemModel.get(["emphasis", "focus"]);
  var focusDataIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : null;
  if (focusDataIndices) {
    getECData(symbolEl).focus = focusDataIndices;
  }
  drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group);
  if (symbolEl.__edge) {
    symbolEl.onHoverStateChange = function(toState) {
      if (toState !== "blur") {
        var parentEl = node.parentNode && data.getItemGraphicEl(node.parentNode.dataIndex);
        if (!(parentEl && parentEl.hoverState === HOVER_STATE_BLUR)) {
          setStatesFlag(symbolEl.__edge, toState);
        }
      }
    };
  }
}
function drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group) {
  var itemModel = node.getModel();
  var edgeShape = seriesModel.get("edgeShape");
  var layout2 = seriesModel.get("layout");
  var orient = seriesModel.getOrient();
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  var edgeForkPosition = seriesModel.get("edgeForkPosition");
  var lineStyle = itemModel.getModel("lineStyle").getLineStyle();
  var edge = symbolEl.__edge;
  if (edgeShape === "curve") {
    if (node.parentNode && node.parentNode !== virtualRoot) {
      if (!edge) {
        edge = symbolEl.__edge = new BezierCurve$1({
          shape: getEdgeShape(layout2, orient, curvature, sourceOldLayout, sourceOldLayout)
        });
      }
      updateProps$1(edge, {
        shape: getEdgeShape(layout2, orient, curvature, sourceLayout, targetLayout)
      }, seriesModel);
    }
  } else if (edgeShape === "polyline") {
    if (layout2 === "orthogonal") {
      if (node !== virtualRoot && node.children && node.children.length !== 0 && node.isExpand === true) {
        var children = node.children;
        var childPoints = [];
        for (var i = 0; i < children.length; i++) {
          var childLayout = children[i].getLayout();
          childPoints.push([childLayout.x, childLayout.y]);
        }
        if (!edge) {
          edge = symbolEl.__edge = new TreePath({
            shape: {
              parentPoint: [targetLayout.x, targetLayout.y],
              childPoints: [[targetLayout.x, targetLayout.y]],
              orient,
              forkPosition: edgeForkPosition
            }
          });
        }
        updateProps$1(edge, {
          shape: {
            parentPoint: [targetLayout.x, targetLayout.y],
            childPoints
          }
        }, seriesModel);
      }
    }
  }
  if (edge) {
    edge.useStyle(defaults({
      strokeNoScale: true,
      fill: null
    }, lineStyle));
    setStatesStylesFromModel(edge, itemModel, "lineStyle");
    setDefaultStateProxy(edge);
    group.add(edge);
  }
}
function removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt) {
  var virtualRoot = data.tree.root;
  var _a2 = getSourceNode(virtualRoot, node), source = _a2.source, sourceLayout = _a2.sourceLayout;
  var symbolEl = data.getItemGraphicEl(node.dataIndex);
  if (!symbolEl) {
    return;
  }
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceEdge = sourceSymbolEl.__edge;
  var edge = symbolEl.__edge || (source.isExpand === false || source.children.length === 1 ? sourceEdge : void 0);
  var edgeShape = seriesModel.get("edgeShape");
  var layoutOpt = seriesModel.get("layout");
  var orient = seriesModel.get("orient");
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  if (edge) {
    if (edgeShape === "curve") {
      removeElement(edge, {
        shape: getEdgeShape(layoutOpt, orient, curvature, sourceLayout, sourceLayout),
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    } else if (edgeShape === "polyline" && seriesModel.get("layout") === "orthogonal") {
      removeElement(edge, {
        shape: {
          parentPoint: [sourceLayout.x, sourceLayout.y],
          childPoints: [[sourceLayout.x, sourceLayout.y]]
        },
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    }
  }
}
function getSourceNode(virtualRoot, node) {
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceLayout;
  while (sourceLayout = source.getLayout(), sourceLayout == null) {
    source = source.parentNode === virtualRoot ? source : source.parentNode || source;
  }
  return {
    source,
    sourceLayout
  };
}
function removeNode(data, dataIndex, symbolEl, group, seriesModel) {
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var virtualRoot = data.tree.root;
  var sourceLayout = getSourceNode(virtualRoot, node).sourceLayout;
  var removeAnimationOpt = {
    duration: seriesModel.get("animationDurationUpdate"),
    easing: seriesModel.get("animationEasingUpdate")
  };
  removeElement(symbolEl, {
    x: sourceLayout.x + 1,
    y: sourceLayout.y + 1
  }, seriesModel, {
    cb: function() {
      group.remove(symbolEl);
      data.setItemGraphicEl(dataIndex, null);
    },
    removeOpt: removeAnimationOpt
  });
  symbolEl.fadeOut(null, data.hostModel, {
    fadeLabel: true,
    animation: removeAnimationOpt
  });
  node.children.forEach(function(childNode) {
    removeNodeEdge(childNode, data, group, seriesModel, removeAnimationOpt);
  });
  removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt);
}
function getEdgeShape(layoutOpt, orient, curvature, sourceLayout, targetLayout) {
  var cpx1;
  var cpy1;
  var cpx2;
  var cpy2;
  var x1;
  var x2;
  var y1;
  var y2;
  if (layoutOpt === "radial") {
    x1 = sourceLayout.rawX;
    y1 = sourceLayout.rawY;
    x2 = targetLayout.rawX;
    y2 = targetLayout.rawY;
    var radialCoor1 = radialCoordinate(x1, y1);
    var radialCoor2 = radialCoordinate(x1, y1 + (y2 - y1) * curvature);
    var radialCoor3 = radialCoordinate(x2, y2 + (y1 - y2) * curvature);
    var radialCoor4 = radialCoordinate(x2, y2);
    return {
      x1: radialCoor1.x || 0,
      y1: radialCoor1.y || 0,
      x2: radialCoor4.x || 0,
      y2: radialCoor4.y || 0,
      cpx1: radialCoor2.x || 0,
      cpy1: radialCoor2.y || 0,
      cpx2: radialCoor3.x || 0,
      cpy2: radialCoor3.y || 0
    };
  } else {
    x1 = sourceLayout.x;
    y1 = sourceLayout.y;
    x2 = targetLayout.x;
    y2 = targetLayout.y;
    if (orient === "LR" || orient === "RL") {
      cpx1 = x1 + (x2 - x1) * curvature;
      cpy1 = y1;
      cpx2 = x2 + (x1 - x2) * curvature;
      cpy2 = y2;
    }
    if (orient === "TB" || orient === "BT") {
      cpx1 = x1;
      cpy1 = y1 + (y2 - y1) * curvature;
      cpx2 = x2;
      cpy2 = y2 + (y1 - y2) * curvature;
    }
  }
  return {
    x1,
    y1,
    x2,
    y2,
    cpx1,
    cpy1,
    cpx2,
    cpy2
  };
}
var TreeView$1 = TreeView;
var inner$e = makeInner();
function linkSeriesData(opt) {
  var mainData = opt.mainData;
  var datas = opt.datas;
  if (!datas) {
    datas = {
      main: mainData
    };
    opt.datasAttr = {
      main: "data"
    };
  }
  opt.datas = opt.mainData = null;
  linkAll(mainData, datas, opt);
  each$g(datas, function(data) {
    each$g(mainData.TRANSFERABLE_METHODS, function(methodName) {
      data.wrapMethod(methodName, curry$1(transferInjection, opt));
    });
  });
  mainData.wrapMethod("cloneShallow", curry$1(cloneShallowInjection, opt));
  each$g(mainData.CHANGABLE_METHODS, function(methodName) {
    mainData.wrapMethod(methodName, curry$1(changeInjection, opt));
  });
  assert(datas[mainData.dataType] === mainData);
}
function transferInjection(opt, res) {
  if (isMainData(this)) {
    var datas = extend({}, inner$e(this).datas);
    datas[this.dataType] = res;
    linkAll(res, datas, opt);
  } else {
    linkSingle(res, this.dataType, inner$e(this).mainData, opt);
  }
  return res;
}
function changeInjection(opt, res) {
  opt.struct && opt.struct.update();
  return res;
}
function cloneShallowInjection(opt, res) {
  each$g(inner$e(res).datas, function(data, dataType) {
    data !== res && linkSingle(data.cloneShallow(), dataType, res, opt);
  });
  return res;
}
function getLinkedData(dataType) {
  var mainData = inner$e(this).mainData;
  return dataType == null || mainData == null ? mainData : inner$e(mainData).datas[dataType];
}
function getLinkedDataAll() {
  var mainData = inner$e(this).mainData;
  return mainData == null ? [{
    data: mainData
  }] : map$1(keys(inner$e(mainData).datas), function(type4) {
    return {
      type: type4,
      data: inner$e(mainData).datas[type4]
    };
  });
}
function isMainData(data) {
  return inner$e(data).mainData === data;
}
function linkAll(mainData, datas, opt) {
  inner$e(mainData).datas = {};
  each$g(datas, function(data, dataType) {
    linkSingle(data, dataType, mainData, opt);
  });
}
function linkSingle(data, dataType, mainData, opt) {
  inner$e(mainData).datas[dataType] = data;
  inner$e(data).mainData = mainData;
  data.dataType = dataType;
  if (opt.struct) {
    data[opt.structAttr] = opt.struct;
    opt.struct[opt.datasAttr[dataType]] = data;
  }
  data.getLinkedData = getLinkedData;
  data.getLinkedDataAll = getLinkedDataAll;
}
var TreeNode = function() {
  function TreeNode2(name, hostTree) {
    this.depth = 0;
    this.height = 0;
    this.dataIndex = -1;
    this.children = [];
    this.viewChildren = [];
    this.isExpand = false;
    this.name = name || "";
    this.hostTree = hostTree;
  }
  TreeNode2.prototype.isRemoved = function() {
    return this.dataIndex < 0;
  };
  TreeNode2.prototype.eachNode = function(options, cb2, context) {
    if (isFunction(options)) {
      context = cb2;
      cb2 = options;
      options = null;
    }
    options = options || {};
    if (isString$1(options)) {
      options = {
        order: options
      };
    }
    var order = options.order || "preorder";
    var children = this[options.attr || "children"];
    var suppressVisitSub;
    order === "preorder" && (suppressVisitSub = cb2.call(context, this));
    for (var i = 0; !suppressVisitSub && i < children.length; i++) {
      children[i].eachNode(options, cb2, context);
    }
    order === "postorder" && cb2.call(context, this);
  };
  TreeNode2.prototype.updateDepthAndHeight = function(depth) {
    var height = 0;
    this.depth = depth;
    for (var i = 0; i < this.children.length; i++) {
      var child = this.children[i];
      child.updateDepthAndHeight(depth + 1);
      if (child.height > height) {
        height = child.height;
      }
    }
    this.height = height + 1;
  };
  TreeNode2.prototype.getNodeById = function(id2) {
    if (this.getId() === id2) {
      return this;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].getNodeById(id2);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.contains = function(node) {
    if (node === this) {
      return true;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].contains(node);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.getAncestors = function(includeSelf) {
    var ancestors = [];
    var node = includeSelf ? this : this.parentNode;
    while (node) {
      ancestors.push(node);
      node = node.parentNode;
    }
    ancestors.reverse();
    return ancestors;
  };
  TreeNode2.prototype.getAncestorsIndices = function() {
    var indices = [];
    var currNode = this;
    while (currNode) {
      indices.push(currNode.dataIndex);
      currNode = currNode.parentNode;
    }
    indices.reverse();
    return indices;
  };
  TreeNode2.prototype.getDescendantIndices = function() {
    var indices = [];
    this.eachNode(function(childNode) {
      indices.push(childNode.dataIndex);
    });
    return indices;
  };
  TreeNode2.prototype.getValue = function(dimension) {
    var data = this.hostTree.data;
    return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
  };
  TreeNode2.prototype.setLayout = function(layout2, merge3) {
    this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, layout2, merge3);
  };
  TreeNode2.prototype.getLayout = function() {
    return this.hostTree.data.getItemLayout(this.dataIndex);
  };
  TreeNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var hostTree = this.hostTree;
    var itemModel = hostTree.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  TreeNode2.prototype.getLevelModel = function() {
    return (this.hostTree.levelModels || [])[this.depth];
  };
  TreeNode2.prototype.setVisual = function(key, value) {
    this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, key, value);
  };
  TreeNode2.prototype.getVisual = function(key) {
    return this.hostTree.data.getItemVisual(this.dataIndex, key);
  };
  TreeNode2.prototype.getRawIndex = function() {
    return this.hostTree.data.getRawIndex(this.dataIndex);
  };
  TreeNode2.prototype.getId = function() {
    return this.hostTree.data.getId(this.dataIndex);
  };
  TreeNode2.prototype.getChildIndex = function() {
    if (this.parentNode) {
      var children = this.parentNode.children;
      for (var i = 0; i < children.length; ++i) {
        if (children[i] === this) {
          return i;
        }
      }
      return -1;
    }
    return -1;
  };
  TreeNode2.prototype.isAncestorOf = function(node) {
    var parent = node.parentNode;
    while (parent) {
      if (parent === this) {
        return true;
      }
      parent = parent.parentNode;
    }
    return false;
  };
  TreeNode2.prototype.isDescendantOf = function(node) {
    return node !== this && node.isAncestorOf(this);
  };
  return TreeNode2;
}();
var Tree = function() {
  function Tree2(hostModel) {
    this.type = "tree";
    this._nodes = [];
    this.hostModel = hostModel;
  }
  Tree2.prototype.eachNode = function(options, cb2, context) {
    this.root.eachNode(options, cb2, context);
  };
  Tree2.prototype.getNodeByDataIndex = function(dataIndex) {
    var rawIndex = this.data.getRawIndex(dataIndex);
    return this._nodes[rawIndex];
  };
  Tree2.prototype.getNodeById = function(name) {
    return this.root.getNodeById(name);
  };
  Tree2.prototype.update = function() {
    var data = this.data;
    var nodes = this._nodes;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
  };
  Tree2.prototype.clearLayouts = function() {
    this.data.clearItemLayouts();
  };
  Tree2.createTree = function(dataRoot, hostModel, beforeLink) {
    var tree = new Tree2(hostModel);
    var listData = [];
    var dimMax = 1;
    buildHierarchy(dataRoot);
    function buildHierarchy(dataNode, parentNode2) {
      var value = dataNode.value;
      dimMax = Math.max(dimMax, isArray$1(value) ? value.length : 1);
      listData.push(dataNode);
      var node = new TreeNode(convertOptionIdName(dataNode.name, ""), tree);
      parentNode2 ? addChild(node, parentNode2) : tree.root = node;
      tree._nodes.push(node);
      var children = dataNode.children;
      if (children) {
        for (var i = 0; i < children.length; i++) {
          buildHierarchy(children[i], node);
        }
      }
    }
    tree.root.updateDepthAndHeight(0);
    var dimensions = prepareSeriesDataSchema(listData, {
      coordDimensions: ["value"],
      dimensionsCount: dimMax
    }).dimensions;
    var list = new SeriesData$1(dimensions, hostModel);
    list.initData(listData);
    beforeLink && beforeLink(list);
    linkSeriesData({
      mainData: list,
      struct: tree,
      structAttr: "tree"
    });
    tree.update();
    return tree;
  };
  return Tree2;
}();
function addChild(child, node) {
  var children = node.children;
  if (child.parentNode === node) {
    return;
  }
  children.push(child);
  child.parentNode = node;
}
var Tree$1 = Tree;
function retrieveTargetInfo(payload, validPayloadTypes, seriesModel) {
  if (payload && indexOf(validPayloadTypes, payload.type) >= 0) {
    var root2 = seriesModel.getData().tree.root;
    var targetNode = payload.targetNode;
    if (isString$1(targetNode)) {
      targetNode = root2.getNodeById(targetNode);
    }
    if (targetNode && root2.contains(targetNode)) {
      return {
        node: targetNode
      };
    }
    var targetNodeId = payload.targetNodeId;
    if (targetNodeId != null && (targetNode = root2.getNodeById(targetNodeId))) {
      return {
        node: targetNode
      };
    }
  }
}
function getPathToRoot(node) {
  var path = [];
  while (node) {
    node = node.parentNode;
    node && path.push(node);
  }
  return path.reverse();
}
function aboveViewRoot(viewRoot, node) {
  var viewPath = getPathToRoot(viewRoot);
  return indexOf(viewPath, node) >= 0;
}
function wrapTreePathInfo(node, seriesModel) {
  var treePathInfo = [];
  while (node) {
    var nodeDataIndex = node.dataIndex;
    treePathInfo.push({
      name: node.name,
      dataIndex: nodeDataIndex,
      value: seriesModel.getRawValue(nodeDataIndex)
    });
    node = node.parentNode;
  }
  treePathInfo.reverse();
  return treePathInfo;
}
var TreeSeriesModel = function(_super) {
  __extends(TreeSeriesModel2, _super);
  function TreeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.hasSymbolVisual = true;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  TreeSeriesModel2.prototype.getInitialData = function(option) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    var leaves = option.leaves || {};
    var leavesModel = new Model$1(leaves, this, this.ecModel);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        if (!(node && node.children.length && node.isExpand)) {
          model.parentModel = leavesModel;
        }
        return model;
      });
    }
    var treeDepth = 0;
    tree.eachNode("preorder", function(node) {
      if (node.depth > treeDepth) {
        treeDepth = node.depth;
      }
    });
    var expandAndCollapse = option.expandAndCollapse;
    var expandTreeDepth = expandAndCollapse && option.initialTreeDepth >= 0 ? option.initialTreeDepth : treeDepth;
    tree.root.eachNode("preorder", function(node) {
      var item = node.hostTree.data.getRawDataItem(node.dataIndex);
      node.isExpand = item && item.collapsed != null ? !item.collapsed : node.depth <= expandTreeDepth;
    });
    return tree.data;
  };
  TreeSeriesModel2.prototype.getOrient = function() {
    var orient = this.get("orient");
    if (orient === "horizontal") {
      orient = "LR";
    } else if (orient === "vertical") {
      orient = "TB";
    }
    return orient;
  };
  TreeSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  TreeSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  TreeSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var tree = this.getData().tree;
    var realRoot = tree.root.children[0];
    var node = tree.getNodeByDataIndex(dataIndex);
    var value = node.getValue();
    var name = node.name;
    while (node && node !== realRoot) {
      name = node.parentNode.name + "." + name;
      node = node.parentNode;
    }
    return createTooltipMarkup("nameValue", {
      name,
      value,
      noValue: isNaN(value) || value == null
    });
  };
  TreeSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    return params;
  };
  TreeSeriesModel2.type = "series.tree";
  TreeSeriesModel2.layoutMode = "box";
  TreeSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "12%",
    top: "12%",
    right: "12%",
    bottom: "12%",
    layout: "orthogonal",
    edgeShape: "curve",
    edgeForkPosition: "50%",
    roam: false,
    nodeScaleRatio: 0.4,
    center: null,
    zoom: 1,
    orient: "LR",
    symbol: "emptyCircle",
    symbolSize: 7,
    expandAndCollapse: true,
    initialTreeDepth: 2,
    lineStyle: {
      color: "#ccc",
      width: 1.5,
      curveness: 0.5
    },
    itemStyle: {
      color: "lightsteelblue",
      borderWidth: 1.5
    },
    label: {
      show: true
    },
    animationEasing: "linear",
    animationDuration: 700,
    animationDurationUpdate: 500
  };
  return TreeSeriesModel2;
}(SeriesModel$1);
var TreeSeriesModel$1 = TreeSeriesModel;
function eachAfter(root2, callback, separation2) {
  var nodes = [root2];
  var next = [];
  var node;
  while (node = nodes.pop()) {
    next.push(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = 0; i < children.length; i++) {
          nodes.push(children[i]);
        }
      }
    }
  }
  while (node = next.pop()) {
    callback(node, separation2);
  }
}
function eachBefore(root2, callback) {
  var nodes = [root2];
  var node;
  while (node = nodes.pop()) {
    callback(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = children.length - 1; i >= 0; i--) {
          nodes.push(children[i]);
        }
      }
    }
  }
}
function treeLayout(ecModel, api) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    commonLayout(seriesModel, api);
  });
}
function commonLayout(seriesModel, api) {
  var layoutInfo = getViewRect$4(seriesModel, api);
  seriesModel.layoutInfo = layoutInfo;
  var layout2 = seriesModel.get("layout");
  var width = 0;
  var height = 0;
  var separation$1 = null;
  if (layout2 === "radial") {
    width = 2 * Math.PI;
    height = Math.min(layoutInfo.height, layoutInfo.width) / 2;
    separation$1 = separation(function(node1, node2) {
      return (node1.parentNode === node2.parentNode ? 1 : 2) / node1.depth;
    });
  } else {
    width = layoutInfo.width;
    height = layoutInfo.height;
    separation$1 = separation();
  }
  var virtualRoot = seriesModel.getData().tree.root;
  var realRoot = virtualRoot.children[0];
  if (realRoot) {
    init(virtualRoot);
    eachAfter(realRoot, firstWalk, separation$1);
    virtualRoot.hierNode.modifier = -realRoot.hierNode.prelim;
    eachBefore(realRoot, secondWalk);
    var left_1 = realRoot;
    var right_1 = realRoot;
    var bottom_1 = realRoot;
    eachBefore(realRoot, function(node) {
      var x2 = node.getLayout().x;
      if (x2 < left_1.getLayout().x) {
        left_1 = node;
      }
      if (x2 > right_1.getLayout().x) {
        right_1 = node;
      }
      if (node.depth > bottom_1.depth) {
        bottom_1 = node;
      }
    });
    var delta = left_1 === right_1 ? 1 : separation$1(left_1, right_1) / 2;
    var tx_1 = delta - left_1.getLayout().x;
    var kx_1 = 0;
    var ky_1 = 0;
    var coorX_1 = 0;
    var coorY_1 = 0;
    if (layout2 === "radial") {
      kx_1 = width / (right_1.getLayout().x + delta + tx_1);
      ky_1 = height / (bottom_1.depth - 1 || 1);
      eachBefore(realRoot, function(node) {
        coorX_1 = (node.getLayout().x + tx_1) * kx_1;
        coorY_1 = (node.depth - 1) * ky_1;
        var finalCoor = radialCoordinate(coorX_1, coorY_1);
        node.setLayout({
          x: finalCoor.x,
          y: finalCoor.y,
          rawX: coorX_1,
          rawY: coorY_1
        }, true);
      });
    } else {
      var orient_1 = seriesModel.getOrient();
      if (orient_1 === "RL" || orient_1 === "LR") {
        ky_1 = height / (right_1.getLayout().x + delta + tx_1);
        kx_1 = width / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorY_1 = (node.getLayout().x + tx_1) * ky_1;
          coorX_1 = orient_1 === "LR" ? (node.depth - 1) * kx_1 : width - (node.depth - 1) * kx_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      } else if (orient_1 === "TB" || orient_1 === "BT") {
        kx_1 = width / (right_1.getLayout().x + delta + tx_1);
        ky_1 = height / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorX_1 = (node.getLayout().x + tx_1) * kx_1;
          coorY_1 = orient_1 === "TB" ? (node.depth - 1) * ky_1 : height - (node.depth - 1) * ky_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      }
    }
  }
}
function treeVisual(ecModel) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style2 = model.getModel("itemStyle").getItemStyle();
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style2);
    });
  });
}
function installTreeAction(registers) {
  registers.registerAction({
    type: "treeExpandAndCollapse",
    event: "treeExpandAndCollapse",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var dataIndex = payload.dataIndex;
      var tree = seriesModel.getData().tree;
      var node = tree.getNodeByDataIndex(dataIndex);
      node.isExpand = !node.isExpand;
    });
  });
  registers.registerAction({
    type: "treeRoam",
    event: "treeRoam",
    update: "none"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
function install$H(registers) {
  registers.registerChartView(TreeView$1);
  registers.registerSeriesModel(TreeSeriesModel$1);
  registers.registerLayout(treeLayout);
  registers.registerVisual(treeVisual);
  installTreeAction(registers);
}
var actionTypes = ["treemapZoomToNode", "treemapRender", "treemapMove"];
function installTreemapAction(registers) {
  for (var i = 0; i < actionTypes.length; i++) {
    registers.registerAction({
      type: actionTypes[i],
      update: "updateView"
    }, noop$1);
  }
  registers.registerAction({
    type: "treemapRootToNode",
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "treemap",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var types2 = ["treemapZoomToNode", "treemapRootToNode"];
      var targetInfo = retrieveTargetInfo(payload, types2, model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
}
function enableAriaDecalForTree(seriesModel) {
  var data = seriesModel.getData();
  var tree = data.tree;
  var decalPaletteScope2 = {};
  tree.eachNode(function(node) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var decal = getDecalFromPalette(seriesModel.ecModel, current.name || current.dataIndex + "", decalPaletteScope2);
    node.setVisual("decal", decal);
  });
}
var TreemapSeriesModel = function(_super) {
  __extends(TreemapSeriesModel2, _super);
  function TreemapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapSeriesModel2.type;
    _this.preventUsingHoverLayer = true;
    return _this;
  }
  TreemapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue$1(root2);
    var levels = option.levels || [];
    var designatedVisualItemStyle = this.designatedVisualItemStyle = {};
    var designatedVisualModel = new Model$1({
      itemStyle: designatedVisualItemStyle
    }, this, ecModel);
    levels = option.levels = setDefault(levels, ecModel);
    var levelModels = map$1(levels || [], function(levelDefine) {
      return new Model$1(levelDefine, designatedVisualModel, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = node ? levelModels[node.depth] : null;
        model.parentModel = levelModel || designatedVisualModel;
        return model;
      });
    }
    return tree.data;
  };
  TreemapSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  TreemapSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  TreemapSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    params.treePathInfo = params.treeAncestors;
    return params;
  };
  TreemapSeriesModel2.prototype.setLayoutInfo = function(layoutInfo) {
    this.layoutInfo = this.layoutInfo || {};
    extend(this.layoutInfo, layoutInfo);
  };
  TreemapSeriesModel2.prototype.mapIdToIndex = function(id2) {
    var idIndexMap = this._idIndexMap;
    if (!idIndexMap) {
      idIndexMap = this._idIndexMap = createHashMap();
      this._idIndexMapCount = 0;
    }
    var index2 = idIndexMap.get(id2);
    if (index2 == null) {
      idIndexMap.set(id2, index2 = this._idIndexMapCount++);
    }
    return index2;
  };
  TreemapSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  TreemapSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  TreemapSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  TreemapSeriesModel2.type = "series.treemap";
  TreemapSeriesModel2.layoutMode = "box";
  TreemapSeriesModel2.defaultOption = {
    progressive: 0,
    left: "center",
    top: "middle",
    width: "80%",
    height: "80%",
    sort: true,
    clipWindow: "origin",
    squareRatio: 0.5 * (1 + Math.sqrt(5)),
    leafDepth: null,
    drillDownIcon: "\u25B6",
    zoomToNodeRatio: 0.32 * 0.32,
    roam: true,
    nodeClick: "zoomToNode",
    animation: true,
    animationDurationUpdate: 900,
    animationEasing: "quinticInOut",
    breadcrumb: {
      show: true,
      height: 22,
      left: "center",
      top: "bottom",
      emptyItemWidth: 25,
      itemStyle: {
        color: "rgba(0,0,0,0.7)",
        textStyle: {
          color: "#fff"
        }
      }
    },
    label: {
      show: true,
      distance: 0,
      padding: 5,
      position: "inside",
      color: "#fff",
      overflow: "truncate"
    },
    upperLabel: {
      show: false,
      position: [0, "50%"],
      height: 20,
      overflow: "truncate",
      verticalAlign: "middle"
    },
    itemStyle: {
      color: null,
      colorAlpha: null,
      colorSaturation: null,
      borderWidth: 0,
      gapWidth: 0,
      borderColor: "#fff",
      borderColorSaturation: null
    },
    emphasis: {
      upperLabel: {
        show: true,
        position: [0, "50%"],
        overflow: "truncate",
        verticalAlign: "middle"
      }
    },
    visualDimension: 0,
    visualMin: null,
    visualMax: null,
    color: [],
    colorAlpha: null,
    colorSaturation: null,
    colorMappingBy: "index",
    visibleMin: 10,
    childrenVisibleMin: null,
    levels: []
  };
  return TreemapSeriesModel2;
}(SeriesModel$1);
function completeTreeValue$1(dataNode) {
  var sum2 = 0;
  each$g(dataNode.children, function(child) {
    completeTreeValue$1(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
function setDefault(levels, ecModel) {
  var globalColorList = normalizeToArray(ecModel.get("color"));
  var globalDecalList = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  if (!globalColorList) {
    return;
  }
  levels = levels || [];
  var hasColorDefine;
  var hasDecalDefine;
  each$g(levels, function(levelDefine) {
    var model = new Model$1(levelDefine);
    var modelColor = model.get("color");
    var modelDecal = model.get("decal");
    if (model.get(["itemStyle", "color"]) || modelColor && modelColor !== "none") {
      hasColorDefine = true;
    }
    if (model.get(["itemStyle", "decal"]) || modelDecal && modelDecal !== "none") {
      hasDecalDefine = true;
    }
  });
  var level0 = levels[0] || (levels[0] = {});
  if (!hasColorDefine) {
    level0.color = globalColorList.slice();
  }
  if (!hasDecalDefine && globalDecalList) {
    level0.decal = globalDecalList.slice();
  }
  return levels;
}
var TreemapSeriesModel$1 = TreemapSeriesModel;
var TEXT_PADDING = 8;
var ITEM_GAP = 8;
var ARRAY_LENGTH = 5;
var Breadcrumb = function() {
  function Breadcrumb2(containerGroup) {
    this.group = new Group$6();
    containerGroup.add(this.group);
  }
  Breadcrumb2.prototype.render = function(seriesModel, api, targetNode, onSelect) {
    var model = seriesModel.getModel("breadcrumb");
    var thisGroup = this.group;
    thisGroup.removeAll();
    if (!model.get("show") || !targetNode) {
      return;
    }
    var normalStyleModel = model.getModel("itemStyle");
    var textStyleModel = normalStyleModel.getModel("textStyle");
    var layoutParam = {
      pos: {
        left: model.get("left"),
        right: model.get("right"),
        top: model.get("top"),
        bottom: model.get("bottom")
      },
      box: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      emptyItemWidth: model.get("emptyItemWidth"),
      totalWidth: 0,
      renderList: []
    };
    this._prepare(targetNode, layoutParam, textStyleModel);
    this._renderContent(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect);
    positionElement(thisGroup, layoutParam.pos, layoutParam.box);
  };
  Breadcrumb2.prototype._prepare = function(targetNode, layoutParam, textStyleModel) {
    for (var node = targetNode; node; node = node.parentNode) {
      var text = convertOptionIdName(node.getModel().get("name"), "");
      var textRect = textStyleModel.getTextRect(text);
      var itemWidth = Math.max(textRect.width + TEXT_PADDING * 2, layoutParam.emptyItemWidth);
      layoutParam.totalWidth += itemWidth + ITEM_GAP;
      layoutParam.renderList.push({
        node,
        text,
        width: itemWidth
      });
    }
  };
  Breadcrumb2.prototype._renderContent = function(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect) {
    var lastX = 0;
    var emptyItemWidth = layoutParam.emptyItemWidth;
    var height = seriesModel.get(["breadcrumb", "height"]);
    var availableSize = getAvailableSize(layoutParam.pos, layoutParam.box);
    var totalWidth = layoutParam.totalWidth;
    var renderList = layoutParam.renderList;
    for (var i = renderList.length - 1; i >= 0; i--) {
      var item = renderList[i];
      var itemNode = item.node;
      var itemWidth = item.width;
      var text = item.text;
      if (totalWidth > availableSize.width) {
        totalWidth -= itemWidth - emptyItemWidth;
        itemWidth = emptyItemWidth;
        text = null;
      }
      var el = new Polygon$1({
        shape: {
          points: makeItemPoints(lastX, 0, itemWidth, height, i === renderList.length - 1, i === 0)
        },
        style: defaults(normalStyleModel.getItemStyle(), {
          lineJoin: "bevel"
        }),
        textContent: new ZRText$1({
          style: {
            text,
            fill: textStyleModel.getTextColor(),
            font: textStyleModel.getFont()
          }
        }),
        textConfig: {
          position: "inside"
        },
        z2: Z2_EMPHASIS_LIFT * 1e4,
        onclick: curry$1(onSelect, itemNode)
      });
      el.disableLabelAnimation = true;
      this.group.add(el);
      packEventData(el, seriesModel, itemNode);
      lastX += itemWidth + ITEM_GAP;
    }
  };
  Breadcrumb2.prototype.remove = function() {
    this.group.removeAll();
  };
  return Breadcrumb2;
}();
function makeItemPoints(x2, y2, itemWidth, itemHeight, head, tail) {
  var points2 = [[head ? x2 : x2 - ARRAY_LENGTH, y2], [x2 + itemWidth, y2], [x2 + itemWidth, y2 + itemHeight], [head ? x2 : x2 - ARRAY_LENGTH, y2 + itemHeight]];
  !tail && points2.splice(2, 0, [x2 + itemWidth + ARRAY_LENGTH, y2 + itemHeight / 2]);
  !head && points2.push([x2, y2 + itemHeight / 2]);
  return points2;
}
function packEventData(el, seriesModel, itemNode) {
  getECData(el).eventData = {
    componentType: "series",
    componentSubType: "treemap",
    componentIndex: seriesModel.componentIndex,
    seriesIndex: seriesModel.seriesIndex,
    seriesName: seriesModel.name,
    seriesType: "treemap",
    selfType: "breadcrumb",
    nodeData: {
      dataIndex: itemNode && itemNode.dataIndex,
      name: itemNode && itemNode.name
    },
    treePathInfo: itemNode && wrapTreePathInfo(itemNode, seriesModel)
  };
}
var Breadcrumb$1 = Breadcrumb;
var AnimationWrap = function() {
  function AnimationWrap2() {
    this._storage = [];
    this._elExistsMap = {};
  }
  AnimationWrap2.prototype.add = function(el, target, duration, delay, easing) {
    if (this._elExistsMap[el.id]) {
      return false;
    }
    this._elExistsMap[el.id] = true;
    this._storage.push({
      el,
      target,
      duration,
      delay,
      easing
    });
    return true;
  };
  AnimationWrap2.prototype.finished = function(callback) {
    this._finishedCallback = callback;
    return this;
  };
  AnimationWrap2.prototype.start = function() {
    var _this = this;
    var count2 = this._storage.length;
    var checkTerminate = function() {
      count2--;
      if (count2 <= 0) {
        _this._storage.length = 0;
        _this._elExistsMap = {};
        _this._finishedCallback && _this._finishedCallback();
      }
    };
    for (var i = 0, len2 = this._storage.length; i < len2; i++) {
      var item = this._storage[i];
      item.el.animateTo(item.target, {
        duration: item.duration,
        delay: item.delay,
        easing: item.easing,
        setToFinal: true,
        done: checkTerminate,
        aborted: checkTerminate
      });
    }
    return this;
  };
  return AnimationWrap2;
}();
function createWrap() {
  return new AnimationWrap();
}
var Group$4 = Group$6;
var Rect$1 = Rect$3;
var DRAG_THRESHOLD = 3;
var PATH_LABEL_NOAMAL = "label";
var PATH_UPPERLABEL_NORMAL = "upperLabel";
var Z2_BASE = Z2_EMPHASIS_LIFT * 10;
var Z2_BG = Z2_EMPHASIS_LIFT * 2;
var Z2_CONTENT = Z2_EMPHASIS_LIFT * 3;
var getStateItemStyle = makeStyleMapper([
  ["fill", "color"],
  ["stroke", "strokeColor"],
  ["lineWidth", "strokeWidth"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"]
]);
var getItemStyleNormal = function(model) {
  var itemStyle = getStateItemStyle(model);
  itemStyle.stroke = itemStyle.fill = itemStyle.lineWidth = null;
  return itemStyle;
};
var inner$d = makeInner();
var TreemapView = function(_super) {
  __extends(TreemapView2, _super);
  function TreemapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapView2.type;
    _this._state = "ready";
    _this._storage = createStorage();
    return _this;
  }
  TreemapView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var models = ecModel.findComponents({
      mainType: "series",
      subType: "treemap",
      query: payload
    });
    if (indexOf(models, seriesModel) < 0) {
      return;
    }
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var payloadType = payload && payload.type;
    var layoutInfo = seriesModel.layoutInfo;
    var isInit = !this._oldTree;
    var thisStorage = this._storage;
    var reRoot = payloadType === "treemapRootToNode" && targetInfo && thisStorage ? {
      rootNodeGroup: thisStorage.nodeGroup[targetInfo.node.getRawIndex()],
      direction: payload.direction
    } : null;
    var containerGroup = this._giveContainerGroup(layoutInfo);
    var hasAnimation = seriesModel.get("animation");
    var renderResult = this._doRender(containerGroup, seriesModel, reRoot);
    hasAnimation && !isInit && (!payloadType || payloadType === "treemapZoomToNode" || payloadType === "treemapRootToNode") ? this._doAnimation(containerGroup, renderResult, seriesModel, reRoot) : renderResult.renderFinally();
    this._resetController(api);
    this._renderBreadcrumb(seriesModel, api, targetInfo);
  };
  TreemapView2.prototype._giveContainerGroup = function(layoutInfo) {
    var containerGroup = this._containerGroup;
    if (!containerGroup) {
      containerGroup = this._containerGroup = new Group$4();
      this._initEvents(containerGroup);
      this.group.add(containerGroup);
    }
    containerGroup.x = layoutInfo.x;
    containerGroup.y = layoutInfo.y;
    return containerGroup;
  };
  TreemapView2.prototype._doRender = function(containerGroup, seriesModel, reRoot) {
    var thisTree = seriesModel.getData().tree;
    var oldTree = this._oldTree;
    var lastsForAnimation = createStorage();
    var thisStorage = createStorage();
    var oldStorage = this._storage;
    var willInvisibleEls = [];
    function doRenderNode(thisNode, oldNode, parentGroup, depth) {
      return renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth);
    }
    dualTravel(thisTree.root ? [thisTree.root] : [], oldTree && oldTree.root ? [oldTree.root] : [], containerGroup, thisTree === oldTree || !oldTree, 0);
    var willDeleteEls = clearStorage(oldStorage);
    this._oldTree = thisTree;
    this._storage = thisStorage;
    return {
      lastsForAnimation,
      willDeleteEls,
      renderFinally
    };
    function dualTravel(thisViewChildren, oldViewChildren, parentGroup, sameTree, depth) {
      if (sameTree) {
        oldViewChildren = thisViewChildren;
        each$g(thisViewChildren, function(child, index2) {
          !child.isRemoved() && processNode(index2, index2);
        });
      } else {
        new DataDiffer$1(oldViewChildren, thisViewChildren, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      }
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIndex, oldIndex) {
        var thisNode = newIndex != null ? thisViewChildren[newIndex] : null;
        var oldNode = oldIndex != null ? oldViewChildren[oldIndex] : null;
        var group = doRenderNode(thisNode, oldNode, parentGroup, depth);
        group && dualTravel(thisNode && thisNode.viewChildren || [], oldNode && oldNode.viewChildren || [], group, sameTree, depth + 1);
      }
    }
    function clearStorage(storage2) {
      var willDeleteEls2 = createStorage();
      storage2 && each$g(storage2, function(store, storageName) {
        var delEls = willDeleteEls2[storageName];
        each$g(store, function(el) {
          el && (delEls.push(el), inner$d(el).willDelete = true);
        });
      });
      return willDeleteEls2;
    }
    function renderFinally() {
      each$g(willDeleteEls, function(els) {
        each$g(els, function(el) {
          el.parent && el.parent.remove(el);
        });
      });
      each$g(willInvisibleEls, function(el) {
        el.invisible = true;
        el.dirty();
      });
    }
  };
  TreemapView2.prototype._doAnimation = function(containerGroup, renderResult, seriesModel, reRoot) {
    var durationOption = seriesModel.get("animationDurationUpdate");
    var easingOption = seriesModel.get("animationEasing");
    var duration = (isFunction(durationOption) ? 0 : durationOption) || 0;
    var easing = (isFunction(easingOption) ? null : easingOption) || "cubicOut";
    var animationWrap = createWrap();
    each$g(renderResult.willDeleteEls, function(store, storageName) {
      each$g(store, function(el, rawIndex) {
        if (el.invisible) {
          return;
        }
        var parent = el.parent;
        var target;
        var innerStore = inner$d(parent);
        if (reRoot && reRoot.direction === "drillDown") {
          target = parent === reRoot.rootNodeGroup ? {
            shape: {
              x: 0,
              y: 0,
              width: innerStore.nodeWidth,
              height: innerStore.nodeHeight
            },
            style: {
              opacity: 0
            }
          } : {
            style: {
              opacity: 0
            }
          };
        } else {
          var targetX = 0;
          var targetY = 0;
          if (!innerStore.willDelete) {
            targetX = innerStore.nodeWidth / 2;
            targetY = innerStore.nodeHeight / 2;
          }
          target = storageName === "nodeGroup" ? {
            x: targetX,
            y: targetY,
            style: {
              opacity: 0
            }
          } : {
            shape: {
              x: targetX,
              y: targetY,
              width: 0,
              height: 0
            },
            style: {
              opacity: 0
            }
          };
        }
        target && animationWrap.add(el, target, duration, 0, easing);
      });
    });
    each$g(this._storage, function(store, storageName) {
      each$g(store, function(el, rawIndex) {
        var last = renderResult.lastsForAnimation[storageName][rawIndex];
        var target = {};
        if (!last) {
          return;
        }
        if (el instanceof Group$6) {
          if (last.oldX != null) {
            target.x = el.x;
            target.y = el.y;
            el.x = last.oldX;
            el.y = last.oldY;
          }
        } else {
          if (last.oldShape) {
            target.shape = extend({}, el.shape);
            el.setShape(last.oldShape);
          }
          if (last.fadein) {
            el.setStyle("opacity", 0);
            target.style = {
              opacity: 1
            };
          } else if (el.style.opacity !== 1) {
            target.style = {
              opacity: 1
            };
          }
        }
        animationWrap.add(el, target, duration, 0, easing);
      });
    }, this);
    this._state = "animating";
    animationWrap.finished(bind$1(function() {
      this._state = "ready";
      renderResult.renderFinally();
    }, this)).start();
  };
  TreemapView2.prototype._resetController = function(api) {
    var controller = this._controller;
    if (!controller) {
      controller = this._controller = new RoamController$1(api.getZr());
      controller.enable(this.seriesModel.get("roam"));
      controller.on("pan", bind$1(this._onPan, this));
      controller.on("zoom", bind$1(this._onZoom, this));
    }
    var rect = new BoundingRect$1(0, 0, api.getWidth(), api.getHeight());
    controller.setPointerChecker(function(e2, x2, y2) {
      return rect.contain(x2, y2);
    });
  };
  TreemapView2.prototype._clearController = function() {
    var controller = this._controller;
    if (controller) {
      controller.dispose();
      controller = null;
    }
  };
  TreemapView2.prototype._onPan = function(e2) {
    if (this._state !== "animating" && (Math.abs(e2.dx) > DRAG_THRESHOLD || Math.abs(e2.dy) > DRAG_THRESHOLD)) {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      this.api.dispatchAction({
        type: "treemapMove",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rootLayout.x + e2.dx,
          y: rootLayout.y + e2.dy,
          width: rootLayout.width,
          height: rootLayout.height
        }
      });
    }
  };
  TreemapView2.prototype._onZoom = function(e2) {
    var mouseX = e2.originX;
    var mouseY = e2.originY;
    if (this._state !== "animating") {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      var rect = new BoundingRect$1(rootLayout.x, rootLayout.y, rootLayout.width, rootLayout.height);
      var layoutInfo = this.seriesModel.layoutInfo;
      mouseX -= layoutInfo.x;
      mouseY -= layoutInfo.y;
      var m2 = create$1();
      translate(m2, m2, [-mouseX, -mouseY]);
      scale$1(m2, m2, [e2.scale, e2.scale]);
      translate(m2, m2, [mouseX, mouseY]);
      rect.applyTransform(m2);
      this.api.dispatchAction({
        type: "treemapRender",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rect.x,
          y: rect.y,
          width: rect.width,
          height: rect.height
        }
      });
    }
  };
  TreemapView2.prototype._initEvents = function(containerGroup) {
    var _this = this;
    containerGroup.on("click", function(e2) {
      if (_this._state !== "ready") {
        return;
      }
      var nodeClick = _this.seriesModel.get("nodeClick", true);
      if (!nodeClick) {
        return;
      }
      var targetInfo = _this.findTarget(e2.offsetX, e2.offsetY);
      if (!targetInfo) {
        return;
      }
      var node = targetInfo.node;
      if (node.getLayout().isLeafRoot) {
        _this._rootToNode(targetInfo);
      } else {
        if (nodeClick === "zoomToNode") {
          _this._zoomToNode(targetInfo);
        } else if (nodeClick === "link") {
          var itemModel = node.hostTree.data.getItemModel(node.dataIndex);
          var link = itemModel.get("link", true);
          var linkTarget = itemModel.get("target", true) || "blank";
          link && windowOpen(link, linkTarget);
        }
      }
    }, this);
  };
  TreemapView2.prototype._renderBreadcrumb = function(seriesModel, api, targetInfo) {
    var _this = this;
    if (!targetInfo) {
      targetInfo = seriesModel.get("leafDepth", true) != null ? {
        node: seriesModel.getViewRoot()
      } : this.findTarget(api.getWidth() / 2, api.getHeight() / 2);
      if (!targetInfo) {
        targetInfo = {
          node: seriesModel.getData().tree.root
        };
      }
    }
    (this._breadcrumb || (this._breadcrumb = new Breadcrumb$1(this.group))).render(seriesModel, api, targetInfo.node, function(node) {
      if (_this._state !== "animating") {
        aboveViewRoot(seriesModel.getViewRoot(), node) ? _this._rootToNode({
          node
        }) : _this._zoomToNode({
          node
        });
      }
    });
  };
  TreemapView2.prototype.remove = function() {
    this._clearController();
    this._containerGroup && this._containerGroup.removeAll();
    this._storage = createStorage();
    this._state = "ready";
    this._breadcrumb && this._breadcrumb.remove();
  };
  TreemapView2.prototype.dispose = function() {
    this._clearController();
  };
  TreemapView2.prototype._zoomToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapZoomToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype._rootToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapRootToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype.findTarget = function(x2, y2) {
    var targetInfo;
    var viewRoot = this.seriesModel.getViewRoot();
    viewRoot.eachNode({
      attr: "viewChildren",
      order: "preorder"
    }, function(node) {
      var bgEl = this._storage.background[node.getRawIndex()];
      if (bgEl) {
        var point = bgEl.transformCoordToLocal(x2, y2);
        var shape = bgEl.shape;
        if (shape.x <= point[0] && point[0] <= shape.x + shape.width && shape.y <= point[1] && point[1] <= shape.y + shape.height) {
          targetInfo = {
            node,
            offsetX: point[0],
            offsetY: point[1]
          };
        } else {
          return false;
        }
      }
    }, this);
    return targetInfo;
  };
  TreemapView2.type = "treemap";
  return TreemapView2;
}(ChartView$1);
function createStorage() {
  return {
    nodeGroup: [],
    background: [],
    content: []
  };
}
function renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth) {
  if (!thisNode) {
    return;
  }
  var thisLayout = thisNode.getLayout();
  var data = seriesModel.getData();
  var nodeModel = thisNode.getModel();
  data.setItemGraphicEl(thisNode.dataIndex, null);
  if (!thisLayout || !thisLayout.isInView) {
    return;
  }
  var thisWidth = thisLayout.width;
  var thisHeight = thisLayout.height;
  var borderWidth = thisLayout.borderWidth;
  var thisInvisible = thisLayout.invisible;
  var thisRawIndex = thisNode.getRawIndex();
  var oldRawIndex = oldNode && oldNode.getRawIndex();
  var thisViewChildren = thisNode.viewChildren;
  var upperHeight = thisLayout.upperHeight;
  var isParent = thisViewChildren && thisViewChildren.length;
  var itemStyleNormalModel = nodeModel.getModel("itemStyle");
  var itemStyleEmphasisModel = nodeModel.getModel(["emphasis", "itemStyle"]);
  var itemStyleBlurModel = nodeModel.getModel(["blur", "itemStyle"]);
  var itemStyleSelectModel = nodeModel.getModel(["select", "itemStyle"]);
  var borderRadius = itemStyleNormalModel.get("borderRadius") || 0;
  var group = giveGraphic("nodeGroup", Group$4);
  if (!group) {
    return;
  }
  parentGroup.add(group);
  group.x = thisLayout.x || 0;
  group.y = thisLayout.y || 0;
  group.markRedraw();
  inner$d(group).nodeWidth = thisWidth;
  inner$d(group).nodeHeight = thisHeight;
  if (thisLayout.isAboveViewRoot) {
    return group;
  }
  var bg2 = giveGraphic("background", Rect$1, depth, Z2_BG);
  bg2 && renderBackground(group, bg2, isParent && thisLayout.upperLabelHeight);
  var emphasisModel = nodeModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var isDisabled = emphasisModel.get("disabled");
  var focusOrIndices = focus === "ancestor" ? thisNode.getAncestorsIndices() : focus === "descendant" ? thisNode.getDescendantIndices() : focus;
  if (isParent) {
    if (isHighDownDispatcher(group)) {
      setAsHighDownDispatcher(group, false);
    }
    if (bg2) {
      setAsHighDownDispatcher(bg2, !isDisabled);
      data.setItemGraphicEl(thisNode.dataIndex, bg2);
      enableHoverFocus(bg2, focusOrIndices, blurScope);
    }
  } else {
    var content = giveGraphic("content", Rect$1, depth, Z2_CONTENT);
    content && renderContent(group, content);
    bg2.disableMorphing = true;
    if (bg2 && isHighDownDispatcher(bg2)) {
      setAsHighDownDispatcher(bg2, false);
    }
    setAsHighDownDispatcher(group, !isDisabled);
    data.setItemGraphicEl(thisNode.dataIndex, group);
    enableHoverFocus(group, focusOrIndices, blurScope);
  }
  return group;
  function renderBackground(group2, bg3, useUpperLabel) {
    var ecData = getECData(bg3);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    bg3.setShape({
      x: 0,
      y: 0,
      width: thisWidth,
      height: thisHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(bg3);
    } else {
      bg3.invisible = false;
      var style2 = thisNode.getVisual("style");
      var visualBorderColor = style2.stroke;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualBorderColor;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      emphasisStyle.fill = itemStyleEmphasisModel.get("borderColor");
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      blurStyle.fill = itemStyleBlurModel.get("borderColor");
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      selectStyle.fill = itemStyleSelectModel.get("borderColor");
      if (useUpperLabel) {
        var upperLabelWidth = thisWidth - 2 * borderWidth;
        prepareText(bg3, visualBorderColor, style2.opacity, {
          x: borderWidth,
          y: 0,
          width: upperLabelWidth,
          height: upperHeight
        });
      } else {
        bg3.removeTextContent();
      }
      bg3.setStyle(normalStyle);
      bg3.ensureState("emphasis").style = emphasisStyle;
      bg3.ensureState("blur").style = blurStyle;
      bg3.ensureState("select").style = selectStyle;
      setDefaultStateProxy(bg3);
    }
    group2.add(bg3);
  }
  function renderContent(group2, content2) {
    var ecData = getECData(content2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    var contentWidth = Math.max(thisWidth - 2 * borderWidth, 0);
    var contentHeight = Math.max(thisHeight - 2 * borderWidth, 0);
    content2.culling = true;
    content2.setShape({
      x: borderWidth,
      y: borderWidth,
      width: contentWidth,
      height: contentHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(content2);
    } else {
      content2.invisible = false;
      var nodeStyle = thisNode.getVisual("style");
      var visualColor = nodeStyle.fill;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualColor;
      normalStyle.decal = nodeStyle.decal;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      prepareText(content2, visualColor, nodeStyle.opacity, null);
      content2.setStyle(normalStyle);
      content2.ensureState("emphasis").style = emphasisStyle;
      content2.ensureState("blur").style = blurStyle;
      content2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(content2);
    }
    group2.add(content2);
  }
  function processInvisible(element) {
    !element.invisible && willInvisibleEls.push(element);
  }
  function prepareText(rectEl, visualColor, visualOpacity, upperLabelRect) {
    var normalLabelModel = nodeModel.getModel(upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL);
    var defaultText = convertOptionIdName(nodeModel.get("name"), null);
    var isShow = normalLabelModel.getShallow("show");
    setLabelStyle(rectEl, getLabelStatesModels(nodeModel, upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL), {
      defaultText: isShow ? defaultText : null,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      labelFetcher: seriesModel,
      labelDataIndex: thisNode.dataIndex
    });
    var textEl = rectEl.getTextContent();
    if (!textEl) {
      return;
    }
    var textStyle = textEl.style;
    var textPadding = normalizeCssArray$1(textStyle.padding || 0);
    if (upperLabelRect) {
      rectEl.setTextConfig({
        layoutRect: upperLabelRect
      });
      textEl.disableLabelLayout = true;
    }
    textEl.beforeUpdate = function() {
      var width = Math.max((upperLabelRect ? upperLabelRect.width : rectEl.shape.width) - textPadding[1] - textPadding[3], 0);
      var height = Math.max((upperLabelRect ? upperLabelRect.height : rectEl.shape.height) - textPadding[0] - textPadding[2], 0);
      if (textStyle.width !== width || textStyle.height !== height) {
        textEl.setStyle({
          width,
          height
        });
      }
    };
    textStyle.truncateMinChar = 2;
    textStyle.lineOverflow = "truncate";
    addDrillDownIcon(textStyle, upperLabelRect, thisLayout);
    var textEmphasisState = textEl.getState("emphasis");
    addDrillDownIcon(textEmphasisState ? textEmphasisState.style : null, upperLabelRect, thisLayout);
  }
  function addDrillDownIcon(style2, upperLabelRect, thisLayout2) {
    var text = style2 ? style2.text : null;
    if (!upperLabelRect && thisLayout2.isLeafRoot && text != null) {
      var iconChar = seriesModel.get("drillDownIcon", true);
      style2.text = iconChar ? iconChar + " " + text : text;
    }
  }
  function giveGraphic(storageName, Ctor, depth2, z2) {
    var element = oldRawIndex != null && oldStorage[storageName][oldRawIndex];
    var lasts = lastsForAnimation[storageName];
    if (element) {
      oldStorage[storageName][oldRawIndex] = null;
      prepareAnimationWhenHasOld(lasts, element);
    } else if (!thisInvisible) {
      element = new Ctor();
      if (element instanceof Displayable$1) {
        element.z2 = calculateZ2(depth2, z2);
      }
      prepareAnimationWhenNoOld(lasts, element);
    }
    return thisStorage[storageName][thisRawIndex] = element;
  }
  function prepareAnimationWhenHasOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    if (element instanceof Group$4) {
      lastCfg.oldX = element.x;
      lastCfg.oldY = element.y;
    } else {
      lastCfg.oldShape = extend({}, element.shape);
    }
  }
  function prepareAnimationWhenNoOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    var parentNode2 = thisNode.parentNode;
    var isGroup = element instanceof Group$6;
    if (parentNode2 && (!reRoot || reRoot.direction === "drillDown")) {
      var parentOldX = 0;
      var parentOldY = 0;
      var parentOldBg = lastsForAnimation.background[parentNode2.getRawIndex()];
      if (!reRoot && parentOldBg && parentOldBg.oldShape) {
        parentOldX = parentOldBg.oldShape.width;
        parentOldY = parentOldBg.oldShape.height;
      }
      if (isGroup) {
        lastCfg.oldX = 0;
        lastCfg.oldY = parentOldY;
      } else {
        lastCfg.oldShape = {
          x: parentOldX,
          y: parentOldY,
          width: 0,
          height: 0
        };
      }
    }
    lastCfg.fadein = !isGroup;
  }
}
function calculateZ2(depth, z2InLevel) {
  return depth * Z2_BASE + z2InLevel;
}
var TreemapView$1 = TreemapView;
var each$d = each$g;
var isObject$1 = isObject$4;
var CATEGORY_DEFAULT_VISUAL_INDEX = -1;
var VisualMapping = function() {
  function VisualMapping2(option) {
    var mappingMethod = option.mappingMethod;
    var visualType = option.type;
    var thisOption = this.option = clone$4(option);
    this.type = visualType;
    this.mappingMethod = mappingMethod;
    this._normalizeData = normalizers[mappingMethod];
    var visualHandler = VisualMapping2.visualHandlers[visualType];
    this.applyVisual = visualHandler.applyVisual;
    this.getColorMapper = visualHandler.getColorMapper;
    this._normalizedToVisual = visualHandler._normalizedToVisual[mappingMethod];
    if (mappingMethod === "piecewise") {
      normalizeVisualRange(thisOption);
      preprocessForPiecewise(thisOption);
    } else if (mappingMethod === "category") {
      thisOption.categories ? preprocessForSpecifiedCategory(thisOption) : normalizeVisualRange(thisOption, true);
    } else {
      assert(mappingMethod !== "linear" || thisOption.dataExtent);
      normalizeVisualRange(thisOption);
    }
  }
  VisualMapping2.prototype.mapValueToVisual = function(value) {
    var normalized = this._normalizeData(value);
    return this._normalizedToVisual(normalized, value);
  };
  VisualMapping2.prototype.getNormalizer = function() {
    return bind$1(this._normalizeData, this);
  };
  VisualMapping2.listVisualTypes = function() {
    return keys(VisualMapping2.visualHandlers);
  };
  VisualMapping2.isValidType = function(visualType) {
    return VisualMapping2.visualHandlers.hasOwnProperty(visualType);
  };
  VisualMapping2.eachVisual = function(visual, callback, context) {
    if (isObject$4(visual)) {
      each$g(visual, callback, context);
    } else {
      callback.call(context, visual);
    }
  };
  VisualMapping2.mapVisual = function(visual, callback, context) {
    var isPrimary;
    var newVisual = isArray$1(visual) ? [] : isObject$4(visual) ? {} : (isPrimary = true, null);
    VisualMapping2.eachVisual(visual, function(v4, key) {
      var newVal = callback.call(context, v4, key);
      isPrimary ? newVisual = newVal : newVisual[key] = newVal;
    });
    return newVisual;
  };
  VisualMapping2.retrieveVisuals = function(obj) {
    var ret = {};
    var hasVisual;
    obj && each$d(VisualMapping2.visualHandlers, function(h, visualType) {
      if (obj.hasOwnProperty(visualType)) {
        ret[visualType] = obj[visualType];
        hasVisual = true;
      }
    });
    return hasVisual ? ret : null;
  };
  VisualMapping2.prepareVisualTypes = function(visualTypes) {
    if (isArray$1(visualTypes)) {
      visualTypes = visualTypes.slice();
    } else if (isObject$1(visualTypes)) {
      var types_1 = [];
      each$d(visualTypes, function(item, type4) {
        types_1.push(type4);
      });
      visualTypes = types_1;
    } else {
      return [];
    }
    visualTypes.sort(function(type1, type22) {
      return type22 === "color" && type1 !== "color" && type1.indexOf("color") === 0 ? 1 : -1;
    });
    return visualTypes;
  };
  VisualMapping2.dependsOn = function(visualType1, visualType2) {
    return visualType2 === "color" ? !!(visualType1 && visualType1.indexOf(visualType2) === 0) : visualType1 === visualType2;
  };
  VisualMapping2.findPieceIndex = function(value, pieceList, findClosestWhenOutside) {
    var possibleI;
    var abs2 = Infinity;
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var pieceValue = pieceList[i].value;
      if (pieceValue != null) {
        if (pieceValue === value || isString$1(pieceValue) && pieceValue === value + "") {
          return i;
        }
        findClosestWhenOutside && updatePossible(pieceValue, i);
      }
    }
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var piece = pieceList[i];
      var interval = piece.interval;
      var close_1 = piece.close;
      if (interval) {
        if (interval[0] === -Infinity) {
          if (littleThan(close_1[1], value, interval[1])) {
            return i;
          }
        } else if (interval[1] === Infinity) {
          if (littleThan(close_1[0], interval[0], value)) {
            return i;
          }
        } else if (littleThan(close_1[0], interval[0], value) && littleThan(close_1[1], value, interval[1])) {
          return i;
        }
        findClosestWhenOutside && updatePossible(interval[0], i);
        findClosestWhenOutside && updatePossible(interval[1], i);
      }
    }
    if (findClosestWhenOutside) {
      return value === Infinity ? pieceList.length - 1 : value === -Infinity ? 0 : possibleI;
    }
    function updatePossible(val, index2) {
      var newAbs = Math.abs(val - value);
      if (newAbs < abs2) {
        abs2 = newAbs;
        possibleI = index2;
      }
    }
  };
  VisualMapping2.visualHandlers = {
    color: {
      applyVisual: makeApplyVisual("color"),
      getColorMapper: function() {
        var thisOption = this.option;
        return bind$1(thisOption.mappingMethod === "category" ? function(value, isNormalized) {
          !isNormalized && (value = this._normalizeData(value));
          return doMapCategory.call(this, value);
        } : function(value, isNormalized, out2) {
          var returnRGBArray = !!out2;
          !isNormalized && (value = this._normalizeData(value));
          out2 = fastLerp(value, thisOption.parsedVisual, out2);
          return returnRGBArray ? out2 : stringify(out2, "rgba");
        }, this);
      },
      _normalizedToVisual: {
        linear: function(normalized) {
          return stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
        },
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    colorHue: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, value);
    }),
    colorSaturation: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, value);
    }),
    colorLightness: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, null, value);
    }),
    colorAlpha: makePartialColorVisualHandler(function(color, value) {
      return modifyAlpha(color, value);
    }),
    decal: {
      applyVisual: makeApplyVisual("decal"),
      _normalizedToVisual: {
        linear: null,
        category: doMapCategory,
        piecewise: null,
        fixed: null
      }
    },
    opacity: {
      applyVisual: makeApplyVisual("opacity"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    },
    liftZ: {
      applyVisual: makeApplyVisual("liftZ"),
      _normalizedToVisual: {
        linear: doMapFixed,
        category: doMapFixed,
        piecewise: doMapFixed,
        fixed: doMapFixed
      }
    },
    symbol: {
      applyVisual: function(value, getter, setter) {
        var symbolCfg = this.mapValueToVisual(value);
        setter("symbol", symbolCfg);
      },
      _normalizedToVisual: {
        linear: doMapToArray,
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = doMapToArray.call(this, normalized);
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    symbolSize: {
      applyVisual: makeApplyVisual("symbolSize"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    }
  };
  return VisualMapping2;
}();
function preprocessForPiecewise(thisOption) {
  var pieceList = thisOption.pieceList;
  thisOption.hasSpecialVisual = false;
  each$g(pieceList, function(piece, index2) {
    piece.originIndex = index2;
    if (piece.visual != null) {
      thisOption.hasSpecialVisual = true;
    }
  });
}
function preprocessForSpecifiedCategory(thisOption) {
  var categories = thisOption.categories;
  var categoryMap = thisOption.categoryMap = {};
  var visual = thisOption.visual;
  each$d(categories, function(cate, index2) {
    categoryMap[cate] = index2;
  });
  if (!isArray$1(visual)) {
    var visualArr_1 = [];
    if (isObject$4(visual)) {
      each$d(visual, function(v4, cate) {
        var index2 = categoryMap[cate];
        visualArr_1[index2 != null ? index2 : CATEGORY_DEFAULT_VISUAL_INDEX] = v4;
      });
    } else {
      visualArr_1[CATEGORY_DEFAULT_VISUAL_INDEX] = visual;
    }
    visual = setVisualToOption(thisOption, visualArr_1);
  }
  for (var i = categories.length - 1; i >= 0; i--) {
    if (visual[i] == null) {
      delete categoryMap[categories[i]];
      categories.pop();
    }
  }
}
function normalizeVisualRange(thisOption, isCategory2) {
  var visual = thisOption.visual;
  var visualArr = [];
  if (isObject$4(visual)) {
    each$d(visual, function(v4) {
      visualArr.push(v4);
    });
  } else if (visual != null) {
    visualArr.push(visual);
  }
  var doNotNeedPair = {
    color: 1,
    symbol: 1
  };
  if (!isCategory2 && visualArr.length === 1 && !doNotNeedPair.hasOwnProperty(thisOption.type)) {
    visualArr[1] = visualArr[0];
  }
  setVisualToOption(thisOption, visualArr);
}
function makePartialColorVisualHandler(applyValue) {
  return {
    applyVisual: function(value, getter, setter) {
      var colorChannel = this.mapValueToVisual(value);
      setter("color", applyValue(getter("color"), colorChannel));
    },
    _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
  };
}
function doMapToArray(normalized) {
  var visual = this.option.visual;
  return visual[Math.round(linearMap$2(normalized, [0, 1], [0, visual.length - 1], true))] || {};
}
function makeApplyVisual(visualType) {
  return function(value, getter, setter) {
    setter(visualType, this.mapValueToVisual(value));
  };
}
function doMapCategory(normalized) {
  var visual = this.option.visual;
  return visual[this.option.loop && normalized !== CATEGORY_DEFAULT_VISUAL_INDEX ? normalized % visual.length : normalized];
}
function doMapFixed() {
  return this.option.visual[0];
}
function createNormalizedToNumericVisual(sourceExtent) {
  return {
    linear: function(normalized) {
      return linearMap$2(normalized, sourceExtent, this.option.visual, true);
    },
    category: doMapCategory,
    piecewise: function(normalized, value) {
      var result = getSpecifiedVisual.call(this, value);
      if (result == null) {
        result = linearMap$2(normalized, sourceExtent, this.option.visual, true);
      }
      return result;
    },
    fixed: doMapFixed
  };
}
function getSpecifiedVisual(value) {
  var thisOption = this.option;
  var pieceList = thisOption.pieceList;
  if (thisOption.hasSpecialVisual) {
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList);
    var piece = pieceList[pieceIndex];
    if (piece && piece.visual) {
      return piece.visual[this.type];
    }
  }
}
function setVisualToOption(thisOption, visualArr) {
  thisOption.visual = visualArr;
  if (thisOption.type === "color") {
    thisOption.parsedVisual = map$1(visualArr, function(item) {
      return parse(item);
    });
  }
  return visualArr;
}
var normalizers = {
  linear: function(value) {
    return linearMap$2(value, this.option.dataExtent, [0, 1], true);
  },
  piecewise: function(value) {
    var pieceList = this.option.pieceList;
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList, true);
    if (pieceIndex != null) {
      return linearMap$2(pieceIndex, [0, pieceList.length - 1], [0, 1], true);
    }
  },
  category: function(value) {
    var index2 = this.option.categories ? this.option.categoryMap[value] : value;
    return index2 == null ? CATEGORY_DEFAULT_VISUAL_INDEX : index2;
  },
  fixed: noop$1
};
function littleThan(close, a, b2) {
  return close ? a <= b2 : a < b2;
}
var VisualMapping$1 = VisualMapping;
var ITEM_STYLE_NORMAL = "itemStyle";
var inner$c = makeInner();
var treemapVisual = {
  seriesType: "treemap",
  reset: function(seriesModel) {
    var tree = seriesModel.getData().tree;
    var root2 = tree.root;
    if (root2.isRemoved()) {
      return;
    }
    travelTree(root2, {}, seriesModel.getViewRoot().getAncestors(), seriesModel);
  }
};
function travelTree(node, designatedVisual, viewRootAncestors, seriesModel) {
  var nodeModel = node.getModel();
  var nodeLayout = node.getLayout();
  var data = node.hostTree.data;
  if (!nodeLayout || nodeLayout.invisible || !nodeLayout.isInView) {
    return;
  }
  var nodeItemStyleModel = nodeModel.getModel(ITEM_STYLE_NORMAL);
  var visuals = buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel);
  var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
  var borderColor = nodeItemStyleModel.get("borderColor");
  var borderColorSaturation = nodeItemStyleModel.get("borderColorSaturation");
  var thisNodeColor;
  if (borderColorSaturation != null) {
    thisNodeColor = calculateColor(visuals);
    borderColor = calculateBorderColor(borderColorSaturation, thisNodeColor);
  }
  existsStyle.stroke = borderColor;
  var viewChildren = node.viewChildren;
  if (!viewChildren || !viewChildren.length) {
    thisNodeColor = calculateColor(visuals);
    existsStyle.fill = thisNodeColor;
  } else {
    var mapping_1 = buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren);
    each$g(viewChildren, function(child, index2) {
      if (child.depth >= viewRootAncestors.length || child === viewRootAncestors[child.depth]) {
        var childVisual = mapVisual$1(nodeModel, visuals, child, index2, mapping_1, seriesModel);
        travelTree(child, childVisual, viewRootAncestors, seriesModel);
      }
    });
  }
}
function buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel) {
  var visuals = extend({}, designatedVisual);
  var designatedVisualItemStyle = seriesModel.designatedVisualItemStyle;
  each$g(["color", "colorAlpha", "colorSaturation"], function(visualName) {
    designatedVisualItemStyle[visualName] = designatedVisual[visualName];
    var val = nodeItemStyleModel.get(visualName);
    designatedVisualItemStyle[visualName] = null;
    val != null && (visuals[visualName] = val);
  });
  return visuals;
}
function calculateColor(visuals) {
  var color = getValueVisualDefine(visuals, "color");
  if (color) {
    var colorAlpha = getValueVisualDefine(visuals, "colorAlpha");
    var colorSaturation = getValueVisualDefine(visuals, "colorSaturation");
    if (colorSaturation) {
      color = modifyHSL(color, null, null, colorSaturation);
    }
    if (colorAlpha) {
      color = modifyAlpha(color, colorAlpha);
    }
    return color;
  }
}
function calculateBorderColor(borderColorSaturation, thisNodeColor) {
  return thisNodeColor != null ? modifyHSL(thisNodeColor, null, null, borderColorSaturation) : null;
}
function getValueVisualDefine(visuals, name) {
  var value = visuals[name];
  if (value != null && value !== "none") {
    return value;
  }
}
function buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren) {
  if (!viewChildren || !viewChildren.length) {
    return;
  }
  var rangeVisual = getRangeVisual(nodeModel, "color") || visuals.color != null && visuals.color !== "none" && (getRangeVisual(nodeModel, "colorAlpha") || getRangeVisual(nodeModel, "colorSaturation"));
  if (!rangeVisual) {
    return;
  }
  var visualMin = nodeModel.get("visualMin");
  var visualMax = nodeModel.get("visualMax");
  var dataExtent = nodeLayout.dataExtent.slice();
  visualMin != null && visualMin < dataExtent[0] && (dataExtent[0] = visualMin);
  visualMax != null && visualMax > dataExtent[1] && (dataExtent[1] = visualMax);
  var colorMappingBy = nodeModel.get("colorMappingBy");
  var opt = {
    type: rangeVisual.name,
    dataExtent,
    visual: rangeVisual.range
  };
  if (opt.type === "color" && (colorMappingBy === "index" || colorMappingBy === "id")) {
    opt.mappingMethod = "category";
    opt.loop = true;
  } else {
    opt.mappingMethod = "linear";
  }
  var mapping = new VisualMapping$1(opt);
  inner$c(mapping).drColorMappingBy = colorMappingBy;
  return mapping;
}
function getRangeVisual(nodeModel, name) {
  var range3 = nodeModel.get(name);
  return isArray$1(range3) && range3.length ? {
    name,
    range: range3
  } : null;
}
function mapVisual$1(nodeModel, visuals, child, index2, mapping, seriesModel) {
  var childVisuals = extend({}, visuals);
  if (mapping) {
    var mappingType = mapping.type;
    var colorMappingBy = mappingType === "color" && inner$c(mapping).drColorMappingBy;
    var value = colorMappingBy === "index" ? index2 : colorMappingBy === "id" ? seriesModel.mapIdToIndex(child.getId()) : child.getValue(nodeModel.get("visualDimension"));
    childVisuals[mappingType] = mapping.mapValueToVisual(value);
  }
  return childVisuals;
}
var mathMax$3 = Math.max;
var mathMin$3 = Math.min;
var retrieveValue = retrieve;
var each$c = each$g;
var PATH_BORDER_WIDTH = ["itemStyle", "borderWidth"];
var PATH_GAP_WIDTH = ["itemStyle", "gapWidth"];
var PATH_UPPER_LABEL_SHOW = ["upperLabel", "show"];
var PATH_UPPER_LABEL_HEIGHT = ["upperLabel", "height"];
var treemapLayout = {
  seriesType: "treemap",
  reset: function(seriesModel, ecModel, api, payload) {
    var ecWidth = api.getWidth();
    var ecHeight = api.getHeight();
    var seriesOption = seriesModel.option;
    var layoutInfo = getLayoutRect(seriesModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    var size = seriesOption.size || [];
    var containerWidth = parsePercent(retrieveValue(layoutInfo.width, size[0]), ecWidth);
    var containerHeight = parsePercent(retrieveValue(layoutInfo.height, size[1]), ecHeight);
    var payloadType = payload && payload.type;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var rootRect = payloadType === "treemapRender" || payloadType === "treemapMove" ? payload.rootRect : null;
    var viewRoot = seriesModel.getViewRoot();
    var viewAbovePath = getPathToRoot(viewRoot);
    if (payloadType !== "treemapMove") {
      var rootSize = payloadType === "treemapZoomToNode" ? estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) : rootRect ? [rootRect.width, rootRect.height] : [containerWidth, containerHeight];
      var sort_1 = seriesOption.sort;
      if (sort_1 && sort_1 !== "asc" && sort_1 !== "desc") {
        sort_1 = "desc";
      }
      var options = {
        squareRatio: seriesOption.squareRatio,
        sort: sort_1,
        leafDepth: seriesOption.leafDepth
      };
      viewRoot.hostTree.clearLayouts();
      var viewRootLayout_1 = {
        x: 0,
        y: 0,
        width: rootSize[0],
        height: rootSize[1],
        area: rootSize[0] * rootSize[1]
      };
      viewRoot.setLayout(viewRootLayout_1);
      squarify(viewRoot, options, false, 0);
      viewRootLayout_1 = viewRoot.getLayout();
      each$c(viewAbovePath, function(node, index2) {
        var childValue = (viewAbovePath[index2 + 1] || viewRoot).getValue();
        node.setLayout(extend({
          dataExtent: [childValue, childValue],
          borderWidth: 0,
          upperHeight: 0
        }, viewRootLayout_1));
      });
    }
    var treeRoot = seriesModel.getData().tree.root;
    treeRoot.setLayout(calculateRootPosition(layoutInfo, rootRect, targetInfo), true);
    seriesModel.setLayoutInfo(layoutInfo);
    prunning(treeRoot, new BoundingRect$1(-layoutInfo.x, -layoutInfo.y, ecWidth, ecHeight), viewAbovePath, viewRoot, 0);
  }
};
function squarify(node, options, hideChildren, depth) {
  var width;
  var height;
  if (node.isRemoved()) {
    return;
  }
  var thisLayout = node.getLayout();
  width = thisLayout.width;
  height = thisLayout.height;
  var nodeModel = node.getModel();
  var borderWidth = nodeModel.get(PATH_BORDER_WIDTH);
  var halfGapWidth = nodeModel.get(PATH_GAP_WIDTH) / 2;
  var upperLabelHeight = getUpperLabelHeight(nodeModel);
  var upperHeight = Math.max(borderWidth, upperLabelHeight);
  var layoutOffset = borderWidth - halfGapWidth;
  var layoutOffsetUpper = upperHeight - halfGapWidth;
  node.setLayout({
    borderWidth,
    upperHeight,
    upperLabelHeight
  }, true);
  width = mathMax$3(width - 2 * layoutOffset, 0);
  height = mathMax$3(height - layoutOffset - layoutOffsetUpper, 0);
  var totalArea = width * height;
  var viewChildren = initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth);
  if (!viewChildren.length) {
    return;
  }
  var rect = {
    x: layoutOffset,
    y: layoutOffsetUpper,
    width,
    height
  };
  var rowFixedLength = mathMin$3(width, height);
  var best = Infinity;
  var row = [];
  row.area = 0;
  for (var i = 0, len2 = viewChildren.length; i < len2; ) {
    var child = viewChildren[i];
    row.push(child);
    row.area += child.getLayout().area;
    var score = worst(row, rowFixedLength, options.squareRatio);
    if (score <= best) {
      i++;
      best = score;
    } else {
      row.area -= row.pop().getLayout().area;
      position(row, rowFixedLength, rect, halfGapWidth, false);
      rowFixedLength = mathMin$3(rect.width, rect.height);
      row.length = row.area = 0;
      best = Infinity;
    }
  }
  if (row.length) {
    position(row, rowFixedLength, rect, halfGapWidth, true);
  }
  if (!hideChildren) {
    var childrenVisibleMin = nodeModel.get("childrenVisibleMin");
    if (childrenVisibleMin != null && totalArea < childrenVisibleMin) {
      hideChildren = true;
    }
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    squarify(viewChildren[i], options, hideChildren, depth + 1);
  }
}
function initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth) {
  var viewChildren = node.children || [];
  var orderBy = options.sort;
  orderBy !== "asc" && orderBy !== "desc" && (orderBy = null);
  var overLeafDepth = options.leafDepth != null && options.leafDepth <= depth;
  if (hideChildren && !overLeafDepth) {
    return node.viewChildren = [];
  }
  viewChildren = filter(viewChildren, function(child) {
    return !child.isRemoved();
  });
  sort$1(viewChildren, orderBy);
  var info = statistic(nodeModel, viewChildren, orderBy);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  info.sum = filterByThreshold(nodeModel, totalArea, info.sum, orderBy, viewChildren);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    var area = viewChildren[i].getValue() / info.sum * totalArea;
    viewChildren[i].setLayout({
      area
    });
  }
  if (overLeafDepth) {
    viewChildren.length && node.setLayout({
      isLeafRoot: true
    }, true);
    viewChildren.length = 0;
  }
  node.viewChildren = viewChildren;
  node.setLayout({
    dataExtent: info.dataExtent
  }, true);
  return viewChildren;
}
function filterByThreshold(nodeModel, totalArea, sum2, orderBy, orderedChildren) {
  if (!orderBy) {
    return sum2;
  }
  var visibleMin = nodeModel.get("visibleMin");
  var len2 = orderedChildren.length;
  var deletePoint = len2;
  for (var i = len2 - 1; i >= 0; i--) {
    var value = orderedChildren[orderBy === "asc" ? len2 - i - 1 : i].getValue();
    if (value / sum2 * totalArea < visibleMin) {
      deletePoint = i;
      sum2 -= value;
    }
  }
  orderBy === "asc" ? orderedChildren.splice(0, len2 - deletePoint) : orderedChildren.splice(deletePoint, len2 - deletePoint);
  return sum2;
}
function sort$1(viewChildren, orderBy) {
  if (orderBy) {
    viewChildren.sort(function(a, b2) {
      var diff = orderBy === "asc" ? a.getValue() - b2.getValue() : b2.getValue() - a.getValue();
      return diff === 0 ? orderBy === "asc" ? a.dataIndex - b2.dataIndex : b2.dataIndex - a.dataIndex : diff;
    });
  }
  return viewChildren;
}
function statistic(nodeModel, children, orderBy) {
  var sum2 = 0;
  for (var i = 0, len2 = children.length; i < len2; i++) {
    sum2 += children[i].getValue();
  }
  var dimension = nodeModel.get("visualDimension");
  var dataExtent;
  if (!children || !children.length) {
    dataExtent = [NaN, NaN];
  } else if (dimension === "value" && orderBy) {
    dataExtent = [children[children.length - 1].getValue(), children[0].getValue()];
    orderBy === "asc" && dataExtent.reverse();
  } else {
    dataExtent = [Infinity, -Infinity];
    each$c(children, function(child) {
      var value = child.getValue(dimension);
      value < dataExtent[0] && (dataExtent[0] = value);
      value > dataExtent[1] && (dataExtent[1] = value);
    });
  }
  return {
    sum: sum2,
    dataExtent
  };
}
function worst(row, rowFixedLength, ratio) {
  var areaMax = 0;
  var areaMin = Infinity;
  for (var i = 0, area = void 0, len2 = row.length; i < len2; i++) {
    area = row[i].getLayout().area;
    if (area) {
      area < areaMin && (areaMin = area);
      area > areaMax && (areaMax = area);
    }
  }
  var squareArea = row.area * row.area;
  var f2 = rowFixedLength * rowFixedLength * ratio;
  return squareArea ? mathMax$3(f2 * areaMax / squareArea, squareArea / (f2 * areaMin)) : Infinity;
}
function position(row, rowFixedLength, rect, halfGapWidth, flush) {
  var idx0WhenH = rowFixedLength === rect.width ? 0 : 1;
  var idx1WhenH = 1 - idx0WhenH;
  var xy = ["x", "y"];
  var wh2 = ["width", "height"];
  var last = rect[xy[idx0WhenH]];
  var rowOtherLength = rowFixedLength ? row.area / rowFixedLength : 0;
  if (flush || rowOtherLength > rect[wh2[idx1WhenH]]) {
    rowOtherLength = rect[wh2[idx1WhenH]];
  }
  for (var i = 0, rowLen = row.length; i < rowLen; i++) {
    var node = row[i];
    var nodeLayout = {};
    var step = rowOtherLength ? node.getLayout().area / rowOtherLength : 0;
    var wh1 = nodeLayout[wh2[idx1WhenH]] = mathMax$3(rowOtherLength - 2 * halfGapWidth, 0);
    var remain = rect[xy[idx0WhenH]] + rect[wh2[idx0WhenH]] - last;
    var modWH = i === rowLen - 1 || remain < step ? remain : step;
    var wh0 = nodeLayout[wh2[idx0WhenH]] = mathMax$3(modWH - 2 * halfGapWidth, 0);
    nodeLayout[xy[idx1WhenH]] = rect[xy[idx1WhenH]] + mathMin$3(halfGapWidth, wh1 / 2);
    nodeLayout[xy[idx0WhenH]] = last + mathMin$3(halfGapWidth, wh0 / 2);
    last += modWH;
    node.setLayout(nodeLayout, true);
  }
  rect[xy[idx1WhenH]] += rowOtherLength;
  rect[wh2[idx1WhenH]] -= rowOtherLength;
}
function estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) {
  var currNode = (targetInfo || {}).node;
  var defaultSize = [containerWidth, containerHeight];
  if (!currNode || currNode === viewRoot) {
    return defaultSize;
  }
  var parent;
  var viewArea = containerWidth * containerHeight;
  var area = viewArea * seriesModel.option.zoomToNodeRatio;
  while (parent = currNode.parentNode) {
    var sum2 = 0;
    var siblings = parent.children;
    for (var i = 0, len2 = siblings.length; i < len2; i++) {
      sum2 += siblings[i].getValue();
    }
    var currNodeValue = currNode.getValue();
    if (currNodeValue === 0) {
      return defaultSize;
    }
    area *= sum2 / currNodeValue;
    var parentModel = parent.getModel();
    var borderWidth = parentModel.get(PATH_BORDER_WIDTH);
    var upperHeight = Math.max(borderWidth, getUpperLabelHeight(parentModel));
    area += 4 * borderWidth * borderWidth + (3 * borderWidth + upperHeight) * Math.pow(area, 0.5);
    area > MAX_SAFE_INTEGER && (area = MAX_SAFE_INTEGER);
    currNode = parent;
  }
  area < viewArea && (area = viewArea);
  var scale2 = Math.pow(area / viewArea, 0.5);
  return [containerWidth * scale2, containerHeight * scale2];
}
function calculateRootPosition(layoutInfo, rootRect, targetInfo) {
  if (rootRect) {
    return {
      x: rootRect.x,
      y: rootRect.y
    };
  }
  var defaultPosition = {
    x: 0,
    y: 0
  };
  if (!targetInfo) {
    return defaultPosition;
  }
  var targetNode = targetInfo.node;
  var layout2 = targetNode.getLayout();
  if (!layout2) {
    return defaultPosition;
  }
  var targetCenter = [layout2.width / 2, layout2.height / 2];
  var node = targetNode;
  while (node) {
    var nodeLayout = node.getLayout();
    targetCenter[0] += nodeLayout.x;
    targetCenter[1] += nodeLayout.y;
    node = node.parentNode;
  }
  return {
    x: layoutInfo.width / 2 - targetCenter[0],
    y: layoutInfo.height / 2 - targetCenter[1]
  };
}
function prunning(node, clipRect, viewAbovePath, viewRoot, depth) {
  var nodeLayout = node.getLayout();
  var nodeInViewAbovePath = viewAbovePath[depth];
  var isAboveViewRoot = nodeInViewAbovePath && nodeInViewAbovePath === node;
  if (nodeInViewAbovePath && !isAboveViewRoot || depth === viewAbovePath.length && node !== viewRoot) {
    return;
  }
  node.setLayout({
    isInView: true,
    invisible: !isAboveViewRoot && !clipRect.intersect(nodeLayout),
    isAboveViewRoot
  }, true);
  var childClipRect = new BoundingRect$1(clipRect.x - nodeLayout.x, clipRect.y - nodeLayout.y, clipRect.width, clipRect.height);
  each$c(node.viewChildren || [], function(child) {
    prunning(child, childClipRect, viewAbovePath, viewRoot, depth + 1);
  });
}
function getUpperLabelHeight(model) {
  return model.get(PATH_UPPER_LABEL_SHOW) ? model.get(PATH_UPPER_LABEL_HEIGHT) : 0;
}
function install$G(registers) {
  registers.registerSeriesModel(TreemapSeriesModel$1);
  registers.registerChartView(TreemapView$1);
  registers.registerVisual(treemapVisual);
  registers.registerLayout(treemapLayout);
  installTreemapAction(registers);
}
function categoryFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (!legendModels || !legendModels.length) {
    return;
  }
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var categoriesData = graphSeries.getCategoriesData();
    var graph = graphSeries.getGraph();
    var data = graph.data;
    var categoryNames = categoriesData.mapArray(categoriesData.getName);
    data.filterSelf(function(idx) {
      var model = data.getItemModel(idx);
      var category = model.getShallow("category");
      if (category != null) {
        if (isNumber(category)) {
          category = categoryNames[category];
        }
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(category)) {
            return false;
          }
        }
      }
      return true;
    });
  });
}
function categoryVisual(ecModel) {
  var paletteScope = {};
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var categoriesData = seriesModel.getCategoriesData();
    var data = seriesModel.getData();
    var categoryNameIdxMap = {};
    categoriesData.each(function(idx) {
      var name = categoriesData.getName(idx);
      categoryNameIdxMap["ec-" + name] = idx;
      var itemModel = categoriesData.getItemModel(idx);
      var style2 = itemModel.getModel("itemStyle").getItemStyle();
      if (!style2.fill) {
        style2.fill = seriesModel.getColorFromPalette(name, paletteScope);
      }
      categoriesData.setItemVisual(idx, "style", style2);
      var symbolVisualList = ["symbol", "symbolSize", "symbolKeepAspect"];
      for (var i = 0; i < symbolVisualList.length; i++) {
        var symbolVisual = itemModel.getShallow(symbolVisualList[i], true);
        if (symbolVisual != null) {
          categoriesData.setItemVisual(idx, symbolVisualList[i], symbolVisual);
        }
      }
    });
    if (categoriesData.count()) {
      data.each(function(idx) {
        var model = data.getItemModel(idx);
        var categoryIdx = model.getShallow("category");
        if (categoryIdx != null) {
          if (isString$1(categoryIdx)) {
            categoryIdx = categoryNameIdxMap["ec-" + categoryIdx];
          }
          var categoryStyle = categoriesData.getItemVisual(categoryIdx, "style");
          var style2 = data.ensureUniqueItemVisual(idx, "style");
          extend(style2, categoryStyle);
          var visualList = ["symbol", "symbolSize", "symbolKeepAspect"];
          for (var i = 0; i < visualList.length; i++) {
            data.setItemVisual(idx, visualList[i], categoriesData.getItemVisual(categoryIdx, visualList[i]));
          }
        }
      });
    }
  });
}
function normalize$2(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
function graphEdgeVisual(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var edgeData = seriesModel.getEdgeData();
    var symbolType = normalize$2(seriesModel.get("edgeSymbol"));
    var symbolSize = normalize$2(seriesModel.get("edgeSymbolSize"));
    edgeData.setVisual("fromSymbol", symbolType && symbolType[0]);
    edgeData.setVisual("toSymbol", symbolType && symbolType[1]);
    edgeData.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    edgeData.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    edgeData.setVisual("style", seriesModel.getModel("lineStyle").getLineStyle());
    edgeData.each(function(idx) {
      var itemModel = edgeData.getItemModel(idx);
      var edge = graph.getEdgeByIndex(idx);
      var symbolType2 = normalize$2(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$2(itemModel.getShallow("symbolSize", true));
      var style2 = itemModel.getModel("lineStyle").getLineStyle();
      var existsStyle = edgeData.ensureUniqueItemVisual(idx, "style");
      extend(existsStyle, style2);
      switch (existsStyle.stroke) {
        case "source": {
          var nodeStyle = edge.node1.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
        case "target": {
          var nodeStyle = edge.node2.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
      }
      symbolType2[0] && edge.setVisual("fromSymbol", symbolType2[0]);
      symbolType2[1] && edge.setVisual("toSymbol", symbolType2[1]);
      symbolSize2[0] && edge.setVisual("fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && edge.setVisual("toSymbolSize", symbolSize2[1]);
    });
  });
}
var KEY_DELIMITER = "-->";
var getAutoCurvenessParams = function(seriesModel) {
  return seriesModel.get("autoCurveness") || null;
};
var createCurveness = function(seriesModel, appendLength) {
  var autoCurvenessParmas = getAutoCurvenessParams(seriesModel);
  var length = 20;
  var curvenessList = [];
  if (isNumber(autoCurvenessParmas)) {
    length = autoCurvenessParmas;
  } else if (isArray$1(autoCurvenessParmas)) {
    seriesModel.__curvenessList = autoCurvenessParmas;
    return;
  }
  if (appendLength > length) {
    length = appendLength;
  }
  var len2 = length % 2 ? length + 2 : length + 3;
  curvenessList = [];
  for (var i = 0; i < len2; i++) {
    curvenessList.push((i % 2 ? i + 1 : i) / 10 * (i % 2 ? -1 : 1));
  }
  seriesModel.__curvenessList = curvenessList;
};
var getKeyOfEdges = function(n1, n2, seriesModel) {
  var source = [n1.id, n1.dataIndex].join(".");
  var target = [n2.id, n2.dataIndex].join(".");
  return [seriesModel.uid, source, target].join(KEY_DELIMITER);
};
var getOppositeKey = function(key) {
  var keys2 = key.split(KEY_DELIMITER);
  return [keys2[0], keys2[2], keys2[1]].join(KEY_DELIMITER);
};
var getEdgeFromMap = function(edge, seriesModel) {
  var key = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  return seriesModel.__edgeMap[key];
};
var getTotalLengthBetweenNodes = function(edge, seriesModel) {
  var len2 = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node1, edge.node2, seriesModel), seriesModel);
  var lenV = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node2, edge.node1, seriesModel), seriesModel);
  return len2 + lenV;
};
var getEdgeMapLengthWithKey = function(key, seriesModel) {
  var edgeMap = seriesModel.__edgeMap;
  return edgeMap[key] ? edgeMap[key].length : 0;
};
function initCurvenessList(seriesModel) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  seriesModel.__curvenessList = [];
  seriesModel.__edgeMap = {};
  createCurveness(seriesModel);
}
function createEdgeMapForCurveness(n1, n2, seriesModel, index2) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  var key = getKeyOfEdges(n1, n2, seriesModel);
  var edgeMap = seriesModel.__edgeMap;
  var oppositeEdges = edgeMap[getOppositeKey(key)];
  if (edgeMap[key] && !oppositeEdges) {
    edgeMap[key].isForward = true;
  } else if (oppositeEdges && edgeMap[key]) {
    oppositeEdges.isForward = true;
    edgeMap[key].isForward = false;
  }
  edgeMap[key] = edgeMap[key] || [];
  edgeMap[key].push(index2);
}
function getCurvenessForEdge(edge, seriesModel, index2, needReverse) {
  var autoCurvenessParams = getAutoCurvenessParams(seriesModel);
  var isArrayParam = isArray$1(autoCurvenessParams);
  if (!autoCurvenessParams) {
    return null;
  }
  var edgeArray = getEdgeFromMap(edge, seriesModel);
  if (!edgeArray) {
    return null;
  }
  var edgeIndex = -1;
  for (var i = 0; i < edgeArray.length; i++) {
    if (edgeArray[i] === index2) {
      edgeIndex = i;
      break;
    }
  }
  var totalLen = getTotalLengthBetweenNodes(edge, seriesModel);
  createCurveness(seriesModel, totalLen);
  edge.lineStyle = edge.lineStyle || {};
  var curKey = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  var curvenessList = seriesModel.__curvenessList;
  var parityCorrection = isArrayParam ? 0 : totalLen % 2 ? 0 : 1;
  if (!edgeArray.isForward) {
    var oppositeKey = getOppositeKey(curKey);
    var len2 = getEdgeMapLengthWithKey(oppositeKey, seriesModel);
    var resValue = curvenessList[edgeIndex + len2 + parityCorrection];
    if (needReverse) {
      if (isArrayParam) {
        if (autoCurvenessParams && autoCurvenessParams[0] === 0) {
          return (len2 + parityCorrection) % 2 ? resValue : -resValue;
        } else {
          return ((len2 % 2 ? 0 : 1) + parityCorrection) % 2 ? resValue : -resValue;
        }
      } else {
        return (len2 + parityCorrection) % 2 ? resValue : -resValue;
      }
    } else {
      return curvenessList[edgeIndex + len2 + parityCorrection];
    }
  } else {
    return curvenessList[parityCorrection + edgeIndex];
  }
}
function simpleLayout(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var graph = seriesModel.getGraph();
  graph.eachNode(function(node) {
    var model = node.getModel();
    node.setLayout([+model.get("x"), +model.get("y")]);
  });
  simpleLayoutEdge(graph, seriesModel);
}
function simpleLayoutEdge(graph, seriesModel) {
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, seriesModel, index2, true), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var points2 = [p1, p2];
    if (+curveness) {
      points2.push([(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * curveness]);
    }
    edge.setLayout(points2);
  });
}
function graphSimpleLayout(ecModel, api) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var layout2 = seriesModel.get("layout");
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      var data_1 = seriesModel.getData();
      var dimensions_1 = [];
      each$g(coordSys.dimensions, function(coordDim) {
        dimensions_1 = dimensions_1.concat(data_1.mapDimensionsAll(coordDim));
      });
      for (var dataIndex = 0; dataIndex < data_1.count(); dataIndex++) {
        var value = [];
        var hasValue = false;
        for (var i = 0; i < dimensions_1.length; i++) {
          var val = data_1.get(dimensions_1[i], dataIndex);
          if (!isNaN(val)) {
            hasValue = true;
          }
          value.push(val);
        }
        if (hasValue) {
          data_1.setItemLayout(dataIndex, coordSys.dataToPoint(value));
        } else {
          data_1.setItemLayout(dataIndex, [NaN, NaN]);
        }
      }
      simpleLayoutEdge(data_1.graph, seriesModel);
    } else if (!layout2 || layout2 === "none") {
      simpleLayout(seriesModel);
    }
  });
}
function getNodeGlobalScale(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys.type !== "view") {
    return 1;
  }
  var nodeScaleRatio = seriesModel.option.nodeScaleRatio;
  var groupZoom = coordSys.scaleX;
  var roamZoom = coordSys.getZoom();
  var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
  return nodeScale / groupZoom;
}
function getSymbolSize(node) {
  var symbolSize = node.getVisual("symbolSize");
  if (symbolSize instanceof Array) {
    symbolSize = (symbolSize[0] + symbolSize[1]) / 2;
  }
  return +symbolSize;
}
var PI$2 = Math.PI;
var _symbolRadiansHalf = [];
function circularLayout(seriesModel, basedOn) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var rect = coordSys.getBoundingRect();
  var nodeData = seriesModel.getData();
  var graph = nodeData.graph;
  var cx = rect.width / 2 + rect.x;
  var cy = rect.height / 2 + rect.y;
  var r2 = Math.min(rect.width, rect.height) / 2;
  var count2 = nodeData.count();
  nodeData.setLayout({
    cx,
    cy
  });
  if (!count2) {
    return;
  }
  _layoutNodesBasedOn[basedOn](seriesModel, graph, nodeData, r2, cx, cy, count2);
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), getCurvenessForEdge(edge, seriesModel, index2), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var cp1;
    var x12 = (p1[0] + p2[0]) / 2;
    var y12 = (p1[1] + p2[1]) / 2;
    if (+curveness) {
      curveness *= 3;
      cp1 = [cx * curveness + x12 * (1 - curveness), cy * curveness + y12 * (1 - curveness)];
    }
    edge.setLayout([p1, p2, cp1]);
  });
}
var _layoutNodesBasedOn = {
  value: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var angle = 0;
    var sum2 = nodeData.getSum("value");
    var unitAngle = Math.PI * 2 / (sum2 || count2);
    graph.eachNode(function(node) {
      var value = node.getValue("value");
      var radianHalf = unitAngle * (sum2 ? value : 1) / 2;
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  },
  symbolSize: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var sumRadian = 0;
    _symbolRadiansHalf.length = count2;
    var nodeScale = getNodeGlobalScale(seriesModel);
    graph.eachNode(function(node) {
      var symbolSize = getSymbolSize(node);
      isNaN(symbolSize) && (symbolSize = 2);
      symbolSize < 0 && (symbolSize = 0);
      symbolSize *= nodeScale;
      var symbolRadianHalf = Math.asin(symbolSize / 2 / r2);
      isNaN(symbolRadianHalf) && (symbolRadianHalf = PI$2 / 2);
      _symbolRadiansHalf[node.dataIndex] = symbolRadianHalf;
      sumRadian += symbolRadianHalf * 2;
    });
    var halfRemainRadian = (2 * PI$2 - sumRadian) / count2 / 2;
    var angle = 0;
    graph.eachNode(function(node) {
      var radianHalf = halfRemainRadian + _symbolRadiansHalf[node.dataIndex];
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  }
};
function graphCircularLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    if (seriesModel.get("layout") === "circular") {
      circularLayout(seriesModel, "symbolSize");
    }
  });
}
var scaleAndAdd = scaleAndAdd$1;
function forceLayout(inNodes, inEdges, opts) {
  var nodes = inNodes;
  var edges = inEdges;
  var rect = opts.rect;
  var width = rect.width;
  var height = rect.height;
  var center2 = [rect.x + width / 2, rect.y + height / 2];
  var gravity = opts.gravity == null ? 0.1 : opts.gravity;
  for (var i = 0; i < nodes.length; i++) {
    var n2 = nodes[i];
    if (!n2.p) {
      n2.p = create$2(width * (Math.random() - 0.5) + center2[0], height * (Math.random() - 0.5) + center2[1]);
    }
    n2.pp = clone$3(n2.p);
    n2.edges = null;
  }
  var initialFriction = opts.friction == null ? 0.6 : opts.friction;
  var friction = initialFriction;
  var beforeStepCallback;
  var afterStepCallback;
  return {
    warmUp: function() {
      friction = initialFriction * 0.8;
    },
    setFixed: function(idx) {
      nodes[idx].fixed = true;
    },
    setUnfixed: function(idx) {
      nodes[idx].fixed = false;
    },
    beforeStep: function(cb2) {
      beforeStepCallback = cb2;
    },
    afterStep: function(cb2) {
      afterStepCallback = cb2;
    },
    step: function(cb2) {
      beforeStepCallback && beforeStepCallback(nodes, edges);
      var v12 = [];
      var nLen = nodes.length;
      for (var i2 = 0; i2 < edges.length; i2++) {
        var e2 = edges[i2];
        if (e2.ignoreForceLayout) {
          continue;
        }
        var n1 = e2.n1;
        var n22 = e2.n2;
        sub(v12, n22.p, n1.p);
        var d2 = len(v12) - e2.d;
        var w2 = n22.w / (n1.w + n22.w);
        if (isNaN(w2)) {
          w2 = 0;
        }
        normalize$4(v12, v12);
        !n1.fixed && scaleAndAdd(n1.p, n1.p, v12, w2 * d2 * friction);
        !n22.fixed && scaleAndAdd(n22.p, n22.p, v12, -(1 - w2) * d2 * friction);
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v12, center2, n3.p);
          scaleAndAdd(n3.p, n3.p, v12, gravity * friction);
        }
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n1 = nodes[i2];
        for (var j = i2 + 1; j < nLen; j++) {
          var n22 = nodes[j];
          sub(v12, n22.p, n1.p);
          var d2 = len(v12);
          if (d2 === 0) {
            set$2(v12, Math.random() - 0.5, Math.random() - 0.5);
            d2 = 1;
          }
          var repFact = (n1.rep + n22.rep) / d2 / d2;
          !n1.fixed && scaleAndAdd(n1.pp, n1.pp, v12, repFact);
          !n22.fixed && scaleAndAdd(n22.pp, n22.pp, v12, -repFact);
        }
      }
      var v4 = [];
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v4, n3.p, n3.pp);
          scaleAndAdd(n3.p, n3.p, v4, friction);
          copy$1(n3.pp, n3.p);
        }
      }
      friction = friction * 0.992;
      var finished = friction < 0.01;
      afterStepCallback && afterStepCallback(nodes, edges, finished);
      cb2 && cb2(finished);
    }
  };
}
function graphForceLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var coordSys = graphSeries.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      return;
    }
    if (graphSeries.get("layout") === "force") {
      var preservedPoints_1 = graphSeries.preservedPoints || {};
      var graph_1 = graphSeries.getGraph();
      var nodeData_1 = graph_1.data;
      var edgeData = graph_1.edgeData;
      var forceModel = graphSeries.getModel("force");
      var initLayout = forceModel.get("initLayout");
      if (graphSeries.preservedPoints) {
        nodeData_1.each(function(idx) {
          var id2 = nodeData_1.getId(idx);
          nodeData_1.setItemLayout(idx, preservedPoints_1[id2] || [NaN, NaN]);
        });
      } else if (!initLayout || initLayout === "none") {
        simpleLayout(graphSeries);
      } else if (initLayout === "circular") {
        circularLayout(graphSeries, "value");
      }
      var nodeDataExtent_1 = nodeData_1.getDataExtent("value");
      var edgeDataExtent_1 = edgeData.getDataExtent("value");
      var repulsion = forceModel.get("repulsion");
      var edgeLength = forceModel.get("edgeLength");
      var repulsionArr_1 = isArray$1(repulsion) ? repulsion : [repulsion, repulsion];
      var edgeLengthArr_1 = isArray$1(edgeLength) ? edgeLength : [edgeLength, edgeLength];
      edgeLengthArr_1 = [edgeLengthArr_1[1], edgeLengthArr_1[0]];
      var nodes_1 = nodeData_1.mapArray("value", function(value, idx) {
        var point = nodeData_1.getItemLayout(idx);
        var rep = linearMap$2(value, nodeDataExtent_1, repulsionArr_1);
        if (isNaN(rep)) {
          rep = (repulsionArr_1[0] + repulsionArr_1[1]) / 2;
        }
        return {
          w: rep,
          rep,
          fixed: nodeData_1.getItemModel(idx).get("fixed"),
          p: !point || isNaN(point[0]) || isNaN(point[1]) ? null : point
        };
      });
      var edges = edgeData.mapArray("value", function(value, idx) {
        var edge = graph_1.getEdgeByIndex(idx);
        var d2 = linearMap$2(value, edgeDataExtent_1, edgeLengthArr_1);
        if (isNaN(d2)) {
          d2 = (edgeLengthArr_1[0] + edgeLengthArr_1[1]) / 2;
        }
        var edgeModel = edge.getModel();
        var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, graphSeries, idx, true), 0);
        return {
          n1: nodes_1[edge.node1.dataIndex],
          n2: nodes_1[edge.node2.dataIndex],
          d: d2,
          curveness,
          ignoreForceLayout: edgeModel.get("ignoreForceLayout")
        };
      });
      var rect = coordSys.getBoundingRect();
      var forceInstance = forceLayout(nodes_1, edges, {
        rect,
        gravity: forceModel.get("gravity"),
        friction: forceModel.get("friction")
      });
      forceInstance.beforeStep(function(nodes, edges2) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (nodes[i].fixed) {
            copy$1(nodes[i].p, graph_1.getNodeByIndex(i).getLayout());
          }
        }
      });
      forceInstance.afterStep(function(nodes, edges2, stopped) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (!nodes[i].fixed) {
            graph_1.getNodeByIndex(i).setLayout(nodes[i].p);
          }
          preservedPoints_1[nodeData_1.getId(i)] = nodes[i].p;
        }
        for (var i = 0, l2 = edges2.length; i < l2; i++) {
          var e2 = edges2[i];
          var edge = graph_1.getEdgeByIndex(i);
          var p1 = e2.n1.p;
          var p2 = e2.n2.p;
          var points2 = edge.getLayout();
          points2 = points2 ? points2.slice() : [];
          points2[0] = points2[0] || [];
          points2[1] = points2[1] || [];
          copy$1(points2[0], p1);
          copy$1(points2[1], p2);
          if (+e2.curveness) {
            points2[2] = [(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * e2.curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * e2.curveness];
          }
          edge.setLayout(points2);
        }
      });
      graphSeries.forceLayout = forceInstance;
      graphSeries.preservedPoints = preservedPoints_1;
      forceInstance.step();
    } else {
      graphSeries.forceLayout = null;
    }
  });
}
function getViewRect$3(seriesModel, api, aspect) {
  var option = extend(seriesModel.getBoxLayoutParams(), {
    aspect
  });
  return getLayoutRect(option, {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function createViewCoordSys(ecModel, api) {
  var viewList = [];
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var coordSysType = seriesModel.get("coordinateSystem");
    if (!coordSysType || coordSysType === "view") {
      var data_1 = seriesModel.getData();
      var positions = data_1.mapArray(function(idx) {
        var itemModel = data_1.getItemModel(idx);
        return [+itemModel.get("x"), +itemModel.get("y")];
      });
      var min3 = [];
      var max3 = [];
      fromPoints(positions, min3, max3);
      if (max3[0] - min3[0] === 0) {
        max3[0] += 1;
        min3[0] -= 1;
      }
      if (max3[1] - min3[1] === 0) {
        max3[1] += 1;
        min3[1] -= 1;
      }
      var aspect = (max3[0] - min3[0]) / (max3[1] - min3[1]);
      var viewRect2 = getViewRect$3(seriesModel, api, aspect);
      if (isNaN(aspect)) {
        min3 = [viewRect2.x, viewRect2.y];
        max3 = [viewRect2.x + viewRect2.width, viewRect2.y + viewRect2.height];
      }
      var bbWidth = max3[0] - min3[0];
      var bbHeight = max3[1] - min3[1];
      var viewWidth = viewRect2.width;
      var viewHeight = viewRect2.height;
      var viewCoordSys = seriesModel.coordinateSystem = new View$1();
      viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
      viewCoordSys.setBoundingRect(min3[0], min3[1], bbWidth, bbHeight);
      viewCoordSys.setViewRect(viewRect2.x, viewRect2.y, viewWidth, viewHeight);
      viewCoordSys.setCenter(seriesModel.get("center"));
      viewCoordSys.setZoom(seriesModel.get("zoom"));
      viewList.push(viewCoordSys);
    }
  });
  return viewList;
}
var straightLineProto = Line$3.prototype;
var bezierCurveProto = BezierCurve$1.prototype;
var StraightLineShape = function() {
  function StraightLineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return StraightLineShape2;
}();
(function(_super) {
  __extends(CurveShape, _super);
  function CurveShape() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return CurveShape;
})(StraightLineShape);
function isStraightLine(shape) {
  return isNaN(+shape.cpx1) || isNaN(+shape.cpy1);
}
var ECLinePath = function(_super) {
  __extends(ECLinePath2, _super);
  function ECLinePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-line";
    return _this;
  }
  ECLinePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECLinePath2.prototype.getDefaultShape = function() {
    return new StraightLineShape();
  };
  ECLinePath2.prototype.buildPath = function(ctx, shape) {
    if (isStraightLine(shape)) {
      straightLineProto.buildPath.call(this, ctx, shape);
    } else {
      bezierCurveProto.buildPath.call(this, ctx, shape);
    }
  };
  ECLinePath2.prototype.pointAt = function(t2) {
    if (isStraightLine(this.shape)) {
      return straightLineProto.pointAt.call(this, t2);
    } else {
      return bezierCurveProto.pointAt.call(this, t2);
    }
  };
  ECLinePath2.prototype.tangentAt = function(t2) {
    var shape = this.shape;
    var p2 = isStraightLine(shape) ? [shape.x2 - shape.x1, shape.y2 - shape.y1] : bezierCurveProto.tangentAt.call(this, t2);
    return normalize$4(p2, p2);
  };
  return ECLinePath2;
}(Path$1);
var ECLinePath$1 = ECLinePath;
var SYMBOL_CATEGORIES = ["fromSymbol", "toSymbol"];
function makeSymbolTypeKey(symbolCategory) {
  return "_" + symbolCategory + "Type";
}
function createSymbol(name, lineData, idx) {
  var symbolType = lineData.getItemVisual(idx, name);
  if (!symbolType || symbolType === "none") {
    return;
  }
  var symbolSize = lineData.getItemVisual(idx, name + "Size");
  var symbolRotate = lineData.getItemVisual(idx, name + "Rotate");
  var symbolOffset = lineData.getItemVisual(idx, name + "Offset");
  var symbolKeepAspect = lineData.getItemVisual(idx, name + "KeepAspect");
  var symbolSizeArr = normalizeSymbolSize(symbolSize);
  var symbolOffsetArr = normalizeSymbolOffset(symbolOffset || 0, symbolSizeArr);
  var symbolPath = createSymbol$1(symbolType, -symbolSizeArr[0] / 2 + symbolOffsetArr[0], -symbolSizeArr[1] / 2 + symbolOffsetArr[1], symbolSizeArr[0], symbolSizeArr[1], null, symbolKeepAspect);
  symbolPath.__specifiedRotation = symbolRotate == null || isNaN(symbolRotate) ? void 0 : +symbolRotate * Math.PI / 180 || 0;
  symbolPath.name = name;
  return symbolPath;
}
function createLine(points2) {
  var line = new ECLinePath$1({
    name: "line",
    subPixelOptimize: true
  });
  setLinePoints(line.shape, points2);
  return line;
}
function setLinePoints(targetShape, points2) {
  targetShape.x1 = points2[0][0];
  targetShape.y1 = points2[0][1];
  targetShape.x2 = points2[1][0];
  targetShape.y2 = points2[1][1];
  targetShape.percent = 1;
  var cp1 = points2[2];
  if (cp1) {
    targetShape.cpx1 = cp1[0];
    targetShape.cpy1 = cp1[1];
  } else {
    targetShape.cpx1 = NaN;
    targetShape.cpy1 = NaN;
  }
}
var Line = function(_super) {
  __extends(Line2, _super);
  function Line2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createLine(lineData, idx, seriesScope);
    return _this;
  }
  Line2.prototype._createLine = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var linePoints = lineData.getItemLayout(idx);
    var line = createLine(linePoints);
    line.shape.percent = 0;
    initProps(line, {
      shape: {
        percent: 1
      }
    }, seriesModel, idx);
    this.add(line);
    each$g(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = createSymbol(symbolCategory, lineData, idx);
      this.add(symbol);
      this[makeSymbolTypeKey(symbolCategory)] = lineData.getItemVisual(idx, symbolCategory);
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var linePoints = lineData.getItemLayout(idx);
    var target = {
      shape: {}
    };
    setLinePoints(target.shape, linePoints);
    updateProps$1(line, target, seriesModel, idx);
    each$g(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbolType = lineData.getItemVisual(idx, symbolCategory);
      var key = makeSymbolTypeKey(symbolCategory);
      if (this[key] !== symbolType) {
        this.remove(this.childOfName(symbolCategory));
        var symbol = createSymbol(symbolCategory, lineData, idx);
        this.add(symbol);
      }
      this[key] = symbolType;
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.getLinePath = function() {
    return this.childAt(0);
  };
  Line2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var blurLineStyle = seriesScope && seriesScope.blurLineStyle;
    var selectLineStyle = seriesScope && seriesScope.selectLineStyle;
    var labelStatesModels = seriesScope && seriesScope.labelStatesModels;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    if (!seriesScope || lineData.hasItemOption) {
      var itemModel = lineData.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      blurLineStyle = itemModel.getModel(["blur", "lineStyle"]).getLineStyle();
      selectLineStyle = itemModel.getModel(["select", "lineStyle"]).getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      labelStatesModels = getLabelStatesModels(itemModel);
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var visualColor = lineStyle.stroke;
    line.useStyle(lineStyle);
    line.style.fill = null;
    line.style.strokeNoScale = true;
    line.ensureState("emphasis").style = emphasisLineStyle;
    line.ensureState("blur").style = blurLineStyle;
    line.ensureState("select").style = selectLineStyle;
    each$g(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = this.childOfName(symbolCategory);
      if (symbol) {
        symbol.setColor(visualColor);
        symbol.style.opacity = lineStyle.opacity;
        for (var i = 0; i < SPECIAL_STATES.length; i++) {
          var stateName = SPECIAL_STATES[i];
          var lineState = line.getState(stateName);
          if (lineState) {
            var lineStateStyle = lineState.style || {};
            var state = symbol.ensureState(stateName);
            var stateStyle = state.style || (state.style = {});
            if (lineStateStyle.stroke != null) {
              stateStyle[symbol.__isEmptyBrush ? "stroke" : "fill"] = lineStateStyle.stroke;
            }
            if (lineStateStyle.opacity != null) {
              stateStyle.opacity = lineStateStyle.opacity;
            }
          }
        }
        symbol.markRedraw();
      }
    }, this);
    var rawVal = seriesModel.getRawValue(idx);
    setLabelStyle(this, labelStatesModels, {
      labelDataIndex: idx,
      labelFetcher: {
        getFormattedLabel: function(dataIndex, stateName) {
          return seriesModel.getFormattedLabel(dataIndex, stateName, lineData.dataType);
        }
      },
      inheritColor: visualColor || "#000",
      defaultOpacity: lineStyle.opacity,
      defaultText: (rawVal == null ? lineData.getName(idx) : isFinite(rawVal) ? round$3(rawVal) : rawVal) + ""
    });
    var label = this.getTextContent();
    if (label) {
      var labelNormalModel = labelStatesModels.normal;
      label.__align = label.style.align;
      label.__verticalAlign = label.style.verticalAlign;
      label.__position = labelNormalModel.get("position") || "middle";
      var distance2 = labelNormalModel.get("distance");
      if (!isArray$1(distance2)) {
        distance2 = [distance2, distance2];
      }
      label.__labelDistance = distance2;
    }
    this.setTextConfig({
      position: null,
      local: true,
      inside: false
    });
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Line2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  Line2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  Line2.prototype.updateLayout = function(lineData, idx) {
    this.setLinePoints(lineData.getItemLayout(idx));
  };
  Line2.prototype.setLinePoints = function(points2) {
    var linePath = this.childOfName("line");
    setLinePoints(linePath.shape, points2);
    linePath.dirty();
  };
  Line2.prototype.beforeUpdate = function() {
    var lineGroup = this;
    var symbolFrom = lineGroup.childOfName("fromSymbol");
    var symbolTo = lineGroup.childOfName("toSymbol");
    var label = lineGroup.getTextContent();
    if (!symbolFrom && !symbolTo && (!label || label.ignore)) {
      return;
    }
    var invScale = 1;
    var parentNode2 = this.parent;
    while (parentNode2) {
      if (parentNode2.scaleX) {
        invScale /= parentNode2.scaleX;
      }
      parentNode2 = parentNode2.parent;
    }
    var line = lineGroup.childOfName("line");
    if (!this.__dirty && !line.__dirty) {
      return;
    }
    var percent = line.shape.percent;
    var fromPos = line.pointAt(0);
    var toPos = line.pointAt(percent);
    var d2 = sub([], toPos, fromPos);
    normalize$4(d2, d2);
    function setSymbolRotation(symbol, percent2) {
      var specifiedRotation = symbol.__specifiedRotation;
      if (specifiedRotation == null) {
        var tangent2 = line.tangentAt(percent2);
        symbol.attr("rotation", (percent2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(tangent2[1], tangent2[0]));
      } else {
        symbol.attr("rotation", specifiedRotation);
      }
    }
    if (symbolFrom) {
      symbolFrom.setPosition(fromPos);
      setSymbolRotation(symbolFrom, 0);
      symbolFrom.scaleX = symbolFrom.scaleY = invScale * percent;
      symbolFrom.markRedraw();
    }
    if (symbolTo) {
      symbolTo.setPosition(toPos);
      setSymbolRotation(symbolTo, 1);
      symbolTo.scaleX = symbolTo.scaleY = invScale * percent;
      symbolTo.markRedraw();
    }
    if (label && !label.ignore) {
      label.x = label.y = 0;
      label.originX = label.originY = 0;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var distance2 = label.__labelDistance;
      var distanceX = distance2[0] * invScale;
      var distanceY = distance2[1] * invScale;
      var halfPercent = percent / 2;
      var tangent = line.tangentAt(halfPercent);
      var n2 = [tangent[1], -tangent[0]];
      var cp = line.pointAt(halfPercent);
      if (n2[1] > 0) {
        n2[0] = -n2[0];
        n2[1] = -n2[1];
      }
      var dir3 = tangent[0] < 0 ? -1 : 1;
      if (label.__position !== "start" && label.__position !== "end") {
        var rotation = -Math.atan2(tangent[1], tangent[0]);
        if (toPos[0] < fromPos[0]) {
          rotation = Math.PI + rotation;
        }
        label.rotation = rotation;
      }
      var dy = void 0;
      switch (label.__position) {
        case "insideStartTop":
        case "insideMiddleTop":
        case "insideEndTop":
        case "middle":
          dy = -distanceY;
          textVerticalAlign = "bottom";
          break;
        case "insideStartBottom":
        case "insideMiddleBottom":
        case "insideEndBottom":
          dy = distanceY;
          textVerticalAlign = "top";
          break;
        default:
          dy = 0;
          textVerticalAlign = "middle";
      }
      switch (label.__position) {
        case "end":
          label.x = d2[0] * distanceX + toPos[0];
          label.y = d2[1] * distanceY + toPos[1];
          textAlign = d2[0] > 0.8 ? "left" : d2[0] < -0.8 ? "right" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "top" : d2[1] < -0.8 ? "bottom" : "middle";
          break;
        case "start":
          label.x = -d2[0] * distanceX + fromPos[0];
          label.y = -d2[1] * distanceY + fromPos[1];
          textAlign = d2[0] > 0.8 ? "right" : d2[0] < -0.8 ? "left" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "bottom" : d2[1] < -0.8 ? "top" : "middle";
          break;
        case "insideStartTop":
        case "insideStart":
        case "insideStartBottom":
          label.x = distanceX * dir3 + fromPos[0];
          label.y = fromPos[1] + dy;
          textAlign = tangent[0] < 0 ? "right" : "left";
          label.originX = -distanceX * dir3;
          label.originY = -dy;
          break;
        case "insideMiddleTop":
        case "insideMiddle":
        case "insideMiddleBottom":
        case "middle":
          label.x = cp[0];
          label.y = cp[1] + dy;
          textAlign = "center";
          label.originY = -dy;
          break;
        case "insideEndTop":
        case "insideEnd":
        case "insideEndBottom":
          label.x = -distanceX * dir3 + toPos[0];
          label.y = toPos[1] + dy;
          textAlign = tangent[0] >= 0 ? "right" : "left";
          label.originX = distanceX * dir3;
          label.originY = -dy;
          break;
      }
      label.scaleX = label.scaleY = invScale;
      label.setStyle({
        verticalAlign: label.__verticalAlign || textVerticalAlign,
        align: label.__align || textAlign
      });
    }
  };
  return Line2;
}(Group$6);
var Line$1 = Line;
var LineDraw = function() {
  function LineDraw2(LineCtor) {
    this.group = new Group$6();
    this._LineCtor = LineCtor || Line$1;
  }
  LineDraw2.prototype.updateData = function(lineData) {
    var _this = this;
    this._progressiveEls = null;
    var lineDraw = this;
    var group = lineDraw.group;
    var oldLineData = lineDraw._lineData;
    lineDraw._lineData = lineData;
    if (!oldLineData) {
      group.removeAll();
    }
    var seriesScope = makeSeriesScope$1(lineData);
    lineData.diff(oldLineData).add(function(idx) {
      _this._doAdd(lineData, idx, seriesScope);
    }).update(function(newIdx, oldIdx) {
      _this._doUpdate(oldLineData, lineData, oldIdx, newIdx, seriesScope);
    }).remove(function(idx) {
      group.remove(oldLineData.getItemGraphicEl(idx));
    }).execute();
  };
  LineDraw2.prototype.updateLayout = function() {
    var lineData = this._lineData;
    if (!lineData) {
      return;
    }
    lineData.eachItemGraphicEl(function(el, idx) {
      el.updateLayout(lineData, idx);
    }, this);
  };
  LineDraw2.prototype.incrementalPrepareUpdate = function(lineData) {
    this._seriesScope = makeSeriesScope$1(lineData);
    this._lineData = null;
    this.group.removeAll();
  };
  LineDraw2.prototype.incrementalUpdate = function(taskParams, lineData) {
    this._progressiveEls = [];
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup && !isEffectObject(el2)) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var itemLayout = lineData.getItemLayout(idx);
      if (lineNeedsDraw(itemLayout)) {
        var el = new this._LineCtor(lineData, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        this.group.add(el);
        lineData.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  LineDraw2.prototype.remove = function() {
    this.group.removeAll();
  };
  LineDraw2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  LineDraw2.prototype._doAdd = function(lineData, idx, seriesScope) {
    var itemLayout = lineData.getItemLayout(idx);
    if (!lineNeedsDraw(itemLayout)) {
      return;
    }
    var el = new this._LineCtor(lineData, idx, seriesScope);
    lineData.setItemGraphicEl(idx, el);
    this.group.add(el);
  };
  LineDraw2.prototype._doUpdate = function(oldLineData, newLineData, oldIdx, newIdx, seriesScope) {
    var itemEl = oldLineData.getItemGraphicEl(oldIdx);
    if (!lineNeedsDraw(newLineData.getItemLayout(newIdx))) {
      this.group.remove(itemEl);
      return;
    }
    if (!itemEl) {
      itemEl = new this._LineCtor(newLineData, newIdx, seriesScope);
    } else {
      itemEl.updateData(newLineData, newIdx, seriesScope);
    }
    newLineData.setItemGraphicEl(newIdx, itemEl);
    this.group.add(itemEl);
  };
  return LineDraw2;
}();
function isEffectObject(el) {
  return el.animators && el.animators.length > 0;
}
function makeSeriesScope$1(lineData) {
  var hostModel = lineData.hostModel;
  var emphasisModel = hostModel.getModel("emphasis");
  return {
    lineStyle: hostModel.getModel("lineStyle").getLineStyle(),
    emphasisLineStyle: emphasisModel.getModel(["lineStyle"]).getLineStyle(),
    blurLineStyle: hostModel.getModel(["blur", "lineStyle"]).getLineStyle(),
    selectLineStyle: hostModel.getModel(["select", "lineStyle"]).getLineStyle(),
    emphasisDisabled: emphasisModel.get("disabled"),
    blurScope: emphasisModel.get("blurScope"),
    focus: emphasisModel.get("focus"),
    labelStatesModels: getLabelStatesModels(hostModel)
  };
}
function isPointNaN(pt) {
  return isNaN(pt[0]) || isNaN(pt[1]);
}
function lineNeedsDraw(pts) {
  return pts && !isPointNaN(pts[0]) && !isPointNaN(pts[1]);
}
var LineDraw$1 = LineDraw;
var v1 = [];
var v2 = [];
var v3 = [];
var quadraticAt = quadraticAt$1;
var v2DistSquare = distSquare;
var mathAbs = Math.abs;
function intersectCurveCircle(curvePoints, center2, radius) {
  var p0 = curvePoints[0];
  var p1 = curvePoints[1];
  var p2 = curvePoints[2];
  var d2 = Infinity;
  var t2;
  var radiusSquare = radius * radius;
  var interval = 0.1;
  for (var _t = 0.1; _t <= 0.9; _t += 0.1) {
    v1[0] = quadraticAt(p0[0], p1[0], p2[0], _t);
    v1[1] = quadraticAt(p0[1], p1[1], p2[1], _t);
    var diff = mathAbs(v2DistSquare(v1, center2) - radiusSquare);
    if (diff < d2) {
      d2 = diff;
      t2 = _t;
    }
  }
  for (var i = 0; i < 32; i++) {
    var next = t2 + interval;
    v2[0] = quadraticAt(p0[0], p1[0], p2[0], t2);
    v2[1] = quadraticAt(p0[1], p1[1], p2[1], t2);
    v3[0] = quadraticAt(p0[0], p1[0], p2[0], next);
    v3[1] = quadraticAt(p0[1], p1[1], p2[1], next);
    var diff = v2DistSquare(v2, center2) - radiusSquare;
    if (mathAbs(diff) < 0.01) {
      break;
    }
    var nextDiff = v2DistSquare(v3, center2) - radiusSquare;
    interval /= 2;
    if (diff < 0) {
      if (nextDiff >= 0) {
        t2 = t2 + interval;
      } else {
        t2 = t2 - interval;
      }
    } else {
      if (nextDiff >= 0) {
        t2 = t2 - interval;
      } else {
        t2 = t2 + interval;
      }
    }
  }
  return t2;
}
function adjustEdge(graph, scale2) {
  var tmp0 = [];
  var quadraticSubdivide$1 = quadraticSubdivide;
  var pts = [[], [], []];
  var pts2 = [[], []];
  var v4 = [];
  scale2 /= 2;
  graph.eachEdge(function(edge, idx) {
    var linePoints = edge.getLayout();
    var fromSymbol = edge.getVisual("fromSymbol");
    var toSymbol = edge.getVisual("toSymbol");
    if (!linePoints.__original) {
      linePoints.__original = [clone$3(linePoints[0]), clone$3(linePoints[1])];
      if (linePoints[2]) {
        linePoints.__original.push(clone$3(linePoints[2]));
      }
    }
    var originalPoints = linePoints.__original;
    if (linePoints[2] != null) {
      copy$1(pts[0], originalPoints[0]);
      copy$1(pts[1], originalPoints[2]);
      copy$1(pts[2], originalPoints[1]);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        var t2 = intersectCurveCircle(pts, originalPoints[0], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[0][0] = tmp0[3];
        pts[1][0] = tmp0[4];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[0][1] = tmp0[3];
        pts[1][1] = tmp0[4];
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        var t2 = intersectCurveCircle(pts, originalPoints[1], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[1][0] = tmp0[1];
        pts[2][0] = tmp0[2];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[1][1] = tmp0[1];
        pts[2][1] = tmp0[2];
      }
      copy$1(linePoints[0], pts[0]);
      copy$1(linePoints[1], pts[2]);
      copy$1(linePoints[2], pts[1]);
    } else {
      copy$1(pts2[0], originalPoints[0]);
      copy$1(pts2[1], originalPoints[1]);
      sub(v4, pts2[1], pts2[0]);
      normalize$4(v4, v4);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        scaleAndAdd$1(pts2[0], pts2[0], v4, symbolSize * scale2);
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        scaleAndAdd$1(pts2[1], pts2[1], v4, -symbolSize * scale2);
      }
      copy$1(linePoints[0], pts2[0]);
      copy$1(linePoints[1], pts2[1]);
    }
  });
}
function isViewCoordSys(coordSys) {
  return coordSys.type === "view";
}
var GraphView = function(_super) {
  __extends(GraphView2, _super);
  function GraphView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphView2.type;
    return _this;
  }
  GraphView2.prototype.init = function(ecModel, api) {
    var symbolDraw = new SymbolDraw$1();
    var lineDraw = new LineDraw$1();
    var group = this.group;
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    group.add(symbolDraw.group);
    group.add(lineDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineDraw = lineDraw;
    this._firstRender = true;
  };
  GraphView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    this._model = seriesModel;
    var symbolDraw = this._symbolDraw;
    var lineDraw = this._lineDraw;
    var group = this.group;
    if (isViewCoordSys(coordSys)) {
      var groupNewProp = {
        x: coordSys.x,
        y: coordSys.y,
        scaleX: coordSys.scaleX,
        scaleY: coordSys.scaleY
      };
      if (this._firstRender) {
        group.attr(groupNewProp);
      } else {
        updateProps$1(group, groupNewProp, seriesModel);
      }
    }
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    var data = seriesModel.getData();
    symbolDraw.updateData(data);
    var edgeData = seriesModel.getEdgeData();
    lineDraw.updateData(edgeData);
    this._updateNodeAndLinkScale();
    this._updateController(seriesModel, ecModel, api);
    clearTimeout(this._layoutTimeout);
    var forceLayout2 = seriesModel.forceLayout;
    var layoutAnimation = seriesModel.get(["force", "layoutAnimation"]);
    if (forceLayout2) {
      this._startForceLayoutIteration(forceLayout2, layoutAnimation);
    }
    data.graph.eachNode(function(node) {
      var idx = node.dataIndex;
      var el = node.getGraphicEl();
      var itemModel = node.getModel();
      if (!el) {
        return;
      }
      el.off("drag").off("dragend");
      var draggable = itemModel.get("draggable");
      if (draggable) {
        el.on("drag", function() {
          if (forceLayout2) {
            forceLayout2.warmUp();
            !_this._layouting && _this._startForceLayoutIteration(forceLayout2, layoutAnimation);
            forceLayout2.setFixed(idx);
            data.setItemLayout(idx, [el.x, el.y]);
          }
        }).on("dragend", function() {
          if (forceLayout2) {
            forceLayout2.setUnfixed(idx);
          }
        });
      }
      el.setDraggable(draggable && !!forceLayout2);
      var focus = itemModel.get(["emphasis", "focus"]);
      if (focus === "adjacency") {
        getECData(el).focus = node.getAdjacentDataIndices();
      }
    });
    data.graph.eachEdge(function(edge) {
      var el = edge.getGraphicEl();
      var focus = edge.getModel().get(["emphasis", "focus"]);
      if (!el) {
        return;
      }
      if (focus === "adjacency") {
        getECData(el).focus = {
          edge: [edge.dataIndex],
          node: [edge.node1.dataIndex, edge.node2.dataIndex]
        };
      }
    });
    var circularRotateLabel = seriesModel.get("layout") === "circular" && seriesModel.get(["circular", "rotateLabel"]);
    var cx = data.getLayout("cx");
    var cy = data.getLayout("cy");
    data.eachItemGraphicEl(function(el, idx) {
      var itemModel = data.getItemModel(idx);
      var labelRotate = itemModel.get(["label", "rotate"]) || 0;
      var symbolPath = el.getSymbolPath();
      if (circularRotateLabel) {
        var pos = data.getItemLayout(idx);
        var rad = Math.atan2(pos[1] - cy, pos[0] - cx);
        if (rad < 0) {
          rad = Math.PI * 2 + rad;
        }
        var isLeft = pos[0] < cx;
        if (isLeft) {
          rad = rad - Math.PI;
        }
        var textPosition = isLeft ? "left" : "right";
        symbolPath.setTextConfig({
          rotation: -rad,
          position: textPosition,
          origin: "center"
        });
        var emphasisState = symbolPath.ensureState("emphasis");
        extend(emphasisState.textConfig || (emphasisState.textConfig = {}), {
          position: textPosition
        });
      } else {
        symbolPath.setTextConfig({
          rotation: labelRotate *= Math.PI / 180
        });
      }
    });
    this._firstRender = false;
  };
  GraphView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  GraphView2.prototype._startForceLayoutIteration = function(forceLayout2, layoutAnimation) {
    var self2 = this;
    (function step() {
      forceLayout2.step(function(stopped) {
        self2.updateLayout(self2._model);
        (self2._layouting = !stopped) && (layoutAnimation ? self2._layoutTimeout = setTimeout(step, 16) : step());
      });
    })();
  };
  GraphView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    if (!isViewCoordSys(seriesModel.coordinateSystem)) {
      controller.disable();
      return;
    }
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale();
      adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
      _this._lineDraw.updateLayout();
      api.updateLabelLayout();
    });
  };
  GraphView2.prototype._updateNodeAndLinkScale = function() {
    var seriesModel = this._model;
    var data = seriesModel.getData();
    var nodeScale = getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el && el.setSymbolScale(nodeScale);
    });
  };
  GraphView2.prototype.updateLayout = function(seriesModel) {
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    this._symbolDraw.updateLayout();
    this._lineDraw.updateLayout();
  };
  GraphView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove();
    this._lineDraw && this._lineDraw.remove();
  };
  GraphView2.type = "graph";
  return GraphView2;
}(ChartView$1);
var GraphView$1 = GraphView;
function generateNodeKey(id2) {
  return "_EC_" + id2;
}
var Graph = function() {
  function Graph2(directed) {
    this.type = "graph";
    this.nodes = [];
    this.edges = [];
    this._nodesMap = {};
    this._edgesMap = {};
    this._directed = directed || false;
  }
  Graph2.prototype.isDirected = function() {
    return this._directed;
  };
  Graph2.prototype.addNode = function(id2, dataIndex) {
    id2 = id2 == null ? "" + dataIndex : "" + id2;
    var nodesMap = this._nodesMap;
    if (nodesMap[generateNodeKey(id2)]) {
      return;
    }
    var node = new GraphNode(id2, dataIndex);
    node.hostGraph = this;
    this.nodes.push(node);
    nodesMap[generateNodeKey(id2)] = node;
    return node;
  };
  Graph2.prototype.getNodeByIndex = function(dataIndex) {
    var rawIdx = this.data.getRawIndex(dataIndex);
    return this.nodes[rawIdx];
  };
  Graph2.prototype.getNodeById = function(id2) {
    return this._nodesMap[generateNodeKey(id2)];
  };
  Graph2.prototype.addEdge = function(n1, n2, dataIndex) {
    var nodesMap = this._nodesMap;
    var edgesMap = this._edgesMap;
    if (isNumber(n1)) {
      n1 = this.nodes[n1];
    }
    if (isNumber(n2)) {
      n2 = this.nodes[n2];
    }
    if (!(n1 instanceof GraphNode)) {
      n1 = nodesMap[generateNodeKey(n1)];
    }
    if (!(n2 instanceof GraphNode)) {
      n2 = nodesMap[generateNodeKey(n2)];
    }
    if (!n1 || !n2) {
      return;
    }
    var key = n1.id + "-" + n2.id;
    var edge = new GraphEdge(n1, n2, dataIndex);
    edge.hostGraph = this;
    if (this._directed) {
      n1.outEdges.push(edge);
      n2.inEdges.push(edge);
    }
    n1.edges.push(edge);
    if (n1 !== n2) {
      n2.edges.push(edge);
    }
    this.edges.push(edge);
    edgesMap[key] = edge;
    return edge;
  };
  Graph2.prototype.getEdgeByIndex = function(dataIndex) {
    var rawIdx = this.edgeData.getRawIndex(dataIndex);
    return this.edges[rawIdx];
  };
  Graph2.prototype.getEdge = function(n1, n2) {
    if (n1 instanceof GraphNode) {
      n1 = n1.id;
    }
    if (n2 instanceof GraphNode) {
      n2 = n2.id;
    }
    var edgesMap = this._edgesMap;
    if (this._directed) {
      return edgesMap[n1 + "-" + n2];
    } else {
      return edgesMap[n1 + "-" + n2] || edgesMap[n2 + "-" + n1];
    }
  };
  Graph2.prototype.eachNode = function(cb2, context) {
    var nodes = this.nodes;
    var len2 = nodes.length;
    for (var i = 0; i < len2; i++) {
      if (nodes[i].dataIndex >= 0) {
        cb2.call(context, nodes[i], i);
      }
    }
  };
  Graph2.prototype.eachEdge = function(cb2, context) {
    var edges = this.edges;
    var len2 = edges.length;
    for (var i = 0; i < len2; i++) {
      if (edges[i].dataIndex >= 0 && edges[i].node1.dataIndex >= 0 && edges[i].node2.dataIndex >= 0) {
        cb2.call(context, edges[i], i);
      }
    }
  };
  Graph2.prototype.breadthFirstTraverse = function(cb2, startNode, direction, context) {
    if (!(startNode instanceof GraphNode)) {
      startNode = this._nodesMap[generateNodeKey(startNode)];
    }
    if (!startNode) {
      return;
    }
    var edgeType = direction === "out" ? "outEdges" : direction === "in" ? "inEdges" : "edges";
    for (var i = 0; i < this.nodes.length; i++) {
      this.nodes[i].__visited = false;
    }
    if (cb2.call(context, startNode, null)) {
      return;
    }
    var queue = [startNode];
    while (queue.length) {
      var currentNode = queue.shift();
      var edges = currentNode[edgeType];
      for (var i = 0; i < edges.length; i++) {
        var e2 = edges[i];
        var otherNode = e2.node1 === currentNode ? e2.node2 : e2.node1;
        if (!otherNode.__visited) {
          if (cb2.call(context, otherNode, currentNode)) {
            return;
          }
          queue.push(otherNode);
          otherNode.__visited = true;
        }
      }
    }
  };
  Graph2.prototype.update = function() {
    var data = this.data;
    var edgeData = this.edgeData;
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
    edgeData.filterSelf(function(idx) {
      var edge = edges[edgeData.getRawIndex(idx)];
      return edge.node1.dataIndex >= 0 && edge.node2.dataIndex >= 0;
    });
    for (var i = 0, len2 = edges.length; i < len2; i++) {
      edges[i].dataIndex = -1;
    }
    for (var i = 0, len2 = edgeData.count(); i < len2; i++) {
      edges[edgeData.getRawIndex(i)].dataIndex = i;
    }
  };
  Graph2.prototype.clone = function() {
    var graph = new Graph2(this._directed);
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0; i < nodes.length; i++) {
      graph.addNode(nodes[i].id, nodes[i].dataIndex);
    }
    for (var i = 0; i < edges.length; i++) {
      var e2 = edges[i];
      graph.addEdge(e2.node1.id, e2.node2.id, e2.dataIndex);
    }
    return graph;
  };
  return Graph2;
}();
var GraphNode = function() {
  function GraphNode2(id2, dataIndex) {
    this.inEdges = [];
    this.outEdges = [];
    this.edges = [];
    this.dataIndex = -1;
    this.id = id2 == null ? "" : id2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphNode2.prototype.degree = function() {
    return this.edges.length;
  };
  GraphNode2.prototype.inDegree = function() {
    return this.inEdges.length;
  };
  GraphNode2.prototype.outDegree = function() {
    return this.outEdges.length;
  };
  GraphNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphNode2.prototype.getAdjacentDataIndices = function() {
    var dataIndices = {
      edge: [],
      node: []
    };
    for (var i = 0; i < this.edges.length; i++) {
      var adjacentEdge = this.edges[i];
      if (adjacentEdge.dataIndex < 0) {
        continue;
      }
      dataIndices.edge.push(adjacentEdge.dataIndex);
      dataIndices.node.push(adjacentEdge.node1.dataIndex, adjacentEdge.node2.dataIndex);
    }
    return dataIndices;
  };
  return GraphNode2;
}();
var GraphEdge = function() {
  function GraphEdge2(n1, n2, dataIndex) {
    this.dataIndex = -1;
    this.node1 = n1;
    this.node2 = n2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphEdge2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.edgeData.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphEdge2.prototype.getAdjacentDataIndices = function() {
    return {
      edge: [this.dataIndex],
      node: [this.node1.dataIndex, this.node2.dataIndex]
    };
  };
  return GraphEdge2;
}();
function createGraphDataProxyMixin(hostName, dataName) {
  return {
    getValue: function(dimension) {
      var data = this[hostName][dataName];
      return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
    },
    setVisual: function(key, value) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemVisual(this.dataIndex, key, value);
    },
    getVisual: function(key) {
      return this[hostName][dataName].getItemVisual(this.dataIndex, key);
    },
    setLayout: function(layout2, merge3) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemLayout(this.dataIndex, layout2, merge3);
    },
    getLayout: function() {
      return this[hostName][dataName].getItemLayout(this.dataIndex);
    },
    getGraphicEl: function() {
      return this[hostName][dataName].getItemGraphicEl(this.dataIndex);
    },
    getRawIndex: function() {
      return this[hostName][dataName].getRawIndex(this.dataIndex);
    }
  };
}
mixin(GraphNode, createGraphDataProxyMixin("hostGraph", "data"));
mixin(GraphEdge, createGraphDataProxyMixin("hostGraph", "edgeData"));
var Graph$1 = Graph;
function createGraphFromNodeEdge(nodes, edges, seriesModel, directed, beforeLink) {
  var graph = new Graph$1(directed);
  for (var i = 0; i < nodes.length; i++) {
    graph.addNode(retrieve(nodes[i].id, nodes[i].name, i), i);
  }
  var linkNameList = [];
  var validEdges = [];
  var linkCount = 0;
  for (var i = 0; i < edges.length; i++) {
    var link = edges[i];
    var source = link.source;
    var target = link.target;
    if (graph.addEdge(source, target, linkCount)) {
      validEdges.push(link);
      linkNameList.push(retrieve(convertOptionIdName(link.id, null), source + " > " + target));
      linkCount++;
    }
  }
  var coordSys = seriesModel.get("coordinateSystem");
  var nodeData;
  if (coordSys === "cartesian2d" || coordSys === "polar") {
    nodeData = createSeriesData(nodes, seriesModel);
  } else {
    var coordSysCtor = CoordinateSystem.get(coordSys);
    var coordDimensions = coordSysCtor ? coordSysCtor.dimensions || [] : [];
    if (indexOf(coordDimensions, "value") < 0) {
      coordDimensions.concat(["value"]);
    }
    var dimensions = prepareSeriesDataSchema(nodes, {
      coordDimensions,
      encodeDefine: seriesModel.getEncode()
    }).dimensions;
    nodeData = new SeriesData$1(dimensions, seriesModel);
    nodeData.initData(nodes);
  }
  var edgeData = new SeriesData$1(["value"], seriesModel);
  edgeData.initData(validEdges, linkNameList);
  beforeLink && beforeLink(nodeData, edgeData);
  linkSeriesData({
    mainData: nodeData,
    struct: graph,
    structAttr: "graph",
    datas: {
      node: nodeData,
      edge: edgeData
    },
    datasAttr: {
      node: "data",
      edge: "edgeData"
    }
  });
  graph.update();
  return graph;
}
var GraphSeriesModel = function(_super) {
  __extends(GraphSeriesModel2, _super);
  function GraphSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  GraphSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    var self2 = this;
    function getCategoriesData() {
      return self2._categoriesData;
    }
    this.legendVisualProvider = new LegendVisualProvider$1(getCategoriesData, getCategoriesData);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeDefaultAndTheme = function(option) {
    _super.prototype.mergeDefaultAndTheme.apply(this, arguments);
    defaultEmphasis(option, "edgeLabel", ["show"]);
  };
  GraphSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var edges = option.edges || option.links || [];
    var nodes = option.data || option.nodes || [];
    var self2 = this;
    if (nodes && edges) {
      initCurvenessList(this);
      var graph = createGraphFromNodeEdge(nodes, edges, this, true, beforeLink);
      each$g(graph.edges, function(edge) {
        createEdgeMapForCurveness(edge.node1, edge.node2, this, edge.dataIndex);
      }, this);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model) {
        var categoriesModels = self2._categoriesModels;
        var categoryIdx = model.getShallow("category");
        var categoryModel = categoriesModels[categoryIdx];
        if (categoryModel) {
          categoryModel.parentModel = model.parentModel;
          model.parentModel = categoryModel;
        }
        return model;
      });
      var oldGetModel = Model$1.prototype.getModel;
      function newGetModel(path, parentModel) {
        var model = oldGetModel.call(this, path, parentModel);
        model.resolveParentPath = resolveParentPath;
        return model;
      }
      edgeData.wrapMethod("getItemModel", function(model) {
        model.resolveParentPath = resolveParentPath;
        model.getModel = newGetModel;
        return model;
      });
      function resolveParentPath(pathArr) {
        if (pathArr && (pathArr[0] === "label" || pathArr[1] === "label")) {
          var newPathArr = pathArr.slice();
          if (pathArr[0] === "label") {
            newPathArr[0] = "edgeLabel";
          } else if (pathArr[1] === "label") {
            newPathArr[1] = "edgeLabel";
          }
          return newPathArr;
        }
        return pathArr;
      }
    }
  };
  GraphSeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  GraphSeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  GraphSeriesModel2.prototype.getCategoriesData = function() {
    return this._categoriesData;
  };
  GraphSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    if (dataType === "edge") {
      var nodeData = this.getData();
      var params = this.getDataParams(dataIndex, dataType);
      var edge = nodeData.graph.getEdgeByIndex(dataIndex);
      var sourceName = nodeData.getName(edge.node1.dataIndex);
      var targetName = nodeData.getName(edge.node2.dataIndex);
      var nameArr = [];
      sourceName != null && nameArr.push(sourceName);
      targetName != null && nameArr.push(targetName);
      return createTooltipMarkup("nameValue", {
        name: nameArr.join(" > "),
        value: params.value,
        noValue: params.value == null
      });
    }
    var nodeMarkup = defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
    return nodeMarkup;
  };
  GraphSeriesModel2.prototype._updateCategoriesData = function() {
    var categories = map$1(this.option.categories || [], function(category) {
      return category.value != null ? category : extend({
        value: 0
      }, category);
    });
    var categoriesData = new SeriesData$1(["value"], this);
    categoriesData.initData(categories);
    this._categoriesData = categoriesData;
    this._categoriesModels = categoriesData.mapArray(function(idx) {
      return categoriesData.getItemModel(idx);
    });
  };
  GraphSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GraphSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GraphSeriesModel2.prototype.isAnimationEnabled = function() {
    return _super.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
  };
  GraphSeriesModel2.type = "series.graph";
  GraphSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  GraphSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    legendHoverLink: true,
    layout: null,
    circular: {
      rotateLabel: false
    },
    force: {
      initLayout: null,
      repulsion: [0, 50],
      gravity: 0.1,
      friction: 0.6,
      edgeLength: 30,
      layoutAnimation: true
    },
    left: "center",
    top: "center",
    symbol: "circle",
    symbolSize: 10,
    edgeSymbol: ["none", "none"],
    edgeSymbolSize: 10,
    edgeLabel: {
      position: "middle",
      distance: 5
    },
    draggable: false,
    roam: false,
    center: null,
    zoom: 1,
    nodeScaleRatio: 0.6,
    label: {
      show: false,
      formatter: "{b}"
    },
    itemStyle: {},
    lineStyle: {
      color: "#aaa",
      width: 1,
      opacity: 0.5
    },
    emphasis: {
      scale: true,
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return GraphSeriesModel2;
}(SeriesModel$1);
var GraphSeriesModel$1 = GraphSeriesModel;
var actionInfo$1 = {
  type: "graphRoam",
  event: "graphRoam",
  update: "none"
};
function install$F(registers) {
  registers.registerChartView(GraphView$1);
  registers.registerSeriesModel(GraphSeriesModel$1);
  registers.registerProcessor(categoryFilter);
  registers.registerVisual(categoryVisual);
  registers.registerVisual(graphEdgeVisual);
  registers.registerLayout(graphSimpleLayout);
  registers.registerLayout(registers.PRIORITY.VISUAL.POST_CHART_LAYOUT, graphCircularLayout);
  registers.registerLayout(graphForceLayout);
  registers.registerCoordinateSystem("graphView", {
    dimensions: View$1.dimensions,
    create: createViewCoordSys
  });
  registers.registerAction({
    type: "focusNodeAdjacency",
    event: "focusNodeAdjacency",
    update: "series:focusNodeAdjacency"
  }, noop$1);
  registers.registerAction({
    type: "unfocusNodeAdjacency",
    event: "unfocusNodeAdjacency",
    update: "series:unfocusNodeAdjacency"
  }, noop$1);
  registers.registerAction(actionInfo$1, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
var PointerShape = function() {
  function PointerShape2() {
    this.angle = 0;
    this.width = 10;
    this.r = 10;
    this.x = 0;
    this.y = 0;
  }
  return PointerShape2;
}();
var PointerPath = function(_super) {
  __extends(PointerPath2, _super);
  function PointerPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "pointer";
    return _this;
  }
  PointerPath2.prototype.getDefaultShape = function() {
    return new PointerShape();
  };
  PointerPath2.prototype.buildPath = function(ctx, shape) {
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var r2 = shape.r;
    var width = shape.width;
    var angle = shape.angle;
    var x2 = shape.x - mathCos2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    var y2 = shape.y - mathSin2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    angle = shape.angle - Math.PI / 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(shape.x + mathCos2(angle) * width, shape.y + mathSin2(angle) * width);
    ctx.lineTo(shape.x + mathCos2(shape.angle) * r2, shape.y + mathSin2(shape.angle) * r2);
    ctx.lineTo(shape.x - mathCos2(angle) * width, shape.y - mathSin2(angle) * width);
    ctx.lineTo(x2, y2);
  };
  return PointerPath2;
}(Path$1);
var PointerPath$1 = PointerPath;
function parsePosition(seriesModel, api) {
  var center2 = seriesModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], api.getWidth());
  var cy = parsePercent(center2[1], api.getHeight());
  var r2 = parsePercent(seriesModel.get("radius"), size / 2);
  return {
    cx,
    cy,
    r: r2
  };
}
function formatLabel(value, labelFormatter) {
  var label = value == null ? "" : value + "";
  if (labelFormatter) {
    if (isString$1(labelFormatter)) {
      label = labelFormatter.replace("{value}", label);
    } else if (isFunction(labelFormatter)) {
      label = labelFormatter(value);
    }
  }
  return label;
}
var PI2 = Math.PI * 2;
var GaugeView = function(_super) {
  __extends(GaugeView2, _super);
  function GaugeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeView2.type;
    return _this;
  }
  GaugeView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeAll();
    var colorList = seriesModel.get(["axisLine", "lineStyle", "color"]);
    var posInfo = parsePosition(seriesModel, api);
    this._renderMain(seriesModel, ecModel, api, colorList, posInfo);
    this._data = seriesModel.getData();
  };
  GaugeView2.prototype.dispose = function() {
  };
  GaugeView2.prototype._renderMain = function(seriesModel, ecModel, api, colorList, posInfo) {
    var group = this.group;
    var clockwise = seriesModel.get("clockwise");
    var startAngle = -seriesModel.get("startAngle") / 180 * Math.PI;
    var endAngle = -seriesModel.get("endAngle") / 180 * Math.PI;
    var axisLineModel = seriesModel.getModel("axisLine");
    var roundCap = axisLineModel.get("roundCap");
    var MainPath = roundCap ? Sausage : Sector$1;
    var showAxis = axisLineModel.get("show");
    var lineStyleModel = axisLineModel.getModel("lineStyle");
    var axisLineWidth = lineStyleModel.get("width");
    var angleRangeSpan = !((endAngle - startAngle) % PI2) && endAngle !== startAngle ? PI2 : (endAngle - startAngle) % PI2;
    var prevEndAngle = startAngle;
    for (var i = 0; showAxis && i < colorList.length; i++) {
      var percent = Math.min(Math.max(colorList[i][0], 0), 1);
      endAngle = startAngle + angleRangeSpan * percent;
      var sector = new MainPath({
        shape: {
          startAngle: prevEndAngle,
          endAngle,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0: posInfo.r - axisLineWidth,
          r: posInfo.r
        },
        silent: true
      });
      sector.setStyle({
        fill: colorList[i][1]
      });
      sector.setStyle(lineStyleModel.getLineStyle(["color", "width"]));
      group.add(sector);
      prevEndAngle = endAngle;
    }
    var getColor = function(percent2) {
      if (percent2 <= 0) {
        return colorList[0][1];
      }
      var i2;
      for (i2 = 0; i2 < colorList.length; i2++) {
        if (colorList[i2][0] >= percent2 && (i2 === 0 ? 0 : colorList[i2 - 1][0]) < percent2) {
          return colorList[i2][1];
        }
      }
      return colorList[i2 - 1][1];
    };
    if (!clockwise) {
      var tmp = startAngle;
      startAngle = endAngle;
      endAngle = tmp;
    }
    this._renderTicks(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
    this._renderTitleAndDetail(seriesModel, ecModel, api, getColor, posInfo);
    this._renderAnchor(seriesModel, posInfo);
    this._renderPointer(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
  };
  GaugeView2.prototype._renderTicks = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var cx = posInfo.cx;
    var cy = posInfo.cy;
    var r2 = posInfo.r;
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var splitLineModel = seriesModel.getModel("splitLine");
    var tickModel = seriesModel.getModel("axisTick");
    var labelModel = seriesModel.getModel("axisLabel");
    var splitNumber = seriesModel.get("splitNumber");
    var subSplitNumber = tickModel.get("splitNumber");
    var splitLineLen = parsePercent(splitLineModel.get("length"), r2);
    var tickLen = parsePercent(tickModel.get("length"), r2);
    var angle = startAngle;
    var step = (endAngle - startAngle) / splitNumber;
    var subStep = step / subSplitNumber;
    var splitLineStyle = splitLineModel.getModel("lineStyle").getLineStyle();
    var tickLineStyle = tickModel.getModel("lineStyle").getLineStyle();
    var splitLineDistance = splitLineModel.get("distance");
    var unitX;
    var unitY;
    for (var i = 0; i <= splitNumber; i++) {
      unitX = Math.cos(angle);
      unitY = Math.sin(angle);
      if (splitLineModel.get("show")) {
        var distance2 = splitLineDistance ? splitLineDistance + axisLineWidth : axisLineWidth;
        var splitLine = new Line$3({
          shape: {
            x1: unitX * (r2 - distance2) + cx,
            y1: unitY * (r2 - distance2) + cy,
            x2: unitX * (r2 - splitLineLen - distance2) + cx,
            y2: unitY * (r2 - splitLineLen - distance2) + cy
          },
          style: splitLineStyle,
          silent: true
        });
        if (splitLineStyle.stroke === "auto") {
          splitLine.setStyle({
            stroke: getColor(i / splitNumber)
          });
        }
        group.add(splitLine);
      }
      if (labelModel.get("show")) {
        var distance2 = labelModel.get("distance") + splitLineDistance;
        var label = formatLabel(round$3(i / splitNumber * (maxVal - minVal) + minVal), labelModel.get("formatter"));
        var autoColor = getColor(i / splitNumber);
        group.add(new ZRText$1({
          style: createTextStyle(labelModel, {
            text: label,
            x: unitX * (r2 - splitLineLen - distance2) + cx,
            y: unitY * (r2 - splitLineLen - distance2) + cy,
            verticalAlign: unitY < -0.8 ? "top" : unitY > 0.8 ? "bottom" : "middle",
            align: unitX < -0.4 ? "left" : unitX > 0.4 ? "right" : "center"
          }, {
            inheritColor: autoColor
          }),
          silent: true
        }));
      }
      if (tickModel.get("show") && i !== splitNumber) {
        var distance2 = tickModel.get("distance");
        distance2 = distance2 ? distance2 + axisLineWidth : axisLineWidth;
        for (var j = 0; j <= subSplitNumber; j++) {
          unitX = Math.cos(angle);
          unitY = Math.sin(angle);
          var tickLine = new Line$3({
            shape: {
              x1: unitX * (r2 - distance2) + cx,
              y1: unitY * (r2 - distance2) + cy,
              x2: unitX * (r2 - tickLen - distance2) + cx,
              y2: unitY * (r2 - tickLen - distance2) + cy
            },
            silent: true,
            style: tickLineStyle
          });
          if (tickLineStyle.stroke === "auto") {
            tickLine.setStyle({
              stroke: getColor((i + j / subSplitNumber) / splitNumber)
            });
          }
          group.add(tickLine);
          angle += subStep;
        }
        angle -= subStep;
      } else {
        angle += step;
      }
    }
  };
  GaugeView2.prototype._renderPointer = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var oldData = this._data;
    var oldProgressData = this._progressEls;
    var progressList = [];
    var showPointer2 = seriesModel.get(["pointer", "show"]);
    var progressModel = seriesModel.getModel("progress");
    var showProgress = progressModel.get("show");
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var valueExtent = [minVal, maxVal];
    var angleExtent = [startAngle, endAngle];
    function createPointer(idx, angle) {
      var itemModel = data.getItemModel(idx);
      var pointerModel = itemModel.getModel("pointer");
      var pointerWidth = parsePercent(pointerModel.get("width"), posInfo.r);
      var pointerLength = parsePercent(pointerModel.get("length"), posInfo.r);
      var pointerStr = seriesModel.get(["pointer", "icon"]);
      var pointerOffset = pointerModel.get("offsetCenter");
      var pointerOffsetX = parsePercent(pointerOffset[0], posInfo.r);
      var pointerOffsetY = parsePercent(pointerOffset[1], posInfo.r);
      var pointerKeepAspect = pointerModel.get("keepAspect");
      var pointer;
      if (pointerStr) {
        pointer = createSymbol$1(pointerStr, pointerOffsetX - pointerWidth / 2, pointerOffsetY - pointerLength, pointerWidth, pointerLength, null, pointerKeepAspect);
      } else {
        pointer = new PointerPath$1({
          shape: {
            angle: -Math.PI / 2,
            width: pointerWidth,
            r: pointerLength,
            x: pointerOffsetX,
            y: pointerOffsetY
          }
        });
      }
      pointer.rotation = -(angle + Math.PI / 2);
      pointer.x = posInfo.cx;
      pointer.y = posInfo.cy;
      return pointer;
    }
    function createProgress(idx, endAngle2) {
      var roundCap = progressModel.get("roundCap");
      var ProgressPath = roundCap ? Sausage : Sector$1;
      var isOverlap = progressModel.get("overlap");
      var progressWidth = isOverlap ? progressModel.get("width") : axisLineWidth / data.count();
      var r0 = isOverlap ? posInfo.r - progressWidth : posInfo.r - (idx + 1) * progressWidth;
      var r2 = isOverlap ? posInfo.r : posInfo.r - idx * progressWidth;
      var progress = new ProgressPath({
        shape: {
          startAngle,
          endAngle: endAngle2,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0,
          r: r2
        }
      });
      isOverlap && (progress.z2 = maxVal - data.get(valueDim, idx) % maxVal);
      return progress;
    }
    if (showProgress || showPointer2) {
      data.diff(oldData).add(function(idx) {
        var val = data.get(valueDim, idx);
        if (showPointer2) {
          var pointer = createPointer(idx, startAngle);
          initProps(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(idx, pointer);
        }
        if (showProgress) {
          var progress = createProgress(idx, startAngle);
          var isClip = progressModel.get("clip");
          initProps(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, idx, progress);
          progressList[idx] = progress;
        }
      }).update(function(newIdx, oldIdx) {
        var val = data.get(valueDim, newIdx);
        if (showPointer2) {
          var previousPointer = oldData.getItemGraphicEl(oldIdx);
          var previousRotate = previousPointer ? previousPointer.rotation : startAngle;
          var pointer = createPointer(newIdx, previousRotate);
          pointer.rotation = previousRotate;
          updateProps$1(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(newIdx, pointer);
        }
        if (showProgress) {
          var previousProgress = oldProgressData[oldIdx];
          var previousEndAngle = previousProgress ? previousProgress.shape.endAngle : startAngle;
          var progress = createProgress(newIdx, previousEndAngle);
          var isClip = progressModel.get("clip");
          updateProps$1(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, newIdx, progress);
          progressList[newIdx] = progress;
        }
      }).execute();
      data.each(function(idx) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel = itemModel.getModel("emphasis");
        var focus = emphasisModel.get("focus");
        var blurScope = emphasisModel.get("blurScope");
        var emphasisDisabled = emphasisModel.get("disabled");
        if (showPointer2) {
          var pointer = data.getItemGraphicEl(idx);
          var symbolStyle = data.getItemVisual(idx, "style");
          var visualColor = symbolStyle.fill;
          if (pointer instanceof ZRImage$1) {
            var pathStyle = pointer.style;
            pointer.useStyle(extend({
              image: pathStyle.image,
              x: pathStyle.x,
              y: pathStyle.y,
              width: pathStyle.width,
              height: pathStyle.height
            }, symbolStyle));
          } else {
            pointer.useStyle(symbolStyle);
            pointer.type !== "pointer" && pointer.setColor(visualColor);
          }
          pointer.setStyle(itemModel.getModel(["pointer", "itemStyle"]).getItemStyle());
          if (pointer.style.fill === "auto") {
            pointer.setStyle("fill", getColor(linearMap$2(data.get(valueDim, idx), valueExtent, [0, 1], true)));
          }
          pointer.z2EmphasisLift = 0;
          setStatesStylesFromModel(pointer, itemModel);
          toggleHoverEmphasis(pointer, focus, blurScope, emphasisDisabled);
        }
        if (showProgress) {
          var progress = progressList[idx];
          progress.useStyle(data.getItemVisual(idx, "style"));
          progress.setStyle(itemModel.getModel(["progress", "itemStyle"]).getItemStyle());
          progress.z2EmphasisLift = 0;
          setStatesStylesFromModel(progress, itemModel);
          toggleHoverEmphasis(progress, focus, blurScope, emphasisDisabled);
        }
      });
      this._progressEls = progressList;
    }
  };
  GaugeView2.prototype._renderAnchor = function(seriesModel, posInfo) {
    var anchorModel = seriesModel.getModel("anchor");
    var showAnchor = anchorModel.get("show");
    if (showAnchor) {
      var anchorSize = anchorModel.get("size");
      var anchorType = anchorModel.get("icon");
      var offsetCenter = anchorModel.get("offsetCenter");
      var anchorKeepAspect = anchorModel.get("keepAspect");
      var anchor = createSymbol$1(anchorType, posInfo.cx - anchorSize / 2 + parsePercent(offsetCenter[0], posInfo.r), posInfo.cy - anchorSize / 2 + parsePercent(offsetCenter[1], posInfo.r), anchorSize, anchorSize, null, anchorKeepAspect);
      anchor.z2 = anchorModel.get("showAbove") ? 1 : 0;
      anchor.setStyle(anchorModel.getModel("itemStyle").getItemStyle());
      this.group.add(anchor);
    }
  };
  GaugeView2.prototype._renderTitleAndDetail = function(seriesModel, ecModel, api, getColor, posInfo) {
    var _this = this;
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var contentGroup = new Group$6();
    var newTitleEls = [];
    var newDetailEls = [];
    var hasAnimation = seriesModel.isAnimationEnabled();
    var showPointerAbove = seriesModel.get(["pointer", "showAbove"]);
    data.diff(this._data).add(function(idx) {
      newTitleEls[idx] = new ZRText$1({
        silent: true
      });
      newDetailEls[idx] = new ZRText$1({
        silent: true
      });
    }).update(function(idx, oldIdx) {
      newTitleEls[idx] = _this._titleEls[oldIdx];
      newDetailEls[idx] = _this._detailEls[oldIdx];
    }).execute();
    data.each(function(idx) {
      var itemModel = data.getItemModel(idx);
      var value = data.get(valueDim, idx);
      var itemGroup = new Group$6();
      var autoColor = getColor(linearMap$2(value, [minVal, maxVal], [0, 1], true));
      var itemTitleModel = itemModel.getModel("title");
      if (itemTitleModel.get("show")) {
        var titleOffsetCenter = itemTitleModel.get("offsetCenter");
        var titleX = posInfo.cx + parsePercent(titleOffsetCenter[0], posInfo.r);
        var titleY = posInfo.cy + parsePercent(titleOffsetCenter[1], posInfo.r);
        var labelEl = newTitleEls[idx];
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemTitleModel, {
            x: titleX,
            y: titleY,
            text: data.getName(idx),
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: autoColor
          })
        });
        itemGroup.add(labelEl);
      }
      var itemDetailModel = itemModel.getModel("detail");
      if (itemDetailModel.get("show")) {
        var detailOffsetCenter = itemDetailModel.get("offsetCenter");
        var detailX = posInfo.cx + parsePercent(detailOffsetCenter[0], posInfo.r);
        var detailY = posInfo.cy + parsePercent(detailOffsetCenter[1], posInfo.r);
        var width = parsePercent(itemDetailModel.get("width"), posInfo.r);
        var height = parsePercent(itemDetailModel.get("height"), posInfo.r);
        var detailColor = seriesModel.get(["progress", "show"]) ? data.getItemVisual(idx, "style").fill : autoColor;
        var labelEl = newDetailEls[idx];
        var formatter_1 = itemDetailModel.get("formatter");
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemDetailModel, {
            x: detailX,
            y: detailY,
            text: formatLabel(value, formatter_1),
            width: isNaN(width) ? null : width,
            height: isNaN(height) ? null : height,
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: detailColor
          })
        });
        setLabelValueAnimation(labelEl, {
          normal: itemDetailModel
        }, value, function(value2) {
          return formatLabel(value2, formatter_1);
        });
        hasAnimation && animateLabelValue(labelEl, idx, data, seriesModel, {
          getFormattedLabel: function(labelDataIndex, status, dataType, labelDimIndex, fmt, extendParams) {
            return formatLabel(extendParams ? extendParams.interpolatedValue : value, formatter_1);
          }
        });
        itemGroup.add(labelEl);
      }
      contentGroup.add(itemGroup);
    });
    this.group.add(contentGroup);
    this._titleEls = newTitleEls;
    this._detailEls = newDetailEls;
  };
  GaugeView2.type = "gauge";
  return GaugeView2;
}(ChartView$1);
var GaugeView$1 = GaugeView;
var GaugeSeriesModel = function(_super) {
  __extends(GaugeSeriesModel2, _super);
  function GaugeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeSeriesModel2.type;
    _this.visualStyleAccessPath = "itemStyle";
    return _this;
  }
  GaugeSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, ["value"]);
  };
  GaugeSeriesModel2.type = "series.gauge";
  GaugeSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    center: ["50%", "50%"],
    legendHoverLink: true,
    radius: "75%",
    startAngle: 225,
    endAngle: -45,
    clockwise: true,
    min: 0,
    max: 100,
    splitNumber: 10,
    axisLine: {
      show: true,
      roundCap: false,
      lineStyle: {
        color: [[1, "#E6EBF8"]],
        width: 10
      }
    },
    progress: {
      show: false,
      overlap: true,
      width: 10,
      roundCap: false,
      clip: true
    },
    splitLine: {
      show: true,
      length: 10,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 3,
        type: "solid"
      }
    },
    axisTick: {
      show: true,
      splitNumber: 5,
      length: 6,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 1,
        type: "solid"
      }
    },
    axisLabel: {
      show: true,
      distance: 15,
      color: "#464646",
      fontSize: 12
    },
    pointer: {
      icon: null,
      offsetCenter: [0, 0],
      show: true,
      showAbove: true,
      length: "60%",
      width: 6,
      keepAspect: false
    },
    anchor: {
      show: false,
      showAbove: false,
      size: 6,
      icon: "circle",
      offsetCenter: [0, 0],
      keepAspect: false,
      itemStyle: {
        color: "#fff",
        borderWidth: 0,
        borderColor: "#5470c6"
      }
    },
    title: {
      show: true,
      offsetCenter: [0, "20%"],
      color: "#464646",
      fontSize: 16,
      valueAnimation: false
    },
    detail: {
      show: true,
      backgroundColor: "rgba(0,0,0,0)",
      borderWidth: 0,
      borderColor: "#ccc",
      width: 100,
      height: null,
      padding: [5, 10],
      offsetCenter: [0, "40%"],
      color: "#464646",
      fontSize: 30,
      fontWeight: "bold",
      lineHeight: 30,
      valueAnimation: false
    }
  };
  return GaugeSeriesModel2;
}(SeriesModel$1);
var GaugeSeriesModel$1 = GaugeSeriesModel;
function install$E(registers) {
  registers.registerChartView(GaugeView$1);
  registers.registerSeriesModel(GaugeSeriesModel$1);
}
var opacityAccessPath$1 = ["itemStyle", "opacity"];
var FunnelPiece = function(_super) {
  __extends(FunnelPiece2, _super);
  function FunnelPiece2(data, idx) {
    var _this = _super.call(this) || this;
    var polygon = _this;
    var labelLine = new Polyline$3();
    var text = new ZRText$1();
    polygon.setTextContent(text);
    _this.setTextGuideLine(labelLine);
    _this.updateData(data, idx, true);
    return _this;
  }
  FunnelPiece2.prototype.updateData = function(data, idx, firstCreate) {
    var polygon = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var opacity = itemModel.get(opacityAccessPath$1);
    opacity = opacity == null ? 1 : opacity;
    if (!firstCreate) {
      saveOldStyle(polygon);
    }
    polygon.useStyle(data.getItemVisual(idx, "style"));
    polygon.style.lineJoin = "round";
    if (firstCreate) {
      polygon.setShape({
        points: layout2.points
      });
      polygon.style.opacity = 0;
      initProps(polygon, {
        style: {
          opacity
        }
      }, seriesModel, idx);
    } else {
      updateProps$1(polygon, {
        style: {
          opacity
        },
        shape: {
          points: layout2.points
        }
      }, seriesModel, idx);
    }
    setStatesStylesFromModel(polygon, itemModel);
    this._updateLabel(data, idx);
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  FunnelPiece2.prototype._updateLabel = function(data, idx) {
    var polygon = this;
    var labelLine = this.getTextGuideLine();
    var labelText = polygon.getTextContent();
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var labelLayout2 = layout2.label;
    var style2 = data.getItemVisual(idx, "style");
    var visualColor = style2.fill;
    setLabelStyle(labelText, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      defaultOpacity: style2.opacity,
      defaultText: data.getName(idx)
    }, {
      normal: {
        align: labelLayout2.textAlign,
        verticalAlign: labelLayout2.verticalAlign
      }
    });
    polygon.setTextConfig({
      local: true,
      inside: !!labelLayout2.inside,
      insideStroke: visualColor,
      outsideFill: visualColor
    });
    var linePoints = labelLayout2.linePoints;
    labelLine.setShape({
      points: linePoints
    });
    polygon.textGuideLineConfig = {
      anchor: linePoints ? new Point$1(linePoints[0][0], linePoints[0][1]) : null
    };
    updateProps$1(labelText, {
      style: {
        x: labelLayout2.x,
        y: labelLayout2.y
      }
    }, seriesModel, idx);
    labelText.attr({
      rotation: labelLayout2.rotation,
      originX: labelLayout2.x,
      originY: labelLayout2.y,
      z2: 10
    });
    setLabelLineStyle(polygon, getLabelLineStatesModels(itemModel), {
      stroke: visualColor
    });
  };
  return FunnelPiece2;
}(Polygon$1);
var FunnelView = function(_super) {
  __extends(FunnelView2, _super);
  function FunnelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelView2.type;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  FunnelView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    data.diff(oldData).add(function(idx) {
      var funnelPiece = new FunnelPiece(data, idx);
      data.setItemGraphicEl(idx, funnelPiece);
      group.add(funnelPiece);
    }).update(function(newIdx, oldIdx) {
      var piece = oldData.getItemGraphicEl(oldIdx);
      piece.updateData(data, newIdx);
      group.add(piece);
      data.setItemGraphicEl(newIdx, piece);
    }).remove(function(idx) {
      var piece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piece, seriesModel, idx);
    }).execute();
    this._data = data;
  };
  FunnelView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  FunnelView2.prototype.dispose = function() {
  };
  FunnelView2.type = "funnel";
  return FunnelView2;
}(ChartView$1);
var FunnelView$1 = FunnelView;
var FunnelSeriesModel = function(_super) {
  __extends(FunnelSeriesModel2, _super);
  function FunnelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelSeriesModel2.type;
    return _this;
  }
  FunnelSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  FunnelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  FunnelSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  FunnelSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueDim = data.mapDimension("value");
    var sum2 = data.getSum(valueDim);
    params.percent = !sum2 ? 0 : +(data.get(valueDim, dataIndex) / sum2 * 100).toFixed(2);
    params.$vars.push("percent");
    return params;
  };
  FunnelSeriesModel2.type = "series.funnel";
  FunnelSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    minSize: "0%",
    maxSize: "100%",
    sort: "descending",
    orient: "vertical",
    gap: 0,
    funnelAlign: "center",
    label: {
      show: true,
      position: "outer"
    },
    labelLine: {
      show: true,
      length: 20,
      lineStyle: {
        width: 1
      }
    },
    itemStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return FunnelSeriesModel2;
}(SeriesModel$1);
var FunnelSeriesModel$1 = FunnelSeriesModel;
function getViewRect$2(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getSortedIndices(data, sort2) {
  var valueDim = data.mapDimension("value");
  var valueArr = data.mapArray(valueDim, function(val) {
    return val;
  });
  var indices = [];
  var isAscending = sort2 === "ascending";
  for (var i = 0, len2 = data.count(); i < len2; i++) {
    indices[i] = i;
  }
  if (isFunction(sort2)) {
    indices.sort(sort2);
  } else if (sort2 !== "none") {
    indices.sort(function(a, b2) {
      return isAscending ? valueArr[a] - valueArr[b2] : valueArr[b2] - valueArr[a];
    });
  }
  return indices;
}
function labelLayout(data) {
  var seriesModel = data.hostModel;
  var orient = seriesModel.get("orient");
  data.each(function(idx) {
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position");
    var labelLineModel = itemModel.getModel("labelLine");
    var layout2 = data.getItemLayout(idx);
    var points2 = layout2.points;
    var isLabelInside = labelPosition === "inner" || labelPosition === "inside" || labelPosition === "center" || labelPosition === "insideLeft" || labelPosition === "insideRight";
    var textAlign;
    var textX;
    var textY;
    var linePoints;
    if (isLabelInside) {
      if (labelPosition === "insideLeft") {
        textX = (points2[0][0] + points2[3][0]) / 2 + 5;
        textY = (points2[0][1] + points2[3][1]) / 2;
        textAlign = "left";
      } else if (labelPosition === "insideRight") {
        textX = (points2[1][0] + points2[2][0]) / 2 - 5;
        textY = (points2[1][1] + points2[2][1]) / 2;
        textAlign = "right";
      } else {
        textX = (points2[0][0] + points2[1][0] + points2[2][0] + points2[3][0]) / 4;
        textY = (points2[0][1] + points2[1][1] + points2[2][1] + points2[3][1]) / 4;
        textAlign = "center";
      }
      linePoints = [[textX, textY], [textX, textY]];
    } else {
      var x1 = void 0;
      var y1 = void 0;
      var x2 = void 0;
      var y2 = void 0;
      var labelLineLen = labelLineModel.get("length");
      if (labelPosition === "left") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        x2 = x1 - labelLineLen;
        textX = x2 - 5;
        textAlign = "right";
      } else if (labelPosition === "right") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        x2 = x1 + labelLineLen;
        textX = x2 + 5;
        textAlign = "left";
      } else if (labelPosition === "top") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        y2 = y1 - labelLineLen;
        textY = y2 - 5;
        textAlign = "center";
      } else if (labelPosition === "bottom") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        y2 = y1 + labelLineLen;
        textY = y2 + 5;
        textAlign = "center";
      } else if (labelPosition === "rightTop") {
        x1 = orient === "horizontal" ? points2[3][0] : points2[1][0];
        y1 = orient === "horizontal" ? points2[3][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "top";
        }
      } else if (labelPosition === "rightBottom") {
        x1 = points2[2][0];
        y1 = points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "bottom";
        }
      } else if (labelPosition === "leftTop") {
        x1 = points2[0][0];
        y1 = orient === "horizontal" ? points2[0][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else if (labelPosition === "leftBottom") {
        x1 = orient === "horizontal" ? points2[1][0] : points2[3][0];
        y1 = orient === "horizontal" ? points2[1][1] : points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "left";
        }
      }
      if (orient === "horizontal") {
        x2 = x1;
        textX = x2;
      } else {
        y2 = y1;
        textY = y2;
      }
      linePoints = [[x1, y1], [x2, y2]];
    }
    layout2.label = {
      linePoints,
      x: textX,
      y: textY,
      verticalAlign: "middle",
      textAlign,
      inside: isLabelInside
    };
  });
}
function funnelLayout(ecModel, api) {
  ecModel.eachSeriesByType("funnel", function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var sort2 = seriesModel.get("sort");
    var viewRect2 = getViewRect$2(seriesModel, api);
    var orient = seriesModel.get("orient");
    var viewWidth = viewRect2.width;
    var viewHeight = viewRect2.height;
    var indices = getSortedIndices(data, sort2);
    var x2 = viewRect2.x;
    var y2 = viewRect2.y;
    var sizeExtent = orient === "horizontal" ? [parsePercent(seriesModel.get("minSize"), viewHeight), parsePercent(seriesModel.get("maxSize"), viewHeight)] : [parsePercent(seriesModel.get("minSize"), viewWidth), parsePercent(seriesModel.get("maxSize"), viewWidth)];
    var dataExtent = data.getDataExtent(valueDim);
    var min3 = seriesModel.get("min");
    var max3 = seriesModel.get("max");
    if (min3 == null) {
      min3 = Math.min(dataExtent[0], 0);
    }
    if (max3 == null) {
      max3 = dataExtent[1];
    }
    var funnelAlign = seriesModel.get("funnelAlign");
    var gap = seriesModel.get("gap");
    var viewSize = orient === "horizontal" ? viewWidth : viewHeight;
    var itemSize = (viewSize - gap * (data.count() - 1)) / data.count();
    var getLinePoints = function(idx2, offset2) {
      if (orient === "horizontal") {
        var val_1 = data.get(valueDim, idx2) || 0;
        var itemHeight = linearMap$2(val_1, [min3, max3], sizeExtent, true);
        var y0 = void 0;
        switch (funnelAlign) {
          case "top":
            y0 = y2;
            break;
          case "center":
            y0 = y2 + (viewHeight - itemHeight) / 2;
            break;
          case "bottom":
            y0 = y2 + (viewHeight - itemHeight);
            break;
        }
        return [[offset2, y0], [offset2, y0 + itemHeight]];
      }
      var val = data.get(valueDim, idx2) || 0;
      var itemWidth = linearMap$2(val, [min3, max3], sizeExtent, true);
      var x0;
      switch (funnelAlign) {
        case "left":
          x0 = x2;
          break;
        case "center":
          x0 = x2 + (viewWidth - itemWidth) / 2;
          break;
        case "right":
          x0 = x2 + viewWidth - itemWidth;
          break;
      }
      return [[x0, offset2], [x0 + itemWidth, offset2]];
    };
    if (sort2 === "ascending") {
      itemSize = -itemSize;
      gap = -gap;
      if (orient === "horizontal") {
        x2 += viewWidth;
      } else {
        y2 += viewHeight;
      }
      indices = indices.reverse();
    }
    for (var i = 0; i < indices.length; i++) {
      var idx = indices[i];
      var nextIdx = indices[i + 1];
      var itemModel = data.getItemModel(idx);
      if (orient === "horizontal") {
        var width = itemModel.get(["itemStyle", "width"]);
        if (width == null) {
          width = itemSize;
        } else {
          width = parsePercent(width, viewWidth);
          if (sort2 === "ascending") {
            width = -width;
          }
        }
        var start2 = getLinePoints(idx, x2);
        var end2 = getLinePoints(nextIdx, x2 + width);
        x2 += width + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      } else {
        var height = itemModel.get(["itemStyle", "height"]);
        if (height == null) {
          height = itemSize;
        } else {
          height = parsePercent(height, viewHeight);
          if (sort2 === "ascending") {
            height = -height;
          }
        }
        var start2 = getLinePoints(idx, y2);
        var end2 = getLinePoints(nextIdx, y2 + height);
        y2 += height + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      }
    }
    labelLayout(data);
  });
}
function install$D(registers) {
  registers.registerChartView(FunnelView$1);
  registers.registerSeriesModel(FunnelSeriesModel$1);
  registers.registerLayout(funnelLayout);
  registers.registerProcessor(dataFilter$1("funnel"));
}
var DEFAULT_SMOOTH = 0.3;
var ParallelView$2 = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    _this._dataGroup = new Group$6();
    _this._initialized = false;
    return _this;
  }
  ParallelView2.prototype.init = function() {
    this.group.add(this._dataGroup);
  };
  ParallelView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._progressiveEls = null;
    var dataGroup = this._dataGroup;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    data.diff(oldData).add(add2).update(update).remove(remove).execute();
    function add2(newDataIndex) {
      var line = addEl(data, dataGroup, newDataIndex, dimensions, coordSys);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function update(newDataIndex, oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      var points2 = createLinePoints(data, newDataIndex, dimensions, coordSys);
      data.setItemGraphicEl(newDataIndex, line);
      updateProps$1(line, {
        shape: {
          points: points2
        }
      }, seriesModel, newDataIndex);
      saveOldStyle(line);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function remove(oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      dataGroup.remove(line);
    }
    if (!this._initialized) {
      this._initialized = true;
      var clipPath = createGridClipShape$2(coordSys, seriesModel, function() {
        setTimeout(function() {
          dataGroup.removeClipPath();
        });
      });
      dataGroup.setClipPath(clipPath);
    }
    this._data = data;
  };
  ParallelView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._initialized = true;
    this._data = null;
    this._dataGroup.removeAll();
  };
  ParallelView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    var data = seriesModel.getData();
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    var progressiveEls = this._progressiveEls = [];
    for (var dataIndex = taskParams.start; dataIndex < taskParams.end; dataIndex++) {
      var line = addEl(data, this._dataGroup, dataIndex, dimensions, coordSys);
      line.incremental = true;
      updateElCommon(line, data, dataIndex, seriesScope);
      progressiveEls.push(line);
    }
  };
  ParallelView2.prototype.remove = function() {
    this._dataGroup && this._dataGroup.removeAll();
    this._data = null;
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ChartView$1);
function createGridClipShape$2(coordSys, seriesModel, cb2) {
  var parallelModel = coordSys.model;
  var rect = coordSys.getRect();
  var rectEl = new Rect$3({
    shape: {
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    }
  });
  var dim = parallelModel.get("layout") === "horizontal" ? "width" : "height";
  rectEl.setShape(dim, 0);
  initProps(rectEl, {
    shape: {
      width: rect.width,
      height: rect.height
    }
  }, seriesModel, cb2);
  return rectEl;
}
function createLinePoints(data, dataIndex, dimensions, coordSys) {
  var points2 = [];
  for (var i = 0; i < dimensions.length; i++) {
    var dimName = dimensions[i];
    var value = data.get(data.mapDimension(dimName), dataIndex);
    if (!isEmptyValue$1(value, coordSys.getAxis(dimName).type)) {
      points2.push(coordSys.dataToPoint(value, dimName));
    }
  }
  return points2;
}
function addEl(data, dataGroup, dataIndex, dimensions, coordSys) {
  var points2 = createLinePoints(data, dataIndex, dimensions, coordSys);
  var line = new Polyline$3({
    shape: {
      points: points2
    },
    z2: 10
  });
  dataGroup.add(line);
  data.setItemGraphicEl(dataIndex, line);
  return line;
}
function makeSeriesScope(seriesModel) {
  var smooth = seriesModel.get("smooth", true);
  smooth === true && (smooth = DEFAULT_SMOOTH);
  smooth = numericToNumber(smooth);
  eqNaN(smooth) && (smooth = 0);
  return {
    smooth
  };
}
function updateElCommon(el, data, dataIndex, seriesScope) {
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.fill = null;
  el.setShape("smooth", seriesScope.smooth);
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel, "lineStyle");
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function isEmptyValue$1(val, axisType) {
  return axisType === "category" ? val == null : val == null || isNaN(val);
}
var ParallelView$3 = ParallelView$2;
var ParallelSeriesModel = function(_super) {
  __extends(ParallelSeriesModel2, _super);
  function ParallelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  ParallelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: bind$1(makeDefaultEncode, null, this)
    });
  };
  ParallelSeriesModel2.prototype.getRawIndicesByActiveState = function(activeState) {
    var coordSys = this.coordinateSystem;
    var data = this.getData();
    var indices = [];
    coordSys.eachActiveState(data, function(theActiveState, dataIndex) {
      if (activeState === theActiveState) {
        indices.push(data.getRawIndex(dataIndex));
      }
    });
    return indices;
  };
  ParallelSeriesModel2.type = "series.parallel";
  ParallelSeriesModel2.dependencies = ["parallel"];
  ParallelSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "parallel",
    parallelIndex: 0,
    label: {
      show: false
    },
    inactiveOpacity: 0.05,
    activeOpacity: 1,
    lineStyle: {
      width: 1,
      opacity: 0.45,
      type: "solid"
    },
    emphasis: {
      label: {
        show: false
      }
    },
    progressive: 500,
    smooth: false,
    animationEasing: "linear"
  };
  return ParallelSeriesModel2;
}(SeriesModel$1);
function makeDefaultEncode(seriesModel) {
  var parallelModel = seriesModel.ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
  if (!parallelModel) {
    return;
  }
  var encodeDefine = {};
  each$g(parallelModel.dimensions, function(axisDim) {
    var dataDimIndex = convertDimNameToNumber(axisDim);
    encodeDefine[axisDim] = dataDimIndex;
  });
  return encodeDefine;
}
function convertDimNameToNumber(dimName) {
  return +dimName.replace("dim", "");
}
var ParallelSeriesModel$1 = ParallelSeriesModel;
var opacityAccessPath = ["lineStyle", "opacity"];
var parallelVisual = {
  seriesType: "parallel",
  reset: function(seriesModel, ecModel) {
    var coordSys = seriesModel.coordinateSystem;
    var opacityMap = {
      normal: seriesModel.get(["lineStyle", "opacity"]),
      active: seriesModel.get("activeOpacity"),
      inactive: seriesModel.get("inactiveOpacity")
    };
    return {
      progress: function(params, data) {
        coordSys.eachActiveState(data, function(activeState, dataIndex) {
          var opacity = opacityMap[activeState];
          if (activeState === "normal" && data.hasItemOption) {
            var itemOpacity = data.getItemModel(dataIndex).get(opacityAccessPath, true);
            itemOpacity != null && (opacity = itemOpacity);
          }
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          existsStyle.opacity = opacity;
        }, params.start, params.end);
      }
    };
  }
};
var parallelVisual$1 = parallelVisual;
function parallelPreprocessor(option) {
  createParallelIfNeeded(option);
  mergeAxisOptionFromParallel(option);
}
function createParallelIfNeeded(option) {
  if (option.parallel) {
    return;
  }
  var hasParallelSeries = false;
  each$g(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "parallel") {
      hasParallelSeries = true;
    }
  });
  if (hasParallelSeries) {
    option.parallel = [{}];
  }
}
function mergeAxisOptionFromParallel(option) {
  var axes = normalizeToArray(option.parallelAxis);
  each$g(axes, function(axisOption) {
    if (!isObject$4(axisOption)) {
      return;
    }
    var parallelIndex = axisOption.parallelIndex || 0;
    var parallelOption = normalizeToArray(option.parallel)[parallelIndex];
    if (parallelOption && parallelOption.parallelAxisDefault) {
      merge(axisOption, parallelOption.parallelAxisDefault, false);
    }
  });
}
var CLICK_THRESHOLD = 5;
var ParallelView = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    return _this;
  }
  ParallelView2.prototype.render = function(parallelModel, ecModel, api) {
    this._model = parallelModel;
    this._api = api;
    if (!this._handlers) {
      this._handlers = {};
      each$g(handlers$1, function(handler, eventName) {
        api.getZr().on(eventName, this._handlers[eventName] = bind$1(handler, this));
      }, this);
    }
    createOrUpdate(this, "_throttledDispatchExpand", parallelModel.get("axisExpandRate"), "fixRate");
  };
  ParallelView2.prototype.dispose = function(ecModel, api) {
    clear$1(this, "_throttledDispatchExpand");
    each$g(this._handlers, function(handler, eventName) {
      api.getZr().off(eventName, handler);
    });
    this._handlers = null;
  };
  ParallelView2.prototype._throttledDispatchExpand = function(opt) {
    this._dispatchExpand(opt);
  };
  ParallelView2.prototype._dispatchExpand = function(opt) {
    opt && this._api.dispatchAction(extend({
      type: "parallelAxisExpand"
    }, opt));
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ComponentView$1);
var handlers$1 = {
  mousedown: function(e2) {
    if (checkTrigger(this, "click")) {
      this._mouseDownPoint = [e2.offsetX, e2.offsetY];
    }
  },
  mouseup: function(e2) {
    var mouseDownPoint = this._mouseDownPoint;
    if (checkTrigger(this, "click") && mouseDownPoint) {
      var point = [e2.offsetX, e2.offsetY];
      var dist2 = Math.pow(mouseDownPoint[0] - point[0], 2) + Math.pow(mouseDownPoint[1] - point[1], 2);
      if (dist2 > CLICK_THRESHOLD) {
        return;
      }
      var result = this._model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
      result.behavior !== "none" && this._dispatchExpand({
        axisExpandWindow: result.axisExpandWindow
      });
    }
    this._mouseDownPoint = null;
  },
  mousemove: function(e2) {
    if (this._mouseDownPoint || !checkTrigger(this, "mousemove")) {
      return;
    }
    var model = this._model;
    var result = model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
    var behavior = result.behavior;
    behavior === "jump" && this._throttledDispatchExpand.debounceNextCall(model.get("axisExpandDebounce"));
    this._throttledDispatchExpand(behavior === "none" ? null : {
      axisExpandWindow: result.axisExpandWindow,
      animation: behavior === "jump" ? null : {
        duration: 0
      }
    });
  }
};
function checkTrigger(view, triggerOn) {
  var model = view._model;
  return model.get("axisExpandable") && model.get("axisExpandTriggerOn") === triggerOn;
}
var ParallelView$1 = ParallelView;
var ParallelModel = function(_super) {
  __extends(ParallelModel2, _super);
  function ParallelModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelModel2.type;
    return _this;
  }
  ParallelModel2.prototype.init = function() {
    _super.prototype.init.apply(this, arguments);
    this.mergeOption({});
  };
  ParallelModel2.prototype.mergeOption = function(newOption) {
    var thisOption = this.option;
    newOption && merge(thisOption, newOption, true);
    this._initDimensions();
  };
  ParallelModel2.prototype.contains = function(model, ecModel) {
    var parallelIndex = model.get("parallelIndex");
    return parallelIndex != null && ecModel.getComponent("parallel", parallelIndex) === this;
  };
  ParallelModel2.prototype.setAxisExpand = function(opt) {
    each$g(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(name) {
      if (opt.hasOwnProperty(name)) {
        this.option[name] = opt[name];
      }
    }, this);
  };
  ParallelModel2.prototype._initDimensions = function() {
    var dimensions = this.dimensions = [];
    var parallelAxisIndex = this.parallelAxisIndex = [];
    var axisModels = filter(this.ecModel.queryComponents({
      mainType: "parallelAxis"
    }), function(axisModel) {
      return (axisModel.get("parallelIndex") || 0) === this.componentIndex;
    }, this);
    each$g(axisModels, function(axisModel) {
      dimensions.push("dim" + axisModel.get("dim"));
      parallelAxisIndex.push(axisModel.componentIndex);
    });
  };
  ParallelModel2.type = "parallel";
  ParallelModel2.dependencies = ["parallelAxis"];
  ParallelModel2.layoutMode = "box";
  ParallelModel2.defaultOption = {
    z: 0,
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    layout: "horizontal",
    axisExpandable: false,
    axisExpandCenter: null,
    axisExpandCount: 0,
    axisExpandWidth: 50,
    axisExpandRate: 17,
    axisExpandDebounce: 50,
    axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4],
    axisExpandTriggerOn: "click",
    parallelAxisDefault: null
  };
  return ParallelModel2;
}(ComponentModel$1);
var ParallelModel$1 = ParallelModel;
var ParallelAxis = function(_super) {
  __extends(ParallelAxis2, _super);
  function ParallelAxis2(dim, scale2, coordExtent, axisType, axisIndex) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.axisIndex = axisIndex;
    return _this;
  }
  ParallelAxis2.prototype.isHorizontal = function() {
    return this.coordinateSystem.getModel().get("layout") !== "horizontal";
  };
  return ParallelAxis2;
}(Axis$1);
var ParallelAxis$1 = ParallelAxis;
function sliderMove(delta, handleEnds, extent3, handleIndex, minSpan, maxSpan) {
  delta = delta || 0;
  var extentSpan = extent3[1] - extent3[0];
  if (minSpan != null) {
    minSpan = restrict$1(minSpan, [0, extentSpan]);
  }
  if (maxSpan != null) {
    maxSpan = Math.max(maxSpan, minSpan != null ? minSpan : 0);
  }
  if (handleIndex === "all") {
    var handleSpan = Math.abs(handleEnds[1] - handleEnds[0]);
    handleSpan = restrict$1(handleSpan, [0, extentSpan]);
    minSpan = maxSpan = restrict$1(handleSpan, [minSpan, maxSpan]);
    handleIndex = 0;
  }
  handleEnds[0] = restrict$1(handleEnds[0], extent3);
  handleEnds[1] = restrict$1(handleEnds[1], extent3);
  var originalDistSign = getSpanSign(handleEnds, handleIndex);
  handleEnds[handleIndex] += delta;
  var extentMinSpan = minSpan || 0;
  var realExtent = extent3.slice();
  originalDistSign.sign < 0 ? realExtent[0] += extentMinSpan : realExtent[1] -= extentMinSpan;
  handleEnds[handleIndex] = restrict$1(handleEnds[handleIndex], realExtent);
  var currDistSign;
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (minSpan != null && (currDistSign.sign !== originalDistSign.sign || currDistSign.span < minSpan)) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + originalDistSign.sign * minSpan;
  }
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (maxSpan != null && currDistSign.span > maxSpan) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + currDistSign.sign * maxSpan;
  }
  return handleEnds;
}
function getSpanSign(handleEnds, handleIndex) {
  var dist2 = handleEnds[handleIndex] - handleEnds[1 - handleIndex];
  return {
    span: Math.abs(dist2),
    sign: dist2 > 0 ? -1 : dist2 < 0 ? 1 : handleIndex ? -1 : 1
  };
}
function restrict$1(value, extend2) {
  return Math.min(extend2[1] != null ? extend2[1] : Infinity, Math.max(extend2[0] != null ? extend2[0] : -Infinity, value));
}
var each$b = each$g;
var mathMin$2 = Math.min;
var mathMax$2 = Math.max;
var mathFloor = Math.floor;
var mathCeil = Math.ceil;
var round = round$3;
var PI$1 = Math.PI;
var Parallel = function() {
  function Parallel2(parallelModel, ecModel, api) {
    this.type = "parallel";
    this._axesMap = createHashMap();
    this._axesLayout = {};
    this.dimensions = parallelModel.dimensions;
    this._model = parallelModel;
    this._init(parallelModel, ecModel, api);
  }
  Parallel2.prototype._init = function(parallelModel, ecModel, api) {
    var dimensions = parallelModel.dimensions;
    var parallelAxisIndex = parallelModel.parallelAxisIndex;
    each$b(dimensions, function(dim, idx) {
      var axisIndex = parallelAxisIndex[idx];
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axis = this._axesMap.set(dim, new ParallelAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisIndex));
      var isCategory2 = axis.type === "category";
      axis.onBand = isCategory2 && axisModel.get("boundaryGap");
      axis.inverse = axisModel.get("inverse");
      axisModel.axis = axis;
      axis.model = axisModel;
      axis.coordinateSystem = axisModel.coordinateSystem = this;
    }, this);
  };
  Parallel2.prototype.update = function(ecModel, api) {
    this._updateAxesFromSeries(this._model, ecModel);
  };
  Parallel2.prototype.containPoint = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var axisBase = layoutInfo.axisBase;
    var layoutBase = layoutInfo.layoutBase;
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var pAxis = point[1 - pixelDimIndex];
    var pLayout = point[pixelDimIndex];
    return pAxis >= axisBase && pAxis <= axisBase + layoutInfo.axisLength && pLayout >= layoutBase && pLayout <= layoutBase + layoutInfo.layoutLength;
  };
  Parallel2.prototype.getModel = function() {
    return this._model;
  };
  Parallel2.prototype._updateAxesFromSeries = function(parallelModel, ecModel) {
    ecModel.eachSeries(function(seriesModel) {
      if (!parallelModel.contains(seriesModel, ecModel)) {
        return;
      }
      var data = seriesModel.getData();
      each$b(this.dimensions, function(dim) {
        var axis = this._axesMap.get(dim);
        axis.scale.unionExtentFromData(data, data.mapDimension(dim));
        niceScaleExtent(axis.scale, axis.model);
      }, this);
    }, this);
  };
  Parallel2.prototype.resize = function(parallelModel, api) {
    this._rect = getLayoutRect(parallelModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._layoutAxes();
  };
  Parallel2.prototype.getRect = function() {
    return this._rect;
  };
  Parallel2.prototype._makeLayoutInfo = function() {
    var parallelModel = this._model;
    var rect = this._rect;
    var xy = ["x", "y"];
    var wh2 = ["width", "height"];
    var layout2 = parallelModel.get("layout");
    var pixelDimIndex = layout2 === "horizontal" ? 0 : 1;
    var layoutLength = rect[wh2[pixelDimIndex]];
    var layoutExtent = [0, layoutLength];
    var axisCount = this.dimensions.length;
    var axisExpandWidth = restrict(parallelModel.get("axisExpandWidth"), layoutExtent);
    var axisExpandCount = restrict(parallelModel.get("axisExpandCount") || 0, [0, axisCount]);
    var axisExpandable = parallelModel.get("axisExpandable") && axisCount > 3 && axisCount > axisExpandCount && axisExpandCount > 1 && axisExpandWidth > 0 && layoutLength > 0;
    var axisExpandWindow = parallelModel.get("axisExpandWindow");
    var winSize;
    if (!axisExpandWindow) {
      winSize = restrict(axisExpandWidth * (axisExpandCount - 1), layoutExtent);
      var axisExpandCenter = parallelModel.get("axisExpandCenter") || mathFloor(axisCount / 2);
      axisExpandWindow = [axisExpandWidth * axisExpandCenter - winSize / 2];
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    } else {
      winSize = restrict(axisExpandWindow[1] - axisExpandWindow[0], layoutExtent);
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    }
    var axisCollapseWidth = (layoutLength - winSize) / (axisCount - axisExpandCount);
    axisCollapseWidth < 3 && (axisCollapseWidth = 0);
    var winInnerIndices = [mathFloor(round(axisExpandWindow[0] / axisExpandWidth, 1)) + 1, mathCeil(round(axisExpandWindow[1] / axisExpandWidth, 1)) - 1];
    var axisExpandWindow0Pos = axisCollapseWidth / axisExpandWidth * axisExpandWindow[0];
    return {
      layout: layout2,
      pixelDimIndex,
      layoutBase: rect[xy[pixelDimIndex]],
      layoutLength,
      axisBase: rect[xy[1 - pixelDimIndex]],
      axisLength: rect[wh2[1 - pixelDimIndex]],
      axisExpandable,
      axisExpandWidth,
      axisCollapseWidth,
      axisExpandWindow,
      axisCount,
      winInnerIndices,
      axisExpandWindow0Pos
    };
  };
  Parallel2.prototype._layoutAxes = function() {
    var rect = this._rect;
    var axes = this._axesMap;
    var dimensions = this.dimensions;
    var layoutInfo = this._makeLayoutInfo();
    var layout2 = layoutInfo.layout;
    axes.each(function(axis) {
      var axisExtent = [0, layoutInfo.axisLength];
      var idx = axis.inverse ? 1 : 0;
      axis.setExtent(axisExtent[idx], axisExtent[1 - idx]);
    });
    each$b(dimensions, function(dim, idx) {
      var posInfo = (layoutInfo.axisExpandable ? layoutAxisWithExpand : layoutAxisWithoutExpand)(idx, layoutInfo);
      var positionTable = {
        horizontal: {
          x: posInfo.position,
          y: layoutInfo.axisLength
        },
        vertical: {
          x: 0,
          y: posInfo.position
        }
      };
      var rotationTable = {
        horizontal: PI$1 / 2,
        vertical: 0
      };
      var position2 = [positionTable[layout2].x + rect.x, positionTable[layout2].y + rect.y];
      var rotation = rotationTable[layout2];
      var transform2 = create$1();
      rotate(transform2, transform2, rotation);
      translate(transform2, transform2, position2);
      this._axesLayout[dim] = {
        position: position2,
        rotation,
        transform: transform2,
        axisNameAvailableWidth: posInfo.axisNameAvailableWidth,
        axisLabelShow: posInfo.axisLabelShow,
        nameTruncateMaxWidth: posInfo.nameTruncateMaxWidth,
        tickDirection: 1,
        labelDirection: 1
      };
    }, this);
  };
  Parallel2.prototype.getAxis = function(dim) {
    return this._axesMap.get(dim);
  };
  Parallel2.prototype.dataToPoint = function(value, dim) {
    return this.axisCoordToPoint(this._axesMap.get(dim).dataToCoord(value), dim);
  };
  Parallel2.prototype.eachActiveState = function(data, callback, start2, end2) {
    start2 == null && (start2 = 0);
    end2 == null && (end2 = data.count());
    var axesMap = this._axesMap;
    var dimensions = this.dimensions;
    var dataDimensions = [];
    var axisModels = [];
    each$g(dimensions, function(axisDim) {
      dataDimensions.push(data.mapDimension(axisDim));
      axisModels.push(axesMap.get(axisDim).model);
    });
    var hasActiveSet = this.hasAxisBrushed();
    for (var dataIndex = start2; dataIndex < end2; dataIndex++) {
      var activeState = void 0;
      if (!hasActiveSet) {
        activeState = "normal";
      } else {
        activeState = "active";
        var values = data.getValues(dataDimensions, dataIndex);
        for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
          var state = axisModels[j].getActiveState(values[j]);
          if (state === "inactive") {
            activeState = "inactive";
            break;
          }
        }
      }
      callback(activeState, dataIndex);
    }
  };
  Parallel2.prototype.hasAxisBrushed = function() {
    var dimensions = this.dimensions;
    var axesMap = this._axesMap;
    var hasActiveSet = false;
    for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
      if (axesMap.get(dimensions[j]).model.getActiveState() !== "normal") {
        hasActiveSet = true;
      }
    }
    return hasActiveSet;
  };
  Parallel2.prototype.axisCoordToPoint = function(coord, dim) {
    var axisLayout = this._axesLayout[dim];
    return applyTransform([coord, 0], axisLayout.transform);
  };
  Parallel2.prototype.getAxisLayout = function(dim) {
    return clone$4(this._axesLayout[dim]);
  };
  Parallel2.prototype.getSlidedAxisExpandWindow = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var axisExpandWindow = layoutInfo.axisExpandWindow.slice();
    var winSize = axisExpandWindow[1] - axisExpandWindow[0];
    var extent3 = [0, layoutInfo.axisExpandWidth * (layoutInfo.axisCount - 1)];
    if (!this.containPoint(point)) {
      return {
        behavior: "none",
        axisExpandWindow
      };
    }
    var pointCoord = point[pixelDimIndex] - layoutInfo.layoutBase - layoutInfo.axisExpandWindow0Pos;
    var delta;
    var behavior = "slide";
    var axisCollapseWidth = layoutInfo.axisCollapseWidth;
    var triggerArea = this._model.get("axisExpandSlideTriggerArea");
    var useJump = triggerArea[0] != null;
    if (axisCollapseWidth) {
      if (useJump && axisCollapseWidth && pointCoord < winSize * triggerArea[0]) {
        behavior = "jump";
        delta = pointCoord - winSize * triggerArea[2];
      } else if (useJump && axisCollapseWidth && pointCoord > winSize * (1 - triggerArea[0])) {
        behavior = "jump";
        delta = pointCoord - winSize * (1 - triggerArea[2]);
      } else {
        (delta = pointCoord - winSize * triggerArea[1]) >= 0 && (delta = pointCoord - winSize * (1 - triggerArea[1])) <= 0 && (delta = 0);
      }
      delta *= layoutInfo.axisExpandWidth / axisCollapseWidth;
      delta ? sliderMove(delta, axisExpandWindow, extent3, "all") : behavior = "none";
    } else {
      var winSize2 = axisExpandWindow[1] - axisExpandWindow[0];
      var pos = extent3[1] * pointCoord / winSize2;
      axisExpandWindow = [mathMax$2(0, pos - winSize2 / 2)];
      axisExpandWindow[1] = mathMin$2(extent3[1], axisExpandWindow[0] + winSize2);
      axisExpandWindow[0] = axisExpandWindow[1] - winSize2;
    }
    return {
      axisExpandWindow,
      behavior
    };
  };
  return Parallel2;
}();
function restrict(len2, extent3) {
  return mathMin$2(mathMax$2(len2, extent3[0]), extent3[1]);
}
function layoutAxisWithoutExpand(axisIndex, layoutInfo) {
  var step = layoutInfo.layoutLength / (layoutInfo.axisCount - 1);
  return {
    position: step * axisIndex,
    axisNameAvailableWidth: step,
    axisLabelShow: true
  };
}
function layoutAxisWithExpand(axisIndex, layoutInfo) {
  var layoutLength = layoutInfo.layoutLength;
  var axisExpandWidth = layoutInfo.axisExpandWidth;
  var axisCount = layoutInfo.axisCount;
  var axisCollapseWidth = layoutInfo.axisCollapseWidth;
  var winInnerIndices = layoutInfo.winInnerIndices;
  var position2;
  var axisNameAvailableWidth = axisCollapseWidth;
  var axisLabelShow = false;
  var nameTruncateMaxWidth;
  if (axisIndex < winInnerIndices[0]) {
    position2 = axisIndex * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  } else if (axisIndex <= winInnerIndices[1]) {
    position2 = layoutInfo.axisExpandWindow0Pos + axisIndex * axisExpandWidth - layoutInfo.axisExpandWindow[0];
    axisNameAvailableWidth = axisExpandWidth;
    axisLabelShow = true;
  } else {
    position2 = layoutLength - (axisCount - 1 - axisIndex) * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  }
  return {
    position: position2,
    axisNameAvailableWidth,
    axisLabelShow,
    nameTruncateMaxWidth
  };
}
var Parallel$1 = Parallel;
function createParallelCoordSys(ecModel, api) {
  var coordSysList = [];
  ecModel.eachComponent("parallel", function(parallelModel, idx) {
    var coordSys = new Parallel$1(parallelModel, ecModel, api);
    coordSys.name = "parallel_" + idx;
    coordSys.resize(parallelModel, api);
    parallelModel.coordinateSystem = coordSys;
    coordSys.model = parallelModel;
    coordSysList.push(coordSys);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "parallel") {
      var parallelModel = seriesModel.getReferringComponents("parallel", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = parallelModel.coordinateSystem;
    }
  });
  return coordSysList;
}
var parallelCoordSysCreator = {
  create: createParallelCoordSys
};
var parallelCoordSysCreator$1 = parallelCoordSysCreator;
var ParallelAxisModel = function(_super) {
  __extends(ParallelAxisModel2, _super);
  function ParallelAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisModel2.type;
    _this.activeIntervals = [];
    return _this;
  }
  ParallelAxisModel2.prototype.getAreaSelectStyle = function() {
    return makeStyleMapper([
      ["fill", "color"],
      ["lineWidth", "borderWidth"],
      ["stroke", "borderColor"],
      ["width", "width"],
      ["opacity", "opacity"]
    ])(this.getModel("areaSelectStyle"));
  };
  ParallelAxisModel2.prototype.setActiveIntervals = function(intervals) {
    var activeIntervals = this.activeIntervals = clone$4(intervals);
    if (activeIntervals) {
      for (var i = activeIntervals.length - 1; i >= 0; i--) {
        asc$2(activeIntervals[i]);
      }
    }
  };
  ParallelAxisModel2.prototype.getActiveState = function(value) {
    var activeIntervals = this.activeIntervals;
    if (!activeIntervals.length) {
      return "normal";
    }
    if (value == null || isNaN(+value)) {
      return "inactive";
    }
    if (activeIntervals.length === 1) {
      var interval = activeIntervals[0];
      if (interval[0] <= value && value <= interval[1]) {
        return "active";
      }
    } else {
      for (var i = 0, len2 = activeIntervals.length; i < len2; i++) {
        if (activeIntervals[i][0] <= value && value <= activeIntervals[i][1]) {
          return "active";
        }
      }
    }
    return "inactive";
  };
  return ParallelAxisModel2;
}(ComponentModel$1);
mixin(ParallelAxisModel, AxisModelCommonMixin);
var ParallelAxisModel$1 = ParallelAxisModel;
var BRUSH_PANEL_GLOBAL = true;
var mathMin$1 = Math.min;
var mathMax$1 = Math.max;
var mathPow = Math.pow;
var COVER_Z = 1e4;
var UNSELECT_THRESHOLD = 6;
var MIN_RESIZE_LINE_WIDTH = 6;
var MUTEX_RESOURCE_KEY = "globalPan";
var DIRECTION_MAP = {
  w: [0, 0],
  e: [0, 1],
  n: [1, 0],
  s: [1, 1]
};
var CURSOR_MAP = {
  w: "ew",
  e: "ew",
  n: "ns",
  s: "ns",
  ne: "nesw",
  sw: "nesw",
  nw: "nwse",
  se: "nwse"
};
var DEFAULT_BRUSH_OPT = {
  brushStyle: {
    lineWidth: 2,
    stroke: "rgba(210,219,238,0.3)",
    fill: "#D2DBEE"
  },
  transformable: true,
  brushMode: "single",
  removeOnClick: false
};
var baseUID = 0;
var BrushController = function(_super) {
  __extends(BrushController2, _super);
  function BrushController2(zr) {
    var _this = _super.call(this) || this;
    _this._track = [];
    _this._covers = [];
    _this._handlers = {};
    _this._zr = zr;
    _this.group = new Group$6();
    _this._uid = "brushController_" + baseUID++;
    each$g(pointerHandlers, function(handler, eventName) {
      this._handlers[eventName] = bind$1(handler, this);
    }, _this);
    return _this;
  }
  BrushController2.prototype.enableBrush = function(brushOption) {
    this._brushType && this._doDisableBrush();
    brushOption.brushType && this._doEnableBrush(brushOption);
    return this;
  };
  BrushController2.prototype._doEnableBrush = function(brushOption) {
    var zr = this._zr;
    if (!this._enableGlobalPan) {
      take(zr, MUTEX_RESOURCE_KEY, this._uid);
    }
    each$g(this._handlers, function(handler, eventName) {
      zr.on(eventName, handler);
    });
    this._brushType = brushOption.brushType;
    this._brushOption = merge(clone$4(DEFAULT_BRUSH_OPT), brushOption, true);
  };
  BrushController2.prototype._doDisableBrush = function() {
    var zr = this._zr;
    release(zr, MUTEX_RESOURCE_KEY, this._uid);
    each$g(this._handlers, function(handler, eventName) {
      zr.off(eventName, handler);
    });
    this._brushType = this._brushOption = null;
  };
  BrushController2.prototype.setPanels = function(panelOpts) {
    if (panelOpts && panelOpts.length) {
      var panels_1 = this._panels = {};
      each$g(panelOpts, function(panelOpts2) {
        panels_1[panelOpts2.panelId] = clone$4(panelOpts2);
      });
    } else {
      this._panels = null;
    }
    return this;
  };
  BrushController2.prototype.mount = function(opt) {
    opt = opt || {};
    this._enableGlobalPan = opt.enableGlobalPan;
    var thisGroup = this.group;
    this._zr.add(thisGroup);
    thisGroup.attr({
      x: opt.x || 0,
      y: opt.y || 0,
      rotation: opt.rotation || 0,
      scaleX: opt.scaleX || 1,
      scaleY: opt.scaleY || 1
    });
    this._transform = thisGroup.getLocalTransform();
    return this;
  };
  BrushController2.prototype.updateCovers = function(coverConfigList) {
    coverConfigList = map$1(coverConfigList, function(coverConfig) {
      return merge(clone$4(DEFAULT_BRUSH_OPT), coverConfig, true);
    });
    var tmpIdPrefix = "\0-brush-index-";
    var oldCovers = this._covers;
    var newCovers = this._covers = [];
    var controller = this;
    var creatingCover = this._creatingCover;
    new DataDiffer$1(oldCovers, coverConfigList, oldGetKey, getKey2).add(addOrUpdate).update(addOrUpdate).remove(remove).execute();
    return this;
    function getKey2(brushOption, index2) {
      return (brushOption.id != null ? brushOption.id : tmpIdPrefix + index2) + "-" + brushOption.brushType;
    }
    function oldGetKey(cover, index2) {
      return getKey2(cover.__brushOption, index2);
    }
    function addOrUpdate(newIndex, oldIndex) {
      var newBrushInternal = coverConfigList[newIndex];
      if (oldIndex != null && oldCovers[oldIndex] === creatingCover) {
        newCovers[newIndex] = oldCovers[oldIndex];
      } else {
        var cover = newCovers[newIndex] = oldIndex != null ? (oldCovers[oldIndex].__brushOption = newBrushInternal, oldCovers[oldIndex]) : endCreating(controller, createCover(controller, newBrushInternal));
        updateCoverAfterCreation(controller, cover);
      }
    }
    function remove(oldIndex) {
      if (oldCovers[oldIndex] !== creatingCover) {
        controller.group.remove(oldCovers[oldIndex]);
      }
    }
  };
  BrushController2.prototype.unmount = function() {
    this.enableBrush(false);
    clearCovers(this);
    this._zr.remove(this.group);
    return this;
  };
  BrushController2.prototype.dispose = function() {
    this.unmount();
    this.off();
  };
  return BrushController2;
}(Eventful$1);
function createCover(controller, brushOption) {
  var cover = coverRenderers[brushOption.brushType].createCover(controller, brushOption);
  cover.__brushOption = brushOption;
  updateZ$1(cover, brushOption);
  controller.group.add(cover);
  return cover;
}
function endCreating(controller, creatingCover) {
  var coverRenderer = getCoverRenderer(creatingCover);
  if (coverRenderer.endCreating) {
    coverRenderer.endCreating(controller, creatingCover);
    updateZ$1(creatingCover, creatingCover.__brushOption);
  }
  return creatingCover;
}
function updateCoverShape(controller, cover) {
  var brushOption = cover.__brushOption;
  getCoverRenderer(cover).updateCoverShape(controller, cover, brushOption.range, brushOption);
}
function updateZ$1(cover, brushOption) {
  var z2 = brushOption.z;
  z2 == null && (z2 = COVER_Z);
  cover.traverse(function(el) {
    el.z = z2;
    el.z2 = z2;
  });
}
function updateCoverAfterCreation(controller, cover) {
  getCoverRenderer(cover).updateCommon(controller, cover);
  updateCoverShape(controller, cover);
}
function getCoverRenderer(cover) {
  return coverRenderers[cover.__brushOption.brushType];
}
function getPanelByPoint(controller, e2, localCursorPoint) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panel;
  var transform2 = controller._transform;
  each$g(panels, function(pn) {
    pn.isTargetByCursor(e2, localCursorPoint, transform2) && (panel = pn);
  });
  return panel;
}
function getPanelByCover(controller, cover) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panelId = cover.__brushOption.panelId;
  return panelId != null ? panels[panelId] : BRUSH_PANEL_GLOBAL;
}
function clearCovers(controller) {
  var covers = controller._covers;
  var originalLength = covers.length;
  each$g(covers, function(cover) {
    controller.group.remove(cover);
  }, controller);
  covers.length = 0;
  return !!originalLength;
}
function trigger(controller, opt) {
  var areas = map$1(controller._covers, function(cover) {
    var brushOption = cover.__brushOption;
    var range3 = clone$4(brushOption.range);
    return {
      brushType: brushOption.brushType,
      panelId: brushOption.panelId,
      range: range3
    };
  });
  controller.trigger("brush", {
    areas,
    isEnd: !!opt.isEnd,
    removeOnClick: !!opt.removeOnClick
  });
}
function shouldShowCover(controller) {
  var track = controller._track;
  if (!track.length) {
    return false;
  }
  var p2 = track[track.length - 1];
  var p1 = track[0];
  var dx = p2[0] - p1[0];
  var dy = p2[1] - p1[1];
  var dist2 = mathPow(dx * dx + dy * dy, 0.5);
  return dist2 > UNSELECT_THRESHOLD;
}
function getTrackEnds(track) {
  var tail = track.length - 1;
  tail < 0 && (tail = 0);
  return [track[0], track[tail]];
}
function createBaseRectCover(rectRangeConverter, controller, brushOption, edgeNameSequences) {
  var cover = new Group$6();
  cover.add(new Rect$3({
    name: "main",
    style: makeStyle(brushOption),
    silent: true,
    draggable: true,
    cursor: "move",
    drift: curry$1(driftRect, rectRangeConverter, controller, cover, ["n", "s", "w", "e"]),
    ondragend: curry$1(trigger, controller, {
      isEnd: true
    })
  }));
  each$g(edgeNameSequences, function(nameSequence) {
    cover.add(new Rect$3({
      name: nameSequence.join(""),
      style: {
        opacity: 0
      },
      draggable: true,
      silent: true,
      invisible: true,
      drift: curry$1(driftRect, rectRangeConverter, controller, cover, nameSequence),
      ondragend: curry$1(trigger, controller, {
        isEnd: true
      })
    }));
  });
  return cover;
}
function updateBaseRect(controller, cover, localRange, brushOption) {
  var lineWidth = brushOption.brushStyle.lineWidth || 0;
  var handleSize = mathMax$1(lineWidth, MIN_RESIZE_LINE_WIDTH);
  var x2 = localRange[0][0];
  var y2 = localRange[1][0];
  var xa2 = x2 - lineWidth / 2;
  var ya2 = y2 - lineWidth / 2;
  var x22 = localRange[0][1];
  var y22 = localRange[1][1];
  var x2a = x22 - handleSize + lineWidth / 2;
  var y2a = y22 - handleSize + lineWidth / 2;
  var width = x22 - x2;
  var height = y22 - y2;
  var widtha = width + lineWidth;
  var heighta = height + lineWidth;
  updateRectShape(controller, cover, "main", x2, y2, width, height);
  if (brushOption.transformable) {
    updateRectShape(controller, cover, "w", xa2, ya2, handleSize, heighta);
    updateRectShape(controller, cover, "e", x2a, ya2, handleSize, heighta);
    updateRectShape(controller, cover, "n", xa2, ya2, widtha, handleSize);
    updateRectShape(controller, cover, "s", xa2, y2a, widtha, handleSize);
    updateRectShape(controller, cover, "nw", xa2, ya2, handleSize, handleSize);
    updateRectShape(controller, cover, "ne", x2a, ya2, handleSize, handleSize);
    updateRectShape(controller, cover, "sw", xa2, y2a, handleSize, handleSize);
    updateRectShape(controller, cover, "se", x2a, y2a, handleSize, handleSize);
  }
}
function updateCommon$1(controller, cover) {
  var brushOption = cover.__brushOption;
  var transformable = brushOption.transformable;
  var mainEl = cover.childAt(0);
  mainEl.useStyle(makeStyle(brushOption));
  mainEl.attr({
    silent: !transformable,
    cursor: transformable ? "move" : "default"
  });
  each$g([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(nameSequence) {
    var el = cover.childOfName(nameSequence.join(""));
    var globalDir = nameSequence.length === 1 ? getGlobalDirection1(controller, nameSequence[0]) : getGlobalDirection2(controller, nameSequence);
    el && el.attr({
      silent: !transformable,
      invisible: !transformable,
      cursor: transformable ? CURSOR_MAP[globalDir] + "-resize" : null
    });
  });
}
function updateRectShape(controller, cover, name, x2, y2, w2, h) {
  var el = cover.childOfName(name);
  el && el.setShape(pointsToRect(clipByPanel(controller, cover, [[x2, y2], [x2 + w2, y2 + h]])));
}
function makeStyle(brushOption) {
  return defaults({
    strokeNoScale: true
  }, brushOption.brushStyle);
}
function formatRectRange(x2, y2, x22, y22) {
  var min3 = [mathMin$1(x2, x22), mathMin$1(y2, y22)];
  var max3 = [mathMax$1(x2, x22), mathMax$1(y2, y22)];
  return [
    [min3[0], max3[0]],
    [min3[1], max3[1]]
  ];
}
function getTransform(controller) {
  return getTransform$1(controller.group);
}
function getGlobalDirection1(controller, localDirName) {
  var map2 = {
    w: "left",
    e: "right",
    n: "top",
    s: "bottom"
  };
  var inverseMap = {
    left: "w",
    right: "e",
    top: "n",
    bottom: "s"
  };
  var dir3 = transformDirection(map2[localDirName], getTransform(controller));
  return inverseMap[dir3];
}
function getGlobalDirection2(controller, localDirNameSeq) {
  var globalDir = [getGlobalDirection1(controller, localDirNameSeq[0]), getGlobalDirection1(controller, localDirNameSeq[1])];
  (globalDir[0] === "e" || globalDir[0] === "w") && globalDir.reverse();
  return globalDir.join("");
}
function driftRect(rectRangeConverter, controller, cover, dirNameSequence, dx, dy) {
  var brushOption = cover.__brushOption;
  var rectRange = rectRangeConverter.toRectRange(brushOption.range);
  var localDelta = toLocalDelta(controller, dx, dy);
  each$g(dirNameSequence, function(dirName) {
    var ind = DIRECTION_MAP[dirName];
    rectRange[ind[0]][ind[1]] += localDelta[ind[0]];
  });
  brushOption.range = rectRangeConverter.fromRectRange(formatRectRange(rectRange[0][0], rectRange[1][0], rectRange[0][1], rectRange[1][1]));
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function driftPolygon(controller, cover, dx, dy) {
  var range3 = cover.__brushOption.range;
  var localDelta = toLocalDelta(controller, dx, dy);
  each$g(range3, function(point) {
    point[0] += localDelta[0];
    point[1] += localDelta[1];
  });
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function toLocalDelta(controller, dx, dy) {
  var thisGroup = controller.group;
  var localD = thisGroup.transformCoordToLocal(dx, dy);
  var localZero = thisGroup.transformCoordToLocal(0, 0);
  return [localD[0] - localZero[0], localD[1] - localZero[1]];
}
function clipByPanel(controller, cover, data) {
  var panel = getPanelByCover(controller, cover);
  return panel && panel !== BRUSH_PANEL_GLOBAL ? panel.clipPath(data, controller._transform) : clone$4(data);
}
function pointsToRect(points2) {
  var xmin = mathMin$1(points2[0][0], points2[1][0]);
  var ymin = mathMin$1(points2[0][1], points2[1][1]);
  var xmax = mathMax$1(points2[0][0], points2[1][0]);
  var ymax = mathMax$1(points2[0][1], points2[1][1]);
  return {
    x: xmin,
    y: ymin,
    width: xmax - xmin,
    height: ymax - ymin
  };
}
function resetCursor(controller, e2, localCursorPoint) {
  if (!controller._brushType || isOutsideZrArea(controller, e2.offsetX, e2.offsetY)) {
    return;
  }
  var zr = controller._zr;
  var covers = controller._covers;
  var currPanel = getPanelByPoint(controller, e2, localCursorPoint);
  if (!controller._dragging) {
    for (var i = 0; i < covers.length; i++) {
      var brushOption = covers[i].__brushOption;
      if (currPanel && (currPanel === BRUSH_PANEL_GLOBAL || brushOption.panelId === currPanel.panelId) && coverRenderers[brushOption.brushType].contain(covers[i], localCursorPoint[0], localCursorPoint[1])) {
        return;
      }
    }
  }
  currPanel && zr.setCursorStyle("crosshair");
}
function preventDefault(e2) {
  var rawE = e2.event;
  rawE.preventDefault && rawE.preventDefault();
}
function mainShapeContain(cover, x2, y2) {
  return cover.childOfName("main").contain(x2, y2);
}
function updateCoverByMouse(controller, e2, localCursorPoint, isEnd) {
  var creatingCover = controller._creatingCover;
  var panel = controller._creatingPanel;
  var thisBrushOption = controller._brushOption;
  var eventParams;
  controller._track.push(localCursorPoint.slice());
  if (shouldShowCover(controller) || creatingCover) {
    if (panel && !creatingCover) {
      thisBrushOption.brushMode === "single" && clearCovers(controller);
      var brushOption = clone$4(thisBrushOption);
      brushOption.brushType = determineBrushType(brushOption.brushType, panel);
      brushOption.panelId = panel === BRUSH_PANEL_GLOBAL ? null : panel.panelId;
      creatingCover = controller._creatingCover = createCover(controller, brushOption);
      controller._covers.push(creatingCover);
    }
    if (creatingCover) {
      var coverRenderer = coverRenderers[determineBrushType(controller._brushType, panel)];
      var coverBrushOption = creatingCover.__brushOption;
      coverBrushOption.range = coverRenderer.getCreatingRange(clipByPanel(controller, creatingCover, controller._track));
      if (isEnd) {
        endCreating(controller, creatingCover);
        coverRenderer.updateCommon(controller, creatingCover);
      }
      updateCoverShape(controller, creatingCover);
      eventParams = {
        isEnd
      };
    }
  } else if (isEnd && thisBrushOption.brushMode === "single" && thisBrushOption.removeOnClick) {
    if (getPanelByPoint(controller, e2, localCursorPoint) && clearCovers(controller)) {
      eventParams = {
        isEnd,
        removeOnClick: true
      };
    }
  }
  return eventParams;
}
function determineBrushType(brushType, panel) {
  if (brushType === "auto") {
    return panel.defaultBrushType;
  }
  return brushType;
}
var pointerHandlers = {
  mousedown: function(e2) {
    if (this._dragging) {
      handleDragEnd(this, e2);
    } else if (!e2.target || !e2.target.draggable) {
      preventDefault(e2);
      var localCursorPoint = this.group.transformCoordToLocal(e2.offsetX, e2.offsetY);
      this._creatingCover = null;
      var panel = this._creatingPanel = getPanelByPoint(this, e2, localCursorPoint);
      if (panel) {
        this._dragging = true;
        this._track = [localCursorPoint.slice()];
      }
    }
  },
  mousemove: function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = this.group.transformCoordToLocal(x2, y2);
    resetCursor(this, e2, localCursorPoint);
    if (this._dragging) {
      preventDefault(e2);
      var eventParams = updateCoverByMouse(this, e2, localCursorPoint, false);
      eventParams && trigger(this, eventParams);
    }
  },
  mouseup: function(e2) {
    handleDragEnd(this, e2);
  }
};
function handleDragEnd(controller, e2) {
  if (controller._dragging) {
    preventDefault(e2);
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = controller.group.transformCoordToLocal(x2, y2);
    var eventParams = updateCoverByMouse(controller, e2, localCursorPoint, true);
    controller._dragging = false;
    controller._track = [];
    controller._creatingCover = null;
    eventParams && trigger(controller, eventParams);
  }
}
function isOutsideZrArea(controller, x2, y2) {
  var zr = controller._zr;
  return x2 < 0 || x2 > zr.getWidth() || y2 < 0 || y2 > zr.getHeight();
}
var coverRenderers = {
  lineX: getLineRenderer(0),
  lineY: getLineRenderer(1),
  rect: {
    createCover: function(controller, brushOption) {
      function returnInput(range3) {
        return range3;
      }
      return createBaseRectCover({
        toRectRange: returnInput,
        fromRectRange: returnInput
      }, controller, brushOption, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      return formatRectRange(ends[1][0], ends[1][1], ends[0][0], ends[0][1]);
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      updateBaseRect(controller, cover, localRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  },
  polygon: {
    createCover: function(controller, brushOption) {
      var cover = new Group$6();
      cover.add(new Polyline$3({
        name: "main",
        style: makeStyle(brushOption),
        silent: true
      }));
      return cover;
    },
    getCreatingRange: function(localTrack) {
      return localTrack;
    },
    endCreating: function(controller, cover) {
      cover.remove(cover.childAt(0));
      cover.add(new Polygon$1({
        name: "main",
        draggable: true,
        drift: curry$1(driftPolygon, controller, cover),
        ondragend: curry$1(trigger, controller, {
          isEnd: true
        })
      }));
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      cover.childAt(0).setShape({
        points: clipByPanel(controller, cover, localRange)
      });
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  }
};
function getLineRenderer(xyIndex) {
  return {
    createCover: function(controller, brushOption) {
      return createBaseRectCover({
        toRectRange: function(range3) {
          var rectRange = [range3, [0, 100]];
          xyIndex && rectRange.reverse();
          return rectRange;
        },
        fromRectRange: function(rectRange) {
          return rectRange[xyIndex];
        }
      }, controller, brushOption, [[["w"], ["e"]], [["n"], ["s"]]][xyIndex]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      var min3 = mathMin$1(ends[0][xyIndex], ends[1][xyIndex]);
      var max3 = mathMax$1(ends[0][xyIndex], ends[1][xyIndex]);
      return [min3, max3];
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      var otherExtent;
      var panel = getPanelByCover(controller, cover);
      if (panel !== BRUSH_PANEL_GLOBAL && panel.getLinearBrushOtherExtent) {
        otherExtent = panel.getLinearBrushOtherExtent(xyIndex);
      } else {
        var zr = controller._zr;
        otherExtent = [0, [zr.getWidth(), zr.getHeight()][1 - xyIndex]];
      }
      var rectRange = [localRange, otherExtent];
      xyIndex && rectRange.reverse();
      updateBaseRect(controller, cover, rectRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  };
}
var BrushController$1 = BrushController;
function makeRectPanelClipPath(rect) {
  rect = normalizeRect(rect);
  return function(localPoints) {
    return clipPointsByRect(localPoints, rect);
  };
}
function makeLinearBrushOtherExtent(rect, specifiedXYIndex) {
  rect = normalizeRect(rect);
  return function(xyIndex) {
    var idx = specifiedXYIndex != null ? specifiedXYIndex : xyIndex;
    var brushWidth = idx ? rect.width : rect.height;
    var base2 = idx ? rect.x : rect.y;
    return [base2, base2 + (brushWidth || 0)];
  };
}
function makeRectIsTargetByCursor(rect, api, targetModel) {
  var boundingRect = normalizeRect(rect);
  return function(e2, localCursorPoint) {
    return boundingRect.contain(localCursorPoint[0], localCursorPoint[1]) && !onIrrelevantElement(e2, api, targetModel);
  };
}
function normalizeRect(rect) {
  return BoundingRect$1.create(rect);
}
var elementList$1 = ["axisLine", "axisTickLabel", "axisName"];
var ParallelAxisView = function(_super) {
  __extends(ParallelAxisView2, _super);
  function ParallelAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisView2.type;
    return _this;
  }
  ParallelAxisView2.prototype.init = function(ecModel, api) {
    _super.prototype.init.apply(this, arguments);
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this));
  };
  ParallelAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    if (fromAxisAreaSelect(axisModel, ecModel, payload)) {
      return;
    }
    this.axisModel = axisModel;
    this.api = api;
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$6();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var coordSysModel = getCoordSysModel(axisModel, ecModel);
    var coordSys = coordSysModel.coordinateSystem;
    var areaSelectStyle = axisModel.getAreaSelectStyle();
    var areaWidth = areaSelectStyle.width;
    var dim = axisModel.axis.dim;
    var axisLayout = coordSys.getAxisLayout(dim);
    var builderOpt = extend({
      strokeContainThreshold: areaWidth
    }, axisLayout);
    var axisBuilder = new AxisBuilder$1(axisModel, builderOpt);
    each$g(elementList$1, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    this._refreshBrushController(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
  };
  ParallelAxisView2.prototype._refreshBrushController = function(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api) {
    var extent3 = axisModel.axis.getExtent();
    var extentLen = extent3[1] - extent3[0];
    var extra = Math.min(30, Math.abs(extentLen) * 0.1);
    var rect = BoundingRect$1.create({
      x: extent3[0],
      y: -areaWidth / 2,
      width: extentLen,
      height: areaWidth
    });
    rect.x -= extra;
    rect.width += 2 * extra;
    this._brushController.mount({
      enableGlobalPan: true,
      rotation: builderOpt.rotation,
      x: builderOpt.position[0],
      y: builderOpt.position[1]
    }).setPanels([{
      panelId: "pl",
      clipPath: makeRectPanelClipPath(rect),
      isTargetByCursor: makeRectIsTargetByCursor(rect, api, coordSysModel),
      getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect, 0)
    }]).enableBrush({
      brushType: "lineX",
      brushStyle: areaSelectStyle,
      removeOnClick: true
    }).updateCovers(getCoverInfoList(axisModel));
  };
  ParallelAxisView2.prototype._onBrush = function(eventParam) {
    var coverInfoList = eventParam.areas;
    var axisModel = this.axisModel;
    var axis = axisModel.axis;
    var intervals = map$1(coverInfoList, function(coverInfo) {
      return [axis.coordToData(coverInfo.range[0], true), axis.coordToData(coverInfo.range[1], true)];
    });
    if (!axisModel.option.realtime === eventParam.isEnd || eventParam.removeOnClick) {
      this.api.dispatchAction({
        type: "axisAreaSelect",
        parallelAxisId: axisModel.id,
        intervals
      });
    }
  };
  ParallelAxisView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  ParallelAxisView2.type = "parallelAxis";
  return ParallelAxisView2;
}(ComponentView$1);
function fromAxisAreaSelect(axisModel, ecModel, payload) {
  return payload && payload.type === "axisAreaSelect" && ecModel.findComponents({
    mainType: "parallelAxis",
    query: payload
  })[0] === axisModel;
}
function getCoverInfoList(axisModel) {
  var axis = axisModel.axis;
  return map$1(axisModel.activeIntervals, function(interval) {
    return {
      brushType: "lineX",
      panelId: "pl",
      range: [axis.dataToCoord(interval[0], true), axis.dataToCoord(interval[1], true)]
    };
  });
}
function getCoordSysModel(axisModel, ecModel) {
  return ecModel.getComponent("parallel", axisModel.get("parallelIndex"));
}
var ParallelAxisView$1 = ParallelAxisView;
var actionInfo = {
  type: "axisAreaSelect",
  event: "axisAreaSelected"
};
function installParallelActions(registers) {
  registers.registerAction(actionInfo, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallelAxis",
      query: payload
    }, function(parallelAxisModel) {
      parallelAxisModel.axis.model.setActiveIntervals(payload.intervals);
    });
  });
  registers.registerAction("parallelAxisExpand", function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallel",
      query: payload
    }, function(parallelModel) {
      parallelModel.setAxisExpand(payload);
    });
  });
}
var defaultAxisOption = {
  type: "value",
  areaSelectStyle: {
    width: 20,
    borderWidth: 1,
    borderColor: "rgba(160,197,232)",
    color: "rgba(160,197,232)",
    opacity: 0.3
  },
  realtime: true,
  z: 10
};
function install$C(registers) {
  registers.registerComponentView(ParallelView$1);
  registers.registerComponentModel(ParallelModel$1);
  registers.registerCoordinateSystem("parallel", parallelCoordSysCreator$1);
  registers.registerPreprocessor(parallelPreprocessor);
  registers.registerComponentModel(ParallelAxisModel$1);
  registers.registerComponentView(ParallelAxisView$1);
  axisModelCreator(registers, "parallel", ParallelAxisModel$1, defaultAxisOption);
  installParallelActions(registers);
}
function install$B(registers) {
  use(install$C);
  registers.registerChartView(ParallelView$3);
  registers.registerSeriesModel(ParallelSeriesModel$1);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, parallelVisual$1);
}
var SankeyPathShape = function() {
  function SankeyPathShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.cpx2 = 0;
    this.cpy2 = 0;
    this.extent = 0;
  }
  return SankeyPathShape2;
}();
var SankeyPath = function(_super) {
  __extends(SankeyPath2, _super);
  function SankeyPath2(opts) {
    return _super.call(this, opts) || this;
  }
  SankeyPath2.prototype.getDefaultShape = function() {
    return new SankeyPathShape();
  };
  SankeyPath2.prototype.buildPath = function(ctx, shape) {
    var extent3 = shape.extent;
    ctx.moveTo(shape.x1, shape.y1);
    ctx.bezierCurveTo(shape.cpx1, shape.cpy1, shape.cpx2, shape.cpy2, shape.x2, shape.y2);
    if (shape.orient === "vertical") {
      ctx.lineTo(shape.x2 + extent3, shape.y2);
      ctx.bezierCurveTo(shape.cpx2 + extent3, shape.cpy2, shape.cpx1 + extent3, shape.cpy1, shape.x1 + extent3, shape.y1);
    } else {
      ctx.lineTo(shape.x2, shape.y2 + extent3);
      ctx.bezierCurveTo(shape.cpx2, shape.cpy2 + extent3, shape.cpx1, shape.cpy1 + extent3, shape.x1, shape.y1 + extent3);
    }
    ctx.closePath();
  };
  SankeyPath2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  SankeyPath2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  return SankeyPath2;
}(Path$1);
var SankeyView = function(_super) {
  __extends(SankeyView2, _super);
  function SankeyView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeyView2.type;
    _this._focusAdjacencyDisabled = false;
    return _this;
  }
  SankeyView2.prototype.render = function(seriesModel, ecModel, api) {
    var sankeyView = this;
    var graph = seriesModel.getGraph();
    var group = this.group;
    var layoutInfo = seriesModel.layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var nodeData = seriesModel.getData();
    var edgeData = seriesModel.getData("edge");
    var orient = seriesModel.get("orient");
    this._model = seriesModel;
    group.removeAll();
    group.x = layoutInfo.x;
    group.y = layoutInfo.y;
    graph.eachEdge(function(edge) {
      var curve = new SankeyPath();
      var ecData = getECData(curve);
      ecData.dataIndex = edge.dataIndex;
      ecData.seriesIndex = seriesModel.seriesIndex;
      ecData.dataType = "edge";
      var edgeModel = edge.getModel();
      var lineStyleModel = edgeModel.getModel("lineStyle");
      var curvature = lineStyleModel.get("curveness");
      var n1Layout = edge.node1.getLayout();
      var node1Model = edge.node1.getModel();
      var dragX1 = node1Model.get("localX");
      var dragY1 = node1Model.get("localY");
      var n2Layout = edge.node2.getLayout();
      var node2Model = edge.node2.getModel();
      var dragX2 = node2Model.get("localX");
      var dragY2 = node2Model.get("localY");
      var edgeLayout = edge.getLayout();
      var x1;
      var y1;
      var x2;
      var y2;
      var cpx1;
      var cpy1;
      var cpx2;
      var cpy2;
      curve.shape.extent = Math.max(1, edgeLayout.dy);
      curve.shape.orient = orient;
      if (orient === "vertical") {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + edgeLayout.sy;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + n1Layout.dy;
        x2 = (dragX2 != null ? dragX2 * width : n2Layout.x) + edgeLayout.ty;
        y2 = dragY2 != null ? dragY2 * height : n2Layout.y;
        cpx1 = x1;
        cpy1 = y1 * (1 - curvature) + y2 * curvature;
        cpx2 = x2;
        cpy2 = y1 * curvature + y2 * (1 - curvature);
      } else {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + n1Layout.dx;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + edgeLayout.sy;
        x2 = dragX2 != null ? dragX2 * width : n2Layout.x;
        y2 = (dragY2 != null ? dragY2 * height : n2Layout.y) + edgeLayout.ty;
        cpx1 = x1 * (1 - curvature) + x2 * curvature;
        cpy1 = y1;
        cpx2 = x1 * curvature + x2 * (1 - curvature);
        cpy2 = y2;
      }
      curve.setShape({
        x1,
        y1,
        x2,
        y2,
        cpx1,
        cpy1,
        cpx2,
        cpy2
      });
      curve.useStyle(lineStyleModel.getItemStyle());
      switch (curve.style.fill) {
        case "source":
          curve.style.fill = edge.node1.getVisual("color");
          curve.style.decal = edge.node1.getVisual("style").decal;
          break;
        case "target":
          curve.style.fill = edge.node2.getVisual("color");
          curve.style.decal = edge.node2.getVisual("style").decal;
          break;
        case "gradient":
          var sourceColor = edge.node1.getVisual("color");
          var targetColor = edge.node2.getVisual("color");
          if (isString$1(sourceColor) && isString$1(targetColor)) {
            curve.style.fill = new LinearGradient$1(0, 0, +(orient === "horizontal"), +(orient === "vertical"), [{
              color: sourceColor,
              offset: 0
            }, {
              color: targetColor,
              offset: 1
            }]);
          }
      }
      var emphasisModel = edgeModel.getModel("emphasis");
      setStatesStylesFromModel(curve, edgeModel, "lineStyle", function(model) {
        return model.getItemStyle();
      });
      group.add(curve);
      edgeData.setItemGraphicEl(edge.dataIndex, curve);
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(curve, focus === "adjacency" ? edge.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
      getECData(curve).dataType = "edge";
    });
    graph.eachNode(function(node) {
      var layout2 = node.getLayout();
      var itemModel = node.getModel();
      var dragX = itemModel.get("localX");
      var dragY = itemModel.get("localY");
      var emphasisModel = itemModel.getModel("emphasis");
      var rect = new Rect$3({
        shape: {
          x: dragX != null ? dragX * width : layout2.x,
          y: dragY != null ? dragY * height : layout2.y,
          width: layout2.dx,
          height: layout2.dy
        },
        style: itemModel.getModel("itemStyle").getItemStyle(),
        z2: 10
      });
      setLabelStyle(rect, getLabelStatesModels(itemModel), {
        labelFetcher: seriesModel,
        labelDataIndex: node.dataIndex,
        defaultText: node.id
      });
      rect.disableLabelAnimation = true;
      rect.setStyle("fill", node.getVisual("color"));
      rect.setStyle("decal", node.getVisual("style").decal);
      setStatesStylesFromModel(rect, itemModel);
      group.add(rect);
      nodeData.setItemGraphicEl(node.dataIndex, rect);
      getECData(rect).dataType = "node";
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(rect, focus === "adjacency" ? node.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    nodeData.eachItemGraphicEl(function(el, dataIndex) {
      var itemModel = nodeData.getItemModel(dataIndex);
      if (itemModel.get("draggable")) {
        el.drift = function(dx, dy) {
          sankeyView._focusAdjacencyDisabled = true;
          this.shape.x += dx;
          this.shape.y += dy;
          this.dirty();
          api.dispatchAction({
            type: "dragNode",
            seriesId: seriesModel.id,
            dataIndex: nodeData.getRawIndex(dataIndex),
            localX: this.shape.x / width,
            localY: this.shape.y / height
          });
        };
        el.ondragend = function() {
          sankeyView._focusAdjacencyDisabled = false;
        };
        el.draggable = true;
        el.cursor = "move";
      }
    });
    if (!this._data && seriesModel.isAnimationEnabled()) {
      group.setClipPath(createGridClipShape$1(group.getBoundingRect(), seriesModel, function() {
        group.removeClipPath();
      }));
    }
    this._data = seriesModel.getData();
  };
  SankeyView2.prototype.dispose = function() {
  };
  SankeyView2.type = "sankey";
  return SankeyView2;
}(ChartView$1);
function createGridClipShape$1(rect, seriesModel, cb2) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      width: rect.width + 20
    }
  }, seriesModel, cb2);
  return rectEl;
}
var SankeyView$1 = SankeyView;
var SankeySeriesModel = function(_super) {
  __extends(SankeySeriesModel2, _super);
  function SankeySeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeySeriesModel2.type;
    return _this;
  }
  SankeySeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var links = option.edges || option.links;
    var nodes = option.data || option.nodes;
    var levels = option.levels;
    this.levelModels = [];
    var levelModels = this.levelModels;
    for (var i = 0; i < levels.length; i++) {
      if (levels[i].depth != null && levels[i].depth >= 0) {
        levelModels[levels[i].depth] = new Model$1(levels[i], this, ecModel);
      }
    }
    if (nodes && links) {
      var graph = createGraphFromNodeEdge(nodes, links, this, true, beforeLink);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var layout2 = seriesModel.getData().getItemLayout(idx);
        if (layout2) {
          var nodeDepth = layout2.depth;
          var levelModel = seriesModel.levelModels[nodeDepth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
      edgeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var edge = seriesModel.getGraph().getEdgeByIndex(idx);
        var layout2 = edge.node1.getLayout();
        if (layout2) {
          var depth = layout2.depth;
          var levelModel = seriesModel.levelModels[depth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
    }
  };
  SankeySeriesModel2.prototype.setNodePosition = function(dataIndex, localPosition) {
    var nodes = this.option.data || this.option.nodes;
    var dataItem = nodes[dataIndex];
    dataItem.localX = localPosition[0];
    dataItem.localY = localPosition[1];
  };
  SankeySeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  SankeySeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  SankeySeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    function noValue(val) {
      return isNaN(val) || val == null;
    }
    if (dataType === "edge") {
      var params = this.getDataParams(dataIndex, dataType);
      var rawDataOpt = params.data;
      var edgeValue = params.value;
      var edgeName = rawDataOpt.source + " -- " + rawDataOpt.target;
      return createTooltipMarkup("nameValue", {
        name: edgeName,
        value: edgeValue,
        noValue: noValue(edgeValue)
      });
    } else {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var value = node.getLayout().value;
      var name_1 = this.getDataParams(dataIndex, dataType).data.name;
      return createTooltipMarkup("nameValue", {
        name: name_1 != null ? name_1 + "" : null,
        value,
        noValue: noValue(value)
      });
    }
  };
  SankeySeriesModel2.prototype.optionUpdated = function() {
  };
  SankeySeriesModel2.prototype.getDataParams = function(dataIndex, dataType) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    if (params.value == null && dataType === "node") {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var nodeValue = node.getLayout().value;
      params.value = nodeValue;
    }
    return params;
  };
  SankeySeriesModel2.type = "series.sankey";
  SankeySeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "5%",
    top: "5%",
    right: "20%",
    bottom: "5%",
    orient: "horizontal",
    nodeWidth: 20,
    nodeGap: 8,
    draggable: true,
    layoutIterations: 32,
    label: {
      show: true,
      position: "right",
      fontSize: 12
    },
    levels: [],
    nodeAlign: "justify",
    lineStyle: {
      color: "#314656",
      opacity: 0.2,
      curveness: 0.5
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        opacity: 0.5
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    animationEasing: "linear",
    animationDuration: 1e3
  };
  return SankeySeriesModel2;
}(SeriesModel$1);
var SankeySeriesModel$1 = SankeySeriesModel;
function sankeyLayout(ecModel, api) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var nodeWidth = seriesModel.get("nodeWidth");
    var nodeGap = seriesModel.get("nodeGap");
    var layoutInfo = getViewRect$1(seriesModel, api);
    seriesModel.layoutInfo = layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    var edges = graph.edges;
    computeNodeValues(nodes);
    var filteredNodes = filter(nodes, function(node) {
      return node.getLayout().value === 0;
    });
    var iterations = filteredNodes.length !== 0 ? 0 : seriesModel.get("layoutIterations");
    var orient = seriesModel.get("orient");
    var nodeAlign = seriesModel.get("nodeAlign");
    layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign);
  });
}
function getViewRect$1(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign) {
  computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign);
  computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient);
  computeEdgeDepths(nodes, orient);
}
function computeNodeValues(nodes) {
  each$g(nodes, function(node) {
    var value1 = sum(node.outEdges, getEdgeValue);
    var value2 = sum(node.inEdges, getEdgeValue);
    var nodeRawValue = node.getValue() || 0;
    var value = Math.max(value1, value2, nodeRawValue);
    node.setLayout({
      value
    }, true);
  });
}
function computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign) {
  var remainEdges = [];
  var indegreeArr = [];
  var zeroIndegrees = [];
  var nextTargetNode = [];
  var x2 = 0;
  for (var i = 0; i < edges.length; i++) {
    remainEdges[i] = 1;
  }
  for (var i = 0; i < nodes.length; i++) {
    indegreeArr[i] = nodes[i].inEdges.length;
    if (indegreeArr[i] === 0) {
      zeroIndegrees.push(nodes[i]);
    }
  }
  var maxNodeDepth = -1;
  while (zeroIndegrees.length) {
    for (var idx = 0; idx < zeroIndegrees.length; idx++) {
      var node = zeroIndegrees[idx];
      var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
      var isItemDepth = item.depth != null && item.depth >= 0;
      if (isItemDepth && item.depth > maxNodeDepth) {
        maxNodeDepth = item.depth;
      }
      node.setLayout({
        depth: isItemDepth ? item.depth : x2
      }, true);
      orient === "vertical" ? node.setLayout({
        dy: nodeWidth
      }, true) : node.setLayout({
        dx: nodeWidth
      }, true);
      for (var edgeIdx = 0; edgeIdx < node.outEdges.length; edgeIdx++) {
        var edge = node.outEdges[edgeIdx];
        var indexEdge = edges.indexOf(edge);
        remainEdges[indexEdge] = 0;
        var targetNode = edge.node2;
        var nodeIndex = nodes.indexOf(targetNode);
        if (--indegreeArr[nodeIndex] === 0 && nextTargetNode.indexOf(targetNode) < 0) {
          nextTargetNode.push(targetNode);
        }
      }
    }
    ++x2;
    zeroIndegrees = nextTargetNode;
    nextTargetNode = [];
  }
  for (var i = 0; i < remainEdges.length; i++) {
    if (remainEdges[i] === 1) {
      throw new Error("Sankey is a DAG, the original data has cycle!");
    }
  }
  var maxDepth = maxNodeDepth > x2 - 1 ? maxNodeDepth : x2 - 1;
  if (nodeAlign && nodeAlign !== "left") {
    adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth);
  }
  var kx = orient === "vertical" ? (height - nodeWidth) / maxDepth : (width - nodeWidth) / maxDepth;
  scaleNodeBreadths(nodes, kx, orient);
}
function isNodeDepth(node) {
  var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
  return item.depth != null && item.depth >= 0;
}
function adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth) {
  if (nodeAlign === "right") {
    var nextSourceNode = [];
    var remainNodes = nodes;
    var nodeHeight = 0;
    while (remainNodes.length) {
      for (var i = 0; i < remainNodes.length; i++) {
        var node = remainNodes[i];
        node.setLayout({
          skNodeHeight: nodeHeight
        }, true);
        for (var j = 0; j < node.inEdges.length; j++) {
          var edge = node.inEdges[j];
          if (nextSourceNode.indexOf(edge.node1) < 0) {
            nextSourceNode.push(edge.node1);
          }
        }
      }
      remainNodes = nextSourceNode;
      nextSourceNode = [];
      ++nodeHeight;
    }
    each$g(nodes, function(node2) {
      if (!isNodeDepth(node2)) {
        node2.setLayout({
          depth: Math.max(0, maxDepth - node2.getLayout().skNodeHeight)
        }, true);
      }
    });
  } else if (nodeAlign === "justify") {
    moveSinksRight(nodes, maxDepth);
  }
}
function moveSinksRight(nodes, maxDepth) {
  each$g(nodes, function(node) {
    if (!isNodeDepth(node) && !node.outEdges.length) {
      node.setLayout({
        depth: maxDepth
      }, true);
    }
  });
}
function scaleNodeBreadths(nodes, kx, orient) {
  each$g(nodes, function(node) {
    var nodeDepth = node.getLayout().depth * kx;
    orient === "vertical" ? node.setLayout({
      y: nodeDepth
    }, true) : node.setLayout({
      x: nodeDepth
    }, true);
  });
}
function computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient) {
  var nodesByBreadth = prepareNodesByBreadth(nodes, orient);
  initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient);
  resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  for (var alpha = 1; iterations > 0; iterations--) {
    alpha *= 0.99;
    relaxRightToLeft(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
    relaxLeftToRight(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  }
}
function prepareNodesByBreadth(nodes, orient) {
  var nodesByBreadth = [];
  var keyAttr = orient === "vertical" ? "y" : "x";
  var groupResult = groupData(nodes, function(node) {
    return node.getLayout()[keyAttr];
  });
  groupResult.keys.sort(function(a, b2) {
    return a - b2;
  });
  each$g(groupResult.keys, function(key) {
    nodesByBreadth.push(groupResult.buckets.get(key));
  });
  return nodesByBreadth;
}
function initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient) {
  var minKy = Infinity;
  each$g(nodesByBreadth, function(nodes) {
    var n2 = nodes.length;
    var sum2 = 0;
    each$g(nodes, function(node) {
      sum2 += node.getLayout().value;
    });
    var ky = orient === "vertical" ? (width - (n2 - 1) * nodeGap) / sum2 : (height - (n2 - 1) * nodeGap) / sum2;
    if (ky < minKy) {
      minKy = ky;
    }
  });
  each$g(nodesByBreadth, function(nodes) {
    each$g(nodes, function(node, i) {
      var nodeDy = node.getLayout().value * minKy;
      if (orient === "vertical") {
        node.setLayout({
          x: i
        }, true);
        node.setLayout({
          dx: nodeDy
        }, true);
      } else {
        node.setLayout({
          y: i
        }, true);
        node.setLayout({
          dy: nodeDy
        }, true);
      }
    });
  });
  each$g(edges, function(edge) {
    var edgeDy = +edge.getValue() * minKy;
    edge.setLayout({
      dy: edgeDy
    }, true);
  });
}
function resolveCollisions(nodesByBreadth, nodeGap, height, width, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$g(nodesByBreadth, function(nodes) {
    nodes.sort(function(a, b2) {
      return a.getLayout()[keyAttr] - b2.getLayout()[keyAttr];
    });
    var nodeX;
    var node;
    var dy;
    var y0 = 0;
    var n2 = nodes.length;
    var nodeDyAttr = orient === "vertical" ? "dx" : "dy";
    for (var i = 0; i < n2; i++) {
      node = nodes[i];
      dy = y0 - node.getLayout()[keyAttr];
      if (dy > 0) {
        nodeX = node.getLayout()[keyAttr] + dy;
        orient === "vertical" ? node.setLayout({
          x: nodeX
        }, true) : node.setLayout({
          y: nodeX
        }, true);
      }
      y0 = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap;
    }
    var viewWidth = orient === "vertical" ? width : height;
    dy = y0 - nodeGap - viewWidth;
    if (dy > 0) {
      nodeX = node.getLayout()[keyAttr] - dy;
      orient === "vertical" ? node.setLayout({
        x: nodeX
      }, true) : node.setLayout({
        y: nodeX
      }, true);
      y0 = nodeX;
      for (var i = n2 - 2; i >= 0; --i) {
        node = nodes[i];
        dy = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap - y0;
        if (dy > 0) {
          nodeX = node.getLayout()[keyAttr] - dy;
          orient === "vertical" ? node.setLayout({
            x: nodeX
          }, true) : node.setLayout({
            y: nodeX
          }, true);
        }
        y0 = node.getLayout()[keyAttr];
      }
    }
  });
}
function relaxRightToLeft(nodesByBreadth, alpha, orient) {
  each$g(nodesByBreadth.slice().reverse(), function(nodes) {
    each$g(nodes, function(node) {
      if (node.outEdges.length) {
        var y2 = sum(node.outEdges, weightedTarget, orient) / sum(node.outEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.outEdges.length;
          y2 = len2 ? sum(node.outEdges, centerTarget, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function weightedTarget(edge, orient) {
  return center(edge.node2, orient) * edge.getValue();
}
function centerTarget(edge, orient) {
  return center(edge.node2, orient);
}
function weightedSource(edge, orient) {
  return center(edge.node1, orient) * edge.getValue();
}
function centerSource(edge, orient) {
  return center(edge.node1, orient);
}
function center(node, orient) {
  return orient === "vertical" ? node.getLayout().x + node.getLayout().dx / 2 : node.getLayout().y + node.getLayout().dy / 2;
}
function getEdgeValue(edge) {
  return edge.getValue();
}
function sum(array4, cb2, orient) {
  var sum2 = 0;
  var len2 = array4.length;
  var i = -1;
  while (++i < len2) {
    var value = +cb2(array4[i], orient);
    if (!isNaN(value)) {
      sum2 += value;
    }
  }
  return sum2;
}
function relaxLeftToRight(nodesByBreadth, alpha, orient) {
  each$g(nodesByBreadth, function(nodes) {
    each$g(nodes, function(node) {
      if (node.inEdges.length) {
        var y2 = sum(node.inEdges, weightedSource, orient) / sum(node.inEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.inEdges.length;
          y2 = len2 ? sum(node.inEdges, centerSource, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function computeEdgeDepths(nodes, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$g(nodes, function(node) {
    node.outEdges.sort(function(a, b2) {
      return a.node2.getLayout()[keyAttr] - b2.node2.getLayout()[keyAttr];
    });
    node.inEdges.sort(function(a, b2) {
      return a.node1.getLayout()[keyAttr] - b2.node1.getLayout()[keyAttr];
    });
  });
  each$g(nodes, function(node) {
    var sy = 0;
    var ty = 0;
    each$g(node.outEdges, function(edge) {
      edge.setLayout({
        sy
      }, true);
      sy += edge.getLayout().dy;
    });
    each$g(node.inEdges, function(edge) {
      edge.setLayout({
        ty
      }, true);
      ty += edge.getLayout().dy;
    });
  });
}
function sankeyVisual(ecModel) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    if (nodes.length) {
      var minValue_1 = Infinity;
      var maxValue_1 = -Infinity;
      each$g(nodes, function(node) {
        var nodeValue = node.getLayout().value;
        if (nodeValue < minValue_1) {
          minValue_1 = nodeValue;
        }
        if (nodeValue > maxValue_1) {
          maxValue_1 = nodeValue;
        }
      });
      each$g(nodes, function(node) {
        var mapping = new VisualMapping$1({
          type: "color",
          mappingMethod: "linear",
          dataExtent: [minValue_1, maxValue_1],
          visual: seriesModel.get("color")
        });
        var mapValueToColor = mapping.mapValueToVisual(node.getLayout().value);
        var customColor = node.getModel().get(["itemStyle", "color"]);
        if (customColor != null) {
          node.setVisual("color", customColor);
          node.setVisual("style", {
            fill: customColor
          });
        } else {
          node.setVisual("color", mapValueToColor);
          node.setVisual("style", {
            fill: mapValueToColor
          });
        }
      });
    }
  });
}
function install$A(registers) {
  registers.registerChartView(SankeyView$1);
  registers.registerSeriesModel(SankeySeriesModel$1);
  registers.registerLayout(sankeyLayout);
  registers.registerVisual(sankeyVisual);
  registers.registerAction({
    type: "dragNode",
    event: "dragnode",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sankey",
      query: payload
    }, function(seriesModel) {
      seriesModel.setNodePosition(payload.dataIndex, [payload.localX, payload.localY]);
    });
  });
}
var WhiskerBoxCommonMixin = function() {
  function WhiskerBoxCommonMixin2() {
  }
  WhiskerBoxCommonMixin2.prototype.getInitialData = function(option, ecModel) {
    var ordinalMeta;
    var xAxisModel = ecModel.getComponent("xAxis", this.get("xAxisIndex"));
    var yAxisModel = ecModel.getComponent("yAxis", this.get("yAxisIndex"));
    var xAxisType = xAxisModel.get("type");
    var yAxisType = yAxisModel.get("type");
    var addOrdinal;
    if (xAxisType === "category") {
      option.layout = "horizontal";
      ordinalMeta = xAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else if (yAxisType === "category") {
      option.layout = "vertical";
      ordinalMeta = yAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else {
      option.layout = option.layout || "horizontal";
    }
    var coordDims = ["x", "y"];
    var baseAxisDimIndex = option.layout === "horizontal" ? 0 : 1;
    var baseAxisDim = this._baseAxisDim = coordDims[baseAxisDimIndex];
    var otherAxisDim = coordDims[1 - baseAxisDimIndex];
    var axisModels = [xAxisModel, yAxisModel];
    var baseAxisType = axisModels[baseAxisDimIndex].get("type");
    var otherAxisType = axisModels[1 - baseAxisDimIndex].get("type");
    var data = option.data;
    if (data && addOrdinal) {
      var newOptionData_1 = [];
      each$g(data, function(item, index2) {
        var newItem;
        if (isArray$1(item)) {
          newItem = item.slice();
          item.unshift(index2);
        } else if (isArray$1(item.value)) {
          newItem = extend({}, item);
          newItem.value = newItem.value.slice();
          item.value.unshift(index2);
        } else {
          newItem = item;
        }
        newOptionData_1.push(newItem);
      });
      option.data = newOptionData_1;
    }
    var defaultValueDimensions = this.defaultValueDimensions;
    var coordDimensions = [{
      name: baseAxisDim,
      type: getDimensionTypeByAxis(baseAxisType),
      ordinalMeta,
      otherDims: {
        tooltip: false,
        itemName: 0
      },
      dimsDef: ["base"]
    }, {
      name: otherAxisDim,
      type: getDimensionTypeByAxis(otherAxisType),
      dimsDef: defaultValueDimensions.slice()
    }];
    return createSeriesDataSimply(this, {
      coordDimensions,
      dimensionsCount: defaultValueDimensions.length + 1,
      encodeDefaulter: curry$1(makeSeriesEncodeForAxisCoordSys, coordDimensions, this)
    });
  };
  WhiskerBoxCommonMixin2.prototype.getBaseAxis = function() {
    var dim = this._baseAxisDim;
    return this.ecModel.getComponent(dim + "Axis", this.get(dim + "AxisIndex")).axis;
  };
  return WhiskerBoxCommonMixin2;
}();
var BoxplotSeriesModel = function(_super) {
  __extends(BoxplotSeriesModel2, _super);
  function BoxplotSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "min",
      defaultTooltip: true
    }, {
      name: "Q1",
      defaultTooltip: true
    }, {
      name: "median",
      defaultTooltip: true
    }, {
      name: "Q3",
      defaultTooltip: true
    }, {
      name: "max",
      defaultTooltip: true
    }];
    _this.visualDrawType = "stroke";
    return _this;
  }
  BoxplotSeriesModel2.type = "series.boxplot";
  BoxplotSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  BoxplotSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    boxWidth: [7, 50],
    itemStyle: {
      color: "#fff",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2,
        shadowBlur: 5,
        shadowOffsetX: 1,
        shadowOffsetY: 1,
        shadowColor: "rgba(0,0,0,0.2)"
      }
    },
    animationDuration: 800
  };
  return BoxplotSeriesModel2;
}(SeriesModel$1);
mixin(BoxplotSeriesModel, WhiskerBoxCommonMixin, true);
var BoxplotSeriesModel$1 = BoxplotSeriesModel;
var BoxplotView = function(_super) {
  __extends(BoxplotView2, _super);
  function BoxplotView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotView2.type;
    return _this;
  }
  BoxplotView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var group = this.group;
    var oldData = this._data;
    if (!this._data) {
      group.removeAll();
    }
    var constDim = seriesModel.get("layout") === "horizontal" ? 1 : 0;
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        var symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim, true);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(symbolEl);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (!symbolEl) {
        symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim);
      } else {
        saveOldStyle(symbolEl);
        updateNormalBoxData(itemLayout, symbolEl, data, newIdx);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  BoxplotView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var data = this._data;
    this._data = null;
    data && data.eachItemGraphicEl(function(el) {
      el && group.remove(el);
    });
  };
  BoxplotView2.type = "boxplot";
  return BoxplotView2;
}(ChartView$1);
var BoxPathShape = function() {
  function BoxPathShape2() {
  }
  return BoxPathShape2;
}();
var BoxPath = function(_super) {
  __extends(BoxPath2, _super);
  function BoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "boxplotBoxPath";
    return _this;
  }
  BoxPath2.prototype.getDefaultShape = function() {
    return new BoxPathShape();
  };
  BoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    var i = 0;
    ctx.moveTo(ends[i][0], ends[i][1]);
    i++;
    for (; i < 4; i++) {
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
    ctx.closePath();
    for (; i < ends.length; i++) {
      ctx.moveTo(ends[i][0], ends[i][1]);
      i++;
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
  };
  return BoxPath2;
}(Path$1);
function createNormalBox$1(itemLayout, data, dataIndex, constDim, isInit) {
  var ends = itemLayout.ends;
  var el = new BoxPath({
    shape: {
      points: isInit ? transInit$1(ends, constDim, itemLayout) : ends
    }
  });
  updateNormalBoxData(itemLayout, el, data, dataIndex, isInit);
  return el;
}
function updateNormalBoxData(itemLayout, el, data, dataIndex, isInit) {
  var seriesModel = data.hostModel;
  var updateMethod = graphic[isInit ? "initProps" : "updateProps"];
  updateMethod(el, {
    shape: {
      points: itemLayout.ends
    }
  }, seriesModel, dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.z2 = 100;
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function transInit$1(points2, dim, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[dim] = itemLayout.initBaseline;
    return point;
  });
}
var BoxplotView$1 = BoxplotView;
function boxplotVisual(ecModel, api) {
}
var each$a = each$g;
function boxplotLayout(ecModel) {
  var groupResult = groupSeriesByAxis(ecModel);
  each$a(groupResult, function(groupItem) {
    var seriesModels = groupItem.seriesModels;
    if (!seriesModels.length) {
      return;
    }
    calculateBase(groupItem);
    each$a(seriesModels, function(seriesModel, idx) {
      layoutSingleSeries(seriesModel, groupItem.boxOffsetList[idx], groupItem.boxWidthList[idx]);
    });
  });
}
function groupSeriesByAxis(ecModel) {
  var result = [];
  var axisList = [];
  ecModel.eachSeriesByType("boxplot", function(seriesModel) {
    var baseAxis = seriesModel.getBaseAxis();
    var idx = indexOf(axisList, baseAxis);
    if (idx < 0) {
      idx = axisList.length;
      axisList[idx] = baseAxis;
      result[idx] = {
        axis: baseAxis,
        seriesModels: []
      };
    }
    result[idx].seriesModels.push(seriesModel);
  });
  return result;
}
function calculateBase(groupItem) {
  var baseAxis = groupItem.axis;
  var seriesModels = groupItem.seriesModels;
  var seriesCount = seriesModels.length;
  var boxWidthList = groupItem.boxWidthList = [];
  var boxOffsetList = groupItem.boxOffsetList = [];
  var boundList = [];
  var bandWidth;
  if (baseAxis.type === "category") {
    bandWidth = baseAxis.getBandWidth();
  } else {
    var maxDataCount_1 = 0;
    each$a(seriesModels, function(seriesModel) {
      maxDataCount_1 = Math.max(maxDataCount_1, seriesModel.getData().count());
    });
    var extent3 = baseAxis.getExtent();
    bandWidth = Math.abs(extent3[1] - extent3[0]) / maxDataCount_1;
  }
  each$a(seriesModels, function(seriesModel) {
    var boxWidthBound = seriesModel.get("boxWidth");
    if (!isArray$1(boxWidthBound)) {
      boxWidthBound = [boxWidthBound, boxWidthBound];
    }
    boundList.push([parsePercent(boxWidthBound[0], bandWidth) || 0, parsePercent(boxWidthBound[1], bandWidth) || 0]);
  });
  var availableWidth = bandWidth * 0.8 - 2;
  var boxGap = availableWidth / seriesCount * 0.3;
  var boxWidth = (availableWidth - boxGap * (seriesCount - 1)) / seriesCount;
  var base2 = boxWidth / 2 - availableWidth / 2;
  each$a(seriesModels, function(seriesModel, idx) {
    boxOffsetList.push(base2);
    base2 += boxGap + boxWidth;
    boxWidthList.push(Math.min(Math.max(boxWidth, boundList[idx][0]), boundList[idx][1]));
  });
}
function layoutSingleSeries(seriesModel, offset2, boxWidth) {
  var coordSys = seriesModel.coordinateSystem;
  var data = seriesModel.getData();
  var halfWidth = boxWidth / 2;
  var cDimIdx = seriesModel.get("layout") === "horizontal" ? 0 : 1;
  var vDimIdx = 1 - cDimIdx;
  var coordDims = ["x", "y"];
  var cDim = data.mapDimension(coordDims[cDimIdx]);
  var vDims = data.mapDimensionsAll(coordDims[vDimIdx]);
  if (cDim == null || vDims.length < 5) {
    return;
  }
  for (var dataIndex = 0; dataIndex < data.count(); dataIndex++) {
    var axisDimVal = data.get(cDim, dataIndex);
    var median = getPoint2(axisDimVal, vDims[2], dataIndex);
    var end1 = getPoint2(axisDimVal, vDims[0], dataIndex);
    var end2 = getPoint2(axisDimVal, vDims[1], dataIndex);
    var end4 = getPoint2(axisDimVal, vDims[3], dataIndex);
    var end5 = getPoint2(axisDimVal, vDims[4], dataIndex);
    var ends = [];
    addBodyEnd(ends, end2, false);
    addBodyEnd(ends, end4, true);
    ends.push(end1, end2, end5, end4);
    layEndLine(ends, end1);
    layEndLine(ends, end5);
    layEndLine(ends, median);
    data.setItemLayout(dataIndex, {
      initBaseline: median[vDimIdx],
      ends
    });
  }
  function getPoint2(axisDimVal2, dim, dataIndex2) {
    var val = data.get(dim, dataIndex2);
    var p2 = [];
    p2[cDimIdx] = axisDimVal2;
    p2[vDimIdx] = val;
    var point;
    if (isNaN(axisDimVal2) || isNaN(val)) {
      point = [NaN, NaN];
    } else {
      point = coordSys.dataToPoint(p2);
      point[cDimIdx] += offset2;
    }
    return point;
  }
  function addBodyEnd(ends2, point, start2) {
    var point1 = point.slice();
    var point2 = point.slice();
    point1[cDimIdx] += halfWidth;
    point2[cDimIdx] -= halfWidth;
    start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
  }
  function layEndLine(ends2, endCenter) {
    var from = endCenter.slice();
    var to = endCenter.slice();
    from[cDimIdx] -= halfWidth;
    to[cDimIdx] += halfWidth;
    ends2.push(from, to);
  }
}
function prepareBoxplotData(rawData, opt) {
  opt = opt || {};
  var boxData = [];
  var outliers = [];
  var boundIQR = opt.boundIQR;
  var useExtreme = boundIQR === "none" || boundIQR === 0;
  for (var i = 0; i < rawData.length; i++) {
    var ascList = asc$2(rawData[i].slice());
    var Q1 = quantile(ascList, 0.25);
    var Q2 = quantile(ascList, 0.5);
    var Q3 = quantile(ascList, 0.75);
    var min3 = ascList[0];
    var max3 = ascList[ascList.length - 1];
    var bound = (boundIQR == null ? 1.5 : boundIQR) * (Q3 - Q1);
    var low = useExtreme ? min3 : Math.max(min3, Q1 - bound);
    var high = useExtreme ? max3 : Math.min(max3, Q3 + bound);
    var itemNameFormatter = opt.itemNameFormatter;
    var itemName = isFunction(itemNameFormatter) ? itemNameFormatter({
      value: i
    }) : isString$1(itemNameFormatter) ? itemNameFormatter.replace("{value}", i + "") : i + "";
    boxData.push([itemName, low, Q1, Q2, Q3, high]);
    for (var j = 0; j < ascList.length; j++) {
      var dataItem = ascList[j];
      if (dataItem < low || dataItem > high) {
        var outlier = [itemName, dataItem];
        outliers.push(outlier);
      }
    }
  }
  return {
    boxData,
    outliers
  };
}
var boxplotTransform = {
  type: "echarts:boxplot",
  transform: function transform(params) {
    var upstream = params.upstream;
    if (upstream.sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS) {
      var errMsg = "";
      throwError(errMsg);
    }
    var result = prepareBoxplotData(upstream.getRawData(), params.config);
    return [{
      dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"],
      data: result.boxData
    }, {
      data: result.outliers
    }];
  }
};
function install$z(registers) {
  registers.registerSeriesModel(BoxplotSeriesModel$1);
  registers.registerChartView(BoxplotView$1);
  registers.registerVisual(boxplotVisual);
  registers.registerLayout(boxplotLayout);
  registers.registerTransform(boxplotTransform);
}
var SKIP_PROPS = ["color", "borderColor"];
var CandlestickView = function(_super) {
  __extends(CandlestickView2, _super);
  function CandlestickView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickView2.type;
    return _this;
  }
  CandlestickView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeClipPath();
    this._progressiveEls = null;
    this._updateDrawMode(seriesModel);
    this._isLargeDraw ? this._renderLarge(seriesModel) : this._renderNormal(seriesModel);
  };
  CandlestickView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._clear();
    this._updateDrawMode(seriesModel);
  };
  CandlestickView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    this._progressiveEls = [];
    this._isLargeDraw ? this._incrementalRenderLarge(params, seriesModel) : this._incrementalRenderNormal(params, seriesModel);
  };
  CandlestickView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  CandlestickView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  CandlestickView2.prototype._renderNormal = function(seriesModel) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var isSimpleBox = data.getLayout("isSimpleBox");
    var needsClip = seriesModel.get("clip", true);
    var coord = seriesModel.coordinateSystem;
    var clipArea = coord.getArea && coord.getArea();
    if (!this._data) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
          return;
        }
        var el = createNormalBox(itemLayout, newIdx, true);
        initProps(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        setBoxCommon(el, data, newIdx, isSimpleBox);
        group.add(el);
        data.setItemGraphicEl(newIdx, el);
      }
    }).update(function(newIdx, oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(el);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
        group.remove(el);
        return;
      }
      if (!el) {
        el = createNormalBox(itemLayout);
      } else {
        updateProps$1(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        saveOldStyle(el);
      }
      setBoxCommon(el, data, newIdx, isSimpleBox);
      group.add(el);
      data.setItemGraphicEl(newIdx, el);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  CandlestickView2.prototype._renderLarge = function(seriesModel) {
    this._clear();
    createLarge(seriesModel, this.group);
    var clipPath = seriesModel.get("clip", true) ? createClipPath(seriesModel.coordinateSystem, false, seriesModel) : null;
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
  };
  CandlestickView2.prototype._incrementalRenderNormal = function(params, seriesModel) {
    var data = seriesModel.getData();
    var isSimpleBox = data.getLayout("isSimpleBox");
    var dataIndex;
    while ((dataIndex = params.next()) != null) {
      var itemLayout = data.getItemLayout(dataIndex);
      var el = createNormalBox(itemLayout);
      setBoxCommon(el, data, dataIndex, isSimpleBox);
      el.incremental = true;
      this.group.add(el);
      this._progressiveEls.push(el);
    }
  };
  CandlestickView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    createLarge(seriesModel, this.group, this._progressiveEls, true);
  };
  CandlestickView2.prototype.remove = function(ecModel) {
    this._clear();
  };
  CandlestickView2.prototype._clear = function() {
    this.group.removeAll();
    this._data = null;
  };
  CandlestickView2.type = "candlestick";
  return CandlestickView2;
}(ChartView$1);
var NormalBoxPathShape = function() {
  function NormalBoxPathShape2() {
  }
  return NormalBoxPathShape2;
}();
var NormalBoxPath = function(_super) {
  __extends(NormalBoxPath2, _super);
  function NormalBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "normalCandlestickBox";
    return _this;
  }
  NormalBoxPath2.prototype.getDefaultShape = function() {
    return new NormalBoxPathShape();
  };
  NormalBoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    if (this.__simpleBox) {
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[6][0], ends[6][1]);
    } else {
      ctx.moveTo(ends[0][0], ends[0][1]);
      ctx.lineTo(ends[1][0], ends[1][1]);
      ctx.lineTo(ends[2][0], ends[2][1]);
      ctx.lineTo(ends[3][0], ends[3][1]);
      ctx.closePath();
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[5][0], ends[5][1]);
      ctx.moveTo(ends[6][0], ends[6][1]);
      ctx.lineTo(ends[7][0], ends[7][1]);
    }
  };
  return NormalBoxPath2;
}(Path$1);
function createNormalBox(itemLayout, dataIndex, isInit) {
  var ends = itemLayout.ends;
  return new NormalBoxPath({
    shape: {
      points: isInit ? transInit(ends, itemLayout) : ends
    },
    z2: 100
  });
}
function isNormalBoxClipped(clipArea, itemLayout) {
  var clipped = true;
  for (var i = 0; i < itemLayout.ends.length; i++) {
    if (clipArea.contain(itemLayout.ends[i][0], itemLayout.ends[i][1])) {
      clipped = false;
      break;
    }
  }
  return clipped;
}
function setBoxCommon(el, data, dataIndex, isSimpleBox) {
  var itemModel = data.getItemModel(dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.__simpleBox = isSimpleBox;
  setStatesStylesFromModel(el, itemModel);
}
function transInit(points2, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[1] = itemLayout.initBaseline;
    return point;
  });
}
var LargeBoxPathShape = function() {
  function LargeBoxPathShape2() {
  }
  return LargeBoxPathShape2;
}();
var LargeBoxPath = function(_super) {
  __extends(LargeBoxPath2, _super);
  function LargeBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeCandlestickBox";
    return _this;
  }
  LargeBoxPath2.prototype.getDefaultShape = function() {
    return new LargeBoxPathShape();
  };
  LargeBoxPath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    for (var i = 0; i < points2.length; ) {
      if (this.__sign === points2[i++]) {
        var x2 = points2[i++];
        ctx.moveTo(x2, points2[i++]);
        ctx.lineTo(x2, points2[i++]);
      } else {
        i += 3;
      }
    }
  };
  return LargeBoxPath2;
}(Path$1);
function createLarge(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var largePoints = data.getLayout("largePoints");
  var elP = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: 1
  });
  group.add(elP);
  var elN = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: -1
  });
  group.add(elN);
  setLargeStyle(1, elP, seriesModel);
  setLargeStyle(-1, elN, seriesModel);
  if (incremental) {
    elP.incremental = true;
    elN.incremental = true;
  }
  if (progressiveEls) {
    progressiveEls.push(elP, elN);
  }
}
function setLargeStyle(sign, el, seriesModel, data) {
  var borderColor = seriesModel.get(["itemStyle", sign > 0 ? "borderColor" : "borderColor0"]) || seriesModel.get(["itemStyle", sign > 0 ? "color" : "color0"]);
  var itemStyle = seriesModel.getModel("itemStyle").getItemStyle(SKIP_PROPS);
  el.useStyle(itemStyle);
  el.style.fill = null;
  el.style.stroke = borderColor;
}
var CandlestickView$1 = CandlestickView;
var CandlestickSeriesModel = function(_super) {
  __extends(CandlestickSeriesModel2, _super);
  function CandlestickSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "open",
      defaultTooltip: true
    }, {
      name: "close",
      defaultTooltip: true
    }, {
      name: "lowest",
      defaultTooltip: true
    }, {
      name: "highest",
      defaultTooltip: true
    }];
    return _this;
  }
  CandlestickSeriesModel2.prototype.getShadowDim = function() {
    return "open";
  };
  CandlestickSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    var itemLayout = data.getItemLayout(dataIndex);
    return itemLayout && selectors.rect(itemLayout.brushRect);
  };
  CandlestickSeriesModel2.type = "series.candlestick";
  CandlestickSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  CandlestickSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    clip: true,
    itemStyle: {
      color: "#eb5454",
      color0: "#47b262",
      borderColor: "#eb5454",
      borderColor0: "#47b262",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2
      }
    },
    barMaxWidth: null,
    barMinWidth: null,
    barWidth: null,
    large: true,
    largeThreshold: 600,
    progressive: 3e3,
    progressiveThreshold: 1e4,
    progressiveChunkMode: "mod",
    animationEasing: "linear",
    animationDuration: 300
  };
  return CandlestickSeriesModel2;
}(SeriesModel$1);
mixin(CandlestickSeriesModel, WhiskerBoxCommonMixin, true);
var CandlestickSeriesModel$1 = CandlestickSeriesModel;
function candlestickPreprocessor(option) {
  if (!option || !isArray$1(option.series)) {
    return;
  }
  each$g(option.series, function(seriesItem) {
    if (isObject$4(seriesItem) && seriesItem.type === "k") {
      seriesItem.type = "candlestick";
    }
  });
}
var positiveBorderColorQuery = ["itemStyle", "borderColor"];
var negativeBorderColorQuery = ["itemStyle", "borderColor0"];
var positiveColorQuery = ["itemStyle", "color"];
var negativeColorQuery = ["itemStyle", "color0"];
var candlestickVisual = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    function getColor(sign, model) {
      return model.get(sign > 0 ? positiveColorQuery : negativeColorQuery);
    }
    function getBorderColor(sign, model) {
      return model.get(sign > 0 ? positiveBorderColorQuery : negativeBorderColorQuery);
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var isLargeRender = seriesModel.pipelineContext.large;
    return !isLargeRender && {
      progress: function(params, data) {
        var dataIndex;
        while ((dataIndex = params.next()) != null) {
          var itemModel = data.getItemModel(dataIndex);
          var sign = data.getItemLayout(dataIndex).sign;
          var style2 = itemModel.getItemStyle();
          style2.fill = getColor(sign, itemModel);
          style2.stroke = getBorderColor(sign, itemModel) || style2.fill;
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          extend(existsStyle, style2);
        }
      }
    };
  }
};
var candlestickVisual$1 = candlestickVisual;
var candlestickLayout = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var data = seriesModel.getData();
    var candleWidth = calculateCandleWidth(seriesModel, data);
    var cDimIdx = 0;
    var vDimIdx = 1;
    var coordDims = ["x", "y"];
    var cDimI = data.getDimensionIndex(data.mapDimension(coordDims[cDimIdx]));
    var vDimsI = map$1(data.mapDimensionsAll(coordDims[vDimIdx]), data.getDimensionIndex, data);
    var openDimI = vDimsI[0];
    var closeDimI = vDimsI[1];
    var lowestDimI = vDimsI[2];
    var highestDimI = vDimsI[3];
    data.setLayout({
      candleWidth,
      isSimpleBox: candleWidth <= 1.3
    });
    if (cDimI < 0 || vDimsI.length < 4) {
      return;
    }
    return {
      progress: seriesModel.pipelineContext.large ? largeProgress : normalProgress
    };
    function normalProgress(params, data2) {
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        var ocLow = Math.min(openVal, closeVal);
        var ocHigh = Math.max(openVal, closeVal);
        var ocLowPoint = getPoint2(ocLow, axisDimVal);
        var ocHighPoint = getPoint2(ocHigh, axisDimVal);
        var lowestPoint = getPoint2(lowestVal, axisDimVal);
        var highestPoint = getPoint2(highestVal, axisDimVal);
        var ends = [];
        addBodyEnd(ends, ocHighPoint, 0);
        addBodyEnd(ends, ocLowPoint, 1);
        ends.push(subPixelOptimizePoint(highestPoint), subPixelOptimizePoint(ocHighPoint), subPixelOptimizePoint(lowestPoint), subPixelOptimizePoint(ocLowPoint));
        data2.setItemLayout(dataIndex, {
          sign: getSign(store, dataIndex, openVal, closeVal, closeDimI),
          initBaseline: openVal > closeVal ? ocHighPoint[vDimIdx] : ocLowPoint[vDimIdx],
          ends,
          brushRect: makeBrushRect(lowestVal, highestVal, axisDimVal)
        });
      }
      function getPoint2(val, axisDimVal2) {
        var p2 = [];
        p2[cDimIdx] = axisDimVal2;
        p2[vDimIdx] = val;
        return isNaN(axisDimVal2) || isNaN(val) ? [NaN, NaN] : coordSys.dataToPoint(p2);
      }
      function addBodyEnd(ends2, point, start2) {
        var point1 = point.slice();
        var point2 = point.slice();
        point1[cDimIdx] = subPixelOptimize(point1[cDimIdx] + candleWidth / 2, 1, false);
        point2[cDimIdx] = subPixelOptimize(point2[cDimIdx] - candleWidth / 2, 1, true);
        start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
      }
      function makeBrushRect(lowestVal2, highestVal2, axisDimVal2) {
        var pmin = getPoint2(lowestVal2, axisDimVal2);
        var pmax = getPoint2(highestVal2, axisDimVal2);
        pmin[cDimIdx] -= candleWidth / 2;
        pmax[cDimIdx] -= candleWidth / 2;
        return {
          x: pmin[0],
          y: pmin[1],
          width: candleWidth,
          height: pmax[1] - pmin[1]
        };
      }
      function subPixelOptimizePoint(point) {
        point[cDimIdx] = subPixelOptimize(point[cDimIdx], 1);
        return point;
      }
    }
    function largeProgress(params, data2) {
      var points2 = createFloat32Array(params.count * 4);
      var offset2 = 0;
      var point;
      var tmpIn = [];
      var tmpOut = [];
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        if (isNaN(axisDimVal) || isNaN(lowestVal) || isNaN(highestVal)) {
          points2[offset2++] = NaN;
          offset2 += 3;
          continue;
        }
        points2[offset2++] = getSign(store, dataIndex, openVal, closeVal, closeDimI);
        tmpIn[cDimIdx] = axisDimVal;
        tmpIn[vDimIdx] = lowestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset2++] = point ? point[0] : NaN;
        points2[offset2++] = point ? point[1] : NaN;
        tmpIn[vDimIdx] = highestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset2++] = point ? point[1] : NaN;
      }
      data2.setLayout("largePoints", points2);
    }
  }
};
function getSign(store, dataIndex, openVal, closeVal, closeDimI) {
  var sign;
  if (openVal > closeVal) {
    sign = -1;
  } else if (openVal < closeVal) {
    sign = 1;
  } else {
    sign = dataIndex > 0 ? store.get(closeDimI, dataIndex - 1) <= closeVal ? 1 : -1 : 1;
  }
  return sign;
}
function calculateCandleWidth(seriesModel, data) {
  var baseAxis = seriesModel.getBaseAxis();
  var extent3;
  var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : (extent3 = baseAxis.getExtent(), Math.abs(extent3[1] - extent3[0]) / data.count());
  var barMaxWidth = parsePercent(retrieve2(seriesModel.get("barMaxWidth"), bandWidth), bandWidth);
  var barMinWidth = parsePercent(retrieve2(seriesModel.get("barMinWidth"), 1), bandWidth);
  var barWidth = seriesModel.get("barWidth");
  return barWidth != null ? parsePercent(barWidth, bandWidth) : Math.max(Math.min(bandWidth / 2, barMaxWidth), barMinWidth);
}
var candlestickLayout$1 = candlestickLayout;
function install$y(registers) {
  registers.registerChartView(CandlestickView$1);
  registers.registerSeriesModel(CandlestickSeriesModel$1);
  registers.registerPreprocessor(candlestickPreprocessor);
  registers.registerVisual(candlestickVisual$1);
  registers.registerLayout(candlestickLayout$1);
}
function updateRipplePath(rippleGroup, effectCfg) {
  var color = effectCfg.rippleEffectColor || effectCfg.color;
  rippleGroup.eachChild(function(ripplePath) {
    ripplePath.attr({
      z: effectCfg.z,
      zlevel: effectCfg.zlevel,
      style: {
        stroke: effectCfg.brushType === "stroke" ? color : null,
        fill: effectCfg.brushType === "fill" ? color : null
      }
    });
  });
}
var EffectSymbol = function(_super) {
  __extends(EffectSymbol2, _super);
  function EffectSymbol2(data, idx) {
    var _this = _super.call(this) || this;
    var symbol = new SymbolClz(data, idx);
    var rippleGroup = new Group$6();
    _this.add(symbol);
    _this.add(rippleGroup);
    _this.updateData(data, idx);
    return _this;
  }
  EffectSymbol2.prototype.stopEffectAnimation = function() {
    this.childAt(1).removeAll();
  };
  EffectSymbol2.prototype.startEffectAnimation = function(effectCfg) {
    var symbolType = effectCfg.symbolType;
    var color = effectCfg.color;
    var rippleNumber = effectCfg.rippleNumber;
    var rippleGroup = this.childAt(1);
    for (var i = 0; i < rippleNumber; i++) {
      var ripplePath = createSymbol$1(symbolType, -1, -1, 2, 2, color);
      ripplePath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 99,
        silent: true,
        scaleX: 0.5,
        scaleY: 0.5
      });
      var delay = -i / rippleNumber * effectCfg.period + effectCfg.effectOffset;
      ripplePath.animate("", true).when(effectCfg.period, {
        scaleX: effectCfg.rippleScale / 2,
        scaleY: effectCfg.rippleScale / 2
      }).delay(delay).start();
      ripplePath.animateStyle(true).when(effectCfg.period, {
        opacity: 0
      }).delay(delay).start();
      rippleGroup.add(ripplePath);
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.updateEffectAnimation = function(effectCfg) {
    var oldEffectCfg = this._effectCfg;
    var rippleGroup = this.childAt(1);
    var DIFFICULT_PROPS = ["symbolType", "period", "rippleScale", "rippleNumber"];
    for (var i = 0; i < DIFFICULT_PROPS.length; i++) {
      var propName = DIFFICULT_PROPS[i];
      if (oldEffectCfg[propName] !== effectCfg[propName]) {
        this.stopEffectAnimation();
        this.startEffectAnimation(effectCfg);
        return;
      }
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  EffectSymbol2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  EffectSymbol2.prototype.getSymbolType = function() {
    var symbol = this.childAt(0);
    return symbol && symbol.getSymbolType();
  };
  EffectSymbol2.prototype.updateData = function(data, idx) {
    var _this = this;
    var seriesModel = data.hostModel;
    this.childAt(0).updateData(data, idx);
    var rippleGroup = this.childAt(1);
    var itemModel = data.getItemModel(idx);
    var symbolType = data.getItemVisual(idx, "symbol");
    var symbolSize = normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
    var symbolStyle = data.getItemVisual(idx, "style");
    var color = symbolStyle && symbolStyle.fill;
    var emphasisModel = itemModel.getModel("emphasis");
    rippleGroup.setScale(symbolSize);
    rippleGroup.traverse(function(ripplePath) {
      ripplePath.setStyle("fill", color);
    });
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      rippleGroup.x = symbolOffset[0];
      rippleGroup.y = symbolOffset[1];
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    rippleGroup.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
    var effectCfg = {};
    effectCfg.showEffectOn = seriesModel.get("showEffectOn");
    effectCfg.rippleScale = itemModel.get(["rippleEffect", "scale"]);
    effectCfg.brushType = itemModel.get(["rippleEffect", "brushType"]);
    effectCfg.period = itemModel.get(["rippleEffect", "period"]) * 1e3;
    effectCfg.effectOffset = idx / data.count();
    effectCfg.z = seriesModel.getShallow("z") || 0;
    effectCfg.zlevel = seriesModel.getShallow("zlevel") || 0;
    effectCfg.symbolType = symbolType;
    effectCfg.color = color;
    effectCfg.rippleEffectColor = itemModel.get(["rippleEffect", "color"]);
    effectCfg.rippleNumber = itemModel.get(["rippleEffect", "number"]);
    if (effectCfg.showEffectOn === "render") {
      this._effectCfg ? this.updateEffectAnimation(effectCfg) : this.startEffectAnimation(effectCfg);
      this._effectCfg = effectCfg;
    } else {
      this._effectCfg = null;
      this.stopEffectAnimation();
      this.onHoverStateChange = function(toState) {
        if (toState === "emphasis") {
          if (effectCfg.showEffectOn !== "render") {
            _this.startEffectAnimation(effectCfg);
          }
        } else if (toState === "normal") {
          if (effectCfg.showEffectOn !== "render") {
            _this.stopEffectAnimation();
          }
        }
      };
    }
    this._effectCfg = effectCfg;
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  EffectSymbol2.prototype.fadeOut = function(cb2) {
    cb2 && cb2();
  };
  return EffectSymbol2;
}(Group$6);
var EffectSymbol$1 = EffectSymbol;
var EffectScatterView = function(_super) {
  __extends(EffectScatterView2, _super);
  function EffectScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterView2.type;
    return _this;
  }
  EffectScatterView2.prototype.init = function() {
    this._symbolDraw = new SymbolDraw$1(EffectSymbol$1);
  };
  EffectScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var effectSymbolDraw = this._symbolDraw;
    effectSymbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this.group.add(effectSymbolDraw.group);
  };
  EffectScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  EffectScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    var res = pointsLayout("").reset(seriesModel, ecModel, api);
    if (res.progress) {
      res.progress({
        start: 0,
        end: data.count(),
        count: data.count()
      }, data);
    }
    this._symbolDraw.updateLayout();
  };
  EffectScatterView2.prototype._updateGroupTransform = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.getRoamTransform) {
      this.group.transform = clone$2(coordSys.getRoamTransform());
      this.group.decomposeTransform();
    }
  };
  EffectScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
  };
  EffectScatterView2.type = "effectScatter";
  return EffectScatterView2;
}(ChartView$1);
var EffectScatterView$1 = EffectScatterView;
var EffectScatterSeriesModel = function(_super) {
  __extends(EffectScatterSeriesModel2, _super);
  function EffectScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  EffectScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  EffectScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  EffectScatterSeriesModel2.type = "series.effectScatter";
  EffectScatterSeriesModel2.dependencies = ["grid", "polar"];
  EffectScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    effectType: "ripple",
    progressive: 0,
    showEffectOn: "render",
    clip: true,
    rippleEffect: {
      period: 4,
      scale: 2.5,
      brushType: "fill",
      number: 3
    },
    universalTransition: {
      divideShape: "clone"
    },
    symbolSize: 10
  };
  return EffectScatterSeriesModel2;
}(SeriesModel$1);
var EffectScatterSeriesModel$1 = EffectScatterSeriesModel;
function install$x(registers) {
  registers.registerChartView(EffectScatterView$1);
  registers.registerSeriesModel(EffectScatterSeriesModel$1);
  registers.registerLayout(pointsLayout("effectScatter"));
}
var EffectLine = function(_super) {
  __extends(EffectLine2, _super);
  function EffectLine2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this.add(_this.createLine(lineData, idx, seriesScope));
    _this._updateEffectSymbol(lineData, idx);
    return _this;
  }
  EffectLine2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Line$1(lineData, idx, seriesScope);
  };
  EffectLine2.prototype._updateEffectSymbol = function(lineData, idx) {
    var itemModel = lineData.getItemModel(idx);
    var effectModel = itemModel.getModel("effect");
    var size = effectModel.get("symbolSize");
    var symbolType = effectModel.get("symbol");
    if (!isArray$1(size)) {
      size = [size, size];
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var color = effectModel.get("color") || lineStyle && lineStyle.stroke;
    var symbol = this.childAt(1);
    if (this._symbolType !== symbolType) {
      this.remove(symbol);
      symbol = createSymbol$1(symbolType, -0.5, -0.5, 1, 1, color);
      symbol.z2 = 100;
      symbol.culling = true;
      this.add(symbol);
    }
    if (!symbol) {
      return;
    }
    symbol.setStyle("shadowColor", color);
    symbol.setStyle(effectModel.getItemStyle(["color"]));
    symbol.scaleX = size[0];
    symbol.scaleY = size[1];
    symbol.setColor(color);
    this._symbolType = symbolType;
    this._symbolScale = size;
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  EffectLine2.prototype._updateEffectAnimation = function(lineData, effectModel, idx) {
    var symbol = this.childAt(1);
    if (!symbol) {
      return;
    }
    var points2 = lineData.getItemLayout(idx);
    var period = effectModel.get("period") * 1e3;
    var loop = effectModel.get("loop");
    var constantSpeed = effectModel.get("constantSpeed");
    var delayExpr = retrieve(effectModel.get("delay"), function(idx2) {
      return idx2 / lineData.count() * period / 3;
    });
    symbol.ignore = true;
    this._updateAnimationPoints(symbol, points2);
    if (constantSpeed > 0) {
      period = this._getLineLength(symbol) / constantSpeed * 1e3;
    }
    if (period !== this._period || loop !== this._loop) {
      symbol.stopAnimation();
      var delayNum = void 0;
      if (isFunction(delayExpr)) {
        delayNum = delayExpr(idx);
      } else {
        delayNum = delayExpr;
      }
      if (symbol.__t > 0) {
        delayNum = -period * symbol.__t;
      }
      this._animateSymbol(symbol, period, delayNum, loop);
    }
    this._period = period;
    this._loop = loop;
  };
  EffectLine2.prototype._animateSymbol = function(symbol, period, delayNum, loop) {
    if (period > 0) {
      symbol.__t = 0;
      var self_1 = this;
      var animator = symbol.animate("", loop).when(period, {
        __t: 1
      }).delay(delayNum).during(function() {
        self_1._updateSymbolPosition(symbol);
      });
      if (!loop) {
        animator.done(function() {
          self_1.remove(symbol);
        });
      }
      animator.start();
    }
  };
  EffectLine2.prototype._getLineLength = function(symbol) {
    return dist$1(symbol.__p1, symbol.__cp1) + dist$1(symbol.__cp1, symbol.__p2);
  };
  EffectLine2.prototype._updateAnimationPoints = function(symbol, points2) {
    symbol.__p1 = points2[0];
    symbol.__p2 = points2[1];
    symbol.__cp1 = points2[2] || [(points2[0][0] + points2[1][0]) / 2, (points2[0][1] + points2[1][1]) / 2];
  };
  EffectLine2.prototype.updateData = function(lineData, idx, seriesScope) {
    this.childAt(0).updateData(lineData, idx, seriesScope);
    this._updateEffectSymbol(lineData, idx);
  };
  EffectLine2.prototype._updateSymbolPosition = function(symbol) {
    var p1 = symbol.__p1;
    var p2 = symbol.__p2;
    var cp1 = symbol.__cp1;
    var t2 = symbol.__t;
    var pos = [symbol.x, symbol.y];
    var lastPos = pos.slice();
    var quadraticAt2 = quadraticAt$1;
    var quadraticDerivativeAt$1 = quadraticDerivativeAt;
    pos[0] = quadraticAt2(p1[0], cp1[0], p2[0], t2);
    pos[1] = quadraticAt2(p1[1], cp1[1], p2[1], t2);
    var tx = quadraticDerivativeAt$1(p1[0], cp1[0], p2[0], t2);
    var ty = quadraticDerivativeAt$1(p1[1], cp1[1], p2[1], t2);
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    if (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") {
      if (symbol.__lastT !== void 0 && symbol.__lastT < symbol.__t) {
        symbol.scaleY = dist$1(lastPos, pos) * 1.05;
        if (t2 === 1) {
          pos[0] = lastPos[0] + (pos[0] - lastPos[0]) / 2;
          pos[1] = lastPos[1] + (pos[1] - lastPos[1]) / 2;
        }
      } else if (symbol.__lastT === 1) {
        symbol.scaleY = 2 * dist$1(p1, pos);
      } else {
        symbol.scaleY = this._symbolScale[1];
      }
    }
    symbol.__lastT = symbol.__t;
    symbol.ignore = false;
    symbol.x = pos[0];
    symbol.y = pos[1];
  };
  EffectLine2.prototype.updateLayout = function(lineData, idx) {
    this.childAt(0).updateLayout(lineData, idx);
    var effectModel = lineData.getItemModel(idx).getModel("effect");
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  return EffectLine2;
}(Group$6);
var EffectLine$1 = EffectLine;
var Polyline = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createPolyline(lineData, idx, seriesScope);
    return _this;
  }
  Polyline2.prototype._createPolyline = function(lineData, idx, seriesScope) {
    var points2 = lineData.getItemLayout(idx);
    var line = new Polyline$3({
      shape: {
        points: points2
      }
    });
    this.add(line);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childAt(0);
    var target = {
      shape: {
        points: lineData.getItemLayout(idx)
      }
    };
    updateProps$1(line, target, seriesModel, idx);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var line = this.childAt(0);
    var itemModel = lineData.getItemModel(idx);
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    if (!seriesScope || lineData.hasItemOption) {
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
    }
    line.useStyle(lineData.getItemVisual(idx, "style"));
    line.style.fill = null;
    line.style.strokeNoScale = true;
    var lineEmphasisState = line.ensureState("emphasis");
    lineEmphasisState.style = emphasisLineStyle;
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Polyline2.prototype.updateLayout = function(lineData, idx) {
    var polyline = this.childAt(0);
    polyline.setShape("points", lineData.getItemLayout(idx));
  };
  return Polyline2;
}(Group$6);
var Polyline$1 = Polyline;
var EffectPolyline = function(_super) {
  __extends(EffectPolyline2, _super);
  function EffectPolyline2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._lastFrame = 0;
    _this._lastFramePercent = 0;
    return _this;
  }
  EffectPolyline2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Polyline$1(lineData, idx, seriesScope);
  };
  EffectPolyline2.prototype._updateAnimationPoints = function(symbol, points2) {
    this._points = points2;
    var accLenArr = [0];
    var len2 = 0;
    for (var i = 1; i < points2.length; i++) {
      var p1 = points2[i - 1];
      var p2 = points2[i];
      len2 += dist$1(p1, p2);
      accLenArr.push(len2);
    }
    if (len2 === 0) {
      this._length = 0;
      return;
    }
    for (var i = 0; i < accLenArr.length; i++) {
      accLenArr[i] /= len2;
    }
    this._offsets = accLenArr;
    this._length = len2;
  };
  EffectPolyline2.prototype._getLineLength = function() {
    return this._length;
  };
  EffectPolyline2.prototype._updateSymbolPosition = function(symbol) {
    var t2 = symbol.__t;
    var points2 = this._points;
    var offsets = this._offsets;
    var len2 = points2.length;
    if (!offsets) {
      return;
    }
    var lastFrame = this._lastFrame;
    var frame;
    if (t2 < this._lastFramePercent) {
      var start2 = Math.min(lastFrame + 1, len2 - 1);
      for (frame = start2; frame >= 0; frame--) {
        if (offsets[frame] <= t2) {
          break;
        }
      }
      frame = Math.min(frame, len2 - 2);
    } else {
      for (frame = lastFrame; frame < len2; frame++) {
        if (offsets[frame] > t2) {
          break;
        }
      }
      frame = Math.min(frame - 1, len2 - 2);
    }
    var p2 = (t2 - offsets[frame]) / (offsets[frame + 1] - offsets[frame]);
    var p0 = points2[frame];
    var p1 = points2[frame + 1];
    symbol.x = p0[0] * (1 - p2) + p2 * p1[0];
    symbol.y = p0[1] * (1 - p2) + p2 * p1[1];
    var tx = p1[0] - p0[0];
    var ty = p1[1] - p0[1];
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    this._lastFrame = frame;
    this._lastFramePercent = t2;
    symbol.ignore = false;
  };
  return EffectPolyline2;
}(EffectLine$1);
var EffectPolyline$1 = EffectPolyline;
var LargeLinesPathShape = function() {
  function LargeLinesPathShape2() {
    this.polyline = false;
    this.curveness = 0;
    this.segs = [];
  }
  return LargeLinesPathShape2;
}();
var LargeLinesPath = function(_super) {
  __extends(LargeLinesPath2, _super);
  function LargeLinesPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeLinesPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeLinesPath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  LargeLinesPath2.prototype.getDefaultShape = function() {
    return new LargeLinesPathShape();
  };
  LargeLinesPath2.prototype.buildPath = function(ctx, shape) {
    var segs = shape.segs;
    var curveness = shape.curveness;
    var i;
    if (shape.polyline) {
      for (i = this._off; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          ctx.moveTo(segs[i++], segs[i++]);
          for (var k2 = 1; k2 < count2; k2++) {
            ctx.lineTo(segs[i++], segs[i++]);
          }
        }
      }
    } else {
      for (i = this._off; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        ctx.moveTo(x0, y0);
        if (curveness > 0) {
          var x2 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y2 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          ctx.quadraticCurveTo(x2, y2, x1, y1);
        } else {
          ctx.lineTo(x1, y1);
        }
      }
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeLinesPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var segs = shape.segs;
    var curveness = shape.curveness;
    var lineWidth = this.style.lineWidth;
    if (shape.polyline) {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          var x0 = segs[i++];
          var y0 = segs[i++];
          for (var k2 = 1; k2 < count2; k2++) {
            var x1 = segs[i++];
            var y1 = segs[i++];
            if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
              return dataIndex;
            }
          }
        }
        dataIndex++;
      }
    } else {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        if (curveness > 0) {
          var x22 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y22 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          if (containStroke$2(x0, y0, x22, y22, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        } else {
          if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        }
        dataIndex++;
      }
    }
    return -1;
  };
  LargeLinesPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeLinesPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.segs;
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX, minY, maxX, maxY);
    }
    return rect;
  };
  return LargeLinesPath2;
}(Path$1);
var LargeLineDraw = function() {
  function LargeLineDraw2() {
    this.group = new Group$6();
  }
  LargeLineDraw2.prototype.updateData = function(data) {
    this._clear();
    var lineEl = this._create();
    lineEl.setShape({
      segs: data.getLayout("linesPoints")
    });
    this._setCommon(lineEl, data);
  };
  LargeLineDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this.group.removeAll();
    this._clear();
  };
  LargeLineDraw2.prototype.incrementalUpdate = function(taskParams, data) {
    var lastAdded = this._newAdded[0];
    var linePoints = data.getLayout("linesPoints");
    var oldSegs = lastAdded && lastAdded.shape.segs;
    if (oldSegs && oldSegs.length < 2e4) {
      var oldLen = oldSegs.length;
      var newSegs = new Float32Array(oldLen + linePoints.length);
      newSegs.set(oldSegs);
      newSegs.set(linePoints, oldLen);
      lastAdded.setShape({
        segs: newSegs
      });
    } else {
      this._newAdded = [];
      var lineEl = this._create();
      lineEl.incremental = true;
      lineEl.setShape({
        segs: linePoints
      });
      this._setCommon(lineEl, data);
      lineEl.__startIndex = taskParams.start;
    }
  };
  LargeLineDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeLineDraw2.prototype.eachRendered = function(cb2) {
    this._newAdded[0] && cb2(this._newAdded[0]);
  };
  LargeLineDraw2.prototype._create = function() {
    var lineEl = new LargeLinesPath({
      cursor: "default"
    });
    this._newAdded.push(lineEl);
    this.group.add(lineEl);
    return lineEl;
  };
  LargeLineDraw2.prototype._setCommon = function(lineEl, data, isIncremental) {
    var hostModel = data.hostModel;
    lineEl.setShape({
      polyline: hostModel.get("polyline"),
      curveness: hostModel.get(["lineStyle", "curveness"])
    });
    lineEl.useStyle(hostModel.getModel("lineStyle").getLineStyle());
    lineEl.style.strokeNoScale = true;
    var style2 = data.getVisual("style");
    if (style2 && style2.stroke) {
      lineEl.setStyle("stroke", style2.stroke);
    }
    lineEl.setStyle("fill", null);
    var ecData = getECData(lineEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    lineEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = lineEl.hoverDataIdx;
      if (dataIndex > 0) {
        ecData.dataIndex = dataIndex + lineEl.__startIndex;
      }
    });
  };
  LargeLineDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeLineDraw2;
}();
var LargeLineDraw$1 = LargeLineDraw;
var linesLayout = {
  seriesType: "lines",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var isPolyline = seriesModel.get("polyline");
    var isLarge = seriesModel.pipelineContext.large;
    return {
      progress: function(params, lineData) {
        var lineCoords = [];
        if (isLarge) {
          var points2 = void 0;
          var segCount = params.end - params.start;
          if (isPolyline) {
            var totalCoordsCount = 0;
            for (var i = params.start; i < params.end; i++) {
              totalCoordsCount += seriesModel.getLineCoordsCount(i);
            }
            points2 = new Float32Array(segCount + totalCoordsCount * 2);
          } else {
            points2 = new Float32Array(segCount * 4);
          }
          var offset2 = 0;
          var pt = [];
          for (var i = params.start; i < params.end; i++) {
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            if (isPolyline) {
              points2[offset2++] = len2;
            }
            for (var k2 = 0; k2 < len2; k2++) {
              pt = coordSys.dataToPoint(lineCoords[k2], false, pt);
              points2[offset2++] = pt[0];
              points2[offset2++] = pt[1];
            }
          }
          lineData.setLayout("linesPoints", points2);
        } else {
          for (var i = params.start; i < params.end; i++) {
            var itemModel = lineData.getItemModel(i);
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            var pts = [];
            if (isPolyline) {
              for (var j = 0; j < len2; j++) {
                pts.push(coordSys.dataToPoint(lineCoords[j]));
              }
            } else {
              pts[0] = coordSys.dataToPoint(lineCoords[0]);
              pts[1] = coordSys.dataToPoint(lineCoords[1]);
              var curveness = itemModel.get(["lineStyle", "curveness"]);
              if (+curveness) {
                pts[2] = [(pts[0][0] + pts[1][0]) / 2 - (pts[0][1] - pts[1][1]) * curveness, (pts[0][1] + pts[1][1]) / 2 - (pts[1][0] - pts[0][0]) * curveness];
              }
            }
            lineData.setItemLayout(i, pts);
          }
        }
      }
    };
  }
};
var linesLayout$1 = linesLayout;
var LinesView = function(_super) {
  __extends(LinesView2, _super);
  function LinesView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesView2.type;
    return _this;
  }
  LinesView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    var zlevel = seriesModel.get("zlevel");
    var trailLength = seriesModel.get(["effect", "trailLength"]);
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg) {
      zr.painter.getLayer(zlevel).clear(true);
    }
    if (this._lastZlevel != null && !isSvg) {
      zr.configLayer(this._lastZlevel, {
        motionBlur: false
      });
    }
    if (this._showEffect(seriesModel) && trailLength > 0) {
      if (!isSvg) {
        zr.configLayer(zlevel, {
          motionBlur: true,
          lastFrameAlpha: Math.max(Math.min(trailLength / 10 + 0.9, 1), 0)
        });
      }
    }
    lineDraw.updateData(data);
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
    this._lastZlevel = zlevel;
    this._finished = true;
  };
  LinesView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    lineDraw.incrementalPrepareUpdate(data);
    this._clearLayer(api);
    this._finished = false;
  };
  LinesView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._lineDraw.incrementalUpdate(taskParams, seriesModel.getData());
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  LinesView2.prototype.eachRendered = function(cb2) {
    this._lineDraw && this._lineDraw.eachRendered(cb2);
  };
  LinesView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var pipelineContext = seriesModel.pipelineContext;
    if (!this._finished || pipelineContext.large || pipelineContext.progressiveRender) {
      return {
        update: true
      };
    } else {
      var res = linesLayout$1.reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._lineDraw.updateLayout();
      this._clearLayer(api);
    }
  };
  LinesView2.prototype._updateLineDraw = function(data, seriesModel) {
    var lineDraw = this._lineDraw;
    var hasEffect = this._showEffect(seriesModel);
    var isPolyline = !!seriesModel.get("polyline");
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!lineDraw || hasEffect !== this._hasEffet || isPolyline !== this._isPolyline || isLargeDraw !== this._isLargeDraw) {
      if (lineDraw) {
        lineDraw.remove();
      }
      lineDraw = this._lineDraw = isLargeDraw ? new LargeLineDraw$1() : new LineDraw$1(isPolyline ? hasEffect ? EffectPolyline$1 : Polyline$1 : hasEffect ? EffectLine$1 : Line$1);
      this._hasEffet = hasEffect;
      this._isPolyline = isPolyline;
      this._isLargeDraw = isLargeDraw;
    }
    this.group.add(lineDraw.group);
    return lineDraw;
  };
  LinesView2.prototype._showEffect = function(seriesModel) {
    return !!seriesModel.get(["effect", "show"]);
  };
  LinesView2.prototype._clearLayer = function(api) {
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg && this._lastZlevel != null) {
      zr.painter.getLayer(this._lastZlevel).clear(true);
    }
  };
  LinesView2.prototype.remove = function(ecModel, api) {
    this._lineDraw && this._lineDraw.remove();
    this._lineDraw = null;
    this._clearLayer(api);
  };
  LinesView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  LinesView2.type = "lines";
  return LinesView2;
}(ChartView$1);
var LinesView$1 = LinesView;
var Uint32Arr = typeof Uint32Array === "undefined" ? Array : Uint32Array;
var Float64Arr = typeof Float64Array === "undefined" ? Array : Float64Array;
function compatEc2(seriesOpt) {
  var data = seriesOpt.data;
  if (data && data[0] && data[0][0] && data[0][0].coord) {
    seriesOpt.data = map$1(data, function(itemOpt) {
      var coords = [itemOpt[0].coord, itemOpt[1].coord];
      var target = {
        coords
      };
      if (itemOpt[0].name) {
        target.fromName = itemOpt[0].name;
      }
      if (itemOpt[1].name) {
        target.toName = itemOpt[1].name;
      }
      return mergeAll([target, itemOpt[0], itemOpt[1]]);
    });
  }
}
var LinesSeriesModel = function(_super) {
  __extends(LinesSeriesModel2, _super);
  function LinesSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  LinesSeriesModel2.prototype.init = function(option) {
    option.data = option.data || [];
    compatEc2(option);
    var result = this._processFlatCoordsArray(option.data);
    this._flatCoords = result.flatCoords;
    this._flatCoordsOffset = result.flatCoordsOffset;
    if (result.flatCoords) {
      option.data = new Float32Array(result.count);
    }
    _super.prototype.init.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.mergeOption = function(option) {
    compatEc2(option);
    if (option.data) {
      var result = this._processFlatCoordsArray(option.data);
      this._flatCoords = result.flatCoords;
      this._flatCoordsOffset = result.flatCoordsOffset;
      if (result.flatCoords) {
        option.data = new Float32Array(result.count);
      }
    }
    _super.prototype.mergeOption.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.appendData = function(params) {
    var result = this._processFlatCoordsArray(params.data);
    if (result.flatCoords) {
      if (!this._flatCoords) {
        this._flatCoords = result.flatCoords;
        this._flatCoordsOffset = result.flatCoordsOffset;
      } else {
        this._flatCoords = concatArray(this._flatCoords, result.flatCoords);
        this._flatCoordsOffset = concatArray(this._flatCoordsOffset, result.flatCoordsOffset);
      }
      params.data = new Float32Array(result.count);
    }
    this.getRawData().appendData(params.data);
  };
  LinesSeriesModel2.prototype._getCoordsFromItemModel = function(idx) {
    var itemModel = this.getData().getItemModel(idx);
    var coords = itemModel.option instanceof Array ? itemModel.option : itemModel.getShallow("coords");
    return coords;
  };
  LinesSeriesModel2.prototype.getLineCoordsCount = function(idx) {
    if (this._flatCoordsOffset) {
      return this._flatCoordsOffset[idx * 2 + 1];
    } else {
      return this._getCoordsFromItemModel(idx).length;
    }
  };
  LinesSeriesModel2.prototype.getLineCoords = function(idx, out2) {
    if (this._flatCoordsOffset) {
      var offset2 = this._flatCoordsOffset[idx * 2];
      var len2 = this._flatCoordsOffset[idx * 2 + 1];
      for (var i = 0; i < len2; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = this._flatCoords[offset2 + i * 2];
        out2[i][1] = this._flatCoords[offset2 + i * 2 + 1];
      }
      return len2;
    } else {
      var coords = this._getCoordsFromItemModel(idx);
      for (var i = 0; i < coords.length; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = coords[i][0];
        out2[i][1] = coords[i][1];
      }
      return coords.length;
    }
  };
  LinesSeriesModel2.prototype._processFlatCoordsArray = function(data) {
    var startOffset = 0;
    if (this._flatCoords) {
      startOffset = this._flatCoords.length;
    }
    if (isNumber(data[0])) {
      var len2 = data.length;
      var coordsOffsetAndLenStorage = new Uint32Arr(len2);
      var coordsStorage = new Float64Arr(len2);
      var coordsCursor = 0;
      var offsetCursor = 0;
      var dataCount = 0;
      for (var i = 0; i < len2; ) {
        dataCount++;
        var count2 = data[i++];
        coordsOffsetAndLenStorage[offsetCursor++] = coordsCursor + startOffset;
        coordsOffsetAndLenStorage[offsetCursor++] = count2;
        for (var k2 = 0; k2 < count2; k2++) {
          var x2 = data[i++];
          var y2 = data[i++];
          coordsStorage[coordsCursor++] = x2;
          coordsStorage[coordsCursor++] = y2;
        }
      }
      return {
        flatCoordsOffset: new Uint32Array(coordsOffsetAndLenStorage.buffer, 0, offsetCursor),
        flatCoords: coordsStorage,
        count: dataCount
      };
    }
    return {
      flatCoordsOffset: null,
      flatCoords: null,
      count: data.length
    };
  };
  LinesSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var lineData = new SeriesData$1(["value"], this);
    lineData.hasItemOption = false;
    lineData.initData(option.data, [], function(dataItem, dimName, dataIndex, dimIndex) {
      if (dataItem instanceof Array) {
        return NaN;
      } else {
        lineData.hasItemOption = true;
        var value = dataItem.value;
        if (value != null) {
          return value instanceof Array ? value[dimIndex] : value;
        }
      }
    });
    return lineData;
  };
  LinesSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var itemModel = data.getItemModel(dataIndex);
    var name = itemModel.get("name");
    if (name) {
      return name;
    }
    var fromName = itemModel.get("fromName");
    var toName = itemModel.get("toName");
    var nameArr = [];
    fromName != null && nameArr.push(fromName);
    toName != null && nameArr.push(toName);
    return createTooltipMarkup("nameValue", {
      name: nameArr.join(" > ")
    });
  };
  LinesSeriesModel2.prototype.preventIncremental = function() {
    return !!this.get(["effect", "show"]);
  };
  LinesSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 1e4 : this.get("progressive");
    }
    return progressive;
  };
  LinesSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 2e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  LinesSeriesModel2.prototype.getZLevelKey = function() {
    var effectModel = this.getModel("effect");
    var trailLength = effectModel.get("trailLength");
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : effectModel.get("show") && trailLength > 0 ? trailLength + "" : "";
  };
  LinesSeriesModel2.type = "series.lines";
  LinesSeriesModel2.dependencies = ["grid", "polar", "geo", "calendar"];
  LinesSeriesModel2.defaultOption = {
    coordinateSystem: "geo",
    z: 2,
    legendHoverLink: true,
    xAxisIndex: 0,
    yAxisIndex: 0,
    symbol: ["none", "none"],
    symbolSize: [10, 10],
    geoIndex: 0,
    effect: {
      show: false,
      period: 4,
      constantSpeed: 0,
      symbol: "circle",
      symbolSize: 3,
      loop: true,
      trailLength: 0.2
    },
    large: false,
    largeThreshold: 2e3,
    polyline: false,
    clip: true,
    label: {
      show: false,
      position: "end"
    },
    lineStyle: {
      opacity: 0.5
    }
  };
  return LinesSeriesModel2;
}(SeriesModel$1);
var LinesSeriesModel$1 = LinesSeriesModel;
function normalize$1(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
var linesVisual = {
  seriesType: "lines",
  reset: function(seriesModel) {
    var symbolType = normalize$1(seriesModel.get("symbol"));
    var symbolSize = normalize$1(seriesModel.get("symbolSize"));
    var data = seriesModel.getData();
    data.setVisual("fromSymbol", symbolType && symbolType[0]);
    data.setVisual("toSymbol", symbolType && symbolType[1]);
    data.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    data.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      var symbolType2 = normalize$1(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$1(itemModel.getShallow("symbolSize", true));
      symbolType2[0] && data2.setItemVisual(idx, "fromSymbol", symbolType2[0]);
      symbolType2[1] && data2.setItemVisual(idx, "toSymbol", symbolType2[1]);
      symbolSize2[0] && data2.setItemVisual(idx, "fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && data2.setItemVisual(idx, "toSymbolSize", symbolSize2[1]);
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
var linesVisual$1 = linesVisual;
function install$w(registers) {
  registers.registerChartView(LinesView$1);
  registers.registerSeriesModel(LinesSeriesModel$1);
  registers.registerLayout(linesLayout$1);
  registers.registerVisual(linesVisual$1);
}
var GRADIENT_LEVELS = 256;
var HeatmapLayer = function() {
  function HeatmapLayer2() {
    this.blurSize = 30;
    this.pointSize = 20;
    this.maxOpacity = 1;
    this.minOpacity = 0;
    this._gradientPixels = {
      inRange: null,
      outOfRange: null
    };
    var canvas = platformApi.createCanvas();
    this.canvas = canvas;
  }
  HeatmapLayer2.prototype.update = function(data, width, height, normalize2, colorFunc, isInRange) {
    var brush2 = this._getBrush();
    var gradientInRange = this._getGradient(colorFunc, "inRange");
    var gradientOutOfRange = this._getGradient(colorFunc, "outOfRange");
    var r2 = this.pointSize + this.blurSize;
    var canvas = this.canvas;
    var ctx = canvas.getContext("2d");
    var len2 = data.length;
    canvas.width = width;
    canvas.height = height;
    for (var i = 0; i < len2; ++i) {
      var p2 = data[i];
      var x2 = p2[0];
      var y2 = p2[1];
      var value = p2[2];
      var alpha = normalize2(value);
      ctx.globalAlpha = alpha;
      ctx.drawImage(brush2, x2 - r2, y2 - r2);
    }
    if (!canvas.width || !canvas.height) {
      return canvas;
    }
    var imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    var pixels = imageData.data;
    var offset2 = 0;
    var pixelLen = pixels.length;
    var minOpacity = this.minOpacity;
    var maxOpacity = this.maxOpacity;
    var diffOpacity = maxOpacity - minOpacity;
    while (offset2 < pixelLen) {
      var alpha = pixels[offset2 + 3] / 256;
      var gradientOffset = Math.floor(alpha * (GRADIENT_LEVELS - 1)) * 4;
      if (alpha > 0) {
        var gradient = isInRange(alpha) ? gradientInRange : gradientOutOfRange;
        alpha > 0 && (alpha = alpha * diffOpacity + minOpacity);
        pixels[offset2++] = gradient[gradientOffset];
        pixels[offset2++] = gradient[gradientOffset + 1];
        pixels[offset2++] = gradient[gradientOffset + 2];
        pixels[offset2++] = gradient[gradientOffset + 3] * alpha * 256;
      } else {
        offset2 += 4;
      }
    }
    ctx.putImageData(imageData, 0, 0);
    return canvas;
  };
  HeatmapLayer2.prototype._getBrush = function() {
    var brushCanvas = this._brushCanvas || (this._brushCanvas = platformApi.createCanvas());
    var r2 = this.pointSize + this.blurSize;
    var d2 = r2 * 2;
    brushCanvas.width = d2;
    brushCanvas.height = d2;
    var ctx = brushCanvas.getContext("2d");
    ctx.clearRect(0, 0, d2, d2);
    ctx.shadowOffsetX = d2;
    ctx.shadowBlur = this.blurSize;
    ctx.shadowColor = "#000";
    ctx.beginPath();
    ctx.arc(-r2, r2, this.pointSize, 0, Math.PI * 2, true);
    ctx.closePath();
    ctx.fill();
    return brushCanvas;
  };
  HeatmapLayer2.prototype._getGradient = function(colorFunc, state) {
    var gradientPixels = this._gradientPixels;
    var pixelsSingleState = gradientPixels[state] || (gradientPixels[state] = new Uint8ClampedArray(256 * 4));
    var color = [0, 0, 0, 0];
    var off = 0;
    for (var i = 0; i < 256; i++) {
      colorFunc[state](i / 255, true, color);
      pixelsSingleState[off++] = color[0];
      pixelsSingleState[off++] = color[1];
      pixelsSingleState[off++] = color[2];
      pixelsSingleState[off++] = color[3];
    }
    return pixelsSingleState;
  };
  return HeatmapLayer2;
}();
var HeatmapLayer$1 = HeatmapLayer;
function getIsInPiecewiseRange(dataExtent, pieceList, selected) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  pieceList = map$1(pieceList, function(piece) {
    return {
      interval: [(piece.interval[0] - dataExtent[0]) / dataSpan, (piece.interval[1] - dataExtent[0]) / dataSpan]
    };
  });
  var len2 = pieceList.length;
  var lastIndex = 0;
  return function(val) {
    var i;
    for (i = lastIndex; i < len2; i++) {
      var interval = pieceList[i].interval;
      if (interval[0] <= val && val <= interval[1]) {
        lastIndex = i;
        break;
      }
    }
    if (i === len2) {
      for (i = lastIndex - 1; i >= 0; i--) {
        var interval = pieceList[i].interval;
        if (interval[0] <= val && val <= interval[1]) {
          lastIndex = i;
          break;
        }
      }
    }
    return i >= 0 && i < len2 && selected[i];
  };
}
function getIsInContinuousRange(dataExtent, range3) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  range3 = [(range3[0] - dataExtent[0]) / dataSpan, (range3[1] - dataExtent[0]) / dataSpan];
  return function(val) {
    return val >= range3[0] && val <= range3[1];
  };
}
function isGeoCoordSys(coordSys) {
  var dimensions = coordSys.dimensions;
  return dimensions[0] === "lng" && dimensions[1] === "lat";
}
var HeatmapView = function(_super) {
  __extends(HeatmapView2, _super);
  function HeatmapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapView2.type;
    return _this;
  }
  HeatmapView2.prototype.render = function(seriesModel, ecModel, api) {
    var visualMapOfThisSeries;
    ecModel.eachComponent("visualMap", function(visualMap) {
      visualMap.eachTargetSeries(function(targetSeries) {
        if (targetSeries === seriesModel) {
          visualMapOfThisSeries = visualMap;
        }
      });
    });
    this._progressiveEls = null;
    this.group.removeAll();
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type === "cartesian2d" || coordSys.type === "calendar") {
      this._renderOnCartesianAndCalendar(seriesModel, api, 0, seriesModel.getData().count());
    } else if (isGeoCoordSys(coordSys)) {
      this._renderOnGeo(coordSys, seriesModel, visualMapOfThisSeries, api);
    }
  };
  HeatmapView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this.group.removeAll();
  };
  HeatmapView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys) {
      if (isGeoCoordSys(coordSys)) {
        this.render(seriesModel, ecModel, api);
      } else {
        this._progressiveEls = [];
        this._renderOnCartesianAndCalendar(seriesModel, api, params.start, params.end, true);
      }
    }
  };
  HeatmapView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  HeatmapView2.prototype._renderOnCartesianAndCalendar = function(seriesModel, api, start2, end2, incremental) {
    var coordSys = seriesModel.coordinateSystem;
    var width;
    var height;
    var xAxisExtent;
    var yAxisExtent;
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      width = xAxis.getBandWidth();
      height = yAxis.getBandWidth();
      xAxisExtent = xAxis.scale.getExtent();
      yAxisExtent = yAxis.scale.getExtent();
    }
    var group = this.group;
    var data = seriesModel.getData();
    var emphasisStyle = seriesModel.getModel(["emphasis", "itemStyle"]).getItemStyle();
    var blurStyle = seriesModel.getModel(["blur", "itemStyle"]).getItemStyle();
    var selectStyle = seriesModel.getModel(["select", "itemStyle"]).getItemStyle();
    var borderRadius = seriesModel.get(["itemStyle", "borderRadius"]);
    var labelStatesModels = getLabelStatesModels(seriesModel);
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    var dataDims = isCoordinateSystemType(coordSys, "cartesian2d") ? [data.mapDimension("x"), data.mapDimension("y"), data.mapDimension("value")] : [data.mapDimension("time"), data.mapDimension("value")];
    for (var idx = start2; idx < end2; idx++) {
      var rect = void 0;
      var style2 = data.getItemVisual(idx, "style");
      if (isCoordinateSystemType(coordSys, "cartesian2d")) {
        var dataDimX = data.get(dataDims[0], idx);
        var dataDimY = data.get(dataDims[1], idx);
        if (isNaN(data.get(dataDims[2], idx)) || dataDimX < xAxisExtent[0] || dataDimX > xAxisExtent[1] || dataDimY < yAxisExtent[0] || dataDimY > yAxisExtent[1]) {
          continue;
        }
        var point = coordSys.dataToPoint([dataDimX, dataDimY]);
        rect = new Rect$3({
          shape: {
            x: Math.floor(Math.round(point[0]) - width / 2),
            y: Math.floor(Math.round(point[1]) - height / 2),
            width: Math.ceil(width),
            height: Math.ceil(height)
          },
          style: style2
        });
      } else {
        if (isNaN(data.get(dataDims[1], idx))) {
          continue;
        }
        rect = new Rect$3({
          z2: 1,
          shape: coordSys.dataToRect([data.get(dataDims[0], idx)]).contentShape,
          style: style2
        });
      }
      if (data.hasItemOption) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel_1 = itemModel.getModel("emphasis");
        emphasisStyle = emphasisModel_1.getModel("itemStyle").getItemStyle();
        blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
        selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
        borderRadius = itemModel.get(["itemStyle", "borderRadius"]);
        focus = emphasisModel_1.get("focus");
        blurScope = emphasisModel_1.get("blurScope");
        emphasisDisabled = emphasisModel_1.get("disabled");
        labelStatesModels = getLabelStatesModels(itemModel);
      }
      rect.shape.r = borderRadius;
      var rawValue = seriesModel.getRawValue(idx);
      var defaultText = "-";
      if (rawValue && rawValue[2] != null) {
        defaultText = rawValue[2] + "";
      }
      setLabelStyle(rect, labelStatesModels, {
        labelFetcher: seriesModel,
        labelDataIndex: idx,
        defaultOpacity: style2.opacity,
        defaultText
      });
      rect.ensureState("emphasis").style = emphasisStyle;
      rect.ensureState("blur").style = blurStyle;
      rect.ensureState("select").style = selectStyle;
      toggleHoverEmphasis(rect, focus, blurScope, emphasisDisabled);
      rect.incremental = incremental;
      if (incremental) {
        rect.states.emphasis.hoverLayer = true;
      }
      group.add(rect);
      data.setItemGraphicEl(idx, rect);
      if (this._progressiveEls) {
        this._progressiveEls.push(rect);
      }
    }
  };
  HeatmapView2.prototype._renderOnGeo = function(geo, seriesModel, visualMapModel, api) {
    var inRangeVisuals = visualMapModel.targetVisuals.inRange;
    var outOfRangeVisuals = visualMapModel.targetVisuals.outOfRange;
    var data = seriesModel.getData();
    var hmLayer = this._hmLayer || this._hmLayer || new HeatmapLayer$1();
    hmLayer.blurSize = seriesModel.get("blurSize");
    hmLayer.pointSize = seriesModel.get("pointSize");
    hmLayer.minOpacity = seriesModel.get("minOpacity");
    hmLayer.maxOpacity = seriesModel.get("maxOpacity");
    var rect = geo.getViewRect().clone();
    var roamTransform = geo.getRoamTransform();
    rect.applyTransform(roamTransform);
    var x2 = Math.max(rect.x, 0);
    var y2 = Math.max(rect.y, 0);
    var x22 = Math.min(rect.width + rect.x, api.getWidth());
    var y22 = Math.min(rect.height + rect.y, api.getHeight());
    var width = x22 - x2;
    var height = y22 - y2;
    var dims = [data.mapDimension("lng"), data.mapDimension("lat"), data.mapDimension("value")];
    var points2 = data.mapArray(dims, function(lng, lat, value) {
      var pt = geo.dataToPoint([lng, lat]);
      pt[0] -= x2;
      pt[1] -= y2;
      pt.push(value);
      return pt;
    });
    var dataExtent = visualMapModel.getExtent();
    var isInRange = visualMapModel.type === "visualMap.continuous" ? getIsInContinuousRange(dataExtent, visualMapModel.option.range) : getIsInPiecewiseRange(dataExtent, visualMapModel.getPieceList(), visualMapModel.option.selected);
    hmLayer.update(points2, width, height, inRangeVisuals.color.getNormalizer(), {
      inRange: inRangeVisuals.color.getColorMapper(),
      outOfRange: outOfRangeVisuals.color.getColorMapper()
    }, isInRange);
    var img = new ZRImage$1({
      style: {
        width,
        height,
        x: x2,
        y: y2,
        image: hmLayer.canvas
      },
      silent: true
    });
    this.group.add(img);
  };
  HeatmapView2.type = "heatmap";
  return HeatmapView2;
}(ChartView$1);
var HeatmapView$1 = HeatmapView;
var HeatmapSeriesModel = function(_super) {
  __extends(HeatmapSeriesModel2, _super);
  function HeatmapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapSeriesModel2.type;
    return _this;
  }
  HeatmapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      generateCoord: "value"
    });
  };
  HeatmapSeriesModel2.prototype.preventIncremental = function() {
    var coordSysCreator = CoordinateSystem.get(this.get("coordinateSystem"));
    if (coordSysCreator && coordSysCreator.dimensions) {
      return coordSysCreator.dimensions[0] === "lng" && coordSysCreator.dimensions[1] === "lat";
    }
  };
  HeatmapSeriesModel2.type = "series.heatmap";
  HeatmapSeriesModel2.dependencies = ["grid", "geo", "calendar"];
  HeatmapSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    geoIndex: 0,
    blurSize: 30,
    pointSize: 20,
    maxOpacity: 1,
    minOpacity: 0,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return HeatmapSeriesModel2;
}(SeriesModel$1);
var HeatmapSeriesModel$1 = HeatmapSeriesModel;
function install$v(registers) {
  registers.registerChartView(HeatmapView$1);
  registers.registerSeriesModel(HeatmapSeriesModel$1);
}
var BAR_BORDER_WIDTH_QUERY = ["itemStyle", "borderWidth"];
var LAYOUT_ATTRS = [{
  xy: "x",
  wh: "width",
  index: 0,
  posDesc: ["left", "right"]
}, {
  xy: "y",
  wh: "height",
  index: 1,
  posDesc: ["top", "bottom"]
}];
var pathForLineWidth = new Circle$1();
var PictorialBarView = function(_super) {
  __extends(PictorialBarView2, _super);
  function PictorialBarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarView2.type;
    return _this;
  }
  PictorialBarView2.prototype.render = function(seriesModel, ecModel, api) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var coordSysRect = cartesian.master.getRect();
    var opt = {
      ecSize: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      seriesModel,
      coordSys: cartesian,
      coordSysExtent: [[coordSysRect.x, coordSysRect.x + coordSysRect.width], [coordSysRect.y, coordSysRect.y + coordSysRect.height]],
      isHorizontal,
      valueDim: LAYOUT_ATTRS[+isHorizontal],
      categoryDim: LAYOUT_ATTRS[1 - +isHorizontal]
    };
    data.diff(oldData).add(function(dataIndex) {
      if (!data.hasValue(dataIndex)) {
        return;
      }
      var itemModel = getItemModel(data, dataIndex);
      var symbolMeta = getSymbolMeta(data, dataIndex, itemModel, opt);
      var bar = createBar(data, opt, symbolMeta);
      data.setItemGraphicEl(dataIndex, bar);
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).update(function(newIndex, oldIndex) {
      var bar = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex)) {
        group.remove(bar);
        return;
      }
      var itemModel = getItemModel(data, newIndex);
      var symbolMeta = getSymbolMeta(data, newIndex, itemModel, opt);
      var pictorialShapeStr = getShapeStr(data, symbolMeta);
      if (bar && pictorialShapeStr !== bar.__pictorialShapeStr) {
        group.remove(bar);
        data.setItemGraphicEl(newIndex, null);
        bar = null;
      }
      if (bar) {
        updateBar(bar, opt, symbolMeta);
      } else {
        bar = createBar(data, opt, symbolMeta, true);
      }
      data.setItemGraphicEl(newIndex, bar);
      bar.__pictorialSymbolMeta = symbolMeta;
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).remove(function(dataIndex) {
      var bar = oldData.getItemGraphicEl(dataIndex);
      bar && removeBar(oldData, dataIndex, bar.__pictorialSymbolMeta.animationModel, bar);
    }).execute();
    this._data = data;
    return this.group;
  };
  PictorialBarView2.prototype.remove = function(ecModel, api) {
    var group = this.group;
    var data = this._data;
    if (ecModel.get("animation")) {
      if (data) {
        data.eachItemGraphicEl(function(bar) {
          removeBar(data, getECData(bar).dataIndex, ecModel, bar);
        });
      }
    } else {
      group.removeAll();
    }
  };
  PictorialBarView2.type = "pictorialBar";
  return PictorialBarView2;
}(ChartView$1);
function getSymbolMeta(data, dataIndex, itemModel, opt) {
  var layout2 = data.getItemLayout(dataIndex);
  var symbolRepeat = itemModel.get("symbolRepeat");
  var symbolClip = itemModel.get("symbolClip");
  var symbolPosition = itemModel.get("symbolPosition") || "start";
  var symbolRotate = itemModel.get("symbolRotate");
  var rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  var symbolPatternSize = itemModel.get("symbolPatternSize") || 2;
  var isAnimationEnabled2 = itemModel.isAnimationEnabled();
  var symbolMeta = {
    dataIndex,
    layout: layout2,
    itemModel,
    symbolType: data.getItemVisual(dataIndex, "symbol") || "circle",
    style: data.getItemVisual(dataIndex, "style"),
    symbolClip,
    symbolRepeat,
    symbolRepeatDirection: itemModel.get("symbolRepeatDirection"),
    symbolPatternSize,
    rotation,
    animationModel: isAnimationEnabled2 ? itemModel : null,
    hoverScale: isAnimationEnabled2 && itemModel.get(["emphasis", "scale"]),
    z2: itemModel.getShallow("z", true) || 0
  };
  prepareBarLength(itemModel, symbolRepeat, layout2, opt, symbolMeta);
  prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, symbolMeta.boundingLength, symbolMeta.pxSign, symbolPatternSize, opt, symbolMeta);
  prepareLineWidth(itemModel, symbolMeta.symbolScale, rotation, opt, symbolMeta);
  var symbolSize = symbolMeta.symbolSize;
  var symbolOffset = normalizeSymbolOffset(itemModel.get("symbolOffset"), symbolSize);
  prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, symbolMeta.valueLineWidth, symbolMeta.boundingLength, symbolMeta.repeatCutLength, opt, symbolMeta);
  return symbolMeta;
}
function prepareBarLength(itemModel, symbolRepeat, layout2, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var symbolBoundingData = itemModel.get("symbolBoundingData");
  var valueAxis2 = opt.coordSys.getOtherAxis(opt.coordSys.getBaseAxis());
  var zeroPx = valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(0));
  var pxSignIdx = 1 - +(layout2[valueDim.wh] <= 0);
  var boundingLength;
  if (isArray$1(symbolBoundingData)) {
    var symbolBoundingExtent = [convertToCoordOnAxis(valueAxis2, symbolBoundingData[0]) - zeroPx, convertToCoordOnAxis(valueAxis2, symbolBoundingData[1]) - zeroPx];
    symbolBoundingExtent[1] < symbolBoundingExtent[0] && symbolBoundingExtent.reverse();
    boundingLength = symbolBoundingExtent[pxSignIdx];
  } else if (symbolBoundingData != null) {
    boundingLength = convertToCoordOnAxis(valueAxis2, symbolBoundingData) - zeroPx;
  } else if (symbolRepeat) {
    boundingLength = opt.coordSysExtent[valueDim.index][pxSignIdx] - zeroPx;
  } else {
    boundingLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.boundingLength = boundingLength;
  if (symbolRepeat) {
    outputSymbolMeta.repeatCutLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.pxSign = boundingLength > 0 ? 1 : -1;
}
function convertToCoordOnAxis(axis, value) {
  return axis.toGlobalCoord(axis.dataToCoord(axis.scale.parse(value)));
}
function prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, boundingLength, pxSign, symbolPatternSize, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var categoryDim = opt.categoryDim;
  var categorySize = Math.abs(layout2[categoryDim.wh]);
  var symbolSize = data.getItemVisual(dataIndex, "symbolSize");
  var parsedSymbolSize;
  if (isArray$1(symbolSize)) {
    parsedSymbolSize = symbolSize.slice();
  } else {
    if (symbolSize == null) {
      parsedSymbolSize = ["100%", "100%"];
    } else {
      parsedSymbolSize = [symbolSize, symbolSize];
    }
  }
  parsedSymbolSize[categoryDim.index] = parsePercent(parsedSymbolSize[categoryDim.index], categorySize);
  parsedSymbolSize[valueDim.index] = parsePercent(parsedSymbolSize[valueDim.index], symbolRepeat ? categorySize : Math.abs(boundingLength));
  outputSymbolMeta.symbolSize = parsedSymbolSize;
  var symbolScale = outputSymbolMeta.symbolScale = [parsedSymbolSize[0] / symbolPatternSize, parsedSymbolSize[1] / symbolPatternSize];
  symbolScale[valueDim.index] *= (opt.isHorizontal ? -1 : 1) * pxSign;
}
function prepareLineWidth(itemModel, symbolScale, rotation, opt, outputSymbolMeta) {
  var valueLineWidth = itemModel.get(BAR_BORDER_WIDTH_QUERY) || 0;
  if (valueLineWidth) {
    pathForLineWidth.attr({
      scaleX: symbolScale[0],
      scaleY: symbolScale[1],
      rotation
    });
    pathForLineWidth.updateTransform();
    valueLineWidth /= pathForLineWidth.getLineScale();
    valueLineWidth *= symbolScale[opt.valueDim.index];
  }
  outputSymbolMeta.valueLineWidth = valueLineWidth || 0;
}
function prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, valueLineWidth, boundingLength, repeatCutLength, opt, outputSymbolMeta) {
  var categoryDim = opt.categoryDim;
  var valueDim = opt.valueDim;
  var pxSign = outputSymbolMeta.pxSign;
  var unitLength = Math.max(symbolSize[valueDim.index] + valueLineWidth, 0);
  var pathLen = unitLength;
  if (symbolRepeat) {
    var absBoundingLength = Math.abs(boundingLength);
    var symbolMargin = retrieve(itemModel.get("symbolMargin"), "15%") + "";
    var hasEndGap = false;
    if (symbolMargin.lastIndexOf("!") === symbolMargin.length - 1) {
      hasEndGap = true;
      symbolMargin = symbolMargin.slice(0, symbolMargin.length - 1);
    }
    var symbolMarginNumeric = parsePercent(symbolMargin, symbolSize[valueDim.index]);
    var uLenWithMargin = Math.max(unitLength + symbolMarginNumeric * 2, 0);
    var endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    var repeatSpecified = isNumeric$1(symbolRepeat);
    var repeatTimes = repeatSpecified ? symbolRepeat : toIntTimes((absBoundingLength + endFix) / uLenWithMargin);
    var mDiff = absBoundingLength - repeatTimes * unitLength;
    symbolMarginNumeric = mDiff / 2 / (hasEndGap ? repeatTimes : Math.max(repeatTimes - 1, 1));
    uLenWithMargin = unitLength + symbolMarginNumeric * 2;
    endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    if (!repeatSpecified && symbolRepeat !== "fixed") {
      repeatTimes = repeatCutLength ? toIntTimes((Math.abs(repeatCutLength) + endFix) / uLenWithMargin) : 0;
    }
    pathLen = repeatTimes * uLenWithMargin - endFix;
    outputSymbolMeta.repeatTimes = repeatTimes;
    outputSymbolMeta.symbolMargin = symbolMarginNumeric;
  }
  var sizeFix = pxSign * (pathLen / 2);
  var pathPosition = outputSymbolMeta.pathPosition = [];
  pathPosition[categoryDim.index] = layout2[categoryDim.wh] / 2;
  pathPosition[valueDim.index] = symbolPosition === "start" ? sizeFix : symbolPosition === "end" ? boundingLength - sizeFix : boundingLength / 2;
  if (symbolOffset) {
    pathPosition[0] += symbolOffset[0];
    pathPosition[1] += symbolOffset[1];
  }
  var bundlePosition = outputSymbolMeta.bundlePosition = [];
  bundlePosition[categoryDim.index] = layout2[categoryDim.xy];
  bundlePosition[valueDim.index] = layout2[valueDim.xy];
  var barRectShape = outputSymbolMeta.barRectShape = extend({}, layout2);
  barRectShape[valueDim.wh] = pxSign * Math.max(Math.abs(layout2[valueDim.wh]), Math.abs(pathPosition[valueDim.index] + sizeFix));
  barRectShape[categoryDim.wh] = layout2[categoryDim.wh];
  var clipShape = outputSymbolMeta.clipShape = {};
  clipShape[categoryDim.xy] = -layout2[categoryDim.xy];
  clipShape[categoryDim.wh] = opt.ecSize[categoryDim.wh];
  clipShape[valueDim.xy] = 0;
  clipShape[valueDim.wh] = layout2[valueDim.wh];
}
function createPath(symbolMeta) {
  var symbolPatternSize = symbolMeta.symbolPatternSize;
  var path = createSymbol$1(symbolMeta.symbolType, -symbolPatternSize / 2, -symbolPatternSize / 2, symbolPatternSize, symbolPatternSize);
  path.attr({
    culling: true
  });
  path.type !== "image" && path.setStyle({
    strokeNoScale: true
  });
  return path;
}
function createOrUpdateRepeatSymbols(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var symbolSize = symbolMeta.symbolSize;
  var valueLineWidth = symbolMeta.valueLineWidth;
  var pathPosition = symbolMeta.pathPosition;
  var valueDim = opt.valueDim;
  var repeatTimes = symbolMeta.repeatTimes || 0;
  var index2 = 0;
  var unit = symbolSize[opt.valueDim.index] + valueLineWidth + symbolMeta.symbolMargin * 2;
  eachPath(bar, function(path2) {
    path2.__pictorialAnimationIndex = index2;
    path2.__pictorialRepeatTimes = repeatTimes;
    if (index2 < repeatTimes) {
      updateAttr(path2, null, makeTarget(index2), symbolMeta, isUpdate);
    } else {
      updateAttr(path2, null, {
        scaleX: 0,
        scaleY: 0
      }, symbolMeta, isUpdate, function() {
        bundle.remove(path2);
      });
    }
    index2++;
  });
  for (; index2 < repeatTimes; index2++) {
    var path = createPath(symbolMeta);
    path.__pictorialAnimationIndex = index2;
    path.__pictorialRepeatTimes = repeatTimes;
    bundle.add(path);
    var target = makeTarget(index2);
    updateAttr(path, {
      x: target.x,
      y: target.y,
      scaleX: 0,
      scaleY: 0
    }, {
      scaleX: target.scaleX,
      scaleY: target.scaleY,
      rotation: target.rotation
    }, symbolMeta, isUpdate);
  }
  function makeTarget(index3) {
    var position2 = pathPosition.slice();
    var pxSign = symbolMeta.pxSign;
    var i = index3;
    if (symbolMeta.symbolRepeatDirection === "start" ? pxSign > 0 : pxSign < 0) {
      i = repeatTimes - 1 - index3;
    }
    position2[valueDim.index] = unit * (i - repeatTimes / 2 + 0.5) + pathPosition[valueDim.index];
    return {
      x: position2[0],
      y: position2[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    };
  }
}
function createOrUpdateSingleSymbol(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var mainPath = bar.__pictorialMainPath;
  if (!mainPath) {
    mainPath = bar.__pictorialMainPath = createPath(symbolMeta);
    bundle.add(mainPath);
    updateAttr(mainPath, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: 0,
      scaleY: 0,
      rotation: symbolMeta.rotation
    }, {
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1]
    }, symbolMeta, isUpdate);
  } else {
    updateAttr(mainPath, null, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateBarRect(bar, symbolMeta, isUpdate) {
  var rectShape = extend({}, symbolMeta.barRectShape);
  var barRect = bar.__pictorialBarRect;
  if (!barRect) {
    barRect = bar.__pictorialBarRect = new Rect$3({
      z2: 2,
      shape: rectShape,
      silent: true,
      style: {
        stroke: "transparent",
        fill: "transparent",
        lineWidth: 0
      }
    });
    barRect.disableMorphing = true;
    bar.add(barRect);
  } else {
    updateAttr(barRect, null, {
      shape: rectShape
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateClip(bar, opt, symbolMeta, isUpdate) {
  if (symbolMeta.symbolClip) {
    var clipPath = bar.__pictorialClipPath;
    var clipShape = extend({}, symbolMeta.clipShape);
    var valueDim = opt.valueDim;
    var animationModel = symbolMeta.animationModel;
    var dataIndex = symbolMeta.dataIndex;
    if (clipPath) {
      updateProps$1(clipPath, {
        shape: clipShape
      }, animationModel, dataIndex);
    } else {
      clipShape[valueDim.wh] = 0;
      clipPath = new Rect$3({
        shape: clipShape
      });
      bar.__pictorialBundle.setClipPath(clipPath);
      bar.__pictorialClipPath = clipPath;
      var target = {};
      target[valueDim.wh] = symbolMeta.clipShape[valueDim.wh];
      graphic[isUpdate ? "updateProps" : "initProps"](clipPath, {
        shape: target
      }, animationModel, dataIndex);
    }
  }
}
function getItemModel(data, dataIndex) {
  var itemModel = data.getItemModel(dataIndex);
  itemModel.getAnimationDelayParams = getAnimationDelayParams;
  itemModel.isAnimationEnabled = isAnimationEnabled;
  return itemModel;
}
function getAnimationDelayParams(path) {
  return {
    index: path.__pictorialAnimationIndex,
    count: path.__pictorialRepeatTimes
  };
}
function isAnimationEnabled() {
  return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
}
function createBar(data, opt, symbolMeta, isUpdate) {
  var bar = new Group$6();
  var bundle = new Group$6();
  bar.add(bundle);
  bar.__pictorialBundle = bundle;
  bundle.x = symbolMeta.bundlePosition[0];
  bundle.y = symbolMeta.bundlePosition[1];
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta);
  }
  createOrUpdateBarRect(bar, symbolMeta, isUpdate);
  createOrUpdateClip(bar, opt, symbolMeta, isUpdate);
  bar.__pictorialShapeStr = getShapeStr(data, symbolMeta);
  bar.__pictorialSymbolMeta = symbolMeta;
  return bar;
}
function updateBar(bar, opt, symbolMeta) {
  var animationModel = symbolMeta.animationModel;
  var dataIndex = symbolMeta.dataIndex;
  var bundle = bar.__pictorialBundle;
  updateProps$1(bundle, {
    x: symbolMeta.bundlePosition[0],
    y: symbolMeta.bundlePosition[1]
  }, animationModel, dataIndex);
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta, true);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta, true);
  }
  createOrUpdateBarRect(bar, symbolMeta, true);
  createOrUpdateClip(bar, opt, symbolMeta, true);
}
function removeBar(data, dataIndex, animationModel, bar) {
  var labelRect = bar.__pictorialBarRect;
  labelRect && labelRect.removeTextContent();
  var pathes = [];
  eachPath(bar, function(path) {
    pathes.push(path);
  });
  bar.__pictorialMainPath && pathes.push(bar.__pictorialMainPath);
  bar.__pictorialClipPath && (animationModel = null);
  each$g(pathes, function(path) {
    removeElement(path, {
      scaleX: 0,
      scaleY: 0
    }, animationModel, dataIndex, function() {
      bar.parent && bar.parent.remove(bar);
    });
  });
  data.setItemGraphicEl(dataIndex, null);
}
function getShapeStr(data, symbolMeta) {
  return [data.getItemVisual(symbolMeta.dataIndex, "symbol") || "none", !!symbolMeta.symbolRepeat, !!symbolMeta.symbolClip].join(":");
}
function eachPath(bar, cb2, context) {
  each$g(bar.__pictorialBundle.children(), function(el) {
    el !== bar.__pictorialBarRect && cb2.call(context, el);
  });
}
function updateAttr(el, immediateAttrs, animationAttrs, symbolMeta, isUpdate, cb2) {
  immediateAttrs && el.attr(immediateAttrs);
  if (symbolMeta.symbolClip && !isUpdate) {
    animationAttrs && el.attr(animationAttrs);
  } else {
    animationAttrs && graphic[isUpdate ? "updateProps" : "initProps"](el, animationAttrs, symbolMeta.animationModel, symbolMeta.dataIndex, cb2);
  }
}
function updateCommon(bar, opt, symbolMeta) {
  var dataIndex = symbolMeta.dataIndex;
  var itemModel = symbolMeta.itemModel;
  var emphasisModel = itemModel.getModel("emphasis");
  var emphasisStyle = emphasisModel.getModel("itemStyle").getItemStyle();
  var blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
  var selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
  var cursorStyle = itemModel.getShallow("cursor");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var hoverScale = emphasisModel.get("scale");
  eachPath(bar, function(path) {
    if (path instanceof ZRImage$1) {
      var pathStyle = path.style;
      path.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolMeta.style));
    } else {
      path.useStyle(symbolMeta.style);
    }
    var emphasisState = path.ensureState("emphasis");
    emphasisState.style = emphasisStyle;
    if (hoverScale) {
      emphasisState.scaleX = path.scaleX * 1.1;
      emphasisState.scaleY = path.scaleY * 1.1;
    }
    path.ensureState("blur").style = blurStyle;
    path.ensureState("select").style = selectStyle;
    cursorStyle && (path.cursor = cursorStyle);
    path.z2 = symbolMeta.z2;
  });
  var barPositionOutside = opt.valueDim.posDesc[+(symbolMeta.boundingLength > 0)];
  var barRect = bar.__pictorialBarRect;
  setLabelStyle(barRect, getLabelStatesModels(itemModel), {
    labelFetcher: opt.seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(opt.seriesModel.getData(), dataIndex),
    inheritColor: symbolMeta.style.fill,
    defaultOpacity: symbolMeta.style.opacity,
    defaultOutsidePosition: barPositionOutside
  });
  toggleHoverEmphasis(bar, focus, blurScope, emphasisModel.get("disabled"));
}
function toIntTimes(times) {
  var roundedTimes = Math.round(times);
  return Math.abs(times - roundedTimes) < 1e-4 ? roundedTimes : Math.ceil(times);
}
var PictorialBarView$1 = PictorialBarView;
var PictorialBarSeriesModel = function(_super) {
  __extends(PictorialBarSeriesModel2, _super);
  function PictorialBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    _this.defaultSymbol = "roundRect";
    return _this;
  }
  PictorialBarSeriesModel2.prototype.getInitialData = function(option) {
    option.stack = null;
    return _super.prototype.getInitialData.apply(this, arguments);
  };
  PictorialBarSeriesModel2.type = "series.pictorialBar";
  PictorialBarSeriesModel2.dependencies = ["grid"];
  PictorialBarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    symbol: "circle",
    symbolSize: null,
    symbolRotate: null,
    symbolPosition: null,
    symbolOffset: null,
    symbolMargin: null,
    symbolRepeat: false,
    symbolRepeatDirection: "end",
    symbolClip: false,
    symbolBoundingData: null,
    symbolPatternSize: 400,
    barGap: "-100%",
    progressive: 0,
    emphasis: {
      scale: false
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  });
  return PictorialBarSeriesModel2;
}(BaseBarSeriesModel$1);
var PictorialBarSeriesModel$1 = PictorialBarSeriesModel;
function install$u(registers) {
  registers.registerChartView(PictorialBarView$1);
  registers.registerSeriesModel(PictorialBarSeriesModel$1);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "pictorialBar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("pictorialBar"));
}
var ThemeRiverView = function(_super) {
  __extends(ThemeRiverView2, _super);
  function ThemeRiverView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverView2.type;
    _this._layers = [];
    return _this;
  }
  ThemeRiverView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var self2 = this;
    var group = this.group;
    var layersSeries = seriesModel.getLayerSeries();
    var layoutInfo = data.getLayout("layoutInfo");
    var rect = layoutInfo.rect;
    var boundaryGap = layoutInfo.boundaryGap;
    group.x = 0;
    group.y = rect.y + boundaryGap[0];
    function keyGetter(item) {
      return item.name;
    }
    var dataDiffer = new DataDiffer$1(this._layersSeries || [], layersSeries, keyGetter, keyGetter);
    var newLayersGroups = [];
    dataDiffer.add(bind$1(process2, this, "add")).update(bind$1(process2, this, "update")).remove(bind$1(process2, this, "remove")).execute();
    function process2(status, idx, oldIdx) {
      var oldLayersGroups = self2._layers;
      if (status === "remove") {
        group.remove(oldLayersGroups[idx]);
        return;
      }
      var points0 = [];
      var points1 = [];
      var style2;
      var indices = layersSeries[idx].indices;
      var j = 0;
      for (; j < indices.length; j++) {
        var layout2 = data.getItemLayout(indices[j]);
        var x2 = layout2.x;
        var y0 = layout2.y0;
        var y2 = layout2.y;
        points0.push(x2, y0);
        points1.push(x2, y0 + y2);
        style2 = data.getItemVisual(indices[j], "style");
      }
      var polygon;
      var textLayout = data.getItemLayout(indices[0]);
      var labelModel = seriesModel.getModel("label");
      var margin = labelModel.get("margin");
      var emphasisModel = seriesModel.getModel("emphasis");
      if (status === "add") {
        var layerGroup = newLayersGroups[idx] = new Group$6();
        polygon = new ECPolygon({
          shape: {
            points: points0,
            stackedOnPoints: points1,
            smooth: 0.4,
            stackedOnSmooth: 0.4,
            smoothConstraint: false
          },
          z2: 0
        });
        layerGroup.add(polygon);
        group.add(layerGroup);
        if (seriesModel.isAnimationEnabled()) {
          polygon.setClipPath(createGridClipShape(polygon.getBoundingRect(), seriesModel, function() {
            polygon.removeClipPath();
          }));
        }
      } else {
        var layerGroup = oldLayersGroups[oldIdx];
        polygon = layerGroup.childAt(0);
        group.add(layerGroup);
        newLayersGroups[idx] = layerGroup;
        updateProps$1(polygon, {
          shape: {
            points: points0,
            stackedOnPoints: points1
          }
        }, seriesModel);
        saveOldStyle(polygon);
      }
      setLabelStyle(polygon, getLabelStatesModels(seriesModel), {
        labelDataIndex: indices[j - 1],
        defaultText: data.getName(indices[j - 1]),
        inheritColor: style2.fill
      }, {
        normal: {
          verticalAlign: "middle"
        }
      });
      polygon.setTextConfig({
        position: null,
        local: true
      });
      var labelEl = polygon.getTextContent();
      if (labelEl) {
        labelEl.x = textLayout.x - margin;
        labelEl.y = textLayout.y0 + textLayout.y / 2;
      }
      polygon.useStyle(style2);
      data.setItemGraphicEl(idx, polygon);
      setStatesStylesFromModel(polygon, seriesModel);
      toggleHoverEmphasis(polygon, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    }
    this._layersSeries = layersSeries;
    this._layers = newLayersGroups;
  };
  ThemeRiverView2.type = "themeRiver";
  return ThemeRiverView2;
}(ChartView$1);
function createGridClipShape(rect, seriesModel, cb2) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      x: rect.x - 50,
      width: rect.width + 100,
      height: rect.height + 20
    }
  }, seriesModel, cb2);
  return rectEl;
}
var ThemeRiverView$1 = ThemeRiverView;
var DATA_NAME_INDEX = 2;
var ThemeRiverSeriesModel = function(_super) {
  __extends(ThemeRiverSeriesModel2, _super);
  function ThemeRiverSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverSeriesModel2.type;
    return _this;
  }
  ThemeRiverSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  ThemeRiverSeriesModel2.prototype.fixData = function(data) {
    var rawDataLength = data.length;
    var timeValueKeys = {};
    var groupResult = groupData(data, function(item) {
      if (!timeValueKeys.hasOwnProperty(item[0] + "")) {
        timeValueKeys[item[0] + ""] = -1;
      }
      return item[2];
    });
    var layerData = [];
    groupResult.buckets.each(function(items, key) {
      layerData.push({
        name: key,
        dataList: items
      });
    });
    var layerNum = layerData.length;
    for (var k2 = 0; k2 < layerNum; ++k2) {
      var name_1 = layerData[k2].name;
      for (var j = 0; j < layerData[k2].dataList.length; ++j) {
        var timeValue = layerData[k2].dataList[j][0] + "";
        timeValueKeys[timeValue] = k2;
      }
      for (var timeValue in timeValueKeys) {
        if (timeValueKeys.hasOwnProperty(timeValue) && timeValueKeys[timeValue] !== k2) {
          timeValueKeys[timeValue] = k2;
          data[rawDataLength] = [timeValue, 0, name_1];
          rawDataLength++;
        }
      }
    }
    return data;
  };
  ThemeRiverSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var singleAxisModel = this.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    var axisType = singleAxisModel.get("type");
    var filterData = filter(option.data, function(dataItem) {
      return dataItem[2] !== void 0;
    });
    var data = this.fixData(filterData || []);
    var nameList = [];
    var nameMap = this.nameMap = createHashMap();
    var count2 = 0;
    for (var i = 0; i < data.length; ++i) {
      nameList.push(data[i][DATA_NAME_INDEX]);
      if (!nameMap.get(data[i][DATA_NAME_INDEX])) {
        nameMap.set(data[i][DATA_NAME_INDEX], count2);
        count2++;
      }
    }
    var dimensions = prepareSeriesDataSchema(data, {
      coordDimensions: ["single"],
      dimensionsDefine: [{
        name: "time",
        type: getDimensionTypeByAxis(axisType)
      }, {
        name: "value",
        type: "float"
      }, {
        name: "name",
        type: "ordinal"
      }],
      encodeDefine: {
        single: 0,
        value: 1,
        itemName: 2
      }
    }).dimensions;
    var list = new SeriesData$1(dimensions, this);
    list.initData(data);
    return list;
  };
  ThemeRiverSeriesModel2.prototype.getLayerSeries = function() {
    var data = this.getData();
    var lenCount = data.count();
    var indexArr = [];
    for (var i = 0; i < lenCount; ++i) {
      indexArr[i] = i;
    }
    var timeDim = data.mapDimension("single");
    var groupResult = groupData(indexArr, function(index2) {
      return data.get("name", index2);
    });
    var layerSeries = [];
    groupResult.buckets.each(function(items, key) {
      items.sort(function(index1, index2) {
        return data.get(timeDim, index1) - data.get(timeDim, index2);
      });
      layerSeries.push({
        name: key,
        indices: items
      });
    });
    return layerSeries;
  };
  ThemeRiverSeriesModel2.prototype.getAxisTooltipData = function(dim, value, baseAxis) {
    if (!isArray$1(dim)) {
      dim = dim ? [dim] : [];
    }
    var data = this.getData();
    var layerSeries = this.getLayerSeries();
    var indices = [];
    var layerNum = layerSeries.length;
    var nestestValue;
    for (var i = 0; i < layerNum; ++i) {
      var minDist = Number.MAX_VALUE;
      var nearestIdx = -1;
      var pointNum = layerSeries[i].indices.length;
      for (var j = 0; j < pointNum; ++j) {
        var theValue = data.get(dim[0], layerSeries[i].indices[j]);
        var dist2 = Math.abs(theValue - value);
        if (dist2 <= minDist) {
          nestestValue = theValue;
          minDist = dist2;
          nearestIdx = layerSeries[i].indices[j];
        }
      }
      indices.push(nearestIdx);
    }
    return {
      dataIndices: indices,
      nestestValue
    };
  };
  ThemeRiverSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var name = data.getName(dataIndex);
    var value = data.get(data.mapDimension("value"), dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  ThemeRiverSeriesModel2.type = "series.themeRiver";
  ThemeRiverSeriesModel2.dependencies = ["singleAxis"];
  ThemeRiverSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "singleAxis",
    boundaryGap: ["10%", "10%"],
    singleAxisIndex: 0,
    animationEasing: "linear",
    label: {
      margin: 4,
      show: true,
      position: "left",
      fontSize: 11
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return ThemeRiverSeriesModel2;
}(SeriesModel$1);
var ThemeRiverSeriesModel$1 = ThemeRiverSeriesModel;
function themeRiverLayout(ecModel, api) {
  ecModel.eachSeriesByType("themeRiver", function(seriesModel) {
    var data = seriesModel.getData();
    var single = seriesModel.coordinateSystem;
    var layoutInfo = {};
    var rect = single.getRect();
    layoutInfo.rect = rect;
    var boundaryGap = seriesModel.get("boundaryGap");
    var axis = single.getAxis();
    layoutInfo.boundaryGap = boundaryGap;
    if (axis.orient === "horizontal") {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.height);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.height);
      var height = rect.height - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, height);
    } else {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.width);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.width);
      var width = rect.width - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, width);
    }
    data.setLayout("layoutInfo", layoutInfo);
  });
}
function doThemeRiverLayout(data, seriesModel, height) {
  if (!data.count()) {
    return;
  }
  var coordSys = seriesModel.coordinateSystem;
  var layerSeries = seriesModel.getLayerSeries();
  var timeDim = data.mapDimension("single");
  var valueDim = data.mapDimension("value");
  var layerPoints = map$1(layerSeries, function(singleLayer) {
    return map$1(singleLayer.indices, function(idx) {
      var pt = coordSys.dataToPoint(data.get(timeDim, idx));
      pt[1] = data.get(valueDim, idx);
      return pt;
    });
  });
  var base2 = computeBaseline(layerPoints);
  var baseLine = base2.y0;
  var ky = height / base2.max;
  var n2 = layerSeries.length;
  var m2 = layerSeries[0].indices.length;
  var baseY0;
  for (var j = 0; j < m2; ++j) {
    baseY0 = baseLine[j] * ky;
    data.setItemLayout(layerSeries[0].indices[j], {
      layerIndex: 0,
      x: layerPoints[0][j][0],
      y0: baseY0,
      y: layerPoints[0][j][1] * ky
    });
    for (var i = 1; i < n2; ++i) {
      baseY0 += layerPoints[i - 1][j][1] * ky;
      data.setItemLayout(layerSeries[i].indices[j], {
        layerIndex: i,
        x: layerPoints[i][j][0],
        y0: baseY0,
        y: layerPoints[i][j][1] * ky
      });
    }
  }
}
function computeBaseline(data) {
  var layerNum = data.length;
  var pointNum = data[0].length;
  var sums = [];
  var y0 = [];
  var max3 = 0;
  for (var i = 0; i < pointNum; ++i) {
    var temp = 0;
    for (var j = 0; j < layerNum; ++j) {
      temp += data[j][i][1];
    }
    if (temp > max3) {
      max3 = temp;
    }
    sums.push(temp);
  }
  for (var k2 = 0; k2 < pointNum; ++k2) {
    y0[k2] = (max3 - sums[k2]) / 2;
  }
  max3 = 0;
  for (var l2 = 0; l2 < pointNum; ++l2) {
    var sum2 = sums[l2] + y0[l2];
    if (sum2 > max3) {
      max3 = sum2;
    }
  }
  return {
    y0,
    max: max3
  };
}
function install$t(registers) {
  registers.registerChartView(ThemeRiverView$1);
  registers.registerSeriesModel(ThemeRiverSeriesModel$1);
  registers.registerLayout(themeRiverLayout);
  registers.registerProcessor(dataFilter$1("themeRiver"));
}
var DEFAULT_SECTOR_Z = 2;
var DEFAULT_TEXT_Z = 4;
var SunburstPiece = function(_super) {
  __extends(SunburstPiece2, _super);
  function SunburstPiece2(node, seriesModel, ecModel, api) {
    var _this = _super.call(this) || this;
    _this.z2 = DEFAULT_SECTOR_Z;
    _this.textConfig = {
      inside: true
    };
    getECData(_this).seriesIndex = seriesModel.seriesIndex;
    var text = new ZRText$1({
      z2: DEFAULT_TEXT_Z,
      silent: node.getModel().get(["label", "silent"])
    });
    _this.setTextContent(text);
    _this.updateData(true, node, seriesModel, ecModel, api);
    return _this;
  }
  SunburstPiece2.prototype.updateData = function(firstCreate, node, seriesModel, ecModel, api) {
    this.node = node;
    node.piece = this;
    seriesModel = seriesModel || this._seriesModel;
    ecModel = ecModel || this._ecModel;
    var sector = this;
    getECData(sector).dataIndex = node.dataIndex;
    var itemModel = node.getModel();
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = node.getLayout();
    var sectorShape = extend({}, layout2);
    sectorShape.label = null;
    var normalStyle = node.getVisual("style");
    normalStyle.lineJoin = "bevel";
    var decal = node.getVisual("decal");
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, api);
    }
    var cornerRadius = getSectorCornerRadius(itemModel.getModel("itemStyle"), sectorShape, true);
    extend(sectorShape, cornerRadius);
    each$g(SPECIAL_STATES, function(stateName) {
      var state = sector.ensureState(stateName);
      var itemStyleModel = itemModel.getModel([stateName, "itemStyle"]);
      state.style = itemStyleModel.getItemStyle();
      var cornerRadius2 = getSectorCornerRadius(itemStyleModel, sectorShape);
      if (cornerRadius2) {
        state.shape = cornerRadius2;
      }
    });
    if (firstCreate) {
      sector.setShape(sectorShape);
      sector.shape.r = layout2.r0;
      updateProps$1(sector, {
        shape: {
          r: layout2.r
        }
      }, seriesModel, node.dataIndex);
    } else {
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel);
      saveOldStyle(sector);
    }
    sector.useStyle(normalStyle);
    this._updateLabel(seriesModel);
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._seriesModel = seriesModel || this._seriesModel;
    this._ecModel = ecModel || this._ecModel;
    var focus = emphasisModel.get("focus");
    var focusOrIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : focus;
    toggleHoverEmphasis(this, focusOrIndices, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  SunburstPiece2.prototype._updateLabel = function(seriesModel) {
    var _this = this;
    var itemModel = this.node.getModel();
    var normalLabelModel = itemModel.getModel("label");
    var layout2 = this.node.getLayout();
    var angle = layout2.endAngle - layout2.startAngle;
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var dx = Math.cos(midAngle);
    var dy = Math.sin(midAngle);
    var sector = this;
    var label = sector.getTextContent();
    var dataIndex = this.node.dataIndex;
    var labelMinAngle = normalLabelModel.get("minAngle") / 180 * Math.PI;
    var isNormalShown = normalLabelModel.get("show") && !(labelMinAngle != null && Math.abs(angle) < labelMinAngle);
    label.ignore = !isNormalShown;
    each$g(DISPLAY_STATES, function(stateName) {
      var labelStateModel = stateName === "normal" ? itemModel.getModel("label") : itemModel.getModel([stateName, "label"]);
      var isNormal = stateName === "normal";
      var state = isNormal ? label : label.ensureState(stateName);
      var text = seriesModel.getFormattedLabel(dataIndex, stateName);
      if (isNormal) {
        text = text || _this.node.name;
      }
      state.style = createTextStyle(labelStateModel, {}, null, stateName !== "normal", true);
      if (text) {
        state.style.text = text;
      }
      var isShown = labelStateModel.get("show");
      if (isShown != null && !isNormal) {
        state.ignore = !isShown;
      }
      var labelPosition = getLabelAttr(labelStateModel, "position");
      var sectorState = isNormal ? sector : sector.states[stateName];
      var labelColor = sectorState.style.fill;
      sectorState.textConfig = {
        outsideFill: labelStateModel.get("color") === "inherit" ? labelColor : null,
        inside: labelPosition !== "outside"
      };
      var r2;
      var labelPadding = getLabelAttr(labelStateModel, "distance") || 0;
      var textAlign = getLabelAttr(labelStateModel, "align");
      if (labelPosition === "outside") {
        r2 = layout2.r + labelPadding;
        textAlign = midAngle > Math.PI / 2 ? "right" : "left";
      } else {
        if (!textAlign || textAlign === "center") {
          if (angle === 2 * Math.PI && layout2.r0 === 0) {
            r2 = 0;
          } else {
            r2 = (layout2.r + layout2.r0) / 2;
          }
          textAlign = "center";
        } else if (textAlign === "left") {
          r2 = layout2.r0 + labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "right";
          }
        } else if (textAlign === "right") {
          r2 = layout2.r - labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "left";
          }
        }
      }
      state.style.align = textAlign;
      state.style.verticalAlign = getLabelAttr(labelStateModel, "verticalAlign") || "middle";
      state.x = r2 * dx + layout2.cx;
      state.y = r2 * dy + layout2.cy;
      var rotateType = getLabelAttr(labelStateModel, "rotate");
      var rotate2 = 0;
      if (rotateType === "radial") {
        rotate2 = -midAngle;
        if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (rotateType === "tangential") {
        rotate2 = Math.PI / 2 - midAngle;
        if (rotate2 > Math.PI / 2) {
          rotate2 -= Math.PI;
        } else if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (isNumber(rotateType)) {
        rotate2 = rotateType * Math.PI / 180;
      }
      state.rotation = rotate2;
    });
    function getLabelAttr(model, name) {
      var stateAttr = model.get(name);
      if (stateAttr == null) {
        return normalLabelModel.get(name);
      }
      return stateAttr;
    }
    label.dirtyStyle();
  };
  return SunburstPiece2;
}(Sector$1);
var SunburstPiece$1 = SunburstPiece;
var ROOT_TO_NODE_ACTION = "sunburstRootToNode";
var HIGHLIGHT_ACTION = "sunburstHighlight";
var UNHIGHLIGHT_ACTION = "sunburstUnhighlight";
function installSunburstAction(registers) {
  registers.registerAction({
    type: ROOT_TO_NODE_ACTION,
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var targetInfo = retrieveTargetInfo(payload, [ROOT_TO_NODE_ACTION], model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
  registers.registerAction({
    type: HIGHLIGHT_ACTION,
    update: "none"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleHighlight);
    function handleHighlight(model) {
      var targetInfo = retrieveTargetInfo(payload, [HIGHLIGHT_ACTION], model);
      if (targetInfo) {
        payload.dataIndex = targetInfo.node.dataIndex;
      }
    }
    api.dispatchAction(extend(payload, {
      type: "highlight"
    }));
  });
  registers.registerAction({
    type: UNHIGHLIGHT_ACTION,
    update: "updateView"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    api.dispatchAction(extend(payload, {
      type: "downplay"
    }));
  });
}
var SunburstView = function(_super) {
  __extends(SunburstView2, _super);
  function SunburstView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstView2.type;
    return _this;
  }
  SunburstView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var self2 = this;
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var data = seriesModel.getData();
    var virtualRoot = data.tree.root;
    var newRoot = seriesModel.getViewRoot();
    var group = this.group;
    var renderLabelForZeroData = seriesModel.get("renderLabelForZeroData");
    var newChildren = [];
    newRoot.eachNode(function(node) {
      newChildren.push(node);
    });
    var oldChildren = this._oldChildren || [];
    dualTravel(newChildren, oldChildren);
    renderRollUp(virtualRoot, newRoot);
    this._initEvents();
    this._oldChildren = newChildren;
    function dualTravel(newChildren2, oldChildren2) {
      if (newChildren2.length === 0 && oldChildren2.length === 0) {
        return;
      }
      new DataDiffer$1(oldChildren2, newChildren2, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIdx, oldIdx) {
        var newNode = newIdx == null ? null : newChildren2[newIdx];
        var oldNode = oldIdx == null ? null : oldChildren2[oldIdx];
        doRenderNode(newNode, oldNode);
      }
    }
    function doRenderNode(newNode, oldNode) {
      if (!renderLabelForZeroData && newNode && !newNode.getValue()) {
        newNode = null;
      }
      if (newNode !== virtualRoot && oldNode !== virtualRoot) {
        if (oldNode && oldNode.piece) {
          if (newNode) {
            oldNode.piece.updateData(false, newNode, seriesModel, ecModel, api);
            data.setItemGraphicEl(newNode.dataIndex, oldNode.piece);
          } else {
            removeNode2(oldNode);
          }
        } else if (newNode) {
          var piece = new SunburstPiece$1(newNode, seriesModel, ecModel, api);
          group.add(piece);
          data.setItemGraphicEl(newNode.dataIndex, piece);
        }
      }
    }
    function removeNode2(node) {
      if (!node) {
        return;
      }
      if (node.piece) {
        group.remove(node.piece);
        node.piece = null;
      }
    }
    function renderRollUp(virtualRoot2, viewRoot) {
      if (viewRoot.depth > 0) {
        if (self2.virtualPiece) {
          self2.virtualPiece.updateData(false, virtualRoot2, seriesModel, ecModel, api);
        } else {
          self2.virtualPiece = new SunburstPiece$1(virtualRoot2, seriesModel, ecModel, api);
          group.add(self2.virtualPiece);
        }
        viewRoot.piece.off("click");
        self2.virtualPiece.on("click", function(e2) {
          self2._rootToNode(viewRoot.parentNode);
        });
      } else if (self2.virtualPiece) {
        group.remove(self2.virtualPiece);
        self2.virtualPiece = null;
      }
    }
  };
  SunburstView2.prototype._initEvents = function() {
    var _this = this;
    this.group.off("click");
    this.group.on("click", function(e2) {
      var targetFound = false;
      var viewRoot = _this.seriesModel.getViewRoot();
      viewRoot.eachNode(function(node) {
        if (!targetFound && node.piece && node.piece === e2.target) {
          var nodeClick = node.getModel().get("nodeClick");
          if (nodeClick === "rootToNode") {
            _this._rootToNode(node);
          } else if (nodeClick === "link") {
            var itemModel = node.getModel();
            var link = itemModel.get("link");
            if (link) {
              var linkTarget = itemModel.get("target", true) || "_blank";
              windowOpen(link, linkTarget);
            }
          }
          targetFound = true;
        }
      });
    });
  };
  SunburstView2.prototype._rootToNode = function(node) {
    if (node !== this.seriesModel.getViewRoot()) {
      this.api.dispatchAction({
        type: ROOT_TO_NODE_ACTION,
        from: this.uid,
        seriesId: this.seriesModel.id,
        targetNode: node
      });
    }
  };
  SunburstView2.prototype.containPoint = function(point, seriesModel) {
    var treeRoot = seriesModel.getData();
    var itemLayout = treeRoot.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  SunburstView2.type = "sunburst";
  return SunburstView2;
}(ChartView$1);
var SunburstView$1 = SunburstView;
var SunburstSeriesModel = function(_super) {
  __extends(SunburstSeriesModel2, _super);
  function SunburstSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstSeriesModel2.type;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  SunburstSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue(root2);
    var levelModels = this._levelModels = map$1(option.levels || [], function(levelDefine) {
      return new Model$1(levelDefine, this, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = levelModels[node.depth];
        levelModel && (model.parentModel = levelModel);
        return model;
      });
    }
    return tree.data;
  };
  SunburstSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  SunburstSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treePathInfo = wrapTreePathInfo(node, this);
    return params;
  };
  SunburstSeriesModel2.prototype.getLevelModel = function(node) {
    return this._levelModels && this._levelModels[node.depth];
  };
  SunburstSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  SunburstSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  SunburstSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  SunburstSeriesModel2.type = "series.sunburst";
  SunburstSeriesModel2.defaultOption = {
    z: 2,
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    stillShowZeroSum: true,
    nodeClick: "rootToNode",
    renderLabelForZeroData: false,
    label: {
      rotate: "radial",
      show: true,
      opacity: 1,
      align: "center",
      position: "inside",
      distance: 5,
      silent: true
    },
    itemStyle: {
      borderWidth: 1,
      borderColor: "white",
      borderType: "solid",
      shadowBlur: 0,
      shadowColor: "rgba(0, 0, 0, 0.2)",
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    emphasis: {
      focus: "descendant"
    },
    blur: {
      itemStyle: {
        opacity: 0.2
      },
      label: {
        opacity: 0.1
      }
    },
    animationType: "expansion",
    animationDuration: 1e3,
    animationDurationUpdate: 500,
    data: [],
    sort: "desc"
  };
  return SunburstSeriesModel2;
}(SeriesModel$1);
function completeTreeValue(dataNode) {
  var sum2 = 0;
  each$g(dataNode.children, function(child) {
    completeTreeValue(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
var SunburstSeriesModel$1 = SunburstSeriesModel;
var RADIAN = Math.PI / 180;
function sunburstLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var center2 = seriesModel.get("center");
    var radius = seriesModel.get("radius");
    if (!isArray$1(radius)) {
      radius = [0, radius];
    }
    if (!isArray$1(center2)) {
      center2 = [center2, center2];
    }
    var width = api.getWidth();
    var height = api.getHeight();
    var size = Math.min(width, height);
    var cx = parsePercent(center2[0], width);
    var cy = parsePercent(center2[1], height);
    var r0 = parsePercent(radius[0], size / 2);
    var r2 = parsePercent(radius[1], size / 2);
    var startAngle = -seriesModel.get("startAngle") * RADIAN;
    var minAngle = seriesModel.get("minAngle") * RADIAN;
    var virtualRoot = seriesModel.getData().tree.root;
    var treeRoot = seriesModel.getViewRoot();
    var rootDepth = treeRoot.depth;
    var sort2 = seriesModel.get("sort");
    if (sort2 != null) {
      initChildren(treeRoot, sort2);
    }
    var validDataCount = 0;
    each$g(treeRoot.children, function(child) {
      !isNaN(child.getValue()) && validDataCount++;
    });
    var sum2 = treeRoot.getValue();
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var renderRollupNode = treeRoot.depth > 0;
    var levels = treeRoot.height - (renderRollupNode ? -1 : 1);
    var rPerLevel = (r2 - r0) / (levels || 1);
    var clockwise = seriesModel.get("clockwise");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var dir3 = clockwise ? 1 : -1;
    var renderNode2 = function(node, startAngle2) {
      if (!node) {
        return;
      }
      var endAngle = startAngle2;
      if (node !== virtualRoot) {
        var value = node.getValue();
        var angle2 = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
        if (angle2 < minAngle) {
          angle2 = minAngle;
        }
        endAngle = startAngle2 + dir3 * angle2;
        var depth = node.depth - rootDepth - (renderRollupNode ? -1 : 1);
        var rStart2 = r0 + rPerLevel * depth;
        var rEnd2 = r0 + rPerLevel * (depth + 1);
        var levelModel = seriesModel.getLevelModel(node);
        if (levelModel) {
          var r0_1 = levelModel.get("r0", true);
          var r_1 = levelModel.get("r", true);
          var radius_1 = levelModel.get("radius", true);
          if (radius_1 != null) {
            r0_1 = radius_1[0];
            r_1 = radius_1[1];
          }
          r0_1 != null && (rStart2 = parsePercent(r0_1, size / 2));
          r_1 != null && (rEnd2 = parsePercent(r_1, size / 2));
        }
        node.setLayout({
          angle: angle2,
          startAngle: startAngle2,
          endAngle,
          clockwise,
          cx,
          cy,
          r0: rStart2,
          r: rEnd2
        });
      }
      if (node.children && node.children.length) {
        var siblingAngle_1 = 0;
        each$g(node.children, function(node2) {
          siblingAngle_1 += renderNode2(node2, startAngle2 + siblingAngle_1);
        });
      }
      return endAngle - startAngle2;
    };
    if (renderRollupNode) {
      var rStart = r0;
      var rEnd = r0 + rPerLevel;
      var angle = Math.PI * 2;
      virtualRoot.setLayout({
        angle,
        startAngle,
        endAngle: startAngle + angle,
        clockwise,
        cx,
        cy,
        r0: rStart,
        r: rEnd
      });
    }
    renderNode2(treeRoot, startAngle);
  });
}
function initChildren(node, sortOrder) {
  var children = node.children || [];
  node.children = sort(children, sortOrder);
  if (children.length) {
    each$g(node.children, function(child) {
      initChildren(child, sortOrder);
    });
  }
}
function sort(children, sortOrder) {
  if (isFunction(sortOrder)) {
    var sortTargets = map$1(children, function(child, idx) {
      var value = child.getValue();
      return {
        params: {
          depth: child.depth,
          height: child.height,
          dataIndex: child.dataIndex,
          getValue: function() {
            return value;
          }
        },
        index: idx
      };
    });
    sortTargets.sort(function(a, b2) {
      return sortOrder(a.params, b2.params);
    });
    return map$1(sortTargets, function(target) {
      return children[target.index];
    });
  } else {
    var isAsc_1 = sortOrder === "asc";
    return children.sort(function(a, b2) {
      var diff = (a.getValue() - b2.getValue()) * (isAsc_1 ? 1 : -1);
      return diff === 0 ? (a.dataIndex - b2.dataIndex) * (isAsc_1 ? -1 : 1) : diff;
    });
  }
}
function sunburstVisual(ecModel) {
  var paletteScope = {};
  function pickColor(node, seriesModel, treeHeight) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var color = seriesModel.getColorFromPalette(current.name || current.dataIndex + "", paletteScope);
    if (node.depth > 1 && isString$1(color)) {
      color = lift(color, (node.depth - 1) / (treeHeight - 1) * 0.5);
    }
    return color;
  }
  ecModel.eachSeriesByType("sunburst", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style2 = model.getModel("itemStyle").getItemStyle();
      if (!style2.fill) {
        style2.fill = pickColor(node, seriesModel, tree.root.height);
      }
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style2);
    });
  });
}
function install$s(registers) {
  registers.registerChartView(SunburstView$1);
  registers.registerSeriesModel(SunburstSeriesModel$1);
  registers.registerLayout(curry$1(sunburstLayout, "sunburst"));
  registers.registerProcessor(curry$1(dataFilter$1, "sunburst"));
  registers.registerVisual(sunburstVisual);
  installSunburstAction(registers);
}
var STYLE_VISUAL_TYPE = {
  color: "fill",
  borderColor: "stroke"
};
var NON_STYLE_VISUAL_PROPS = {
  symbol: 1,
  symbolSize: 1,
  symbolKeepAspect: 1,
  legendIcon: 1,
  visualMeta: 1,
  liftZ: 1,
  decal: 1
};
var customInnerStore = makeInner();
var CustomSeriesModel = function(_super) {
  __extends(CustomSeriesModel2, _super);
  function CustomSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomSeriesModel2.type;
    return _this;
  }
  CustomSeriesModel2.prototype.optionUpdated = function() {
    this.currentZLevel = this.get("zlevel", true);
    this.currentZ = this.get("z", true);
  };
  CustomSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this);
  };
  CustomSeriesModel2.prototype.getDataParams = function(dataIndex, dataType, el) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    el && (params.info = customInnerStore(el).info);
    return params;
  };
  CustomSeriesModel2.type = "series.custom";
  CustomSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  CustomSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    clip: false
  };
  return CustomSeriesModel2;
}(SeriesModel$1);
var CustomSeriesModel$1 = CustomSeriesModel;
function dataToCoordSize$3(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["x", "y"], function(dim, dimIdx) {
    var axis = this.getAxis(dim);
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
  }, this);
}
function cartesianPrepareCustom(coordSys) {
  var rect = coordSys.master.getRect();
  return {
    coordSys: {
      type: "cartesian2d",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$3, coordSys)
    }
  };
}
function dataToCoordSize$2(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1([0, 1], function(dimIdx) {
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var p1 = [];
    var p2 = [];
    p1[dimIdx] = val - halfSize;
    p2[dimIdx] = val + halfSize;
    p1[1 - dimIdx] = p2[1 - dimIdx] = dataItem[1 - dimIdx];
    return Math.abs(this.dataToPoint(p1)[dimIdx] - this.dataToPoint(p2)[dimIdx]);
  }, this);
}
function geoPrepareCustom(coordSys) {
  var rect = coordSys.getBoundingRect();
  return {
    coordSys: {
      type: "geo",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      zoom: coordSys.getZoom()
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$2, coordSys)
    }
  };
}
function dataToCoordSize$1(dataSize, dataItem) {
  var axis = this.getAxis();
  var val = dataItem instanceof Array ? dataItem[0] : dataItem;
  var halfSize = (dataSize instanceof Array ? dataSize[0] : dataSize) / 2;
  return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
}
function singlePrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  return {
    coordSys: {
      type: "singleAxis",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(val) {
        return coordSys.dataToPoint(val);
      },
      size: bind$1(dataToCoordSize$1, coordSys)
    }
  };
}
function dataToCoordSize(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["Radius", "Angle"], function(dim, dimIdx) {
    var getterName = "get" + dim + "Axis";
    var axis = this[getterName]();
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var result = axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
    if (dim === "Angle") {
      result = result * Math.PI / 180;
    }
    return result;
  }, this);
}
function polarPrepareCustom(coordSys) {
  var radiusAxis = coordSys.getRadiusAxis();
  var angleAxis = coordSys.getAngleAxis();
  var radius = radiusAxis.getExtent();
  radius[0] > radius[1] && radius.reverse();
  return {
    coordSys: {
      type: "polar",
      cx: coordSys.cx,
      cy: coordSys.cy,
      r: radius[1],
      r0: radius[0]
    },
    api: {
      coord: function(data) {
        var radius2 = radiusAxis.dataToRadius(data[0]);
        var angle = angleAxis.dataToAngle(data[1]);
        var coord = coordSys.coordToPoint([radius2, angle]);
        coord.push(radius2, angle * Math.PI / 180);
        return coord;
      },
      size: bind$1(dataToCoordSize, coordSys)
    }
  };
}
function calendarPrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  var rangeInfo = coordSys.getRangeInfo();
  return {
    coordSys: {
      type: "calendar",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      cellWidth: coordSys.getCellWidth(),
      cellHeight: coordSys.getCellHeight(),
      rangeInfo: {
        start: rangeInfo.start,
        end: rangeInfo.end,
        weeks: rangeInfo.weeks,
        dayCount: rangeInfo.allDay
      }
    },
    api: {
      coord: function(data, clamp2) {
        return coordSys.dataToPoint(data, clamp2);
      }
    }
  };
}
function isEC4CompatibleStyle(style2, elType, hasOwnTextContentOption, hasOwnTextConfig) {
  return style2 && (style2.legacy || style2.legacy !== false && !hasOwnTextContentOption && !hasOwnTextConfig && elType !== "tspan" && (elType === "text" || hasOwn(style2, "text")));
}
function convertFromEC4CompatibleStyle(hostStyle, elType, isNormal) {
  var srcStyle = hostStyle;
  var textConfig;
  var textContent;
  var textContentStyle;
  if (elType === "text") {
    textContentStyle = srcStyle;
  } else {
    textContentStyle = {};
    hasOwn(srcStyle, "text") && (textContentStyle.text = srcStyle.text);
    hasOwn(srcStyle, "rich") && (textContentStyle.rich = srcStyle.rich);
    hasOwn(srcStyle, "textFill") && (textContentStyle.fill = srcStyle.textFill);
    hasOwn(srcStyle, "textStroke") && (textContentStyle.stroke = srcStyle.textStroke);
    hasOwn(srcStyle, "fontFamily") && (textContentStyle.fontFamily = srcStyle.fontFamily);
    hasOwn(srcStyle, "fontSize") && (textContentStyle.fontSize = srcStyle.fontSize);
    hasOwn(srcStyle, "fontStyle") && (textContentStyle.fontStyle = srcStyle.fontStyle);
    hasOwn(srcStyle, "fontWeight") && (textContentStyle.fontWeight = srcStyle.fontWeight);
    textContent = {
      type: "text",
      style: textContentStyle,
      silent: true
    };
    textConfig = {};
    var hasOwnPos = hasOwn(srcStyle, "textPosition");
    if (isNormal) {
      textConfig.position = hasOwnPos ? srcStyle.textPosition : "inside";
    } else {
      hasOwnPos && (textConfig.position = srcStyle.textPosition);
    }
    hasOwn(srcStyle, "textPosition") && (textConfig.position = srcStyle.textPosition);
    hasOwn(srcStyle, "textOffset") && (textConfig.offset = srcStyle.textOffset);
    hasOwn(srcStyle, "textRotation") && (textConfig.rotation = srcStyle.textRotation);
    hasOwn(srcStyle, "textDistance") && (textConfig.distance = srcStyle.textDistance);
  }
  convertEC4CompatibleRichItem(textContentStyle, hostStyle);
  each$g(textContentStyle.rich, function(richItem) {
    convertEC4CompatibleRichItem(richItem, richItem);
  });
  return {
    textConfig,
    textContent
  };
}
function convertEC4CompatibleRichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  richItem.font = richItem.textFont || richItem.font;
  hasOwn(richItem, "textStrokeWidth") && (out2.lineWidth = richItem.textStrokeWidth);
  hasOwn(richItem, "textAlign") && (out2.align = richItem.textAlign);
  hasOwn(richItem, "textVerticalAlign") && (out2.verticalAlign = richItem.textVerticalAlign);
  hasOwn(richItem, "textLineHeight") && (out2.lineHeight = richItem.textLineHeight);
  hasOwn(richItem, "textWidth") && (out2.width = richItem.textWidth);
  hasOwn(richItem, "textHeight") && (out2.height = richItem.textHeight);
  hasOwn(richItem, "textBackgroundColor") && (out2.backgroundColor = richItem.textBackgroundColor);
  hasOwn(richItem, "textPadding") && (out2.padding = richItem.textPadding);
  hasOwn(richItem, "textBorderColor") && (out2.borderColor = richItem.textBorderColor);
  hasOwn(richItem, "textBorderWidth") && (out2.borderWidth = richItem.textBorderWidth);
  hasOwn(richItem, "textBorderRadius") && (out2.borderRadius = richItem.textBorderRadius);
  hasOwn(richItem, "textBoxShadowColor") && (out2.shadowColor = richItem.textBoxShadowColor);
  hasOwn(richItem, "textBoxShadowBlur") && (out2.shadowBlur = richItem.textBoxShadowBlur);
  hasOwn(richItem, "textBoxShadowOffsetX") && (out2.shadowOffsetX = richItem.textBoxShadowOffsetX);
  hasOwn(richItem, "textBoxShadowOffsetY") && (out2.shadowOffsetY = richItem.textBoxShadowOffsetY);
}
function convertToEC4StyleForCustomSerise(itemStl, txStl, txCfg) {
  var out2 = itemStl;
  out2.textPosition = out2.textPosition || txCfg.position || "inside";
  txCfg.offset != null && (out2.textOffset = txCfg.offset);
  txCfg.rotation != null && (out2.textRotation = txCfg.rotation);
  txCfg.distance != null && (out2.textDistance = txCfg.distance);
  var isInside = out2.textPosition.indexOf("inside") >= 0;
  var hostFill = itemStl.fill || "#000";
  convertToEC4RichItem(out2, txStl);
  var textFillNotSet = out2.textFill == null;
  if (isInside) {
    if (textFillNotSet) {
      out2.textFill = txCfg.insideFill || "#fff";
      !out2.textStroke && txCfg.insideStroke && (out2.textStroke = txCfg.insideStroke);
      !out2.textStroke && (out2.textStroke = hostFill);
      out2.textStrokeWidth == null && (out2.textStrokeWidth = 2);
    }
  } else {
    if (textFillNotSet) {
      out2.textFill = itemStl.fill || txCfg.outsideFill || "#000";
    }
    !out2.textStroke && txCfg.outsideStroke && (out2.textStroke = txCfg.outsideStroke);
  }
  out2.text = txStl.text;
  out2.rich = txStl.rich;
  each$g(txStl.rich, function(richItem) {
    convertToEC4RichItem(richItem, richItem);
  });
  return out2;
}
function convertToEC4RichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  hasOwn(richItem, "fill") && (out2.textFill = richItem.fill);
  hasOwn(richItem, "stroke") && (out2.textStroke = richItem.fill);
  hasOwn(richItem, "lineWidth") && (out2.textStrokeWidth = richItem.lineWidth);
  hasOwn(richItem, "font") && (out2.font = richItem.font);
  hasOwn(richItem, "fontStyle") && (out2.fontStyle = richItem.fontStyle);
  hasOwn(richItem, "fontWeight") && (out2.fontWeight = richItem.fontWeight);
  hasOwn(richItem, "fontSize") && (out2.fontSize = richItem.fontSize);
  hasOwn(richItem, "fontFamily") && (out2.fontFamily = richItem.fontFamily);
  hasOwn(richItem, "align") && (out2.textAlign = richItem.align);
  hasOwn(richItem, "verticalAlign") && (out2.textVerticalAlign = richItem.verticalAlign);
  hasOwn(richItem, "lineHeight") && (out2.textLineHeight = richItem.lineHeight);
  hasOwn(richItem, "width") && (out2.textWidth = richItem.width);
  hasOwn(richItem, "height") && (out2.textHeight = richItem.height);
  hasOwn(richItem, "backgroundColor") && (out2.textBackgroundColor = richItem.backgroundColor);
  hasOwn(richItem, "padding") && (out2.textPadding = richItem.padding);
  hasOwn(richItem, "borderColor") && (out2.textBorderColor = richItem.borderColor);
  hasOwn(richItem, "borderWidth") && (out2.textBorderWidth = richItem.borderWidth);
  hasOwn(richItem, "borderRadius") && (out2.textBorderRadius = richItem.borderRadius);
  hasOwn(richItem, "shadowColor") && (out2.textBoxShadowColor = richItem.shadowColor);
  hasOwn(richItem, "shadowBlur") && (out2.textBoxShadowBlur = richItem.shadowBlur);
  hasOwn(richItem, "shadowOffsetX") && (out2.textBoxShadowOffsetX = richItem.shadowOffsetX);
  hasOwn(richItem, "shadowOffsetY") && (out2.textBoxShadowOffsetY = richItem.shadowOffsetY);
  hasOwn(richItem, "textShadowColor") && (out2.textShadowColor = richItem.textShadowColor);
  hasOwn(richItem, "textShadowBlur") && (out2.textShadowBlur = richItem.textShadowBlur);
  hasOwn(richItem, "textShadowOffsetX") && (out2.textShadowOffsetX = richItem.textShadowOffsetX);
  hasOwn(richItem, "textShadowOffsetY") && (out2.textShadowOffsetY = richItem.textShadowOffsetY);
}
var LEGACY_TRANSFORM_PROPS_MAP = {
  position: ["x", "y"],
  scale: ["scaleX", "scaleY"],
  origin: ["originX", "originY"]
};
var LEGACY_TRANSFORM_PROPS = keys(LEGACY_TRANSFORM_PROPS_MAP);
reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = 1;
  return obj;
}, {});
TRANSFORMABLE_PROPS.join(", ");
var ELEMENT_ANIMATABLE_PROPS = ["", "style", "shape", "extra"];
var transitionInnerStore = makeInner();
function getElementAnimationConfig(animationType, el, elOption, parentModel, dataIndex) {
  var animationProp = animationType + "Animation";
  var config = getAnimationConfig(animationType, parentModel, dataIndex) || {};
  var userDuring = transitionInnerStore(el).userDuring;
  if (config.duration > 0) {
    config.during = userDuring ? bind$1(duringCall, {
      el,
      userDuring
    }) : null;
    config.setToFinal = true;
    config.scope = animationType;
  }
  extend(config, elOption[animationProp]);
  return config;
}
function applyUpdateTransition(el, elOption, animatableModel, opts) {
  opts = opts || {};
  var dataIndex = opts.dataIndex, isInit = opts.isInit, clearStyle = opts.clearStyle;
  var hasAnimation = animatableModel.isAnimationEnabled();
  var store = transitionInnerStore(el);
  var styleOpt = elOption.style;
  store.userDuring = elOption.during;
  var transFromProps = {};
  var propsToSet = {};
  prepareTransformAllPropsFinal(el, elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("shape", elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("extra", elOption, propsToSet);
  if (!isInit && hasAnimation) {
    prepareTransformTransitionFrom(el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("shape", el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("extra", el, elOption, transFromProps);
    prepareStyleTransitionFrom(el, elOption, styleOpt, transFromProps);
  }
  propsToSet.style = styleOpt;
  applyPropsDirectly(el, propsToSet, clearStyle);
  applyMiscProps(el, elOption);
  if (hasAnimation) {
    if (isInit) {
      var enterFromProps_1 = {};
      each$g(ELEMENT_ANIMATABLE_PROPS, function(propName) {
        var prop = propName ? elOption[propName] : elOption;
        if (prop && prop.enterFrom) {
          if (propName) {
            enterFromProps_1[propName] = enterFromProps_1[propName] || {};
          }
          extend(propName ? enterFromProps_1[propName] : enterFromProps_1, prop.enterFrom);
        }
      });
      var config = getElementAnimationConfig("enter", el, elOption, animatableModel, dataIndex);
      if (config.duration > 0) {
        el.animateFrom(enterFromProps_1, config);
      }
    } else {
      applyPropsTransition(el, elOption, dataIndex || 0, animatableModel, transFromProps);
    }
  }
  updateLeaveTo(el, elOption);
  styleOpt ? el.dirty() : el.markRedraw();
}
function updateLeaveTo(el, elOption) {
  var leaveToProps = transitionInnerStore(el).leaveToProps;
  for (var i = 0; i < ELEMENT_ANIMATABLE_PROPS.length; i++) {
    var propName = ELEMENT_ANIMATABLE_PROPS[i];
    var prop = propName ? elOption[propName] : elOption;
    if (prop && prop.leaveTo) {
      if (!leaveToProps) {
        leaveToProps = transitionInnerStore(el).leaveToProps = {};
      }
      if (propName) {
        leaveToProps[propName] = leaveToProps[propName] || {};
      }
      extend(propName ? leaveToProps[propName] : leaveToProps, prop.leaveTo);
    }
  }
}
function applyLeaveTransition(el, elOption, animatableModel, onRemove) {
  if (el) {
    var parent_1 = el.parent;
    var leaveToProps = transitionInnerStore(el).leaveToProps;
    if (leaveToProps) {
      var config = getElementAnimationConfig("update", el, elOption, animatableModel, 0);
      config.done = function() {
        parent_1.remove(el);
        onRemove && onRemove();
      };
      el.animateTo(leaveToProps, config);
    } else {
      parent_1.remove(el);
      onRemove && onRemove();
    }
  }
}
function isTransitionAll(transition) {
  return transition === "all";
}
function applyPropsDirectly(el, allPropsFinal, clearStyle) {
  var styleOpt = allPropsFinal.style;
  if (!el.isGroup && styleOpt) {
    if (clearStyle) {
      el.useStyle({});
      var animators = el.animators;
      for (var i = 0; i < animators.length; i++) {
        var animator = animators[i];
        if (animator.targetName === "style") {
          animator.changeTarget(el.style);
        }
      }
    }
    el.setStyle(styleOpt);
  }
  if (allPropsFinal) {
    allPropsFinal.style = null;
    allPropsFinal && el.attr(allPropsFinal);
    allPropsFinal.style = styleOpt;
  }
}
function applyPropsTransition(el, elOption, dataIndex, model, transFromProps) {
  if (transFromProps) {
    var config = getElementAnimationConfig("update", el, elOption, model, dataIndex);
    if (config.duration > 0) {
      el.animateFrom(transFromProps, config);
    }
  }
}
function applyMiscProps(el, elOption) {
  hasOwn(elOption, "silent") && (el.silent = elOption.silent);
  hasOwn(elOption, "ignore") && (el.ignore = elOption.ignore);
  if (el instanceof Displayable$1) {
    hasOwn(elOption, "invisible") && (el.invisible = elOption.invisible);
  }
  if (el instanceof Path$1) {
    hasOwn(elOption, "autoBatch") && (el.autoBatch = elOption.autoBatch);
  }
}
var tmpDuringScope = {};
var transitionDuringAPI = {
  setTransform: function(key, val) {
    tmpDuringScope.el[key] = val;
    return this;
  },
  getTransform: function(key) {
    return tmpDuringScope.el[key];
  },
  setShape: function(key, val) {
    var el = tmpDuringScope.el;
    var shape = el.shape || (el.shape = {});
    shape[key] = val;
    el.dirtyShape && el.dirtyShape();
    return this;
  },
  getShape: function(key) {
    var shape = tmpDuringScope.el.shape;
    if (shape) {
      return shape[key];
    }
  },
  setStyle: function(key, val) {
    var el = tmpDuringScope.el;
    var style2 = el.style;
    if (style2) {
      style2[key] = val;
      el.dirtyStyle && el.dirtyStyle();
    }
    return this;
  },
  getStyle: function(key) {
    var style2 = tmpDuringScope.el.style;
    if (style2) {
      return style2[key];
    }
  },
  setExtra: function(key, val) {
    var extra = tmpDuringScope.el.extra || (tmpDuringScope.el.extra = {});
    extra[key] = val;
    return this;
  },
  getExtra: function(key) {
    var extra = tmpDuringScope.el.extra;
    if (extra) {
      return extra[key];
    }
  }
};
function duringCall() {
  var scope = this;
  var el = scope.el;
  if (!el) {
    return;
  }
  var latestUserDuring = transitionInnerStore(el).userDuring;
  var scopeUserDuring = scope.userDuring;
  if (latestUserDuring !== scopeUserDuring) {
    scope.el = scope.userDuring = null;
    return;
  }
  tmpDuringScope.el = el;
  scopeUserDuring(transitionDuringAPI);
}
function prepareShapeOrExtraTransitionFrom(mainAttr, fromEl, elOption, transFromProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var elPropsInAttr = fromEl[mainAttr];
  var transFromPropsInAttr;
  if (elPropsInAttr) {
    var transition = elOption.transition;
    var attrTransition = attrOpt.transition;
    if (attrTransition) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      if (isTransitionAll(attrTransition)) {
        extend(transFromPropsInAttr, elPropsInAttr);
      } else {
        var transitionKeys2 = normalizeToArray(attrTransition);
        for (var i = 0; i < transitionKeys2.length; i++) {
          var key = transitionKeys2[i];
          var elVal = elPropsInAttr[key];
          transFromPropsInAttr[key] = elVal;
        }
      }
    } else if (isTransitionAll(transition) || indexOf(transition, mainAttr) >= 0) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      var elPropsInAttrKeys = keys(elPropsInAttr);
      for (var i = 0; i < elPropsInAttrKeys.length; i++) {
        var key = elPropsInAttrKeys[i];
        var elVal = elPropsInAttr[key];
        if (isNonStyleTransitionEnabled(attrOpt[key], elVal)) {
          transFromPropsInAttr[key] = elVal;
        }
      }
    }
  }
}
function prepareShapeOrExtraAllPropsFinal(mainAttr, elOption, allProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var allPropsInAttr = allProps[mainAttr] = {};
  var keysInAttr = keys(attrOpt);
  for (var i = 0; i < keysInAttr.length; i++) {
    var key = keysInAttr[i];
    allPropsInAttr[key] = cloneValue(attrOpt[key]);
  }
}
function prepareTransformTransitionFrom(el, elOption, transFromProps) {
  var transition = elOption.transition;
  var transitionKeys2 = isTransitionAll(transition) ? TRANSFORMABLE_PROPS : normalizeToArray(transition || []);
  for (var i = 0; i < transitionKeys2.length; i++) {
    var key = transitionKeys2[i];
    if (key === "style" || key === "shape" || key === "extra") {
      continue;
    }
    var elVal = el[key];
    transFromProps[key] = elVal;
  }
}
function prepareTransformAllPropsFinal(el, elOption, allProps) {
  for (var i = 0; i < LEGACY_TRANSFORM_PROPS.length; i++) {
    var legacyName = LEGACY_TRANSFORM_PROPS[i];
    var xyName = LEGACY_TRANSFORM_PROPS_MAP[legacyName];
    var legacyArr = elOption[legacyName];
    if (legacyArr) {
      allProps[xyName[0]] = legacyArr[0];
      allProps[xyName[1]] = legacyArr[1];
    }
  }
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var key = TRANSFORMABLE_PROPS[i];
    if (elOption[key] != null) {
      allProps[key] = elOption[key];
    }
  }
}
function prepareStyleTransitionFrom(fromEl, elOption, styleOpt, transFromProps) {
  if (!styleOpt) {
    return;
  }
  var fromElStyle = fromEl.style;
  var transFromStyleProps;
  if (fromElStyle) {
    var styleTransition = styleOpt.transition;
    var elTransition = elOption.transition;
    if (styleTransition && !isTransitionAll(styleTransition)) {
      var transitionKeys2 = normalizeToArray(styleTransition);
      !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
      for (var i = 0; i < transitionKeys2.length; i++) {
        var key = transitionKeys2[i];
        var elVal = fromElStyle[key];
        transFromStyleProps[key] = elVal;
      }
    } else if (fromEl.getAnimationStyleProps && (isTransitionAll(elTransition) || isTransitionAll(styleTransition) || indexOf(elTransition, "style") >= 0)) {
      var animationProps = fromEl.getAnimationStyleProps();
      var animationStyleProps = animationProps ? animationProps.style : null;
      if (animationStyleProps) {
        !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
        var styleKeys = keys(styleOpt);
        for (var i = 0; i < styleKeys.length; i++) {
          var key = styleKeys[i];
          if (animationStyleProps[key]) {
            var elVal = fromElStyle[key];
            transFromStyleProps[key] = elVal;
          }
        }
      }
    }
  }
}
function isNonStyleTransitionEnabled(optVal, elVal) {
  return !isArrayLike(optVal) ? optVal != null && isFinite(optVal) : optVal !== elVal;
}
var getStateToRestore = makeInner();
var KEYFRAME_EXCLUDE_KEYS = ["percent", "easing", "shape", "style", "extra"];
function stopPreviousKeyframeAnimationAndRestore(el) {
  el.stopAnimation("keyframe");
  el.attr(getStateToRestore(el));
}
function applyKeyframeAnimation(el, animationOpts, animatableModel) {
  if (!animatableModel.isAnimationEnabled() || !animationOpts) {
    return;
  }
  if (isArray$1(animationOpts)) {
    each$g(animationOpts, function(singleAnimationOpts) {
      applyKeyframeAnimation(el, singleAnimationOpts, animatableModel);
    });
    return;
  }
  var keyframes = animationOpts.keyframes;
  var duration = animationOpts.duration;
  if (animatableModel && duration == null) {
    var config = getAnimationConfig("enter", animatableModel, 0);
    duration = config && config.duration;
  }
  if (!keyframes || !duration) {
    return;
  }
  var stateToRestore = getStateToRestore(el);
  each$g(ELEMENT_ANIMATABLE_PROPS, function(targetPropName) {
    if (targetPropName && !el[targetPropName]) {
      return;
    }
    var animator;
    keyframes.sort(function(a, b2) {
      return a.percent - b2.percent;
    });
    each$g(keyframes, function(kf2) {
      var animators = el.animators;
      var kfValues = targetPropName ? kf2[targetPropName] : kf2;
      if (!kfValues) {
        return;
      }
      var propKeys = keys(kfValues);
      if (!targetPropName) {
        propKeys = filter(propKeys, function(key) {
          return indexOf(KEYFRAME_EXCLUDE_KEYS, key) < 0;
        });
      }
      if (!propKeys.length) {
        return;
      }
      if (!animator) {
        animator = el.animate(targetPropName, animationOpts.loop, true);
        animator.scope = "keyframe";
      }
      for (var i = 0; i < animators.length; i++) {
        if (animators[i] !== animator && animators[i].targetName === animator.targetName) {
          animators[i].stopTracks(propKeys);
        }
      }
      targetPropName && (stateToRestore[targetPropName] = stateToRestore[targetPropName] || {});
      var savedTarget = targetPropName ? stateToRestore[targetPropName] : stateToRestore;
      each$g(propKeys, function(key) {
        savedTarget[key] = ((targetPropName ? el[targetPropName] : el) || {})[key];
      });
      animator.whenWithKeys(duration * kf2.percent, kfValues, propKeys, kf2.easing);
    });
    if (!animator) {
      return;
    }
    animator.delay(animationOpts.delay || 0).duration(duration).start(animationOpts.easing);
  });
}
var EMPHASIS = "emphasis";
var NORMAL = "normal";
var BLUR = "blur";
var SELECT = "select";
var STATES = [NORMAL, EMPHASIS, BLUR, SELECT];
var PATH_ITEM_STYLE = {
  normal: ["itemStyle"],
  emphasis: [EMPHASIS, "itemStyle"],
  blur: [BLUR, "itemStyle"],
  select: [SELECT, "itemStyle"]
};
var PATH_LABEL = {
  normal: ["label"],
  emphasis: [EMPHASIS, "label"],
  blur: [BLUR, "label"],
  select: [SELECT, "label"]
};
var DEFAULT_TRANSITION = ["x", "y"];
var GROUP_DIFF_PREFIX = "e\0\0";
var attachedTxInfoTmp = {
  normal: {},
  emphasis: {},
  blur: {},
  select: {}
};
var prepareCustoms = {
  cartesian2d: cartesianPrepareCustom,
  geo: geoPrepareCustom,
  singleAxis: singlePrepareCustom,
  polar: polarPrepareCustom,
  calendar: calendarPrepareCustom
};
function isPath(el) {
  return el instanceof Path$1;
}
function isDisplayable(el) {
  return el instanceof Displayable$1;
}
function copyElement(sourceEl, targetEl) {
  targetEl.copyTransform(sourceEl);
  if (isDisplayable(targetEl) && isDisplayable(sourceEl)) {
    targetEl.setStyle(sourceEl.style);
    targetEl.z = sourceEl.z;
    targetEl.z2 = sourceEl.z2;
    targetEl.zlevel = sourceEl.zlevel;
    targetEl.invisible = sourceEl.invisible;
    targetEl.ignore = sourceEl.ignore;
    if (isPath(targetEl) && isPath(sourceEl)) {
      targetEl.setShape(sourceEl.shape);
    }
  }
}
var CustomChartView = function(_super) {
  __extends(CustomChartView2, _super);
  function CustomChartView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomChartView2.type;
    return _this;
  }
  CustomChartView2.prototype.render = function(customSeries, ecModel, api, payload) {
    this._progressiveEls = null;
    var oldData = this._data;
    var data = customSeries.getData();
    var group = this.group;
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      createOrUpdateItem(api, null, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      applyLeaveTransition(el, customInnerStore(el).option, customSeries);
    }).update(function(newIdx, oldIdx) {
      var oldEl = oldData.getItemGraphicEl(oldIdx);
      createOrUpdateItem(api, oldEl, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).execute();
    var clipPath = customSeries.get("clip", true) ? createClipPath(customSeries.coordinateSystem, false, customSeries) : null;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
    this._data = data;
  };
  CustomChartView2.prototype.incrementalPrepareRender = function(customSeries, ecModel, api) {
    this.group.removeAll();
    this._data = null;
  };
  CustomChartView2.prototype.incrementalRender = function(params, customSeries, ecModel, api, payload) {
    var data = customSeries.getData();
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    var progressiveEls = this._progressiveEls = [];
    function setIncrementalAndHoverLayer(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = params.start; idx < params.end; idx++) {
      var el = createOrUpdateItem(null, null, idx, renderItem(idx, payload), customSeries, this.group, data);
      if (el) {
        el.traverse(setIncrementalAndHoverLayer);
        progressiveEls.push(el);
      }
    }
  };
  CustomChartView2.prototype.eachRendered = function(cb2) {
    traverseElements(this._progressiveEls || this.group, cb2);
  };
  CustomChartView2.prototype.filterForExposedEvent = function(eventType, query, targetEl, packedEvent) {
    var elementName = query.element;
    if (elementName == null || targetEl.name === elementName) {
      return true;
    }
    while ((targetEl = targetEl.__hostTarget || targetEl.parent) && targetEl !== this.group) {
      if (targetEl.name === elementName) {
        return true;
      }
    }
    return false;
  };
  CustomChartView2.type = "custom";
  return CustomChartView2;
}(ChartView$1);
var CustomChartView$1 = CustomChartView;
function createEl$1(elOption) {
  var graphicType = elOption.type;
  var el;
  if (graphicType === "path") {
    var shape = elOption.shape;
    var pathRect = shape.width != null && shape.height != null ? {
      x: shape.x || 0,
      y: shape.y || 0,
      width: shape.width,
      height: shape.height
    } : null;
    var pathData = getPathData(shape);
    el = makePath(pathData, null, pathRect, shape.layout || "center");
    customInnerStore(el).customPathData = pathData;
  } else if (graphicType === "image") {
    el = new ZRImage$1({});
    customInnerStore(el).customImagePath = elOption.style.image;
  } else if (graphicType === "text") {
    el = new ZRText$1({});
  } else if (graphicType === "group") {
    el = new Group$6();
  } else if (graphicType === "compoundPath") {
    throw new Error('"compoundPath" is not supported yet.');
  } else {
    var Clz = getShapeClass(graphicType);
    if (!Clz) {
      var errMsg = "";
      throwError(errMsg);
    }
    el = new Clz();
  }
  customInnerStore(el).customGraphicType = graphicType;
  el.name = elOption.name;
  el.z2EmphasisLift = 1;
  el.z2SelectLift = 1;
  return el;
}
function updateElNormal(api, el, dataIndex, elOption, attachedTxInfo, seriesModel, isInit) {
  stopPreviousKeyframeAnimationAndRestore(el);
  var txCfgOpt = attachedTxInfo && attachedTxInfo.normal.cfg;
  if (txCfgOpt) {
    el.setTextConfig(txCfgOpt);
  }
  if (elOption && elOption.transition == null) {
    elOption.transition = DEFAULT_TRANSITION;
  }
  var styleOpt = elOption && elOption.style;
  if (styleOpt) {
    if (el.type === "text") {
      var textOptionStyle = styleOpt;
      hasOwn(textOptionStyle, "textFill") && (textOptionStyle.fill = textOptionStyle.textFill);
      hasOwn(textOptionStyle, "textStroke") && (textOptionStyle.stroke = textOptionStyle.textStroke);
    }
    var decalPattern = void 0;
    var decalObj = isPath(el) ? styleOpt.decal : null;
    if (api && decalObj) {
      decalObj.dirty = true;
      decalPattern = createOrUpdatePatternFromDecal(decalObj, api);
    }
    styleOpt.__decalPattern = decalPattern;
  }
  if (isDisplayable(el)) {
    if (styleOpt) {
      var decalPattern = styleOpt.__decalPattern;
      if (decalPattern) {
        styleOpt.decal = decalPattern;
      }
    }
  }
  applyUpdateTransition(el, elOption, seriesModel, {
    dataIndex,
    isInit,
    clearStyle: true
  });
  applyKeyframeAnimation(el, elOption.keyframeAnimation, seriesModel);
}
function updateElOnState(state, el, elStateOpt, styleOpt, attachedTxInfo) {
  var elDisplayable = el.isGroup ? null : el;
  var txCfgOpt = attachedTxInfo && attachedTxInfo[state].cfg;
  if (elDisplayable) {
    var stateObj = elDisplayable.ensureState(state);
    if (styleOpt === false) {
      var existingEmphasisState = elDisplayable.getState(state);
      if (existingEmphasisState) {
        existingEmphasisState.style = null;
      }
    } else {
      stateObj.style = styleOpt || null;
    }
    if (txCfgOpt) {
      stateObj.textConfig = txCfgOpt;
    }
    setDefaultStateProxy(elDisplayable);
  }
}
function updateZ(el, elOption, seriesModel) {
  if (el.isGroup) {
    return;
  }
  var elDisplayable = el;
  var currentZ = seriesModel.currentZ;
  var currentZLevel = seriesModel.currentZLevel;
  elDisplayable.z = currentZ;
  elDisplayable.zlevel = currentZLevel;
  var optZ2 = elOption.z2;
  optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  for (var i = 0; i < STATES.length; i++) {
    updateZForEachState(elDisplayable, elOption, STATES[i]);
  }
}
function updateZForEachState(elDisplayable, elOption, state) {
  var isNormal = state === NORMAL;
  var elStateOpt = isNormal ? elOption : retrieveStateOption(elOption, state);
  var optZ2 = elStateOpt ? elStateOpt.z2 : null;
  var stateObj;
  if (optZ2 != null) {
    stateObj = isNormal ? elDisplayable : elDisplayable.ensureState(state);
    stateObj.z2 = optZ2 || 0;
  }
}
function makeRenderItem(customSeries, data, ecModel, api) {
  var renderItem = customSeries.get("renderItem");
  var coordSys = customSeries.coordinateSystem;
  var prepareResult2 = {};
  if (coordSys) {
    prepareResult2 = coordSys.prepareCustoms ? coordSys.prepareCustoms(coordSys) : prepareCustoms[coordSys.type](coordSys);
  }
  var userAPI = defaults({
    getWidth: api.getWidth,
    getHeight: api.getHeight,
    getZr: api.getZr,
    getDevicePixelRatio: api.getDevicePixelRatio,
    value,
    style: style2,
    ordinalRawValue,
    styleEmphasis,
    visual,
    barLayout,
    currentSeriesIndices,
    font
  }, prepareResult2.api || {});
  var userParams = {
    context: {},
    seriesId: customSeries.id,
    seriesName: customSeries.name,
    seriesIndex: customSeries.seriesIndex,
    coordSys: prepareResult2.coordSys,
    dataInsideLength: data.count(),
    encode: wrapEncodeDef(customSeries.getData())
  };
  var currDataIndexInside;
  var currItemModel;
  var currItemStyleModels = {};
  var currLabelModels = {};
  var seriesItemStyleModels = {};
  var seriesLabelModels = {};
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    seriesItemStyleModels[stateName] = customSeries.getModel(PATH_ITEM_STYLE[stateName]);
    seriesLabelModels[stateName] = customSeries.getModel(PATH_LABEL[stateName]);
  }
  function getItemModel2(dataIndexInside) {
    return dataIndexInside === currDataIndexInside ? currItemModel || (currItemModel = data.getItemModel(dataIndexInside)) : data.getItemModel(dataIndexInside);
  }
  function getItemStyleModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesItemStyleModels[state] : dataIndexInside === currDataIndexInside ? currItemStyleModels[state] || (currItemStyleModels[state] = getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state])) : getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state]);
  }
  function getLabelModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesLabelModels[state] : dataIndexInside === currDataIndexInside ? currLabelModels[state] || (currLabelModels[state] = getItemModel2(dataIndexInside).getModel(PATH_LABEL[state])) : getItemModel2(dataIndexInside).getModel(PATH_LABEL[state]);
  }
  return function(dataIndexInside, payload) {
    currDataIndexInside = dataIndexInside;
    currItemModel = null;
    currItemStyleModels = {};
    currLabelModels = {};
    return renderItem && renderItem(defaults({
      dataIndexInside,
      dataIndex: data.getRawIndex(dataIndexInside),
      actionType: payload ? payload.type : null
    }, userParams), userAPI);
  };
  function value(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    return data.getStore().get(data.getDimensionIndex(dim || 0), dataIndexInside);
  }
  function ordinalRawValue(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    dim = dim || 0;
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo) {
      var dimIndex = data.getDimensionIndex(dim);
      return dimIndex >= 0 ? data.getStore().get(dimIndex, dataIndexInside) : void 0;
    }
    var val = data.get(dimInfo.name, dataIndexInside);
    var ordinalMeta = dimInfo && dimInfo.ordinalMeta;
    return ordinalMeta ? ordinalMeta.categories[val] : val;
  }
  function style2(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var style3 = data.getItemVisual(dataIndexInside, "style");
    var visualColor = style3 && style3.fill;
    var opacity = style3 && style3.opacity;
    var itemStyle = getItemStyleModel(dataIndexInside, NORMAL).getItemStyle();
    visualColor != null && (itemStyle.fill = visualColor);
    opacity != null && (itemStyle.opacity = opacity);
    var opt = {
      inheritColor: isString$1(visualColor) ? visualColor : "#000"
    };
    var labelModel = getLabelModel(dataIndexInside, NORMAL);
    var textStyle = createTextStyle(labelModel, null, opt, false, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve2(customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, opt, false);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function styleEmphasis(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var itemStyle = getItemStyleModel(dataIndexInside, EMPHASIS).getItemStyle();
    var labelModel = getLabelModel(dataIndexInside, EMPHASIS);
    var textStyle = createTextStyle(labelModel, null, null, true, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve3(customSeries.getFormattedLabel(dataIndexInside, EMPHASIS), customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, null, true);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function applyUserPropsAfter(itemStyle, extra) {
    for (var key in extra) {
      if (hasOwn(extra, key)) {
        itemStyle[key] = extra[key];
      }
    }
  }
  function preFetchFromExtra(extra, itemStyle) {
    if (extra) {
      extra.textFill && (itemStyle.textFill = extra.textFill);
      extra.textPosition && (itemStyle.textPosition = extra.textPosition);
    }
  }
  function visual(visualType, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    if (hasOwn(STYLE_VISUAL_TYPE, visualType)) {
      var style_1 = data.getItemVisual(dataIndexInside, "style");
      return style_1 ? style_1[STYLE_VISUAL_TYPE[visualType]] : null;
    }
    if (hasOwn(NON_STYLE_VISUAL_PROPS, visualType)) {
      return data.getItemVisual(dataIndexInside, visualType);
    }
  }
  function barLayout(opt) {
    if (coordSys.type === "cartesian2d") {
      var baseAxis = coordSys.getBaseAxis();
      return getLayoutOnAxis(defaults({
        axis: baseAxis
      }, opt));
    }
  }
  function currentSeriesIndices() {
    return ecModel.getCurrentSeriesIndices();
  }
  function font(opt) {
    return getFont(opt, ecModel);
  }
}
function wrapEncodeDef(data) {
  var encodeDef = {};
  each$g(data.dimensions, function(dimName) {
    var dimInfo = data.getDimensionInfo(dimName);
    if (!dimInfo.isExtraCoord) {
      var coordDim = dimInfo.coordDim;
      var dataDims = encodeDef[coordDim] = encodeDef[coordDim] || [];
      dataDims[dimInfo.coordDimIndex] = data.getDimensionIndex(dimName);
    }
  });
  return encodeDef;
}
function createOrUpdateItem(api, existsEl, dataIndex, elOption, seriesModel, group, data) {
  if (!elOption) {
    group.remove(existsEl);
    return;
  }
  var el = doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group);
  el && data.setItemGraphicEl(dataIndex, el);
  el && toggleHoverEmphasis(el, elOption.focus, elOption.blurScope, elOption.emphasisDisabled);
  return el;
}
function doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group) {
  var toBeReplacedIdx = -1;
  var oldEl = existsEl;
  if (existsEl && doesElNeedRecreate(existsEl, elOption, seriesModel)) {
    toBeReplacedIdx = indexOf(group.childrenRef(), existsEl);
    existsEl = null;
  }
  var isInit = !existsEl;
  var el = existsEl;
  if (!el) {
    el = createEl$1(elOption);
    if (oldEl) {
      copyElement(oldEl, el);
    }
  } else {
    el.clearStates();
  }
  if (elOption.morph === false) {
    el.disableMorphing = true;
  } else if (el.disableMorphing) {
    el.disableMorphing = false;
  }
  attachedTxInfoTmp.normal.cfg = attachedTxInfoTmp.normal.conOpt = attachedTxInfoTmp.emphasis.cfg = attachedTxInfoTmp.emphasis.conOpt = attachedTxInfoTmp.blur.cfg = attachedTxInfoTmp.blur.conOpt = attachedTxInfoTmp.select.cfg = attachedTxInfoTmp.select.conOpt = null;
  attachedTxInfoTmp.isLegacy = false;
  doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfoTmp);
  doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit);
  updateElNormal(api, el, dataIndex, elOption, attachedTxInfoTmp, seriesModel, isInit);
  hasOwn(elOption, "info") && (customInnerStore(el).info = elOption.info);
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    if (stateName !== NORMAL) {
      var otherStateOpt = retrieveStateOption(elOption, stateName);
      var otherStyleOpt = retrieveStyleOptionOnState(elOption, otherStateOpt, stateName);
      updateElOnState(stateName, el, otherStateOpt, otherStyleOpt, attachedTxInfoTmp);
    }
  }
  updateZ(el, elOption, seriesModel);
  if (elOption.type === "group") {
    mergeChildren(api, el, dataIndex, elOption, seriesModel);
  }
  if (toBeReplacedIdx >= 0) {
    group.replaceAt(el, toBeReplacedIdx);
  } else {
    group.add(el);
  }
  return el;
}
function doesElNeedRecreate(el, elOption, seriesModel) {
  var elInner = customInnerStore(el);
  var elOptionType = elOption.type;
  var elOptionShape = elOption.shape;
  var elOptionStyle = elOption.style;
  return seriesModel.isUniversalTransitionEnabled() || elOptionType != null && elOptionType !== elInner.customGraphicType || elOptionType === "path" && hasOwnPathData(elOptionShape) && getPathData(elOptionShape) !== elInner.customPathData || elOptionType === "image" && hasOwn(elOptionStyle, "image") && elOptionStyle.image !== elInner.customImagePath;
}
function doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit) {
  var clipPathOpt = elOption.clipPath;
  if (clipPathOpt === false) {
    if (el && el.getClipPath()) {
      el.removeClipPath();
    }
  } else if (clipPathOpt) {
    var clipPath = el.getClipPath();
    if (clipPath && doesElNeedRecreate(clipPath, clipPathOpt, seriesModel)) {
      clipPath = null;
    }
    if (!clipPath) {
      clipPath = createEl$1(clipPathOpt);
      el.setClipPath(clipPath);
    }
    updateElNormal(null, clipPath, dataIndex, clipPathOpt, null, seriesModel, isInit);
  }
}
function doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfo) {
  if (el.isGroup) {
    return;
  }
  processTxInfo(elOption, null, attachedTxInfo);
  processTxInfo(elOption, EMPHASIS, attachedTxInfo);
  var txConOptNormal = attachedTxInfo.normal.conOpt;
  var txConOptEmphasis = attachedTxInfo.emphasis.conOpt;
  var txConOptBlur = attachedTxInfo.blur.conOpt;
  var txConOptSelect = attachedTxInfo.select.conOpt;
  if (txConOptNormal != null || txConOptEmphasis != null || txConOptSelect != null || txConOptBlur != null) {
    var textContent = el.getTextContent();
    if (txConOptNormal === false) {
      textContent && el.removeTextContent();
    } else {
      txConOptNormal = attachedTxInfo.normal.conOpt = txConOptNormal || {
        type: "text"
      };
      if (!textContent) {
        textContent = createEl$1(txConOptNormal);
        el.setTextContent(textContent);
      } else {
        textContent.clearStates();
      }
      updateElNormal(null, textContent, dataIndex, txConOptNormal, null, seriesModel, isInit);
      var txConStlOptNormal = txConOptNormal && txConOptNormal.style;
      for (var i = 0; i < STATES.length; i++) {
        var stateName = STATES[i];
        if (stateName !== NORMAL) {
          var txConOptOtherState = attachedTxInfo[stateName].conOpt;
          updateElOnState(stateName, textContent, txConOptOtherState, retrieveStyleOptionOnState(txConOptNormal, txConOptOtherState, stateName), null);
        }
      }
      txConStlOptNormal ? textContent.dirty() : textContent.markRedraw();
    }
  }
}
function processTxInfo(elOption, state, attachedTxInfo) {
  var stateOpt = !state ? elOption : retrieveStateOption(elOption, state);
  var styleOpt = !state ? elOption.style : retrieveStyleOptionOnState(elOption, stateOpt, EMPHASIS);
  var elType = elOption.type;
  var txCfg = stateOpt ? stateOpt.textConfig : null;
  var txConOptNormal = elOption.textContent;
  var txConOpt = !txConOptNormal ? null : !state ? txConOptNormal : retrieveStateOption(txConOptNormal, state);
  if (styleOpt && (attachedTxInfo.isLegacy || isEC4CompatibleStyle(styleOpt, elType, !!txCfg, !!txConOpt))) {
    attachedTxInfo.isLegacy = true;
    var convertResult = convertFromEC4CompatibleStyle(styleOpt, elType, !state);
    if (!txCfg && convertResult.textConfig) {
      txCfg = convertResult.textConfig;
    }
    if (!txConOpt && convertResult.textContent) {
      txConOpt = convertResult.textContent;
    }
  }
  if (!state && txConOpt) {
    var txConOptNormal_1 = txConOpt;
    !txConOptNormal_1.type && (txConOptNormal_1.type = "text");
  }
  var info = !state ? attachedTxInfo.normal : attachedTxInfo[state];
  info.cfg = txCfg;
  info.conOpt = txConOpt;
}
function retrieveStateOption(elOption, state) {
  return !state ? elOption : elOption ? elOption[state] : null;
}
function retrieveStyleOptionOnState(stateOptionNormal, stateOption, state) {
  var style2 = stateOption && stateOption.style;
  if (style2 == null && state === EMPHASIS && stateOptionNormal) {
    style2 = stateOptionNormal.styleEmphasis;
  }
  return style2;
}
function mergeChildren(api, el, dataIndex, elOption, seriesModel) {
  var newChildren = elOption.children;
  var newLen = newChildren ? newChildren.length : 0;
  var mergeChildren2 = elOption.$mergeChildren;
  var byName = mergeChildren2 === "byName" || elOption.diffChildrenByName;
  var notMerge = mergeChildren2 === false;
  if (!newLen && !byName && !notMerge) {
    return;
  }
  if (byName) {
    diffGroupChildren({
      api,
      oldChildren: el.children() || [],
      newChildren: newChildren || [],
      dataIndex,
      seriesModel,
      group: el
    });
    return;
  }
  notMerge && el.removeAll();
  var index2 = 0;
  for (; index2 < newLen; index2++) {
    newChildren[index2] && doCreateOrUpdateEl(api, el.childAt(index2), dataIndex, newChildren[index2], seriesModel, el);
  }
  for (var i = el.childCount() - 1; i >= index2; i--) {
    var child = el.childAt(i);
    applyLeaveTransition(child, customInnerStore(el).option, seriesModel);
  }
}
function diffGroupChildren(context) {
  new DataDiffer$1(context.oldChildren, context.newChildren, getKey, getKey, context).add(processAddUpdate).update(processAddUpdate).remove(processRemove).execute();
}
function getKey(item, idx) {
  var name = item && item.name;
  return name != null ? name : GROUP_DIFF_PREFIX + idx;
}
function processAddUpdate(newIndex, oldIndex) {
  var context = this.context;
  var childOption = newIndex != null ? context.newChildren[newIndex] : null;
  var child = oldIndex != null ? context.oldChildren[oldIndex] : null;
  doCreateOrUpdateEl(context.api, child, context.dataIndex, childOption, context.seriesModel, context.group);
}
function processRemove(oldIndex) {
  var context = this.context;
  var child = context.oldChildren[oldIndex];
  applyLeaveTransition(child, customInnerStore(child).option, context.seriesModel);
}
function getPathData(shape) {
  return shape && (shape.pathData || shape.d);
}
function hasOwnPathData(shape) {
  return shape && (hasOwn(shape, "pathData") || hasOwn(shape, "d"));
}
function install$r(registers) {
  registers.registerChartView(CustomChartView$1);
  registers.registerSeriesModel(CustomSeriesModel$1);
}
var inner$b = makeInner();
var clone$1 = clone$4;
var bind = bind$1;
var BaseAxisPointer = function() {
  function BaseAxisPointer2() {
    this._dragging = false;
    this.animationThreshold = 15;
  }
  BaseAxisPointer2.prototype.render = function(axisModel, axisPointerModel, api, forceRender) {
    var value = axisPointerModel.get("value");
    var status = axisPointerModel.get("status");
    this._axisModel = axisModel;
    this._axisPointerModel = axisPointerModel;
    this._api = api;
    if (!forceRender && this._lastValue === value && this._lastStatus === status) {
      return;
    }
    this._lastValue = value;
    this._lastStatus = status;
    var group = this._group;
    var handle = this._handle;
    if (!status || status === "hide") {
      group && group.hide();
      handle && handle.hide();
      return;
    }
    group && group.show();
    handle && handle.show();
    var elOption = {};
    this.makeElOption(elOption, value, axisModel, axisPointerModel, api);
    var graphicKey = elOption.graphicKey;
    if (graphicKey !== this._lastGraphicKey) {
      this.clear(api);
    }
    this._lastGraphicKey = graphicKey;
    var moveAnimation = this._moveAnimation = this.determineAnimation(axisModel, axisPointerModel);
    if (!group) {
      group = this._group = new Group$6();
      this.createPointerEl(group, elOption, axisModel, axisPointerModel);
      this.createLabelEl(group, elOption, axisModel, axisPointerModel);
      api.getZr().add(group);
    } else {
      var doUpdateProps = curry$1(updateProps, axisPointerModel, moveAnimation);
      this.updatePointerEl(group, elOption, doUpdateProps);
      this.updateLabelEl(group, elOption, doUpdateProps, axisPointerModel);
    }
    updateMandatoryProps(group, axisPointerModel, true);
    this._renderHandle(value);
  };
  BaseAxisPointer2.prototype.remove = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.dispose = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.determineAnimation = function(axisModel, axisPointerModel) {
    var animation = axisPointerModel.get("animation");
    var axis = axisModel.axis;
    var isCategoryAxis = axis.type === "category";
    var useSnap = axisPointerModel.get("snap");
    if (!useSnap && !isCategoryAxis) {
      return false;
    }
    if (animation === "auto" || animation == null) {
      var animationThreshold = this.animationThreshold;
      if (isCategoryAxis && axis.getBandWidth() > animationThreshold) {
        return true;
      }
      if (useSnap) {
        var seriesDataCount = getAxisInfo$1(axisModel).seriesDataCount;
        var axisExtent = axis.getExtent();
        return Math.abs(axisExtent[0] - axisExtent[1]) / seriesDataCount > animationThreshold;
      }
      return false;
    }
    return animation === true;
  };
  BaseAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
  };
  BaseAxisPointer2.prototype.createPointerEl = function(group, elOption, axisModel, axisPointerModel) {
    var pointerOption = elOption.pointer;
    if (pointerOption) {
      var pointerEl = inner$b(group).pointerEl = new graphic[pointerOption.type](clone$1(elOption.pointer));
      group.add(pointerEl);
    }
  };
  BaseAxisPointer2.prototype.createLabelEl = function(group, elOption, axisModel, axisPointerModel) {
    if (elOption.label) {
      var labelEl = inner$b(group).labelEl = new ZRText$1(clone$1(elOption.label));
      group.add(labelEl);
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype.updatePointerEl = function(group, elOption, updateProps2) {
    var pointerEl = inner$b(group).pointerEl;
    if (pointerEl && elOption.pointer) {
      pointerEl.setStyle(elOption.pointer.style);
      updateProps2(pointerEl, {
        shape: elOption.pointer.shape
      });
    }
  };
  BaseAxisPointer2.prototype.updateLabelEl = function(group, elOption, updateProps2, axisPointerModel) {
    var labelEl = inner$b(group).labelEl;
    if (labelEl) {
      labelEl.setStyle(elOption.label.style);
      updateProps2(labelEl, {
        x: elOption.label.x,
        y: elOption.label.y
      });
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype._renderHandle = function(value) {
    if (this._dragging || !this.updateHandleTransform) {
      return;
    }
    var axisPointerModel = this._axisPointerModel;
    var zr = this._api.getZr();
    var handle = this._handle;
    var handleModel = axisPointerModel.getModel("handle");
    var status = axisPointerModel.get("status");
    if (!handleModel.get("show") || !status || status === "hide") {
      handle && zr.remove(handle);
      this._handle = null;
      return;
    }
    var isInit;
    if (!this._handle) {
      isInit = true;
      handle = this._handle = createIcon(handleModel.get("icon"), {
        cursor: "move",
        draggable: true,
        onmousemove: function(e2) {
          stop(e2.event);
        },
        onmousedown: bind(this._onHandleDragMove, this, 0, 0),
        drift: bind(this._onHandleDragMove, this),
        ondragend: bind(this._onHandleDragEnd, this)
      });
      zr.add(handle);
    }
    updateMandatoryProps(handle, axisPointerModel, false);
    handle.setStyle(handleModel.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
    var handleSize = handleModel.get("size");
    if (!isArray$1(handleSize)) {
      handleSize = [handleSize, handleSize];
    }
    handle.scaleX = handleSize[0] / 2;
    handle.scaleY = handleSize[1] / 2;
    createOrUpdate(this, "_doDispatchAxisPointer", handleModel.get("throttle") || 0, "fixRate");
    this._moveHandleToValue(value, isInit);
  };
  BaseAxisPointer2.prototype._moveHandleToValue = function(value, isInit) {
    updateProps(this._axisPointerModel, !isInit && this._moveAnimation, this._handle, getHandleTransProps(this.getHandleTransform(value, this._axisModel, this._axisPointerModel)));
  };
  BaseAxisPointer2.prototype._onHandleDragMove = function(dx, dy) {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    this._dragging = true;
    var trans = this.updateHandleTransform(getHandleTransProps(handle), [dx, dy], this._axisModel, this._axisPointerModel);
    this._payloadInfo = trans;
    handle.stopAnimation();
    handle.attr(getHandleTransProps(trans));
    inner$b(handle).lastProp = null;
    this._doDispatchAxisPointer();
  };
  BaseAxisPointer2.prototype._doDispatchAxisPointer = function() {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var payloadInfo = this._payloadInfo;
    var axisModel = this._axisModel;
    this._api.dispatchAction({
      type: "updateAxisPointer",
      x: payloadInfo.cursorPoint[0],
      y: payloadInfo.cursorPoint[1],
      tooltipOption: payloadInfo.tooltipOption,
      axesInfo: [{
        axisDim: axisModel.axis.dim,
        axisIndex: axisModel.componentIndex
      }]
    });
  };
  BaseAxisPointer2.prototype._onHandleDragEnd = function() {
    this._dragging = false;
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var value = this._axisPointerModel.get("value");
    this._moveHandleToValue(value);
    this._api.dispatchAction({
      type: "hideTip"
    });
  };
  BaseAxisPointer2.prototype.clear = function(api) {
    this._lastValue = null;
    this._lastStatus = null;
    var zr = api.getZr();
    var group = this._group;
    var handle = this._handle;
    if (zr && group) {
      this._lastGraphicKey = null;
      group && zr.remove(group);
      handle && zr.remove(handle);
      this._group = null;
      this._handle = null;
      this._payloadInfo = null;
    }
    clear$1(this, "_doDispatchAxisPointer");
  };
  BaseAxisPointer2.prototype.doClear = function() {
  };
  BaseAxisPointer2.prototype.buildLabel = function(xy, wh2, xDimIndex) {
    xDimIndex = xDimIndex || 0;
    return {
      x: xy[xDimIndex],
      y: xy[1 - xDimIndex],
      width: wh2[xDimIndex],
      height: wh2[1 - xDimIndex]
    };
  };
  return BaseAxisPointer2;
}();
function updateProps(animationModel, moveAnimation, el, props) {
  if (!propsEqual(inner$b(el).lastProp, props)) {
    inner$b(el).lastProp = props;
    moveAnimation ? updateProps$1(el, props, animationModel) : (el.stopAnimation(), el.attr(props));
  }
}
function propsEqual(lastProps, newProps) {
  if (isObject$4(lastProps) && isObject$4(newProps)) {
    var equals_1 = true;
    each$g(newProps, function(item, key) {
      equals_1 = equals_1 && propsEqual(lastProps[key], item);
    });
    return !!equals_1;
  } else {
    return lastProps === newProps;
  }
}
function updateLabelShowHide(labelEl, axisPointerModel) {
  labelEl[axisPointerModel.get(["label", "show"]) ? "show" : "hide"]();
}
function getHandleTransProps(trans) {
  return {
    x: trans.x || 0,
    y: trans.y || 0,
    rotation: trans.rotation || 0
  };
}
function updateMandatoryProps(group, axisPointerModel, silent) {
  var z2 = axisPointerModel.get("z");
  var zlevel = axisPointerModel.get("zlevel");
  group && group.traverse(function(el) {
    if (el.type !== "group") {
      z2 != null && (el.z = z2);
      zlevel != null && (el.zlevel = zlevel);
      el.silent = silent;
    }
  });
}
var BaseAxisPointer$1 = BaseAxisPointer;
function buildElStyle(axisPointerModel) {
  var axisPointerType = axisPointerModel.get("type");
  var styleModel = axisPointerModel.getModel(axisPointerType + "Style");
  var style2;
  if (axisPointerType === "line") {
    style2 = styleModel.getLineStyle();
    style2.fill = null;
  } else if (axisPointerType === "shadow") {
    style2 = styleModel.getAreaStyle();
    style2.stroke = null;
  }
  return style2;
}
function buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos) {
  var value = axisPointerModel.get("value");
  var text = getValueLabel(value, axisModel.axis, axisModel.ecModel, axisPointerModel.get("seriesDataIndices"), {
    precision: axisPointerModel.get(["label", "precision"]),
    formatter: axisPointerModel.get(["label", "formatter"])
  });
  var labelModel = axisPointerModel.getModel("label");
  var paddings = normalizeCssArray(labelModel.get("padding") || 0);
  var font = labelModel.getFont();
  var textRect = getBoundingRect(text, font);
  var position2 = labelPos.position;
  var width = textRect.width + paddings[1] + paddings[3];
  var height = textRect.height + paddings[0] + paddings[2];
  var align = labelPos.align;
  align === "right" && (position2[0] -= width);
  align === "center" && (position2[0] -= width / 2);
  var verticalAlign = labelPos.verticalAlign;
  verticalAlign === "bottom" && (position2[1] -= height);
  verticalAlign === "middle" && (position2[1] -= height / 2);
  confineInContainer(position2, width, height, api);
  var bgColor = labelModel.get("backgroundColor");
  if (!bgColor || bgColor === "auto") {
    bgColor = axisModel.get(["axisLine", "lineStyle", "color"]);
  }
  elOption.label = {
    x: position2[0],
    y: position2[1],
    style: createTextStyle(labelModel, {
      text,
      font,
      fill: labelModel.getTextColor(),
      padding: paddings,
      backgroundColor: bgColor
    }),
    z2: 10
  };
}
function confineInContainer(position2, width, height, api) {
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  position2[0] = Math.min(position2[0] + width, viewWidth) - width;
  position2[1] = Math.min(position2[1] + height, viewHeight) - height;
  position2[0] = Math.max(position2[0], 0);
  position2[1] = Math.max(position2[1], 0);
}
function getValueLabel(value, axis, ecModel, seriesDataIndices, opt) {
  value = axis.scale.parse(value);
  var text = axis.scale.getLabel({
    value
  }, {
    precision: opt.precision
  });
  var formatter = opt.formatter;
  if (formatter) {
    var params_1 = {
      value: getAxisRawValue(axis, {
        value
      }),
      axisDimension: axis.dim,
      axisIndex: axis.index,
      seriesData: []
    };
    each$g(seriesDataIndices, function(idxItem) {
      var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
      var dataIndex = idxItem.dataIndexInside;
      var dataParams = series && series.getDataParams(dataIndex);
      dataParams && params_1.seriesData.push(dataParams);
    });
    if (isString$1(formatter)) {
      text = formatter.replace("{value}", text);
    } else if (isFunction(formatter)) {
      text = formatter(params_1);
    }
  }
  return text;
}
function getTransformedPosition(axis, value, layoutInfo) {
  var transform2 = create$1();
  rotate(transform2, transform2, layoutInfo.rotation);
  translate(transform2, transform2, layoutInfo.position);
  return applyTransform([axis.dataToCoord(value), (layoutInfo.labelOffset || 0) + (layoutInfo.labelDirection || 1) * (layoutInfo.labelMargin || 0)], transform2);
}
function buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api) {
  var textLayout = AxisBuilder$1.innerTextLayout(layoutInfo.rotation, 0, layoutInfo.labelDirection);
  layoutInfo.labelMargin = axisPointerModel.get(["label", "margin"]);
  buildLabelElOption(elOption, axisModel, axisPointerModel, api, {
    position: getTransformedPosition(axisModel.axis, value, layoutInfo),
    align: textLayout.textAlign,
    verticalAlign: textLayout.textVerticalAlign
  });
}
function makeLineShape(p1, p2, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x1: p1[xDimIndex],
    y1: p1[1 - xDimIndex],
    x2: p2[xDimIndex],
    y2: p2[1 - xDimIndex]
  };
}
function makeRectShape(xy, wh2, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x: xy[xDimIndex],
    y: xy[1 - xDimIndex],
    width: wh2[xDimIndex],
    height: wh2[1 - xDimIndex]
  };
}
function makeSectorShape(cx, cy, r0, r2, startAngle, endAngle) {
  return {
    cx,
    cy,
    r0,
    r: r2,
    startAngle,
    endAngle,
    clockwise: true
  };
}
var CartesianAxisPointer = function(_super) {
  __extends(CartesianAxisPointer2, _super);
  function CartesianAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisPointerType = axisPointerModel.get("type");
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var pixelValue = axis.toGlobalCoord(axis.dataToCoord(value, true));
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$2[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$2(grid.model, axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  CartesianAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$2(axisModel.axis.grid.model, axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var pos = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: pos[0],
      y: pos[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  CartesianAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisExtent = axis.getGlobalExtent(true);
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var dimIndex = axis.dim === "x" ? 0 : 1;
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    var tooltipOptions = [{
      verticalAlign: "middle"
    }, {
      align: "center"
    }];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: tooltipOptions[dimIndex]
    };
  };
  return CartesianAxisPointer2;
}(BaseAxisPointer$1);
function getCartesian(grid, axis) {
  var opt = {};
  opt[axis.dim + "AxisIndex"] = axis.index;
  return grid.getCartesian(opt);
}
var pointerShapeBuilder$2 = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getAxisDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getAxisDimIndex(axis))
    };
  }
};
function getAxisDimIndex(axis) {
  return axis.dim === "x" ? 0 : 1;
}
var CartesianAxisPointer$1 = CartesianAxisPointer;
var AxisPointerModel = function(_super) {
  __extends(AxisPointerModel2, _super);
  function AxisPointerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerModel2.type;
    return _this;
  }
  AxisPointerModel2.type = "axisPointer";
  AxisPointerModel2.defaultOption = {
    show: "auto",
    z: 50,
    type: "line",
    snap: false,
    triggerTooltip: true,
    value: null,
    status: null,
    link: [],
    animation: null,
    animationDurationUpdate: 200,
    lineStyle: {
      color: "#B9BEC9",
      width: 1,
      type: "dashed"
    },
    shadowStyle: {
      color: "rgba(210,219,238,0.2)"
    },
    label: {
      show: true,
      formatter: null,
      precision: "auto",
      margin: 3,
      color: "#fff",
      padding: [5, 7, 5, 7],
      backgroundColor: "auto",
      borderColor: null,
      borderWidth: 0,
      borderRadius: 3
    },
    handle: {
      show: false,
      icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z",
      size: 45,
      margin: 50,
      color: "#333",
      shadowBlur: 3,
      shadowColor: "#aaa",
      shadowOffsetX: 0,
      shadowOffsetY: 2,
      throttle: 40
    }
  };
  return AxisPointerModel2;
}(ComponentModel$1);
var AxisPointerModel$1 = AxisPointerModel;
var inner$a = makeInner();
var each$9 = each$g;
function register(key, api, handler) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  inner$a(zr).records || (inner$a(zr).records = {});
  initGlobalListeners(zr, api);
  var record = inner$a(zr).records[key] || (inner$a(zr).records[key] = {});
  record.handler = handler;
}
function initGlobalListeners(zr, api) {
  if (inner$a(zr).initialized) {
    return;
  }
  inner$a(zr).initialized = true;
  useHandler("click", curry$1(doEnter, "click"));
  useHandler("mousemove", curry$1(doEnter, "mousemove"));
  useHandler("globalout", onLeave);
  function useHandler(eventType, cb2) {
    zr.on(eventType, function(e2) {
      var dis = makeDispatchAction$1(api);
      each$9(inner$a(zr).records, function(record) {
        record && cb2(record, e2, dis.dispatchAction);
      });
      dispatchTooltipFinally(dis.pendings, api);
    });
  }
}
function dispatchTooltipFinally(pendings, api) {
  var showLen = pendings.showTip.length;
  var hideLen = pendings.hideTip.length;
  var actuallyPayload;
  if (showLen) {
    actuallyPayload = pendings.showTip[showLen - 1];
  } else if (hideLen) {
    actuallyPayload = pendings.hideTip[hideLen - 1];
  }
  if (actuallyPayload) {
    actuallyPayload.dispatchAction = null;
    api.dispatchAction(actuallyPayload);
  }
}
function onLeave(record, e2, dispatchAction2) {
  record.handler("leave", null, dispatchAction2);
}
function doEnter(currTrigger, record, e2, dispatchAction2) {
  record.handler(currTrigger, e2, dispatchAction2);
}
function makeDispatchAction$1(api) {
  var pendings = {
    showTip: [],
    hideTip: []
  };
  var dispatchAction2 = function(payload) {
    var pendingList = pendings[payload.type];
    if (pendingList) {
      pendingList.push(payload);
    } else {
      payload.dispatchAction = dispatchAction2;
      api.dispatchAction(payload);
    }
  };
  return {
    dispatchAction: dispatchAction2,
    pendings
  };
}
function unregister(key, api) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  var record = (inner$a(zr).records || {})[key];
  if (record) {
    inner$a(zr).records[key] = null;
  }
}
var AxisPointerView = function(_super) {
  __extends(AxisPointerView2, _super);
  function AxisPointerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerView2.type;
    return _this;
  }
  AxisPointerView2.prototype.render = function(globalAxisPointerModel, ecModel, api) {
    var globalTooltipModel = ecModel.getComponent("tooltip");
    var triggerOn = globalAxisPointerModel.get("triggerOn") || globalTooltipModel && globalTooltipModel.get("triggerOn") || "mousemove|click";
    register("axisPointer", api, function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none" && (currTrigger === "leave" || triggerOn.indexOf(currTrigger) >= 0)) {
        dispatchAction2({
          type: "updateAxisPointer",
          currTrigger,
          x: e2 && e2.offsetX,
          y: e2 && e2.offsetY
        });
      }
    });
  };
  AxisPointerView2.prototype.remove = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.prototype.dispose = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.type = "axisPointer";
  return AxisPointerView2;
}(ComponentView$1);
var AxisPointerView$1 = AxisPointerView;
function findPointFromSeries(finder, ecModel) {
  var point = [];
  var seriesIndex = finder.seriesIndex;
  var seriesModel;
  if (seriesIndex == null || !(seriesModel = ecModel.getSeriesByIndex(seriesIndex))) {
    return {
      point: []
    };
  }
  var data = seriesModel.getData();
  var dataIndex = queryDataIndex(data, finder);
  if (dataIndex == null || dataIndex < 0 || isArray$1(dataIndex)) {
    return {
      point: []
    };
  }
  var el = data.getItemGraphicEl(dataIndex);
  var coordSys = seriesModel.coordinateSystem;
  if (seriesModel.getTooltipPosition) {
    point = seriesModel.getTooltipPosition(dataIndex) || [];
  } else if (coordSys && coordSys.dataToPoint) {
    if (finder.isStacked) {
      var baseAxis = coordSys.getBaseAxis();
      var valueAxis2 = coordSys.getOtherAxis(baseAxis);
      var valueAxisDim = valueAxis2.dim;
      var baseAxisDim = baseAxis.dim;
      var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
      var baseDim = data.mapDimension(baseAxisDim);
      var stackedData = [];
      stackedData[baseDataOffset] = data.get(baseDim, dataIndex);
      stackedData[1 - baseDataOffset] = data.get(data.getCalculationInfo("stackResultDimension"), dataIndex);
      point = coordSys.dataToPoint(stackedData) || [];
    } else {
      point = coordSys.dataToPoint(data.getValues(map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }), dataIndex)) || [];
    }
  } else if (el) {
    var rect = el.getBoundingRect().clone();
    rect.applyTransform(el.transform);
    point = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  }
  return {
    point,
    el
  };
}
var inner$9 = makeInner();
function axisTrigger(payload, ecModel, api) {
  var currTrigger = payload.currTrigger;
  var point = [payload.x, payload.y];
  var finder = payload;
  var dispatchAction2 = payload.dispatchAction || bind$1(api.dispatchAction, api);
  var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
  if (!coordSysAxesInfo) {
    return;
  }
  if (illegalPoint(point)) {
    point = findPointFromSeries({
      seriesIndex: finder.seriesIndex,
      dataIndex: finder.dataIndex
    }, ecModel).point;
  }
  var isIllegalPoint = illegalPoint(point);
  var inputAxesInfo = finder.axesInfo;
  var axesInfo = coordSysAxesInfo.axesInfo;
  var shouldHide = currTrigger === "leave" || illegalPoint(point);
  var outputPayload = {};
  var showValueMap = {};
  var dataByCoordSys = {
    list: [],
    map: {}
  };
  var updaters = {
    showPointer: curry$1(showPointer, showValueMap),
    showTooltip: curry$1(showTooltip, dataByCoordSys)
  };
  each$g(coordSysAxesInfo.coordSysMap, function(coordSys, coordSysKey) {
    var coordSysContainsPoint = isIllegalPoint || coordSys.containPoint(point);
    each$g(coordSysAxesInfo.coordSysAxesInfo[coordSysKey], function(axisInfo, key) {
      var axis = axisInfo.axis;
      var inputAxisInfo = findInputAxisInfo(inputAxesInfo, axisInfo);
      if (!shouldHide && coordSysContainsPoint && (!inputAxesInfo || inputAxisInfo)) {
        var val = inputAxisInfo && inputAxisInfo.value;
        if (val == null && !isIllegalPoint) {
          val = axis.pointToData(point);
        }
        val != null && processOnAxis(axisInfo, val, updaters, false, outputPayload);
      }
    });
  });
  var linkTriggers = {};
  each$g(axesInfo, function(tarAxisInfo, tarKey) {
    var linkGroup = tarAxisInfo.linkGroup;
    if (linkGroup && !showValueMap[tarKey]) {
      each$g(linkGroup.axesInfo, function(srcAxisInfo, srcKey) {
        var srcValItem = showValueMap[srcKey];
        if (srcAxisInfo !== tarAxisInfo && srcValItem) {
          var val = srcValItem.value;
          linkGroup.mapper && (val = tarAxisInfo.axis.scale.parse(linkGroup.mapper(val, makeMapperParam(srcAxisInfo), makeMapperParam(tarAxisInfo))));
          linkTriggers[tarAxisInfo.key] = val;
        }
      });
    }
  });
  each$g(linkTriggers, function(val, tarKey) {
    processOnAxis(axesInfo[tarKey], val, updaters, true, outputPayload);
  });
  updateModelActually(showValueMap, axesInfo, outputPayload);
  dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2);
  dispatchHighDownActually(axesInfo, dispatchAction2, api);
  return outputPayload;
}
function processOnAxis(axisInfo, newValue, updaters, noSnap, outputFinder) {
  var axis = axisInfo.axis;
  if (axis.scale.isBlank() || !axis.containData(newValue)) {
    return;
  }
  if (!axisInfo.involveSeries) {
    updaters.showPointer(axisInfo, newValue);
    return;
  }
  var payloadInfo = buildPayloadsBySeries(newValue, axisInfo);
  var payloadBatch = payloadInfo.payloadBatch;
  var snapToValue = payloadInfo.snapToValue;
  if (payloadBatch[0] && outputFinder.seriesIndex == null) {
    extend(outputFinder, payloadBatch[0]);
  }
  if (!noSnap && axisInfo.snap) {
    if (axis.containData(snapToValue) && snapToValue != null) {
      newValue = snapToValue;
    }
  }
  updaters.showPointer(axisInfo, newValue, payloadBatch);
  updaters.showTooltip(axisInfo, payloadInfo, snapToValue);
}
function buildPayloadsBySeries(value, axisInfo) {
  var axis = axisInfo.axis;
  var dim = axis.dim;
  var snapToValue = value;
  var payloadBatch = [];
  var minDist = Number.MAX_VALUE;
  var minDiff = -1;
  each$g(axisInfo.seriesModels, function(series, idx) {
    var dataDim = series.getData().mapDimensionsAll(dim);
    var seriesNestestValue;
    var dataIndices;
    if (series.getAxisTooltipData) {
      var result = series.getAxisTooltipData(dataDim, value, axis);
      dataIndices = result.dataIndices;
      seriesNestestValue = result.nestestValue;
    } else {
      dataIndices = series.getData().indicesOfNearest(dataDim[0], value, axis.type === "category" ? 0.5 : null);
      if (!dataIndices.length) {
        return;
      }
      seriesNestestValue = series.getData().get(dataDim[0], dataIndices[0]);
    }
    if (seriesNestestValue == null || !isFinite(seriesNestestValue)) {
      return;
    }
    var diff = value - seriesNestestValue;
    var dist2 = Math.abs(diff);
    if (dist2 <= minDist) {
      if (dist2 < minDist || diff >= 0 && minDiff < 0) {
        minDist = dist2;
        minDiff = diff;
        snapToValue = seriesNestestValue;
        payloadBatch.length = 0;
      }
      each$g(dataIndices, function(dataIndex) {
        payloadBatch.push({
          seriesIndex: series.seriesIndex,
          dataIndexInside: dataIndex,
          dataIndex: series.getData().getRawIndex(dataIndex)
        });
      });
    }
  });
  return {
    payloadBatch,
    snapToValue
  };
}
function showPointer(showValueMap, axisInfo, value, payloadBatch) {
  showValueMap[axisInfo.key] = {
    value,
    payloadBatch
  };
}
function showTooltip(dataByCoordSys, axisInfo, payloadInfo, value) {
  var payloadBatch = payloadInfo.payloadBatch;
  var axis = axisInfo.axis;
  var axisModel = axis.model;
  var axisPointerModel = axisInfo.axisPointerModel;
  if (!axisInfo.triggerTooltip || !payloadBatch.length) {
    return;
  }
  var coordSysModel = axisInfo.coordSys.model;
  var coordSysKey = makeKey(coordSysModel);
  var coordSysItem = dataByCoordSys.map[coordSysKey];
  if (!coordSysItem) {
    coordSysItem = dataByCoordSys.map[coordSysKey] = {
      coordSysId: coordSysModel.id,
      coordSysIndex: coordSysModel.componentIndex,
      coordSysType: coordSysModel.type,
      coordSysMainType: coordSysModel.mainType,
      dataByAxis: []
    };
    dataByCoordSys.list.push(coordSysItem);
  }
  coordSysItem.dataByAxis.push({
    axisDim: axis.dim,
    axisIndex: axisModel.componentIndex,
    axisType: axisModel.type,
    axisId: axisModel.id,
    value,
    valueLabelOpt: {
      precision: axisPointerModel.get(["label", "precision"]),
      formatter: axisPointerModel.get(["label", "formatter"])
    },
    seriesDataIndices: payloadBatch.slice()
  });
}
function updateModelActually(showValueMap, axesInfo, outputPayload) {
  var outputAxesInfo = outputPayload.axesInfo = [];
  each$g(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    var valItem = showValueMap[key];
    if (valItem) {
      !axisInfo.useHandle && (option.status = "show");
      option.value = valItem.value;
      option.seriesDataIndices = (valItem.payloadBatch || []).slice();
    } else {
      !axisInfo.useHandle && (option.status = "hide");
    }
    option.status === "show" && outputAxesInfo.push({
      axisDim: axisInfo.axis.dim,
      axisIndex: axisInfo.axis.model.componentIndex,
      value: option.value
    });
  });
}
function dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2) {
  if (illegalPoint(point) || !dataByCoordSys.list.length) {
    dispatchAction2({
      type: "hideTip"
    });
    return;
  }
  var sampleItem = ((dataByCoordSys.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
  dispatchAction2({
    type: "showTip",
    escapeConnect: true,
    x: point[0],
    y: point[1],
    tooltipOption: payload.tooltipOption,
    position: payload.position,
    dataIndexInside: sampleItem.dataIndexInside,
    dataIndex: sampleItem.dataIndex,
    seriesIndex: sampleItem.seriesIndex,
    dataByCoordSys: dataByCoordSys.list
  });
}
function dispatchHighDownActually(axesInfo, dispatchAction2, api) {
  var zr = api.getZr();
  var highDownKey = "axisPointerLastHighlights";
  var lastHighlights = inner$9(zr)[highDownKey] || {};
  var newHighlights = inner$9(zr)[highDownKey] = {};
  each$g(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    option.status === "show" && each$g(option.seriesDataIndices, function(batchItem) {
      var key2 = batchItem.seriesIndex + " | " + batchItem.dataIndex;
      newHighlights[key2] = batchItem;
    });
  });
  var toHighlight = [];
  var toDownplay = [];
  each$g(lastHighlights, function(batchItem, key) {
    !newHighlights[key] && toDownplay.push(batchItem);
  });
  each$g(newHighlights, function(batchItem, key) {
    !lastHighlights[key] && toHighlight.push(batchItem);
  });
  toDownplay.length && api.dispatchAction({
    type: "downplay",
    escapeConnect: true,
    notBlur: true,
    batch: toDownplay
  });
  toHighlight.length && api.dispatchAction({
    type: "highlight",
    escapeConnect: true,
    notBlur: true,
    batch: toHighlight
  });
}
function findInputAxisInfo(inputAxesInfo, axisInfo) {
  for (var i = 0; i < (inputAxesInfo || []).length; i++) {
    var inputAxisInfo = inputAxesInfo[i];
    if (axisInfo.axis.dim === inputAxisInfo.axisDim && axisInfo.axis.model.componentIndex === inputAxisInfo.axisIndex) {
      return inputAxisInfo;
    }
  }
}
function makeMapperParam(axisInfo) {
  var axisModel = axisInfo.axis.model;
  var item = {};
  var dim = item.axisDim = axisInfo.axis.dim;
  item.axisIndex = item[dim + "AxisIndex"] = axisModel.componentIndex;
  item.axisName = item[dim + "AxisName"] = axisModel.name;
  item.axisId = item[dim + "AxisId"] = axisModel.id;
  return item;
}
function illegalPoint(point) {
  return !point || point[0] == null || isNaN(point[0]) || point[1] == null || isNaN(point[1]);
}
function install$q(registers) {
  AxisView$1.registerAxisPointerClass("CartesianAxisPointer", CartesianAxisPointer$1);
  registers.registerComponentModel(AxisPointerModel$1);
  registers.registerComponentView(AxisPointerView$1);
  registers.registerPreprocessor(function(option) {
    if (option) {
      (!option.axisPointer || option.axisPointer.length === 0) && (option.axisPointer = {});
      var link = option.axisPointer.link;
      if (link && !isArray$1(link)) {
        option.axisPointer.link = [link];
      }
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, function(ecModel, api) {
    ecModel.getComponent("axisPointer").coordSysAxesInfo = collect(ecModel, api);
  });
  registers.registerAction({
    type: "updateAxisPointer",
    event: "updateAxisPointer",
    update: ":updateAxisPointer"
  }, axisTrigger);
}
function install$p(registers) {
  use(install$N);
  use(install$q);
}
var PolarAxisPointer = function(_super) {
  __extends(PolarAxisPointer2, _super);
  function PolarAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    if (axis.dim === "angle") {
      this.animationThreshold = Math.PI / 18;
    }
    var polar = axis.polar;
    var otherAxis = polar.getOtherAxis(axis);
    var otherExtent = otherAxis.getExtent();
    var coordValue = axis.dataToCoord(value);
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$1[axisPointerType](axis, polar, coordValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var labelMargin = axisPointerModel.get(["label", "margin"]);
    var labelPos = getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin);
    buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos);
  };
  return PolarAxisPointer2;
}(BaseAxisPointer$1);
function getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin) {
  var axis = axisModel.axis;
  var coord = axis.dataToCoord(value);
  var axisAngle = polar.getAngleAxis().getExtent()[0];
  axisAngle = axisAngle / 180 * Math.PI;
  var radiusExtent = polar.getRadiusAxis().getExtent();
  var position2;
  var align;
  var verticalAlign;
  if (axis.dim === "radius") {
    var transform2 = create$1();
    rotate(transform2, transform2, axisAngle);
    translate(transform2, transform2, [polar.cx, polar.cy]);
    position2 = applyTransform([coord, -labelMargin], transform2);
    var labelRotation = axisModel.getModel("axisLabel").get("rotate") || 0;
    var labelLayout2 = AxisBuilder$1.innerTextLayout(axisAngle, labelRotation * Math.PI / 180, -1);
    align = labelLayout2.textAlign;
    verticalAlign = labelLayout2.textVerticalAlign;
  } else {
    var r2 = radiusExtent[1];
    position2 = polar.coordToPoint([r2 + labelMargin, coord]);
    var cx = polar.cx;
    var cy = polar.cy;
    align = Math.abs(position2[0] - cx) / r2 < 0.3 ? "center" : position2[0] > cx ? "left" : "right";
    verticalAlign = Math.abs(position2[1] - cy) / r2 < 0.3 ? "middle" : position2[1] > cy ? "top" : "bottom";
  }
  return {
    position: position2,
    align,
    verticalAlign
  };
}
var pointerShapeBuilder$1 = {
  line: function(axis, polar, coordValue, otherExtent) {
    return axis.dim === "angle" ? {
      type: "Line",
      shape: makeLineShape(polar.coordToPoint([otherExtent[0], coordValue]), polar.coordToPoint([otherExtent[1], coordValue]))
    } : {
      type: "Circle",
      shape: {
        cx: polar.cx,
        cy: polar.cy,
        r: coordValue
      }
    };
  },
  shadow: function(axis, polar, coordValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var radian = Math.PI / 180;
    return axis.dim === "angle" ? {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, otherExtent[0], otherExtent[1], (-coordValue - bandWidth / 2) * radian, (-coordValue + bandWidth / 2) * radian)
    } : {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, coordValue - bandWidth / 2, coordValue + bandWidth / 2, 0, Math.PI * 2)
    };
  }
};
var PolarAxisPointer$1 = PolarAxisPointer;
var PolarModel = function(_super) {
  __extends(PolarModel2, _super);
  function PolarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarModel2.type;
    return _this;
  }
  PolarModel2.prototype.findAxisModel = function(axisType) {
    var foundAxisModel;
    var ecModel = this.ecModel;
    ecModel.eachComponent(axisType, function(axisModel) {
      if (axisModel.getCoordSysModel() === this) {
        foundAxisModel = axisModel;
      }
    }, this);
    return foundAxisModel;
  };
  PolarModel2.type = "polar";
  PolarModel2.dependencies = ["radiusAxis", "angleAxis"];
  PolarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "80%"
  };
  return PolarModel2;
}(ComponentModel$1);
var PolarModel$1 = PolarModel;
var PolarAxisModel = function(_super) {
  __extends(PolarAxisModel2, _super);
  function PolarAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("polar", SINGLE_REFERRING).models[0];
  };
  PolarAxisModel2.type = "polarAxis";
  return PolarAxisModel2;
}(ComponentModel$1);
mixin(PolarAxisModel, AxisModelCommonMixin);
var AngleAxisModel = function(_super) {
  __extends(AngleAxisModel2, _super);
  function AngleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisModel2.type;
    return _this;
  }
  AngleAxisModel2.type = "angleAxis";
  return AngleAxisModel2;
}(PolarAxisModel);
var RadiusAxisModel = function(_super) {
  __extends(RadiusAxisModel2, _super);
  function RadiusAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisModel2.type;
    return _this;
  }
  RadiusAxisModel2.type = "radiusAxis";
  return RadiusAxisModel2;
}(PolarAxisModel);
var RadiusAxis = function(_super) {
  __extends(RadiusAxis2, _super);
  function RadiusAxis2(scale2, radiusExtent) {
    return _super.call(this, "radius", scale2, radiusExtent) || this;
  }
  RadiusAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  return RadiusAxis2;
}(Axis$1);
RadiusAxis.prototype.dataToRadius = Axis$1.prototype.dataToCoord;
RadiusAxis.prototype.radiusToData = Axis$1.prototype.coordToData;
var RadiusAxis$1 = RadiusAxis;
var inner$8 = makeInner();
var AngleAxis = function(_super) {
  __extends(AngleAxis2, _super);
  function AngleAxis2(scale2, angleExtent) {
    return _super.call(this, "angle", scale2, angleExtent || [0, 360]) || this;
  }
  AngleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  AngleAxis2.prototype.calculateCategoryInterval = function() {
    var axis = this;
    var labelModel = axis.getLabelModel();
    var ordinalScale = axis.scale;
    var ordinalExtent = ordinalScale.getExtent();
    var tickCount = ordinalScale.count();
    if (ordinalExtent[1] - ordinalExtent[0] < 1) {
      return 0;
    }
    var tickValue = ordinalExtent[0];
    var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
    var unitH = Math.abs(unitSpan);
    var rect = getBoundingRect(tickValue == null ? "" : tickValue + "", labelModel.getFont(), "center", "top");
    var maxH = Math.max(rect.height, 7);
    var dh2 = maxH / unitH;
    isNaN(dh2) && (dh2 = Infinity);
    var interval = Math.max(0, Math.floor(dh2));
    var cache = inner$8(axis.model);
    var lastAutoInterval = cache.lastAutoInterval;
    var lastTickCount = cache.lastTickCount;
    if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval) {
      interval = lastAutoInterval;
    } else {
      cache.lastTickCount = tickCount;
      cache.lastAutoInterval = interval;
    }
    return interval;
  };
  return AngleAxis2;
}(Axis$1);
AngleAxis.prototype.dataToAngle = Axis$1.prototype.dataToCoord;
AngleAxis.prototype.angleToData = Axis$1.prototype.coordToData;
var AngleAxis$1 = AngleAxis;
var polarDimensions = ["radius", "angle"];
var Polar = function() {
  function Polar2(name) {
    this.dimensions = polarDimensions;
    this.type = "polar";
    this.cx = 0;
    this.cy = 0;
    this._radiusAxis = new RadiusAxis$1();
    this._angleAxis = new AngleAxis$1();
    this.axisPointerEnabled = true;
    this.name = name || "";
    this._radiusAxis.polar = this._angleAxis.polar = this;
  }
  Polar2.prototype.containPoint = function(point) {
    var coord = this.pointToCoord(point);
    return this._radiusAxis.contain(coord[0]) && this._angleAxis.contain(coord[1]);
  };
  Polar2.prototype.containData = function(data) {
    return this._radiusAxis.containData(data[0]) && this._angleAxis.containData(data[1]);
  };
  Polar2.prototype.getAxis = function(dim) {
    var key = "_" + dim + "Axis";
    return this[key];
  };
  Polar2.prototype.getAxes = function() {
    return [this._radiusAxis, this._angleAxis];
  };
  Polar2.prototype.getAxesByScale = function(scaleType) {
    var axes = [];
    var angleAxis = this._angleAxis;
    var radiusAxis = this._radiusAxis;
    angleAxis.scale.type === scaleType && axes.push(angleAxis);
    radiusAxis.scale.type === scaleType && axes.push(radiusAxis);
    return axes;
  };
  Polar2.prototype.getAngleAxis = function() {
    return this._angleAxis;
  };
  Polar2.prototype.getRadiusAxis = function() {
    return this._radiusAxis;
  };
  Polar2.prototype.getOtherAxis = function(axis) {
    var angleAxis = this._angleAxis;
    return axis === angleAxis ? this._radiusAxis : angleAxis;
  };
  Polar2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
  };
  Polar2.prototype.getTooltipAxes = function(dim) {
    var baseAxis = dim != null && dim !== "auto" ? this.getAxis(dim) : this.getBaseAxis();
    return {
      baseAxes: [baseAxis],
      otherAxes: [this.getOtherAxis(baseAxis)]
    };
  };
  Polar2.prototype.dataToPoint = function(data, clamp2) {
    return this.coordToPoint([this._radiusAxis.dataToRadius(data[0], clamp2), this._angleAxis.dataToAngle(data[1], clamp2)]);
  };
  Polar2.prototype.pointToData = function(point, clamp2) {
    var coord = this.pointToCoord(point);
    return [this._radiusAxis.radiusToData(coord[0], clamp2), this._angleAxis.angleToData(coord[1], clamp2)];
  };
  Polar2.prototype.pointToCoord = function(point) {
    var dx = point[0] - this.cx;
    var dy = point[1] - this.cy;
    var angleAxis = this.getAngleAxis();
    var extent3 = angleAxis.getExtent();
    var minAngle = Math.min(extent3[0], extent3[1]);
    var maxAngle = Math.max(extent3[0], extent3[1]);
    angleAxis.inverse ? minAngle = maxAngle - 360 : maxAngle = minAngle + 360;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx) / Math.PI * 180;
    var dir3 = radian < minAngle ? 1 : -1;
    while (radian < minAngle || radian > maxAngle) {
      radian += dir3 * 360;
    }
    return [radius, radian];
  };
  Polar2.prototype.coordToPoint = function(coord) {
    var radius = coord[0];
    var radian = coord[1] / 180 * Math.PI;
    var x2 = Math.cos(radian) * radius + this.cx;
    var y2 = -Math.sin(radian) * radius + this.cy;
    return [x2, y2];
  };
  Polar2.prototype.getArea = function() {
    var angleAxis = this.getAngleAxis();
    var radiusAxis = this.getRadiusAxis();
    var radiusExtent = radiusAxis.getExtent().slice();
    radiusExtent[0] > radiusExtent[1] && radiusExtent.reverse();
    var angleExtent = angleAxis.getExtent();
    var RADIAN2 = Math.PI / 180;
    return {
      cx: this.cx,
      cy: this.cy,
      r0: radiusExtent[0],
      r: radiusExtent[1],
      startAngle: -angleExtent[0] * RADIAN2,
      endAngle: -angleExtent[1] * RADIAN2,
      clockwise: angleAxis.inverse,
      contain: function(x2, y2) {
        var dx = x2 - this.cx;
        var dy = y2 - this.cy;
        var d2 = dx * dx + dy * dy - 1e-4;
        var r2 = this.r;
        var r0 = this.r0;
        return d2 <= r2 * r2 && d2 >= r0 * r0;
      }
    };
  };
  Polar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Polar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Polar2;
}();
function getCoordSys$2(finder) {
  var seriesModel = finder.seriesModel;
  var polarModel = finder.polarModel;
  return polarModel && polarModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
var Polar$1 = Polar;
function resizePolar(polar, polarModel, api) {
  var center2 = polarModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  polar.cx = parsePercent(center2[0], width);
  polar.cy = parsePercent(center2[1], height);
  var radiusAxis = polar.getRadiusAxis();
  var size = Math.min(width, height) / 2;
  var radius = polarModel.get("radius");
  if (radius == null) {
    radius = [0, "100%"];
  } else if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  var parsedRadius = [parsePercent(radius[0], size), parsePercent(radius[1], size)];
  radiusAxis.inverse ? radiusAxis.setExtent(parsedRadius[1], parsedRadius[0]) : radiusAxis.setExtent(parsedRadius[0], parsedRadius[1]);
}
function updatePolarScale(ecModel, api) {
  var polar = this;
  var angleAxis = polar.getAngleAxis();
  var radiusAxis = polar.getRadiusAxis();
  angleAxis.scale.setExtent(Infinity, -Infinity);
  radiusAxis.scale.setExtent(Infinity, -Infinity);
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.coordinateSystem === polar) {
      var data_1 = seriesModel.getData();
      each$g(getDataDimensionsOnAxis(data_1, "radius"), function(dim) {
        radiusAxis.scale.unionExtentFromData(data_1, dim);
      });
      each$g(getDataDimensionsOnAxis(data_1, "angle"), function(dim) {
        angleAxis.scale.unionExtentFromData(data_1, dim);
      });
    }
  });
  niceScaleExtent(angleAxis.scale, angleAxis.model);
  niceScaleExtent(radiusAxis.scale, radiusAxis.model);
  if (angleAxis.type === "category" && !angleAxis.onBand) {
    var extent3 = angleAxis.getExtent();
    var diff = 360 / angleAxis.scale.count();
    angleAxis.inverse ? extent3[1] += diff : extent3[1] -= diff;
    angleAxis.setExtent(extent3[0], extent3[1]);
  }
}
function isAngleAxisModel(axisModel) {
  return axisModel.mainType === "angleAxis";
}
function setAxis(axis, axisModel) {
  axis.type = axisModel.get("type");
  axis.scale = createScaleByModel$1(axisModel);
  axis.onBand = axisModel.get("boundaryGap") && axis.type === "category";
  axis.inverse = axisModel.get("inverse");
  if (isAngleAxisModel(axisModel)) {
    axis.inverse = axis.inverse !== axisModel.get("clockwise");
    var startAngle = axisModel.get("startAngle");
    axis.setExtent(startAngle, startAngle + (axis.inverse ? -360 : 360));
  }
  axisModel.axis = axis;
  axis.model = axisModel;
}
var polarCreator = {
  dimensions: polarDimensions,
  create: function(ecModel, api) {
    var polarList = [];
    ecModel.eachComponent("polar", function(polarModel, idx) {
      var polar = new Polar$1(idx + "");
      polar.update = updatePolarScale;
      var radiusAxis = polar.getRadiusAxis();
      var angleAxis = polar.getAngleAxis();
      var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
      var angleAxisModel = polarModel.findAxisModel("angleAxis");
      setAxis(radiusAxis, radiusAxisModel);
      setAxis(angleAxis, angleAxisModel);
      resizePolar(polar, polarModel, api);
      polarList.push(polar);
      polarModel.coordinateSystem = polar;
      polar.model = polarModel;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.get("coordinateSystem") === "polar") {
        var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
        seriesModel.coordinateSystem = polarModel.coordinateSystem;
      }
    });
    return polarList;
  }
};
var polarCreator$1 = polarCreator;
var elementList = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
function getAxisLineShape(polar, rExtent, angle) {
  rExtent[1] > rExtent[0] && (rExtent = rExtent.slice().reverse());
  var start2 = polar.coordToPoint([rExtent[0], angle]);
  var end2 = polar.coordToPoint([rExtent[1], angle]);
  return {
    x1: start2[0],
    y1: start2[1],
    x2: end2[0],
    y2: end2[1]
  };
}
function getRadiusIdx(polar) {
  var radiusAxis = polar.getRadiusAxis();
  return radiusAxis.inverse ? 0 : 1;
}
function fixAngleOverlap(list) {
  var firstItem = list[0];
  var lastItem = list[list.length - 1];
  if (firstItem && lastItem && Math.abs(Math.abs(firstItem.coord - lastItem.coord) - 360) < 1e-4) {
    list.pop();
  }
}
var AngleAxisView = function(_super) {
  __extends(AngleAxisView2, _super);
  function AngleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  AngleAxisView2.prototype.render = function(angleAxisModel, ecModel) {
    this.group.removeAll();
    if (!angleAxisModel.get("show")) {
      return;
    }
    var angleAxis = angleAxisModel.axis;
    var polar = angleAxis.polar;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var ticksAngles = angleAxis.getTicksCoords();
    var minorTickAngles = angleAxis.getMinorTicksCoords();
    var labels = map$1(angleAxis.getViewLabels(), function(labelItem) {
      labelItem = clone$4(labelItem);
      var scale2 = angleAxis.scale;
      var tickValue = scale2.type === "ordinal" ? scale2.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
      labelItem.coord = angleAxis.dataToCoord(tickValue);
      return labelItem;
    });
    fixAngleOverlap(labels);
    fixAngleOverlap(ticksAngles);
    each$g(elementList, function(name) {
      if (angleAxisModel.get([name, "show"]) && (!angleAxis.scale.isBlank() || name === "axisLine")) {
        angelAxisElementsBuilders[name](this.group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels);
      }
    }, this);
  };
  AngleAxisView2.type = "angleAxis";
  return AngleAxisView2;
}(AxisView$1);
var angelAxisElementsBuilders = {
  axisLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var lineStyleModel = angleAxisModel.getModel(["axisLine", "lineStyle"]);
    var rId = getRadiusIdx(polar);
    var r0Id = rId ? 0 : 1;
    var shape;
    if (radiusExtent[r0Id] === 0) {
      shape = new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    } else {
      shape = new Ring$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId],
          r0: radiusExtent[r0Id]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    }
    shape.style.fill = null;
    group.add(shape);
  },
  axisTick: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var tickModel = angleAxisModel.getModel("axisTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * tickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = map$1(ticksAngles, function(tickAngleItem) {
      return new Line$3({
        shape: getAxisLineShape(polar, [radius, radius + tickLen], tickAngleItem.coord)
      });
    });
    group.add(mergePath(lines, {
      style: defaults(tickModel.getModel("lineStyle").getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      })
    }));
  },
  minorTick: function(group, angleAxisModel, polar, tickAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var tickModel = angleAxisModel.getModel("axisTick");
    var minorTickModel = angleAxisModel.getModel("minorTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * minorTickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, [radius, radius + tickLen], minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults(minorTickModel.getModel("lineStyle").getLineStyle(), defaults(tickModel.getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      }))
    }));
  },
  axisLabel: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels) {
    var rawCategoryData = angleAxisModel.getCategories(true);
    var commonLabelModel = angleAxisModel.getModel("axisLabel");
    var labelMargin = commonLabelModel.get("margin");
    var triggerEvent = angleAxisModel.get("triggerEvent");
    each$g(labels, function(labelItem, idx) {
      var labelModel = commonLabelModel;
      var tickValue = labelItem.tickValue;
      var r2 = radiusExtent[getRadiusIdx(polar)];
      var p2 = polar.coordToPoint([r2 + labelMargin, labelItem.coord]);
      var cx = polar.cx;
      var cy = polar.cy;
      var labelTextAlign = Math.abs(p2[0] - cx) / r2 < 0.3 ? "center" : p2[0] > cx ? "left" : "right";
      var labelTextVerticalAlign = Math.abs(p2[1] - cy) / r2 < 0.3 ? "middle" : p2[1] > cy ? "top" : "bottom";
      if (rawCategoryData && rawCategoryData[tickValue]) {
        var rawCategoryItem = rawCategoryData[tickValue];
        if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
          labelModel = new Model$1(rawCategoryItem.textStyle, commonLabelModel, commonLabelModel.ecModel);
        }
      }
      var textEl = new ZRText$1({
        silent: AxisBuilder$1.isLabelSilent(angleAxisModel),
        style: createTextStyle(labelModel, {
          x: p2[0],
          y: p2[1],
          fill: labelModel.getTextColor() || angleAxisModel.get(["axisLine", "lineStyle", "color"]),
          text: labelItem.formattedLabel,
          align: labelTextAlign,
          verticalAlign: labelTextVerticalAlign
        })
      });
      group.add(textEl);
      if (triggerEvent) {
        var eventData = AxisBuilder$1.makeAxisEventDataBase(angleAxisModel);
        eventData.targetType = "axisLabel";
        eventData.value = labelItem.rawLabel;
        getECData(textEl).eventData = eventData;
      }
    }, this);
  },
  splitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var splitLineModel = angleAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksAngles.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        shape: getAxisLineShape(polar, radiusExtent, ticksAngles[i].coord)
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyleModel.getLineStyle()),
        silent: true,
        z: angleAxisModel.get("z")
      }));
    }
  },
  minorSplitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var minorSplitLineModel = angleAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, radiusExtent, minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: lineStyleModel.getLineStyle(),
      silent: true,
      z: angleAxisModel.get("z")
    }));
  },
  splitArea: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!ticksAngles.length) {
      return;
    }
    var splitAreaModel = angleAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var RADIAN2 = Math.PI / 180;
    var prevAngle = -ticksAngles[0].coord * RADIAN2;
    var r0 = Math.min(radiusExtent[0], radiusExtent[1]);
    var r1 = Math.max(radiusExtent[0], radiusExtent[1]);
    var clockwise = angleAxisModel.get("clockwise");
    for (var i = 1, len2 = ticksAngles.length; i <= len2; i++) {
      var coord = i === len2 ? ticksAngles[0].coord : ticksAngles[i].coord;
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0,
          r: r1,
          startAngle: prevAngle,
          endAngle: -coord * RADIAN2,
          clockwise
        },
        silent: true
      }));
      prevAngle = -coord * RADIAN2;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
var AngleAxisView$1 = AngleAxisView;
var axisBuilderAttrs$1 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$1 = ["splitLine", "splitArea", "minorSplitLine"];
var RadiusAxisView = function(_super) {
  __extends(RadiusAxisView2, _super);
  function RadiusAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  RadiusAxisView2.prototype.render = function(radiusAxisModel, ecModel) {
    this.group.removeAll();
    if (!radiusAxisModel.get("show")) {
      return;
    }
    var oldAxisGroup = this._axisGroup;
    var newAxisGroup = this._axisGroup = new Group$6();
    this.group.add(newAxisGroup);
    var radiusAxis = radiusAxisModel.axis;
    var polar = radiusAxis.polar;
    var angleAxis = polar.getAngleAxis();
    var ticksCoords = radiusAxis.getTicksCoords();
    var minorTicksCoords = radiusAxis.getMinorTicksCoords();
    var axisAngle = angleAxis.getExtent()[0];
    var radiusExtent = radiusAxis.getExtent();
    var layout2 = layoutAxis(polar, radiusAxisModel, axisAngle);
    var axisBuilder = new AxisBuilder$1(radiusAxisModel, layout2);
    each$g(axisBuilderAttrs$1, axisBuilder.add, axisBuilder);
    newAxisGroup.add(axisBuilder.getGroup());
    groupTransition(oldAxisGroup, newAxisGroup, radiusAxisModel);
    each$g(selfBuilderAttrs$1, function(name) {
      if (radiusAxisModel.get([name, "show"]) && !radiusAxis.scale.isBlank()) {
        axisElementBuilders$1[name](this.group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords);
      }
    }, this);
  };
  RadiusAxisView2.type = "radiusAxis";
  return RadiusAxisView2;
}(AxisView$1);
var axisElementBuilders$1 = {
  splitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    var splitLineModel = radiusAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: ticksCoords[i].coord
        }
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length],
          fill: null
        }, lineStyleModel.getLineStyle()),
        silent: true
      }));
    }
  },
  minorSplitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords) {
    if (!minorTicksCoords.length) {
      return;
    }
    var minorSplitLineModel = radiusAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        lines.push(new Circle$1({
          shape: {
            cx: polar.cx,
            cy: polar.cy,
            r: minorTicksCoords[i][k2].coord
          }
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults({
        fill: null
      }, lineStyleModel.getLineStyle()),
      silent: true
    }));
  },
  splitArea: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    if (!ticksCoords.length) {
      return;
    }
    var splitAreaModel = radiusAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var prevRadius = ticksCoords[0].coord;
    for (var i = 1; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0: prevRadius,
          r: ticksCoords[i].coord,
          startAngle: 0,
          endAngle: Math.PI * 2
        },
        silent: true
      }));
      prevRadius = ticksCoords[i].coord;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
function layoutAxis(polar, radiusAxisModel, axisAngle) {
  return {
    position: [polar.cx, polar.cy],
    rotation: axisAngle / 180 * Math.PI,
    labelDirection: -1,
    tickDirection: -1,
    nameDirection: 1,
    labelRotate: radiusAxisModel.getModel("axisLabel").get("rotate"),
    z2: 1
  };
}
var RadiusAxisView$1 = RadiusAxisView;
function getSeriesStackId(seriesModel) {
  return seriesModel.get("stack") || "__ec_stack_" + seriesModel.seriesIndex;
}
function getAxisKey(polar, axis) {
  return axis.dim + polar.model.componentIndex;
}
function barLayoutPolar(seriesType2, ecModel, api) {
  var lastStackCoords = {};
  var barWidthAndOffset = calRadialBar(filter(ecModel.getSeriesByType(seriesType2), function(seriesModel) {
    return !ecModel.isSeriesFiltered(seriesModel) && seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "polar";
  }));
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (seriesModel.coordinateSystem.type !== "polar") {
      return;
    }
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var stackId = getSeriesStackId(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[axisKey][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    var valueAxis2 = polar.getOtherAxis(baseAxis);
    var cx = seriesModel.coordinateSystem.cx;
    var cy = seriesModel.coordinateSystem.cy;
    var barMinHeight = seriesModel.get("barMinHeight") || 0;
    var barMinAngle = seriesModel.get("barMinAngle") || 0;
    lastStackCoords[stackId] = lastStackCoords[stackId] || [];
    var valueDim = data.mapDimension(valueAxis2.dim);
    var baseDim = data.mapDimension(baseAxis.dim);
    var stacked = isDimensionStacked(data, valueDim);
    var clampLayout = baseAxis.dim !== "radius" || !seriesModel.get("roundCap", true);
    var valueAxisStart = valueAxis2.dataToCoord(0);
    for (var idx = 0, len2 = data.count(); idx < len2; idx++) {
      var value = data.get(valueDim, idx);
      var baseValue = data.get(baseDim, idx);
      var sign = value >= 0 ? "p" : "n";
      var baseCoord = valueAxisStart;
      if (stacked) {
        if (!lastStackCoords[stackId][baseValue]) {
          lastStackCoords[stackId][baseValue] = {
            p: valueAxisStart,
            n: valueAxisStart
          };
        }
        baseCoord = lastStackCoords[stackId][baseValue][sign];
      }
      var r0 = void 0;
      var r2 = void 0;
      var startAngle = void 0;
      var endAngle = void 0;
      if (valueAxis2.dim === "radius") {
        var radiusSpan = valueAxis2.dataToCoord(value) - valueAxisStart;
        var angle = baseAxis.dataToCoord(baseValue);
        if (Math.abs(radiusSpan) < barMinHeight) {
          radiusSpan = (radiusSpan < 0 ? -1 : 1) * barMinHeight;
        }
        r0 = baseCoord;
        r2 = baseCoord + radiusSpan;
        startAngle = angle - columnOffset;
        endAngle = startAngle - columnWidth;
        stacked && (lastStackCoords[stackId][baseValue][sign] = r2);
      } else {
        var angleSpan = valueAxis2.dataToCoord(value, clampLayout) - valueAxisStart;
        var radius = baseAxis.dataToCoord(baseValue);
        if (Math.abs(angleSpan) < barMinAngle) {
          angleSpan = (angleSpan < 0 ? -1 : 1) * barMinAngle;
        }
        r0 = radius + columnOffset;
        r2 = r0 + columnWidth;
        startAngle = baseCoord;
        endAngle = baseCoord + angleSpan;
        stacked && (lastStackCoords[stackId][baseValue][sign] = endAngle);
      }
      data.setItemLayout(idx, {
        cx,
        cy,
        r0,
        r: r2,
        startAngle: -startAngle * Math.PI / 180,
        endAngle: -endAngle * Math.PI / 180,
        clockwise: startAngle >= endAngle
      });
    }
  });
}
function calRadialBar(barSeries) {
  var columnsMap = {};
  each$g(barSeries, function(seriesModel, idx) {
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var axisExtent = baseAxis.getExtent();
    var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: "20%",
      gap: "30%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = getSeriesStackId(seriesModel);
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    if (barWidth && !stacks[stackId].width) {
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      stacks[stackId].width = barWidth;
      columnsOnAxis.remainedWidth -= barWidth;
    }
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    barGap != null && (columnsOnAxis.gap = barGap);
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$g(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGap = parsePercent(columnsOnAxis.categoryGap, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$g(stacks, function(column, stack) {
      var maxWidth = column.maxWidth;
      if (maxWidth && maxWidth < autoWidth) {
        maxWidth = Math.min(maxWidth, remainedWidth);
        if (column.width) {
          maxWidth = Math.min(maxWidth, column.width);
        }
        remainedWidth -= maxWidth;
        column.width = maxWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$g(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset2 = -widthSum / 2;
    each$g(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        offset: offset2,
        width: column.width
      };
      offset2 += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
var angleAxisExtraOption = {
  startAngle: 90,
  clockwise: true,
  splitNumber: 12,
  axisLabel: {
    rotate: 0
  }
};
var radiusAxisExtraOption = {
  splitNumber: 5
};
var PolarView = function(_super) {
  __extends(PolarView2, _super);
  function PolarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarView2.type;
    return _this;
  }
  PolarView2.type = "polar";
  return PolarView2;
}(ComponentView$1);
function install$o(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("PolarAxisPointer", PolarAxisPointer$1);
  registers.registerCoordinateSystem("polar", polarCreator$1);
  registers.registerComponentModel(PolarModel$1);
  registers.registerComponentView(PolarView);
  axisModelCreator(registers, "angle", AngleAxisModel, angleAxisExtraOption);
  axisModelCreator(registers, "radius", RadiusAxisModel, radiusAxisExtraOption);
  registers.registerComponentView(AngleAxisView$1);
  registers.registerComponentView(RadiusAxisView$1);
  registers.registerLayout(curry$1(barLayoutPolar, "bar"));
}
function layout$1(axisModel, opt) {
  opt = opt || {};
  var single = axisModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var axisPosition = axis.position;
  var orient = axis.orient;
  var rect = single.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var positionMap = {
    horizontal: {
      top: rectBound[2],
      bottom: rectBound[3]
    },
    vertical: {
      left: rectBound[0],
      right: rectBound[1]
    }
  };
  layout2.position = [orient === "vertical" ? positionMap.vertical[axisPosition] : rectBound[0], orient === "horizontal" ? positionMap.horizontal[axisPosition] : rectBound[3]];
  var r2 = {
    horizontal: 0,
    vertical: 1
  };
  layout2.rotation = Math.PI / 2 * r2[orient];
  var directionMap = {
    top: -1,
    bottom: 1,
    right: 1,
    left: -1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = directionMap[axisPosition];
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotation = opt.rotate;
  labelRotation == null && (labelRotation = axisModel.get(["axisLabel", "rotate"]));
  layout2.labelRotation = axisPosition === "top" ? -labelRotation : labelRotation;
  layout2.z2 = 1;
  return layout2;
}
var axisBuilderAttrs = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs = ["splitArea", "splitLine"];
var SingleAxisView = function(_super) {
  __extends(SingleAxisView2, _super);
  function SingleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisView2.type;
    _this.axisPointerClass = "SingleAxisPointer";
    return _this;
  }
  SingleAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$6();
    var layout2 = layout$1(axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, layout2);
    each$g(axisBuilderAttrs, axisBuilder.add, axisBuilder);
    group.add(this._axisGroup);
    group.add(axisBuilder.getGroup());
    each$g(selfBuilderAttrs, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders[name](this, this.group, this._axisGroup, axisModel);
      }
    }, this);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  SingleAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  SingleAxisView2.type = "singleAxis";
  return SingleAxisView2;
}(AxisView$1);
var axisElementBuilders = {
  splitLine: function(axisView, group, axisGroup, axisModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var gridRect = axisModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var splitLines = [];
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    for (var i = 0; i < ticksCoords.length; ++i) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        subPixelOptimize: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        silent: true
      }));
    }
    var lineStyle = lineStyleModel.getLineStyle(["color"]);
    for (var i = 0; i < splitLines.length; ++i) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyle),
        silent: true
      }));
    }
  },
  splitArea: function(axisView, group, axisGroup, axisModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, axisModel);
  }
};
var SingleAxisView$1 = SingleAxisView;
var SingleAxisModel = function(_super) {
  __extends(SingleAxisModel2, _super);
  function SingleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisModel2.type;
    return _this;
  }
  SingleAxisModel2.prototype.getCoordSysModel = function() {
    return this;
  };
  SingleAxisModel2.type = "singleAxis";
  SingleAxisModel2.layoutMode = "box";
  SingleAxisModel2.defaultOption = {
    left: "5%",
    top: "5%",
    right: "5%",
    bottom: "5%",
    type: "value",
    position: "bottom",
    orient: "horizontal",
    axisLine: {
      show: true,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    tooltip: {
      show: true
    },
    axisTick: {
      show: true,
      length: 6,
      lineStyle: {
        width: 1
      }
    },
    axisLabel: {
      show: true,
      interval: "auto"
    },
    splitLine: {
      show: true,
      lineStyle: {
        type: "dashed",
        opacity: 0.2
      }
    }
  };
  return SingleAxisModel2;
}(ComponentModel$1);
mixin(SingleAxisModel, AxisModelCommonMixin.prototype);
var SingleAxisModel$1 = SingleAxisModel;
var SingleAxis = function(_super) {
  __extends(SingleAxis2, _super);
  function SingleAxis2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  SingleAxis2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  SingleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.coordinateSystem.pointToData(point)[0];
  };
  return SingleAxis2;
}(Axis$1);
var SingleAxis$1 = SingleAxis;
var singleDimensions = ["single"];
var Single = function() {
  function Single2(axisModel, ecModel, api) {
    this.type = "single";
    this.dimension = "single";
    this.dimensions = singleDimensions;
    this.axisPointerEnabled = true;
    this.model = axisModel;
    this._init(axisModel, ecModel, api);
  }
  Single2.prototype._init = function(axisModel, ecModel, api) {
    var dim = this.dimension;
    var axis = new SingleAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisModel.get("position"));
    var isCategory2 = axis.type === "category";
    axis.onBand = isCategory2 && axisModel.get("boundaryGap");
    axis.inverse = axisModel.get("inverse");
    axis.orient = axisModel.get("orient");
    axisModel.axis = axis;
    axis.model = axisModel;
    axis.coordinateSystem = this;
    this._axis = axis;
  };
  Single2.prototype.update = function(ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.coordinateSystem === this) {
        var data_1 = seriesModel.getData();
        each$g(data_1.mapDimensionsAll(this.dimension), function(dim) {
          this._axis.scale.unionExtentFromData(data_1, dim);
        }, this);
        niceScaleExtent(this._axis.scale, this._axis.model);
      }
    }, this);
  };
  Single2.prototype.resize = function(axisModel, api) {
    this._rect = getLayoutRect({
      left: axisModel.get("left"),
      top: axisModel.get("top"),
      right: axisModel.get("right"),
      bottom: axisModel.get("bottom"),
      width: axisModel.get("width"),
      height: axisModel.get("height")
    }, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._adjustAxis();
  };
  Single2.prototype.getRect = function() {
    return this._rect;
  };
  Single2.prototype._adjustAxis = function() {
    var rect = this._rect;
    var axis = this._axis;
    var isHorizontal = axis.isHorizontal();
    var extent3 = isHorizontal ? [0, rect.width] : [0, rect.height];
    var idx = axis.reverse ? 1 : 0;
    axis.setExtent(extent3[idx], extent3[1 - idx]);
    this._updateAxisTransform(axis, isHorizontal ? rect.x : rect.y);
  };
  Single2.prototype._updateAxisTransform = function(axis, coordBase) {
    var axisExtent = axis.getExtent();
    var extentSum = axisExtent[0] + axisExtent[1];
    var isHorizontal = axis.isHorizontal();
    axis.toGlobalCoord = isHorizontal ? function(coord) {
      return coord + coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
    axis.toLocalCoord = isHorizontal ? function(coord) {
      return coord - coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
  };
  Single2.prototype.getAxis = function() {
    return this._axis;
  };
  Single2.prototype.getBaseAxis = function() {
    return this._axis;
  };
  Single2.prototype.getAxes = function() {
    return [this._axis];
  };
  Single2.prototype.getTooltipAxes = function() {
    return {
      baseAxes: [this.getAxis()],
      otherAxes: []
    };
  };
  Single2.prototype.containPoint = function(point) {
    var rect = this.getRect();
    var axis = this.getAxis();
    var orient = axis.orient;
    if (orient === "horizontal") {
      return axis.contain(axis.toLocalCoord(point[0])) && point[1] >= rect.y && point[1] <= rect.y + rect.height;
    } else {
      return axis.contain(axis.toLocalCoord(point[1])) && point[0] >= rect.y && point[0] <= rect.y + rect.height;
    }
  };
  Single2.prototype.pointToData = function(point) {
    var axis = this.getAxis();
    return [axis.coordToData(axis.toLocalCoord(point[axis.orient === "horizontal" ? 0 : 1]))];
  };
  Single2.prototype.dataToPoint = function(val) {
    var axis = this.getAxis();
    var rect = this.getRect();
    var pt = [];
    var idx = axis.orient === "horizontal" ? 0 : 1;
    if (val instanceof Array) {
      val = val[0];
    }
    pt[idx] = axis.toGlobalCoord(axis.dataToCoord(+val));
    pt[1 - idx] = idx === 0 ? rect.y + rect.height / 2 : rect.x + rect.width / 2;
    return pt;
  };
  Single2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Single2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Single2;
}();
function getCoordSys$1(finder) {
  var seriesModel = finder.seriesModel;
  var singleModel = finder.singleAxisModel;
  return singleModel && singleModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
function create(ecModel, api) {
  var singles = [];
  ecModel.eachComponent("singleAxis", function(axisModel, idx) {
    var single = new Single(axisModel, ecModel, api);
    single.name = "single_" + idx;
    single.resize(axisModel, api);
    axisModel.coordinateSystem = single;
    singles.push(single);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "singleAxis") {
      var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = singleAxisModel && singleAxisModel.coordinateSystem;
    }
  });
  return singles;
}
var singleCreator = {
  create,
  dimensions: singleDimensions
};
var singleCreator$1 = singleCreator;
var XY$1 = ["x", "y"];
var WH$1 = ["width", "height"];
var SingleAxisPointer = function(_super) {
  __extends(SingleAxisPointer2, _super);
  function SingleAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SingleAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var otherExtent = getGlobalExtent(coordSys, 1 - getPointDimIndex(axis));
    var pixelValue = coordSys.dataToPoint(value)[0];
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$1(axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  SingleAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$1(axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var position2 = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: position2[0],
      y: position2[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  SingleAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var dimIndex = getPointDimIndex(axis);
    var axisExtent = getGlobalExtent(coordSys, dimIndex);
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var otherExtent = getGlobalExtent(coordSys, 1 - dimIndex);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: {
        verticalAlign: "middle"
      }
    };
  };
  return SingleAxisPointer2;
}(BaseAxisPointer$1);
var pointerShapeBuilder = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getPointDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = axis.getBandWidth();
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getPointDimIndex(axis))
    };
  }
};
function getPointDimIndex(axis) {
  return axis.isHorizontal() ? 0 : 1;
}
function getGlobalExtent(coordSys, dimIndex) {
  var rect = coordSys.getRect();
  return [rect[XY$1[dimIndex]], rect[XY$1[dimIndex]] + rect[WH$1[dimIndex]]];
}
var SingleAxisPointer$1 = SingleAxisPointer;
var SingleView = function(_super) {
  __extends(SingleView2, _super);
  function SingleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleView2.type;
    return _this;
  }
  SingleView2.type = "single";
  return SingleView2;
}(ComponentView$1);
function install$n(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("SingleAxisPointer", SingleAxisPointer$1);
  registers.registerComponentView(SingleView);
  registers.registerComponentView(SingleAxisView$1);
  registers.registerComponentModel(SingleAxisModel$1);
  axisModelCreator(registers, "single", SingleAxisModel$1, SingleAxisModel$1.defaultOption);
  registers.registerCoordinateSystem("single", singleCreator$1);
}
var CalendarModel = function(_super) {
  __extends(CalendarModel2, _super);
  function CalendarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarModel2.type;
    return _this;
  }
  CalendarModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(option, inputPositionParams);
  };
  CalendarModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(this.option, option);
  };
  CalendarModel2.prototype.getCellSize = function() {
    return this.option.cellSize;
  };
  CalendarModel2.type = "calendar";
  CalendarModel2.defaultOption = {
    z: 2,
    left: 80,
    top: 60,
    cellSize: 20,
    orient: "horizontal",
    splitLine: {
      show: true,
      lineStyle: {
        color: "#000",
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      color: "#fff",
      borderWidth: 1,
      borderColor: "#ccc"
    },
    dayLabel: {
      show: true,
      firstDay: 0,
      position: "start",
      margin: "50%",
      color: "#000"
    },
    monthLabel: {
      show: true,
      position: "start",
      margin: 5,
      align: "center",
      formatter: null,
      color: "#000"
    },
    yearLabel: {
      show: true,
      position: null,
      margin: 30,
      formatter: null,
      color: "#ccc",
      fontFamily: "sans-serif",
      fontWeight: "bolder",
      fontSize: 20
    }
  };
  return CalendarModel2;
}(ComponentModel$1);
function mergeAndNormalizeLayoutParams$1(target, raw) {
  var cellSize = target.cellSize;
  var cellSizeArr;
  if (!isArray$1(cellSize)) {
    cellSizeArr = target.cellSize = [cellSize, cellSize];
  } else {
    cellSizeArr = cellSize;
  }
  if (cellSizeArr.length === 1) {
    cellSizeArr[1] = cellSizeArr[0];
  }
  var ignoreSize = map$1([0, 1], function(hvIdx) {
    if (sizeCalculable(raw, hvIdx)) {
      cellSizeArr[hvIdx] = "auto";
    }
    return cellSizeArr[hvIdx] != null && cellSizeArr[hvIdx] !== "auto";
  });
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize
  });
}
var CalendarModel$1 = CalendarModel;
var CalendarView = function(_super) {
  __extends(CalendarView2, _super);
  function CalendarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarView2.type;
    return _this;
  }
  CalendarView2.prototype.render = function(calendarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    var coordSys = calendarModel.coordinateSystem;
    var rangeData = coordSys.getRangeInfo();
    var orient = coordSys.getOrient();
    var localeModel = ecModel.getLocaleModel();
    this._renderDayRect(calendarModel, rangeData, group);
    this._renderLines(calendarModel, rangeData, orient, group);
    this._renderYearText(calendarModel, rangeData, orient, group);
    this._renderMonthText(calendarModel, localeModel, orient, group);
    this._renderWeekText(calendarModel, localeModel, rangeData, orient, group);
  };
  CalendarView2.prototype._renderDayRect = function(calendarModel, rangeData, group) {
    var coordSys = calendarModel.coordinateSystem;
    var itemRectStyleModel = calendarModel.getModel("itemStyle").getItemStyle();
    var sw = coordSys.getCellWidth();
    var sh2 = coordSys.getCellHeight();
    for (var i = rangeData.start.time; i <= rangeData.end.time; i = coordSys.getNextNDay(i, 1).time) {
      var point = coordSys.dataToRect([i], false).tl;
      var rect = new Rect$3({
        shape: {
          x: point[0],
          y: point[1],
          width: sw,
          height: sh2
        },
        cursor: "default",
        style: itemRectStyleModel
      });
      group.add(rect);
    }
  };
  CalendarView2.prototype._renderLines = function(calendarModel, rangeData, orient, group) {
    var self2 = this;
    var coordSys = calendarModel.coordinateSystem;
    var lineStyleModel = calendarModel.getModel(["splitLine", "lineStyle"]).getLineStyle();
    var show = calendarModel.get(["splitLine", "show"]);
    var lineWidth = lineStyleModel.lineWidth;
    this._tlpoints = [];
    this._blpoints = [];
    this._firstDayOfMonth = [];
    this._firstDayPoints = [];
    var firstDay = rangeData.start;
    for (var i = 0; firstDay.time <= rangeData.end.time; i++) {
      addPoints(firstDay.formatedDate);
      if (i === 0) {
        firstDay = coordSys.getDateInfo(rangeData.start.y + "-" + rangeData.start.m);
      }
      var date4 = firstDay.date;
      date4.setMonth(date4.getMonth() + 1);
      firstDay = coordSys.getDateInfo(date4);
    }
    addPoints(coordSys.getNextNDay(rangeData.end.time, 1).formatedDate);
    function addPoints(date5) {
      self2._firstDayOfMonth.push(coordSys.getDateInfo(date5));
      self2._firstDayPoints.push(coordSys.dataToRect([date5], false).tl);
      var points2 = self2._getLinePointsOfOneWeek(calendarModel, date5, orient);
      self2._tlpoints.push(points2[0]);
      self2._blpoints.push(points2[points2.length - 1]);
      show && self2._drawSplitline(points2, lineStyleModel, group);
    }
    show && this._drawSplitline(self2._getEdgesPoints(self2._tlpoints, lineWidth, orient), lineStyleModel, group);
    show && this._drawSplitline(self2._getEdgesPoints(self2._blpoints, lineWidth, orient), lineStyleModel, group);
  };
  CalendarView2.prototype._getEdgesPoints = function(points2, lineWidth, orient) {
    var rs = [points2[0].slice(), points2[points2.length - 1].slice()];
    var idx = orient === "horizontal" ? 0 : 1;
    rs[0][idx] = rs[0][idx] - lineWidth / 2;
    rs[1][idx] = rs[1][idx] + lineWidth / 2;
    return rs;
  };
  CalendarView2.prototype._drawSplitline = function(points2, lineStyle, group) {
    var poyline = new Polyline$3({
      z2: 20,
      shape: {
        points: points2
      },
      style: lineStyle
    });
    group.add(poyline);
  };
  CalendarView2.prototype._getLinePointsOfOneWeek = function(calendarModel, date4, orient) {
    var coordSys = calendarModel.coordinateSystem;
    var parsedDate = coordSys.getDateInfo(date4);
    var points2 = [];
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(parsedDate.time, i);
      var point = coordSys.dataToRect([tmpD.time], false);
      points2[2 * tmpD.day] = point.tl;
      points2[2 * tmpD.day + 1] = point[orient === "horizontal" ? "bl" : "tr"];
    }
    return points2;
  };
  CalendarView2.prototype._formatterLabel = function(formatter, params) {
    if (isString$1(formatter) && formatter) {
      return formatTplSimple(formatter, params);
    }
    if (isFunction(formatter)) {
      return formatter(params);
    }
    return params.nameMap;
  };
  CalendarView2.prototype._yearTextPositionControl = function(textEl, point, orient, position2, margin) {
    var x2 = point[0];
    var y2 = point[1];
    var aligns = ["center", "bottom"];
    if (position2 === "bottom") {
      y2 += margin;
      aligns = ["center", "top"];
    } else if (position2 === "left") {
      x2 -= margin;
    } else if (position2 === "right") {
      x2 += margin;
      aligns = ["center", "top"];
    } else {
      y2 -= margin;
    }
    var rotate2 = 0;
    if (position2 === "left" || position2 === "right") {
      rotate2 = Math.PI / 2;
    }
    return {
      rotation: rotate2,
      x: x2,
      y: y2,
      style: {
        align: aligns[0],
        verticalAlign: aligns[1]
      }
    };
  };
  CalendarView2.prototype._renderYearText = function(calendarModel, rangeData, orient, group) {
    var yearLabel = calendarModel.getModel("yearLabel");
    if (!yearLabel.get("show")) {
      return;
    }
    var margin = yearLabel.get("margin");
    var pos = yearLabel.get("position");
    if (!pos) {
      pos = orient !== "horizontal" ? "top" : "left";
    }
    var points2 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]];
    var xc2 = (points2[0][0] + points2[1][0]) / 2;
    var yc2 = (points2[0][1] + points2[1][1]) / 2;
    var idx = orient === "horizontal" ? 0 : 1;
    var posPoints = {
      top: [xc2, points2[idx][1]],
      bottom: [xc2, points2[1 - idx][1]],
      left: [points2[1 - idx][0], yc2],
      right: [points2[idx][0], yc2]
    };
    var name = rangeData.start.y;
    if (+rangeData.end.y > +rangeData.start.y) {
      name = name + "-" + rangeData.end.y;
    }
    var formatter = yearLabel.get("formatter");
    var params = {
      start: rangeData.start.y,
      end: rangeData.end.y,
      nameMap: name
    };
    var content = this._formatterLabel(formatter, params);
    var yearText = new ZRText$1({
      z2: 30,
      style: createTextStyle(yearLabel, {
        text: content
      })
    });
    yearText.attr(this._yearTextPositionControl(yearText, posPoints[pos], orient, pos, margin));
    group.add(yearText);
  };
  CalendarView2.prototype._monthTextPositionControl = function(point, isCenter, orient, position2, margin) {
    var align = "left";
    var vAlign = "top";
    var x2 = point[0];
    var y2 = point[1];
    if (orient === "horizontal") {
      y2 = y2 + margin;
      if (isCenter) {
        align = "center";
      }
      if (position2 === "start") {
        vAlign = "bottom";
      }
    } else {
      x2 = x2 + margin;
      if (isCenter) {
        vAlign = "middle";
      }
      if (position2 === "start") {
        align = "right";
      }
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderMonthText = function(calendarModel, localeModel, orient, group) {
    var monthLabel = calendarModel.getModel("monthLabel");
    if (!monthLabel.get("show")) {
      return;
    }
    var nameMap = monthLabel.get("nameMap");
    var margin = monthLabel.get("margin");
    var pos = monthLabel.get("position");
    var align = monthLabel.get("align");
    var termPoints = [this._tlpoints, this._blpoints];
    if (!nameMap || isString$1(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      nameMap = localeModel.get(["time", "monthAbbr"]) || [];
    }
    var idx = pos === "start" ? 0 : 1;
    var axis = orient === "horizontal" ? 0 : 1;
    margin = pos === "start" ? -margin : margin;
    var isCenter = align === "center";
    for (var i = 0; i < termPoints[idx].length - 1; i++) {
      var tmp = termPoints[idx][i].slice();
      var firstDay = this._firstDayOfMonth[i];
      if (isCenter) {
        var firstDayPoints = this._firstDayPoints[i];
        tmp[axis] = (firstDayPoints[axis] + termPoints[0][i + 1][axis]) / 2;
      }
      var formatter = monthLabel.get("formatter");
      var name_1 = nameMap[+firstDay.m - 1];
      var params = {
        yyyy: firstDay.y,
        yy: (firstDay.y + "").slice(2),
        MM: firstDay.m,
        M: +firstDay.m,
        nameMap: name_1
      };
      var content = this._formatterLabel(formatter, params);
      var monthText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(monthLabel, {
          text: content
        }), this._monthTextPositionControl(tmp, isCenter, orient, pos, margin))
      });
      group.add(monthText);
    }
  };
  CalendarView2.prototype._weekTextPositionControl = function(point, orient, position2, margin, cellSize) {
    var align = "center";
    var vAlign = "middle";
    var x2 = point[0];
    var y2 = point[1];
    var isStart = position2 === "start";
    if (orient === "horizontal") {
      x2 = x2 + margin + (isStart ? 1 : -1) * cellSize[0] / 2;
      align = isStart ? "right" : "left";
    } else {
      y2 = y2 + margin + (isStart ? 1 : -1) * cellSize[1] / 2;
      vAlign = isStart ? "bottom" : "top";
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderWeekText = function(calendarModel, localeModel, rangeData, orient, group) {
    var dayLabel = calendarModel.getModel("dayLabel");
    if (!dayLabel.get("show")) {
      return;
    }
    var coordSys = calendarModel.coordinateSystem;
    var pos = dayLabel.get("position");
    var nameMap = dayLabel.get("nameMap");
    var margin = dayLabel.get("margin");
    var firstDayOfWeek = coordSys.getFirstDayOfWeek();
    if (!nameMap || isString$1(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      var dayOfWeekShort = localeModel.get(["time", "dayOfWeekShort"]);
      nameMap = dayOfWeekShort || map$1(localeModel.get(["time", "dayOfWeekAbbr"]), function(val) {
        return val[0];
      });
    }
    var start2 = coordSys.getNextNDay(rangeData.end.time, 7 - rangeData.lweek).time;
    var cellSize = [coordSys.getCellWidth(), coordSys.getCellHeight()];
    margin = parsePercent(margin, Math.min(cellSize[1], cellSize[0]));
    if (pos === "start") {
      start2 = coordSys.getNextNDay(rangeData.start.time, -(7 + rangeData.fweek)).time;
      margin = -margin;
    }
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(start2, i);
      var point = coordSys.dataToRect([tmpD.time], false).center;
      var day = i;
      day = Math.abs((i + firstDayOfWeek) % 7);
      var weekText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(dayLabel, {
          text: nameMap[day]
        }), this._weekTextPositionControl(point, orient, pos, margin, cellSize))
      });
      group.add(weekText);
    }
  };
  CalendarView2.type = "calendar";
  return CalendarView2;
}(ComponentView$1);
var CalendarView$1 = CalendarView;
var PROXIMATE_ONE_DAY = 864e5;
var Calendar = function() {
  function Calendar2(calendarModel, ecModel, api) {
    this.type = "calendar";
    this.dimensions = Calendar2.dimensions;
    this.getDimensionsInfo = Calendar2.getDimensionsInfo;
    this._model = calendarModel;
  }
  Calendar2.getDimensionsInfo = function() {
    return [{
      name: "time",
      type: "time"
    }, "value"];
  };
  Calendar2.prototype.getRangeInfo = function() {
    return this._rangeInfo;
  };
  Calendar2.prototype.getModel = function() {
    return this._model;
  };
  Calendar2.prototype.getRect = function() {
    return this._rect;
  };
  Calendar2.prototype.getCellWidth = function() {
    return this._sw;
  };
  Calendar2.prototype.getCellHeight = function() {
    return this._sh;
  };
  Calendar2.prototype.getOrient = function() {
    return this._orient;
  };
  Calendar2.prototype.getFirstDayOfWeek = function() {
    return this._firstDayOfWeek;
  };
  Calendar2.prototype.getDateInfo = function(date4) {
    date4 = parseDate(date4);
    var y2 = date4.getFullYear();
    var m2 = date4.getMonth() + 1;
    var mStr = m2 < 10 ? "0" + m2 : "" + m2;
    var d2 = date4.getDate();
    var dStr = d2 < 10 ? "0" + d2 : "" + d2;
    var day = date4.getDay();
    day = Math.abs((day + 7 - this.getFirstDayOfWeek()) % 7);
    return {
      y: y2 + "",
      m: mStr,
      d: dStr,
      day,
      time: date4.getTime(),
      formatedDate: y2 + "-" + mStr + "-" + dStr,
      date: date4
    };
  };
  Calendar2.prototype.getNextNDay = function(date4, n2) {
    n2 = n2 || 0;
    if (n2 === 0) {
      return this.getDateInfo(date4);
    }
    date4 = new Date(this.getDateInfo(date4).time);
    date4.setDate(date4.getDate() + n2);
    return this.getDateInfo(date4);
  };
  Calendar2.prototype.update = function(ecModel, api) {
    this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay");
    this._orient = this._model.get("orient");
    this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0;
    this._rangeInfo = this._getRangeInfo(this._initRangeOption());
    var weeks = this._rangeInfo.weeks || 1;
    var whNames = ["width", "height"];
    var cellSize = this._model.getCellSize().slice();
    var layoutParams = this._model.getBoxLayoutParams();
    var cellNumbers = this._orient === "horizontal" ? [weeks, 7] : [7, weeks];
    each$g([0, 1], function(idx) {
      if (cellSizeSpecified(cellSize, idx)) {
        layoutParams[whNames[idx]] = cellSize[idx] * cellNumbers[idx];
      }
    });
    var whGlobal = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var calendarRect = this._rect = getLayoutRect(layoutParams, whGlobal);
    each$g([0, 1], function(idx) {
      if (!cellSizeSpecified(cellSize, idx)) {
        cellSize[idx] = calendarRect[whNames[idx]] / cellNumbers[idx];
      }
    });
    function cellSizeSpecified(cellSize2, idx) {
      return cellSize2[idx] != null && cellSize2[idx] !== "auto";
    }
    this._sw = cellSize[0];
    this._sh = cellSize[1];
  };
  Calendar2.prototype.dataToPoint = function(data, clamp2) {
    isArray$1(data) && (data = data[0]);
    clamp2 == null && (clamp2 = true);
    var dayInfo = this.getDateInfo(data);
    var range3 = this._rangeInfo;
    var date4 = dayInfo.formatedDate;
    if (clamp2 && !(dayInfo.time >= range3.start.time && dayInfo.time < range3.end.time + PROXIMATE_ONE_DAY)) {
      return [NaN, NaN];
    }
    var week = dayInfo.day;
    var nthWeek = this._getRangeInfo([range3.start.time, date4]).nthWeek;
    if (this._orient === "vertical") {
      return [this._rect.x + week * this._sw + this._sw / 2, this._rect.y + nthWeek * this._sh + this._sh / 2];
    }
    return [this._rect.x + nthWeek * this._sw + this._sw / 2, this._rect.y + week * this._sh + this._sh / 2];
  };
  Calendar2.prototype.pointToData = function(point) {
    var date4 = this.pointToDate(point);
    return date4 && date4.time;
  };
  Calendar2.prototype.dataToRect = function(data, clamp2) {
    var point = this.dataToPoint(data, clamp2);
    return {
      contentShape: {
        x: point[0] - (this._sw - this._lineWidth) / 2,
        y: point[1] - (this._sh - this._lineWidth) / 2,
        width: this._sw - this._lineWidth,
        height: this._sh - this._lineWidth
      },
      center: point,
      tl: [point[0] - this._sw / 2, point[1] - this._sh / 2],
      tr: [point[0] + this._sw / 2, point[1] - this._sh / 2],
      br: [point[0] + this._sw / 2, point[1] + this._sh / 2],
      bl: [point[0] - this._sw / 2, point[1] + this._sh / 2]
    };
  };
  Calendar2.prototype.pointToDate = function(point) {
    var nthX = Math.floor((point[0] - this._rect.x) / this._sw) + 1;
    var nthY = Math.floor((point[1] - this._rect.y) / this._sh) + 1;
    var range3 = this._rangeInfo.range;
    if (this._orient === "vertical") {
      return this._getDateByWeeksAndDay(nthY, nthX - 1, range3);
    }
    return this._getDateByWeeksAndDay(nthX, nthY - 1, range3);
  };
  Calendar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Calendar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  Calendar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Calendar2.prototype._initRangeOption = function() {
    var range3 = this._model.get("range");
    var normalizedRange;
    if (isArray$1(range3) && range3.length === 1) {
      range3 = range3[0];
    }
    if (!isArray$1(range3)) {
      var rangeStr = range3.toString();
      if (/^\d{4}$/.test(rangeStr)) {
        normalizedRange = [rangeStr + "-01-01", rangeStr + "-12-31"];
      }
      if (/^\d{4}[\/|-]\d{1,2}$/.test(rangeStr)) {
        var start2 = this.getDateInfo(rangeStr);
        var firstDay = start2.date;
        firstDay.setMonth(firstDay.getMonth() + 1);
        var end2 = this.getNextNDay(firstDay, -1);
        normalizedRange = [start2.formatedDate, end2.formatedDate];
      }
      if (/^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(rangeStr)) {
        normalizedRange = [rangeStr, rangeStr];
      }
    } else {
      normalizedRange = range3;
    }
    if (!normalizedRange) {
      return range3;
    }
    var tmp = this._getRangeInfo(normalizedRange);
    if (tmp.start.time > tmp.end.time) {
      normalizedRange.reverse();
    }
    return normalizedRange;
  };
  Calendar2.prototype._getRangeInfo = function(range3) {
    var parsedRange = [this.getDateInfo(range3[0]), this.getDateInfo(range3[1])];
    var reversed;
    if (parsedRange[0].time > parsedRange[1].time) {
      reversed = true;
      parsedRange.reverse();
    }
    var allDay = Math.floor(parsedRange[1].time / PROXIMATE_ONE_DAY) - Math.floor(parsedRange[0].time / PROXIMATE_ONE_DAY) + 1;
    var date4 = new Date(parsedRange[0].time);
    var startDateNum = date4.getDate();
    var endDateNum = parsedRange[1].date.getDate();
    date4.setDate(startDateNum + allDay - 1);
    var dateNum = date4.getDate();
    if (dateNum !== endDateNum) {
      var sign = date4.getTime() - parsedRange[1].time > 0 ? 1 : -1;
      while ((dateNum = date4.getDate()) !== endDateNum && (date4.getTime() - parsedRange[1].time) * sign > 0) {
        allDay -= sign;
        date4.setDate(dateNum - sign);
      }
    }
    var weeks = Math.floor((allDay + parsedRange[0].day + 6) / 7);
    var nthWeek = reversed ? -weeks + 1 : weeks - 1;
    reversed && parsedRange.reverse();
    return {
      range: [parsedRange[0].formatedDate, parsedRange[1].formatedDate],
      start: parsedRange[0],
      end: parsedRange[1],
      allDay,
      weeks,
      nthWeek,
      fweek: parsedRange[0].day,
      lweek: parsedRange[1].day
    };
  };
  Calendar2.prototype._getDateByWeeksAndDay = function(nthWeek, day, range3) {
    var rangeInfo = this._getRangeInfo(range3);
    if (nthWeek > rangeInfo.weeks || nthWeek === 0 && day < rangeInfo.fweek || nthWeek === rangeInfo.weeks && day > rangeInfo.lweek) {
      return null;
    }
    var nthDay = (nthWeek - 1) * 7 - rangeInfo.fweek + day;
    var date4 = new Date(rangeInfo.start.time);
    date4.setDate(+rangeInfo.start.d + nthDay);
    return this.getDateInfo(date4);
  };
  Calendar2.create = function(ecModel, api) {
    var calendarList = [];
    ecModel.eachComponent("calendar", function(calendarModel) {
      var calendar = new Calendar2(calendarModel, ecModel, api);
      calendarList.push(calendar);
      calendarModel.coordinateSystem = calendar;
    });
    ecModel.eachSeries(function(calendarSeries) {
      if (calendarSeries.get("coordinateSystem") === "calendar") {
        calendarSeries.coordinateSystem = calendarList[calendarSeries.get("calendarIndex") || 0];
      }
    });
    return calendarList;
  };
  Calendar2.dimensions = ["time", "value"];
  return Calendar2;
}();
function getCoordSys(finder) {
  var calendarModel = finder.calendarModel;
  var seriesModel = finder.seriesModel;
  var coordSys = calendarModel ? calendarModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem : null;
  return coordSys;
}
var Calendar$1 = Calendar;
function install$m(registers) {
  registers.registerComponentModel(CalendarModel$1);
  registers.registerComponentView(CalendarView$1);
  registers.registerCoordinateSystem("calendar", Calendar$1);
}
function setKeyInfoToNewElOption(resultItem, newElOption) {
  var existElOption = resultItem.existing;
  newElOption.id = resultItem.keyInfo.id;
  !newElOption.type && existElOption && (newElOption.type = existElOption.type);
  if (newElOption.parentId == null) {
    var newElParentOption = newElOption.parentOption;
    if (newElParentOption) {
      newElOption.parentId = newElParentOption.id;
    } else if (existElOption) {
      newElOption.parentId = existElOption.parentId;
    }
  }
  newElOption.parentOption = null;
}
function isSetLoc(obj, props) {
  var isSet;
  each$g(props, function(prop) {
    obj[prop] != null && obj[prop] !== "auto" && (isSet = true);
  });
  return isSet;
}
function mergeNewElOptionToExist(existList, index2, newElOption) {
  var newElOptCopy = extend({}, newElOption);
  var existElOption = existList[index2];
  var $action = newElOption.$action || "merge";
  if ($action === "merge") {
    if (existElOption) {
      merge(existElOption, newElOptCopy, true);
      mergeLayoutParam(existElOption, newElOptCopy, {
        ignoreSize: true
      });
      copyLayoutParams(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption, "shape");
      copyTransitionInfo(newElOption, existElOption, "style");
      copyTransitionInfo(newElOption, existElOption, "extra");
      newElOption.clipPath = existElOption.clipPath;
    } else {
      existList[index2] = newElOptCopy;
    }
  } else if ($action === "replace") {
    existList[index2] = newElOptCopy;
  } else if ($action === "remove") {
    existElOption && (existList[index2] = null);
  }
}
var TRANSITION_PROPS_TO_COPY = ["transition", "enterFrom", "leaveTo"];
var ROOT_TRANSITION_PROPS_TO_COPY = TRANSITION_PROPS_TO_COPY.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
function copyTransitionInfo(target, source, targetProp) {
  if (targetProp) {
    if (!target[targetProp] && source[targetProp]) {
      target[targetProp] = {};
    }
    target = target[targetProp];
    source = source[targetProp];
  }
  if (!target || !source) {
    return;
  }
  var props = targetProp ? TRANSITION_PROPS_TO_COPY : ROOT_TRANSITION_PROPS_TO_COPY;
  for (var i = 0; i < props.length; i++) {
    var prop = props[i];
    if (target[prop] == null && source[prop] != null) {
      target[prop] = source[prop];
    }
  }
}
function setLayoutInfoToExist(existItem, newElOption) {
  if (!existItem) {
    return;
  }
  existItem.hv = newElOption.hv = [
    isSetLoc(newElOption, ["left", "right"]),
    isSetLoc(newElOption, ["top", "bottom"])
  ];
  if (existItem.type === "group") {
    var existingGroupOpt = existItem;
    var newGroupOpt = newElOption;
    existingGroupOpt.width == null && (existingGroupOpt.width = newGroupOpt.width = 0);
    existingGroupOpt.height == null && (existingGroupOpt.height = newGroupOpt.height = 0);
  }
}
var GraphicComponentModel = function(_super) {
  __extends(GraphicComponentModel2, _super);
  function GraphicComponentModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentModel2.type;
    _this.preventAutoZ = true;
    return _this;
  }
  GraphicComponentModel2.prototype.mergeOption = function(option, ecModel) {
    var elements = this.option.elements;
    this.option.elements = null;
    _super.prototype.mergeOption.call(this, option, ecModel);
    this.option.elements = elements;
  };
  GraphicComponentModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    var newList = (isInit ? thisOption : newOption).elements;
    var existList = thisOption.elements = isInit ? [] : thisOption.elements;
    var flattenedList = [];
    this._flatten(newList, flattenedList, null);
    var mappingResult = mappingToExists(existList, flattenedList, "normalMerge");
    var elOptionsToUpdate = this._elOptionsToUpdate = [];
    each$g(mappingResult, function(resultItem, index2) {
      var newElOption = resultItem.newOption;
      if (!newElOption) {
        return;
      }
      elOptionsToUpdate.push(newElOption);
      setKeyInfoToNewElOption(resultItem, newElOption);
      mergeNewElOptionToExist(existList, index2, newElOption);
      setLayoutInfoToExist(existList[index2], newElOption);
    }, this);
    thisOption.elements = filter(existList, function(item) {
      item && delete item.$action;
      return item != null;
    });
  };
  GraphicComponentModel2.prototype._flatten = function(optionList, result, parentOption) {
    each$g(optionList, function(option) {
      if (!option) {
        return;
      }
      if (parentOption) {
        option.parentOption = parentOption;
      }
      result.push(option);
      var children = option.children;
      if (option.type === "group" && children) {
        this._flatten(children, result, option);
      }
      delete option.children;
    }, this);
  };
  GraphicComponentModel2.prototype.useElOptionsToUpdate = function() {
    var els = this._elOptionsToUpdate;
    this._elOptionsToUpdate = null;
    return els;
  };
  GraphicComponentModel2.type = "graphic";
  GraphicComponentModel2.defaultOption = {
    elements: []
  };
  return GraphicComponentModel2;
}(ComponentModel$1);
var nonShapeGraphicElements = {
  path: null,
  compoundPath: null,
  group: Group$6,
  image: ZRImage$1,
  text: ZRText$1
};
var inner$7 = makeInner();
var GraphicComponentView = function(_super) {
  __extends(GraphicComponentView2, _super);
  function GraphicComponentView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentView2.type;
    return _this;
  }
  GraphicComponentView2.prototype.init = function() {
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.render = function(graphicModel, ecModel, api) {
    if (graphicModel !== this._lastGraphicModel) {
      this._clear();
    }
    this._lastGraphicModel = graphicModel;
    this._updateElements(graphicModel);
    this._relocate(graphicModel, api);
  };
  GraphicComponentView2.prototype._updateElements = function(graphicModel) {
    var elOptionsToUpdate = graphicModel.useElOptionsToUpdate();
    if (!elOptionsToUpdate) {
      return;
    }
    var elMap = this._elMap;
    var rootGroup = this.group;
    var globalZ = graphicModel.get("z");
    var globalZLevel = graphicModel.get("zlevel");
    each$g(elOptionsToUpdate, function(elOption) {
      var id2 = convertOptionIdName(elOption.id, null);
      var elExisting = id2 != null ? elMap.get(id2) : null;
      var parentId = convertOptionIdName(elOption.parentId, null);
      var targetElParent = parentId != null ? elMap.get(parentId) : rootGroup;
      var elType = elOption.type;
      var elOptionStyle = elOption.style;
      if (elType === "text" && elOptionStyle) {
        if (elOption.hv && elOption.hv[1]) {
          elOptionStyle.textVerticalAlign = elOptionStyle.textBaseline = elOptionStyle.verticalAlign = elOptionStyle.align = null;
        }
      }
      var textContentOption = elOption.textContent;
      var textConfig = elOption.textConfig;
      if (elOptionStyle && isEC4CompatibleStyle(elOptionStyle, elType, !!textConfig, !!textContentOption)) {
        var convertResult = convertFromEC4CompatibleStyle(elOptionStyle, elType, true);
        if (!textConfig && convertResult.textConfig) {
          textConfig = elOption.textConfig = convertResult.textConfig;
        }
        if (!textContentOption && convertResult.textContent) {
          textContentOption = convertResult.textContent;
        }
      }
      var elOptionCleaned = getCleanedElOption(elOption);
      var $action = elOption.$action || "merge";
      var isMerge = $action === "merge";
      var isReplace = $action === "replace";
      if (isMerge) {
        var isInit = !elExisting;
        var el_1 = elExisting;
        if (isInit) {
          el_1 = createEl(id2, targetElParent, elOption.type, elMap);
        } else {
          el_1 && (inner$7(el_1).isNew = false);
          stopPreviousKeyframeAnimationAndRestore(el_1);
        }
        if (el_1) {
          applyUpdateTransition(el_1, elOptionCleaned, graphicModel, {
            isInit
          });
          updateCommonAttrs(el_1, elOption, globalZ, globalZLevel);
        }
      } else if (isReplace) {
        removeEl$1(elExisting, elOption, elMap, graphicModel);
        var el_2 = createEl(id2, targetElParent, elOption.type, elMap);
        if (el_2) {
          applyUpdateTransition(el_2, elOptionCleaned, graphicModel, {
            isInit: true
          });
          updateCommonAttrs(el_2, elOption, globalZ, globalZLevel);
        }
      } else if ($action === "remove") {
        updateLeaveTo(elExisting, elOption);
        removeEl$1(elExisting, elOption, elMap, graphicModel);
      }
      var el = elMap.get(id2);
      if (el && textContentOption) {
        if (isMerge) {
          var textContentExisting = el.getTextContent();
          textContentExisting ? textContentExisting.attr(textContentOption) : el.setTextContent(new ZRText$1(textContentOption));
        } else if (isReplace) {
          el.setTextContent(new ZRText$1(textContentOption));
        }
      }
      if (el) {
        var clipPathOption = elOption.clipPath;
        if (clipPathOption) {
          var clipPathType = clipPathOption.type;
          var clipPath = void 0;
          var isInit = false;
          if (isMerge) {
            var oldClipPath = el.getClipPath();
            isInit = !oldClipPath || inner$7(oldClipPath).type !== clipPathType;
            clipPath = isInit ? newEl(clipPathType) : oldClipPath;
          } else if (isReplace) {
            isInit = true;
            clipPath = newEl(clipPathType);
          }
          el.setClipPath(clipPath);
          applyUpdateTransition(clipPath, clipPathOption, graphicModel, {
            isInit
          });
          applyKeyframeAnimation(clipPath, clipPathOption.keyframeAnimation, graphicModel);
        }
        var elInner = inner$7(el);
        el.setTextConfig(textConfig);
        elInner.option = elOption;
        setEventData(el, graphicModel, elOption);
        setTooltipConfig({
          el,
          componentModel: graphicModel,
          itemName: el.name,
          itemTooltipOption: elOption.tooltip
        });
        applyKeyframeAnimation(el, elOption.keyframeAnimation, graphicModel);
      }
    });
  };
  GraphicComponentView2.prototype._relocate = function(graphicModel, api) {
    var elOptions = graphicModel.option.elements;
    var rootGroup = this.group;
    var elMap = this._elMap;
    var apiWidth = api.getWidth();
    var apiHeight = api.getHeight();
    var xy = ["x", "y"];
    for (var i = 0; i < elOptions.length; i++) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el || !el.isGroup) {
        continue;
      }
      var parentEl = el.parent;
      var isParentRoot = parentEl === rootGroup;
      var elInner = inner$7(el);
      var parentElInner = inner$7(parentEl);
      elInner.width = parsePercent(elInner.option.width, isParentRoot ? apiWidth : parentElInner.width) || 0;
      elInner.height = parsePercent(elInner.option.height, isParentRoot ? apiHeight : parentElInner.height) || 0;
    }
    for (var i = elOptions.length - 1; i >= 0; i--) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el) {
        continue;
      }
      var parentEl = el.parent;
      var parentElInner = inner$7(parentEl);
      var containerInfo = parentEl === rootGroup ? {
        width: apiWidth,
        height: apiHeight
      } : {
        width: parentElInner.width,
        height: parentElInner.height
      };
      var layoutPos = {};
      var layouted = positionElement(el, elOption, containerInfo, null, {
        hv: elOption.hv,
        boundingMode: elOption.bounding
      }, layoutPos);
      if (!inner$7(el).isNew && layouted) {
        var transition = elOption.transition;
        var animatePos = {};
        for (var k2 = 0; k2 < xy.length; k2++) {
          var key = xy[k2];
          var val = layoutPos[key];
          if (transition && (isTransitionAll(transition) || indexOf(transition, key) >= 0)) {
            animatePos[key] = val;
          } else {
            el[key] = val;
          }
        }
        updateProps$1(el, animatePos, graphicModel, 0);
      } else {
        el.attr(layoutPos);
      }
    }
  };
  GraphicComponentView2.prototype._clear = function() {
    var _this = this;
    var elMap = this._elMap;
    elMap.each(function(el) {
      removeEl$1(el, inner$7(el).option, elMap, _this._lastGraphicModel);
    });
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.dispose = function() {
    this._clear();
  };
  GraphicComponentView2.type = "graphic";
  return GraphicComponentView2;
}(ComponentView$1);
function newEl(graphicType) {
  var Clz = hasOwn(nonShapeGraphicElements, graphicType) ? nonShapeGraphicElements[graphicType] : getShapeClass(graphicType);
  var el = new Clz({});
  inner$7(el).type = graphicType;
  return el;
}
function createEl(id2, targetElParent, graphicType, elMap) {
  var el = newEl(graphicType);
  targetElParent.add(el);
  elMap.set(id2, el);
  inner$7(el).id = id2;
  inner$7(el).isNew = true;
  return el;
}
function removeEl$1(elExisting, elOption, elMap, graphicModel) {
  var existElParent = elExisting && elExisting.parent;
  if (existElParent) {
    elExisting.type === "group" && elExisting.traverse(function(el) {
      removeEl$1(el, elOption, elMap, graphicModel);
    });
    applyLeaveTransition(elExisting, elOption, graphicModel);
    elMap.removeKey(inner$7(elExisting).id);
  }
}
function updateCommonAttrs(el, elOption, defaultZ, defaultZlevel) {
  if (!el.isGroup) {
    var elDisplayable = el;
    elDisplayable.cursor = retrieve2(elOption.cursor, Displayable$1.prototype.cursor);
    elDisplayable.z = retrieve2(elOption.z, defaultZ || 0);
    elDisplayable.zlevel = retrieve2(elOption.zlevel, defaultZlevel || 0);
    var optZ2 = elOption.z2;
    optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  }
  each$g(keys(elOption), function(key) {
    var val = elOption[key];
    if (key.indexOf("on") === 0 && isFunction(val)) {
      el[key] = val;
    }
  });
  el.draggable = elOption.draggable;
  elOption.name != null && (el.name = elOption.name);
  elOption.id != null && (el.id = elOption.id);
}
function getCleanedElOption(elOption) {
  elOption = extend({}, elOption);
  each$g(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(LOCATION_PARAMS), function(name) {
    delete elOption[name];
  });
  return elOption;
}
function setEventData(el, graphicModel, elOption) {
  var eventData = getECData(el).eventData;
  if (!el.silent && !el.ignore && !eventData) {
    eventData = getECData(el).eventData = {
      componentType: "graphic",
      componentIndex: graphicModel.componentIndex,
      name: el.name
    };
  }
  if (eventData) {
    eventData.info = elOption.info;
  }
}
function install$l(registers) {
  registers.registerComponentModel(GraphicComponentModel);
  registers.registerComponentView(GraphicComponentView);
  registers.registerPreprocessor(function(option) {
    var graphicOption = option.graphic;
    if (isArray$1(graphicOption)) {
      if (!graphicOption[0] || !graphicOption[0].elements) {
        option.graphic = [{
          elements: graphicOption
        }];
      } else {
        option.graphic = [option.graphic[0]];
      }
    } else if (graphicOption && !graphicOption.elements) {
      option.graphic = [{
        elements: [graphicOption]
      }];
    }
  });
}
var DATA_ZOOM_AXIS_DIMENSIONS = ["x", "y", "radius", "angle", "single"];
var SERIES_COORDS = ["cartesian2d", "polar", "singleAxis"];
function isCoordSupported(seriesModel) {
  var coordType = seriesModel.get("coordinateSystem");
  return indexOf(SERIES_COORDS, coordType) >= 0;
}
function getAxisMainType(axisDim) {
  return axisDim + "Axis";
}
function findEffectedDataZooms(ecModel, payload) {
  var axisRecords = createHashMap();
  var effectedModels = [];
  var effectedModelMap = createHashMap();
  ecModel.eachComponent({
    mainType: "dataZoom",
    query: payload
  }, function(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid)) {
      addToEffected(dataZoomModel);
    }
  });
  var foundNewLink;
  do {
    foundNewLink = false;
    ecModel.eachComponent("dataZoom", processSingle);
  } while (foundNewLink);
  function processSingle(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid) && isLinked(dataZoomModel)) {
      addToEffected(dataZoomModel);
      foundNewLink = true;
    }
  }
  function addToEffected(dataZoom) {
    effectedModelMap.set(dataZoom.uid, true);
    effectedModels.push(dataZoom);
    markAxisControlled(dataZoom);
  }
  function isLinked(dataZoomModel) {
    var isLink = false;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var axisIdxArr = axisRecords.get(axisDim);
      if (axisIdxArr && axisIdxArr[axisIndex]) {
        isLink = true;
      }
    });
    return isLink;
  }
  function markAxisControlled(dataZoomModel) {
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      (axisRecords.get(axisDim) || axisRecords.set(axisDim, []))[axisIndex] = true;
    });
  }
  return effectedModels;
}
function collectReferCoordSysModelInfo(dataZoomModel) {
  var ecModel = dataZoomModel.ecModel;
  var coordSysInfoWrap = {
    infoList: [],
    infoMap: createHashMap()
  };
  dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
    var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    if (!axisModel) {
      return;
    }
    var coordSysModel = axisModel.getCoordSysModel();
    if (!coordSysModel) {
      return;
    }
    var coordSysUid = coordSysModel.uid;
    var coordSysInfo = coordSysInfoWrap.infoMap.get(coordSysUid);
    if (!coordSysInfo) {
      coordSysInfo = {
        model: coordSysModel,
        axisModels: []
      };
      coordSysInfoWrap.infoList.push(coordSysInfo);
      coordSysInfoWrap.infoMap.set(coordSysUid, coordSysInfo);
    }
    coordSysInfo.axisModels.push(axisModel);
  });
  return coordSysInfoWrap;
}
var DataZoomAxisInfo = function() {
  function DataZoomAxisInfo2() {
    this.indexList = [];
    this.indexMap = [];
  }
  DataZoomAxisInfo2.prototype.add = function(axisCmptIdx) {
    if (!this.indexMap[axisCmptIdx]) {
      this.indexList.push(axisCmptIdx);
      this.indexMap[axisCmptIdx] = true;
    }
  };
  return DataZoomAxisInfo2;
}();
var DataZoomModel = function(_super) {
  __extends(DataZoomModel2, _super);
  function DataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomModel2.type;
    _this._autoThrottle = true;
    _this._noTarget = true;
    _this._rangePropMode = ["percent", "percent"];
    return _this;
  }
  DataZoomModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputRawOption = retrieveRawOption(option);
    this.settledOption = inputRawOption;
    this.mergeDefaultAndTheme(option, ecModel);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype.mergeOption = function(newOption) {
    var inputRawOption = retrieveRawOption(newOption);
    merge(this.option, newOption, true);
    merge(this.settledOption, inputRawOption, true);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype._doInit = function(inputRawOption) {
    var thisOption = this.option;
    this._setDefaultThrottle(inputRawOption);
    this._updateRangeUse(inputRawOption);
    var settledOption = this.settledOption;
    each$g([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      if (this._rangePropMode[index2] === "value") {
        thisOption[names2[0]] = settledOption[names2[0]] = null;
      }
    }, this);
    this._resetTarget();
  };
  DataZoomModel2.prototype._resetTarget = function() {
    var optionOrient = this.get("orient", true);
    var targetAxisIndexMap = this._targetAxisInfoMap = createHashMap();
    var hasAxisSpecified = this._fillSpecifiedTargetAxis(targetAxisIndexMap);
    if (hasAxisSpecified) {
      this._orient = optionOrient || this._makeAutoOrientByTargetAxis();
    } else {
      this._orient = optionOrient || "horizontal";
      this._fillAutoTargetAxisByOrient(targetAxisIndexMap, this._orient);
    }
    this._noTarget = true;
    targetAxisIndexMap.each(function(axisInfo) {
      if (axisInfo.indexList.length) {
        this._noTarget = false;
      }
    }, this);
  };
  DataZoomModel2.prototype._fillSpecifiedTargetAxis = function(targetAxisIndexMap) {
    var hasAxisSpecified = false;
    each$g(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim) {
      var refering = this.getReferringComponents(getAxisMainType(axisDim), MULTIPLE_REFERRING);
      if (!refering.specified) {
        return;
      }
      hasAxisSpecified = true;
      var axisInfo = new DataZoomAxisInfo();
      each$g(refering.models, function(axisModel) {
        axisInfo.add(axisModel.componentIndex);
      });
      targetAxisIndexMap.set(axisDim, axisInfo);
    }, this);
    return hasAxisSpecified;
  };
  DataZoomModel2.prototype._fillAutoTargetAxisByOrient = function(targetAxisIndexMap, orient) {
    var ecModel = this.ecModel;
    var needAuto = true;
    if (needAuto) {
      var axisDim = orient === "vertical" ? "y" : "x";
      var axisModels = ecModel.findComponents({
        mainType: axisDim + "Axis"
      });
      setParallelAxis(axisModels, axisDim);
    }
    if (needAuto) {
      var axisModels = ecModel.findComponents({
        mainType: "singleAxis",
        filter: function(axisModel) {
          return axisModel.get("orient", true) === orient;
        }
      });
      setParallelAxis(axisModels, "single");
    }
    function setParallelAxis(axisModels2, axisDim2) {
      var axisModel = axisModels2[0];
      if (!axisModel) {
        return;
      }
      var axisInfo = new DataZoomAxisInfo();
      axisInfo.add(axisModel.componentIndex);
      targetAxisIndexMap.set(axisDim2, axisInfo);
      needAuto = false;
      if (axisDim2 === "x" || axisDim2 === "y") {
        var gridModel_1 = axisModel.getReferringComponents("grid", SINGLE_REFERRING).models[0];
        gridModel_1 && each$g(axisModels2, function(axModel) {
          if (axisModel.componentIndex !== axModel.componentIndex && gridModel_1 === axModel.getReferringComponents("grid", SINGLE_REFERRING).models[0]) {
            axisInfo.add(axModel.componentIndex);
          }
        });
      }
    }
    if (needAuto) {
      each$g(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim2) {
        if (!needAuto) {
          return;
        }
        var axisModels2 = ecModel.findComponents({
          mainType: getAxisMainType(axisDim2),
          filter: function(axisModel) {
            return axisModel.get("type", true) === "category";
          }
        });
        if (axisModels2[0]) {
          var axisInfo = new DataZoomAxisInfo();
          axisInfo.add(axisModels2[0].componentIndex);
          targetAxisIndexMap.set(axisDim2, axisInfo);
          needAuto = false;
        }
      }, this);
    }
  };
  DataZoomModel2.prototype._makeAutoOrientByTargetAxis = function() {
    var dim;
    this.eachTargetAxis(function(axisDim) {
      !dim && (dim = axisDim);
    }, this);
    return dim === "y" ? "vertical" : "horizontal";
  };
  DataZoomModel2.prototype._setDefaultThrottle = function(inputRawOption) {
    if (inputRawOption.hasOwnProperty("throttle")) {
      this._autoThrottle = false;
    }
    if (this._autoThrottle) {
      var globalOption = this.ecModel.option;
      this.option.throttle = globalOption.animation && globalOption.animationDurationUpdate > 0 ? 100 : 20;
    }
  };
  DataZoomModel2.prototype._updateRangeUse = function(inputRawOption) {
    var rangePropMode = this._rangePropMode;
    var rangeModeInOption = this.get("rangeMode");
    each$g([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      var percentSpecified = inputRawOption[names2[0]] != null;
      var valueSpecified = inputRawOption[names2[1]] != null;
      if (percentSpecified && !valueSpecified) {
        rangePropMode[index2] = "percent";
      } else if (!percentSpecified && valueSpecified) {
        rangePropMode[index2] = "value";
      } else if (rangeModeInOption) {
        rangePropMode[index2] = rangeModeInOption[index2];
      } else if (percentSpecified) {
        rangePropMode[index2] = "percent";
      }
    });
  };
  DataZoomModel2.prototype.noTarget = function() {
    return this._noTarget;
  };
  DataZoomModel2.prototype.getFirstTargetAxisModel = function() {
    var firstAxisModel;
    this.eachTargetAxis(function(axisDim, axisIndex) {
      if (firstAxisModel == null) {
        firstAxisModel = this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
      }
    }, this);
    return firstAxisModel;
  };
  DataZoomModel2.prototype.eachTargetAxis = function(callback, context) {
    this._targetAxisInfoMap.each(function(axisInfo, axisDim) {
      each$g(axisInfo.indexList, function(axisIndex) {
        callback.call(context, axisDim, axisIndex);
      });
    });
  };
  DataZoomModel2.prototype.getAxisProxy = function(axisDim, axisIndex) {
    var axisModel = this.getAxisModel(axisDim, axisIndex);
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
  };
  DataZoomModel2.prototype.getAxisModel = function(axisDim, axisIndex) {
    var axisInfo = this._targetAxisInfoMap.get(axisDim);
    if (axisInfo && axisInfo.indexMap[axisIndex]) {
      return this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    }
  };
  DataZoomModel2.prototype.setRawRange = function(opt) {
    var thisOption = this.option;
    var settledOption = this.settledOption;
    each$g([["start", "startValue"], ["end", "endValue"]], function(names2) {
      if (opt[names2[0]] != null || opt[names2[1]] != null) {
        thisOption[names2[0]] = settledOption[names2[0]] = opt[names2[0]];
        thisOption[names2[1]] = settledOption[names2[1]] = opt[names2[1]];
      }
    }, this);
    this._updateRangeUse(opt);
  };
  DataZoomModel2.prototype.setCalculatedRange = function(opt) {
    var option = this.option;
    each$g(["start", "startValue", "end", "endValue"], function(name) {
      option[name] = opt[name];
    });
  };
  DataZoomModel2.prototype.getPercentRange = function() {
    var axisProxy = this.findRepresentativeAxisProxy();
    if (axisProxy) {
      return axisProxy.getDataPercentWindow();
    }
  };
  DataZoomModel2.prototype.getValueRange = function(axisDim, axisIndex) {
    if (axisDim == null && axisIndex == null) {
      var axisProxy = this.findRepresentativeAxisProxy();
      if (axisProxy) {
        return axisProxy.getDataValueWindow();
      }
    } else {
      return this.getAxisProxy(axisDim, axisIndex).getDataValueWindow();
    }
  };
  DataZoomModel2.prototype.findRepresentativeAxisProxy = function(axisModel) {
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
    var firstProxy;
    var axisDimList = this._targetAxisInfoMap.keys();
    for (var i = 0; i < axisDimList.length; i++) {
      var axisDim = axisDimList[i];
      var axisInfo = this._targetAxisInfoMap.get(axisDim);
      for (var j = 0; j < axisInfo.indexList.length; j++) {
        var proxy = this.getAxisProxy(axisDim, axisInfo.indexList[j]);
        if (proxy.hostedBy(this)) {
          return proxy;
        }
        if (!firstProxy) {
          firstProxy = proxy;
        }
      }
    }
    return firstProxy;
  };
  DataZoomModel2.prototype.getRangePropMode = function() {
    return this._rangePropMode.slice();
  };
  DataZoomModel2.prototype.getOrient = function() {
    return this._orient;
  };
  DataZoomModel2.type = "dataZoom";
  DataZoomModel2.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"];
  DataZoomModel2.defaultOption = {
    z: 4,
    filterMode: "filter",
    start: 0,
    end: 100
  };
  return DataZoomModel2;
}(ComponentModel$1);
function retrieveRawOption(option) {
  var ret = {};
  each$g(["start", "end", "startValue", "endValue", "throttle"], function(name) {
    option.hasOwnProperty(name) && (ret[name] = option[name]);
  });
  return ret;
}
var DataZoomModel$1 = DataZoomModel;
var SelectDataZoomModel = function(_super) {
  __extends(SelectDataZoomModel2, _super);
  function SelectDataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomModel2.type;
    return _this;
  }
  SelectDataZoomModel2.type = "dataZoom.select";
  return SelectDataZoomModel2;
}(DataZoomModel$1);
var SelectZoomModel = SelectDataZoomModel;
var DataZoomView = function(_super) {
  __extends(DataZoomView2, _super);
  function DataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomView2.type;
    return _this;
  }
  DataZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    this.dataZoomModel = dataZoomModel;
    this.ecModel = ecModel;
    this.api = api;
  };
  DataZoomView2.type = "dataZoom";
  return DataZoomView2;
}(ComponentView$1);
var DataZoomView$1 = DataZoomView;
var SelectDataZoomView = function(_super) {
  __extends(SelectDataZoomView2, _super);
  function SelectDataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomView2.type;
    return _this;
  }
  SelectDataZoomView2.type = "dataZoom.select";
  return SelectDataZoomView2;
}(DataZoomView$1);
var SelectZoomView = SelectDataZoomView;
var each$8 = each$g;
var asc$1 = asc$2;
var AxisProxy = function() {
  function AxisProxy2(dimName, axisIndex, dataZoomModel, ecModel) {
    this._dimName = dimName;
    this._axisIndex = axisIndex;
    this.ecModel = ecModel;
    this._dataZoomModel = dataZoomModel;
  }
  AxisProxy2.prototype.hostedBy = function(dataZoomModel) {
    return this._dataZoomModel === dataZoomModel;
  };
  AxisProxy2.prototype.getDataValueWindow = function() {
    return this._valueWindow.slice();
  };
  AxisProxy2.prototype.getDataPercentWindow = function() {
    return this._percentWindow.slice();
  };
  AxisProxy2.prototype.getTargetSeriesModels = function() {
    var seriesModels = [];
    this.ecModel.eachSeries(function(seriesModel) {
      if (isCoordSupported(seriesModel)) {
        var axisMainType = getAxisMainType(this._dimName);
        var axisModel = seriesModel.getReferringComponents(axisMainType, SINGLE_REFERRING).models[0];
        if (axisModel && this._axisIndex === axisModel.componentIndex) {
          seriesModels.push(seriesModel);
        }
      }
    }, this);
    return seriesModels;
  };
  AxisProxy2.prototype.getAxisModel = function() {
    return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
  };
  AxisProxy2.prototype.getMinMaxSpan = function() {
    return clone$4(this._minMaxSpan);
  };
  AxisProxy2.prototype.calculateDataWindow = function(opt) {
    var dataExtent = this._dataExtent;
    var axisModel = this.getAxisModel();
    var scale2 = axisModel.axis.scale;
    var rangePropMode = this._dataZoomModel.getRangePropMode();
    var percentExtent = [0, 100];
    var percentWindow = [];
    var valueWindow = [];
    var hasPropModeValue;
    each$8(["start", "end"], function(prop, idx) {
      var boundPercent = opt[prop];
      var boundValue = opt[prop + "Value"];
      if (rangePropMode[idx] === "percent") {
        boundPercent == null && (boundPercent = percentExtent[idx]);
        boundValue = scale2.parse(linearMap$2(boundPercent, percentExtent, dataExtent));
      } else {
        hasPropModeValue = true;
        boundValue = boundValue == null ? dataExtent[idx] : scale2.parse(boundValue);
        boundPercent = linearMap$2(boundValue, dataExtent, percentExtent);
      }
      valueWindow[idx] = boundValue;
      percentWindow[idx] = boundPercent;
    });
    asc$1(valueWindow);
    asc$1(percentWindow);
    var spans = this._minMaxSpan;
    hasPropModeValue ? restrictSet(valueWindow, percentWindow, dataExtent, percentExtent, false) : restrictSet(percentWindow, valueWindow, percentExtent, dataExtent, true);
    function restrictSet(fromWindow, toWindow, fromExtent, toExtent, toValue) {
      var suffix = toValue ? "Span" : "ValueSpan";
      sliderMove(0, fromWindow, fromExtent, "all", spans["min" + suffix], spans["max" + suffix]);
      for (var i = 0; i < 2; i++) {
        toWindow[i] = linearMap$2(fromWindow[i], fromExtent, toExtent, true);
        toValue && (toWindow[i] = scale2.parse(toWindow[i]));
      }
    }
    return {
      valueWindow,
      percentWindow
    };
  };
  AxisProxy2.prototype.reset = function(dataZoomModel) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var targetSeries = this.getTargetSeriesModels();
    this._dataExtent = calculateDataExtent(this, this._dimName, targetSeries);
    this._updateMinMaxSpan();
    var dataWindow = this.calculateDataWindow(dataZoomModel.settledOption);
    this._valueWindow = dataWindow.valueWindow;
    this._percentWindow = dataWindow.percentWindow;
    this._setAxisModel();
  };
  AxisProxy2.prototype.filterData = function(dataZoomModel, api) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var axisDim = this._dimName;
    var seriesModels = this.getTargetSeriesModels();
    var filterMode = dataZoomModel.get("filterMode");
    var valueWindow = this._valueWindow;
    if (filterMode === "none") {
      return;
    }
    each$8(seriesModels, function(seriesModel) {
      var seriesData = seriesModel.getData();
      var dataDims = seriesData.mapDimensionsAll(axisDim);
      if (!dataDims.length) {
        return;
      }
      if (filterMode === "weakFilter") {
        var store_1 = seriesData.getStore();
        var dataDimIndices_1 = map$1(dataDims, function(dim) {
          return seriesData.getDimensionIndex(dim);
        }, seriesData);
        seriesData.filterSelf(function(dataIndex) {
          var leftOut;
          var rightOut;
          var hasValue;
          for (var i = 0; i < dataDims.length; i++) {
            var value = store_1.get(dataDimIndices_1[i], dataIndex);
            var thisHasValue = !isNaN(value);
            var thisLeftOut = value < valueWindow[0];
            var thisRightOut = value > valueWindow[1];
            if (thisHasValue && !thisLeftOut && !thisRightOut) {
              return true;
            }
            thisHasValue && (hasValue = true);
            thisLeftOut && (leftOut = true);
            thisRightOut && (rightOut = true);
          }
          return hasValue && leftOut && rightOut;
        });
      } else {
        each$8(dataDims, function(dim) {
          if (filterMode === "empty") {
            seriesModel.setData(seriesData = seriesData.map(dim, function(value) {
              return !isInWindow(value) ? NaN : value;
            }));
          } else {
            var range3 = {};
            range3[dim] = valueWindow;
            seriesData.selectRange(range3);
          }
        });
      }
      each$8(dataDims, function(dim) {
        seriesData.setApproximateExtent(valueWindow, dim);
      });
    });
    function isInWindow(value) {
      return value >= valueWindow[0] && value <= valueWindow[1];
    }
  };
  AxisProxy2.prototype._updateMinMaxSpan = function() {
    var minMaxSpan = this._minMaxSpan = {};
    var dataZoomModel = this._dataZoomModel;
    var dataExtent = this._dataExtent;
    each$8(["min", "max"], function(minMax) {
      var percentSpan = dataZoomModel.get(minMax + "Span");
      var valueSpan = dataZoomModel.get(minMax + "ValueSpan");
      valueSpan != null && (valueSpan = this.getAxisModel().axis.scale.parse(valueSpan));
      if (valueSpan != null) {
        percentSpan = linearMap$2(dataExtent[0] + valueSpan, dataExtent, [0, 100], true);
      } else if (percentSpan != null) {
        valueSpan = linearMap$2(percentSpan, [0, 100], dataExtent, true) - dataExtent[0];
      }
      minMaxSpan[minMax + "Span"] = percentSpan;
      minMaxSpan[minMax + "ValueSpan"] = valueSpan;
    }, this);
  };
  AxisProxy2.prototype._setAxisModel = function() {
    var axisModel = this.getAxisModel();
    var percentWindow = this._percentWindow;
    var valueWindow = this._valueWindow;
    if (!percentWindow) {
      return;
    }
    var precision = getPixelPrecision(valueWindow, [0, 500]);
    precision = Math.min(precision, 20);
    var rawExtentInfo = axisModel.axis.scale.rawExtentInfo;
    if (percentWindow[0] !== 0) {
      rawExtentInfo.setDeterminedMinMax("min", +valueWindow[0].toFixed(precision));
    }
    if (percentWindow[1] !== 100) {
      rawExtentInfo.setDeterminedMinMax("max", +valueWindow[1].toFixed(precision));
    }
    rawExtentInfo.freeze();
  };
  return AxisProxy2;
}();
function calculateDataExtent(axisProxy, axisDim, seriesModels) {
  var dataExtent = [Infinity, -Infinity];
  each$8(seriesModels, function(seriesModel) {
    unionAxisExtentFromData(dataExtent, seriesModel.getData(), axisDim);
  });
  var axisModel = axisProxy.getAxisModel();
  var rawExtentResult = ensureScaleRawExtentInfo(axisModel.axis.scale, axisModel, dataExtent).calculate();
  return [rawExtentResult.min, rawExtentResult.max];
}
var AxisProxy$1 = AxisProxy;
var dataZoomProcessor = {
  getTargetSeries: function(ecModel) {
    function eachAxisModel(cb2) {
      ecModel.eachComponent("dataZoom", function(dataZoomModel) {
        dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
          var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
          cb2(axisDim, axisIndex, axisModel, dataZoomModel);
        });
      });
    }
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      axisModel.__dzAxisProxy = null;
    });
    var proxyList = [];
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      if (!axisModel.__dzAxisProxy) {
        axisModel.__dzAxisProxy = new AxisProxy$1(axisDim, axisIndex, dataZoomModel, ecModel);
        proxyList.push(axisModel.__dzAxisProxy);
      }
    });
    var seriesModelMap = createHashMap();
    each$g(proxyList, function(axisProxy) {
      each$g(axisProxy.getTargetSeriesModels(), function(seriesModel) {
        seriesModelMap.set(seriesModel.uid, seriesModel);
      });
    });
    return seriesModelMap;
  },
  overallReset: function(ecModel, api) {
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).reset(dataZoomModel);
      });
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).filterData(dataZoomModel, api);
      });
    });
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var percentRange = axisProxy.getDataPercentWindow();
        var valueRange = axisProxy.getDataValueWindow();
        dataZoomModel.setCalculatedRange({
          start: percentRange[0],
          end: percentRange[1],
          startValue: valueRange[0],
          endValue: valueRange[1]
        });
      }
    });
  }
};
var dataZoomProcessor$1 = dataZoomProcessor;
function installDataZoomAction(registers) {
  registers.registerAction("dataZoom", function(payload, ecModel) {
    var effectedModels = findEffectedDataZooms(ecModel, payload);
    each$g(effectedModels, function(dataZoomModel) {
      dataZoomModel.setRawRange({
        start: payload.start,
        end: payload.end,
        startValue: payload.startValue,
        endValue: payload.endValue
      });
    });
  });
}
var installed$1 = false;
function installCommon$1(registers) {
  if (installed$1) {
    return;
  }
  installed$1 = true;
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, dataZoomProcessor$1);
  installDataZoomAction(registers);
  registers.registerSubTypeDefaulter("dataZoom", function() {
    return "slider";
  });
}
function install$k(registers) {
  registers.registerComponentModel(SelectZoomModel);
  registers.registerComponentView(SelectZoomView);
  installCommon$1(registers);
}
var ToolboxFeature = function() {
  function ToolboxFeature2() {
  }
  return ToolboxFeature2;
}();
var features = {};
function registerFeature(name, ctor) {
  features[name] = ctor;
}
function getFeature(name) {
  return features[name];
}
var ToolboxModel = function(_super) {
  __extends(ToolboxModel2, _super);
  function ToolboxModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ToolboxModel2.type;
    return _this;
  }
  ToolboxModel2.prototype.optionUpdated = function() {
    _super.prototype.optionUpdated.apply(this, arguments);
    var ecModel = this.ecModel;
    each$g(this.option.feature, function(featureOpt, featureName) {
      var Feature = getFeature(featureName);
      if (Feature) {
        if (Feature.getDefaultOption) {
          Feature.defaultOption = Feature.getDefaultOption(ecModel);
        }
        merge(featureOpt, Feature.defaultOption);
      }
    });
  };
  ToolboxModel2.type = "toolbox";
  ToolboxModel2.layoutMode = {
    type: "box",
    ignoreSize: true
  };
  ToolboxModel2.defaultOption = {
    show: true,
    z: 6,
    orient: "horizontal",
    left: "right",
    top: "top",
    backgroundColor: "transparent",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemSize: 15,
    itemGap: 8,
    showTitle: true,
    iconStyle: {
      borderColor: "#666",
      color: "none"
    },
    emphasis: {
      iconStyle: {
        borderColor: "#3E98C5"
      }
    },
    tooltip: {
      show: false,
      position: "bottom"
    }
  };
  return ToolboxModel2;
}(ComponentModel$1);
var ToolboxModel$1 = ToolboxModel;
function layout(group, componentModel, api) {
  var boxLayoutParams = componentModel.getBoxLayoutParams();
  var padding = componentModel.get("padding");
  var viewportSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var rect = getLayoutRect(boxLayoutParams, viewportSize, padding);
  box(componentModel.get("orient"), group, componentModel.get("itemGap"), rect.width, rect.height);
  positionElement(group, boxLayoutParams, viewportSize, padding);
}
function makeBackground(rect, componentModel) {
  var padding = normalizeCssArray(componentModel.get("padding"));
  var style2 = componentModel.getItemStyle(["color", "opacity"]);
  style2.fill = componentModel.get("backgroundColor");
  rect = new Rect$3({
    shape: {
      x: rect.x - padding[3],
      y: rect.y - padding[0],
      width: rect.width + padding[1] + padding[3],
      height: rect.height + padding[0] + padding[2],
      r: componentModel.get("borderRadius")
    },
    style: style2,
    silent: true,
    z2: -1
  });
  return rect;
}
var ToolboxView = function(_super) {
  __extends(ToolboxView2, _super);
  function ToolboxView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ToolboxView2.prototype.render = function(toolboxModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    if (!toolboxModel.get("show")) {
      return;
    }
    var itemSize = +toolboxModel.get("itemSize");
    var featureOpts = toolboxModel.get("feature") || {};
    var features2 = this._features || (this._features = {});
    var featureNames = [];
    each$g(featureOpts, function(opt, name) {
      featureNames.push(name);
    });
    new DataDiffer$1(this._featureNames || [], featureNames).add(processFeature).update(processFeature).remove(curry$1(processFeature, null)).execute();
    this._featureNames = featureNames;
    function processFeature(newIndex, oldIndex) {
      var featureName = featureNames[newIndex];
      var oldName = featureNames[oldIndex];
      var featureOpt = featureOpts[featureName];
      var featureModel = new Model$1(featureOpt, toolboxModel, toolboxModel.ecModel);
      var feature;
      if (payload && payload.newTitle != null && payload.featureName === featureName) {
        featureOpt.title = payload.newTitle;
      }
      if (featureName && !oldName) {
        if (isUserFeatureName(featureName)) {
          feature = {
            onclick: featureModel.option.onclick,
            featureName
          };
        } else {
          var Feature = getFeature(featureName);
          if (!Feature) {
            return;
          }
          feature = new Feature();
        }
        features2[featureName] = feature;
      } else {
        feature = features2[oldName];
        if (!feature) {
          return;
        }
      }
      feature.uid = getUID("toolbox-feature");
      feature.model = featureModel;
      feature.ecModel = ecModel;
      feature.api = api;
      var isToolboxFeature = feature instanceof ToolboxFeature;
      if (!featureName && oldName) {
        isToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
        return;
      }
      if (!featureModel.get("show") || isToolboxFeature && feature.unusable) {
        isToolboxFeature && feature.remove && feature.remove(ecModel, api);
        return;
      }
      createIconPaths(featureModel, feature, featureName);
      featureModel.setIconStatus = function(iconName, status) {
        var option = this.option;
        var iconPaths = this.iconPaths;
        option.iconStatus = option.iconStatus || {};
        option.iconStatus[iconName] = status;
        if (iconPaths[iconName]) {
          (status === "emphasis" ? enterEmphasis : leaveEmphasis)(iconPaths[iconName]);
        }
      };
      if (feature instanceof ToolboxFeature) {
        if (feature.render) {
          feature.render(featureModel, ecModel, api, payload);
        }
      }
    }
    function createIconPaths(featureModel, feature, featureName) {
      var iconStyleModel = featureModel.getModel("iconStyle");
      var iconStyleEmphasisModel = featureModel.getModel(["emphasis", "iconStyle"]);
      var icons = feature instanceof ToolboxFeature && feature.getIcons ? feature.getIcons() : featureModel.get("icon");
      var titles = featureModel.get("title") || {};
      var iconsMap;
      var titlesMap;
      if (isString$1(icons)) {
        iconsMap = {};
        iconsMap[featureName] = icons;
      } else {
        iconsMap = icons;
      }
      if (isString$1(titles)) {
        titlesMap = {};
        titlesMap[featureName] = titles;
      } else {
        titlesMap = titles;
      }
      var iconPaths = featureModel.iconPaths = {};
      each$g(iconsMap, function(iconStr, iconName) {
        var path = createIcon(iconStr, {}, {
          x: -itemSize / 2,
          y: -itemSize / 2,
          width: itemSize,
          height: itemSize
        });
        path.setStyle(iconStyleModel.getItemStyle());
        var pathEmphasisState = path.ensureState("emphasis");
        pathEmphasisState.style = iconStyleEmphasisModel.getItemStyle();
        var textContent = new ZRText$1({
          style: {
            text: titlesMap[iconName],
            align: iconStyleEmphasisModel.get("textAlign"),
            borderRadius: iconStyleEmphasisModel.get("textBorderRadius"),
            padding: iconStyleEmphasisModel.get("textPadding"),
            fill: null
          },
          ignore: true
        });
        path.setTextContent(textContent);
        setTooltipConfig({
          el: path,
          componentModel: toolboxModel,
          itemName: iconName,
          formatterParamsExtra: {
            title: titlesMap[iconName]
          }
        });
        path.__title = titlesMap[iconName];
        path.on("mouseover", function() {
          var hoverStyle = iconStyleEmphasisModel.getItemStyle();
          var defaultTextPosition = toolboxModel.get("orient") === "vertical" ? toolboxModel.get("right") == null ? "right" : "left" : toolboxModel.get("bottom") == null ? "bottom" : "top";
          textContent.setStyle({
            fill: iconStyleEmphasisModel.get("textFill") || hoverStyle.fill || hoverStyle.stroke || "#000",
            backgroundColor: iconStyleEmphasisModel.get("textBackgroundColor")
          });
          path.setTextConfig({
            position: iconStyleEmphasisModel.get("textPosition") || defaultTextPosition
          });
          textContent.ignore = !toolboxModel.get("showTitle");
          enterEmphasis(this);
        }).on("mouseout", function() {
          if (featureModel.get(["iconStatus", iconName]) !== "emphasis") {
            leaveEmphasis(this);
          }
          textContent.hide();
        });
        (featureModel.get(["iconStatus", iconName]) === "emphasis" ? enterEmphasis : leaveEmphasis)(path);
        group.add(path);
        path.on("click", bind$1(feature.onclick, feature, ecModel, api, iconName));
        iconPaths[iconName] = path;
      });
    }
    layout(group, toolboxModel, api);
    group.add(makeBackground(group.getBoundingRect(), toolboxModel));
    group.eachChild(function(icon) {
      var titleText = icon.__title;
      var emphasisState = icon.ensureState("emphasis");
      var emphasisTextConfig = emphasisState.textConfig || (emphasisState.textConfig = {});
      var textContent = icon.getTextContent();
      var emphasisTextState = textContent && textContent.states.emphasis;
      if (emphasisTextState && !isFunction(emphasisTextState) && titleText) {
        var emphasisTextStyle = emphasisTextState.style || (emphasisTextState.style = {});
        var rect = getBoundingRect(titleText, ZRText$1.makeFont(emphasisTextStyle));
        var offsetX = icon.x + group.x;
        var offsetY = icon.y + group.y + itemSize;
        var needPutOnTop = false;
        if (offsetY + rect.height > api.getHeight()) {
          emphasisTextConfig.position = "top";
          needPutOnTop = true;
        }
        var topOffset = needPutOnTop ? -5 - rect.height : itemSize + 8;
        if (offsetX + rect.width / 2 > api.getWidth()) {
          emphasisTextConfig.position = ["100%", topOffset];
          emphasisTextStyle.align = "right";
        } else if (offsetX - rect.width / 2 < 0) {
          emphasisTextConfig.position = [0, topOffset];
          emphasisTextStyle.align = "left";
        }
      }
    });
  };
  ToolboxView2.prototype.updateView = function(toolboxModel, ecModel, api, payload) {
    each$g(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.updateView && feature.updateView(feature.model, ecModel, api, payload);
    });
  };
  ToolboxView2.prototype.remove = function(ecModel, api) {
    each$g(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.remove && feature.remove(ecModel, api);
    });
    this.group.removeAll();
  };
  ToolboxView2.prototype.dispose = function(ecModel, api) {
    each$g(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
    });
  };
  ToolboxView2.type = "toolbox";
  return ToolboxView2;
}(ComponentView$1);
function isUserFeatureName(featureName) {
  return featureName.indexOf("my") === 0;
}
var ToolboxView$1 = ToolboxView;
var SaveAsImage = function(_super) {
  __extends(SaveAsImage2, _super);
  function SaveAsImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SaveAsImage2.prototype.onclick = function(ecModel, api) {
    var model = this.model;
    var title = model.get("name") || ecModel.get("title.0.text") || "echarts";
    var isSvg = api.getZr().painter.getType() === "svg";
    var type4 = isSvg ? "svg" : model.get("type", true) || "png";
    var url2 = api.getConnectedDataURL({
      type: type4,
      backgroundColor: model.get("backgroundColor", true) || ecModel.get("backgroundColor") || "#fff",
      connectedBackgroundColor: model.get("connectedBackgroundColor"),
      excludeComponents: model.get("excludeComponents"),
      pixelRatio: model.get("pixelRatio")
    });
    var browser = env$1.browser;
    if (isFunction(MouseEvent) && (browser.newEdge || !browser.ie && !browser.edge)) {
      var $a2 = document.createElement("a");
      $a2.download = title + "." + type4;
      $a2.target = "_blank";
      $a2.href = url2;
      var evt = new MouseEvent("click", {
        view: document.defaultView,
        bubbles: true,
        cancelable: false
      });
      $a2.dispatchEvent(evt);
    } else {
      if (window.navigator.msSaveOrOpenBlob || isSvg) {
        var parts = url2.split(",");
        var base64Encoded = parts[0].indexOf("base64") > -1;
        var bstr = isSvg ? decodeURIComponent(parts[1]) : parts[1];
        base64Encoded && (bstr = window.atob(bstr));
        var filename = title + "." + type4;
        if (window.navigator.msSaveOrOpenBlob) {
          var n2 = bstr.length;
          var u8arr = new Uint8Array(n2);
          while (n2--) {
            u8arr[n2] = bstr.charCodeAt(n2);
          }
          var blob = new Blob([u8arr]);
          window.navigator.msSaveOrOpenBlob(blob, filename);
        } else {
          var frame = document.createElement("iframe");
          document.body.appendChild(frame);
          var cw = frame.contentWindow;
          var doc = cw.document;
          doc.open("image/svg+xml", "replace");
          doc.write(bstr);
          doc.close();
          cw.focus();
          doc.execCommand("SaveAs", true, filename);
          document.body.removeChild(frame);
        }
      } else {
        var lang = model.get("lang");
        var html = '<body style="margin:0;"><img src="' + url2 + '" style="max-width:100%;" title="' + (lang && lang[0] || "") + '" /></body>';
        var tab = window.open();
        tab.document.write(html);
        tab.document.title = title;
      }
    }
  };
  SaveAsImage2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0",
      title: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "title"]),
      type: "png",
      connectedBackgroundColor: "#fff",
      name: "",
      excludeComponents: ["toolbox"],
      lang: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "lang"])
    };
    return defaultOption2;
  };
  return SaveAsImage2;
}(ToolboxFeature);
var SaveAsImage$1 = SaveAsImage;
var INNER_STACK_KEYWORD = "__ec_magicType_stack__";
var radioTypes = [["line", "bar"], ["stack"]];
var MagicType = function(_super) {
  __extends(MagicType2, _super);
  function MagicType2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  MagicType2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon");
    var icons = {};
    each$g(model.get("type"), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  MagicType2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: [],
      icon: {
        line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4",
        bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7",
        stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "magicType", "title"]),
      option: {},
      seriesIndex: {}
    };
    return defaultOption2;
  };
  MagicType2.prototype.onclick = function(ecModel, api, type4) {
    var model = this.model;
    var seriesIndex = model.get(["seriesIndex", type4]);
    if (!seriesOptGenreator[type4]) {
      return;
    }
    var newOption = {
      series: []
    };
    var generateNewSeriesTypes = function(seriesModel) {
      var seriesType2 = seriesModel.subType;
      var seriesId = seriesModel.id;
      var newSeriesOpt = seriesOptGenreator[type4](seriesType2, seriesId, seriesModel, model);
      if (newSeriesOpt) {
        defaults(newSeriesOpt, seriesModel.option);
        newOption.series.push(newSeriesOpt);
      }
      var coordSys = seriesModel.coordinateSystem;
      if (coordSys && coordSys.type === "cartesian2d" && (type4 === "line" || type4 === "bar")) {
        var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
        if (categoryAxis2) {
          var axisDim = categoryAxis2.dim;
          var axisType = axisDim + "Axis";
          var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
          var axisIndex = axisModel.componentIndex;
          newOption[axisType] = newOption[axisType] || [];
          for (var i = 0; i <= axisIndex; i++) {
            newOption[axisType][axisIndex] = newOption[axisType][axisIndex] || {};
          }
          newOption[axisType][axisIndex].boundaryGap = type4 === "bar";
        }
      }
    };
    each$g(radioTypes, function(radio) {
      if (indexOf(radio, type4) >= 0) {
        each$g(radio, function(item) {
          model.setIconStatus(item, "normal");
        });
      }
    });
    model.setIconStatus(type4, "emphasis");
    ecModel.eachComponent({
      mainType: "series",
      query: seriesIndex == null ? null : {
        seriesIndex
      }
    }, generateNewSeriesTypes);
    var newTitle;
    var currentType = type4;
    if (type4 === "stack") {
      newTitle = merge({
        stack: model.option.title.tiled,
        tiled: model.option.title.stack
      }, model.option.title);
      if (model.get(["iconStatus", type4]) !== "emphasis") {
        currentType = "tiled";
      }
    }
    api.dispatchAction({
      type: "changeMagicType",
      currentType,
      newOption,
      newTitle,
      featureName: "magicType"
    });
  };
  return MagicType2;
}(ToolboxFeature);
var seriesOptGenreator = {
  "line": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "bar") {
      return merge({
        id: seriesId,
        type: "line",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "line"]) || {}, true);
    }
  },
  "bar": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "line") {
      return merge({
        id: seriesId,
        type: "bar",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "bar"]) || {}, true);
    }
  },
  "stack": function(seriesType2, seriesId, seriesModel, model) {
    var isStack = seriesModel.get("stack") === INNER_STACK_KEYWORD;
    if (seriesType2 === "line" || seriesType2 === "bar") {
      model.setIconStatus("stack", isStack ? "normal" : "emphasis");
      return merge({
        id: seriesId,
        stack: isStack ? "" : INNER_STACK_KEYWORD
      }, model.get(["option", "stack"]) || {}, true);
    }
  }
};
registerAction({
  type: "changeMagicType",
  event: "magicTypeChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.mergeOption(payload.newOption);
});
var MagicType$1 = MagicType;
var BLOCK_SPLITER = new Array(60).join("-");
var ITEM_SPLITER = "	";
function groupSeries(ecModel) {
  var seriesGroupByCategoryAxis = {};
  var otherSeries = [];
  var meta = [];
  ecModel.eachRawSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && (coordSys.type === "cartesian2d" || coordSys.type === "polar")) {
      var baseAxis = coordSys.getBaseAxis();
      if (baseAxis.type === "category") {
        var key = baseAxis.dim + "_" + baseAxis.index;
        if (!seriesGroupByCategoryAxis[key]) {
          seriesGroupByCategoryAxis[key] = {
            categoryAxis: baseAxis,
            valueAxis: coordSys.getOtherAxis(baseAxis),
            series: []
          };
          meta.push({
            axisDim: baseAxis.dim,
            axisIndex: baseAxis.index
          });
        }
        seriesGroupByCategoryAxis[key].series.push(seriesModel);
      } else {
        otherSeries.push(seriesModel);
      }
    } else {
      otherSeries.push(seriesModel);
    }
  });
  return {
    seriesGroupByCategoryAxis,
    other: otherSeries,
    meta
  };
}
function assembleSeriesWithCategoryAxis(groups) {
  var tables = [];
  each$g(groups, function(group, key) {
    var categoryAxis2 = group.categoryAxis;
    var valueAxis2 = group.valueAxis;
    var valueAxisDim = valueAxis2.dim;
    var headers = [" "].concat(map$1(group.series, function(series) {
      return series.name;
    }));
    var columns = [categoryAxis2.model.getCategories()];
    each$g(group.series, function(series) {
      var rawData = series.getRawData();
      columns.push(series.getRawData().mapArray(rawData.mapDimension(valueAxisDim), function(val) {
        return val;
      }));
    });
    var lines = [headers.join(ITEM_SPLITER)];
    for (var i = 0; i < columns[0].length; i++) {
      var items = [];
      for (var j = 0; j < columns.length; j++) {
        items.push(columns[j][i]);
      }
      lines.push(items.join(ITEM_SPLITER));
    }
    tables.push(lines.join("\n"));
  });
  return tables.join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function assembleOtherSeries(series) {
  return map$1(series, function(series2) {
    var data = series2.getRawData();
    var lines = [series2.name];
    var vals = [];
    data.each(data.dimensions, function() {
      var argLen = arguments.length;
      var dataIndex = arguments[argLen - 1];
      var name = data.getName(dataIndex);
      for (var i = 0; i < argLen - 1; i++) {
        vals[i] = arguments[i];
      }
      lines.push((name ? name + ITEM_SPLITER : "") + vals.join(ITEM_SPLITER));
    });
    return lines.join("\n");
  }).join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function getContentFromModel(ecModel) {
  var result = groupSeries(ecModel);
  return {
    value: filter([assembleSeriesWithCategoryAxis(result.seriesGroupByCategoryAxis), assembleOtherSeries(result.other)], function(str) {
      return !!str.replace(/[\n\t\s]/g, "");
    }).join("\n\n" + BLOCK_SPLITER + "\n\n"),
    meta: result.meta
  };
}
function trim(str) {
  return str.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
}
function isTSVFormat(block) {
  var firstLine = block.slice(0, block.indexOf("\n"));
  if (firstLine.indexOf(ITEM_SPLITER) >= 0) {
    return true;
  }
}
var itemSplitRegex = new RegExp("[" + ITEM_SPLITER + "]+", "g");
function parseTSVContents(tsv) {
  var tsvLines = tsv.split(/\n+/g);
  var headers = trim(tsvLines.shift()).split(itemSplitRegex);
  var categories = [];
  var series = map$1(headers, function(header) {
    return {
      name: header,
      data: []
    };
  });
  for (var i = 0; i < tsvLines.length; i++) {
    var items = trim(tsvLines[i]).split(itemSplitRegex);
    categories.push(items.shift());
    for (var j = 0; j < items.length; j++) {
      series[j] && (series[j].data[i] = items[j]);
    }
  }
  return {
    series,
    categories
  };
}
function parseListContents(str) {
  var lines = str.split(/\n+/g);
  var seriesName = trim(lines.shift());
  var data = [];
  for (var i = 0; i < lines.length; i++) {
    var line = trim(lines[i]);
    if (!line) {
      continue;
    }
    var items = line.split(itemSplitRegex);
    var name_1 = "";
    var value = void 0;
    var hasName = false;
    if (isNaN(items[0])) {
      hasName = true;
      name_1 = items[0];
      items = items.slice(1);
      data[i] = {
        name: name_1,
        value: []
      };
      value = data[i].value;
    } else {
      value = data[i] = [];
    }
    for (var j = 0; j < items.length; j++) {
      value.push(+items[j]);
    }
    if (value.length === 1) {
      hasName ? data[i].value = value[0] : data[i] = value[0];
    }
  }
  return {
    name: seriesName,
    data
  };
}
function parseContents(str, blockMetaList) {
  var blocks = str.split(new RegExp("\n*" + BLOCK_SPLITER + "\n*", "g"));
  var newOption = {
    series: []
  };
  each$g(blocks, function(block, idx) {
    if (isTSVFormat(block)) {
      var result = parseTSVContents(block);
      var blockMeta = blockMetaList[idx];
      var axisKey = blockMeta.axisDim + "Axis";
      if (blockMeta) {
        newOption[axisKey] = newOption[axisKey] || [];
        newOption[axisKey][blockMeta.axisIndex] = {
          data: result.categories
        };
        newOption.series = newOption.series.concat(result.series);
      }
    } else {
      var result = parseListContents(block);
      newOption.series.push(result);
    }
  });
  return newOption;
}
var DataView = function(_super) {
  __extends(DataView2, _super);
  function DataView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataView2.prototype.onclick = function(ecModel, api) {
    setTimeout(function() {
      api.dispatchAction({
        type: "hideTip"
      });
    });
    var container2 = api.getDom();
    var model = this.model;
    if (this._dom) {
      container2.removeChild(this._dom);
    }
    var root2 = document.createElement("div");
    root2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px";
    root2.style.backgroundColor = model.get("backgroundColor") || "#fff";
    var header = document.createElement("h4");
    var lang = model.get("lang") || [];
    header.innerHTML = lang[0] || model.get("title");
    header.style.cssText = "margin:10px 20px";
    header.style.color = model.get("textColor");
    var viewMain = document.createElement("div");
    var textarea = document.createElement("textarea");
    viewMain.style.cssText = "overflow:auto";
    var optionToContent = model.get("optionToContent");
    var contentToOption = model.get("contentToOption");
    var result = getContentFromModel(ecModel);
    if (isFunction(optionToContent)) {
      var htmlOrDom = optionToContent(api.getOption());
      if (isString$1(htmlOrDom)) {
        viewMain.innerHTML = htmlOrDom;
      } else if (isDom(htmlOrDom)) {
        viewMain.appendChild(htmlOrDom);
      }
    } else {
      textarea.readOnly = model.get("readOnly");
      var style2 = textarea.style;
      style2.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none";
      style2.color = model.get("textColor");
      style2.borderColor = model.get("textareaBorderColor");
      style2.backgroundColor = model.get("textareaColor");
      textarea.value = result.value;
      viewMain.appendChild(textarea);
    }
    var blockMetaList = result.meta;
    var buttonContainer = document.createElement("div");
    buttonContainer.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
    var buttonStyle = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px";
    var closeButton = document.createElement("div");
    var refreshButton = document.createElement("div");
    buttonStyle += ";background-color:" + model.get("buttonColor");
    buttonStyle += ";color:" + model.get("buttonTextColor");
    var self2 = this;
    function close() {
      container2.removeChild(root2);
      self2._dom = null;
    }
    addEventListener$1(closeButton, "click", close);
    addEventListener$1(refreshButton, "click", function() {
      if (contentToOption == null && optionToContent != null || contentToOption != null && optionToContent == null) {
        close();
        return;
      }
      var newOption;
      try {
        if (isFunction(contentToOption)) {
          newOption = contentToOption(viewMain, api.getOption());
        } else {
          newOption = parseContents(textarea.value, blockMetaList);
        }
      } catch (e2) {
        close();
        throw new Error("Data view format error " + e2);
      }
      if (newOption) {
        api.dispatchAction({
          type: "changeDataView",
          newOption
        });
      }
      close();
    });
    closeButton.innerHTML = lang[1];
    refreshButton.innerHTML = lang[2];
    refreshButton.style.cssText = closeButton.style.cssText = buttonStyle;
    !model.get("readOnly") && buttonContainer.appendChild(refreshButton);
    buttonContainer.appendChild(closeButton);
    root2.appendChild(header);
    root2.appendChild(viewMain);
    root2.appendChild(buttonContainer);
    viewMain.style.height = container2.clientHeight - 80 + "px";
    container2.appendChild(root2);
    this._dom = root2;
  };
  DataView2.prototype.remove = function(ecModel, api) {
    this._dom && api.getDom().removeChild(this._dom);
  };
  DataView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  DataView2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      readOnly: false,
      optionToContent: null,
      contentToOption: null,
      icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28",
      title: ecModel.getLocaleModel().get(["toolbox", "dataView", "title"]),
      lang: ecModel.getLocaleModel().get(["toolbox", "dataView", "lang"]),
      backgroundColor: "#fff",
      textColor: "#000",
      textareaColor: "#fff",
      textareaBorderColor: "#333",
      buttonColor: "#c23531",
      buttonTextColor: "#fff"
    };
    return defaultOption2;
  };
  return DataView2;
}(ToolboxFeature);
function tryMergeDataOption(newData, originalData) {
  return map$1(newData, function(newVal, idx) {
    var original = originalData && originalData[idx];
    if (isObject$4(original) && !isArray$1(original)) {
      var newValIsObject = isObject$4(newVal) && !isArray$1(newVal);
      if (!newValIsObject) {
        newVal = {
          value: newVal
        };
      }
      var shouldDeleteName = original.name != null && newVal.name == null;
      newVal = defaults(newVal, original);
      shouldDeleteName && delete newVal.name;
      return newVal;
    } else {
      return newVal;
    }
  });
}
registerAction({
  type: "changeDataView",
  event: "dataViewChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  var newSeriesOptList = [];
  each$g(payload.newOption.series, function(seriesOpt) {
    var seriesModel = ecModel.getSeriesByName(seriesOpt.name)[0];
    if (!seriesModel) {
      newSeriesOptList.push(extend({
        type: "scatter"
      }, seriesOpt));
    } else {
      var originalData = seriesModel.get("data");
      newSeriesOptList.push({
        name: seriesOpt.name,
        data: tryMergeDataOption(seriesOpt.data, originalData)
      });
    }
  });
  ecModel.mergeOption(defaults({
    series: newSeriesOptList
  }, payload.newOption));
});
var DataView$1 = DataView;
var each$7 = each$g;
var inner$6 = makeInner();
function push(ecModel, newSnapshot) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  each$7(newSnapshot, function(batchItem, dataZoomId) {
    var i = storedSnapshots.length - 1;
    for (; i >= 0; i--) {
      var snapshot = storedSnapshots[i];
      if (snapshot[dataZoomId]) {
        break;
      }
    }
    if (i < 0) {
      var dataZoomModel = ecModel.queryComponents({
        mainType: "dataZoom",
        subType: "select",
        id: dataZoomId
      })[0];
      if (dataZoomModel) {
        var percentRange = dataZoomModel.getPercentRange();
        storedSnapshots[0][dataZoomId] = {
          dataZoomId,
          start: percentRange[0],
          end: percentRange[1]
        };
      }
    }
  });
  storedSnapshots.push(newSnapshot);
}
function pop(ecModel) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  var head = storedSnapshots[storedSnapshots.length - 1];
  storedSnapshots.length > 1 && storedSnapshots.pop();
  var snapshot = {};
  each$7(head, function(batchItem, dataZoomId) {
    for (var i = storedSnapshots.length - 1; i >= 0; i--) {
      batchItem = storedSnapshots[i][dataZoomId];
      if (batchItem) {
        snapshot[dataZoomId] = batchItem;
        break;
      }
    }
  });
  return snapshot;
}
function clear(ecModel) {
  inner$6(ecModel).snapshots = null;
}
function count(ecModel) {
  return getStoreSnapshots(ecModel).length;
}
function getStoreSnapshots(ecModel) {
  var store = inner$6(ecModel);
  if (!store.snapshots) {
    store.snapshots = [{}];
  }
  return store.snapshots;
}
var RestoreOption = function(_super) {
  __extends(RestoreOption2, _super);
  function RestoreOption2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  RestoreOption2.prototype.onclick = function(ecModel, api) {
    clear(ecModel);
    api.dispatchAction({
      type: "restore",
      from: this.uid
    });
  };
  RestoreOption2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5",
      title: ecModel.getLocaleModel().get(["toolbox", "restore", "title"])
    };
    return defaultOption2;
  };
  return RestoreOption2;
}(ToolboxFeature);
registerAction({
  type: "restore",
  event: "restore",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.resetOption("recreate");
});
var Restore = RestoreOption;
var INCLUDE_FINDER_MAIN_TYPES = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"];
var BrushTargetManager = function() {
  function BrushTargetManager2(finder, ecModel, opt) {
    var _this = this;
    this._targetInfoList = [];
    var foundCpts = parseFinder(ecModel, finder);
    each$g(targetInfoBuilders, function(builder, type4) {
      if (!opt || !opt.include || indexOf(opt.include, type4) >= 0) {
        builder(foundCpts, _this._targetInfoList);
      }
    });
  }
  BrushTargetManager2.prototype.setOutputRanges = function(areas, ecModel) {
    this.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      (area.coordRanges || (area.coordRanges = [])).push(coordRange);
      if (!area.coordRange) {
        area.coordRange = coordRange;
        var result = coordConvert[area.brushType](0, coordSys, coordRange);
        area.__rangeOffset = {
          offset: diffProcessor[area.brushType](result.values, area.range, [1, 1]),
          xyMinMax: result.xyMinMax
        };
      }
    });
    return areas;
  };
  BrushTargetManager2.prototype.matchOutputRanges = function(areas, ecModel, cb2) {
    each$g(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      if (targetInfo && targetInfo !== true) {
        each$g(targetInfo.coordSyses, function(coordSys) {
          var result = coordConvert[area.brushType](1, coordSys, area.range, true);
          cb2(area, result.values, coordSys, ecModel);
        });
      }
    }, this);
  };
  BrushTargetManager2.prototype.setInputRanges = function(areas, ecModel) {
    each$g(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      area.range = area.range || [];
      if (targetInfo && targetInfo !== true) {
        area.panelId = targetInfo.panelId;
        var result = coordConvert[area.brushType](0, targetInfo.coordSys, area.coordRange);
        var rangeOffset = area.__rangeOffset;
        area.range = rangeOffset ? diffProcessor[area.brushType](result.values, rangeOffset.offset, getScales(result.xyMinMax, rangeOffset.xyMinMax)) : result.values;
      }
    }, this);
  };
  BrushTargetManager2.prototype.makePanelOpts = function(api, getDefaultBrushType) {
    return map$1(this._targetInfoList, function(targetInfo) {
      var rect = targetInfo.getPanelRect();
      return {
        panelId: targetInfo.panelId,
        defaultBrushType: getDefaultBrushType ? getDefaultBrushType(targetInfo) : null,
        clipPath: makeRectPanelClipPath(rect),
        isTargetByCursor: makeRectIsTargetByCursor(rect, api, targetInfo.coordSysModel),
        getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect)
      };
    });
  };
  BrushTargetManager2.prototype.controlSeries = function(area, seriesModel, ecModel) {
    var targetInfo = this.findTargetInfo(area, ecModel);
    return targetInfo === true || targetInfo && indexOf(targetInfo.coordSyses, seriesModel.coordinateSystem) >= 0;
  };
  BrushTargetManager2.prototype.findTargetInfo = function(area, ecModel) {
    var targetInfoList = this._targetInfoList;
    var foundCpts = parseFinder(ecModel, area);
    for (var i = 0; i < targetInfoList.length; i++) {
      var targetInfo = targetInfoList[i];
      var areaPanelId = area.panelId;
      if (areaPanelId) {
        if (targetInfo.panelId === areaPanelId) {
          return targetInfo;
        }
      } else {
        for (var j = 0; j < targetInfoMatchers.length; j++) {
          if (targetInfoMatchers[j](foundCpts, targetInfo)) {
            return targetInfo;
          }
        }
      }
    }
    return true;
  };
  return BrushTargetManager2;
}();
function formatMinMax(minMax) {
  minMax[0] > minMax[1] && minMax.reverse();
  return minMax;
}
function parseFinder(ecModel, finder) {
  return parseFinder$1(ecModel, finder, {
    includeMainTypes: INCLUDE_FINDER_MAIN_TYPES
  });
}
var targetInfoBuilders = {
  grid: function(foundCpts, targetInfoList) {
    var xAxisModels = foundCpts.xAxisModels;
    var yAxisModels = foundCpts.yAxisModels;
    var gridModels = foundCpts.gridModels;
    var gridModelMap = createHashMap();
    var xAxesHas = {};
    var yAxesHas = {};
    if (!xAxisModels && !yAxisModels && !gridModels) {
      return;
    }
    each$g(xAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
    });
    each$g(yAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      yAxesHas[gridModel.id] = true;
    });
    each$g(gridModels, function(gridModel) {
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
      yAxesHas[gridModel.id] = true;
    });
    gridModelMap.each(function(gridModel) {
      var grid = gridModel.coordinateSystem;
      var cartesians = [];
      each$g(grid.getCartesians(), function(cartesian, index2) {
        if (indexOf(xAxisModels, cartesian.getAxis("x").model) >= 0 || indexOf(yAxisModels, cartesian.getAxis("y").model) >= 0) {
          cartesians.push(cartesian);
        }
      });
      targetInfoList.push({
        panelId: "grid--" + gridModel.id,
        gridModel,
        coordSysModel: gridModel,
        coordSys: cartesians[0],
        coordSyses: cartesians,
        getPanelRect: panelRectBuilders.grid,
        xAxisDeclared: xAxesHas[gridModel.id],
        yAxisDeclared: yAxesHas[gridModel.id]
      });
    });
  },
  geo: function(foundCpts, targetInfoList) {
    each$g(foundCpts.geoModels, function(geoModel) {
      var coordSys = geoModel.coordinateSystem;
      targetInfoList.push({
        panelId: "geo--" + geoModel.id,
        geoModel,
        coordSysModel: geoModel,
        coordSys,
        coordSyses: [coordSys],
        getPanelRect: panelRectBuilders.geo
      });
    });
  }
};
var targetInfoMatchers = [
  function(foundCpts, targetInfo) {
    var xAxisModel = foundCpts.xAxisModel;
    var yAxisModel = foundCpts.yAxisModel;
    var gridModel = foundCpts.gridModel;
    !gridModel && xAxisModel && (gridModel = xAxisModel.axis.grid.model);
    !gridModel && yAxisModel && (gridModel = yAxisModel.axis.grid.model);
    return gridModel && gridModel === targetInfo.gridModel;
  },
  function(foundCpts, targetInfo) {
    var geoModel = foundCpts.geoModel;
    return geoModel && geoModel === targetInfo.geoModel;
  }
];
var panelRectBuilders = {
  grid: function() {
    return this.coordSys.master.getRect().clone();
  },
  geo: function() {
    var coordSys = this.coordSys;
    var rect = coordSys.getBoundingRect().clone();
    rect.applyTransform(getTransform$1(coordSys));
    return rect;
  }
};
var coordConvert = {
  lineX: curry$1(axisConvert, 0),
  lineY: curry$1(axisConvert, 1),
  rect: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xminymin = to ? coordSys.pointToData([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2);
    var xmaxymax = to ? coordSys.pointToData([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2);
    var values = [formatMinMax([xminymin[0], xmaxymax[0]]), formatMinMax([xminymin[1], xmaxymax[1]])];
    return {
      values,
      xyMinMax: values
    };
  },
  polygon: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xyMinMax = [[Infinity, -Infinity], [Infinity, -Infinity]];
    var values = map$1(rangeOrCoordRange, function(item) {
      var p2 = to ? coordSys.pointToData(item, clamp2) : coordSys.dataToPoint(item, clamp2);
      xyMinMax[0][0] = Math.min(xyMinMax[0][0], p2[0]);
      xyMinMax[1][0] = Math.min(xyMinMax[1][0], p2[1]);
      xyMinMax[0][1] = Math.max(xyMinMax[0][1], p2[0]);
      xyMinMax[1][1] = Math.max(xyMinMax[1][1], p2[1]);
      return p2;
    });
    return {
      values,
      xyMinMax
    };
  }
};
function axisConvert(axisNameIndex, to, coordSys, rangeOrCoordRange) {
  var axis = coordSys.getAxis(["x", "y"][axisNameIndex]);
  var values = formatMinMax(map$1([0, 1], function(i) {
    return to ? axis.coordToData(axis.toLocalCoord(rangeOrCoordRange[i]), true) : axis.toGlobalCoord(axis.dataToCoord(rangeOrCoordRange[i]));
  }));
  var xyMinMax = [];
  xyMinMax[axisNameIndex] = values;
  xyMinMax[1 - axisNameIndex] = [NaN, NaN];
  return {
    values,
    xyMinMax
  };
}
var diffProcessor = {
  lineX: curry$1(axisDiffProcessor, 0),
  lineY: curry$1(axisDiffProcessor, 1),
  rect: function(values, refer, scales) {
    return [[values[0][0] - scales[0] * refer[0][0], values[0][1] - scales[0] * refer[0][1]], [values[1][0] - scales[1] * refer[1][0], values[1][1] - scales[1] * refer[1][1]]];
  },
  polygon: function(values, refer, scales) {
    return map$1(values, function(item, idx) {
      return [item[0] - scales[0] * refer[idx][0], item[1] - scales[1] * refer[idx][1]];
    });
  }
};
function axisDiffProcessor(axisNameIndex, values, refer, scales) {
  return [values[0] - scales[axisNameIndex] * refer[0], values[1] - scales[axisNameIndex] * refer[1]];
}
function getScales(xyMinMaxCurr, xyMinMaxOrigin) {
  var sizeCurr = getSize(xyMinMaxCurr);
  var sizeOrigin = getSize(xyMinMaxOrigin);
  var scales = [sizeCurr[0] / sizeOrigin[0], sizeCurr[1] / sizeOrigin[1]];
  isNaN(scales[0]) && (scales[0] = 1);
  isNaN(scales[1]) && (scales[1] = 1);
  return scales;
}
function getSize(xyMinMax) {
  return xyMinMax ? [xyMinMax[0][1] - xyMinMax[0][0], xyMinMax[1][1] - xyMinMax[1][0]] : [NaN, NaN];
}
var BrushTargetManager$1 = BrushTargetManager;
var each$6 = each$g;
var DATA_ZOOM_ID_BASE = makeInternalComponentId("toolbox-dataZoom_");
var DataZoomFeature = function(_super) {
  __extends(DataZoomFeature2, _super);
  function DataZoomFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataZoomFeature2.prototype.render = function(featureModel, ecModel, api, payload) {
    if (!this._brushController) {
      this._brushController = new BrushController$1(api.getZr());
      this._brushController.on("brush", bind$1(this._onBrush, this)).mount();
    }
    updateZoomBtnStatus(featureModel, ecModel, this, payload, api);
    updateBackBtnStatus(featureModel, ecModel);
  };
  DataZoomFeature2.prototype.onclick = function(ecModel, api, type4) {
    handlers[type4].call(this);
  };
  DataZoomFeature2.prototype.remove = function(ecModel, api) {
    this._brushController && this._brushController.unmount();
  };
  DataZoomFeature2.prototype.dispose = function(ecModel, api) {
    this._brushController && this._brushController.dispose();
  };
  DataZoomFeature2.prototype._onBrush = function(eventParam) {
    var areas = eventParam.areas;
    if (!eventParam.isEnd || !areas.length) {
      return;
    }
    var snapshot = {};
    var ecModel = this.ecModel;
    this._brushController.updateCovers([]);
    var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(this.model), ecModel, {
      include: ["grid"]
    });
    brushTargetManager.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      if (coordSys.type !== "cartesian2d") {
        return;
      }
      var brushType = area.brushType;
      if (brushType === "rect") {
        setBatch("x", coordSys, coordRange[0]);
        setBatch("y", coordSys, coordRange[1]);
      } else {
        setBatch({
          lineX: "x",
          lineY: "y"
        }[brushType], coordSys, coordRange);
      }
    });
    push(ecModel, snapshot);
    this._dispatchZoomAction(snapshot);
    function setBatch(dimName, coordSys, minMax) {
      var axis = coordSys.getAxis(dimName);
      var axisModel = axis.model;
      var dataZoomModel = findDataZoom(dimName, axisModel, ecModel);
      var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy(axisModel).getMinMaxSpan();
      if (minMaxSpan.minValueSpan != null || minMaxSpan.maxValueSpan != null) {
        minMax = sliderMove(0, minMax.slice(), axis.scale.getExtent(), 0, minMaxSpan.minValueSpan, minMaxSpan.maxValueSpan);
      }
      dataZoomModel && (snapshot[dataZoomModel.id] = {
        dataZoomId: dataZoomModel.id,
        startValue: minMax[0],
        endValue: minMax[1]
      });
    }
    function findDataZoom(dimName, axisModel, ecModel2) {
      var found;
      ecModel2.eachComponent({
        mainType: "dataZoom",
        subType: "select"
      }, function(dzModel) {
        var has2 = dzModel.getAxisModel(dimName, axisModel.componentIndex);
        has2 && (found = dzModel);
      });
      return found;
    }
  };
  DataZoomFeature2.prototype._dispatchZoomAction = function(snapshot) {
    var batch = [];
    each$6(snapshot, function(batchItem, dataZoomId) {
      batch.push(clone$4(batchItem));
    });
    batch.length && this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      batch
    });
  };
  DataZoomFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      filterMode: "filter",
      icon: {
        zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1",
        back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "dataZoom", "title"]),
      brushStyle: {
        borderWidth: 0,
        color: "rgba(210,219,238,0.2)"
      }
    };
    return defaultOption2;
  };
  return DataZoomFeature2;
}(ToolboxFeature);
var handlers = {
  zoom: function() {
    var nextActive = !this._isZoomActive;
    this.api.dispatchAction({
      type: "takeGlobalCursor",
      key: "dataZoomSelect",
      dataZoomSelectActive: nextActive
    });
  },
  back: function() {
    this._dispatchZoomAction(pop(this.ecModel));
  }
};
function makeAxisFinder(dzFeatureModel) {
  var setting = {
    xAxisIndex: dzFeatureModel.get("xAxisIndex", true),
    yAxisIndex: dzFeatureModel.get("yAxisIndex", true),
    xAxisId: dzFeatureModel.get("xAxisId", true),
    yAxisId: dzFeatureModel.get("yAxisId", true)
  };
  if (setting.xAxisIndex == null && setting.xAxisId == null) {
    setting.xAxisIndex = "all";
  }
  if (setting.yAxisIndex == null && setting.yAxisId == null) {
    setting.yAxisIndex = "all";
  }
  return setting;
}
function updateBackBtnStatus(featureModel, ecModel) {
  featureModel.setIconStatus("back", count(ecModel) > 1 ? "emphasis" : "normal");
}
function updateZoomBtnStatus(featureModel, ecModel, view, payload, api) {
  var zoomActive = view._isZoomActive;
  if (payload && payload.type === "takeGlobalCursor") {
    zoomActive = payload.key === "dataZoomSelect" ? payload.dataZoomSelectActive : false;
  }
  view._isZoomActive = zoomActive;
  featureModel.setIconStatus("zoom", zoomActive ? "emphasis" : "normal");
  var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(featureModel), ecModel, {
    include: ["grid"]
  });
  var panels = brushTargetManager.makePanelOpts(api, function(targetInfo) {
    return targetInfo.xAxisDeclared && !targetInfo.yAxisDeclared ? "lineX" : !targetInfo.xAxisDeclared && targetInfo.yAxisDeclared ? "lineY" : "rect";
  });
  view._brushController.setPanels(panels).enableBrush(zoomActive && panels.length ? {
    brushType: "auto",
    brushStyle: featureModel.getModel("brushStyle").getItemStyle()
  } : false);
}
registerInternalOptionCreator("dataZoom", function(ecModel) {
  var toolboxModel = ecModel.getComponent("toolbox", 0);
  var featureDataZoomPath = ["feature", "dataZoom"];
  if (!toolboxModel || toolboxModel.get(featureDataZoomPath) == null) {
    return;
  }
  var dzFeatureModel = toolboxModel.getModel(featureDataZoomPath);
  var dzOptions = [];
  var finder = makeAxisFinder(dzFeatureModel);
  var finderResult = parseFinder$1(ecModel, finder);
  each$6(finderResult.xAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "xAxis", "xAxisIndex");
  });
  each$6(finderResult.yAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "yAxis", "yAxisIndex");
  });
  function buildInternalOptions(axisModel, axisMainType, axisIndexPropName) {
    var axisIndex = axisModel.componentIndex;
    var newOpt = {
      type: "select",
      $fromToolbox: true,
      filterMode: dzFeatureModel.get("filterMode", true) || "filter",
      id: DATA_ZOOM_ID_BASE + axisMainType + axisIndex
    };
    newOpt[axisIndexPropName] = axisIndex;
    dzOptions.push(newOpt);
  }
  return dzOptions;
});
var DataZoom = DataZoomFeature;
function install$j(registers) {
  registers.registerComponentModel(ToolboxModel$1);
  registers.registerComponentView(ToolboxView$1);
  registerFeature("saveAsImage", SaveAsImage$1);
  registerFeature("magicType", MagicType$1);
  registerFeature("dataView", DataView$1);
  registerFeature("dataZoom", DataZoom);
  registerFeature("restore", Restore);
  use(install$k);
}
var TooltipModel = function(_super) {
  __extends(TooltipModel2, _super);
  function TooltipModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipModel2.type;
    return _this;
  }
  TooltipModel2.type = "tooltip";
  TooltipModel2.dependencies = ["axisPointer"];
  TooltipModel2.defaultOption = {
    z: 60,
    show: true,
    showContent: true,
    trigger: "item",
    triggerOn: "mousemove|click",
    alwaysShowContent: false,
    displayMode: "single",
    renderMode: "auto",
    confine: null,
    showDelay: 0,
    hideDelay: 100,
    transitionDuration: 0.4,
    enterable: false,
    backgroundColor: "#fff",
    shadowBlur: 10,
    shadowColor: "rgba(0, 0, 0, .2)",
    shadowOffsetX: 1,
    shadowOffsetY: 2,
    borderRadius: 4,
    borderWidth: 1,
    padding: null,
    extraCssText: "",
    axisPointer: {
      type: "line",
      axis: "auto",
      animation: "auto",
      animationDurationUpdate: 200,
      animationEasingUpdate: "exponentialOut",
      crossStyle: {
        color: "#999",
        width: 1,
        type: "dashed",
        textStyle: {}
      }
    },
    textStyle: {
      color: "#666",
      fontSize: 14
    }
  };
  return TooltipModel2;
}(ComponentModel$1);
var TooltipModel$1 = TooltipModel;
function shouldTooltipConfine(tooltipModel) {
  var confineOption = tooltipModel.get("confine");
  return confineOption != null ? !!confineOption : tooltipModel.get("renderMode") === "richText";
}
function testStyle(styleProps) {
  if (!env$1.domSupported) {
    return;
  }
  var style2 = document.documentElement.style;
  for (var i = 0, len2 = styleProps.length; i < len2; i++) {
    if (styleProps[i] in style2) {
      return styleProps[i];
    }
  }
}
var TRANSFORM_VENDOR = testStyle(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]);
var TRANSITION_VENDOR = testStyle(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
function toCSSVendorPrefix(styleVendor, styleProp) {
  if (!styleVendor) {
    return styleProp;
  }
  styleProp = toCamelCase(styleProp, true);
  var idx = styleVendor.indexOf(styleProp);
  styleVendor = idx === -1 ? styleProp : "-" + styleVendor.slice(0, idx) + "-" + styleProp;
  return styleVendor.toLowerCase();
}
function getComputedStyle$1(el, style2) {
  var stl = el.currentStyle || document.defaultView && document.defaultView.getComputedStyle(el);
  return stl ? style2 ? stl[style2] : stl : null;
}
var CSS_TRANSITION_VENDOR = toCSSVendorPrefix(TRANSITION_VENDOR, "transition");
var CSS_TRANSFORM_VENDOR = toCSSVendorPrefix(TRANSFORM_VENDOR, "transform");
var gCssText = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (env$1.transform3dSupported ? "will-change:transform;" : "");
function mirrorPos(pos) {
  pos = pos === "left" ? "right" : pos === "right" ? "left" : pos === "top" ? "bottom" : "top";
  return pos;
}
function assembleArrow(tooltipModel, borderColor, arrowPosition) {
  if (!isString$1(arrowPosition) || arrowPosition === "inside") {
    return "";
  }
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var borderWidth = tooltipModel.get("borderWidth");
  borderColor = convertToColorString(borderColor);
  var arrowPos = mirrorPos(arrowPosition);
  var arrowSize = Math.max(Math.round(borderWidth) * 1.5, 6);
  var positionStyle = "";
  var transformStyle = CSS_TRANSFORM_VENDOR + ":";
  var rotateDeg;
  if (indexOf(["left", "right"], arrowPos) > -1) {
    positionStyle += "top:50%";
    transformStyle += "translateY(-50%) rotate(" + (rotateDeg = arrowPos === "left" ? -225 : -45) + "deg)";
  } else {
    positionStyle += "left:50%";
    transformStyle += "translateX(-50%) rotate(" + (rotateDeg = arrowPos === "top" ? 225 : 45) + "deg)";
  }
  var rotateRadian = rotateDeg * Math.PI / 180;
  var arrowWH = arrowSize + borderWidth;
  var rotatedWH = arrowWH * Math.abs(Math.cos(rotateRadian)) + arrowWH * Math.abs(Math.sin(rotateRadian));
  var arrowOffset = Math.round(((rotatedWH - Math.SQRT2 * borderWidth) / 2 + Math.SQRT2 * borderWidth - (rotatedWH - arrowWH) / 2) * 100) / 100;
  positionStyle += ";" + arrowPos + ":-" + arrowOffset + "px";
  var borderStyle = borderColor + " solid " + borderWidth + "px;";
  var styleCss = ["position:absolute;width:" + arrowSize + "px;height:" + arrowSize + "px;", positionStyle + ";" + transformStyle + ";", "border-bottom:" + borderStyle, "border-right:" + borderStyle, "background-color:" + backgroundColor2 + ";"];
  return '<div style="' + styleCss.join("") + '"></div>';
}
function assembleTransition(duration, onlyFade) {
  var transitionCurve = "cubic-bezier(0.23,1,0.32,1)";
  var transitionOption = " " + duration / 2 + "s " + transitionCurve;
  var transitionText = "opacity" + transitionOption + ",visibility" + transitionOption;
  if (!onlyFade) {
    transitionOption = " " + duration + "s " + transitionCurve;
    transitionText += env$1.transformSupported ? "," + CSS_TRANSFORM_VENDOR + transitionOption : ",left" + transitionOption + ",top" + transitionOption;
  }
  return CSS_TRANSITION_VENDOR + ":" + transitionText;
}
function assembleTransform(x2, y2, toString) {
  var x0 = x2.toFixed(0) + "px";
  var y0 = y2.toFixed(0) + "px";
  if (!env$1.transformSupported) {
    return toString ? "top:" + y0 + ";left:" + x0 + ";" : [["top", y0], ["left", x0]];
  }
  var is3d = env$1.transform3dSupported;
  var translate2 = "translate" + (is3d ? "3d" : "") + "(" + x0 + "," + y0 + (is3d ? ",0" : "") + ")";
  return toString ? "top:0;left:0;" + CSS_TRANSFORM_VENDOR + ":" + translate2 + ";" : [["top", 0], ["left", 0], [TRANSFORM_VENDOR, translate2]];
}
function assembleFont(textStyleModel) {
  var cssText = [];
  var fontSize = textStyleModel.get("fontSize");
  var color = textStyleModel.getTextColor();
  color && cssText.push("color:" + color);
  cssText.push("font:" + textStyleModel.getFont());
  fontSize && cssText.push("line-height:" + Math.round(fontSize * 3 / 2) + "px");
  var shadowColor = textStyleModel.get("textShadowColor");
  var shadowBlur = textStyleModel.get("textShadowBlur") || 0;
  var shadowOffsetX = textStyleModel.get("textShadowOffsetX") || 0;
  var shadowOffsetY = textStyleModel.get("textShadowOffsetY") || 0;
  shadowColor && shadowBlur && cssText.push("text-shadow:" + shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor);
  each$g(["decoration", "align"], function(name) {
    var val = textStyleModel.get(name);
    val && cssText.push("text-" + name + ":" + val);
  });
  return cssText.join(";");
}
function assembleCssText(tooltipModel, enableTransition, onlyFade) {
  var cssText = [];
  var transitionDuration = tooltipModel.get("transitionDuration");
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var shadowBlur = tooltipModel.get("shadowBlur");
  var shadowColor = tooltipModel.get("shadowColor");
  var shadowOffsetX = tooltipModel.get("shadowOffsetX");
  var shadowOffsetY = tooltipModel.get("shadowOffsetY");
  var textStyleModel = tooltipModel.getModel("textStyle");
  var padding = getPaddingFromTooltipModel(tooltipModel, "html");
  var boxShadow = shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor;
  cssText.push("box-shadow:" + boxShadow);
  enableTransition && transitionDuration && cssText.push(assembleTransition(transitionDuration, onlyFade));
  if (backgroundColor2) {
    cssText.push("background-color:" + backgroundColor2);
  }
  each$g(["width", "color", "radius"], function(name) {
    var borderName = "border-" + name;
    var camelCase = toCamelCase(borderName);
    var val = tooltipModel.get(camelCase);
    val != null && cssText.push(borderName + ":" + val + (name === "color" ? "" : "px"));
  });
  cssText.push(assembleFont(textStyleModel));
  if (padding != null) {
    cssText.push("padding:" + normalizeCssArray(padding).join("px ") + "px");
  }
  return cssText.join(";") + ";";
}
function makeStyleCoord$1(out2, zr, appendToBody, zrX, zrY) {
  var zrPainter = zr && zr.painter;
  if (appendToBody) {
    var zrViewportRoot = zrPainter && zrPainter.getViewportRoot();
    if (zrViewportRoot) {
      transformLocalCoord(out2, zrViewportRoot, document.body, zrX, zrY);
    }
  } else {
    out2[0] = zrX;
    out2[1] = zrY;
    var viewportRootOffset = zrPainter && zrPainter.getViewportRootOffset();
    if (viewportRootOffset) {
      out2[0] += viewportRootOffset.offsetLeft;
      out2[1] += viewportRootOffset.offsetTop;
    }
  }
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipHTMLContent = function() {
  function TooltipHTMLContent2(container2, api, opt) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._firstShow = true;
    this._longHide = true;
    if (env$1.wxa) {
      return null;
    }
    var el = document.createElement("div");
    el.domBelongToZr = true;
    this.el = el;
    var zr = this._zr = api.getZr();
    var appendToBody = this._appendToBody = opt && opt.appendToBody;
    makeStyleCoord$1(this._styleCoord, zr, appendToBody, api.getWidth() / 2, api.getHeight() / 2);
    if (appendToBody) {
      document.body.appendChild(el);
    } else {
      container2.appendChild(el);
    }
    this._container = container2;
    var self2 = this;
    el.onmouseenter = function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    };
    el.onmousemove = function(e2) {
      e2 = e2 || window.event;
      if (!self2._enterable) {
        var handler = zr.handler;
        var zrViewportRoot = zr.painter.getViewportRoot();
        normalizeEvent(zrViewportRoot, e2, true);
        handler.dispatch("mousemove", e2);
      }
    };
    el.onmouseleave = function() {
      self2._inContent = false;
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
    };
  }
  TooltipHTMLContent2.prototype.update = function(tooltipModel) {
    var container2 = this._container;
    var position2 = getComputedStyle$1(container2, "position");
    var domStyle = container2.style;
    if (domStyle.position !== "absolute" && position2 !== "absolute") {
      domStyle.position = "relative";
    }
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
    this.el.className = tooltipModel.get("className") || "";
  };
  TooltipHTMLContent2.prototype.show = function(tooltipModel, nearPointColor) {
    clearTimeout(this._hideTimeout);
    clearTimeout(this._longHideTimeout);
    var el = this.el;
    var style2 = el.style;
    var styleCoord = this._styleCoord;
    if (!el.innerHTML) {
      style2.display = "none";
    } else {
      style2.cssText = gCssText + assembleCssText(tooltipModel, !this._firstShow, this._longHide) + assembleTransform(styleCoord[0], styleCoord[1], true) + ("border-color:" + convertToColorString(nearPointColor) + ";") + (tooltipModel.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none"));
    }
    this._show = true;
    this._firstShow = false;
    this._longHide = false;
  };
  TooltipHTMLContent2.prototype.setContent = function(content, markers, tooltipModel, borderColor, arrowPosition) {
    var el = this.el;
    if (content == null) {
      el.innerHTML = "";
      return;
    }
    var arrow = "";
    if (isString$1(arrowPosition) && tooltipModel.get("trigger") === "item" && !shouldTooltipConfine(tooltipModel)) {
      arrow = assembleArrow(tooltipModel, borderColor, arrowPosition);
    }
    if (isString$1(content)) {
      el.innerHTML = content + arrow;
    } else if (content) {
      el.innerHTML = "";
      if (!isArray$1(content)) {
        content = [content];
      }
      for (var i = 0; i < content.length; i++) {
        if (isDom(content[i]) && content[i].parentNode !== el) {
          el.appendChild(content[i]);
        }
      }
      if (arrow && el.childNodes.length) {
        var arrowEl = document.createElement("div");
        arrowEl.innerHTML = arrow;
        el.appendChild(arrowEl);
      }
    }
  };
  TooltipHTMLContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipHTMLContent2.prototype.getSize = function() {
    var el = this.el;
    return [el.offsetWidth, el.offsetHeight];
  };
  TooltipHTMLContent2.prototype.moveTo = function(zrX, zrY) {
    var styleCoord = this._styleCoord;
    makeStyleCoord$1(styleCoord, this._zr, this._appendToBody, zrX, zrY);
    if (styleCoord[0] != null && styleCoord[1] != null) {
      var style_1 = this.el.style;
      var transforms = assembleTransform(styleCoord[0], styleCoord[1]);
      each$g(transforms, function(transform2) {
        style_1[transform2[0]] = transform2[1];
      });
    }
  };
  TooltipHTMLContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipHTMLContent2.prototype.hide = function() {
    var _this = this;
    var style2 = this.el.style;
    style2.visibility = "hidden";
    style2.opacity = "0";
    env$1.transform3dSupported && (style2.willChange = "");
    this._show = false;
    this._longHideTimeout = setTimeout(function() {
      return _this._longHide = true;
    }, 500);
  };
  TooltipHTMLContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipHTMLContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipHTMLContent2.prototype.dispose = function() {
    this.el.parentNode.removeChild(this.el);
  };
  return TooltipHTMLContent2;
}();
var TooltipHTMLContent$1 = TooltipHTMLContent;
var TooltipRichContent = function() {
  function TooltipRichContent2(api) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._zr = api.getZr();
    makeStyleCoord(this._styleCoord, this._zr, api.getWidth() / 2, api.getHeight() / 2);
  }
  TooltipRichContent2.prototype.update = function(tooltipModel) {
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
  };
  TooltipRichContent2.prototype.show = function() {
    if (this._hideTimeout) {
      clearTimeout(this._hideTimeout);
    }
    this.el.show();
    this._show = true;
  };
  TooltipRichContent2.prototype.setContent = function(content, markupStyleCreator, tooltipModel, borderColor, arrowPosition) {
    var _this = this;
    if (isObject$4(content)) {
      throwError("");
    }
    if (this.el) {
      this._zr.remove(this.el);
    }
    var textStyleModel = tooltipModel.getModel("textStyle");
    this.el = new ZRText$1({
      style: {
        rich: markupStyleCreator.richTextStyles,
        text: content,
        lineHeight: 22,
        borderWidth: 1,
        borderColor,
        textShadowColor: textStyleModel.get("textShadowColor"),
        fill: tooltipModel.get(["textStyle", "color"]),
        padding: getPaddingFromTooltipModel(tooltipModel, "richText"),
        verticalAlign: "top",
        align: "left"
      },
      z: tooltipModel.get("z")
    });
    each$g(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(propName) {
      _this.el.style[propName] = tooltipModel.get(propName);
    });
    each$g(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(propName) {
      _this.el.style[propName] = textStyleModel.get(propName) || 0;
    });
    this._zr.add(this.el);
    var self2 = this;
    this.el.on("mouseover", function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    });
    this.el.on("mouseout", function() {
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
      self2._inContent = false;
    });
  };
  TooltipRichContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipRichContent2.prototype.getSize = function() {
    var el = this.el;
    var bounding = this.el.getBoundingRect();
    var shadowOuterSize = calcShadowOuterSize(el.style);
    return [bounding.width + shadowOuterSize.left + shadowOuterSize.right, bounding.height + shadowOuterSize.top + shadowOuterSize.bottom];
  };
  TooltipRichContent2.prototype.moveTo = function(x2, y2) {
    var el = this.el;
    if (el) {
      var styleCoord = this._styleCoord;
      makeStyleCoord(styleCoord, this._zr, x2, y2);
      x2 = styleCoord[0];
      y2 = styleCoord[1];
      var style2 = el.style;
      var borderWidth = mathMaxWith0(style2.borderWidth || 0);
      var shadowOuterSize = calcShadowOuterSize(style2);
      el.x = x2 + borderWidth + shadowOuterSize.left;
      el.y = y2 + borderWidth + shadowOuterSize.top;
      el.markRedraw();
    }
  };
  TooltipRichContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipRichContent2.prototype.hide = function() {
    if (this.el) {
      this.el.hide();
    }
    this._show = false;
  };
  TooltipRichContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipRichContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipRichContent2.prototype.dispose = function() {
    this._zr.remove(this.el);
  };
  return TooltipRichContent2;
}();
function mathMaxWith0(val) {
  return Math.max(0, val);
}
function calcShadowOuterSize(style2) {
  var shadowBlur = mathMaxWith0(style2.shadowBlur || 0);
  var shadowOffsetX = mathMaxWith0(style2.shadowOffsetX || 0);
  var shadowOffsetY = mathMaxWith0(style2.shadowOffsetY || 0);
  return {
    left: mathMaxWith0(shadowBlur - shadowOffsetX),
    right: mathMaxWith0(shadowBlur + shadowOffsetX),
    top: mathMaxWith0(shadowBlur - shadowOffsetY),
    bottom: mathMaxWith0(shadowBlur + shadowOffsetY)
  };
}
function makeStyleCoord(out2, zr, zrX, zrY) {
  out2[0] = zrX;
  out2[1] = zrY;
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipRichContent$1 = TooltipRichContent;
var proxyRect = new Rect$3({
  shape: {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  }
});
var TooltipView = function(_super) {
  __extends(TooltipView2, _super);
  function TooltipView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipView2.type;
    return _this;
  }
  TooltipView2.prototype.init = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    var tooltipModel = ecModel.getComponent("tooltip");
    var renderMode = this._renderMode = getTooltipRenderMode(tooltipModel.get("renderMode"));
    this._tooltipContent = renderMode === "richText" ? new TooltipRichContent$1(api) : new TooltipHTMLContent$1(api.getDom(), api, {
      appendToBody: tooltipModel.get("appendToBody", true)
    });
  };
  TooltipView2.prototype.render = function(tooltipModel, ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    this.group.removeAll();
    this._tooltipModel = tooltipModel;
    this._ecModel = ecModel;
    this._api = api;
    this._alwaysShowContent = tooltipModel.get("alwaysShowContent");
    var tooltipContent = this._tooltipContent;
    tooltipContent.update(tooltipModel);
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    this._initGlobalListener();
    this._keepShow();
    if (this._renderMode !== "richText" && tooltipModel.get("transitionDuration")) {
      createOrUpdate(this, "_updatePosition", 50, "fixRate");
    } else {
      clear$1(this, "_updatePosition");
    }
  };
  TooltipView2.prototype._initGlobalListener = function() {
    var tooltipModel = this._tooltipModel;
    var triggerOn = tooltipModel.get("triggerOn");
    register("itemTooltip", this._api, bind$1(function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none") {
        if (triggerOn.indexOf(currTrigger) >= 0) {
          this._tryShow(e2, dispatchAction2);
        } else if (currTrigger === "leave") {
          this._hide(dispatchAction2);
        }
      }
    }, this));
  };
  TooltipView2.prototype._keepShow = function() {
    var tooltipModel = this._tooltipModel;
    var ecModel = this._ecModel;
    var api = this._api;
    if (this._lastX != null && this._lastY != null && tooltipModel.get("triggerOn") !== "none") {
      var self_1 = this;
      clearTimeout(this._refreshUpdateTimeout);
      this._refreshUpdateTimeout = setTimeout(function() {
        !api.isDisposed() && self_1.manuallyShowTip(tooltipModel, ecModel, api, {
          x: self_1._lastX,
          y: self_1._lastY,
          dataByCoordSys: self_1._lastDataByCoordSys
        });
      });
    }
  };
  TooltipView2.prototype.manuallyShowTip = function(tooltipModel, ecModel, api, payload) {
    if (payload.from === this.uid || env$1.node || !api.getDom()) {
      return;
    }
    var dispatchAction2 = makeDispatchAction(payload, api);
    this._ticket = "";
    var dataByCoordSys = payload.dataByCoordSys;
    var cmptRef = findComponentReference(payload, ecModel, api);
    if (cmptRef) {
      var rect = cmptRef.el.getBoundingRect().clone();
      rect.applyTransform(cmptRef.el.transform);
      this._tryShow({
        offsetX: rect.x + rect.width / 2,
        offsetY: rect.y + rect.height / 2,
        target: cmptRef.el,
        position: payload.position,
        positionDefault: "bottom"
      }, dispatchAction2);
    } else if (payload.tooltip && payload.x != null && payload.y != null) {
      var el = proxyRect;
      el.x = payload.x;
      el.y = payload.y;
      el.update();
      getECData(el).tooltipConfig = {
        name: null,
        option: payload.tooltip
      };
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        target: el
      }, dispatchAction2);
    } else if (dataByCoordSys) {
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        dataByCoordSys,
        tooltipOption: payload.tooltipOption
      }, dispatchAction2);
    } else if (payload.seriesIndex != null) {
      if (this._manuallyAxisShowTip(tooltipModel, ecModel, api, payload)) {
        return;
      }
      var pointInfo = findPointFromSeries(payload, ecModel);
      var cx = pointInfo.point[0];
      var cy = pointInfo.point[1];
      if (cx != null && cy != null) {
        this._tryShow({
          offsetX: cx,
          offsetY: cy,
          target: pointInfo.el,
          position: payload.position,
          positionDefault: "bottom"
        }, dispatchAction2);
      }
    } else if (payload.x != null && payload.y != null) {
      api.dispatchAction({
        type: "updateAxisPointer",
        x: payload.x,
        y: payload.y
      });
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        target: api.getZr().findHover(payload.x, payload.y).target
      }, dispatchAction2);
    }
  };
  TooltipView2.prototype.manuallyHideTip = function(tooltipModel, ecModel, api, payload) {
    var tooltipContent = this._tooltipContent;
    if (!this._alwaysShowContent && this._tooltipModel) {
      tooltipContent.hideLater(this._tooltipModel.get("hideDelay"));
    }
    this._lastX = this._lastY = this._lastDataByCoordSys = null;
    if (payload.from !== this.uid) {
      this._hide(makeDispatchAction(payload, api));
    }
  };
  TooltipView2.prototype._manuallyAxisShowTip = function(tooltipModel, ecModel, api, payload) {
    var seriesIndex = payload.seriesIndex;
    var dataIndex = payload.dataIndex;
    var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
    if (seriesIndex == null || dataIndex == null || coordSysAxesInfo == null) {
      return;
    }
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    if (!seriesModel) {
      return;
    }
    var data = seriesModel.getData();
    var tooltipCascadedModel = buildTooltipModel([data.getItemModel(dataIndex), seriesModel, (seriesModel.coordinateSystem || {}).model], this._tooltipModel);
    if (tooltipCascadedModel.get("trigger") !== "axis") {
      return;
    }
    api.dispatchAction({
      type: "updateAxisPointer",
      seriesIndex,
      dataIndex,
      position: payload.position
    });
    return true;
  };
  TooltipView2.prototype._tryShow = function(e2, dispatchAction2) {
    var el = e2.target;
    var tooltipModel = this._tooltipModel;
    if (!tooltipModel) {
      return;
    }
    this._lastX = e2.offsetX;
    this._lastY = e2.offsetY;
    var dataByCoordSys = e2.dataByCoordSys;
    if (dataByCoordSys && dataByCoordSys.length) {
      this._showAxisTooltip(dataByCoordSys, e2);
    } else if (el) {
      this._lastDataByCoordSys = null;
      var seriesDispatcher_1;
      var cmptDispatcher_1;
      findEventDispatcher(el, function(target) {
        if (getECData(target).dataIndex != null) {
          seriesDispatcher_1 = target;
          return true;
        }
        if (getECData(target).tooltipConfig != null) {
          cmptDispatcher_1 = target;
          return true;
        }
      }, true);
      if (seriesDispatcher_1) {
        this._showSeriesItemTooltip(e2, seriesDispatcher_1, dispatchAction2);
      } else if (cmptDispatcher_1) {
        this._showComponentItemTooltip(e2, cmptDispatcher_1, dispatchAction2);
      } else {
        this._hide(dispatchAction2);
      }
    } else {
      this._lastDataByCoordSys = null;
      this._hide(dispatchAction2);
    }
  };
  TooltipView2.prototype._showOrMove = function(tooltipModel, cb2) {
    var delay = tooltipModel.get("showDelay");
    cb2 = bind$1(cb2, this);
    clearTimeout(this._showTimout);
    delay > 0 ? this._showTimout = setTimeout(cb2, delay) : cb2();
  };
  TooltipView2.prototype._showAxisTooltip = function(dataByCoordSys, e2) {
    var ecModel = this._ecModel;
    var globalTooltipModel = this._tooltipModel;
    var point = [e2.offsetX, e2.offsetY];
    var singleTooltipModel = buildTooltipModel([e2.tooltipOption], globalTooltipModel);
    var renderMode = this._renderMode;
    var cbParamsList = [];
    var articleMarkup = createTooltipMarkup("section", {
      blocks: [],
      noHeader: true
    });
    var markupTextArrLegacy = [];
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    each$g(dataByCoordSys, function(itemCoordSys) {
      each$g(itemCoordSys.dataByAxis, function(axisItem) {
        var axisModel = ecModel.getComponent(axisItem.axisDim + "Axis", axisItem.axisIndex);
        var axisValue = axisItem.value;
        if (!axisModel || axisValue == null) {
          return;
        }
        var axisValueLabel = getValueLabel(axisValue, axisModel.axis, ecModel, axisItem.seriesDataIndices, axisItem.valueLabelOpt);
        var axisSectionMarkup = createTooltipMarkup("section", {
          header: axisValueLabel,
          noHeader: !trim$1(axisValueLabel),
          sortBlocks: true,
          blocks: []
        });
        articleMarkup.blocks.push(axisSectionMarkup);
        each$g(axisItem.seriesDataIndices, function(idxItem) {
          var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
          var dataIndex = idxItem.dataIndexInside;
          var cbParams = series.getDataParams(dataIndex);
          if (cbParams.dataIndex < 0) {
            return;
          }
          cbParams.axisDim = axisItem.axisDim;
          cbParams.axisIndex = axisItem.axisIndex;
          cbParams.axisType = axisItem.axisType;
          cbParams.axisId = axisItem.axisId;
          cbParams.axisValue = getAxisRawValue(axisModel.axis, {
            value: axisValue
          });
          cbParams.axisValueLabel = axisValueLabel;
          cbParams.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(cbParams.color), renderMode);
          var seriesTooltipResult = normalizeTooltipFormatResult(series.formatTooltip(dataIndex, true, null));
          var frag = seriesTooltipResult.frag;
          if (frag) {
            var valueFormatter = buildTooltipModel([series], globalTooltipModel).get("valueFormatter");
            axisSectionMarkup.blocks.push(valueFormatter ? extend({
              valueFormatter
            }, frag) : frag);
          }
          if (seriesTooltipResult.text) {
            markupTextArrLegacy.push(seriesTooltipResult.text);
          }
          cbParamsList.push(cbParams);
        });
      });
    });
    articleMarkup.blocks.reverse();
    markupTextArrLegacy.reverse();
    var positionExpr = e2.position;
    var orderMode = singleTooltipModel.get("order");
    var builtMarkupText = buildTooltipMarkup(articleMarkup, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), singleTooltipModel.get("textStyle"));
    builtMarkupText && markupTextArrLegacy.unshift(builtMarkupText);
    var blockBreak = renderMode === "richText" ? "\n\n" : "<br/>";
    var allMarkupText = markupTextArrLegacy.join(blockBreak);
    this._showOrMove(singleTooltipModel, function() {
      if (this._updateContentNotChangedOnAxis(dataByCoordSys, cbParamsList)) {
        this._updatePosition(singleTooltipModel, positionExpr, point[0], point[1], this._tooltipContent, cbParamsList);
      } else {
        this._showTooltipContent(singleTooltipModel, allMarkupText, cbParamsList, Math.random() + "", point[0], point[1], positionExpr, null, markupStyleCreator);
      }
    });
  };
  TooltipView2.prototype._showSeriesItemTooltip = function(e2, dispatcher, dispatchAction2) {
    var ecModel = this._ecModel;
    var ecData = getECData(dispatcher);
    var seriesIndex = ecData.seriesIndex;
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    var dataModel = ecData.dataModel || seriesModel;
    var dataIndex = ecData.dataIndex;
    var dataType = ecData.dataType;
    var data = dataModel.getData(dataType);
    var renderMode = this._renderMode;
    var positionDefault = e2.positionDefault;
    var tooltipModel = buildTooltipModel([data.getItemModel(dataIndex), dataModel, seriesModel && (seriesModel.coordinateSystem || {}).model], this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var tooltipTrigger = tooltipModel.get("trigger");
    if (tooltipTrigger != null && tooltipTrigger !== "item") {
      return;
    }
    var params = dataModel.getDataParams(dataIndex, dataType);
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    params.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(params.color), renderMode);
    var seriesTooltipResult = normalizeTooltipFormatResult(dataModel.formatTooltip(dataIndex, false, dataType));
    var orderMode = tooltipModel.get("order");
    var valueFormatter = tooltipModel.get("valueFormatter");
    var frag = seriesTooltipResult.frag;
    var markupText = frag ? buildTooltipMarkup(valueFormatter ? extend({
      valueFormatter
    }, frag) : frag, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), tooltipModel.get("textStyle")) : seriesTooltipResult.text;
    var asyncTicket = "item_" + dataModel.name + "_" + dataIndex;
    this._showOrMove(tooltipModel, function() {
      this._showTooltipContent(tooltipModel, markupText, params, asyncTicket, e2.offsetX, e2.offsetY, e2.position, e2.target, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      dataIndexInside: dataIndex,
      dataIndex: data.getRawIndex(dataIndex),
      seriesIndex,
      from: this.uid
    });
  };
  TooltipView2.prototype._showComponentItemTooltip = function(e2, el, dispatchAction2) {
    var ecData = getECData(el);
    var tooltipConfig = ecData.tooltipConfig;
    var tooltipOpt = tooltipConfig.option || {};
    if (isString$1(tooltipOpt)) {
      var content = tooltipOpt;
      tooltipOpt = {
        content,
        formatter: content
      };
    }
    var tooltipModelCascade = [tooltipOpt];
    var cmpt = this._ecModel.getComponent(ecData.componentMainType, ecData.componentIndex);
    if (cmpt) {
      tooltipModelCascade.push(cmpt);
    }
    tooltipModelCascade.push({
      formatter: tooltipOpt.content
    });
    var positionDefault = e2.positionDefault;
    var subTooltipModel = buildTooltipModel(tooltipModelCascade, this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var defaultHtml = subTooltipModel.get("content");
    var asyncTicket = Math.random() + "";
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    this._showOrMove(subTooltipModel, function() {
      var formatterParams = clone$4(subTooltipModel.get("formatterParams") || {});
      this._showTooltipContent(subTooltipModel, defaultHtml, formatterParams, asyncTicket, e2.offsetX, e2.offsetY, e2.position, el, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      from: this.uid
    });
  };
  TooltipView2.prototype._showTooltipContent = function(tooltipModel, defaultHtml, params, asyncTicket, x2, y2, positionExpr, el, markupStyleCreator) {
    this._ticket = "";
    if (!tooltipModel.get("showContent") || !tooltipModel.get("show")) {
      return;
    }
    var tooltipContent = this._tooltipContent;
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    var formatter = tooltipModel.get("formatter");
    positionExpr = positionExpr || tooltipModel.get("position");
    var html = defaultHtml;
    var nearPoint = this._getNearestPoint([x2, y2], params, tooltipModel.get("trigger"), tooltipModel.get("borderColor"));
    var nearPointColor = nearPoint.color;
    if (formatter) {
      if (isString$1(formatter)) {
        var useUTC = tooltipModel.ecModel.get("useUTC");
        var params0 = isArray$1(params) ? params[0] : params;
        var isTimeAxis = params0 && params0.axisType && params0.axisType.indexOf("time") >= 0;
        html = formatter;
        if (isTimeAxis) {
          html = format$1(params0.axisValue, html, useUTC);
        }
        html = formatTpl(html, params, true);
      } else if (isFunction(formatter)) {
        var callback = bind$1(function(cbTicket, html2) {
          if (cbTicket === this._ticket) {
            tooltipContent.setContent(html2, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
            this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
          }
        }, this);
        this._ticket = asyncTicket;
        html = formatter(params, asyncTicket, callback);
      } else {
        html = formatter;
      }
    }
    tooltipContent.setContent(html, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
    tooltipContent.show(tooltipModel, nearPointColor);
    this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
  };
  TooltipView2.prototype._getNearestPoint = function(point, tooltipDataParams, trigger2, borderColor) {
    if (trigger2 === "axis" || isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || (this._renderMode === "html" ? "#fff" : "none")
      };
    }
    if (!isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || tooltipDataParams.color || tooltipDataParams.borderColor
      };
    }
  };
  TooltipView2.prototype._updatePosition = function(tooltipModel, positionExpr, x2, y2, content, params, el) {
    var viewWidth = this._api.getWidth();
    var viewHeight = this._api.getHeight();
    positionExpr = positionExpr || tooltipModel.get("position");
    var contentSize = content.getSize();
    var align = tooltipModel.get("align");
    var vAlign = tooltipModel.get("verticalAlign");
    var rect = el && el.getBoundingRect().clone();
    el && rect.applyTransform(el.transform);
    if (isFunction(positionExpr)) {
      positionExpr = positionExpr([x2, y2], params, content.el, rect, {
        viewSize: [viewWidth, viewHeight],
        contentSize: contentSize.slice()
      });
    }
    if (isArray$1(positionExpr)) {
      x2 = parsePercent(positionExpr[0], viewWidth);
      y2 = parsePercent(positionExpr[1], viewHeight);
    } else if (isObject$4(positionExpr)) {
      var boxLayoutPosition = positionExpr;
      boxLayoutPosition.width = contentSize[0];
      boxLayoutPosition.height = contentSize[1];
      var layoutRect = getLayoutRect(boxLayoutPosition, {
        width: viewWidth,
        height: viewHeight
      });
      x2 = layoutRect.x;
      y2 = layoutRect.y;
      align = null;
      vAlign = null;
    } else if (isString$1(positionExpr) && el) {
      var pos = calcTooltipPosition(positionExpr, rect, contentSize, tooltipModel.get("borderWidth"));
      x2 = pos[0];
      y2 = pos[1];
    } else {
      var pos = refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, align ? null : 20, vAlign ? null : 20);
      x2 = pos[0];
      y2 = pos[1];
    }
    align && (x2 -= isCenterAlign(align) ? contentSize[0] / 2 : align === "right" ? contentSize[0] : 0);
    vAlign && (y2 -= isCenterAlign(vAlign) ? contentSize[1] / 2 : vAlign === "bottom" ? contentSize[1] : 0);
    if (shouldTooltipConfine(tooltipModel)) {
      var pos = confineTooltipPosition(x2, y2, content, viewWidth, viewHeight);
      x2 = pos[0];
      y2 = pos[1];
    }
    content.moveTo(x2, y2);
  };
  TooltipView2.prototype._updateContentNotChangedOnAxis = function(dataByCoordSys, cbParamsList) {
    var lastCoordSys = this._lastDataByCoordSys;
    var lastCbParamsList = this._cbParamsList;
    var contentNotChanged = !!lastCoordSys && lastCoordSys.length === dataByCoordSys.length;
    contentNotChanged && each$g(lastCoordSys, function(lastItemCoordSys, indexCoordSys) {
      var lastDataByAxis = lastItemCoordSys.dataByAxis || [];
      var thisItemCoordSys = dataByCoordSys[indexCoordSys] || {};
      var thisDataByAxis = thisItemCoordSys.dataByAxis || [];
      contentNotChanged = contentNotChanged && lastDataByAxis.length === thisDataByAxis.length;
      contentNotChanged && each$g(lastDataByAxis, function(lastItem, indexAxis) {
        var thisItem = thisDataByAxis[indexAxis] || {};
        var lastIndices = lastItem.seriesDataIndices || [];
        var newIndices = thisItem.seriesDataIndices || [];
        contentNotChanged = contentNotChanged && lastItem.value === thisItem.value && lastItem.axisType === thisItem.axisType && lastItem.axisId === thisItem.axisId && lastIndices.length === newIndices.length;
        contentNotChanged && each$g(lastIndices, function(lastIdxItem, j) {
          var newIdxItem = newIndices[j];
          contentNotChanged = contentNotChanged && lastIdxItem.seriesIndex === newIdxItem.seriesIndex && lastIdxItem.dataIndex === newIdxItem.dataIndex;
        });
        lastCbParamsList && each$g(lastItem.seriesDataIndices, function(idxItem) {
          var seriesIdx = idxItem.seriesIndex;
          var cbParams = cbParamsList[seriesIdx];
          var lastCbParams = lastCbParamsList[seriesIdx];
          if (cbParams && lastCbParams && lastCbParams.data !== cbParams.data) {
            contentNotChanged = false;
          }
        });
      });
    });
    this._lastDataByCoordSys = dataByCoordSys;
    this._cbParamsList = cbParamsList;
    return !!contentNotChanged;
  };
  TooltipView2.prototype._hide = function(dispatchAction2) {
    this._lastDataByCoordSys = null;
    dispatchAction2({
      type: "hideTip",
      from: this.uid
    });
  };
  TooltipView2.prototype.dispose = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    clear$1(this, "_updatePosition");
    this._tooltipContent.dispose();
    unregister("itemTooltip", api);
  };
  TooltipView2.type = "tooltip";
  return TooltipView2;
}(ComponentView$1);
function buildTooltipModel(modelCascade, globalTooltipModel, defaultTooltipOption) {
  var ecModel = globalTooltipModel.ecModel;
  var resultModel;
  if (defaultTooltipOption) {
    resultModel = new Model$1(defaultTooltipOption, ecModel, ecModel);
    resultModel = new Model$1(globalTooltipModel.option, resultModel, ecModel);
  } else {
    resultModel = globalTooltipModel;
  }
  for (var i = modelCascade.length - 1; i >= 0; i--) {
    var tooltipOpt = modelCascade[i];
    if (tooltipOpt) {
      if (tooltipOpt instanceof Model$1) {
        tooltipOpt = tooltipOpt.get("tooltip", true);
      }
      if (isString$1(tooltipOpt)) {
        tooltipOpt = {
          formatter: tooltipOpt
        };
      }
      if (tooltipOpt) {
        resultModel = new Model$1(tooltipOpt, resultModel, ecModel);
      }
    }
  }
  return resultModel;
}
function makeDispatchAction(payload, api) {
  return payload.dispatchAction || bind$1(api.dispatchAction, api);
}
function refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, gapH, gapV) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  if (gapH != null) {
    if (x2 + width + gapH + 2 > viewWidth) {
      x2 -= width + gapH;
    } else {
      x2 += gapH;
    }
  }
  if (gapV != null) {
    if (y2 + height + gapV > viewHeight) {
      y2 -= height + gapV;
    } else {
      y2 += gapV;
    }
  }
  return [x2, y2];
}
function confineTooltipPosition(x2, y2, content, viewWidth, viewHeight) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  x2 = Math.min(x2 + width, viewWidth) - width;
  y2 = Math.min(y2 + height, viewHeight) - height;
  x2 = Math.max(x2, 0);
  y2 = Math.max(y2, 0);
  return [x2, y2];
}
function calcTooltipPosition(position2, rect, contentSize, borderWidth) {
  var domWidth = contentSize[0];
  var domHeight = contentSize[1];
  var offset2 = Math.ceil(Math.SQRT2 * borderWidth) + 8;
  var x2 = 0;
  var y2 = 0;
  var rectWidth = rect.width;
  var rectHeight = rect.height;
  switch (position2) {
    case "inside":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "top":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y - domHeight - offset2;
      break;
    case "bottom":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight + offset2;
      break;
    case "left":
      x2 = rect.x - domWidth - offset2;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "right":
      x2 = rect.x + rectWidth + offset2;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
  }
  return [x2, y2];
}
function isCenterAlign(align) {
  return align === "center" || align === "middle";
}
function findComponentReference(payload, ecModel, api) {
  var queryOptionMap = preParseFinder(payload).queryOptionMap;
  var componentMainType = queryOptionMap.keys()[0];
  if (!componentMainType || componentMainType === "series") {
    return;
  }
  var queryResult = queryReferringComponents(ecModel, componentMainType, queryOptionMap.get(componentMainType), {
    useDefault: false,
    enableAll: false,
    enableNone: false
  });
  var model = queryResult.models[0];
  if (!model) {
    return;
  }
  var view = api.getViewOfComponentModel(model);
  var el;
  view.group.traverse(function(subEl) {
    var tooltipConfig = getECData(subEl).tooltipConfig;
    if (tooltipConfig && tooltipConfig.name === payload.name) {
      el = subEl;
      return true;
    }
  });
  if (el) {
    return {
      componentMainType,
      componentIndex: model.componentIndex,
      el
    };
  }
}
var TooltipView$1 = TooltipView;
function install$i(registers) {
  use(install$q);
  registers.registerComponentModel(TooltipModel$1);
  registers.registerComponentView(TooltipView$1);
  registers.registerAction({
    type: "showTip",
    event: "showTip",
    update: "tooltip:manuallyShowTip"
  }, noop$1);
  registers.registerAction({
    type: "hideTip",
    event: "hideTip",
    update: "tooltip:manuallyHideTip"
  }, noop$1);
}
var DEFAULT_TOOLBOX_BTNS = ["rect", "polygon", "keep", "clear"];
function brushPreprocessor(option, isNew) {
  var brushComponents = normalizeToArray(option ? option.brush : []);
  if (!brushComponents.length) {
    return;
  }
  var brushComponentSpecifiedBtns = [];
  each$g(brushComponents, function(brushOpt) {
    var tbs = brushOpt.hasOwnProperty("toolbox") ? brushOpt.toolbox : [];
    if (tbs instanceof Array) {
      brushComponentSpecifiedBtns = brushComponentSpecifiedBtns.concat(tbs);
    }
  });
  var toolbox = option && option.toolbox;
  if (isArray$1(toolbox)) {
    toolbox = toolbox[0];
  }
  if (!toolbox) {
    toolbox = {
      feature: {}
    };
    option.toolbox = [toolbox];
  }
  var toolboxFeature = toolbox.feature || (toolbox.feature = {});
  var toolboxBrush = toolboxFeature.brush || (toolboxFeature.brush = {});
  var brushTypes = toolboxBrush.type || (toolboxBrush.type = []);
  brushTypes.push.apply(brushTypes, brushComponentSpecifiedBtns);
  removeDuplicate(brushTypes);
  if (isNew && !brushTypes.length) {
    brushTypes.push.apply(brushTypes, DEFAULT_TOOLBOX_BTNS);
  }
}
function removeDuplicate(arr) {
  var map2 = {};
  each$g(arr, function(val) {
    map2[val] = 1;
  });
  arr.length = 0;
  each$g(map2, function(flag, val) {
    arr.push(val);
  });
}
var each$5 = each$g;
function hasKeys(obj) {
  if (obj) {
    for (var name_1 in obj) {
      if (obj.hasOwnProperty(name_1)) {
        return true;
      }
    }
  }
}
function createVisualMappings(option, stateList, supplementVisualOption) {
  var visualMappings = {};
  each$5(stateList, function(state) {
    var mappings = visualMappings[state] = createMappings();
    each$5(option[state], function(visualData, visualType) {
      if (!VisualMapping$1.isValidType(visualType)) {
        return;
      }
      var mappingOption = {
        type: visualType,
        visual: visualData
      };
      supplementVisualOption && supplementVisualOption(mappingOption, state);
      mappings[visualType] = new VisualMapping$1(mappingOption);
      if (visualType === "opacity") {
        mappingOption = clone$4(mappingOption);
        mappingOption.type = "colorAlpha";
        mappings.__hidden.__alphaForOpacity = new VisualMapping$1(mappingOption);
      }
    });
  });
  return visualMappings;
  function createMappings() {
    var Creater = function() {
    };
    Creater.prototype.__hidden = Creater.prototype;
    var obj = new Creater();
    return obj;
  }
}
function replaceVisualOption(thisOption, newOption, keys2) {
  var has2;
  each$g(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      has2 = true;
    }
  });
  has2 && each$g(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      thisOption[key] = clone$4(newOption[key]);
    } else {
      delete thisOption[key];
    }
  });
}
function applyVisual(stateList, visualMappings, data, getValueState, scope, dimension) {
  var visualTypesMap = {};
  each$g(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  var dataIndex;
  function getVisual(key) {
    return getItemVisualFromData(data, dataIndex, key);
  }
  function setVisual(key, value) {
    setItemVisualFromData(data, dataIndex, key, value);
  }
  if (dimension == null) {
    data.each(eachItem);
  } else {
    data.each([dimension], eachItem);
  }
  function eachItem(valueOrIndex, index2) {
    dataIndex = dimension == null ? valueOrIndex : index2;
    var rawDataItem = data.getRawDataItem(dataIndex);
    if (rawDataItem && rawDataItem.visualMap === false) {
      return;
    }
    var valueState = getValueState.call(scope, valueOrIndex);
    var mappings = visualMappings[valueState];
    var visualTypes = visualTypesMap[valueState];
    for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
      var type4 = visualTypes[i];
      mappings[type4] && mappings[type4].applyVisual(valueOrIndex, getVisual, setVisual);
    }
  }
}
function incrementalApplyVisual(stateList, visualMappings, getValueState, dim) {
  var visualTypesMap = {};
  each$g(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  return {
    progress: function progress(params, data) {
      var dimIndex;
      if (dim != null) {
        dimIndex = data.getDimensionIndex(dim);
      }
      function getVisual(key) {
        return getItemVisualFromData(data, dataIndex, key);
      }
      function setVisual(key, value2) {
        setItemVisualFromData(data, dataIndex, key, value2);
      }
      var dataIndex;
      var store = data.getStore();
      while ((dataIndex = params.next()) != null) {
        var rawDataItem = data.getRawDataItem(dataIndex);
        if (rawDataItem && rawDataItem.visualMap === false) {
          continue;
        }
        var value = dim != null ? store.get(dimIndex, dataIndex) : dataIndex;
        var valueState = getValueState(value);
        var mappings = visualMappings[valueState];
        var visualTypes = visualTypesMap[valueState];
        for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
          var type4 = visualTypes[i];
          mappings[type4] && mappings[type4].applyVisual(value, getVisual, setVisual);
        }
      }
    }
  };
}
function makeBrushCommonSelectorForSeries(area) {
  var brushType = area.brushType;
  var selectors = {
    point: function(itemLayout) {
      return selector[brushType].point(itemLayout, selectors, area);
    },
    rect: function(itemLayout) {
      return selector[brushType].rect(itemLayout, selectors, area);
    }
  };
  return selectors;
}
var selector = {
  lineX: getLineSelectors(0),
  lineY: getLineSelectors(1),
  rect: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.intersect(itemLayout);
    }
  },
  polygon: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]) && contain(area.range, itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      var points2 = area.range;
      if (!itemLayout || points2.length <= 1) {
        return false;
      }
      var x2 = itemLayout.x;
      var y2 = itemLayout.y;
      var width = itemLayout.width;
      var height = itemLayout.height;
      var p2 = points2[0];
      if (contain(points2, x2, y2) || contain(points2, x2 + width, y2) || contain(points2, x2, y2 + height) || contain(points2, x2 + width, y2 + height) || BoundingRect$1.create(itemLayout).contain(p2[0], p2[1]) || linePolygonIntersect(x2, y2, x2 + width, y2, points2) || linePolygonIntersect(x2, y2, x2, y2 + height, points2) || linePolygonIntersect(x2 + width, y2, x2 + width, y2 + height, points2) || linePolygonIntersect(x2, y2 + height, x2 + width, y2 + height, points2)) {
        return true;
      }
    }
  }
};
function getLineSelectors(xyIndex) {
  var xy = ["x", "y"];
  var wh2 = ["width", "height"];
  return {
    point: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var p2 = itemLayout[xyIndex];
        return inLineRange(p2, range3);
      }
    },
    rect: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var layoutRange = [itemLayout[xy[xyIndex]], itemLayout[xy[xyIndex]] + itemLayout[wh2[xyIndex]]];
        layoutRange[1] < layoutRange[0] && layoutRange.reverse();
        return inLineRange(layoutRange[0], range3) || inLineRange(layoutRange[1], range3) || inLineRange(range3[0], layoutRange) || inLineRange(range3[1], layoutRange);
      }
    }
  };
}
function inLineRange(p2, range3) {
  return range3[0] <= p2 && p2 <= range3[1];
}
var STATE_LIST = ["inBrush", "outOfBrush"];
var DISPATCH_METHOD = "__ecBrushSelect";
var DISPATCH_FLAG = "__ecInBrushSelectEvent";
function layoutCovers(ecModel) {
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    var brushTargetManager = brushModel.brushTargetManager = new BrushTargetManager$1(brushModel.option, ecModel);
    brushTargetManager.setInputRanges(brushModel.areas, ecModel);
  });
}
function brushVisual(ecModel, api, payload) {
  var brushSelected = [];
  var throttleType;
  var throttleDelay;
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    payload && payload.type === "takeGlobalCursor" && brushModel.setBrushOption(payload.key === "brush" ? payload.brushOption : {
      brushType: false
    });
  });
  layoutCovers(ecModel);
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel, brushIndex) {
    var thisBrushSelected = {
      brushId: brushModel.id,
      brushIndex,
      brushName: brushModel.name,
      areas: clone$4(brushModel.areas),
      selected: []
    };
    brushSelected.push(thisBrushSelected);
    var brushOption = brushModel.option;
    var brushLink = brushOption.brushLink;
    var linkedSeriesMap = [];
    var selectedDataIndexForLink = [];
    var rangeInfoBySeries = [];
    var hasBrushExists = false;
    if (!brushIndex) {
      throttleType = brushOption.throttleType;
      throttleDelay = brushOption.throttleDelay;
    }
    var areas = map$1(brushModel.areas, function(area) {
      var builder = boundingRectBuilders[area.brushType];
      var selectableArea = defaults({
        boundingRect: builder ? builder(area) : void 0
      }, area);
      selectableArea.selectors = makeBrushCommonSelectorForSeries(selectableArea);
      return selectableArea;
    });
    var visualMappings = createVisualMappings(brushModel.option, STATE_LIST, function(mappingOption) {
      mappingOption.mappingMethod = "fixed";
    });
    isArray$1(brushLink) && each$g(brushLink, function(seriesIndex) {
      linkedSeriesMap[seriesIndex] = 1;
    });
    function linkOthers(seriesIndex) {
      return brushLink === "all" || !!linkedSeriesMap[seriesIndex];
    }
    function brushed(rangeInfoList) {
      return !!rangeInfoList.length;
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var rangeInfoList = rangeInfoBySeries[seriesIndex] = [];
      seriesModel.subType === "parallel" ? stepAParallel(seriesModel, seriesIndex) : stepAOthers(seriesModel, seriesIndex, rangeInfoList);
    });
    function stepAParallel(seriesModel, seriesIndex) {
      var coordSys = seriesModel.coordinateSystem;
      hasBrushExists = hasBrushExists || coordSys.hasAxisBrushed();
      linkOthers(seriesIndex) && coordSys.eachActiveState(seriesModel.getData(), function(activeState, dataIndex) {
        activeState === "active" && (selectedDataIndexForLink[dataIndex] = 1);
      });
    }
    function stepAOthers(seriesModel, seriesIndex, rangeInfoList) {
      if (!seriesModel.brushSelector || brushModelNotControll(brushModel, seriesIndex)) {
        return;
      }
      each$g(areas, function(area) {
        if (brushModel.brushTargetManager.controlSeries(area, seriesModel, ecModel)) {
          rangeInfoList.push(area);
        }
        hasBrushExists = hasBrushExists || brushed(rangeInfoList);
      });
      if (linkOthers(seriesIndex) && brushed(rangeInfoList)) {
        var data_1 = seriesModel.getData();
        data_1.each(function(dataIndex) {
          if (checkInRange(seriesModel, rangeInfoList, data_1, dataIndex)) {
            selectedDataIndexForLink[dataIndex] = 1;
          }
        });
      }
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var seriesBrushSelected = {
        seriesId: seriesModel.id,
        seriesIndex,
        seriesName: seriesModel.name,
        dataIndex: []
      };
      thisBrushSelected.selected.push(seriesBrushSelected);
      var rangeInfoList = rangeInfoBySeries[seriesIndex];
      var data = seriesModel.getData();
      var getValueState = linkOthers(seriesIndex) ? function(dataIndex) {
        return selectedDataIndexForLink[dataIndex] ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      } : function(dataIndex) {
        return checkInRange(seriesModel, rangeInfoList, data, dataIndex) ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      };
      (linkOthers(seriesIndex) ? hasBrushExists : brushed(rangeInfoList)) && applyVisual(STATE_LIST, visualMappings, data, getValueState);
    });
  });
  dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload);
}
function dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload) {
  if (!payload) {
    return;
  }
  var zr = api.getZr();
  if (zr[DISPATCH_FLAG]) {
    return;
  }
  if (!zr[DISPATCH_METHOD]) {
    zr[DISPATCH_METHOD] = doDispatch;
  }
  var fn = createOrUpdate(zr, DISPATCH_METHOD, throttleDelay, throttleType);
  fn(api, brushSelected);
}
function doDispatch(api, brushSelected) {
  if (!api.isDisposed()) {
    var zr = api.getZr();
    zr[DISPATCH_FLAG] = true;
    api.dispatchAction({
      type: "brushSelect",
      batch: brushSelected
    });
    zr[DISPATCH_FLAG] = false;
  }
}
function checkInRange(seriesModel, rangeInfoList, data, dataIndex) {
  for (var i = 0, len2 = rangeInfoList.length; i < len2; i++) {
    var area = rangeInfoList[i];
    if (seriesModel.brushSelector(dataIndex, data, area.selectors, area)) {
      return true;
    }
  }
}
function brushModelNotControll(brushModel, seriesIndex) {
  var seriesIndices = brushModel.option.seriesIndex;
  return seriesIndices != null && seriesIndices !== "all" && (isArray$1(seriesIndices) ? indexOf(seriesIndices, seriesIndex) < 0 : seriesIndex !== seriesIndices);
}
var boundingRectBuilders = {
  rect: function(area) {
    return getBoundingRectFromMinMax(area.range);
  },
  polygon: function(area) {
    var minMax;
    var range3 = area.range;
    for (var i = 0, len2 = range3.length; i < len2; i++) {
      minMax = minMax || [[Infinity, -Infinity], [Infinity, -Infinity]];
      var rg2 = range3[i];
      rg2[0] < minMax[0][0] && (minMax[0][0] = rg2[0]);
      rg2[0] > minMax[0][1] && (minMax[0][1] = rg2[0]);
      rg2[1] < minMax[1][0] && (minMax[1][0] = rg2[1]);
      rg2[1] > minMax[1][1] && (minMax[1][1] = rg2[1]);
    }
    return minMax && getBoundingRectFromMinMax(minMax);
  }
};
function getBoundingRectFromMinMax(minMax) {
  return new BoundingRect$1(minMax[0][0], minMax[1][0], minMax[0][1] - minMax[0][0], minMax[1][1] - minMax[1][0]);
}
var BrushView = function(_super) {
  __extends(BrushView2, _super);
  function BrushView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushView2.type;
    return _this;
  }
  BrushView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
    this.model;
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this)).mount();
  };
  BrushView2.prototype.render = function(brushModel, ecModel, api, payload) {
    this.model = brushModel;
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateTransform = function(brushModel, ecModel, api, payload) {
    layoutCovers(ecModel);
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateVisual = function(brushModel, ecModel, api, payload) {
    this.updateTransform(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateView = function(brushModel, ecModel, api, payload) {
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype._updateController = function(brushModel, ecModel, api, payload) {
    (!payload || payload.$from !== brushModel.id) && this._brushController.setPanels(brushModel.brushTargetManager.makePanelOpts(api)).enableBrush(brushModel.brushOption).updateCovers(brushModel.areas.slice());
  };
  BrushView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  BrushView2.prototype._onBrush = function(eventParam) {
    var modelId = this.model.id;
    var areas = this.model.brushTargetManager.setOutputRanges(eventParam.areas, this.ecModel);
    (!eventParam.isEnd || eventParam.removeOnClick) && this.api.dispatchAction({
      type: "brush",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
    eventParam.isEnd && this.api.dispatchAction({
      type: "brushEnd",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
  };
  BrushView2.type = "brush";
  return BrushView2;
}(ComponentView$1);
var BrushView$1 = BrushView;
var DEFAULT_OUT_OF_BRUSH_COLOR = "#ddd";
var BrushModel = function(_super) {
  __extends(BrushModel2, _super);
  function BrushModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushModel2.type;
    _this.areas = [];
    _this.brushOption = {};
    return _this;
  }
  BrushModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, ["inBrush", "outOfBrush"]);
    var inBrush = thisOption.inBrush = thisOption.inBrush || {};
    thisOption.outOfBrush = thisOption.outOfBrush || {
      color: DEFAULT_OUT_OF_BRUSH_COLOR
    };
    if (!inBrush.hasOwnProperty("liftZ")) {
      inBrush.liftZ = 5;
    }
  };
  BrushModel2.prototype.setAreas = function(areas) {
    if (!areas) {
      return;
    }
    this.areas = map$1(areas, function(area) {
      return generateBrushOption(this.option, area);
    }, this);
  };
  BrushModel2.prototype.setBrushOption = function(brushOption) {
    this.brushOption = generateBrushOption(this.option, brushOption);
    this.brushType = this.brushOption.brushType;
  };
  BrushModel2.type = "brush";
  BrushModel2.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"];
  BrushModel2.defaultOption = {
    seriesIndex: "all",
    brushType: "rect",
    brushMode: "single",
    transformable: true,
    brushStyle: {
      borderWidth: 1,
      color: "rgba(210,219,238,0.3)",
      borderColor: "#D2DBEE"
    },
    throttleType: "fixRate",
    throttleDelay: 0,
    removeOnClick: true,
    z: 1e4
  };
  return BrushModel2;
}(ComponentModel$1);
function generateBrushOption(option, brushOption) {
  return merge({
    brushType: option.brushType,
    brushMode: option.brushMode,
    transformable: option.transformable,
    brushStyle: new Model$1(option.brushStyle).getItemStyle(),
    removeOnClick: option.removeOnClick,
    z: option.z
  }, brushOption, true);
}
var BrushModel$1 = BrushModel;
var ICON_TYPES = ["rect", "polygon", "lineX", "lineY", "keep", "clear"];
var BrushFeature = function(_super) {
  __extends(BrushFeature2, _super);
  function BrushFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  BrushFeature2.prototype.render = function(featureModel, ecModel, api) {
    var brushType;
    var brushMode;
    var isBrushed;
    ecModel.eachComponent({
      mainType: "brush"
    }, function(brushModel) {
      brushType = brushModel.brushType;
      brushMode = brushModel.brushOption.brushMode || "single";
      isBrushed = isBrushed || !!brushModel.areas.length;
    });
    this._brushType = brushType;
    this._brushMode = brushMode;
    each$g(featureModel.get("type", true), function(type4) {
      featureModel.setIconStatus(type4, (type4 === "keep" ? brushMode === "multiple" : type4 === "clear" ? isBrushed : type4 === brushType) ? "emphasis" : "normal");
    });
  };
  BrushFeature2.prototype.updateView = function(featureModel, ecModel, api) {
    this.render(featureModel, ecModel, api);
  };
  BrushFeature2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon", true);
    var icons = {};
    each$g(model.get("type", true), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  BrushFeature2.prototype.onclick = function(ecModel, api, type4) {
    var brushType = this._brushType;
    var brushMode = this._brushMode;
    if (type4 === "clear") {
      api.dispatchAction({
        type: "axisAreaSelect",
        intervals: []
      });
      api.dispatchAction({
        type: "brush",
        command: "clear",
        areas: []
      });
    } else {
      api.dispatchAction({
        type: "takeGlobalCursor",
        key: "brush",
        brushOption: {
          brushType: type4 === "keep" ? brushType : brushType === type4 ? false : type4,
          brushMode: type4 === "keep" ? brushMode === "multiple" ? "single" : "multiple" : brushMode
        }
      });
    }
  };
  BrushFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: ICON_TYPES.slice(),
      icon: {
        rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13",
        polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2",
        lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4",
        lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4",
        keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z",
        clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "brush", "title"])
    };
    return defaultOption2;
  };
  return BrushFeature2;
}(ToolboxFeature);
var BrushFeature$1 = BrushFeature;
function install$h(registers) {
  registers.registerComponentView(BrushView$1);
  registers.registerComponentModel(BrushModel$1);
  registers.registerPreprocessor(brushPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, brushVisual);
  registers.registerAction({
    type: "brush",
    event: "brush",
    update: "updateVisual"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "brush",
      query: payload
    }, function(brushModel) {
      brushModel.setAreas(payload.areas);
    });
  });
  registers.registerAction({
    type: "brushSelect",
    event: "brushSelected",
    update: "none"
  }, noop$1);
  registers.registerAction({
    type: "brushEnd",
    event: "brushEnd",
    update: "none"
  }, noop$1);
  registerFeature("brush", BrushFeature$1);
}
var TitleModel = function(_super) {
  __extends(TitleModel2, _super);
  function TitleModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  TitleModel2.type = "title";
  TitleModel2.defaultOption = {
    z: 6,
    show: true,
    text: "",
    target: "blank",
    subtext: "",
    subtarget: "blank",
    left: 0,
    top: 0,
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    textStyle: {
      fontSize: 18,
      fontWeight: "bold",
      color: "#464646"
    },
    subtextStyle: {
      fontSize: 12,
      color: "#6E7079"
    }
  };
  return TitleModel2;
}(ComponentModel$1);
var TitleView = function(_super) {
  __extends(TitleView2, _super);
  function TitleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleView2.type;
    return _this;
  }
  TitleView2.prototype.render = function(titleModel, ecModel, api) {
    this.group.removeAll();
    if (!titleModel.get("show")) {
      return;
    }
    var group = this.group;
    var textStyleModel = titleModel.getModel("textStyle");
    var subtextStyleModel = titleModel.getModel("subtextStyle");
    var textAlign = titleModel.get("textAlign");
    var textVerticalAlign = retrieve2(titleModel.get("textBaseline"), titleModel.get("textVerticalAlign"));
    var textEl = new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: titleModel.get("text"),
        fill: textStyleModel.getTextColor()
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var textRect = textEl.getBoundingRect();
    var subText = titleModel.get("subtext");
    var subTextEl = new ZRText$1({
      style: createTextStyle(subtextStyleModel, {
        text: subText,
        fill: subtextStyleModel.getTextColor(),
        y: textRect.height + titleModel.get("itemGap"),
        verticalAlign: "top"
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var link = titleModel.get("link");
    var sublink = titleModel.get("sublink");
    var triggerEvent = titleModel.get("triggerEvent", true);
    textEl.silent = !link && !triggerEvent;
    subTextEl.silent = !sublink && !triggerEvent;
    if (link) {
      textEl.on("click", function() {
        windowOpen(link, "_" + titleModel.get("target"));
      });
    }
    if (sublink) {
      subTextEl.on("click", function() {
        windowOpen(sublink, "_" + titleModel.get("subtarget"));
      });
    }
    getECData(textEl).eventData = getECData(subTextEl).eventData = triggerEvent ? {
      componentType: "title",
      componentIndex: titleModel.componentIndex
    } : null;
    group.add(textEl);
    subText && group.add(subTextEl);
    var groupRect = group.getBoundingRect();
    var layoutOption = titleModel.getBoxLayoutParams();
    layoutOption.width = groupRect.width;
    layoutOption.height = groupRect.height;
    var layoutRect = getLayoutRect(layoutOption, {
      width: api.getWidth(),
      height: api.getHeight()
    }, titleModel.get("padding"));
    if (!textAlign) {
      textAlign = titleModel.get("left") || titleModel.get("right");
      if (textAlign === "middle") {
        textAlign = "center";
      }
      if (textAlign === "right") {
        layoutRect.x += layoutRect.width;
      } else if (textAlign === "center") {
        layoutRect.x += layoutRect.width / 2;
      }
    }
    if (!textVerticalAlign) {
      textVerticalAlign = titleModel.get("top") || titleModel.get("bottom");
      if (textVerticalAlign === "center") {
        textVerticalAlign = "middle";
      }
      if (textVerticalAlign === "bottom") {
        layoutRect.y += layoutRect.height;
      } else if (textVerticalAlign === "middle") {
        layoutRect.y += layoutRect.height / 2;
      }
      textVerticalAlign = textVerticalAlign || "top";
    }
    group.x = layoutRect.x;
    group.y = layoutRect.y;
    group.markRedraw();
    var alignStyle = {
      align: textAlign,
      verticalAlign: textVerticalAlign
    };
    textEl.setStyle(alignStyle);
    subTextEl.setStyle(alignStyle);
    groupRect = group.getBoundingRect();
    var padding = layoutRect.margin;
    var style2 = titleModel.getItemStyle(["color", "opacity"]);
    style2.fill = titleModel.get("backgroundColor");
    var rect = new Rect$3({
      shape: {
        x: groupRect.x - padding[3],
        y: groupRect.y - padding[0],
        width: groupRect.width + padding[1] + padding[3],
        height: groupRect.height + padding[0] + padding[2],
        r: titleModel.get("borderRadius")
      },
      style: style2,
      subPixelOptimize: true,
      silent: true
    });
    group.add(rect);
  };
  TitleView2.type = "title";
  return TitleView2;
}(ComponentView$1);
function install$g(registers) {
  registers.registerComponentModel(TitleModel);
  registers.registerComponentView(TitleView);
}
var TimelineModel = function(_super) {
  __extends(TimelineModel2, _super);
  function TimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineModel2.type;
    _this.layoutMode = "box";
    return _this;
  }
  TimelineModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._initData();
  };
  TimelineModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this._initData();
  };
  TimelineModel2.prototype.setCurrentIndex = function(currentIndex) {
    if (currentIndex == null) {
      currentIndex = this.option.currentIndex;
    }
    var count2 = this._data.count();
    if (this.option.loop) {
      currentIndex = (currentIndex % count2 + count2) % count2;
    } else {
      currentIndex >= count2 && (currentIndex = count2 - 1);
      currentIndex < 0 && (currentIndex = 0);
    }
    this.option.currentIndex = currentIndex;
  };
  TimelineModel2.prototype.getCurrentIndex = function() {
    return this.option.currentIndex;
  };
  TimelineModel2.prototype.isIndexMax = function() {
    return this.getCurrentIndex() >= this._data.count() - 1;
  };
  TimelineModel2.prototype.setPlayState = function(state) {
    this.option.autoPlay = !!state;
  };
  TimelineModel2.prototype.getPlayState = function() {
    return !!this.option.autoPlay;
  };
  TimelineModel2.prototype._initData = function() {
    var thisOption = this.option;
    var dataArr = thisOption.data || [];
    var axisType = thisOption.axisType;
    var names2 = this._names = [];
    var processedDataArr;
    if (axisType === "category") {
      processedDataArr = [];
      each$g(dataArr, function(item, index2) {
        var value = convertOptionIdName(getDataItemValue(item), "");
        var newItem;
        if (isObject$4(item)) {
          newItem = clone$4(item);
          newItem.value = index2;
        } else {
          newItem = index2;
        }
        processedDataArr.push(newItem);
        names2.push(value);
      });
    } else {
      processedDataArr = dataArr;
    }
    var dimType = {
      category: "ordinal",
      time: "time",
      value: "number"
    }[axisType] || "number";
    var data = this._data = new SeriesData$1([{
      name: "value",
      type: dimType
    }], this);
    data.initData(processedDataArr, names2);
  };
  TimelineModel2.prototype.getData = function() {
    return this._data;
  };
  TimelineModel2.prototype.getCategories = function() {
    if (this.get("axisType") === "category") {
      return this._names.slice();
    }
  };
  TimelineModel2.type = "timeline";
  TimelineModel2.defaultOption = {
    z: 4,
    show: true,
    axisType: "time",
    realtime: true,
    left: "20%",
    top: null,
    right: "20%",
    bottom: 0,
    width: null,
    height: 40,
    padding: 5,
    controlPosition: "left",
    autoPlay: false,
    rewind: false,
    loop: true,
    playInterval: 2e3,
    currentIndex: 0,
    itemStyle: {},
    label: {
      color: "#000"
    },
    data: []
  };
  return TimelineModel2;
}(ComponentModel$1);
var TimelineModel$1 = TimelineModel;
var SliderTimelineModel = function(_super) {
  __extends(SliderTimelineModel2, _super);
  function SliderTimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineModel2.type;
    return _this;
  }
  SliderTimelineModel2.type = "timeline.slider";
  SliderTimelineModel2.defaultOption = inheritDefaultOption(TimelineModel$1.defaultOption, {
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    orient: "horizontal",
    inverse: false,
    tooltip: {
      trigger: "item"
    },
    symbol: "circle",
    symbolSize: 12,
    lineStyle: {
      show: true,
      width: 2,
      color: "#DAE1F5"
    },
    label: {
      position: "auto",
      show: true,
      interval: "auto",
      rotate: 0,
      color: "#A4B1D7"
    },
    itemStyle: {
      color: "#A4B1D7",
      borderWidth: 1
    },
    checkpointStyle: {
      symbol: "circle",
      symbolSize: 15,
      color: "#316bf3",
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0, 0, 0, 0.3)",
      animation: true,
      animationDuration: 300,
      animationEasing: "quinticInOut"
    },
    controlStyle: {
      show: true,
      showPlayBtn: true,
      showPrevBtn: true,
      showNextBtn: true,
      itemSize: 24,
      itemGap: 12,
      position: "left",
      playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z",
      stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z",
      nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z",
      prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z",
      prevBtnSize: 18,
      nextBtnSize: 18,
      color: "#A4B1D7",
      borderColor: "#A4B1D7",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true,
        color: "#6f778d"
      },
      itemStyle: {
        color: "#316BF3"
      },
      controlStyle: {
        color: "#316BF3",
        borderColor: "#316BF3",
        borderWidth: 2
      }
    },
    progress: {
      lineStyle: {
        color: "#316BF3"
      },
      itemStyle: {
        color: "#316BF3"
      },
      label: {
        color: "#6f778d"
      }
    },
    data: []
  });
  return SliderTimelineModel2;
}(TimelineModel$1);
mixin(SliderTimelineModel, DataFormatMixin.prototype);
var SliderTimelineModel$1 = SliderTimelineModel;
var TimelineView = function(_super) {
  __extends(TimelineView2, _super);
  function TimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineView2.type;
    return _this;
  }
  TimelineView2.type = "timeline";
  return TimelineView2;
}(ComponentView$1);
var TimelineView$1 = TimelineView;
var TimelineAxis = function(_super) {
  __extends(TimelineAxis2, _super);
  function TimelineAxis2(dim, scale2, coordExtent, axisType) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    return _this;
  }
  TimelineAxis2.prototype.getLabelModel = function() {
    return this.model.getModel("label");
  };
  TimelineAxis2.prototype.isHorizontal = function() {
    return this.model.get("orient") === "horizontal";
  };
  return TimelineAxis2;
}(Axis$1);
var TimelineAxis$1 = TimelineAxis;
var PI = Math.PI;
var labelDataIndexStore = makeInner();
var SliderTimelineView = function(_super) {
  __extends(SliderTimelineView2, _super);
  function SliderTimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineView2.type;
    return _this;
  }
  SliderTimelineView2.prototype.init = function(ecModel, api) {
    this.api = api;
  };
  SliderTimelineView2.prototype.render = function(timelineModel, ecModel, api) {
    this.model = timelineModel;
    this.api = api;
    this.ecModel = ecModel;
    this.group.removeAll();
    if (timelineModel.get("show", true)) {
      var layoutInfo_1 = this._layout(timelineModel, api);
      var mainGroup_1 = this._createGroup("_mainGroup");
      var labelGroup = this._createGroup("_labelGroup");
      var axis_1 = this._axis = this._createAxis(layoutInfo_1, timelineModel);
      timelineModel.formatTooltip = function(dataIndex) {
        var name = axis_1.scale.getLabel({
          value: dataIndex
        });
        return createTooltipMarkup("nameValue", {
          noName: true,
          value: name
        });
      };
      each$g(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(name) {
        this["_render" + name](layoutInfo_1, mainGroup_1, axis_1, timelineModel);
      }, this);
      this._renderAxisLabel(layoutInfo_1, labelGroup, axis_1, timelineModel);
      this._position(layoutInfo_1, timelineModel);
    }
    this._doPlayStop();
    this._updateTicksStatus();
  };
  SliderTimelineView2.prototype.remove = function() {
    this._clearTimer();
    this.group.removeAll();
  };
  SliderTimelineView2.prototype.dispose = function() {
    this._clearTimer();
  };
  SliderTimelineView2.prototype._layout = function(timelineModel, api) {
    var labelPosOpt = timelineModel.get(["label", "position"]);
    var orient = timelineModel.get("orient");
    var viewRect2 = getViewRect(timelineModel, api);
    var parsedLabelPos;
    if (labelPosOpt == null || labelPosOpt === "auto") {
      parsedLabelPos = orient === "horizontal" ? viewRect2.y + viewRect2.height / 2 < api.getHeight() / 2 ? "-" : "+" : viewRect2.x + viewRect2.width / 2 < api.getWidth() / 2 ? "+" : "-";
    } else if (isString$1(labelPosOpt)) {
      parsedLabelPos = {
        horizontal: {
          top: "-",
          bottom: "+"
        },
        vertical: {
          left: "-",
          right: "+"
        }
      }[orient][labelPosOpt];
    } else {
      parsedLabelPos = labelPosOpt;
    }
    var labelAlignMap = {
      horizontal: "center",
      vertical: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "left" : "right"
    };
    var labelBaselineMap = {
      horizontal: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "top" : "bottom",
      vertical: "middle"
    };
    var rotationMap = {
      horizontal: 0,
      vertical: PI / 2
    };
    var mainLength = orient === "vertical" ? viewRect2.height : viewRect2.width;
    var controlModel = timelineModel.getModel("controlStyle");
    var showControl = controlModel.get("show", true);
    var controlSize = showControl ? controlModel.get("itemSize") : 0;
    var controlGap = showControl ? controlModel.get("itemGap") : 0;
    var sizePlusGap = controlSize + controlGap;
    var labelRotation = timelineModel.get(["label", "rotate"]) || 0;
    labelRotation = labelRotation * PI / 180;
    var playPosition;
    var prevBtnPosition;
    var nextBtnPosition;
    var controlPosition = controlModel.get("position", true);
    var showPlayBtn = showControl && controlModel.get("showPlayBtn", true);
    var showPrevBtn = showControl && controlModel.get("showPrevBtn", true);
    var showNextBtn = showControl && controlModel.get("showNextBtn", true);
    var xLeft = 0;
    var xRight = mainLength;
    if (controlPosition === "left" || controlPosition === "bottom") {
      showPlayBtn && (playPosition = [0, 0], xLeft += sizePlusGap);
      showPrevBtn && (prevBtnPosition = [xLeft, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    } else {
      showPlayBtn && (playPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
      showPrevBtn && (prevBtnPosition = [0, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    }
    var axisExtent = [xLeft, xRight];
    if (timelineModel.get("inverse")) {
      axisExtent.reverse();
    }
    return {
      viewRect: viewRect2,
      mainLength,
      orient,
      rotation: rotationMap[orient],
      labelRotation,
      labelPosOpt: parsedLabelPos,
      labelAlign: timelineModel.get(["label", "align"]) || labelAlignMap[orient],
      labelBaseline: timelineModel.get(["label", "verticalAlign"]) || timelineModel.get(["label", "baseline"]) || labelBaselineMap[orient],
      playPosition,
      prevBtnPosition,
      nextBtnPosition,
      axisExtent,
      controlSize,
      controlGap
    };
  };
  SliderTimelineView2.prototype._position = function(layoutInfo, timelineModel) {
    var mainGroup = this._mainGroup;
    var labelGroup = this._labelGroup;
    var viewRect2 = layoutInfo.viewRect;
    if (layoutInfo.orient === "vertical") {
      var m2 = create$1();
      var rotateOriginX = viewRect2.x;
      var rotateOriginY = viewRect2.y + viewRect2.height;
      translate(m2, m2, [-rotateOriginX, -rotateOriginY]);
      rotate(m2, m2, -PI / 2);
      translate(m2, m2, [rotateOriginX, rotateOriginY]);
      viewRect2 = viewRect2.clone();
      viewRect2.applyTransform(m2);
    }
    var viewBound = getBound(viewRect2);
    var mainBound = getBound(mainGroup.getBoundingRect());
    var labelBound = getBound(labelGroup.getBoundingRect());
    var mainPosition = [mainGroup.x, mainGroup.y];
    var labelsPosition = [labelGroup.x, labelGroup.y];
    labelsPosition[0] = mainPosition[0] = viewBound[0][0];
    var labelPosOpt = layoutInfo.labelPosOpt;
    if (labelPosOpt == null || isString$1(labelPosOpt)) {
      var mainBoundIdx = labelPosOpt === "+" ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      toBound(labelsPosition, labelBound, viewBound, 1, 1 - mainBoundIdx);
    } else {
      var mainBoundIdx = labelPosOpt >= 0 ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      labelsPosition[1] = mainPosition[1] + labelPosOpt;
    }
    mainGroup.setPosition(mainPosition);
    labelGroup.setPosition(labelsPosition);
    mainGroup.rotation = labelGroup.rotation = layoutInfo.rotation;
    setOrigin(mainGroup);
    setOrigin(labelGroup);
    function setOrigin(targetGroup) {
      targetGroup.originX = viewBound[0][0] - targetGroup.x;
      targetGroup.originY = viewBound[1][0] - targetGroup.y;
    }
    function getBound(rect) {
      return [[rect.x, rect.x + rect.width], [rect.y, rect.y + rect.height]];
    }
    function toBound(fromPos, from, to, dimIdx, boundIdx) {
      fromPos[dimIdx] += to[dimIdx][boundIdx] - from[dimIdx][boundIdx];
    }
  };
  SliderTimelineView2.prototype._createAxis = function(layoutInfo, timelineModel) {
    var data = timelineModel.getData();
    var axisType = timelineModel.get("axisType");
    var scale2 = createScaleByModel(timelineModel, axisType);
    scale2.getTicks = function() {
      return data.mapArray(["value"], function(value) {
        return {
          value
        };
      });
    };
    var dataExtent = data.getDataExtent("value");
    scale2.setExtent(dataExtent[0], dataExtent[1]);
    scale2.calcNiceTicks();
    var axis = new TimelineAxis$1("value", scale2, layoutInfo.axisExtent, axisType);
    axis.model = timelineModel;
    return axis;
  };
  SliderTimelineView2.prototype._createGroup = function(key) {
    var newGroup = this[key] = new Group$6();
    this.group.add(newGroup);
    return newGroup;
  };
  SliderTimelineView2.prototype._renderAxisLine = function(layoutInfo, group, axis, timelineModel) {
    var axisExtent = axis.getExtent();
    if (!timelineModel.get(["lineStyle", "show"])) {
      return;
    }
    var line = new Line$3({
      shape: {
        x1: axisExtent[0],
        y1: 0,
        x2: axisExtent[1],
        y2: 0
      },
      style: extend({
        lineCap: "round"
      }, timelineModel.getModel("lineStyle").getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(line);
    var progressLine = this._progressLine = new Line$3({
      shape: {
        x1: axisExtent[0],
        x2: this._currentPointer ? this._currentPointer.x : axisExtent[0],
        y1: 0,
        y2: 0
      },
      style: defaults({
        lineCap: "round",
        lineWidth: line.style.lineWidth
      }, timelineModel.getModel(["progress", "lineStyle"]).getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(progressLine);
  };
  SliderTimelineView2.prototype._renderAxisTick = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var data = timelineModel.getData();
    var ticks = axis.scale.getTicks();
    this._tickSymbols = [];
    each$g(ticks, function(tick) {
      var tickCoord = axis.dataToCoord(tick.value);
      var itemModel = data.getItemModel(tick.value);
      var itemStyleModel = itemModel.getModel("itemStyle");
      var hoverStyleModel = itemModel.getModel(["emphasis", "itemStyle"]);
      var progressStyleModel = itemModel.getModel(["progress", "itemStyle"]);
      var symbolOpt = {
        x: tickCoord,
        y: 0,
        onclick: bind$1(_this._changeTimeline, _this, tick.value)
      };
      var el = giveSymbol(itemModel, itemStyleModel, group, symbolOpt);
      el.ensureState("emphasis").style = hoverStyleModel.getItemStyle();
      el.ensureState("progress").style = progressStyleModel.getItemStyle();
      enableHoverEmphasis(el);
      var ecData = getECData(el);
      if (itemModel.get("tooltip")) {
        ecData.dataIndex = tick.value;
        ecData.dataModel = timelineModel;
      } else {
        ecData.dataIndex = ecData.dataModel = null;
      }
      _this._tickSymbols.push(el);
    });
  };
  SliderTimelineView2.prototype._renderAxisLabel = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var labelModel = axis.getLabelModel();
    if (!labelModel.get("show")) {
      return;
    }
    var data = timelineModel.getData();
    var labels = axis.getViewLabels();
    this._tickLabels = [];
    each$g(labels, function(labelItem) {
      var dataIndex = labelItem.tickValue;
      var itemModel = data.getItemModel(dataIndex);
      var normalLabelModel = itemModel.getModel("label");
      var hoverLabelModel = itemModel.getModel(["emphasis", "label"]);
      var progressLabelModel = itemModel.getModel(["progress", "label"]);
      var tickCoord = axis.dataToCoord(labelItem.tickValue);
      var textEl = new ZRText$1({
        x: tickCoord,
        y: 0,
        rotation: layoutInfo.labelRotation - layoutInfo.rotation,
        onclick: bind$1(_this._changeTimeline, _this, dataIndex),
        silent: false,
        style: createTextStyle(normalLabelModel, {
          text: labelItem.formattedLabel,
          align: layoutInfo.labelAlign,
          verticalAlign: layoutInfo.labelBaseline
        })
      });
      textEl.ensureState("emphasis").style = createTextStyle(hoverLabelModel);
      textEl.ensureState("progress").style = createTextStyle(progressLabelModel);
      group.add(textEl);
      enableHoverEmphasis(textEl);
      labelDataIndexStore(textEl).dataIndex = dataIndex;
      _this._tickLabels.push(textEl);
    });
  };
  SliderTimelineView2.prototype._renderControl = function(layoutInfo, group, axis, timelineModel) {
    var controlSize = layoutInfo.controlSize;
    var rotation = layoutInfo.rotation;
    var itemStyle = timelineModel.getModel("controlStyle").getItemStyle();
    var hoverStyle = timelineModel.getModel(["emphasis", "controlStyle"]).getItemStyle();
    var playState = timelineModel.getPlayState();
    var inverse = timelineModel.get("inverse", true);
    makeBtn(layoutInfo.nextBtnPosition, "next", bind$1(this._changeTimeline, this, inverse ? "-" : "+"));
    makeBtn(layoutInfo.prevBtnPosition, "prev", bind$1(this._changeTimeline, this, inverse ? "+" : "-"));
    makeBtn(layoutInfo.playPosition, playState ? "stop" : "play", bind$1(this._handlePlayClick, this, !playState), true);
    function makeBtn(position2, iconName, onclick, willRotate) {
      if (!position2) {
        return;
      }
      var iconSize = parsePercent$1(retrieve2(timelineModel.get(["controlStyle", iconName + "BtnSize"]), controlSize), controlSize);
      var rect = [0, -iconSize / 2, iconSize, iconSize];
      var btn = makeControlIcon(timelineModel, iconName + "Icon", rect, {
        x: position2[0],
        y: position2[1],
        originX: controlSize / 2,
        originY: 0,
        rotation: willRotate ? -rotation : 0,
        rectHover: true,
        style: itemStyle,
        onclick
      });
      btn.ensureState("emphasis").style = hoverStyle;
      group.add(btn);
      enableHoverEmphasis(btn);
    }
  };
  SliderTimelineView2.prototype._renderCurrentPointer = function(layoutInfo, group, axis, timelineModel) {
    var data = timelineModel.getData();
    var currentIndex = timelineModel.getCurrentIndex();
    var pointerModel = data.getItemModel(currentIndex).getModel("checkpointStyle");
    var me2 = this;
    var callback = {
      onCreate: function(pointer) {
        pointer.draggable = true;
        pointer.drift = bind$1(me2._handlePointerDrag, me2);
        pointer.ondragend = bind$1(me2._handlePointerDragend, me2);
        pointerMoveTo(pointer, me2._progressLine, currentIndex, axis, timelineModel, true);
      },
      onUpdate: function(pointer) {
        pointerMoveTo(pointer, me2._progressLine, currentIndex, axis, timelineModel);
      }
    };
    this._currentPointer = giveSymbol(pointerModel, pointerModel, this._mainGroup, {}, this._currentPointer, callback);
  };
  SliderTimelineView2.prototype._handlePlayClick = function(nextState) {
    this._clearTimer();
    this.api.dispatchAction({
      type: "timelinePlayChange",
      playState: nextState,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._handlePointerDrag = function(dx, dy, e2) {
    this._clearTimer();
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY]);
  };
  SliderTimelineView2.prototype._handlePointerDragend = function(e2) {
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
  };
  SliderTimelineView2.prototype._pointerChangeTimeline = function(mousePos, trigger2) {
    var toCoord = this._toAxisCoord(mousePos)[0];
    var axis = this._axis;
    var axisExtent = asc$2(axis.getExtent().slice());
    toCoord > axisExtent[1] && (toCoord = axisExtent[1]);
    toCoord < axisExtent[0] && (toCoord = axisExtent[0]);
    this._currentPointer.x = toCoord;
    this._currentPointer.markRedraw();
    this._progressLine.shape.x2 = toCoord;
    this._progressLine.dirty();
    var targetDataIndex = this._findNearestTick(toCoord);
    var timelineModel = this.model;
    if (trigger2 || targetDataIndex !== timelineModel.getCurrentIndex() && timelineModel.get("realtime")) {
      this._changeTimeline(targetDataIndex);
    }
  };
  SliderTimelineView2.prototype._doPlayStop = function() {
    var _this = this;
    this._clearTimer();
    if (this.model.getPlayState()) {
      this._timer = setTimeout(function() {
        var timelineModel = _this.model;
        _this._changeTimeline(timelineModel.getCurrentIndex() + (timelineModel.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval"));
    }
  };
  SliderTimelineView2.prototype._toAxisCoord = function(vertex) {
    var trans = this._mainGroup.getLocalTransform();
    return applyTransform(vertex, trans, true);
  };
  SliderTimelineView2.prototype._findNearestTick = function(axisCoord) {
    var data = this.model.getData();
    var dist2 = Infinity;
    var targetDataIndex;
    var axis = this._axis;
    data.each(["value"], function(value, dataIndex) {
      var coord = axis.dataToCoord(value);
      var d2 = Math.abs(coord - axisCoord);
      if (d2 < dist2) {
        dist2 = d2;
        targetDataIndex = dataIndex;
      }
    });
    return targetDataIndex;
  };
  SliderTimelineView2.prototype._clearTimer = function() {
    if (this._timer) {
      clearTimeout(this._timer);
      this._timer = null;
    }
  };
  SliderTimelineView2.prototype._changeTimeline = function(nextIndex) {
    var currentIndex = this.model.getCurrentIndex();
    if (nextIndex === "+") {
      nextIndex = currentIndex + 1;
    } else if (nextIndex === "-") {
      nextIndex = currentIndex - 1;
    }
    this.api.dispatchAction({
      type: "timelineChange",
      currentIndex: nextIndex,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._updateTicksStatus = function() {
    var currentIndex = this.model.getCurrentIndex();
    var tickSymbols = this._tickSymbols;
    var tickLabels = this._tickLabels;
    if (tickSymbols) {
      for (var i = 0; i < tickSymbols.length; i++) {
        tickSymbols && tickSymbols[i] && tickSymbols[i].toggleState("progress", i < currentIndex);
      }
    }
    if (tickLabels) {
      for (var i = 0; i < tickLabels.length; i++) {
        tickLabels && tickLabels[i] && tickLabels[i].toggleState("progress", labelDataIndexStore(tickLabels[i]).dataIndex <= currentIndex);
      }
    }
  };
  SliderTimelineView2.type = "timeline.slider";
  return SliderTimelineView2;
}(TimelineView$1);
function createScaleByModel(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new IntervalScale$1();
    }
  }
}
function getViewRect(model, api) {
  return getLayoutRect(model.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  }, model.get("padding"));
}
function makeControlIcon(timelineModel, objPath, rect, opts) {
  var style2 = opts.style;
  var icon = createIcon(timelineModel.get(["controlStyle", objPath]), opts || {}, new BoundingRect$1(rect[0], rect[1], rect[2], rect[3]));
  if (style2) {
    icon.setStyle(style2);
  }
  return icon;
}
function giveSymbol(hostModel, itemStyleModel, group, opt, symbol, callback) {
  var color = itemStyleModel.get("color");
  if (!symbol) {
    var symbolType = hostModel.get("symbol");
    symbol = createSymbol$1(symbolType, -1, -1, 2, 2, color);
    symbol.setStyle("strokeNoScale", true);
    group.add(symbol);
    callback && callback.onCreate(symbol);
  } else {
    symbol.setColor(color);
    group.add(symbol);
    callback && callback.onUpdate(symbol);
  }
  var itemStyle = itemStyleModel.getItemStyle(["color"]);
  symbol.setStyle(itemStyle);
  opt = merge({
    rectHover: true,
    z2: 100
  }, opt, true);
  var symbolSize = normalizeSymbolSize(hostModel.get("symbolSize"));
  opt.scaleX = symbolSize[0] / 2;
  opt.scaleY = symbolSize[1] / 2;
  var symbolOffset = normalizeSymbolOffset(hostModel.get("symbolOffset"), symbolSize);
  if (symbolOffset) {
    opt.x = (opt.x || 0) + symbolOffset[0];
    opt.y = (opt.y || 0) + symbolOffset[1];
  }
  var symbolRotate = hostModel.get("symbolRotate");
  opt.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  symbol.attr(opt);
  symbol.updateTransform();
  return symbol;
}
function pointerMoveTo(pointer, progressLine, dataIndex, axis, timelineModel, noAnimation) {
  if (pointer.dragging) {
    return;
  }
  var pointerModel = timelineModel.getModel("checkpointStyle");
  var toCoord = axis.dataToCoord(timelineModel.getData().get("value", dataIndex));
  if (noAnimation || !pointerModel.get("animation", true)) {
    pointer.attr({
      x: toCoord,
      y: 0
    });
    progressLine && progressLine.attr({
      shape: {
        x2: toCoord
      }
    });
  } else {
    var animationCfg = {
      duration: pointerModel.get("animationDuration", true),
      easing: pointerModel.get("animationEasing", true)
    };
    pointer.stopAnimation(null, true);
    pointer.animateTo({
      x: toCoord,
      y: 0
    }, animationCfg);
    progressLine && progressLine.animateTo({
      shape: {
        x2: toCoord
      }
    }, animationCfg);
  }
}
var SliderTimelineView$1 = SliderTimelineView;
function installTimelineAction(registers) {
  registers.registerAction({
    type: "timelineChange",
    event: "timelineChanged",
    update: "prepareAndUpdate"
  }, function(payload, ecModel, api) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.currentIndex != null) {
      timelineModel.setCurrentIndex(payload.currentIndex);
      if (!timelineModel.get("loop", true) && timelineModel.isIndexMax() && timelineModel.getPlayState()) {
        timelineModel.setPlayState(false);
        api.dispatchAction({
          type: "timelinePlayChange",
          playState: false,
          from: payload.from
        });
      }
    }
    ecModel.resetOption("timeline", {
      replaceMerge: timelineModel.get("replaceMerge", true)
    });
    return defaults({
      currentIndex: timelineModel.option.currentIndex
    }, payload);
  });
  registers.registerAction({
    type: "timelinePlayChange",
    event: "timelinePlayChanged",
    update: "update"
  }, function(payload, ecModel) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.playState != null) {
      timelineModel.setPlayState(payload.playState);
    }
  });
}
function timelinePreprocessor(option) {
  var timelineOpt = option && option.timeline;
  if (!isArray$1(timelineOpt)) {
    timelineOpt = timelineOpt ? [timelineOpt] : [];
  }
  each$g(timelineOpt, function(opt) {
    if (!opt) {
      return;
    }
    compatibleEC2(opt);
  });
}
function compatibleEC2(opt) {
  var type4 = opt.type;
  var ec2Types = {
    "number": "value",
    "time": "time"
  };
  if (ec2Types[type4]) {
    opt.axisType = ec2Types[type4];
    delete opt.type;
  }
  transferItem(opt);
  if (has$1(opt, "controlPosition")) {
    var controlStyle = opt.controlStyle || (opt.controlStyle = {});
    if (!has$1(controlStyle, "position")) {
      controlStyle.position = opt.controlPosition;
    }
    if (controlStyle.position === "none" && !has$1(controlStyle, "show")) {
      controlStyle.show = false;
      delete controlStyle.position;
    }
    delete opt.controlPosition;
  }
  each$g(opt.data || [], function(dataItem) {
    if (isObject$4(dataItem) && !isArray$1(dataItem)) {
      if (!has$1(dataItem, "value") && has$1(dataItem, "name")) {
        dataItem.value = dataItem.name;
      }
      transferItem(dataItem);
    }
  });
}
function transferItem(opt) {
  var itemStyle = opt.itemStyle || (opt.itemStyle = {});
  var itemStyleEmphasis = itemStyle.emphasis || (itemStyle.emphasis = {});
  var label = opt.label || opt.label || {};
  var labelNormal = label.normal || (label.normal = {});
  var excludeLabelAttr = {
    normal: 1,
    emphasis: 1
  };
  each$g(label, function(value, name) {
    if (!excludeLabelAttr[name] && !has$1(labelNormal, name)) {
      labelNormal[name] = value;
    }
  });
  if (itemStyleEmphasis.label && !has$1(label, "emphasis")) {
    label.emphasis = itemStyleEmphasis.label;
    delete itemStyleEmphasis.label;
  }
}
function has$1(obj, attr) {
  return obj.hasOwnProperty(attr);
}
function install$f(registers) {
  registers.registerComponentModel(SliderTimelineModel$1);
  registers.registerComponentView(SliderTimelineView$1);
  registers.registerSubTypeDefaulter("timeline", function() {
    return "slider";
  });
  installTimelineAction(registers);
  registers.registerPreprocessor(timelinePreprocessor);
}
function checkMarkerInSeries(seriesOpts, markerType) {
  if (!seriesOpts) {
    return false;
  }
  var seriesOptArr = isArray$1(seriesOpts) ? seriesOpts : [seriesOpts];
  for (var idx = 0; idx < seriesOptArr.length; idx++) {
    if (seriesOptArr[idx] && seriesOptArr[idx][markerType]) {
      return true;
    }
  }
  return false;
}
function fillLabel(opt) {
  defaultEmphasis(opt, "label", ["show"]);
}
var inner$5 = makeInner();
var MarkerModel = function(_super) {
  __extends(MarkerModel2, _super);
  function MarkerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerModel2.type;
    _this.createdBySelf = false;
    return _this;
  }
  MarkerModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._mergeOption(option, ecModel, false, true);
  };
  MarkerModel2.prototype.isAnimationEnabled = function() {
    if (env$1.node) {
      return false;
    }
    var hostSeries = this.__hostSeries;
    return this.getShallow("animation") && hostSeries && hostSeries.isAnimationEnabled();
  };
  MarkerModel2.prototype.mergeOption = function(newOpt, ecModel) {
    this._mergeOption(newOpt, ecModel, false, false);
  };
  MarkerModel2.prototype._mergeOption = function(newOpt, ecModel, createdBySelf, isInit) {
    var componentType = this.mainType;
    if (!createdBySelf) {
      ecModel.eachSeries(function(seriesModel) {
        var markerOpt = seriesModel.get(this.mainType, true);
        var markerModel = inner$5(seriesModel)[componentType];
        if (!markerOpt || !markerOpt.data) {
          inner$5(seriesModel)[componentType] = null;
          return;
        }
        if (!markerModel) {
          if (isInit) {
            fillLabel(markerOpt);
          }
          each$g(markerOpt.data, function(item) {
            if (item instanceof Array) {
              fillLabel(item[0]);
              fillLabel(item[1]);
            } else {
              fillLabel(item);
            }
          });
          markerModel = this.createMarkerModelFromSeries(markerOpt, this, ecModel);
          extend(markerModel, {
            mainType: this.mainType,
            seriesIndex: seriesModel.seriesIndex,
            name: seriesModel.name,
            createdBySelf: true
          });
          markerModel.__hostSeries = seriesModel;
        } else {
          markerModel._mergeOption(markerOpt, ecModel, true);
        }
        inner$5(seriesModel)[componentType] = markerModel;
      }, this);
    }
  };
  MarkerModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var itemName = data.getName(dataIndex);
    return createTooltipMarkup("section", {
      header: this.name,
      blocks: [createTooltipMarkup("nameValue", {
        name: itemName,
        value,
        noName: !itemName,
        noValue: value == null
      })]
    });
  };
  MarkerModel2.prototype.getData = function() {
    return this._data;
  };
  MarkerModel2.prototype.setData = function(data) {
    this._data = data;
  };
  MarkerModel2.getMarkerModelFromSeries = function(seriesModel, componentType) {
    return inner$5(seriesModel)[componentType];
  };
  MarkerModel2.type = "marker";
  MarkerModel2.dependencies = ["series", "grid", "polar", "geo"];
  return MarkerModel2;
}(ComponentModel$1);
mixin(MarkerModel, DataFormatMixin.prototype);
var MarkerModel$1 = MarkerModel;
var MarkPointModel = function(_super) {
  __extends(MarkPointModel2, _super);
  function MarkPointModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointModel2.type;
    return _this;
  }
  MarkPointModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkPointModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkPointModel2.type = "markPoint";
  MarkPointModel2.defaultOption = {
    z: 5,
    symbol: "pin",
    symbolSize: 50,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "inside"
    },
    itemStyle: {
      borderWidth: 2
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return MarkPointModel2;
}(MarkerModel$1);
var MarkPointModel$1 = MarkPointModel;
function hasXOrY(item) {
  return !(isNaN(parseFloat(item.x)) && isNaN(parseFloat(item.y)));
}
function hasXAndY(item) {
  return !isNaN(parseFloat(item.x)) && !isNaN(parseFloat(item.y));
}
function markerTypeCalculatorWithExtent(markerType, data, otherDataDim, targetDataDim, otherCoordIndex, targetCoordIndex) {
  var coordArr = [];
  var stacked = isDimensionStacked(data, targetDataDim);
  var calcDataDim = stacked ? data.getCalculationInfo("stackResultDimension") : targetDataDim;
  var value = numCalculate(data, calcDataDim, markerType);
  var dataIndex = data.indicesOfNearest(calcDataDim, value)[0];
  coordArr[otherCoordIndex] = data.get(otherDataDim, dataIndex);
  coordArr[targetCoordIndex] = data.get(calcDataDim, dataIndex);
  var coordArrValue = data.get(targetDataDim, dataIndex);
  var precision = getPrecision(data.get(targetDataDim, dataIndex));
  precision = Math.min(precision, 20);
  if (precision >= 0) {
    coordArr[targetCoordIndex] = +coordArr[targetCoordIndex].toFixed(precision);
  }
  return [coordArr, coordArrValue];
}
var markerTypeCalculator = {
  min: curry$1(markerTypeCalculatorWithExtent, "min"),
  max: curry$1(markerTypeCalculatorWithExtent, "max"),
  average: curry$1(markerTypeCalculatorWithExtent, "average"),
  median: curry$1(markerTypeCalculatorWithExtent, "median")
};
function dataTransform(seriesModel, item) {
  var data = seriesModel.getData();
  var coordSys = seriesModel.coordinateSystem;
  if (item && !hasXAndY(item) && !isArray$1(item.coord) && coordSys) {
    var dims = coordSys.dimensions;
    var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
    item = clone$4(item);
    if (item.type && markerTypeCalculator[item.type] && axisInfo.baseAxis && axisInfo.valueAxis) {
      var otherCoordIndex = indexOf(dims, axisInfo.baseAxis.dim);
      var targetCoordIndex = indexOf(dims, axisInfo.valueAxis.dim);
      var coordInfo = markerTypeCalculator[item.type](data, axisInfo.baseDataDim, axisInfo.valueDataDim, otherCoordIndex, targetCoordIndex);
      item.coord = coordInfo[0];
      item.value = coordInfo[1];
    } else {
      var coord = [item.xAxis != null ? item.xAxis : item.radiusAxis, item.yAxis != null ? item.yAxis : item.angleAxis];
      for (var i = 0; i < 2; i++) {
        if (markerTypeCalculator[coord[i]]) {
          coord[i] = numCalculate(data, data.mapDimension(dims[i]), coord[i]);
        }
      }
      item.coord = coord;
    }
  }
  return item;
}
function getAxisInfo(item, data, coordSys, seriesModel) {
  var ret = {};
  if (item.valueIndex != null || item.valueDim != null) {
    ret.valueDataDim = item.valueIndex != null ? data.getDimension(item.valueIndex) : item.valueDim;
    ret.valueAxis = coordSys.getAxis(dataDimToCoordDim(seriesModel, ret.valueDataDim));
    ret.baseAxis = coordSys.getOtherAxis(ret.valueAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
  } else {
    ret.baseAxis = seriesModel.getBaseAxis();
    ret.valueAxis = coordSys.getOtherAxis(ret.baseAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
    ret.valueDataDim = data.mapDimension(ret.valueAxis.dim);
  }
  return ret;
}
function dataDimToCoordDim(seriesModel, dataDim) {
  var dimItem = seriesModel.getData().getDimensionInfo(dataDim);
  return dimItem && dimItem.coordDim;
}
function dataFilter(coordSys, item) {
  return coordSys && coordSys.containData && item.coord && !hasXOrY(item) ? coordSys.containData(item.coord) : true;
}
function createMarkerDimValueGetter(inCoordSys, dims) {
  return inCoordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = dimIndex < 2 ? item.coord && item.coord[dimIndex] : item.value;
    return parseDataValue(rawVal, dims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dims[dimIndex]);
  };
}
function numCalculate(data, valueDataDim, type4) {
  if (type4 === "average") {
    var sum_1 = 0;
    var count_1 = 0;
    data.each(valueDataDim, function(val, idx) {
      if (!isNaN(val)) {
        sum_1 += val;
        count_1++;
      }
    });
    return sum_1 / count_1;
  } else if (type4 === "median") {
    return data.getMedian(valueDataDim);
  } else {
    return data.getDataExtent(valueDataDim)[type4 === "max" ? 1 : 0];
  }
}
var inner$4 = makeInner();
var MarkerView = function(_super) {
  __extends(MarkerView2, _super);
  function MarkerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerView2.type;
    return _this;
  }
  MarkerView2.prototype.init = function() {
    this.markerGroupMap = createHashMap();
  };
  MarkerView2.prototype.render = function(markerModel, ecModel, api) {
    var _this = this;
    var markerGroupMap = this.markerGroupMap;
    markerGroupMap.each(function(item) {
      inner$4(item).keep = false;
    });
    ecModel.eachSeries(function(seriesModel) {
      var markerModel2 = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      markerModel2 && _this.renderSeries(seriesModel, markerModel2, ecModel, api);
    });
    markerGroupMap.each(function(item) {
      !inner$4(item).keep && _this.group.remove(item.group);
    });
  };
  MarkerView2.prototype.markKeep = function(drawGroup) {
    inner$4(drawGroup).keep = true;
  };
  MarkerView2.prototype.blurSeries = function(seriesModelList) {
    var _this = this;
    each$g(seriesModelList, function(seriesModel) {
      var markerModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      if (markerModel) {
        var data = markerModel.getData();
        data.eachItemGraphicEl(function(el) {
          if (el) {
            enterBlur(el);
          }
        });
      }
    });
  };
  MarkerView2.type = "marker";
  return MarkerView2;
}(ComponentView$1);
var MarkerView$1 = MarkerView;
function updateMarkerLayout(mpData, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  mpData.each(function(idx) {
    var itemModel = mpData.getItemModel(idx);
    var point;
    var xPx = parsePercent(itemModel.get("x"), api.getWidth());
    var yPx = parsePercent(itemModel.get("y"), api.getHeight());
    if (!isNaN(xPx) && !isNaN(yPx)) {
      point = [xPx, yPx];
    } else if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(mpData.getValues(mpData.dimensions, idx));
    } else if (coordSys) {
      var x2 = mpData.get(coordSys.dimensions[0], idx);
      var y2 = mpData.get(coordSys.dimensions[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
    mpData.setItemLayout(idx, point);
  });
}
var MarkPointView = function(_super) {
  __extends(MarkPointView2, _super);
  function MarkPointView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointView2.type;
    return _this;
  }
  MarkPointView2.prototype.updateTransform = function(markPointModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mpModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markPoint");
      if (mpModel) {
        updateMarkerLayout(mpModel.getData(), seriesModel, api);
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkPointView2.prototype.renderSeries = function(seriesModel, mpModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var symbolDrawMap = this.markerGroupMap;
    var symbolDraw = symbolDrawMap.get(seriesId) || symbolDrawMap.set(seriesId, new SymbolDraw$1());
    var mpData = createData(coordSys, seriesModel, mpModel);
    mpModel.setData(mpData);
    updateMarkerLayout(mpModel.getData(), seriesModel, api);
    mpData.each(function(idx) {
      var itemModel = mpData.getItemModel(idx);
      var symbol = itemModel.getShallow("symbol");
      var symbolSize = itemModel.getShallow("symbolSize");
      var symbolRotate = itemModel.getShallow("symbolRotate");
      var symbolOffset = itemModel.getShallow("symbolOffset");
      var symbolKeepAspect = itemModel.getShallow("symbolKeepAspect");
      if (isFunction(symbol) || isFunction(symbolSize) || isFunction(symbolRotate) || isFunction(symbolOffset)) {
        var rawIdx = mpModel.getRawValue(idx);
        var dataParams = mpModel.getDataParams(idx);
        if (isFunction(symbol)) {
          symbol = symbol(rawIdx, dataParams);
        }
        if (isFunction(symbolSize)) {
          symbolSize = symbolSize(rawIdx, dataParams);
        }
        if (isFunction(symbolRotate)) {
          symbolRotate = symbolRotate(rawIdx, dataParams);
        }
        if (isFunction(symbolOffset)) {
          symbolOffset = symbolOffset(rawIdx, dataParams);
        }
      }
      var style2 = itemModel.getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style2.fill) {
        style2.fill = color;
      }
      mpData.setItemVisual(idx, {
        symbol,
        symbolSize,
        symbolRotate,
        symbolOffset,
        symbolKeepAspect,
        style: style2
      });
    });
    symbolDraw.updateData(mpData);
    this.group.add(symbolDraw.group);
    mpData.eachItemGraphicEl(function(el) {
      el.traverse(function(child) {
        getECData(child).dataModel = mpModel;
      });
    });
    this.markKeep(symbolDraw);
    symbolDraw.group.silent = mpModel.get("silent") || seriesModel.get("silent");
  };
  MarkPointView2.type = "markPoint";
  return MarkPointView2;
}(MarkerView$1);
function createData(coordSys, seriesModel, mpModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var mpData = new SeriesData$1(coordDimsInfos, mpModel);
  var dataOpt = map$1(mpModel.get("data"), curry$1(dataTransform, seriesModel));
  if (coordSys) {
    dataOpt = filter(dataOpt, curry$1(dataFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  mpData.initData(dataOpt, null, dimValueGetter);
  return mpData;
}
var MarkPointView$1 = MarkPointView;
function install$e(registers) {
  registers.registerComponentModel(MarkPointModel$1);
  registers.registerComponentView(MarkPointView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markPoint")) {
      opt.markPoint = opt.markPoint || {};
    }
  });
}
var MarkLineModel = function(_super) {
  __extends(MarkLineModel2, _super);
  function MarkLineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineModel2.type;
    return _this;
  }
  MarkLineModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkLineModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkLineModel2.type = "markLine";
  MarkLineModel2.defaultOption = {
    z: 5,
    symbol: ["circle", "arrow"],
    symbolSize: [8, 16],
    symbolOffset: 0,
    precision: 2,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "end",
      distance: 5
    },
    lineStyle: {
      type: "dashed"
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        width: 3
      }
    },
    animationEasing: "linear"
  };
  return MarkLineModel2;
}(MarkerModel$1);
var MarkLineModel$1 = MarkLineModel;
var inner$3 = makeInner();
var markLineTransform = function(seriesModel, coordSys, mlModel, item) {
  var data = seriesModel.getData();
  var itemArray;
  if (!isArray$1(item)) {
    var mlType = item.type;
    if (mlType === "min" || mlType === "max" || mlType === "average" || mlType === "median" || item.xAxis != null || item.yAxis != null) {
      var valueAxis2 = void 0;
      var value = void 0;
      if (item.yAxis != null || item.xAxis != null) {
        valueAxis2 = coordSys.getAxis(item.yAxis != null ? "y" : "x");
        value = retrieve(item.yAxis, item.xAxis);
      } else {
        var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
        valueAxis2 = axisInfo.valueAxis;
        var valueDataDim = getStackedDimension(data, axisInfo.valueDataDim);
        value = numCalculate(data, valueDataDim, mlType);
      }
      var valueIndex = valueAxis2.dim === "x" ? 0 : 1;
      var baseIndex = 1 - valueIndex;
      var mlFrom = clone$4(item);
      var mlTo = {
        coord: []
      };
      mlFrom.type = null;
      mlFrom.coord = [];
      mlFrom.coord[baseIndex] = -Infinity;
      mlTo.coord[baseIndex] = Infinity;
      var precision = mlModel.get("precision");
      if (precision >= 0 && isNumber(value)) {
        value = +value.toFixed(Math.min(precision, 20));
      }
      mlFrom.coord[valueIndex] = mlTo.coord[valueIndex] = value;
      itemArray = [mlFrom, mlTo, {
        type: mlType,
        valueIndex: item.valueIndex,
        value
      }];
    } else {
      itemArray = [];
    }
  } else {
    itemArray = item;
  }
  var normalizedItem = [dataTransform(seriesModel, itemArray[0]), dataTransform(seriesModel, itemArray[1]), extend({}, itemArray[2])];
  normalizedItem[2].type = normalizedItem[2].type || null;
  merge(normalizedItem[2], normalizedItem[0]);
  merge(normalizedItem[2], normalizedItem[1]);
  return normalizedItem;
};
function isInifinity$1(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkLineHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  var dimName = coordSys.dimensions[dimIndex];
  return isInifinity$1(fromCoord[otherDimIndex]) && isInifinity$1(toCoord[otherDimIndex]) && fromCoord[dimIndex] === toCoord[dimIndex] && coordSys.getAxis(dimName).containData(fromCoord[dimIndex]);
}
function markLineFilter(coordSys, item) {
  if (coordSys.type === "cartesian2d") {
    var fromCoord = item[0].coord;
    var toCoord = item[1].coord;
    if (fromCoord && toCoord && (ifMarkLineHasOnlyDim(1, fromCoord, toCoord, coordSys) || ifMarkLineHasOnlyDim(0, fromCoord, toCoord, coordSys))) {
      return true;
    }
  }
  return dataFilter(coordSys, item[0]) && dataFilter(coordSys, item[1]);
}
function updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get("x"), api.getWidth());
  var yPx = parsePercent(itemModel.get("y"), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(data.dimensions, idx));
    } else {
      var dims = coordSys.dimensions;
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var dims = coordSys.dimensions;
      if (isInifinity$1(data.get(dims[0], idx))) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[isFrom ? 0 : 1]);
      } else if (isInifinity$1(data.get(dims[1], idx))) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[isFrom ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  data.setItemLayout(idx, point);
}
var MarkLineView = function(_super) {
  __extends(MarkLineView2, _super);
  function MarkLineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineView2.type;
    return _this;
  }
  MarkLineView2.prototype.updateTransform = function(markLineModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mlModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markLine");
      if (mlModel) {
        var mlData_1 = mlModel.getData();
        var fromData_1 = inner$3(mlModel).from;
        var toData_1 = inner$3(mlModel).to;
        fromData_1.each(function(idx) {
          updateSingleMarkerEndLayout(fromData_1, idx, true, seriesModel, api);
          updateSingleMarkerEndLayout(toData_1, idx, false, seriesModel, api);
        });
        mlData_1.each(function(idx) {
          mlData_1.setItemLayout(idx, [fromData_1.getItemLayout(idx), toData_1.getItemLayout(idx)]);
        });
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkLineView2.prototype.renderSeries = function(seriesModel, mlModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var lineDrawMap = this.markerGroupMap;
    var lineDraw = lineDrawMap.get(seriesId) || lineDrawMap.set(seriesId, new LineDraw$1());
    this.group.add(lineDraw.group);
    var mlData = createList$1(coordSys, seriesModel, mlModel);
    var fromData = mlData.from;
    var toData = mlData.to;
    var lineData = mlData.line;
    inner$3(mlModel).from = fromData;
    inner$3(mlModel).to = toData;
    mlModel.setData(lineData);
    var symbolType = mlModel.get("symbol");
    var symbolSize = mlModel.get("symbolSize");
    var symbolRotate = mlModel.get("symbolRotate");
    var symbolOffset = mlModel.get("symbolOffset");
    if (!isArray$1(symbolType)) {
      symbolType = [symbolType, symbolType];
    }
    if (!isArray$1(symbolSize)) {
      symbolSize = [symbolSize, symbolSize];
    }
    if (!isArray$1(symbolRotate)) {
      symbolRotate = [symbolRotate, symbolRotate];
    }
    if (!isArray$1(symbolOffset)) {
      symbolOffset = [symbolOffset, symbolOffset];
    }
    mlData.from.each(function(idx) {
      updateDataVisualAndLayout(fromData, idx, true);
      updateDataVisualAndLayout(toData, idx, false);
    });
    lineData.each(function(idx) {
      var lineStyle = lineData.getItemModel(idx).getModel("lineStyle").getLineStyle();
      lineData.setItemLayout(idx, [fromData.getItemLayout(idx), toData.getItemLayout(idx)]);
      if (lineStyle.stroke == null) {
        lineStyle.stroke = fromData.getItemVisual(idx, "style").fill;
      }
      lineData.setItemVisual(idx, {
        fromSymbolKeepAspect: fromData.getItemVisual(idx, "symbolKeepAspect"),
        fromSymbolOffset: fromData.getItemVisual(idx, "symbolOffset"),
        fromSymbolRotate: fromData.getItemVisual(idx, "symbolRotate"),
        fromSymbolSize: fromData.getItemVisual(idx, "symbolSize"),
        fromSymbol: fromData.getItemVisual(idx, "symbol"),
        toSymbolKeepAspect: toData.getItemVisual(idx, "symbolKeepAspect"),
        toSymbolOffset: toData.getItemVisual(idx, "symbolOffset"),
        toSymbolRotate: toData.getItemVisual(idx, "symbolRotate"),
        toSymbolSize: toData.getItemVisual(idx, "symbolSize"),
        toSymbol: toData.getItemVisual(idx, "symbol"),
        style: lineStyle
      });
    });
    lineDraw.updateData(lineData);
    mlData.line.eachItemGraphicEl(function(el, idx) {
      el.traverse(function(child) {
        getECData(child).dataModel = mlModel;
      });
    });
    function updateDataVisualAndLayout(data, idx, isFrom) {
      var itemModel = data.getItemModel(idx);
      updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api);
      var style2 = itemModel.getModel("itemStyle").getItemStyle();
      if (style2.fill == null) {
        style2.fill = getVisualFromData(seriesData, "color");
      }
      data.setItemVisual(idx, {
        symbolKeepAspect: itemModel.get("symbolKeepAspect"),
        symbolOffset: retrieve2(itemModel.get("symbolOffset", true), symbolOffset[isFrom ? 0 : 1]),
        symbolRotate: retrieve2(itemModel.get("symbolRotate", true), symbolRotate[isFrom ? 0 : 1]),
        symbolSize: retrieve2(itemModel.get("symbolSize"), symbolSize[isFrom ? 0 : 1]),
        symbol: retrieve2(itemModel.get("symbol", true), symbolType[isFrom ? 0 : 1]),
        style: style2
      });
    }
    this.markKeep(lineDraw);
    lineDraw.group.silent = mlModel.get("silent") || seriesModel.get("silent");
  };
  MarkLineView2.type = "markLine";
  return MarkLineView2;
}(MarkerView$1);
function createList$1(coordSys, seriesModel, mlModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var fromData = new SeriesData$1(coordDimsInfos, mlModel);
  var toData = new SeriesData$1(coordDimsInfos, mlModel);
  var lineData = new SeriesData$1([], mlModel);
  var optData = map$1(mlModel.get("data"), curry$1(markLineTransform, seriesModel, coordSys, mlModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markLineFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  fromData.initData(map$1(optData, function(item) {
    return item[0];
  }), null, dimValueGetter);
  toData.initData(map$1(optData, function(item) {
    return item[1];
  }), null, dimValueGetter);
  lineData.initData(map$1(optData, function(item) {
    return item[2];
  }));
  lineData.hasItemOption = true;
  return {
    from: fromData,
    to: toData,
    line: lineData
  };
}
var MarkLineView$1 = MarkLineView;
function install$d(registers) {
  registers.registerComponentModel(MarkLineModel$1);
  registers.registerComponentView(MarkLineView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markLine")) {
      opt.markLine = opt.markLine || {};
    }
  });
}
var MarkAreaModel = function(_super) {
  __extends(MarkAreaModel2, _super);
  function MarkAreaModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaModel2.type;
    return _this;
  }
  MarkAreaModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkAreaModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkAreaModel2.type = "markArea";
  MarkAreaModel2.defaultOption = {
    z: 1,
    tooltip: {
      trigger: "item"
    },
    animation: false,
    label: {
      show: true,
      position: "top"
    },
    itemStyle: {
      borderWidth: 0
    },
    emphasis: {
      label: {
        show: true,
        position: "top"
      }
    }
  };
  return MarkAreaModel2;
}(MarkerModel$1);
var MarkAreaModel$1 = MarkAreaModel;
var inner$2 = makeInner();
var markAreaTransform = function(seriesModel, coordSys, maModel, item) {
  var lt2 = dataTransform(seriesModel, item[0]);
  var rb2 = dataTransform(seriesModel, item[1]);
  var ltCoord = lt2.coord;
  var rbCoord = rb2.coord;
  ltCoord[0] = retrieve(ltCoord[0], -Infinity);
  ltCoord[1] = retrieve(ltCoord[1], -Infinity);
  rbCoord[0] = retrieve(rbCoord[0], Infinity);
  rbCoord[1] = retrieve(rbCoord[1], Infinity);
  var result = mergeAll([{}, lt2, rb2]);
  result.coord = [lt2.coord, rb2.coord];
  result.x0 = lt2.x;
  result.y0 = lt2.y;
  result.x1 = rb2.x;
  result.y1 = rb2.y;
  return result;
};
function isInifinity(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkAreaHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  return isInifinity(fromCoord[otherDimIndex]) && isInifinity(toCoord[otherDimIndex]);
}
function markAreaFilter(coordSys, item) {
  var fromCoord = item.coord[0];
  var toCoord = item.coord[1];
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    if (fromCoord && toCoord && (ifMarkAreaHasOnlyDim(1, fromCoord, toCoord) || ifMarkAreaHasOnlyDim(0, fromCoord, toCoord))) {
      return true;
    }
  }
  return dataFilter(coordSys, {
    coord: fromCoord,
    x: item.x0,
    y: item.y0
  }) || dataFilter(coordSys, {
    coord: toCoord,
    x: item.x1,
    y: item.y1
  });
}
function getSingleMarkerEndPoint(data, idx, dims, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get(dims[0]), api.getWidth());
  var yPx = parsePercent(itemModel.get(dims[1]), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(dims, idx));
    } else {
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      var pt = [x2, y2];
      coordSys.clampData && coordSys.clampData(pt, pt);
      point = coordSys.dataToPoint(pt, true);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      if (isInifinity(x2)) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[dims[0] === "x0" ? 0 : 1]);
      } else if (isInifinity(y2)) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[dims[1] === "y0" ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  return point;
}
var dimPermutations = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]];
var MarkAreaView = function(_super) {
  __extends(MarkAreaView2, _super);
  function MarkAreaView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaView2.type;
    return _this;
  }
  MarkAreaView2.prototype.updateTransform = function(markAreaModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var maModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markArea");
      if (maModel) {
        var areaData_1 = maModel.getData();
        areaData_1.each(function(idx) {
          var points2 = map$1(dimPermutations, function(dim) {
            return getSingleMarkerEndPoint(areaData_1, idx, dim, seriesModel, api);
          });
          areaData_1.setItemLayout(idx, points2);
          var el = areaData_1.getItemGraphicEl(idx);
          el.setShape("points", points2);
        });
      }
    }, this);
  };
  MarkAreaView2.prototype.renderSeries = function(seriesModel, maModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var areaGroupMap = this.markerGroupMap;
    var polygonGroup = areaGroupMap.get(seriesId) || areaGroupMap.set(seriesId, {
      group: new Group$6()
    });
    this.group.add(polygonGroup.group);
    this.markKeep(polygonGroup);
    var areaData = createList(coordSys, seriesModel, maModel);
    maModel.setData(areaData);
    areaData.each(function(idx) {
      var points2 = map$1(dimPermutations, function(dim) {
        return getSingleMarkerEndPoint(areaData, idx, dim, seriesModel, api);
      });
      var xAxisScale = coordSys.getAxis("x").scale;
      var yAxisScale = coordSys.getAxis("y").scale;
      var xAxisExtent = xAxisScale.getExtent();
      var yAxisExtent = yAxisScale.getExtent();
      var xPointExtent = [xAxisScale.parse(areaData.get("x0", idx)), xAxisScale.parse(areaData.get("x1", idx))];
      var yPointExtent = [yAxisScale.parse(areaData.get("y0", idx)), yAxisScale.parse(areaData.get("y1", idx))];
      asc$2(xPointExtent);
      asc$2(yPointExtent);
      var overlapped = !(xAxisExtent[0] > xPointExtent[1] || xAxisExtent[1] < xPointExtent[0] || yAxisExtent[0] > yPointExtent[1] || yAxisExtent[1] < yPointExtent[0]);
      var allClipped = !overlapped;
      areaData.setItemLayout(idx, {
        points: points2,
        allClipped
      });
      var style2 = areaData.getItemModel(idx).getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style2.fill) {
        style2.fill = color;
        if (isString$1(style2.fill)) {
          style2.fill = modifyAlpha(style2.fill, 0.4);
        }
      }
      if (!style2.stroke) {
        style2.stroke = color;
      }
      areaData.setItemVisual(idx, "style", style2);
    });
    areaData.diff(inner$2(polygonGroup).data).add(function(idx) {
      var layout2 = areaData.getItemLayout(idx);
      if (!layout2.allClipped) {
        var polygon = new Polygon$1({
          shape: {
            points: layout2.points
          }
        });
        areaData.setItemGraphicEl(idx, polygon);
        polygonGroup.group.add(polygon);
      }
    }).update(function(newIdx, oldIdx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(oldIdx);
      var layout2 = areaData.getItemLayout(newIdx);
      if (!layout2.allClipped) {
        if (polygon) {
          updateProps$1(polygon, {
            shape: {
              points: layout2.points
            }
          }, maModel, newIdx);
        } else {
          polygon = new Polygon$1({
            shape: {
              points: layout2.points
            }
          });
        }
        areaData.setItemGraphicEl(newIdx, polygon);
        polygonGroup.group.add(polygon);
      } else if (polygon) {
        polygonGroup.group.remove(polygon);
      }
    }).remove(function(idx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(idx);
      polygonGroup.group.remove(polygon);
    }).execute();
    areaData.eachItemGraphicEl(function(polygon, idx) {
      var itemModel = areaData.getItemModel(idx);
      var style2 = areaData.getItemVisual(idx, "style");
      polygon.useStyle(areaData.getItemVisual(idx, "style"));
      setLabelStyle(polygon, getLabelStatesModels(itemModel), {
        labelFetcher: maModel,
        labelDataIndex: idx,
        defaultText: areaData.getName(idx) || "",
        inheritColor: isString$1(style2.fill) ? modifyAlpha(style2.fill, 1) : "#000"
      });
      setStatesStylesFromModel(polygon, itemModel);
      toggleHoverEmphasis(polygon, null, null, itemModel.get(["emphasis", "disabled"]));
      getECData(polygon).dataModel = maModel;
    });
    inner$2(polygonGroup).data = areaData;
    polygonGroup.group.silent = maModel.get("silent") || seriesModel.get("silent");
  };
  MarkAreaView2.type = "markArea";
  return MarkAreaView2;
}(MarkerView$1);
function createList(coordSys, seriesModel, maModel) {
  var areaData;
  var dataDims;
  var dims = ["x0", "y0", "x1", "y1"];
  if (coordSys) {
    var coordDimsInfos_1 = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var data = seriesModel.getData();
      var info = data.getDimensionInfo(data.mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
    dataDims = map$1(dims, function(dim, idx) {
      return {
        name: dim,
        type: coordDimsInfos_1[idx % 2].type
      };
    });
    areaData = new SeriesData$1(dataDims, maModel);
  } else {
    dataDims = [{
      name: "value",
      type: "float"
    }];
    areaData = new SeriesData$1(dataDims, maModel);
  }
  var optData = map$1(maModel.get("data"), curry$1(markAreaTransform, seriesModel, coordSys, maModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markAreaFilter, coordSys));
  }
  var dimValueGetter = coordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = item.coord[Math.floor(dimIndex / 2)][dimIndex % 2];
    return parseDataValue(rawVal, dataDims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dataDims[dimIndex]);
  };
  areaData.initData(optData, null, dimValueGetter);
  areaData.hasItemOption = true;
  return areaData;
}
var MarkAreaView$1 = MarkAreaView;
function install$c(registers) {
  registers.registerComponentModel(MarkAreaModel$1);
  registers.registerComponentView(MarkAreaView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markArea")) {
      opt.markArea = opt.markArea || {};
    }
  });
}
var getDefaultSelectorOptions = function(ecModel, type4) {
  if (type4 === "all") {
    return {
      type: "all",
      title: ecModel.getLocaleModel().get(["legend", "selector", "all"])
    };
  } else if (type4 === "inverse") {
    return {
      type: "inverse",
      title: ecModel.getLocaleModel().get(["legend", "selector", "inverse"])
    };
  }
};
var LegendModel = function(_super) {
  __extends(LegendModel2, _super);
  function LegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  LegendModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    option.selected = option.selected || {};
    this._updateSelector(option);
  };
  LegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    this._updateSelector(option);
  };
  LegendModel2.prototype._updateSelector = function(option) {
    var selector2 = option.selector;
    var ecModel = this.ecModel;
    if (selector2 === true) {
      selector2 = option.selector = ["all", "inverse"];
    }
    if (isArray$1(selector2)) {
      each$g(selector2, function(item, index2) {
        isString$1(item) && (item = {
          type: item
        });
        selector2[index2] = merge(item, getDefaultSelectorOptions(ecModel, item.type));
      });
    }
  };
  LegendModel2.prototype.optionUpdated = function() {
    this._updateData(this.ecModel);
    var legendData = this._data;
    if (legendData[0] && this.get("selectedMode") === "single") {
      var hasSelected = false;
      for (var i = 0; i < legendData.length; i++) {
        var name_1 = legendData[i].get("name");
        if (this.isSelected(name_1)) {
          this.select(name_1);
          hasSelected = true;
          break;
        }
      }
      !hasSelected && this.select(legendData[0].get("name"));
    }
  };
  LegendModel2.prototype._updateData = function(ecModel) {
    var potentialData = [];
    var availableNames = [];
    ecModel.eachRawSeries(function(seriesModel) {
      var seriesName = seriesModel.name;
      availableNames.push(seriesName);
      var isPotential;
      if (seriesModel.legendVisualProvider) {
        var provider = seriesModel.legendVisualProvider;
        var names2 = provider.getAllNames();
        if (!ecModel.isSeriesFiltered(seriesModel)) {
          availableNames = availableNames.concat(names2);
        }
        if (names2.length) {
          potentialData = potentialData.concat(names2);
        } else {
          isPotential = true;
        }
      } else {
        isPotential = true;
      }
      if (isPotential && isNameSpecified(seriesModel)) {
        potentialData.push(seriesModel.name);
      }
    });
    this._availableNames = availableNames;
    var rawData = this.get("data") || potentialData;
    var legendData = map$1(rawData, function(dataItem) {
      if (isString$1(dataItem) || isNumber(dataItem)) {
        dataItem = {
          name: dataItem
        };
      }
      return new Model$1(dataItem, this, this.ecModel);
    }, this);
    this._data = legendData;
  };
  LegendModel2.prototype.getData = function() {
    return this._data;
  };
  LegendModel2.prototype.select = function(name) {
    var selected = this.option.selected;
    var selectedMode = this.get("selectedMode");
    if (selectedMode === "single") {
      var data = this._data;
      each$g(data, function(dataItem) {
        selected[dataItem.get("name")] = false;
      });
    }
    selected[name] = true;
  };
  LegendModel2.prototype.unSelect = function(name) {
    if (this.get("selectedMode") !== "single") {
      this.option.selected[name] = false;
    }
  };
  LegendModel2.prototype.toggleSelected = function(name) {
    var selected = this.option.selected;
    if (!selected.hasOwnProperty(name)) {
      selected[name] = true;
    }
    this[selected[name] ? "unSelect" : "select"](name);
  };
  LegendModel2.prototype.allSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$g(data, function(dataItem) {
      selected[dataItem.get("name", true)] = true;
    });
  };
  LegendModel2.prototype.inverseSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$g(data, function(dataItem) {
      var name = dataItem.get("name", true);
      if (!selected.hasOwnProperty(name)) {
        selected[name] = true;
      }
      selected[name] = !selected[name];
    });
  };
  LegendModel2.prototype.isSelected = function(name) {
    var selected = this.option.selected;
    return !(selected.hasOwnProperty(name) && !selected[name]) && indexOf(this._availableNames, name) >= 0;
  };
  LegendModel2.prototype.getOrient = function() {
    return this.get("orient") === "vertical" ? {
      index: 1,
      name: "vertical"
    } : {
      index: 0,
      name: "horizontal"
    };
  };
  LegendModel2.type = "legend.plain";
  LegendModel2.dependencies = ["series"];
  LegendModel2.defaultOption = {
    z: 4,
    show: true,
    orient: "horizontal",
    left: "center",
    top: 0,
    align: "auto",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    itemWidth: 25,
    itemHeight: 14,
    symbolRotate: "inherit",
    symbolKeepAspect: true,
    inactiveColor: "#ccc",
    inactiveBorderColor: "#ccc",
    inactiveBorderWidth: "auto",
    itemStyle: {
      color: "inherit",
      opacity: "inherit",
      borderColor: "inherit",
      borderWidth: "auto",
      borderCap: "inherit",
      borderJoin: "inherit",
      borderDashOffset: "inherit",
      borderMiterLimit: "inherit"
    },
    lineStyle: {
      width: "auto",
      color: "inherit",
      inactiveColor: "#ccc",
      inactiveWidth: 2,
      opacity: "inherit",
      type: "inherit",
      cap: "inherit",
      join: "inherit",
      dashOffset: "inherit",
      miterLimit: "inherit"
    },
    textStyle: {
      color: "#333"
    },
    selectedMode: true,
    selector: false,
    selectorLabel: {
      show: true,
      borderRadius: 10,
      padding: [3, 5, 3, 5],
      fontSize: 12,
      fontFamily: "sans-serif",
      color: "#666",
      borderWidth: 1,
      borderColor: "#666"
    },
    emphasis: {
      selectorLabel: {
        show: true,
        color: "#eee",
        backgroundColor: "#666"
      }
    },
    selectorPosition: "auto",
    selectorItemGap: 7,
    selectorButtonGap: 10,
    tooltip: {
      show: false
    }
  };
  return LegendModel2;
}(ComponentModel$1);
var LegendModel$1 = LegendModel;
var curry = curry$1;
var each$4 = each$g;
var Group$3 = Group$6;
var LegendView = function(_super) {
  __extends(LegendView2, _super);
  function LegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendView2.type;
    _this.newlineDisabled = false;
    return _this;
  }
  LegendView2.prototype.init = function() {
    this.group.add(this._contentGroup = new Group$3());
    this.group.add(this._selectorGroup = new Group$3());
    this._isFirstRender = true;
  };
  LegendView2.prototype.getContentGroup = function() {
    return this._contentGroup;
  };
  LegendView2.prototype.getSelectorGroup = function() {
    return this._selectorGroup;
  };
  LegendView2.prototype.render = function(legendModel, ecModel, api) {
    var isFirstRender = this._isFirstRender;
    this._isFirstRender = false;
    this.resetInner();
    if (!legendModel.get("show", true)) {
      return;
    }
    var itemAlign = legendModel.get("align");
    var orient = legendModel.get("orient");
    if (!itemAlign || itemAlign === "auto") {
      itemAlign = legendModel.get("left") === "right" && orient === "vertical" ? "right" : "left";
    }
    var selector2 = legendModel.get("selector", true);
    var selectorPosition = legendModel.get("selectorPosition", true);
    if (selector2 && (!selectorPosition || selectorPosition === "auto")) {
      selectorPosition = orient === "horizontal" ? "end" : "start";
    }
    this.renderInner(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var positionInfo = legendModel.getBoxLayoutParams();
    var viewportSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var padding = legendModel.get("padding");
    var maxSize = getLayoutRect(positionInfo, viewportSize, padding);
    var mainRect = this.layoutInner(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition);
    var layoutRect = getLayoutRect(defaults({
      width: mainRect.width,
      height: mainRect.height
    }, positionInfo), viewportSize, padding);
    this.group.x = layoutRect.x - mainRect.x;
    this.group.y = layoutRect.y - mainRect.y;
    this.group.markRedraw();
    this.group.add(this._backgroundEl = makeBackground(mainRect, legendModel));
  };
  LegendView2.prototype.resetInner = function() {
    this.getContentGroup().removeAll();
    this._backgroundEl && this.group.remove(this._backgroundEl);
    this.getSelectorGroup().removeAll();
  };
  LegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var legendDrawnMap = createHashMap();
    var selectMode = legendModel.get("selectedMode");
    var excludeSeriesId = [];
    ecModel.eachRawSeries(function(seriesModel) {
      !seriesModel.get("legendHoverLink") && excludeSeriesId.push(seriesModel.id);
    });
    each$4(legendModel.getData(), function(legendItemModel, dataIndex) {
      var name = legendItemModel.get("name");
      if (!this.newlineDisabled && (name === "" || name === "\n")) {
        var g2 = new Group$3();
        g2.newline = true;
        contentGroup.add(g2);
        return;
      }
      var seriesModel = ecModel.getSeriesByName(name)[0];
      if (legendDrawnMap.get(name)) {
        return;
      }
      if (seriesModel) {
        var data = seriesModel.getData();
        var lineVisualStyle = data.getVisual("legendLineStyle") || {};
        var legendIcon = data.getVisual("legendIcon");
        var style2 = data.getVisual("style");
        var itemGroup = this._createItem(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, style2, legendIcon, selectMode);
        itemGroup.on("click", curry(dispatchSelectAction, name, null, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, seriesModel.name, null, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, seriesModel.name, null, api, excludeSeriesId));
        legendDrawnMap.set(name, true);
      } else {
        ecModel.eachRawSeries(function(seriesModel2) {
          if (legendDrawnMap.get(name)) {
            return;
          }
          if (seriesModel2.legendVisualProvider) {
            var provider = seriesModel2.legendVisualProvider;
            if (!provider.containName(name)) {
              return;
            }
            var idx = provider.indexOfName(name);
            var style3 = provider.getItemVisual(idx, "style");
            var legendIcon2 = provider.getItemVisual(idx, "legendIcon");
            var colorArr = parse(style3.fill);
            if (colorArr && colorArr[3] === 0) {
              colorArr[3] = 0.2;
              style3 = extend(extend({}, style3), {
                fill: stringify(colorArr, "rgba")
              });
            }
            var itemGroup2 = this._createItem(seriesModel2, name, dataIndex, legendItemModel, legendModel, itemAlign, {}, style3, legendIcon2, selectMode);
            itemGroup2.on("click", curry(dispatchSelectAction, null, name, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, null, name, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, null, name, api, excludeSeriesId));
            legendDrawnMap.set(name, true);
          }
        }, this);
      }
    }, this);
    if (selector2) {
      this._createSelector(selector2, legendModel, api, orient, selectorPosition);
    }
  };
  LegendView2.prototype._createSelector = function(selector2, legendModel, api, orient, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    each$4(selector2, function createSelectorButton(selectorItem) {
      var type4 = selectorItem.type;
      var labelText = new ZRText$1({
        style: {
          x: 0,
          y: 0,
          align: "center",
          verticalAlign: "middle"
        },
        onclick: function() {
          api.dispatchAction({
            type: type4 === "all" ? "legendAllSelect" : "legendInverseSelect"
          });
        }
      });
      selectorGroup.add(labelText);
      var labelModel = legendModel.getModel("selectorLabel");
      var emphasisLabelModel = legendModel.getModel(["emphasis", "selectorLabel"]);
      setLabelStyle(labelText, {
        normal: labelModel,
        emphasis: emphasisLabelModel
      }, {
        defaultText: selectorItem.title
      });
      enableHoverEmphasis(labelText);
    });
  };
  LegendView2.prototype._createItem = function(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, itemVisualStyle, legendIcon, selectMode) {
    var drawType = seriesModel.visualDrawType;
    var itemWidth = legendModel.get("itemWidth");
    var itemHeight = legendModel.get("itemHeight");
    var isSelected = legendModel.isSelected(name);
    var iconRotate = legendItemModel.get("symbolRotate");
    var symbolKeepAspect = legendItemModel.get("symbolKeepAspect");
    var legendIconType = legendItemModel.get("icon");
    legendIcon = legendIconType || legendIcon || "roundRect";
    var style2 = getLegendStyle(legendIcon, legendItemModel, lineVisualStyle, itemVisualStyle, drawType, isSelected);
    var itemGroup = new Group$3();
    var textStyleModel = legendItemModel.getModel("textStyle");
    if (isFunction(seriesModel.getLegendIcon) && (!legendIconType || legendIconType === "inherit")) {
      itemGroup.add(seriesModel.getLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate,
        itemStyle: style2.itemStyle,
        lineStyle: style2.lineStyle,
        symbolKeepAspect
      }));
    } else {
      var rotate2 = legendIconType === "inherit" && seriesModel.getData().getVisual("symbol") ? iconRotate === "inherit" ? seriesModel.getData().getVisual("symbolRotate") : iconRotate : 0;
      itemGroup.add(getDefaultLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate: rotate2,
        itemStyle: style2.itemStyle,
        lineStyle: style2.lineStyle,
        symbolKeepAspect
      }));
    }
    var textX = itemAlign === "left" ? itemWidth + 5 : -5;
    var textAlign = itemAlign;
    var formatter = legendModel.get("formatter");
    var content = name;
    if (isString$1(formatter) && formatter) {
      content = formatter.replace("{name}", name != null ? name : "");
    } else if (isFunction(formatter)) {
      content = formatter(name);
    }
    var inactiveColor = legendItemModel.get("inactiveColor");
    itemGroup.add(new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: content,
        x: textX,
        y: itemHeight / 2,
        fill: isSelected ? textStyleModel.getTextColor() : inactiveColor,
        align: textAlign,
        verticalAlign: "middle"
      })
    }));
    var hitRect = new Rect$3({
      shape: itemGroup.getBoundingRect(),
      invisible: true
    });
    var tooltipModel = legendItemModel.getModel("tooltip");
    if (tooltipModel.get("show")) {
      setTooltipConfig({
        el: hitRect,
        componentModel: legendModel,
        itemName: name,
        itemTooltipOption: tooltipModel.option
      });
    }
    itemGroup.add(hitRect);
    itemGroup.eachChild(function(child) {
      child.silent = true;
    });
    hitRect.silent = !selectMode;
    this.getContentGroup().add(itemGroup);
    enableHoverEmphasis(itemGroup);
    itemGroup.__legendDataIndex = dataIndex;
    return itemGroup;
  };
  LegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var selectorGroup = this.getSelectorGroup();
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), maxSize.width, maxSize.height);
    var contentRect = contentGroup.getBoundingRect();
    var contentPos = [-contentRect.x, -contentRect.y];
    selectorGroup.markRedraw();
    contentGroup.markRedraw();
    if (selector2) {
      box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
      var selectorRect = selectorGroup.getBoundingRect();
      var selectorPos = [-selectorRect.x, -selectorRect.y];
      var selectorButtonGap = legendModel.get("selectorButtonGap", true);
      var orientIdx = legendModel.getOrient().index;
      var wh2 = orientIdx === 0 ? "width" : "height";
      var hw = orientIdx === 0 ? "height" : "width";
      var yx = orientIdx === 0 ? "y" : "x";
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += contentRect[wh2] + selectorButtonGap;
      } else {
        contentPos[orientIdx] += selectorRect[wh2] + selectorButtonGap;
      }
      selectorPos[1 - orientIdx] += contentRect[hw] / 2 - selectorRect[hw] / 2;
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      var mainRect = {
        x: 0,
        y: 0
      };
      mainRect[wh2] = contentRect[wh2] + selectorButtonGap + selectorRect[wh2];
      mainRect[hw] = Math.max(contentRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(0, selectorRect[yx] + selectorPos[1 - orientIdx]);
      return mainRect;
    } else {
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      return this.group.getBoundingRect();
    }
  };
  LegendView2.prototype.remove = function() {
    this.getContentGroup().removeAll();
    this._isFirstRender = true;
  };
  LegendView2.type = "legend.plain";
  return LegendView2;
}(ComponentView$1);
function getLegendStyle(iconType, legendModel, lineVisualStyle, itemVisualStyle, drawType, isSelected) {
  function handleCommonProps(style2, visualStyle) {
    if (style2.lineWidth === "auto") {
      style2.lineWidth = visualStyle.lineWidth > 0 ? 2 : 0;
    }
    each$4(style2, function(propVal, propName) {
      style2[propName] === "inherit" && (style2[propName] = visualStyle[propName]);
    });
  }
  var legendItemModel = legendModel.getModel("itemStyle");
  var itemStyle = legendItemModel.getItemStyle();
  var iconBrushType = iconType.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
  itemStyle.decal = itemVisualStyle.decal;
  if (itemStyle.fill === "inherit") {
    itemStyle.fill = itemVisualStyle[drawType];
  }
  if (itemStyle.stroke === "inherit") {
    itemStyle.stroke = itemVisualStyle[iconBrushType];
  }
  if (itemStyle.opacity === "inherit") {
    itemStyle.opacity = (drawType === "fill" ? itemVisualStyle : lineVisualStyle).opacity;
  }
  handleCommonProps(itemStyle, itemVisualStyle);
  var legendLineModel = legendModel.getModel("lineStyle");
  var lineStyle = legendLineModel.getLineStyle();
  handleCommonProps(lineStyle, lineVisualStyle);
  itemStyle.fill === "auto" && (itemStyle.fill = itemVisualStyle.fill);
  itemStyle.stroke === "auto" && (itemStyle.stroke = itemVisualStyle.fill);
  lineStyle.stroke === "auto" && (lineStyle.stroke = itemVisualStyle.fill);
  if (!isSelected) {
    var borderWidth = legendModel.get("inactiveBorderWidth");
    var visualHasBorder = itemStyle[iconBrushType];
    itemStyle.lineWidth = borderWidth === "auto" ? itemVisualStyle.lineWidth > 0 && visualHasBorder ? 2 : 0 : itemStyle.lineWidth;
    itemStyle.fill = legendModel.get("inactiveColor");
    itemStyle.stroke = legendModel.get("inactiveBorderColor");
    lineStyle.stroke = legendLineModel.get("inactiveColor");
    lineStyle.lineWidth = legendLineModel.get("inactiveWidth");
  }
  return {
    itemStyle,
    lineStyle
  };
}
function getDefaultLegendIcon(opt) {
  var symboType = opt.icon || "roundRect";
  var icon = createSymbol$1(symboType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill, opt.symbolKeepAspect);
  icon.setStyle(opt.itemStyle);
  icon.rotation = (opt.iconRotate || 0) * Math.PI / 180;
  icon.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
  if (symboType.indexOf("empty") > -1) {
    icon.style.stroke = icon.style.fill;
    icon.style.fill = "#fff";
    icon.style.lineWidth = 2;
  }
  return icon;
}
function dispatchSelectAction(seriesName, dataName, api, excludeSeriesId) {
  dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId);
  api.dispatchAction({
    type: "legendToggleSelect",
    name: seriesName != null ? seriesName : dataName
  });
  dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId);
}
function isUseHoverLayer(api) {
  var list = api.getZr().storage.getDisplayList();
  var emphasisState;
  var i = 0;
  var len2 = list.length;
  while (i < len2 && !(emphasisState = list[i].states.emphasis)) {
    i++;
  }
  return emphasisState && emphasisState.hoverLayer;
}
function dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "highlight",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
function dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "downplay",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
var LegendView$1 = LegendView;
function legendFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (legendModels && legendModels.length) {
    ecModel.filterSeries(function(series) {
      for (var i = 0; i < legendModels.length; i++) {
        if (!legendModels[i].isSelected(series.name)) {
          return false;
        }
      }
      return true;
    });
  }
}
function legendSelectActionHandler(methodName, payload, ecModel) {
  var selectedMap = {};
  var isToggleSelect = methodName === "toggleSelected";
  var isSelected;
  ecModel.eachComponent("legend", function(legendModel) {
    if (isToggleSelect && isSelected != null) {
      legendModel[isSelected ? "select" : "unSelect"](payload.name);
    } else if (methodName === "allSelect" || methodName === "inverseSelect") {
      legendModel[methodName]();
    } else {
      legendModel[methodName](payload.name);
      isSelected = legendModel.isSelected(payload.name);
    }
    var legendData = legendModel.getData();
    each$g(legendData, function(model) {
      var name = model.get("name");
      if (name === "\n" || name === "") {
        return;
      }
      var isItemSelected = legendModel.isSelected(name);
      if (selectedMap.hasOwnProperty(name)) {
        selectedMap[name] = selectedMap[name] && isItemSelected;
      } else {
        selectedMap[name] = isItemSelected;
      }
    });
  });
  return methodName === "allSelect" || methodName === "inverseSelect" ? {
    selected: selectedMap
  } : {
    name: payload.name,
    selected: selectedMap
  };
}
function installLegendAction(registers) {
  registers.registerAction("legendToggleSelect", "legendselectchanged", curry$1(legendSelectActionHandler, "toggleSelected"));
  registers.registerAction("legendAllSelect", "legendselectall", curry$1(legendSelectActionHandler, "allSelect"));
  registers.registerAction("legendInverseSelect", "legendinverseselect", curry$1(legendSelectActionHandler, "inverseSelect"));
  registers.registerAction("legendSelect", "legendselected", curry$1(legendSelectActionHandler, "select"));
  registers.registerAction("legendUnSelect", "legendunselected", curry$1(legendSelectActionHandler, "unSelect"));
}
function install$b(registers) {
  registers.registerComponentModel(LegendModel$1);
  registers.registerComponentView(LegendView$1);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.SERIES_FILTER, legendFilter);
  registers.registerSubTypeDefaulter("legend", function() {
    return "plain";
  });
  installLegendAction(registers);
}
var ScrollableLegendModel = function(_super) {
  __extends(ScrollableLegendModel2, _super);
  function ScrollableLegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendModel2.type;
    return _this;
  }
  ScrollableLegendModel2.prototype.setScrollDataIndex = function(scrollDataIndex) {
    this.option.scrollDataIndex = scrollDataIndex;
  };
  ScrollableLegendModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.call(this, option, parentModel, ecModel);
    mergeAndNormalizeLayoutParams(this, option, inputPositionParams);
  };
  ScrollableLegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    mergeAndNormalizeLayoutParams(this, this.option, option);
  };
  ScrollableLegendModel2.type = "legend.scroll";
  ScrollableLegendModel2.defaultOption = inheritDefaultOption(LegendModel$1.defaultOption, {
    scrollDataIndex: 0,
    pageButtonItemGap: 5,
    pageButtonGap: null,
    pageButtonPosition: "end",
    pageFormatter: "{current}/{total}",
    pageIcons: {
      horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"],
      vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"]
    },
    pageIconColor: "#2f4554",
    pageIconInactiveColor: "#aaa",
    pageIconSize: 15,
    pageTextStyle: {
      color: "#333"
    },
    animationDurationUpdate: 800
  });
  return ScrollableLegendModel2;
}(LegendModel$1);
function mergeAndNormalizeLayoutParams(legendModel, target, raw) {
  var orient = legendModel.getOrient();
  var ignoreSize = [1, 1];
  ignoreSize[orient.index] = 0;
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize: !!ignoreSize
  });
}
var ScrollableLegendModel$1 = ScrollableLegendModel;
var Group$2 = Group$6;
var WH = ["width", "height"];
var XY = ["x", "y"];
var ScrollableLegendView = function(_super) {
  __extends(ScrollableLegendView2, _super);
  function ScrollableLegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendView2.type;
    _this.newlineDisabled = true;
    _this._currentIndex = 0;
    return _this;
  }
  ScrollableLegendView2.prototype.init = function() {
    _super.prototype.init.call(this);
    this.group.add(this._containerGroup = new Group$2());
    this._containerGroup.add(this.getContentGroup());
    this.group.add(this._controllerGroup = new Group$2());
  };
  ScrollableLegendView2.prototype.resetInner = function() {
    _super.prototype.resetInner.call(this);
    this._controllerGroup.removeAll();
    this._containerGroup.removeClipPath();
    this._containerGroup.__rectSize = null;
  };
  ScrollableLegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var self2 = this;
    _super.prototype.renderInner.call(this, itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var controllerGroup = this._controllerGroup;
    var pageIconSize = legendModel.get("pageIconSize", true);
    var pageIconSizeArr = isArray$1(pageIconSize) ? pageIconSize : [pageIconSize, pageIconSize];
    createPageButton("pagePrev", 0);
    var pageTextStyleModel = legendModel.getModel("pageTextStyle");
    controllerGroup.add(new ZRText$1({
      name: "pageText",
      style: {
        text: "xx/xx",
        fill: pageTextStyleModel.getTextColor(),
        font: pageTextStyleModel.getFont(),
        verticalAlign: "middle",
        align: "center"
      },
      silent: true
    }));
    createPageButton("pageNext", 1);
    function createPageButton(name, iconIdx) {
      var pageDataIndexName = name + "DataIndex";
      var icon = createIcon(legendModel.get("pageIcons", true)[legendModel.getOrient().name][iconIdx], {
        onclick: bind$1(self2._pageGo, self2, pageDataIndexName, legendModel, api)
      }, {
        x: -pageIconSizeArr[0] / 2,
        y: -pageIconSizeArr[1] / 2,
        width: pageIconSizeArr[0],
        height: pageIconSizeArr[1]
      });
      icon.name = name;
      controllerGroup.add(icon);
    }
  };
  ScrollableLegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    var orientIdx = legendModel.getOrient().index;
    var wh2 = WH[orientIdx];
    var xy = XY[orientIdx];
    var hw = WH[1 - orientIdx];
    var yx = XY[1 - orientIdx];
    selector2 && box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
    var selectorButtonGap = legendModel.get("selectorButtonGap", true);
    var selectorRect = selectorGroup.getBoundingRect();
    var selectorPos = [-selectorRect.x, -selectorRect.y];
    var processMaxSize = clone$4(maxSize);
    selector2 && (processMaxSize[wh2] = maxSize[wh2] - selectorRect[wh2] - selectorButtonGap);
    var mainRect = this._layoutContentAndController(legendModel, isFirstRender, processMaxSize, orientIdx, wh2, hw, yx, xy);
    if (selector2) {
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += mainRect[wh2] + selectorButtonGap;
      } else {
        var offset2 = selectorRect[wh2] + selectorButtonGap;
        selectorPos[orientIdx] -= offset2;
        mainRect[xy] -= offset2;
      }
      mainRect[wh2] += selectorRect[wh2] + selectorButtonGap;
      selectorPos[1 - orientIdx] += mainRect[yx] + mainRect[hw] / 2 - selectorRect[hw] / 2;
      mainRect[hw] = Math.max(mainRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(mainRect[yx], selectorRect[yx] + selectorPos[1 - orientIdx]);
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      selectorGroup.markRedraw();
    }
    return mainRect;
  };
  ScrollableLegendView2.prototype._layoutContentAndController = function(legendModel, isFirstRender, maxSize, orientIdx, wh2, hw, yx, xy) {
    var contentGroup = this.getContentGroup();
    var containerGroup = this._containerGroup;
    var controllerGroup = this._controllerGroup;
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), !orientIdx ? null : maxSize.width, orientIdx ? null : maxSize.height);
    box("horizontal", controllerGroup, legendModel.get("pageButtonItemGap", true));
    var contentRect = contentGroup.getBoundingRect();
    var controllerRect = controllerGroup.getBoundingRect();
    var showController = this._showController = contentRect[wh2] > maxSize[wh2];
    var contentPos = [-contentRect.x, -contentRect.y];
    if (!isFirstRender) {
      contentPos[orientIdx] = contentGroup[xy];
    }
    var containerPos = [0, 0];
    var controllerPos = [-controllerRect.x, -controllerRect.y];
    var pageButtonGap = retrieve2(legendModel.get("pageButtonGap", true), legendModel.get("itemGap", true));
    if (showController) {
      var pageButtonPosition = legendModel.get("pageButtonPosition", true);
      if (pageButtonPosition === "end") {
        controllerPos[orientIdx] += maxSize[wh2] - controllerRect[wh2];
      } else {
        containerPos[orientIdx] += controllerRect[wh2] + pageButtonGap;
      }
    }
    controllerPos[1 - orientIdx] += contentRect[hw] / 2 - controllerRect[hw] / 2;
    contentGroup.setPosition(contentPos);
    containerGroup.setPosition(containerPos);
    controllerGroup.setPosition(controllerPos);
    var mainRect = {
      x: 0,
      y: 0
    };
    mainRect[wh2] = showController ? maxSize[wh2] : contentRect[wh2];
    mainRect[hw] = Math.max(contentRect[hw], controllerRect[hw]);
    mainRect[yx] = Math.min(0, controllerRect[yx] + controllerPos[1 - orientIdx]);
    containerGroup.__rectSize = maxSize[wh2];
    if (showController) {
      var clipShape = {
        x: 0,
        y: 0
      };
      clipShape[wh2] = Math.max(maxSize[wh2] - controllerRect[wh2] - pageButtonGap, 0);
      clipShape[hw] = mainRect[hw];
      containerGroup.setClipPath(new Rect$3({
        shape: clipShape
      }));
      containerGroup.__rectSize = clipShape[wh2];
    } else {
      controllerGroup.eachChild(function(child) {
        child.attr({
          invisible: true,
          silent: true
        });
      });
    }
    var pageInfo = this._getPageInfo(legendModel);
    pageInfo.pageIndex != null && updateProps$1(contentGroup, {
      x: pageInfo.contentPosition[0],
      y: pageInfo.contentPosition[1]
    }, showController ? legendModel : null);
    this._updatePageInfoView(legendModel, pageInfo);
    return mainRect;
  };
  ScrollableLegendView2.prototype._pageGo = function(to, legendModel, api) {
    var scrollDataIndex = this._getPageInfo(legendModel)[to];
    scrollDataIndex != null && api.dispatchAction({
      type: "legendScroll",
      scrollDataIndex,
      legendId: legendModel.id
    });
  };
  ScrollableLegendView2.prototype._updatePageInfoView = function(legendModel, pageInfo) {
    var controllerGroup = this._controllerGroup;
    each$g(["pagePrev", "pageNext"], function(name) {
      var key = name + "DataIndex";
      var canJump = pageInfo[key] != null;
      var icon = controllerGroup.childOfName(name);
      if (icon) {
        icon.setStyle("fill", canJump ? legendModel.get("pageIconColor", true) : legendModel.get("pageIconInactiveColor", true));
        icon.cursor = canJump ? "pointer" : "default";
      }
    });
    var pageText = controllerGroup.childOfName("pageText");
    var pageFormatter = legendModel.get("pageFormatter");
    var pageIndex = pageInfo.pageIndex;
    var current = pageIndex != null ? pageIndex + 1 : 0;
    var total = pageInfo.pageCount;
    pageText && pageFormatter && pageText.setStyle("text", isString$1(pageFormatter) ? pageFormatter.replace("{current}", current == null ? "" : current + "").replace("{total}", total == null ? "" : total + "") : pageFormatter({
      current,
      total
    }));
  };
  ScrollableLegendView2.prototype._getPageInfo = function(legendModel) {
    var scrollDataIndex = legendModel.get("scrollDataIndex", true);
    var contentGroup = this.getContentGroup();
    var containerRectSize = this._containerGroup.__rectSize;
    var orientIdx = legendModel.getOrient().index;
    var wh2 = WH[orientIdx];
    var xy = XY[orientIdx];
    var targetItemIndex = this._findTargetItemIndex(scrollDataIndex);
    var children = contentGroup.children();
    var targetItem = children[targetItemIndex];
    var itemCount = children.length;
    var pCount = !itemCount ? 0 : 1;
    var result = {
      contentPosition: [contentGroup.x, contentGroup.y],
      pageCount: pCount,
      pageIndex: pCount - 1,
      pagePrevDataIndex: null,
      pageNextDataIndex: null
    };
    if (!targetItem) {
      return result;
    }
    var targetItemInfo = getItemInfo(targetItem);
    result.contentPosition[orientIdx] = -targetItemInfo.s;
    for (var i = targetItemIndex + 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i <= itemCount; ++i) {
      currItemInfo = getItemInfo(children[i]);
      if (!currItemInfo && winEndItemInfo.e > winStartItemInfo.s + containerRectSize || currItemInfo && !intersect2(currItemInfo, winStartItemInfo.s)) {
        if (winEndItemInfo.i > winStartItemInfo.i) {
          winStartItemInfo = winEndItemInfo;
        } else {
          winStartItemInfo = currItemInfo;
        }
        if (winStartItemInfo) {
          if (result.pageNextDataIndex == null) {
            result.pageNextDataIndex = winStartItemInfo.i;
          }
          ++result.pageCount;
        }
      }
      winEndItemInfo = currItemInfo;
    }
    for (var i = targetItemIndex - 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i >= -1; --i) {
      currItemInfo = getItemInfo(children[i]);
      if ((!currItemInfo || !intersect2(winEndItemInfo, currItemInfo.s)) && winStartItemInfo.i < winEndItemInfo.i) {
        winEndItemInfo = winStartItemInfo;
        if (result.pagePrevDataIndex == null) {
          result.pagePrevDataIndex = winStartItemInfo.i;
        }
        ++result.pageCount;
        ++result.pageIndex;
      }
      winStartItemInfo = currItemInfo;
    }
    return result;
    function getItemInfo(el) {
      if (el) {
        var itemRect = el.getBoundingRect();
        var start2 = itemRect[xy] + el[xy];
        return {
          s: start2,
          e: start2 + itemRect[wh2],
          i: el.__legendDataIndex
        };
      }
    }
    function intersect2(itemInfo, winStart) {
      return itemInfo.e >= winStart && itemInfo.s <= winStart + containerRectSize;
    }
  };
  ScrollableLegendView2.prototype._findTargetItemIndex = function(targetDataIndex) {
    if (!this._showController) {
      return 0;
    }
    var index2;
    var contentGroup = this.getContentGroup();
    var defaultIndex;
    contentGroup.eachChild(function(child, idx) {
      var legendDataIdx = child.__legendDataIndex;
      if (defaultIndex == null && legendDataIdx != null) {
        defaultIndex = idx;
      }
      if (legendDataIdx === targetDataIndex) {
        index2 = idx;
      }
    });
    return index2 != null ? index2 : defaultIndex;
  };
  ScrollableLegendView2.type = "legend.scroll";
  return ScrollableLegendView2;
}(LegendView$1);
var ScrollableLegendView$1 = ScrollableLegendView;
function installScrollableLegendAction(registers) {
  registers.registerAction("legendScroll", "legendscroll", function(payload, ecModel) {
    var scrollDataIndex = payload.scrollDataIndex;
    scrollDataIndex != null && ecModel.eachComponent({
      mainType: "legend",
      subType: "scroll",
      query: payload
    }, function(legendModel) {
      legendModel.setScrollDataIndex(scrollDataIndex);
    });
  });
}
function install$a(registers) {
  use(install$b);
  registers.registerComponentModel(ScrollableLegendModel$1);
  registers.registerComponentView(ScrollableLegendView$1);
  installScrollableLegendAction(registers);
}
function install$9(registers) {
  use(install$b);
  use(install$a);
}
var InsideZoomModel = function(_super) {
  __extends(InsideZoomModel2, _super);
  function InsideZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = InsideZoomModel2.type;
    return _this;
  }
  InsideZoomModel2.type = "dataZoom.inside";
  InsideZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    disabled: false,
    zoomLock: false,
    zoomOnMouseWheel: true,
    moveOnMouseMove: true,
    moveOnMouseWheel: false,
    preventDefaultMouseMove: true
  });
  return InsideZoomModel2;
}(DataZoomModel$1);
var InsideZoomModel$1 = InsideZoomModel;
var inner$1 = makeInner();
function setViewInfoToCoordSysRecord(api, dataZoomModel, getRange) {
  inner$1(api).coordSysRecordMap.each(function(coordSysRecord) {
    var dzInfo = coordSysRecord.dataZoomInfoMap.get(dataZoomModel.uid);
    if (dzInfo) {
      dzInfo.getRange = getRange;
    }
  });
}
function disposeCoordSysRecordIfNeeded(api, dataZoomModel) {
  var coordSysRecordMap = inner$1(api).coordSysRecordMap;
  var coordSysKeyArr = coordSysRecordMap.keys();
  for (var i = 0; i < coordSysKeyArr.length; i++) {
    var coordSysKey = coordSysKeyArr[i];
    var coordSysRecord = coordSysRecordMap.get(coordSysKey);
    var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
    if (dataZoomInfoMap) {
      var dzUid = dataZoomModel.uid;
      var dzInfo = dataZoomInfoMap.get(dzUid);
      if (dzInfo) {
        dataZoomInfoMap.removeKey(dzUid);
        if (!dataZoomInfoMap.keys().length) {
          disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        }
      }
    }
  }
}
function disposeCoordSysRecord(coordSysRecordMap, coordSysRecord) {
  if (coordSysRecord) {
    coordSysRecordMap.removeKey(coordSysRecord.model.uid);
    var controller = coordSysRecord.controller;
    controller && controller.dispose();
  }
}
function createCoordSysRecord(api, coordSysModel) {
  var coordSysRecord = {
    model: coordSysModel,
    containsPoint: curry$1(containsPoint, coordSysModel),
    dispatchAction: curry$1(dispatchAction, api),
    dataZoomInfoMap: null,
    controller: null
  };
  var controller = coordSysRecord.controller = new RoamController$1(api.getZr());
  each$g(["pan", "zoom", "scrollMove"], function(eventName) {
    controller.on(eventName, function(event) {
      var batch = [];
      coordSysRecord.dataZoomInfoMap.each(function(dzInfo) {
        if (!event.isAvailableBehavior(dzInfo.model.option)) {
          return;
        }
        var method4 = (dzInfo.getRange || {})[eventName];
        var range3 = method4 && method4(dzInfo.dzReferCoordSysInfo, coordSysRecord.model.mainType, coordSysRecord.controller, event);
        !dzInfo.model.get("disabled", true) && range3 && batch.push({
          dataZoomId: dzInfo.model.id,
          start: range3[0],
          end: range3[1]
        });
      });
      batch.length && coordSysRecord.dispatchAction(batch);
    });
  });
  return coordSysRecord;
}
function dispatchAction(api, batch) {
  if (!api.isDisposed()) {
    api.dispatchAction({
      type: "dataZoom",
      animation: {
        easing: "cubicOut",
        duration: 100
      },
      batch
    });
  }
}
function containsPoint(coordSysModel, e2, x2, y2) {
  return coordSysModel.coordinateSystem.containPoint([x2, y2]);
}
function mergeControllerParams(dataZoomInfoMap) {
  var controlType;
  var prefix = "type_";
  var typePriority = {
    "type_true": 2,
    "type_move": 1,
    "type_false": 0,
    "type_undefined": -1
  };
  var preventDefaultMouseMove = true;
  dataZoomInfoMap.each(function(dataZoomInfo) {
    var dataZoomModel = dataZoomInfo.model;
    var oneType = dataZoomModel.get("disabled", true) ? false : dataZoomModel.get("zoomLock", true) ? "move" : true;
    if (typePriority[prefix + oneType] > typePriority[prefix + controlType]) {
      controlType = oneType;
    }
    preventDefaultMouseMove = preventDefaultMouseMove && dataZoomModel.get("preventDefaultMouseMove", true);
  });
  return {
    controlType,
    opt: {
      zoomOnMouseWheel: true,
      moveOnMouseMove: true,
      moveOnMouseWheel: true,
      preventDefaultMouseMove: !!preventDefaultMouseMove
    }
  };
}
function installDataZoomRoamProcessor(registers) {
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, function(ecModel, api) {
    var apiInner = inner$1(api);
    var coordSysRecordMap = apiInner.coordSysRecordMap || (apiInner.coordSysRecordMap = createHashMap());
    coordSysRecordMap.each(function(coordSysRecord) {
      coordSysRecord.dataZoomInfoMap = null;
    });
    ecModel.eachComponent({
      mainType: "dataZoom",
      subType: "inside"
    }, function(dataZoomModel) {
      var dzReferCoordSysWrap = collectReferCoordSysModelInfo(dataZoomModel);
      each$g(dzReferCoordSysWrap.infoList, function(dzCoordSysInfo) {
        var coordSysUid = dzCoordSysInfo.model.uid;
        var coordSysRecord = coordSysRecordMap.get(coordSysUid) || coordSysRecordMap.set(coordSysUid, createCoordSysRecord(api, dzCoordSysInfo.model));
        var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap || (coordSysRecord.dataZoomInfoMap = createHashMap());
        dataZoomInfoMap.set(dataZoomModel.uid, {
          dzReferCoordSysInfo: dzCoordSysInfo,
          model: dataZoomModel,
          getRange: null
        });
      });
    });
    coordSysRecordMap.each(function(coordSysRecord) {
      var controller = coordSysRecord.controller;
      var firstDzInfo;
      var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
      if (dataZoomInfoMap) {
        var firstDzKey = dataZoomInfoMap.keys()[0];
        if (firstDzKey != null) {
          firstDzInfo = dataZoomInfoMap.get(firstDzKey);
        }
      }
      if (!firstDzInfo) {
        disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        return;
      }
      var controllerParams = mergeControllerParams(dataZoomInfoMap);
      controller.enable(controllerParams.controlType, controllerParams.opt);
      controller.setPointerChecker(coordSysRecord.containsPoint);
      createOrUpdate(coordSysRecord, "dispatchAction", firstDzInfo.model.get("throttle", true), "fixRate");
    });
  });
}
var InsideZoomView = function(_super) {
  __extends(InsideZoomView2, _super);
  function InsideZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataZoom.inside";
    return _this;
  }
  InsideZoomView2.prototype.render = function(dataZoomModel, ecModel, api) {
    _super.prototype.render.apply(this, arguments);
    if (dataZoomModel.noTarget()) {
      this._clear();
      return;
    }
    this.range = dataZoomModel.getPercentRange();
    setViewInfoToCoordSysRecord(api, dataZoomModel, {
      pan: bind$1(getRangeHandlers.pan, this),
      zoom: bind$1(getRangeHandlers.zoom, this),
      scrollMove: bind$1(getRangeHandlers.scrollMove, this)
    });
  };
  InsideZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  InsideZoomView2.prototype._clear = function() {
    disposeCoordSysRecordIfNeeded(this.api, this.dataZoomModel);
    this.range = null;
  };
  InsideZoomView2.type = "dataZoom.inside";
  return InsideZoomView2;
}(DataZoomView$1);
var getRangeHandlers = {
  zoom: function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var directionInfo = getDirectionInfo[coordSysMainType](null, [e2.originX, e2.originY], axisModel, controller, coordSysInfo);
    var percentPoint = (directionInfo.signal > 0 ? directionInfo.pixelStart + directionInfo.pixelLength - directionInfo.pixel : directionInfo.pixel - directionInfo.pixelStart) / directionInfo.pixelLength * (range3[1] - range3[0]) + range3[0];
    var scale2 = Math.max(1 / e2.scale, 0);
    range3[0] = (range3[0] - percentPoint) * scale2 + percentPoint;
    range3[1] = (range3[1] - percentPoint) * scale2 + percentPoint;
    var minMaxSpan = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    sliderMove(0, range3, [0, 100], 0, minMaxSpan.minSpan, minMaxSpan.maxSpan);
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  },
  pan: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([e2.oldX, e2.oldY], [e2.newX, e2.newY], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * directionInfo.pixel / directionInfo.pixelLength;
  }),
  scrollMove: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([0, 0], [e2.scrollDelta, e2.scrollDelta], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * e2.scrollDelta;
  })
};
function makeMover(getPercentDelta) {
  return function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var percentDelta = getPercentDelta(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2);
    sliderMove(percentDelta, range3, [0, 100], "all");
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  };
}
var getDirectionInfo = {
  grid: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    oldPoint = oldPoint || [0, 0];
    if (axis.dim === "x") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  polar: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var polar = coordSysInfo.model.coordinateSystem;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var angleExtent = polar.getAngleAxis().getExtent();
    oldPoint = oldPoint ? polar.pointToCoord(oldPoint) : [0, 0];
    newPoint = polar.pointToCoord(newPoint);
    if (axisModel.mainType === "radiusAxis") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = radiusExtent[1] - radiusExtent[0];
      ret.pixelStart = radiusExtent[0];
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = angleExtent[1] - angleExtent[0];
      ret.pixelStart = angleExtent[0];
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  singleAxis: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    var ret = {};
    oldPoint = oldPoint || [0, 0];
    if (axis.orient === "horizontal") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  }
};
var InsideZoomView$1 = InsideZoomView;
function install$8(registers) {
  installCommon$1(registers);
  registers.registerComponentModel(InsideZoomModel$1);
  registers.registerComponentView(InsideZoomView$1);
  installDataZoomRoamProcessor(registers);
}
var SliderZoomModel = function(_super) {
  __extends(SliderZoomModel2, _super);
  function SliderZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomModel2.type;
    return _this;
  }
  SliderZoomModel2.type = "dataZoom.slider";
  SliderZoomModel2.layoutMode = "box";
  SliderZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    show: true,
    right: "ph",
    top: "ph",
    width: "ph",
    height: "ph",
    left: null,
    bottom: null,
    borderColor: "#d2dbee",
    borderRadius: 3,
    backgroundColor: "rgba(47,69,84,0)",
    dataBackground: {
      lineStyle: {
        color: "#d2dbee",
        width: 0.5
      },
      areaStyle: {
        color: "#d2dbee",
        opacity: 0.2
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#8fb0f7",
        width: 0.5
      },
      areaStyle: {
        color: "#8fb0f7",
        opacity: 0.2
      }
    },
    fillerColor: "rgba(135,175,274,0.2)",
    handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z",
    handleSize: "100%",
    handleStyle: {
      color: "#fff",
      borderColor: "#ACB8D1"
    },
    moveHandleSize: 7,
    moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z",
    moveHandleStyle: {
      color: "#D2DBEE",
      opacity: 0.7
    },
    showDetail: true,
    showDataShadow: "auto",
    realtime: true,
    zoomLock: false,
    textStyle: {
      color: "#6E7079"
    },
    brushSelect: true,
    brushStyle: {
      color: "rgba(135,175,274,0.15)"
    },
    emphasis: {
      handleStyle: {
        borderColor: "#8FB0F7"
      },
      moveHandleStyle: {
        color: "#8FB0F7"
      }
    }
  });
  return SliderZoomModel2;
}(DataZoomModel$1);
var SliderZoomModel$1 = SliderZoomModel;
var Rect = Rect$3;
var DEFAULT_LOCATION_EDGE_GAP = 7;
var DEFAULT_FRAME_BORDER_WIDTH = 1;
var DEFAULT_FILLER_SIZE = 30;
var DEFAULT_MOVE_HANDLE_SIZE = 7;
var HORIZONTAL = "horizontal";
var VERTICAL = "vertical";
var LABEL_GAP = 5;
var SHOW_DATA_SHADOW_SERIES_TYPE = ["line", "bar", "candlestick", "scatter"];
var REALTIME_ANIMATION_CONFIG = {
  easing: "cubicOut",
  duration: 100,
  delay: 0
};
var SliderZoomView = function(_super) {
  __extends(SliderZoomView2, _super);
  function SliderZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomView2.type;
    _this._displayables = {};
    return _this;
  }
  SliderZoomView2.prototype.init = function(ecModel, api) {
    this.api = api;
    this._onBrush = bind$1(this._onBrush, this);
    this._onBrushEnd = bind$1(this._onBrushEnd, this);
  };
  SliderZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    _super.prototype.render.apply(this, arguments);
    createOrUpdate(this, "_dispatchZoomAction", dataZoomModel.get("throttle"), "fixRate");
    this._orient = dataZoomModel.getOrient();
    if (dataZoomModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    if (dataZoomModel.noTarget()) {
      this._clear();
      this.group.removeAll();
      return;
    }
    if (!payload || payload.type !== "dataZoom" || payload.from !== this.uid) {
      this._buildView();
    }
    this._updateView();
  };
  SliderZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  SliderZoomView2.prototype._clear = function() {
    clear$1(this, "_dispatchZoomAction");
    var zr = this.api.getZr();
    zr.off("mousemove", this._onBrush);
    zr.off("mouseup", this._onBrushEnd);
  };
  SliderZoomView2.prototype._buildView = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    this._brushing = false;
    this._displayables.brushRect = null;
    this._resetLocation();
    this._resetInterval();
    var barGroup = this._displayables.sliderGroup = new Group$6();
    this._renderBackground();
    this._renderHandle();
    this._renderDataShadow();
    thisGroup.add(barGroup);
    this._positionGroup();
  };
  SliderZoomView2.prototype._resetLocation = function() {
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var showMoveHandle = dataZoomModel.get("brushSelect");
    var moveHandleSize = showMoveHandle ? DEFAULT_MOVE_HANDLE_SIZE : 0;
    var coordRect = this._findCoordRect();
    var ecSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var positionInfo = this._orient === HORIZONTAL ? {
      right: ecSize.width - coordRect.x - coordRect.width,
      top: ecSize.height - DEFAULT_FILLER_SIZE - DEFAULT_LOCATION_EDGE_GAP - moveHandleSize,
      width: coordRect.width,
      height: DEFAULT_FILLER_SIZE
    } : {
      right: DEFAULT_LOCATION_EDGE_GAP,
      top: coordRect.y,
      width: DEFAULT_FILLER_SIZE,
      height: coordRect.height
    };
    var layoutParams = getLayoutParams(dataZoomModel.option);
    each$g(["right", "top", "width", "height"], function(name) {
      if (layoutParams[name] === "ph") {
        layoutParams[name] = positionInfo[name];
      }
    });
    var layoutRect = getLayoutRect(layoutParams, ecSize);
    this._location = {
      x: layoutRect.x,
      y: layoutRect.y
    };
    this._size = [layoutRect.width, layoutRect.height];
    this._orient === VERTICAL && this._size.reverse();
  };
  SliderZoomView2.prototype._positionGroup = function() {
    var thisGroup = this.group;
    var location = this._location;
    var orient = this._orient;
    var targetAxisModel = this.dataZoomModel.getFirstTargetAxisModel();
    var inverse = targetAxisModel && targetAxisModel.get("inverse");
    var sliderGroup = this._displayables.sliderGroup;
    var otherAxisInverse = (this._dataShadowInfo || {}).otherAxisInverse;
    sliderGroup.attr(orient === HORIZONTAL && !inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: 1
    } : orient === HORIZONTAL && inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: -1
    } : orient === VERTICAL && !inverse ? {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: 1,
      rotation: Math.PI / 2
    } : {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: -1,
      rotation: Math.PI / 2
    });
    var rect = thisGroup.getBoundingRect([sliderGroup]);
    thisGroup.x = location.x - rect.x;
    thisGroup.y = location.y - rect.y;
    thisGroup.markRedraw();
  };
  SliderZoomView2.prototype._getViewExtent = function() {
    return [0, this._size[0]];
  };
  SliderZoomView2.prototype._renderBackground = function() {
    var dataZoomModel = this.dataZoomModel;
    var size = this._size;
    var barGroup = this._displayables.sliderGroup;
    var brushSelect = dataZoomModel.get("brushSelect");
    barGroup.add(new Rect({
      silent: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: dataZoomModel.get("backgroundColor")
      },
      z2: -40
    }));
    var clickPanel = new Rect({
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: "transparent"
      },
      z2: 0,
      onclick: bind$1(this._onClickPanel, this)
    });
    var zr = this.api.getZr();
    if (brushSelect) {
      clickPanel.on("mousedown", this._onBrushStart, this);
      clickPanel.cursor = "crosshair";
      zr.on("mousemove", this._onBrush);
      zr.on("mouseup", this._onBrushEnd);
    } else {
      zr.off("mousemove", this._onBrush);
      zr.off("mouseup", this._onBrushEnd);
    }
    barGroup.add(clickPanel);
  };
  SliderZoomView2.prototype._renderDataShadow = function() {
    var info = this._dataShadowInfo = this._prepareDataShadowInfo();
    this._displayables.dataShadowSegs = [];
    if (!info) {
      return;
    }
    var size = this._size;
    var oldSize = this._shadowSize || [];
    var seriesModel = info.series;
    var data = seriesModel.getRawData();
    var otherDim = seriesModel.getShadowDim ? seriesModel.getShadowDim() : info.otherDim;
    if (otherDim == null) {
      return;
    }
    var polygonPts = this._shadowPolygonPts;
    var polylinePts = this._shadowPolylinePts;
    if (data !== this._shadowData || otherDim !== this._shadowDim || size[0] !== oldSize[0] || size[1] !== oldSize[1]) {
      var otherDataExtent_1 = data.getDataExtent(otherDim);
      var otherOffset = (otherDataExtent_1[1] - otherDataExtent_1[0]) * 0.3;
      otherDataExtent_1 = [otherDataExtent_1[0] - otherOffset, otherDataExtent_1[1] + otherOffset];
      var otherShadowExtent_1 = [0, size[1]];
      var thisShadowExtent = [0, size[0]];
      var areaPoints_1 = [[size[0], 0], [0, 0]];
      var linePoints_1 = [];
      var step_1 = thisShadowExtent[1] / (data.count() - 1);
      var thisCoord_1 = 0;
      var stride_1 = Math.round(data.count() / size[0]);
      var lastIsEmpty_1;
      data.each([otherDim], function(value, index2) {
        if (stride_1 > 0 && index2 % stride_1) {
          thisCoord_1 += step_1;
          return;
        }
        var isEmpty = value == null || isNaN(value) || value === "";
        var otherCoord = isEmpty ? 0 : linearMap$2(value, otherDataExtent_1, otherShadowExtent_1, true);
        if (isEmpty && !lastIsEmpty_1 && index2) {
          areaPoints_1.push([areaPoints_1[areaPoints_1.length - 1][0], 0]);
          linePoints_1.push([linePoints_1[linePoints_1.length - 1][0], 0]);
        } else if (!isEmpty && lastIsEmpty_1) {
          areaPoints_1.push([thisCoord_1, 0]);
          linePoints_1.push([thisCoord_1, 0]);
        }
        areaPoints_1.push([thisCoord_1, otherCoord]);
        linePoints_1.push([thisCoord_1, otherCoord]);
        thisCoord_1 += step_1;
        lastIsEmpty_1 = isEmpty;
      });
      polygonPts = this._shadowPolygonPts = areaPoints_1;
      polylinePts = this._shadowPolylinePts = linePoints_1;
    }
    this._shadowData = data;
    this._shadowDim = otherDim;
    this._shadowSize = [size[0], size[1]];
    var dataZoomModel = this.dataZoomModel;
    function createDataShadowGroup(isSelectedArea) {
      var model = dataZoomModel.getModel(isSelectedArea ? "selectedDataBackground" : "dataBackground");
      var group2 = new Group$6();
      var polygon = new Polygon$1({
        shape: {
          points: polygonPts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("areaStyle").getAreaStyle(),
        silent: true,
        z2: -20
      });
      var polyline = new Polyline$3({
        shape: {
          points: polylinePts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("lineStyle").getLineStyle(),
        silent: true,
        z2: -19
      });
      group2.add(polygon);
      group2.add(polyline);
      return group2;
    }
    for (var i = 0; i < 3; i++) {
      var group = createDataShadowGroup(i === 1);
      this._displayables.sliderGroup.add(group);
      this._displayables.dataShadowSegs.push(group);
    }
  };
  SliderZoomView2.prototype._prepareDataShadowInfo = function() {
    var dataZoomModel = this.dataZoomModel;
    var showDataShadow = dataZoomModel.get("showDataShadow");
    if (showDataShadow === false) {
      return;
    }
    var result;
    var ecModel = this.ecModel;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var seriesModels = dataZoomModel.getAxisProxy(axisDim, axisIndex).getTargetSeriesModels();
      each$g(seriesModels, function(seriesModel) {
        if (result) {
          return;
        }
        if (showDataShadow !== true && indexOf(SHOW_DATA_SHADOW_SERIES_TYPE, seriesModel.get("type")) < 0) {
          return;
        }
        var thisAxis = ecModel.getComponent(getAxisMainType(axisDim), axisIndex).axis;
        var otherDim = getOtherDim(axisDim);
        var otherAxisInverse;
        var coordSys = seriesModel.coordinateSystem;
        if (otherDim != null && coordSys.getOtherAxis) {
          otherAxisInverse = coordSys.getOtherAxis(thisAxis).inverse;
        }
        otherDim = seriesModel.getData().mapDimension(otherDim);
        result = {
          thisAxis,
          series: seriesModel,
          thisDim: axisDim,
          otherDim,
          otherAxisInverse
        };
      }, this);
    }, this);
    return result;
  };
  SliderZoomView2.prototype._renderHandle = function() {
    var thisGroup = this.group;
    var displayables = this._displayables;
    var handles = displayables.handles = [null, null];
    var handleLabels = displayables.handleLabels = [null, null];
    var sliderGroup = this._displayables.sliderGroup;
    var size = this._size;
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var borderRadius = dataZoomModel.get("borderRadius") || 0;
    var brushSelect = dataZoomModel.get("brushSelect");
    var filler = displayables.filler = new Rect({
      silent: brushSelect,
      style: {
        fill: dataZoomModel.get("fillerColor")
      },
      textConfig: {
        position: "inside"
      }
    });
    sliderGroup.add(filler);
    sliderGroup.add(new Rect({
      silent: true,
      subPixelOptimize: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1],
        r: borderRadius
      },
      style: {
        stroke: dataZoomModel.get("dataBackgroundColor") || dataZoomModel.get("borderColor"),
        lineWidth: DEFAULT_FRAME_BORDER_WIDTH,
        fill: "rgba(0,0,0,0)"
      }
    }));
    each$g([0, 1], function(handleIndex) {
      var iconStr = dataZoomModel.get("handleIcon");
      if (!symbolBuildProxies[iconStr] && iconStr.indexOf("path://") < 0 && iconStr.indexOf("image://") < 0) {
        iconStr = "path://" + iconStr;
      }
      var path = createSymbol$1(iconStr, -1, 0, 2, 2, null, true);
      path.attr({
        cursor: getCursor$1(this._orient),
        draggable: true,
        drift: bind$1(this._onDragMove, this, handleIndex),
        ondragend: bind$1(this._onDragEnd, this),
        onmouseover: bind$1(this._showDataInfo, this, true),
        onmouseout: bind$1(this._showDataInfo, this, false),
        z2: 5
      });
      var bRect = path.getBoundingRect();
      var handleSize = dataZoomModel.get("handleSize");
      this._handleHeight = parsePercent(handleSize, this._size[1]);
      this._handleWidth = bRect.width / bRect.height * this._handleHeight;
      path.setStyle(dataZoomModel.getModel("handleStyle").getItemStyle());
      path.style.strokeNoScale = true;
      path.rectHover = true;
      path.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
      enableHoverEmphasis(path);
      var handleColor = dataZoomModel.get("handleColor");
      if (handleColor != null) {
        path.style.fill = handleColor;
      }
      sliderGroup.add(handles[handleIndex] = path);
      var textStyleModel = dataZoomModel.getModel("textStyle");
      thisGroup.add(handleLabels[handleIndex] = new ZRText$1({
        silent: true,
        invisible: true,
        style: createTextStyle(textStyleModel, {
          x: 0,
          y: 0,
          text: "",
          verticalAlign: "middle",
          align: "center",
          fill: textStyleModel.getTextColor(),
          font: textStyleModel.getFont()
        }),
        z2: 10
      }));
    }, this);
    var actualMoveZone = filler;
    if (brushSelect) {
      var moveHandleHeight = parsePercent(dataZoomModel.get("moveHandleSize"), size[1]);
      var moveHandle_1 = displayables.moveHandle = new Rect$3({
        style: dataZoomModel.getModel("moveHandleStyle").getItemStyle(),
        silent: true,
        shape: {
          r: [0, 0, 2, 2],
          y: size[1] - 0.5,
          height: moveHandleHeight
        }
      });
      var iconSize = moveHandleHeight * 0.8;
      var moveHandleIcon = displayables.moveHandleIcon = createSymbol$1(dataZoomModel.get("moveHandleIcon"), -iconSize / 2, -iconSize / 2, iconSize, iconSize, "#fff", true);
      moveHandleIcon.silent = true;
      moveHandleIcon.y = size[1] + moveHandleHeight / 2 - 0.5;
      moveHandle_1.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
      var moveZoneExpandSize = Math.min(size[1] / 2, Math.max(moveHandleHeight, 10));
      actualMoveZone = displayables.moveZone = new Rect$3({
        invisible: true,
        shape: {
          y: size[1] - moveZoneExpandSize,
          height: moveHandleHeight + moveZoneExpandSize
        }
      });
      actualMoveZone.on("mouseover", function() {
        api.enterEmphasis(moveHandle_1);
      }).on("mouseout", function() {
        api.leaveEmphasis(moveHandle_1);
      });
      sliderGroup.add(moveHandle_1);
      sliderGroup.add(moveHandleIcon);
      sliderGroup.add(actualMoveZone);
    }
    actualMoveZone.attr({
      draggable: true,
      cursor: getCursor$1(this._orient),
      drift: bind$1(this._onDragMove, this, "all"),
      ondragstart: bind$1(this._showDataInfo, this, true),
      ondragend: bind$1(this._onDragEnd, this),
      onmouseover: bind$1(this._showDataInfo, this, true),
      onmouseout: bind$1(this._showDataInfo, this, false)
    });
  };
  SliderZoomView2.prototype._resetInterval = function() {
    var range3 = this._range = this.dataZoomModel.getPercentRange();
    var viewExtent = this._getViewExtent();
    this._handleEnds = [linearMap$2(range3[0], [0, 100], viewExtent, true), linearMap$2(range3[1], [0, 100], viewExtent, true)];
  };
  SliderZoomView2.prototype._updateInterval = function(handleIndex, delta) {
    var dataZoomModel = this.dataZoomModel;
    var handleEnds = this._handleEnds;
    var viewExtend = this._getViewExtent();
    var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    var percentExtent = [0, 100];
    sliderMove(delta, handleEnds, viewExtend, dataZoomModel.get("zoomLock") ? "all" : handleIndex, minMaxSpan.minSpan != null ? linearMap$2(minMaxSpan.minSpan, percentExtent, viewExtend, true) : null, minMaxSpan.maxSpan != null ? linearMap$2(minMaxSpan.maxSpan, percentExtent, viewExtend, true) : null);
    var lastRange = this._range;
    var range3 = this._range = asc$2([linearMap$2(handleEnds[0], viewExtend, percentExtent, true), linearMap$2(handleEnds[1], viewExtend, percentExtent, true)]);
    return !lastRange || lastRange[0] !== range3[0] || lastRange[1] !== range3[1];
  };
  SliderZoomView2.prototype._updateView = function(nonRealtime) {
    var displaybles = this._displayables;
    var handleEnds = this._handleEnds;
    var handleInterval = asc$2(handleEnds.slice());
    var size = this._size;
    each$g([0, 1], function(handleIndex) {
      var handle = displaybles.handles[handleIndex];
      var handleHeight = this._handleHeight;
      handle.attr({
        scaleX: handleHeight / 2,
        scaleY: handleHeight / 2,
        x: handleEnds[handleIndex] + (handleIndex ? -1 : 1),
        y: size[1] / 2 - handleHeight / 2
      });
    }, this);
    displaybles.filler.setShape({
      x: handleInterval[0],
      y: 0,
      width: handleInterval[1] - handleInterval[0],
      height: size[1]
    });
    var viewExtent = {
      x: handleInterval[0],
      width: handleInterval[1] - handleInterval[0]
    };
    if (displaybles.moveHandle) {
      displaybles.moveHandle.setShape(viewExtent);
      displaybles.moveZone.setShape(viewExtent);
      displaybles.moveZone.getBoundingRect();
      displaybles.moveHandleIcon && displaybles.moveHandleIcon.attr("x", viewExtent.x + viewExtent.width / 2);
    }
    var dataShadowSegs = displaybles.dataShadowSegs;
    var segIntervals = [0, handleInterval[0], handleInterval[1], size[0]];
    for (var i = 0; i < dataShadowSegs.length; i++) {
      var segGroup = dataShadowSegs[i];
      var clipPath = segGroup.getClipPath();
      if (!clipPath) {
        clipPath = new Rect$3();
        segGroup.setClipPath(clipPath);
      }
      clipPath.setShape({
        x: segIntervals[i],
        y: 0,
        width: segIntervals[i + 1] - segIntervals[i],
        height: size[1]
      });
    }
    this._updateDataInfo(nonRealtime);
  };
  SliderZoomView2.prototype._updateDataInfo = function(nonRealtime) {
    var dataZoomModel = this.dataZoomModel;
    var displaybles = this._displayables;
    var handleLabels = displaybles.handleLabels;
    var orient = this._orient;
    var labelTexts = ["", ""];
    if (dataZoomModel.get("showDetail")) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var axis = axisProxy.getAxisModel().axis;
        var range3 = this._range;
        var dataInterval = nonRealtime ? axisProxy.calculateDataWindow({
          start: range3[0],
          end: range3[1]
        }).valueWindow : axisProxy.getDataValueWindow();
        labelTexts = [this._formatLabel(dataInterval[0], axis), this._formatLabel(dataInterval[1], axis)];
      }
    }
    var orderedHandleEnds = asc$2(this._handleEnds.slice());
    setLabel.call(this, 0);
    setLabel.call(this, 1);
    function setLabel(handleIndex) {
      var barTransform = getTransform$1(displaybles.handles[handleIndex].parent, this.group);
      var direction = transformDirection(handleIndex === 0 ? "right" : "left", barTransform);
      var offset2 = this._handleWidth / 2 + LABEL_GAP;
      var textPoint = applyTransform([orderedHandleEnds[handleIndex] + (handleIndex === 0 ? -offset2 : offset2), this._size[1] / 2], barTransform);
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        verticalAlign: orient === HORIZONTAL ? "middle" : direction,
        align: orient === HORIZONTAL ? direction : "center",
        text: labelTexts[handleIndex]
      });
    }
  };
  SliderZoomView2.prototype._formatLabel = function(value, axis) {
    var dataZoomModel = this.dataZoomModel;
    var labelFormatter = dataZoomModel.get("labelFormatter");
    var labelPrecision = dataZoomModel.get("labelPrecision");
    if (labelPrecision == null || labelPrecision === "auto") {
      labelPrecision = axis.getPixelPrecision();
    }
    var valueStr = value == null || isNaN(value) ? "" : axis.type === "category" || axis.type === "time" ? axis.scale.getLabel({
      value: Math.round(value)
    }) : value.toFixed(Math.min(labelPrecision, 20));
    return isFunction(labelFormatter) ? labelFormatter(value, valueStr) : isString$1(labelFormatter) ? labelFormatter.replace("{value}", valueStr) : valueStr;
  };
  SliderZoomView2.prototype._showDataInfo = function(showOrHide) {
    showOrHide = this._dragging || showOrHide;
    var displayables = this._displayables;
    var handleLabels = displayables.handleLabels;
    handleLabels[0].attr("invisible", !showOrHide);
    handleLabels[1].attr("invisible", !showOrHide);
    displayables.moveHandle && this.api[showOrHide ? "enterEmphasis" : "leaveEmphasis"](displayables.moveHandle, 1);
  };
  SliderZoomView2.prototype._onDragMove = function(handleIndex, dx, dy, event) {
    this._dragging = true;
    stop(event.event);
    var barTransform = this._displayables.sliderGroup.getLocalTransform();
    var vertex = applyTransform([dx, dy], barTransform, true);
    var changed = this._updateInterval(handleIndex, vertex[0]);
    var realtime = this.dataZoomModel.get("realtime");
    this._updateView(!realtime);
    changed && realtime && this._dispatchZoomAction(true);
  };
  SliderZoomView2.prototype._onDragEnd = function() {
    this._dragging = false;
    this._showDataInfo(false);
    var realtime = this.dataZoomModel.get("realtime");
    !realtime && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onClickPanel = function(e2) {
    var size = this._size;
    var localPoint = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
    if (localPoint[0] < 0 || localPoint[0] > size[0] || localPoint[1] < 0 || localPoint[1] > size[1]) {
      return;
    }
    var handleEnds = this._handleEnds;
    var center2 = (handleEnds[0] + handleEnds[1]) / 2;
    var changed = this._updateInterval("all", localPoint[0] - center2);
    this._updateView();
    changed && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrushStart = function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    this._brushStart = new Point$1(x2, y2);
    this._brushing = true;
    this._brushStartTime = +new Date();
  };
  SliderZoomView2.prototype._onBrushEnd = function(e2) {
    if (!this._brushing) {
      return;
    }
    var brushRect = this._displayables.brushRect;
    this._brushing = false;
    if (!brushRect) {
      return;
    }
    brushRect.attr("ignore", true);
    var brushShape = brushRect.shape;
    var brushEndTime = +new Date();
    if (brushEndTime - this._brushStartTime < 200 && Math.abs(brushShape.width) < 5) {
      return;
    }
    var viewExtend = this._getViewExtent();
    var percentExtent = [0, 100];
    this._range = asc$2([linearMap$2(brushShape.x, viewExtend, percentExtent, true), linearMap$2(brushShape.x + brushShape.width, viewExtend, percentExtent, true)]);
    this._handleEnds = [brushShape.x, brushShape.x + brushShape.width];
    this._updateView();
    this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrush = function(e2) {
    if (this._brushing) {
      stop(e2.event);
      this._updateBrushRect(e2.offsetX, e2.offsetY);
    }
  };
  SliderZoomView2.prototype._updateBrushRect = function(mouseX, mouseY) {
    var displayables = this._displayables;
    var dataZoomModel = this.dataZoomModel;
    var brushRect = displayables.brushRect;
    if (!brushRect) {
      brushRect = displayables.brushRect = new Rect({
        silent: true,
        style: dataZoomModel.getModel("brushStyle").getItemStyle()
      });
      displayables.sliderGroup.add(brushRect);
    }
    brushRect.attr("ignore", false);
    var brushStart = this._brushStart;
    var sliderGroup = this._displayables.sliderGroup;
    var endPoint = sliderGroup.transformCoordToLocal(mouseX, mouseY);
    var startPoint = sliderGroup.transformCoordToLocal(brushStart.x, brushStart.y);
    var size = this._size;
    endPoint[0] = Math.max(Math.min(size[0], endPoint[0]), 0);
    brushRect.setShape({
      x: startPoint[0],
      y: 0,
      width: endPoint[0] - startPoint[0],
      height: size[1]
    });
  };
  SliderZoomView2.prototype._dispatchZoomAction = function(realtime) {
    var range3 = this._range;
    this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      dataZoomId: this.dataZoomModel.id,
      animation: realtime ? REALTIME_ANIMATION_CONFIG : null,
      start: range3[0],
      end: range3[1]
    });
  };
  SliderZoomView2.prototype._findCoordRect = function() {
    var rect;
    var coordSysInfoList = collectReferCoordSysModelInfo(this.dataZoomModel).infoList;
    if (!rect && coordSysInfoList.length) {
      var coordSys = coordSysInfoList[0].model.coordinateSystem;
      rect = coordSys.getRect && coordSys.getRect();
    }
    if (!rect) {
      var width = this.api.getWidth();
      var height = this.api.getHeight();
      rect = {
        x: width * 0.2,
        y: height * 0.2,
        width: width * 0.6,
        height: height * 0.6
      };
    }
    return rect;
  };
  SliderZoomView2.type = "dataZoom.slider";
  return SliderZoomView2;
}(DataZoomView$1);
function getOtherDim(thisDim) {
  var map2 = {
    x: "y",
    y: "x",
    radius: "angle",
    angle: "radius"
  };
  return map2[thisDim];
}
function getCursor$1(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var SliderZoomView$1 = SliderZoomView;
function install$7(registers) {
  registers.registerComponentModel(SliderZoomModel$1);
  registers.registerComponentView(SliderZoomView$1);
  installCommon$1(registers);
}
function install$6(registers) {
  use(install$8);
  use(install$7);
}
var visualDefault = {
  get: function(visualType, key, isCategory2) {
    var value = clone$4((defaultOption[visualType] || {})[key]);
    return isCategory2 ? isArray$1(value) ? value[value.length - 1] : value : value;
  }
};
var defaultOption = {
  color: {
    active: ["#006edd", "#e0ffff"],
    inactive: ["rgba(0,0,0,0)"]
  },
  colorHue: {
    active: [0, 360],
    inactive: [0, 0]
  },
  colorSaturation: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  colorLightness: {
    active: [0.9, 0.5],
    inactive: [0, 0]
  },
  colorAlpha: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  opacity: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  symbol: {
    active: ["circle", "roundRect", "diamond"],
    inactive: ["none"]
  },
  symbolSize: {
    active: [10, 50],
    inactive: [0, 0]
  }
};
var visualDefault$1 = visualDefault;
var mapVisual = VisualMapping$1.mapVisual;
var eachVisual = VisualMapping$1.eachVisual;
var isArray = isArray$1;
var each$3 = each$g;
var asc = asc$2;
var linearMap$1 = linearMap$2;
var VisualMapModel = function(_super) {
  __extends(VisualMapModel2, _super);
  function VisualMapModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapModel2.type;
    _this.stateList = ["inRange", "outOfRange"];
    _this.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"];
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    _this.dataBound = [-Infinity, Infinity];
    _this.targetVisuals = {};
    _this.controllerVisuals = {};
    return _this;
  }
  VisualMapModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  VisualMapModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, this.replacableOptionKeys);
    this.textStyleModel = this.getModel("textStyle");
    this.resetItemSize();
    this.completeVisualOption();
  };
  VisualMapModel2.prototype.resetVisual = function(supplementVisualOption) {
    var stateList = this.stateList;
    supplementVisualOption = bind$1(supplementVisualOption, this);
    this.controllerVisuals = createVisualMappings(this.option.controller, stateList, supplementVisualOption);
    this.targetVisuals = createVisualMappings(this.option.target, stateList, supplementVisualOption);
  };
  VisualMapModel2.prototype.getItemSymbol = function() {
    return null;
  };
  VisualMapModel2.prototype.getTargetSeriesIndices = function() {
    var optionSeriesIndex = this.option.seriesIndex;
    var seriesIndices = [];
    if (optionSeriesIndex == null || optionSeriesIndex === "all") {
      this.ecModel.eachSeries(function(seriesModel, index2) {
        seriesIndices.push(index2);
      });
    } else {
      seriesIndices = normalizeToArray(optionSeriesIndex);
    }
    return seriesIndices;
  };
  VisualMapModel2.prototype.eachTargetSeries = function(callback, context) {
    each$g(this.getTargetSeriesIndices(), function(seriesIndex) {
      var seriesModel = this.ecModel.getSeriesByIndex(seriesIndex);
      if (seriesModel) {
        callback.call(context, seriesModel);
      }
    }, this);
  };
  VisualMapModel2.prototype.isTargetSeries = function(seriesModel) {
    var is = false;
    this.eachTargetSeries(function(model) {
      model === seriesModel && (is = true);
    });
    return is;
  };
  VisualMapModel2.prototype.formatValueText = function(value, isCategory2, edgeSymbols) {
    var option = this.option;
    var precision = option.precision;
    var dataBound = this.dataBound;
    var formatter = option.formatter;
    var isMinMax;
    edgeSymbols = edgeSymbols || ["<", ">"];
    if (isArray$1(value)) {
      value = value.slice();
      isMinMax = true;
    }
    var textValue = isCategory2 ? value : isMinMax ? [toFixed(value[0]), toFixed(value[1])] : toFixed(value);
    if (isString$1(formatter)) {
      return formatter.replace("{value}", isMinMax ? textValue[0] : textValue).replace("{value2}", isMinMax ? textValue[1] : textValue);
    } else if (isFunction(formatter)) {
      return isMinMax ? formatter(value[0], value[1]) : formatter(value);
    }
    if (isMinMax) {
      if (value[0] === dataBound[0]) {
        return edgeSymbols[0] + " " + textValue[1];
      } else if (value[1] === dataBound[1]) {
        return edgeSymbols[1] + " " + textValue[0];
      } else {
        return textValue[0] + " - " + textValue[1];
      }
    } else {
      return textValue;
    }
    function toFixed(val) {
      return val === dataBound[0] ? "min" : val === dataBound[1] ? "max" : (+val).toFixed(Math.min(precision, 20));
    }
  };
  VisualMapModel2.prototype.resetExtent = function() {
    var thisOption = this.option;
    var extent3 = asc([thisOption.min, thisOption.max]);
    this._dataExtent = extent3;
  };
  VisualMapModel2.prototype.getDataDimensionIndex = function(data) {
    var optDim = this.option.dimension;
    if (optDim != null) {
      return data.getDimensionIndex(optDim);
    }
    var dimNames = data.dimensions;
    for (var i = dimNames.length - 1; i >= 0; i--) {
      var dimName = dimNames[i];
      var dimInfo = data.getDimensionInfo(dimName);
      if (!dimInfo.isCalculationCoord) {
        return dimInfo.storeDimIndex;
      }
    }
  };
  VisualMapModel2.prototype.getExtent = function() {
    return this._dataExtent.slice();
  };
  VisualMapModel2.prototype.completeVisualOption = function() {
    var ecModel = this.ecModel;
    var thisOption = this.option;
    var base2 = {
      inRange: thisOption.inRange,
      outOfRange: thisOption.outOfRange
    };
    var target = thisOption.target || (thisOption.target = {});
    var controller = thisOption.controller || (thisOption.controller = {});
    merge(target, base2);
    merge(controller, base2);
    var isCategory2 = this.isCategory();
    completeSingle.call(this, target);
    completeSingle.call(this, controller);
    completeInactive.call(this, target, "inRange", "outOfRange");
    completeController.call(this, controller);
    function completeSingle(base3) {
      if (isArray(thisOption.color) && !base3.inRange) {
        base3.inRange = {
          color: thisOption.color.slice().reverse()
        };
      }
      base3.inRange = base3.inRange || {
        color: ecModel.get("gradientColor")
      };
    }
    function completeInactive(base3, stateExist, stateAbsent) {
      var optExist = base3[stateExist];
      var optAbsent = base3[stateAbsent];
      if (optExist && !optAbsent) {
        optAbsent = base3[stateAbsent] = {};
        each$3(optExist, function(visualData, visualType) {
          if (!VisualMapping$1.isValidType(visualType)) {
            return;
          }
          var defa = visualDefault$1.get(visualType, "inactive", isCategory2);
          if (defa != null) {
            optAbsent[visualType] = defa;
            if (visualType === "color" && !optAbsent.hasOwnProperty("opacity") && !optAbsent.hasOwnProperty("colorAlpha")) {
              optAbsent.opacity = [0, 0];
            }
          }
        });
      }
    }
    function completeController(controller2) {
      var symbolExists = (controller2.inRange || {}).symbol || (controller2.outOfRange || {}).symbol;
      var symbolSizeExists = (controller2.inRange || {}).symbolSize || (controller2.outOfRange || {}).symbolSize;
      var inactiveColor = this.get("inactiveColor");
      var itemSymbol = this.getItemSymbol();
      var defaultSymbol = itemSymbol || "roundRect";
      each$3(this.stateList, function(state) {
        var itemSize = this.itemSize;
        var visuals = controller2[state];
        if (!visuals) {
          visuals = controller2[state] = {
            color: isCategory2 ? inactiveColor : [inactiveColor]
          };
        }
        if (visuals.symbol == null) {
          visuals.symbol = symbolExists && clone$4(symbolExists) || (isCategory2 ? defaultSymbol : [defaultSymbol]);
        }
        if (visuals.symbolSize == null) {
          visuals.symbolSize = symbolSizeExists && clone$4(symbolSizeExists) || (isCategory2 ? itemSize[0] : [itemSize[0], itemSize[0]]);
        }
        visuals.symbol = mapVisual(visuals.symbol, function(symbol) {
          return symbol === "none" ? defaultSymbol : symbol;
        });
        var symbolSize = visuals.symbolSize;
        if (symbolSize != null) {
          var max_1 = -Infinity;
          eachVisual(symbolSize, function(value) {
            value > max_1 && (max_1 = value);
          });
          visuals.symbolSize = mapVisual(symbolSize, function(value) {
            return linearMap$1(value, [0, max_1], [0, itemSize[0]], true);
          });
        }
      }, this);
    }
  };
  VisualMapModel2.prototype.resetItemSize = function() {
    this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
  };
  VisualMapModel2.prototype.isCategory = function() {
    return !!this.option.categories;
  };
  VisualMapModel2.prototype.setSelected = function(selected) {
  };
  VisualMapModel2.prototype.getSelected = function() {
    return null;
  };
  VisualMapModel2.prototype.getValueState = function(value) {
    return null;
  };
  VisualMapModel2.prototype.getVisualMeta = function(getColorVisual2) {
    return null;
  };
  VisualMapModel2.type = "visualMap";
  VisualMapModel2.dependencies = ["series"];
  VisualMapModel2.defaultOption = {
    show: true,
    z: 4,
    seriesIndex: "all",
    min: 0,
    max: 200,
    left: 0,
    right: null,
    top: null,
    bottom: 0,
    itemWidth: null,
    itemHeight: null,
    inverse: false,
    orient: "vertical",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    contentColor: "#5793f3",
    inactiveColor: "#aaa",
    borderWidth: 0,
    padding: 5,
    textGap: 10,
    precision: 0,
    textStyle: {
      color: "#333"
    }
  };
  return VisualMapModel2;
}(ComponentModel$1);
var VisualMapModel$1 = VisualMapModel;
var DEFAULT_BAR_BOUND = [20, 140];
var ContinuousModel = function(_super) {
  __extends(ContinuousModel2, _super);
  function ContinuousModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousModel2.type;
    return _this;
  }
  ContinuousModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    this.resetVisual(function(mappingOption) {
      mappingOption.mappingMethod = "linear";
      mappingOption.dataExtent = this.getExtent();
    });
    this._resetRange();
  };
  ContinuousModel2.prototype.resetItemSize = function() {
    _super.prototype.resetItemSize.apply(this, arguments);
    var itemSize = this.itemSize;
    (itemSize[0] == null || isNaN(itemSize[0])) && (itemSize[0] = DEFAULT_BAR_BOUND[0]);
    (itemSize[1] == null || isNaN(itemSize[1])) && (itemSize[1] = DEFAULT_BAR_BOUND[1]);
  };
  ContinuousModel2.prototype._resetRange = function() {
    var dataExtent = this.getExtent();
    var range3 = this.option.range;
    if (!range3 || range3.auto) {
      dataExtent.auto = 1;
      this.option.range = dataExtent;
    } else if (isArray$1(range3)) {
      if (range3[0] > range3[1]) {
        range3.reverse();
      }
      range3[0] = Math.max(range3[0], dataExtent[0]);
      range3[1] = Math.min(range3[1], dataExtent[1]);
    }
  };
  ContinuousModel2.prototype.completeVisualOption = function() {
    _super.prototype.completeVisualOption.apply(this, arguments);
    each$g(this.stateList, function(state) {
      var symbolSize = this.option.controller[state].symbolSize;
      if (symbolSize && symbolSize[0] !== symbolSize[1]) {
        symbolSize[0] = symbolSize[1] / 3;
      }
    }, this);
  };
  ContinuousModel2.prototype.setSelected = function(selected) {
    this.option.range = selected.slice();
    this._resetRange();
  };
  ContinuousModel2.prototype.getSelected = function() {
    var dataExtent = this.getExtent();
    var dataInterval = asc$2((this.get("range") || []).slice());
    dataInterval[0] > dataExtent[1] && (dataInterval[0] = dataExtent[1]);
    dataInterval[1] > dataExtent[1] && (dataInterval[1] = dataExtent[1]);
    dataInterval[0] < dataExtent[0] && (dataInterval[0] = dataExtent[0]);
    dataInterval[1] < dataExtent[0] && (dataInterval[1] = dataExtent[0]);
    return dataInterval;
  };
  ContinuousModel2.prototype.getValueState = function(value) {
    var range3 = this.option.range;
    var dataExtent = this.getExtent();
    return (range3[0] <= dataExtent[0] || range3[0] <= value) && (range3[1] >= dataExtent[1] || value <= range3[1]) ? "inRange" : "outOfRange";
  };
  ContinuousModel2.prototype.findTargetDataIndices = function(range3) {
    var result = [];
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        range3[0] <= value && value <= range3[1] && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  ContinuousModel2.prototype.getVisualMeta = function(getColorVisual2) {
    var oVals = getColorStopValues(this, "outOfRange", this.getExtent());
    var iVals = getColorStopValues(this, "inRange", this.option.range.slice());
    var stops = [];
    function setStop(value, valueState) {
      stops.push({
        value,
        color: getColorVisual2(value, valueState)
      });
    }
    var iIdx = 0;
    var oIdx = 0;
    var iLen = iVals.length;
    var oLen = oVals.length;
    for (; oIdx < oLen && (!iVals.length || oVals[oIdx] <= iVals[0]); oIdx++) {
      if (oVals[oIdx] < iVals[iIdx]) {
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    for (var first = 1; iIdx < iLen; iIdx++, first = 0) {
      first && stops.length && setStop(iVals[iIdx], "outOfRange");
      setStop(iVals[iIdx], "inRange");
    }
    for (var first = 1; oIdx < oLen; oIdx++) {
      if (!iVals.length || iVals[iVals.length - 1] < oVals[oIdx]) {
        if (first) {
          stops.length && setStop(stops[stops.length - 1].value, "outOfRange");
          first = 0;
        }
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    var stopsLen = stops.length;
    return {
      stops,
      outerColors: [stopsLen ? stops[0].color : "transparent", stopsLen ? stops[stopsLen - 1].color : "transparent"]
    };
  };
  ContinuousModel2.type = "visualMap.continuous";
  ContinuousModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    align: "auto",
    calculable: false,
    hoverLink: true,
    realtime: true,
    handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z",
    handleSize: "120%",
    handleStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    indicatorIcon: "circle",
    indicatorSize: "50%",
    indicatorStyle: {
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0,0,0,0.2)"
    }
  });
  return ContinuousModel2;
}(VisualMapModel$1);
function getColorStopValues(visualMapModel, valueState, dataExtent) {
  if (dataExtent[0] === dataExtent[1]) {
    return dataExtent.slice();
  }
  var count2 = 200;
  var step = (dataExtent[1] - dataExtent[0]) / count2;
  var value = dataExtent[0];
  var stopValues = [];
  for (var i = 0; i <= count2 && value < dataExtent[1]; i++) {
    stopValues.push(value);
    value += step;
  }
  stopValues.push(dataExtent[1]);
  return stopValues;
}
var ContinuousModel$1 = ContinuousModel;
var VisualMapView = function(_super) {
  __extends(VisualMapView2, _super);
  function VisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapView2.type;
    _this.autoPositionValues = {
      left: 1,
      right: 1,
      top: 1,
      bottom: 1
    };
    return _this;
  }
  VisualMapView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
  };
  VisualMapView2.prototype.render = function(visualMapModel, ecModel, api, payload) {
    this.visualMapModel = visualMapModel;
    if (visualMapModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    this.doRender(visualMapModel, ecModel, api, payload);
  };
  VisualMapView2.prototype.renderBackground = function(group) {
    var visualMapModel = this.visualMapModel;
    var padding = normalizeCssArray(visualMapModel.get("padding") || 0);
    var rect = group.getBoundingRect();
    group.add(new Rect$3({
      z2: -1,
      silent: true,
      shape: {
        x: rect.x - padding[3],
        y: rect.y - padding[0],
        width: rect.width + padding[3] + padding[1],
        height: rect.height + padding[0] + padding[2]
      },
      style: {
        fill: visualMapModel.get("backgroundColor"),
        stroke: visualMapModel.get("borderColor"),
        lineWidth: visualMapModel.get("borderWidth")
      }
    }));
  };
  VisualMapView2.prototype.getControllerVisual = function(targetValue, visualCluster, opts) {
    opts = opts || {};
    var forceState = opts.forceState;
    var visualMapModel = this.visualMapModel;
    var visualObj = {};
    if (visualCluster === "color") {
      var defaultColor = visualMapModel.get("contentColor");
      visualObj.color = defaultColor;
    }
    function getter(key) {
      return visualObj[key];
    }
    function setter(key, value) {
      visualObj[key] = value;
    }
    var mappings = visualMapModel.controllerVisuals[forceState || visualMapModel.getValueState(targetValue)];
    var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
    each$g(visualTypes, function(type4) {
      var visualMapping = mappings[type4];
      if (opts.convertOpacityToAlpha && type4 === "opacity") {
        type4 = "colorAlpha";
        visualMapping = mappings.__alphaForOpacity;
      }
      if (VisualMapping$1.dependsOn(type4, visualCluster)) {
        visualMapping && visualMapping.applyVisual(targetValue, getter, setter);
      }
    });
    return visualObj[visualCluster];
  };
  VisualMapView2.prototype.positionGroup = function(group) {
    var model = this.visualMapModel;
    var api = this.api;
    positionElement(group, model.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  VisualMapView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
  };
  VisualMapView2.type = "visualMap";
  return VisualMapView2;
}(ComponentView$1);
var VisualMapView$1 = VisualMapView;
var paramsSet = [["left", "right", "width"], ["top", "bottom", "height"]];
function getItemAlign(visualMapModel, api, itemSize) {
  var modelOption = visualMapModel.option;
  var itemAlign = modelOption.align;
  if (itemAlign != null && itemAlign !== "auto") {
    return itemAlign;
  }
  var ecSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var realIndex = modelOption.orient === "horizontal" ? 1 : 0;
  var reals = paramsSet[realIndex];
  var fakeValue = [0, null, 10];
  var layoutInput = {};
  for (var i = 0; i < 3; i++) {
    layoutInput[paramsSet[1 - realIndex][i]] = fakeValue[i];
    layoutInput[reals[i]] = i === 2 ? itemSize[0] : modelOption[reals[i]];
  }
  var rParam = [["x", "width", 3], ["y", "height", 0]][realIndex];
  var rect = getLayoutRect(layoutInput, ecSize, modelOption.padding);
  return reals[(rect.margin[rParam[2]] || 0) + rect[rParam[0]] + rect[rParam[1]] * 0.5 < ecSize[rParam[1]] * 0.5 ? 0 : 1];
}
function makeHighDownBatch(batch, visualMapModel) {
  each$g(batch || [], function(batchItem) {
    if (batchItem.dataIndex != null) {
      batchItem.dataIndexInside = batchItem.dataIndex;
      batchItem.dataIndex = null;
    }
    batchItem.highlightKey = "visualMap" + (visualMapModel ? visualMapModel.componentIndex : "");
  });
  return batch;
}
var linearMap = linearMap$2;
var each$2 = each$g;
var mathMin = Math.min;
var mathMax = Math.max;
var HOVER_LINK_SIZE = 12;
var HOVER_LINK_OUT = 6;
var ContinuousView = function(_super) {
  __extends(ContinuousView2, _super);
  function ContinuousView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousView2.type;
    _this._shapes = {};
    _this._dataInterval = [];
    _this._handleEnds = [];
    _this._hoverLinkDataIndices = [];
    return _this;
  }
  ContinuousView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
    this._api = api;
    if (!payload || payload.type !== "selectDataRange" || payload.from !== this.uid) {
      this._buildView();
    }
  };
  ContinuousView2.prototype._buildView = function() {
    this.group.removeAll();
    var visualMapModel = this.visualMapModel;
    var thisGroup = this.group;
    this._orient = visualMapModel.get("orient");
    this._useHandle = visualMapModel.get("calculable");
    this._resetInterval();
    this._renderBar(thisGroup);
    var dataRangeText = visualMapModel.get("text");
    this._renderEndsText(thisGroup, dataRangeText, 0);
    this._renderEndsText(thisGroup, dataRangeText, 1);
    this._updateView(true);
    this.renderBackground(thisGroup);
    this._updateView();
    this._enableHoverLinkToSeries();
    this._enableHoverLinkFromSeries();
    this.positionGroup(thisGroup);
  };
  ContinuousView2.prototype._renderEndsText = function(group, dataRangeText, endsIndex) {
    if (!dataRangeText) {
      return;
    }
    var text = dataRangeText[1 - endsIndex];
    text = text != null ? text + "" : "";
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var itemSize = visualMapModel.itemSize;
    var barGroup = this._shapes.mainGroup;
    var position2 = this._applyTransform([itemSize[0] / 2, endsIndex === 0 ? -textGap : itemSize[1] + textGap], barGroup);
    var align = this._applyTransform(endsIndex === 0 ? "bottom" : "top", barGroup);
    var orient = this._orient;
    var textStyleModel = this.visualMapModel.textStyleModel;
    this.group.add(new ZRText$1({
      style: {
        x: position2[0],
        y: position2[1],
        verticalAlign: orient === "horizontal" ? "middle" : align,
        align: orient === "horizontal" ? align : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
  };
  ContinuousView2.prototype._renderBar = function(targetGroup) {
    var visualMapModel = this.visualMapModel;
    var shapes = this._shapes;
    var itemSize = visualMapModel.itemSize;
    var orient = this._orient;
    var useHandle = this._useHandle;
    var itemAlign = getItemAlign(visualMapModel, this.api, itemSize);
    var mainGroup = shapes.mainGroup = this._createBarGroup(itemAlign);
    var gradientBarGroup = new Group$6();
    mainGroup.add(gradientBarGroup);
    gradientBarGroup.add(shapes.outOfRange = createPolygon());
    gradientBarGroup.add(shapes.inRange = createPolygon(null, useHandle ? getCursor(this._orient) : null, bind$1(this._dragHandle, this, "all", false), bind$1(this._dragHandle, this, "all", true)));
    gradientBarGroup.setClipPath(new Rect$3({
      shape: {
        x: 0,
        y: 0,
        width: itemSize[0],
        height: itemSize[1],
        r: 3
      }
    }));
    var textRect = visualMapModel.textStyleModel.getTextRect("\u56FD");
    var textSize = mathMax(textRect.width, textRect.height);
    if (useHandle) {
      shapes.handleThumbs = [];
      shapes.handleLabels = [];
      shapes.handleLabelPoints = [];
      this._createHandle(visualMapModel, mainGroup, 0, itemSize, textSize, orient);
      this._createHandle(visualMapModel, mainGroup, 1, itemSize, textSize, orient);
    }
    this._createIndicator(visualMapModel, mainGroup, itemSize, textSize, orient);
    targetGroup.add(mainGroup);
  };
  ContinuousView2.prototype._createHandle = function(visualMapModel, mainGroup, handleIndex, itemSize, textSize, orient) {
    var onDrift = bind$1(this._dragHandle, this, handleIndex, false);
    var onDragEnd = bind$1(this._dragHandle, this, handleIndex, true);
    var handleSize = parsePercent$1(visualMapModel.get("handleSize"), itemSize[0]);
    var handleThumb = createSymbol$1(visualMapModel.get("handleIcon"), -handleSize / 2, -handleSize / 2, handleSize, handleSize, null, true);
    var cursor = getCursor(this._orient);
    handleThumb.attr({
      cursor,
      draggable: true,
      drift: onDrift,
      ondragend: onDragEnd,
      onmousemove: function(e2) {
        stop(e2.event);
      }
    });
    handleThumb.x = itemSize[0] / 2;
    handleThumb.useStyle(visualMapModel.getModel("handleStyle").getItemStyle());
    handleThumb.setStyle({
      strokeNoScale: true,
      strokeFirst: true
    });
    handleThumb.style.lineWidth *= 2;
    handleThumb.ensureState("emphasis").style = visualMapModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
    setAsHighDownDispatcher(handleThumb, true);
    mainGroup.add(handleThumb);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var handleLabel = new ZRText$1({
      cursor,
      draggable: true,
      drift: onDrift,
      onmousemove: function(e2) {
        stop(e2.event);
      },
      ondragend: onDragEnd,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    handleLabel.ensureState("blur").style = {
      opacity: 0.1
    };
    handleLabel.stateTransition = {
      duration: 200
    };
    this.group.add(handleLabel);
    var handleLabelPoint = [handleSize, 0];
    var shapes = this._shapes;
    shapes.handleThumbs[handleIndex] = handleThumb;
    shapes.handleLabelPoints[handleIndex] = handleLabelPoint;
    shapes.handleLabels[handleIndex] = handleLabel;
  };
  ContinuousView2.prototype._createIndicator = function(visualMapModel, mainGroup, itemSize, textSize, orient) {
    var scale2 = parsePercent$1(visualMapModel.get("indicatorSize"), itemSize[0]);
    var indicator = createSymbol$1(visualMapModel.get("indicatorIcon"), -scale2 / 2, -scale2 / 2, scale2, scale2, null, true);
    indicator.attr({
      cursor: "move",
      invisible: true,
      silent: true,
      x: itemSize[0] / 2
    });
    var indicatorStyle = visualMapModel.getModel("indicatorStyle").getItemStyle();
    if (indicator instanceof ZRImage$1) {
      var pathStyle = indicator.style;
      indicator.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, indicatorStyle));
    } else {
      indicator.useStyle(indicatorStyle);
    }
    mainGroup.add(indicator);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var indicatorLabel = new ZRText$1({
      silent: true,
      invisible: true,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    this.group.add(indicatorLabel);
    var indicatorLabelPoint = [(orient === "horizontal" ? textSize / 2 : HOVER_LINK_OUT) + itemSize[0] / 2, 0];
    var shapes = this._shapes;
    shapes.indicator = indicator;
    shapes.indicatorLabel = indicatorLabel;
    shapes.indicatorLabelPoint = indicatorLabelPoint;
    this._firstShowIndicator = true;
  };
  ContinuousView2.prototype._dragHandle = function(handleIndex, isEnd, dx, dy) {
    if (!this._useHandle) {
      return;
    }
    this._dragging = !isEnd;
    if (!isEnd) {
      var vertex = this._applyTransform([dx, dy], this._shapes.mainGroup, true);
      this._updateInterval(handleIndex, vertex[1]);
      this._hideIndicator();
      this._updateView();
    }
    if (isEnd === !this.visualMapModel.get("realtime")) {
      this.api.dispatchAction({
        type: "selectDataRange",
        from: this.uid,
        visualMapId: this.visualMapModel.id,
        selected: this._dataInterval.slice()
      });
    }
    if (isEnd) {
      !this._hovering && this._clearHoverLinkToSeries();
    } else if (useHoverLinkOnHandle(this.visualMapModel)) {
      this._doHoverLinkToSeries(this._handleEnds[handleIndex], false);
    }
  };
  ContinuousView2.prototype._resetInterval = function() {
    var visualMapModel = this.visualMapModel;
    var dataInterval = this._dataInterval = visualMapModel.getSelected();
    var dataExtent = visualMapModel.getExtent();
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    this._handleEnds = [linearMap(dataInterval[0], dataExtent, sizeExtent, true), linearMap(dataInterval[1], dataExtent, sizeExtent, true)];
  };
  ContinuousView2.prototype._updateInterval = function(handleIndex, delta) {
    delta = delta || 0;
    var visualMapModel = this.visualMapModel;
    var handleEnds = this._handleEnds;
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    sliderMove(delta, handleEnds, sizeExtent, handleIndex, 0);
    var dataExtent = visualMapModel.getExtent();
    this._dataInterval = [linearMap(handleEnds[0], sizeExtent, dataExtent, true), linearMap(handleEnds[1], sizeExtent, dataExtent, true)];
  };
  ContinuousView2.prototype._updateView = function(forSketch) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var shapes = this._shapes;
    var outOfRangeHandleEnds = [0, visualMapModel.itemSize[1]];
    var inRangeHandleEnds = forSketch ? outOfRangeHandleEnds : this._handleEnds;
    var visualInRange = this._createBarVisual(this._dataInterval, dataExtent, inRangeHandleEnds, "inRange");
    var visualOutOfRange = this._createBarVisual(dataExtent, dataExtent, outOfRangeHandleEnds, "outOfRange");
    shapes.inRange.setStyle({
      fill: visualInRange.barColor
    }).setShape("points", visualInRange.barPoints);
    shapes.outOfRange.setStyle({
      fill: visualOutOfRange.barColor
    }).setShape("points", visualOutOfRange.barPoints);
    this._updateHandle(inRangeHandleEnds, visualInRange);
  };
  ContinuousView2.prototype._createBarVisual = function(dataInterval, dataExtent, handleEnds, forceState) {
    var opts = {
      forceState,
      convertOpacityToAlpha: true
    };
    var colorStops = this._makeColorGradient(dataInterval, opts);
    var symbolSizes = [this.getControllerVisual(dataInterval[0], "symbolSize", opts), this.getControllerVisual(dataInterval[1], "symbolSize", opts)];
    var barPoints = this._createBarPoints(handleEnds, symbolSizes);
    return {
      barColor: new LinearGradient$1(0, 0, 0, 1, colorStops),
      barPoints,
      handlesColor: [colorStops[0].color, colorStops[colorStops.length - 1].color]
    };
  };
  ContinuousView2.prototype._makeColorGradient = function(dataInterval, opts) {
    var sampleNumber = 100;
    var colorStops = [];
    var step = (dataInterval[1] - dataInterval[0]) / sampleNumber;
    colorStops.push({
      color: this.getControllerVisual(dataInterval[0], "color", opts),
      offset: 0
    });
    for (var i = 1; i < sampleNumber; i++) {
      var currValue = dataInterval[0] + step * i;
      if (currValue > dataInterval[1]) {
        break;
      }
      colorStops.push({
        color: this.getControllerVisual(currValue, "color", opts),
        offset: i / sampleNumber
      });
    }
    colorStops.push({
      color: this.getControllerVisual(dataInterval[1], "color", opts),
      offset: 1
    });
    return colorStops;
  };
  ContinuousView2.prototype._createBarPoints = function(handleEnds, symbolSizes) {
    var itemSize = this.visualMapModel.itemSize;
    return [[itemSize[0] - symbolSizes[0], handleEnds[0]], [itemSize[0], handleEnds[0]], [itemSize[0], handleEnds[1]], [itemSize[0] - symbolSizes[1], handleEnds[1]]];
  };
  ContinuousView2.prototype._createBarGroup = function(itemAlign) {
    var orient = this._orient;
    var inverse = this.visualMapModel.get("inverse");
    return new Group$6(orient === "horizontal" && !inverse ? {
      scaleX: itemAlign === "bottom" ? 1 : -1,
      rotation: Math.PI / 2
    } : orient === "horizontal" && inverse ? {
      scaleX: itemAlign === "bottom" ? -1 : 1,
      rotation: -Math.PI / 2
    } : orient === "vertical" && !inverse ? {
      scaleX: itemAlign === "left" ? 1 : -1,
      scaleY: -1
    } : {
      scaleX: itemAlign === "left" ? 1 : -1
    });
  };
  ContinuousView2.prototype._updateHandle = function(handleEnds, visualInRange) {
    if (!this._useHandle) {
      return;
    }
    var shapes = this._shapes;
    var visualMapModel = this.visualMapModel;
    var handleThumbs = shapes.handleThumbs;
    var handleLabels = shapes.handleLabels;
    var itemSize = visualMapModel.itemSize;
    var dataExtent = visualMapModel.getExtent();
    each$2([0, 1], function(handleIndex) {
      var handleThumb = handleThumbs[handleIndex];
      handleThumb.setStyle("fill", visualInRange.handlesColor[handleIndex]);
      handleThumb.y = handleEnds[handleIndex];
      var val = linearMap(handleEnds[handleIndex], [0, itemSize[1]], dataExtent, true);
      var symbolSize = this.getControllerVisual(val, "symbolSize");
      handleThumb.scaleX = handleThumb.scaleY = symbolSize / itemSize[0];
      handleThumb.x = itemSize[0] - symbolSize / 2;
      var textPoint = applyTransform(shapes.handleLabelPoints[handleIndex], getTransform$1(handleThumb, this.group));
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        text: visualMapModel.formatValueText(this._dataInterval[handleIndex]),
        verticalAlign: "middle",
        align: this._orient === "vertical" ? this._applyTransform("left", shapes.mainGroup) : "center"
      });
    }, this);
  };
  ContinuousView2.prototype._showIndicator = function(cursorValue, textValue, rangeSymbol, halfHoverLinkSize) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var itemSize = visualMapModel.itemSize;
    var sizeExtent = [0, itemSize[1]];
    var shapes = this._shapes;
    var indicator = shapes.indicator;
    if (!indicator) {
      return;
    }
    indicator.attr("invisible", false);
    var opts = {
      convertOpacityToAlpha: true
    };
    var color = this.getControllerVisual(cursorValue, "color", opts);
    var symbolSize = this.getControllerVisual(cursorValue, "symbolSize");
    var y2 = linearMap(cursorValue, dataExtent, sizeExtent, true);
    var x2 = itemSize[0] - symbolSize / 2;
    var oldIndicatorPos = {
      x: indicator.x,
      y: indicator.y
    };
    indicator.y = y2;
    indicator.x = x2;
    var textPoint = applyTransform(shapes.indicatorLabelPoint, getTransform$1(indicator, this.group));
    var indicatorLabel = shapes.indicatorLabel;
    indicatorLabel.attr("invisible", false);
    var align = this._applyTransform("left", shapes.mainGroup);
    var orient = this._orient;
    var isHorizontal = orient === "horizontal";
    indicatorLabel.setStyle({
      text: (rangeSymbol ? rangeSymbol : "") + visualMapModel.formatValueText(textValue),
      verticalAlign: isHorizontal ? align : "middle",
      align: isHorizontal ? "center" : align
    });
    var indicatorNewProps = {
      x: x2,
      y: y2,
      style: {
        fill: color
      }
    };
    var labelNewProps = {
      style: {
        x: textPoint[0],
        y: textPoint[1]
      }
    };
    if (visualMapModel.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
      var animationCfg = {
        duration: 100,
        easing: "cubicInOut",
        additive: true
      };
      indicator.x = oldIndicatorPos.x;
      indicator.y = oldIndicatorPos.y;
      indicator.animateTo(indicatorNewProps, animationCfg);
      indicatorLabel.animateTo(labelNewProps, animationCfg);
    } else {
      indicator.attr(indicatorNewProps);
      indicatorLabel.attr(labelNewProps);
    }
    this._firstShowIndicator = false;
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.enterBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._enableHoverLinkToSeries = function() {
    var self2 = this;
    this._shapes.mainGroup.on("mousemove", function(e2) {
      self2._hovering = true;
      if (!self2._dragging) {
        var itemSize = self2.visualMapModel.itemSize;
        var pos = self2._applyTransform([e2.offsetX, e2.offsetY], self2._shapes.mainGroup, true, true);
        pos[1] = mathMin(mathMax(0, pos[1]), itemSize[1]);
        self2._doHoverLinkToSeries(pos[1], 0 <= pos[0] && pos[0] <= itemSize[0]);
      }
    }).on("mouseout", function() {
      self2._hovering = false;
      !self2._dragging && self2._clearHoverLinkToSeries();
    });
  };
  ContinuousView2.prototype._enableHoverLinkFromSeries = function() {
    var zr = this.api.getZr();
    if (this.visualMapModel.option.hoverLink) {
      zr.on("mouseover", this._hoverLinkFromSeriesMouseOver, this);
      zr.on("mouseout", this._hideIndicator, this);
    } else {
      this._clearHoverLinkFromSeries();
    }
  };
  ContinuousView2.prototype._doHoverLinkToSeries = function(cursorPos, hoverOnBar) {
    var visualMapModel = this.visualMapModel;
    var itemSize = visualMapModel.itemSize;
    if (!visualMapModel.option.hoverLink) {
      return;
    }
    var sizeExtent = [0, itemSize[1]];
    var dataExtent = visualMapModel.getExtent();
    cursorPos = mathMin(mathMax(sizeExtent[0], cursorPos), sizeExtent[1]);
    var halfHoverLinkSize = getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent);
    var hoverRange = [cursorPos - halfHoverLinkSize, cursorPos + halfHoverLinkSize];
    var cursorValue = linearMap(cursorPos, sizeExtent, dataExtent, true);
    var valueRange = [linearMap(hoverRange[0], sizeExtent, dataExtent, true), linearMap(hoverRange[1], sizeExtent, dataExtent, true)];
    hoverRange[0] < sizeExtent[0] && (valueRange[0] = -Infinity);
    hoverRange[1] > sizeExtent[1] && (valueRange[1] = Infinity);
    if (hoverOnBar) {
      if (valueRange[0] === -Infinity) {
        this._showIndicator(cursorValue, valueRange[1], "< ", halfHoverLinkSize);
      } else if (valueRange[1] === Infinity) {
        this._showIndicator(cursorValue, valueRange[0], "> ", halfHoverLinkSize);
      } else {
        this._showIndicator(cursorValue, cursorValue, "\u2248 ", halfHoverLinkSize);
      }
    }
    var oldBatch = this._hoverLinkDataIndices;
    var newBatch = [];
    if (hoverOnBar || useHoverLinkOnHandle(visualMapModel)) {
      newBatch = this._hoverLinkDataIndices = visualMapModel.findTargetDataIndices(valueRange);
    }
    var resultBatches = compressBatches(oldBatch, newBatch);
    this._dispatchHighDown("downplay", makeHighDownBatch(resultBatches[0], visualMapModel));
    this._dispatchHighDown("highlight", makeHighDownBatch(resultBatches[1], visualMapModel));
  };
  ContinuousView2.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
    var el = e2.target;
    var visualMapModel = this.visualMapModel;
    if (!el || getECData(el).dataIndex == null) {
      return;
    }
    var ecData = getECData(el);
    var dataModel = this.ecModel.getSeriesByIndex(ecData.seriesIndex);
    if (!visualMapModel.isTargetSeries(dataModel)) {
      return;
    }
    var data = dataModel.getData(ecData.dataType);
    var value = data.getStore().get(visualMapModel.getDataDimensionIndex(data), ecData.dataIndex);
    if (!isNaN(value)) {
      this._showIndicator(value, value);
    }
  };
  ContinuousView2.prototype._hideIndicator = function() {
    var shapes = this._shapes;
    shapes.indicator && shapes.indicator.attr("invisible", true);
    shapes.indicatorLabel && shapes.indicatorLabel.attr("invisible", true);
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.leaveBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._clearHoverLinkToSeries = function() {
    this._hideIndicator();
    var indices = this._hoverLinkDataIndices;
    this._dispatchHighDown("downplay", makeHighDownBatch(indices, this.visualMapModel));
    indices.length = 0;
  };
  ContinuousView2.prototype._clearHoverLinkFromSeries = function() {
    this._hideIndicator();
    var zr = this.api.getZr();
    zr.off("mouseover", this._hoverLinkFromSeriesMouseOver);
    zr.off("mouseout", this._hideIndicator);
  };
  ContinuousView2.prototype._applyTransform = function(vertex, element, inverse, global2) {
    var transform2 = getTransform$1(element, global2 ? null : this.group);
    return isArray$1(vertex) ? applyTransform(vertex, transform2, inverse) : transformDirection(vertex, transform2, inverse);
  };
  ContinuousView2.prototype._dispatchHighDown = function(type4, batch) {
    batch && batch.length && this.api.dispatchAction({
      type: type4,
      batch
    });
  };
  ContinuousView2.prototype.dispose = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.prototype.remove = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.type = "visualMap.continuous";
  return ContinuousView2;
}(VisualMapView$1);
function createPolygon(points2, cursor, onDrift, onDragEnd) {
  return new Polygon$1({
    shape: {
      points: points2
    },
    draggable: !!onDrift,
    cursor,
    drift: onDrift,
    onmousemove: function(e2) {
      stop(e2.event);
    },
    ondragend: onDragEnd
  });
}
function getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent) {
  var halfHoverLinkSize = HOVER_LINK_SIZE / 2;
  var hoverLinkDataSize = visualMapModel.get("hoverLinkDataSize");
  if (hoverLinkDataSize) {
    halfHoverLinkSize = linearMap(hoverLinkDataSize, dataExtent, sizeExtent, true) / 2;
  }
  return halfHoverLinkSize;
}
function useHoverLinkOnHandle(visualMapModel) {
  var hoverLinkOnHandle = visualMapModel.get("hoverLinkOnHandle");
  return !!(hoverLinkOnHandle == null ? visualMapModel.get("realtime") : hoverLinkOnHandle);
}
function getCursor(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var ContinuousView$1 = ContinuousView;
var visualMapActionInfo = {
  type: "selectDataRange",
  event: "dataRangeSelected",
  update: "update"
};
var visualMapActionHander = function(payload, ecModel) {
  ecModel.eachComponent({
    mainType: "visualMap",
    query: payload
  }, function(model) {
    model.setSelected(payload.selected);
  });
};
var visualMapEncodingHandlers = [
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var resetDefines = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        var pipelineContext = seriesModel.pipelineContext;
        if (!visualMapModel.isTargetSeries(seriesModel) || pipelineContext && pipelineContext.large) {
          return;
        }
        resetDefines.push(incrementalApplyVisual(visualMapModel.stateList, visualMapModel.targetVisuals, bind$1(visualMapModel.getValueState, visualMapModel), visualMapModel.getDataDimensionIndex(seriesModel.getData())));
      });
      return resetDefines;
    }
  },
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      var visualMetaList = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        if (visualMapModel.isTargetSeries(seriesModel)) {
          var visualMeta = visualMapModel.getVisualMeta(bind$1(getColorVisual, null, seriesModel, visualMapModel)) || {
            stops: [],
            outerColors: []
          };
          var dimIdx = visualMapModel.getDataDimensionIndex(data);
          if (dimIdx >= 0) {
            visualMeta.dimension = dimIdx;
            visualMetaList.push(visualMeta);
          }
        }
      });
      seriesModel.getData().setVisual("visualMeta", visualMetaList);
    }
  }
];
function getColorVisual(seriesModel, visualMapModel, value, valueState) {
  var mappings = visualMapModel.targetVisuals[valueState];
  var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
  var resultVisual = {
    color: getVisualFromData(seriesModel.getData(), "color")
  };
  for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
    var type4 = visualTypes[i];
    var mapping = mappings[type4 === "opacity" ? "__alphaForOpacity" : type4];
    mapping && mapping.applyVisual(value, getVisual, setVisual);
  }
  return resultVisual.color;
  function getVisual(key) {
    return resultVisual[key];
  }
  function setVisual(key, value2) {
    resultVisual[key] = value2;
  }
}
var each$1 = each$g;
function visualMapPreprocessor(option) {
  var visualMap = option && option.visualMap;
  if (!isArray$1(visualMap)) {
    visualMap = visualMap ? [visualMap] : [];
  }
  each$1(visualMap, function(opt) {
    if (!opt) {
      return;
    }
    if (has(opt, "splitList") && !has(opt, "pieces")) {
      opt.pieces = opt.splitList;
      delete opt.splitList;
    }
    var pieces = opt.pieces;
    if (pieces && isArray$1(pieces)) {
      each$1(pieces, function(piece) {
        if (isObject$4(piece)) {
          if (has(piece, "start") && !has(piece, "min")) {
            piece.min = piece.start;
          }
          if (has(piece, "end") && !has(piece, "max")) {
            piece.max = piece.end;
          }
        }
      });
    }
  });
}
function has(obj, name) {
  return obj && obj.hasOwnProperty && obj.hasOwnProperty(name);
}
var installed = false;
function installCommon(registers) {
  if (installed) {
    return;
  }
  installed = true;
  registers.registerSubTypeDefaulter("visualMap", function(option) {
    return !option.categories && (!(option.pieces ? option.pieces.length > 0 : option.splitNumber > 0) || option.calculable) ? "continuous" : "piecewise";
  });
  registers.registerAction(visualMapActionInfo, visualMapActionHander);
  each$g(visualMapEncodingHandlers, function(handler) {
    registers.registerVisual(registers.PRIORITY.VISUAL.COMPONENT, handler);
  });
  registers.registerPreprocessor(visualMapPreprocessor);
}
function install$5(registers) {
  registers.registerComponentModel(ContinuousModel$1);
  registers.registerComponentView(ContinuousView$1);
  installCommon(registers);
}
var PiecewiseModel = function(_super) {
  __extends(PiecewiseModel2, _super);
  function PiecewiseModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseModel2.type;
    _this._pieceList = [];
    return _this;
  }
  PiecewiseModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    var mode = this._mode = this._determineMode();
    this._pieceList = [];
    resetMethods[this._mode].call(this, this._pieceList);
    this._resetSelected(newOption, isInit);
    var categories = this.option.categories;
    this.resetVisual(function(mappingOption, state) {
      if (mode === "categories") {
        mappingOption.mappingMethod = "category";
        mappingOption.categories = clone$4(categories);
      } else {
        mappingOption.dataExtent = this.getExtent();
        mappingOption.mappingMethod = "piecewise";
        mappingOption.pieceList = map$1(this._pieceList, function(piece) {
          piece = clone$4(piece);
          if (state !== "inRange") {
            piece.visual = null;
          }
          return piece;
        });
      }
    });
  };
  PiecewiseModel2.prototype.completeVisualOption = function() {
    var option = this.option;
    var visualTypesInPieces = {};
    var visualTypes = VisualMapping$1.listVisualTypes();
    var isCategory2 = this.isCategory();
    each$g(option.pieces, function(piece) {
      each$g(visualTypes, function(visualType) {
        if (piece.hasOwnProperty(visualType)) {
          visualTypesInPieces[visualType] = 1;
        }
      });
    });
    each$g(visualTypesInPieces, function(v4, visualType) {
      var exists = false;
      each$g(this.stateList, function(state) {
        exists = exists || has2(option, state, visualType) || has2(option.target, state, visualType);
      }, this);
      !exists && each$g(this.stateList, function(state) {
        (option[state] || (option[state] = {}))[visualType] = visualDefault$1.get(visualType, state === "inRange" ? "active" : "inactive", isCategory2);
      });
    }, this);
    function has2(obj, state, visualType) {
      return obj && obj[state] && obj[state].hasOwnProperty(visualType);
    }
    _super.prototype.completeVisualOption.apply(this, arguments);
  };
  PiecewiseModel2.prototype._resetSelected = function(newOption, isInit) {
    var thisOption = this.option;
    var pieceList = this._pieceList;
    var selected = (isInit ? thisOption : newOption).selected || {};
    thisOption.selected = selected;
    each$g(pieceList, function(piece, index2) {
      var key = this.getSelectedMapKey(piece);
      if (!selected.hasOwnProperty(key)) {
        selected[key] = true;
      }
    }, this);
    if (thisOption.selectedMode === "single") {
      var hasSel_1 = false;
      each$g(pieceList, function(piece, index2) {
        var key = this.getSelectedMapKey(piece);
        if (selected[key]) {
          hasSel_1 ? selected[key] = false : hasSel_1 = true;
        }
      }, this);
    }
  };
  PiecewiseModel2.prototype.getItemSymbol = function() {
    return this.get("itemSymbol");
  };
  PiecewiseModel2.prototype.getSelectedMapKey = function(piece) {
    return this._mode === "categories" ? piece.value + "" : piece.index + "";
  };
  PiecewiseModel2.prototype.getPieceList = function() {
    return this._pieceList;
  };
  PiecewiseModel2.prototype._determineMode = function() {
    var option = this.option;
    return option.pieces && option.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
  };
  PiecewiseModel2.prototype.setSelected = function(selected) {
    this.option.selected = clone$4(selected);
  };
  PiecewiseModel2.prototype.getValueState = function(value) {
    var index2 = VisualMapping$1.findPieceIndex(value, this._pieceList);
    return index2 != null ? this.option.selected[this.getSelectedMapKey(this._pieceList[index2])] ? "inRange" : "outOfRange" : "outOfRange";
  };
  PiecewiseModel2.prototype.findTargetDataIndices = function(pieceIndex) {
    var result = [];
    var pieceList = this._pieceList;
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        var pIdx = VisualMapping$1.findPieceIndex(value, pieceList);
        pIdx === pieceIndex && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  PiecewiseModel2.prototype.getRepresentValue = function(piece) {
    var representValue;
    if (this.isCategory()) {
      representValue = piece.value;
    } else {
      if (piece.value != null) {
        representValue = piece.value;
      } else {
        var pieceInterval = piece.interval || [];
        representValue = pieceInterval[0] === -Infinity && pieceInterval[1] === Infinity ? 0 : (pieceInterval[0] + pieceInterval[1]) / 2;
      }
    }
    return representValue;
  };
  PiecewiseModel2.prototype.getVisualMeta = function(getColorVisual2) {
    if (this.isCategory()) {
      return;
    }
    var stops = [];
    var outerColors = ["", ""];
    var visualMapModel = this;
    function setStop(interval, valueState) {
      var representValue = visualMapModel.getRepresentValue({
        interval
      });
      if (!valueState) {
        valueState = visualMapModel.getValueState(representValue);
      }
      var color = getColorVisual2(representValue, valueState);
      if (interval[0] === -Infinity) {
        outerColors[0] = color;
      } else if (interval[1] === Infinity) {
        outerColors[1] = color;
      } else {
        stops.push({
          value: interval[0],
          color
        }, {
          value: interval[1],
          color
        });
      }
    }
    var pieceList = this._pieceList.slice();
    if (!pieceList.length) {
      pieceList.push({
        interval: [-Infinity, Infinity]
      });
    } else {
      var edge = pieceList[0].interval[0];
      edge !== -Infinity && pieceList.unshift({
        interval: [-Infinity, edge]
      });
      edge = pieceList[pieceList.length - 1].interval[1];
      edge !== Infinity && pieceList.push({
        interval: [edge, Infinity]
      });
    }
    var curr = -Infinity;
    each$g(pieceList, function(piece) {
      var interval = piece.interval;
      if (interval) {
        interval[0] > curr && setStop([curr, interval[0]], "outOfRange");
        setStop(interval.slice());
        curr = interval[1];
      }
    }, this);
    return {
      stops,
      outerColors
    };
  };
  PiecewiseModel2.type = "visualMap.piecewise";
  PiecewiseModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    selected: null,
    minOpen: false,
    maxOpen: false,
    align: "auto",
    itemWidth: 20,
    itemHeight: 14,
    itemSymbol: "roundRect",
    pieces: null,
    categories: null,
    splitNumber: 5,
    selectedMode: "multiple",
    itemGap: 10,
    hoverLink: true
  });
  return PiecewiseModel2;
}(VisualMapModel$1);
var resetMethods = {
  splitNumber: function(outPieceList) {
    var thisOption = this.option;
    var precision = Math.min(thisOption.precision, 20);
    var dataExtent = this.getExtent();
    var splitNumber = thisOption.splitNumber;
    splitNumber = Math.max(parseInt(splitNumber, 10), 1);
    thisOption.splitNumber = splitNumber;
    var splitStep = (dataExtent[1] - dataExtent[0]) / splitNumber;
    while (+splitStep.toFixed(precision) !== splitStep && precision < 5) {
      precision++;
    }
    thisOption.precision = precision;
    splitStep = +splitStep.toFixed(precision);
    if (thisOption.minOpen) {
      outPieceList.push({
        interval: [-Infinity, dataExtent[0]],
        close: [0, 0]
      });
    }
    for (var index2 = 0, curr = dataExtent[0]; index2 < splitNumber; curr += splitStep, index2++) {
      var max3 = index2 === splitNumber - 1 ? dataExtent[1] : curr + splitStep;
      outPieceList.push({
        interval: [curr, max3],
        close: [1, 1]
      });
    }
    if (thisOption.maxOpen) {
      outPieceList.push({
        interval: [dataExtent[1], Infinity],
        close: [0, 0]
      });
    }
    reformIntervals(outPieceList);
    each$g(outPieceList, function(piece, index3) {
      piece.index = index3;
      piece.text = this.formatValueText(piece.interval);
    }, this);
  },
  categories: function(outPieceList) {
    var thisOption = this.option;
    each$g(thisOption.categories, function(cate) {
      outPieceList.push({
        text: this.formatValueText(cate, true),
        value: cate
      });
    }, this);
    normalizeReverse(thisOption, outPieceList);
  },
  pieces: function(outPieceList) {
    var thisOption = this.option;
    each$g(thisOption.pieces, function(pieceListItem, index2) {
      if (!isObject$4(pieceListItem)) {
        pieceListItem = {
          value: pieceListItem
        };
      }
      var item = {
        text: "",
        index: index2
      };
      if (pieceListItem.label != null) {
        item.text = pieceListItem.label;
      }
      if (pieceListItem.hasOwnProperty("value")) {
        var value = item.value = pieceListItem.value;
        item.interval = [value, value];
        item.close = [1, 1];
      } else {
        var interval = item.interval = [];
        var close_1 = item.close = [0, 0];
        var closeList = [1, 0, 1];
        var infinityList = [-Infinity, Infinity];
        var useMinMax = [];
        for (var lg2 = 0; lg2 < 2; lg2++) {
          var names2 = [["gte", "gt", "min"], ["lte", "lt", "max"]][lg2];
          for (var i = 0; i < 3 && interval[lg2] == null; i++) {
            interval[lg2] = pieceListItem[names2[i]];
            close_1[lg2] = closeList[i];
            useMinMax[lg2] = i === 2;
          }
          interval[lg2] == null && (interval[lg2] = infinityList[lg2]);
        }
        useMinMax[0] && interval[1] === Infinity && (close_1[0] = 0);
        useMinMax[1] && interval[0] === -Infinity && (close_1[1] = 0);
        if (interval[0] === interval[1] && close_1[0] && close_1[1]) {
          item.value = interval[0];
        }
      }
      item.visual = VisualMapping$1.retrieveVisuals(pieceListItem);
      outPieceList.push(item);
    }, this);
    normalizeReverse(thisOption, outPieceList);
    reformIntervals(outPieceList);
    each$g(outPieceList, function(piece) {
      var close = piece.close;
      var edgeSymbols = [["<", "\u2264"][close[1]], [">", "\u2265"][close[0]]];
      piece.text = piece.text || this.formatValueText(piece.value != null ? piece.value : piece.interval, false, edgeSymbols);
    }, this);
  }
};
function normalizeReverse(thisOption, pieceList) {
  var inverse = thisOption.inverse;
  if (thisOption.orient === "vertical" ? !inverse : inverse) {
    pieceList.reverse();
  }
}
var PiecewiseModel$1 = PiecewiseModel;
var PiecewiseVisualMapView = function(_super) {
  __extends(PiecewiseVisualMapView2, _super);
  function PiecewiseVisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseVisualMapView2.type;
    return _this;
  }
  PiecewiseVisualMapView2.prototype.doRender = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var textStyleModel = visualMapModel.textStyleModel;
    var textFont = textStyleModel.getFont();
    var textFill = textStyleModel.getTextColor();
    var itemAlign = this._getItemAlign();
    var itemSize = visualMapModel.itemSize;
    var viewData = this._getViewData();
    var endsText = viewData.endsText;
    var showLabel = retrieve(visualMapModel.get("showLabel", true), !endsText);
    endsText && this._renderEndsText(thisGroup, endsText[0], itemSize, showLabel, itemAlign);
    each$g(viewData.viewPieceList, function(item) {
      var piece = item.piece;
      var itemGroup = new Group$6();
      itemGroup.onclick = bind$1(this._onItemClick, this, piece);
      this._enableHoverLink(itemGroup, item.indexInModelPieceList);
      var representValue = visualMapModel.getRepresentValue(piece);
      this._createItemSymbol(itemGroup, representValue, [0, 0, itemSize[0], itemSize[1]]);
      if (showLabel) {
        var visualState = this.visualMapModel.getValueState(representValue);
        itemGroup.add(new ZRText$1({
          style: {
            x: itemAlign === "right" ? -textGap : itemSize[0] + textGap,
            y: itemSize[1] / 2,
            text: piece.text,
            verticalAlign: "middle",
            align: itemAlign,
            font: textFont,
            fill: textFill,
            opacity: visualState === "outOfRange" ? 0.5 : 1
          }
        }));
      }
      thisGroup.add(itemGroup);
    }, this);
    endsText && this._renderEndsText(thisGroup, endsText[1], itemSize, showLabel, itemAlign);
    box(visualMapModel.get("orient"), thisGroup, visualMapModel.get("itemGap"));
    this.renderBackground(thisGroup);
    this.positionGroup(thisGroup);
  };
  PiecewiseVisualMapView2.prototype._enableHoverLink = function(itemGroup, pieceIndex) {
    var _this = this;
    itemGroup.on("mouseover", function() {
      return onHoverLink("highlight");
    }).on("mouseout", function() {
      return onHoverLink("downplay");
    });
    var onHoverLink = function(method4) {
      var visualMapModel = _this.visualMapModel;
      visualMapModel.option.hoverLink && _this.api.dispatchAction({
        type: method4,
        batch: makeHighDownBatch(visualMapModel.findTargetDataIndices(pieceIndex), visualMapModel)
      });
    };
  };
  PiecewiseVisualMapView2.prototype._getItemAlign = function() {
    var visualMapModel = this.visualMapModel;
    var modelOption = visualMapModel.option;
    if (modelOption.orient === "vertical") {
      return getItemAlign(visualMapModel, this.api, visualMapModel.itemSize);
    } else {
      var align = modelOption.align;
      if (!align || align === "auto") {
        align = "left";
      }
      return align;
    }
  };
  PiecewiseVisualMapView2.prototype._renderEndsText = function(group, text, itemSize, showLabel, itemAlign) {
    if (!text) {
      return;
    }
    var itemGroup = new Group$6();
    var textStyleModel = this.visualMapModel.textStyleModel;
    itemGroup.add(new ZRText$1({
      style: {
        x: showLabel ? itemAlign === "right" ? itemSize[0] : 0 : itemSize[0] / 2,
        y: itemSize[1] / 2,
        verticalAlign: "middle",
        align: showLabel ? itemAlign : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
    group.add(itemGroup);
  };
  PiecewiseVisualMapView2.prototype._getViewData = function() {
    var visualMapModel = this.visualMapModel;
    var viewPieceList = map$1(visualMapModel.getPieceList(), function(piece, index2) {
      return {
        piece,
        indexInModelPieceList: index2
      };
    });
    var endsText = visualMapModel.get("text");
    var orient = visualMapModel.get("orient");
    var inverse = visualMapModel.get("inverse");
    if (orient === "horizontal" ? inverse : !inverse) {
      viewPieceList.reverse();
    } else if (endsText) {
      endsText = endsText.slice().reverse();
    }
    return {
      viewPieceList,
      endsText
    };
  };
  PiecewiseVisualMapView2.prototype._createItemSymbol = function(group, representValue, shapeParam) {
    group.add(createSymbol$1(this.getControllerVisual(representValue, "symbol"), shapeParam[0], shapeParam[1], shapeParam[2], shapeParam[3], this.getControllerVisual(representValue, "color")));
  };
  PiecewiseVisualMapView2.prototype._onItemClick = function(piece) {
    var visualMapModel = this.visualMapModel;
    var option = visualMapModel.option;
    var selected = clone$4(option.selected);
    var newKey = visualMapModel.getSelectedMapKey(piece);
    if (option.selectedMode === "single") {
      selected[newKey] = true;
      each$g(selected, function(o, key) {
        selected[key] = key === newKey;
      });
    } else {
      selected[newKey] = !selected[newKey];
    }
    this.api.dispatchAction({
      type: "selectDataRange",
      from: this.uid,
      visualMapId: this.visualMapModel.id,
      selected
    });
  };
  PiecewiseVisualMapView2.type = "visualMap.piecewise";
  return PiecewiseVisualMapView2;
}(VisualMapView$1);
var PiecewiseView = PiecewiseVisualMapView;
function install$4(registers) {
  registers.registerComponentModel(PiecewiseModel$1);
  registers.registerComponentView(PiecewiseView);
  installCommon(registers);
}
function install$3(registers) {
  use(install$5);
  use(install$4);
}
var DEFAULT_OPTION = {
  label: {
    enabled: true
  },
  decal: {
    show: false
  }
};
var inner = makeInner();
var decalPaletteScope = {};
function ariaVisual(ecModel, api) {
  var ariaModel = ecModel.getModel("aria");
  if (!ariaModel.get("enabled")) {
    return;
  }
  var defaultOption2 = clone$4(DEFAULT_OPTION);
  merge(defaultOption2.label, ecModel.getLocaleModel().get("aria"), false);
  merge(ariaModel.option, defaultOption2, false);
  setDecal();
  setLabel();
  function setDecal() {
    var decalModel = ariaModel.getModel("decal");
    var useDecal = decalModel.get("show");
    if (useDecal) {
      var paletteScopeGroupByType_1 = createHashMap();
      ecModel.eachSeries(function(seriesModel) {
        if (seriesModel.isColorBySeries()) {
          return;
        }
        var decalScope = paletteScopeGroupByType_1.get(seriesModel.type);
        if (!decalScope) {
          decalScope = {};
          paletteScopeGroupByType_1.set(seriesModel.type, decalScope);
        }
        inner(seriesModel).scope = decalScope;
      });
      ecModel.eachRawSeries(function(seriesModel) {
        if (ecModel.isSeriesFiltered(seriesModel)) {
          return;
        }
        if (isFunction(seriesModel.enableAriaDecal)) {
          seriesModel.enableAriaDecal();
          return;
        }
        var data = seriesModel.getData();
        if (!seriesModel.isColorBySeries()) {
          var dataAll_1 = seriesModel.getRawData();
          var idxMap_1 = {};
          var decalScope_1 = inner(seriesModel).scope;
          data.each(function(idx) {
            var rawIdx = data.getRawIndex(idx);
            idxMap_1[rawIdx] = idx;
          });
          var dataCount_1 = dataAll_1.count();
          dataAll_1.each(function(rawIdx) {
            var idx = idxMap_1[rawIdx];
            var name = dataAll_1.getName(rawIdx) || rawIdx + "";
            var paletteDecal2 = getDecalFromPalette(seriesModel.ecModel, name, decalScope_1, dataCount_1);
            var specifiedDecal2 = data.getItemVisual(idx, "decal");
            data.setItemVisual(idx, "decal", mergeDecal(specifiedDecal2, paletteDecal2));
          });
        } else {
          var paletteDecal = getDecalFromPalette(seriesModel.ecModel, seriesModel.name, decalPaletteScope, ecModel.getSeriesCount());
          var specifiedDecal = data.getVisual("decal");
          data.setVisual("decal", mergeDecal(specifiedDecal, paletteDecal));
        }
        function mergeDecal(specifiedDecal2, paletteDecal2) {
          var resultDecal = specifiedDecal2 ? extend(extend({}, paletteDecal2), specifiedDecal2) : paletteDecal2;
          resultDecal.dirty = true;
          return resultDecal;
        }
      });
    }
  }
  function setLabel() {
    var labelLocale = ecModel.getLocaleModel().get("aria");
    var labelModel = ariaModel.getModel("label");
    labelModel.option = defaults(labelModel.option, labelLocale);
    if (!labelModel.get("enabled")) {
      return;
    }
    var dom = api.getZr().dom;
    if (labelModel.get("description")) {
      dom.setAttribute("aria-label", labelModel.get("description"));
      return;
    }
    var seriesCnt = ecModel.getSeriesCount();
    var maxDataCnt = labelModel.get(["data", "maxCount"]) || 10;
    var maxSeriesCnt = labelModel.get(["series", "maxCount"]) || 10;
    var displaySeriesCnt = Math.min(seriesCnt, maxSeriesCnt);
    var ariaLabel;
    if (seriesCnt < 1) {
      return;
    } else {
      var title = getTitle();
      if (title) {
        var withTitle = labelModel.get(["general", "withTitle"]);
        ariaLabel = replace(withTitle, {
          title
        });
      } else {
        ariaLabel = labelModel.get(["general", "withoutTitle"]);
      }
      var seriesLabels_1 = [];
      var prefix = seriesCnt > 1 ? labelModel.get(["series", "multiple", "prefix"]) : labelModel.get(["series", "single", "prefix"]);
      ariaLabel += replace(prefix, {
        seriesCount: seriesCnt
      });
      ecModel.eachSeries(function(seriesModel, idx) {
        if (idx < displaySeriesCnt) {
          var seriesLabel = void 0;
          var seriesName = seriesModel.get("name");
          var withName = seriesName ? "withName" : "withoutName";
          seriesLabel = seriesCnt > 1 ? labelModel.get(["series", "multiple", withName]) : labelModel.get(["series", "single", withName]);
          seriesLabel = replace(seriesLabel, {
            seriesId: seriesModel.seriesIndex,
            seriesName: seriesModel.get("name"),
            seriesType: getSeriesTypeName(seriesModel.subType)
          });
          var data = seriesModel.getData();
          if (data.count() > maxDataCnt) {
            var partialLabel = labelModel.get(["data", "partialData"]);
            seriesLabel += replace(partialLabel, {
              displayCnt: maxDataCnt
            });
          } else {
            seriesLabel += labelModel.get(["data", "allData"]);
          }
          var middleSeparator_1 = labelModel.get(["data", "separator", "middle"]);
          var endSeparator_1 = labelModel.get(["data", "separator", "end"]);
          var dataLabels = [];
          for (var i = 0; i < data.count(); i++) {
            if (i < maxDataCnt) {
              var name_1 = data.getName(i);
              var value = data.getValues(i);
              var dataLabel = labelModel.get(["data", name_1 ? "withName" : "withoutName"]);
              dataLabels.push(replace(dataLabel, {
                name: name_1,
                value: value.join(middleSeparator_1)
              }));
            }
          }
          seriesLabel += dataLabels.join(middleSeparator_1) + endSeparator_1;
          seriesLabels_1.push(seriesLabel);
        }
      });
      var separatorModel = labelModel.getModel(["series", "multiple", "separator"]);
      var middleSeparator = separatorModel.get("middle");
      var endSeparator = separatorModel.get("end");
      ariaLabel += seriesLabels_1.join(middleSeparator) + endSeparator;
      dom.setAttribute("aria-label", ariaLabel);
    }
  }
  function replace(str, keyValues) {
    if (!isString$1(str)) {
      return str;
    }
    var result = str;
    each$g(keyValues, function(value, key) {
      result = result.replace(new RegExp("\\{\\s*" + key + "\\s*\\}", "g"), value);
    });
    return result;
  }
  function getTitle() {
    var title = ecModel.get("title");
    if (title && title.length) {
      title = title[0];
    }
    return title && title.text;
  }
  function getSeriesTypeName(type4) {
    return ecModel.getLocaleModel().get(["series", "typeNames"])[type4] || "\u81EA\u5B9A\u4E49\u56FE";
  }
}
function ariaPreprocessor(option) {
  if (!option || !option.aria) {
    return;
  }
  var aria = option.aria;
  if (aria.show != null) {
    aria.enabled = aria.show;
  }
  aria.label = aria.label || {};
  each$g(["description", "general", "series", "data"], function(name) {
    if (aria[name] != null) {
      aria.label[name] = aria[name];
    }
  });
}
function install$2(registers) {
  registers.registerPreprocessor(ariaPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.ARIA, ariaVisual);
}
var RELATIONAL_EXPRESSION_OP_ALIAS_MAP = {
  value: "eq",
  "<": "lt",
  "<=": "lte",
  ">": "gt",
  ">=": "gte",
  "=": "eq",
  "!=": "ne",
  "<>": "ne"
};
var RegExpEvaluator = function() {
  function RegExpEvaluator2(rVal) {
    var condValue = this._condVal = isString$1(rVal) ? new RegExp(rVal) : isRegExp(rVal) ? rVal : null;
    if (condValue == null) {
      var errMsg = "";
      throwError(errMsg);
    }
  }
  RegExpEvaluator2.prototype.evaluate = function(lVal) {
    var type4 = typeof lVal;
    return isString$1(type4) ? this._condVal.test(lVal) : isNumber(type4) ? this._condVal.test(lVal + "") : false;
  };
  return RegExpEvaluator2;
}();
var ConstConditionInternal = function() {
  function ConstConditionInternal2() {
  }
  ConstConditionInternal2.prototype.evaluate = function() {
    return this.value;
  };
  return ConstConditionInternal2;
}();
var AndConditionInternal = function() {
  function AndConditionInternal2() {
  }
  AndConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (!children[i].evaluate()) {
        return false;
      }
    }
    return true;
  };
  return AndConditionInternal2;
}();
var OrConditionInternal = function() {
  function OrConditionInternal2() {
  }
  OrConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].evaluate()) {
        return true;
      }
    }
    return false;
  };
  return OrConditionInternal2;
}();
var NotConditionInternal = function() {
  function NotConditionInternal2() {
  }
  NotConditionInternal2.prototype.evaluate = function() {
    return !this.child.evaluate();
  };
  return NotConditionInternal2;
}();
var RelationalConditionInternal = function() {
  function RelationalConditionInternal2() {
  }
  RelationalConditionInternal2.prototype.evaluate = function() {
    var needParse = !!this.valueParser;
    var getValue2 = this.getValue;
    var tarValRaw = getValue2(this.valueGetterParam);
    var tarValParsed = needParse ? this.valueParser(tarValRaw) : null;
    for (var i = 0; i < this.subCondList.length; i++) {
      if (!this.subCondList[i].evaluate(needParse ? tarValParsed : tarValRaw)) {
        return false;
      }
    }
    return true;
  };
  return RelationalConditionInternal2;
}();
function parseOption(exprOption, getters) {
  if (exprOption === true || exprOption === false) {
    var cond = new ConstConditionInternal();
    cond.value = exprOption;
    return cond;
  }
  var errMsg = "";
  if (!isObjectNotArray(exprOption)) {
    throwError(errMsg);
  }
  if (exprOption.and) {
    return parseAndOrOption("and", exprOption, getters);
  } else if (exprOption.or) {
    return parseAndOrOption("or", exprOption, getters);
  } else if (exprOption.not) {
    return parseNotOption(exprOption, getters);
  }
  return parseRelationalOption(exprOption, getters);
}
function parseAndOrOption(op, exprOption, getters) {
  var subOptionArr = exprOption[op];
  var errMsg = "";
  if (!isArray$1(subOptionArr)) {
    throwError(errMsg);
  }
  if (!subOptionArr.length) {
    throwError(errMsg);
  }
  var cond = op === "and" ? new AndConditionInternal() : new OrConditionInternal();
  cond.children = map$1(subOptionArr, function(subOption) {
    return parseOption(subOption, getters);
  });
  if (!cond.children.length) {
    throwError(errMsg);
  }
  return cond;
}
function parseNotOption(exprOption, getters) {
  var subOption = exprOption.not;
  var errMsg = "";
  if (!isObjectNotArray(subOption)) {
    throwError(errMsg);
  }
  var cond = new NotConditionInternal();
  cond.child = parseOption(subOption, getters);
  if (!cond.child) {
    throwError(errMsg);
  }
  return cond;
}
function parseRelationalOption(exprOption, getters) {
  var errMsg = "";
  var valueGetterParam = getters.prepareGetValue(exprOption);
  var subCondList = [];
  var exprKeys = keys(exprOption);
  var parserName = exprOption.parser;
  var valueParser = parserName ? getRawValueParser(parserName) : null;
  for (var i = 0; i < exprKeys.length; i++) {
    var keyRaw = exprKeys[i];
    if (keyRaw === "parser" || getters.valueGetterAttrMap.get(keyRaw)) {
      continue;
    }
    var op = hasOwn(RELATIONAL_EXPRESSION_OP_ALIAS_MAP, keyRaw) ? RELATIONAL_EXPRESSION_OP_ALIAS_MAP[keyRaw] : keyRaw;
    var condValueRaw = exprOption[keyRaw];
    var condValueParsed = valueParser ? valueParser(condValueRaw) : condValueRaw;
    var evaluator = createFilterComparator(op, condValueParsed) || op === "reg" && new RegExpEvaluator(condValueParsed);
    if (!evaluator) {
      throwError(errMsg);
    }
    subCondList.push(evaluator);
  }
  if (!subCondList.length) {
    throwError(errMsg);
  }
  var cond = new RelationalConditionInternal();
  cond.valueGetterParam = valueGetterParam;
  cond.valueParser = valueParser;
  cond.getValue = getters.getValue;
  cond.subCondList = subCondList;
  return cond;
}
function isObjectNotArray(val) {
  return isObject$4(val) && !isArrayLike(val);
}
var ConditionalExpressionParsed = function() {
  function ConditionalExpressionParsed2(exprOption, getters) {
    this._cond = parseOption(exprOption, getters);
  }
  ConditionalExpressionParsed2.prototype.evaluate = function() {
    return this._cond.evaluate();
  };
  return ConditionalExpressionParsed2;
}();
function parseConditionalExpression(exprOption, getters) {
  return new ConditionalExpressionParsed(exprOption, getters);
}
var filterTransform = {
  type: "echarts:filter",
  transform: function(params) {
    var upstream = params.upstream;
    var rawItem;
    var condition = parseConditionalExpression(params.config, {
      valueGetterAttrMap: createHashMap({
        dimension: true
      }),
      prepareGetValue: function(exprOption) {
        var errMsg = "";
        var dimLoose = exprOption.dimension;
        if (!hasOwn(exprOption, "dimension")) {
          throwError(errMsg);
        }
        var dimInfo = upstream.getDimensionInfo(dimLoose);
        if (!dimInfo) {
          throwError(errMsg);
        }
        return {
          dimIdx: dimInfo.index
        };
      },
      getValue: function(param) {
        return upstream.retrieveValueFromItem(rawItem, param.dimIdx);
      }
    });
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      rawItem = upstream.getRawDataItem(i);
      if (condition.evaluate()) {
        resultData.push(rawItem);
      }
    }
    return {
      data: resultData
    };
  }
};
var sortTransform = {
  type: "echarts:sort",
  transform: function(params) {
    var upstream = params.upstream;
    var config = params.config;
    var errMsg = "";
    var orderExprList = normalizeToArray(config);
    if (!orderExprList.length) {
      throwError(errMsg);
    }
    var orderDefList = [];
    each$g(orderExprList, function(orderExpr) {
      var dimLoose = orderExpr.dimension;
      var order = orderExpr.order;
      var parserName = orderExpr.parser;
      var incomparable = orderExpr.incomparable;
      if (dimLoose == null) {
        throwError(errMsg);
      }
      if (order !== "asc" && order !== "desc") {
        throwError(errMsg);
      }
      if (incomparable && incomparable !== "min" && incomparable !== "max") {
        var errMsg_1 = "";
        throwError(errMsg_1);
      }
      if (order !== "asc" && order !== "desc") {
        var errMsg_2 = "";
        throwError(errMsg_2);
      }
      var dimInfo = upstream.getDimensionInfo(dimLoose);
      if (!dimInfo) {
        throwError(errMsg);
      }
      var parser = parserName ? getRawValueParser(parserName) : null;
      if (parserName && !parser) {
        throwError(errMsg);
      }
      orderDefList.push({
        dimIdx: dimInfo.index,
        parser,
        comparator: new SortOrderComparator(order, incomparable)
      });
    });
    var sourceFormat = upstream.sourceFormat;
    if (sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS && sourceFormat !== SOURCE_FORMAT_OBJECT_ROWS) {
      throwError(errMsg);
    }
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      resultData.push(upstream.getRawDataItem(i));
    }
    resultData.sort(function(item0, item1) {
      for (var i2 = 0; i2 < orderDefList.length; i2++) {
        var orderDef = orderDefList[i2];
        var val0 = upstream.retrieveValueFromItem(item0, orderDef.dimIdx);
        var val1 = upstream.retrieveValueFromItem(item1, orderDef.dimIdx);
        if (orderDef.parser) {
          val0 = orderDef.parser(val0);
          val1 = orderDef.parser(val1);
        }
        var result = orderDef.comparator.evaluate(val0, val1);
        if (result !== 0) {
          return result;
        }
      }
      return 0;
    });
    return {
      data: resultData
    };
  }
};
function install$1(registers) {
  registers.registerTransform(filterTransform);
  registers.registerTransform(sortTransform);
}
var DatasetModel = function(_super) {
  __extends(DatasetModel2, _super);
  function DatasetModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetModel2.prototype.init = function(option, parentModel, ecModel) {
    _super.prototype.init.call(this, option, parentModel, ecModel);
    this._sourceManager = new SourceManager(this);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.mergeOption = function(newOption, ecModel) {
    _super.prototype.mergeOption.call(this, newOption, ecModel);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.optionUpdated = function() {
    this._sourceManager.dirty();
  };
  DatasetModel2.prototype.getSourceManager = function() {
    return this._sourceManager;
  };
  DatasetModel2.type = "dataset";
  DatasetModel2.defaultOption = {
    seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN
  };
  return DatasetModel2;
}(ComponentModel$1);
var DatasetView = function(_super) {
  __extends(DatasetView2, _super);
  function DatasetView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetView2.type = "dataset";
  return DatasetView2;
}(ComponentView$1);
function install(registers) {
  registers.registerComponentModel(DatasetModel);
  registers.registerComponentView(DatasetView);
}
var CMD = PathProxy$1.CMD;
function aroundEqual(a, b2) {
  return Math.abs(a - b2) < 1e-5;
}
function pathToBezierCurves(path) {
  var data = path.data;
  var len2 = path.len();
  var bezierArrayGroups = [];
  var currentSubpath;
  var xi2 = 0;
  var yi2 = 0;
  var x0 = 0;
  var y0 = 0;
  function createNewSubpath(x3, y3) {
    if (currentSubpath && currentSubpath.length > 2) {
      bezierArrayGroups.push(currentSubpath);
    }
    currentSubpath = [x3, y3];
  }
  function addLine(x02, y02, x12, y12) {
    if (!(aroundEqual(x02, x12) && aroundEqual(y02, y12))) {
      currentSubpath.push(x02, y02, x12, y12, x12, y12);
    }
  }
  function addArc(startAngle2, endAngle2, cx2, cy2, rx2, ry2) {
    var delta = Math.abs(endAngle2 - startAngle2);
    var len3 = Math.tan(delta / 4) * 4 / 3;
    var dir3 = endAngle2 < startAngle2 ? -1 : 1;
    var c1 = Math.cos(startAngle2);
    var s1 = Math.sin(startAngle2);
    var c2 = Math.cos(endAngle2);
    var s2 = Math.sin(endAngle2);
    var x12 = c1 * rx2 + cx2;
    var y12 = s1 * ry2 + cy2;
    var x4 = c2 * rx2 + cx2;
    var y4 = s2 * ry2 + cy2;
    var hx = rx2 * len3 * dir3;
    var hy = ry2 * len3 * dir3;
    currentSubpath.push(x12 - hx * s1, y12 + hy * c1, x4 + hx * s2, y4 - hy * c2, x4, y4);
  }
  var x1;
  var y1;
  var x2;
  var y2;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (isFirst) {
      xi2 = data[i];
      yi2 = data[i + 1];
      x0 = xi2;
      y0 = yi2;
      if (cmd === CMD.L || cmd === CMD.C || cmd === CMD.Q) {
        currentSubpath = [x0, y0];
      }
    }
    switch (cmd) {
      case CMD.M:
        xi2 = x0 = data[i++];
        yi2 = y0 = data[i++];
        createNewSubpath(x0, y0);
        break;
      case CMD.L:
        x1 = data[i++];
        y1 = data[i++];
        addLine(xi2, yi2, x1, y1);
        xi2 = x1;
        yi2 = y1;
        break;
      case CMD.C:
        currentSubpath.push(data[i++], data[i++], data[i++], data[i++], xi2 = data[i++], yi2 = data[i++]);
        break;
      case CMD.Q:
        x1 = data[i++];
        y1 = data[i++];
        x2 = data[i++];
        y2 = data[i++];
        currentSubpath.push(xi2 + 2 / 3 * (x1 - xi2), yi2 + 2 / 3 * (y1 - yi2), x2 + 2 / 3 * (x1 - x2), y2 + 2 / 3 * (y1 - y2), x2, y2);
        xi2 = x2;
        yi2 = y2;
        break;
      case CMD.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var startAngle = data[i++];
        var endAngle = data[i++] + startAngle;
        i += 1;
        var anticlockwise = !data[i++];
        x1 = Math.cos(startAngle) * rx + cx;
        y1 = Math.sin(startAngle) * ry + cy;
        if (isFirst) {
          x0 = x1;
          y0 = y1;
          createNewSubpath(x0, y0);
        } else {
          addLine(xi2, yi2, x1, y1);
        }
        xi2 = Math.cos(endAngle) * rx + cx;
        yi2 = Math.sin(endAngle) * ry + cy;
        var step = (anticlockwise ? -1 : 1) * Math.PI / 2;
        for (var angle = startAngle; anticlockwise ? angle > endAngle : angle < endAngle; angle += step) {
          var nextAngle = anticlockwise ? Math.max(angle + step, endAngle) : Math.min(angle + step, endAngle);
          addArc(angle, nextAngle, cx, cy, rx, ry);
        }
        break;
      case CMD.R:
        x0 = xi2 = data[i++];
        y0 = yi2 = data[i++];
        x1 = x0 + data[i++];
        y1 = y0 + data[i++];
        createNewSubpath(x1, y0);
        addLine(x1, y0, x1, y1);
        addLine(x1, y1, x0, y1);
        addLine(x0, y1, x0, y0);
        addLine(x0, y0, x1, y0);
        break;
      case CMD.Z:
        currentSubpath && addLine(xi2, yi2, x0, y0);
        xi2 = x0;
        yi2 = y0;
        break;
    }
  }
  if (currentSubpath && currentSubpath.length > 2) {
    bezierArrayGroups.push(currentSubpath);
  }
  return bezierArrayGroups;
}
function adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, out2, scale2) {
  if (aroundEqual(x0, x1) && aroundEqual(y0, y1) && aroundEqual(x2, x3) && aroundEqual(y2, y3)) {
    out2.push(x3, y3);
    return;
  }
  var PIXEL_DISTANCE = 2 / scale2;
  var PIXEL_DISTANCE_SQR = PIXEL_DISTANCE * PIXEL_DISTANCE;
  var dx = x3 - x0;
  var dy = y3 - y0;
  var d2 = Math.sqrt(dx * dx + dy * dy);
  dx /= d2;
  dy /= d2;
  var dx1 = x1 - x0;
  var dy1 = y1 - y0;
  var dx2 = x2 - x3;
  var dy2 = y2 - y3;
  var cp1LenSqr = dx1 * dx1 + dy1 * dy1;
  var cp2LenSqr = dx2 * dx2 + dy2 * dy2;
  if (cp1LenSqr < PIXEL_DISTANCE_SQR && cp2LenSqr < PIXEL_DISTANCE_SQR) {
    out2.push(x3, y3);
    return;
  }
  var projLen1 = dx * dx1 + dy * dy1;
  var projLen2 = -dx * dx2 - dy * dy2;
  var d1Sqr = cp1LenSqr - projLen1 * projLen1;
  var d2Sqr = cp2LenSqr - projLen2 * projLen2;
  if (d1Sqr < PIXEL_DISTANCE_SQR && projLen1 >= 0 && d2Sqr < PIXEL_DISTANCE_SQR && projLen2 >= 0) {
    out2.push(x3, y3);
    return;
  }
  var tmpSegX = [];
  var tmpSegY = [];
  cubicSubdivide(x0, x1, x2, x3, 0.5, tmpSegX);
  cubicSubdivide(y0, y1, y2, y3, 0.5, tmpSegY);
  adpativeBezier(tmpSegX[0], tmpSegY[0], tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], tmpSegX[3], tmpSegY[3], out2, scale2);
  adpativeBezier(tmpSegX[4], tmpSegY[4], tmpSegX[5], tmpSegY[5], tmpSegX[6], tmpSegY[6], tmpSegX[7], tmpSegY[7], out2, scale2);
}
function pathToPolygons(path, scale2) {
  var bezierArrayGroups = pathToBezierCurves(path);
  var polygons = [];
  scale2 = scale2 || 1;
  for (var i = 0; i < bezierArrayGroups.length; i++) {
    var beziers = bezierArrayGroups[i];
    var polygon = [];
    var x0 = beziers[0];
    var y0 = beziers[1];
    polygon.push(x0, y0);
    for (var k2 = 2; k2 < beziers.length; ) {
      var x1 = beziers[k2++];
      var y1 = beziers[k2++];
      var x2 = beziers[k2++];
      var y2 = beziers[k2++];
      var x3 = beziers[k2++];
      var y3 = beziers[k2++];
      adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, polygon, scale2);
      x0 = x3;
      y0 = y3;
    }
    polygons.push(polygon);
  }
  return polygons;
}
function getDividingGrids(dimSize, rowDim, count2) {
  var rowSize = dimSize[rowDim];
  var columnSize = dimSize[1 - rowDim];
  var ratio = Math.abs(rowSize / columnSize);
  var rowCount = Math.ceil(Math.sqrt(ratio * count2));
  var columnCount = Math.floor(count2 / rowCount);
  if (columnCount === 0) {
    columnCount = 1;
    rowCount = count2;
  }
  var grids = [];
  for (var i = 0; i < rowCount; i++) {
    grids.push(columnCount);
  }
  var currentCount = rowCount * columnCount;
  var remained = count2 - currentCount;
  if (remained > 0) {
    for (var i = 0; i < remained; i++) {
      grids[i % rowCount] += 1;
    }
  }
  return grids;
}
function divideSector(sectorShape, count2, outShapes) {
  var r0 = sectorShape.r0;
  var r2 = sectorShape.r;
  var startAngle = sectorShape.startAngle;
  var endAngle = sectorShape.endAngle;
  var angle = Math.abs(endAngle - startAngle);
  var arcLen = angle * r2;
  var deltaR = r2 - r0;
  var isAngleRow = arcLen > Math.abs(deltaR);
  var grids = getDividingGrids([arcLen, deltaR], isAngleRow ? 0 : 1, count2);
  var rowSize = (isAngleRow ? angle : deltaR) / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = (isAngleRow ? deltaR : angle) / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      if (isAngleRow) {
        newShape.startAngle = startAngle + rowSize * row;
        newShape.endAngle = startAngle + rowSize * (row + 1);
        newShape.r0 = r0 + columnSize * column;
        newShape.r = r0 + columnSize * (column + 1);
      } else {
        newShape.startAngle = startAngle + columnSize * column;
        newShape.endAngle = startAngle + columnSize * (column + 1);
        newShape.r0 = r0 + rowSize * row;
        newShape.r = r0 + rowSize * (row + 1);
      }
      newShape.clockwise = sectorShape.clockwise;
      newShape.cx = sectorShape.cx;
      newShape.cy = sectorShape.cy;
      outShapes.push(newShape);
    }
  }
}
function divideRect(rectShape, count2, outShapes) {
  var width = rectShape.width;
  var height = rectShape.height;
  var isHorizontalRow = width > height;
  var grids = getDividingGrids([width, height], isHorizontalRow ? 0 : 1, count2);
  var rowSizeDim = isHorizontalRow ? "width" : "height";
  var columnSizeDim = isHorizontalRow ? "height" : "width";
  var rowDim = isHorizontalRow ? "x" : "y";
  var columnDim = isHorizontalRow ? "y" : "x";
  var rowSize = rectShape[rowSizeDim] / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = rectShape[columnSizeDim] / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      newShape[rowDim] = row * rowSize;
      newShape[columnDim] = column * columnSize;
      newShape[rowSizeDim] = rowSize;
      newShape[columnSizeDim] = columnSize;
      newShape.x += rectShape.x;
      newShape.y += rectShape.y;
      outShapes.push(newShape);
    }
  }
}
function crossProduct2d(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function lineLineIntersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d(nx, ny, mx, my);
  if (Math.abs(nmCrossProduct) < 1e-6) {
    return null;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var p2 = crossProduct2d(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return null;
  }
  return new Point$1(p2 * mx + a1x, p2 * my + a1y);
}
function projPtOnLine(pt, lineA, lineB) {
  var dir3 = new Point$1();
  Point$1.sub(dir3, lineB, lineA);
  dir3.normalize();
  var dir22 = new Point$1();
  Point$1.sub(dir22, pt, lineA);
  var len2 = dir22.dot(dir3);
  return len2;
}
function addToPoly(poly, pt) {
  var last = poly[poly.length - 1];
  if (last && last[0] === pt[0] && last[1] === pt[1]) {
    return;
  }
  poly.push(pt);
}
function splitPolygonByLine(points2, lineA, lineB) {
  var len2 = points2.length;
  var intersections = [];
  for (var i = 0; i < len2; i++) {
    var p0 = points2[i];
    var p1 = points2[(i + 1) % len2];
    var intersectionPt = lineLineIntersect(p0[0], p0[1], p1[0], p1[1], lineA.x, lineA.y, lineB.x, lineB.y);
    if (intersectionPt) {
      intersections.push({
        projPt: projPtOnLine(intersectionPt, lineA, lineB),
        pt: intersectionPt,
        idx: i
      });
    }
  }
  if (intersections.length < 2) {
    return [{ points: points2 }, { points: points2 }];
  }
  intersections.sort(function(a, b2) {
    return a.projPt - b2.projPt;
  });
  var splitPt0 = intersections[0];
  var splitPt1 = intersections[intersections.length - 1];
  if (splitPt1.idx < splitPt0.idx) {
    var tmp = splitPt0;
    splitPt0 = splitPt1;
    splitPt1 = tmp;
  }
  var splitPt0Arr = [splitPt0.pt.x, splitPt0.pt.y];
  var splitPt1Arr = [splitPt1.pt.x, splitPt1.pt.y];
  var newPolyA = [splitPt0Arr];
  var newPolyB = [splitPt1Arr];
  for (var i = splitPt0.idx + 1; i <= splitPt1.idx; i++) {
    addToPoly(newPolyA, points2[i].slice());
  }
  addToPoly(newPolyA, splitPt1Arr);
  addToPoly(newPolyA, splitPt0Arr);
  for (var i = splitPt1.idx + 1; i <= splitPt0.idx + len2; i++) {
    addToPoly(newPolyB, points2[i % len2].slice());
  }
  addToPoly(newPolyB, splitPt0Arr);
  addToPoly(newPolyB, splitPt1Arr);
  return [{
    points: newPolyA
  }, {
    points: newPolyB
  }];
}
function binaryDividePolygon(polygonShape) {
  var points2 = polygonShape.points;
  var min3 = [];
  var max3 = [];
  fromPoints(points2, min3, max3);
  var boundingRect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
  var width = boundingRect.width;
  var height = boundingRect.height;
  var x2 = boundingRect.x;
  var y2 = boundingRect.y;
  var pt02 = new Point$1();
  var pt12 = new Point$1();
  if (width > height) {
    pt02.x = pt12.x = x2 + width / 2;
    pt02.y = y2;
    pt12.y = y2 + height;
  } else {
    pt02.y = pt12.y = y2 + height / 2;
    pt02.x = x2;
    pt12.x = x2 + width;
  }
  return splitPolygonByLine(points2, pt02, pt12);
}
function binaryDivideRecursive(divider, shape, count2, out2) {
  if (count2 === 1) {
    out2.push(shape);
  } else {
    var mid = Math.floor(count2 / 2);
    var sub2 = divider(shape);
    binaryDivideRecursive(divider, sub2[0], mid, out2);
    binaryDivideRecursive(divider, sub2[1], count2 - mid, out2);
  }
  return out2;
}
function clone(path, count2) {
  var paths = [];
  for (var i = 0; i < count2; i++) {
    paths.push(clonePath(path));
  }
  return paths;
}
function copyPathProps(source, target) {
  target.setStyle(source.style);
  target.z = source.z;
  target.z2 = source.z2;
  target.zlevel = source.zlevel;
}
function polygonConvert(points2) {
  var out2 = [];
  for (var i = 0; i < points2.length; ) {
    out2.push([points2[i++], points2[i++]]);
  }
  return out2;
}
function split(path, count2) {
  var outShapes = [];
  var shape = path.shape;
  var OutShapeCtor;
  switch (path.type) {
    case "rect":
      divideRect(shape, count2, outShapes);
      OutShapeCtor = Rect$3;
      break;
    case "sector":
      divideSector(shape, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    case "circle":
      divideSector({
        r0: 0,
        r: shape.r,
        startAngle: 0,
        endAngle: Math.PI * 2,
        cx: shape.cx,
        cy: shape.cy
      }, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    default:
      var m2 = path.getComputedTransform();
      var scale2 = m2 ? Math.sqrt(Math.max(m2[0] * m2[0] + m2[1] * m2[1], m2[2] * m2[2] + m2[3] * m2[3])) : 1;
      var polygons = map$1(pathToPolygons(path.getUpdatedPathProxy(), scale2), function(poly) {
        return polygonConvert(poly);
      });
      var polygonCount = polygons.length;
      if (polygonCount === 0) {
        binaryDivideRecursive(binaryDividePolygon, {
          points: polygons[0]
        }, count2, outShapes);
      } else if (polygonCount === count2) {
        for (var i = 0; i < polygonCount; i++) {
          outShapes.push({
            points: polygons[i]
          });
        }
      } else {
        var totalArea_1 = 0;
        var items = map$1(polygons, function(poly) {
          var min3 = [];
          var max3 = [];
          fromPoints(poly, min3, max3);
          var area = (max3[1] - min3[1]) * (max3[0] - min3[0]);
          totalArea_1 += area;
          return { poly, area };
        });
        items.sort(function(a, b2) {
          return b2.area - a.area;
        });
        var left = count2;
        for (var i = 0; i < polygonCount; i++) {
          var item = items[i];
          if (left <= 0) {
            break;
          }
          var selfCount = i === polygonCount - 1 ? left : Math.ceil(item.area / totalArea_1 * count2);
          if (selfCount < 0) {
            continue;
          }
          binaryDivideRecursive(binaryDividePolygon, {
            points: item.poly
          }, selfCount, outShapes);
          left -= selfCount;
        }
      }
      OutShapeCtor = Polygon$1;
      break;
  }
  if (!OutShapeCtor) {
    return clone(path, count2);
  }
  var out2 = [];
  for (var i = 0; i < outShapes.length; i++) {
    var subPath = new OutShapeCtor();
    subPath.setShape(outShapes[i]);
    copyPathProps(path, subPath);
    out2.push(subPath);
  }
  return out2;
}
function alignSubpath(subpath1, subpath2) {
  var len1 = subpath1.length;
  var len2 = subpath2.length;
  if (len1 === len2) {
    return [subpath1, subpath2];
  }
  var tmpSegX = [];
  var tmpSegY = [];
  var shorterPath = len1 < len2 ? subpath1 : subpath2;
  var shorterLen = Math.min(len1, len2);
  var diff = Math.abs(len2 - len1) / 6;
  var shorterBezierCount = (shorterLen - 2) / 6;
  var eachCurveSubDivCount = Math.ceil(diff / shorterBezierCount) + 1;
  var newSubpath = [shorterPath[0], shorterPath[1]];
  var remained = diff;
  for (var i = 2; i < shorterLen; ) {
    var x0 = shorterPath[i - 2];
    var y0 = shorterPath[i - 1];
    var x1 = shorterPath[i++];
    var y1 = shorterPath[i++];
    var x2 = shorterPath[i++];
    var y2 = shorterPath[i++];
    var x3 = shorterPath[i++];
    var y3 = shorterPath[i++];
    if (remained <= 0) {
      newSubpath.push(x1, y1, x2, y2, x3, y3);
      continue;
    }
    var actualSubDivCount = Math.min(remained, eachCurveSubDivCount - 1) + 1;
    for (var k2 = 1; k2 <= actualSubDivCount; k2++) {
      var p2 = k2 / actualSubDivCount;
      cubicSubdivide(x0, x1, x2, x3, p2, tmpSegX);
      cubicSubdivide(y0, y1, y2, y3, p2, tmpSegY);
      x0 = tmpSegX[3];
      y0 = tmpSegY[3];
      newSubpath.push(tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], x0, y0);
      x1 = tmpSegX[5];
      y1 = tmpSegY[5];
      x2 = tmpSegX[6];
      y2 = tmpSegY[6];
    }
    remained -= actualSubDivCount - 1;
  }
  return shorterPath === subpath1 ? [newSubpath, subpath2] : [subpath1, newSubpath];
}
function createSubpath(lastSubpathSubpath, otherSubpath) {
  var len2 = lastSubpathSubpath.length;
  var lastX = lastSubpathSubpath[len2 - 2];
  var lastY = lastSubpathSubpath[len2 - 1];
  var newSubpath = [];
  for (var i = 0; i < otherSubpath.length; ) {
    newSubpath[i++] = lastX;
    newSubpath[i++] = lastY;
  }
  return newSubpath;
}
function alignBezierCurves(array1, array22) {
  var _a2;
  var lastSubpath1;
  var lastSubpath2;
  var newArray1 = [];
  var newArray2 = [];
  for (var i = 0; i < Math.max(array1.length, array22.length); i++) {
    var subpath1 = array1[i];
    var subpath2 = array22[i];
    var newSubpath1 = void 0;
    var newSubpath2 = void 0;
    if (!subpath1) {
      newSubpath1 = createSubpath(lastSubpath1 || subpath2, subpath2);
      newSubpath2 = subpath2;
    } else if (!subpath2) {
      newSubpath2 = createSubpath(lastSubpath2 || subpath1, subpath1);
      newSubpath1 = subpath1;
    } else {
      _a2 = alignSubpath(subpath1, subpath2), newSubpath1 = _a2[0], newSubpath2 = _a2[1];
      lastSubpath1 = newSubpath1;
      lastSubpath2 = newSubpath2;
    }
    newArray1.push(newSubpath1);
    newArray2.push(newSubpath2);
  }
  return [newArray1, newArray2];
}
function centroid(array4) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = array4.length;
  for (var i = 0, j = len2 - 2; i < len2; j = i, i += 2) {
    var x0 = array4[j];
    var y0 = array4[j + 1];
    var x1 = array4[i];
    var y1 = array4[i + 1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
  }
  if (signedArea === 0) {
    return [array4[0] || 0, array4[1] || 0];
  }
  return [cx / signedArea / 3, cy / signedArea / 3, signedArea];
}
function findBestRingOffset(fromSubBeziers, toSubBeziers, fromCp, toCp) {
  var bezierCount = (fromSubBeziers.length - 2) / 6;
  var bestScore = Infinity;
  var bestOffset = 0;
  var len2 = fromSubBeziers.length;
  var len22 = len2 - 2;
  for (var offset2 = 0; offset2 < bezierCount; offset2++) {
    var cursorOffset = offset2 * 6;
    var score = 0;
    for (var k2 = 0; k2 < len2; k2 += 2) {
      var idx = k2 === 0 ? cursorOffset : (cursorOffset + k2 - 2) % len22 + 2;
      var x0 = fromSubBeziers[idx] - fromCp[0];
      var y0 = fromSubBeziers[idx + 1] - fromCp[1];
      var x1 = toSubBeziers[k2] - toCp[0];
      var y1 = toSubBeziers[k2 + 1] - toCp[1];
      var dx = x1 - x0;
      var dy = y1 - y0;
      score += dx * dx + dy * dy;
    }
    if (score < bestScore) {
      bestScore = score;
      bestOffset = offset2;
    }
  }
  return bestOffset;
}
function reverse(array4) {
  var newArr = [];
  var len2 = array4.length;
  for (var i = 0; i < len2; i += 2) {
    newArr[i] = array4[len2 - i - 2];
    newArr[i + 1] = array4[len2 - i - 1];
  }
  return newArr;
}
function findBestMorphingRotation(fromArr, toArr2, searchAngleIteration, searchAngleRange) {
  var result = [];
  var fromNeedsReverse;
  for (var i = 0; i < fromArr.length; i++) {
    var fromSubpathBezier = fromArr[i];
    var toSubpathBezier = toArr2[i];
    var fromCp = centroid(fromSubpathBezier);
    var toCp = centroid(toSubpathBezier);
    if (fromNeedsReverse == null) {
      fromNeedsReverse = fromCp[2] < 0 !== toCp[2] < 0;
    }
    var newFromSubpathBezier = [];
    var newToSubpathBezier = [];
    var bestAngle = 0;
    var bestScore = Infinity;
    var tmpArr2 = [];
    var len2 = fromSubpathBezier.length;
    if (fromNeedsReverse) {
      fromSubpathBezier = reverse(fromSubpathBezier);
    }
    var offset2 = findBestRingOffset(fromSubpathBezier, toSubpathBezier, fromCp, toCp) * 6;
    var len22 = len2 - 2;
    for (var k2 = 0; k2 < len22; k2 += 2) {
      var idx = (offset2 + k2) % len22 + 2;
      newFromSubpathBezier[k2 + 2] = fromSubpathBezier[idx] - fromCp[0];
      newFromSubpathBezier[k2 + 3] = fromSubpathBezier[idx + 1] - fromCp[1];
    }
    newFromSubpathBezier[0] = fromSubpathBezier[offset2] - fromCp[0];
    newFromSubpathBezier[1] = fromSubpathBezier[offset2 + 1] - fromCp[1];
    if (searchAngleIteration > 0) {
      var step = searchAngleRange / searchAngleIteration;
      for (var angle = -searchAngleRange / 2; angle <= searchAngleRange / 2; angle += step) {
        var sa2 = Math.sin(angle);
        var ca2 = Math.cos(angle);
        var score = 0;
        for (var k2 = 0; k2 < fromSubpathBezier.length; k2 += 2) {
          var x0 = newFromSubpathBezier[k2];
          var y0 = newFromSubpathBezier[k2 + 1];
          var x1 = toSubpathBezier[k2] - toCp[0];
          var y1 = toSubpathBezier[k2 + 1] - toCp[1];
          var newX1 = x1 * ca2 - y1 * sa2;
          var newY1 = x1 * sa2 + y1 * ca2;
          tmpArr2[k2] = newX1;
          tmpArr2[k2 + 1] = newY1;
          var dx = newX1 - x0;
          var dy = newY1 - y0;
          score += dx * dx + dy * dy;
        }
        if (score < bestScore) {
          bestScore = score;
          bestAngle = angle;
          for (var m2 = 0; m2 < tmpArr2.length; m2++) {
            newToSubpathBezier[m2] = tmpArr2[m2];
          }
        }
      }
    } else {
      for (var i_1 = 0; i_1 < len2; i_1 += 2) {
        newToSubpathBezier[i_1] = toSubpathBezier[i_1] - toCp[0];
        newToSubpathBezier[i_1 + 1] = toSubpathBezier[i_1 + 1] - toCp[1];
      }
    }
    result.push({
      from: newFromSubpathBezier,
      to: newToSubpathBezier,
      fromCp,
      toCp,
      rotation: -bestAngle
    });
  }
  return result;
}
function isCombineMorphing(path) {
  return path.__isCombineMorphing;
}
var SAVED_METHOD_PREFIX = "__mOriginal_";
function saveAndModifyMethod(obj, methodName, modifiers) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  var originalMethod = obj[savedMethodName] || obj[methodName];
  if (!obj[savedMethodName]) {
    obj[savedMethodName] = obj[methodName];
  }
  var replace = modifiers.replace;
  var after = modifiers.after;
  var before = modifiers.before;
  obj[methodName] = function() {
    var args = arguments;
    var res;
    before && before.apply(this, args);
    if (replace) {
      res = replace.apply(this, args);
    } else {
      res = originalMethod.apply(this, args);
    }
    after && after.apply(this, args);
    return res;
  };
}
function restoreMethod(obj, methodName) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  if (obj[savedMethodName]) {
    obj[methodName] = obj[savedMethodName];
    obj[savedMethodName] = null;
  }
}
function applyTransformOnBeziers(bezierCurves, mm) {
  for (var i = 0; i < bezierCurves.length; i++) {
    var subBeziers = bezierCurves[i];
    for (var k2 = 0; k2 < subBeziers.length; ) {
      var x2 = subBeziers[k2];
      var y2 = subBeziers[k2 + 1];
      subBeziers[k2++] = mm[0] * x2 + mm[2] * y2 + mm[4];
      subBeziers[k2++] = mm[1] * x2 + mm[3] * y2 + mm[5];
    }
  }
}
function prepareMorphPath(fromPath, toPath) {
  var fromPathProxy = fromPath.getUpdatedPathProxy();
  var toPathProxy = toPath.getUpdatedPathProxy();
  var _a2 = alignBezierCurves(pathToBezierCurves(fromPathProxy), pathToBezierCurves(toPathProxy)), fromBezierCurves = _a2[0], toBezierCurves = _a2[1];
  var fromPathTransform = fromPath.getComputedTransform();
  var toPathTransform = toPath.getComputedTransform();
  function updateIdentityTransform() {
    this.transform = null;
  }
  fromPathTransform && applyTransformOnBeziers(fromBezierCurves, fromPathTransform);
  toPathTransform && applyTransformOnBeziers(toBezierCurves, toPathTransform);
  saveAndModifyMethod(toPath, "updateTransform", { replace: updateIdentityTransform });
  toPath.transform = null;
  var morphingData = findBestMorphingRotation(fromBezierCurves, toBezierCurves, 10, Math.PI);
  var tmpArr2 = [];
  saveAndModifyMethod(toPath, "buildPath", { replace: function(path) {
    var t2 = toPath.__morphT;
    var onet = 1 - t2;
    var newCp = [];
    for (var i = 0; i < morphingData.length; i++) {
      var item = morphingData[i];
      var from = item.from;
      var to = item.to;
      var angle = item.rotation * t2;
      var fromCp = item.fromCp;
      var toCp = item.toCp;
      var sa2 = Math.sin(angle);
      var ca2 = Math.cos(angle);
      lerp$1(newCp, fromCp, toCp, t2);
      for (var m2 = 0; m2 < from.length; m2 += 2) {
        var x0_1 = from[m2];
        var y0_1 = from[m2 + 1];
        var x1 = to[m2];
        var y1 = to[m2 + 1];
        var x2 = x0_1 * onet + x1 * t2;
        var y2 = y0_1 * onet + y1 * t2;
        tmpArr2[m2] = x2 * ca2 - y2 * sa2 + newCp[0];
        tmpArr2[m2 + 1] = x2 * sa2 + y2 * ca2 + newCp[1];
      }
      var x0 = tmpArr2[0];
      var y0 = tmpArr2[1];
      path.moveTo(x0, y0);
      for (var m2 = 2; m2 < from.length; ) {
        var x1 = tmpArr2[m2++];
        var y1 = tmpArr2[m2++];
        var x22 = tmpArr2[m2++];
        var y22 = tmpArr2[m2++];
        var x3 = tmpArr2[m2++];
        var y3 = tmpArr2[m2++];
        if (x0 === x1 && y0 === y1 && x22 === x3 && y22 === y3) {
          path.lineTo(x3, y3);
        } else {
          path.bezierCurveTo(x1, y1, x22, y22, x3, y3);
        }
        x0 = x3;
        y0 = y3;
      }
    }
  } });
}
function morphPath(fromPath, toPath, animationOpts) {
  if (!fromPath || !toPath) {
    return toPath;
  }
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  prepareMorphPath(fromPath, toPath);
  toPath.__morphT = 0;
  function restoreToPath() {
    restoreMethod(toPath, "buildPath");
    restoreMethod(toPath, "updateTransform");
    toPath.__morphT = -1;
    toPath.createPathProxy();
    toPath.dirtyShape();
  }
  toPath.animateTo({
    __morphT: 1
  }, defaults({
    during: function(p2) {
      toPath.dirtyShape();
      oldDuring && oldDuring(p2);
    },
    done: function() {
      restoreToPath();
      oldDone && oldDone();
    }
  }, animationOpts));
  return toPath;
}
function hilbert(x2, y2, minX, minY, maxX, maxY) {
  var bits = 16;
  x2 = maxX === minX ? 0 : Math.round(32767 * (x2 - minX) / (maxX - minX));
  y2 = maxY === minY ? 0 : Math.round(32767 * (y2 - minY) / (maxY - minY));
  var d2 = 0;
  var tmp;
  for (var s = (1 << bits) / 2; s > 0; s /= 2) {
    var rx = 0;
    var ry = 0;
    if ((x2 & s) > 0) {
      rx = 1;
    }
    if ((y2 & s) > 0) {
      ry = 1;
    }
    d2 += s * s * (3 * rx ^ ry);
    if (ry === 0) {
      if (rx === 1) {
        x2 = s - 1 - x2;
        y2 = s - 1 - y2;
      }
      tmp = x2;
      x2 = y2;
      y2 = tmp;
    }
  }
  return d2;
}
function sortPaths(pathList) {
  var xMin = Infinity;
  var yMin = Infinity;
  var xMax = -Infinity;
  var yMax = -Infinity;
  var cps = map$1(pathList, function(path) {
    var rect = path.getBoundingRect();
    var m2 = path.getComputedTransform();
    var x2 = rect.x + rect.width / 2 + (m2 ? m2[4] : 0);
    var y2 = rect.y + rect.height / 2 + (m2 ? m2[5] : 0);
    xMin = Math.min(x2, xMin);
    yMin = Math.min(y2, yMin);
    xMax = Math.max(x2, xMax);
    yMax = Math.max(y2, yMax);
    return [x2, y2];
  });
  var items = map$1(cps, function(cp, idx) {
    return {
      cp,
      z: hilbert(cp[0], cp[1], xMin, yMin, xMax, yMax),
      path: pathList[idx]
    };
  });
  return items.sort(function(a, b2) {
    return a.z - b2.z;
  }).map(function(item) {
    return item.path;
  });
}
function defaultDividePath(param) {
  return split(param.path, param.count);
}
function createEmptyReturn() {
  return {
    fromIndividuals: [],
    toIndividuals: [],
    count: 0
  };
}
function combineMorph(fromList, toPath, animationOpts) {
  var fromPathList = [];
  function addFromPath(fromList2) {
    for (var i2 = 0; i2 < fromList2.length; i2++) {
      var from2 = fromList2[i2];
      if (isCombineMorphing(from2)) {
        addFromPath(from2.childrenRef());
      } else if (from2 instanceof Path$1) {
        fromPathList.push(from2);
      }
    }
  }
  addFromPath(fromList);
  var separateCount = fromPathList.length;
  if (!separateCount) {
    return createEmptyReturn();
  }
  var dividePath = animationOpts.dividePath || defaultDividePath;
  var toSubPathList = dividePath({
    path: toPath,
    count: separateCount
  });
  if (toSubPathList.length !== separateCount) {
    console.error("Invalid morphing: unmatched splitted path");
    return createEmptyReturn();
  }
  fromPathList = sortPaths(fromPathList);
  toSubPathList = sortPaths(toSubPathList);
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  var individualDelay = animationOpts.individualDelay;
  var identityTransform = new Transformable$1();
  for (var i = 0; i < separateCount; i++) {
    var from = fromPathList[i];
    var to = toSubPathList[i];
    to.parent = toPath;
    to.copyTransform(identityTransform);
    if (!individualDelay) {
      prepareMorphPath(from, to);
    }
  }
  toPath.__isCombineMorphing = true;
  toPath.childrenRef = function() {
    return toSubPathList;
  };
  function addToSubPathListToZr(zr) {
    for (var i2 = 0; i2 < toSubPathList.length; i2++) {
      toSubPathList[i2].addSelfToZr(zr);
    }
  }
  saveAndModifyMethod(toPath, "addSelfToZr", {
    after: function(zr) {
      addToSubPathListToZr(zr);
    }
  });
  saveAndModifyMethod(toPath, "removeSelfFromZr", {
    after: function(zr) {
      for (var i2 = 0; i2 < toSubPathList.length; i2++) {
        toSubPathList[i2].removeSelfFromZr(zr);
      }
    }
  });
  function restoreToPath() {
    toPath.__isCombineMorphing = false;
    toPath.__morphT = -1;
    toPath.childrenRef = null;
    restoreMethod(toPath, "addSelfToZr");
    restoreMethod(toPath, "removeSelfFromZr");
  }
  var toLen = toSubPathList.length;
  if (individualDelay) {
    var animating_1 = toLen;
    var eachDone = function() {
      animating_1--;
      if (animating_1 === 0) {
        restoreToPath();
        oldDone && oldDone();
      }
    };
    for (var i = 0; i < toLen; i++) {
      var indivdualAnimationOpts = individualDelay ? defaults({
        delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toSubPathList[i]),
        done: eachDone
      }, animationOpts) : animationOpts;
      morphPath(fromPathList[i], toSubPathList[i], indivdualAnimationOpts);
    }
  } else {
    toPath.__morphT = 0;
    toPath.animateTo({
      __morphT: 1
    }, defaults({
      during: function(p2) {
        for (var i2 = 0; i2 < toLen; i2++) {
          var child = toSubPathList[i2];
          child.__morphT = toPath.__morphT;
          child.dirtyShape();
        }
        oldDuring && oldDuring(p2);
      },
      done: function() {
        restoreToPath();
        for (var i2 = 0; i2 < fromList.length; i2++) {
          restoreMethod(fromList[i2], "updateTransform");
        }
        oldDone && oldDone();
      }
    }, animationOpts));
  }
  if (toPath.__zr) {
    addToSubPathListToZr(toPath.__zr);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toSubPathList,
    count: toLen
  };
}
function separateMorph(fromPath, toPathList, animationOpts) {
  var toLen = toPathList.length;
  var fromPathList = [];
  var dividePath = animationOpts.dividePath || defaultDividePath;
  function addFromPath(fromList) {
    for (var i2 = 0; i2 < fromList.length; i2++) {
      var from = fromList[i2];
      if (isCombineMorphing(from)) {
        addFromPath(from.childrenRef());
      } else if (from instanceof Path$1) {
        fromPathList.push(from);
      }
    }
  }
  if (isCombineMorphing(fromPath)) {
    addFromPath(fromPath.childrenRef());
    var fromLen = fromPathList.length;
    if (fromLen < toLen) {
      var k2 = 0;
      for (var i = fromLen; i < toLen; i++) {
        fromPathList.push(clonePath(fromPathList[k2++ % fromLen]));
      }
    }
    fromPathList.length = toLen;
  } else {
    fromPathList = dividePath({ path: fromPath, count: toLen });
    var fromPathTransform = fromPath.getComputedTransform();
    for (var i = 0; i < fromPathList.length; i++) {
      fromPathList[i].setLocalTransform(fromPathTransform);
    }
    if (fromPathList.length !== toLen) {
      console.error("Invalid morphing: unmatched splitted path");
      return createEmptyReturn();
    }
  }
  fromPathList = sortPaths(fromPathList);
  toPathList = sortPaths(toPathList);
  var individualDelay = animationOpts.individualDelay;
  for (var i = 0; i < toLen; i++) {
    var indivdualAnimationOpts = individualDelay ? defaults({
      delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toPathList[i])
    }, animationOpts) : animationOpts;
    morphPath(fromPathList[i], toPathList[i], indivdualAnimationOpts);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toPathList,
    count: toPathList.length
  };
}
function isMultiple(elements) {
  return isArray$1(elements[0]);
}
function prepareMorphBatches(one, many) {
  var batches = [];
  var batchCount = one.length;
  for (var i = 0; i < batchCount; i++) {
    batches.push({
      one: one[i],
      many: []
    });
  }
  for (var i = 0; i < many.length; i++) {
    var len2 = many[i].length;
    var k2 = void 0;
    for (k2 = 0; k2 < len2; k2++) {
      batches[k2 % batchCount].many.push(many[i][k2]);
    }
  }
  var off = 0;
  for (var i = batchCount - 1; i >= 0; i--) {
    if (!batches[i].many.length) {
      var moveFrom = batches[off].many;
      if (moveFrom.length <= 1) {
        if (off) {
          off = 0;
        } else {
          return batches;
        }
      }
      var len2 = moveFrom.length;
      var mid = Math.ceil(len2 / 2);
      batches[i].many = moveFrom.slice(mid, len2);
      batches[off].many = moveFrom.slice(0, mid);
      off++;
    }
  }
  return batches;
}
var pathDividers = {
  clone: function(params) {
    var ret = [];
    var approxOpacity = 1 - Math.pow(1 - params.path.style.opacity, 1 / params.count);
    for (var i = 0; i < params.count; i++) {
      var cloned = clonePath(params.path);
      cloned.setStyle("opacity", approxOpacity);
      ret.push(cloned);
    }
    return ret;
  },
  split: null
};
function applyMorphAnimation(from, to, divideShape, seriesModel, dataIndex, animateOtherProps) {
  if (!from.length || !to.length) {
    return;
  }
  var updateAnimationCfg = getAnimationConfig("update", seriesModel, dataIndex);
  if (!(updateAnimationCfg && updateAnimationCfg.duration > 0)) {
    return;
  }
  var animationDelay = seriesModel.getModel("universalTransition").get("delay");
  var animationCfg = Object.assign({
    setToFinal: true
  }, updateAnimationCfg);
  var many;
  var one;
  if (isMultiple(from)) {
    many = from;
    one = to;
  }
  if (isMultiple(to)) {
    many = to;
    one = from;
  }
  function morphOneBatch(batch, fromIsMany2, animateIndex2, animateCount2, forceManyOne) {
    var batchMany = batch.many;
    var batchOne = batch.one;
    if (batchMany.length === 1 && !forceManyOne) {
      var batchFrom = fromIsMany2 ? batchMany[0] : batchOne;
      var batchTo = fromIsMany2 ? batchOne : batchMany[0];
      if (isCombineMorphing(batchFrom)) {
        morphOneBatch({
          many: [batchFrom],
          one: batchTo
        }, true, animateIndex2, animateCount2, true);
      } else {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(animateIndex2, animateCount2)
        }, animationCfg) : animationCfg;
        morphPath(batchFrom, batchTo, individualAnimationCfg);
        animateOtherProps(batchFrom, batchTo, batchFrom, batchTo, individualAnimationCfg);
      }
    } else {
      var separateAnimationCfg = defaults({
        dividePath: pathDividers[divideShape],
        individualDelay: animationDelay && function(idx, count3, fromPath, toPath) {
          return animationDelay(idx + animateIndex2, animateCount2);
        }
      }, animationCfg);
      var _a2 = fromIsMany2 ? combineMorph(batchMany, batchOne, separateAnimationCfg) : separateMorph(batchOne, batchMany, separateAnimationCfg), fromIndividuals = _a2.fromIndividuals, toIndividuals = _a2.toIndividuals;
      var count2 = fromIndividuals.length;
      for (var k2 = 0; k2 < count2; k2++) {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(k2, count2)
        }, animationCfg) : animationCfg;
        animateOtherProps(fromIndividuals[k2], toIndividuals[k2], fromIsMany2 ? batchMany[k2] : batch.one, fromIsMany2 ? batch.one : batchMany[k2], individualAnimationCfg);
      }
    }
  }
  var fromIsMany = many ? many === from : from.length > to.length;
  var morphBatches = many ? prepareMorphBatches(one, many) : prepareMorphBatches(fromIsMany ? to : from, [fromIsMany ? from : to]);
  var animateCount = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    animateCount += morphBatches[i].many.length;
  }
  var animateIndex = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    morphOneBatch(morphBatches[i], fromIsMany, animateIndex, animateCount);
    animateIndex += morphBatches[i].many.length;
  }
}
function getPathList(elements) {
  if (!elements) {
    return [];
  }
  if (isArray$1(elements)) {
    var pathList_1 = [];
    for (var i = 0; i < elements.length; i++) {
      pathList_1.push(getPathList(elements[i]));
    }
    return pathList_1;
  }
  var pathList = [];
  elements.traverse(function(el) {
    if (el instanceof Path$1 && !el.disableMorphing && !el.invisible && !el.ignore) {
      pathList.push(el);
    }
  });
  return pathList;
}
var DATA_COUNT_THRESHOLD = 1e4;
var getUniversalTransitionGlobalStore = makeInner();
function getGroupIdDimension(data) {
  var dimensions = data.dimensions;
  for (var i = 0; i < dimensions.length; i++) {
    var dimInfo = data.getDimensionInfo(dimensions[i]);
    if (dimInfo && dimInfo.otherDims.itemGroupId === 0) {
      return dimensions[i];
    }
  }
}
function flattenDataDiffItems(list) {
  var items = [];
  each$g(list, function(seriesInfo) {
    var data = seriesInfo.data;
    if (data.count() > DATA_COUNT_THRESHOLD) {
      return;
    }
    var indices = data.getIndices();
    var groupDim = getGroupIdDimension(data);
    for (var dataIndex = 0; dataIndex < indices.length; dataIndex++) {
      items.push({
        data,
        dim: seriesInfo.dim || groupDim,
        divide: seriesInfo.divide,
        dataIndex
      });
    }
  });
  return items;
}
function fadeInElement(newEl2, newSeries, newIndex) {
  newEl2.traverse(function(el) {
    if (el instanceof Path$1) {
      initProps(el, {
        style: {
          opacity: 0
        }
      }, newSeries, {
        dataIndex: newIndex,
        isFrom: true
      });
    }
  });
}
function removeEl(el) {
  if (el.parent) {
    var computedTransform = el.getComputedTransform();
    el.setLocalTransform(computedTransform);
    el.parent.remove(el);
  }
}
function stopAnimation(el) {
  el.stopAnimation();
  if (el.isGroup) {
    el.traverse(function(child) {
      child.stopAnimation();
    });
  }
}
function animateElementStyles(el, dataIndex, seriesModel) {
  var animationConfig = getAnimationConfig("update", seriesModel, dataIndex);
  animationConfig && el.traverse(function(child) {
    if (child instanceof Displayable$1) {
      var oldStyle = getOldStyle(child);
      if (oldStyle) {
        child.animateFrom({
          style: oldStyle
        }, animationConfig);
      }
    }
  });
}
function isAllIdSame(oldDiffItems, newDiffItems) {
  var len2 = oldDiffItems.length;
  if (len2 !== newDiffItems.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    var oldItem = oldDiffItems[i];
    var newItem = newDiffItems[i];
    if (oldItem.data.getId(oldItem.dataIndex) !== newItem.data.getId(newItem.dataIndex)) {
      return false;
    }
  }
  return true;
}
function transitionBetween(oldList, newList, api) {
  var oldDiffItems = flattenDataDiffItems(oldList);
  var newDiffItems = flattenDataDiffItems(newList);
  function updateMorphingPathProps(from, to, rawFrom, rawTo, animationCfg) {
    if (rawFrom || from) {
      to.animateFrom({
        style: rawFrom && rawFrom !== from ? extend(extend({}, rawFrom.style), from.style) : from.style
      }, animationCfg);
    }
  }
  function findKeyDim(items) {
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].dim) {
        return items[i2].dim;
      }
    }
  }
  var oldKeyDim = findKeyDim(oldDiffItems);
  var newKeyDim = findKeyDim(newDiffItems);
  var hasMorphAnimation = false;
  function createKeyGetter(isOld, onlyGetId) {
    return function(diffItem) {
      var data = diffItem.data;
      var dataIndex = diffItem.dataIndex;
      if (onlyGetId) {
        return data.getId(dataIndex);
      }
      var dataGroupId = data.hostModel && data.hostModel.get("dataGroupId");
      var keyDim = isOld ? oldKeyDim || newKeyDim : newKeyDim || oldKeyDim;
      var dimInfo = keyDim && data.getDimensionInfo(keyDim);
      var dimOrdinalMeta = dimInfo && dimInfo.ordinalMeta;
      if (dimInfo) {
        var key = data.get(dimInfo.name, dataIndex);
        if (dimOrdinalMeta) {
          return dimOrdinalMeta.categories[key] || key + "";
        }
        return key + "";
      }
      var itemVal = data.getRawDataItem(dataIndex);
      if (itemVal && itemVal.groupId) {
        return itemVal.groupId + "";
      }
      return dataGroupId || data.getId(dataIndex);
    };
  }
  var useId = isAllIdSame(oldDiffItems, newDiffItems);
  var isElementStillInChart = {};
  if (!useId) {
    for (var i = 0; i < newDiffItems.length; i++) {
      var newItem = newDiffItems[i];
      var el = newItem.data.getItemGraphicEl(newItem.dataIndex);
      if (el) {
        isElementStillInChart[el.id] = true;
      }
    }
  }
  function updateOneToOne(newIndex, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var newItem2 = newDiffItems[newIndex];
    var newSeries = newItem2.data.hostModel;
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    var newEl2 = newItem2.data.getItemGraphicEl(newItem2.dataIndex);
    if (oldEl === newEl2) {
      newEl2 && animateElementStyles(newEl2, newItem2.dataIndex, newSeries);
      return;
    }
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newIndex);
      }
    }
  }
  new DataDiffer$1(oldDiffItems, newDiffItems, createKeyGetter(true, useId), createKeyGetter(false, useId), null, "multiple").update(updateOneToOne).updateManyToOne(function(newIndex, oldIndices) {
    var newItem2 = newDiffItems[newIndex];
    var newData = newItem2.data;
    var newSeries = newData.hostModel;
    var newEl2 = newData.getItemGraphicEl(newItem2.dataIndex);
    var oldElsList = filter(map$1(oldIndices, function(idx) {
      return oldDiffItems[idx].data.getItemGraphicEl(oldDiffItems[idx].dataIndex);
    }), function(oldEl) {
      return oldEl && oldEl !== newEl2 && !isElementStillInChart[oldEl.id];
    });
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldElsList.length) {
        each$g(oldElsList, function(oldEl) {
          stopAnimation(oldEl);
          removeEl(oldEl);
        });
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldElsList), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newItem2.dataIndex);
      }
    }
  }).updateOneToMany(function(newIndices, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    var newElsList = filter(map$1(newIndices, function(idx) {
      return newDiffItems[idx].data.getItemGraphicEl(newDiffItems[idx].dataIndex);
    }), function(el2) {
      return el2 && el2 !== oldEl;
    });
    var newSeris = newDiffItems[newIndices[0]].data.hostModel;
    if (newElsList.length) {
      each$g(newElsList, function(newEl2) {
        return stopAnimation(newEl2);
      });
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newElsList), oldItem.divide, newSeris, newIndices[0], updateMorphingPathProps);
      } else {
        each$g(newElsList, function(newEl2) {
          return fadeInElement(newEl2, newSeris, newIndices[0]);
        });
      }
    }
  }).updateManyToMany(function(newIndices, oldIndices) {
    new DataDiffer$1(oldIndices, newIndices, function(rawIdx) {
      return oldDiffItems[rawIdx].data.getId(oldDiffItems[rawIdx].dataIndex);
    }, function(rawIdx) {
      return newDiffItems[rawIdx].data.getId(newDiffItems[rawIdx].dataIndex);
    }).update(function(newIndex, oldIndex) {
      updateOneToOne(newIndices[newIndex], oldIndices[oldIndex]);
    }).execute();
  }).execute();
  if (hasMorphAnimation) {
    each$g(newList, function(_a2) {
      var data = _a2.data;
      var seriesModel = data.hostModel;
      var view = seriesModel && api.getViewOfSeriesModel(seriesModel);
      var animationCfg = getAnimationConfig("update", seriesModel, 0);
      if (view && seriesModel.isAnimationEnabled() && animationCfg && animationCfg.duration > 0) {
        view.group.traverse(function(el2) {
          if (el2 instanceof Path$1 && !el2.animators.length) {
            el2.animateFrom({
              style: {
                opacity: 0
              }
            }, animationCfg);
          }
        });
      }
    });
  }
}
function getSeriesTransitionKey(series) {
  var seriesKey = series.getModel("universalTransition").get("seriesKey");
  if (!seriesKey) {
    return series.id;
  }
  return seriesKey;
}
function convertArraySeriesKeyToString(seriesKey) {
  if (isArray$1(seriesKey)) {
    return seriesKey.sort().join(",");
  }
  return seriesKey;
}
function getDivideShapeFromData(data) {
  if (data.hostModel) {
    return data.hostModel.getModel("universalTransition").get("divideShape");
  }
}
function findTransitionSeriesBatches(globalStore, params) {
  var updateBatches = createHashMap();
  var oldDataMap = createHashMap();
  var oldDataMapForSplit = createHashMap();
  each$g(globalStore.oldSeries, function(series, idx) {
    var oldData = globalStore.oldData[idx];
    var transitionKey = getSeriesTransitionKey(series);
    var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
    oldDataMap.set(transitionKeyStr, oldData);
    if (isArray$1(transitionKey)) {
      each$g(transitionKey, function(key) {
        oldDataMapForSplit.set(key, {
          data: oldData,
          key: transitionKeyStr
        });
      });
    }
  });
  each$g(params.updatedSeries, function(series) {
    if (series.isUniversalTransitionEnabled() && series.isAnimationEnabled()) {
      var newData = series.getData();
      var transitionKey = getSeriesTransitionKey(series);
      var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
      var oldData = oldDataMap.get(transitionKeyStr);
      if (oldData) {
        updateBatches.set(transitionKeyStr, {
          oldSeries: [{
            divide: getDivideShapeFromData(oldData),
            data: oldData
          }],
          newSeries: [{
            divide: getDivideShapeFromData(newData),
            data: newData
          }]
        });
      } else {
        if (isArray$1(transitionKey)) {
          var oldSeries_1 = [];
          each$g(transitionKey, function(key) {
            var oldData2 = oldDataMap.get(key);
            if (oldData2) {
              oldSeries_1.push({
                divide: getDivideShapeFromData(oldData2),
                data: oldData2
              });
            }
          });
          if (oldSeries_1.length) {
            updateBatches.set(transitionKeyStr, {
              oldSeries: oldSeries_1,
              newSeries: [{
                data: newData,
                divide: getDivideShapeFromData(newData)
              }]
            });
          }
        } else {
          var oldData_1 = oldDataMapForSplit.get(transitionKey);
          if (oldData_1) {
            var batch = updateBatches.get(oldData_1.key);
            if (!batch) {
              batch = {
                oldSeries: [{
                  data: oldData_1.data,
                  divide: getDivideShapeFromData(oldData_1.data)
                }],
                newSeries: []
              };
              updateBatches.set(oldData_1.key, batch);
            }
            batch.newSeries.push({
              data: newData,
              divide: getDivideShapeFromData(newData)
            });
          }
        }
      }
    }
  });
  return updateBatches;
}
function querySeries(series, finder) {
  for (var i = 0; i < series.length; i++) {
    var found = finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id;
    if (found) {
      return i;
    }
  }
}
function transitionSeriesFromOpt(transitionOpt, globalStore, params, api) {
  var from = [];
  var to = [];
  each$g(normalizeToArray(transitionOpt.from), function(finder) {
    var idx = querySeries(globalStore.oldSeries, finder);
    if (idx >= 0) {
      from.push({
        data: globalStore.oldData[idx],
        divide: getDivideShapeFromData(globalStore.oldData[idx]),
        dim: finder.dimension
      });
    }
  });
  each$g(normalizeToArray(transitionOpt.to), function(finder) {
    var idx = querySeries(params.updatedSeries, finder);
    if (idx >= 0) {
      var data = params.updatedSeries[idx].getData();
      to.push({
        data,
        divide: getDivideShapeFromData(data),
        dim: finder.dimension
      });
    }
  });
  if (from.length > 0 && to.length > 0) {
    transitionBetween(from, to, api);
  }
}
function installUniversalTransition(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecMOdel, api, params) {
    each$g(normalizeToArray(params.seriesTransition), function(transOpt) {
      each$g(normalizeToArray(transOpt.to), function(finder) {
        var series = params.updatedSeries;
        for (var i = 0; i < series.length; i++) {
          if (finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id) {
            series[i][SERIES_UNIVERSAL_TRANSITION_PROP] = true;
          }
        }
      });
    });
  });
  registers.registerUpdateLifecycle("series:transition", function(ecModel, api, params) {
    var globalStore = getUniversalTransitionGlobalStore(api);
    if (globalStore.oldSeries && params.updatedSeries && params.optionChanged) {
      var transitionOpt = params.seriesTransition;
      if (transitionOpt) {
        each$g(normalizeToArray(transitionOpt), function(opt) {
          transitionSeriesFromOpt(opt, globalStore, params, api);
        });
      } else {
        var updateBatches_1 = findTransitionSeriesBatches(globalStore, params);
        each$g(updateBatches_1.keys(), function(key) {
          var batch = updateBatches_1.get(key);
          transitionBetween(batch.oldSeries, batch.newSeries, api);
        });
      }
      each$g(params.updatedSeries, function(series) {
        if (series[SERIES_UNIVERSAL_TRANSITION_PROP]) {
          series[SERIES_UNIVERSAL_TRANSITION_PROP] = false;
        }
      });
    }
    var allSeries = ecModel.getSeries();
    var savedSeries = globalStore.oldSeries = [];
    var savedData = globalStore.oldData = [];
    for (var i = 0; i < allSeries.length; i++) {
      var data = allSeries[i].getData();
      if (data.count() < DATA_COUNT_THRESHOLD) {
        savedSeries.push(allSeries[i]);
        savedData.push(data);
      }
    }
  });
}
use([install$R]);
use([install$S]);
use([install$Q, install$P, install$O, install$M, install$K, install$I, install$H, install$G, install$F, install$E, install$D, install$B, install$A, install$z, install$y, install$x, install$w, install$v, install$u, install$t, install$s, install$r]);
use(install$p);
use(install$o);
use(install$J);
use(install$n);
use(install$C);
use(install$m);
use(install$l);
use(install$j);
use(install$i);
use(install$q);
use(install$h);
use(install$g);
use(install$f);
use(install$e);
use(install$d);
use(install$c);
use(install$9);
use(install$6);
use(install$8);
use(install$7);
use(install$3);
use(install$5);
use(install$4);
use(install$2);
use(install$1);
use(install);
use(installUniversalTransition);
use(installLabelLayout);
function useEcharts(options) {
  const {
    defaultOptions
  } = options != null ? options : {};
  const container2 = useRef(null);
  const chart = useRef();
  const optionsRef = useRef(defaultOptions);
  useEffect(() => {
    if (!container2.current) {
      return;
    }
    const myEcharts = init$1(container2.current);
    chart.current = myEcharts;
    if (optionsRef.current) {
      myEcharts.setOption(optionsRef.current);
    }
  }, []);
  useEffect(() => {
    return () => {
      var _a2, _b2, _c2, _d;
      (_b2 = (_a2 = chart.current) == null ? void 0 : _a2.dispose) == null ? void 0 : _b2.call(_a2);
      (_d = (_c2 = chart.current) == null ? void 0 : _c2.off) == null ? void 0 : _d.call(_c2, "*");
      chart.current = void 0;
    };
  }, []);
  useEventListener("resize", () => {
    requestAnimationFrame(() => {
      var _a2, _b2;
      (_b2 = (_a2 = chart == null ? void 0 : chart.current) == null ? void 0 : _a2.resize) == null ? void 0 : _b2.call(_a2);
    });
  });
  return {
    chart,
    container: container2
  };
}
class Charts {
  constructor() {
    __publicField(this, "chartsEmitters", /* @__PURE__ */ new Map());
    __publicField(this, "add", (id2, chart, option, title) => {
      if (chart && option) {
        this.chartsEmitters.set(id2, {
          chart,
          option,
          title
        });
      } else {
        console.log("\u6DFB\u52A0\u5931\u8D25");
      }
    });
    __publicField(this, "get", (id2) => {
      return this.chartsEmitters.get(id2);
    });
    __publicField(this, "clear", () => {
      this.chartsEmitters.clear();
    });
    __publicField(this, "delete", (id2) => {
      this.chartsEmitters.delete(id2);
    });
    __publicField(this, "list", () => {
      var _a2, _b2, _c2;
      const list = [];
      for (const key of this.chartsEmitters.keys()) {
        list.push({
          id: key,
          chart: (_a2 = this.chartsEmitters.get(key)) == null ? void 0 : _a2.chart,
          option: (_b2 = this.chartsEmitters.get(key)) == null ? void 0 : _b2.option,
          title: (_c2 = this.chartsEmitters.get(key)) == null ? void 0 : _c2.title
        });
      }
      return list;
    });
  }
}
const _Charts = new Charts();
var lodash = { exports: {} };
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
(function(module, exports) {
  (function() {
    var undefined$1;
    var VERSION = "4.17.21";
    var LARGE_ARRAY_SIZE2 = 200;
    var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT2 = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
    var HASH_UNDEFINED2 = "__lodash_hash_undefined__";
    var MAX_MEMOIZE_SIZE = 500;
    var PLACEHOLDER = "__lodash_placeholder__";
    var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
    var COMPARE_PARTIAL_FLAG2 = 1, COMPARE_UNORDERED_FLAG2 = 2;
    var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
    var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
    var HOT_COUNT = 800, HOT_SPAN = 16;
    var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
    var INFINITY = 1 / 0, MAX_SAFE_INTEGER2 = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN2 = 0 / 0;
    var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
    var wrapFlags = [
      ["ary", WRAP_ARY_FLAG],
      ["bind", WRAP_BIND_FLAG],
      ["bindKey", WRAP_BIND_KEY_FLAG],
      ["curry", WRAP_CURRY_FLAG],
      ["curryRight", WRAP_CURRY_RIGHT_FLAG],
      ["flip", WRAP_FLIP_FLAG],
      ["partial", WRAP_PARTIAL_FLAG],
      ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
      ["rearg", WRAP_REARG_FLAG]
    ];
    var argsTag2 = "[object Arguments]", arrayTag2 = "[object Array]", asyncTag2 = "[object AsyncFunction]", boolTag2 = "[object Boolean]", dateTag2 = "[object Date]", domExcTag = "[object DOMException]", errorTag2 = "[object Error]", funcTag2 = "[object Function]", genTag2 = "[object GeneratorFunction]", mapTag2 = "[object Map]", numberTag2 = "[object Number]", nullTag2 = "[object Null]", objectTag2 = "[object Object]", promiseTag2 = "[object Promise]", proxyTag2 = "[object Proxy]", regexpTag2 = "[object RegExp]", setTag2 = "[object Set]", stringTag2 = "[object String]", symbolTag2 = "[object Symbol]", undefinedTag2 = "[object Undefined]", weakMapTag2 = "[object WeakMap]", weakSetTag = "[object WeakSet]";
    var arrayBufferTag2 = "[object ArrayBuffer]", dataViewTag2 = "[object DataView]", float32Tag2 = "[object Float32Array]", float64Tag2 = "[object Float64Array]", int8Tag2 = "[object Int8Array]", int16Tag2 = "[object Int16Array]", int32Tag2 = "[object Int32Array]", uint8Tag2 = "[object Uint8Array]", uint8ClampedTag2 = "[object Uint8ClampedArray]", uint16Tag2 = "[object Uint16Array]", uint32Tag2 = "[object Uint32Array]";
    var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
    var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
    var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
    var reRegExpChar2 = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar2.source);
    var reTrimStart2 = /^\s+/;
    var reWhitespace2 = /\s/;
    var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
    var reEscapeChar = /\\(\\)?/g;
    var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
    var reFlags = /\w*$/;
    var reIsBadHex2 = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary2 = /^0b[01]+$/i;
    var reIsHostCtor2 = /^\[object .+?Constructor\]$/;
    var reIsOctal2 = /^0o[0-7]+$/i;
    var reIsUint2 = /^(?:0|[1-9]\d*)$/;
    var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
    var reNoMatch = /($^)/;
    var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
    var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
    var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
    var reApos = RegExp(rsApos, "g");
    var reComboMark = RegExp(rsCombo, "g");
    var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    var reUnicodeWord = RegExp([
      rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
      rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
      rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
      rsUpper + "+" + rsOptContrUpper,
      rsOrdUpper,
      rsOrdLower,
      rsDigits,
      rsEmoji
    ].join("|"), "g");
    var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    var contextProps = [
      "Array",
      "Buffer",
      "DataView",
      "Date",
      "Error",
      "Float32Array",
      "Float64Array",
      "Function",
      "Int8Array",
      "Int16Array",
      "Int32Array",
      "Map",
      "Math",
      "Object",
      "Promise",
      "RegExp",
      "Set",
      "String",
      "Symbol",
      "TypeError",
      "Uint8Array",
      "Uint8ClampedArray",
      "Uint16Array",
      "Uint32Array",
      "WeakMap",
      "_",
      "clearTimeout",
      "isFinite",
      "parseInt",
      "setTimeout"
    ];
    var templateCounter = -1;
    var typedArrayTags2 = {};
    typedArrayTags2[float32Tag2] = typedArrayTags2[float64Tag2] = typedArrayTags2[int8Tag2] = typedArrayTags2[int16Tag2] = typedArrayTags2[int32Tag2] = typedArrayTags2[uint8Tag2] = typedArrayTags2[uint8ClampedTag2] = typedArrayTags2[uint16Tag2] = typedArrayTags2[uint32Tag2] = true;
    typedArrayTags2[argsTag2] = typedArrayTags2[arrayTag2] = typedArrayTags2[arrayBufferTag2] = typedArrayTags2[boolTag2] = typedArrayTags2[dataViewTag2] = typedArrayTags2[dateTag2] = typedArrayTags2[errorTag2] = typedArrayTags2[funcTag2] = typedArrayTags2[mapTag2] = typedArrayTags2[numberTag2] = typedArrayTags2[objectTag2] = typedArrayTags2[regexpTag2] = typedArrayTags2[setTag2] = typedArrayTags2[stringTag2] = typedArrayTags2[weakMapTag2] = false;
    var cloneableTags = {};
    cloneableTags[argsTag2] = cloneableTags[arrayTag2] = cloneableTags[arrayBufferTag2] = cloneableTags[dataViewTag2] = cloneableTags[boolTag2] = cloneableTags[dateTag2] = cloneableTags[float32Tag2] = cloneableTags[float64Tag2] = cloneableTags[int8Tag2] = cloneableTags[int16Tag2] = cloneableTags[int32Tag2] = cloneableTags[mapTag2] = cloneableTags[numberTag2] = cloneableTags[objectTag2] = cloneableTags[regexpTag2] = cloneableTags[setTag2] = cloneableTags[stringTag2] = cloneableTags[symbolTag2] = cloneableTags[uint8Tag2] = cloneableTags[uint8ClampedTag2] = cloneableTags[uint16Tag2] = cloneableTags[uint32Tag2] = true;
    cloneableTags[errorTag2] = cloneableTags[funcTag2] = cloneableTags[weakMapTag2] = false;
    var deburredLetters = {
      "\xC0": "A",
      "\xC1": "A",
      "\xC2": "A",
      "\xC3": "A",
      "\xC4": "A",
      "\xC5": "A",
      "\xE0": "a",
      "\xE1": "a",
      "\xE2": "a",
      "\xE3": "a",
      "\xE4": "a",
      "\xE5": "a",
      "\xC7": "C",
      "\xE7": "c",
      "\xD0": "D",
      "\xF0": "d",
      "\xC8": "E",
      "\xC9": "E",
      "\xCA": "E",
      "\xCB": "E",
      "\xE8": "e",
      "\xE9": "e",
      "\xEA": "e",
      "\xEB": "e",
      "\xCC": "I",
      "\xCD": "I",
      "\xCE": "I",
      "\xCF": "I",
      "\xEC": "i",
      "\xED": "i",
      "\xEE": "i",
      "\xEF": "i",
      "\xD1": "N",
      "\xF1": "n",
      "\xD2": "O",
      "\xD3": "O",
      "\xD4": "O",
      "\xD5": "O",
      "\xD6": "O",
      "\xD8": "O",
      "\xF2": "o",
      "\xF3": "o",
      "\xF4": "o",
      "\xF5": "o",
      "\xF6": "o",
      "\xF8": "o",
      "\xD9": "U",
      "\xDA": "U",
      "\xDB": "U",
      "\xDC": "U",
      "\xF9": "u",
      "\xFA": "u",
      "\xFB": "u",
      "\xFC": "u",
      "\xDD": "Y",
      "\xFD": "y",
      "\xFF": "y",
      "\xC6": "Ae",
      "\xE6": "ae",
      "\xDE": "Th",
      "\xFE": "th",
      "\xDF": "ss",
      "\u0100": "A",
      "\u0102": "A",
      "\u0104": "A",
      "\u0101": "a",
      "\u0103": "a",
      "\u0105": "a",
      "\u0106": "C",
      "\u0108": "C",
      "\u010A": "C",
      "\u010C": "C",
      "\u0107": "c",
      "\u0109": "c",
      "\u010B": "c",
      "\u010D": "c",
      "\u010E": "D",
      "\u0110": "D",
      "\u010F": "d",
      "\u0111": "d",
      "\u0112": "E",
      "\u0114": "E",
      "\u0116": "E",
      "\u0118": "E",
      "\u011A": "E",
      "\u0113": "e",
      "\u0115": "e",
      "\u0117": "e",
      "\u0119": "e",
      "\u011B": "e",
      "\u011C": "G",
      "\u011E": "G",
      "\u0120": "G",
      "\u0122": "G",
      "\u011D": "g",
      "\u011F": "g",
      "\u0121": "g",
      "\u0123": "g",
      "\u0124": "H",
      "\u0126": "H",
      "\u0125": "h",
      "\u0127": "h",
      "\u0128": "I",
      "\u012A": "I",
      "\u012C": "I",
      "\u012E": "I",
      "\u0130": "I",
      "\u0129": "i",
      "\u012B": "i",
      "\u012D": "i",
      "\u012F": "i",
      "\u0131": "i",
      "\u0134": "J",
      "\u0135": "j",
      "\u0136": "K",
      "\u0137": "k",
      "\u0138": "k",
      "\u0139": "L",
      "\u013B": "L",
      "\u013D": "L",
      "\u013F": "L",
      "\u0141": "L",
      "\u013A": "l",
      "\u013C": "l",
      "\u013E": "l",
      "\u0140": "l",
      "\u0142": "l",
      "\u0143": "N",
      "\u0145": "N",
      "\u0147": "N",
      "\u014A": "N",
      "\u0144": "n",
      "\u0146": "n",
      "\u0148": "n",
      "\u014B": "n",
      "\u014C": "O",
      "\u014E": "O",
      "\u0150": "O",
      "\u014D": "o",
      "\u014F": "o",
      "\u0151": "o",
      "\u0154": "R",
      "\u0156": "R",
      "\u0158": "R",
      "\u0155": "r",
      "\u0157": "r",
      "\u0159": "r",
      "\u015A": "S",
      "\u015C": "S",
      "\u015E": "S",
      "\u0160": "S",
      "\u015B": "s",
      "\u015D": "s",
      "\u015F": "s",
      "\u0161": "s",
      "\u0162": "T",
      "\u0164": "T",
      "\u0166": "T",
      "\u0163": "t",
      "\u0165": "t",
      "\u0167": "t",
      "\u0168": "U",
      "\u016A": "U",
      "\u016C": "U",
      "\u016E": "U",
      "\u0170": "U",
      "\u0172": "U",
      "\u0169": "u",
      "\u016B": "u",
      "\u016D": "u",
      "\u016F": "u",
      "\u0171": "u",
      "\u0173": "u",
      "\u0174": "W",
      "\u0175": "w",
      "\u0176": "Y",
      "\u0177": "y",
      "\u0178": "Y",
      "\u0179": "Z",
      "\u017B": "Z",
      "\u017D": "Z",
      "\u017A": "z",
      "\u017C": "z",
      "\u017E": "z",
      "\u0132": "IJ",
      "\u0133": "ij",
      "\u0152": "Oe",
      "\u0153": "oe",
      "\u0149": "'n",
      "\u017F": "s"
    };
    var htmlEscapes = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    };
    var htmlUnescapes = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&#39;": "'"
    };
    var stringEscapes = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    };
    var freeParseFloat = parseFloat, freeParseInt2 = parseInt;
    var freeGlobal2 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
    var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
    var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule = freeExports && true && module && !module.nodeType && module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal2.process;
    var nodeUtil2 = function() {
      try {
        var types2 = freeModule && freeModule.require && freeModule.require("util").types;
        if (types2) {
          return types2;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e2) {
      }
    }();
    var nodeIsArrayBuffer = nodeUtil2 && nodeUtil2.isArrayBuffer, nodeIsDate = nodeUtil2 && nodeUtil2.isDate, nodeIsMap = nodeUtil2 && nodeUtil2.isMap, nodeIsRegExp = nodeUtil2 && nodeUtil2.isRegExp, nodeIsSet = nodeUtil2 && nodeUtil2.isSet, nodeIsTypedArray2 = nodeUtil2 && nodeUtil2.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayAggregator(array4, setter, iteratee, accumulator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        var value = array4[index2];
        setter(accumulator, value, iteratee(value), array4);
      }
      return accumulator;
    }
    function arrayEach(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (iteratee(array4[index2], index2, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEachRight(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      while (length--) {
        if (iteratee(array4[length], length, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEvery(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (!predicate(array4[index2], index2, array4)) {
          return false;
        }
      }
      return true;
    }
    function arrayFilter2(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (predicate(value, index2, array4)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayIncludes(array4, value) {
      var length = array4 == null ? 0 : array4.length;
      return !!length && baseIndexOf(array4, value, 0) > -1;
    }
    function arrayIncludesWith(array4, value, comparator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (comparator(value, array4[index2])) {
          return true;
        }
      }
      return false;
    }
    function arrayMap(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, result = Array(length);
      while (++index2 < length) {
        result[index2] = iteratee(array4[index2], index2, array4);
      }
      return result;
    }
    function arrayPush2(array4, values) {
      var index2 = -1, length = values.length, offset2 = array4.length;
      while (++index2 < length) {
        array4[offset2 + index2] = values[index2];
      }
      return array4;
    }
    function arrayReduce(array4, iteratee, accumulator, initAccum) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[++index2];
      }
      while (++index2 < length) {
        accumulator = iteratee(accumulator, array4[index2], index2, array4);
      }
      return accumulator;
    }
    function arrayReduceRight(array4, iteratee, accumulator, initAccum) {
      var length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[--length];
      }
      while (length--) {
        accumulator = iteratee(accumulator, array4[length], length, array4);
      }
      return accumulator;
    }
    function arraySome2(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return true;
        }
      }
      return false;
    }
    var asciiSize = baseProperty("length");
    function asciiToArray(string3) {
      return string3.split("");
    }
    function asciiWords(string3) {
      return string3.match(reAsciiWord) || [];
    }
    function baseFindKey(collection, predicate, eachFunc) {
      var result;
      eachFunc(collection, function(value, key, collection2) {
        if (predicate(value, key, collection2)) {
          result = key;
          return false;
        }
      });
      return result;
    }
    function baseFindIndex(array4, predicate, fromIndex, fromRight) {
      var length = array4.length, index2 = fromIndex + (fromRight ? 1 : -1);
      while (fromRight ? index2-- : ++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIndexOf(array4, value, fromIndex) {
      return value === value ? strictIndexOf(array4, value, fromIndex) : baseFindIndex(array4, baseIsNaN, fromIndex);
    }
    function baseIndexOfWith(array4, value, fromIndex, comparator) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (comparator(array4[index2], value)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseMean(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      return length ? baseSum(array4, iteratee) / length : NAN2;
    }
    function baseProperty(key) {
      return function(object4) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function basePropertyOf(object4) {
      return function(key) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
      eachFunc(collection, function(value, index2, collection2) {
        accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index2, collection2);
      });
      return accumulator;
    }
    function baseSortBy(array4, comparer) {
      var length = array4.length;
      array4.sort(comparer);
      while (length--) {
        array4[length] = array4[length].value;
      }
      return array4;
    }
    function baseSum(array4, iteratee) {
      var result, index2 = -1, length = array4.length;
      while (++index2 < length) {
        var current = iteratee(array4[index2]);
        if (current !== undefined$1) {
          result = result === undefined$1 ? current : result + current;
        }
      }
      return result;
    }
    function baseTimes2(n2, iteratee) {
      var index2 = -1, result = Array(n2);
      while (++index2 < n2) {
        result[index2] = iteratee(index2);
      }
      return result;
    }
    function baseToPairs(object4, props) {
      return arrayMap(props, function(key) {
        return [key, object4[key]];
      });
    }
    function baseTrim2(string3) {
      return string3 ? string3.slice(0, trimmedEndIndex2(string3) + 1).replace(reTrimStart2, "") : string3;
    }
    function baseUnary2(func) {
      return function(value) {
        return func(value);
      };
    }
    function baseValues(object4, props) {
      return arrayMap(props, function(key) {
        return object4[key];
      });
    }
    function cacheHas2(cache, key) {
      return cache.has(key);
    }
    function charsStartIndex(strSymbols, chrSymbols) {
      var index2 = -1, length = strSymbols.length;
      while (++index2 < length && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function charsEndIndex(strSymbols, chrSymbols) {
      var index2 = strSymbols.length;
      while (index2-- && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function countHolders(array4, placeholder) {
      var length = array4.length, result = 0;
      while (length--) {
        if (array4[length] === placeholder) {
          ++result;
        }
      }
      return result;
    }
    var deburrLetter = basePropertyOf(deburredLetters);
    var escapeHtmlChar = basePropertyOf(htmlEscapes);
    function escapeStringChar(chr) {
      return "\\" + stringEscapes[chr];
    }
    function getValue2(object4, key) {
      return object4 == null ? undefined$1 : object4[key];
    }
    function hasUnicode(string3) {
      return reHasUnicode.test(string3);
    }
    function hasUnicodeWord(string3) {
      return reHasUnicodeWord.test(string3);
    }
    function iteratorToArray(iterator2) {
      var data, result = [];
      while (!(data = iterator2.next()).done) {
        result.push(data.value);
      }
      return result;
    }
    function mapToArray2(map2) {
      var index2 = -1, result = Array(map2.size);
      map2.forEach(function(value, key) {
        result[++index2] = [key, value];
      });
      return result;
    }
    function overArg2(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function replaceHolders(array4, placeholder) {
      var index2 = -1, length = array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (value === placeholder || value === PLACEHOLDER) {
          array4[index2] = PLACEHOLDER;
          result[resIndex++] = index2;
        }
      }
      return result;
    }
    function setToArray2(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = value;
      });
      return result;
    }
    function setToPairs(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = [value, value];
      });
      return result;
    }
    function strictIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return -1;
    }
    function strictLastIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex + 1;
      while (index2--) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return index2;
    }
    function stringSize(string3) {
      return hasUnicode(string3) ? unicodeSize(string3) : asciiSize(string3);
    }
    function stringToArray(string3) {
      return hasUnicode(string3) ? unicodeToArray(string3) : asciiToArray(string3);
    }
    function trimmedEndIndex2(string3) {
      var index2 = string3.length;
      while (index2-- && reWhitespace2.test(string3.charAt(index2))) {
      }
      return index2;
    }
    var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
    function unicodeSize(string3) {
      var result = reUnicode.lastIndex = 0;
      while (reUnicode.test(string3)) {
        ++result;
      }
      return result;
    }
    function unicodeToArray(string3) {
      return string3.match(reUnicode) || [];
    }
    function unicodeWords(string3) {
      return string3.match(reUnicodeWord) || [];
    }
    var runInContext = function runInContext2(context) {
      context = context == null ? root2 : _.defaults(root2.Object(), context, _.pick(root2, contextProps));
      var Array2 = context.Array, Date2 = context.Date, Error2 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
      var arrayProto2 = Array2.prototype, funcProto2 = Function2.prototype, objectProto2 = Object2.prototype;
      var coreJsData2 = context["__core-js_shared__"];
      var funcToString2 = funcProto2.toString;
      var hasOwnProperty2 = objectProto2.hasOwnProperty;
      var idCounter = 0;
      var maskSrcKey2 = function() {
        var uid = /[^.]+$/.exec(coreJsData2 && coreJsData2.keys && coreJsData2.keys.IE_PROTO || "");
        return uid ? "Symbol(src)_1." + uid : "";
      }();
      var nativeObjectToString2 = objectProto2.toString;
      var objectCtorString = funcToString2.call(Object2);
      var oldDash = root2._;
      var reIsNative2 = RegExp2("^" + funcToString2.call(hasOwnProperty2).replace(reRegExpChar2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
      var Buffer2 = moduleExports ? context.Buffer : undefined$1, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined$1, getPrototype = overArg2(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable2 = objectProto2.propertyIsEnumerable, splice2 = arrayProto2.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined$1, symIterator = Symbol2 ? Symbol2.iterator : undefined$1, symToStringTag2 = Symbol2 ? Symbol2.toStringTag : undefined$1;
      var defineProperty = function() {
        try {
          var func = getNative2(Object2, "defineProperty");
          func({}, "", {});
          return func;
        } catch (e2) {
        }
      }();
      var ctxClearTimeout = context.clearTimeout !== root2.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root2.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root2.setTimeout && context.setTimeout;
      var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols2 = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined$1, nativeIsFinite = context.isFinite, nativeJoin = arrayProto2.join, nativeKeys2 = overArg2(Object2.keys, Object2), nativeMax2 = Math2.max, nativeMin2 = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto2.reverse;
      var DataView2 = getNative2(context, "DataView"), Map2 = getNative2(context, "Map"), Promise2 = getNative2(context, "Promise"), Set2 = getNative2(context, "Set"), WeakMap2 = getNative2(context, "WeakMap"), nativeCreate2 = getNative2(Object2, "create");
      var metaMap = WeakMap2 && new WeakMap2();
      var realNames = {};
      var dataViewCtorString2 = toSource2(DataView2), mapCtorString2 = toSource2(Map2), promiseCtorString2 = toSource2(Promise2), setCtorString2 = toSource2(Set2), weakMapCtorString2 = toSource2(WeakMap2);
      var symbolProto2 = Symbol2 ? Symbol2.prototype : undefined$1, symbolValueOf2 = symbolProto2 ? symbolProto2.valueOf : undefined$1, symbolToString = symbolProto2 ? symbolProto2.toString : undefined$1;
      function lodash2(value) {
        if (isObjectLike2(value) && !isArray2(value) && !(value instanceof LazyWrapper)) {
          if (value instanceof LodashWrapper) {
            return value;
          }
          if (hasOwnProperty2.call(value, "__wrapped__")) {
            return wrapperClone(value);
          }
        }
        return new LodashWrapper(value);
      }
      var baseCreate = function() {
        function object4() {
        }
        return function(proto2) {
          if (!isObject2(proto2)) {
            return {};
          }
          if (objectCreate) {
            return objectCreate(proto2);
          }
          object4.prototype = proto2;
          var result2 = new object4();
          object4.prototype = undefined$1;
          return result2;
        };
      }();
      function baseLodash() {
      }
      function LodashWrapper(value, chainAll) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__chain__ = !!chainAll;
        this.__index__ = 0;
        this.__values__ = undefined$1;
      }
      lodash2.templateSettings = {
        "escape": reEscape,
        "evaluate": reEvaluate,
        "interpolate": reInterpolate,
        "variable": "",
        "imports": {
          "_": lodash2
        }
      };
      lodash2.prototype = baseLodash.prototype;
      lodash2.prototype.constructor = lodash2;
      LodashWrapper.prototype = baseCreate(baseLodash.prototype);
      LodashWrapper.prototype.constructor = LodashWrapper;
      function LazyWrapper(value) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__dir__ = 1;
        this.__filtered__ = false;
        this.__iteratees__ = [];
        this.__takeCount__ = MAX_ARRAY_LENGTH;
        this.__views__ = [];
      }
      function lazyClone() {
        var result2 = new LazyWrapper(this.__wrapped__);
        result2.__actions__ = copyArray(this.__actions__);
        result2.__dir__ = this.__dir__;
        result2.__filtered__ = this.__filtered__;
        result2.__iteratees__ = copyArray(this.__iteratees__);
        result2.__takeCount__ = this.__takeCount__;
        result2.__views__ = copyArray(this.__views__);
        return result2;
      }
      function lazyReverse() {
        if (this.__filtered__) {
          var result2 = new LazyWrapper(this);
          result2.__dir__ = -1;
          result2.__filtered__ = true;
        } else {
          result2 = this.clone();
          result2.__dir__ *= -1;
        }
        return result2;
      }
      function lazyValue() {
        var array4 = this.__wrapped__.value(), dir3 = this.__dir__, isArr = isArray2(array4), isRight = dir3 < 0, arrLength = isArr ? array4.length : 0, view = getView(0, arrLength, this.__views__), start2 = view.start, end2 = view.end, length = end2 - start2, index2 = isRight ? end2 : start2 - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin2(length, this.__takeCount__);
        if (!isArr || !isRight && arrLength == length && takeCount == length) {
          return baseWrapperValue(array4, this.__actions__);
        }
        var result2 = [];
        outer:
          while (length-- && resIndex < takeCount) {
            index2 += dir3;
            var iterIndex = -1, value = array4[index2];
            while (++iterIndex < iterLength) {
              var data = iteratees[iterIndex], iteratee2 = data.iteratee, type4 = data.type, computed = iteratee2(value);
              if (type4 == LAZY_MAP_FLAG) {
                value = computed;
              } else if (!computed) {
                if (type4 == LAZY_FILTER_FLAG) {
                  continue outer;
                } else {
                  break outer;
                }
              }
            }
            result2[resIndex++] = value;
          }
        return result2;
      }
      LazyWrapper.prototype = baseCreate(baseLodash.prototype);
      LazyWrapper.prototype.constructor = LazyWrapper;
      function Hash2(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function hashClear2() {
        this.__data__ = nativeCreate2 ? nativeCreate2(null) : {};
        this.size = 0;
      }
      function hashDelete2(key) {
        var result2 = this.has(key) && delete this.__data__[key];
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function hashGet2(key) {
        var data = this.__data__;
        if (nativeCreate2) {
          var result2 = data[key];
          return result2 === HASH_UNDEFINED2 ? undefined$1 : result2;
        }
        return hasOwnProperty2.call(data, key) ? data[key] : undefined$1;
      }
      function hashHas2(key) {
        var data = this.__data__;
        return nativeCreate2 ? data[key] !== undefined$1 : hasOwnProperty2.call(data, key);
      }
      function hashSet2(key, value) {
        var data = this.__data__;
        this.size += this.has(key) ? 0 : 1;
        data[key] = nativeCreate2 && value === undefined$1 ? HASH_UNDEFINED2 : value;
        return this;
      }
      Hash2.prototype.clear = hashClear2;
      Hash2.prototype["delete"] = hashDelete2;
      Hash2.prototype.get = hashGet2;
      Hash2.prototype.has = hashHas2;
      Hash2.prototype.set = hashSet2;
      function ListCache2(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function listCacheClear2() {
        this.__data__ = [];
        this.size = 0;
      }
      function listCacheDelete2(key) {
        var data = this.__data__, index2 = assocIndexOf2(data, key);
        if (index2 < 0) {
          return false;
        }
        var lastIndex = data.length - 1;
        if (index2 == lastIndex) {
          data.pop();
        } else {
          splice2.call(data, index2, 1);
        }
        --this.size;
        return true;
      }
      function listCacheGet2(key) {
        var data = this.__data__, index2 = assocIndexOf2(data, key);
        return index2 < 0 ? undefined$1 : data[index2][1];
      }
      function listCacheHas2(key) {
        return assocIndexOf2(this.__data__, key) > -1;
      }
      function listCacheSet2(key, value) {
        var data = this.__data__, index2 = assocIndexOf2(data, key);
        if (index2 < 0) {
          ++this.size;
          data.push([key, value]);
        } else {
          data[index2][1] = value;
        }
        return this;
      }
      ListCache2.prototype.clear = listCacheClear2;
      ListCache2.prototype["delete"] = listCacheDelete2;
      ListCache2.prototype.get = listCacheGet2;
      ListCache2.prototype.has = listCacheHas2;
      ListCache2.prototype.set = listCacheSet2;
      function MapCache2(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function mapCacheClear2() {
        this.size = 0;
        this.__data__ = {
          "hash": new Hash2(),
          "map": new (Map2 || ListCache2)(),
          "string": new Hash2()
        };
      }
      function mapCacheDelete2(key) {
        var result2 = getMapData2(this, key)["delete"](key);
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function mapCacheGet2(key) {
        return getMapData2(this, key).get(key);
      }
      function mapCacheHas2(key) {
        return getMapData2(this, key).has(key);
      }
      function mapCacheSet2(key, value) {
        var data = getMapData2(this, key), size2 = data.size;
        data.set(key, value);
        this.size += data.size == size2 ? 0 : 1;
        return this;
      }
      MapCache2.prototype.clear = mapCacheClear2;
      MapCache2.prototype["delete"] = mapCacheDelete2;
      MapCache2.prototype.get = mapCacheGet2;
      MapCache2.prototype.has = mapCacheHas2;
      MapCache2.prototype.set = mapCacheSet2;
      function SetCache2(values2) {
        var index2 = -1, length = values2 == null ? 0 : values2.length;
        this.__data__ = new MapCache2();
        while (++index2 < length) {
          this.add(values2[index2]);
        }
      }
      function setCacheAdd2(value) {
        this.__data__.set(value, HASH_UNDEFINED2);
        return this;
      }
      function setCacheHas2(value) {
        return this.__data__.has(value);
      }
      SetCache2.prototype.add = SetCache2.prototype.push = setCacheAdd2;
      SetCache2.prototype.has = setCacheHas2;
      function Stack2(entries) {
        var data = this.__data__ = new ListCache2(entries);
        this.size = data.size;
      }
      function stackClear2() {
        this.__data__ = new ListCache2();
        this.size = 0;
      }
      function stackDelete2(key) {
        var data = this.__data__, result2 = data["delete"](key);
        this.size = data.size;
        return result2;
      }
      function stackGet2(key) {
        return this.__data__.get(key);
      }
      function stackHas2(key) {
        return this.__data__.has(key);
      }
      function stackSet2(key, value) {
        var data = this.__data__;
        if (data instanceof ListCache2) {
          var pairs = data.__data__;
          if (!Map2 || pairs.length < LARGE_ARRAY_SIZE2 - 1) {
            pairs.push([key, value]);
            this.size = ++data.size;
            return this;
          }
          data = this.__data__ = new MapCache2(pairs);
        }
        data.set(key, value);
        this.size = data.size;
        return this;
      }
      Stack2.prototype.clear = stackClear2;
      Stack2.prototype["delete"] = stackDelete2;
      Stack2.prototype.get = stackGet2;
      Stack2.prototype.has = stackHas2;
      Stack2.prototype.set = stackSet2;
      function arrayLikeKeys2(value, inherited) {
        var isArr = isArray2(value), isArg = !isArr && isArguments2(value), isBuff = !isArr && !isArg && isBuffer2(value), isType = !isArr && !isArg && !isBuff && isTypedArray2(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes2(value.length, String2) : [], length = result2.length;
        for (var key in value) {
          if ((inherited || hasOwnProperty2.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex2(key, length)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function arraySample(array4) {
        var length = array4.length;
        return length ? array4[baseRandom(0, length - 1)] : undefined$1;
      }
      function arraySampleSize(array4, n2) {
        return shuffleSelf(copyArray(array4), baseClamp(n2, 0, array4.length));
      }
      function arrayShuffle(array4) {
        return shuffleSelf(copyArray(array4));
      }
      function assignMergeValue(object4, key, value) {
        if (value !== undefined$1 && !eq2(object4[key], value) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assignValue(object4, key, value) {
        var objValue = object4[key];
        if (!(hasOwnProperty2.call(object4, key) && eq2(objValue, value)) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assocIndexOf2(array4, key) {
        var length = array4.length;
        while (length--) {
          if (eq2(array4[length][0], key)) {
            return length;
          }
        }
        return -1;
      }
      function baseAggregator(collection, setter, iteratee2, accumulator) {
        baseEach(collection, function(value, key, collection2) {
          setter(accumulator, value, iteratee2(value), collection2);
        });
        return accumulator;
      }
      function baseAssign(object4, source) {
        return object4 && copyObject(source, keys2(source), object4);
      }
      function baseAssignIn(object4, source) {
        return object4 && copyObject(source, keysIn(source), object4);
      }
      function baseAssignValue(object4, key, value) {
        if (key == "__proto__" && defineProperty) {
          defineProperty(object4, key, {
            "configurable": true,
            "enumerable": true,
            "value": value,
            "writable": true
          });
        } else {
          object4[key] = value;
        }
      }
      function baseAt(object4, paths) {
        var index2 = -1, length = paths.length, result2 = Array2(length), skip = object4 == null;
        while (++index2 < length) {
          result2[index2] = skip ? undefined$1 : get2(object4, paths[index2]);
        }
        return result2;
      }
      function baseClamp(number4, lower, upper) {
        if (number4 === number4) {
          if (upper !== undefined$1) {
            number4 = number4 <= upper ? number4 : upper;
          }
          if (lower !== undefined$1) {
            number4 = number4 >= lower ? number4 : lower;
          }
        }
        return number4;
      }
      function baseClone(value, bitmask, customizer, key, object4, stack) {
        var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
        if (customizer) {
          result2 = object4 ? customizer(value, key, object4, stack) : customizer(value);
        }
        if (result2 !== undefined$1) {
          return result2;
        }
        if (!isObject2(value)) {
          return value;
        }
        var isArr = isArray2(value);
        if (isArr) {
          result2 = initCloneArray(value);
          if (!isDeep) {
            return copyArray(value, result2);
          }
        } else {
          var tag = getTag2(value), isFunc = tag == funcTag2 || tag == genTag2;
          if (isBuffer2(value)) {
            return cloneBuffer(value, isDeep);
          }
          if (tag == objectTag2 || tag == argsTag2 || isFunc && !object4) {
            result2 = isFlat || isFunc ? {} : initCloneObject(value);
            if (!isDeep) {
              return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
            }
          } else {
            if (!cloneableTags[tag]) {
              return object4 ? value : {};
            }
            result2 = initCloneByTag(value, tag, isDeep);
          }
        }
        stack || (stack = new Stack2());
        var stacked = stack.get(value);
        if (stacked) {
          return stacked;
        }
        stack.set(value, result2);
        if (isSet(value)) {
          value.forEach(function(subValue) {
            result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
          });
        } else if (isMap(value)) {
          value.forEach(function(subValue, key2) {
            result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
        }
        var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys2 : isFlat ? keysIn : keys2;
        var props = isArr ? undefined$1 : keysFunc(value);
        arrayEach(props || value, function(subValue, key2) {
          if (props) {
            key2 = subValue;
            subValue = value[key2];
          }
          assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
        });
        return result2;
      }
      function baseConforms(source) {
        var props = keys2(source);
        return function(object4) {
          return baseConformsTo(object4, source, props);
        };
      }
      function baseConformsTo(object4, source, props) {
        var length = props.length;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (length--) {
          var key = props[length], predicate = source[key], value = object4[key];
          if (value === undefined$1 && !(key in object4) || !predicate(value)) {
            return false;
          }
        }
        return true;
      }
      function baseDelay(func, wait, args) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return setTimeout2(function() {
          func.apply(undefined$1, args);
        }, wait);
      }
      function baseDifference(array4, values2, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, isCommon = true, length = array4.length, result2 = [], valuesLength = values2.length;
        if (!length) {
          return result2;
        }
        if (iteratee2) {
          values2 = arrayMap(values2, baseUnary2(iteratee2));
        }
        if (comparator) {
          includes2 = arrayIncludesWith;
          isCommon = false;
        } else if (values2.length >= LARGE_ARRAY_SIZE2) {
          includes2 = cacheHas2;
          isCommon = false;
          values2 = new SetCache2(values2);
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 == null ? value : iteratee2(value);
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var valuesIndex = valuesLength;
              while (valuesIndex--) {
                if (values2[valuesIndex] === computed) {
                  continue outer;
                }
              }
              result2.push(value);
            } else if (!includes2(values2, computed, comparator)) {
              result2.push(value);
            }
          }
        return result2;
      }
      var baseEach = createBaseEach(baseForOwn);
      var baseEachRight = createBaseEach(baseForOwnRight, true);
      function baseEvery(collection, predicate) {
        var result2 = true;
        baseEach(collection, function(value, index2, collection2) {
          result2 = !!predicate(value, index2, collection2);
          return result2;
        });
        return result2;
      }
      function baseExtremum(array4, iteratee2, comparator) {
        var index2 = -1, length = array4.length;
        while (++index2 < length) {
          var value = array4[index2], current = iteratee2(value);
          if (current != null && (computed === undefined$1 ? current === current && !isSymbol2(current) : comparator(current, computed))) {
            var computed = current, result2 = value;
          }
        }
        return result2;
      }
      function baseFill(array4, value, start2, end2) {
        var length = array4.length;
        start2 = toInteger(start2);
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 === undefined$1 || end2 > length ? length : toInteger(end2);
        if (end2 < 0) {
          end2 += length;
        }
        end2 = start2 > end2 ? 0 : toLength(end2);
        while (start2 < end2) {
          array4[start2++] = value;
        }
        return array4;
      }
      function baseFilter(collection, predicate) {
        var result2 = [];
        baseEach(collection, function(value, index2, collection2) {
          if (predicate(value, index2, collection2)) {
            result2.push(value);
          }
        });
        return result2;
      }
      function baseFlatten(array4, depth, predicate, isStrict, result2) {
        var index2 = -1, length = array4.length;
        predicate || (predicate = isFlattenable);
        result2 || (result2 = []);
        while (++index2 < length) {
          var value = array4[index2];
          if (depth > 0 && predicate(value)) {
            if (depth > 1) {
              baseFlatten(value, depth - 1, predicate, isStrict, result2);
            } else {
              arrayPush2(result2, value);
            }
          } else if (!isStrict) {
            result2[result2.length] = value;
          }
        }
        return result2;
      }
      var baseFor = createBaseFor();
      var baseForRight = createBaseFor(true);
      function baseForOwn(object4, iteratee2) {
        return object4 && baseFor(object4, iteratee2, keys2);
      }
      function baseForOwnRight(object4, iteratee2) {
        return object4 && baseForRight(object4, iteratee2, keys2);
      }
      function baseFunctions(object4, props) {
        return arrayFilter2(props, function(key) {
          return isFunction2(object4[key]);
        });
      }
      function baseGet(object4, path) {
        path = castPath(path, object4);
        var index2 = 0, length = path.length;
        while (object4 != null && index2 < length) {
          object4 = object4[toKey(path[index2++])];
        }
        return index2 && index2 == length ? object4 : undefined$1;
      }
      function baseGetAllKeys2(object4, keysFunc, symbolsFunc) {
        var result2 = keysFunc(object4);
        return isArray2(object4) ? result2 : arrayPush2(result2, symbolsFunc(object4));
      }
      function baseGetTag2(value) {
        if (value == null) {
          return value === undefined$1 ? undefinedTag2 : nullTag2;
        }
        return symToStringTag2 && symToStringTag2 in Object2(value) ? getRawTag2(value) : objectToString2(value);
      }
      function baseGt(value, other) {
        return value > other;
      }
      function baseHas(object4, key) {
        return object4 != null && hasOwnProperty2.call(object4, key);
      }
      function baseHasIn(object4, key) {
        return object4 != null && key in Object2(object4);
      }
      function baseInRange(number4, start2, end2) {
        return number4 >= nativeMin2(start2, end2) && number4 < nativeMax2(start2, end2);
      }
      function baseIntersection(arrays, iteratee2, comparator) {
        var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result2 = [];
        while (othIndex--) {
          var array4 = arrays[othIndex];
          if (othIndex && iteratee2) {
            array4 = arrayMap(array4, baseUnary2(iteratee2));
          }
          maxLength = nativeMin2(array4.length, maxLength);
          caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array4.length >= 120) ? new SetCache2(othIndex && array4) : undefined$1;
        }
        array4 = arrays[0];
        var index2 = -1, seen = caches[0];
        outer:
          while (++index2 < length && result2.length < maxLength) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (!(seen ? cacheHas2(seen, computed) : includes2(result2, computed, comparator))) {
              othIndex = othLength;
              while (--othIndex) {
                var cache = caches[othIndex];
                if (!(cache ? cacheHas2(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                  continue outer;
                }
              }
              if (seen) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseInverter(object4, setter, iteratee2, accumulator) {
        baseForOwn(object4, function(value, key, object5) {
          setter(accumulator, iteratee2(value), key, object5);
        });
        return accumulator;
      }
      function baseInvoke(object4, path, args) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        var func = object4 == null ? object4 : object4[toKey(last(path))];
        return func == null ? undefined$1 : apply(func, object4, args);
      }
      function baseIsArguments2(value) {
        return isObjectLike2(value) && baseGetTag2(value) == argsTag2;
      }
      function baseIsArrayBuffer(value) {
        return isObjectLike2(value) && baseGetTag2(value) == arrayBufferTag2;
      }
      function baseIsDate(value) {
        return isObjectLike2(value) && baseGetTag2(value) == dateTag2;
      }
      function baseIsEqual2(value, other, bitmask, customizer, stack) {
        if (value === other) {
          return true;
        }
        if (value == null || other == null || !isObjectLike2(value) && !isObjectLike2(other)) {
          return value !== value && other !== other;
        }
        return baseIsEqualDeep2(value, other, bitmask, customizer, baseIsEqual2, stack);
      }
      function baseIsEqualDeep2(object4, other, bitmask, customizer, equalFunc, stack) {
        var objIsArr = isArray2(object4), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag2 : getTag2(object4), othTag = othIsArr ? arrayTag2 : getTag2(other);
        objTag = objTag == argsTag2 ? objectTag2 : objTag;
        othTag = othTag == argsTag2 ? objectTag2 : othTag;
        var objIsObj = objTag == objectTag2, othIsObj = othTag == objectTag2, isSameTag = objTag == othTag;
        if (isSameTag && isBuffer2(object4)) {
          if (!isBuffer2(other)) {
            return false;
          }
          objIsArr = true;
          objIsObj = false;
        }
        if (isSameTag && !objIsObj) {
          stack || (stack = new Stack2());
          return objIsArr || isTypedArray2(object4) ? equalArrays2(object4, other, bitmask, customizer, equalFunc, stack) : equalByTag2(object4, other, objTag, bitmask, customizer, equalFunc, stack);
        }
        if (!(bitmask & COMPARE_PARTIAL_FLAG2)) {
          var objIsWrapped = objIsObj && hasOwnProperty2.call(object4, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
          if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object4.value() : object4, othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new Stack2());
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
          }
        }
        if (!isSameTag) {
          return false;
        }
        stack || (stack = new Stack2());
        return equalObjects2(object4, other, bitmask, customizer, equalFunc, stack);
      }
      function baseIsMap(value) {
        return isObjectLike2(value) && getTag2(value) == mapTag2;
      }
      function baseIsMatch(object4, source, matchData, customizer) {
        var index2 = matchData.length, length = index2, noCustomizer = !customizer;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (index2--) {
          var data = matchData[index2];
          if (noCustomizer && data[2] ? data[1] !== object4[data[0]] : !(data[0] in object4)) {
            return false;
          }
        }
        while (++index2 < length) {
          data = matchData[index2];
          var key = data[0], objValue = object4[key], srcValue = data[1];
          if (noCustomizer && data[2]) {
            if (objValue === undefined$1 && !(key in object4)) {
              return false;
            }
          } else {
            var stack = new Stack2();
            if (customizer) {
              var result2 = customizer(objValue, srcValue, key, object4, source, stack);
            }
            if (!(result2 === undefined$1 ? baseIsEqual2(srcValue, objValue, COMPARE_PARTIAL_FLAG2 | COMPARE_UNORDERED_FLAG2, customizer, stack) : result2)) {
              return false;
            }
          }
        }
        return true;
      }
      function baseIsNative2(value) {
        if (!isObject2(value) || isMasked2(value)) {
          return false;
        }
        var pattern4 = isFunction2(value) ? reIsNative2 : reIsHostCtor2;
        return pattern4.test(toSource2(value));
      }
      function baseIsRegExp(value) {
        return isObjectLike2(value) && baseGetTag2(value) == regexpTag2;
      }
      function baseIsSet(value) {
        return isObjectLike2(value) && getTag2(value) == setTag2;
      }
      function baseIsTypedArray2(value) {
        return isObjectLike2(value) && isLength2(value.length) && !!typedArrayTags2[baseGetTag2(value)];
      }
      function baseIteratee(value) {
        if (typeof value == "function") {
          return value;
        }
        if (value == null) {
          return identity2;
        }
        if (typeof value == "object") {
          return isArray2(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
        }
        return property(value);
      }
      function baseKeys2(object4) {
        if (!isPrototype2(object4)) {
          return nativeKeys2(object4);
        }
        var result2 = [];
        for (var key in Object2(object4)) {
          if (hasOwnProperty2.call(object4, key) && key != "constructor") {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseKeysIn(object4) {
        if (!isObject2(object4)) {
          return nativeKeysIn(object4);
        }
        var isProto = isPrototype2(object4), result2 = [];
        for (var key in object4) {
          if (!(key == "constructor" && (isProto || !hasOwnProperty2.call(object4, key)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseLt(value, other) {
        return value < other;
      }
      function baseMap(collection, iteratee2) {
        var index2 = -1, result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value, key, collection2) {
          result2[++index2] = iteratee2(value, key, collection2);
        });
        return result2;
      }
      function baseMatches(source) {
        var matchData = getMatchData(source);
        if (matchData.length == 1 && matchData[0][2]) {
          return matchesStrictComparable(matchData[0][0], matchData[0][1]);
        }
        return function(object4) {
          return object4 === source || baseIsMatch(object4, source, matchData);
        };
      }
      function baseMatchesProperty(path, srcValue) {
        if (isKey(path) && isStrictComparable(srcValue)) {
          return matchesStrictComparable(toKey(path), srcValue);
        }
        return function(object4) {
          var objValue = get2(object4, path);
          return objValue === undefined$1 && objValue === srcValue ? hasIn(object4, path) : baseIsEqual2(srcValue, objValue, COMPARE_PARTIAL_FLAG2 | COMPARE_UNORDERED_FLAG2);
        };
      }
      function baseMerge(object4, source, srcIndex, customizer, stack) {
        if (object4 === source) {
          return;
        }
        baseFor(source, function(srcValue, key) {
          stack || (stack = new Stack2());
          if (isObject2(srcValue)) {
            baseMergeDeep(object4, source, key, srcIndex, baseMerge, customizer, stack);
          } else {
            var newValue = customizer ? customizer(safeGet(object4, key), srcValue, key + "", object4, source, stack) : undefined$1;
            if (newValue === undefined$1) {
              newValue = srcValue;
            }
            assignMergeValue(object4, key, newValue);
          }
        }, keysIn);
      }
      function baseMergeDeep(object4, source, key, srcIndex, mergeFunc, customizer, stack) {
        var objValue = safeGet(object4, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
        if (stacked) {
          assignMergeValue(object4, key, stacked);
          return;
        }
        var newValue = customizer ? customizer(objValue, srcValue, key + "", object4, source, stack) : undefined$1;
        var isCommon = newValue === undefined$1;
        if (isCommon) {
          var isArr = isArray2(srcValue), isBuff = !isArr && isBuffer2(srcValue), isTyped = !isArr && !isBuff && isTypedArray2(srcValue);
          newValue = srcValue;
          if (isArr || isBuff || isTyped) {
            if (isArray2(objValue)) {
              newValue = objValue;
            } else if (isArrayLikeObject(objValue)) {
              newValue = copyArray(objValue);
            } else if (isBuff) {
              isCommon = false;
              newValue = cloneBuffer(srcValue, true);
            } else if (isTyped) {
              isCommon = false;
              newValue = cloneTypedArray(srcValue, true);
            } else {
              newValue = [];
            }
          } else if (isPlainObject(srcValue) || isArguments2(srcValue)) {
            newValue = objValue;
            if (isArguments2(objValue)) {
              newValue = toPlainObject(objValue);
            } else if (!isObject2(objValue) || isFunction2(objValue)) {
              newValue = initCloneObject(srcValue);
            }
          } else {
            isCommon = false;
          }
        }
        if (isCommon) {
          stack.set(srcValue, newValue);
          mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
          stack["delete"](srcValue);
        }
        assignMergeValue(object4, key, newValue);
      }
      function baseNth(array4, n2) {
        var length = array4.length;
        if (!length) {
          return;
        }
        n2 += n2 < 0 ? length : 0;
        return isIndex2(n2, length) ? array4[n2] : undefined$1;
      }
      function baseOrderBy(collection, iteratees, orders) {
        if (iteratees.length) {
          iteratees = arrayMap(iteratees, function(iteratee2) {
            if (isArray2(iteratee2)) {
              return function(value) {
                return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
              };
            }
            return iteratee2;
          });
        } else {
          iteratees = [identity2];
        }
        var index2 = -1;
        iteratees = arrayMap(iteratees, baseUnary2(getIteratee()));
        var result2 = baseMap(collection, function(value, key, collection2) {
          var criteria = arrayMap(iteratees, function(iteratee2) {
            return iteratee2(value);
          });
          return { "criteria": criteria, "index": ++index2, "value": value };
        });
        return baseSortBy(result2, function(object4, other) {
          return compareMultiple(object4, other, orders);
        });
      }
      function basePick(object4, paths) {
        return basePickBy(object4, paths, function(value, path) {
          return hasIn(object4, path);
        });
      }
      function basePickBy(object4, paths, predicate) {
        var index2 = -1, length = paths.length, result2 = {};
        while (++index2 < length) {
          var path = paths[index2], value = baseGet(object4, path);
          if (predicate(value, path)) {
            baseSet(result2, castPath(path, object4), value);
          }
        }
        return result2;
      }
      function basePropertyDeep(path) {
        return function(object4) {
          return baseGet(object4, path);
        };
      }
      function basePullAll(array4, values2, iteratee2, comparator) {
        var indexOf3 = comparator ? baseIndexOfWith : baseIndexOf, index2 = -1, length = values2.length, seen = array4;
        if (array4 === values2) {
          values2 = copyArray(values2);
        }
        if (iteratee2) {
          seen = arrayMap(array4, baseUnary2(iteratee2));
        }
        while (++index2 < length) {
          var fromIndex = 0, value = values2[index2], computed = iteratee2 ? iteratee2(value) : value;
          while ((fromIndex = indexOf3(seen, computed, fromIndex, comparator)) > -1) {
            if (seen !== array4) {
              splice2.call(seen, fromIndex, 1);
            }
            splice2.call(array4, fromIndex, 1);
          }
        }
        return array4;
      }
      function basePullAt(array4, indexes) {
        var length = array4 ? indexes.length : 0, lastIndex = length - 1;
        while (length--) {
          var index2 = indexes[length];
          if (length == lastIndex || index2 !== previous) {
            var previous = index2;
            if (isIndex2(index2)) {
              splice2.call(array4, index2, 1);
            } else {
              baseUnset(array4, index2);
            }
          }
        }
        return array4;
      }
      function baseRandom(lower, upper) {
        return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
      }
      function baseRange(start2, end2, step, fromRight) {
        var index2 = -1, length = nativeMax2(nativeCeil((end2 - start2) / (step || 1)), 0), result2 = Array2(length);
        while (length--) {
          result2[fromRight ? length : ++index2] = start2;
          start2 += step;
        }
        return result2;
      }
      function baseRepeat(string3, n2) {
        var result2 = "";
        if (!string3 || n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return result2;
        }
        do {
          if (n2 % 2) {
            result2 += string3;
          }
          n2 = nativeFloor(n2 / 2);
          if (n2) {
            string3 += string3;
          }
        } while (n2);
        return result2;
      }
      function baseRest(func, start2) {
        return setToString(overRest(func, start2, identity2), func + "");
      }
      function baseSample(collection) {
        return arraySample(values(collection));
      }
      function baseSampleSize(collection, n2) {
        var array4 = values(collection);
        return shuffleSelf(array4, baseClamp(n2, 0, array4.length));
      }
      function baseSet(object4, path, value, customizer) {
        if (!isObject2(object4)) {
          return object4;
        }
        path = castPath(path, object4);
        var index2 = -1, length = path.length, lastIndex = length - 1, nested = object4;
        while (nested != null && ++index2 < length) {
          var key = toKey(path[index2]), newValue = value;
          if (key === "__proto__" || key === "constructor" || key === "prototype") {
            return object4;
          }
          if (index2 != lastIndex) {
            var objValue = nested[key];
            newValue = customizer ? customizer(objValue, key, nested) : undefined$1;
            if (newValue === undefined$1) {
              newValue = isObject2(objValue) ? objValue : isIndex2(path[index2 + 1]) ? [] : {};
            }
          }
          assignValue(nested, key, newValue);
          nested = nested[key];
        }
        return object4;
      }
      var baseSetData = !metaMap ? identity2 : function(func, data) {
        metaMap.set(func, data);
        return func;
      };
      var baseSetToString = !defineProperty ? identity2 : function(func, string3) {
        return defineProperty(func, "toString", {
          "configurable": true,
          "enumerable": false,
          "value": constant(string3),
          "writable": true
        });
      };
      function baseShuffle(collection) {
        return shuffleSelf(values(collection));
      }
      function baseSlice(array4, start2, end2) {
        var index2 = -1, length = array4.length;
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 > length ? length : end2;
        if (end2 < 0) {
          end2 += length;
        }
        length = start2 > end2 ? 0 : end2 - start2 >>> 0;
        start2 >>>= 0;
        var result2 = Array2(length);
        while (++index2 < length) {
          result2[index2] = array4[index2 + start2];
        }
        return result2;
      }
      function baseSome(collection, predicate) {
        var result2;
        baseEach(collection, function(value, index2, collection2) {
          result2 = predicate(value, index2, collection2);
          return !result2;
        });
        return !!result2;
      }
      function baseSortedIndex(array4, value, retHighest) {
        var low = 0, high = array4 == null ? low : array4.length;
        if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
          while (low < high) {
            var mid = low + high >>> 1, computed = array4[mid];
            if (computed !== null && !isSymbol2(computed) && (retHighest ? computed <= value : computed < value)) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return high;
        }
        return baseSortedIndexBy(array4, value, identity2, retHighest);
      }
      function baseSortedIndexBy(array4, value, iteratee2, retHighest) {
        var low = 0, high = array4 == null ? 0 : array4.length;
        if (high === 0) {
          return 0;
        }
        value = iteratee2(value);
        var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol2(value), valIsUndefined = value === undefined$1;
        while (low < high) {
          var mid = nativeFloor((low + high) / 2), computed = iteratee2(array4[mid]), othIsDefined = computed !== undefined$1, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol2(computed);
          if (valIsNaN) {
            var setLow = retHighest || othIsReflexive;
          } else if (valIsUndefined) {
            setLow = othIsReflexive && (retHighest || othIsDefined);
          } else if (valIsNull) {
            setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
          } else if (valIsSymbol) {
            setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
          } else if (othIsNull || othIsSymbol) {
            setLow = false;
          } else {
            setLow = retHighest ? computed <= value : computed < value;
          }
          if (setLow) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return nativeMin2(high, MAX_ARRAY_INDEX);
      }
      function baseSortedUniq(array4, iteratee2) {
        var index2 = -1, length = array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
          if (!index2 || !eq2(computed, seen)) {
            var seen = computed;
            result2[resIndex++] = value === 0 ? 0 : value;
          }
        }
        return result2;
      }
      function baseToNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        return +value;
      }
      function baseToString(value) {
        if (typeof value == "string") {
          return value;
        }
        if (isArray2(value)) {
          return arrayMap(value, baseToString) + "";
        }
        if (isSymbol2(value)) {
          return symbolToString ? symbolToString.call(value) : "";
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function baseUniq(array4, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, length = array4.length, isCommon = true, result2 = [], seen = result2;
        if (comparator) {
          isCommon = false;
          includes2 = arrayIncludesWith;
        } else if (length >= LARGE_ARRAY_SIZE2) {
          var set3 = iteratee2 ? null : createSet(array4);
          if (set3) {
            return setToArray2(set3);
          }
          isCommon = false;
          includes2 = cacheHas2;
          seen = new SetCache2();
        } else {
          seen = iteratee2 ? [] : result2;
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var seenIndex = seen.length;
              while (seenIndex--) {
                if (seen[seenIndex] === computed) {
                  continue outer;
                }
              }
              if (iteratee2) {
                seen.push(computed);
              }
              result2.push(value);
            } else if (!includes2(seen, computed, comparator)) {
              if (seen !== result2) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseUnset(object4, path) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        return object4 == null || delete object4[toKey(last(path))];
      }
      function baseUpdate(object4, path, updater, customizer) {
        return baseSet(object4, path, updater(baseGet(object4, path)), customizer);
      }
      function baseWhile(array4, predicate, isDrop, fromRight) {
        var length = array4.length, index2 = fromRight ? length : -1;
        while ((fromRight ? index2-- : ++index2 < length) && predicate(array4[index2], index2, array4)) {
        }
        return isDrop ? baseSlice(array4, fromRight ? 0 : index2, fromRight ? index2 + 1 : length) : baseSlice(array4, fromRight ? index2 + 1 : 0, fromRight ? length : index2);
      }
      function baseWrapperValue(value, actions2) {
        var result2 = value;
        if (result2 instanceof LazyWrapper) {
          result2 = result2.value();
        }
        return arrayReduce(actions2, function(result3, action) {
          return action.func.apply(action.thisArg, arrayPush2([result3], action.args));
        }, result2);
      }
      function baseXor(arrays, iteratee2, comparator) {
        var length = arrays.length;
        if (length < 2) {
          return length ? baseUniq(arrays[0]) : [];
        }
        var index2 = -1, result2 = Array2(length);
        while (++index2 < length) {
          var array4 = arrays[index2], othIndex = -1;
          while (++othIndex < length) {
            if (othIndex != index2) {
              result2[index2] = baseDifference(result2[index2] || array4, arrays[othIndex], iteratee2, comparator);
            }
          }
        }
        return baseUniq(baseFlatten(result2, 1), iteratee2, comparator);
      }
      function baseZipObject(props, values2, assignFunc) {
        var index2 = -1, length = props.length, valsLength = values2.length, result2 = {};
        while (++index2 < length) {
          var value = index2 < valsLength ? values2[index2] : undefined$1;
          assignFunc(result2, props[index2], value);
        }
        return result2;
      }
      function castArrayLikeObject(value) {
        return isArrayLikeObject(value) ? value : [];
      }
      function castFunction(value) {
        return typeof value == "function" ? value : identity2;
      }
      function castPath(value, object4) {
        if (isArray2(value)) {
          return value;
        }
        return isKey(value, object4) ? [value] : stringToPath(toString(value));
      }
      var castRest = baseRest;
      function castSlice(array4, start2, end2) {
        var length = array4.length;
        end2 = end2 === undefined$1 ? length : end2;
        return !start2 && end2 >= length ? array4 : baseSlice(array4, start2, end2);
      }
      var clearTimeout2 = ctxClearTimeout || function(id2) {
        return root2.clearTimeout(id2);
      };
      function cloneBuffer(buffer, isDeep) {
        if (isDeep) {
          return buffer.slice();
        }
        var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
        buffer.copy(result2);
        return result2;
      }
      function cloneArrayBuffer(arrayBuffer) {
        var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
        new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
        return result2;
      }
      function cloneDataView(dataView, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
        return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
      }
      function cloneRegExp(regexp4) {
        var result2 = new regexp4.constructor(regexp4.source, reFlags.exec(regexp4));
        result2.lastIndex = regexp4.lastIndex;
        return result2;
      }
      function cloneSymbol(symbol) {
        return symbolValueOf2 ? Object2(symbolValueOf2.call(symbol)) : {};
      }
      function cloneTypedArray(typedArray, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
        return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
      }
      function compareAscending(value, other) {
        if (value !== other) {
          var valIsDefined = value !== undefined$1, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol2(value);
          var othIsDefined = other !== undefined$1, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol2(other);
          if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
            return 1;
          }
          if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
            return -1;
          }
        }
        return 0;
      }
      function compareMultiple(object4, other, orders) {
        var index2 = -1, objCriteria = object4.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
        while (++index2 < length) {
          var result2 = compareAscending(objCriteria[index2], othCriteria[index2]);
          if (result2) {
            if (index2 >= ordersLength) {
              return result2;
            }
            var order = orders[index2];
            return result2 * (order == "desc" ? -1 : 1);
          }
        }
        return object4.index - other.index;
      }
      function composeArgs(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
        while (++leftIndex < leftLength) {
          result2[leftIndex] = partials[leftIndex];
        }
        while (++argsIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[holders[argsIndex]] = args[argsIndex];
          }
        }
        while (rangeLength--) {
          result2[leftIndex++] = args[argsIndex++];
        }
        return result2;
      }
      function composeArgsRight(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
        while (++argsIndex < rangeLength) {
          result2[argsIndex] = args[argsIndex];
        }
        var offset2 = argsIndex;
        while (++rightIndex < rightLength) {
          result2[offset2 + rightIndex] = partials[rightIndex];
        }
        while (++holdersIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[offset2 + holders[holdersIndex]] = args[argsIndex++];
          }
        }
        return result2;
      }
      function copyArray(source, array4) {
        var index2 = -1, length = source.length;
        array4 || (array4 = Array2(length));
        while (++index2 < length) {
          array4[index2] = source[index2];
        }
        return array4;
      }
      function copyObject(source, props, object4, customizer) {
        var isNew = !object4;
        object4 || (object4 = {});
        var index2 = -1, length = props.length;
        while (++index2 < length) {
          var key = props[index2];
          var newValue = customizer ? customizer(object4[key], source[key], key, object4, source) : undefined$1;
          if (newValue === undefined$1) {
            newValue = source[key];
          }
          if (isNew) {
            baseAssignValue(object4, key, newValue);
          } else {
            assignValue(object4, key, newValue);
          }
        }
        return object4;
      }
      function copySymbols(source, object4) {
        return copyObject(source, getSymbols2(source), object4);
      }
      function copySymbolsIn(source, object4) {
        return copyObject(source, getSymbolsIn(source), object4);
      }
      function createAggregator(setter, initializer) {
        return function(collection, iteratee2) {
          var func = isArray2(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
          return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
        };
      }
      function createAssigner(assigner) {
        return baseRest(function(object4, sources) {
          var index2 = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined$1, guard = length > 2 ? sources[2] : undefined$1;
          customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined$1;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            customizer = length < 3 ? undefined$1 : customizer;
            length = 1;
          }
          object4 = Object2(object4);
          while (++index2 < length) {
            var source = sources[index2];
            if (source) {
              assigner(object4, source, index2, customizer);
            }
          }
          return object4;
        });
      }
      function createBaseEach(eachFunc, fromRight) {
        return function(collection, iteratee2) {
          if (collection == null) {
            return collection;
          }
          if (!isArrayLike2(collection)) {
            return eachFunc(collection, iteratee2);
          }
          var length = collection.length, index2 = fromRight ? length : -1, iterable = Object2(collection);
          while (fromRight ? index2-- : ++index2 < length) {
            if (iteratee2(iterable[index2], index2, iterable) === false) {
              break;
            }
          }
          return collection;
        };
      }
      function createBaseFor(fromRight) {
        return function(object4, iteratee2, keysFunc) {
          var index2 = -1, iterable = Object2(object4), props = keysFunc(object4), length = props.length;
          while (length--) {
            var key = props[fromRight ? length : ++index2];
            if (iteratee2(iterable[key], key, iterable) === false) {
              break;
            }
          }
          return object4;
        };
      }
      function createBind(func, bitmask, thisArg) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return fn.apply(isBind ? thisArg : this, arguments);
        }
        return wrapper;
      }
      function createCaseFirst(methodName) {
        return function(string3) {
          string3 = toString(string3);
          var strSymbols = hasUnicode(string3) ? stringToArray(string3) : undefined$1;
          var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
          var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string3.slice(1);
          return chr[methodName]() + trailing;
        };
      }
      function createCompounder(callback) {
        return function(string3) {
          return arrayReduce(words(deburr(string3).replace(reApos, "")), callback, "");
        };
      }
      function createCtor(Ctor) {
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return new Ctor();
            case 1:
              return new Ctor(args[0]);
            case 2:
              return new Ctor(args[0], args[1]);
            case 3:
              return new Ctor(args[0], args[1], args[2]);
            case 4:
              return new Ctor(args[0], args[1], args[2], args[3]);
            case 5:
              return new Ctor(args[0], args[1], args[2], args[3], args[4]);
            case 6:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
            case 7:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
          }
          var thisBinding = baseCreate(Ctor.prototype), result2 = Ctor.apply(thisBinding, args);
          return isObject2(result2) ? result2 : thisBinding;
        };
      }
      function createCurry(func, bitmask, arity) {
        var Ctor = createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length, placeholder = getHolder(wrapper);
          while (index2--) {
            args[index2] = arguments[index2];
          }
          var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
          length -= holders.length;
          if (length < arity) {
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, undefined$1, args, holders, undefined$1, undefined$1, arity - length);
          }
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return apply(fn, this, args);
        }
        return wrapper;
      }
      function createFind(findIndexFunc) {
        return function(collection, predicate, fromIndex) {
          var iterable = Object2(collection);
          if (!isArrayLike2(collection)) {
            var iteratee2 = getIteratee(predicate, 3);
            collection = keys2(collection);
            predicate = function(key) {
              return iteratee2(iterable[key], key, iterable);
            };
          }
          var index2 = findIndexFunc(collection, predicate, fromIndex);
          return index2 > -1 ? iterable[iteratee2 ? collection[index2] : index2] : undefined$1;
        };
      }
      function createFlow(fromRight) {
        return flatRest(function(funcs) {
          var length = funcs.length, index2 = length, prereq = LodashWrapper.prototype.thru;
          if (fromRight) {
            funcs.reverse();
          }
          while (index2--) {
            var func = funcs[index2];
            if (typeof func != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT2);
            }
            if (prereq && !wrapper && getFuncName(func) == "wrapper") {
              var wrapper = new LodashWrapper([], true);
            }
          }
          index2 = wrapper ? index2 : length;
          while (++index2 < length) {
            func = funcs[index2];
            var funcName = getFuncName(func), data = funcName == "wrapper" ? getData(func) : undefined$1;
            if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
              wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
            } else {
              wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
            }
          }
          return function() {
            var args = arguments, value = args[0];
            if (wrapper && args.length == 1 && isArray2(value)) {
              return wrapper.plant(value).value();
            }
            var index3 = 0, result2 = length ? funcs[index3].apply(this, args) : value;
            while (++index3 < length) {
              result2 = funcs[index3].call(this, result2);
            }
            return result2;
          };
        });
      }
      function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
        var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined$1 : createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length;
          while (index2--) {
            args[index2] = arguments[index2];
          }
          if (isCurried) {
            var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
          }
          if (partials) {
            args = composeArgs(args, partials, holders, isCurried);
          }
          if (partialsRight) {
            args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
          }
          length -= holdersCount;
          if (isCurried && length < arity) {
            var newHolders = replaceHolders(args, placeholder);
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, thisArg, args, newHolders, argPos, ary2, arity - length);
          }
          var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
          length = args.length;
          if (argPos) {
            args = reorder(args, argPos);
          } else if (isFlip && length > 1) {
            args.reverse();
          }
          if (isAry && ary2 < length) {
            args.length = ary2;
          }
          if (this && this !== root2 && this instanceof wrapper) {
            fn = Ctor || createCtor(fn);
          }
          return fn.apply(thisBinding, args);
        }
        return wrapper;
      }
      function createInverter(setter, toIteratee) {
        return function(object4, iteratee2) {
          return baseInverter(object4, setter, toIteratee(iteratee2), {});
        };
      }
      function createMathOperation(operator, defaultValue) {
        return function(value, other) {
          var result2;
          if (value === undefined$1 && other === undefined$1) {
            return defaultValue;
          }
          if (value !== undefined$1) {
            result2 = value;
          }
          if (other !== undefined$1) {
            if (result2 === undefined$1) {
              return other;
            }
            if (typeof value == "string" || typeof other == "string") {
              value = baseToString(value);
              other = baseToString(other);
            } else {
              value = baseToNumber(value);
              other = baseToNumber(other);
            }
            result2 = operator(value, other);
          }
          return result2;
        };
      }
      function createOver(arrayFunc) {
        return flatRest(function(iteratees) {
          iteratees = arrayMap(iteratees, baseUnary2(getIteratee()));
          return baseRest(function(args) {
            var thisArg = this;
            return arrayFunc(iteratees, function(iteratee2) {
              return apply(iteratee2, thisArg, args);
            });
          });
        });
      }
      function createPadding(length, chars) {
        chars = chars === undefined$1 ? " " : baseToString(chars);
        var charsLength = chars.length;
        if (charsLength < 2) {
          return charsLength ? baseRepeat(chars, length) : chars;
        }
        var result2 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
        return hasUnicode(chars) ? castSlice(stringToArray(result2), 0, length).join("") : result2.slice(0, length);
      }
      function createPartial(func, bitmask, thisArg, partials) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          while (++leftIndex < leftLength) {
            args[leftIndex] = partials[leftIndex];
          }
          while (argsLength--) {
            args[leftIndex++] = arguments[++argsIndex];
          }
          return apply(fn, isBind ? thisArg : this, args);
        }
        return wrapper;
      }
      function createRange(fromRight) {
        return function(start2, end2, step) {
          if (step && typeof step != "number" && isIterateeCall(start2, end2, step)) {
            end2 = step = undefined$1;
          }
          start2 = toFinite(start2);
          if (end2 === undefined$1) {
            end2 = start2;
            start2 = 0;
          } else {
            end2 = toFinite(end2);
          }
          step = step === undefined$1 ? start2 < end2 ? 1 : -1 : toFinite(step);
          return baseRange(start2, end2, step, fromRight);
        };
      }
      function createRelationalOperation(operator) {
        return function(value, other) {
          if (!(typeof value == "string" && typeof other == "string")) {
            value = toNumber2(value);
            other = toNumber2(other);
          }
          return operator(value, other);
        };
      }
      function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
        var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined$1, newHoldersRight = isCurry ? undefined$1 : holders, newPartials = isCurry ? partials : undefined$1, newPartialsRight = isCurry ? undefined$1 : partials;
        bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
        bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
        if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
          bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
        }
        var newData = [
          func,
          bitmask,
          thisArg,
          newPartials,
          newHolders,
          newPartialsRight,
          newHoldersRight,
          argPos,
          ary2,
          arity
        ];
        var result2 = wrapFunc.apply(undefined$1, newData);
        if (isLaziable(func)) {
          setData(result2, newData);
        }
        result2.placeholder = placeholder;
        return setWrapToString(result2, func, bitmask);
      }
      function createRound(methodName) {
        var func = Math2[methodName];
        return function(number4, precision) {
          number4 = toNumber2(number4);
          precision = precision == null ? 0 : nativeMin2(toInteger(precision), 292);
          if (precision && nativeIsFinite(number4)) {
            var pair = (toString(number4) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
            pair = (toString(value) + "e").split("e");
            return +(pair[0] + "e" + (+pair[1] - precision));
          }
          return func(number4);
        };
      }
      var createSet = !(Set2 && 1 / setToArray2(new Set2([, -0]))[1] == INFINITY) ? noop2 : function(values2) {
        return new Set2(values2);
      };
      function createToPairs(keysFunc) {
        return function(object4) {
          var tag = getTag2(object4);
          if (tag == mapTag2) {
            return mapToArray2(object4);
          }
          if (tag == setTag2) {
            return setToPairs(object4);
          }
          return baseToPairs(object4, keysFunc(object4));
        };
      }
      function createWrap2(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
        var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
        if (!isBindKey && typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var length = partials ? partials.length : 0;
        if (!length) {
          bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
          partials = holders = undefined$1;
        }
        ary2 = ary2 === undefined$1 ? ary2 : nativeMax2(toInteger(ary2), 0);
        arity = arity === undefined$1 ? arity : toInteger(arity);
        length -= holders ? holders.length : 0;
        if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
          var partialsRight = partials, holdersRight = holders;
          partials = holders = undefined$1;
        }
        var data = isBindKey ? undefined$1 : getData(func);
        var newData = [
          func,
          bitmask,
          thisArg,
          partials,
          holders,
          partialsRight,
          holdersRight,
          argPos,
          ary2,
          arity
        ];
        if (data) {
          mergeData(newData, data);
        }
        func = newData[0];
        bitmask = newData[1];
        thisArg = newData[2];
        partials = newData[3];
        holders = newData[4];
        arity = newData[9] = newData[9] === undefined$1 ? isBindKey ? 0 : func.length : nativeMax2(newData[9] - length, 0);
        if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
          bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
        }
        if (!bitmask || bitmask == WRAP_BIND_FLAG) {
          var result2 = createBind(func, bitmask, thisArg);
        } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
          result2 = createCurry(func, bitmask, arity);
        } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
          result2 = createPartial(func, bitmask, thisArg, partials);
        } else {
          result2 = createHybrid.apply(undefined$1, newData);
        }
        var setter = data ? baseSetData : setData;
        return setWrapToString(setter(result2, newData), func, bitmask);
      }
      function customDefaultsAssignIn(objValue, srcValue, key, object4) {
        if (objValue === undefined$1 || eq2(objValue, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
          return srcValue;
        }
        return objValue;
      }
      function customDefaultsMerge(objValue, srcValue, key, object4, source, stack) {
        if (isObject2(objValue) && isObject2(srcValue)) {
          stack.set(srcValue, objValue);
          baseMerge(objValue, srcValue, undefined$1, customDefaultsMerge, stack);
          stack["delete"](srcValue);
        }
        return objValue;
      }
      function customOmitClone(value) {
        return isPlainObject(value) ? undefined$1 : value;
      }
      function equalArrays2(array4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG2, arrLength = array4.length, othLength = other.length;
        if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
          return false;
        }
        var arrStacked = stack.get(array4);
        var othStacked = stack.get(other);
        if (arrStacked && othStacked) {
          return arrStacked == other && othStacked == array4;
        }
        var index2 = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG2 ? new SetCache2() : undefined$1;
        stack.set(array4, other);
        stack.set(other, array4);
        while (++index2 < arrLength) {
          var arrValue = array4[index2], othValue = other[index2];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, arrValue, index2, other, array4, stack) : customizer(arrValue, othValue, index2, array4, other, stack);
          }
          if (compared !== undefined$1) {
            if (compared) {
              continue;
            }
            result2 = false;
            break;
          }
          if (seen) {
            if (!arraySome2(other, function(othValue2, othIndex) {
              if (!cacheHas2(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                return seen.push(othIndex);
              }
            })) {
              result2 = false;
              break;
            }
          } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
            result2 = false;
            break;
          }
        }
        stack["delete"](array4);
        stack["delete"](other);
        return result2;
      }
      function equalByTag2(object4, other, tag, bitmask, customizer, equalFunc, stack) {
        switch (tag) {
          case dataViewTag2:
            if (object4.byteLength != other.byteLength || object4.byteOffset != other.byteOffset) {
              return false;
            }
            object4 = object4.buffer;
            other = other.buffer;
          case arrayBufferTag2:
            if (object4.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object4), new Uint8Array2(other))) {
              return false;
            }
            return true;
          case boolTag2:
          case dateTag2:
          case numberTag2:
            return eq2(+object4, +other);
          case errorTag2:
            return object4.name == other.name && object4.message == other.message;
          case regexpTag2:
          case stringTag2:
            return object4 == other + "";
          case mapTag2:
            var convert = mapToArray2;
          case setTag2:
            var isPartial = bitmask & COMPARE_PARTIAL_FLAG2;
            convert || (convert = setToArray2);
            if (object4.size != other.size && !isPartial) {
              return false;
            }
            var stacked = stack.get(object4);
            if (stacked) {
              return stacked == other;
            }
            bitmask |= COMPARE_UNORDERED_FLAG2;
            stack.set(object4, other);
            var result2 = equalArrays2(convert(object4), convert(other), bitmask, customizer, equalFunc, stack);
            stack["delete"](object4);
            return result2;
          case symbolTag2:
            if (symbolValueOf2) {
              return symbolValueOf2.call(object4) == symbolValueOf2.call(other);
            }
        }
        return false;
      }
      function equalObjects2(object4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG2, objProps = getAllKeys2(object4), objLength = objProps.length, othProps = getAllKeys2(other), othLength = othProps.length;
        if (objLength != othLength && !isPartial) {
          return false;
        }
        var index2 = objLength;
        while (index2--) {
          var key = objProps[index2];
          if (!(isPartial ? key in other : hasOwnProperty2.call(other, key))) {
            return false;
          }
        }
        var objStacked = stack.get(object4);
        var othStacked = stack.get(other);
        if (objStacked && othStacked) {
          return objStacked == other && othStacked == object4;
        }
        var result2 = true;
        stack.set(object4, other);
        stack.set(other, object4);
        var skipCtor = isPartial;
        while (++index2 < objLength) {
          key = objProps[index2];
          var objValue = object4[key], othValue = other[key];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, objValue, key, other, object4, stack) : customizer(objValue, othValue, key, object4, other, stack);
          }
          if (!(compared === undefined$1 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
            result2 = false;
            break;
          }
          skipCtor || (skipCtor = key == "constructor");
        }
        if (result2 && !skipCtor) {
          var objCtor = object4.constructor, othCtor = other.constructor;
          if (objCtor != othCtor && ("constructor" in object4 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
            result2 = false;
          }
        }
        stack["delete"](object4);
        stack["delete"](other);
        return result2;
      }
      function flatRest(func) {
        return setToString(overRest(func, undefined$1, flatten), func + "");
      }
      function getAllKeys2(object4) {
        return baseGetAllKeys2(object4, keys2, getSymbols2);
      }
      function getAllKeysIn(object4) {
        return baseGetAllKeys2(object4, keysIn, getSymbolsIn);
      }
      var getData = !metaMap ? noop2 : function(func) {
        return metaMap.get(func);
      };
      function getFuncName(func) {
        var result2 = func.name + "", array4 = realNames[result2], length = hasOwnProperty2.call(realNames, result2) ? array4.length : 0;
        while (length--) {
          var data = array4[length], otherFunc = data.func;
          if (otherFunc == null || otherFunc == func) {
            return data.name;
          }
        }
        return result2;
      }
      function getHolder(func) {
        var object4 = hasOwnProperty2.call(lodash2, "placeholder") ? lodash2 : func;
        return object4.placeholder;
      }
      function getIteratee() {
        var result2 = lodash2.iteratee || iteratee;
        result2 = result2 === iteratee ? baseIteratee : result2;
        return arguments.length ? result2(arguments[0], arguments[1]) : result2;
      }
      function getMapData2(map3, key) {
        var data = map3.__data__;
        return isKeyable2(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
      }
      function getMatchData(object4) {
        var result2 = keys2(object4), length = result2.length;
        while (length--) {
          var key = result2[length], value = object4[key];
          result2[length] = [key, value, isStrictComparable(value)];
        }
        return result2;
      }
      function getNative2(object4, key) {
        var value = getValue2(object4, key);
        return baseIsNative2(value) ? value : undefined$1;
      }
      function getRawTag2(value) {
        var isOwn = hasOwnProperty2.call(value, symToStringTag2), tag = value[symToStringTag2];
        try {
          value[symToStringTag2] = undefined$1;
          var unmasked = true;
        } catch (e2) {
        }
        var result2 = nativeObjectToString2.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag2] = tag;
          } else {
            delete value[symToStringTag2];
          }
        }
        return result2;
      }
      var getSymbols2 = !nativeGetSymbols2 ? stubArray2 : function(object4) {
        if (object4 == null) {
          return [];
        }
        object4 = Object2(object4);
        return arrayFilter2(nativeGetSymbols2(object4), function(symbol) {
          return propertyIsEnumerable2.call(object4, symbol);
        });
      };
      var getSymbolsIn = !nativeGetSymbols2 ? stubArray2 : function(object4) {
        var result2 = [];
        while (object4) {
          arrayPush2(result2, getSymbols2(object4));
          object4 = getPrototype(object4);
        }
        return result2;
      };
      var getTag2 = baseGetTag2;
      if (DataView2 && getTag2(new DataView2(new ArrayBuffer(1))) != dataViewTag2 || Map2 && getTag2(new Map2()) != mapTag2 || Promise2 && getTag2(Promise2.resolve()) != promiseTag2 || Set2 && getTag2(new Set2()) != setTag2 || WeakMap2 && getTag2(new WeakMap2()) != weakMapTag2) {
        getTag2 = function(value) {
          var result2 = baseGetTag2(value), Ctor = result2 == objectTag2 ? value.constructor : undefined$1, ctorString = Ctor ? toSource2(Ctor) : "";
          if (ctorString) {
            switch (ctorString) {
              case dataViewCtorString2:
                return dataViewTag2;
              case mapCtorString2:
                return mapTag2;
              case promiseCtorString2:
                return promiseTag2;
              case setCtorString2:
                return setTag2;
              case weakMapCtorString2:
                return weakMapTag2;
            }
          }
          return result2;
        };
      }
      function getView(start2, end2, transforms) {
        var index2 = -1, length = transforms.length;
        while (++index2 < length) {
          var data = transforms[index2], size2 = data.size;
          switch (data.type) {
            case "drop":
              start2 += size2;
              break;
            case "dropRight":
              end2 -= size2;
              break;
            case "take":
              end2 = nativeMin2(end2, start2 + size2);
              break;
            case "takeRight":
              start2 = nativeMax2(start2, end2 - size2);
              break;
          }
        }
        return { "start": start2, "end": end2 };
      }
      function getWrapDetails(source) {
        var match = source.match(reWrapDetails);
        return match ? match[1].split(reSplitDetails) : [];
      }
      function hasPath(object4, path, hasFunc) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length, result2 = false;
        while (++index2 < length) {
          var key = toKey(path[index2]);
          if (!(result2 = object4 != null && hasFunc(object4, key))) {
            break;
          }
          object4 = object4[key];
        }
        if (result2 || ++index2 != length) {
          return result2;
        }
        length = object4 == null ? 0 : object4.length;
        return !!length && isLength2(length) && isIndex2(key, length) && (isArray2(object4) || isArguments2(object4));
      }
      function initCloneArray(array4) {
        var length = array4.length, result2 = new array4.constructor(length);
        if (length && typeof array4[0] == "string" && hasOwnProperty2.call(array4, "index")) {
          result2.index = array4.index;
          result2.input = array4.input;
        }
        return result2;
      }
      function initCloneObject(object4) {
        return typeof object4.constructor == "function" && !isPrototype2(object4) ? baseCreate(getPrototype(object4)) : {};
      }
      function initCloneByTag(object4, tag, isDeep) {
        var Ctor = object4.constructor;
        switch (tag) {
          case arrayBufferTag2:
            return cloneArrayBuffer(object4);
          case boolTag2:
          case dateTag2:
            return new Ctor(+object4);
          case dataViewTag2:
            return cloneDataView(object4, isDeep);
          case float32Tag2:
          case float64Tag2:
          case int8Tag2:
          case int16Tag2:
          case int32Tag2:
          case uint8Tag2:
          case uint8ClampedTag2:
          case uint16Tag2:
          case uint32Tag2:
            return cloneTypedArray(object4, isDeep);
          case mapTag2:
            return new Ctor();
          case numberTag2:
          case stringTag2:
            return new Ctor(object4);
          case regexpTag2:
            return cloneRegExp(object4);
          case setTag2:
            return new Ctor();
          case symbolTag2:
            return cloneSymbol(object4);
        }
      }
      function insertWrapDetails(source, details) {
        var length = details.length;
        if (!length) {
          return source;
        }
        var lastIndex = length - 1;
        details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
        details = details.join(length > 2 ? ", " : " ");
        return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
      }
      function isFlattenable(value) {
        return isArray2(value) || isArguments2(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
      }
      function isIndex2(value, length) {
        var type4 = typeof value;
        length = length == null ? MAX_SAFE_INTEGER2 : length;
        return !!length && (type4 == "number" || type4 != "symbol" && reIsUint2.test(value)) && (value > -1 && value % 1 == 0 && value < length);
      }
      function isIterateeCall(value, index2, object4) {
        if (!isObject2(object4)) {
          return false;
        }
        var type4 = typeof index2;
        if (type4 == "number" ? isArrayLike2(object4) && isIndex2(index2, object4.length) : type4 == "string" && index2 in object4) {
          return eq2(object4[index2], value);
        }
        return false;
      }
      function isKey(value, object4) {
        if (isArray2(value)) {
          return false;
        }
        var type4 = typeof value;
        if (type4 == "number" || type4 == "symbol" || type4 == "boolean" || value == null || isSymbol2(value)) {
          return true;
        }
        return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object4 != null && value in Object2(object4);
      }
      function isKeyable2(value) {
        var type4 = typeof value;
        return type4 == "string" || type4 == "number" || type4 == "symbol" || type4 == "boolean" ? value !== "__proto__" : value === null;
      }
      function isLaziable(func) {
        var funcName = getFuncName(func), other = lodash2[funcName];
        if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
          return false;
        }
        if (func === other) {
          return true;
        }
        var data = getData(other);
        return !!data && func === data[0];
      }
      function isMasked2(func) {
        return !!maskSrcKey2 && maskSrcKey2 in func;
      }
      var isMaskable = coreJsData2 ? isFunction2 : stubFalse2;
      function isPrototype2(value) {
        var Ctor = value && value.constructor, proto2 = typeof Ctor == "function" && Ctor.prototype || objectProto2;
        return value === proto2;
      }
      function isStrictComparable(value) {
        return value === value && !isObject2(value);
      }
      function matchesStrictComparable(key, srcValue) {
        return function(object4) {
          if (object4 == null) {
            return false;
          }
          return object4[key] === srcValue && (srcValue !== undefined$1 || key in Object2(object4));
        };
      }
      function memoizeCapped(func) {
        var result2 = memoize(func, function(key) {
          if (cache.size === MAX_MEMOIZE_SIZE) {
            cache.clear();
          }
          return key;
        });
        var cache = result2.cache;
        return result2;
      }
      function mergeData(data, source) {
        var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
        var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
        if (!(isCommon || isCombo)) {
          return data;
        }
        if (srcBitmask & WRAP_BIND_FLAG) {
          data[2] = source[2];
          newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
        }
        var value = source[3];
        if (value) {
          var partials = data[3];
          data[3] = partials ? composeArgs(partials, value, source[4]) : value;
          data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
        }
        value = source[5];
        if (value) {
          partials = data[5];
          data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
          data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
        }
        value = source[7];
        if (value) {
          data[7] = value;
        }
        if (srcBitmask & WRAP_ARY_FLAG) {
          data[8] = data[8] == null ? source[8] : nativeMin2(data[8], source[8]);
        }
        if (data[9] == null) {
          data[9] = source[9];
        }
        data[0] = source[0];
        data[1] = newBitmask;
        return data;
      }
      function nativeKeysIn(object4) {
        var result2 = [];
        if (object4 != null) {
          for (var key in Object2(object4)) {
            result2.push(key);
          }
        }
        return result2;
      }
      function objectToString2(value) {
        return nativeObjectToString2.call(value);
      }
      function overRest(func, start2, transform3) {
        start2 = nativeMax2(start2 === undefined$1 ? func.length - 1 : start2, 0);
        return function() {
          var args = arguments, index2 = -1, length = nativeMax2(args.length - start2, 0), array4 = Array2(length);
          while (++index2 < length) {
            array4[index2] = args[start2 + index2];
          }
          index2 = -1;
          var otherArgs = Array2(start2 + 1);
          while (++index2 < start2) {
            otherArgs[index2] = args[index2];
          }
          otherArgs[start2] = transform3(array4);
          return apply(func, this, otherArgs);
        };
      }
      function parent(object4, path) {
        return path.length < 2 ? object4 : baseGet(object4, baseSlice(path, 0, -1));
      }
      function reorder(array4, indexes) {
        var arrLength = array4.length, length = nativeMin2(indexes.length, arrLength), oldArray = copyArray(array4);
        while (length--) {
          var index2 = indexes[length];
          array4[length] = isIndex2(index2, arrLength) ? oldArray[index2] : undefined$1;
        }
        return array4;
      }
      function safeGet(object4, key) {
        if (key === "constructor" && typeof object4[key] === "function") {
          return;
        }
        if (key == "__proto__") {
          return;
        }
        return object4[key];
      }
      var setData = shortOut(baseSetData);
      var setTimeout2 = ctxSetTimeout || function(func, wait) {
        return root2.setTimeout(func, wait);
      };
      var setToString = shortOut(baseSetToString);
      function setWrapToString(wrapper, reference, bitmask) {
        var source = reference + "";
        return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
      }
      function shortOut(func) {
        var count2 = 0, lastCalled = 0;
        return function() {
          var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
          lastCalled = stamp;
          if (remaining > 0) {
            if (++count2 >= HOT_COUNT) {
              return arguments[0];
            }
          } else {
            count2 = 0;
          }
          return func.apply(undefined$1, arguments);
        };
      }
      function shuffleSelf(array4, size2) {
        var index2 = -1, length = array4.length, lastIndex = length - 1;
        size2 = size2 === undefined$1 ? length : size2;
        while (++index2 < size2) {
          var rand = baseRandom(index2, lastIndex), value = array4[rand];
          array4[rand] = array4[index2];
          array4[index2] = value;
        }
        array4.length = size2;
        return array4;
      }
      var stringToPath = memoizeCapped(function(string3) {
        var result2 = [];
        if (string3.charCodeAt(0) === 46) {
          result2.push("");
        }
        string3.replace(rePropName, function(match, number4, quote, subString) {
          result2.push(quote ? subString.replace(reEscapeChar, "$1") : number4 || match);
        });
        return result2;
      });
      function toKey(value) {
        if (typeof value == "string" || isSymbol2(value)) {
          return value;
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function toSource2(func) {
        if (func != null) {
          try {
            return funcToString2.call(func);
          } catch (e2) {
          }
          try {
            return func + "";
          } catch (e2) {
          }
        }
        return "";
      }
      function updateWrapDetails(details, bitmask) {
        arrayEach(wrapFlags, function(pair) {
          var value = "_." + pair[0];
          if (bitmask & pair[1] && !arrayIncludes(details, value)) {
            details.push(value);
          }
        });
        return details.sort();
      }
      function wrapperClone(wrapper) {
        if (wrapper instanceof LazyWrapper) {
          return wrapper.clone();
        }
        var result2 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
        result2.__actions__ = copyArray(wrapper.__actions__);
        result2.__index__ = wrapper.__index__;
        result2.__values__ = wrapper.__values__;
        return result2;
      }
      function chunk(array4, size2, guard) {
        if (guard ? isIterateeCall(array4, size2, guard) : size2 === undefined$1) {
          size2 = 1;
        } else {
          size2 = nativeMax2(toInteger(size2), 0);
        }
        var length = array4 == null ? 0 : array4.length;
        if (!length || size2 < 1) {
          return [];
        }
        var index2 = 0, resIndex = 0, result2 = Array2(nativeCeil(length / size2));
        while (index2 < length) {
          result2[resIndex++] = baseSlice(array4, index2, index2 += size2);
        }
        return result2;
      }
      function compact(array4) {
        var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2];
          if (value) {
            result2[resIndex++] = value;
          }
        }
        return result2;
      }
      function concat() {
        var length = arguments.length;
        if (!length) {
          return [];
        }
        var args = Array2(length - 1), array4 = arguments[0], index2 = length;
        while (index2--) {
          args[index2 - 1] = arguments[index2];
        }
        return arrayPush2(isArray2(array4) ? copyArray(array4) : [array4], baseFlatten(args, 1));
      }
      var difference = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
      });
      var differenceBy = baseRest(function(array4, values2) {
        var iteratee2 = last(values2);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
      });
      var differenceWith = baseRest(function(array4, values2) {
        var comparator = last(values2);
        if (isArrayLikeObject(comparator)) {
          comparator = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), undefined$1, comparator) : [];
      });
      function drop(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function dropRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function dropRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true, true) : [];
      }
      function dropWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true) : [];
      }
      function fill(array4, value, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (start2 && typeof start2 != "number" && isIterateeCall(array4, value, start2)) {
          start2 = 0;
          end2 = length;
        }
        return baseFill(array4, value, start2, end2);
      }
      function findIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2);
      }
      function findLastIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length - 1;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = fromIndex < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2, true);
      }
      function flatten(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, 1) : [];
      }
      function flattenDeep(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, INFINITY) : [];
      }
      function flattenDepth(array4, depth) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(array4, depth);
      }
      function fromPairs(pairs) {
        var index2 = -1, length = pairs == null ? 0 : pairs.length, result2 = {};
        while (++index2 < length) {
          var pair = pairs[index2];
          result2[pair[0]] = pair[1];
        }
        return result2;
      }
      function head(array4) {
        return array4 && array4.length ? array4[0] : undefined$1;
      }
      function indexOf2(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseIndexOf(array4, value, index2);
      }
      function initial(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 0, -1) : [];
      }
      var intersection = baseRest(function(arrays) {
        var mapped = arrayMap(arrays, castArrayLikeObject);
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
      });
      var intersectionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        if (iteratee2 === last(mapped)) {
          iteratee2 = undefined$1;
        } else {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
      });
      var intersectionWith = baseRest(function(arrays) {
        var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        if (comparator) {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined$1, comparator) : [];
      });
      function join(array4, separator) {
        return array4 == null ? "" : nativeJoin.call(array4, separator);
      }
      function last(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? array4[length - 1] : undefined$1;
      }
      function lastIndexOf(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = index2 < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return value === value ? strictLastIndexOf(array4, value, index2) : baseFindIndex(array4, baseIsNaN, index2, true);
      }
      function nth(array4, n2) {
        return array4 && array4.length ? baseNth(array4, toInteger(n2)) : undefined$1;
      }
      var pull = baseRest(pullAll);
      function pullAll(array4, values2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2) : array4;
      }
      function pullAllBy(array4, values2, iteratee2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, getIteratee(iteratee2, 2)) : array4;
      }
      function pullAllWith(array4, values2, comparator) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, undefined$1, comparator) : array4;
      }
      var pullAt = flatRest(function(array4, indexes) {
        var length = array4 == null ? 0 : array4.length, result2 = baseAt(array4, indexes);
        basePullAt(array4, arrayMap(indexes, function(index2) {
          return isIndex2(index2, length) ? +index2 : index2;
        }).sort(compareAscending));
        return result2;
      });
      function remove(array4, predicate) {
        var result2 = [];
        if (!(array4 && array4.length)) {
          return result2;
        }
        var index2 = -1, indexes = [], length = array4.length;
        predicate = getIteratee(predicate, 3);
        while (++index2 < length) {
          var value = array4[index2];
          if (predicate(value, index2, array4)) {
            result2.push(value);
            indexes.push(index2);
          }
        }
        basePullAt(array4, indexes);
        return result2;
      }
      function reverse2(array4) {
        return array4 == null ? array4 : nativeReverse.call(array4);
      }
      function slice2(array4, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (end2 && typeof end2 != "number" && isIterateeCall(array4, start2, end2)) {
          start2 = 0;
          end2 = length;
        } else {
          start2 = start2 == null ? 0 : toInteger(start2);
          end2 = end2 === undefined$1 ? length : toInteger(end2);
        }
        return baseSlice(array4, start2, end2);
      }
      function sortedIndex(array4, value) {
        return baseSortedIndex(array4, value);
      }
      function sortedIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2));
      }
      function sortedIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value);
          if (index2 < length && eq2(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedLastIndex(array4, value) {
        return baseSortedIndex(array4, value, true);
      }
      function sortedLastIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2), true);
      }
      function sortedLastIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value, true) - 1;
          if (eq2(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedUniq(array4) {
        return array4 && array4.length ? baseSortedUniq(array4) : [];
      }
      function sortedUniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseSortedUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function tail(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 1, length) : [];
      }
      function take2(array4, n2, guard) {
        if (!(array4 && array4.length)) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function takeRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function takeRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), false, true) : [];
      }
      function takeWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3)) : [];
      }
      var union = baseRest(function(arrays) {
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
      });
      var unionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
      });
      var unionWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined$1, comparator);
      });
      function uniq(array4) {
        return array4 && array4.length ? baseUniq(array4) : [];
      }
      function uniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function uniqWith(array4, comparator) {
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return array4 && array4.length ? baseUniq(array4, undefined$1, comparator) : [];
      }
      function unzip(array4) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var length = 0;
        array4 = arrayFilter2(array4, function(group) {
          if (isArrayLikeObject(group)) {
            length = nativeMax2(group.length, length);
            return true;
          }
        });
        return baseTimes2(length, function(index2) {
          return arrayMap(array4, baseProperty(index2));
        });
      }
      function unzipWith(array4, iteratee2) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var result2 = unzip(array4);
        if (iteratee2 == null) {
          return result2;
        }
        return arrayMap(result2, function(group) {
          return apply(iteratee2, undefined$1, group);
        });
      }
      var without = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, values2) : [];
      });
      var xor = baseRest(function(arrays) {
        return baseXor(arrayFilter2(arrays, isArrayLikeObject));
      });
      var xorBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseXor(arrayFilter2(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
      });
      var xorWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseXor(arrayFilter2(arrays, isArrayLikeObject), undefined$1, comparator);
      });
      var zip = baseRest(unzip);
      function zipObject(props, values2) {
        return baseZipObject(props || [], values2 || [], assignValue);
      }
      function zipObjectDeep(props, values2) {
        return baseZipObject(props || [], values2 || [], baseSet);
      }
      var zipWith = baseRest(function(arrays) {
        var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined$1;
        iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined$1;
        return unzipWith(arrays, iteratee2);
      });
      function chain(value) {
        var result2 = lodash2(value);
        result2.__chain__ = true;
        return result2;
      }
      function tap(value, interceptor) {
        interceptor(value);
        return value;
      }
      function thru(value, interceptor) {
        return interceptor(value);
      }
      var wrapperAt = flatRest(function(paths) {
        var length = paths.length, start2 = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object4) {
          return baseAt(object4, paths);
        };
        if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex2(start2)) {
          return this.thru(interceptor);
        }
        value = value.slice(start2, +start2 + (length ? 1 : 0));
        value.__actions__.push({
          "func": thru,
          "args": [interceptor],
          "thisArg": undefined$1
        });
        return new LodashWrapper(value, this.__chain__).thru(function(array4) {
          if (length && !array4.length) {
            array4.push(undefined$1);
          }
          return array4;
        });
      });
      function wrapperChain() {
        return chain(this);
      }
      function wrapperCommit() {
        return new LodashWrapper(this.value(), this.__chain__);
      }
      function wrapperNext() {
        if (this.__values__ === undefined$1) {
          this.__values__ = toArray2(this.value());
        }
        var done = this.__index__ >= this.__values__.length, value = done ? undefined$1 : this.__values__[this.__index__++];
        return { "done": done, "value": value };
      }
      function wrapperToIterator() {
        return this;
      }
      function wrapperPlant(value) {
        var result2, parent2 = this;
        while (parent2 instanceof baseLodash) {
          var clone4 = wrapperClone(parent2);
          clone4.__index__ = 0;
          clone4.__values__ = undefined$1;
          if (result2) {
            previous.__wrapped__ = clone4;
          } else {
            result2 = clone4;
          }
          var previous = clone4;
          parent2 = parent2.__wrapped__;
        }
        previous.__wrapped__ = value;
        return result2;
      }
      function wrapperReverse() {
        var value = this.__wrapped__;
        if (value instanceof LazyWrapper) {
          var wrapped = value;
          if (this.__actions__.length) {
            wrapped = new LazyWrapper(this);
          }
          wrapped = wrapped.reverse();
          wrapped.__actions__.push({
            "func": thru,
            "args": [reverse2],
            "thisArg": undefined$1
          });
          return new LodashWrapper(wrapped, this.__chain__);
        }
        return this.thru(reverse2);
      }
      function wrapperValue() {
        return baseWrapperValue(this.__wrapped__, this.__actions__);
      }
      var countBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          ++result2[key];
        } else {
          baseAssignValue(result2, key, 1);
        }
      });
      function every(collection, predicate, guard) {
        var func = isArray2(collection) ? arrayEvery : baseEvery;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      function filter2(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter2 : baseFilter;
        return func(collection, getIteratee(predicate, 3));
      }
      var find2 = createFind(findIndex);
      var findLast = createFind(findLastIndex);
      function flatMap(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), 1);
      }
      function flatMapDeep(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), INFINITY);
      }
      function flatMapDepth(collection, iteratee2, depth) {
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(map2(collection, iteratee2), depth);
      }
      function forEach(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEach : baseEach;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function forEachRight(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEachRight : baseEachRight;
        return func(collection, getIteratee(iteratee2, 3));
      }
      var groupBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          result2[key].push(value);
        } else {
          baseAssignValue(result2, key, [value]);
        }
      });
      function includes(collection, value, fromIndex, guard) {
        collection = isArrayLike2(collection) ? collection : values(collection);
        fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
        var length = collection.length;
        if (fromIndex < 0) {
          fromIndex = nativeMax2(length + fromIndex, 0);
        }
        return isString2(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
      }
      var invokeMap = baseRest(function(collection, path, args) {
        var index2 = -1, isFunc = typeof path == "function", result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value) {
          result2[++index2] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
        });
        return result2;
      });
      var keyBy = createAggregator(function(result2, value, key) {
        baseAssignValue(result2, key, value);
      });
      function map2(collection, iteratee2) {
        var func = isArray2(collection) ? arrayMap : baseMap;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function orderBy(collection, iteratees, orders, guard) {
        if (collection == null) {
          return [];
        }
        if (!isArray2(iteratees)) {
          iteratees = iteratees == null ? [] : [iteratees];
        }
        orders = guard ? undefined$1 : orders;
        if (!isArray2(orders)) {
          orders = orders == null ? [] : [orders];
        }
        return baseOrderBy(collection, iteratees, orders);
      }
      var partition = createAggregator(function(result2, value, key) {
        result2[key ? 0 : 1].push(value);
      }, function() {
        return [[], []];
      });
      function reduce2(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
      }
      function reduceRight(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
      }
      function reject(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter2 : baseFilter;
        return func(collection, negate(getIteratee(predicate, 3)));
      }
      function sample(collection) {
        var func = isArray2(collection) ? arraySample : baseSample;
        return func(collection);
      }
      function sampleSize(collection, n2, guard) {
        if (guard ? isIterateeCall(collection, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        var func = isArray2(collection) ? arraySampleSize : baseSampleSize;
        return func(collection, n2);
      }
      function shuffle(collection) {
        var func = isArray2(collection) ? arrayShuffle : baseShuffle;
        return func(collection);
      }
      function size(collection) {
        if (collection == null) {
          return 0;
        }
        if (isArrayLike2(collection)) {
          return isString2(collection) ? stringSize(collection) : collection.length;
        }
        var tag = getTag2(collection);
        if (tag == mapTag2 || tag == setTag2) {
          return collection.size;
        }
        return baseKeys2(collection).length;
      }
      function some(collection, predicate, guard) {
        var func = isArray2(collection) ? arraySome2 : baseSome;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      var sortBy = baseRest(function(collection, iteratees) {
        if (collection == null) {
          return [];
        }
        var length = iteratees.length;
        if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
          iteratees = [];
        } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
          iteratees = [iteratees[0]];
        }
        return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
      });
      var now2 = ctxNow || function() {
        return root2.Date.now();
      };
      function after(n2, func) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 < 1) {
            return func.apply(this, arguments);
          }
        };
      }
      function ary(func, n2, guard) {
        n2 = guard ? undefined$1 : n2;
        n2 = func && n2 == null ? func.length : n2;
        return createWrap2(func, WRAP_ARY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, n2);
      }
      function before(n2, func) {
        var result2;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 > 0) {
            result2 = func.apply(this, arguments);
          }
          if (n2 <= 1) {
            func = undefined$1;
          }
          return result2;
        };
      }
      var bind2 = baseRest(function(func, thisArg, partials) {
        var bitmask = WRAP_BIND_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bind2));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(func, bitmask, thisArg, partials, holders);
      });
      var bindKey = baseRest(function(object4, key, partials) {
        var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bindKey));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(key, bitmask, object4, partials, holders);
      });
      function curry2(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curry2.placeholder;
        return result2;
      }
      function curryRight(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_RIGHT_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curryRight.placeholder;
        return result2;
      }
      function debounce2(func, wait, options) {
        var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        wait = toNumber2(wait) || 0;
        if (isObject2(options)) {
          leading = !!options.leading;
          maxing = "maxWait" in options;
          maxWait = maxing ? nativeMax2(toNumber2(options.maxWait) || 0, wait) : maxWait;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = undefined$1;
          lastInvokeTime = time;
          result2 = func.apply(thisArg, args);
          return result2;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout2(timerExpired, wait);
          return leading ? invokeFunc(time) : result2;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin2(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === undefined$1 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now2();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout2(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = undefined$1;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = undefined$1;
          return result2;
        }
        function cancel2() {
          if (timerId !== undefined$1) {
            clearTimeout2(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = undefined$1;
        }
        function flush() {
          return timerId === undefined$1 ? result2 : trailingEdge(now2());
        }
        function debounced() {
          var time = now2(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === undefined$1) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout2(timerId);
              timerId = setTimeout2(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === undefined$1) {
            timerId = setTimeout2(timerExpired, wait);
          }
          return result2;
        }
        debounced.cancel = cancel2;
        debounced.flush = flush;
        return debounced;
      }
      var defer = baseRest(function(func, args) {
        return baseDelay(func, 1, args);
      });
      var delay = baseRest(function(func, wait, args) {
        return baseDelay(func, toNumber2(wait) || 0, args);
      });
      function flip2(func) {
        return createWrap2(func, WRAP_FLIP_FLAG);
      }
      function memoize(func, resolver) {
        if (typeof func != "function" || resolver != null && typeof resolver != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var memoized = function() {
          var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
          if (cache.has(key)) {
            return cache.get(key);
          }
          var result2 = func.apply(this, args);
          memoized.cache = cache.set(key, result2) || cache;
          return result2;
        };
        memoized.cache = new (memoize.Cache || MapCache2)();
        return memoized;
      }
      memoize.Cache = MapCache2;
      function negate(predicate) {
        if (typeof predicate != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return !predicate.call(this);
            case 1:
              return !predicate.call(this, args[0]);
            case 2:
              return !predicate.call(this, args[0], args[1]);
            case 3:
              return !predicate.call(this, args[0], args[1], args[2]);
          }
          return !predicate.apply(this, args);
        };
      }
      function once(func) {
        return before(2, func);
      }
      var overArgs = castRest(function(func, transforms) {
        transforms = transforms.length == 1 && isArray2(transforms[0]) ? arrayMap(transforms[0], baseUnary2(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary2(getIteratee()));
        var funcsLength = transforms.length;
        return baseRest(function(args) {
          var index2 = -1, length = nativeMin2(args.length, funcsLength);
          while (++index2 < length) {
            args[index2] = transforms[index2].call(this, args[index2]);
          }
          return apply(func, this, args);
        });
      });
      var partial = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partial));
        return createWrap2(func, WRAP_PARTIAL_FLAG, undefined$1, partials, holders);
      });
      var partialRight = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partialRight));
        return createWrap2(func, WRAP_PARTIAL_RIGHT_FLAG, undefined$1, partials, holders);
      });
      var rearg = flatRest(function(func, indexes) {
        return createWrap2(func, WRAP_REARG_FLAG, undefined$1, undefined$1, undefined$1, indexes);
      });
      function rest(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 === undefined$1 ? start2 : toInteger(start2);
        return baseRest(func, start2);
      }
      function spread(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 == null ? 0 : nativeMax2(toInteger(start2), 0);
        return baseRest(function(args) {
          var array4 = args[start2], otherArgs = castSlice(args, 0, start2);
          if (array4) {
            arrayPush2(otherArgs, array4);
          }
          return apply(func, this, otherArgs);
        });
      }
      function throttle2(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        if (isObject2(options)) {
          leading = "leading" in options ? !!options.leading : leading;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        return debounce2(func, wait, {
          "leading": leading,
          "maxWait": wait,
          "trailing": trailing
        });
      }
      function unary(func) {
        return ary(func, 1);
      }
      function wrap(value, wrapper) {
        return partial(castFunction(wrapper), value);
      }
      function castArray() {
        if (!arguments.length) {
          return [];
        }
        var value = arguments[0];
        return isArray2(value) ? value : [value];
      }
      function clone3(value) {
        return baseClone(value, CLONE_SYMBOLS_FLAG);
      }
      function cloneWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
      }
      function cloneDeep(value) {
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
      }
      function cloneDeepWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
      }
      function conformsTo(object4, source) {
        return source == null || baseConformsTo(object4, source, keys2(source));
      }
      function eq2(value, other) {
        return value === other || value !== value && other !== other;
      }
      var gt = createRelationalOperation(baseGt);
      var gte = createRelationalOperation(function(value, other) {
        return value >= other;
      });
      var isArguments2 = baseIsArguments2(function() {
        return arguments;
      }()) ? baseIsArguments2 : function(value) {
        return isObjectLike2(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable2.call(value, "callee");
      };
      var isArray2 = Array2.isArray;
      var isArrayBuffer = nodeIsArrayBuffer ? baseUnary2(nodeIsArrayBuffer) : baseIsArrayBuffer;
      function isArrayLike2(value) {
        return value != null && isLength2(value.length) && !isFunction2(value);
      }
      function isArrayLikeObject(value) {
        return isObjectLike2(value) && isArrayLike2(value);
      }
      function isBoolean(value) {
        return value === true || value === false || isObjectLike2(value) && baseGetTag2(value) == boolTag2;
      }
      var isBuffer2 = nativeIsBuffer || stubFalse2;
      var isDate = nodeIsDate ? baseUnary2(nodeIsDate) : baseIsDate;
      function isElement(value) {
        return isObjectLike2(value) && value.nodeType === 1 && !isPlainObject(value);
      }
      function isEmpty(value) {
        if (value == null) {
          return true;
        }
        if (isArrayLike2(value) && (isArray2(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer2(value) || isTypedArray2(value) || isArguments2(value))) {
          return !value.length;
        }
        var tag = getTag2(value);
        if (tag == mapTag2 || tag == setTag2) {
          return !value.size;
        }
        if (isPrototype2(value)) {
          return !baseKeys2(value).length;
        }
        for (var key in value) {
          if (hasOwnProperty2.call(value, key)) {
            return false;
          }
        }
        return true;
      }
      function isEqual2(value, other) {
        return baseIsEqual2(value, other);
      }
      function isEqualWith(value, other, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        var result2 = customizer ? customizer(value, other) : undefined$1;
        return result2 === undefined$1 ? baseIsEqual2(value, other, undefined$1, customizer) : !!result2;
      }
      function isError(value) {
        if (!isObjectLike2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == errorTag2 || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
      }
      function isFinite2(value) {
        return typeof value == "number" && nativeIsFinite(value);
      }
      function isFunction2(value) {
        if (!isObject2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == funcTag2 || tag == genTag2 || tag == asyncTag2 || tag == proxyTag2;
      }
      function isInteger(value) {
        return typeof value == "number" && value == toInteger(value);
      }
      function isLength2(value) {
        return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
      }
      function isObject2(value) {
        var type4 = typeof value;
        return value != null && (type4 == "object" || type4 == "function");
      }
      function isObjectLike2(value) {
        return value != null && typeof value == "object";
      }
      var isMap = nodeIsMap ? baseUnary2(nodeIsMap) : baseIsMap;
      function isMatch(object4, source) {
        return object4 === source || baseIsMatch(object4, source, getMatchData(source));
      }
      function isMatchWith(object4, source, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseIsMatch(object4, source, getMatchData(source), customizer);
      }
      function isNaN2(value) {
        return isNumber2(value) && value != +value;
      }
      function isNative(value) {
        if (isMaskable(value)) {
          throw new Error2(CORE_ERROR_TEXT);
        }
        return baseIsNative2(value);
      }
      function isNull(value) {
        return value === null;
      }
      function isNil(value) {
        return value == null;
      }
      function isNumber2(value) {
        return typeof value == "number" || isObjectLike2(value) && baseGetTag2(value) == numberTag2;
      }
      function isPlainObject(value) {
        if (!isObjectLike2(value) || baseGetTag2(value) != objectTag2) {
          return false;
        }
        var proto2 = getPrototype(value);
        if (proto2 === null) {
          return true;
        }
        var Ctor = hasOwnProperty2.call(proto2, "constructor") && proto2.constructor;
        return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString2.call(Ctor) == objectCtorString;
      }
      var isRegExp2 = nodeIsRegExp ? baseUnary2(nodeIsRegExp) : baseIsRegExp;
      function isSafeInteger(value) {
        return isInteger(value) && value >= -MAX_SAFE_INTEGER2 && value <= MAX_SAFE_INTEGER2;
      }
      var isSet = nodeIsSet ? baseUnary2(nodeIsSet) : baseIsSet;
      function isString2(value) {
        return typeof value == "string" || !isArray2(value) && isObjectLike2(value) && baseGetTag2(value) == stringTag2;
      }
      function isSymbol2(value) {
        return typeof value == "symbol" || isObjectLike2(value) && baseGetTag2(value) == symbolTag2;
      }
      var isTypedArray2 = nodeIsTypedArray2 ? baseUnary2(nodeIsTypedArray2) : baseIsTypedArray2;
      function isUndefined(value) {
        return value === undefined$1;
      }
      function isWeakMap(value) {
        return isObjectLike2(value) && getTag2(value) == weakMapTag2;
      }
      function isWeakSet(value) {
        return isObjectLike2(value) && baseGetTag2(value) == weakSetTag;
      }
      var lt2 = createRelationalOperation(baseLt);
      var lte = createRelationalOperation(function(value, other) {
        return value <= other;
      });
      function toArray2(value) {
        if (!value) {
          return [];
        }
        if (isArrayLike2(value)) {
          return isString2(value) ? stringToArray(value) : copyArray(value);
        }
        if (symIterator && value[symIterator]) {
          return iteratorToArray(value[symIterator]());
        }
        var tag = getTag2(value), func = tag == mapTag2 ? mapToArray2 : tag == setTag2 ? setToArray2 : values;
        return func(value);
      }
      function toFinite(value) {
        if (!value) {
          return value === 0 ? value : 0;
        }
        value = toNumber2(value);
        if (value === INFINITY || value === -INFINITY) {
          var sign = value < 0 ? -1 : 1;
          return sign * MAX_INTEGER;
        }
        return value === value ? value : 0;
      }
      function toInteger(value) {
        var result2 = toFinite(value), remainder = result2 % 1;
        return result2 === result2 ? remainder ? result2 - remainder : result2 : 0;
      }
      function toLength(value) {
        return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
      }
      function toNumber2(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        if (isObject2(value)) {
          var other = typeof value.valueOf == "function" ? value.valueOf() : value;
          value = isObject2(other) ? other + "" : other;
        }
        if (typeof value != "string") {
          return value === 0 ? value : +value;
        }
        value = baseTrim2(value);
        var isBinary = reIsBinary2.test(value);
        return isBinary || reIsOctal2.test(value) ? freeParseInt2(value.slice(2), isBinary ? 2 : 8) : reIsBadHex2.test(value) ? NAN2 : +value;
      }
      function toPlainObject(value) {
        return copyObject(value, keysIn(value));
      }
      function toSafeInteger(value) {
        return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER2, MAX_SAFE_INTEGER2) : value === 0 ? value : 0;
      }
      function toString(value) {
        return value == null ? "" : baseToString(value);
      }
      var assign = createAssigner(function(object4, source) {
        if (isPrototype2(source) || isArrayLike2(source)) {
          copyObject(source, keys2(source), object4);
          return;
        }
        for (var key in source) {
          if (hasOwnProperty2.call(source, key)) {
            assignValue(object4, key, source[key]);
          }
        }
      });
      var assignIn = createAssigner(function(object4, source) {
        copyObject(source, keysIn(source), object4);
      });
      var assignInWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keysIn(source), object4, customizer);
      });
      var assignWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keys2(source), object4, customizer);
      });
      var at = flatRest(baseAt);
      function create2(prototype, properties) {
        var result2 = baseCreate(prototype);
        return properties == null ? result2 : baseAssign(result2, properties);
      }
      var defaults2 = baseRest(function(object4, sources) {
        object4 = Object2(object4);
        var index2 = -1;
        var length = sources.length;
        var guard = length > 2 ? sources[2] : undefined$1;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          length = 1;
        }
        while (++index2 < length) {
          var source = sources[index2];
          var props = keysIn(source);
          var propsIndex = -1;
          var propsLength = props.length;
          while (++propsIndex < propsLength) {
            var key = props[propsIndex];
            var value = object4[key];
            if (value === undefined$1 || eq2(value, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
              object4[key] = source[key];
            }
          }
        }
        return object4;
      });
      var defaultsDeep = baseRest(function(args) {
        args.push(undefined$1, customDefaultsMerge);
        return apply(mergeWith, undefined$1, args);
      });
      function findKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwn);
      }
      function findLastKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwnRight);
      }
      function forIn(object4, iteratee2) {
        return object4 == null ? object4 : baseFor(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forInRight(object4, iteratee2) {
        return object4 == null ? object4 : baseForRight(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forOwn(object4, iteratee2) {
        return object4 && baseForOwn(object4, getIteratee(iteratee2, 3));
      }
      function forOwnRight(object4, iteratee2) {
        return object4 && baseForOwnRight(object4, getIteratee(iteratee2, 3));
      }
      function functions(object4) {
        return object4 == null ? [] : baseFunctions(object4, keys2(object4));
      }
      function functionsIn(object4) {
        return object4 == null ? [] : baseFunctions(object4, keysIn(object4));
      }
      function get2(object4, path, defaultValue) {
        var result2 = object4 == null ? undefined$1 : baseGet(object4, path);
        return result2 === undefined$1 ? defaultValue : result2;
      }
      function has2(object4, path) {
        return object4 != null && hasPath(object4, path, baseHas);
      }
      function hasIn(object4, path) {
        return object4 != null && hasPath(object4, path, baseHasIn);
      }
      var invert2 = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        result2[value] = key;
      }, constant(identity2));
      var invertBy = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        if (hasOwnProperty2.call(result2, value)) {
          result2[value].push(key);
        } else {
          result2[value] = [key];
        }
      }, getIteratee);
      var invoke = baseRest(baseInvoke);
      function keys2(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys2(object4) : baseKeys2(object4);
      }
      function keysIn(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys2(object4, true) : baseKeysIn(object4);
      }
      function mapKeys(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, iteratee2(value, key, object5), value);
        });
        return result2;
      }
      function mapValues(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, key, iteratee2(value, key, object5));
        });
        return result2;
      }
      var merge3 = createAssigner(function(object4, source, srcIndex) {
        baseMerge(object4, source, srcIndex);
      });
      var mergeWith = createAssigner(function(object4, source, srcIndex, customizer) {
        baseMerge(object4, source, srcIndex, customizer);
      });
      var omit2 = flatRest(function(object4, paths) {
        var result2 = {};
        if (object4 == null) {
          return result2;
        }
        var isDeep = false;
        paths = arrayMap(paths, function(path) {
          path = castPath(path, object4);
          isDeep || (isDeep = path.length > 1);
          return path;
        });
        copyObject(object4, getAllKeysIn(object4), result2);
        if (isDeep) {
          result2 = baseClone(result2, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
        }
        var length = paths.length;
        while (length--) {
          baseUnset(result2, paths[length]);
        }
        return result2;
      });
      function omitBy(object4, predicate) {
        return pickBy(object4, negate(getIteratee(predicate)));
      }
      var pick = flatRest(function(object4, paths) {
        return object4 == null ? {} : basePick(object4, paths);
      });
      function pickBy(object4, predicate) {
        if (object4 == null) {
          return {};
        }
        var props = arrayMap(getAllKeysIn(object4), function(prop) {
          return [prop];
        });
        predicate = getIteratee(predicate);
        return basePickBy(object4, props, function(value, path) {
          return predicate(value, path[0]);
        });
      }
      function result(object4, path, defaultValue) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length;
        if (!length) {
          length = 1;
          object4 = undefined$1;
        }
        while (++index2 < length) {
          var value = object4 == null ? undefined$1 : object4[toKey(path[index2])];
          if (value === undefined$1) {
            index2 = length;
            value = defaultValue;
          }
          object4 = isFunction2(value) ? value.call(object4) : value;
        }
        return object4;
      }
      function set2(object4, path, value) {
        return object4 == null ? object4 : baseSet(object4, path, value);
      }
      function setWith(object4, path, value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseSet(object4, path, value, customizer);
      }
      var toPairs = createToPairs(keys2);
      var toPairsIn = createToPairs(keysIn);
      function transform2(object4, iteratee2, accumulator) {
        var isArr = isArray2(object4), isArrLike = isArr || isBuffer2(object4) || isTypedArray2(object4);
        iteratee2 = getIteratee(iteratee2, 4);
        if (accumulator == null) {
          var Ctor = object4 && object4.constructor;
          if (isArrLike) {
            accumulator = isArr ? new Ctor() : [];
          } else if (isObject2(object4)) {
            accumulator = isFunction2(Ctor) ? baseCreate(getPrototype(object4)) : {};
          } else {
            accumulator = {};
          }
        }
        (isArrLike ? arrayEach : baseForOwn)(object4, function(value, index2, object5) {
          return iteratee2(accumulator, value, index2, object5);
        });
        return accumulator;
      }
      function unset(object4, path) {
        return object4 == null ? true : baseUnset(object4, path);
      }
      function update(object4, path, updater) {
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater));
      }
      function updateWith(object4, path, updater, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater), customizer);
      }
      function values(object4) {
        return object4 == null ? [] : baseValues(object4, keys2(object4));
      }
      function valuesIn(object4) {
        return object4 == null ? [] : baseValues(object4, keysIn(object4));
      }
      function clamp2(number4, lower, upper) {
        if (upper === undefined$1) {
          upper = lower;
          lower = undefined$1;
        }
        if (upper !== undefined$1) {
          upper = toNumber2(upper);
          upper = upper === upper ? upper : 0;
        }
        if (lower !== undefined$1) {
          lower = toNumber2(lower);
          lower = lower === lower ? lower : 0;
        }
        return baseClamp(toNumber2(number4), lower, upper);
      }
      function inRange(number4, start2, end2) {
        start2 = toFinite(start2);
        if (end2 === undefined$1) {
          end2 = start2;
          start2 = 0;
        } else {
          end2 = toFinite(end2);
        }
        number4 = toNumber2(number4);
        return baseInRange(number4, start2, end2);
      }
      function random(lower, upper, floating) {
        if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
          upper = floating = undefined$1;
        }
        if (floating === undefined$1) {
          if (typeof upper == "boolean") {
            floating = upper;
            upper = undefined$1;
          } else if (typeof lower == "boolean") {
            floating = lower;
            lower = undefined$1;
          }
        }
        if (lower === undefined$1 && upper === undefined$1) {
          lower = 0;
          upper = 1;
        } else {
          lower = toFinite(lower);
          if (upper === undefined$1) {
            upper = lower;
            lower = 0;
          } else {
            upper = toFinite(upper);
          }
        }
        if (lower > upper) {
          var temp = lower;
          lower = upper;
          upper = temp;
        }
        if (floating || lower % 1 || upper % 1) {
          var rand = nativeRandom();
          return nativeMin2(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
        }
        return baseRandom(lower, upper);
      }
      var camelCase = createCompounder(function(result2, word, index2) {
        word = word.toLowerCase();
        return result2 + (index2 ? capitalize(word) : word);
      });
      function capitalize(string3) {
        return upperFirst(toString(string3).toLowerCase());
      }
      function deburr(string3) {
        string3 = toString(string3);
        return string3 && string3.replace(reLatin, deburrLetter).replace(reComboMark, "");
      }
      function endsWith(string3, target, position2) {
        string3 = toString(string3);
        target = baseToString(target);
        var length = string3.length;
        position2 = position2 === undefined$1 ? length : baseClamp(toInteger(position2), 0, length);
        var end2 = position2;
        position2 -= target.length;
        return position2 >= 0 && string3.slice(position2, end2) == target;
      }
      function escape(string3) {
        string3 = toString(string3);
        return string3 && reHasUnescapedHtml.test(string3) ? string3.replace(reUnescapedHtml, escapeHtmlChar) : string3;
      }
      function escapeRegExp(string3) {
        string3 = toString(string3);
        return string3 && reHasRegExpChar.test(string3) ? string3.replace(reRegExpChar2, "\\$&") : string3;
      }
      var kebabCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "-" : "") + word.toLowerCase();
      });
      var lowerCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toLowerCase();
      });
      var lowerFirst = createCaseFirst("toLowerCase");
      function pad3(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        if (!length || strLength >= length) {
          return string3;
        }
        var mid = (length - strLength) / 2;
        return createPadding(nativeFloor(mid), chars) + string3 + createPadding(nativeCeil(mid), chars);
      }
      function padEnd(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? string3 + createPadding(length - strLength, chars) : string3;
      }
      function padStart(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? createPadding(length - strLength, chars) + string3 : string3;
      }
      function parseInt2(string3, radix, guard) {
        if (guard || radix == null) {
          radix = 0;
        } else if (radix) {
          radix = +radix;
        }
        return nativeParseInt(toString(string3).replace(reTrimStart2, ""), radix || 0);
      }
      function repeat(string3, n2, guard) {
        if (guard ? isIterateeCall(string3, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        return baseRepeat(toString(string3), n2);
      }
      function replace() {
        var args = arguments, string3 = toString(args[0]);
        return args.length < 3 ? string3 : string3.replace(args[1], args[2]);
      }
      var snakeCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "_" : "") + word.toLowerCase();
      });
      function split2(string3, separator, limit) {
        if (limit && typeof limit != "number" && isIterateeCall(string3, separator, limit)) {
          separator = limit = undefined$1;
        }
        limit = limit === undefined$1 ? MAX_ARRAY_LENGTH : limit >>> 0;
        if (!limit) {
          return [];
        }
        string3 = toString(string3);
        if (string3 && (typeof separator == "string" || separator != null && !isRegExp2(separator))) {
          separator = baseToString(separator);
          if (!separator && hasUnicode(string3)) {
            return castSlice(stringToArray(string3), 0, limit);
          }
        }
        return string3.split(separator, limit);
      }
      var startCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + upperFirst(word);
      });
      function startsWith(string3, target, position2) {
        string3 = toString(string3);
        position2 = position2 == null ? 0 : baseClamp(toInteger(position2), 0, string3.length);
        target = baseToString(target);
        return string3.slice(position2, position2 + target.length) == target;
      }
      function template(string3, options, guard) {
        var settings = lodash2.templateSettings;
        if (guard && isIterateeCall(string3, options, guard)) {
          options = undefined$1;
        }
        string3 = toString(string3);
        options = assignInWith({}, options, settings, customDefaultsAssignIn);
        var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys2(imports), importsValues = baseValues(imports, importsKeys);
        var isEscaping, isEvaluating, index2 = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
        var reDelimiters = RegExp2((options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$", "g");
        var sourceURL = "//# sourceURL=" + (hasOwnProperty2.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
        string3.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset2) {
          interpolateValue || (interpolateValue = esTemplateValue);
          source += string3.slice(index2, offset2).replace(reUnescapedString, escapeStringChar);
          if (escapeValue) {
            isEscaping = true;
            source += "' +\n__e(" + escapeValue + ") +\n'";
          }
          if (evaluateValue) {
            isEvaluating = true;
            source += "';\n" + evaluateValue + ";\n__p += '";
          }
          if (interpolateValue) {
            source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
          }
          index2 = offset2 + match.length;
          return match;
        });
        source += "';\n";
        var variable = hasOwnProperty2.call(options, "variable") && options.variable;
        if (!variable) {
          source = "with (obj) {\n" + source + "\n}\n";
        } else if (reForbiddenIdentifierChars.test(variable)) {
          throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
        }
        source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
        source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
        var result2 = attempt(function() {
          return Function2(importsKeys, sourceURL + "return " + source).apply(undefined$1, importsValues);
        });
        result2.source = source;
        if (isError(result2)) {
          throw result2;
        }
        return result2;
      }
      function toLower(value) {
        return toString(value).toLowerCase();
      }
      function toUpper(value) {
        return toString(value).toUpperCase();
      }
      function trim2(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return baseTrim2(string3);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), chrSymbols = stringToArray(chars), start2 = charsStartIndex(strSymbols, chrSymbols), end2 = charsEndIndex(strSymbols, chrSymbols) + 1;
        return castSlice(strSymbols, start2, end2).join("");
      }
      function trimEnd(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.slice(0, trimmedEndIndex2(string3) + 1);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), end2 = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
        return castSlice(strSymbols, 0, end2).join("");
      }
      function trimStart(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.replace(reTrimStart2, "");
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), start2 = charsStartIndex(strSymbols, stringToArray(chars));
        return castSlice(strSymbols, start2).join("");
      }
      function truncate(string3, options) {
        var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
        if (isObject2(options)) {
          var separator = "separator" in options ? options.separator : separator;
          length = "length" in options ? toInteger(options.length) : length;
          omission = "omission" in options ? baseToString(options.omission) : omission;
        }
        string3 = toString(string3);
        var strLength = string3.length;
        if (hasUnicode(string3)) {
          var strSymbols = stringToArray(string3);
          strLength = strSymbols.length;
        }
        if (length >= strLength) {
          return string3;
        }
        var end2 = length - stringSize(omission);
        if (end2 < 1) {
          return omission;
        }
        var result2 = strSymbols ? castSlice(strSymbols, 0, end2).join("") : string3.slice(0, end2);
        if (separator === undefined$1) {
          return result2 + omission;
        }
        if (strSymbols) {
          end2 += result2.length - end2;
        }
        if (isRegExp2(separator)) {
          if (string3.slice(end2).search(separator)) {
            var match, substring = result2;
            if (!separator.global) {
              separator = RegExp2(separator.source, toString(reFlags.exec(separator)) + "g");
            }
            separator.lastIndex = 0;
            while (match = separator.exec(substring)) {
              var newEnd = match.index;
            }
            result2 = result2.slice(0, newEnd === undefined$1 ? end2 : newEnd);
          }
        } else if (string3.indexOf(baseToString(separator), end2) != end2) {
          var index2 = result2.lastIndexOf(separator);
          if (index2 > -1) {
            result2 = result2.slice(0, index2);
          }
        }
        return result2 + omission;
      }
      function unescape2(string3) {
        string3 = toString(string3);
        return string3 && reHasEscapedHtml.test(string3) ? string3.replace(reEscapedHtml, unescapeHtmlChar) : string3;
      }
      var upperCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toUpperCase();
      });
      var upperFirst = createCaseFirst("toUpperCase");
      function words(string3, pattern4, guard) {
        string3 = toString(string3);
        pattern4 = guard ? undefined$1 : pattern4;
        if (pattern4 === undefined$1) {
          return hasUnicodeWord(string3) ? unicodeWords(string3) : asciiWords(string3);
        }
        return string3.match(pattern4) || [];
      }
      var attempt = baseRest(function(func, args) {
        try {
          return apply(func, undefined$1, args);
        } catch (e2) {
          return isError(e2) ? e2 : new Error2(e2);
        }
      });
      var bindAll = flatRest(function(object4, methodNames) {
        arrayEach(methodNames, function(key) {
          key = toKey(key);
          baseAssignValue(object4, key, bind2(object4[key], object4));
        });
        return object4;
      });
      function cond(pairs) {
        var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
        pairs = !length ? [] : arrayMap(pairs, function(pair) {
          if (typeof pair[1] != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT2);
          }
          return [toIteratee(pair[0]), pair[1]];
        });
        return baseRest(function(args) {
          var index2 = -1;
          while (++index2 < length) {
            var pair = pairs[index2];
            if (apply(pair[0], this, args)) {
              return apply(pair[1], this, args);
            }
          }
        });
      }
      function conforms(source) {
        return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
      }
      function constant(value) {
        return function() {
          return value;
        };
      }
      function defaultTo(value, defaultValue) {
        return value == null || value !== value ? defaultValue : value;
      }
      var flow = createFlow();
      var flowRight = createFlow(true);
      function identity2(value) {
        return value;
      }
      function iteratee(func) {
        return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
      }
      function matches(source) {
        return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
      }
      function matchesProperty(path, srcValue) {
        return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
      }
      var method4 = baseRest(function(path, args) {
        return function(object4) {
          return baseInvoke(object4, path, args);
        };
      });
      var methodOf = baseRest(function(object4, args) {
        return function(path) {
          return baseInvoke(object4, path, args);
        };
      });
      function mixin2(object4, source, options) {
        var props = keys2(source), methodNames = baseFunctions(source, props);
        if (options == null && !(isObject2(source) && (methodNames.length || !props.length))) {
          options = source;
          source = object4;
          object4 = this;
          methodNames = baseFunctions(source, keys2(source));
        }
        var chain2 = !(isObject2(options) && "chain" in options) || !!options.chain, isFunc = isFunction2(object4);
        arrayEach(methodNames, function(methodName) {
          var func = source[methodName];
          object4[methodName] = func;
          if (isFunc) {
            object4.prototype[methodName] = function() {
              var chainAll = this.__chain__;
              if (chain2 || chainAll) {
                var result2 = object4(this.__wrapped__), actions2 = result2.__actions__ = copyArray(this.__actions__);
                actions2.push({ "func": func, "args": arguments, "thisArg": object4 });
                result2.__chain__ = chainAll;
                return result2;
              }
              return func.apply(object4, arrayPush2([this.value()], arguments));
            };
          }
        });
        return object4;
      }
      function noConflict() {
        if (root2._ === this) {
          root2._ = oldDash;
        }
        return this;
      }
      function noop2() {
      }
      function nthArg(n2) {
        n2 = toInteger(n2);
        return baseRest(function(args) {
          return baseNth(args, n2);
        });
      }
      var over = createOver(arrayMap);
      var overEvery = createOver(arrayEvery);
      var overSome = createOver(arraySome2);
      function property(path) {
        return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
      }
      function propertyOf(object4) {
        return function(path) {
          return object4 == null ? undefined$1 : baseGet(object4, path);
        };
      }
      var range3 = createRange();
      var rangeRight = createRange(true);
      function stubArray2() {
        return [];
      }
      function stubFalse2() {
        return false;
      }
      function stubObject() {
        return {};
      }
      function stubString() {
        return "";
      }
      function stubTrue() {
        return true;
      }
      function times(n2, iteratee2) {
        n2 = toInteger(n2);
        if (n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return [];
        }
        var index2 = MAX_ARRAY_LENGTH, length = nativeMin2(n2, MAX_ARRAY_LENGTH);
        iteratee2 = getIteratee(iteratee2);
        n2 -= MAX_ARRAY_LENGTH;
        var result2 = baseTimes2(length, iteratee2);
        while (++index2 < n2) {
          iteratee2(index2);
        }
        return result2;
      }
      function toPath(value) {
        if (isArray2(value)) {
          return arrayMap(value, toKey);
        }
        return isSymbol2(value) ? [value] : copyArray(stringToPath(toString(value)));
      }
      function uniqueId(prefix) {
        var id2 = ++idCounter;
        return toString(prefix) + id2;
      }
      var add2 = createMathOperation(function(augend, addend) {
        return augend + addend;
      }, 0);
      var ceil = createRound("ceil");
      var divide = createMathOperation(function(dividend, divisor) {
        return dividend / divisor;
      }, 1);
      var floor = createRound("floor");
      function max3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseGt) : undefined$1;
      }
      function maxBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseGt) : undefined$1;
      }
      function mean(array4) {
        return baseMean(array4, identity2);
      }
      function meanBy(array4, iteratee2) {
        return baseMean(array4, getIteratee(iteratee2, 2));
      }
      function min3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseLt) : undefined$1;
      }
      function minBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseLt) : undefined$1;
      }
      var multiply = createMathOperation(function(multiplier, multiplicand) {
        return multiplier * multiplicand;
      }, 1);
      var round2 = createRound("round");
      var subtract = createMathOperation(function(minuend, subtrahend) {
        return minuend - subtrahend;
      }, 0);
      function sum2(array4) {
        return array4 && array4.length ? baseSum(array4, identity2) : 0;
      }
      function sumBy(array4, iteratee2) {
        return array4 && array4.length ? baseSum(array4, getIteratee(iteratee2, 2)) : 0;
      }
      lodash2.after = after;
      lodash2.ary = ary;
      lodash2.assign = assign;
      lodash2.assignIn = assignIn;
      lodash2.assignInWith = assignInWith;
      lodash2.assignWith = assignWith;
      lodash2.at = at;
      lodash2.before = before;
      lodash2.bind = bind2;
      lodash2.bindAll = bindAll;
      lodash2.bindKey = bindKey;
      lodash2.castArray = castArray;
      lodash2.chain = chain;
      lodash2.chunk = chunk;
      lodash2.compact = compact;
      lodash2.concat = concat;
      lodash2.cond = cond;
      lodash2.conforms = conforms;
      lodash2.constant = constant;
      lodash2.countBy = countBy;
      lodash2.create = create2;
      lodash2.curry = curry2;
      lodash2.curryRight = curryRight;
      lodash2.debounce = debounce2;
      lodash2.defaults = defaults2;
      lodash2.defaultsDeep = defaultsDeep;
      lodash2.defer = defer;
      lodash2.delay = delay;
      lodash2.difference = difference;
      lodash2.differenceBy = differenceBy;
      lodash2.differenceWith = differenceWith;
      lodash2.drop = drop;
      lodash2.dropRight = dropRight;
      lodash2.dropRightWhile = dropRightWhile;
      lodash2.dropWhile = dropWhile;
      lodash2.fill = fill;
      lodash2.filter = filter2;
      lodash2.flatMap = flatMap;
      lodash2.flatMapDeep = flatMapDeep;
      lodash2.flatMapDepth = flatMapDepth;
      lodash2.flatten = flatten;
      lodash2.flattenDeep = flattenDeep;
      lodash2.flattenDepth = flattenDepth;
      lodash2.flip = flip2;
      lodash2.flow = flow;
      lodash2.flowRight = flowRight;
      lodash2.fromPairs = fromPairs;
      lodash2.functions = functions;
      lodash2.functionsIn = functionsIn;
      lodash2.groupBy = groupBy;
      lodash2.initial = initial;
      lodash2.intersection = intersection;
      lodash2.intersectionBy = intersectionBy;
      lodash2.intersectionWith = intersectionWith;
      lodash2.invert = invert2;
      lodash2.invertBy = invertBy;
      lodash2.invokeMap = invokeMap;
      lodash2.iteratee = iteratee;
      lodash2.keyBy = keyBy;
      lodash2.keys = keys2;
      lodash2.keysIn = keysIn;
      lodash2.map = map2;
      lodash2.mapKeys = mapKeys;
      lodash2.mapValues = mapValues;
      lodash2.matches = matches;
      lodash2.matchesProperty = matchesProperty;
      lodash2.memoize = memoize;
      lodash2.merge = merge3;
      lodash2.mergeWith = mergeWith;
      lodash2.method = method4;
      lodash2.methodOf = methodOf;
      lodash2.mixin = mixin2;
      lodash2.negate = negate;
      lodash2.nthArg = nthArg;
      lodash2.omit = omit2;
      lodash2.omitBy = omitBy;
      lodash2.once = once;
      lodash2.orderBy = orderBy;
      lodash2.over = over;
      lodash2.overArgs = overArgs;
      lodash2.overEvery = overEvery;
      lodash2.overSome = overSome;
      lodash2.partial = partial;
      lodash2.partialRight = partialRight;
      lodash2.partition = partition;
      lodash2.pick = pick;
      lodash2.pickBy = pickBy;
      lodash2.property = property;
      lodash2.propertyOf = propertyOf;
      lodash2.pull = pull;
      lodash2.pullAll = pullAll;
      lodash2.pullAllBy = pullAllBy;
      lodash2.pullAllWith = pullAllWith;
      lodash2.pullAt = pullAt;
      lodash2.range = range3;
      lodash2.rangeRight = rangeRight;
      lodash2.rearg = rearg;
      lodash2.reject = reject;
      lodash2.remove = remove;
      lodash2.rest = rest;
      lodash2.reverse = reverse2;
      lodash2.sampleSize = sampleSize;
      lodash2.set = set2;
      lodash2.setWith = setWith;
      lodash2.shuffle = shuffle;
      lodash2.slice = slice2;
      lodash2.sortBy = sortBy;
      lodash2.sortedUniq = sortedUniq;
      lodash2.sortedUniqBy = sortedUniqBy;
      lodash2.split = split2;
      lodash2.spread = spread;
      lodash2.tail = tail;
      lodash2.take = take2;
      lodash2.takeRight = takeRight;
      lodash2.takeRightWhile = takeRightWhile;
      lodash2.takeWhile = takeWhile;
      lodash2.tap = tap;
      lodash2.throttle = throttle2;
      lodash2.thru = thru;
      lodash2.toArray = toArray2;
      lodash2.toPairs = toPairs;
      lodash2.toPairsIn = toPairsIn;
      lodash2.toPath = toPath;
      lodash2.toPlainObject = toPlainObject;
      lodash2.transform = transform2;
      lodash2.unary = unary;
      lodash2.union = union;
      lodash2.unionBy = unionBy;
      lodash2.unionWith = unionWith;
      lodash2.uniq = uniq;
      lodash2.uniqBy = uniqBy;
      lodash2.uniqWith = uniqWith;
      lodash2.unset = unset;
      lodash2.unzip = unzip;
      lodash2.unzipWith = unzipWith;
      lodash2.update = update;
      lodash2.updateWith = updateWith;
      lodash2.values = values;
      lodash2.valuesIn = valuesIn;
      lodash2.without = without;
      lodash2.words = words;
      lodash2.wrap = wrap;
      lodash2.xor = xor;
      lodash2.xorBy = xorBy;
      lodash2.xorWith = xorWith;
      lodash2.zip = zip;
      lodash2.zipObject = zipObject;
      lodash2.zipObjectDeep = zipObjectDeep;
      lodash2.zipWith = zipWith;
      lodash2.entries = toPairs;
      lodash2.entriesIn = toPairsIn;
      lodash2.extend = assignIn;
      lodash2.extendWith = assignInWith;
      mixin2(lodash2, lodash2);
      lodash2.add = add2;
      lodash2.attempt = attempt;
      lodash2.camelCase = camelCase;
      lodash2.capitalize = capitalize;
      lodash2.ceil = ceil;
      lodash2.clamp = clamp2;
      lodash2.clone = clone3;
      lodash2.cloneDeep = cloneDeep;
      lodash2.cloneDeepWith = cloneDeepWith;
      lodash2.cloneWith = cloneWith;
      lodash2.conformsTo = conformsTo;
      lodash2.deburr = deburr;
      lodash2.defaultTo = defaultTo;
      lodash2.divide = divide;
      lodash2.endsWith = endsWith;
      lodash2.eq = eq2;
      lodash2.escape = escape;
      lodash2.escapeRegExp = escapeRegExp;
      lodash2.every = every;
      lodash2.find = find2;
      lodash2.findIndex = findIndex;
      lodash2.findKey = findKey;
      lodash2.findLast = findLast;
      lodash2.findLastIndex = findLastIndex;
      lodash2.findLastKey = findLastKey;
      lodash2.floor = floor;
      lodash2.forEach = forEach;
      lodash2.forEachRight = forEachRight;
      lodash2.forIn = forIn;
      lodash2.forInRight = forInRight;
      lodash2.forOwn = forOwn;
      lodash2.forOwnRight = forOwnRight;
      lodash2.get = get2;
      lodash2.gt = gt;
      lodash2.gte = gte;
      lodash2.has = has2;
      lodash2.hasIn = hasIn;
      lodash2.head = head;
      lodash2.identity = identity2;
      lodash2.includes = includes;
      lodash2.indexOf = indexOf2;
      lodash2.inRange = inRange;
      lodash2.invoke = invoke;
      lodash2.isArguments = isArguments2;
      lodash2.isArray = isArray2;
      lodash2.isArrayBuffer = isArrayBuffer;
      lodash2.isArrayLike = isArrayLike2;
      lodash2.isArrayLikeObject = isArrayLikeObject;
      lodash2.isBoolean = isBoolean;
      lodash2.isBuffer = isBuffer2;
      lodash2.isDate = isDate;
      lodash2.isElement = isElement;
      lodash2.isEmpty = isEmpty;
      lodash2.isEqual = isEqual2;
      lodash2.isEqualWith = isEqualWith;
      lodash2.isError = isError;
      lodash2.isFinite = isFinite2;
      lodash2.isFunction = isFunction2;
      lodash2.isInteger = isInteger;
      lodash2.isLength = isLength2;
      lodash2.isMap = isMap;
      lodash2.isMatch = isMatch;
      lodash2.isMatchWith = isMatchWith;
      lodash2.isNaN = isNaN2;
      lodash2.isNative = isNative;
      lodash2.isNil = isNil;
      lodash2.isNull = isNull;
      lodash2.isNumber = isNumber2;
      lodash2.isObject = isObject2;
      lodash2.isObjectLike = isObjectLike2;
      lodash2.isPlainObject = isPlainObject;
      lodash2.isRegExp = isRegExp2;
      lodash2.isSafeInteger = isSafeInteger;
      lodash2.isSet = isSet;
      lodash2.isString = isString2;
      lodash2.isSymbol = isSymbol2;
      lodash2.isTypedArray = isTypedArray2;
      lodash2.isUndefined = isUndefined;
      lodash2.isWeakMap = isWeakMap;
      lodash2.isWeakSet = isWeakSet;
      lodash2.join = join;
      lodash2.kebabCase = kebabCase;
      lodash2.last = last;
      lodash2.lastIndexOf = lastIndexOf;
      lodash2.lowerCase = lowerCase;
      lodash2.lowerFirst = lowerFirst;
      lodash2.lt = lt2;
      lodash2.lte = lte;
      lodash2.max = max3;
      lodash2.maxBy = maxBy;
      lodash2.mean = mean;
      lodash2.meanBy = meanBy;
      lodash2.min = min3;
      lodash2.minBy = minBy;
      lodash2.stubArray = stubArray2;
      lodash2.stubFalse = stubFalse2;
      lodash2.stubObject = stubObject;
      lodash2.stubString = stubString;
      lodash2.stubTrue = stubTrue;
      lodash2.multiply = multiply;
      lodash2.nth = nth;
      lodash2.noConflict = noConflict;
      lodash2.noop = noop2;
      lodash2.now = now2;
      lodash2.pad = pad3;
      lodash2.padEnd = padEnd;
      lodash2.padStart = padStart;
      lodash2.parseInt = parseInt2;
      lodash2.random = random;
      lodash2.reduce = reduce2;
      lodash2.reduceRight = reduceRight;
      lodash2.repeat = repeat;
      lodash2.replace = replace;
      lodash2.result = result;
      lodash2.round = round2;
      lodash2.runInContext = runInContext2;
      lodash2.sample = sample;
      lodash2.size = size;
      lodash2.snakeCase = snakeCase;
      lodash2.some = some;
      lodash2.sortedIndex = sortedIndex;
      lodash2.sortedIndexBy = sortedIndexBy;
      lodash2.sortedIndexOf = sortedIndexOf;
      lodash2.sortedLastIndex = sortedLastIndex;
      lodash2.sortedLastIndexBy = sortedLastIndexBy;
      lodash2.sortedLastIndexOf = sortedLastIndexOf;
      lodash2.startCase = startCase;
      lodash2.startsWith = startsWith;
      lodash2.subtract = subtract;
      lodash2.sum = sum2;
      lodash2.sumBy = sumBy;
      lodash2.template = template;
      lodash2.times = times;
      lodash2.toFinite = toFinite;
      lodash2.toInteger = toInteger;
      lodash2.toLength = toLength;
      lodash2.toLower = toLower;
      lodash2.toNumber = toNumber2;
      lodash2.toSafeInteger = toSafeInteger;
      lodash2.toString = toString;
      lodash2.toUpper = toUpper;
      lodash2.trim = trim2;
      lodash2.trimEnd = trimEnd;
      lodash2.trimStart = trimStart;
      lodash2.truncate = truncate;
      lodash2.unescape = unescape2;
      lodash2.uniqueId = uniqueId;
      lodash2.upperCase = upperCase;
      lodash2.upperFirst = upperFirst;
      lodash2.each = forEach;
      lodash2.eachRight = forEachRight;
      lodash2.first = head;
      mixin2(lodash2, function() {
        var source = {};
        baseForOwn(lodash2, function(func, methodName) {
          if (!hasOwnProperty2.call(lodash2.prototype, methodName)) {
            source[methodName] = func;
          }
        });
        return source;
      }(), { "chain": false });
      lodash2.VERSION = VERSION;
      arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
        lodash2[methodName].placeholder = lodash2;
      });
      arrayEach(["drop", "take"], function(methodName, index2) {
        LazyWrapper.prototype[methodName] = function(n2) {
          n2 = n2 === undefined$1 ? 1 : nativeMax2(toInteger(n2), 0);
          var result2 = this.__filtered__ && !index2 ? new LazyWrapper(this) : this.clone();
          if (result2.__filtered__) {
            result2.__takeCount__ = nativeMin2(n2, result2.__takeCount__);
          } else {
            result2.__views__.push({
              "size": nativeMin2(n2, MAX_ARRAY_LENGTH),
              "type": methodName + (result2.__dir__ < 0 ? "Right" : "")
            });
          }
          return result2;
        };
        LazyWrapper.prototype[methodName + "Right"] = function(n2) {
          return this.reverse()[methodName](n2).reverse();
        };
      });
      arrayEach(["filter", "map", "takeWhile"], function(methodName, index2) {
        var type4 = index2 + 1, isFilter = type4 == LAZY_FILTER_FLAG || type4 == LAZY_WHILE_FLAG;
        LazyWrapper.prototype[methodName] = function(iteratee2) {
          var result2 = this.clone();
          result2.__iteratees__.push({
            "iteratee": getIteratee(iteratee2, 3),
            "type": type4
          });
          result2.__filtered__ = result2.__filtered__ || isFilter;
          return result2;
        };
      });
      arrayEach(["head", "last"], function(methodName, index2) {
        var takeName = "take" + (index2 ? "Right" : "");
        LazyWrapper.prototype[methodName] = function() {
          return this[takeName](1).value()[0];
        };
      });
      arrayEach(["initial", "tail"], function(methodName, index2) {
        var dropName = "drop" + (index2 ? "" : "Right");
        LazyWrapper.prototype[methodName] = function() {
          return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
        };
      });
      LazyWrapper.prototype.compact = function() {
        return this.filter(identity2);
      };
      LazyWrapper.prototype.find = function(predicate) {
        return this.filter(predicate).head();
      };
      LazyWrapper.prototype.findLast = function(predicate) {
        return this.reverse().find(predicate);
      };
      LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
        if (typeof path == "function") {
          return new LazyWrapper(this);
        }
        return this.map(function(value) {
          return baseInvoke(value, path, args);
        });
      });
      LazyWrapper.prototype.reject = function(predicate) {
        return this.filter(negate(getIteratee(predicate)));
      };
      LazyWrapper.prototype.slice = function(start2, end2) {
        start2 = toInteger(start2);
        var result2 = this;
        if (result2.__filtered__ && (start2 > 0 || end2 < 0)) {
          return new LazyWrapper(result2);
        }
        if (start2 < 0) {
          result2 = result2.takeRight(-start2);
        } else if (start2) {
          result2 = result2.drop(start2);
        }
        if (end2 !== undefined$1) {
          end2 = toInteger(end2);
          result2 = end2 < 0 ? result2.dropRight(-end2) : result2.take(end2 - start2);
        }
        return result2;
      };
      LazyWrapper.prototype.takeRightWhile = function(predicate) {
        return this.reverse().takeWhile(predicate).reverse();
      };
      LazyWrapper.prototype.toArray = function() {
        return this.take(MAX_ARRAY_LENGTH);
      };
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash2[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
        if (!lodashFunc) {
          return;
        }
        lodash2.prototype[methodName] = function() {
          var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray2(value);
          var interceptor = function(value2) {
            var result3 = lodashFunc.apply(lodash2, arrayPush2([value2], args));
            return isTaker && chainAll ? result3[0] : result3;
          };
          if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
            isLazy = useLazy = false;
          }
          var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
          if (!retUnwrapped && useLazy) {
            value = onlyLazy ? value : new LazyWrapper(this);
            var result2 = func.apply(value, args);
            result2.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined$1 });
            return new LodashWrapper(result2, chainAll);
          }
          if (isUnwrapped && onlyLazy) {
            return func.apply(this, args);
          }
          result2 = this.thru(interceptor);
          return isUnwrapped ? isTaker ? result2.value()[0] : result2.value() : result2;
        };
      });
      arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
        var func = arrayProto2[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
        lodash2.prototype[methodName] = function() {
          var args = arguments;
          if (retUnwrapped && !this.__chain__) {
            var value = this.value();
            return func.apply(isArray2(value) ? value : [], args);
          }
          return this[chainName](function(value2) {
            return func.apply(isArray2(value2) ? value2 : [], args);
          });
        };
      });
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var lodashFunc = lodash2[methodName];
        if (lodashFunc) {
          var key = lodashFunc.name + "";
          if (!hasOwnProperty2.call(realNames, key)) {
            realNames[key] = [];
          }
          realNames[key].push({ "name": methodName, "func": lodashFunc });
        }
      });
      realNames[createHybrid(undefined$1, WRAP_BIND_KEY_FLAG).name] = [{
        "name": "wrapper",
        "func": undefined$1
      }];
      LazyWrapper.prototype.clone = lazyClone;
      LazyWrapper.prototype.reverse = lazyReverse;
      LazyWrapper.prototype.value = lazyValue;
      lodash2.prototype.at = wrapperAt;
      lodash2.prototype.chain = wrapperChain;
      lodash2.prototype.commit = wrapperCommit;
      lodash2.prototype.next = wrapperNext;
      lodash2.prototype.plant = wrapperPlant;
      lodash2.prototype.reverse = wrapperReverse;
      lodash2.prototype.toJSON = lodash2.prototype.valueOf = lodash2.prototype.value = wrapperValue;
      lodash2.prototype.first = lodash2.prototype.head;
      if (symIterator) {
        lodash2.prototype[symIterator] = wrapperToIterator;
      }
      return lodash2;
    };
    var _ = runInContext();
    if (freeModule) {
      (freeModule.exports = _)._ = _;
      freeExports._ = _;
    } else {
      root2._ = _;
    }
  }).call(commonjsGlobal);
})(lodash, lodash.exports);
class EventEmitter {
  constructor() {
    __publicField(this, "subscriptions", /* @__PURE__ */ new Map());
    __publicField(this, "emitEffectCache", /* @__PURE__ */ new Map());
    __publicField(this, "useSubscription", (event, listener) => {
      const callbackRef = useRef();
      useEffect(() => {
        var _a2, _b2;
        callbackRef.current = listener;
        function subscription(val) {
          if (callbackRef.current) {
            callbackRef.current(val);
          }
        }
        const subscriptions = (_b2 = (_a2 = this.subscriptions) == null ? void 0 : _a2.get(event)) != null ? _b2 : [];
        subscriptions.push(subscription);
        this.subscriptions.set(event, subscriptions);
        this.emitEffect(event);
        return () => {
          this.subscriptions.delete(event);
        };
      }, []);
    });
    __publicField(this, "emit", (event, ...args) => {
      if (typeof event === "string" || typeof event === "number") {
        const subscriptionValuesCallback = this.subscriptions.get(event);
        subscriptionValuesCallback == null ? void 0 : subscriptionValuesCallback.forEach((callback) => {
          callback == null ? void 0 : callback({
            params: lodash.exports.cloneDeep(args),
            event
          });
        });
        this.emitEffectCache.set(event, {
          params: lodash.exports.cloneDeep(args),
          event
        });
      } else
        throw new TypeError("event must be string or number !");
    });
    __publicField(this, "emitEffect", (event) => {
      const emitEffectCache = this.emitEffectCache.get(event);
      const listeners = this.subscriptions.get(event);
      if (emitEffectCache)
        listeners == null ? void 0 : listeners.forEach((listener) => {
          listener == null ? void 0 : listener(__spreadValues({}, emitEffectCache));
        });
    });
    __publicField(this, "removeListener", (event) => {
      this.subscriptions.delete(event);
    });
    __publicField(this, "clear", () => {
      this.subscriptions.clear();
    });
    this.clear();
  }
}
const eventEmitterOverall = new EventEmitter();
function useChartEventEmitter(options) {
  const ref = useRef();
  const eventEmitterOptions = useMemo$1(() => options != null ? options : { global: false }, [options]);
  if (!ref.current) {
    ref.current = eventEmitterOptions.global ? ref.current = eventEmitterOverall : ref.current = new EventEmitter();
  }
  useEffect(() => {
    return () => {
      var _a2;
      return (_a2 = ref.current) == null ? void 0 : _a2.clear();
    };
  }, []);
  return ref.current;
}
const useEchartsTool = ({
  id: id2,
  title,
  chart,
  option
}, deps) => {
  const ref = useRef(_Charts);
  const event = useChartEventEmitter({ global: true });
  useDebounceEffect(() => {
    if (ref.current && (chart == null ? void 0 : chart.current) && id2 && option) {
      ref.current.add(id2, chart == null ? void 0 : chart.current, option, title);
      event.emit("list");
    }
  }, deps != null ? deps : [], {
    wait: 100
  });
  return { tool: ref.current };
};
var IconContext = /* @__PURE__ */ createContext({});
var IconContext$1 = IconContext;
function _defineProperty$1(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function ownKeys$1(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
    })), keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    i % 2 ? ownKeys$1(Object(source), true).forEach(function(key) {
      _defineProperty$1(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
  if (_i == null)
    return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _arrayLikeToArray(arr, len2) {
  if (len2 == null || len2 > arr.length)
    len2 = arr.length;
  for (var i = 0, arr2 = new Array(len2); i < len2; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray(o, minLen);
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
var classnames = { exports: {} };
/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
(function(module) {
  (function() {
    var hasOwn2 = {}.hasOwnProperty;
    function classNames2() {
      var classes = [];
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (!arg)
          continue;
        var argType = typeof arg;
        if (argType === "string" || argType === "number") {
          classes.push(arg);
        } else if (Array.isArray(arg)) {
          if (arg.length) {
            var inner2 = classNames2.apply(null, arg);
            if (inner2) {
              classes.push(inner2);
            }
          }
        } else if (argType === "object") {
          if (arg.toString === Object.prototype.toString) {
            for (var key in arg) {
              if (hasOwn2.call(arg, key) && arg[key]) {
                classes.push(key);
              }
            }
          } else {
            classes.push(arg.toString());
          }
        }
      }
      return classes.join(" ");
    }
    if (module.exports) {
      classNames2.default = classNames2;
      module.exports = classNames2;
    } else {
      window.classNames = classNames2;
    }
  })();
})(classnames);
var classNames = classnames.exports;
function _typeof$1(obj) {
  "@babel/helpers - typeof";
  return _typeof$1 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && typeof Symbol == "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof$1(obj);
}
function bound01(n2, max3) {
  if (isOnePointZero(n2)) {
    n2 = "100%";
  }
  var isPercent = isPercentage(n2);
  n2 = max3 === 360 ? n2 : Math.min(max3, Math.max(0, parseFloat(n2)));
  if (isPercent) {
    n2 = parseInt(String(n2 * max3), 10) / 100;
  }
  if (Math.abs(n2 - max3) < 1e-6) {
    return 1;
  }
  if (max3 === 360) {
    n2 = (n2 < 0 ? n2 % max3 + max3 : n2 % max3) / parseFloat(String(max3));
  } else {
    n2 = n2 % max3 / parseFloat(String(max3));
  }
  return n2;
}
function isOnePointZero(n2) {
  return typeof n2 === "string" && n2.indexOf(".") !== -1 && parseFloat(n2) === 1;
}
function isPercentage(n2) {
  return typeof n2 === "string" && n2.indexOf("%") !== -1;
}
function boundAlpha(a) {
  a = parseFloat(a);
  if (isNaN(a) || a < 0 || a > 1) {
    a = 1;
  }
  return a;
}
function convertToPercentage(n2) {
  if (n2 <= 1) {
    return Number(n2) * 100 + "%";
  }
  return n2;
}
function pad2(c2) {
  return c2.length === 1 ? "0" + c2 : String(c2);
}
function rgbToRgb(r2, g2, b2) {
  return {
    r: bound01(r2, 255) * 255,
    g: bound01(g2, 255) * 255,
    b: bound01(b2, 255) * 255
  };
}
function hue2rgb(p2, q2, t2) {
  if (t2 < 0) {
    t2 += 1;
  }
  if (t2 > 1) {
    t2 -= 1;
  }
  if (t2 < 1 / 6) {
    return p2 + (q2 - p2) * (6 * t2);
  }
  if (t2 < 1 / 2) {
    return q2;
  }
  if (t2 < 2 / 3) {
    return p2 + (q2 - p2) * (2 / 3 - t2) * 6;
  }
  return p2;
}
function hslToRgb(h, s, l2) {
  var r2;
  var g2;
  var b2;
  h = bound01(h, 360);
  s = bound01(s, 100);
  l2 = bound01(l2, 100);
  if (s === 0) {
    g2 = l2;
    b2 = l2;
    r2 = l2;
  } else {
    var q2 = l2 < 0.5 ? l2 * (1 + s) : l2 + s - l2 * s;
    var p2 = 2 * l2 - q2;
    r2 = hue2rgb(p2, q2, h + 1 / 3);
    g2 = hue2rgb(p2, q2, h);
    b2 = hue2rgb(p2, q2, h - 1 / 3);
  }
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHsv(r2, g2, b2) {
  r2 = bound01(r2, 255);
  g2 = bound01(g2, 255);
  b2 = bound01(b2, 255);
  var max3 = Math.max(r2, g2, b2);
  var min3 = Math.min(r2, g2, b2);
  var h = 0;
  var v4 = max3;
  var d2 = max3 - min3;
  var s = max3 === 0 ? 0 : d2 / max3;
  if (max3 === min3) {
    h = 0;
  } else {
    switch (max3) {
      case r2:
        h = (g2 - b2) / d2 + (g2 < b2 ? 6 : 0);
        break;
      case g2:
        h = (b2 - r2) / d2 + 2;
        break;
      case b2:
        h = (r2 - g2) / d2 + 4;
        break;
    }
    h /= 6;
  }
  return { h, s, v: v4 };
}
function hsvToRgb(h, s, v4) {
  h = bound01(h, 360) * 6;
  s = bound01(s, 100);
  v4 = bound01(v4, 100);
  var i = Math.floor(h);
  var f2 = h - i;
  var p2 = v4 * (1 - s);
  var q2 = v4 * (1 - f2 * s);
  var t2 = v4 * (1 - (1 - f2) * s);
  var mod = i % 6;
  var r2 = [v4, q2, p2, p2, t2, v4][mod];
  var g2 = [t2, v4, v4, q2, p2, p2][mod];
  var b2 = [p2, p2, t2, v4, v4, q2][mod];
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHex(r2, g2, b2, allow3Char) {
  var hex2 = [
    pad2(Math.round(r2).toString(16)),
    pad2(Math.round(g2).toString(16)),
    pad2(Math.round(b2).toString(16))
  ];
  if (allow3Char && hex2[0].startsWith(hex2[0].charAt(1)) && hex2[1].startsWith(hex2[1].charAt(1)) && hex2[2].startsWith(hex2[2].charAt(1))) {
    return hex2[0].charAt(0) + hex2[1].charAt(0) + hex2[2].charAt(0);
  }
  return hex2.join("");
}
function convertHexToDecimal(h) {
  return parseIntFromHex(h) / 255;
}
function parseIntFromHex(val) {
  return parseInt(val, 16);
}
var names = {
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgreen: "#006400",
  darkgrey: "#a9a9a9",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  goldenrod: "#daa520",
  gold: "#ffd700",
  gray: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  grey: "#808080",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavenderblush: "#fff0f5",
  lavender: "#e6e6fa",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgreen: "#90ee90",
  lightgrey: "#d3d3d3",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370db",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#db7093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
};
function inputToRGB(color) {
  var rgb = { r: 0, g: 0, b: 0 };
  var a = 1;
  var s = null;
  var v4 = null;
  var l2 = null;
  var ok2 = false;
  var format2 = false;
  if (typeof color === "string") {
    color = stringInputToObject(color);
  }
  if (typeof color === "object") {
    if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
      rgb = rgbToRgb(color.r, color.g, color.b);
      ok2 = true;
      format2 = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
      s = convertToPercentage(color.s);
      v4 = convertToPercentage(color.v);
      rgb = hsvToRgb(color.h, s, v4);
      ok2 = true;
      format2 = "hsv";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
      s = convertToPercentage(color.s);
      l2 = convertToPercentage(color.l);
      rgb = hslToRgb(color.h, s, l2);
      ok2 = true;
      format2 = "hsl";
    }
    if (Object.prototype.hasOwnProperty.call(color, "a")) {
      a = color.a;
    }
  }
  a = boundAlpha(a);
  return {
    ok: ok2,
    format: color.format || format2,
    r: Math.min(255, Math.max(rgb.r, 0)),
    g: Math.min(255, Math.max(rgb.g, 0)),
    b: Math.min(255, Math.max(rgb.b, 0)),
    a
  };
}
var CSS_INTEGER = "[-\\+]?\\d+%?";
var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";
var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var matchers = {
  CSS_UNIT: new RegExp(CSS_UNIT),
  rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
  rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
  hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
  hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
  hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
  hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
  hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
  hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
};
function stringInputToObject(color) {
  color = color.trim().toLowerCase();
  if (color.length === 0) {
    return false;
  }
  var named = false;
  if (names[color]) {
    color = names[color];
    named = true;
  } else if (color === "transparent") {
    return { r: 0, g: 0, b: 0, a: 0, format: "name" };
  }
  var match = matchers.rgb.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3] };
  }
  match = matchers.rgba.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3], a: match[4] };
  }
  match = matchers.hsl.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3] };
  }
  match = matchers.hsla.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3], a: match[4] };
  }
  match = matchers.hsv.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3] };
  }
  match = matchers.hsva.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3], a: match[4] };
  }
  match = matchers.hex8.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      a: convertHexToDecimal(match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex6.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      format: named ? "name" : "hex"
    };
  }
  match = matchers.hex4.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      a: convertHexToDecimal(match[4] + match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex3.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      format: named ? "name" : "hex"
    };
  }
  return false;
}
function isValidCSSUnit(color) {
  return Boolean(matchers.CSS_UNIT.exec(String(color)));
}
var hueStep = 2;
var saturationStep = 0.16;
var saturationStep2 = 0.05;
var brightnessStep1 = 0.05;
var brightnessStep2 = 0.15;
var lightColorCount = 5;
var darkColorCount = 4;
var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];
function toHsv(_ref) {
  var r2 = _ref.r, g2 = _ref.g, b2 = _ref.b;
  var hsv = rgbToHsv(r2, g2, b2);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
}
function toHex(_ref2) {
  var r2 = _ref2.r, g2 = _ref2.g, b2 = _ref2.b;
  return "#".concat(rgbToHex(r2, g2, b2, false));
}
function mix$1(rgb1, rgb2, amount) {
  var p2 = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p2 + rgb1.r,
    g: (rgb2.g - rgb1.g) * p2 + rgb1.g,
    b: (rgb2.b - rgb1.b) * p2 + rgb1.b
  };
  return rgb;
}
function getHue(hsv, i, light) {
  var hue;
  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }
  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }
  return hue;
}
function getSaturation(hsv, i, light) {
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }
  var saturation;
  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  }
  if (saturation > 1) {
    saturation = 1;
  }
  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }
  if (saturation < 0.06) {
    saturation = 0.06;
  }
  return Number(saturation.toFixed(2));
}
function getValue$2(hsv, i, light) {
  var value;
  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }
  if (value > 1) {
    value = 1;
  }
  return Number(value.toFixed(2));
}
function generate$1(color) {
  var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);
  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue$2(hsv, i, true)
    }));
    patterns.push(colorString);
  }
  patterns.push(toHex(pColor));
  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);
    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue$2(_hsv, _i)
    }));
    patterns.push(_colorString);
  }
  if (opts.theme === "dark") {
    return darkColorMap.map(function(_ref3) {
      var index2 = _ref3.index, opacity = _ref3.opacity;
      var darkColorString = toHex(mix$1(inputToRGB(opts.backgroundColor || "#141414"), inputToRGB(patterns[index2]), opacity * 100));
      return darkColorString;
    });
  }
  return patterns;
}
var presetPrimaryColors = {
  red: "#F5222D",
  volcano: "#FA541C",
  orange: "#FA8C16",
  gold: "#FAAD14",
  yellow: "#FADB14",
  lime: "#A0D911",
  green: "#52C41A",
  cyan: "#13C2C2",
  blue: "#1890FF",
  geekblue: "#2F54EB",
  purple: "#722ED1",
  magenta: "#EB2F96",
  grey: "#666666"
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function(key) {
  presetPalettes[key] = generate$1(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5];
  presetDarkPalettes[key] = generate$1(presetPrimaryColors[key], {
    theme: "dark",
    backgroundColor: "#141414"
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});
presetPalettes.red;
presetPalettes.volcano;
presetPalettes.gold;
presetPalettes.orange;
presetPalettes.yellow;
presetPalettes.lime;
presetPalettes.green;
presetPalettes.cyan;
presetPalettes.blue;
presetPalettes.geekblue;
presetPalettes.purple;
presetPalettes.magenta;
presetPalettes.grey;
var warned = {};
function warning$2(valid, message) {
}
function call(method4, valid, message) {
  if (!valid && !warned[message]) {
    method4(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning$2, valid, message);
}
function canUseDom() {
  return !!(typeof window !== "undefined" && window.document && window.document.createElement);
}
var MARK_KEY = "rc-util-key";
function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, mark = _ref.mark;
  if (mark) {
    return mark.startsWith("data-") ? mark : "data-".concat(mark);
  }
  return MARK_KEY;
}
function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }
  var head = document.querySelector("head");
  return head || document.body;
}
function injectCSS(css2) {
  var _option$csp;
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!canUseDom()) {
    return null;
  }
  var styleNode = document.createElement("style");
  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
    var _option$csp2;
    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
  }
  styleNode.innerHTML = css2;
  var container2 = getContainer(option);
  var firstChild = container2.firstChild;
  if (option.prepend && container2.prepend) {
    container2.prepend(styleNode);
  } else if (option.prepend && firstChild) {
    container2.insertBefore(styleNode, firstChild);
  } else {
    container2.appendChild(styleNode);
  }
  return styleNode;
}
var containerCache = /* @__PURE__ */ new Map();
function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var container2 = getContainer(option);
  return Array.from(containerCache.get(container2).children).find(function(node) {
    return node.tagName === "STYLE" && node.getAttribute(getMark(option)) === key;
  });
}
function updateCSS(css2, key) {
  var option = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var container2 = getContainer(option);
  if (!containerCache.has(container2)) {
    var placeholderStyle = injectCSS("", option);
    var parentNode2 = placeholderStyle.parentNode;
    containerCache.set(container2, parentNode2);
    parentNode2.removeChild(placeholderStyle);
  }
  var existNode = findExistNode(key, option);
  if (existNode) {
    var _option$csp3, _option$csp4;
    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
      var _option$csp5;
      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
    }
    if (existNode.innerHTML !== css2) {
      existNode.innerHTML = css2;
    }
    return existNode;
  }
  var newNode = injectCSS(css2, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}
function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof$1(target) === "object" && typeof target.name === "string" && typeof target.theme === "string" && (_typeof$1(target.icon) === "object" || typeof target.icon === "function");
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return Object.keys(attrs).reduce(function(acc, key) {
    var val = attrs[key];
    switch (key) {
      case "class":
        acc.className = val;
        delete acc.class;
        break;
      default:
        acc[key] = val;
    }
    return acc;
  }, {});
}
function generate(node, key, rootProps) {
  if (!rootProps) {
    return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2$1({
      key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function(child, index2) {
      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
    }));
  }
  return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2$1(_objectSpread2$1({
    key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function(child, index2) {
    return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
  }));
}
function getSecondaryColor(primaryColor) {
  return generate$1(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }
  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
}
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles2() {
  var styleStr = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : iconStyles;
  var _useContext = useContext(IconContext$1), csp = _useContext.csp;
  useEffect(function() {
    updateCSS(styleStr, "@ant-design-icons", {
      prepend: true,
      csp
    });
  }, []);
};
var _excluded$j = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: "#333",
  secondaryColor: "#E6E6E6",
  calculated: false
};
function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor, secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}
function getTwoToneColors() {
  return _objectSpread2$1({}, twoToneColorPalette);
}
var IconBase = function IconBase2(props) {
  var icon = props.icon, className = props.className, onClick = props.onClick, style2 = props.style, primaryColor = props.primaryColor, secondaryColor = props.secondaryColor, restProps = _objectWithoutProperties(props, _excluded$j);
  var colors = twoToneColorPalette;
  if (primaryColor) {
    colors = {
      primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }
  useInsertStyles();
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));
  if (!isIconDefinition(icon)) {
    return null;
  }
  var target = icon;
  if (target && typeof target.icon === "function") {
    target = _objectSpread2$1(_objectSpread2$1({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }
  return generate(target.icon, "svg-".concat(target.name), _objectSpread2$1({
    className,
    onClick,
    style: style2,
    "data-icon": target.name,
    width: "1em",
    height: "1em",
    fill: "currentColor",
    "aria-hidden": "true"
  }, restProps));
};
IconBase.displayName = "IconReact";
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;
var ReactIcon = IconBase;
function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return ReactIcon.setTwoToneColors({
    primaryColor,
    secondaryColor
  });
}
function getTwoToneColor() {
  var colors = ReactIcon.getTwoToneColors();
  if (!colors.calculated) {
    return colors.primaryColor;
  }
  return [colors.primaryColor, colors.secondaryColor];
}
var _excluded$i = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
setTwoToneColor("#1890ff");
var Icon$1 = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var className = props.className, icon = props.icon, spin = props.spin, rotate2 = props.rotate, tabIndex = props.tabIndex, onClick = props.onClick, twoToneColor = props.twoToneColor, restProps = _objectWithoutProperties(props, _excluded$i);
  var _React$useContext = React.useContext(IconContext$1), _React$useContext$pre = _React$useContext.prefixCls, prefixCls = _React$useContext$pre === void 0 ? "anticon" : _React$useContext$pre;
  var classString = classNames(prefixCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty$1(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === "loading"), _classNames), className);
  var iconTabIndex = tabIndex;
  if (iconTabIndex === void 0 && onClick) {
    iconTabIndex = -1;
  }
  var svgStyle = rotate2 ? {
    msTransform: "rotate(".concat(rotate2, "deg)"),
    transform: "rotate(".concat(rotate2, "deg)")
  } : void 0;
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return /* @__PURE__ */ React.createElement("span", _objectSpread2$1(_objectSpread2$1({
    role: "img",
    "aria-label": icon.name
  }, restProps), {}, {
    ref,
    tabIndex: iconTabIndex,
    onClick,
    className: classString
  }), /* @__PURE__ */ React.createElement(ReactIcon, {
    icon,
    primaryColor,
    secondaryColor,
    style: svgStyle
  }));
});
Icon$1.displayName = "AntdIcon";
Icon$1.getTwoToneColor = getTwoToneColor;
Icon$1.setTwoToneColor = setTwoToneColor;
var AntdIcon = Icon$1;
var CloseOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3 5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4 512 196.9 824.9A7.95 7.95 0 00203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3 3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" } }] }, "name": "close", "theme": "outlined" };
var CloseOutlinedSvg = CloseOutlined$2;
var CloseOutlined = function CloseOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: CloseOutlinedSvg
  }));
};
CloseOutlined.displayName = "CloseOutlined";
var CloseOutlined$1 = /* @__PURE__ */ React.forwardRef(CloseOutlined);
var DownOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5 0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39 17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z" } }] }, "name": "down", "theme": "outlined" };
var DownOutlinedSvg = DownOutlined$2;
var DownOutlined = function DownOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: DownOutlinedSvg
  }));
};
DownOutlined.displayName = "DownOutlined";
var DownOutlined$1 = /* @__PURE__ */ React.forwardRef(DownOutlined);
var EllipsisOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M176 511a56 56 0 10112 0 56 56 0 10-112 0zm280 0a56 56 0 10112 0 56 56 0 10-112 0zm280 0a56 56 0 10112 0 56 56 0 10-112 0z" } }] }, "name": "ellipsis", "theme": "outlined" };
var EllipsisOutlinedSvg = EllipsisOutlined$2;
var EllipsisOutlined = function EllipsisOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: EllipsisOutlinedSvg
  }));
};
EllipsisOutlined.displayName = "EllipsisOutlined";
var EllipsisOutlined$1 = /* @__PURE__ */ React.forwardRef(EllipsisOutlined);
var LeftOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M724 218.3V141c0-6.7-7.7-10.4-12.9-6.3L260.3 486.8a31.86 31.86 0 000 50.3l450.8 352.1c5.3 4.1 12.9.4 12.9-6.3v-77.3c0-4.9-2.3-9.6-6.1-12.6l-360-281 360-281.1c3.8-3 6.1-7.7 6.1-12.6z" } }] }, "name": "left", "theme": "outlined" };
var LeftOutlinedSvg = LeftOutlined$2;
var LeftOutlined = function LeftOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: LeftOutlinedSvg
  }));
};
LeftOutlined.displayName = "LeftOutlined";
var LeftOutlined$1 = /* @__PURE__ */ React.forwardRef(LeftOutlined);
var LoadingOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, "name": "loading", "theme": "outlined" };
var LoadingOutlinedSvg = LoadingOutlined$2;
var LoadingOutlined = function LoadingOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: LoadingOutlinedSvg
  }));
};
LoadingOutlined.displayName = "LoadingOutlined";
var LoadingOutlined$1 = /* @__PURE__ */ React.forwardRef(LoadingOutlined);
var PlusOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "defs", "attrs": {}, "children": [{ "tag": "style", "attrs": {} }] }, { "tag": "path", "attrs": { "d": "M482 152h60q8 0 8 8v704q0 8-8 8h-60q-8 0-8-8V160q0-8 8-8z" } }, { "tag": "path", "attrs": { "d": "M176 474h672q8 0 8 8v60q0 8-8 8H176q-8 0-8-8v-60q0-8 8-8z" } }] }, "name": "plus", "theme": "outlined" };
var PlusOutlinedSvg = PlusOutlined$2;
var PlusOutlined = function PlusOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: PlusOutlinedSvg
  }));
};
PlusOutlined.displayName = "PlusOutlined";
var PlusOutlined$1 = /* @__PURE__ */ React.forwardRef(PlusOutlined);
var RightOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M765.7 486.8L314.9 134.7A7.97 7.97 0 00302 141v77.3c0 4.9 2.3 9.6 6.1 12.6l360 281.1-360 281.1c-3.9 3-6.1 7.7-6.1 12.6V883c0 6.7 7.7 10.4 12.9 6.3l450.8-352.1a31.96 31.96 0 000-50.4z" } }] }, "name": "right", "theme": "outlined" };
var RightOutlinedSvg = RightOutlined$2;
var RightOutlined = function RightOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: RightOutlinedSvg
  }));
};
RightOutlined.displayName = "RightOutlined";
var RightOutlined$1 = /* @__PURE__ */ React.forwardRef(RightOutlined);
var UpOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M890.5 755.3L537.9 269.2c-12.8-17.6-39-17.6-51.7 0L133.5 755.3A8 8 0 00140 768h75c5.1 0 9.9-2.5 12.9-6.6L512 369.8l284.1 391.6c3 4.1 7.8 6.6 12.9 6.6h75c6.5 0 10.3-7.4 6.5-12.7z" } }] }, "name": "up", "theme": "outlined" };
var UpOutlinedSvg = UpOutlined$2;
var UpOutlined = function UpOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    ref,
    icon: UpOutlinedSvg
  }));
};
UpOutlined.displayName = "UpOutlined";
var UpOutlined$1 = /* @__PURE__ */ React.forwardRef(UpOutlined);
function _extends$1() {
  _extends$1 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor)
      descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps)
    _defineProperties(Constructor.prototype, protoProps);
  if (staticProps)
    _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _setPrototypeOf$1(o, p2) {
  _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf$1(o, p2);
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass)
    _setPrototypeOf$1(subClass, superClass);
}
function _getPrototypeOf$1(o) {
  _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf$1(o);
}
function _isNativeReflectConstruct$1() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _assertThisInitialized(self2) {
  if (self2 === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self2;
}
function _possibleConstructorReturn(self2, call2) {
  if (call2 && (_typeof$1(call2) === "object" || typeof call2 === "function")) {
    return call2;
  } else if (call2 !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self2);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$1();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf$1(Derived), result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$1(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
function omit(obj, fields) {
  var clone3 = _objectSpread2$1({}, obj);
  if (Array.isArray(fields)) {
    fields.forEach(function(key) {
      delete clone3[key];
    });
  }
  return clone3;
}
var reactIs = { exports: {} };
var reactIs_production_min = {};
/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b = typeof Symbol === "function" && Symbol.for, c = b ? Symbol.for("react.element") : 60103, d = b ? Symbol.for("react.portal") : 60106, e = b ? Symbol.for("react.fragment") : 60107, f$1 = b ? Symbol.for("react.strict_mode") : 60108, g$1 = b ? Symbol.for("react.profiler") : 60114, h$1 = b ? Symbol.for("react.provider") : 60109, k = b ? Symbol.for("react.context") : 60110, l = b ? Symbol.for("react.async_mode") : 60111, m$2 = b ? Symbol.for("react.concurrent_mode") : 60111, n$1 = b ? Symbol.for("react.forward_ref") : 60112, p$1 = b ? Symbol.for("react.suspense") : 60113, q$1 = b ? Symbol.for("react.suspense_list") : 60120, r$1 = b ? Symbol.for("react.memo") : 60115, t = b ? Symbol.for("react.lazy") : 60116, v = b ? Symbol.for("react.block") : 60121, w = b ? Symbol.for("react.fundamental") : 60117, x = b ? Symbol.for("react.responder") : 60118, y$1 = b ? Symbol.for("react.scope") : 60119;
function z(a) {
  if (typeof a === "object" && a !== null) {
    var u = a.$$typeof;
    switch (u) {
      case c:
        switch (a = a.type, a) {
          case l:
          case m$2:
          case e:
          case g$1:
          case f$1:
          case p$1:
            return a;
          default:
            switch (a = a && a.$$typeof, a) {
              case k:
              case n$1:
              case t:
              case r$1:
              case h$1:
                return a;
              default:
                return u;
            }
        }
      case d:
        return u;
    }
  }
}
function A(a) {
  return z(a) === m$2;
}
reactIs_production_min.AsyncMode = l;
reactIs_production_min.ConcurrentMode = m$2;
reactIs_production_min.ContextConsumer = k;
reactIs_production_min.ContextProvider = h$1;
reactIs_production_min.Element = c;
reactIs_production_min.ForwardRef = n$1;
reactIs_production_min.Fragment = e;
reactIs_production_min.Lazy = t;
reactIs_production_min.Memo = r$1;
reactIs_production_min.Portal = d;
reactIs_production_min.Profiler = g$1;
reactIs_production_min.StrictMode = f$1;
reactIs_production_min.Suspense = p$1;
reactIs_production_min.isAsyncMode = function(a) {
  return A(a) || z(a) === l;
};
reactIs_production_min.isConcurrentMode = A;
reactIs_production_min.isContextConsumer = function(a) {
  return z(a) === k;
};
reactIs_production_min.isContextProvider = function(a) {
  return z(a) === h$1;
};
reactIs_production_min.isElement = function(a) {
  return typeof a === "object" && a !== null && a.$$typeof === c;
};
reactIs_production_min.isForwardRef = function(a) {
  return z(a) === n$1;
};
reactIs_production_min.isFragment = function(a) {
  return z(a) === e;
};
reactIs_production_min.isLazy = function(a) {
  return z(a) === t;
};
reactIs_production_min.isMemo = function(a) {
  return z(a) === r$1;
};
reactIs_production_min.isPortal = function(a) {
  return z(a) === d;
};
reactIs_production_min.isProfiler = function(a) {
  return z(a) === g$1;
};
reactIs_production_min.isStrictMode = function(a) {
  return z(a) === f$1;
};
reactIs_production_min.isSuspense = function(a) {
  return z(a) === p$1;
};
reactIs_production_min.isValidElementType = function(a) {
  return typeof a === "string" || typeof a === "function" || a === e || a === m$2 || a === g$1 || a === f$1 || a === p$1 || a === q$1 || typeof a === "object" && a !== null && (a.$$typeof === t || a.$$typeof === r$1 || a.$$typeof === h$1 || a.$$typeof === k || a.$$typeof === n$1 || a.$$typeof === w || a.$$typeof === x || a.$$typeof === y$1 || a.$$typeof === v);
};
reactIs_production_min.typeOf = z;
{
  reactIs.exports = reactIs_production_min;
}
function toArray$1(children) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var ret = [];
  React__default.Children.forEach(children, function(child) {
    if ((child === void 0 || child === null) && !option.keepEmpty) {
      return;
    }
    if (Array.isArray(child)) {
      ret = ret.concat(toArray$1(child));
    } else if (reactIs.exports.isFragment(child) && child.props) {
      ret = ret.concat(toArray$1(child.props.children, option));
    } else {
      ret.push(child);
    }
  });
  return ret;
}
function useMemo(getValue2, condition, shouldUpdate) {
  var cacheRef = React.useRef({});
  if (!("value" in cacheRef.current) || shouldUpdate(cacheRef.current.condition, condition)) {
    cacheRef.current.value = getValue2();
    cacheRef.current.condition = condition;
  }
  return cacheRef.current.value;
}
function fillRef(ref, node) {
  if (typeof ref === "function") {
    ref(node);
  } else if (_typeof$1(ref) === "object" && ref && "current" in ref) {
    ref.current = node;
  }
}
function composeRef() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }
  var refList = refs.filter(function(ref) {
    return ref;
  });
  if (refList.length <= 1) {
    return refList[0];
  }
  return function(node) {
    refs.forEach(function(ref) {
      fillRef(ref, node);
    });
  };
}
function supportRef(nodeOrComponent) {
  var _type$prototype, _nodeOrComponent$prot;
  var type4 = reactIs.exports.isMemo(nodeOrComponent) ? nodeOrComponent.type.type : nodeOrComponent.type;
  if (typeof type4 === "function" && !((_type$prototype = type4.prototype) === null || _type$prototype === void 0 ? void 0 : _type$prototype.render)) {
    return false;
  }
  if (typeof nodeOrComponent === "function" && !((_nodeOrComponent$prot = nodeOrComponent.prototype) === null || _nodeOrComponent$prot === void 0 ? void 0 : _nodeOrComponent$prot.render)) {
    return false;
  }
  return true;
}
var reactDom = { exports: {} };
var reactDom_production_min = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
var objectAssign = shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
var scheduler = { exports: {} };
var scheduler_production_min = {};
/** @license React v0.20.2
 * scheduler.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function(exports) {
  var f2, g2, h, k2;
  if (typeof performance === "object" && typeof performance.now === "function") {
    var l2 = performance;
    exports.unstable_now = function() {
      return l2.now();
    };
  } else {
    var p2 = Date, q2 = p2.now();
    exports.unstable_now = function() {
      return p2.now() - q2;
    };
  }
  if (typeof window === "undefined" || typeof MessageChannel !== "function") {
    var t2 = null, u = null, w2 = function() {
      if (t2 !== null)
        try {
          var a = exports.unstable_now();
          t2(true, a);
          t2 = null;
        } catch (b2) {
          throw setTimeout(w2, 0), b2;
        }
    };
    f2 = function(a) {
      t2 !== null ? setTimeout(f2, 0, a) : (t2 = a, setTimeout(w2, 0));
    };
    g2 = function(a, b2) {
      u = setTimeout(a, b2);
    };
    h = function() {
      clearTimeout(u);
    };
    exports.unstable_shouldYield = function() {
      return false;
    };
    k2 = exports.unstable_forceFrameRate = function() {
    };
  } else {
    var x2 = window.setTimeout, y2 = window.clearTimeout;
    if (typeof console !== "undefined") {
      var z2 = window.cancelAnimationFrame;
      typeof window.requestAnimationFrame !== "function" && console.error("This browser doesn't support requestAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");
      typeof z2 !== "function" && console.error("This browser doesn't support cancelAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");
    }
    var A2 = false, B2 = null, C = -1, D2 = 5, E = 0;
    exports.unstable_shouldYield = function() {
      return exports.unstable_now() >= E;
    };
    k2 = function() {
    };
    exports.unstable_forceFrameRate = function(a) {
      0 > a || 125 < a ? console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported") : D2 = 0 < a ? Math.floor(1e3 / a) : 5;
    };
    var F2 = new MessageChannel(), G2 = F2.port2;
    F2.port1.onmessage = function() {
      if (B2 !== null) {
        var a = exports.unstable_now();
        E = a + D2;
        try {
          B2(true, a) ? G2.postMessage(null) : (A2 = false, B2 = null);
        } catch (b2) {
          throw G2.postMessage(null), b2;
        }
      } else
        A2 = false;
    };
    f2 = function(a) {
      B2 = a;
      A2 || (A2 = true, G2.postMessage(null));
    };
    g2 = function(a, b2) {
      C = x2(function() {
        a(exports.unstable_now());
      }, b2);
    };
    h = function() {
      y2(C);
      C = -1;
    };
  }
  function H2(a, b2) {
    var c2 = a.length;
    a.push(b2);
    a:
      for (; ; ) {
        var d2 = c2 - 1 >>> 1, e2 = a[d2];
        if (e2 !== void 0 && 0 < I2(e2, b2))
          a[d2] = b2, a[c2] = e2, c2 = d2;
        else
          break a;
      }
  }
  function J(a) {
    a = a[0];
    return a === void 0 ? null : a;
  }
  function K(a) {
    var b2 = a[0];
    if (b2 !== void 0) {
      var c2 = a.pop();
      if (c2 !== b2) {
        a[0] = c2;
        a:
          for (var d2 = 0, e2 = a.length; d2 < e2; ) {
            var m2 = 2 * (d2 + 1) - 1, n2 = a[m2], v4 = m2 + 1, r2 = a[v4];
            if (n2 !== void 0 && 0 > I2(n2, c2))
              r2 !== void 0 && 0 > I2(r2, n2) ? (a[d2] = r2, a[v4] = c2, d2 = v4) : (a[d2] = n2, a[m2] = c2, d2 = m2);
            else if (r2 !== void 0 && 0 > I2(r2, c2))
              a[d2] = r2, a[v4] = c2, d2 = v4;
            else
              break a;
          }
      }
      return b2;
    }
    return null;
  }
  function I2(a, b2) {
    var c2 = a.sortIndex - b2.sortIndex;
    return c2 !== 0 ? c2 : a.id - b2.id;
  }
  var L = [], M2 = [], N2 = 1, O2 = null, P2 = 3, Q = false, R2 = false, S2 = false;
  function T2(a) {
    for (var b2 = J(M2); b2 !== null; ) {
      if (b2.callback === null)
        K(M2);
      else if (b2.startTime <= a)
        K(M2), b2.sortIndex = b2.expirationTime, H2(L, b2);
      else
        break;
      b2 = J(M2);
    }
  }
  function U2(a) {
    S2 = false;
    T2(a);
    if (!R2)
      if (J(L) !== null)
        R2 = true, f2(V2);
      else {
        var b2 = J(M2);
        b2 !== null && g2(U2, b2.startTime - a);
      }
  }
  function V2(a, b2) {
    R2 = false;
    S2 && (S2 = false, h());
    Q = true;
    var c2 = P2;
    try {
      T2(b2);
      for (O2 = J(L); O2 !== null && (!(O2.expirationTime > b2) || a && !exports.unstable_shouldYield()); ) {
        var d2 = O2.callback;
        if (typeof d2 === "function") {
          O2.callback = null;
          P2 = O2.priorityLevel;
          var e2 = d2(O2.expirationTime <= b2);
          b2 = exports.unstable_now();
          typeof e2 === "function" ? O2.callback = e2 : O2 === J(L) && K(L);
          T2(b2);
        } else
          K(L);
        O2 = J(L);
      }
      if (O2 !== null)
        var m2 = true;
      else {
        var n2 = J(M2);
        n2 !== null && g2(U2, n2.startTime - b2);
        m2 = false;
      }
      return m2;
    } finally {
      O2 = null, P2 = c2, Q = false;
    }
  }
  var W2 = k2;
  exports.unstable_IdlePriority = 5;
  exports.unstable_ImmediatePriority = 1;
  exports.unstable_LowPriority = 4;
  exports.unstable_NormalPriority = 3;
  exports.unstable_Profiling = null;
  exports.unstable_UserBlockingPriority = 2;
  exports.unstable_cancelCallback = function(a) {
    a.callback = null;
  };
  exports.unstable_continueExecution = function() {
    R2 || Q || (R2 = true, f2(V2));
  };
  exports.unstable_getCurrentPriorityLevel = function() {
    return P2;
  };
  exports.unstable_getFirstCallbackNode = function() {
    return J(L);
  };
  exports.unstable_next = function(a) {
    switch (P2) {
      case 1:
      case 2:
      case 3:
        var b2 = 3;
        break;
      default:
        b2 = P2;
    }
    var c2 = P2;
    P2 = b2;
    try {
      return a();
    } finally {
      P2 = c2;
    }
  };
  exports.unstable_pauseExecution = function() {
  };
  exports.unstable_requestPaint = W2;
  exports.unstable_runWithPriority = function(a, b2) {
    switch (a) {
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
        break;
      default:
        a = 3;
    }
    var c2 = P2;
    P2 = a;
    try {
      return b2();
    } finally {
      P2 = c2;
    }
  };
  exports.unstable_scheduleCallback = function(a, b2, c2) {
    var d2 = exports.unstable_now();
    typeof c2 === "object" && c2 !== null ? (c2 = c2.delay, c2 = typeof c2 === "number" && 0 < c2 ? d2 + c2 : d2) : c2 = d2;
    switch (a) {
      case 1:
        var e2 = -1;
        break;
      case 2:
        e2 = 250;
        break;
      case 5:
        e2 = 1073741823;
        break;
      case 4:
        e2 = 1e4;
        break;
      default:
        e2 = 5e3;
    }
    e2 = c2 + e2;
    a = { id: N2++, callback: b2, priorityLevel: a, startTime: c2, expirationTime: e2, sortIndex: -1 };
    c2 > d2 ? (a.sortIndex = c2, H2(M2, a), J(L) === null && a === J(M2) && (S2 ? h() : S2 = true, g2(U2, c2 - d2))) : (a.sortIndex = e2, H2(L, a), R2 || Q || (R2 = true, f2(V2)));
    return a;
  };
  exports.unstable_wrapCallback = function(a) {
    var b2 = P2;
    return function() {
      var c2 = P2;
      P2 = b2;
      try {
        return a.apply(this, arguments);
      } finally {
        P2 = c2;
      }
    };
  };
})(scheduler_production_min);
{
  scheduler.exports = scheduler_production_min;
}
/** @license React v17.0.2
 * react-dom.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var aa = React__default, m$1 = objectAssign, r = scheduler.exports;
function y(a) {
  for (var b2 = "https://reactjs.org/docs/error-decoder.html?invariant=" + a, c2 = 1; c2 < arguments.length; c2++)
    b2 += "&args[]=" + encodeURIComponent(arguments[c2]);
  return "Minified React error #" + a + "; visit " + b2 + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
}
if (!aa)
  throw Error(y(227));
var ba = /* @__PURE__ */ new Set(), ca = {};
function da(a, b2) {
  ea(a, b2);
  ea(a + "Capture", b2);
}
function ea(a, b2) {
  ca[a] = b2;
  for (a = 0; a < b2.length; a++)
    ba.add(b2[a]);
}
var fa = !(typeof window === "undefined" || typeof window.document === "undefined" || typeof window.document.createElement === "undefined"), ha = /^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/, ia = Object.prototype.hasOwnProperty, ja = {}, ka = {};
function la(a) {
  if (ia.call(ka, a))
    return true;
  if (ia.call(ja, a))
    return false;
  if (ha.test(a))
    return ka[a] = true;
  ja[a] = true;
  return false;
}
function ma(a, b2, c2, d2) {
  if (c2 !== null && c2.type === 0)
    return false;
  switch (typeof b2) {
    case "function":
    case "symbol":
      return true;
    case "boolean":
      if (d2)
        return false;
      if (c2 !== null)
        return !c2.acceptsBooleans;
      a = a.toLowerCase().slice(0, 5);
      return a !== "data-" && a !== "aria-";
    default:
      return false;
  }
}
function na(a, b2, c2, d2) {
  if (b2 === null || typeof b2 === "undefined" || ma(a, b2, c2, d2))
    return true;
  if (d2)
    return false;
  if (c2 !== null)
    switch (c2.type) {
      case 3:
        return !b2;
      case 4:
        return b2 === false;
      case 5:
        return isNaN(b2);
      case 6:
        return isNaN(b2) || 1 > b2;
    }
  return false;
}
function B(a, b2, c2, d2, e2, f2, g2) {
  this.acceptsBooleans = b2 === 2 || b2 === 3 || b2 === 4;
  this.attributeName = d2;
  this.attributeNamespace = e2;
  this.mustUseProperty = c2;
  this.propertyName = a;
  this.type = b2;
  this.sanitizeURL = f2;
  this.removeEmptyString = g2;
}
var D = {};
"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a) {
  D[a] = new B(a, 0, false, a, null, false, false);
});
[["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(a) {
  var b2 = a[0];
  D[b2] = new B(b2, 1, false, a[1], null, false, false);
});
["contentEditable", "draggable", "spellCheck", "value"].forEach(function(a) {
  D[a] = new B(a, 2, false, a.toLowerCase(), null, false, false);
});
["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(a) {
  D[a] = new B(a, 2, false, a, null, false, false);
});
"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a) {
  D[a] = new B(a, 3, false, a.toLowerCase(), null, false, false);
});
["checked", "multiple", "muted", "selected"].forEach(function(a) {
  D[a] = new B(a, 3, true, a, null, false, false);
});
["capture", "download"].forEach(function(a) {
  D[a] = new B(a, 4, false, a, null, false, false);
});
["cols", "rows", "size", "span"].forEach(function(a) {
  D[a] = new B(a, 6, false, a, null, false, false);
});
["rowSpan", "start"].forEach(function(a) {
  D[a] = new B(a, 5, false, a.toLowerCase(), null, false, false);
});
var oa = /[\-:]([a-z])/g;
function pa(a) {
  return a[1].toUpperCase();
}
"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a) {
  var b2 = a.replace(oa, pa);
  D[b2] = new B(b2, 1, false, a, null, false, false);
});
"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a) {
  var b2 = a.replace(oa, pa);
  D[b2] = new B(b2, 1, false, a, "http://www.w3.org/1999/xlink", false, false);
});
["xml:base", "xml:lang", "xml:space"].forEach(function(a) {
  var b2 = a.replace(oa, pa);
  D[b2] = new B(b2, 1, false, a, "http://www.w3.org/XML/1998/namespace", false, false);
});
["tabIndex", "crossOrigin"].forEach(function(a) {
  D[a] = new B(a, 1, false, a.toLowerCase(), null, false, false);
});
D.xlinkHref = new B("xlinkHref", 1, false, "xlink:href", "http://www.w3.org/1999/xlink", true, false);
["src", "href", "action", "formAction"].forEach(function(a) {
  D[a] = new B(a, 1, false, a.toLowerCase(), null, true, true);
});
function qa(a, b2, c2, d2) {
  var e2 = D.hasOwnProperty(b2) ? D[b2] : null;
  var f2 = e2 !== null ? e2.type === 0 : d2 ? false : !(2 < b2.length) || b2[0] !== "o" && b2[0] !== "O" || b2[1] !== "n" && b2[1] !== "N" ? false : true;
  f2 || (na(b2, c2, e2, d2) && (c2 = null), d2 || e2 === null ? la(b2) && (c2 === null ? a.removeAttribute(b2) : a.setAttribute(b2, "" + c2)) : e2.mustUseProperty ? a[e2.propertyName] = c2 === null ? e2.type === 3 ? false : "" : c2 : (b2 = e2.attributeName, d2 = e2.attributeNamespace, c2 === null ? a.removeAttribute(b2) : (e2 = e2.type, c2 = e2 === 3 || e2 === 4 && c2 === true ? "" : "" + c2, d2 ? a.setAttributeNS(d2, b2, c2) : a.setAttribute(b2, c2))));
}
var ra = aa.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED, sa = 60103, ta = 60106, ua = 60107, wa = 60108, xa = 60114, ya = 60109, za = 60110, Aa = 60112, Ba = 60113, Ca = 60120, Da = 60115, Ea = 60116, Fa = 60121, Ga = 60128, Ha = 60129, Ia = 60130, Ja = 60131;
if (typeof Symbol === "function" && Symbol.for) {
  var E = Symbol.for;
  sa = E("react.element");
  ta = E("react.portal");
  ua = E("react.fragment");
  wa = E("react.strict_mode");
  xa = E("react.profiler");
  ya = E("react.provider");
  za = E("react.context");
  Aa = E("react.forward_ref");
  Ba = E("react.suspense");
  Ca = E("react.suspense_list");
  Da = E("react.memo");
  Ea = E("react.lazy");
  Fa = E("react.block");
  E("react.scope");
  Ga = E("react.opaque.id");
  Ha = E("react.debug_trace_mode");
  Ia = E("react.offscreen");
  Ja = E("react.legacy_hidden");
}
var Ka = typeof Symbol === "function" && Symbol.iterator;
function La(a) {
  if (a === null || typeof a !== "object")
    return null;
  a = Ka && a[Ka] || a["@@iterator"];
  return typeof a === "function" ? a : null;
}
var Ma;
function Na(a) {
  if (Ma === void 0)
    try {
      throw Error();
    } catch (c2) {
      var b2 = c2.stack.trim().match(/\n( *(at )?)/);
      Ma = b2 && b2[1] || "";
    }
  return "\n" + Ma + a;
}
var Oa = false;
function Pa(a, b2) {
  if (!a || Oa)
    return "";
  Oa = true;
  var c2 = Error.prepareStackTrace;
  Error.prepareStackTrace = void 0;
  try {
    if (b2)
      if (b2 = function() {
        throw Error();
      }, Object.defineProperty(b2.prototype, "props", { set: function() {
        throw Error();
      } }), typeof Reflect === "object" && Reflect.construct) {
        try {
          Reflect.construct(b2, []);
        } catch (k2) {
          var d2 = k2;
        }
        Reflect.construct(a, [], b2);
      } else {
        try {
          b2.call();
        } catch (k2) {
          d2 = k2;
        }
        a.call(b2.prototype);
      }
    else {
      try {
        throw Error();
      } catch (k2) {
        d2 = k2;
      }
      a();
    }
  } catch (k2) {
    if (k2 && d2 && typeof k2.stack === "string") {
      for (var e2 = k2.stack.split("\n"), f2 = d2.stack.split("\n"), g2 = e2.length - 1, h = f2.length - 1; 1 <= g2 && 0 <= h && e2[g2] !== f2[h]; )
        h--;
      for (; 1 <= g2 && 0 <= h; g2--, h--)
        if (e2[g2] !== f2[h]) {
          if (g2 !== 1 || h !== 1) {
            do
              if (g2--, h--, 0 > h || e2[g2] !== f2[h])
                return "\n" + e2[g2].replace(" at new ", " at ");
            while (1 <= g2 && 0 <= h);
          }
          break;
        }
    }
  } finally {
    Oa = false, Error.prepareStackTrace = c2;
  }
  return (a = a ? a.displayName || a.name : "") ? Na(a) : "";
}
function Qa(a) {
  switch (a.tag) {
    case 5:
      return Na(a.type);
    case 16:
      return Na("Lazy");
    case 13:
      return Na("Suspense");
    case 19:
      return Na("SuspenseList");
    case 0:
    case 2:
    case 15:
      return a = Pa(a.type, false), a;
    case 11:
      return a = Pa(a.type.render, false), a;
    case 22:
      return a = Pa(a.type._render, false), a;
    case 1:
      return a = Pa(a.type, true), a;
    default:
      return "";
  }
}
function Ra(a) {
  if (a == null)
    return null;
  if (typeof a === "function")
    return a.displayName || a.name || null;
  if (typeof a === "string")
    return a;
  switch (a) {
    case ua:
      return "Fragment";
    case ta:
      return "Portal";
    case xa:
      return "Profiler";
    case wa:
      return "StrictMode";
    case Ba:
      return "Suspense";
    case Ca:
      return "SuspenseList";
  }
  if (typeof a === "object")
    switch (a.$$typeof) {
      case za:
        return (a.displayName || "Context") + ".Consumer";
      case ya:
        return (a._context.displayName || "Context") + ".Provider";
      case Aa:
        var b2 = a.render;
        b2 = b2.displayName || b2.name || "";
        return a.displayName || (b2 !== "" ? "ForwardRef(" + b2 + ")" : "ForwardRef");
      case Da:
        return Ra(a.type);
      case Fa:
        return Ra(a._render);
      case Ea:
        b2 = a._payload;
        a = a._init;
        try {
          return Ra(a(b2));
        } catch (c2) {
        }
    }
  return null;
}
function Sa(a) {
  switch (typeof a) {
    case "boolean":
    case "number":
    case "object":
    case "string":
    case "undefined":
      return a;
    default:
      return "";
  }
}
function Ta(a) {
  var b2 = a.type;
  return (a = a.nodeName) && a.toLowerCase() === "input" && (b2 === "checkbox" || b2 === "radio");
}
function Ua(a) {
  var b2 = Ta(a) ? "checked" : "value", c2 = Object.getOwnPropertyDescriptor(a.constructor.prototype, b2), d2 = "" + a[b2];
  if (!a.hasOwnProperty(b2) && typeof c2 !== "undefined" && typeof c2.get === "function" && typeof c2.set === "function") {
    var e2 = c2.get, f2 = c2.set;
    Object.defineProperty(a, b2, { configurable: true, get: function() {
      return e2.call(this);
    }, set: function(a2) {
      d2 = "" + a2;
      f2.call(this, a2);
    } });
    Object.defineProperty(a, b2, { enumerable: c2.enumerable });
    return { getValue: function() {
      return d2;
    }, setValue: function(a2) {
      d2 = "" + a2;
    }, stopTracking: function() {
      a._valueTracker = null;
      delete a[b2];
    } };
  }
}
function Va(a) {
  a._valueTracker || (a._valueTracker = Ua(a));
}
function Wa(a) {
  if (!a)
    return false;
  var b2 = a._valueTracker;
  if (!b2)
    return true;
  var c2 = b2.getValue();
  var d2 = "";
  a && (d2 = Ta(a) ? a.checked ? "true" : "false" : a.value);
  a = d2;
  return a !== c2 ? (b2.setValue(a), true) : false;
}
function Xa(a) {
  a = a || (typeof document !== "undefined" ? document : void 0);
  if (typeof a === "undefined")
    return null;
  try {
    return a.activeElement || a.body;
  } catch (b2) {
    return a.body;
  }
}
function Ya(a, b2) {
  var c2 = b2.checked;
  return m$1({}, b2, { defaultChecked: void 0, defaultValue: void 0, value: void 0, checked: c2 != null ? c2 : a._wrapperState.initialChecked });
}
function Za(a, b2) {
  var c2 = b2.defaultValue == null ? "" : b2.defaultValue, d2 = b2.checked != null ? b2.checked : b2.defaultChecked;
  c2 = Sa(b2.value != null ? b2.value : c2);
  a._wrapperState = { initialChecked: d2, initialValue: c2, controlled: b2.type === "checkbox" || b2.type === "radio" ? b2.checked != null : b2.value != null };
}
function $a(a, b2) {
  b2 = b2.checked;
  b2 != null && qa(a, "checked", b2, false);
}
function ab(a, b2) {
  $a(a, b2);
  var c2 = Sa(b2.value), d2 = b2.type;
  if (c2 != null)
    if (d2 === "number") {
      if (c2 === 0 && a.value === "" || a.value != c2)
        a.value = "" + c2;
    } else
      a.value !== "" + c2 && (a.value = "" + c2);
  else if (d2 === "submit" || d2 === "reset") {
    a.removeAttribute("value");
    return;
  }
  b2.hasOwnProperty("value") ? bb(a, b2.type, c2) : b2.hasOwnProperty("defaultValue") && bb(a, b2.type, Sa(b2.defaultValue));
  b2.checked == null && b2.defaultChecked != null && (a.defaultChecked = !!b2.defaultChecked);
}
function cb(a, b2, c2) {
  if (b2.hasOwnProperty("value") || b2.hasOwnProperty("defaultValue")) {
    var d2 = b2.type;
    if (!(d2 !== "submit" && d2 !== "reset" || b2.value !== void 0 && b2.value !== null))
      return;
    b2 = "" + a._wrapperState.initialValue;
    c2 || b2 === a.value || (a.value = b2);
    a.defaultValue = b2;
  }
  c2 = a.name;
  c2 !== "" && (a.name = "");
  a.defaultChecked = !!a._wrapperState.initialChecked;
  c2 !== "" && (a.name = c2);
}
function bb(a, b2, c2) {
  if (b2 !== "number" || Xa(a.ownerDocument) !== a)
    c2 == null ? a.defaultValue = "" + a._wrapperState.initialValue : a.defaultValue !== "" + c2 && (a.defaultValue = "" + c2);
}
function db(a) {
  var b2 = "";
  aa.Children.forEach(a, function(a2) {
    a2 != null && (b2 += a2);
  });
  return b2;
}
function eb(a, b2) {
  a = m$1({ children: void 0 }, b2);
  if (b2 = db(b2.children))
    a.children = b2;
  return a;
}
function fb(a, b2, c2, d2) {
  a = a.options;
  if (b2) {
    b2 = {};
    for (var e2 = 0; e2 < c2.length; e2++)
      b2["$" + c2[e2]] = true;
    for (c2 = 0; c2 < a.length; c2++)
      e2 = b2.hasOwnProperty("$" + a[c2].value), a[c2].selected !== e2 && (a[c2].selected = e2), e2 && d2 && (a[c2].defaultSelected = true);
  } else {
    c2 = "" + Sa(c2);
    b2 = null;
    for (e2 = 0; e2 < a.length; e2++) {
      if (a[e2].value === c2) {
        a[e2].selected = true;
        d2 && (a[e2].defaultSelected = true);
        return;
      }
      b2 !== null || a[e2].disabled || (b2 = a[e2]);
    }
    b2 !== null && (b2.selected = true);
  }
}
function gb(a, b2) {
  if (b2.dangerouslySetInnerHTML != null)
    throw Error(y(91));
  return m$1({}, b2, { value: void 0, defaultValue: void 0, children: "" + a._wrapperState.initialValue });
}
function hb(a, b2) {
  var c2 = b2.value;
  if (c2 == null) {
    c2 = b2.children;
    b2 = b2.defaultValue;
    if (c2 != null) {
      if (b2 != null)
        throw Error(y(92));
      if (Array.isArray(c2)) {
        if (!(1 >= c2.length))
          throw Error(y(93));
        c2 = c2[0];
      }
      b2 = c2;
    }
    b2 == null && (b2 = "");
    c2 = b2;
  }
  a._wrapperState = { initialValue: Sa(c2) };
}
function ib(a, b2) {
  var c2 = Sa(b2.value), d2 = Sa(b2.defaultValue);
  c2 != null && (c2 = "" + c2, c2 !== a.value && (a.value = c2), b2.defaultValue == null && a.defaultValue !== c2 && (a.defaultValue = c2));
  d2 != null && (a.defaultValue = "" + d2);
}
function jb(a) {
  var b2 = a.textContent;
  b2 === a._wrapperState.initialValue && b2 !== "" && b2 !== null && (a.value = b2);
}
var kb = { html: "http://www.w3.org/1999/xhtml", mathml: "http://www.w3.org/1998/Math/MathML", svg: "http://www.w3.org/2000/svg" };
function lb(a) {
  switch (a) {
    case "svg":
      return "http://www.w3.org/2000/svg";
    case "math":
      return "http://www.w3.org/1998/Math/MathML";
    default:
      return "http://www.w3.org/1999/xhtml";
  }
}
function mb(a, b2) {
  return a == null || a === "http://www.w3.org/1999/xhtml" ? lb(b2) : a === "http://www.w3.org/2000/svg" && b2 === "foreignObject" ? "http://www.w3.org/1999/xhtml" : a;
}
var nb, ob = function(a) {
  return typeof MSApp !== "undefined" && MSApp.execUnsafeLocalFunction ? function(b2, c2, d2, e2) {
    MSApp.execUnsafeLocalFunction(function() {
      return a(b2, c2, d2, e2);
    });
  } : a;
}(function(a, b2) {
  if (a.namespaceURI !== kb.svg || "innerHTML" in a)
    a.innerHTML = b2;
  else {
    nb = nb || document.createElement("div");
    nb.innerHTML = "<svg>" + b2.valueOf().toString() + "</svg>";
    for (b2 = nb.firstChild; a.firstChild; )
      a.removeChild(a.firstChild);
    for (; b2.firstChild; )
      a.appendChild(b2.firstChild);
  }
});
function pb(a, b2) {
  if (b2) {
    var c2 = a.firstChild;
    if (c2 && c2 === a.lastChild && c2.nodeType === 3) {
      c2.nodeValue = b2;
      return;
    }
  }
  a.textContent = b2;
}
var qb = {
  animationIterationCount: true,
  borderImageOutset: true,
  borderImageSlice: true,
  borderImageWidth: true,
  boxFlex: true,
  boxFlexGroup: true,
  boxOrdinalGroup: true,
  columnCount: true,
  columns: true,
  flex: true,
  flexGrow: true,
  flexPositive: true,
  flexShrink: true,
  flexNegative: true,
  flexOrder: true,
  gridArea: true,
  gridRow: true,
  gridRowEnd: true,
  gridRowSpan: true,
  gridRowStart: true,
  gridColumn: true,
  gridColumnEnd: true,
  gridColumnSpan: true,
  gridColumnStart: true,
  fontWeight: true,
  lineClamp: true,
  lineHeight: true,
  opacity: true,
  order: true,
  orphans: true,
  tabSize: true,
  widows: true,
  zIndex: true,
  zoom: true,
  fillOpacity: true,
  floodOpacity: true,
  stopOpacity: true,
  strokeDasharray: true,
  strokeDashoffset: true,
  strokeMiterlimit: true,
  strokeOpacity: true,
  strokeWidth: true
}, rb = ["Webkit", "ms", "Moz", "O"];
Object.keys(qb).forEach(function(a) {
  rb.forEach(function(b2) {
    b2 = b2 + a.charAt(0).toUpperCase() + a.substring(1);
    qb[b2] = qb[a];
  });
});
function sb(a, b2, c2) {
  return b2 == null || typeof b2 === "boolean" || b2 === "" ? "" : c2 || typeof b2 !== "number" || b2 === 0 || qb.hasOwnProperty(a) && qb[a] ? ("" + b2).trim() : b2 + "px";
}
function tb(a, b2) {
  a = a.style;
  for (var c2 in b2)
    if (b2.hasOwnProperty(c2)) {
      var d2 = c2.indexOf("--") === 0, e2 = sb(c2, b2[c2], d2);
      c2 === "float" && (c2 = "cssFloat");
      d2 ? a.setProperty(c2, e2) : a[c2] = e2;
    }
}
var ub = m$1({ menuitem: true }, { area: true, base: true, br: true, col: true, embed: true, hr: true, img: true, input: true, keygen: true, link: true, meta: true, param: true, source: true, track: true, wbr: true });
function vb(a, b2) {
  if (b2) {
    if (ub[a] && (b2.children != null || b2.dangerouslySetInnerHTML != null))
      throw Error(y(137, a));
    if (b2.dangerouslySetInnerHTML != null) {
      if (b2.children != null)
        throw Error(y(60));
      if (!(typeof b2.dangerouslySetInnerHTML === "object" && "__html" in b2.dangerouslySetInnerHTML))
        throw Error(y(61));
    }
    if (b2.style != null && typeof b2.style !== "object")
      throw Error(y(62));
  }
}
function wb(a, b2) {
  if (a.indexOf("-") === -1)
    return typeof b2.is === "string";
  switch (a) {
    case "annotation-xml":
    case "color-profile":
    case "font-face":
    case "font-face-src":
    case "font-face-uri":
    case "font-face-format":
    case "font-face-name":
    case "missing-glyph":
      return false;
    default:
      return true;
  }
}
function xb(a) {
  a = a.target || a.srcElement || window;
  a.correspondingUseElement && (a = a.correspondingUseElement);
  return a.nodeType === 3 ? a.parentNode : a;
}
var yb = null, zb = null, Ab = null;
function Bb(a) {
  if (a = Cb(a)) {
    if (typeof yb !== "function")
      throw Error(y(280));
    var b2 = a.stateNode;
    b2 && (b2 = Db(b2), yb(a.stateNode, a.type, b2));
  }
}
function Eb(a) {
  zb ? Ab ? Ab.push(a) : Ab = [a] : zb = a;
}
function Fb() {
  if (zb) {
    var a = zb, b2 = Ab;
    Ab = zb = null;
    Bb(a);
    if (b2)
      for (a = 0; a < b2.length; a++)
        Bb(b2[a]);
  }
}
function Gb(a, b2) {
  return a(b2);
}
function Hb(a, b2, c2, d2, e2) {
  return a(b2, c2, d2, e2);
}
function Ib() {
}
var Jb = Gb, Kb = false, Lb = false;
function Mb() {
  if (zb !== null || Ab !== null)
    Ib(), Fb();
}
function Nb(a, b2, c2) {
  if (Lb)
    return a(b2, c2);
  Lb = true;
  try {
    return Jb(a, b2, c2);
  } finally {
    Lb = false, Mb();
  }
}
function Ob(a, b2) {
  var c2 = a.stateNode;
  if (c2 === null)
    return null;
  var d2 = Db(c2);
  if (d2 === null)
    return null;
  c2 = d2[b2];
  a:
    switch (b2) {
      case "onClick":
      case "onClickCapture":
      case "onDoubleClick":
      case "onDoubleClickCapture":
      case "onMouseDown":
      case "onMouseDownCapture":
      case "onMouseMove":
      case "onMouseMoveCapture":
      case "onMouseUp":
      case "onMouseUpCapture":
      case "onMouseEnter":
        (d2 = !d2.disabled) || (a = a.type, d2 = !(a === "button" || a === "input" || a === "select" || a === "textarea"));
        a = !d2;
        break a;
      default:
        a = false;
    }
  if (a)
    return null;
  if (c2 && typeof c2 !== "function")
    throw Error(y(231, b2, typeof c2));
  return c2;
}
var Pb = false;
if (fa)
  try {
    var Qb = {};
    Object.defineProperty(Qb, "passive", { get: function() {
      Pb = true;
    } });
    window.addEventListener("test", Qb, Qb);
    window.removeEventListener("test", Qb, Qb);
  } catch (a) {
    Pb = false;
  }
function Rb(a, b2, c2, d2, e2, f2, g2, h, k2) {
  var l2 = Array.prototype.slice.call(arguments, 3);
  try {
    b2.apply(c2, l2);
  } catch (n2) {
    this.onError(n2);
  }
}
var Sb = false, Tb = null, Ub = false, Vb = null, Wb = { onError: function(a) {
  Sb = true;
  Tb = a;
} };
function Xb(a, b2, c2, d2, e2, f2, g2, h, k2) {
  Sb = false;
  Tb = null;
  Rb.apply(Wb, arguments);
}
function Yb(a, b2, c2, d2, e2, f2, g2, h, k2) {
  Xb.apply(this, arguments);
  if (Sb) {
    if (Sb) {
      var l2 = Tb;
      Sb = false;
      Tb = null;
    } else
      throw Error(y(198));
    Ub || (Ub = true, Vb = l2);
  }
}
function Zb(a) {
  var b2 = a, c2 = a;
  if (a.alternate)
    for (; b2.return; )
      b2 = b2.return;
  else {
    a = b2;
    do
      b2 = a, (b2.flags & 1026) !== 0 && (c2 = b2.return), a = b2.return;
    while (a);
  }
  return b2.tag === 3 ? c2 : null;
}
function $b(a) {
  if (a.tag === 13) {
    var b2 = a.memoizedState;
    b2 === null && (a = a.alternate, a !== null && (b2 = a.memoizedState));
    if (b2 !== null)
      return b2.dehydrated;
  }
  return null;
}
function ac(a) {
  if (Zb(a) !== a)
    throw Error(y(188));
}
function bc(a) {
  var b2 = a.alternate;
  if (!b2) {
    b2 = Zb(a);
    if (b2 === null)
      throw Error(y(188));
    return b2 !== a ? null : a;
  }
  for (var c2 = a, d2 = b2; ; ) {
    var e2 = c2.return;
    if (e2 === null)
      break;
    var f2 = e2.alternate;
    if (f2 === null) {
      d2 = e2.return;
      if (d2 !== null) {
        c2 = d2;
        continue;
      }
      break;
    }
    if (e2.child === f2.child) {
      for (f2 = e2.child; f2; ) {
        if (f2 === c2)
          return ac(e2), a;
        if (f2 === d2)
          return ac(e2), b2;
        f2 = f2.sibling;
      }
      throw Error(y(188));
    }
    if (c2.return !== d2.return)
      c2 = e2, d2 = f2;
    else {
      for (var g2 = false, h = e2.child; h; ) {
        if (h === c2) {
          g2 = true;
          c2 = e2;
          d2 = f2;
          break;
        }
        if (h === d2) {
          g2 = true;
          d2 = e2;
          c2 = f2;
          break;
        }
        h = h.sibling;
      }
      if (!g2) {
        for (h = f2.child; h; ) {
          if (h === c2) {
            g2 = true;
            c2 = f2;
            d2 = e2;
            break;
          }
          if (h === d2) {
            g2 = true;
            d2 = f2;
            c2 = e2;
            break;
          }
          h = h.sibling;
        }
        if (!g2)
          throw Error(y(189));
      }
    }
    if (c2.alternate !== d2)
      throw Error(y(190));
  }
  if (c2.tag !== 3)
    throw Error(y(188));
  return c2.stateNode.current === c2 ? a : b2;
}
function cc(a) {
  a = bc(a);
  if (!a)
    return null;
  for (var b2 = a; ; ) {
    if (b2.tag === 5 || b2.tag === 6)
      return b2;
    if (b2.child)
      b2.child.return = b2, b2 = b2.child;
    else {
      if (b2 === a)
        break;
      for (; !b2.sibling; ) {
        if (!b2.return || b2.return === a)
          return null;
        b2 = b2.return;
      }
      b2.sibling.return = b2.return;
      b2 = b2.sibling;
    }
  }
  return null;
}
function dc(a, b2) {
  for (var c2 = a.alternate; b2 !== null; ) {
    if (b2 === a || b2 === c2)
      return true;
    b2 = b2.return;
  }
  return false;
}
var ec, fc, gc, hc, ic = false, jc = [], kc = null, lc = null, mc = null, nc = /* @__PURE__ */ new Map(), oc = /* @__PURE__ */ new Map(), pc = [], qc = "mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");
function rc(a, b2, c2, d2, e2) {
  return { blockedOn: a, domEventName: b2, eventSystemFlags: c2 | 16, nativeEvent: e2, targetContainers: [d2] };
}
function sc(a, b2) {
  switch (a) {
    case "focusin":
    case "focusout":
      kc = null;
      break;
    case "dragenter":
    case "dragleave":
      lc = null;
      break;
    case "mouseover":
    case "mouseout":
      mc = null;
      break;
    case "pointerover":
    case "pointerout":
      nc.delete(b2.pointerId);
      break;
    case "gotpointercapture":
    case "lostpointercapture":
      oc.delete(b2.pointerId);
  }
}
function tc(a, b2, c2, d2, e2, f2) {
  if (a === null || a.nativeEvent !== f2)
    return a = rc(b2, c2, d2, e2, f2), b2 !== null && (b2 = Cb(b2), b2 !== null && fc(b2)), a;
  a.eventSystemFlags |= d2;
  b2 = a.targetContainers;
  e2 !== null && b2.indexOf(e2) === -1 && b2.push(e2);
  return a;
}
function uc(a, b2, c2, d2, e2) {
  switch (b2) {
    case "focusin":
      return kc = tc(kc, a, b2, c2, d2, e2), true;
    case "dragenter":
      return lc = tc(lc, a, b2, c2, d2, e2), true;
    case "mouseover":
      return mc = tc(mc, a, b2, c2, d2, e2), true;
    case "pointerover":
      var f2 = e2.pointerId;
      nc.set(f2, tc(nc.get(f2) || null, a, b2, c2, d2, e2));
      return true;
    case "gotpointercapture":
      return f2 = e2.pointerId, oc.set(f2, tc(oc.get(f2) || null, a, b2, c2, d2, e2)), true;
  }
  return false;
}
function vc(a) {
  var b2 = wc(a.target);
  if (b2 !== null) {
    var c2 = Zb(b2);
    if (c2 !== null) {
      if (b2 = c2.tag, b2 === 13) {
        if (b2 = $b(c2), b2 !== null) {
          a.blockedOn = b2;
          hc(a.lanePriority, function() {
            r.unstable_runWithPriority(a.priority, function() {
              gc(c2);
            });
          });
          return;
        }
      } else if (b2 === 3 && c2.stateNode.hydrate) {
        a.blockedOn = c2.tag === 3 ? c2.stateNode.containerInfo : null;
        return;
      }
    }
  }
  a.blockedOn = null;
}
function xc(a) {
  if (a.blockedOn !== null)
    return false;
  for (var b2 = a.targetContainers; 0 < b2.length; ) {
    var c2 = yc(a.domEventName, a.eventSystemFlags, b2[0], a.nativeEvent);
    if (c2 !== null)
      return b2 = Cb(c2), b2 !== null && fc(b2), a.blockedOn = c2, false;
    b2.shift();
  }
  return true;
}
function zc(a, b2, c2) {
  xc(a) && c2.delete(b2);
}
function Ac() {
  for (ic = false; 0 < jc.length; ) {
    var a = jc[0];
    if (a.blockedOn !== null) {
      a = Cb(a.blockedOn);
      a !== null && ec(a);
      break;
    }
    for (var b2 = a.targetContainers; 0 < b2.length; ) {
      var c2 = yc(a.domEventName, a.eventSystemFlags, b2[0], a.nativeEvent);
      if (c2 !== null) {
        a.blockedOn = c2;
        break;
      }
      b2.shift();
    }
    a.blockedOn === null && jc.shift();
  }
  kc !== null && xc(kc) && (kc = null);
  lc !== null && xc(lc) && (lc = null);
  mc !== null && xc(mc) && (mc = null);
  nc.forEach(zc);
  oc.forEach(zc);
}
function Bc(a, b2) {
  a.blockedOn === b2 && (a.blockedOn = null, ic || (ic = true, r.unstable_scheduleCallback(r.unstable_NormalPriority, Ac)));
}
function Cc(a) {
  function b2(b3) {
    return Bc(b3, a);
  }
  if (0 < jc.length) {
    Bc(jc[0], a);
    for (var c2 = 1; c2 < jc.length; c2++) {
      var d2 = jc[c2];
      d2.blockedOn === a && (d2.blockedOn = null);
    }
  }
  kc !== null && Bc(kc, a);
  lc !== null && Bc(lc, a);
  mc !== null && Bc(mc, a);
  nc.forEach(b2);
  oc.forEach(b2);
  for (c2 = 0; c2 < pc.length; c2++)
    d2 = pc[c2], d2.blockedOn === a && (d2.blockedOn = null);
  for (; 0 < pc.length && (c2 = pc[0], c2.blockedOn === null); )
    vc(c2), c2.blockedOn === null && pc.shift();
}
function Dc(a, b2) {
  var c2 = {};
  c2[a.toLowerCase()] = b2.toLowerCase();
  c2["Webkit" + a] = "webkit" + b2;
  c2["Moz" + a] = "moz" + b2;
  return c2;
}
var Ec = { animationend: Dc("Animation", "AnimationEnd"), animationiteration: Dc("Animation", "AnimationIteration"), animationstart: Dc("Animation", "AnimationStart"), transitionend: Dc("Transition", "TransitionEnd") }, Fc = {}, Gc = {};
fa && (Gc = document.createElement("div").style, "AnimationEvent" in window || (delete Ec.animationend.animation, delete Ec.animationiteration.animation, delete Ec.animationstart.animation), "TransitionEvent" in window || delete Ec.transitionend.transition);
function Hc(a) {
  if (Fc[a])
    return Fc[a];
  if (!Ec[a])
    return a;
  var b2 = Ec[a], c2;
  for (c2 in b2)
    if (b2.hasOwnProperty(c2) && c2 in Gc)
      return Fc[a] = b2[c2];
  return a;
}
var Ic = Hc("animationend"), Jc = Hc("animationiteration"), Kc = Hc("animationstart"), Lc = Hc("transitionend"), Mc = /* @__PURE__ */ new Map(), Nc = /* @__PURE__ */ new Map(), Oc = [
  "abort",
  "abort",
  Ic,
  "animationEnd",
  Jc,
  "animationIteration",
  Kc,
  "animationStart",
  "canplay",
  "canPlay",
  "canplaythrough",
  "canPlayThrough",
  "durationchange",
  "durationChange",
  "emptied",
  "emptied",
  "encrypted",
  "encrypted",
  "ended",
  "ended",
  "error",
  "error",
  "gotpointercapture",
  "gotPointerCapture",
  "load",
  "load",
  "loadeddata",
  "loadedData",
  "loadedmetadata",
  "loadedMetadata",
  "loadstart",
  "loadStart",
  "lostpointercapture",
  "lostPointerCapture",
  "playing",
  "playing",
  "progress",
  "progress",
  "seeking",
  "seeking",
  "stalled",
  "stalled",
  "suspend",
  "suspend",
  "timeupdate",
  "timeUpdate",
  Lc,
  "transitionEnd",
  "waiting",
  "waiting"
];
function Pc(a, b2) {
  for (var c2 = 0; c2 < a.length; c2 += 2) {
    var d2 = a[c2], e2 = a[c2 + 1];
    e2 = "on" + (e2[0].toUpperCase() + e2.slice(1));
    Nc.set(d2, b2);
    Mc.set(d2, e2);
    da(e2, [d2]);
  }
}
var Qc = r.unstable_now;
Qc();
var F = 8;
function Rc(a) {
  if ((1 & a) !== 0)
    return F = 15, 1;
  if ((2 & a) !== 0)
    return F = 14, 2;
  if ((4 & a) !== 0)
    return F = 13, 4;
  var b2 = 24 & a;
  if (b2 !== 0)
    return F = 12, b2;
  if ((a & 32) !== 0)
    return F = 11, 32;
  b2 = 192 & a;
  if (b2 !== 0)
    return F = 10, b2;
  if ((a & 256) !== 0)
    return F = 9, 256;
  b2 = 3584 & a;
  if (b2 !== 0)
    return F = 8, b2;
  if ((a & 4096) !== 0)
    return F = 7, 4096;
  b2 = 4186112 & a;
  if (b2 !== 0)
    return F = 6, b2;
  b2 = 62914560 & a;
  if (b2 !== 0)
    return F = 5, b2;
  if (a & 67108864)
    return F = 4, 67108864;
  if ((a & 134217728) !== 0)
    return F = 3, 134217728;
  b2 = 805306368 & a;
  if (b2 !== 0)
    return F = 2, b2;
  if ((1073741824 & a) !== 0)
    return F = 1, 1073741824;
  F = 8;
  return a;
}
function Sc(a) {
  switch (a) {
    case 99:
      return 15;
    case 98:
      return 10;
    case 97:
    case 96:
      return 8;
    case 95:
      return 2;
    default:
      return 0;
  }
}
function Tc(a) {
  switch (a) {
    case 15:
    case 14:
      return 99;
    case 13:
    case 12:
    case 11:
    case 10:
      return 98;
    case 9:
    case 8:
    case 7:
    case 6:
    case 4:
    case 5:
      return 97;
    case 3:
    case 2:
    case 1:
      return 95;
    case 0:
      return 90;
    default:
      throw Error(y(358, a));
  }
}
function Uc(a, b2) {
  var c2 = a.pendingLanes;
  if (c2 === 0)
    return F = 0;
  var d2 = 0, e2 = 0, f2 = a.expiredLanes, g2 = a.suspendedLanes, h = a.pingedLanes;
  if (f2 !== 0)
    d2 = f2, e2 = F = 15;
  else if (f2 = c2 & 134217727, f2 !== 0) {
    var k2 = f2 & ~g2;
    k2 !== 0 ? (d2 = Rc(k2), e2 = F) : (h &= f2, h !== 0 && (d2 = Rc(h), e2 = F));
  } else
    f2 = c2 & ~g2, f2 !== 0 ? (d2 = Rc(f2), e2 = F) : h !== 0 && (d2 = Rc(h), e2 = F);
  if (d2 === 0)
    return 0;
  d2 = 31 - Vc(d2);
  d2 = c2 & ((0 > d2 ? 0 : 1 << d2) << 1) - 1;
  if (b2 !== 0 && b2 !== d2 && (b2 & g2) === 0) {
    Rc(b2);
    if (e2 <= F)
      return b2;
    F = e2;
  }
  b2 = a.entangledLanes;
  if (b2 !== 0)
    for (a = a.entanglements, b2 &= d2; 0 < b2; )
      c2 = 31 - Vc(b2), e2 = 1 << c2, d2 |= a[c2], b2 &= ~e2;
  return d2;
}
function Wc(a) {
  a = a.pendingLanes & -1073741825;
  return a !== 0 ? a : a & 1073741824 ? 1073741824 : 0;
}
function Xc(a, b2) {
  switch (a) {
    case 15:
      return 1;
    case 14:
      return 2;
    case 12:
      return a = Yc(24 & ~b2), a === 0 ? Xc(10, b2) : a;
    case 10:
      return a = Yc(192 & ~b2), a === 0 ? Xc(8, b2) : a;
    case 8:
      return a = Yc(3584 & ~b2), a === 0 && (a = Yc(4186112 & ~b2), a === 0 && (a = 512)), a;
    case 2:
      return b2 = Yc(805306368 & ~b2), b2 === 0 && (b2 = 268435456), b2;
  }
  throw Error(y(358, a));
}
function Yc(a) {
  return a & -a;
}
function Zc(a) {
  for (var b2 = [], c2 = 0; 31 > c2; c2++)
    b2.push(a);
  return b2;
}
function $c(a, b2, c2) {
  a.pendingLanes |= b2;
  var d2 = b2 - 1;
  a.suspendedLanes &= d2;
  a.pingedLanes &= d2;
  a = a.eventTimes;
  b2 = 31 - Vc(b2);
  a[b2] = c2;
}
var Vc = Math.clz32 ? Math.clz32 : ad, bd = Math.log, cd = Math.LN2;
function ad(a) {
  return a === 0 ? 32 : 31 - (bd(a) / cd | 0) | 0;
}
var dd = r.unstable_UserBlockingPriority, ed = r.unstable_runWithPriority, fd = true;
function gd(a, b2, c2, d2) {
  Kb || Ib();
  var e2 = hd, f2 = Kb;
  Kb = true;
  try {
    Hb(e2, a, b2, c2, d2);
  } finally {
    (Kb = f2) || Mb();
  }
}
function id$1(a, b2, c2, d2) {
  ed(dd, hd.bind(null, a, b2, c2, d2));
}
function hd(a, b2, c2, d2) {
  if (fd) {
    var e2;
    if ((e2 = (b2 & 4) === 0) && 0 < jc.length && -1 < qc.indexOf(a))
      a = rc(null, a, b2, c2, d2), jc.push(a);
    else {
      var f2 = yc(a, b2, c2, d2);
      if (f2 === null)
        e2 && sc(a, d2);
      else {
        if (e2) {
          if (-1 < qc.indexOf(a)) {
            a = rc(f2, a, b2, c2, d2);
            jc.push(a);
            return;
          }
          if (uc(f2, a, b2, c2, d2))
            return;
          sc(a, d2);
        }
        jd(a, b2, d2, null, c2);
      }
    }
  }
}
function yc(a, b2, c2, d2) {
  var e2 = xb(d2);
  e2 = wc(e2);
  if (e2 !== null) {
    var f2 = Zb(e2);
    if (f2 === null)
      e2 = null;
    else {
      var g2 = f2.tag;
      if (g2 === 13) {
        e2 = $b(f2);
        if (e2 !== null)
          return e2;
        e2 = null;
      } else if (g2 === 3) {
        if (f2.stateNode.hydrate)
          return f2.tag === 3 ? f2.stateNode.containerInfo : null;
        e2 = null;
      } else
        f2 !== e2 && (e2 = null);
    }
  }
  jd(a, b2, d2, e2, c2);
  return null;
}
var kd = null, ld = null, md = null;
function nd() {
  if (md)
    return md;
  var a, b2 = ld, c2 = b2.length, d2, e2 = "value" in kd ? kd.value : kd.textContent, f2 = e2.length;
  for (a = 0; a < c2 && b2[a] === e2[a]; a++)
    ;
  var g2 = c2 - a;
  for (d2 = 1; d2 <= g2 && b2[c2 - d2] === e2[f2 - d2]; d2++)
    ;
  return md = e2.slice(a, 1 < d2 ? 1 - d2 : void 0);
}
function od(a) {
  var b2 = a.keyCode;
  "charCode" in a ? (a = a.charCode, a === 0 && b2 === 13 && (a = 13)) : a = b2;
  a === 10 && (a = 13);
  return 32 <= a || a === 13 ? a : 0;
}
function pd() {
  return true;
}
function qd() {
  return false;
}
function rd(a) {
  function b2(b3, d2, e2, f2, g2) {
    this._reactName = b3;
    this._targetInst = e2;
    this.type = d2;
    this.nativeEvent = f2;
    this.target = g2;
    this.currentTarget = null;
    for (var c2 in a)
      a.hasOwnProperty(c2) && (b3 = a[c2], this[c2] = b3 ? b3(f2) : f2[c2]);
    this.isDefaultPrevented = (f2.defaultPrevented != null ? f2.defaultPrevented : f2.returnValue === false) ? pd : qd;
    this.isPropagationStopped = qd;
    return this;
  }
  m$1(b2.prototype, { preventDefault: function() {
    this.defaultPrevented = true;
    var a2 = this.nativeEvent;
    a2 && (a2.preventDefault ? a2.preventDefault() : typeof a2.returnValue !== "unknown" && (a2.returnValue = false), this.isDefaultPrevented = pd);
  }, stopPropagation: function() {
    var a2 = this.nativeEvent;
    a2 && (a2.stopPropagation ? a2.stopPropagation() : typeof a2.cancelBubble !== "unknown" && (a2.cancelBubble = true), this.isPropagationStopped = pd);
  }, persist: function() {
  }, isPersistent: pd });
  return b2;
}
var sd = { eventPhase: 0, bubbles: 0, cancelable: 0, timeStamp: function(a) {
  return a.timeStamp || Date.now();
}, defaultPrevented: 0, isTrusted: 0 }, td = rd(sd), ud = m$1({}, sd, { view: 0, detail: 0 }), vd = rd(ud), wd, xd, yd, Ad = m$1({}, ud, { screenX: 0, screenY: 0, clientX: 0, clientY: 0, pageX: 0, pageY: 0, ctrlKey: 0, shiftKey: 0, altKey: 0, metaKey: 0, getModifierState: zd, button: 0, buttons: 0, relatedTarget: function(a) {
  return a.relatedTarget === void 0 ? a.fromElement === a.srcElement ? a.toElement : a.fromElement : a.relatedTarget;
}, movementX: function(a) {
  if ("movementX" in a)
    return a.movementX;
  a !== yd && (yd && a.type === "mousemove" ? (wd = a.screenX - yd.screenX, xd = a.screenY - yd.screenY) : xd = wd = 0, yd = a);
  return wd;
}, movementY: function(a) {
  return "movementY" in a ? a.movementY : xd;
} }), Bd = rd(Ad), Cd = m$1({}, Ad, { dataTransfer: 0 }), Dd = rd(Cd), Ed = m$1({}, ud, { relatedTarget: 0 }), Fd = rd(Ed), Gd = m$1({}, sd, { animationName: 0, elapsedTime: 0, pseudoElement: 0 }), Hd = rd(Gd), Id = m$1({}, sd, { clipboardData: function(a) {
  return "clipboardData" in a ? a.clipboardData : window.clipboardData;
} }), Jd = rd(Id), Kd = m$1({}, sd, { data: 0 }), Ld = rd(Kd), Md = {
  Esc: "Escape",
  Spacebar: " ",
  Left: "ArrowLeft",
  Up: "ArrowUp",
  Right: "ArrowRight",
  Down: "ArrowDown",
  Del: "Delete",
  Win: "OS",
  Menu: "ContextMenu",
  Apps: "ContextMenu",
  Scroll: "ScrollLock",
  MozPrintableKey: "Unidentified"
}, Nd = {
  8: "Backspace",
  9: "Tab",
  12: "Clear",
  13: "Enter",
  16: "Shift",
  17: "Control",
  18: "Alt",
  19: "Pause",
  20: "CapsLock",
  27: "Escape",
  32: " ",
  33: "PageUp",
  34: "PageDown",
  35: "End",
  36: "Home",
  37: "ArrowLeft",
  38: "ArrowUp",
  39: "ArrowRight",
  40: "ArrowDown",
  45: "Insert",
  46: "Delete",
  112: "F1",
  113: "F2",
  114: "F3",
  115: "F4",
  116: "F5",
  117: "F6",
  118: "F7",
  119: "F8",
  120: "F9",
  121: "F10",
  122: "F11",
  123: "F12",
  144: "NumLock",
  145: "ScrollLock",
  224: "Meta"
}, Od = { Alt: "altKey", Control: "ctrlKey", Meta: "metaKey", Shift: "shiftKey" };
function Pd(a) {
  var b2 = this.nativeEvent;
  return b2.getModifierState ? b2.getModifierState(a) : (a = Od[a]) ? !!b2[a] : false;
}
function zd() {
  return Pd;
}
var Qd = m$1({}, ud, { key: function(a) {
  if (a.key) {
    var b2 = Md[a.key] || a.key;
    if (b2 !== "Unidentified")
      return b2;
  }
  return a.type === "keypress" ? (a = od(a), a === 13 ? "Enter" : String.fromCharCode(a)) : a.type === "keydown" || a.type === "keyup" ? Nd[a.keyCode] || "Unidentified" : "";
}, code: 0, location: 0, ctrlKey: 0, shiftKey: 0, altKey: 0, metaKey: 0, repeat: 0, locale: 0, getModifierState: zd, charCode: function(a) {
  return a.type === "keypress" ? od(a) : 0;
}, keyCode: function(a) {
  return a.type === "keydown" || a.type === "keyup" ? a.keyCode : 0;
}, which: function(a) {
  return a.type === "keypress" ? od(a) : a.type === "keydown" || a.type === "keyup" ? a.keyCode : 0;
} }), Rd = rd(Qd), Sd = m$1({}, Ad, { pointerId: 0, width: 0, height: 0, pressure: 0, tangentialPressure: 0, tiltX: 0, tiltY: 0, twist: 0, pointerType: 0, isPrimary: 0 }), Td = rd(Sd), Ud = m$1({}, ud, { touches: 0, targetTouches: 0, changedTouches: 0, altKey: 0, metaKey: 0, ctrlKey: 0, shiftKey: 0, getModifierState: zd }), Vd = rd(Ud), Wd = m$1({}, sd, { propertyName: 0, elapsedTime: 0, pseudoElement: 0 }), Xd = rd(Wd), Yd = m$1({}, Ad, {
  deltaX: function(a) {
    return "deltaX" in a ? a.deltaX : "wheelDeltaX" in a ? -a.wheelDeltaX : 0;
  },
  deltaY: function(a) {
    return "deltaY" in a ? a.deltaY : "wheelDeltaY" in a ? -a.wheelDeltaY : "wheelDelta" in a ? -a.wheelDelta : 0;
  },
  deltaZ: 0,
  deltaMode: 0
}), Zd = rd(Yd), $d = [9, 13, 27, 32], ae = fa && "CompositionEvent" in window, be = null;
fa && "documentMode" in document && (be = document.documentMode);
var ce = fa && "TextEvent" in window && !be, de = fa && (!ae || be && 8 < be && 11 >= be), ee = String.fromCharCode(32), fe = false;
function ge(a, b2) {
  switch (a) {
    case "keyup":
      return $d.indexOf(b2.keyCode) !== -1;
    case "keydown":
      return b2.keyCode !== 229;
    case "keypress":
    case "mousedown":
    case "focusout":
      return true;
    default:
      return false;
  }
}
function he(a) {
  a = a.detail;
  return typeof a === "object" && "data" in a ? a.data : null;
}
var ie = false;
function je(a, b2) {
  switch (a) {
    case "compositionend":
      return he(b2);
    case "keypress":
      if (b2.which !== 32)
        return null;
      fe = true;
      return ee;
    case "textInput":
      return a = b2.data, a === ee && fe ? null : a;
    default:
      return null;
  }
}
function ke(a, b2) {
  if (ie)
    return a === "compositionend" || !ae && ge(a, b2) ? (a = nd(), md = ld = kd = null, ie = false, a) : null;
  switch (a) {
    case "paste":
      return null;
    case "keypress":
      if (!(b2.ctrlKey || b2.altKey || b2.metaKey) || b2.ctrlKey && b2.altKey) {
        if (b2.char && 1 < b2.char.length)
          return b2.char;
        if (b2.which)
          return String.fromCharCode(b2.which);
      }
      return null;
    case "compositionend":
      return de && b2.locale !== "ko" ? null : b2.data;
    default:
      return null;
  }
}
var le = { color: true, date: true, datetime: true, "datetime-local": true, email: true, month: true, number: true, password: true, range: true, search: true, tel: true, text: true, time: true, url: true, week: true };
function me(a) {
  var b2 = a && a.nodeName && a.nodeName.toLowerCase();
  return b2 === "input" ? !!le[a.type] : b2 === "textarea" ? true : false;
}
function ne(a, b2, c2, d2) {
  Eb(d2);
  b2 = oe(b2, "onChange");
  0 < b2.length && (c2 = new td("onChange", "change", null, c2, d2), a.push({ event: c2, listeners: b2 }));
}
var pe = null, qe = null;
function re(a) {
  se(a, 0);
}
function te(a) {
  var b2 = ue(a);
  if (Wa(b2))
    return a;
}
function ve(a, b2) {
  if (a === "change")
    return b2;
}
var we = false;
if (fa) {
  var xe;
  if (fa) {
    var ye = "oninput" in document;
    if (!ye) {
      var ze = document.createElement("div");
      ze.setAttribute("oninput", "return;");
      ye = typeof ze.oninput === "function";
    }
    xe = ye;
  } else
    xe = false;
  we = xe && (!document.documentMode || 9 < document.documentMode);
}
function Ae() {
  pe && (pe.detachEvent("onpropertychange", Be), qe = pe = null);
}
function Be(a) {
  if (a.propertyName === "value" && te(qe)) {
    var b2 = [];
    ne(b2, qe, a, xb(a));
    a = re;
    if (Kb)
      a(b2);
    else {
      Kb = true;
      try {
        Gb(a, b2);
      } finally {
        Kb = false, Mb();
      }
    }
  }
}
function Ce(a, b2, c2) {
  a === "focusin" ? (Ae(), pe = b2, qe = c2, pe.attachEvent("onpropertychange", Be)) : a === "focusout" && Ae();
}
function De(a) {
  if (a === "selectionchange" || a === "keyup" || a === "keydown")
    return te(qe);
}
function Ee(a, b2) {
  if (a === "click")
    return te(b2);
}
function Fe(a, b2) {
  if (a === "input" || a === "change")
    return te(b2);
}
function Ge(a, b2) {
  return a === b2 && (a !== 0 || 1 / a === 1 / b2) || a !== a && b2 !== b2;
}
var He = typeof Object.is === "function" ? Object.is : Ge, Ie = Object.prototype.hasOwnProperty;
function Je(a, b2) {
  if (He(a, b2))
    return true;
  if (typeof a !== "object" || a === null || typeof b2 !== "object" || b2 === null)
    return false;
  var c2 = Object.keys(a), d2 = Object.keys(b2);
  if (c2.length !== d2.length)
    return false;
  for (d2 = 0; d2 < c2.length; d2++)
    if (!Ie.call(b2, c2[d2]) || !He(a[c2[d2]], b2[c2[d2]]))
      return false;
  return true;
}
function Ke(a) {
  for (; a && a.firstChild; )
    a = a.firstChild;
  return a;
}
function Le(a, b2) {
  var c2 = Ke(a);
  a = 0;
  for (var d2; c2; ) {
    if (c2.nodeType === 3) {
      d2 = a + c2.textContent.length;
      if (a <= b2 && d2 >= b2)
        return { node: c2, offset: b2 - a };
      a = d2;
    }
    a: {
      for (; c2; ) {
        if (c2.nextSibling) {
          c2 = c2.nextSibling;
          break a;
        }
        c2 = c2.parentNode;
      }
      c2 = void 0;
    }
    c2 = Ke(c2);
  }
}
function Me(a, b2) {
  return a && b2 ? a === b2 ? true : a && a.nodeType === 3 ? false : b2 && b2.nodeType === 3 ? Me(a, b2.parentNode) : "contains" in a ? a.contains(b2) : a.compareDocumentPosition ? !!(a.compareDocumentPosition(b2) & 16) : false : false;
}
function Ne() {
  for (var a = window, b2 = Xa(); b2 instanceof a.HTMLIFrameElement; ) {
    try {
      var c2 = typeof b2.contentWindow.location.href === "string";
    } catch (d2) {
      c2 = false;
    }
    if (c2)
      a = b2.contentWindow;
    else
      break;
    b2 = Xa(a.document);
  }
  return b2;
}
function Oe(a) {
  var b2 = a && a.nodeName && a.nodeName.toLowerCase();
  return b2 && (b2 === "input" && (a.type === "text" || a.type === "search" || a.type === "tel" || a.type === "url" || a.type === "password") || b2 === "textarea" || a.contentEditable === "true");
}
var Pe = fa && "documentMode" in document && 11 >= document.documentMode, Qe = null, Re = null, Se = null, Te = false;
function Ue(a, b2, c2) {
  var d2 = c2.window === c2 ? c2.document : c2.nodeType === 9 ? c2 : c2.ownerDocument;
  Te || Qe == null || Qe !== Xa(d2) || (d2 = Qe, "selectionStart" in d2 && Oe(d2) ? d2 = { start: d2.selectionStart, end: d2.selectionEnd } : (d2 = (d2.ownerDocument && d2.ownerDocument.defaultView || window).getSelection(), d2 = { anchorNode: d2.anchorNode, anchorOffset: d2.anchorOffset, focusNode: d2.focusNode, focusOffset: d2.focusOffset }), Se && Je(Se, d2) || (Se = d2, d2 = oe(Re, "onSelect"), 0 < d2.length && (b2 = new td("onSelect", "select", null, b2, c2), a.push({ event: b2, listeners: d2 }), b2.target = Qe)));
}
Pc("cancel cancel click click close close contextmenu contextMenu copy copy cut cut auxclick auxClick dblclick doubleClick dragend dragEnd dragstart dragStart drop drop focusin focus focusout blur input input invalid invalid keydown keyDown keypress keyPress keyup keyUp mousedown mouseDown mouseup mouseUp paste paste pause pause play play pointercancel pointerCancel pointerdown pointerDown pointerup pointerUp ratechange rateChange reset reset seeked seeked submit submit touchcancel touchCancel touchend touchEnd touchstart touchStart volumechange volumeChange".split(" "), 0);
Pc("drag drag dragenter dragEnter dragexit dragExit dragleave dragLeave dragover dragOver mousemove mouseMove mouseout mouseOut mouseover mouseOver pointermove pointerMove pointerout pointerOut pointerover pointerOver scroll scroll toggle toggle touchmove touchMove wheel wheel".split(" "), 1);
Pc(Oc, 2);
for (var Ve = "change selectionchange textInput compositionstart compositionend compositionupdate".split(" "), We = 0; We < Ve.length; We++)
  Nc.set(Ve[We], 0);
ea("onMouseEnter", ["mouseout", "mouseover"]);
ea("onMouseLeave", ["mouseout", "mouseover"]);
ea("onPointerEnter", ["pointerout", "pointerover"]);
ea("onPointerLeave", ["pointerout", "pointerover"]);
da("onChange", "change click focusin focusout input keydown keyup selectionchange".split(" "));
da("onSelect", "focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" "));
da("onBeforeInput", ["compositionend", "keypress", "textInput", "paste"]);
da("onCompositionEnd", "compositionend focusout keydown keypress keyup mousedown".split(" "));
da("onCompositionStart", "compositionstart focusout keydown keypress keyup mousedown".split(" "));
da("onCompositionUpdate", "compositionupdate focusout keydown keypress keyup mousedown".split(" "));
var Xe = "abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange seeked seeking stalled suspend timeupdate volumechange waiting".split(" "), Ye = new Set("cancel close invalid load scroll toggle".split(" ").concat(Xe));
function Ze(a, b2, c2) {
  var d2 = a.type || "unknown-event";
  a.currentTarget = c2;
  Yb(d2, b2, void 0, a);
  a.currentTarget = null;
}
function se(a, b2) {
  b2 = (b2 & 4) !== 0;
  for (var c2 = 0; c2 < a.length; c2++) {
    var d2 = a[c2], e2 = d2.event;
    d2 = d2.listeners;
    a: {
      var f2 = void 0;
      if (b2)
        for (var g2 = d2.length - 1; 0 <= g2; g2--) {
          var h = d2[g2], k2 = h.instance, l2 = h.currentTarget;
          h = h.listener;
          if (k2 !== f2 && e2.isPropagationStopped())
            break a;
          Ze(e2, h, l2);
          f2 = k2;
        }
      else
        for (g2 = 0; g2 < d2.length; g2++) {
          h = d2[g2];
          k2 = h.instance;
          l2 = h.currentTarget;
          h = h.listener;
          if (k2 !== f2 && e2.isPropagationStopped())
            break a;
          Ze(e2, h, l2);
          f2 = k2;
        }
    }
  }
  if (Ub)
    throw a = Vb, Ub = false, Vb = null, a;
}
function G(a, b2) {
  var c2 = $e(b2), d2 = a + "__bubble";
  c2.has(d2) || (af(b2, a, 2, false), c2.add(d2));
}
var bf = "_reactListening" + Math.random().toString(36).slice(2);
function cf(a) {
  a[bf] || (a[bf] = true, ba.forEach(function(b2) {
    Ye.has(b2) || df(b2, false, a, null);
    df(b2, true, a, null);
  }));
}
function df(a, b2, c2, d2) {
  var e2 = 4 < arguments.length && arguments[4] !== void 0 ? arguments[4] : 0, f2 = c2;
  a === "selectionchange" && c2.nodeType !== 9 && (f2 = c2.ownerDocument);
  if (d2 !== null && !b2 && Ye.has(a)) {
    if (a !== "scroll")
      return;
    e2 |= 2;
    f2 = d2;
  }
  var g2 = $e(f2), h = a + "__" + (b2 ? "capture" : "bubble");
  g2.has(h) || (b2 && (e2 |= 4), af(f2, a, e2, b2), g2.add(h));
}
function af(a, b2, c2, d2) {
  var e2 = Nc.get(b2);
  switch (e2 === void 0 ? 2 : e2) {
    case 0:
      e2 = gd;
      break;
    case 1:
      e2 = id$1;
      break;
    default:
      e2 = hd;
  }
  c2 = e2.bind(null, b2, c2, a);
  e2 = void 0;
  !Pb || b2 !== "touchstart" && b2 !== "touchmove" && b2 !== "wheel" || (e2 = true);
  d2 ? e2 !== void 0 ? a.addEventListener(b2, c2, { capture: true, passive: e2 }) : a.addEventListener(b2, c2, true) : e2 !== void 0 ? a.addEventListener(b2, c2, { passive: e2 }) : a.addEventListener(b2, c2, false);
}
function jd(a, b2, c2, d2, e2) {
  var f2 = d2;
  if ((b2 & 1) === 0 && (b2 & 2) === 0 && d2 !== null)
    a:
      for (; ; ) {
        if (d2 === null)
          return;
        var g2 = d2.tag;
        if (g2 === 3 || g2 === 4) {
          var h = d2.stateNode.containerInfo;
          if (h === e2 || h.nodeType === 8 && h.parentNode === e2)
            break;
          if (g2 === 4)
            for (g2 = d2.return; g2 !== null; ) {
              var k2 = g2.tag;
              if (k2 === 3 || k2 === 4) {
                if (k2 = g2.stateNode.containerInfo, k2 === e2 || k2.nodeType === 8 && k2.parentNode === e2)
                  return;
              }
              g2 = g2.return;
            }
          for (; h !== null; ) {
            g2 = wc(h);
            if (g2 === null)
              return;
            k2 = g2.tag;
            if (k2 === 5 || k2 === 6) {
              d2 = f2 = g2;
              continue a;
            }
            h = h.parentNode;
          }
        }
        d2 = d2.return;
      }
  Nb(function() {
    var d3 = f2, e3 = xb(c2), g3 = [];
    a: {
      var h2 = Mc.get(a);
      if (h2 !== void 0) {
        var k3 = td, x2 = a;
        switch (a) {
          case "keypress":
            if (od(c2) === 0)
              break a;
          case "keydown":
          case "keyup":
            k3 = Rd;
            break;
          case "focusin":
            x2 = "focus";
            k3 = Fd;
            break;
          case "focusout":
            x2 = "blur";
            k3 = Fd;
            break;
          case "beforeblur":
          case "afterblur":
            k3 = Fd;
            break;
          case "click":
            if (c2.button === 2)
              break a;
          case "auxclick":
          case "dblclick":
          case "mousedown":
          case "mousemove":
          case "mouseup":
          case "mouseout":
          case "mouseover":
          case "contextmenu":
            k3 = Bd;
            break;
          case "drag":
          case "dragend":
          case "dragenter":
          case "dragexit":
          case "dragleave":
          case "dragover":
          case "dragstart":
          case "drop":
            k3 = Dd;
            break;
          case "touchcancel":
          case "touchend":
          case "touchmove":
          case "touchstart":
            k3 = Vd;
            break;
          case Ic:
          case Jc:
          case Kc:
            k3 = Hd;
            break;
          case Lc:
            k3 = Xd;
            break;
          case "scroll":
            k3 = vd;
            break;
          case "wheel":
            k3 = Zd;
            break;
          case "copy":
          case "cut":
          case "paste":
            k3 = Jd;
            break;
          case "gotpointercapture":
          case "lostpointercapture":
          case "pointercancel":
          case "pointerdown":
          case "pointermove":
          case "pointerout":
          case "pointerover":
          case "pointerup":
            k3 = Td;
        }
        var w2 = (b2 & 4) !== 0, z2 = !w2 && a === "scroll", u = w2 ? h2 !== null ? h2 + "Capture" : null : h2;
        w2 = [];
        for (var t2 = d3, q2; t2 !== null; ) {
          q2 = t2;
          var v4 = q2.stateNode;
          q2.tag === 5 && v4 !== null && (q2 = v4, u !== null && (v4 = Ob(t2, u), v4 != null && w2.push(ef(t2, v4, q2))));
          if (z2)
            break;
          t2 = t2.return;
        }
        0 < w2.length && (h2 = new k3(h2, x2, null, c2, e3), g3.push({ event: h2, listeners: w2 }));
      }
    }
    if ((b2 & 7) === 0) {
      a: {
        h2 = a === "mouseover" || a === "pointerover";
        k3 = a === "mouseout" || a === "pointerout";
        if (h2 && (b2 & 16) === 0 && (x2 = c2.relatedTarget || c2.fromElement) && (wc(x2) || x2[ff]))
          break a;
        if (k3 || h2) {
          h2 = e3.window === e3 ? e3 : (h2 = e3.ownerDocument) ? h2.defaultView || h2.parentWindow : window;
          if (k3) {
            if (x2 = c2.relatedTarget || c2.toElement, k3 = d3, x2 = x2 ? wc(x2) : null, x2 !== null && (z2 = Zb(x2), x2 !== z2 || x2.tag !== 5 && x2.tag !== 6))
              x2 = null;
          } else
            k3 = null, x2 = d3;
          if (k3 !== x2) {
            w2 = Bd;
            v4 = "onMouseLeave";
            u = "onMouseEnter";
            t2 = "mouse";
            if (a === "pointerout" || a === "pointerover")
              w2 = Td, v4 = "onPointerLeave", u = "onPointerEnter", t2 = "pointer";
            z2 = k3 == null ? h2 : ue(k3);
            q2 = x2 == null ? h2 : ue(x2);
            h2 = new w2(v4, t2 + "leave", k3, c2, e3);
            h2.target = z2;
            h2.relatedTarget = q2;
            v4 = null;
            wc(e3) === d3 && (w2 = new w2(u, t2 + "enter", x2, c2, e3), w2.target = q2, w2.relatedTarget = z2, v4 = w2);
            z2 = v4;
            if (k3 && x2)
              b: {
                w2 = k3;
                u = x2;
                t2 = 0;
                for (q2 = w2; q2; q2 = gf(q2))
                  t2++;
                q2 = 0;
                for (v4 = u; v4; v4 = gf(v4))
                  q2++;
                for (; 0 < t2 - q2; )
                  w2 = gf(w2), t2--;
                for (; 0 < q2 - t2; )
                  u = gf(u), q2--;
                for (; t2--; ) {
                  if (w2 === u || u !== null && w2 === u.alternate)
                    break b;
                  w2 = gf(w2);
                  u = gf(u);
                }
                w2 = null;
              }
            else
              w2 = null;
            k3 !== null && hf(g3, h2, k3, w2, false);
            x2 !== null && z2 !== null && hf(g3, z2, x2, w2, true);
          }
        }
      }
      a: {
        h2 = d3 ? ue(d3) : window;
        k3 = h2.nodeName && h2.nodeName.toLowerCase();
        if (k3 === "select" || k3 === "input" && h2.type === "file")
          var J = ve;
        else if (me(h2))
          if (we)
            J = Fe;
          else {
            J = De;
            var K = Ce;
          }
        else
          (k3 = h2.nodeName) && k3.toLowerCase() === "input" && (h2.type === "checkbox" || h2.type === "radio") && (J = Ee);
        if (J && (J = J(a, d3))) {
          ne(g3, J, c2, e3);
          break a;
        }
        K && K(a, h2, d3);
        a === "focusout" && (K = h2._wrapperState) && K.controlled && h2.type === "number" && bb(h2, "number", h2.value);
      }
      K = d3 ? ue(d3) : window;
      switch (a) {
        case "focusin":
          if (me(K) || K.contentEditable === "true")
            Qe = K, Re = d3, Se = null;
          break;
        case "focusout":
          Se = Re = Qe = null;
          break;
        case "mousedown":
          Te = true;
          break;
        case "contextmenu":
        case "mouseup":
        case "dragend":
          Te = false;
          Ue(g3, c2, e3);
          break;
        case "selectionchange":
          if (Pe)
            break;
        case "keydown":
        case "keyup":
          Ue(g3, c2, e3);
      }
      var Q;
      if (ae)
        b: {
          switch (a) {
            case "compositionstart":
              var L = "onCompositionStart";
              break b;
            case "compositionend":
              L = "onCompositionEnd";
              break b;
            case "compositionupdate":
              L = "onCompositionUpdate";
              break b;
          }
          L = void 0;
        }
      else
        ie ? ge(a, c2) && (L = "onCompositionEnd") : a === "keydown" && c2.keyCode === 229 && (L = "onCompositionStart");
      L && (de && c2.locale !== "ko" && (ie || L !== "onCompositionStart" ? L === "onCompositionEnd" && ie && (Q = nd()) : (kd = e3, ld = "value" in kd ? kd.value : kd.textContent, ie = true)), K = oe(d3, L), 0 < K.length && (L = new Ld(L, a, null, c2, e3), g3.push({ event: L, listeners: K }), Q ? L.data = Q : (Q = he(c2), Q !== null && (L.data = Q))));
      if (Q = ce ? je(a, c2) : ke(a, c2))
        d3 = oe(d3, "onBeforeInput"), 0 < d3.length && (e3 = new Ld("onBeforeInput", "beforeinput", null, c2, e3), g3.push({ event: e3, listeners: d3 }), e3.data = Q);
    }
    se(g3, b2);
  });
}
function ef(a, b2, c2) {
  return { instance: a, listener: b2, currentTarget: c2 };
}
function oe(a, b2) {
  for (var c2 = b2 + "Capture", d2 = []; a !== null; ) {
    var e2 = a, f2 = e2.stateNode;
    e2.tag === 5 && f2 !== null && (e2 = f2, f2 = Ob(a, c2), f2 != null && d2.unshift(ef(a, f2, e2)), f2 = Ob(a, b2), f2 != null && d2.push(ef(a, f2, e2)));
    a = a.return;
  }
  return d2;
}
function gf(a) {
  if (a === null)
    return null;
  do
    a = a.return;
  while (a && a.tag !== 5);
  return a ? a : null;
}
function hf(a, b2, c2, d2, e2) {
  for (var f2 = b2._reactName, g2 = []; c2 !== null && c2 !== d2; ) {
    var h = c2, k2 = h.alternate, l2 = h.stateNode;
    if (k2 !== null && k2 === d2)
      break;
    h.tag === 5 && l2 !== null && (h = l2, e2 ? (k2 = Ob(c2, f2), k2 != null && g2.unshift(ef(c2, k2, h))) : e2 || (k2 = Ob(c2, f2), k2 != null && g2.push(ef(c2, k2, h))));
    c2 = c2.return;
  }
  g2.length !== 0 && a.push({ event: b2, listeners: g2 });
}
function jf() {
}
var kf = null, lf = null;
function mf(a, b2) {
  switch (a) {
    case "button":
    case "input":
    case "select":
    case "textarea":
      return !!b2.autoFocus;
  }
  return false;
}
function nf(a, b2) {
  return a === "textarea" || a === "option" || a === "noscript" || typeof b2.children === "string" || typeof b2.children === "number" || typeof b2.dangerouslySetInnerHTML === "object" && b2.dangerouslySetInnerHTML !== null && b2.dangerouslySetInnerHTML.__html != null;
}
var of = typeof setTimeout === "function" ? setTimeout : void 0, pf = typeof clearTimeout === "function" ? clearTimeout : void 0;
function qf(a) {
  a.nodeType === 1 ? a.textContent = "" : a.nodeType === 9 && (a = a.body, a != null && (a.textContent = ""));
}
function rf(a) {
  for (; a != null; a = a.nextSibling) {
    var b2 = a.nodeType;
    if (b2 === 1 || b2 === 3)
      break;
  }
  return a;
}
function sf(a) {
  a = a.previousSibling;
  for (var b2 = 0; a; ) {
    if (a.nodeType === 8) {
      var c2 = a.data;
      if (c2 === "$" || c2 === "$!" || c2 === "$?") {
        if (b2 === 0)
          return a;
        b2--;
      } else
        c2 === "/$" && b2++;
    }
    a = a.previousSibling;
  }
  return null;
}
var tf = 0;
function uf(a) {
  return { $$typeof: Ga, toString: a, valueOf: a };
}
var vf = Math.random().toString(36).slice(2), wf = "__reactFiber$" + vf, xf = "__reactProps$" + vf, ff = "__reactContainer$" + vf, yf = "__reactEvents$" + vf;
function wc(a) {
  var b2 = a[wf];
  if (b2)
    return b2;
  for (var c2 = a.parentNode; c2; ) {
    if (b2 = c2[ff] || c2[wf]) {
      c2 = b2.alternate;
      if (b2.child !== null || c2 !== null && c2.child !== null)
        for (a = sf(a); a !== null; ) {
          if (c2 = a[wf])
            return c2;
          a = sf(a);
        }
      return b2;
    }
    a = c2;
    c2 = a.parentNode;
  }
  return null;
}
function Cb(a) {
  a = a[wf] || a[ff];
  return !a || a.tag !== 5 && a.tag !== 6 && a.tag !== 13 && a.tag !== 3 ? null : a;
}
function ue(a) {
  if (a.tag === 5 || a.tag === 6)
    return a.stateNode;
  throw Error(y(33));
}
function Db(a) {
  return a[xf] || null;
}
function $e(a) {
  var b2 = a[yf];
  b2 === void 0 && (b2 = a[yf] = /* @__PURE__ */ new Set());
  return b2;
}
var zf = [], Af = -1;
function Bf(a) {
  return { current: a };
}
function H(a) {
  0 > Af || (a.current = zf[Af], zf[Af] = null, Af--);
}
function I(a, b2) {
  Af++;
  zf[Af] = a.current;
  a.current = b2;
}
var Cf = {}, M = Bf(Cf), N = Bf(false), Df = Cf;
function Ef(a, b2) {
  var c2 = a.type.contextTypes;
  if (!c2)
    return Cf;
  var d2 = a.stateNode;
  if (d2 && d2.__reactInternalMemoizedUnmaskedChildContext === b2)
    return d2.__reactInternalMemoizedMaskedChildContext;
  var e2 = {}, f2;
  for (f2 in c2)
    e2[f2] = b2[f2];
  d2 && (a = a.stateNode, a.__reactInternalMemoizedUnmaskedChildContext = b2, a.__reactInternalMemoizedMaskedChildContext = e2);
  return e2;
}
function Ff(a) {
  a = a.childContextTypes;
  return a !== null && a !== void 0;
}
function Gf() {
  H(N);
  H(M);
}
function Hf(a, b2, c2) {
  if (M.current !== Cf)
    throw Error(y(168));
  I(M, b2);
  I(N, c2);
}
function If(a, b2, c2) {
  var d2 = a.stateNode;
  a = b2.childContextTypes;
  if (typeof d2.getChildContext !== "function")
    return c2;
  d2 = d2.getChildContext();
  for (var e2 in d2)
    if (!(e2 in a))
      throw Error(y(108, Ra(b2) || "Unknown", e2));
  return m$1({}, c2, d2);
}
function Jf(a) {
  a = (a = a.stateNode) && a.__reactInternalMemoizedMergedChildContext || Cf;
  Df = M.current;
  I(M, a);
  I(N, N.current);
  return true;
}
function Kf(a, b2, c2) {
  var d2 = a.stateNode;
  if (!d2)
    throw Error(y(169));
  c2 ? (a = If(a, b2, Df), d2.__reactInternalMemoizedMergedChildContext = a, H(N), H(M), I(M, a)) : H(N);
  I(N, c2);
}
var Lf = null, Mf = null, Nf = r.unstable_runWithPriority, Of = r.unstable_scheduleCallback, Pf = r.unstable_cancelCallback, Qf = r.unstable_shouldYield, Rf = r.unstable_requestPaint, Sf = r.unstable_now, Tf = r.unstable_getCurrentPriorityLevel, Uf = r.unstable_ImmediatePriority, Vf = r.unstable_UserBlockingPriority, Wf = r.unstable_NormalPriority, Xf = r.unstable_LowPriority, Yf = r.unstable_IdlePriority, Zf = {}, $f = Rf !== void 0 ? Rf : function() {
}, ag = null, bg = null, cg = false, dg = Sf(), O = 1e4 > dg ? Sf : function() {
  return Sf() - dg;
};
function eg() {
  switch (Tf()) {
    case Uf:
      return 99;
    case Vf:
      return 98;
    case Wf:
      return 97;
    case Xf:
      return 96;
    case Yf:
      return 95;
    default:
      throw Error(y(332));
  }
}
function fg(a) {
  switch (a) {
    case 99:
      return Uf;
    case 98:
      return Vf;
    case 97:
      return Wf;
    case 96:
      return Xf;
    case 95:
      return Yf;
    default:
      throw Error(y(332));
  }
}
function gg(a, b2) {
  a = fg(a);
  return Nf(a, b2);
}
function hg(a, b2, c2) {
  a = fg(a);
  return Of(a, b2, c2);
}
function ig() {
  if (bg !== null) {
    var a = bg;
    bg = null;
    Pf(a);
  }
  jg();
}
function jg() {
  if (!cg && ag !== null) {
    cg = true;
    var a = 0;
    try {
      var b2 = ag;
      gg(99, function() {
        for (; a < b2.length; a++) {
          var c2 = b2[a];
          do
            c2 = c2(true);
          while (c2 !== null);
        }
      });
      ag = null;
    } catch (c2) {
      throw ag !== null && (ag = ag.slice(a + 1)), Of(Uf, ig), c2;
    } finally {
      cg = false;
    }
  }
}
var kg = ra.ReactCurrentBatchConfig;
function lg(a, b2) {
  if (a && a.defaultProps) {
    b2 = m$1({}, b2);
    a = a.defaultProps;
    for (var c2 in a)
      b2[c2] === void 0 && (b2[c2] = a[c2]);
    return b2;
  }
  return b2;
}
var mg = Bf(null), ng = null, og = null, pg = null;
function qg() {
  pg = og = ng = null;
}
function rg(a) {
  var b2 = mg.current;
  H(mg);
  a.type._context._currentValue = b2;
}
function sg(a, b2) {
  for (; a !== null; ) {
    var c2 = a.alternate;
    if ((a.childLanes & b2) === b2)
      if (c2 === null || (c2.childLanes & b2) === b2)
        break;
      else
        c2.childLanes |= b2;
    else
      a.childLanes |= b2, c2 !== null && (c2.childLanes |= b2);
    a = a.return;
  }
}
function tg(a, b2) {
  ng = a;
  pg = og = null;
  a = a.dependencies;
  a !== null && a.firstContext !== null && ((a.lanes & b2) !== 0 && (ug = true), a.firstContext = null);
}
function vg(a, b2) {
  if (pg !== a && b2 !== false && b2 !== 0) {
    if (typeof b2 !== "number" || b2 === 1073741823)
      pg = a, b2 = 1073741823;
    b2 = { context: a, observedBits: b2, next: null };
    if (og === null) {
      if (ng === null)
        throw Error(y(308));
      og = b2;
      ng.dependencies = { lanes: 0, firstContext: b2, responders: null };
    } else
      og = og.next = b2;
  }
  return a._currentValue;
}
var wg = false;
function xg(a) {
  a.updateQueue = { baseState: a.memoizedState, firstBaseUpdate: null, lastBaseUpdate: null, shared: { pending: null }, effects: null };
}
function yg(a, b2) {
  a = a.updateQueue;
  b2.updateQueue === a && (b2.updateQueue = { baseState: a.baseState, firstBaseUpdate: a.firstBaseUpdate, lastBaseUpdate: a.lastBaseUpdate, shared: a.shared, effects: a.effects });
}
function zg(a, b2) {
  return { eventTime: a, lane: b2, tag: 0, payload: null, callback: null, next: null };
}
function Ag(a, b2) {
  a = a.updateQueue;
  if (a !== null) {
    a = a.shared;
    var c2 = a.pending;
    c2 === null ? b2.next = b2 : (b2.next = c2.next, c2.next = b2);
    a.pending = b2;
  }
}
function Bg(a, b2) {
  var c2 = a.updateQueue, d2 = a.alternate;
  if (d2 !== null && (d2 = d2.updateQueue, c2 === d2)) {
    var e2 = null, f2 = null;
    c2 = c2.firstBaseUpdate;
    if (c2 !== null) {
      do {
        var g2 = { eventTime: c2.eventTime, lane: c2.lane, tag: c2.tag, payload: c2.payload, callback: c2.callback, next: null };
        f2 === null ? e2 = f2 = g2 : f2 = f2.next = g2;
        c2 = c2.next;
      } while (c2 !== null);
      f2 === null ? e2 = f2 = b2 : f2 = f2.next = b2;
    } else
      e2 = f2 = b2;
    c2 = { baseState: d2.baseState, firstBaseUpdate: e2, lastBaseUpdate: f2, shared: d2.shared, effects: d2.effects };
    a.updateQueue = c2;
    return;
  }
  a = c2.lastBaseUpdate;
  a === null ? c2.firstBaseUpdate = b2 : a.next = b2;
  c2.lastBaseUpdate = b2;
}
function Cg(a, b2, c2, d2) {
  var e2 = a.updateQueue;
  wg = false;
  var f2 = e2.firstBaseUpdate, g2 = e2.lastBaseUpdate, h = e2.shared.pending;
  if (h !== null) {
    e2.shared.pending = null;
    var k2 = h, l2 = k2.next;
    k2.next = null;
    g2 === null ? f2 = l2 : g2.next = l2;
    g2 = k2;
    var n2 = a.alternate;
    if (n2 !== null) {
      n2 = n2.updateQueue;
      var A2 = n2.lastBaseUpdate;
      A2 !== g2 && (A2 === null ? n2.firstBaseUpdate = l2 : A2.next = l2, n2.lastBaseUpdate = k2);
    }
  }
  if (f2 !== null) {
    A2 = e2.baseState;
    g2 = 0;
    n2 = l2 = k2 = null;
    do {
      h = f2.lane;
      var p2 = f2.eventTime;
      if ((d2 & h) === h) {
        n2 !== null && (n2 = n2.next = {
          eventTime: p2,
          lane: 0,
          tag: f2.tag,
          payload: f2.payload,
          callback: f2.callback,
          next: null
        });
        a: {
          var C = a, x2 = f2;
          h = b2;
          p2 = c2;
          switch (x2.tag) {
            case 1:
              C = x2.payload;
              if (typeof C === "function") {
                A2 = C.call(p2, A2, h);
                break a;
              }
              A2 = C;
              break a;
            case 3:
              C.flags = C.flags & -4097 | 64;
            case 0:
              C = x2.payload;
              h = typeof C === "function" ? C.call(p2, A2, h) : C;
              if (h === null || h === void 0)
                break a;
              A2 = m$1({}, A2, h);
              break a;
            case 2:
              wg = true;
          }
        }
        f2.callback !== null && (a.flags |= 32, h = e2.effects, h === null ? e2.effects = [f2] : h.push(f2));
      } else
        p2 = { eventTime: p2, lane: h, tag: f2.tag, payload: f2.payload, callback: f2.callback, next: null }, n2 === null ? (l2 = n2 = p2, k2 = A2) : n2 = n2.next = p2, g2 |= h;
      f2 = f2.next;
      if (f2 === null)
        if (h = e2.shared.pending, h === null)
          break;
        else
          f2 = h.next, h.next = null, e2.lastBaseUpdate = h, e2.shared.pending = null;
    } while (1);
    n2 === null && (k2 = A2);
    e2.baseState = k2;
    e2.firstBaseUpdate = l2;
    e2.lastBaseUpdate = n2;
    Dg |= g2;
    a.lanes = g2;
    a.memoizedState = A2;
  }
}
function Eg(a, b2, c2) {
  a = b2.effects;
  b2.effects = null;
  if (a !== null)
    for (b2 = 0; b2 < a.length; b2++) {
      var d2 = a[b2], e2 = d2.callback;
      if (e2 !== null) {
        d2.callback = null;
        d2 = c2;
        if (typeof e2 !== "function")
          throw Error(y(191, e2));
        e2.call(d2);
      }
    }
}
var Fg = new aa.Component().refs;
function Gg(a, b2, c2, d2) {
  b2 = a.memoizedState;
  c2 = c2(d2, b2);
  c2 = c2 === null || c2 === void 0 ? b2 : m$1({}, b2, c2);
  a.memoizedState = c2;
  a.lanes === 0 && (a.updateQueue.baseState = c2);
}
var Kg = { isMounted: function(a) {
  return (a = a._reactInternals) ? Zb(a) === a : false;
}, enqueueSetState: function(a, b2, c2) {
  a = a._reactInternals;
  var d2 = Hg(), e2 = Ig(a), f2 = zg(d2, e2);
  f2.payload = b2;
  c2 !== void 0 && c2 !== null && (f2.callback = c2);
  Ag(a, f2);
  Jg(a, e2, d2);
}, enqueueReplaceState: function(a, b2, c2) {
  a = a._reactInternals;
  var d2 = Hg(), e2 = Ig(a), f2 = zg(d2, e2);
  f2.tag = 1;
  f2.payload = b2;
  c2 !== void 0 && c2 !== null && (f2.callback = c2);
  Ag(a, f2);
  Jg(a, e2, d2);
}, enqueueForceUpdate: function(a, b2) {
  a = a._reactInternals;
  var c2 = Hg(), d2 = Ig(a), e2 = zg(c2, d2);
  e2.tag = 2;
  b2 !== void 0 && b2 !== null && (e2.callback = b2);
  Ag(a, e2);
  Jg(a, d2, c2);
} };
function Lg(a, b2, c2, d2, e2, f2, g2) {
  a = a.stateNode;
  return typeof a.shouldComponentUpdate === "function" ? a.shouldComponentUpdate(d2, f2, g2) : b2.prototype && b2.prototype.isPureReactComponent ? !Je(c2, d2) || !Je(e2, f2) : true;
}
function Mg(a, b2, c2) {
  var d2 = false, e2 = Cf;
  var f2 = b2.contextType;
  typeof f2 === "object" && f2 !== null ? f2 = vg(f2) : (e2 = Ff(b2) ? Df : M.current, d2 = b2.contextTypes, f2 = (d2 = d2 !== null && d2 !== void 0) ? Ef(a, e2) : Cf);
  b2 = new b2(c2, f2);
  a.memoizedState = b2.state !== null && b2.state !== void 0 ? b2.state : null;
  b2.updater = Kg;
  a.stateNode = b2;
  b2._reactInternals = a;
  d2 && (a = a.stateNode, a.__reactInternalMemoizedUnmaskedChildContext = e2, a.__reactInternalMemoizedMaskedChildContext = f2);
  return b2;
}
function Ng(a, b2, c2, d2) {
  a = b2.state;
  typeof b2.componentWillReceiveProps === "function" && b2.componentWillReceiveProps(c2, d2);
  typeof b2.UNSAFE_componentWillReceiveProps === "function" && b2.UNSAFE_componentWillReceiveProps(c2, d2);
  b2.state !== a && Kg.enqueueReplaceState(b2, b2.state, null);
}
function Og(a, b2, c2, d2) {
  var e2 = a.stateNode;
  e2.props = c2;
  e2.state = a.memoizedState;
  e2.refs = Fg;
  xg(a);
  var f2 = b2.contextType;
  typeof f2 === "object" && f2 !== null ? e2.context = vg(f2) : (f2 = Ff(b2) ? Df : M.current, e2.context = Ef(a, f2));
  Cg(a, c2, e2, d2);
  e2.state = a.memoizedState;
  f2 = b2.getDerivedStateFromProps;
  typeof f2 === "function" && (Gg(a, b2, f2, c2), e2.state = a.memoizedState);
  typeof b2.getDerivedStateFromProps === "function" || typeof e2.getSnapshotBeforeUpdate === "function" || typeof e2.UNSAFE_componentWillMount !== "function" && typeof e2.componentWillMount !== "function" || (b2 = e2.state, typeof e2.componentWillMount === "function" && e2.componentWillMount(), typeof e2.UNSAFE_componentWillMount === "function" && e2.UNSAFE_componentWillMount(), b2 !== e2.state && Kg.enqueueReplaceState(e2, e2.state, null), Cg(a, c2, e2, d2), e2.state = a.memoizedState);
  typeof e2.componentDidMount === "function" && (a.flags |= 4);
}
var Pg = Array.isArray;
function Qg(a, b2, c2) {
  a = c2.ref;
  if (a !== null && typeof a !== "function" && typeof a !== "object") {
    if (c2._owner) {
      c2 = c2._owner;
      if (c2) {
        if (c2.tag !== 1)
          throw Error(y(309));
        var d2 = c2.stateNode;
      }
      if (!d2)
        throw Error(y(147, a));
      var e2 = "" + a;
      if (b2 !== null && b2.ref !== null && typeof b2.ref === "function" && b2.ref._stringRef === e2)
        return b2.ref;
      b2 = function(a2) {
        var b3 = d2.refs;
        b3 === Fg && (b3 = d2.refs = {});
        a2 === null ? delete b3[e2] : b3[e2] = a2;
      };
      b2._stringRef = e2;
      return b2;
    }
    if (typeof a !== "string")
      throw Error(y(284));
    if (!c2._owner)
      throw Error(y(290, a));
  }
  return a;
}
function Rg(a, b2) {
  if (a.type !== "textarea")
    throw Error(y(31, Object.prototype.toString.call(b2) === "[object Object]" ? "object with keys {" + Object.keys(b2).join(", ") + "}" : b2));
}
function Sg(a) {
  function b2(b3, c3) {
    if (a) {
      var d3 = b3.lastEffect;
      d3 !== null ? (d3.nextEffect = c3, b3.lastEffect = c3) : b3.firstEffect = b3.lastEffect = c3;
      c3.nextEffect = null;
      c3.flags = 8;
    }
  }
  function c2(c3, d3) {
    if (!a)
      return null;
    for (; d3 !== null; )
      b2(c3, d3), d3 = d3.sibling;
    return null;
  }
  function d2(a2, b3) {
    for (a2 = /* @__PURE__ */ new Map(); b3 !== null; )
      b3.key !== null ? a2.set(b3.key, b3) : a2.set(b3.index, b3), b3 = b3.sibling;
    return a2;
  }
  function e2(a2, b3) {
    a2 = Tg(a2, b3);
    a2.index = 0;
    a2.sibling = null;
    return a2;
  }
  function f2(b3, c3, d3) {
    b3.index = d3;
    if (!a)
      return c3;
    d3 = b3.alternate;
    if (d3 !== null)
      return d3 = d3.index, d3 < c3 ? (b3.flags = 2, c3) : d3;
    b3.flags = 2;
    return c3;
  }
  function g2(b3) {
    a && b3.alternate === null && (b3.flags = 2);
    return b3;
  }
  function h(a2, b3, c3, d3) {
    if (b3 === null || b3.tag !== 6)
      return b3 = Ug(c3, a2.mode, d3), b3.return = a2, b3;
    b3 = e2(b3, c3);
    b3.return = a2;
    return b3;
  }
  function k2(a2, b3, c3, d3) {
    if (b3 !== null && b3.elementType === c3.type)
      return d3 = e2(b3, c3.props), d3.ref = Qg(a2, b3, c3), d3.return = a2, d3;
    d3 = Vg(c3.type, c3.key, c3.props, null, a2.mode, d3);
    d3.ref = Qg(a2, b3, c3);
    d3.return = a2;
    return d3;
  }
  function l2(a2, b3, c3, d3) {
    if (b3 === null || b3.tag !== 4 || b3.stateNode.containerInfo !== c3.containerInfo || b3.stateNode.implementation !== c3.implementation)
      return b3 = Wg(c3, a2.mode, d3), b3.return = a2, b3;
    b3 = e2(b3, c3.children || []);
    b3.return = a2;
    return b3;
  }
  function n2(a2, b3, c3, d3, f3) {
    if (b3 === null || b3.tag !== 7)
      return b3 = Xg(c3, a2.mode, d3, f3), b3.return = a2, b3;
    b3 = e2(b3, c3);
    b3.return = a2;
    return b3;
  }
  function A2(a2, b3, c3) {
    if (typeof b3 === "string" || typeof b3 === "number")
      return b3 = Ug("" + b3, a2.mode, c3), b3.return = a2, b3;
    if (typeof b3 === "object" && b3 !== null) {
      switch (b3.$$typeof) {
        case sa:
          return c3 = Vg(b3.type, b3.key, b3.props, null, a2.mode, c3), c3.ref = Qg(a2, null, b3), c3.return = a2, c3;
        case ta:
          return b3 = Wg(b3, a2.mode, c3), b3.return = a2, b3;
      }
      if (Pg(b3) || La(b3))
        return b3 = Xg(b3, a2.mode, c3, null), b3.return = a2, b3;
      Rg(a2, b3);
    }
    return null;
  }
  function p2(a2, b3, c3, d3) {
    var e3 = b3 !== null ? b3.key : null;
    if (typeof c3 === "string" || typeof c3 === "number")
      return e3 !== null ? null : h(a2, b3, "" + c3, d3);
    if (typeof c3 === "object" && c3 !== null) {
      switch (c3.$$typeof) {
        case sa:
          return c3.key === e3 ? c3.type === ua ? n2(a2, b3, c3.props.children, d3, e3) : k2(a2, b3, c3, d3) : null;
        case ta:
          return c3.key === e3 ? l2(a2, b3, c3, d3) : null;
      }
      if (Pg(c3) || La(c3))
        return e3 !== null ? null : n2(a2, b3, c3, d3, null);
      Rg(a2, c3);
    }
    return null;
  }
  function C(a2, b3, c3, d3, e3) {
    if (typeof d3 === "string" || typeof d3 === "number")
      return a2 = a2.get(c3) || null, h(b3, a2, "" + d3, e3);
    if (typeof d3 === "object" && d3 !== null) {
      switch (d3.$$typeof) {
        case sa:
          return a2 = a2.get(d3.key === null ? c3 : d3.key) || null, d3.type === ua ? n2(b3, a2, d3.props.children, e3, d3.key) : k2(b3, a2, d3, e3);
        case ta:
          return a2 = a2.get(d3.key === null ? c3 : d3.key) || null, l2(b3, a2, d3, e3);
      }
      if (Pg(d3) || La(d3))
        return a2 = a2.get(c3) || null, n2(b3, a2, d3, e3, null);
      Rg(b3, d3);
    }
    return null;
  }
  function x2(e3, g3, h2, k3) {
    for (var l3 = null, t2 = null, u = g3, z2 = g3 = 0, q2 = null; u !== null && z2 < h2.length; z2++) {
      u.index > z2 ? (q2 = u, u = null) : q2 = u.sibling;
      var n3 = p2(e3, u, h2[z2], k3);
      if (n3 === null) {
        u === null && (u = q2);
        break;
      }
      a && u && n3.alternate === null && b2(e3, u);
      g3 = f2(n3, g3, z2);
      t2 === null ? l3 = n3 : t2.sibling = n3;
      t2 = n3;
      u = q2;
    }
    if (z2 === h2.length)
      return c2(e3, u), l3;
    if (u === null) {
      for (; z2 < h2.length; z2++)
        u = A2(e3, h2[z2], k3), u !== null && (g3 = f2(u, g3, z2), t2 === null ? l3 = u : t2.sibling = u, t2 = u);
      return l3;
    }
    for (u = d2(e3, u); z2 < h2.length; z2++)
      q2 = C(u, e3, z2, h2[z2], k3), q2 !== null && (a && q2.alternate !== null && u.delete(q2.key === null ? z2 : q2.key), g3 = f2(q2, g3, z2), t2 === null ? l3 = q2 : t2.sibling = q2, t2 = q2);
    a && u.forEach(function(a2) {
      return b2(e3, a2);
    });
    return l3;
  }
  function w2(e3, g3, h2, k3) {
    var l3 = La(h2);
    if (typeof l3 !== "function")
      throw Error(y(150));
    h2 = l3.call(h2);
    if (h2 == null)
      throw Error(y(151));
    for (var t2 = l3 = null, u = g3, z2 = g3 = 0, q2 = null, n3 = h2.next(); u !== null && !n3.done; z2++, n3 = h2.next()) {
      u.index > z2 ? (q2 = u, u = null) : q2 = u.sibling;
      var w3 = p2(e3, u, n3.value, k3);
      if (w3 === null) {
        u === null && (u = q2);
        break;
      }
      a && u && w3.alternate === null && b2(e3, u);
      g3 = f2(w3, g3, z2);
      t2 === null ? l3 = w3 : t2.sibling = w3;
      t2 = w3;
      u = q2;
    }
    if (n3.done)
      return c2(e3, u), l3;
    if (u === null) {
      for (; !n3.done; z2++, n3 = h2.next())
        n3 = A2(e3, n3.value, k3), n3 !== null && (g3 = f2(n3, g3, z2), t2 === null ? l3 = n3 : t2.sibling = n3, t2 = n3);
      return l3;
    }
    for (u = d2(e3, u); !n3.done; z2++, n3 = h2.next())
      n3 = C(u, e3, z2, n3.value, k3), n3 !== null && (a && n3.alternate !== null && u.delete(n3.key === null ? z2 : n3.key), g3 = f2(n3, g3, z2), t2 === null ? l3 = n3 : t2.sibling = n3, t2 = n3);
    a && u.forEach(function(a2) {
      return b2(e3, a2);
    });
    return l3;
  }
  return function(a2, d3, f3, h2) {
    var k3 = typeof f3 === "object" && f3 !== null && f3.type === ua && f3.key === null;
    k3 && (f3 = f3.props.children);
    var l3 = typeof f3 === "object" && f3 !== null;
    if (l3)
      switch (f3.$$typeof) {
        case sa:
          a: {
            l3 = f3.key;
            for (k3 = d3; k3 !== null; ) {
              if (k3.key === l3) {
                switch (k3.tag) {
                  case 7:
                    if (f3.type === ua) {
                      c2(a2, k3.sibling);
                      d3 = e2(k3, f3.props.children);
                      d3.return = a2;
                      a2 = d3;
                      break a;
                    }
                    break;
                  default:
                    if (k3.elementType === f3.type) {
                      c2(a2, k3.sibling);
                      d3 = e2(k3, f3.props);
                      d3.ref = Qg(a2, k3, f3);
                      d3.return = a2;
                      a2 = d3;
                      break a;
                    }
                }
                c2(a2, k3);
                break;
              } else
                b2(a2, k3);
              k3 = k3.sibling;
            }
            f3.type === ua ? (d3 = Xg(f3.props.children, a2.mode, h2, f3.key), d3.return = a2, a2 = d3) : (h2 = Vg(f3.type, f3.key, f3.props, null, a2.mode, h2), h2.ref = Qg(a2, d3, f3), h2.return = a2, a2 = h2);
          }
          return g2(a2);
        case ta:
          a: {
            for (k3 = f3.key; d3 !== null; ) {
              if (d3.key === k3)
                if (d3.tag === 4 && d3.stateNode.containerInfo === f3.containerInfo && d3.stateNode.implementation === f3.implementation) {
                  c2(a2, d3.sibling);
                  d3 = e2(d3, f3.children || []);
                  d3.return = a2;
                  a2 = d3;
                  break a;
                } else {
                  c2(a2, d3);
                  break;
                }
              else
                b2(a2, d3);
              d3 = d3.sibling;
            }
            d3 = Wg(f3, a2.mode, h2);
            d3.return = a2;
            a2 = d3;
          }
          return g2(a2);
      }
    if (typeof f3 === "string" || typeof f3 === "number")
      return f3 = "" + f3, d3 !== null && d3.tag === 6 ? (c2(a2, d3.sibling), d3 = e2(d3, f3), d3.return = a2, a2 = d3) : (c2(a2, d3), d3 = Ug(f3, a2.mode, h2), d3.return = a2, a2 = d3), g2(a2);
    if (Pg(f3))
      return x2(a2, d3, f3, h2);
    if (La(f3))
      return w2(a2, d3, f3, h2);
    l3 && Rg(a2, f3);
    if (typeof f3 === "undefined" && !k3)
      switch (a2.tag) {
        case 1:
        case 22:
        case 0:
        case 11:
        case 15:
          throw Error(y(152, Ra(a2.type) || "Component"));
      }
    return c2(a2, d3);
  };
}
var Yg = Sg(true), Zg = Sg(false), $g = {}, ah = Bf($g), bh = Bf($g), ch = Bf($g);
function dh(a) {
  if (a === $g)
    throw Error(y(174));
  return a;
}
function eh(a, b2) {
  I(ch, b2);
  I(bh, a);
  I(ah, $g);
  a = b2.nodeType;
  switch (a) {
    case 9:
    case 11:
      b2 = (b2 = b2.documentElement) ? b2.namespaceURI : mb(null, "");
      break;
    default:
      a = a === 8 ? b2.parentNode : b2, b2 = a.namespaceURI || null, a = a.tagName, b2 = mb(b2, a);
  }
  H(ah);
  I(ah, b2);
}
function fh() {
  H(ah);
  H(bh);
  H(ch);
}
function gh(a) {
  dh(ch.current);
  var b2 = dh(ah.current);
  var c2 = mb(b2, a.type);
  b2 !== c2 && (I(bh, a), I(ah, c2));
}
function hh(a) {
  bh.current === a && (H(ah), H(bh));
}
var P = Bf(0);
function ih(a) {
  for (var b2 = a; b2 !== null; ) {
    if (b2.tag === 13) {
      var c2 = b2.memoizedState;
      if (c2 !== null && (c2 = c2.dehydrated, c2 === null || c2.data === "$?" || c2.data === "$!"))
        return b2;
    } else if (b2.tag === 19 && b2.memoizedProps.revealOrder !== void 0) {
      if ((b2.flags & 64) !== 0)
        return b2;
    } else if (b2.child !== null) {
      b2.child.return = b2;
      b2 = b2.child;
      continue;
    }
    if (b2 === a)
      break;
    for (; b2.sibling === null; ) {
      if (b2.return === null || b2.return === a)
        return null;
      b2 = b2.return;
    }
    b2.sibling.return = b2.return;
    b2 = b2.sibling;
  }
  return null;
}
var jh = null, kh = null, lh = false;
function mh(a, b2) {
  var c2 = nh(5, null, null, 0);
  c2.elementType = "DELETED";
  c2.type = "DELETED";
  c2.stateNode = b2;
  c2.return = a;
  c2.flags = 8;
  a.lastEffect !== null ? (a.lastEffect.nextEffect = c2, a.lastEffect = c2) : a.firstEffect = a.lastEffect = c2;
}
function oh(a, b2) {
  switch (a.tag) {
    case 5:
      var c2 = a.type;
      b2 = b2.nodeType !== 1 || c2.toLowerCase() !== b2.nodeName.toLowerCase() ? null : b2;
      return b2 !== null ? (a.stateNode = b2, true) : false;
    case 6:
      return b2 = a.pendingProps === "" || b2.nodeType !== 3 ? null : b2, b2 !== null ? (a.stateNode = b2, true) : false;
    case 13:
      return false;
    default:
      return false;
  }
}
function ph(a) {
  if (lh) {
    var b2 = kh;
    if (b2) {
      var c2 = b2;
      if (!oh(a, b2)) {
        b2 = rf(c2.nextSibling);
        if (!b2 || !oh(a, b2)) {
          a.flags = a.flags & -1025 | 2;
          lh = false;
          jh = a;
          return;
        }
        mh(jh, c2);
      }
      jh = a;
      kh = rf(b2.firstChild);
    } else
      a.flags = a.flags & -1025 | 2, lh = false, jh = a;
  }
}
function qh(a) {
  for (a = a.return; a !== null && a.tag !== 5 && a.tag !== 3 && a.tag !== 13; )
    a = a.return;
  jh = a;
}
function rh(a) {
  if (a !== jh)
    return false;
  if (!lh)
    return qh(a), lh = true, false;
  var b2 = a.type;
  if (a.tag !== 5 || b2 !== "head" && b2 !== "body" && !nf(b2, a.memoizedProps))
    for (b2 = kh; b2; )
      mh(a, b2), b2 = rf(b2.nextSibling);
  qh(a);
  if (a.tag === 13) {
    a = a.memoizedState;
    a = a !== null ? a.dehydrated : null;
    if (!a)
      throw Error(y(317));
    a: {
      a = a.nextSibling;
      for (b2 = 0; a; ) {
        if (a.nodeType === 8) {
          var c2 = a.data;
          if (c2 === "/$") {
            if (b2 === 0) {
              kh = rf(a.nextSibling);
              break a;
            }
            b2--;
          } else
            c2 !== "$" && c2 !== "$!" && c2 !== "$?" || b2++;
        }
        a = a.nextSibling;
      }
      kh = null;
    }
  } else
    kh = jh ? rf(a.stateNode.nextSibling) : null;
  return true;
}
function sh() {
  kh = jh = null;
  lh = false;
}
var th = [];
function uh() {
  for (var a = 0; a < th.length; a++)
    th[a]._workInProgressVersionPrimary = null;
  th.length = 0;
}
var vh = ra.ReactCurrentDispatcher, wh = ra.ReactCurrentBatchConfig, xh = 0, R = null, S = null, T = null, yh = false, zh = false;
function Ah() {
  throw Error(y(321));
}
function Bh(a, b2) {
  if (b2 === null)
    return false;
  for (var c2 = 0; c2 < b2.length && c2 < a.length; c2++)
    if (!He(a[c2], b2[c2]))
      return false;
  return true;
}
function Ch(a, b2, c2, d2, e2, f2) {
  xh = f2;
  R = b2;
  b2.memoizedState = null;
  b2.updateQueue = null;
  b2.lanes = 0;
  vh.current = a === null || a.memoizedState === null ? Dh : Eh;
  a = c2(d2, e2);
  if (zh) {
    f2 = 0;
    do {
      zh = false;
      if (!(25 > f2))
        throw Error(y(301));
      f2 += 1;
      T = S = null;
      b2.updateQueue = null;
      vh.current = Fh;
      a = c2(d2, e2);
    } while (zh);
  }
  vh.current = Gh;
  b2 = S !== null && S.next !== null;
  xh = 0;
  T = S = R = null;
  yh = false;
  if (b2)
    throw Error(y(300));
  return a;
}
function Hh() {
  var a = { memoizedState: null, baseState: null, baseQueue: null, queue: null, next: null };
  T === null ? R.memoizedState = T = a : T = T.next = a;
  return T;
}
function Ih() {
  if (S === null) {
    var a = R.alternate;
    a = a !== null ? a.memoizedState : null;
  } else
    a = S.next;
  var b2 = T === null ? R.memoizedState : T.next;
  if (b2 !== null)
    T = b2, S = a;
  else {
    if (a === null)
      throw Error(y(310));
    S = a;
    a = { memoizedState: S.memoizedState, baseState: S.baseState, baseQueue: S.baseQueue, queue: S.queue, next: null };
    T === null ? R.memoizedState = T = a : T = T.next = a;
  }
  return T;
}
function Jh(a, b2) {
  return typeof b2 === "function" ? b2(a) : b2;
}
function Kh(a) {
  var b2 = Ih(), c2 = b2.queue;
  if (c2 === null)
    throw Error(y(311));
  c2.lastRenderedReducer = a;
  var d2 = S, e2 = d2.baseQueue, f2 = c2.pending;
  if (f2 !== null) {
    if (e2 !== null) {
      var g2 = e2.next;
      e2.next = f2.next;
      f2.next = g2;
    }
    d2.baseQueue = e2 = f2;
    c2.pending = null;
  }
  if (e2 !== null) {
    e2 = e2.next;
    d2 = d2.baseState;
    var h = g2 = f2 = null, k2 = e2;
    do {
      var l2 = k2.lane;
      if ((xh & l2) === l2)
        h !== null && (h = h.next = { lane: 0, action: k2.action, eagerReducer: k2.eagerReducer, eagerState: k2.eagerState, next: null }), d2 = k2.eagerReducer === a ? k2.eagerState : a(d2, k2.action);
      else {
        var n2 = {
          lane: l2,
          action: k2.action,
          eagerReducer: k2.eagerReducer,
          eagerState: k2.eagerState,
          next: null
        };
        h === null ? (g2 = h = n2, f2 = d2) : h = h.next = n2;
        R.lanes |= l2;
        Dg |= l2;
      }
      k2 = k2.next;
    } while (k2 !== null && k2 !== e2);
    h === null ? f2 = d2 : h.next = g2;
    He(d2, b2.memoizedState) || (ug = true);
    b2.memoizedState = d2;
    b2.baseState = f2;
    b2.baseQueue = h;
    c2.lastRenderedState = d2;
  }
  return [b2.memoizedState, c2.dispatch];
}
function Lh(a) {
  var b2 = Ih(), c2 = b2.queue;
  if (c2 === null)
    throw Error(y(311));
  c2.lastRenderedReducer = a;
  var d2 = c2.dispatch, e2 = c2.pending, f2 = b2.memoizedState;
  if (e2 !== null) {
    c2.pending = null;
    var g2 = e2 = e2.next;
    do
      f2 = a(f2, g2.action), g2 = g2.next;
    while (g2 !== e2);
    He(f2, b2.memoizedState) || (ug = true);
    b2.memoizedState = f2;
    b2.baseQueue === null && (b2.baseState = f2);
    c2.lastRenderedState = f2;
  }
  return [f2, d2];
}
function Mh(a, b2, c2) {
  var d2 = b2._getVersion;
  d2 = d2(b2._source);
  var e2 = b2._workInProgressVersionPrimary;
  if (e2 !== null)
    a = e2 === d2;
  else if (a = a.mutableReadLanes, a = (xh & a) === a)
    b2._workInProgressVersionPrimary = d2, th.push(b2);
  if (a)
    return c2(b2._source);
  th.push(b2);
  throw Error(y(350));
}
function Nh(a, b2, c2, d2) {
  var e2 = U;
  if (e2 === null)
    throw Error(y(349));
  var f2 = b2._getVersion, g2 = f2(b2._source), h = vh.current, k2 = h.useState(function() {
    return Mh(e2, b2, c2);
  }), l2 = k2[1], n2 = k2[0];
  k2 = T;
  var A2 = a.memoizedState, p2 = A2.refs, C = p2.getSnapshot, x2 = A2.source;
  A2 = A2.subscribe;
  var w2 = R;
  a.memoizedState = { refs: p2, source: b2, subscribe: d2 };
  h.useEffect(function() {
    p2.getSnapshot = c2;
    p2.setSnapshot = l2;
    var a2 = f2(b2._source);
    if (!He(g2, a2)) {
      a2 = c2(b2._source);
      He(n2, a2) || (l2(a2), a2 = Ig(w2), e2.mutableReadLanes |= a2 & e2.pendingLanes);
      a2 = e2.mutableReadLanes;
      e2.entangledLanes |= a2;
      for (var d3 = e2.entanglements, h2 = a2; 0 < h2; ) {
        var k3 = 31 - Vc(h2), v4 = 1 << k3;
        d3[k3] |= a2;
        h2 &= ~v4;
      }
    }
  }, [c2, b2, d2]);
  h.useEffect(function() {
    return d2(b2._source, function() {
      var a2 = p2.getSnapshot, c3 = p2.setSnapshot;
      try {
        c3(a2(b2._source));
        var d3 = Ig(w2);
        e2.mutableReadLanes |= d3 & e2.pendingLanes;
      } catch (q2) {
        c3(function() {
          throw q2;
        });
      }
    });
  }, [b2, d2]);
  He(C, c2) && He(x2, b2) && He(A2, d2) || (a = { pending: null, dispatch: null, lastRenderedReducer: Jh, lastRenderedState: n2 }, a.dispatch = l2 = Oh.bind(null, R, a), k2.queue = a, k2.baseQueue = null, n2 = Mh(e2, b2, c2), k2.memoizedState = k2.baseState = n2);
  return n2;
}
function Ph(a, b2, c2) {
  var d2 = Ih();
  return Nh(d2, a, b2, c2);
}
function Qh(a) {
  var b2 = Hh();
  typeof a === "function" && (a = a());
  b2.memoizedState = b2.baseState = a;
  a = b2.queue = { pending: null, dispatch: null, lastRenderedReducer: Jh, lastRenderedState: a };
  a = a.dispatch = Oh.bind(null, R, a);
  return [b2.memoizedState, a];
}
function Rh(a, b2, c2, d2) {
  a = { tag: a, create: b2, destroy: c2, deps: d2, next: null };
  b2 = R.updateQueue;
  b2 === null ? (b2 = { lastEffect: null }, R.updateQueue = b2, b2.lastEffect = a.next = a) : (c2 = b2.lastEffect, c2 === null ? b2.lastEffect = a.next = a : (d2 = c2.next, c2.next = a, a.next = d2, b2.lastEffect = a));
  return a;
}
function Sh(a) {
  var b2 = Hh();
  a = { current: a };
  return b2.memoizedState = a;
}
function Th() {
  return Ih().memoizedState;
}
function Uh(a, b2, c2, d2) {
  var e2 = Hh();
  R.flags |= a;
  e2.memoizedState = Rh(1 | b2, c2, void 0, d2 === void 0 ? null : d2);
}
function Vh(a, b2, c2, d2) {
  var e2 = Ih();
  d2 = d2 === void 0 ? null : d2;
  var f2 = void 0;
  if (S !== null) {
    var g2 = S.memoizedState;
    f2 = g2.destroy;
    if (d2 !== null && Bh(d2, g2.deps)) {
      Rh(b2, c2, f2, d2);
      return;
    }
  }
  R.flags |= a;
  e2.memoizedState = Rh(1 | b2, c2, f2, d2);
}
function Wh(a, b2) {
  return Uh(516, 4, a, b2);
}
function Xh(a, b2) {
  return Vh(516, 4, a, b2);
}
function Yh(a, b2) {
  return Vh(4, 2, a, b2);
}
function Zh(a, b2) {
  if (typeof b2 === "function")
    return a = a(), b2(a), function() {
      b2(null);
    };
  if (b2 !== null && b2 !== void 0)
    return a = a(), b2.current = a, function() {
      b2.current = null;
    };
}
function $h(a, b2, c2) {
  c2 = c2 !== null && c2 !== void 0 ? c2.concat([a]) : null;
  return Vh(4, 2, Zh.bind(null, b2, a), c2);
}
function ai() {
}
function bi(a, b2) {
  var c2 = Ih();
  b2 = b2 === void 0 ? null : b2;
  var d2 = c2.memoizedState;
  if (d2 !== null && b2 !== null && Bh(b2, d2[1]))
    return d2[0];
  c2.memoizedState = [a, b2];
  return a;
}
function ci(a, b2) {
  var c2 = Ih();
  b2 = b2 === void 0 ? null : b2;
  var d2 = c2.memoizedState;
  if (d2 !== null && b2 !== null && Bh(b2, d2[1]))
    return d2[0];
  a = a();
  c2.memoizedState = [a, b2];
  return a;
}
function di(a, b2) {
  var c2 = eg();
  gg(98 > c2 ? 98 : c2, function() {
    a(true);
  });
  gg(97 < c2 ? 97 : c2, function() {
    var c3 = wh.transition;
    wh.transition = 1;
    try {
      a(false), b2();
    } finally {
      wh.transition = c3;
    }
  });
}
function Oh(a, b2, c2) {
  var d2 = Hg(), e2 = Ig(a), f2 = { lane: e2, action: c2, eagerReducer: null, eagerState: null, next: null }, g2 = b2.pending;
  g2 === null ? f2.next = f2 : (f2.next = g2.next, g2.next = f2);
  b2.pending = f2;
  g2 = a.alternate;
  if (a === R || g2 !== null && g2 === R)
    zh = yh = true;
  else {
    if (a.lanes === 0 && (g2 === null || g2.lanes === 0) && (g2 = b2.lastRenderedReducer, g2 !== null))
      try {
        var h = b2.lastRenderedState, k2 = g2(h, c2);
        f2.eagerReducer = g2;
        f2.eagerState = k2;
        if (He(k2, h))
          return;
      } catch (l2) {
      } finally {
      }
    Jg(a, e2, d2);
  }
}
var Gh = { readContext: vg, useCallback: Ah, useContext: Ah, useEffect: Ah, useImperativeHandle: Ah, useLayoutEffect: Ah, useMemo: Ah, useReducer: Ah, useRef: Ah, useState: Ah, useDebugValue: Ah, useDeferredValue: Ah, useTransition: Ah, useMutableSource: Ah, useOpaqueIdentifier: Ah, unstable_isNewReconciler: false }, Dh = { readContext: vg, useCallback: function(a, b2) {
  Hh().memoizedState = [a, b2 === void 0 ? null : b2];
  return a;
}, useContext: vg, useEffect: Wh, useImperativeHandle: function(a, b2, c2) {
  c2 = c2 !== null && c2 !== void 0 ? c2.concat([a]) : null;
  return Uh(4, 2, Zh.bind(null, b2, a), c2);
}, useLayoutEffect: function(a, b2) {
  return Uh(4, 2, a, b2);
}, useMemo: function(a, b2) {
  var c2 = Hh();
  b2 = b2 === void 0 ? null : b2;
  a = a();
  c2.memoizedState = [a, b2];
  return a;
}, useReducer: function(a, b2, c2) {
  var d2 = Hh();
  b2 = c2 !== void 0 ? c2(b2) : b2;
  d2.memoizedState = d2.baseState = b2;
  a = d2.queue = { pending: null, dispatch: null, lastRenderedReducer: a, lastRenderedState: b2 };
  a = a.dispatch = Oh.bind(null, R, a);
  return [d2.memoizedState, a];
}, useRef: Sh, useState: Qh, useDebugValue: ai, useDeferredValue: function(a) {
  var b2 = Qh(a), c2 = b2[0], d2 = b2[1];
  Wh(function() {
    var b3 = wh.transition;
    wh.transition = 1;
    try {
      d2(a);
    } finally {
      wh.transition = b3;
    }
  }, [a]);
  return c2;
}, useTransition: function() {
  var a = Qh(false), b2 = a[0];
  a = di.bind(null, a[1]);
  Sh(a);
  return [a, b2];
}, useMutableSource: function(a, b2, c2) {
  var d2 = Hh();
  d2.memoizedState = { refs: { getSnapshot: b2, setSnapshot: null }, source: a, subscribe: c2 };
  return Nh(d2, a, b2, c2);
}, useOpaqueIdentifier: function() {
  if (lh) {
    var a = false, b2 = uf(function() {
      a || (a = true, c2("r:" + (tf++).toString(36)));
      throw Error(y(355));
    }), c2 = Qh(b2)[1];
    (R.mode & 2) === 0 && (R.flags |= 516, Rh(5, function() {
      c2("r:" + (tf++).toString(36));
    }, void 0, null));
    return b2;
  }
  b2 = "r:" + (tf++).toString(36);
  Qh(b2);
  return b2;
}, unstable_isNewReconciler: false }, Eh = { readContext: vg, useCallback: bi, useContext: vg, useEffect: Xh, useImperativeHandle: $h, useLayoutEffect: Yh, useMemo: ci, useReducer: Kh, useRef: Th, useState: function() {
  return Kh(Jh);
}, useDebugValue: ai, useDeferredValue: function(a) {
  var b2 = Kh(Jh), c2 = b2[0], d2 = b2[1];
  Xh(function() {
    var b3 = wh.transition;
    wh.transition = 1;
    try {
      d2(a);
    } finally {
      wh.transition = b3;
    }
  }, [a]);
  return c2;
}, useTransition: function() {
  var a = Kh(Jh)[0];
  return [
    Th().current,
    a
  ];
}, useMutableSource: Ph, useOpaqueIdentifier: function() {
  return Kh(Jh)[0];
}, unstable_isNewReconciler: false }, Fh = { readContext: vg, useCallback: bi, useContext: vg, useEffect: Xh, useImperativeHandle: $h, useLayoutEffect: Yh, useMemo: ci, useReducer: Lh, useRef: Th, useState: function() {
  return Lh(Jh);
}, useDebugValue: ai, useDeferredValue: function(a) {
  var b2 = Lh(Jh), c2 = b2[0], d2 = b2[1];
  Xh(function() {
    var b3 = wh.transition;
    wh.transition = 1;
    try {
      d2(a);
    } finally {
      wh.transition = b3;
    }
  }, [a]);
  return c2;
}, useTransition: function() {
  var a = Lh(Jh)[0];
  return [
    Th().current,
    a
  ];
}, useMutableSource: Ph, useOpaqueIdentifier: function() {
  return Lh(Jh)[0];
}, unstable_isNewReconciler: false }, ei = ra.ReactCurrentOwner, ug = false;
function fi(a, b2, c2, d2) {
  b2.child = a === null ? Zg(b2, null, c2, d2) : Yg(b2, a.child, c2, d2);
}
function gi(a, b2, c2, d2, e2) {
  c2 = c2.render;
  var f2 = b2.ref;
  tg(b2, e2);
  d2 = Ch(a, b2, c2, d2, f2, e2);
  if (a !== null && !ug)
    return b2.updateQueue = a.updateQueue, b2.flags &= -517, a.lanes &= ~e2, hi(a, b2, e2);
  b2.flags |= 1;
  fi(a, b2, d2, e2);
  return b2.child;
}
function ii(a, b2, c2, d2, e2, f2) {
  if (a === null) {
    var g2 = c2.type;
    if (typeof g2 === "function" && !ji(g2) && g2.defaultProps === void 0 && c2.compare === null && c2.defaultProps === void 0)
      return b2.tag = 15, b2.type = g2, ki(a, b2, g2, d2, e2, f2);
    a = Vg(c2.type, null, d2, b2, b2.mode, f2);
    a.ref = b2.ref;
    a.return = b2;
    return b2.child = a;
  }
  g2 = a.child;
  if ((e2 & f2) === 0 && (e2 = g2.memoizedProps, c2 = c2.compare, c2 = c2 !== null ? c2 : Je, c2(e2, d2) && a.ref === b2.ref))
    return hi(a, b2, f2);
  b2.flags |= 1;
  a = Tg(g2, d2);
  a.ref = b2.ref;
  a.return = b2;
  return b2.child = a;
}
function ki(a, b2, c2, d2, e2, f2) {
  if (a !== null && Je(a.memoizedProps, d2) && a.ref === b2.ref)
    if (ug = false, (f2 & e2) !== 0)
      (a.flags & 16384) !== 0 && (ug = true);
    else
      return b2.lanes = a.lanes, hi(a, b2, f2);
  return li(a, b2, c2, d2, f2);
}
function mi(a, b2, c2) {
  var d2 = b2.pendingProps, e2 = d2.children, f2 = a !== null ? a.memoizedState : null;
  if (d2.mode === "hidden" || d2.mode === "unstable-defer-without-hiding")
    if ((b2.mode & 4) === 0)
      b2.memoizedState = { baseLanes: 0 }, ni(b2, c2);
    else if ((c2 & 1073741824) !== 0)
      b2.memoizedState = { baseLanes: 0 }, ni(b2, f2 !== null ? f2.baseLanes : c2);
    else
      return a = f2 !== null ? f2.baseLanes | c2 : c2, b2.lanes = b2.childLanes = 1073741824, b2.memoizedState = { baseLanes: a }, ni(b2, a), null;
  else
    f2 !== null ? (d2 = f2.baseLanes | c2, b2.memoizedState = null) : d2 = c2, ni(b2, d2);
  fi(a, b2, e2, c2);
  return b2.child;
}
function oi(a, b2) {
  var c2 = b2.ref;
  if (a === null && c2 !== null || a !== null && a.ref !== c2)
    b2.flags |= 128;
}
function li(a, b2, c2, d2, e2) {
  var f2 = Ff(c2) ? Df : M.current;
  f2 = Ef(b2, f2);
  tg(b2, e2);
  c2 = Ch(a, b2, c2, d2, f2, e2);
  if (a !== null && !ug)
    return b2.updateQueue = a.updateQueue, b2.flags &= -517, a.lanes &= ~e2, hi(a, b2, e2);
  b2.flags |= 1;
  fi(a, b2, c2, e2);
  return b2.child;
}
function pi(a, b2, c2, d2, e2) {
  if (Ff(c2)) {
    var f2 = true;
    Jf(b2);
  } else
    f2 = false;
  tg(b2, e2);
  if (b2.stateNode === null)
    a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2), Mg(b2, c2, d2), Og(b2, c2, d2, e2), d2 = true;
  else if (a === null) {
    var g2 = b2.stateNode, h = b2.memoizedProps;
    g2.props = h;
    var k2 = g2.context, l2 = c2.contextType;
    typeof l2 === "object" && l2 !== null ? l2 = vg(l2) : (l2 = Ff(c2) ? Df : M.current, l2 = Ef(b2, l2));
    var n2 = c2.getDerivedStateFromProps, A2 = typeof n2 === "function" || typeof g2.getSnapshotBeforeUpdate === "function";
    A2 || typeof g2.UNSAFE_componentWillReceiveProps !== "function" && typeof g2.componentWillReceiveProps !== "function" || (h !== d2 || k2 !== l2) && Ng(b2, g2, d2, l2);
    wg = false;
    var p2 = b2.memoizedState;
    g2.state = p2;
    Cg(b2, d2, g2, e2);
    k2 = b2.memoizedState;
    h !== d2 || p2 !== k2 || N.current || wg ? (typeof n2 === "function" && (Gg(b2, c2, n2, d2), k2 = b2.memoizedState), (h = wg || Lg(b2, c2, h, d2, p2, k2, l2)) ? (A2 || typeof g2.UNSAFE_componentWillMount !== "function" && typeof g2.componentWillMount !== "function" || (typeof g2.componentWillMount === "function" && g2.componentWillMount(), typeof g2.UNSAFE_componentWillMount === "function" && g2.UNSAFE_componentWillMount()), typeof g2.componentDidMount === "function" && (b2.flags |= 4)) : (typeof g2.componentDidMount === "function" && (b2.flags |= 4), b2.memoizedProps = d2, b2.memoizedState = k2), g2.props = d2, g2.state = k2, g2.context = l2, d2 = h) : (typeof g2.componentDidMount === "function" && (b2.flags |= 4), d2 = false);
  } else {
    g2 = b2.stateNode;
    yg(a, b2);
    h = b2.memoizedProps;
    l2 = b2.type === b2.elementType ? h : lg(b2.type, h);
    g2.props = l2;
    A2 = b2.pendingProps;
    p2 = g2.context;
    k2 = c2.contextType;
    typeof k2 === "object" && k2 !== null ? k2 = vg(k2) : (k2 = Ff(c2) ? Df : M.current, k2 = Ef(b2, k2));
    var C = c2.getDerivedStateFromProps;
    (n2 = typeof C === "function" || typeof g2.getSnapshotBeforeUpdate === "function") || typeof g2.UNSAFE_componentWillReceiveProps !== "function" && typeof g2.componentWillReceiveProps !== "function" || (h !== A2 || p2 !== k2) && Ng(b2, g2, d2, k2);
    wg = false;
    p2 = b2.memoizedState;
    g2.state = p2;
    Cg(b2, d2, g2, e2);
    var x2 = b2.memoizedState;
    h !== A2 || p2 !== x2 || N.current || wg ? (typeof C === "function" && (Gg(b2, c2, C, d2), x2 = b2.memoizedState), (l2 = wg || Lg(b2, c2, l2, d2, p2, x2, k2)) ? (n2 || typeof g2.UNSAFE_componentWillUpdate !== "function" && typeof g2.componentWillUpdate !== "function" || (typeof g2.componentWillUpdate === "function" && g2.componentWillUpdate(d2, x2, k2), typeof g2.UNSAFE_componentWillUpdate === "function" && g2.UNSAFE_componentWillUpdate(d2, x2, k2)), typeof g2.componentDidUpdate === "function" && (b2.flags |= 4), typeof g2.getSnapshotBeforeUpdate === "function" && (b2.flags |= 256)) : (typeof g2.componentDidUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 4), typeof g2.getSnapshotBeforeUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 256), b2.memoizedProps = d2, b2.memoizedState = x2), g2.props = d2, g2.state = x2, g2.context = k2, d2 = l2) : (typeof g2.componentDidUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 4), typeof g2.getSnapshotBeforeUpdate !== "function" || h === a.memoizedProps && p2 === a.memoizedState || (b2.flags |= 256), d2 = false);
  }
  return qi(a, b2, c2, d2, f2, e2);
}
function qi(a, b2, c2, d2, e2, f2) {
  oi(a, b2);
  var g2 = (b2.flags & 64) !== 0;
  if (!d2 && !g2)
    return e2 && Kf(b2, c2, false), hi(a, b2, f2);
  d2 = b2.stateNode;
  ei.current = b2;
  var h = g2 && typeof c2.getDerivedStateFromError !== "function" ? null : d2.render();
  b2.flags |= 1;
  a !== null && g2 ? (b2.child = Yg(b2, a.child, null, f2), b2.child = Yg(b2, null, h, f2)) : fi(a, b2, h, f2);
  b2.memoizedState = d2.state;
  e2 && Kf(b2, c2, true);
  return b2.child;
}
function ri(a) {
  var b2 = a.stateNode;
  b2.pendingContext ? Hf(a, b2.pendingContext, b2.pendingContext !== b2.context) : b2.context && Hf(a, b2.context, false);
  eh(a, b2.containerInfo);
}
var si = { dehydrated: null, retryLane: 0 };
function ti(a, b2, c2) {
  var d2 = b2.pendingProps, e2 = P.current, f2 = false, g2;
  (g2 = (b2.flags & 64) !== 0) || (g2 = a !== null && a.memoizedState === null ? false : (e2 & 2) !== 0);
  g2 ? (f2 = true, b2.flags &= -65) : a !== null && a.memoizedState === null || d2.fallback === void 0 || d2.unstable_avoidThisFallback === true || (e2 |= 1);
  I(P, e2 & 1);
  if (a === null) {
    d2.fallback !== void 0 && ph(b2);
    a = d2.children;
    e2 = d2.fallback;
    if (f2)
      return a = ui(b2, a, e2, c2), b2.child.memoizedState = { baseLanes: c2 }, b2.memoizedState = si, a;
    if (typeof d2.unstable_expectedLoadTime === "number")
      return a = ui(b2, a, e2, c2), b2.child.memoizedState = { baseLanes: c2 }, b2.memoizedState = si, b2.lanes = 33554432, a;
    c2 = vi({ mode: "visible", children: a }, b2.mode, c2, null);
    c2.return = b2;
    return b2.child = c2;
  }
  if (a.memoizedState !== null) {
    if (f2)
      return d2 = wi(a, b2, d2.children, d2.fallback, c2), f2 = b2.child, e2 = a.child.memoizedState, f2.memoizedState = e2 === null ? { baseLanes: c2 } : { baseLanes: e2.baseLanes | c2 }, f2.childLanes = a.childLanes & ~c2, b2.memoizedState = si, d2;
    c2 = xi(a, b2, d2.children, c2);
    b2.memoizedState = null;
    return c2;
  }
  if (f2)
    return d2 = wi(a, b2, d2.children, d2.fallback, c2), f2 = b2.child, e2 = a.child.memoizedState, f2.memoizedState = e2 === null ? { baseLanes: c2 } : { baseLanes: e2.baseLanes | c2 }, f2.childLanes = a.childLanes & ~c2, b2.memoizedState = si, d2;
  c2 = xi(a, b2, d2.children, c2);
  b2.memoizedState = null;
  return c2;
}
function ui(a, b2, c2, d2) {
  var e2 = a.mode, f2 = a.child;
  b2 = { mode: "hidden", children: b2 };
  (e2 & 2) === 0 && f2 !== null ? (f2.childLanes = 0, f2.pendingProps = b2) : f2 = vi(b2, e2, 0, null);
  c2 = Xg(c2, e2, d2, null);
  f2.return = a;
  c2.return = a;
  f2.sibling = c2;
  a.child = f2;
  return c2;
}
function xi(a, b2, c2, d2) {
  var e2 = a.child;
  a = e2.sibling;
  c2 = Tg(e2, { mode: "visible", children: c2 });
  (b2.mode & 2) === 0 && (c2.lanes = d2);
  c2.return = b2;
  c2.sibling = null;
  a !== null && (a.nextEffect = null, a.flags = 8, b2.firstEffect = b2.lastEffect = a);
  return b2.child = c2;
}
function wi(a, b2, c2, d2, e2) {
  var f2 = b2.mode, g2 = a.child;
  a = g2.sibling;
  var h = { mode: "hidden", children: c2 };
  (f2 & 2) === 0 && b2.child !== g2 ? (c2 = b2.child, c2.childLanes = 0, c2.pendingProps = h, g2 = c2.lastEffect, g2 !== null ? (b2.firstEffect = c2.firstEffect, b2.lastEffect = g2, g2.nextEffect = null) : b2.firstEffect = b2.lastEffect = null) : c2 = Tg(g2, h);
  a !== null ? d2 = Tg(a, d2) : (d2 = Xg(d2, f2, e2, null), d2.flags |= 2);
  d2.return = b2;
  c2.return = b2;
  c2.sibling = d2;
  b2.child = c2;
  return d2;
}
function yi(a, b2) {
  a.lanes |= b2;
  var c2 = a.alternate;
  c2 !== null && (c2.lanes |= b2);
  sg(a.return, b2);
}
function zi(a, b2, c2, d2, e2, f2) {
  var g2 = a.memoizedState;
  g2 === null ? a.memoizedState = { isBackwards: b2, rendering: null, renderingStartTime: 0, last: d2, tail: c2, tailMode: e2, lastEffect: f2 } : (g2.isBackwards = b2, g2.rendering = null, g2.renderingStartTime = 0, g2.last = d2, g2.tail = c2, g2.tailMode = e2, g2.lastEffect = f2);
}
function Ai(a, b2, c2) {
  var d2 = b2.pendingProps, e2 = d2.revealOrder, f2 = d2.tail;
  fi(a, b2, d2.children, c2);
  d2 = P.current;
  if ((d2 & 2) !== 0)
    d2 = d2 & 1 | 2, b2.flags |= 64;
  else {
    if (a !== null && (a.flags & 64) !== 0)
      a:
        for (a = b2.child; a !== null; ) {
          if (a.tag === 13)
            a.memoizedState !== null && yi(a, c2);
          else if (a.tag === 19)
            yi(a, c2);
          else if (a.child !== null) {
            a.child.return = a;
            a = a.child;
            continue;
          }
          if (a === b2)
            break a;
          for (; a.sibling === null; ) {
            if (a.return === null || a.return === b2)
              break a;
            a = a.return;
          }
          a.sibling.return = a.return;
          a = a.sibling;
        }
    d2 &= 1;
  }
  I(P, d2);
  if ((b2.mode & 2) === 0)
    b2.memoizedState = null;
  else
    switch (e2) {
      case "forwards":
        c2 = b2.child;
        for (e2 = null; c2 !== null; )
          a = c2.alternate, a !== null && ih(a) === null && (e2 = c2), c2 = c2.sibling;
        c2 = e2;
        c2 === null ? (e2 = b2.child, b2.child = null) : (e2 = c2.sibling, c2.sibling = null);
        zi(b2, false, e2, c2, f2, b2.lastEffect);
        break;
      case "backwards":
        c2 = null;
        e2 = b2.child;
        for (b2.child = null; e2 !== null; ) {
          a = e2.alternate;
          if (a !== null && ih(a) === null) {
            b2.child = e2;
            break;
          }
          a = e2.sibling;
          e2.sibling = c2;
          c2 = e2;
          e2 = a;
        }
        zi(b2, true, c2, null, f2, b2.lastEffect);
        break;
      case "together":
        zi(b2, false, null, null, void 0, b2.lastEffect);
        break;
      default:
        b2.memoizedState = null;
    }
  return b2.child;
}
function hi(a, b2, c2) {
  a !== null && (b2.dependencies = a.dependencies);
  Dg |= b2.lanes;
  if ((c2 & b2.childLanes) !== 0) {
    if (a !== null && b2.child !== a.child)
      throw Error(y(153));
    if (b2.child !== null) {
      a = b2.child;
      c2 = Tg(a, a.pendingProps);
      b2.child = c2;
      for (c2.return = b2; a.sibling !== null; )
        a = a.sibling, c2 = c2.sibling = Tg(a, a.pendingProps), c2.return = b2;
      c2.sibling = null;
    }
    return b2.child;
  }
  return null;
}
var Bi, Ci, Di, Ei;
Bi = function(a, b2) {
  for (var c2 = b2.child; c2 !== null; ) {
    if (c2.tag === 5 || c2.tag === 6)
      a.appendChild(c2.stateNode);
    else if (c2.tag !== 4 && c2.child !== null) {
      c2.child.return = c2;
      c2 = c2.child;
      continue;
    }
    if (c2 === b2)
      break;
    for (; c2.sibling === null; ) {
      if (c2.return === null || c2.return === b2)
        return;
      c2 = c2.return;
    }
    c2.sibling.return = c2.return;
    c2 = c2.sibling;
  }
};
Ci = function() {
};
Di = function(a, b2, c2, d2) {
  var e2 = a.memoizedProps;
  if (e2 !== d2) {
    a = b2.stateNode;
    dh(ah.current);
    var f2 = null;
    switch (c2) {
      case "input":
        e2 = Ya(a, e2);
        d2 = Ya(a, d2);
        f2 = [];
        break;
      case "option":
        e2 = eb(a, e2);
        d2 = eb(a, d2);
        f2 = [];
        break;
      case "select":
        e2 = m$1({}, e2, { value: void 0 });
        d2 = m$1({}, d2, { value: void 0 });
        f2 = [];
        break;
      case "textarea":
        e2 = gb(a, e2);
        d2 = gb(a, d2);
        f2 = [];
        break;
      default:
        typeof e2.onClick !== "function" && typeof d2.onClick === "function" && (a.onclick = jf);
    }
    vb(c2, d2);
    var g2;
    c2 = null;
    for (l2 in e2)
      if (!d2.hasOwnProperty(l2) && e2.hasOwnProperty(l2) && e2[l2] != null)
        if (l2 === "style") {
          var h = e2[l2];
          for (g2 in h)
            h.hasOwnProperty(g2) && (c2 || (c2 = {}), c2[g2] = "");
        } else
          l2 !== "dangerouslySetInnerHTML" && l2 !== "children" && l2 !== "suppressContentEditableWarning" && l2 !== "suppressHydrationWarning" && l2 !== "autoFocus" && (ca.hasOwnProperty(l2) ? f2 || (f2 = []) : (f2 = f2 || []).push(l2, null));
    for (l2 in d2) {
      var k2 = d2[l2];
      h = e2 != null ? e2[l2] : void 0;
      if (d2.hasOwnProperty(l2) && k2 !== h && (k2 != null || h != null))
        if (l2 === "style")
          if (h) {
            for (g2 in h)
              !h.hasOwnProperty(g2) || k2 && k2.hasOwnProperty(g2) || (c2 || (c2 = {}), c2[g2] = "");
            for (g2 in k2)
              k2.hasOwnProperty(g2) && h[g2] !== k2[g2] && (c2 || (c2 = {}), c2[g2] = k2[g2]);
          } else
            c2 || (f2 || (f2 = []), f2.push(l2, c2)), c2 = k2;
        else
          l2 === "dangerouslySetInnerHTML" ? (k2 = k2 ? k2.__html : void 0, h = h ? h.__html : void 0, k2 != null && h !== k2 && (f2 = f2 || []).push(l2, k2)) : l2 === "children" ? typeof k2 !== "string" && typeof k2 !== "number" || (f2 = f2 || []).push(l2, "" + k2) : l2 !== "suppressContentEditableWarning" && l2 !== "suppressHydrationWarning" && (ca.hasOwnProperty(l2) ? (k2 != null && l2 === "onScroll" && G("scroll", a), f2 || h === k2 || (f2 = [])) : typeof k2 === "object" && k2 !== null && k2.$$typeof === Ga ? k2.toString() : (f2 = f2 || []).push(l2, k2));
    }
    c2 && (f2 = f2 || []).push("style", c2);
    var l2 = f2;
    if (b2.updateQueue = l2)
      b2.flags |= 4;
  }
};
Ei = function(a, b2, c2, d2) {
  c2 !== d2 && (b2.flags |= 4);
};
function Fi(a, b2) {
  if (!lh)
    switch (a.tailMode) {
      case "hidden":
        b2 = a.tail;
        for (var c2 = null; b2 !== null; )
          b2.alternate !== null && (c2 = b2), b2 = b2.sibling;
        c2 === null ? a.tail = null : c2.sibling = null;
        break;
      case "collapsed":
        c2 = a.tail;
        for (var d2 = null; c2 !== null; )
          c2.alternate !== null && (d2 = c2), c2 = c2.sibling;
        d2 === null ? b2 || a.tail === null ? a.tail = null : a.tail.sibling = null : d2.sibling = null;
    }
}
function Gi(a, b2, c2) {
  var d2 = b2.pendingProps;
  switch (b2.tag) {
    case 2:
    case 16:
    case 15:
    case 0:
    case 11:
    case 7:
    case 8:
    case 12:
    case 9:
    case 14:
      return null;
    case 1:
      return Ff(b2.type) && Gf(), null;
    case 3:
      fh();
      H(N);
      H(M);
      uh();
      d2 = b2.stateNode;
      d2.pendingContext && (d2.context = d2.pendingContext, d2.pendingContext = null);
      if (a === null || a.child === null)
        rh(b2) ? b2.flags |= 4 : d2.hydrate || (b2.flags |= 256);
      Ci(b2);
      return null;
    case 5:
      hh(b2);
      var e2 = dh(ch.current);
      c2 = b2.type;
      if (a !== null && b2.stateNode != null)
        Di(a, b2, c2, d2, e2), a.ref !== b2.ref && (b2.flags |= 128);
      else {
        if (!d2) {
          if (b2.stateNode === null)
            throw Error(y(166));
          return null;
        }
        a = dh(ah.current);
        if (rh(b2)) {
          d2 = b2.stateNode;
          c2 = b2.type;
          var f2 = b2.memoizedProps;
          d2[wf] = b2;
          d2[xf] = f2;
          switch (c2) {
            case "dialog":
              G("cancel", d2);
              G("close", d2);
              break;
            case "iframe":
            case "object":
            case "embed":
              G("load", d2);
              break;
            case "video":
            case "audio":
              for (a = 0; a < Xe.length; a++)
                G(Xe[a], d2);
              break;
            case "source":
              G("error", d2);
              break;
            case "img":
            case "image":
            case "link":
              G("error", d2);
              G("load", d2);
              break;
            case "details":
              G("toggle", d2);
              break;
            case "input":
              Za(d2, f2);
              G("invalid", d2);
              break;
            case "select":
              d2._wrapperState = { wasMultiple: !!f2.multiple };
              G("invalid", d2);
              break;
            case "textarea":
              hb(d2, f2), G("invalid", d2);
          }
          vb(c2, f2);
          a = null;
          for (var g2 in f2)
            f2.hasOwnProperty(g2) && (e2 = f2[g2], g2 === "children" ? typeof e2 === "string" ? d2.textContent !== e2 && (a = ["children", e2]) : typeof e2 === "number" && d2.textContent !== "" + e2 && (a = ["children", "" + e2]) : ca.hasOwnProperty(g2) && e2 != null && g2 === "onScroll" && G("scroll", d2));
          switch (c2) {
            case "input":
              Va(d2);
              cb(d2, f2, true);
              break;
            case "textarea":
              Va(d2);
              jb(d2);
              break;
            case "select":
            case "option":
              break;
            default:
              typeof f2.onClick === "function" && (d2.onclick = jf);
          }
          d2 = a;
          b2.updateQueue = d2;
          d2 !== null && (b2.flags |= 4);
        } else {
          g2 = e2.nodeType === 9 ? e2 : e2.ownerDocument;
          a === kb.html && (a = lb(c2));
          a === kb.html ? c2 === "script" ? (a = g2.createElement("div"), a.innerHTML = "<script><\/script>", a = a.removeChild(a.firstChild)) : typeof d2.is === "string" ? a = g2.createElement(c2, { is: d2.is }) : (a = g2.createElement(c2), c2 === "select" && (g2 = a, d2.multiple ? g2.multiple = true : d2.size && (g2.size = d2.size))) : a = g2.createElementNS(a, c2);
          a[wf] = b2;
          a[xf] = d2;
          Bi(a, b2, false, false);
          b2.stateNode = a;
          g2 = wb(c2, d2);
          switch (c2) {
            case "dialog":
              G("cancel", a);
              G("close", a);
              e2 = d2;
              break;
            case "iframe":
            case "object":
            case "embed":
              G("load", a);
              e2 = d2;
              break;
            case "video":
            case "audio":
              for (e2 = 0; e2 < Xe.length; e2++)
                G(Xe[e2], a);
              e2 = d2;
              break;
            case "source":
              G("error", a);
              e2 = d2;
              break;
            case "img":
            case "image":
            case "link":
              G("error", a);
              G("load", a);
              e2 = d2;
              break;
            case "details":
              G("toggle", a);
              e2 = d2;
              break;
            case "input":
              Za(a, d2);
              e2 = Ya(a, d2);
              G("invalid", a);
              break;
            case "option":
              e2 = eb(a, d2);
              break;
            case "select":
              a._wrapperState = { wasMultiple: !!d2.multiple };
              e2 = m$1({}, d2, { value: void 0 });
              G("invalid", a);
              break;
            case "textarea":
              hb(a, d2);
              e2 = gb(a, d2);
              G("invalid", a);
              break;
            default:
              e2 = d2;
          }
          vb(c2, e2);
          var h = e2;
          for (f2 in h)
            if (h.hasOwnProperty(f2)) {
              var k2 = h[f2];
              f2 === "style" ? tb(a, k2) : f2 === "dangerouslySetInnerHTML" ? (k2 = k2 ? k2.__html : void 0, k2 != null && ob(a, k2)) : f2 === "children" ? typeof k2 === "string" ? (c2 !== "textarea" || k2 !== "") && pb(a, k2) : typeof k2 === "number" && pb(a, "" + k2) : f2 !== "suppressContentEditableWarning" && f2 !== "suppressHydrationWarning" && f2 !== "autoFocus" && (ca.hasOwnProperty(f2) ? k2 != null && f2 === "onScroll" && G("scroll", a) : k2 != null && qa(a, f2, k2, g2));
            }
          switch (c2) {
            case "input":
              Va(a);
              cb(a, d2, false);
              break;
            case "textarea":
              Va(a);
              jb(a);
              break;
            case "option":
              d2.value != null && a.setAttribute("value", "" + Sa(d2.value));
              break;
            case "select":
              a.multiple = !!d2.multiple;
              f2 = d2.value;
              f2 != null ? fb(a, !!d2.multiple, f2, false) : d2.defaultValue != null && fb(a, !!d2.multiple, d2.defaultValue, true);
              break;
            default:
              typeof e2.onClick === "function" && (a.onclick = jf);
          }
          mf(c2, d2) && (b2.flags |= 4);
        }
        b2.ref !== null && (b2.flags |= 128);
      }
      return null;
    case 6:
      if (a && b2.stateNode != null)
        Ei(a, b2, a.memoizedProps, d2);
      else {
        if (typeof d2 !== "string" && b2.stateNode === null)
          throw Error(y(166));
        c2 = dh(ch.current);
        dh(ah.current);
        rh(b2) ? (d2 = b2.stateNode, c2 = b2.memoizedProps, d2[wf] = b2, d2.nodeValue !== c2 && (b2.flags |= 4)) : (d2 = (c2.nodeType === 9 ? c2 : c2.ownerDocument).createTextNode(d2), d2[wf] = b2, b2.stateNode = d2);
      }
      return null;
    case 13:
      H(P);
      d2 = b2.memoizedState;
      if ((b2.flags & 64) !== 0)
        return b2.lanes = c2, b2;
      d2 = d2 !== null;
      c2 = false;
      a === null ? b2.memoizedProps.fallback !== void 0 && rh(b2) : c2 = a.memoizedState !== null;
      if (d2 && !c2 && (b2.mode & 2) !== 0)
        if (a === null && b2.memoizedProps.unstable_avoidThisFallback !== true || (P.current & 1) !== 0)
          V === 0 && (V = 3);
        else {
          if (V === 0 || V === 3)
            V = 4;
          U === null || (Dg & 134217727) === 0 && (Hi & 134217727) === 0 || Ii(U, W);
        }
      if (d2 || c2)
        b2.flags |= 4;
      return null;
    case 4:
      return fh(), Ci(b2), a === null && cf(b2.stateNode.containerInfo), null;
    case 10:
      return rg(b2), null;
    case 17:
      return Ff(b2.type) && Gf(), null;
    case 19:
      H(P);
      d2 = b2.memoizedState;
      if (d2 === null)
        return null;
      f2 = (b2.flags & 64) !== 0;
      g2 = d2.rendering;
      if (g2 === null)
        if (f2)
          Fi(d2, false);
        else {
          if (V !== 0 || a !== null && (a.flags & 64) !== 0)
            for (a = b2.child; a !== null; ) {
              g2 = ih(a);
              if (g2 !== null) {
                b2.flags |= 64;
                Fi(d2, false);
                f2 = g2.updateQueue;
                f2 !== null && (b2.updateQueue = f2, b2.flags |= 4);
                d2.lastEffect === null && (b2.firstEffect = null);
                b2.lastEffect = d2.lastEffect;
                d2 = c2;
                for (c2 = b2.child; c2 !== null; )
                  f2 = c2, a = d2, f2.flags &= 2, f2.nextEffect = null, f2.firstEffect = null, f2.lastEffect = null, g2 = f2.alternate, g2 === null ? (f2.childLanes = 0, f2.lanes = a, f2.child = null, f2.memoizedProps = null, f2.memoizedState = null, f2.updateQueue = null, f2.dependencies = null, f2.stateNode = null) : (f2.childLanes = g2.childLanes, f2.lanes = g2.lanes, f2.child = g2.child, f2.memoizedProps = g2.memoizedProps, f2.memoizedState = g2.memoizedState, f2.updateQueue = g2.updateQueue, f2.type = g2.type, a = g2.dependencies, f2.dependencies = a === null ? null : { lanes: a.lanes, firstContext: a.firstContext }), c2 = c2.sibling;
                I(P, P.current & 1 | 2);
                return b2.child;
              }
              a = a.sibling;
            }
          d2.tail !== null && O() > Ji && (b2.flags |= 64, f2 = true, Fi(d2, false), b2.lanes = 33554432);
        }
      else {
        if (!f2)
          if (a = ih(g2), a !== null) {
            if (b2.flags |= 64, f2 = true, c2 = a.updateQueue, c2 !== null && (b2.updateQueue = c2, b2.flags |= 4), Fi(d2, true), d2.tail === null && d2.tailMode === "hidden" && !g2.alternate && !lh)
              return b2 = b2.lastEffect = d2.lastEffect, b2 !== null && (b2.nextEffect = null), null;
          } else
            2 * O() - d2.renderingStartTime > Ji && c2 !== 1073741824 && (b2.flags |= 64, f2 = true, Fi(d2, false), b2.lanes = 33554432);
        d2.isBackwards ? (g2.sibling = b2.child, b2.child = g2) : (c2 = d2.last, c2 !== null ? c2.sibling = g2 : b2.child = g2, d2.last = g2);
      }
      return d2.tail !== null ? (c2 = d2.tail, d2.rendering = c2, d2.tail = c2.sibling, d2.lastEffect = b2.lastEffect, d2.renderingStartTime = O(), c2.sibling = null, b2 = P.current, I(P, f2 ? b2 & 1 | 2 : b2 & 1), c2) : null;
    case 23:
    case 24:
      return Ki(), a !== null && a.memoizedState !== null !== (b2.memoizedState !== null) && d2.mode !== "unstable-defer-without-hiding" && (b2.flags |= 4), null;
  }
  throw Error(y(156, b2.tag));
}
function Li(a) {
  switch (a.tag) {
    case 1:
      Ff(a.type) && Gf();
      var b2 = a.flags;
      return b2 & 4096 ? (a.flags = b2 & -4097 | 64, a) : null;
    case 3:
      fh();
      H(N);
      H(M);
      uh();
      b2 = a.flags;
      if ((b2 & 64) !== 0)
        throw Error(y(285));
      a.flags = b2 & -4097 | 64;
      return a;
    case 5:
      return hh(a), null;
    case 13:
      return H(P), b2 = a.flags, b2 & 4096 ? (a.flags = b2 & -4097 | 64, a) : null;
    case 19:
      return H(P), null;
    case 4:
      return fh(), null;
    case 10:
      return rg(a), null;
    case 23:
    case 24:
      return Ki(), null;
    default:
      return null;
  }
}
function Mi(a, b2) {
  try {
    var c2 = "", d2 = b2;
    do
      c2 += Qa(d2), d2 = d2.return;
    while (d2);
    var e2 = c2;
  } catch (f2) {
    e2 = "\nError generating stack: " + f2.message + "\n" + f2.stack;
  }
  return { value: a, source: b2, stack: e2 };
}
function Ni(a, b2) {
  try {
    console.error(b2.value);
  } catch (c2) {
    setTimeout(function() {
      throw c2;
    });
  }
}
var Oi = typeof WeakMap === "function" ? WeakMap : Map;
function Pi(a, b2, c2) {
  c2 = zg(-1, c2);
  c2.tag = 3;
  c2.payload = { element: null };
  var d2 = b2.value;
  c2.callback = function() {
    Qi || (Qi = true, Ri = d2);
    Ni(a, b2);
  };
  return c2;
}
function Si(a, b2, c2) {
  c2 = zg(-1, c2);
  c2.tag = 3;
  var d2 = a.type.getDerivedStateFromError;
  if (typeof d2 === "function") {
    var e2 = b2.value;
    c2.payload = function() {
      Ni(a, b2);
      return d2(e2);
    };
  }
  var f2 = a.stateNode;
  f2 !== null && typeof f2.componentDidCatch === "function" && (c2.callback = function() {
    typeof d2 !== "function" && (Ti === null ? Ti = /* @__PURE__ */ new Set([this]) : Ti.add(this), Ni(a, b2));
    var c3 = b2.stack;
    this.componentDidCatch(b2.value, { componentStack: c3 !== null ? c3 : "" });
  });
  return c2;
}
var Ui = typeof WeakSet === "function" ? WeakSet : Set;
function Vi(a) {
  var b2 = a.ref;
  if (b2 !== null)
    if (typeof b2 === "function")
      try {
        b2(null);
      } catch (c2) {
        Wi(a, c2);
      }
    else
      b2.current = null;
}
function Xi(a, b2) {
  switch (b2.tag) {
    case 0:
    case 11:
    case 15:
    case 22:
      return;
    case 1:
      if (b2.flags & 256 && a !== null) {
        var c2 = a.memoizedProps, d2 = a.memoizedState;
        a = b2.stateNode;
        b2 = a.getSnapshotBeforeUpdate(b2.elementType === b2.type ? c2 : lg(b2.type, c2), d2);
        a.__reactInternalSnapshotBeforeUpdate = b2;
      }
      return;
    case 3:
      b2.flags & 256 && qf(b2.stateNode.containerInfo);
      return;
    case 5:
    case 6:
    case 4:
    case 17:
      return;
  }
  throw Error(y(163));
}
function Yi(a, b2, c2) {
  switch (c2.tag) {
    case 0:
    case 11:
    case 15:
    case 22:
      b2 = c2.updateQueue;
      b2 = b2 !== null ? b2.lastEffect : null;
      if (b2 !== null) {
        a = b2 = b2.next;
        do {
          if ((a.tag & 3) === 3) {
            var d2 = a.create;
            a.destroy = d2();
          }
          a = a.next;
        } while (a !== b2);
      }
      b2 = c2.updateQueue;
      b2 = b2 !== null ? b2.lastEffect : null;
      if (b2 !== null) {
        a = b2 = b2.next;
        do {
          var e2 = a;
          d2 = e2.next;
          e2 = e2.tag;
          (e2 & 4) !== 0 && (e2 & 1) !== 0 && (Zi(c2, a), $i(c2, a));
          a = d2;
        } while (a !== b2);
      }
      return;
    case 1:
      a = c2.stateNode;
      c2.flags & 4 && (b2 === null ? a.componentDidMount() : (d2 = c2.elementType === c2.type ? b2.memoizedProps : lg(c2.type, b2.memoizedProps), a.componentDidUpdate(d2, b2.memoizedState, a.__reactInternalSnapshotBeforeUpdate)));
      b2 = c2.updateQueue;
      b2 !== null && Eg(c2, b2, a);
      return;
    case 3:
      b2 = c2.updateQueue;
      if (b2 !== null) {
        a = null;
        if (c2.child !== null)
          switch (c2.child.tag) {
            case 5:
              a = c2.child.stateNode;
              break;
            case 1:
              a = c2.child.stateNode;
          }
        Eg(c2, b2, a);
      }
      return;
    case 5:
      a = c2.stateNode;
      b2 === null && c2.flags & 4 && mf(c2.type, c2.memoizedProps) && a.focus();
      return;
    case 6:
      return;
    case 4:
      return;
    case 12:
      return;
    case 13:
      c2.memoizedState === null && (c2 = c2.alternate, c2 !== null && (c2 = c2.memoizedState, c2 !== null && (c2 = c2.dehydrated, c2 !== null && Cc(c2))));
      return;
    case 19:
    case 17:
    case 20:
    case 21:
    case 23:
    case 24:
      return;
  }
  throw Error(y(163));
}
function aj(a, b2) {
  for (var c2 = a; ; ) {
    if (c2.tag === 5) {
      var d2 = c2.stateNode;
      if (b2)
        d2 = d2.style, typeof d2.setProperty === "function" ? d2.setProperty("display", "none", "important") : d2.display = "none";
      else {
        d2 = c2.stateNode;
        var e2 = c2.memoizedProps.style;
        e2 = e2 !== void 0 && e2 !== null && e2.hasOwnProperty("display") ? e2.display : null;
        d2.style.display = sb("display", e2);
      }
    } else if (c2.tag === 6)
      c2.stateNode.nodeValue = b2 ? "" : c2.memoizedProps;
    else if ((c2.tag !== 23 && c2.tag !== 24 || c2.memoizedState === null || c2 === a) && c2.child !== null) {
      c2.child.return = c2;
      c2 = c2.child;
      continue;
    }
    if (c2 === a)
      break;
    for (; c2.sibling === null; ) {
      if (c2.return === null || c2.return === a)
        return;
      c2 = c2.return;
    }
    c2.sibling.return = c2.return;
    c2 = c2.sibling;
  }
}
function bj(a, b2) {
  if (Mf && typeof Mf.onCommitFiberUnmount === "function")
    try {
      Mf.onCommitFiberUnmount(Lf, b2);
    } catch (f2) {
    }
  switch (b2.tag) {
    case 0:
    case 11:
    case 14:
    case 15:
    case 22:
      a = b2.updateQueue;
      if (a !== null && (a = a.lastEffect, a !== null)) {
        var c2 = a = a.next;
        do {
          var d2 = c2, e2 = d2.destroy;
          d2 = d2.tag;
          if (e2 !== void 0)
            if ((d2 & 4) !== 0)
              Zi(b2, c2);
            else {
              d2 = b2;
              try {
                e2();
              } catch (f2) {
                Wi(d2, f2);
              }
            }
          c2 = c2.next;
        } while (c2 !== a);
      }
      break;
    case 1:
      Vi(b2);
      a = b2.stateNode;
      if (typeof a.componentWillUnmount === "function")
        try {
          a.props = b2.memoizedProps, a.state = b2.memoizedState, a.componentWillUnmount();
        } catch (f2) {
          Wi(b2, f2);
        }
      break;
    case 5:
      Vi(b2);
      break;
    case 4:
      cj(a, b2);
  }
}
function dj(a) {
  a.alternate = null;
  a.child = null;
  a.dependencies = null;
  a.firstEffect = null;
  a.lastEffect = null;
  a.memoizedProps = null;
  a.memoizedState = null;
  a.pendingProps = null;
  a.return = null;
  a.updateQueue = null;
}
function ej(a) {
  return a.tag === 5 || a.tag === 3 || a.tag === 4;
}
function fj(a) {
  a: {
    for (var b2 = a.return; b2 !== null; ) {
      if (ej(b2))
        break a;
      b2 = b2.return;
    }
    throw Error(y(160));
  }
  var c2 = b2;
  b2 = c2.stateNode;
  switch (c2.tag) {
    case 5:
      var d2 = false;
      break;
    case 3:
      b2 = b2.containerInfo;
      d2 = true;
      break;
    case 4:
      b2 = b2.containerInfo;
      d2 = true;
      break;
    default:
      throw Error(y(161));
  }
  c2.flags & 16 && (pb(b2, ""), c2.flags &= -17);
  a:
    b:
      for (c2 = a; ; ) {
        for (; c2.sibling === null; ) {
          if (c2.return === null || ej(c2.return)) {
            c2 = null;
            break a;
          }
          c2 = c2.return;
        }
        c2.sibling.return = c2.return;
        for (c2 = c2.sibling; c2.tag !== 5 && c2.tag !== 6 && c2.tag !== 18; ) {
          if (c2.flags & 2)
            continue b;
          if (c2.child === null || c2.tag === 4)
            continue b;
          else
            c2.child.return = c2, c2 = c2.child;
        }
        if (!(c2.flags & 2)) {
          c2 = c2.stateNode;
          break a;
        }
      }
  d2 ? gj(a, c2, b2) : hj(a, c2, b2);
}
function gj(a, b2, c2) {
  var d2 = a.tag, e2 = d2 === 5 || d2 === 6;
  if (e2)
    a = e2 ? a.stateNode : a.stateNode.instance, b2 ? c2.nodeType === 8 ? c2.parentNode.insertBefore(a, b2) : c2.insertBefore(a, b2) : (c2.nodeType === 8 ? (b2 = c2.parentNode, b2.insertBefore(a, c2)) : (b2 = c2, b2.appendChild(a)), c2 = c2._reactRootContainer, c2 !== null && c2 !== void 0 || b2.onclick !== null || (b2.onclick = jf));
  else if (d2 !== 4 && (a = a.child, a !== null))
    for (gj(a, b2, c2), a = a.sibling; a !== null; )
      gj(a, b2, c2), a = a.sibling;
}
function hj(a, b2, c2) {
  var d2 = a.tag, e2 = d2 === 5 || d2 === 6;
  if (e2)
    a = e2 ? a.stateNode : a.stateNode.instance, b2 ? c2.insertBefore(a, b2) : c2.appendChild(a);
  else if (d2 !== 4 && (a = a.child, a !== null))
    for (hj(a, b2, c2), a = a.sibling; a !== null; )
      hj(a, b2, c2), a = a.sibling;
}
function cj(a, b2) {
  for (var c2 = b2, d2 = false, e2, f2; ; ) {
    if (!d2) {
      d2 = c2.return;
      a:
        for (; ; ) {
          if (d2 === null)
            throw Error(y(160));
          e2 = d2.stateNode;
          switch (d2.tag) {
            case 5:
              f2 = false;
              break a;
            case 3:
              e2 = e2.containerInfo;
              f2 = true;
              break a;
            case 4:
              e2 = e2.containerInfo;
              f2 = true;
              break a;
          }
          d2 = d2.return;
        }
      d2 = true;
    }
    if (c2.tag === 5 || c2.tag === 6) {
      a:
        for (var g2 = a, h = c2, k2 = h; ; )
          if (bj(g2, k2), k2.child !== null && k2.tag !== 4)
            k2.child.return = k2, k2 = k2.child;
          else {
            if (k2 === h)
              break a;
            for (; k2.sibling === null; ) {
              if (k2.return === null || k2.return === h)
                break a;
              k2 = k2.return;
            }
            k2.sibling.return = k2.return;
            k2 = k2.sibling;
          }
      f2 ? (g2 = e2, h = c2.stateNode, g2.nodeType === 8 ? g2.parentNode.removeChild(h) : g2.removeChild(h)) : e2.removeChild(c2.stateNode);
    } else if (c2.tag === 4) {
      if (c2.child !== null) {
        e2 = c2.stateNode.containerInfo;
        f2 = true;
        c2.child.return = c2;
        c2 = c2.child;
        continue;
      }
    } else if (bj(a, c2), c2.child !== null) {
      c2.child.return = c2;
      c2 = c2.child;
      continue;
    }
    if (c2 === b2)
      break;
    for (; c2.sibling === null; ) {
      if (c2.return === null || c2.return === b2)
        return;
      c2 = c2.return;
      c2.tag === 4 && (d2 = false);
    }
    c2.sibling.return = c2.return;
    c2 = c2.sibling;
  }
}
function ij(a, b2) {
  switch (b2.tag) {
    case 0:
    case 11:
    case 14:
    case 15:
    case 22:
      var c2 = b2.updateQueue;
      c2 = c2 !== null ? c2.lastEffect : null;
      if (c2 !== null) {
        var d2 = c2 = c2.next;
        do
          (d2.tag & 3) === 3 && (a = d2.destroy, d2.destroy = void 0, a !== void 0 && a()), d2 = d2.next;
        while (d2 !== c2);
      }
      return;
    case 1:
      return;
    case 5:
      c2 = b2.stateNode;
      if (c2 != null) {
        d2 = b2.memoizedProps;
        var e2 = a !== null ? a.memoizedProps : d2;
        a = b2.type;
        var f2 = b2.updateQueue;
        b2.updateQueue = null;
        if (f2 !== null) {
          c2[xf] = d2;
          a === "input" && d2.type === "radio" && d2.name != null && $a(c2, d2);
          wb(a, e2);
          b2 = wb(a, d2);
          for (e2 = 0; e2 < f2.length; e2 += 2) {
            var g2 = f2[e2], h = f2[e2 + 1];
            g2 === "style" ? tb(c2, h) : g2 === "dangerouslySetInnerHTML" ? ob(c2, h) : g2 === "children" ? pb(c2, h) : qa(c2, g2, h, b2);
          }
          switch (a) {
            case "input":
              ab(c2, d2);
              break;
            case "textarea":
              ib(c2, d2);
              break;
            case "select":
              a = c2._wrapperState.wasMultiple, c2._wrapperState.wasMultiple = !!d2.multiple, f2 = d2.value, f2 != null ? fb(c2, !!d2.multiple, f2, false) : a !== !!d2.multiple && (d2.defaultValue != null ? fb(c2, !!d2.multiple, d2.defaultValue, true) : fb(c2, !!d2.multiple, d2.multiple ? [] : "", false));
          }
        }
      }
      return;
    case 6:
      if (b2.stateNode === null)
        throw Error(y(162));
      b2.stateNode.nodeValue = b2.memoizedProps;
      return;
    case 3:
      c2 = b2.stateNode;
      c2.hydrate && (c2.hydrate = false, Cc(c2.containerInfo));
      return;
    case 12:
      return;
    case 13:
      b2.memoizedState !== null && (jj = O(), aj(b2.child, true));
      kj(b2);
      return;
    case 19:
      kj(b2);
      return;
    case 17:
      return;
    case 23:
    case 24:
      aj(b2, b2.memoizedState !== null);
      return;
  }
  throw Error(y(163));
}
function kj(a) {
  var b2 = a.updateQueue;
  if (b2 !== null) {
    a.updateQueue = null;
    var c2 = a.stateNode;
    c2 === null && (c2 = a.stateNode = new Ui());
    b2.forEach(function(b3) {
      var d2 = lj.bind(null, a, b3);
      c2.has(b3) || (c2.add(b3), b3.then(d2, d2));
    });
  }
}
function mj(a, b2) {
  return a !== null && (a = a.memoizedState, a === null || a.dehydrated !== null) ? (b2 = b2.memoizedState, b2 !== null && b2.dehydrated === null) : false;
}
var nj = Math.ceil, oj = ra.ReactCurrentDispatcher, pj = ra.ReactCurrentOwner, X = 0, U = null, Y = null, W = 0, qj = 0, rj = Bf(0), V = 0, sj = null, tj = 0, Dg = 0, Hi = 0, uj = 0, vj = null, jj = 0, Ji = Infinity;
function wj() {
  Ji = O() + 500;
}
var Z = null, Qi = false, Ri = null, Ti = null, xj = false, yj = null, zj = 90, Aj = [], Bj = [], Cj = null, Dj = 0, Ej = null, Fj = -1, Gj = 0, Hj = 0, Ij = null, Jj = false;
function Hg() {
  return (X & 48) !== 0 ? O() : Fj !== -1 ? Fj : Fj = O();
}
function Ig(a) {
  a = a.mode;
  if ((a & 2) === 0)
    return 1;
  if ((a & 4) === 0)
    return eg() === 99 ? 1 : 2;
  Gj === 0 && (Gj = tj);
  if (kg.transition !== 0) {
    Hj !== 0 && (Hj = vj !== null ? vj.pendingLanes : 0);
    a = Gj;
    var b2 = 4186112 & ~Hj;
    b2 &= -b2;
    b2 === 0 && (a = 4186112 & ~a, b2 = a & -a, b2 === 0 && (b2 = 8192));
    return b2;
  }
  a = eg();
  (X & 4) !== 0 && a === 98 ? a = Xc(12, Gj) : (a = Sc(a), a = Xc(a, Gj));
  return a;
}
function Jg(a, b2, c2) {
  if (50 < Dj)
    throw Dj = 0, Ej = null, Error(y(185));
  a = Kj(a, b2);
  if (a === null)
    return null;
  $c(a, b2, c2);
  a === U && (Hi |= b2, V === 4 && Ii(a, W));
  var d2 = eg();
  b2 === 1 ? (X & 8) !== 0 && (X & 48) === 0 ? Lj(a) : (Mj(a, c2), X === 0 && (wj(), ig())) : ((X & 4) === 0 || d2 !== 98 && d2 !== 99 || (Cj === null ? Cj = /* @__PURE__ */ new Set([a]) : Cj.add(a)), Mj(a, c2));
  vj = a;
}
function Kj(a, b2) {
  a.lanes |= b2;
  var c2 = a.alternate;
  c2 !== null && (c2.lanes |= b2);
  c2 = a;
  for (a = a.return; a !== null; )
    a.childLanes |= b2, c2 = a.alternate, c2 !== null && (c2.childLanes |= b2), c2 = a, a = a.return;
  return c2.tag === 3 ? c2.stateNode : null;
}
function Mj(a, b2) {
  for (var c2 = a.callbackNode, d2 = a.suspendedLanes, e2 = a.pingedLanes, f2 = a.expirationTimes, g2 = a.pendingLanes; 0 < g2; ) {
    var h = 31 - Vc(g2), k2 = 1 << h, l2 = f2[h];
    if (l2 === -1) {
      if ((k2 & d2) === 0 || (k2 & e2) !== 0) {
        l2 = b2;
        Rc(k2);
        var n2 = F;
        f2[h] = 10 <= n2 ? l2 + 250 : 6 <= n2 ? l2 + 5e3 : -1;
      }
    } else
      l2 <= b2 && (a.expiredLanes |= k2);
    g2 &= ~k2;
  }
  d2 = Uc(a, a === U ? W : 0);
  b2 = F;
  if (d2 === 0)
    c2 !== null && (c2 !== Zf && Pf(c2), a.callbackNode = null, a.callbackPriority = 0);
  else {
    if (c2 !== null) {
      if (a.callbackPriority === b2)
        return;
      c2 !== Zf && Pf(c2);
    }
    b2 === 15 ? (c2 = Lj.bind(null, a), ag === null ? (ag = [c2], bg = Of(Uf, jg)) : ag.push(c2), c2 = Zf) : b2 === 14 ? c2 = hg(99, Lj.bind(null, a)) : (c2 = Tc(b2), c2 = hg(c2, Nj.bind(null, a)));
    a.callbackPriority = b2;
    a.callbackNode = c2;
  }
}
function Nj(a) {
  Fj = -1;
  Hj = Gj = 0;
  if ((X & 48) !== 0)
    throw Error(y(327));
  var b2 = a.callbackNode;
  if (Oj() && a.callbackNode !== b2)
    return null;
  var c2 = Uc(a, a === U ? W : 0);
  if (c2 === 0)
    return null;
  var d2 = c2;
  var e2 = X;
  X |= 16;
  var f2 = Pj();
  if (U !== a || W !== d2)
    wj(), Qj(a, d2);
  do
    try {
      Rj();
      break;
    } catch (h) {
      Sj(a, h);
    }
  while (1);
  qg();
  oj.current = f2;
  X = e2;
  Y !== null ? d2 = 0 : (U = null, W = 0, d2 = V);
  if ((tj & Hi) !== 0)
    Qj(a, 0);
  else if (d2 !== 0) {
    d2 === 2 && (X |= 64, a.hydrate && (a.hydrate = false, qf(a.containerInfo)), c2 = Wc(a), c2 !== 0 && (d2 = Tj(a, c2)));
    if (d2 === 1)
      throw b2 = sj, Qj(a, 0), Ii(a, c2), Mj(a, O()), b2;
    a.finishedWork = a.current.alternate;
    a.finishedLanes = c2;
    switch (d2) {
      case 0:
      case 1:
        throw Error(y(345));
      case 2:
        Uj(a);
        break;
      case 3:
        Ii(a, c2);
        if ((c2 & 62914560) === c2 && (d2 = jj + 500 - O(), 10 < d2)) {
          if (Uc(a, 0) !== 0)
            break;
          e2 = a.suspendedLanes;
          if ((e2 & c2) !== c2) {
            Hg();
            a.pingedLanes |= a.suspendedLanes & e2;
            break;
          }
          a.timeoutHandle = of(Uj.bind(null, a), d2);
          break;
        }
        Uj(a);
        break;
      case 4:
        Ii(a, c2);
        if ((c2 & 4186112) === c2)
          break;
        d2 = a.eventTimes;
        for (e2 = -1; 0 < c2; ) {
          var g2 = 31 - Vc(c2);
          f2 = 1 << g2;
          g2 = d2[g2];
          g2 > e2 && (e2 = g2);
          c2 &= ~f2;
        }
        c2 = e2;
        c2 = O() - c2;
        c2 = (120 > c2 ? 120 : 480 > c2 ? 480 : 1080 > c2 ? 1080 : 1920 > c2 ? 1920 : 3e3 > c2 ? 3e3 : 4320 > c2 ? 4320 : 1960 * nj(c2 / 1960)) - c2;
        if (10 < c2) {
          a.timeoutHandle = of(Uj.bind(null, a), c2);
          break;
        }
        Uj(a);
        break;
      case 5:
        Uj(a);
        break;
      default:
        throw Error(y(329));
    }
  }
  Mj(a, O());
  return a.callbackNode === b2 ? Nj.bind(null, a) : null;
}
function Ii(a, b2) {
  b2 &= ~uj;
  b2 &= ~Hi;
  a.suspendedLanes |= b2;
  a.pingedLanes &= ~b2;
  for (a = a.expirationTimes; 0 < b2; ) {
    var c2 = 31 - Vc(b2), d2 = 1 << c2;
    a[c2] = -1;
    b2 &= ~d2;
  }
}
function Lj(a) {
  if ((X & 48) !== 0)
    throw Error(y(327));
  Oj();
  if (a === U && (a.expiredLanes & W) !== 0) {
    var b2 = W;
    var c2 = Tj(a, b2);
    (tj & Hi) !== 0 && (b2 = Uc(a, b2), c2 = Tj(a, b2));
  } else
    b2 = Uc(a, 0), c2 = Tj(a, b2);
  a.tag !== 0 && c2 === 2 && (X |= 64, a.hydrate && (a.hydrate = false, qf(a.containerInfo)), b2 = Wc(a), b2 !== 0 && (c2 = Tj(a, b2)));
  if (c2 === 1)
    throw c2 = sj, Qj(a, 0), Ii(a, b2), Mj(a, O()), c2;
  a.finishedWork = a.current.alternate;
  a.finishedLanes = b2;
  Uj(a);
  Mj(a, O());
  return null;
}
function Vj() {
  if (Cj !== null) {
    var a = Cj;
    Cj = null;
    a.forEach(function(a2) {
      a2.expiredLanes |= 24 & a2.pendingLanes;
      Mj(a2, O());
    });
  }
  ig();
}
function Wj(a, b2) {
  var c2 = X;
  X |= 1;
  try {
    return a(b2);
  } finally {
    X = c2, X === 0 && (wj(), ig());
  }
}
function Xj(a, b2) {
  var c2 = X;
  X &= -2;
  X |= 8;
  try {
    return a(b2);
  } finally {
    X = c2, X === 0 && (wj(), ig());
  }
}
function ni(a, b2) {
  I(rj, qj);
  qj |= b2;
  tj |= b2;
}
function Ki() {
  qj = rj.current;
  H(rj);
}
function Qj(a, b2) {
  a.finishedWork = null;
  a.finishedLanes = 0;
  var c2 = a.timeoutHandle;
  c2 !== -1 && (a.timeoutHandle = -1, pf(c2));
  if (Y !== null)
    for (c2 = Y.return; c2 !== null; ) {
      var d2 = c2;
      switch (d2.tag) {
        case 1:
          d2 = d2.type.childContextTypes;
          d2 !== null && d2 !== void 0 && Gf();
          break;
        case 3:
          fh();
          H(N);
          H(M);
          uh();
          break;
        case 5:
          hh(d2);
          break;
        case 4:
          fh();
          break;
        case 13:
          H(P);
          break;
        case 19:
          H(P);
          break;
        case 10:
          rg(d2);
          break;
        case 23:
        case 24:
          Ki();
      }
      c2 = c2.return;
    }
  U = a;
  Y = Tg(a.current, null);
  W = qj = tj = b2;
  V = 0;
  sj = null;
  uj = Hi = Dg = 0;
}
function Sj(a, b2) {
  do {
    var c2 = Y;
    try {
      qg();
      vh.current = Gh;
      if (yh) {
        for (var d2 = R.memoizedState; d2 !== null; ) {
          var e2 = d2.queue;
          e2 !== null && (e2.pending = null);
          d2 = d2.next;
        }
        yh = false;
      }
      xh = 0;
      T = S = R = null;
      zh = false;
      pj.current = null;
      if (c2 === null || c2.return === null) {
        V = 1;
        sj = b2;
        Y = null;
        break;
      }
      a: {
        var f2 = a, g2 = c2.return, h = c2, k2 = b2;
        b2 = W;
        h.flags |= 2048;
        h.firstEffect = h.lastEffect = null;
        if (k2 !== null && typeof k2 === "object" && typeof k2.then === "function") {
          var l2 = k2;
          if ((h.mode & 2) === 0) {
            var n2 = h.alternate;
            n2 ? (h.updateQueue = n2.updateQueue, h.memoizedState = n2.memoizedState, h.lanes = n2.lanes) : (h.updateQueue = null, h.memoizedState = null);
          }
          var A2 = (P.current & 1) !== 0, p2 = g2;
          do {
            var C;
            if (C = p2.tag === 13) {
              var x2 = p2.memoizedState;
              if (x2 !== null)
                C = x2.dehydrated !== null ? true : false;
              else {
                var w2 = p2.memoizedProps;
                C = w2.fallback === void 0 ? false : w2.unstable_avoidThisFallback !== true ? true : A2 ? false : true;
              }
            }
            if (C) {
              var z2 = p2.updateQueue;
              if (z2 === null) {
                var u = /* @__PURE__ */ new Set();
                u.add(l2);
                p2.updateQueue = u;
              } else
                z2.add(l2);
              if ((p2.mode & 2) === 0) {
                p2.flags |= 64;
                h.flags |= 16384;
                h.flags &= -2981;
                if (h.tag === 1)
                  if (h.alternate === null)
                    h.tag = 17;
                  else {
                    var t2 = zg(-1, 1);
                    t2.tag = 2;
                    Ag(h, t2);
                  }
                h.lanes |= 1;
                break a;
              }
              k2 = void 0;
              h = b2;
              var q2 = f2.pingCache;
              q2 === null ? (q2 = f2.pingCache = new Oi(), k2 = /* @__PURE__ */ new Set(), q2.set(l2, k2)) : (k2 = q2.get(l2), k2 === void 0 && (k2 = /* @__PURE__ */ new Set(), q2.set(l2, k2)));
              if (!k2.has(h)) {
                k2.add(h);
                var v4 = Yj.bind(null, f2, l2, h);
                l2.then(v4, v4);
              }
              p2.flags |= 4096;
              p2.lanes = b2;
              break a;
            }
            p2 = p2.return;
          } while (p2 !== null);
          k2 = Error((Ra(h.type) || "A React component") + " suspended while rendering, but no fallback UI was specified.\n\nAdd a <Suspense fallback=...> component higher in the tree to provide a loading indicator or placeholder to display.");
        }
        V !== 5 && (V = 2);
        k2 = Mi(k2, h);
        p2 = g2;
        do {
          switch (p2.tag) {
            case 3:
              f2 = k2;
              p2.flags |= 4096;
              b2 &= -b2;
              p2.lanes |= b2;
              var J = Pi(p2, f2, b2);
              Bg(p2, J);
              break a;
            case 1:
              f2 = k2;
              var K = p2.type, Q = p2.stateNode;
              if ((p2.flags & 64) === 0 && (typeof K.getDerivedStateFromError === "function" || Q !== null && typeof Q.componentDidCatch === "function" && (Ti === null || !Ti.has(Q)))) {
                p2.flags |= 4096;
                b2 &= -b2;
                p2.lanes |= b2;
                var L = Si(p2, f2, b2);
                Bg(p2, L);
                break a;
              }
          }
          p2 = p2.return;
        } while (p2 !== null);
      }
      Zj(c2);
    } catch (va) {
      b2 = va;
      Y === c2 && c2 !== null && (Y = c2 = c2.return);
      continue;
    }
    break;
  } while (1);
}
function Pj() {
  var a = oj.current;
  oj.current = Gh;
  return a === null ? Gh : a;
}
function Tj(a, b2) {
  var c2 = X;
  X |= 16;
  var d2 = Pj();
  U === a && W === b2 || Qj(a, b2);
  do
    try {
      ak();
      break;
    } catch (e2) {
      Sj(a, e2);
    }
  while (1);
  qg();
  X = c2;
  oj.current = d2;
  if (Y !== null)
    throw Error(y(261));
  U = null;
  W = 0;
  return V;
}
function ak() {
  for (; Y !== null; )
    bk(Y);
}
function Rj() {
  for (; Y !== null && !Qf(); )
    bk(Y);
}
function bk(a) {
  var b2 = ck(a.alternate, a, qj);
  a.memoizedProps = a.pendingProps;
  b2 === null ? Zj(a) : Y = b2;
  pj.current = null;
}
function Zj(a) {
  var b2 = a;
  do {
    var c2 = b2.alternate;
    a = b2.return;
    if ((b2.flags & 2048) === 0) {
      c2 = Gi(c2, b2, qj);
      if (c2 !== null) {
        Y = c2;
        return;
      }
      c2 = b2;
      if (c2.tag !== 24 && c2.tag !== 23 || c2.memoizedState === null || (qj & 1073741824) !== 0 || (c2.mode & 4) === 0) {
        for (var d2 = 0, e2 = c2.child; e2 !== null; )
          d2 |= e2.lanes | e2.childLanes, e2 = e2.sibling;
        c2.childLanes = d2;
      }
      a !== null && (a.flags & 2048) === 0 && (a.firstEffect === null && (a.firstEffect = b2.firstEffect), b2.lastEffect !== null && (a.lastEffect !== null && (a.lastEffect.nextEffect = b2.firstEffect), a.lastEffect = b2.lastEffect), 1 < b2.flags && (a.lastEffect !== null ? a.lastEffect.nextEffect = b2 : a.firstEffect = b2, a.lastEffect = b2));
    } else {
      c2 = Li(b2);
      if (c2 !== null) {
        c2.flags &= 2047;
        Y = c2;
        return;
      }
      a !== null && (a.firstEffect = a.lastEffect = null, a.flags |= 2048);
    }
    b2 = b2.sibling;
    if (b2 !== null) {
      Y = b2;
      return;
    }
    Y = b2 = a;
  } while (b2 !== null);
  V === 0 && (V = 5);
}
function Uj(a) {
  var b2 = eg();
  gg(99, dk.bind(null, a, b2));
  return null;
}
function dk(a, b2) {
  do
    Oj();
  while (yj !== null);
  if ((X & 48) !== 0)
    throw Error(y(327));
  var c2 = a.finishedWork;
  if (c2 === null)
    return null;
  a.finishedWork = null;
  a.finishedLanes = 0;
  if (c2 === a.current)
    throw Error(y(177));
  a.callbackNode = null;
  var d2 = c2.lanes | c2.childLanes, e2 = d2, f2 = a.pendingLanes & ~e2;
  a.pendingLanes = e2;
  a.suspendedLanes = 0;
  a.pingedLanes = 0;
  a.expiredLanes &= e2;
  a.mutableReadLanes &= e2;
  a.entangledLanes &= e2;
  e2 = a.entanglements;
  for (var g2 = a.eventTimes, h = a.expirationTimes; 0 < f2; ) {
    var k2 = 31 - Vc(f2), l2 = 1 << k2;
    e2[k2] = 0;
    g2[k2] = -1;
    h[k2] = -1;
    f2 &= ~l2;
  }
  Cj !== null && (d2 & 24) === 0 && Cj.has(a) && Cj.delete(a);
  a === U && (Y = U = null, W = 0);
  1 < c2.flags ? c2.lastEffect !== null ? (c2.lastEffect.nextEffect = c2, d2 = c2.firstEffect) : d2 = c2 : d2 = c2.firstEffect;
  if (d2 !== null) {
    e2 = X;
    X |= 32;
    pj.current = null;
    kf = fd;
    g2 = Ne();
    if (Oe(g2)) {
      if ("selectionStart" in g2)
        h = { start: g2.selectionStart, end: g2.selectionEnd };
      else
        a:
          if (h = (h = g2.ownerDocument) && h.defaultView || window, (l2 = h.getSelection && h.getSelection()) && l2.rangeCount !== 0) {
            h = l2.anchorNode;
            f2 = l2.anchorOffset;
            k2 = l2.focusNode;
            l2 = l2.focusOffset;
            try {
              h.nodeType, k2.nodeType;
            } catch (va) {
              h = null;
              break a;
            }
            var n2 = 0, A2 = -1, p2 = -1, C = 0, x2 = 0, w2 = g2, z2 = null;
            b:
              for (; ; ) {
                for (var u; ; ) {
                  w2 !== h || f2 !== 0 && w2.nodeType !== 3 || (A2 = n2 + f2);
                  w2 !== k2 || l2 !== 0 && w2.nodeType !== 3 || (p2 = n2 + l2);
                  w2.nodeType === 3 && (n2 += w2.nodeValue.length);
                  if ((u = w2.firstChild) === null)
                    break;
                  z2 = w2;
                  w2 = u;
                }
                for (; ; ) {
                  if (w2 === g2)
                    break b;
                  z2 === h && ++C === f2 && (A2 = n2);
                  z2 === k2 && ++x2 === l2 && (p2 = n2);
                  if ((u = w2.nextSibling) !== null)
                    break;
                  w2 = z2;
                  z2 = w2.parentNode;
                }
                w2 = u;
              }
            h = A2 === -1 || p2 === -1 ? null : { start: A2, end: p2 };
          } else
            h = null;
      h = h || { start: 0, end: 0 };
    } else
      h = null;
    lf = { focusedElem: g2, selectionRange: h };
    fd = false;
    Ij = null;
    Jj = false;
    Z = d2;
    do
      try {
        ek();
      } catch (va) {
        if (Z === null)
          throw Error(y(330));
        Wi(Z, va);
        Z = Z.nextEffect;
      }
    while (Z !== null);
    Ij = null;
    Z = d2;
    do
      try {
        for (g2 = a; Z !== null; ) {
          var t2 = Z.flags;
          t2 & 16 && pb(Z.stateNode, "");
          if (t2 & 128) {
            var q2 = Z.alternate;
            if (q2 !== null) {
              var v4 = q2.ref;
              v4 !== null && (typeof v4 === "function" ? v4(null) : v4.current = null);
            }
          }
          switch (t2 & 1038) {
            case 2:
              fj(Z);
              Z.flags &= -3;
              break;
            case 6:
              fj(Z);
              Z.flags &= -3;
              ij(Z.alternate, Z);
              break;
            case 1024:
              Z.flags &= -1025;
              break;
            case 1028:
              Z.flags &= -1025;
              ij(Z.alternate, Z);
              break;
            case 4:
              ij(Z.alternate, Z);
              break;
            case 8:
              h = Z;
              cj(g2, h);
              var J = h.alternate;
              dj(h);
              J !== null && dj(J);
          }
          Z = Z.nextEffect;
        }
      } catch (va) {
        if (Z === null)
          throw Error(y(330));
        Wi(Z, va);
        Z = Z.nextEffect;
      }
    while (Z !== null);
    v4 = lf;
    q2 = Ne();
    t2 = v4.focusedElem;
    g2 = v4.selectionRange;
    if (q2 !== t2 && t2 && t2.ownerDocument && Me(t2.ownerDocument.documentElement, t2)) {
      g2 !== null && Oe(t2) && (q2 = g2.start, v4 = g2.end, v4 === void 0 && (v4 = q2), "selectionStart" in t2 ? (t2.selectionStart = q2, t2.selectionEnd = Math.min(v4, t2.value.length)) : (v4 = (q2 = t2.ownerDocument || document) && q2.defaultView || window, v4.getSelection && (v4 = v4.getSelection(), h = t2.textContent.length, J = Math.min(g2.start, h), g2 = g2.end === void 0 ? J : Math.min(g2.end, h), !v4.extend && J > g2 && (h = g2, g2 = J, J = h), h = Le(t2, J), f2 = Le(t2, g2), h && f2 && (v4.rangeCount !== 1 || v4.anchorNode !== h.node || v4.anchorOffset !== h.offset || v4.focusNode !== f2.node || v4.focusOffset !== f2.offset) && (q2 = q2.createRange(), q2.setStart(h.node, h.offset), v4.removeAllRanges(), J > g2 ? (v4.addRange(q2), v4.extend(f2.node, f2.offset)) : (q2.setEnd(f2.node, f2.offset), v4.addRange(q2))))));
      q2 = [];
      for (v4 = t2; v4 = v4.parentNode; )
        v4.nodeType === 1 && q2.push({ element: v4, left: v4.scrollLeft, top: v4.scrollTop });
      typeof t2.focus === "function" && t2.focus();
      for (t2 = 0; t2 < q2.length; t2++)
        v4 = q2[t2], v4.element.scrollLeft = v4.left, v4.element.scrollTop = v4.top;
    }
    fd = !!kf;
    lf = kf = null;
    a.current = c2;
    Z = d2;
    do
      try {
        for (t2 = a; Z !== null; ) {
          var K = Z.flags;
          K & 36 && Yi(t2, Z.alternate, Z);
          if (K & 128) {
            q2 = void 0;
            var Q = Z.ref;
            if (Q !== null) {
              var L = Z.stateNode;
              switch (Z.tag) {
                case 5:
                  q2 = L;
                  break;
                default:
                  q2 = L;
              }
              typeof Q === "function" ? Q(q2) : Q.current = q2;
            }
          }
          Z = Z.nextEffect;
        }
      } catch (va) {
        if (Z === null)
          throw Error(y(330));
        Wi(Z, va);
        Z = Z.nextEffect;
      }
    while (Z !== null);
    Z = null;
    $f();
    X = e2;
  } else
    a.current = c2;
  if (xj)
    xj = false, yj = a, zj = b2;
  else
    for (Z = d2; Z !== null; )
      b2 = Z.nextEffect, Z.nextEffect = null, Z.flags & 8 && (K = Z, K.sibling = null, K.stateNode = null), Z = b2;
  d2 = a.pendingLanes;
  d2 === 0 && (Ti = null);
  d2 === 1 ? a === Ej ? Dj++ : (Dj = 0, Ej = a) : Dj = 0;
  c2 = c2.stateNode;
  if (Mf && typeof Mf.onCommitFiberRoot === "function")
    try {
      Mf.onCommitFiberRoot(Lf, c2, void 0, (c2.current.flags & 64) === 64);
    } catch (va) {
    }
  Mj(a, O());
  if (Qi)
    throw Qi = false, a = Ri, Ri = null, a;
  if ((X & 8) !== 0)
    return null;
  ig();
  return null;
}
function ek() {
  for (; Z !== null; ) {
    var a = Z.alternate;
    Jj || Ij === null || ((Z.flags & 8) !== 0 ? dc(Z, Ij) && (Jj = true) : Z.tag === 13 && mj(a, Z) && dc(Z, Ij) && (Jj = true));
    var b2 = Z.flags;
    (b2 & 256) !== 0 && Xi(a, Z);
    (b2 & 512) === 0 || xj || (xj = true, hg(97, function() {
      Oj();
      return null;
    }));
    Z = Z.nextEffect;
  }
}
function Oj() {
  if (zj !== 90) {
    var a = 97 < zj ? 97 : zj;
    zj = 90;
    return gg(a, fk);
  }
  return false;
}
function $i(a, b2) {
  Aj.push(b2, a);
  xj || (xj = true, hg(97, function() {
    Oj();
    return null;
  }));
}
function Zi(a, b2) {
  Bj.push(b2, a);
  xj || (xj = true, hg(97, function() {
    Oj();
    return null;
  }));
}
function fk() {
  if (yj === null)
    return false;
  var a = yj;
  yj = null;
  if ((X & 48) !== 0)
    throw Error(y(331));
  var b2 = X;
  X |= 32;
  var c2 = Bj;
  Bj = [];
  for (var d2 = 0; d2 < c2.length; d2 += 2) {
    var e2 = c2[d2], f2 = c2[d2 + 1], g2 = e2.destroy;
    e2.destroy = void 0;
    if (typeof g2 === "function")
      try {
        g2();
      } catch (k2) {
        if (f2 === null)
          throw Error(y(330));
        Wi(f2, k2);
      }
  }
  c2 = Aj;
  Aj = [];
  for (d2 = 0; d2 < c2.length; d2 += 2) {
    e2 = c2[d2];
    f2 = c2[d2 + 1];
    try {
      var h = e2.create;
      e2.destroy = h();
    } catch (k2) {
      if (f2 === null)
        throw Error(y(330));
      Wi(f2, k2);
    }
  }
  for (h = a.current.firstEffect; h !== null; )
    a = h.nextEffect, h.nextEffect = null, h.flags & 8 && (h.sibling = null, h.stateNode = null), h = a;
  X = b2;
  ig();
  return true;
}
function gk(a, b2, c2) {
  b2 = Mi(c2, b2);
  b2 = Pi(a, b2, 1);
  Ag(a, b2);
  b2 = Hg();
  a = Kj(a, 1);
  a !== null && ($c(a, 1, b2), Mj(a, b2));
}
function Wi(a, b2) {
  if (a.tag === 3)
    gk(a, a, b2);
  else
    for (var c2 = a.return; c2 !== null; ) {
      if (c2.tag === 3) {
        gk(c2, a, b2);
        break;
      } else if (c2.tag === 1) {
        var d2 = c2.stateNode;
        if (typeof c2.type.getDerivedStateFromError === "function" || typeof d2.componentDidCatch === "function" && (Ti === null || !Ti.has(d2))) {
          a = Mi(b2, a);
          var e2 = Si(c2, a, 1);
          Ag(c2, e2);
          e2 = Hg();
          c2 = Kj(c2, 1);
          if (c2 !== null)
            $c(c2, 1, e2), Mj(c2, e2);
          else if (typeof d2.componentDidCatch === "function" && (Ti === null || !Ti.has(d2)))
            try {
              d2.componentDidCatch(b2, a);
            } catch (f2) {
            }
          break;
        }
      }
      c2 = c2.return;
    }
}
function Yj(a, b2, c2) {
  var d2 = a.pingCache;
  d2 !== null && d2.delete(b2);
  b2 = Hg();
  a.pingedLanes |= a.suspendedLanes & c2;
  U === a && (W & c2) === c2 && (V === 4 || V === 3 && (W & 62914560) === W && 500 > O() - jj ? Qj(a, 0) : uj |= c2);
  Mj(a, b2);
}
function lj(a, b2) {
  var c2 = a.stateNode;
  c2 !== null && c2.delete(b2);
  b2 = 0;
  b2 === 0 && (b2 = a.mode, (b2 & 2) === 0 ? b2 = 1 : (b2 & 4) === 0 ? b2 = eg() === 99 ? 1 : 2 : (Gj === 0 && (Gj = tj), b2 = Yc(62914560 & ~Gj), b2 === 0 && (b2 = 4194304)));
  c2 = Hg();
  a = Kj(a, b2);
  a !== null && ($c(a, b2, c2), Mj(a, c2));
}
var ck;
ck = function(a, b2, c2) {
  var d2 = b2.lanes;
  if (a !== null)
    if (a.memoizedProps !== b2.pendingProps || N.current)
      ug = true;
    else if ((c2 & d2) !== 0)
      ug = (a.flags & 16384) !== 0 ? true : false;
    else {
      ug = false;
      switch (b2.tag) {
        case 3:
          ri(b2);
          sh();
          break;
        case 5:
          gh(b2);
          break;
        case 1:
          Ff(b2.type) && Jf(b2);
          break;
        case 4:
          eh(b2, b2.stateNode.containerInfo);
          break;
        case 10:
          d2 = b2.memoizedProps.value;
          var e2 = b2.type._context;
          I(mg, e2._currentValue);
          e2._currentValue = d2;
          break;
        case 13:
          if (b2.memoizedState !== null) {
            if ((c2 & b2.child.childLanes) !== 0)
              return ti(a, b2, c2);
            I(P, P.current & 1);
            b2 = hi(a, b2, c2);
            return b2 !== null ? b2.sibling : null;
          }
          I(P, P.current & 1);
          break;
        case 19:
          d2 = (c2 & b2.childLanes) !== 0;
          if ((a.flags & 64) !== 0) {
            if (d2)
              return Ai(a, b2, c2);
            b2.flags |= 64;
          }
          e2 = b2.memoizedState;
          e2 !== null && (e2.rendering = null, e2.tail = null, e2.lastEffect = null);
          I(P, P.current);
          if (d2)
            break;
          else
            return null;
        case 23:
        case 24:
          return b2.lanes = 0, mi(a, b2, c2);
      }
      return hi(a, b2, c2);
    }
  else
    ug = false;
  b2.lanes = 0;
  switch (b2.tag) {
    case 2:
      d2 = b2.type;
      a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2);
      a = b2.pendingProps;
      e2 = Ef(b2, M.current);
      tg(b2, c2);
      e2 = Ch(null, b2, d2, a, e2, c2);
      b2.flags |= 1;
      if (typeof e2 === "object" && e2 !== null && typeof e2.render === "function" && e2.$$typeof === void 0) {
        b2.tag = 1;
        b2.memoizedState = null;
        b2.updateQueue = null;
        if (Ff(d2)) {
          var f2 = true;
          Jf(b2);
        } else
          f2 = false;
        b2.memoizedState = e2.state !== null && e2.state !== void 0 ? e2.state : null;
        xg(b2);
        var g2 = d2.getDerivedStateFromProps;
        typeof g2 === "function" && Gg(b2, d2, g2, a);
        e2.updater = Kg;
        b2.stateNode = e2;
        e2._reactInternals = b2;
        Og(b2, d2, a, c2);
        b2 = qi(null, b2, d2, true, f2, c2);
      } else
        b2.tag = 0, fi(null, b2, e2, c2), b2 = b2.child;
      return b2;
    case 16:
      e2 = b2.elementType;
      a: {
        a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2);
        a = b2.pendingProps;
        f2 = e2._init;
        e2 = f2(e2._payload);
        b2.type = e2;
        f2 = b2.tag = hk(e2);
        a = lg(e2, a);
        switch (f2) {
          case 0:
            b2 = li(null, b2, e2, a, c2);
            break a;
          case 1:
            b2 = pi(null, b2, e2, a, c2);
            break a;
          case 11:
            b2 = gi(null, b2, e2, a, c2);
            break a;
          case 14:
            b2 = ii(null, b2, e2, lg(e2.type, a), d2, c2);
            break a;
        }
        throw Error(y(306, e2, ""));
      }
      return b2;
    case 0:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), li(a, b2, d2, e2, c2);
    case 1:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), pi(a, b2, d2, e2, c2);
    case 3:
      ri(b2);
      d2 = b2.updateQueue;
      if (a === null || d2 === null)
        throw Error(y(282));
      d2 = b2.pendingProps;
      e2 = b2.memoizedState;
      e2 = e2 !== null ? e2.element : null;
      yg(a, b2);
      Cg(b2, d2, null, c2);
      d2 = b2.memoizedState.element;
      if (d2 === e2)
        sh(), b2 = hi(a, b2, c2);
      else {
        e2 = b2.stateNode;
        if (f2 = e2.hydrate)
          kh = rf(b2.stateNode.containerInfo.firstChild), jh = b2, f2 = lh = true;
        if (f2) {
          a = e2.mutableSourceEagerHydrationData;
          if (a != null)
            for (e2 = 0; e2 < a.length; e2 += 2)
              f2 = a[e2], f2._workInProgressVersionPrimary = a[e2 + 1], th.push(f2);
          c2 = Zg(b2, null, d2, c2);
          for (b2.child = c2; c2; )
            c2.flags = c2.flags & -3 | 1024, c2 = c2.sibling;
        } else
          fi(a, b2, d2, c2), sh();
        b2 = b2.child;
      }
      return b2;
    case 5:
      return gh(b2), a === null && ph(b2), d2 = b2.type, e2 = b2.pendingProps, f2 = a !== null ? a.memoizedProps : null, g2 = e2.children, nf(d2, e2) ? g2 = null : f2 !== null && nf(d2, f2) && (b2.flags |= 16), oi(a, b2), fi(a, b2, g2, c2), b2.child;
    case 6:
      return a === null && ph(b2), null;
    case 13:
      return ti(a, b2, c2);
    case 4:
      return eh(b2, b2.stateNode.containerInfo), d2 = b2.pendingProps, a === null ? b2.child = Yg(b2, null, d2, c2) : fi(a, b2, d2, c2), b2.child;
    case 11:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), gi(a, b2, d2, e2, c2);
    case 7:
      return fi(a, b2, b2.pendingProps, c2), b2.child;
    case 8:
      return fi(a, b2, b2.pendingProps.children, c2), b2.child;
    case 12:
      return fi(a, b2, b2.pendingProps.children, c2), b2.child;
    case 10:
      a: {
        d2 = b2.type._context;
        e2 = b2.pendingProps;
        g2 = b2.memoizedProps;
        f2 = e2.value;
        var h = b2.type._context;
        I(mg, h._currentValue);
        h._currentValue = f2;
        if (g2 !== null)
          if (h = g2.value, f2 = He(h, f2) ? 0 : (typeof d2._calculateChangedBits === "function" ? d2._calculateChangedBits(h, f2) : 1073741823) | 0, f2 === 0) {
            if (g2.children === e2.children && !N.current) {
              b2 = hi(a, b2, c2);
              break a;
            }
          } else
            for (h = b2.child, h !== null && (h.return = b2); h !== null; ) {
              var k2 = h.dependencies;
              if (k2 !== null) {
                g2 = h.child;
                for (var l2 = k2.firstContext; l2 !== null; ) {
                  if (l2.context === d2 && (l2.observedBits & f2) !== 0) {
                    h.tag === 1 && (l2 = zg(-1, c2 & -c2), l2.tag = 2, Ag(h, l2));
                    h.lanes |= c2;
                    l2 = h.alternate;
                    l2 !== null && (l2.lanes |= c2);
                    sg(h.return, c2);
                    k2.lanes |= c2;
                    break;
                  }
                  l2 = l2.next;
                }
              } else
                g2 = h.tag === 10 ? h.type === b2.type ? null : h.child : h.child;
              if (g2 !== null)
                g2.return = h;
              else
                for (g2 = h; g2 !== null; ) {
                  if (g2 === b2) {
                    g2 = null;
                    break;
                  }
                  h = g2.sibling;
                  if (h !== null) {
                    h.return = g2.return;
                    g2 = h;
                    break;
                  }
                  g2 = g2.return;
                }
              h = g2;
            }
        fi(a, b2, e2.children, c2);
        b2 = b2.child;
      }
      return b2;
    case 9:
      return e2 = b2.type, f2 = b2.pendingProps, d2 = f2.children, tg(b2, c2), e2 = vg(e2, f2.unstable_observedBits), d2 = d2(e2), b2.flags |= 1, fi(a, b2, d2, c2), b2.child;
    case 14:
      return e2 = b2.type, f2 = lg(e2, b2.pendingProps), f2 = lg(e2.type, f2), ii(a, b2, e2, f2, d2, c2);
    case 15:
      return ki(a, b2, b2.type, b2.pendingProps, d2, c2);
    case 17:
      return d2 = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d2 ? e2 : lg(d2, e2), a !== null && (a.alternate = null, b2.alternate = null, b2.flags |= 2), b2.tag = 1, Ff(d2) ? (a = true, Jf(b2)) : a = false, tg(b2, c2), Mg(b2, d2, e2), Og(b2, d2, e2, c2), qi(null, b2, d2, true, a, c2);
    case 19:
      return Ai(a, b2, c2);
    case 23:
      return mi(a, b2, c2);
    case 24:
      return mi(a, b2, c2);
  }
  throw Error(y(156, b2.tag));
};
function ik(a, b2, c2, d2) {
  this.tag = a;
  this.key = c2;
  this.sibling = this.child = this.return = this.stateNode = this.type = this.elementType = null;
  this.index = 0;
  this.ref = null;
  this.pendingProps = b2;
  this.dependencies = this.memoizedState = this.updateQueue = this.memoizedProps = null;
  this.mode = d2;
  this.flags = 0;
  this.lastEffect = this.firstEffect = this.nextEffect = null;
  this.childLanes = this.lanes = 0;
  this.alternate = null;
}
function nh(a, b2, c2, d2) {
  return new ik(a, b2, c2, d2);
}
function ji(a) {
  a = a.prototype;
  return !(!a || !a.isReactComponent);
}
function hk(a) {
  if (typeof a === "function")
    return ji(a) ? 1 : 0;
  if (a !== void 0 && a !== null) {
    a = a.$$typeof;
    if (a === Aa)
      return 11;
    if (a === Da)
      return 14;
  }
  return 2;
}
function Tg(a, b2) {
  var c2 = a.alternate;
  c2 === null ? (c2 = nh(a.tag, b2, a.key, a.mode), c2.elementType = a.elementType, c2.type = a.type, c2.stateNode = a.stateNode, c2.alternate = a, a.alternate = c2) : (c2.pendingProps = b2, c2.type = a.type, c2.flags = 0, c2.nextEffect = null, c2.firstEffect = null, c2.lastEffect = null);
  c2.childLanes = a.childLanes;
  c2.lanes = a.lanes;
  c2.child = a.child;
  c2.memoizedProps = a.memoizedProps;
  c2.memoizedState = a.memoizedState;
  c2.updateQueue = a.updateQueue;
  b2 = a.dependencies;
  c2.dependencies = b2 === null ? null : { lanes: b2.lanes, firstContext: b2.firstContext };
  c2.sibling = a.sibling;
  c2.index = a.index;
  c2.ref = a.ref;
  return c2;
}
function Vg(a, b2, c2, d2, e2, f2) {
  var g2 = 2;
  d2 = a;
  if (typeof a === "function")
    ji(a) && (g2 = 1);
  else if (typeof a === "string")
    g2 = 5;
  else
    a:
      switch (a) {
        case ua:
          return Xg(c2.children, e2, f2, b2);
        case Ha:
          g2 = 8;
          e2 |= 16;
          break;
        case wa:
          g2 = 8;
          e2 |= 1;
          break;
        case xa:
          return a = nh(12, c2, b2, e2 | 8), a.elementType = xa, a.type = xa, a.lanes = f2, a;
        case Ba:
          return a = nh(13, c2, b2, e2), a.type = Ba, a.elementType = Ba, a.lanes = f2, a;
        case Ca:
          return a = nh(19, c2, b2, e2), a.elementType = Ca, a.lanes = f2, a;
        case Ia:
          return vi(c2, e2, f2, b2);
        case Ja:
          return a = nh(24, c2, b2, e2), a.elementType = Ja, a.lanes = f2, a;
        default:
          if (typeof a === "object" && a !== null)
            switch (a.$$typeof) {
              case ya:
                g2 = 10;
                break a;
              case za:
                g2 = 9;
                break a;
              case Aa:
                g2 = 11;
                break a;
              case Da:
                g2 = 14;
                break a;
              case Ea:
                g2 = 16;
                d2 = null;
                break a;
              case Fa:
                g2 = 22;
                break a;
            }
          throw Error(y(130, a == null ? a : typeof a, ""));
      }
  b2 = nh(g2, c2, b2, e2);
  b2.elementType = a;
  b2.type = d2;
  b2.lanes = f2;
  return b2;
}
function Xg(a, b2, c2, d2) {
  a = nh(7, a, d2, b2);
  a.lanes = c2;
  return a;
}
function vi(a, b2, c2, d2) {
  a = nh(23, a, d2, b2);
  a.elementType = Ia;
  a.lanes = c2;
  return a;
}
function Ug(a, b2, c2) {
  a = nh(6, a, null, b2);
  a.lanes = c2;
  return a;
}
function Wg(a, b2, c2) {
  b2 = nh(4, a.children !== null ? a.children : [], a.key, b2);
  b2.lanes = c2;
  b2.stateNode = { containerInfo: a.containerInfo, pendingChildren: null, implementation: a.implementation };
  return b2;
}
function jk(a, b2, c2) {
  this.tag = b2;
  this.containerInfo = a;
  this.finishedWork = this.pingCache = this.current = this.pendingChildren = null;
  this.timeoutHandle = -1;
  this.pendingContext = this.context = null;
  this.hydrate = c2;
  this.callbackNode = null;
  this.callbackPriority = 0;
  this.eventTimes = Zc(0);
  this.expirationTimes = Zc(-1);
  this.entangledLanes = this.finishedLanes = this.mutableReadLanes = this.expiredLanes = this.pingedLanes = this.suspendedLanes = this.pendingLanes = 0;
  this.entanglements = Zc(0);
  this.mutableSourceEagerHydrationData = null;
}
function kk(a, b2, c2) {
  var d2 = 3 < arguments.length && arguments[3] !== void 0 ? arguments[3] : null;
  return { $$typeof: ta, key: d2 == null ? null : "" + d2, children: a, containerInfo: b2, implementation: c2 };
}
function lk(a, b2, c2, d2) {
  var e2 = b2.current, f2 = Hg(), g2 = Ig(e2);
  a:
    if (c2) {
      c2 = c2._reactInternals;
      b: {
        if (Zb(c2) !== c2 || c2.tag !== 1)
          throw Error(y(170));
        var h = c2;
        do {
          switch (h.tag) {
            case 3:
              h = h.stateNode.context;
              break b;
            case 1:
              if (Ff(h.type)) {
                h = h.stateNode.__reactInternalMemoizedMergedChildContext;
                break b;
              }
          }
          h = h.return;
        } while (h !== null);
        throw Error(y(171));
      }
      if (c2.tag === 1) {
        var k2 = c2.type;
        if (Ff(k2)) {
          c2 = If(c2, k2, h);
          break a;
        }
      }
      c2 = h;
    } else
      c2 = Cf;
  b2.context === null ? b2.context = c2 : b2.pendingContext = c2;
  b2 = zg(f2, g2);
  b2.payload = { element: a };
  d2 = d2 === void 0 ? null : d2;
  d2 !== null && (b2.callback = d2);
  Ag(e2, b2);
  Jg(e2, g2, f2);
  return g2;
}
function mk(a) {
  a = a.current;
  if (!a.child)
    return null;
  switch (a.child.tag) {
    case 5:
      return a.child.stateNode;
    default:
      return a.child.stateNode;
  }
}
function nk(a, b2) {
  a = a.memoizedState;
  if (a !== null && a.dehydrated !== null) {
    var c2 = a.retryLane;
    a.retryLane = c2 !== 0 && c2 < b2 ? c2 : b2;
  }
}
function ok(a, b2) {
  nk(a, b2);
  (a = a.alternate) && nk(a, b2);
}
function pk() {
  return null;
}
function qk(a, b2, c2) {
  var d2 = c2 != null && c2.hydrationOptions != null && c2.hydrationOptions.mutableSources || null;
  c2 = new jk(a, b2, c2 != null && c2.hydrate === true);
  b2 = nh(3, null, null, b2 === 2 ? 7 : b2 === 1 ? 3 : 0);
  c2.current = b2;
  b2.stateNode = c2;
  xg(b2);
  a[ff] = c2.current;
  cf(a.nodeType === 8 ? a.parentNode : a);
  if (d2)
    for (a = 0; a < d2.length; a++) {
      b2 = d2[a];
      var e2 = b2._getVersion;
      e2 = e2(b2._source);
      c2.mutableSourceEagerHydrationData == null ? c2.mutableSourceEagerHydrationData = [b2, e2] : c2.mutableSourceEagerHydrationData.push(b2, e2);
    }
  this._internalRoot = c2;
}
qk.prototype.render = function(a) {
  lk(a, this._internalRoot, null, null);
};
qk.prototype.unmount = function() {
  var a = this._internalRoot, b2 = a.containerInfo;
  lk(null, a, null, function() {
    b2[ff] = null;
  });
};
function rk(a) {
  return !(!a || a.nodeType !== 1 && a.nodeType !== 9 && a.nodeType !== 11 && (a.nodeType !== 8 || a.nodeValue !== " react-mount-point-unstable "));
}
function sk(a, b2) {
  b2 || (b2 = a ? a.nodeType === 9 ? a.documentElement : a.firstChild : null, b2 = !(!b2 || b2.nodeType !== 1 || !b2.hasAttribute("data-reactroot")));
  if (!b2)
    for (var c2; c2 = a.lastChild; )
      a.removeChild(c2);
  return new qk(a, 0, b2 ? { hydrate: true } : void 0);
}
function tk(a, b2, c2, d2, e2) {
  var f2 = c2._reactRootContainer;
  if (f2) {
    var g2 = f2._internalRoot;
    if (typeof e2 === "function") {
      var h = e2;
      e2 = function() {
        var a2 = mk(g2);
        h.call(a2);
      };
    }
    lk(b2, g2, a, e2);
  } else {
    f2 = c2._reactRootContainer = sk(c2, d2);
    g2 = f2._internalRoot;
    if (typeof e2 === "function") {
      var k2 = e2;
      e2 = function() {
        var a2 = mk(g2);
        k2.call(a2);
      };
    }
    Xj(function() {
      lk(b2, g2, a, e2);
    });
  }
  return mk(g2);
}
ec = function(a) {
  if (a.tag === 13) {
    var b2 = Hg();
    Jg(a, 4, b2);
    ok(a, 4);
  }
};
fc = function(a) {
  if (a.tag === 13) {
    var b2 = Hg();
    Jg(a, 67108864, b2);
    ok(a, 67108864);
  }
};
gc = function(a) {
  if (a.tag === 13) {
    var b2 = Hg(), c2 = Ig(a);
    Jg(a, c2, b2);
    ok(a, c2);
  }
};
hc = function(a, b2) {
  return b2();
};
yb = function(a, b2, c2) {
  switch (b2) {
    case "input":
      ab(a, c2);
      b2 = c2.name;
      if (c2.type === "radio" && b2 != null) {
        for (c2 = a; c2.parentNode; )
          c2 = c2.parentNode;
        c2 = c2.querySelectorAll("input[name=" + JSON.stringify("" + b2) + '][type="radio"]');
        for (b2 = 0; b2 < c2.length; b2++) {
          var d2 = c2[b2];
          if (d2 !== a && d2.form === a.form) {
            var e2 = Db(d2);
            if (!e2)
              throw Error(y(90));
            Wa(d2);
            ab(d2, e2);
          }
        }
      }
      break;
    case "textarea":
      ib(a, c2);
      break;
    case "select":
      b2 = c2.value, b2 != null && fb(a, !!c2.multiple, b2, false);
  }
};
Gb = Wj;
Hb = function(a, b2, c2, d2, e2) {
  var f2 = X;
  X |= 4;
  try {
    return gg(98, a.bind(null, b2, c2, d2, e2));
  } finally {
    X = f2, X === 0 && (wj(), ig());
  }
};
Ib = function() {
  (X & 49) === 0 && (Vj(), Oj());
};
Jb = function(a, b2) {
  var c2 = X;
  X |= 2;
  try {
    return a(b2);
  } finally {
    X = c2, X === 0 && (wj(), ig());
  }
};
function uk(a, b2) {
  var c2 = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : null;
  if (!rk(b2))
    throw Error(y(200));
  return kk(a, b2, null, c2);
}
var vk = { Events: [Cb, ue, Db, Eb, Fb, Oj, { current: false }] }, wk = { findFiberByHostInstance: wc, bundleType: 0, version: "17.0.2", rendererPackageName: "react-dom" };
var xk = { bundleType: wk.bundleType, version: wk.version, rendererPackageName: wk.rendererPackageName, rendererConfig: wk.rendererConfig, overrideHookState: null, overrideHookStateDeletePath: null, overrideHookStateRenamePath: null, overrideProps: null, overridePropsDeletePath: null, overridePropsRenamePath: null, setSuspenseHandler: null, scheduleUpdate: null, currentDispatcherRef: ra.ReactCurrentDispatcher, findHostInstanceByFiber: function(a) {
  a = cc(a);
  return a === null ? null : a.stateNode;
}, findFiberByHostInstance: wk.findFiberByHostInstance || pk, findHostInstancesForRefresh: null, scheduleRefresh: null, scheduleRoot: null, setRefreshHandler: null, getCurrentFiber: null };
if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined") {
  var yk = __REACT_DEVTOOLS_GLOBAL_HOOK__;
  if (!yk.isDisabled && yk.supportsFiber)
    try {
      Lf = yk.inject(xk), Mf = yk;
    } catch (a) {
    }
}
reactDom_production_min.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = vk;
reactDom_production_min.createPortal = uk;
reactDom_production_min.findDOMNode = function(a) {
  if (a == null)
    return null;
  if (a.nodeType === 1)
    return a;
  var b2 = a._reactInternals;
  if (b2 === void 0) {
    if (typeof a.render === "function")
      throw Error(y(188));
    throw Error(y(268, Object.keys(a)));
  }
  a = cc(b2);
  a = a === null ? null : a.stateNode;
  return a;
};
reactDom_production_min.flushSync = function(a, b2) {
  var c2 = X;
  if ((c2 & 48) !== 0)
    return a(b2);
  X |= 1;
  try {
    if (a)
      return gg(99, a.bind(null, b2));
  } finally {
    X = c2, ig();
  }
};
reactDom_production_min.hydrate = function(a, b2, c2) {
  if (!rk(b2))
    throw Error(y(200));
  return tk(null, a, b2, true, c2);
};
reactDom_production_min.render = function(a, b2, c2) {
  if (!rk(b2))
    throw Error(y(200));
  return tk(null, a, b2, false, c2);
};
reactDom_production_min.unmountComponentAtNode = function(a) {
  if (!rk(a))
    throw Error(y(40));
  return a._reactRootContainer ? (Xj(function() {
    tk(null, null, a, false, function() {
      a._reactRootContainer = null;
      a[ff] = null;
    });
  }), true) : false;
};
reactDom_production_min.unstable_batchedUpdates = Wj;
reactDom_production_min.unstable_createPortal = function(a, b2) {
  return uk(a, b2, 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : null);
};
reactDom_production_min.unstable_renderSubtreeIntoContainer = function(a, b2, c2, d2) {
  if (!rk(c2))
    throw Error(y(200));
  if (a == null || a._reactInternals === void 0)
    throw Error(y(38));
  return tk(a, b2, c2, false, d2);
};
reactDom_production_min.version = "17.0.2";
function checkDCE() {
  if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === "undefined" || typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE !== "function") {
    return;
  }
  try {
    __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(checkDCE);
  } catch (err) {
    console.error(err);
  }
}
{
  checkDCE();
  reactDom.exports = reactDom_production_min;
}
var ReactDOM = reactDom.exports;
function findDOMNode(node) {
  if (node instanceof HTMLElement) {
    return node;
  }
  return ReactDOM.findDOMNode(node);
}
var elementListeners = /* @__PURE__ */ new Map();
function onResize(entities) {
  entities.forEach(function(entity) {
    var _elementListeners$get;
    var target = entity.target;
    (_elementListeners$get = elementListeners.get(target)) === null || _elementListeners$get === void 0 ? void 0 : _elementListeners$get.forEach(function(listener) {
      return listener(target);
    });
  });
}
var resizeObserver = new index$8(onResize);
function observe(element, callback) {
  if (!elementListeners.has(element)) {
    elementListeners.set(element, /* @__PURE__ */ new Set());
    resizeObserver.observe(element);
  }
  elementListeners.get(element).add(callback);
}
function unobserve(element, callback) {
  if (elementListeners.has(element)) {
    elementListeners.get(element).delete(callback);
    if (!elementListeners.get(element).size) {
      resizeObserver.unobserve(element);
      elementListeners.delete(element);
    }
  }
}
var DomWrapper$1 = /* @__PURE__ */ function(_React$Component) {
  _inherits(DomWrapper2, _React$Component);
  var _super = _createSuper(DomWrapper2);
  function DomWrapper2() {
    _classCallCheck(this, DomWrapper2);
    return _super.apply(this, arguments);
  }
  _createClass(DomWrapper2, [{
    key: "render",
    value: function render2() {
      return this.props.children;
    }
  }]);
  return DomWrapper2;
}(React.Component);
var CollectionContext = /* @__PURE__ */ React.createContext(null);
function Collection(_ref) {
  var children = _ref.children, onBatchResize = _ref.onBatchResize;
  var resizeIdRef = React.useRef(0);
  var resizeInfosRef = React.useRef([]);
  var onCollectionResize = React.useContext(CollectionContext);
  var onResize2 = React.useCallback(function(size, element, data) {
    resizeIdRef.current += 1;
    var currentId = resizeIdRef.current;
    resizeInfosRef.current.push({
      size,
      element,
      data
    });
    Promise.resolve().then(function() {
      if (currentId === resizeIdRef.current) {
        onBatchResize === null || onBatchResize === void 0 ? void 0 : onBatchResize(resizeInfosRef.current);
        resizeInfosRef.current = [];
      }
    });
    onCollectionResize === null || onCollectionResize === void 0 ? void 0 : onCollectionResize(size, element, data);
  }, [onBatchResize, onCollectionResize]);
  return /* @__PURE__ */ React.createElement(CollectionContext.Provider, {
    value: onResize2
  }, children);
}
function SingleObserver(props) {
  var children = props.children, disabled = props.disabled;
  var elementRef = React.useRef(null);
  var wrapperRef = React.useRef(null);
  var onCollectionResize = React.useContext(CollectionContext);
  var isRenderProps = typeof children === "function";
  var mergedChildren = isRenderProps ? children(elementRef) : children;
  var sizeRef = React.useRef({
    width: -1,
    height: -1,
    offsetWidth: -1,
    offsetHeight: -1
  });
  var canRef = !isRenderProps && /* @__PURE__ */ React.isValidElement(mergedChildren) && supportRef(mergedChildren);
  var originRef = canRef ? mergedChildren.ref : null;
  var mergedRef = React.useMemo(function() {
    return composeRef(originRef, elementRef);
  }, [originRef, elementRef]);
  var propsRef = React.useRef(props);
  propsRef.current = props;
  var onInternalResize = React.useCallback(function(target) {
    var _propsRef$current = propsRef.current, onResize2 = _propsRef$current.onResize, data = _propsRef$current.data;
    var _target$getBoundingCl = target.getBoundingClientRect(), width = _target$getBoundingCl.width, height = _target$getBoundingCl.height;
    var offsetWidth = target.offsetWidth, offsetHeight = target.offsetHeight;
    var fixedWidth = Math.floor(width);
    var fixedHeight = Math.floor(height);
    if (sizeRef.current.width !== fixedWidth || sizeRef.current.height !== fixedHeight || sizeRef.current.offsetWidth !== offsetWidth || sizeRef.current.offsetHeight !== offsetHeight) {
      var size = {
        width: fixedWidth,
        height: fixedHeight,
        offsetWidth,
        offsetHeight
      };
      sizeRef.current = size;
      var mergedOffsetWidth = offsetWidth === Math.round(width) ? width : offsetWidth;
      var mergedOffsetHeight = offsetHeight === Math.round(height) ? height : offsetHeight;
      var sizeInfo = _objectSpread2$1(_objectSpread2$1({}, size), {}, {
        offsetWidth: mergedOffsetWidth,
        offsetHeight: mergedOffsetHeight
      });
      onCollectionResize === null || onCollectionResize === void 0 ? void 0 : onCollectionResize(sizeInfo, target, data);
      if (onResize2) {
        Promise.resolve().then(function() {
          onResize2(sizeInfo, target);
        });
      }
    }
  }, []);
  React.useEffect(function() {
    var currentElement = findDOMNode(elementRef.current) || findDOMNode(wrapperRef.current);
    if (currentElement && !disabled) {
      observe(currentElement, onInternalResize);
    }
    return function() {
      return unobserve(currentElement, onInternalResize);
    };
  }, [elementRef.current, disabled]);
  return /* @__PURE__ */ React.createElement(DomWrapper$1, {
    ref: wrapperRef
  }, canRef ? /* @__PURE__ */ React.cloneElement(mergedChildren, {
    ref: mergedRef
  }) : mergedChildren);
}
var INTERNAL_PREFIX_KEY = "rc-observer-key";
function ResizeObserver(props) {
  var children = props.children;
  var childNodes = typeof children === "function" ? [children] : toArray$1(children);
  return childNodes.map(function(child, index2) {
    var key = (child === null || child === void 0 ? void 0 : child.key) || "".concat(INTERNAL_PREFIX_KEY, "-").concat(index2);
    return /* @__PURE__ */ React.createElement(SingleObserver, _extends$1({}, props, {
      key
    }), child);
  });
}
ResizeObserver.Collection = Collection;
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
var HOOK_MARK = "RC_FORM_INTERNAL_HOOKS";
var warningFunc = function warningFunc2() {
  warningOnce(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
};
var Context = /* @__PURE__ */ React.createContext({
  getFieldValue: warningFunc,
  getFieldsValue: warningFunc,
  getFieldError: warningFunc,
  getFieldWarning: warningFunc,
  getFieldsError: warningFunc,
  isFieldsTouched: warningFunc,
  isFieldTouched: warningFunc,
  isFieldValidating: warningFunc,
  isFieldsValidating: warningFunc,
  resetFields: warningFunc,
  setFields: warningFunc,
  setFieldsValue: warningFunc,
  validateFields: warningFunc,
  submit: warningFunc,
  getInternalHooks: function getInternalHooks() {
    warningFunc();
    return {
      dispatch: warningFunc,
      initEntityValue: warningFunc,
      registerField: warningFunc,
      useSubscribe: warningFunc,
      setInitialValues: warningFunc,
      setCallbacks: warningFunc,
      getFields: warningFunc,
      setValidateMessages: warningFunc,
      setPreserve: warningFunc,
      getInitialValue: warningFunc
    };
  }
});
function toArray(value) {
  if (value === void 0 || value === null) {
    return [];
  }
  return Array.isArray(value) ? value : [value];
}
var runtime = { exports: {} };
(function(module) {
  var runtime2 = function(exports) {
    var Op = Object.prototype;
    var hasOwn2 = Op.hasOwnProperty;
    var undefined$1;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }
    function wrap(innerFn, outerFn, self2, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context2(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self2, context);
      return generator;
    }
    exports.wrap = wrap;
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }
    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};
    function Generator() {
    }
    function GeneratorFunction() {
    }
    function GeneratorFunctionPrototype() {
    }
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function() {
      return this;
    });
    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn2.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = GeneratorFunctionPrototype;
    define(Gp, "constructor", GeneratorFunctionPrototype);
    define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
    GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction");
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method4) {
        define(prototype, method4, function(arg) {
          return this._invoke(method4, arg);
        });
      });
    }
    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };
    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };
    exports.awrap = function(arg) {
      return { __await: arg };
    };
    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method4, arg, resolve, reject) {
        var record = tryCatch(generator[method4], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value && typeof value === "object" && hasOwn2.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value2) {
              invoke("next", value2, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }
          return PromiseImpl.resolve(value).then(function(unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }
      var previousPromise;
      function enqueue(method4, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method4, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
      this._invoke = enqueue;
    }
    defineIteratorMethods(AsyncIterator.prototype);
    define(AsyncIterator.prototype, asyncIteratorSymbol, function() {
      return this;
    });
    exports.AsyncIterator = AsyncIterator;
    exports.async = function(innerFn, outerFn, self2, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0)
        PromiseImpl = Promise;
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self2, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function(result) {
        return result.done ? result.value : iter.next();
      });
    };
    function makeInvokeMethod(innerFn, self2, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method4, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }
        if (state === GenStateCompleted) {
          if (method4 === "throw") {
            throw arg;
          }
          return doneResult();
        }
        context.method = method4;
        context.arg = arg;
        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel)
                continue;
              return delegateResult;
            }
          }
          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }
            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }
          state = GenStateExecuting;
          var record = tryCatch(innerFn, self2, context);
          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;
            if (record.arg === ContinueSentinel) {
              continue;
            }
            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }
    function maybeInvokeDelegate(delegate, context) {
      var method4 = delegate.iterator[context.method];
      if (method4 === undefined$1) {
        context.delegate = null;
        if (context.method === "throw") {
          if (delegate.iterator["return"]) {
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);
            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }
          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }
        return ContinueSentinel;
      }
      var record = tryCatch(method4, delegate.iterator, context.arg);
      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }
      var info = record.arg;
      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }
      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }
      } else {
        return info;
      }
      context.delegate = null;
      return ContinueSentinel;
    }
    defineIteratorMethods(Gp);
    define(Gp, toStringTagSymbol, "Generator");
    define(Gp, iteratorSymbol, function() {
      return this;
    });
    define(Gp, "toString", function() {
      return "[object Generator]";
    });
    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };
      if (1 in locs) {
        entry.catchLoc = locs[1];
      }
      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }
      this.tryEntries.push(entry);
    }
    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }
    function Context2(tryLocsList) {
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }
    exports.keys = function(object4) {
      var keys2 = [];
      for (var key in object4) {
        keys2.push(key);
      }
      keys2.reverse();
      return function next() {
        while (keys2.length) {
          var key2 = keys2.pop();
          if (key2 in object4) {
            next.value = key2;
            next.done = false;
            return next;
          }
        }
        next.done = true;
        return next;
      };
    };
    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }
        if (typeof iterable.next === "function") {
          return iterable;
        }
        if (!isNaN(iterable.length)) {
          var i = -1, next = function next2() {
            while (++i < iterable.length) {
              if (hasOwn2.call(iterable, i)) {
                next2.value = iterable[i];
                next2.done = false;
                return next2;
              }
            }
            next2.value = undefined$1;
            next2.done = true;
            return next2;
          };
          return next.next = next;
        }
      }
      return { next: doneResult };
    }
    exports.values = values;
    function doneResult() {
      return { value: undefined$1, done: true };
    }
    Context2.prototype = {
      constructor: Context2,
      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined$1;
        this.tryEntries.forEach(resetTryEntry);
        if (!skipTempReset) {
          for (var name in this) {
            if (name.charAt(0) === "t" && hasOwn2.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },
      stop: function() {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }
        return this.rval;
      },
      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }
        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;
          if (caught) {
            context.method = "next";
            context.arg = undefined$1;
          }
          return !!caught;
        }
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;
          if (entry.tryLoc === "root") {
            return handle("end");
          }
          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn2.call(entry, "catchLoc");
            var hasFinally = hasOwn2.call(entry, "finallyLoc");
            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function(type4, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev && hasOwn2.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }
        if (finallyEntry && (type4 === "break" || type4 === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }
        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type4;
        record.arg = arg;
        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }
        return this.complete(record);
      },
      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }
        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }
        return ContinueSentinel;
      },
      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }
        throw new Error("illegal catch attempt");
      },
      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName,
          nextLoc
        };
        if (this.method === "next") {
          this.arg = undefined$1;
        }
        return ContinueSentinel;
      }
    };
    return exports;
  }(module.exports);
  try {
    regeneratorRuntime = runtime2;
  } catch (accidentalStrictMode) {
    if (typeof globalThis === "object") {
      globalThis.regeneratorRuntime = runtime2;
    } else {
      Function("r", "regeneratorRuntime = r")(runtime2);
    }
  }
})(runtime);
var regenerator = runtime.exports;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function() {
    var self2 = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self2, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p2) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf(o, p2);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct2(Parent2, args2, Class2) {
      var a = [null];
      a.push.apply(a, args2);
      var Constructor = Function.bind.apply(Parent2, a);
      var instance = new Constructor();
      if (Class2)
        _setPrototypeOf(instance, Class2.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? /* @__PURE__ */ new Map() : void 0;
  _wrapNativeSuper = function _wrapNativeSuper2(Class2) {
    if (Class2 === null || !_isNativeFunction(Class2))
      return Class2;
    if (typeof Class2 !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class2))
        return _cache.get(Class2);
      _cache.set(Class2, Wrapper);
    }
    function Wrapper() {
      return _construct(Class2, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class2.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class2);
  };
  return _wrapNativeSuper(Class);
}
var formatRegExp = /%[sdj%]/g;
var warning = function warning2() {
};
if (typeof process !== "undefined" && process.env && false) {
  warning = function warning3(type4, errors) {
    if (typeof console !== "undefined" && console.warn && typeof ASYNC_VALIDATOR_NO_WARNING === "undefined") {
      if (errors.every(function(e2) {
        return typeof e2 === "string";
      })) {
        console.warn(type4, errors);
      }
    }
  };
}
function convertFieldsError(errors) {
  if (!errors || !errors.length)
    return null;
  var fields = {};
  errors.forEach(function(error) {
    var field = error.field;
    fields[field] = fields[field] || [];
    fields[field].push(error);
  });
  return fields;
}
function format(template) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  var i = 0;
  var len2 = args.length;
  if (typeof template === "function") {
    return template.apply(null, args);
  }
  if (typeof template === "string") {
    var str = template.replace(formatRegExp, function(x2) {
      if (x2 === "%%") {
        return "%";
      }
      if (i >= len2) {
        return x2;
      }
      switch (x2) {
        case "%s":
          return String(args[i++]);
        case "%d":
          return Number(args[i++]);
        case "%j":
          try {
            return JSON.stringify(args[i++]);
          } catch (_) {
            return "[Circular]";
          }
          break;
        default:
          return x2;
      }
    });
    return str;
  }
  return template;
}
function isNativeStringType(type4) {
  return type4 === "string" || type4 === "url" || type4 === "hex" || type4 === "email" || type4 === "date" || type4 === "pattern";
}
function isEmptyValue(value, type4) {
  if (value === void 0 || value === null) {
    return true;
  }
  if (type4 === "array" && Array.isArray(value) && !value.length) {
    return true;
  }
  if (isNativeStringType(type4) && typeof value === "string" && !value) {
    return true;
  }
  return false;
}
function asyncParallelArray(arr, func, callback) {
  var results = [];
  var total = 0;
  var arrLength = arr.length;
  function count2(errors) {
    results.push.apply(results, errors || []);
    total++;
    if (total === arrLength) {
      callback(results);
    }
  }
  arr.forEach(function(a) {
    func(a, count2);
  });
}
function asyncSerialArray(arr, func, callback) {
  var index2 = 0;
  var arrLength = arr.length;
  function next(errors) {
    if (errors && errors.length) {
      callback(errors);
      return;
    }
    var original = index2;
    index2 = index2 + 1;
    if (original < arrLength) {
      func(arr[original], next);
    } else {
      callback([]);
    }
  }
  next([]);
}
function flattenObjArr(objArr) {
  var ret = [];
  Object.keys(objArr).forEach(function(k2) {
    ret.push.apply(ret, objArr[k2] || []);
  });
  return ret;
}
var AsyncValidationError = /* @__PURE__ */ function(_Error) {
  _inheritsLoose(AsyncValidationError2, _Error);
  function AsyncValidationError2(errors, fields) {
    var _this;
    _this = _Error.call(this, "Async Validation Error") || this;
    _this.errors = errors;
    _this.fields = fields;
    return _this;
  }
  return AsyncValidationError2;
}(/* @__PURE__ */ _wrapNativeSuper(Error));
function asyncMap(objArr, option, func, callback, source) {
  if (option.first) {
    var _pending = new Promise(function(resolve, reject) {
      var next = function next2(errors) {
        callback(errors);
        return errors.length ? reject(new AsyncValidationError(errors, convertFieldsError(errors))) : resolve(source);
      };
      var flattenArr = flattenObjArr(objArr);
      asyncSerialArray(flattenArr, func, next);
    });
    _pending["catch"](function(e2) {
      return e2;
    });
    return _pending;
  }
  var firstFields = option.firstFields === true ? Object.keys(objArr) : option.firstFields || [];
  var objArrKeys = Object.keys(objArr);
  var objArrLength = objArrKeys.length;
  var total = 0;
  var results = [];
  var pending = new Promise(function(resolve, reject) {
    var next = function next2(errors) {
      results.push.apply(results, errors);
      total++;
      if (total === objArrLength) {
        callback(results);
        return results.length ? reject(new AsyncValidationError(results, convertFieldsError(results))) : resolve(source);
      }
    };
    if (!objArrKeys.length) {
      callback(results);
      resolve(source);
    }
    objArrKeys.forEach(function(key) {
      var arr = objArr[key];
      if (firstFields.indexOf(key) !== -1) {
        asyncSerialArray(arr, func, next);
      } else {
        asyncParallelArray(arr, func, next);
      }
    });
  });
  pending["catch"](function(e2) {
    return e2;
  });
  return pending;
}
function isErrorObj(obj) {
  return !!(obj && obj.message !== void 0);
}
function getValue$1(value, path) {
  var v4 = value;
  for (var i = 0; i < path.length; i++) {
    if (v4 == void 0) {
      return v4;
    }
    v4 = v4[path[i]];
  }
  return v4;
}
function complementError(rule, source) {
  return function(oe2) {
    var fieldValue;
    if (rule.fullFields) {
      fieldValue = getValue$1(source, rule.fullFields);
    } else {
      fieldValue = source[oe2.field || rule.fullField];
    }
    if (isErrorObj(oe2)) {
      oe2.field = oe2.field || rule.fullField;
      oe2.fieldValue = fieldValue;
      return oe2;
    }
    return {
      message: typeof oe2 === "function" ? oe2() : oe2,
      fieldValue,
      field: oe2.field || rule.fullField
    };
  };
}
function deepMerge(target, source) {
  if (source) {
    for (var s in source) {
      if (source.hasOwnProperty(s)) {
        var value = source[s];
        if (typeof value === "object" && typeof target[s] === "object") {
          target[s] = _extends({}, target[s], value);
        } else {
          target[s] = value;
        }
      }
    }
  }
  return target;
}
var required$1 = function required(rule, value, source, errors, options, type4) {
  if (rule.required && (!source.hasOwnProperty(rule.field) || isEmptyValue(value, type4 || rule.type))) {
    errors.push(format(options.messages.required, rule.fullField));
  }
};
var whitespace = function whitespace2(rule, value, source, errors, options) {
  if (/^\s+$/.test(value) || value === "") {
    errors.push(format(options.messages.whitespace, rule.fullField));
  }
};
var pattern$2 = {
  email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/,
  url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"),
  hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i
};
var types = {
  integer: function integer(value) {
    return types.number(value) && parseInt(value, 10) === value;
  },
  "float": function float(value) {
    return types.number(value) && !types.integer(value);
  },
  array: function array(value) {
    return Array.isArray(value);
  },
  regexp: function regexp(value) {
    if (value instanceof RegExp) {
      return true;
    }
    try {
      return !!new RegExp(value);
    } catch (e2) {
      return false;
    }
  },
  date: function date(value) {
    return typeof value.getTime === "function" && typeof value.getMonth === "function" && typeof value.getYear === "function" && !isNaN(value.getTime());
  },
  number: function number(value) {
    if (isNaN(value)) {
      return false;
    }
    return typeof value === "number";
  },
  object: function object(value) {
    return typeof value === "object" && !types.array(value);
  },
  method: function method(value) {
    return typeof value === "function";
  },
  email: function email(value) {
    return typeof value === "string" && value.length <= 320 && !!value.match(pattern$2.email);
  },
  url: function url(value) {
    return typeof value === "string" && value.length <= 2048 && !!value.match(pattern$2.url);
  },
  hex: function hex(value) {
    return typeof value === "string" && !!value.match(pattern$2.hex);
  }
};
var type$1 = function type(rule, value, source, errors, options) {
  if (rule.required && value === void 0) {
    required$1(rule, value, source, errors, options);
    return;
  }
  var custom = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"];
  var ruleType = rule.type;
  if (custom.indexOf(ruleType) > -1) {
    if (!types[ruleType](value)) {
      errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
    }
  } else if (ruleType && typeof value !== rule.type) {
    errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
  }
};
var range = function range2(rule, value, source, errors, options) {
  var len2 = typeof rule.len === "number";
  var min3 = typeof rule.min === "number";
  var max3 = typeof rule.max === "number";
  var spRegexp = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
  var val = value;
  var key = null;
  var num = typeof value === "number";
  var str = typeof value === "string";
  var arr = Array.isArray(value);
  if (num) {
    key = "number";
  } else if (str) {
    key = "string";
  } else if (arr) {
    key = "array";
  }
  if (!key) {
    return false;
  }
  if (arr) {
    val = value.length;
  }
  if (str) {
    val = value.replace(spRegexp, "_").length;
  }
  if (len2) {
    if (val !== rule.len) {
      errors.push(format(options.messages[key].len, rule.fullField, rule.len));
    }
  } else if (min3 && !max3 && val < rule.min) {
    errors.push(format(options.messages[key].min, rule.fullField, rule.min));
  } else if (max3 && !min3 && val > rule.max) {
    errors.push(format(options.messages[key].max, rule.fullField, rule.max));
  } else if (min3 && max3 && (val < rule.min || val > rule.max)) {
    errors.push(format(options.messages[key].range, rule.fullField, rule.min, rule.max));
  }
};
var ENUM$1 = "enum";
var enumerable$1 = function enumerable(rule, value, source, errors, options) {
  rule[ENUM$1] = Array.isArray(rule[ENUM$1]) ? rule[ENUM$1] : [];
  if (rule[ENUM$1].indexOf(value) === -1) {
    errors.push(format(options.messages[ENUM$1], rule.fullField, rule[ENUM$1].join(", ")));
  }
};
var pattern$1 = function pattern(rule, value, source, errors, options) {
  if (rule.pattern) {
    if (rule.pattern instanceof RegExp) {
      rule.pattern.lastIndex = 0;
      if (!rule.pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    } else if (typeof rule.pattern === "string") {
      var _pattern = new RegExp(rule.pattern);
      if (!_pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    }
  }
};
var rules = {
  required: required$1,
  whitespace,
  type: type$1,
  range,
  "enum": enumerable$1,
  pattern: pattern$1
};
var string = function string2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "string");
    if (!isEmptyValue(value, "string")) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
      rules.pattern(rule, value, source, errors, options);
      if (rule.whitespace === true) {
        rules.whitespace(rule, value, source, errors, options);
      }
    }
  }
  callback(errors);
};
var method2 = function method3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var number2 = function number3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (value === "") {
      value = void 0;
    }
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var _boolean = function _boolean2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var regexp2 = function regexp3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var integer2 = function integer3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var floatFn = function floatFn2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var array2 = function array3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if ((value === void 0 || value === null) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "array");
    if (value !== void 0 && value !== null) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var object2 = function object3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var ENUM = "enum";
var enumerable2 = function enumerable3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules[ENUM](rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var pattern2 = function pattern3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "string")) {
      rules.pattern(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var date2 = function date3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "date") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "date")) {
      var dateObject;
      if (value instanceof Date) {
        dateObject = value;
      } else {
        dateObject = new Date(value);
      }
      rules.type(rule, dateObject, source, errors, options);
      if (dateObject) {
        rules.range(rule, dateObject.getTime(), source, errors, options);
      }
    }
  }
  callback(errors);
};
var required2 = function required3(rule, value, callback, source, options) {
  var errors = [];
  var type4 = Array.isArray(value) ? "array" : typeof value;
  rules.required(rule, value, source, errors, options, type4);
  callback(errors);
};
var type2 = function type3(rule, value, callback, source, options) {
  var ruleType = rule.type;
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, ruleType) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, ruleType);
    if (!isEmptyValue(value, ruleType)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var any = function any2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
  }
  callback(errors);
};
var validators = {
  string,
  method: method2,
  number: number2,
  "boolean": _boolean,
  regexp: regexp2,
  integer: integer2,
  "float": floatFn,
  array: array2,
  object: object2,
  "enum": enumerable2,
  pattern: pattern2,
  date: date2,
  url: type2,
  hex: type2,
  email: type2,
  required: required2,
  any
};
function newMessages() {
  return {
    "default": "Validation error on field %s",
    required: "%s is required",
    "enum": "%s must be one of %s",
    whitespace: "%s cannot be empty",
    date: {
      format: "%s date %s is invalid for format %s",
      parse: "%s date could not be parsed, %s is invalid ",
      invalid: "%s date %s is invalid"
    },
    types: {
      string: "%s is not a %s",
      method: "%s is not a %s (function)",
      array: "%s is not an %s",
      object: "%s is not an %s",
      number: "%s is not a %s",
      date: "%s is not a %s",
      "boolean": "%s is not a %s",
      integer: "%s is not an %s",
      "float": "%s is not a %s",
      regexp: "%s is not a valid %s",
      email: "%s is not a valid %s",
      url: "%s is not a valid %s",
      hex: "%s is not a valid %s"
    },
    string: {
      len: "%s must be exactly %s characters",
      min: "%s must be at least %s characters",
      max: "%s cannot be longer than %s characters",
      range: "%s must be between %s and %s characters"
    },
    number: {
      len: "%s must equal %s",
      min: "%s cannot be less than %s",
      max: "%s cannot be greater than %s",
      range: "%s must be between %s and %s"
    },
    array: {
      len: "%s must be exactly %s in length",
      min: "%s cannot be less than %s in length",
      max: "%s cannot be greater than %s in length",
      range: "%s must be between %s and %s in length"
    },
    pattern: {
      mismatch: "%s value %s does not match pattern %s"
    },
    clone: function clone3() {
      var cloned = JSON.parse(JSON.stringify(this));
      cloned.clone = this.clone;
      return cloned;
    }
  };
}
var messages = newMessages();
var Schema = /* @__PURE__ */ function() {
  function Schema2(descriptor) {
    this.rules = null;
    this._messages = messages;
    this.define(descriptor);
  }
  var _proto = Schema2.prototype;
  _proto.define = function define(rules2) {
    var _this = this;
    if (!rules2) {
      throw new Error("Cannot configure a schema with no rules");
    }
    if (typeof rules2 !== "object" || Array.isArray(rules2)) {
      throw new Error("Rules must be an object");
    }
    this.rules = {};
    Object.keys(rules2).forEach(function(name) {
      var item = rules2[name];
      _this.rules[name] = Array.isArray(item) ? item : [item];
    });
  };
  _proto.messages = function messages2(_messages) {
    if (_messages) {
      this._messages = deepMerge(newMessages(), _messages);
    }
    return this._messages;
  };
  _proto.validate = function validate(source_, o, oc2) {
    var _this2 = this;
    if (o === void 0) {
      o = {};
    }
    if (oc2 === void 0) {
      oc2 = function oc3() {
      };
    }
    var source = source_;
    var options = o;
    var callback = oc2;
    if (typeof options === "function") {
      callback = options;
      options = {};
    }
    if (!this.rules || Object.keys(this.rules).length === 0) {
      if (callback) {
        callback(null, source);
      }
      return Promise.resolve(source);
    }
    function complete(results) {
      var errors = [];
      var fields = {};
      function add2(e2) {
        if (Array.isArray(e2)) {
          var _errors;
          errors = (_errors = errors).concat.apply(_errors, e2);
        } else {
          errors.push(e2);
        }
      }
      for (var i = 0; i < results.length; i++) {
        add2(results[i]);
      }
      if (!errors.length) {
        callback(null, source);
      } else {
        fields = convertFieldsError(errors);
        callback(errors, fields);
      }
    }
    if (options.messages) {
      var messages$1 = this.messages();
      if (messages$1 === messages) {
        messages$1 = newMessages();
      }
      deepMerge(messages$1, options.messages);
      options.messages = messages$1;
    } else {
      options.messages = this.messages();
    }
    var series = {};
    var keys2 = options.keys || Object.keys(this.rules);
    keys2.forEach(function(z2) {
      var arr = _this2.rules[z2];
      var value = source[z2];
      arr.forEach(function(r2) {
        var rule = r2;
        if (typeof rule.transform === "function") {
          if (source === source_) {
            source = _extends({}, source);
          }
          value = source[z2] = rule.transform(value);
        }
        if (typeof rule === "function") {
          rule = {
            validator: rule
          };
        } else {
          rule = _extends({}, rule);
        }
        rule.validator = _this2.getValidationMethod(rule);
        if (!rule.validator) {
          return;
        }
        rule.field = z2;
        rule.fullField = rule.fullField || z2;
        rule.type = _this2.getType(rule);
        series[z2] = series[z2] || [];
        series[z2].push({
          rule,
          value,
          source,
          field: z2
        });
      });
    });
    var errorFields = {};
    return asyncMap(series, options, function(data, doIt) {
      var rule = data.rule;
      var deep = (rule.type === "object" || rule.type === "array") && (typeof rule.fields === "object" || typeof rule.defaultField === "object");
      deep = deep && (rule.required || !rule.required && data.value);
      rule.field = data.field;
      function addFullField(key, schema) {
        return _extends({}, schema, {
          fullField: rule.fullField + "." + key,
          fullFields: rule.fullFields ? [].concat(rule.fullFields, [key]) : [key]
        });
      }
      function cb2(e2) {
        if (e2 === void 0) {
          e2 = [];
        }
        var errorList = Array.isArray(e2) ? e2 : [e2];
        if (!options.suppressWarning && errorList.length) {
          Schema2.warning("async-validator:", errorList);
        }
        if (errorList.length && rule.message !== void 0) {
          errorList = [].concat(rule.message);
        }
        var filledErrors = errorList.map(complementError(rule, source));
        if (options.first && filledErrors.length) {
          errorFields[rule.field] = 1;
          return doIt(filledErrors);
        }
        if (!deep) {
          doIt(filledErrors);
        } else {
          if (rule.required && !data.value) {
            if (rule.message !== void 0) {
              filledErrors = [].concat(rule.message).map(complementError(rule, source));
            } else if (options.error) {
              filledErrors = [options.error(rule, format(options.messages.required, rule.field))];
            }
            return doIt(filledErrors);
          }
          var fieldsSchema = {};
          if (rule.defaultField) {
            Object.keys(data.value).map(function(key) {
              fieldsSchema[key] = rule.defaultField;
            });
          }
          fieldsSchema = _extends({}, fieldsSchema, data.rule.fields);
          var paredFieldsSchema = {};
          Object.keys(fieldsSchema).forEach(function(field) {
            var fieldSchema = fieldsSchema[field];
            var fieldSchemaList = Array.isArray(fieldSchema) ? fieldSchema : [fieldSchema];
            paredFieldsSchema[field] = fieldSchemaList.map(addFullField.bind(null, field));
          });
          var schema = new Schema2(paredFieldsSchema);
          schema.messages(options.messages);
          if (data.rule.options) {
            data.rule.options.messages = options.messages;
            data.rule.options.error = options.error;
          }
          schema.validate(data.value, data.rule.options || options, function(errs) {
            var finalErrors = [];
            if (filledErrors && filledErrors.length) {
              finalErrors.push.apply(finalErrors, filledErrors);
            }
            if (errs && errs.length) {
              finalErrors.push.apply(finalErrors, errs);
            }
            doIt(finalErrors.length ? finalErrors : null);
          });
        }
      }
      var res;
      if (rule.asyncValidator) {
        res = rule.asyncValidator(rule, data.value, cb2, data.source, options);
      } else if (rule.validator) {
        res = rule.validator(rule, data.value, cb2, data.source, options);
        if (res === true) {
          cb2();
        } else if (res === false) {
          cb2(typeof rule.message === "function" ? rule.message(rule.fullField || rule.field) : rule.message || (rule.fullField || rule.field) + " fails");
        } else if (res instanceof Array) {
          cb2(res);
        } else if (res instanceof Error) {
          cb2(res.message);
        }
      }
      if (res && res.then) {
        res.then(function() {
          return cb2();
        }, function(e2) {
          return cb2(e2);
        });
      }
    }, function(results) {
      complete(results);
    }, source);
  };
  _proto.getType = function getType(rule) {
    if (rule.type === void 0 && rule.pattern instanceof RegExp) {
      rule.type = "pattern";
    }
    if (typeof rule.validator !== "function" && rule.type && !validators.hasOwnProperty(rule.type)) {
      throw new Error(format("Unknown rule type %s", rule.type));
    }
    return rule.type || "string";
  };
  _proto.getValidationMethod = function getValidationMethod(rule) {
    if (typeof rule.validator === "function") {
      return rule.validator;
    }
    var keys2 = Object.keys(rule);
    var messageIndex = keys2.indexOf("message");
    if (messageIndex !== -1) {
      keys2.splice(messageIndex, 1);
    }
    if (keys2.length === 1 && keys2[0] === "required") {
      return validators.required;
    }
    return validators[this.getType(rule)] || void 0;
  };
  return Schema2;
}();
Schema.register = function register2(type4, validator) {
  if (typeof validator !== "function") {
    throw new Error("Cannot register a validator by type, validator is not a function");
  }
  validators[type4] = validator;
};
Schema.warning = warning;
Schema.messages = messages;
Schema.validators = validators;
var typeTemplate$1 = "'${name}' is not a valid ${type}";
var defaultValidateMessages = {
  default: "Validation error on field '${name}'",
  required: "'${name}' is required",
  enum: "'${name}' must be one of [${enum}]",
  whitespace: "'${name}' cannot be empty",
  date: {
    format: "'${name}' is invalid for format date",
    parse: "'${name}' could not be parsed as date",
    invalid: "'${name}' is invalid date"
  },
  types: {
    string: typeTemplate$1,
    method: typeTemplate$1,
    array: typeTemplate$1,
    object: typeTemplate$1,
    number: typeTemplate$1,
    date: typeTemplate$1,
    boolean: typeTemplate$1,
    integer: typeTemplate$1,
    float: typeTemplate$1,
    regexp: typeTemplate$1,
    email: typeTemplate$1,
    url: typeTemplate$1,
    hex: typeTemplate$1
  },
  string: {
    len: "'${name}' must be exactly ${len} characters",
    min: "'${name}' must be at least ${min} characters",
    max: "'${name}' cannot be longer than ${max} characters",
    range: "'${name}' must be between ${min} and ${max} characters"
  },
  number: {
    len: "'${name}' must equal ${len}",
    min: "'${name}' cannot be less than ${min}",
    max: "'${name}' cannot be greater than ${max}",
    range: "'${name}' must be between ${min} and ${max}"
  },
  array: {
    len: "'${name}' must be exactly ${len} in length",
    min: "'${name}' cannot be less than ${min} in length",
    max: "'${name}' cannot be greater than ${max} in length",
    range: "'${name}' must be between ${min} and ${max} in length"
  },
  pattern: {
    mismatch: "'${name}' does not match pattern ${pattern}"
  }
};
function get(entity, path) {
  var current = entity;
  for (var i = 0; i < path.length; i += 1) {
    if (current === null || current === void 0) {
      return void 0;
    }
    current = current[path[i]];
  }
  return current;
}
function _toArray(arr) {
  return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
}
function internalSet(entity, paths, value, removeIfUndefined) {
  if (!paths.length) {
    return value;
  }
  var _paths = _toArray(paths), path = _paths[0], restPath = _paths.slice(1);
  var clone3;
  if (!entity && typeof path === "number") {
    clone3 = [];
  } else if (Array.isArray(entity)) {
    clone3 = _toConsumableArray(entity);
  } else {
    clone3 = _objectSpread2$1({}, entity);
  }
  if (removeIfUndefined && value === void 0 && restPath.length === 1) {
    delete clone3[path][restPath[0]];
  } else {
    clone3[path] = internalSet(clone3[path], restPath, value, removeIfUndefined);
  }
  return clone3;
}
function set(entity, paths, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  if (paths.length && removeIfUndefined && value === void 0 && !get(entity, paths.slice(0, -1))) {
    return entity;
  }
  return internalSet(entity, paths, value, removeIfUndefined);
}
function getNamePath(path) {
  return toArray(path);
}
function getValue(store, namePath) {
  var value = get(store, namePath);
  return value;
}
function setValue(store, namePath, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  var newStore = set(store, namePath, value, removeIfUndefined);
  return newStore;
}
function cloneByNamePathList(store, namePathList) {
  var newStore = {};
  namePathList.forEach(function(namePath) {
    var value = getValue(store, namePath);
    newStore = setValue(newStore, namePath, value);
  });
  return newStore;
}
function containsNamePath(namePathList, namePath) {
  return namePathList && namePathList.some(function(path) {
    return matchNamePath(path, namePath);
  });
}
function isObject(obj) {
  return _typeof$1(obj) === "object" && obj !== null && Object.getPrototypeOf(obj) === Object.prototype;
}
function internalSetValues(store, values) {
  var newStore = Array.isArray(store) ? _toConsumableArray(store) : _objectSpread2$1({}, store);
  if (!values) {
    return newStore;
  }
  Object.keys(values).forEach(function(key) {
    var prevValue = newStore[key];
    var value = values[key];
    var recursive = isObject(prevValue) && isObject(value);
    newStore[key] = recursive ? internalSetValues(prevValue, value || {}) : value;
  });
  return newStore;
}
function setValues(store) {
  for (var _len = arguments.length, restValues = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    restValues[_key - 1] = arguments[_key];
  }
  return restValues.reduce(function(current, newStore) {
    return internalSetValues(current, newStore);
  }, store);
}
function matchNamePath(namePath, changedNamePath) {
  if (!namePath || !changedNamePath || namePath.length !== changedNamePath.length) {
    return false;
  }
  return namePath.every(function(nameUnit, i) {
    return changedNamePath[i] === nameUnit;
  });
}
function isSimilar(source, target) {
  if (source === target) {
    return true;
  }
  if (!source && target || source && !target) {
    return false;
  }
  if (!source || !target || _typeof$1(source) !== "object" || _typeof$1(target) !== "object") {
    return false;
  }
  var sourceKeys = Object.keys(source);
  var targetKeys = Object.keys(target);
  var keys2 = new Set([].concat(_toConsumableArray(sourceKeys), _toConsumableArray(targetKeys)));
  return _toConsumableArray(keys2).every(function(key) {
    var sourceValue = source[key];
    var targetValue = target[key];
    if (typeof sourceValue === "function" && typeof targetValue === "function") {
      return true;
    }
    return sourceValue === targetValue;
  });
}
function defaultGetValueFromEvent(valuePropName) {
  var event = arguments.length <= 1 ? void 0 : arguments[1];
  if (event && event.target && _typeof$1(event.target) === "object" && valuePropName in event.target) {
    return event.target[valuePropName];
  }
  return event;
}
function move(array4, moveIndex, toIndex) {
  var length = array4.length;
  if (moveIndex < 0 || moveIndex >= length || toIndex < 0 || toIndex >= length) {
    return array4;
  }
  var item = array4[moveIndex];
  var diff = moveIndex - toIndex;
  if (diff > 0) {
    return [].concat(_toConsumableArray(array4.slice(0, toIndex)), [item], _toConsumableArray(array4.slice(toIndex, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, length)));
  }
  if (diff < 0) {
    return [].concat(_toConsumableArray(array4.slice(0, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, toIndex + 1)), [item], _toConsumableArray(array4.slice(toIndex + 1, length)));
  }
  return array4;
}
var AsyncValidator = Schema;
function replaceMessage(template, kv) {
  return template.replace(/\$\{\w+\}/g, function(str) {
    var key = str.slice(2, -1);
    return kv[key];
  });
}
function validateRule(_x, _x2, _x3, _x4, _x5) {
  return _validateRule.apply(this, arguments);
}
function _validateRule() {
  _validateRule = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee2(name, value, rule, options, messageVariables) {
    var cloneRule, subRuleField, validator, messages2, result, subResults, kv, fillVariableResult;
    return regenerator.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            cloneRule = _objectSpread2$1({}, rule);
            delete cloneRule.ruleIndex;
            subRuleField = null;
            if (cloneRule && cloneRule.type === "array" && cloneRule.defaultField) {
              subRuleField = cloneRule.defaultField;
              delete cloneRule.defaultField;
            }
            validator = new AsyncValidator(_defineProperty$1({}, name, [cloneRule]));
            messages2 = setValues({}, defaultValidateMessages, options.validateMessages);
            validator.messages(messages2);
            result = [];
            _context2.prev = 8;
            _context2.next = 11;
            return Promise.resolve(validator.validate(_defineProperty$1({}, name, value), _objectSpread2$1({}, options)));
          case 11:
            _context2.next = 16;
            break;
          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](8);
            if (_context2.t0.errors) {
              result = _context2.t0.errors.map(function(_ref4, index2) {
                var message = _ref4.message;
                return /* @__PURE__ */ React.isValidElement(message) ? /* @__PURE__ */ React.cloneElement(message, {
                  key: "error_".concat(index2)
                }) : message;
              });
            } else {
              console.error(_context2.t0);
              result = [messages2.default];
            }
          case 16:
            if (!(!result.length && subRuleField)) {
              _context2.next = 21;
              break;
            }
            _context2.next = 19;
            return Promise.all(value.map(function(subValue, i) {
              return validateRule("".concat(name, ".").concat(i), subValue, subRuleField, options, messageVariables);
            }));
          case 19:
            subResults = _context2.sent;
            return _context2.abrupt("return", subResults.reduce(function(prev, errors) {
              return [].concat(_toConsumableArray(prev), _toConsumableArray(errors));
            }, []));
          case 21:
            kv = _objectSpread2$1(_objectSpread2$1({}, rule), {}, {
              name,
              enum: (rule.enum || []).join(", ")
            }, messageVariables);
            fillVariableResult = result.map(function(error) {
              if (typeof error === "string") {
                return replaceMessage(error, kv);
              }
              return error;
            });
            return _context2.abrupt("return", fillVariableResult);
          case 24:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[8, 13]]);
  }));
  return _validateRule.apply(this, arguments);
}
function validateRules(namePath, value, rules2, options, validateFirst, messageVariables) {
  var name = namePath.join(".");
  var filledRules = rules2.map(function(currentRule, ruleIndex) {
    var originValidatorFunc = currentRule.validator;
    var cloneRule = _objectSpread2$1(_objectSpread2$1({}, currentRule), {}, {
      ruleIndex
    });
    if (originValidatorFunc) {
      cloneRule.validator = function(rule, val, callback) {
        var hasPromise = false;
        var wrappedCallback = function wrappedCallback2() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          Promise.resolve().then(function() {
            warningOnce(!hasPromise, "Your validator function has already return a promise. `callback` will be ignored.");
            if (!hasPromise) {
              callback.apply(void 0, args);
            }
          });
        };
        var promise = originValidatorFunc(rule, val, wrappedCallback);
        hasPromise = promise && typeof promise.then === "function" && typeof promise.catch === "function";
        warningOnce(hasPromise, "`callback` is deprecated. Please return a promise instead.");
        if (hasPromise) {
          promise.then(function() {
            callback();
          }).catch(function(err) {
            callback(err || " ");
          });
        }
      };
    }
    return cloneRule;
  }).sort(function(_ref, _ref2) {
    var w1 = _ref.warningOnly, i1 = _ref.ruleIndex;
    var w2 = _ref2.warningOnly, i2 = _ref2.ruleIndex;
    if (!!w1 === !!w2) {
      return i1 - i2;
    }
    if (w1) {
      return 1;
    }
    return -1;
  });
  var summaryPromise;
  if (validateFirst === true) {
    summaryPromise = new Promise(/* @__PURE__ */ function() {
      var _ref3 = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee(resolve, reject) {
        var i, rule, errors;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                i = 0;
              case 1:
                if (!(i < filledRules.length)) {
                  _context.next = 12;
                  break;
                }
                rule = filledRules[i];
                _context.next = 5;
                return validateRule(name, value, rule, options, messageVariables);
              case 5:
                errors = _context.sent;
                if (!errors.length) {
                  _context.next = 9;
                  break;
                }
                reject([{
                  errors,
                  rule
                }]);
                return _context.abrupt("return");
              case 9:
                i += 1;
                _context.next = 1;
                break;
              case 12:
                resolve([]);
              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return function(_x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }());
  } else {
    var rulePromises = filledRules.map(function(rule) {
      return validateRule(name, value, rule, options, messageVariables).then(function(errors) {
        return {
          errors,
          rule
        };
      });
    });
    summaryPromise = (validateFirst ? finishOnFirstFailed(rulePromises) : finishOnAllFailed(rulePromises)).then(function(errors) {
      return Promise.reject(errors);
    });
  }
  summaryPromise.catch(function(e2) {
    return e2;
  });
  return summaryPromise;
}
function finishOnAllFailed(_x8) {
  return _finishOnAllFailed.apply(this, arguments);
}
function _finishOnAllFailed() {
  _finishOnAllFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee3(rulePromises) {
    return regenerator.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", Promise.all(rulePromises).then(function(errorsList) {
              var _ref5;
              var errors = (_ref5 = []).concat.apply(_ref5, _toConsumableArray(errorsList));
              return errors;
            }));
          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _finishOnAllFailed.apply(this, arguments);
}
function finishOnFirstFailed(_x9) {
  return _finishOnFirstFailed.apply(this, arguments);
}
function _finishOnFirstFailed() {
  _finishOnFirstFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee4(rulePromises) {
    var count2;
    return regenerator.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            count2 = 0;
            return _context4.abrupt("return", new Promise(function(resolve) {
              rulePromises.forEach(function(promise) {
                promise.then(function(ruleError) {
                  if (ruleError.errors.length) {
                    resolve([ruleError]);
                  }
                  count2 += 1;
                  if (count2 === rulePromises.length) {
                    resolve([]);
                  }
                });
              });
            }));
          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _finishOnFirstFailed.apply(this, arguments);
}
var _excluded$h = ["name"];
var EMPTY_ERRORS = [];
function requireUpdate(shouldUpdate, prev, next, prevValue, nextValue, info) {
  if (typeof shouldUpdate === "function") {
    return shouldUpdate(prev, next, "source" in info ? {
      source: info.source
    } : {});
  }
  return prevValue !== nextValue;
}
var Field = /* @__PURE__ */ function(_React$Component) {
  _inherits(Field2, _React$Component);
  var _super = _createSuper(Field2);
  function Field2(props) {
    var _this;
    _classCallCheck(this, Field2);
    _this = _super.call(this, props);
    _this.state = {
      resetCount: 0
    };
    _this.cancelRegisterFunc = null;
    _this.mounted = false;
    _this.touched = false;
    _this.dirty = false;
    _this.validatePromise = null;
    _this.prevValidating = void 0;
    _this.errors = EMPTY_ERRORS;
    _this.warnings = EMPTY_ERRORS;
    _this.cancelRegister = function() {
      var _this$props = _this.props, preserve = _this$props.preserve, isListField = _this$props.isListField, name = _this$props.name;
      if (_this.cancelRegisterFunc) {
        _this.cancelRegisterFunc(isListField, preserve, getNamePath(name));
      }
      _this.cancelRegisterFunc = null;
    };
    _this.getNamePath = function() {
      var _this$props2 = _this.props, name = _this$props2.name, fieldContext = _this$props2.fieldContext;
      var _fieldContext$prefixN = fieldContext.prefixName, prefixName = _fieldContext$prefixN === void 0 ? [] : _fieldContext$prefixN;
      return name !== void 0 ? [].concat(_toConsumableArray(prefixName), _toConsumableArray(name)) : [];
    };
    _this.getRules = function() {
      var _this$props3 = _this.props, _this$props3$rules = _this$props3.rules, rules2 = _this$props3$rules === void 0 ? [] : _this$props3$rules, fieldContext = _this$props3.fieldContext;
      return rules2.map(function(rule) {
        if (typeof rule === "function") {
          return rule(fieldContext);
        }
        return rule;
      });
    };
    _this.refresh = function() {
      if (!_this.mounted)
        return;
      _this.setState(function(_ref) {
        var resetCount = _ref.resetCount;
        return {
          resetCount: resetCount + 1
        };
      });
    };
    _this.triggerMetaEvent = function(destroy) {
      var onMetaChange = _this.props.onMetaChange;
      onMetaChange === null || onMetaChange === void 0 ? void 0 : onMetaChange(_objectSpread2$1(_objectSpread2$1({}, _this.getMeta()), {}, {
        destroy
      }));
    };
    _this.onStoreChange = function(prevStore, namePathList, info) {
      var _this$props4 = _this.props, shouldUpdate = _this$props4.shouldUpdate, _this$props4$dependen = _this$props4.dependencies, dependencies = _this$props4$dependen === void 0 ? [] : _this$props4$dependen, onReset = _this$props4.onReset;
      var store = info.store;
      var namePath = _this.getNamePath();
      var prevValue = _this.getValue(prevStore);
      var curValue = _this.getValue(store);
      var namePathMatch = namePathList && containsNamePath(namePathList, namePath);
      if (info.type === "valueUpdate" && info.source === "external" && prevValue !== curValue) {
        _this.touched = true;
        _this.dirty = true;
        _this.validatePromise = null;
        _this.errors = EMPTY_ERRORS;
        _this.warnings = EMPTY_ERRORS;
        _this.triggerMetaEvent();
      }
      switch (info.type) {
        case "reset":
          if (!namePathList || namePathMatch) {
            _this.touched = false;
            _this.dirty = false;
            _this.validatePromise = null;
            _this.errors = EMPTY_ERRORS;
            _this.warnings = EMPTY_ERRORS;
            _this.triggerMetaEvent();
            onReset === null || onReset === void 0 ? void 0 : onReset();
            _this.refresh();
            return;
          }
          break;
        case "remove": {
          if (shouldUpdate) {
            _this.reRender();
            return;
          }
          break;
        }
        case "setField": {
          if (namePathMatch) {
            var data = info.data;
            if ("touched" in data) {
              _this.touched = data.touched;
            }
            if ("validating" in data && !("originRCField" in data)) {
              _this.validatePromise = data.validating ? Promise.resolve([]) : null;
            }
            if ("errors" in data) {
              _this.errors = data.errors || EMPTY_ERRORS;
            }
            if ("warnings" in data) {
              _this.warnings = data.warnings || EMPTY_ERRORS;
            }
            _this.dirty = true;
            _this.triggerMetaEvent();
            _this.reRender();
            return;
          }
          if (shouldUpdate && !namePath.length && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
        }
        case "dependenciesUpdate": {
          var dependencyList = dependencies.map(getNamePath);
          if (dependencyList.some(function(dependency) {
            return containsNamePath(info.relatedFields, dependency);
          })) {
            _this.reRender();
            return;
          }
          break;
        }
        default:
          if (namePathMatch || (!dependencies.length || namePath.length || shouldUpdate) && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
      }
      if (shouldUpdate === true) {
        _this.reRender();
      }
    };
    _this.validateRules = function(options) {
      var namePath = _this.getNamePath();
      var currentValue = _this.getValue();
      var rootPromise = Promise.resolve().then(function() {
        if (!_this.mounted) {
          return [];
        }
        var _this$props5 = _this.props, _this$props5$validate = _this$props5.validateFirst, validateFirst = _this$props5$validate === void 0 ? false : _this$props5$validate, messageVariables = _this$props5.messageVariables;
        var _ref2 = options || {}, triggerName = _ref2.triggerName;
        var filteredRules = _this.getRules();
        if (triggerName) {
          filteredRules = filteredRules.filter(function(rule) {
            var validateTrigger = rule.validateTrigger;
            if (!validateTrigger) {
              return true;
            }
            var triggerList = toArray(validateTrigger);
            return triggerList.includes(triggerName);
          });
        }
        var promise = validateRules(namePath, currentValue, filteredRules, options, validateFirst, messageVariables);
        promise.catch(function(e2) {
          return e2;
        }).then(function() {
          var ruleErrors = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : EMPTY_ERRORS;
          if (_this.validatePromise === rootPromise) {
            _this.validatePromise = null;
            var nextErrors = [];
            var nextWarnings = [];
            ruleErrors.forEach(function(_ref3) {
              var warningOnly = _ref3.rule.warningOnly, _ref3$errors = _ref3.errors, errors = _ref3$errors === void 0 ? EMPTY_ERRORS : _ref3$errors;
              if (warningOnly) {
                nextWarnings.push.apply(nextWarnings, _toConsumableArray(errors));
              } else {
                nextErrors.push.apply(nextErrors, _toConsumableArray(errors));
              }
            });
            _this.errors = nextErrors;
            _this.warnings = nextWarnings;
            _this.triggerMetaEvent();
            _this.reRender();
          }
        });
        return promise;
      });
      _this.validatePromise = rootPromise;
      _this.dirty = true;
      _this.errors = EMPTY_ERRORS;
      _this.warnings = EMPTY_ERRORS;
      _this.triggerMetaEvent();
      _this.reRender();
      return rootPromise;
    };
    _this.isFieldValidating = function() {
      return !!_this.validatePromise;
    };
    _this.isFieldTouched = function() {
      return _this.touched;
    };
    _this.isFieldDirty = function() {
      if (_this.dirty || _this.props.initialValue !== void 0) {
        return true;
      }
      var fieldContext = _this.props.fieldContext;
      var _fieldContext$getInte = fieldContext.getInternalHooks(HOOK_MARK), getInitialValue = _fieldContext$getInte.getInitialValue;
      if (getInitialValue(_this.getNamePath()) !== void 0) {
        return true;
      }
      return false;
    };
    _this.getErrors = function() {
      return _this.errors;
    };
    _this.getWarnings = function() {
      return _this.warnings;
    };
    _this.isListField = function() {
      return _this.props.isListField;
    };
    _this.isList = function() {
      return _this.props.isList;
    };
    _this.isPreserve = function() {
      return _this.props.preserve;
    };
    _this.getMeta = function() {
      _this.prevValidating = _this.isFieldValidating();
      var meta = {
        touched: _this.isFieldTouched(),
        validating: _this.prevValidating,
        errors: _this.errors,
        warnings: _this.warnings,
        name: _this.getNamePath()
      };
      return meta;
    };
    _this.getOnlyChild = function(children) {
      if (typeof children === "function") {
        var meta = _this.getMeta();
        return _objectSpread2$1(_objectSpread2$1({}, _this.getOnlyChild(children(_this.getControlled(), meta, _this.props.fieldContext))), {}, {
          isFunction: true
        });
      }
      var childList = toArray$1(children);
      if (childList.length !== 1 || !/* @__PURE__ */ React.isValidElement(childList[0])) {
        return {
          child: childList,
          isFunction: false
        };
      }
      return {
        child: childList[0],
        isFunction: false
      };
    };
    _this.getValue = function(store) {
      var getFieldsValue = _this.props.fieldContext.getFieldsValue;
      var namePath = _this.getNamePath();
      return getValue(store || getFieldsValue(true), namePath);
    };
    _this.getControlled = function() {
      var childProps = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      var _this$props6 = _this.props, trigger2 = _this$props6.trigger, validateTrigger = _this$props6.validateTrigger, getValueFromEvent = _this$props6.getValueFromEvent, normalize2 = _this$props6.normalize, valuePropName = _this$props6.valuePropName, getValueProps = _this$props6.getValueProps, fieldContext = _this$props6.fieldContext;
      var mergedValidateTrigger = validateTrigger !== void 0 ? validateTrigger : fieldContext.validateTrigger;
      var namePath = _this.getNamePath();
      var getInternalHooks3 = fieldContext.getInternalHooks, getFieldsValue = fieldContext.getFieldsValue;
      var _getInternalHooks = getInternalHooks3(HOOK_MARK), dispatch2 = _getInternalHooks.dispatch;
      var value = _this.getValue();
      var mergedGetValueProps = getValueProps || function(val) {
        return _defineProperty$1({}, valuePropName, val);
      };
      var originTriggerFunc = childProps[trigger2];
      var control = _objectSpread2$1(_objectSpread2$1({}, childProps), mergedGetValueProps(value));
      control[trigger2] = function() {
        _this.touched = true;
        _this.dirty = true;
        _this.triggerMetaEvent();
        var newValue;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        if (getValueFromEvent) {
          newValue = getValueFromEvent.apply(void 0, args);
        } else {
          newValue = defaultGetValueFromEvent.apply(void 0, [valuePropName].concat(args));
        }
        if (normalize2) {
          newValue = normalize2(newValue, value, getFieldsValue(true));
        }
        dispatch2({
          type: "updateValue",
          namePath,
          value: newValue
        });
        if (originTriggerFunc) {
          originTriggerFunc.apply(void 0, args);
        }
      };
      var validateTriggerList = toArray(mergedValidateTrigger || []);
      validateTriggerList.forEach(function(triggerName) {
        var originTrigger = control[triggerName];
        control[triggerName] = function() {
          if (originTrigger) {
            originTrigger.apply(void 0, arguments);
          }
          var rules2 = _this.props.rules;
          if (rules2 && rules2.length) {
            dispatch2({
              type: "validateField",
              namePath,
              triggerName
            });
          }
        };
      });
      return control;
    };
    if (props.fieldContext) {
      var getInternalHooks2 = props.fieldContext.getInternalHooks;
      var _getInternalHooks2 = getInternalHooks2(HOOK_MARK), initEntityValue = _getInternalHooks2.initEntityValue;
      initEntityValue(_assertThisInitialized(_this));
    }
    return _this;
  }
  _createClass(Field2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props7 = this.props, shouldUpdate = _this$props7.shouldUpdate, fieldContext = _this$props7.fieldContext;
      this.mounted = true;
      if (fieldContext) {
        var getInternalHooks2 = fieldContext.getInternalHooks;
        var _getInternalHooks3 = getInternalHooks2(HOOK_MARK), registerField = _getInternalHooks3.registerField;
        this.cancelRegisterFunc = registerField(this);
      }
      if (shouldUpdate === true) {
        this.reRender();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cancelRegister();
      this.triggerMetaEvent(true);
      this.mounted = false;
    }
  }, {
    key: "reRender",
    value: function reRender() {
      if (!this.mounted)
        return;
      this.forceUpdate();
    }
  }, {
    key: "render",
    value: function render2() {
      var resetCount = this.state.resetCount;
      var children = this.props.children;
      var _this$getOnlyChild = this.getOnlyChild(children), child = _this$getOnlyChild.child, isFunction2 = _this$getOnlyChild.isFunction;
      var returnChildNode;
      if (isFunction2) {
        returnChildNode = child;
      } else if (/* @__PURE__ */ React.isValidElement(child)) {
        returnChildNode = /* @__PURE__ */ React.cloneElement(child, this.getControlled(child.props));
      } else {
        warningOnce(!child, "`children` of Field is not validate ReactElement.");
        returnChildNode = child;
      }
      return /* @__PURE__ */ React.createElement(React.Fragment, {
        key: resetCount
      }, returnChildNode);
    }
  }]);
  return Field2;
}(React.Component);
Field.contextType = Context;
Field.defaultProps = {
  trigger: "onChange",
  valuePropName: "value"
};
function WrapperField(_ref5) {
  var name = _ref5.name, restProps = _objectWithoutProperties(_ref5, _excluded$h);
  var fieldContext = React.useContext(Context);
  var namePath = name !== void 0 ? getNamePath(name) : void 0;
  var key = "keep";
  if (!restProps.isListField) {
    key = "_".concat((namePath || []).join("_"));
  }
  return /* @__PURE__ */ React.createElement(Field, _extends$1({
    key,
    name: namePath
  }, restProps, {
    fieldContext
  }));
}
var ListContext = /* @__PURE__ */ React.createContext(null);
var List = function List2(_ref) {
  var name = _ref.name, initialValue = _ref.initialValue, children = _ref.children, rules2 = _ref.rules, validateTrigger = _ref.validateTrigger;
  var context = React.useContext(Context);
  var keyRef = React.useRef({
    keys: [],
    id: 0
  });
  var keyManager = keyRef.current;
  var prefixName = React.useMemo(function() {
    var parentPrefixName = getNamePath(context.prefixName) || [];
    return [].concat(_toConsumableArray(parentPrefixName), _toConsumableArray(getNamePath(name)));
  }, [context.prefixName, name]);
  var fieldContext = React.useMemo(function() {
    return _objectSpread2$1(_objectSpread2$1({}, context), {}, {
      prefixName
    });
  }, [context, prefixName]);
  var listContext = React.useMemo(function() {
    return {
      getKey: function getKey2(namePath) {
        var len2 = prefixName.length;
        var pathName = namePath[len2];
        return [keyManager.keys[pathName], namePath.slice(len2 + 1)];
      }
    };
  }, [prefixName]);
  if (typeof children !== "function") {
    warningOnce(false, "Form.List only accepts function as children.");
    return null;
  }
  var shouldUpdate = function shouldUpdate2(prevValue, nextValue, _ref2) {
    var source = _ref2.source;
    if (source === "internal") {
      return false;
    }
    return prevValue !== nextValue;
  };
  return /* @__PURE__ */ React.createElement(ListContext.Provider, {
    value: listContext
  }, /* @__PURE__ */ React.createElement(Context.Provider, {
    value: fieldContext
  }, /* @__PURE__ */ React.createElement(WrapperField, {
    name: [],
    shouldUpdate,
    rules: rules2,
    validateTrigger,
    initialValue,
    isList: true
  }, function(_ref3, meta) {
    var _ref3$value = _ref3.value, value = _ref3$value === void 0 ? [] : _ref3$value, onChange3 = _ref3.onChange;
    var getFieldValue = context.getFieldValue;
    var getNewValue = function getNewValue2() {
      var values = getFieldValue(prefixName || []);
      return values || [];
    };
    var operations = {
      add: function add2(defaultValue, index2) {
        var newValue = getNewValue();
        if (index2 >= 0 && index2 <= newValue.length) {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys.slice(0, index2)), [keyManager.id], _toConsumableArray(keyManager.keys.slice(index2)));
          onChange3([].concat(_toConsumableArray(newValue.slice(0, index2)), [defaultValue], _toConsumableArray(newValue.slice(index2))));
        } else {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys), [keyManager.id]);
          onChange3([].concat(_toConsumableArray(newValue), [defaultValue]));
        }
        keyManager.id += 1;
      },
      remove: function remove(index2) {
        var newValue = getNewValue();
        var indexSet = new Set(Array.isArray(index2) ? index2 : [index2]);
        if (indexSet.size <= 0) {
          return;
        }
        keyManager.keys = keyManager.keys.filter(function(_, keysIndex) {
          return !indexSet.has(keysIndex);
        });
        onChange3(newValue.filter(function(_, valueIndex) {
          return !indexSet.has(valueIndex);
        }));
      },
      move: function move$1(from, to) {
        if (from === to) {
          return;
        }
        var newValue = getNewValue();
        if (from < 0 || from >= newValue.length || to < 0 || to >= newValue.length) {
          return;
        }
        keyManager.keys = move(keyManager.keys, from, to);
        onChange3(move(newValue, from, to));
      }
    };
    var listValue = value || [];
    if (!Array.isArray(listValue)) {
      listValue = [];
    }
    return children(listValue.map(function(__, index2) {
      var key = keyManager.keys[index2];
      if (key === void 0) {
        keyManager.keys[index2] = keyManager.id;
        key = keyManager.keys[index2];
        keyManager.id += 1;
      }
      return {
        name: index2,
        key,
        isListField: true
      };
    }), operations, meta);
  })));
};
function allPromiseFinish(promiseList) {
  var hasError = false;
  var count2 = promiseList.length;
  var results = [];
  if (!promiseList.length) {
    return Promise.resolve([]);
  }
  return new Promise(function(resolve, reject) {
    promiseList.forEach(function(promise, index2) {
      promise.catch(function(e2) {
        hasError = true;
        return e2;
      }).then(function(result) {
        count2 -= 1;
        results[index2] = result;
        if (count2 > 0) {
          return;
        }
        if (hasError) {
          reject(results);
        }
        resolve(results);
      });
    });
  });
}
var SPLIT = "__@field_split__";
function normalize(namePath) {
  return namePath.map(function(cell) {
    return "".concat(_typeof$1(cell), ":").concat(cell);
  }).join(SPLIT);
}
var NameMap = /* @__PURE__ */ function() {
  function NameMap2() {
    _classCallCheck(this, NameMap2);
    this.kvs = /* @__PURE__ */ new Map();
  }
  _createClass(NameMap2, [{
    key: "set",
    value: function set2(key, value) {
      this.kvs.set(normalize(key), value);
    }
  }, {
    key: "get",
    value: function get2(key) {
      return this.kvs.get(normalize(key));
    }
  }, {
    key: "update",
    value: function update(key, updater) {
      var origin = this.get(key);
      var next = updater(origin);
      if (!next) {
        this.delete(key);
      } else {
        this.set(key, next);
      }
    }
  }, {
    key: "delete",
    value: function _delete(key) {
      this.kvs.delete(normalize(key));
    }
  }, {
    key: "map",
    value: function map2(callback) {
      return _toConsumableArray(this.kvs.entries()).map(function(_ref) {
        var _ref2 = _slicedToArray(_ref, 2), key = _ref2[0], value = _ref2[1];
        var cells = key.split(SPLIT);
        return callback({
          key: cells.map(function(cell) {
            var _cell$match = cell.match(/^([^:]*):(.*)$/), _cell$match2 = _slicedToArray(_cell$match, 3), type4 = _cell$match2[1], unit = _cell$match2[2];
            return type4 === "number" ? Number(unit) : unit;
          }),
          value
        });
      });
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = {};
      this.map(function(_ref3) {
        var key = _ref3.key, value = _ref3.value;
        json[key.join(".")] = value;
        return null;
      });
      return json;
    }
  }]);
  return NameMap2;
}();
var _excluded$g = ["name", "errors"];
var FormStore = /* @__PURE__ */ _createClass(function FormStore2(forceRootUpdate) {
  var _this = this;
  _classCallCheck(this, FormStore2);
  this.formHooked = false;
  this.forceRootUpdate = void 0;
  this.subscribable = true;
  this.store = {};
  this.fieldEntities = [];
  this.initialValues = {};
  this.callbacks = {};
  this.validateMessages = null;
  this.preserve = null;
  this.lastValidatePromise = null;
  this.getForm = function() {
    return {
      getFieldValue: _this.getFieldValue,
      getFieldsValue: _this.getFieldsValue,
      getFieldError: _this.getFieldError,
      getFieldWarning: _this.getFieldWarning,
      getFieldsError: _this.getFieldsError,
      isFieldsTouched: _this.isFieldsTouched,
      isFieldTouched: _this.isFieldTouched,
      isFieldValidating: _this.isFieldValidating,
      isFieldsValidating: _this.isFieldsValidating,
      resetFields: _this.resetFields,
      setFields: _this.setFields,
      setFieldsValue: _this.setFieldsValue,
      validateFields: _this.validateFields,
      submit: _this.submit,
      getInternalHooks: _this.getInternalHooks
    };
  };
  this.getInternalHooks = function(key) {
    if (key === HOOK_MARK) {
      _this.formHooked = true;
      return {
        dispatch: _this.dispatch,
        initEntityValue: _this.initEntityValue,
        registerField: _this.registerField,
        useSubscribe: _this.useSubscribe,
        setInitialValues: _this.setInitialValues,
        setCallbacks: _this.setCallbacks,
        setValidateMessages: _this.setValidateMessages,
        getFields: _this.getFields,
        setPreserve: _this.setPreserve,
        getInitialValue: _this.getInitialValue
      };
    }
    warningOnce(false, "`getInternalHooks` is internal usage. Should not call directly.");
    return null;
  };
  this.useSubscribe = function(subscribable) {
    _this.subscribable = subscribable;
  };
  this.setInitialValues = function(initialValues, init2) {
    _this.initialValues = initialValues || {};
    if (init2) {
      _this.store = setValues({}, initialValues, _this.store);
    }
  };
  this.getInitialValue = function(namePath) {
    return getValue(_this.initialValues, namePath);
  };
  this.setCallbacks = function(callbacks) {
    _this.callbacks = callbacks;
  };
  this.setValidateMessages = function(validateMessages) {
    _this.validateMessages = validateMessages;
  };
  this.setPreserve = function(preserve) {
    _this.preserve = preserve;
  };
  this.timeoutId = null;
  this.warningUnhooked = function() {
  };
  this.getFieldEntities = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    if (!pure) {
      return _this.fieldEntities;
    }
    return _this.fieldEntities.filter(function(field) {
      return field.getNamePath().length;
    });
  };
  this.getFieldsMap = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    var cache = new NameMap();
    _this.getFieldEntities(pure).forEach(function(field) {
      var namePath = field.getNamePath();
      cache.set(namePath, field);
    });
    return cache;
  };
  this.getFieldEntitiesForNamePathList = function(nameList) {
    if (!nameList) {
      return _this.getFieldEntities(true);
    }
    var cache = _this.getFieldsMap(true);
    return nameList.map(function(name) {
      var namePath = getNamePath(name);
      return cache.get(namePath) || {
        INVALIDATE_NAME_PATH: getNamePath(name)
      };
    });
  };
  this.getFieldsValue = function(nameList, filterFunc) {
    _this.warningUnhooked();
    if (nameList === true && !filterFunc) {
      return _this.store;
    }
    var fieldEntities = _this.getFieldEntitiesForNamePathList(Array.isArray(nameList) ? nameList : null);
    var filteredNameList = [];
    fieldEntities.forEach(function(entity) {
      var _entity$isListField;
      var namePath = "INVALIDATE_NAME_PATH" in entity ? entity.INVALIDATE_NAME_PATH : entity.getNamePath();
      if (!nameList && ((_entity$isListField = entity.isListField) === null || _entity$isListField === void 0 ? void 0 : _entity$isListField.call(entity))) {
        return;
      }
      if (!filterFunc) {
        filteredNameList.push(namePath);
      } else {
        var meta = "getMeta" in entity ? entity.getMeta() : null;
        if (filterFunc(meta)) {
          filteredNameList.push(namePath);
        }
      }
    });
    return cloneByNamePathList(_this.store, filteredNameList.map(getNamePath));
  };
  this.getFieldValue = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    return getValue(_this.store, namePath);
  };
  this.getFieldsError = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntitiesForNamePathList(nameList);
    return fieldEntities.map(function(entity, index2) {
      if (entity && !("INVALIDATE_NAME_PATH" in entity)) {
        return {
          name: entity.getNamePath(),
          errors: entity.getErrors(),
          warnings: entity.getWarnings()
        };
      }
      return {
        name: getNamePath(nameList[index2]),
        errors: [],
        warnings: []
      };
    });
  };
  this.getFieldError = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.errors;
  };
  this.getFieldWarning = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.warnings;
  };
  this.isFieldsTouched = function() {
    _this.warningUnhooked();
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var arg0 = args[0], arg1 = args[1];
    var namePathList;
    var isAllFieldsTouched = false;
    if (args.length === 0) {
      namePathList = null;
    } else if (args.length === 1) {
      if (Array.isArray(arg0)) {
        namePathList = arg0.map(getNamePath);
        isAllFieldsTouched = false;
      } else {
        namePathList = null;
        isAllFieldsTouched = arg0;
      }
    } else {
      namePathList = arg0.map(getNamePath);
      isAllFieldsTouched = arg1;
    }
    var fieldEntities = _this.getFieldEntities(true);
    var isFieldTouched = function isFieldTouched2(field) {
      return field.isFieldTouched();
    };
    if (!namePathList) {
      return isAllFieldsTouched ? fieldEntities.every(isFieldTouched) : fieldEntities.some(isFieldTouched);
    }
    var map2 = new NameMap();
    namePathList.forEach(function(shortNamePath) {
      map2.set(shortNamePath, []);
    });
    fieldEntities.forEach(function(field) {
      var fieldNamePath = field.getNamePath();
      namePathList.forEach(function(shortNamePath) {
        if (shortNamePath.every(function(nameUnit, i) {
          return fieldNamePath[i] === nameUnit;
        })) {
          map2.update(shortNamePath, function(list) {
            return [].concat(_toConsumableArray(list), [field]);
          });
        }
      });
    });
    var isNamePathListTouched = function isNamePathListTouched2(entities) {
      return entities.some(isFieldTouched);
    };
    var namePathListEntities = map2.map(function(_ref) {
      var value = _ref.value;
      return value;
    });
    return isAllFieldsTouched ? namePathListEntities.every(isNamePathListTouched) : namePathListEntities.some(isNamePathListTouched);
  };
  this.isFieldTouched = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsTouched([name]);
  };
  this.isFieldsValidating = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntities();
    if (!nameList) {
      return fieldEntities.some(function(testField) {
        return testField.isFieldValidating();
      });
    }
    var namePathList = nameList.map(getNamePath);
    return fieldEntities.some(function(testField) {
      var fieldNamePath = testField.getNamePath();
      return containsNamePath(namePathList, fieldNamePath) && testField.isFieldValidating();
    });
  };
  this.isFieldValidating = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsValidating([name]);
  };
  this.resetWithFieldInitialValue = function() {
    var info = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var cache = new NameMap();
    var fieldEntities = _this.getFieldEntities(true);
    fieldEntities.forEach(function(field) {
      var initialValue = field.props.initialValue;
      var namePath = field.getNamePath();
      if (initialValue !== void 0) {
        var records = cache.get(namePath) || /* @__PURE__ */ new Set();
        records.add({
          entity: field,
          value: initialValue
        });
        cache.set(namePath, records);
      }
    });
    var resetWithFields = function resetWithFields2(entities) {
      entities.forEach(function(field) {
        var initialValue = field.props.initialValue;
        if (initialValue !== void 0) {
          var namePath = field.getNamePath();
          var formInitialValue = _this.getInitialValue(namePath);
          if (formInitialValue !== void 0) {
            warningOnce(false, "Form already set 'initialValues' with path '".concat(namePath.join("."), "'. Field can not overwrite it."));
          } else {
            var records = cache.get(namePath);
            if (records && records.size > 1) {
              warningOnce(false, "Multiple Field with path '".concat(namePath.join("."), "' set 'initialValue'. Can not decide which one to pick."));
            } else if (records) {
              var originValue = _this.getFieldValue(namePath);
              if (!info.skipExist || originValue === void 0) {
                _this.store = setValue(_this.store, namePath, _toConsumableArray(records)[0].value);
              }
            }
          }
        }
      });
    };
    var requiredFieldEntities;
    if (info.entities) {
      requiredFieldEntities = info.entities;
    } else if (info.namePathList) {
      requiredFieldEntities = [];
      info.namePathList.forEach(function(namePath) {
        var records = cache.get(namePath);
        if (records) {
          var _requiredFieldEntitie;
          (_requiredFieldEntitie = requiredFieldEntities).push.apply(_requiredFieldEntitie, _toConsumableArray(_toConsumableArray(records).map(function(r2) {
            return r2.entity;
          })));
        }
      });
    } else {
      requiredFieldEntities = fieldEntities;
    }
    resetWithFields(requiredFieldEntities);
  };
  this.resetFields = function(nameList) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (!nameList) {
      _this.store = setValues({}, _this.initialValues);
      _this.resetWithFieldInitialValue();
      _this.notifyObservers(prevStore, null, {
        type: "reset"
      });
      return;
    }
    var namePathList = nameList.map(getNamePath);
    namePathList.forEach(function(namePath) {
      var initialValue = _this.getInitialValue(namePath);
      _this.store = setValue(_this.store, namePath, initialValue);
    });
    _this.resetWithFieldInitialValue({
      namePathList
    });
    _this.notifyObservers(prevStore, namePathList, {
      type: "reset"
    });
  };
  this.setFields = function(fields) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    fields.forEach(function(fieldData) {
      var name = fieldData.name;
      fieldData.errors;
      var data = _objectWithoutProperties(fieldData, _excluded$g);
      var namePath = getNamePath(name);
      if ("value" in data) {
        _this.store = setValue(_this.store, namePath, data.value);
      }
      _this.notifyObservers(prevStore, [namePath], {
        type: "setField",
        data: fieldData
      });
    });
  };
  this.getFields = function() {
    var entities = _this.getFieldEntities(true);
    var fields = entities.map(function(field) {
      var namePath = field.getNamePath();
      var meta = field.getMeta();
      var fieldData = _objectSpread2$1(_objectSpread2$1({}, meta), {}, {
        name: namePath,
        value: _this.getFieldValue(namePath)
      });
      Object.defineProperty(fieldData, "originRCField", {
        value: true
      });
      return fieldData;
    });
    return fields;
  };
  this.initEntityValue = function(entity) {
    var initialValue = entity.props.initialValue;
    if (initialValue !== void 0) {
      var namePath = entity.getNamePath();
      var prevValue = getValue(_this.store, namePath);
      if (prevValue === void 0) {
        _this.store = setValue(_this.store, namePath, initialValue);
      }
    }
  };
  this.registerField = function(entity) {
    _this.fieldEntities.push(entity);
    if (entity.props.initialValue !== void 0) {
      var prevStore = _this.store;
      _this.resetWithFieldInitialValue({
        entities: [entity],
        skipExist: true
      });
      _this.notifyObservers(prevStore, [entity.getNamePath()], {
        type: "valueUpdate",
        source: "internal"
      });
    }
    return function(isListField, preserve) {
      var subNamePath = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
      _this.fieldEntities = _this.fieldEntities.filter(function(item) {
        return item !== entity;
      });
      var mergedPreserve = preserve !== void 0 ? preserve : _this.preserve;
      if (mergedPreserve === false && (!isListField || subNamePath.length > 1)) {
        var namePath = entity.getNamePath();
        var defaultValue = isListField ? void 0 : getValue(_this.initialValues, namePath);
        if (namePath.length && _this.getFieldValue(namePath) !== defaultValue && _this.fieldEntities.every(function(field) {
          return !matchNamePath(field.getNamePath(), namePath);
        })) {
          var _prevStore = _this.store;
          _this.store = setValue(_prevStore, namePath, defaultValue, true);
          _this.notifyObservers(_prevStore, [namePath], {
            type: "remove"
          });
          _this.triggerDependenciesUpdate(_prevStore, namePath);
        }
      }
    };
  };
  this.dispatch = function(action) {
    switch (action.type) {
      case "updateValue": {
        var namePath = action.namePath, value = action.value;
        _this.updateValue(namePath, value);
        break;
      }
      case "validateField": {
        var _namePath = action.namePath, triggerName = action.triggerName;
        _this.validateFields([_namePath], {
          triggerName
        });
        break;
      }
    }
  };
  this.notifyObservers = function(prevStore, namePathList, info) {
    if (_this.subscribable) {
      var mergedInfo = _objectSpread2$1(_objectSpread2$1({}, info), {}, {
        store: _this.getFieldsValue(true)
      });
      _this.getFieldEntities().forEach(function(_ref2) {
        var onStoreChange = _ref2.onStoreChange;
        onStoreChange(prevStore, namePathList, mergedInfo);
      });
    } else {
      _this.forceRootUpdate();
    }
  };
  this.triggerDependenciesUpdate = function(prevStore, namePath) {
    var childrenFields = _this.getDependencyChildrenFields(namePath);
    if (childrenFields.length) {
      _this.validateFields(childrenFields);
    }
    _this.notifyObservers(prevStore, childrenFields, {
      type: "dependenciesUpdate",
      relatedFields: [namePath].concat(_toConsumableArray(childrenFields))
    });
    return childrenFields;
  };
  this.updateValue = function(name, value) {
    var namePath = getNamePath(name);
    var prevStore = _this.store;
    _this.store = setValue(_this.store, namePath, value);
    _this.notifyObservers(prevStore, [namePath], {
      type: "valueUpdate",
      source: "internal"
    });
    var childrenFields = _this.triggerDependenciesUpdate(prevStore, namePath);
    var onValuesChange = _this.callbacks.onValuesChange;
    if (onValuesChange) {
      var changedValues = cloneByNamePathList(_this.store, [namePath]);
      onValuesChange(changedValues, _this.getFieldsValue());
    }
    _this.triggerOnFieldsChange([namePath].concat(_toConsumableArray(childrenFields)));
  };
  this.setFieldsValue = function(store) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (store) {
      _this.store = setValues(_this.store, store);
    }
    _this.notifyObservers(prevStore, null, {
      type: "valueUpdate",
      source: "external"
    });
  };
  this.getDependencyChildrenFields = function(rootNamePath) {
    var children = /* @__PURE__ */ new Set();
    var childrenFields = [];
    var dependencies2fields = new NameMap();
    _this.getFieldEntities().forEach(function(field) {
      var dependencies = field.props.dependencies;
      (dependencies || []).forEach(function(dependency) {
        var dependencyNamePath = getNamePath(dependency);
        dependencies2fields.update(dependencyNamePath, function() {
          var fields = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
          fields.add(field);
          return fields;
        });
      });
    });
    var fillChildren = function fillChildren2(namePath) {
      var fields = dependencies2fields.get(namePath) || /* @__PURE__ */ new Set();
      fields.forEach(function(field) {
        if (!children.has(field)) {
          children.add(field);
          var fieldNamePath = field.getNamePath();
          if (field.isFieldDirty() && fieldNamePath.length) {
            childrenFields.push(fieldNamePath);
            fillChildren2(fieldNamePath);
          }
        }
      });
    };
    fillChildren(rootNamePath);
    return childrenFields;
  };
  this.triggerOnFieldsChange = function(namePathList, filedErrors) {
    var onFieldsChange = _this.callbacks.onFieldsChange;
    if (onFieldsChange) {
      var fields = _this.getFields();
      if (filedErrors) {
        var cache = new NameMap();
        filedErrors.forEach(function(_ref3) {
          var name = _ref3.name, errors = _ref3.errors;
          cache.set(name, errors);
        });
        fields.forEach(function(field) {
          field.errors = cache.get(field.name) || field.errors;
        });
      }
      var changedFields = fields.filter(function(_ref4) {
        var fieldName = _ref4.name;
        return containsNamePath(namePathList, fieldName);
      });
      onFieldsChange(changedFields, fields);
    }
  };
  this.validateFields = function(nameList, options) {
    _this.warningUnhooked();
    var provideNameList = !!nameList;
    var namePathList = provideNameList ? nameList.map(getNamePath) : [];
    var promiseList = [];
    _this.getFieldEntities(true).forEach(function(field) {
      if (!provideNameList) {
        namePathList.push(field.getNamePath());
      }
      if ((options === null || options === void 0 ? void 0 : options.recursive) && provideNameList) {
        var namePath = field.getNamePath();
        if (namePath.every(function(nameUnit, i) {
          return nameList[i] === nameUnit || nameList[i] === void 0;
        })) {
          namePathList.push(namePath);
        }
      }
      if (!field.props.rules || !field.props.rules.length) {
        return;
      }
      var fieldNamePath = field.getNamePath();
      if (!provideNameList || containsNamePath(namePathList, fieldNamePath)) {
        var promise = field.validateRules(_objectSpread2$1({
          validateMessages: _objectSpread2$1(_objectSpread2$1({}, defaultValidateMessages), _this.validateMessages)
        }, options));
        promiseList.push(promise.then(function() {
          return {
            name: fieldNamePath,
            errors: [],
            warnings: []
          };
        }).catch(function(ruleErrors) {
          var mergedErrors = [];
          var mergedWarnings = [];
          ruleErrors.forEach(function(_ref5) {
            var warningOnly = _ref5.rule.warningOnly, errors = _ref5.errors;
            if (warningOnly) {
              mergedWarnings.push.apply(mergedWarnings, _toConsumableArray(errors));
            } else {
              mergedErrors.push.apply(mergedErrors, _toConsumableArray(errors));
            }
          });
          if (mergedErrors.length) {
            return Promise.reject({
              name: fieldNamePath,
              errors: mergedErrors,
              warnings: mergedWarnings
            });
          }
          return {
            name: fieldNamePath,
            errors: mergedErrors,
            warnings: mergedWarnings
          };
        }));
      }
    });
    var summaryPromise = allPromiseFinish(promiseList);
    _this.lastValidatePromise = summaryPromise;
    summaryPromise.catch(function(results) {
      return results;
    }).then(function(results) {
      var resultNamePathList = results.map(function(_ref6) {
        var name = _ref6.name;
        return name;
      });
      _this.notifyObservers(_this.store, resultNamePathList, {
        type: "validateFinish"
      });
      _this.triggerOnFieldsChange(resultNamePathList, results);
    });
    var returnPromise = summaryPromise.then(function() {
      if (_this.lastValidatePromise === summaryPromise) {
        return Promise.resolve(_this.getFieldsValue(namePathList));
      }
      return Promise.reject([]);
    }).catch(function(results) {
      var errorList = results.filter(function(result) {
        return result && result.errors.length;
      });
      return Promise.reject({
        values: _this.getFieldsValue(namePathList),
        errorFields: errorList,
        outOfDate: _this.lastValidatePromise !== summaryPromise
      });
    });
    returnPromise.catch(function(e2) {
      return e2;
    });
    return returnPromise;
  };
  this.submit = function() {
    _this.warningUnhooked();
    _this.validateFields().then(function(values) {
      var onFinish = _this.callbacks.onFinish;
      if (onFinish) {
        try {
          onFinish(values);
        } catch (err) {
          console.error(err);
        }
      }
    }).catch(function(e2) {
      var onFinishFailed = _this.callbacks.onFinishFailed;
      if (onFinishFailed) {
        onFinishFailed(e2);
      }
    });
  };
  this.forceRootUpdate = forceRootUpdate;
});
function useForm(form) {
  var formRef = React.useRef();
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray(_React$useState, 2), forceUpdate = _React$useState2[1];
  if (!formRef.current) {
    if (form) {
      formRef.current = form;
    } else {
      var forceReRender = function forceReRender2() {
        forceUpdate({});
      };
      var formStore = new FormStore(forceReRender);
      formRef.current = formStore.getForm();
    }
  }
  return [formRef.current];
}
var FormContext = /* @__PURE__ */ React.createContext({
  triggerFormChange: function triggerFormChange() {
  },
  triggerFormFinish: function triggerFormFinish() {
  },
  registerForm: function registerForm() {
  },
  unregisterForm: function unregisterForm() {
  }
});
var FormProvider = function FormProvider2(_ref) {
  var validateMessages = _ref.validateMessages, onFormChange = _ref.onFormChange, onFormFinish = _ref.onFormFinish, children = _ref.children;
  var formContext = React.useContext(FormContext);
  var formsRef = React.useRef({});
  return /* @__PURE__ */ React.createElement(FormContext.Provider, {
    value: _objectSpread2$1(_objectSpread2$1({}, formContext), {}, {
      validateMessages: _objectSpread2$1(_objectSpread2$1({}, formContext.validateMessages), validateMessages),
      triggerFormChange: function triggerFormChange2(name, changedFields) {
        if (onFormChange) {
          onFormChange(name, {
            changedFields,
            forms: formsRef.current
          });
        }
        formContext.triggerFormChange(name, changedFields);
      },
      triggerFormFinish: function triggerFormFinish2(name, values) {
        if (onFormFinish) {
          onFormFinish(name, {
            values,
            forms: formsRef.current
          });
        }
        formContext.triggerFormFinish(name, values);
      },
      registerForm: function registerForm2(name, form) {
        if (name) {
          formsRef.current = _objectSpread2$1(_objectSpread2$1({}, formsRef.current), {}, _defineProperty$1({}, name, form));
        }
        formContext.registerForm(name, form);
      },
      unregisterForm: function unregisterForm2(name) {
        var newForms = _objectSpread2$1({}, formsRef.current);
        delete newForms[name];
        formsRef.current = newForms;
        formContext.unregisterForm(name);
      }
    })
  }, children);
};
var _excluded$f = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"];
var Form = function Form2(_ref, ref) {
  var name = _ref.name, initialValues = _ref.initialValues, fields = _ref.fields, form = _ref.form, preserve = _ref.preserve, children = _ref.children, _ref$component = _ref.component, Component2 = _ref$component === void 0 ? "form" : _ref$component, validateMessages = _ref.validateMessages, _ref$validateTrigger = _ref.validateTrigger, validateTrigger = _ref$validateTrigger === void 0 ? "onChange" : _ref$validateTrigger, onValuesChange = _ref.onValuesChange, _onFieldsChange = _ref.onFieldsChange, _onFinish = _ref.onFinish, onFinishFailed = _ref.onFinishFailed, restProps = _objectWithoutProperties(_ref, _excluded$f);
  var formContext = React.useContext(FormContext);
  var _useForm = useForm(form), _useForm2 = _slicedToArray(_useForm, 1), formInstance = _useForm2[0];
  var _formInstance$getInte = formInstance.getInternalHooks(HOOK_MARK), useSubscribe = _formInstance$getInte.useSubscribe, setInitialValues = _formInstance$getInte.setInitialValues, setCallbacks = _formInstance$getInte.setCallbacks, setValidateMessages = _formInstance$getInte.setValidateMessages, setPreserve = _formInstance$getInte.setPreserve;
  React.useImperativeHandle(ref, function() {
    return formInstance;
  });
  React.useEffect(function() {
    formContext.registerForm(name, formInstance);
    return function() {
      formContext.unregisterForm(name);
    };
  }, [formContext, formInstance, name]);
  setValidateMessages(_objectSpread2$1(_objectSpread2$1({}, formContext.validateMessages), validateMessages));
  setCallbacks({
    onValuesChange,
    onFieldsChange: function onFieldsChange(changedFields) {
      formContext.triggerFormChange(name, changedFields);
      if (_onFieldsChange) {
        for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          rest[_key - 1] = arguments[_key];
        }
        _onFieldsChange.apply(void 0, [changedFields].concat(rest));
      }
    },
    onFinish: function onFinish(values2) {
      formContext.triggerFormFinish(name, values2);
      if (_onFinish) {
        _onFinish(values2);
      }
    },
    onFinishFailed
  });
  setPreserve(preserve);
  var mountRef = React.useRef(null);
  setInitialValues(initialValues, !mountRef.current);
  if (!mountRef.current) {
    mountRef.current = true;
  }
  var childrenNode = children;
  var childrenRenderProps = typeof children === "function";
  if (childrenRenderProps) {
    var values = formInstance.getFieldsValue(true);
    childrenNode = children(values, formInstance);
  }
  useSubscribe(!childrenRenderProps);
  var prevFieldsRef = React.useRef();
  React.useEffect(function() {
    if (!isSimilar(prevFieldsRef.current || [], fields || [])) {
      formInstance.setFields(fields || []);
    }
    prevFieldsRef.current = fields;
  }, [fields, formInstance]);
  var formContextValue = React.useMemo(function() {
    return _objectSpread2$1(_objectSpread2$1({}, formInstance), {}, {
      validateTrigger
    });
  }, [formInstance, validateTrigger]);
  var wrapperNode = /* @__PURE__ */ React.createElement(Context.Provider, {
    value: formContextValue
  }, childrenNode);
  if (Component2 === false) {
    return wrapperNode;
  }
  return /* @__PURE__ */ React.createElement(Component2, _extends$1({}, restProps, {
    onSubmit: function onSubmit(event) {
      event.preventDefault();
      event.stopPropagation();
      formInstance.submit();
    },
    onReset: function onReset(event) {
      var _restProps$onReset;
      event.preventDefault();
      formInstance.resetFields();
      (_restProps$onReset = restProps.onReset) === null || _restProps$onReset === void 0 ? void 0 : _restProps$onReset.call(restProps, event);
    }
  }), wrapperNode);
};
var InternalForm = /* @__PURE__ */ React.forwardRef(Form);
var RefForm = InternalForm;
RefForm.FormProvider = FormProvider;
RefForm.Field = WrapperField;
RefForm.List = List;
RefForm.useForm = useForm;
var devWarning = function(valid, component, message) {
  warningOnce(valid, "[antd: ".concat(component, "] ").concat(message));
};
var enUS$1 = {
  items_per_page: "/ page",
  jump_to: "Go to",
  jump_to_confirm: "confirm",
  page: "Page",
  prev_page: "Previous Page",
  next_page: "Next Page",
  prev_5: "Previous 5 Pages",
  next_5: "Next 5 Pages",
  prev_3: "Previous 3 Pages",
  next_3: "Next 3 Pages",
  page_size: "Page Size"
};
var locale$2 = {
  locale: "en_US",
  today: "Today",
  now: "Now",
  backToToday: "Back to today",
  ok: "Ok",
  clear: "Clear",
  month: "Month",
  year: "Year",
  timeSelect: "select time",
  dateSelect: "select date",
  weekSelect: "Choose a week",
  monthSelect: "Choose a month",
  yearSelect: "Choose a year",
  decadeSelect: "Choose a decade",
  yearFormat: "YYYY",
  dateFormat: "M/D/YYYY",
  dayFormat: "D",
  dateTimeFormat: "M/D/YYYY HH:mm:ss",
  monthBeforeYear: true,
  previousMonth: "Previous month (PageUp)",
  nextMonth: "Next month (PageDown)",
  previousYear: "Last year (Control + left)",
  nextYear: "Next year (Control + right)",
  previousDecade: "Last decade",
  nextDecade: "Next decade",
  previousCentury: "Last century",
  nextCentury: "Next century"
};
var locale$1 = {
  placeholder: "Select time",
  rangePlaceholder: ["Start time", "End time"]
};
var TimePicker = locale$1;
var locale = {
  lang: _extends$1({
    placeholder: "Select date",
    yearPlaceholder: "Select year",
    quarterPlaceholder: "Select quarter",
    monthPlaceholder: "Select month",
    weekPlaceholder: "Select week",
    rangePlaceholder: ["Start date", "End date"],
    rangeYearPlaceholder: ["Start year", "End year"],
    rangeQuarterPlaceholder: ["Start quarter", "End quarter"],
    rangeMonthPlaceholder: ["Start month", "End month"],
    rangeWeekPlaceholder: ["Start week", "End week"]
  }, locale$2),
  timePickerLocale: _extends$1({}, TimePicker)
};
var enUS = locale;
var typeTemplate = "${label} is not a valid ${type}";
var localeValues = {
  locale: "en",
  Pagination: enUS$1,
  DatePicker: enUS,
  TimePicker,
  Calendar: enUS,
  global: {
    placeholder: "Please select"
  },
  Table: {
    filterTitle: "Filter menu",
    filterConfirm: "OK",
    filterReset: "Reset",
    filterEmptyText: "No filters",
    filterCheckall: "Select all items",
    filterSearchPlaceholder: "Search in filters",
    emptyText: "No data",
    selectAll: "Select current page",
    selectInvert: "Invert current page",
    selectNone: "Clear all data",
    selectionAll: "Select all data",
    sortTitle: "Sort",
    expand: "Expand row",
    collapse: "Collapse row",
    triggerDesc: "Click to sort descending",
    triggerAsc: "Click to sort ascending",
    cancelSort: "Click to cancel sorting"
  },
  Modal: {
    okText: "OK",
    cancelText: "Cancel",
    justOkText: "OK"
  },
  Popconfirm: {
    okText: "OK",
    cancelText: "Cancel"
  },
  Transfer: {
    titles: ["", ""],
    searchPlaceholder: "Search here",
    itemUnit: "item",
    itemsUnit: "items",
    remove: "Remove",
    selectCurrent: "Select current page",
    removeCurrent: "Remove current page",
    selectAll: "Select all data",
    removeAll: "Remove all data",
    selectInvert: "Invert current page"
  },
  Upload: {
    uploading: "Uploading...",
    removeFile: "Remove file",
    uploadError: "Upload error",
    previewFile: "Preview file",
    downloadFile: "Download file"
  },
  Empty: {
    description: "No Data"
  },
  Icon: {
    icon: "icon"
  },
  Text: {
    edit: "Edit",
    copy: "Copy",
    copied: "Copied",
    expand: "Expand"
  },
  PageHeader: {
    back: "Back"
  },
  Form: {
    optional: "(optional)",
    defaultValidateMessages: {
      "default": "Field validation error for ${label}",
      required: "Please enter ${label}",
      "enum": "${label} must be one of [${enum}]",
      whitespace: "${label} cannot be a blank character",
      date: {
        format: "${label} date format is invalid",
        parse: "${label} cannot be converted to a date",
        invalid: "${label} is an invalid date"
      },
      types: {
        string: typeTemplate,
        method: typeTemplate,
        array: typeTemplate,
        object: typeTemplate,
        number: typeTemplate,
        date: typeTemplate,
        "boolean": typeTemplate,
        integer: typeTemplate,
        "float": typeTemplate,
        regexp: typeTemplate,
        email: typeTemplate,
        url: typeTemplate,
        hex: typeTemplate
      },
      string: {
        len: "${label} must be ${len} characters",
        min: "${label} must be at least ${min} characters",
        max: "${label} must be up to ${max} characters",
        range: "${label} must be between ${min}-${max} characters"
      },
      number: {
        len: "${label} must be equal to ${len}",
        min: "${label} must be minimum ${min}",
        max: "${label} must be maximum ${max}",
        range: "${label} must be between ${min}-${max}"
      },
      array: {
        len: "Must be ${len} ${label}",
        min: "At least ${min} ${label}",
        max: "At most ${max} ${label}",
        range: "The amount of ${label} must be between ${min}-${max}"
      },
      pattern: {
        mismatch: "${label} does not match the pattern ${pattern}"
      }
    }
  },
  Image: {
    preview: "Preview"
  }
};
var defaultLocale = localeValues;
var LocaleContext = /* @__PURE__ */ createContext(void 0);
var LocaleContext$1 = LocaleContext;
var LocaleReceiver = /* @__PURE__ */ function(_React$Component) {
  _inherits(LocaleReceiver2, _React$Component);
  var _super = _createSuper(LocaleReceiver2);
  function LocaleReceiver2() {
    _classCallCheck(this, LocaleReceiver2);
    return _super.apply(this, arguments);
  }
  _createClass(LocaleReceiver2, [{
    key: "getLocale",
    value: function getLocale() {
      var _this$props = this.props, componentName = _this$props.componentName, defaultLocale$1 = _this$props.defaultLocale;
      var locale2 = defaultLocale$1 || defaultLocale[componentName !== null && componentName !== void 0 ? componentName : "global"];
      var antLocale = this.context;
      var localeFromContext = componentName && antLocale ? antLocale[componentName] : {};
      return _extends$1(_extends$1({}, locale2 instanceof Function ? locale2() : locale2), localeFromContext || {});
    }
  }, {
    key: "getLocaleCode",
    value: function getLocaleCode() {
      var antLocale = this.context;
      var localeCode = antLocale && antLocale.locale;
      if (antLocale && antLocale.exist && !localeCode) {
        return defaultLocale.locale;
      }
      return localeCode;
    }
  }, {
    key: "render",
    value: function render2() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    }
  }]);
  return LocaleReceiver2;
}(React.Component);
LocaleReceiver.defaultProps = {
  componentName: "global"
};
LocaleReceiver.contextType = LocaleContext$1;
var Empty$2 = function Empty() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-default");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "184",
    height: "152",
    viewBox: "0 0 184 152",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(24 31.67)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "67.797",
    cy: "106.89",
    rx: "67.797",
    ry: "12.668"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-1"),
    d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-2"),
    d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z",
    transform: "translate(13.56)"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-3"),
    d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-4"),
    d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z"
  })), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-5"),
    d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    transform: "translate(149.65 15.383)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    cx: "20.654",
    cy: "3.167",
    rx: "2.849",
    ry: "2.815"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z"
  }))));
};
var DefaultEmptyImg = Empty$2;
var Simple = function Simple2() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-simple");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "64",
    height: "41",
    viewBox: "0 0 64 41",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(0 1)",
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "32",
    cy: "33",
    rx: "32",
    ry: "7"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    fillRule: "nonzero"
  }, /* @__PURE__ */ React.createElement("path", {
    d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z",
    className: "".concat(prefixCls, "-path")
  }))));
};
var SimpleEmptyImg = Simple;
var __rest$b = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var defaultEmptyImg = /* @__PURE__ */ React.createElement(DefaultEmptyImg, null);
var simpleEmptyImg = /* @__PURE__ */ React.createElement(SimpleEmptyImg, null);
var Empty2 = function Empty3(_a2) {
  var className = _a2.className, customizePrefixCls = _a2.prefixCls, _a$image = _a2.image, image = _a$image === void 0 ? defaultEmptyImg : _a$image, description = _a2.description, children = _a2.children, imageStyle = _a2.imageStyle, restProps = __rest$b(_a2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  return /* @__PURE__ */ React.createElement(LocaleReceiver, {
    componentName: "Empty"
  }, function(locale2) {
    var _classNames;
    var prefixCls = getPrefixCls("empty", customizePrefixCls);
    var des = typeof description !== "undefined" ? description : locale2.description;
    var alt = typeof des === "string" ? des : "empty";
    var imageNode = null;
    if (typeof image === "string") {
      imageNode = /* @__PURE__ */ React.createElement("img", {
        alt,
        src: image
      });
    } else {
      imageNode = image;
    }
    return /* @__PURE__ */ React.createElement("div", _extends$1({
      className: classNames(prefixCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-normal"), image === simpleEmptyImg), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className)
    }, restProps), /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-image"),
      style: imageStyle
    }, imageNode), des && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-description")
    }, des), children && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-footer")
    }, children));
  });
};
Empty2.PRESENTED_IMAGE_DEFAULT = defaultEmptyImg;
Empty2.PRESENTED_IMAGE_SIMPLE = simpleEmptyImg;
var Empty$1 = Empty2;
var renderEmpty = function renderEmpty2(componentName) {
  return /* @__PURE__ */ React.createElement(ConfigConsumer, null, function(_ref) {
    var getPrefixCls = _ref.getPrefixCls;
    var prefix = getPrefixCls("empty");
    switch (componentName) {
      case "Table":
      case "List":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE
        });
      case "Select":
      case "TreeSelect":
      case "Cascader":
      case "Transfer":
      case "Mentions":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE,
          className: "".concat(prefix, "-small")
        });
      default:
        return /* @__PURE__ */ React.createElement(Empty$1, null);
    }
  });
};
var defaultRenderEmpty = renderEmpty;
var defaultGetPrefixCls = function defaultGetPrefixCls2(suffixCls, customizePrefixCls) {
  if (customizePrefixCls)
    return customizePrefixCls;
  return suffixCls ? "ant-".concat(suffixCls) : "ant";
};
var ConfigContext = /* @__PURE__ */ React.createContext({
  getPrefixCls: defaultGetPrefixCls,
  renderEmpty: defaultRenderEmpty
});
var ConfigConsumer = ConfigContext.Consumer;
var SizeContext = /* @__PURE__ */ React.createContext(void 0);
var SizeContext$1 = SizeContext;
function makePrefixMap(styleProp, eventName) {
  var prefixes = {};
  prefixes[styleProp.toLowerCase()] = eventName.toLowerCase();
  prefixes["Webkit".concat(styleProp)] = "webkit".concat(eventName);
  prefixes["Moz".concat(styleProp)] = "moz".concat(eventName);
  prefixes["ms".concat(styleProp)] = "MS".concat(eventName);
  prefixes["O".concat(styleProp)] = "o".concat(eventName.toLowerCase());
  return prefixes;
}
function getVendorPrefixes(domSupport, win) {
  var prefixes = {
    animationend: makePrefixMap("Animation", "AnimationEnd"),
    transitionend: makePrefixMap("Transition", "TransitionEnd")
  };
  if (domSupport) {
    if (!("AnimationEvent" in win)) {
      delete prefixes.animationend.animation;
    }
    if (!("TransitionEvent" in win)) {
      delete prefixes.transitionend.transition;
    }
  }
  return prefixes;
}
var vendorPrefixes = getVendorPrefixes(canUseDom(), typeof window !== "undefined" ? window : {});
var style = {};
if (canUseDom()) {
  var _document$createEleme = document.createElement("div");
  style = _document$createEleme.style;
}
var prefixedEventNames = {};
function getVendorPrefixedEventName(eventName) {
  if (prefixedEventNames[eventName]) {
    return prefixedEventNames[eventName];
  }
  var prefixMap = vendorPrefixes[eventName];
  if (prefixMap) {
    var stylePropList = Object.keys(prefixMap);
    var len2 = stylePropList.length;
    for (var i = 0; i < len2; i += 1) {
      var styleProp = stylePropList[i];
      if (Object.prototype.hasOwnProperty.call(prefixMap, styleProp) && styleProp in style) {
        prefixedEventNames[eventName] = prefixMap[styleProp];
        return prefixedEventNames[eventName];
      }
    }
  }
  return "";
}
var internalAnimationEndName = getVendorPrefixedEventName("animationend");
var internalTransitionEndName = getVendorPrefixedEventName("transitionend");
var supportTransition = !!(internalAnimationEndName && internalTransitionEndName);
var animationEndName = internalAnimationEndName || "animationend";
var transitionEndName = internalTransitionEndName || "transitionend";
function getTransitionName$1(transitionName, transitionType) {
  if (!transitionName)
    return null;
  if (_typeof$1(transitionName) === "object") {
    var type4 = transitionType.replace(/-\w/g, function(match) {
      return match[1].toUpperCase();
    });
    return transitionName[type4];
  }
  return "".concat(transitionName, "-").concat(transitionType);
}
var STATUS_NONE = "none";
var STATUS_APPEAR = "appear";
var STATUS_ENTER = "enter";
var STATUS_LEAVE = "leave";
var STEP_NONE = "none";
var STEP_PREPARE = "prepare";
var STEP_START = "start";
var STEP_ACTIVE = "active";
var STEP_ACTIVATED = "end";
function useMountStatus(defaultValue) {
  var destroyRef = useRef(false);
  var _useState = useState(defaultValue), _useState2 = _slicedToArray(_useState, 2), val = _useState2[0], setVal = _useState2[1];
  function setValue2(next) {
    if (!destroyRef.current) {
      setVal(next);
    }
  }
  useEffect(function() {
    return function() {
      destroyRef.current = true;
    };
  }, []);
  return [val, setValue2];
}
var useIsomorphicLayoutEffect = canUseDom() ? useLayoutEffect$1 : useEffect;
var raf = function raf2(callback) {
  return +setTimeout(callback, 16);
};
var caf = function caf2(num) {
  return clearTimeout(num);
};
if (typeof window !== "undefined" && "requestAnimationFrame" in window) {
  raf = function raf3(callback) {
    return window.requestAnimationFrame(callback);
  };
  caf = function caf3(handle) {
    return window.cancelAnimationFrame(handle);
  };
}
var rafUUID = 0;
var rafIds = /* @__PURE__ */ new Map();
function cleanup(id2) {
  rafIds.delete(id2);
}
function wrapperRaf$1(callback) {
  var times = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  rafUUID += 1;
  var id2 = rafUUID;
  function callRef(leftTimes) {
    if (leftTimes === 0) {
      cleanup(id2);
      callback();
    } else {
      var realId = raf(function() {
        callRef(leftTimes - 1);
      });
      rafIds.set(id2, realId);
    }
  }
  callRef(times);
  return id2;
}
wrapperRaf$1.cancel = function(id2) {
  var realId = rafIds.get(id2);
  cleanup(realId);
  return caf(realId);
};
var useNextFrame = function() {
  var nextFrameRef = React.useRef(null);
  function cancelNextFrame() {
    wrapperRaf$1.cancel(nextFrameRef.current);
  }
  function nextFrame(callback) {
    var delay = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 2;
    cancelNextFrame();
    var nextFrameId = wrapperRaf$1(function() {
      if (delay <= 1) {
        callback({
          isCanceled: function isCanceled() {
            return nextFrameId !== nextFrameRef.current;
          }
        });
      } else {
        nextFrame(callback, delay - 1);
      }
    });
    nextFrameRef.current = nextFrameId;
  }
  React.useEffect(function() {
    return function() {
      cancelNextFrame();
    };
  }, []);
  return [nextFrame, cancelNextFrame];
};
var STEP_QUEUE = [STEP_PREPARE, STEP_START, STEP_ACTIVE, STEP_ACTIVATED];
var SkipStep = false;
var DoStep = true;
function isActive(step) {
  return step === STEP_ACTIVE || step === STEP_ACTIVATED;
}
var useStepQueue = function(status, callback) {
  var _useState = useMountStatus(STEP_NONE), _useState2 = _slicedToArray(_useState, 2), step = _useState2[0], setStep = _useState2[1];
  var _useNextFrame = useNextFrame(), _useNextFrame2 = _slicedToArray(_useNextFrame, 2), nextFrame = _useNextFrame2[0], cancelNextFrame = _useNextFrame2[1];
  function startQueue() {
    setStep(STEP_PREPARE);
  }
  useIsomorphicLayoutEffect(function() {
    if (step !== STEP_NONE && step !== STEP_ACTIVATED) {
      var index2 = STEP_QUEUE.indexOf(step);
      var nextStep = STEP_QUEUE[index2 + 1];
      var result = callback(step);
      if (result === SkipStep) {
        setStep(nextStep);
      } else {
        nextFrame(function(info) {
          function doNext() {
            if (info.isCanceled())
              return;
            setStep(nextStep);
          }
          if (result === true) {
            doNext();
          } else {
            Promise.resolve(result).then(doNext);
          }
        });
      }
    }
  }, [status, step]);
  React.useEffect(function() {
    return function() {
      cancelNextFrame();
    };
  }, []);
  return [startQueue, step];
};
var useDomMotionEvents = function(callback) {
  var cacheElementRef = useRef();
  var callbackRef = useRef(callback);
  callbackRef.current = callback;
  var onInternalMotionEnd = React.useCallback(function(event) {
    callbackRef.current(event);
  }, []);
  function removeMotionEvents(element) {
    if (element) {
      element.removeEventListener(transitionEndName, onInternalMotionEnd);
      element.removeEventListener(animationEndName, onInternalMotionEnd);
    }
  }
  function patchMotionEvents(element) {
    if (cacheElementRef.current && cacheElementRef.current !== element) {
      removeMotionEvents(cacheElementRef.current);
    }
    if (element && element !== cacheElementRef.current) {
      element.addEventListener(transitionEndName, onInternalMotionEnd);
      element.addEventListener(animationEndName, onInternalMotionEnd);
      cacheElementRef.current = element;
    }
  }
  React.useEffect(function() {
    return function() {
      removeMotionEvents(cacheElementRef.current);
    };
  }, []);
  return [patchMotionEvents, removeMotionEvents];
};
function useStatus(supportMotion, visible, getElement2, _ref) {
  var _ref$motionEnter = _ref.motionEnter, motionEnter = _ref$motionEnter === void 0 ? true : _ref$motionEnter, _ref$motionAppear = _ref.motionAppear, motionAppear = _ref$motionAppear === void 0 ? true : _ref$motionAppear, _ref$motionLeave = _ref.motionLeave, motionLeave = _ref$motionLeave === void 0 ? true : _ref$motionLeave, motionDeadline = _ref.motionDeadline, motionLeaveImmediately = _ref.motionLeaveImmediately, onAppearPrepare = _ref.onAppearPrepare, onEnterPrepare = _ref.onEnterPrepare, onLeavePrepare = _ref.onLeavePrepare, onAppearStart = _ref.onAppearStart, onEnterStart = _ref.onEnterStart, onLeaveStart = _ref.onLeaveStart, onAppearActive = _ref.onAppearActive, onEnterActive = _ref.onEnterActive, onLeaveActive = _ref.onLeaveActive, onAppearEnd = _ref.onAppearEnd, onEnterEnd = _ref.onEnterEnd, onLeaveEnd = _ref.onLeaveEnd, onVisibleChanged = _ref.onVisibleChanged;
  var _useState = useMountStatus(), _useState2 = _slicedToArray(_useState, 2), asyncVisible = _useState2[0], setAsyncVisible = _useState2[1];
  var _useState3 = useMountStatus(STATUS_NONE), _useState4 = _slicedToArray(_useState3, 2), status = _useState4[0], setStatus = _useState4[1];
  var _useState5 = useMountStatus(null), _useState6 = _slicedToArray(_useState5, 2), style2 = _useState6[0], setStyle2 = _useState6[1];
  var mountedRef = useRef(false);
  var deadlineRef = useRef(null);
  var destroyedRef = useRef(false);
  var cacheElementRef = useRef(null);
  function getDomElement() {
    var element = getElement2();
    return element || cacheElementRef.current;
  }
  var activeRef = useRef(false);
  function onInternalMotionEnd(event) {
    var element = getDomElement();
    if (event && !event.deadline && event.target !== element) {
      return;
    }
    var canEnd;
    if (status === STATUS_APPEAR && activeRef.current) {
      canEnd = onAppearEnd === null || onAppearEnd === void 0 ? void 0 : onAppearEnd(element, event);
    } else if (status === STATUS_ENTER && activeRef.current) {
      canEnd = onEnterEnd === null || onEnterEnd === void 0 ? void 0 : onEnterEnd(element, event);
    } else if (status === STATUS_LEAVE && activeRef.current) {
      canEnd = onLeaveEnd === null || onLeaveEnd === void 0 ? void 0 : onLeaveEnd(element, event);
    }
    if (canEnd !== false && !destroyedRef.current) {
      setStatus(STATUS_NONE);
      setStyle2(null);
    }
  }
  var _useDomMotionEvents = useDomMotionEvents(onInternalMotionEnd), _useDomMotionEvents2 = _slicedToArray(_useDomMotionEvents, 1), patchMotionEvents = _useDomMotionEvents2[0];
  var eventHandlers = React.useMemo(function() {
    var _ref2, _ref3, _ref4;
    switch (status) {
      case STATUS_APPEAR:
        return _ref2 = {}, _defineProperty$1(_ref2, STEP_PREPARE, onAppearPrepare), _defineProperty$1(_ref2, STEP_START, onAppearStart), _defineProperty$1(_ref2, STEP_ACTIVE, onAppearActive), _ref2;
      case STATUS_ENTER:
        return _ref3 = {}, _defineProperty$1(_ref3, STEP_PREPARE, onEnterPrepare), _defineProperty$1(_ref3, STEP_START, onEnterStart), _defineProperty$1(_ref3, STEP_ACTIVE, onEnterActive), _ref3;
      case STATUS_LEAVE:
        return _ref4 = {}, _defineProperty$1(_ref4, STEP_PREPARE, onLeavePrepare), _defineProperty$1(_ref4, STEP_START, onLeaveStart), _defineProperty$1(_ref4, STEP_ACTIVE, onLeaveActive), _ref4;
      default:
        return {};
    }
  }, [status]);
  var _useStepQueue = useStepQueue(status, function(newStep) {
    if (newStep === STEP_PREPARE) {
      var onPrepare = eventHandlers[STEP_PREPARE];
      if (!onPrepare) {
        return SkipStep;
      }
      return onPrepare(getDomElement());
    }
    if (step in eventHandlers) {
      var _eventHandlers$step;
      setStyle2(((_eventHandlers$step = eventHandlers[step]) === null || _eventHandlers$step === void 0 ? void 0 : _eventHandlers$step.call(eventHandlers, getDomElement(), null)) || null);
    }
    if (step === STEP_ACTIVE) {
      patchMotionEvents(getDomElement());
      if (motionDeadline > 0) {
        clearTimeout(deadlineRef.current);
        deadlineRef.current = setTimeout(function() {
          onInternalMotionEnd({
            deadline: true
          });
        }, motionDeadline);
      }
    }
    return DoStep;
  }), _useStepQueue2 = _slicedToArray(_useStepQueue, 2), startStep = _useStepQueue2[0], step = _useStepQueue2[1];
  var active = isActive(step);
  activeRef.current = active;
  useIsomorphicLayoutEffect(function() {
    setAsyncVisible(visible);
    var isMounted = mountedRef.current;
    mountedRef.current = true;
    if (!supportMotion) {
      return;
    }
    var nextStatus;
    if (!isMounted && visible && motionAppear) {
      nextStatus = STATUS_APPEAR;
    }
    if (isMounted && visible && motionEnter) {
      nextStatus = STATUS_ENTER;
    }
    if (isMounted && !visible && motionLeave || !isMounted && motionLeaveImmediately && !visible && motionLeave) {
      nextStatus = STATUS_LEAVE;
    }
    if (nextStatus) {
      setStatus(nextStatus);
      startStep();
    }
  }, [visible]);
  useEffect(function() {
    if (status === STATUS_APPEAR && !motionAppear || status === STATUS_ENTER && !motionEnter || status === STATUS_LEAVE && !motionLeave) {
      setStatus(STATUS_NONE);
    }
  }, [motionAppear, motionEnter, motionLeave]);
  useEffect(function() {
    return function() {
      clearTimeout(deadlineRef.current);
      destroyedRef.current = true;
    };
  }, []);
  useEffect(function() {
    if (asyncVisible !== void 0 && status === STATUS_NONE) {
      onVisibleChanged === null || onVisibleChanged === void 0 ? void 0 : onVisibleChanged(asyncVisible);
    }
  }, [asyncVisible, status]);
  var mergedStyle = style2;
  if (eventHandlers[STEP_PREPARE] && step === STEP_START) {
    mergedStyle = _objectSpread2$1({
      transition: "none"
    }, mergedStyle);
  }
  return [status, step, mergedStyle, asyncVisible !== null && asyncVisible !== void 0 ? asyncVisible : visible];
}
var DomWrapper = /* @__PURE__ */ function(_React$Component) {
  _inherits(DomWrapper2, _React$Component);
  var _super = _createSuper(DomWrapper2);
  function DomWrapper2() {
    _classCallCheck(this, DomWrapper2);
    return _super.apply(this, arguments);
  }
  _createClass(DomWrapper2, [{
    key: "render",
    value: function render2() {
      return this.props.children;
    }
  }]);
  return DomWrapper2;
}(React.Component);
function genCSSMotion(config) {
  var transitionSupport = config;
  if (_typeof$1(config) === "object") {
    transitionSupport = config.transitionSupport;
  }
  function isSupportTransition(props) {
    return !!(props.motionName && transitionSupport);
  }
  var CSSMotion2 = /* @__PURE__ */ React.forwardRef(function(props, ref) {
    var _props$visible = props.visible, visible = _props$visible === void 0 ? true : _props$visible, _props$removeOnLeave = props.removeOnLeave, removeOnLeave = _props$removeOnLeave === void 0 ? true : _props$removeOnLeave, forceRender = props.forceRender, children = props.children, motionName = props.motionName, leavedClassName = props.leavedClassName, eventProps = props.eventProps;
    var supportMotion = isSupportTransition(props);
    var nodeRef = useRef();
    var wrapperNodeRef = useRef();
    function getDomElement() {
      try {
        return nodeRef.current instanceof HTMLElement ? nodeRef.current : findDOMNode(wrapperNodeRef.current);
      } catch (e2) {
        return null;
      }
    }
    var _useStatus = useStatus(supportMotion, visible, getDomElement, props), _useStatus2 = _slicedToArray(_useStatus, 4), status = _useStatus2[0], statusStep = _useStatus2[1], statusStyle = _useStatus2[2], mergedVisible = _useStatus2[3];
    var renderedRef = React.useRef(mergedVisible);
    if (mergedVisible) {
      renderedRef.current = true;
    }
    var setNodeRef = React.useCallback(function(node) {
      nodeRef.current = node;
      fillRef(ref, node);
    }, []);
    var motionChildren;
    var mergedProps = _objectSpread2$1(_objectSpread2$1({}, eventProps), {}, {
      visible
    });
    if (!children) {
      motionChildren = null;
    } else if (status === STATUS_NONE || !isSupportTransition(props)) {
      if (mergedVisible) {
        motionChildren = children(_objectSpread2$1({}, mergedProps), setNodeRef);
      } else if (!removeOnLeave && renderedRef.current) {
        motionChildren = children(_objectSpread2$1(_objectSpread2$1({}, mergedProps), {}, {
          className: leavedClassName
        }), setNodeRef);
      } else if (forceRender) {
        motionChildren = children(_objectSpread2$1(_objectSpread2$1({}, mergedProps), {}, {
          style: {
            display: "none"
          }
        }), setNodeRef);
      } else {
        motionChildren = null;
      }
    } else {
      var _classNames;
      var statusSuffix;
      if (statusStep === STEP_PREPARE) {
        statusSuffix = "prepare";
      } else if (isActive(statusStep)) {
        statusSuffix = "active";
      } else if (statusStep === STEP_START) {
        statusSuffix = "start";
      }
      motionChildren = children(_objectSpread2$1(_objectSpread2$1({}, mergedProps), {}, {
        className: classNames(getTransitionName$1(motionName, status), (_classNames = {}, _defineProperty$1(_classNames, getTransitionName$1(motionName, "".concat(status, "-").concat(statusSuffix)), statusSuffix), _defineProperty$1(_classNames, motionName, typeof motionName === "string"), _classNames)),
        style: statusStyle
      }), setNodeRef);
    }
    return /* @__PURE__ */ React.createElement(DomWrapper, {
      ref: wrapperNodeRef
    }, motionChildren);
  });
  CSSMotion2.displayName = "CSSMotion";
  return CSSMotion2;
}
var CSSMotion = genCSSMotion(supportTransition);
function addEventListenerWrap(target, eventType, cb2, option) {
  var callback = ReactDOM.unstable_batchedUpdates ? function run(e2) {
    ReactDOM.unstable_batchedUpdates(cb2, e2);
  } : cb2;
  if (target.addEventListener) {
    target.addEventListener(eventType, callback, option);
  }
  return {
    remove: function remove() {
      if (target.removeEventListener) {
        target.removeEventListener(eventType, callback);
      }
    }
  };
}
function useControlledState(defaultStateValue, option) {
  var _ref = option || {}, defaultValue = _ref.defaultValue, value = _ref.value, onChange3 = _ref.onChange, postState = _ref.postState;
  var _React$useState = React.useState(function() {
    if (value !== void 0) {
      return value;
    }
    if (defaultValue !== void 0) {
      return typeof defaultValue === "function" ? defaultValue() : defaultValue;
    }
    return typeof defaultStateValue === "function" ? defaultStateValue() : defaultStateValue;
  }), _React$useState2 = _slicedToArray(_React$useState, 2), innerValue = _React$useState2[0], setInnerValue = _React$useState2[1];
  var mergedValue = value !== void 0 ? value : innerValue;
  if (postState) {
    mergedValue = postState(mergedValue);
  }
  var onChangeRef = React.useRef(onChange3);
  onChangeRef.current = onChange3;
  var triggerChange = React.useCallback(function(newValue) {
    setInnerValue(newValue);
    if (mergedValue !== newValue && onChangeRef.current) {
      onChangeRef.current(newValue, mergedValue);
    }
  }, [mergedValue, onChangeRef]);
  var firstRenderRef = React.useRef(true);
  React.useEffect(function() {
    if (firstRenderRef.current) {
      firstRenderRef.current = false;
      return;
    }
    if (value === void 0) {
      setInnerValue(value);
    }
  }, [value]);
  return [mergedValue, triggerChange];
}
var KeyCode = {
  MAC_ENTER: 3,
  BACKSPACE: 8,
  TAB: 9,
  NUM_CENTER: 12,
  ENTER: 13,
  SHIFT: 16,
  CTRL: 17,
  ALT: 18,
  PAUSE: 19,
  CAPS_LOCK: 20,
  ESC: 27,
  SPACE: 32,
  PAGE_UP: 33,
  PAGE_DOWN: 34,
  END: 35,
  HOME: 36,
  LEFT: 37,
  UP: 38,
  RIGHT: 39,
  DOWN: 40,
  PRINT_SCREEN: 44,
  INSERT: 45,
  DELETE: 46,
  ZERO: 48,
  ONE: 49,
  TWO: 50,
  THREE: 51,
  FOUR: 52,
  FIVE: 53,
  SIX: 54,
  SEVEN: 55,
  EIGHT: 56,
  NINE: 57,
  QUESTION_MARK: 63,
  A: 65,
  B: 66,
  C: 67,
  D: 68,
  E: 69,
  F: 70,
  G: 71,
  H: 72,
  I: 73,
  J: 74,
  K: 75,
  L: 76,
  M: 77,
  N: 78,
  O: 79,
  P: 80,
  Q: 81,
  R: 82,
  S: 83,
  T: 84,
  U: 85,
  V: 86,
  W: 87,
  X: 88,
  Y: 89,
  Z: 90,
  META: 91,
  WIN_KEY_RIGHT: 92,
  CONTEXT_MENU: 93,
  NUM_ZERO: 96,
  NUM_ONE: 97,
  NUM_TWO: 98,
  NUM_THREE: 99,
  NUM_FOUR: 100,
  NUM_FIVE: 101,
  NUM_SIX: 102,
  NUM_SEVEN: 103,
  NUM_EIGHT: 104,
  NUM_NINE: 105,
  NUM_MULTIPLY: 106,
  NUM_PLUS: 107,
  NUM_MINUS: 109,
  NUM_PERIOD: 110,
  NUM_DIVISION: 111,
  F1: 112,
  F2: 113,
  F3: 114,
  F4: 115,
  F5: 116,
  F6: 117,
  F7: 118,
  F8: 119,
  F9: 120,
  F10: 121,
  F11: 122,
  F12: 123,
  NUMLOCK: 144,
  SEMICOLON: 186,
  DASH: 189,
  EQUALS: 187,
  COMMA: 188,
  PERIOD: 190,
  SLASH: 191,
  APOSTROPHE: 192,
  SINGLE_QUOTE: 222,
  OPEN_SQUARE_BRACKET: 219,
  BACKSLASH: 220,
  CLOSE_SQUARE_BRACKET: 221,
  WIN_KEY: 224,
  MAC_FF_META: 224,
  WIN_IME: 229,
  isTextModifyingKeyEvent: function isTextModifyingKeyEvent(e2) {
    var keyCode = e2.keyCode;
    if (e2.altKey && !e2.ctrlKey || e2.metaKey || keyCode >= KeyCode.F1 && keyCode <= KeyCode.F12) {
      return false;
    }
    switch (keyCode) {
      case KeyCode.ALT:
      case KeyCode.CAPS_LOCK:
      case KeyCode.CONTEXT_MENU:
      case KeyCode.CTRL:
      case KeyCode.DOWN:
      case KeyCode.END:
      case KeyCode.ESC:
      case KeyCode.HOME:
      case KeyCode.INSERT:
      case KeyCode.LEFT:
      case KeyCode.MAC_FF_META:
      case KeyCode.META:
      case KeyCode.NUMLOCK:
      case KeyCode.NUM_CENTER:
      case KeyCode.PAGE_DOWN:
      case KeyCode.PAGE_UP:
      case KeyCode.PAUSE:
      case KeyCode.PRINT_SCREEN:
      case KeyCode.RIGHT:
      case KeyCode.SHIFT:
      case KeyCode.UP:
      case KeyCode.WIN_KEY:
      case KeyCode.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  },
  isCharacterKey: function isCharacterKey(keyCode) {
    if (keyCode >= KeyCode.ZERO && keyCode <= KeyCode.NINE) {
      return true;
    }
    if (keyCode >= KeyCode.NUM_ZERO && keyCode <= KeyCode.NUM_MULTIPLY) {
      return true;
    }
    if (keyCode >= KeyCode.A && keyCode <= KeyCode.Z) {
      return true;
    }
    if (window.navigator.userAgent.indexOf("WebKit") !== -1 && keyCode === 0) {
      return true;
    }
    switch (keyCode) {
      case KeyCode.SPACE:
      case KeyCode.QUESTION_MARK:
      case KeyCode.NUM_PLUS:
      case KeyCode.NUM_MINUS:
      case KeyCode.NUM_PERIOD:
      case KeyCode.NUM_DIVISION:
      case KeyCode.SEMICOLON:
      case KeyCode.DASH:
      case KeyCode.EQUALS:
      case KeyCode.COMMA:
      case KeyCode.PERIOD:
      case KeyCode.SLASH:
      case KeyCode.APOSTROPHE:
      case KeyCode.SINGLE_QUOTE:
      case KeyCode.OPEN_SQUARE_BRACKET:
      case KeyCode.BACKSLASH:
      case KeyCode.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  }
};
var isMobile = function() {
  if (typeof navigator === "undefined" || typeof window === "undefined") {
    return false;
  }
  var agent = navigator.userAgent || navigator.vendor || window.opera;
  if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(agent) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw-(n|u)|c55\/|capi|ccwa|cdm-|cell|chtm|cldc|cmd-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc-s|devi|dica|dmob|do(c|p)o|ds(12|-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(-|_)|g1 u|g560|gene|gf-5|g-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd-(m|p|t)|hei-|hi(pt|ta)|hp( i|ip)|hs-c|ht(c(-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i-(20|go|ma)|i230|iac( |-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|-[a-w])|libw|lynx|m1-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|-([1-8]|c))|phil|pire|pl(ay|uc)|pn-2|po(ck|rt|se)|prox|psio|pt-g|qa-a|qc(07|12|21|32|60|-[2-7]|i-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h-|oo|p-)|sdk\/|se(c(-|0|1)|47|mc|nd|ri)|sgh-|shar|sie(-|m)|sk-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h-|v-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl-|tdg-|tel(i|m)|tim-|t-mo|to(pl|sh)|ts(70|m-|m3|m5)|tx-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas-|your|zeto|zte-/i.test(agent === null || agent === void 0 ? void 0 : agent.substr(0, 4))) {
    return true;
  }
  return false;
};
var useLayoutEffect = canUseDom() ? React.useLayoutEffect : React.useEffect;
function contains(root2, n2) {
  if (!root2) {
    return false;
  }
  return root2.contains(n2);
}
var Portal = /* @__PURE__ */ forwardRef(function(props, ref) {
  var didUpdate = props.didUpdate, getContainer2 = props.getContainer, children = props.children;
  var containerRef = useRef();
  useImperativeHandle(ref, function() {
    return {};
  });
  var initRef = useRef(false);
  if (!initRef.current && canUseDom()) {
    containerRef.current = getContainer2();
    initRef.current = true;
  }
  useEffect(function() {
    didUpdate === null || didUpdate === void 0 ? void 0 : didUpdate(props);
  });
  useEffect(function() {
    return function() {
      var _containerRef$current, _containerRef$current2;
      (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : (_containerRef$current2 = _containerRef$current.parentNode) === null || _containerRef$current2 === void 0 ? void 0 : _containerRef$current2.removeChild(containerRef.current);
    };
  }, []);
  return containerRef.current ? /* @__PURE__ */ ReactDOM.createPortal(children, containerRef.current) : null;
});
function isPointsEq(a1, a2, isAlignPoint) {
  if (isAlignPoint) {
    return a1[0] === a2[0];
  }
  return a1[0] === a2[0] && a1[1] === a2[1];
}
function getAlignFromPlacement(builtinPlacements, placementStr, align) {
  var baseAlign = builtinPlacements[placementStr] || {};
  return _objectSpread2$1(_objectSpread2$1({}, baseAlign), align);
}
function getAlignPopupClassName(builtinPlacements, prefixCls, align, isAlignPoint) {
  var points2 = align.points;
  var placements2 = Object.keys(builtinPlacements);
  for (var i = 0; i < placements2.length; i += 1) {
    var placement = placements2[i];
    if (isPointsEq(builtinPlacements[placement].points, points2, isAlignPoint)) {
      return "".concat(prefixCls, "-placement-").concat(placement);
    }
  }
  return "";
}
function getMotion$1(_ref) {
  var prefixCls = _ref.prefixCls, motion = _ref.motion, animation = _ref.animation, transitionName = _ref.transitionName;
  if (motion) {
    return motion;
  }
  if (animation) {
    return {
      motionName: "".concat(prefixCls, "-").concat(animation)
    };
  }
  if (transitionName) {
    return {
      motionName: transitionName
    };
  }
  return null;
}
function Mask(props) {
  var prefixCls = props.prefixCls, visible = props.visible, zIndex = props.zIndex, mask = props.mask, maskMotion = props.maskMotion, maskAnimation = props.maskAnimation, maskTransitionName = props.maskTransitionName;
  if (!mask) {
    return null;
  }
  var motion = {};
  if (maskMotion || maskTransitionName || maskAnimation) {
    motion = _objectSpread2$1({
      motionAppear: true
    }, getMotion$1({
      motion: maskMotion,
      prefixCls,
      transitionName: maskTransitionName,
      animation: maskAnimation
    }));
  }
  return /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({}, motion, {
    visible,
    removeOnLeave: true
  }), function(_ref) {
    var className = _ref.className;
    return /* @__PURE__ */ React.createElement("div", {
      style: {
        zIndex
      },
      className: classNames("".concat(prefixCls, "-mask"), className)
    });
  });
}
var isVisible = function(element) {
  if (!element) {
    return false;
  }
  if (element.offsetParent) {
    return true;
  }
  if (element.getBBox) {
    var box2 = element.getBBox();
    if (box2.width || box2.height) {
      return true;
    }
  }
  if (element.getBoundingClientRect) {
    var _box = element.getBoundingClientRect();
    if (_box.width || _box.height) {
      return true;
    }
  }
  return false;
};
function ownKeys(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    if (enumerableOnly) {
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
      });
    }
    keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(Object(source), true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}
function _typeof(obj) {
  "@babel/helpers - typeof";
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function(obj2) {
      return typeof obj2;
    };
  } else {
    _typeof = function(obj2) {
      return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
    };
  }
  return _typeof(obj);
}
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
var vendorPrefix;
var jsCssMap = {
  Webkit: "-webkit-",
  Moz: "-moz-",
  ms: "-ms-",
  O: "-o-"
};
function getVendorPrefix() {
  if (vendorPrefix !== void 0) {
    return vendorPrefix;
  }
  vendorPrefix = "";
  var style2 = document.createElement("p").style;
  var testProp = "Transform";
  for (var key in jsCssMap) {
    if (key + testProp in style2) {
      vendorPrefix = key;
    }
  }
  return vendorPrefix;
}
function getTransitionName() {
  return getVendorPrefix() ? "".concat(getVendorPrefix(), "TransitionProperty") : "transitionProperty";
}
function getTransformName() {
  return getVendorPrefix() ? "".concat(getVendorPrefix(), "Transform") : "transform";
}
function setTransitionProperty(node, value) {
  var name = getTransitionName();
  if (name) {
    node.style[name] = value;
    if (name !== "transitionProperty") {
      node.style.transitionProperty = value;
    }
  }
}
function setTransform(node, value) {
  var name = getTransformName();
  if (name) {
    node.style[name] = value;
    if (name !== "transform") {
      node.style.transform = value;
    }
  }
}
function getTransitionProperty(node) {
  return node.style.transitionProperty || node.style[getTransitionName()];
}
function getTransformXY(node) {
  var style2 = window.getComputedStyle(node, null);
  var transform2 = style2.getPropertyValue("transform") || style2.getPropertyValue(getTransformName());
  if (transform2 && transform2 !== "none") {
    var matrix = transform2.replace(/[^0-9\-.,]/g, "").split(",");
    return {
      x: parseFloat(matrix[12] || matrix[4], 0),
      y: parseFloat(matrix[13] || matrix[5], 0)
    };
  }
  return {
    x: 0,
    y: 0
  };
}
var matrix2d = /matrix\((.*)\)/;
var matrix3d = /matrix3d\((.*)\)/;
function setTransformXY(node, xy) {
  var style2 = window.getComputedStyle(node, null);
  var transform2 = style2.getPropertyValue("transform") || style2.getPropertyValue(getTransformName());
  if (transform2 && transform2 !== "none") {
    var arr;
    var match2d = transform2.match(matrix2d);
    if (match2d) {
      match2d = match2d[1];
      arr = match2d.split(",").map(function(item) {
        return parseFloat(item, 10);
      });
      arr[4] = xy.x;
      arr[5] = xy.y;
      setTransform(node, "matrix(".concat(arr.join(","), ")"));
    } else {
      var match3d = transform2.match(matrix3d)[1];
      arr = match3d.split(",").map(function(item) {
        return parseFloat(item, 10);
      });
      arr[12] = xy.x;
      arr[13] = xy.y;
      setTransform(node, "matrix3d(".concat(arr.join(","), ")"));
    }
  } else {
    setTransform(node, "translateX(".concat(xy.x, "px) translateY(").concat(xy.y, "px) translateZ(0)"));
  }
}
var RE_NUM = /[\-+]?(?:\d*\.|)\d+(?:[eE][\-+]?\d+|)/.source;
var getComputedStyleX;
function forceRelayout(elem) {
  var originalStyle = elem.style.display;
  elem.style.display = "none";
  elem.offsetHeight;
  elem.style.display = originalStyle;
}
function css(el, name, v4) {
  var value = v4;
  if (_typeof(name) === "object") {
    for (var i in name) {
      if (name.hasOwnProperty(i)) {
        css(el, i, name[i]);
      }
    }
    return void 0;
  }
  if (typeof value !== "undefined") {
    if (typeof value === "number") {
      value = "".concat(value, "px");
    }
    el.style[name] = value;
    return void 0;
  }
  return getComputedStyleX(el, name);
}
function getClientPosition(elem) {
  var box2;
  var x2;
  var y2;
  var doc = elem.ownerDocument;
  var body = doc.body;
  var docElem = doc && doc.documentElement;
  box2 = elem.getBoundingClientRect();
  x2 = box2.left;
  y2 = box2.top;
  x2 -= docElem.clientLeft || body.clientLeft || 0;
  y2 -= docElem.clientTop || body.clientTop || 0;
  return {
    left: x2,
    top: y2
  };
}
function getScroll(w2, top) {
  var ret = w2["page".concat(top ? "Y" : "X", "Offset")];
  var method4 = "scroll".concat(top ? "Top" : "Left");
  if (typeof ret !== "number") {
    var d2 = w2.document;
    ret = d2.documentElement[method4];
    if (typeof ret !== "number") {
      ret = d2.body[method4];
    }
  }
  return ret;
}
function getScrollLeft(w2) {
  return getScroll(w2);
}
function getScrollTop(w2) {
  return getScroll(w2, true);
}
function getOffset$1(el) {
  var pos = getClientPosition(el);
  var doc = el.ownerDocument;
  var w2 = doc.defaultView || doc.parentWindow;
  pos.left += getScrollLeft(w2);
  pos.top += getScrollTop(w2);
  return pos;
}
function isWindow(obj) {
  return obj !== null && obj !== void 0 && obj == obj.window;
}
function getDocument(node) {
  if (isWindow(node)) {
    return node.document;
  }
  if (node.nodeType === 9) {
    return node;
  }
  return node.ownerDocument;
}
function _getComputedStyle(elem, name, cs) {
  var computedStyle = cs;
  var val = "";
  var d2 = getDocument(elem);
  computedStyle = computedStyle || d2.defaultView.getComputedStyle(elem, null);
  if (computedStyle) {
    val = computedStyle.getPropertyValue(name) || computedStyle[name];
  }
  return val;
}
var _RE_NUM_NO_PX = new RegExp("^(".concat(RE_NUM, ")(?!px)[a-z%]+$"), "i");
var RE_POS = /^(top|right|bottom|left)$/;
var CURRENT_STYLE = "currentStyle";
var RUNTIME_STYLE = "runtimeStyle";
var LEFT$1 = "left";
var PX = "px";
function _getComputedStyleIE(elem, name) {
  var ret = elem[CURRENT_STYLE] && elem[CURRENT_STYLE][name];
  if (_RE_NUM_NO_PX.test(ret) && !RE_POS.test(name)) {
    var style2 = elem.style;
    var left = style2[LEFT$1];
    var rsLeft = elem[RUNTIME_STYLE][LEFT$1];
    elem[RUNTIME_STYLE][LEFT$1] = elem[CURRENT_STYLE][LEFT$1];
    style2[LEFT$1] = name === "fontSize" ? "1em" : ret || 0;
    ret = style2.pixelLeft + PX;
    style2[LEFT$1] = left;
    elem[RUNTIME_STYLE][LEFT$1] = rsLeft;
  }
  return ret === "" ? "auto" : ret;
}
if (typeof window !== "undefined") {
  getComputedStyleX = window.getComputedStyle ? _getComputedStyle : _getComputedStyleIE;
}
function getOffsetDirection(dir3, option) {
  if (dir3 === "left") {
    return option.useCssRight ? "right" : dir3;
  }
  return option.useCssBottom ? "bottom" : dir3;
}
function oppositeOffsetDirection(dir3) {
  if (dir3 === "left") {
    return "right";
  } else if (dir3 === "right") {
    return "left";
  } else if (dir3 === "top") {
    return "bottom";
  } else if (dir3 === "bottom") {
    return "top";
  }
}
function setLeftTop(elem, offset2, option) {
  if (css(elem, "position") === "static") {
    elem.style.position = "relative";
  }
  var presetH = -999;
  var presetV = -999;
  var horizontalProperty = getOffsetDirection("left", option);
  var verticalProperty = getOffsetDirection("top", option);
  var oppositeHorizontalProperty = oppositeOffsetDirection(horizontalProperty);
  var oppositeVerticalProperty = oppositeOffsetDirection(verticalProperty);
  if (horizontalProperty !== "left") {
    presetH = 999;
  }
  if (verticalProperty !== "top") {
    presetV = 999;
  }
  var originalTransition = "";
  var originalOffset = getOffset$1(elem);
  if ("left" in offset2 || "top" in offset2) {
    originalTransition = getTransitionProperty(elem) || "";
    setTransitionProperty(elem, "none");
  }
  if ("left" in offset2) {
    elem.style[oppositeHorizontalProperty] = "";
    elem.style[horizontalProperty] = "".concat(presetH, "px");
  }
  if ("top" in offset2) {
    elem.style[oppositeVerticalProperty] = "";
    elem.style[verticalProperty] = "".concat(presetV, "px");
  }
  forceRelayout(elem);
  var old = getOffset$1(elem);
  var originalStyle = {};
  for (var key in offset2) {
    if (offset2.hasOwnProperty(key)) {
      var dir3 = getOffsetDirection(key, option);
      var preset = key === "left" ? presetH : presetV;
      var off = originalOffset[key] - old[key];
      if (dir3 === key) {
        originalStyle[dir3] = preset + off;
      } else {
        originalStyle[dir3] = preset - off;
      }
    }
  }
  css(elem, originalStyle);
  forceRelayout(elem);
  if ("left" in offset2 || "top" in offset2) {
    setTransitionProperty(elem, originalTransition);
  }
  var ret = {};
  for (var _key in offset2) {
    if (offset2.hasOwnProperty(_key)) {
      var _dir = getOffsetDirection(_key, option);
      var _off = offset2[_key] - originalOffset[_key];
      if (_key === _dir) {
        ret[_dir] = originalStyle[_dir] + _off;
      } else {
        ret[_dir] = originalStyle[_dir] - _off;
      }
    }
  }
  css(elem, ret);
}
function setTransform$1(elem, offset2) {
  var originalOffset = getOffset$1(elem);
  var originalXY = getTransformXY(elem);
  var resultXY = {
    x: originalXY.x,
    y: originalXY.y
  };
  if ("left" in offset2) {
    resultXY.x = originalXY.x + offset2.left - originalOffset.left;
  }
  if ("top" in offset2) {
    resultXY.y = originalXY.y + offset2.top - originalOffset.top;
  }
  setTransformXY(elem, resultXY);
}
function setOffset(elem, offset2, option) {
  if (option.ignoreShake) {
    var oriOffset = getOffset$1(elem);
    var oLeft = oriOffset.left.toFixed(0);
    var oTop = oriOffset.top.toFixed(0);
    var tLeft = offset2.left.toFixed(0);
    var tTop = offset2.top.toFixed(0);
    if (oLeft === tLeft && oTop === tTop) {
      return;
    }
  }
  if (option.useCssRight || option.useCssBottom) {
    setLeftTop(elem, offset2, option);
  } else if (option.useCssTransform && getTransformName() in document.body.style) {
    setTransform$1(elem, offset2);
  } else {
    setLeftTop(elem, offset2, option);
  }
}
function each(arr, fn) {
  for (var i = 0; i < arr.length; i++) {
    fn(arr[i]);
  }
}
function isBorderBoxFn(elem) {
  return getComputedStyleX(elem, "boxSizing") === "border-box";
}
var BOX_MODELS = ["margin", "border", "padding"];
var CONTENT_INDEX = -1;
var PADDING_INDEX = 2;
var BORDER_INDEX = 1;
var MARGIN_INDEX = 0;
function swap(elem, options, callback) {
  var old = {};
  var style2 = elem.style;
  var name;
  for (name in options) {
    if (options.hasOwnProperty(name)) {
      old[name] = style2[name];
      style2[name] = options[name];
    }
  }
  callback.call(elem);
  for (name in options) {
    if (options.hasOwnProperty(name)) {
      style2[name] = old[name];
    }
  }
}
function getPBMWidth(elem, props, which) {
  var value = 0;
  var prop;
  var j;
  var i;
  for (j = 0; j < props.length; j++) {
    prop = props[j];
    if (prop) {
      for (i = 0; i < which.length; i++) {
        var cssProp = void 0;
        if (prop === "border") {
          cssProp = "".concat(prop).concat(which[i], "Width");
        } else {
          cssProp = prop + which[i];
        }
        value += parseFloat(getComputedStyleX(elem, cssProp)) || 0;
      }
    }
  }
  return value;
}
var domUtils = {
  getParent: function getParent(element) {
    var parent = element;
    do {
      if (parent.nodeType === 11 && parent.host) {
        parent = parent.host;
      } else {
        parent = parent.parentNode;
      }
    } while (parent && parent.nodeType !== 1 && parent.nodeType !== 9);
    return parent;
  }
};
each(["Width", "Height"], function(name) {
  domUtils["doc".concat(name)] = function(refWin) {
    var d2 = refWin.document;
    return Math.max(d2.documentElement["scroll".concat(name)], d2.body["scroll".concat(name)], domUtils["viewport".concat(name)](d2));
  };
  domUtils["viewport".concat(name)] = function(win) {
    var prop = "client".concat(name);
    var doc = win.document;
    var body = doc.body;
    var documentElement = doc.documentElement;
    var documentElementProp = documentElement[prop];
    return doc.compatMode === "CSS1Compat" && documentElementProp || body && body[prop] || documentElementProp;
  };
});
function getWH(elem, name, ex) {
  var extra = ex;
  if (isWindow(elem)) {
    return name === "width" ? domUtils.viewportWidth(elem) : domUtils.viewportHeight(elem);
  } else if (elem.nodeType === 9) {
    return name === "width" ? domUtils.docWidth(elem) : domUtils.docHeight(elem);
  }
  var which = name === "width" ? ["Left", "Right"] : ["Top", "Bottom"];
  var borderBoxValue = name === "width" ? elem.getBoundingClientRect().width : elem.getBoundingClientRect().height;
  var isBorderBox = isBorderBoxFn(elem);
  var cssBoxValue = 0;
  if (borderBoxValue === null || borderBoxValue === void 0 || borderBoxValue <= 0) {
    borderBoxValue = void 0;
    cssBoxValue = getComputedStyleX(elem, name);
    if (cssBoxValue === null || cssBoxValue === void 0 || Number(cssBoxValue) < 0) {
      cssBoxValue = elem.style[name] || 0;
    }
    cssBoxValue = parseFloat(cssBoxValue) || 0;
  }
  if (extra === void 0) {
    extra = isBorderBox ? BORDER_INDEX : CONTENT_INDEX;
  }
  var borderBoxValueOrIsBorderBox = borderBoxValue !== void 0 || isBorderBox;
  var val = borderBoxValue || cssBoxValue;
  if (extra === CONTENT_INDEX) {
    if (borderBoxValueOrIsBorderBox) {
      return val - getPBMWidth(elem, ["border", "padding"], which);
    }
    return cssBoxValue;
  } else if (borderBoxValueOrIsBorderBox) {
    if (extra === BORDER_INDEX) {
      return val;
    }
    return val + (extra === PADDING_INDEX ? -getPBMWidth(elem, ["border"], which) : getPBMWidth(elem, ["margin"], which));
  }
  return cssBoxValue + getPBMWidth(elem, BOX_MODELS.slice(extra), which);
}
var cssShow = {
  position: "absolute",
  visibility: "hidden",
  display: "block"
};
function getWHIgnoreDisplay() {
  for (var _len = arguments.length, args = new Array(_len), _key2 = 0; _key2 < _len; _key2++) {
    args[_key2] = arguments[_key2];
  }
  var val;
  var elem = args[0];
  if (elem.offsetWidth !== 0) {
    val = getWH.apply(void 0, args);
  } else {
    swap(elem, cssShow, function() {
      val = getWH.apply(void 0, args);
    });
  }
  return val;
}
each(["width", "height"], function(name) {
  var first = name.charAt(0).toUpperCase() + name.slice(1);
  domUtils["outer".concat(first)] = function(el, includeMargin) {
    return el && getWHIgnoreDisplay(el, name, includeMargin ? MARGIN_INDEX : BORDER_INDEX);
  };
  var which = name === "width" ? ["Left", "Right"] : ["Top", "Bottom"];
  domUtils[name] = function(elem, v4) {
    var val = v4;
    if (val !== void 0) {
      if (elem) {
        var isBorderBox = isBorderBoxFn(elem);
        if (isBorderBox) {
          val += getPBMWidth(elem, ["padding", "border"], which);
        }
        return css(elem, name, val);
      }
      return void 0;
    }
    return elem && getWHIgnoreDisplay(elem, name, CONTENT_INDEX);
  };
});
function mix(to, from) {
  for (var i in from) {
    if (from.hasOwnProperty(i)) {
      to[i] = from[i];
    }
  }
  return to;
}
var utils = {
  getWindow: function getWindow(node) {
    if (node && node.document && node.setTimeout) {
      return node;
    }
    var doc = node.ownerDocument || node;
    return doc.defaultView || doc.parentWindow;
  },
  getDocument,
  offset: function offset(el, value, option) {
    if (typeof value !== "undefined") {
      setOffset(el, value, option || {});
    } else {
      return getOffset$1(el);
    }
  },
  isWindow,
  each,
  css,
  clone: function clone2(obj) {
    var i;
    var ret = {};
    for (i in obj) {
      if (obj.hasOwnProperty(i)) {
        ret[i] = obj[i];
      }
    }
    var overflow = obj.overflow;
    if (overflow) {
      for (i in obj) {
        if (obj.hasOwnProperty(i)) {
          ret.overflow[i] = obj.overflow[i];
        }
      }
    }
    return ret;
  },
  mix,
  getWindowScrollLeft: function getWindowScrollLeft(w2) {
    return getScrollLeft(w2);
  },
  getWindowScrollTop: function getWindowScrollTop(w2) {
    return getScrollTop(w2);
  },
  merge: function merge2() {
    var ret = {};
    for (var i = 0; i < arguments.length; i++) {
      utils.mix(ret, i < 0 || arguments.length <= i ? void 0 : arguments[i]);
    }
    return ret;
  },
  viewportWidth: 0,
  viewportHeight: 0
};
mix(utils, domUtils);
var getParent$1 = utils.getParent;
function getOffsetParent(element) {
  if (utils.isWindow(element) || element.nodeType === 9) {
    return null;
  }
  var doc = utils.getDocument(element);
  var body = doc.body;
  var parent;
  var positionStyle = utils.css(element, "position");
  var skipStatic = positionStyle === "fixed" || positionStyle === "absolute";
  if (!skipStatic) {
    return element.nodeName.toLowerCase() === "html" ? null : getParent$1(element);
  }
  for (parent = getParent$1(element); parent && parent !== body && parent.nodeType !== 9; parent = getParent$1(parent)) {
    positionStyle = utils.css(parent, "position");
    if (positionStyle !== "static") {
      return parent;
    }
  }
  return null;
}
var getParent$1$1 = utils.getParent;
function isAncestorFixed(element) {
  if (utils.isWindow(element) || element.nodeType === 9) {
    return false;
  }
  var doc = utils.getDocument(element);
  var body = doc.body;
  var parent = null;
  for (parent = getParent$1$1(element); parent && parent !== body && parent !== doc; parent = getParent$1$1(parent)) {
    var positionStyle = utils.css(parent, "position");
    if (positionStyle === "fixed") {
      return true;
    }
  }
  return false;
}
function getVisibleRectForElement(element, alwaysByViewport) {
  var visibleRect = {
    left: 0,
    right: Infinity,
    top: 0,
    bottom: Infinity
  };
  var el = getOffsetParent(element);
  var doc = utils.getDocument(element);
  var win = doc.defaultView || doc.parentWindow;
  var body = doc.body;
  var documentElement = doc.documentElement;
  while (el) {
    if ((navigator.userAgent.indexOf("MSIE") === -1 || el.clientWidth !== 0) && el !== body && el !== documentElement && utils.css(el, "overflow") !== "visible") {
      var pos = utils.offset(el);
      pos.left += el.clientLeft;
      pos.top += el.clientTop;
      visibleRect.top = Math.max(visibleRect.top, pos.top);
      visibleRect.right = Math.min(visibleRect.right, pos.left + el.clientWidth);
      visibleRect.bottom = Math.min(visibleRect.bottom, pos.top + el.clientHeight);
      visibleRect.left = Math.max(visibleRect.left, pos.left);
    } else if (el === body || el === documentElement) {
      break;
    }
    el = getOffsetParent(el);
  }
  var originalPosition = null;
  if (!utils.isWindow(element) && element.nodeType !== 9) {
    originalPosition = element.style.position;
    var position2 = utils.css(element, "position");
    if (position2 === "absolute") {
      element.style.position = "fixed";
    }
  }
  var scrollX = utils.getWindowScrollLeft(win);
  var scrollY = utils.getWindowScrollTop(win);
  var viewportWidth = utils.viewportWidth(win);
  var viewportHeight = utils.viewportHeight(win);
  var documentWidth = documentElement.scrollWidth;
  var documentHeight = documentElement.scrollHeight;
  var bodyStyle = window.getComputedStyle(body);
  if (bodyStyle.overflowX === "hidden") {
    documentWidth = win.innerWidth;
  }
  if (bodyStyle.overflowY === "hidden") {
    documentHeight = win.innerHeight;
  }
  if (element.style) {
    element.style.position = originalPosition;
  }
  if (alwaysByViewport || isAncestorFixed(element)) {
    visibleRect.left = Math.max(visibleRect.left, scrollX);
    visibleRect.top = Math.max(visibleRect.top, scrollY);
    visibleRect.right = Math.min(visibleRect.right, scrollX + viewportWidth);
    visibleRect.bottom = Math.min(visibleRect.bottom, scrollY + viewportHeight);
  } else {
    var maxVisibleWidth = Math.max(documentWidth, scrollX + viewportWidth);
    visibleRect.right = Math.min(visibleRect.right, maxVisibleWidth);
    var maxVisibleHeight = Math.max(documentHeight, scrollY + viewportHeight);
    visibleRect.bottom = Math.min(visibleRect.bottom, maxVisibleHeight);
  }
  return visibleRect.top >= 0 && visibleRect.left >= 0 && visibleRect.bottom > visibleRect.top && visibleRect.right > visibleRect.left ? visibleRect : null;
}
function adjustForViewport(elFuturePos, elRegion, visibleRect, overflow) {
  var pos = utils.clone(elFuturePos);
  var size = {
    width: elRegion.width,
    height: elRegion.height
  };
  if (overflow.adjustX && pos.left < visibleRect.left) {
    pos.left = visibleRect.left;
  }
  if (overflow.resizeWidth && pos.left >= visibleRect.left && pos.left + size.width > visibleRect.right) {
    size.width -= pos.left + size.width - visibleRect.right;
  }
  if (overflow.adjustX && pos.left + size.width > visibleRect.right) {
    pos.left = Math.max(visibleRect.right - size.width, visibleRect.left);
  }
  if (overflow.adjustY && pos.top < visibleRect.top) {
    pos.top = visibleRect.top;
  }
  if (overflow.resizeHeight && pos.top >= visibleRect.top && pos.top + size.height > visibleRect.bottom) {
    size.height -= pos.top + size.height - visibleRect.bottom;
  }
  if (overflow.adjustY && pos.top + size.height > visibleRect.bottom) {
    pos.top = Math.max(visibleRect.bottom - size.height, visibleRect.top);
  }
  return utils.mix(pos, size);
}
function getRegion(node) {
  var offset2;
  var w2;
  var h;
  if (!utils.isWindow(node) && node.nodeType !== 9) {
    offset2 = utils.offset(node);
    w2 = utils.outerWidth(node);
    h = utils.outerHeight(node);
  } else {
    var win = utils.getWindow(node);
    offset2 = {
      left: utils.getWindowScrollLeft(win),
      top: utils.getWindowScrollTop(win)
    };
    w2 = utils.viewportWidth(win);
    h = utils.viewportHeight(win);
  }
  offset2.width = w2;
  offset2.height = h;
  return offset2;
}
function getAlignOffset(region, align) {
  var V2 = align.charAt(0);
  var H2 = align.charAt(1);
  var w2 = region.width;
  var h = region.height;
  var x2 = region.left;
  var y2 = region.top;
  if (V2 === "c") {
    y2 += h / 2;
  } else if (V2 === "b") {
    y2 += h;
  }
  if (H2 === "c") {
    x2 += w2 / 2;
  } else if (H2 === "r") {
    x2 += w2;
  }
  return {
    left: x2,
    top: y2
  };
}
function getElFuturePos(elRegion, refNodeRegion, points2, offset2, targetOffset2) {
  var p1 = getAlignOffset(refNodeRegion, points2[1]);
  var p2 = getAlignOffset(elRegion, points2[0]);
  var diff = [p2.left - p1.left, p2.top - p1.top];
  return {
    left: Math.round(elRegion.left - diff[0] + offset2[0] - targetOffset2[0]),
    top: Math.round(elRegion.top - diff[1] + offset2[1] - targetOffset2[1])
  };
}
function isFailX(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.left < visibleRect.left || elFuturePos.left + elRegion.width > visibleRect.right;
}
function isFailY(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.top < visibleRect.top || elFuturePos.top + elRegion.height > visibleRect.bottom;
}
function isCompleteFailX(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.left > visibleRect.right || elFuturePos.left + elRegion.width < visibleRect.left;
}
function isCompleteFailY(elFuturePos, elRegion, visibleRect) {
  return elFuturePos.top > visibleRect.bottom || elFuturePos.top + elRegion.height < visibleRect.top;
}
function flip(points2, reg, map2) {
  var ret = [];
  utils.each(points2, function(p2) {
    ret.push(p2.replace(reg, function(m2) {
      return map2[m2];
    }));
  });
  return ret;
}
function flipOffset(offset2, index2) {
  offset2[index2] = -offset2[index2];
  return offset2;
}
function convertOffset(str, offsetLen) {
  var n2;
  if (/%$/.test(str)) {
    n2 = parseInt(str.substring(0, str.length - 1), 10) / 100 * offsetLen;
  } else {
    n2 = parseInt(str, 10);
  }
  return n2 || 0;
}
function normalizeOffset(offset2, el) {
  offset2[0] = convertOffset(offset2[0], el.width);
  offset2[1] = convertOffset(offset2[1], el.height);
}
function doAlign(el, tgtRegion, align, isTgtRegionVisible) {
  var points2 = align.points;
  var offset2 = align.offset || [0, 0];
  var targetOffset2 = align.targetOffset || [0, 0];
  var overflow = align.overflow;
  var source = align.source || el;
  offset2 = [].concat(offset2);
  targetOffset2 = [].concat(targetOffset2);
  overflow = overflow || {};
  var newOverflowCfg = {};
  var fail = 0;
  var alwaysByViewport = !!(overflow && overflow.alwaysByViewport);
  var visibleRect = getVisibleRectForElement(source, alwaysByViewport);
  var elRegion = getRegion(source);
  normalizeOffset(offset2, elRegion);
  normalizeOffset(targetOffset2, tgtRegion);
  var elFuturePos = getElFuturePos(elRegion, tgtRegion, points2, offset2, targetOffset2);
  var newElRegion = utils.merge(elRegion, elFuturePos);
  if (visibleRect && (overflow.adjustX || overflow.adjustY) && isTgtRegionVisible) {
    if (overflow.adjustX) {
      if (isFailX(elFuturePos, elRegion, visibleRect)) {
        var newPoints = flip(points2, /[lr]/gi, {
          l: "r",
          r: "l"
        });
        var newOffset = flipOffset(offset2, 0);
        var newTargetOffset = flipOffset(targetOffset2, 0);
        var newElFuturePos = getElFuturePos(elRegion, tgtRegion, newPoints, newOffset, newTargetOffset);
        if (!isCompleteFailX(newElFuturePos, elRegion, visibleRect)) {
          fail = 1;
          points2 = newPoints;
          offset2 = newOffset;
          targetOffset2 = newTargetOffset;
        }
      }
    }
    if (overflow.adjustY) {
      if (isFailY(elFuturePos, elRegion, visibleRect)) {
        var _newPoints = flip(points2, /[tb]/gi, {
          t: "b",
          b: "t"
        });
        var _newOffset = flipOffset(offset2, 1);
        var _newTargetOffset = flipOffset(targetOffset2, 1);
        var _newElFuturePos = getElFuturePos(elRegion, tgtRegion, _newPoints, _newOffset, _newTargetOffset);
        if (!isCompleteFailY(_newElFuturePos, elRegion, visibleRect)) {
          fail = 1;
          points2 = _newPoints;
          offset2 = _newOffset;
          targetOffset2 = _newTargetOffset;
        }
      }
    }
    if (fail) {
      elFuturePos = getElFuturePos(elRegion, tgtRegion, points2, offset2, targetOffset2);
      utils.mix(newElRegion, elFuturePos);
    }
    var isStillFailX = isFailX(elFuturePos, elRegion, visibleRect);
    var isStillFailY = isFailY(elFuturePos, elRegion, visibleRect);
    if (isStillFailX || isStillFailY) {
      var _newPoints2 = points2;
      if (isStillFailX) {
        _newPoints2 = flip(points2, /[lr]/gi, {
          l: "r",
          r: "l"
        });
      }
      if (isStillFailY) {
        _newPoints2 = flip(points2, /[tb]/gi, {
          t: "b",
          b: "t"
        });
      }
      points2 = _newPoints2;
      offset2 = align.offset || [0, 0];
      targetOffset2 = align.targetOffset || [0, 0];
    }
    newOverflowCfg.adjustX = overflow.adjustX && isStillFailX;
    newOverflowCfg.adjustY = overflow.adjustY && isStillFailY;
    if (newOverflowCfg.adjustX || newOverflowCfg.adjustY) {
      newElRegion = adjustForViewport(elFuturePos, elRegion, visibleRect, newOverflowCfg);
    }
  }
  if (newElRegion.width !== elRegion.width) {
    utils.css(source, "width", utils.width(source) + newElRegion.width - elRegion.width);
  }
  if (newElRegion.height !== elRegion.height) {
    utils.css(source, "height", utils.height(source) + newElRegion.height - elRegion.height);
  }
  utils.offset(source, {
    left: newElRegion.left,
    top: newElRegion.top
  }, {
    useCssRight: align.useCssRight,
    useCssBottom: align.useCssBottom,
    useCssTransform: align.useCssTransform,
    ignoreShake: align.ignoreShake
  });
  return {
    points: points2,
    offset: offset2,
    targetOffset: targetOffset2,
    overflow: newOverflowCfg
  };
}
function isOutOfVisibleRect(target, alwaysByViewport) {
  var visibleRect = getVisibleRectForElement(target, alwaysByViewport);
  var targetRegion = getRegion(target);
  return !visibleRect || targetRegion.left + targetRegion.width <= visibleRect.left || targetRegion.top + targetRegion.height <= visibleRect.top || targetRegion.left >= visibleRect.right || targetRegion.top >= visibleRect.bottom;
}
function alignElement(el, refNode, align) {
  var target = align.target || refNode;
  var refNodeRegion = getRegion(target);
  var isTargetNotOutOfVisible = !isOutOfVisibleRect(target, align.overflow && align.overflow.alwaysByViewport);
  return doAlign(el, refNodeRegion, align, isTargetNotOutOfVisible);
}
alignElement.__getOffsetParent = getOffsetParent;
alignElement.__getVisibleRectForElement = getVisibleRectForElement;
function alignPoint(el, tgtPoint, align) {
  var pageX;
  var pageY;
  var doc = utils.getDocument(el);
  var win = doc.defaultView || doc.parentWindow;
  var scrollX = utils.getWindowScrollLeft(win);
  var scrollY = utils.getWindowScrollTop(win);
  var viewportWidth = utils.viewportWidth(win);
  var viewportHeight = utils.viewportHeight(win);
  if ("pageX" in tgtPoint) {
    pageX = tgtPoint.pageX;
  } else {
    pageX = scrollX + tgtPoint.clientX;
  }
  if ("pageY" in tgtPoint) {
    pageY = tgtPoint.pageY;
  } else {
    pageY = scrollY + tgtPoint.clientY;
  }
  var tgtRegion = {
    left: pageX,
    top: pageY,
    width: 0,
    height: 0
  };
  var pointInView = pageX >= 0 && pageX <= scrollX + viewportWidth && pageY >= 0 && pageY <= scrollY + viewportHeight;
  var points2 = [align.points[0], "cc"];
  return doAlign(el, tgtRegion, _objectSpread2(_objectSpread2({}, align), {}, {
    points: points2
  }), pointInView);
}
function isSamePoint(prev, next) {
  if (prev === next)
    return true;
  if (!prev || !next)
    return false;
  if ("pageX" in next && "pageY" in next) {
    return prev.pageX === next.pageX && prev.pageY === next.pageY;
  }
  if ("clientX" in next && "clientY" in next) {
    return prev.clientX === next.clientX && prev.clientY === next.clientY;
  }
  return false;
}
function restoreFocus(activeElement, container2) {
  if (activeElement !== document.activeElement && contains(container2, activeElement) && typeof activeElement.focus === "function") {
    activeElement.focus();
  }
}
function monitorResize(element, callback) {
  var prevWidth = null;
  var prevHeight = null;
  function onResize2(_ref) {
    var _ref2 = _slicedToArray(_ref, 1), target = _ref2[0].target;
    if (!document.documentElement.contains(target))
      return;
    var _target$getBoundingCl = target.getBoundingClientRect(), width = _target$getBoundingCl.width, height = _target$getBoundingCl.height;
    var fixedWidth = Math.floor(width);
    var fixedHeight = Math.floor(height);
    if (prevWidth !== fixedWidth || prevHeight !== fixedHeight) {
      Promise.resolve().then(function() {
        callback({
          width: fixedWidth,
          height: fixedHeight
        });
      });
    }
    prevWidth = fixedWidth;
    prevHeight = fixedHeight;
  }
  var resizeObserver2 = new index$8(onResize2);
  if (element) {
    resizeObserver2.observe(element);
  }
  return function() {
    resizeObserver2.disconnect();
  };
}
var useBuffer = function(callback, buffer) {
  var calledRef = React__default.useRef(false);
  var timeoutRef = React__default.useRef(null);
  function cancelTrigger() {
    window.clearTimeout(timeoutRef.current);
  }
  function trigger2(force) {
    if (!calledRef.current || force === true) {
      if (callback() === false) {
        return;
      }
      calledRef.current = true;
      cancelTrigger();
      timeoutRef.current = window.setTimeout(function() {
        calledRef.current = false;
      }, buffer);
    } else {
      cancelTrigger();
      timeoutRef.current = window.setTimeout(function() {
        calledRef.current = false;
        trigger2();
      }, buffer);
    }
  }
  return [trigger2, function() {
    calledRef.current = false;
    cancelTrigger();
  }];
};
function getElement(func) {
  if (typeof func !== "function")
    return null;
  return func();
}
function getPoint(point) {
  if (_typeof$1(point) !== "object" || !point)
    return null;
  return point;
}
var Align = function Align2(_ref, ref) {
  var children = _ref.children, disabled = _ref.disabled, target = _ref.target, align = _ref.align, onAlign = _ref.onAlign, monitorWindowResize = _ref.monitorWindowResize, _ref$monitorBufferTim = _ref.monitorBufferTime, monitorBufferTime = _ref$monitorBufferTim === void 0 ? 0 : _ref$monitorBufferTim;
  var cacheRef = React__default.useRef({});
  var nodeRef = React__default.useRef();
  var childNode = React__default.Children.only(children);
  var forceAlignPropsRef = React__default.useRef({});
  forceAlignPropsRef.current.disabled = disabled;
  forceAlignPropsRef.current.target = target;
  forceAlignPropsRef.current.align = align;
  forceAlignPropsRef.current.onAlign = onAlign;
  var _useBuffer = useBuffer(function() {
    var _forceAlignPropsRef$c = forceAlignPropsRef.current, latestDisabled = _forceAlignPropsRef$c.disabled, latestTarget = _forceAlignPropsRef$c.target, latestAlign = _forceAlignPropsRef$c.align, latestOnAlign = _forceAlignPropsRef$c.onAlign;
    if (!latestDisabled && latestTarget) {
      var source = nodeRef.current;
      var result;
      var element = getElement(latestTarget);
      var point = getPoint(latestTarget);
      cacheRef.current.element = element;
      cacheRef.current.point = point;
      cacheRef.current.align = latestAlign;
      var _document = document, activeElement = _document.activeElement;
      if (element && isVisible(element)) {
        result = alignElement(source, element, latestAlign);
      } else if (point) {
        result = alignPoint(source, point, latestAlign);
      }
      restoreFocus(activeElement, source);
      if (latestOnAlign && result) {
        latestOnAlign(source, result);
      }
      return true;
    }
    return false;
  }, monitorBufferTime), _useBuffer2 = _slicedToArray(_useBuffer, 2), _forceAlign = _useBuffer2[0], cancelForceAlign = _useBuffer2[1];
  var resizeMonitor = React__default.useRef({
    cancel: function cancel2() {
    }
  });
  var sourceResizeMonitor = React__default.useRef({
    cancel: function cancel2() {
    }
  });
  React__default.useEffect(function() {
    var element = getElement(target);
    var point = getPoint(target);
    if (nodeRef.current !== sourceResizeMonitor.current.element) {
      sourceResizeMonitor.current.cancel();
      sourceResizeMonitor.current.element = nodeRef.current;
      sourceResizeMonitor.current.cancel = monitorResize(nodeRef.current, _forceAlign);
    }
    if (cacheRef.current.element !== element || !isSamePoint(cacheRef.current.point, point) || !isEqual_1(cacheRef.current.align, align)) {
      _forceAlign();
      if (resizeMonitor.current.element !== element) {
        resizeMonitor.current.cancel();
        resizeMonitor.current.element = element;
        resizeMonitor.current.cancel = monitorResize(element, _forceAlign);
      }
    }
  });
  React__default.useEffect(function() {
    if (!disabled) {
      _forceAlign();
    } else {
      cancelForceAlign();
    }
  }, [disabled]);
  var winResizeRef = React__default.useRef(null);
  React__default.useEffect(function() {
    if (monitorWindowResize) {
      if (!winResizeRef.current) {
        winResizeRef.current = addEventListenerWrap(window, "resize", _forceAlign);
      }
    } else if (winResizeRef.current) {
      winResizeRef.current.remove();
      winResizeRef.current = null;
    }
  }, [monitorWindowResize]);
  React__default.useEffect(function() {
    return function() {
      resizeMonitor.current.cancel();
      sourceResizeMonitor.current.cancel();
      if (winResizeRef.current)
        winResizeRef.current.remove();
      cancelForceAlign();
    };
  }, []);
  React__default.useImperativeHandle(ref, function() {
    return {
      forceAlign: function forceAlign() {
        return _forceAlign(true);
      }
    };
  });
  if (/* @__PURE__ */ React__default.isValidElement(childNode)) {
    childNode = /* @__PURE__ */ React__default.cloneElement(childNode, {
      ref: composeRef(childNode.ref, nodeRef)
    });
  }
  return childNode;
};
var RcAlign = /* @__PURE__ */ React__default.forwardRef(Align);
RcAlign.displayName = "Align";
var StatusQueue = ["measure", "align", null, "motion"];
var useVisibleStatus = function(visible, doMeasure) {
  var _useState = useState(null), _useState2 = _slicedToArray(_useState, 2), status = _useState2[0], setInternalStatus = _useState2[1];
  var rafRef = useRef();
  var destroyRef = useRef(false);
  function setStatus(nextStatus) {
    if (!destroyRef.current) {
      setInternalStatus(nextStatus);
    }
  }
  function cancelRaf() {
    wrapperRaf$1.cancel(rafRef.current);
  }
  function goNextStatus(callback) {
    cancelRaf();
    rafRef.current = wrapperRaf$1(function() {
      setStatus(function(prev) {
        switch (status) {
          case "align":
            return "motion";
          case "motion":
            return "stable";
        }
        return prev;
      });
      callback === null || callback === void 0 ? void 0 : callback();
    });
  }
  useEffect(function() {
    setStatus("measure");
  }, [visible]);
  useEffect(function() {
    switch (status) {
      case "measure":
        doMeasure();
        break;
    }
    if (status) {
      rafRef.current = wrapperRaf$1(/* @__PURE__ */ _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee() {
        var index2, nextStatus;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                index2 = StatusQueue.indexOf(status);
                nextStatus = StatusQueue[index2 + 1];
                if (nextStatus && index2 !== -1) {
                  setStatus(nextStatus);
                }
              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
    }
  }, [status]);
  useEffect(function() {
    return function() {
      destroyRef.current = true;
      cancelRaf();
    };
  }, []);
  return [status, goNextStatus];
};
var useStretchStyle = function(stretch) {
  var _React$useState = React.useState({
    width: 0,
    height: 0
  }), _React$useState2 = _slicedToArray(_React$useState, 2), targetSize = _React$useState2[0], setTargetSize = _React$useState2[1];
  function measureStretch(element) {
    setTargetSize({
      width: element.offsetWidth,
      height: element.offsetHeight
    });
  }
  var style2 = React.useMemo(function() {
    var sizeStyle = {};
    if (stretch) {
      var width = targetSize.width, height = targetSize.height;
      if (stretch.indexOf("height") !== -1 && height) {
        sizeStyle.height = height;
      } else if (stretch.indexOf("minHeight") !== -1 && height) {
        sizeStyle.minHeight = height;
      }
      if (stretch.indexOf("width") !== -1 && width) {
        sizeStyle.width = width;
      } else if (stretch.indexOf("minWidth") !== -1 && width) {
        sizeStyle.minWidth = width;
      }
    }
    return sizeStyle;
  }, [stretch, targetSize]);
  return [style2, measureStretch];
};
var PopupInner = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var visible = props.visible, prefixCls = props.prefixCls, className = props.className, style2 = props.style, children = props.children, zIndex = props.zIndex, stretch = props.stretch, destroyPopupOnHide = props.destroyPopupOnHide, forceRender = props.forceRender, align = props.align, point = props.point, getRootDomNode = props.getRootDomNode, getClassNameFromAlign = props.getClassNameFromAlign, onAlign = props.onAlign, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onMouseDown = props.onMouseDown, onTouchStart = props.onTouchStart;
  var alignRef = useRef();
  var elementRef = useRef();
  var _useState = useState(), _useState2 = _slicedToArray(_useState, 2), alignedClassName = _useState2[0], setAlignedClassName = _useState2[1];
  var _useStretchStyle = useStretchStyle(stretch), _useStretchStyle2 = _slicedToArray(_useStretchStyle, 2), stretchStyle = _useStretchStyle2[0], measureStretchStyle = _useStretchStyle2[1];
  function doMeasure() {
    if (stretch) {
      measureStretchStyle(getRootDomNode());
    }
  }
  var _useVisibleStatus = useVisibleStatus(visible, doMeasure), _useVisibleStatus2 = _slicedToArray(_useVisibleStatus, 2), status = _useVisibleStatus2[0], goNextStatus = _useVisibleStatus2[1];
  var prepareResolveRef = useRef();
  function getAlignTarget() {
    if (point) {
      return point;
    }
    return getRootDomNode;
  }
  function forceAlign() {
    var _alignRef$current;
    (_alignRef$current = alignRef.current) === null || _alignRef$current === void 0 ? void 0 : _alignRef$current.forceAlign();
  }
  function onInternalAlign(popupDomNode, matchAlign) {
    var nextAlignedClassName = getClassNameFromAlign(matchAlign);
    if (alignedClassName !== nextAlignedClassName) {
      setAlignedClassName(nextAlignedClassName);
    }
    if (status === "align") {
      if (alignedClassName !== nextAlignedClassName) {
        Promise.resolve().then(function() {
          forceAlign();
        });
      } else {
        goNextStatus(function() {
          var _prepareResolveRef$cu;
          (_prepareResolveRef$cu = prepareResolveRef.current) === null || _prepareResolveRef$cu === void 0 ? void 0 : _prepareResolveRef$cu.call(prepareResolveRef);
        });
      }
      onAlign === null || onAlign === void 0 ? void 0 : onAlign(popupDomNode, matchAlign);
    }
  }
  var motion = _objectSpread2$1({}, getMotion$1(props));
  ["onAppearEnd", "onEnterEnd", "onLeaveEnd"].forEach(function(eventName) {
    var originHandler = motion[eventName];
    motion[eventName] = function(element, event) {
      goNextStatus();
      return originHandler === null || originHandler === void 0 ? void 0 : originHandler(element, event);
    };
  });
  function onShowPrepare() {
    return new Promise(function(resolve) {
      prepareResolveRef.current = resolve;
    });
  }
  React.useEffect(function() {
    if (!motion.motionName && status === "motion") {
      goNextStatus();
    }
  }, [motion.motionName, status]);
  React.useImperativeHandle(ref, function() {
    return {
      forceAlign,
      getElement: function getElement2() {
        return elementRef.current;
      }
    };
  });
  var mergedStyle = _objectSpread2$1(_objectSpread2$1({}, stretchStyle), {}, {
    zIndex,
    opacity: status === "motion" || status === "stable" || !visible ? void 0 : 0,
    pointerEvents: status === "stable" ? void 0 : "none"
  }, style2);
  var alignDisabled = true;
  if ((align === null || align === void 0 ? void 0 : align.points) && (status === "align" || status === "stable")) {
    alignDisabled = false;
  }
  var childNode = children;
  if (React.Children.count(children) > 1) {
    childNode = /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-content")
    }, children);
  }
  return /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({
    visible,
    ref: elementRef,
    leavedClassName: "".concat(prefixCls, "-hidden")
  }, motion, {
    onAppearPrepare: onShowPrepare,
    onEnterPrepare: onShowPrepare,
    removeOnLeave: destroyPopupOnHide,
    forceRender
  }), function(_ref, motionRef) {
    var motionClassName = _ref.className, motionStyle = _ref.style;
    var mergedClassName = classNames(prefixCls, className, alignedClassName, motionClassName);
    return /* @__PURE__ */ React.createElement(RcAlign, {
      target: getAlignTarget(),
      key: "popup",
      ref: alignRef,
      monitorWindowResize: true,
      disabled: alignDisabled,
      align,
      onAlign: onInternalAlign
    }, /* @__PURE__ */ React.createElement("div", {
      ref: motionRef,
      className: mergedClassName,
      onMouseEnter,
      onMouseLeave,
      onMouseDownCapture: onMouseDown,
      onTouchStartCapture: onTouchStart,
      style: _objectSpread2$1(_objectSpread2$1({}, motionStyle), mergedStyle)
    }, childNode));
  });
});
PopupInner.displayName = "PopupInner";
var MobilePopupInner = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var prefixCls = props.prefixCls, visible = props.visible, zIndex = props.zIndex, children = props.children, _props$mobile = props.mobile;
  _props$mobile = _props$mobile === void 0 ? {} : _props$mobile;
  var popupClassName = _props$mobile.popupClassName, popupStyle = _props$mobile.popupStyle, _props$mobile$popupMo = _props$mobile.popupMotion, popupMotion = _props$mobile$popupMo === void 0 ? {} : _props$mobile$popupMo, popupRender = _props$mobile.popupRender;
  var elementRef = React.useRef();
  React.useImperativeHandle(ref, function() {
    return {
      forceAlign: function forceAlign() {
      },
      getElement: function getElement2() {
        return elementRef.current;
      }
    };
  });
  var mergedStyle = _objectSpread2$1({
    zIndex
  }, popupStyle);
  var childNode = children;
  if (React.Children.count(children) > 1) {
    childNode = /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-content")
    }, children);
  }
  if (popupRender) {
    childNode = popupRender(childNode);
  }
  return /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({
    visible,
    ref: elementRef,
    removeOnLeave: true
  }, popupMotion), function(_ref, motionRef) {
    var motionClassName = _ref.className, motionStyle = _ref.style;
    var mergedClassName = classNames(prefixCls, popupClassName, motionClassName);
    return /* @__PURE__ */ React.createElement("div", {
      ref: motionRef,
      className: mergedClassName,
      style: _objectSpread2$1(_objectSpread2$1({}, motionStyle), mergedStyle)
    }, childNode);
  });
});
MobilePopupInner.displayName = "MobilePopupInner";
var _excluded$e = ["visible", "mobile"];
var Popup = /* @__PURE__ */ React.forwardRef(function(_ref, ref) {
  var visible = _ref.visible, mobile = _ref.mobile, props = _objectWithoutProperties(_ref, _excluded$e);
  var _useState = useState(visible), _useState2 = _slicedToArray(_useState, 2), innerVisible = _useState2[0], serInnerVisible = _useState2[1];
  var _useState3 = useState(false), _useState4 = _slicedToArray(_useState3, 2), inMobile = _useState4[0], setInMobile = _useState4[1];
  var cloneProps = _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    visible: innerVisible
  });
  useEffect(function() {
    serInnerVisible(visible);
    if (visible && mobile) {
      setInMobile(isMobile());
    }
  }, [visible, mobile]);
  var popupNode = inMobile ? /* @__PURE__ */ React.createElement(MobilePopupInner, _extends$1({}, cloneProps, {
    mobile,
    ref
  })) : /* @__PURE__ */ React.createElement(PopupInner, _extends$1({}, cloneProps, {
    ref
  }));
  return /* @__PURE__ */ React.createElement("div", null, /* @__PURE__ */ React.createElement(Mask, cloneProps), popupNode);
});
Popup.displayName = "Popup";
var TriggerContext = /* @__PURE__ */ React.createContext(null);
function noop() {
}
function returnEmptyString() {
  return "";
}
function returnDocument(element) {
  if (element) {
    return element.ownerDocument;
  }
  return window.document;
}
var ALL_HANDLERS = ["onClick", "onMouseDown", "onTouchStart", "onMouseEnter", "onMouseLeave", "onFocus", "onBlur", "onContextMenu"];
function generateTrigger(PortalComponent) {
  var Trigger2 = /* @__PURE__ */ function(_React$Component) {
    _inherits(Trigger3, _React$Component);
    var _super = _createSuper(Trigger3);
    function Trigger3(props) {
      var _this;
      _classCallCheck(this, Trigger3);
      _this = _super.call(this, props);
      _this.popupRef = /* @__PURE__ */ React.createRef();
      _this.triggerRef = /* @__PURE__ */ React.createRef();
      _this.attachId = void 0;
      _this.clickOutsideHandler = void 0;
      _this.touchOutsideHandler = void 0;
      _this.contextMenuOutsideHandler1 = void 0;
      _this.contextMenuOutsideHandler2 = void 0;
      _this.mouseDownTimeout = void 0;
      _this.focusTime = void 0;
      _this.preClickTime = void 0;
      _this.preTouchTime = void 0;
      _this.delayTimer = void 0;
      _this.hasPopupMouseDown = void 0;
      _this.onMouseEnter = function(e2) {
        var mouseEnterDelay = _this.props.mouseEnterDelay;
        _this.fireEvents("onMouseEnter", e2);
        _this.delaySetPopupVisible(true, mouseEnterDelay, mouseEnterDelay ? null : e2);
      };
      _this.onMouseMove = function(e2) {
        _this.fireEvents("onMouseMove", e2);
        _this.setPoint(e2);
      };
      _this.onMouseLeave = function(e2) {
        _this.fireEvents("onMouseLeave", e2);
        _this.delaySetPopupVisible(false, _this.props.mouseLeaveDelay);
      };
      _this.onPopupMouseEnter = function() {
        _this.clearDelayTimer();
      };
      _this.onPopupMouseLeave = function(e2) {
        var _this$popupRef$curren;
        if (e2.relatedTarget && !e2.relatedTarget.setTimeout && contains((_this$popupRef$curren = _this.popupRef.current) === null || _this$popupRef$curren === void 0 ? void 0 : _this$popupRef$curren.getElement(), e2.relatedTarget)) {
          return;
        }
        _this.delaySetPopupVisible(false, _this.props.mouseLeaveDelay);
      };
      _this.onFocus = function(e2) {
        _this.fireEvents("onFocus", e2);
        _this.clearDelayTimer();
        if (_this.isFocusToShow()) {
          _this.focusTime = Date.now();
          _this.delaySetPopupVisible(true, _this.props.focusDelay);
        }
      };
      _this.onMouseDown = function(e2) {
        _this.fireEvents("onMouseDown", e2);
        _this.preClickTime = Date.now();
      };
      _this.onTouchStart = function(e2) {
        _this.fireEvents("onTouchStart", e2);
        _this.preTouchTime = Date.now();
      };
      _this.onBlur = function(e2) {
        _this.fireEvents("onBlur", e2);
        _this.clearDelayTimer();
        if (_this.isBlurToHide()) {
          _this.delaySetPopupVisible(false, _this.props.blurDelay);
        }
      };
      _this.onContextMenu = function(e2) {
        e2.preventDefault();
        _this.fireEvents("onContextMenu", e2);
        _this.setPopupVisible(true, e2);
      };
      _this.onContextMenuClose = function() {
        if (_this.isContextMenuToShow()) {
          _this.close();
        }
      };
      _this.onClick = function(event) {
        _this.fireEvents("onClick", event);
        if (_this.focusTime) {
          var preTime;
          if (_this.preClickTime && _this.preTouchTime) {
            preTime = Math.min(_this.preClickTime, _this.preTouchTime);
          } else if (_this.preClickTime) {
            preTime = _this.preClickTime;
          } else if (_this.preTouchTime) {
            preTime = _this.preTouchTime;
          }
          if (Math.abs(preTime - _this.focusTime) < 20) {
            return;
          }
          _this.focusTime = 0;
        }
        _this.preClickTime = 0;
        _this.preTouchTime = 0;
        if (_this.isClickToShow() && (_this.isClickToHide() || _this.isBlurToHide()) && event && event.preventDefault) {
          event.preventDefault();
        }
        var nextVisible = !_this.state.popupVisible;
        if (_this.isClickToHide() && !nextVisible || nextVisible && _this.isClickToShow()) {
          _this.setPopupVisible(!_this.state.popupVisible, event);
        }
      };
      _this.onPopupMouseDown = function() {
        _this.hasPopupMouseDown = true;
        clearTimeout(_this.mouseDownTimeout);
        _this.mouseDownTimeout = window.setTimeout(function() {
          _this.hasPopupMouseDown = false;
        }, 0);
        if (_this.context) {
          var _this$context;
          (_this$context = _this.context).onPopupMouseDown.apply(_this$context, arguments);
        }
      };
      _this.onDocumentClick = function(event) {
        if (_this.props.mask && !_this.props.maskClosable) {
          return;
        }
        var target = event.target;
        var root2 = _this.getRootDomNode();
        var popupNode = _this.getPopupDomNode();
        if ((!contains(root2, target) || _this.isContextMenuOnly()) && !contains(popupNode, target) && !_this.hasPopupMouseDown) {
          _this.close();
        }
      };
      _this.getRootDomNode = function() {
        var getTriggerDOMNode = _this.props.getTriggerDOMNode;
        if (getTriggerDOMNode) {
          return getTriggerDOMNode(_this.triggerRef.current);
        }
        try {
          var domNode = findDOMNode(_this.triggerRef.current);
          if (domNode) {
            return domNode;
          }
        } catch (err) {
        }
        return ReactDOM.findDOMNode(_assertThisInitialized(_this));
      };
      _this.getPopupClassNameFromAlign = function(align) {
        var className = [];
        var _this$props = _this.props, popupPlacement = _this$props.popupPlacement, builtinPlacements = _this$props.builtinPlacements, prefixCls = _this$props.prefixCls, alignPoint2 = _this$props.alignPoint, getPopupClassNameFromAlign = _this$props.getPopupClassNameFromAlign;
        if (popupPlacement && builtinPlacements) {
          className.push(getAlignPopupClassName(builtinPlacements, prefixCls, align, alignPoint2));
        }
        if (getPopupClassNameFromAlign) {
          className.push(getPopupClassNameFromAlign(align));
        }
        return className.join(" ");
      };
      _this.getComponent = function() {
        var _this$props2 = _this.props, prefixCls = _this$props2.prefixCls, destroyPopupOnHide = _this$props2.destroyPopupOnHide, popupClassName = _this$props2.popupClassName, onPopupAlign = _this$props2.onPopupAlign, popupMotion = _this$props2.popupMotion, popupAnimation = _this$props2.popupAnimation, popupTransitionName = _this$props2.popupTransitionName, popupStyle = _this$props2.popupStyle, mask = _this$props2.mask, maskAnimation = _this$props2.maskAnimation, maskTransitionName = _this$props2.maskTransitionName, maskMotion = _this$props2.maskMotion, zIndex = _this$props2.zIndex, popup = _this$props2.popup, stretch = _this$props2.stretch, alignPoint2 = _this$props2.alignPoint, mobile = _this$props2.mobile, forceRender = _this$props2.forceRender;
        var _this$state = _this.state, popupVisible = _this$state.popupVisible, point = _this$state.point;
        var align = _this.getPopupAlign();
        var mouseProps = {};
        if (_this.isMouseEnterToShow()) {
          mouseProps.onMouseEnter = _this.onPopupMouseEnter;
        }
        if (_this.isMouseLeaveToHide()) {
          mouseProps.onMouseLeave = _this.onPopupMouseLeave;
        }
        mouseProps.onMouseDown = _this.onPopupMouseDown;
        mouseProps.onTouchStart = _this.onPopupMouseDown;
        return /* @__PURE__ */ React.createElement(Popup, _extends$1({
          prefixCls,
          destroyPopupOnHide,
          visible: popupVisible,
          point: alignPoint2 && point,
          className: popupClassName,
          align,
          onAlign: onPopupAlign,
          animation: popupAnimation,
          getClassNameFromAlign: _this.getPopupClassNameFromAlign
        }, mouseProps, {
          stretch,
          getRootDomNode: _this.getRootDomNode,
          style: popupStyle,
          mask,
          zIndex,
          transitionName: popupTransitionName,
          maskAnimation,
          maskTransitionName,
          maskMotion,
          ref: _this.popupRef,
          motion: popupMotion,
          mobile,
          forceRender
        }), typeof popup === "function" ? popup() : popup);
      };
      _this.attachParent = function(popupContainer) {
        wrapperRaf$1.cancel(_this.attachId);
        var _this$props3 = _this.props, getPopupContainer = _this$props3.getPopupContainer, getDocument2 = _this$props3.getDocument;
        var domNode = _this.getRootDomNode();
        var mountNode;
        if (!getPopupContainer) {
          mountNode = getDocument2(_this.getRootDomNode()).body;
        } else if (domNode || getPopupContainer.length === 0) {
          mountNode = getPopupContainer(domNode);
        }
        if (mountNode) {
          mountNode.appendChild(popupContainer);
        } else {
          _this.attachId = wrapperRaf$1(function() {
            _this.attachParent(popupContainer);
          });
        }
      };
      _this.getContainer = function() {
        var getDocument2 = _this.props.getDocument;
        var popupContainer = getDocument2(_this.getRootDomNode()).createElement("div");
        popupContainer.style.position = "absolute";
        popupContainer.style.top = "0";
        popupContainer.style.left = "0";
        popupContainer.style.width = "100%";
        _this.attachParent(popupContainer);
        return popupContainer;
      };
      _this.setPoint = function(point) {
        var alignPoint2 = _this.props.alignPoint;
        if (!alignPoint2 || !point)
          return;
        _this.setState({
          point: {
            pageX: point.pageX,
            pageY: point.pageY
          }
        });
      };
      _this.handlePortalUpdate = function() {
        if (_this.state.prevPopupVisible !== _this.state.popupVisible) {
          _this.props.afterPopupVisibleChange(_this.state.popupVisible);
        }
      };
      _this.triggerContextValue = {
        onPopupMouseDown: _this.onPopupMouseDown
      };
      var _popupVisible;
      if ("popupVisible" in props) {
        _popupVisible = !!props.popupVisible;
      } else {
        _popupVisible = !!props.defaultPopupVisible;
      }
      _this.state = {
        prevPopupVisible: _popupVisible,
        popupVisible: _popupVisible
      };
      ALL_HANDLERS.forEach(function(h) {
        _this["fire".concat(h)] = function(e2) {
          _this.fireEvents(h, e2);
        };
      });
      return _this;
    }
    _createClass(Trigger3, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.componentDidUpdate();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        var props = this.props;
        var state = this.state;
        if (state.popupVisible) {
          var currentDocument;
          if (!this.clickOutsideHandler && (this.isClickToHide() || this.isContextMenuToShow())) {
            currentDocument = props.getDocument(this.getRootDomNode());
            this.clickOutsideHandler = addEventListenerWrap(currentDocument, "mousedown", this.onDocumentClick);
          }
          if (!this.touchOutsideHandler) {
            currentDocument = currentDocument || props.getDocument(this.getRootDomNode());
            this.touchOutsideHandler = addEventListenerWrap(currentDocument, "touchstart", this.onDocumentClick);
          }
          if (!this.contextMenuOutsideHandler1 && this.isContextMenuToShow()) {
            currentDocument = currentDocument || props.getDocument(this.getRootDomNode());
            this.contextMenuOutsideHandler1 = addEventListenerWrap(currentDocument, "scroll", this.onContextMenuClose);
          }
          if (!this.contextMenuOutsideHandler2 && this.isContextMenuToShow()) {
            this.contextMenuOutsideHandler2 = addEventListenerWrap(window, "blur", this.onContextMenuClose);
          }
          return;
        }
        this.clearOutsideHandler();
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.clearDelayTimer();
        this.clearOutsideHandler();
        clearTimeout(this.mouseDownTimeout);
        wrapperRaf$1.cancel(this.attachId);
      }
    }, {
      key: "getPopupDomNode",
      value: function getPopupDomNode() {
        var _this$popupRef$curren2;
        return ((_this$popupRef$curren2 = this.popupRef.current) === null || _this$popupRef$curren2 === void 0 ? void 0 : _this$popupRef$curren2.getElement()) || null;
      }
    }, {
      key: "getPopupAlign",
      value: function getPopupAlign() {
        var props = this.props;
        var popupPlacement = props.popupPlacement, popupAlign = props.popupAlign, builtinPlacements = props.builtinPlacements;
        if (popupPlacement && builtinPlacements) {
          return getAlignFromPlacement(builtinPlacements, popupPlacement, popupAlign);
        }
        return popupAlign;
      }
    }, {
      key: "setPopupVisible",
      value: function setPopupVisible(popupVisible, event) {
        var alignPoint2 = this.props.alignPoint;
        var prevPopupVisible = this.state.popupVisible;
        this.clearDelayTimer();
        if (prevPopupVisible !== popupVisible) {
          if (!("popupVisible" in this.props)) {
            this.setState({
              popupVisible,
              prevPopupVisible
            });
          }
          this.props.onPopupVisibleChange(popupVisible);
        }
        if (alignPoint2 && event && popupVisible) {
          this.setPoint(event);
        }
      }
    }, {
      key: "delaySetPopupVisible",
      value: function delaySetPopupVisible(visible, delayS, event) {
        var _this2 = this;
        var delay = delayS * 1e3;
        this.clearDelayTimer();
        if (delay) {
          var point = event ? {
            pageX: event.pageX,
            pageY: event.pageY
          } : null;
          this.delayTimer = window.setTimeout(function() {
            _this2.setPopupVisible(visible, point);
            _this2.clearDelayTimer();
          }, delay);
        } else {
          this.setPopupVisible(visible, event);
        }
      }
    }, {
      key: "clearDelayTimer",
      value: function clearDelayTimer() {
        if (this.delayTimer) {
          clearTimeout(this.delayTimer);
          this.delayTimer = null;
        }
      }
    }, {
      key: "clearOutsideHandler",
      value: function clearOutsideHandler() {
        if (this.clickOutsideHandler) {
          this.clickOutsideHandler.remove();
          this.clickOutsideHandler = null;
        }
        if (this.contextMenuOutsideHandler1) {
          this.contextMenuOutsideHandler1.remove();
          this.contextMenuOutsideHandler1 = null;
        }
        if (this.contextMenuOutsideHandler2) {
          this.contextMenuOutsideHandler2.remove();
          this.contextMenuOutsideHandler2 = null;
        }
        if (this.touchOutsideHandler) {
          this.touchOutsideHandler.remove();
          this.touchOutsideHandler = null;
        }
      }
    }, {
      key: "createTwoChains",
      value: function createTwoChains(event) {
        var childPros = this.props.children.props;
        var props = this.props;
        if (childPros[event] && props[event]) {
          return this["fire".concat(event)];
        }
        return childPros[event] || props[event];
      }
    }, {
      key: "isClickToShow",
      value: function isClickToShow() {
        var _this$props4 = this.props, action = _this$props4.action, showAction = _this$props4.showAction;
        return action.indexOf("click") !== -1 || showAction.indexOf("click") !== -1;
      }
    }, {
      key: "isContextMenuOnly",
      value: function isContextMenuOnly() {
        var action = this.props.action;
        return action === "contextMenu" || action.length === 1 && action[0] === "contextMenu";
      }
    }, {
      key: "isContextMenuToShow",
      value: function isContextMenuToShow() {
        var _this$props5 = this.props, action = _this$props5.action, showAction = _this$props5.showAction;
        return action.indexOf("contextMenu") !== -1 || showAction.indexOf("contextMenu") !== -1;
      }
    }, {
      key: "isClickToHide",
      value: function isClickToHide() {
        var _this$props6 = this.props, action = _this$props6.action, hideAction = _this$props6.hideAction;
        return action.indexOf("click") !== -1 || hideAction.indexOf("click") !== -1;
      }
    }, {
      key: "isMouseEnterToShow",
      value: function isMouseEnterToShow() {
        var _this$props7 = this.props, action = _this$props7.action, showAction = _this$props7.showAction;
        return action.indexOf("hover") !== -1 || showAction.indexOf("mouseEnter") !== -1;
      }
    }, {
      key: "isMouseLeaveToHide",
      value: function isMouseLeaveToHide() {
        var _this$props8 = this.props, action = _this$props8.action, hideAction = _this$props8.hideAction;
        return action.indexOf("hover") !== -1 || hideAction.indexOf("mouseLeave") !== -1;
      }
    }, {
      key: "isFocusToShow",
      value: function isFocusToShow() {
        var _this$props9 = this.props, action = _this$props9.action, showAction = _this$props9.showAction;
        return action.indexOf("focus") !== -1 || showAction.indexOf("focus") !== -1;
      }
    }, {
      key: "isBlurToHide",
      value: function isBlurToHide() {
        var _this$props10 = this.props, action = _this$props10.action, hideAction = _this$props10.hideAction;
        return action.indexOf("focus") !== -1 || hideAction.indexOf("blur") !== -1;
      }
    }, {
      key: "forcePopupAlign",
      value: function forcePopupAlign() {
        if (this.state.popupVisible) {
          var _this$popupRef$curren3;
          (_this$popupRef$curren3 = this.popupRef.current) === null || _this$popupRef$curren3 === void 0 ? void 0 : _this$popupRef$curren3.forceAlign();
        }
      }
    }, {
      key: "fireEvents",
      value: function fireEvents(type4, e2) {
        var childCallback = this.props.children.props[type4];
        if (childCallback) {
          childCallback(e2);
        }
        var callback = this.props[type4];
        if (callback) {
          callback(e2);
        }
      }
    }, {
      key: "close",
      value: function close() {
        this.setPopupVisible(false);
      }
    }, {
      key: "render",
      value: function render2() {
        var popupVisible = this.state.popupVisible;
        var _this$props11 = this.props, children = _this$props11.children, forceRender = _this$props11.forceRender, alignPoint2 = _this$props11.alignPoint, className = _this$props11.className, autoDestroy = _this$props11.autoDestroy;
        var child = React.Children.only(children);
        var newChildProps = {
          key: "trigger"
        };
        if (this.isContextMenuToShow()) {
          newChildProps.onContextMenu = this.onContextMenu;
        } else {
          newChildProps.onContextMenu = this.createTwoChains("onContextMenu");
        }
        if (this.isClickToHide() || this.isClickToShow()) {
          newChildProps.onClick = this.onClick;
          newChildProps.onMouseDown = this.onMouseDown;
          newChildProps.onTouchStart = this.onTouchStart;
        } else {
          newChildProps.onClick = this.createTwoChains("onClick");
          newChildProps.onMouseDown = this.createTwoChains("onMouseDown");
          newChildProps.onTouchStart = this.createTwoChains("onTouchStart");
        }
        if (this.isMouseEnterToShow()) {
          newChildProps.onMouseEnter = this.onMouseEnter;
          if (alignPoint2) {
            newChildProps.onMouseMove = this.onMouseMove;
          }
        } else {
          newChildProps.onMouseEnter = this.createTwoChains("onMouseEnter");
        }
        if (this.isMouseLeaveToHide()) {
          newChildProps.onMouseLeave = this.onMouseLeave;
        } else {
          newChildProps.onMouseLeave = this.createTwoChains("onMouseLeave");
        }
        if (this.isFocusToShow() || this.isBlurToHide()) {
          newChildProps.onFocus = this.onFocus;
          newChildProps.onBlur = this.onBlur;
        } else {
          newChildProps.onFocus = this.createTwoChains("onFocus");
          newChildProps.onBlur = this.createTwoChains("onBlur");
        }
        var childrenClassName = classNames(child && child.props && child.props.className, className);
        if (childrenClassName) {
          newChildProps.className = childrenClassName;
        }
        var cloneProps = _objectSpread2$1({}, newChildProps);
        if (supportRef(child)) {
          cloneProps.ref = composeRef(this.triggerRef, child.ref);
        }
        var trigger2 = /* @__PURE__ */ React.cloneElement(child, cloneProps);
        var portal;
        if (popupVisible || this.popupRef.current || forceRender) {
          portal = /* @__PURE__ */ React.createElement(PortalComponent, {
            key: "portal",
            getContainer: this.getContainer,
            didUpdate: this.handlePortalUpdate
          }, this.getComponent());
        }
        if (!popupVisible && autoDestroy) {
          portal = null;
        }
        return /* @__PURE__ */ React.createElement(TriggerContext.Provider, {
          value: this.triggerContextValue
        }, trigger2, portal);
      }
    }], [{
      key: "getDerivedStateFromProps",
      value: function getDerivedStateFromProps(_ref, prevState) {
        var popupVisible = _ref.popupVisible;
        var newState = {};
        if (popupVisible !== void 0 && prevState.popupVisible !== popupVisible) {
          newState.popupVisible = popupVisible;
          newState.prevPopupVisible = prevState.popupVisible;
        }
        return newState;
      }
    }]);
    return Trigger3;
  }(React.Component);
  Trigger2.contextType = TriggerContext;
  Trigger2.defaultProps = {
    prefixCls: "rc-trigger-popup",
    getPopupClassNameFromAlign: returnEmptyString,
    getDocument: returnDocument,
    onPopupVisibleChange: noop,
    afterPopupVisibleChange: noop,
    onPopupAlign: noop,
    popupClassName: "",
    mouseEnterDelay: 0,
    mouseLeaveDelay: 0.1,
    focusDelay: 0,
    blurDelay: 0.15,
    popupStyle: {},
    destroyPopupOnHide: false,
    popupAlign: {},
    defaultPopupVisible: false,
    mask: false,
    maskClosable: true,
    action: [],
    showAction: [],
    hideAction: [],
    autoDestroy: false
  };
  return Trigger2;
}
var Trigger = generateTrigger(Portal);
var _excluded$d = ["prefixCls", "invalidate", "item", "renderItem", "responsive", "registerSize", "itemKey", "className", "style", "children", "display", "order", "component"];
var UNDEFINED = void 0;
function InternalItem(props, ref) {
  var prefixCls = props.prefixCls, invalidate = props.invalidate, item = props.item, renderItem = props.renderItem, responsive = props.responsive, registerSize = props.registerSize, itemKey = props.itemKey, className = props.className, style2 = props.style, children = props.children, display = props.display, order = props.order, _props$component = props.component, Component2 = _props$component === void 0 ? "div" : _props$component, restProps = _objectWithoutProperties(props, _excluded$d);
  var mergedHidden = responsive && !display;
  function internalRegisterSize(width) {
    registerSize(itemKey, width);
  }
  React.useEffect(function() {
    return function() {
      internalRegisterSize(null);
    };
  }, []);
  var childNode = renderItem && item !== UNDEFINED ? renderItem(item) : children;
  var overflowStyle;
  if (!invalidate) {
    overflowStyle = {
      opacity: mergedHidden ? 0 : 1,
      height: mergedHidden ? 0 : UNDEFINED,
      overflowY: mergedHidden ? "hidden" : UNDEFINED,
      order: responsive ? order : UNDEFINED,
      pointerEvents: mergedHidden ? "none" : UNDEFINED,
      position: mergedHidden ? "absolute" : UNDEFINED
    };
  }
  var overflowProps = {};
  if (mergedHidden) {
    overflowProps["aria-hidden"] = true;
  }
  var itemNode = /* @__PURE__ */ React.createElement(Component2, _extends$1({
    className: classNames(!invalidate && prefixCls, className),
    style: _objectSpread2$1(_objectSpread2$1({}, overflowStyle), style2)
  }, overflowProps, restProps, {
    ref
  }), childNode);
  if (responsive) {
    itemNode = /* @__PURE__ */ React.createElement(ResizeObserver, {
      onResize: function onResize2(_ref) {
        var offsetWidth = _ref.offsetWidth;
        internalRegisterSize(offsetWidth);
      }
    }, itemNode);
  }
  return itemNode;
}
var Item$1 = /* @__PURE__ */ React.forwardRef(InternalItem);
Item$1.displayName = "Item";
function useBatchFrameState() {
  var _useState = useState({}), _useState2 = _slicedToArray(_useState, 2), forceUpdate = _useState2[1];
  var statesRef = useRef([]);
  var destroyRef = useRef(false);
  var walkingIndex = 0;
  var beforeFrameId = 0;
  useEffect(function() {
    return function() {
      destroyRef.current = true;
    };
  }, []);
  function createState(defaultValue) {
    var myIndex = walkingIndex;
    walkingIndex += 1;
    if (statesRef.current.length < myIndex + 1) {
      statesRef.current[myIndex] = defaultValue;
    }
    var value = statesRef.current[myIndex];
    function setValue2(val) {
      statesRef.current[myIndex] = typeof val === "function" ? val(statesRef.current[myIndex]) : val;
      wrapperRaf$1.cancel(beforeFrameId);
      beforeFrameId = wrapperRaf$1(function() {
        if (!destroyRef.current) {
          forceUpdate({});
        }
      });
    }
    return [value, setValue2];
  }
  return createState;
}
var _excluded$c = ["component"], _excluded2$4 = ["className"], _excluded3$1 = ["className"];
var InternalRawItem = function InternalRawItem2(props, ref) {
  var context = React.useContext(OverflowContext);
  if (!context) {
    var _props$component = props.component, Component2 = _props$component === void 0 ? "div" : _props$component, _restProps = _objectWithoutProperties(props, _excluded$c);
    return /* @__PURE__ */ React.createElement(Component2, _extends$1({}, _restProps, {
      ref
    }));
  }
  var contextClassName = context.className, restContext = _objectWithoutProperties(context, _excluded2$4);
  var className = props.className, restProps = _objectWithoutProperties(props, _excluded3$1);
  return /* @__PURE__ */ React.createElement(OverflowContext.Provider, {
    value: null
  }, /* @__PURE__ */ React.createElement(Item$1, _extends$1({
    ref,
    className: classNames(contextClassName, className)
  }, restContext, restProps)));
};
var RawItem = /* @__PURE__ */ React.forwardRef(InternalRawItem);
RawItem.displayName = "RawItem";
var _excluded$b = ["prefixCls", "data", "renderItem", "renderRawItem", "itemKey", "itemWidth", "ssr", "style", "className", "maxCount", "renderRest", "renderRawRest", "suffix", "component", "itemComponent", "onVisibleChange"];
var OverflowContext = /* @__PURE__ */ React.createContext(null);
var RESPONSIVE = "responsive";
var INVALIDATE = "invalidate";
function defaultRenderRest(omittedItems) {
  return "+ ".concat(omittedItems.length, " ...");
}
function Overflow(props, ref) {
  var _props$prefixCls = props.prefixCls, prefixCls = _props$prefixCls === void 0 ? "rc-overflow" : _props$prefixCls, _props$data = props.data, data = _props$data === void 0 ? [] : _props$data, renderItem = props.renderItem, renderRawItem = props.renderRawItem, itemKey = props.itemKey, _props$itemWidth = props.itemWidth, itemWidth = _props$itemWidth === void 0 ? 10 : _props$itemWidth, ssr = props.ssr, style2 = props.style, className = props.className, maxCount = props.maxCount, renderRest = props.renderRest, renderRawRest = props.renderRawRest, suffix = props.suffix, _props$component = props.component, Component2 = _props$component === void 0 ? "div" : _props$component, itemComponent = props.itemComponent, onVisibleChange = props.onVisibleChange, restProps = _objectWithoutProperties(props, _excluded$b);
  var createUseState = useBatchFrameState();
  var fullySSR = ssr === "full";
  var _createUseState = createUseState(null), _createUseState2 = _slicedToArray(_createUseState, 2), containerWidth = _createUseState2[0], setContainerWidth = _createUseState2[1];
  var mergedContainerWidth = containerWidth || 0;
  var _createUseState3 = createUseState(/* @__PURE__ */ new Map()), _createUseState4 = _slicedToArray(_createUseState3, 2), itemWidths = _createUseState4[0], setItemWidths = _createUseState4[1];
  var _createUseState5 = createUseState(0), _createUseState6 = _slicedToArray(_createUseState5, 2), prevRestWidth = _createUseState6[0], setPrevRestWidth = _createUseState6[1];
  var _createUseState7 = createUseState(0), _createUseState8 = _slicedToArray(_createUseState7, 2), restWidth = _createUseState8[0], setRestWidth = _createUseState8[1];
  var _createUseState9 = createUseState(0), _createUseState10 = _slicedToArray(_createUseState9, 2), suffixWidth = _createUseState10[0], setSuffixWidth = _createUseState10[1];
  var _useState = useState(null), _useState2 = _slicedToArray(_useState, 2), suffixFixedStart = _useState2[0], setSuffixFixedStart = _useState2[1];
  var _useState3 = useState(null), _useState4 = _slicedToArray(_useState3, 2), displayCount = _useState4[0], setDisplayCount = _useState4[1];
  var mergedDisplayCount = React.useMemo(function() {
    if (displayCount === null && fullySSR) {
      return Number.MAX_SAFE_INTEGER;
    }
    return displayCount || 0;
  }, [displayCount, containerWidth]);
  var _useState5 = useState(false), _useState6 = _slicedToArray(_useState5, 2), restReady = _useState6[0], setRestReady = _useState6[1];
  var itemPrefixCls = "".concat(prefixCls, "-item");
  var mergedRestWidth = Math.max(prevRestWidth, restWidth);
  var isResponsive = data.length && maxCount === RESPONSIVE;
  var invalidate = maxCount === INVALIDATE;
  var showRest = isResponsive || typeof maxCount === "number" && data.length > maxCount;
  var mergedData = useMemo$1(function() {
    var items = data;
    if (isResponsive) {
      if (containerWidth === null && fullySSR) {
        items = data;
      } else {
        items = data.slice(0, Math.min(data.length, mergedContainerWidth / itemWidth));
      }
    } else if (typeof maxCount === "number") {
      items = data.slice(0, maxCount);
    }
    return items;
  }, [data, itemWidth, containerWidth, maxCount, isResponsive]);
  var omittedItems = useMemo$1(function() {
    if (isResponsive) {
      return data.slice(mergedDisplayCount + 1);
    }
    return data.slice(mergedData.length);
  }, [data, mergedData, isResponsive, mergedDisplayCount]);
  var getKey2 = useCallback(function(item, index2) {
    var _ref;
    if (typeof itemKey === "function") {
      return itemKey(item);
    }
    return (_ref = itemKey && (item === null || item === void 0 ? void 0 : item[itemKey])) !== null && _ref !== void 0 ? _ref : index2;
  }, [itemKey]);
  var mergedRenderItem = useCallback(renderItem || function(item) {
    return item;
  }, [renderItem]);
  function updateDisplayCount(count2, notReady) {
    setDisplayCount(count2);
    if (!notReady) {
      setRestReady(count2 < data.length - 1);
      onVisibleChange === null || onVisibleChange === void 0 ? void 0 : onVisibleChange(count2);
    }
  }
  function onOverflowResize(_, element) {
    setContainerWidth(element.clientWidth);
  }
  function registerSize(key, width) {
    setItemWidths(function(origin) {
      var clone3 = new Map(origin);
      if (width === null) {
        clone3.delete(key);
      } else {
        clone3.set(key, width);
      }
      return clone3;
    });
  }
  function registerOverflowSize(_, width) {
    setRestWidth(width);
    setPrevRestWidth(restWidth);
  }
  function registerSuffixSize(_, width) {
    setSuffixWidth(width);
  }
  function getItemWidth(index2) {
    return itemWidths.get(getKey2(mergedData[index2], index2));
  }
  useLayoutEffect(function() {
    if (mergedContainerWidth && mergedRestWidth && mergedData) {
      var totalWidth = suffixWidth;
      var len2 = mergedData.length;
      var lastIndex = len2 - 1;
      if (!len2) {
        updateDisplayCount(0);
        setSuffixFixedStart(null);
        return;
      }
      for (var i = 0; i < len2; i += 1) {
        var currentItemWidth = getItemWidth(i);
        if (currentItemWidth === void 0) {
          updateDisplayCount(i - 1, true);
          break;
        }
        totalWidth += currentItemWidth;
        if (lastIndex === 0 && totalWidth <= mergedContainerWidth || i === lastIndex - 1 && totalWidth + getItemWidth(lastIndex) <= mergedContainerWidth) {
          updateDisplayCount(lastIndex);
          setSuffixFixedStart(null);
          break;
        } else if (totalWidth + mergedRestWidth > mergedContainerWidth) {
          updateDisplayCount(i - 1);
          setSuffixFixedStart(totalWidth - currentItemWidth - suffixWidth + restWidth);
          break;
        }
      }
      if (suffix && getItemWidth(0) + suffixWidth > mergedContainerWidth) {
        setSuffixFixedStart(null);
      }
    }
  }, [mergedContainerWidth, itemWidths, restWidth, suffixWidth, getKey2, mergedData]);
  var displayRest = restReady && !!omittedItems.length;
  var suffixStyle = {};
  if (suffixFixedStart !== null && isResponsive) {
    suffixStyle = {
      position: "absolute",
      left: suffixFixedStart,
      top: 0
    };
  }
  var itemSharedProps = {
    prefixCls: itemPrefixCls,
    responsive: isResponsive,
    component: itemComponent,
    invalidate
  };
  var internalRenderItemNode = renderRawItem ? function(item, index2) {
    var key = getKey2(item, index2);
    return /* @__PURE__ */ React.createElement(OverflowContext.Provider, {
      key,
      value: _objectSpread2$1(_objectSpread2$1({}, itemSharedProps), {}, {
        order: index2,
        item,
        itemKey: key,
        registerSize,
        display: index2 <= mergedDisplayCount
      })
    }, renderRawItem(item, index2));
  } : function(item, index2) {
    var key = getKey2(item, index2);
    return /* @__PURE__ */ React.createElement(Item$1, _extends$1({}, itemSharedProps, {
      order: index2,
      key,
      item,
      renderItem: mergedRenderItem,
      itemKey: key,
      registerSize,
      display: index2 <= mergedDisplayCount
    }));
  };
  var restNode;
  var restContextProps = {
    order: displayRest ? mergedDisplayCount : Number.MAX_SAFE_INTEGER,
    className: "".concat(itemPrefixCls, "-rest"),
    registerSize: registerOverflowSize,
    display: displayRest
  };
  if (!renderRawRest) {
    var mergedRenderRest = renderRest || defaultRenderRest;
    restNode = /* @__PURE__ */ React.createElement(Item$1, _extends$1({}, itemSharedProps, restContextProps), typeof mergedRenderRest === "function" ? mergedRenderRest(omittedItems) : mergedRenderRest);
  } else if (renderRawRest) {
    restNode = /* @__PURE__ */ React.createElement(OverflowContext.Provider, {
      value: _objectSpread2$1(_objectSpread2$1({}, itemSharedProps), restContextProps)
    }, renderRawRest(omittedItems));
  }
  var overflowNode = /* @__PURE__ */ React.createElement(Component2, _extends$1({
    className: classNames(!invalidate && prefixCls, className),
    style: style2,
    ref
  }, restProps), mergedData.map(internalRenderItemNode), showRest ? restNode : null, suffix && /* @__PURE__ */ React.createElement(Item$1, _extends$1({}, itemSharedProps, {
    order: mergedDisplayCount,
    className: "".concat(itemPrefixCls, "-suffix"),
    registerSize: registerSuffixSize,
    display: true,
    style: suffixStyle
  }), suffix));
  if (isResponsive) {
    overflowNode = /* @__PURE__ */ React.createElement(ResizeObserver, {
      onResize: onOverflowResize
    }, overflowNode);
  }
  return overflowNode;
}
var ForwardOverflow = /* @__PURE__ */ React.forwardRef(Overflow);
ForwardOverflow.displayName = "Overflow";
ForwardOverflow.Item = RawItem;
ForwardOverflow.RESPONSIVE = RESPONSIVE;
ForwardOverflow.INVALIDATE = INVALIDATE;
var tuple = function tuple2() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return args;
};
var isValidElement = React.isValidElement;
function replaceElement(element, replacement, props) {
  if (!isValidElement(element))
    return replacement;
  return /* @__PURE__ */ React.cloneElement(element, typeof props === "function" ? props(element.props || {}) : props);
}
function cloneElement(element, props) {
  return replaceElement(element, element, props);
}
function getDataOrAriaProps(props) {
  return Object.keys(props).reduce(function(prev, key) {
    if ((key.substr(0, 5) === "data-" || key.substr(0, 5) === "aria-" || key === "role") && key.substr(0, 7) !== "data-__") {
      prev[key] = props[key];
    }
    return prev;
  }, {});
}
var responsiveArray = ["xxl", "xl", "lg", "md", "sm", "xs"];
var responsiveMap = {
  xs: "(max-width: 575px)",
  sm: "(min-width: 576px)",
  md: "(min-width: 768px)",
  lg: "(min-width: 992px)",
  xl: "(min-width: 1200px)",
  xxl: "(min-width: 1600px)"
};
var subscribers = /* @__PURE__ */ new Map();
var subUid = -1;
var screens = {};
var responsiveObserve = {
  matchHandlers: {},
  dispatch: function dispatch(pointMap) {
    screens = pointMap;
    subscribers.forEach(function(func) {
      return func(screens);
    });
    return subscribers.size >= 1;
  },
  subscribe: function subscribe(func) {
    if (!subscribers.size)
      this.register();
    subUid += 1;
    subscribers.set(subUid, func);
    func(screens);
    return subUid;
  },
  unsubscribe: function unsubscribe(token) {
    subscribers["delete"](token);
    if (!subscribers.size)
      this.unregister();
  },
  unregister: function unregister2() {
    var _this = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var handler = _this.matchHandlers[matchMediaQuery];
      handler === null || handler === void 0 ? void 0 : handler.mql.removeListener(handler === null || handler === void 0 ? void 0 : handler.listener);
    });
    subscribers.clear();
  },
  register: function register3() {
    var _this2 = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var listener = function listener2(_ref) {
        var matches = _ref.matches;
        _this2.dispatch(_extends$1(_extends$1({}, screens), _defineProperty$1({}, screen, matches)));
      };
      var mql = window.matchMedia(matchMediaQuery);
      mql.addListener(listener);
      _this2.matchHandlers[matchMediaQuery] = {
        mql,
        listener
      };
      listener(mql);
    });
  }
};
var ResponsiveObserve = responsiveObserve;
function useForceUpdate() {
  var _React$useReducer = React.useReducer(function(x2) {
    return x2 + 1;
  }, 0), _React$useReducer2 = _slicedToArray(_React$useReducer, 2), forceUpdate = _React$useReducer2[1];
  return forceUpdate;
}
var autoAdjustOverflow$1 = {
  adjustX: 1,
  adjustY: 1
};
var targetOffset = [0, 0];
var placements$1 = {
  topLeft: {
    points: ["bl", "tl"],
    overflow: autoAdjustOverflow$1,
    offset: [0, -4],
    targetOffset
  },
  topCenter: {
    points: ["bc", "tc"],
    overflow: autoAdjustOverflow$1,
    offset: [0, -4],
    targetOffset
  },
  topRight: {
    points: ["br", "tr"],
    overflow: autoAdjustOverflow$1,
    offset: [0, -4],
    targetOffset
  },
  bottomLeft: {
    points: ["tl", "bl"],
    overflow: autoAdjustOverflow$1,
    offset: [0, 4],
    targetOffset
  },
  bottomCenter: {
    points: ["tc", "bc"],
    overflow: autoAdjustOverflow$1,
    offset: [0, 4],
    targetOffset
  },
  bottomRight: {
    points: ["tr", "br"],
    overflow: autoAdjustOverflow$1,
    offset: [0, 4],
    targetOffset
  }
};
var ESC$1 = KeyCode.ESC, TAB = KeyCode.TAB;
function useAccessibility$1(_ref) {
  var visible = _ref.visible, setTriggerVisible = _ref.setTriggerVisible, triggerRef = _ref.triggerRef, menuRef = _ref.menuRef, menuClassName = _ref.menuClassName, onVisibleChange = _ref.onVisibleChange;
  var handleCloseMenuAndReturnFocus = function handleCloseMenuAndReturnFocus2() {
    if (visible && triggerRef.current) {
      if (triggerRef.current.triggerRef.current) {
        triggerRef.current.triggerRef.current.focus();
      }
      setTriggerVisible(false);
      if (typeof onVisibleChange === "function") {
        onVisibleChange(false);
      }
    }
  };
  var handleKeyDown = function handleKeyDown2(event) {
    switch (event.keyCode) {
      case ESC$1:
        handleCloseMenuAndReturnFocus();
        break;
      case TAB:
        handleCloseMenuAndReturnFocus();
        break;
    }
  };
  var focusOpenedMenu = function focusOpenedMenu2() {
    if (menuRef.current) {
      var _menuRef$current$clas, _menuRef$current$quer, _menuRef$current;
      var menuList = ((_menuRef$current$clas = menuRef.current.className) === null || _menuRef$current$clas === void 0 ? void 0 : _menuRef$current$clas.includes(menuClassName)) ? menuRef.current : (_menuRef$current$quer = (_menuRef$current = menuRef.current).querySelector) === null || _menuRef$current$quer === void 0 ? void 0 : _menuRef$current$quer.call(_menuRef$current, menuClassName);
      if (menuList) {
        menuList["focus"]();
      }
    }
  };
  React.useEffect(function() {
    if (visible) {
      setTimeout(function() {
        focusOpenedMenu();
        window.addEventListener("keydown", handleKeyDown);
      }, 100);
      return function() {
        window.removeEventListener("keydown", handleKeyDown);
      };
    }
    return function() {
      return null;
    };
  }, [visible]);
  var returnFocus = function returnFocus2() {
    if (visible && triggerRef.current) {
      if (triggerRef.current.triggerRef.current) {
        setTimeout(function() {
          var _triggerRef$current, _triggerRef$current$t, _triggerRef$current$t2;
          (_triggerRef$current = triggerRef.current) === null || _triggerRef$current === void 0 ? void 0 : (_triggerRef$current$t = _triggerRef$current.triggerRef) === null || _triggerRef$current$t === void 0 ? void 0 : (_triggerRef$current$t2 = _triggerRef$current$t.current) === null || _triggerRef$current$t2 === void 0 ? void 0 : _triggerRef$current$t2.focus();
        }, 100);
      }
    }
  };
  return {
    returnFocus
  };
}
var _excluded$a = ["arrow", "prefixCls", "transitionName", "animation", "align", "placement", "placements", "getPopupContainer", "showAction", "hideAction", "overlayClassName", "overlayStyle", "visible", "trigger"];
function Dropdown(props, ref) {
  var _props$arrow = props.arrow, arrow = _props$arrow === void 0 ? false : _props$arrow, _props$prefixCls = props.prefixCls, prefixCls = _props$prefixCls === void 0 ? "rc-dropdown" : _props$prefixCls, transitionName = props.transitionName, animation = props.animation, align = props.align, _props$placement = props.placement, placement = _props$placement === void 0 ? "bottomLeft" : _props$placement, _props$placements = props.placements, placements2 = _props$placements === void 0 ? placements$1 : _props$placements, getPopupContainer = props.getPopupContainer, showAction = props.showAction, hideAction = props.hideAction, overlayClassName = props.overlayClassName, overlayStyle = props.overlayStyle, visible = props.visible, _props$trigger = props.trigger, trigger2 = _props$trigger === void 0 ? ["hover"] : _props$trigger, otherProps = _objectWithoutProperties(props, _excluded$a);
  var _React$useState = React.useState(), _React$useState2 = _slicedToArray(_React$useState, 2), triggerVisible = _React$useState2[0], setTriggerVisible = _React$useState2[1];
  var mergedVisible = "visible" in props ? visible : triggerVisible;
  var triggerRef = React.useRef(null);
  React.useImperativeHandle(ref, function() {
    return triggerRef.current;
  });
  var menuRef = React.useRef(null);
  var menuClassName = "".concat(prefixCls, "-menu");
  var _useAccessibility = useAccessibility$1({
    visible: mergedVisible,
    setTriggerVisible,
    triggerRef,
    menuRef,
    menuClassName,
    onVisibleChange: props.onVisibleChange
  }), returnFocus = _useAccessibility.returnFocus;
  var getOverlayElement = function getOverlayElement2() {
    var overlay = props.overlay;
    var overlayElement;
    if (typeof overlay === "function") {
      overlayElement = overlay();
    } else {
      overlayElement = overlay;
    }
    return overlayElement;
  };
  var onClick = function onClick2(e2) {
    var onOverlayClick = props.onOverlayClick;
    var overlayProps = getOverlayElement().props;
    setTriggerVisible(false);
    if (onOverlayClick) {
      onOverlayClick(e2);
    }
    if (overlayProps.onClick) {
      overlayProps.onClick(e2);
    }
    returnFocus();
  };
  var onVisibleChange = function onVisibleChange2(newVisible) {
    var onVisibleChangeProp = props.onVisibleChange;
    setTriggerVisible(newVisible);
    if (typeof onVisibleChangeProp === "function") {
      onVisibleChangeProp(newVisible);
    }
  };
  var getMenuElement = function getMenuElement2() {
    var overlayElement = getOverlayElement();
    var extraOverlayProps = {
      prefixCls: menuClassName,
      onClick,
      ref: supportRef(overlayElement) ? menuRef : void 0
    };
    if (typeof overlayElement.type === "string") {
      delete extraOverlayProps.prefixCls;
    }
    return /* @__PURE__ */ React.createElement(React.Fragment, null, arrow && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-arrow")
    }), /* @__PURE__ */ React.cloneElement(overlayElement, extraOverlayProps));
  };
  var getMenuElementOrLambda = function getMenuElementOrLambda2() {
    var overlay = props.overlay;
    if (typeof overlay === "function") {
      return getMenuElement;
    }
    return getMenuElement();
  };
  var getMinOverlayWidthMatchTrigger = function getMinOverlayWidthMatchTrigger2() {
    var minOverlayWidthMatchTrigger = props.minOverlayWidthMatchTrigger, alignPoint2 = props.alignPoint;
    if ("minOverlayWidthMatchTrigger" in props) {
      return minOverlayWidthMatchTrigger;
    }
    return !alignPoint2;
  };
  var getOpenClassName = function getOpenClassName2() {
    var openClassName = props.openClassName;
    if (openClassName !== void 0) {
      return openClassName;
    }
    return "".concat(prefixCls, "-open");
  };
  var renderChildren = function renderChildren2() {
    var children = props.children;
    var childrenProps = children.props ? children.props : {};
    var childClassName = classNames(childrenProps.className, getOpenClassName());
    return mergedVisible && children ? /* @__PURE__ */ React.cloneElement(children, {
      className: childClassName
    }) : children;
  };
  var triggerHideAction = hideAction;
  if (!triggerHideAction && trigger2.indexOf("contextMenu") !== -1) {
    triggerHideAction = ["click"];
  }
  return /* @__PURE__ */ React.createElement(Trigger, _objectSpread2$1(_objectSpread2$1({
    builtinPlacements: placements2
  }, otherProps), {}, {
    prefixCls,
    ref: triggerRef,
    popupClassName: classNames(overlayClassName, _defineProperty$1({}, "".concat(prefixCls, "-show-arrow"), arrow)),
    popupStyle: overlayStyle,
    action: trigger2,
    showAction,
    hideAction: triggerHideAction || [],
    popupPlacement: placement,
    popupAlign: align,
    popupTransitionName: transitionName,
    popupAnimation: animation,
    popupVisible: mergedVisible,
    stretch: getMinOverlayWidthMatchTrigger() ? "minWidth" : "",
    popup: getMenuElementOrLambda(),
    onPopupVisibleChange: onVisibleChange,
    getPopupContainer
  }), renderChildren());
}
var Dropdown$1 = /* @__PURE__ */ React.forwardRef(Dropdown);
var UnreachableException = /* @__PURE__ */ _createClass(function UnreachableException2(value) {
  _classCallCheck(this, UnreachableException2);
  this.error = new Error("unreachable case: ".concat(JSON.stringify(value)));
});
var __rest$a = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var ButtonGroup = function ButtonGroup2(props) {
  return /* @__PURE__ */ React.createElement(ConfigConsumer, null, function(_ref) {
    var _classNames;
    var getPrefixCls = _ref.getPrefixCls, direction = _ref.direction;
    var customizePrefixCls = props.prefixCls, size = props.size, className = props.className, others = __rest$a(props, ["prefixCls", "size", "className"]);
    var prefixCls = getPrefixCls("btn-group", customizePrefixCls);
    var sizeCls = "";
    switch (size) {
      case "large":
        sizeCls = "lg";
        break;
      case "small":
        sizeCls = "sm";
        break;
      case "middle":
      case void 0:
        break;
      default:
        console.warn(new UnreachableException(size).error);
    }
    var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(sizeCls), sizeCls), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
    return /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
      className: classes
    }));
  });
};
var Group$1 = ButtonGroup;
var id = 0;
var ids = {};
function wrapperRaf(callback) {
  var delayFrames = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  var myId = id++;
  var restFrames = delayFrames;
  function internalCallback() {
    restFrames -= 1;
    if (restFrames <= 0) {
      callback();
      delete ids[myId];
    } else {
      ids[myId] = wrapperRaf$1(internalCallback);
    }
  }
  ids[myId] = wrapperRaf$1(internalCallback);
  return myId;
}
wrapperRaf.cancel = function cancel(pid) {
  if (pid === void 0)
    return;
  wrapperRaf$1.cancel(ids[pid]);
  delete ids[pid];
};
wrapperRaf.ids = ids;
var styleForPseudo;
function isHidden(element) {
  return !element || element.offsetParent === null || element.hidden;
}
function isNotGrey(color) {
  var match = (color || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
  if (match && match[1] && match[2] && match[3]) {
    return !(match[1] === match[2] && match[2] === match[3]);
  }
  return true;
}
var Wave = /* @__PURE__ */ function(_React$Component) {
  _inherits(Wave2, _React$Component);
  var _super = _createSuper(Wave2);
  function Wave2() {
    var _this;
    _classCallCheck(this, Wave2);
    _this = _super.apply(this, arguments);
    _this.containerRef = /* @__PURE__ */ React.createRef();
    _this.animationStart = false;
    _this.destroyed = false;
    _this.onClick = function(node, waveColor) {
      var _a2, _b2;
      var _this$props = _this.props, insertExtraNode = _this$props.insertExtraNode, disabled = _this$props.disabled;
      if (disabled || !node || isHidden(node) || node.className.indexOf("-leave") >= 0) {
        return;
      }
      _this.extraNode = document.createElement("div");
      var _assertThisInitialize = _assertThisInitialized(_this), extraNode = _assertThisInitialize.extraNode;
      var getPrefixCls = _this.context.getPrefixCls;
      extraNode.className = "".concat(getPrefixCls(""), "-click-animating-node");
      var attributeName = _this.getAttributeName();
      node.setAttribute(attributeName, "true");
      if (waveColor && waveColor !== "#ffffff" && waveColor !== "rgb(255, 255, 255)" && isNotGrey(waveColor) && !/rgba\((?:\d*, ){3}0\)/.test(waveColor) && waveColor !== "transparent") {
        extraNode.style.borderColor = waveColor;
        var nodeRoot = ((_a2 = node.getRootNode) === null || _a2 === void 0 ? void 0 : _a2.call(node)) || node.ownerDocument;
        var nodeBody = nodeRoot instanceof Document ? nodeRoot.body : (_b2 = nodeRoot.firstChild) !== null && _b2 !== void 0 ? _b2 : nodeRoot;
        styleForPseudo = updateCSS("\n      [".concat(getPrefixCls(""), "-click-animating-without-extra-node='true']::after, .").concat(getPrefixCls(""), "-click-animating-node {\n        --antd-wave-shadow-color: ").concat(waveColor, ";\n      }"), "antd-wave", {
          csp: _this.csp,
          attachTo: nodeBody
        });
      }
      if (insertExtraNode) {
        node.appendChild(extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.addEventListener("".concat(name, "start"), _this.onTransitionStart);
        node.addEventListener("".concat(name, "end"), _this.onTransitionEnd);
      });
    };
    _this.onTransitionStart = function(e2) {
      if (_this.destroyed) {
        return;
      }
      var node = _this.containerRef.current;
      if (!e2 || e2.target !== node || _this.animationStart) {
        return;
      }
      _this.resetEffect(node);
    };
    _this.onTransitionEnd = function(e2) {
      if (!e2 || e2.animationName !== "fadeEffect") {
        return;
      }
      _this.resetEffect(e2.target);
    };
    _this.bindAnimationEvent = function(node) {
      if (!node || !node.getAttribute || node.getAttribute("disabled") || node.className.indexOf("disabled") >= 0) {
        return;
      }
      var onClick = function onClick2(e2) {
        if (e2.target.tagName === "INPUT" || isHidden(e2.target)) {
          return;
        }
        _this.resetEffect(node);
        var waveColor = getComputedStyle(node).getPropertyValue("border-top-color") || getComputedStyle(node).getPropertyValue("border-color") || getComputedStyle(node).getPropertyValue("background-color");
        _this.clickWaveTimeoutId = window.setTimeout(function() {
          return _this.onClick(node, waveColor);
        }, 0);
        wrapperRaf.cancel(_this.animationStartId);
        _this.animationStart = true;
        _this.animationStartId = wrapperRaf(function() {
          _this.animationStart = false;
        }, 10);
      };
      node.addEventListener("click", onClick, true);
      return {
        cancel: function cancel2() {
          node.removeEventListener("click", onClick, true);
        }
      };
    };
    _this.renderWave = function(_ref) {
      var csp = _ref.csp;
      var children = _this.props.children;
      _this.csp = csp;
      if (!/* @__PURE__ */ React.isValidElement(children))
        return children;
      var ref = _this.containerRef;
      if (supportRef(children)) {
        ref = composeRef(children.ref, _this.containerRef);
      }
      return cloneElement(children, {
        ref
      });
    };
    return _this;
  }
  _createClass(Wave2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = this.containerRef.current;
      if (!node || node.nodeType !== 1) {
        return;
      }
      this.instance = this.bindAnimationEvent(node);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.instance) {
        this.instance.cancel();
      }
      if (this.clickWaveTimeoutId) {
        clearTimeout(this.clickWaveTimeoutId);
      }
      this.destroyed = true;
    }
  }, {
    key: "getAttributeName",
    value: function getAttributeName() {
      var getPrefixCls = this.context.getPrefixCls;
      var insertExtraNode = this.props.insertExtraNode;
      return insertExtraNode ? "".concat(getPrefixCls(""), "-click-animating") : "".concat(getPrefixCls(""), "-click-animating-without-extra-node");
    }
  }, {
    key: "resetEffect",
    value: function resetEffect(node) {
      var _this2 = this;
      if (!node || node === this.extraNode || !(node instanceof Element)) {
        return;
      }
      var insertExtraNode = this.props.insertExtraNode;
      var attributeName = this.getAttributeName();
      node.setAttribute(attributeName, "false");
      if (styleForPseudo) {
        styleForPseudo.innerHTML = "";
      }
      if (insertExtraNode && this.extraNode && node.contains(this.extraNode)) {
        node.removeChild(this.extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.removeEventListener("".concat(name, "start"), _this2.onTransitionStart);
        node.removeEventListener("".concat(name, "end"), _this2.onTransitionEnd);
      });
    }
  }, {
    key: "render",
    value: function render2() {
      return /* @__PURE__ */ React.createElement(ConfigConsumer, null, this.renderWave);
    }
  }]);
  return Wave2;
}(React.Component);
Wave.contextType = ConfigContext;
var getCollapsedWidth = function getCollapsedWidth2() {
  return {
    width: 0,
    opacity: 0,
    transform: "scale(0)"
  };
};
var getRealWidth = function getRealWidth2(node) {
  return {
    width: node.scrollWidth,
    opacity: 1,
    transform: "scale(1)"
  };
};
var LoadingIcon = function LoadingIcon2(_ref) {
  var prefixCls = _ref.prefixCls, loading = _ref.loading, existIcon = _ref.existIcon;
  var visible = !!loading;
  if (existIcon) {
    return /* @__PURE__ */ React__default.createElement("span", {
      className: "".concat(prefixCls, "-loading-icon")
    }, /* @__PURE__ */ React__default.createElement(LoadingOutlined$1, null));
  }
  return /* @__PURE__ */ React__default.createElement(CSSMotion, {
    visible,
    motionName: "".concat(prefixCls, "-loading-icon-motion"),
    removeOnLeave: true,
    onAppearStart: getCollapsedWidth,
    onAppearActive: getRealWidth,
    onEnterStart: getCollapsedWidth,
    onEnterActive: getRealWidth,
    onLeaveStart: getRealWidth,
    onLeaveActive: getCollapsedWidth
  }, function(_ref2, ref) {
    var className = _ref2.className, style2 = _ref2.style;
    return /* @__PURE__ */ React__default.createElement("span", {
      className: "".concat(prefixCls, "-loading-icon"),
      style: style2,
      ref
    }, /* @__PURE__ */ React__default.createElement(LoadingOutlined$1, {
      className
    }));
  });
};
var LoadingIcon$1 = LoadingIcon;
var __rest$9 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var rxTwoCNChar = /^[\u4e00-\u9fa5]{2}$/;
var isTwoCNChar = rxTwoCNChar.test.bind(rxTwoCNChar);
function isString(str) {
  return typeof str === "string";
}
function isUnborderedButtonType(type4) {
  return type4 === "text" || type4 === "link";
}
function isReactFragment(node) {
  return /* @__PURE__ */ React.isValidElement(node) && node.type === React.Fragment;
}
function insertSpace(child, needInserted) {
  if (child == null) {
    return;
  }
  var SPACE = needInserted ? " " : "";
  if (typeof child !== "string" && typeof child !== "number" && isString(child.type) && isTwoCNChar(child.props.children)) {
    return cloneElement(child, {
      children: child.props.children.split("").join(SPACE)
    });
  }
  if (typeof child === "string") {
    return isTwoCNChar(child) ? /* @__PURE__ */ React.createElement("span", null, child.split("").join(SPACE)) : /* @__PURE__ */ React.createElement("span", null, child);
  }
  if (isReactFragment(child)) {
    return /* @__PURE__ */ React.createElement("span", null, child);
  }
  return child;
}
function spaceChildren(children, needInserted) {
  var isPrevChildPure = false;
  var childList = [];
  React.Children.forEach(children, function(child) {
    var type4 = _typeof$1(child);
    var isCurrentChildPure = type4 === "string" || type4 === "number";
    if (isPrevChildPure && isCurrentChildPure) {
      var lastIndex = childList.length - 1;
      var lastChild = childList[lastIndex];
      childList[lastIndex] = "".concat(lastChild).concat(child);
    } else {
      childList.push(child);
    }
    isPrevChildPure = isCurrentChildPure;
  });
  return React.Children.map(childList, function(child) {
    return insertSpace(child, needInserted);
  });
}
tuple("default", "primary", "ghost", "dashed", "link", "text");
tuple("default", "circle", "round");
tuple("submit", "button", "reset");
var InternalButton = function InternalButton2(props, ref) {
  var _classNames;
  var _props$loading = props.loading, loading = _props$loading === void 0 ? false : _props$loading, customizePrefixCls = props.prefixCls, _props$type = props.type, type4 = _props$type === void 0 ? "default" : _props$type, danger = props.danger, _props$shape = props.shape, shape = _props$shape === void 0 ? "default" : _props$shape, customizeSize = props.size, className = props.className, children = props.children, icon = props.icon, _props$ghost = props.ghost, ghost = _props$ghost === void 0 ? false : _props$ghost, _props$block = props.block, block = _props$block === void 0 ? false : _props$block, _props$htmlType = props.htmlType, htmlType = _props$htmlType === void 0 ? "button" : _props$htmlType, rest = __rest$9(props, ["loading", "prefixCls", "type", "danger", "shape", "size", "className", "children", "icon", "ghost", "block", "htmlType"]);
  var size = React.useContext(SizeContext$1);
  var _React$useState = React.useState(!!loading), _React$useState2 = _slicedToArray(_React$useState, 2), innerLoading = _React$useState2[0], setLoading = _React$useState2[1];
  var _React$useState3 = React.useState(false), _React$useState4 = _slicedToArray(_React$useState3, 2), hasTwoCNChar = _React$useState4[0], setHasTwoCNChar = _React$useState4[1];
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, autoInsertSpaceInButton = _React$useContext.autoInsertSpaceInButton, direction = _React$useContext.direction;
  var buttonRef = ref || /* @__PURE__ */ React.createRef();
  var isNeedInserted = function isNeedInserted2() {
    return React.Children.count(children) === 1 && !icon && !isUnborderedButtonType(type4);
  };
  var fixTwoCNChar = function fixTwoCNChar2() {
    if (!buttonRef || !buttonRef.current || autoInsertSpaceInButton === false) {
      return;
    }
    var buttonText = buttonRef.current.textContent;
    if (isNeedInserted() && isTwoCNChar(buttonText)) {
      if (!hasTwoCNChar) {
        setHasTwoCNChar(true);
      }
    } else if (hasTwoCNChar) {
      setHasTwoCNChar(false);
    }
  };
  var loadingOrDelay = _typeof$1(loading) === "object" && loading.delay ? loading.delay || true : !!loading;
  React.useEffect(function() {
    var delayTimer = null;
    if (typeof loadingOrDelay === "number") {
      delayTimer = window.setTimeout(function() {
        delayTimer = null;
        setLoading(loadingOrDelay);
      }, loadingOrDelay);
    } else {
      setLoading(loadingOrDelay);
    }
    return function() {
      if (delayTimer) {
        window.clearTimeout(delayTimer);
        delayTimer = null;
      }
    };
  }, [loadingOrDelay]);
  React.useEffect(fixTwoCNChar, [buttonRef]);
  var handleClick = function handleClick2(e2) {
    var onClick = props.onClick, disabled = props.disabled;
    if (innerLoading || disabled) {
      e2.preventDefault();
      return;
    }
    onClick === null || onClick === void 0 ? void 0 : onClick(e2);
  };
  devWarning(!(typeof icon === "string" && icon.length > 2), "Button", "`icon` is using ReactNode instead of string naming in v4. Please check `".concat(icon, "` at https://ant.design/components/icon"));
  devWarning(!(ghost && isUnborderedButtonType(type4)), "Button", "`link` or `text` button can't be a `ghost` button.");
  var prefixCls = getPrefixCls("btn", customizePrefixCls);
  var autoInsertSpace = autoInsertSpaceInButton !== false;
  var sizeClassNameMap = {
    large: "lg",
    small: "sm",
    middle: void 0
  };
  var sizeFullname = customizeSize || size;
  var sizeCls = sizeFullname ? sizeClassNameMap[sizeFullname] || "" : "";
  var iconType = innerLoading ? "loading" : icon;
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(shape), shape !== "default" && shape), _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(type4), type4), _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(sizeCls), sizeCls), _defineProperty$1(_classNames, "".concat(prefixCls, "-icon-only"), !children && children !== 0 && !!iconType), _defineProperty$1(_classNames, "".concat(prefixCls, "-background-ghost"), ghost && !isUnborderedButtonType(type4)), _defineProperty$1(_classNames, "".concat(prefixCls, "-loading"), innerLoading), _defineProperty$1(_classNames, "".concat(prefixCls, "-two-chinese-chars"), hasTwoCNChar && autoInsertSpace), _defineProperty$1(_classNames, "".concat(prefixCls, "-block"), block), _defineProperty$1(_classNames, "".concat(prefixCls, "-dangerous"), !!danger), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  var iconNode = icon && !innerLoading ? icon : /* @__PURE__ */ React.createElement(LoadingIcon$1, {
    existIcon: !!icon,
    prefixCls,
    loading: !!innerLoading
  });
  var kids = children || children === 0 ? spaceChildren(children, isNeedInserted() && autoInsertSpace) : null;
  var linkButtonRestProps = omit(rest, ["navigate"]);
  if (linkButtonRestProps.href !== void 0) {
    return /* @__PURE__ */ React.createElement("a", _extends$1({}, linkButtonRestProps, {
      className: classes,
      onClick: handleClick,
      ref: buttonRef
    }), iconNode, kids);
  }
  var buttonNode = /* @__PURE__ */ React.createElement("button", _extends$1({}, rest, {
    type: htmlType,
    className: classes,
    onClick: handleClick,
    ref: buttonRef
  }), iconNode, kids);
  if (isUnborderedButtonType(type4)) {
    return buttonNode;
  }
  return /* @__PURE__ */ React.createElement(Wave, {
    disabled: !!innerLoading
  }, buttonNode);
};
var Button$1 = /* @__PURE__ */ React.forwardRef(InternalButton);
Button$1.displayName = "Button";
Button$1.Group = Group$1;
Button$1.__ANT_BUTTON = true;
var Button$2 = Button$1;
var shallowequal = function shallowEqual(objA, objB, compare2, compareContext) {
  var ret = compare2 ? compare2.call(compareContext, objA, objB) : void 0;
  if (ret !== void 0) {
    return !!ret;
  }
  if (objA === objB) {
    return true;
  }
  if (typeof objA !== "object" || !objA || typeof objB !== "object" || !objB) {
    return false;
  }
  var keysA = Object.keys(objA);
  var keysB = Object.keys(objB);
  if (keysA.length !== keysB.length) {
    return false;
  }
  var bHasOwnProperty = Object.prototype.hasOwnProperty.bind(objB);
  for (var idx = 0; idx < keysA.length; idx++) {
    var key = keysA[idx];
    if (!bHasOwnProperty(key)) {
      return false;
    }
    var valueA = objA[key];
    var valueB = objB[key];
    ret = compare2 ? compare2.call(compareContext, valueA, valueB, key) : void 0;
    if (ret === false || ret === void 0 && valueA !== valueB) {
      return false;
    }
  }
  return true;
};
var _excluded$9 = ["children", "locked"];
var MenuContext = /* @__PURE__ */ React.createContext(null);
function mergeProps(origin, target) {
  var clone3 = _objectSpread2$1({}, origin);
  Object.keys(target).forEach(function(key) {
    var value = target[key];
    if (value !== void 0) {
      clone3[key] = value;
    }
  });
  return clone3;
}
function InheritableContextProvider(_ref) {
  var children = _ref.children, locked = _ref.locked, restProps = _objectWithoutProperties(_ref, _excluded$9);
  var context = React.useContext(MenuContext);
  var inheritableContext = useMemo(function() {
    return mergeProps(context, restProps);
  }, [context, restProps], function(prev, next) {
    return !locked && (prev[0] !== next[0] || !shallowequal(prev[1], next[1]));
  });
  return /* @__PURE__ */ React.createElement(MenuContext.Provider, {
    value: inheritableContext
  }, children);
}
function useActive(eventKey, disabled, onMouseEnter, onMouseLeave) {
  var _React$useContext = React.useContext(MenuContext), activeKey = _React$useContext.activeKey, onActive = _React$useContext.onActive, onInactive = _React$useContext.onInactive;
  var ret = {
    active: activeKey === eventKey
  };
  if (!disabled) {
    ret.onMouseEnter = function(domEvent) {
      onMouseEnter === null || onMouseEnter === void 0 ? void 0 : onMouseEnter({
        key: eventKey,
        domEvent
      });
      onActive(eventKey);
    };
    ret.onMouseLeave = function(domEvent) {
      onMouseLeave === null || onMouseLeave === void 0 ? void 0 : onMouseLeave({
        key: eventKey,
        domEvent
      });
      onInactive(eventKey);
    };
  }
  return ret;
}
var _excluded$8 = ["item"];
function warnItemProp(_ref) {
  var item = _ref.item, restInfo = _objectWithoutProperties(_ref, _excluded$8);
  Object.defineProperty(restInfo, "item", {
    get: function get2() {
      warningOnce(false, "`info.item` is deprecated since we will move to function component that not provides React Node instance in future.");
      return item;
    }
  });
  return restInfo;
}
function Icon(_ref) {
  var icon = _ref.icon, props = _ref.props, children = _ref.children;
  var iconNode;
  if (typeof icon === "function") {
    iconNode = /* @__PURE__ */ React.createElement(icon, _objectSpread2$1({}, props));
  } else {
    iconNode = icon;
  }
  return iconNode || children || null;
}
function useDirectionStyle(level) {
  var _React$useContext = React.useContext(MenuContext), mode = _React$useContext.mode, rtl = _React$useContext.rtl, inlineIndent = _React$useContext.inlineIndent;
  if (mode !== "inline") {
    return null;
  }
  var len2 = level;
  return rtl ? {
    paddingRight: len2 * inlineIndent
  } : {
    paddingLeft: len2 * inlineIndent
  };
}
var EmptyList = [];
var PathRegisterContext = /* @__PURE__ */ React.createContext(null);
function useMeasure() {
  return React.useContext(PathRegisterContext);
}
var PathTrackerContext = /* @__PURE__ */ React.createContext(EmptyList);
function useFullPath(eventKey) {
  var parentKeyPath = React.useContext(PathTrackerContext);
  return React.useMemo(function() {
    return eventKey !== void 0 ? [].concat(_toConsumableArray(parentKeyPath), [eventKey]) : parentKeyPath;
  }, [parentKeyPath, eventKey]);
}
var PathUserContext = /* @__PURE__ */ React.createContext(null);
var IdContext = /* @__PURE__ */ React.createContext(null);
function getMenuId(uuid2, eventKey) {
  if (uuid2 === void 0) {
    return null;
  }
  return "".concat(uuid2, "-").concat(eventKey);
}
function useMenuId(eventKey) {
  var id2 = React.useContext(IdContext);
  return getMenuId(id2, eventKey);
}
var PrivateContext = /* @__PURE__ */ React.createContext({});
var _excluded$7 = ["title", "attribute", "elementRef"], _excluded2$3 = ["style", "className", "eventKey", "warnKey", "disabled", "itemIcon", "children", "role", "onMouseEnter", "onMouseLeave", "onClick", "onKeyDown", "onFocus"], _excluded3 = ["active"];
var LegacyMenuItem = /* @__PURE__ */ function(_React$Component) {
  _inherits(LegacyMenuItem2, _React$Component);
  var _super = _createSuper(LegacyMenuItem2);
  function LegacyMenuItem2() {
    _classCallCheck(this, LegacyMenuItem2);
    return _super.apply(this, arguments);
  }
  _createClass(LegacyMenuItem2, [{
    key: "render",
    value: function render2() {
      var _this$props = this.props, title = _this$props.title, attribute = _this$props.attribute, elementRef = _this$props.elementRef, restProps = _objectWithoutProperties(_this$props, _excluded$7);
      var passedProps = omit(restProps, ["eventKey"]);
      warningOnce(!attribute, "`attribute` of Menu.Item is deprecated. Please pass attribute directly.");
      return /* @__PURE__ */ React.createElement(ForwardOverflow.Item, _extends$1({}, attribute, {
        title: typeof title === "string" ? title : void 0
      }, passedProps, {
        ref: elementRef
      }));
    }
  }]);
  return LegacyMenuItem2;
}(React.Component);
var InternalMenuItem = function InternalMenuItem2(props) {
  var _classNames;
  var style2 = props.style, className = props.className, eventKey = props.eventKey;
  props.warnKey;
  var disabled = props.disabled, itemIcon = props.itemIcon, children = props.children, role = props.role, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onClick = props.onClick, onKeyDown2 = props.onKeyDown, onFocus2 = props.onFocus, restProps = _objectWithoutProperties(props, _excluded2$3);
  var domDataId = useMenuId(eventKey);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, onItemClick = _React$useContext.onItemClick, contextDisabled = _React$useContext.disabled, overflowDisabled = _React$useContext.overflowDisabled, contextItemIcon = _React$useContext.itemIcon, selectedKeys = _React$useContext.selectedKeys, onActive = _React$useContext.onActive;
  var _React$useContext2 = React.useContext(PrivateContext), _internalRenderMenuItem = _React$useContext2._internalRenderMenuItem;
  var itemCls = "".concat(prefixCls, "-item");
  var legacyMenuItemRef = React.useRef();
  var elementRef = React.useRef();
  var mergedDisabled = contextDisabled || disabled;
  var connectedKeys = useFullPath(eventKey);
  var getEventInfo = function getEventInfo2(e2) {
    return {
      key: eventKey,
      keyPath: _toConsumableArray(connectedKeys).reverse(),
      item: legacyMenuItemRef.current,
      domEvent: e2
    };
  };
  var mergedItemIcon = itemIcon || contextItemIcon;
  var _useActive = useActive(eventKey, mergedDisabled, onMouseEnter, onMouseLeave), active = _useActive.active, activeProps = _objectWithoutProperties(_useActive, _excluded3);
  var selected = selectedKeys.includes(eventKey);
  var directionStyle = useDirectionStyle(connectedKeys.length);
  var onInternalClick = function onInternalClick2(e2) {
    if (mergedDisabled) {
      return;
    }
    var info = getEventInfo(e2);
    onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
    onItemClick(info);
  };
  var onInternalKeyDown = function onInternalKeyDown2(e2) {
    onKeyDown2 === null || onKeyDown2 === void 0 ? void 0 : onKeyDown2(e2);
    if (e2.which === KeyCode.ENTER) {
      var info = getEventInfo(e2);
      onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
      onItemClick(info);
    }
  };
  var onInternalFocus = function onInternalFocus2(e2) {
    onActive(eventKey);
    onFocus2 === null || onFocus2 === void 0 ? void 0 : onFocus2(e2);
  };
  var optionRoleProps = {};
  if (props.role === "option") {
    optionRoleProps["aria-selected"] = selected;
  }
  var renderNode2 = /* @__PURE__ */ React.createElement(LegacyMenuItem, _extends$1({
    ref: legacyMenuItemRef,
    elementRef,
    role: role === null ? "none" : role || "menuitem",
    tabIndex: disabled ? null : -1,
    "data-menu-id": overflowDisabled && domDataId ? null : domDataId
  }, restProps, activeProps, optionRoleProps, {
    component: "li",
    "aria-disabled": disabled,
    style: _objectSpread2$1(_objectSpread2$1({}, directionStyle), style2),
    className: classNames(itemCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(itemCls, "-active"), active), _defineProperty$1(_classNames, "".concat(itemCls, "-selected"), selected), _defineProperty$1(_classNames, "".concat(itemCls, "-disabled"), mergedDisabled), _classNames), className),
    onClick: onInternalClick,
    onKeyDown: onInternalKeyDown,
    onFocus: onInternalFocus
  }), children, /* @__PURE__ */ React.createElement(Icon, {
    props: _objectSpread2$1(_objectSpread2$1({}, props), {}, {
      isSelected: selected
    }),
    icon: mergedItemIcon
  }));
  if (_internalRenderMenuItem) {
    renderNode2 = _internalRenderMenuItem(renderNode2, props);
  }
  return renderNode2;
};
function MenuItem(props) {
  var eventKey = props.eventKey;
  var measure = useMeasure();
  var connectedKeyPath = useFullPath(eventKey);
  React.useEffect(function() {
    if (measure) {
      measure.registerPath(eventKey, connectedKeyPath);
      return function() {
        measure.unregisterPath(eventKey, connectedKeyPath);
      };
    }
  }, [connectedKeyPath]);
  if (measure) {
    return null;
  }
  return /* @__PURE__ */ React.createElement(InternalMenuItem, props);
}
function parseChildren(children, keyPath) {
  return toArray$1(children).map(function(child, index2) {
    if (/* @__PURE__ */ React.isValidElement(child)) {
      var _child$props$eventKey, _child$props;
      var key = child.key;
      var eventKey = (_child$props$eventKey = (_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.eventKey) !== null && _child$props$eventKey !== void 0 ? _child$props$eventKey : key;
      var emptyKey = eventKey === null || eventKey === void 0;
      if (emptyKey) {
        eventKey = "tmp_key-".concat([].concat(_toConsumableArray(keyPath), [index2]).join("-"));
      }
      var cloneProps = {
        key: eventKey,
        eventKey
      };
      return /* @__PURE__ */ React.cloneElement(child, cloneProps);
    }
    return child;
  });
}
function useMemoCallback(func) {
  var funRef = React.useRef(func);
  funRef.current = func;
  var callback = React.useCallback(function() {
    var _funRef$current;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    return (_funRef$current = funRef.current) === null || _funRef$current === void 0 ? void 0 : _funRef$current.call.apply(_funRef$current, [funRef].concat(args));
  }, []);
  return func ? callback : void 0;
}
var _excluded$6 = ["className", "children"];
var InternalSubMenuList = function InternalSubMenuList2(_ref, ref) {
  var className = _ref.className, children = _ref.children, restProps = _objectWithoutProperties(_ref, _excluded$6);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, mode = _React$useContext.mode, rtl = _React$useContext.rtl;
  return /* @__PURE__ */ React.createElement("ul", _extends$1({
    className: classNames(prefixCls, rtl && "".concat(prefixCls, "-rtl"), "".concat(prefixCls, "-sub"), "".concat(prefixCls, "-").concat(mode === "inline" ? "inline" : "vertical"), className)
  }, restProps, {
    "data-menu-list": true,
    ref
  }), children);
};
var SubMenuList = /* @__PURE__ */ React.forwardRef(InternalSubMenuList);
SubMenuList.displayName = "SubMenuList";
var autoAdjustOverflow = {
  adjustX: 1,
  adjustY: 1
};
var placements = {
  topLeft: {
    points: ["bl", "tl"],
    overflow: autoAdjustOverflow,
    offset: [0, -7]
  },
  bottomLeft: {
    points: ["tl", "bl"],
    overflow: autoAdjustOverflow,
    offset: [0, 7]
  },
  leftTop: {
    points: ["tr", "tl"],
    overflow: autoAdjustOverflow,
    offset: [-4, 0]
  },
  rightTop: {
    points: ["tl", "tr"],
    overflow: autoAdjustOverflow,
    offset: [4, 0]
  }
};
var placementsRtl = {
  topLeft: {
    points: ["bl", "tl"],
    overflow: autoAdjustOverflow,
    offset: [0, -7]
  },
  bottomLeft: {
    points: ["tl", "bl"],
    overflow: autoAdjustOverflow,
    offset: [0, 7]
  },
  rightTop: {
    points: ["tr", "tl"],
    overflow: autoAdjustOverflow,
    offset: [-4, 0]
  },
  leftTop: {
    points: ["tl", "tr"],
    overflow: autoAdjustOverflow,
    offset: [4, 0]
  }
};
function getMotion(mode, motion, defaultMotions) {
  if (motion) {
    return motion;
  }
  if (defaultMotions) {
    return defaultMotions[mode] || defaultMotions.other;
  }
  return void 0;
}
var popupPlacementMap = {
  horizontal: "bottomLeft",
  vertical: "rightTop",
  "vertical-left": "rightTop",
  "vertical-right": "leftTop"
};
function PopupTrigger(_ref) {
  var prefixCls = _ref.prefixCls, visible = _ref.visible, children = _ref.children, popup = _ref.popup, popupClassName = _ref.popupClassName, popupOffset = _ref.popupOffset, disabled = _ref.disabled, mode = _ref.mode, onVisibleChange = _ref.onVisibleChange;
  var _React$useContext = React.useContext(MenuContext), getPopupContainer = _React$useContext.getPopupContainer, rtl = _React$useContext.rtl, subMenuOpenDelay = _React$useContext.subMenuOpenDelay, subMenuCloseDelay = _React$useContext.subMenuCloseDelay, builtinPlacements = _React$useContext.builtinPlacements, triggerSubMenuAction = _React$useContext.triggerSubMenuAction, forceSubMenuRender = _React$useContext.forceSubMenuRender, motion = _React$useContext.motion, defaultMotions = _React$useContext.defaultMotions;
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), innerVisible = _React$useState2[0], setInnerVisible = _React$useState2[1];
  var placement = rtl ? _objectSpread2$1(_objectSpread2$1({}, placementsRtl), builtinPlacements) : _objectSpread2$1(_objectSpread2$1({}, placements), builtinPlacements);
  var popupPlacement = popupPlacementMap[mode];
  var targetMotion = getMotion(mode, motion, defaultMotions);
  var mergedMotion = _objectSpread2$1(_objectSpread2$1({}, targetMotion), {}, {
    leavedClassName: "".concat(prefixCls, "-hidden"),
    removeOnLeave: false,
    motionAppear: true
  });
  var visibleRef = React.useRef();
  React.useEffect(function() {
    visibleRef.current = wrapperRaf$1(function() {
      setInnerVisible(visible);
    });
    return function() {
      wrapperRaf$1.cancel(visibleRef.current);
    };
  }, [visible]);
  return /* @__PURE__ */ React.createElement(Trigger, {
    prefixCls,
    popupClassName: classNames("".concat(prefixCls, "-popup"), _defineProperty$1({}, "".concat(prefixCls, "-rtl"), rtl), popupClassName),
    stretch: mode === "horizontal" ? "minWidth" : null,
    getPopupContainer,
    builtinPlacements: placement,
    popupPlacement,
    popupVisible: innerVisible,
    popup,
    popupAlign: popupOffset && {
      offset: popupOffset
    },
    action: disabled ? [] : [triggerSubMenuAction],
    mouseEnterDelay: subMenuOpenDelay,
    mouseLeaveDelay: subMenuCloseDelay,
    onPopupVisibleChange: onVisibleChange,
    forceRender: forceSubMenuRender,
    popupMotion: mergedMotion
  }, children);
}
function InlineSubMenuList(_ref) {
  var id2 = _ref.id, open = _ref.open, keyPath = _ref.keyPath, children = _ref.children;
  var fixedMode = "inline";
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, forceSubMenuRender = _React$useContext.forceSubMenuRender, motion = _React$useContext.motion, defaultMotions = _React$useContext.defaultMotions, mode = _React$useContext.mode;
  var sameModeRef = React.useRef(false);
  sameModeRef.current = mode === fixedMode;
  var _React$useState = React.useState(!sameModeRef.current), _React$useState2 = _slicedToArray(_React$useState, 2), destroy = _React$useState2[0], setDestroy = _React$useState2[1];
  var mergedOpen = sameModeRef.current ? open : false;
  React.useEffect(function() {
    if (sameModeRef.current) {
      setDestroy(false);
    }
  }, [mode]);
  var mergedMotion = _objectSpread2$1({}, getMotion(fixedMode, motion, defaultMotions));
  if (keyPath.length > 1) {
    mergedMotion.motionAppear = false;
  }
  var originOnVisibleChanged = mergedMotion.onVisibleChanged;
  mergedMotion.onVisibleChanged = function(newVisible) {
    if (!sameModeRef.current && !newVisible) {
      setDestroy(true);
    }
    return originOnVisibleChanged === null || originOnVisibleChanged === void 0 ? void 0 : originOnVisibleChanged(newVisible);
  };
  if (destroy) {
    return null;
  }
  return /* @__PURE__ */ React.createElement(InheritableContextProvider, {
    mode: fixedMode,
    locked: !sameModeRef.current
  }, /* @__PURE__ */ React.createElement(CSSMotion, _extends$1({
    visible: mergedOpen
  }, mergedMotion, {
    forceRender: forceSubMenuRender,
    removeOnLeave: false,
    leavedClassName: "".concat(prefixCls, "-hidden")
  }), function(_ref2) {
    var motionClassName = _ref2.className, motionStyle = _ref2.style;
    return /* @__PURE__ */ React.createElement(SubMenuList, {
      id: id2,
      className: motionClassName,
      style: motionStyle
    }, children);
  }));
}
var _excluded$5 = ["style", "className", "title", "eventKey", "warnKey", "disabled", "internalPopupClose", "children", "itemIcon", "expandIcon", "popupClassName", "popupOffset", "onClick", "onMouseEnter", "onMouseLeave", "onTitleClick", "onTitleMouseEnter", "onTitleMouseLeave"], _excluded2$2 = ["active"];
var InternalSubMenu = function InternalSubMenu2(props) {
  var _classNames;
  var style2 = props.style, className = props.className, title = props.title, eventKey = props.eventKey;
  props.warnKey;
  var disabled = props.disabled, internalPopupClose = props.internalPopupClose, children = props.children, itemIcon = props.itemIcon, expandIcon = props.expandIcon, popupClassName = props.popupClassName, popupOffset = props.popupOffset, onClick = props.onClick, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onTitleClick = props.onTitleClick, onTitleMouseEnter = props.onTitleMouseEnter, onTitleMouseLeave = props.onTitleMouseLeave, restProps = _objectWithoutProperties(props, _excluded$5);
  var domDataId = useMenuId(eventKey);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls, mode = _React$useContext.mode, openKeys = _React$useContext.openKeys, contextDisabled = _React$useContext.disabled, overflowDisabled = _React$useContext.overflowDisabled, activeKey = _React$useContext.activeKey, selectedKeys = _React$useContext.selectedKeys, contextItemIcon = _React$useContext.itemIcon, contextExpandIcon = _React$useContext.expandIcon, onItemClick = _React$useContext.onItemClick, onOpenChange = _React$useContext.onOpenChange, onActive = _React$useContext.onActive;
  var _React$useContext2 = React.useContext(PrivateContext), _internalRenderSubMenuItem = _React$useContext2._internalRenderSubMenuItem;
  var _React$useContext3 = React.useContext(PathUserContext), isSubPathKey = _React$useContext3.isSubPathKey;
  var connectedPath = useFullPath();
  var subMenuPrefixCls = "".concat(prefixCls, "-submenu");
  var mergedDisabled = contextDisabled || disabled;
  var elementRef = React.useRef();
  var popupRef = React.useRef();
  var mergedItemIcon = itemIcon || contextItemIcon;
  var mergedExpandIcon = expandIcon || contextExpandIcon;
  var originOpen = openKeys.includes(eventKey);
  var open = !overflowDisabled && originOpen;
  var childrenSelected = isSubPathKey(selectedKeys, eventKey);
  var _useActive = useActive(eventKey, mergedDisabled, onTitleMouseEnter, onTitleMouseLeave), active = _useActive.active, activeProps = _objectWithoutProperties(_useActive, _excluded2$2);
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), childrenActive = _React$useState2[0], setChildrenActive = _React$useState2[1];
  var triggerChildrenActive = function triggerChildrenActive2(newActive) {
    if (!mergedDisabled) {
      setChildrenActive(newActive);
    }
  };
  var onInternalMouseEnter = function onInternalMouseEnter2(domEvent) {
    triggerChildrenActive(true);
    onMouseEnter === null || onMouseEnter === void 0 ? void 0 : onMouseEnter({
      key: eventKey,
      domEvent
    });
  };
  var onInternalMouseLeave = function onInternalMouseLeave2(domEvent) {
    triggerChildrenActive(false);
    onMouseLeave === null || onMouseLeave === void 0 ? void 0 : onMouseLeave({
      key: eventKey,
      domEvent
    });
  };
  var mergedActive = React.useMemo(function() {
    if (active) {
      return active;
    }
    if (mode !== "inline") {
      return childrenActive || isSubPathKey([activeKey], eventKey);
    }
    return false;
  }, [mode, active, activeKey, childrenActive, eventKey, isSubPathKey]);
  var directionStyle = useDirectionStyle(connectedPath.length);
  var onInternalTitleClick = function onInternalTitleClick2(e2) {
    if (mergedDisabled) {
      return;
    }
    onTitleClick === null || onTitleClick === void 0 ? void 0 : onTitleClick({
      key: eventKey,
      domEvent: e2
    });
    if (mode === "inline") {
      onOpenChange(eventKey, !originOpen);
    }
  };
  var onMergedItemClick = useMemoCallback(function(info) {
    onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
    onItemClick(info);
  });
  var onPopupVisibleChange = function onPopupVisibleChange2(newVisible) {
    if (mode !== "inline") {
      onOpenChange(eventKey, newVisible);
    }
  };
  var onInternalFocus = function onInternalFocus2() {
    onActive(eventKey);
  };
  var popupId = domDataId && "".concat(domDataId, "-popup");
  var titleNode = /* @__PURE__ */ React.createElement("div", _extends$1({
    role: "menuitem",
    style: directionStyle,
    className: "".concat(subMenuPrefixCls, "-title"),
    tabIndex: mergedDisabled ? null : -1,
    ref: elementRef,
    title: typeof title === "string" ? title : null,
    "data-menu-id": overflowDisabled && domDataId ? null : domDataId,
    "aria-expanded": open,
    "aria-haspopup": true,
    "aria-controls": popupId,
    "aria-disabled": mergedDisabled,
    onClick: onInternalTitleClick,
    onFocus: onInternalFocus
  }, activeProps), title, /* @__PURE__ */ React.createElement(Icon, {
    icon: mode !== "horizontal" ? mergedExpandIcon : null,
    props: _objectSpread2$1(_objectSpread2$1({}, props), {}, {
      isOpen: open,
      isSubMenu: true
    })
  }, /* @__PURE__ */ React.createElement("i", {
    className: "".concat(subMenuPrefixCls, "-arrow")
  })));
  var triggerModeRef = React.useRef(mode);
  if (mode !== "inline") {
    triggerModeRef.current = connectedPath.length > 1 ? "vertical" : mode;
  }
  if (!overflowDisabled) {
    var triggerMode = triggerModeRef.current;
    titleNode = /* @__PURE__ */ React.createElement(PopupTrigger, {
      mode: triggerMode,
      prefixCls: subMenuPrefixCls,
      visible: !internalPopupClose && open && mode !== "inline",
      popupClassName,
      popupOffset,
      popup: /* @__PURE__ */ React.createElement(InheritableContextProvider, {
        mode: triggerMode === "horizontal" ? "vertical" : triggerMode
      }, /* @__PURE__ */ React.createElement(SubMenuList, {
        id: popupId,
        ref: popupRef
      }, children)),
      disabled: mergedDisabled,
      onVisibleChange: onPopupVisibleChange
    }, titleNode);
  }
  var listNode = /* @__PURE__ */ React.createElement(ForwardOverflow.Item, _extends$1({
    role: "none"
  }, restProps, {
    component: "li",
    style: style2,
    className: classNames(subMenuPrefixCls, "".concat(subMenuPrefixCls, "-").concat(mode), className, (_classNames = {}, _defineProperty$1(_classNames, "".concat(subMenuPrefixCls, "-open"), open), _defineProperty$1(_classNames, "".concat(subMenuPrefixCls, "-active"), mergedActive), _defineProperty$1(_classNames, "".concat(subMenuPrefixCls, "-selected"), childrenSelected), _defineProperty$1(_classNames, "".concat(subMenuPrefixCls, "-disabled"), mergedDisabled), _classNames)),
    onMouseEnter: onInternalMouseEnter,
    onMouseLeave: onInternalMouseLeave
  }), titleNode, !overflowDisabled && /* @__PURE__ */ React.createElement(InlineSubMenuList, {
    id: popupId,
    open,
    keyPath: connectedPath
  }, children));
  if (_internalRenderSubMenuItem) {
    listNode = _internalRenderSubMenuItem(listNode, props);
  }
  return /* @__PURE__ */ React.createElement(InheritableContextProvider, {
    onItemClick: onMergedItemClick,
    mode: mode === "horizontal" ? "vertical" : mode,
    itemIcon: mergedItemIcon,
    expandIcon: mergedExpandIcon
  }, listNode);
};
function SubMenu(props) {
  var eventKey = props.eventKey, children = props.children;
  var connectedKeyPath = useFullPath(eventKey);
  var childList = parseChildren(children, connectedKeyPath);
  var measure = useMeasure();
  React.useEffect(function() {
    if (measure) {
      measure.registerPath(eventKey, connectedKeyPath);
      return function() {
        measure.unregisterPath(eventKey, connectedKeyPath);
      };
    }
  }, [connectedKeyPath]);
  var renderNode2;
  if (measure) {
    renderNode2 = childList;
  } else {
    renderNode2 = /* @__PURE__ */ React.createElement(InternalSubMenu, props, childList);
  }
  return /* @__PURE__ */ React.createElement(PathTrackerContext.Provider, {
    value: connectedKeyPath
  }, renderNode2);
}
function focusable(node) {
  var includePositive = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  if (isVisible(node)) {
    var nodeName = node.nodeName.toLowerCase();
    var isFocusableElement = ["input", "select", "textarea", "button"].includes(nodeName) || node.isContentEditable || nodeName === "a" && !!node.getAttribute("href");
    var tabIndexAttr = node.getAttribute("tabindex");
    var tabIndexNum = Number(tabIndexAttr);
    var tabIndex = null;
    if (tabIndexAttr && !Number.isNaN(tabIndexNum)) {
      tabIndex = tabIndexNum;
    } else if (isFocusableElement && tabIndex === null) {
      tabIndex = 0;
    }
    if (isFocusableElement && node.disabled) {
      tabIndex = null;
    }
    return tabIndex !== null && (tabIndex >= 0 || includePositive && tabIndex < 0);
  }
  return false;
}
function getFocusNodeList(node) {
  var includePositive = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  var res = _toConsumableArray(node.querySelectorAll("*")).filter(function(child) {
    return focusable(child, includePositive);
  });
  if (focusable(node, includePositive)) {
    res.unshift(node);
  }
  return res;
}
var LEFT = KeyCode.LEFT, RIGHT = KeyCode.RIGHT, UP = KeyCode.UP, DOWN = KeyCode.DOWN, ENTER = KeyCode.ENTER, ESC = KeyCode.ESC, HOME = KeyCode.HOME, END = KeyCode.END;
var ArrowKeys = [UP, DOWN, LEFT, RIGHT];
function getOffset(mode, isRootLevel, isRtl, which) {
  var _inline, _horizontal, _vertical, _offsets$;
  var prev = "prev";
  var next = "next";
  var children = "children";
  var parent = "parent";
  if (mode === "inline" && which === ENTER) {
    return {
      inlineTrigger: true
    };
  }
  var inline = (_inline = {}, _defineProperty$1(_inline, UP, prev), _defineProperty$1(_inline, DOWN, next), _inline);
  var horizontal = (_horizontal = {}, _defineProperty$1(_horizontal, LEFT, isRtl ? next : prev), _defineProperty$1(_horizontal, RIGHT, isRtl ? prev : next), _defineProperty$1(_horizontal, DOWN, children), _defineProperty$1(_horizontal, ENTER, children), _horizontal);
  var vertical = (_vertical = {}, _defineProperty$1(_vertical, UP, prev), _defineProperty$1(_vertical, DOWN, next), _defineProperty$1(_vertical, ENTER, children), _defineProperty$1(_vertical, ESC, parent), _defineProperty$1(_vertical, LEFT, isRtl ? children : parent), _defineProperty$1(_vertical, RIGHT, isRtl ? parent : children), _vertical);
  var offsets = {
    inline,
    horizontal,
    vertical,
    inlineSub: inline,
    horizontalSub: vertical,
    verticalSub: vertical
  };
  var type4 = (_offsets$ = offsets["".concat(mode).concat(isRootLevel ? "" : "Sub")]) === null || _offsets$ === void 0 ? void 0 : _offsets$[which];
  switch (type4) {
    case prev:
      return {
        offset: -1,
        sibling: true
      };
    case next:
      return {
        offset: 1,
        sibling: true
      };
    case parent:
      return {
        offset: -1,
        sibling: false
      };
    case children:
      return {
        offset: 1,
        sibling: false
      };
    default:
      return null;
  }
}
function findContainerUL(element) {
  var current = element;
  while (current) {
    if (current.getAttribute("data-menu-list")) {
      return current;
    }
    current = current.parentElement;
  }
  return null;
}
function getFocusElement(activeElement, elements) {
  var current = activeElement || document.activeElement;
  while (current) {
    if (elements.has(current)) {
      return current;
    }
    current = current.parentElement;
  }
  return null;
}
function getFocusableElements(container2, elements) {
  var list = getFocusNodeList(container2, true);
  return list.filter(function(ele) {
    return elements.has(ele);
  });
}
function getNextFocusElement(parentQueryContainer, elements, focusMenuElement) {
  var offset2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 1;
  if (!parentQueryContainer) {
    return null;
  }
  var sameLevelFocusableMenuElementList = getFocusableElements(parentQueryContainer, elements);
  var count2 = sameLevelFocusableMenuElementList.length;
  var focusIndex = sameLevelFocusableMenuElementList.findIndex(function(ele) {
    return focusMenuElement === ele;
  });
  if (offset2 < 0) {
    if (focusIndex === -1) {
      focusIndex = count2 - 1;
    } else {
      focusIndex -= 1;
    }
  } else if (offset2 > 0) {
    focusIndex += 1;
  }
  focusIndex = (focusIndex + count2) % count2;
  return sameLevelFocusableMenuElementList[focusIndex];
}
function useAccessibility(mode, activeKey, isRtl, id2, containerRef, getKeys, getKeyPath, triggerActiveKey, triggerAccessibilityOpen, originOnKeyDown) {
  var rafRef = React.useRef();
  var activeRef = React.useRef();
  activeRef.current = activeKey;
  var cleanRaf = function cleanRaf2() {
    wrapperRaf$1.cancel(rafRef.current);
  };
  React.useEffect(function() {
    return function() {
      cleanRaf();
    };
  }, []);
  return function(e2) {
    var which = e2.which;
    if ([].concat(ArrowKeys, [ENTER, ESC, HOME, END]).includes(which)) {
      var elements;
      var key2element;
      var element2key;
      var refreshElements = function refreshElements2() {
        elements = /* @__PURE__ */ new Set();
        key2element = /* @__PURE__ */ new Map();
        element2key = /* @__PURE__ */ new Map();
        var keys2 = getKeys();
        keys2.forEach(function(key) {
          var element = document.querySelector("[data-menu-id='".concat(getMenuId(id2, key), "']"));
          if (element) {
            elements.add(element);
            element2key.set(element, key);
            key2element.set(key, element);
          }
        });
        return elements;
      };
      refreshElements();
      var activeElement = key2element.get(activeKey);
      var focusMenuElement = getFocusElement(activeElement, elements);
      var focusMenuKey = element2key.get(focusMenuElement);
      var offsetObj = getOffset(mode, getKeyPath(focusMenuKey, true).length === 1, isRtl, which);
      if (!offsetObj && which !== HOME && which !== END) {
        return;
      }
      if (ArrowKeys.includes(which) || [HOME, END].includes(which)) {
        e2.preventDefault();
      }
      var tryFocus = function tryFocus2(menuElement) {
        if (menuElement) {
          var focusTargetElement = menuElement;
          var link = menuElement.querySelector("a");
          if (link === null || link === void 0 ? void 0 : link.getAttribute("href")) {
            focusTargetElement = link;
          }
          var targetKey = element2key.get(menuElement);
          triggerActiveKey(targetKey);
          cleanRaf();
          rafRef.current = wrapperRaf$1(function() {
            if (activeRef.current === targetKey) {
              focusTargetElement.focus();
            }
          });
        }
      };
      if ([HOME, END].includes(which) || offsetObj.sibling || !focusMenuElement) {
        var parentQueryContainer;
        if (!focusMenuElement || mode === "inline") {
          parentQueryContainer = containerRef.current;
        } else {
          parentQueryContainer = findContainerUL(focusMenuElement);
        }
        var targetElement;
        var focusableElements = getFocusableElements(parentQueryContainer, elements);
        if (which === HOME) {
          targetElement = focusableElements[0];
        } else if (which === END) {
          targetElement = focusableElements[focusableElements.length - 1];
        } else {
          targetElement = getNextFocusElement(parentQueryContainer, elements, focusMenuElement, offsetObj.offset);
        }
        tryFocus(targetElement);
      } else if (offsetObj.inlineTrigger) {
        triggerAccessibilityOpen(focusMenuKey);
      } else if (offsetObj.offset > 0) {
        triggerAccessibilityOpen(focusMenuKey, true);
        cleanRaf();
        rafRef.current = wrapperRaf$1(function() {
          refreshElements();
          var controlId = focusMenuElement.getAttribute("aria-controls");
          var subQueryContainer = document.getElementById(controlId);
          var targetElement2 = getNextFocusElement(subQueryContainer, elements);
          tryFocus(targetElement2);
        }, 5);
      } else if (offsetObj.offset < 0) {
        var keyPath = getKeyPath(focusMenuKey, true);
        var parentKey = keyPath[keyPath.length - 2];
        var parentMenuElement = key2element.get(parentKey);
        triggerAccessibilityOpen(parentKey, false);
        tryFocus(parentMenuElement);
      }
    }
    originOnKeyDown === null || originOnKeyDown === void 0 ? void 0 : originOnKeyDown(e2);
  };
}
var uniquePrefix = Math.random().toFixed(5).toString().slice(2);
var internalId = 0;
function useUUID(id2) {
  var _useMergedState = useControlledState(id2, {
    value: id2
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), uuid2 = _useMergedState2[0], setUUID = _useMergedState2[1];
  React.useEffect(function() {
    internalId += 1;
    var newId = "".concat(uniquePrefix, "-").concat(internalId);
    setUUID("rc-menu-uuid-".concat(newId));
  }, []);
  return uuid2;
}
function nextSlice(callback) {
  Promise.resolve().then(callback);
}
var PATH_SPLIT = "__RC_UTIL_PATH_SPLIT__";
var getPathStr = function getPathStr2(keyPath) {
  return keyPath.join(PATH_SPLIT);
};
var getPathKeys = function getPathKeys2(keyPathStr) {
  return keyPathStr.split(PATH_SPLIT);
};
var OVERFLOW_KEY = "rc-menu-more";
function useKeyRecords() {
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray(_React$useState, 2), internalForceUpdate = _React$useState2[1];
  var key2pathRef = useRef(/* @__PURE__ */ new Map());
  var path2keyRef = useRef(/* @__PURE__ */ new Map());
  var _React$useState3 = React.useState([]), _React$useState4 = _slicedToArray(_React$useState3, 2), overflowKeys = _React$useState4[0], setOverflowKeys = _React$useState4[1];
  var updateRef = useRef(0);
  var destroyRef = useRef(false);
  var forceUpdate = function forceUpdate2() {
    if (!destroyRef.current) {
      internalForceUpdate({});
    }
  };
  var registerPath = useCallback(function(key, keyPath) {
    var connectedPath = getPathStr(keyPath);
    path2keyRef.current.set(connectedPath, key);
    key2pathRef.current.set(key, connectedPath);
    updateRef.current += 1;
    var id2 = updateRef.current;
    nextSlice(function() {
      if (id2 === updateRef.current) {
        forceUpdate();
      }
    });
  }, []);
  var unregisterPath = useCallback(function(key, keyPath) {
    var connectedPath = getPathStr(keyPath);
    path2keyRef.current.delete(connectedPath);
    key2pathRef.current.delete(key);
  }, []);
  var refreshOverflowKeys = useCallback(function(keys2) {
    setOverflowKeys(keys2);
  }, []);
  var getKeyPath = useCallback(function(eventKey, includeOverflow) {
    var fullPath = key2pathRef.current.get(eventKey) || "";
    var keys2 = getPathKeys(fullPath);
    if (includeOverflow && overflowKeys.includes(keys2[0])) {
      keys2.unshift(OVERFLOW_KEY);
    }
    return keys2;
  }, [overflowKeys]);
  var isSubPathKey = useCallback(function(pathKeys, eventKey) {
    return pathKeys.some(function(pathKey) {
      var pathKeyList = getKeyPath(pathKey, true);
      return pathKeyList.includes(eventKey);
    });
  }, [getKeyPath]);
  var getKeys = function getKeys2() {
    var keys2 = _toConsumableArray(key2pathRef.current.keys());
    if (overflowKeys.length) {
      keys2.push(OVERFLOW_KEY);
    }
    return keys2;
  };
  var getSubPathKeys = useCallback(function(key) {
    var connectedPath = "".concat(key2pathRef.current.get(key)).concat(PATH_SPLIT);
    var pathKeys = /* @__PURE__ */ new Set();
    _toConsumableArray(path2keyRef.current.keys()).forEach(function(pathKey) {
      if (pathKey.startsWith(connectedPath)) {
        pathKeys.add(path2keyRef.current.get(pathKey));
      }
    });
    return pathKeys;
  }, []);
  React.useEffect(function() {
    return function() {
      destroyRef.current = true;
    };
  }, []);
  return {
    registerPath,
    unregisterPath,
    refreshOverflowKeys,
    isSubPathKey,
    getKeyPath,
    getKeys,
    getSubPathKeys
  };
}
var _excluded$4 = ["prefixCls", "style", "className", "tabIndex", "children", "direction", "id", "mode", "inlineCollapsed", "disabled", "disabledOverflow", "subMenuOpenDelay", "subMenuCloseDelay", "forceSubMenuRender", "defaultOpenKeys", "openKeys", "activeKey", "defaultActiveFirst", "selectable", "multiple", "defaultSelectedKeys", "selectedKeys", "onSelect", "onDeselect", "inlineIndent", "motion", "defaultMotions", "triggerSubMenuAction", "builtinPlacements", "itemIcon", "expandIcon", "overflowedIndicator", "overflowedIndicatorPopupClassName", "getPopupContainer", "onClick", "onOpenChange", "onKeyDown", "openAnimation", "openTransitionName", "_internalRenderMenuItem", "_internalRenderSubMenuItem"];
var EMPTY_LIST = [];
var Menu = function Menu2(props) {
  var _childList$, _classNames;
  var _props$prefixCls = props.prefixCls, prefixCls = _props$prefixCls === void 0 ? "rc-menu" : _props$prefixCls, style2 = props.style, className = props.className, _props$tabIndex = props.tabIndex, tabIndex = _props$tabIndex === void 0 ? 0 : _props$tabIndex, children = props.children, direction = props.direction, id2 = props.id, _props$mode = props.mode, mode = _props$mode === void 0 ? "vertical" : _props$mode, inlineCollapsed = props.inlineCollapsed, disabled = props.disabled, disabledOverflow = props.disabledOverflow, _props$subMenuOpenDel = props.subMenuOpenDelay, subMenuOpenDelay = _props$subMenuOpenDel === void 0 ? 0.1 : _props$subMenuOpenDel, _props$subMenuCloseDe = props.subMenuCloseDelay, subMenuCloseDelay = _props$subMenuCloseDe === void 0 ? 0.1 : _props$subMenuCloseDe, forceSubMenuRender = props.forceSubMenuRender, defaultOpenKeys = props.defaultOpenKeys, openKeys = props.openKeys, activeKey = props.activeKey, defaultActiveFirst = props.defaultActiveFirst, _props$selectable = props.selectable, selectable = _props$selectable === void 0 ? true : _props$selectable, _props$multiple = props.multiple, multiple = _props$multiple === void 0 ? false : _props$multiple, defaultSelectedKeys = props.defaultSelectedKeys, selectedKeys = props.selectedKeys, onSelect = props.onSelect, onDeselect = props.onDeselect, _props$inlineIndent = props.inlineIndent, inlineIndent = _props$inlineIndent === void 0 ? 24 : _props$inlineIndent, motion = props.motion, defaultMotions = props.defaultMotions, _props$triggerSubMenu = props.triggerSubMenuAction, triggerSubMenuAction = _props$triggerSubMenu === void 0 ? "hover" : _props$triggerSubMenu, builtinPlacements = props.builtinPlacements, itemIcon = props.itemIcon, expandIcon = props.expandIcon, _props$overflowedIndi = props.overflowedIndicator, overflowedIndicator = _props$overflowedIndi === void 0 ? "..." : _props$overflowedIndi, overflowedIndicatorPopupClassName = props.overflowedIndicatorPopupClassName, getPopupContainer = props.getPopupContainer, onClick = props.onClick, onOpenChange = props.onOpenChange, onKeyDown2 = props.onKeyDown;
  props.openAnimation;
  props.openTransitionName;
  var _internalRenderMenuItem = props._internalRenderMenuItem, _internalRenderSubMenuItem = props._internalRenderSubMenuItem, restProps = _objectWithoutProperties(props, _excluded$4);
  var childList = parseChildren(children, EMPTY_LIST);
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), mounted = _React$useState2[0], setMounted = _React$useState2[1];
  var containerRef = React.useRef();
  var uuid2 = useUUID(id2);
  var isRtl = direction === "rtl";
  var _React$useMemo = React.useMemo(function() {
    if ((mode === "inline" || mode === "vertical") && inlineCollapsed) {
      return ["vertical", inlineCollapsed];
    }
    return [mode, false];
  }, [mode, inlineCollapsed]), _React$useMemo2 = _slicedToArray(_React$useMemo, 2), mergedMode = _React$useMemo2[0], mergedInlineCollapsed = _React$useMemo2[1];
  var _React$useState3 = React.useState(0), _React$useState4 = _slicedToArray(_React$useState3, 2), lastVisibleIndex = _React$useState4[0], setLastVisibleIndex = _React$useState4[1];
  var allVisible = lastVisibleIndex >= childList.length - 1 || mergedMode !== "horizontal" || disabledOverflow;
  var _useMergedState = useControlledState(defaultOpenKeys, {
    value: openKeys,
    postState: function postState(keys2) {
      return keys2 || EMPTY_LIST;
    }
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), mergedOpenKeys = _useMergedState2[0], setMergedOpenKeys = _useMergedState2[1];
  var triggerOpenKeys = function triggerOpenKeys2(keys2) {
    setMergedOpenKeys(keys2);
    onOpenChange === null || onOpenChange === void 0 ? void 0 : onOpenChange(keys2);
  };
  var _React$useState5 = React.useState(mergedOpenKeys), _React$useState6 = _slicedToArray(_React$useState5, 2), inlineCacheOpenKeys = _React$useState6[0], setInlineCacheOpenKeys = _React$useState6[1];
  var isInlineMode = mergedMode === "inline";
  var mountRef = React.useRef(false);
  React.useEffect(function() {
    if (isInlineMode) {
      setInlineCacheOpenKeys(mergedOpenKeys);
    }
  }, [mergedOpenKeys]);
  React.useEffect(function() {
    if (!mountRef.current) {
      mountRef.current = true;
      return;
    }
    if (isInlineMode) {
      setMergedOpenKeys(inlineCacheOpenKeys);
    } else {
      triggerOpenKeys(EMPTY_LIST);
    }
  }, [isInlineMode]);
  var _useKeyRecords = useKeyRecords(), registerPath = _useKeyRecords.registerPath, unregisterPath = _useKeyRecords.unregisterPath, refreshOverflowKeys = _useKeyRecords.refreshOverflowKeys, isSubPathKey = _useKeyRecords.isSubPathKey, getKeyPath = _useKeyRecords.getKeyPath, getKeys = _useKeyRecords.getKeys, getSubPathKeys = _useKeyRecords.getSubPathKeys;
  var registerPathContext = React.useMemo(function() {
    return {
      registerPath,
      unregisterPath
    };
  }, [registerPath, unregisterPath]);
  var pathUserContext = React.useMemo(function() {
    return {
      isSubPathKey
    };
  }, [isSubPathKey]);
  React.useEffect(function() {
    refreshOverflowKeys(allVisible ? EMPTY_LIST : childList.slice(lastVisibleIndex + 1).map(function(child) {
      return child.key;
    }));
  }, [lastVisibleIndex, allVisible]);
  var _useMergedState3 = useControlledState(activeKey || defaultActiveFirst && ((_childList$ = childList[0]) === null || _childList$ === void 0 ? void 0 : _childList$.key), {
    value: activeKey
  }), _useMergedState4 = _slicedToArray(_useMergedState3, 2), mergedActiveKey = _useMergedState4[0], setMergedActiveKey = _useMergedState4[1];
  var onActive = useMemoCallback(function(key) {
    setMergedActiveKey(key);
  });
  var onInactive = useMemoCallback(function() {
    setMergedActiveKey(void 0);
  });
  var _useMergedState5 = useControlledState(defaultSelectedKeys || [], {
    value: selectedKeys,
    postState: function postState(keys2) {
      if (Array.isArray(keys2)) {
        return keys2;
      }
      if (keys2 === null || keys2 === void 0) {
        return EMPTY_LIST;
      }
      return [keys2];
    }
  }), _useMergedState6 = _slicedToArray(_useMergedState5, 2), mergedSelectKeys = _useMergedState6[0], setMergedSelectKeys = _useMergedState6[1];
  var triggerSelection = function triggerSelection2(info) {
    if (selectable) {
      var targetKey = info.key;
      var exist = mergedSelectKeys.includes(targetKey);
      var newSelectKeys;
      if (multiple) {
        if (exist) {
          newSelectKeys = mergedSelectKeys.filter(function(key) {
            return key !== targetKey;
          });
        } else {
          newSelectKeys = [].concat(_toConsumableArray(mergedSelectKeys), [targetKey]);
        }
      } else {
        newSelectKeys = [targetKey];
      }
      setMergedSelectKeys(newSelectKeys);
      var selectInfo = _objectSpread2$1(_objectSpread2$1({}, info), {}, {
        selectedKeys: newSelectKeys
      });
      if (exist) {
        onDeselect === null || onDeselect === void 0 ? void 0 : onDeselect(selectInfo);
      } else {
        onSelect === null || onSelect === void 0 ? void 0 : onSelect(selectInfo);
      }
    }
    if (!multiple && mergedOpenKeys.length && mergedMode !== "inline") {
      triggerOpenKeys(EMPTY_LIST);
    }
  };
  var onInternalClick = useMemoCallback(function(info) {
    onClick === null || onClick === void 0 ? void 0 : onClick(warnItemProp(info));
    triggerSelection(info);
  });
  var onInternalOpenChange = useMemoCallback(function(key, open) {
    var newOpenKeys = mergedOpenKeys.filter(function(k2) {
      return k2 !== key;
    });
    if (open) {
      newOpenKeys.push(key);
    } else if (mergedMode !== "inline") {
      var subPathKeys = getSubPathKeys(key);
      newOpenKeys = newOpenKeys.filter(function(k2) {
        return !subPathKeys.has(k2);
      });
    }
    if (!shallowequal(mergedOpenKeys, newOpenKeys)) {
      triggerOpenKeys(newOpenKeys);
    }
  });
  var getInternalPopupContainer = useMemoCallback(getPopupContainer);
  var triggerAccessibilityOpen = function triggerAccessibilityOpen2(key, open) {
    var nextOpen = open !== null && open !== void 0 ? open : !mergedOpenKeys.includes(key);
    onInternalOpenChange(key, nextOpen);
  };
  var onInternalKeyDown = useAccessibility(mergedMode, mergedActiveKey, isRtl, uuid2, containerRef, getKeys, getKeyPath, setMergedActiveKey, triggerAccessibilityOpen, onKeyDown2);
  React.useEffect(function() {
    setMounted(true);
  }, []);
  var privateContext = React.useMemo(function() {
    return {
      _internalRenderMenuItem,
      _internalRenderSubMenuItem
    };
  }, [_internalRenderMenuItem, _internalRenderSubMenuItem]);
  var wrappedChildList = mergedMode !== "horizontal" || disabledOverflow ? childList : childList.map(function(child, index2) {
    return /* @__PURE__ */ React.createElement(InheritableContextProvider, {
      key: child.key,
      overflowDisabled: index2 > lastVisibleIndex
    }, child);
  });
  var container2 = /* @__PURE__ */ React.createElement(ForwardOverflow, _extends$1({
    id: id2,
    ref: containerRef,
    prefixCls: "".concat(prefixCls, "-overflow"),
    component: "ul",
    itemComponent: MenuItem,
    className: classNames(prefixCls, "".concat(prefixCls, "-root"), "".concat(prefixCls, "-").concat(mergedMode), className, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-inline-collapsed"), mergedInlineCollapsed), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), isRtl), _classNames)),
    dir: direction,
    style: style2,
    role: "menu",
    tabIndex,
    data: wrappedChildList,
    renderRawItem: function renderRawItem(node) {
      return node;
    },
    renderRawRest: function renderRawRest(omitItems) {
      var len2 = omitItems.length;
      var originOmitItems = len2 ? childList.slice(-len2) : null;
      return /* @__PURE__ */ React.createElement(SubMenu, {
        eventKey: OVERFLOW_KEY,
        title: overflowedIndicator,
        disabled: allVisible,
        internalPopupClose: len2 === 0,
        popupClassName: overflowedIndicatorPopupClassName
      }, originOmitItems);
    },
    maxCount: mergedMode !== "horizontal" || disabledOverflow ? ForwardOverflow.INVALIDATE : ForwardOverflow.RESPONSIVE,
    ssr: "full",
    "data-menu-list": true,
    onVisibleChange: function onVisibleChange(newLastIndex) {
      setLastVisibleIndex(newLastIndex);
    },
    onKeyDown: onInternalKeyDown
  }, restProps));
  return /* @__PURE__ */ React.createElement(PrivateContext.Provider, {
    value: privateContext
  }, /* @__PURE__ */ React.createElement(IdContext.Provider, {
    value: uuid2
  }, /* @__PURE__ */ React.createElement(InheritableContextProvider, {
    prefixCls,
    mode: mergedMode,
    openKeys: mergedOpenKeys,
    rtl: isRtl,
    disabled,
    motion: mounted ? motion : null,
    defaultMotions: mounted ? defaultMotions : null,
    activeKey: mergedActiveKey,
    onActive,
    onInactive,
    selectedKeys: mergedSelectKeys,
    inlineIndent,
    subMenuOpenDelay,
    subMenuCloseDelay,
    forceSubMenuRender,
    builtinPlacements,
    triggerSubMenuAction,
    getPopupContainer: getInternalPopupContainer,
    itemIcon,
    expandIcon,
    onItemClick: onInternalClick,
    onOpenChange: onInternalOpenChange
  }, /* @__PURE__ */ React.createElement(PathUserContext.Provider, {
    value: pathUserContext
  }, container2), /* @__PURE__ */ React.createElement("div", {
    style: {
      display: "none"
    },
    "aria-hidden": true
  }, /* @__PURE__ */ React.createElement(PathRegisterContext.Provider, {
    value: registerPathContext
  }, childList)))));
};
var _excluded$3 = ["className", "title", "eventKey", "children"], _excluded2$1 = ["children"];
var InternalMenuItemGroup = function InternalMenuItemGroup2(_ref) {
  var className = _ref.className, title = _ref.title;
  _ref.eventKey;
  var children = _ref.children, restProps = _objectWithoutProperties(_ref, _excluded$3);
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls;
  var groupPrefixCls = "".concat(prefixCls, "-item-group");
  return /* @__PURE__ */ React.createElement("li", _extends$1({}, restProps, {
    onClick: function onClick(e2) {
      return e2.stopPropagation();
    },
    className: classNames(groupPrefixCls, className)
  }), /* @__PURE__ */ React.createElement("div", {
    className: "".concat(groupPrefixCls, "-title"),
    title: typeof title === "string" ? title : void 0
  }, title), /* @__PURE__ */ React.createElement("ul", {
    className: "".concat(groupPrefixCls, "-list")
  }, children));
};
function MenuItemGroup(_ref2) {
  var children = _ref2.children, props = _objectWithoutProperties(_ref2, _excluded2$1);
  var connectedKeyPath = useFullPath(props.eventKey);
  var childList = parseChildren(children, connectedKeyPath);
  var measure = useMeasure();
  if (measure) {
    return childList;
  }
  return /* @__PURE__ */ React.createElement(InternalMenuItemGroup, omit(props, ["warnKey"]), childList);
}
function Divider$2(_ref) {
  var className = _ref.className, style2 = _ref.style;
  var _React$useContext = React.useContext(MenuContext), prefixCls = _React$useContext.prefixCls;
  var measure = useMeasure();
  if (measure) {
    return null;
  }
  return /* @__PURE__ */ React.createElement("li", {
    className: classNames("".concat(prefixCls, "-item-divider"), className),
    style: style2
  });
}
var ExportMenu = Menu;
ExportMenu.Item = MenuItem;
ExportMenu.SubMenu = SubMenu;
ExportMenu.ItemGroup = MenuItemGroup;
ExportMenu.Divider = Divider$2;
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = React__default, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c2, a, k2) {
  var b2, d2 = {}, e2 = null, l2 = null;
  k2 !== void 0 && (e2 = "" + k2);
  a.key !== void 0 && (e2 = "" + a.key);
  a.ref !== void 0 && (l2 = a.ref);
  for (b2 in a)
    n.call(a, b2) && !p.hasOwnProperty(b2) && (d2[b2] = a[b2]);
  if (c2 && c2.defaultProps)
    for (b2 in a = c2.defaultProps, a)
      d2[b2] === void 0 && (d2[b2] = a[b2]);
  return { $$typeof: g, type: c2, key: e2, ref: l2, props: d2, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const jsxs = jsxRuntime.exports.jsxs;
var Checkbox = /* @__PURE__ */ function(_Component) {
  _inherits(Checkbox2, _Component);
  var _super = _createSuper(Checkbox2);
  function Checkbox2(props) {
    var _this;
    _classCallCheck(this, Checkbox2);
    _this = _super.call(this, props);
    _this.handleChange = function(e2) {
      var _this$props = _this.props, disabled = _this$props.disabled, onChange3 = _this$props.onChange;
      if (disabled) {
        return;
      }
      if (!("checked" in _this.props)) {
        _this.setState({
          checked: e2.target.checked
        });
      }
      if (onChange3) {
        onChange3({
          target: _objectSpread2$1(_objectSpread2$1({}, _this.props), {}, {
            checked: e2.target.checked
          }),
          stopPropagation: function stopPropagation() {
            e2.stopPropagation();
          },
          preventDefault: function preventDefault2() {
            e2.preventDefault();
          },
          nativeEvent: e2.nativeEvent
        });
      }
    };
    _this.saveInput = function(node) {
      _this.input = node;
    };
    var checked = "checked" in props ? props.checked : props.defaultChecked;
    _this.state = {
      checked
    };
    return _this;
  }
  _createClass(Checkbox2, [{
    key: "focus",
    value: function focus() {
      this.input.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.input.blur();
    }
  }, {
    key: "render",
    value: function render2() {
      var _classNames;
      var _this$props2 = this.props, prefixCls = _this$props2.prefixCls, className = _this$props2.className, style2 = _this$props2.style, name = _this$props2.name, id2 = _this$props2.id, type4 = _this$props2.type, disabled = _this$props2.disabled, readOnly = _this$props2.readOnly, tabIndex = _this$props2.tabIndex, onClick = _this$props2.onClick, onFocus2 = _this$props2.onFocus, onBlur2 = _this$props2.onBlur, onKeyDown2 = _this$props2.onKeyDown, onKeyPress2 = _this$props2.onKeyPress, onKeyUp2 = _this$props2.onKeyUp, autoFocus = _this$props2.autoFocus, value = _this$props2.value, required4 = _this$props2.required, others = _objectWithoutProperties(_this$props2, ["prefixCls", "className", "style", "name", "id", "type", "disabled", "readOnly", "tabIndex", "onClick", "onFocus", "onBlur", "onKeyDown", "onKeyPress", "onKeyUp", "autoFocus", "value", "required"]);
      var globalProps = Object.keys(others).reduce(function(prev, key) {
        if (key.substr(0, 5) === "aria-" || key.substr(0, 5) === "data-" || key === "role") {
          prev[key] = others[key];
        }
        return prev;
      }, {});
      var checked = this.state.checked;
      var classString = classNames(prefixCls, className, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-checked"), checked), _defineProperty$1(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
      return /* @__PURE__ */ jsxs("span", {
        className: classString,
        style: style2,
        children: [/* @__PURE__ */ jsx("input", __spreadValues({
          name,
          id: id2,
          type: type4,
          required: required4,
          readOnly,
          disabled,
          tabIndex,
          className: "".concat(prefixCls, "-input"),
          checked: !!checked,
          onClick,
          onFocus: onFocus2,
          onBlur: onBlur2,
          onKeyUp: onKeyUp2,
          onKeyDown: onKeyDown2,
          onKeyPress: onKeyPress2,
          onChange: this.handleChange,
          autoFocus,
          ref: this.saveInput,
          value
        }, globalProps)), /* @__PURE__ */ jsx("span", {
          className: "".concat(prefixCls, "-inner")
        })]
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if ("checked" in props) {
        return _objectSpread2$1(_objectSpread2$1({}, state), {}, {
          checked: props.checked
        });
      }
      return null;
    }
  }]);
  return Checkbox2;
}(Component);
Checkbox.defaultProps = {
  prefixCls: "rc-checkbox",
  className: "",
  style: {},
  type: "checkbox",
  defaultChecked: false,
  onFocus: function onFocus() {
  },
  onBlur: function onBlur() {
  },
  onChange: function onChange() {
  },
  onKeyDown: function onKeyDown() {
  },
  onKeyPress: function onKeyPress() {
  },
  onKeyUp: function onKeyUp() {
  }
};
var RadioGroupContext = /* @__PURE__ */ React.createContext(null);
var RadioGroupContextProvider = RadioGroupContext.Provider;
var RadioGroupContext$1 = RadioGroupContext;
var __rest$8 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var InternalRadio = function InternalRadio2(props, ref) {
  var _classNames;
  var context = React.useContext(RadioGroupContext$1);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var innerRef = React.useRef();
  var mergedRef = composeRef(ref, innerRef);
  React.useEffect(function() {
    devWarning(!("optionType" in props), "Radio", "`optionType` is only support in Radio.Group.");
  }, []);
  var onChange3 = function onChange4(e2) {
    var _a2, _b2;
    (_a2 = props.onChange) === null || _a2 === void 0 ? void 0 : _a2.call(props, e2);
    (_b2 = context === null || context === void 0 ? void 0 : context.onChange) === null || _b2 === void 0 ? void 0 : _b2.call(context, e2);
  };
  var customizePrefixCls = props.prefixCls, className = props.className, children = props.children, style2 = props.style, restProps = __rest$8(props, ["prefixCls", "className", "children", "style"]);
  var prefixCls = getPrefixCls("radio", customizePrefixCls);
  var radioProps = _extends$1({}, restProps);
  if (context) {
    radioProps.name = context.name;
    radioProps.onChange = onChange3;
    radioProps.checked = props.value === context.value;
    radioProps.disabled = props.disabled || context.disabled;
  }
  var wrapperClassString = classNames("".concat(prefixCls, "-wrapper"), (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-wrapper-checked"), radioProps.checked), _defineProperty$1(_classNames, "".concat(prefixCls, "-wrapper-disabled"), radioProps.disabled), _defineProperty$1(_classNames, "".concat(prefixCls, "-wrapper-rtl"), direction === "rtl"), _classNames), className);
  return /* @__PURE__ */ React.createElement("label", {
    className: wrapperClassString,
    style: style2,
    onMouseEnter: props.onMouseEnter,
    onMouseLeave: props.onMouseLeave
  }, /* @__PURE__ */ React.createElement(Checkbox, _extends$1({}, radioProps, {
    type: "radio",
    prefixCls,
    ref: mergedRef
  })), children !== void 0 ? /* @__PURE__ */ React.createElement("span", null, children) : null);
};
var Radio$2 = /* @__PURE__ */ React.forwardRef(InternalRadio);
Radio$2.displayName = "Radio";
var InternalRadio$1 = Radio$2;
var RadioGroup = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var size = React.useContext(SizeContext$1);
  var _useMergedState = useControlledState(props.defaultValue, {
    value: props.value
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), value = _useMergedState2[0], setValue2 = _useMergedState2[1];
  var onRadioChange = function onRadioChange2(ev) {
    var lastValue = value;
    var val = ev.target.value;
    if (!("value" in props)) {
      setValue2(val);
    }
    var onChange3 = props.onChange;
    if (onChange3 && val !== lastValue) {
      onChange3(ev);
    }
  };
  var renderGroup = function renderGroup2() {
    var _classNames;
    var customizePrefixCls = props.prefixCls, _props$className = props.className, className = _props$className === void 0 ? "" : _props$className, options = props.options, optionType = props.optionType, _props$buttonStyle = props.buttonStyle, buttonStyle = _props$buttonStyle === void 0 ? "outline" : _props$buttonStyle, disabled = props.disabled, children = props.children, customizeSize = props.size, style2 = props.style, id2 = props.id, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave;
    var prefixCls = getPrefixCls("radio", customizePrefixCls);
    var groupPrefixCls = "".concat(prefixCls, "-group");
    var childrenToRender = children;
    if (options && options.length > 0) {
      var optionsPrefixCls = optionType === "button" ? "".concat(prefixCls, "-button") : prefixCls;
      childrenToRender = options.map(function(option) {
        if (typeof option === "string" || typeof option === "number") {
          return /* @__PURE__ */ React.createElement(InternalRadio$1, {
            key: option.toString(),
            prefixCls: optionsPrefixCls,
            disabled,
            value: option,
            checked: value === option
          }, option);
        }
        return /* @__PURE__ */ React.createElement(InternalRadio$1, {
          key: "radio-group-value-options-".concat(option.value),
          prefixCls: optionsPrefixCls,
          disabled: option.disabled || disabled,
          value: option.value,
          checked: value === option.value,
          style: option.style
        }, option.label);
      });
    }
    var mergedSize = customizeSize || size;
    var classString = classNames(groupPrefixCls, "".concat(groupPrefixCls, "-").concat(buttonStyle), (_classNames = {}, _defineProperty$1(_classNames, "".concat(groupPrefixCls, "-").concat(mergedSize), mergedSize), _defineProperty$1(_classNames, "".concat(groupPrefixCls, "-rtl"), direction === "rtl"), _classNames), className);
    return /* @__PURE__ */ React.createElement("div", _extends$1({}, getDataOrAriaProps(props), {
      className: classString,
      style: style2,
      onMouseEnter,
      onMouseLeave,
      id: id2,
      ref
    }), childrenToRender);
  };
  return /* @__PURE__ */ React.createElement(RadioGroupContextProvider, {
    value: {
      onChange: onRadioChange,
      value,
      disabled: props.disabled,
      name: props.name
    }
  }, renderGroup());
});
var Group = /* @__PURE__ */ React.memo(RadioGroup);
var __rest$7 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var RadioButton = function RadioButton2(props, ref) {
  var radioGroupContext = React.useContext(RadioGroupContext$1);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var customizePrefixCls = props.prefixCls, radioProps = __rest$7(props, ["prefixCls"]);
  var prefixCls = getPrefixCls("radio-button", customizePrefixCls);
  if (radioGroupContext) {
    radioProps.checked = props.value === radioGroupContext.value;
    radioProps.disabled = props.disabled || radioGroupContext.disabled;
  }
  return /* @__PURE__ */ React.createElement(InternalRadio$1, _extends$1({
    prefixCls
  }, radioProps, {
    type: "radio",
    ref
  }));
};
var Button = /* @__PURE__ */ React.forwardRef(RadioButton);
var Radio = InternalRadio$1;
Radio.Button = Button;
Radio.Group = Group;
var Radio$1 = Radio;
function useRaf(callback) {
  var rafRef = useRef();
  var removedRef = useRef(false);
  function trigger2() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    if (!removedRef.current) {
      wrapperRaf$1.cancel(rafRef.current);
      rafRef.current = wrapperRaf$1(function() {
        callback.apply(void 0, args);
      });
    }
  }
  useEffect(function() {
    return function() {
      removedRef.current = true;
      wrapperRaf$1.cancel(rafRef.current);
    };
  }, []);
  return trigger2;
}
function useRafState(defaultState) {
  var batchRef = useRef([]);
  var _useState = useState({}), _useState2 = _slicedToArray(_useState, 2), forceUpdate = _useState2[1];
  var state = useRef(typeof defaultState === "function" ? defaultState() : defaultState);
  var flushUpdate = useRaf(function() {
    var current = state.current;
    batchRef.current.forEach(function(callback) {
      current = callback(current);
    });
    batchRef.current = [];
    state.current = current;
    forceUpdate({});
  });
  function updater(callback) {
    batchRef.current.push(callback);
    flushUpdate();
  }
  return [state.current, updater];
}
function TabNode(_ref, ref) {
  var _classNames;
  var prefixCls = _ref.prefixCls, id2 = _ref.id, active = _ref.active, _ref$tab = _ref.tab, key = _ref$tab.key, tab = _ref$tab.tab, disabled = _ref$tab.disabled, closeIcon = _ref$tab.closeIcon, closable = _ref.closable, renderWrapper = _ref.renderWrapper, removeAriaLabel = _ref.removeAriaLabel, editable = _ref.editable, onClick = _ref.onClick, onRemove = _ref.onRemove, onFocus2 = _ref.onFocus, style2 = _ref.style;
  var tabPrefix = "".concat(prefixCls, "-tab");
  React.useEffect(function() {
    return onRemove;
  }, []);
  var removable = editable && closable !== false && !disabled;
  function onInternalClick(e2) {
    if (disabled) {
      return;
    }
    onClick(e2);
  }
  function onRemoveTab(event) {
    event.preventDefault();
    event.stopPropagation();
    editable.onEdit("remove", {
      key,
      event
    });
  }
  var node = /* @__PURE__ */ React.createElement("div", {
    key,
    ref,
    className: classNames(tabPrefix, (_classNames = {}, _defineProperty$1(_classNames, "".concat(tabPrefix, "-with-remove"), removable), _defineProperty$1(_classNames, "".concat(tabPrefix, "-active"), active), _defineProperty$1(_classNames, "".concat(tabPrefix, "-disabled"), disabled), _classNames)),
    style: style2,
    onClick: onInternalClick
  }, /* @__PURE__ */ React.createElement("div", {
    role: "tab",
    "aria-selected": active,
    id: id2 && "".concat(id2, "-tab-").concat(key),
    className: "".concat(tabPrefix, "-btn"),
    "aria-controls": id2 && "".concat(id2, "-panel-").concat(key),
    "aria-disabled": disabled,
    tabIndex: disabled ? null : 0,
    onClick: function onClick2(e2) {
      e2.stopPropagation();
      onInternalClick(e2);
    },
    onKeyDown: function onKeyDown2(e2) {
      if ([KeyCode.SPACE, KeyCode.ENTER].includes(e2.which)) {
        e2.preventDefault();
        onInternalClick(e2);
      }
    },
    onFocus: onFocus2
  }, tab), removable && /* @__PURE__ */ React.createElement("button", {
    type: "button",
    "aria-label": removeAriaLabel || "remove",
    tabIndex: 0,
    className: "".concat(tabPrefix, "-remove"),
    onClick: function onClick2(e2) {
      e2.stopPropagation();
      onRemoveTab(e2);
    }
  }, closeIcon || editable.removeIcon || "\xD7"));
  return renderWrapper ? renderWrapper(node) : node;
}
var TabNode$1 = /* @__PURE__ */ React.forwardRef(TabNode);
var DEFAULT_SIZE$1 = {
  width: 0,
  height: 0,
  left: 0,
  top: 0
};
function useOffsets(tabs, tabSizes, holderScrollWidth) {
  return useMemo$1(function() {
    var _tabs$;
    var map2 = /* @__PURE__ */ new Map();
    var lastOffset = tabSizes.get((_tabs$ = tabs[0]) === null || _tabs$ === void 0 ? void 0 : _tabs$.key) || DEFAULT_SIZE$1;
    var rightOffset = lastOffset.left + lastOffset.width;
    for (var i = 0; i < tabs.length; i += 1) {
      var key = tabs[i].key;
      var data = tabSizes.get(key);
      if (!data) {
        var _tabs;
        data = tabSizes.get((_tabs = tabs[i - 1]) === null || _tabs === void 0 ? void 0 : _tabs.key) || DEFAULT_SIZE$1;
      }
      var entity = map2.get(key) || _objectSpread2$1({}, data);
      entity.right = rightOffset - entity.left - entity.width;
      map2.set(key, entity);
    }
    return map2;
  }, [tabs.map(function(tab) {
    return tab.key;
  }).join("_"), tabSizes, holderScrollWidth]);
}
var DEFAULT_SIZE = {
  width: 0,
  height: 0,
  left: 0,
  top: 0,
  right: 0
};
function useVisibleRange(tabOffsets, containerSize, tabContentNodeSize, addNodeSize, _ref) {
  var tabs = _ref.tabs, tabPosition = _ref.tabPosition, rtl = _ref.rtl;
  var unit;
  var position2;
  var transformSize;
  if (["top", "bottom"].includes(tabPosition)) {
    unit = "width";
    position2 = rtl ? "right" : "left";
    transformSize = Math.abs(containerSize.left);
  } else {
    unit = "height";
    position2 = "top";
    transformSize = -containerSize.top;
  }
  var basicSize = containerSize[unit];
  var tabContentSize = tabContentNodeSize[unit];
  var addSize = addNodeSize[unit];
  var mergedBasicSize = basicSize;
  if (tabContentSize + addSize > basicSize && tabContentSize < basicSize) {
    mergedBasicSize = basicSize - addSize;
  }
  return useMemo$1(function() {
    if (!tabs.length) {
      return [0, 0];
    }
    var len2 = tabs.length;
    var endIndex = len2;
    for (var i = 0; i < len2; i += 1) {
      var offset2 = tabOffsets.get(tabs[i].key) || DEFAULT_SIZE;
      if (offset2[position2] + offset2[unit] > transformSize + mergedBasicSize) {
        endIndex = i - 1;
        break;
      }
    }
    var startIndex = 0;
    for (var _i = len2 - 1; _i >= 0; _i -= 1) {
      var _offset = tabOffsets.get(tabs[_i].key) || DEFAULT_SIZE;
      if (_offset[position2] < transformSize) {
        startIndex = _i + 1;
        break;
      }
    }
    return [startIndex, endIndex];
  }, [tabOffsets, transformSize, mergedBasicSize, tabPosition, tabs.map(function(tab) {
    return tab.key;
  }).join("_"), rtl]);
}
function AddButton(_ref, ref) {
  var prefixCls = _ref.prefixCls, editable = _ref.editable, locale2 = _ref.locale, style2 = _ref.style;
  if (!editable || editable.showAdd === false) {
    return null;
  }
  return /* @__PURE__ */ React.createElement("button", {
    ref,
    type: "button",
    className: "".concat(prefixCls, "-nav-add"),
    style: style2,
    "aria-label": (locale2 === null || locale2 === void 0 ? void 0 : locale2.addAriaLabel) || "Add tab",
    onClick: function onClick(event) {
      editable.onEdit("add", {
        event
      });
    }
  }, editable.addIcon || "+");
}
var AddButton$1 = /* @__PURE__ */ React.forwardRef(AddButton);
function OperationNode(_ref, ref) {
  var prefixCls = _ref.prefixCls, id2 = _ref.id, tabs = _ref.tabs, locale2 = _ref.locale, mobile = _ref.mobile, _ref$moreIcon = _ref.moreIcon, moreIcon = _ref$moreIcon === void 0 ? "More" : _ref$moreIcon, moreTransitionName = _ref.moreTransitionName, style2 = _ref.style, className = _ref.className, editable = _ref.editable, tabBarGutter = _ref.tabBarGutter, rtl = _ref.rtl, removeAriaLabel = _ref.removeAriaLabel, onTabClick = _ref.onTabClick;
  var _useState = useState(false), _useState2 = _slicedToArray(_useState, 2), open = _useState2[0], setOpen = _useState2[1];
  var _useState3 = useState(null), _useState4 = _slicedToArray(_useState3, 2), selectedKey = _useState4[0], setSelectedKey = _useState4[1];
  var popupId = "".concat(id2, "-more-popup");
  var dropdownPrefix = "".concat(prefixCls, "-dropdown");
  var selectedItemId = selectedKey !== null ? "".concat(popupId, "-").concat(selectedKey) : null;
  var dropdownAriaLabel = locale2 === null || locale2 === void 0 ? void 0 : locale2.dropdownAriaLabel;
  function onRemoveTab(event, key) {
    event.preventDefault();
    event.stopPropagation();
    editable.onEdit("remove", {
      key,
      event
    });
  }
  var menu = /* @__PURE__ */ React.createElement(ExportMenu, {
    onClick: function onClick(_ref2) {
      var key = _ref2.key, domEvent = _ref2.domEvent;
      onTabClick(key, domEvent);
      setOpen(false);
    },
    id: popupId,
    tabIndex: -1,
    role: "listbox",
    "aria-activedescendant": selectedItemId,
    selectedKeys: [selectedKey],
    "aria-label": dropdownAriaLabel !== void 0 ? dropdownAriaLabel : "expanded dropdown"
  }, tabs.map(function(tab) {
    var removable = editable && tab.closable !== false && !tab.disabled;
    return /* @__PURE__ */ React.createElement(MenuItem, {
      key: tab.key,
      id: "".concat(popupId, "-").concat(tab.key),
      role: "option",
      "aria-controls": id2 && "".concat(id2, "-panel-").concat(tab.key),
      disabled: tab.disabled
    }, /* @__PURE__ */ React.createElement("span", null, tab.tab), removable && /* @__PURE__ */ React.createElement("button", {
      type: "button",
      "aria-label": removeAriaLabel || "remove",
      tabIndex: 0,
      className: "".concat(dropdownPrefix, "-menu-item-remove"),
      onClick: function onClick(e2) {
        e2.stopPropagation();
        onRemoveTab(e2, tab.key);
      }
    }, tab.closeIcon || editable.removeIcon || "\xD7"));
  }));
  function selectOffset(offset2) {
    var enabledTabs = tabs.filter(function(tab2) {
      return !tab2.disabled;
    });
    var selectedIndex = enabledTabs.findIndex(function(tab2) {
      return tab2.key === selectedKey;
    }) || 0;
    var len2 = enabledTabs.length;
    for (var i = 0; i < len2; i += 1) {
      selectedIndex = (selectedIndex + offset2 + len2) % len2;
      var tab = enabledTabs[selectedIndex];
      if (!tab.disabled) {
        setSelectedKey(tab.key);
        return;
      }
    }
  }
  function onKeyDown2(e2) {
    var which = e2.which;
    if (!open) {
      if ([KeyCode.DOWN, KeyCode.SPACE, KeyCode.ENTER].includes(which)) {
        setOpen(true);
        e2.preventDefault();
      }
      return;
    }
    switch (which) {
      case KeyCode.UP:
        selectOffset(-1);
        e2.preventDefault();
        break;
      case KeyCode.DOWN:
        selectOffset(1);
        e2.preventDefault();
        break;
      case KeyCode.ESC:
        setOpen(false);
        break;
      case KeyCode.SPACE:
      case KeyCode.ENTER:
        if (selectedKey !== null)
          onTabClick(selectedKey, e2);
        break;
    }
  }
  useEffect(function() {
    var ele = document.getElementById(selectedItemId);
    if (ele && ele.scrollIntoView) {
      ele.scrollIntoView(false);
    }
  }, [selectedKey]);
  useEffect(function() {
    if (!open) {
      setSelectedKey(null);
    }
  }, [open]);
  var moreStyle = _defineProperty$1({}, rtl ? "marginRight" : "marginLeft", tabBarGutter);
  if (!tabs.length) {
    moreStyle.visibility = "hidden";
    moreStyle.order = 1;
  }
  var overlayClassName = classNames(_defineProperty$1({}, "".concat(dropdownPrefix, "-rtl"), rtl));
  var moreNode = mobile ? null : /* @__PURE__ */ React.createElement(Dropdown$1, {
    prefixCls: dropdownPrefix,
    overlay: menu,
    trigger: ["hover"],
    visible: open,
    transitionName: moreTransitionName,
    onVisibleChange: setOpen,
    overlayClassName,
    mouseEnterDelay: 0.1,
    mouseLeaveDelay: 0.1
  }, /* @__PURE__ */ React.createElement("button", {
    type: "button",
    className: "".concat(prefixCls, "-nav-more"),
    style: moreStyle,
    tabIndex: -1,
    "aria-hidden": "true",
    "aria-haspopup": "listbox",
    "aria-controls": popupId,
    id: "".concat(id2, "-more"),
    "aria-expanded": open,
    onKeyDown: onKeyDown2
  }, moreIcon));
  return /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-nav-operations"), className),
    style: style2,
    ref
  }, moreNode, /* @__PURE__ */ React.createElement(AddButton$1, {
    prefixCls,
    locale: locale2,
    editable
  }));
}
var OperationNode$1 = /* @__PURE__ */ React.memo(/* @__PURE__ */ React.forwardRef(OperationNode), function(_, next) {
  return next.tabMoving;
});
var TabContext = /* @__PURE__ */ createContext(null);
var MIN_SWIPE_DISTANCE = 0.1;
var STOP_SWIPE_DISTANCE = 0.01;
var REFRESH_INTERVAL = 20;
var SPEED_OFF_MULTIPLE = Math.pow(0.995, REFRESH_INTERVAL);
function useTouchMove(ref, onOffset) {
  var _useState = useState(), _useState2 = _slicedToArray(_useState, 2), touchPosition = _useState2[0], setTouchPosition = _useState2[1];
  var _useState3 = useState(0), _useState4 = _slicedToArray(_useState3, 2), lastTimestamp = _useState4[0], setLastTimestamp = _useState4[1];
  var _useState5 = useState(0), _useState6 = _slicedToArray(_useState5, 2), lastTimeDiff = _useState6[0], setLastTimeDiff = _useState6[1];
  var _useState7 = useState(), _useState8 = _slicedToArray(_useState7, 2), lastOffset = _useState8[0], setLastOffset = _useState8[1];
  var motionRef = useRef();
  function onTouchStart(e2) {
    var _e$touches$ = e2.touches[0], screenX = _e$touches$.screenX, screenY = _e$touches$.screenY;
    setTouchPosition({
      x: screenX,
      y: screenY
    });
    window.clearInterval(motionRef.current);
  }
  function onTouchMove(e2) {
    if (!touchPosition)
      return;
    e2.preventDefault();
    var _e$touches$2 = e2.touches[0], screenX = _e$touches$2.screenX, screenY = _e$touches$2.screenY;
    setTouchPosition({
      x: screenX,
      y: screenY
    });
    var offsetX = screenX - touchPosition.x;
    var offsetY = screenY - touchPosition.y;
    onOffset(offsetX, offsetY);
    var now2 = Date.now();
    setLastTimestamp(now2);
    setLastTimeDiff(now2 - lastTimestamp);
    setLastOffset({
      x: offsetX,
      y: offsetY
    });
  }
  function onTouchEnd() {
    if (!touchPosition)
      return;
    setTouchPosition(null);
    setLastOffset(null);
    if (lastOffset) {
      var distanceX = lastOffset.x / lastTimeDiff;
      var distanceY = lastOffset.y / lastTimeDiff;
      var absX = Math.abs(distanceX);
      var absY = Math.abs(distanceY);
      if (Math.max(absX, absY) < MIN_SWIPE_DISTANCE)
        return;
      var currentX = distanceX;
      var currentY = distanceY;
      motionRef.current = window.setInterval(function() {
        if (Math.abs(currentX) < STOP_SWIPE_DISTANCE && Math.abs(currentY) < STOP_SWIPE_DISTANCE) {
          window.clearInterval(motionRef.current);
          return;
        }
        currentX *= SPEED_OFF_MULTIPLE;
        currentY *= SPEED_OFF_MULTIPLE;
        onOffset(currentX * REFRESH_INTERVAL, currentY * REFRESH_INTERVAL);
      }, REFRESH_INTERVAL);
    }
  }
  var lastWheelDirectionRef = useRef();
  function onWheel(e2) {
    var deltaX = e2.deltaX, deltaY = e2.deltaY;
    var mixed = 0;
    var absX = Math.abs(deltaX);
    var absY = Math.abs(deltaY);
    if (absX === absY) {
      mixed = lastWheelDirectionRef.current === "x" ? deltaX : deltaY;
    } else if (absX > absY) {
      mixed = deltaX;
      lastWheelDirectionRef.current = "x";
    } else {
      mixed = deltaY;
      lastWheelDirectionRef.current = "y";
    }
    if (onOffset(-mixed, -mixed)) {
      e2.preventDefault();
    }
  }
  var touchEventsRef = useRef(null);
  touchEventsRef.current = {
    onTouchStart,
    onTouchMove,
    onTouchEnd,
    onWheel
  };
  React.useEffect(function() {
    function onProxyTouchStart(e2) {
      touchEventsRef.current.onTouchStart(e2);
    }
    function onProxyTouchMove(e2) {
      touchEventsRef.current.onTouchMove(e2);
    }
    function onProxyTouchEnd(e2) {
      touchEventsRef.current.onTouchEnd(e2);
    }
    function onProxyWheel(e2) {
      touchEventsRef.current.onWheel(e2);
    }
    document.addEventListener("touchmove", onProxyTouchMove, {
      passive: false
    });
    document.addEventListener("touchend", onProxyTouchEnd, {
      passive: false
    });
    ref.current.addEventListener("touchstart", onProxyTouchStart, {
      passive: false
    });
    ref.current.addEventListener("wheel", onProxyWheel);
    return function() {
      document.removeEventListener("touchmove", onProxyTouchMove);
      document.removeEventListener("touchend", onProxyTouchEnd);
    };
  }, []);
}
function useRefs() {
  var cacheRefs = useRef(/* @__PURE__ */ new Map());
  function getRef(key) {
    if (!cacheRefs.current.has(key)) {
      cacheRefs.current.set(key, /* @__PURE__ */ React.createRef());
    }
    return cacheRefs.current.get(key);
  }
  function removeRef(key) {
    cacheRefs.current.delete(key);
  }
  return [getRef, removeRef];
}
function useSyncState(defaultState, onChange3) {
  var stateRef = React.useRef(defaultState);
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray(_React$useState, 2), forceUpdate = _React$useState2[1];
  function setState(updater) {
    var newValue = typeof updater === "function" ? updater(stateRef.current) : updater;
    if (newValue !== stateRef.current) {
      onChange3(newValue, stateRef.current);
    }
    stateRef.current = newValue;
    forceUpdate({});
  }
  return [stateRef.current, setState];
}
var ExtraContent = function ExtraContent2(_ref) {
  var position2 = _ref.position, prefixCls = _ref.prefixCls, extra = _ref.extra;
  if (!extra)
    return null;
  var content;
  var assertExtra = {};
  if (extra && _typeof$1(extra) === "object" && !/* @__PURE__ */ React.isValidElement(extra)) {
    assertExtra = extra;
  } else {
    assertExtra.right = extra;
  }
  if (position2 === "right") {
    content = assertExtra.right;
  }
  if (position2 === "left") {
    content = assertExtra.left;
  }
  return content ? /* @__PURE__ */ React.createElement("div", {
    className: "".concat(prefixCls, "-extra-content")
  }, content) : null;
};
function TabNavList(props, ref) {
  var _classNames;
  var _React$useContext = React.useContext(TabContext), prefixCls = _React$useContext.prefixCls, tabs = _React$useContext.tabs;
  var className = props.className, style2 = props.style, id2 = props.id, animated = props.animated, activeKey = props.activeKey, rtl = props.rtl, extra = props.extra, editable = props.editable, locale2 = props.locale, tabPosition = props.tabPosition, tabBarGutter = props.tabBarGutter, children = props.children, onTabClick = props.onTabClick, onTabScroll = props.onTabScroll;
  var tabsWrapperRef = useRef();
  var tabListRef = useRef();
  var operationsRef = useRef();
  var innerAddButtonRef = useRef();
  var _useRefs = useRefs(), _useRefs2 = _slicedToArray(_useRefs, 2), getBtnRef = _useRefs2[0], removeBtnRef = _useRefs2[1];
  var tabPositionTopOrBottom = tabPosition === "top" || tabPosition === "bottom";
  var _useSyncState = useSyncState(0, function(next, prev) {
    if (tabPositionTopOrBottom && onTabScroll) {
      onTabScroll({
        direction: next > prev ? "left" : "right"
      });
    }
  }), _useSyncState2 = _slicedToArray(_useSyncState, 2), transformLeft = _useSyncState2[0], setTransformLeft = _useSyncState2[1];
  var _useSyncState3 = useSyncState(0, function(next, prev) {
    if (!tabPositionTopOrBottom && onTabScroll) {
      onTabScroll({
        direction: next > prev ? "top" : "bottom"
      });
    }
  }), _useSyncState4 = _slicedToArray(_useSyncState3, 2), transformTop = _useSyncState4[0], setTransformTop = _useSyncState4[1];
  var _useState = useState(0), _useState2 = _slicedToArray(_useState, 2), wrapperScrollWidth = _useState2[0], setWrapperScrollWidth = _useState2[1];
  var _useState3 = useState(0), _useState4 = _slicedToArray(_useState3, 2), wrapperScrollHeight = _useState4[0], setWrapperScrollHeight = _useState4[1];
  var _useState5 = useState(null), _useState6 = _slicedToArray(_useState5, 2), wrapperWidth = _useState6[0], setWrapperWidth = _useState6[1];
  var _useState7 = useState(null), _useState8 = _slicedToArray(_useState7, 2), wrapperHeight = _useState8[0], setWrapperHeight = _useState8[1];
  var _useState9 = useState(0), _useState10 = _slicedToArray(_useState9, 2), addWidth = _useState10[0], setAddWidth = _useState10[1];
  var _useState11 = useState(0), _useState12 = _slicedToArray(_useState11, 2), addHeight = _useState12[0], setAddHeight = _useState12[1];
  var _useRafState = useRafState(/* @__PURE__ */ new Map()), _useRafState2 = _slicedToArray(_useRafState, 2), tabSizes = _useRafState2[0], setTabSizes = _useRafState2[1];
  var tabOffsets = useOffsets(tabs, tabSizes, wrapperScrollWidth);
  var operationsHiddenClassName = "".concat(prefixCls, "-nav-operations-hidden");
  var transformMin = 0;
  var transformMax = 0;
  if (!tabPositionTopOrBottom) {
    transformMin = Math.min(0, wrapperHeight - wrapperScrollHeight);
    transformMax = 0;
  } else if (rtl) {
    transformMin = 0;
    transformMax = Math.max(0, wrapperScrollWidth - wrapperWidth);
  } else {
    transformMin = Math.min(0, wrapperWidth - wrapperScrollWidth);
    transformMax = 0;
  }
  function alignInRange(value) {
    if (value < transformMin) {
      return transformMin;
    }
    if (value > transformMax) {
      return transformMax;
    }
    return value;
  }
  var touchMovingRef = useRef();
  var _useState13 = useState(), _useState14 = _slicedToArray(_useState13, 2), lockAnimation = _useState14[0], setLockAnimation = _useState14[1];
  function doLockAnimation() {
    setLockAnimation(Date.now());
  }
  function clearTouchMoving() {
    window.clearTimeout(touchMovingRef.current);
  }
  useTouchMove(tabsWrapperRef, function(offsetX, offsetY) {
    function doMove(setState, offset2) {
      setState(function(value) {
        var newValue = alignInRange(value + offset2);
        return newValue;
      });
    }
    if (tabPositionTopOrBottom) {
      if (wrapperWidth >= wrapperScrollWidth) {
        return false;
      }
      doMove(setTransformLeft, offsetX);
    } else {
      if (wrapperHeight >= wrapperScrollHeight) {
        return false;
      }
      doMove(setTransformTop, offsetY);
    }
    clearTouchMoving();
    doLockAnimation();
    return true;
  });
  useEffect(function() {
    clearTouchMoving();
    if (lockAnimation) {
      touchMovingRef.current = window.setTimeout(function() {
        setLockAnimation(0);
      }, 100);
    }
    return clearTouchMoving;
  }, [lockAnimation]);
  function scrollToTab() {
    var key = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : activeKey;
    var tabOffset = tabOffsets.get(key) || {
      width: 0,
      height: 0,
      left: 0,
      right: 0,
      top: 0
    };
    if (tabPositionTopOrBottom) {
      var newTransform = transformLeft;
      if (rtl) {
        if (tabOffset.right < transformLeft) {
          newTransform = tabOffset.right;
        } else if (tabOffset.right + tabOffset.width > transformLeft + wrapperWidth) {
          newTransform = tabOffset.right + tabOffset.width - wrapperWidth;
        }
      } else if (tabOffset.left < -transformLeft) {
        newTransform = -tabOffset.left;
      } else if (tabOffset.left + tabOffset.width > -transformLeft + wrapperWidth) {
        newTransform = -(tabOffset.left + tabOffset.width - wrapperWidth);
      }
      setTransformTop(0);
      setTransformLeft(alignInRange(newTransform));
    } else {
      var _newTransform = transformTop;
      if (tabOffset.top < -transformTop) {
        _newTransform = -tabOffset.top;
      } else if (tabOffset.top + tabOffset.height > -transformTop + wrapperHeight) {
        _newTransform = -(tabOffset.top + tabOffset.height - wrapperHeight);
      }
      setTransformLeft(0);
      setTransformTop(alignInRange(_newTransform));
    }
  }
  var _useVisibleRange = useVisibleRange(tabOffsets, {
    width: wrapperWidth,
    height: wrapperHeight,
    left: transformLeft,
    top: transformTop
  }, {
    width: wrapperScrollWidth,
    height: wrapperScrollHeight
  }, {
    width: addWidth,
    height: addHeight
  }, _objectSpread2$1(_objectSpread2$1({}, props), {}, {
    tabs
  })), _useVisibleRange2 = _slicedToArray(_useVisibleRange, 2), visibleStart = _useVisibleRange2[0], visibleEnd = _useVisibleRange2[1];
  var tabNodeStyle = {};
  if (tabPosition === "top" || tabPosition === "bottom") {
    tabNodeStyle[rtl ? "marginRight" : "marginLeft"] = tabBarGutter;
  } else {
    tabNodeStyle.marginTop = tabBarGutter;
  }
  var tabNodes = tabs.map(function(tab, i) {
    var key = tab.key;
    return /* @__PURE__ */ React.createElement(TabNode$1, {
      id: id2,
      prefixCls,
      key,
      tab,
      style: i === 0 ? void 0 : tabNodeStyle,
      closable: tab.closable,
      editable,
      active: key === activeKey,
      renderWrapper: children,
      removeAriaLabel: locale2 === null || locale2 === void 0 ? void 0 : locale2.removeAriaLabel,
      ref: getBtnRef(key),
      onClick: function onClick(e2) {
        onTabClick(key, e2);
      },
      onRemove: function onRemove() {
        removeBtnRef(key);
      },
      onFocus: function onFocus2() {
        scrollToTab(key);
        doLockAnimation();
        if (!tabsWrapperRef.current) {
          return;
        }
        if (!rtl) {
          tabsWrapperRef.current.scrollLeft = 0;
        }
        tabsWrapperRef.current.scrollTop = 0;
      }
    });
  });
  var onListHolderResize = useRaf(function() {
    var _tabsWrapperRef$curre, _tabsWrapperRef$curre2, _innerAddButtonRef$cu, _innerAddButtonRef$cu2, _tabListRef$current, _tabListRef$current2;
    var offsetWidth = ((_tabsWrapperRef$curre = tabsWrapperRef.current) === null || _tabsWrapperRef$curre === void 0 ? void 0 : _tabsWrapperRef$curre.offsetWidth) || 0;
    var offsetHeight = ((_tabsWrapperRef$curre2 = tabsWrapperRef.current) === null || _tabsWrapperRef$curre2 === void 0 ? void 0 : _tabsWrapperRef$curre2.offsetHeight) || 0;
    var newAddWidth = ((_innerAddButtonRef$cu = innerAddButtonRef.current) === null || _innerAddButtonRef$cu === void 0 ? void 0 : _innerAddButtonRef$cu.offsetWidth) || 0;
    var newAddHeight = ((_innerAddButtonRef$cu2 = innerAddButtonRef.current) === null || _innerAddButtonRef$cu2 === void 0 ? void 0 : _innerAddButtonRef$cu2.offsetHeight) || 0;
    setWrapperWidth(offsetWidth);
    setWrapperHeight(offsetHeight);
    setAddWidth(newAddWidth);
    setAddHeight(newAddHeight);
    var newWrapperScrollWidth = (((_tabListRef$current = tabListRef.current) === null || _tabListRef$current === void 0 ? void 0 : _tabListRef$current.offsetWidth) || 0) - newAddWidth;
    var newWrapperScrollHeight = (((_tabListRef$current2 = tabListRef.current) === null || _tabListRef$current2 === void 0 ? void 0 : _tabListRef$current2.offsetHeight) || 0) - newAddHeight;
    setWrapperScrollWidth(newWrapperScrollWidth);
    setWrapperScrollHeight(newWrapperScrollHeight);
    setTabSizes(function() {
      var newSizes = /* @__PURE__ */ new Map();
      tabs.forEach(function(_ref2) {
        var key = _ref2.key;
        var btnNode = getBtnRef(key).current;
        if (btnNode) {
          newSizes.set(key, {
            width: btnNode.offsetWidth,
            height: btnNode.offsetHeight,
            left: btnNode.offsetLeft,
            top: btnNode.offsetTop
          });
        }
      });
      return newSizes;
    });
  });
  var startHiddenTabs = tabs.slice(0, visibleStart);
  var endHiddenTabs = tabs.slice(visibleEnd + 1);
  var hiddenTabs = [].concat(_toConsumableArray(startHiddenTabs), _toConsumableArray(endHiddenTabs));
  var _useState15 = useState(), _useState16 = _slicedToArray(_useState15, 2), inkStyle = _useState16[0], setInkStyle = _useState16[1];
  var activeTabOffset = tabOffsets.get(activeKey);
  var inkBarRafRef = useRef();
  function cleanInkBarRaf() {
    wrapperRaf$1.cancel(inkBarRafRef.current);
  }
  useEffect(function() {
    var newInkStyle = {};
    if (activeTabOffset) {
      if (tabPositionTopOrBottom) {
        if (rtl) {
          newInkStyle.right = activeTabOffset.right;
        } else {
          newInkStyle.left = activeTabOffset.left;
        }
        newInkStyle.width = activeTabOffset.width;
      } else {
        newInkStyle.top = activeTabOffset.top;
        newInkStyle.height = activeTabOffset.height;
      }
    }
    cleanInkBarRaf();
    inkBarRafRef.current = wrapperRaf$1(function() {
      setInkStyle(newInkStyle);
    });
    return cleanInkBarRaf;
  }, [activeTabOffset, tabPositionTopOrBottom, rtl]);
  useEffect(function() {
    scrollToTab();
  }, [activeKey, activeTabOffset, tabOffsets, tabPositionTopOrBottom]);
  useEffect(function() {
    onListHolderResize();
  }, [rtl, tabBarGutter, activeKey, tabs.map(function(tab) {
    return tab.key;
  }).join("_")]);
  var hasDropdown = !!hiddenTabs.length;
  var wrapPrefix = "".concat(prefixCls, "-nav-wrap");
  var pingLeft;
  var pingRight;
  var pingTop;
  var pingBottom;
  if (tabPositionTopOrBottom) {
    if (rtl) {
      pingRight = transformLeft > 0;
      pingLeft = transformLeft + wrapperWidth < wrapperScrollWidth;
    } else {
      pingLeft = transformLeft < 0;
      pingRight = -transformLeft + wrapperWidth < wrapperScrollWidth;
    }
  } else {
    pingTop = transformTop < 0;
    pingBottom = -transformTop + wrapperHeight < wrapperScrollHeight;
  }
  return /* @__PURE__ */ React.createElement("div", {
    ref,
    role: "tablist",
    className: classNames("".concat(prefixCls, "-nav"), className),
    style: style2,
    onKeyDown: function onKeyDown2() {
      doLockAnimation();
    }
  }, /* @__PURE__ */ React.createElement(ExtraContent, {
    position: "left",
    extra,
    prefixCls
  }), /* @__PURE__ */ React.createElement(ResizeObserver, {
    onResize: onListHolderResize
  }, /* @__PURE__ */ React.createElement("div", {
    className: classNames(wrapPrefix, (_classNames = {}, _defineProperty$1(_classNames, "".concat(wrapPrefix, "-ping-left"), pingLeft), _defineProperty$1(_classNames, "".concat(wrapPrefix, "-ping-right"), pingRight), _defineProperty$1(_classNames, "".concat(wrapPrefix, "-ping-top"), pingTop), _defineProperty$1(_classNames, "".concat(wrapPrefix, "-ping-bottom"), pingBottom), _classNames)),
    ref: tabsWrapperRef
  }, /* @__PURE__ */ React.createElement(ResizeObserver, {
    onResize: onListHolderResize
  }, /* @__PURE__ */ React.createElement("div", {
    ref: tabListRef,
    className: "".concat(prefixCls, "-nav-list"),
    style: {
      transform: "translate(".concat(transformLeft, "px, ").concat(transformTop, "px)"),
      transition: lockAnimation ? "none" : void 0
    }
  }, tabNodes, /* @__PURE__ */ React.createElement(AddButton$1, {
    ref: innerAddButtonRef,
    prefixCls,
    locale: locale2,
    editable,
    style: _objectSpread2$1(_objectSpread2$1({}, tabNodes.length === 0 ? void 0 : tabNodeStyle), {}, {
      visibility: hasDropdown ? "hidden" : null
    })
  }), /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-ink-bar"), _defineProperty$1({}, "".concat(prefixCls, "-ink-bar-animated"), animated.inkBar)),
    style: inkStyle
  }))))), /* @__PURE__ */ React.createElement(OperationNode$1, _extends$1({}, props, {
    removeAriaLabel: locale2 === null || locale2 === void 0 ? void 0 : locale2.removeAriaLabel,
    ref: operationsRef,
    prefixCls,
    tabs: hiddenTabs,
    className: !hasDropdown && operationsHiddenClassName,
    tabMoving: !!lockAnimation
  })), /* @__PURE__ */ React.createElement(ExtraContent, {
    position: "right",
    extra,
    prefixCls
  }));
}
var TabNavList$1 = /* @__PURE__ */ React.forwardRef(TabNavList);
function TabPanelList(_ref) {
  var id2 = _ref.id, activeKey = _ref.activeKey, animated = _ref.animated, tabPosition = _ref.tabPosition, rtl = _ref.rtl, destroyInactiveTabPane = _ref.destroyInactiveTabPane;
  var _React$useContext = React.useContext(TabContext), prefixCls = _React$useContext.prefixCls, tabs = _React$useContext.tabs;
  var tabPaneAnimated = animated.tabPane;
  var activeIndex = tabs.findIndex(function(tab) {
    return tab.key === activeKey;
  });
  return /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-content-holder"))
  }, /* @__PURE__ */ React.createElement("div", {
    className: classNames("".concat(prefixCls, "-content"), "".concat(prefixCls, "-content-").concat(tabPosition), _defineProperty$1({}, "".concat(prefixCls, "-content-animated"), tabPaneAnimated)),
    style: activeIndex && tabPaneAnimated ? _defineProperty$1({}, rtl ? "marginRight" : "marginLeft", "-".concat(activeIndex, "00%")) : null
  }, tabs.map(function(tab) {
    return /* @__PURE__ */ React.cloneElement(tab.node, {
      key: tab.key,
      prefixCls,
      tabKey: tab.key,
      id: id2,
      animated: tabPaneAnimated,
      active: tab.key === activeKey,
      destroyInactiveTabPane
    });
  })));
}
function TabPane$1(_ref) {
  var prefixCls = _ref.prefixCls, forceRender = _ref.forceRender, className = _ref.className, style2 = _ref.style, id2 = _ref.id, active = _ref.active, animated = _ref.animated, destroyInactiveTabPane = _ref.destroyInactiveTabPane, tabKey = _ref.tabKey, children = _ref.children;
  var _React$useState = React.useState(forceRender), _React$useState2 = _slicedToArray(_React$useState, 2), visited = _React$useState2[0], setVisited = _React$useState2[1];
  React.useEffect(function() {
    if (active) {
      setVisited(true);
    } else if (destroyInactiveTabPane) {
      setVisited(false);
    }
  }, [active, destroyInactiveTabPane]);
  var mergedStyle = {};
  if (!active) {
    if (animated) {
      mergedStyle.visibility = "hidden";
      mergedStyle.height = 0;
      mergedStyle.overflowY = "hidden";
    } else {
      mergedStyle.display = "none";
    }
  }
  return /* @__PURE__ */ React.createElement("div", {
    id: id2 && "".concat(id2, "-panel-").concat(tabKey),
    role: "tabpanel",
    tabIndex: active ? 0 : -1,
    "aria-labelledby": id2 && "".concat(id2, "-tab-").concat(tabKey),
    "aria-hidden": !active,
    style: _objectSpread2$1(_objectSpread2$1({}, mergedStyle), style2),
    className: classNames("".concat(prefixCls, "-tabpane"), active && "".concat(prefixCls, "-tabpane-active"), className)
  }, (active || visited || forceRender) && children);
}
var _excluded$2 = ["id", "prefixCls", "className", "children", "direction", "activeKey", "defaultActiveKey", "editable", "animated", "tabPosition", "tabBarGutter", "tabBarStyle", "tabBarExtraContent", "locale", "moreIcon", "moreTransitionName", "destroyInactiveTabPane", "renderTabBar", "onChange", "onTabClick", "onTabScroll"];
var uuid$1 = 0;
function parseTabList(children) {
  return toArray$1(children).map(function(node) {
    if (/* @__PURE__ */ React.isValidElement(node)) {
      var key = node.key !== void 0 ? String(node.key) : void 0;
      return _objectSpread2$1(_objectSpread2$1({
        key
      }, node.props), {}, {
        node
      });
    }
    return null;
  }).filter(function(tab) {
    return tab;
  });
}
function Tabs$1(_ref, ref) {
  var _classNames;
  var id2 = _ref.id, _ref$prefixCls = _ref.prefixCls, prefixCls = _ref$prefixCls === void 0 ? "rc-tabs" : _ref$prefixCls, className = _ref.className, children = _ref.children, direction = _ref.direction, activeKey = _ref.activeKey, defaultActiveKey = _ref.defaultActiveKey, editable = _ref.editable, _ref$animated = _ref.animated, animated = _ref$animated === void 0 ? {
    inkBar: true,
    tabPane: false
  } : _ref$animated, _ref$tabPosition = _ref.tabPosition, tabPosition = _ref$tabPosition === void 0 ? "top" : _ref$tabPosition, tabBarGutter = _ref.tabBarGutter, tabBarStyle = _ref.tabBarStyle, tabBarExtraContent = _ref.tabBarExtraContent, locale2 = _ref.locale, moreIcon = _ref.moreIcon, moreTransitionName = _ref.moreTransitionName, destroyInactiveTabPane = _ref.destroyInactiveTabPane, renderTabBar = _ref.renderTabBar, onChange3 = _ref.onChange, onTabClick = _ref.onTabClick, onTabScroll = _ref.onTabScroll, restProps = _objectWithoutProperties(_ref, _excluded$2);
  var tabs = parseTabList(children);
  var rtl = direction === "rtl";
  var mergedAnimated;
  if (animated === false) {
    mergedAnimated = {
      inkBar: false,
      tabPane: false
    };
  } else if (animated === true) {
    mergedAnimated = {
      inkBar: true,
      tabPane: true
    };
  } else {
    mergedAnimated = _objectSpread2$1({
      inkBar: true,
      tabPane: false
    }, _typeof$1(animated) === "object" ? animated : {});
  }
  var _useState = useState(false), _useState2 = _slicedToArray(_useState, 2), mobile = _useState2[0], setMobile = _useState2[1];
  useEffect(function() {
    setMobile(isMobile());
  }, []);
  var _useMergedState = useControlledState(function() {
    var _tabs$;
    return (_tabs$ = tabs[0]) === null || _tabs$ === void 0 ? void 0 : _tabs$.key;
  }, {
    value: activeKey,
    defaultValue: defaultActiveKey
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), mergedActiveKey = _useMergedState2[0], setMergedActiveKey = _useMergedState2[1];
  var _useState3 = useState(function() {
    return tabs.findIndex(function(tab) {
      return tab.key === mergedActiveKey;
    });
  }), _useState4 = _slicedToArray(_useState3, 2), activeIndex = _useState4[0], setActiveIndex = _useState4[1];
  useEffect(function() {
    var newActiveIndex = tabs.findIndex(function(tab) {
      return tab.key === mergedActiveKey;
    });
    if (newActiveIndex === -1) {
      var _tabs$newActiveIndex;
      newActiveIndex = Math.max(0, Math.min(activeIndex, tabs.length - 1));
      setMergedActiveKey((_tabs$newActiveIndex = tabs[newActiveIndex]) === null || _tabs$newActiveIndex === void 0 ? void 0 : _tabs$newActiveIndex.key);
    }
    setActiveIndex(newActiveIndex);
  }, [tabs.map(function(tab) {
    return tab.key;
  }).join("_"), mergedActiveKey, activeIndex]);
  var _useMergedState3 = useControlledState(null, {
    value: id2
  }), _useMergedState4 = _slicedToArray(_useMergedState3, 2), mergedId = _useMergedState4[0], setMergedId = _useMergedState4[1];
  var mergedTabPosition = tabPosition;
  if (mobile && !["left", "right"].includes(tabPosition)) {
    mergedTabPosition = "top";
  }
  useEffect(function() {
    if (!id2) {
      setMergedId("rc-tabs-".concat(uuid$1));
      uuid$1 += 1;
    }
  }, []);
  function onInternalTabClick(key, e2) {
    onTabClick === null || onTabClick === void 0 ? void 0 : onTabClick(key, e2);
    var isActiveChanged = key !== mergedActiveKey;
    setMergedActiveKey(key);
    if (isActiveChanged) {
      onChange3 === null || onChange3 === void 0 ? void 0 : onChange3(key);
    }
  }
  var sharedProps = {
    id: mergedId,
    activeKey: mergedActiveKey,
    animated: mergedAnimated,
    tabPosition: mergedTabPosition,
    rtl,
    mobile
  };
  var tabNavBar;
  var tabNavBarProps = _objectSpread2$1(_objectSpread2$1({}, sharedProps), {}, {
    editable,
    locale: locale2,
    moreIcon,
    moreTransitionName,
    tabBarGutter,
    onTabClick: onInternalTabClick,
    onTabScroll,
    extra: tabBarExtraContent,
    style: tabBarStyle,
    panes: children
  });
  if (renderTabBar) {
    tabNavBar = renderTabBar(tabNavBarProps, TabNavList$1);
  } else {
    tabNavBar = /* @__PURE__ */ React.createElement(TabNavList$1, tabNavBarProps);
  }
  return /* @__PURE__ */ React.createElement(TabContext.Provider, {
    value: {
      tabs,
      prefixCls
    }
  }, /* @__PURE__ */ React.createElement("div", _extends$1({
    ref,
    id: id2,
    className: classNames(prefixCls, "".concat(prefixCls, "-").concat(mergedTabPosition), (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-mobile"), mobile), _defineProperty$1(_classNames, "".concat(prefixCls, "-editable"), editable), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), rtl), _classNames), className)
  }, restProps), tabNavBar, /* @__PURE__ */ React.createElement(TabPanelList, _extends$1({
    destroyInactiveTabPane
  }, sharedProps, {
    animated: mergedAnimated
  }))));
}
var ForwardTabs = /* @__PURE__ */ React.forwardRef(Tabs$1);
ForwardTabs.TabPane = TabPane$1;
var __rest$6 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
function Tabs(_a2) {
  var type4 = _a2.type, className = _a2.className, propSize = _a2.size, _onEdit = _a2.onEdit, hideAdd = _a2.hideAdd, centered = _a2.centered, addIcon = _a2.addIcon, props = __rest$6(_a2, ["type", "className", "size", "onEdit", "hideAdd", "centered", "addIcon"]);
  var customizePrefixCls = props.prefixCls, _props$moreIcon = props.moreIcon, moreIcon = _props$moreIcon === void 0 ? /* @__PURE__ */ React.createElement(EllipsisOutlined$1, null) : _props$moreIcon;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var prefixCls = getPrefixCls("tabs", customizePrefixCls);
  var editable;
  if (type4 === "editable-card") {
    editable = {
      onEdit: function onEdit(editType, _ref) {
        var key = _ref.key, event = _ref.event;
        _onEdit === null || _onEdit === void 0 ? void 0 : _onEdit(editType === "add" ? event : key, editType);
      },
      removeIcon: /* @__PURE__ */ React.createElement(CloseOutlined$1, null),
      addIcon: addIcon || /* @__PURE__ */ React.createElement(PlusOutlined$1, null),
      showAdd: hideAdd !== true
    };
  }
  var rootPrefixCls = getPrefixCls();
  devWarning(!("onPrevClick" in props) && !("onNextClick" in props), "Tabs", "`onPrevClick` and `onNextClick` has been removed. Please use `onTabScroll` instead.");
  return /* @__PURE__ */ React.createElement(SizeContext$1.Consumer, null, function(contextSize) {
    var _classNames;
    var size = propSize !== void 0 ? propSize : contextSize;
    return /* @__PURE__ */ React.createElement(ForwardTabs, _extends$1({
      direction,
      moreTransitionName: "".concat(rootPrefixCls, "-slide-up")
    }, props, {
      className: classNames((_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(size), size), _defineProperty$1(_classNames, "".concat(prefixCls, "-card"), ["card", "editable-card"].includes(type4)), _defineProperty$1(_classNames, "".concat(prefixCls, "-editable-card"), type4 === "editable-card"), _defineProperty$1(_classNames, "".concat(prefixCls, "-centered"), centered), _classNames), className),
      editable,
      moreIcon,
      prefixCls
    }));
  });
}
Tabs.TabPane = TabPane$1;
var RowContext = /* @__PURE__ */ createContext({});
var RowContext$1 = RowContext;
var canUseDocElement = function canUseDocElement2() {
  return canUseDom() && window.document.documentElement;
};
var flexGapSupported;
var detectFlexGapSupported = function detectFlexGapSupported2() {
  if (!canUseDocElement()) {
    return false;
  }
  if (flexGapSupported !== void 0) {
    return flexGapSupported;
  }
  var flex = document.createElement("div");
  flex.style.display = "flex";
  flex.style.flexDirection = "column";
  flex.style.rowGap = "1px";
  flex.appendChild(document.createElement("div"));
  flex.appendChild(document.createElement("div"));
  document.body.appendChild(flex);
  flexGapSupported = flex.scrollHeight === 1;
  document.body.removeChild(flex);
  return flexGapSupported;
};
var useFlexGapSupport = function() {
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), flexible = _React$useState2[0], setFlexible = _React$useState2[1];
  React.useEffect(function() {
    setFlexible(detectFlexGapSupported());
  }, []);
  return flexible;
};
var __rest$5 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
tuple("top", "middle", "bottom", "stretch");
tuple("start", "end", "center", "space-around", "space-between");
var Row = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var customizePrefixCls = props.prefixCls, justify = props.justify, align = props.align, className = props.className, style2 = props.style, children = props.children, _props$gutter = props.gutter, gutter = _props$gutter === void 0 ? 0 : _props$gutter, wrap = props.wrap, others = __rest$5(props, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useState = React.useState({
    xs: true,
    sm: true,
    md: true,
    lg: true,
    xl: true,
    xxl: true
  }), _React$useState2 = _slicedToArray(_React$useState, 2), screens2 = _React$useState2[0], setScreens = _React$useState2[1];
  var supportFlexGap = useFlexGapSupport();
  var gutterRef = React.useRef(gutter);
  React.useEffect(function() {
    var token = ResponsiveObserve.subscribe(function(screen) {
      var currentGutter = gutterRef.current || 0;
      if (!Array.isArray(currentGutter) && _typeof$1(currentGutter) === "object" || Array.isArray(currentGutter) && (_typeof$1(currentGutter[0]) === "object" || _typeof$1(currentGutter[1]) === "object")) {
        setScreens(screen);
      }
    });
    return function() {
      return ResponsiveObserve.unsubscribe(token);
    };
  }, []);
  var getGutter = function getGutter2() {
    var results = [0, 0];
    var normalizedGutter = Array.isArray(gutter) ? gutter : [gutter, 0];
    normalizedGutter.forEach(function(g2, index2) {
      if (_typeof$1(g2) === "object") {
        for (var i = 0; i < responsiveArray.length; i++) {
          var breakpoint = responsiveArray[i];
          if (screens2[breakpoint] && g2[breakpoint] !== void 0) {
            results[index2] = g2[breakpoint];
            break;
          }
        }
      } else {
        results[index2] = g2 || 0;
      }
    });
    return results;
  };
  var prefixCls = getPrefixCls("row", customizePrefixCls);
  var gutters = getGutter();
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-no-wrap"), wrap === false), _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(justify), justify), _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(align), align), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  var rowStyle = {};
  var horizontalGutter = gutters[0] > 0 ? gutters[0] / -2 : void 0;
  var verticalGutter = gutters[1] > 0 ? gutters[1] / -2 : void 0;
  if (horizontalGutter) {
    rowStyle.marginLeft = horizontalGutter;
    rowStyle.marginRight = horizontalGutter;
  }
  if (supportFlexGap) {
    var _gutters = _slicedToArray(gutters, 2);
    rowStyle.rowGap = _gutters[1];
  } else if (verticalGutter) {
    rowStyle.marginTop = verticalGutter;
    rowStyle.marginBottom = verticalGutter;
  }
  var _gutters2 = _slicedToArray(gutters, 2), gutterH = _gutters2[0], gutterV = _gutters2[1];
  var rowContext = React.useMemo(function() {
    return {
      gutter: [gutterH, gutterV],
      wrap,
      supportFlexGap
    };
  }, [gutterH, gutterV, wrap, supportFlexGap]);
  return /* @__PURE__ */ React.createElement(RowContext$1.Provider, {
    value: rowContext
  }, /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    className: classes,
    style: _extends$1(_extends$1({}, rowStyle), style2),
    ref
  }), children));
});
Row.displayName = "Row";
var Row$1 = Row;
var __rest$4 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
function parseFlex(flex) {
  if (typeof flex === "number") {
    return "".concat(flex, " ").concat(flex, " auto");
  }
  if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(flex)) {
    return "0 0 ".concat(flex);
  }
  return flex;
}
var sizes = ["xs", "sm", "md", "lg", "xl", "xxl"];
var Col = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useContext2 = React.useContext(RowContext$1), gutter = _React$useContext2.gutter, wrap = _React$useContext2.wrap, supportFlexGap = _React$useContext2.supportFlexGap;
  var customizePrefixCls = props.prefixCls, span = props.span, order = props.order, offset2 = props.offset, push2 = props.push, pull = props.pull, className = props.className, children = props.children, flex = props.flex, style2 = props.style, others = __rest$4(props, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]);
  var prefixCls = getPrefixCls("col", customizePrefixCls);
  var sizeClassObj = {};
  sizes.forEach(function(size) {
    var _extends2;
    var sizeProps = {};
    var propSize = props[size];
    if (typeof propSize === "number") {
      sizeProps.span = propSize;
    } else if (_typeof$1(propSize) === "object") {
      sizeProps = propSize || {};
    }
    delete others[size];
    sizeClassObj = _extends$1(_extends$1({}, sizeClassObj), (_extends2 = {}, _defineProperty$1(_extends2, "".concat(prefixCls, "-").concat(size, "-").concat(sizeProps.span), sizeProps.span !== void 0), _defineProperty$1(_extends2, "".concat(prefixCls, "-").concat(size, "-order-").concat(sizeProps.order), sizeProps.order || sizeProps.order === 0), _defineProperty$1(_extends2, "".concat(prefixCls, "-").concat(size, "-offset-").concat(sizeProps.offset), sizeProps.offset || sizeProps.offset === 0), _defineProperty$1(_extends2, "".concat(prefixCls, "-").concat(size, "-push-").concat(sizeProps.push), sizeProps.push || sizeProps.push === 0), _defineProperty$1(_extends2, "".concat(prefixCls, "-").concat(size, "-pull-").concat(sizeProps.pull), sizeProps.pull || sizeProps.pull === 0), _defineProperty$1(_extends2, "".concat(prefixCls, "-rtl"), direction === "rtl"), _extends2));
  });
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-").concat(span), span !== void 0), _defineProperty$1(_classNames, "".concat(prefixCls, "-order-").concat(order), order), _defineProperty$1(_classNames, "".concat(prefixCls, "-offset-").concat(offset2), offset2), _defineProperty$1(_classNames, "".concat(prefixCls, "-push-").concat(push2), push2), _defineProperty$1(_classNames, "".concat(prefixCls, "-pull-").concat(pull), pull), _classNames), className, sizeClassObj);
  var mergedStyle = {};
  if (gutter && gutter[0] > 0) {
    var horizontalGutter = gutter[0] / 2;
    mergedStyle.paddingLeft = horizontalGutter;
    mergedStyle.paddingRight = horizontalGutter;
  }
  if (gutter && gutter[1] > 0 && !supportFlexGap) {
    var verticalGutter = gutter[1] / 2;
    mergedStyle.paddingTop = verticalGutter;
    mergedStyle.paddingBottom = verticalGutter;
  }
  if (flex) {
    mergedStyle.flex = parseFlex(flex);
    if (wrap === false && !mergedStyle.minWidth) {
      mergedStyle.minWidth = 0;
    }
  }
  return /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    style: _extends$1(_extends$1({}, mergedStyle), style2),
    className: classes,
    ref
  }), children);
});
Col.displayName = "Col";
var Col$1 = Col;
var __rest$3 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var Divider = function Divider2(props) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var customizePrefixCls = props.prefixCls, _props$type = props.type, type4 = _props$type === void 0 ? "horizontal" : _props$type, _props$orientation = props.orientation, orientation = _props$orientation === void 0 ? "center" : _props$orientation, orientationMargin = props.orientationMargin, className = props.className, children = props.children, dashed = props.dashed, plain = props.plain, restProps = __rest$3(props, ["prefixCls", "type", "orientation", "orientationMargin", "className", "children", "dashed", "plain"]);
  var prefixCls = getPrefixCls("divider", customizePrefixCls);
  var orientationPrefix = orientation.length > 0 ? "-".concat(orientation) : orientation;
  var hasChildren = !!children;
  var hasCustomMarginLeft = orientation === "left" && orientationMargin != null;
  var hasCustomMarginRight = orientation === "right" && orientationMargin != null;
  var classString = classNames(prefixCls, "".concat(prefixCls, "-").concat(type4), (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-with-text"), hasChildren), _defineProperty$1(_classNames, "".concat(prefixCls, "-with-text").concat(orientationPrefix), hasChildren), _defineProperty$1(_classNames, "".concat(prefixCls, "-dashed"), !!dashed), _defineProperty$1(_classNames, "".concat(prefixCls, "-plain"), !!plain), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _defineProperty$1(_classNames, "".concat(prefixCls, "-no-default-orientation-margin-left"), hasCustomMarginLeft), _defineProperty$1(_classNames, "".concat(prefixCls, "-no-default-orientation-margin-right"), hasCustomMarginRight), _classNames), className);
  var innerStyle = _extends$1(_extends$1({}, hasCustomMarginLeft && {
    marginLeft: orientationMargin
  }), hasCustomMarginRight && {
    marginRight: orientationMargin
  });
  return /* @__PURE__ */ React.createElement("div", _extends$1({
    className: classString
  }, restProps, {
    role: "separator"
  }), children && /* @__PURE__ */ React.createElement("span", {
    className: "".concat(prefixCls, "-inner-text"),
    style: innerStyle
  }, children));
};
var Divider$1 = Divider;
var cached;
function getScrollBarSize(fresh) {
  if (typeof document === "undefined") {
    return 0;
  }
  if (fresh || cached === void 0) {
    var inner2 = document.createElement("div");
    inner2.style.width = "100%";
    inner2.style.height = "200px";
    var outer = document.createElement("div");
    var outerStyle = outer.style;
    outerStyle.position = "absolute";
    outerStyle.top = "0";
    outerStyle.left = "0";
    outerStyle.pointerEvents = "none";
    outerStyle.visibility = "hidden";
    outerStyle.width = "200px";
    outerStyle.height = "150px";
    outerStyle.overflow = "hidden";
    outer.appendChild(inner2);
    document.body.appendChild(outer);
    var widthContained = inner2.offsetWidth;
    outer.style.overflow = "scroll";
    var widthScroll = inner2.offsetWidth;
    if (widthContained === widthScroll) {
      widthScroll = outer.clientWidth;
    }
    document.body.removeChild(outer);
    cached = widthContained - widthScroll;
  }
  return cached;
}
function setStyle(style2) {
  var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!style2) {
    return {};
  }
  var _options$element = options.element, element = _options$element === void 0 ? document.body : _options$element;
  var oldStyle = {};
  var styleKeys = Object.keys(style2);
  styleKeys.forEach(function(key) {
    oldStyle[key] = element.style[key];
  });
  styleKeys.forEach(function(key) {
    element.style[key] = style2[key];
  });
  return oldStyle;
}
function isBodyOverflowing() {
  return document.body.scrollHeight > (window.innerHeight || document.documentElement.clientHeight) && window.innerWidth > document.body.offsetWidth;
}
var cacheStyle$1 = {};
var switchScrollingEffect = function(close) {
  if (!isBodyOverflowing() && !close) {
    return;
  }
  var scrollingEffectClassName2 = "ant-scrolling-effect";
  var scrollingEffectClassNameReg2 = new RegExp("".concat(scrollingEffectClassName2), "g");
  var bodyClassName = document.body.className;
  if (close) {
    if (!scrollingEffectClassNameReg2.test(bodyClassName))
      return;
    setStyle(cacheStyle$1);
    cacheStyle$1 = {};
    document.body.className = bodyClassName.replace(scrollingEffectClassNameReg2, "").trim();
    return;
  }
  var scrollBarSize = getScrollBarSize();
  if (scrollBarSize) {
    cacheStyle$1 = setStyle({
      position: "relative",
      width: "calc(100% - ".concat(scrollBarSize, "px)")
    });
    if (!scrollingEffectClassNameReg2.test(bodyClassName)) {
      var addClassName = "".concat(bodyClassName, " ").concat(scrollingEffectClassName2);
      document.body.className = addClassName.trim();
    }
  }
};
var locks = [];
var scrollingEffectClassName = "ant-scrolling-effect";
var scrollingEffectClassNameReg = new RegExp("".concat(scrollingEffectClassName), "g");
var uuid = 0;
var cacheStyle = /* @__PURE__ */ new Map();
var ScrollLocker = /* @__PURE__ */ _createClass(function ScrollLocker2(_options) {
  var _this = this;
  _classCallCheck(this, ScrollLocker2);
  this.lockTarget = void 0;
  this.options = void 0;
  this.getContainer = function() {
    var _this$options;
    return (_this$options = _this.options) === null || _this$options === void 0 ? void 0 : _this$options.container;
  };
  this.reLock = function(options) {
    var findLock = locks.find(function(_ref) {
      var target = _ref.target;
      return target === _this.lockTarget;
    });
    if (findLock) {
      _this.unLock();
    }
    _this.options = options;
    if (findLock) {
      findLock.options = options;
      _this.lock();
    }
  };
  this.lock = function() {
    var _this$options3;
    if (locks.some(function(_ref2) {
      var target = _ref2.target;
      return target === _this.lockTarget;
    })) {
      return;
    }
    if (locks.some(function(_ref3) {
      var _this$options2;
      var options = _ref3.options;
      return (options === null || options === void 0 ? void 0 : options.container) === ((_this$options2 = _this.options) === null || _this$options2 === void 0 ? void 0 : _this$options2.container);
    })) {
      locks = [].concat(_toConsumableArray(locks), [{
        target: _this.lockTarget,
        options: _this.options
      }]);
      return;
    }
    var scrollBarSize = 0;
    var container2 = ((_this$options3 = _this.options) === null || _this$options3 === void 0 ? void 0 : _this$options3.container) || document.body;
    if (container2 === document.body && window.innerWidth - document.documentElement.clientWidth > 0 || container2.scrollHeight > container2.clientHeight) {
      scrollBarSize = getScrollBarSize();
    }
    var containerClassName = container2.className;
    if (locks.filter(function(_ref4) {
      var _this$options4;
      var options = _ref4.options;
      return (options === null || options === void 0 ? void 0 : options.container) === ((_this$options4 = _this.options) === null || _this$options4 === void 0 ? void 0 : _this$options4.container);
    }).length === 0) {
      cacheStyle.set(container2, setStyle({
        width: scrollBarSize !== 0 ? "calc(100% - ".concat(scrollBarSize, "px)") : void 0,
        overflow: "hidden",
        overflowX: "hidden",
        overflowY: "hidden"
      }, {
        element: container2
      }));
    }
    if (!scrollingEffectClassNameReg.test(containerClassName)) {
      var addClassName = "".concat(containerClassName, " ").concat(scrollingEffectClassName);
      container2.className = addClassName.trim();
    }
    locks = [].concat(_toConsumableArray(locks), [{
      target: _this.lockTarget,
      options: _this.options
    }]);
  };
  this.unLock = function() {
    var _this$options5;
    var findLock = locks.find(function(_ref5) {
      var target = _ref5.target;
      return target === _this.lockTarget;
    });
    locks = locks.filter(function(_ref6) {
      var target = _ref6.target;
      return target !== _this.lockTarget;
    });
    if (!findLock || locks.some(function(_ref7) {
      var _findLock$options;
      var options = _ref7.options;
      return (options === null || options === void 0 ? void 0 : options.container) === ((_findLock$options = findLock.options) === null || _findLock$options === void 0 ? void 0 : _findLock$options.container);
    })) {
      return;
    }
    var container2 = ((_this$options5 = _this.options) === null || _this$options5 === void 0 ? void 0 : _this$options5.container) || document.body;
    var containerClassName = container2.className;
    if (!scrollingEffectClassNameReg.test(containerClassName))
      return;
    setStyle(cacheStyle.get(container2), {
      element: container2
    });
    cacheStyle.delete(container2);
    container2.className = container2.className.replace(scrollingEffectClassNameReg, "").trim();
  };
  this.lockTarget = uuid++;
  this.options = _options;
});
var openCount = 0;
var supportDom = canUseDom();
var cacheOverflow = {};
var getParent2 = function getParent3(getContainer2) {
  if (!supportDom) {
    return null;
  }
  if (getContainer2) {
    if (typeof getContainer2 === "string") {
      return document.querySelectorAll(getContainer2)[0];
    }
    if (typeof getContainer2 === "function") {
      return getContainer2();
    }
    if (_typeof$1(getContainer2) === "object" && getContainer2 instanceof window.HTMLElement) {
      return getContainer2;
    }
  }
  return document.body;
};
var PortalWrapper = /* @__PURE__ */ function(_React$Component) {
  _inherits(PortalWrapper2, _React$Component);
  var _super = _createSuper(PortalWrapper2);
  function PortalWrapper2(props) {
    var _this;
    _classCallCheck(this, PortalWrapper2);
    _this = _super.call(this, props);
    _this.container = void 0;
    _this.componentRef = /* @__PURE__ */ React.createRef();
    _this.rafId = void 0;
    _this.scrollLocker = void 0;
    _this.renderComponent = void 0;
    _this.updateScrollLocker = function(prevProps) {
      var _ref = prevProps || {}, prevVisible = _ref.visible;
      var _this$props = _this.props, getContainer2 = _this$props.getContainer, visible = _this$props.visible;
      if (visible && visible !== prevVisible && supportDom && getParent2(getContainer2) !== _this.scrollLocker.getContainer()) {
        _this.scrollLocker.reLock({
          container: getParent2(getContainer2)
        });
      }
    };
    _this.updateOpenCount = function(prevProps) {
      var _ref2 = prevProps || {}, prevVisible = _ref2.visible, prevGetContainer = _ref2.getContainer;
      var _this$props2 = _this.props, visible = _this$props2.visible, getContainer2 = _this$props2.getContainer;
      if (visible !== prevVisible && supportDom && getParent2(getContainer2) === document.body) {
        if (visible && !prevVisible) {
          openCount += 1;
        } else if (prevProps) {
          openCount -= 1;
        }
      }
      var getContainerIsFunc = typeof getContainer2 === "function" && typeof prevGetContainer === "function";
      if (getContainerIsFunc ? getContainer2.toString() !== prevGetContainer.toString() : getContainer2 !== prevGetContainer) {
        _this.removeCurrentContainer();
      }
    };
    _this.attachToParent = function() {
      var force = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
      if (force || _this.container && !_this.container.parentNode) {
        var parent = getParent2(_this.props.getContainer);
        if (parent) {
          parent.appendChild(_this.container);
          return true;
        }
        return false;
      }
      return true;
    };
    _this.getContainer = function() {
      if (!supportDom) {
        return null;
      }
      if (!_this.container) {
        _this.container = document.createElement("div");
        _this.attachToParent(true);
      }
      _this.setWrapperClassName();
      return _this.container;
    };
    _this.setWrapperClassName = function() {
      var wrapperClassName = _this.props.wrapperClassName;
      if (_this.container && wrapperClassName && wrapperClassName !== _this.container.className) {
        _this.container.className = wrapperClassName;
      }
    };
    _this.removeCurrentContainer = function() {
      var _this$container, _this$container$paren;
      (_this$container = _this.container) === null || _this$container === void 0 ? void 0 : (_this$container$paren = _this$container.parentNode) === null || _this$container$paren === void 0 ? void 0 : _this$container$paren.removeChild(_this.container);
    };
    _this.switchScrollingEffect = function() {
      if (openCount === 1 && !Object.keys(cacheOverflow).length) {
        switchScrollingEffect();
        cacheOverflow = setStyle({
          overflow: "hidden",
          overflowX: "hidden",
          overflowY: "hidden"
        });
      } else if (!openCount) {
        setStyle(cacheOverflow);
        cacheOverflow = {};
        switchScrollingEffect(true);
      }
    };
    _this.scrollLocker = new ScrollLocker({
      container: getParent2(props.getContainer)
    });
    return _this;
  }
  _createClass(PortalWrapper2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.updateOpenCount();
      if (!this.attachToParent()) {
        this.rafId = wrapperRaf$1(function() {
          _this2.forceUpdate();
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      this.updateOpenCount(prevProps);
      this.updateScrollLocker(prevProps);
      this.setWrapperClassName();
      this.attachToParent();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props3 = this.props, visible = _this$props3.visible, getContainer2 = _this$props3.getContainer;
      if (supportDom && getParent2(getContainer2) === document.body) {
        openCount = visible && openCount ? openCount - 1 : openCount;
      }
      this.removeCurrentContainer();
      wrapperRaf$1.cancel(this.rafId);
    }
  }, {
    key: "render",
    value: function render2() {
      var _this$props4 = this.props, children = _this$props4.children, forceRender = _this$props4.forceRender, visible = _this$props4.visible;
      var portal = null;
      var childProps = {
        getOpenCount: function getOpenCount() {
          return openCount;
        },
        getContainer: this.getContainer,
        switchScrollingEffect: this.switchScrollingEffect,
        scrollLocker: this.scrollLocker
      };
      if (forceRender || visible || this.componentRef.current) {
        portal = /* @__PURE__ */ React.createElement(Portal, {
          getContainer: this.getContainer,
          ref: this.componentRef
        }, children(childProps));
      }
      return portal;
    }
  }]);
  return PortalWrapper2;
}(React.Component);
function dataToArray(vars) {
  if (Array.isArray(vars)) {
    return vars;
  }
  return [vars];
}
var transitionEndObject = {
  transition: "transitionend",
  WebkitTransition: "webkitTransitionEnd",
  MozTransition: "transitionend",
  OTransition: "oTransitionEnd otransitionend"
};
var transitionStr = Object.keys(transitionEndObject).filter(function(key) {
  if (typeof document === "undefined") {
    return false;
  }
  var html = document.getElementsByTagName("html")[0];
  return key in (html ? html.style : {});
})[0];
var transitionEnd = transitionEndObject[transitionStr];
function addEventListener(target, eventType, callback, options) {
  if (target.addEventListener) {
    target.addEventListener(eventType, callback, options);
  } else if (target.attachEvent) {
    target.attachEvent("on".concat(eventType), callback);
  }
}
function removeEventListener(target, eventType, callback, options) {
  if (target.removeEventListener) {
    target.removeEventListener(eventType, callback, options);
  } else if (target.attachEvent) {
    target.detachEvent("on".concat(eventType), callback);
  }
}
function transformArguments(arg, cb2) {
  var result = typeof arg === "function" ? arg(cb2) : arg;
  if (Array.isArray(result)) {
    if (result.length === 2) {
      return result;
    }
    return [result[0], result[1]];
  }
  return [result];
}
var isNumeric = function isNumeric2(value) {
  return !isNaN(parseFloat(value)) && isFinite(value);
};
var windowIsUndefined = !(typeof window !== "undefined" && window.document && window.document.createElement);
var getTouchParentScroll = function getTouchParentScroll2(root2, currentTarget, differX, differY) {
  if (!currentTarget || currentTarget === document || currentTarget instanceof Document) {
    return false;
  }
  if (currentTarget === root2.parentNode) {
    return true;
  }
  var isY = Math.max(Math.abs(differX), Math.abs(differY)) === Math.abs(differY);
  var isX = Math.max(Math.abs(differX), Math.abs(differY)) === Math.abs(differX);
  var scrollY = currentTarget.scrollHeight - currentTarget.clientHeight;
  var scrollX = currentTarget.scrollWidth - currentTarget.clientWidth;
  var style2 = document.defaultView.getComputedStyle(currentTarget);
  var overflowY = style2.overflowY === "auto" || style2.overflowY === "scroll";
  var overflowX = style2.overflowX === "auto" || style2.overflowX === "scroll";
  var y2 = scrollY && overflowY;
  var x2 = scrollX && overflowX;
  if (isY && (!y2 || y2 && (currentTarget.scrollTop >= scrollY && differY < 0 || currentTarget.scrollTop <= 0 && differY > 0)) || isX && (!x2 || x2 && (currentTarget.scrollLeft >= scrollX && differX < 0 || currentTarget.scrollLeft <= 0 && differX > 0))) {
    return getTouchParentScroll2(root2, currentTarget.parentNode, differX, differY);
  }
  return false;
};
var _excluded$1 = ["className", "children", "style", "width", "height", "defaultOpen", "open", "prefixCls", "placement", "level", "levelMove", "ease", "duration", "getContainer", "handler", "onChange", "afterVisibleChange", "showMask", "maskClosable", "maskStyle", "onClose", "onHandleClick", "keyboard", "getOpenCount", "scrollLocker", "contentWrapperStyle"];
var currentDrawer = {};
var DrawerChild = /* @__PURE__ */ function(_React$Component) {
  _inherits(DrawerChild2, _React$Component);
  var _super = _createSuper(DrawerChild2);
  function DrawerChild2(props) {
    var _this;
    _classCallCheck(this, DrawerChild2);
    _this = _super.call(this, props);
    _this.levelDom = void 0;
    _this.dom = void 0;
    _this.contentWrapper = void 0;
    _this.contentDom = void 0;
    _this.maskDom = void 0;
    _this.handlerDom = void 0;
    _this.drawerId = void 0;
    _this.timeout = void 0;
    _this.passive = void 0;
    _this.startPos = void 0;
    _this.domFocus = function() {
      if (_this.dom) {
        _this.dom.focus();
      }
    };
    _this.removeStartHandler = function(e2) {
      if (e2.touches.length > 1) {
        _this.startPos = null;
        return;
      }
      _this.startPos = {
        x: e2.touches[0].clientX,
        y: e2.touches[0].clientY
      };
    };
    _this.removeMoveHandler = function(e2) {
      if (e2.changedTouches.length > 1 || !_this.startPos) {
        return;
      }
      var currentTarget = e2.currentTarget;
      var differX = e2.changedTouches[0].clientX - _this.startPos.x;
      var differY = e2.changedTouches[0].clientY - _this.startPos.y;
      if ((currentTarget === _this.maskDom || currentTarget === _this.handlerDom || currentTarget === _this.contentDom && getTouchParentScroll(currentTarget, e2.target, differX, differY)) && e2.cancelable) {
        e2.preventDefault();
      }
    };
    _this.transitionEnd = function(e2) {
      var dom = e2.target;
      removeEventListener(dom, transitionEnd, _this.transitionEnd);
      dom.style.transition = "";
    };
    _this.onKeyDown = function(e2) {
      if (e2.keyCode === KeyCode.ESC) {
        var onClose = _this.props.onClose;
        e2.stopPropagation();
        if (onClose) {
          onClose(e2);
        }
      }
    };
    _this.onWrapperTransitionEnd = function(e2) {
      var _this$props = _this.props, open = _this$props.open, afterVisibleChange2 = _this$props.afterVisibleChange;
      if (e2.target === _this.contentWrapper && e2.propertyName.match(/transform$/)) {
        _this.dom.style.transition = "";
        if (!open && _this.getCurrentDrawerSome()) {
          document.body.style.overflowX = "";
          if (_this.maskDom) {
            _this.maskDom.style.left = "";
            _this.maskDom.style.width = "";
          }
        }
        if (afterVisibleChange2) {
          afterVisibleChange2(!!open);
        }
      }
    };
    _this.openLevelTransition = function() {
      var _this$props2 = _this.props, open = _this$props2.open, width = _this$props2.width, height = _this$props2.height;
      var _this$getHorizontalBo = _this.getHorizontalBoolAndPlacementName(), isHorizontal = _this$getHorizontalBo.isHorizontal, placementName = _this$getHorizontalBo.placementName;
      var contentValue = _this.contentDom ? _this.contentDom.getBoundingClientRect()[isHorizontal ? "width" : "height"] : 0;
      var value = (isHorizontal ? width : height) || contentValue;
      _this.setLevelAndScrolling(open, placementName, value);
    };
    _this.setLevelTransform = function(open, placementName, value, right) {
      var _this$props3 = _this.props, placement = _this$props3.placement, levelMove = _this$props3.levelMove, duration = _this$props3.duration, ease = _this$props3.ease, showMask = _this$props3.showMask;
      _this.levelDom.forEach(function(dom) {
        dom.style.transition = "transform ".concat(duration, " ").concat(ease);
        addEventListener(dom, transitionEnd, _this.transitionEnd);
        var levelValue = open ? value : 0;
        if (levelMove) {
          var $levelMove = transformArguments(levelMove, {
            target: dom,
            open
          });
          levelValue = open ? $levelMove[0] : $levelMove[1] || 0;
        }
        var $value = typeof levelValue === "number" ? "".concat(levelValue, "px") : levelValue;
        var placementPos = placement === "left" || placement === "top" ? $value : "-".concat($value);
        placementPos = showMask && placement === "right" && right ? "calc(".concat(placementPos, " + ").concat(right, "px)") : placementPos;
        dom.style.transform = levelValue ? "".concat(placementName, "(").concat(placementPos, ")") : "";
      });
    };
    _this.setLevelAndScrolling = function(open, placementName, value) {
      var onChange3 = _this.props.onChange;
      if (!windowIsUndefined) {
        var right = document.body.scrollHeight > (window.innerHeight || document.documentElement.clientHeight) && window.innerWidth > document.body.offsetWidth ? getScrollBarSize(true) : 0;
        _this.setLevelTransform(open, placementName, value, right);
        _this.toggleScrollingToDrawerAndBody(right);
      }
      if (onChange3) {
        onChange3(open);
      }
    };
    _this.toggleScrollingToDrawerAndBody = function(right) {
      var _this$props4 = _this.props, getContainer2 = _this$props4.getContainer, showMask = _this$props4.showMask, open = _this$props4.open;
      var container2 = getContainer2 && getContainer2();
      if (container2 && container2.parentNode === document.body && showMask) {
        var eventArray = ["touchstart"];
        var domArray = [document.body, _this.maskDom, _this.handlerDom, _this.contentDom];
        if (open && document.body.style.overflow !== "hidden") {
          if (right) {
            _this.addScrollingEffect(right);
          }
          document.body.style.touchAction = "none";
          domArray.forEach(function(item, i) {
            if (!item) {
              return;
            }
            addEventListener(item, eventArray[i] || "touchmove", i ? _this.removeMoveHandler : _this.removeStartHandler, _this.passive);
          });
        } else if (_this.getCurrentDrawerSome()) {
          document.body.style.touchAction = "";
          if (right) {
            _this.remScrollingEffect(right);
          }
          domArray.forEach(function(item, i) {
            if (!item) {
              return;
            }
            removeEventListener(item, eventArray[i] || "touchmove", i ? _this.removeMoveHandler : _this.removeStartHandler, _this.passive);
          });
        }
      }
    };
    _this.addScrollingEffect = function(right) {
      var _this$props5 = _this.props, placement = _this$props5.placement, duration = _this$props5.duration, ease = _this$props5.ease;
      var widthTransition = "width ".concat(duration, " ").concat(ease);
      var transformTransition = "transform ".concat(duration, " ").concat(ease);
      _this.dom.style.transition = "none";
      switch (placement) {
        case "right":
          _this.dom.style.transform = "translateX(-".concat(right, "px)");
          break;
        case "top":
        case "bottom":
          _this.dom.style.width = "calc(100% - ".concat(right, "px)");
          _this.dom.style.transform = "translateZ(0)";
          break;
      }
      clearTimeout(_this.timeout);
      _this.timeout = setTimeout(function() {
        if (_this.dom) {
          _this.dom.style.transition = "".concat(transformTransition, ",").concat(widthTransition);
          _this.dom.style.width = "";
          _this.dom.style.transform = "";
        }
      });
    };
    _this.remScrollingEffect = function(right) {
      var _this$props6 = _this.props, placement = _this$props6.placement, duration = _this$props6.duration, ease = _this$props6.ease;
      if (transitionStr) {
        document.body.style.overflowX = "hidden";
      }
      _this.dom.style.transition = "none";
      var heightTransition;
      var widthTransition = "width ".concat(duration, " ").concat(ease);
      var transformTransition = "transform ".concat(duration, " ").concat(ease);
      switch (placement) {
        case "left": {
          _this.dom.style.width = "100%";
          widthTransition = "width 0s ".concat(ease, " ").concat(duration);
          break;
        }
        case "right": {
          _this.dom.style.transform = "translateX(".concat(right, "px)");
          _this.dom.style.width = "100%";
          widthTransition = "width 0s ".concat(ease, " ").concat(duration);
          if (_this.maskDom) {
            _this.maskDom.style.left = "-".concat(right, "px");
            _this.maskDom.style.width = "calc(100% + ".concat(right, "px)");
          }
          break;
        }
        case "top":
        case "bottom": {
          _this.dom.style.width = "calc(100% + ".concat(right, "px)");
          _this.dom.style.height = "100%";
          _this.dom.style.transform = "translateZ(0)";
          heightTransition = "height 0s ".concat(ease, " ").concat(duration);
          break;
        }
      }
      clearTimeout(_this.timeout);
      _this.timeout = setTimeout(function() {
        if (_this.dom) {
          _this.dom.style.transition = "".concat(transformTransition, ",").concat(heightTransition ? "".concat(heightTransition, ",") : "").concat(widthTransition);
          _this.dom.style.transform = "";
          _this.dom.style.width = "";
          _this.dom.style.height = "";
        }
      });
    };
    _this.getCurrentDrawerSome = function() {
      return !Object.keys(currentDrawer).some(function(key) {
        return currentDrawer[key];
      });
    };
    _this.getLevelDom = function(_ref) {
      var level = _ref.level, getContainer2 = _ref.getContainer;
      if (windowIsUndefined) {
        return;
      }
      var container2 = getContainer2 && getContainer2();
      var parent = container2 ? container2.parentNode : null;
      _this.levelDom = [];
      if (level === "all") {
        var children = parent ? Array.prototype.slice.call(parent.children) : [];
        children.forEach(function(child) {
          if (child.nodeName !== "SCRIPT" && child.nodeName !== "STYLE" && child.nodeName !== "LINK" && child !== container2) {
            _this.levelDom.push(child);
          }
        });
      } else if (level) {
        dataToArray(level).forEach(function(key) {
          document.querySelectorAll(key).forEach(function(item) {
            _this.levelDom.push(item);
          });
        });
      }
    };
    _this.getHorizontalBoolAndPlacementName = function() {
      var placement = _this.props.placement;
      var isHorizontal = placement === "left" || placement === "right";
      var placementName = "translate".concat(isHorizontal ? "X" : "Y");
      return {
        isHorizontal,
        placementName
      };
    };
    _this.state = {
      _self: _assertThisInitialized(_this)
    };
    return _this;
  }
  _createClass(DrawerChild2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      if (!windowIsUndefined) {
        var passiveSupported = false;
        try {
          window.addEventListener("test", null, Object.defineProperty({}, "passive", {
            get: function get2() {
              passiveSupported = true;
              return null;
            }
          }));
        } catch (err) {
        }
        this.passive = passiveSupported ? {
          passive: false
        } : false;
      }
      var _this$props7 = this.props, open = _this$props7.open, getContainer2 = _this$props7.getContainer, showMask = _this$props7.showMask, autoFocus = _this$props7.autoFocus;
      var container2 = getContainer2 && getContainer2();
      this.drawerId = "drawer_id_".concat(Number((Date.now() + Math.random()).toString().replace(".", Math.round(Math.random() * 9).toString())).toString(16));
      this.getLevelDom(this.props);
      if (open) {
        if (container2 && container2.parentNode === document.body) {
          currentDrawer[this.drawerId] = open;
        }
        this.openLevelTransition();
        this.forceUpdate(function() {
          if (autoFocus) {
            _this2.domFocus();
          }
        });
        if (showMask) {
          var _this$props$scrollLoc;
          (_this$props$scrollLoc = this.props.scrollLocker) === null || _this$props$scrollLoc === void 0 ? void 0 : _this$props$scrollLoc.lock();
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props8 = this.props, open = _this$props8.open, getContainer2 = _this$props8.getContainer, scrollLocker = _this$props8.scrollLocker, showMask = _this$props8.showMask, autoFocus = _this$props8.autoFocus;
      var container2 = getContainer2 && getContainer2();
      if (open !== prevProps.open) {
        if (container2 && container2.parentNode === document.body) {
          currentDrawer[this.drawerId] = !!open;
        }
        this.openLevelTransition();
        if (open) {
          if (autoFocus) {
            this.domFocus();
          }
          if (showMask) {
            scrollLocker === null || scrollLocker === void 0 ? void 0 : scrollLocker.lock();
          }
        } else {
          scrollLocker === null || scrollLocker === void 0 ? void 0 : scrollLocker.unLock();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props9 = this.props, open = _this$props9.open, scrollLocker = _this$props9.scrollLocker;
      delete currentDrawer[this.drawerId];
      if (open) {
        this.setLevelTransform(false);
        document.body.style.touchAction = "";
      }
      scrollLocker === null || scrollLocker === void 0 ? void 0 : scrollLocker.unLock();
    }
  }, {
    key: "render",
    value: function render2() {
      var _classnames, _this3 = this;
      var _this$props10 = this.props, className = _this$props10.className, children = _this$props10.children, style2 = _this$props10.style, width = _this$props10.width, height = _this$props10.height;
      _this$props10.defaultOpen;
      var $open = _this$props10.open, prefixCls = _this$props10.prefixCls, placement = _this$props10.placement;
      _this$props10.level;
      _this$props10.levelMove;
      _this$props10.ease;
      _this$props10.duration;
      _this$props10.getContainer;
      var handler = _this$props10.handler;
      _this$props10.onChange;
      _this$props10.afterVisibleChange;
      var showMask = _this$props10.showMask, maskClosable = _this$props10.maskClosable, maskStyle = _this$props10.maskStyle, onClose = _this$props10.onClose, onHandleClick = _this$props10.onHandleClick, keyboard = _this$props10.keyboard;
      _this$props10.getOpenCount;
      _this$props10.scrollLocker;
      var contentWrapperStyle = _this$props10.contentWrapperStyle, props = _objectWithoutProperties(_this$props10, _excluded$1);
      var open = this.dom ? $open : false;
      var wrapperClassName = classNames(prefixCls, (_classnames = {}, _defineProperty$1(_classnames, "".concat(prefixCls, "-").concat(placement), true), _defineProperty$1(_classnames, "".concat(prefixCls, "-open"), open), _defineProperty$1(_classnames, className || "", !!className), _defineProperty$1(_classnames, "no-mask", !showMask), _classnames));
      var _this$getHorizontalBo2 = this.getHorizontalBoolAndPlacementName(), placementName = _this$getHorizontalBo2.placementName;
      var placementPos = placement === "left" || placement === "top" ? "-100%" : "100%";
      var transform2 = open ? "" : "".concat(placementName, "(").concat(placementPos, ")");
      var handlerChildren = handler && /* @__PURE__ */ React.cloneElement(handler, {
        onClick: function onClick(e2) {
          if (handler.props.onClick) {
            handler.props.onClick();
          }
          if (onHandleClick) {
            onHandleClick(e2);
          }
        },
        ref: function ref(c2) {
          _this3.handlerDom = c2;
        }
      });
      return /* @__PURE__ */ React.createElement("div", _extends$1({}, omit(props, ["switchScrollingEffect", "autoFocus"]), {
        tabIndex: -1,
        className: wrapperClassName,
        style: style2,
        ref: function ref(c2) {
          _this3.dom = c2;
        },
        onKeyDown: open && keyboard ? this.onKeyDown : void 0,
        onTransitionEnd: this.onWrapperTransitionEnd
      }), showMask && /* @__PURE__ */ React.createElement("div", {
        className: "".concat(prefixCls, "-mask"),
        onClick: maskClosable ? onClose : void 0,
        style: maskStyle,
        ref: function ref(c2) {
          _this3.maskDom = c2;
        }
      }), /* @__PURE__ */ React.createElement("div", {
        className: "".concat(prefixCls, "-content-wrapper"),
        style: _objectSpread2$1({
          transform: transform2,
          msTransform: transform2,
          width: isNumeric(width) ? "".concat(width, "px") : width,
          height: isNumeric(height) ? "".concat(height, "px") : height
        }, contentWrapperStyle),
        ref: function ref(c2) {
          _this3.contentWrapper = c2;
        }
      }, /* @__PURE__ */ React.createElement("div", {
        className: "".concat(prefixCls, "-content"),
        ref: function ref(c2) {
          _this3.contentDom = c2;
        }
      }, children), handlerChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, _ref2) {
      var prevProps = _ref2.prevProps, _self = _ref2._self;
      var nextState = {
        prevProps: props
      };
      if (prevProps !== void 0) {
        var placement = props.placement, level = props.level;
        if (placement !== prevProps.placement) {
          _self.contentDom = null;
        }
        if (level !== prevProps.level) {
          _self.getLevelDom(props);
        }
      }
      return nextState;
    }
  }]);
  return DrawerChild2;
}(React.Component);
var _excluded = ["defaultOpen", "getContainer", "wrapperClassName", "forceRender", "handler"], _excluded2 = ["visible", "afterClose"];
var DrawerWrapper$1 = /* @__PURE__ */ function(_React$Component) {
  _inherits(DrawerWrapper2, _React$Component);
  var _super = _createSuper(DrawerWrapper2);
  function DrawerWrapper2(props) {
    var _this;
    _classCallCheck(this, DrawerWrapper2);
    _this = _super.call(this, props);
    _this.dom = void 0;
    _this.onHandleClick = function(e2) {
      var _this$props = _this.props, onHandleClick = _this$props.onHandleClick, $open = _this$props.open;
      if (onHandleClick) {
        onHandleClick(e2);
      }
      if (typeof $open === "undefined") {
        var open = _this.state.open;
        _this.setState({
          open: !open
        });
      }
    };
    _this.onClose = function(e2) {
      var _this$props2 = _this.props, onClose = _this$props2.onClose, open = _this$props2.open;
      if (onClose) {
        onClose(e2);
      }
      if (typeof open === "undefined") {
        _this.setState({
          open: false
        });
      }
    };
    var _open = typeof props.open !== "undefined" ? props.open : !!props.defaultOpen;
    _this.state = {
      open: _open
    };
    if ("onMaskClick" in props) {
      console.warn("`onMaskClick` are removed, please use `onClose` instead.");
    }
    return _this;
  }
  _createClass(DrawerWrapper2, [{
    key: "render",
    value: function render2() {
      var _this2 = this;
      var _this$props3 = this.props;
      _this$props3.defaultOpen;
      var getContainer2 = _this$props3.getContainer, wrapperClassName = _this$props3.wrapperClassName, forceRender = _this$props3.forceRender, handler = _this$props3.handler, props = _objectWithoutProperties(_this$props3, _excluded);
      var open = this.state.open;
      if (!getContainer2) {
        return /* @__PURE__ */ React.createElement("div", {
          className: wrapperClassName,
          ref: function ref(c2) {
            _this2.dom = c2;
          }
        }, /* @__PURE__ */ React.createElement(DrawerChild, _extends$1({}, props, {
          open,
          handler,
          getContainer: function getContainer3() {
            return _this2.dom;
          },
          onClose: this.onClose,
          onHandleClick: this.onHandleClick
        })));
      }
      var $forceRender = !!handler || forceRender;
      return /* @__PURE__ */ React.createElement(PortalWrapper, {
        visible: open,
        forceRender: $forceRender,
        getContainer: getContainer2,
        wrapperClassName
      }, function(_ref) {
        var visible = _ref.visible, afterClose = _ref.afterClose, rest = _objectWithoutProperties(_ref, _excluded2);
        return /* @__PURE__ */ React.createElement(DrawerChild, _extends$1({}, props, rest, {
          open: visible !== void 0 ? visible : open,
          afterVisibleChange: afterClose !== void 0 ? afterClose : props.afterVisibleChange,
          handler,
          onClose: _this2.onClose,
          onHandleClick: _this2.onHandleClick
        }));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, _ref2) {
      var prevProps = _ref2.prevProps;
      var newState = {
        prevProps: props
      };
      if (typeof prevProps !== "undefined" && props.open !== prevProps.open) {
        newState.open = props.open;
      }
      return newState;
    }
  }]);
  return DrawerWrapper2;
}(React.Component);
DrawerWrapper$1.defaultProps = {
  prefixCls: "drawer",
  placement: "left",
  getContainer: "body",
  defaultOpen: false,
  level: "all",
  duration: ".3s",
  ease: "cubic-bezier(0.78, 0.14, 0.15, 0.86)",
  onChange: function onChange2() {
  },
  afterVisibleChange: function afterVisibleChange() {
  },
  handler: /* @__PURE__ */ React.createElement("div", {
    className: "drawer-handle"
  }, /* @__PURE__ */ React.createElement("i", {
    className: "drawer-handle-icon"
  })),
  showMask: true,
  maskClosable: true,
  maskStyle: {},
  wrapperClassName: "",
  className: "",
  keyboard: true,
  forceRender: false,
  autoFocus: true
};
var __rest$2 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var DrawerContext = /* @__PURE__ */ React.createContext(null);
tuple("top", "right", "bottom", "left");
tuple("default", "large");
var defaultPushState = {
  distance: 180
};
var Drawer = /* @__PURE__ */ React.forwardRef(function(_a2, ref) {
  var width = _a2.width, height = _a2.height, _a$size = _a2.size, size = _a$size === void 0 ? "default" : _a$size, _a$closable = _a2.closable, closable = _a$closable === void 0 ? true : _a$closable, _a$placement = _a2.placement, placement = _a$placement === void 0 ? "right" : _a$placement, _a$maskClosable = _a2.maskClosable, maskClosable = _a$maskClosable === void 0 ? true : _a$maskClosable, _a$mask = _a2.mask, mask = _a$mask === void 0 ? true : _a$mask, _a$level = _a2.level, level = _a$level === void 0 ? null : _a$level, _a$keyboard = _a2.keyboard, keyboard = _a$keyboard === void 0 ? true : _a$keyboard, _a$push = _a2.push, _push = _a$push === void 0 ? defaultPushState : _a$push, _a$closeIcon = _a2.closeIcon, closeIcon = _a$closeIcon === void 0 ? /* @__PURE__ */ React.createElement(CloseOutlined$1, null) : _a$closeIcon, bodyStyle = _a2.bodyStyle, drawerStyle = _a2.drawerStyle, prefixCls = _a2.prefixCls, className = _a2.className, direction = _a2.direction, visible = _a2.visible, children = _a2.children, zIndex = _a2.zIndex, destroyOnClose = _a2.destroyOnClose, style2 = _a2.style, title = _a2.title, headerStyle = _a2.headerStyle, onClose = _a2.onClose, footer = _a2.footer, footerStyle = _a2.footerStyle, extra = _a2.extra, rest = __rest$2(_a2, ["width", "height", "size", "closable", "placement", "maskClosable", "mask", "level", "keyboard", "push", "closeIcon", "bodyStyle", "drawerStyle", "prefixCls", "className", "direction", "visible", "children", "zIndex", "destroyOnClose", "style", "title", "headerStyle", "onClose", "footer", "footerStyle", "extra"]);
  var forceUpdate = useForceUpdate();
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), internalPush = _React$useState2[0], setPush = _React$useState2[1];
  var parentDrawer = React.useContext(DrawerContext);
  var destroyClose = React.useRef(false);
  React.useEffect(function() {
    if (visible && parentDrawer) {
      parentDrawer.push();
    }
    return function() {
      if (parentDrawer) {
        parentDrawer.pull();
      }
    };
  }, []);
  React.useEffect(function() {
    if (parentDrawer) {
      if (visible) {
        parentDrawer.push();
      } else {
        parentDrawer.pull();
      }
    }
  }, [visible]);
  var operations = React.useMemo(function() {
    return {
      push: function push2() {
        if (_push) {
          setPush(true);
        }
      },
      pull: function pull() {
        if (_push) {
          setPush(false);
        }
      }
    };
  }, [_push]);
  React.useImperativeHandle(ref, function() {
    return operations;
  }, [operations]);
  var isDestroyOnClose = destroyOnClose && !visible;
  var onDestroyTransitionEnd = function onDestroyTransitionEnd2() {
    if (!isDestroyOnClose) {
      return;
    }
    if (!visible) {
      destroyClose.current = true;
      forceUpdate();
    }
  };
  var getOffsetStyle = function getOffsetStyle2() {
    if (!visible && !mask) {
      return {};
    }
    var offsetStyle2 = {};
    if (placement === "left" || placement === "right") {
      var defaultWidth = size === "large" ? 736 : 378;
      offsetStyle2.width = typeof width === "undefined" ? defaultWidth : width;
    } else {
      var defaultHeight = size === "large" ? 736 : 378;
      offsetStyle2.height = typeof height === "undefined" ? defaultHeight : height;
    }
    return offsetStyle2;
  };
  var getRcDrawerStyle = function getRcDrawerStyle2() {
    var getPushTransform = function getPushTransform2(_placement) {
      var distance2;
      if (typeof _push === "boolean") {
        distance2 = _push ? defaultPushState.distance : 0;
      } else {
        distance2 = _push.distance;
      }
      distance2 = parseFloat(String(distance2 || 0));
      if (_placement === "left" || _placement === "right") {
        return "translateX(".concat(_placement === "left" ? distance2 : -distance2, "px)");
      }
      if (_placement === "top" || _placement === "bottom") {
        return "translateY(".concat(_placement === "top" ? distance2 : -distance2, "px)");
      }
    };
    var offsetStyle2 = mask ? {} : getOffsetStyle();
    return _extends$1(_extends$1({
      zIndex,
      transform: internalPush ? getPushTransform(placement) : void 0
    }, offsetStyle2), style2);
  };
  var closeIconNode = closable && /* @__PURE__ */ React.createElement("button", {
    type: "button",
    onClick: onClose,
    "aria-label": "Close",
    className: "".concat(prefixCls, "-close")
  }, closeIcon);
  function renderHeader() {
    if (!title && !closable) {
      return null;
    }
    return /* @__PURE__ */ React.createElement("div", {
      className: classNames("".concat(prefixCls, "-header"), _defineProperty$1({}, "".concat(prefixCls, "-header-close-only"), closable && !title && !extra)),
      style: headerStyle
    }, /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-header-title")
    }, closeIconNode, title && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-title")
    }, title)), extra && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-extra")
    }, extra));
  }
  function renderFooter() {
    if (!footer) {
      return null;
    }
    var footerClassName = "".concat(prefixCls, "-footer");
    return /* @__PURE__ */ React.createElement("div", {
      className: footerClassName,
      style: footerStyle
    }, footer);
  }
  var renderBody = function renderBody2() {
    if (destroyClose.current && !visible) {
      return null;
    }
    destroyClose.current = false;
    var containerStyle = {};
    if (isDestroyOnClose) {
      containerStyle.opacity = 0;
      containerStyle.transition = "opacity .3s";
    }
    return /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-wrapper-body"),
      style: _extends$1(_extends$1({}, containerStyle), drawerStyle),
      onTransitionEnd: onDestroyTransitionEnd
    }, renderHeader(), /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-body"),
      style: bodyStyle
    }, children), renderFooter());
  };
  var drawerClassName = classNames(_defineProperty$1({
    "no-mask": !mask
  }, "".concat(prefixCls, "-rtl"), direction === "rtl"), className);
  var offsetStyle = mask ? getOffsetStyle() : {};
  return /* @__PURE__ */ React.createElement(DrawerContext.Provider, {
    value: operations
  }, /* @__PURE__ */ React.createElement(DrawerWrapper$1, _extends$1({
    handler: false
  }, _extends$1({
    placement,
    prefixCls,
    maskClosable,
    level,
    keyboard,
    children,
    onClose
  }, rest), offsetStyle, {
    open: visible,
    showMask: mask,
    style: getRcDrawerStyle(),
    className: drawerClassName
  }), renderBody()));
});
Drawer.displayName = "Drawer";
var DrawerWrapper = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var customizePrefixCls = props.prefixCls, customizeGetContainer = props.getContainer;
  var _React$useContext = React.useContext(ConfigContext), getPopupContainer = _React$useContext.getPopupContainer, getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var prefixCls = getPrefixCls("drawer", customizePrefixCls);
  var getContainer2 = customizeGetContainer === void 0 && getPopupContainer ? function() {
    return getPopupContainer(document.body);
  } : customizeGetContainer;
  return /* @__PURE__ */ React.createElement(Drawer, _extends$1({}, props, {
    ref,
    prefixCls,
    getContainer: getContainer2,
    direction
  }));
});
DrawerWrapper.displayName = "DrawerWrapper";
var Drawer$1 = DrawerWrapper;
function Item(_ref) {
  var className = _ref.className, direction = _ref.direction, index2 = _ref.index, marginDirection = _ref.marginDirection, children = _ref.children, split2 = _ref.split, wrap = _ref.wrap;
  var _React$useContext = React.useContext(SpaceContext), horizontalSize = _React$useContext.horizontalSize, verticalSize = _React$useContext.verticalSize, latestIndex = _React$useContext.latestIndex, supportFlexGap = _React$useContext.supportFlexGap;
  var style2 = {};
  if (!supportFlexGap) {
    if (direction === "vertical") {
      if (index2 < latestIndex) {
        style2 = {
          marginBottom: horizontalSize / (split2 ? 2 : 1)
        };
      }
    } else {
      style2 = _extends$1(_extends$1({}, index2 < latestIndex && _defineProperty$1({}, marginDirection, horizontalSize / (split2 ? 2 : 1))), wrap && {
        paddingBottom: verticalSize
      });
    }
  }
  if (children === null || children === void 0) {
    return null;
  }
  return /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement("div", {
    className,
    style: style2
  }, children), index2 < latestIndex && split2 && /* @__PURE__ */ React.createElement("span", {
    className: "".concat(className, "-split"),
    style: style2
  }, split2));
}
var __rest$1 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var SpaceContext = /* @__PURE__ */ React.createContext({
  latestIndex: 0,
  horizontalSize: 0,
  verticalSize: 0,
  supportFlexGap: false
});
var spaceSize = {
  small: 8,
  middle: 16,
  large: 24
};
function getNumberSize(size) {
  return typeof size === "string" ? spaceSize[size] : size || 0;
}
var Space = function Space2(props) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, space = _React$useContext.space, directionConfig = _React$useContext.direction;
  var _props$size = props.size, size = _props$size === void 0 ? (space === null || space === void 0 ? void 0 : space.size) || "small" : _props$size, align = props.align, className = props.className, children = props.children, _props$direction = props.direction, direction = _props$direction === void 0 ? "horizontal" : _props$direction, customizePrefixCls = props.prefixCls, split2 = props.split, style2 = props.style, _props$wrap = props.wrap, wrap = _props$wrap === void 0 ? false : _props$wrap, otherProps = __rest$1(props, ["size", "align", "className", "children", "direction", "prefixCls", "split", "style", "wrap"]);
  var supportFlexGap = useFlexGapSupport();
  var _React$useMemo = React.useMemo(function() {
    return (Array.isArray(size) ? size : [size, size]).map(function(item) {
      return getNumberSize(item);
    });
  }, [size]), _React$useMemo2 = _slicedToArray(_React$useMemo, 2), horizontalSize = _React$useMemo2[0], verticalSize = _React$useMemo2[1];
  var childNodes = toArray$1(children, {
    keepEmpty: true
  });
  var mergedAlign = align === void 0 && direction === "horizontal" ? "center" : align;
  var prefixCls = getPrefixCls("space", customizePrefixCls);
  var cn = classNames(prefixCls, "".concat(prefixCls, "-").concat(direction), (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), directionConfig === "rtl"), _defineProperty$1(_classNames, "".concat(prefixCls, "-align-").concat(mergedAlign), mergedAlign), _classNames), className);
  var itemClassName = "".concat(prefixCls, "-item");
  var marginDirection = directionConfig === "rtl" ? "marginLeft" : "marginRight";
  var latestIndex = 0;
  var nodes = childNodes.map(function(child, i) {
    if (child !== null && child !== void 0) {
      latestIndex = i;
    }
    var keyOfChild = child && child.key;
    return /* @__PURE__ */ React.createElement(Item, {
      className: itemClassName,
      key: "".concat(itemClassName, "-").concat(keyOfChild || i),
      direction,
      index: i,
      marginDirection,
      split: split2,
      wrap
    }, child);
  });
  var spaceContext = React.useMemo(function() {
    return {
      horizontalSize,
      verticalSize,
      latestIndex,
      supportFlexGap
    };
  }, [horizontalSize, verticalSize, latestIndex, supportFlexGap]);
  if (childNodes.length === 0) {
    return null;
  }
  var gapStyle = {};
  if (wrap) {
    gapStyle.flexWrap = "wrap";
    if (!supportFlexGap) {
      gapStyle.marginBottom = -verticalSize;
    }
  }
  if (supportFlexGap) {
    gapStyle.columnGap = horizontalSize;
    gapStyle.rowGap = verticalSize;
  }
  return /* @__PURE__ */ React.createElement("div", _extends$1({
    className: cn,
    style: _extends$1(_extends$1({}, gapStyle), style2)
  }, otherProps), /* @__PURE__ */ React.createElement(SpaceContext.Provider, {
    value: spaceContext
  }, nodes));
};
var Space$1 = Space;
var Switch$2 = React.forwardRef(function(_ref, ref) {
  var _classNames;
  var _ref$prefixCls = _ref.prefixCls, prefixCls = _ref$prefixCls === void 0 ? "rc-switch" : _ref$prefixCls, className = _ref.className, checked = _ref.checked, defaultChecked = _ref.defaultChecked, disabled = _ref.disabled, loadingIcon = _ref.loadingIcon, checkedChildren = _ref.checkedChildren, unCheckedChildren = _ref.unCheckedChildren, onClick = _ref.onClick, onChange3 = _ref.onChange, onKeyDown2 = _ref.onKeyDown, restProps = _objectWithoutProperties(_ref, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]);
  var _useMergedState = useControlledState(false, {
    value: checked,
    defaultValue: defaultChecked
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), innerChecked = _useMergedState2[0], setInnerChecked = _useMergedState2[1];
  function triggerChange(newChecked, event) {
    var mergedChecked = innerChecked;
    if (!disabled) {
      mergedChecked = newChecked;
      setInnerChecked(mergedChecked);
      onChange3 === null || onChange3 === void 0 ? void 0 : onChange3(mergedChecked, event);
    }
    return mergedChecked;
  }
  function onInternalKeyDown(e2) {
    if (e2.which === KeyCode.LEFT) {
      triggerChange(false, e2);
    } else if (e2.which === KeyCode.RIGHT) {
      triggerChange(true, e2);
    }
    onKeyDown2 === null || onKeyDown2 === void 0 ? void 0 : onKeyDown2(e2);
  }
  function onInternalClick(e2) {
    var ret = triggerChange(!innerChecked, e2);
    onClick === null || onClick === void 0 ? void 0 : onClick(ret, e2);
  }
  var switchClassName = classNames(prefixCls, className, (_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-checked"), innerChecked), _defineProperty$1(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
  return React.createElement("button", Object.assign({}, restProps, {
    type: "button",
    role: "switch",
    "aria-checked": innerChecked,
    disabled,
    className: switchClassName,
    ref,
    onKeyDown: onInternalKeyDown,
    onClick: onInternalClick
  }), loadingIcon, React.createElement("span", {
    className: "".concat(prefixCls, "-inner")
  }, innerChecked ? checkedChildren : unCheckedChildren));
});
Switch$2.displayName = "Switch";
var __rest = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var Switch = /* @__PURE__ */ React.forwardRef(function(_a2, ref) {
  var _classNames;
  var customizePrefixCls = _a2.prefixCls, customizeSize = _a2.size, loading = _a2.loading, _a$className = _a2.className, className = _a$className === void 0 ? "" : _a$className, disabled = _a2.disabled, props = __rest(_a2, ["prefixCls", "size", "loading", "className", "disabled"]);
  devWarning("checked" in props || !("value" in props), "Switch", "`value` is not a valid prop, do you mean `checked`?");
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var size = React.useContext(SizeContext$1);
  var prefixCls = getPrefixCls("switch", customizePrefixCls);
  var loadingIcon = /* @__PURE__ */ React.createElement("div", {
    className: "".concat(prefixCls, "-handle")
  }, loading && /* @__PURE__ */ React.createElement(LoadingOutlined$1, {
    className: "".concat(prefixCls, "-loading-icon")
  }));
  var classes = classNames((_classNames = {}, _defineProperty$1(_classNames, "".concat(prefixCls, "-small"), (customizeSize || size) === "small"), _defineProperty$1(_classNames, "".concat(prefixCls, "-loading"), loading), _defineProperty$1(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  return /* @__PURE__ */ React.createElement(Wave, {
    insertExtraNode: true
  }, /* @__PURE__ */ React.createElement(Switch$2, _extends$1({}, props, {
    prefixCls,
    className: classes,
    disabled: disabled || loading,
    ref,
    loadingIcon
  })));
});
Switch.__ANT_SWITCH = true;
Switch.displayName = "Switch";
var Switch$1 = Switch;
var _default = "";
var index$7 = "";
var index$6 = "";
var index$5 = "";
var index$4 = "";
var index$3 = "";
var index$2 = "";
var index$1 = "";
const container = "_container_oi76t_1";
var styles = {
  container,
  "function": "_function_oi76t_10"
};
var index = "";
var reactEchartsJson_cjs = {};
(function(exports) {
  var Wor = Object.defineProperty;
  var a6e = Object.getOwnPropertySymbols;
  var Gor = Object.prototype.hasOwnProperty, Hor = Object.prototype.propertyIsEnumerable;
  var EKt = (f2, i, t2) => i in f2 ? Wor(f2, i, { enumerable: true, configurable: true, writable: true, value: t2 }) : f2[i] = t2, o6e = (f2, i) => {
    for (var t2 in i || (i = {}))
      Gor.call(i, t2) && EKt(f2, t2, i[t2]);
    if (a6e)
      for (var t2 of a6e(i))
        Hor.call(i, t2) && EKt(f2, t2, i[t2]);
    return f2;
  };
  var XM = (f2, i, t2) => (EKt(f2, typeof i != "symbol" ? i + "" : i, t2), t2);
  Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
  var dp = React__default;
  function Uor(f2) {
    return f2 && typeof f2 == "object" && "default" in f2 ? f2 : { default: f2 };
  }
  function qor(f2) {
    if (f2 && f2.__esModule)
      return f2;
    var i = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
    return f2 && Object.keys(f2).forEach(function(t2) {
      if (t2 !== "default") {
        var h = Object.getOwnPropertyDescriptor(f2, t2);
        Object.defineProperty(i, t2, h.get ? h : { enumerable: true, get: function() {
          return f2[t2];
        } });
      }
    }), i.default = f2, Object.freeze(i);
  }
  var ztt = Uor(dp), Vo = qor(dp), Zor = globalThis && globalThis.__read || function(f2, i) {
    var t2 = typeof Symbol == "function" && f2[Symbol.iterator];
    if (!t2)
      return f2;
    var h = t2.call(f2), v4, _ = [], M2;
    try {
      for (; (i === void 0 || i-- > 0) && !(v4 = h.next()).done; )
        _.push(v4.value);
    } catch (I2) {
      M2 = { error: I2 };
    } finally {
      try {
        v4 && !v4.done && (t2 = h.return) && t2.call(h);
      } finally {
        if (M2)
          throw M2.error;
      }
    }
    return _;
  };
  function $or(f2, i) {
    f2 === void 0 && (f2 = false);
    var t2 = Zor(dp.useState(f2), 2), h = t2[0], v4 = t2[1], _ = dp.useMemo(function() {
      var M2 = i === void 0 ? !f2 : i, I2 = function() {
        return v4(function($) {
          return $ === f2 ? M2 : f2;
        });
      }, P2 = function($) {
        return v4($);
      }, N3 = function() {
        return v4(f2);
      }, z3 = function() {
        return v4(M2);
      };
      return { toggle: I2, set: P2, setLeft: N3, setRight: z3 };
    }, []);
    return [h, _];
  }
  var Yor = globalThis && globalThis.__read || function(f2, i) {
    var t2 = typeof Symbol == "function" && f2[Symbol.iterator];
    if (!t2)
      return f2;
    var h = t2.call(f2), v4, _ = [], M2;
    try {
      for (; (i === void 0 || i-- > 0) && !(v4 = h.next()).done; )
        _.push(v4.value);
    } catch (I2) {
      M2 = { error: I2 };
    } finally {
      try {
        v4 && !v4.done && (t2 = h.return) && t2.call(h);
      } finally {
        if (M2)
          throw M2.error;
      }
    }
    return _;
  };
  function Kor(f2) {
    f2 === void 0 && (f2 = false);
    var i = Yor($or(f2), 2), t2 = i[0], h = i[1], v4 = h.toggle, _ = h.set, M2 = dp.useMemo(function() {
      var I2 = function() {
        return _(true);
      }, P2 = function() {
        return _(false);
      };
      return { toggle: v4, set: function(z3) {
        return _(!!z3);
      }, setTrue: I2, setFalse: P2 };
    }, []);
    return [t2, M2];
  }
  function dee(f2) {
    var i = dp.useRef(f2);
    return i.current = f2, i;
  }
  var Xor = !!(typeof window != "undefined" && window.document && window.document.createElement), Qor = Xor;
  function HBe(f2, i) {
    if (!!Qor) {
      if (!f2)
        return i;
      var t2;
      return typeof f2 == "function" ? t2 = f2() : "current" in f2 ? t2 = f2.current : t2 = f2, t2;
    }
  }
  var Jor = function(i) {
    var t2 = dee(i);
    dp.useEffect(function() {
      return function() {
        t2.current();
      };
    }, []);
  }, gee = Jor;
  function s6e(f2, i) {
    if (f2 === i)
      return true;
    for (var t2 = 0; t2 < f2.length; t2++)
      if (!Object.is(f2[t2], i[t2]))
        return false;
    return true;
  }
  var tsr = function(i) {
    var t2 = function(v4, _, M2) {
      var I2 = dp.useRef(false), P2 = dp.useRef([]), N3 = dp.useRef([]), z3 = dp.useRef();
      i(function() {
        var H2, $ = Array.isArray(M2) ? M2 : [M2], et = $.map(function(at) {
          return HBe(at);
        });
        if (!I2.current) {
          I2.current = true, P2.current = et, N3.current = _, z3.current = v4();
          return;
        }
        (et.length !== P2.current.length || !s6e(et, P2.current) || !s6e(_, N3.current)) && ((H2 = z3.current) === null || H2 === void 0 || H2.call(z3), P2.current = et, N3.current = _, z3.current = v4());
      }), gee(function() {
        var H2;
        (H2 = z3.current) === null || H2 === void 0 || H2.call(z3), I2.current = false;
      });
    };
    return t2;
  }, esr = tsr, nsr = esr(dp.useEffect), rsr = nsr, YD = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof commonjsGlobal != "undefined" ? commonjsGlobal : typeof self != "undefined" ? self : {};
  function isr(f2) {
    return f2 && f2.__esModule && Object.prototype.hasOwnProperty.call(f2, "default") ? f2.default : f2;
  }
  function asr(f2) {
    var i = typeof f2;
    return f2 != null && (i == "object" || i == "function");
  }
  var UBe = asr, osr = typeof YD == "object" && YD && YD.Object === Object && YD, ssr = osr, lsr = ssr, usr = typeof self == "object" && self && self.Object === Object && self, csr = lsr || usr || Function("return this")(), qBe = csr, fsr = qBe, hsr = function() {
    return fsr.Date.now();
  }, psr = hsr, dsr = /\s/;
  function gsr(f2) {
    for (var i = f2.length; i-- && dsr.test(f2.charAt(i)); )
      ;
    return i;
  }
  var vsr = gsr, ysr = vsr, msr = /^\s+/;
  function bsr(f2) {
    return f2 && f2.slice(0, ysr(f2) + 1).replace(msr, "");
  }
  var _sr = bsr, xsr = qBe, wsr = xsr.Symbol, ZBe = wsr, l6e = ZBe, $Be = Object.prototype, Ssr = $Be.hasOwnProperty, Msr = $Be.toString, Rpt = l6e ? l6e.toStringTag : void 0;
  function Csr(f2) {
    var i = Ssr.call(f2, Rpt), t2 = f2[Rpt];
    try {
      f2[Rpt] = void 0;
      var h = true;
    } catch {
    }
    var v4 = Msr.call(f2);
    return h && (i ? f2[Rpt] = t2 : delete f2[Rpt]), v4;
  }
  var Tsr = Csr, Asr = Object.prototype, Isr = Asr.toString;
  function Dsr(f2) {
    return Isr.call(f2);
  }
  var Esr = Dsr, u6e = ZBe, ksr = Tsr, Psr = Esr, Lsr = "[object Null]", Osr = "[object Undefined]", c6e = u6e ? u6e.toStringTag : void 0;
  function Rsr(f2) {
    return f2 == null ? f2 === void 0 ? Osr : Lsr : c6e && c6e in Object(f2) ? ksr(f2) : Psr(f2);
  }
  var Nsr = Rsr;
  function Fsr(f2) {
    return f2 != null && typeof f2 == "object";
  }
  var Vsr = Fsr, Bsr = Nsr, zsr = Vsr, jsr = "[object Symbol]";
  function Wsr(f2) {
    return typeof f2 == "symbol" || zsr(f2) && Bsr(f2) == jsr;
  }
  var Gsr = Wsr, Hsr = _sr, f6e = UBe, Usr = Gsr, h6e = 0 / 0, qsr = /^[-+]0x[0-9a-f]+$/i, Zsr = /^0b[01]+$/i, $sr = /^0o[0-7]+$/i, Ysr = parseInt;
  function Ksr(f2) {
    if (typeof f2 == "number")
      return f2;
    if (Usr(f2))
      return h6e;
    if (f6e(f2)) {
      var i = typeof f2.valueOf == "function" ? f2.valueOf() : f2;
      f2 = f6e(i) ? i + "" : i;
    }
    if (typeof f2 != "string")
      return f2 === 0 ? f2 : +f2;
    f2 = Hsr(f2);
    var t2 = Zsr.test(f2);
    return t2 || $sr.test(f2) ? Ysr(f2.slice(2), t2 ? 2 : 8) : qsr.test(f2) ? h6e : +f2;
  }
  var Xsr = Ksr, Qsr = UBe, kKt = psr, p6e = Xsr, Jsr = "Expected a function", tlr = Math.max, elr = Math.min;
  function nlr(f2, i, t2) {
    var h, v4, _, M2, I2, P2, N3 = 0, z3 = false, H2 = false, $ = true;
    if (typeof f2 != "function")
      throw new TypeError(Jsr);
    i = p6e(i) || 0, Qsr(t2) && (z3 = !!t2.leading, H2 = "maxWait" in t2, _ = H2 ? tlr(p6e(t2.maxWait) || 0, i) : _, $ = "trailing" in t2 ? !!t2.trailing : $);
    function et(re2) {
      var ye = h, me2 = v4;
      return h = v4 = void 0, N3 = re2, M2 = f2.apply(me2, ye), M2;
    }
    function at(re2) {
      return N3 = re2, I2 = setTimeout(_t, i), z3 ? et(re2) : M2;
    }
    function ht(re2) {
      var ye = re2 - P2, me2 = re2 - N3, be2 = i - ye;
      return H2 ? elr(be2, _ - me2) : be2;
    }
    function bt(re2) {
      var ye = re2 - P2, me2 = re2 - N3;
      return P2 === void 0 || ye >= i || ye < 0 || H2 && me2 >= _;
    }
    function _t() {
      var re2 = kKt();
      if (bt(re2))
        return Et(re2);
      I2 = setTimeout(_t, ht(re2));
    }
    function Et(re2) {
      return I2 = void 0, $ && h ? et(re2) : (h = v4 = void 0, M2);
    }
    function zt() {
      I2 !== void 0 && clearTimeout(I2), N3 = 0, h = P2 = v4 = I2 = void 0;
    }
    function Ft() {
      return I2 === void 0 ? M2 : Et(kKt());
    }
    function fe2() {
      var re2 = kKt(), ye = bt(re2);
      if (h = arguments, v4 = this, P2 = re2, ye) {
        if (I2 === void 0)
          return at(P2);
        if (H2)
          return clearTimeout(I2), I2 = setTimeout(_t, i), et(P2);
      }
      return I2 === void 0 && (I2 = setTimeout(_t, i)), M2;
    }
    return fe2.cancel = zt, fe2.flush = Ft, fe2;
  }
  var rlr = nlr, ilr = globalThis && globalThis.__read || function(f2, i) {
    var t2 = typeof Symbol == "function" && f2[Symbol.iterator];
    if (!t2)
      return f2;
    var h = t2.call(f2), v4, _ = [], M2;
    try {
      for (; (i === void 0 || i-- > 0) && !(v4 = h.next()).done; )
        _.push(v4.value);
    } catch (I2) {
      M2 = { error: I2 };
    } finally {
      try {
        v4 && !v4.done && (t2 = h.return) && t2.call(h);
      } finally {
        if (M2)
          throw M2.error;
      }
    }
    return _;
  }, alr = globalThis && globalThis.__spread || function() {
    for (var f2 = [], i = 0; i < arguments.length; i++)
      f2 = f2.concat(ilr(arguments[i]));
    return f2;
  };
  function olr(f2, i) {
    var t2, h = dee(f2), v4 = (t2 = i == null ? void 0 : i.wait) !== null && t2 !== void 0 ? t2 : 1e3, _ = dp.useMemo(function() {
      return rlr(function() {
        for (var M2 = [], I2 = 0; I2 < arguments.length; I2++)
          M2[I2] = arguments[I2];
        return h.current.apply(h, alr(M2));
      }, v4, i);
    }, []);
    return gee(function() {
      _.cancel();
    }), { run: _, cancel: _.cancel, flush: _.flush };
  }
  var slr = function(i) {
    return function(t2, h) {
      var v4 = dp.useRef(false);
      i(function() {
        return function() {
          v4.current = false;
        };
      }, []), i(function() {
        if (!v4.current)
          v4.current = true;
        else
          return t2();
      }, h);
    };
  }, llr = slr(dp.useEffect), ulr = globalThis && globalThis.__read || function(f2, i) {
    var t2 = typeof Symbol == "function" && f2[Symbol.iterator];
    if (!t2)
      return f2;
    var h = t2.call(f2), v4, _ = [], M2;
    try {
      for (; (i === void 0 || i-- > 0) && !(v4 = h.next()).done; )
        _.push(v4.value);
    } catch (I2) {
      M2 = { error: I2 };
    } finally {
      try {
        v4 && !v4.done && (t2 = h.return) && t2.call(h);
      } finally {
        if (M2)
          throw M2.error;
      }
    }
    return _;
  };
  function clr(f2, i, t2) {
    var h = ulr(dp.useState({}), 2), v4 = h[0], _ = h[1], M2 = olr(function() {
      _({});
    }, t2), I2 = M2.run, P2 = M2.cancel;
    dp.useEffect(function() {
      return I2();
    }, i), gee(P2), llr(f2, [v4]);
  }
  function flr(f2, i, t2) {
    t2 === void 0 && (t2 = {});
    var h = dee(i);
    rsr(function() {
      var v4 = HBe(t2.target, window);
      if (!!(v4 != null && v4.addEventListener)) {
        var _ = function(I2) {
          return h.current(I2);
        };
        return v4.addEventListener(f2, _, { capture: t2.capture, once: t2.once, passive: t2.passive }), function() {
          v4.removeEventListener(f2, _, { capture: t2.capture });
        };
      }
    }, [f2, t2.capture, t2.once, t2.passive], t2.target);
  }
  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.
  
  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.
  
  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  var fJt = function(f2, i) {
    return fJt = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(t2, h) {
      t2.__proto__ = h;
    } || function(t2, h) {
      for (var v4 in h)
        Object.prototype.hasOwnProperty.call(h, v4) && (t2[v4] = h[v4]);
    }, fJt(f2, i);
  };
  function ii2(f2, i) {
    if (typeof i != "function" && i !== null)
      throw new TypeError("Class extends value " + String(i) + " is not a constructor or null");
    fJt(f2, i);
    function t2() {
      this.constructor = f2;
    }
    f2.prototype = i === null ? Object.create(i) : (t2.prototype = i.prototype, new t2());
  }
  var hlr = function() {
    function f2() {
      this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
    }
    return f2;
  }(), plr = function() {
    function f2() {
      this.browser = new hlr(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
    }
    return f2;
  }(), WH2 = new plr();
  typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (WH2.wxa = true, WH2.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? WH2.worker = true : typeof navigator == "undefined" ? (WH2.node = true, WH2.svgSupported = true) : dlr(navigator.userAgent, WH2);
  function dlr(f2, i) {
    var t2 = i.browser, h = f2.match(/Firefox\/([\d.]+)/), v4 = f2.match(/MSIE\s([\d.]+)/) || f2.match(/Trident\/.+?rv:(([\d.]+))/), _ = f2.match(/Edge?\/([\d.]+)/), M2 = /micromessenger/i.test(f2);
    h && (t2.firefox = true, t2.version = h[1]), v4 && (t2.ie = true, t2.version = v4[1]), _ && (t2.edge = true, t2.version = _[1], t2.newEdge = +_[1].split(".")[0] > 18), M2 && (t2.weChat = true), i.svgSupported = typeof SVGRect != "undefined", i.touchEventsSupported = "ontouchstart" in window && !t2.ie && !t2.edge, i.pointerEventsSupported = "onpointerdown" in window && (t2.edge || t2.ie && +t2.version >= 11), i.domSupported = typeof document != "undefined";
    var I2 = document.documentElement.style;
    i.transform3dSupported = (t2.ie && "transition" in I2 || t2.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in I2) && !("OTransition" in I2), i.transformSupported = i.transform3dSupported || t2.ie && +t2.version >= 9;
  }
  var gp = WH2, vee = 12, YBe = "sans-serif", K7 = vee + "px " + YBe, glr = 20, vlr = 100, ylr = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
  function mlr(f2) {
    var i = {};
    if (typeof JSON == "undefined")
      return i;
    for (var t2 = 0; t2 < f2.length; t2++) {
      var h = String.fromCharCode(t2 + 32), v4 = (f2.charCodeAt(t2) - glr) / vlr;
      i[h] = v4;
    }
    return i;
  }
  var blr = mlr(ylr), Q6 = { createCanvas: function() {
    return typeof document != "undefined" && document.createElement("canvas");
  }, measureText: function() {
    var f2, i;
    return function(t2, h) {
      if (!f2) {
        var v4 = Q6.createCanvas();
        f2 = v4 && v4.getContext("2d");
      }
      if (f2)
        return i !== h && (i = f2.font = h || K7), f2.measureText(t2);
      t2 = t2 || "", h = h || K7;
      var _ = /^([0-9]*?)px$/.exec(h), M2 = +(_ && _[1]) || vee, I2 = 0;
      if (h.indexOf("mono") >= 0)
        I2 = M2 * t2.length;
      else
        for (var P2 = 0; P2 < t2.length; P2++) {
          var N3 = blr[t2[P2]];
          I2 += N3 == null ? M2 : N3 * M2;
        }
      return { width: I2 };
    };
  }(), loadImage: function(f2, i, t2) {
    var h = new Image();
    return h.onload = i, h.onerror = t2, h.src = f2, h;
  } }, KBe = zL(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(f2, i) {
    return f2["[object " + i + "]"] = true, f2;
  }, {}), XBe = zL(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(f2, i) {
    return f2["[object " + i + "Array]"] = true, f2;
  }, {}), Ktt = Object.prototype.toString, akt = Array.prototype, _lr = akt.forEach, xlr = akt.filter, yee = akt.slice, wlr = akt.map, d6e = function() {
  }.constructor, DIt = d6e ? d6e.prototype : null, mee = "__proto__", Slr = 2311;
  function QBe() {
    return Slr++;
  }
  function bee() {
    for (var f2 = [], i = 0; i < arguments.length; i++)
      f2[i] = arguments[i];
    typeof console != "undefined" && console.error.apply(console, f2);
  }
  function pu(f2) {
    if (f2 == null || typeof f2 != "object")
      return f2;
    var i = f2, t2 = Ktt.call(f2);
    if (t2 === "[object Array]") {
      if (!Adt(f2)) {
        i = [];
        for (var h = 0, v4 = f2.length; h < v4; h++)
          i[h] = pu(f2[h]);
      }
    } else if (XBe[t2]) {
      if (!Adt(f2)) {
        var _ = f2.constructor;
        if (_.from)
          i = _.from(f2);
        else {
          i = new _(f2.length);
          for (var h = 0, v4 = f2.length; h < v4; h++)
            i[h] = f2[h];
        }
      }
    } else if (!KBe[t2] && !Adt(f2) && !qdt(f2)) {
      i = {};
      for (var M2 in f2)
        f2.hasOwnProperty(M2) && M2 !== mee && (i[M2] = pu(f2[M2]));
    }
    return i;
  }
  function cc2(f2, i, t2) {
    if (!Xl(i) || !Xl(f2))
      return t2 ? pu(i) : f2;
    for (var h in i)
      if (i.hasOwnProperty(h) && h !== mee) {
        var v4 = f2[h], _ = i[h];
        Xl(_) && Xl(v4) && !Za2(_) && !Za2(v4) && !qdt(_) && !qdt(v4) && !g6e(_) && !g6e(v4) && !Adt(_) && !Adt(v4) ? cc2(v4, _, t2) : (t2 || !(h in f2)) && (f2[h] = pu(i[h]));
      }
    return f2;
  }
  function _ee(f2, i) {
    for (var t2 = f2[0], h = 1, v4 = f2.length; h < v4; h++)
      t2 = cc2(t2, f2[h], i);
    return t2;
  }
  function ba2(f2, i) {
    if (Object.assign)
      Object.assign(f2, i);
    else
      for (var t2 in i)
        i.hasOwnProperty(t2) && t2 !== mee && (f2[t2] = i[t2]);
    return f2;
  }
  function Ul(f2, i, t2) {
    for (var h = Of2(i), v4 = 0; v4 < h.length; v4++) {
      var _ = h[v4];
      (t2 ? i[_] != null : f2[_] == null) && (f2[_] = i[_]);
    }
    return f2;
  }
  function Pc2(f2, i) {
    if (f2) {
      if (f2.indexOf)
        return f2.indexOf(i);
      for (var t2 = 0, h = f2.length; t2 < h; t2++)
        if (f2[t2] === i)
          return t2;
    }
    return -1;
  }
  function Mlr(f2, i) {
    var t2 = f2.prototype;
    function h() {
    }
    h.prototype = i.prototype, f2.prototype = new h();
    for (var v4 in t2)
      t2.hasOwnProperty(v4) && (f2.prototype[v4] = t2[v4]);
    f2.prototype.constructor = f2, f2.superClass = i;
  }
  function Sm(f2, i, t2) {
    if (f2 = "prototype" in f2 ? f2.prototype : f2, i = "prototype" in i ? i.prototype : i, Object.getOwnPropertyNames)
      for (var h = Object.getOwnPropertyNames(i), v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4];
        _ !== "constructor" && (t2 ? i[_] != null : f2[_] == null) && (f2[_] = i[_]);
      }
    else
      Ul(f2, i, t2);
  }
  function xS(f2) {
    return !f2 || typeof f2 == "string" ? false : typeof f2.length == "number";
  }
  function Qe2(f2, i, t2) {
    if (!!(f2 && i))
      if (f2.forEach && f2.forEach === _lr)
        f2.forEach(i, t2);
      else if (f2.length === +f2.length)
        for (var h = 0, v4 = f2.length; h < v4; h++)
          i.call(t2, f2[h], h, f2);
      else
        for (var _ in f2)
          f2.hasOwnProperty(_) && i.call(t2, f2[_], _, f2);
  }
  function Xa2(f2, i, t2) {
    if (!f2)
      return [];
    if (!i)
      return xee(f2);
    if (f2.map && f2.map === wlr)
      return f2.map(i, t2);
    for (var h = [], v4 = 0, _ = f2.length; v4 < _; v4++)
      h.push(i.call(t2, f2[v4], v4, f2));
    return h;
  }
  function zL(f2, i, t2, h) {
    if (!!(f2 && i)) {
      for (var v4 = 0, _ = f2.length; v4 < _; v4++)
        t2 = i.call(h, t2, f2[v4], v4, f2);
      return t2;
    }
  }
  function Ld2(f2, i, t2) {
    if (!f2)
      return [];
    if (!i)
      return xee(f2);
    if (f2.filter && f2.filter === xlr)
      return f2.filter(i, t2);
    for (var h = [], v4 = 0, _ = f2.length; v4 < _; v4++)
      i.call(t2, f2[v4], v4, f2) && h.push(f2[v4]);
    return h;
  }
  function Clr(f2, i, t2) {
    if (!!(f2 && i)) {
      for (var h = 0, v4 = f2.length; h < v4; h++)
        if (i.call(t2, f2[h], h, f2))
          return f2[h];
    }
  }
  function Of2(f2) {
    if (!f2)
      return [];
    if (Object.keys)
      return Object.keys(f2);
    var i = [];
    for (var t2 in f2)
      f2.hasOwnProperty(t2) && i.push(t2);
    return i;
  }
  function Tlr(f2, i) {
    for (var t2 = [], h = 2; h < arguments.length; h++)
      t2[h - 2] = arguments[h];
    return function() {
      return f2.apply(i, t2.concat(yee.call(arguments)));
    };
  }
  var ks = DIt && Ol(DIt.bind) ? DIt.call.bind(DIt.bind) : Tlr;
  function Ou(f2) {
    for (var i = [], t2 = 1; t2 < arguments.length; t2++)
      i[t2 - 1] = arguments[t2];
    return function() {
      return f2.apply(this, i.concat(yee.call(arguments)));
    };
  }
  function Za2(f2) {
    return Array.isArray ? Array.isArray(f2) : Ktt.call(f2) === "[object Array]";
  }
  function Ol(f2) {
    return typeof f2 == "function";
  }
  function ms(f2) {
    return typeof f2 == "string";
  }
  function hJt(f2) {
    return Ktt.call(f2) === "[object String]";
  }
  function vp(f2) {
    return typeof f2 == "number";
  }
  function Xl(f2) {
    var i = typeof f2;
    return i === "function" || !!f2 && i === "object";
  }
  function g6e(f2) {
    return !!KBe[Ktt.call(f2)];
  }
  function YT(f2) {
    return !!XBe[Ktt.call(f2)];
  }
  function qdt(f2) {
    return typeof f2 == "object" && typeof f2.nodeType == "number" && typeof f2.ownerDocument == "object";
  }
  function okt(f2) {
    return f2.colorStops != null;
  }
  function Alr(f2) {
    return f2.image != null;
  }
  function Ilr(f2) {
    return Ktt.call(f2) === "[object RegExp]";
  }
  function Zdt(f2) {
    return f2 !== f2;
  }
  function y_() {
    for (var f2 = [], i = 0; i < arguments.length; i++)
      f2[i] = arguments[i];
    for (var t2 = 0, h = f2.length; t2 < h; t2++)
      if (f2[t2] != null)
        return f2[t2];
  }
  function _c2(f2, i) {
    return f2 != null ? f2 : i;
  }
  function U6(f2, i, t2) {
    return f2 != null ? f2 : i != null ? i : t2;
  }
  function xee(f2) {
    for (var i = [], t2 = 1; t2 < arguments.length; t2++)
      i[t2 - 1] = arguments[t2];
    return yee.apply(f2, i);
  }
  function wee(f2) {
    if (typeof f2 == "number")
      return [f2, f2, f2, f2];
    var i = f2.length;
    return i === 2 ? [f2[0], f2[1], f2[0], f2[1]] : i === 3 ? [f2[0], f2[1], f2[2], f2[1]] : f2;
  }
  function z2(f2, i) {
    if (!f2)
      throw new Error(i);
  }
  function w5(f2) {
    return f2 == null ? null : typeof f2.trim == "function" ? f2.trim() : f2.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
  var JBe = "__ec_primitive__";
  function oEt(f2) {
    f2[JBe] = true;
  }
  function Adt(f2) {
    return f2[JBe];
  }
  var Dlr = function() {
    function f2(i) {
      this.data = {};
      var t2 = Za2(i);
      this.data = {};
      var h = this;
      i instanceof f2 ? i.each(v4) : i && Qe2(i, v4);
      function v4(_, M2) {
        t2 ? h.set(_, M2) : h.set(M2, _);
      }
    }
    return f2.prototype.get = function(i) {
      return this.data.hasOwnProperty(i) ? this.data[i] : null;
    }, f2.prototype.set = function(i, t2) {
      return this.data[i] = t2;
    }, f2.prototype.each = function(i, t2) {
      for (var h in this.data)
        this.data.hasOwnProperty(h) && i.call(t2, this.data[h], h);
    }, f2.prototype.keys = function() {
      return Of2(this.data);
    }, f2.prototype.removeKey = function(i) {
      delete this.data[i];
    }, f2;
  }();
  function Il(f2) {
    return new Dlr(f2);
  }
  function pJt(f2, i) {
    for (var t2 = new f2.constructor(f2.length + i.length), h = 0; h < f2.length; h++)
      t2[h] = f2[h];
    for (var v4 = f2.length, h = 0; h < i.length; h++)
      t2[h + v4] = i[h];
    return t2;
  }
  function skt(f2, i) {
    var t2;
    if (Object.create)
      t2 = Object.create(f2);
    else {
      var h = function() {
      };
      h.prototype = f2, t2 = new h();
    }
    return i && ba2(t2, i), t2;
  }
  function tze(f2) {
    var i = f2.style;
    i.webkitUserSelect = "none", i.userSelect = "none", i.webkitTapHighlightColor = "rgba(0,0,0,0)", i["-webkit-touch-callout"] = "none";
  }
  function qs(f2, i) {
    return f2.hasOwnProperty(i);
  }
  function xm() {
  }
  var VDt = 180 / Math.PI;
  function wU(f2, i) {
    return f2 == null && (f2 = 0), i == null && (i = 0), [f2, i];
  }
  function N2(f2, i) {
    return f2[0] = i[0], f2[1] = i[1], f2;
  }
  function q6(f2) {
    return [f2[0], f2[1]];
  }
  function Elr(f2, i, t2) {
    return f2[0] = i, f2[1] = t2, f2;
  }
  function v6e(f2, i, t2) {
    return f2[0] = i[0] + t2[0], f2[1] = i[1] + t2[1], f2;
  }
  function dJt(f2, i, t2, h) {
    return f2[0] = i[0] + t2[0] * h, f2[1] = i[1] + t2[1] * h, f2;
  }
  function tU(f2, i, t2) {
    return f2[0] = i[0] - t2[0], f2[1] = i[1] - t2[1], f2;
  }
  function gJt(f2) {
    return Math.sqrt(klr(f2));
  }
  function klr(f2) {
    return f2[0] * f2[0] + f2[1] * f2[1];
  }
  function PKt(f2, i, t2) {
    return f2[0] = i[0] * t2, f2[1] = i[1] * t2, f2;
  }
  function Sgt(f2, i) {
    var t2 = gJt(i);
    return t2 === 0 ? (f2[0] = 0, f2[1] = 0) : (f2[0] = i[0] / t2, f2[1] = i[1] / t2), f2;
  }
  function vJt(f2, i) {
    return Math.sqrt((f2[0] - i[0]) * (f2[0] - i[0]) + (f2[1] - i[1]) * (f2[1] - i[1]));
  }
  var R7 = vJt;
  function Plr(f2, i) {
    return (f2[0] - i[0]) * (f2[0] - i[0]) + (f2[1] - i[1]) * (f2[1] - i[1]);
  }
  var oU = Plr;
  function BDt(f2, i, t2, h) {
    return f2[0] = i[0] + h * (t2[0] - i[0]), f2[1] = i[1] + h * (t2[1] - i[1]), f2;
  }
  function Wx(f2, i, t2) {
    var h = i[0], v4 = i[1];
    return f2[0] = t2[0] * h + t2[2] * v4 + t2[4], f2[1] = t2[1] * h + t2[3] * v4 + t2[5], f2;
  }
  function N7(f2, i, t2) {
    return f2[0] = Math.min(i[0], t2[0]), f2[1] = Math.min(i[1], t2[1]), f2;
  }
  function F7(f2, i, t2) {
    return f2[0] = Math.max(i[0], t2[0]), f2[1] = Math.max(i[1], t2[1]), f2;
  }
  var QJ = function() {
    function f2(i, t2) {
      this.target = i, this.topTarget = t2 && t2.topTarget;
    }
    return f2;
  }(), Llr = function() {
    function f2(i) {
      this.handler = i, i.on("mousedown", this._dragStart, this), i.on("mousemove", this._drag, this), i.on("mouseup", this._dragEnd, this);
    }
    return f2.prototype._dragStart = function(i) {
      for (var t2 = i.target; t2 && !t2.draggable; )
        t2 = t2.parent || t2.__hostTarget;
      t2 && (this._draggingTarget = t2, t2.dragging = true, this._x = i.offsetX, this._y = i.offsetY, this.handler.dispatchToElement(new QJ(t2, i), "dragstart", i.event));
    }, f2.prototype._drag = function(i) {
      var t2 = this._draggingTarget;
      if (t2) {
        var h = i.offsetX, v4 = i.offsetY, _ = h - this._x, M2 = v4 - this._y;
        this._x = h, this._y = v4, t2.drift(_, M2, i), this.handler.dispatchToElement(new QJ(t2, i), "drag", i.event);
        var I2 = this.handler.findHover(h, v4, t2).target, P2 = this._dropTarget;
        this._dropTarget = I2, t2 !== I2 && (P2 && I2 !== P2 && this.handler.dispatchToElement(new QJ(P2, i), "dragleave", i.event), I2 && I2 !== P2 && this.handler.dispatchToElement(new QJ(I2, i), "dragenter", i.event));
      }
    }, f2.prototype._dragEnd = function(i) {
      var t2 = this._draggingTarget;
      t2 && (t2.dragging = false), this.handler.dispatchToElement(new QJ(t2, i), "dragend", i.event), this._dropTarget && this.handler.dispatchToElement(new QJ(this._dropTarget, i), "drop", i.event), this._draggingTarget = null, this._dropTarget = null;
    }, f2;
  }(), Olr = Llr, Rlr = function() {
    function f2(i) {
      i && (this._$eventProcessor = i);
    }
    return f2.prototype.on = function(i, t2, h, v4) {
      this._$handlers || (this._$handlers = {});
      var _ = this._$handlers;
      if (typeof t2 == "function" && (v4 = h, h = t2, t2 = null), !h || !i)
        return this;
      var M2 = this._$eventProcessor;
      t2 != null && M2 && M2.normalizeQuery && (t2 = M2.normalizeQuery(t2)), _[i] || (_[i] = []);
      for (var I2 = 0; I2 < _[i].length; I2++)
        if (_[i][I2].h === h)
          return this;
      var P2 = { h, query: t2, ctx: v4 || this, callAtLast: h.zrEventfulCallAtLast }, N3 = _[i].length - 1, z3 = _[i][N3];
      return z3 && z3.callAtLast ? _[i].splice(N3, 0, P2) : _[i].push(P2), this;
    }, f2.prototype.isSilent = function(i) {
      var t2 = this._$handlers;
      return !t2 || !t2[i] || !t2[i].length;
    }, f2.prototype.off = function(i, t2) {
      var h = this._$handlers;
      if (!h)
        return this;
      if (!i)
        return this._$handlers = {}, this;
      if (t2) {
        if (h[i]) {
          for (var v4 = [], _ = 0, M2 = h[i].length; _ < M2; _++)
            h[i][_].h !== t2 && v4.push(h[i][_]);
          h[i] = v4;
        }
        h[i] && h[i].length === 0 && delete h[i];
      } else
        delete h[i];
      return this;
    }, f2.prototype.trigger = function(i) {
      for (var t2 = [], h = 1; h < arguments.length; h++)
        t2[h - 1] = arguments[h];
      if (!this._$handlers)
        return this;
      var v4 = this._$handlers[i], _ = this._$eventProcessor;
      if (v4)
        for (var M2 = t2.length, I2 = v4.length, P2 = 0; P2 < I2; P2++) {
          var N3 = v4[P2];
          if (!(_ && _.filter && N3.query != null && !_.filter(i, N3.query)))
            switch (M2) {
              case 0:
                N3.h.call(N3.ctx);
                break;
              case 1:
                N3.h.call(N3.ctx, t2[0]);
                break;
              case 2:
                N3.h.call(N3.ctx, t2[0], t2[1]);
                break;
              default:
                N3.h.apply(N3.ctx, t2);
                break;
            }
        }
      return _ && _.afterTrigger && _.afterTrigger(i), this;
    }, f2.prototype.triggerWithContext = function(i) {
      for (var t2 = [], h = 1; h < arguments.length; h++)
        t2[h - 1] = arguments[h];
      if (!this._$handlers)
        return this;
      var v4 = this._$handlers[i], _ = this._$eventProcessor;
      if (v4)
        for (var M2 = t2.length, I2 = t2[M2 - 1], P2 = v4.length, N3 = 0; N3 < P2; N3++) {
          var z3 = v4[N3];
          if (!(_ && _.filter && z3.query != null && !_.filter(i, z3.query)))
            switch (M2) {
              case 0:
                z3.h.call(I2);
                break;
              case 1:
                z3.h.call(I2, t2[0]);
                break;
              case 2:
                z3.h.call(I2, t2[0], t2[1]);
                break;
              default:
                z3.h.apply(I2, t2.slice(1, M2 - 1));
                break;
            }
        }
      return _ && _.afterTrigger && _.afterTrigger(i), this;
    }, f2;
  }(), iE = Rlr, Nlr = Math.log(2);
  function yJt(f2, i, t2, h, v4, _) {
    var M2 = h + "-" + v4, I2 = f2.length;
    if (_.hasOwnProperty(M2))
      return _[M2];
    if (i === 1) {
      var P2 = Math.round(Math.log((1 << I2) - 1 & ~v4) / Nlr);
      return f2[t2][P2];
    }
    for (var N3 = h | 1 << t2, z3 = t2 + 1; h & 1 << z3; )
      z3++;
    for (var H2 = 0, $ = 0, et = 0; $ < I2; $++) {
      var at = 1 << $;
      at & v4 || (H2 += (et % 2 ? -1 : 1) * f2[t2][$] * yJt(f2, i - 1, z3, N3, v4 | at, _), et++);
    }
    return _[M2] = H2, H2;
  }
  function y6e(f2, i) {
    var t2 = [[f2[0], f2[1], 1, 0, 0, 0, -i[0] * f2[0], -i[0] * f2[1]], [0, 0, 0, f2[0], f2[1], 1, -i[1] * f2[0], -i[1] * f2[1]], [f2[2], f2[3], 1, 0, 0, 0, -i[2] * f2[2], -i[2] * f2[3]], [0, 0, 0, f2[2], f2[3], 1, -i[3] * f2[2], -i[3] * f2[3]], [f2[4], f2[5], 1, 0, 0, 0, -i[4] * f2[4], -i[4] * f2[5]], [0, 0, 0, f2[4], f2[5], 1, -i[5] * f2[4], -i[5] * f2[5]], [f2[6], f2[7], 1, 0, 0, 0, -i[6] * f2[6], -i[6] * f2[7]], [0, 0, 0, f2[6], f2[7], 1, -i[7] * f2[6], -i[7] * f2[7]]], h = {}, v4 = yJt(t2, 8, 0, 0, 0, h);
    if (v4 !== 0) {
      for (var _ = [], M2 = 0; M2 < 8; M2++)
        for (var I2 = 0; I2 < 8; I2++)
          _[I2] == null && (_[I2] = 0), _[I2] += ((M2 + I2) % 2 ? -1 : 1) * yJt(t2, 7, M2 === 0 ? 1 : 0, 1 << M2, 1 << I2, h) / v4 * i[M2];
      return function(P2, N3, z3) {
        var H2 = N3 * _[6] + z3 * _[7] + 1;
        P2[0] = (N3 * _[0] + z3 * _[1] + _[2]) / H2, P2[1] = (N3 * _[3] + z3 * _[4] + _[5]) / H2;
      };
    }
  }
  var m6e = "___zrEVENTSAVED", LKt = [];
  function Flr(f2, i, t2, h, v4) {
    return mJt(LKt, i, h, v4, true) && mJt(f2, t2, LKt[0], LKt[1]);
  }
  function mJt(f2, i, t2, h, v4) {
    if (i.getBoundingClientRect && gp.domSupported && !eze(i)) {
      var _ = i[m6e] || (i[m6e] = {}), M2 = Vlr(i, _), I2 = Blr(M2, _, v4);
      if (I2)
        return I2(f2, t2, h), true;
    }
    return false;
  }
  function Vlr(f2, i) {
    var t2 = i.markers;
    if (t2)
      return t2;
    t2 = i.markers = [];
    for (var h = ["left", "right"], v4 = ["top", "bottom"], _ = 0; _ < 4; _++) {
      var M2 = document.createElement("div"), I2 = M2.style, P2 = _ % 2, N3 = (_ >> 1) % 2;
      I2.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", h[P2] + ":0", v4[N3] + ":0", h[1 - P2] + ":auto", v4[1 - N3] + ":auto", ""].join("!important;"), f2.appendChild(M2), t2.push(M2);
    }
    return t2;
  }
  function Blr(f2, i, t2) {
    for (var h = t2 ? "invTrans" : "trans", v4 = i[h], _ = i.srcCoords, M2 = [], I2 = [], P2 = true, N3 = 0; N3 < 4; N3++) {
      var z3 = f2[N3].getBoundingClientRect(), H2 = 2 * N3, $ = z3.left, et = z3.top;
      M2.push($, et), P2 = P2 && _ && $ === _[H2] && et === _[H2 + 1], I2.push(f2[N3].offsetLeft, f2[N3].offsetTop);
    }
    return P2 && v4 ? v4 : (i.srcCoords = M2, i[h] = t2 ? y6e(I2, M2) : y6e(M2, I2));
  }
  function eze(f2) {
    return f2.nodeName.toUpperCase() === "CANVAS";
  }
  var zlr = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, OKt = [], jlr = gp.browser.firefox && +gp.browser.version.split(".")[0] < 39;
  function bJt(f2, i, t2, h) {
    return t2 = t2 || {}, h ? b6e(f2, i, t2) : jlr && i.layerX != null && i.layerX !== i.offsetX ? (t2.zrX = i.layerX, t2.zrY = i.layerY) : i.offsetX != null ? (t2.zrX = i.offsetX, t2.zrY = i.offsetY) : b6e(f2, i, t2), t2;
  }
  function b6e(f2, i, t2) {
    if (gp.domSupported && f2.getBoundingClientRect) {
      var h = i.clientX, v4 = i.clientY;
      if (eze(f2)) {
        var _ = f2.getBoundingClientRect();
        t2.zrX = h - _.left, t2.zrY = v4 - _.top;
        return;
      } else if (mJt(OKt, f2, h, v4)) {
        t2.zrX = OKt[0], t2.zrY = OKt[1];
        return;
      }
    }
    t2.zrX = t2.zrY = 0;
  }
  function See(f2) {
    return f2 || window.event;
  }
  function GD(f2, i, t2) {
    if (i = See(i), i.zrX != null)
      return i;
    var h = i.type, v4 = h && h.indexOf("touch") >= 0;
    if (v4) {
      var M2 = h !== "touchend" ? i.targetTouches[0] : i.changedTouches[0];
      M2 && bJt(f2, M2, i, t2);
    } else {
      bJt(f2, i, i, t2);
      var _ = Wlr(i);
      i.zrDelta = _ ? _ / 120 : -(i.detail || 0) / 3;
    }
    var I2 = i.button;
    return i.which == null && I2 !== void 0 && zlr.test(i.type) && (i.which = I2 & 1 ? 1 : I2 & 2 ? 3 : I2 & 4 ? 2 : 0), i;
  }
  function Wlr(f2) {
    var i = f2.wheelDelta;
    if (i)
      return i;
    var t2 = f2.deltaX, h = f2.deltaY;
    if (t2 == null || h == null)
      return i;
    var v4 = Math.abs(h !== 0 ? h : t2), _ = h > 0 ? -1 : h < 0 ? 1 : t2 > 0 ? -1 : 1;
    return 3 * v4 * _;
  }
  function _Jt(f2, i, t2, h) {
    f2.addEventListener(i, t2, h);
  }
  function Glr(f2, i, t2, h) {
    f2.removeEventListener(i, t2, h);
  }
  var J6 = function(f2) {
    f2.preventDefault(), f2.stopPropagation(), f2.cancelBubble = true;
  };
  function _6e(f2) {
    return f2.which === 2 || f2.which === 3;
  }
  var Hlr = function() {
    function f2() {
      this._track = [];
    }
    return f2.prototype.recognize = function(i, t2, h) {
      return this._doTrack(i, t2, h), this._recognize(i);
    }, f2.prototype.clear = function() {
      return this._track.length = 0, this;
    }, f2.prototype._doTrack = function(i, t2, h) {
      var v4 = i.touches;
      if (!!v4) {
        for (var _ = { points: [], touches: [], target: t2, event: i }, M2 = 0, I2 = v4.length; M2 < I2; M2++) {
          var P2 = v4[M2], N3 = bJt(h, P2, {});
          _.points.push([N3.zrX, N3.zrY]), _.touches.push(P2);
        }
        this._track.push(_);
      }
    }, f2.prototype._recognize = function(i) {
      for (var t2 in RKt)
        if (RKt.hasOwnProperty(t2)) {
          var h = RKt[t2](this._track, i);
          if (h)
            return h;
        }
    }, f2;
  }();
  function x6e(f2) {
    var i = f2[1][0] - f2[0][0], t2 = f2[1][1] - f2[0][1];
    return Math.sqrt(i * i + t2 * t2);
  }
  function Ulr(f2) {
    return [(f2[0][0] + f2[1][0]) / 2, (f2[0][1] + f2[1][1]) / 2];
  }
  var RKt = { pinch: function(f2, i) {
    var t2 = f2.length;
    if (!!t2) {
      var h = (f2[t2 - 1] || {}).points, v4 = (f2[t2 - 2] || {}).points || h;
      if (v4 && v4.length > 1 && h && h.length > 1) {
        var _ = x6e(h) / x6e(v4);
        !isFinite(_) && (_ = 1), i.pinchScale = _;
        var M2 = Ulr(h);
        return i.pinchX = M2[0], i.pinchY = M2[1], { type: "pinch", target: f2[0].target, event: i };
      }
    }
  } }, nze = "silent";
  function qlr(f2, i, t2) {
    return { type: f2, event: t2, target: i.target, topTarget: i.topTarget, cancelBubble: false, offsetX: t2.zrX, offsetY: t2.zrY, gestureEvent: t2.gestureEvent, pinchX: t2.pinchX, pinchY: t2.pinchY, pinchScale: t2.pinchScale, wheelDelta: t2.zrDelta, zrByTouch: t2.zrByTouch, which: t2.which, stop: Zlr };
  }
  function Zlr() {
    J6(this.event);
  }
  var $lr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.handler = null, t2;
    }
    return i.prototype.dispose = function() {
    }, i.prototype.setCursor = function() {
    }, i;
  }(iE), Npt = function() {
    function f2(i, t2) {
      this.x = i, this.y = t2;
    }
    return f2;
  }(), Ylr = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], rze = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _) {
      var M2 = f2.call(this) || this;
      return M2._hovered = new Npt(0, 0), M2.storage = t2, M2.painter = h, M2.painterRoot = _, v4 = v4 || new $lr(), M2.proxy = null, M2.setHandlerProxy(v4), M2._draggingMgr = new Olr(M2), M2;
    }
    return i.prototype.setHandlerProxy = function(t2) {
      this.proxy && this.proxy.dispose(), t2 && (Qe2(Ylr, function(h) {
        t2.on && t2.on(h, this[h], this);
      }, this), t2.handler = this), this.proxy = t2;
    }, i.prototype.mousemove = function(t2) {
      var h = t2.zrX, v4 = t2.zrY, _ = ize(this, h, v4), M2 = this._hovered, I2 = M2.target;
      I2 && !I2.__zr && (M2 = this.findHover(M2.x, M2.y), I2 = M2.target);
      var P2 = this._hovered = _ ? new Npt(h, v4) : this.findHover(h, v4), N3 = P2.target, z3 = this.proxy;
      z3.setCursor && z3.setCursor(N3 ? N3.cursor : "default"), I2 && N3 !== I2 && this.dispatchToElement(M2, "mouseout", t2), this.dispatchToElement(P2, "mousemove", t2), N3 && N3 !== I2 && this.dispatchToElement(P2, "mouseover", t2);
    }, i.prototype.mouseout = function(t2) {
      var h = t2.zrEventControl;
      h !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", t2), h !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: t2 });
    }, i.prototype.resize = function() {
      this._hovered = new Npt(0, 0);
    }, i.prototype.dispatch = function(t2, h) {
      var v4 = this[t2];
      v4 && v4.call(this, h);
    }, i.prototype.dispose = function() {
      this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
    }, i.prototype.setCursorStyle = function(t2) {
      var h = this.proxy;
      h.setCursor && h.setCursor(t2);
    }, i.prototype.dispatchToElement = function(t2, h, v4) {
      t2 = t2 || {};
      var _ = t2.target;
      if (!(_ && _.silent)) {
        for (var M2 = "on" + h, I2 = qlr(h, t2, v4); _ && (_[M2] && (I2.cancelBubble = !!_[M2].call(_, I2)), _.trigger(h, I2), _ = _.__hostTarget ? _.__hostTarget : _.parent, !I2.cancelBubble); )
          ;
        I2.cancelBubble || (this.trigger(h, I2), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(P2) {
          typeof P2[M2] == "function" && P2[M2].call(P2, I2), P2.trigger && P2.trigger(h, I2);
        }));
      }
    }, i.prototype.findHover = function(t2, h, v4) {
      for (var _ = this.storage.getDisplayList(), M2 = new Npt(t2, h), I2 = _.length - 1; I2 >= 0; I2--) {
        var P2 = void 0;
        if (_[I2] !== v4 && !_[I2].ignore && (P2 = Klr(_[I2], t2, h)) && (!M2.topTarget && (M2.topTarget = _[I2]), P2 !== nze)) {
          M2.target = _[I2];
          break;
        }
      }
      return M2;
    }, i.prototype.processGesture = function(t2, h) {
      this._gestureMgr || (this._gestureMgr = new Hlr());
      var v4 = this._gestureMgr;
      h === "start" && v4.clear();
      var _ = v4.recognize(t2, this.findHover(t2.zrX, t2.zrY, null).target, this.proxy.dom);
      if (h === "end" && v4.clear(), _) {
        var M2 = _.type;
        t2.gestureEvent = M2;
        var I2 = new Npt();
        I2.target = _.target, this.dispatchToElement(I2, M2, _.event);
      }
    }, i;
  }(iE);
  Qe2(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(f2) {
    rze.prototype[f2] = function(i) {
      var t2 = i.zrX, h = i.zrY, v4 = ize(this, t2, h), _, M2;
      if ((f2 !== "mouseup" || !v4) && (_ = this.findHover(t2, h), M2 = _.target), f2 === "mousedown")
        this._downEl = M2, this._downPoint = [i.zrX, i.zrY], this._upEl = M2;
      else if (f2 === "mouseup")
        this._upEl = M2;
      else if (f2 === "click") {
        if (this._downEl !== this._upEl || !this._downPoint || R7(this._downPoint, [i.zrX, i.zrY]) > 4)
          return;
        this._downPoint = null;
      }
      this.dispatchToElement(_, f2, i);
    };
  });
  function Klr(f2, i, t2) {
    if (f2[f2.rectHover ? "rectContain" : "contain"](i, t2)) {
      for (var h = f2, v4 = void 0, _ = false; h; ) {
        if (h.ignoreClip && (_ = true), !_) {
          var M2 = h.getClipPath();
          if (M2 && !M2.contain(i, t2))
            return false;
          h.silent && (v4 = true);
        }
        var I2 = h.__hostTarget;
        h = I2 || h.parent;
      }
      return v4 ? nze : true;
    }
    return false;
  }
  function ize(f2, i, t2) {
    var h = f2.painter;
    return i < 0 || i > h.getWidth() || t2 < 0 || t2 > h.getHeight();
  }
  var Xlr = rze, aze = 32, Fpt = 7;
  function Qlr(f2) {
    for (var i = 0; f2 >= aze; )
      i |= f2 & 1, f2 >>= 1;
    return f2 + i;
  }
  function w6e(f2, i, t2, h) {
    var v4 = i + 1;
    if (v4 === t2)
      return 1;
    if (h(f2[v4++], f2[i]) < 0) {
      for (; v4 < t2 && h(f2[v4], f2[v4 - 1]) < 0; )
        v4++;
      Jlr(f2, i, v4);
    } else
      for (; v4 < t2 && h(f2[v4], f2[v4 - 1]) >= 0; )
        v4++;
    return v4 - i;
  }
  function Jlr(f2, i, t2) {
    for (t2--; i < t2; ) {
      var h = f2[i];
      f2[i++] = f2[t2], f2[t2--] = h;
    }
  }
  function S6e(f2, i, t2, h, v4) {
    for (h === i && h++; h < t2; h++) {
      for (var _ = f2[h], M2 = i, I2 = h, P2; M2 < I2; )
        P2 = M2 + I2 >>> 1, v4(_, f2[P2]) < 0 ? I2 = P2 : M2 = P2 + 1;
      var N3 = h - M2;
      switch (N3) {
        case 3:
          f2[M2 + 3] = f2[M2 + 2];
        case 2:
          f2[M2 + 2] = f2[M2 + 1];
        case 1:
          f2[M2 + 1] = f2[M2];
          break;
        default:
          for (; N3 > 0; )
            f2[M2 + N3] = f2[M2 + N3 - 1], N3--;
      }
      f2[M2] = _;
    }
  }
  function NKt(f2, i, t2, h, v4, _) {
    var M2 = 0, I2 = 0, P2 = 1;
    if (_(f2, i[t2 + v4]) > 0) {
      for (I2 = h - v4; P2 < I2 && _(f2, i[t2 + v4 + P2]) > 0; )
        M2 = P2, P2 = (P2 << 1) + 1, P2 <= 0 && (P2 = I2);
      P2 > I2 && (P2 = I2), M2 += v4, P2 += v4;
    } else {
      for (I2 = v4 + 1; P2 < I2 && _(f2, i[t2 + v4 - P2]) <= 0; )
        M2 = P2, P2 = (P2 << 1) + 1, P2 <= 0 && (P2 = I2);
      P2 > I2 && (P2 = I2);
      var N3 = M2;
      M2 = v4 - P2, P2 = v4 - N3;
    }
    for (M2++; M2 < P2; ) {
      var z3 = M2 + (P2 - M2 >>> 1);
      _(f2, i[t2 + z3]) > 0 ? M2 = z3 + 1 : P2 = z3;
    }
    return P2;
  }
  function FKt(f2, i, t2, h, v4, _) {
    var M2 = 0, I2 = 0, P2 = 1;
    if (_(f2, i[t2 + v4]) < 0) {
      for (I2 = v4 + 1; P2 < I2 && _(f2, i[t2 + v4 - P2]) < 0; )
        M2 = P2, P2 = (P2 << 1) + 1, P2 <= 0 && (P2 = I2);
      P2 > I2 && (P2 = I2);
      var N3 = M2;
      M2 = v4 - P2, P2 = v4 - N3;
    } else {
      for (I2 = h - v4; P2 < I2 && _(f2, i[t2 + v4 + P2]) >= 0; )
        M2 = P2, P2 = (P2 << 1) + 1, P2 <= 0 && (P2 = I2);
      P2 > I2 && (P2 = I2), M2 += v4, P2 += v4;
    }
    for (M2++; M2 < P2; ) {
      var z3 = M2 + (P2 - M2 >>> 1);
      _(f2, i[t2 + z3]) < 0 ? P2 = z3 : M2 = z3 + 1;
    }
    return P2;
  }
  function tur(f2, i) {
    var t2 = Fpt, h, v4, _ = 0, M2 = [];
    h = [], v4 = [];
    function I2(et, at) {
      h[_] = et, v4[_] = at, _ += 1;
    }
    function P2() {
      for (; _ > 1; ) {
        var et = _ - 2;
        if (et >= 1 && v4[et - 1] <= v4[et] + v4[et + 1] || et >= 2 && v4[et - 2] <= v4[et] + v4[et - 1])
          v4[et - 1] < v4[et + 1] && et--;
        else if (v4[et] > v4[et + 1])
          break;
        z3(et);
      }
    }
    function N3() {
      for (; _ > 1; ) {
        var et = _ - 2;
        et > 0 && v4[et - 1] < v4[et + 1] && et--, z3(et);
      }
    }
    function z3(et) {
      var at = h[et], ht = v4[et], bt = h[et + 1], _t = v4[et + 1];
      v4[et] = ht + _t, et === _ - 3 && (h[et + 1] = h[et + 2], v4[et + 1] = v4[et + 2]), _--;
      var Et = FKt(f2[bt], f2, at, ht, 0, i);
      at += Et, ht -= Et, ht !== 0 && (_t = NKt(f2[at + ht - 1], f2, bt, _t, _t - 1, i), _t !== 0 && (ht <= _t ? H2(at, ht, bt, _t) : $(at, ht, bt, _t)));
    }
    function H2(et, at, ht, bt) {
      var _t = 0;
      for (_t = 0; _t < at; _t++)
        M2[_t] = f2[et + _t];
      var Et = 0, zt = ht, Ft = et;
      if (f2[Ft++] = f2[zt++], --bt === 0) {
        for (_t = 0; _t < at; _t++)
          f2[Ft + _t] = M2[Et + _t];
        return;
      }
      if (at === 1) {
        for (_t = 0; _t < bt; _t++)
          f2[Ft + _t] = f2[zt + _t];
        f2[Ft + bt] = M2[Et];
        return;
      }
      for (var fe2 = t2, re2, ye, me2; ; ) {
        re2 = 0, ye = 0, me2 = false;
        do
          if (i(f2[zt], M2[Et]) < 0) {
            if (f2[Ft++] = f2[zt++], ye++, re2 = 0, --bt === 0) {
              me2 = true;
              break;
            }
          } else if (f2[Ft++] = M2[Et++], re2++, ye = 0, --at === 1) {
            me2 = true;
            break;
          }
        while ((re2 | ye) < fe2);
        if (me2)
          break;
        do {
          if (re2 = FKt(f2[zt], M2, Et, at, 0, i), re2 !== 0) {
            for (_t = 0; _t < re2; _t++)
              f2[Ft + _t] = M2[Et + _t];
            if (Ft += re2, Et += re2, at -= re2, at <= 1) {
              me2 = true;
              break;
            }
          }
          if (f2[Ft++] = f2[zt++], --bt === 0) {
            me2 = true;
            break;
          }
          if (ye = NKt(M2[Et], f2, zt, bt, 0, i), ye !== 0) {
            for (_t = 0; _t < ye; _t++)
              f2[Ft + _t] = f2[zt + _t];
            if (Ft += ye, zt += ye, bt -= ye, bt === 0) {
              me2 = true;
              break;
            }
          }
          if (f2[Ft++] = M2[Et++], --at === 1) {
            me2 = true;
            break;
          }
          fe2--;
        } while (re2 >= Fpt || ye >= Fpt);
        if (me2)
          break;
        fe2 < 0 && (fe2 = 0), fe2 += 2;
      }
      if (t2 = fe2, t2 < 1 && (t2 = 1), at === 1) {
        for (_t = 0; _t < bt; _t++)
          f2[Ft + _t] = f2[zt + _t];
        f2[Ft + bt] = M2[Et];
      } else {
        if (at === 0)
          throw new Error();
        for (_t = 0; _t < at; _t++)
          f2[Ft + _t] = M2[Et + _t];
      }
    }
    function $(et, at, ht, bt) {
      var _t = 0;
      for (_t = 0; _t < bt; _t++)
        M2[_t] = f2[ht + _t];
      var Et = et + at - 1, zt = bt - 1, Ft = ht + bt - 1, fe2 = 0, re2 = 0;
      if (f2[Ft--] = f2[Et--], --at === 0) {
        for (fe2 = Ft - (bt - 1), _t = 0; _t < bt; _t++)
          f2[fe2 + _t] = M2[_t];
        return;
      }
      if (bt === 1) {
        for (Ft -= at, Et -= at, re2 = Ft + 1, fe2 = Et + 1, _t = at - 1; _t >= 0; _t--)
          f2[re2 + _t] = f2[fe2 + _t];
        f2[Ft] = M2[zt];
        return;
      }
      for (var ye = t2; ; ) {
        var me2 = 0, be2 = 0, Te2 = false;
        do
          if (i(M2[zt], f2[Et]) < 0) {
            if (f2[Ft--] = f2[Et--], me2++, be2 = 0, --at === 0) {
              Te2 = true;
              break;
            }
          } else if (f2[Ft--] = M2[zt--], be2++, me2 = 0, --bt === 1) {
            Te2 = true;
            break;
          }
        while ((me2 | be2) < ye);
        if (Te2)
          break;
        do {
          if (me2 = at - FKt(M2[zt], f2, et, at, at - 1, i), me2 !== 0) {
            for (Ft -= me2, Et -= me2, at -= me2, re2 = Ft + 1, fe2 = Et + 1, _t = me2 - 1; _t >= 0; _t--)
              f2[re2 + _t] = f2[fe2 + _t];
            if (at === 0) {
              Te2 = true;
              break;
            }
          }
          if (f2[Ft--] = M2[zt--], --bt === 1) {
            Te2 = true;
            break;
          }
          if (be2 = bt - NKt(f2[Et], M2, 0, bt, bt - 1, i), be2 !== 0) {
            for (Ft -= be2, zt -= be2, bt -= be2, re2 = Ft + 1, fe2 = zt + 1, _t = 0; _t < be2; _t++)
              f2[re2 + _t] = M2[fe2 + _t];
            if (bt <= 1) {
              Te2 = true;
              break;
            }
          }
          if (f2[Ft--] = f2[Et--], --at === 0) {
            Te2 = true;
            break;
          }
          ye--;
        } while (me2 >= Fpt || be2 >= Fpt);
        if (Te2)
          break;
        ye < 0 && (ye = 0), ye += 2;
      }
      if (t2 = ye, t2 < 1 && (t2 = 1), bt === 1) {
        for (Ft -= at, Et -= at, re2 = Ft + 1, fe2 = Et + 1, _t = at - 1; _t >= 0; _t--)
          f2[re2 + _t] = f2[fe2 + _t];
        f2[Ft] = M2[zt];
      } else {
        if (bt === 0)
          throw new Error();
        for (fe2 = Ft - (bt - 1), _t = 0; _t < bt; _t++)
          f2[fe2 + _t] = M2[_t];
      }
    }
    return { mergeRuns: P2, forceMergeRuns: N3, pushRun: I2 };
  }
  function zDt(f2, i, t2, h) {
    t2 || (t2 = 0), h || (h = f2.length);
    var v4 = h - t2;
    if (!(v4 < 2)) {
      var _ = 0;
      if (v4 < aze) {
        _ = w6e(f2, t2, h, i), S6e(f2, t2, h, t2 + _, i);
        return;
      }
      var M2 = tur(f2, i), I2 = Qlr(v4);
      do {
        if (_ = w6e(f2, t2, h, i), _ < I2) {
          var P2 = v4;
          P2 > I2 && (P2 = I2), S6e(f2, t2, t2 + P2, t2 + _, i), _ = P2;
        }
        M2.pushRun(t2, _), M2.mergeRuns(), v4 -= _, t2 += _;
      } while (v4 !== 0);
      M2.forceMergeRuns();
    }
  }
  var UT = 1, ddt = 2, _tt = 4, M6e = false;
  function VKt() {
    M6e || (M6e = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
  }
  function C6e(f2, i) {
    return f2.zlevel === i.zlevel ? f2.z === i.z ? f2.z2 - i.z2 : f2.z - i.z : f2.zlevel - i.zlevel;
  }
  var eur = function() {
    function f2() {
      this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = C6e;
    }
    return f2.prototype.traverse = function(i, t2) {
      for (var h = 0; h < this._roots.length; h++)
        this._roots[h].traverse(i, t2);
    }, f2.prototype.getDisplayList = function(i, t2) {
      t2 = t2 || false;
      var h = this._displayList;
      return (i || !h.length) && this.updateDisplayList(t2), h;
    }, f2.prototype.updateDisplayList = function(i) {
      this._displayListLen = 0;
      for (var t2 = this._roots, h = this._displayList, v4 = 0, _ = t2.length; v4 < _; v4++)
        this._updateAndAddDisplayable(t2[v4], null, i);
      h.length = this._displayListLen, zDt(h, C6e);
    }, f2.prototype._updateAndAddDisplayable = function(i, t2, h) {
      if (!(i.ignore && !h)) {
        i.beforeUpdate(), i.update(), i.afterUpdate();
        var v4 = i.getClipPath();
        if (i.ignoreClip)
          t2 = null;
        else if (v4) {
          t2 ? t2 = t2.slice() : t2 = [];
          for (var _ = v4, M2 = i; _; )
            _.parent = M2, _.updateTransform(), t2.push(_), M2 = _, _ = _.getClipPath();
        }
        if (i.childrenRef) {
          for (var I2 = i.childrenRef(), P2 = 0; P2 < I2.length; P2++) {
            var N3 = I2[P2];
            i.__dirty && (N3.__dirty |= UT), this._updateAndAddDisplayable(N3, t2, h);
          }
          i.__dirty = 0;
        } else {
          var z3 = i;
          t2 && t2.length ? z3.__clipPaths = t2 : z3.__clipPaths && z3.__clipPaths.length > 0 && (z3.__clipPaths = []), isNaN(z3.z) && (VKt(), z3.z = 0), isNaN(z3.z2) && (VKt(), z3.z2 = 0), isNaN(z3.zlevel) && (VKt(), z3.zlevel = 0), this._displayList[this._displayListLen++] = z3;
        }
        var H2 = i.getDecalElement && i.getDecalElement();
        H2 && this._updateAndAddDisplayable(H2, t2, h);
        var $ = i.getTextGuideLine();
        $ && this._updateAndAddDisplayable($, t2, h);
        var et = i.getTextContent();
        et && this._updateAndAddDisplayable(et, t2, h);
      }
    }, f2.prototype.addRoot = function(i) {
      i.__zr && i.__zr.storage === this || this._roots.push(i);
    }, f2.prototype.delRoot = function(i) {
      if (i instanceof Array) {
        for (var t2 = 0, h = i.length; t2 < h; t2++)
          this.delRoot(i[t2]);
        return;
      }
      var v4 = Pc2(this._roots, i);
      v4 >= 0 && this._roots.splice(v4, 1);
    }, f2.prototype.delAllRoots = function() {
      this._roots = [], this._displayList = [], this._displayListLen = 0;
    }, f2.prototype.getRoots = function() {
      return this._roots;
    }, f2.prototype.dispose = function() {
      this._displayList = null, this._roots = null;
    }, f2;
  }(), nur = eur, oze;
  oze = gp.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(f2) {
    return setTimeout(f2, 16);
  };
  var xJt = oze, jDt = { linear: function(f2) {
    return f2;
  }, quadraticIn: function(f2) {
    return f2 * f2;
  }, quadraticOut: function(f2) {
    return f2 * (2 - f2);
  }, quadraticInOut: function(f2) {
    return (f2 *= 2) < 1 ? 0.5 * f2 * f2 : -0.5 * (--f2 * (f2 - 2) - 1);
  }, cubicIn: function(f2) {
    return f2 * f2 * f2;
  }, cubicOut: function(f2) {
    return --f2 * f2 * f2 + 1;
  }, cubicInOut: function(f2) {
    return (f2 *= 2) < 1 ? 0.5 * f2 * f2 * f2 : 0.5 * ((f2 -= 2) * f2 * f2 + 2);
  }, quarticIn: function(f2) {
    return f2 * f2 * f2 * f2;
  }, quarticOut: function(f2) {
    return 1 - --f2 * f2 * f2 * f2;
  }, quarticInOut: function(f2) {
    return (f2 *= 2) < 1 ? 0.5 * f2 * f2 * f2 * f2 : -0.5 * ((f2 -= 2) * f2 * f2 * f2 - 2);
  }, quinticIn: function(f2) {
    return f2 * f2 * f2 * f2 * f2;
  }, quinticOut: function(f2) {
    return --f2 * f2 * f2 * f2 * f2 + 1;
  }, quinticInOut: function(f2) {
    return (f2 *= 2) < 1 ? 0.5 * f2 * f2 * f2 * f2 * f2 : 0.5 * ((f2 -= 2) * f2 * f2 * f2 * f2 + 2);
  }, sinusoidalIn: function(f2) {
    return 1 - Math.cos(f2 * Math.PI / 2);
  }, sinusoidalOut: function(f2) {
    return Math.sin(f2 * Math.PI / 2);
  }, sinusoidalInOut: function(f2) {
    return 0.5 * (1 - Math.cos(Math.PI * f2));
  }, exponentialIn: function(f2) {
    return f2 === 0 ? 0 : Math.pow(1024, f2 - 1);
  }, exponentialOut: function(f2) {
    return f2 === 1 ? 1 : 1 - Math.pow(2, -10 * f2);
  }, exponentialInOut: function(f2) {
    return f2 === 0 ? 0 : f2 === 1 ? 1 : (f2 *= 2) < 1 ? 0.5 * Math.pow(1024, f2 - 1) : 0.5 * (-Math.pow(2, -10 * (f2 - 1)) + 2);
  }, circularIn: function(f2) {
    return 1 - Math.sqrt(1 - f2 * f2);
  }, circularOut: function(f2) {
    return Math.sqrt(1 - --f2 * f2);
  }, circularInOut: function(f2) {
    return (f2 *= 2) < 1 ? -0.5 * (Math.sqrt(1 - f2 * f2) - 1) : 0.5 * (Math.sqrt(1 - (f2 -= 2) * f2) + 1);
  }, elasticIn: function(f2) {
    var i, t2 = 0.1, h = 0.4;
    return f2 === 0 ? 0 : f2 === 1 ? 1 : (!t2 || t2 < 1 ? (t2 = 1, i = h / 4) : i = h * Math.asin(1 / t2) / (2 * Math.PI), -(t2 * Math.pow(2, 10 * (f2 -= 1)) * Math.sin((f2 - i) * (2 * Math.PI) / h)));
  }, elasticOut: function(f2) {
    var i, t2 = 0.1, h = 0.4;
    return f2 === 0 ? 0 : f2 === 1 ? 1 : (!t2 || t2 < 1 ? (t2 = 1, i = h / 4) : i = h * Math.asin(1 / t2) / (2 * Math.PI), t2 * Math.pow(2, -10 * f2) * Math.sin((f2 - i) * (2 * Math.PI) / h) + 1);
  }, elasticInOut: function(f2) {
    var i, t2 = 0.1, h = 0.4;
    return f2 === 0 ? 0 : f2 === 1 ? 1 : (!t2 || t2 < 1 ? (t2 = 1, i = h / 4) : i = h * Math.asin(1 / t2) / (2 * Math.PI), (f2 *= 2) < 1 ? -0.5 * (t2 * Math.pow(2, 10 * (f2 -= 1)) * Math.sin((f2 - i) * (2 * Math.PI) / h)) : t2 * Math.pow(2, -10 * (f2 -= 1)) * Math.sin((f2 - i) * (2 * Math.PI) / h) * 0.5 + 1);
  }, backIn: function(f2) {
    var i = 1.70158;
    return f2 * f2 * ((i + 1) * f2 - i);
  }, backOut: function(f2) {
    var i = 1.70158;
    return --f2 * f2 * ((i + 1) * f2 + i) + 1;
  }, backInOut: function(f2) {
    var i = 2.5949095;
    return (f2 *= 2) < 1 ? 0.5 * (f2 * f2 * ((i + 1) * f2 - i)) : 0.5 * ((f2 -= 2) * f2 * ((i + 1) * f2 + i) + 2);
  }, bounceIn: function(f2) {
    return 1 - jDt.bounceOut(1 - f2);
  }, bounceOut: function(f2) {
    return f2 < 1 / 2.75 ? 7.5625 * f2 * f2 : f2 < 2 / 2.75 ? 7.5625 * (f2 -= 1.5 / 2.75) * f2 + 0.75 : f2 < 2.5 / 2.75 ? 7.5625 * (f2 -= 2.25 / 2.75) * f2 + 0.9375 : 7.5625 * (f2 -= 2.625 / 2.75) * f2 + 0.984375;
  }, bounceInOut: function(f2) {
    return f2 < 0.5 ? jDt.bounceIn(f2 * 2) * 0.5 : jDt.bounceOut(f2 * 2 - 1) * 0.5 + 0.5;
  } }, sze = jDt, EIt = Math.pow, q7 = Math.sqrt, sEt = 1e-8, lze = 1e-4, T6e = q7(3), kIt = 1 / 3, EL = wU(), ZD = wU(), Ott = wU();
  function V7(f2) {
    return f2 > -sEt && f2 < sEt;
  }
  function uze(f2) {
    return f2 > sEt || f2 < -sEt;
  }
  function fb2(f2, i, t2, h, v4) {
    var _ = 1 - v4;
    return _ * _ * (_ * f2 + 3 * v4 * i) + v4 * v4 * (v4 * h + 3 * _ * t2);
  }
  function A6e(f2, i, t2, h, v4) {
    var _ = 1 - v4;
    return 3 * (((i - f2) * _ + 2 * (t2 - i) * v4) * _ + (h - t2) * v4 * v4);
  }
  function lEt(f2, i, t2, h, v4, _) {
    var M2 = h + 3 * (i - t2) - f2, I2 = 3 * (t2 - i * 2 + f2), P2 = 3 * (i - f2), N3 = f2 - v4, z3 = I2 * I2 - 3 * M2 * P2, H2 = I2 * P2 - 9 * M2 * N3, $ = P2 * P2 - 3 * I2 * N3, et = 0;
    if (V7(z3) && V7(H2))
      if (V7(I2))
        _[0] = 0;
      else {
        var at = -P2 / I2;
        at >= 0 && at <= 1 && (_[et++] = at);
      }
    else {
      var ht = H2 * H2 - 4 * z3 * $;
      if (V7(ht)) {
        var bt = H2 / z3, at = -I2 / M2 + bt, _t = -bt / 2;
        at >= 0 && at <= 1 && (_[et++] = at), _t >= 0 && _t <= 1 && (_[et++] = _t);
      } else if (ht > 0) {
        var Et = q7(ht), zt = z3 * I2 + 1.5 * M2 * (-H2 + Et), Ft = z3 * I2 + 1.5 * M2 * (-H2 - Et);
        zt < 0 ? zt = -EIt(-zt, kIt) : zt = EIt(zt, kIt), Ft < 0 ? Ft = -EIt(-Ft, kIt) : Ft = EIt(Ft, kIt);
        var at = (-I2 - (zt + Ft)) / (3 * M2);
        at >= 0 && at <= 1 && (_[et++] = at);
      } else {
        var fe2 = (2 * z3 * I2 - 3 * M2 * H2) / (2 * q7(z3 * z3 * z3)), re2 = Math.acos(fe2) / 3, ye = q7(z3), me2 = Math.cos(re2), at = (-I2 - 2 * ye * me2) / (3 * M2), _t = (-I2 + ye * (me2 + T6e * Math.sin(re2))) / (3 * M2), be2 = (-I2 + ye * (me2 - T6e * Math.sin(re2))) / (3 * M2);
        at >= 0 && at <= 1 && (_[et++] = at), _t >= 0 && _t <= 1 && (_[et++] = _t), be2 >= 0 && be2 <= 1 && (_[et++] = be2);
      }
    }
    return et;
  }
  function cze(f2, i, t2, h, v4) {
    var _ = 6 * t2 - 12 * i + 6 * f2, M2 = 9 * i + 3 * h - 3 * f2 - 9 * t2, I2 = 3 * i - 3 * f2, P2 = 0;
    if (V7(M2)) {
      if (uze(_)) {
        var N3 = -I2 / _;
        N3 >= 0 && N3 <= 1 && (v4[P2++] = N3);
      }
    } else {
      var z3 = _ * _ - 4 * M2 * I2;
      if (V7(z3))
        v4[0] = -_ / (2 * M2);
      else if (z3 > 0) {
        var H2 = q7(z3), N3 = (-_ + H2) / (2 * M2), $ = (-_ - H2) / (2 * M2);
        N3 >= 0 && N3 <= 1 && (v4[P2++] = N3), $ >= 0 && $ <= 1 && (v4[P2++] = $);
      }
    }
    return P2;
  }
  function X7(f2, i, t2, h, v4, _) {
    var M2 = (i - f2) * v4 + f2, I2 = (t2 - i) * v4 + i, P2 = (h - t2) * v4 + t2, N3 = (I2 - M2) * v4 + M2, z3 = (P2 - I2) * v4 + I2, H2 = (z3 - N3) * v4 + N3;
    _[0] = f2, _[1] = M2, _[2] = N3, _[3] = H2, _[4] = H2, _[5] = z3, _[6] = P2, _[7] = h;
  }
  function fze(f2, i, t2, h, v4, _, M2, I2, P2, N3, z3) {
    var H2, $ = 5e-3, et = 1 / 0, at, ht, bt, _t;
    EL[0] = P2, EL[1] = N3;
    for (var Et = 0; Et < 1; Et += 0.05)
      ZD[0] = fb2(f2, t2, v4, M2, Et), ZD[1] = fb2(i, h, _, I2, Et), bt = oU(EL, ZD), bt < et && (H2 = Et, et = bt);
    et = 1 / 0;
    for (var zt = 0; zt < 32 && !($ < lze); zt++)
      at = H2 - $, ht = H2 + $, ZD[0] = fb2(f2, t2, v4, M2, at), ZD[1] = fb2(i, h, _, I2, at), bt = oU(ZD, EL), at >= 0 && bt < et ? (H2 = at, et = bt) : (Ott[0] = fb2(f2, t2, v4, M2, ht), Ott[1] = fb2(i, h, _, I2, ht), _t = oU(Ott, EL), ht <= 1 && _t < et ? (H2 = ht, et = _t) : $ *= 0.5);
    return z3 && (z3[0] = fb2(f2, t2, v4, M2, H2), z3[1] = fb2(i, h, _, I2, H2)), q7(et);
  }
  function rur(f2, i, t2, h, v4, _, M2, I2, P2) {
    for (var N3 = f2, z3 = i, H2 = 0, $ = 1 / P2, et = 1; et <= P2; et++) {
      var at = et * $, ht = fb2(f2, t2, v4, M2, at), bt = fb2(i, h, _, I2, at), _t = ht - N3, Et = bt - z3;
      H2 += Math.sqrt(_t * _t + Et * Et), N3 = ht, z3 = bt;
    }
    return H2;
  }
  function v_(f2, i, t2, h) {
    var v4 = 1 - h;
    return v4 * (v4 * f2 + 2 * h * i) + h * h * t2;
  }
  function wJt(f2, i, t2, h) {
    return 2 * ((1 - h) * (i - f2) + h * (t2 - i));
  }
  function iur(f2, i, t2, h, v4) {
    var _ = f2 - 2 * i + t2, M2 = 2 * (i - f2), I2 = f2 - h, P2 = 0;
    if (V7(_)) {
      if (uze(M2)) {
        var N3 = -I2 / M2;
        N3 >= 0 && N3 <= 1 && (v4[P2++] = N3);
      }
    } else {
      var z3 = M2 * M2 - 4 * _ * I2;
      if (V7(z3)) {
        var N3 = -M2 / (2 * _);
        N3 >= 0 && N3 <= 1 && (v4[P2++] = N3);
      } else if (z3 > 0) {
        var H2 = q7(z3), N3 = (-M2 + H2) / (2 * _), $ = (-M2 - H2) / (2 * _);
        N3 >= 0 && N3 <= 1 && (v4[P2++] = N3), $ >= 0 && $ <= 1 && (v4[P2++] = $);
      }
    }
    return P2;
  }
  function hze(f2, i, t2) {
    var h = f2 + t2 - 2 * i;
    return h === 0 ? 0.5 : (f2 - i) / h;
  }
  function $dt(f2, i, t2, h, v4) {
    var _ = (i - f2) * h + f2, M2 = (t2 - i) * h + i, I2 = (M2 - _) * h + _;
    v4[0] = f2, v4[1] = _, v4[2] = I2, v4[3] = I2, v4[4] = M2, v4[5] = t2;
  }
  function pze(f2, i, t2, h, v4, _, M2, I2, P2) {
    var N3, z3 = 5e-3, H2 = 1 / 0;
    EL[0] = M2, EL[1] = I2;
    for (var $ = 0; $ < 1; $ += 0.05) {
      ZD[0] = v_(f2, t2, v4, $), ZD[1] = v_(i, h, _, $);
      var et = oU(EL, ZD);
      et < H2 && (N3 = $, H2 = et);
    }
    H2 = 1 / 0;
    for (var at = 0; at < 32 && !(z3 < lze); at++) {
      var ht = N3 - z3, bt = N3 + z3;
      ZD[0] = v_(f2, t2, v4, ht), ZD[1] = v_(i, h, _, ht);
      var et = oU(ZD, EL);
      if (ht >= 0 && et < H2)
        N3 = ht, H2 = et;
      else {
        Ott[0] = v_(f2, t2, v4, bt), Ott[1] = v_(i, h, _, bt);
        var _t = oU(Ott, EL);
        bt <= 1 && _t < H2 ? (N3 = bt, H2 = _t) : z3 *= 0.5;
      }
    }
    return P2 && (P2[0] = v_(f2, t2, v4, N3), P2[1] = v_(i, h, _, N3)), q7(H2);
  }
  function aur(f2, i, t2, h, v4, _, M2) {
    for (var I2 = f2, P2 = i, N3 = 0, z3 = 1 / M2, H2 = 1; H2 <= M2; H2++) {
      var $ = H2 * z3, et = v_(f2, t2, v4, $), at = v_(i, h, _, $), ht = et - I2, bt = at - P2;
      N3 += Math.sqrt(ht * ht + bt * bt), I2 = et, P2 = at;
    }
    return N3;
  }
  var our = /cubic-bezier\(([0-9,\.e ]+)\)/;
  function Mee(f2) {
    var i = f2 && our.exec(f2);
    if (i) {
      var t2 = i[1].split(","), h = +w5(t2[0]), v4 = +w5(t2[1]), _ = +w5(t2[2]), M2 = +w5(t2[3]);
      if (isNaN(h + v4 + _ + M2))
        return;
      var I2 = [];
      return function(P2) {
        return P2 <= 0 ? 0 : P2 >= 1 ? 1 : lEt(0, h, _, 1, P2, I2) && fb2(0, v4, M2, 1, I2[0]);
      };
    }
  }
  var sur = function() {
    function f2(i) {
      this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = i.life || 1e3, this._delay = i.delay || 0, this.loop = i.loop || false, this.onframe = i.onframe || xm, this.ondestroy = i.ondestroy || xm, this.onrestart = i.onrestart || xm, i.easing && this.setEasing(i.easing);
    }
    return f2.prototype.step = function(i, t2) {
      if (this._inited || (this._startTime = i + this._delay, this._inited = true), this._paused) {
        this._pausedTime += t2;
        return;
      }
      var h = this._life, v4 = i - this._startTime - this._pausedTime, _ = v4 / h;
      _ < 0 && (_ = 0), _ = Math.min(_, 1);
      var M2 = this.easingFunc, I2 = M2 ? M2(_) : _;
      if (this.onframe(I2), _ === 1)
        if (this.loop) {
          var P2 = v4 % h;
          this._startTime = i - P2, this._pausedTime = 0, this.onrestart();
        } else
          return true;
      return false;
    }, f2.prototype.pause = function() {
      this._paused = true;
    }, f2.prototype.resume = function() {
      this._paused = false;
    }, f2.prototype.setEasing = function(i) {
      this.easing = i, this.easingFunc = Ol(i) ? i : sze[i] || Mee(i);
    }, f2;
  }(), lur = sur, dze = function() {
    function f2(i) {
      this.value = i;
    }
    return f2;
  }(), uur = function() {
    function f2() {
      this._len = 0;
    }
    return f2.prototype.insert = function(i) {
      var t2 = new dze(i);
      return this.insertEntry(t2), t2;
    }, f2.prototype.insertEntry = function(i) {
      this.head ? (this.tail.next = i, i.prev = this.tail, i.next = null, this.tail = i) : this.head = this.tail = i, this._len++;
    }, f2.prototype.remove = function(i) {
      var t2 = i.prev, h = i.next;
      t2 ? t2.next = h : this.head = h, h ? h.prev = t2 : this.tail = t2, i.next = i.prev = null, this._len--;
    }, f2.prototype.len = function() {
      return this._len;
    }, f2.prototype.clear = function() {
      this.head = this.tail = null, this._len = 0;
    }, f2;
  }(), cur = function() {
    function f2(i) {
      this._list = new uur(), this._maxSize = 10, this._map = {}, this._maxSize = i;
    }
    return f2.prototype.put = function(i, t2) {
      var h = this._list, v4 = this._map, _ = null;
      if (v4[i] == null) {
        var M2 = h.len(), I2 = this._lastRemovedEntry;
        if (M2 >= this._maxSize && M2 > 0) {
          var P2 = h.head;
          h.remove(P2), delete v4[P2.key], _ = P2.value, this._lastRemovedEntry = P2;
        }
        I2 ? I2.value = t2 : I2 = new dze(t2), I2.key = i, h.insertEntry(I2), v4[i] = I2;
      }
      return _;
    }, f2.prototype.get = function(i) {
      var t2 = this._map[i], h = this._list;
      if (t2 != null)
        return t2 !== h.tail && (h.remove(t2), h.insertEntry(t2)), t2.value;
    }, f2.prototype.clear = function() {
      this._list.clear(), this._map = {};
    }, f2.prototype.len = function() {
      return this._list.len();
    }, f2;
  }(), Mgt = cur, I6e = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
  function M5(f2) {
    return f2 = Math.round(f2), f2 < 0 ? 0 : f2 > 255 ? 255 : f2;
  }
  function fur(f2) {
    return f2 = Math.round(f2), f2 < 0 ? 0 : f2 > 360 ? 360 : f2;
  }
  function Ydt(f2) {
    return f2 < 0 ? 0 : f2 > 1 ? 1 : f2;
  }
  function BKt(f2) {
    var i = f2;
    return i.length && i.charAt(i.length - 1) === "%" ? M5(parseFloat(i) / 100 * 255) : M5(parseInt(i, 10));
  }
  function jtt(f2) {
    var i = f2;
    return i.length && i.charAt(i.length - 1) === "%" ? Ydt(parseFloat(i) / 100) : Ydt(parseFloat(i));
  }
  function zKt(f2, i, t2) {
    return t2 < 0 ? t2 += 1 : t2 > 1 && (t2 -= 1), t2 * 6 < 1 ? f2 + (i - f2) * t2 * 6 : t2 * 2 < 1 ? i : t2 * 3 < 2 ? f2 + (i - f2) * (2 / 3 - t2) * 6 : f2;
  }
  function B7(f2, i, t2) {
    return f2 + (i - f2) * t2;
  }
  function WD(f2, i, t2, h, v4) {
    return f2[0] = i, f2[1] = t2, f2[2] = h, f2[3] = v4, f2;
  }
  function SJt(f2, i) {
    return f2[0] = i[0], f2[1] = i[1], f2[2] = i[2], f2[3] = i[3], f2;
  }
  var gze = new Mgt(20), PIt = null;
  function JJ(f2, i) {
    PIt && SJt(PIt, i), PIt = gze.put(f2, PIt || i.slice());
  }
  function ZT(f2, i) {
    if (!!f2) {
      i = i || [];
      var t2 = gze.get(f2);
      if (t2)
        return SJt(i, t2);
      f2 = f2 + "";
      var h = f2.replace(/ /g, "").toLowerCase();
      if (h in I6e)
        return SJt(i, I6e[h]), JJ(f2, i), i;
      var v4 = h.length;
      if (h.charAt(0) === "#") {
        if (v4 === 4 || v4 === 5) {
          var _ = parseInt(h.slice(1, 4), 16);
          if (!(_ >= 0 && _ <= 4095)) {
            WD(i, 0, 0, 0, 1);
            return;
          }
          return WD(i, (_ & 3840) >> 4 | (_ & 3840) >> 8, _ & 240 | (_ & 240) >> 4, _ & 15 | (_ & 15) << 4, v4 === 5 ? parseInt(h.slice(4), 16) / 15 : 1), JJ(f2, i), i;
        } else if (v4 === 7 || v4 === 9) {
          var _ = parseInt(h.slice(1, 7), 16);
          if (!(_ >= 0 && _ <= 16777215)) {
            WD(i, 0, 0, 0, 1);
            return;
          }
          return WD(i, (_ & 16711680) >> 16, (_ & 65280) >> 8, _ & 255, v4 === 9 ? parseInt(h.slice(7), 16) / 255 : 1), JJ(f2, i), i;
        }
        return;
      }
      var M2 = h.indexOf("("), I2 = h.indexOf(")");
      if (M2 !== -1 && I2 + 1 === v4) {
        var P2 = h.substr(0, M2), N3 = h.substr(M2 + 1, I2 - (M2 + 1)).split(","), z3 = 1;
        switch (P2) {
          case "rgba":
            if (N3.length !== 4)
              return N3.length === 3 ? WD(i, +N3[0], +N3[1], +N3[2], 1) : WD(i, 0, 0, 0, 1);
            z3 = jtt(N3.pop());
          case "rgb":
            if (N3.length !== 3) {
              WD(i, 0, 0, 0, 1);
              return;
            }
            return WD(i, BKt(N3[0]), BKt(N3[1]), BKt(N3[2]), z3), JJ(f2, i), i;
          case "hsla":
            if (N3.length !== 4) {
              WD(i, 0, 0, 0, 1);
              return;
            }
            return N3[3] = jtt(N3[3]), MJt(N3, i), JJ(f2, i), i;
          case "hsl":
            if (N3.length !== 3) {
              WD(i, 0, 0, 0, 1);
              return;
            }
            return MJt(N3, i), JJ(f2, i), i;
          default:
            return;
        }
      }
      WD(i, 0, 0, 0, 1);
    }
  }
  function MJt(f2, i) {
    var t2 = (parseFloat(f2[0]) % 360 + 360) % 360 / 360, h = jtt(f2[1]), v4 = jtt(f2[2]), _ = v4 <= 0.5 ? v4 * (h + 1) : v4 + h - v4 * h, M2 = v4 * 2 - _;
    return i = i || [], WD(i, M5(zKt(M2, _, t2 + 1 / 3) * 255), M5(zKt(M2, _, t2) * 255), M5(zKt(M2, _, t2 - 1 / 3) * 255), 1), f2.length === 4 && (i[3] = f2[3]), i;
  }
  function hur(f2) {
    if (!!f2) {
      var i = f2[0] / 255, t2 = f2[1] / 255, h = f2[2] / 255, v4 = Math.min(i, t2, h), _ = Math.max(i, t2, h), M2 = _ - v4, I2 = (_ + v4) / 2, P2, N3;
      if (M2 === 0)
        P2 = 0, N3 = 0;
      else {
        I2 < 0.5 ? N3 = M2 / (_ + v4) : N3 = M2 / (2 - _ - v4);
        var z3 = ((_ - i) / 6 + M2 / 2) / M2, H2 = ((_ - t2) / 6 + M2 / 2) / M2, $ = ((_ - h) / 6 + M2 / 2) / M2;
        i === _ ? P2 = $ - H2 : t2 === _ ? P2 = 1 / 3 + z3 - $ : h === _ && (P2 = 2 / 3 + H2 - z3), P2 < 0 && (P2 += 1), P2 > 1 && (P2 -= 1);
      }
      var et = [P2 * 360, N3, I2];
      return f2[3] != null && et.push(f2[3]), et;
    }
  }
  function CJt(f2, i) {
    var t2 = ZT(f2);
    if (t2) {
      for (var h = 0; h < 3; h++)
        i < 0 ? t2[h] = t2[h] * (1 - i) | 0 : t2[h] = (255 - t2[h]) * i + t2[h] | 0, t2[h] > 255 ? t2[h] = 255 : t2[h] < 0 && (t2[h] = 0);
      return Z6(t2, t2.length === 4 ? "rgba" : "rgb");
    }
  }
  function jKt(f2, i, t2) {
    if (!(!(i && i.length) || !(f2 >= 0 && f2 <= 1))) {
      t2 = t2 || [];
      var h = f2 * (i.length - 1), v4 = Math.floor(h), _ = Math.ceil(h), M2 = i[v4], I2 = i[_], P2 = h - v4;
      return t2[0] = M5(B7(M2[0], I2[0], P2)), t2[1] = M5(B7(M2[1], I2[1], P2)), t2[2] = M5(B7(M2[2], I2[2], P2)), t2[3] = Ydt(B7(M2[3], I2[3], P2)), t2;
    }
  }
  function pur(f2, i, t2) {
    if (!(!(i && i.length) || !(f2 >= 0 && f2 <= 1))) {
      var h = f2 * (i.length - 1), v4 = Math.floor(h), _ = Math.ceil(h), M2 = ZT(i[v4]), I2 = ZT(i[_]), P2 = h - v4, N3 = Z6([M5(B7(M2[0], I2[0], P2)), M5(B7(M2[1], I2[1], P2)), M5(B7(M2[2], I2[2], P2)), Ydt(B7(M2[3], I2[3], P2))], "rgba");
      return t2 ? { color: N3, leftIndex: v4, rightIndex: _, value: h } : N3;
    }
  }
  function Idt(f2, i, t2, h) {
    var v4 = ZT(f2);
    if (f2)
      return v4 = hur(v4), i != null && (v4[0] = fur(i)), t2 != null && (v4[1] = jtt(t2)), h != null && (v4[2] = jtt(h)), Z6(MJt(v4), "rgba");
  }
  function uEt(f2, i) {
    var t2 = ZT(f2);
    if (t2 && i != null)
      return t2[3] = Ydt(i), Z6(t2, "rgba");
  }
  function Z6(f2, i) {
    if (!(!f2 || !f2.length)) {
      var t2 = f2[0] + "," + f2[1] + "," + f2[2];
      return (i === "rgba" || i === "hsva" || i === "hsla") && (t2 += "," + f2[3]), i + "(" + t2 + ")";
    }
  }
  function cEt(f2, i) {
    var t2 = ZT(f2);
    return t2 ? (0.299 * t2[0] + 0.587 * t2[1] + 0.114 * t2[2]) * t2[3] / 255 + (1 - t2[3]) * i : 0;
  }
  var fEt = Math.round;
  function Wtt(f2) {
    var i;
    if (!f2 || f2 === "transparent")
      f2 = "none";
    else if (typeof f2 == "string" && f2.indexOf("rgba") > -1) {
      var t2 = ZT(f2);
      t2 && (f2 = "rgb(" + t2[0] + "," + t2[1] + "," + t2[2] + ")", i = t2[3]);
    }
    return { color: f2, opacity: i == null ? 1 : i };
  }
  var D6e = 1e-4;
  function z7(f2) {
    return f2 < D6e && f2 > -D6e;
  }
  function LIt(f2) {
    return fEt(f2 * 1e3) / 1e3;
  }
  function TJt(f2) {
    return fEt(f2 * 1e4) / 1e4;
  }
  function dur(f2) {
    return "matrix(" + LIt(f2[0]) + "," + LIt(f2[1]) + "," + LIt(f2[2]) + "," + LIt(f2[3]) + "," + TJt(f2[4]) + "," + TJt(f2[5]) + ")";
  }
  var gur = { left: "start", right: "end", center: "middle", middle: "middle" };
  function vur(f2, i, t2) {
    return t2 === "top" ? f2 += i / 2 : t2 === "bottom" && (f2 -= i / 2), f2;
  }
  function yur(f2) {
    return f2 && (f2.shadowBlur || f2.shadowOffsetX || f2.shadowOffsetY);
  }
  function mur(f2) {
    var i = f2.style, t2 = f2.getGlobalScale();
    return [i.shadowColor, (i.shadowBlur || 0).toFixed(2), (i.shadowOffsetX || 0).toFixed(2), (i.shadowOffsetY || 0).toFixed(2), t2[0], t2[1]].join(",");
  }
  function vze(f2) {
    return f2 && !!f2.image;
  }
  function bur(f2) {
    return f2 && !!f2.svgElement;
  }
  function _ur(f2) {
    return vze(f2) || bur(f2);
  }
  function yze(f2) {
    return f2.type === "linear";
  }
  function mze(f2) {
    return f2.type === "radial";
  }
  function xur(f2) {
    return f2 && (f2.type === "linear" || f2.type === "radial");
  }
  function lkt(f2) {
    return "url(#" + f2 + ")";
  }
  function bze(f2) {
    var i = f2.getGlobalScale(), t2 = Math.max(i[0], i[1]);
    return Math.max(Math.ceil(Math.log(t2) / Math.log(10)), 1);
  }
  function _ze(f2) {
    var i = f2.x || 0, t2 = f2.y || 0, h = (f2.rotation || 0) * VDt, v4 = _c2(f2.scaleX, 1), _ = _c2(f2.scaleY, 1), M2 = f2.skewX || 0, I2 = f2.skewY || 0, P2 = [];
    return (i || t2) && P2.push("translate(" + i + "px," + t2 + "px)"), h && P2.push("rotate(" + h + ")"), (v4 !== 1 || _ !== 1) && P2.push("scale(" + v4 + "," + _ + ")"), (M2 || I2) && P2.push("skew(" + fEt(M2 * VDt) + "deg, " + fEt(I2 * VDt) + "deg)"), P2.join(" ");
  }
  var wur = function() {
    return gp.hasGlobalWindow && Ol(window.btoa) ? function(f2) {
      return window.btoa(unescape(f2));
    } : typeof Buffer != "undefined" ? function(f2) {
      return Buffer.from(f2).toString("base64");
    } : function(f2) {
      return null;
    };
  }(), AJt = Array.prototype.slice;
  function j6(f2, i, t2) {
    return (i - f2) * t2 + f2;
  }
  function WKt(f2, i, t2, h) {
    for (var v4 = i.length, _ = 0; _ < v4; _++)
      f2[_] = j6(i[_], t2[_], h);
    return f2;
  }
  function Sur(f2, i, t2, h) {
    for (var v4 = i.length, _ = v4 && i[0].length, M2 = 0; M2 < v4; M2++) {
      f2[M2] || (f2[M2] = []);
      for (var I2 = 0; I2 < _; I2++)
        f2[M2][I2] = j6(i[M2][I2], t2[M2][I2], h);
    }
    return f2;
  }
  function OIt(f2, i, t2, h) {
    for (var v4 = i.length, _ = 0; _ < v4; _++)
      f2[_] = i[_] + t2[_] * h;
    return f2;
  }
  function E6e(f2, i, t2, h) {
    for (var v4 = i.length, _ = v4 && i[0].length, M2 = 0; M2 < v4; M2++) {
      f2[M2] || (f2[M2] = []);
      for (var I2 = 0; I2 < _; I2++)
        f2[M2][I2] = i[M2][I2] + t2[M2][I2] * h;
    }
    return f2;
  }
  function Mur(f2, i) {
    for (var t2 = f2.length, h = i.length, v4 = t2 > h ? i : f2, _ = Math.min(t2, h), M2 = v4[_ - 1] || { color: [0, 0, 0, 0], offset: 0 }, I2 = _; I2 < Math.max(t2, h); I2++)
      v4.push({ offset: M2.offset, color: M2.color.slice() });
  }
  function Cur(f2, i, t2) {
    var h = f2, v4 = i;
    if (!(!h.push || !v4.push)) {
      var _ = h.length, M2 = v4.length;
      if (_ !== M2) {
        var I2 = _ > M2;
        if (I2)
          h.length = M2;
        else
          for (var P2 = _; P2 < M2; P2++)
            h.push(t2 === 1 ? v4[P2] : AJt.call(v4[P2]));
      }
      for (var N3 = h[0] && h[0].length, P2 = 0; P2 < h.length; P2++)
        if (t2 === 1)
          isNaN(h[P2]) && (h[P2] = v4[P2]);
        else
          for (var z3 = 0; z3 < N3; z3++)
            isNaN(h[P2][z3]) && (h[P2][z3] = v4[P2][z3]);
    }
  }
  function Ddt(f2) {
    if (xS(f2)) {
      var i = f2.length;
      if (xS(f2[0])) {
        for (var t2 = [], h = 0; h < i; h++)
          t2.push(AJt.call(f2[h]));
        return t2;
      }
      return AJt.call(f2);
    }
    return f2;
  }
  function WDt(f2) {
    return f2[0] = Math.floor(f2[0]) || 0, f2[1] = Math.floor(f2[1]) || 0, f2[2] = Math.floor(f2[2]) || 0, f2[3] = f2[3] == null ? 1 : f2[3], "rgba(" + f2.join(",") + ")";
  }
  function Tur(f2) {
    return xS(f2 && f2[0]) ? 2 : 1;
  }
  var RIt = 0, GDt = 1, xze = 2, gdt = 3, IJt = 4, DJt = 5, k6e = 6;
  function P6e(f2) {
    return f2 === IJt || f2 === DJt;
  }
  function NIt(f2) {
    return f2 === GDt || f2 === xze;
  }
  var Vpt = [0, 0, 0, 0], Aur = function() {
    function f2(i) {
      this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = i;
    }
    return f2.prototype.isFinished = function() {
      return this._finished;
    }, f2.prototype.setFinished = function() {
      this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
    }, f2.prototype.needsAnimate = function() {
      return this.keyframes.length >= 1;
    }, f2.prototype.getAdditiveTrack = function() {
      return this._additiveTrack;
    }, f2.prototype.addKeyframe = function(i, t2, h) {
      this._needsSort = true;
      var v4 = this.keyframes, _ = v4.length, M2 = false, I2 = k6e, P2 = t2;
      if (xS(t2)) {
        var N3 = Tur(t2);
        I2 = N3, (N3 === 1 && !vp(t2[0]) || N3 === 2 && !vp(t2[0][0])) && (M2 = true);
      } else if (vp(t2) && !Zdt(t2))
        I2 = RIt;
      else if (ms(t2))
        if (!isNaN(+t2))
          I2 = RIt;
        else {
          var z3 = ZT(t2);
          z3 && (P2 = z3, I2 = gdt);
        }
      else if (okt(t2)) {
        var H2 = ba2({}, P2);
        H2.colorStops = Xa2(t2.colorStops, function(et) {
          return { offset: et.offset, color: ZT(et.color) };
        }), yze(t2) ? I2 = IJt : mze(t2) && (I2 = DJt), P2 = H2;
      }
      _ === 0 ? this.valType = I2 : (I2 !== this.valType || I2 === k6e) && (M2 = true), this.discrete = this.discrete || M2;
      var $ = { time: i, value: P2, rawValue: t2, percent: 0 };
      return h && ($.easing = h, $.easingFunc = Ol(h) ? h : sze[h] || Mee(h)), v4.push($), $;
    }, f2.prototype.prepare = function(i, t2) {
      var h = this.keyframes;
      this._needsSort && h.sort(function(ht, bt) {
        return ht.time - bt.time;
      });
      for (var v4 = this.valType, _ = h.length, M2 = h[_ - 1], I2 = this.discrete, P2 = NIt(v4), N3 = P6e(v4), z3 = 0; z3 < _; z3++) {
        var H2 = h[z3], $ = H2.value, et = M2.value;
        H2.percent = H2.time / i, I2 || (P2 && z3 !== _ - 1 ? Cur($, et, v4) : N3 && Mur($.colorStops, et.colorStops));
      }
      if (!I2 && v4 !== DJt && t2 && this.needsAnimate() && t2.needsAnimate() && v4 === t2.valType && !t2._finished) {
        this._additiveTrack = t2;
        for (var at = h[0].value, z3 = 0; z3 < _; z3++)
          v4 === RIt ? h[z3].additiveValue = h[z3].value - at : v4 === gdt ? h[z3].additiveValue = OIt([], h[z3].value, at, -1) : NIt(v4) && (h[z3].additiveValue = v4 === GDt ? OIt([], h[z3].value, at, -1) : E6e([], h[z3].value, at, -1));
      }
    }, f2.prototype.step = function(i, t2) {
      if (!this._finished) {
        this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
        var h = this._additiveTrack != null, v4 = h ? "additiveValue" : "value", _ = this.valType, M2 = this.keyframes, I2 = M2.length, P2 = this.propName, N3 = _ === gdt, z3, H2 = this._lastFr, $ = Math.min, et, at;
        if (I2 === 1)
          et = at = M2[0];
        else {
          if (t2 < 0)
            z3 = 0;
          else if (t2 < this._lastFrP) {
            var ht = $(H2 + 1, I2 - 1);
            for (z3 = ht; z3 >= 0 && !(M2[z3].percent <= t2); z3--)
              ;
            z3 = $(z3, I2 - 2);
          } else {
            for (z3 = H2; z3 < I2 && !(M2[z3].percent > t2); z3++)
              ;
            z3 = $(z3 - 1, I2 - 2);
          }
          at = M2[z3 + 1], et = M2[z3];
        }
        if (!!(et && at)) {
          this._lastFr = z3, this._lastFrP = t2;
          var bt = at.percent - et.percent, _t = bt === 0 ? 1 : $((t2 - et.percent) / bt, 1);
          at.easingFunc && (_t = at.easingFunc(_t));
          var Et = h ? this._additiveValue : N3 ? Vpt : i[P2];
          if ((NIt(_) || N3) && !Et && (Et = this._additiveValue = []), this.discrete)
            i[P2] = _t < 1 ? et.rawValue : at.rawValue;
          else if (NIt(_))
            _ === GDt ? WKt(Et, et[v4], at[v4], _t) : Sur(Et, et[v4], at[v4], _t);
          else if (P6e(_)) {
            var zt = et[v4], Ft = at[v4], fe2 = _ === IJt;
            i[P2] = { type: fe2 ? "linear" : "radial", x: j6(zt.x, Ft.x, _t), y: j6(zt.y, Ft.y, _t), colorStops: Xa2(zt.colorStops, function(ye, me2) {
              var be2 = Ft.colorStops[me2];
              return { offset: j6(ye.offset, be2.offset, _t), color: WDt(WKt([], ye.color, be2.color, _t)) };
            }), global: Ft.global }, fe2 ? (i[P2].x2 = j6(zt.x2, Ft.x2, _t), i[P2].y2 = j6(zt.y2, Ft.y2, _t)) : i[P2].r = j6(zt.r, Ft.r, _t);
          } else if (N3)
            WKt(Et, et[v4], at[v4], _t), h || (i[P2] = WDt(Et));
          else {
            var re2 = j6(et[v4], at[v4], _t);
            h ? this._additiveValue = re2 : i[P2] = re2;
          }
          h && this._addToTarget(i);
        }
      }
    }, f2.prototype._addToTarget = function(i) {
      var t2 = this.valType, h = this.propName, v4 = this._additiveValue;
      t2 === RIt ? i[h] = i[h] + v4 : t2 === gdt ? (ZT(i[h], Vpt), OIt(Vpt, Vpt, v4, 1), i[h] = WDt(Vpt)) : t2 === GDt ? OIt(i[h], i[h], v4, 1) : t2 === xze && E6e(i[h], i[h], v4, 1);
    }, f2;
  }(), Cee = function() {
    function f2(i, t2, h, v4) {
      if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = i, this._loop = t2, t2 && v4) {
        bee("Can' use additive animation on looped animation.");
        return;
      }
      this._additiveAnimators = v4, this._allowDiscrete = h;
    }
    return f2.prototype.getMaxTime = function() {
      return this._maxTime;
    }, f2.prototype.getDelay = function() {
      return this._delay;
    }, f2.prototype.getLoop = function() {
      return this._loop;
    }, f2.prototype.getTarget = function() {
      return this._target;
    }, f2.prototype.changeTarget = function(i) {
      this._target = i;
    }, f2.prototype.when = function(i, t2, h) {
      return this.whenWithKeys(i, t2, Of2(t2), h);
    }, f2.prototype.whenWithKeys = function(i, t2, h, v4) {
      for (var _ = this._tracks, M2 = 0; M2 < h.length; M2++) {
        var I2 = h[M2], P2 = _[I2];
        if (!P2) {
          P2 = _[I2] = new Aur(I2);
          var N3 = void 0, z3 = this._getAdditiveTrack(I2);
          if (z3) {
            var H2 = z3.keyframes, $ = H2[H2.length - 1];
            N3 = $ && $.value, z3.valType === gdt && N3 && (N3 = WDt(N3));
          } else
            N3 = this._target[I2];
          if (N3 == null)
            continue;
          i > 0 && P2.addKeyframe(0, Ddt(N3), v4), this._trackKeys.push(I2);
        }
        P2.addKeyframe(i, Ddt(t2[I2]), v4);
      }
      return this._maxTime = Math.max(this._maxTime, i), this;
    }, f2.prototype.pause = function() {
      this._clip.pause(), this._paused = true;
    }, f2.prototype.resume = function() {
      this._clip.resume(), this._paused = false;
    }, f2.prototype.isPaused = function() {
      return !!this._paused;
    }, f2.prototype.duration = function(i) {
      return this._maxTime = i, this._force = true, this;
    }, f2.prototype._doneCallback = function() {
      this._setTracksFinished(), this._clip = null;
      var i = this._doneCbs;
      if (i)
        for (var t2 = i.length, h = 0; h < t2; h++)
          i[h].call(this);
    }, f2.prototype._abortedCallback = function() {
      this._setTracksFinished();
      var i = this.animation, t2 = this._abortedCbs;
      if (i && i.removeClip(this._clip), this._clip = null, t2)
        for (var h = 0; h < t2.length; h++)
          t2[h].call(this);
    }, f2.prototype._setTracksFinished = function() {
      for (var i = this._tracks, t2 = this._trackKeys, h = 0; h < t2.length; h++)
        i[t2[h]].setFinished();
    }, f2.prototype._getAdditiveTrack = function(i) {
      var t2, h = this._additiveAnimators;
      if (h)
        for (var v4 = 0; v4 < h.length; v4++) {
          var _ = h[v4].getTrack(i);
          _ && (t2 = _);
        }
      return t2;
    }, f2.prototype.start = function(i) {
      if (!(this._started > 0)) {
        this._started = 1;
        for (var t2 = this, h = [], v4 = this._maxTime || 0, _ = 0; _ < this._trackKeys.length; _++) {
          var M2 = this._trackKeys[_], I2 = this._tracks[M2], P2 = this._getAdditiveTrack(M2), N3 = I2.keyframes, z3 = N3.length;
          if (I2.prepare(v4, P2), I2.needsAnimate())
            if (!this._allowDiscrete && I2.discrete) {
              var H2 = N3[z3 - 1];
              H2 && (t2._target[I2.propName] = H2.rawValue), I2.setFinished();
            } else
              h.push(I2);
        }
        if (h.length || this._force) {
          var $ = new lur({ life: v4, loop: this._loop, delay: this._delay || 0, onframe: function(et) {
            t2._started = 2;
            var at = t2._additiveAnimators;
            if (at) {
              for (var ht = false, bt = 0; bt < at.length; bt++)
                if (at[bt]._clip) {
                  ht = true;
                  break;
                }
              ht || (t2._additiveAnimators = null);
            }
            for (var bt = 0; bt < h.length; bt++)
              h[bt].step(t2._target, et);
            var _t = t2._onframeCbs;
            if (_t)
              for (var bt = 0; bt < _t.length; bt++)
                _t[bt](t2._target, et);
          }, ondestroy: function() {
            t2._doneCallback();
          } });
          this._clip = $, this.animation && this.animation.addClip($), i && $.setEasing(i);
        } else
          this._doneCallback();
        return this;
      }
    }, f2.prototype.stop = function(i) {
      if (!!this._clip) {
        var t2 = this._clip;
        i && t2.onframe(1), this._abortedCallback();
      }
    }, f2.prototype.delay = function(i) {
      return this._delay = i, this;
    }, f2.prototype.during = function(i) {
      return i && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(i)), this;
    }, f2.prototype.done = function(i) {
      return i && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(i)), this;
    }, f2.prototype.aborted = function(i) {
      return i && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(i)), this;
    }, f2.prototype.getClip = function() {
      return this._clip;
    }, f2.prototype.getTrack = function(i) {
      return this._tracks[i];
    }, f2.prototype.getTracks = function() {
      var i = this;
      return Xa2(this._trackKeys, function(t2) {
        return i._tracks[t2];
      });
    }, f2.prototype.stopTracks = function(i, t2) {
      if (!i.length || !this._clip)
        return true;
      for (var h = this._tracks, v4 = this._trackKeys, _ = 0; _ < i.length; _++) {
        var M2 = h[i[_]];
        M2 && !M2.isFinished() && (t2 ? M2.step(this._target, 1) : this._started === 1 && M2.step(this._target, 0), M2.setFinished());
      }
      for (var I2 = true, _ = 0; _ < v4.length; _++)
        if (!h[v4[_]].isFinished()) {
          I2 = false;
          break;
        }
      return I2 && this._abortedCallback(), I2;
    }, f2.prototype.saveTo = function(i, t2, h) {
      if (!!i) {
        t2 = t2 || this._trackKeys;
        for (var v4 = 0; v4 < t2.length; v4++) {
          var _ = t2[v4], M2 = this._tracks[_];
          if (!(!M2 || M2.isFinished())) {
            var I2 = M2.keyframes, P2 = I2[h ? 0 : I2.length - 1];
            P2 && (i[_] = Ddt(P2.rawValue));
          }
        }
      }
    }, f2.prototype.__changeFinalValue = function(i, t2) {
      t2 = t2 || Of2(i);
      for (var h = 0; h < t2.length; h++) {
        var v4 = t2[h], _ = this._tracks[v4];
        if (!!_) {
          var M2 = _.keyframes;
          if (M2.length > 1) {
            var I2 = M2.pop();
            _.addKeyframe(I2.time, i[v4]), _.prepare(this._maxTime, _.getAdditiveTrack());
          }
        }
      }
    }, f2;
  }();
  function Ttt() {
    return new Date().getTime();
  }
  var Iur = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this) || this;
      return h._running = false, h._time = 0, h._pausedTime = 0, h._pauseStart = 0, h._paused = false, t2 = t2 || {}, h.stage = t2.stage || {}, h;
    }
    return i.prototype.addClip = function(t2) {
      t2.animation && this.removeClip(t2), this._head ? (this._tail.next = t2, t2.prev = this._tail, t2.next = null, this._tail = t2) : this._head = this._tail = t2, t2.animation = this;
    }, i.prototype.addAnimator = function(t2) {
      t2.animation = this;
      var h = t2.getClip();
      h && this.addClip(h);
    }, i.prototype.removeClip = function(t2) {
      if (!!t2.animation) {
        var h = t2.prev, v4 = t2.next;
        h ? h.next = v4 : this._head = v4, v4 ? v4.prev = h : this._tail = h, t2.next = t2.prev = t2.animation = null;
      }
    }, i.prototype.removeAnimator = function(t2) {
      var h = t2.getClip();
      h && this.removeClip(h), t2.animation = null;
    }, i.prototype.update = function(t2) {
      for (var h = Ttt() - this._pausedTime, v4 = h - this._time, _ = this._head; _; ) {
        var M2 = _.next, I2 = _.step(h, v4);
        I2 && (_.ondestroy(), this.removeClip(_)), _ = M2;
      }
      this._time = h, t2 || (this.trigger("frame", v4), this.stage.update && this.stage.update());
    }, i.prototype._startLoop = function() {
      var t2 = this;
      this._running = true;
      function h() {
        t2._running && (xJt(h), !t2._paused && t2.update());
      }
      xJt(h);
    }, i.prototype.start = function() {
      this._running || (this._time = Ttt(), this._pausedTime = 0, this._startLoop());
    }, i.prototype.stop = function() {
      this._running = false;
    }, i.prototype.pause = function() {
      this._paused || (this._pauseStart = Ttt(), this._paused = true);
    }, i.prototype.resume = function() {
      this._paused && (this._pausedTime += Ttt() - this._pauseStart, this._paused = false);
    }, i.prototype.clear = function() {
      for (var t2 = this._head; t2; ) {
        var h = t2.next;
        t2.prev = t2.next = t2.animation = null, t2 = h;
      }
      this._head = this._tail = null;
    }, i.prototype.isFinished = function() {
      return this._head == null;
    }, i.prototype.animate = function(t2, h) {
      h = h || {}, this.start();
      var v4 = new Cee(t2, h.loop);
      return this.addAnimator(v4), v4;
    }, i;
  }(iE), Dur = Iur, Eur = 300, GKt = gp.domSupported, HKt = function() {
    var f2 = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], i = ["touchstart", "touchend", "touchmove"], t2 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, h = Xa2(f2, function(v4) {
      var _ = v4.replace("mouse", "pointer");
      return t2.hasOwnProperty(_) ? _ : v4;
    });
    return { mouse: f2, touch: i, pointer: h };
  }(), L6e = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, O6e = false;
  function EJt(f2) {
    var i = f2.pointerType;
    return i === "pen" || i === "touch";
  }
  function kur(f2) {
    f2.touching = true, f2.touchTimer != null && (clearTimeout(f2.touchTimer), f2.touchTimer = null), f2.touchTimer = setTimeout(function() {
      f2.touching = false, f2.touchTimer = null;
    }, 700);
  }
  function UKt(f2) {
    f2 && (f2.zrByTouch = true);
  }
  function Pur(f2, i) {
    return GD(f2.dom, new Lur(f2, i), true);
  }
  function wze(f2, i) {
    for (var t2 = i, h = false; t2 && t2.nodeType !== 9 && !(h = t2.domBelongToZr || t2 !== i && t2 === f2.painterRoot); )
      t2 = t2.parentNode;
    return h;
  }
  var Lur = function() {
    function f2(i, t2) {
      this.stopPropagation = xm, this.stopImmediatePropagation = xm, this.preventDefault = xm, this.type = t2.type, this.target = this.currentTarget = i.dom, this.pointerType = t2.pointerType, this.clientX = t2.clientX, this.clientY = t2.clientY;
    }
    return f2;
  }(), b5 = { mousedown: function(f2) {
    f2 = GD(this.dom, f2), this.__mayPointerCapture = [f2.zrX, f2.zrY], this.trigger("mousedown", f2);
  }, mousemove: function(f2) {
    f2 = GD(this.dom, f2);
    var i = this.__mayPointerCapture;
    i && (f2.zrX !== i[0] || f2.zrY !== i[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", f2);
  }, mouseup: function(f2) {
    f2 = GD(this.dom, f2), this.__togglePointerCapture(false), this.trigger("mouseup", f2);
  }, mouseout: function(f2) {
    f2 = GD(this.dom, f2);
    var i = f2.toElement || f2.relatedTarget;
    wze(this, i) || (this.__pointerCapturing && (f2.zrEventControl = "no_globalout"), this.trigger("mouseout", f2));
  }, wheel: function(f2) {
    O6e = true, f2 = GD(this.dom, f2), this.trigger("mousewheel", f2);
  }, mousewheel: function(f2) {
    O6e || (f2 = GD(this.dom, f2), this.trigger("mousewheel", f2));
  }, touchstart: function(f2) {
    f2 = GD(this.dom, f2), UKt(f2), this.__lastTouchMoment = new Date(), this.handler.processGesture(f2, "start"), b5.mousemove.call(this, f2), b5.mousedown.call(this, f2);
  }, touchmove: function(f2) {
    f2 = GD(this.dom, f2), UKt(f2), this.handler.processGesture(f2, "change"), b5.mousemove.call(this, f2);
  }, touchend: function(f2) {
    f2 = GD(this.dom, f2), UKt(f2), this.handler.processGesture(f2, "end"), b5.mouseup.call(this, f2), +new Date() - +this.__lastTouchMoment < Eur && b5.click.call(this, f2);
  }, pointerdown: function(f2) {
    b5.mousedown.call(this, f2);
  }, pointermove: function(f2) {
    EJt(f2) || b5.mousemove.call(this, f2);
  }, pointerup: function(f2) {
    b5.mouseup.call(this, f2);
  }, pointerout: function(f2) {
    EJt(f2) || b5.mouseout.call(this, f2);
  } };
  Qe2(["click", "dblclick", "contextmenu"], function(f2) {
    b5[f2] = function(i) {
      i = GD(this.dom, i), this.trigger(f2, i);
    };
  });
  var kJt = { pointermove: function(f2) {
    EJt(f2) || kJt.mousemove.call(this, f2);
  }, pointerup: function(f2) {
    kJt.mouseup.call(this, f2);
  }, mousemove: function(f2) {
    this.trigger("mousemove", f2);
  }, mouseup: function(f2) {
    var i = this.__pointerCapturing;
    this.__togglePointerCapture(false), this.trigger("mouseup", f2), i && (f2.zrEventControl = "only_globalout", this.trigger("mouseout", f2));
  } };
  function Our(f2, i) {
    var t2 = i.domHandlers;
    gp.pointerEventsSupported ? Qe2(HKt.pointer, function(h) {
      HDt(i, h, function(v4) {
        t2[h].call(f2, v4);
      });
    }) : (gp.touchEventsSupported && Qe2(HKt.touch, function(h) {
      HDt(i, h, function(v4) {
        t2[h].call(f2, v4), kur(i);
      });
    }), Qe2(HKt.mouse, function(h) {
      HDt(i, h, function(v4) {
        v4 = See(v4), i.touching || t2[h].call(f2, v4);
      });
    }));
  }
  function Rur(f2, i) {
    gp.pointerEventsSupported ? Qe2(L6e.pointer, t2) : gp.touchEventsSupported || Qe2(L6e.mouse, t2);
    function t2(h) {
      function v4(_) {
        _ = See(_), wze(f2, _.target) || (_ = Pur(f2, _), i.domHandlers[h].call(f2, _));
      }
      HDt(i, h, v4, { capture: true });
    }
  }
  function HDt(f2, i, t2, h) {
    f2.mounted[i] = t2, f2.listenerOpts[i] = h, _Jt(f2.domTarget, i, t2, h);
  }
  function qKt(f2) {
    var i = f2.mounted;
    for (var t2 in i)
      i.hasOwnProperty(t2) && Glr(f2.domTarget, t2, i[t2], f2.listenerOpts[t2]);
    f2.mounted = {};
  }
  var R6e = function() {
    function f2(i, t2) {
      this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = i, this.domHandlers = t2;
    }
    return f2;
  }(), Nur = function(f2) {
    ii2(i, f2);
    function i(t2, h) {
      var v4 = f2.call(this) || this;
      return v4.__pointerCapturing = false, v4.dom = t2, v4.painterRoot = h, v4._localHandlerScope = new R6e(t2, b5), GKt && (v4._globalHandlerScope = new R6e(document, kJt)), Our(v4, v4._localHandlerScope), v4;
    }
    return i.prototype.dispose = function() {
      qKt(this._localHandlerScope), GKt && qKt(this._globalHandlerScope);
    }, i.prototype.setCursor = function(t2) {
      this.dom.style && (this.dom.style.cursor = t2 || "default");
    }, i.prototype.__togglePointerCapture = function(t2) {
      if (this.__mayPointerCapture = null, GKt && +this.__pointerCapturing ^ +t2) {
        this.__pointerCapturing = t2;
        var h = this._globalHandlerScope;
        t2 ? Rur(this, h) : qKt(h);
      }
    }, i;
  }(iE), Fur = Nur, Sze = 1;
  gp.hasGlobalWindow && (Sze = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
  var hEt = Sze, PJt = 0.4, LJt = "#333", OJt = "#ccc", Vur = "#eee";
  function nE() {
    return [1, 0, 0, 1, 0, 0];
  }
  function ukt(f2) {
    return f2[0] = 1, f2[1] = 0, f2[2] = 0, f2[3] = 1, f2[4] = 0, f2[5] = 0, f2;
  }
  function Tee(f2, i) {
    return f2[0] = i[0], f2[1] = i[1], f2[2] = i[2], f2[3] = i[3], f2[4] = i[4], f2[5] = i[5], f2;
  }
  function $6(f2, i, t2) {
    var h = i[0] * t2[0] + i[2] * t2[1], v4 = i[1] * t2[0] + i[3] * t2[1], _ = i[0] * t2[2] + i[2] * t2[3], M2 = i[1] * t2[2] + i[3] * t2[3], I2 = i[0] * t2[4] + i[2] * t2[5] + i[4], P2 = i[1] * t2[4] + i[3] * t2[5] + i[5];
    return f2[0] = h, f2[1] = v4, f2[2] = _, f2[3] = M2, f2[4] = I2, f2[5] = P2, f2;
  }
  function jL(f2, i, t2) {
    return f2[0] = i[0], f2[1] = i[1], f2[2] = i[2], f2[3] = i[3], f2[4] = i[4] + t2[0], f2[5] = i[5] + t2[1], f2;
  }
  function SU(f2, i, t2) {
    var h = i[0], v4 = i[2], _ = i[4], M2 = i[1], I2 = i[3], P2 = i[5], N3 = Math.sin(t2), z3 = Math.cos(t2);
    return f2[0] = h * z3 + M2 * N3, f2[1] = -h * N3 + M2 * z3, f2[2] = v4 * z3 + I2 * N3, f2[3] = -v4 * N3 + z3 * I2, f2[4] = z3 * _ + N3 * P2, f2[5] = z3 * P2 - N3 * _, f2;
  }
  function Aee(f2, i, t2) {
    var h = t2[0], v4 = t2[1];
    return f2[0] = i[0] * h, f2[1] = i[1] * v4, f2[2] = i[2] * h, f2[3] = i[3] * v4, f2[4] = i[4] * h, f2[5] = i[5] * v4, f2;
  }
  function Xtt(f2, i) {
    var t2 = i[0], h = i[2], v4 = i[4], _ = i[1], M2 = i[3], I2 = i[5], P2 = t2 * M2 - _ * h;
    return P2 ? (P2 = 1 / P2, f2[0] = M2 * P2, f2[1] = -_ * P2, f2[2] = -h * P2, f2[3] = t2 * P2, f2[4] = (h * I2 - M2 * v4) * P2, f2[5] = (_ * v4 - t2 * I2) * P2, f2) : null;
  }
  function Bur(f2) {
    var i = nE();
    return Tee(i, f2), i;
  }
  var N6e = ukt, F6e = 5e-5;
  function vH(f2) {
    return f2 > F6e || f2 < -F6e;
  }
  var yH = [], ttt = [], ZKt = nE(), $Kt = Math.abs, zur = function() {
    function f2() {
    }
    return f2.prototype.getLocalTransform = function(i) {
      return f2.getLocalTransform(this, i);
    }, f2.prototype.setPosition = function(i) {
      this.x = i[0], this.y = i[1];
    }, f2.prototype.setScale = function(i) {
      this.scaleX = i[0], this.scaleY = i[1];
    }, f2.prototype.setSkew = function(i) {
      this.skewX = i[0], this.skewY = i[1];
    }, f2.prototype.setOrigin = function(i) {
      this.originX = i[0], this.originY = i[1];
    }, f2.prototype.needLocalTransform = function() {
      return vH(this.rotation) || vH(this.x) || vH(this.y) || vH(this.scaleX - 1) || vH(this.scaleY - 1) || vH(this.skewX) || vH(this.skewY);
    }, f2.prototype.updateTransform = function() {
      var i = this.parent && this.parent.transform, t2 = this.needLocalTransform(), h = this.transform;
      if (!(t2 || i)) {
        h && N6e(h);
        return;
      }
      h = h || nE(), t2 ? this.getLocalTransform(h) : N6e(h), i && (t2 ? $6(h, i, h) : Tee(h, i)), this.transform = h, this._resolveGlobalScaleRatio(h);
    }, f2.prototype._resolveGlobalScaleRatio = function(i) {
      var t2 = this.globalScaleRatio;
      if (t2 != null && t2 !== 1) {
        this.getGlobalScale(yH);
        var h = yH[0] < 0 ? -1 : 1, v4 = yH[1] < 0 ? -1 : 1, _ = ((yH[0] - h) * t2 + h) / yH[0] || 0, M2 = ((yH[1] - v4) * t2 + v4) / yH[1] || 0;
        i[0] *= _, i[1] *= _, i[2] *= M2, i[3] *= M2;
      }
      this.invTransform = this.invTransform || nE(), Xtt(this.invTransform, i);
    }, f2.prototype.getComputedTransform = function() {
      for (var i = this, t2 = []; i; )
        t2.push(i), i = i.parent;
      for (; i = t2.pop(); )
        i.updateTransform();
      return this.transform;
    }, f2.prototype.setLocalTransform = function(i) {
      if (!!i) {
        var t2 = i[0] * i[0] + i[1] * i[1], h = i[2] * i[2] + i[3] * i[3], v4 = Math.atan2(i[1], i[0]), _ = Math.PI / 2 + v4 - Math.atan2(i[3], i[2]);
        h = Math.sqrt(h) * Math.cos(_), t2 = Math.sqrt(t2), this.skewX = _, this.skewY = 0, this.rotation = -v4, this.x = +i[4], this.y = +i[5], this.scaleX = t2, this.scaleY = h, this.originX = 0, this.originY = 0;
      }
    }, f2.prototype.decomposeTransform = function() {
      if (!!this.transform) {
        var i = this.parent, t2 = this.transform;
        i && i.transform && ($6(ttt, i.invTransform, t2), t2 = ttt);
        var h = this.originX, v4 = this.originY;
        (h || v4) && (ZKt[4] = h, ZKt[5] = v4, $6(ttt, t2, ZKt), ttt[4] -= h, ttt[5] -= v4, t2 = ttt), this.setLocalTransform(t2);
      }
    }, f2.prototype.getGlobalScale = function(i) {
      var t2 = this.transform;
      return i = i || [], t2 ? (i[0] = Math.sqrt(t2[0] * t2[0] + t2[1] * t2[1]), i[1] = Math.sqrt(t2[2] * t2[2] + t2[3] * t2[3]), t2[0] < 0 && (i[0] = -i[0]), t2[3] < 0 && (i[1] = -i[1]), i) : (i[0] = 1, i[1] = 1, i);
    }, f2.prototype.transformCoordToLocal = function(i, t2) {
      var h = [i, t2], v4 = this.invTransform;
      return v4 && Wx(h, h, v4), h;
    }, f2.prototype.transformCoordToGlobal = function(i, t2) {
      var h = [i, t2], v4 = this.transform;
      return v4 && Wx(h, h, v4), h;
    }, f2.prototype.getLineScale = function() {
      var i = this.transform;
      return i && $Kt(i[0] - 1) > 1e-10 && $Kt(i[3] - 1) > 1e-10 ? Math.sqrt($Kt(i[0] * i[3] - i[2] * i[1])) : 1;
    }, f2.prototype.copyTransform = function(i) {
      Mze(this, i);
    }, f2.getLocalTransform = function(i, t2) {
      t2 = t2 || [];
      var h = i.originX || 0, v4 = i.originY || 0, _ = i.scaleX, M2 = i.scaleY, I2 = i.anchorX, P2 = i.anchorY, N3 = i.rotation || 0, z3 = i.x, H2 = i.y, $ = i.skewX ? Math.tan(i.skewX) : 0, et = i.skewY ? Math.tan(-i.skewY) : 0;
      if (h || v4 || I2 || P2) {
        var at = h + I2, ht = v4 + P2;
        t2[4] = -at * _ - $ * ht * M2, t2[5] = -ht * M2 - et * at * _;
      } else
        t2[4] = t2[5] = 0;
      return t2[0] = _, t2[3] = M2, t2[1] = et * _, t2[2] = $ * M2, N3 && SU(t2, t2, N3), t2[4] += h + z3, t2[5] += v4 + H2, t2;
    }, f2.initDefaultProps = function() {
      var i = f2.prototype;
      i.scaleX = i.scaleY = i.globalScaleRatio = 1, i.x = i.y = i.originX = i.originY = i.skewX = i.skewY = i.rotation = i.anchorX = i.anchorY = 0;
    }(), f2;
  }(), WL = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
  function Mze(f2, i) {
    for (var t2 = 0; t2 < WL.length; t2++) {
      var h = WL[t2];
      f2[h] = i[h];
    }
  }
  var G6 = zur, jur = function() {
    function f2(i, t2) {
      this.x = i || 0, this.y = t2 || 0;
    }
    return f2.prototype.copy = function(i) {
      return this.x = i.x, this.y = i.y, this;
    }, f2.prototype.clone = function() {
      return new f2(this.x, this.y);
    }, f2.prototype.set = function(i, t2) {
      return this.x = i, this.y = t2, this;
    }, f2.prototype.equal = function(i) {
      return i.x === this.x && i.y === this.y;
    }, f2.prototype.add = function(i) {
      return this.x += i.x, this.y += i.y, this;
    }, f2.prototype.scale = function(i) {
      this.x *= i, this.y *= i;
    }, f2.prototype.scaleAndAdd = function(i, t2) {
      this.x += i.x * t2, this.y += i.y * t2;
    }, f2.prototype.sub = function(i) {
      return this.x -= i.x, this.y -= i.y, this;
    }, f2.prototype.dot = function(i) {
      return this.x * i.x + this.y * i.y;
    }, f2.prototype.len = function() {
      return Math.sqrt(this.x * this.x + this.y * this.y);
    }, f2.prototype.lenSquare = function() {
      return this.x * this.x + this.y * this.y;
    }, f2.prototype.normalize = function() {
      var i = this.len();
      return this.x /= i, this.y /= i, this;
    }, f2.prototype.distance = function(i) {
      var t2 = this.x - i.x, h = this.y - i.y;
      return Math.sqrt(t2 * t2 + h * h);
    }, f2.prototype.distanceSquare = function(i) {
      var t2 = this.x - i.x, h = this.y - i.y;
      return t2 * t2 + h * h;
    }, f2.prototype.negate = function() {
      return this.x = -this.x, this.y = -this.y, this;
    }, f2.prototype.transform = function(i) {
      if (!!i) {
        var t2 = this.x, h = this.y;
        return this.x = i[0] * t2 + i[2] * h + i[4], this.y = i[1] * t2 + i[3] * h + i[5], this;
      }
    }, f2.prototype.toArray = function(i) {
      return i[0] = this.x, i[1] = this.y, i;
    }, f2.prototype.fromArray = function(i) {
      this.x = i[0], this.y = i[1];
    }, f2.set = function(i, t2, h) {
      i.x = t2, i.y = h;
    }, f2.copy = function(i, t2) {
      i.x = t2.x, i.y = t2.y;
    }, f2.len = function(i) {
      return Math.sqrt(i.x * i.x + i.y * i.y);
    }, f2.lenSquare = function(i) {
      return i.x * i.x + i.y * i.y;
    }, f2.dot = function(i, t2) {
      return i.x * t2.x + i.y * t2.y;
    }, f2.add = function(i, t2, h) {
      i.x = t2.x + h.x, i.y = t2.y + h.y;
    }, f2.sub = function(i, t2, h) {
      i.x = t2.x - h.x, i.y = t2.y - h.y;
    }, f2.scale = function(i, t2, h) {
      i.x = t2.x * h, i.y = t2.y * h;
    }, f2.scaleAndAdd = function(i, t2, h, v4) {
      i.x = t2.x + h.x * v4, i.y = t2.y + h.y * v4;
    }, f2.lerp = function(i, t2, h, v4) {
      var _ = 1 - v4;
      i.x = _ * t2.x + v4 * h.x, i.y = _ * t2.y + v4 * h.y;
    }, f2;
  }(), ac2 = jur, FIt = Math.min, VIt = Math.max, mH = new ac2(), bH = new ac2(), _H = new ac2(), xH = new ac2(), Bpt = new ac2(), zpt = new ac2(), Wur = function() {
    function f2(i, t2, h, v4) {
      h < 0 && (i = i + h, h = -h), v4 < 0 && (t2 = t2 + v4, v4 = -v4), this.x = i, this.y = t2, this.width = h, this.height = v4;
    }
    return f2.prototype.union = function(i) {
      var t2 = FIt(i.x, this.x), h = FIt(i.y, this.y);
      isFinite(this.x) && isFinite(this.width) ? this.width = VIt(i.x + i.width, this.x + this.width) - t2 : this.width = i.width, isFinite(this.y) && isFinite(this.height) ? this.height = VIt(i.y + i.height, this.y + this.height) - h : this.height = i.height, this.x = t2, this.y = h;
    }, f2.prototype.applyTransform = function(i) {
      f2.applyTransform(this, this, i);
    }, f2.prototype.calculateTransform = function(i) {
      var t2 = this, h = i.width / t2.width, v4 = i.height / t2.height, _ = nE();
      return jL(_, _, [-t2.x, -t2.y]), Aee(_, _, [h, v4]), jL(_, _, [i.x, i.y]), _;
    }, f2.prototype.intersect = function(i, t2) {
      if (!i)
        return false;
      i instanceof f2 || (i = f2.create(i));
      var h = this, v4 = h.x, _ = h.x + h.width, M2 = h.y, I2 = h.y + h.height, P2 = i.x, N3 = i.x + i.width, z3 = i.y, H2 = i.y + i.height, $ = !(_ < P2 || N3 < v4 || I2 < z3 || H2 < M2);
      if (t2) {
        var et = 1 / 0, at = 0, ht = Math.abs(_ - P2), bt = Math.abs(N3 - v4), _t = Math.abs(I2 - z3), Et = Math.abs(H2 - M2), zt = Math.min(ht, bt), Ft = Math.min(_t, Et);
        _ < P2 || N3 < v4 ? zt > at && (at = zt, ht < bt ? ac2.set(zpt, -ht, 0) : ac2.set(zpt, bt, 0)) : zt < et && (et = zt, ht < bt ? ac2.set(Bpt, ht, 0) : ac2.set(Bpt, -bt, 0)), I2 < z3 || H2 < M2 ? Ft > at && (at = Ft, _t < Et ? ac2.set(zpt, 0, -_t) : ac2.set(zpt, 0, Et)) : zt < et && (et = zt, _t < Et ? ac2.set(Bpt, 0, _t) : ac2.set(Bpt, 0, -Et));
      }
      return t2 && ac2.copy(t2, $ ? Bpt : zpt), $;
    }, f2.prototype.contain = function(i, t2) {
      var h = this;
      return i >= h.x && i <= h.x + h.width && t2 >= h.y && t2 <= h.y + h.height;
    }, f2.prototype.clone = function() {
      return new f2(this.x, this.y, this.width, this.height);
    }, f2.prototype.copy = function(i) {
      f2.copy(this, i);
    }, f2.prototype.plain = function() {
      return { x: this.x, y: this.y, width: this.width, height: this.height };
    }, f2.prototype.isFinite = function() {
      return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
    }, f2.prototype.isZero = function() {
      return this.width === 0 || this.height === 0;
    }, f2.create = function(i) {
      return new f2(i.x, i.y, i.width, i.height);
    }, f2.copy = function(i, t2) {
      i.x = t2.x, i.y = t2.y, i.width = t2.width, i.height = t2.height;
    }, f2.applyTransform = function(i, t2, h) {
      if (!h) {
        i !== t2 && f2.copy(i, t2);
        return;
      }
      if (h[1] < 1e-5 && h[1] > -1e-5 && h[2] < 1e-5 && h[2] > -1e-5) {
        var v4 = h[0], _ = h[3], M2 = h[4], I2 = h[5];
        i.x = t2.x * v4 + M2, i.y = t2.y * _ + I2, i.width = t2.width * v4, i.height = t2.height * _, i.width < 0 && (i.x += i.width, i.width = -i.width), i.height < 0 && (i.y += i.height, i.height = -i.height);
        return;
      }
      mH.x = _H.x = t2.x, mH.y = xH.y = t2.y, bH.x = xH.x = t2.x + t2.width, bH.y = _H.y = t2.y + t2.height, mH.transform(h), xH.transform(h), bH.transform(h), _H.transform(h), i.x = FIt(mH.x, bH.x, _H.x, xH.x), i.y = FIt(mH.y, bH.y, _H.y, xH.y);
      var P2 = VIt(mH.x, bH.x, _H.x, xH.x), N3 = VIt(mH.y, bH.y, _H.y, xH.y);
      i.width = P2 - i.x, i.height = N3 - i.y;
    }, f2;
  }(), Lc2 = Wur, V6e = {};
  function $T(f2, i) {
    i = i || K7;
    var t2 = V6e[i];
    t2 || (t2 = V6e[i] = new Mgt(500));
    var h = t2.get(f2);
    return h == null && (h = Q6.measureText(f2, i).width, t2.put(f2, h)), h;
  }
  function B6e(f2, i, t2, h) {
    var v4 = $T(f2, i), _ = ckt(i), M2 = vdt(0, v4, t2), I2 = xtt(0, _, h), P2 = new Lc2(M2, I2, v4, _);
    return P2;
  }
  function Cgt(f2, i, t2, h) {
    var v4 = ((f2 || "") + "").split(`
`), _ = v4.length;
    if (_ === 1)
      return B6e(v4[0], i, t2, h);
    for (var M2 = new Lc2(0, 0, 0, 0), I2 = 0; I2 < v4.length; I2++) {
      var P2 = B6e(v4[I2], i, t2, h);
      I2 === 0 ? M2.copy(P2) : M2.union(P2);
    }
    return M2;
  }
  function vdt(f2, i, t2) {
    return t2 === "right" ? f2 -= i : t2 === "center" && (f2 -= i / 2), f2;
  }
  function xtt(f2, i, t2) {
    return t2 === "middle" ? f2 -= i / 2 : t2 === "bottom" && (f2 -= i), f2;
  }
  function ckt(f2) {
    return $T("\u56FD", f2);
  }
  function T5(f2, i) {
    return typeof f2 == "string" ? f2.lastIndexOf("%") >= 0 ? parseFloat(f2) / 100 * i : parseFloat(f2) : f2;
  }
  function pEt(f2, i, t2) {
    var h = i.position || "inside", v4 = i.distance != null ? i.distance : 5, _ = t2.height, M2 = t2.width, I2 = _ / 2, P2 = t2.x, N3 = t2.y, z3 = "left", H2 = "top";
    if (h instanceof Array)
      P2 += T5(h[0], t2.width), N3 += T5(h[1], t2.height), z3 = null, H2 = null;
    else
      switch (h) {
        case "left":
          P2 -= v4, N3 += I2, z3 = "right", H2 = "middle";
          break;
        case "right":
          P2 += v4 + M2, N3 += I2, H2 = "middle";
          break;
        case "top":
          P2 += M2 / 2, N3 -= v4, z3 = "center", H2 = "bottom";
          break;
        case "bottom":
          P2 += M2 / 2, N3 += _ + v4, z3 = "center";
          break;
        case "inside":
          P2 += M2 / 2, N3 += I2, z3 = "center", H2 = "middle";
          break;
        case "insideLeft":
          P2 += v4, N3 += I2, H2 = "middle";
          break;
        case "insideRight":
          P2 += M2 - v4, N3 += I2, z3 = "right", H2 = "middle";
          break;
        case "insideTop":
          P2 += M2 / 2, N3 += v4, z3 = "center";
          break;
        case "insideBottom":
          P2 += M2 / 2, N3 += _ - v4, z3 = "center", H2 = "bottom";
          break;
        case "insideTopLeft":
          P2 += v4, N3 += v4;
          break;
        case "insideTopRight":
          P2 += M2 - v4, N3 += v4, z3 = "right";
          break;
        case "insideBottomLeft":
          P2 += v4, N3 += _ - v4, H2 = "bottom";
          break;
        case "insideBottomRight":
          P2 += M2 - v4, N3 += _ - v4, z3 = "right", H2 = "bottom";
          break;
      }
    return f2 = f2 || {}, f2.x = P2, f2.y = N3, f2.align = z3, f2.verticalAlign = H2, f2;
  }
  var YKt = "__zr_normal__", KKt = WL.concat(["ignore"]), Gur = zL(WL, function(f2, i) {
    return f2[i] = true, f2;
  }, { ignore: false }), ett = {}, Hur = new Lc2(0, 0, 0, 0), Iee = function() {
    function f2(i) {
      this.id = QBe(), this.animators = [], this.currentStates = [], this.states = {}, this._init(i);
    }
    return f2.prototype._init = function(i) {
      this.attr(i);
    }, f2.prototype.drift = function(i, t2, h) {
      switch (this.draggable) {
        case "horizontal":
          t2 = 0;
          break;
        case "vertical":
          i = 0;
          break;
      }
      var v4 = this.transform;
      v4 || (v4 = this.transform = [1, 0, 0, 1, 0, 0]), v4[4] += i, v4[5] += t2, this.decomposeTransform(), this.markRedraw();
    }, f2.prototype.beforeUpdate = function() {
    }, f2.prototype.afterUpdate = function() {
    }, f2.prototype.update = function() {
      this.updateTransform(), this.__dirty && this.updateInnerText();
    }, f2.prototype.updateInnerText = function(i) {
      var t2 = this._textContent;
      if (t2 && (!t2.ignore || i)) {
        this.textConfig || (this.textConfig = {});
        var h = this.textConfig, v4 = h.local, _ = t2.innerTransformable, M2 = void 0, I2 = void 0, P2 = false;
        _.parent = v4 ? this : null;
        var N3 = false;
        if (_.copyTransform(t2), h.position != null) {
          var z3 = Hur;
          h.layoutRect ? z3.copy(h.layoutRect) : z3.copy(this.getBoundingRect()), v4 || z3.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(ett, h, z3) : pEt(ett, h, z3), _.x = ett.x, _.y = ett.y, M2 = ett.align, I2 = ett.verticalAlign;
          var H2 = h.origin;
          if (H2 && h.rotation != null) {
            var $ = void 0, et = void 0;
            H2 === "center" ? ($ = z3.width * 0.5, et = z3.height * 0.5) : ($ = T5(H2[0], z3.width), et = T5(H2[1], z3.height)), N3 = true, _.originX = -_.x + $ + (v4 ? 0 : z3.x), _.originY = -_.y + et + (v4 ? 0 : z3.y);
          }
        }
        h.rotation != null && (_.rotation = h.rotation);
        var at = h.offset;
        at && (_.x += at[0], _.y += at[1], N3 || (_.originX = -at[0], _.originY = -at[1]));
        var ht = h.inside == null ? typeof h.position == "string" && h.position.indexOf("inside") >= 0 : h.inside, bt = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), _t = void 0, Et = void 0, zt = void 0;
        ht && this.canBeInsideText() ? (_t = h.insideFill, Et = h.insideStroke, (_t == null || _t === "auto") && (_t = this.getInsideTextFill()), (Et == null || Et === "auto") && (Et = this.getInsideTextStroke(_t), zt = true)) : (_t = h.outsideFill, Et = h.outsideStroke, (_t == null || _t === "auto") && (_t = this.getOutsideFill()), (Et == null || Et === "auto") && (Et = this.getOutsideStroke(_t), zt = true)), _t = _t || "#000", (_t !== bt.fill || Et !== bt.stroke || zt !== bt.autoStroke || M2 !== bt.align || I2 !== bt.verticalAlign) && (P2 = true, bt.fill = _t, bt.stroke = Et, bt.autoStroke = zt, bt.align = M2, bt.verticalAlign = I2, t2.setDefaultTextStyle(bt)), t2.__dirty |= UT, P2 && t2.dirtyStyle(true);
      }
    }, f2.prototype.canBeInsideText = function() {
      return true;
    }, f2.prototype.getInsideTextFill = function() {
      return "#fff";
    }, f2.prototype.getInsideTextStroke = function(i) {
      return "#000";
    }, f2.prototype.getOutsideFill = function() {
      return this.__zr && this.__zr.isDarkMode() ? OJt : LJt;
    }, f2.prototype.getOutsideStroke = function(i) {
      var t2 = this.__zr && this.__zr.getBackgroundColor(), h = typeof t2 == "string" && ZT(t2);
      h || (h = [255, 255, 255, 1]);
      for (var v4 = h[3], _ = this.__zr.isDarkMode(), M2 = 0; M2 < 3; M2++)
        h[M2] = h[M2] * v4 + (_ ? 0 : 255) * (1 - v4);
      return h[3] = 1, Z6(h, "rgba");
    }, f2.prototype.traverse = function(i, t2) {
    }, f2.prototype.attrKV = function(i, t2) {
      i === "textConfig" ? this.setTextConfig(t2) : i === "textContent" ? this.setTextContent(t2) : i === "clipPath" ? this.setClipPath(t2) : i === "extra" ? (this.extra = this.extra || {}, ba2(this.extra, t2)) : this[i] = t2;
    }, f2.prototype.hide = function() {
      this.ignore = true, this.markRedraw();
    }, f2.prototype.show = function() {
      this.ignore = false, this.markRedraw();
    }, f2.prototype.attr = function(i, t2) {
      if (typeof i == "string")
        this.attrKV(i, t2);
      else if (Xl(i))
        for (var h = i, v4 = Of2(h), _ = 0; _ < v4.length; _++) {
          var M2 = v4[_];
          this.attrKV(M2, i[M2]);
        }
      return this.markRedraw(), this;
    }, f2.prototype.saveCurrentToNormalState = function(i) {
      this._innerSaveToNormal(i);
      for (var t2 = this._normalState, h = 0; h < this.animators.length; h++) {
        var v4 = this.animators[h], _ = v4.__fromStateTransition;
        if (!(v4.getLoop() || _ && _ !== YKt)) {
          var M2 = v4.targetName, I2 = M2 ? t2[M2] : t2;
          v4.saveTo(I2);
        }
      }
    }, f2.prototype._innerSaveToNormal = function(i) {
      var t2 = this._normalState;
      t2 || (t2 = this._normalState = {}), i.textConfig && !t2.textConfig && (t2.textConfig = this.textConfig), this._savePrimaryToNormal(i, t2, KKt);
    }, f2.prototype._savePrimaryToNormal = function(i, t2, h) {
      for (var v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4];
        i[_] != null && !(_ in t2) && (t2[_] = this[_]);
      }
    }, f2.prototype.hasState = function() {
      return this.currentStates.length > 0;
    }, f2.prototype.getState = function(i) {
      return this.states[i];
    }, f2.prototype.ensureState = function(i) {
      var t2 = this.states;
      return t2[i] || (t2[i] = {}), t2[i];
    }, f2.prototype.clearStates = function(i) {
      this.useState(YKt, false, i);
    }, f2.prototype.useState = function(i, t2, h, v4) {
      var _ = i === YKt, M2 = this.hasState();
      if (!(!M2 && _)) {
        var I2 = this.currentStates, P2 = this.stateTransition;
        if (!(Pc2(I2, i) >= 0 && (t2 || I2.length === 1))) {
          var N3;
          if (this.stateProxy && !_ && (N3 = this.stateProxy(i)), N3 || (N3 = this.states && this.states[i]), !N3 && !_) {
            bee("State " + i + " not exists.");
            return;
          }
          _ || this.saveCurrentToNormalState(N3);
          var z3 = !!(N3 && N3.hoverLayer || v4);
          z3 && this._toggleHoverLayerFlag(true), this._applyStateObj(i, N3, this._normalState, t2, !h && !this.__inHover && P2 && P2.duration > 0, P2);
          var H2 = this._textContent, $ = this._textGuide;
          return H2 && H2.useState(i, t2, h, z3), $ && $.useState(i, t2, h, z3), _ ? (this.currentStates = [], this._normalState = {}) : t2 ? this.currentStates.push(i) : this.currentStates = [i], this._updateAnimationTargets(), this.markRedraw(), !z3 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~UT), N3;
        }
      }
    }, f2.prototype.useStates = function(i, t2, h) {
      if (!i.length)
        this.clearStates();
      else {
        var v4 = [], _ = this.currentStates, M2 = i.length, I2 = M2 === _.length;
        if (I2) {
          for (var P2 = 0; P2 < M2; P2++)
            if (i[P2] !== _[P2]) {
              I2 = false;
              break;
            }
        }
        if (I2)
          return;
        for (var P2 = 0; P2 < M2; P2++) {
          var N3 = i[P2], z3 = void 0;
          this.stateProxy && (z3 = this.stateProxy(N3, i)), z3 || (z3 = this.states[N3]), z3 && v4.push(z3);
        }
        var H2 = v4[M2 - 1], $ = !!(H2 && H2.hoverLayer || h);
        $ && this._toggleHoverLayerFlag(true);
        var et = this._mergeStates(v4), at = this.stateTransition;
        this.saveCurrentToNormalState(et), this._applyStateObj(i.join(","), et, this._normalState, false, !t2 && !this.__inHover && at && at.duration > 0, at);
        var ht = this._textContent, bt = this._textGuide;
        ht && ht.useStates(i, t2, $), bt && bt.useStates(i, t2, $), this._updateAnimationTargets(), this.currentStates = i.slice(), this.markRedraw(), !$ && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~UT);
      }
    }, f2.prototype._updateAnimationTargets = function() {
      for (var i = 0; i < this.animators.length; i++) {
        var t2 = this.animators[i];
        t2.targetName && t2.changeTarget(this[t2.targetName]);
      }
    }, f2.prototype.removeState = function(i) {
      var t2 = Pc2(this.currentStates, i);
      if (t2 >= 0) {
        var h = this.currentStates.slice();
        h.splice(t2, 1), this.useStates(h);
      }
    }, f2.prototype.replaceState = function(i, t2, h) {
      var v4 = this.currentStates.slice(), _ = Pc2(v4, i), M2 = Pc2(v4, t2) >= 0;
      _ >= 0 ? M2 ? v4.splice(_, 1) : v4[_] = t2 : h && !M2 && v4.push(t2), this.useStates(v4);
    }, f2.prototype.toggleState = function(i, t2) {
      t2 ? this.useState(i, true) : this.removeState(i);
    }, f2.prototype._mergeStates = function(i) {
      for (var t2 = {}, h, v4 = 0; v4 < i.length; v4++) {
        var _ = i[v4];
        ba2(t2, _), _.textConfig && (h = h || {}, ba2(h, _.textConfig));
      }
      return h && (t2.textConfig = h), t2;
    }, f2.prototype._applyStateObj = function(i, t2, h, v4, _, M2) {
      var I2 = !(t2 && v4);
      t2 && t2.textConfig ? (this.textConfig = ba2({}, v4 ? this.textConfig : h.textConfig), ba2(this.textConfig, t2.textConfig)) : I2 && h.textConfig && (this.textConfig = h.textConfig);
      for (var P2 = {}, N3 = false, z3 = 0; z3 < KKt.length; z3++) {
        var H2 = KKt[z3], $ = _ && Gur[H2];
        t2 && t2[H2] != null ? $ ? (N3 = true, P2[H2] = t2[H2]) : this[H2] = t2[H2] : I2 && h[H2] != null && ($ ? (N3 = true, P2[H2] = h[H2]) : this[H2] = h[H2]);
      }
      if (!_)
        for (var z3 = 0; z3 < this.animators.length; z3++) {
          var et = this.animators[z3], at = et.targetName;
          et.getLoop() || et.__changeFinalValue(at ? (t2 || h)[at] : t2 || h);
        }
      N3 && this._transitionState(i, P2, M2);
    }, f2.prototype._attachComponent = function(i) {
      if (!(i.__zr && !i.__hostTarget) && i !== this) {
        var t2 = this.__zr;
        t2 && i.addSelfToZr(t2), i.__zr = t2, i.__hostTarget = this;
      }
    }, f2.prototype._detachComponent = function(i) {
      i.__zr && i.removeSelfFromZr(i.__zr), i.__zr = null, i.__hostTarget = null;
    }, f2.prototype.getClipPath = function() {
      return this._clipPath;
    }, f2.prototype.setClipPath = function(i) {
      this._clipPath && this._clipPath !== i && this.removeClipPath(), this._attachComponent(i), this._clipPath = i, this.markRedraw();
    }, f2.prototype.removeClipPath = function() {
      var i = this._clipPath;
      i && (this._detachComponent(i), this._clipPath = null, this.markRedraw());
    }, f2.prototype.getTextContent = function() {
      return this._textContent;
    }, f2.prototype.setTextContent = function(i) {
      var t2 = this._textContent;
      t2 !== i && (t2 && t2 !== i && this.removeTextContent(), i.innerTransformable = new G6(), this._attachComponent(i), this._textContent = i, this.markRedraw());
    }, f2.prototype.setTextConfig = function(i) {
      this.textConfig || (this.textConfig = {}), ba2(this.textConfig, i), this.markRedraw();
    }, f2.prototype.removeTextConfig = function() {
      this.textConfig = null, this.markRedraw();
    }, f2.prototype.removeTextContent = function() {
      var i = this._textContent;
      i && (i.innerTransformable = null, this._detachComponent(i), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
    }, f2.prototype.getTextGuideLine = function() {
      return this._textGuide;
    }, f2.prototype.setTextGuideLine = function(i) {
      this._textGuide && this._textGuide !== i && this.removeTextGuideLine(), this._attachComponent(i), this._textGuide = i, this.markRedraw();
    }, f2.prototype.removeTextGuideLine = function() {
      var i = this._textGuide;
      i && (this._detachComponent(i), this._textGuide = null, this.markRedraw());
    }, f2.prototype.markRedraw = function() {
      this.__dirty |= UT;
      var i = this.__zr;
      i && (this.__inHover ? i.refreshHover() : i.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
    }, f2.prototype.dirty = function() {
      this.markRedraw();
    }, f2.prototype._toggleHoverLayerFlag = function(i) {
      this.__inHover = i;
      var t2 = this._textContent, h = this._textGuide;
      t2 && (t2.__inHover = i), h && (h.__inHover = i);
    }, f2.prototype.addSelfToZr = function(i) {
      if (this.__zr !== i) {
        this.__zr = i;
        var t2 = this.animators;
        if (t2)
          for (var h = 0; h < t2.length; h++)
            i.animation.addAnimator(t2[h]);
        this._clipPath && this._clipPath.addSelfToZr(i), this._textContent && this._textContent.addSelfToZr(i), this._textGuide && this._textGuide.addSelfToZr(i);
      }
    }, f2.prototype.removeSelfFromZr = function(i) {
      if (!!this.__zr) {
        this.__zr = null;
        var t2 = this.animators;
        if (t2)
          for (var h = 0; h < t2.length; h++)
            i.animation.removeAnimator(t2[h]);
        this._clipPath && this._clipPath.removeSelfFromZr(i), this._textContent && this._textContent.removeSelfFromZr(i), this._textGuide && this._textGuide.removeSelfFromZr(i);
      }
    }, f2.prototype.animate = function(i, t2, h) {
      var v4 = i ? this[i] : this, _ = new Cee(v4, t2, h);
      return i && (_.targetName = i), this.addAnimator(_, i), _;
    }, f2.prototype.addAnimator = function(i, t2) {
      var h = this.__zr, v4 = this;
      i.during(function() {
        v4.updateDuringAnimation(t2);
      }).done(function() {
        var _ = v4.animators, M2 = Pc2(_, i);
        M2 >= 0 && _.splice(M2, 1);
      }), this.animators.push(i), h && h.animation.addAnimator(i), h && h.wakeUp();
    }, f2.prototype.updateDuringAnimation = function(i) {
      this.markRedraw();
    }, f2.prototype.stopAnimation = function(i, t2) {
      for (var h = this.animators, v4 = h.length, _ = [], M2 = 0; M2 < v4; M2++) {
        var I2 = h[M2];
        !i || i === I2.scope ? I2.stop(t2) : _.push(I2);
      }
      return this.animators = _, this;
    }, f2.prototype.animateTo = function(i, t2, h) {
      XKt(this, i, t2, h);
    }, f2.prototype.animateFrom = function(i, t2, h) {
      XKt(this, i, t2, h, true);
    }, f2.prototype._transitionState = function(i, t2, h, v4) {
      for (var _ = XKt(this, t2, h, v4), M2 = 0; M2 < _.length; M2++)
        _[M2].__fromStateTransition = i;
    }, f2.prototype.getBoundingRect = function() {
      return null;
    }, f2.prototype.getPaintRect = function() {
      return null;
    }, f2.initDefaultProps = function() {
      var i = f2.prototype;
      i.type = "element", i.name = "", i.ignore = i.silent = i.isGroup = i.draggable = i.dragging = i.ignoreClip = i.__inHover = false, i.__dirty = UT;
      function t2(h, v4, _, M2) {
        Object.defineProperty(i, h, { get: function() {
          if (!this[v4]) {
            var P2 = this[v4] = [];
            I2(this, P2);
          }
          return this[v4];
        }, set: function(P2) {
          this[_] = P2[0], this[M2] = P2[1], this[v4] = P2, I2(this, P2);
        } });
        function I2(P2, N3) {
          Object.defineProperty(N3, 0, { get: function() {
            return P2[_];
          }, set: function(z3) {
            P2[_] = z3;
          } }), Object.defineProperty(N3, 1, { get: function() {
            return P2[M2];
          }, set: function(z3) {
            P2[M2] = z3;
          } });
        }
      }
      Object.defineProperty && (t2("position", "_legacyPos", "x", "y"), t2("scale", "_legacyScale", "scaleX", "scaleY"), t2("origin", "_legacyOrigin", "originX", "originY"));
    }(), f2;
  }();
  Sm(Iee, iE);
  Sm(Iee, G6);
  function XKt(f2, i, t2, h, v4) {
    t2 = t2 || {};
    var _ = [];
    Cze(f2, "", f2, i, t2, h, _, v4);
    var M2 = _.length, I2 = false, P2 = t2.done, N3 = t2.aborted, z3 = function() {
      I2 = true, M2--, M2 <= 0 && (I2 ? P2 && P2() : N3 && N3());
    }, H2 = function() {
      M2--, M2 <= 0 && (I2 ? P2 && P2() : N3 && N3());
    };
    M2 || P2 && P2(), _.length > 0 && t2.during && _[0].during(function(at, ht) {
      t2.during(ht);
    });
    for (var $ = 0; $ < _.length; $++) {
      var et = _[$];
      z3 && et.done(z3), H2 && et.aborted(H2), t2.force && et.duration(t2.duration), et.start(t2.easing);
    }
    return _;
  }
  function QKt(f2, i, t2) {
    for (var h = 0; h < t2; h++)
      f2[h] = i[h];
  }
  function Uur(f2) {
    return xS(f2[0]);
  }
  function qur(f2, i, t2) {
    if (xS(i[t2]))
      if (xS(f2[t2]) || (f2[t2] = []), YT(i[t2])) {
        var h = i[t2].length;
        f2[t2].length !== h && (f2[t2] = new i[t2].constructor(h), QKt(f2[t2], i[t2], h));
      } else {
        var v4 = i[t2], _ = f2[t2], M2 = v4.length;
        if (Uur(v4))
          for (var I2 = v4[0].length, P2 = 0; P2 < M2; P2++)
            _[P2] ? QKt(_[P2], v4[P2], I2) : _[P2] = Array.prototype.slice.call(v4[P2]);
        else
          QKt(_, v4, M2);
        _.length = v4.length;
      }
    else
      f2[t2] = i[t2];
  }
  function Zur(f2, i) {
    return f2 === i || xS(f2) && xS(i) && $ur(f2, i);
  }
  function $ur(f2, i) {
    var t2 = f2.length;
    if (t2 !== i.length)
      return false;
    for (var h = 0; h < t2; h++)
      if (f2[h] !== i[h])
        return false;
    return true;
  }
  function Cze(f2, i, t2, h, v4, _, M2, I2) {
    for (var P2 = Of2(h), N3 = v4.duration, z3 = v4.delay, H2 = v4.additive, $ = v4.setToFinal, et = !Xl(_), at = f2.animators, ht = [], bt = 0; bt < P2.length; bt++) {
      var _t = P2[bt], Et = h[_t];
      if (Et != null && t2[_t] != null && (et || _[_t]))
        if (Xl(Et) && !xS(Et) && !okt(Et)) {
          if (i) {
            I2 || (t2[_t] = Et, f2.updateDuringAnimation(i));
            continue;
          }
          Cze(f2, _t, t2[_t], Et, v4, _ && _[_t], M2, I2);
        } else
          ht.push(_t);
      else
        I2 || (t2[_t] = Et, f2.updateDuringAnimation(i), ht.push(_t));
    }
    var zt = ht.length;
    if (!H2 && zt)
      for (var Ft = 0; Ft < at.length; Ft++) {
        var fe2 = at[Ft];
        if (fe2.targetName === i) {
          var re2 = fe2.stopTracks(ht);
          if (re2) {
            var ye = Pc2(at, fe2);
            at.splice(ye, 1);
          }
        }
      }
    if (v4.force || (ht = Ld2(ht, function(We) {
      return !Zur(h[We], t2[We]);
    }), zt = ht.length), zt > 0 || v4.force && !M2.length) {
      var me2 = void 0, be2 = void 0, Te2 = void 0;
      if (I2) {
        be2 = {}, $ && (me2 = {});
        for (var Ft = 0; Ft < zt; Ft++) {
          var _t = ht[Ft];
          be2[_t] = t2[_t], $ ? me2[_t] = h[_t] : t2[_t] = h[_t];
        }
      } else if ($) {
        Te2 = {};
        for (var Ft = 0; Ft < zt; Ft++) {
          var _t = ht[Ft];
          Te2[_t] = Ddt(t2[_t]), qur(t2, h, _t);
        }
      }
      var fe2 = new Cee(t2, false, false, H2 ? Ld2(at, function(en) {
        return en.targetName === i;
      }) : null);
      fe2.targetName = i, v4.scope && (fe2.scope = v4.scope), $ && me2 && fe2.whenWithKeys(0, me2, ht), Te2 && fe2.whenWithKeys(0, Te2, ht), fe2.whenWithKeys(N3 == null ? 500 : N3, I2 ? be2 : h, ht).delay(z3 || 0), f2.addAnimator(fe2, i), M2.push(fe2);
    }
  }
  var Tze = Iee, Aze = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this) || this;
      return h.isGroup = true, h._children = [], h.attr(t2), h;
    }
    return i.prototype.childrenRef = function() {
      return this._children;
    }, i.prototype.children = function() {
      return this._children.slice();
    }, i.prototype.childAt = function(t2) {
      return this._children[t2];
    }, i.prototype.childOfName = function(t2) {
      for (var h = this._children, v4 = 0; v4 < h.length; v4++)
        if (h[v4].name === t2)
          return h[v4];
    }, i.prototype.childCount = function() {
      return this._children.length;
    }, i.prototype.add = function(t2) {
      return t2 && t2 !== this && t2.parent !== this && (this._children.push(t2), this._doAdd(t2)), this;
    }, i.prototype.addBefore = function(t2, h) {
      if (t2 && t2 !== this && t2.parent !== this && h && h.parent === this) {
        var v4 = this._children, _ = v4.indexOf(h);
        _ >= 0 && (v4.splice(_, 0, t2), this._doAdd(t2));
      }
      return this;
    }, i.prototype.replace = function(t2, h) {
      var v4 = Pc2(this._children, t2);
      return v4 >= 0 && this.replaceAt(h, v4), this;
    }, i.prototype.replaceAt = function(t2, h) {
      var v4 = this._children, _ = v4[h];
      if (t2 && t2 !== this && t2.parent !== this && t2 !== _) {
        v4[h] = t2, _.parent = null;
        var M2 = this.__zr;
        M2 && _.removeSelfFromZr(M2), this._doAdd(t2);
      }
      return this;
    }, i.prototype._doAdd = function(t2) {
      t2.parent && t2.parent.remove(t2), t2.parent = this;
      var h = this.__zr;
      h && h !== t2.__zr && t2.addSelfToZr(h), h && h.refresh();
    }, i.prototype.remove = function(t2) {
      var h = this.__zr, v4 = this._children, _ = Pc2(v4, t2);
      return _ < 0 ? this : (v4.splice(_, 1), t2.parent = null, h && t2.removeSelfFromZr(h), h && h.refresh(), this);
    }, i.prototype.removeAll = function() {
      for (var t2 = this._children, h = this.__zr, v4 = 0; v4 < t2.length; v4++) {
        var _ = t2[v4];
        h && _.removeSelfFromZr(h), _.parent = null;
      }
      return t2.length = 0, this;
    }, i.prototype.eachChild = function(t2, h) {
      for (var v4 = this._children, _ = 0; _ < v4.length; _++) {
        var M2 = v4[_];
        t2.call(h, M2, _);
      }
      return this;
    }, i.prototype.traverse = function(t2, h) {
      for (var v4 = 0; v4 < this._children.length; v4++) {
        var _ = this._children[v4], M2 = t2.call(h, _);
        _.isGroup && !M2 && _.traverse(t2, h);
      }
      return this;
    }, i.prototype.addSelfToZr = function(t2) {
      f2.prototype.addSelfToZr.call(this, t2);
      for (var h = 0; h < this._children.length; h++) {
        var v4 = this._children[h];
        v4.addSelfToZr(t2);
      }
    }, i.prototype.removeSelfFromZr = function(t2) {
      f2.prototype.removeSelfFromZr.call(this, t2);
      for (var h = 0; h < this._children.length; h++) {
        var v4 = this._children[h];
        v4.removeSelfFromZr(t2);
      }
    }, i.prototype.getBoundingRect = function(t2) {
      for (var h = new Lc2(0, 0, 0, 0), v4 = t2 || this._children, _ = [], M2 = null, I2 = 0; I2 < v4.length; I2++) {
        var P2 = v4[I2];
        if (!(P2.ignore || P2.invisible)) {
          var N3 = P2.getBoundingRect(), z3 = P2.getLocalTransform(_);
          z3 ? (Lc2.applyTransform(h, N3, z3), M2 = M2 || h.clone(), M2.union(h)) : (M2 = M2 || N3.clone(), M2.union(N3));
        }
      }
      return M2 || h;
    }, i;
  }(Tze);
  Aze.prototype.type = "group";
  var mu = Aze;
  /*!
  * ZRender, a high performance 2d drawing library.
  *
  * Copyright (c) 2013, Baidu Inc.
  * All rights reserved.
  *
  * LICENSE
  * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
  */
  var UDt = {}, Ize = {};
  function Yur(f2) {
    delete Ize[f2];
  }
  function Kur(f2) {
    if (!f2)
      return false;
    if (typeof f2 == "string")
      return cEt(f2, 1) < PJt;
    if (f2.colorStops) {
      for (var i = f2.colorStops, t2 = 0, h = i.length, v4 = 0; v4 < h; v4++)
        t2 += cEt(i[v4].color, 1);
      return t2 /= h, t2 < PJt;
    }
    return false;
  }
  var Xur = function() {
    function f2(i, t2, h) {
      var v4 = this;
      this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, h = h || {}, this.dom = t2, this.id = i;
      var _ = new nur(), M2 = h.renderer || "canvas";
      UDt[M2] || (M2 = Of2(UDt)[0]), h.useDirtyRect = h.useDirtyRect == null ? false : h.useDirtyRect;
      var I2 = new UDt[M2](t2, _, h, i), P2 = h.ssr || I2.ssrOnly;
      this.storage = _, this.painter = I2;
      var N3 = !gp.node && !gp.worker && !P2 ? new Fur(I2.getViewportRoot(), I2.root) : null;
      this.handler = new Xlr(_, I2, N3, I2.root), this.animation = new Dur({ stage: { update: P2 ? null : function() {
        return v4._flush(true);
      } } }), P2 || this.animation.start();
    }
    return f2.prototype.add = function(i) {
      !i || (this.storage.addRoot(i), i.addSelfToZr(this), this.refresh());
    }, f2.prototype.remove = function(i) {
      !i || (this.storage.delRoot(i), i.removeSelfFromZr(this), this.refresh());
    }, f2.prototype.configLayer = function(i, t2) {
      this.painter.configLayer && this.painter.configLayer(i, t2), this.refresh();
    }, f2.prototype.setBackgroundColor = function(i) {
      this.painter.setBackgroundColor && this.painter.setBackgroundColor(i), this.refresh(), this._backgroundColor = i, this._darkMode = Kur(i);
    }, f2.prototype.getBackgroundColor = function() {
      return this._backgroundColor;
    }, f2.prototype.setDarkMode = function(i) {
      this._darkMode = i;
    }, f2.prototype.isDarkMode = function() {
      return this._darkMode;
    }, f2.prototype.refreshImmediately = function(i) {
      i || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
    }, f2.prototype.refresh = function() {
      this._needsRefresh = true, this.animation.start();
    }, f2.prototype.flush = function() {
      this._flush(false);
    }, f2.prototype._flush = function(i) {
      var t2, h = Ttt();
      this._needsRefresh && (t2 = true, this.refreshImmediately(i)), this._needsRefreshHover && (t2 = true, this.refreshHoverImmediately());
      var v4 = Ttt();
      t2 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: v4 - h })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
    }, f2.prototype.setSleepAfterStill = function(i) {
      this._sleepAfterStill = i;
    }, f2.prototype.wakeUp = function() {
      this.animation.start(), this._stillFrameAccum = 0;
    }, f2.prototype.refreshHover = function() {
      this._needsRefreshHover = true;
    }, f2.prototype.refreshHoverImmediately = function() {
      this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
    }, f2.prototype.resize = function(i) {
      i = i || {}, this.painter.resize(i.width, i.height), this.handler.resize();
    }, f2.prototype.clearAnimation = function() {
      this.animation.clear();
    }, f2.prototype.getWidth = function() {
      return this.painter.getWidth();
    }, f2.prototype.getHeight = function() {
      return this.painter.getHeight();
    }, f2.prototype.setCursorStyle = function(i) {
      this.handler.setCursorStyle(i);
    }, f2.prototype.findHover = function(i, t2) {
      return this.handler.findHover(i, t2);
    }, f2.prototype.on = function(i, t2, h) {
      return this.handler.on(i, t2, h), this;
    }, f2.prototype.off = function(i, t2) {
      this.handler.off(i, t2);
    }, f2.prototype.trigger = function(i, t2) {
      this.handler.trigger(i, t2);
    }, f2.prototype.clear = function() {
      for (var i = this.storage.getRoots(), t2 = 0; t2 < i.length; t2++)
        i[t2] instanceof mu && i[t2].removeSelfFromZr(this);
      this.storage.delAllRoots(), this.painter.clear();
    }, f2.prototype.dispose = function() {
      this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, Yur(this.id);
    }, f2;
  }();
  function z6e(f2, i) {
    var t2 = new Xur(QBe(), f2, i);
    return Ize[t2.id] = t2, t2;
  }
  function Qur(f2, i) {
    UDt[f2] = i;
  }
  var j6e = 1e-4, Dze = 20;
  function Jur(f2) {
    return f2.replace(/^\s+|\s+$/g, "");
  }
  function cd2(f2, i, t2, h) {
    var v4 = i[0], _ = i[1], M2 = t2[0], I2 = t2[1], P2 = _ - v4, N3 = I2 - M2;
    if (P2 === 0)
      return N3 === 0 ? M2 : (M2 + I2) / 2;
    if (h)
      if (P2 > 0) {
        if (f2 <= v4)
          return M2;
        if (f2 >= _)
          return I2;
      } else {
        if (f2 >= v4)
          return M2;
        if (f2 <= _)
          return I2;
      }
    else {
      if (f2 === v4)
        return M2;
      if (f2 === _)
        return I2;
    }
    return (f2 - v4) / P2 * N3 + M2;
  }
  function cs(f2, i) {
    switch (f2) {
      case "center":
      case "middle":
        f2 = "50%";
        break;
      case "left":
      case "top":
        f2 = "0%";
        break;
      case "right":
      case "bottom":
        f2 = "100%";
        break;
    }
    return ms(f2) ? Jur(f2).match(/%$/) ? parseFloat(f2) / 100 * i : parseFloat(f2) : f2 == null ? NaN : +f2;
  }
  function gy(f2, i, t2) {
    return i == null && (i = 10), i = Math.min(Math.max(0, i), Dze), f2 = (+f2).toFixed(i), t2 ? f2 : +f2;
  }
  function QD(f2) {
    return f2.sort(function(i, t2) {
      return i - t2;
    }), f2;
  }
  function PL(f2) {
    if (f2 = +f2, isNaN(f2))
      return 0;
    if (f2 > 1e-14) {
      for (var i = 1, t2 = 0; t2 < 15; t2++, i *= 10)
        if (Math.round(f2 * i) / i === f2)
          return t2;
    }
    return tcr(f2);
  }
  function tcr(f2) {
    var i = f2.toString().toLowerCase(), t2 = i.indexOf("e"), h = t2 > 0 ? +i.slice(t2 + 1) : 0, v4 = t2 > 0 ? t2 : i.length, _ = i.indexOf("."), M2 = _ < 0 ? 0 : v4 - 1 - _;
    return Math.max(0, M2 - h);
  }
  function Eze(f2, i) {
    var t2 = Math.log, h = Math.LN10, v4 = Math.floor(t2(f2[1] - f2[0]) / h), _ = Math.round(t2(Math.abs(i[1] - i[0])) / h), M2 = Math.min(Math.max(-v4 + _, 0), 20);
    return isFinite(M2) ? M2 : 20;
  }
  function ecr(f2, i, t2) {
    if (!f2[i])
      return 0;
    var h = zL(f2, function(at, ht) {
      return at + (isNaN(ht) ? 0 : ht);
    }, 0);
    if (h === 0)
      return 0;
    for (var v4 = Math.pow(10, t2), _ = Xa2(f2, function(at) {
      return (isNaN(at) ? 0 : at) / h * v4 * 100;
    }), M2 = v4 * 100, I2 = Xa2(_, function(at) {
      return Math.floor(at);
    }), P2 = zL(I2, function(at, ht) {
      return at + ht;
    }, 0), N3 = Xa2(_, function(at, ht) {
      return at - I2[ht];
    }); P2 < M2; ) {
      for (var z3 = Number.NEGATIVE_INFINITY, H2 = null, $ = 0, et = N3.length; $ < et; ++$)
        N3[$] > z3 && (z3 = N3[$], H2 = $);
      ++I2[H2], N3[H2] = 0, ++P2;
    }
    return I2[i] / v4;
  }
  function ncr(f2, i) {
    var t2 = Math.max(PL(f2), PL(i)), h = f2 + i;
    return t2 > Dze ? h : gy(h, t2);
  }
  var W6e = 9007199254740991;
  function kze(f2) {
    var i = Math.PI * 2;
    return (f2 % i + i) % i;
  }
  function dEt(f2) {
    return f2 > -j6e && f2 < j6e;
  }
  var rcr = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
  function GL(f2) {
    if (f2 instanceof Date)
      return f2;
    if (ms(f2)) {
      var i = rcr.exec(f2);
      if (!i)
        return new Date(NaN);
      if (i[8]) {
        var t2 = +i[4] || 0;
        return i[8].toUpperCase() !== "Z" && (t2 -= +i[8].slice(0, 3)), new Date(Date.UTC(+i[1], +(i[2] || 1) - 1, +i[3] || 1, t2, +(i[5] || 0), +i[6] || 0, i[7] ? +i[7].substring(0, 3) : 0));
      } else
        return new Date(+i[1], +(i[2] || 1) - 1, +i[3] || 1, +i[4] || 0, +(i[5] || 0), +i[6] || 0, i[7] ? +i[7].substring(0, 3) : 0);
    } else if (f2 == null)
      return new Date(NaN);
    return new Date(Math.round(f2));
  }
  function icr(f2) {
    return Math.pow(10, Dee(f2));
  }
  function Dee(f2) {
    if (f2 === 0)
      return 0;
    var i = Math.floor(Math.log(f2) / Math.LN10);
    return f2 / Math.pow(10, i) >= 10 && i++, i;
  }
  function Pze(f2, i) {
    var t2 = Dee(f2), h = Math.pow(10, t2), v4 = f2 / h, _;
    return i ? v4 < 1.5 ? _ = 1 : v4 < 2.5 ? _ = 2 : v4 < 4 ? _ = 3 : v4 < 7 ? _ = 5 : _ = 10 : v4 < 1 ? _ = 1 : v4 < 2 ? _ = 2 : v4 < 3 ? _ = 3 : v4 < 5 ? _ = 5 : _ = 10, f2 = _ * h, t2 >= -20 ? +f2.toFixed(t2 < 0 ? -t2 : 0) : f2;
  }
  function JKt(f2, i) {
    var t2 = (f2.length - 1) * i + 1, h = Math.floor(t2), v4 = +f2[h - 1], _ = t2 - h;
    return _ ? v4 + _ * (f2[h] - v4) : v4;
  }
  function G6e(f2) {
    f2.sort(function(P2, N3) {
      return I2(P2, N3, 0) ? -1 : 1;
    });
    for (var i = -1 / 0, t2 = 1, h = 0; h < f2.length; ) {
      for (var v4 = f2[h].interval, _ = f2[h].close, M2 = 0; M2 < 2; M2++)
        v4[M2] <= i && (v4[M2] = i, _[M2] = M2 ? 1 : 1 - t2), i = v4[M2], t2 = _[M2];
      v4[0] === v4[1] && _[0] * _[1] !== 1 ? f2.splice(h, 1) : h++;
    }
    return f2;
    function I2(P2, N3, z3) {
      return P2.interval[z3] < N3.interval[z3] || P2.interval[z3] === N3.interval[z3] && (P2.close[z3] - N3.close[z3] === (z3 ? -1 : 1) || !z3 && I2(P2, N3, 1));
    }
  }
  function tN(f2) {
    var i = parseFloat(f2);
    return i == f2 && (i !== 0 || !ms(f2) || f2.indexOf("x") <= 0) ? i : NaN;
  }
  function Lze(f2) {
    return !isNaN(tN(f2));
  }
  function Oze() {
    return Math.round(Math.random() * 9);
  }
  function Rze(f2, i) {
    return i === 0 ? f2 : Rze(i, f2 % i);
  }
  function H6e(f2, i) {
    return f2 == null ? i : i == null ? f2 : f2 * i / Rze(f2, i);
  }
  function Ep(f2) {
    throw new Error(f2);
  }
  function U6e(f2, i, t2) {
    return (i - f2) * t2 + f2;
  }
  var Nze = "series\0", Fze = "\0_ec_\0";
  function Od2(f2) {
    return f2 instanceof Array ? f2 : f2 == null ? [] : [f2];
  }
  function gU(f2, i, t2) {
    if (f2) {
      f2[i] = f2[i] || {}, f2.emphasis = f2.emphasis || {}, f2.emphasis[i] = f2.emphasis[i] || {};
      for (var h = 0, v4 = t2.length; h < v4; h++) {
        var _ = t2[h];
        !f2.emphasis[i].hasOwnProperty(_) && f2[i].hasOwnProperty(_) && (f2.emphasis[i][_] = f2[i][_]);
      }
    }
  }
  var q6e = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
  function Qtt(f2) {
    return Xl(f2) && !Za2(f2) && !(f2 instanceof Date) ? f2.value : f2;
  }
  function acr(f2) {
    return Xl(f2) && !(f2 instanceof Array);
  }
  function Vze(f2, i, t2) {
    var h = t2 === "normalMerge", v4 = t2 === "replaceMerge", _ = t2 === "replaceAll";
    f2 = f2 || [], i = (i || []).slice();
    var M2 = Il();
    Qe2(i, function(P2, N3) {
      if (!Xl(P2)) {
        i[N3] = null;
        return;
      }
    });
    var I2 = ocr(f2, M2, t2);
    return (h || v4) && scr(I2, f2, M2, i), h && lcr(I2, i), h || v4 ? ucr(I2, i, v4) : _ && ccr(I2, i), fcr(I2), I2;
  }
  function ocr(f2, i, t2) {
    var h = [];
    if (t2 === "replaceAll")
      return h;
    for (var v4 = 0; v4 < f2.length; v4++) {
      var _ = f2[v4];
      _ && _.id != null && i.set(_.id, v4), h.push({ existing: t2 === "replaceMerge" || Kdt(_) ? null : _, newOption: null, keyInfo: null, brandNew: null });
    }
    return h;
  }
  function scr(f2, i, t2, h) {
    Qe2(h, function(v4, _) {
      if (!(!v4 || v4.id == null)) {
        var M2 = Edt(v4.id), I2 = t2.get(M2);
        if (I2 != null) {
          var P2 = f2[I2];
          z2(!P2.newOption, 'Duplicated option on id "' + M2 + '".'), P2.newOption = v4, P2.existing = i[I2], h[_] = null;
        }
      }
    });
  }
  function lcr(f2, i) {
    Qe2(i, function(t2, h) {
      if (!(!t2 || t2.name == null))
        for (var v4 = 0; v4 < f2.length; v4++) {
          var _ = f2[v4].existing;
          if (!f2[v4].newOption && _ && (_.id == null || t2.id == null) && !Kdt(t2) && !Kdt(_) && Bze("name", _, t2)) {
            f2[v4].newOption = t2, i[h] = null;
            return;
          }
        }
    });
  }
  function ucr(f2, i, t2) {
    Qe2(i, function(h) {
      if (!!h) {
        for (var v4, _ = 0; (v4 = f2[_]) && (v4.newOption || Kdt(v4.existing) || v4.existing && h.id != null && !Bze("id", h, v4.existing)); )
          _++;
        v4 ? (v4.newOption = h, v4.brandNew = t2) : f2.push({ newOption: h, brandNew: t2, existing: null, keyInfo: null }), _++;
      }
    });
  }
  function ccr(f2, i) {
    Qe2(i, function(t2) {
      f2.push({ newOption: t2, brandNew: true, existing: null, keyInfo: null });
    });
  }
  function fcr(f2) {
    var i = Il();
    Qe2(f2, function(t2) {
      var h = t2.existing;
      h && i.set(h.id, t2);
    }), Qe2(f2, function(t2) {
      var h = t2.newOption;
      z2(!h || h.id == null || !i.get(h.id) || i.get(h.id) === t2, "id duplicates: " + (h && h.id)), h && h.id != null && i.set(h.id, t2), !t2.keyInfo && (t2.keyInfo = {});
    }), Qe2(f2, function(t2, h) {
      var v4 = t2.existing, _ = t2.newOption, M2 = t2.keyInfo;
      if (!!Xl(_)) {
        if (M2.name = _.name != null ? Edt(_.name) : v4 ? v4.name : Nze + h, v4)
          M2.id = Edt(v4.id);
        else if (_.id != null)
          M2.id = Edt(_.id);
        else {
          var I2 = 0;
          do
            M2.id = "\0" + M2.name + "\0" + I2++;
          while (i.get(M2.id));
        }
        i.set(M2.id, t2);
      }
    });
  }
  function Bze(f2, i, t2) {
    var h = l1(i[f2], null), v4 = l1(t2[f2], null);
    return h != null && v4 != null && h === v4;
  }
  function Edt(f2) {
    return l1(f2, "");
  }
  function l1(f2, i) {
    return f2 == null ? i : ms(f2) ? f2 : vp(f2) || hJt(f2) ? f2 + "" : i;
  }
  function Eee(f2) {
    var i = f2.name;
    return !!(i && i.indexOf(Nze));
  }
  function Kdt(f2) {
    return f2 && f2.id != null && Edt(f2.id).indexOf(Fze) === 0;
  }
  function hcr(f2) {
    return Fze + f2;
  }
  function pcr(f2, i, t2) {
    Qe2(f2, function(h) {
      var v4 = h.newOption;
      Xl(v4) && (h.keyInfo.mainType = i, h.keyInfo.subType = dcr(i, v4, h.existing, t2));
    });
  }
  function dcr(f2, i, t2, h) {
    var v4 = i.type ? i.type : t2 ? t2.subType : h.determineSubType(f2, i);
    return v4;
  }
  function gcr(f2, i) {
    var t2 = {}, h = {};
    return v4(f2 || [], t2), v4(i || [], h, t2), [_(t2), _(h)];
    function v4(M2, I2, P2) {
      for (var N3 = 0, z3 = M2.length; N3 < z3; N3++) {
        var H2 = l1(M2[N3].seriesId, null);
        if (H2 == null)
          return;
        for (var $ = Od2(M2[N3].dataIndex), et = P2 && P2[H2], at = 0, ht = $.length; at < ht; at++) {
          var bt = $[at];
          et && et[bt] ? et[bt] = null : (I2[H2] || (I2[H2] = {}))[bt] = 1;
        }
      }
    }
    function _(M2, I2) {
      var P2 = [];
      for (var N3 in M2)
        if (M2.hasOwnProperty(N3) && M2[N3] != null)
          if (I2)
            P2.push(+N3);
          else {
            var z3 = _(M2[N3], true);
            z3.length && P2.push({ seriesId: N3, dataIndex: z3 });
          }
      return P2;
    }
  }
  function vU(f2, i) {
    if (i.dataIndexInside != null)
      return i.dataIndexInside;
    if (i.dataIndex != null)
      return Za2(i.dataIndex) ? Xa2(i.dataIndex, function(t2) {
        return f2.indexOfRawIndex(t2);
      }) : f2.indexOfRawIndex(i.dataIndex);
    if (i.name != null)
      return Za2(i.name) ? Xa2(i.name, function(t2) {
        return f2.indexOfName(t2);
      }) : f2.indexOfName(i.name);
  }
  function Wh2() {
    var f2 = "__ec_inner_" + vcr++;
    return function(i) {
      return i[f2] || (i[f2] = {});
    };
  }
  var vcr = Oze();
  function kdt(f2, i, t2) {
    var h = kee(i, t2), v4 = h.mainTypeSpecified, _ = h.queryOptionMap, M2 = h.others, I2 = M2, P2 = t2 ? t2.defaultMainType : null;
    return !v4 && P2 && _.set(P2, {}), _.each(function(N3, z3) {
      var H2 = Tgt(f2, z3, N3, { useDefault: P2 === z3, enableAll: t2 && t2.enableAll != null ? t2.enableAll : true, enableNone: t2 && t2.enableNone != null ? t2.enableNone : true });
      I2[z3 + "Models"] = H2.models, I2[z3 + "Model"] = H2.models[0];
    }), I2;
  }
  function kee(f2, i) {
    var t2;
    if (ms(f2)) {
      var h = {};
      h[f2 + "Index"] = 0, t2 = h;
    } else
      t2 = f2;
    var v4 = Il(), _ = {}, M2 = false;
    return Qe2(t2, function(I2, P2) {
      if (P2 === "dataIndex" || P2 === "dataIndexInside") {
        _[P2] = I2;
        return;
      }
      var N3 = P2.match(/^(\w+)(Index|Id|Name)$/) || [], z3 = N3[1], H2 = (N3[2] || "").toLowerCase();
      if (!(!z3 || !H2 || i && i.includeMainTypes && Pc2(i.includeMainTypes, z3) < 0)) {
        M2 = M2 || !!z3;
        var $ = v4.get(z3) || v4.set(z3, {});
        $[H2] = I2;
      }
    }), { mainTypeSpecified: M2, queryOptionMap: v4, others: _ };
  }
  var _m = { useDefault: true, enableAll: false, enableNone: false }, ycr = { useDefault: false, enableAll: true, enableNone: true };
  function Tgt(f2, i, t2, h) {
    h = h || _m;
    var v4 = t2.index, _ = t2.id, M2 = t2.name, I2 = { models: null, specified: v4 != null || _ != null || M2 != null };
    if (!I2.specified) {
      var P2 = void 0;
      return I2.models = h.useDefault && (P2 = f2.getComponent(i)) ? [P2] : [], I2;
    }
    return v4 === "none" || v4 === false ? (z2(h.enableNone, '`"none"` or `false` is not a valid value on index option.'), I2.models = [], I2) : (v4 === "all" && (z2(h.enableAll, '`"all"` is not a valid value on index option.'), v4 = _ = M2 = null), I2.models = f2.queryComponents({ mainType: i, index: v4, id: _, name: M2 }), I2);
  }
  function zze(f2, i, t2) {
    f2.setAttribute ? f2.setAttribute(i, t2) : f2[i] = t2;
  }
  function mcr(f2, i) {
    return f2.getAttribute ? f2.getAttribute(i) : f2[i];
  }
  function bcr(f2) {
    return f2 === "auto" ? gp.domSupported ? "html" : "richText" : f2 || "html";
  }
  function RJt(f2, i) {
    var t2 = Il(), h = [];
    return Qe2(f2, function(v4) {
      var _ = i(v4);
      (t2.get(_) || (h.push(_), t2.set(_, []))).push(v4);
    }), { keys: h, buckets: t2 };
  }
  function jze(f2, i, t2, h, v4) {
    var _ = i == null || i === "auto";
    if (h == null)
      return h;
    if (vp(h)) {
      var M2 = U6e(t2 || 0, h, v4);
      return gy(M2, _ ? Math.max(PL(t2 || 0), PL(h)) : i);
    } else {
      if (ms(h))
        return v4 < 1 ? t2 : h;
      for (var I2 = [], P2 = t2, N3 = h, z3 = Math.max(P2 ? P2.length : 0, N3.length), H2 = 0; H2 < z3; ++H2) {
        var $ = f2.getDimensionInfo(H2);
        if ($ && $.type === "ordinal")
          I2[H2] = (v4 < 1 && P2 ? P2 : N3)[H2];
        else {
          var et = P2 && P2[H2] ? P2[H2] : 0, at = N3[H2], M2 = U6e(et, at, v4);
          I2[H2] = gy(M2, _ ? Math.max(PL(et), PL(at)) : i);
        }
      }
      return I2;
    }
  }
  var _cr = ".", wH = "___EC__COMPONENT__CONTAINER___", Wze = "___EC__EXTENDED_CLASS___";
  function LL(f2) {
    var i = { main: "", sub: "" };
    if (f2) {
      var t2 = f2.split(_cr);
      i.main = t2[0] || "", i.sub = t2[1] || "";
    }
    return i;
  }
  function xcr(f2) {
    z2(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(f2), 'componentType "' + f2 + '" illegal');
  }
  function wcr(f2) {
    return !!(f2 && f2[Wze]);
  }
  function Pee(f2, i) {
    f2.$constructor = f2, f2.extend = function(t2) {
      var h = this, v4;
      return Scr(h) ? v4 = function(_) {
        ii2(M2, _);
        function M2() {
          return _.apply(this, arguments) || this;
        }
        return M2;
      }(h) : (v4 = function() {
        (t2.$constructor || h).apply(this, arguments);
      }, Mlr(v4, this)), ba2(v4.prototype, t2), v4[Wze] = true, v4.extend = this.extend, v4.superCall = Tcr, v4.superApply = Acr, v4.superClass = h, v4;
    };
  }
  function Scr(f2) {
    return Ol(f2) && /^class\s/.test(Function.prototype.toString.call(f2));
  }
  function Gze(f2, i) {
    f2.extend = i.extend;
  }
  var Mcr = Math.round(Math.random() * 10);
  function Ccr(f2) {
    var i = ["__\0is_clz", Mcr++].join("_");
    f2.prototype[i] = true, f2.isInstance = function(t2) {
      return !!(t2 && t2[i]);
    };
  }
  function Tcr(f2, i) {
    for (var t2 = [], h = 2; h < arguments.length; h++)
      t2[h - 2] = arguments[h];
    return this.superClass.prototype[i].apply(f2, t2);
  }
  function Acr(f2, i, t2) {
    return this.superClass.prototype[i].apply(f2, t2);
  }
  function fkt(f2) {
    var i = {};
    f2.registerClass = function(h) {
      var v4 = h.type || h.prototype.type;
      if (v4) {
        xcr(v4), h.prototype.type = v4;
        var _ = LL(v4);
        if (!_.sub)
          i[_.main] = h;
        else if (_.sub !== wH) {
          var M2 = t2(_);
          M2[_.sub] = h;
        }
      }
      return h;
    }, f2.getClass = function(h, v4, _) {
      var M2 = i[h];
      if (M2 && M2[wH] && (M2 = v4 ? M2[v4] : null), _ && !M2)
        throw new Error(v4 ? "Component " + h + "." + (v4 || "") + " is used but not imported." : h + ".type should be specified.");
      return M2;
    }, f2.getClassesByMainType = function(h) {
      var v4 = LL(h), _ = [], M2 = i[v4.main];
      return M2 && M2[wH] ? Qe2(M2, function(I2, P2) {
        P2 !== wH && _.push(I2);
      }) : _.push(M2), _;
    }, f2.hasClass = function(h) {
      var v4 = LL(h);
      return !!i[v4.main];
    }, f2.getAllClassMainTypes = function() {
      var h = [];
      return Qe2(i, function(v4, _) {
        h.push(_);
      }), h;
    }, f2.hasSubTypes = function(h) {
      var v4 = LL(h), _ = i[v4.main];
      return _ && _[wH];
    };
    function t2(h) {
      var v4 = i[h.main];
      return (!v4 || !v4[wH]) && (v4 = i[h.main] = {}, v4[wH] = true), v4;
    }
  }
  function yU(f2, i) {
    for (var t2 = 0; t2 < f2.length; t2++)
      f2[t2][1] || (f2[t2][1] = f2[t2][0]);
    return i = i || false, function(h, v4, _) {
      for (var M2 = {}, I2 = 0; I2 < f2.length; I2++) {
        var P2 = f2[I2][1];
        if (!(v4 && Pc2(v4, P2) >= 0 || _ && Pc2(_, P2) < 0)) {
          var N3 = h.getShallow(P2, i);
          N3 != null && (M2[f2[I2][0]] = N3);
        }
      }
      return M2;
    };
  }
  var Icr = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], Dcr = yU(Icr), Ecr = function() {
    function f2() {
    }
    return f2.prototype.getAreaStyle = function(i, t2) {
      return Dcr(this, i, t2);
    }, f2;
  }(), NJt = new Mgt(50);
  function kcr(f2) {
    if (typeof f2 == "string") {
      var i = NJt.get(f2);
      return i && i.image;
    } else
      return f2;
  }
  function Lee(f2, i, t2, h, v4) {
    if (f2)
      if (typeof f2 == "string") {
        if (i && i.__zrImageSrc === f2 || !t2)
          return i;
        var _ = NJt.get(f2), M2 = { hostEl: t2, cb: h, cbPayload: v4 };
        if (_)
          i = _.image, !hkt(i) && _.pending.push(M2);
        else {
          var I2 = Q6.loadImage(f2, Z6e, Z6e);
          I2.__zrImageSrc = f2, NJt.put(f2, I2.__cachedImgObj = { image: I2, pending: [M2] });
        }
        return i;
      } else
        return f2;
    else
      return i;
  }
  function Z6e() {
    var f2 = this.__cachedImgObj;
    this.onload = this.onerror = this.__cachedImgObj = null;
    for (var i = 0; i < f2.pending.length; i++) {
      var t2 = f2.pending[i], h = t2.cb;
      h && h(this, t2.cbPayload), t2.hostEl.dirty();
    }
    f2.pending.length = 0;
  }
  function hkt(f2) {
    return f2 && f2.width && f2.height;
  }
  var tXt = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
  function Pcr(f2, i, t2, h, v4) {
    if (!i)
      return "";
    var _ = (f2 + "").split(`
`);
    v4 = Hze(i, t2, h, v4);
    for (var M2 = 0, I2 = _.length; M2 < I2; M2++)
      _[M2] = Uze(_[M2], v4);
    return _.join(`
`);
  }
  function Hze(f2, i, t2, h) {
    h = h || {};
    var v4 = ba2({}, h);
    v4.font = i, t2 = _c2(t2, "..."), v4.maxIterations = _c2(h.maxIterations, 2);
    var _ = v4.minChar = _c2(h.minChar, 0);
    v4.cnCharWidth = $T("\u56FD", i);
    var M2 = v4.ascCharWidth = $T("a", i);
    v4.placeholder = _c2(h.placeholder, "");
    for (var I2 = f2 = Math.max(0, f2 - 1), P2 = 0; P2 < _ && I2 >= M2; P2++)
      I2 -= M2;
    var N3 = $T(t2, i);
    return N3 > I2 && (t2 = "", N3 = 0), I2 = f2 - N3, v4.ellipsis = t2, v4.ellipsisWidth = N3, v4.contentWidth = I2, v4.containerWidth = f2, v4;
  }
  function Uze(f2, i) {
    var t2 = i.containerWidth, h = i.font, v4 = i.contentWidth;
    if (!t2)
      return "";
    var _ = $T(f2, h);
    if (_ <= t2)
      return f2;
    for (var M2 = 0; ; M2++) {
      if (_ <= v4 || M2 >= i.maxIterations) {
        f2 += i.ellipsis;
        break;
      }
      var I2 = M2 === 0 ? Lcr(f2, v4, i.ascCharWidth, i.cnCharWidth) : _ > 0 ? Math.floor(f2.length * v4 / _) : 0;
      f2 = f2.substr(0, I2), _ = $T(f2, h);
    }
    return f2 === "" && (f2 = i.placeholder), f2;
  }
  function Lcr(f2, i, t2, h) {
    for (var v4 = 0, _ = 0, M2 = f2.length; _ < M2 && v4 < i; _++) {
      var I2 = f2.charCodeAt(_);
      v4 += 0 <= I2 && I2 <= 127 ? t2 : h;
    }
    return _;
  }
  function Ocr(f2, i) {
    f2 != null && (f2 += "");
    var t2 = i.overflow, h = i.padding, v4 = i.font, _ = t2 === "truncate", M2 = ckt(v4), I2 = _c2(i.lineHeight, M2), P2 = !!i.backgroundColor, N3 = i.lineOverflow === "truncate", z3 = i.width, H2;
    z3 != null && (t2 === "break" || t2 === "breakAll") ? H2 = f2 ? qze(f2, i.font, z3, t2 === "breakAll", 0).lines : [] : H2 = f2 ? f2.split(`
`) : [];
    var $ = H2.length * I2, et = _c2(i.height, $);
    if ($ > et && N3) {
      var at = Math.floor(et / I2);
      H2 = H2.slice(0, at);
    }
    if (f2 && _ && z3 != null)
      for (var ht = Hze(z3, v4, i.ellipsis, { minChar: i.truncateMinChar, placeholder: i.placeholder }), bt = 0; bt < H2.length; bt++)
        H2[bt] = Uze(H2[bt], ht);
    for (var _t = et, Et = 0, bt = 0; bt < H2.length; bt++)
      Et = Math.max($T(H2[bt], v4), Et);
    z3 == null && (z3 = Et);
    var zt = Et;
    return h && (_t += h[0] + h[2], zt += h[1] + h[3], z3 += h[1] + h[3]), P2 && (zt = z3), { lines: H2, height: et, outerWidth: zt, outerHeight: _t, lineHeight: I2, calculatedLineHeight: M2, contentWidth: Et, contentHeight: $, width: z3 };
  }
  var Rcr = function() {
    function f2() {
    }
    return f2;
  }(), $6e = function() {
    function f2(i) {
      this.tokens = [], i && (this.tokens = i);
    }
    return f2;
  }(), Ncr = function() {
    function f2() {
      this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
    }
    return f2;
  }();
  function Fcr(f2, i) {
    var t2 = new Ncr();
    if (f2 != null && (f2 += ""), !f2)
      return t2;
    for (var h = i.width, v4 = i.height, _ = i.overflow, M2 = (_ === "break" || _ === "breakAll") && h != null ? { width: h, accumWidth: 0, breakAll: _ === "breakAll" } : null, I2 = tXt.lastIndex = 0, P2; (P2 = tXt.exec(f2)) != null; ) {
      var N3 = P2.index;
      N3 > I2 && eXt(t2, f2.substring(I2, N3), i, M2), eXt(t2, P2[2], i, M2, P2[1]), I2 = tXt.lastIndex;
    }
    I2 < f2.length && eXt(t2, f2.substring(I2, f2.length), i, M2);
    var z3 = [], H2 = 0, $ = 0, et = i.padding, at = _ === "truncate", ht = i.lineOverflow === "truncate";
    function bt(nr, pr, Nr) {
      nr.width = pr, nr.lineHeight = Nr, H2 += Nr, $ = Math.max($, pr);
    }
    t:
      for (var _t = 0; _t < t2.lines.length; _t++) {
        for (var Et = t2.lines[_t], zt = 0, Ft = 0, fe2 = 0; fe2 < Et.tokens.length; fe2++) {
          var re2 = Et.tokens[fe2], ye = re2.styleName && i.rich[re2.styleName] || {}, me2 = re2.textPadding = ye.padding, be2 = me2 ? me2[1] + me2[3] : 0, Te2 = re2.font = ye.font || i.font;
          re2.contentHeight = ckt(Te2);
          var We = _c2(ye.height, re2.contentHeight);
          if (re2.innerHeight = We, me2 && (We += me2[0] + me2[2]), re2.height = We, re2.lineHeight = U6(ye.lineHeight, i.lineHeight, We), re2.align = ye && ye.align || i.align, re2.verticalAlign = ye && ye.verticalAlign || "middle", ht && v4 != null && H2 + re2.lineHeight > v4) {
            fe2 > 0 ? (Et.tokens = Et.tokens.slice(0, fe2), bt(Et, Ft, zt), t2.lines = t2.lines.slice(0, _t + 1)) : t2.lines = t2.lines.slice(0, _t);
            break t;
          }
          var en = ye.width, Ue2 = en == null || en === "auto";
          if (typeof en == "string" && en.charAt(en.length - 1) === "%")
            re2.percentWidth = en, z3.push(re2), re2.contentWidth = $T(re2.text, Te2);
          else {
            if (Ue2) {
              var Mn = ye.backgroundColor, Vn = Mn && Mn.image;
              Vn && (Vn = kcr(Vn), hkt(Vn) && (re2.width = Math.max(re2.width, Vn.width * We / Vn.height)));
            }
            var xn = at && h != null ? h - Ft : null;
            xn != null && xn < re2.width ? !Ue2 || xn < be2 ? (re2.text = "", re2.width = re2.contentWidth = 0) : (re2.text = Pcr(re2.text, xn - be2, Te2, i.ellipsis, { minChar: i.truncateMinChar }), re2.width = re2.contentWidth = $T(re2.text, Te2)) : re2.contentWidth = $T(re2.text, Te2);
          }
          re2.width += be2, Ft += re2.width, ye && (zt = Math.max(zt, re2.lineHeight));
        }
        bt(Et, Ft, zt);
      }
    t2.outerWidth = t2.width = _c2(h, $), t2.outerHeight = t2.height = _c2(v4, H2), t2.contentHeight = H2, t2.contentWidth = $, et && (t2.outerWidth += et[1] + et[3], t2.outerHeight += et[0] + et[2]);
    for (var _t = 0; _t < z3.length; _t++) {
      var re2 = z3[_t], Zr = re2.percentWidth;
      re2.width = parseInt(Zr, 10) / 100 * t2.width;
    }
    return t2;
  }
  function eXt(f2, i, t2, h, v4) {
    var _ = i === "", M2 = v4 && t2.rich[v4] || {}, I2 = f2.lines, P2 = M2.font || t2.font, N3 = false, z3, H2;
    if (h) {
      var $ = M2.padding, et = $ ? $[1] + $[3] : 0;
      if (M2.width != null && M2.width !== "auto") {
        var at = T5(M2.width, h.width) + et;
        I2.length > 0 && at + h.accumWidth > h.width && (z3 = i.split(`
`), N3 = true), h.accumWidth = at;
      } else {
        var ht = qze(i, P2, h.width, h.breakAll, h.accumWidth);
        h.accumWidth = ht.accumWidth + et, H2 = ht.linesWidths, z3 = ht.lines;
      }
    } else
      z3 = i.split(`
`);
    for (var bt = 0; bt < z3.length; bt++) {
      var _t = z3[bt], Et = new Rcr();
      if (Et.styleName = v4, Et.text = _t, Et.isLineHolder = !_t && !_, typeof M2.width == "number" ? Et.width = M2.width : Et.width = H2 ? H2[bt] : $T(_t, P2), !bt && !N3) {
        var zt = (I2[I2.length - 1] || (I2[0] = new $6e())).tokens, Ft = zt.length;
        Ft === 1 && zt[0].isLineHolder ? zt[0] = Et : (_t || !Ft || _) && zt.push(Et);
      } else
        I2.push(new $6e([Et]));
    }
  }
  function Vcr(f2) {
    var i = f2.charCodeAt(0);
    return i >= 33 && i <= 383;
  }
  var Bcr = zL(",&?/;] ".split(""), function(f2, i) {
    return f2[i] = true, f2;
  }, {});
  function zcr(f2) {
    return Vcr(f2) ? !!Bcr[f2] : true;
  }
  function qze(f2, i, t2, h, v4) {
    for (var _ = [], M2 = [], I2 = "", P2 = "", N3 = 0, z3 = 0, H2 = 0; H2 < f2.length; H2++) {
      var $ = f2.charAt(H2);
      if ($ === `
`) {
        P2 && (I2 += P2, z3 += N3), _.push(I2), M2.push(z3), I2 = "", P2 = "", N3 = 0, z3 = 0;
        continue;
      }
      var et = $T($, i), at = h ? false : !zcr($);
      if (_.length ? z3 + et > t2 : v4 + z3 + et > t2) {
        z3 ? (I2 || P2) && (at ? (I2 || (I2 = P2, P2 = "", N3 = 0, z3 = N3), _.push(I2), M2.push(z3 - N3), P2 += $, N3 += et, I2 = "", z3 = N3) : (P2 && (I2 += P2, P2 = "", N3 = 0), _.push(I2), M2.push(z3), I2 = $, z3 = et)) : at ? (_.push(P2), M2.push(N3), P2 = $, N3 = et) : (_.push($), M2.push(et));
        continue;
      }
      z3 += et, at ? (P2 += $, N3 += et) : (P2 && (I2 += P2, P2 = "", N3 = 0), I2 += $);
    }
    return !_.length && !I2 && (I2 = f2, P2 = "", N3 = 0), P2 && (I2 += P2), I2 && (_.push(I2), M2.push(z3)), _.length === 1 && (z3 += v4), { accumWidth: z3, lines: _, linesWidths: M2 };
  }
  var FJt = "__zr_style_" + Math.round(Math.random() * 10), sU = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, pkt = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
  sU[FJt] = true;
  var Y6e = ["z", "z2", "invisible"], jcr = ["invisible"], Wcr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype._init = function(t2) {
      for (var h = Of2(t2), v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4];
        _ === "style" ? this.useStyle(t2[_]) : f2.prototype.attrKV.call(this, _, t2[_]);
      }
      this.style || this.useStyle({});
    }, i.prototype.beforeBrush = function() {
    }, i.prototype.afterBrush = function() {
    }, i.prototype.innerBeforeBrush = function() {
    }, i.prototype.innerAfterBrush = function() {
    }, i.prototype.shouldBePainted = function(t2, h, v4, _) {
      var M2 = this.transform;
      if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && Gcr(this, t2, h) || M2 && !M2[0] && !M2[3])
        return false;
      if (v4 && this.__clipPaths) {
        for (var I2 = 0; I2 < this.__clipPaths.length; ++I2)
          if (this.__clipPaths[I2].isZeroArea())
            return false;
      }
      if (_ && this.parent)
        for (var P2 = this.parent; P2; ) {
          if (P2.ignore)
            return false;
          P2 = P2.parent;
        }
      return true;
    }, i.prototype.contain = function(t2, h) {
      return this.rectContain(t2, h);
    }, i.prototype.traverse = function(t2, h) {
      t2.call(h, this);
    }, i.prototype.rectContain = function(t2, h) {
      var v4 = this.transformCoordToLocal(t2, h), _ = this.getBoundingRect();
      return _.contain(v4[0], v4[1]);
    }, i.prototype.getPaintRect = function() {
      var t2 = this._paintRect;
      if (!this._paintRect || this.__dirty) {
        var h = this.transform, v4 = this.getBoundingRect(), _ = this.style, M2 = _.shadowBlur || 0, I2 = _.shadowOffsetX || 0, P2 = _.shadowOffsetY || 0;
        t2 = this._paintRect || (this._paintRect = new Lc2(0, 0, 0, 0)), h ? Lc2.applyTransform(t2, v4, h) : t2.copy(v4), (M2 || I2 || P2) && (t2.width += M2 * 2 + Math.abs(I2), t2.height += M2 * 2 + Math.abs(P2), t2.x = Math.min(t2.x, t2.x + I2 - M2), t2.y = Math.min(t2.y, t2.y + P2 - M2));
        var N3 = this.dirtyRectTolerance;
        t2.isZero() || (t2.x = Math.floor(t2.x - N3), t2.y = Math.floor(t2.y - N3), t2.width = Math.ceil(t2.width + 1 + N3 * 2), t2.height = Math.ceil(t2.height + 1 + N3 * 2));
      }
      return t2;
    }, i.prototype.setPrevPaintRect = function(t2) {
      t2 ? (this._prevPaintRect = this._prevPaintRect || new Lc2(0, 0, 0, 0), this._prevPaintRect.copy(t2)) : this._prevPaintRect = null;
    }, i.prototype.getPrevPaintRect = function() {
      return this._prevPaintRect;
    }, i.prototype.animateStyle = function(t2) {
      return this.animate("style", t2);
    }, i.prototype.updateDuringAnimation = function(t2) {
      t2 === "style" ? this.dirtyStyle() : this.markRedraw();
    }, i.prototype.attrKV = function(t2, h) {
      t2 !== "style" ? f2.prototype.attrKV.call(this, t2, h) : this.style ? this.setStyle(h) : this.useStyle(h);
    }, i.prototype.setStyle = function(t2, h) {
      return typeof t2 == "string" ? this.style[t2] = h : ba2(this.style, t2), this.dirtyStyle(), this;
    }, i.prototype.dirtyStyle = function(t2) {
      t2 || this.markRedraw(), this.__dirty |= ddt, this._rect && (this._rect = null);
    }, i.prototype.dirty = function() {
      this.dirtyStyle();
    }, i.prototype.styleChanged = function() {
      return !!(this.__dirty & ddt);
    }, i.prototype.styleUpdated = function() {
      this.__dirty &= ~ddt;
    }, i.prototype.createStyle = function(t2) {
      return skt(sU, t2);
    }, i.prototype.useStyle = function(t2) {
      t2[FJt] || (t2 = this.createStyle(t2)), this.__inHover ? this.__hoverStyle = t2 : this.style = t2, this.dirtyStyle();
    }, i.prototype.isStyleObject = function(t2) {
      return t2[FJt];
    }, i.prototype._innerSaveToNormal = function(t2) {
      f2.prototype._innerSaveToNormal.call(this, t2);
      var h = this._normalState;
      t2.style && !h.style && (h.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(t2, h, Y6e);
    }, i.prototype._applyStateObj = function(t2, h, v4, _, M2, I2) {
      f2.prototype._applyStateObj.call(this, t2, h, v4, _, M2, I2);
      var P2 = !(h && _), N3;
      if (h && h.style ? M2 ? _ ? N3 = h.style : (N3 = this._mergeStyle(this.createStyle(), v4.style), this._mergeStyle(N3, h.style)) : (N3 = this._mergeStyle(this.createStyle(), _ ? this.style : v4.style), this._mergeStyle(N3, h.style)) : P2 && (N3 = v4.style), N3)
        if (M2) {
          var z3 = this.style;
          if (this.style = this.createStyle(P2 ? {} : z3), P2)
            for (var H2 = Of2(z3), $ = 0; $ < H2.length; $++) {
              var et = H2[$];
              et in N3 && (N3[et] = N3[et], this.style[et] = z3[et]);
            }
          for (var at = Of2(N3), $ = 0; $ < at.length; $++) {
            var et = at[$];
            this.style[et] = this.style[et];
          }
          this._transitionState(t2, { style: N3 }, I2, this.getAnimationStyleProps());
        } else
          this.useStyle(N3);
      for (var ht = this.__inHover ? jcr : Y6e, $ = 0; $ < ht.length; $++) {
        var et = ht[$];
        h && h[et] != null ? this[et] = h[et] : P2 && v4[et] != null && (this[et] = v4[et]);
      }
    }, i.prototype._mergeStates = function(t2) {
      for (var h = f2.prototype._mergeStates.call(this, t2), v4, _ = 0; _ < t2.length; _++) {
        var M2 = t2[_];
        M2.style && (v4 = v4 || {}, this._mergeStyle(v4, M2.style));
      }
      return v4 && (h.style = v4), h;
    }, i.prototype._mergeStyle = function(t2, h) {
      return ba2(t2, h), t2;
    }, i.prototype.getAnimationStyleProps = function() {
      return pkt;
    }, i.initDefaultProps = function() {
      var t2 = i.prototype;
      t2.type = "displayable", t2.invisible = false, t2.z = 0, t2.z2 = 0, t2.zlevel = 0, t2.culling = false, t2.cursor = "pointer", t2.rectHover = false, t2.incremental = false, t2._rect = null, t2.dirtyRectTolerance = 0, t2.__dirty = UT | ddt;
    }(), i;
  }(Tze), nXt = new Lc2(0, 0, 0, 0), rXt = new Lc2(0, 0, 0, 0);
  function Gcr(f2, i, t2) {
    return nXt.copy(f2.getBoundingRect()), f2.transform && nXt.applyTransform(f2.transform), rXt.width = i, rXt.height = t2, !nXt.intersect(rXt);
  }
  var rE = Wcr, tC = Math.min, eC = Math.max, iXt = Math.sin, aXt = Math.cos, SH = Math.PI * 2, BIt = wU(), zIt = wU(), jIt = wU();
  function dkt(f2, i, t2) {
    if (f2.length !== 0) {
      for (var h = f2[0], v4 = h[0], _ = h[0], M2 = h[1], I2 = h[1], P2 = 1; P2 < f2.length; P2++)
        h = f2[P2], v4 = tC(v4, h[0]), _ = eC(_, h[0]), M2 = tC(M2, h[1]), I2 = eC(I2, h[1]);
      i[0] = v4, i[1] = M2, t2[0] = _, t2[1] = I2;
    }
  }
  function K6e(f2, i, t2, h, v4, _) {
    v4[0] = tC(f2, t2), v4[1] = tC(i, h), _[0] = eC(f2, t2), _[1] = eC(i, h);
  }
  var X6e = [], Q6e = [];
  function Hcr(f2, i, t2, h, v4, _, M2, I2, P2, N3) {
    var z3 = cze, H2 = fb2, $ = z3(f2, t2, v4, M2, X6e);
    P2[0] = 1 / 0, P2[1] = 1 / 0, N3[0] = -1 / 0, N3[1] = -1 / 0;
    for (var et = 0; et < $; et++) {
      var at = H2(f2, t2, v4, M2, X6e[et]);
      P2[0] = tC(at, P2[0]), N3[0] = eC(at, N3[0]);
    }
    $ = z3(i, h, _, I2, Q6e);
    for (var et = 0; et < $; et++) {
      var ht = H2(i, h, _, I2, Q6e[et]);
      P2[1] = tC(ht, P2[1]), N3[1] = eC(ht, N3[1]);
    }
    P2[0] = tC(f2, P2[0]), N3[0] = eC(f2, N3[0]), P2[0] = tC(M2, P2[0]), N3[0] = eC(M2, N3[0]), P2[1] = tC(i, P2[1]), N3[1] = eC(i, N3[1]), P2[1] = tC(I2, P2[1]), N3[1] = eC(I2, N3[1]);
  }
  function Ucr(f2, i, t2, h, v4, _, M2, I2) {
    var P2 = hze, N3 = v_, z3 = eC(tC(P2(f2, t2, v4), 1), 0), H2 = eC(tC(P2(i, h, _), 1), 0), $ = N3(f2, t2, v4, z3), et = N3(i, h, _, H2);
    M2[0] = tC(f2, v4, $), M2[1] = tC(i, _, et), I2[0] = eC(f2, v4, $), I2[1] = eC(i, _, et);
  }
  function qcr(f2, i, t2, h, v4, _, M2, I2, P2) {
    var N3 = N7, z3 = F7, H2 = Math.abs(v4 - _);
    if (H2 % SH < 1e-4 && H2 > 1e-4) {
      I2[0] = f2 - t2, I2[1] = i - h, P2[0] = f2 + t2, P2[1] = i + h;
      return;
    }
    if (BIt[0] = aXt(v4) * t2 + f2, BIt[1] = iXt(v4) * h + i, zIt[0] = aXt(_) * t2 + f2, zIt[1] = iXt(_) * h + i, N3(I2, BIt, zIt), z3(P2, BIt, zIt), v4 = v4 % SH, v4 < 0 && (v4 = v4 + SH), _ = _ % SH, _ < 0 && (_ = _ + SH), v4 > _ && !M2 ? _ += SH : v4 < _ && M2 && (v4 += SH), M2) {
      var $ = _;
      _ = v4, v4 = $;
    }
    for (var et = 0; et < _; et += Math.PI / 2)
      et > v4 && (jIt[0] = aXt(et) * t2 + f2, jIt[1] = iXt(et) * h + i, N3(I2, jIt, I2), z3(P2, jIt, P2));
  }
  var og2 = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, MH = [], CH = [], wL = [], S7 = [], SL = [], ML = [], oXt = Math.min, sXt = Math.max, TH = Math.cos, AH = Math.sin, F6 = Math.abs, VJt = Math.PI, k7 = VJt * 2, lXt = typeof Float32Array != "undefined", jpt = [];
  function uXt(f2) {
    var i = Math.round(f2 / VJt * 1e8) / 1e8;
    return i % 2 * VJt;
  }
  function Zcr(f2, i) {
    var t2 = uXt(f2[0]);
    t2 < 0 && (t2 += k7);
    var h = t2 - f2[0], v4 = f2[1];
    v4 += h, !i && v4 - t2 >= k7 ? v4 = t2 + k7 : i && t2 - v4 >= k7 ? v4 = t2 - k7 : !i && t2 > v4 ? v4 = t2 + (k7 - uXt(t2 - v4)) : i && t2 < v4 && (v4 = t2 - (k7 - uXt(v4 - t2))), f2[0] = t2, f2[1] = v4;
  }
  var $cr = function() {
    function f2(i) {
      this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, i && (this._saveData = false), this._saveData && (this.data = []);
    }
    return f2.prototype.increaseVersion = function() {
      this._version++;
    }, f2.prototype.getVersion = function() {
      return this._version;
    }, f2.prototype.setScale = function(i, t2, h) {
      h = h || 0, h > 0 && (this._ux = F6(h / hEt / i) || 0, this._uy = F6(h / hEt / t2) || 0);
    }, f2.prototype.setDPR = function(i) {
      this.dpr = i;
    }, f2.prototype.setContext = function(i) {
      this._ctx = i;
    }, f2.prototype.getContext = function() {
      return this._ctx;
    }, f2.prototype.beginPath = function() {
      return this._ctx && this._ctx.beginPath(), this.reset(), this;
    }, f2.prototype.reset = function() {
      this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
    }, f2.prototype.moveTo = function(i, t2) {
      return this._drawPendingPt(), this.addData(og2.M, i, t2), this._ctx && this._ctx.moveTo(i, t2), this._x0 = i, this._y0 = t2, this._xi = i, this._yi = t2, this;
    }, f2.prototype.lineTo = function(i, t2) {
      var h = F6(i - this._xi), v4 = F6(t2 - this._yi), _ = h > this._ux || v4 > this._uy;
      if (this.addData(og2.L, i, t2), this._ctx && _ && this._ctx.lineTo(i, t2), _)
        this._xi = i, this._yi = t2, this._pendingPtDist = 0;
      else {
        var M2 = h * h + v4 * v4;
        M2 > this._pendingPtDist && (this._pendingPtX = i, this._pendingPtY = t2, this._pendingPtDist = M2);
      }
      return this;
    }, f2.prototype.bezierCurveTo = function(i, t2, h, v4, _, M2) {
      return this._drawPendingPt(), this.addData(og2.C, i, t2, h, v4, _, M2), this._ctx && this._ctx.bezierCurveTo(i, t2, h, v4, _, M2), this._xi = _, this._yi = M2, this;
    }, f2.prototype.quadraticCurveTo = function(i, t2, h, v4) {
      return this._drawPendingPt(), this.addData(og2.Q, i, t2, h, v4), this._ctx && this._ctx.quadraticCurveTo(i, t2, h, v4), this._xi = h, this._yi = v4, this;
    }, f2.prototype.arc = function(i, t2, h, v4, _, M2) {
      this._drawPendingPt(), jpt[0] = v4, jpt[1] = _, Zcr(jpt, M2), v4 = jpt[0], _ = jpt[1];
      var I2 = _ - v4;
      return this.addData(og2.A, i, t2, h, h, v4, I2, 0, M2 ? 0 : 1), this._ctx && this._ctx.arc(i, t2, h, v4, _, M2), this._xi = TH(_) * h + i, this._yi = AH(_) * h + t2, this;
    }, f2.prototype.arcTo = function(i, t2, h, v4, _) {
      return this._drawPendingPt(), this._ctx && this._ctx.arcTo(i, t2, h, v4, _), this;
    }, f2.prototype.rect = function(i, t2, h, v4) {
      return this._drawPendingPt(), this._ctx && this._ctx.rect(i, t2, h, v4), this.addData(og2.R, i, t2, h, v4), this;
    }, f2.prototype.closePath = function() {
      this._drawPendingPt(), this.addData(og2.Z);
      var i = this._ctx, t2 = this._x0, h = this._y0;
      return i && i.closePath(), this._xi = t2, this._yi = h, this;
    }, f2.prototype.fill = function(i) {
      i && i.fill(), this.toStatic();
    }, f2.prototype.stroke = function(i) {
      i && i.stroke(), this.toStatic();
    }, f2.prototype.len = function() {
      return this._len;
    }, f2.prototype.setData = function(i) {
      var t2 = i.length;
      !(this.data && this.data.length === t2) && lXt && (this.data = new Float32Array(t2));
      for (var h = 0; h < t2; h++)
        this.data[h] = i[h];
      this._len = t2;
    }, f2.prototype.appendPath = function(i) {
      i instanceof Array || (i = [i]);
      for (var t2 = i.length, h = 0, v4 = this._len, _ = 0; _ < t2; _++)
        h += i[_].len();
      lXt && this.data instanceof Float32Array && (this.data = new Float32Array(v4 + h));
      for (var _ = 0; _ < t2; _++)
        for (var M2 = i[_].data, I2 = 0; I2 < M2.length; I2++)
          this.data[v4++] = M2[I2];
      this._len = v4;
    }, f2.prototype.addData = function(i, t2, h, v4, _, M2, I2, P2, N3) {
      if (!!this._saveData) {
        var z3 = this.data;
        this._len + arguments.length > z3.length && (this._expandData(), z3 = this.data);
        for (var H2 = 0; H2 < arguments.length; H2++)
          z3[this._len++] = arguments[H2];
      }
    }, f2.prototype._drawPendingPt = function() {
      this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
    }, f2.prototype._expandData = function() {
      if (!(this.data instanceof Array)) {
        for (var i = [], t2 = 0; t2 < this._len; t2++)
          i[t2] = this.data[t2];
        this.data = i;
      }
    }, f2.prototype.toStatic = function() {
      if (!!this._saveData) {
        this._drawPendingPt();
        var i = this.data;
        i instanceof Array && (i.length = this._len, lXt && this._len > 11 && (this.data = new Float32Array(i)));
      }
    }, f2.prototype.getBoundingRect = function() {
      wL[0] = wL[1] = SL[0] = SL[1] = Number.MAX_VALUE, S7[0] = S7[1] = ML[0] = ML[1] = -Number.MAX_VALUE;
      var i = this.data, t2 = 0, h = 0, v4 = 0, _ = 0, M2;
      for (M2 = 0; M2 < this._len; ) {
        var I2 = i[M2++], P2 = M2 === 1;
        switch (P2 && (t2 = i[M2], h = i[M2 + 1], v4 = t2, _ = h), I2) {
          case og2.M:
            t2 = v4 = i[M2++], h = _ = i[M2++], SL[0] = v4, SL[1] = _, ML[0] = v4, ML[1] = _;
            break;
          case og2.L:
            K6e(t2, h, i[M2], i[M2 + 1], SL, ML), t2 = i[M2++], h = i[M2++];
            break;
          case og2.C:
            Hcr(t2, h, i[M2++], i[M2++], i[M2++], i[M2++], i[M2], i[M2 + 1], SL, ML), t2 = i[M2++], h = i[M2++];
            break;
          case og2.Q:
            Ucr(t2, h, i[M2++], i[M2++], i[M2], i[M2 + 1], SL, ML), t2 = i[M2++], h = i[M2++];
            break;
          case og2.A:
            var N3 = i[M2++], z3 = i[M2++], H2 = i[M2++], $ = i[M2++], et = i[M2++], at = i[M2++] + et;
            M2 += 1;
            var ht = !i[M2++];
            P2 && (v4 = TH(et) * H2 + N3, _ = AH(et) * $ + z3), qcr(N3, z3, H2, $, et, at, ht, SL, ML), t2 = TH(at) * H2 + N3, h = AH(at) * $ + z3;
            break;
          case og2.R:
            v4 = t2 = i[M2++], _ = h = i[M2++];
            var bt = i[M2++], _t = i[M2++];
            K6e(v4, _, v4 + bt, _ + _t, SL, ML);
            break;
          case og2.Z:
            t2 = v4, h = _;
            break;
        }
        N7(wL, wL, SL), F7(S7, S7, ML);
      }
      return M2 === 0 && (wL[0] = wL[1] = S7[0] = S7[1] = 0), new Lc2(wL[0], wL[1], S7[0] - wL[0], S7[1] - wL[1]);
    }, f2.prototype._calculateLength = function() {
      var i = this.data, t2 = this._len, h = this._ux, v4 = this._uy, _ = 0, M2 = 0, I2 = 0, P2 = 0;
      this._pathSegLen || (this._pathSegLen = []);
      for (var N3 = this._pathSegLen, z3 = 0, H2 = 0, $ = 0; $ < t2; ) {
        var et = i[$++], at = $ === 1;
        at && (_ = i[$], M2 = i[$ + 1], I2 = _, P2 = M2);
        var ht = -1;
        switch (et) {
          case og2.M:
            _ = I2 = i[$++], M2 = P2 = i[$++];
            break;
          case og2.L: {
            var bt = i[$++], _t = i[$++], Et = bt - _, zt = _t - M2;
            (F6(Et) > h || F6(zt) > v4 || $ === t2 - 1) && (ht = Math.sqrt(Et * Et + zt * zt), _ = bt, M2 = _t);
            break;
          }
          case og2.C: {
            var Ft = i[$++], fe2 = i[$++], bt = i[$++], _t = i[$++], re2 = i[$++], ye = i[$++];
            ht = rur(_, M2, Ft, fe2, bt, _t, re2, ye, 10), _ = re2, M2 = ye;
            break;
          }
          case og2.Q: {
            var Ft = i[$++], fe2 = i[$++], bt = i[$++], _t = i[$++];
            ht = aur(_, M2, Ft, fe2, bt, _t, 10), _ = bt, M2 = _t;
            break;
          }
          case og2.A:
            var me2 = i[$++], be2 = i[$++], Te2 = i[$++], We = i[$++], en = i[$++], Ue2 = i[$++], Mn = Ue2 + en;
            $ += 1, i[$++], at && (I2 = TH(en) * Te2 + me2, P2 = AH(en) * We + be2), ht = sXt(Te2, We) * oXt(k7, Math.abs(Ue2)), _ = TH(Mn) * Te2 + me2, M2 = AH(Mn) * We + be2;
            break;
          case og2.R: {
            I2 = _ = i[$++], P2 = M2 = i[$++];
            var Vn = i[$++], xn = i[$++];
            ht = Vn * 2 + xn * 2;
            break;
          }
          case og2.Z: {
            var Et = I2 - _, zt = P2 - M2;
            ht = Math.sqrt(Et * Et + zt * zt), _ = I2, M2 = P2;
            break;
          }
        }
        ht >= 0 && (N3[H2++] = ht, z3 += ht);
      }
      return this._pathLen = z3, z3;
    }, f2.prototype.rebuildPath = function(i, t2) {
      var h = this.data, v4 = this._ux, _ = this._uy, M2 = this._len, I2, P2, N3, z3, H2, $, et = t2 < 1, at, ht, bt = 0, _t = 0, Et, zt = 0, Ft, fe2;
      if (et && (this._pathSegLen || this._calculateLength(), at = this._pathSegLen, ht = this._pathLen, Et = t2 * ht, !Et))
        return;
      t:
        for (var re2 = 0; re2 < M2; ) {
          var ye = h[re2++], me2 = re2 === 1;
          switch (me2 && (N3 = h[re2], z3 = h[re2 + 1], I2 = N3, P2 = z3), ye !== og2.L && zt > 0 && (i.lineTo(Ft, fe2), zt = 0), ye) {
            case og2.M:
              I2 = N3 = h[re2++], P2 = z3 = h[re2++], i.moveTo(N3, z3);
              break;
            case og2.L: {
              H2 = h[re2++], $ = h[re2++];
              var be2 = F6(H2 - N3), Te2 = F6($ - z3);
              if (be2 > v4 || Te2 > _) {
                if (et) {
                  var We = at[_t++];
                  if (bt + We > Et) {
                    var en = (Et - bt) / We;
                    i.lineTo(N3 * (1 - en) + H2 * en, z3 * (1 - en) + $ * en);
                    break t;
                  }
                  bt += We;
                }
                i.lineTo(H2, $), N3 = H2, z3 = $, zt = 0;
              } else {
                var Ue2 = be2 * be2 + Te2 * Te2;
                Ue2 > zt && (Ft = H2, fe2 = $, zt = Ue2);
              }
              break;
            }
            case og2.C: {
              var Mn = h[re2++], Vn = h[re2++], xn = h[re2++], Zr = h[re2++], nr = h[re2++], pr = h[re2++];
              if (et) {
                var We = at[_t++];
                if (bt + We > Et) {
                  var en = (Et - bt) / We;
                  X7(N3, Mn, xn, nr, en, MH), X7(z3, Vn, Zr, pr, en, CH), i.bezierCurveTo(MH[1], CH[1], MH[2], CH[2], MH[3], CH[3]);
                  break t;
                }
                bt += We;
              }
              i.bezierCurveTo(Mn, Vn, xn, Zr, nr, pr), N3 = nr, z3 = pr;
              break;
            }
            case og2.Q: {
              var Mn = h[re2++], Vn = h[re2++], xn = h[re2++], Zr = h[re2++];
              if (et) {
                var We = at[_t++];
                if (bt + We > Et) {
                  var en = (Et - bt) / We;
                  $dt(N3, Mn, xn, en, MH), $dt(z3, Vn, Zr, en, CH), i.quadraticCurveTo(MH[1], CH[1], MH[2], CH[2]);
                  break t;
                }
                bt += We;
              }
              i.quadraticCurveTo(Mn, Vn, xn, Zr), N3 = xn, z3 = Zr;
              break;
            }
            case og2.A:
              var Nr = h[re2++], ai2 = h[re2++], gi2 = h[re2++], To = h[re2++], us = h[re2++], ml = h[re2++], ll = h[re2++], Rs = !h[re2++], es = gi2 > To ? gi2 : To, Ws = F6(gi2 - To) > 1e-3, il = us + ml, bs = false;
              if (et) {
                var We = at[_t++];
                bt + We > Et && (il = us + ml * (Et - bt) / We, bs = true), bt += We;
              }
              if (Ws && i.ellipse ? i.ellipse(Nr, ai2, gi2, To, ll, us, il, Rs) : i.arc(Nr, ai2, es, us, il, Rs), bs)
                break t;
              me2 && (I2 = TH(us) * gi2 + Nr, P2 = AH(us) * To + ai2), N3 = TH(il) * gi2 + Nr, z3 = AH(il) * To + ai2;
              break;
            case og2.R:
              I2 = N3 = h[re2], P2 = z3 = h[re2 + 1], H2 = h[re2++], $ = h[re2++];
              var Rl = h[re2++], Mh2 = h[re2++];
              if (et) {
                var We = at[_t++];
                if (bt + We > Et) {
                  var au = Et - bt;
                  i.moveTo(H2, $), i.lineTo(H2 + oXt(au, Rl), $), au -= Rl, au > 0 && i.lineTo(H2 + Rl, $ + oXt(au, Mh2)), au -= Mh2, au > 0 && i.lineTo(H2 + sXt(Rl - au, 0), $ + Mh2), au -= Rl, au > 0 && i.lineTo(H2, $ + sXt(Mh2 - au, 0));
                  break t;
                }
                bt += We;
              }
              i.rect(H2, $, Rl, Mh2);
              break;
            case og2.Z:
              if (et) {
                var We = at[_t++];
                if (bt + We > Et) {
                  var en = (Et - bt) / We;
                  i.lineTo(N3 * (1 - en) + I2 * en, z3 * (1 - en) + P2 * en);
                  break t;
                }
                bt += We;
              }
              i.closePath(), N3 = I2, z3 = P2;
          }
        }
    }, f2.prototype.clone = function() {
      var i = new f2(), t2 = this.data;
      return i.data = t2.slice ? t2.slice() : Array.prototype.slice.call(t2), i._len = this._len, i;
    }, f2.CMD = og2, f2.initDefaultProps = function() {
      var i = f2.prototype;
      i._saveData = true, i._ux = 0, i._uy = 0, i._pendingPtDist = 0, i._version = 0;
    }(), f2;
  }(), HL = $cr;
  function L7(f2, i, t2, h, v4, _, M2) {
    if (v4 === 0)
      return false;
    var I2 = v4, P2 = 0, N3 = f2;
    if (M2 > i + I2 && M2 > h + I2 || M2 < i - I2 && M2 < h - I2 || _ > f2 + I2 && _ > t2 + I2 || _ < f2 - I2 && _ < t2 - I2)
      return false;
    if (f2 !== t2)
      P2 = (i - h) / (f2 - t2), N3 = (f2 * h - t2 * i) / (f2 - t2);
    else
      return Math.abs(_ - f2) <= I2 / 2;
    var z3 = P2 * _ - M2 + N3, H2 = z3 * z3 / (P2 * P2 + 1);
    return H2 <= I2 / 2 * I2 / 2;
  }
  function Ycr(f2, i, t2, h, v4, _, M2, I2, P2, N3, z3) {
    if (P2 === 0)
      return false;
    var H2 = P2;
    if (z3 > i + H2 && z3 > h + H2 && z3 > _ + H2 && z3 > I2 + H2 || z3 < i - H2 && z3 < h - H2 && z3 < _ - H2 && z3 < I2 - H2 || N3 > f2 + H2 && N3 > t2 + H2 && N3 > v4 + H2 && N3 > M2 + H2 || N3 < f2 - H2 && N3 < t2 - H2 && N3 < v4 - H2 && N3 < M2 - H2)
      return false;
    var $ = fze(f2, i, t2, h, v4, _, M2, I2, N3, z3, null);
    return $ <= H2 / 2;
  }
  function Zze(f2, i, t2, h, v4, _, M2, I2, P2) {
    if (M2 === 0)
      return false;
    var N3 = M2;
    if (P2 > i + N3 && P2 > h + N3 && P2 > _ + N3 || P2 < i - N3 && P2 < h - N3 && P2 < _ - N3 || I2 > f2 + N3 && I2 > t2 + N3 && I2 > v4 + N3 || I2 < f2 - N3 && I2 < t2 - N3 && I2 < v4 - N3)
      return false;
    var z3 = pze(f2, i, t2, h, v4, _, I2, P2, null);
    return z3 <= N3 / 2;
  }
  var J6e = Math.PI * 2;
  function j7(f2) {
    return f2 %= J6e, f2 < 0 && (f2 += J6e), f2;
  }
  var Wpt = Math.PI * 2;
  function Kcr(f2, i, t2, h, v4, _, M2, I2, P2) {
    if (M2 === 0)
      return false;
    var N3 = M2;
    I2 -= f2, P2 -= i;
    var z3 = Math.sqrt(I2 * I2 + P2 * P2);
    if (z3 - N3 > t2 || z3 + N3 < t2)
      return false;
    if (Math.abs(h - v4) % Wpt < 1e-4)
      return true;
    if (_) {
      var H2 = h;
      h = j7(v4), v4 = j7(H2);
    } else
      h = j7(h), v4 = j7(v4);
    h > v4 && (v4 += Wpt);
    var $ = Math.atan2(P2, I2);
    return $ < 0 && ($ += Wpt), $ >= h && $ <= v4 || $ + Wpt >= h && $ + Wpt <= v4;
  }
  function W6(f2, i, t2, h, v4, _) {
    if (_ > i && _ > h || _ < i && _ < h || h === i)
      return 0;
    var M2 = (_ - i) / (h - i), I2 = h < i ? 1 : -1;
    (M2 === 1 || M2 === 0) && (I2 = h < i ? 0.5 : -0.5);
    var P2 = M2 * (t2 - f2) + f2;
    return P2 === v4 ? 1 / 0 : P2 > v4 ? I2 : 0;
  }
  var M7 = HL.CMD, IH = Math.PI * 2, Xcr = 1e-4;
  function Qcr(f2, i) {
    return Math.abs(f2 - i) < Xcr;
  }
  var F2 = [-1, -1, -1], UD = [-1, -1];
  function Jcr() {
    var f2 = UD[0];
    UD[0] = UD[1], UD[1] = f2;
  }
  function tfr(f2, i, t2, h, v4, _, M2, I2, P2, N3) {
    if (N3 > i && N3 > h && N3 > _ && N3 > I2 || N3 < i && N3 < h && N3 < _ && N3 < I2)
      return 0;
    var z3 = lEt(i, h, _, I2, N3, F2);
    if (z3 === 0)
      return 0;
    for (var H2 = 0, $ = -1, et = void 0, at = void 0, ht = 0; ht < z3; ht++) {
      var bt = F2[ht], _t = bt === 0 || bt === 1 ? 0.5 : 1, Et = fb2(f2, t2, v4, M2, bt);
      Et < P2 || ($ < 0 && ($ = cze(i, h, _, I2, UD), UD[1] < UD[0] && $ > 1 && Jcr(), et = fb2(i, h, _, I2, UD[0]), $ > 1 && (at = fb2(i, h, _, I2, UD[1]))), $ === 2 ? bt < UD[0] ? H2 += et < i ? _t : -_t : bt < UD[1] ? H2 += at < et ? _t : -_t : H2 += I2 < at ? _t : -_t : bt < UD[0] ? H2 += et < i ? _t : -_t : H2 += I2 < et ? _t : -_t);
    }
    return H2;
  }
  function efr(f2, i, t2, h, v4, _, M2, I2) {
    if (I2 > i && I2 > h && I2 > _ || I2 < i && I2 < h && I2 < _)
      return 0;
    var P2 = iur(i, h, _, I2, F2);
    if (P2 === 0)
      return 0;
    var N3 = hze(i, h, _);
    if (N3 >= 0 && N3 <= 1) {
      for (var z3 = 0, H2 = v_(i, h, _, N3), $ = 0; $ < P2; $++) {
        var et = F2[$] === 0 || F2[$] === 1 ? 0.5 : 1, at = v_(f2, t2, v4, F2[$]);
        at < M2 || (F2[$] < N3 ? z3 += H2 < i ? et : -et : z3 += _ < H2 ? et : -et);
      }
      return z3;
    } else {
      var et = F2[0] === 0 || F2[0] === 1 ? 0.5 : 1, at = v_(f2, t2, v4, F2[0]);
      return at < M2 ? 0 : _ < i ? et : -et;
    }
  }
  function nfr(f2, i, t2, h, v4, _, M2, I2) {
    if (I2 -= i, I2 > t2 || I2 < -t2)
      return 0;
    var P2 = Math.sqrt(t2 * t2 - I2 * I2);
    F2[0] = -P2, F2[1] = P2;
    var N3 = Math.abs(h - v4);
    if (N3 < 1e-4)
      return 0;
    if (N3 >= IH - 1e-4) {
      h = 0, v4 = IH;
      var z3 = _ ? 1 : -1;
      return M2 >= F2[0] + f2 && M2 <= F2[1] + f2 ? z3 : 0;
    }
    if (h > v4) {
      var H2 = h;
      h = v4, v4 = H2;
    }
    h < 0 && (h += IH, v4 += IH);
    for (var $ = 0, et = 0; et < 2; et++) {
      var at = F2[et];
      if (at + f2 > M2) {
        var ht = Math.atan2(I2, at), z3 = _ ? 1 : -1;
        ht < 0 && (ht = IH + ht), (ht >= h && ht <= v4 || ht + IH >= h && ht + IH <= v4) && (ht > Math.PI / 2 && ht < Math.PI * 1.5 && (z3 = -z3), $ += z3);
      }
    }
    return $;
  }
  function $ze(f2, i, t2, h, v4) {
    for (var _ = f2.data, M2 = f2.len(), I2 = 0, P2 = 0, N3 = 0, z3 = 0, H2 = 0, $, et, at = 0; at < M2; ) {
      var ht = _[at++], bt = at === 1;
      switch (ht === M7.M && at > 1 && (t2 || (I2 += W6(P2, N3, z3, H2, h, v4))), bt && (P2 = _[at], N3 = _[at + 1], z3 = P2, H2 = N3), ht) {
        case M7.M:
          z3 = _[at++], H2 = _[at++], P2 = z3, N3 = H2;
          break;
        case M7.L:
          if (t2) {
            if (L7(P2, N3, _[at], _[at + 1], i, h, v4))
              return true;
          } else
            I2 += W6(P2, N3, _[at], _[at + 1], h, v4) || 0;
          P2 = _[at++], N3 = _[at++];
          break;
        case M7.C:
          if (t2) {
            if (Ycr(P2, N3, _[at++], _[at++], _[at++], _[at++], _[at], _[at + 1], i, h, v4))
              return true;
          } else
            I2 += tfr(P2, N3, _[at++], _[at++], _[at++], _[at++], _[at], _[at + 1], h, v4) || 0;
          P2 = _[at++], N3 = _[at++];
          break;
        case M7.Q:
          if (t2) {
            if (Zze(P2, N3, _[at++], _[at++], _[at], _[at + 1], i, h, v4))
              return true;
          } else
            I2 += efr(P2, N3, _[at++], _[at++], _[at], _[at + 1], h, v4) || 0;
          P2 = _[at++], N3 = _[at++];
          break;
        case M7.A:
          var _t = _[at++], Et = _[at++], zt = _[at++], Ft = _[at++], fe2 = _[at++], re2 = _[at++];
          at += 1;
          var ye = !!(1 - _[at++]);
          $ = Math.cos(fe2) * zt + _t, et = Math.sin(fe2) * Ft + Et, bt ? (z3 = $, H2 = et) : I2 += W6(P2, N3, $, et, h, v4);
          var me2 = (h - _t) * Ft / zt + _t;
          if (t2) {
            if (Kcr(_t, Et, Ft, fe2, fe2 + re2, ye, i, me2, v4))
              return true;
          } else
            I2 += nfr(_t, Et, Ft, fe2, fe2 + re2, ye, me2, v4);
          P2 = Math.cos(fe2 + re2) * zt + _t, N3 = Math.sin(fe2 + re2) * Ft + Et;
          break;
        case M7.R:
          z3 = P2 = _[at++], H2 = N3 = _[at++];
          var be2 = _[at++], Te2 = _[at++];
          if ($ = z3 + be2, et = H2 + Te2, t2) {
            if (L7(z3, H2, $, H2, i, h, v4) || L7($, H2, $, et, i, h, v4) || L7($, et, z3, et, i, h, v4) || L7(z3, et, z3, H2, i, h, v4))
              return true;
          } else
            I2 += W6($, H2, $, et, h, v4), I2 += W6(z3, et, z3, H2, h, v4);
          break;
        case M7.Z:
          if (t2) {
            if (L7(P2, N3, z3, H2, i, h, v4))
              return true;
          } else
            I2 += W6(P2, N3, z3, H2, h, v4);
          P2 = z3, N3 = H2;
          break;
      }
    }
    return !t2 && !Qcr(N3, H2) && (I2 += W6(P2, N3, z3, H2, h, v4) || 0), I2 !== 0;
  }
  function rfr(f2, i, t2) {
    return $ze(f2, 0, false, i, t2);
  }
  function ifr(f2, i, t2, h) {
    return $ze(f2, i, true, t2, h);
  }
  var gEt = Ul({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, sU), afr = { style: Ul({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, pkt.style) }, cXt = WL.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), ofr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.update = function() {
      var t2 = this;
      f2.prototype.update.call(this);
      var h = this.style;
      if (h.decal) {
        var v4 = this._decalEl = this._decalEl || new i();
        v4.buildPath === i.prototype.buildPath && (v4.buildPath = function(P2) {
          t2.buildPath(P2, t2.shape);
        }), v4.silent = true;
        var _ = v4.style;
        for (var M2 in h)
          _[M2] !== h[M2] && (_[M2] = h[M2]);
        _.fill = h.fill ? h.decal : null, _.decal = null, _.shadowColor = null, h.strokeFirst && (_.stroke = null);
        for (var I2 = 0; I2 < cXt.length; ++I2)
          v4[cXt[I2]] = this[cXt[I2]];
        v4.__dirty |= UT;
      } else
        this._decalEl && (this._decalEl = null);
    }, i.prototype.getDecalElement = function() {
      return this._decalEl;
    }, i.prototype._init = function(t2) {
      var h = Of2(t2);
      this.shape = this.getDefaultShape();
      var v4 = this.getDefaultStyle();
      v4 && this.useStyle(v4);
      for (var _ = 0; _ < h.length; _++) {
        var M2 = h[_], I2 = t2[M2];
        M2 === "style" ? this.style ? ba2(this.style, I2) : this.useStyle(I2) : M2 === "shape" ? ba2(this.shape, I2) : f2.prototype.attrKV.call(this, M2, I2);
      }
      this.style || this.useStyle({});
    }, i.prototype.getDefaultStyle = function() {
      return null;
    }, i.prototype.getDefaultShape = function() {
      return {};
    }, i.prototype.canBeInsideText = function() {
      return this.hasFill();
    }, i.prototype.getInsideTextFill = function() {
      var t2 = this.style.fill;
      if (t2 !== "none") {
        if (ms(t2)) {
          var h = cEt(t2, 0);
          return h > 0.5 ? LJt : h > 0.2 ? Vur : OJt;
        } else if (t2)
          return OJt;
      }
      return LJt;
    }, i.prototype.getInsideTextStroke = function(t2) {
      var h = this.style.fill;
      if (ms(h)) {
        var v4 = this.__zr, _ = !!(v4 && v4.isDarkMode()), M2 = cEt(t2, 0) < PJt;
        if (_ === M2)
          return h;
      }
    }, i.prototype.buildPath = function(t2, h, v4) {
    }, i.prototype.pathUpdated = function() {
      this.__dirty &= ~_tt;
    }, i.prototype.getUpdatedPathProxy = function(t2) {
      return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, t2), this.path;
    }, i.prototype.createPathProxy = function() {
      this.path = new HL(false);
    }, i.prototype.hasStroke = function() {
      var t2 = this.style, h = t2.stroke;
      return !(h == null || h === "none" || !(t2.lineWidth > 0));
    }, i.prototype.hasFill = function() {
      var t2 = this.style, h = t2.fill;
      return h != null && h !== "none";
    }, i.prototype.getBoundingRect = function() {
      var t2 = this._rect, h = this.style, v4 = !t2;
      if (v4) {
        var _ = false;
        this.path || (_ = true, this.createPathProxy());
        var M2 = this.path;
        (_ || this.__dirty & _tt) && (M2.beginPath(), this.buildPath(M2, this.shape, false), this.pathUpdated()), t2 = M2.getBoundingRect();
      }
      if (this._rect = t2, this.hasStroke() && this.path && this.path.len() > 0) {
        var I2 = this._rectStroke || (this._rectStroke = t2.clone());
        if (this.__dirty || v4) {
          I2.copy(t2);
          var P2 = h.strokeNoScale ? this.getLineScale() : 1, N3 = h.lineWidth;
          if (!this.hasFill()) {
            var z3 = this.strokeContainThreshold;
            N3 = Math.max(N3, z3 == null ? 4 : z3);
          }
          P2 > 1e-10 && (I2.width += N3 / P2, I2.height += N3 / P2, I2.x -= N3 / P2 / 2, I2.y -= N3 / P2 / 2);
        }
        return I2;
      }
      return t2;
    }, i.prototype.contain = function(t2, h) {
      var v4 = this.transformCoordToLocal(t2, h), _ = this.getBoundingRect(), M2 = this.style;
      if (t2 = v4[0], h = v4[1], _.contain(t2, h)) {
        var I2 = this.path;
        if (this.hasStroke()) {
          var P2 = M2.lineWidth, N3 = M2.strokeNoScale ? this.getLineScale() : 1;
          if (N3 > 1e-10 && (this.hasFill() || (P2 = Math.max(P2, this.strokeContainThreshold)), ifr(I2, P2 / N3, t2, h)))
            return true;
        }
        if (this.hasFill())
          return rfr(I2, t2, h);
      }
      return false;
    }, i.prototype.dirtyShape = function() {
      this.__dirty |= _tt, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
    }, i.prototype.dirty = function() {
      this.dirtyStyle(), this.dirtyShape();
    }, i.prototype.animateShape = function(t2) {
      return this.animate("shape", t2);
    }, i.prototype.updateDuringAnimation = function(t2) {
      t2 === "style" ? this.dirtyStyle() : t2 === "shape" ? this.dirtyShape() : this.markRedraw();
    }, i.prototype.attrKV = function(t2, h) {
      t2 === "shape" ? this.setShape(h) : f2.prototype.attrKV.call(this, t2, h);
    }, i.prototype.setShape = function(t2, h) {
      var v4 = this.shape;
      return v4 || (v4 = this.shape = {}), typeof t2 == "string" ? v4[t2] = h : ba2(v4, t2), this.dirtyShape(), this;
    }, i.prototype.shapeChanged = function() {
      return !!(this.__dirty & _tt);
    }, i.prototype.createStyle = function(t2) {
      return skt(gEt, t2);
    }, i.prototype._innerSaveToNormal = function(t2) {
      f2.prototype._innerSaveToNormal.call(this, t2);
      var h = this._normalState;
      t2.shape && !h.shape && (h.shape = ba2({}, this.shape));
    }, i.prototype._applyStateObj = function(t2, h, v4, _, M2, I2) {
      f2.prototype._applyStateObj.call(this, t2, h, v4, _, M2, I2);
      var P2 = !(h && _), N3;
      if (h && h.shape ? M2 ? _ ? N3 = h.shape : (N3 = ba2({}, v4.shape), ba2(N3, h.shape)) : (N3 = ba2({}, _ ? this.shape : v4.shape), ba2(N3, h.shape)) : P2 && (N3 = v4.shape), N3)
        if (M2) {
          this.shape = ba2({}, this.shape);
          for (var z3 = {}, H2 = Of2(N3), $ = 0; $ < H2.length; $++) {
            var et = H2[$];
            typeof N3[et] == "object" ? this.shape[et] = N3[et] : z3[et] = N3[et];
          }
          this._transitionState(t2, { shape: z3 }, I2);
        } else
          this.shape = N3, this.dirtyShape();
    }, i.prototype._mergeStates = function(t2) {
      for (var h = f2.prototype._mergeStates.call(this, t2), v4, _ = 0; _ < t2.length; _++) {
        var M2 = t2[_];
        M2.shape && (v4 = v4 || {}, this._mergeStyle(v4, M2.shape));
      }
      return v4 && (h.shape = v4), h;
    }, i.prototype.getAnimationStyleProps = function() {
      return afr;
    }, i.prototype.isZeroArea = function() {
      return false;
    }, i.extend = function(t2) {
      var h = function(_) {
        ii2(M2, _);
        function M2(I2) {
          var P2 = _.call(this, I2) || this;
          return t2.init && t2.init.call(P2, I2), P2;
        }
        return M2.prototype.getDefaultStyle = function() {
          return pu(t2.style);
        }, M2.prototype.getDefaultShape = function() {
          return pu(t2.shape);
        }, M2;
      }(i);
      for (var v4 in t2)
        typeof t2[v4] == "function" && (h.prototype[v4] = t2[v4]);
      return h;
    }, i.initDefaultProps = function() {
      var t2 = i.prototype;
      t2.type = "path", t2.strokeContainThreshold = 5, t2.segmentIgnoreThreshold = 0, t2.subPixelOptimize = false, t2.autoBatch = false, t2.__dirty = UT | ddt | _tt;
    }(), i;
  }(rE), Uc2 = ofr, sfr = Ul({ strokeFirst: true, font: K7, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, gEt), Yze = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.hasStroke = function() {
      var t2 = this.style, h = t2.stroke;
      return h != null && h !== "none" && t2.lineWidth > 0;
    }, i.prototype.hasFill = function() {
      var t2 = this.style, h = t2.fill;
      return h != null && h !== "none";
    }, i.prototype.createStyle = function(t2) {
      return skt(sfr, t2);
    }, i.prototype.setBoundingRect = function(t2) {
      this._rect = t2;
    }, i.prototype.getBoundingRect = function() {
      var t2 = this.style;
      if (!this._rect) {
        var h = t2.text;
        h != null ? h += "" : h = "";
        var v4 = Cgt(h, t2.font, t2.textAlign, t2.textBaseline);
        if (v4.x += t2.x || 0, v4.y += t2.y || 0, this.hasStroke()) {
          var _ = t2.lineWidth;
          v4.x -= _ / 2, v4.y -= _ / 2, v4.width += _, v4.height += _;
        }
        this._rect = v4;
      }
      return this._rect;
    }, i.initDefaultProps = function() {
      var t2 = i.prototype;
      t2.dirtyRectTolerance = 10;
    }(), i;
  }(rE);
  Yze.prototype.type = "tspan";
  var Xdt = Yze, lfr = Ul({ x: 0, y: 0 }, sU), ufr = { style: Ul({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, pkt.style) };
  function cfr(f2) {
    return !!(f2 && typeof f2 != "string" && f2.width && f2.height);
  }
  var Kze = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.createStyle = function(t2) {
      return skt(lfr, t2);
    }, i.prototype._getSize = function(t2) {
      var h = this.style, v4 = h[t2];
      if (v4 != null)
        return v4;
      var _ = cfr(h.image) ? h.image : this.__image;
      if (!_)
        return 0;
      var M2 = t2 === "width" ? "height" : "width", I2 = h[M2];
      return I2 == null ? _[t2] : _[t2] / _[M2] * I2;
    }, i.prototype.getWidth = function() {
      return this._getSize("width");
    }, i.prototype.getHeight = function() {
      return this._getSize("height");
    }, i.prototype.getAnimationStyleProps = function() {
      return ufr;
    }, i.prototype.getBoundingRect = function() {
      var t2 = this.style;
      return this._rect || (this._rect = new Lc2(t2.x || 0, t2.y || 0, this.getWidth(), this.getHeight())), this._rect;
    }, i;
  }(rE);
  Kze.prototype.type = "image";
  var Ux = Kze;
  function ffr(f2, i) {
    var t2 = i.x, h = i.y, v4 = i.width, _ = i.height, M2 = i.r, I2, P2, N3, z3;
    v4 < 0 && (t2 = t2 + v4, v4 = -v4), _ < 0 && (h = h + _, _ = -_), typeof M2 == "number" ? I2 = P2 = N3 = z3 = M2 : M2 instanceof Array ? M2.length === 1 ? I2 = P2 = N3 = z3 = M2[0] : M2.length === 2 ? (I2 = N3 = M2[0], P2 = z3 = M2[1]) : M2.length === 3 ? (I2 = M2[0], P2 = z3 = M2[1], N3 = M2[2]) : (I2 = M2[0], P2 = M2[1], N3 = M2[2], z3 = M2[3]) : I2 = P2 = N3 = z3 = 0;
    var H2;
    I2 + P2 > v4 && (H2 = I2 + P2, I2 *= v4 / H2, P2 *= v4 / H2), N3 + z3 > v4 && (H2 = N3 + z3, N3 *= v4 / H2, z3 *= v4 / H2), P2 + N3 > _ && (H2 = P2 + N3, P2 *= _ / H2, N3 *= _ / H2), I2 + z3 > _ && (H2 = I2 + z3, I2 *= _ / H2, z3 *= _ / H2), f2.moveTo(t2 + I2, h), f2.lineTo(t2 + v4 - P2, h), P2 !== 0 && f2.arc(t2 + v4 - P2, h + P2, P2, -Math.PI / 2, 0), f2.lineTo(t2 + v4, h + _ - N3), N3 !== 0 && f2.arc(t2 + v4 - N3, h + _ - N3, N3, 0, Math.PI / 2), f2.lineTo(t2 + z3, h + _), z3 !== 0 && f2.arc(t2 + z3, h + _ - z3, z3, Math.PI / 2, Math.PI), f2.lineTo(t2, h + I2), I2 !== 0 && f2.arc(t2 + I2, h + I2, I2, Math.PI, Math.PI * 1.5);
  }
  var Att = Math.round;
  function Xze(f2, i, t2) {
    if (!!i) {
      var h = i.x1, v4 = i.x2, _ = i.y1, M2 = i.y2;
      f2.x1 = h, f2.x2 = v4, f2.y1 = _, f2.y2 = M2;
      var I2 = t2 && t2.lineWidth;
      return I2 && (Att(h * 2) === Att(v4 * 2) && (f2.x1 = f2.x2 = eU(h, I2, true)), Att(_ * 2) === Att(M2 * 2) && (f2.y1 = f2.y2 = eU(_, I2, true))), f2;
    }
  }
  function Qze(f2, i, t2) {
    if (!!i) {
      var h = i.x, v4 = i.y, _ = i.width, M2 = i.height;
      f2.x = h, f2.y = v4, f2.width = _, f2.height = M2;
      var I2 = t2 && t2.lineWidth;
      return I2 && (f2.x = eU(h, I2, true), f2.y = eU(v4, I2, true), f2.width = Math.max(eU(h + _, I2, false) - f2.x, _ === 0 ? 0 : 1), f2.height = Math.max(eU(v4 + M2, I2, false) - f2.y, M2 === 0 ? 0 : 1)), f2;
    }
  }
  function eU(f2, i, t2) {
    if (!i)
      return f2;
    var h = Att(f2 * 2);
    return (h + Att(i)) % 2 === 0 ? h / 2 : (h + (t2 ? 1 : -1)) / 2;
  }
  var hfr = function() {
    function f2() {
      this.x = 0, this.y = 0, this.width = 0, this.height = 0;
    }
    return f2;
  }(), pfr = {}, Jze = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultShape = function() {
      return new hfr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4, _, M2, I2;
      if (this.subPixelOptimize) {
        var P2 = Qze(pfr, h, this.style);
        v4 = P2.x, _ = P2.y, M2 = P2.width, I2 = P2.height, P2.r = h.r, h = P2;
      } else
        v4 = h.x, _ = h.y, M2 = h.width, I2 = h.height;
      h.r ? ffr(t2, h) : t2.rect(v4, _, M2, I2);
    }, i.prototype.isZeroArea = function() {
      return !this.shape.width || !this.shape.height;
    }, i;
  }(Uc2);
  Jze.prototype.type = "rect";
  var Sh2 = Jze, tNe = { fill: "#000" }, eNe = 2, dfr = { style: Ul({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, pkt.style) }, tje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this) || this;
      return h.type = "text", h._children = [], h._defaultStyle = tNe, h.attr(t2), h;
    }
    return i.prototype.childrenRef = function() {
      return this._children;
    }, i.prototype.update = function() {
      f2.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
      for (var t2 = 0; t2 < this._children.length; t2++) {
        var h = this._children[t2];
        h.zlevel = this.zlevel, h.z = this.z, h.z2 = this.z2, h.culling = this.culling, h.cursor = this.cursor, h.invisible = this.invisible;
      }
    }, i.prototype.updateTransform = function() {
      var t2 = this.innerTransformable;
      t2 ? (t2.updateTransform(), t2.transform && (this.transform = t2.transform)) : f2.prototype.updateTransform.call(this);
    }, i.prototype.getLocalTransform = function(t2) {
      var h = this.innerTransformable;
      return h ? h.getLocalTransform(t2) : f2.prototype.getLocalTransform.call(this, t2);
    }, i.prototype.getComputedTransform = function() {
      return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), f2.prototype.getComputedTransform.call(this);
    }, i.prototype._updateSubTexts = function() {
      this._childCursor = 0, yfr(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
    }, i.prototype.addSelfToZr = function(t2) {
      f2.prototype.addSelfToZr.call(this, t2);
      for (var h = 0; h < this._children.length; h++)
        this._children[h].__zr = t2;
    }, i.prototype.removeSelfFromZr = function(t2) {
      f2.prototype.removeSelfFromZr.call(this, t2);
      for (var h = 0; h < this._children.length; h++)
        this._children[h].__zr = null;
    }, i.prototype.getBoundingRect = function() {
      if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
        for (var t2 = new Lc2(0, 0, 0, 0), h = this._children, v4 = [], _ = null, M2 = 0; M2 < h.length; M2++) {
          var I2 = h[M2], P2 = I2.getBoundingRect(), N3 = I2.getLocalTransform(v4);
          N3 ? (t2.copy(P2), t2.applyTransform(N3), _ = _ || t2.clone(), _.union(t2)) : (_ = _ || P2.clone(), _.union(P2));
        }
        this._rect = _ || t2;
      }
      return this._rect;
    }, i.prototype.setDefaultTextStyle = function(t2) {
      this._defaultStyle = t2 || tNe;
    }, i.prototype.setTextContent = function(t2) {
    }, i.prototype._mergeStyle = function(t2, h) {
      if (!h)
        return t2;
      var v4 = h.rich, _ = t2.rich || v4 && {};
      return ba2(t2, h), v4 && _ ? (this._mergeRich(_, v4), t2.rich = _) : _ && (t2.rich = _), t2;
    }, i.prototype._mergeRich = function(t2, h) {
      for (var v4 = Of2(h), _ = 0; _ < v4.length; _++) {
        var M2 = v4[_];
        t2[M2] = t2[M2] || {}, ba2(t2[M2], h[M2]);
      }
    }, i.prototype.getAnimationStyleProps = function() {
      return dfr;
    }, i.prototype._getOrCreateChild = function(t2) {
      var h = this._children[this._childCursor];
      return (!h || !(h instanceof t2)) && (h = new t2()), this._children[this._childCursor++] = h, h.__zr = this.__zr, h.parent = this, h;
    }, i.prototype._updatePlainTexts = function() {
      var t2 = this.style, h = t2.font || K7, v4 = t2.padding, _ = lNe(t2), M2 = Ocr(_, t2), I2 = fXt(t2), P2 = !!t2.backgroundColor, N3 = M2.outerHeight, z3 = M2.outerWidth, H2 = M2.contentWidth, $ = M2.lines, et = M2.lineHeight, at = this._defaultStyle, ht = t2.x || 0, bt = t2.y || 0, _t = t2.align || at.align || "left", Et = t2.verticalAlign || at.verticalAlign || "top", zt = ht, Ft = xtt(bt, M2.contentHeight, Et);
      if (I2 || v4) {
        var fe2 = vdt(ht, z3, _t), re2 = xtt(bt, N3, Et);
        I2 && this._renderBackground(t2, t2, fe2, re2, z3, N3);
      }
      Ft += et / 2, v4 && (zt = sNe(ht, _t, v4), Et === "top" ? Ft += v4[0] : Et === "bottom" && (Ft -= v4[2]));
      for (var ye = 0, me2 = false, be2 = oNe("fill" in t2 ? t2.fill : (me2 = true, at.fill)), Te2 = aNe("stroke" in t2 ? t2.stroke : !P2 && (!at.autoStroke || me2) ? (ye = eNe, at.stroke) : null), We = t2.textShadowBlur > 0, en = t2.width != null && (t2.overflow === "truncate" || t2.overflow === "break" || t2.overflow === "breakAll"), Ue2 = M2.calculatedLineHeight, Mn = 0; Mn < $.length; Mn++) {
        var Vn = this._getOrCreateChild(Xdt), xn = Vn.createStyle();
        Vn.useStyle(xn), xn.text = $[Mn], xn.x = zt, xn.y = Ft, _t && (xn.textAlign = _t), xn.textBaseline = "middle", xn.opacity = t2.opacity, xn.strokeFirst = true, We && (xn.shadowBlur = t2.textShadowBlur || 0, xn.shadowColor = t2.textShadowColor || "transparent", xn.shadowOffsetX = t2.textShadowOffsetX || 0, xn.shadowOffsetY = t2.textShadowOffsetY || 0), xn.stroke = Te2, xn.fill = be2, Te2 && (xn.lineWidth = t2.lineWidth || ye, xn.lineDash = t2.lineDash, xn.lineDashOffset = t2.lineDashOffset || 0), xn.font = h, rNe(xn, t2), Ft += et, en && Vn.setBoundingRect(new Lc2(vdt(xn.x, t2.width, xn.textAlign), xtt(xn.y, Ue2, xn.textBaseline), H2, Ue2));
      }
    }, i.prototype._updateRichTexts = function() {
      var t2 = this.style, h = lNe(t2), v4 = Fcr(h, t2), _ = v4.width, M2 = v4.outerWidth, I2 = v4.outerHeight, P2 = t2.padding, N3 = t2.x || 0, z3 = t2.y || 0, H2 = this._defaultStyle, $ = t2.align || H2.align, et = t2.verticalAlign || H2.verticalAlign, at = vdt(N3, M2, $), ht = xtt(z3, I2, et), bt = at, _t = ht;
      P2 && (bt += P2[3], _t += P2[0]);
      var Et = bt + _;
      fXt(t2) && this._renderBackground(t2, t2, at, ht, M2, I2);
      for (var zt = !!t2.backgroundColor, Ft = 0; Ft < v4.lines.length; Ft++) {
        for (var fe2 = v4.lines[Ft], re2 = fe2.tokens, ye = re2.length, me2 = fe2.lineHeight, be2 = fe2.width, Te2 = 0, We = bt, en = Et, Ue2 = ye - 1, Mn = void 0; Te2 < ye && (Mn = re2[Te2], !Mn.align || Mn.align === "left"); )
          this._placeToken(Mn, t2, me2, _t, We, "left", zt), be2 -= Mn.width, We += Mn.width, Te2++;
        for (; Ue2 >= 0 && (Mn = re2[Ue2], Mn.align === "right"); )
          this._placeToken(Mn, t2, me2, _t, en, "right", zt), be2 -= Mn.width, en -= Mn.width, Ue2--;
        for (We += (_ - (We - bt) - (Et - en) - be2) / 2; Te2 <= Ue2; )
          Mn = re2[Te2], this._placeToken(Mn, t2, me2, _t, We + Mn.width / 2, "center", zt), We += Mn.width, Te2++;
        _t += me2;
      }
    }, i.prototype._placeToken = function(t2, h, v4, _, M2, I2, P2) {
      var N3 = h.rich[t2.styleName] || {};
      N3.text = t2.text;
      var z3 = t2.verticalAlign, H2 = _ + v4 / 2;
      z3 === "top" ? H2 = _ + t2.height / 2 : z3 === "bottom" && (H2 = _ + v4 - t2.height / 2);
      var $ = !t2.isLineHolder && fXt(N3);
      $ && this._renderBackground(N3, h, I2 === "right" ? M2 - t2.width : I2 === "center" ? M2 - t2.width / 2 : M2, H2 - t2.height / 2, t2.width, t2.height);
      var et = !!N3.backgroundColor, at = t2.textPadding;
      at && (M2 = sNe(M2, I2, at), H2 -= t2.height / 2 - at[0] - t2.innerHeight / 2);
      var ht = this._getOrCreateChild(Xdt), bt = ht.createStyle();
      ht.useStyle(bt);
      var _t = this._defaultStyle, Et = false, zt = 0, Ft = oNe("fill" in N3 ? N3.fill : "fill" in h ? h.fill : (Et = true, _t.fill)), fe2 = aNe("stroke" in N3 ? N3.stroke : "stroke" in h ? h.stroke : !et && !P2 && (!_t.autoStroke || Et) ? (zt = eNe, _t.stroke) : null), re2 = N3.textShadowBlur > 0 || h.textShadowBlur > 0;
      bt.text = t2.text, bt.x = M2, bt.y = H2, re2 && (bt.shadowBlur = N3.textShadowBlur || h.textShadowBlur || 0, bt.shadowColor = N3.textShadowColor || h.textShadowColor || "transparent", bt.shadowOffsetX = N3.textShadowOffsetX || h.textShadowOffsetX || 0, bt.shadowOffsetY = N3.textShadowOffsetY || h.textShadowOffsetY || 0), bt.textAlign = I2, bt.textBaseline = "middle", bt.font = t2.font || K7, bt.opacity = U6(N3.opacity, h.opacity, 1), rNe(bt, N3), fe2 && (bt.lineWidth = U6(N3.lineWidth, h.lineWidth, zt), bt.lineDash = _c2(N3.lineDash, h.lineDash), bt.lineDashOffset = h.lineDashOffset || 0, bt.stroke = fe2), Ft && (bt.fill = Ft);
      var ye = t2.contentWidth, me2 = t2.contentHeight;
      ht.setBoundingRect(new Lc2(vdt(bt.x, ye, bt.textAlign), xtt(bt.y, me2, bt.textBaseline), ye, me2));
    }, i.prototype._renderBackground = function(t2, h, v4, _, M2, I2) {
      var P2 = t2.backgroundColor, N3 = t2.borderWidth, z3 = t2.borderColor, H2 = P2 && P2.image, $ = P2 && !H2, et = t2.borderRadius, at = this, ht, bt;
      if ($ || t2.lineHeight || N3 && z3) {
        ht = this._getOrCreateChild(Sh2), ht.useStyle(ht.createStyle()), ht.style.fill = null;
        var _t = ht.shape;
        _t.x = v4, _t.y = _, _t.width = M2, _t.height = I2, _t.r = et, ht.dirtyShape();
      }
      if ($) {
        var Et = ht.style;
        Et.fill = P2 || null, Et.fillOpacity = _c2(t2.fillOpacity, 1);
      } else if (H2) {
        bt = this._getOrCreateChild(Ux), bt.onload = function() {
          at.dirtyStyle();
        };
        var zt = bt.style;
        zt.image = P2.image, zt.x = v4, zt.y = _, zt.width = M2, zt.height = I2;
      }
      if (N3 && z3) {
        var Et = ht.style;
        Et.lineWidth = N3, Et.stroke = z3, Et.strokeOpacity = _c2(t2.strokeOpacity, 1), Et.lineDash = t2.borderDash, Et.lineDashOffset = t2.borderDashOffset || 0, ht.strokeContainThreshold = 0, ht.hasFill() && ht.hasStroke() && (Et.strokeFirst = true, Et.lineWidth *= 2);
      }
      var Ft = (ht || bt).style;
      Ft.shadowBlur = t2.shadowBlur || 0, Ft.shadowColor = t2.shadowColor || "transparent", Ft.shadowOffsetX = t2.shadowOffsetX || 0, Ft.shadowOffsetY = t2.shadowOffsetY || 0, Ft.opacity = U6(t2.opacity, h.opacity, 1);
    }, i.makeFont = function(t2) {
      var h = "";
      return nje(t2) && (h = [t2.fontStyle, t2.fontWeight, eje(t2.fontSize), t2.fontFamily || "sans-serif"].join(" ")), h && w5(h) || t2.textFont || t2.font;
    }, i;
  }(rE), gfr = { left: true, right: 1, center: 1 }, vfr = { top: 1, bottom: 1, middle: 1 }, nNe = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
  function eje(f2) {
    return typeof f2 == "string" && (f2.indexOf("px") !== -1 || f2.indexOf("rem") !== -1 || f2.indexOf("em") !== -1) ? f2 : isNaN(+f2) ? vee + "px" : f2 + "px";
  }
  function rNe(f2, i) {
    for (var t2 = 0; t2 < nNe.length; t2++) {
      var h = nNe[t2], v4 = i[h];
      v4 != null && (f2[h] = v4);
    }
  }
  function nje(f2) {
    return f2.fontSize != null || f2.fontFamily || f2.fontWeight;
  }
  function yfr(f2) {
    return iNe(f2), Qe2(f2.rich, iNe), f2;
  }
  function iNe(f2) {
    if (f2) {
      f2.font = tje.makeFont(f2);
      var i = f2.align;
      i === "middle" && (i = "center"), f2.align = i == null || gfr[i] ? i : "left";
      var t2 = f2.verticalAlign;
      t2 === "center" && (t2 = "middle"), f2.verticalAlign = t2 == null || vfr[t2] ? t2 : "top";
      var h = f2.padding;
      h && (f2.padding = wee(f2.padding));
    }
  }
  function aNe(f2, i) {
    return f2 == null || i <= 0 || f2 === "transparent" || f2 === "none" ? null : f2.image || f2.colorStops ? "#000" : f2;
  }
  function oNe(f2) {
    return f2 == null || f2 === "none" ? null : f2.image || f2.colorStops ? "#000" : f2;
  }
  function sNe(f2, i, t2) {
    return i === "right" ? f2 - t2[1] : i === "center" ? f2 + t2[3] / 2 - t2[1] / 2 : f2 + t2[3];
  }
  function lNe(f2) {
    var i = f2.text;
    return i != null && (i += ""), i;
  }
  function fXt(f2) {
    return !!(f2.backgroundColor || f2.lineHeight || f2.borderWidth && f2.borderColor);
  }
  var op = tje, Du = Wh2(), BJt = function(f2, i, t2, h) {
    if (h) {
      var v4 = Du(h);
      v4.dataIndex = t2, v4.dataType = i, v4.seriesIndex = f2, h.type === "group" && h.traverse(function(_) {
        var M2 = Du(_);
        M2.seriesIndex = f2, M2.dataIndex = t2, M2.dataType = i;
      });
    }
  }, uNe = 1, cNe = {}, rje = Wh2(), Oee = Wh2(), Ree = 0, Agt = 1, gkt = 2, j2 = ["emphasis", "blur", "select"], Qdt = ["normal", "emphasis", "blur", "select"], Jtt = 10, mfr = 9, lU = "highlight", qDt = "downplay", Pdt = "select", ZDt = "unselect", Ldt = "toggleSelect";
  function ntt(f2) {
    return f2 != null && f2 !== "none";
  }
  var fNe = new Mgt(100);
  function hNe(f2) {
    if (ms(f2)) {
      var i = fNe.get(f2);
      return i || (i = CJt(f2, -0.1), fNe.put(f2, i)), i;
    } else if (okt(f2)) {
      var t2 = ba2({}, f2);
      return t2.colorStops = Xa2(f2.colorStops, function(h) {
        return { offset: h.offset, color: CJt(h.color, -0.1) };
      }), t2;
    }
    return f2;
  }
  function vkt(f2, i, t2) {
    f2.onHoverStateChange && (f2.hoverState || 0) !== t2 && f2.onHoverStateChange(i), f2.hoverState = t2;
  }
  function ije(f2) {
    vkt(f2, "emphasis", gkt);
  }
  function aje(f2) {
    f2.hoverState === gkt && vkt(f2, "normal", Ree);
  }
  function Nee(f2) {
    vkt(f2, "blur", Agt);
  }
  function oje(f2) {
    f2.hoverState === Agt && vkt(f2, "normal", Ree);
  }
  function bfr(f2) {
    f2.selected = true;
  }
  function _fr(f2) {
    f2.selected = false;
  }
  function pNe(f2, i, t2) {
    i(f2, t2);
  }
  function iN(f2, i, t2) {
    pNe(f2, i, t2), f2.isGroup && f2.traverse(function(h) {
      pNe(h, i, t2);
    });
  }
  function vEt(f2, i) {
    switch (i) {
      case "emphasis":
        f2.hoverState = gkt;
        break;
      case "normal":
        f2.hoverState = Ree;
        break;
      case "blur":
        f2.hoverState = Agt;
        break;
      case "select":
        f2.selected = true;
    }
  }
  function xfr(f2, i, t2, h) {
    for (var v4 = f2.style, _ = {}, M2 = 0; M2 < i.length; M2++) {
      var I2 = i[M2], P2 = v4[I2];
      _[I2] = P2 == null ? h && h[I2] : P2;
    }
    for (var M2 = 0; M2 < f2.animators.length; M2++) {
      var N3 = f2.animators[M2];
      N3.__fromStateTransition && N3.__fromStateTransition.indexOf(t2) < 0 && N3.targetName === "style" && N3.saveTo(_, i);
    }
    return _;
  }
  function wfr(f2, i, t2, h) {
    var v4 = t2 && Pc2(t2, "select") >= 0, _ = false;
    if (f2 instanceof Uc2) {
      var M2 = rje(f2), I2 = v4 && M2.selectFill || M2.normalFill, P2 = v4 && M2.selectStroke || M2.normalStroke;
      if (ntt(I2) || ntt(P2)) {
        h = h || {};
        var N3 = h.style || {};
        N3.fill === "inherit" ? (_ = true, h = ba2({}, h), N3 = ba2({}, N3), N3.fill = I2) : !ntt(N3.fill) && ntt(I2) ? (_ = true, h = ba2({}, h), N3 = ba2({}, N3), N3.fill = hNe(I2)) : !ntt(N3.stroke) && ntt(P2) && (_ || (h = ba2({}, h), N3 = ba2({}, N3)), N3.stroke = hNe(P2)), h.style = N3;
      }
    }
    if (h && h.z2 == null) {
      _ || (h = ba2({}, h));
      var z3 = f2.z2EmphasisLift;
      h.z2 = f2.z2 + (z3 != null ? z3 : Jtt);
    }
    return h;
  }
  function Sfr(f2, i, t2) {
    if (t2 && t2.z2 == null) {
      t2 = ba2({}, t2);
      var h = f2.z2SelectLift;
      t2.z2 = f2.z2 + (h != null ? h : mfr);
    }
    return t2;
  }
  function Mfr(f2, i, t2) {
    var h = Pc2(f2.currentStates, i) >= 0, v4 = f2.style.opacity, _ = h ? null : xfr(f2, ["opacity"], i, { opacity: 1 });
    t2 = t2 || {};
    var M2 = t2.style || {};
    return M2.opacity == null && (t2 = ba2({}, t2), M2 = ba2({ opacity: h ? v4 : _.opacity * 0.1 }, M2), t2.style = M2), t2;
  }
  function hXt(f2, i) {
    var t2 = this.states[f2];
    if (this.style) {
      if (f2 === "emphasis")
        return wfr(this, f2, i, t2);
      if (f2 === "blur")
        return Mfr(this, f2, t2);
      if (f2 === "select")
        return Sfr(this, f2, t2);
    }
    return t2;
  }
  function mU(f2) {
    f2.stateProxy = hXt;
    var i = f2.getTextContent(), t2 = f2.getTextGuideLine();
    i && (i.stateProxy = hXt), t2 && (t2.stateProxy = hXt);
  }
  function dNe(f2, i) {
    !fje(f2, i) && !f2.__highByOuter && iN(f2, ije);
  }
  function gNe(f2, i) {
    !fje(f2, i) && !f2.__highByOuter && iN(f2, aje);
  }
  function NL(f2, i) {
    f2.__highByOuter |= 1 << (i || 0), iN(f2, ije);
  }
  function FL(f2, i) {
    !(f2.__highByOuter &= ~(1 << (i || 0))) && iN(f2, aje);
  }
  function sje(f2) {
    iN(f2, Nee);
  }
  function lje(f2) {
    iN(f2, oje);
  }
  function uje(f2) {
    iN(f2, bfr);
  }
  function cje(f2) {
    iN(f2, _fr);
  }
  function fje(f2, i) {
    return f2.__highDownSilentOnTouch && i.zrByTouch;
  }
  function hje(f2) {
    var i = f2.getModel();
    i.eachComponent(function(t2, h) {
      var v4 = Oee(h);
      if (v4.isBlured) {
        var _ = t2 === "series" ? f2.getViewOfSeriesModel(h) : f2.getViewOfComponentModel(h);
        _.group.traverse(function(M2) {
          oje(M2);
        });
      }
      v4.isBlured = false;
    });
  }
  function zJt(f2, i, t2, h) {
    var v4 = h.getModel();
    t2 = t2 || "coordinateSystem";
    function _(N3, z3) {
      for (var H2 = 0; H2 < z3.length; H2++) {
        var $ = N3.getItemGraphicEl(z3[H2]);
        $ && lje($);
      }
    }
    if (f2 != null && !(!i || i === "none")) {
      var M2 = v4.getSeriesByIndex(f2), I2 = M2.coordinateSystem;
      I2 && I2.master && (I2 = I2.master);
      var P2 = [];
      v4.eachSeries(function(N3) {
        var z3 = M2 === N3, H2 = N3.coordinateSystem;
        H2 && H2.master && (H2 = H2.master);
        var $ = H2 && I2 ? H2 === I2 : z3;
        if (!(t2 === "series" && !z3 || t2 === "coordinateSystem" && !$ || i === "series" && z3)) {
          var et = h.getViewOfSeriesModel(N3);
          if (et.group.traverse(function(bt) {
            Nee(bt);
          }), xS(i))
            _(N3.getData(), i);
          else if (Xl(i))
            for (var at = Of2(i), ht = 0; ht < at.length; ht++)
              _(N3.getData(at[ht]), i[at[ht]]);
          P2.push(N3), Oee(N3).isBlured = true;
        }
      }), v4.eachComponent(function(N3, z3) {
        if (N3 !== "series") {
          var H2 = h.getViewOfComponentModel(z3);
          H2 && H2.blurSeries && H2.blurSeries(P2, v4);
        }
      });
    }
  }
  function jJt(f2, i, t2) {
    if (!(f2 == null || i == null)) {
      var h = t2.getModel().getComponent(f2, i);
      if (!!h) {
        Oee(h).isBlured = true;
        var v4 = t2.getViewOfComponentModel(h);
        !v4 || !v4.focusBlurEnabled || v4.group.traverse(function(_) {
          Nee(_);
        });
      }
    }
  }
  function Cfr(f2, i, t2) {
    var h = f2.seriesIndex, v4 = f2.getData(i.dataType);
    if (!!v4) {
      var _ = vU(v4, i);
      _ = (Za2(_) ? _[0] : _) || 0;
      var M2 = v4.getItemGraphicEl(_);
      if (!M2)
        for (var I2 = v4.count(), P2 = 0; !M2 && P2 < I2; )
          M2 = v4.getItemGraphicEl(P2++);
      if (M2) {
        var N3 = Du(M2);
        zJt(h, N3.focus, N3.blurScope, t2);
      } else {
        var z3 = f2.get(["emphasis", "focus"]), H2 = f2.get(["emphasis", "blurScope"]);
        z3 != null && zJt(h, z3, H2, t2);
      }
    }
  }
  function Fee(f2, i, t2, h) {
    var v4 = { focusSelf: false, dispatchers: null };
    if (f2 == null || f2 === "series" || i == null || t2 == null)
      return v4;
    var _ = h.getModel().getComponent(f2, i);
    if (!_)
      return v4;
    var M2 = h.getViewOfComponentModel(_);
    if (!M2 || !M2.findHighDownDispatchers)
      return v4;
    for (var I2 = M2.findHighDownDispatchers(t2), P2, N3 = 0; N3 < I2.length; N3++)
      if (Du(I2[N3]).focus === "self") {
        P2 = true;
        break;
      }
    return { focusSelf: P2, dispatchers: I2 };
  }
  function Tfr(f2, i, t2) {
    var h = Du(f2), v4 = Fee(h.componentMainType, h.componentIndex, h.componentHighDownName, t2), _ = v4.dispatchers, M2 = v4.focusSelf;
    _ ? (M2 && jJt(h.componentMainType, h.componentIndex, t2), Qe2(_, function(I2) {
      return dNe(I2, i);
    })) : (zJt(h.seriesIndex, h.focus, h.blurScope, t2), h.focus === "self" && jJt(h.componentMainType, h.componentIndex, t2), dNe(f2, i));
  }
  function Afr(f2, i, t2) {
    hje(t2);
    var h = Du(f2), v4 = Fee(h.componentMainType, h.componentIndex, h.componentHighDownName, t2).dispatchers;
    v4 ? Qe2(v4, function(_) {
      return gNe(_, i);
    }) : gNe(f2, i);
  }
  function Ifr(f2, i, t2) {
    if (!!GJt(i)) {
      var h = i.dataType, v4 = f2.getData(h), _ = vU(v4, i);
      Za2(_) || (_ = [_]), f2[i.type === Ldt ? "toggleSelect" : i.type === Pdt ? "select" : "unselect"](_, h);
    }
  }
  function vNe(f2) {
    var i = f2.getAllData();
    Qe2(i, function(t2) {
      var h = t2.data, v4 = t2.type;
      h.eachItemGraphicEl(function(_, M2) {
        f2.isSelected(M2, v4) ? uje(_) : cje(_);
      });
    });
  }
  function Dfr(f2) {
    var i = [];
    return f2.eachSeries(function(t2) {
      var h = t2.getAllData();
      Qe2(h, function(v4) {
        v4.data;
        var _ = v4.type, M2 = t2.getSelectedDataIndices();
        if (M2.length > 0) {
          var I2 = { dataIndex: M2, seriesIndex: t2.seriesIndex };
          _ != null && (I2.dataType = _), i.push(I2);
        }
      });
    }), i;
  }
  function uU(f2, i, t2) {
    nU(f2, true), iN(f2, mU), WJt(f2, i, t2);
  }
  function Efr(f2) {
    nU(f2, false);
  }
  function vy(f2, i, t2, h) {
    h ? Efr(f2) : uU(f2, i, t2);
  }
  function WJt(f2, i, t2) {
    var h = Du(f2);
    i != null ? (h.focus = i, h.blurScope = t2) : h.focus && (h.focus = null);
  }
  var yNe = ["emphasis", "blur", "select"], kfr = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
  function Hx(f2, i, t2, h) {
    t2 = t2 || "itemStyle";
    for (var v4 = 0; v4 < yNe.length; v4++) {
      var _ = yNe[v4], M2 = i.getModel([_, t2]), I2 = f2.ensureState(_);
      I2.style = h ? h(M2) : M2[kfr[t2]]();
    }
  }
  function nU(f2, i) {
    var t2 = i === false, h = f2;
    f2.highDownSilentOnTouch && (h.__highDownSilentOnTouch = f2.highDownSilentOnTouch), (!t2 || h.__highDownDispatcher) && (h.__highByOuter = h.__highByOuter || 0, h.__highDownDispatcher = !t2);
  }
  function Jdt(f2) {
    return !!(f2 && f2.__highDownDispatcher);
  }
  function Pfr(f2, i, t2) {
    var h = Du(f2);
    h.componentMainType = i.mainType, h.componentIndex = i.componentIndex, h.componentHighDownName = t2;
  }
  function Lfr(f2) {
    var i = cNe[f2];
    return i == null && uNe <= 32 && (i = cNe[f2] = uNe++), i;
  }
  function GJt(f2) {
    var i = f2.type;
    return i === Pdt || i === ZDt || i === Ldt;
  }
  function mNe(f2) {
    var i = f2.type;
    return i === lU || i === qDt;
  }
  function Ofr(f2) {
    var i = rje(f2);
    i.normalFill = f2.style.fill, i.normalStroke = f2.style.stroke;
    var t2 = f2.states.select || {};
    i.selectFill = t2.style && t2.style.fill || null, i.selectStroke = t2.style && t2.style.stroke || null;
  }
  var rtt = HL.CMD, Rfr = [[], [], []], bNe = Math.sqrt, Nfr = Math.atan2;
  function pje(f2, i) {
    if (!!i) {
      var t2 = f2.data, h = f2.len(), v4, _, M2, I2, P2, N3, z3 = rtt.M, H2 = rtt.C, $ = rtt.L, et = rtt.R, at = rtt.A, ht = rtt.Q;
      for (M2 = 0, I2 = 0; M2 < h; ) {
        switch (v4 = t2[M2++], I2 = M2, _ = 0, v4) {
          case z3:
            _ = 1;
            break;
          case $:
            _ = 1;
            break;
          case H2:
            _ = 3;
            break;
          case ht:
            _ = 2;
            break;
          case at:
            var bt = i[4], _t = i[5], Et = bNe(i[0] * i[0] + i[1] * i[1]), zt = bNe(i[2] * i[2] + i[3] * i[3]), Ft = Nfr(-i[1] / zt, i[0] / Et);
            t2[M2] *= Et, t2[M2++] += bt, t2[M2] *= zt, t2[M2++] += _t, t2[M2++] *= Et, t2[M2++] *= zt, t2[M2++] += Ft, t2[M2++] += Ft, M2 += 2, I2 = M2;
            break;
          case et:
            N3[0] = t2[M2++], N3[1] = t2[M2++], Wx(N3, N3, i), t2[I2++] = N3[0], t2[I2++] = N3[1], N3[0] += t2[M2++], N3[1] += t2[M2++], Wx(N3, N3, i), t2[I2++] = N3[0], t2[I2++] = N3[1];
        }
        for (P2 = 0; P2 < _; P2++) {
          var fe2 = Rfr[P2];
          fe2[0] = t2[M2++], fe2[1] = t2[M2++], Wx(fe2, fe2, i), t2[I2++] = fe2[0], t2[I2++] = fe2[1];
        }
      }
      f2.increaseVersion();
    }
  }
  var pXt = Math.sqrt, WIt = Math.sin, GIt = Math.cos, Gpt = Math.PI;
  function _Ne(f2) {
    return Math.sqrt(f2[0] * f2[0] + f2[1] * f2[1]);
  }
  function HJt(f2, i) {
    return (f2[0] * i[0] + f2[1] * i[1]) / (_Ne(f2) * _Ne(i));
  }
  function xNe(f2, i) {
    return (f2[0] * i[1] < f2[1] * i[0] ? -1 : 1) * Math.acos(HJt(f2, i));
  }
  function wNe(f2, i, t2, h, v4, _, M2, I2, P2, N3, z3) {
    var H2 = P2 * (Gpt / 180), $ = GIt(H2) * (f2 - t2) / 2 + WIt(H2) * (i - h) / 2, et = -1 * WIt(H2) * (f2 - t2) / 2 + GIt(H2) * (i - h) / 2, at = $ * $ / (M2 * M2) + et * et / (I2 * I2);
    at > 1 && (M2 *= pXt(at), I2 *= pXt(at));
    var ht = (v4 === _ ? -1 : 1) * pXt((M2 * M2 * (I2 * I2) - M2 * M2 * (et * et) - I2 * I2 * ($ * $)) / (M2 * M2 * (et * et) + I2 * I2 * ($ * $))) || 0, bt = ht * M2 * et / I2, _t = ht * -I2 * $ / M2, Et = (f2 + t2) / 2 + GIt(H2) * bt - WIt(H2) * _t, zt = (i + h) / 2 + WIt(H2) * bt + GIt(H2) * _t, Ft = xNe([1, 0], [($ - bt) / M2, (et - _t) / I2]), fe2 = [($ - bt) / M2, (et - _t) / I2], re2 = [(-1 * $ - bt) / M2, (-1 * et - _t) / I2], ye = xNe(fe2, re2);
    if (HJt(fe2, re2) <= -1 && (ye = Gpt), HJt(fe2, re2) >= 1 && (ye = 0), ye < 0) {
      var me2 = Math.round(ye / Gpt * 1e6) / 1e6;
      ye = Gpt * 2 + me2 % 2 * Gpt;
    }
    z3.addData(N3, Et, zt, M2, I2, Ft, ye, H2, _);
  }
  var Ffr = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, Vfr = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function Bfr(f2) {
    var i = new HL();
    if (!f2)
      return i;
    var t2 = 0, h = 0, v4 = t2, _ = h, M2, I2 = HL.CMD, P2 = f2.match(Ffr);
    if (!P2)
      return i;
    for (var N3 = 0; N3 < P2.length; N3++) {
      for (var z3 = P2[N3], H2 = z3.charAt(0), $ = void 0, et = z3.match(Vfr) || [], at = et.length, ht = 0; ht < at; ht++)
        et[ht] = parseFloat(et[ht]);
      for (var bt = 0; bt < at; ) {
        var _t = void 0, Et = void 0, zt = void 0, Ft = void 0, fe2 = void 0, re2 = void 0, ye = void 0, me2 = t2, be2 = h, Te2 = void 0, We = void 0;
        switch (H2) {
          case "l":
            t2 += et[bt++], h += et[bt++], $ = I2.L, i.addData($, t2, h);
            break;
          case "L":
            t2 = et[bt++], h = et[bt++], $ = I2.L, i.addData($, t2, h);
            break;
          case "m":
            t2 += et[bt++], h += et[bt++], $ = I2.M, i.addData($, t2, h), v4 = t2, _ = h, H2 = "l";
            break;
          case "M":
            t2 = et[bt++], h = et[bt++], $ = I2.M, i.addData($, t2, h), v4 = t2, _ = h, H2 = "L";
            break;
          case "h":
            t2 += et[bt++], $ = I2.L, i.addData($, t2, h);
            break;
          case "H":
            t2 = et[bt++], $ = I2.L, i.addData($, t2, h);
            break;
          case "v":
            h += et[bt++], $ = I2.L, i.addData($, t2, h);
            break;
          case "V":
            h = et[bt++], $ = I2.L, i.addData($, t2, h);
            break;
          case "C":
            $ = I2.C, i.addData($, et[bt++], et[bt++], et[bt++], et[bt++], et[bt++], et[bt++]), t2 = et[bt - 2], h = et[bt - 1];
            break;
          case "c":
            $ = I2.C, i.addData($, et[bt++] + t2, et[bt++] + h, et[bt++] + t2, et[bt++] + h, et[bt++] + t2, et[bt++] + h), t2 += et[bt - 2], h += et[bt - 1];
            break;
          case "S":
            _t = t2, Et = h, Te2 = i.len(), We = i.data, M2 === I2.C && (_t += t2 - We[Te2 - 4], Et += h - We[Te2 - 3]), $ = I2.C, me2 = et[bt++], be2 = et[bt++], t2 = et[bt++], h = et[bt++], i.addData($, _t, Et, me2, be2, t2, h);
            break;
          case "s":
            _t = t2, Et = h, Te2 = i.len(), We = i.data, M2 === I2.C && (_t += t2 - We[Te2 - 4], Et += h - We[Te2 - 3]), $ = I2.C, me2 = t2 + et[bt++], be2 = h + et[bt++], t2 += et[bt++], h += et[bt++], i.addData($, _t, Et, me2, be2, t2, h);
            break;
          case "Q":
            me2 = et[bt++], be2 = et[bt++], t2 = et[bt++], h = et[bt++], $ = I2.Q, i.addData($, me2, be2, t2, h);
            break;
          case "q":
            me2 = et[bt++] + t2, be2 = et[bt++] + h, t2 += et[bt++], h += et[bt++], $ = I2.Q, i.addData($, me2, be2, t2, h);
            break;
          case "T":
            _t = t2, Et = h, Te2 = i.len(), We = i.data, M2 === I2.Q && (_t += t2 - We[Te2 - 4], Et += h - We[Te2 - 3]), t2 = et[bt++], h = et[bt++], $ = I2.Q, i.addData($, _t, Et, t2, h);
            break;
          case "t":
            _t = t2, Et = h, Te2 = i.len(), We = i.data, M2 === I2.Q && (_t += t2 - We[Te2 - 4], Et += h - We[Te2 - 3]), t2 += et[bt++], h += et[bt++], $ = I2.Q, i.addData($, _t, Et, t2, h);
            break;
          case "A":
            zt = et[bt++], Ft = et[bt++], fe2 = et[bt++], re2 = et[bt++], ye = et[bt++], me2 = t2, be2 = h, t2 = et[bt++], h = et[bt++], $ = I2.A, wNe(me2, be2, t2, h, re2, ye, zt, Ft, fe2, $, i);
            break;
          case "a":
            zt = et[bt++], Ft = et[bt++], fe2 = et[bt++], re2 = et[bt++], ye = et[bt++], me2 = t2, be2 = h, t2 += et[bt++], h += et[bt++], $ = I2.A, wNe(me2, be2, t2, h, re2, ye, zt, Ft, fe2, $, i);
            break;
        }
      }
      (H2 === "z" || H2 === "Z") && ($ = I2.Z, i.addData($), t2 = v4, h = _), M2 = $;
    }
    return i.toStatic(), i;
  }
  var dje = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.applyTransform = function(t2) {
    }, i;
  }(Uc2);
  function gje(f2) {
    return f2.setData != null;
  }
  function vje(f2, i) {
    var t2 = Bfr(f2), h = ba2({}, i);
    return h.buildPath = function(v4) {
      if (gje(v4)) {
        v4.setData(t2.data);
        var _ = v4.getContext();
        _ && v4.rebuildPath(_, 1);
      } else {
        var _ = v4;
        t2.rebuildPath(_, 1);
      }
    }, h.applyTransform = function(v4) {
      pje(t2, v4), this.dirtyShape();
    }, h;
  }
  function yje(f2, i) {
    return new dje(vje(f2, i));
  }
  function zfr(f2, i) {
    var t2 = vje(f2, i), h = function(v4) {
      ii2(_, v4);
      function _(M2) {
        var I2 = v4.call(this, M2) || this;
        return I2.applyTransform = t2.applyTransform, I2.buildPath = t2.buildPath, I2;
      }
      return _;
    }(dje);
    return h;
  }
  function jfr(f2, i) {
    for (var t2 = [], h = f2.length, v4 = 0; v4 < h; v4++) {
      var _ = f2[v4];
      t2.push(_.getUpdatedPathProxy(true));
    }
    var M2 = new Uc2(i);
    return M2.createPathProxy(), M2.buildPath = function(I2) {
      if (gje(I2)) {
        I2.appendPath(t2);
        var P2 = I2.getContext();
        P2 && I2.rebuildPath(P2, 1);
      }
    }, M2;
  }
  function Vee(f2, i) {
    i = i || {};
    var t2 = new Uc2();
    return f2.shape && t2.setShape(f2.shape), t2.setStyle(f2.style), i.bakeTransform ? pje(t2.path, f2.getComputedTransform()) : i.toLocal ? t2.setLocalTransform(f2.getComputedTransform()) : t2.copyTransform(f2), t2.buildPath = f2.buildPath, t2.applyTransform = t2.applyTransform, t2.z = f2.z, t2.z2 = f2.z2, t2.zlevel = f2.zlevel, t2;
  }
  var Wfr = function() {
    function f2() {
      this.cx = 0, this.cy = 0, this.r = 0;
    }
    return f2;
  }(), mje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultShape = function() {
      return new Wfr();
    }, i.prototype.buildPath = function(t2, h) {
      t2.moveTo(h.cx + h.r, h.cy), t2.arc(h.cx, h.cy, h.r, 0, Math.PI * 2);
    }, i;
  }(Uc2);
  mje.prototype.type = "circle";
  var UL = mje, Gfr = function() {
    function f2() {
      this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
    }
    return f2;
  }(), bje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultShape = function() {
      return new Gfr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = 0.5522848, _ = h.cx, M2 = h.cy, I2 = h.rx, P2 = h.ry, N3 = I2 * v4, z3 = P2 * v4;
      t2.moveTo(_ - I2, M2), t2.bezierCurveTo(_ - I2, M2 - z3, _ - N3, M2 - P2, _, M2 - P2), t2.bezierCurveTo(_ + N3, M2 - P2, _ + I2, M2 - z3, _ + I2, M2), t2.bezierCurveTo(_ + I2, M2 + z3, _ + N3, M2 + P2, _, M2 + P2), t2.bezierCurveTo(_ - N3, M2 + P2, _ - I2, M2 + z3, _ - I2, M2), t2.closePath();
    }, i;
  }(Uc2);
  bje.prototype.type = "ellipse";
  var Bee = bje, _je = Math.PI, dXt = _je * 2, DH = Math.sin, itt = Math.cos, Hfr = Math.acos, vS = Math.atan2, SNe = Math.abs, Odt = Math.sqrt, ydt = Math.max, CL = Math.min, y5 = 1e-4;
  function Ufr(f2, i, t2, h, v4, _, M2, I2) {
    var P2 = t2 - f2, N3 = h - i, z3 = M2 - v4, H2 = I2 - _, $ = H2 * P2 - z3 * N3;
    if (!($ * $ < y5))
      return $ = (z3 * (i - _) - H2 * (f2 - v4)) / $, [f2 + $ * P2, i + $ * N3];
  }
  function HIt(f2, i, t2, h, v4, _, M2) {
    var I2 = f2 - t2, P2 = i - h, N3 = (M2 ? _ : -_) / Odt(I2 * I2 + P2 * P2), z3 = N3 * P2, H2 = -N3 * I2, $ = f2 + z3, et = i + H2, at = t2 + z3, ht = h + H2, bt = ($ + at) / 2, _t = (et + ht) / 2, Et = at - $, zt = ht - et, Ft = Et * Et + zt * zt, fe2 = v4 - _, re2 = $ * ht - at * et, ye = (zt < 0 ? -1 : 1) * Odt(ydt(0, fe2 * fe2 * Ft - re2 * re2)), me2 = (re2 * zt - Et * ye) / Ft, be2 = (-re2 * Et - zt * ye) / Ft, Te2 = (re2 * zt + Et * ye) / Ft, We = (-re2 * Et + zt * ye) / Ft, en = me2 - bt, Ue2 = be2 - _t, Mn = Te2 - bt, Vn = We - _t;
    return en * en + Ue2 * Ue2 > Mn * Mn + Vn * Vn && (me2 = Te2, be2 = We), { cx: me2, cy: be2, x0: -z3, y0: -H2, x1: me2 * (v4 / fe2 - 1), y1: be2 * (v4 / fe2 - 1) };
  }
  function qfr(f2) {
    var i;
    if (Za2(f2)) {
      var t2 = f2.length;
      if (!t2)
        return f2;
      t2 === 1 ? i = [f2[0], f2[0], 0, 0] : t2 === 2 ? i = [f2[0], f2[0], f2[1], f2[1]] : t2 === 3 ? i = f2.concat(f2[2]) : i = f2;
    } else
      i = [f2, f2, f2, f2];
    return i;
  }
  function Zfr(f2, i) {
    var t2, h = ydt(i.r, 0), v4 = ydt(i.r0 || 0, 0), _ = h > 0, M2 = v4 > 0;
    if (!(!_ && !M2)) {
      if (_ || (h = v4, v4 = 0), v4 > h) {
        var I2 = h;
        h = v4, v4 = I2;
      }
      var P2 = i.startAngle, N3 = i.endAngle;
      if (!(isNaN(P2) || isNaN(N3))) {
        var z3 = i.cx, H2 = i.cy, $ = !!i.clockwise, et = SNe(N3 - P2), at = et > dXt && et % dXt;
        if (at > y5 && (et = at), !(h > y5))
          f2.moveTo(z3, H2);
        else if (et > dXt - y5)
          f2.moveTo(z3 + h * itt(P2), H2 + h * DH(P2)), f2.arc(z3, H2, h, P2, N3, !$), v4 > y5 && (f2.moveTo(z3 + v4 * itt(N3), H2 + v4 * DH(N3)), f2.arc(z3, H2, v4, N3, P2, $));
        else {
          var ht = void 0, bt = void 0, _t = void 0, Et = void 0, zt = void 0, Ft = void 0, fe2 = void 0, re2 = void 0, ye = void 0, me2 = void 0, be2 = void 0, Te2 = void 0, We = void 0, en = void 0, Ue2 = void 0, Mn = void 0, Vn = h * itt(P2), xn = h * DH(P2), Zr = v4 * itt(N3), nr = v4 * DH(N3), pr = et > y5;
          if (pr) {
            var Nr = i.cornerRadius;
            Nr && (t2 = qfr(Nr), ht = t2[0], bt = t2[1], _t = t2[2], Et = t2[3]);
            var ai2 = SNe(h - v4) / 2;
            if (zt = CL(ai2, _t), Ft = CL(ai2, Et), fe2 = CL(ai2, ht), re2 = CL(ai2, bt), be2 = ye = ydt(zt, Ft), Te2 = me2 = ydt(fe2, re2), (ye > y5 || me2 > y5) && (We = h * itt(N3), en = h * DH(N3), Ue2 = v4 * itt(P2), Mn = v4 * DH(P2), et < _je)) {
              var gi2 = Ufr(Vn, xn, Ue2, Mn, We, en, Zr, nr);
              if (gi2) {
                var To = Vn - gi2[0], us = xn - gi2[1], ml = We - gi2[0], ll = en - gi2[1], Rs = 1 / DH(Hfr((To * ml + us * ll) / (Odt(To * To + us * us) * Odt(ml * ml + ll * ll))) / 2), es = Odt(gi2[0] * gi2[0] + gi2[1] * gi2[1]);
                be2 = CL(ye, (h - es) / (Rs + 1)), Te2 = CL(me2, (v4 - es) / (Rs - 1));
              }
            }
          }
          if (!pr)
            f2.moveTo(z3 + Vn, H2 + xn);
          else if (be2 > y5) {
            var Ws = CL(_t, be2), il = CL(Et, be2), bs = HIt(Ue2, Mn, Vn, xn, h, Ws, $), Rl = HIt(We, en, Zr, nr, h, il, $);
            f2.moveTo(z3 + bs.cx + bs.x0, H2 + bs.cy + bs.y0), be2 < ye && Ws === il ? f2.arc(z3 + bs.cx, H2 + bs.cy, be2, vS(bs.y0, bs.x0), vS(Rl.y0, Rl.x0), !$) : (Ws > 0 && f2.arc(z3 + bs.cx, H2 + bs.cy, Ws, vS(bs.y0, bs.x0), vS(bs.y1, bs.x1), !$), f2.arc(z3, H2, h, vS(bs.cy + bs.y1, bs.cx + bs.x1), vS(Rl.cy + Rl.y1, Rl.cx + Rl.x1), !$), il > 0 && f2.arc(z3 + Rl.cx, H2 + Rl.cy, il, vS(Rl.y1, Rl.x1), vS(Rl.y0, Rl.x0), !$));
          } else
            f2.moveTo(z3 + Vn, H2 + xn), f2.arc(z3, H2, h, P2, N3, !$);
          if (!(v4 > y5) || !pr)
            f2.lineTo(z3 + Zr, H2 + nr);
          else if (Te2 > y5) {
            var Ws = CL(ht, Te2), il = CL(bt, Te2), bs = HIt(Zr, nr, We, en, v4, -il, $), Rl = HIt(Vn, xn, Ue2, Mn, v4, -Ws, $);
            f2.lineTo(z3 + bs.cx + bs.x0, H2 + bs.cy + bs.y0), Te2 < me2 && Ws === il ? f2.arc(z3 + bs.cx, H2 + bs.cy, Te2, vS(bs.y0, bs.x0), vS(Rl.y0, Rl.x0), !$) : (il > 0 && f2.arc(z3 + bs.cx, H2 + bs.cy, il, vS(bs.y0, bs.x0), vS(bs.y1, bs.x1), !$), f2.arc(z3, H2, v4, vS(bs.cy + bs.y1, bs.cx + bs.x1), vS(Rl.cy + Rl.y1, Rl.cx + Rl.x1), $), Ws > 0 && f2.arc(z3 + Rl.cx, H2 + Rl.cy, Ws, vS(Rl.y1, Rl.x1), vS(Rl.y0, Rl.x0), !$));
          } else
            f2.lineTo(z3 + Zr, H2 + nr), f2.arc(z3, H2, v4, N3, P2, $);
        }
        f2.closePath();
      }
    }
  }
  var $fr = function() {
    function f2() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
    }
    return f2;
  }(), xje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultShape = function() {
      return new $fr();
    }, i.prototype.buildPath = function(t2, h) {
      Zfr(t2, h);
    }, i.prototype.isZeroArea = function() {
      return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
    }, i;
  }(Uc2);
  xje.prototype.type = "sector";
  var rC = xje, Yfr = function() {
    function f2() {
      this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
    }
    return f2;
  }(), wje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultShape = function() {
      return new Yfr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.cx, _ = h.cy, M2 = Math.PI * 2;
      t2.moveTo(v4 + h.r, _), t2.arc(v4, _, h.r, 0, M2, false), t2.moveTo(v4 + h.r0, _), t2.arc(v4, _, h.r0, 0, M2, true);
    }, i;
  }(Uc2);
  wje.prototype.type = "ring";
  var ykt = wje;
  function Kfr(f2, i, t2, h) {
    var v4 = [], _ = [], M2 = [], I2 = [], P2, N3, z3, H2;
    if (h) {
      z3 = [1 / 0, 1 / 0], H2 = [-1 / 0, -1 / 0];
      for (var $ = 0, et = f2.length; $ < et; $++)
        N7(z3, z3, f2[$]), F7(H2, H2, f2[$]);
      N7(z3, z3, h[0]), F7(H2, H2, h[1]);
    }
    for (var $ = 0, et = f2.length; $ < et; $++) {
      var at = f2[$];
      if (t2)
        P2 = f2[$ ? $ - 1 : et - 1], N3 = f2[($ + 1) % et];
      else if ($ === 0 || $ === et - 1) {
        v4.push(q6(f2[$]));
        continue;
      } else
        P2 = f2[$ - 1], N3 = f2[$ + 1];
      tU(_, N3, P2), PKt(_, _, i);
      var ht = vJt(at, P2), bt = vJt(at, N3), _t = ht + bt;
      _t !== 0 && (ht /= _t, bt /= _t), PKt(M2, _, -ht), PKt(I2, _, bt);
      var Et = v6e([], at, M2), zt = v6e([], at, I2);
      h && (F7(Et, Et, z3), N7(Et, Et, H2), F7(zt, zt, z3), N7(zt, zt, H2)), v4.push(Et), v4.push(zt);
    }
    return t2 && v4.push(v4.shift()), v4;
  }
  function Sje(f2, i, t2) {
    var h = i.smooth, v4 = i.points;
    if (v4 && v4.length >= 2) {
      if (h) {
        var _ = Kfr(v4, h, t2, i.smoothConstraint);
        f2.moveTo(v4[0][0], v4[0][1]);
        for (var M2 = v4.length, I2 = 0; I2 < (t2 ? M2 : M2 - 1); I2++) {
          var P2 = _[I2 * 2], N3 = _[I2 * 2 + 1], z3 = v4[(I2 + 1) % M2];
          f2.bezierCurveTo(P2[0], P2[1], N3[0], N3[1], z3[0], z3[1]);
        }
      } else {
        f2.moveTo(v4[0][0], v4[0][1]);
        for (var I2 = 1, H2 = v4.length; I2 < H2; I2++)
          f2.lineTo(v4[I2][0], v4[I2][1]);
      }
      t2 && f2.closePath();
    }
  }
  var Xfr = function() {
    function f2() {
      this.points = null, this.smooth = 0, this.smoothConstraint = null;
    }
    return f2;
  }(), Mje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultShape = function() {
      return new Xfr();
    }, i.prototype.buildPath = function(t2, h) {
      Sje(t2, h, true);
    }, i;
  }(Uc2);
  Mje.prototype.type = "polygon";
  var iC = Mje, Qfr = function() {
    function f2() {
      this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
    }
    return f2;
  }(), Cje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new Qfr();
    }, i.prototype.buildPath = function(t2, h) {
      Sje(t2, h, false);
    }, i;
  }(Uc2);
  Cje.prototype.type = "polyline";
  var aC = Cje, Jfr = {}, thr = function() {
    function f2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return f2;
  }(), Tje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new thr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4, _, M2, I2;
      if (this.subPixelOptimize) {
        var P2 = Xze(Jfr, h, this.style);
        v4 = P2.x1, _ = P2.y1, M2 = P2.x2, I2 = P2.y2;
      } else
        v4 = h.x1, _ = h.y1, M2 = h.x2, I2 = h.y2;
      var N3 = h.percent;
      N3 !== 0 && (t2.moveTo(v4, _), N3 < 1 && (M2 = v4 * (1 - N3) + M2 * N3, I2 = _ * (1 - N3) + I2 * N3), t2.lineTo(M2, I2));
    }, i.prototype.pointAt = function(t2) {
      var h = this.shape;
      return [h.x1 * (1 - t2) + h.x2 * t2, h.y1 * (1 - t2) + h.y2 * t2];
    }, i;
  }(Uc2);
  Tje.prototype.type = "line";
  var m_ = Tje, QM = [], ehr = function() {
    function f2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
    }
    return f2;
  }();
  function MNe(f2, i, t2) {
    var h = f2.cpx2, v4 = f2.cpy2;
    return h != null || v4 != null ? [(t2 ? A6e : fb2)(f2.x1, f2.cpx1, f2.cpx2, f2.x2, i), (t2 ? A6e : fb2)(f2.y1, f2.cpy1, f2.cpy2, f2.y2, i)] : [(t2 ? wJt : v_)(f2.x1, f2.cpx1, f2.x2, i), (t2 ? wJt : v_)(f2.y1, f2.cpy1, f2.y2, i)];
  }
  var Aje = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new ehr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.x1, _ = h.y1, M2 = h.x2, I2 = h.y2, P2 = h.cpx1, N3 = h.cpy1, z3 = h.cpx2, H2 = h.cpy2, $ = h.percent;
      $ !== 0 && (t2.moveTo(v4, _), z3 == null || H2 == null ? ($ < 1 && ($dt(v4, P2, M2, $, QM), P2 = QM[1], M2 = QM[2], $dt(_, N3, I2, $, QM), N3 = QM[1], I2 = QM[2]), t2.quadraticCurveTo(P2, N3, M2, I2)) : ($ < 1 && (X7(v4, P2, z3, M2, $, QM), P2 = QM[1], z3 = QM[2], M2 = QM[3], X7(_, N3, H2, I2, $, QM), N3 = QM[1], H2 = QM[2], I2 = QM[3]), t2.bezierCurveTo(P2, N3, z3, H2, M2, I2)));
    }, i.prototype.pointAt = function(t2) {
      return MNe(this.shape, t2, false);
    }, i.prototype.tangentAt = function(t2) {
      var h = MNe(this.shape, t2, true);
      return Sgt(h, h);
    }, i;
  }(Uc2);
  Aje.prototype.type = "bezier-curve";
  var mkt = Aje, nhr = function() {
    function f2() {
      this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return f2;
  }(), Ije = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new nhr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.cx, _ = h.cy, M2 = Math.max(h.r, 0), I2 = h.startAngle, P2 = h.endAngle, N3 = h.clockwise, z3 = Math.cos(I2), H2 = Math.sin(I2);
      t2.moveTo(z3 * M2 + v4, H2 * M2 + _), t2.arc(v4, _, M2, I2, P2, !N3);
    }, i;
  }(Uc2);
  Ije.prototype.type = "arc";
  var zee = Ije, rhr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "compound", t2;
    }
    return i.prototype._updatePathDirty = function() {
      for (var t2 = this.shape.paths, h = this.shapeChanged(), v4 = 0; v4 < t2.length; v4++)
        h = h || t2[v4].shapeChanged();
      h && this.dirtyShape();
    }, i.prototype.beforeBrush = function() {
      this._updatePathDirty();
      for (var t2 = this.shape.paths || [], h = this.getGlobalScale(), v4 = 0; v4 < t2.length; v4++)
        t2[v4].path || t2[v4].createPathProxy(), t2[v4].path.setScale(h[0], h[1], t2[v4].segmentIgnoreThreshold);
    }, i.prototype.buildPath = function(t2, h) {
      for (var v4 = h.paths || [], _ = 0; _ < v4.length; _++)
        v4[_].buildPath(t2, v4[_].shape, true);
    }, i.prototype.afterBrush = function() {
      for (var t2 = this.shape.paths || [], h = 0; h < t2.length; h++)
        t2[h].pathUpdated();
    }, i.prototype.getBoundingRect = function() {
      return this._updatePathDirty.call(this), Uc2.prototype.getBoundingRect.call(this);
    }, i;
  }(Uc2), jee = rhr, ihr = function() {
    function f2(i) {
      this.colorStops = i || [];
    }
    return f2.prototype.addColorStop = function(i, t2) {
      this.colorStops.push({ offset: i, color: t2 });
    }, f2;
  }(), Dje = ihr, ahr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _, M2, I2) {
      var P2 = f2.call(this, M2) || this;
      return P2.x = t2 == null ? 0 : t2, P2.y = h == null ? 0 : h, P2.x2 = v4 == null ? 1 : v4, P2.y2 = _ == null ? 0 : _, P2.type = "linear", P2.global = I2 || false, P2;
    }
    return i;
  }(Dje), Igt = ahr, ohr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _, M2) {
      var I2 = f2.call(this, _) || this;
      return I2.x = t2 == null ? 0.5 : t2, I2.y = h == null ? 0.5 : h, I2.r = v4 == null ? 0.5 : v4, I2.type = "radial", I2.global = M2 || false, I2;
    }
    return i;
  }(Dje), Eje = ohr, EH = [0, 0], kH = [0, 0], UIt = new ac2(), qIt = new ac2(), shr = function() {
    function f2(i, t2) {
      this._corners = [], this._axes = [], this._origin = [0, 0];
      for (var h = 0; h < 4; h++)
        this._corners[h] = new ac2();
      for (var h = 0; h < 2; h++)
        this._axes[h] = new ac2();
      i && this.fromBoundingRect(i, t2);
    }
    return f2.prototype.fromBoundingRect = function(i, t2) {
      var h = this._corners, v4 = this._axes, _ = i.x, M2 = i.y, I2 = _ + i.width, P2 = M2 + i.height;
      if (h[0].set(_, M2), h[1].set(I2, M2), h[2].set(I2, P2), h[3].set(_, P2), t2)
        for (var N3 = 0; N3 < 4; N3++)
          h[N3].transform(t2);
      ac2.sub(v4[0], h[1], h[0]), ac2.sub(v4[1], h[3], h[0]), v4[0].normalize(), v4[1].normalize();
      for (var N3 = 0; N3 < 2; N3++)
        this._origin[N3] = v4[N3].dot(h[0]);
    }, f2.prototype.intersect = function(i, t2) {
      var h = true, v4 = !t2;
      return UIt.set(1 / 0, 1 / 0), qIt.set(0, 0), !this._intersectCheckOneSide(this, i, UIt, qIt, v4, 1) && (h = false, v4) || !this._intersectCheckOneSide(i, this, UIt, qIt, v4, -1) && (h = false, v4) || v4 || ac2.copy(t2, h ? UIt : qIt), h;
    }, f2.prototype._intersectCheckOneSide = function(i, t2, h, v4, _, M2) {
      for (var I2 = true, P2 = 0; P2 < 2; P2++) {
        var N3 = this._axes[P2];
        if (this._getProjMinMaxOnAxis(P2, i._corners, EH), this._getProjMinMaxOnAxis(P2, t2._corners, kH), EH[1] < kH[0] || EH[0] > kH[1]) {
          if (I2 = false, _)
            return I2;
          var z3 = Math.abs(kH[0] - EH[1]), H2 = Math.abs(EH[0] - kH[1]);
          Math.min(z3, H2) > v4.len() && (z3 < H2 ? ac2.scale(v4, N3, -z3 * M2) : ac2.scale(v4, N3, H2 * M2));
        } else if (h) {
          var z3 = Math.abs(kH[0] - EH[1]), H2 = Math.abs(EH[0] - kH[1]);
          Math.min(z3, H2) < h.len() && (z3 < H2 ? ac2.scale(h, N3, z3 * M2) : ac2.scale(h, N3, -H2 * M2));
        }
      }
      return I2;
    }, f2.prototype._getProjMinMaxOnAxis = function(i, t2, h) {
      for (var v4 = this._axes[i], _ = this._origin, M2 = t2[0].dot(v4) + _[i], I2 = M2, P2 = M2, N3 = 1; N3 < t2.length; N3++) {
        var z3 = t2[N3].dot(v4) + _[i];
        I2 = Math.min(z3, I2), P2 = Math.max(z3, P2);
      }
      h[0] = I2, h[1] = P2;
    }, f2;
  }(), yEt = shr, lhr = [], uhr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.notClear = true, t2.incremental = true, t2._displayables = [], t2._temporaryDisplayables = [], t2._cursor = 0, t2;
    }
    return i.prototype.traverse = function(t2, h) {
      t2.call(h, this);
    }, i.prototype.useStyle = function() {
      this.style = {};
    }, i.prototype.getCursor = function() {
      return this._cursor;
    }, i.prototype.innerAfterBrush = function() {
      this._cursor = this._displayables.length;
    }, i.prototype.clearDisplaybles = function() {
      this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
    }, i.prototype.clearTemporalDisplayables = function() {
      this._temporaryDisplayables = [];
    }, i.prototype.addDisplayable = function(t2, h) {
      h ? this._temporaryDisplayables.push(t2) : this._displayables.push(t2), this.markRedraw();
    }, i.prototype.addDisplayables = function(t2, h) {
      h = h || false;
      for (var v4 = 0; v4 < t2.length; v4++)
        this.addDisplayable(t2[v4], h);
    }, i.prototype.getDisplayables = function() {
      return this._displayables;
    }, i.prototype.getTemporalDisplayables = function() {
      return this._temporaryDisplayables;
    }, i.prototype.eachPendingDisplayable = function(t2) {
      for (var h = this._cursor; h < this._displayables.length; h++)
        t2 && t2(this._displayables[h]);
      for (var h = 0; h < this._temporaryDisplayables.length; h++)
        t2 && t2(this._temporaryDisplayables[h]);
    }, i.prototype.update = function() {
      this.updateTransform();
      for (var t2 = this._cursor; t2 < this._displayables.length; t2++) {
        var h = this._displayables[t2];
        h.parent = this, h.update(), h.parent = null;
      }
      for (var t2 = 0; t2 < this._temporaryDisplayables.length; t2++) {
        var h = this._temporaryDisplayables[t2];
        h.parent = this, h.update(), h.parent = null;
      }
    }, i.prototype.getBoundingRect = function() {
      if (!this._rect) {
        for (var t2 = new Lc2(1 / 0, 1 / 0, -1 / 0, -1 / 0), h = 0; h < this._displayables.length; h++) {
          var v4 = this._displayables[h], _ = v4.getBoundingRect().clone();
          v4.needLocalTransform() && _.applyTransform(v4.getLocalTransform(lhr)), t2.union(_);
        }
        this._rect = t2;
      }
      return this._rect;
    }, i.prototype.contain = function(t2, h) {
      var v4 = this.transformCoordToLocal(t2, h), _ = this.getBoundingRect();
      if (_.contain(v4[0], v4[1]))
        for (var M2 = 0; M2 < this._displayables.length; M2++) {
          var I2 = this._displayables[M2];
          if (I2.contain(t2, h))
            return true;
        }
      return false;
    }, i;
  }(rE), chr = uhr, kje = Wh2();
  function tet(f2, i, t2, h, v4) {
    var _;
    if (i && i.ecModel) {
      var M2 = i.ecModel.getUpdatePayload();
      _ = M2 && M2.animation;
    }
    var I2 = i && i.isAnimationEnabled(), P2 = f2 === "update";
    if (I2) {
      var N3 = void 0, z3 = void 0, H2 = void 0;
      h ? (N3 = _c2(h.duration, 200), z3 = _c2(h.easing, "cubicOut"), H2 = 0) : (N3 = i.getShallow(P2 ? "animationDurationUpdate" : "animationDuration"), z3 = i.getShallow(P2 ? "animationEasingUpdate" : "animationEasing"), H2 = i.getShallow(P2 ? "animationDelayUpdate" : "animationDelay")), _ && (_.duration != null && (N3 = _.duration), _.easing != null && (z3 = _.easing), _.delay != null && (H2 = _.delay)), Ol(H2) && (H2 = H2(t2, v4)), Ol(N3) && (N3 = N3(t2));
      var $ = { duration: N3 || 0, delay: H2, easing: z3 };
      return $;
    } else
      return null;
  }
  function Wee(f2, i, t2, h, v4, _, M2) {
    var I2 = false, P2;
    Ol(v4) ? (M2 = _, _ = v4, v4 = null) : Xl(v4) && (_ = v4.cb, M2 = v4.during, I2 = v4.isFrom, P2 = v4.removeOpt, v4 = v4.dataIndex);
    var N3 = f2 === "leave";
    N3 || i.stopAnimation("leave");
    var z3 = tet(f2, h, v4, N3 ? P2 || {} : null, h && h.getAnimationDelayParams ? h.getAnimationDelayParams(i, v4) : null);
    if (z3 && z3.duration > 0) {
      var H2 = z3.duration, $ = z3.delay, et = z3.easing, at = { duration: H2, delay: $ || 0, easing: et, done: _, force: !!_ || !!M2, setToFinal: !N3, scope: f2, during: M2 };
      I2 ? i.animateFrom(t2, at) : i.animateTo(t2, at);
    } else
      i.stopAnimation(), !I2 && i.attr(t2), M2 && M2(1), _ && _();
  }
  function jh2(f2, i, t2, h, v4, _) {
    Wee("update", f2, i, t2, h, v4, _);
  }
  function Qv(f2, i, t2, h, v4, _) {
    Wee("enter", f2, i, t2, h, v4, _);
  }
  function Rtt(f2) {
    if (!f2.__zr)
      return true;
    for (var i = 0; i < f2.animators.length; i++) {
      var t2 = f2.animators[i];
      if (t2.scope === "leave")
        return true;
    }
    return false;
  }
  function Q7(f2, i, t2, h, v4, _) {
    Rtt(f2) || Wee("leave", f2, i, t2, h, v4, _);
  }
  function CNe(f2, i, t2, h) {
    f2.removeTextContent(), f2.removeTextGuideLine(), Q7(f2, { style: { opacity: 0 } }, i, t2, h);
  }
  function tgt(f2, i, t2) {
    function h() {
      f2.parent && f2.parent.remove(f2);
    }
    f2.isGroup ? f2.traverse(function(v4) {
      v4.isGroup || CNe(v4, i, t2, h);
    }) : CNe(f2, i, t2, h);
  }
  function A5(f2) {
    kje(f2).oldStyle = f2.style;
  }
  function fhr(f2) {
    return kje(f2).oldStyle;
  }
  var mEt = Math.max, bEt = Math.min, UJt = {};
  function hhr(f2) {
    return Uc2.extend(f2);
  }
  var phr = zfr;
  function dhr(f2, i) {
    return phr(f2, i);
  }
  function I5(f2, i) {
    UJt[f2] = i;
  }
  function Gee(f2) {
    if (UJt.hasOwnProperty(f2))
      return UJt[f2];
  }
  function bkt(f2, i, t2, h) {
    var v4 = yje(f2, i);
    return t2 && (h === "center" && (t2 = Lje(t2, v4.getBoundingRect())), Oje(v4, t2)), v4;
  }
  function Pje(f2, i, t2) {
    var h = new Ux({ style: { image: f2, x: i.x, y: i.y, width: i.width, height: i.height }, onload: function(v4) {
      if (t2 === "center") {
        var _ = { width: v4.width, height: v4.height };
        h.setStyle(Lje(i, _));
      }
    } });
    return h;
  }
  function Lje(f2, i) {
    var t2 = i.width / i.height, h = f2.height * t2, v4;
    h <= f2.width ? v4 = f2.height : (h = f2.width, v4 = h / t2);
    var _ = f2.x + f2.width / 2, M2 = f2.y + f2.height / 2;
    return { x: _ - h / 2, y: M2 - v4 / 2, width: h, height: v4 };
  }
  var KD = jfr;
  function Oje(f2, i) {
    if (!!f2.applyTransform) {
      var t2 = f2.getBoundingRect(), h = t2.calculateTransform(i);
      f2.applyTransform(h);
    }
  }
  function ghr(f2) {
    return Xze(f2.shape, f2.shape, f2.style), f2;
  }
  function vhr(f2) {
    return Qze(f2.shape, f2.shape, f2.style), f2;
  }
  var $Dt = eU;
  function cU(f2, i) {
    for (var t2 = ukt([]); f2 && f2 !== i; )
      $6(t2, f2.getLocalTransform(), t2), f2 = f2.parent;
    return t2;
  }
  function C5(f2, i, t2) {
    return i && !xS(i) && (i = G6.getLocalTransform(i)), t2 && (i = Xtt([], i)), Wx([], f2, i);
  }
  function _kt(f2, i, t2) {
    var h = i[4] === 0 || i[5] === 0 || i[0] === 0 ? 1 : Math.abs(2 * i[4] / i[0]), v4 = i[4] === 0 || i[5] === 0 || i[2] === 0 ? 1 : Math.abs(2 * i[4] / i[2]), _ = [f2 === "left" ? -h : f2 === "right" ? h : 0, f2 === "top" ? -v4 : f2 === "bottom" ? v4 : 0];
    return _ = C5(_, i, t2), Math.abs(_[0]) > Math.abs(_[1]) ? _[0] > 0 ? "right" : "left" : _[1] > 0 ? "bottom" : "top";
  }
  function TNe(f2) {
    return !f2.isGroup;
  }
  function yhr(f2) {
    return f2.shape != null;
  }
  function Dgt(f2, i, t2) {
    if (!f2 || !i)
      return;
    function h(M2) {
      var I2 = {};
      return M2.traverse(function(P2) {
        TNe(P2) && P2.anid && (I2[P2.anid] = P2);
      }), I2;
    }
    function v4(M2) {
      var I2 = { x: M2.x, y: M2.y, rotation: M2.rotation };
      return yhr(M2) && (I2.shape = ba2({}, M2.shape)), I2;
    }
    var _ = h(f2);
    i.traverse(function(M2) {
      if (TNe(M2) && M2.anid) {
        var I2 = _[M2.anid];
        if (I2) {
          var P2 = v4(M2);
          M2.attr(v4(I2)), jh2(M2, P2, t2, Du(M2).dataIndex);
        }
      }
    });
  }
  function Rje(f2, i) {
    return Xa2(f2, function(t2) {
      var h = t2[0];
      h = mEt(h, i.x), h = bEt(h, i.x + i.width);
      var v4 = t2[1];
      return v4 = mEt(v4, i.y), v4 = bEt(v4, i.y + i.height), [h, v4];
    });
  }
  function mhr(f2, i) {
    var t2 = mEt(f2.x, i.x), h = bEt(f2.x + f2.width, i.x + i.width), v4 = mEt(f2.y, i.y), _ = bEt(f2.y + f2.height, i.y + i.height);
    if (h >= t2 && _ >= v4)
      return { x: t2, y: v4, width: h - t2, height: _ - v4 };
  }
  function Egt(f2, i, t2) {
    var h = ba2({ rectHover: true }, i), v4 = h.style = { strokeNoScale: true };
    if (t2 = t2 || { x: -1, y: -1, width: 2, height: 2 }, f2)
      return f2.indexOf("image://") === 0 ? (v4.image = f2.slice(8), Ul(v4, t2), new Ux(h)) : bkt(f2.replace("path://", ""), h, t2, "center");
  }
  function mdt(f2, i, t2, h, v4) {
    for (var _ = 0, M2 = v4[v4.length - 1]; _ < v4.length; _++) {
      var I2 = v4[_];
      if (Nje(f2, i, t2, h, I2[0], I2[1], M2[0], M2[1]))
        return true;
      M2 = I2;
    }
  }
  function Nje(f2, i, t2, h, v4, _, M2, I2) {
    var P2 = t2 - f2, N3 = h - i, z3 = M2 - v4, H2 = I2 - _, $ = gXt(z3, H2, P2, N3);
    if (bhr($))
      return false;
    var et = f2 - v4, at = i - _, ht = gXt(et, at, P2, N3) / $;
    if (ht < 0 || ht > 1)
      return false;
    var bt = gXt(et, at, z3, H2) / $;
    return !(bt < 0 || bt > 1);
  }
  function gXt(f2, i, t2, h) {
    return f2 * h - t2 * i;
  }
  function bhr(f2) {
    return f2 <= 1e-6 && f2 >= -1e-6;
  }
  function eet(f2) {
    var i = f2.itemTooltipOption, t2 = f2.componentModel, h = f2.itemName, v4 = ms(i) ? { formatter: i } : i, _ = t2.mainType, M2 = t2.componentIndex, I2 = { componentType: _, name: h, $vars: ["name"] };
    I2[_ + "Index"] = M2;
    var P2 = f2.formatterParamsExtra;
    P2 && Qe2(Of2(P2), function(z3) {
      qs(I2, z3) || (I2[z3] = P2[z3], I2.$vars.push(z3));
    });
    var N3 = Du(f2.el);
    N3.componentMainType = _, N3.componentIndex = M2, N3.tooltipConfig = { name: h, option: Ul({ content: h, formatterParams: I2 }, v4) };
  }
  function ANe(f2, i) {
    var t2;
    f2.isGroup && (t2 = i(f2)), t2 || f2.traverse(i);
  }
  function oV(f2, i) {
    if (f2)
      if (Za2(f2))
        for (var t2 = 0; t2 < f2.length; t2++)
          ANe(f2[t2], i);
      else
        ANe(f2, i);
  }
  I5("circle", UL);
  I5("ellipse", Bee);
  I5("sector", rC);
  I5("ring", ykt);
  I5("polygon", iC);
  I5("polyline", aC);
  I5("rect", Sh2);
  I5("line", m_);
  I5("bezierCurve", mkt);
  I5("arc", zee);
  var kgt = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: jh2, initProps: Qv, removeElement: Q7, removeElementWithFadeOut: tgt, isElementRemoved: Rtt, extendShape: hhr, extendPath: dhr, registerShape: I5, getShapeClass: Gee, makePath: bkt, makeImage: Pje, mergePath: KD, resizePath: Oje, subPixelOptimizeLine: ghr, subPixelOptimizeRect: vhr, subPixelOptimize: $Dt, getTransform: cU, applyTransform: C5, transformDirection: _kt, groupTransition: Dgt, clipPointsByRect: Rje, clipRectByRect: mhr, createIcon: Egt, linePolygonIntersect: mdt, lineLineIntersect: Nje, setTooltipConfig: eet, traverseElements: oV, Group: mu, Image: Ux, Text: op, Circle: UL, Ellipse: Bee, Sector: rC, Ring: ykt, Polygon: iC, Polyline: aC, Rect: Sh2, Line: m_, BezierCurve: mkt, Arc: zee, IncrementalDisplayable: chr, CompoundPath: jee, LinearGradient: Igt, RadialGradient: Eje, BoundingRect: Lc2, OrientedBoundingRect: yEt, Point: ac2, Path: Uc2 }, Symbol.toStringTag, { value: "Module" })), xkt = {};
  function Fje(f2, i) {
    for (var t2 = 0; t2 < j2.length; t2++) {
      var h = j2[t2], v4 = i[h], _ = f2.ensureState(h);
      _.style = _.style || {}, _.style.text = v4;
    }
    var M2 = f2.currentStates.slice();
    f2.clearStates(true), f2.setStyle({ text: i.normal }), f2.useStates(M2, true);
  }
  function qJt(f2, i, t2) {
    var h = f2.labelFetcher, v4 = f2.labelDataIndex, _ = f2.labelDimIndex, M2 = i.normal, I2;
    h && (I2 = h.getFormattedLabel(v4, "normal", null, _, M2 && M2.get("formatter"), t2 != null ? { interpolatedValue: t2 } : null)), I2 == null && (I2 = Ol(f2.defaultText) ? f2.defaultText(v4, f2, t2) : f2.defaultText);
    for (var P2 = { normal: I2 }, N3 = 0; N3 < j2.length; N3++) {
      var z3 = j2[N3], H2 = i[z3];
      P2[z3] = _c2(h ? h.getFormattedLabel(v4, z3, null, _, H2 && H2.get("formatter")) : null, I2);
    }
    return P2;
  }
  function SS(f2, i, t2, h) {
    t2 = t2 || xkt;
    for (var v4 = f2 instanceof op, _ = false, M2 = 0; M2 < Qdt.length; M2++) {
      var I2 = i[Qdt[M2]];
      if (I2 && I2.getShallow("show")) {
        _ = true;
        break;
      }
    }
    var P2 = v4 ? f2 : f2.getTextContent();
    if (_) {
      v4 || (P2 || (P2 = new op(), f2.setTextContent(P2)), f2.stateProxy && (P2.stateProxy = f2.stateProxy));
      var N3 = qJt(t2, i), z3 = i.normal, H2 = !!z3.getShallow("show"), $ = By(z3, h && h.normal, t2, false, !v4);
      $.text = N3.normal, v4 || f2.setTextConfig(_Et(z3, t2, false));
      for (var M2 = 0; M2 < j2.length; M2++) {
        var et = j2[M2], I2 = i[et];
        if (I2) {
          var at = P2.ensureState(et), ht = !!_c2(I2.getShallow("show"), H2);
          if (ht !== H2 && (at.ignore = !ht), at.style = By(I2, h && h[et], t2, true, !v4), at.style.text = N3[et], !v4) {
            var bt = f2.ensureState(et);
            bt.textConfig = _Et(I2, t2, true);
          }
        }
      }
      P2.silent = !!z3.getShallow("silent"), P2.style.x != null && ($.x = P2.style.x), P2.style.y != null && ($.y = P2.style.y), P2.ignore = !H2, P2.useStyle($), P2.dirty(), t2.enableTextSetter && (net(P2).setLabelText = function(_t) {
        var Et = qJt(t2, i, _t);
        Fje(P2, Et);
      });
    } else
      P2 && (P2.ignore = true);
    f2.dirty();
  }
  function b_(f2, i) {
    i = i || "label";
    for (var t2 = { normal: f2.getModel(i) }, h = 0; h < j2.length; h++) {
      var v4 = j2[h];
      t2[v4] = f2.getModel([v4, i]);
    }
    return t2;
  }
  function By(f2, i, t2, h, v4) {
    var _ = {};
    return _hr(_, f2, t2, h, v4), i && ba2(_, i), _;
  }
  function _Et(f2, i, t2) {
    i = i || {};
    var h = {}, v4, _ = f2.getShallow("rotate"), M2 = _c2(f2.getShallow("distance"), t2 ? null : 5), I2 = f2.getShallow("offset");
    return v4 = f2.getShallow("position") || (t2 ? null : "inside"), v4 === "outside" && (v4 = i.defaultOutsidePosition || "top"), v4 != null && (h.position = v4), I2 != null && (h.offset = I2), _ != null && (_ *= Math.PI / 180, h.rotation = _), M2 != null && (h.distance = M2), h.outsideFill = f2.get("color") === "inherit" ? i.inheritColor || null : "auto", h;
  }
  function _hr(f2, i, t2, h, v4) {
    t2 = t2 || xkt;
    var _ = i.ecModel, M2 = _ && _.option.textStyle, I2 = xhr(i), P2;
    if (I2) {
      P2 = {};
      for (var N3 in I2)
        if (I2.hasOwnProperty(N3)) {
          var z3 = i.getModel(["rich", N3]);
          kNe(P2[N3] = {}, z3, M2, t2, h, v4, false, true);
        }
    }
    P2 && (f2.rich = P2);
    var H2 = i.get("overflow");
    H2 && (f2.overflow = H2);
    var $ = i.get("minMargin");
    $ != null && (f2.margin = $), kNe(f2, i, M2, t2, h, v4, true, false);
  }
  function xhr(f2) {
    for (var i; f2 && f2 !== f2.ecModel; ) {
      var t2 = (f2.option || xkt).rich;
      if (t2) {
        i = i || {};
        for (var h = Of2(t2), v4 = 0; v4 < h.length; v4++) {
          var _ = h[v4];
          i[_] = 1;
        }
      }
      f2 = f2.parentModel;
    }
    return i;
  }
  var INe = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], DNe = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], ENe = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
  function kNe(f2, i, t2, h, v4, _, M2, I2) {
    t2 = !v4 && t2 || xkt;
    var P2 = h && h.inheritColor, N3 = i.getShallow("color"), z3 = i.getShallow("textBorderColor"), H2 = _c2(i.getShallow("opacity"), t2.opacity);
    (N3 === "inherit" || N3 === "auto") && (P2 ? N3 = P2 : N3 = null), (z3 === "inherit" || z3 === "auto") && (P2 ? z3 = P2 : z3 = null), _ || (N3 = N3 || t2.color, z3 = z3 || t2.textBorderColor), N3 != null && (f2.fill = N3), z3 != null && (f2.stroke = z3);
    var $ = _c2(i.getShallow("textBorderWidth"), t2.textBorderWidth);
    $ != null && (f2.lineWidth = $);
    var et = _c2(i.getShallow("textBorderType"), t2.textBorderType);
    et != null && (f2.lineDash = et);
    var at = _c2(i.getShallow("textBorderDashOffset"), t2.textBorderDashOffset);
    at != null && (f2.lineDashOffset = at), !v4 && H2 == null && !I2 && (H2 = h && h.defaultOpacity), H2 != null && (f2.opacity = H2), !v4 && !_ && f2.fill == null && h.inheritColor && (f2.fill = h.inheritColor);
    for (var ht = 0; ht < INe.length; ht++) {
      var bt = INe[ht], _t = _c2(i.getShallow(bt), t2[bt]);
      _t != null && (f2[bt] = _t);
    }
    for (var ht = 0; ht < DNe.length; ht++) {
      var bt = DNe[ht], _t = i.getShallow(bt);
      _t != null && (f2[bt] = _t);
    }
    if (f2.verticalAlign == null) {
      var Et = i.getShallow("baseline");
      Et != null && (f2.verticalAlign = Et);
    }
    if (!M2 || !h.disableBox) {
      for (var ht = 0; ht < ENe.length; ht++) {
        var bt = ENe[ht], _t = i.getShallow(bt);
        _t != null && (f2[bt] = _t);
      }
      var zt = i.getShallow("borderType");
      zt != null && (f2.borderDash = zt), (f2.backgroundColor === "auto" || f2.backgroundColor === "inherit") && P2 && (f2.backgroundColor = P2), (f2.borderColor === "auto" || f2.borderColor === "inherit") && P2 && (f2.borderColor = P2);
    }
  }
  function Vje(f2, i) {
    var t2 = i && i.getModel("textStyle");
    return w5([f2.fontStyle || t2 && t2.getShallow("fontStyle") || "", f2.fontWeight || t2 && t2.getShallow("fontWeight") || "", (f2.fontSize || t2 && t2.getShallow("fontSize") || 12) + "px", f2.fontFamily || t2 && t2.getShallow("fontFamily") || "sans-serif"].join(" "));
  }
  var net = Wh2();
  function Bje(f2, i, t2, h) {
    if (!!f2) {
      var v4 = net(f2);
      v4.prevValue = v4.value, v4.value = t2;
      var _ = i.normal;
      v4.valueAnimation = _.get("valueAnimation"), v4.valueAnimation && (v4.precision = _.get("precision"), v4.defaultInterpolatedText = h, v4.statesModels = i);
    }
  }
  function zje(f2, i, t2, h, v4) {
    var _ = net(f2);
    if (!_.valueAnimation || _.prevValue === _.value)
      return;
    var M2 = _.defaultInterpolatedText, I2 = _c2(_.interpolatedValue, _.prevValue), P2 = _.value;
    function N3(z3) {
      var H2 = jze(t2, _.precision, I2, P2, z3);
      _.interpolatedValue = z3 === 1 ? null : H2;
      var $ = qJt({ labelDataIndex: i, labelFetcher: v4, defaultText: M2 ? M2(H2) : H2 + "" }, _.statesModels, H2);
      Fje(f2, $);
    }
    f2.percent = 0, (_.prevValue == null ? Qv : jh2)(f2, { percent: 1 }, h, i, null, N3);
  }
  var whr = ["textStyle", "color"], vXt = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], yXt = new op(), Shr = function() {
    function f2() {
    }
    return f2.prototype.getTextColor = function(i) {
      var t2 = this.ecModel;
      return this.getShallow("color") || (!i && t2 ? t2.get(whr) : null);
    }, f2.prototype.getFont = function() {
      return Vje({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
    }, f2.prototype.getTextRect = function(i) {
      for (var t2 = { text: i, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, h = 0; h < vXt.length; h++)
        t2[vXt[h]] = this.getShallow(vXt[h]);
      return yXt.useStyle(t2), yXt.update(), yXt.getBoundingRect();
    }, f2;
  }(), Mhr = Shr, jje = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], Chr = yU(jje), Thr = function() {
    function f2() {
    }
    return f2.prototype.getLineStyle = function(i) {
      return Chr(this, i);
    }, f2;
  }(), Wje = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], Ahr = yU(Wje), Ihr = function() {
    function f2() {
    }
    return f2.prototype.getItemStyle = function(i, t2) {
      return Ahr(this, i, t2);
    }, f2;
  }(), MU = function() {
    function f2(i, t2, h) {
      this.parentModel = t2, this.ecModel = h, this.option = i;
    }
    return f2.prototype.init = function(i, t2, h) {
      for (var v4 = [], _ = 3; _ < arguments.length; _++)
        v4[_ - 3] = arguments[_];
    }, f2.prototype.mergeOption = function(i, t2) {
      cc2(this.option, i, true);
    }, f2.prototype.get = function(i, t2) {
      return i == null ? this.option : this._doGet(this.parsePath(i), !t2 && this.parentModel);
    }, f2.prototype.getShallow = function(i, t2) {
      var h = this.option, v4 = h == null ? h : h[i];
      if (v4 == null && !t2) {
        var _ = this.parentModel;
        _ && (v4 = _.getShallow(i));
      }
      return v4;
    }, f2.prototype.getModel = function(i, t2) {
      var h = i != null, v4 = h ? this.parsePath(i) : null, _ = h ? this._doGet(v4) : this.option;
      return t2 = t2 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(v4)), new f2(_, t2, this.ecModel);
    }, f2.prototype.isEmpty = function() {
      return this.option == null;
    }, f2.prototype.restoreData = function() {
    }, f2.prototype.clone = function() {
      var i = this.constructor;
      return new i(pu(this.option));
    }, f2.prototype.parsePath = function(i) {
      return typeof i == "string" ? i.split(".") : i;
    }, f2.prototype.resolveParentPath = function(i) {
      return i;
    }, f2.prototype.isAnimationEnabled = function() {
      if (!gp.node && this.option) {
        if (this.option.animation != null)
          return !!this.option.animation;
        if (this.parentModel)
          return this.parentModel.isAnimationEnabled();
      }
    }, f2.prototype._doGet = function(i, t2) {
      var h = this.option;
      if (!i)
        return h;
      for (var v4 = 0; v4 < i.length && !(!!i[v4] && (h = h && typeof h == "object" ? h[i[v4]] : null, h == null)); v4++)
        ;
      return h == null && t2 && (h = t2._doGet(this.resolveParentPath(i), t2.parentModel)), h;
    }, f2;
  }();
  Pee(MU);
  Ccr(MU);
  Sm(MU, Thr);
  Sm(MU, Ihr);
  Sm(MU, Ecr);
  Sm(MU, Mhr);
  var Gg2 = MU, Dhr = Math.round(Math.random() * 10);
  function ret(f2) {
    return [f2 || "", Dhr++].join("_");
  }
  function Ehr(f2) {
    var i = {};
    f2.registerSubTypeDefaulter = function(t2, h) {
      var v4 = LL(t2);
      i[v4.main] = h;
    }, f2.determineSubType = function(t2, h) {
      var v4 = h.type;
      if (!v4) {
        var _ = LL(t2).main;
        f2.hasSubTypes(t2) && i[_] && (v4 = i[_](h));
      }
      return v4;
    };
  }
  function khr(f2, i) {
    f2.topologicalTravel = function(_, M2, I2, P2) {
      if (!_.length)
        return;
      var N3 = t2(M2), z3 = N3.graph, H2 = N3.noEntryList, $ = {};
      for (Qe2(_, function(Et) {
        $[Et] = true;
      }); H2.length; ) {
        var et = H2.pop(), at = z3[et], ht = !!$[et];
        ht && (I2.call(P2, et, at.originalDeps.slice()), delete $[et]), Qe2(at.successor, ht ? _t : bt);
      }
      Qe2($, function() {
        var Et = "";
        throw new Error(Et);
      });
      function bt(Et) {
        z3[Et].entryCount--, z3[Et].entryCount === 0 && H2.push(Et);
      }
      function _t(Et) {
        $[Et] = true, bt(Et);
      }
    };
    function t2(_) {
      var M2 = {}, I2 = [];
      return Qe2(_, function(P2) {
        var N3 = h(M2, P2), z3 = N3.originalDeps = i(P2), H2 = v4(z3, _);
        N3.entryCount = H2.length, N3.entryCount === 0 && I2.push(P2), Qe2(H2, function($) {
          Pc2(N3.predecessor, $) < 0 && N3.predecessor.push($);
          var et = h(M2, $);
          Pc2(et.successor, $) < 0 && et.successor.push(P2);
        });
      }), { graph: M2, noEntryList: I2 };
    }
    function h(_, M2) {
      return _[M2] || (_[M2] = { predecessor: [], successor: [] }), _[M2];
    }
    function v4(_, M2) {
      var I2 = [];
      return Qe2(_, function(P2) {
        Pc2(M2, P2) >= 0 && I2.push(P2);
      }), I2;
    }
  }
  function sV(f2, i) {
    return cc2(cc2({}, f2, true), i, true);
  }
  var Phr = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, Lhr = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, xEt = "ZH", Hee = "EN", egt = Hee, YDt = {}, Uee = {}, Gje = gp.domSupported ? function() {
    var f2 = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
    return f2.indexOf(xEt) > -1 ? xEt : egt;
  }() : egt;
  function Hje(f2, i) {
    f2 = f2.toUpperCase(), Uee[f2] = new Gg2(i), YDt[f2] = i;
  }
  function Ohr(f2) {
    if (ms(f2)) {
      var i = YDt[f2.toUpperCase()] || {};
      return f2 === xEt || f2 === Hee ? pu(i) : cc2(pu(i), pu(YDt[egt]), false);
    } else
      return cc2(pu(f2), pu(YDt[egt]), false);
  }
  function ZJt(f2) {
    return Uee[f2];
  }
  function Rhr() {
    return Uee[egt];
  }
  Hje(Hee, Phr);
  Hje(xEt, Lhr);
  var qee = 1e3, Zee = qee * 60, Rdt = Zee * 60, XD = Rdt * 24, PNe = XD * 365, bdt = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, ZIt = "{yyyy}-{MM}-{dd}", LNe = { year: "{yyyy}", month: "{yyyy}-{MM}", day: ZIt, hour: ZIt + " " + bdt.hour, minute: ZIt + " " + bdt.minute, second: ZIt + " " + bdt.second, millisecond: bdt.none }, mXt = ["year", "month", "day", "hour", "minute", "second", "millisecond"], Uje = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
  function PH(f2, i) {
    return f2 += "", "0000".substr(0, i - f2.length) + f2;
  }
  function Ntt(f2) {
    switch (f2) {
      case "half-year":
      case "quarter":
        return "month";
      case "week":
      case "half-week":
        return "day";
      case "half-day":
      case "quarter-day":
        return "hour";
      default:
        return f2;
    }
  }
  function Nhr(f2) {
    return f2 === Ntt(f2);
  }
  function Fhr(f2) {
    switch (f2) {
      case "year":
      case "month":
        return "day";
      case "millisecond":
        return "millisecond";
      default:
        return "second";
    }
  }
  function wkt(f2, i, t2, h) {
    var v4 = GL(f2), _ = v4[$ee(t2)](), M2 = v4[Ftt(t2)]() + 1, I2 = Math.floor((M2 - 1) / 4) + 1, P2 = v4[Skt(t2)](), N3 = v4["get" + (t2 ? "UTC" : "") + "Day"](), z3 = v4[ngt(t2)](), H2 = (z3 - 1) % 12 + 1, $ = v4[Mkt(t2)](), et = v4[Ckt(t2)](), at = v4[Tkt(t2)](), ht = h instanceof Gg2 ? h : ZJt(h || Gje) || Rhr(), bt = ht.getModel("time"), _t = bt.get("month"), Et = bt.get("monthAbbr"), zt = bt.get("dayOfWeek"), Ft = bt.get("dayOfWeekAbbr");
    return (i || "").replace(/{yyyy}/g, _ + "").replace(/{yy}/g, _ % 100 + "").replace(/{Q}/g, I2 + "").replace(/{MMMM}/g, _t[M2 - 1]).replace(/{MMM}/g, Et[M2 - 1]).replace(/{MM}/g, PH(M2, 2)).replace(/{M}/g, M2 + "").replace(/{dd}/g, PH(P2, 2)).replace(/{d}/g, P2 + "").replace(/{eeee}/g, zt[N3]).replace(/{ee}/g, Ft[N3]).replace(/{e}/g, N3 + "").replace(/{HH}/g, PH(z3, 2)).replace(/{H}/g, z3 + "").replace(/{hh}/g, PH(H2 + "", 2)).replace(/{h}/g, H2 + "").replace(/{mm}/g, PH($, 2)).replace(/{m}/g, $ + "").replace(/{ss}/g, PH(et, 2)).replace(/{s}/g, et + "").replace(/{SSS}/g, PH(at, 3)).replace(/{S}/g, at + "");
  }
  function Vhr(f2, i, t2, h, v4) {
    var _ = null;
    if (ms(t2))
      _ = t2;
    else if (Ol(t2))
      _ = t2(f2.value, i, { level: f2.level });
    else {
      var M2 = ba2({}, bdt);
      if (f2.level > 0)
        for (var I2 = 0; I2 < mXt.length; ++I2)
          M2[mXt[I2]] = "{primary|" + M2[mXt[I2]] + "}";
      var P2 = t2 ? t2.inherit === false ? t2 : Ul(t2, M2) : M2, N3 = qje(f2.value, v4);
      if (P2[N3])
        _ = P2[N3];
      else if (P2.inherit) {
        for (var z3 = Uje.indexOf(N3), I2 = z3 - 1; I2 >= 0; --I2)
          if (P2[N3]) {
            _ = P2[N3];
            break;
          }
        _ = _ || M2.none;
      }
      if (Za2(_)) {
        var H2 = f2.level == null ? 0 : f2.level >= 0 ? f2.level : _.length + f2.level;
        H2 = Math.min(H2, _.length - 1), _ = _[H2];
      }
    }
    return wkt(new Date(f2.value), _, v4, h);
  }
  function qje(f2, i) {
    var t2 = GL(f2), h = t2[Ftt(i)]() + 1, v4 = t2[Skt(i)](), _ = t2[ngt(i)](), M2 = t2[Mkt(i)](), I2 = t2[Ckt(i)](), P2 = t2[Tkt(i)](), N3 = P2 === 0, z3 = N3 && I2 === 0, H2 = z3 && M2 === 0, $ = H2 && _ === 0, et = $ && v4 === 1, at = et && h === 1;
    return at ? "year" : et ? "month" : $ ? "day" : H2 ? "hour" : z3 ? "minute" : N3 ? "second" : "millisecond";
  }
  function ONe(f2, i, t2) {
    var h = vp(f2) ? GL(f2) : f2;
    switch (i = i || qje(f2, t2), i) {
      case "year":
        return h[$ee(t2)]();
      case "half-year":
        return h[Ftt(t2)]() >= 6 ? 1 : 0;
      case "quarter":
        return Math.floor((h[Ftt(t2)]() + 1) / 4);
      case "month":
        return h[Ftt(t2)]();
      case "day":
        return h[Skt(t2)]();
      case "half-day":
        return h[ngt(t2)]() / 24;
      case "hour":
        return h[ngt(t2)]();
      case "minute":
        return h[Mkt(t2)]();
      case "second":
        return h[Ckt(t2)]();
      case "millisecond":
        return h[Tkt(t2)]();
    }
  }
  function $ee(f2) {
    return f2 ? "getUTCFullYear" : "getFullYear";
  }
  function Ftt(f2) {
    return f2 ? "getUTCMonth" : "getMonth";
  }
  function Skt(f2) {
    return f2 ? "getUTCDate" : "getDate";
  }
  function ngt(f2) {
    return f2 ? "getUTCHours" : "getHours";
  }
  function Mkt(f2) {
    return f2 ? "getUTCMinutes" : "getMinutes";
  }
  function Ckt(f2) {
    return f2 ? "getUTCSeconds" : "getSeconds";
  }
  function Tkt(f2) {
    return f2 ? "getUTCMilliseconds" : "getMilliseconds";
  }
  function Bhr(f2) {
    return f2 ? "setUTCFullYear" : "setFullYear";
  }
  function Zje(f2) {
    return f2 ? "setUTCMonth" : "setMonth";
  }
  function $je(f2) {
    return f2 ? "setUTCDate" : "setDate";
  }
  function Yje(f2) {
    return f2 ? "setUTCHours" : "setHours";
  }
  function Kje(f2) {
    return f2 ? "setUTCMinutes" : "setMinutes";
  }
  function Xje(f2) {
    return f2 ? "setUTCSeconds" : "setSeconds";
  }
  function Qje(f2) {
    return f2 ? "setUTCMilliseconds" : "setMilliseconds";
  }
  function Jje(f2) {
    if (!Lze(f2))
      return ms(f2) ? f2 : "-";
    var i = (f2 + "").split(".");
    return i[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (i.length > 1 ? "." + i[1] : "");
  }
  function tWe(f2, i) {
    return f2 = (f2 || "").toLowerCase().replace(/-(.)/g, function(t2, h) {
      return h.toUpperCase();
    }), i && f2 && (f2 = f2.charAt(0).toUpperCase() + f2.slice(1)), f2;
  }
  var iet = wee, zhr = /([&<>"'])/g, jhr = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
  function HT(f2) {
    return f2 == null ? "" : (f2 + "").replace(zhr, function(i, t2) {
      return jhr[t2];
    });
  }
  function $Jt(f2, i, t2) {
    var h = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
    function v4(z3) {
      return z3 && w5(z3) ? z3 : "-";
    }
    function _(z3) {
      return !!(z3 != null && !isNaN(z3) && isFinite(z3));
    }
    var M2 = i === "time", I2 = f2 instanceof Date;
    if (M2 || I2) {
      var P2 = M2 ? GL(f2) : f2;
      if (isNaN(+P2)) {
        if (I2)
          return "-";
      } else
        return wkt(P2, h, t2);
    }
    if (i === "ordinal")
      return hJt(f2) ? v4(f2) : vp(f2) && _(f2) ? f2 + "" : "-";
    var N3 = tN(f2);
    return _(N3) ? Jje(N3) : hJt(f2) ? v4(f2) : typeof f2 == "boolean" ? f2 + "" : "-";
  }
  var RNe = ["a", "b", "c", "d", "e", "f", "g"], bXt = function(f2, i) {
    return "{" + f2 + (i == null ? "" : i) + "}";
  };
  function eWe(f2, i, t2) {
    Za2(i) || (i = [i]);
    var h = i.length;
    if (!h)
      return "";
    for (var v4 = i[0].$vars || [], _ = 0; _ < v4.length; _++) {
      var M2 = RNe[_];
      f2 = f2.replace(bXt(M2), bXt(M2, 0));
    }
    for (var I2 = 0; I2 < h; I2++)
      for (var P2 = 0; P2 < v4.length; P2++) {
        var N3 = i[I2][v4[P2]];
        f2 = f2.replace(bXt(RNe[P2], I2), t2 ? HT(N3) : N3);
      }
    return f2;
  }
  function Whr(f2, i, t2) {
    return Qe2(i, function(h, v4) {
      f2 = f2.replace("{" + v4 + "}", t2 ? HT(h) : h);
    }), f2;
  }
  function Ghr(f2, i) {
    var t2 = ms(f2) ? { color: f2, extraCssText: i } : f2 || {}, h = t2.color, v4 = t2.type;
    i = t2.extraCssText;
    var _ = t2.renderMode || "html";
    if (!h)
      return "";
    if (_ === "html")
      return v4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + HT(h) + ";" + (i || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + HT(h) + ";" + (i || "") + '"></span>';
    var M2 = t2.markerId || "markerX";
    return { renderMode: _, content: "{" + M2 + "|}  ", style: v4 === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: h } : { width: 10, height: 10, borderRadius: 5, backgroundColor: h } };
  }
  function bU(f2, i) {
    return i = i || "transparent", ms(f2) ? f2 : Xl(f2) && f2.colorStops && (f2.colorStops[0] || {}).color || i;
  }
  function wEt(f2, i) {
    if (i === "_blank" || i === "blank") {
      var t2 = window.open();
      t2.opener = null, t2.location.href = f2;
    } else
      window.open(f2, i);
  }
  var KDt = Qe2, nWe = ["left", "right", "top", "bottom", "width", "height"], rU = [["width", "left", "right"], ["height", "top", "bottom"]];
  function Yee(f2, i, t2, h, v4) {
    var _ = 0, M2 = 0;
    h == null && (h = 1 / 0), v4 == null && (v4 = 1 / 0);
    var I2 = 0;
    i.eachChild(function(P2, N3) {
      var z3 = P2.getBoundingRect(), H2 = i.childAt(N3 + 1), $ = H2 && H2.getBoundingRect(), et, at;
      if (f2 === "horizontal") {
        var ht = z3.width + ($ ? -$.x + z3.x : 0);
        et = _ + ht, et > h || P2.newline ? (_ = 0, et = ht, M2 += I2 + t2, I2 = z3.height) : I2 = Math.max(I2, z3.height);
      } else {
        var bt = z3.height + ($ ? -$.y + z3.y : 0);
        at = M2 + bt, at > v4 || P2.newline ? (_ += I2 + t2, M2 = 0, at = bt, I2 = z3.width) : I2 = Math.max(I2, z3.width);
      }
      P2.newline || (P2.x = _, P2.y = M2, P2.markRedraw(), f2 === "horizontal" ? _ = et + t2 : M2 = at + t2);
    });
  }
  var fU = Yee;
  Ou(Yee, "vertical");
  Ou(Yee, "horizontal");
  function Hhr(f2, i, t2) {
    var h = i.width, v4 = i.height, _ = cs(f2.left, h), M2 = cs(f2.top, v4), I2 = cs(f2.right, h), P2 = cs(f2.bottom, v4);
    return (isNaN(_) || isNaN(parseFloat(f2.left))) && (_ = 0), (isNaN(I2) || isNaN(parseFloat(f2.right))) && (I2 = h), (isNaN(M2) || isNaN(parseFloat(f2.top))) && (M2 = 0), (isNaN(P2) || isNaN(parseFloat(f2.bottom))) && (P2 = v4), t2 = iet(t2 || 0), { width: Math.max(I2 - _ - t2[1] - t2[3], 0), height: Math.max(P2 - M2 - t2[0] - t2[2], 0) };
  }
  function u1(f2, i, t2) {
    t2 = iet(t2 || 0);
    var h = i.width, v4 = i.height, _ = cs(f2.left, h), M2 = cs(f2.top, v4), I2 = cs(f2.right, h), P2 = cs(f2.bottom, v4), N3 = cs(f2.width, h), z3 = cs(f2.height, v4), H2 = t2[2] + t2[0], $ = t2[1] + t2[3], et = f2.aspect;
    switch (isNaN(N3) && (N3 = h - I2 - $ - _), isNaN(z3) && (z3 = v4 - P2 - H2 - M2), et != null && (isNaN(N3) && isNaN(z3) && (et > h / v4 ? N3 = h * 0.8 : z3 = v4 * 0.8), isNaN(N3) && (N3 = et * z3), isNaN(z3) && (z3 = N3 / et)), isNaN(_) && (_ = h - I2 - N3 - $), isNaN(M2) && (M2 = v4 - P2 - z3 - H2), f2.left || f2.right) {
      case "center":
        _ = h / 2 - N3 / 2 - t2[3];
        break;
      case "right":
        _ = h - N3 - $;
        break;
    }
    switch (f2.top || f2.bottom) {
      case "middle":
      case "center":
        M2 = v4 / 2 - z3 / 2 - t2[0];
        break;
      case "bottom":
        M2 = v4 - z3 - H2;
        break;
    }
    _ = _ || 0, M2 = M2 || 0, isNaN(N3) && (N3 = h - $ - _ - (I2 || 0)), isNaN(z3) && (z3 = v4 - H2 - M2 - (P2 || 0));
    var at = new Lc2(_ + t2[3], M2 + t2[0], N3, z3);
    return at.margin = t2, at;
  }
  function Akt(f2, i, t2, h, v4, _) {
    var M2 = !v4 || !v4.hv || v4.hv[0], I2 = !v4 || !v4.hv || v4.hv[1], P2 = v4 && v4.boundingMode || "all";
    if (_ = _ || f2, _.x = f2.x, _.y = f2.y, !M2 && !I2)
      return false;
    var N3;
    if (P2 === "raw")
      N3 = f2.type === "group" ? new Lc2(0, 0, +i.width || 0, +i.height || 0) : f2.getBoundingRect();
    else if (N3 = f2.getBoundingRect(), f2.needLocalTransform()) {
      var z3 = f2.getLocalTransform();
      N3 = N3.clone(), N3.applyTransform(z3);
    }
    var H2 = u1(Ul({ width: N3.width, height: N3.height }, i), t2, h), $ = M2 ? H2.x - N3.x : 0, et = I2 ? H2.y - N3.y : 0;
    return P2 === "raw" ? (_.x = $, _.y = et) : (_.x += $, _.y += et), _ === f2 && f2.markRedraw(), true;
  }
  function Uhr(f2, i) {
    return f2[rU[i][0]] != null || f2[rU[i][1]] != null && f2[rU[i][2]] != null;
  }
  function rgt(f2) {
    var i = f2.layoutMode || f2.constructor.layoutMode;
    return Xl(i) ? i : i ? { type: i } : null;
  }
  function J7(f2, i, t2) {
    var h = t2 && t2.ignoreSize;
    !Za2(h) && (h = [h, h]);
    var v4 = M2(rU[0], 0), _ = M2(rU[1], 1);
    N3(rU[0], f2, v4), N3(rU[1], f2, _);
    function M2(z3, H2) {
      var $ = {}, et = 0, at = {}, ht = 0, bt = 2;
      if (KDt(z3, function(zt) {
        at[zt] = f2[zt];
      }), KDt(z3, function(zt) {
        I2(i, zt) && ($[zt] = at[zt] = i[zt]), P2($, zt) && et++, P2(at, zt) && ht++;
      }), h[H2])
        return P2(i, z3[1]) ? at[z3[2]] = null : P2(i, z3[2]) && (at[z3[1]] = null), at;
      if (ht === bt || !et)
        return at;
      if (et >= bt)
        return $;
      for (var _t = 0; _t < z3.length; _t++) {
        var Et = z3[_t];
        if (!I2($, Et) && I2(f2, Et)) {
          $[Et] = f2[Et];
          break;
        }
      }
      return $;
    }
    function I2(z3, H2) {
      return z3.hasOwnProperty(H2);
    }
    function P2(z3, H2) {
      return z3[H2] != null && z3[H2] !== "auto";
    }
    function N3(z3, H2, $) {
      KDt(z3, function(et) {
        H2[et] = $[et];
      });
    }
  }
  function aet(f2) {
    return rWe({}, f2);
  }
  function rWe(f2, i) {
    return i && f2 && KDt(nWe, function(t2) {
      i.hasOwnProperty(t2) && (f2[t2] = i[t2]);
    }), f2;
  }
  var qhr = Wh2(), oet = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this, t2, h, v4) || this;
      return _.uid = ret("ec_cpt_model"), _;
    }
    return i.prototype.init = function(t2, h, v4) {
      this.mergeDefaultAndTheme(t2, v4);
    }, i.prototype.mergeDefaultAndTheme = function(t2, h) {
      var v4 = rgt(this), _ = v4 ? aet(t2) : {}, M2 = h.getTheme();
      cc2(t2, M2.get(this.mainType)), cc2(t2, this.getDefaultOption()), v4 && J7(t2, _, v4);
    }, i.prototype.mergeOption = function(t2, h) {
      cc2(this.option, t2, true);
      var v4 = rgt(this);
      v4 && J7(this.option, t2, v4);
    }, i.prototype.optionUpdated = function(t2, h) {
    }, i.prototype.getDefaultOption = function() {
      var t2 = this.constructor;
      if (!wcr(t2))
        return t2.defaultOption;
      var h = qhr(this);
      if (!h.defaultOption) {
        for (var v4 = [], _ = t2; _; ) {
          var M2 = _.prototype.defaultOption;
          M2 && v4.push(M2), _ = _.superClass;
        }
        for (var I2 = {}, P2 = v4.length - 1; P2 >= 0; P2--)
          I2 = cc2(I2, v4[P2], true);
        h.defaultOption = I2;
      }
      return h.defaultOption;
    }, i.prototype.getReferringComponents = function(t2, h) {
      var v4 = t2 + "Index", _ = t2 + "Id";
      return Tgt(this.ecModel, t2, { index: this.get(v4, true), id: this.get(_, true) }, h);
    }, i.prototype.getBoxLayoutParams = function() {
      var t2 = this;
      return { left: t2.get("left"), top: t2.get("top"), right: t2.get("right"), bottom: t2.get("bottom"), width: t2.get("width"), height: t2.get("height") };
    }, i.prototype.getZLevelKey = function() {
      return "";
    }, i.prototype.setZLevel = function(t2) {
      this.option.zlevel = t2;
    }, i.protoInitialize = function() {
      var t2 = i.prototype;
      t2.type = "component", t2.id = "", t2.name = "", t2.mainType = "", t2.subType = "", t2.componentIndex = 0;
    }(), i;
  }(Gg2);
  Gze(oet, Gg2);
  fkt(oet);
  Ehr(oet);
  khr(oet, Zhr);
  function Zhr(f2) {
    var i = [];
    return Qe2(oet.getClassesByMainType(f2), function(t2) {
      i = i.concat(t2.dependencies || t2.prototype.dependencies || []);
    }), i = Xa2(i, function(t2) {
      return LL(t2).main;
    }), f2 !== "dataset" && Pc2(i, "dataset") <= 0 && i.unshift("dataset"), i;
  }
  var zh2 = oet, iWe = "";
  typeof navigator != "undefined" && (iWe = navigator.platform || "");
  var att = "rgba(0, 0, 0, 0.2)", $hr = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: att, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: att, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: att, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: att, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: att, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: att, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: iWe.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, aWe = Il(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), aE = "original", wS = "arrayRows", oE = "objectRows", qL = "keyedColumns", Z7 = "typedArray", oWe = "unknown", VL = "column", set2 = "row", jx = { Must: 1, Might: 2, Not: 3 }, sWe = Wh2();
  function Yhr(f2) {
    sWe(f2).datasetMap = Il();
  }
  function lWe(f2, i, t2) {
    var h = {}, v4 = Xee(i);
    if (!v4 || !f2)
      return h;
    var _ = [], M2 = [], I2 = i.ecModel, P2 = sWe(I2).datasetMap, N3 = v4.uid + "_" + t2.seriesLayoutBy, z3, H2;
    f2 = f2.slice(), Qe2(f2, function(ht, bt) {
      var _t = Xl(ht) ? ht : f2[bt] = { name: ht };
      _t.type === "ordinal" && z3 == null && (z3 = bt, H2 = at(_t)), h[_t.name] = [];
    });
    var $ = P2.get(N3) || P2.set(N3, { categoryWayDim: H2, valueWayDim: 0 });
    Qe2(f2, function(ht, bt) {
      var _t = ht.name, Et = at(ht);
      if (z3 == null) {
        var zt = $.valueWayDim;
        et(h[_t], zt, Et), et(M2, zt, Et), $.valueWayDim += Et;
      } else if (z3 === bt)
        et(h[_t], 0, Et), et(_, 0, Et);
      else {
        var zt = $.categoryWayDim;
        et(h[_t], zt, Et), et(M2, zt, Et), $.categoryWayDim += Et;
      }
    });
    function et(ht, bt, _t) {
      for (var Et = 0; Et < _t; Et++)
        ht.push(bt + Et);
    }
    function at(ht) {
      var bt = ht.dimsDef;
      return bt ? bt.length : 1;
    }
    return _.length && (h.itemName = _), M2.length && (h.seriesName = M2), h;
  }
  function Kee(f2, i, t2) {
    var h = {}, v4 = Xee(f2);
    if (!v4)
      return h;
    var _ = i.sourceFormat, M2 = i.dimensionsDefine, I2;
    (_ === oE || _ === qL) && Qe2(M2, function(z3, H2) {
      (Xl(z3) ? z3.name : z3) === "name" && (I2 = H2);
    });
    var P2 = function() {
      for (var z3 = {}, H2 = {}, $ = [], et = 0, at = Math.min(5, t2); et < at; et++) {
        var ht = cWe(i.data, _, i.seriesLayoutBy, M2, i.startIndex, et);
        $.push(ht);
        var bt = ht === jx.Not;
        if (bt && z3.v == null && et !== I2 && (z3.v = et), (z3.n == null || z3.n === z3.v || !bt && $[z3.n] === jx.Not) && (z3.n = et), _t(z3) && $[z3.n] !== jx.Not)
          return z3;
        bt || (ht === jx.Might && H2.v == null && et !== I2 && (H2.v = et), (H2.n == null || H2.n === H2.v) && (H2.n = et));
      }
      function _t(Et) {
        return Et.v != null && Et.n != null;
      }
      return _t(z3) ? z3 : _t(H2) ? H2 : null;
    }();
    if (P2) {
      h.value = [P2.v];
      var N3 = I2 != null ? I2 : P2.n;
      h.itemName = [N3], h.seriesName = [N3];
    }
    return h;
  }
  function Xee(f2) {
    var i = f2.get("data", true);
    if (!i)
      return Tgt(f2.ecModel, "dataset", { index: f2.get("datasetIndex", true), id: f2.get("datasetId", true) }, _m).models[0];
  }
  function Khr(f2) {
    return !f2.get("transform", true) && !f2.get("fromTransformResult", true) ? [] : Tgt(f2.ecModel, "dataset", { index: f2.get("fromDatasetIndex", true), id: f2.get("fromDatasetId", true) }, _m).models;
  }
  function uWe(f2, i) {
    return cWe(f2.data, f2.sourceFormat, f2.seriesLayoutBy, f2.dimensionsDefine, f2.startIndex, i);
  }
  function cWe(f2, i, t2, h, v4, _) {
    var M2, I2 = 5;
    if (YT(f2))
      return jx.Not;
    var P2, N3;
    if (h) {
      var z3 = h[_];
      Xl(z3) ? (P2 = z3.name, N3 = z3.type) : ms(z3) && (P2 = z3);
    }
    if (N3 != null)
      return N3 === "ordinal" ? jx.Must : jx.Not;
    if (i === wS) {
      var H2 = f2;
      if (t2 === set2) {
        for (var $ = H2[_], et = 0; et < ($ || []).length && et < I2; et++)
          if ((M2 = Ft($[v4 + et])) != null)
            return M2;
      } else
        for (var et = 0; et < H2.length && et < I2; et++) {
          var at = H2[v4 + et];
          if (at && (M2 = Ft(at[_])) != null)
            return M2;
        }
    } else if (i === oE) {
      var ht = f2;
      if (!P2)
        return jx.Not;
      for (var et = 0; et < ht.length && et < I2; et++) {
        var bt = ht[et];
        if (bt && (M2 = Ft(bt[P2])) != null)
          return M2;
      }
    } else if (i === qL) {
      var _t = f2;
      if (!P2)
        return jx.Not;
      var $ = _t[P2];
      if (!$ || YT($))
        return jx.Not;
      for (var et = 0; et < $.length && et < I2; et++)
        if ((M2 = Ft($[et])) != null)
          return M2;
    } else if (i === aE)
      for (var Et = f2, et = 0; et < Et.length && et < I2; et++) {
        var bt = Et[et], zt = Qtt(bt);
        if (!Za2(zt))
          return jx.Not;
        if ((M2 = Ft(zt[_])) != null)
          return M2;
      }
    function Ft(fe2) {
      var re2 = ms(fe2);
      if (fe2 != null && isFinite(fe2) && fe2 !== "")
        return re2 ? jx.Might : jx.Not;
      if (re2 && fe2 !== "-")
        return jx.Must;
    }
    return jx.Not;
  }
  var YJt = Il();
  function Xhr(f2, i) {
    z2(YJt.get(f2) == null && i), YJt.set(f2, i);
  }
  function Qhr(f2, i, t2) {
    var h = YJt.get(i);
    if (!h)
      return t2;
    var v4 = h(f2);
    return v4 ? t2.concat(v4) : t2;
  }
  var NNe = Wh2(), Jhr = Wh2(), Qee = function() {
    function f2() {
    }
    return f2.prototype.getColorFromPalette = function(i, t2, h) {
      var v4 = Od2(this.get("color", true)), _ = this.get("colorLayer", true);
      return fWe(this, NNe, v4, _, i, t2, h);
    }, f2.prototype.clearColorPalette = function() {
      epr(this, NNe);
    }, f2;
  }();
  function KJt(f2, i, t2, h) {
    var v4 = Od2(f2.get(["aria", "decal", "decals"]));
    return fWe(f2, Jhr, v4, null, i, t2, h);
  }
  function tpr(f2, i) {
    for (var t2 = f2.length, h = 0; h < t2; h++)
      if (f2[h].length > i)
        return f2[h];
    return f2[t2 - 1];
  }
  function fWe(f2, i, t2, h, v4, _, M2) {
    _ = _ || f2;
    var I2 = i(_), P2 = I2.paletteIdx || 0, N3 = I2.paletteNameMap = I2.paletteNameMap || {};
    if (N3.hasOwnProperty(v4))
      return N3[v4];
    var z3 = M2 == null || !h ? t2 : tpr(h, M2);
    if (z3 = z3 || t2, !(!z3 || !z3.length)) {
      var H2 = z3[P2];
      return v4 && (N3[v4] = H2), I2.paletteIdx = (P2 + 1) % z3.length, H2;
    }
  }
  function epr(f2, i) {
    i(f2).paletteIdx = 0, i(f2).paletteNameMap = {};
  }
  var $It, Hpt, FNe, VNe = "\0_ec_inner", npr = 1, hWe = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.init = function(t2, h, v4, _, M2, I2) {
      _ = _ || {}, this.option = null, this._theme = new Gg2(_), this._locale = new Gg2(M2), this._optionManager = I2;
    }, i.prototype.setOption = function(t2, h, v4) {
      var _ = jNe(h);
      this._optionManager.setOption(t2, v4, _), this._resetOption(null, _);
    }, i.prototype.resetOption = function(t2, h) {
      return this._resetOption(t2, jNe(h));
    }, i.prototype._resetOption = function(t2, h) {
      var v4 = false, _ = this._optionManager;
      if (!t2 || t2 === "recreate") {
        var M2 = _.mountOption(t2 === "recreate");
        !this.option || t2 === "recreate" ? FNe(this, M2) : (this.restoreData(), this._mergeOption(M2, h)), v4 = true;
      }
      if ((t2 === "timeline" || t2 === "media") && this.restoreData(), !t2 || t2 === "recreate" || t2 === "timeline") {
        var I2 = _.getTimelineOption(this);
        I2 && (v4 = true, this._mergeOption(I2, h));
      }
      if (!t2 || t2 === "recreate" || t2 === "media") {
        var P2 = _.getMediaOption(this);
        P2.length && Qe2(P2, function(N3) {
          v4 = true, this._mergeOption(N3, h);
        }, this);
      }
      return v4;
    }, i.prototype.mergeOption = function(t2) {
      this._mergeOption(t2, null);
    }, i.prototype._mergeOption = function(t2, h) {
      var v4 = this.option, _ = this._componentsMap, M2 = this._componentsCount, I2 = [], P2 = Il(), N3 = h && h.replaceMergeMainTypeMap;
      Yhr(this), Qe2(t2, function(H2, $) {
        H2 != null && (zh2.hasClass($) ? $ && (I2.push($), P2.set($, true)) : v4[$] = v4[$] == null ? pu(H2) : cc2(v4[$], H2, true));
      }), N3 && N3.each(function(H2, $) {
        zh2.hasClass($) && !P2.get($) && (I2.push($), P2.set($, true));
      }), zh2.topologicalTravel(I2, zh2.getAllClassMainTypes(), z3, this);
      function z3(H2) {
        var $ = Qhr(this, H2, Od2(t2[H2])), et = _.get(H2), at = et ? N3 && N3.get(H2) ? "replaceMerge" : "normalMerge" : "replaceAll", ht = Vze(et, $, at);
        pcr(ht, H2, zh2), v4[H2] = null, _.set(H2, null), M2.set(H2, 0);
        var bt = [], _t = [], Et = 0, zt;
        Qe2(ht, function(Ft, fe2) {
          var re2 = Ft.existing, ye = Ft.newOption;
          if (!ye)
            re2 && (re2.mergeOption({}, this), re2.optionUpdated({}, false));
          else {
            var me2 = H2 === "series", be2 = zh2.getClass(H2, Ft.keyInfo.subType, !me2);
            if (!be2)
              return;
            if (H2 === "tooltip") {
              if (zt)
                return;
              zt = true;
            }
            if (re2 && re2.constructor === be2)
              re2.name = Ft.keyInfo.name, re2.mergeOption(ye, this), re2.optionUpdated(ye, false);
            else {
              var Te2 = ba2({ componentIndex: fe2 }, Ft.keyInfo);
              re2 = new be2(ye, this, this, Te2), ba2(re2, Te2), Ft.brandNew && (re2.__requireNewView = true), re2.init(ye, this, this), re2.optionUpdated(null, true);
            }
          }
          re2 ? (bt.push(re2.option), _t.push(re2), Et++) : (bt.push(void 0), _t.push(void 0));
        }, this), v4[H2] = bt, _.set(H2, _t), M2.set(H2, Et), H2 === "series" && $It(this);
      }
      this._seriesIndices || $It(this);
    }, i.prototype.getOption = function() {
      var t2 = pu(this.option);
      return Qe2(t2, function(h, v4) {
        if (zh2.hasClass(v4)) {
          for (var _ = Od2(h), M2 = _.length, I2 = false, P2 = M2 - 1; P2 >= 0; P2--)
            _[P2] && !Kdt(_[P2]) ? I2 = true : (_[P2] = null, !I2 && M2--);
          _.length = M2, t2[v4] = _;
        }
      }), delete t2[VNe], t2;
    }, i.prototype.getTheme = function() {
      return this._theme;
    }, i.prototype.getLocaleModel = function() {
      return this._locale;
    }, i.prototype.setUpdatePayload = function(t2) {
      this._payload = t2;
    }, i.prototype.getUpdatePayload = function() {
      return this._payload;
    }, i.prototype.getComponent = function(t2, h) {
      var v4 = this._componentsMap.get(t2);
      if (v4) {
        var _ = v4[h || 0];
        if (_)
          return _;
        if (h == null) {
          for (var M2 = 0; M2 < v4.length; M2++)
            if (v4[M2])
              return v4[M2];
        }
      }
    }, i.prototype.queryComponents = function(t2) {
      var h = t2.mainType;
      if (!h)
        return [];
      var v4 = t2.index, _ = t2.id, M2 = t2.name, I2 = this._componentsMap.get(h);
      if (!I2 || !I2.length)
        return [];
      var P2;
      return v4 != null ? (P2 = [], Qe2(Od2(v4), function(N3) {
        I2[N3] && P2.push(I2[N3]);
      })) : _ != null ? P2 = BNe("id", _, I2) : M2 != null ? P2 = BNe("name", M2, I2) : P2 = Ld2(I2, function(N3) {
        return !!N3;
      }), zNe(P2, t2);
    }, i.prototype.findComponents = function(t2) {
      var h = t2.query, v4 = t2.mainType, _ = I2(h), M2 = _ ? this.queryComponents(_) : Ld2(this._componentsMap.get(v4), function(N3) {
        return !!N3;
      });
      return P2(zNe(M2, t2));
      function I2(N3) {
        var z3 = v4 + "Index", H2 = v4 + "Id", $ = v4 + "Name";
        return N3 && (N3[z3] != null || N3[H2] != null || N3[$] != null) ? { mainType: v4, index: N3[z3], id: N3[H2], name: N3[$] } : null;
      }
      function P2(N3) {
        return t2.filter ? Ld2(N3, t2.filter) : N3;
      }
    }, i.prototype.eachComponent = function(t2, h, v4) {
      var _ = this._componentsMap;
      if (Ol(t2)) {
        var M2 = h, I2 = t2;
        _.each(function(H2, $) {
          for (var et = 0; H2 && et < H2.length; et++) {
            var at = H2[et];
            at && I2.call(M2, $, at, at.componentIndex);
          }
        });
      } else
        for (var P2 = ms(t2) ? _.get(t2) : Xl(t2) ? this.findComponents(t2) : null, N3 = 0; P2 && N3 < P2.length; N3++) {
          var z3 = P2[N3];
          z3 && h.call(v4, z3, z3.componentIndex);
        }
    }, i.prototype.getSeriesByName = function(t2) {
      var h = l1(t2, null);
      return Ld2(this._componentsMap.get("series"), function(v4) {
        return !!v4 && h != null && v4.name === h;
      });
    }, i.prototype.getSeriesByIndex = function(t2) {
      return this._componentsMap.get("series")[t2];
    }, i.prototype.getSeriesByType = function(t2) {
      return Ld2(this._componentsMap.get("series"), function(h) {
        return !!h && h.subType === t2;
      });
    }, i.prototype.getSeries = function() {
      return Ld2(this._componentsMap.get("series"), function(t2) {
        return !!t2;
      });
    }, i.prototype.getSeriesCount = function() {
      return this._componentsCount.get("series");
    }, i.prototype.eachSeries = function(t2, h) {
      Hpt(this), Qe2(this._seriesIndices, function(v4) {
        var _ = this._componentsMap.get("series")[v4];
        t2.call(h, _, v4);
      }, this);
    }, i.prototype.eachRawSeries = function(t2, h) {
      Qe2(this._componentsMap.get("series"), function(v4) {
        v4 && t2.call(h, v4, v4.componentIndex);
      });
    }, i.prototype.eachSeriesByType = function(t2, h, v4) {
      Hpt(this), Qe2(this._seriesIndices, function(_) {
        var M2 = this._componentsMap.get("series")[_];
        M2.subType === t2 && h.call(v4, M2, _);
      }, this);
    }, i.prototype.eachRawSeriesByType = function(t2, h, v4) {
      return Qe2(this.getSeriesByType(t2), h, v4);
    }, i.prototype.isSeriesFiltered = function(t2) {
      return Hpt(this), this._seriesIndicesMap.get(t2.componentIndex) == null;
    }, i.prototype.getCurrentSeriesIndices = function() {
      return (this._seriesIndices || []).slice();
    }, i.prototype.filterSeries = function(t2, h) {
      Hpt(this);
      var v4 = [];
      Qe2(this._seriesIndices, function(_) {
        var M2 = this._componentsMap.get("series")[_];
        t2.call(h, M2, _) && v4.push(_);
      }, this), this._seriesIndices = v4, this._seriesIndicesMap = Il(v4);
    }, i.prototype.restoreData = function(t2) {
      $It(this);
      var h = this._componentsMap, v4 = [];
      h.each(function(_, M2) {
        zh2.hasClass(M2) && v4.push(M2);
      }), zh2.topologicalTravel(v4, zh2.getAllClassMainTypes(), function(_) {
        Qe2(h.get(_), function(M2) {
          M2 && (_ !== "series" || !rpr(M2, t2)) && M2.restoreData();
        });
      });
    }, i.internalField = function() {
      $It = function(t2) {
        var h = t2._seriesIndices = [];
        Qe2(t2._componentsMap.get("series"), function(v4) {
          v4 && h.push(v4.componentIndex);
        }), t2._seriesIndicesMap = Il(h);
      }, Hpt = function(t2) {
      }, FNe = function(t2, h) {
        t2.option = {}, t2.option[VNe] = npr, t2._componentsMap = Il({ series: [] }), t2._componentsCount = Il();
        var v4 = h.aria;
        Xl(v4) && v4.enabled == null && (v4.enabled = true), ipr(h, t2._theme.option), cc2(h, $hr, false), t2._mergeOption(h, null);
      };
    }(), i;
  }(Gg2);
  function rpr(f2, i) {
    if (i) {
      var t2 = i.seriesIndex, h = i.seriesId, v4 = i.seriesName;
      return t2 != null && f2.componentIndex !== t2 || h != null && f2.id !== h || v4 != null && f2.name !== v4;
    }
  }
  function ipr(f2, i) {
    var t2 = f2.color && !f2.colorLayer;
    Qe2(i, function(h, v4) {
      v4 === "colorLayer" && t2 || zh2.hasClass(v4) || (typeof h == "object" ? f2[v4] = f2[v4] ? cc2(f2[v4], h, false) : pu(h) : f2[v4] == null && (f2[v4] = h));
    });
  }
  function BNe(f2, i, t2) {
    if (Za2(i)) {
      var h = Il();
      return Qe2(i, function(_) {
        if (_ != null) {
          var M2 = l1(_, null);
          M2 != null && h.set(_, true);
        }
      }), Ld2(t2, function(_) {
        return _ && h.get(_[f2]);
      });
    } else {
      var v4 = l1(i, null);
      return Ld2(t2, function(_) {
        return _ && v4 != null && _[f2] === v4;
      });
    }
  }
  function zNe(f2, i) {
    return i.hasOwnProperty("subType") ? Ld2(f2, function(t2) {
      return t2 && t2.subType === i.subType;
    }) : f2;
  }
  function jNe(f2) {
    var i = Il();
    return f2 && Qe2(Od2(f2.replaceMerge), function(t2) {
      i.set(t2, true);
    }), { replaceMergeMainTypeMap: i };
  }
  Sm(hWe, Qee);
  var pWe = hWe, apr = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], opr = function() {
    function f2(i) {
      Qe2(apr, function(t2) {
        this[t2] = ks(i[t2], i);
      }, this);
    }
    return f2;
  }(), dWe = opr, _Xt = {}, spr = function() {
    function f2() {
      this._coordinateSystems = [];
    }
    return f2.prototype.create = function(i, t2) {
      var h = [];
      Qe2(_Xt, function(v4, _) {
        var M2 = v4.create(i, t2);
        h = h.concat(M2 || []);
      }), this._coordinateSystems = h;
    }, f2.prototype.update = function(i, t2) {
      Qe2(this._coordinateSystems, function(h) {
        h.update && h.update(i, t2);
      });
    }, f2.prototype.getCoordinateSystems = function() {
      return this._coordinateSystems.slice();
    }, f2.register = function(i, t2) {
      _Xt[i] = t2;
    }, f2.get = function(i) {
      return _Xt[i];
    }, f2;
  }(), Pgt = spr, lpr = /^(min|max)?(.+)$/, upr = function() {
    function f2(i) {
      this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = i;
    }
    return f2.prototype.setOption = function(i, t2, h) {
      i && (Qe2(Od2(i.series), function(M2) {
        M2 && M2.data && YT(M2.data) && oEt(M2.data);
      }), Qe2(Od2(i.dataset), function(M2) {
        M2 && M2.source && YT(M2.source) && oEt(M2.source);
      })), i = pu(i);
      var v4 = this._optionBackup, _ = cpr(i, t2, !v4);
      this._newBaseOption = _.baseOption, v4 ? (_.timelineOptions.length && (v4.timelineOptions = _.timelineOptions), _.mediaList.length && (v4.mediaList = _.mediaList), _.mediaDefault && (v4.mediaDefault = _.mediaDefault)) : this._optionBackup = _;
    }, f2.prototype.mountOption = function(i) {
      var t2 = this._optionBackup;
      return this._timelineOptions = t2.timelineOptions, this._mediaList = t2.mediaList, this._mediaDefault = t2.mediaDefault, this._currentMediaIndices = [], pu(i ? t2.baseOption : this._newBaseOption);
    }, f2.prototype.getTimelineOption = function(i) {
      var t2, h = this._timelineOptions;
      if (h.length) {
        var v4 = i.getComponent("timeline");
        v4 && (t2 = pu(h[v4.getCurrentIndex()]));
      }
      return t2;
    }, f2.prototype.getMediaOption = function(i) {
      var t2 = this._api.getWidth(), h = this._api.getHeight(), v4 = this._mediaList, _ = this._mediaDefault, M2 = [], I2 = [];
      if (!v4.length && !_)
        return I2;
      for (var P2 = 0, N3 = v4.length; P2 < N3; P2++)
        fpr(v4[P2].query, t2, h) && M2.push(P2);
      return !M2.length && _ && (M2 = [-1]), M2.length && !ppr(M2, this._currentMediaIndices) && (I2 = Xa2(M2, function(z3) {
        return pu(z3 === -1 ? _.option : v4[z3].option);
      })), this._currentMediaIndices = M2, I2;
    }, f2;
  }();
  function cpr(f2, i, t2) {
    var h = [], v4, _, M2 = f2.baseOption, I2 = f2.timeline, P2 = f2.options, N3 = f2.media, z3 = !!f2.media, H2 = !!(P2 || I2 || M2 && M2.timeline);
    M2 ? (_ = M2, _.timeline || (_.timeline = I2)) : ((H2 || z3) && (f2.options = f2.media = null), _ = f2), z3 && Za2(N3) && Qe2(N3, function(et) {
      et && et.option && (et.query ? h.push(et) : v4 || (v4 = et));
    }), $(_), Qe2(P2, function(et) {
      return $(et);
    }), Qe2(h, function(et) {
      return $(et.option);
    });
    function $(et) {
      Qe2(i, function(at) {
        at(et, t2);
      });
    }
    return { baseOption: _, timelineOptions: P2 || [], mediaDefault: v4, mediaList: h };
  }
  function fpr(f2, i, t2) {
    var h = { width: i, height: t2, aspectratio: i / t2 }, v4 = true;
    return Qe2(f2, function(_, M2) {
      var I2 = M2.match(lpr);
      if (!(!I2 || !I2[1] || !I2[2])) {
        var P2 = I2[1], N3 = I2[2].toLowerCase();
        hpr(h[N3], _, P2) || (v4 = false);
      }
    }), v4;
  }
  function hpr(f2, i, t2) {
    return t2 === "min" ? f2 >= i : t2 === "max" ? f2 <= i : f2 === i;
  }
  function ppr(f2, i) {
    return f2.join(",") === i.join(",");
  }
  var dpr2 = upr, v5 = Qe2, igt = Xl, WNe = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
  function xXt(f2) {
    var i = f2 && f2.itemStyle;
    if (!!i)
      for (var t2 = 0, h = WNe.length; t2 < h; t2++) {
        var v4 = WNe[t2], _ = i.normal, M2 = i.emphasis;
        _ && _[v4] && (f2[v4] = f2[v4] || {}, f2[v4].normal ? cc2(f2[v4].normal, _[v4]) : f2[v4].normal = _[v4], _[v4] = null), M2 && M2[v4] && (f2[v4] = f2[v4] || {}, f2[v4].emphasis ? cc2(f2[v4].emphasis, M2[v4]) : f2[v4].emphasis = M2[v4], M2[v4] = null);
      }
  }
  function mS(f2, i, t2) {
    if (f2 && f2[i] && (f2[i].normal || f2[i].emphasis)) {
      var h = f2[i].normal, v4 = f2[i].emphasis;
      h && (t2 ? (f2[i].normal = f2[i].emphasis = null, Ul(f2[i], h)) : f2[i] = h), v4 && (f2.emphasis = f2.emphasis || {}, f2.emphasis[i] = v4, v4.focus && (f2.emphasis.focus = v4.focus), v4.blurScope && (f2.emphasis.blurScope = v4.blurScope));
    }
  }
  function _dt(f2) {
    mS(f2, "itemStyle"), mS(f2, "lineStyle"), mS(f2, "areaStyle"), mS(f2, "label"), mS(f2, "labelLine"), mS(f2, "upperLabel"), mS(f2, "edgeLabel");
  }
  function bm(f2, i) {
    var t2 = igt(f2) && f2[i], h = igt(t2) && t2.textStyle;
    if (h)
      for (var v4 = 0, _ = q6e.length; v4 < _; v4++) {
        var M2 = q6e[v4];
        h.hasOwnProperty(M2) && (t2[M2] = h[M2]);
      }
  }
  function HD(f2) {
    f2 && (_dt(f2), bm(f2, "label"), f2.emphasis && bm(f2.emphasis, "label"));
  }
  function gpr(f2) {
    if (!!igt(f2)) {
      xXt(f2), _dt(f2), bm(f2, "label"), bm(f2, "upperLabel"), bm(f2, "edgeLabel"), f2.emphasis && (bm(f2.emphasis, "label"), bm(f2.emphasis, "upperLabel"), bm(f2.emphasis, "edgeLabel"));
      var i = f2.markPoint;
      i && (xXt(i), HD(i));
      var t2 = f2.markLine;
      t2 && (xXt(t2), HD(t2));
      var h = f2.markArea;
      h && HD(h);
      var v4 = f2.data;
      if (f2.type === "graph") {
        v4 = v4 || f2.nodes;
        var _ = f2.links || f2.edges;
        if (_ && !YT(_))
          for (var M2 = 0; M2 < _.length; M2++)
            HD(_[M2]);
        Qe2(f2.categories, function(N3) {
          _dt(N3);
        });
      }
      if (v4 && !YT(v4))
        for (var M2 = 0; M2 < v4.length; M2++)
          HD(v4[M2]);
      if (i = f2.markPoint, i && i.data)
        for (var I2 = i.data, M2 = 0; M2 < I2.length; M2++)
          HD(I2[M2]);
      if (t2 = f2.markLine, t2 && t2.data)
        for (var P2 = t2.data, M2 = 0; M2 < P2.length; M2++)
          Za2(P2[M2]) ? (HD(P2[M2][0]), HD(P2[M2][1])) : HD(P2[M2]);
      f2.type === "gauge" ? (bm(f2, "axisLabel"), bm(f2, "title"), bm(f2, "detail")) : f2.type === "treemap" ? (mS(f2.breadcrumb, "itemStyle"), Qe2(f2.levels, function(N3) {
        _dt(N3);
      })) : f2.type === "tree" && _dt(f2.leaves);
    }
  }
  function V6(f2) {
    return Za2(f2) ? f2 : f2 ? [f2] : [];
  }
  function GNe(f2) {
    return (Za2(f2) ? f2[0] : f2) || {};
  }
  function vpr(f2, i) {
    v5(V6(f2.series), function(h) {
      igt(h) && gpr(h);
    });
    var t2 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
    i && t2.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), v5(t2, function(h) {
      v5(V6(f2[h]), function(v4) {
        v4 && (bm(v4, "axisLabel"), bm(v4.axisPointer, "label"));
      });
    }), v5(V6(f2.parallel), function(h) {
      var v4 = h && h.parallelAxisDefault;
      bm(v4, "axisLabel"), bm(v4 && v4.axisPointer, "label");
    }), v5(V6(f2.calendar), function(h) {
      mS(h, "itemStyle"), bm(h, "dayLabel"), bm(h, "monthLabel"), bm(h, "yearLabel");
    }), v5(V6(f2.radar), function(h) {
      bm(h, "name"), h.name && h.axisName == null && (h.axisName = h.name, delete h.name), h.nameGap != null && h.axisNameGap == null && (h.axisNameGap = h.nameGap, delete h.nameGap);
    }), v5(V6(f2.geo), function(h) {
      igt(h) && (HD(h), v5(V6(h.regions), function(v4) {
        HD(v4);
      }));
    }), v5(V6(f2.timeline), function(h) {
      HD(h), mS(h, "label"), mS(h, "itemStyle"), mS(h, "controlStyle", true);
      var v4 = h.data;
      Za2(v4) && Qe2(v4, function(_) {
        Xl(_) && (mS(_, "label"), mS(_, "itemStyle"));
      });
    }), v5(V6(f2.toolbox), function(h) {
      mS(h, "iconStyle"), v5(h.feature, function(v4) {
        mS(v4, "iconStyle");
      });
    }), bm(GNe(f2.axisPointer), "label"), bm(GNe(f2.tooltip).axisPointer, "label");
  }
  function ypr(f2, i) {
    for (var t2 = i.split(","), h = f2, v4 = 0; v4 < t2.length && (h = h && h[t2[v4]], h != null); v4++)
      ;
    return h;
  }
  function mpr(f2, i, t2, h) {
    for (var v4 = i.split(","), _ = f2, M2, I2 = 0; I2 < v4.length - 1; I2++)
      M2 = v4[I2], _[M2] == null && (_[M2] = {}), _ = _[M2];
    (h || _[v4[I2]] == null) && (_[v4[I2]] = t2);
  }
  function HNe(f2) {
    f2 && Qe2(bpr, function(i) {
      i[0] in f2 && !(i[1] in f2) && (f2[i[1]] = f2[i[0]]);
    });
  }
  var bpr = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], _pr = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], wXt = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
  function Upt(f2) {
    var i = f2 && f2.itemStyle;
    if (i)
      for (var t2 = 0; t2 < wXt.length; t2++) {
        var h = wXt[t2][1], v4 = wXt[t2][0];
        i[h] != null && (i[v4] = i[h]);
      }
  }
  function UNe(f2) {
    !f2 || f2.alignTo === "edge" && f2.margin != null && f2.edgeDistance == null && (f2.edgeDistance = f2.margin);
  }
  function qNe(f2) {
    !f2 || f2.downplay && !f2.blur && (f2.blur = f2.downplay);
  }
  function xpr(f2) {
    !f2 || f2.focusNodeAdjacency != null && (f2.emphasis = f2.emphasis || {}, f2.emphasis.focus == null && (f2.emphasis.focus = "adjacency"));
  }
  function gWe(f2, i) {
    if (f2)
      for (var t2 = 0; t2 < f2.length; t2++)
        i(f2[t2]), f2[t2] && gWe(f2[t2].children, i);
  }
  function vWe(f2, i) {
    vpr(f2, i), f2.series = Od2(f2.series), Qe2(f2.series, function(t2) {
      if (!!Xl(t2)) {
        var h = t2.type;
        if (h === "line")
          t2.clipOverflow != null && (t2.clip = t2.clipOverflow);
        else if (h === "pie" || h === "gauge") {
          t2.clockWise != null && (t2.clockwise = t2.clockWise), UNe(t2.label);
          var v4 = t2.data;
          if (v4 && !YT(v4))
            for (var _ = 0; _ < v4.length; _++)
              UNe(v4[_]);
          t2.hoverOffset != null && (t2.emphasis = t2.emphasis || {}, (t2.emphasis.scaleSize = null) && (t2.emphasis.scaleSize = t2.hoverOffset));
        } else if (h === "gauge") {
          var M2 = ypr(t2, "pointer.color");
          M2 != null && mpr(t2, "itemStyle.color", M2);
        } else if (h === "bar") {
          Upt(t2), Upt(t2.backgroundStyle), Upt(t2.emphasis);
          var v4 = t2.data;
          if (v4 && !YT(v4))
            for (var _ = 0; _ < v4.length; _++)
              typeof v4[_] == "object" && (Upt(v4[_]), Upt(v4[_] && v4[_].emphasis));
        } else if (h === "sunburst") {
          var I2 = t2.highlightPolicy;
          I2 && (t2.emphasis = t2.emphasis || {}, t2.emphasis.focus || (t2.emphasis.focus = I2)), qNe(t2), gWe(t2.data, qNe);
        } else
          h === "graph" || h === "sankey" ? xpr(t2) : h === "map" && (t2.mapType && !t2.map && (t2.map = t2.mapType), t2.mapLocation && Ul(t2, t2.mapLocation));
        t2.hoverAnimation != null && (t2.emphasis = t2.emphasis || {}, t2.emphasis && t2.emphasis.scale == null && (t2.emphasis.scale = t2.hoverAnimation)), HNe(t2);
      }
    }), f2.dataRange && (f2.visualMap = f2.dataRange), Qe2(_pr, function(t2) {
      var h = f2[t2];
      h && (Za2(h) || (h = [h]), Qe2(h, function(v4) {
        HNe(v4);
      }));
    });
  }
  function wpr(f2) {
    var i = Il();
    f2.eachSeries(function(t2) {
      var h = t2.get("stack");
      if (h) {
        var v4 = i.get(h) || i.set(h, []), _ = t2.getData(), M2 = { stackResultDimension: _.getCalculationInfo("stackResultDimension"), stackedOverDimension: _.getCalculationInfo("stackedOverDimension"), stackedDimension: _.getCalculationInfo("stackedDimension"), stackedByDimension: _.getCalculationInfo("stackedByDimension"), isStackedByIndex: _.getCalculationInfo("isStackedByIndex"), data: _, seriesModel: t2 };
        if (!M2.stackedDimension || !(M2.isStackedByIndex || M2.stackedByDimension))
          return;
        v4.length && _.setCalculationInfo("stackedOnSeries", v4[v4.length - 1].seriesModel), v4.push(M2);
      }
    }), i.each(Spr);
  }
  function Spr(f2) {
    Qe2(f2, function(i, t2) {
      var h = [], v4 = [NaN, NaN], _ = [i.stackResultDimension, i.stackedOverDimension], M2 = i.data, I2 = i.isStackedByIndex;
      M2.modify(_, function(P2, N3, z3) {
        var H2 = M2.get(i.stackedDimension, z3);
        if (isNaN(H2))
          return v4;
        var $, et;
        I2 ? et = M2.getRawIndex(z3) : $ = M2.get(i.stackedByDimension, z3);
        for (var at = NaN, ht = t2 - 1; ht >= 0; ht--) {
          var bt = f2[ht];
          if (I2 || (et = bt.data.rawIndexOf(bt.stackedByDimension, $)), et >= 0) {
            var _t = bt.data.getByRawIndex(bt.stackResultDimension, et);
            if (H2 >= 0 && _t > 0 || H2 <= 0 && _t < 0) {
              H2 = ncr(H2, _t), at = _t;
              break;
            }
          }
        }
        return h[0] = H2, h[1] = at, h;
      });
    });
  }
  var Ikt = function() {
    function f2(i) {
      this.data = i.data || (i.sourceFormat === qL ? {} : []), this.sourceFormat = i.sourceFormat || oWe, this.seriesLayoutBy = i.seriesLayoutBy || VL, this.startIndex = i.startIndex || 0, this.dimensionsDetectedCount = i.dimensionsDetectedCount, this.metaRawOption = i.metaRawOption;
      var t2 = this.dimensionsDefine = i.dimensionsDefine;
      if (t2)
        for (var h = 0; h < t2.length; h++) {
          var v4 = t2[h];
          v4.type == null && uWe(this, h) === jx.Must && (v4.type = "ordinal");
        }
    }
    return f2;
  }();
  function Jee(f2) {
    return f2 instanceof Ikt;
  }
  function XJt(f2, i, t2) {
    t2 = t2 || yWe(f2);
    var h = i.seriesLayoutBy, v4 = Cpr(f2, t2, h, i.sourceHeader, i.dimensions), _ = new Ikt({ data: f2, sourceFormat: t2, seriesLayoutBy: h, dimensionsDefine: v4.dimensionsDefine, startIndex: v4.startIndex, dimensionsDetectedCount: v4.dimensionsDetectedCount, metaRawOption: pu(i) });
    return _;
  }
  function tne(f2) {
    return new Ikt({ data: f2, sourceFormat: YT(f2) ? Z7 : aE });
  }
  function Mpr(f2) {
    return new Ikt({ data: f2.data, sourceFormat: f2.sourceFormat, seriesLayoutBy: f2.seriesLayoutBy, dimensionsDefine: pu(f2.dimensionsDefine), startIndex: f2.startIndex, dimensionsDetectedCount: f2.dimensionsDetectedCount });
  }
  function yWe(f2) {
    var i = oWe;
    if (YT(f2))
      i = Z7;
    else if (Za2(f2)) {
      f2.length === 0 && (i = wS);
      for (var t2 = 0, h = f2.length; t2 < h; t2++) {
        var v4 = f2[t2];
        if (v4 != null) {
          if (Za2(v4)) {
            i = wS;
            break;
          } else if (Xl(v4)) {
            i = oE;
            break;
          }
        }
      }
    } else if (Xl(f2)) {
      for (var _ in f2)
        if (qs(f2, _) && xS(f2[_])) {
          i = qL;
          break;
        }
    }
    return i;
  }
  function Cpr(f2, i, t2, h, v4) {
    var _, M2;
    if (!f2)
      return { dimensionsDefine: ZNe(v4), startIndex: M2, dimensionsDetectedCount: _ };
    if (i === wS) {
      var I2 = f2;
      h === "auto" || h == null ? $Ne(function(N3) {
        N3 != null && N3 !== "-" && (ms(N3) ? M2 == null && (M2 = 1) : M2 = 0);
      }, t2, I2, 10) : M2 = vp(h) ? h : h ? 1 : 0, !v4 && M2 === 1 && (v4 = [], $Ne(function(N3, z3) {
        v4[z3] = N3 != null ? N3 + "" : "";
      }, t2, I2, 1 / 0)), _ = v4 ? v4.length : t2 === set2 ? I2.length : I2[0] ? I2[0].length : null;
    } else if (i === oE)
      v4 || (v4 = Tpr(f2));
    else if (i === qL)
      v4 || (v4 = [], Qe2(f2, function(N3, z3) {
        v4.push(z3);
      }));
    else if (i === aE) {
      var P2 = Qtt(f2[0]);
      _ = Za2(P2) && P2.length || 1;
    }
    return { startIndex: M2, dimensionsDefine: ZNe(v4), dimensionsDetectedCount: _ };
  }
  function Tpr(f2) {
    for (var i = 0, t2; i < f2.length && !(t2 = f2[i++]); )
      ;
    if (t2) {
      var h = [];
      return Qe2(t2, function(v4, _) {
        h.push(_);
      }), h;
    }
  }
  function ZNe(f2) {
    if (!!f2) {
      var i = Il();
      return Xa2(f2, function(t2, h) {
        t2 = Xl(t2) ? t2 : { name: t2 };
        var v4 = { name: t2.name, displayName: t2.displayName, type: t2.type };
        if (v4.name == null)
          return v4;
        v4.name += "", v4.displayName == null && (v4.displayName = v4.name);
        var _ = i.get(v4.name);
        return _ ? v4.name += "-" + _.count++ : i.set(v4.name, { count: 1 }), v4;
      });
    }
  }
  function $Ne(f2, i, t2, h) {
    if (i === set2)
      for (var v4 = 0; v4 < t2.length && v4 < h; v4++)
        f2(t2[v4] ? t2[v4][0] : null, v4);
    else
      for (var _ = t2[0] || [], v4 = 0; v4 < _.length && v4 < h; v4++)
        f2(_[v4], v4);
  }
  function mWe(f2) {
    var i = f2.sourceFormat;
    return i === oE || i === qL;
  }
  var LH, OH, RH, YNe, KNe, bWe = function() {
    function f2(i, t2) {
      var h = Jee(i) ? i : tne(i);
      this._source = h;
      var v4 = this._data = h.data;
      h.sourceFormat === Z7 && (this._offset = 0, this._dimSize = t2, this._data = v4), KNe(this, v4, h);
    }
    return f2.prototype.getSource = function() {
      return this._source;
    }, f2.prototype.count = function() {
      return 0;
    }, f2.prototype.getItem = function(i, t2) {
    }, f2.prototype.appendData = function(i) {
    }, f2.prototype.clean = function() {
    }, f2.protoInitialize = function() {
      var i = f2.prototype;
      i.pure = false, i.persistent = true;
    }(), f2.internalField = function() {
      var i;
      KNe = function(M2, I2, P2) {
        var N3 = P2.sourceFormat, z3 = P2.seriesLayoutBy, H2 = P2.startIndex, $ = P2.dimensionsDefine, et = YNe[ene(N3, z3)];
        if (ba2(M2, et), N3 === Z7)
          M2.getItem = t2, M2.count = v4, M2.fillStorage = h;
        else {
          var at = _We(N3, z3);
          M2.getItem = ks(at, null, I2, H2, $);
          var ht = xWe(N3, z3);
          M2.count = ks(ht, null, I2, H2, $);
        }
      };
      var t2 = function(M2, I2) {
        M2 = M2 - this._offset, I2 = I2 || [];
        for (var P2 = this._data, N3 = this._dimSize, z3 = N3 * M2, H2 = 0; H2 < N3; H2++)
          I2[H2] = P2[z3 + H2];
        return I2;
      }, h = function(M2, I2, P2, N3) {
        for (var z3 = this._data, H2 = this._dimSize, $ = 0; $ < H2; $++) {
          for (var et = N3[$], at = et[0] == null ? 1 / 0 : et[0], ht = et[1] == null ? -1 / 0 : et[1], bt = I2 - M2, _t = P2[$], Et = 0; Et < bt; Et++) {
            var zt = z3[Et * H2 + $];
            _t[M2 + Et] = zt, zt < at && (at = zt), zt > ht && (ht = zt);
          }
          et[0] = at, et[1] = ht;
        }
      }, v4 = function() {
        return this._data ? this._data.length / this._dimSize : 0;
      };
      YNe = (i = {}, i[wS + "_" + VL] = { pure: true, appendData: _ }, i[wS + "_" + set2] = { pure: true, appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      } }, i[oE] = { pure: true, appendData: _ }, i[qL] = { pure: true, appendData: function(M2) {
        var I2 = this._data;
        Qe2(M2, function(P2, N3) {
          for (var z3 = I2[N3] || (I2[N3] = []), H2 = 0; H2 < (P2 || []).length; H2++)
            z3.push(P2[H2]);
        });
      } }, i[aE] = { appendData: _ }, i[Z7] = { persistent: false, pure: true, appendData: function(M2) {
        this._data = M2;
      }, clean: function() {
        this._offset += this.count(), this._data = null;
      } }, i);
      function _(M2) {
        for (var I2 = 0; I2 < M2.length; I2++)
          this._data.push(M2[I2]);
      }
    }(), f2;
  }(), XNe = function(f2, i, t2, h) {
    return f2[h];
  }, Apr = (LH = {}, LH[wS + "_" + VL] = function(f2, i, t2, h) {
    return f2[h + i];
  }, LH[wS + "_" + set2] = function(f2, i, t2, h, v4) {
    h += i;
    for (var _ = v4 || [], M2 = f2, I2 = 0; I2 < M2.length; I2++) {
      var P2 = M2[I2];
      _[I2] = P2 ? P2[h] : null;
    }
    return _;
  }, LH[oE] = XNe, LH[qL] = function(f2, i, t2, h, v4) {
    for (var _ = v4 || [], M2 = 0; M2 < t2.length; M2++) {
      var I2 = t2[M2].name, P2 = f2[I2];
      _[M2] = P2 ? P2[h] : null;
    }
    return _;
  }, LH[aE] = XNe, LH);
  function _We(f2, i) {
    var t2 = Apr[ene(f2, i)];
    return t2;
  }
  var QNe = function(f2, i, t2) {
    return f2.length;
  }, Ipr = (OH = {}, OH[wS + "_" + VL] = function(f2, i, t2) {
    return Math.max(0, f2.length - i);
  }, OH[wS + "_" + set2] = function(f2, i, t2) {
    var h = f2[0];
    return h ? Math.max(0, h.length - i) : 0;
  }, OH[oE] = QNe, OH[qL] = function(f2, i, t2) {
    var h = t2[0].name, v4 = f2[h];
    return v4 ? v4.length : 0;
  }, OH[aE] = QNe, OH);
  function xWe(f2, i) {
    var t2 = Ipr[ene(f2, i)];
    return t2;
  }
  var SXt = function(f2, i, t2) {
    return f2[i];
  }, Dpr = (RH = {}, RH[wS] = SXt, RH[oE] = function(f2, i, t2) {
    return f2[t2];
  }, RH[qL] = SXt, RH[aE] = function(f2, i, t2) {
    var h = Qtt(f2);
    return h instanceof Array ? h[i] : h;
  }, RH[Z7] = SXt, RH);
  function wWe(f2) {
    var i = Dpr[f2];
    return i;
  }
  function ene(f2, i) {
    return f2 === wS ? f2 + "_" + i : f2;
  }
  function Gtt(f2, i, t2) {
    if (!!f2) {
      var h = f2.getRawDataItem(i);
      if (h != null) {
        var v4 = f2.getStore(), _ = v4.getSource().sourceFormat;
        if (t2 != null) {
          var M2 = f2.getDimensionIndex(t2), I2 = v4.getDimensionProperty(M2);
          return wWe(_)(h, M2, I2);
        } else {
          var P2 = h;
          return _ === aE && (P2 = Qtt(h)), P2;
        }
      }
    }
  }
  var Epr = /\{@(.+?)\}/g, nne = function() {
    function f2() {
    }
    return f2.prototype.getDataParams = function(i, t2) {
      var h = this.getData(t2), v4 = this.getRawValue(i, t2), _ = h.getRawIndex(i), M2 = h.getName(i), I2 = h.getRawDataItem(i), P2 = h.getItemVisual(i, "style"), N3 = P2 && P2[h.getItemVisual(i, "drawType") || "fill"], z3 = P2 && P2.stroke, H2 = this.mainType, $ = H2 === "series", et = h.userOutput && h.userOutput.get();
      return { componentType: H2, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: $ ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: $ ? this.id : null, seriesName: $ ? this.name : null, name: M2, dataIndex: _, data: I2, dataType: t2, value: v4, color: N3, borderColor: z3, dimensionNames: et ? et.fullDimensions : null, encode: et ? et.encode : null, $vars: ["seriesName", "name", "value"] };
    }, f2.prototype.getFormattedLabel = function(i, t2, h, v4, _, M2) {
      t2 = t2 || "normal";
      var I2 = this.getData(h), P2 = this.getDataParams(i, h);
      if (M2 && (P2.value = M2.interpolatedValue), v4 != null && Za2(P2.value) && (P2.value = P2.value[v4]), !_) {
        var N3 = I2.getItemModel(i);
        _ = N3.get(t2 === "normal" ? ["label", "formatter"] : [t2, "label", "formatter"]);
      }
      if (Ol(_))
        return P2.status = t2, P2.dimensionIndex = v4, _(P2);
      if (ms(_)) {
        var z3 = eWe(_, P2);
        return z3.replace(Epr, function(H2, $) {
          var et = $.length, at = $;
          at.charAt(0) === "[" && at.charAt(et - 1) === "]" && (at = +at.slice(1, et - 1));
          var ht = Gtt(I2, i, at);
          if (M2 && Za2(M2.interpolatedValue)) {
            var bt = I2.getDimensionIndex(at);
            bt >= 0 && (ht = M2.interpolatedValue[bt]);
          }
          return ht != null ? ht + "" : "";
        });
      }
    }, f2.prototype.getRawValue = function(i, t2) {
      return Gtt(this.getData(t2), i);
    }, f2.prototype.formatTooltip = function(i, t2, h) {
    }, f2;
  }();
  function JNe(f2) {
    var i, t2;
    return Xl(f2) ? f2.type && (t2 = f2) : i = f2, { text: i, frag: t2 };
  }
  function Ndt(f2) {
    return new kpr(f2);
  }
  var kpr = function() {
    function f2(i) {
      i = i || {}, this._reset = i.reset, this._plan = i.plan, this._count = i.count, this._onDirty = i.onDirty, this._dirty = true;
    }
    return f2.prototype.perform = function(i) {
      var t2 = this._upstream, h = i && i.skip;
      if (this._dirty && t2) {
        var v4 = this.context;
        v4.data = v4.outputData = t2.context.outputData;
      }
      this.__pipeline && (this.__pipeline.currentTask = this);
      var _;
      this._plan && !h && (_ = this._plan(this.context));
      var M2 = z3(this._modBy), I2 = this._modDataCount || 0, P2 = z3(i && i.modBy), N3 = i && i.modDataCount || 0;
      (M2 !== P2 || I2 !== N3) && (_ = "reset");
      function z3(Et) {
        return !(Et >= 1) && (Et = 1), Et;
      }
      var H2;
      (this._dirty || _ === "reset") && (this._dirty = false, H2 = this._doReset(h)), this._modBy = P2, this._modDataCount = N3;
      var $ = i && i.step;
      if (t2 ? this._dueEnd = t2._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
        var et = this._dueIndex, at = Math.min($ != null ? this._dueIndex + $ : 1 / 0, this._dueEnd);
        if (!h && (H2 || et < at)) {
          var ht = this._progress;
          if (Za2(ht))
            for (var bt = 0; bt < ht.length; bt++)
              this._doProgress(ht[bt], et, at, P2, N3);
          else
            this._doProgress(ht, et, at, P2, N3);
        }
        this._dueIndex = at;
        var _t = this._settedOutputEnd != null ? this._settedOutputEnd : at;
        this._outputDueEnd = _t;
      } else
        this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
      return this.unfinished();
    }, f2.prototype.dirty = function() {
      this._dirty = true, this._onDirty && this._onDirty(this.context);
    }, f2.prototype._doProgress = function(i, t2, h, v4, _) {
      tFe.reset(t2, h, v4, _), this._callingProgress = i, this._callingProgress({ start: t2, end: h, count: h - t2, next: tFe.next }, this.context);
    }, f2.prototype._doReset = function(i) {
      this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
      var t2, h;
      !i && this._reset && (t2 = this._reset(this.context), t2 && t2.progress && (h = t2.forceFirstProgress, t2 = t2.progress), Za2(t2) && !t2.length && (t2 = null)), this._progress = t2, this._modBy = this._modDataCount = null;
      var v4 = this._downstream;
      return v4 && v4.dirty(), h;
    }, f2.prototype.unfinished = function() {
      return this._progress && this._dueIndex < this._dueEnd;
    }, f2.prototype.pipe = function(i) {
      (this._downstream !== i || this._dirty) && (this._downstream = i, i._upstream = this, i.dirty());
    }, f2.prototype.dispose = function() {
      this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
    }, f2.prototype.getUpstream = function() {
      return this._upstream;
    }, f2.prototype.getDownstream = function() {
      return this._downstream;
    }, f2.prototype.setOutputEnd = function(i) {
      this._outputDueEnd = this._settedOutputEnd = i;
    }, f2;
  }(), tFe = function() {
    var f2, i, t2, h, v4, _ = { reset: function(P2, N3, z3, H2) {
      i = P2, f2 = N3, t2 = z3, h = H2, v4 = Math.ceil(h / t2), _.next = t2 > 1 && h > 0 ? I2 : M2;
    } };
    return _;
    function M2() {
      return i < f2 ? i++ : null;
    }
    function I2() {
      var P2 = i % v4 * t2 + Math.ceil(i / v4), N3 = i >= f2 ? null : P2 < h ? P2 : i;
      return i++, N3;
    }
  }();
  function $7(f2, i) {
    var t2 = i && i.type;
    return t2 === "ordinal" ? f2 : (t2 === "time" && !vp(f2) && f2 != null && f2 !== "-" && (f2 = +GL(f2)), f2 == null || f2 === "" ? NaN : +f2);
  }
  var Ppr = Il({ number: function(f2) {
    return parseFloat(f2);
  }, time: function(f2) {
    return +GL(f2);
  }, trim: function(f2) {
    return ms(f2) ? w5(f2) : f2;
  } });
  function SWe(f2) {
    return Ppr.get(f2);
  }
  var MWe = { lt: function(f2, i) {
    return f2 < i;
  }, lte: function(f2, i) {
    return f2 <= i;
  }, gt: function(f2, i) {
    return f2 > i;
  }, gte: function(f2, i) {
    return f2 >= i;
  } }, Lpr = function() {
    function f2(i, t2) {
      if (!vp(t2)) {
        var h = "";
        Ep(h);
      }
      this._opFn = MWe[i], this._rvalFloat = tN(t2);
    }
    return f2.prototype.evaluate = function(i) {
      return vp(i) ? this._opFn(i, this._rvalFloat) : this._opFn(tN(i), this._rvalFloat);
    }, f2;
  }(), CWe = function() {
    function f2(i, t2) {
      var h = i === "desc";
      this._resultLT = h ? 1 : -1, t2 == null && (t2 = h ? "min" : "max"), this._incomparable = t2 === "min" ? -1 / 0 : 1 / 0;
    }
    return f2.prototype.evaluate = function(i, t2) {
      var h = vp(i) ? i : tN(i), v4 = vp(t2) ? t2 : tN(t2), _ = isNaN(h), M2 = isNaN(v4);
      if (_ && (h = this._incomparable), M2 && (v4 = this._incomparable), _ && M2) {
        var I2 = ms(i), P2 = ms(t2);
        I2 && (h = P2 ? i : 0), P2 && (v4 = I2 ? t2 : 0);
      }
      return h < v4 ? this._resultLT : h > v4 ? -this._resultLT : 0;
    }, f2;
  }(), Opr = function() {
    function f2(i, t2) {
      this._rval = t2, this._isEQ = i, this._rvalTypeof = typeof t2, this._rvalFloat = tN(t2);
    }
    return f2.prototype.evaluate = function(i) {
      var t2 = i === this._rval;
      if (!t2) {
        var h = typeof i;
        h !== this._rvalTypeof && (h === "number" || this._rvalTypeof === "number") && (t2 = tN(i) === this._rvalFloat);
      }
      return this._isEQ ? t2 : !t2;
    }, f2;
  }();
  function Rpr(f2, i) {
    return f2 === "eq" || f2 === "ne" ? new Opr(f2 === "eq", i) : qs(MWe, f2) ? new Lpr(f2, i) : null;
  }
  var Npr = function() {
    function f2() {
    }
    return f2.prototype.getRawData = function() {
      throw new Error("not supported");
    }, f2.prototype.getRawDataItem = function(i) {
      throw new Error("not supported");
    }, f2.prototype.cloneRawData = function() {
    }, f2.prototype.getDimensionInfo = function(i) {
    }, f2.prototype.cloneAllDimensionInfo = function() {
    }, f2.prototype.count = function() {
    }, f2.prototype.retrieveValue = function(i, t2) {
    }, f2.prototype.retrieveValueFromItem = function(i, t2) {
    }, f2.prototype.convertValue = function(i, t2) {
      return $7(i, t2);
    }, f2;
  }();
  function Fpr(f2, i) {
    var t2 = new Npr(), h = f2.data, v4 = t2.sourceFormat = f2.sourceFormat, _ = f2.startIndex, M2 = "";
    f2.seriesLayoutBy !== VL && Ep(M2);
    var I2 = [], P2 = {}, N3 = f2.dimensionsDefine;
    if (N3)
      Qe2(N3, function(ht, bt) {
        var _t = ht.name, Et = { index: bt, name: _t, displayName: ht.displayName };
        if (I2.push(Et), _t != null) {
          var zt = "";
          qs(P2, _t) && Ep(zt), P2[_t] = Et;
        }
      });
    else
      for (var z3 = 0; z3 < f2.dimensionsDetectedCount; z3++)
        I2.push({ index: z3 });
    var H2 = _We(v4, VL);
    i.__isBuiltIn && (t2.getRawDataItem = function(ht) {
      return H2(h, _, I2, ht);
    }, t2.getRawData = ks(Vpr, null, f2)), t2.cloneRawData = ks(Bpr, null, f2);
    var $ = xWe(v4, VL);
    t2.count = ks($, null, h, _, I2);
    var et = wWe(v4);
    t2.retrieveValue = function(ht, bt) {
      var _t = H2(h, _, I2, ht);
      return at(_t, bt);
    };
    var at = t2.retrieveValueFromItem = function(ht, bt) {
      if (ht != null) {
        var _t = I2[bt];
        if (_t)
          return et(ht, bt, _t.name);
      }
    };
    return t2.getDimensionInfo = ks(zpr, null, I2, P2), t2.cloneAllDimensionInfo = ks(jpr, null, I2), t2;
  }
  function Vpr(f2) {
    var i = f2.sourceFormat;
    if (!rne(i)) {
      var t2 = "";
      Ep(t2);
    }
    return f2.data;
  }
  function Bpr(f2) {
    var i = f2.sourceFormat, t2 = f2.data;
    if (!rne(i)) {
      var h = "";
      Ep(h);
    }
    if (i === wS) {
      for (var v4 = [], _ = 0, M2 = t2.length; _ < M2; _++)
        v4.push(t2[_].slice());
      return v4;
    } else if (i === oE) {
      for (var v4 = [], _ = 0, M2 = t2.length; _ < M2; _++)
        v4.push(ba2({}, t2[_]));
      return v4;
    }
  }
  function zpr(f2, i, t2) {
    if (t2 != null) {
      if (vp(t2) || !isNaN(t2) && !qs(i, t2))
        return f2[t2];
      if (qs(i, t2))
        return i[t2];
    }
  }
  function jpr(f2) {
    return pu(f2);
  }
  var TWe = Il();
  function Wpr(f2) {
    f2 = pu(f2);
    var i = f2.type, t2 = "";
    i || Ep(t2);
    var h = i.split(":");
    h.length !== 2 && Ep(t2);
    var v4 = false;
    h[0] === "echarts" && (i = h[1], v4 = true), f2.__isBuiltIn = v4, TWe.set(i, f2);
  }
  function Gpr(f2, i, t2) {
    var h = Od2(f2), v4 = h.length, _ = "";
    v4 || Ep(_);
    for (var M2 = 0, I2 = v4; M2 < I2; M2++) {
      var P2 = h[M2];
      i = Hpr(P2, i), M2 !== I2 - 1 && (i.length = Math.max(i.length, 1));
    }
    return i;
  }
  function Hpr(f2, i, t2, h) {
    var v4 = "";
    i.length || Ep(v4), Xl(f2) || Ep(v4);
    var _ = f2.type, M2 = TWe.get(_);
    M2 || Ep(v4);
    var I2 = Xa2(i, function(N3) {
      return Fpr(N3, M2);
    }), P2 = Od2(M2.transform({ upstream: I2[0], upstreamList: I2, config: pu(f2.config) }));
    return Xa2(P2, function(N3, z3) {
      var H2 = "";
      Xl(N3) || Ep(H2), N3.data || Ep(H2);
      var $ = yWe(N3.data);
      rne($) || Ep(H2);
      var et, at = i[0];
      if (at && z3 === 0 && !N3.dimensions) {
        var ht = at.startIndex;
        ht && (N3.data = at.data.slice(0, ht).concat(N3.data)), et = { seriesLayoutBy: VL, sourceHeader: ht, dimensions: at.metaRawOption.dimensions };
      } else
        et = { seriesLayoutBy: VL, sourceHeader: 0, dimensions: N3.dimensions };
      return XJt(N3.data, et, null);
    });
  }
  function rne(f2) {
    return f2 === wS || f2 === oE;
  }
  var Dkt = "undefined", Upr = typeof Uint32Array === Dkt ? Array : Uint32Array, qpr = typeof Uint16Array === Dkt ? Array : Uint16Array, AWe = typeof Int32Array === Dkt ? Array : Int32Array, eFe = typeof Float64Array === Dkt ? Array : Float64Array, IWe = { float: eFe, int: AWe, ordinal: Array, number: Array, time: eFe }, MXt;
  function qpt(f2) {
    return f2 > 65535 ? Upr : qpr;
  }
  function ott() {
    return [1 / 0, -1 / 0];
  }
  function Zpr(f2) {
    var i = f2.constructor;
    return i === Array ? f2.slice() : new i(f2);
  }
  function nFe(f2, i, t2, h, v4) {
    var _ = IWe[t2 || "float"];
    if (v4) {
      var M2 = f2[i], I2 = M2 && M2.length;
      if (I2 !== h) {
        for (var P2 = new _(h), N3 = 0; N3 < I2; N3++)
          P2[N3] = M2[N3];
        f2[i] = P2;
      }
    } else
      f2[i] = new _(h);
  }
  var QJt = function() {
    function f2() {
      this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = Il();
    }
    return f2.prototype.initData = function(i, t2, h) {
      this._provider = i, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
      var v4 = i.getSource(), _ = this.defaultDimValueGetter = MXt[v4.sourceFormat];
      this._dimValueGetter = h || _, this._rawExtent = [], mWe(v4), this._dimensions = Xa2(t2, function(M2) {
        return { type: M2.type, property: M2.property };
      }), this._initDataFromProvider(0, i.count());
    }, f2.prototype.getProvider = function() {
      return this._provider;
    }, f2.prototype.getSource = function() {
      return this._provider.getSource();
    }, f2.prototype.ensureCalculationDimension = function(i, t2) {
      var h = this._calcDimNameToIdx, v4 = this._dimensions, _ = h.get(i);
      if (_ != null) {
        if (v4[_].type === t2)
          return _;
      } else
        _ = v4.length;
      return v4[_] = { type: t2 }, h.set(i, _), this._chunks[_] = new IWe[t2 || "float"](this._rawCount), this._rawExtent[_] = ott(), _;
    }, f2.prototype.collectOrdinalMeta = function(i, t2) {
      var h = this._chunks[i], v4 = this._dimensions[i], _ = this._rawExtent, M2 = v4.ordinalOffset || 0, I2 = h.length;
      M2 === 0 && (_[i] = ott());
      for (var P2 = _[i], N3 = M2; N3 < I2; N3++) {
        var z3 = h[N3] = t2.parseAndCollect(h[N3]);
        P2[0] = Math.min(z3, P2[0]), P2[1] = Math.max(z3, P2[1]);
      }
      v4.ordinalMeta = t2, v4.ordinalOffset = I2, v4.type = "ordinal";
    }, f2.prototype.getOrdinalMeta = function(i) {
      var t2 = this._dimensions[i], h = t2.ordinalMeta;
      return h;
    }, f2.prototype.getDimensionProperty = function(i) {
      var t2 = this._dimensions[i];
      return t2 && t2.property;
    }, f2.prototype.appendData = function(i) {
      var t2 = this._provider, h = this.count();
      t2.appendData(i);
      var v4 = t2.count();
      return t2.persistent || (v4 += h), h < v4 && this._initDataFromProvider(h, v4, true), [h, v4];
    }, f2.prototype.appendValues = function(i, t2) {
      for (var h = this._chunks, v4 = this._dimensions, _ = v4.length, M2 = this._rawExtent, I2 = this.count(), P2 = I2 + Math.max(i.length, t2 || 0), N3 = 0; N3 < _; N3++) {
        var z3 = v4[N3];
        nFe(h, N3, z3.type, P2, true);
      }
      for (var H2 = [], $ = I2; $ < P2; $++)
        for (var et = $ - I2, at = 0; at < _; at++) {
          var z3 = v4[at], ht = MXt.arrayRows.call(this, i[et] || H2, z3.property, et, at);
          h[at][$] = ht;
          var bt = M2[at];
          ht < bt[0] && (bt[0] = ht), ht > bt[1] && (bt[1] = ht);
        }
      return this._rawCount = this._count = P2, { start: I2, end: P2 };
    }, f2.prototype._initDataFromProvider = function(i, t2, h) {
      for (var v4 = this._provider, _ = this._chunks, M2 = this._dimensions, I2 = M2.length, P2 = this._rawExtent, N3 = Xa2(M2, function(Et) {
        return Et.property;
      }), z3 = 0; z3 < I2; z3++) {
        var H2 = M2[z3];
        P2[z3] || (P2[z3] = ott()), nFe(_, z3, H2.type, t2, h);
      }
      if (v4.fillStorage)
        v4.fillStorage(i, t2, _, P2);
      else
        for (var $ = [], et = i; et < t2; et++) {
          $ = v4.getItem(et, $);
          for (var at = 0; at < I2; at++) {
            var ht = _[at], bt = this._dimValueGetter($, N3[at], et, at);
            ht[et] = bt;
            var _t = P2[at];
            bt < _t[0] && (_t[0] = bt), bt > _t[1] && (_t[1] = bt);
          }
        }
      !v4.persistent && v4.clean && v4.clean(), this._rawCount = this._count = t2, this._extent = [];
    }, f2.prototype.count = function() {
      return this._count;
    }, f2.prototype.get = function(i, t2) {
      if (!(t2 >= 0 && t2 < this._count))
        return NaN;
      var h = this._chunks[i];
      return h ? h[this.getRawIndex(t2)] : NaN;
    }, f2.prototype.getValues = function(i, t2) {
      var h = [], v4 = [];
      if (t2 == null) {
        t2 = i, i = [];
        for (var _ = 0; _ < this._dimensions.length; _++)
          v4.push(_);
      } else
        v4 = i;
      for (var _ = 0, M2 = v4.length; _ < M2; _++)
        h.push(this.get(v4[_], t2));
      return h;
    }, f2.prototype.getByRawIndex = function(i, t2) {
      if (!(t2 >= 0 && t2 < this._rawCount))
        return NaN;
      var h = this._chunks[i];
      return h ? h[t2] : NaN;
    }, f2.prototype.getSum = function(i) {
      var t2 = this._chunks[i], h = 0;
      if (t2)
        for (var v4 = 0, _ = this.count(); v4 < _; v4++) {
          var M2 = this.get(i, v4);
          isNaN(M2) || (h += M2);
        }
      return h;
    }, f2.prototype.getMedian = function(i) {
      var t2 = [];
      this.each([i], function(_) {
        isNaN(_) || t2.push(_);
      });
      var h = t2.sort(function(_, M2) {
        return _ - M2;
      }), v4 = this.count();
      return v4 === 0 ? 0 : v4 % 2 === 1 ? h[(v4 - 1) / 2] : (h[v4 / 2] + h[v4 / 2 - 1]) / 2;
    }, f2.prototype.indexOfRawIndex = function(i) {
      if (i >= this._rawCount || i < 0)
        return -1;
      if (!this._indices)
        return i;
      var t2 = this._indices, h = t2[i];
      if (h != null && h < this._count && h === i)
        return i;
      for (var v4 = 0, _ = this._count - 1; v4 <= _; ) {
        var M2 = (v4 + _) / 2 | 0;
        if (t2[M2] < i)
          v4 = M2 + 1;
        else if (t2[M2] > i)
          _ = M2 - 1;
        else
          return M2;
      }
      return -1;
    }, f2.prototype.indicesOfNearest = function(i, t2, h) {
      var v4 = this._chunks, _ = v4[i], M2 = [];
      if (!_)
        return M2;
      h == null && (h = 1 / 0);
      for (var I2 = 1 / 0, P2 = -1, N3 = 0, z3 = 0, H2 = this.count(); z3 < H2; z3++) {
        var $ = this.getRawIndex(z3), et = t2 - _[$], at = Math.abs(et);
        at <= h && ((at < I2 || at === I2 && et >= 0 && P2 < 0) && (I2 = at, P2 = et, N3 = 0), et === P2 && (M2[N3++] = z3));
      }
      return M2.length = N3, M2;
    }, f2.prototype.getIndices = function() {
      var i, t2 = this._indices;
      if (t2) {
        var h = t2.constructor, v4 = this._count;
        if (h === Array) {
          i = new h(v4);
          for (var _ = 0; _ < v4; _++)
            i[_] = t2[_];
        } else
          i = new h(t2.buffer, 0, v4);
      } else {
        var h = qpt(this._rawCount);
        i = new h(this.count());
        for (var _ = 0; _ < i.length; _++)
          i[_] = _;
      }
      return i;
    }, f2.prototype.filter = function(i, t2) {
      if (!this._count)
        return this;
      for (var h = this.clone(), v4 = h.count(), _ = qpt(h._rawCount), M2 = new _(v4), I2 = [], P2 = i.length, N3 = 0, z3 = i[0], H2 = h._chunks, $ = 0; $ < v4; $++) {
        var et = void 0, at = h.getRawIndex($);
        if (P2 === 0)
          et = t2($);
        else if (P2 === 1) {
          var ht = H2[z3][at];
          et = t2(ht, $);
        } else {
          for (var bt = 0; bt < P2; bt++)
            I2[bt] = H2[i[bt]][at];
          I2[bt] = $, et = t2.apply(null, I2);
        }
        et && (M2[N3++] = at);
      }
      return N3 < v4 && (h._indices = M2), h._count = N3, h._extent = [], h._updateGetRawIdx(), h;
    }, f2.prototype.selectRange = function(i) {
      var t2 = this.clone(), h = t2._count;
      if (!h)
        return this;
      var v4 = Of2(i), _ = v4.length;
      if (!_)
        return this;
      var M2 = t2.count(), I2 = qpt(t2._rawCount), P2 = new I2(M2), N3 = 0, z3 = v4[0], H2 = i[z3][0], $ = i[z3][1], et = t2._chunks, at = false;
      if (!t2._indices) {
        var ht = 0;
        if (_ === 1) {
          for (var bt = et[v4[0]], _t = 0; _t < h; _t++) {
            var Et = bt[_t];
            (Et >= H2 && Et <= $ || isNaN(Et)) && (P2[N3++] = ht), ht++;
          }
          at = true;
        } else if (_ === 2) {
          for (var bt = et[v4[0]], zt = et[v4[1]], Ft = i[v4[1]][0], fe2 = i[v4[1]][1], _t = 0; _t < h; _t++) {
            var Et = bt[_t], re2 = zt[_t];
            (Et >= H2 && Et <= $ || isNaN(Et)) && (re2 >= Ft && re2 <= fe2 || isNaN(re2)) && (P2[N3++] = ht), ht++;
          }
          at = true;
        }
      }
      if (!at)
        if (_ === 1)
          for (var _t = 0; _t < M2; _t++) {
            var ye = t2.getRawIndex(_t), Et = et[v4[0]][ye];
            (Et >= H2 && Et <= $ || isNaN(Et)) && (P2[N3++] = ye);
          }
        else
          for (var _t = 0; _t < M2; _t++) {
            for (var me2 = true, ye = t2.getRawIndex(_t), be2 = 0; be2 < _; be2++) {
              var Te2 = v4[be2], Et = et[Te2][ye];
              (Et < i[Te2][0] || Et > i[Te2][1]) && (me2 = false);
            }
            me2 && (P2[N3++] = t2.getRawIndex(_t));
          }
      return N3 < M2 && (t2._indices = P2), t2._count = N3, t2._extent = [], t2._updateGetRawIdx(), t2;
    }, f2.prototype.map = function(i, t2) {
      var h = this.clone(i);
      return this._updateDims(h, i, t2), h;
    }, f2.prototype.modify = function(i, t2) {
      this._updateDims(this, i, t2);
    }, f2.prototype._updateDims = function(i, t2, h) {
      for (var v4 = i._chunks, _ = [], M2 = t2.length, I2 = i.count(), P2 = [], N3 = i._rawExtent, z3 = 0; z3 < t2.length; z3++)
        N3[t2[z3]] = ott();
      for (var H2 = 0; H2 < I2; H2++) {
        for (var $ = i.getRawIndex(H2), et = 0; et < M2; et++)
          P2[et] = v4[t2[et]][$];
        P2[M2] = H2;
        var at = h && h.apply(null, P2);
        if (at != null) {
          typeof at != "object" && (_[0] = at, at = _);
          for (var z3 = 0; z3 < at.length; z3++) {
            var ht = t2[z3], bt = at[z3], _t = N3[ht], Et = v4[ht];
            Et && (Et[$] = bt), bt < _t[0] && (_t[0] = bt), bt > _t[1] && (_t[1] = bt);
          }
        }
      }
    }, f2.prototype.lttbDownSample = function(i, t2) {
      var h = this.clone([i], true), v4 = h._chunks, _ = v4[i], M2 = this.count(), I2 = 0, P2 = Math.floor(1 / t2), N3 = this.getRawIndex(0), z3, H2, $, et = new (qpt(this._rawCount))(Math.min((Math.ceil(M2 / P2) + 2) * 2, M2));
      et[I2++] = N3;
      for (var at = 1; at < M2 - 1; at += P2) {
        for (var ht = Math.min(at + P2, M2 - 1), bt = Math.min(at + P2 * 2, M2), _t = (bt + ht) / 2, Et = 0, zt = ht; zt < bt; zt++) {
          var Ft = this.getRawIndex(zt), fe2 = _[Ft];
          isNaN(fe2) || (Et += fe2);
        }
        Et /= bt - ht;
        var re2 = at, ye = Math.min(at + P2, M2), me2 = at - 1, be2 = _[N3];
        z3 = -1, $ = re2;
        for (var Te2 = -1, We = 0, zt = re2; zt < ye; zt++) {
          var Ft = this.getRawIndex(zt), fe2 = _[Ft];
          if (isNaN(fe2)) {
            We++, Te2 < 0 && (Te2 = Ft);
            continue;
          }
          H2 = Math.abs((me2 - _t) * (fe2 - be2) - (me2 - zt) * (Et - be2)), H2 > z3 && (z3 = H2, $ = Ft);
        }
        We > 0 && We < ye - re2 && (et[I2++] = Math.min(Te2, $), $ = Math.max(Te2, $)), et[I2++] = $, N3 = $;
      }
      return et[I2++] = this.getRawIndex(M2 - 1), h._count = I2, h._indices = et, h.getRawIndex = this._getRawIdx, h;
    }, f2.prototype.downSample = function(i, t2, h, v4) {
      for (var _ = this.clone([i], true), M2 = _._chunks, I2 = [], P2 = Math.floor(1 / t2), N3 = M2[i], z3 = this.count(), H2 = _._rawExtent[i] = ott(), $ = new (qpt(this._rawCount))(Math.ceil(z3 / P2)), et = 0, at = 0; at < z3; at += P2) {
        P2 > z3 - at && (P2 = z3 - at, I2.length = P2);
        for (var ht = 0; ht < P2; ht++) {
          var bt = this.getRawIndex(at + ht);
          I2[ht] = N3[bt];
        }
        var _t = h(I2), Et = this.getRawIndex(Math.min(at + v4(I2, _t) || 0, z3 - 1));
        N3[Et] = _t, _t < H2[0] && (H2[0] = _t), _t > H2[1] && (H2[1] = _t), $[et++] = Et;
      }
      return _._count = et, _._indices = $, _._updateGetRawIdx(), _;
    }, f2.prototype.each = function(i, t2) {
      if (!!this._count)
        for (var h = i.length, v4 = this._chunks, _ = 0, M2 = this.count(); _ < M2; _++) {
          var I2 = this.getRawIndex(_);
          switch (h) {
            case 0:
              t2(_);
              break;
            case 1:
              t2(v4[i[0]][I2], _);
              break;
            case 2:
              t2(v4[i[0]][I2], v4[i[1]][I2], _);
              break;
            default:
              for (var P2 = 0, N3 = []; P2 < h; P2++)
                N3[P2] = v4[i[P2]][I2];
              N3[P2] = _, t2.apply(null, N3);
          }
        }
    }, f2.prototype.getDataExtent = function(i) {
      var t2 = this._chunks[i], h = ott();
      if (!t2)
        return h;
      var v4 = this.count(), _ = !this._indices, M2;
      if (_)
        return this._rawExtent[i].slice();
      if (M2 = this._extent[i], M2)
        return M2.slice();
      M2 = h;
      for (var I2 = M2[0], P2 = M2[1], N3 = 0; N3 < v4; N3++) {
        var z3 = this.getRawIndex(N3), H2 = t2[z3];
        H2 < I2 && (I2 = H2), H2 > P2 && (P2 = H2);
      }
      return M2 = [I2, P2], this._extent[i] = M2, M2;
    }, f2.prototype.getRawDataItem = function(i) {
      var t2 = this.getRawIndex(i);
      if (this._provider.persistent)
        return this._provider.getItem(t2);
      for (var h = [], v4 = this._chunks, _ = 0; _ < v4.length; _++)
        h.push(v4[_][t2]);
      return h;
    }, f2.prototype.clone = function(i, t2) {
      var h = new f2(), v4 = this._chunks, _ = i && zL(i, function(I2, P2) {
        return I2[P2] = true, I2;
      }, {});
      if (_)
        for (var M2 = 0; M2 < v4.length; M2++)
          h._chunks[M2] = _[M2] ? Zpr(v4[M2]) : v4[M2];
      else
        h._chunks = v4;
      return this._copyCommonProps(h), t2 || (h._indices = this._cloneIndices()), h._updateGetRawIdx(), h;
    }, f2.prototype._copyCommonProps = function(i) {
      i._count = this._count, i._rawCount = this._rawCount, i._provider = this._provider, i._dimensions = this._dimensions, i._extent = pu(this._extent), i._rawExtent = pu(this._rawExtent);
    }, f2.prototype._cloneIndices = function() {
      if (this._indices) {
        var i = this._indices.constructor, t2 = void 0;
        if (i === Array) {
          var h = this._indices.length;
          t2 = new i(h);
          for (var v4 = 0; v4 < h; v4++)
            t2[v4] = this._indices[v4];
        } else
          t2 = new i(this._indices);
        return t2;
      }
      return null;
    }, f2.prototype._getRawIdxIdentity = function(i) {
      return i;
    }, f2.prototype._getRawIdx = function(i) {
      return i < this._count && i >= 0 ? this._indices[i] : -1;
    }, f2.prototype._updateGetRawIdx = function() {
      this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
    }, f2.internalField = function() {
      function i(t2, h, v4, _) {
        return $7(t2[_], this._dimensions[_]);
      }
      MXt = { arrayRows: i, objectRows: function(t2, h, v4, _) {
        return $7(t2[h], this._dimensions[_]);
      }, keyedColumns: i, original: function(t2, h, v4, _) {
        var M2 = t2 && (t2.value == null ? t2 : t2.value);
        return $7(M2 instanceof Array ? M2[_] : M2, this._dimensions[_]);
      }, typedArray: function(t2, h, v4, _) {
        return t2[_];
      } };
    }(), f2;
  }(), DWe = function() {
    function f2(i) {
      this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = i;
    }
    return f2.prototype.dirty = function() {
      this._setLocalSource([], []), this._storeList = [], this._dirty = true;
    }, f2.prototype._setLocalSource = function(i, t2) {
      this._sourceList = i, this._upstreamSignList = t2, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
    }, f2.prototype._getVersionSign = function() {
      return this._sourceHost.uid + "_" + this._versionSignBase;
    }, f2.prototype.prepareSource = function() {
      this._isDirty() && (this._createSource(), this._dirty = false);
    }, f2.prototype._createSource = function() {
      this._setLocalSource([], []);
      var i = this._sourceHost, t2 = this._getUpstreamSourceManagers(), h = !!t2.length, v4, _;
      if (YIt(i)) {
        var M2 = i, I2 = void 0, P2 = void 0, N3 = void 0;
        if (h) {
          var z3 = t2[0];
          z3.prepareSource(), N3 = z3.getSource(), I2 = N3.data, P2 = N3.sourceFormat, _ = [z3._getVersionSign()];
        } else
          I2 = M2.get("data", true), P2 = YT(I2) ? Z7 : aE, _ = [];
        var H2 = this._getSourceMetaRawOption() || {}, $ = N3 && N3.metaRawOption || {}, et = _c2(H2.seriesLayoutBy, $.seriesLayoutBy) || null, at = _c2(H2.sourceHeader, $.sourceHeader), ht = _c2(H2.dimensions, $.dimensions), bt = et !== $.seriesLayoutBy || !!at != !!$.sourceHeader || ht;
        v4 = bt ? [XJt(I2, { seriesLayoutBy: et, sourceHeader: at, dimensions: ht }, P2)] : [];
      } else {
        var _t = i;
        if (h) {
          var Et = this._applyTransform(t2);
          v4 = Et.sourceList, _ = Et.upstreamSignList;
        } else {
          var zt = _t.get("source", true);
          v4 = [XJt(zt, this._getSourceMetaRawOption(), null)], _ = [];
        }
      }
      this._setLocalSource(v4, _);
    }, f2.prototype._applyTransform = function(i) {
      var t2 = this._sourceHost, h = t2.get("transform", true), v4 = t2.get("fromTransformResult", true);
      if (v4 != null) {
        var _ = "";
        i.length !== 1 && iFe(_);
      }
      var M2, I2 = [], P2 = [];
      return Qe2(i, function(N3) {
        N3.prepareSource();
        var z3 = N3.getSource(v4 || 0), H2 = "";
        v4 != null && !z3 && iFe(H2), I2.push(z3), P2.push(N3._getVersionSign());
      }), h ? M2 = Gpr(h, I2, { datasetIndex: t2.componentIndex }) : v4 != null && (M2 = [Mpr(I2[0])]), { sourceList: M2, upstreamSignList: P2 };
    }, f2.prototype._isDirty = function() {
      if (this._dirty)
        return true;
      for (var i = this._getUpstreamSourceManagers(), t2 = 0; t2 < i.length; t2++) {
        var h = i[t2];
        if (h._isDirty() || this._upstreamSignList[t2] !== h._getVersionSign())
          return true;
      }
    }, f2.prototype.getSource = function(i) {
      i = i || 0;
      var t2 = this._sourceList[i];
      if (!t2) {
        var h = this._getUpstreamSourceManagers();
        return h[0] && h[0].getSource(i);
      }
      return t2;
    }, f2.prototype.getSharedDataStore = function(i) {
      var t2 = i.makeStoreSchema();
      return this._innerGetDataStore(t2.dimensions, i.source, t2.hash);
    }, f2.prototype._innerGetDataStore = function(i, t2, h) {
      var v4 = 0, _ = this._storeList, M2 = _[v4];
      M2 || (M2 = _[v4] = {});
      var I2 = M2[h];
      if (!I2) {
        var P2 = this._getUpstreamSourceManagers()[0];
        YIt(this._sourceHost) && P2 ? I2 = P2._innerGetDataStore(i, t2, h) : (I2 = new QJt(), I2.initData(new bWe(t2, i.length), i)), M2[h] = I2;
      }
      return I2;
    }, f2.prototype._getUpstreamSourceManagers = function() {
      var i = this._sourceHost;
      if (YIt(i)) {
        var t2 = Xee(i);
        return t2 ? [t2.getSourceManager()] : [];
      } else
        return Xa2(Khr(i), function(h) {
          return h.getSourceManager();
        });
    }, f2.prototype._getSourceMetaRawOption = function() {
      var i = this._sourceHost, t2, h, v4;
      if (YIt(i))
        t2 = i.get("seriesLayoutBy", true), h = i.get("sourceHeader", true), v4 = i.get("dimensions", true);
      else if (!this._getUpstreamSourceManagers().length) {
        var _ = i;
        t2 = _.get("seriesLayoutBy", true), h = _.get("sourceHeader", true), v4 = _.get("dimensions", true);
      }
      return { seriesLayoutBy: t2, sourceHeader: h, dimensions: v4 };
    }, f2;
  }();
  function rFe(f2) {
    var i = f2.option.transform;
    i && oEt(f2.option.transform);
  }
  function YIt(f2) {
    return f2.mainType === "series";
  }
  function iFe(f2) {
    throw new Error(f2);
  }
  var EWe = "line-height:1";
  function kWe(f2, i) {
    var t2 = f2.color || "#6e7079", h = f2.fontSize || 12, v4 = f2.fontWeight || "400", _ = f2.color || "#464646", M2 = f2.fontSize || 14, I2 = f2.fontWeight || "900";
    return i === "html" ? { nameStyle: "font-size:" + HT(h + "") + "px;color:" + HT(t2) + ";font-weight:" + HT(v4 + ""), valueStyle: "font-size:" + HT(M2 + "") + "px;color:" + HT(_) + ";font-weight:" + HT(I2 + "") } : { nameStyle: { fontSize: h, fill: t2, fontWeight: v4 }, valueStyle: { fontSize: M2, fill: _, fontWeight: I2 } };
  }
  var $pr = [0, 10, 20, 30], Ypr = ["", `
`, `

`, `


`];
  function pb2(f2, i) {
    return i.type = f2, i;
  }
  function JJt(f2) {
    return f2.type === "section";
  }
  function PWe(f2) {
    return JJt(f2) ? Kpr : Xpr;
  }
  function LWe(f2) {
    if (JJt(f2)) {
      var i = 0, t2 = f2.blocks.length, h = t2 > 1 || t2 > 0 && !f2.noHeader;
      return Qe2(f2.blocks, function(v4) {
        var _ = LWe(v4);
        _ >= i && (i = _ + +(h && (!_ || JJt(v4) && !v4.noHeader)));
      }), i;
    }
    return 0;
  }
  function Kpr(f2, i, t2, h) {
    var v4 = i.noHeader, _ = Qpr(LWe(i)), M2 = [], I2 = i.blocks || [];
    z2(!I2 || Za2(I2)), I2 = I2 || [];
    var P2 = f2.orderMode;
    if (i.sortBlocks && P2) {
      I2 = I2.slice();
      var N3 = { valueAsc: "asc", valueDesc: "desc" };
      if (qs(N3, P2)) {
        var z3 = new CWe(N3[P2], null);
        I2.sort(function(at, ht) {
          return z3.evaluate(at.sortParam, ht.sortParam);
        });
      } else
        P2 === "seriesDesc" && I2.reverse();
    }
    Qe2(I2, function(at, ht) {
      var bt = i.valueFormatter, _t = PWe(at)(bt ? ba2(ba2({}, f2), { valueFormatter: bt }) : f2, at, ht > 0 ? _.html : 0, h);
      _t != null && M2.push(_t);
    });
    var H2 = f2.renderMode === "richText" ? M2.join(_.richText) : tte(M2.join(""), v4 ? t2 : _.html);
    if (v4)
      return H2;
    var $ = $Jt(i.header, "ordinal", f2.useUTC), et = kWe(h, f2.renderMode).nameStyle;
    return f2.renderMode === "richText" ? OWe(f2, $, et) + _.richText + H2 : tte('<div style="' + et + ";" + EWe + ';">' + HT($) + "</div>" + H2, t2);
  }
  function Xpr(f2, i, t2, h) {
    var v4 = f2.renderMode, _ = i.noName, M2 = i.noValue, I2 = !i.markerType, P2 = i.name, N3 = f2.useUTC, z3 = i.valueFormatter || f2.valueFormatter || function(Ft) {
      return Ft = Za2(Ft) ? Ft : [Ft], Xa2(Ft, function(fe2, re2) {
        return $Jt(fe2, Za2(et) ? et[re2] : et, N3);
      });
    };
    if (!(_ && M2)) {
      var H2 = I2 ? "" : f2.markupStyleCreator.makeTooltipMarker(i.markerType, i.markerColor || "#333", v4), $ = _ ? "" : $Jt(P2, "ordinal", N3), et = i.valueType, at = M2 ? [] : z3(i.value), ht = !I2 || !_, bt = !I2 && _, _t = kWe(h, v4), Et = _t.nameStyle, zt = _t.valueStyle;
      return v4 === "richText" ? (I2 ? "" : H2) + (_ ? "" : OWe(f2, $, Et)) + (M2 ? "" : edr(f2, at, ht, bt, zt)) : tte((I2 ? "" : H2) + (_ ? "" : Jpr($, !I2, Et)) + (M2 ? "" : tdr(at, ht, bt, zt)), t2);
    }
  }
  function aFe(f2, i, t2, h, v4, _) {
    if (!!f2) {
      var M2 = PWe(f2), I2 = { useUTC: v4, renderMode: t2, orderMode: h, markupStyleCreator: i, valueFormatter: f2.valueFormatter };
      return M2(I2, f2, 0, _);
    }
  }
  function Qpr(f2) {
    return { html: $pr[f2], richText: Ypr[f2] };
  }
  function tte(f2, i) {
    var t2 = '<div style="clear:both"></div>', h = "margin: " + i + "px 0 0";
    return '<div style="' + h + ";" + EWe + ';">' + f2 + t2 + "</div>";
  }
  function Jpr(f2, i, t2) {
    var h = i ? "margin-left:2px" : "";
    return '<span style="' + t2 + ";" + h + '">' + HT(f2) + "</span>";
  }
  function tdr(f2, i, t2, h) {
    var v4 = t2 ? "10px" : "20px", _ = i ? "float:right;margin-left:" + v4 : "";
    return f2 = Za2(f2) ? f2 : [f2], '<span style="' + _ + ";" + h + '">' + Xa2(f2, function(M2) {
      return HT(M2);
    }).join("&nbsp;&nbsp;") + "</span>";
  }
  function OWe(f2, i, t2) {
    return f2.markupStyleCreator.wrapRichTextStyle(i, t2);
  }
  function edr(f2, i, t2, h, v4) {
    var _ = [v4], M2 = h ? 10 : 20;
    return t2 && _.push({ padding: [0, 0, 0, M2], align: "right" }), f2.markupStyleCreator.wrapRichTextStyle(Za2(i) ? i.join("  ") : i, _);
  }
  function RWe(f2, i) {
    var t2 = f2.getData().getItemVisual(i, "style"), h = t2[f2.visualDrawType];
    return bU(h);
  }
  function NWe(f2, i) {
    var t2 = f2.get("padding");
    return t2 != null ? t2 : i === "richText" ? [8, 10] : 10;
  }
  var CXt = function() {
    function f2() {
      this.richTextStyles = {}, this._nextStyleNameId = Oze();
    }
    return f2.prototype._generateStyleName = function() {
      return "__EC_aUTo_" + this._nextStyleNameId++;
    }, f2.prototype.makeTooltipMarker = function(i, t2, h) {
      var v4 = h === "richText" ? this._generateStyleName() : null, _ = Ghr({ color: t2, type: i, renderMode: h, markerId: v4 });
      return ms(_) ? _ : (this.richTextStyles[v4] = _.style, _.content);
    }, f2.prototype.wrapRichTextStyle = function(i, t2) {
      var h = {};
      Za2(t2) ? Qe2(t2, function(_) {
        return ba2(h, _);
      }) : ba2(h, t2);
      var v4 = this._generateStyleName();
      return this.richTextStyles[v4] = h, "{" + v4 + "|" + i + "}";
    }, f2;
  }();
  function FWe(f2) {
    var i = f2.series, t2 = f2.dataIndex, h = f2.multipleSeries, v4 = i.getData(), _ = v4.mapDimensionsAll("defaultedTooltip"), M2 = _.length, I2 = i.getRawValue(t2), P2 = Za2(I2), N3 = RWe(i, t2), z3, H2, $, et;
    if (M2 > 1 || P2 && !M2) {
      var at = ndr(I2, i, t2, _, N3);
      z3 = at.inlineValues, H2 = at.inlineValueTypes, $ = at.blocks, et = at.inlineValues[0];
    } else if (M2) {
      var ht = v4.getDimensionInfo(_[0]);
      et = z3 = Gtt(v4, t2, _[0]), H2 = ht.type;
    } else
      et = z3 = P2 ? I2[0] : I2;
    var bt = Eee(i), _t = bt && i.name || "", Et = v4.getName(t2), zt = h ? _t : Et;
    return pb2("section", { header: _t, noHeader: h || !bt, sortParam: et, blocks: [pb2("nameValue", { markerType: "item", markerColor: N3, name: zt, noName: !w5(zt), value: z3, valueType: H2 })].concat($ || []) });
  }
  function ndr(f2, i, t2, h, v4) {
    var _ = i.getData(), M2 = zL(f2, function(H2, $, et) {
      var at = _.getDimensionInfo(et);
      return H2 = H2 || at && at.tooltip !== false && at.displayName != null;
    }, false), I2 = [], P2 = [], N3 = [];
    h.length ? Qe2(h, function(H2) {
      z3(Gtt(_, t2, H2), H2);
    }) : Qe2(f2, z3);
    function z3(H2, $) {
      var et = _.getDimensionInfo($);
      !et || et.otherDims.tooltip === false || (M2 ? N3.push(pb2("nameValue", { markerType: "subItem", markerColor: v4, name: et.displayName, value: H2, valueType: et.type })) : (I2.push(H2), P2.push(et.type)));
    }
    return { inlineValues: I2, inlineValueTypes: P2, blocks: N3 };
  }
  var C7 = Wh2();
  function KIt(f2, i) {
    return f2.getName(i) || f2.getId(i);
  }
  var XDt = "__universalTransitionEnabled", Ekt = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2._selectedDataIndicesMap = {}, t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      this.seriesIndex = this.componentIndex, this.dataTask = Ndt({ count: idr, reset: adr }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(t2, v4);
      var _ = C7(this).sourceManager = new DWe(this);
      _.prepareSource();
      var M2 = this.getInitialData(t2, v4);
      sFe(M2, this), this.dataTask.context.data = M2, C7(this).dataBeforeProcessed = M2, oFe(this), this._initSelectedMapFromData(M2);
    }, i.prototype.mergeDefaultAndTheme = function(t2, h) {
      var v4 = rgt(this), _ = v4 ? aet(t2) : {}, M2 = this.subType;
      zh2.hasClass(M2) && (M2 += "Series"), cc2(t2, h.getTheme().get(this.subType)), cc2(t2, this.getDefaultOption()), gU(t2, "label", ["show"]), this.fillDataTextStyle(t2.data), v4 && J7(t2, _, v4);
    }, i.prototype.mergeOption = function(t2, h) {
      t2 = cc2(this.option, t2, true), this.fillDataTextStyle(t2.data);
      var v4 = rgt(this);
      v4 && J7(this.option, t2, v4);
      var _ = C7(this).sourceManager;
      _.dirty(), _.prepareSource();
      var M2 = this.getInitialData(t2, h);
      sFe(M2, this), this.dataTask.dirty(), this.dataTask.context.data = M2, C7(this).dataBeforeProcessed = M2, oFe(this), this._initSelectedMapFromData(M2);
    }, i.prototype.fillDataTextStyle = function(t2) {
      if (t2 && !YT(t2))
        for (var h = ["show"], v4 = 0; v4 < t2.length; v4++)
          t2[v4] && t2[v4].label && gU(t2[v4], "label", h);
    }, i.prototype.getInitialData = function(t2, h) {
    }, i.prototype.appendData = function(t2) {
      var h = this.getRawData();
      h.appendData(t2.data);
    }, i.prototype.getData = function(t2) {
      var h = ete(this);
      if (h) {
        var v4 = h.context.data;
        return t2 == null ? v4 : v4.getLinkedData(t2);
      } else
        return C7(this).data;
    }, i.prototype.getAllData = function() {
      var t2 = this.getData();
      return t2 && t2.getLinkedDataAll ? t2.getLinkedDataAll() : [{ data: t2 }];
    }, i.prototype.setData = function(t2) {
      var h = ete(this);
      if (h) {
        var v4 = h.context;
        v4.outputData = t2, h !== this.dataTask && (v4.data = t2);
      }
      C7(this).data = t2;
    }, i.prototype.getEncode = function() {
      var t2 = this.get("encode", true);
      if (t2)
        return Il(t2);
    }, i.prototype.getSourceManager = function() {
      return C7(this).sourceManager;
    }, i.prototype.getSource = function() {
      return this.getSourceManager().getSource();
    }, i.prototype.getRawData = function() {
      return C7(this).dataBeforeProcessed;
    }, i.prototype.getColorBy = function() {
      var t2 = this.get("colorBy");
      return t2 || "series";
    }, i.prototype.isColorBySeries = function() {
      return this.getColorBy() === "series";
    }, i.prototype.getBaseAxis = function() {
      var t2 = this.coordinateSystem;
      return t2 && t2.getBaseAxis && t2.getBaseAxis();
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      return FWe({ series: this, dataIndex: t2, multipleSeries: h });
    }, i.prototype.isAnimationEnabled = function() {
      var t2 = this.ecModel;
      if (gp.node && !(t2 && t2.ssr))
        return false;
      var h = this.getShallow("animation");
      return h && this.getData().count() > this.getShallow("animationThreshold") && (h = false), !!h;
    }, i.prototype.restoreData = function() {
      this.dataTask.dirty();
    }, i.prototype.getColorFromPalette = function(t2, h, v4) {
      var _ = this.ecModel, M2 = Qee.prototype.getColorFromPalette.call(this, t2, h, v4);
      return M2 || (M2 = _.getColorFromPalette(t2, h, v4)), M2;
    }, i.prototype.coordDimToDataDim = function(t2) {
      return this.getRawData().mapDimensionsAll(t2);
    }, i.prototype.getProgressive = function() {
      return this.get("progressive");
    }, i.prototype.getProgressiveThreshold = function() {
      return this.get("progressiveThreshold");
    }, i.prototype.select = function(t2, h) {
      this._innerSelect(this.getData(h), t2);
    }, i.prototype.unselect = function(t2, h) {
      var v4 = this.option.selectedMap;
      if (!!v4) {
        var _ = this.option.selectedMode, M2 = this.getData(h);
        if (_ === "series" || v4 === "all") {
          this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
          return;
        }
        for (var I2 = 0; I2 < t2.length; I2++) {
          var P2 = t2[I2], N3 = KIt(M2, P2);
          v4[N3] = false, this._selectedDataIndicesMap[N3] = -1;
        }
      }
    }, i.prototype.toggleSelect = function(t2, h) {
      for (var v4 = [], _ = 0; _ < t2.length; _++)
        v4[0] = t2[_], this.isSelected(t2[_], h) ? this.unselect(v4, h) : this.select(v4, h);
    }, i.prototype.getSelectedDataIndices = function() {
      if (this.option.selectedMap === "all")
        return [].slice.call(this.getData().getIndices());
      for (var t2 = this._selectedDataIndicesMap, h = Of2(t2), v4 = [], _ = 0; _ < h.length; _++) {
        var M2 = t2[h[_]];
        M2 >= 0 && v4.push(M2);
      }
      return v4;
    }, i.prototype.isSelected = function(t2, h) {
      var v4 = this.option.selectedMap;
      if (!v4)
        return false;
      var _ = this.getData(h);
      return (v4 === "all" || v4[KIt(_, t2)]) && !_.getItemModel(t2).get(["select", "disabled"]);
    }, i.prototype.isUniversalTransitionEnabled = function() {
      if (this[XDt])
        return true;
      var t2 = this.option.universalTransition;
      return t2 ? t2 === true ? true : t2 && t2.enabled : false;
    }, i.prototype._innerSelect = function(t2, h) {
      var v4, _, M2 = this.option, I2 = M2.selectedMode, P2 = h.length;
      if (!(!I2 || !P2)) {
        if (I2 === "series")
          M2.selectedMap = "all";
        else if (I2 === "multiple") {
          Xl(M2.selectedMap) || (M2.selectedMap = {});
          for (var N3 = M2.selectedMap, z3 = 0; z3 < P2; z3++) {
            var H2 = h[z3], $ = KIt(t2, H2);
            N3[$] = true, this._selectedDataIndicesMap[$] = t2.getRawIndex(H2);
          }
        } else if (I2 === "single" || I2 === true) {
          var et = h[P2 - 1], $ = KIt(t2, et);
          M2.selectedMap = (v4 = {}, v4[$] = true, v4), this._selectedDataIndicesMap = (_ = {}, _[$] = t2.getRawIndex(et), _);
        }
      }
    }, i.prototype._initSelectedMapFromData = function(t2) {
      if (!this.option.selectedMap) {
        var h = [];
        t2.hasItemOption && t2.each(function(v4) {
          var _ = t2.getRawDataItem(v4);
          _ && _.selected && h.push(v4);
        }), h.length > 0 && this._innerSelect(t2, h);
      }
    }, i.registerClass = function(t2) {
      return zh2.registerClass(t2);
    }, i.protoInitialize = function() {
      var t2 = i.prototype;
      t2.type = "series.__base__", t2.seriesIndex = 0, t2.ignoreStyleOnData = false, t2.hasSymbolVisual = false, t2.defaultSymbol = "circle", t2.visualStyleAccessPath = "itemStyle", t2.visualDrawType = "fill";
    }(), i;
  }(zh2);
  Sm(Ekt, nne);
  Sm(Ekt, Qee);
  Gze(Ekt, zh2);
  function oFe(f2) {
    var i = f2.name;
    Eee(f2) || (f2.name = rdr(f2) || i);
  }
  function rdr(f2) {
    var i = f2.getRawData(), t2 = i.mapDimensionsAll("seriesName"), h = [];
    return Qe2(t2, function(v4) {
      var _ = i.getDimensionInfo(v4);
      _.displayName && h.push(_.displayName);
    }), h.join(" ");
  }
  function idr(f2) {
    return f2.model.getRawData().count();
  }
  function adr(f2) {
    var i = f2.model;
    return i.setData(i.getRawData().cloneShallow()), odr;
  }
  function odr(f2, i) {
    i.outputData && f2.end > i.outputData.count() && i.model.getRawData().cloneShallow(i.outputData);
  }
  function sFe(f2, i) {
    Qe2(pJt(f2.CHANGABLE_METHODS, f2.DOWNSAMPLE_METHODS), function(t2) {
      f2.wrapMethod(t2, Ou(sdr, i));
    });
  }
  function sdr(f2, i) {
    var t2 = ete(f2);
    return t2 && t2.setOutputEnd((i || this).count()), i;
  }
  function ete(f2) {
    var i = (f2.ecModel || {}).scheduler, t2 = i && i.getPipeline(f2.uid);
    if (t2) {
      var h = t2.currentTask;
      if (h) {
        var v4 = h.agentStubMap;
        v4 && (h = v4.get(f2.uid));
      }
      return h;
    }
  }
  var Jv = Ekt, ine = function() {
    function f2() {
      this.group = new mu(), this.uid = ret("viewComponent");
    }
    return f2.prototype.init = function(i, t2) {
    }, f2.prototype.render = function(i, t2, h, v4) {
    }, f2.prototype.dispose = function(i, t2) {
    }, f2.prototype.updateView = function(i, t2, h, v4) {
    }, f2.prototype.updateLayout = function(i, t2, h, v4) {
    }, f2.prototype.updateVisual = function(i, t2, h, v4) {
    }, f2.prototype.blurSeries = function(i, t2) {
    }, f2.prototype.eachRendered = function(i) {
      var t2 = this.group;
      t2 && t2.traverse(i);
    }, f2;
  }();
  Pee(ine);
  fkt(ine);
  var W0 = ine;
  function uet() {
    var f2 = Wh2();
    return function(i) {
      var t2 = f2(i), h = i.pipelineContext, v4 = !!t2.large, _ = !!t2.progressiveRender, M2 = t2.large = !!(h && h.large), I2 = t2.progressiveRender = !!(h && h.progressiveRender);
      return (v4 !== M2 || _ !== I2) && "reset";
    };
  }
  var VWe = Wh2(), ldr = uet(), ane = function() {
    function f2() {
      this.group = new mu(), this.uid = ret("viewChart"), this.renderTask = Ndt({ plan: udr, reset: cdr }), this.renderTask.context = { view: this };
    }
    return f2.prototype.init = function(i, t2) {
    }, f2.prototype.render = function(i, t2, h, v4) {
    }, f2.prototype.highlight = function(i, t2, h, v4) {
      var _ = i.getData(v4 && v4.dataType);
      !_ || uFe(_, v4, "emphasis");
    }, f2.prototype.downplay = function(i, t2, h, v4) {
      var _ = i.getData(v4 && v4.dataType);
      !_ || uFe(_, v4, "normal");
    }, f2.prototype.remove = function(i, t2) {
      this.group.removeAll();
    }, f2.prototype.dispose = function(i, t2) {
    }, f2.prototype.updateView = function(i, t2, h, v4) {
      this.render(i, t2, h, v4);
    }, f2.prototype.updateLayout = function(i, t2, h, v4) {
      this.render(i, t2, h, v4);
    }, f2.prototype.updateVisual = function(i, t2, h, v4) {
      this.render(i, t2, h, v4);
    }, f2.prototype.eachRendered = function(i) {
      oV(this.group, i);
    }, f2.markUpdateMethod = function(i, t2) {
      VWe(i).updateMethod = t2;
    }, f2.protoInitialize = function() {
      var i = f2.prototype;
      i.type = "chart";
    }(), f2;
  }();
  function lFe(f2, i, t2) {
    f2 && Jdt(f2) && (i === "emphasis" ? NL : FL)(f2, t2);
  }
  function uFe(f2, i, t2) {
    var h = vU(f2, i), v4 = i && i.highlightKey != null ? Lfr(i.highlightKey) : null;
    h != null ? Qe2(Od2(h), function(_) {
      lFe(f2.getItemGraphicEl(_), t2, v4);
    }) : f2.eachItemGraphicEl(function(_) {
      lFe(_, t2, v4);
    });
  }
  Pee(ane);
  fkt(ane);
  function udr(f2) {
    return ldr(f2.model);
  }
  function cdr(f2) {
    var i = f2.model, t2 = f2.ecModel, h = f2.api, v4 = f2.payload, _ = i.pipelineContext.progressiveRender, M2 = f2.view, I2 = v4 && VWe(v4).updateMethod, P2 = _ ? "incrementalPrepareRender" : I2 && M2[I2] ? I2 : "render";
    return P2 !== "render" && M2[P2](i, t2, h, v4), fdr[P2];
  }
  var fdr = { incrementalPrepareRender: { progress: function(f2, i) {
    i.view.incrementalRender(f2, i.model, i.ecModel, i.api, i.payload);
  } }, render: { forceFirstProgress: true, progress: function(f2, i) {
    i.view.render(i.model, i.ecModel, i.api, i.payload);
  } } }, Hg2 = ane, SEt = "\0__throttleOriginMethod", cFe = "\0__throttleRate", fFe = "\0__throttleType";
  function one(f2, i, t2) {
    var h, v4 = 0, _ = 0, M2 = null, I2, P2, N3, z3;
    i = i || 0;
    function H2() {
      _ = new Date().getTime(), M2 = null, f2.apply(P2, N3 || []);
    }
    var $ = function() {
      for (var et = [], at = 0; at < arguments.length; at++)
        et[at] = arguments[at];
      h = new Date().getTime(), P2 = this, N3 = et;
      var ht = z3 || i, bt = z3 || t2;
      z3 = null, I2 = h - (bt ? v4 : _) - ht, clearTimeout(M2), bt ? M2 = setTimeout(H2, ht) : I2 >= 0 ? H2() : M2 = setTimeout(H2, -I2), v4 = h;
    };
    return $.clear = function() {
      M2 && (clearTimeout(M2), M2 = null);
    }, $.debounceNextCall = function(et) {
      z3 = et;
    }, $;
  }
  function cet(f2, i, t2, h) {
    var v4 = f2[i];
    if (!!v4) {
      var _ = v4[SEt] || v4, M2 = v4[fFe], I2 = v4[cFe];
      if (I2 !== t2 || M2 !== h) {
        if (t2 == null || !h)
          return f2[i] = _;
        v4 = f2[i] = one(_, t2, h === "debounce"), v4[SEt] = _, v4[fFe] = h, v4[cFe] = t2;
      }
      return v4;
    }
  }
  function agt(f2, i) {
    var t2 = f2[i];
    t2 && t2[SEt] && (t2.clear && t2.clear(), f2[i] = t2[SEt]);
  }
  var hFe = Wh2(), pFe = { itemStyle: yU(Wje, true), lineStyle: yU(jje, true) }, hdr = { lineStyle: "stroke", itemStyle: "fill" };
  function BWe(f2, i) {
    var t2 = f2.visualStyleMapper || pFe[i];
    return t2 || (console.warn("Unkown style type '" + i + "'."), pFe.itemStyle);
  }
  function zWe(f2, i) {
    var t2 = f2.visualDrawType || hdr[i];
    return t2 || (console.warn("Unkown style type '" + i + "'."), "fill");
  }
  var pdr = { createOnAllSeries: true, performRawSeries: true, reset: function(f2, i) {
    var t2 = f2.getData(), h = f2.visualStyleAccessPath || "itemStyle", v4 = f2.getModel(h), _ = BWe(f2, h), M2 = _(v4), I2 = v4.getShallow("decal");
    I2 && (t2.setVisual("decal", I2), I2.dirty = true);
    var P2 = zWe(f2, h), N3 = M2[P2], z3 = Ol(N3) ? N3 : null, H2 = M2.fill === "auto" || M2.stroke === "auto";
    if (!M2[P2] || z3 || H2) {
      var $ = f2.getColorFromPalette(f2.name, null, i.getSeriesCount());
      M2[P2] || (M2[P2] = $, t2.setVisual("colorFromPalette", true)), M2.fill = M2.fill === "auto" || Ol(M2.fill) ? $ : M2.fill, M2.stroke = M2.stroke === "auto" || Ol(M2.stroke) ? $ : M2.stroke;
    }
    if (t2.setVisual("style", M2), t2.setVisual("drawType", P2), !i.isSeriesFiltered(f2) && z3)
      return t2.setVisual("colorFromPalette", false), { dataEach: function(et, at) {
        var ht = f2.getDataParams(at), bt = ba2({}, M2);
        bt[P2] = z3(ht), et.setItemVisual(at, "style", bt);
      } };
  } }, Zpt = new Gg2(), ddr = { createOnAllSeries: true, performRawSeries: true, reset: function(f2, i) {
    if (!(f2.ignoreStyleOnData || i.isSeriesFiltered(f2))) {
      var t2 = f2.getData(), h = f2.visualStyleAccessPath || "itemStyle", v4 = BWe(f2, h), _ = t2.getVisual("drawType");
      return { dataEach: t2.hasItemOption ? function(M2, I2) {
        var P2 = M2.getRawDataItem(I2);
        if (P2 && P2[h]) {
          Zpt.option = P2[h];
          var N3 = v4(Zpt), z3 = M2.ensureUniqueItemVisual(I2, "style");
          ba2(z3, N3), Zpt.option.decal && (M2.setItemVisual(I2, "decal", Zpt.option.decal), Zpt.option.decal.dirty = true), _ in N3 && M2.setItemVisual(I2, "colorFromPalette", false);
        }
      } : null };
    }
  } }, gdr = { performRawSeries: true, overallReset: function(f2) {
    var i = Il();
    f2.eachSeries(function(t2) {
      var h = t2.getColorBy();
      if (!t2.isColorBySeries()) {
        var v4 = t2.type + "-" + h, _ = i.get(v4);
        _ || (_ = {}, i.set(v4, _)), hFe(t2).scope = _;
      }
    }), f2.eachSeries(function(t2) {
      if (!(t2.isColorBySeries() || f2.isSeriesFiltered(t2))) {
        var h = t2.getRawData(), v4 = {}, _ = t2.getData(), M2 = hFe(t2).scope, I2 = t2.visualStyleAccessPath || "itemStyle", P2 = zWe(t2, I2);
        _.each(function(N3) {
          var z3 = _.getRawIndex(N3);
          v4[z3] = N3;
        }), h.each(function(N3) {
          var z3 = v4[N3], H2 = _.getItemVisual(z3, "colorFromPalette");
          if (H2) {
            var $ = _.ensureUniqueItemVisual(z3, "style"), et = h.getName(N3) || N3 + "", at = h.count();
            $[P2] = t2.getColorFromPalette(et, M2, at);
          }
        });
      }
    });
  } }, XIt = Math.PI;
  function vdr(f2, i) {
    i = i || {}, Ul(i, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
    var t2 = new mu(), h = new Sh2({ style: { fill: i.maskColor }, zlevel: i.zlevel, z: 1e4 });
    t2.add(h);
    var v4 = new op({ style: { text: i.text, fill: i.textColor, fontSize: i.fontSize, fontWeight: i.fontWeight, fontStyle: i.fontStyle, fontFamily: i.fontFamily }, zlevel: i.zlevel, z: 10001 }), _ = new Sh2({ style: { fill: "none" }, textContent: v4, textConfig: { position: "right", distance: 10 }, zlevel: i.zlevel, z: 10001 });
    t2.add(_);
    var M2;
    return i.showSpinner && (M2 = new zee({ shape: { startAngle: -XIt / 2, endAngle: -XIt / 2 + 0.1, r: i.spinnerRadius }, style: { stroke: i.color, lineCap: "round", lineWidth: i.lineWidth }, zlevel: i.zlevel, z: 10001 }), M2.animateShape(true).when(1e3, { endAngle: XIt * 3 / 2 }).start("circularInOut"), M2.animateShape(true).when(1e3, { startAngle: XIt * 3 / 2 }).delay(300).start("circularInOut"), t2.add(M2)), t2.resize = function() {
      var I2 = v4.getBoundingRect().width, P2 = i.showSpinner ? i.spinnerRadius : 0, N3 = (f2.getWidth() - P2 * 2 - (i.showSpinner && I2 ? 10 : 0) - I2) / 2 - (i.showSpinner && I2 ? 0 : 5 + I2 / 2) + (i.showSpinner ? 0 : I2 / 2) + (I2 ? 0 : P2), z3 = f2.getHeight() / 2;
      i.showSpinner && M2.setShape({ cx: N3, cy: z3 }), _.setShape({ x: N3 - P2, y: z3 - P2, width: P2 * 2, height: P2 * 2 }), h.setShape({ x: 0, y: 0, width: f2.getWidth(), height: f2.getHeight() });
    }, t2.resize(), t2;
  }
  var ydr = function() {
    function f2(i, t2, h, v4) {
      this._stageTaskMap = Il(), this.ecInstance = i, this.api = t2, h = this._dataProcessorHandlers = h.slice(), v4 = this._visualHandlers = v4.slice(), this._allHandlers = h.concat(v4);
    }
    return f2.prototype.restoreData = function(i, t2) {
      i.restoreData(t2), this._stageTaskMap.each(function(h) {
        var v4 = h.overallTask;
        v4 && v4.dirty();
      });
    }, f2.prototype.getPerformArgs = function(i, t2) {
      if (!!i.__pipeline) {
        var h = this._pipelineMap.get(i.__pipeline.id), v4 = h.context, _ = !t2 && h.progressiveEnabled && (!v4 || v4.progressiveRender) && i.__idxInPipeline > h.blockIndex, M2 = _ ? h.step : null, I2 = v4 && v4.modDataCount, P2 = I2 != null ? Math.ceil(I2 / M2) : null;
        return { step: M2, modBy: P2, modDataCount: I2 };
      }
    }, f2.prototype.getPipeline = function(i) {
      return this._pipelineMap.get(i);
    }, f2.prototype.updateStreamModes = function(i, t2) {
      var h = this._pipelineMap.get(i.uid), v4 = i.getData(), _ = v4.count(), M2 = h.progressiveEnabled && t2.incrementalPrepareRender && _ >= h.threshold, I2 = i.get("large") && _ >= i.get("largeThreshold"), P2 = i.get("progressiveChunkMode") === "mod" ? _ : null;
      i.pipelineContext = h.context = { progressiveRender: M2, modDataCount: P2, large: I2 };
    }, f2.prototype.restorePipelines = function(i) {
      var t2 = this, h = t2._pipelineMap = Il();
      i.eachSeries(function(v4) {
        var _ = v4.getProgressive(), M2 = v4.uid;
        h.set(M2, { id: M2, head: null, tail: null, threshold: v4.getProgressiveThreshold(), progressiveEnabled: _ && !(v4.preventIncremental && v4.preventIncremental()), blockIndex: -1, step: Math.round(_ || 700), count: 0 }), t2._pipe(v4, v4.dataTask);
      });
    }, f2.prototype.prepareStageTasks = function() {
      var i = this._stageTaskMap, t2 = this.api.getModel(), h = this.api;
      Qe2(this._allHandlers, function(v4) {
        var _ = i.get(v4.uid) || i.set(v4.uid, {}), M2 = "";
        z2(!(v4.reset && v4.overallReset), M2), v4.reset && this._createSeriesStageTask(v4, _, t2, h), v4.overallReset && this._createOverallStageTask(v4, _, t2, h);
      }, this);
    }, f2.prototype.prepareView = function(i, t2, h, v4) {
      var _ = i.renderTask, M2 = _.context;
      M2.model = t2, M2.ecModel = h, M2.api = v4, _.__block = !i.incrementalPrepareRender, this._pipe(t2, _);
    }, f2.prototype.performDataProcessorTasks = function(i, t2) {
      this._performStageTasks(this._dataProcessorHandlers, i, t2, { block: true });
    }, f2.prototype.performVisualTasks = function(i, t2, h) {
      this._performStageTasks(this._visualHandlers, i, t2, h);
    }, f2.prototype._performStageTasks = function(i, t2, h, v4) {
      v4 = v4 || {};
      var _ = false, M2 = this;
      Qe2(i, function(P2, N3) {
        if (!(v4.visualType && v4.visualType !== P2.visualType)) {
          var z3 = M2._stageTaskMap.get(P2.uid), H2 = z3.seriesTaskMap, $ = z3.overallTask;
          if ($) {
            var et, at = $.agentStubMap;
            at.each(function(bt) {
              I2(v4, bt) && (bt.dirty(), et = true);
            }), et && $.dirty(), M2.updatePayload($, h);
            var ht = M2.getPerformArgs($, v4.block);
            at.each(function(bt) {
              bt.perform(ht);
            }), $.perform(ht) && (_ = true);
          } else
            H2 && H2.each(function(bt, _t) {
              I2(v4, bt) && bt.dirty();
              var Et = M2.getPerformArgs(bt, v4.block);
              Et.skip = !P2.performRawSeries && t2.isSeriesFiltered(bt.context.model), M2.updatePayload(bt, h), bt.perform(Et) && (_ = true);
            });
        }
      });
      function I2(P2, N3) {
        return P2.setDirty && (!P2.dirtyMap || P2.dirtyMap.get(N3.__pipeline.id));
      }
      this.unfinished = _ || this.unfinished;
    }, f2.prototype.performSeriesTasks = function(i) {
      var t2;
      i.eachSeries(function(h) {
        t2 = h.dataTask.perform() || t2;
      }), this.unfinished = t2 || this.unfinished;
    }, f2.prototype.plan = function() {
      this._pipelineMap.each(function(i) {
        var t2 = i.tail;
        do {
          if (t2.__block) {
            i.blockIndex = t2.__idxInPipeline;
            break;
          }
          t2 = t2.getUpstream();
        } while (t2);
      });
    }, f2.prototype.updatePayload = function(i, t2) {
      t2 !== "remain" && (i.context.payload = t2);
    }, f2.prototype._createSeriesStageTask = function(i, t2, h, v4) {
      var _ = this, M2 = t2.seriesTaskMap, I2 = t2.seriesTaskMap = Il(), P2 = i.seriesType, N3 = i.getTargetSeries;
      i.createOnAllSeries ? h.eachRawSeries(z3) : P2 ? h.eachRawSeriesByType(P2, z3) : N3 && N3(h, v4).each(z3);
      function z3(H2) {
        var $ = H2.uid, et = I2.set($, M2 && M2.get($) || Ndt({ plan: wdr, reset: Sdr, count: Cdr }));
        et.context = { model: H2, ecModel: h, api: v4, useClearVisual: i.isVisual && !i.isLayout, plan: i.plan, reset: i.reset, scheduler: _ }, _._pipe(H2, et);
      }
    }, f2.prototype._createOverallStageTask = function(i, t2, h, v4) {
      var _ = this, M2 = t2.overallTask = t2.overallTask || Ndt({ reset: mdr });
      M2.context = { ecModel: h, api: v4, overallReset: i.overallReset, scheduler: _ };
      var I2 = M2.agentStubMap, P2 = M2.agentStubMap = Il(), N3 = i.seriesType, z3 = i.getTargetSeries, H2 = true, $ = false, et = "";
      z2(!i.createOnAllSeries, et), N3 ? h.eachRawSeriesByType(N3, at) : z3 ? z3(h, v4).each(at) : (H2 = false, Qe2(h.getSeries(), at));
      function at(ht) {
        var bt = ht.uid, _t = P2.set(bt, I2 && I2.get(bt) || ($ = true, Ndt({ reset: bdr, onDirty: xdr })));
        _t.context = { model: ht, overallProgress: H2 }, _t.agent = M2, _t.__block = H2, _._pipe(ht, _t);
      }
      $ && M2.dirty();
    }, f2.prototype._pipe = function(i, t2) {
      var h = i.uid, v4 = this._pipelineMap.get(h);
      !v4.head && (v4.head = t2), v4.tail && v4.tail.pipe(t2), v4.tail = t2, t2.__idxInPipeline = v4.count++, t2.__pipeline = v4;
    }, f2.wrapStageHandler = function(i, t2) {
      return Ol(i) && (i = { overallReset: i, seriesType: Tdr(i) }), i.uid = ret("stageHandler"), t2 && (i.visualType = t2), i;
    }, f2;
  }();
  function mdr(f2) {
    f2.overallReset(f2.ecModel, f2.api, f2.payload);
  }
  function bdr(f2) {
    return f2.overallProgress && _dr;
  }
  function _dr() {
    this.agent.dirty(), this.getDownstream().dirty();
  }
  function xdr() {
    this.agent && this.agent.dirty();
  }
  function wdr(f2) {
    return f2.plan ? f2.plan(f2.model, f2.ecModel, f2.api, f2.payload) : null;
  }
  function Sdr(f2) {
    f2.useClearVisual && f2.data.clearAllVisual();
    var i = f2.resetDefines = Od2(f2.reset(f2.model, f2.ecModel, f2.api, f2.payload));
    return i.length > 1 ? Xa2(i, function(t2, h) {
      return jWe(h);
    }) : Mdr;
  }
  var Mdr = jWe(0);
  function jWe(f2) {
    return function(i, t2) {
      var h = t2.data, v4 = t2.resetDefines[f2];
      if (v4 && v4.dataEach)
        for (var _ = i.start; _ < i.end; _++)
          v4.dataEach(h, _);
      else
        v4 && v4.progress && v4.progress(i, h);
    };
  }
  function Cdr(f2) {
    return f2.data.count();
  }
  function Tdr(f2) {
    MEt = null;
    try {
      f2(ogt, WWe);
    } catch {
    }
    return MEt;
  }
  var ogt = {}, WWe = {}, MEt;
  GWe(ogt, pWe);
  GWe(WWe, dWe);
  ogt.eachSeriesByType = ogt.eachRawSeriesByType = function(f2) {
    MEt = f2;
  };
  ogt.eachComponent = function(f2) {
    f2.mainType === "series" && f2.subType && (MEt = f2.subType);
  };
  function GWe(f2, i) {
    for (var t2 in i.prototype)
      f2[t2] = xm;
  }
  var HWe = ydr, dFe = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], Adr = { color: dFe, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], dFe] }, R2 = "#B9B8CE", gFe = "#100C2A", QIt = function() {
    return { axisLine: { lineStyle: { color: R2 } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
  }, vFe = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], UWe = { darkMode: true, color: vFe, backgroundColor: gFe, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: R2 } }, textStyle: { color: R2 }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: R2 } }, dataZoom: { borderColor: "#71708A", textStyle: { color: R2 }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: R2 } }, timeline: { lineStyle: { color: R2 }, label: { color: R2 }, controlStyle: { color: R2, borderColor: R2 } }, calendar: { itemStyle: { color: gFe }, dayLabel: { color: R2 }, monthLabel: { color: R2 }, yearLabel: { color: R2 } }, timeAxis: QIt(), logAxis: QIt(), valueAxis: QIt(), categoryAxis: QIt(), line: { symbol: "circle" }, graph: { color: vFe }, gauge: { title: { color: R2 }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: R2 }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
  UWe.categoryAxis.splitLine.show = false;
  var Idr = UWe, Ddr = function() {
    function f2() {
    }
    return f2.prototype.normalizeQuery = function(i) {
      var t2 = {}, h = {}, v4 = {};
      if (ms(i)) {
        var _ = LL(i);
        t2.mainType = _.main || null, t2.subType = _.sub || null;
      } else {
        var M2 = ["Index", "Name", "Id"], I2 = { name: 1, dataIndex: 1, dataType: 1 };
        Qe2(i, function(P2, N3) {
          for (var z3 = false, H2 = 0; H2 < M2.length; H2++) {
            var $ = M2[H2], et = N3.lastIndexOf($);
            if (et > 0 && et === N3.length - $.length) {
              var at = N3.slice(0, et);
              at !== "data" && (t2.mainType = at, t2[$.toLowerCase()] = P2, z3 = true);
            }
          }
          I2.hasOwnProperty(N3) && (h[N3] = P2, z3 = true), z3 || (v4[N3] = P2);
        });
      }
      return { cptQuery: t2, dataQuery: h, otherQuery: v4 };
    }, f2.prototype.filter = function(i, t2) {
      var h = this.eventInfo;
      if (!h)
        return true;
      var v4 = h.targetEl, _ = h.packedEvent, M2 = h.model, I2 = h.view;
      if (!M2 || !I2)
        return true;
      var P2 = t2.cptQuery, N3 = t2.dataQuery;
      return z3(P2, M2, "mainType") && z3(P2, M2, "subType") && z3(P2, M2, "index", "componentIndex") && z3(P2, M2, "name") && z3(P2, M2, "id") && z3(N3, _, "name") && z3(N3, _, "dataIndex") && z3(N3, _, "dataType") && (!I2.filterForExposedEvent || I2.filterForExposedEvent(i, t2.otherQuery, v4, _));
      function z3(H2, $, et, at) {
        return H2[et] == null || $[at || et] === H2[et];
      }
    }, f2.prototype.afterTrigger = function() {
      this.eventInfo = null;
    }, f2;
  }(), nte = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], yFe = nte.concat(["symbolKeepAspect"]), Edr = { createOnAllSeries: true, performRawSeries: true, reset: function(f2, i) {
    var t2 = f2.getData();
    if (f2.legendIcon && t2.setVisual("legendIcon", f2.legendIcon), !f2.hasSymbolVisual)
      return;
    for (var h = {}, v4 = {}, _ = false, M2 = 0; M2 < nte.length; M2++) {
      var I2 = nte[M2], P2 = f2.get(I2);
      Ol(P2) ? (_ = true, v4[I2] = P2) : h[I2] = P2;
    }
    if (h.symbol = h.symbol || f2.defaultSymbol, t2.setVisual(ba2({ legendIcon: f2.legendIcon || h.symbol, symbolKeepAspect: f2.get("symbolKeepAspect") }, h)), i.isSeriesFiltered(f2))
      return;
    var N3 = Of2(v4);
    function z3(H2, $) {
      for (var et = f2.getRawValue($), at = f2.getDataParams($), ht = 0; ht < N3.length; ht++) {
        var bt = N3[ht];
        H2.setItemVisual($, bt, v4[bt](et, at));
      }
    }
    return { dataEach: _ ? z3 : null };
  } }, kdr = { createOnAllSeries: true, performRawSeries: true, reset: function(f2, i) {
    if (!f2.hasSymbolVisual || i.isSeriesFiltered(f2))
      return;
    var t2 = f2.getData();
    function h(v4, _) {
      for (var M2 = v4.getItemModel(_), I2 = 0; I2 < yFe.length; I2++) {
        var P2 = yFe[I2], N3 = M2.getShallow(P2, true);
        N3 != null && v4.setItemVisual(_, P2, N3);
      }
    }
    return { dataEach: t2.hasItemOption ? h : null };
  } };
  function sne(f2, i, t2) {
    switch (t2) {
      case "color":
        var h = f2.getItemVisual(i, "style");
        return h[f2.getVisual("drawType")];
      case "opacity":
        return f2.getItemVisual(i, "style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return f2.getItemVisual(i, t2);
    }
  }
  function Lgt(f2, i) {
    switch (i) {
      case "color":
        var t2 = f2.getVisual("style");
        return t2[f2.getVisual("drawType")];
      case "opacity":
        return f2.getVisual("style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return f2.getVisual(i);
    }
  }
  function qWe(f2, i, t2, h) {
    switch (t2) {
      case "color":
        var v4 = f2.ensureUniqueItemVisual(i, "style");
        v4[f2.getVisual("drawType")] = h, f2.setItemVisual(i, "colorFromPalette", false);
        break;
      case "opacity":
        f2.ensureUniqueItemVisual(i, "style").opacity = h;
        break;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        f2.setItemVisual(i, t2, h);
        break;
    }
  }
  function ZWe(f2, i) {
    function t2(h, v4) {
      var _ = [];
      return h.eachComponent({ mainType: "series", subType: f2, query: v4 }, function(M2) {
        _.push(M2.seriesIndex);
      }), _;
    }
    Qe2([[f2 + "ToggleSelect", "toggleSelect"], [f2 + "Select", "select"], [f2 + "UnSelect", "unselect"]], function(h) {
      i(h[0], function(v4, _, M2) {
        v4 = ba2({}, v4), M2.dispatchAction(ba2(v4, { type: h[1], seriesIndex: t2(_, v4) }));
      });
    });
  }
  function stt(f2, i, t2, h, v4) {
    var _ = f2 + i;
    t2.isSilent(_) || h.eachComponent({ mainType: "series", subType: "pie" }, function(M2) {
      for (var I2 = M2.seriesIndex, P2 = M2.option.selectedMap, N3 = v4.selected, z3 = 0; z3 < N3.length; z3++)
        if (N3[z3].seriesIndex === I2) {
          var H2 = M2.getData(), $ = vU(H2, v4.fromActionPayload);
          t2.trigger(_, { type: _, seriesId: M2.id, name: Za2($) ? H2.getName($[0]) : H2.getName($), selected: ms(P2) ? P2 : ba2({}, P2) });
        }
    });
  }
  function Pdr(f2, i, t2) {
    f2.on("selectchanged", function(h) {
      var v4 = t2.getModel();
      h.isFromClick ? (stt("map", "selectchanged", i, v4, h), stt("pie", "selectchanged", i, v4, h)) : h.fromAction === "select" ? (stt("map", "selected", i, v4, h), stt("pie", "selected", i, v4, h)) : h.fromAction === "unselect" && (stt("map", "unselected", i, v4, h), stt("pie", "unselected", i, v4, h));
    });
  }
  function Itt(f2, i, t2) {
    for (var h; f2 && !(i(f2) && (h = f2, t2)); )
      f2 = f2.__hostTarget || f2.parent;
    return h;
  }
  var Ldr = Math.round(Math.random() * 9), Odr = typeof Object.defineProperty == "function", Rdr = function() {
    function f2() {
      this._id = "__ec_inner_" + Ldr++;
    }
    return f2.prototype.get = function(i) {
      return this._guard(i)[this._id];
    }, f2.prototype.set = function(i, t2) {
      var h = this._guard(i);
      return Odr ? Object.defineProperty(h, this._id, { value: t2, enumerable: false, configurable: true }) : h[this._id] = t2, this;
    }, f2.prototype.delete = function(i) {
      return this.has(i) ? (delete this._guard(i)[this._id], true) : false;
    }, f2.prototype.has = function(i) {
      return !!this._guard(i)[this._id];
    }, f2.prototype._guard = function(i) {
      if (i !== Object(i))
        throw TypeError("Value of WeakMap is not a non-null object.");
      return i;
    }, f2;
  }(), Ndr = Rdr, Fdr = Uc2.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(f2, i) {
    var t2 = i.cx, h = i.cy, v4 = i.width / 2, _ = i.height / 2;
    f2.moveTo(t2, h - _), f2.lineTo(t2 + v4, h + _), f2.lineTo(t2 - v4, h + _), f2.closePath();
  } }), Vdr = Uc2.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(f2, i) {
    var t2 = i.cx, h = i.cy, v4 = i.width / 2, _ = i.height / 2;
    f2.moveTo(t2, h - _), f2.lineTo(t2 + v4, h), f2.lineTo(t2, h + _), f2.lineTo(t2 - v4, h), f2.closePath();
  } }), Bdr = Uc2.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(f2, i) {
    var t2 = i.x, h = i.y, v4 = i.width / 5 * 3, _ = Math.max(v4, i.height), M2 = v4 / 2, I2 = M2 * M2 / (_ - M2), P2 = h - _ + M2 + I2, N3 = Math.asin(I2 / M2), z3 = Math.cos(N3) * M2, H2 = Math.sin(N3), $ = Math.cos(N3), et = M2 * 0.6, at = M2 * 0.7;
    f2.moveTo(t2 - z3, P2 + I2), f2.arc(t2, P2, M2, Math.PI - N3, Math.PI * 2 + N3), f2.bezierCurveTo(t2 + z3 - H2 * et, P2 + I2 + $ * et, t2, h - at, t2, h), f2.bezierCurveTo(t2, h - at, t2 - z3 + H2 * et, P2 + I2 + $ * et, t2 - z3, P2 + I2), f2.closePath();
  } }), zdr = Uc2.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(f2, i) {
    var t2 = i.height, h = i.width, v4 = i.x, _ = i.y, M2 = h / 3 * 2;
    f2.moveTo(v4, _), f2.lineTo(v4 + M2, _ + t2), f2.lineTo(v4, _ + t2 / 4 * 3), f2.lineTo(v4 - M2, _ + t2), f2.lineTo(v4, _), f2.closePath();
  } }), jdr = { line: m_, rect: Sh2, roundRect: Sh2, square: Sh2, circle: UL, diamond: Vdr, pin: Bdr, arrow: zdr, triangle: Fdr }, Wdr = { line: function(f2, i, t2, h, v4) {
    v4.x1 = f2, v4.y1 = i + h / 2, v4.x2 = f2 + t2, v4.y2 = i + h / 2;
  }, rect: function(f2, i, t2, h, v4) {
    v4.x = f2, v4.y = i, v4.width = t2, v4.height = h;
  }, roundRect: function(f2, i, t2, h, v4) {
    v4.x = f2, v4.y = i, v4.width = t2, v4.height = h, v4.r = Math.min(t2, h) / 4;
  }, square: function(f2, i, t2, h, v4) {
    var _ = Math.min(t2, h);
    v4.x = f2, v4.y = i, v4.width = _, v4.height = _;
  }, circle: function(f2, i, t2, h, v4) {
    v4.cx = f2 + t2 / 2, v4.cy = i + h / 2, v4.r = Math.min(t2, h) / 2;
  }, diamond: function(f2, i, t2, h, v4) {
    v4.cx = f2 + t2 / 2, v4.cy = i + h / 2, v4.width = t2, v4.height = h;
  }, pin: function(f2, i, t2, h, v4) {
    v4.x = f2 + t2 / 2, v4.y = i + h / 2, v4.width = t2, v4.height = h;
  }, arrow: function(f2, i, t2, h, v4) {
    v4.x = f2 + t2 / 2, v4.y = i + h / 2, v4.width = t2, v4.height = h;
  }, triangle: function(f2, i, t2, h, v4) {
    v4.cx = f2 + t2 / 2, v4.cy = i + h / 2, v4.width = t2, v4.height = h;
  } }, CEt = {};
  Qe2(jdr, function(f2, i) {
    CEt[i] = new f2();
  });
  var Gdr = Uc2.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(f2, i, t2) {
    var h = pEt(f2, i, t2), v4 = this.shape;
    return v4 && v4.symbolType === "pin" && i.position === "inside" && (h.y = t2.y + t2.height * 0.4), h;
  }, buildPath: function(f2, i, t2) {
    var h = i.symbolType;
    if (h !== "none") {
      var v4 = CEt[h];
      v4 || (h = "rect", v4 = CEt[h]), Wdr[h](i.x, i.y, i.width, i.height, v4.shape), v4.buildPath(f2, v4.shape, t2);
    }
  } });
  function Hdr(f2, i) {
    if (this.type !== "image") {
      var t2 = this.style;
      this.__isEmptyBrush ? (t2.stroke = f2, t2.fill = i || "#fff", t2.lineWidth = 2) : this.shape.symbolType === "line" ? t2.stroke = f2 : t2.fill = f2, this.markRedraw();
    }
  }
  function wm(f2, i, t2, h, v4, _, M2) {
    var I2 = f2.indexOf("empty") === 0;
    I2 && (f2 = f2.substr(5, 1).toLowerCase() + f2.substr(6));
    var P2;
    return f2.indexOf("image://") === 0 ? P2 = Pje(f2.slice(8), new Lc2(i, t2, h, v4), M2 ? "center" : "cover") : f2.indexOf("path://") === 0 ? P2 = bkt(f2.slice(7), {}, new Lc2(i, t2, h, v4), M2 ? "center" : "cover") : P2 = new Gdr({ shape: { symbolType: f2, x: i, y: t2, width: h, height: v4 } }), P2.__isEmptyBrush = I2, P2.setColor = Hdr, _ && P2.setColor(_), P2;
  }
  function Ogt(f2) {
    return Za2(f2) || (f2 = [+f2, +f2]), [f2[0] || 0, f2[1] || 0];
  }
  function fet(f2, i) {
    if (f2 != null)
      return Za2(f2) || (f2 = [f2, f2]), [cs(f2[0], i[0]) || 0, cs(_c2(f2[1], f2[0]), i[1]) || 0];
  }
  function Udr(f2, i, t2) {
    var h = i.x == null ? 0 : i.x, v4 = i.x2 == null ? 1 : i.x2, _ = i.y == null ? 0 : i.y, M2 = i.y2 == null ? 0 : i.y2;
    i.global || (h = h * t2.width + t2.x, v4 = v4 * t2.width + t2.x, _ = _ * t2.height + t2.y, M2 = M2 * t2.height + t2.y), h = isNaN(h) ? 0 : h, v4 = isNaN(v4) ? 1 : v4, _ = isNaN(_) ? 0 : _, M2 = isNaN(M2) ? 0 : M2;
    var I2 = f2.createLinearGradient(h, _, v4, M2);
    return I2;
  }
  function qdr(f2, i, t2) {
    var h = t2.width, v4 = t2.height, _ = Math.min(h, v4), M2 = i.x == null ? 0.5 : i.x, I2 = i.y == null ? 0.5 : i.y, P2 = i.r == null ? 0.5 : i.r;
    i.global || (M2 = M2 * h + t2.x, I2 = I2 * v4 + t2.y, P2 = P2 * _);
    var N3 = f2.createRadialGradient(M2, I2, 0, M2, I2, P2);
    return N3;
  }
  function rte(f2, i, t2) {
    for (var h = i.type === "radial" ? qdr(f2, i, t2) : Udr(f2, i, t2), v4 = i.colorStops, _ = 0; _ < v4.length; _++)
      h.addColorStop(v4[_].offset, v4[_].color);
    return h;
  }
  function Zdr(f2, i) {
    if (f2 === i || !f2 && !i)
      return false;
    if (!f2 || !i || f2.length !== i.length)
      return true;
    for (var t2 = 0; t2 < f2.length; t2++)
      if (f2[t2] !== i[t2])
        return true;
    return false;
  }
  function JIt(f2) {
    return parseInt(f2, 10);
  }
  function Dtt(f2, i, t2) {
    var h = ["width", "height"][i], v4 = ["clientWidth", "clientHeight"][i], _ = ["paddingLeft", "paddingTop"][i], M2 = ["paddingRight", "paddingBottom"][i];
    if (t2[h] != null && t2[h] !== "auto")
      return parseFloat(t2[h]);
    var I2 = document.defaultView.getComputedStyle(f2);
    return (f2[v4] || JIt(I2[h]) || JIt(f2.style[h])) - (JIt(I2[_]) || 0) - (JIt(I2[M2]) || 0) | 0;
  }
  function $dr(f2, i) {
    return !f2 || f2 === "solid" || !(i > 0) ? null : f2 === "dashed" ? [4 * i, 2 * i] : f2 === "dotted" ? [i] : vp(f2) ? [f2] : Za2(f2) ? f2 : null;
  }
  function lne(f2) {
    var i = f2.style, t2 = i.lineDash && i.lineWidth > 0 && $dr(i.lineDash, i.lineWidth), h = i.lineDashOffset;
    if (t2) {
      var v4 = i.strokeNoScale && f2.getLineScale ? f2.getLineScale() : 1;
      v4 && v4 !== 1 && (t2 = Xa2(t2, function(_) {
        return _ / v4;
      }), h /= v4);
    }
    return [t2, h];
  }
  var Ydr = new HL(true);
  function TEt(f2) {
    var i = f2.stroke;
    return !(i == null || i === "none" || !(f2.lineWidth > 0));
  }
  function mFe(f2) {
    return typeof f2 == "string" && f2 !== "none";
  }
  function AEt(f2) {
    var i = f2.fill;
    return i != null && i !== "none";
  }
  function bFe(f2, i) {
    if (i.fillOpacity != null && i.fillOpacity !== 1) {
      var t2 = f2.globalAlpha;
      f2.globalAlpha = i.fillOpacity * i.opacity, f2.fill(), f2.globalAlpha = t2;
    } else
      f2.fill();
  }
  function _Fe(f2, i) {
    if (i.strokeOpacity != null && i.strokeOpacity !== 1) {
      var t2 = f2.globalAlpha;
      f2.globalAlpha = i.strokeOpacity * i.opacity, f2.stroke(), f2.globalAlpha = t2;
    } else
      f2.stroke();
  }
  function ite(f2, i, t2) {
    var h = Lee(i.image, i.__image, t2);
    if (hkt(h)) {
      var v4 = f2.createPattern(h, i.repeat || "repeat");
      if (typeof DOMMatrix == "function" && v4 && v4.setTransform) {
        var _ = new DOMMatrix();
        _.translateSelf(i.x || 0, i.y || 0), _.rotateSelf(0, 0, (i.rotation || 0) * VDt), _.scaleSelf(i.scaleX || 1, i.scaleY || 1), v4.setTransform(_);
      }
      return v4;
    }
  }
  function Kdr(f2, i, t2, h) {
    var v4, _ = TEt(t2), M2 = AEt(t2), I2 = t2.strokePercent, P2 = I2 < 1, N3 = !i.path;
    (!i.silent || P2) && N3 && i.createPathProxy();
    var z3 = i.path || Ydr, H2 = i.__dirty;
    if (!h) {
      var $ = t2.fill, et = t2.stroke, at = M2 && !!$.colorStops, ht = _ && !!et.colorStops, bt = M2 && !!$.image, _t = _ && !!et.image, Et = void 0, zt = void 0, Ft = void 0, fe2 = void 0, re2 = void 0;
      (at || ht) && (re2 = i.getBoundingRect()), at && (Et = H2 ? rte(f2, $, re2) : i.__canvasFillGradient, i.__canvasFillGradient = Et), ht && (zt = H2 ? rte(f2, et, re2) : i.__canvasStrokeGradient, i.__canvasStrokeGradient = zt), bt && (Ft = H2 || !i.__canvasFillPattern ? ite(f2, $, i) : i.__canvasFillPattern, i.__canvasFillPattern = Ft), _t && (fe2 = H2 || !i.__canvasStrokePattern ? ite(f2, et, i) : i.__canvasStrokePattern, i.__canvasStrokePattern = Ft), at ? f2.fillStyle = Et : bt && (Ft ? f2.fillStyle = Ft : M2 = false), ht ? f2.strokeStyle = zt : _t && (fe2 ? f2.strokeStyle = fe2 : _ = false);
    }
    var ye = i.getGlobalScale();
    z3.setScale(ye[0], ye[1], i.segmentIgnoreThreshold);
    var me2, be2;
    f2.setLineDash && t2.lineDash && (v4 = lne(i), me2 = v4[0], be2 = v4[1]);
    var Te2 = true;
    (N3 || H2 & _tt) && (z3.setDPR(f2.dpr), P2 ? z3.setContext(null) : (z3.setContext(f2), Te2 = false), z3.reset(), i.buildPath(z3, i.shape, h), z3.toStatic(), i.pathUpdated()), Te2 && z3.rebuildPath(f2, P2 ? I2 : 1), me2 && (f2.setLineDash(me2), f2.lineDashOffset = be2), h || (t2.strokeFirst ? (_ && _Fe(f2, t2), M2 && bFe(f2, t2)) : (M2 && bFe(f2, t2), _ && _Fe(f2, t2))), me2 && f2.setLineDash([]);
  }
  function Xdr(f2, i, t2) {
    var h = i.__image = Lee(t2.image, i.__image, i, i.onload);
    if (!(!h || !hkt(h))) {
      var v4 = t2.x || 0, _ = t2.y || 0, M2 = i.getWidth(), I2 = i.getHeight(), P2 = h.width / h.height;
      if (M2 == null && I2 != null ? M2 = I2 * P2 : I2 == null && M2 != null ? I2 = M2 / P2 : M2 == null && I2 == null && (M2 = h.width, I2 = h.height), t2.sWidth && t2.sHeight) {
        var N3 = t2.sx || 0, z3 = t2.sy || 0;
        f2.drawImage(h, N3, z3, t2.sWidth, t2.sHeight, v4, _, M2, I2);
      } else if (t2.sx && t2.sy) {
        var N3 = t2.sx, z3 = t2.sy, H2 = M2 - N3, $ = I2 - z3;
        f2.drawImage(h, N3, z3, H2, $, v4, _, M2, I2);
      } else
        f2.drawImage(h, v4, _, M2, I2);
    }
  }
  function Qdr(f2, i, t2) {
    var h, v4 = t2.text;
    if (v4 != null && (v4 += ""), v4) {
      f2.font = t2.font || K7, f2.textAlign = t2.textAlign, f2.textBaseline = t2.textBaseline;
      var _ = void 0, M2 = void 0;
      f2.setLineDash && t2.lineDash && (h = lne(i), _ = h[0], M2 = h[1]), _ && (f2.setLineDash(_), f2.lineDashOffset = M2), t2.strokeFirst ? (TEt(t2) && f2.strokeText(v4, t2.x, t2.y), AEt(t2) && f2.fillText(v4, t2.x, t2.y)) : (AEt(t2) && f2.fillText(v4, t2.x, t2.y), TEt(t2) && f2.strokeText(v4, t2.x, t2.y)), _ && f2.setLineDash([]);
    }
  }
  var xFe = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], wFe = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
  function $We(f2, i, t2, h, v4) {
    var _ = false;
    if (!h && (t2 = t2 || {}, i === t2))
      return false;
    if (h || i.opacity !== t2.opacity) {
      nC(f2, v4), _ = true;
      var M2 = Math.max(Math.min(i.opacity, 1), 0);
      f2.globalAlpha = isNaN(M2) ? sU.opacity : M2;
    }
    (h || i.blend !== t2.blend) && (_ || (nC(f2, v4), _ = true), f2.globalCompositeOperation = i.blend || sU.blend);
    for (var I2 = 0; I2 < xFe.length; I2++) {
      var P2 = xFe[I2];
      (h || i[P2] !== t2[P2]) && (_ || (nC(f2, v4), _ = true), f2[P2] = f2.dpr * (i[P2] || 0));
    }
    return (h || i.shadowColor !== t2.shadowColor) && (_ || (nC(f2, v4), _ = true), f2.shadowColor = i.shadowColor || sU.shadowColor), _;
  }
  function SFe(f2, i, t2, h, v4) {
    var _ = sgt(i, v4.inHover), M2 = h ? null : t2 && sgt(t2, v4.inHover) || {};
    if (_ === M2)
      return false;
    var I2 = $We(f2, _, M2, h, v4);
    if ((h || _.fill !== M2.fill) && (I2 || (nC(f2, v4), I2 = true), mFe(_.fill) && (f2.fillStyle = _.fill)), (h || _.stroke !== M2.stroke) && (I2 || (nC(f2, v4), I2 = true), mFe(_.stroke) && (f2.strokeStyle = _.stroke)), (h || _.opacity !== M2.opacity) && (I2 || (nC(f2, v4), I2 = true), f2.globalAlpha = _.opacity == null ? 1 : _.opacity), i.hasStroke()) {
      var P2 = _.lineWidth, N3 = P2 / (_.strokeNoScale && i.getLineScale ? i.getLineScale() : 1);
      f2.lineWidth !== N3 && (I2 || (nC(f2, v4), I2 = true), f2.lineWidth = N3);
    }
    for (var z3 = 0; z3 < wFe.length; z3++) {
      var H2 = wFe[z3], $ = H2[0];
      (h || _[$] !== M2[$]) && (I2 || (nC(f2, v4), I2 = true), f2[$] = _[$] || H2[1]);
    }
    return I2;
  }
  function Jdr(f2, i, t2, h, v4) {
    return $We(f2, sgt(i, v4.inHover), t2 && sgt(t2, v4.inHover), h, v4);
  }
  function YWe(f2, i) {
    var t2 = i.transform, h = f2.dpr || 1;
    t2 ? f2.setTransform(h * t2[0], h * t2[1], h * t2[2], h * t2[3], h * t2[4], h * t2[5]) : f2.setTransform(h, 0, 0, h, 0, 0);
  }
  function tgr(f2, i, t2) {
    for (var h = false, v4 = 0; v4 < f2.length; v4++) {
      var _ = f2[v4];
      h = h || _.isZeroArea(), YWe(i, _), i.beginPath(), _.buildPath(i, _.shape), i.clip();
    }
    t2.allClipped = h;
  }
  function egr(f2, i) {
    return f2 && i ? f2[0] !== i[0] || f2[1] !== i[1] || f2[2] !== i[2] || f2[3] !== i[3] || f2[4] !== i[4] || f2[5] !== i[5] : !(!f2 && !i);
  }
  var MFe = 1, CFe = 2, TFe = 3, AFe = 4;
  function ngr(f2) {
    var i = AEt(f2), t2 = TEt(f2);
    return !(f2.lineDash || !(+i ^ +t2) || i && typeof f2.fill != "string" || t2 && typeof f2.stroke != "string" || f2.strokePercent < 1 || f2.strokeOpacity < 1 || f2.fillOpacity < 1);
  }
  function nC(f2, i) {
    i.batchFill && f2.fill(), i.batchStroke && f2.stroke(), i.batchFill = "", i.batchStroke = "";
  }
  function sgt(f2, i) {
    return i && f2.__hoverStyle || f2.style;
  }
  function KWe(f2, i) {
    iU(f2, i, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
  }
  function iU(f2, i, t2, h) {
    var v4 = i.transform;
    if (!i.shouldBePainted(t2.viewWidth, t2.viewHeight, false, false)) {
      i.__dirty &= ~UT, i.__isRendered = false;
      return;
    }
    var _ = i.__clipPaths, M2 = t2.prevElClipPaths, I2 = false, P2 = false;
    if ((!M2 || Zdr(_, M2)) && (M2 && M2.length && (nC(f2, t2), f2.restore(), P2 = I2 = true, t2.prevElClipPaths = null, t2.allClipped = false, t2.prevEl = null), _ && _.length && (nC(f2, t2), f2.save(), tgr(_, f2, t2), I2 = true), t2.prevElClipPaths = _), t2.allClipped) {
      i.__isRendered = false;
      return;
    }
    i.beforeBrush && i.beforeBrush(), i.innerBeforeBrush();
    var N3 = t2.prevEl;
    N3 || (P2 = I2 = true);
    var z3 = i instanceof Uc2 && i.autoBatch && ngr(i.style);
    I2 || egr(v4, N3.transform) ? (nC(f2, t2), YWe(f2, i)) : z3 || nC(f2, t2);
    var H2 = sgt(i, t2.inHover);
    i instanceof Uc2 ? (t2.lastDrawType !== MFe && (P2 = true, t2.lastDrawType = MFe), SFe(f2, i, N3, P2, t2), (!z3 || !t2.batchFill && !t2.batchStroke) && f2.beginPath(), Kdr(f2, i, H2, z3), z3 && (t2.batchFill = H2.fill || "", t2.batchStroke = H2.stroke || "")) : i instanceof Xdt ? (t2.lastDrawType !== TFe && (P2 = true, t2.lastDrawType = TFe), SFe(f2, i, N3, P2, t2), Qdr(f2, i, H2)) : i instanceof Ux ? (t2.lastDrawType !== CFe && (P2 = true, t2.lastDrawType = CFe), Jdr(f2, i, N3, P2, t2), Xdr(f2, i, H2)) : i.getTemporalDisplayables && (t2.lastDrawType !== AFe && (P2 = true, t2.lastDrawType = AFe), rgr(f2, i, t2)), z3 && h && nC(f2, t2), i.innerAfterBrush(), i.afterBrush && i.afterBrush(), t2.prevEl = i, i.__dirty = 0, i.__isRendered = true;
  }
  function rgr(f2, i, t2) {
    var h = i.getDisplayables(), v4 = i.getTemporalDisplayables();
    f2.save();
    var _ = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: t2.viewWidth, viewHeight: t2.viewHeight, inHover: t2.inHover }, M2, I2;
    for (M2 = i.getCursor(), I2 = h.length; M2 < I2; M2++) {
      var P2 = h[M2];
      P2.beforeBrush && P2.beforeBrush(), P2.innerBeforeBrush(), iU(f2, P2, _, M2 === I2 - 1), P2.innerAfterBrush(), P2.afterBrush && P2.afterBrush(), _.prevEl = P2;
    }
    for (var N3 = 0, z3 = v4.length; N3 < z3; N3++) {
      var P2 = v4[N3];
      P2.beforeBrush && P2.beforeBrush(), P2.innerBeforeBrush(), iU(f2, P2, _, N3 === z3 - 1), P2.innerAfterBrush(), P2.afterBrush && P2.afterBrush(), _.prevEl = P2;
    }
    i.clearTemporalDisplayables(), i.notClear = true, f2.restore();
  }
  var TXt = new Ndr(), IFe = new Mgt(100), DFe = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
  function lgt(f2, i) {
    if (f2 === "none")
      return null;
    var t2 = i.getDevicePixelRatio(), h = i.getZr(), v4 = h.painter.type === "svg";
    f2.dirty && TXt.delete(f2);
    var _ = TXt.get(f2);
    if (_)
      return _;
    var M2 = Ul(f2, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
    M2.backgroundColor === "none" && (M2.backgroundColor = null);
    var I2 = { repeat: "repeat" };
    return P2(I2), I2.rotation = M2.rotation, I2.scaleX = I2.scaleY = v4 ? 1 : 1 / t2, TXt.set(f2, I2), f2.dirty = false, I2;
    function P2(N3) {
      for (var z3 = [t2], H2 = true, $ = 0; $ < DFe.length; ++$) {
        var et = M2[DFe[$]];
        if (et != null && !Za2(et) && !ms(et) && !vp(et) && typeof et != "boolean") {
          H2 = false;
          break;
        }
        z3.push(et);
      }
      var at;
      if (H2) {
        at = z3.join(",") + (v4 ? "-svg" : "");
        var ht = IFe.get(at);
        ht && (v4 ? N3.svgElement = ht : N3.image = ht);
      }
      var bt = QWe(M2.dashArrayX), _t = igr(M2.dashArrayY), Et = XWe(M2.symbol), zt = agr(bt), Ft = JWe(_t), fe2 = !v4 && Q6.createCanvas(), re2 = v4 && { tag: "g", attrs: {}, key: "dcl", children: [] }, ye = be2(), me2;
      fe2 && (fe2.width = ye.width * t2, fe2.height = ye.height * t2, me2 = fe2.getContext("2d")), Te2(), H2 && IFe.put(at, fe2 || re2), N3.image = fe2, N3.svgElement = re2, N3.svgWidth = ye.width, N3.svgHeight = ye.height;
      function be2() {
        for (var We = 1, en = 0, Ue2 = zt.length; en < Ue2; ++en)
          We = H6e(We, zt[en]);
        for (var Mn = 1, en = 0, Ue2 = Et.length; en < Ue2; ++en)
          Mn = H6e(Mn, Et[en].length);
        We *= Mn;
        var Vn = Ft * zt.length * Et.length;
        return { width: Math.max(1, Math.min(We, M2.maxTileWidth)), height: Math.max(1, Math.min(Vn, M2.maxTileHeight)) };
      }
      function Te2() {
        me2 && (me2.clearRect(0, 0, fe2.width, fe2.height), M2.backgroundColor && (me2.fillStyle = M2.backgroundColor, me2.fillRect(0, 0, fe2.width, fe2.height)));
        for (var We = 0, en = 0; en < _t.length; ++en)
          We += _t[en];
        if (We <= 0)
          return;
        for (var Ue2 = -Ft, Mn = 0, Vn = 0, xn = 0; Ue2 < ye.height; ) {
          if (Mn % 2 === 0) {
            for (var Zr = Vn / 2 % Et.length, nr = 0, pr = 0, Nr = 0; nr < ye.width * 2; ) {
              for (var ai2 = 0, en = 0; en < bt[xn].length; ++en)
                ai2 += bt[xn][en];
              if (ai2 <= 0)
                break;
              if (pr % 2 === 0) {
                var gi2 = (1 - M2.symbolSize) * 0.5, To = nr + bt[xn][pr] * gi2, us = Ue2 + _t[Mn] * gi2, ml = bt[xn][pr] * M2.symbolSize, ll = _t[Mn] * M2.symbolSize, Rs = Nr / 2 % Et[Zr].length;
                es(To, us, ml, ll, Et[Zr][Rs]);
              }
              nr += bt[xn][pr], ++Nr, ++pr, pr === bt[xn].length && (pr = 0);
            }
            ++xn, xn === bt.length && (xn = 0);
          }
          Ue2 += _t[Mn], ++Vn, ++Mn, Mn === _t.length && (Mn = 0);
        }
        function es(Ws, il, bs, Rl, Mh2) {
          var au = v4 ? 1 : t2, eh2 = wm(Mh2, Ws * au, il * au, bs * au, Rl * au, M2.color, M2.symbolKeepAspect);
          if (v4) {
            var Gh2 = h.painter.renderOneToVNode(eh2);
            Gh2 && re2.children.push(Gh2);
          } else
            KWe(me2, eh2);
        }
      }
    }
  }
  function XWe(f2) {
    if (!f2 || f2.length === 0)
      return [["rect"]];
    if (ms(f2))
      return [[f2]];
    for (var i = true, t2 = 0; t2 < f2.length; ++t2)
      if (!ms(f2[t2])) {
        i = false;
        break;
      }
    if (i)
      return XWe([f2]);
    for (var h = [], t2 = 0; t2 < f2.length; ++t2)
      ms(f2[t2]) ? h.push([f2[t2]]) : h.push(f2[t2]);
    return h;
  }
  function QWe(f2) {
    if (!f2 || f2.length === 0)
      return [[0, 0]];
    if (vp(f2)) {
      var i = Math.ceil(f2);
      return [[i, i]];
    }
    for (var t2 = true, h = 0; h < f2.length; ++h)
      if (!vp(f2[h])) {
        t2 = false;
        break;
      }
    if (t2)
      return QWe([f2]);
    for (var v4 = [], h = 0; h < f2.length; ++h)
      if (vp(f2[h])) {
        var i = Math.ceil(f2[h]);
        v4.push([i, i]);
      } else {
        var i = Xa2(f2[h], function(I2) {
          return Math.ceil(I2);
        });
        i.length % 2 === 1 ? v4.push(i.concat(i)) : v4.push(i);
      }
    return v4;
  }
  function igr(f2) {
    if (!f2 || typeof f2 == "object" && f2.length === 0)
      return [0, 0];
    if (vp(f2)) {
      var i = Math.ceil(f2);
      return [i, i];
    }
    var t2 = Xa2(f2, function(h) {
      return Math.ceil(h);
    });
    return f2.length % 2 ? t2.concat(t2) : t2;
  }
  function agr(f2) {
    return Xa2(f2, function(i) {
      return JWe(i);
    });
  }
  function JWe(f2) {
    for (var i = 0, t2 = 0; t2 < f2.length; ++t2)
      i += f2[t2];
    return f2.length % 2 === 1 ? i * 2 : i;
  }
  function ogr(f2, i) {
    f2.eachRawSeries(function(t2) {
      if (!f2.isSeriesFiltered(t2)) {
        var h = t2.getData();
        h.hasItemVisual() && h.each(function(M2) {
          var I2 = h.getItemVisual(M2, "decal");
          if (I2) {
            var P2 = h.ensureUniqueItemVisual(M2, "style");
            P2.decal = lgt(I2, i);
          }
        });
        var v4 = h.getVisual("decal");
        if (v4) {
          var _ = h.getVisual("style");
          _.decal = lgt(v4, i);
        }
      }
    });
  }
  var sgr = new iE(), _5 = sgr, tGe = {};
  function lgr(f2, i) {
    tGe[f2] = i;
  }
  function ugr(f2) {
    return tGe[f2];
  }
  var cgr = typeof window != "undefined", fgr = 1, hgr = 800, pgr = 900, dgr = 1e3, ggr = 2e3, vgr = 5e3, eGe = 1e3, ygr = 1100, une = 2e3, nGe = 3e3, mgr = 4e3, kkt = 4500, bgr = 4600, _gr = 5e3, xgr = 6e3, rGe = 7e3, wgr = { PROCESSOR: { FILTER: dgr, SERIES_FILTER: hgr, STATISTIC: vgr }, VISUAL: { LAYOUT: eGe, PROGRESSIVE_LAYOUT: ygr, GLOBAL: une, CHART: nGe, POST_CHART_LAYOUT: bgr, COMPONENT: mgr, BRUSH: _gr, CHART_ITEM: kkt, ARIA: xgr, DECAL: rGe } }, yS = "__flagInMainProcess", JM = "__pendingUpdate", AXt = "__needsUpdateStatus", EFe = /^[a-zA-Z0-9_]+$/, IXt = "__connectUpdateStatus", kFe = 0, Sgr = 1, Mgr = 2;
  function iGe(f2) {
    return function() {
      for (var i = [], t2 = 0; t2 < arguments.length; t2++)
        i[t2] = arguments[t2];
      if (this.isDisposed()) {
        this.id;
        return;
      }
      return oGe(this, f2, i);
    };
  }
  function aGe(f2) {
    return function() {
      for (var i = [], t2 = 0; t2 < arguments.length; t2++)
        i[t2] = arguments[t2];
      return oGe(this, f2, i);
    };
  }
  function oGe(f2, i, t2) {
    return t2[0] = t2[0] && t2[0].toLowerCase(), iE.prototype[i].apply(f2, t2);
  }
  var sGe = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i;
  }(iE), lGe = sGe.prototype;
  lGe.on = aGe("on");
  lGe.off = aGe("off");
  var ltt, DXt, tDt, T7, EXt, kXt, PXt, $pt, Ypt, PFe, LFe, LXt, OFe, eDt, RFe, uGe, ND, NFe, cGe = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this, new Ddr()) || this;
      _._chartsViews = [], _._chartsMap = {}, _._componentsViews = [], _._componentsMap = {}, _._pendingActions = [], v4 = v4 || {}, ms(h) && (h = fGe[h]), _._dom = t2;
      var M2 = "canvas", I2 = false, P2 = _._zr = z6e(t2, { renderer: v4.renderer || M2, devicePixelRatio: v4.devicePixelRatio, width: v4.width, height: v4.height, ssr: v4.ssr, useDirtyRect: v4.useDirtyRect == null ? I2 : v4.useDirtyRect });
      _._ssr = v4.ssr, _._throttledZrFlush = one(ks(P2.flush, P2), 17), h = pu(h), h && vWe(h, true), _._theme = h, _._locale = Ohr(v4.locale || Gje), _._coordSysMgr = new Pgt();
      var N3 = _._api = RFe(_);
      function z3(H2, $) {
        return H2.__prio - $.__prio;
      }
      return zDt(DEt, z3), zDt(ate, z3), _._scheduler = new HWe(_, N3, ate, DEt), _._messageCenter = new sGe(), _._initEvents(), _.resize = ks(_.resize, _), P2.animation.on("frame", _._onframe, _), PFe(P2, _), LFe(P2, _), oEt(_), _;
    }
    return i.prototype._onframe = function() {
      if (!this._disposed) {
        NFe(this);
        var t2 = this._scheduler;
        if (this[JM]) {
          var h = this[JM].silent;
          this[yS] = true;
          try {
            ltt(this), T7.update.call(this, null, this[JM].updateParams);
          } catch (P2) {
            throw this[yS] = false, this[JM] = null, P2;
          }
          this._zr.flush(), this[yS] = false, this[JM] = null, $pt.call(this, h), Ypt.call(this, h);
        } else if (t2.unfinished) {
          var v4 = fgr, _ = this._model, M2 = this._api;
          t2.unfinished = false;
          do {
            var I2 = +new Date();
            t2.performSeriesTasks(_), t2.performDataProcessorTasks(_), kXt(this, _), t2.performVisualTasks(_), eDt(this, this._model, M2, "remain", {}), v4 -= +new Date() - I2;
          } while (v4 > 0 && t2.unfinished);
          t2.unfinished || this._zr.flush();
        }
      }
    }, i.prototype.getDom = function() {
      return this._dom;
    }, i.prototype.getId = function() {
      return this.id;
    }, i.prototype.getZr = function() {
      return this._zr;
    }, i.prototype.isSSR = function() {
      return this._ssr;
    }, i.prototype.setOption = function(t2, h, v4) {
      if (!this[yS]) {
        if (this._disposed) {
          this.id;
          return;
        }
        var _, M2, I2;
        if (Xl(h) && (v4 = h.lazyUpdate, _ = h.silent, M2 = h.replaceMerge, I2 = h.transition, h = h.notMerge), this[yS] = true, !this._model || h) {
          var P2 = new dpr2(this._api), N3 = this._theme, z3 = this._model = new pWe();
          z3.scheduler = this._scheduler, z3.ssr = this._ssr, z3.init(null, null, null, N3, this._locale, P2);
        }
        this._model.setOption(t2, { replaceMerge: M2 }, ote);
        var H2 = { seriesTransition: I2, optionChanged: true };
        if (v4)
          this[JM] = { silent: _, updateParams: H2 }, this[yS] = false, this.getZr().wakeUp();
        else {
          try {
            ltt(this), T7.update.call(this, null, H2);
          } catch ($) {
            throw this[JM] = null, this[yS] = false, $;
          }
          this._ssr || this._zr.flush(), this[JM] = null, this[yS] = false, $pt.call(this, _), Ypt.call(this, _);
        }
      }
    }, i.prototype.setTheme = function() {
    }, i.prototype.getModel = function() {
      return this._model;
    }, i.prototype.getOption = function() {
      return this._model && this._model.getOption();
    }, i.prototype.getWidth = function() {
      return this._zr.getWidth();
    }, i.prototype.getHeight = function() {
      return this._zr.getHeight();
    }, i.prototype.getDevicePixelRatio = function() {
      return this._zr.painter.dpr || cgr && window.devicePixelRatio || 1;
    }, i.prototype.getRenderedCanvas = function(t2) {
      return this.renderToCanvas(t2);
    }, i.prototype.renderToCanvas = function(t2) {
      t2 = t2 || {};
      var h = this._zr.painter;
      return h.getRenderedCanvas({ backgroundColor: t2.backgroundColor || this._model.get("backgroundColor"), pixelRatio: t2.pixelRatio || this.getDevicePixelRatio() });
    }, i.prototype.renderToSVGString = function(t2) {
      t2 = t2 || {};
      var h = this._zr.painter;
      return h.renderToString({ useViewBox: t2.useViewBox });
    }, i.prototype.getSvgDataURL = function() {
      if (!!gp.svgSupported) {
        var t2 = this._zr, h = t2.storage.getDisplayList();
        return Qe2(h, function(v4) {
          v4.stopAnimation(null, true);
        }), t2.painter.toDataURL();
      }
    }, i.prototype.getDataURL = function(t2) {
      if (this._disposed) {
        this.id;
        return;
      }
      t2 = t2 || {};
      var h = t2.excludeComponents, v4 = this._model, _ = [], M2 = this;
      Qe2(h, function(P2) {
        v4.eachComponent({ mainType: P2 }, function(N3) {
          var z3 = M2._componentsMap[N3.__viewId];
          z3.group.ignore || (_.push(z3), z3.group.ignore = true);
        });
      });
      var I2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(t2).toDataURL("image/" + (t2 && t2.type || "png"));
      return Qe2(_, function(P2) {
        P2.group.ignore = false;
      }), I2;
    }, i.prototype.getConnectedDataURL = function(t2) {
      if (this._disposed) {
        this.id;
        return;
      }
      var h = t2.type === "svg", v4 = this.group, _ = Math.min, M2 = Math.max, I2 = 1 / 0;
      if (FFe[v4]) {
        var P2 = I2, N3 = I2, z3 = -I2, H2 = -I2, $ = [], et = t2 && t2.pixelRatio || this.getDevicePixelRatio();
        Qe2(Vdt, function(zt, Ft) {
          if (zt.group === v4) {
            var fe2 = h ? zt.getZr().painter.getSvgDom().innerHTML : zt.renderToCanvas(pu(t2)), re2 = zt.getDom().getBoundingClientRect();
            P2 = _(re2.left, P2), N3 = _(re2.top, N3), z3 = M2(re2.right, z3), H2 = M2(re2.bottom, H2), $.push({ dom: fe2, left: re2.left, top: re2.top });
          }
        }), P2 *= et, N3 *= et, z3 *= et, H2 *= et;
        var at = z3 - P2, ht = H2 - N3, bt = Q6.createCanvas(), _t = z6e(bt, { renderer: h ? "svg" : "canvas" });
        if (_t.resize({ width: at, height: ht }), h) {
          var Et = "";
          return Qe2($, function(zt) {
            var Ft = zt.left - P2, fe2 = zt.top - N3;
            Et += '<g transform="translate(' + Ft + "," + fe2 + ')">' + zt.dom + "</g>";
          }), _t.painter.getSvgRoot().innerHTML = Et, t2.connectedBackgroundColor && _t.painter.setBackgroundColor(t2.connectedBackgroundColor), _t.refreshImmediately(), _t.painter.toDataURL();
        } else
          return t2.connectedBackgroundColor && _t.add(new Sh2({ shape: { x: 0, y: 0, width: at, height: ht }, style: { fill: t2.connectedBackgroundColor } })), Qe2($, function(zt) {
            var Ft = new Ux({ style: { x: zt.left * et - P2, y: zt.top * et - N3, image: zt.dom } });
            _t.add(Ft);
          }), _t.refreshImmediately(), bt.toDataURL("image/" + (t2 && t2.type || "png"));
      } else
        return this.getDataURL(t2);
    }, i.prototype.convertToPixel = function(t2, h) {
      return EXt(this, "convertToPixel", t2, h);
    }, i.prototype.convertFromPixel = function(t2, h) {
      return EXt(this, "convertFromPixel", t2, h);
    }, i.prototype.containPixel = function(t2, h) {
      if (this._disposed) {
        this.id;
        return;
      }
      var v4 = this._model, _, M2 = kdt(v4, t2);
      return Qe2(M2, function(I2, P2) {
        P2.indexOf("Models") >= 0 && Qe2(I2, function(N3) {
          var z3 = N3.coordinateSystem;
          if (z3 && z3.containPoint)
            _ = _ || !!z3.containPoint(h);
          else if (P2 === "seriesModels") {
            var H2 = this._chartsMap[N3.__viewId];
            H2 && H2.containPoint && (_ = _ || H2.containPoint(h, N3));
          }
        }, this);
      }, this), !!_;
    }, i.prototype.getVisual = function(t2, h) {
      var v4 = this._model, _ = kdt(v4, t2, { defaultMainType: "series" }), M2 = _.seriesModel, I2 = M2.getData(), P2 = _.hasOwnProperty("dataIndexInside") ? _.dataIndexInside : _.hasOwnProperty("dataIndex") ? I2.indexOfRawIndex(_.dataIndex) : null;
      return P2 != null ? sne(I2, P2, h) : Lgt(I2, h);
    }, i.prototype.getViewOfComponentModel = function(t2) {
      return this._componentsMap[t2.__viewId];
    }, i.prototype.getViewOfSeriesModel = function(t2) {
      return this._chartsMap[t2.__viewId];
    }, i.prototype._initEvents = function() {
      var t2 = this;
      Qe2(Cgr, function(h) {
        var v4 = function(_) {
          var M2 = t2.getModel(), I2 = _.target, P2, N3 = h === "globalout";
          if (N3 ? P2 = {} : I2 && Itt(I2, function(at) {
            var ht = Du(at);
            if (ht && ht.dataIndex != null) {
              var bt = ht.dataModel || M2.getSeriesByIndex(ht.seriesIndex);
              return P2 = bt && bt.getDataParams(ht.dataIndex, ht.dataType) || {}, true;
            } else if (ht.eventData)
              return P2 = ba2({}, ht.eventData), true;
          }, true), P2) {
            var z3 = P2.componentType, H2 = P2.componentIndex;
            (z3 === "markLine" || z3 === "markPoint" || z3 === "markArea") && (z3 = "series", H2 = P2.seriesIndex);
            var $ = z3 && H2 != null && M2.getComponent(z3, H2), et = $ && t2[$.mainType === "series" ? "_chartsMap" : "_componentsMap"][$.__viewId];
            P2.event = _, P2.type = h, t2._$eventProcessor.eventInfo = { targetEl: I2, packedEvent: P2, model: $, view: et }, t2.trigger(h, P2);
          }
        };
        v4.zrEventfulCallAtLast = true, t2._zr.on(h, v4, t2);
      }), Qe2(Fdt, function(h, v4) {
        t2._messageCenter.on(v4, function(_) {
          this.trigger(v4, _);
        }, t2);
      }), Qe2(["selectchanged"], function(h) {
        t2._messageCenter.on(h, function(v4) {
          this.trigger(h, v4);
        }, t2);
      }), Pdr(this._messageCenter, this, this._api);
    }, i.prototype.isDisposed = function() {
      return this._disposed;
    }, i.prototype.clear = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this.setOption({ series: [] }, true);
    }, i.prototype.dispose = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._disposed = true;
      var t2 = this.getDom();
      t2 && zze(this.getDom(), fne, "");
      var h = this, v4 = h._api, _ = h._model;
      Qe2(h._componentsViews, function(M2) {
        M2.dispose(_, v4);
      }), Qe2(h._chartsViews, function(M2) {
        M2.dispose(_, v4);
      }), h._zr.dispose(), h._dom = h._model = h._chartsMap = h._componentsMap = h._chartsViews = h._componentsViews = h._scheduler = h._api = h._zr = h._throttledZrFlush = h._theme = h._coordSysMgr = h._messageCenter = null, delete Vdt[h.id];
    }, i.prototype.resize = function(t2) {
      if (!this[yS]) {
        if (this._disposed) {
          this.id;
          return;
        }
        this._zr.resize(t2);
        var h = this._model;
        if (this._loadingFX && this._loadingFX.resize(), !!h) {
          var v4 = h.resetOption("media"), _ = t2 && t2.silent;
          this[JM] && (_ == null && (_ = this[JM].silent), v4 = true, this[JM] = null), this[yS] = true;
          try {
            v4 && ltt(this), T7.update.call(this, { type: "resize", animation: ba2({ duration: 0 }, t2 && t2.animation) });
          } catch (M2) {
            throw this[yS] = false, M2;
          }
          this[yS] = false, $pt.call(this, _), Ypt.call(this, _);
        }
      }
    }, i.prototype.showLoading = function(t2, h) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (Xl(t2) && (h = t2, t2 = ""), t2 = t2 || "default", this.hideLoading(), !!ste[t2]) {
        var v4 = ste[t2](this._api, h), _ = this._zr;
        this._loadingFX = v4, _.add(v4);
      }
    }, i.prototype.hideLoading = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
    }, i.prototype.makeActionFromEvent = function(t2) {
      var h = ba2({}, t2);
      return h.type = Fdt[t2.type], h;
    }, i.prototype.dispatchAction = function(t2, h) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (Xl(h) || (h = { silent: !!h }), !!IEt[t2.type] && !!this._model) {
        if (this[yS]) {
          this._pendingActions.push(t2);
          return;
        }
        var v4 = h.silent;
        PXt.call(this, t2, v4);
        var _ = h.flush;
        _ ? this._zr.flush() : _ !== false && gp.browser.weChat && this._throttledZrFlush(), $pt.call(this, v4), Ypt.call(this, v4);
      }
    }, i.prototype.updateLabelLayout = function() {
      _5.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
    }, i.prototype.appendData = function(t2) {
      if (this._disposed) {
        this.id;
        return;
      }
      var h = t2.seriesIndex, v4 = this.getModel(), _ = v4.getSeriesByIndex(h);
      _.appendData(t2), this._scheduler.unfinished = true, this.getZr().wakeUp();
    }, i.internalField = function() {
      ltt = function(H2) {
        var $ = H2._scheduler;
        $.restorePipelines(H2._model), $.prepareStageTasks(), DXt(H2, true), DXt(H2, false), $.plan();
      }, DXt = function(H2, $) {
        for (var et = H2._model, at = H2._scheduler, ht = $ ? H2._componentsViews : H2._chartsViews, bt = $ ? H2._componentsMap : H2._chartsMap, _t = H2._zr, Et = H2._api, zt = 0; zt < ht.length; zt++)
          ht[zt].__alive = false;
        $ ? et.eachComponent(function(re2, ye) {
          re2 !== "series" && Ft(ye);
        }) : et.eachSeries(Ft);
        function Ft(re2) {
          var ye = re2.__requireNewView;
          re2.__requireNewView = false;
          var me2 = "_ec_" + re2.id + "_" + re2.type, be2 = !ye && bt[me2];
          if (!be2) {
            var Te2 = LL(re2.type), We = $ ? W0.getClass(Te2.main, Te2.sub) : Hg2.getClass(Te2.sub);
            be2 = new We(), be2.init(et, Et), bt[me2] = be2, ht.push(be2), _t.add(be2.group);
          }
          re2.__viewId = be2.__id = me2, be2.__alive = true, be2.__model = re2, be2.group.__ecComponentInfo = { mainType: re2.mainType, index: re2.componentIndex }, !$ && at.prepareView(be2, re2, et, Et);
        }
        for (var zt = 0; zt < ht.length; ) {
          var fe2 = ht[zt];
          fe2.__alive ? zt++ : (!$ && fe2.renderTask.dispose(), _t.remove(fe2.group), fe2.dispose(et, Et), ht.splice(zt, 1), bt[fe2.__id] === fe2 && delete bt[fe2.__id], fe2.__id = fe2.group.__ecComponentInfo = null);
        }
      }, tDt = function(H2, $, et, at, ht) {
        var bt = H2._model;
        if (bt.setUpdatePayload(et), !at) {
          Qe2([].concat(H2._componentsViews).concat(H2._chartsViews), fe2);
          return;
        }
        var _t = {};
        _t[at + "Id"] = et[at + "Id"], _t[at + "Index"] = et[at + "Index"], _t[at + "Name"] = et[at + "Name"];
        var Et = { mainType: at, query: _t };
        ht && (Et.subType = ht);
        var zt = et.excludeSeriesId, Ft;
        zt != null && (Ft = Il(), Qe2(Od2(zt), function(re2) {
          var ye = l1(re2, null);
          ye != null && Ft.set(ye, true);
        })), bt && bt.eachComponent(Et, function(re2) {
          var ye = Ft && Ft.get(re2.id) !== null;
          if (!ye)
            if (mNe(et))
              if (re2 instanceof Jv)
                et.type === lU && !et.notBlur && !re2.get(["emphasis", "disabled"]) && Cfr(re2, et, H2._api);
              else {
                var me2 = Fee(re2.mainType, re2.componentIndex, et.name, H2._api), be2 = me2.focusSelf, Te2 = me2.dispatchers;
                et.type === lU && be2 && !et.notBlur && jJt(re2.mainType, re2.componentIndex, H2._api), Te2 && Qe2(Te2, function(We) {
                  et.type === lU ? NL(We) : FL(We);
                });
              }
            else
              GJt(et) && re2 instanceof Jv && (Ifr(re2, et, H2._api), vNe(re2), ND(H2));
        }, H2), bt && bt.eachComponent(Et, function(re2) {
          var ye = Ft && Ft.get(re2.id) !== null;
          ye || fe2(H2[at === "series" ? "_chartsMap" : "_componentsMap"][re2.__viewId]);
        }, H2);
        function fe2(re2) {
          re2 && re2.__alive && re2[$] && re2[$](re2.__model, bt, H2._api, et);
        }
      }, T7 = { prepareAndUpdate: function(H2) {
        ltt(this), T7.update.call(this, H2, { optionChanged: H2.newOption != null });
      }, update: function(H2, $) {
        var et = this._model, at = this._api, ht = this._zr, bt = this._coordSysMgr, _t = this._scheduler;
        if (!!et) {
          et.setUpdatePayload(H2), _t.restoreData(et, H2), _t.performSeriesTasks(et), bt.create(et, at), _t.performDataProcessorTasks(et, H2), kXt(this, et), bt.update(et, at), t2(et), _t.performVisualTasks(et, H2), LXt(this, et, at, H2, $);
          var Et = et.get("backgroundColor") || "transparent", zt = et.get("darkMode");
          ht.setBackgroundColor(Et), zt != null && zt !== "auto" && ht.setDarkMode(zt), _5.trigger("afterupdate", et, at);
        }
      }, updateTransform: function(H2) {
        var $ = this, et = this._model, at = this._api;
        if (!!et) {
          et.setUpdatePayload(H2);
          var ht = [];
          et.eachComponent(function(_t, Et) {
            if (_t !== "series") {
              var zt = $.getViewOfComponentModel(Et);
              if (zt && zt.__alive)
                if (zt.updateTransform) {
                  var Ft = zt.updateTransform(Et, et, at, H2);
                  Ft && Ft.update && ht.push(zt);
                } else
                  ht.push(zt);
            }
          });
          var bt = Il();
          et.eachSeries(function(_t) {
            var Et = $._chartsMap[_t.__viewId];
            if (Et.updateTransform) {
              var zt = Et.updateTransform(_t, et, at, H2);
              zt && zt.update && bt.set(_t.uid, 1);
            } else
              bt.set(_t.uid, 1);
          }), t2(et), this._scheduler.performVisualTasks(et, H2, { setDirty: true, dirtyMap: bt }), eDt(this, et, at, H2, {}, bt), _5.trigger("afterupdate", et, at);
        }
      }, updateView: function(H2) {
        var $ = this._model;
        !$ || ($.setUpdatePayload(H2), Hg2.markUpdateMethod(H2, "updateView"), t2($), this._scheduler.performVisualTasks($, H2, { setDirty: true }), LXt(this, $, this._api, H2, {}), _5.trigger("afterupdate", $, this._api));
      }, updateVisual: function(H2) {
        var $ = this, et = this._model;
        !et || (et.setUpdatePayload(H2), et.eachSeries(function(at) {
          at.getData().clearAllVisual();
        }), Hg2.markUpdateMethod(H2, "updateVisual"), t2(et), this._scheduler.performVisualTasks(et, H2, { visualType: "visual", setDirty: true }), et.eachComponent(function(at, ht) {
          if (at !== "series") {
            var bt = $.getViewOfComponentModel(ht);
            bt && bt.__alive && bt.updateVisual(ht, et, $._api, H2);
          }
        }), et.eachSeries(function(at) {
          var ht = $._chartsMap[at.__viewId];
          ht.updateVisual(at, et, $._api, H2);
        }), _5.trigger("afterupdate", et, this._api));
      }, updateLayout: function(H2) {
        T7.update.call(this, H2);
      } }, EXt = function(H2, $, et, at) {
        if (H2._disposed) {
          H2.id;
          return;
        }
        for (var ht = H2._model, bt = H2._coordSysMgr.getCoordinateSystems(), _t, Et = kdt(ht, et), zt = 0; zt < bt.length; zt++) {
          var Ft = bt[zt];
          if (Ft[$] && (_t = Ft[$](ht, Et, at)) != null)
            return _t;
        }
      }, kXt = function(H2, $) {
        var et = H2._chartsMap, at = H2._scheduler;
        $.eachSeries(function(ht) {
          at.updateStreamModes(ht, et[ht.__viewId]);
        });
      }, PXt = function(H2, $) {
        var et = this, at = this.getModel(), ht = H2.type, bt = H2.escapeConnect, _t = IEt[ht], Et = _t.actionInfo, zt = (Et.update || "update").split(":"), Ft = zt.pop(), fe2 = zt[0] != null && LL(zt[0]);
        this[yS] = true;
        var re2 = [H2], ye = false;
        H2.batch && (ye = true, re2 = Xa2(H2.batch, function(Mn) {
          return Mn = Ul(ba2({}, Mn), H2), Mn.batch = null, Mn;
        }));
        var me2 = [], be2, Te2 = GJt(H2), We = mNe(H2);
        if (We && hje(this._api), Qe2(re2, function(Mn) {
          if (be2 = _t.action(Mn, et._model, et._api), be2 = be2 || ba2({}, Mn), be2.type = Et.event || be2.type, me2.push(be2), We) {
            var Vn = kee(H2), xn = Vn.queryOptionMap, Zr = Vn.mainTypeSpecified, nr = Zr ? xn.keys()[0] : "series";
            tDt(et, Ft, Mn, nr), ND(et);
          } else
            Te2 ? (tDt(et, Ft, Mn, "series"), ND(et)) : fe2 && tDt(et, Ft, Mn, fe2.main, fe2.sub);
        }), Ft !== "none" && !We && !Te2 && !fe2)
          try {
            this[JM] ? (ltt(this), T7.update.call(this, H2), this[JM] = null) : T7[Ft].call(this, H2);
          } catch (Mn) {
            throw this[yS] = false, Mn;
          }
        if (ye ? be2 = { type: Et.event || ht, escapeConnect: bt, batch: me2 } : be2 = me2[0], this[yS] = false, !$) {
          var en = this._messageCenter;
          if (en.trigger(be2.type, be2), Te2) {
            var Ue2 = { type: "selectchanged", escapeConnect: bt, selected: Dfr(at), isFromClick: H2.isFromClick || false, fromAction: H2.type, fromActionPayload: H2 };
            en.trigger(Ue2.type, Ue2);
          }
        }
      }, $pt = function(H2) {
        for (var $ = this._pendingActions; $.length; ) {
          var et = $.shift();
          PXt.call(this, et, H2);
        }
      }, Ypt = function(H2) {
        !H2 && this.trigger("updated");
      }, PFe = function(H2, $) {
        H2.on("rendered", function(et) {
          $.trigger("rendered", et), H2.animation.isFinished() && !$[JM] && !$._scheduler.unfinished && !$._pendingActions.length && $.trigger("finished");
        });
      }, LFe = function(H2, $) {
        H2.on("mouseover", function(et) {
          var at = et.target, ht = Itt(at, Jdt);
          ht && (Tfr(ht, et, $._api), ND($));
        }).on("mouseout", function(et) {
          var at = et.target, ht = Itt(at, Jdt);
          ht && (Afr(ht, et, $._api), ND($));
        }).on("click", function(et) {
          var at = et.target, ht = Itt(at, function(Et) {
            return Du(Et).dataIndex != null;
          }, true);
          if (ht) {
            var bt = ht.selected ? "unselect" : "select", _t = Du(ht);
            $._api.dispatchAction({ type: bt, dataType: _t.dataType, dataIndexInside: _t.dataIndex, seriesIndex: _t.seriesIndex, isFromClick: true });
          }
        });
      };
      function t2(H2) {
        H2.clearColorPalette(), H2.eachSeries(function($) {
          $.clearColorPalette();
        });
      }
      function h(H2) {
        var $ = [], et = [], at = false;
        if (H2.eachComponent(function(Et, zt) {
          var Ft = zt.get("zlevel") || 0, fe2 = zt.get("z") || 0, re2 = zt.getZLevelKey();
          at = at || !!re2, (Et === "series" ? et : $).push({ zlevel: Ft, z: fe2, idx: zt.componentIndex, type: Et, key: re2 });
        }), at) {
          var ht = $.concat(et), bt, _t;
          zDt(ht, function(Et, zt) {
            return Et.zlevel === zt.zlevel ? Et.z - zt.z : Et.zlevel - zt.zlevel;
          }), Qe2(ht, function(Et) {
            var zt = H2.getComponent(Et.type, Et.idx), Ft = Et.zlevel, fe2 = Et.key;
            bt != null && (Ft = Math.max(bt, Ft)), fe2 ? (Ft === bt && fe2 !== _t && Ft++, _t = fe2) : _t && (Ft === bt && Ft++, _t = ""), bt = Ft, zt.setZLevel(Ft);
          });
        }
      }
      LXt = function(H2, $, et, at, ht) {
        h($), OFe(H2, $, et, at, ht), Qe2(H2._chartsViews, function(bt) {
          bt.__alive = false;
        }), eDt(H2, $, et, at, ht), Qe2(H2._chartsViews, function(bt) {
          bt.__alive || bt.remove($, et);
        });
      }, OFe = function(H2, $, et, at, ht, bt) {
        Qe2(bt || H2._componentsViews, function(_t) {
          var Et = _t.__model;
          N3(Et, _t), _t.render(Et, $, et, at), I2(Et, _t), z3(Et, _t);
        });
      }, eDt = function(H2, $, et, at, ht, bt) {
        var _t = H2._scheduler;
        ht = ba2(ht || {}, { updatedSeries: $.getSeries() }), _5.trigger("series:beforeupdate", $, et, ht);
        var Et = false;
        $.eachSeries(function(zt) {
          var Ft = H2._chartsMap[zt.__viewId];
          Ft.__alive = true;
          var fe2 = Ft.renderTask;
          _t.updatePayload(fe2, at), N3(zt, Ft), bt && bt.get(zt.uid) && fe2.dirty(), fe2.perform(_t.getPerformArgs(fe2)) && (Et = true), Ft.group.silent = !!zt.get("silent"), M2(zt, Ft), vNe(zt);
        }), _t.unfinished = Et || _t.unfinished, _5.trigger("series:layoutlabels", $, et, ht), _5.trigger("series:transition", $, et, ht), $.eachSeries(function(zt) {
          var Ft = H2._chartsMap[zt.__viewId];
          I2(zt, Ft), z3(zt, Ft);
        }), _(H2, $), _5.trigger("series:afterupdate", $, et, ht);
      }, ND = function(H2) {
        H2[AXt] = true, H2.getZr().wakeUp();
      }, NFe = function(H2) {
        !H2[AXt] || (H2.getZr().storage.traverse(function($) {
          Rtt($) || v4($);
        }), H2[AXt] = false);
      };
      function v4(H2) {
        for (var $ = [], et = H2.currentStates, at = 0; at < et.length; at++) {
          var ht = et[at];
          ht === "emphasis" || ht === "blur" || ht === "select" || $.push(ht);
        }
        H2.selected && H2.states.select && $.push("select"), H2.hoverState === gkt && H2.states.emphasis ? $.push("emphasis") : H2.hoverState === Agt && H2.states.blur && $.push("blur"), H2.useStates($);
      }
      function _(H2, $) {
        var et = H2._zr, at = et.storage, ht = 0;
        at.traverse(function(bt) {
          bt.isGroup || ht++;
        }), ht > $.get("hoverLayerThreshold") && !gp.node && !gp.worker && $.eachSeries(function(bt) {
          if (!bt.preventUsingHoverLayer) {
            var _t = H2._chartsMap[bt.__viewId];
            _t.__alive && _t.eachRendered(function(Et) {
              Et.states.emphasis && (Et.states.emphasis.hoverLayer = true);
            });
          }
        });
      }
      function M2(H2, $) {
        var et = H2.get("blendMode") || null;
        $.eachRendered(function(at) {
          at.isGroup || (at.style.blend = et);
        });
      }
      function I2(H2, $) {
        if (!H2.preventAutoZ) {
          var et = H2.get("z") || 0, at = H2.get("zlevel") || 0;
          $.eachRendered(function(ht) {
            return P2(ht, et, at, -1 / 0), true;
          });
        }
      }
      function P2(H2, $, et, at) {
        var ht = H2.getTextContent(), bt = H2.getTextGuideLine(), _t = H2.isGroup;
        if (_t)
          for (var Et = H2.childrenRef(), zt = 0; zt < Et.length; zt++)
            at = Math.max(P2(Et[zt], $, et, at), at);
        else
          H2.z = $, H2.zlevel = et, at = Math.max(H2.z2, at);
        if (ht && (ht.z = $, ht.zlevel = et, isFinite(at) && (ht.z2 = at + 2)), bt) {
          var Ft = H2.textGuideLineConfig;
          bt.z = $, bt.zlevel = et, isFinite(at) && (bt.z2 = at + (Ft && Ft.showAbove ? 1 : -1));
        }
        return at;
      }
      function N3(H2, $) {
        $.eachRendered(function(et) {
          if (!Rtt(et)) {
            var at = et.getTextContent(), ht = et.getTextGuideLine();
            et.stateTransition && (et.stateTransition = null), at && at.stateTransition && (at.stateTransition = null), ht && ht.stateTransition && (ht.stateTransition = null), et.hasState() ? (et.prevStates = et.currentStates, et.clearStates()) : et.prevStates && (et.prevStates = null);
          }
        });
      }
      function z3(H2, $) {
        var et = H2.getModel("stateAnimation"), at = H2.isAnimationEnabled(), ht = et.get("duration"), bt = ht > 0 ? { duration: ht, delay: et.get("delay"), easing: et.get("easing") } : null;
        $.eachRendered(function(_t) {
          if (_t.states && _t.states.emphasis) {
            if (Rtt(_t))
              return;
            if (_t instanceof Uc2 && Ofr(_t), _t.__dirty) {
              var Et = _t.prevStates;
              Et && _t.useStates(Et);
            }
            if (at) {
              _t.stateTransition = bt;
              var zt = _t.getTextContent(), Ft = _t.getTextGuideLine();
              zt && (zt.stateTransition = bt), Ft && (Ft.stateTransition = bt);
            }
            _t.__dirty && v4(_t);
          }
        });
      }
      RFe = function(H2) {
        return new (function($) {
          ii2(et, $);
          function et() {
            return $ !== null && $.apply(this, arguments) || this;
          }
          return et.prototype.getCoordinateSystems = function() {
            return H2._coordSysMgr.getCoordinateSystems();
          }, et.prototype.getComponentByElement = function(at) {
            for (; at; ) {
              var ht = at.__ecComponentInfo;
              if (ht != null)
                return H2._model.getComponent(ht.mainType, ht.index);
              at = at.parent;
            }
          }, et.prototype.enterEmphasis = function(at, ht) {
            NL(at, ht), ND(H2);
          }, et.prototype.leaveEmphasis = function(at, ht) {
            FL(at, ht), ND(H2);
          }, et.prototype.enterBlur = function(at) {
            sje(at), ND(H2);
          }, et.prototype.leaveBlur = function(at) {
            lje(at), ND(H2);
          }, et.prototype.enterSelect = function(at) {
            uje(at), ND(H2);
          }, et.prototype.leaveSelect = function(at) {
            cje(at), ND(H2);
          }, et.prototype.getModel = function() {
            return H2.getModel();
          }, et.prototype.getViewOfComponentModel = function(at) {
            return H2.getViewOfComponentModel(at);
          }, et.prototype.getViewOfSeriesModel = function(at) {
            return H2.getViewOfSeriesModel(at);
          }, et;
        }(dWe))(H2);
      }, uGe = function(H2) {
        function $(et, at) {
          for (var ht = 0; ht < et.length; ht++) {
            var bt = et[ht];
            bt[IXt] = at;
          }
        }
        Qe2(Fdt, function(et, at) {
          H2._messageCenter.on(at, function(ht) {
            if (FFe[H2.group] && H2[IXt] !== kFe) {
              if (ht && ht.escapeConnect)
                return;
              var bt = H2.makeActionFromEvent(ht), _t = [];
              Qe2(Vdt, function(Et) {
                Et !== H2 && Et.group === H2.group && _t.push(Et);
              }), $(_t, kFe), Qe2(_t, function(Et) {
                Et[IXt] !== Sgr && Et.dispatchAction(bt);
              }), $(_t, Mgr);
            }
          });
        });
      };
    }(), i;
  }(iE), cne = cGe.prototype;
  cne.on = iGe("on");
  cne.off = iGe("off");
  cne.one = function(f2, i, t2) {
    var h = this;
    function v4() {
      for (var _ = [], M2 = 0; M2 < arguments.length; M2++)
        _[M2] = arguments[M2];
      i && i.apply && i.apply(this, _), h.off(f2, v4);
    }
    this.on.call(this, f2, v4, t2);
  };
  var Cgr = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
  var IEt = {}, Fdt = {}, ate = [], ote = [], DEt = [], fGe = {}, ste = {}, Vdt = {}, FFe = {}, Tgr = +new Date() - 0, fne = "_echarts_instance_";
  function Agr(f2, i, t2) {
    var h = !(t2 && t2.ssr);
    if (h) {
      var v4 = Igr(f2);
      if (v4)
        return v4;
    }
    var _ = new cGe(f2, i, t2);
    return _.id = "ec_" + Tgr++, Vdt[_.id] = _, h && zze(f2, fne, _.id), uGe(_), _5.trigger("afterinit", _), _;
  }
  function Igr(f2) {
    return Vdt[mcr(f2, fne)];
  }
  function hGe(f2, i) {
    fGe[f2] = i;
  }
  function pGe(f2) {
    Pc2(ote, f2) < 0 && ote.push(f2);
  }
  function dGe(f2, i) {
    pne(ate, f2, i, ggr);
  }
  function Dgr(f2) {
    hne("afterinit", f2);
  }
  function Egr(f2) {
    hne("afterupdate", f2);
  }
  function hne(f2, i) {
    _5.on(f2, i);
  }
  function ZL(f2, i, t2) {
    Ol(i) && (t2 = i, i = "");
    var h = Xl(f2) ? f2.type : [f2, f2 = { event: i }][0];
    f2.event = (f2.event || h).toLowerCase(), i = f2.event, !Fdt[i] && (z2(EFe.test(h) && EFe.test(i)), IEt[h] || (IEt[h] = { action: t2, actionInfo: f2 }), Fdt[i] = h);
  }
  function kgr(f2, i) {
    Pgt.register(f2, i);
  }
  function Pgr(f2, i) {
    pne(DEt, f2, i, eGe, "layout");
  }
  function CU(f2, i) {
    pne(DEt, f2, i, nGe, "visual");
  }
  var VFe = [];
  function pne(f2, i, t2, h, v4) {
    if ((Ol(i) || Xl(i)) && (t2 = i, i = h), !(Pc2(VFe, t2) >= 0)) {
      VFe.push(t2);
      var _ = HWe.wrapStageHandler(t2, v4);
      _.__prio = i, _.__raw = t2, f2.push(_);
    }
  }
  function gGe(f2, i) {
    ste[f2] = i;
  }
  function Lgr(f2, i, t2) {
    var h = ugr("registerMap");
    h && h(f2, i, t2);
  }
  var Ogr = Wpr;
  CU(une, pdr);
  CU(kkt, ddr);
  CU(kkt, gdr);
  CU(une, Edr);
  CU(kkt, kdr);
  CU(rGe, ogr);
  pGe(vWe);
  dGe(pgr, wpr);
  gGe("default", vdr);
  ZL({ type: lU, event: lU, update: lU }, xm);
  ZL({ type: qDt, event: qDt, update: qDt }, xm);
  ZL({ type: Pdt, event: Pdt, update: Pdt }, xm);
  ZL({ type: ZDt, event: ZDt, update: ZDt }, xm);
  ZL({ type: Ldt, event: Ldt, update: Ldt }, xm);
  hGe("light", Adr);
  hGe("dark", Idr);
  var BFe = [], Rgr = { registerPreprocessor: pGe, registerProcessor: dGe, registerPostInit: Dgr, registerPostUpdate: Egr, registerUpdateLifecycle: hne, registerAction: ZL, registerCoordinateSystem: kgr, registerLayout: Pgr, registerVisual: CU, registerTransform: Ogr, registerLoading: gGe, registerMap: Lgr, registerImpl: lgr, PRIORITY: wgr, ComponentModel: zh2, ComponentView: W0, SeriesModel: Jv, ChartView: Hg2, registerComponentModel: function(f2) {
    zh2.registerClass(f2);
  }, registerComponentView: function(f2) {
    W0.registerClass(f2);
  }, registerSeriesModel: function(f2) {
    Jv.registerClass(f2);
  }, registerChartView: function(f2) {
    Hg2.registerClass(f2);
  }, registerSubTypeDefaulter: function(f2, i) {
    zh2.registerSubTypeDefaulter(f2, i);
  }, registerPainter: function(f2, i) {
    Qur(f2, i);
  } };
  function zc2(f2) {
    if (Za2(f2)) {
      Qe2(f2, function(i) {
        zc2(i);
      });
      return;
    }
    Pc2(BFe, f2) >= 0 || (BFe.push(f2), Ol(f2) && (f2 = { install: f2 }), f2.install(Rgr));
  }
  function Kpt(f2) {
    return f2 == null ? 0 : f2.length || 1;
  }
  function zFe(f2) {
    return f2;
  }
  var Ngr = function() {
    function f2(i, t2, h, v4, _, M2) {
      this._old = i, this._new = t2, this._oldKeyGetter = h || zFe, this._newKeyGetter = v4 || zFe, this.context = _, this._diffModeMultiple = M2 === "multiple";
    }
    return f2.prototype.add = function(i) {
      return this._add = i, this;
    }, f2.prototype.update = function(i) {
      return this._update = i, this;
    }, f2.prototype.updateManyToOne = function(i) {
      return this._updateManyToOne = i, this;
    }, f2.prototype.updateOneToMany = function(i) {
      return this._updateOneToMany = i, this;
    }, f2.prototype.updateManyToMany = function(i) {
      return this._updateManyToMany = i, this;
    }, f2.prototype.remove = function(i) {
      return this._remove = i, this;
    }, f2.prototype.execute = function() {
      this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
    }, f2.prototype._executeOneToOne = function() {
      var i = this._old, t2 = this._new, h = {}, v4 = new Array(i.length), _ = new Array(t2.length);
      this._initIndexMap(i, null, v4, "_oldKeyGetter"), this._initIndexMap(t2, h, _, "_newKeyGetter");
      for (var M2 = 0; M2 < i.length; M2++) {
        var I2 = v4[M2], P2 = h[I2], N3 = Kpt(P2);
        if (N3 > 1) {
          var z3 = P2.shift();
          P2.length === 1 && (h[I2] = P2[0]), this._update && this._update(z3, M2);
        } else
          N3 === 1 ? (h[I2] = null, this._update && this._update(P2, M2)) : this._remove && this._remove(M2);
      }
      this._performRestAdd(_, h);
    }, f2.prototype._executeMultiple = function() {
      var i = this._old, t2 = this._new, h = {}, v4 = {}, _ = [], M2 = [];
      this._initIndexMap(i, h, _, "_oldKeyGetter"), this._initIndexMap(t2, v4, M2, "_newKeyGetter");
      for (var I2 = 0; I2 < _.length; I2++) {
        var P2 = _[I2], N3 = h[P2], z3 = v4[P2], H2 = Kpt(N3), $ = Kpt(z3);
        if (H2 > 1 && $ === 1)
          this._updateManyToOne && this._updateManyToOne(z3, N3), v4[P2] = null;
        else if (H2 === 1 && $ > 1)
          this._updateOneToMany && this._updateOneToMany(z3, N3), v4[P2] = null;
        else if (H2 === 1 && $ === 1)
          this._update && this._update(z3, N3), v4[P2] = null;
        else if (H2 > 1 && $ > 1)
          this._updateManyToMany && this._updateManyToMany(z3, N3), v4[P2] = null;
        else if (H2 > 1)
          for (var et = 0; et < H2; et++)
            this._remove && this._remove(N3[et]);
        else
          this._remove && this._remove(N3);
      }
      this._performRestAdd(M2, v4);
    }, f2.prototype._performRestAdd = function(i, t2) {
      for (var h = 0; h < i.length; h++) {
        var v4 = i[h], _ = t2[v4], M2 = Kpt(_);
        if (M2 > 1)
          for (var I2 = 0; I2 < M2; I2++)
            this._add && this._add(_[I2]);
        else
          M2 === 1 && this._add && this._add(_);
        t2[v4] = null;
      }
    }, f2.prototype._initIndexMap = function(i, t2, h, v4) {
      for (var _ = this._diffModeMultiple, M2 = 0; M2 < i.length; M2++) {
        var I2 = "_ec_" + this[v4](i[M2], M2);
        if (_ || (h[M2] = I2), !!t2) {
          var P2 = t2[I2], N3 = Kpt(P2);
          N3 === 0 ? (t2[I2] = M2, _ && h.push(I2)) : N3 === 1 ? t2[I2] = [P2, M2] : P2.push(M2);
        }
      }
    }, f2;
  }(), eN = Ngr, Fgr = function() {
    function f2(i, t2) {
      this._encode = i, this._schema = t2;
    }
    return f2.prototype.get = function() {
      return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
    }, f2.prototype._getFullDimensionNames = function() {
      return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
    }, f2;
  }();
  function Vgr(f2, i) {
    var t2 = {}, h = t2.encode = {}, v4 = Il(), _ = [], M2 = [], I2 = {};
    Qe2(f2.dimensions, function($) {
      var et = f2.getDimensionInfo($), at = et.coordDim;
      if (at) {
        var ht = et.coordDimIndex;
        OXt(h, at)[ht] = $, et.isExtraCoord || (v4.set(at, 1), Bgr(et.type) && (_[0] = $), OXt(I2, at)[ht] = f2.getDimensionIndex(et.name)), et.defaultTooltip && M2.push($);
      }
      aWe.each(function(bt, _t) {
        var Et = OXt(h, _t), zt = et.otherDims[_t];
        zt != null && zt !== false && (Et[zt] = et.name);
      });
    });
    var P2 = [], N3 = {};
    v4.each(function($, et) {
      var at = h[et];
      N3[et] = at[0], P2 = P2.concat(at);
    }), t2.dataDimsOnCoord = P2, t2.dataDimIndicesOnCoord = Xa2(P2, function($) {
      return f2.getDimensionInfo($).storeDimIndex;
    }), t2.encodeFirstDimNotExtra = N3;
    var z3 = h.label;
    z3 && z3.length && (_ = z3.slice());
    var H2 = h.tooltip;
    return H2 && H2.length ? M2 = H2.slice() : M2.length || (M2 = _.slice()), h.defaultedLabel = _, h.defaultedTooltip = M2, t2.userOutput = new Fgr(I2, i), t2;
  }
  function OXt(f2, i) {
    return f2.hasOwnProperty(i) || (f2[i] = []), f2[i];
  }
  function EEt(f2) {
    return f2 === "category" ? "ordinal" : f2 === "time" ? "time" : "float";
  }
  function Bgr(f2) {
    return !(f2 === "ordinal" || f2 === "time");
  }
  var zgr = function() {
    function f2(i) {
      this.otherDims = {}, i != null && ba2(this, i);
    }
    return f2;
  }(), QDt = zgr, jgr = Wh2(), Wgr = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, vGe = function() {
    function f2(i) {
      this.dimensions = i.dimensions, this._dimOmitted = i.dimensionOmitted, this.source = i.source, this._fullDimCount = i.fullDimensionCount, this._updateDimOmitted(i.dimensionOmitted);
    }
    return f2.prototype.isDimensionOmitted = function() {
      return this._dimOmitted;
    }, f2.prototype._updateDimOmitted = function(i) {
      this._dimOmitted = i, i && (this._dimNameMap || (this._dimNameMap = bGe(this.source)));
    }, f2.prototype.getSourceDimensionIndex = function(i) {
      return _c2(this._dimNameMap.get(i), -1);
    }, f2.prototype.getSourceDimension = function(i) {
      var t2 = this.source.dimensionsDefine;
      if (t2)
        return t2[i];
    }, f2.prototype.makeStoreSchema = function() {
      for (var i = this._fullDimCount, t2 = mWe(this.source), h = !_Ge(i), v4 = "", _ = [], M2 = 0, I2 = 0; M2 < i; M2++) {
        var P2 = void 0, N3 = void 0, z3 = void 0, H2 = this.dimensions[I2];
        if (H2 && H2.storeDimIndex === M2)
          P2 = t2 ? H2.name : null, N3 = H2.type, z3 = H2.ordinalMeta, I2++;
        else {
          var $ = this.getSourceDimension(M2);
          $ && (P2 = t2 ? $.name : null, N3 = $.type);
        }
        _.push({ property: P2, type: N3, ordinalMeta: z3 }), t2 && P2 != null && (!H2 || !H2.isCalculationCoord) && (v4 += h ? P2.replace(/\`/g, "`1").replace(/\$/g, "`2") : P2), v4 += "$", v4 += Wgr[N3] || "f", z3 && (v4 += z3.uid), v4 += "$";
      }
      var et = this.source, at = [et.seriesLayoutBy, et.startIndex, v4].join("$$");
      return { dimensions: _, hash: at };
    }, f2.prototype.makeOutputDimensionNames = function() {
      for (var i = [], t2 = 0, h = 0; t2 < this._fullDimCount; t2++) {
        var v4 = void 0, _ = this.dimensions[h];
        if (_ && _.storeDimIndex === t2)
          _.isCalculationCoord || (v4 = _.name), h++;
        else {
          var M2 = this.getSourceDimension(t2);
          M2 && (v4 = M2.name);
        }
        i.push(v4);
      }
      return i;
    }, f2.prototype.appendCalculationDimension = function(i) {
      this.dimensions.push(i), i.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
    }, f2;
  }();
  function yGe(f2) {
    return f2 instanceof vGe;
  }
  function mGe(f2) {
    for (var i = Il(), t2 = 0; t2 < (f2 || []).length; t2++) {
      var h = f2[t2], v4 = Xl(h) ? h.name : h;
      v4 != null && i.get(v4) == null && i.set(v4, t2);
    }
    return i;
  }
  function bGe(f2) {
    var i = jgr(f2);
    return i.dimNameMap || (i.dimNameMap = mGe(f2.dimensionsDefine));
  }
  function _Ge(f2) {
    return f2 > 30;
  }
  var Xpt = Xl, A7 = Xa2, Ggr = typeof Int32Array == "undefined" ? Array : Int32Array, Hgr = "e\0\0", jFe = -1, Ugr = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], qgr = ["_approximateExtent"], WFe, nDt, Qpt, Jpt, RXt, rDt, NXt, Zgr = function() {
    function f2(i, t2) {
      this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
      var h, v4 = false;
      yGe(i) ? (h = i.dimensions, this._dimOmitted = i.isDimensionOmitted(), this._schema = i) : (v4 = true, h = i), h = h || ["x", "y"];
      for (var _ = {}, M2 = [], I2 = {}, P2 = false, N3 = {}, z3 = 0; z3 < h.length; z3++) {
        var H2 = h[z3], $ = ms(H2) ? new QDt({ name: H2 }) : H2 instanceof QDt ? H2 : new QDt(H2), et = $.name;
        $.type = $.type || "float", $.coordDim || ($.coordDim = et, $.coordDimIndex = 0);
        var at = $.otherDims = $.otherDims || {};
        M2.push(et), _[et] = $, N3[et] != null && (P2 = true), $.createInvertedIndices && (I2[et] = []), at.itemName === 0 && (this._nameDimIdx = z3), at.itemId === 0 && (this._idDimIdx = z3), v4 && ($.storeDimIndex = z3);
      }
      if (this.dimensions = M2, this._dimInfos = _, this._initGetDimensionInfo(P2), this.hostModel = t2, this._invertedIndicesMap = I2, this._dimOmitted) {
        var ht = this._dimIdxToName = Il();
        Qe2(M2, function(bt) {
          ht.set(_[bt].storeDimIndex, bt);
        });
      }
    }
    return f2.prototype.getDimension = function(i) {
      var t2 = this._recognizeDimIndex(i);
      if (t2 == null)
        return i;
      if (t2 = i, !this._dimOmitted)
        return this.dimensions[t2];
      var h = this._dimIdxToName.get(t2);
      if (h != null)
        return h;
      var v4 = this._schema.getSourceDimension(t2);
      if (v4)
        return v4.name;
    }, f2.prototype.getDimensionIndex = function(i) {
      var t2 = this._recognizeDimIndex(i);
      if (t2 != null)
        return t2;
      if (i == null)
        return -1;
      var h = this._getDimInfo(i);
      return h ? h.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(i) : -1;
    }, f2.prototype._recognizeDimIndex = function(i) {
      if (vp(i) || i != null && !isNaN(i) && !this._getDimInfo(i) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(i) < 0))
        return +i;
    }, f2.prototype._getStoreDimIndex = function(i) {
      var t2 = this.getDimensionIndex(i);
      return t2;
    }, f2.prototype.getDimensionInfo = function(i) {
      return this._getDimInfo(this.getDimension(i));
    }, f2.prototype._initGetDimensionInfo = function(i) {
      var t2 = this._dimInfos;
      this._getDimInfo = i ? function(h) {
        return t2.hasOwnProperty(h) ? t2[h] : void 0;
      } : function(h) {
        return t2[h];
      };
    }, f2.prototype.getDimensionsOnCoord = function() {
      return this._dimSummary.dataDimsOnCoord.slice();
    }, f2.prototype.mapDimension = function(i, t2) {
      var h = this._dimSummary;
      if (t2 == null)
        return h.encodeFirstDimNotExtra[i];
      var v4 = h.encode[i];
      return v4 ? v4[t2] : null;
    }, f2.prototype.mapDimensionsAll = function(i) {
      var t2 = this._dimSummary, h = t2.encode[i];
      return (h || []).slice();
    }, f2.prototype.getStore = function() {
      return this._store;
    }, f2.prototype.initData = function(i, t2, h) {
      var v4 = this, _;
      if (i instanceof QJt && (_ = i), !_) {
        var M2 = this.dimensions, I2 = Jee(i) || xS(i) ? new bWe(i, M2.length) : i;
        _ = new QJt();
        var P2 = A7(M2, function(N3) {
          return { type: v4._dimInfos[N3].type, property: N3 };
        });
        _.initData(I2, P2, h);
      }
      this._store = _, this._nameList = (t2 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, _.count()), this._dimSummary = Vgr(this, this._schema), this.userOutput = this._dimSummary.userOutput;
    }, f2.prototype.appendData = function(i) {
      var t2 = this._store.appendData(i);
      this._doInit(t2[0], t2[1]);
    }, f2.prototype.appendValues = function(i, t2) {
      var h = this._store.appendValues(i, t2.length), v4 = h.start, _ = h.end, M2 = this._shouldMakeIdFromName();
      if (this._updateOrdinalMeta(), t2)
        for (var I2 = v4; I2 < _; I2++) {
          var P2 = I2 - v4;
          this._nameList[I2] = t2[P2], M2 && NXt(this, I2);
        }
    }, f2.prototype._updateOrdinalMeta = function() {
      for (var i = this._store, t2 = this.dimensions, h = 0; h < t2.length; h++) {
        var v4 = this._dimInfos[t2[h]];
        v4.ordinalMeta && i.collectOrdinalMeta(v4.storeDimIndex, v4.ordinalMeta);
      }
    }, f2.prototype._shouldMakeIdFromName = function() {
      var i = this._store.getProvider();
      return this._idDimIdx == null && i.getSource().sourceFormat !== Z7 && !i.fillStorage;
    }, f2.prototype._doInit = function(i, t2) {
      if (!(i >= t2)) {
        var h = this._store, v4 = h.getProvider();
        this._updateOrdinalMeta();
        var _ = this._nameList, M2 = this._idList, I2 = v4.getSource().sourceFormat, P2 = I2 === aE;
        if (P2 && !v4.pure)
          for (var N3 = [], z3 = i; z3 < t2; z3++) {
            var H2 = v4.getItem(z3, N3);
            if (!this.hasItemOption && acr(H2) && (this.hasItemOption = true), H2) {
              var $ = H2.name;
              _[z3] == null && $ != null && (_[z3] = l1($, null));
              var et = H2.id;
              M2[z3] == null && et != null && (M2[z3] = l1(et, null));
            }
          }
        if (this._shouldMakeIdFromName())
          for (var z3 = i; z3 < t2; z3++)
            NXt(this, z3);
        WFe(this);
      }
    }, f2.prototype.getApproximateExtent = function(i) {
      return this._approximateExtent[i] || this._store.getDataExtent(this._getStoreDimIndex(i));
    }, f2.prototype.setApproximateExtent = function(i, t2) {
      t2 = this.getDimension(t2), this._approximateExtent[t2] = i.slice();
    }, f2.prototype.getCalculationInfo = function(i) {
      return this._calculationInfo[i];
    }, f2.prototype.setCalculationInfo = function(i, t2) {
      Xpt(i) ? ba2(this._calculationInfo, i) : this._calculationInfo[i] = t2;
    }, f2.prototype.getName = function(i) {
      var t2 = this.getRawIndex(i), h = this._nameList[t2];
      return h == null && this._nameDimIdx != null && (h = Qpt(this, this._nameDimIdx, t2)), h == null && (h = ""), h;
    }, f2.prototype._getCategory = function(i, t2) {
      var h = this._store.get(i, t2), v4 = this._store.getOrdinalMeta(i);
      return v4 ? v4.categories[h] : h;
    }, f2.prototype.getId = function(i) {
      return nDt(this, this.getRawIndex(i));
    }, f2.prototype.count = function() {
      return this._store.count();
    }, f2.prototype.get = function(i, t2) {
      var h = this._store, v4 = this._dimInfos[i];
      if (v4)
        return h.get(v4.storeDimIndex, t2);
    }, f2.prototype.getByRawIndex = function(i, t2) {
      var h = this._store, v4 = this._dimInfos[i];
      if (v4)
        return h.getByRawIndex(v4.storeDimIndex, t2);
    }, f2.prototype.getIndices = function() {
      return this._store.getIndices();
    }, f2.prototype.getDataExtent = function(i) {
      return this._store.getDataExtent(this._getStoreDimIndex(i));
    }, f2.prototype.getSum = function(i) {
      return this._store.getSum(this._getStoreDimIndex(i));
    }, f2.prototype.getMedian = function(i) {
      return this._store.getMedian(this._getStoreDimIndex(i));
    }, f2.prototype.getValues = function(i, t2) {
      var h = this, v4 = this._store;
      return Za2(i) ? v4.getValues(A7(i, function(_) {
        return h._getStoreDimIndex(_);
      }), t2) : v4.getValues(i);
    }, f2.prototype.hasValue = function(i) {
      for (var t2 = this._dimSummary.dataDimIndicesOnCoord, h = 0, v4 = t2.length; h < v4; h++)
        if (isNaN(this._store.get(t2[h], i)))
          return false;
      return true;
    }, f2.prototype.indexOfName = function(i) {
      for (var t2 = 0, h = this._store.count(); t2 < h; t2++)
        if (this.getName(t2) === i)
          return t2;
      return -1;
    }, f2.prototype.getRawIndex = function(i) {
      return this._store.getRawIndex(i);
    }, f2.prototype.indexOfRawIndex = function(i) {
      return this._store.indexOfRawIndex(i);
    }, f2.prototype.rawIndexOf = function(i, t2) {
      var h = i && this._invertedIndicesMap[i], v4 = h[t2];
      return v4 == null || isNaN(v4) ? jFe : v4;
    }, f2.prototype.indicesOfNearest = function(i, t2, h) {
      return this._store.indicesOfNearest(this._getStoreDimIndex(i), t2, h);
    }, f2.prototype.each = function(i, t2, h) {
      Ol(i) && (h = t2, t2 = i, i = []);
      var v4 = h || this, _ = A7(Jpt(i), this._getStoreDimIndex, this);
      this._store.each(_, v4 ? ks(t2, v4) : t2);
    }, f2.prototype.filterSelf = function(i, t2, h) {
      Ol(i) && (h = t2, t2 = i, i = []);
      var v4 = h || this, _ = A7(Jpt(i), this._getStoreDimIndex, this);
      return this._store = this._store.filter(_, v4 ? ks(t2, v4) : t2), this;
    }, f2.prototype.selectRange = function(i) {
      var t2 = this, h = {}, v4 = Of2(i);
      return Qe2(v4, function(_) {
        var M2 = t2._getStoreDimIndex(_);
        h[M2] = i[_];
      }), this._store = this._store.selectRange(h), this;
    }, f2.prototype.mapArray = function(i, t2, h) {
      Ol(i) && (h = t2, t2 = i, i = []), h = h || this;
      var v4 = [];
      return this.each(i, function() {
        v4.push(t2 && t2.apply(this, arguments));
      }, h), v4;
    }, f2.prototype.map = function(i, t2, h, v4) {
      var _ = h || v4 || this, M2 = A7(Jpt(i), this._getStoreDimIndex, this), I2 = rDt(this);
      return I2._store = this._store.map(M2, _ ? ks(t2, _) : t2), I2;
    }, f2.prototype.modify = function(i, t2, h, v4) {
      var _ = h || v4 || this, M2 = A7(Jpt(i), this._getStoreDimIndex, this);
      this._store.modify(M2, _ ? ks(t2, _) : t2);
    }, f2.prototype.downSample = function(i, t2, h, v4) {
      var _ = rDt(this);
      return _._store = this._store.downSample(this._getStoreDimIndex(i), t2, h, v4), _;
    }, f2.prototype.lttbDownSample = function(i, t2) {
      var h = rDt(this);
      return h._store = this._store.lttbDownSample(this._getStoreDimIndex(i), t2), h;
    }, f2.prototype.getRawDataItem = function(i) {
      return this._store.getRawDataItem(i);
    }, f2.prototype.getItemModel = function(i) {
      var t2 = this.hostModel, h = this.getRawDataItem(i);
      return new Gg2(h, t2, t2 && t2.ecModel);
    }, f2.prototype.diff = function(i) {
      var t2 = this;
      return new eN(i ? i.getStore().getIndices() : [], this.getStore().getIndices(), function(h) {
        return nDt(i, h);
      }, function(h) {
        return nDt(t2, h);
      });
    }, f2.prototype.getVisual = function(i) {
      var t2 = this._visual;
      return t2 && t2[i];
    }, f2.prototype.setVisual = function(i, t2) {
      this._visual = this._visual || {}, Xpt(i) ? ba2(this._visual, i) : this._visual[i] = t2;
    }, f2.prototype.getItemVisual = function(i, t2) {
      var h = this._itemVisuals[i], v4 = h && h[t2];
      return v4 == null ? this.getVisual(t2) : v4;
    }, f2.prototype.hasItemVisual = function() {
      return this._itemVisuals.length > 0;
    }, f2.prototype.ensureUniqueItemVisual = function(i, t2) {
      var h = this._itemVisuals, v4 = h[i];
      v4 || (v4 = h[i] = {});
      var _ = v4[t2];
      return _ == null && (_ = this.getVisual(t2), Za2(_) ? _ = _.slice() : Xpt(_) && (_ = ba2({}, _)), v4[t2] = _), _;
    }, f2.prototype.setItemVisual = function(i, t2, h) {
      var v4 = this._itemVisuals[i] || {};
      this._itemVisuals[i] = v4, Xpt(t2) ? ba2(v4, t2) : v4[t2] = h;
    }, f2.prototype.clearAllVisual = function() {
      this._visual = {}, this._itemVisuals = [];
    }, f2.prototype.setLayout = function(i, t2) {
      Xpt(i) ? ba2(this._layout, i) : this._layout[i] = t2;
    }, f2.prototype.getLayout = function(i) {
      return this._layout[i];
    }, f2.prototype.getItemLayout = function(i) {
      return this._itemLayouts[i];
    }, f2.prototype.setItemLayout = function(i, t2, h) {
      this._itemLayouts[i] = h ? ba2(this._itemLayouts[i] || {}, t2) : t2;
    }, f2.prototype.clearItemLayouts = function() {
      this._itemLayouts.length = 0;
    }, f2.prototype.setItemGraphicEl = function(i, t2) {
      var h = this.hostModel && this.hostModel.seriesIndex;
      BJt(h, this.dataType, i, t2), this._graphicEls[i] = t2;
    }, f2.prototype.getItemGraphicEl = function(i) {
      return this._graphicEls[i];
    }, f2.prototype.eachItemGraphicEl = function(i, t2) {
      Qe2(this._graphicEls, function(h, v4) {
        h && i && i.call(t2, h, v4);
      });
    }, f2.prototype.cloneShallow = function(i) {
      return i || (i = new f2(this._schema ? this._schema : A7(this.dimensions, this._getDimInfo, this), this.hostModel)), RXt(i, this), i._store = this._store, i;
    }, f2.prototype.wrapMethod = function(i, t2) {
      var h = this[i];
      !Ol(h) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(i), this[i] = function() {
        var v4 = h.apply(this, arguments);
        return t2.apply(this, [v4].concat(xee(arguments)));
      });
    }, f2.internalField = function() {
      WFe = function(i) {
        var t2 = i._invertedIndicesMap;
        Qe2(t2, function(h, v4) {
          var _ = i._dimInfos[v4], M2 = _.ordinalMeta, I2 = i._store;
          if (M2) {
            h = t2[v4] = new Ggr(M2.categories.length);
            for (var P2 = 0; P2 < h.length; P2++)
              h[P2] = jFe;
            for (var P2 = 0; P2 < I2.count(); P2++)
              h[I2.get(_.storeDimIndex, P2)] = P2;
          }
        });
      }, Qpt = function(i, t2, h) {
        return l1(i._getCategory(t2, h), null);
      }, nDt = function(i, t2) {
        var h = i._idList[t2];
        return h == null && i._idDimIdx != null && (h = Qpt(i, i._idDimIdx, t2)), h == null && (h = Hgr + t2), h;
      }, Jpt = function(i) {
        return Za2(i) || (i = i != null ? [i] : []), i;
      }, rDt = function(i) {
        var t2 = new f2(i._schema ? i._schema : A7(i.dimensions, i._getDimInfo, i), i.hostModel);
        return RXt(t2, i), t2;
      }, RXt = function(i, t2) {
        Qe2(Ugr.concat(t2.__wrappedMethods || []), function(h) {
          t2.hasOwnProperty(h) && (i[h] = t2[h]);
        }), i.__wrappedMethods = t2.__wrappedMethods, Qe2(qgr, function(h) {
          i[h] = pu(t2[h]);
        }), i._calculationInfo = ba2({}, t2._calculationInfo);
      }, NXt = function(i, t2) {
        var h = i._nameList, v4 = i._idList, _ = i._nameDimIdx, M2 = i._idDimIdx, I2 = h[t2], P2 = v4[t2];
        if (I2 == null && _ != null && (h[t2] = I2 = Qpt(i, _, t2)), P2 == null && M2 != null && (v4[t2] = P2 = Qpt(i, M2, t2)), P2 == null && I2 != null) {
          var N3 = i._nameRepeatCount, z3 = N3[I2] = (N3[I2] || 0) + 1;
          P2 = I2, z3 > 1 && (P2 += "__ec__" + z3), v4[t2] = P2;
        }
      };
    }(), f2;
  }(), B2 = Zgr;
  function Rgt(f2, i) {
    Jee(f2) || (f2 = tne(f2)), i = i || {};
    var t2 = i.coordDimensions || [], h = i.dimensionsDefine || f2.dimensionsDefine || [], v4 = Il(), _ = [], M2 = Ygr(f2, t2, h, i.dimensionsCount), I2 = i.canOmitUnusedDimensions && _Ge(M2), P2 = h === f2.dimensionsDefine, N3 = P2 ? bGe(f2) : mGe(h), z3 = i.encodeDefine;
    !z3 && i.encodeDefaulter && (z3 = i.encodeDefaulter(f2, M2));
    for (var H2 = Il(z3), $ = new AWe(M2), et = 0; et < $.length; et++)
      $[et] = -1;
    function at(be2) {
      var Te2 = $[be2];
      if (Te2 < 0) {
        var We = h[be2], en = Xl(We) ? We : { name: We }, Ue2 = new QDt(), Mn = en.name;
        Mn != null && N3.get(Mn) != null && (Ue2.name = Ue2.displayName = Mn), en.type != null && (Ue2.type = en.type), en.displayName != null && (Ue2.displayName = en.displayName);
        var Vn = _.length;
        return $[be2] = Vn, Ue2.storeDimIndex = be2, _.push(Ue2), Ue2;
      }
      return _[Te2];
    }
    if (!I2)
      for (var et = 0; et < M2; et++)
        at(et);
    H2.each(function(be2, Te2) {
      var We = Od2(be2).slice();
      if (We.length === 1 && !ms(We[0]) && We[0] < 0) {
        H2.set(Te2, false);
        return;
      }
      var en = H2.set(Te2, []);
      Qe2(We, function(Ue2, Mn) {
        var Vn = ms(Ue2) ? N3.get(Ue2) : Ue2;
        Vn != null && Vn < M2 && (en[Mn] = Vn, bt(at(Vn), Te2, Mn));
      });
    });
    var ht = 0;
    Qe2(t2, function(be2) {
      var Te2, We, en, Ue2;
      if (ms(be2))
        Te2 = be2, Ue2 = {};
      else {
        Ue2 = be2, Te2 = Ue2.name;
        var Mn = Ue2.ordinalMeta;
        Ue2.ordinalMeta = null, Ue2 = ba2({}, Ue2), Ue2.ordinalMeta = Mn, We = Ue2.dimsDef, en = Ue2.otherDims, Ue2.name = Ue2.coordDim = Ue2.coordDimIndex = Ue2.dimsDef = Ue2.otherDims = null;
      }
      var Vn = H2.get(Te2);
      if (Vn !== false) {
        if (Vn = Od2(Vn), !Vn.length)
          for (var xn = 0; xn < (We && We.length || 1); xn++) {
            for (; ht < M2 && at(ht).coordDim != null; )
              ht++;
            ht < M2 && Vn.push(ht++);
          }
        Qe2(Vn, function(Zr, nr) {
          var pr = at(Zr);
          if (P2 && Ue2.type != null && (pr.type = Ue2.type), bt(Ul(pr, Ue2), Te2, nr), pr.name == null && We) {
            var Nr = We[nr];
            !Xl(Nr) && (Nr = { name: Nr }), pr.name = pr.displayName = Nr.name, pr.defaultTooltip = Nr.defaultTooltip;
          }
          en && Ul(pr.otherDims, en);
        });
      }
    });
    function bt(be2, Te2, We) {
      aWe.get(Te2) != null ? be2.otherDims[Te2] = We : (be2.coordDim = Te2, be2.coordDimIndex = We, v4.set(Te2, true));
    }
    var _t = i.generateCoord, Et = i.generateCoordCount, zt = Et != null;
    Et = _t ? Et || 1 : 0;
    var Ft = _t || "value";
    function fe2(be2) {
      be2.name == null && (be2.name = be2.coordDim);
    }
    if (I2)
      Qe2(_, function(be2) {
        fe2(be2);
      }), _.sort(function(be2, Te2) {
        return be2.storeDimIndex - Te2.storeDimIndex;
      });
    else
      for (var re2 = 0; re2 < M2; re2++) {
        var ye = at(re2), me2 = ye.coordDim;
        me2 == null && (ye.coordDim = Kgr(Ft, v4, zt), ye.coordDimIndex = 0, (!_t || Et <= 0) && (ye.isExtraCoord = true), Et--), fe2(ye), ye.type == null && (uWe(f2, re2) === jx.Must || ye.isExtraCoord && (ye.otherDims.itemName != null || ye.otherDims.seriesName != null)) && (ye.type = "ordinal");
      }
    return $gr(_), new vGe({ source: f2, dimensions: _, fullDimensionCount: M2, dimensionOmitted: I2 });
  }
  function $gr(f2) {
    for (var i = Il(), t2 = 0; t2 < f2.length; t2++) {
      var h = f2[t2], v4 = h.name, _ = i.get(v4) || 0;
      _ > 0 && (h.name = v4 + (_ - 1)), _++, i.set(v4, _);
    }
  }
  function Ygr(f2, i, t2, h) {
    var v4 = Math.max(f2.dimensionsDetectedCount || 1, i.length, t2.length, h || 0);
    return Qe2(i, function(_) {
      var M2;
      Xl(_) && (M2 = _.dimsDef) && (v4 = Math.max(v4, M2.length));
    }), v4;
  }
  function Kgr(f2, i, t2) {
    var h = i.data;
    if (t2 || h.hasOwnProperty(f2)) {
      for (var v4 = 0; h.hasOwnProperty(f2 + v4); )
        v4++;
      f2 += v4;
    }
    return i.set(f2, true), f2;
  }
  var Xgr = function() {
    function f2(i) {
      this.coordSysDims = [], this.axisMap = Il(), this.categoryAxisMap = Il(), this.coordSysName = i;
    }
    return f2;
  }();
  function Qgr(f2) {
    var i = f2.get("coordinateSystem"), t2 = new Xgr(i), h = Jgr[i];
    if (h)
      return h(f2, t2, t2.axisMap, t2.categoryAxisMap), t2;
  }
  var Jgr = { cartesian2d: function(f2, i, t2, h) {
    var v4 = f2.getReferringComponents("xAxis", _m).models[0], _ = f2.getReferringComponents("yAxis", _m).models[0];
    i.coordSysDims = ["x", "y"], t2.set("x", v4), t2.set("y", _), utt(v4) && (h.set("x", v4), i.firstCategoryDimIndex = 0), utt(_) && (h.set("y", _), i.firstCategoryDimIndex == null && (i.firstCategoryDimIndex = 1));
  }, singleAxis: function(f2, i, t2, h) {
    var v4 = f2.getReferringComponents("singleAxis", _m).models[0];
    i.coordSysDims = ["single"], t2.set("single", v4), utt(v4) && (h.set("single", v4), i.firstCategoryDimIndex = 0);
  }, polar: function(f2, i, t2, h) {
    var v4 = f2.getReferringComponents("polar", _m).models[0], _ = v4.findAxisModel("radiusAxis"), M2 = v4.findAxisModel("angleAxis");
    i.coordSysDims = ["radius", "angle"], t2.set("radius", _), t2.set("angle", M2), utt(_) && (h.set("radius", _), i.firstCategoryDimIndex = 0), utt(M2) && (h.set("angle", M2), i.firstCategoryDimIndex == null && (i.firstCategoryDimIndex = 1));
  }, geo: function(f2, i, t2, h) {
    i.coordSysDims = ["lng", "lat"];
  }, parallel: function(f2, i, t2, h) {
    var v4 = f2.ecModel, _ = v4.getComponent("parallel", f2.get("parallelIndex")), M2 = i.coordSysDims = _.dimensions.slice();
    Qe2(_.parallelAxisIndex, function(I2, P2) {
      var N3 = v4.getComponent("parallelAxis", I2), z3 = M2[P2];
      t2.set(z3, N3), utt(N3) && (h.set(z3, N3), i.firstCategoryDimIndex == null && (i.firstCategoryDimIndex = P2));
    });
  } };
  function utt(f2) {
    return f2.get("type") === "category";
  }
  function tvr(f2, i, t2) {
    t2 = t2 || {};
    var h = t2.byIndex, v4 = t2.stackedCoordDimension, _, M2, I2;
    evr(i) ? _ = i : (M2 = i.schema, _ = M2.dimensions, I2 = i.store);
    var P2 = !!(f2 && f2.get("stack")), N3, z3, H2, $;
    if (Qe2(_, function(Et, zt) {
      ms(Et) && (_[zt] = Et = { name: Et }), P2 && !Et.isExtraCoord && (!h && !N3 && Et.ordinalMeta && (N3 = Et), !z3 && Et.type !== "ordinal" && Et.type !== "time" && (!v4 || v4 === Et.coordDim) && (z3 = Et));
    }), z3 && !h && !N3 && (h = true), z3) {
      H2 = "__\0ecstackresult_" + f2.id, $ = "__\0ecstackedover_" + f2.id, N3 && (N3.createInvertedIndices = true);
      var et = z3.coordDim, at = z3.type, ht = 0;
      Qe2(_, function(Et) {
        Et.coordDim === et && ht++;
      });
      var bt = { name: H2, coordDim: et, coordDimIndex: ht, type: at, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: _.length }, _t = { name: $, coordDim: $, coordDimIndex: ht + 1, type: at, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: _.length + 1 };
      M2 ? (I2 && (bt.storeDimIndex = I2.ensureCalculationDimension($, at), _t.storeDimIndex = I2.ensureCalculationDimension(H2, at)), M2.appendCalculationDimension(bt), M2.appendCalculationDimension(_t)) : (_.push(bt), _.push(_t));
    }
    return { stackedDimension: z3 && z3.name, stackedByDimension: N3 && N3.name, isStackedByIndex: h, stackedOverDimension: $, stackResultDimension: H2 };
  }
  function evr(f2) {
    return !yGe(f2.schema);
  }
  function tV(f2, i) {
    return !!i && i === f2.getCalculationInfo("stackedDimension");
  }
  function xGe(f2, i) {
    return tV(f2, i) ? f2.getCalculationInfo("stackResultDimension") : i;
  }
  function nvr(f2, i) {
    var t2 = f2.get("coordinateSystem"), h = Pgt.get(t2), v4;
    return i && i.coordSysDims && (v4 = Xa2(i.coordSysDims, function(_) {
      var M2 = { name: _ }, I2 = i.axisMap.get(_);
      if (I2) {
        var P2 = I2.get("type");
        M2.type = EEt(P2);
      }
      return M2;
    })), v4 || (v4 = h && (h.getDimensionsInfo ? h.getDimensionsInfo() : h.dimensions.slice()) || ["x", "y"]), v4;
  }
  function rvr(f2, i, t2) {
    var h, v4;
    return t2 && Qe2(f2, function(_, M2) {
      var I2 = _.coordDim, P2 = t2.categoryAxisMap.get(I2);
      P2 && (h == null && (h = M2), _.ordinalMeta = P2.getOrdinalMeta(), i && (_.createInvertedIndices = true)), _.otherDims.itemName != null && (v4 = true);
    }), !v4 && h != null && (f2[h].otherDims.itemName = 0), h;
  }
  function aN(f2, i, t2) {
    t2 = t2 || {};
    var h = i.getSourceManager(), v4, _ = false;
    f2 ? (_ = true, v4 = tne(f2)) : (v4 = h.getSource(), _ = v4.sourceFormat === aE);
    var M2 = Qgr(i), I2 = nvr(i, M2), P2 = t2.useEncodeDefaulter, N3 = Ol(P2) ? P2 : P2 ? Ou(lWe, I2, i) : null, z3 = { coordDimensions: I2, generateCoord: t2.generateCoord, encodeDefine: i.getEncode(), encodeDefaulter: N3, canOmitUnusedDimensions: !_ }, H2 = Rgt(v4, z3), $ = rvr(H2.dimensions, t2.createInvertedIndices, M2), et = _ ? null : h.getSharedDataStore(H2), at = tvr(i, { schema: H2, store: et }), ht = new B2(H2, i);
    ht.setCalculationInfo(at);
    var bt = $ != null && ivr(v4) ? function(_t, Et, zt, Ft) {
      return Ft === $ ? zt : this.defaultDimValueGetter(_t, Et, zt, Ft);
    } : null;
    return ht.hasItemOption = false, ht.initData(_ ? v4 : et, null, bt), ht;
  }
  function ivr(f2) {
    if (f2.sourceFormat === aE) {
      var i = avr(f2.data || []);
      return !Za2(Qtt(i));
    }
  }
  function avr(f2) {
    for (var i = 0; i < f2.length && f2[i] == null; )
      i++;
    return f2[i];
  }
  var wGe = function() {
    function f2(i) {
      this._setting = i || {}, this._extent = [1 / 0, -1 / 0];
    }
    return f2.prototype.getSetting = function(i) {
      return this._setting[i];
    }, f2.prototype.unionExtent = function(i) {
      var t2 = this._extent;
      i[0] < t2[0] && (t2[0] = i[0]), i[1] > t2[1] && (t2[1] = i[1]);
    }, f2.prototype.unionExtentFromData = function(i, t2) {
      this.unionExtent(i.getApproximateExtent(t2));
    }, f2.prototype.getExtent = function() {
      return this._extent.slice();
    }, f2.prototype.setExtent = function(i, t2) {
      var h = this._extent;
      isNaN(i) || (h[0] = i), isNaN(t2) || (h[1] = t2);
    }, f2.prototype.isInExtentRange = function(i) {
      return this._extent[0] <= i && this._extent[1] >= i;
    }, f2.prototype.isBlank = function() {
      return this._isBlank;
    }, f2.prototype.setBlank = function(i) {
      this._isBlank = i;
    }, f2;
  }();
  fkt(wGe);
  var oN = wGe, ovr = 0, svr = function() {
    function f2(i) {
      this.categories = i.categories || [], this._needCollect = i.needCollect, this._deduplication = i.deduplication, this.uid = ++ovr;
    }
    return f2.createByAxisModel = function(i) {
      var t2 = i.option, h = t2.data, v4 = h && Xa2(h, lvr);
      return new f2({ categories: v4, needCollect: !v4, deduplication: t2.dedplication !== false });
    }, f2.prototype.getOrdinal = function(i) {
      return this._getOrCreateMap().get(i);
    }, f2.prototype.parseAndCollect = function(i) {
      var t2, h = this._needCollect;
      if (!ms(i) && !h)
        return i;
      if (h && !this._deduplication)
        return t2 = this.categories.length, this.categories[t2] = i, t2;
      var v4 = this._getOrCreateMap();
      return t2 = v4.get(i), t2 == null && (h ? (t2 = this.categories.length, this.categories[t2] = i, v4.set(i, t2)) : t2 = NaN), t2;
    }, f2.prototype._getOrCreateMap = function() {
      return this._map || (this._map = Il(this.categories));
    }, f2;
  }();
  function lvr(f2) {
    return Xl(f2) && f2.value != null ? f2.value : f2 + "";
  }
  var lte = svr;
  function ute(f2) {
    return f2.type === "interval" || f2.type === "log";
  }
  function uvr(f2, i, t2, h) {
    var v4 = {}, _ = f2[1] - f2[0], M2 = v4.interval = Pze(_ / i, true);
    t2 != null && M2 < t2 && (M2 = v4.interval = t2), h != null && M2 > h && (M2 = v4.interval = h);
    var I2 = v4.intervalPrecision = SGe(M2), P2 = v4.niceTickExtent = [gy(Math.ceil(f2[0] / M2) * M2, I2), gy(Math.floor(f2[1] / M2) * M2, I2)];
    return cvr(P2, f2), v4;
  }
  function FXt(f2) {
    var i = Math.pow(10, Dee(f2)), t2 = f2 / i;
    return t2 ? t2 === 2 ? t2 = 3 : t2 === 3 ? t2 = 5 : t2 *= 2 : t2 = 1, gy(t2 * i);
  }
  function SGe(f2) {
    return PL(f2) + 2;
  }
  function GFe(f2, i, t2) {
    f2[i] = Math.max(Math.min(f2[i], t2[1]), t2[0]);
  }
  function cvr(f2, i) {
    !isFinite(f2[0]) && (f2[0] = i[0]), !isFinite(f2[1]) && (f2[1] = i[1]), GFe(f2, 0, i), GFe(f2, 1, i), f2[0] > f2[1] && (f2[0] = f2[1]);
  }
  function Pkt(f2, i) {
    return f2 >= i[0] && f2 <= i[1];
  }
  function Lkt(f2, i) {
    return i[1] === i[0] ? 0.5 : (f2 - i[0]) / (i[1] - i[0]);
  }
  function Okt(f2, i) {
    return f2 * (i[1] - i[0]) + i[0];
  }
  var MGe = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      h.type = "ordinal";
      var v4 = h.getSetting("ordinalMeta");
      return v4 || (v4 = new lte({})), Za2(v4) && (v4 = new lte({ categories: Xa2(v4, function(_) {
        return Xl(_) ? _.value : _;
      }) })), h._ordinalMeta = v4, h._extent = h.getSetting("extent") || [0, v4.categories.length - 1], h;
    }
    return i.prototype.parse = function(t2) {
      return ms(t2) ? this._ordinalMeta.getOrdinal(t2) : Math.round(t2);
    }, i.prototype.contain = function(t2) {
      return t2 = this.parse(t2), Pkt(t2, this._extent) && this._ordinalMeta.categories[t2] != null;
    }, i.prototype.normalize = function(t2) {
      return t2 = this._getTickNumber(this.parse(t2)), Lkt(t2, this._extent);
    }, i.prototype.scale = function(t2) {
      return t2 = Math.round(Okt(t2, this._extent)), this.getRawOrdinalNumber(t2);
    }, i.prototype.getTicks = function() {
      for (var t2 = [], h = this._extent, v4 = h[0]; v4 <= h[1]; )
        t2.push({ value: v4 }), v4++;
      return t2;
    }, i.prototype.getMinorTicks = function(t2) {
    }, i.prototype.setSortInfo = function(t2) {
      if (t2 == null) {
        this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
        return;
      }
      for (var h = t2.ordinalNumbers, v4 = this._ordinalNumbersByTick = [], _ = this._ticksByOrdinalNumber = [], M2 = 0, I2 = this._ordinalMeta.categories.length, P2 = Math.min(I2, h.length); M2 < P2; ++M2) {
        var N3 = h[M2];
        v4[M2] = N3, _[N3] = M2;
      }
      for (var z3 = 0; M2 < I2; ++M2) {
        for (; _[z3] != null; )
          z3++;
        v4.push(z3), _[z3] = M2;
      }
    }, i.prototype._getTickNumber = function(t2) {
      var h = this._ticksByOrdinalNumber;
      return h && t2 >= 0 && t2 < h.length ? h[t2] : t2;
    }, i.prototype.getRawOrdinalNumber = function(t2) {
      var h = this._ordinalNumbersByTick;
      return h && t2 >= 0 && t2 < h.length ? h[t2] : t2;
    }, i.prototype.getLabel = function(t2) {
      if (!this.isBlank()) {
        var h = this.getRawOrdinalNumber(t2.value), v4 = this._ordinalMeta.categories[h];
        return v4 == null ? "" : v4 + "";
      }
    }, i.prototype.count = function() {
      return this._extent[1] - this._extent[0] + 1;
    }, i.prototype.unionExtentFromData = function(t2, h) {
      this.unionExtent(t2.getApproximateExtent(h));
    }, i.prototype.isInExtentRange = function(t2) {
      return t2 = this._getTickNumber(t2), this._extent[0] <= t2 && this._extent[1] >= t2;
    }, i.prototype.getOrdinalMeta = function() {
      return this._ordinalMeta;
    }, i.prototype.calcNiceTicks = function() {
    }, i.prototype.calcNiceExtent = function() {
    }, i.type = "ordinal", i;
  }(oN);
  oN.registerClass(MGe);
  var dne = MGe, NH = gy, CGe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "interval", t2._interval = 0, t2._intervalPrecision = 2, t2;
    }
    return i.prototype.parse = function(t2) {
      return t2;
    }, i.prototype.contain = function(t2) {
      return Pkt(t2, this._extent);
    }, i.prototype.normalize = function(t2) {
      return Lkt(t2, this._extent);
    }, i.prototype.scale = function(t2) {
      return Okt(t2, this._extent);
    }, i.prototype.setExtent = function(t2, h) {
      var v4 = this._extent;
      isNaN(t2) || (v4[0] = parseFloat(t2)), isNaN(h) || (v4[1] = parseFloat(h));
    }, i.prototype.unionExtent = function(t2) {
      var h = this._extent;
      t2[0] < h[0] && (h[0] = t2[0]), t2[1] > h[1] && (h[1] = t2[1]), this.setExtent(h[0], h[1]);
    }, i.prototype.getInterval = function() {
      return this._interval;
    }, i.prototype.setInterval = function(t2) {
      this._interval = t2, this._niceExtent = this._extent.slice(), this._intervalPrecision = SGe(t2);
    }, i.prototype.getTicks = function(t2) {
      var h = this._interval, v4 = this._extent, _ = this._niceExtent, M2 = this._intervalPrecision, I2 = [];
      if (!h)
        return I2;
      var P2 = 1e4;
      v4[0] < _[0] && (t2 ? I2.push({ value: NH(_[0] - h, M2) }) : I2.push({ value: v4[0] }));
      for (var N3 = _[0]; N3 <= _[1] && (I2.push({ value: N3 }), N3 = NH(N3 + h, M2), N3 !== I2[I2.length - 1].value); )
        if (I2.length > P2)
          return [];
      var z3 = I2.length ? I2[I2.length - 1].value : _[1];
      return v4[1] > z3 && (t2 ? I2.push({ value: NH(z3 + h, M2) }) : I2.push({ value: v4[1] })), I2;
    }, i.prototype.getMinorTicks = function(t2) {
      for (var h = this.getTicks(true), v4 = [], _ = this.getExtent(), M2 = 1; M2 < h.length; M2++) {
        for (var I2 = h[M2], P2 = h[M2 - 1], N3 = 0, z3 = [], H2 = I2.value - P2.value, $ = H2 / t2; N3 < t2 - 1; ) {
          var et = NH(P2.value + (N3 + 1) * $);
          et > _[0] && et < _[1] && z3.push(et), N3++;
        }
        v4.push(z3);
      }
      return v4;
    }, i.prototype.getLabel = function(t2, h) {
      if (t2 == null)
        return "";
      var v4 = h && h.precision;
      v4 == null ? v4 = PL(t2.value) || 0 : v4 === "auto" && (v4 = this._intervalPrecision);
      var _ = NH(t2.value, v4, true);
      return Jje(_);
    }, i.prototype.calcNiceTicks = function(t2, h, v4) {
      t2 = t2 || 5;
      var _ = this._extent, M2 = _[1] - _[0];
      if (!!isFinite(M2)) {
        M2 < 0 && (M2 = -M2, _.reverse());
        var I2 = uvr(_, t2, h, v4);
        this._intervalPrecision = I2.intervalPrecision, this._interval = I2.interval, this._niceExtent = I2.niceTickExtent;
      }
    }, i.prototype.calcNiceExtent = function(t2) {
      var h = this._extent;
      if (h[0] === h[1])
        if (h[0] !== 0) {
          var v4 = h[0];
          t2.fixMax || (h[1] += v4 / 2), h[0] -= v4 / 2;
        } else
          h[1] = 1;
      var _ = h[1] - h[0];
      isFinite(_) || (h[0] = 0, h[1] = 1), this.calcNiceTicks(t2.splitNumber, t2.minInterval, t2.maxInterval);
      var M2 = this._interval;
      t2.fixMin || (h[0] = NH(Math.floor(h[0] / M2) * M2)), t2.fixMax || (h[1] = NH(Math.ceil(h[1] / M2) * M2));
    }, i.prototype.setNiceExtent = function(t2, h) {
      this._niceExtent = [t2, h];
    }, i.type = "interval", i;
  }(oN);
  oN.registerClass(CGe);
  var eV = CGe, TGe = typeof Float32Array != "undefined", fvr = TGe ? Float32Array : Array;
  function OL(f2) {
    return Za2(f2) ? TGe ? new Float32Array(f2) : f2 : new fvr(f2);
  }
  var cte = "__ec_stack_";
  function gne(f2) {
    return f2.get("stack") || cte + f2.seriesIndex;
  }
  function vne(f2) {
    return f2.dim + f2.index;
  }
  function hvr(f2) {
    var i = [], t2 = f2.axis, h = "axis0";
    if (t2.type === "category") {
      for (var v4 = t2.getBandWidth(), _ = 0; _ < f2.count; _++)
        i.push(Ul({ bandWidth: v4, axisKey: h, stackId: cte + _ }, f2));
      for (var M2 = DGe(i), I2 = [], _ = 0; _ < f2.count; _++) {
        var P2 = M2[h][cte + _];
        P2.offsetCenter = P2.offset + P2.width / 2, I2.push(P2);
      }
      return I2;
    }
  }
  function AGe(f2, i) {
    var t2 = [];
    return i.eachSeriesByType(f2, function(h) {
      PGe(h) && t2.push(h);
    }), t2;
  }
  function pvr(f2) {
    var i = {};
    Qe2(f2, function(P2) {
      var N3 = P2.coordinateSystem, z3 = N3.getBaseAxis();
      if (!(z3.type !== "time" && z3.type !== "value"))
        for (var H2 = P2.getData(), $ = z3.dim + "_" + z3.index, et = H2.getDimensionIndex(H2.mapDimension(z3.dim)), at = H2.getStore(), ht = 0, bt = at.count(); ht < bt; ++ht) {
          var _t = at.get(et, ht);
          i[$] ? i[$].push(_t) : i[$] = [_t];
        }
    });
    var t2 = {};
    for (var h in i)
      if (i.hasOwnProperty(h)) {
        var v4 = i[h];
        if (v4) {
          v4.sort(function(P2, N3) {
            return P2 - N3;
          });
          for (var _ = null, M2 = 1; M2 < v4.length; ++M2) {
            var I2 = v4[M2] - v4[M2 - 1];
            I2 > 0 && (_ = _ === null ? I2 : Math.min(_, I2));
          }
          t2[h] = _;
        }
      }
    return t2;
  }
  function IGe(f2) {
    var i = pvr(f2), t2 = [];
    return Qe2(f2, function(h) {
      var v4 = h.coordinateSystem, _ = v4.getBaseAxis(), M2 = _.getExtent(), I2;
      if (_.type === "category")
        I2 = _.getBandWidth();
      else if (_.type === "value" || _.type === "time") {
        var P2 = _.dim + "_" + _.index, N3 = i[P2], z3 = Math.abs(M2[1] - M2[0]), H2 = _.scale.getExtent(), $ = Math.abs(H2[1] - H2[0]);
        I2 = N3 ? z3 / $ * N3 : z3;
      } else {
        var et = h.getData();
        I2 = Math.abs(M2[1] - M2[0]) / et.count();
      }
      var at = cs(h.get("barWidth"), I2), ht = cs(h.get("barMaxWidth"), I2), bt = cs(h.get("barMinWidth") || (LGe(h) ? 0.5 : 1), I2), _t = h.get("barGap"), Et = h.get("barCategoryGap");
      t2.push({ bandWidth: I2, barWidth: at, barMaxWidth: ht, barMinWidth: bt, barGap: _t, barCategoryGap: Et, axisKey: vne(_), stackId: gne(h) });
    }), DGe(t2);
  }
  function DGe(f2) {
    var i = {};
    Qe2(f2, function(h, v4) {
      var _ = h.axisKey, M2 = h.bandWidth, I2 = i[_] || { bandWidth: M2, remainedWidth: M2, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, P2 = I2.stacks;
      i[_] = I2;
      var N3 = h.stackId;
      P2[N3] || I2.autoWidthCount++, P2[N3] = P2[N3] || { width: 0, maxWidth: 0 };
      var z3 = h.barWidth;
      z3 && !P2[N3].width && (P2[N3].width = z3, z3 = Math.min(I2.remainedWidth, z3), I2.remainedWidth -= z3);
      var H2 = h.barMaxWidth;
      H2 && (P2[N3].maxWidth = H2);
      var $ = h.barMinWidth;
      $ && (P2[N3].minWidth = $);
      var et = h.barGap;
      et != null && (I2.gap = et);
      var at = h.barCategoryGap;
      at != null && (I2.categoryGap = at);
    });
    var t2 = {};
    return Qe2(i, function(h, v4) {
      t2[v4] = {};
      var _ = h.stacks, M2 = h.bandWidth, I2 = h.categoryGap;
      if (I2 == null) {
        var P2 = Of2(_).length;
        I2 = Math.max(35 - P2 * 4, 15) + "%";
      }
      var N3 = cs(I2, M2), z3 = cs(h.gap, 1), H2 = h.remainedWidth, $ = h.autoWidthCount, et = (H2 - N3) / ($ + ($ - 1) * z3);
      et = Math.max(et, 0), Qe2(_, function(_t) {
        var Et = _t.maxWidth, zt = _t.minWidth;
        if (_t.width) {
          var Ft = _t.width;
          Et && (Ft = Math.min(Ft, Et)), zt && (Ft = Math.max(Ft, zt)), _t.width = Ft, H2 -= Ft + z3 * Ft, $--;
        } else {
          var Ft = et;
          Et && Et < Ft && (Ft = Math.min(Et, H2)), zt && zt > Ft && (Ft = zt), Ft !== et && (_t.width = Ft, H2 -= Ft + z3 * Ft, $--);
        }
      }), et = (H2 - N3) / ($ + ($ - 1) * z3), et = Math.max(et, 0);
      var at = 0, ht;
      Qe2(_, function(_t, Et) {
        _t.width || (_t.width = et), ht = _t, at += _t.width * (1 + z3);
      }), ht && (at -= ht.width * z3);
      var bt = -at / 2;
      Qe2(_, function(_t, Et) {
        t2[v4][Et] = t2[v4][Et] || { bandWidth: M2, offset: bt, width: _t.width }, bt += _t.width * (1 + z3);
      });
    }), t2;
  }
  function dvr(f2, i, t2) {
    if (f2 && i) {
      var h = f2[vne(i)];
      return h != null && t2 != null ? h[gne(t2)] : h;
    }
  }
  function EGe(f2, i) {
    var t2 = AGe(f2, i), h = IGe(t2);
    Qe2(t2, function(v4) {
      var _ = v4.getData(), M2 = v4.coordinateSystem, I2 = M2.getBaseAxis(), P2 = gne(v4), N3 = h[vne(I2)][P2], z3 = N3.offset, H2 = N3.width;
      _.setLayout({ bandWidth: N3.bandWidth, offset: z3, size: H2 });
    });
  }
  function kGe(f2) {
    return { seriesType: f2, plan: uet(), reset: function(i) {
      if (!!PGe(i)) {
        var t2 = i.getData(), h = i.coordinateSystem, v4 = h.getBaseAxis(), _ = h.getOtherAxis(v4), M2 = t2.getDimensionIndex(t2.mapDimension(_.dim)), I2 = t2.getDimensionIndex(t2.mapDimension(v4.dim)), P2 = i.get("showBackground", true), N3 = t2.mapDimension(_.dim), z3 = t2.getCalculationInfo("stackResultDimension"), H2 = tV(t2, N3) && !!t2.getCalculationInfo("stackedOnSeries"), $ = _.isHorizontal(), et = gvr(v4, _), at = LGe(i), ht = i.get("barMinHeight") || 0, bt = z3 && t2.getDimensionIndex(z3), _t = t2.getLayout("size"), Et = t2.getLayout("offset");
        return { progress: function(zt, Ft) {
          for (var fe2 = zt.count, re2 = at && OL(fe2 * 3), ye = at && P2 && OL(fe2 * 3), me2 = at && OL(fe2), be2 = h.master.getRect(), Te2 = $ ? be2.width : be2.height, We, en = Ft.getStore(), Ue2 = 0; (We = zt.next()) != null; ) {
            var Mn = en.get(H2 ? bt : M2, We), Vn = en.get(I2, We), xn = et, Zr = void 0;
            H2 && (Zr = +Mn - en.get(M2, We));
            var nr = void 0, pr = void 0, Nr = void 0, ai2 = void 0;
            if ($) {
              var gi2 = h.dataToPoint([Mn, Vn]);
              if (H2) {
                var To = h.dataToPoint([Zr, Vn]);
                xn = To[0];
              }
              nr = xn, pr = gi2[1] + Et, Nr = gi2[0] - xn, ai2 = _t, Math.abs(Nr) < ht && (Nr = (Nr < 0 ? -1 : 1) * ht);
            } else {
              var gi2 = h.dataToPoint([Vn, Mn]);
              if (H2) {
                var To = h.dataToPoint([Vn, Zr]);
                xn = To[1];
              }
              nr = gi2[0] + Et, pr = xn, Nr = _t, ai2 = gi2[1] - xn, Math.abs(ai2) < ht && (ai2 = (ai2 <= 0 ? -1 : 1) * ht);
            }
            at ? (re2[Ue2] = nr, re2[Ue2 + 1] = pr, re2[Ue2 + 2] = $ ? Nr : ai2, ye && (ye[Ue2] = $ ? be2.x : nr, ye[Ue2 + 1] = $ ? pr : be2.y, ye[Ue2 + 2] = Te2), me2[We] = We) : Ft.setItemLayout(We, { x: nr, y: pr, width: Nr, height: ai2 }), Ue2 += 3;
          }
          at && Ft.setLayout({ largePoints: re2, largeDataIndices: me2, largeBackgroundPoints: ye, valueAxisHorizontal: $ });
        } };
      }
    } };
  }
  function PGe(f2) {
    return f2.coordinateSystem && f2.coordinateSystem.type === "cartesian2d";
  }
  function LGe(f2) {
    return f2.pipelineContext && f2.pipelineContext.large;
  }
  function gvr(f2, i) {
    return i.toGlobalCoord(i.dataToCoord(i.type === "log" ? 1 : 0));
  }
  var vvr = function(f2, i, t2, h) {
    for (; t2 < h; ) {
      var v4 = t2 + h >>> 1;
      f2[v4][1] < i ? t2 = v4 + 1 : h = v4;
    }
    return t2;
  }, OGe = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "time", h;
    }
    return i.prototype.getLabel = function(t2) {
      var h = this.getSetting("useUTC");
      return wkt(t2.value, LNe[Fhr(Ntt(this._minLevelUnit))] || LNe.second, h, this.getSetting("locale"));
    }, i.prototype.getFormattedLabel = function(t2, h, v4) {
      var _ = this.getSetting("useUTC"), M2 = this.getSetting("locale");
      return Vhr(t2, h, v4, M2, _);
    }, i.prototype.getTicks = function() {
      var t2 = this._interval, h = this._extent, v4 = [];
      if (!t2)
        return v4;
      v4.push({ value: h[0], level: 0 });
      var _ = this.getSetting("useUTC"), M2 = Svr(this._minLevelUnit, this._approxInterval, _, h);
      return v4 = v4.concat(M2), v4.push({ value: h[1], level: 0 }), v4;
    }, i.prototype.calcNiceExtent = function(t2) {
      var h = this._extent;
      if (h[0] === h[1] && (h[0] -= XD, h[1] += XD), h[1] === -1 / 0 && h[0] === 1 / 0) {
        var v4 = new Date();
        h[1] = +new Date(v4.getFullYear(), v4.getMonth(), v4.getDate()), h[0] = h[1] - XD;
      }
      this.calcNiceTicks(t2.splitNumber, t2.minInterval, t2.maxInterval);
    }, i.prototype.calcNiceTicks = function(t2, h, v4) {
      t2 = t2 || 10;
      var _ = this._extent, M2 = _[1] - _[0];
      this._approxInterval = M2 / t2, h != null && this._approxInterval < h && (this._approxInterval = h), v4 != null && this._approxInterval > v4 && (this._approxInterval = v4);
      var I2 = iDt.length, P2 = Math.min(vvr(iDt, this._approxInterval, 0, I2), I2 - 1);
      this._interval = iDt[P2][1], this._minLevelUnit = iDt[Math.max(P2 - 1, 0)][0];
    }, i.prototype.parse = function(t2) {
      return vp(t2) ? t2 : +GL(t2);
    }, i.prototype.contain = function(t2) {
      return Pkt(this.parse(t2), this._extent);
    }, i.prototype.normalize = function(t2) {
      return Lkt(this.parse(t2), this._extent);
    }, i.prototype.scale = function(t2) {
      return Okt(t2, this._extent);
    }, i.type = "time", i;
  }(eV), iDt = [["second", qee], ["minute", Zee], ["hour", Rdt], ["quarter-day", Rdt * 6], ["half-day", Rdt * 12], ["day", XD * 1.2], ["half-week", XD * 3.5], ["week", XD * 7], ["month", XD * 31], ["quarter", XD * 95], ["half-year", PNe / 2], ["year", PNe]];
  function yvr(f2, i, t2, h) {
    var v4 = GL(i), _ = GL(t2), M2 = function(at) {
      return ONe(v4, at, h) === ONe(_, at, h);
    }, I2 = function() {
      return M2("year");
    }, P2 = function() {
      return I2() && M2("month");
    }, N3 = function() {
      return P2() && M2("day");
    }, z3 = function() {
      return N3() && M2("hour");
    }, H2 = function() {
      return z3() && M2("minute");
    }, $ = function() {
      return H2() && M2("second");
    }, et = function() {
      return $() && M2("millisecond");
    };
    switch (f2) {
      case "year":
        return I2();
      case "month":
        return P2();
      case "day":
        return N3();
      case "hour":
        return z3();
      case "minute":
        return H2();
      case "second":
        return $();
      case "millisecond":
        return et();
    }
  }
  function mvr(f2, i) {
    return f2 /= XD, f2 > 16 ? 16 : f2 > 7.5 ? 7 : f2 > 3.5 ? 4 : f2 > 1.5 ? 2 : 1;
  }
  function bvr(f2) {
    var i = 30 * XD;
    return f2 /= i, f2 > 6 ? 6 : f2 > 3 ? 3 : f2 > 2 ? 2 : 1;
  }
  function _vr(f2) {
    return f2 /= Rdt, f2 > 12 ? 12 : f2 > 6 ? 6 : f2 > 3.5 ? 4 : f2 > 2 ? 2 : 1;
  }
  function HFe(f2, i) {
    return f2 /= i ? Zee : qee, f2 > 30 ? 30 : f2 > 20 ? 20 : f2 > 15 ? 15 : f2 > 10 ? 10 : f2 > 5 ? 5 : f2 > 2 ? 2 : 1;
  }
  function xvr(f2) {
    return Pze(f2, true);
  }
  function wvr(f2, i, t2) {
    var h = new Date(f2);
    switch (Ntt(i)) {
      case "year":
      case "month":
        h[Zje(t2)](0);
      case "day":
        h[$je(t2)](1);
      case "hour":
        h[Yje(t2)](0);
      case "minute":
        h[Kje(t2)](0);
      case "second":
        h[Xje(t2)](0), h[Qje(t2)](0);
    }
    return h.getTime();
  }
  function Svr(f2, i, t2, h) {
    var v4 = 1e4, _ = Uje, M2 = 0;
    function I2(Te2, We, en, Ue2, Mn, Vn, xn) {
      for (var Zr = new Date(We), nr = We, pr = Zr[Ue2](); nr < en && nr <= h[1]; )
        xn.push({ value: nr }), pr += Te2, Zr[Mn](pr), nr = Zr.getTime();
      xn.push({ value: nr, notAdd: true });
    }
    function P2(Te2, We, en) {
      var Ue2 = [], Mn = !We.length;
      if (!yvr(Ntt(Te2), h[0], h[1], t2)) {
        Mn && (We = [{ value: wvr(new Date(h[0]), Te2, t2) }, { value: h[1] }]);
        for (var Vn = 0; Vn < We.length - 1; Vn++) {
          var xn = We[Vn].value, Zr = We[Vn + 1].value;
          if (xn !== Zr) {
            var nr = void 0, pr = void 0, Nr = void 0, ai2 = false;
            switch (Te2) {
              case "year":
                nr = Math.max(1, Math.round(i / XD / 365)), pr = $ee(t2), Nr = Bhr(t2);
                break;
              case "half-year":
              case "quarter":
              case "month":
                nr = bvr(i), pr = Ftt(t2), Nr = Zje(t2);
                break;
              case "week":
              case "half-week":
              case "day":
                nr = mvr(i), pr = Skt(t2), Nr = $je(t2), ai2 = true;
                break;
              case "half-day":
              case "quarter-day":
              case "hour":
                nr = _vr(i), pr = ngt(t2), Nr = Yje(t2);
                break;
              case "minute":
                nr = HFe(i, true), pr = Mkt(t2), Nr = Kje(t2);
                break;
              case "second":
                nr = HFe(i, false), pr = Ckt(t2), Nr = Xje(t2);
                break;
              case "millisecond":
                nr = xvr(i), pr = Tkt(t2), Nr = Qje(t2);
                break;
            }
            I2(nr, xn, Zr, pr, Nr, ai2, Ue2), Te2 === "year" && en.length > 1 && Vn === 0 && en.unshift({ value: en[0].value - nr });
          }
        }
        for (var Vn = 0; Vn < Ue2.length; Vn++)
          en.push(Ue2[Vn]);
        return Ue2;
      }
    }
    for (var N3 = [], z3 = [], H2 = 0, $ = 0, et = 0; et < _.length && M2++ < v4; ++et) {
      var at = Ntt(_[et]);
      if (!!Nhr(_[et])) {
        P2(_[et], N3[N3.length - 1] || [], z3);
        var ht = _[et + 1] ? Ntt(_[et + 1]) : null;
        if (at !== ht) {
          if (z3.length) {
            $ = H2, z3.sort(function(Te2, We) {
              return Te2.value - We.value;
            });
            for (var bt = [], _t = 0; _t < z3.length; ++_t) {
              var Et = z3[_t].value;
              (_t === 0 || z3[_t - 1].value !== Et) && (bt.push(z3[_t]), Et >= h[0] && Et <= h[1] && H2++);
            }
            var zt = (h[1] - h[0]) / i;
            if (H2 > zt * 1.5 && $ > zt / 1.5 || (N3.push(bt), H2 > zt || f2 === _[et]))
              break;
          }
          z3 = [];
        }
      }
    }
    for (var Ft = Ld2(Xa2(N3, function(Te2) {
      return Ld2(Te2, function(We) {
        return We.value >= h[0] && We.value <= h[1] && !We.notAdd;
      });
    }), function(Te2) {
      return Te2.length > 0;
    }), fe2 = [], re2 = Ft.length - 1, et = 0; et < Ft.length; ++et)
      for (var ye = Ft[et], me2 = 0; me2 < ye.length; ++me2)
        fe2.push({ value: ye[me2].value, level: re2 - et });
    fe2.sort(function(Te2, We) {
      return Te2.value - We.value;
    });
    for (var be2 = [], et = 0; et < fe2.length; ++et)
      (et === 0 || fe2[et].value !== fe2[et - 1].value) && be2.push(fe2[et]);
    return be2;
  }
  oN.registerClass(OGe);
  var RGe = OGe, UFe = oN.prototype, Bdt = eV.prototype, Mvr = gy, Cvr = Math.floor, Tvr = Math.ceil, aDt = Math.pow, FD = Math.log, yne = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "log", t2.base = 10, t2._originalScale = new eV(), t2._interval = 0, t2;
    }
    return i.prototype.getTicks = function(t2) {
      var h = this._originalScale, v4 = this._extent, _ = h.getExtent(), M2 = Bdt.getTicks.call(this, t2);
      return Xa2(M2, function(I2) {
        var P2 = I2.value, N3 = gy(aDt(this.base, P2));
        return N3 = P2 === v4[0] && this._fixMin ? oDt(N3, _[0]) : N3, N3 = P2 === v4[1] && this._fixMax ? oDt(N3, _[1]) : N3, { value: N3 };
      }, this);
    }, i.prototype.setExtent = function(t2, h) {
      var v4 = this.base;
      t2 = FD(t2) / FD(v4), h = FD(h) / FD(v4), Bdt.setExtent.call(this, t2, h);
    }, i.prototype.getExtent = function() {
      var t2 = this.base, h = UFe.getExtent.call(this);
      h[0] = aDt(t2, h[0]), h[1] = aDt(t2, h[1]);
      var v4 = this._originalScale, _ = v4.getExtent();
      return this._fixMin && (h[0] = oDt(h[0], _[0])), this._fixMax && (h[1] = oDt(h[1], _[1])), h;
    }, i.prototype.unionExtent = function(t2) {
      this._originalScale.unionExtent(t2);
      var h = this.base;
      t2[0] = FD(t2[0]) / FD(h), t2[1] = FD(t2[1]) / FD(h), UFe.unionExtent.call(this, t2);
    }, i.prototype.unionExtentFromData = function(t2, h) {
      this.unionExtent(t2.getApproximateExtent(h));
    }, i.prototype.calcNiceTicks = function(t2) {
      t2 = t2 || 10;
      var h = this._extent, v4 = h[1] - h[0];
      if (!(v4 === 1 / 0 || v4 <= 0)) {
        var _ = icr(v4), M2 = t2 / v4 * _;
        for (M2 <= 0.5 && (_ *= 10); !isNaN(_) && Math.abs(_) < 1 && Math.abs(_) > 0; )
          _ *= 10;
        var I2 = [gy(Tvr(h[0] / _) * _), gy(Cvr(h[1] / _) * _)];
        this._interval = _, this._niceExtent = I2;
      }
    }, i.prototype.calcNiceExtent = function(t2) {
      Bdt.calcNiceExtent.call(this, t2), this._fixMin = t2.fixMin, this._fixMax = t2.fixMax;
    }, i.prototype.parse = function(t2) {
      return t2;
    }, i.prototype.contain = function(t2) {
      return t2 = FD(t2) / FD(this.base), Pkt(t2, this._extent);
    }, i.prototype.normalize = function(t2) {
      return t2 = FD(t2) / FD(this.base), Lkt(t2, this._extent);
    }, i.prototype.scale = function(t2) {
      return t2 = Okt(t2, this._extent), aDt(this.base, t2);
    }, i.type = "log", i;
  }(oN), NGe = yne.prototype;
  NGe.getMinorTicks = Bdt.getMinorTicks;
  NGe.getLabel = Bdt.getLabel;
  function oDt(f2, i) {
    return Mvr(f2, PL(i));
  }
  oN.registerClass(yne);
  var Avr = yne, Ivr = function() {
    function f2(i, t2, h) {
      this._prepareParams(i, t2, h);
    }
    return f2.prototype._prepareParams = function(i, t2, h) {
      h[1] < h[0] && (h = [NaN, NaN]), this._dataMin = h[0], this._dataMax = h[1];
      var v4 = this._isOrdinal = i.type === "ordinal";
      this._needCrossZero = i.type === "interval" && t2.getNeedCrossZero && t2.getNeedCrossZero();
      var _ = this._modelMinRaw = t2.get("min", true);
      Ol(_) ? this._modelMinNum = sDt(i, _({ min: h[0], max: h[1] })) : _ !== "dataMin" && (this._modelMinNum = sDt(i, _));
      var M2 = this._modelMaxRaw = t2.get("max", true);
      if (Ol(M2) ? this._modelMaxNum = sDt(i, M2({ min: h[0], max: h[1] })) : M2 !== "dataMax" && (this._modelMaxNum = sDt(i, M2)), v4)
        this._axisDataLen = t2.getCategories().length;
      else {
        var I2 = t2.get("boundaryGap"), P2 = Za2(I2) ? I2 : [I2 || 0, I2 || 0];
        typeof P2[0] == "boolean" || typeof P2[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [T5(P2[0], 1), T5(P2[1], 1)];
      }
    }, f2.prototype.calculate = function() {
      var i = this._isOrdinal, t2 = this._dataMin, h = this._dataMax, v4 = this._axisDataLen, _ = this._boundaryGapInner, M2 = i ? null : h - t2 || Math.abs(t2), I2 = this._modelMinRaw === "dataMin" ? t2 : this._modelMinNum, P2 = this._modelMaxRaw === "dataMax" ? h : this._modelMaxNum, N3 = I2 != null, z3 = P2 != null;
      I2 == null && (I2 = i ? v4 ? 0 : NaN : t2 - _[0] * M2), P2 == null && (P2 = i ? v4 ? v4 - 1 : NaN : h + _[1] * M2), (I2 == null || !isFinite(I2)) && (I2 = NaN), (P2 == null || !isFinite(P2)) && (P2 = NaN);
      var H2 = Zdt(I2) || Zdt(P2) || i && !v4;
      this._needCrossZero && (I2 > 0 && P2 > 0 && !N3 && (I2 = 0), I2 < 0 && P2 < 0 && !z3 && (P2 = 0));
      var $ = this._determinedMin, et = this._determinedMax;
      return $ != null && (I2 = $, N3 = true), et != null && (P2 = et, z3 = true), { min: I2, max: P2, minFixed: N3, maxFixed: z3, isBlank: H2 };
    }, f2.prototype.modifyDataMinMax = function(i, t2) {
      this[Evr[i]] = t2;
    }, f2.prototype.setDeterminedMinMax = function(i, t2) {
      var h = Dvr[i];
      this[h] = t2;
    }, f2.prototype.freeze = function() {
      this.frozen = true;
    }, f2;
  }(), Dvr = { min: "_determinedMin", max: "_determinedMax" }, Evr = { min: "_dataMin", max: "_dataMax" };
  function FGe(f2, i, t2) {
    var h = f2.rawExtentInfo;
    return h || (h = new Ivr(f2, i, t2), f2.rawExtentInfo = h, h);
  }
  function sDt(f2, i) {
    return i == null ? null : Zdt(i) ? NaN : f2.parse(i);
  }
  function VGe(f2, i) {
    var t2 = f2.type, h = FGe(f2, i, f2.getExtent()).calculate();
    f2.setBlank(h.isBlank);
    var v4 = h.min, _ = h.max, M2 = i.ecModel;
    if (M2 && t2 === "time") {
      var I2 = AGe("bar", M2), P2 = false;
      if (Qe2(I2, function(H2) {
        P2 = P2 || H2.getBaseAxis() === i.axis;
      }), P2) {
        var N3 = IGe(I2), z3 = kvr(v4, _, i, N3);
        v4 = z3.min, _ = z3.max;
      }
    }
    return { extent: [v4, _], fixMin: h.minFixed, fixMax: h.maxFixed };
  }
  function kvr(f2, i, t2, h) {
    var v4 = t2.axis.getExtent(), _ = v4[1] - v4[0], M2 = dvr(h, t2.axis);
    if (M2 === void 0)
      return { min: f2, max: i };
    var I2 = 1 / 0;
    Qe2(M2, function(et) {
      I2 = Math.min(et.offset, I2);
    });
    var P2 = -1 / 0;
    Qe2(M2, function(et) {
      P2 = Math.max(et.offset + et.width, P2);
    }), I2 = Math.abs(I2), P2 = Math.abs(P2);
    var N3 = I2 + P2, z3 = i - f2, H2 = 1 - (I2 + P2) / _, $ = z3 / H2 - z3;
    return i += $ * (P2 / N3), f2 -= $ * (I2 / N3), { min: f2, max: i };
  }
  function Htt(f2, i) {
    var t2 = i, h = VGe(f2, t2), v4 = h.extent, _ = t2.get("splitNumber");
    f2 instanceof Avr && (f2.base = t2.get("logBase"));
    var M2 = f2.type, I2 = t2.get("interval"), P2 = M2 === "interval" || M2 === "time";
    f2.setExtent(v4[0], v4[1]), f2.calcNiceExtent({ splitNumber: _, fixMin: h.fixMin, fixMax: h.fixMax, minInterval: P2 ? t2.get("minInterval") : null, maxInterval: P2 ? t2.get("maxInterval") : null }), I2 != null && f2.setInterval && f2.setInterval(I2);
  }
  function Rkt(f2, i) {
    if (i = i || f2.get("type"), i)
      switch (i) {
        case "category":
          return new dne({ ordinalMeta: f2.getOrdinalMeta ? f2.getOrdinalMeta() : f2.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new RGe({ locale: f2.ecModel.getLocaleModel(), useUTC: f2.ecModel.get("useUTC") });
        default:
          return new (oN.getClass(i) || eV)();
      }
  }
  function Pvr(f2) {
    var i = f2.scale.getExtent(), t2 = i[0], h = i[1];
    return !(t2 > 0 && h > 0 || t2 < 0 && h < 0);
  }
  function Ngt(f2) {
    var i = f2.getLabelModel().get("formatter"), t2 = f2.type === "category" ? f2.scale.getExtent()[0] : null;
    return f2.scale.type === "time" ? function(h) {
      return function(v4, _) {
        return f2.scale.getFormattedLabel(v4, _, h);
      };
    }(i) : ms(i) ? function(h) {
      return function(v4) {
        var _ = f2.scale.getLabel(v4), M2 = h.replace("{value}", _ != null ? _ : "");
        return M2;
      };
    }(i) : Ol(i) ? function(h) {
      return function(v4, _) {
        return t2 != null && (_ = v4.value - t2), h(mne(f2, v4), _, v4.level != null ? { level: v4.level } : null);
      };
    }(i) : function(h) {
      return f2.scale.getLabel(h);
    };
  }
  function mne(f2, i) {
    return f2.type === "category" ? f2.scale.getLabel(i) : i.value;
  }
  function Lvr(f2) {
    var i = f2.model, t2 = f2.scale;
    if (!(!i.get(["axisLabel", "show"]) || t2.isBlank())) {
      var h, v4, _ = t2.getExtent();
      t2 instanceof dne ? v4 = t2.count() : (h = t2.getTicks(), v4 = h.length);
      var M2 = f2.getLabelModel(), I2 = Ngt(f2), P2, N3 = 1;
      v4 > 40 && (N3 = Math.ceil(v4 / 40));
      for (var z3 = 0; z3 < v4; z3 += N3) {
        var H2 = h ? h[z3] : { value: _[0] + z3 }, $ = I2(H2, z3), et = M2.getTextRect($), at = Ovr(et, M2.get("rotate") || 0);
        P2 ? P2.union(at) : P2 = at;
      }
      return P2;
    }
  }
  function Ovr(f2, i) {
    var t2 = i * Math.PI / 180, h = f2.width, v4 = f2.height, _ = h * Math.abs(Math.cos(t2)) + Math.abs(v4 * Math.sin(t2)), M2 = h * Math.abs(Math.sin(t2)) + Math.abs(v4 * Math.cos(t2)), I2 = new Lc2(f2.x, f2.y, _, M2);
    return I2;
  }
  function bne(f2) {
    var i = f2.get("interval");
    return i == null ? "auto" : i;
  }
  function BGe(f2) {
    return f2.type === "category" && bne(f2.getLabelModel()) === 0;
  }
  function kEt(f2, i) {
    var t2 = {};
    return Qe2(f2.mapDimensionsAll(i), function(h) {
      t2[xGe(f2, h)] = true;
    }), Of2(t2);
  }
  function Rvr(f2, i, t2) {
    i && Qe2(kEt(i, t2), function(h) {
      var v4 = i.getApproximateExtent(h);
      v4[0] < f2[0] && (f2[0] = v4[0]), v4[1] > f2[1] && (f2[1] = v4[1]);
    });
  }
  var Fgt = function() {
    function f2() {
    }
    return f2.prototype.getNeedCrossZero = function() {
      var i = this.option;
      return !i.scale;
    }, f2.prototype.getCoordSysModel = function() {
    }, f2;
  }(), Nvr = 1e-8;
  function qFe(f2, i) {
    return Math.abs(f2 - i) < Nvr;
  }
  function KH(f2, i, t2) {
    var h = 0, v4 = f2[0];
    if (!v4)
      return false;
    for (var _ = 1; _ < f2.length; _++) {
      var M2 = f2[_];
      h += W6(v4[0], v4[1], M2[0], M2[1], i, t2), v4 = M2;
    }
    var I2 = f2[0];
    return (!qFe(v4[0], I2[0]) || !qFe(v4[1], I2[1])) && (h += W6(v4[0], v4[1], I2[0], I2[1], i, t2)), h !== 0;
  }
  var Fvr = [];
  function VXt(f2, i) {
    for (var t2 = 0; t2 < f2.length; t2++)
      Wx(f2[t2], f2[t2], i);
  }
  function ZFe(f2, i, t2, h) {
    for (var v4 = 0; v4 < f2.length; v4++) {
      var _ = f2[v4];
      h && (_ = h.project(_)), _ && isFinite(_[0]) && isFinite(_[1]) && (N7(i, i, _), F7(t2, t2, _));
    }
  }
  function Vvr(f2) {
    for (var i = 0, t2 = 0, h = 0, v4 = f2.length, _ = f2[v4 - 1][0], M2 = f2[v4 - 1][1], I2 = 0; I2 < v4; I2++) {
      var P2 = f2[I2][0], N3 = f2[I2][1], z3 = _ * N3 - P2 * M2;
      i += z3, t2 += (_ + P2) * z3, h += (M2 + N3) * z3, _ = P2, M2 = N3;
    }
    return i ? [t2 / i / 3, h / i / 3, i] : [f2[0][0] || 0, f2[0][1] || 0];
  }
  var zGe = function() {
    function f2(i) {
      this.name = i;
    }
    return f2.prototype.setCenter = function(i) {
      this._center = i;
    }, f2.prototype.getCenter = function() {
      var i = this._center;
      return i || (i = this._center = this.calcCenter()), i;
    }, f2;
  }(), $Fe = function() {
    function f2(i, t2) {
      this.type = "polygon", this.exterior = i, this.interiors = t2;
    }
    return f2;
  }(), YFe = function() {
    function f2(i) {
      this.type = "linestring", this.points = i;
    }
    return f2;
  }(), jGe = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this, t2) || this;
      return _.type = "geoJSON", _.geometries = h, _._center = v4 && [v4[0], v4[1]], _;
    }
    return i.prototype.calcCenter = function() {
      for (var t2 = this.geometries, h, v4 = 0, _ = 0; _ < t2.length; _++) {
        var M2 = t2[_], I2 = M2.exterior, P2 = I2 && I2.length;
        P2 > v4 && (h = M2, v4 = P2);
      }
      if (h)
        return Vvr(h.exterior);
      var N3 = this.getBoundingRect();
      return [N3.x + N3.width / 2, N3.y + N3.height / 2];
    }, i.prototype.getBoundingRect = function(t2) {
      var h = this._rect;
      if (h && !t2)
        return h;
      var v4 = [1 / 0, 1 / 0], _ = [-1 / 0, -1 / 0], M2 = this.geometries;
      return Qe2(M2, function(I2) {
        I2.type === "polygon" ? ZFe(I2.exterior, v4, _, t2) : Qe2(I2.points, function(P2) {
          ZFe(P2, v4, _, t2);
        });
      }), isFinite(v4[0]) && isFinite(v4[1]) && isFinite(_[0]) && isFinite(_[1]) || (v4[0] = v4[1] = _[0] = _[1] = 0), h = new Lc2(v4[0], v4[1], _[0] - v4[0], _[1] - v4[1]), t2 || (this._rect = h), h;
    }, i.prototype.contain = function(t2) {
      var h = this.getBoundingRect(), v4 = this.geometries;
      if (!h.contain(t2[0], t2[1]))
        return false;
      t:
        for (var _ = 0, M2 = v4.length; _ < M2; _++) {
          var I2 = v4[_];
          if (I2.type === "polygon") {
            var P2 = I2.exterior, N3 = I2.interiors;
            if (KH(P2, t2[0], t2[1])) {
              for (var z3 = 0; z3 < (N3 ? N3.length : 0); z3++)
                if (KH(N3[z3], t2[0], t2[1]))
                  continue t;
              return true;
            }
          }
        }
      return false;
    }, i.prototype.transformTo = function(t2, h, v4, _) {
      var M2 = this.getBoundingRect(), I2 = M2.width / M2.height;
      v4 ? _ || (_ = v4 / I2) : v4 = I2 * _;
      for (var P2 = new Lc2(t2, h, v4, _), N3 = M2.calculateTransform(P2), z3 = this.geometries, H2 = 0; H2 < z3.length; H2++) {
        var $ = z3[H2];
        $.type === "polygon" ? (VXt($.exterior, N3), Qe2($.interiors, function(et) {
          VXt(et, N3);
        })) : Qe2($.points, function(et) {
          VXt(et, N3);
        });
      }
      M2 = this._rect, M2.copy(P2), this._center = [M2.x + M2.width / 2, M2.y + M2.height / 2];
    }, i.prototype.cloneShallow = function(t2) {
      t2 == null && (t2 = this.name);
      var h = new i(t2, this.geometries, this._center);
      return h._rect = this._rect, h.transformTo = null, h;
    }, i;
  }(zGe), Bvr = function(f2) {
    ii2(i, f2);
    function i(t2, h) {
      var v4 = f2.call(this, t2) || this;
      return v4.type = "geoSVG", v4._elOnlyForCalculate = h, v4;
    }
    return i.prototype.calcCenter = function() {
      for (var t2 = this._elOnlyForCalculate, h = t2.getBoundingRect(), v4 = [h.x + h.width / 2, h.y + h.height / 2], _ = ukt(Fvr), M2 = t2; M2 && !M2.isGeoSVGGraphicRoot; )
        $6(_, M2.getLocalTransform(), _), M2 = M2.parent;
      return Xtt(_, _), Wx(v4, v4, _), v4;
    }, i;
  }(zGe);
  function zvr(f2) {
    if (!f2.UTF8Encoding)
      return f2;
    var i = f2, t2 = i.UTF8Scale;
    t2 == null && (t2 = 1024);
    var h = i.features;
    return Qe2(h, function(v4) {
      var _ = v4.geometry, M2 = _.encodeOffsets, I2 = _.coordinates;
      if (!!M2)
        switch (_.type) {
          case "LineString":
            _.coordinates = WGe(I2, M2, t2);
            break;
          case "Polygon":
            BXt(I2, M2, t2);
            break;
          case "MultiLineString":
            BXt(I2, M2, t2);
            break;
          case "MultiPolygon":
            Qe2(I2, function(P2, N3) {
              return BXt(P2, M2[N3], t2);
            });
        }
    }), i.UTF8Encoding = false, i;
  }
  function BXt(f2, i, t2) {
    for (var h = 0; h < f2.length; h++)
      f2[h] = WGe(f2[h], i[h], t2);
  }
  function WGe(f2, i, t2) {
    for (var h = [], v4 = i[0], _ = i[1], M2 = 0; M2 < f2.length; M2 += 2) {
      var I2 = f2.charCodeAt(M2) - 64, P2 = f2.charCodeAt(M2 + 1) - 64;
      I2 = I2 >> 1 ^ -(I2 & 1), P2 = P2 >> 1 ^ -(P2 & 1), I2 += v4, P2 += _, v4 = I2, _ = P2, h.push([I2 / t2, P2 / t2]);
    }
    return h;
  }
  function jvr(f2, i) {
    return f2 = zvr(f2), Xa2(Ld2(f2.features, function(t2) {
      return t2.geometry && t2.properties && t2.geometry.coordinates.length > 0;
    }), function(t2) {
      var h = t2.properties, v4 = t2.geometry, _ = [];
      switch (v4.type) {
        case "Polygon":
          var M2 = v4.coordinates;
          _.push(new $Fe(M2[0], M2.slice(1)));
          break;
        case "MultiPolygon":
          Qe2(v4.coordinates, function(P2) {
            P2[0] && _.push(new $Fe(P2[0], P2.slice(1)));
          });
          break;
        case "LineString":
          _.push(new YFe([v4.coordinates]));
          break;
        case "MultiLineString":
          _.push(new YFe(v4.coordinates));
      }
      var I2 = new jGe(h[i || "name"], _, h.cp);
      return I2.properties = h, I2;
    });
  }
  var ugt = Wh2();
  function Wvr(f2) {
    return f2.type === "category" ? Hvr(f2) : qvr(f2);
  }
  function Gvr(f2, i) {
    return f2.type === "category" ? Uvr(f2, i) : { ticks: Xa2(f2.scale.getTicks(), function(t2) {
      return t2.value;
    }) };
  }
  function Hvr(f2) {
    var i = f2.getLabelModel(), t2 = GGe(f2, i);
    return !i.get("show") || f2.scale.isBlank() ? { labels: [], labelCategoryInterval: t2.labelCategoryInterval } : t2;
  }
  function GGe(f2, i) {
    var t2 = HGe(f2, "labels"), h = bne(i), v4 = UGe(t2, h);
    if (v4)
      return v4;
    var _, M2;
    return Ol(h) ? _ = $Ge(f2, h) : (M2 = h === "auto" ? Zvr(f2) : h, _ = ZGe(f2, M2)), qGe(t2, h, { labels: _, labelCategoryInterval: M2 });
  }
  function Uvr(f2, i) {
    var t2 = HGe(f2, "ticks"), h = bne(i), v4 = UGe(t2, h);
    if (v4)
      return v4;
    var _, M2;
    if ((!i.get("show") || f2.scale.isBlank()) && (_ = []), Ol(h))
      _ = $Ge(f2, h, true);
    else if (h === "auto") {
      var I2 = GGe(f2, f2.getLabelModel());
      M2 = I2.labelCategoryInterval, _ = Xa2(I2.labels, function(P2) {
        return P2.tickValue;
      });
    } else
      M2 = h, _ = ZGe(f2, M2, true);
    return qGe(t2, h, { ticks: _, tickCategoryInterval: M2 });
  }
  function qvr(f2) {
    var i = f2.scale.getTicks(), t2 = Ngt(f2);
    return { labels: Xa2(i, function(h, v4) {
      return { level: h.level, formattedLabel: t2(h, v4), rawLabel: f2.scale.getLabel(h), tickValue: h.value };
    }) };
  }
  function HGe(f2, i) {
    return ugt(f2)[i] || (ugt(f2)[i] = []);
  }
  function UGe(f2, i) {
    for (var t2 = 0; t2 < f2.length; t2++)
      if (f2[t2].key === i)
        return f2[t2].value;
  }
  function qGe(f2, i, t2) {
    return f2.push({ key: i, value: t2 }), t2;
  }
  function Zvr(f2) {
    var i = ugt(f2).autoInterval;
    return i != null ? i : ugt(f2).autoInterval = f2.calculateCategoryInterval();
  }
  function $vr(f2) {
    var i = Yvr(f2), t2 = Ngt(f2), h = (i.axisRotate - i.labelRotate) / 180 * Math.PI, v4 = f2.scale, _ = v4.getExtent(), M2 = v4.count();
    if (_[1] - _[0] < 1)
      return 0;
    var I2 = 1;
    M2 > 40 && (I2 = Math.max(1, Math.floor(M2 / 40)));
    for (var P2 = _[0], N3 = f2.dataToCoord(P2 + 1) - f2.dataToCoord(P2), z3 = Math.abs(N3 * Math.cos(h)), H2 = Math.abs(N3 * Math.sin(h)), $ = 0, et = 0; P2 <= _[1]; P2 += I2) {
      var at = 0, ht = 0, bt = Cgt(t2({ value: P2 }), i.font, "center", "top");
      at = bt.width * 1.3, ht = bt.height * 1.3, $ = Math.max($, at, 7), et = Math.max(et, ht, 7);
    }
    var _t = $ / z3, Et = et / H2;
    isNaN(_t) && (_t = 1 / 0), isNaN(Et) && (Et = 1 / 0);
    var zt = Math.max(0, Math.floor(Math.min(_t, Et))), Ft = ugt(f2.model), fe2 = f2.getExtent(), re2 = Ft.lastAutoInterval, ye = Ft.lastTickCount;
    return re2 != null && ye != null && Math.abs(re2 - zt) <= 1 && Math.abs(ye - M2) <= 1 && re2 > zt && Ft.axisExtent0 === fe2[0] && Ft.axisExtent1 === fe2[1] ? zt = re2 : (Ft.lastTickCount = M2, Ft.lastAutoInterval = zt, Ft.axisExtent0 = fe2[0], Ft.axisExtent1 = fe2[1]), zt;
  }
  function Yvr(f2) {
    var i = f2.getLabelModel();
    return { axisRotate: f2.getRotate ? f2.getRotate() : f2.isHorizontal && !f2.isHorizontal() ? 90 : 0, labelRotate: i.get("rotate") || 0, font: i.getFont() };
  }
  function ZGe(f2, i, t2) {
    var h = Ngt(f2), v4 = f2.scale, _ = v4.getExtent(), M2 = f2.getLabelModel(), I2 = [], P2 = Math.max((i || 0) + 1, 1), N3 = _[0], z3 = v4.count();
    N3 !== 0 && P2 > 1 && z3 / P2 > 2 && (N3 = Math.round(Math.ceil(N3 / P2) * P2));
    var H2 = BGe(f2), $ = M2.get("showMinLabel") || H2, et = M2.get("showMaxLabel") || H2;
    $ && N3 !== _[0] && ht(_[0]);
    for (var at = N3; at <= _[1]; at += P2)
      ht(at);
    et && at - P2 !== _[1] && ht(_[1]);
    function ht(bt) {
      var _t = { value: bt };
      I2.push(t2 ? bt : { formattedLabel: h(_t), rawLabel: v4.getLabel(_t), tickValue: bt });
    }
    return I2;
  }
  function $Ge(f2, i, t2) {
    var h = f2.scale, v4 = Ngt(f2), _ = [];
    return Qe2(h.getTicks(), function(M2) {
      var I2 = h.getLabel(M2), P2 = M2.value;
      i(M2.value, I2) && _.push(t2 ? P2 : { formattedLabel: v4(M2), rawLabel: I2, tickValue: P2 });
    }), _;
  }
  var KFe = [0, 1], Kvr = function() {
    function f2(i, t2, h) {
      this.onBand = false, this.inverse = false, this.dim = i, this.scale = t2, this._extent = h || [0, 0];
    }
    return f2.prototype.contain = function(i) {
      var t2 = this._extent, h = Math.min(t2[0], t2[1]), v4 = Math.max(t2[0], t2[1]);
      return i >= h && i <= v4;
    }, f2.prototype.containData = function(i) {
      return this.scale.contain(i);
    }, f2.prototype.getExtent = function() {
      return this._extent.slice();
    }, f2.prototype.getPixelPrecision = function(i) {
      return Eze(i || this.scale.getExtent(), this._extent);
    }, f2.prototype.setExtent = function(i, t2) {
      var h = this._extent;
      h[0] = i, h[1] = t2;
    }, f2.prototype.dataToCoord = function(i, t2) {
      var h = this._extent, v4 = this.scale;
      return i = v4.normalize(i), this.onBand && v4.type === "ordinal" && (h = h.slice(), XFe(h, v4.count())), cd2(i, KFe, h, t2);
    }, f2.prototype.coordToData = function(i, t2) {
      var h = this._extent, v4 = this.scale;
      this.onBand && v4.type === "ordinal" && (h = h.slice(), XFe(h, v4.count()));
      var _ = cd2(i, h, KFe, t2);
      return this.scale.scale(_);
    }, f2.prototype.pointToData = function(i, t2) {
    }, f2.prototype.getTicksCoords = function(i) {
      i = i || {};
      var t2 = i.tickModel || this.getTickModel(), h = Gvr(this, t2), v4 = h.ticks, _ = Xa2(v4, function(I2) {
        return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(I2) : I2), tickValue: I2 };
      }, this), M2 = t2.get("alignWithLabel");
      return Xvr(this, _, M2, i.clamp), _;
    }, f2.prototype.getMinorTicksCoords = function() {
      if (this.scale.type === "ordinal")
        return [];
      var i = this.model.getModel("minorTick"), t2 = i.get("splitNumber");
      t2 > 0 && t2 < 100 || (t2 = 5);
      var h = this.scale.getMinorTicks(t2), v4 = Xa2(h, function(_) {
        return Xa2(_, function(M2) {
          return { coord: this.dataToCoord(M2), tickValue: M2 };
        }, this);
      }, this);
      return v4;
    }, f2.prototype.getViewLabels = function() {
      return Wvr(this).labels;
    }, f2.prototype.getLabelModel = function() {
      return this.model.getModel("axisLabel");
    }, f2.prototype.getTickModel = function() {
      return this.model.getModel("axisTick");
    }, f2.prototype.getBandWidth = function() {
      var i = this._extent, t2 = this.scale.getExtent(), h = t2[1] - t2[0] + (this.onBand ? 1 : 0);
      h === 0 && (h = 1);
      var v4 = Math.abs(i[1] - i[0]);
      return Math.abs(v4) / h;
    }, f2.prototype.calculateCategoryInterval = function() {
      return $vr(this);
    }, f2;
  }();
  function XFe(f2, i) {
    var t2 = f2[1] - f2[0], h = i, v4 = t2 / h / 2;
    f2[0] += v4, f2[1] -= v4;
  }
  function Xvr(f2, i, t2, h) {
    var v4 = i.length;
    if (!f2.onBand || t2 || !v4)
      return;
    var _ = f2.getExtent(), M2, I2;
    if (v4 === 1)
      i[0].coord = _[0], M2 = i[1] = { coord: _[0] };
    else {
      var P2 = i[v4 - 1].tickValue - i[0].tickValue, N3 = (i[v4 - 1].coord - i[0].coord) / P2;
      Qe2(i, function(et) {
        et.coord -= N3 / 2;
      });
      var z3 = f2.scale.getExtent();
      I2 = 1 + z3[1] - i[v4 - 1].tickValue, M2 = { coord: i[v4 - 1].coord + N3 * I2 }, i.push(M2);
    }
    var H2 = _[0] > _[1];
    $(i[0].coord, _[0]) && (h ? i[0].coord = _[0] : i.shift()), h && $(_[0], i[0].coord) && i.unshift({ coord: _[0] }), $(_[1], M2.coord) && (h ? M2.coord = _[1] : i.pop()), h && $(M2.coord, _[1]) && i.push({ coord: _[1] });
    function $(et, at) {
      return et = gy(et), at = gy(at), H2 ? et > at : et < at;
    }
  }
  var D5 = Kvr, tdt = Math.PI * 2, FH = HL.CMD, Qvr = ["top", "right", "bottom", "left"];
  function Jvr(f2, i, t2, h, v4) {
    var _ = t2.width, M2 = t2.height;
    switch (f2) {
      case "top":
        h.set(t2.x + _ / 2, t2.y - i), v4.set(0, -1);
        break;
      case "bottom":
        h.set(t2.x + _ / 2, t2.y + M2 + i), v4.set(0, 1);
        break;
      case "left":
        h.set(t2.x - i, t2.y + M2 / 2), v4.set(-1, 0);
        break;
      case "right":
        h.set(t2.x + _ + i, t2.y + M2 / 2), v4.set(1, 0);
        break;
    }
  }
  function t0r(f2, i, t2, h, v4, _, M2, I2, P2) {
    M2 -= f2, I2 -= i;
    var N3 = Math.sqrt(M2 * M2 + I2 * I2);
    M2 /= N3, I2 /= N3;
    var z3 = M2 * t2 + f2, H2 = I2 * t2 + i;
    if (Math.abs(h - v4) % tdt < 1e-4)
      return P2[0] = z3, P2[1] = H2, N3 - t2;
    if (_) {
      var $ = h;
      h = j7(v4), v4 = j7($);
    } else
      h = j7(h), v4 = j7(v4);
    h > v4 && (v4 += tdt);
    var et = Math.atan2(I2, M2);
    if (et < 0 && (et += tdt), et >= h && et <= v4 || et + tdt >= h && et + tdt <= v4)
      return P2[0] = z3, P2[1] = H2, N3 - t2;
    var at = t2 * Math.cos(h) + f2, ht = t2 * Math.sin(h) + i, bt = t2 * Math.cos(v4) + f2, _t = t2 * Math.sin(v4) + i, Et = (at - M2) * (at - M2) + (ht - I2) * (ht - I2), zt = (bt - M2) * (bt - M2) + (_t - I2) * (_t - I2);
    return Et < zt ? (P2[0] = at, P2[1] = ht, Math.sqrt(Et)) : (P2[0] = bt, P2[1] = _t, Math.sqrt(zt));
  }
  function PEt(f2, i, t2, h, v4, _, M2, I2) {
    var P2 = v4 - f2, N3 = _ - i, z3 = t2 - f2, H2 = h - i, $ = Math.sqrt(z3 * z3 + H2 * H2);
    z3 /= $, H2 /= $;
    var et = P2 * z3 + N3 * H2, at = et / $;
    I2 && (at = Math.min(Math.max(at, 0), 1)), at *= $;
    var ht = M2[0] = f2 + at * z3, bt = M2[1] = i + at * H2;
    return Math.sqrt((ht - v4) * (ht - v4) + (bt - _) * (bt - _));
  }
  function YGe(f2, i, t2, h, v4, _, M2) {
    t2 < 0 && (f2 = f2 + t2, t2 = -t2), h < 0 && (i = i + h, h = -h);
    var I2 = f2 + t2, P2 = i + h, N3 = M2[0] = Math.min(Math.max(v4, f2), I2), z3 = M2[1] = Math.min(Math.max(_, i), P2);
    return Math.sqrt((N3 - v4) * (N3 - v4) + (z3 - _) * (z3 - _));
  }
  var x5 = [];
  function e0r(f2, i, t2) {
    var h = YGe(i.x, i.y, i.width, i.height, f2.x, f2.y, x5);
    return t2.set(x5[0], x5[1]), h;
  }
  function n0r(f2, i, t2) {
    for (var h = 0, v4 = 0, _ = 0, M2 = 0, I2, P2, N3 = 1 / 0, z3 = i.data, H2 = f2.x, $ = f2.y, et = 0; et < z3.length; ) {
      var at = z3[et++];
      et === 1 && (h = z3[et], v4 = z3[et + 1], _ = h, M2 = v4);
      var ht = N3;
      switch (at) {
        case FH.M:
          _ = z3[et++], M2 = z3[et++], h = _, v4 = M2;
          break;
        case FH.L:
          ht = PEt(h, v4, z3[et], z3[et + 1], H2, $, x5, true), h = z3[et++], v4 = z3[et++];
          break;
        case FH.C:
          ht = fze(h, v4, z3[et++], z3[et++], z3[et++], z3[et++], z3[et], z3[et + 1], H2, $, x5), h = z3[et++], v4 = z3[et++];
          break;
        case FH.Q:
          ht = pze(h, v4, z3[et++], z3[et++], z3[et], z3[et + 1], H2, $, x5), h = z3[et++], v4 = z3[et++];
          break;
        case FH.A:
          var bt = z3[et++], _t = z3[et++], Et = z3[et++], zt = z3[et++], Ft = z3[et++], fe2 = z3[et++];
          et += 1;
          var re2 = !!(1 - z3[et++]);
          I2 = Math.cos(Ft) * Et + bt, P2 = Math.sin(Ft) * zt + _t, et <= 1 && (_ = I2, M2 = P2);
          var ye = (H2 - bt) * zt / Et + bt;
          ht = t0r(bt, _t, zt, Ft, Ft + fe2, re2, ye, $, x5), h = Math.cos(Ft + fe2) * Et + bt, v4 = Math.sin(Ft + fe2) * zt + _t;
          break;
        case FH.R:
          _ = h = z3[et++], M2 = v4 = z3[et++];
          var me2 = z3[et++], be2 = z3[et++];
          ht = YGe(_, M2, me2, be2, H2, $, x5);
          break;
        case FH.Z:
          ht = PEt(h, v4, _, M2, H2, $, x5, true), h = _, v4 = M2;
          break;
      }
      ht < N3 && (N3 = ht, t2.set(x5[0], x5[1]));
    }
    return N3;
  }
  var S5 = new ac2(), Wg2 = new ac2(), Vy = new ac2(), RL = new ac2(), kL = new ac2();
  function QFe(f2, i) {
    if (!!f2) {
      var t2 = f2.getTextGuideLine(), h = f2.getTextContent();
      if (!!(h && t2)) {
        var v4 = f2.textGuideLineConfig || {}, _ = [[0, 0], [0, 0], [0, 0]], M2 = v4.candidates || Qvr, I2 = h.getBoundingRect().clone();
        I2.applyTransform(h.getComputedTransform());
        var P2 = 1 / 0, N3 = v4.anchor, z3 = f2.getComputedTransform(), H2 = z3 && Xtt([], z3), $ = i.get("length2") || 0;
        N3 && Vy.copy(N3);
        for (var et = 0; et < M2.length; et++) {
          var at = M2[et];
          Jvr(at, 0, I2, S5, RL), ac2.scaleAndAdd(Wg2, S5, RL, $), Wg2.transform(H2);
          var ht = f2.getBoundingRect(), bt = N3 ? N3.distance(Wg2) : f2 instanceof Uc2 ? n0r(Wg2, f2.path, Vy) : e0r(Wg2, ht, Vy);
          bt < P2 && (P2 = bt, Wg2.transform(z3), Vy.transform(z3), Vy.toArray(_[0]), Wg2.toArray(_[1]), S5.toArray(_[2]));
        }
        KGe(_, i.get("minTurnAngle")), t2.setShape({ points: _ });
      }
    }
  }
  var LEt = [], V2 = new ac2();
  function KGe(f2, i) {
    if (i <= 180 && i > 0) {
      i = i / 180 * Math.PI, S5.fromArray(f2[0]), Wg2.fromArray(f2[1]), Vy.fromArray(f2[2]), ac2.sub(RL, S5, Wg2), ac2.sub(kL, Vy, Wg2);
      var t2 = RL.len(), h = kL.len();
      if (!(t2 < 1e-3 || h < 1e-3)) {
        RL.scale(1 / t2), kL.scale(1 / h);
        var v4 = RL.dot(kL), _ = Math.cos(i);
        if (_ < v4) {
          var M2 = PEt(Wg2.x, Wg2.y, Vy.x, Vy.y, S5.x, S5.y, LEt, false);
          V2.fromArray(LEt), V2.scaleAndAdd(kL, M2 / Math.tan(Math.PI - i));
          var I2 = Vy.x !== Wg2.x ? (V2.x - Wg2.x) / (Vy.x - Wg2.x) : (V2.y - Wg2.y) / (Vy.y - Wg2.y);
          if (isNaN(I2))
            return;
          I2 < 0 ? ac2.copy(V2, Wg2) : I2 > 1 && ac2.copy(V2, Vy), V2.toArray(f2[1]);
        }
      }
    }
  }
  function r0r(f2, i, t2) {
    if (t2 <= 180 && t2 > 0) {
      t2 = t2 / 180 * Math.PI, S5.fromArray(f2[0]), Wg2.fromArray(f2[1]), Vy.fromArray(f2[2]), ac2.sub(RL, Wg2, S5), ac2.sub(kL, Vy, Wg2);
      var h = RL.len(), v4 = kL.len();
      if (!(h < 1e-3 || v4 < 1e-3)) {
        RL.scale(1 / h), kL.scale(1 / v4);
        var _ = RL.dot(i), M2 = Math.cos(t2);
        if (_ < M2) {
          var I2 = PEt(Wg2.x, Wg2.y, Vy.x, Vy.y, S5.x, S5.y, LEt, false);
          V2.fromArray(LEt);
          var P2 = Math.PI / 2, N3 = Math.acos(kL.dot(i)), z3 = P2 + N3 - t2;
          if (z3 >= P2)
            ac2.copy(V2, Vy);
          else {
            V2.scaleAndAdd(kL, I2 / Math.tan(Math.PI / 2 - z3));
            var H2 = Vy.x !== Wg2.x ? (V2.x - Wg2.x) / (Vy.x - Wg2.x) : (V2.y - Wg2.y) / (Vy.y - Wg2.y);
            if (isNaN(H2))
              return;
            H2 < 0 ? ac2.copy(V2, Wg2) : H2 > 1 && ac2.copy(V2, Vy);
          }
          V2.toArray(f2[1]);
        }
      }
    }
  }
  function JFe(f2, i, t2, h) {
    var v4 = t2 === "normal", _ = v4 ? f2 : f2.ensureState(t2);
    _.ignore = i;
    var M2 = h.get("smooth");
    M2 && M2 === true && (M2 = 0.3), _.shape = _.shape || {}, M2 > 0 && (_.shape.smooth = M2);
    var I2 = h.getModel("lineStyle").getLineStyle();
    v4 ? f2.useStyle(I2) : _.style = I2;
  }
  function i0r(f2, i) {
    var t2 = i.smooth, h = i.points;
    if (!!h)
      if (f2.moveTo(h[0][0], h[0][1]), t2 > 0 && h.length >= 3) {
        var v4 = R7(h[0], h[1]), _ = R7(h[1], h[2]);
        if (!v4 || !_) {
          f2.lineTo(h[1][0], h[1][1]), f2.lineTo(h[2][0], h[2][1]);
          return;
        }
        var M2 = Math.min(v4, _) * t2, I2 = BDt([], h[1], h[0], M2 / v4), P2 = BDt([], h[1], h[2], M2 / _), N3 = BDt([], I2, P2, 0.5);
        f2.bezierCurveTo(I2[0], I2[1], I2[0], I2[1], N3[0], N3[1]), f2.bezierCurveTo(P2[0], P2[1], P2[0], P2[1], h[2][0], h[2][1]);
      } else
        for (var z3 = 1; z3 < h.length; z3++)
          f2.lineTo(h[z3][0], h[z3][1]);
  }
  function _ne(f2, i, t2) {
    var h = f2.getTextGuideLine(), v4 = f2.getTextContent();
    if (!v4) {
      h && f2.removeTextGuideLine();
      return;
    }
    for (var _ = i.normal, M2 = _.get("show"), I2 = v4.ignore, P2 = 0; P2 < Qdt.length; P2++) {
      var N3 = Qdt[P2], z3 = i[N3], H2 = N3 === "normal";
      if (z3) {
        var $ = z3.get("show"), et = H2 ? I2 : _c2(v4.states[N3] && v4.states[N3].ignore, I2);
        if (et || !_c2($, M2)) {
          var at = H2 ? h : h && h.states.normal;
          at && (at.ignore = true);
          continue;
        }
        h || (h = new aC(), f2.setTextGuideLine(h), !H2 && (I2 || !M2) && JFe(h, true, "normal", i.normal), f2.stateProxy && (h.stateProxy = f2.stateProxy)), JFe(h, false, N3, z3);
      }
    }
    if (h) {
      Ul(h.style, t2), h.style.fill = null;
      var ht = _.get("showAbove"), bt = f2.textGuideLineConfig = f2.textGuideLineConfig || {};
      bt.showAbove = ht || false, h.buildPath = i0r;
    }
  }
  function xne(f2, i) {
    i = i || "labelLine";
    for (var t2 = { normal: f2.getModel(i) }, h = 0; h < j2.length; h++) {
      var v4 = j2[h];
      t2[v4] = f2.getModel([v4, i]);
    }
    return t2;
  }
  function XGe(f2) {
    for (var i = [], t2 = 0; t2 < f2.length; t2++) {
      var h = f2[t2];
      if (!h.defaultAttr.ignore) {
        var v4 = h.label, _ = v4.getComputedTransform(), M2 = v4.getBoundingRect(), I2 = !_ || _[1] < 1e-5 && _[2] < 1e-5, P2 = v4.style.margin || 0, N3 = M2.clone();
        N3.applyTransform(_), N3.x -= P2 / 2, N3.y -= P2 / 2, N3.width += P2, N3.height += P2;
        var z3 = I2 ? new yEt(M2, _) : null;
        i.push({ label: v4, labelLine: h.labelLine, rect: N3, localRect: M2, obb: z3, priority: h.priority, defaultAttr: h.defaultAttr, layoutOption: h.computedLayoutOption, axisAligned: I2, transform: _ });
      }
    }
    return i;
  }
  function QGe(f2, i, t2, h, v4, _) {
    var M2 = f2.length;
    if (M2 < 2)
      return;
    f2.sort(function(me2, be2) {
      return me2.rect[i] - be2.rect[i];
    });
    for (var I2 = 0, P2, N3 = false, z3 = 0, H2 = 0; H2 < M2; H2++) {
      var $ = f2[H2], et = $.rect;
      P2 = et[i] - I2, P2 < 0 && (et[i] -= P2, $.label[i] -= P2, N3 = true);
      var at = Math.max(-P2, 0);
      z3 += at, I2 = et[i] + et[t2];
    }
    z3 > 0 && _ && fe2(-z3 / M2, 0, M2);
    var ht = f2[0], bt = f2[M2 - 1], _t, Et;
    zt(), _t < 0 && re2(-_t, 0.8), Et < 0 && re2(Et, 0.8), zt(), Ft(_t, Et, 1), Ft(Et, _t, -1), zt(), _t < 0 && ye(-_t), Et < 0 && ye(Et);
    function zt() {
      _t = ht.rect[i] - h, Et = v4 - bt.rect[i] - bt.rect[t2];
    }
    function Ft(me2, be2, Te2) {
      if (me2 < 0) {
        var We = Math.min(be2, -me2);
        if (We > 0) {
          fe2(We * Te2, 0, M2);
          var en = We + me2;
          en < 0 && re2(-en * Te2, 1);
        } else
          re2(-me2 * Te2, 1);
      }
    }
    function fe2(me2, be2, Te2) {
      me2 !== 0 && (N3 = true);
      for (var We = be2; We < Te2; We++) {
        var en = f2[We], Ue2 = en.rect;
        Ue2[i] += me2, en.label[i] += me2;
      }
    }
    function re2(me2, be2) {
      for (var Te2 = [], We = 0, en = 1; en < M2; en++) {
        var Ue2 = f2[en - 1].rect, Mn = Math.max(f2[en].rect[i] - Ue2[i] - Ue2[t2], 0);
        Te2.push(Mn), We += Mn;
      }
      if (!!We) {
        var Vn = Math.min(Math.abs(me2) / We, be2);
        if (me2 > 0)
          for (var en = 0; en < M2 - 1; en++) {
            var xn = Te2[en] * Vn;
            fe2(xn, 0, en + 1);
          }
        else
          for (var en = M2 - 1; en > 0; en--) {
            var xn = Te2[en - 1] * Vn;
            fe2(-xn, en, M2);
          }
      }
    }
    function ye(me2) {
      var be2 = me2 < 0 ? -1 : 1;
      me2 = Math.abs(me2);
      for (var Te2 = Math.ceil(me2 / (M2 - 1)), We = 0; We < M2 - 1; We++)
        if (be2 > 0 ? fe2(Te2, 0, We + 1) : fe2(-Te2, M2 - We - 1, M2), me2 -= Te2, me2 <= 0)
          return;
    }
    return N3;
  }
  function a0r(f2, i, t2, h) {
    return QGe(f2, "x", "width", i, t2, h);
  }
  function JGe(f2, i, t2, h) {
    return QGe(f2, "y", "height", i, t2, h);
  }
  function tHe(f2) {
    var i = [];
    f2.sort(function(ht, bt) {
      return bt.priority - ht.priority;
    });
    var t2 = new Lc2(0, 0, 0, 0);
    function h(ht) {
      if (!ht.ignore) {
        var bt = ht.ensureState("emphasis");
        bt.ignore == null && (bt.ignore = false);
      }
      ht.ignore = true;
    }
    for (var v4 = 0; v4 < f2.length; v4++) {
      var _ = f2[v4], M2 = _.axisAligned, I2 = _.localRect, P2 = _.transform, N3 = _.label, z3 = _.labelLine;
      t2.copy(_.rect), t2.width -= 0.1, t2.height -= 0.1, t2.x += 0.05, t2.y += 0.05;
      for (var H2 = _.obb, $ = false, et = 0; et < i.length; et++) {
        var at = i[et];
        if (!!t2.intersect(at.rect)) {
          if (M2 && at.axisAligned) {
            $ = true;
            break;
          }
          if (at.obb || (at.obb = new yEt(at.localRect, at.transform)), H2 || (H2 = new yEt(I2, P2)), H2.intersect(at.obb)) {
            $ = true;
            break;
          }
        }
      }
      $ ? (h(N3), z3 && h(z3)) : (N3.attr("ignore", _.defaultAttr.ignore), z3 && z3.attr("ignore", _.defaultAttr.labelGuideIgnore), i.push(_));
    }
  }
  function o0r(f2) {
    if (f2) {
      for (var i = [], t2 = 0; t2 < f2.length; t2++)
        i.push(f2[t2].slice());
      return i;
    }
  }
  function s0r(f2, i) {
    var t2 = f2.label, h = i && i.getTextGuideLine();
    return { dataIndex: f2.dataIndex, dataType: f2.dataType, seriesIndex: f2.seriesModel.seriesIndex, text: f2.label.style.text, rect: f2.hostRect, labelRect: f2.rect, align: t2.style.align, verticalAlign: t2.style.verticalAlign, labelLinePoints: o0r(h && h.shape.points) };
  }
  var t8e = ["align", "verticalAlign", "width", "height", "fontSize"], BT = new G6(), zXt = Wh2(), l0r = Wh2();
  function lDt(f2, i, t2) {
    for (var h = 0; h < t2.length; h++) {
      var v4 = t2[h];
      i[v4] != null && (f2[v4] = i[v4]);
    }
  }
  var uDt = ["x", "y", "rotation"], u0r = function() {
    function f2() {
      this._labelList = [], this._chartViewList = [];
    }
    return f2.prototype.clearLabels = function() {
      this._labelList = [], this._chartViewList = [];
    }, f2.prototype._addLabel = function(i, t2, h, v4, _) {
      var M2 = v4.style, I2 = v4.__hostTarget, P2 = I2.textConfig || {}, N3 = v4.getComputedTransform(), z3 = v4.getBoundingRect().plain();
      Lc2.applyTransform(z3, z3, N3), N3 ? BT.setLocalTransform(N3) : (BT.x = BT.y = BT.rotation = BT.originX = BT.originY = 0, BT.scaleX = BT.scaleY = 1);
      var H2 = v4.__hostTarget, $;
      if (H2) {
        $ = H2.getBoundingRect().plain();
        var et = H2.getComputedTransform();
        Lc2.applyTransform($, $, et);
      }
      var at = $ && H2.getTextGuideLine();
      this._labelList.push({ label: v4, labelLine: at, seriesModel: h, dataIndex: i, dataType: t2, layoutOption: _, computedLayoutOption: null, rect: z3, hostRect: $, priority: $ ? $.width * $.height : 0, defaultAttr: { ignore: v4.ignore, labelGuideIgnore: at && at.ignore, x: BT.x, y: BT.y, scaleX: BT.scaleX, scaleY: BT.scaleY, rotation: BT.rotation, style: { x: M2.x, y: M2.y, align: M2.align, verticalAlign: M2.verticalAlign, width: M2.width, height: M2.height, fontSize: M2.fontSize }, cursor: v4.cursor, attachedPos: P2.position, attachedRot: P2.rotation } });
    }, f2.prototype.addLabelsOfSeries = function(i) {
      var t2 = this;
      this._chartViewList.push(i);
      var h = i.__model, v4 = h.get("labelLayout");
      !(Ol(v4) || Of2(v4).length) || i.group.traverse(function(_) {
        if (_.ignore)
          return true;
        var M2 = _.getTextContent(), I2 = Du(_);
        M2 && !M2.disableLabelLayout && t2._addLabel(I2.dataIndex, I2.dataType, h, M2, v4);
      });
    }, f2.prototype.updateLayoutConfig = function(i) {
      var t2 = i.getWidth(), h = i.getHeight();
      function v4(zt, Ft) {
        return function() {
          QFe(zt, Ft);
        };
      }
      for (var _ = 0; _ < this._labelList.length; _++) {
        var M2 = this._labelList[_], I2 = M2.label, P2 = I2.__hostTarget, N3 = M2.defaultAttr, z3 = void 0;
        Ol(M2.layoutOption) ? z3 = M2.layoutOption(s0r(M2, P2)) : z3 = M2.layoutOption, z3 = z3 || {}, M2.computedLayoutOption = z3;
        var H2 = Math.PI / 180;
        P2 && P2.setTextConfig({ local: false, position: z3.x != null || z3.y != null ? null : N3.attachedPos, rotation: z3.rotate != null ? z3.rotate * H2 : N3.attachedRot, offset: [z3.dx || 0, z3.dy || 0] });
        var $ = false;
        if (z3.x != null ? (I2.x = cs(z3.x, t2), I2.setStyle("x", 0), $ = true) : (I2.x = N3.x, I2.setStyle("x", N3.style.x)), z3.y != null ? (I2.y = cs(z3.y, h), I2.setStyle("y", 0), $ = true) : (I2.y = N3.y, I2.setStyle("y", N3.style.y)), z3.labelLinePoints) {
          var et = P2.getTextGuideLine();
          et && (et.setShape({ points: z3.labelLinePoints }), $ = false);
        }
        var at = zXt(I2);
        at.needsUpdateLabelLine = $, I2.rotation = z3.rotate != null ? z3.rotate * H2 : N3.rotation, I2.scaleX = N3.scaleX, I2.scaleY = N3.scaleY;
        for (var ht = 0; ht < t8e.length; ht++) {
          var bt = t8e[ht];
          I2.setStyle(bt, z3[bt] != null ? z3[bt] : N3.style[bt]);
        }
        if (z3.draggable) {
          if (I2.draggable = true, I2.cursor = "move", P2) {
            var _t = M2.seriesModel;
            if (M2.dataIndex != null) {
              var Et = M2.seriesModel.getData(M2.dataType);
              _t = Et.getItemModel(M2.dataIndex);
            }
            I2.on("drag", v4(P2, _t.getModel("labelLine")));
          }
        } else
          I2.off("drag"), I2.cursor = N3.cursor;
      }
    }, f2.prototype.layout = function(i) {
      var t2 = i.getWidth(), h = i.getHeight(), v4 = XGe(this._labelList), _ = Ld2(v4, function(P2) {
        return P2.layoutOption.moveOverlap === "shiftX";
      }), M2 = Ld2(v4, function(P2) {
        return P2.layoutOption.moveOverlap === "shiftY";
      });
      a0r(_, 0, t2), JGe(M2, 0, h);
      var I2 = Ld2(v4, function(P2) {
        return P2.layoutOption.hideOverlap;
      });
      tHe(I2);
    }, f2.prototype.processLabelsOverall = function() {
      var i = this;
      Qe2(this._chartViewList, function(t2) {
        var h = t2.__model, v4 = t2.ignoreLabelLineUpdate, _ = h.isAnimationEnabled();
        t2.group.traverse(function(M2) {
          if (M2.ignore && !M2.forceLabelAnimation)
            return true;
          var I2 = !v4, P2 = M2.getTextContent();
          !I2 && P2 && (I2 = zXt(P2).needsUpdateLabelLine), I2 && i._updateLabelLine(M2, h), _ && i._animateLabels(M2, h);
        });
      });
    }, f2.prototype._updateLabelLine = function(i, t2) {
      var h = i.getTextContent(), v4 = Du(i), _ = v4.dataIndex;
      if (h && _ != null) {
        var M2 = t2.getData(v4.dataType), I2 = M2.getItemModel(_), P2 = {}, N3 = M2.getItemVisual(_, "style"), z3 = M2.getVisual("drawType");
        P2.stroke = N3[z3];
        var H2 = I2.getModel("labelLine");
        _ne(i, xne(I2), P2), QFe(i, H2);
      }
    }, f2.prototype._animateLabels = function(i, t2) {
      var h = i.getTextContent(), v4 = i.getTextGuideLine();
      if (h && (i.forceLabelAnimation || !h.ignore && !h.invisible && !i.disableLabelAnimation && !Rtt(i))) {
        var _ = zXt(h), M2 = _.oldLayout, I2 = Du(i), P2 = I2.dataIndex, N3 = { x: h.x, y: h.y, rotation: h.rotation }, z3 = t2.getData(I2.dataType);
        if (M2) {
          h.attr(M2);
          var $ = i.prevStates;
          $ && (Pc2($, "select") >= 0 && h.attr(_.oldLayoutSelect), Pc2($, "emphasis") >= 0 && h.attr(_.oldLayoutEmphasis)), jh2(h, N3, t2, P2);
        } else if (h.attr(N3), !net(h).valueAnimation) {
          var H2 = _c2(h.style.opacity, 1);
          h.style.opacity = 0, Qv(h, { style: { opacity: H2 } }, t2, P2);
        }
        if (_.oldLayout = N3, h.states.select) {
          var et = _.oldLayoutSelect = {};
          lDt(et, N3, uDt), lDt(et, h.states.select, uDt);
        }
        if (h.states.emphasis) {
          var at = _.oldLayoutEmphasis = {};
          lDt(at, N3, uDt), lDt(at, h.states.emphasis, uDt);
        }
        zje(h, P2, z3, t2, t2);
      }
      if (v4 && !v4.ignore && !v4.invisible) {
        var _ = l0r(v4), M2 = _.oldLayout, ht = { points: v4.shape.points };
        M2 ? (v4.attr({ shape: M2 }), jh2(v4, { shape: ht }, t2)) : (v4.setShape(ht), v4.style.strokePercent = 0, Qv(v4, { style: { strokePercent: 1 } }, t2)), _.oldLayout = ht;
      }
    }, f2;
  }(), c0r = u0r, jXt = Wh2();
  function f0r(f2) {
    f2.registerUpdateLifecycle("series:beforeupdate", function(i, t2, h) {
      var v4 = jXt(t2).labelManager;
      v4 || (v4 = jXt(t2).labelManager = new c0r()), v4.clearLabels();
    }), f2.registerUpdateLifecycle("series:layoutlabels", function(i, t2, h) {
      var v4 = jXt(t2).labelManager;
      h.updatedSeries.forEach(function(_) {
        v4.addLabelsOfSeries(t2.getViewOfSeriesModel(_));
      }), v4.updateLayoutConfig(t2), v4.layout(t2), v4.processLabelsOverall();
    });
  }
  var WXt = Math.sin, GXt = Math.cos, eHe = Math.PI, VH = Math.PI * 2, h0r = 180 / eHe, p0r = function() {
    function f2() {
    }
    return f2.prototype.reset = function(i) {
      this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, i || 4);
    }, f2.prototype.moveTo = function(i, t2) {
      this._add("M", i, t2);
    }, f2.prototype.lineTo = function(i, t2) {
      this._add("L", i, t2);
    }, f2.prototype.bezierCurveTo = function(i, t2, h, v4, _, M2) {
      this._add("C", i, t2, h, v4, _, M2);
    }, f2.prototype.quadraticCurveTo = function(i, t2, h, v4) {
      this._add("Q", i, t2, h, v4);
    }, f2.prototype.arc = function(i, t2, h, v4, _, M2) {
      this.ellipse(i, t2, h, h, 0, v4, _, M2);
    }, f2.prototype.ellipse = function(i, t2, h, v4, _, M2, I2, P2) {
      var N3 = I2 - M2, z3 = !P2, H2 = Math.abs(N3), $ = z7(H2 - VH) || (z3 ? N3 >= VH : -N3 >= VH), et = N3 > 0 ? N3 % VH : N3 % VH + VH, at = false;
      $ ? at = true : z7(H2) ? at = false : at = et >= eHe == !!z3;
      var ht = i + h * GXt(M2), bt = t2 + v4 * WXt(M2);
      this._start && this._add("M", ht, bt);
      var _t = Math.round(_ * h0r);
      if ($) {
        var Et = 1 / this._p, zt = (z3 ? 1 : -1) * (VH - Et);
        this._add("A", h, v4, _t, 1, +z3, i + h * GXt(M2 + zt), t2 + v4 * WXt(M2 + zt)), Et > 0.01 && this._add("A", h, v4, _t, 0, +z3, ht, bt);
      } else {
        var Ft = i + h * GXt(I2), fe2 = t2 + v4 * WXt(I2);
        this._add("A", h, v4, _t, +at, +z3, Ft, fe2);
      }
    }, f2.prototype.rect = function(i, t2, h, v4) {
      this._add("M", i, t2), this._add("l", h, 0), this._add("l", 0, v4), this._add("l", -h, 0), this._add("Z");
    }, f2.prototype.closePath = function() {
      this._d.length > 0 && this._add("Z");
    }, f2.prototype._add = function(i, t2, h, v4, _, M2, I2, P2, N3) {
      for (var z3 = [], H2 = this._p, $ = 1; $ < arguments.length; $++) {
        var et = arguments[$];
        if (isNaN(et)) {
          this._invalid = true;
          return;
        }
        z3.push(Math.round(et * H2) / H2);
      }
      this._d.push(i + z3.join(" ")), this._start = i === "Z";
    }, f2.prototype.generateStr = function() {
      this._str = this._invalid ? "" : this._d.join(""), this._d = [];
    }, f2.prototype.getStr = function() {
      return this._str;
    }, f2;
  }(), nHe = p0r, zdt = "none", d0r = Math.round;
  function g0r(f2) {
    var i = f2.fill;
    return i != null && i !== zdt;
  }
  function v0r(f2) {
    var i = f2.stroke;
    return i != null && i !== zdt;
  }
  var fte = ["lineCap", "miterLimit", "lineJoin"], y0r = Xa2(fte, function(f2) {
    return "stroke-" + f2.toLowerCase();
  });
  function m0r(f2, i, t2, h) {
    var v4 = i.opacity == null ? 1 : i.opacity;
    if (t2 instanceof Ux) {
      f2("opacity", v4);
      return;
    }
    if (g0r(i)) {
      var _ = Wtt(i.fill);
      f2("fill", _.color);
      var M2 = i.fillOpacity != null ? i.fillOpacity * _.opacity * v4 : _.opacity * v4;
      (h || M2 < 1) && f2("fill-opacity", M2);
    } else
      f2("fill", zdt);
    if (v0r(i)) {
      var I2 = Wtt(i.stroke);
      f2("stroke", I2.color);
      var P2 = i.strokeNoScale ? t2.getLineScale() : 1, N3 = P2 ? (i.lineWidth || 0) / P2 : 0, z3 = i.strokeOpacity != null ? i.strokeOpacity * I2.opacity * v4 : I2.opacity * v4, H2 = i.strokeFirst;
      if ((h || N3 !== 1) && f2("stroke-width", N3), (h || H2) && f2("paint-order", H2 ? "stroke" : "fill"), (h || z3 < 1) && f2("stroke-opacity", z3), i.lineDash) {
        var $ = lne(t2), et = $[0], at = $[1];
        et && (at = d0r(at || 0), f2("stroke-dasharray", et.join(",")), (at || h) && f2("stroke-dashoffset", at));
      } else
        h && f2("stroke-dasharray", zdt);
      for (var ht = 0; ht < fte.length; ht++) {
        var bt = fte[ht];
        if (h || i[bt] !== gEt[bt]) {
          var _t = i[bt] || gEt[bt];
          _t && f2(y0r[ht], _t);
        }
      }
    } else
      h && f2("stroke", zdt);
  }
  var rHe = "http://www.w3.org/2000/svg", iHe = "http://www.w3.org/1999/xlink", b0r = "http://www.w3.org/2000/xmlns/", _0r = "http://www.w3.org/XML/1998/namespace";
  function aHe(f2) {
    return document.createElementNS(rHe, f2);
  }
  function hb2(f2, i, t2, h, v4) {
    return { tag: f2, attrs: t2 || {}, children: h, text: v4, key: i };
  }
  function x0r(f2, i) {
    var t2 = [];
    if (i)
      for (var h in i) {
        var v4 = i[h], _ = h;
        v4 !== false && (v4 !== true && v4 != null && (_ += '="' + v4 + '"'), t2.push(_));
      }
    return "<" + f2 + " " + t2.join(" ") + ">";
  }
  function w0r(f2) {
    return "</" + f2 + ">";
  }
  function wne(f2, i) {
    i = i || {};
    var t2 = i.newline ? `
` : "";
    function h(v4) {
      var _ = v4.children, M2 = v4.tag, I2 = v4.attrs;
      return x0r(M2, I2) + (v4.text || "") + (_ ? "" + t2 + Xa2(_, function(P2) {
        return h(P2);
      }).join(t2) + t2 : "") + w0r(M2);
    }
    return h(f2);
  }
  function S0r(f2, i, t2) {
    t2 = t2 || {};
    var h = t2.newline ? `
` : "", v4 = " {" + h, _ = h + "}", M2 = Xa2(Of2(f2), function(P2) {
      return P2 + v4 + Xa2(Of2(f2[P2]), function(N3) {
        return N3 + ":" + f2[P2][N3] + ";";
      }).join(h) + _;
    }).join(h), I2 = Xa2(Of2(i), function(P2) {
      return "@keyframes " + P2 + v4 + Xa2(Of2(i[P2]), function(N3) {
        return N3 + v4 + Xa2(Of2(i[P2][N3]), function(z3) {
          var H2 = i[P2][N3][z3];
          return z3 === "d" && (H2 = 'path("' + H2 + '")'), z3 + ":" + H2 + ";";
        }).join(h) + _;
      }).join(h) + _;
    }).join(h);
    return !M2 && !I2 ? "" : ["<![CDATA[", M2, I2, "]]>"].join(h);
  }
  function hte(f2) {
    return { zrId: f2, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
  }
  function e8e(f2, i, t2, h) {
    return hb2("svg", "root", { width: f2, height: i, xmlns: rHe, "xmlns:xlink": iHe, version: "1.1", baseProfile: "full", viewBox: h ? "0 0 " + f2 + " " + i : false }, t2);
  }
  var n8e = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, GH = "transform-origin";
  function M0r(f2, i, t2) {
    var h = ba2({}, f2.shape);
    ba2(h, i), f2.buildPath(t2, h);
    var v4 = new nHe();
    return v4.reset(bze(f2)), t2.rebuildPath(v4, 1), v4.generateStr(), v4.getStr();
  }
  function C0r(f2, i) {
    var t2 = i.originX, h = i.originY;
    (t2 || h) && (f2[GH] = t2 + "px " + h + "px");
  }
  var T0r = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
  function oHe(f2, i) {
    var t2 = i.zrId + "-ani-" + i.cssAnimIdx++;
    return i.cssAnims[t2] = f2, t2;
  }
  function A0r(f2, i, t2) {
    var h = f2.shape.paths, v4 = {}, _, M2;
    if (Qe2(h, function(P2) {
      var N3 = hte(t2.zrId);
      N3.animation = true, Nkt(P2, {}, N3, true);
      var z3 = N3.cssAnims, H2 = N3.cssNodes, $ = Of2(z3), et = $.length;
      if (!!et) {
        M2 = $[et - 1];
        var at = z3[M2];
        for (var ht in at) {
          var bt = at[ht];
          v4[ht] = v4[ht] || { d: "" }, v4[ht].d += bt.d || "";
        }
        for (var _t in H2) {
          var Et = H2[_t].animation;
          Et.indexOf(M2) >= 0 && (_ = Et);
        }
      }
    }), !!_) {
      i.d = false;
      var I2 = oHe(v4, t2);
      return _.replace(M2, I2);
    }
  }
  function r8e(f2) {
    return ms(f2) ? n8e[f2] ? "cubic-bezier(" + n8e[f2] + ")" : Mee(f2) ? f2 : "" : "";
  }
  function Nkt(f2, i, t2, h) {
    var v4 = f2.animators, _ = v4.length, M2 = [];
    if (f2 instanceof jee) {
      var I2 = A0r(f2, i, t2);
      if (I2)
        M2.push(I2);
      else if (!_)
        return;
    } else if (!_)
      return;
    for (var P2 = {}, N3 = 0; N3 < _; N3++) {
      var z3 = v4[N3], H2 = [z3.getMaxTime() / 1e3 + "s"], $ = r8e(z3.getClip().easing), et = z3.getDelay();
      $ ? H2.push($) : H2.push("linear"), et && H2.push(et / 1e3 + "s"), z3.getLoop() && H2.push("infinite");
      var at = H2.join(" ");
      P2[at] = P2[at] || [at, []], P2[at][1].push(z3);
    }
    function ht(Et) {
      var zt = Et[1], Ft = zt.length, fe2 = {}, re2 = {}, ye = {}, me2 = "animation-timing-function";
      function be2(es, Ws, il) {
        for (var bs = es.getTracks(), Rl = es.getMaxTime(), Mh2 = 0; Mh2 < bs.length; Mh2++) {
          var au = bs[Mh2];
          if (au.needsAnimate()) {
            var eh2 = au.keyframes, Gh2 = au.propName;
            if (il && (Gh2 = il(Gh2)), Gh2)
              for (var Pp = 0; Pp < eh2.length; Pp++) {
                var zy = eh2[Pp], Rd2 = Math.round(zy.time / Rl * 100) + "%", c1 = r8e(zy.easing), _d = zy.rawValue;
                (ms(_d) || vp(_d)) && (Ws[Rd2] = Ws[Rd2] || {}, Ws[Rd2][Gh2] = zy.rawValue, c1 && (Ws[Rd2][me2] = c1));
              }
          }
        }
      }
      for (var Te2 = 0; Te2 < Ft; Te2++) {
        var We = zt[Te2], en = We.targetName;
        en ? en === "shape" && be2(We, re2) : !h && be2(We, fe2);
      }
      for (var Ue2 in fe2) {
        var Mn = {};
        Mze(Mn, f2), ba2(Mn, fe2[Ue2]);
        var Vn = _ze(Mn), xn = fe2[Ue2][me2];
        ye[Ue2] = Vn ? { transform: Vn } : {}, C0r(ye[Ue2], Mn), xn && (ye[Ue2][me2] = xn);
      }
      var Zr, nr = true;
      for (var Ue2 in re2) {
        ye[Ue2] = ye[Ue2] || {};
        var pr = !Zr, xn = re2[Ue2][me2];
        pr && (Zr = new HL());
        var Nr = Zr.len();
        Zr.reset(), ye[Ue2].d = M0r(f2, re2[Ue2], Zr);
        var ai2 = Zr.len();
        if (!pr && Nr !== ai2) {
          nr = false;
          break;
        }
        xn && (ye[Ue2][me2] = xn);
      }
      if (!nr)
        for (var Ue2 in ye)
          delete ye[Ue2].d;
      if (!h)
        for (var Te2 = 0; Te2 < Ft; Te2++) {
          var We = zt[Te2], en = We.targetName;
          en === "style" && be2(We, ye, function(bs) {
            return T0r[bs];
          });
        }
      for (var gi2 = Of2(ye), To = true, us, Te2 = 1; Te2 < gi2.length; Te2++) {
        var ml = gi2[Te2 - 1], ll = gi2[Te2];
        if (ye[ml][GH] !== ye[ll][GH]) {
          To = false;
          break;
        }
        us = ye[ml][GH];
      }
      if (To && us) {
        for (var Ue2 in ye)
          ye[Ue2][GH] && delete ye[Ue2][GH];
        i[GH] = us;
      }
      if (Ld2(gi2, function(es) {
        return Of2(ye[es]).length > 0;
      }).length) {
        var Rs = oHe(ye, t2);
        return Rs + " " + Et[0] + " both";
      }
    }
    for (var bt in P2) {
      var I2 = ht(P2[bt]);
      I2 && M2.push(I2);
    }
    if (M2.length) {
      var _t = t2.zrId + "-cls-" + t2.cssClassIdx++;
      t2.cssNodes["." + _t] = { animation: M2.join(",") }, i.class = _t;
    }
  }
  var cgt = Math.round;
  function sHe(f2) {
    return f2 && ms(f2.src);
  }
  function lHe(f2) {
    return f2 && Ol(f2.toDataURL);
  }
  function Sne(f2, i, t2, h) {
    m0r(function(v4, _) {
      var M2 = v4 === "fill" || v4 === "stroke";
      M2 && xur(_) ? R0r(i, f2, v4, h) : M2 && _ur(_) ? N0r(t2, f2, v4, h) : f2[v4] = _;
    }, i, t2, false), O0r(t2, f2, h);
  }
  function i8e(f2) {
    return z7(f2[0] - 1) && z7(f2[1]) && z7(f2[2]) && z7(f2[3] - 1);
  }
  function I0r(f2) {
    return z7(f2[4]) && z7(f2[5]);
  }
  function Mne(f2, i, t2) {
    if (i && !(I0r(i) && i8e(i))) {
      var h = t2 ? 10 : 1e4;
      f2.transform = i8e(i) ? "translate(" + cgt(i[4] * h) / h + " " + cgt(i[5] * h) / h + ")" : dur(i);
    }
  }
  function a8e(f2, i, t2) {
    for (var h = f2.points, v4 = [], _ = 0; _ < h.length; _++)
      v4.push(cgt(h[_][0] * t2) / t2), v4.push(cgt(h[_][1] * t2) / t2);
    i.points = v4.join(" ");
  }
  function o8e(f2) {
    return !f2.smooth;
  }
  function D0r(f2) {
    var i = Xa2(f2, function(t2) {
      return typeof t2 == "string" ? [t2, t2] : t2;
    });
    return function(t2, h, v4) {
      for (var _ = 0; _ < i.length; _++) {
        var M2 = i[_], I2 = t2[M2[0]];
        I2 != null && (h[M2[1]] = cgt(I2 * v4) / v4);
      }
    };
  }
  var E0r = { circle: [D0r(["cx", "cy", "r"])], polyline: [a8e, o8e], polygon: [a8e, o8e] };
  function k0r(f2) {
    for (var i = f2.animators, t2 = 0; t2 < i.length; t2++)
      if (i[t2].targetName === "shape")
        return true;
    return false;
  }
  function uHe(f2, i) {
    var t2 = f2.style, h = f2.shape, v4 = E0r[f2.type], _ = {}, M2 = i.animation, I2 = "path", P2 = f2.style.strokePercent, N3 = i.compress && bze(f2) || 4;
    if (v4 && !i.willUpdate && !(v4[1] && !v4[1](h)) && !(M2 && k0r(f2)) && !(P2 < 1)) {
      I2 = f2.type;
      var z3 = Math.pow(10, N3);
      v4[0](h, _, z3);
    } else {
      f2.path || f2.createPathProxy();
      var H2 = f2.path;
      f2.shapeChanged() && (H2.beginPath(), f2.buildPath(H2, f2.shape), f2.pathUpdated());
      var $ = H2.getVersion(), et = f2, at = et.__svgPathBuilder;
      (et.__svgPathVersion !== $ || !at || P2 !== et.__svgPathStrokePercent) && (at || (at = et.__svgPathBuilder = new nHe()), at.reset(N3), H2.rebuildPath(at, P2), at.generateStr(), et.__svgPathVersion = $, et.__svgPathStrokePercent = P2), _.d = at.getStr();
    }
    return Mne(_, f2.transform), Sne(_, t2, f2, i), i.animation && Nkt(f2, _, i), hb2(I2, f2.id + "", _);
  }
  function P0r(f2, i) {
    var t2 = f2.style, h = t2.image;
    if (h && !ms(h) && (sHe(h) ? h = h.src : lHe(h) && (h = h.toDataURL())), !!h) {
      var v4 = t2.x || 0, _ = t2.y || 0, M2 = t2.width, I2 = t2.height, P2 = { href: h, width: M2, height: I2 };
      return v4 && (P2.x = v4), _ && (P2.y = _), Mne(P2, f2.transform), Sne(P2, t2, f2, i), i.animation && Nkt(f2, P2, i), hb2("image", f2.id + "", P2);
    }
  }
  function L0r(f2, i) {
    var t2 = f2.style, h = t2.text;
    if (h != null && (h += ""), !(!h || isNaN(t2.x) || isNaN(t2.y))) {
      var v4 = t2.font || K7, _ = t2.x || 0, M2 = vur(t2.y || 0, ckt(v4), t2.textBaseline), I2 = gur[t2.textAlign] || t2.textAlign, P2 = { "dominant-baseline": "central", "text-anchor": I2 };
      if (nje(t2)) {
        var N3 = "", z3 = t2.fontStyle, H2 = eje(t2.fontSize);
        if (!parseFloat(H2))
          return;
        var $ = t2.fontFamily || YBe, et = t2.fontWeight;
        N3 += "font-size:" + H2 + ";font-family:" + $ + ";", z3 && z3 !== "normal" && (N3 += "font-style:" + z3 + ";"), et && et !== "normal" && (N3 += "font-weight:" + et + ";"), P2.style = N3;
      } else
        P2.style = "font: " + v4;
      return h.match(/\s/) && (P2["xml:space"] = "preserve"), _ && (P2.x = _), M2 && (P2.y = M2), Mne(P2, f2.transform), Sne(P2, t2, f2, i), i.animation && Nkt(f2, P2, i), hb2("text", f2.id + "", P2, void 0, h);
    }
  }
  function s8e(f2, i) {
    if (f2 instanceof Uc2)
      return uHe(f2, i);
    if (f2 instanceof Ux)
      return P0r(f2, i);
    if (f2 instanceof Xdt)
      return L0r(f2, i);
  }
  function O0r(f2, i, t2) {
    var h = f2.style;
    if (yur(h)) {
      var v4 = mur(f2), _ = t2.shadowCache, M2 = _[v4];
      if (!M2) {
        var I2 = f2.getGlobalScale(), P2 = I2[0], N3 = I2[1];
        if (!P2 || !N3)
          return;
        var z3 = h.shadowOffsetX || 0, H2 = h.shadowOffsetY || 0, $ = h.shadowBlur, et = Wtt(h.shadowColor), at = et.opacity, ht = et.color, bt = $ / 2 / P2, _t = $ / 2 / N3, Et = bt + " " + _t;
        M2 = t2.zrId + "-s" + t2.shadowIdx++, t2.defs[M2] = hb2("filter", M2, { id: M2, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [hb2("feDropShadow", "", { dx: z3 / P2, dy: H2 / N3, stdDeviation: Et, "flood-color": ht, "flood-opacity": at })]), _[v4] = M2;
      }
      i.filter = lkt(M2);
    }
  }
  function R0r(f2, i, t2, h) {
    var v4 = f2[t2], _, M2 = { gradientUnits: v4.global ? "userSpaceOnUse" : "objectBoundingBox" };
    if (yze(v4))
      _ = "linearGradient", M2.x1 = v4.x, M2.y1 = v4.y, M2.x2 = v4.x2, M2.y2 = v4.y2;
    else if (mze(v4))
      _ = "radialGradient", M2.cx = _c2(v4.x, 0.5), M2.cy = _c2(v4.y, 0.5), M2.r = _c2(v4.r, 0.5);
    else
      return;
    for (var I2 = v4.colorStops, P2 = [], N3 = 0, z3 = I2.length; N3 < z3; ++N3) {
      var H2 = TJt(I2[N3].offset) * 100 + "%", $ = I2[N3].color, et = Wtt($), at = et.color, ht = et.opacity, bt = { offset: H2 };
      bt["stop-color"] = at, ht < 1 && (bt["stop-opacity"] = ht), P2.push(hb2("stop", N3 + "", bt));
    }
    var _t = hb2(_, "", M2, P2), Et = wne(_t), zt = h.gradientCache, Ft = zt[Et];
    Ft || (Ft = h.zrId + "-g" + h.gradientIdx++, zt[Et] = Ft, M2.id = Ft, h.defs[Ft] = hb2(_, Ft, M2, P2)), i[t2] = lkt(Ft);
  }
  function N0r(f2, i, t2, h) {
    var v4 = f2.style[t2], _ = { patternUnits: "userSpaceOnUse" }, M2;
    if (vze(v4)) {
      var I2 = v4.imageWidth, P2 = v4.imageHeight, N3 = void 0, z3 = v4.image;
      if (ms(z3) ? N3 = z3 : sHe(z3) ? N3 = z3.src : lHe(z3) && (N3 = z3.toDataURL()), typeof Image == "undefined") {
        var H2 = "Image width/height must been given explictly in svg-ssr renderer.";
        z2(I2, H2), z2(P2, H2);
      } else if (I2 == null || P2 == null) {
        var $ = function(Et, zt) {
          if (Et) {
            var Ft = Et.elm, fe2 = Et.attrs.width = I2 || zt.width, re2 = Et.attrs.height = P2 || zt.height;
            Ft && (Ft.setAttribute("width", fe2), Ft.setAttribute("height", re2));
          }
        }, et = Lee(N3, null, f2, function(Et) {
          $(at, Et), $(M2, Et);
        });
        et && et.width && et.height && (I2 = I2 || et.width, P2 = P2 || et.height);
      }
      M2 = hb2("image", "img", { href: N3, width: I2, height: P2 }), _.width = I2, _.height = P2;
    } else
      v4.svgElement && (M2 = pu(v4.svgElement), _.width = v4.svgWidth, _.height = v4.svgHeight);
    if (!!M2) {
      _.patternTransform = _ze(v4);
      var at = hb2("pattern", "", _, [M2]), ht = wne(at), bt = h.patternCache, _t = bt[ht];
      _t || (_t = h.zrId + "-p" + h.patternIdx++, bt[ht] = _t, _.id = _t, at = h.defs[_t] = hb2("pattern", _t, _, [M2])), i[t2] = lkt(_t);
    }
  }
  function F0r(f2, i, t2) {
    var h = t2.clipPathCache, v4 = t2.defs, _ = h[f2.id];
    if (!_) {
      _ = t2.zrId + "-c" + t2.clipPathIdx++;
      var M2 = { id: _ };
      h[f2.id] = _, v4[_] = hb2("clipPath", _, M2, [uHe(f2, t2)]);
    }
    i["clip-path"] = lkt(_);
  }
  function l8e(f2) {
    return document.createTextNode(f2);
  }
  function XH(f2, i, t2) {
    f2.insertBefore(i, t2);
  }
  function u8e(f2, i) {
    f2.removeChild(i);
  }
  function c8e(f2, i) {
    f2.appendChild(i);
  }
  function cHe(f2) {
    return f2.parentNode;
  }
  function fHe(f2) {
    return f2.nextSibling;
  }
  function HXt(f2, i) {
    f2.textContent = i;
  }
  var f8e = 58, V0r = 120, B0r = hb2("", "");
  function pte(f2) {
    return f2 === void 0;
  }
  function DL(f2) {
    return f2 !== void 0;
  }
  function z0r(f2, i, t2) {
    for (var h = {}, v4 = i; v4 <= t2; ++v4) {
      var _ = f2[v4].key;
      _ !== void 0 && (h[_] = v4);
    }
    return h;
  }
  function xdt(f2, i) {
    var t2 = f2.key === i.key, h = f2.tag === i.tag;
    return h && t2;
  }
  function fgt(f2) {
    var i, t2 = f2.children, h = f2.tag;
    if (DL(h)) {
      var v4 = f2.elm = aHe(h);
      if (Cne(B0r, f2), Za2(t2))
        for (i = 0; i < t2.length; ++i) {
          var _ = t2[i];
          _ != null && c8e(v4, fgt(_));
        }
      else
        DL(f2.text) && !Xl(f2.text) && c8e(v4, l8e(f2.text));
    } else
      f2.elm = l8e(f2.text);
    return f2.elm;
  }
  function hHe(f2, i, t2, h, v4) {
    for (; h <= v4; ++h) {
      var _ = t2[h];
      _ != null && XH(f2, fgt(_), i);
    }
  }
  function OEt(f2, i, t2, h) {
    for (; t2 <= h; ++t2) {
      var v4 = i[t2];
      if (v4 != null)
        if (DL(v4.tag)) {
          var _ = cHe(v4.elm);
          u8e(_, v4.elm);
        } else
          u8e(f2, v4.elm);
    }
  }
  function Cne(f2, i) {
    var t2, h = i.elm, v4 = f2 && f2.attrs || {}, _ = i.attrs || {};
    if (v4 !== _) {
      for (t2 in _) {
        var M2 = _[t2], I2 = v4[t2];
        I2 !== M2 && (M2 === true ? h.setAttribute(t2, "") : M2 === false ? h.removeAttribute(t2) : t2.charCodeAt(0) !== V0r ? h.setAttribute(t2, M2) : t2 === "xmlns:xlink" || t2 === "xmlns" ? h.setAttributeNS(b0r, t2, M2) : t2.charCodeAt(3) === f8e ? h.setAttributeNS(_0r, t2, M2) : t2.charCodeAt(5) === f8e ? h.setAttributeNS(iHe, t2, M2) : h.setAttribute(t2, M2));
      }
      for (t2 in v4)
        t2 in _ || h.removeAttribute(t2);
    }
  }
  function j0r(f2, i, t2) {
    for (var h = 0, v4 = 0, _ = i.length - 1, M2 = i[0], I2 = i[_], P2 = t2.length - 1, N3 = t2[0], z3 = t2[P2], H2, $, et, at; h <= _ && v4 <= P2; )
      M2 == null ? M2 = i[++h] : I2 == null ? I2 = i[--_] : N3 == null ? N3 = t2[++v4] : z3 == null ? z3 = t2[--P2] : xdt(M2, N3) ? (wtt(M2, N3), M2 = i[++h], N3 = t2[++v4]) : xdt(I2, z3) ? (wtt(I2, z3), I2 = i[--_], z3 = t2[--P2]) : xdt(M2, z3) ? (wtt(M2, z3), XH(f2, M2.elm, fHe(I2.elm)), M2 = i[++h], z3 = t2[--P2]) : xdt(I2, N3) ? (wtt(I2, N3), XH(f2, I2.elm, M2.elm), I2 = i[--_], N3 = t2[++v4]) : (pte(H2) && (H2 = z0r(i, h, _)), $ = H2[N3.key], pte($) ? XH(f2, fgt(N3), M2.elm) : (et = i[$], et.tag !== N3.tag ? XH(f2, fgt(N3), M2.elm) : (wtt(et, N3), i[$] = void 0, XH(f2, et.elm, M2.elm))), N3 = t2[++v4]);
    (h <= _ || v4 <= P2) && (h > _ ? (at = t2[P2 + 1] == null ? null : t2[P2 + 1].elm, hHe(f2, at, t2, v4, P2)) : OEt(f2, i, h, _));
  }
  function wtt(f2, i) {
    var t2 = i.elm = f2.elm, h = f2.children, v4 = i.children;
    f2 !== i && (Cne(f2, i), pte(i.text) ? DL(h) && DL(v4) ? h !== v4 && j0r(t2, h, v4) : DL(v4) ? (DL(f2.text) && HXt(t2, ""), hHe(t2, null, v4, 0, v4.length - 1)) : DL(h) ? OEt(t2, h, 0, h.length - 1) : DL(f2.text) && HXt(t2, "") : f2.text !== i.text && (DL(h) && OEt(t2, h, 0, h.length - 1), HXt(t2, i.text)));
  }
  function W0r(f2, i) {
    if (xdt(f2, i))
      wtt(f2, i);
    else {
      var t2 = f2.elm, h = cHe(t2);
      fgt(i), h !== null && (XH(h, i.elm, fHe(t2)), OEt(h, [f2], 0, 0));
    }
    return i;
  }
  var G0r = 0, H0r = function() {
    function f2(i, t2, h) {
      if (this.type = "svg", this.refreshHover = h8e(), this.configLayer = h8e(), this.storage = t2, this._opts = h = ba2({}, h), this.root = i, this._id = "zr" + G0r++, this._oldVNode = e8e(h.width, h.height), i && !h.ssr) {
        var v4 = this._viewport = document.createElement("div");
        v4.style.cssText = "position:relative;overflow:hidden";
        var _ = this._svgDom = this._oldVNode.elm = aHe("svg");
        Cne(null, this._oldVNode), v4.appendChild(_), i.appendChild(v4);
      }
      this.resize(h.width, h.height);
    }
    return f2.prototype.getType = function() {
      return this.type;
    }, f2.prototype.getViewportRoot = function() {
      return this._viewport;
    }, f2.prototype.getViewportRootOffset = function() {
      var i = this.getViewportRoot();
      if (i)
        return { offsetLeft: i.offsetLeft || 0, offsetTop: i.offsetTop || 0 };
    }, f2.prototype.getSvgDom = function() {
      return this._svgDom;
    }, f2.prototype.refresh = function() {
      if (this.root) {
        var i = this.renderToVNode({ willUpdate: true });
        i.attrs.style = "position:absolute;left:0;top:0;user-select:none", W0r(this._oldVNode, i), this._oldVNode = i;
      }
    }, f2.prototype.renderOneToVNode = function(i) {
      return s8e(i, hte(this._id));
    }, f2.prototype.renderToVNode = function(i) {
      i = i || {};
      var t2 = this.storage.getDisplayList(true), h = this._backgroundColor, v4 = this._width, _ = this._height, M2 = hte(this._id);
      M2.animation = i.animation, M2.willUpdate = i.willUpdate, M2.compress = i.compress;
      var I2 = [];
      if (h && h !== "none") {
        var P2 = Wtt(h), N3 = P2.color, z3 = P2.opacity;
        this._bgVNode = hb2("rect", "bg", { width: v4, height: _, x: "0", y: "0", id: "0", fill: N3, "fill-opacity": z3 }), I2.push(this._bgVNode);
      } else
        this._bgVNode = null;
      var H2 = i.compress ? null : this._mainVNode = hb2("g", "main", {}, []);
      this._paintList(t2, M2, H2 ? H2.children : I2), H2 && I2.push(H2);
      var $ = Xa2(Of2(M2.defs), function(ht) {
        return M2.defs[ht];
      });
      if ($.length && I2.push(hb2("defs", "defs", {}, $)), i.animation) {
        var et = S0r(M2.cssNodes, M2.cssAnims, { newline: true });
        if (et) {
          var at = hb2("style", "stl", {}, [], et);
          I2.push(at);
        }
      }
      return e8e(v4, _, I2, i.useViewBox);
    }, f2.prototype.renderToString = function(i) {
      return i = i || {}, wne(this.renderToVNode({ animation: _c2(i.cssAnimation, true), willUpdate: false, compress: true, useViewBox: _c2(i.useViewBox, true) }), { newline: true });
    }, f2.prototype.setBackgroundColor = function(i) {
      this._backgroundColor = i;
      var t2 = this._bgVNode;
      if (t2 && t2.elm) {
        var h = Wtt(i), v4 = h.color, _ = h.opacity;
        t2.elm.setAttribute("fill", v4), _ < 1 && t2.elm.setAttribute("fill-opacity", _);
      }
    }, f2.prototype.getSvgRoot = function() {
      return this._mainVNode && this._mainVNode.elm;
    }, f2.prototype._paintList = function(i, t2, h) {
      for (var v4 = i.length, _ = [], M2 = 0, I2, P2, N3 = 0, z3 = 0; z3 < v4; z3++) {
        var H2 = i[z3];
        if (!H2.invisible) {
          var $ = H2.__clipPaths, et = $ && $.length || 0, at = P2 && P2.length || 0, ht = void 0;
          for (ht = Math.max(et - 1, at - 1); ht >= 0 && !($ && P2 && $[ht] === P2[ht]); ht--)
            ;
          for (var bt = at - 1; bt > ht; bt--)
            M2--, I2 = _[M2 - 1];
          for (var _t = ht + 1; _t < et; _t++) {
            var Et = {};
            F0r($[_t], Et, t2);
            var zt = hb2("g", "clip-g-" + N3++, Et, []);
            (I2 ? I2.children : h).push(zt), _[M2++] = zt, I2 = zt;
          }
          P2 = $;
          var Ft = s8e(H2, t2);
          Ft && (I2 ? I2.children : h).push(Ft);
        }
      }
    }, f2.prototype.resize = function(i, t2) {
      var h = this._opts, v4 = this.root, _ = this._viewport;
      if (i != null && (h.width = i), t2 != null && (h.height = t2), v4 && _ && (_.style.display = "none", i = Dtt(v4, 0, h), t2 = Dtt(v4, 1, h), _.style.display = ""), this._width !== i || this._height !== t2) {
        if (this._width = i, this._height = t2, _) {
          var M2 = _.style;
          M2.width = i + "px", M2.height = t2 + "px";
        }
        var I2 = this._svgDom;
        I2 && (I2.setAttribute("width", i), I2.setAttribute("height", t2));
      }
    }, f2.prototype.getWidth = function() {
      return this._width;
    }, f2.prototype.getHeight = function() {
      return this._height;
    }, f2.prototype.dispose = function() {
      this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
    }, f2.prototype.clear = function() {
      this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
    }, f2.prototype.toDataURL = function(i) {
      var t2 = encodeURIComponent(this.renderToString()), h = "data:image/svg+xml;";
      return i ? (t2 = wur(t2), t2 && h + "base64," + t2) : h + "charset=UTF-8," + t2;
    }, f2;
  }();
  function h8e(f2) {
    return function() {
    };
  }
  var U0r = H0r;
  function q0r(f2) {
    f2.registerPainter("svg", U0r);
  }
  function p8e(f2, i, t2) {
    var h = Q6.createCanvas(), v4 = i.getWidth(), _ = i.getHeight(), M2 = h.style;
    return M2 && (M2.position = "absolute", M2.left = "0", M2.top = "0", M2.width = v4 + "px", M2.height = _ + "px", h.setAttribute("data-zr-dom-id", f2)), h.width = v4 * t2, h.height = _ * t2, h;
  }
  var Z0r = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this) || this;
      _.motionBlur = false, _.lastFrameAlpha = 0.7, _.dpr = 1, _.virtual = false, _.config = {}, _.incremental = false, _.zlevel = 0, _.maxRepaintRectCount = 5, _.__dirty = true, _.__firstTimePaint = true, _.__used = false, _.__drawIndex = 0, _.__startIndex = 0, _.__endIndex = 0, _.__prevStartIndex = null, _.__prevEndIndex = null;
      var M2;
      v4 = v4 || hEt, typeof t2 == "string" ? M2 = p8e(t2, h, v4) : Xl(t2) && (M2 = t2, t2 = M2.id), _.id = t2, _.dom = M2;
      var I2 = M2.style;
      return I2 && (tze(M2), M2.onselectstart = function() {
        return false;
      }, I2.padding = "0", I2.margin = "0", I2.borderWidth = "0"), _.painter = h, _.dpr = v4, _;
    }
    return i.prototype.getElementCount = function() {
      return this.__endIndex - this.__startIndex;
    }, i.prototype.afterBrush = function() {
      this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
    }, i.prototype.initContext = function() {
      this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
    }, i.prototype.setUnpainted = function() {
      this.__firstTimePaint = true;
    }, i.prototype.createBackBuffer = function() {
      var t2 = this.dpr;
      this.domBack = p8e("back-" + this.id, this.painter, t2), this.ctxBack = this.domBack.getContext("2d"), t2 !== 1 && this.ctxBack.scale(t2, t2);
    }, i.prototype.createRepaintRects = function(t2, h, v4, _) {
      if (this.__firstTimePaint)
        return this.__firstTimePaint = false, null;
      var M2 = [], I2 = this.maxRepaintRectCount, P2 = false, N3 = new Lc2(0, 0, 0, 0);
      function z3(Et) {
        if (!(!Et.isFinite() || Et.isZero()))
          if (M2.length === 0) {
            var zt = new Lc2(0, 0, 0, 0);
            zt.copy(Et), M2.push(zt);
          } else {
            for (var Ft = false, fe2 = 1 / 0, re2 = 0, ye = 0; ye < M2.length; ++ye) {
              var me2 = M2[ye];
              if (me2.intersect(Et)) {
                var be2 = new Lc2(0, 0, 0, 0);
                be2.copy(me2), be2.union(Et), M2[ye] = be2, Ft = true;
                break;
              } else if (P2) {
                N3.copy(Et), N3.union(me2);
                var Te2 = Et.width * Et.height, We = me2.width * me2.height, en = N3.width * N3.height, Ue2 = en - Te2 - We;
                Ue2 < fe2 && (fe2 = Ue2, re2 = ye);
              }
            }
            if (P2 && (M2[re2].union(Et), Ft = true), !Ft) {
              var zt = new Lc2(0, 0, 0, 0);
              zt.copy(Et), M2.push(zt);
            }
            P2 || (P2 = M2.length >= I2);
          }
      }
      for (var H2 = this.__startIndex; H2 < this.__endIndex; ++H2) {
        var $ = t2[H2];
        if ($) {
          var et = $.shouldBePainted(v4, _, true, true), at = $.__isRendered && ($.__dirty & UT || !et) ? $.getPrevPaintRect() : null;
          at && z3(at);
          var ht = et && ($.__dirty & UT || !$.__isRendered) ? $.getPaintRect() : null;
          ht && z3(ht);
        }
      }
      for (var H2 = this.__prevStartIndex; H2 < this.__prevEndIndex; ++H2) {
        var $ = h[H2], et = $.shouldBePainted(v4, _, true, true);
        if ($ && (!et || !$.__zr) && $.__isRendered) {
          var at = $.getPrevPaintRect();
          at && z3(at);
        }
      }
      var bt;
      do {
        bt = false;
        for (var H2 = 0; H2 < M2.length; ) {
          if (M2[H2].isZero()) {
            M2.splice(H2, 1);
            continue;
          }
          for (var _t = H2 + 1; _t < M2.length; )
            M2[H2].intersect(M2[_t]) ? (bt = true, M2[H2].union(M2[_t]), M2.splice(_t, 1)) : _t++;
          H2++;
        }
      } while (bt);
      return this._paintRects = M2, M2;
    }, i.prototype.debugGetPaintRects = function() {
      return (this._paintRects || []).slice();
    }, i.prototype.resize = function(t2, h) {
      var v4 = this.dpr, _ = this.dom, M2 = _.style, I2 = this.domBack;
      M2 && (M2.width = t2 + "px", M2.height = h + "px"), _.width = t2 * v4, _.height = h * v4, I2 && (I2.width = t2 * v4, I2.height = h * v4, v4 !== 1 && this.ctxBack.scale(v4, v4));
    }, i.prototype.clear = function(t2, h, v4) {
      var _ = this.dom, M2 = this.ctx, I2 = _.width, P2 = _.height;
      h = h || this.clearColor;
      var N3 = this.motionBlur && !t2, z3 = this.lastFrameAlpha, H2 = this.dpr, $ = this;
      N3 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(_, 0, 0, I2 / H2, P2 / H2));
      var et = this.domBack;
      function at(ht, bt, _t, Et) {
        if (M2.clearRect(ht, bt, _t, Et), h && h !== "transparent") {
          var zt = void 0;
          okt(h) ? (zt = h.__canvasGradient || rte(M2, h, { x: 0, y: 0, width: _t, height: Et }), h.__canvasGradient = zt) : Alr(h) && (zt = ite(M2, h, { dirty: function() {
            $.setUnpainted(), $.__painter.refresh();
          } })), M2.save(), M2.fillStyle = zt || h, M2.fillRect(ht, bt, _t, Et), M2.restore();
        }
        N3 && (M2.save(), M2.globalAlpha = z3, M2.drawImage(et, ht, bt, _t, Et), M2.restore());
      }
      !v4 || N3 ? at(0, 0, I2, P2) : v4.length && Qe2(v4, function(ht) {
        at(ht.x * H2, ht.y * H2, ht.width * H2, ht.height * H2);
      });
    }, i;
  }(iE), UXt = Z0r, d8e = 1e5, BH = 314159, cDt = 0.01, $0r = 1e-3;
  function Y0r(f2) {
    return f2 ? f2.__builtin__ ? true : !(typeof f2.resize != "function" || typeof f2.refresh != "function") : false;
  }
  function K0r(f2, i) {
    var t2 = document.createElement("div");
    return t2.style.cssText = ["position:relative", "width:" + f2 + "px", "height:" + i + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", t2;
  }
  var X0r = function() {
    function f2(i, t2, h, v4) {
      this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
      var _ = !i.nodeName || i.nodeName.toUpperCase() === "CANVAS";
      this._opts = h = ba2({}, h || {}), this.dpr = h.devicePixelRatio || hEt, this._singleCanvas = _, this.root = i;
      var M2 = i.style;
      M2 && (tze(i), i.innerHTML = ""), this.storage = t2;
      var I2 = this._zlevelList;
      this._prevDisplayList = [];
      var P2 = this._layers;
      if (_) {
        var z3 = i, H2 = z3.width, $ = z3.height;
        h.width != null && (H2 = h.width), h.height != null && ($ = h.height), this.dpr = h.devicePixelRatio || 1, z3.width = H2 * this.dpr, z3.height = $ * this.dpr, this._width = H2, this._height = $;
        var et = new UXt(z3, this, this.dpr);
        et.__builtin__ = true, et.initContext(), P2[BH] = et, et.zlevel = BH, I2.push(BH), this._domRoot = i;
      } else {
        this._width = Dtt(i, 0, h), this._height = Dtt(i, 1, h);
        var N3 = this._domRoot = K0r(this._width, this._height);
        i.appendChild(N3);
      }
    }
    return f2.prototype.getType = function() {
      return "canvas";
    }, f2.prototype.isSingleCanvas = function() {
      return this._singleCanvas;
    }, f2.prototype.getViewportRoot = function() {
      return this._domRoot;
    }, f2.prototype.getViewportRootOffset = function() {
      var i = this.getViewportRoot();
      if (i)
        return { offsetLeft: i.offsetLeft || 0, offsetTop: i.offsetTop || 0 };
    }, f2.prototype.refresh = function(i) {
      var t2 = this.storage.getDisplayList(true), h = this._prevDisplayList, v4 = this._zlevelList;
      this._redrawId = Math.random(), this._paintList(t2, h, i, this._redrawId);
      for (var _ = 0; _ < v4.length; _++) {
        var M2 = v4[_], I2 = this._layers[M2];
        if (!I2.__builtin__ && I2.refresh) {
          var P2 = _ === 0 ? this._backgroundColor : null;
          I2.refresh(P2);
        }
      }
      return this._opts.useDirtyRect && (this._prevDisplayList = t2.slice()), this;
    }, f2.prototype.refreshHover = function() {
      this._paintHoverList(this.storage.getDisplayList(false));
    }, f2.prototype._paintHoverList = function(i) {
      var t2 = i.length, h = this._hoverlayer;
      if (h && h.clear(), !!t2) {
        for (var v4 = { inHover: true, viewWidth: this._width, viewHeight: this._height }, _, M2 = 0; M2 < t2; M2++) {
          var I2 = i[M2];
          I2.__inHover && (h || (h = this._hoverlayer = this.getLayer(d8e)), _ || (_ = h.ctx, _.save()), iU(_, I2, v4, M2 === t2 - 1));
        }
        _ && _.restore();
      }
    }, f2.prototype.getHoverLayer = function() {
      return this.getLayer(d8e);
    }, f2.prototype.paintOne = function(i, t2) {
      KWe(i, t2);
    }, f2.prototype._paintList = function(i, t2, h, v4) {
      if (this._redrawId === v4) {
        h = h || false, this._updateLayerStatus(i);
        var _ = this._doPaintList(i, t2, h), M2 = _.finished, I2 = _.needsRefreshHover;
        if (this._needsManuallyCompositing && this._compositeManually(), I2 && this._paintHoverList(i), M2)
          this.eachLayer(function(N3) {
            N3.afterBrush && N3.afterBrush();
          });
        else {
          var P2 = this;
          xJt(function() {
            P2._paintList(i, t2, h, v4);
          });
        }
      }
    }, f2.prototype._compositeManually = function() {
      var i = this.getLayer(BH).ctx, t2 = this._domRoot.width, h = this._domRoot.height;
      i.clearRect(0, 0, t2, h), this.eachBuiltinLayer(function(v4) {
        v4.virtual && i.drawImage(v4.dom, 0, 0, t2, h);
      });
    }, f2.prototype._doPaintList = function(i, t2, h) {
      for (var v4 = this, _ = [], M2 = this._opts.useDirtyRect, I2 = 0; I2 < this._zlevelList.length; I2++) {
        var P2 = this._zlevelList[I2], N3 = this._layers[P2];
        N3.__builtin__ && N3 !== this._hoverlayer && (N3.__dirty || h) && _.push(N3);
      }
      for (var z3 = true, H2 = false, $ = function(ht) {
        var bt = _[ht], _t = bt.ctx, Et = M2 && bt.createRepaintRects(i, t2, et._width, et._height), zt = h ? bt.__startIndex : bt.__drawIndex, Ft = !h && bt.incremental && Date.now, fe2 = Ft && Date.now(), re2 = bt.zlevel === et._zlevelList[0] ? et._backgroundColor : null;
        if (bt.__startIndex === bt.__endIndex)
          bt.clear(false, re2, Et);
        else if (zt === bt.__startIndex) {
          var ye = i[zt];
          (!ye.incremental || !ye.notClear || h) && bt.clear(false, re2, Et);
        }
        zt === -1 && (console.error("For some unknown reason. drawIndex is -1"), zt = bt.__startIndex);
        var me2, be2 = function(Ue2) {
          var Mn = { inHover: false, allClipped: false, prevEl: null, viewWidth: v4._width, viewHeight: v4._height };
          for (me2 = zt; me2 < bt.__endIndex; me2++) {
            var Vn = i[me2];
            if (Vn.__inHover && (H2 = true), v4._doPaintEl(Vn, bt, M2, Ue2, Mn, me2 === bt.__endIndex - 1), Ft) {
              var xn = Date.now() - fe2;
              if (xn > 15)
                break;
            }
          }
          Mn.prevElClipPaths && _t.restore();
        };
        if (Et)
          if (Et.length === 0)
            me2 = bt.__endIndex;
          else
            for (var Te2 = et.dpr, We = 0; We < Et.length; ++We) {
              var en = Et[We];
              _t.save(), _t.beginPath(), _t.rect(en.x * Te2, en.y * Te2, en.width * Te2, en.height * Te2), _t.clip(), be2(en), _t.restore();
            }
        else
          _t.save(), be2(), _t.restore();
        bt.__drawIndex = me2, bt.__drawIndex < bt.__endIndex && (z3 = false);
      }, et = this, at = 0; at < _.length; at++)
        $(at);
      return gp.wxa && Qe2(this._layers, function(ht) {
        ht && ht.ctx && ht.ctx.draw && ht.ctx.draw();
      }), { finished: z3, needsRefreshHover: H2 };
    }, f2.prototype._doPaintEl = function(i, t2, h, v4, _, M2) {
      var I2 = t2.ctx;
      if (h) {
        var P2 = i.getPaintRect();
        (!v4 || P2 && P2.intersect(v4)) && (iU(I2, i, _, M2), i.setPrevPaintRect(P2));
      } else
        iU(I2, i, _, M2);
    }, f2.prototype.getLayer = function(i, t2) {
      this._singleCanvas && !this._needsManuallyCompositing && (i = BH);
      var h = this._layers[i];
      return h || (h = new UXt("zr_" + i, this, this.dpr), h.zlevel = i, h.__builtin__ = true, this._layerConfig[i] ? cc2(h, this._layerConfig[i], true) : this._layerConfig[i - cDt] && cc2(h, this._layerConfig[i - cDt], true), t2 && (h.virtual = t2), this.insertLayer(i, h), h.initContext()), h;
    }, f2.prototype.insertLayer = function(i, t2) {
      var h = this._layers, v4 = this._zlevelList, _ = v4.length, M2 = this._domRoot, I2 = null, P2 = -1;
      if (!h[i] && !!Y0r(t2)) {
        if (_ > 0 && i > v4[0]) {
          for (P2 = 0; P2 < _ - 1 && !(v4[P2] < i && v4[P2 + 1] > i); P2++)
            ;
          I2 = h[v4[P2]];
        }
        if (v4.splice(P2 + 1, 0, i), h[i] = t2, !t2.virtual)
          if (I2) {
            var N3 = I2.dom;
            N3.nextSibling ? M2.insertBefore(t2.dom, N3.nextSibling) : M2.appendChild(t2.dom);
          } else
            M2.firstChild ? M2.insertBefore(t2.dom, M2.firstChild) : M2.appendChild(t2.dom);
        t2.__painter = this;
      }
    }, f2.prototype.eachLayer = function(i, t2) {
      for (var h = this._zlevelList, v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4];
        i.call(t2, this._layers[_], _);
      }
    }, f2.prototype.eachBuiltinLayer = function(i, t2) {
      for (var h = this._zlevelList, v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4], M2 = this._layers[_];
        M2.__builtin__ && i.call(t2, M2, _);
      }
    }, f2.prototype.eachOtherLayer = function(i, t2) {
      for (var h = this._zlevelList, v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4], M2 = this._layers[_];
        M2.__builtin__ || i.call(t2, M2, _);
      }
    }, f2.prototype.getLayers = function() {
      return this._layers;
    }, f2.prototype._updateLayerStatus = function(i) {
      this.eachBuiltinLayer(function(H2, $) {
        H2.__dirty = H2.__used = false;
      });
      function t2(H2) {
        _ && (_.__endIndex !== H2 && (_.__dirty = true), _.__endIndex = H2);
      }
      if (this._singleCanvas)
        for (var h = 1; h < i.length; h++) {
          var v4 = i[h];
          if (v4.zlevel !== i[h - 1].zlevel || v4.incremental) {
            this._needsManuallyCompositing = true;
            break;
          }
        }
      var _ = null, M2 = 0, I2, P2;
      for (P2 = 0; P2 < i.length; P2++) {
        var v4 = i[P2], N3 = v4.zlevel, z3 = void 0;
        I2 !== N3 && (I2 = N3, M2 = 0), v4.incremental ? (z3 = this.getLayer(N3 + $0r, this._needsManuallyCompositing), z3.incremental = true, M2 = 1) : z3 = this.getLayer(N3 + (M2 > 0 ? cDt : 0), this._needsManuallyCompositing), z3.__builtin__ || bee("ZLevel " + N3 + " has been used by unkown layer " + z3.id), z3 !== _ && (z3.__used = true, z3.__startIndex !== P2 && (z3.__dirty = true), z3.__startIndex = P2, z3.incremental ? z3.__drawIndex = -1 : z3.__drawIndex = P2, t2(P2), _ = z3), v4.__dirty & UT && !v4.__inHover && (z3.__dirty = true, z3.incremental && z3.__drawIndex < 0 && (z3.__drawIndex = P2));
      }
      t2(P2), this.eachBuiltinLayer(function(H2, $) {
        !H2.__used && H2.getElementCount() > 0 && (H2.__dirty = true, H2.__startIndex = H2.__endIndex = H2.__drawIndex = 0), H2.__dirty && H2.__drawIndex < 0 && (H2.__drawIndex = H2.__startIndex);
      });
    }, f2.prototype.clear = function() {
      return this.eachBuiltinLayer(this._clearLayer), this;
    }, f2.prototype._clearLayer = function(i) {
      i.clear();
    }, f2.prototype.setBackgroundColor = function(i) {
      this._backgroundColor = i, Qe2(this._layers, function(t2) {
        t2.setUnpainted();
      });
    }, f2.prototype.configLayer = function(i, t2) {
      if (t2) {
        var h = this._layerConfig;
        h[i] ? cc2(h[i], t2, true) : h[i] = t2;
        for (var v4 = 0; v4 < this._zlevelList.length; v4++) {
          var _ = this._zlevelList[v4];
          if (_ === i || _ === i + cDt) {
            var M2 = this._layers[_];
            cc2(M2, h[i], true);
          }
        }
      }
    }, f2.prototype.delLayer = function(i) {
      var t2 = this._layers, h = this._zlevelList, v4 = t2[i];
      !v4 || (v4.dom.parentNode.removeChild(v4.dom), delete t2[i], h.splice(Pc2(h, i), 1));
    }, f2.prototype.resize = function(i, t2) {
      if (this._domRoot.style) {
        var h = this._domRoot;
        h.style.display = "none";
        var v4 = this._opts, _ = this.root;
        if (i != null && (v4.width = i), t2 != null && (v4.height = t2), i = Dtt(_, 0, v4), t2 = Dtt(_, 1, v4), h.style.display = "", this._width !== i || t2 !== this._height) {
          h.style.width = i + "px", h.style.height = t2 + "px";
          for (var M2 in this._layers)
            this._layers.hasOwnProperty(M2) && this._layers[M2].resize(i, t2);
          this.refresh(true);
        }
        this._width = i, this._height = t2;
      } else {
        if (i == null || t2 == null)
          return;
        this._width = i, this._height = t2, this.getLayer(BH).resize(i, t2);
      }
      return this;
    }, f2.prototype.clearLayer = function(i) {
      var t2 = this._layers[i];
      t2 && t2.clear();
    }, f2.prototype.dispose = function() {
      this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
    }, f2.prototype.getRenderedCanvas = function(i) {
      if (i = i || {}, this._singleCanvas && !this._compositeManually)
        return this._layers[BH].dom;
      var t2 = new UXt("image", this, i.pixelRatio || this.dpr);
      t2.initContext(), t2.clear(false, i.backgroundColor || this._backgroundColor);
      var h = t2.ctx;
      if (i.pixelRatio <= this.dpr) {
        this.refresh();
        var v4 = t2.dom.width, _ = t2.dom.height;
        this.eachLayer(function(H2) {
          H2.__builtin__ ? h.drawImage(H2.dom, 0, 0, v4, _) : H2.renderToCanvas && (h.save(), H2.renderToCanvas(h), h.restore());
        });
      } else
        for (var M2 = { inHover: false, viewWidth: this._width, viewHeight: this._height }, I2 = this.storage.getDisplayList(true), P2 = 0, N3 = I2.length; P2 < N3; P2++) {
          var z3 = I2[P2];
          iU(h, z3, M2, P2 === N3 - 1);
        }
      return t2.dom;
    }, f2.prototype.getWidth = function() {
      return this._width;
    }, f2.prototype.getHeight = function() {
      return this._height;
    }, f2;
  }(), Q0r = X0r;
  function J0r(f2) {
    f2.registerPainter("canvas", Q0r);
  }
  var tyr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.hasSymbolVisual = true, t2;
    }
    return i.prototype.getInitialData = function(t2) {
      return aN(null, this, { useEncodeDefaulter: true });
    }, i.prototype.getLegendIcon = function(t2) {
      var h = new mu(), v4 = wm("line", 0, t2.itemHeight / 2, t2.itemWidth, 0, t2.lineStyle.stroke, false);
      h.add(v4), v4.setStyle(t2.lineStyle);
      var _ = this.getData().getVisual("symbol"), M2 = this.getData().getVisual("symbolRotate"), I2 = _ === "none" ? "circle" : _, P2 = t2.itemHeight * 0.8, N3 = wm(I2, (t2.itemWidth - P2) / 2, (t2.itemHeight - P2) / 2, P2, P2, t2.itemStyle.fill);
      h.add(N3), N3.setStyle(t2.itemStyle);
      var z3 = t2.iconRotate === "inherit" ? M2 : t2.iconRotate || 0;
      return N3.rotation = z3 * Math.PI / 180, N3.setOrigin([t2.itemWidth / 2, t2.itemHeight / 2]), I2.indexOf("empty") > -1 && (N3.style.stroke = N3.style.fill, N3.style.fill = "#fff", N3.style.lineWidth = 2), h;
    }, i.type = "series.line", i.dependencies = ["grid", "polar"], i.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, i;
  }(Jv), eyr = tyr;
  function Utt(f2, i) {
    var t2 = f2.mapDimensionsAll("defaultedLabel"), h = t2.length;
    if (h === 1) {
      var v4 = Gtt(f2, i, t2[0]);
      return v4 != null ? v4 + "" : null;
    } else if (h) {
      for (var _ = [], M2 = 0; M2 < t2.length; M2++)
        _.push(Gtt(f2, i, t2[M2]));
      return _.join(" ");
    }
  }
  function pHe(f2, i) {
    var t2 = f2.mapDimensionsAll("defaultedLabel");
    if (!Za2(i))
      return i + "";
    for (var h = [], v4 = 0; v4 < t2.length; v4++) {
      var _ = f2.getDimensionIndex(t2[v4]);
      _ >= 0 && h.push(i[_]);
    }
    return h.join(" ");
  }
  var nyr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _) {
      var M2 = f2.call(this) || this;
      return M2.updateData(t2, h, v4, _), M2;
    }
    return i.prototype._createSymbol = function(t2, h, v4, _, M2) {
      this.removeAll();
      var I2 = wm(t2, -1, -1, 2, 2, null, M2);
      I2.attr({ z2: 100, culling: true, scaleX: _[0] / 2, scaleY: _[1] / 2 }), I2.drift = ryr, this._symbolType = t2, this.add(I2);
    }, i.prototype.stopSymbolAnimation = function(t2) {
      this.childAt(0).stopAnimation(null, t2);
    }, i.prototype.getSymbolType = function() {
      return this._symbolType;
    }, i.prototype.getSymbolPath = function() {
      return this.childAt(0);
    }, i.prototype.highlight = function() {
      NL(this.childAt(0));
    }, i.prototype.downplay = function() {
      FL(this.childAt(0));
    }, i.prototype.setZ = function(t2, h) {
      var v4 = this.childAt(0);
      v4.zlevel = t2, v4.z = h;
    }, i.prototype.setDraggable = function(t2) {
      var h = this.childAt(0);
      h.draggable = t2, h.cursor = t2 ? "move" : h.cursor;
    }, i.prototype.updateData = function(t2, h, v4, _) {
      this.silent = false;
      var M2 = t2.getItemVisual(h, "symbol") || "circle", I2 = t2.hostModel, P2 = i.getSymbolSize(t2, h), N3 = M2 !== this._symbolType, z3 = _ && _.disableAnimation;
      if (N3) {
        var H2 = t2.getItemVisual(h, "symbolKeepAspect");
        this._createSymbol(M2, t2, h, P2, H2);
      } else {
        var $ = this.childAt(0);
        $.silent = false;
        var et = { scaleX: P2[0] / 2, scaleY: P2[1] / 2 };
        z3 ? $.attr(et) : jh2($, et, I2, h), A5($);
      }
      if (this._updateCommon(t2, h, P2, v4, _), N3) {
        var $ = this.childAt(0);
        if (!z3) {
          var et = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: $.style.opacity } };
          $.scaleX = $.scaleY = 0, $.style.opacity = 0, Qv($, et, I2, h);
        }
      }
      z3 && this.childAt(0).stopAnimation("leave");
    }, i.prototype._updateCommon = function(t2, h, v4, _, M2) {
      var I2 = this.childAt(0), P2 = t2.hostModel, N3, z3, H2, $, et, at, ht, bt, _t;
      if (_ && (N3 = _.emphasisItemStyle, z3 = _.blurItemStyle, H2 = _.selectItemStyle, $ = _.focus, et = _.blurScope, ht = _.labelStatesModels, bt = _.hoverScale, _t = _.cursorStyle, at = _.emphasisDisabled), !_ || t2.hasItemOption) {
        var Et = _ && _.itemModel ? _.itemModel : t2.getItemModel(h), zt = Et.getModel("emphasis");
        N3 = zt.getModel("itemStyle").getItemStyle(), H2 = Et.getModel(["select", "itemStyle"]).getItemStyle(), z3 = Et.getModel(["blur", "itemStyle"]).getItemStyle(), $ = zt.get("focus"), et = zt.get("blurScope"), at = zt.get("disabled"), ht = b_(Et), bt = zt.getShallow("scale"), _t = Et.getShallow("cursor");
      }
      var Ft = t2.getItemVisual(h, "symbolRotate");
      I2.attr("rotation", (Ft || 0) * Math.PI / 180 || 0);
      var fe2 = fet(t2.getItemVisual(h, "symbolOffset"), v4);
      fe2 && (I2.x = fe2[0], I2.y = fe2[1]), _t && I2.attr("cursor", _t);
      var re2 = t2.getItemVisual(h, "style"), ye = re2.fill;
      if (I2 instanceof Ux) {
        var me2 = I2.style;
        I2.useStyle(ba2({ image: me2.image, x: me2.x, y: me2.y, width: me2.width, height: me2.height }, re2));
      } else
        I2.__isEmptyBrush ? I2.useStyle(ba2({}, re2)) : I2.useStyle(re2), I2.style.decal = null, I2.setColor(ye, M2 && M2.symbolInnerColor), I2.style.strokeNoScale = true;
      var be2 = t2.getItemVisual(h, "liftZ"), Te2 = this._z2;
      be2 != null ? Te2 == null && (this._z2 = I2.z2, I2.z2 += be2) : Te2 != null && (I2.z2 = Te2, this._z2 = null);
      var We = M2 && M2.useNameLabel;
      SS(I2, ht, { labelFetcher: P2, labelDataIndex: h, defaultText: en, inheritColor: ye, defaultOpacity: re2.opacity });
      function en(Vn) {
        return We ? t2.getName(Vn) : Utt(t2, Vn);
      }
      this._sizeX = v4[0] / 2, this._sizeY = v4[1] / 2;
      var Ue2 = I2.ensureState("emphasis");
      if (Ue2.style = N3, I2.ensureState("select").style = H2, I2.ensureState("blur").style = z3, bt) {
        var Mn = Math.max(1.1, 3 / this._sizeY);
        Ue2.scaleX = this._sizeX * Mn, Ue2.scaleY = this._sizeY * Mn;
      }
      this.setSymbolScale(1), vy(this, $, et, at);
    }, i.prototype.setSymbolScale = function(t2) {
      this.scaleX = this.scaleY = t2;
    }, i.prototype.fadeOut = function(t2, h, v4) {
      var _ = this.childAt(0), M2 = Du(this).dataIndex, I2 = v4 && v4.animation;
      if (this.silent = _.silent = true, v4 && v4.fadeLabel) {
        var P2 = _.getTextContent();
        P2 && Q7(P2, { style: { opacity: 0 } }, h, { dataIndex: M2, removeOpt: I2, cb: function() {
          _.removeTextContent();
        } });
      } else
        _.removeTextContent();
      Q7(_, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, h, { dataIndex: M2, cb: t2, removeOpt: I2 });
    }, i.getSymbolSize = function(t2, h) {
      return Ogt(t2.getItemVisual(h, "symbolSize"));
    }, i;
  }(mu);
  function ryr(f2, i) {
    this.parent.drift(f2, i);
  }
  var Vgt = nyr;
  function qXt(f2, i, t2, h) {
    return i && !isNaN(i[0]) && !isNaN(i[1]) && !(h.isIgnore && h.isIgnore(t2)) && !(h.clipShape && !h.clipShape.contain(i[0], i[1])) && f2.getItemVisual(t2, "symbol") !== "none";
  }
  function g8e(f2) {
    return f2 != null && !Xl(f2) && (f2 = { isIgnore: f2 }), f2 || {};
  }
  function v8e(f2) {
    var i = f2.hostModel, t2 = i.getModel("emphasis");
    return { emphasisItemStyle: t2.getModel("itemStyle").getItemStyle(), blurItemStyle: i.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: i.getModel(["select", "itemStyle"]).getItemStyle(), focus: t2.get("focus"), blurScope: t2.get("blurScope"), emphasisDisabled: t2.get("disabled"), hoverScale: t2.get("scale"), labelStatesModels: b_(i), cursorStyle: i.get("cursor") };
  }
  var iyr = function() {
    function f2(i) {
      this.group = new mu(), this._SymbolCtor = i || Vgt;
    }
    return f2.prototype.updateData = function(i, t2) {
      this._progressiveEls = null, t2 = g8e(t2);
      var h = this.group, v4 = i.hostModel, _ = this._data, M2 = this._SymbolCtor, I2 = t2.disableAnimation, P2 = v8e(i), N3 = { disableAnimation: I2 }, z3 = t2.getSymbolPoint || function(H2) {
        return i.getItemLayout(H2);
      };
      _ || h.removeAll(), i.diff(_).add(function(H2) {
        var $ = z3(H2);
        if (qXt(i, $, H2, t2)) {
          var et = new M2(i, H2, P2, N3);
          et.setPosition($), i.setItemGraphicEl(H2, et), h.add(et);
        }
      }).update(function(H2, $) {
        var et = _.getItemGraphicEl($), at = z3(H2);
        if (!qXt(i, at, H2, t2)) {
          h.remove(et);
          return;
        }
        var ht = i.getItemVisual(H2, "symbol") || "circle", bt = et && et.getSymbolType && et.getSymbolType();
        if (!et || bt && bt !== ht)
          h.remove(et), et = new M2(i, H2, P2, N3), et.setPosition(at);
        else {
          et.updateData(i, H2, P2, N3);
          var _t = { x: at[0], y: at[1] };
          I2 ? et.attr(_t) : jh2(et, _t, v4);
        }
        h.add(et), i.setItemGraphicEl(H2, et);
      }).remove(function(H2) {
        var $ = _.getItemGraphicEl(H2);
        $ && $.fadeOut(function() {
          h.remove($);
        }, v4);
      }).execute(), this._getSymbolPoint = z3, this._data = i;
    }, f2.prototype.updateLayout = function() {
      var i = this, t2 = this._data;
      t2 && t2.eachItemGraphicEl(function(h, v4) {
        var _ = i._getSymbolPoint(v4);
        h.setPosition(_), h.markRedraw();
      });
    }, f2.prototype.incrementalPrepareUpdate = function(i) {
      this._seriesScope = v8e(i), this._data = null, this.group.removeAll();
    }, f2.prototype.incrementalUpdate = function(i, t2, h) {
      this._progressiveEls = [], h = g8e(h);
      function v4(P2) {
        P2.isGroup || (P2.incremental = true, P2.ensureState("emphasis").hoverLayer = true);
      }
      for (var _ = i.start; _ < i.end; _++) {
        var M2 = t2.getItemLayout(_);
        if (qXt(t2, M2, _, h)) {
          var I2 = new this._SymbolCtor(t2, _, this._seriesScope);
          I2.traverse(v4), I2.setPosition(M2), this.group.add(I2), t2.setItemGraphicEl(_, I2), this._progressiveEls.push(I2);
        }
      }
    }, f2.prototype.eachRendered = function(i) {
      oV(this._progressiveEls || this.group, i);
    }, f2.prototype.remove = function(i) {
      var t2 = this.group, h = this._data;
      h && i ? h.eachItemGraphicEl(function(v4) {
        v4.fadeOut(function() {
          t2.remove(v4);
        }, h.hostModel);
      }) : t2.removeAll();
    }, f2;
  }(), Bgt = iyr;
  function dHe(f2, i, t2) {
    var h = f2.getBaseAxis(), v4 = f2.getOtherAxis(h), _ = ayr(v4, t2), M2 = h.dim, I2 = v4.dim, P2 = i.mapDimension(I2), N3 = i.mapDimension(M2), z3 = I2 === "x" || I2 === "radius" ? 1 : 0, H2 = Xa2(f2.dimensions, function(at) {
      return i.mapDimension(at);
    }), $ = false, et = i.getCalculationInfo("stackResultDimension");
    return tV(i, H2[0]) && ($ = true, H2[0] = et), tV(i, H2[1]) && ($ = true, H2[1] = et), { dataDimsForPoint: H2, valueStart: _, valueAxisDim: I2, baseAxisDim: M2, stacked: !!$, valueDim: P2, baseDim: N3, baseDataOffset: z3, stackedOverDimension: i.getCalculationInfo("stackedOverDimension") };
  }
  function ayr(f2, i) {
    var t2 = 0, h = f2.scale.getExtent();
    return i === "start" ? t2 = h[0] : i === "end" ? t2 = h[1] : h[0] > 0 ? t2 = h[0] : h[1] < 0 && (t2 = h[1]), t2;
  }
  function gHe(f2, i, t2, h) {
    var v4 = NaN;
    f2.stacked && (v4 = t2.get(t2.getCalculationInfo("stackedOverDimension"), h)), isNaN(v4) && (v4 = f2.valueStart);
    var _ = f2.baseDataOffset, M2 = [];
    return M2[_] = t2.get(f2.baseDim, h), M2[1 - _] = v4, i.dataToPoint(M2);
  }
  function oyr(f2, i) {
    var t2 = [];
    return i.diff(f2).add(function(h) {
      t2.push({ cmd: "+", idx: h });
    }).update(function(h, v4) {
      t2.push({ cmd: "=", idx: v4, idx1: h });
    }).remove(function(h) {
      t2.push({ cmd: "-", idx: h });
    }).execute(), t2;
  }
  function syr(f2, i, t2, h, v4, _, M2, I2) {
    for (var P2 = oyr(f2, i), N3 = [], z3 = [], H2 = [], $ = [], et = [], at = [], ht = [], bt = dHe(v4, i, M2), _t = f2.getLayout("points") || [], Et = i.getLayout("points") || [], zt = 0; zt < P2.length; zt++) {
      var Ft = P2[zt], fe2 = true, re2 = void 0, ye = void 0;
      switch (Ft.cmd) {
        case "=":
          re2 = Ft.idx * 2, ye = Ft.idx1 * 2;
          var me2 = _t[re2], be2 = _t[re2 + 1], Te2 = Et[ye], We = Et[ye + 1];
          (isNaN(me2) || isNaN(be2)) && (me2 = Te2, be2 = We), N3.push(me2, be2), z3.push(Te2, We), H2.push(t2[re2], t2[re2 + 1]), $.push(h[ye], h[ye + 1]), ht.push(i.getRawIndex(Ft.idx1));
          break;
        case "+":
          var en = Ft.idx, Ue2 = bt.dataDimsForPoint, Mn = v4.dataToPoint([i.get(Ue2[0], en), i.get(Ue2[1], en)]);
          ye = en * 2, N3.push(Mn[0], Mn[1]), z3.push(Et[ye], Et[ye + 1]);
          var Vn = gHe(bt, v4, i, en);
          H2.push(Vn[0], Vn[1]), $.push(h[ye], h[ye + 1]), ht.push(i.getRawIndex(en));
          break;
        case "-":
          fe2 = false;
      }
      fe2 && (et.push(Ft), at.push(at.length));
    }
    at.sort(function(ml, ll) {
      return ht[ml] - ht[ll];
    });
    for (var xn = N3.length, Zr = OL(xn), nr = OL(xn), pr = OL(xn), Nr = OL(xn), ai2 = [], zt = 0; zt < at.length; zt++) {
      var gi2 = at[zt], To = zt * 2, us = gi2 * 2;
      Zr[To] = N3[us], Zr[To + 1] = N3[us + 1], nr[To] = z3[us], nr[To + 1] = z3[us + 1], pr[To] = H2[us], pr[To + 1] = H2[us + 1], Nr[To] = $[us], Nr[To + 1] = $[us + 1], ai2[zt] = et[gi2];
    }
    return { current: Zr, next: nr, stackedOnCurrent: pr, stackedOnNext: Nr, status: ai2 };
  }
  var I7 = Math.min, D7 = Math.max;
  function hU(f2, i) {
    return isNaN(f2) || isNaN(i);
  }
  function dte(f2, i, t2, h, v4, _, M2, I2, P2) {
    for (var N3, z3, H2, $, et, at, ht = t2, bt = 0; bt < h; bt++) {
      var _t = i[ht * 2], Et = i[ht * 2 + 1];
      if (ht >= v4 || ht < 0)
        break;
      if (hU(_t, Et)) {
        if (P2) {
          ht += _;
          continue;
        }
        break;
      }
      if (ht === t2)
        f2[_ > 0 ? "moveTo" : "lineTo"](_t, Et), H2 = _t, $ = Et;
      else {
        var zt = _t - N3, Ft = Et - z3;
        if (zt * zt + Ft * Ft < 0.5) {
          ht += _;
          continue;
        }
        if (M2 > 0) {
          for (var fe2 = ht + _, re2 = i[fe2 * 2], ye = i[fe2 * 2 + 1]; re2 === _t && ye === Et && bt < h; )
            bt++, fe2 += _, ht += _, re2 = i[fe2 * 2], ye = i[fe2 * 2 + 1], _t = i[ht * 2], Et = i[ht * 2 + 1], zt = _t - N3, Ft = Et - z3;
          var me2 = bt + 1;
          if (P2)
            for (; hU(re2, ye) && me2 < h; )
              me2++, fe2 += _, re2 = i[fe2 * 2], ye = i[fe2 * 2 + 1];
          var be2 = 0.5, Te2 = 0, We = 0, en = void 0, Ue2 = void 0;
          if (me2 >= h || hU(re2, ye))
            et = _t, at = Et;
          else {
            Te2 = re2 - N3, We = ye - z3;
            var Mn = _t - N3, Vn = re2 - _t, xn = Et - z3, Zr = ye - Et, nr = void 0, pr = void 0;
            if (I2 === "x") {
              nr = Math.abs(Mn), pr = Math.abs(Vn);
              var Nr = Te2 > 0 ? 1 : -1;
              et = _t - Nr * nr * M2, at = Et, en = _t + Nr * pr * M2, Ue2 = Et;
            } else if (I2 === "y") {
              nr = Math.abs(xn), pr = Math.abs(Zr);
              var ai2 = We > 0 ? 1 : -1;
              et = _t, at = Et - ai2 * nr * M2, en = _t, Ue2 = Et + ai2 * pr * M2;
            } else
              nr = Math.sqrt(Mn * Mn + xn * xn), pr = Math.sqrt(Vn * Vn + Zr * Zr), be2 = pr / (pr + nr), et = _t - Te2 * M2 * (1 - be2), at = Et - We * M2 * (1 - be2), en = _t + Te2 * M2 * be2, Ue2 = Et + We * M2 * be2, en = I7(en, D7(re2, _t)), Ue2 = I7(Ue2, D7(ye, Et)), en = D7(en, I7(re2, _t)), Ue2 = D7(Ue2, I7(ye, Et)), Te2 = en - _t, We = Ue2 - Et, et = _t - Te2 * nr / pr, at = Et - We * nr / pr, et = I7(et, D7(N3, _t)), at = I7(at, D7(z3, Et)), et = D7(et, I7(N3, _t)), at = D7(at, I7(z3, Et)), Te2 = _t - et, We = Et - at, en = _t + Te2 * pr / nr, Ue2 = Et + We * pr / nr;
          }
          f2.bezierCurveTo(H2, $, et, at, _t, Et), H2 = en, $ = Ue2;
        } else
          f2.lineTo(_t, Et);
      }
      N3 = _t, z3 = Et, ht += _;
    }
    return bt;
  }
  var vHe = function() {
    function f2() {
      this.smooth = 0, this.smoothConstraint = true;
    }
    return f2;
  }(), lyr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "ec-polyline", h;
    }
    return i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new vHe();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.points, _ = 0, M2 = v4.length / 2;
      if (h.connectNulls) {
        for (; M2 > 0 && hU(v4[M2 * 2 - 2], v4[M2 * 2 - 1]); M2--)
          ;
        for (; _ < M2 && hU(v4[_ * 2], v4[_ * 2 + 1]); _++)
          ;
      }
      for (; _ < M2; )
        _ += dte(t2, v4, _, M2, M2, 1, h.smooth, h.smoothMonotone, h.connectNulls) + 1;
    }, i.prototype.getPointOn = function(t2, h) {
      this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
      for (var v4 = this.path, _ = v4.data, M2 = HL.CMD, I2, P2, N3 = h === "x", z3 = [], H2 = 0; H2 < _.length; ) {
        var $ = _[H2++], et = void 0, at = void 0, ht = void 0, bt = void 0, _t = void 0, Et = void 0, zt = void 0;
        switch ($) {
          case M2.M:
            I2 = _[H2++], P2 = _[H2++];
            break;
          case M2.L:
            if (et = _[H2++], at = _[H2++], zt = N3 ? (t2 - I2) / (et - I2) : (t2 - P2) / (at - P2), zt <= 1 && zt >= 0) {
              var Ft = N3 ? (at - P2) * zt + P2 : (et - I2) * zt + I2;
              return N3 ? [t2, Ft] : [Ft, t2];
            }
            I2 = et, P2 = at;
            break;
          case M2.C:
            et = _[H2++], at = _[H2++], ht = _[H2++], bt = _[H2++], _t = _[H2++], Et = _[H2++];
            var fe2 = N3 ? lEt(I2, et, ht, _t, t2, z3) : lEt(P2, at, bt, Et, t2, z3);
            if (fe2 > 0)
              for (var re2 = 0; re2 < fe2; re2++) {
                var ye = z3[re2];
                if (ye <= 1 && ye >= 0) {
                  var Ft = N3 ? fb2(P2, at, bt, Et, ye) : fb2(I2, et, ht, _t, ye);
                  return N3 ? [t2, Ft] : [Ft, t2];
                }
              }
            I2 = _t, P2 = Et;
            break;
        }
      }
    }, i;
  }(Uc2), uyr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i;
  }(vHe), yHe = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "ec-polygon", h;
    }
    return i.prototype.getDefaultShape = function() {
      return new uyr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.points, _ = h.stackedOnPoints, M2 = 0, I2 = v4.length / 2, P2 = h.smoothMonotone;
      if (h.connectNulls) {
        for (; I2 > 0 && hU(v4[I2 * 2 - 2], v4[I2 * 2 - 1]); I2--)
          ;
        for (; M2 < I2 && hU(v4[M2 * 2], v4[M2 * 2 + 1]); M2++)
          ;
      }
      for (; M2 < I2; ) {
        var N3 = dte(t2, v4, M2, I2, I2, 1, h.smooth, P2, h.connectNulls);
        dte(t2, _, M2 + N3 - 1, N3, I2, -1, h.stackedOnSmooth, P2, h.connectNulls), M2 += N3 + 1, t2.closePath();
      }
    }, i;
  }(Uc2);
  function mHe(f2, i, t2, h, v4) {
    var _ = f2.getArea(), M2 = _.x, I2 = _.y, P2 = _.width, N3 = _.height, z3 = t2.get(["lineStyle", "width"]) || 2;
    M2 -= z3 / 2, I2 -= z3 / 2, P2 += z3, N3 += z3, M2 = Math.floor(M2), P2 = Math.round(P2);
    var H2 = new Sh2({ shape: { x: M2, y: I2, width: P2, height: N3 } });
    if (i) {
      var $ = f2.getBaseAxis(), et = $.isHorizontal(), at = $.inverse;
      et ? (at && (H2.shape.x += P2), H2.shape.width = 0) : (at || (H2.shape.y += N3), H2.shape.height = 0);
      var ht = Ol(v4) ? function(bt) {
        v4(bt, H2);
      } : null;
      Qv(H2, { shape: { width: P2, height: N3, x: M2, y: I2 } }, t2, null, h, ht);
    }
    return H2;
  }
  function bHe(f2, i, t2) {
    var h = f2.getArea(), v4 = gy(h.r0, 1), _ = gy(h.r, 1), M2 = new rC({ shape: { cx: gy(f2.cx, 1), cy: gy(f2.cy, 1), r0: v4, r: _, startAngle: h.startAngle, endAngle: h.endAngle, clockwise: h.clockwise } });
    if (i) {
      var I2 = f2.getBaseAxis().dim === "angle";
      I2 ? M2.shape.endAngle = h.startAngle : M2.shape.r = v4, Qv(M2, { shape: { endAngle: h.endAngle, r: _ } }, t2);
    }
    return M2;
  }
  function Fkt(f2, i, t2, h, v4) {
    if (f2) {
      if (f2.type === "polar")
        return bHe(f2, i, t2);
      if (f2.type === "cartesian2d")
        return mHe(f2, i, t2, h, v4);
    } else
      return null;
    return null;
  }
  function Y6(f2, i) {
    return f2.type === i;
  }
  function y8e(f2, i) {
    if (f2.length === i.length) {
      for (var t2 = 0; t2 < f2.length; t2++)
        if (f2[t2] !== i[t2])
          return;
      return true;
    }
  }
  function m8e(f2) {
    for (var i = 1 / 0, t2 = 1 / 0, h = -1 / 0, v4 = -1 / 0, _ = 0; _ < f2.length; ) {
      var M2 = f2[_++], I2 = f2[_++];
      isNaN(M2) || (i = Math.min(M2, i), h = Math.max(M2, h)), isNaN(I2) || (t2 = Math.min(I2, t2), v4 = Math.max(I2, v4));
    }
    return [[i, t2], [h, v4]];
  }
  function b8e(f2, i) {
    var t2 = m8e(f2), h = t2[0], v4 = t2[1], _ = m8e(i), M2 = _[0], I2 = _[1];
    return Math.max(Math.abs(h[0] - M2[0]), Math.abs(h[1] - M2[1]), Math.abs(v4[0] - I2[0]), Math.abs(v4[1] - I2[1]));
  }
  function _8e(f2) {
    return vp(f2) ? f2 : f2 ? 0.5 : 0;
  }
  function cyr(f2, i, t2) {
    if (!t2.valueDim)
      return [];
    for (var h = i.count(), v4 = OL(h * 2), _ = 0; _ < h; _++) {
      var M2 = gHe(t2, f2, i, _);
      v4[_ * 2] = M2[0], v4[_ * 2 + 1] = M2[1];
    }
    return v4;
  }
  function E7(f2, i, t2, h) {
    var v4 = i.getBaseAxis(), _ = v4.dim === "x" || v4.dim === "radius" ? 0 : 1, M2 = [], I2 = 0, P2 = [], N3 = [], z3 = [], H2 = [];
    if (h) {
      for (I2 = 0; I2 < f2.length; I2 += 2)
        !isNaN(f2[I2]) && !isNaN(f2[I2 + 1]) && H2.push(f2[I2], f2[I2 + 1]);
      f2 = H2;
    }
    for (I2 = 0; I2 < f2.length - 2; I2 += 2)
      switch (z3[0] = f2[I2 + 2], z3[1] = f2[I2 + 3], N3[0] = f2[I2], N3[1] = f2[I2 + 1], M2.push(N3[0], N3[1]), t2) {
        case "end":
          P2[_] = z3[_], P2[1 - _] = N3[1 - _], M2.push(P2[0], P2[1]);
          break;
        case "middle":
          var $ = (N3[_] + z3[_]) / 2, et = [];
          P2[_] = et[_] = $, P2[1 - _] = N3[1 - _], et[1 - _] = z3[1 - _], M2.push(P2[0], P2[1]), M2.push(et[0], et[1]);
          break;
        default:
          P2[_] = N3[_], P2[1 - _] = z3[1 - _], M2.push(P2[0], P2[1]);
      }
    return M2.push(f2[I2++], f2[I2++]), M2;
  }
  function fyr(f2, i) {
    var t2 = [], h = f2.length, v4, _;
    function M2(z3, H2, $) {
      var et = z3.coord, at = ($ - et) / (H2.coord - et), ht = pur(at, [z3.color, H2.color]);
      return { coord: $, color: ht };
    }
    for (var I2 = 0; I2 < h; I2++) {
      var P2 = f2[I2], N3 = P2.coord;
      if (N3 < 0)
        v4 = P2;
      else if (N3 > i) {
        _ ? t2.push(M2(_, P2, i)) : v4 && t2.push(M2(v4, P2, 0), M2(v4, P2, i));
        break;
      } else
        v4 && (t2.push(M2(v4, P2, 0)), v4 = null), t2.push(P2), _ = P2;
    }
    return t2;
  }
  function hyr(f2, i, t2) {
    var h = f2.getVisual("visualMeta");
    if (!(!h || !h.length || !f2.count()) && i.type === "cartesian2d") {
      for (var v4, _, M2 = h.length - 1; M2 >= 0; M2--) {
        var I2 = f2.getDimensionInfo(h[M2].dimension);
        if (v4 = I2 && I2.coordDim, v4 === "x" || v4 === "y") {
          _ = h[M2];
          break;
        }
      }
      if (!!_) {
        var P2 = i.getAxis(v4), N3 = Xa2(_.stops, function(zt) {
          return { coord: P2.toGlobalCoord(P2.dataToCoord(zt.value)), color: zt.color };
        }), z3 = N3.length, H2 = _.outerColors.slice();
        z3 && N3[0].coord > N3[z3 - 1].coord && (N3.reverse(), H2.reverse());
        var $ = fyr(N3, v4 === "x" ? t2.getWidth() : t2.getHeight()), et = $.length;
        if (!et && z3)
          return N3[0].coord < 0 ? H2[1] ? H2[1] : N3[z3 - 1].color : H2[0] ? H2[0] : N3[0].color;
        var at = 10, ht = $[0].coord - at, bt = $[et - 1].coord + at, _t = bt - ht;
        if (_t < 1e-3)
          return "transparent";
        Qe2($, function(zt) {
          zt.offset = (zt.coord - ht) / _t;
        }), $.push({ offset: et ? $[et - 1].offset : 0.5, color: H2[1] || "transparent" }), $.unshift({ offset: et ? $[0].offset : 0.5, color: H2[0] || "transparent" });
        var Et = new Igt(0, 0, 0, 0, $, true);
        return Et[v4] = ht, Et[v4 + "2"] = bt, Et;
      }
    }
  }
  function pyr(f2, i, t2) {
    var h = f2.get("showAllSymbol"), v4 = h === "auto";
    if (!(h && !v4)) {
      var _ = t2.getAxesByScale("ordinal")[0];
      if (!!_ && !(v4 && dyr(_, i))) {
        var M2 = i.mapDimension(_.dim), I2 = {};
        return Qe2(_.getViewLabels(), function(P2) {
          var N3 = _.scale.getRawOrdinalNumber(P2.tickValue);
          I2[N3] = 1;
        }), function(P2) {
          return !I2.hasOwnProperty(i.get(M2, P2));
        };
      }
    }
  }
  function dyr(f2, i) {
    var t2 = f2.getExtent(), h = Math.abs(t2[1] - t2[0]) / f2.scale.count();
    isNaN(h) && (h = 0);
    for (var v4 = i.count(), _ = Math.max(1, Math.round(v4 / 5)), M2 = 0; M2 < v4; M2 += _)
      if (Vgt.getSymbolSize(i, M2)[f2.isHorizontal() ? 1 : 0] * 1.5 > h)
        return false;
    return true;
  }
  function gyr(f2, i) {
    return isNaN(f2) || isNaN(i);
  }
  function vyr(f2) {
    for (var i = f2.length / 2; i > 0 && gyr(f2[i * 2 - 2], f2[i * 2 - 1]); i--)
      ;
    return i - 1;
  }
  function x8e(f2, i) {
    return [f2[i * 2], f2[i * 2 + 1]];
  }
  function yyr(f2, i, t2) {
    for (var h = f2.length / 2, v4 = t2 === "x" ? 0 : 1, _, M2, I2 = 0, P2 = -1, N3 = 0; N3 < h; N3++)
      if (M2 = f2[N3 * 2 + v4], !(isNaN(M2) || isNaN(f2[N3 * 2 + 1 - v4]))) {
        if (N3 === 0) {
          _ = M2;
          continue;
        }
        if (_ <= i && M2 >= i || _ >= i && M2 <= i) {
          P2 = N3;
          break;
        }
        I2 = N3, _ = M2;
      }
    return { range: [I2, P2], t: (i - _) / (M2 - _) };
  }
  function _He(f2) {
    if (f2.get(["endLabel", "show"]))
      return true;
    for (var i = 0; i < j2.length; i++)
      if (f2.get([j2[i], "endLabel", "show"]))
        return true;
    return false;
  }
  function ZXt(f2, i, t2, h) {
    if (Y6(i, "cartesian2d")) {
      var v4 = h.getModel("endLabel"), _ = v4.get("valueAnimation"), M2 = h.getData(), I2 = { lastFrameIndex: 0 }, P2 = _He(h) ? function(et, at) {
        f2._endLabelOnDuring(et, at, M2, I2, _, v4, i);
      } : null, N3 = i.getBaseAxis().isHorizontal(), z3 = mHe(i, t2, h, function() {
        var et = f2._endLabel;
        et && t2 && I2.originalX != null && et.attr({ x: I2.originalX, y: I2.originalY });
      }, P2);
      if (!h.get("clip", true)) {
        var H2 = z3.shape, $ = Math.max(H2.width, H2.height);
        N3 ? (H2.y -= $, H2.height += $ * 2) : (H2.x -= $, H2.width += $ * 2);
      }
      return P2 && P2(1, z3), z3;
    } else
      return bHe(i, t2, h);
  }
  function myr(f2, i) {
    var t2 = i.getBaseAxis(), h = t2.isHorizontal(), v4 = t2.inverse, _ = h ? v4 ? "right" : "left" : "center", M2 = h ? "middle" : v4 ? "top" : "bottom";
    return { normal: { align: f2.get("align") || _, verticalAlign: f2.get("verticalAlign") || M2 } };
  }
  var byr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.init = function() {
      var t2 = new mu(), h = new Bgt();
      this.group.add(h.group), this._symbolDraw = h, this._lineGroup = t2;
    }, i.prototype.render = function(t2, h, v4) {
      var _ = this, M2 = t2.coordinateSystem, I2 = this.group, P2 = t2.getData(), N3 = t2.getModel("lineStyle"), z3 = t2.getModel("areaStyle"), H2 = P2.getLayout("points") || [], $ = M2.type === "polar", et = this._coordSys, at = this._symbolDraw, ht = this._polyline, bt = this._polygon, _t = this._lineGroup, Et = t2.get("animation"), zt = !z3.isEmpty(), Ft = z3.get("origin"), fe2 = dHe(M2, P2, Ft), re2 = zt && cyr(M2, P2, fe2), ye = t2.get("showSymbol"), me2 = t2.get("connectNulls"), be2 = ye && !$ && pyr(t2, P2, M2), Te2 = this._data;
      Te2 && Te2.eachItemGraphicEl(function(ll, Rs) {
        ll.__temp && (I2.remove(ll), Te2.setItemGraphicEl(Rs, null));
      }), ye || at.remove(), I2.add(_t);
      var We = $ ? false : t2.get("step"), en;
      M2 && M2.getArea && t2.get("clip", true) && (en = M2.getArea(), en.width != null ? (en.x -= 0.1, en.y -= 0.1, en.width += 0.2, en.height += 0.2) : en.r0 && (en.r0 -= 0.5, en.r += 0.5)), this._clipShapeForSymbol = en;
      var Ue2 = hyr(P2, M2, v4) || P2.getVisual("style")[P2.getVisual("drawType")];
      if (!(ht && et.type === M2.type && We === this._step))
        ye && at.updateData(P2, { isIgnore: be2, clipShape: en, disableAnimation: true, getSymbolPoint: function(ll) {
          return [H2[ll * 2], H2[ll * 2 + 1]];
        } }), Et && this._initSymbolLabelAnimation(P2, M2, en), We && (H2 = E7(H2, M2, We, me2), re2 && (re2 = E7(re2, M2, We, me2))), ht = this._newPolyline(H2), zt && (bt = this._newPolygon(H2, re2)), $ || this._initOrUpdateEndLabel(t2, M2, bU(Ue2)), _t.setClipPath(ZXt(this, M2, true, t2));
      else {
        zt && !bt ? bt = this._newPolygon(H2, re2) : bt && !zt && (_t.remove(bt), bt = this._polygon = null), $ || this._initOrUpdateEndLabel(t2, M2, bU(Ue2));
        var Mn = _t.getClipPath();
        if (Mn) {
          var Vn = ZXt(this, M2, false, t2);
          Qv(Mn, { shape: Vn.shape }, t2);
        } else
          _t.setClipPath(ZXt(this, M2, true, t2));
        ye && at.updateData(P2, { isIgnore: be2, clipShape: en, disableAnimation: true, getSymbolPoint: function(ll) {
          return [H2[ll * 2], H2[ll * 2 + 1]];
        } }), (!y8e(this._stackedOnPoints, re2) || !y8e(this._points, H2)) && (Et ? this._doUpdateAnimation(P2, re2, M2, v4, We, Ft, me2) : (We && (H2 = E7(H2, M2, We, me2), re2 && (re2 = E7(re2, M2, We, me2))), ht.setShape({ points: H2 }), bt && bt.setShape({ points: H2, stackedOnPoints: re2 })));
      }
      var xn = t2.getModel("emphasis"), Zr = xn.get("focus"), nr = xn.get("blurScope"), pr = xn.get("disabled");
      if (ht.useStyle(Ul(N3.getLineStyle(), { fill: "none", stroke: Ue2, lineJoin: "bevel" })), Hx(ht, t2, "lineStyle"), ht.style.lineWidth > 0 && t2.get(["emphasis", "lineStyle", "width"]) === "bolder") {
        var Nr = ht.getState("emphasis").style;
        Nr.lineWidth = +ht.style.lineWidth + 1;
      }
      Du(ht).seriesIndex = t2.seriesIndex, vy(ht, Zr, nr, pr);
      var ai2 = _8e(t2.get("smooth")), gi2 = t2.get("smoothMonotone");
      if (ht.setShape({ smooth: ai2, smoothMonotone: gi2, connectNulls: me2 }), bt) {
        var To = P2.getCalculationInfo("stackedOnSeries"), us = 0;
        bt.useStyle(Ul(z3.getAreaStyle(), { fill: Ue2, opacity: 0.7, lineJoin: "bevel", decal: P2.getVisual("style").decal })), To && (us = _8e(To.get("smooth"))), bt.setShape({ smooth: ai2, stackedOnSmooth: us, smoothMonotone: gi2, connectNulls: me2 }), Hx(bt, t2, "areaStyle"), Du(bt).seriesIndex = t2.seriesIndex, vy(bt, Zr, nr, pr);
      }
      var ml = function(ll) {
        _._changePolyState(ll);
      };
      P2.eachItemGraphicEl(function(ll) {
        ll && (ll.onHoverStateChange = ml);
      }), this._polyline.onHoverStateChange = ml, this._data = P2, this._coordSys = M2, this._stackedOnPoints = re2, this._points = H2, this._step = We, this._valueOrigin = Ft, t2.get("triggerLineEvent") && (this.packEventData(t2, ht), bt && this.packEventData(t2, bt));
    }, i.prototype.packEventData = function(t2, h) {
      Du(h).eventData = { componentType: "series", componentSubType: "line", componentIndex: t2.componentIndex, seriesIndex: t2.seriesIndex, seriesName: t2.name, seriesType: "line" };
    }, i.prototype.highlight = function(t2, h, v4, _) {
      var M2 = t2.getData(), I2 = vU(M2, _);
      if (this._changePolyState("emphasis"), !(I2 instanceof Array) && I2 != null && I2 >= 0) {
        var P2 = M2.getLayout("points"), N3 = M2.getItemGraphicEl(I2);
        if (!N3) {
          var z3 = P2[I2 * 2], H2 = P2[I2 * 2 + 1];
          if (isNaN(z3) || isNaN(H2) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(z3, H2))
            return;
          var $ = t2.get("zlevel"), et = t2.get("z");
          N3 = new Vgt(M2, I2), N3.x = z3, N3.y = H2, N3.setZ($, et);
          var at = N3.getSymbolPath().getTextContent();
          at && (at.zlevel = $, at.z = et, at.z2 = this._polyline.z2 + 1), N3.__temp = true, M2.setItemGraphicEl(I2, N3), N3.stopSymbolAnimation(true), this.group.add(N3);
        }
        N3.highlight();
      } else
        Hg2.prototype.highlight.call(this, t2, h, v4, _);
    }, i.prototype.downplay = function(t2, h, v4, _) {
      var M2 = t2.getData(), I2 = vU(M2, _);
      if (this._changePolyState("normal"), I2 != null && I2 >= 0) {
        var P2 = M2.getItemGraphicEl(I2);
        P2 && (P2.__temp ? (M2.setItemGraphicEl(I2, null), this.group.remove(P2)) : P2.downplay());
      } else
        Hg2.prototype.downplay.call(this, t2, h, v4, _);
    }, i.prototype._changePolyState = function(t2) {
      var h = this._polygon;
      vEt(this._polyline, t2), h && vEt(h, t2);
    }, i.prototype._newPolyline = function(t2) {
      var h = this._polyline;
      return h && this._lineGroup.remove(h), h = new lyr({ shape: { points: t2 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(h), this._polyline = h, h;
    }, i.prototype._newPolygon = function(t2, h) {
      var v4 = this._polygon;
      return v4 && this._lineGroup.remove(v4), v4 = new yHe({ shape: { points: t2, stackedOnPoints: h }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(v4), this._polygon = v4, v4;
    }, i.prototype._initSymbolLabelAnimation = function(t2, h, v4) {
      var _, M2, I2 = h.getBaseAxis(), P2 = I2.inverse;
      h.type === "cartesian2d" ? (_ = I2.isHorizontal(), M2 = false) : h.type === "polar" && (_ = I2.dim === "angle", M2 = true);
      var N3 = t2.hostModel, z3 = N3.get("animationDuration");
      Ol(z3) && (z3 = z3(null));
      var H2 = N3.get("animationDelay") || 0, $ = Ol(H2) ? H2(null) : H2;
      t2.eachItemGraphicEl(function(et, at) {
        var ht = et;
        if (ht) {
          var bt = [et.x, et.y], _t = void 0, Et = void 0, zt = void 0;
          if (v4)
            if (M2) {
              var Ft = v4, fe2 = h.pointToCoord(bt);
              _ ? (_t = Ft.startAngle, Et = Ft.endAngle, zt = -fe2[1] / 180 * Math.PI) : (_t = Ft.r0, Et = Ft.r, zt = fe2[0]);
            } else {
              var re2 = v4;
              _ ? (_t = re2.x, Et = re2.x + re2.width, zt = et.x) : (_t = re2.y + re2.height, Et = re2.y, zt = et.y);
            }
          var ye = Et === _t ? 0 : (zt - _t) / (Et - _t);
          P2 && (ye = 1 - ye);
          var me2 = Ol(H2) ? H2(at) : z3 * ye + $, be2 = ht.getSymbolPath(), Te2 = be2.getTextContent();
          ht.attr({ scaleX: 0, scaleY: 0 }), ht.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: me2 }), Te2 && Te2.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: me2 }), be2.disableLabelAnimation = true;
        }
      });
    }, i.prototype._initOrUpdateEndLabel = function(t2, h, v4) {
      var _ = t2.getModel("endLabel");
      if (_He(t2)) {
        var M2 = t2.getData(), I2 = this._polyline, P2 = M2.getLayout("points");
        if (!P2) {
          I2.removeTextContent(), this._endLabel = null;
          return;
        }
        var N3 = this._endLabel;
        N3 || (N3 = this._endLabel = new op({ z2: 200 }), N3.ignoreClip = true, I2.setTextContent(this._endLabel), I2.disableLabelAnimation = true);
        var z3 = vyr(P2);
        z3 >= 0 && (SS(I2, b_(t2, "endLabel"), { inheritColor: v4, labelFetcher: t2, labelDataIndex: z3, defaultText: function(H2, $, et) {
          return et != null ? pHe(M2, et) : Utt(M2, H2);
        }, enableTextSetter: true }, myr(_, h)), I2.textConfig.position = null);
      } else
        this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
    }, i.prototype._endLabelOnDuring = function(t2, h, v4, _, M2, I2, P2) {
      var N3 = this._endLabel, z3 = this._polyline;
      if (N3) {
        t2 < 1 && _.originalX == null && (_.originalX = N3.x, _.originalY = N3.y);
        var H2 = v4.getLayout("points"), $ = v4.hostModel, et = $.get("connectNulls"), at = I2.get("precision"), ht = I2.get("distance") || 0, bt = P2.getBaseAxis(), _t = bt.isHorizontal(), Et = bt.inverse, zt = h.shape, Ft = Et ? _t ? zt.x : zt.y + zt.height : _t ? zt.x + zt.width : zt.y, fe2 = (_t ? ht : 0) * (Et ? -1 : 1), re2 = (_t ? 0 : -ht) * (Et ? -1 : 1), ye = _t ? "x" : "y", me2 = yyr(H2, Ft, ye), be2 = me2.range, Te2 = be2[1] - be2[0], We = void 0;
        if (Te2 >= 1) {
          if (Te2 > 1 && !et) {
            var en = x8e(H2, be2[0]);
            N3.attr({ x: en[0] + fe2, y: en[1] + re2 }), M2 && (We = $.getRawValue(be2[0]));
          } else {
            var en = z3.getPointOn(Ft, ye);
            en && N3.attr({ x: en[0] + fe2, y: en[1] + re2 });
            var Ue2 = $.getRawValue(be2[0]), Mn = $.getRawValue(be2[1]);
            M2 && (We = jze(v4, at, Ue2, Mn, me2.t));
          }
          _.lastFrameIndex = be2[0];
        } else {
          var Vn = t2 === 1 || _.lastFrameIndex > 0 ? be2[0] : 0, en = x8e(H2, Vn);
          M2 && (We = $.getRawValue(Vn)), N3.attr({ x: en[0] + fe2, y: en[1] + re2 });
        }
        M2 && net(N3).setLabelText(We);
      }
    }, i.prototype._doUpdateAnimation = function(t2, h, v4, _, M2, I2, P2) {
      var N3 = this._polyline, z3 = this._polygon, H2 = t2.hostModel, $ = syr(this._data, t2, this._stackedOnPoints, h, this._coordSys, v4, this._valueOrigin), et = $.current, at = $.stackedOnCurrent, ht = $.next, bt = $.stackedOnNext;
      if (M2 && (et = E7($.current, v4, M2, P2), at = E7($.stackedOnCurrent, v4, M2, P2), ht = E7($.next, v4, M2, P2), bt = E7($.stackedOnNext, v4, M2, P2)), b8e(et, ht) > 3e3 || z3 && b8e(at, bt) > 3e3) {
        N3.stopAnimation(), N3.setShape({ points: ht }), z3 && (z3.stopAnimation(), z3.setShape({ points: ht, stackedOnPoints: bt }));
        return;
      }
      N3.shape.__points = $.current, N3.shape.points = et;
      var _t = { shape: { points: ht } };
      $.current !== et && (_t.shape.__points = $.next), N3.stopAnimation(), jh2(N3, _t, H2), z3 && (z3.setShape({ points: et, stackedOnPoints: at }), z3.stopAnimation(), jh2(z3, { shape: { stackedOnPoints: bt } }, H2), N3.shape.points !== z3.shape.points && (z3.shape.points = N3.shape.points));
      for (var Et = [], zt = $.status, Ft = 0; Ft < zt.length; Ft++) {
        var fe2 = zt[Ft].cmd;
        if (fe2 === "=") {
          var re2 = t2.getItemGraphicEl(zt[Ft].idx1);
          re2 && Et.push({ el: re2, ptIdx: Ft });
        }
      }
      N3.animators && N3.animators.length && N3.animators[0].during(function() {
        z3 && z3.dirtyShape();
        for (var ye = N3.shape.__points, me2 = 0; me2 < Et.length; me2++) {
          var be2 = Et[me2].el, Te2 = Et[me2].ptIdx * 2;
          be2.x = ye[Te2], be2.y = ye[Te2 + 1], be2.markRedraw();
        }
      });
    }, i.prototype.remove = function(t2) {
      var h = this.group, v4 = this._data;
      this._lineGroup.removeAll(), this._symbolDraw.remove(true), v4 && v4.eachItemGraphicEl(function(_, M2) {
        _.__temp && (h.remove(_), v4.setItemGraphicEl(M2, null));
      }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
    }, i.type = "line", i;
  }(Hg2), _yr = byr;
  function zgt(f2, i) {
    return { seriesType: f2, plan: uet(), reset: function(t2) {
      var h = t2.getData(), v4 = t2.coordinateSystem, _ = t2.pipelineContext, M2 = i || _.large;
      if (!!v4) {
        var I2 = Xa2(v4.dimensions, function(et) {
          return h.mapDimension(et);
        }).slice(0, 2), P2 = I2.length, N3 = h.getCalculationInfo("stackResultDimension");
        tV(h, I2[0]) && (I2[0] = N3), tV(h, I2[1]) && (I2[1] = N3);
        var z3 = h.getStore(), H2 = h.getDimensionIndex(I2[0]), $ = h.getDimensionIndex(I2[1]);
        return P2 && { progress: function(et, at) {
          for (var ht = et.end - et.start, bt = M2 && OL(ht * P2), _t = [], Et = [], zt = et.start, Ft = 0; zt < et.end; zt++) {
            var fe2 = void 0;
            if (P2 === 1) {
              var re2 = z3.get(H2, zt);
              fe2 = v4.dataToPoint(re2, null, Et);
            } else
              _t[0] = z3.get(H2, zt), _t[1] = z3.get($, zt), fe2 = v4.dataToPoint(_t, null, Et);
            M2 ? (bt[Ft++] = fe2[0], bt[Ft++] = fe2[1]) : at.setItemLayout(zt, fe2.slice());
          }
          M2 && at.setLayout("points", bt);
        } };
      }
    } };
  }
  var xyr = { average: function(f2) {
    for (var i = 0, t2 = 0, h = 0; h < f2.length; h++)
      isNaN(f2[h]) || (i += f2[h], t2++);
    return t2 === 0 ? NaN : i / t2;
  }, sum: function(f2) {
    for (var i = 0, t2 = 0; t2 < f2.length; t2++)
      i += f2[t2] || 0;
    return i;
  }, max: function(f2) {
    for (var i = -1 / 0, t2 = 0; t2 < f2.length; t2++)
      f2[t2] > i && (i = f2[t2]);
    return isFinite(i) ? i : NaN;
  }, min: function(f2) {
    for (var i = 1 / 0, t2 = 0; t2 < f2.length; t2++)
      f2[t2] < i && (i = f2[t2]);
    return isFinite(i) ? i : NaN;
  }, nearest: function(f2) {
    return f2[0];
  } }, wyr = function(f2) {
    return Math.round(f2.length / 2);
  };
  function xHe(f2) {
    return { seriesType: f2, reset: function(i, t2, h) {
      var v4 = i.getData(), _ = i.get("sampling"), M2 = i.coordinateSystem, I2 = v4.count();
      if (I2 > 10 && M2.type === "cartesian2d" && _) {
        var P2 = M2.getBaseAxis(), N3 = M2.getOtherAxis(P2), z3 = P2.getExtent(), H2 = h.getDevicePixelRatio(), $ = Math.abs(z3[1] - z3[0]) * (H2 || 1), et = Math.round(I2 / $);
        if (isFinite(et) && et > 1) {
          _ === "lttb" && i.setData(v4.lttbDownSample(v4.mapDimension(N3.dim), 1 / et));
          var at = void 0;
          ms(_) ? at = xyr[_] : Ol(_) && (at = _), at && i.setData(v4.downSample(v4.mapDimension(N3.dim), 1 / et, at, wyr));
        }
      }
    } };
  }
  function Syr(f2) {
    f2.registerChartView(_yr), f2.registerSeriesModel(eyr), f2.registerLayout(zgt("line", true)), f2.registerVisual({ seriesType: "line", reset: function(i) {
      var t2 = i.getData(), h = i.getModel("lineStyle").getLineStyle();
      h && !h.stroke && (h.stroke = t2.getVisual("style").fill), t2.setVisual("legendLineStyle", h);
    } }), f2.registerProcessor(f2.PRIORITY.PROCESSOR.STATISTIC, xHe("line"));
  }
  var wHe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      return aN(null, this, { useEncodeDefaulter: true });
    }, i.prototype.getMarkerPosition = function(t2) {
      var h = this.coordinateSystem;
      if (h && h.clampData) {
        var v4 = h.dataToPoint(h.clampData(t2)), _ = this.getData(), M2 = _.getLayout("offset"), I2 = _.getLayout("size"), P2 = h.getBaseAxis().isHorizontal() ? 0 : 1;
        return v4[P2] += M2 + I2 / 2, v4;
      }
      return [NaN, NaN];
    }, i.type = "series.__base_bar__", i.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, i;
  }(Jv);
  Jv.registerClass(wHe);
  var REt = wHe, Myr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.getInitialData = function() {
      return aN(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
    }, i.prototype.getProgressive = function() {
      return this.get("large") ? this.get("progressive") : false;
    }, i.prototype.getProgressiveThreshold = function() {
      var t2 = this.get("progressiveThreshold"), h = this.get("largeThreshold");
      return h > t2 && (t2 = h), t2;
    }, i.prototype.brushSelector = function(t2, h, v4) {
      return v4.rect(h.getItemLayout(t2));
    }, i.type = "series.bar", i.dependencies = ["grid", "polar"], i.defaultOption = sV(REt.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), i;
  }(REt), Cyr = Myr, Tyr = function() {
    function f2() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return f2;
  }(), Ayr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "sausage", h;
    }
    return i.prototype.getDefaultShape = function() {
      return new Tyr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.cx, _ = h.cy, M2 = Math.max(h.r0 || 0, 0), I2 = Math.max(h.r, 0), P2 = (I2 - M2) * 0.5, N3 = M2 + P2, z3 = h.startAngle, H2 = h.endAngle, $ = h.clockwise, et = Math.PI * 2, at = $ ? H2 - z3 < et : z3 - H2 < et;
      at || (z3 = H2 - ($ ? et : -et));
      var ht = Math.cos(z3), bt = Math.sin(z3), _t = Math.cos(H2), Et = Math.sin(H2);
      at ? (t2.moveTo(ht * M2 + v4, bt * M2 + _), t2.arc(ht * N3 + v4, bt * N3 + _, P2, -Math.PI + z3, z3, !$)) : t2.moveTo(ht * I2 + v4, bt * I2 + _), t2.arc(v4, _, I2, z3, H2, !$), t2.arc(_t * N3 + v4, Et * N3 + _, P2, H2 - Math.PI * 2, H2 - Math.PI, !$), M2 !== 0 && t2.arc(v4, _, M2, H2, z3, $);
    }, i;
  }(Uc2), NEt = Ayr;
  function Iyr(f2, i) {
    i = i || {};
    var t2 = i.isRoundCap;
    return function(h, v4, _) {
      var M2 = v4.position;
      if (!M2 || M2 instanceof Array)
        return pEt(h, v4, _);
      var I2 = f2(M2), P2 = v4.distance != null ? v4.distance : 5, N3 = this.shape, z3 = N3.cx, H2 = N3.cy, $ = N3.r, et = N3.r0, at = ($ + et) / 2, ht = N3.startAngle, bt = N3.endAngle, _t = (ht + bt) / 2, Et = t2 ? Math.abs($ - et) / 2 : 0, zt = Math.cos, Ft = Math.sin, fe2 = z3 + $ * zt(ht), re2 = H2 + $ * Ft(ht), ye = "left", me2 = "top";
      switch (I2) {
        case "startArc":
          fe2 = z3 + (et - P2) * zt(_t), re2 = H2 + (et - P2) * Ft(_t), ye = "center", me2 = "top";
          break;
        case "insideStartArc":
          fe2 = z3 + (et + P2) * zt(_t), re2 = H2 + (et + P2) * Ft(_t), ye = "center", me2 = "bottom";
          break;
        case "startAngle":
          fe2 = z3 + at * zt(ht) + fDt(ht, P2 + Et, false), re2 = H2 + at * Ft(ht) + hDt(ht, P2 + Et, false), ye = "right", me2 = "middle";
          break;
        case "insideStartAngle":
          fe2 = z3 + at * zt(ht) + fDt(ht, -P2 + Et, false), re2 = H2 + at * Ft(ht) + hDt(ht, -P2 + Et, false), ye = "left", me2 = "middle";
          break;
        case "middle":
          fe2 = z3 + at * zt(_t), re2 = H2 + at * Ft(_t), ye = "center", me2 = "middle";
          break;
        case "endArc":
          fe2 = z3 + ($ + P2) * zt(_t), re2 = H2 + ($ + P2) * Ft(_t), ye = "center", me2 = "bottom";
          break;
        case "insideEndArc":
          fe2 = z3 + ($ - P2) * zt(_t), re2 = H2 + ($ - P2) * Ft(_t), ye = "center", me2 = "top";
          break;
        case "endAngle":
          fe2 = z3 + at * zt(bt) + fDt(bt, P2 + Et, true), re2 = H2 + at * Ft(bt) + hDt(bt, P2 + Et, true), ye = "left", me2 = "middle";
          break;
        case "insideEndAngle":
          fe2 = z3 + at * zt(bt) + fDt(bt, -P2 + Et, true), re2 = H2 + at * Ft(bt) + hDt(bt, -P2 + Et, true), ye = "right", me2 = "middle";
          break;
        default:
          return pEt(h, v4, _);
      }
      return h = h || {}, h.x = fe2, h.y = re2, h.align = ye, h.verticalAlign = me2, h;
    };
  }
  function Dyr(f2, i, t2, h) {
    if (vp(h)) {
      f2.setTextConfig({ rotation: h });
      return;
    } else if (Za2(i)) {
      f2.setTextConfig({ rotation: 0 });
      return;
    }
    var v4 = f2.shape, _ = v4.clockwise ? v4.startAngle : v4.endAngle, M2 = v4.clockwise ? v4.endAngle : v4.startAngle, I2 = (_ + M2) / 2, P2, N3 = t2(i);
    switch (N3) {
      case "startArc":
      case "insideStartArc":
      case "middle":
      case "insideEndArc":
      case "endArc":
        P2 = I2;
        break;
      case "startAngle":
      case "insideStartAngle":
        P2 = _;
        break;
      case "endAngle":
      case "insideEndAngle":
        P2 = M2;
        break;
      default:
        f2.setTextConfig({ rotation: 0 });
        return;
    }
    var z3 = Math.PI * 1.5 - P2;
    N3 === "middle" && z3 > Math.PI / 2 && z3 < Math.PI * 1.5 && (z3 -= Math.PI), f2.setTextConfig({ rotation: z3 });
  }
  function fDt(f2, i, t2) {
    return i * Math.sin(f2) * (t2 ? -1 : 1);
  }
  function hDt(f2, i, t2) {
    return i * Math.cos(f2) * (t2 ? 1 : -1);
  }
  var $Xt = Math.max, YXt = Math.min;
  function Eyr(f2, i) {
    var t2 = f2.getArea && f2.getArea();
    if (Y6(f2, "cartesian2d")) {
      var h = f2.getBaseAxis();
      if (h.type !== "category" || !h.onBand) {
        var v4 = i.getLayout("bandWidth");
        h.isHorizontal() ? (t2.x -= v4, t2.width += v4 * 2) : (t2.y -= v4, t2.height += v4 * 2);
      }
    }
    return t2;
  }
  var kyr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2.call(this) || this;
      return t2.type = i.type, t2._isFirstFrame = true, t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      this._model = t2, this._removeOnRenderedListener(v4), this._updateDrawMode(t2);
      var M2 = t2.get("coordinateSystem");
      (M2 === "cartesian2d" || M2 === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(t2, h, v4) : this._renderNormal(t2, h, v4, _));
    }, i.prototype.incrementalPrepareRender = function(t2) {
      this._clear(), this._updateDrawMode(t2), this._updateLargeClip(t2);
    }, i.prototype.incrementalRender = function(t2, h) {
      this._progressiveEls = [], this._incrementalRenderLarge(t2, h);
    }, i.prototype.eachRendered = function(t2) {
      oV(this._progressiveEls || this.group, t2);
    }, i.prototype._updateDrawMode = function(t2) {
      var h = t2.pipelineContext.large;
      (this._isLargeDraw == null || h !== this._isLargeDraw) && (this._isLargeDraw = h, this._clear());
    }, i.prototype._renderNormal = function(t2, h, v4, _) {
      var M2 = this.group, I2 = t2.getData(), P2 = this._data, N3 = t2.coordinateSystem, z3 = N3.getBaseAxis(), H2;
      N3.type === "cartesian2d" ? H2 = z3.isHorizontal() : N3.type === "polar" && (H2 = z3.dim === "angle");
      var $ = t2.isAnimationEnabled() ? t2 : null, et = Pyr(t2, N3);
      et && this._enableRealtimeSort(et, I2, v4);
      var at = t2.get("clip", true) || et, ht = Eyr(N3, I2);
      M2.removeClipPath();
      var bt = t2.get("roundCap", true), _t = t2.get("showBackground", true), Et = t2.getModel("backgroundStyle"), zt = Et.get("borderRadius") || 0, Ft = [], fe2 = this._backgroundEls, re2 = _ && _.isInitSort, ye = _ && _.type === "changeAxisOrder";
      function me2(We) {
        var en = pDt[N3.type](I2, We), Ue2 = Byr(N3, H2, en);
        return Ue2.useStyle(Et.getItemStyle()), N3.type === "cartesian2d" && Ue2.setShape("r", zt), Ft[We] = Ue2, Ue2;
      }
      I2.diff(P2).add(function(We) {
        var en = I2.getItemModel(We), Ue2 = pDt[N3.type](I2, We, en);
        if (_t && me2(We), !(!I2.hasValue(We) || !T8e[N3.type](Ue2))) {
          var Mn = false;
          at && (Mn = w8e[N3.type](ht, Ue2));
          var Vn = S8e[N3.type](t2, I2, We, Ue2, H2, $, z3.model, false, bt);
          et && (Vn.forceLabelAnimation = true), A8e(Vn, I2, We, en, Ue2, t2, H2, N3.type === "polar"), re2 ? Vn.attr({ shape: Ue2 }) : et ? M8e(et, $, Vn, Ue2, We, H2, false, false) : Qv(Vn, { shape: Ue2 }, t2, We), I2.setItemGraphicEl(We, Vn), M2.add(Vn), Vn.ignore = Mn;
        }
      }).update(function(We, en) {
        var Ue2 = I2.getItemModel(We), Mn = pDt[N3.type](I2, We, Ue2);
        if (_t) {
          var Vn = void 0;
          fe2.length === 0 ? Vn = me2(en) : (Vn = fe2[en], Vn.useStyle(Et.getItemStyle()), N3.type === "cartesian2d" && Vn.setShape("r", zt), Ft[We] = Vn);
          var xn = pDt[N3.type](I2, We), Zr = MHe(H2, xn, N3);
          jh2(Vn, { shape: Zr }, $, We);
        }
        var nr = P2.getItemGraphicEl(en);
        if (!I2.hasValue(We) || !T8e[N3.type](Mn)) {
          M2.remove(nr);
          return;
        }
        var pr = false;
        if (at && (pr = w8e[N3.type](ht, Mn), pr && M2.remove(nr)), nr ? A5(nr) : nr = S8e[N3.type](t2, I2, We, Mn, H2, $, z3.model, !!nr, bt), et && (nr.forceLabelAnimation = true), ye) {
          var Nr = nr.getTextContent();
          if (Nr) {
            var ai2 = net(Nr);
            ai2.prevValue != null && (ai2.prevValue = ai2.value);
          }
        } else
          A8e(nr, I2, We, Ue2, Mn, t2, H2, N3.type === "polar");
        re2 ? nr.attr({ shape: Mn }) : et ? M8e(et, $, nr, Mn, We, H2, true, ye) : jh2(nr, { shape: Mn }, t2, We, null), I2.setItemGraphicEl(We, nr), nr.ignore = pr, M2.add(nr);
      }).remove(function(We) {
        var en = P2.getItemGraphicEl(We);
        en && tgt(en, t2, We);
      }).execute();
      var be2 = this._backgroundGroup || (this._backgroundGroup = new mu());
      be2.removeAll();
      for (var Te2 = 0; Te2 < Ft.length; ++Te2)
        be2.add(Ft[Te2]);
      M2.add(be2), this._backgroundEls = Ft, this._data = I2;
    }, i.prototype._renderLarge = function(t2, h, v4) {
      this._clear(), D8e(t2, this.group), this._updateLargeClip(t2);
    }, i.prototype._incrementalRenderLarge = function(t2, h) {
      this._removeBackground(), D8e(h, this.group, this._progressiveEls, true);
    }, i.prototype._updateLargeClip = function(t2) {
      var h = t2.get("clip", true) && Fkt(t2.coordinateSystem, false, t2), v4 = this.group;
      h ? v4.setClipPath(h) : v4.removeClipPath();
    }, i.prototype._enableRealtimeSort = function(t2, h, v4) {
      var _ = this;
      if (!!h.count()) {
        var M2 = t2.baseAxis;
        if (this._isFirstFrame)
          this._dispatchInitSort(h, t2, v4), this._isFirstFrame = false;
        else {
          var I2 = function(P2) {
            var N3 = h.getItemGraphicEl(P2), z3 = N3 && N3.shape;
            return z3 && Math.abs(M2.isHorizontal() ? z3.height : z3.width) || 0;
          };
          this._onRendered = function() {
            _._updateSortWithinSameData(h, I2, M2, v4);
          }, v4.getZr().on("rendered", this._onRendered);
        }
      }
    }, i.prototype._dataSort = function(t2, h, v4) {
      var _ = [];
      return t2.each(t2.mapDimension(h.dim), function(M2, I2) {
        var P2 = v4(I2);
        P2 = P2 == null ? NaN : P2, _.push({ dataIndex: I2, mappedValue: P2, ordinalNumber: M2 });
      }), _.sort(function(M2, I2) {
        return I2.mappedValue - M2.mappedValue;
      }), { ordinalNumbers: Xa2(_, function(M2) {
        return M2.ordinalNumber;
      }) };
    }, i.prototype._isOrderChangedWithinSameData = function(t2, h, v4) {
      for (var _ = v4.scale, M2 = t2.mapDimension(v4.dim), I2 = Number.MAX_VALUE, P2 = 0, N3 = _.getOrdinalMeta().categories.length; P2 < N3; ++P2) {
        var z3 = t2.rawIndexOf(M2, _.getRawOrdinalNumber(P2)), H2 = z3 < 0 ? Number.MIN_VALUE : h(t2.indexOfRawIndex(z3));
        if (H2 > I2)
          return true;
        I2 = H2;
      }
      return false;
    }, i.prototype._isOrderDifferentInView = function(t2, h) {
      for (var v4 = h.scale, _ = v4.getExtent(), M2 = Math.max(0, _[0]), I2 = Math.min(_[1], v4.getOrdinalMeta().categories.length - 1); M2 <= I2; ++M2)
        if (t2.ordinalNumbers[M2] !== v4.getRawOrdinalNumber(M2))
          return true;
    }, i.prototype._updateSortWithinSameData = function(t2, h, v4, _) {
      if (!!this._isOrderChangedWithinSameData(t2, h, v4)) {
        var M2 = this._dataSort(t2, v4, h);
        this._isOrderDifferentInView(M2, v4) && (this._removeOnRenderedListener(_), _.dispatchAction({ type: "changeAxisOrder", componentType: v4.dim + "Axis", axisId: v4.index, sortInfo: M2 }));
      }
    }, i.prototype._dispatchInitSort = function(t2, h, v4) {
      var _ = h.baseAxis, M2 = this._dataSort(t2, _, function(I2) {
        return t2.get(t2.mapDimension(h.otherAxis.dim), I2);
      });
      v4.dispatchAction({ type: "changeAxisOrder", componentType: _.dim + "Axis", isInitSort: true, axisId: _.index, sortInfo: M2 });
    }, i.prototype.remove = function(t2, h) {
      this._clear(this._model), this._removeOnRenderedListener(h);
    }, i.prototype.dispose = function(t2, h) {
      this._removeOnRenderedListener(h);
    }, i.prototype._removeOnRenderedListener = function(t2) {
      this._onRendered && (t2.getZr().off("rendered", this._onRendered), this._onRendered = null);
    }, i.prototype._clear = function(t2) {
      var h = this.group, v4 = this._data;
      t2 && t2.isAnimationEnabled() && v4 && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], v4.eachItemGraphicEl(function(_) {
        tgt(_, t2, Du(_).dataIndex);
      })) : h.removeAll(), this._data = null, this._isFirstFrame = true;
    }, i.prototype._removeBackground = function() {
      this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
    }, i.type = "bar", i;
  }(Hg2), w8e = { cartesian2d: function(f2, i) {
    var t2 = i.width < 0 ? -1 : 1, h = i.height < 0 ? -1 : 1;
    t2 < 0 && (i.x += i.width, i.width = -i.width), h < 0 && (i.y += i.height, i.height = -i.height);
    var v4 = f2.x + f2.width, _ = f2.y + f2.height, M2 = $Xt(i.x, f2.x), I2 = YXt(i.x + i.width, v4), P2 = $Xt(i.y, f2.y), N3 = YXt(i.y + i.height, _), z3 = I2 < M2, H2 = N3 < P2;
    return i.x = z3 && M2 > v4 ? I2 : M2, i.y = H2 && P2 > _ ? N3 : P2, i.width = z3 ? 0 : I2 - M2, i.height = H2 ? 0 : N3 - P2, t2 < 0 && (i.x += i.width, i.width = -i.width), h < 0 && (i.y += i.height, i.height = -i.height), z3 || H2;
  }, polar: function(f2, i) {
    var t2 = i.r0 <= i.r ? 1 : -1;
    if (t2 < 0) {
      var h = i.r;
      i.r = i.r0, i.r0 = h;
    }
    var v4 = YXt(i.r, f2.r), _ = $Xt(i.r0, f2.r0);
    i.r = v4, i.r0 = _;
    var M2 = v4 - _ < 0;
    if (t2 < 0) {
      var h = i.r;
      i.r = i.r0, i.r0 = h;
    }
    return M2;
  } }, S8e = { cartesian2d: function(f2, i, t2, h, v4, _, M2, I2, P2) {
    var N3 = new Sh2({ shape: ba2({}, h), z2: 1 });
    if (N3.__dataIndex = t2, N3.name = "item", _) {
      var z3 = N3.shape, H2 = v4 ? "height" : "width";
      z3[H2] = 0;
    }
    return N3;
  }, polar: function(f2, i, t2, h, v4, _, M2, I2, P2) {
    var N3 = !v4 && P2 ? NEt : rC, z3 = new N3({ shape: h, z2: 1 });
    z3.name = "item";
    var H2 = SHe(v4);
    if (z3.calculateTextPosition = Iyr(H2, { isRoundCap: N3 === NEt }), _) {
      var $ = z3.shape, et = v4 ? "r" : "endAngle", at = {};
      $[et] = v4 ? 0 : h.startAngle, at[et] = h[et], (I2 ? jh2 : Qv)(z3, { shape: at }, _);
    }
    return z3;
  } };
  function Pyr(f2, i) {
    var t2 = f2.get("realtimeSort", true), h = i.getBaseAxis();
    if (t2 && h.type === "category" && i.type === "cartesian2d")
      return { baseAxis: h, otherAxis: i.getOtherAxis(h) };
  }
  function M8e(f2, i, t2, h, v4, _, M2, I2) {
    var P2, N3;
    _ ? (N3 = { x: h.x, width: h.width }, P2 = { y: h.y, height: h.height }) : (N3 = { y: h.y, height: h.height }, P2 = { x: h.x, width: h.width }), I2 || (M2 ? jh2 : Qv)(t2, { shape: P2 }, i, v4, null);
    var z3 = i ? f2.baseAxis.model : null;
    (M2 ? jh2 : Qv)(t2, { shape: N3 }, z3, v4);
  }
  function C8e(f2, i) {
    for (var t2 = 0; t2 < i.length; t2++)
      if (!isFinite(f2[i[t2]]))
        return true;
    return false;
  }
  var Lyr = ["x", "y", "width", "height"], Oyr = ["cx", "cy", "r", "startAngle", "endAngle"], T8e = { cartesian2d: function(f2) {
    return !C8e(f2, Lyr);
  }, polar: function(f2) {
    return !C8e(f2, Oyr);
  } }, pDt = { cartesian2d: function(f2, i, t2) {
    var h = f2.getItemLayout(i), v4 = t2 ? Nyr(t2, h) : 0, _ = h.width > 0 ? 1 : -1, M2 = h.height > 0 ? 1 : -1;
    return { x: h.x + _ * v4 / 2, y: h.y + M2 * v4 / 2, width: h.width - _ * v4, height: h.height - M2 * v4 };
  }, polar: function(f2, i, t2) {
    var h = f2.getItemLayout(i);
    return { cx: h.cx, cy: h.cy, r0: h.r0, r: h.r, startAngle: h.startAngle, endAngle: h.endAngle, clockwise: h.clockwise };
  } };
  function Ryr(f2) {
    return f2.startAngle != null && f2.endAngle != null && f2.startAngle === f2.endAngle;
  }
  function SHe(f2) {
    return function(i) {
      var t2 = i ? "Arc" : "Angle";
      return function(h) {
        switch (h) {
          case "start":
          case "insideStart":
          case "end":
          case "insideEnd":
            return h + t2;
          default:
            return h;
        }
      };
    }(f2);
  }
  function A8e(f2, i, t2, h, v4, _, M2, I2) {
    var P2 = i.getItemVisual(t2, "style");
    I2 || f2.setShape("r", h.get(["itemStyle", "borderRadius"]) || 0), f2.useStyle(P2);
    var N3 = h.getShallow("cursor");
    N3 && f2.attr("cursor", N3);
    var z3 = I2 ? M2 ? v4.r >= v4.r0 ? "endArc" : "startArc" : v4.endAngle >= v4.startAngle ? "endAngle" : "startAngle" : M2 ? v4.height >= 0 ? "bottom" : "top" : v4.width >= 0 ? "right" : "left", H2 = b_(h);
    SS(f2, H2, { labelFetcher: _, labelDataIndex: t2, defaultText: Utt(_.getData(), t2), inheritColor: P2.fill, defaultOpacity: P2.opacity, defaultOutsidePosition: z3 });
    var $ = f2.getTextContent();
    if (I2 && $) {
      var et = h.get(["label", "position"]);
      f2.textConfig.inside = et === "middle" ? true : null, Dyr(f2, et === "outside" ? z3 : et, SHe(M2), h.get(["label", "rotate"]));
    }
    Bje($, H2, _.getRawValue(t2), function(ht) {
      return pHe(i, ht);
    });
    var at = h.getModel(["emphasis"]);
    vy(f2, at.get("focus"), at.get("blurScope"), at.get("disabled")), Hx(f2, h), Ryr(v4) && (f2.style.fill = "none", f2.style.stroke = "none", Qe2(f2.states, function(ht) {
      ht.style && (ht.style.fill = ht.style.stroke = "none");
    }));
  }
  function Nyr(f2, i) {
    var t2 = f2.get(["itemStyle", "borderColor"]);
    if (!t2 || t2 === "none")
      return 0;
    var h = f2.get(["itemStyle", "borderWidth"]) || 0, v4 = isNaN(i.width) ? Number.MAX_VALUE : Math.abs(i.width), _ = isNaN(i.height) ? Number.MAX_VALUE : Math.abs(i.height);
    return Math.min(h, v4, _);
  }
  var Fyr = function() {
    function f2() {
    }
    return f2;
  }(), I8e = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "largeBar", h;
    }
    return i.prototype.getDefaultShape = function() {
      return new Fyr();
    }, i.prototype.buildPath = function(t2, h) {
      for (var v4 = h.points, _ = this.baseDimIdx, M2 = 1 - this.baseDimIdx, I2 = [], P2 = [], N3 = this.barWidth, z3 = 0; z3 < v4.length; z3 += 3)
        P2[_] = N3, P2[M2] = v4[z3 + 2], I2[_] = v4[z3 + _], I2[M2] = v4[z3 + M2], t2.rect(I2[0], I2[1], P2[0], P2[1]);
    }, i;
  }(Uc2);
  function D8e(f2, i, t2, h) {
    var v4 = f2.getData(), _ = v4.getLayout("valueAxisHorizontal") ? 1 : 0, M2 = v4.getLayout("largeDataIndices"), I2 = v4.getLayout("size"), P2 = f2.getModel("backgroundStyle"), N3 = v4.getLayout("largeBackgroundPoints");
    if (N3) {
      var z3 = new I8e({ shape: { points: N3 }, incremental: !!h, silent: true, z2: 0 });
      z3.baseDimIdx = _, z3.largeDataIndices = M2, z3.barWidth = I2, z3.useStyle(P2.getItemStyle()), i.add(z3), t2 && t2.push(z3);
    }
    var H2 = new I8e({ shape: { points: v4.getLayout("largePoints") }, incremental: !!h, z2: 1 });
    H2.baseDimIdx = _, H2.largeDataIndices = M2, H2.barWidth = I2, i.add(H2), H2.useStyle(v4.getVisual("style")), Du(H2).seriesIndex = f2.seriesIndex, f2.get("silent") || (H2.on("mousedown", E8e), H2.on("mousemove", E8e)), t2 && t2.push(H2);
  }
  var E8e = one(function(f2) {
    var i = this, t2 = Vyr(i, f2.offsetX, f2.offsetY);
    Du(i).dataIndex = t2 >= 0 ? t2 : null;
  }, 30, false);
  function Vyr(f2, i, t2) {
    for (var h = f2.baseDimIdx, v4 = 1 - h, _ = f2.shape.points, M2 = f2.largeDataIndices, I2 = [], P2 = [], N3 = f2.barWidth, z3 = 0, H2 = _.length / 3; z3 < H2; z3++) {
      var $ = z3 * 3;
      if (P2[h] = N3, P2[v4] = _[$ + 2], I2[h] = _[$ + h], I2[v4] = _[$ + v4], P2[v4] < 0 && (I2[v4] += P2[v4], P2[v4] = -P2[v4]), i >= I2[0] && i <= I2[0] + P2[0] && t2 >= I2[1] && t2 <= I2[1] + P2[1])
        return M2[z3];
    }
    return -1;
  }
  function MHe(f2, i, t2) {
    if (Y6(t2, "cartesian2d")) {
      var h = i, v4 = t2.getArea();
      return { x: f2 ? h.x : v4.x, y: f2 ? v4.y : h.y, width: f2 ? h.width : v4.width, height: f2 ? v4.height : h.height };
    } else {
      var v4 = t2.getArea(), _ = i;
      return { cx: v4.cx, cy: v4.cy, r0: f2 ? v4.r0 : _.r0, r: f2 ? v4.r : _.r, startAngle: f2 ? _.startAngle : 0, endAngle: f2 ? _.endAngle : Math.PI * 2 };
    }
  }
  function Byr(f2, i, t2) {
    var h = f2.type === "polar" ? rC : Sh2;
    return new h({ shape: MHe(i, t2, f2), silent: true, z2: 0 });
  }
  var zyr = kyr;
  function jyr(f2) {
    f2.registerChartView(zyr), f2.registerSeriesModel(Cyr), f2.registerLayout(f2.PRIORITY.VISUAL.LAYOUT, Ou(EGe, "bar")), f2.registerLayout(f2.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, kGe("bar")), f2.registerProcessor(f2.PRIORITY.PROCESSOR.STATISTIC, xHe("bar")), f2.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(i, t2) {
      var h = i.componentType || "series";
      t2.eachComponent({ mainType: h, query: i }, function(v4) {
        i.sortInfo && v4.axis.setCategorySortInfo(i.sortInfo);
      });
    });
  }
  var dDt = Math.PI * 2, k8e = Math.PI / 180;
  function CHe(f2, i) {
    return u1(f2.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
  }
  function THe(f2, i) {
    var t2 = CHe(f2, i), h = f2.get("center"), v4 = f2.get("radius");
    Za2(v4) || (v4 = [0, v4]), Za2(h) || (h = [h, h]);
    var _ = cs(t2.width, i.getWidth()), M2 = cs(t2.height, i.getHeight()), I2 = Math.min(_, M2), P2 = cs(h[0], _) + t2.x, N3 = cs(h[1], M2) + t2.y, z3 = cs(v4[0], I2 / 2), H2 = cs(v4[1], I2 / 2);
    return { cx: P2, cy: N3, r0: z3, r: H2 };
  }
  function Wyr(f2, i, t2) {
    i.eachSeriesByType(f2, function(h) {
      var v4 = h.getData(), _ = v4.mapDimension("value"), M2 = CHe(h, t2), I2 = THe(h, t2), P2 = I2.cx, N3 = I2.cy, z3 = I2.r, H2 = I2.r0, $ = -h.get("startAngle") * k8e, et = h.get("minAngle") * k8e, at = 0;
      v4.each(_, function(Te2) {
        !isNaN(Te2) && at++;
      });
      var ht = v4.getSum(_), bt = Math.PI / (ht || at) * 2, _t = h.get("clockwise"), Et = h.get("roseType"), zt = h.get("stillShowZeroSum"), Ft = v4.getDataExtent(_);
      Ft[0] = 0;
      var fe2 = dDt, re2 = 0, ye = $, me2 = _t ? 1 : -1;
      if (v4.setLayout({ viewRect: M2, r: z3 }), v4.each(_, function(Te2, We) {
        var en;
        if (isNaN(Te2)) {
          v4.setItemLayout(We, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: _t, cx: P2, cy: N3, r0: H2, r: Et ? NaN : z3 });
          return;
        }
        Et !== "area" ? en = ht === 0 && zt ? bt : Te2 * bt : en = dDt / at, en < et ? (en = et, fe2 -= et) : re2 += Te2;
        var Ue2 = ye + me2 * en;
        v4.setItemLayout(We, { angle: en, startAngle: ye, endAngle: Ue2, clockwise: _t, cx: P2, cy: N3, r0: H2, r: Et ? cd2(Te2, Ft, [H2, z3]) : z3 }), ye = Ue2;
      }), fe2 < dDt && at)
        if (fe2 <= 1e-3) {
          var be2 = dDt / at;
          v4.each(_, function(Te2, We) {
            if (!isNaN(Te2)) {
              var en = v4.getItemLayout(We);
              en.angle = be2, en.startAngle = $ + me2 * We * be2, en.endAngle = $ + me2 * (We + 1) * be2;
            }
          });
        } else
          bt = fe2 / re2, ye = $, v4.each(_, function(Te2, We) {
            if (!isNaN(Te2)) {
              var en = v4.getItemLayout(We), Ue2 = en.angle === et ? et : Te2 * bt;
              en.startAngle = ye, en.endAngle = ye + me2 * Ue2, ye += me2 * Ue2;
            }
          });
    });
  }
  function jgt(f2) {
    return { seriesType: f2, reset: function(i, t2) {
      var h = t2.findComponents({ mainType: "legend" });
      if (!(!h || !h.length)) {
        var v4 = i.getData();
        v4.filterSelf(function(_) {
          for (var M2 = v4.getName(_), I2 = 0; I2 < h.length; I2++)
            if (!h[I2].isSelected(M2))
              return false;
          return true;
        });
      }
    } };
  }
  var Gyr = Math.PI / 180;
  function P8e(f2, i, t2, h, v4, _, M2, I2, P2, N3) {
    if (f2.length < 2)
      return;
    function z3(ht) {
      for (var bt = ht.rB, _t = bt * bt, Et = 0; Et < ht.list.length; Et++) {
        var zt = ht.list[Et], Ft = Math.abs(zt.label.y - t2), fe2 = h + zt.len, re2 = fe2 * fe2, ye = Math.sqrt((1 - Math.abs(Ft * Ft / _t)) * re2), me2 = i + (ye + zt.len2) * v4, be2 = me2 - zt.label.x, Te2 = zt.targetTextWidth - be2 * v4;
        AHe(zt, Te2, true), zt.label.x = me2;
      }
    }
    function H2(ht) {
      for (var bt = { list: [], maxY: 0 }, _t = { list: [], maxY: 0 }, Et = 0; Et < ht.length; Et++)
        if (ht[Et].labelAlignTo === "none") {
          var zt = ht[Et], Ft = zt.label.y > t2 ? _t : bt, fe2 = Math.abs(zt.label.y - t2);
          if (fe2 >= Ft.maxY) {
            var re2 = zt.label.x - i - zt.len2 * v4, ye = h + zt.len, me2 = Math.abs(re2) < ye ? Math.sqrt(fe2 * fe2 / (1 - re2 * re2 / ye / ye)) : ye;
            Ft.rB = me2, Ft.maxY = fe2;
          }
          Ft.list.push(zt);
        }
      z3(bt), z3(_t);
    }
    for (var $ = f2.length, et = 0; et < $; et++)
      if (f2[et].position === "outer" && f2[et].labelAlignTo === "labelLine") {
        var at = f2[et].label.x - N3;
        f2[et].linePoints[1][0] += at, f2[et].label.x = N3;
      }
    JGe(f2, P2, P2 + M2) && H2(f2);
  }
  function Hyr(f2, i, t2, h, v4, _, M2, I2) {
    for (var P2 = [], N3 = [], z3 = Number.MAX_VALUE, H2 = -Number.MAX_VALUE, $ = 0; $ < f2.length; $++) {
      var et = f2[$].label;
      KXt(f2[$]) || (et.x < i ? (z3 = Math.min(z3, et.x), P2.push(f2[$])) : (H2 = Math.max(H2, et.x), N3.push(f2[$])));
    }
    for (var $ = 0; $ < f2.length; $++) {
      var at = f2[$];
      if (!KXt(at) && at.linePoints) {
        if (at.labelStyleWidth != null)
          continue;
        var et = at.label, ht = at.linePoints, bt = void 0;
        at.labelAlignTo === "edge" ? et.x < i ? bt = ht[2][0] - at.labelDistance - M2 - at.edgeDistance : bt = M2 + v4 - at.edgeDistance - ht[2][0] - at.labelDistance : at.labelAlignTo === "labelLine" ? et.x < i ? bt = z3 - M2 - at.bleedMargin : bt = M2 + v4 - H2 - at.bleedMargin : et.x < i ? bt = et.x - M2 - at.bleedMargin : bt = M2 + v4 - et.x - at.bleedMargin, at.targetTextWidth = bt, AHe(at, bt);
      }
    }
    P8e(N3, i, t2, h, 1, v4, _, M2, I2, H2), P8e(P2, i, t2, h, -1, v4, _, M2, I2, z3);
    for (var $ = 0; $ < f2.length; $++) {
      var at = f2[$];
      if (!KXt(at) && at.linePoints) {
        var et = at.label, ht = at.linePoints, _t = at.labelAlignTo === "edge", Et = et.style.padding, zt = Et ? Et[1] + Et[3] : 0, Ft = et.style.backgroundColor ? 0 : zt, fe2 = at.rect.width + Ft, re2 = ht[1][0] - ht[2][0];
        _t ? et.x < i ? ht[2][0] = M2 + at.edgeDistance + fe2 + at.labelDistance : ht[2][0] = M2 + v4 - at.edgeDistance - fe2 - at.labelDistance : (et.x < i ? ht[2][0] = et.x + at.labelDistance : ht[2][0] = et.x - at.labelDistance, ht[1][0] = ht[2][0] + re2), ht[1][1] = ht[2][1] = et.y;
      }
    }
  }
  function AHe(f2, i, t2) {
    if (t2 === void 0 && (t2 = false), f2.labelStyleWidth == null) {
      var h = f2.label, v4 = h.style, _ = f2.rect, M2 = v4.backgroundColor, I2 = v4.padding, P2 = I2 ? I2[1] + I2[3] : 0, N3 = v4.overflow, z3 = _.width + (M2 ? 0 : P2);
      if (i < z3 || t2) {
        var H2 = _.height;
        if (N3 && N3.match("break")) {
          h.setStyle("backgroundColor", null), h.setStyle("width", i - P2);
          var $ = h.getBoundingRect();
          h.setStyle("width", Math.ceil($.width)), h.setStyle("backgroundColor", M2);
        } else {
          var et = i - P2, at = i < z3 ? et : t2 ? et > f2.unconstrainedWidth ? null : et : null;
          h.setStyle("width", at);
        }
        var ht = h.getBoundingRect();
        _.width = ht.width;
        var bt = (h.style.margin || 0) + 2.1;
        _.height = ht.height + bt, _.y -= (_.height - H2) / 2;
      }
    }
  }
  function KXt(f2) {
    return f2.position === "center";
  }
  function Uyr(f2) {
    var i = f2.getData(), t2 = [], h, v4, _ = false, M2 = (f2.get("minShowLabelAngle") || 0) * Gyr, I2 = i.getLayout("viewRect"), P2 = i.getLayout("r"), N3 = I2.width, z3 = I2.x, H2 = I2.y, $ = I2.height;
    function et(re2) {
      re2.ignore = true;
    }
    function at(re2) {
      if (!re2.ignore)
        return true;
      for (var ye in re2.states)
        if (re2.states[ye].ignore === false)
          return true;
      return false;
    }
    i.each(function(re2) {
      var ye = i.getItemGraphicEl(re2), me2 = ye.shape, be2 = ye.getTextContent(), Te2 = ye.getTextGuideLine(), We = i.getItemModel(re2), en = We.getModel("label"), Ue2 = en.get("position") || We.get(["emphasis", "label", "position"]), Mn = en.get("distanceToLabelLine"), Vn = en.get("alignTo"), xn = cs(en.get("edgeDistance"), N3), Zr = en.get("bleedMargin"), nr = We.getModel("labelLine"), pr = nr.get("length");
      pr = cs(pr, N3);
      var Nr = nr.get("length2");
      if (Nr = cs(Nr, N3), Math.abs(me2.endAngle - me2.startAngle) < M2) {
        Qe2(be2.states, et), be2.ignore = true;
        return;
      }
      if (!!at(be2)) {
        var ai2 = (me2.startAngle + me2.endAngle) / 2, gi2 = Math.cos(ai2), To = Math.sin(ai2), us, ml, ll, Rs;
        h = me2.cx, v4 = me2.cy;
        var es = Ue2 === "inside" || Ue2 === "inner";
        if (Ue2 === "center")
          us = me2.cx, ml = me2.cy, Rs = "center";
        else {
          var Ws = (es ? (me2.r + me2.r0) / 2 * gi2 : me2.r * gi2) + h, il = (es ? (me2.r + me2.r0) / 2 * To : me2.r * To) + v4;
          if (us = Ws + gi2 * 3, ml = il + To * 3, !es) {
            var bs = Ws + gi2 * (pr + P2 - me2.r), Rl = il + To * (pr + P2 - me2.r), Mh2 = bs + (gi2 < 0 ? -1 : 1) * Nr, au = Rl;
            Vn === "edge" ? us = gi2 < 0 ? z3 + xn : z3 + N3 - xn : us = Mh2 + (gi2 < 0 ? -Mn : Mn), ml = au, ll = [[Ws, il], [bs, Rl], [Mh2, au]];
          }
          Rs = es ? "center" : Vn === "edge" ? gi2 > 0 ? "right" : "left" : gi2 > 0 ? "left" : "right";
        }
        var eh2 = Math.PI, Gh2 = 0, Pp = en.get("rotate");
        if (vp(Pp))
          Gh2 = Pp * (eh2 / 180);
        else if (Ue2 === "center")
          Gh2 = 0;
        else if (Pp === "radial" || Pp === true) {
          var zy = gi2 < 0 ? -ai2 + eh2 : -ai2;
          Gh2 = zy;
        } else if (Pp === "tangential" && Ue2 !== "outside" && Ue2 !== "outer") {
          var Rd2 = Math.atan2(gi2, To);
          Rd2 < 0 && (Rd2 = eh2 * 2 + Rd2);
          var c1 = To > 0;
          c1 && (Rd2 = eh2 + Rd2), Gh2 = Rd2 - eh2;
        }
        if (_ = !!Gh2, be2.x = us, be2.y = ml, be2.rotation = Gh2, be2.setStyle({ verticalAlign: "middle" }), es) {
          be2.setStyle({ align: Rs });
          var qg2 = be2.states.select;
          qg2 && (qg2.x += be2.x, qg2.y += be2.y);
        } else {
          var _d = be2.getBoundingRect().clone();
          _d.applyTransform(be2.getComputedTransform());
          var G0 = (be2.style.margin || 0) + 2.1;
          _d.y -= G0 / 2, _d.height += G0, t2.push({ label: be2, labelLine: Te2, position: Ue2, len: pr, len2: Nr, minTurnAngle: nr.get("minTurnAngle"), maxSurfaceAngle: nr.get("maxSurfaceAngle"), surfaceNormal: new ac2(gi2, To), linePoints: ll, textAlign: Rs, labelDistance: Mn, labelAlignTo: Vn, edgeDistance: xn, bleedMargin: Zr, rect: _d, unconstrainedWidth: _d.width, labelStyleWidth: be2.style.width });
        }
        ye.setTextConfig({ inside: es });
      }
    }), !_ && f2.get("avoidLabelOverlap") && Hyr(t2, h, v4, P2, N3, $, z3, H2);
    for (var ht = 0; ht < t2.length; ht++) {
      var bt = t2[ht], _t = bt.label, Et = bt.labelLine, zt = isNaN(_t.x) || isNaN(_t.y);
      if (_t) {
        _t.setStyle({ align: bt.textAlign }), zt && (Qe2(_t.states, et), _t.ignore = true);
        var Ft = _t.states.select;
        Ft && (Ft.x += _t.x, Ft.y += _t.y);
      }
      if (Et) {
        var fe2 = bt.linePoints;
        zt || !fe2 ? (Qe2(Et.states, et), Et.ignore = true) : (KGe(fe2, bt.minTurnAngle), r0r(fe2, bt.surfaceNormal, bt.maxSurfaceAngle), Et.setShape({ points: fe2 }), _t.__hostTarget.textGuideLineConfig = { anchor: new ac2(fe2[0][0], fe2[0][1]) });
      }
    }
  }
  function Ett(f2, i, t2) {
    var h = f2.get("borderRadius");
    if (h == null)
      return t2 ? { cornerRadius: 0 } : null;
    Za2(h) || (h = [h, h, h, h]);
    var v4 = Math.abs(i.r || 0 - i.r0 || 0);
    return { cornerRadius: Xa2(h, function(_) {
      return T5(_, v4);
    }) };
  }
  var qyr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this) || this;
      _.z2 = 2;
      var M2 = new op();
      return _.setTextContent(M2), _.updateData(t2, h, v4, true), _;
    }
    return i.prototype.updateData = function(t2, h, v4, _) {
      var M2 = this, I2 = t2.hostModel, P2 = t2.getItemModel(h), N3 = P2.getModel("emphasis"), z3 = t2.getItemLayout(h), H2 = ba2(Ett(P2.getModel("itemStyle"), z3, true), z3);
      if (isNaN(H2.startAngle)) {
        M2.setShape(H2);
        return;
      }
      if (_) {
        M2.setShape(H2);
        var $ = I2.getShallow("animationType");
        I2.ecModel.ssr ? (Qv(M2, { scaleX: 0, scaleY: 0 }, I2, { dataIndex: h, isFrom: true }), M2.originX = H2.cx, M2.originY = H2.cy) : $ === "scale" ? (M2.shape.r = z3.r0, Qv(M2, { shape: { r: z3.r } }, I2, h)) : v4 != null ? (M2.setShape({ startAngle: v4, endAngle: v4 }), Qv(M2, { shape: { startAngle: z3.startAngle, endAngle: z3.endAngle } }, I2, h)) : (M2.shape.endAngle = z3.startAngle, jh2(M2, { shape: { endAngle: z3.endAngle } }, I2, h));
      } else
        A5(M2), jh2(M2, { shape: H2 }, I2, h);
      M2.useStyle(t2.getItemVisual(h, "style")), Hx(M2, P2);
      var et = (z3.startAngle + z3.endAngle) / 2, at = I2.get("selectedOffset"), ht = Math.cos(et) * at, bt = Math.sin(et) * at, _t = P2.getShallow("cursor");
      _t && M2.attr("cursor", _t), this._updateLabel(I2, t2, h), M2.ensureState("emphasis").shape = ba2({ r: z3.r + (N3.get("scale") && N3.get("scaleSize") || 0) }, Ett(N3.getModel("itemStyle"), z3)), ba2(M2.ensureState("select"), { x: ht, y: bt, shape: Ett(P2.getModel(["select", "itemStyle"]), z3) }), ba2(M2.ensureState("blur"), { shape: Ett(P2.getModel(["blur", "itemStyle"]), z3) });
      var Et = M2.getTextGuideLine(), zt = M2.getTextContent();
      Et && ba2(Et.ensureState("select"), { x: ht, y: bt }), ba2(zt.ensureState("select"), { x: ht, y: bt }), vy(this, N3.get("focus"), N3.get("blurScope"), N3.get("disabled"));
    }, i.prototype._updateLabel = function(t2, h, v4) {
      var _ = this, M2 = h.getItemModel(v4), I2 = M2.getModel("labelLine"), P2 = h.getItemVisual(v4, "style"), N3 = P2 && P2.fill, z3 = P2 && P2.opacity;
      SS(_, b_(M2), { labelFetcher: h.hostModel, labelDataIndex: v4, inheritColor: N3, defaultOpacity: z3, defaultText: t2.getFormattedLabel(v4, "normal") || h.getName(v4) });
      var H2 = _.getTextContent();
      _.setTextConfig({ position: null, rotation: null }), H2.attr({ z2: 10 });
      var $ = t2.get(["label", "position"]);
      if ($ !== "outside" && $ !== "outer")
        _.removeTextGuideLine();
      else {
        var et = this.getTextGuideLine();
        et || (et = new aC(), this.setTextGuideLine(et)), _ne(this, xne(M2), { stroke: N3, opacity: U6(I2.get(["lineStyle", "opacity"]), z3, 1) });
      }
    }, i;
  }(rC), Zyr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.ignoreLabelLineUpdate = true, t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      var M2 = t2.getData(), I2 = this._data, P2 = this.group, N3;
      if (!I2 && M2.count() > 0) {
        for (var z3 = M2.getItemLayout(0), H2 = 1; isNaN(z3 && z3.startAngle) && H2 < M2.count(); ++H2)
          z3 = M2.getItemLayout(H2);
        z3 && (N3 = z3.startAngle);
      }
      if (this._emptyCircleSector && P2.remove(this._emptyCircleSector), M2.count() === 0 && t2.get("showEmptyCircle")) {
        var $ = new rC({ shape: THe(t2, v4) });
        $.useStyle(t2.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = $, P2.add($);
      }
      M2.diff(I2).add(function(et) {
        var at = new qyr(M2, et, N3);
        M2.setItemGraphicEl(et, at), P2.add(at);
      }).update(function(et, at) {
        var ht = I2.getItemGraphicEl(at);
        ht.updateData(M2, et, N3), ht.off("click"), P2.add(ht), M2.setItemGraphicEl(et, ht);
      }).remove(function(et) {
        var at = I2.getItemGraphicEl(et);
        tgt(at, t2, et);
      }).execute(), Uyr(t2), t2.get("animationTypeUpdate") !== "expansion" && (this._data = M2);
    }, i.prototype.dispose = function() {
    }, i.prototype.containPoint = function(t2, h) {
      var v4 = h.getData(), _ = v4.getItemLayout(0);
      if (_) {
        var M2 = t2[0] - _.cx, I2 = t2[1] - _.cy, P2 = Math.sqrt(M2 * M2 + I2 * I2);
        return P2 <= _.r && P2 >= _.r0;
      }
    }, i.type = "pie", i;
  }(Hg2), $yr = Zyr;
  function het(f2, i, t2) {
    i = Za2(i) && { coordDimensions: i } || ba2({ encodeDefine: f2.getEncode() }, i);
    var h = f2.getSource(), v4 = Rgt(h, i).dimensions, _ = new B2(v4, f2);
    return _.initData(h, t2), _;
  }
  var Yyr = function() {
    function f2(i, t2) {
      this._getDataWithEncodedVisual = i, this._getRawData = t2;
    }
    return f2.prototype.getAllNames = function() {
      var i = this._getRawData();
      return i.mapArray(i.getName);
    }, f2.prototype.containName = function(i) {
      var t2 = this._getRawData();
      return t2.indexOfName(i) >= 0;
    }, f2.prototype.indexOfName = function(i) {
      var t2 = this._getDataWithEncodedVisual();
      return t2.indexOfName(i);
    }, f2.prototype.getItemVisual = function(i, t2) {
      var h = this._getDataWithEncodedVisual();
      return h.getItemVisual(i, t2);
    }, f2;
  }(), Wgt = Yyr, Kyr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.init = function(t2) {
      f2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Wgt(ks(this.getData, this), ks(this.getRawData, this)), this._defaultLabelLine(t2);
    }, i.prototype.mergeOption = function() {
      f2.prototype.mergeOption.apply(this, arguments);
    }, i.prototype.getInitialData = function() {
      return het(this, { coordDimensions: ["value"], encodeDefaulter: Ou(Kee, this) });
    }, i.prototype.getDataParams = function(t2) {
      var h = this.getData(), v4 = f2.prototype.getDataParams.call(this, t2), _ = [];
      return h.each(h.mapDimension("value"), function(M2) {
        _.push(M2);
      }), v4.percent = ecr(_, t2, h.hostModel.get("percentPrecision")), v4.$vars.push("percent"), v4;
    }, i.prototype._defaultLabelLine = function(t2) {
      gU(t2, "labelLine", ["show"]);
      var h = t2.labelLine, v4 = t2.emphasis.labelLine;
      h.show = h.show && t2.label.show, v4.show = v4.show && t2.emphasis.label.show;
    }, i.type = "series.pie", i.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, i;
  }(Jv), Xyr = Kyr;
  function Qyr(f2) {
    return { seriesType: f2, reset: function(i, t2) {
      var h = i.getData();
      h.filterSelf(function(v4) {
        var _ = h.mapDimension("value"), M2 = h.get(_, v4);
        return !(vp(M2) && !isNaN(M2) && M2 < 0);
      });
    } };
  }
  function Jyr(f2) {
    f2.registerChartView($yr), f2.registerSeriesModel(Xyr), ZWe("pie", f2.registerAction), f2.registerLayout(Ou(Wyr, "pie")), f2.registerProcessor(jgt("pie")), f2.registerProcessor(Qyr("pie"));
  }
  var tmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.hasSymbolVisual = true, t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      return aN(null, this, { useEncodeDefaulter: true });
    }, i.prototype.getProgressive = function() {
      var t2 = this.option.progressive;
      return t2 == null ? this.option.large ? 5e3 : this.get("progressive") : t2;
    }, i.prototype.getProgressiveThreshold = function() {
      var t2 = this.option.progressiveThreshold;
      return t2 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : t2;
    }, i.prototype.brushSelector = function(t2, h, v4) {
      return v4.point(h.getItemLayout(t2));
    }, i.prototype.getZLevelKey = function() {
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
    }, i.type = "series.scatter", i.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, i;
  }(Jv), emr = tmr, IHe = 4, nmr = function() {
    function f2() {
    }
    return f2;
  }(), rmr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h._off = 0, h.hoverDataIdx = -1, h;
    }
    return i.prototype.getDefaultShape = function() {
      return new nmr();
    }, i.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.points, _ = h.size, M2 = this.symbolProxy, I2 = M2.shape, P2 = t2.getContext ? t2.getContext() : t2, N3 = P2 && _[0] < IHe, z3 = this.softClipShape, H2;
      if (N3) {
        this._ctx = P2;
        return;
      }
      for (this._ctx = null, H2 = this._off; H2 < v4.length; ) {
        var $ = v4[H2++], et = v4[H2++];
        isNaN($) || isNaN(et) || z3 && !z3.contain($, et) || (I2.x = $ - _[0] / 2, I2.y = et - _[1] / 2, I2.width = _[0], I2.height = _[1], M2.buildPath(t2, I2, true));
      }
      this.incremental && (this._off = H2, this.notClear = true);
    }, i.prototype.afterBrush = function() {
      var t2 = this.shape, h = t2.points, v4 = t2.size, _ = this._ctx, M2 = this.softClipShape, I2;
      if (!!_) {
        for (I2 = this._off; I2 < h.length; ) {
          var P2 = h[I2++], N3 = h[I2++];
          isNaN(P2) || isNaN(N3) || M2 && !M2.contain(P2, N3) || _.fillRect(P2 - v4[0] / 2, N3 - v4[1] / 2, v4[0], v4[1]);
        }
        this.incremental && (this._off = I2, this.notClear = true);
      }
    }, i.prototype.findDataIndex = function(t2, h) {
      for (var v4 = this.shape, _ = v4.points, M2 = v4.size, I2 = Math.max(M2[0], 4), P2 = Math.max(M2[1], 4), N3 = _.length / 2 - 1; N3 >= 0; N3--) {
        var z3 = N3 * 2, H2 = _[z3] - I2 / 2, $ = _[z3 + 1] - P2 / 2;
        if (t2 >= H2 && h >= $ && t2 <= H2 + I2 && h <= $ + P2)
          return N3;
      }
      return -1;
    }, i.prototype.contain = function(t2, h) {
      var v4 = this.transformCoordToLocal(t2, h), _ = this.getBoundingRect();
      if (t2 = v4[0], h = v4[1], _.contain(t2, h)) {
        var M2 = this.hoverDataIdx = this.findDataIndex(t2, h);
        return M2 >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, i.prototype.getBoundingRect = function() {
      var t2 = this._rect;
      if (!t2) {
        for (var h = this.shape, v4 = h.points, _ = h.size, M2 = _[0], I2 = _[1], P2 = 1 / 0, N3 = 1 / 0, z3 = -1 / 0, H2 = -1 / 0, $ = 0; $ < v4.length; ) {
          var et = v4[$++], at = v4[$++];
          P2 = Math.min(et, P2), z3 = Math.max(et, z3), N3 = Math.min(at, N3), H2 = Math.max(at, H2);
        }
        t2 = this._rect = new Lc2(P2 - M2 / 2, N3 - I2 / 2, z3 - P2 + M2, H2 - N3 + I2);
      }
      return t2;
    }, i;
  }(Uc2), imr = function() {
    function f2() {
      this.group = new mu();
    }
    return f2.prototype.updateData = function(i, t2) {
      this._clear();
      var h = this._create();
      h.setShape({ points: i.getLayout("points") }), this._setCommon(h, i, t2);
    }, f2.prototype.updateLayout = function(i) {
      var t2 = i.getLayout("points");
      this.group.eachChild(function(h) {
        if (h.startIndex != null) {
          var v4 = (h.endIndex - h.startIndex) * 2, _ = h.startIndex * 4 * 2;
          t2 = new Float32Array(t2.buffer, _, v4);
        }
        h.setShape("points", t2), h.reset();
      });
    }, f2.prototype.incrementalPrepareUpdate = function(i) {
      this._clear();
    }, f2.prototype.incrementalUpdate = function(i, t2, h) {
      var v4 = this._newAdded[0], _ = t2.getLayout("points"), M2 = v4 && v4.shape.points;
      if (M2 && M2.length < 2e4) {
        var I2 = M2.length, P2 = new Float32Array(I2 + _.length);
        P2.set(M2), P2.set(_, I2), v4.endIndex = i.end, v4.setShape({ points: P2 });
      } else {
        this._newAdded = [];
        var N3 = this._create();
        N3.startIndex = i.start, N3.endIndex = i.end, N3.incremental = true, N3.setShape({ points: _ }), this._setCommon(N3, t2, h);
      }
    }, f2.prototype.eachRendered = function(i) {
      this._newAdded[0] && i(this._newAdded[0]);
    }, f2.prototype._create = function() {
      var i = new rmr({ cursor: "default" });
      return this.group.add(i), this._newAdded.push(i), i;
    }, f2.prototype._setCommon = function(i, t2, h) {
      var v4 = t2.hostModel;
      h = h || {};
      var _ = t2.getVisual("symbolSize");
      i.setShape("size", _ instanceof Array ? _ : [_, _]), i.softClipShape = h.clipShape || null, i.symbolProxy = wm(t2.getVisual("symbol"), 0, 0, 0, 0), i.setColor = i.symbolProxy.setColor;
      var M2 = i.shape.size[0] < IHe;
      i.useStyle(v4.getModel("itemStyle").getItemStyle(M2 ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
      var I2 = t2.getVisual("style"), P2 = I2 && I2.fill;
      P2 && i.setColor(P2);
      var N3 = Du(i);
      N3.seriesIndex = v4.seriesIndex, i.on("mousemove", function(z3) {
        N3.dataIndex = null;
        var H2 = i.hoverDataIdx;
        H2 >= 0 && (N3.dataIndex = H2 + (i.startIndex || 0));
      });
    }, f2.prototype.remove = function() {
      this._clear();
    }, f2.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, f2;
  }(), amr = imr, omr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this._updateSymbolDraw(_, t2);
      M2.updateData(_, { clipShape: this._getClipShape(t2) }), this._finished = true;
    }, i.prototype.incrementalPrepareRender = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this._updateSymbolDraw(_, t2);
      M2.incrementalPrepareUpdate(_), this._finished = false;
    }, i.prototype.incrementalRender = function(t2, h, v4) {
      this._symbolDraw.incrementalUpdate(t2, h.getData(), { clipShape: this._getClipShape(h) }), this._finished = t2.end === h.getData().count();
    }, i.prototype.updateTransform = function(t2, h, v4) {
      var _ = t2.getData();
      if (this.group.dirty(), !this._finished || _.count() > 1e4)
        return { update: true };
      var M2 = zgt("").reset(t2, h, v4);
      M2.progress && M2.progress({ start: 0, end: _.count(), count: _.count() }, _), this._symbolDraw.updateLayout(_);
    }, i.prototype.eachRendered = function(t2) {
      this._symbolDraw && this._symbolDraw.eachRendered(t2);
    }, i.prototype._getClipShape = function(t2) {
      var h = t2.coordinateSystem, v4 = h && h.getArea && h.getArea();
      return t2.get("clip", true) ? v4 : null;
    }, i.prototype._updateSymbolDraw = function(t2, h) {
      var v4 = this._symbolDraw, _ = h.pipelineContext, M2 = _.large;
      return (!v4 || M2 !== this._isLargeDraw) && (v4 && v4.remove(), v4 = this._symbolDraw = M2 ? new amr() : new Bgt(), this._isLargeDraw = M2, this.group.removeAll()), this.group.add(v4.group), v4;
    }, i.prototype.remove = function(t2, h) {
      this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
    }, i.prototype.dispose = function() {
    }, i.type = "scatter", i;
  }(Hg2), smr = omr, lmr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.type = "grid", i.dependencies = ["xAxis", "yAxis"], i.layoutMode = "box", i.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, i;
  }(zh2), umr = lmr, gte = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("grid", _m).models[0];
    }, i.type = "cartesian2dAxis", i;
  }(zh2);
  Sm(gte, Fgt);
  var DHe = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, cmr = cc2({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, DHe), Tne = cc2({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, DHe), fmr = cc2({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, Tne), hmr = Ul({ logBase: 10 }, Tne), EHe = { category: cmr, value: Tne, time: fmr, log: hmr }, pmr = { value: 1, category: 1, time: 1, log: 1 };
  function qtt(f2, i, t2, h) {
    Qe2(pmr, function(v4, _) {
      var M2 = cc2(cc2({}, EHe[_], true), h, true), I2 = function(P2) {
        ii2(N3, P2);
        function N3() {
          var z3 = P2 !== null && P2.apply(this, arguments) || this;
          return z3.type = i + "Axis." + _, z3;
        }
        return N3.prototype.mergeDefaultAndTheme = function(z3, H2) {
          var $ = rgt(this), et = $ ? aet(z3) : {}, at = H2.getTheme();
          cc2(z3, at.get(_ + "Axis")), cc2(z3, this.getDefaultOption()), z3.type = L8e(z3), $ && J7(z3, et, $);
        }, N3.prototype.optionUpdated = function() {
          var z3 = this.option;
          z3.type === "category" && (this.__ordinalMeta = lte.createByAxisModel(this));
        }, N3.prototype.getCategories = function(z3) {
          var H2 = this.option;
          if (H2.type === "category")
            return z3 ? H2.data : this.__ordinalMeta.categories;
        }, N3.prototype.getOrdinalMeta = function() {
          return this.__ordinalMeta;
        }, N3.type = i + "Axis." + _, N3.defaultOption = M2, N3;
      }(t2);
      f2.registerComponentModel(I2);
    }), f2.registerSubTypeDefaulter(i + "Axis", L8e);
  }
  function L8e(f2) {
    return f2.type || (f2.data ? "category" : "value");
  }
  var dmr = function() {
    function f2(i) {
      this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = i || "";
    }
    return f2.prototype.getAxis = function(i) {
      return this._axes[i];
    }, f2.prototype.getAxes = function() {
      return Xa2(this._dimList, function(i) {
        return this._axes[i];
      }, this);
    }, f2.prototype.getAxesByScale = function(i) {
      return i = i.toLowerCase(), Ld2(this.getAxes(), function(t2) {
        return t2.scale.type === i;
      });
    }, f2.prototype.addAxis = function(i) {
      var t2 = i.dim;
      this._axes[t2] = i, this._dimList.push(t2);
    }, f2;
  }(), gmr = dmr, vte = ["x", "y"];
  function O8e(f2) {
    return f2.type === "interval" || f2.type === "time";
  }
  var vmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "cartesian2d", t2.dimensions = vte, t2;
    }
    return i.prototype.calcAffineTransform = function() {
      this._transform = this._invTransform = null;
      var t2 = this.getAxis("x").scale, h = this.getAxis("y").scale;
      if (!(!O8e(t2) || !O8e(h))) {
        var v4 = t2.getExtent(), _ = h.getExtent(), M2 = this.dataToPoint([v4[0], _[0]]), I2 = this.dataToPoint([v4[1], _[1]]), P2 = v4[1] - v4[0], N3 = _[1] - _[0];
        if (!(!P2 || !N3)) {
          var z3 = (I2[0] - M2[0]) / P2, H2 = (I2[1] - M2[1]) / N3, $ = M2[0] - v4[0] * z3, et = M2[1] - _[0] * H2, at = this._transform = [z3, 0, 0, H2, $, et];
          this._invTransform = Xtt([], at);
        }
      }
    }, i.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
    }, i.prototype.containPoint = function(t2) {
      var h = this.getAxis("x"), v4 = this.getAxis("y");
      return h.contain(h.toLocalCoord(t2[0])) && v4.contain(v4.toLocalCoord(t2[1]));
    }, i.prototype.containData = function(t2) {
      return this.getAxis("x").containData(t2[0]) && this.getAxis("y").containData(t2[1]);
    }, i.prototype.dataToPoint = function(t2, h, v4) {
      v4 = v4 || [];
      var _ = t2[0], M2 = t2[1];
      if (this._transform && _ != null && isFinite(_) && M2 != null && isFinite(M2))
        return Wx(v4, t2, this._transform);
      var I2 = this.getAxis("x"), P2 = this.getAxis("y");
      return v4[0] = I2.toGlobalCoord(I2.dataToCoord(_, h)), v4[1] = P2.toGlobalCoord(P2.dataToCoord(M2, h)), v4;
    }, i.prototype.clampData = function(t2, h) {
      var v4 = this.getAxis("x").scale, _ = this.getAxis("y").scale, M2 = v4.getExtent(), I2 = _.getExtent(), P2 = v4.parse(t2[0]), N3 = _.parse(t2[1]);
      return h = h || [], h[0] = Math.min(Math.max(Math.min(M2[0], M2[1]), P2), Math.max(M2[0], M2[1])), h[1] = Math.min(Math.max(Math.min(I2[0], I2[1]), N3), Math.max(I2[0], I2[1])), h;
    }, i.prototype.pointToData = function(t2, h) {
      var v4 = [];
      if (this._invTransform)
        return Wx(v4, t2, this._invTransform);
      var _ = this.getAxis("x"), M2 = this.getAxis("y");
      return v4[0] = _.coordToData(_.toLocalCoord(t2[0]), h), v4[1] = M2.coordToData(M2.toLocalCoord(t2[1]), h), v4;
    }, i.prototype.getOtherAxis = function(t2) {
      return this.getAxis(t2.dim === "x" ? "y" : "x");
    }, i.prototype.getArea = function() {
      var t2 = this.getAxis("x").getGlobalExtent(), h = this.getAxis("y").getGlobalExtent(), v4 = Math.min(t2[0], t2[1]), _ = Math.min(h[0], h[1]), M2 = Math.max(t2[0], t2[1]) - v4, I2 = Math.max(h[0], h[1]) - _;
      return new Lc2(v4, _, M2, I2);
    }, i;
  }(gmr), ymr = vmr, mmr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _, M2) {
      var I2 = f2.call(this, t2, h, v4) || this;
      return I2.index = 0, I2.type = _ || "value", I2.position = M2 || "bottom", I2;
    }
    return i.prototype.isHorizontal = function() {
      var t2 = this.position;
      return t2 === "top" || t2 === "bottom";
    }, i.prototype.getGlobalExtent = function(t2) {
      var h = this.getExtent();
      return h[0] = this.toGlobalCoord(h[0]), h[1] = this.toGlobalCoord(h[1]), t2 && h[0] > h[1] && h.reverse(), h;
    }, i.prototype.pointToData = function(t2, h) {
      return this.coordToData(this.toLocalCoord(t2[this.dim === "x" ? 0 : 1]), h);
    }, i.prototype.setCategorySortInfo = function(t2) {
      if (this.type !== "category")
        return false;
      this.model.option.categorySortInfo = t2, this.scale.setSortInfo(t2);
    }, i;
  }(D5), bmr = mmr;
  function yte(f2, i, t2) {
    t2 = t2 || {};
    var h = f2.coordinateSystem, v4 = i.axis, _ = {}, M2 = v4.getAxesOnZeroOf()[0], I2 = v4.position, P2 = M2 ? "onZero" : I2, N3 = v4.dim, z3 = h.getRect(), H2 = [z3.x, z3.x + z3.width, z3.y, z3.y + z3.height], $ = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, et = i.get("offset") || 0, at = N3 === "x" ? [H2[2] - et, H2[3] + et] : [H2[0] - et, H2[1] + et];
    if (M2) {
      var ht = M2.toGlobalCoord(M2.dataToCoord(0));
      at[$.onZero] = Math.max(Math.min(ht, at[1]), at[0]);
    }
    _.position = [N3 === "y" ? at[$[P2]] : H2[0], N3 === "x" ? at[$[P2]] : H2[3]], _.rotation = Math.PI / 2 * (N3 === "x" ? 0 : 1);
    var bt = { top: -1, bottom: 1, left: -1, right: 1 };
    _.labelDirection = _.tickDirection = _.nameDirection = bt[I2], _.labelOffset = M2 ? at[$[I2]] - at[$.onZero] : 0, i.get(["axisTick", "inside"]) && (_.tickDirection = -_.tickDirection), y_(t2.labelInside, i.get(["axisLabel", "inside"])) && (_.labelDirection = -_.labelDirection);
    var _t = i.get(["axisLabel", "rotate"]);
    return _.labelRotate = P2 === "top" ? -_t : _t, _.z2 = 1, _;
  }
  function R8e(f2) {
    return f2.get("coordinateSystem") === "cartesian2d";
  }
  function N8e(f2) {
    var i = { xAxisModel: null, yAxisModel: null };
    return Qe2(i, function(t2, h) {
      var v4 = h.replace(/Model$/, ""), _ = f2.getReferringComponents(v4, _m).models[0];
      i[h] = _;
    }), i;
  }
  var XXt = Math.log;
  function kHe(f2, i, t2) {
    var h = eV.prototype, v4 = h.getTicks.call(t2), _ = h.getTicks.call(t2, true), M2 = v4.length - 1, I2 = h.getInterval.call(t2), P2 = VGe(f2, i), N3 = P2.extent, z3 = P2.fixMin, H2 = P2.fixMax;
    if (f2.type === "log") {
      var $ = XXt(f2.base);
      N3 = [XXt(N3[0]) / $, XXt(N3[1]) / $];
    }
    f2.setExtent(N3[0], N3[1]), f2.calcNiceExtent({ splitNumber: M2, fixMin: z3, fixMax: H2 });
    var et = h.getExtent.call(f2);
    z3 && (N3[0] = et[0]), H2 && (N3[1] = et[1]);
    var at = h.getInterval.call(f2), ht = N3[0], bt = N3[1];
    if (z3 && H2)
      at = (bt - ht) / M2;
    else if (z3)
      for (bt = N3[0] + at * M2; bt < N3[1] && isFinite(bt) && isFinite(N3[1]); )
        at = FXt(at), bt = N3[0] + at * M2;
    else if (H2)
      for (ht = N3[1] - at * M2; ht > N3[0] && isFinite(ht) && isFinite(N3[0]); )
        at = FXt(at), ht = N3[1] - at * M2;
    else {
      var _t = f2.getTicks().length - 1;
      _t > M2 && (at = FXt(at));
      var Et = at * M2;
      bt = Math.ceil(N3[1] / at) * at, ht = gy(bt - Et), ht < 0 && N3[0] >= 0 ? (ht = 0, bt = gy(Et)) : bt > 0 && N3[1] <= 0 && (bt = 0, ht = -gy(Et));
    }
    var zt = (v4[0].value - _[0].value) / I2, Ft = (v4[M2].value - _[M2].value) / I2;
    h.setExtent.call(f2, ht + at * zt, bt + at * Ft), h.setInterval.call(f2, at), (zt || Ft) && h.setNiceExtent.call(f2, ht + at, bt - at);
  }
  var _mr = function() {
    function f2(i, t2, h) {
      this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = vte, this._initCartesian(i, t2, h), this.model = i;
    }
    return f2.prototype.getRect = function() {
      return this._rect;
    }, f2.prototype.update = function(i, t2) {
      var h = this._axesMap;
      this._updateScale(i, this.model);
      function v4(M2) {
        var I2, P2 = Of2(M2), N3 = P2.length;
        if (!!N3) {
          for (var z3 = [], H2 = N3 - 1; H2 >= 0; H2--) {
            var $ = +P2[H2], et = M2[$], at = et.model, ht = et.scale;
            ute(ht) && at.get("alignTicks") && at.get("interval") == null ? z3.push(et) : (Htt(ht, at), ute(ht) && (I2 = et));
          }
          z3.length && (I2 || (I2 = z3.pop(), Htt(I2.scale, I2.model)), Qe2(z3, function(bt) {
            kHe(bt.scale, bt.model, I2.scale);
          }));
        }
      }
      v4(h.x), v4(h.y);
      var _ = {};
      Qe2(h.x, function(M2) {
        F8e(h, "y", M2, _);
      }), Qe2(h.y, function(M2) {
        F8e(h, "x", M2, _);
      }), this.resize(this.model, t2);
    }, f2.prototype.resize = function(i, t2, h) {
      var v4 = i.getBoxLayoutParams(), _ = !h && i.get("containLabel"), M2 = u1(v4, { width: t2.getWidth(), height: t2.getHeight() });
      this._rect = M2;
      var I2 = this._axesList;
      P2(), _ && (Qe2(I2, function(N3) {
        if (!N3.model.get(["axisLabel", "inside"])) {
          var z3 = Lvr(N3);
          if (z3) {
            var H2 = N3.isHorizontal() ? "height" : "width", $ = N3.model.get(["axisLabel", "margin"]);
            M2[H2] -= z3[H2] + $, N3.position === "top" ? M2.y += z3.height + $ : N3.position === "left" && (M2.x += z3.width + $);
          }
        }
      }), P2()), Qe2(this._coordsList, function(N3) {
        N3.calcAffineTransform();
      });
      function P2() {
        Qe2(I2, function(N3) {
          var z3 = N3.isHorizontal(), H2 = z3 ? [0, M2.width] : [0, M2.height], $ = N3.inverse ? 1 : 0;
          N3.setExtent(H2[$], H2[1 - $]), xmr(N3, z3 ? M2.x : M2.y);
        });
      }
    }, f2.prototype.getAxis = function(i, t2) {
      var h = this._axesMap[i];
      if (h != null)
        return h[t2 || 0];
    }, f2.prototype.getAxes = function() {
      return this._axesList.slice();
    }, f2.prototype.getCartesian = function(i, t2) {
      if (i != null && t2 != null) {
        var h = "x" + i + "y" + t2;
        return this._coordsMap[h];
      }
      Xl(i) && (t2 = i.yAxisIndex, i = i.xAxisIndex);
      for (var v4 = 0, _ = this._coordsList; v4 < _.length; v4++)
        if (_[v4].getAxis("x").index === i || _[v4].getAxis("y").index === t2)
          return _[v4];
    }, f2.prototype.getCartesians = function() {
      return this._coordsList.slice();
    }, f2.prototype.convertToPixel = function(i, t2, h) {
      var v4 = this._findConvertTarget(t2);
      return v4.cartesian ? v4.cartesian.dataToPoint(h) : v4.axis ? v4.axis.toGlobalCoord(v4.axis.dataToCoord(h)) : null;
    }, f2.prototype.convertFromPixel = function(i, t2, h) {
      var v4 = this._findConvertTarget(t2);
      return v4.cartesian ? v4.cartesian.pointToData(h) : v4.axis ? v4.axis.coordToData(v4.axis.toLocalCoord(h)) : null;
    }, f2.prototype._findConvertTarget = function(i) {
      var t2 = i.seriesModel, h = i.xAxisModel || t2 && t2.getReferringComponents("xAxis", _m).models[0], v4 = i.yAxisModel || t2 && t2.getReferringComponents("yAxis", _m).models[0], _ = i.gridModel, M2 = this._coordsList, I2, P2;
      if (t2)
        I2 = t2.coordinateSystem, Pc2(M2, I2) < 0 && (I2 = null);
      else if (h && v4)
        I2 = this.getCartesian(h.componentIndex, v4.componentIndex);
      else if (h)
        P2 = this.getAxis("x", h.componentIndex);
      else if (v4)
        P2 = this.getAxis("y", v4.componentIndex);
      else if (_) {
        var N3 = _.coordinateSystem;
        N3 === this && (I2 = this._coordsList[0]);
      }
      return { cartesian: I2, axis: P2 };
    }, f2.prototype.containPoint = function(i) {
      var t2 = this._coordsList[0];
      if (t2)
        return t2.containPoint(i);
    }, f2.prototype._initCartesian = function(i, t2, h) {
      var v4 = this, _ = this, M2 = { left: false, right: false, top: false, bottom: false }, I2 = { x: {}, y: {} }, P2 = { x: 0, y: 0 };
      if (t2.eachComponent("xAxis", N3("x"), this), t2.eachComponent("yAxis", N3("y"), this), !P2.x || !P2.y) {
        this._axesMap = {}, this._axesList = [];
        return;
      }
      this._axesMap = I2, Qe2(I2.x, function(z3, H2) {
        Qe2(I2.y, function($, et) {
          var at = "x" + H2 + "y" + et, ht = new ymr(at);
          ht.master = v4, ht.model = i, v4._coordsMap[at] = ht, v4._coordsList.push(ht), ht.addAxis(z3), ht.addAxis($);
        });
      });
      function N3(z3) {
        return function(H2, $) {
          if (!!QXt(H2, i)) {
            var et = H2.get("position");
            z3 === "x" ? et !== "top" && et !== "bottom" && (et = M2.bottom ? "top" : "bottom") : et !== "left" && et !== "right" && (et = M2.left ? "right" : "left"), M2[et] = true;
            var at = new bmr(z3, Rkt(H2), [0, 0], H2.get("type"), et), ht = at.type === "category";
            at.onBand = ht && H2.get("boundaryGap"), at.inverse = H2.get("inverse"), H2.axis = at, at.model = H2, at.grid = _, at.index = $, _._axesList.push(at), I2[z3][$] = at, P2[z3]++;
          }
        };
      }
    }, f2.prototype._updateScale = function(i, t2) {
      Qe2(this._axesList, function(v4) {
        if (v4.scale.setExtent(1 / 0, -1 / 0), v4.type === "category") {
          var _ = v4.model.get("categorySortInfo");
          v4.scale.setSortInfo(_);
        }
      }), i.eachSeries(function(v4) {
        if (R8e(v4)) {
          var _ = N8e(v4), M2 = _.xAxisModel, I2 = _.yAxisModel;
          if (!QXt(M2, t2) || !QXt(I2, t2))
            return;
          var P2 = this.getCartesian(M2.componentIndex, I2.componentIndex), N3 = v4.getData(), z3 = P2.getAxis("x"), H2 = P2.getAxis("y");
          h(N3, z3), h(N3, H2);
        }
      }, this);
      function h(v4, _) {
        Qe2(kEt(v4, _.dim), function(M2) {
          _.scale.unionExtentFromData(v4, M2);
        });
      }
    }, f2.prototype.getTooltipAxes = function(i) {
      var t2 = [], h = [];
      return Qe2(this.getCartesians(), function(v4) {
        var _ = i != null && i !== "auto" ? v4.getAxis(i) : v4.getBaseAxis(), M2 = v4.getOtherAxis(_);
        Pc2(t2, _) < 0 && t2.push(_), Pc2(h, M2) < 0 && h.push(M2);
      }), { baseAxes: t2, otherAxes: h };
    }, f2.create = function(i, t2) {
      var h = [];
      return i.eachComponent("grid", function(v4, _) {
        var M2 = new f2(v4, i, t2);
        M2.name = "grid_" + _, M2.resize(v4, t2, true), v4.coordinateSystem = M2, h.push(M2);
      }), i.eachSeries(function(v4) {
        if (!!R8e(v4)) {
          var _ = N8e(v4), M2 = _.xAxisModel, I2 = _.yAxisModel, P2 = M2.getCoordSysModel(), N3 = P2.coordinateSystem;
          v4.coordinateSystem = N3.getCartesian(M2.componentIndex, I2.componentIndex);
        }
      }), h;
    }, f2.dimensions = vte, f2;
  }();
  function QXt(f2, i) {
    return f2.getCoordSysModel() === i;
  }
  function F8e(f2, i, t2, h) {
    t2.getAxesOnZeroOf = function() {
      return _ ? [_] : [];
    };
    var v4 = f2[i], _, M2 = t2.model, I2 = M2.get(["axisLine", "onZero"]), P2 = M2.get(["axisLine", "onZeroAxisIndex"]);
    if (!I2)
      return;
    if (P2 != null)
      V8e(v4[P2]) && (_ = v4[P2]);
    else
      for (var N3 in v4)
        if (v4.hasOwnProperty(N3) && V8e(v4[N3]) && !h[z3(v4[N3])]) {
          _ = v4[N3];
          break;
        }
    _ && (h[z3(_)] = true);
    function z3(H2) {
      return H2.dim + "_" + H2.index;
    }
  }
  function V8e(f2) {
    return f2 && f2.type !== "category" && f2.type !== "time" && Pvr(f2);
  }
  function xmr(f2, i) {
    var t2 = f2.getExtent(), h = t2[0] + t2[1];
    f2.toGlobalCoord = f2.dim === "x" ? function(v4) {
      return v4 + i;
    } : function(v4) {
      return h - v4 + i;
    }, f2.toLocalCoord = f2.dim === "x" ? function(v4) {
      return v4 - i;
    } : function(v4) {
      return h - v4 + i;
    };
  }
  var wmr = _mr, W7 = Math.PI, pU = function() {
    function f2(i, t2) {
      this.group = new mu(), this.opt = t2, this.axisModel = i, Ul(t2, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
        return true;
      } });
      var h = new mu({ x: t2.position[0], y: t2.position[1], rotation: t2.rotation });
      h.updateTransform(), this._transformGroup = h;
    }
    return f2.prototype.hasBuilder = function(i) {
      return !!B8e[i];
    }, f2.prototype.add = function(i) {
      B8e[i](this.opt, this.axisModel, this.group, this._transformGroup);
    }, f2.prototype.getGroup = function() {
      return this.group;
    }, f2.innerTextLayout = function(i, t2, h) {
      var v4 = kze(t2 - i), _, M2;
      return dEt(v4) ? (M2 = h > 0 ? "top" : "bottom", _ = "center") : dEt(v4 - W7) ? (M2 = h > 0 ? "bottom" : "top", _ = "center") : (M2 = "middle", v4 > 0 && v4 < W7 ? _ = h > 0 ? "right" : "left" : _ = h > 0 ? "left" : "right"), { rotation: v4, textAlign: _, textVerticalAlign: M2 };
    }, f2.makeAxisEventDataBase = function(i) {
      var t2 = { componentType: i.mainType, componentIndex: i.componentIndex };
      return t2[i.mainType + "Index"] = i.componentIndex, t2;
    }, f2.isLabelSilent = function(i) {
      var t2 = i.get("tooltip");
      return i.get("silent") || !(i.get("triggerEvent") || t2 && t2.show);
    }, f2;
  }(), B8e = { axisLine: function(f2, i, t2, h) {
    var v4 = i.get(["axisLine", "show"]);
    if (v4 === "auto" && f2.handleAutoShown && (v4 = f2.handleAutoShown("axisLine")), !!v4) {
      var _ = i.axis.getExtent(), M2 = h.transform, I2 = [_[0], 0], P2 = [_[1], 0];
      M2 && (Wx(I2, I2, M2), Wx(P2, P2, M2));
      var N3 = ba2({ lineCap: "round" }, i.getModel(["axisLine", "lineStyle"]).getLineStyle()), z3 = new m_({ subPixelOptimize: true, shape: { x1: I2[0], y1: I2[1], x2: P2[0], y2: P2[1] }, style: N3, strokeContainThreshold: f2.strokeContainThreshold || 5, silent: true, z2: 1 });
      z3.anid = "line", t2.add(z3);
      var H2 = i.get(["axisLine", "symbol"]);
      if (H2 != null) {
        var $ = i.get(["axisLine", "symbolSize"]);
        ms(H2) && (H2 = [H2, H2]), (ms($) || vp($)) && ($ = [$, $]);
        var et = fet(i.get(["axisLine", "symbolOffset"]) || 0, $), at = $[0], ht = $[1];
        Qe2([{ rotate: f2.rotation + Math.PI / 2, offset: et[0], r: 0 }, { rotate: f2.rotation - Math.PI / 2, offset: et[1], r: Math.sqrt((I2[0] - P2[0]) * (I2[0] - P2[0]) + (I2[1] - P2[1]) * (I2[1] - P2[1])) }], function(bt, _t) {
          if (H2[_t] !== "none" && H2[_t] != null) {
            var Et = wm(H2[_t], -at / 2, -ht / 2, at, ht, N3.stroke, true), zt = bt.r + bt.offset;
            Et.attr({ rotation: bt.rotate, x: I2[0] + zt * Math.cos(f2.rotation), y: I2[1] - zt * Math.sin(f2.rotation), silent: true, z2: 11 }), t2.add(Et);
          }
        });
      }
    }
  }, axisTickLabel: function(f2, i, t2, h) {
    var v4 = Cmr(t2, h, i, f2), _ = Amr(t2, h, i, f2);
    if (Mmr(i, _, v4), Tmr(t2, h, i, f2.tickDirection), i.get(["axisLabel", "hideOverlap"])) {
      var M2 = XGe(Xa2(_, function(I2) {
        return { label: I2, priority: I2.z2, defaultAttr: { ignore: I2.ignore } };
      }));
      tHe(M2);
    }
  }, axisName: function(f2, i, t2, h) {
    var v4 = y_(f2.axisName, i.get("name"));
    if (!!v4) {
      var _ = i.get("nameLocation"), M2 = f2.nameDirection, I2 = i.getModel("nameTextStyle"), P2 = i.get("nameGap") || 0, N3 = i.axis.getExtent(), z3 = N3[0] > N3[1] ? -1 : 1, H2 = [_ === "start" ? N3[0] - z3 * P2 : _ === "end" ? N3[1] + z3 * P2 : (N3[0] + N3[1]) / 2, j8e(_) ? f2.labelOffset + M2 * P2 : 0], $, et = i.get("nameRotate");
      et != null && (et = et * W7 / 180);
      var at;
      j8e(_) ? $ = pU.innerTextLayout(f2.rotation, et != null ? et : f2.rotation, M2) : ($ = Smr(f2.rotation, _, et || 0, N3), at = f2.axisNameAvailableWidth, at != null && (at = Math.abs(at / Math.sin($.rotation)), !isFinite(at) && (at = null)));
      var ht = I2.getFont(), bt = i.get("nameTruncate", true) || {}, _t = bt.ellipsis, Et = y_(f2.nameTruncateMaxWidth, bt.maxWidth, at), zt = new op({ x: H2[0], y: H2[1], rotation: $.rotation, silent: pU.isLabelSilent(i), style: By(I2, { text: v4, font: ht, overflow: "truncate", width: Et, ellipsis: _t, fill: I2.getTextColor() || i.get(["axisLine", "lineStyle", "color"]), align: I2.get("align") || $.textAlign, verticalAlign: I2.get("verticalAlign") || $.textVerticalAlign }), z2: 1 });
      if (eet({ el: zt, componentModel: i, itemName: v4 }), zt.__fullText = v4, zt.anid = "name", i.get("triggerEvent")) {
        var Ft = pU.makeAxisEventDataBase(i);
        Ft.targetType = "axisName", Ft.name = v4, Du(zt).eventData = Ft;
      }
      h.add(zt), zt.updateTransform(), t2.add(zt), zt.decomposeTransform();
    }
  } };
  function Smr(f2, i, t2, h) {
    var v4 = kze(t2 - f2), _, M2, I2 = h[0] > h[1], P2 = i === "start" && !I2 || i !== "start" && I2;
    return dEt(v4 - W7 / 2) ? (M2 = P2 ? "bottom" : "top", _ = "center") : dEt(v4 - W7 * 1.5) ? (M2 = P2 ? "top" : "bottom", _ = "center") : (M2 = "middle", v4 < W7 * 1.5 && v4 > W7 / 2 ? _ = P2 ? "left" : "right" : _ = P2 ? "right" : "left"), { rotation: v4, textAlign: _, textVerticalAlign: M2 };
  }
  function Mmr(f2, i, t2) {
    if (!BGe(f2.axis)) {
      var h = f2.get(["axisLabel", "showMinLabel"]), v4 = f2.get(["axisLabel", "showMaxLabel"]);
      i = i || [], t2 = t2 || [];
      var _ = i[0], M2 = i[1], I2 = i[i.length - 1], P2 = i[i.length - 2], N3 = t2[0], z3 = t2[1], H2 = t2[t2.length - 1], $ = t2[t2.length - 2];
      h === false ? (VD(_), VD(N3)) : z8e(_, M2) && (h ? (VD(M2), VD(z3)) : (VD(_), VD(N3))), v4 === false ? (VD(I2), VD(H2)) : z8e(P2, I2) && (v4 ? (VD(P2), VD($)) : (VD(I2), VD(H2)));
    }
  }
  function VD(f2) {
    f2 && (f2.ignore = true);
  }
  function z8e(f2, i) {
    var t2 = f2 && f2.getBoundingRect().clone(), h = i && i.getBoundingRect().clone();
    if (!(!t2 || !h)) {
      var v4 = ukt([]);
      return SU(v4, v4, -f2.rotation), t2.applyTransform($6([], v4, f2.getLocalTransform())), h.applyTransform($6([], v4, i.getLocalTransform())), t2.intersect(h);
    }
  }
  function j8e(f2) {
    return f2 === "middle" || f2 === "center";
  }
  function PHe(f2, i, t2, h, v4) {
    for (var _ = [], M2 = [], I2 = [], P2 = 0; P2 < f2.length; P2++) {
      var N3 = f2[P2].coord;
      M2[0] = N3, M2[1] = 0, I2[0] = N3, I2[1] = t2, i && (Wx(M2, M2, i), Wx(I2, I2, i));
      var z3 = new m_({ subPixelOptimize: true, shape: { x1: M2[0], y1: M2[1], x2: I2[0], y2: I2[1] }, style: h, z2: 2, autoBatch: true, silent: true });
      z3.anid = v4 + "_" + f2[P2].tickValue, _.push(z3);
    }
    return _;
  }
  function Cmr(f2, i, t2, h) {
    var v4 = t2.axis, _ = t2.getModel("axisTick"), M2 = _.get("show");
    if (M2 === "auto" && h.handleAutoShown && (M2 = h.handleAutoShown("axisTick")), !(!M2 || v4.scale.isBlank())) {
      for (var I2 = _.getModel("lineStyle"), P2 = h.tickDirection * _.get("length"), N3 = v4.getTicksCoords(), z3 = PHe(N3, i.transform, P2, Ul(I2.getLineStyle(), { stroke: t2.get(["axisLine", "lineStyle", "color"]) }), "ticks"), H2 = 0; H2 < z3.length; H2++)
        f2.add(z3[H2]);
      return z3;
    }
  }
  function Tmr(f2, i, t2, h) {
    var v4 = t2.axis, _ = t2.getModel("minorTick");
    if (!(!_.get("show") || v4.scale.isBlank())) {
      var M2 = v4.getMinorTicksCoords();
      if (!!M2.length)
        for (var I2 = _.getModel("lineStyle"), P2 = h * _.get("length"), N3 = Ul(I2.getLineStyle(), Ul(t2.getModel("axisTick").getLineStyle(), { stroke: t2.get(["axisLine", "lineStyle", "color"]) })), z3 = 0; z3 < M2.length; z3++)
          for (var H2 = PHe(M2[z3], i.transform, P2, N3, "minorticks_" + z3), $ = 0; $ < H2.length; $++)
            f2.add(H2[$]);
    }
  }
  function Amr(f2, i, t2, h) {
    var v4 = t2.axis, _ = y_(h.axisLabelShow, t2.get(["axisLabel", "show"]));
    if (!(!_ || v4.scale.isBlank())) {
      var M2 = t2.getModel("axisLabel"), I2 = M2.get("margin"), P2 = v4.getViewLabels(), N3 = (y_(h.labelRotate, M2.get("rotate")) || 0) * W7 / 180, z3 = pU.innerTextLayout(h.rotation, N3, h.labelDirection), H2 = t2.getCategories && t2.getCategories(true), $ = [], et = pU.isLabelSilent(t2), at = t2.get("triggerEvent");
      return Qe2(P2, function(ht, bt) {
        var _t = v4.scale.type === "ordinal" ? v4.scale.getRawOrdinalNumber(ht.tickValue) : ht.tickValue, Et = ht.formattedLabel, zt = ht.rawLabel, Ft = M2;
        if (H2 && H2[_t]) {
          var fe2 = H2[_t];
          Xl(fe2) && fe2.textStyle && (Ft = new Gg2(fe2.textStyle, M2, t2.ecModel));
        }
        var re2 = Ft.getTextColor() || t2.get(["axisLine", "lineStyle", "color"]), ye = v4.dataToCoord(_t), me2 = new op({ x: ye, y: h.labelOffset + h.labelDirection * I2, rotation: z3.rotation, silent: et, z2: 10 + (ht.level || 0), style: By(Ft, { text: Et, align: Ft.getShallow("align", true) || z3.textAlign, verticalAlign: Ft.getShallow("verticalAlign", true) || Ft.getShallow("baseline", true) || z3.textVerticalAlign, fill: Ol(re2) ? re2(v4.type === "category" ? zt : v4.type === "value" ? _t + "" : _t, bt) : re2 }) });
        if (me2.anid = "label_" + _t, at) {
          var be2 = pU.makeAxisEventDataBase(t2);
          be2.targetType = "axisLabel", be2.value = zt, be2.tickIndex = bt, v4.type === "category" && (be2.dataIndex = _t), Du(me2).eventData = be2;
        }
        i.add(me2), me2.updateTransform(), $.push(me2), f2.add(me2), me2.decomposeTransform();
      }), $;
    }
  }
  var nN = pU;
  function Imr(f2, i) {
    var t2 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
    return Dmr(t2, f2, i), t2.seriesInvolved && kmr(t2, f2), t2;
  }
  function Dmr(f2, i, t2) {
    var h = i.getComponent("tooltip"), v4 = i.getComponent("axisPointer"), _ = v4.get("link", true) || [], M2 = [];
    Qe2(t2.getCoordinateSystems(), function(I2) {
      if (!I2.axisPointerEnabled)
        return;
      var P2 = hgt(I2.model), N3 = f2.coordSysAxesInfo[P2] = {};
      f2.coordSysMap[P2] = I2;
      var z3 = I2.model, H2 = z3.getModel("tooltip", h);
      if (Qe2(I2.getAxes(), Ou(ht, false, null)), I2.getTooltipAxes && h && H2.get("show")) {
        var $ = H2.get("trigger") === "axis", et = H2.get(["axisPointer", "type"]) === "cross", at = I2.getTooltipAxes(H2.get(["axisPointer", "axis"]));
        ($ || et) && Qe2(at.baseAxes, Ou(ht, et ? "cross" : true, $)), et && Qe2(at.otherAxes, Ou(ht, "cross", false));
      }
      function ht(bt, _t, Et) {
        var zt = Et.model.getModel("axisPointer", v4), Ft = zt.get("show");
        if (!(!Ft || Ft === "auto" && !bt && !mte(zt))) {
          _t == null && (_t = zt.get("triggerTooltip")), zt = bt ? Emr(Et, H2, v4, i, bt, _t) : zt;
          var fe2 = zt.get("snap"), re2 = hgt(Et.model), ye = _t || fe2 || Et.type === "category", me2 = f2.axesInfo[re2] = { key: re2, axis: Et, coordSys: I2, axisPointerModel: zt, triggerTooltip: _t, involveSeries: ye, snap: fe2, useHandle: mte(zt), seriesModels: [], linkGroup: null };
          N3[re2] = me2, f2.seriesInvolved = f2.seriesInvolved || ye;
          var be2 = Pmr(_, Et);
          if (be2 != null) {
            var Te2 = M2[be2] || (M2[be2] = { axesInfo: {} });
            Te2.axesInfo[re2] = me2, Te2.mapper = _[be2].mapper, me2.linkGroup = Te2;
          }
        }
      }
    });
  }
  function Emr(f2, i, t2, h, v4, _) {
    var M2 = i.getModel("axisPointer"), I2 = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], P2 = {};
    Qe2(I2, function($) {
      P2[$] = pu(M2.get($));
    }), P2.snap = f2.type !== "category" && !!_, M2.get("type") === "cross" && (P2.type = "line");
    var N3 = P2.label || (P2.label = {});
    if (N3.show == null && (N3.show = false), v4 === "cross") {
      var z3 = M2.get(["label", "show"]);
      if (N3.show = z3 != null ? z3 : true, !_) {
        var H2 = P2.lineStyle = M2.get("crossStyle");
        H2 && Ul(N3, H2.textStyle);
      }
    }
    return f2.model.getModel("axisPointer", new Gg2(P2, t2, h));
  }
  function kmr(f2, i) {
    i.eachSeries(function(t2) {
      var h = t2.coordinateSystem, v4 = t2.get(["tooltip", "trigger"], true), _ = t2.get(["tooltip", "show"], true);
      !h || v4 === "none" || v4 === false || v4 === "item" || _ === false || t2.get(["axisPointer", "show"], true) === false || Qe2(f2.coordSysAxesInfo[hgt(h.model)], function(M2) {
        var I2 = M2.axis;
        h.getAxis(I2.dim) === I2 && (M2.seriesModels.push(t2), M2.seriesDataCount == null && (M2.seriesDataCount = 0), M2.seriesDataCount += t2.getData().count());
      });
    });
  }
  function Pmr(f2, i) {
    for (var t2 = i.model, h = i.dim, v4 = 0; v4 < f2.length; v4++) {
      var _ = f2[v4] || {};
      if (JXt(_[h + "AxisId"], t2.id) || JXt(_[h + "AxisIndex"], t2.componentIndex) || JXt(_[h + "AxisName"], t2.name))
        return v4;
    }
  }
  function JXt(f2, i) {
    return f2 === "all" || Za2(f2) && Pc2(f2, i) >= 0 || f2 === i;
  }
  function Lmr(f2) {
    var i = Ane(f2);
    if (!!i) {
      var t2 = i.axisPointerModel, h = i.axis.scale, v4 = t2.option, _ = t2.get("status"), M2 = t2.get("value");
      M2 != null && (M2 = h.parse(M2));
      var I2 = mte(t2);
      _ == null && (v4.status = I2 ? "show" : "hide");
      var P2 = h.getExtent().slice();
      P2[0] > P2[1] && P2.reverse(), (M2 == null || M2 > P2[1]) && (M2 = P2[1]), M2 < P2[0] && (M2 = P2[0]), v4.value = M2, I2 && (v4.status = i.axis.scale.isBlank() ? "hide" : "show");
    }
  }
  function Ane(f2) {
    var i = (f2.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
    return i && i.axesInfo[hgt(f2)];
  }
  function Omr(f2) {
    var i = Ane(f2);
    return i && i.axisPointerModel;
  }
  function mte(f2) {
    return !!f2.get(["handle", "show"]);
  }
  function hgt(f2) {
    return f2.type + "||" + f2.id;
  }
  var W8e = {}, Rmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      this.axisPointerClass && Lmr(t2), f2.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(t2, v4, true);
    }, i.prototype.updateAxisPointer = function(t2, h, v4, _) {
      this._doUpdateAxisPointerClass(t2, v4, false);
    }, i.prototype.remove = function(t2, h) {
      var v4 = this._axisPointer;
      v4 && v4.remove(h);
    }, i.prototype.dispose = function(t2, h) {
      this._disposeAxisPointer(h), f2.prototype.dispose.apply(this, arguments);
    }, i.prototype._doUpdateAxisPointerClass = function(t2, h, v4) {
      var _ = i.getAxisPointerClass(this.axisPointerClass);
      if (!!_) {
        var M2 = Omr(t2);
        M2 ? (this._axisPointer || (this._axisPointer = new _())).render(t2, M2, h, v4) : this._disposeAxisPointer(h);
      }
    }, i.prototype._disposeAxisPointer = function(t2) {
      this._axisPointer && this._axisPointer.dispose(t2), this._axisPointer = null;
    }, i.registerAxisPointerClass = function(t2, h) {
      W8e[t2] = h;
    }, i.getAxisPointerClass = function(t2) {
      return t2 && W8e[t2];
    }, i.type = "axis", i;
  }(W0), TU = Rmr, bte = Wh2();
  function LHe(f2, i, t2, h) {
    var v4 = t2.axis;
    if (!v4.scale.isBlank()) {
      var _ = t2.getModel("splitArea"), M2 = _.getModel("areaStyle"), I2 = M2.get("color"), P2 = h.coordinateSystem.getRect(), N3 = v4.getTicksCoords({ tickModel: _, clamp: true });
      if (!!N3.length) {
        var z3 = I2.length, H2 = bte(f2).splitAreaColors, $ = Il(), et = 0;
        if (H2)
          for (var at = 0; at < N3.length; at++) {
            var ht = H2.get(N3[at].tickValue);
            if (ht != null) {
              et = (ht + (z3 - 1) * at) % z3;
              break;
            }
          }
        var bt = v4.toGlobalCoord(N3[0].coord), _t = M2.getAreaStyle();
        I2 = Za2(I2) ? I2 : [I2];
        for (var at = 1; at < N3.length; at++) {
          var Et = v4.toGlobalCoord(N3[at].coord), zt = void 0, Ft = void 0, fe2 = void 0, re2 = void 0;
          v4.isHorizontal() ? (zt = bt, Ft = P2.y, fe2 = Et - zt, re2 = P2.height, bt = zt + fe2) : (zt = P2.x, Ft = bt, fe2 = P2.width, re2 = Et - Ft, bt = Ft + re2);
          var ye = N3[at - 1].tickValue;
          ye != null && $.set(ye, et), i.add(new Sh2({ anid: ye != null ? "area_" + ye : null, shape: { x: zt, y: Ft, width: fe2, height: re2 }, style: Ul({ fill: I2[et] }, _t), autoBatch: true, silent: true })), et = (et + 1) % z3;
        }
        bte(f2).splitAreaColors = $;
      }
    }
  }
  function OHe(f2) {
    bte(f2).splitAreaColors = null;
  }
  var Nmr = ["axisLine", "axisTickLabel", "axisName"], Fmr = ["splitArea", "splitLine", "minorSplitLine"], RHe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.axisPointerClass = "CartesianAxisPointer", t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      this.group.removeAll();
      var M2 = this._axisGroup;
      if (this._axisGroup = new mu(), this.group.add(this._axisGroup), !!t2.get("show")) {
        var I2 = t2.getCoordSysModel(), P2 = yte(I2, t2), N3 = new nN(t2, ba2({ handleAutoShown: function(H2) {
          for (var $ = I2.coordinateSystem.getCartesians(), et = 0; et < $.length; et++)
            if (ute($[et].getOtherAxis(t2.axis).scale))
              return true;
          return false;
        } }, P2));
        Qe2(Nmr, N3.add, N3), this._axisGroup.add(N3.getGroup()), Qe2(Fmr, function(H2) {
          t2.get([H2, "show"]) && Vmr[H2](this, this._axisGroup, t2, I2);
        }, this);
        var z3 = _ && _.type === "changeAxisOrder" && _.isInitSort;
        z3 || Dgt(M2, this._axisGroup, t2), f2.prototype.render.call(this, t2, h, v4, _);
      }
    }, i.prototype.remove = function() {
      OHe(this);
    }, i.type = "cartesianAxis", i;
  }(TU), Vmr = { splitLine: function(f2, i, t2, h) {
    var v4 = t2.axis;
    if (!v4.scale.isBlank()) {
      var _ = t2.getModel("splitLine"), M2 = _.getModel("lineStyle"), I2 = M2.get("color");
      I2 = Za2(I2) ? I2 : [I2];
      for (var P2 = h.coordinateSystem.getRect(), N3 = v4.isHorizontal(), z3 = 0, H2 = v4.getTicksCoords({ tickModel: _ }), $ = [], et = [], at = M2.getLineStyle(), ht = 0; ht < H2.length; ht++) {
        var bt = v4.toGlobalCoord(H2[ht].coord);
        N3 ? ($[0] = bt, $[1] = P2.y, et[0] = bt, et[1] = P2.y + P2.height) : ($[0] = P2.x, $[1] = bt, et[0] = P2.x + P2.width, et[1] = bt);
        var _t = z3++ % I2.length, Et = H2[ht].tickValue;
        i.add(new m_({ anid: Et != null ? "line_" + H2[ht].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: $[0], y1: $[1], x2: et[0], y2: et[1] }, style: Ul({ stroke: I2[_t] }, at), silent: true }));
      }
    }
  }, minorSplitLine: function(f2, i, t2, h) {
    var v4 = t2.axis, _ = t2.getModel("minorSplitLine"), M2 = _.getModel("lineStyle"), I2 = h.coordinateSystem.getRect(), P2 = v4.isHorizontal(), N3 = v4.getMinorTicksCoords();
    if (!!N3.length)
      for (var z3 = [], H2 = [], $ = M2.getLineStyle(), et = 0; et < N3.length; et++)
        for (var at = 0; at < N3[et].length; at++) {
          var ht = v4.toGlobalCoord(N3[et][at].coord);
          P2 ? (z3[0] = ht, z3[1] = I2.y, H2[0] = ht, H2[1] = I2.y + I2.height) : (z3[0] = I2.x, z3[1] = ht, H2[0] = I2.x + I2.width, H2[1] = ht), i.add(new m_({ anid: "minor_line_" + N3[et][at].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: z3[0], y1: z3[1], x2: H2[0], y2: H2[1] }, style: $, silent: true }));
        }
  }, splitArea: function(f2, i, t2, h) {
    LHe(f2, i, t2, h);
  } }, NHe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "xAxis", i;
  }(RHe), Bmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = NHe.type, t2;
    }
    return i.type = "yAxis", i;
  }(RHe), zmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "grid", t2;
    }
    return i.prototype.render = function(t2, h) {
      this.group.removeAll(), t2.get("show") && this.group.add(new Sh2({ shape: t2.coordinateSystem.getRect(), style: Ul({ fill: t2.get("backgroundColor") }, t2.getItemStyle()), silent: true, z2: -1 }));
    }, i.type = "grid", i;
  }(W0), G8e = { offset: 0 };
  function FHe(f2) {
    f2.registerComponentView(zmr), f2.registerComponentModel(umr), f2.registerCoordinateSystem("cartesian2d", wmr), qtt(f2, "x", gte, G8e), qtt(f2, "y", gte, G8e), f2.registerComponentView(NHe), f2.registerComponentView(Bmr), f2.registerPreprocessor(function(i) {
      i.xAxis && i.yAxis && !i.grid && (i.grid = {});
    });
  }
  function jmr(f2) {
    zc2(FHe), f2.registerSeriesModel(emr), f2.registerChartView(smr), f2.registerLayout(zgt("scatter"));
  }
  function Wmr(f2) {
    f2.eachSeriesByType("radar", function(i) {
      var t2 = i.getData(), h = [], v4 = i.coordinateSystem;
      if (!!v4) {
        var _ = v4.getIndicatorAxes();
        Qe2(_, function(M2, I2) {
          t2.each(t2.mapDimension(_[I2].dim), function(P2, N3) {
            h[N3] = h[N3] || [];
            var z3 = v4.dataToPoint(P2, I2);
            h[N3][I2] = H8e(z3) ? z3 : U8e(v4);
          });
        }), t2.each(function(M2) {
          var I2 = Clr(h[M2], function(P2) {
            return H8e(P2);
          }) || U8e(v4);
          h[M2].push(I2.slice()), t2.setItemLayout(M2, h[M2]);
        });
      }
    });
  }
  function H8e(f2) {
    return !isNaN(f2[0]) && !isNaN(f2[1]);
  }
  function U8e(f2) {
    return [f2.cx, f2.cy];
  }
  function Gmr(f2) {
    var i = f2.polar;
    if (i) {
      Za2(i) || (i = [i]);
      var t2 = [];
      Qe2(i, function(h, v4) {
        h.indicator ? (h.type && !h.shape && (h.shape = h.type), f2.radar = f2.radar || [], Za2(f2.radar) || (f2.radar = [f2.radar]), f2.radar.push(h)) : t2.push(h);
      }), f2.polar = t2;
    }
    Qe2(f2.series, function(h) {
      h && h.type === "radar" && h.polarIndex && (h.radarIndex = h.polarIndex);
    });
  }
  var Hmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = t2.coordinateSystem, M2 = this.group, I2 = t2.getData(), P2 = this._data;
      function N3($, et) {
        var at = $.getItemVisual(et, "symbol") || "circle";
        if (at !== "none") {
          var ht = Ogt($.getItemVisual(et, "symbolSize")), bt = wm(at, -1, -1, 2, 2), _t = $.getItemVisual(et, "symbolRotate") || 0;
          return bt.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: ht[0] / 2, scaleY: ht[1] / 2, rotation: _t * Math.PI / 180 || 0 }), bt;
        }
      }
      function z3($, et, at, ht, bt, _t) {
        at.removeAll();
        for (var Et = 0; Et < et.length - 1; Et++) {
          var zt = N3(ht, bt);
          zt && (zt.__dimIdx = Et, $[Et] ? (zt.setPosition($[Et]), kgt[_t ? "initProps" : "updateProps"](zt, { x: et[Et][0], y: et[Et][1] }, t2, bt)) : zt.setPosition(et[Et]), at.add(zt));
        }
      }
      function H2($) {
        return Xa2($, function(et) {
          return [_.cx, _.cy];
        });
      }
      I2.diff(P2).add(function($) {
        var et = I2.getItemLayout($);
        if (!!et) {
          var at = new iC(), ht = new aC(), bt = { shape: { points: et } };
          at.shape.points = H2(et), ht.shape.points = H2(et), Qv(at, bt, t2, $), Qv(ht, bt, t2, $);
          var _t = new mu(), Et = new mu();
          _t.add(ht), _t.add(at), _t.add(Et), z3(ht.shape.points, et, Et, I2, $, true), I2.setItemGraphicEl($, _t);
        }
      }).update(function($, et) {
        var at = P2.getItemGraphicEl(et), ht = at.childAt(0), bt = at.childAt(1), _t = at.childAt(2), Et = { shape: { points: I2.getItemLayout($) } };
        !Et.shape.points || (z3(ht.shape.points, Et.shape.points, _t, I2, $, false), A5(bt), A5(ht), jh2(ht, Et, t2), jh2(bt, Et, t2), I2.setItemGraphicEl($, at));
      }).remove(function($) {
        M2.remove(P2.getItemGraphicEl($));
      }).execute(), I2.eachItemGraphicEl(function($, et) {
        var at = I2.getItemModel(et), ht = $.childAt(0), bt = $.childAt(1), _t = $.childAt(2), Et = I2.getItemVisual(et, "style"), zt = Et.fill;
        M2.add($), ht.useStyle(Ul(at.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: zt })), Hx(ht, at, "lineStyle"), Hx(bt, at, "areaStyle");
        var Ft = at.getModel("areaStyle"), fe2 = Ft.isEmpty() && Ft.parentModel.isEmpty();
        bt.ignore = fe2, Qe2(["emphasis", "select", "blur"], function(me2) {
          var be2 = at.getModel([me2, "areaStyle"]), Te2 = be2.isEmpty() && be2.parentModel.isEmpty();
          bt.ensureState(me2).ignore = Te2 && fe2;
        }), bt.useStyle(Ul(Ft.getAreaStyle(), { fill: zt, opacity: 0.7, decal: Et.decal }));
        var re2 = at.getModel("emphasis"), ye = re2.getModel("itemStyle").getItemStyle();
        _t.eachChild(function(me2) {
          if (me2 instanceof Ux) {
            var be2 = me2.style;
            me2.useStyle(ba2({ image: be2.image, x: be2.x, y: be2.y, width: be2.width, height: be2.height }, Et));
          } else
            me2.useStyle(Et), me2.setColor(zt), me2.style.strokeNoScale = true;
          var Te2 = me2.ensureState("emphasis");
          Te2.style = pu(ye);
          var We = I2.getStore().get(I2.getDimensionIndex(me2.__dimIdx), et);
          (We == null || isNaN(We)) && (We = ""), SS(me2, b_(at), { labelFetcher: I2.hostModel, labelDataIndex: et, labelDimIndex: me2.__dimIdx, defaultText: We, inheritColor: zt, defaultOpacity: Et.opacity });
        }), vy($, re2.get("focus"), re2.get("blurScope"), re2.get("disabled"));
      }), this._data = I2;
    }, i.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, i.type = "radar", i;
  }(Hg2), Umr = Hmr, qmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.hasSymbolVisual = true, t2;
    }
    return i.prototype.init = function(t2) {
      f2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Wgt(ks(this.getData, this), ks(this.getRawData, this));
    }, i.prototype.getInitialData = function(t2, h) {
      return het(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      var _ = this.getData(), M2 = this.coordinateSystem, I2 = M2.getIndicatorAxes(), P2 = this.getData().getName(t2), N3 = P2 === "" ? this.name : P2, z3 = RWe(this, t2);
      return pb2("section", { header: N3, sortBlocks: true, blocks: Xa2(I2, function(H2) {
        var $ = _.get(_.mapDimension(H2.dim), t2);
        return pb2("nameValue", { markerType: "subItem", markerColor: z3, name: H2.name, value: $, sortParam: $ });
      }) });
    }, i.prototype.getTooltipPosition = function(t2) {
      if (t2 != null) {
        for (var h = this.getData(), v4 = this.coordinateSystem, _ = h.getValues(Xa2(v4.dimensions, function(N3) {
          return h.mapDimension(N3);
        }), t2), M2 = 0, I2 = _.length; M2 < I2; M2++)
          if (!isNaN(_[M2])) {
            var P2 = v4.getIndicatorAxes();
            return v4.coordToPoint(P2[M2].dataToCoord(_[M2]), M2);
          }
      }
    }, i.type = "series.radar", i.dependencies = ["radar"], i.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, i;
  }(Jv), Zmr = qmr, edt = EHe.value;
  function gDt(f2, i) {
    return Ul({ show: i }, f2);
  }
  var $mr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.optionUpdated = function() {
      var t2 = this.get("boundaryGap"), h = this.get("splitNumber"), v4 = this.get("scale"), _ = this.get("axisLine"), M2 = this.get("axisTick"), I2 = this.get("axisLabel"), P2 = this.get("axisName"), N3 = this.get(["axisName", "show"]), z3 = this.get(["axisName", "formatter"]), H2 = this.get("axisNameGap"), $ = this.get("triggerEvent"), et = Xa2(this.get("indicator") || [], function(at) {
        at.max != null && at.max > 0 && !at.min ? at.min = 0 : at.min != null && at.min < 0 && !at.max && (at.max = 0);
        var ht = P2;
        at.color != null && (ht = Ul({ color: at.color }, P2));
        var bt = cc2(pu(at), { boundaryGap: t2, splitNumber: h, scale: v4, axisLine: _, axisTick: M2, axisLabel: I2, name: at.text, showName: N3, nameLocation: "end", nameGap: H2, nameTextStyle: ht, triggerEvent: $ }, false);
        if (N3 || (bt.name = ""), ms(z3)) {
          var _t = bt.name;
          bt.name = z3.replace("{value}", _t != null ? _t : "");
        } else
          Ol(z3) && (bt.name = z3(bt.name, bt));
        var Et = new Gg2(bt, null, this.ecModel);
        return Sm(Et, Fgt.prototype), Et.mainType = "radar", Et.componentIndex = this.componentIndex, Et;
      }, this);
      this._indicatorModels = et;
    }, i.prototype.getIndicatorModels = function() {
      return this._indicatorModels;
    }, i.type = "radar", i.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: cc2({ lineStyle: { color: "#bbb" } }, edt.axisLine), axisLabel: gDt(edt.axisLabel, false), axisTick: gDt(edt.axisTick, false), splitLine: gDt(edt.splitLine, true), splitArea: gDt(edt.splitArea, true), indicator: [] }, i;
  }(zh2), Ymr = $mr, Kmr = ["axisLine", "axisTickLabel", "axisName"], Xmr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = this.group;
      _.removeAll(), this._buildAxes(t2), this._buildSplitLineAndArea(t2);
    }, i.prototype._buildAxes = function(t2) {
      var h = t2.coordinateSystem, v4 = h.getIndicatorAxes(), _ = Xa2(v4, function(M2) {
        var I2 = M2.model.get("showName") ? M2.name : "", P2 = new nN(M2.model, { axisName: I2, position: [h.cx, h.cy], rotation: M2.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
        return P2;
      });
      Qe2(_, function(M2) {
        Qe2(Kmr, M2.add, M2), this.group.add(M2.getGroup());
      }, this);
    }, i.prototype._buildSplitLineAndArea = function(t2) {
      var h = t2.coordinateSystem, v4 = h.getIndicatorAxes();
      if (!v4.length)
        return;
      var _ = t2.get("shape"), M2 = t2.getModel("splitLine"), I2 = t2.getModel("splitArea"), P2 = M2.getModel("lineStyle"), N3 = I2.getModel("areaStyle"), z3 = M2.get("show"), H2 = I2.get("show"), $ = P2.get("color"), et = N3.get("color"), at = Za2($) ? $ : [$], ht = Za2(et) ? et : [et], bt = [], _t = [];
      function Et(Vn, xn, Zr) {
        var nr = Zr % xn.length;
        return Vn[nr] = Vn[nr] || [], nr;
      }
      if (_ === "circle")
        for (var zt = v4[0].getTicksCoords(), Ft = h.cx, fe2 = h.cy, re2 = 0; re2 < zt.length; re2++) {
          if (z3) {
            var ye = Et(bt, at, re2);
            bt[ye].push(new UL({ shape: { cx: Ft, cy: fe2, r: zt[re2].coord } }));
          }
          if (H2 && re2 < zt.length - 1) {
            var ye = Et(_t, ht, re2);
            _t[ye].push(new ykt({ shape: { cx: Ft, cy: fe2, r0: zt[re2].coord, r: zt[re2 + 1].coord } }));
          }
        }
      else
        for (var me2, be2 = Xa2(v4, function(Vn, xn) {
          var Zr = Vn.getTicksCoords();
          return me2 = me2 == null ? Zr.length - 1 : Math.min(Zr.length - 1, me2), Xa2(Zr, function(nr) {
            return h.coordToPoint(nr.coord, xn);
          });
        }), Te2 = [], re2 = 0; re2 <= me2; re2++) {
          for (var We = [], en = 0; en < v4.length; en++)
            We.push(be2[en][re2]);
          if (We[0] && We.push(We[0].slice()), z3) {
            var ye = Et(bt, at, re2);
            bt[ye].push(new aC({ shape: { points: We } }));
          }
          if (H2 && Te2) {
            var ye = Et(_t, ht, re2 - 1);
            _t[ye].push(new iC({ shape: { points: We.concat(Te2) } }));
          }
          Te2 = We.slice().reverse();
        }
      var Ue2 = P2.getLineStyle(), Mn = N3.getAreaStyle();
      Qe2(_t, function(Vn, xn) {
        this.group.add(KD(Vn, { style: Ul({ stroke: "none", fill: ht[xn % ht.length] }, Mn), silent: true }));
      }, this), Qe2(bt, function(Vn, xn) {
        this.group.add(KD(Vn, { style: Ul({ fill: "none", stroke: at[xn % at.length] }, Ue2), silent: true }));
      }, this);
    }, i.type = "radar", i;
  }(W0), Qmr = Xmr, Jmr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this, t2, h, v4) || this;
      return _.type = "value", _.angle = 0, _.name = "", _;
    }
    return i;
  }(D5), t1r = Jmr, e1r = function() {
    function f2(i, t2, h) {
      this.dimensions = [], this._model = i, this._indicatorAxes = Xa2(i.getIndicatorModels(), function(v4, _) {
        var M2 = "indicator_" + _, I2 = new t1r(M2, new eV());
        return I2.name = v4.get("name"), I2.model = v4, v4.axis = I2, this.dimensions.push(M2), I2;
      }, this), this.resize(i, h);
    }
    return f2.prototype.getIndicatorAxes = function() {
      return this._indicatorAxes;
    }, f2.prototype.dataToPoint = function(i, t2) {
      var h = this._indicatorAxes[t2];
      return this.coordToPoint(h.dataToCoord(i), t2);
    }, f2.prototype.coordToPoint = function(i, t2) {
      var h = this._indicatorAxes[t2], v4 = h.angle, _ = this.cx + i * Math.cos(v4), M2 = this.cy - i * Math.sin(v4);
      return [_, M2];
    }, f2.prototype.pointToData = function(i) {
      var t2 = i[0] - this.cx, h = i[1] - this.cy, v4 = Math.sqrt(t2 * t2 + h * h);
      t2 /= v4, h /= v4;
      for (var _ = Math.atan2(-h, t2), M2 = 1 / 0, I2, P2 = -1, N3 = 0; N3 < this._indicatorAxes.length; N3++) {
        var z3 = this._indicatorAxes[N3], H2 = Math.abs(_ - z3.angle);
        H2 < M2 && (I2 = z3, P2 = N3, M2 = H2);
      }
      return [P2, +(I2 && I2.coordToData(v4))];
    }, f2.prototype.resize = function(i, t2) {
      var h = i.get("center"), v4 = t2.getWidth(), _ = t2.getHeight(), M2 = Math.min(v4, _) / 2;
      this.cx = cs(h[0], v4), this.cy = cs(h[1], _), this.startAngle = i.get("startAngle") * Math.PI / 180;
      var I2 = i.get("radius");
      (ms(I2) || vp(I2)) && (I2 = [0, I2]), this.r0 = cs(I2[0], M2), this.r = cs(I2[1], M2), Qe2(this._indicatorAxes, function(P2, N3) {
        P2.setExtent(this.r0, this.r);
        var z3 = this.startAngle + N3 * Math.PI * 2 / this._indicatorAxes.length;
        z3 = Math.atan2(Math.sin(z3), Math.cos(z3)), P2.angle = z3;
      }, this);
    }, f2.prototype.update = function(i, t2) {
      var h = this._indicatorAxes, v4 = this._model;
      Qe2(h, function(I2) {
        I2.scale.setExtent(1 / 0, -1 / 0);
      }), i.eachSeriesByType("radar", function(I2, P2) {
        if (!(I2.get("coordinateSystem") !== "radar" || i.getComponent("radar", I2.get("radarIndex")) !== v4)) {
          var N3 = I2.getData();
          Qe2(h, function(z3) {
            z3.scale.unionExtentFromData(N3, N3.mapDimension(z3.dim));
          });
        }
      }, this);
      var _ = v4.get("splitNumber"), M2 = new eV();
      M2.setExtent(0, _), M2.setInterval(1), Qe2(h, function(I2, P2) {
        kHe(I2.scale, I2.model, M2);
      });
    }, f2.prototype.convertToPixel = function(i, t2, h) {
      return console.warn("Not implemented."), null;
    }, f2.prototype.convertFromPixel = function(i, t2, h) {
      return console.warn("Not implemented."), null;
    }, f2.prototype.containPoint = function(i) {
      return console.warn("Not implemented."), false;
    }, f2.create = function(i, t2) {
      var h = [];
      return i.eachComponent("radar", function(v4) {
        var _ = new f2(v4, i, t2);
        h.push(_), v4.coordinateSystem = _;
      }), i.eachSeriesByType("radar", function(v4) {
        v4.get("coordinateSystem") === "radar" && (v4.coordinateSystem = h[v4.get("radarIndex") || 0]);
      }), h;
    }, f2.dimensions = [], f2;
  }(), n1r = e1r;
  function r1r(f2) {
    f2.registerCoordinateSystem("radar", n1r), f2.registerComponentModel(Ymr), f2.registerComponentView(Qmr), f2.registerVisual({ seriesType: "radar", reset: function(i) {
      var t2 = i.getData();
      t2.each(function(h) {
        t2.setItemVisual(h, "legendIcon", "roundRect");
      }), t2.setVisual("legendIcon", "roundRect");
    } });
  }
  function i1r(f2) {
    zc2(r1r), f2.registerChartView(Umr), f2.registerSeriesModel(Zmr), f2.registerLayout(Wmr), f2.registerProcessor(jgt("radar")), f2.registerPreprocessor(Gmr);
  }
  var q8e = "\0_ec_interaction_mutex";
  function a1r(f2, i, t2) {
    var h = Ine(f2);
    h[i] = t2;
  }
  function o1r(f2, i, t2) {
    var h = Ine(f2), v4 = h[i];
    v4 === t2 && (h[i] = null);
  }
  function Z8e(f2, i) {
    return !!Ine(f2)[i];
  }
  function Ine(f2) {
    return f2[q8e] || (f2[q8e] = {});
  }
  ZL({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, xm);
  var s1r = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this) || this;
      h._zr = t2;
      var v4 = ks(h._mousedownHandler, h), _ = ks(h._mousemoveHandler, h), M2 = ks(h._mouseupHandler, h), I2 = ks(h._mousewheelHandler, h), P2 = ks(h._pinchHandler, h);
      return h.enable = function(N3, z3) {
        this.disable(), this._opt = Ul(pu(z3) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), N3 == null && (N3 = true), (N3 === true || N3 === "move" || N3 === "pan") && (t2.on("mousedown", v4), t2.on("mousemove", _), t2.on("mouseup", M2)), (N3 === true || N3 === "scale" || N3 === "zoom") && (t2.on("mousewheel", I2), t2.on("pinch", P2));
      }, h.disable = function() {
        t2.off("mousedown", v4), t2.off("mousemove", _), t2.off("mouseup", M2), t2.off("mousewheel", I2), t2.off("pinch", P2);
      }, h;
    }
    return i.prototype.isDragging = function() {
      return this._dragging;
    }, i.prototype.isPinching = function() {
      return this._pinching;
    }, i.prototype.setPointerChecker = function(t2) {
      this.pointerChecker = t2;
    }, i.prototype.dispose = function() {
      this.disable();
    }, i.prototype._mousedownHandler = function(t2) {
      if (!(_6e(t2) || t2.target && t2.target.draggable)) {
        var h = t2.offsetX, v4 = t2.offsetY;
        this.pointerChecker && this.pointerChecker(t2, h, v4) && (this._x = h, this._y = v4, this._dragging = true);
      }
    }, i.prototype._mousemoveHandler = function(t2) {
      if (!(!this._dragging || !JDt("moveOnMouseMove", t2, this._opt) || t2.gestureEvent === "pinch" || Z8e(this._zr, "globalPan"))) {
        var h = t2.offsetX, v4 = t2.offsetY, _ = this._x, M2 = this._y, I2 = h - _, P2 = v4 - M2;
        this._x = h, this._y = v4, this._opt.preventDefaultMouseMove && J6(t2.event), VHe(this, "pan", "moveOnMouseMove", t2, { dx: I2, dy: P2, oldX: _, oldY: M2, newX: h, newY: v4, isAvailableBehavior: null });
      }
    }, i.prototype._mouseupHandler = function(t2) {
      _6e(t2) || (this._dragging = false);
    }, i.prototype._mousewheelHandler = function(t2) {
      var h = JDt("zoomOnMouseWheel", t2, this._opt), v4 = JDt("moveOnMouseWheel", t2, this._opt), _ = t2.wheelDelta, M2 = Math.abs(_), I2 = t2.offsetX, P2 = t2.offsetY;
      if (!(_ === 0 || !h && !v4)) {
        if (h) {
          var N3 = M2 > 3 ? 1.4 : M2 > 1 ? 1.2 : 1.1, z3 = _ > 0 ? N3 : 1 / N3;
          tQt(this, "zoom", "zoomOnMouseWheel", t2, { scale: z3, originX: I2, originY: P2, isAvailableBehavior: null });
        }
        if (v4) {
          var H2 = Math.abs(_), $ = (_ > 0 ? 1 : -1) * (H2 > 3 ? 0.4 : H2 > 1 ? 0.15 : 0.05);
          tQt(this, "scrollMove", "moveOnMouseWheel", t2, { scrollDelta: $, originX: I2, originY: P2, isAvailableBehavior: null });
        }
      }
    }, i.prototype._pinchHandler = function(t2) {
      if (!Z8e(this._zr, "globalPan")) {
        var h = t2.pinchScale > 1 ? 1.1 : 1 / 1.1;
        tQt(this, "zoom", null, t2, { scale: h, originX: t2.pinchX, originY: t2.pinchY, isAvailableBehavior: null });
      }
    }, i;
  }(iE);
  function tQt(f2, i, t2, h, v4) {
    f2.pointerChecker && f2.pointerChecker(h, v4.originX, v4.originY) && (J6(h.event), VHe(f2, i, t2, h, v4));
  }
  function VHe(f2, i, t2, h, v4) {
    v4.isAvailableBehavior = ks(JDt, null, t2, h), f2.trigger(i, v4);
  }
  function JDt(f2, i, t2) {
    var h = t2[f2];
    return !f2 || h && (!ms(h) || i.event[h + "Key"]);
  }
  var Ggt = s1r;
  function Dne(f2, i, t2) {
    var h = f2.target;
    h.x += i, h.y += t2, h.dirty();
  }
  function Ene(f2, i, t2, h) {
    var v4 = f2.target, _ = f2.zoomLimit, M2 = f2.zoom = f2.zoom || 1;
    if (M2 *= i, _) {
      var I2 = _.min || 0, P2 = _.max || 1 / 0;
      M2 = Math.max(Math.min(P2, M2), I2);
    }
    var N3 = M2 / f2.zoom;
    f2.zoom = M2, v4.x -= (t2 - v4.x) * (N3 - 1), v4.y -= (h - v4.y) * (N3 - 1), v4.scaleX *= N3, v4.scaleY *= N3, v4.dirty();
  }
  var l1r = { axisPointer: 1, tooltip: 1, brush: 1 };
  function Vkt(f2, i, t2) {
    var h = i.getComponentByElement(f2.topTarget), v4 = h && h.coordinateSystem;
    return h && h !== t2 && !l1r.hasOwnProperty(h.mainType) && v4 && v4.model !== t2;
  }
  function BHe(f2) {
    if (ms(f2)) {
      var i = new DOMParser();
      f2 = i.parseFromString(f2, "text/xml");
    }
    var t2 = f2;
    for (t2.nodeType === 9 && (t2 = t2.firstChild); t2.nodeName.toLowerCase() !== "svg" || t2.nodeType !== 1; )
      t2 = t2.nextSibling;
    return t2;
  }
  var eQt, FEt = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, $8e = Of2(FEt), VEt = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, Y8e = Of2(VEt), u1r = function() {
    function f2() {
      this._defs = {}, this._root = null;
    }
    return f2.prototype.parse = function(i, t2) {
      t2 = t2 || {};
      var h = BHe(i);
      this._defsUsePending = [];
      var v4 = new mu();
      this._root = v4;
      var _ = [], M2 = h.getAttribute("viewBox") || "", I2 = parseFloat(h.getAttribute("width") || t2.width), P2 = parseFloat(h.getAttribute("height") || t2.height);
      isNaN(I2) && (I2 = null), isNaN(P2) && (P2 = null), zT(h, v4, null, true, false);
      for (var N3 = h.firstChild; N3; )
        this._parseNode(N3, v4, _, null, false, false), N3 = N3.nextSibling;
      h1r(this._defs, this._defsUsePending), this._defsUsePending = [];
      var z3, H2;
      if (M2) {
        var $ = Bkt(M2);
        $.length >= 4 && (z3 = { x: parseFloat($[0] || 0), y: parseFloat($[1] || 0), width: parseFloat($[2]), height: parseFloat($[3]) });
      }
      if (z3 && I2 != null && P2 != null && (H2 = jHe(z3, { x: 0, y: 0, width: I2, height: P2 }), !t2.ignoreViewBox)) {
        var et = v4;
        v4 = new mu(), v4.add(et), et.scaleX = et.scaleY = H2.scale, et.x = H2.x, et.y = H2.y;
      }
      return !t2.ignoreRootClip && I2 != null && P2 != null && v4.setClipPath(new Sh2({ shape: { x: 0, y: 0, width: I2, height: P2 } })), { root: v4, width: I2, height: P2, viewBoxRect: z3, viewBoxTransform: H2, named: _ };
    }, f2.prototype._parseNode = function(i, t2, h, v4, _, M2) {
      var I2 = i.nodeName.toLowerCase(), P2, N3 = v4;
      if (I2 === "defs" && (_ = true), I2 === "text" && (M2 = true), I2 === "defs" || I2 === "switch")
        P2 = t2;
      else {
        if (!_) {
          var z3 = eQt[I2];
          if (z3 && qs(eQt, I2)) {
            P2 = z3.call(this, i, t2);
            var H2 = i.getAttribute("name");
            if (H2) {
              var $ = { name: H2, namedFrom: null, svgNodeTagLower: I2, el: P2 };
              h.push($), I2 === "g" && (N3 = $);
            } else
              v4 && h.push({ name: v4.name, namedFrom: v4, svgNodeTagLower: I2, el: P2 });
            t2.add(P2);
          }
        }
        var et = K8e[I2];
        if (et && qs(K8e, I2)) {
          var at = et.call(this, i), ht = i.getAttribute("id");
          ht && (this._defs[ht] = at);
        }
      }
      if (P2 && P2.isGroup)
        for (var bt = i.firstChild; bt; )
          bt.nodeType === 1 ? this._parseNode(bt, P2, h, N3, _, M2) : bt.nodeType === 3 && M2 && this._parseText(bt, P2), bt = bt.nextSibling;
    }, f2.prototype._parseText = function(i, t2) {
      var h = new Xdt({ style: { text: i.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
      BD(t2, h), zT(i, h, this._defsUsePending, false, false), c1r(h, t2);
      var v4 = h.style, _ = v4.fontSize;
      _ && _ < 9 && (v4.fontSize = 9, h.scaleX *= _ / 9, h.scaleY *= _ / 9);
      var M2 = (v4.fontSize || v4.fontFamily) && [v4.fontStyle, v4.fontWeight, (v4.fontSize || 12) + "px", v4.fontFamily || "sans-serif"].join(" ");
      v4.font = M2;
      var I2 = h.getBoundingRect();
      return this._textX += I2.width, t2.add(h), h;
    }, f2.internalField = function() {
      eQt = { g: function(i, t2) {
        var h = new mu();
        return BD(t2, h), zT(i, h, this._defsUsePending, false, false), h;
      }, rect: function(i, t2) {
        var h = new Sh2();
        return BD(t2, h), zT(i, h, this._defsUsePending, false, false), h.setShape({ x: parseFloat(i.getAttribute("x") || "0"), y: parseFloat(i.getAttribute("y") || "0"), width: parseFloat(i.getAttribute("width") || "0"), height: parseFloat(i.getAttribute("height") || "0") }), h.silent = true, h;
      }, circle: function(i, t2) {
        var h = new UL();
        return BD(t2, h), zT(i, h, this._defsUsePending, false, false), h.setShape({ cx: parseFloat(i.getAttribute("cx") || "0"), cy: parseFloat(i.getAttribute("cy") || "0"), r: parseFloat(i.getAttribute("r") || "0") }), h.silent = true, h;
      }, line: function(i, t2) {
        var h = new m_();
        return BD(t2, h), zT(i, h, this._defsUsePending, false, false), h.setShape({ x1: parseFloat(i.getAttribute("x1") || "0"), y1: parseFloat(i.getAttribute("y1") || "0"), x2: parseFloat(i.getAttribute("x2") || "0"), y2: parseFloat(i.getAttribute("y2") || "0") }), h.silent = true, h;
      }, ellipse: function(i, t2) {
        var h = new Bee();
        return BD(t2, h), zT(i, h, this._defsUsePending, false, false), h.setShape({ cx: parseFloat(i.getAttribute("cx") || "0"), cy: parseFloat(i.getAttribute("cy") || "0"), rx: parseFloat(i.getAttribute("rx") || "0"), ry: parseFloat(i.getAttribute("ry") || "0") }), h.silent = true, h;
      }, polygon: function(i, t2) {
        var h = i.getAttribute("points"), v4;
        h && (v4 = J8e(h));
        var _ = new iC({ shape: { points: v4 || [] }, silent: true });
        return BD(t2, _), zT(i, _, this._defsUsePending, false, false), _;
      }, polyline: function(i, t2) {
        var h = i.getAttribute("points"), v4;
        h && (v4 = J8e(h));
        var _ = new aC({ shape: { points: v4 || [] }, silent: true });
        return BD(t2, _), zT(i, _, this._defsUsePending, false, false), _;
      }, image: function(i, t2) {
        var h = new Ux();
        return BD(t2, h), zT(i, h, this._defsUsePending, false, false), h.setStyle({ image: i.getAttribute("xlink:href") || i.getAttribute("href"), x: +i.getAttribute("x"), y: +i.getAttribute("y"), width: +i.getAttribute("width"), height: +i.getAttribute("height") }), h.silent = true, h;
      }, text: function(i, t2) {
        var h = i.getAttribute("x") || "0", v4 = i.getAttribute("y") || "0", _ = i.getAttribute("dx") || "0", M2 = i.getAttribute("dy") || "0";
        this._textX = parseFloat(h) + parseFloat(_), this._textY = parseFloat(v4) + parseFloat(M2);
        var I2 = new mu();
        return BD(t2, I2), zT(i, I2, this._defsUsePending, false, true), I2;
      }, tspan: function(i, t2) {
        var h = i.getAttribute("x"), v4 = i.getAttribute("y");
        h != null && (this._textX = parseFloat(h)), v4 != null && (this._textY = parseFloat(v4));
        var _ = i.getAttribute("dx") || "0", M2 = i.getAttribute("dy") || "0", I2 = new mu();
        return BD(t2, I2), zT(i, I2, this._defsUsePending, false, true), this._textX += parseFloat(_), this._textY += parseFloat(M2), I2;
      }, path: function(i, t2) {
        var h = i.getAttribute("d") || "", v4 = yje(h);
        return BD(t2, v4), zT(i, v4, this._defsUsePending, false, false), v4.silent = true, v4;
      } };
    }(), f2;
  }(), K8e = { lineargradient: function(f2) {
    var i = parseInt(f2.getAttribute("x1") || "0", 10), t2 = parseInt(f2.getAttribute("y1") || "0", 10), h = parseInt(f2.getAttribute("x2") || "10", 10), v4 = parseInt(f2.getAttribute("y2") || "0", 10), _ = new Igt(i, t2, h, v4);
    return X8e(f2, _), Q8e(f2, _), _;
  }, radialgradient: function(f2) {
    var i = parseInt(f2.getAttribute("cx") || "0", 10), t2 = parseInt(f2.getAttribute("cy") || "0", 10), h = parseInt(f2.getAttribute("r") || "0", 10), v4 = new Eje(i, t2, h);
    return X8e(f2, v4), Q8e(f2, v4), v4;
  } };
  function X8e(f2, i) {
    var t2 = f2.getAttribute("gradientUnits");
    t2 === "userSpaceOnUse" && (i.global = true);
  }
  function Q8e(f2, i) {
    for (var t2 = f2.firstChild; t2; ) {
      if (t2.nodeType === 1 && t2.nodeName.toLocaleLowerCase() === "stop") {
        var h = t2.getAttribute("offset"), v4 = void 0;
        h && h.indexOf("%") > 0 ? v4 = parseInt(h, 10) / 100 : h ? v4 = parseFloat(h) : v4 = 0;
        var _ = {};
        zHe(t2, _, _);
        var M2 = _.stopColor || t2.getAttribute("stop-color") || "#000000";
        i.colorStops.push({ offset: v4, color: M2 });
      }
      t2 = t2.nextSibling;
    }
  }
  function BD(f2, i) {
    f2 && f2.__inheritedStyle && (i.__inheritedStyle || (i.__inheritedStyle = {}), Ul(i.__inheritedStyle, f2.__inheritedStyle));
  }
  function J8e(f2) {
    for (var i = Bkt(f2), t2 = [], h = 0; h < i.length; h += 2) {
      var v4 = parseFloat(i[h]), _ = parseFloat(i[h + 1]);
      t2.push([v4, _]);
    }
    return t2;
  }
  function zT(f2, i, t2, h, v4) {
    var _ = i, M2 = _.__inheritedStyle = _.__inheritedStyle || {}, I2 = {};
    f2.nodeType === 1 && (g1r(f2, i), zHe(f2, M2, I2), h || v1r(f2, M2, I2)), _.style = _.style || {}, M2.fill != null && (_.style.fill = t9e(_, "fill", M2.fill, t2)), M2.stroke != null && (_.style.stroke = t9e(_, "stroke", M2.stroke, t2)), Qe2(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(P2) {
      M2[P2] != null && (_.style[P2] = parseFloat(M2[P2]));
    }), Qe2(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(P2) {
      M2[P2] != null && (_.style[P2] = M2[P2]);
    }), v4 && (_.__selfStyle = I2), M2.lineDash && (_.style.lineDash = Xa2(Bkt(M2.lineDash), function(P2) {
      return parseFloat(P2);
    })), (M2.visibility === "hidden" || M2.visibility === "collapse") && (_.invisible = true), M2.display === "none" && (_.ignore = true);
  }
  function c1r(f2, i) {
    var t2 = i.__selfStyle;
    if (t2) {
      var h = t2.textBaseline, v4 = h;
      !h || h === "auto" || h === "baseline" ? v4 = "alphabetic" : h === "before-edge" || h === "text-before-edge" ? v4 = "top" : h === "after-edge" || h === "text-after-edge" ? v4 = "bottom" : (h === "central" || h === "mathematical") && (v4 = "middle"), f2.style.textBaseline = v4;
    }
    var _ = i.__inheritedStyle;
    if (_) {
      var M2 = _.textAlign, I2 = M2;
      M2 && (M2 === "middle" && (I2 = "center"), f2.style.textAlign = I2);
    }
  }
  var f1r = /^url\(\s*#(.*?)\)/;
  function t9e(f2, i, t2, h) {
    var v4 = t2 && t2.match(f1r);
    if (v4) {
      var _ = w5(v4[1]);
      h.push([f2, i, _]);
      return;
    }
    return t2 === "none" && (t2 = null), t2;
  }
  function h1r(f2, i) {
    for (var t2 = 0; t2 < i.length; t2++) {
      var h = i[t2];
      h[0].style[h[1]] = f2[h[2]];
    }
  }
  var p1r = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function Bkt(f2) {
    return f2.match(p1r) || [];
  }
  var d1r = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, nQt = Math.PI / 180;
  function g1r(f2, i) {
    var t2 = f2.getAttribute("transform");
    if (t2) {
      t2 = t2.replace(/,/g, " ");
      var h = [], v4 = null;
      t2.replace(d1r, function(H2, $, et) {
        return h.push($, et), "";
      });
      for (var _ = h.length - 1; _ > 0; _ -= 2) {
        var M2 = h[_], I2 = h[_ - 1], P2 = Bkt(M2);
        switch (v4 = v4 || nE(), I2) {
          case "translate":
            jL(v4, v4, [parseFloat(P2[0]), parseFloat(P2[1] || "0")]);
            break;
          case "scale":
            Aee(v4, v4, [parseFloat(P2[0]), parseFloat(P2[1] || P2[0])]);
            break;
          case "rotate":
            SU(v4, v4, -parseFloat(P2[0]) * nQt);
            break;
          case "skewX":
            var N3 = Math.tan(parseFloat(P2[0]) * nQt);
            $6(v4, [1, 0, N3, 1, 0, 0], v4);
            break;
          case "skewY":
            var z3 = Math.tan(parseFloat(P2[0]) * nQt);
            $6(v4, [1, z3, 0, 1, 0, 0], v4);
            break;
          case "matrix":
            v4[0] = parseFloat(P2[0]), v4[1] = parseFloat(P2[1]), v4[2] = parseFloat(P2[2]), v4[3] = parseFloat(P2[3]), v4[4] = parseFloat(P2[4]), v4[5] = parseFloat(P2[5]);
            break;
        }
      }
      i.setLocalTransform(v4);
    }
  }
  var e9e = /([^\s:;]+)\s*:\s*([^:;]+)/g;
  function zHe(f2, i, t2) {
    var h = f2.getAttribute("style");
    if (!!h) {
      e9e.lastIndex = 0;
      for (var v4; (v4 = e9e.exec(h)) != null; ) {
        var _ = v4[1], M2 = qs(FEt, _) ? FEt[_] : null;
        M2 && (i[M2] = v4[2]);
        var I2 = qs(VEt, _) ? VEt[_] : null;
        I2 && (t2[I2] = v4[2]);
      }
    }
  }
  function v1r(f2, i, t2) {
    for (var h = 0; h < $8e.length; h++) {
      var v4 = $8e[h], _ = f2.getAttribute(v4);
      _ != null && (i[FEt[v4]] = _);
    }
    for (var h = 0; h < Y8e.length; h++) {
      var v4 = Y8e[h], _ = f2.getAttribute(v4);
      _ != null && (t2[VEt[v4]] = _);
    }
  }
  function jHe(f2, i) {
    var t2 = i.width / f2.width, h = i.height / f2.height, v4 = Math.min(t2, h);
    return { scale: v4, x: -(f2.x + f2.width / 2) * v4 + (i.x + i.width / 2), y: -(f2.y + f2.height / 2) * v4 + (i.y + i.height / 2) };
  }
  function y1r(f2, i) {
    var t2 = new u1r();
    return t2.parse(f2, i);
  }
  var m1r = Il(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), b1r = function() {
    function f2(i, t2) {
      this.type = "geoSVG", this._usedGraphicMap = Il(), this._freedGraphics = [], this._mapName = i, this._parsedXML = BHe(t2);
    }
    return f2.prototype.load = function() {
      var i = this._firstGraphic;
      if (!i) {
        i = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(i), this._boundingRect = this._firstGraphic.boundingRect.clone();
        var t2 = x1r(i.named), h = t2.regions, v4 = t2.regionsMap;
        this._regions = h, this._regionsMap = v4;
      }
      return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
    }, f2.prototype._buildGraphic = function(i) {
      var t2, h;
      try {
        t2 = i && y1r(i, { ignoreViewBox: true, ignoreRootClip: true }) || {}, h = t2.root, z2(h != null);
      } catch (bt) {
        throw new Error(`Invalid svg format
` + bt.message);
      }
      var v4 = new mu();
      v4.add(h), v4.isGeoSVGGraphicRoot = true;
      var _ = t2.width, M2 = t2.height, I2 = t2.viewBoxRect, P2 = this._boundingRect;
      if (!P2) {
        var N3 = void 0, z3 = void 0, H2 = void 0, $ = void 0;
        if (_ != null ? (N3 = 0, H2 = _) : I2 && (N3 = I2.x, H2 = I2.width), M2 != null ? (z3 = 0, $ = M2) : I2 && (z3 = I2.y, $ = I2.height), N3 == null || z3 == null) {
          var et = h.getBoundingRect();
          N3 == null && (N3 = et.x, H2 = et.width), z3 == null && (z3 = et.y, $ = et.height);
        }
        P2 = this._boundingRect = new Lc2(N3, z3, H2, $);
      }
      if (I2) {
        var at = jHe(I2, P2);
        h.scaleX = h.scaleY = at.scale, h.x = at.x, h.y = at.y;
      }
      v4.setClipPath(new Sh2({ shape: P2.plain() }));
      var ht = [];
      return Qe2(t2.named, function(bt) {
        m1r.get(bt.svgNodeTagLower) != null && (ht.push(bt), _1r(bt.el));
      }), { root: v4, boundingRect: P2, named: ht };
    }, f2.prototype.useGraphic = function(i) {
      var t2 = this._usedGraphicMap, h = t2.get(i);
      return h || (h = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), t2.set(i, h), h);
    }, f2.prototype.freeGraphic = function(i) {
      var t2 = this._usedGraphicMap, h = t2.get(i);
      h && (t2.removeKey(i), this._freedGraphics.push(h));
    }, f2;
  }();
  function _1r(f2) {
    f2.silent = false, f2.isGroup && f2.traverse(function(i) {
      i.silent = false;
    });
  }
  function x1r(f2) {
    var i = [], t2 = Il();
    return Qe2(f2, function(h) {
      if (h.namedFrom == null) {
        var v4 = new Bvr(h.name, h.el);
        i.push(v4), t2.set(h.name, v4);
      }
    }), { regions: i, regionsMap: t2 };
  }
  var _te = [126, 25], n9e = "\u5357\u6D77\u8BF8\u5C9B", HH = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
  for (var zH = 0; zH < HH.length; zH++)
    for (var ctt = 0; ctt < HH[zH].length; ctt++)
      HH[zH][ctt][0] /= 10.5, HH[zH][ctt][1] /= -10.5 / 0.75, HH[zH][ctt][0] += _te[0], HH[zH][ctt][1] += _te[1];
  function w1r(f2, i) {
    if (f2 === "china") {
      for (var t2 = 0; t2 < i.length; t2++)
        if (i[t2].name === n9e)
          return;
      i.push(new jGe(n9e, Xa2(HH, function(h) {
        return { type: "polygon", exterior: h };
      }), _te));
    }
  }
  var S1r = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
  function M1r(f2, i) {
    if (f2 === "china") {
      var t2 = S1r[i.name];
      if (t2) {
        var h = i.getCenter();
        h[0] += t2[0] / 10.5, h[1] += -t2[1] / (10.5 / 0.75), i.setCenter(h);
      }
    }
  }
  var C1r = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
  function T1r(f2, i) {
    f2 === "china" && i.name === "\u53F0\u6E7E" && i.geometries.push({ type: "polygon", exterior: C1r[0] });
  }
  var A1r = "name", I1r = function() {
    function f2(i, t2, h) {
      this.type = "geoJSON", this._parsedMap = Il(), this._mapName = i, this._specialAreas = h, this._geoJSON = E1r(t2);
    }
    return f2.prototype.load = function(i, t2) {
      t2 = t2 || A1r;
      var h = this._parsedMap.get(t2);
      if (!h) {
        var v4 = this._parseToRegions(t2);
        h = this._parsedMap.set(t2, { regions: v4, boundingRect: D1r(v4) });
      }
      var _ = Il(), M2 = [];
      return Qe2(h.regions, function(I2) {
        var P2 = I2.name;
        i && qs(i, P2) && (I2 = I2.cloneShallow(P2 = i[P2])), M2.push(I2), _.set(P2, I2);
      }), { regions: M2, boundingRect: h.boundingRect || new Lc2(0, 0, 0, 0), regionsMap: _ };
    }, f2.prototype._parseToRegions = function(i) {
      var t2 = this._mapName, h = this._geoJSON, v4;
      try {
        v4 = h ? jvr(h, i) : [];
      } catch (_) {
        throw new Error(`Invalid geoJson format
` + _.message);
      }
      return w1r(t2, v4), Qe2(v4, function(_) {
        var M2 = _.name;
        M1r(t2, _), T1r(t2, _);
        var I2 = this._specialAreas && this._specialAreas[M2];
        I2 && _.transformTo(I2.left, I2.top, I2.width, I2.height);
      }, this), v4;
    }, f2.prototype.getMapForUser = function() {
      return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
    }, f2;
  }();
  function D1r(f2) {
    for (var i, t2 = 0; t2 < f2.length; t2++) {
      var h = f2[t2].getBoundingRect();
      i = i || h.clone(), i.union(h);
    }
    return i;
  }
  function E1r(f2) {
    return ms(f2) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(f2) : new Function("return (" + f2 + ");")() : f2;
  }
  var ndt = Il(), rN = { registerMap: function(f2, i, t2) {
    if (i.svg) {
      var h = new b1r(f2, i.svg);
      ndt.set(f2, h);
    } else {
      var v4 = i.geoJson || i.geoJSON;
      v4 && !i.features ? t2 = i.specialAreas : v4 = i;
      var h = new I1r(f2, v4, t2);
      ndt.set(f2, h);
    }
  }, getGeoResource: function(f2) {
    return ndt.get(f2);
  }, getMapForUser: function(f2) {
    var i = ndt.get(f2);
    return i && i.type === "geoJSON" && i.getMapForUser();
  }, load: function(f2, i, t2) {
    var h = ndt.get(f2);
    if (!!h)
      return h.load(i, t2);
  } }, kne = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], k1r = Il(kne), P1r = Il(kne.concat(["g"])), L1r = Il(kne.concat(["g"])), WHe = Wh2();
  function vDt(f2) {
    var i = f2.getItemStyle(), t2 = f2.get("areaColor");
    return t2 != null && (i.fill = t2), i;
  }
  function r9e(f2) {
    var i = f2.style;
    i && (i.stroke = i.stroke || i.fill, i.fill = null);
  }
  var O1r = function() {
    function f2(i) {
      var t2 = new mu();
      this.uid = ret("ec_map_draw"), this._controller = new Ggt(i.getZr()), this._controllerHost = { target: t2 }, this.group = t2, t2.add(this._regionsGroup = new mu()), t2.add(this._svgGroup = new mu());
    }
    return f2.prototype.draw = function(i, t2, h, v4, _) {
      var M2 = i.mainType === "geo", I2 = i.getData && i.getData();
      M2 && t2.eachComponent({ mainType: "series", subType: "map" }, function(_t) {
        !I2 && _t.getHostGeoModel() === i && (I2 = _t.getData());
      });
      var P2 = i.coordinateSystem, N3 = this._regionsGroup, z3 = this.group, H2 = P2.getTransformInfo(), $ = H2.raw, et = H2.roam, at = !N3.childAt(0) || _;
      at ? (z3.x = et.x, z3.y = et.y, z3.scaleX = et.scaleX, z3.scaleY = et.scaleY, z3.dirty()) : jh2(z3, et, i);
      var ht = I2 && I2.getVisual("visualMeta") && I2.getVisual("visualMeta").length > 0, bt = { api: h, geo: P2, mapOrGeoModel: i, data: I2, isVisualEncodedByVisualMap: ht, isGeo: M2, transformInfoRaw: $ };
      P2.resourceType === "geoJSON" ? this._buildGeoJSON(bt) : P2.resourceType === "geoSVG" && this._buildSVG(bt), this._updateController(i, t2, h), this._updateMapSelectHandler(i, N3, h, v4);
    }, f2.prototype._buildGeoJSON = function(i) {
      var t2 = this._regionsGroupByName = Il(), h = Il(), v4 = this._regionsGroup, _ = i.transformInfoRaw, M2 = i.mapOrGeoModel, I2 = i.data, P2 = i.geo.projection, N3 = P2 && P2.stream;
      function z3(et, at) {
        return at && (et = at(et)), et && [et[0] * _.scaleX + _.x, et[1] * _.scaleY + _.y];
      }
      function H2(et) {
        for (var at = [], ht = !N3 && P2 && P2.project, bt = 0; bt < et.length; ++bt) {
          var _t = z3(et[bt], ht);
          _t && at.push(_t);
        }
        return at;
      }
      function $(et) {
        return { shape: { points: H2(et) } };
      }
      v4.removeAll(), Qe2(i.geo.regions, function(et) {
        var at = et.name, ht = t2.get(at), bt = h.get(at) || {}, _t = bt.dataIdx, Et = bt.regionModel;
        ht || (ht = t2.set(at, new mu()), v4.add(ht), _t = I2 ? I2.indexOfName(at) : null, Et = i.isGeo ? M2.getRegionModel(at) : I2 ? I2.getItemModel(_t) : null, h.set(at, { dataIdx: _t, regionModel: Et }));
        var zt = [], Ft = [];
        Qe2(et.geometries, function(ye) {
          if (ye.type === "polygon") {
            var me2 = [ye.exterior].concat(ye.interiors || []);
            N3 && (me2 = u9e(me2, N3)), Qe2(me2, function(Te2) {
              zt.push(new iC($(Te2)));
            });
          } else {
            var be2 = ye.points;
            N3 && (be2 = u9e(be2, N3, true)), Qe2(be2, function(Te2) {
              Ft.push(new aC($(Te2)));
            });
          }
        });
        var fe2 = z3(et.getCenter(), P2 && P2.project);
        function re2(ye, me2) {
          if (!!ye.length) {
            var be2 = new jee({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: ye } });
            ht.add(be2), i9e(i, be2, _t, Et), a9e(i, be2, at, Et, M2, _t, fe2), me2 && (r9e(be2), Qe2(be2.states, r9e));
          }
        }
        re2(zt), re2(Ft, true);
      }), t2.each(function(et, at) {
        var ht = h.get(at), bt = ht.dataIdx, _t = ht.regionModel;
        o9e(i, et, at, _t, M2, bt), s9e(i, et, at, _t, M2), l9e(i, et, at, _t, M2);
      }, this);
    }, f2.prototype._buildSVG = function(i) {
      var t2 = i.geo.map, h = i.transformInfoRaw;
      this._svgGroup.x = h.x, this._svgGroup.y = h.y, this._svgGroup.scaleX = h.scaleX, this._svgGroup.scaleY = h.scaleY, this._svgResourceChanged(t2) && (this._freeSVG(), this._useSVG(t2));
      var v4 = this._svgDispatcherMap = Il(), _ = false;
      Qe2(this._svgGraphicRecord.named, function(M2) {
        var I2 = M2.name, P2 = i.mapOrGeoModel, N3 = i.data, z3 = M2.svgNodeTagLower, H2 = M2.el, $ = N3 ? N3.indexOfName(I2) : null, et = P2.getRegionModel(I2);
        if (k1r.get(z3) != null && H2 instanceof rE && i9e(i, H2, $, et), H2 instanceof rE && (H2.culling = true), H2.z2EmphasisLift = 0, !M2.namedFrom && (L1r.get(z3) != null && a9e(i, H2, I2, et, P2, $, null), o9e(i, H2, I2, et, P2, $), s9e(i, H2, I2, et, P2), P1r.get(z3) != null)) {
          var at = l9e(i, H2, I2, et, P2);
          at === "self" && (_ = true);
          var ht = v4.get(I2) || v4.set(I2, []);
          ht.push(H2);
        }
      }, this), this._enableBlurEntireSVG(_, i);
    }, f2.prototype._enableBlurEntireSVG = function(i, t2) {
      if (i && t2.isGeo) {
        var h = t2.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), v4 = h.opacity;
        this._svgGraphicRecord.root.traverse(function(_) {
          if (!_.isGroup) {
            mU(_);
            var M2 = _.ensureState("blur").style || {};
            M2.opacity == null && v4 != null && (M2.opacity = v4), _.ensureState("emphasis");
          }
        });
      }
    }, f2.prototype.remove = function() {
      this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
    }, f2.prototype.findHighDownDispatchers = function(i, t2) {
      if (i == null)
        return [];
      var h = t2.coordinateSystem;
      if (h.resourceType === "geoJSON") {
        var v4 = this._regionsGroupByName;
        if (v4) {
          var _ = v4.get(i);
          return _ ? [_] : [];
        }
      } else if (h.resourceType === "geoSVG")
        return this._svgDispatcherMap && this._svgDispatcherMap.get(i) || [];
    }, f2.prototype._svgResourceChanged = function(i) {
      return this._svgMapName !== i;
    }, f2.prototype._useSVG = function(i) {
      var t2 = rN.getGeoResource(i);
      if (t2 && t2.type === "geoSVG") {
        var h = t2.useGraphic(this.uid);
        this._svgGroup.add(h.root), this._svgGraphicRecord = h, this._svgMapName = i;
      }
    }, f2.prototype._freeSVG = function() {
      var i = this._svgMapName;
      if (i != null) {
        var t2 = rN.getGeoResource(i);
        t2 && t2.type === "geoSVG" && t2.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
      }
    }, f2.prototype._updateController = function(i, t2, h) {
      var v4 = i.coordinateSystem, _ = this._controller, M2 = this._controllerHost;
      M2.zoomLimit = i.get("scaleLimit"), M2.zoom = v4.getZoom(), _.enable(i.get("roam") || false);
      var I2 = i.mainType;
      function P2() {
        var N3 = { type: "geoRoam", componentType: I2 };
        return N3[I2 + "Id"] = i.id, N3;
      }
      _.off("pan").on("pan", function(N3) {
        this._mouseDownFlag = false, Dne(M2, N3.dx, N3.dy), h.dispatchAction(ba2(P2(), { dx: N3.dx, dy: N3.dy, animation: { duration: 0 } }));
      }, this), _.off("zoom").on("zoom", function(N3) {
        this._mouseDownFlag = false, Ene(M2, N3.scale, N3.originX, N3.originY), h.dispatchAction(ba2(P2(), { zoom: N3.scale, originX: N3.originX, originY: N3.originY, animation: { duration: 0 } }));
      }, this), _.setPointerChecker(function(N3, z3, H2) {
        return v4.containPoint([z3, H2]) && !Vkt(N3, h, i);
      });
    }, f2.prototype.resetForLabelLayout = function() {
      this.group.traverse(function(i) {
        var t2 = i.getTextContent();
        t2 && (t2.ignore = WHe(t2).ignore);
      });
    }, f2.prototype._updateMapSelectHandler = function(i, t2, h, v4) {
      var _ = this;
      t2.off("mousedown"), t2.off("click"), i.get("selectedMode") && (t2.on("mousedown", function() {
        _._mouseDownFlag = true;
      }), t2.on("click", function(M2) {
        !_._mouseDownFlag || (_._mouseDownFlag = false);
      }));
    }, f2;
  }();
  function i9e(f2, i, t2, h) {
    var v4 = h.getModel("itemStyle"), _ = h.getModel(["emphasis", "itemStyle"]), M2 = h.getModel(["blur", "itemStyle"]), I2 = h.getModel(["select", "itemStyle"]), P2 = vDt(v4), N3 = vDt(_), z3 = vDt(I2), H2 = vDt(M2), $ = f2.data;
    if ($) {
      var et = $.getItemVisual(t2, "style"), at = $.getItemVisual(t2, "decal");
      f2.isVisualEncodedByVisualMap && et.fill && (P2.fill = et.fill), at && (P2.decal = lgt(at, f2.api));
    }
    i.setStyle(P2), i.style.strokeNoScale = true, i.ensureState("emphasis").style = N3, i.ensureState("select").style = z3, i.ensureState("blur").style = H2, mU(i);
  }
  function a9e(f2, i, t2, h, v4, _, M2) {
    var I2 = f2.data, P2 = f2.isGeo, N3 = I2 && isNaN(I2.get(I2.mapDimension("value"), _)), z3 = I2 && I2.getItemLayout(_);
    if (P2 || N3 || z3 && z3.showLabel) {
      var H2 = P2 ? t2 : _, $ = void 0;
      (!I2 || _ >= 0) && ($ = v4);
      var et = M2 ? { normal: { align: "center", verticalAlign: "middle" } } : null;
      SS(i, b_(h), { labelFetcher: $, labelDataIndex: H2, defaultText: t2 }, et);
      var at = i.getTextContent();
      if (at && (WHe(at).ignore = at.ignore, i.textConfig && M2)) {
        var ht = i.getBoundingRect().clone();
        i.textConfig.layoutRect = ht, i.textConfig.position = [(M2[0] - ht.x) / ht.width * 100 + "%", (M2[1] - ht.y) / ht.height * 100 + "%"];
      }
      i.disableLabelAnimation = true;
    } else
      i.removeTextContent(), i.removeTextConfig(), i.disableLabelAnimation = null;
  }
  function o9e(f2, i, t2, h, v4, _) {
    f2.data ? f2.data.setItemGraphicEl(_, i) : Du(i).eventData = { componentType: "geo", componentIndex: v4.componentIndex, geoIndex: v4.componentIndex, name: t2, region: h && h.option || {} };
  }
  function s9e(f2, i, t2, h, v4) {
    f2.data || eet({ el: i, componentModel: v4, itemName: t2, itemTooltipOption: h.get("tooltip") });
  }
  function l9e(f2, i, t2, h, v4) {
    i.highDownSilentOnTouch = !!v4.get("selectedMode");
    var _ = h.getModel("emphasis"), M2 = _.get("focus");
    return vy(i, M2, _.get("blurScope"), _.get("disabled")), f2.isGeo && Pfr(i, v4, t2), M2;
  }
  function u9e(f2, i, t2) {
    var h = [], v4;
    function _() {
      v4 = [];
    }
    function M2() {
      v4.length && (h.push(v4), v4 = []);
    }
    var I2 = i({ polygonStart: _, polygonEnd: M2, lineStart: _, lineEnd: M2, point: function(P2, N3) {
      isFinite(P2) && isFinite(N3) && v4.push([P2, N3]);
    }, sphere: function() {
    } });
    return !t2 && I2.polygonStart(), Qe2(f2, function(P2) {
      I2.lineStart();
      for (var N3 = 0; N3 < P2.length; N3++)
        I2.point(P2[N3][0], P2[N3][1]);
      I2.lineEnd();
    }), !t2 && I2.polygonEnd(), h;
  }
  var GHe = O1r, R1r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      if (!(_ && _.type === "mapToggleSelect" && _.from === this.uid)) {
        var M2 = this.group;
        if (M2.removeAll(), !t2.getHostGeoModel()) {
          if (this._mapDraw && _ && _.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), _ && _.type === "geoRoam" && _.componentType === "series" && _.seriesId === t2.id) {
            var I2 = this._mapDraw;
            I2 && M2.add(I2.group);
          } else if (t2.needsDrawMap) {
            var I2 = this._mapDraw || new GHe(v4);
            M2.add(I2.group), I2.draw(t2, h, v4, this, _), this._mapDraw = I2;
          } else
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          t2.get("showLegendSymbol") && h.getComponent("legend") && this._renderSymbols(t2, h, v4);
        }
      }
    }, i.prototype.remove = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
    }, i.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
    }, i.prototype._renderSymbols = function(t2, h, v4) {
      var _ = t2.originalData, M2 = this.group;
      _.each(_.mapDimension("value"), function(I2, P2) {
        if (!isNaN(I2)) {
          var N3 = _.getItemLayout(P2);
          if (!(!N3 || !N3.point)) {
            var z3 = N3.point, H2 = N3.offset, $ = new UL({ style: { fill: t2.getData().getVisual("style").fill }, shape: { cx: z3[0] + H2 * 9, cy: z3[1], r: 3 }, silent: true, z2: 8 + (H2 ? 0 : Jtt + 1) });
            if (!H2) {
              var et = t2.mainSeries.getData(), at = _.getName(P2), ht = et.indexOfName(at), bt = _.getItemModel(P2), _t = bt.getModel("label"), Et = et.getItemGraphicEl(ht);
              SS($, b_(bt), { labelFetcher: { getFormattedLabel: function(zt, Ft) {
                return t2.getFormattedLabel(ht, Ft);
              } }, defaultText: at }), $.disableLabelAnimation = true, _t.get("position") || $.setTextConfig({ position: "bottom" }), Et.onHoverStateChange = function(zt) {
                vEt($, zt);
              };
            }
            M2.add($);
          }
        }
      });
    }, i.type = "map", i;
  }(Hg2), N1r = R1r, F1r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.needsDrawMap = false, t2.seriesGroup = [], t2.getTooltipPosition = function(h) {
        if (h != null) {
          var v4 = this.getData().getName(h), _ = this.coordinateSystem, M2 = _.getRegion(v4);
          return M2 && _.dataToPoint(M2.getCenter());
        }
      }, t2;
    }
    return i.prototype.getInitialData = function(t2) {
      for (var h = het(this, { coordDimensions: ["value"], encodeDefaulter: Ou(Kee, this) }), v4 = Il(), _ = [], M2 = 0, I2 = h.count(); M2 < I2; M2++) {
        var P2 = h.getName(M2);
        v4.set(P2, true);
      }
      var N3 = rN.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
      return Qe2(N3.regions, function(z3) {
        var H2 = z3.name;
        v4.get(H2) || _.push(H2);
      }), h.appendValues([], _), h;
    }, i.prototype.getHostGeoModel = function() {
      var t2 = this.option.geoIndex;
      return t2 != null ? this.ecModel.getComponent("geo", t2) : null;
    }, i.prototype.getMapType = function() {
      return (this.getHostGeoModel() || this).option.map;
    }, i.prototype.getRawValue = function(t2) {
      var h = this.getData();
      return h.get(h.mapDimension("value"), t2);
    }, i.prototype.getRegionModel = function(t2) {
      var h = this.getData();
      return h.getItemModel(h.indexOfName(t2));
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      for (var _ = this.getData(), M2 = this.getRawValue(t2), I2 = _.getName(t2), P2 = this.seriesGroup, N3 = [], z3 = 0; z3 < P2.length; z3++) {
        var H2 = P2[z3].originalData.indexOfName(I2), $ = _.mapDimension("value");
        isNaN(P2[z3].originalData.get($, H2)) || N3.push(P2[z3].name);
      }
      return pb2("section", { header: N3.join(", "), noHeader: !N3.length, blocks: [pb2("nameValue", { name: I2, value: M2 })] });
    }, i.prototype.setZoom = function(t2) {
      this.option.zoom = t2;
    }, i.prototype.setCenter = function(t2) {
      this.option.center = t2;
    }, i.prototype.getLegendIcon = function(t2) {
      var h = t2.icon || "roundRect", v4 = wm(h, 0, 0, t2.itemWidth, t2.itemHeight, t2.itemStyle.fill);
      return v4.setStyle(t2.itemStyle), v4.style.stroke = "none", h.indexOf("empty") > -1 && (v4.style.stroke = v4.style.fill, v4.style.fill = "#fff", v4.style.lineWidth = 2), v4;
    }, i.type = "series.map", i.dependencies = ["geo"], i.layoutMode = "box", i.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, i;
  }(Jv), V1r = F1r;
  function B1r(f2, i) {
    var t2 = {};
    return Qe2(f2, function(h) {
      h.each(h.mapDimension("value"), function(v4, _) {
        var M2 = "ec-" + h.getName(_);
        t2[M2] = t2[M2] || [], isNaN(v4) || t2[M2].push(v4);
      });
    }), f2[0].map(f2[0].mapDimension("value"), function(h, v4) {
      for (var _ = "ec-" + f2[0].getName(v4), M2 = 0, I2 = 1 / 0, P2 = -1 / 0, N3 = t2[_].length, z3 = 0; z3 < N3; z3++)
        I2 = Math.min(I2, t2[_][z3]), P2 = Math.max(P2, t2[_][z3]), M2 += t2[_][z3];
      var H2;
      return i === "min" ? H2 = I2 : i === "max" ? H2 = P2 : i === "average" ? H2 = M2 / N3 : H2 = M2, N3 === 0 ? NaN : H2;
    });
  }
  function z1r(f2) {
    var i = {};
    f2.eachSeriesByType("map", function(t2) {
      var h = t2.getHostGeoModel(), v4 = h ? "o" + h.id : "i" + t2.getMapType();
      (i[v4] = i[v4] || []).push(t2);
    }), Qe2(i, function(t2, h) {
      for (var v4 = B1r(Xa2(t2, function(M2) {
        return M2.getData();
      }), t2[0].get("mapValueCalculation")), _ = 0; _ < t2.length; _++)
        t2[_].originalData = t2[_].getData();
      for (var _ = 0; _ < t2.length; _++)
        t2[_].seriesGroup = t2, t2[_].needsDrawMap = _ === 0 && !t2[_].getHostGeoModel(), t2[_].setData(v4.cloneShallow()), t2[_].mainSeries = t2[0];
    });
  }
  function j1r(f2) {
    var i = {};
    f2.eachSeriesByType("map", function(t2) {
      var h = t2.getMapType();
      if (!(t2.getHostGeoModel() || i[h])) {
        var v4 = {};
        Qe2(t2.seriesGroup, function(M2) {
          var I2 = M2.coordinateSystem, P2 = M2.originalData;
          M2.get("showLegendSymbol") && f2.getComponent("legend") && P2.each(P2.mapDimension("value"), function(N3, z3) {
            var H2 = P2.getName(z3), $ = I2.getRegion(H2);
            if (!(!$ || isNaN(N3))) {
              var et = v4[H2] || 0, at = I2.dataToPoint($.getCenter());
              v4[H2] = et + 1, P2.setItemLayout(z3, { point: at, offset: et });
            }
          });
        });
        var _ = t2.getData();
        _.each(function(M2) {
          var I2 = _.getName(M2), P2 = _.getItemLayout(M2) || {};
          P2.showLabel = !v4[I2], _.setItemLayout(M2, P2);
        }), i[h] = true;
      }
    });
  }
  var c9e = Wx, W1r = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this) || this;
      return h.type = "view", h.dimensions = ["x", "y"], h._roamTransformable = new G6(), h._rawTransformable = new G6(), h.name = t2, h;
    }
    return i.prototype.setBoundingRect = function(t2, h, v4, _) {
      return this._rect = new Lc2(t2, h, v4, _), this._rect;
    }, i.prototype.getBoundingRect = function() {
      return this._rect;
    }, i.prototype.setViewRect = function(t2, h, v4, _) {
      this._transformTo(t2, h, v4, _), this._viewRect = new Lc2(t2, h, v4, _);
    }, i.prototype._transformTo = function(t2, h, v4, _) {
      var M2 = this.getBoundingRect(), I2 = this._rawTransformable;
      I2.transform = M2.calculateTransform(new Lc2(t2, h, v4, _));
      var P2 = I2.parent;
      I2.parent = null, I2.decomposeTransform(), I2.parent = P2, this._updateTransform();
    }, i.prototype.setCenter = function(t2) {
      !t2 || (this._center = t2, this._updateCenterAndZoom());
    }, i.prototype.setZoom = function(t2) {
      t2 = t2 || 1;
      var h = this.zoomLimit;
      h && (h.max != null && (t2 = Math.min(h.max, t2)), h.min != null && (t2 = Math.max(h.min, t2))), this._zoom = t2, this._updateCenterAndZoom();
    }, i.prototype.getDefaultCenter = function() {
      var t2 = this.getBoundingRect(), h = t2.x + t2.width / 2, v4 = t2.y + t2.height / 2;
      return [h, v4];
    }, i.prototype.getCenter = function() {
      return this._center || this.getDefaultCenter();
    }, i.prototype.getZoom = function() {
      return this._zoom || 1;
    }, i.prototype.getRoamTransform = function() {
      return this._roamTransformable.getLocalTransform();
    }, i.prototype._updateCenterAndZoom = function() {
      var t2 = this._rawTransformable.getLocalTransform(), h = this._roamTransformable, v4 = this.getDefaultCenter(), _ = this.getCenter(), M2 = this.getZoom();
      _ = Wx([], _, t2), v4 = Wx([], v4, t2), h.originX = _[0], h.originY = _[1], h.x = v4[0] - _[0], h.y = v4[1] - _[1], h.scaleX = h.scaleY = M2, this._updateTransform();
    }, i.prototype._updateTransform = function() {
      var t2 = this._roamTransformable, h = this._rawTransformable;
      h.parent = t2, t2.updateTransform(), h.updateTransform(), Tee(this.transform || (this.transform = []), h.transform || nE()), this._rawTransform = h.getLocalTransform(), this.invTransform = this.invTransform || [], Xtt(this.invTransform, this.transform), this.decomposeTransform();
    }, i.prototype.getTransformInfo = function() {
      var t2 = this._rawTransformable, h = this._roamTransformable, v4 = new G6();
      return v4.transform = h.transform, v4.decomposeTransform(), { roam: { x: v4.x, y: v4.y, scaleX: v4.scaleX, scaleY: v4.scaleY }, raw: { x: t2.x, y: t2.y, scaleX: t2.scaleX, scaleY: t2.scaleY } };
    }, i.prototype.getViewRect = function() {
      return this._viewRect;
    }, i.prototype.getViewRectAfterRoam = function() {
      var t2 = this.getBoundingRect().clone();
      return t2.applyTransform(this.transform), t2;
    }, i.prototype.dataToPoint = function(t2, h, v4) {
      var _ = h ? this._rawTransform : this.transform;
      return v4 = v4 || [], _ ? c9e(v4, t2, _) : N2(v4, t2);
    }, i.prototype.pointToData = function(t2) {
      var h = this.invTransform;
      return h ? c9e([], t2, h) : [t2[0], t2[1]];
    }, i.prototype.convertToPixel = function(t2, h, v4) {
      var _ = f9e(h);
      return _ === this ? _.dataToPoint(v4) : null;
    }, i.prototype.convertFromPixel = function(t2, h, v4) {
      var _ = f9e(h);
      return _ === this ? _.pointToData(v4) : null;
    }, i.prototype.containPoint = function(t2) {
      return this.getViewRectAfterRoam().contain(t2[0], t2[1]);
    }, i.dimensions = ["x", "y"], i;
  }(G6);
  function f9e(f2) {
    var i = f2.seriesModel;
    return i ? i.coordinateSystem : null;
  }
  var Hgt = W1r, G1r = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, HHe = ["lng", "lat"], UHe = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this, t2) || this;
      _.dimensions = HHe, _.type = "geo", _._nameCoordMap = Il(), _.map = h;
      var M2 = v4.projection, I2 = rN.load(h, v4.nameMap, v4.nameProperty), P2 = rN.getGeoResource(h);
      _.resourceType = P2 ? P2.type : null;
      var N3 = _.regions = I2.regions, z3 = G1r[P2.type];
      _._regionsMap = I2.regionsMap, _.regions = I2.regions, _.projection = M2;
      var H2;
      if (M2)
        for (var $ = 0; $ < N3.length; $++) {
          var et = N3[$].getBoundingRect(M2);
          H2 = H2 || et.clone(), H2.union(et);
        }
      else
        H2 = I2.boundingRect;
      return _.setBoundingRect(H2.x, H2.y, H2.width, H2.height), _.aspectScale = M2 ? 1 : _c2(v4.aspectScale, z3.aspectScale), _._invertLongitute = M2 ? false : z3.invertLongitute, _;
    }
    return i.prototype._transformTo = function(t2, h, v4, _) {
      var M2 = this.getBoundingRect(), I2 = this._invertLongitute;
      M2 = M2.clone(), I2 && (M2.y = -M2.y - M2.height);
      var P2 = this._rawTransformable;
      P2.transform = M2.calculateTransform(new Lc2(t2, h, v4, _));
      var N3 = P2.parent;
      P2.parent = null, P2.decomposeTransform(), P2.parent = N3, I2 && (P2.scaleY = -P2.scaleY), this._updateTransform();
    }, i.prototype.getRegion = function(t2) {
      return this._regionsMap.get(t2);
    }, i.prototype.getRegionByCoord = function(t2) {
      for (var h = this.regions, v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4];
        if (_.type === "geoJSON" && _.contain(t2))
          return h[v4];
      }
    }, i.prototype.addGeoCoord = function(t2, h) {
      this._nameCoordMap.set(t2, h);
    }, i.prototype.getGeoCoord = function(t2) {
      var h = this._regionsMap.get(t2);
      return this._nameCoordMap.get(t2) || h && h.getCenter();
    }, i.prototype.dataToPoint = function(t2, h, v4) {
      if (ms(t2) && (t2 = this.getGeoCoord(t2)), t2) {
        var _ = this.projection;
        return _ && (t2 = _.project(t2)), t2 && this.projectedToPoint(t2);
      }
    }, i.prototype.pointToData = function(t2) {
      var h = this.projection;
      return h && (t2 = h.unproject(t2)), t2 && this.pointToProjected(t2);
    }, i.prototype.pointToProjected = function(t2) {
      return f2.prototype.pointToData.call(this, t2);
    }, i.prototype.projectedToPoint = function(t2, h, v4) {
      return f2.prototype.dataToPoint.call(this, t2, h, v4);
    }, i.prototype.convertToPixel = function(t2, h, v4) {
      var _ = h9e(h);
      return _ === this ? _.dataToPoint(v4) : null;
    }, i.prototype.convertFromPixel = function(t2, h, v4) {
      var _ = h9e(h);
      return _ === this ? _.pointToData(v4) : null;
    }, i;
  }(Hgt);
  Sm(UHe, Hgt);
  function h9e(f2) {
    var i = f2.geoModel, t2 = f2.seriesModel;
    return i ? i.coordinateSystem : t2 ? t2.coordinateSystem || (t2.getReferringComponents("geo", _m).models[0] || {}).coordinateSystem : null;
  }
  var p9e = UHe;
  function d9e(f2, i) {
    var t2 = f2.get("boundingCoords");
    if (t2 != null) {
      var h = t2[0], v4 = t2[1];
      if (isFinite(h[0]) && isFinite(h[1]) && isFinite(v4[0]) && isFinite(v4[1])) {
        var _ = this.projection;
        if (_) {
          var M2 = h[0], I2 = h[1], P2 = v4[0], N3 = v4[1];
          h = [1 / 0, 1 / 0], v4 = [-1 / 0, -1 / 0];
          var z3 = function(re2, ye, me2, be2) {
            for (var Te2 = me2 - re2, We = be2 - ye, en = 0; en <= 100; en++) {
              var Ue2 = en / 100, Mn = _.project([re2 + Te2 * Ue2, ye + We * Ue2]);
              N7(h, h, Mn), F7(v4, v4, Mn);
            }
          };
          z3(M2, I2, P2, I2), z3(P2, I2, P2, N3), z3(P2, N3, M2, N3), z3(M2, N3, P2, I2);
        }
        this.setBoundingRect(h[0], h[1], v4[0] - h[0], v4[1] - h[1]);
      }
    }
    var H2 = this.getBoundingRect(), $ = f2.get("layoutCenter"), et = f2.get("layoutSize"), at = i.getWidth(), ht = i.getHeight(), bt = H2.width / H2.height * this.aspectScale, _t = false, Et, zt;
    $ && et && (Et = [cs($[0], at), cs($[1], ht)], zt = cs(et, Math.min(at, ht)), !isNaN(Et[0]) && !isNaN(Et[1]) && !isNaN(zt) && (_t = true));
    var Ft;
    if (_t)
      Ft = {}, bt > 1 ? (Ft.width = zt, Ft.height = zt / bt) : (Ft.height = zt, Ft.width = zt * bt), Ft.y = Et[1] - Ft.height / 2, Ft.x = Et[0] - Ft.width / 2;
    else {
      var fe2 = f2.getBoxLayoutParams();
      fe2.aspect = bt, Ft = u1(fe2, { width: at, height: ht });
    }
    this.setViewRect(Ft.x, Ft.y, Ft.width, Ft.height), this.setCenter(f2.get("center")), this.setZoom(f2.get("zoom"));
  }
  function H1r(f2, i) {
    Qe2(i.get("geoCoord"), function(t2, h) {
      f2.addGeoCoord(h, t2);
    });
  }
  var U1r = function() {
    function f2() {
      this.dimensions = HHe;
    }
    return f2.prototype.create = function(i, t2) {
      var h = [];
      function v4(M2) {
        return { nameProperty: M2.get("nameProperty"), aspectScale: M2.get("aspectScale"), projection: M2.get("projection") };
      }
      i.eachComponent("geo", function(M2, I2) {
        var P2 = M2.get("map"), N3 = new p9e(P2 + I2, P2, ba2({ nameMap: M2.get("nameMap") }, v4(M2)));
        N3.zoomLimit = M2.get("scaleLimit"), h.push(N3), M2.coordinateSystem = N3, N3.model = M2, N3.resize = d9e, N3.resize(M2, t2);
      }), i.eachSeries(function(M2) {
        var I2 = M2.get("coordinateSystem");
        if (I2 === "geo") {
          var P2 = M2.get("geoIndex") || 0;
          M2.coordinateSystem = h[P2];
        }
      });
      var _ = {};
      return i.eachSeriesByType("map", function(M2) {
        if (!M2.getHostGeoModel()) {
          var I2 = M2.getMapType();
          _[I2] = _[I2] || [], _[I2].push(M2);
        }
      }), Qe2(_, function(M2, I2) {
        var P2 = Xa2(M2, function(z3) {
          return z3.get("nameMap");
        }), N3 = new p9e(I2, I2, ba2({ nameMap: _ee(P2) }, v4(M2[0])));
        N3.zoomLimit = y_.apply(null, Xa2(M2, function(z3) {
          return z3.get("scaleLimit");
        })), h.push(N3), N3.resize = d9e, N3.resize(M2[0], t2), Qe2(M2, function(z3) {
          z3.coordinateSystem = N3, H1r(N3, z3);
        });
      }), h;
    }, f2.prototype.getFilledRegions = function(i, t2, h, v4) {
      for (var _ = (i || []).slice(), M2 = Il(), I2 = 0; I2 < _.length; I2++)
        M2.set(_[I2].name, _[I2]);
      var P2 = rN.load(t2, h, v4);
      return Qe2(P2.regions, function(N3) {
        var z3 = N3.name;
        !M2.get(z3) && _.push({ name: z3 });
      }), _;
    }, f2;
  }(), q1r = new U1r(), qHe = q1r, Z1r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      var _ = rN.getGeoResource(t2.map);
      if (_ && _.type === "geoJSON") {
        var M2 = t2.itemStyle = t2.itemStyle || {};
        "color" in M2 || (M2.color = "#eee");
      }
      this.mergeDefaultAndTheme(t2, v4), gU(t2, "label", ["show"]);
    }, i.prototype.optionUpdated = function() {
      var t2 = this, h = this.option;
      h.regions = qHe.getFilledRegions(h.regions, h.map, h.nameMap, h.nameProperty);
      var v4 = {};
      this._optionModelMap = zL(h.regions || [], function(_, M2) {
        var I2 = M2.name;
        return I2 && (_.set(I2, new Gg2(M2, t2, t2.ecModel)), M2.selected && (v4[I2] = true)), _;
      }, Il()), h.selectedMap || (h.selectedMap = v4);
    }, i.prototype.getRegionModel = function(t2) {
      return this._optionModelMap.get(t2) || new Gg2(null, this, this.ecModel);
    }, i.prototype.getFormattedLabel = function(t2, h) {
      var v4 = this.getRegionModel(t2), _ = h === "normal" ? v4.get(["label", "formatter"]) : v4.get(["emphasis", "label", "formatter"]), M2 = { name: t2 };
      if (Ol(_))
        return M2.status = h, _(M2);
      if (ms(_))
        return _.replace("{a}", t2 != null ? t2 : "");
    }, i.prototype.setZoom = function(t2) {
      this.option.zoom = t2;
    }, i.prototype.setCenter = function(t2) {
      this.option.center = t2;
    }, i.prototype.select = function(t2) {
      var h = this.option, v4 = h.selectedMode;
      if (!!v4) {
        v4 !== "multiple" && (h.selectedMap = null);
        var _ = h.selectedMap || (h.selectedMap = {});
        _[t2] = true;
      }
    }, i.prototype.unSelect = function(t2) {
      var h = this.option.selectedMap;
      h && (h[t2] = false);
    }, i.prototype.toggleSelected = function(t2) {
      this[this.isSelected(t2) ? "unSelect" : "select"](t2);
    }, i.prototype.isSelected = function(t2) {
      var h = this.option.selectedMap;
      return !!(h && h[t2]);
    }, i.type = "geo", i.layoutMode = "box", i.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, i;
  }(zh2), $1r = Z1r;
  function g9e(f2, i) {
    return f2.pointToProjected ? f2.pointToProjected(i) : f2.pointToData(i);
  }
  function Pne(f2, i, t2) {
    var h = f2.getZoom(), v4 = f2.getCenter(), _ = i.zoom, M2 = f2.projectedToPoint ? f2.projectedToPoint(v4) : f2.dataToPoint(v4);
    if (i.dx != null && i.dy != null && (M2[0] -= i.dx, M2[1] -= i.dy, f2.setCenter(g9e(f2, M2))), _ != null) {
      if (t2) {
        var I2 = t2.min || 0, P2 = t2.max || 1 / 0;
        _ = Math.max(Math.min(h * _, P2), I2) / h;
      }
      f2.scaleX *= _, f2.scaleY *= _;
      var N3 = (i.originX - f2.x) * (_ - 1), z3 = (i.originY - f2.y) * (_ - 1);
      f2.x -= N3, f2.y -= z3, f2.updateTransform(), f2.setCenter(g9e(f2, M2)), f2.setZoom(_ * h);
    }
    return { center: f2.getCenter(), zoom: f2.getZoom() };
  }
  var Y1r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.focusBlurEnabled = true, t2;
    }
    return i.prototype.init = function(t2, h) {
      this._api = h;
    }, i.prototype.render = function(t2, h, v4, _) {
      if (this._model = t2, !t2.get("show")) {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
        return;
      }
      this._mapDraw || (this._mapDraw = new GHe(v4));
      var M2 = this._mapDraw;
      M2.draw(t2, h, v4, this, _), M2.group.on("click", this._handleRegionClick, this), M2.group.silent = t2.get("silent"), this.group.add(M2.group), this.updateSelectStatus(t2, h, v4);
    }, i.prototype._handleRegionClick = function(t2) {
      var h;
      Itt(t2.target, function(v4) {
        return (h = Du(v4).eventData) != null;
      }, true), h && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: h.name });
    }, i.prototype.updateSelectStatus = function(t2, h, v4) {
      var _ = this;
      this._mapDraw.group.traverse(function(M2) {
        var I2 = Du(M2).eventData;
        if (I2)
          return _._model.isSelected(I2.name) ? v4.enterSelect(M2) : v4.leaveSelect(M2), true;
      });
    }, i.prototype.findHighDownDispatchers = function(t2) {
      return this._mapDraw && this._mapDraw.findHighDownDispatchers(t2, this._model);
    }, i.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove();
    }, i.type = "geo", i;
  }(W0), K1r = Y1r;
  function X1r(f2, i, t2) {
    rN.registerMap(f2, i, t2);
  }
  function ZHe(f2) {
    f2.registerCoordinateSystem("geo", qHe), f2.registerComponentModel($1r), f2.registerComponentView(K1r), f2.registerImpl("registerMap", X1r), f2.registerImpl("getMap", function(t2) {
      return rN.getMapForUser(t2);
    });
    function i(t2, h) {
      h.update = "geo:updateSelectStatus", f2.registerAction(h, function(v4, _) {
        var M2 = {}, I2 = [];
        return _.eachComponent({ mainType: "geo", query: v4 }, function(P2) {
          P2[t2](v4.name);
          var N3 = P2.coordinateSystem;
          Qe2(N3.regions, function(H2) {
            M2[H2.name] = P2.isSelected(H2.name) || false;
          });
          var z3 = [];
          Qe2(M2, function(H2, $) {
            M2[$] && z3.push($);
          }), I2.push({ geoIndex: P2.componentIndex, name: z3 });
        }), { selected: M2, allSelected: I2, name: v4.name };
      });
    }
    i("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), i("select", { type: "geoSelect", event: "geoselected" }), i("unSelect", { type: "geoUnSelect", event: "geounselected" }), f2.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(t2, h) {
      var v4 = t2.componentType || "series";
      h.eachComponent({ mainType: v4, query: t2 }, function(_) {
        var M2 = _.coordinateSystem;
        if (M2.type === "geo") {
          var I2 = Pne(M2, t2, _.get("scaleLimit"));
          _.setCenter && _.setCenter(I2.center), _.setZoom && _.setZoom(I2.zoom), v4 === "series" && Qe2(_.seriesGroup, function(P2) {
            P2.setCenter(I2.center), P2.setZoom(I2.zoom);
          });
        }
      });
    });
  }
  function Q1r(f2) {
    zc2(ZHe), f2.registerChartView(N1r), f2.registerSeriesModel(V1r), f2.registerLayout(j1r), f2.registerProcessor(f2.PRIORITY.PROCESSOR.STATISTIC, z1r), ZWe("map", f2.registerAction);
  }
  function J1r(f2) {
    var i = f2;
    i.hierNode = { defaultAncestor: null, ancestor: i, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
    for (var t2 = [i], h, v4; h = t2.pop(); )
      if (v4 = h.children, h.isExpand && v4.length)
        for (var _ = v4.length, M2 = _ - 1; M2 >= 0; M2--) {
          var I2 = v4[M2];
          I2.hierNode = { defaultAncestor: null, ancestor: I2, prelim: 0, modifier: 0, change: 0, shift: 0, i: M2, thread: null }, t2.push(I2);
        }
  }
  function tbr(f2, i) {
    var t2 = f2.isExpand ? f2.children : [], h = f2.parentNode.children, v4 = f2.hierNode.i ? h[f2.hierNode.i - 1] : null;
    if (t2.length) {
      rbr(f2);
      var _ = (t2[0].hierNode.prelim + t2[t2.length - 1].hierNode.prelim) / 2;
      v4 ? (f2.hierNode.prelim = v4.hierNode.prelim + i(f2, v4), f2.hierNode.modifier = f2.hierNode.prelim - _) : f2.hierNode.prelim = _;
    } else
      v4 && (f2.hierNode.prelim = v4.hierNode.prelim + i(f2, v4));
    f2.parentNode.hierNode.defaultAncestor = ibr(f2, v4, f2.parentNode.hierNode.defaultAncestor || h[0], i);
  }
  function ebr(f2) {
    var i = f2.hierNode.prelim + f2.parentNode.hierNode.modifier;
    f2.setLayout({ x: i }, true), f2.hierNode.modifier += f2.parentNode.hierNode.modifier;
  }
  function v9e(f2) {
    return arguments.length ? f2 : sbr;
  }
  function wdt(f2, i) {
    return f2 -= Math.PI / 2, { x: i * Math.cos(f2), y: i * Math.sin(f2) };
  }
  function nbr(f2, i) {
    return u1(f2.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
  }
  function rbr(f2) {
    for (var i = f2.children, t2 = i.length, h = 0, v4 = 0; --t2 >= 0; ) {
      var _ = i[t2];
      _.hierNode.prelim += h, _.hierNode.modifier += h, v4 += _.hierNode.change, h += _.hierNode.shift + v4;
    }
  }
  function ibr(f2, i, t2, h) {
    if (i) {
      for (var v4 = f2, _ = f2, M2 = _.parentNode.children[0], I2 = i, P2 = v4.hierNode.modifier, N3 = _.hierNode.modifier, z3 = M2.hierNode.modifier, H2 = I2.hierNode.modifier; I2 = rQt(I2), _ = iQt(_), I2 && _; ) {
        v4 = rQt(v4), M2 = iQt(M2), v4.hierNode.ancestor = f2;
        var $ = I2.hierNode.prelim + H2 - _.hierNode.prelim - N3 + h(I2, _);
        $ > 0 && (obr(abr(I2, f2, t2), f2, $), N3 += $, P2 += $), H2 += I2.hierNode.modifier, N3 += _.hierNode.modifier, P2 += v4.hierNode.modifier, z3 += M2.hierNode.modifier;
      }
      I2 && !rQt(v4) && (v4.hierNode.thread = I2, v4.hierNode.modifier += H2 - P2), _ && !iQt(M2) && (M2.hierNode.thread = _, M2.hierNode.modifier += N3 - z3, t2 = f2);
    }
    return t2;
  }
  function rQt(f2) {
    var i = f2.children;
    return i.length && f2.isExpand ? i[i.length - 1] : f2.hierNode.thread;
  }
  function iQt(f2) {
    var i = f2.children;
    return i.length && f2.isExpand ? i[0] : f2.hierNode.thread;
  }
  function abr(f2, i, t2) {
    return f2.hierNode.ancestor.parentNode === i.parentNode ? f2.hierNode.ancestor : t2;
  }
  function obr(f2, i, t2) {
    var h = t2 / (i.hierNode.i - f2.hierNode.i);
    i.hierNode.change -= h, i.hierNode.shift += t2, i.hierNode.modifier += t2, i.hierNode.prelim += t2, f2.hierNode.change += h;
  }
  function sbr(f2, i) {
    return f2.parentNode === i.parentNode ? 1 : 2;
  }
  var lbr = function() {
    function f2() {
      this.parentPoint = [], this.childPoints = [];
    }
    return f2;
  }(), ubr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new lbr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.childPoints, _ = v4.length, M2 = h.parentPoint, I2 = v4[0], P2 = v4[_ - 1];
      if (_ === 1) {
        t2.moveTo(M2[0], M2[1]), t2.lineTo(I2[0], I2[1]);
        return;
      }
      var N3 = h.orient, z3 = N3 === "TB" || N3 === "BT" ? 0 : 1, H2 = 1 - z3, $ = cs(h.forkPosition, 1), et = [];
      et[z3] = M2[z3], et[H2] = M2[H2] + (P2[H2] - M2[H2]) * $, t2.moveTo(M2[0], M2[1]), t2.lineTo(et[0], et[1]), t2.moveTo(I2[0], I2[1]), et[z3] = I2[z3], t2.lineTo(et[0], et[1]), et[z3] = P2[z3], t2.lineTo(et[0], et[1]), t2.lineTo(P2[0], P2[1]);
      for (var at = 1; at < _ - 1; at++) {
        var ht = v4[at];
        t2.moveTo(ht[0], ht[1]), et[z3] = ht[z3], t2.lineTo(et[0], et[1]);
      }
    }, i;
  }(Uc2), cbr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._mainGroup = new mu(), t2;
    }
    return i.prototype.init = function(t2, h) {
      this._controller = new Ggt(h.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
    }, i.prototype.render = function(t2, h, v4) {
      var _ = t2.getData(), M2 = t2.layoutInfo, I2 = this._mainGroup, P2 = t2.get("layout");
      P2 === "radial" ? (I2.x = M2.x + M2.width / 2, I2.y = M2.y + M2.height / 2) : (I2.x = M2.x, I2.y = M2.y), this._updateViewCoordSys(t2), this._updateController(t2, h, v4);
      var N3 = this._data;
      _.diff(N3).add(function(z3) {
        y9e(_, z3) && m9e(_, z3, null, I2, t2);
      }).update(function(z3, H2) {
        var $ = N3.getItemGraphicEl(H2);
        if (!y9e(_, z3)) {
          $ && _9e(N3, H2, $, I2, t2);
          return;
        }
        m9e(_, z3, $, I2, t2);
      }).remove(function(z3) {
        var H2 = N3.getItemGraphicEl(z3);
        H2 && _9e(N3, z3, H2, I2, t2);
      }).execute(), this._nodeScaleRatio = t2.get("nodeScaleRatio"), this._updateNodeAndLinkScale(t2), t2.get("expandAndCollapse") === true && _.eachItemGraphicEl(function(z3, H2) {
        z3.off("click").on("click", function() {
          v4.dispatchAction({ type: "treeExpandAndCollapse", seriesId: t2.id, dataIndex: H2 });
        });
      }), this._data = _;
    }, i.prototype._updateViewCoordSys = function(t2) {
      var h = t2.getData(), v4 = [];
      h.each(function(z3) {
        var H2 = h.getItemLayout(z3);
        H2 && !isNaN(H2.x) && !isNaN(H2.y) && v4.push([+H2.x, +H2.y]);
      });
      var _ = [], M2 = [];
      dkt(v4, _, M2);
      var I2 = this._min, P2 = this._max;
      M2[0] - _[0] === 0 && (_[0] = I2 ? I2[0] : _[0] - 1, M2[0] = P2 ? P2[0] : M2[0] + 1), M2[1] - _[1] === 0 && (_[1] = I2 ? I2[1] : _[1] - 1, M2[1] = P2 ? P2[1] : M2[1] + 1);
      var N3 = t2.coordinateSystem = new Hgt();
      N3.zoomLimit = t2.get("scaleLimit"), N3.setBoundingRect(_[0], _[1], M2[0] - _[0], M2[1] - _[1]), N3.setCenter(t2.get("center")), N3.setZoom(t2.get("zoom")), this.group.attr({ x: N3.x, y: N3.y, scaleX: N3.scaleX, scaleY: N3.scaleY }), this._min = _, this._max = M2;
    }, i.prototype._updateController = function(t2, h, v4) {
      var _ = this, M2 = this._controller, I2 = this._controllerHost, P2 = this.group;
      M2.setPointerChecker(function(N3, z3, H2) {
        var $ = P2.getBoundingRect();
        return $.applyTransform(P2.transform), $.contain(z3, H2) && !Vkt(N3, v4, t2);
      }), M2.enable(t2.get("roam")), I2.zoomLimit = t2.get("scaleLimit"), I2.zoom = t2.coordinateSystem.getZoom(), M2.off("pan").off("zoom").on("pan", function(N3) {
        Dne(I2, N3.dx, N3.dy), v4.dispatchAction({ seriesId: t2.id, type: "treeRoam", dx: N3.dx, dy: N3.dy });
      }).on("zoom", function(N3) {
        Ene(I2, N3.scale, N3.originX, N3.originY), v4.dispatchAction({ seriesId: t2.id, type: "treeRoam", zoom: N3.scale, originX: N3.originX, originY: N3.originY }), _._updateNodeAndLinkScale(t2), v4.updateLabelLayout();
      });
    }, i.prototype._updateNodeAndLinkScale = function(t2) {
      var h = t2.getData(), v4 = this._getNodeGlobalScale(t2);
      h.eachItemGraphicEl(function(_, M2) {
        _.setSymbolScale(v4);
      });
    }, i.prototype._getNodeGlobalScale = function(t2) {
      var h = t2.coordinateSystem;
      if (h.type !== "view")
        return 1;
      var v4 = this._nodeScaleRatio, _ = h.scaleX || 1, M2 = h.getZoom(), I2 = (M2 - 1) * v4 + 1;
      return I2 / _;
    }, i.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, i.prototype.remove = function() {
      this._mainGroup.removeAll(), this._data = null;
    }, i.type = "tree", i;
  }(Hg2);
  function y9e(f2, i) {
    var t2 = f2.getItemLayout(i);
    return t2 && !isNaN(t2.x) && !isNaN(t2.y);
  }
  function m9e(f2, i, t2, h, v4) {
    var _ = !t2, M2 = f2.tree.getNodeByDataIndex(i), I2 = M2.getModel(), P2 = M2.getVisual("style").fill, N3 = M2.isExpand === false && M2.children.length !== 0 ? P2 : "#fff", z3 = f2.tree.root, H2 = M2.parentNode === z3 ? M2 : M2.parentNode || M2, $ = f2.getItemGraphicEl(H2.dataIndex), et = H2.getLayout(), at = $ ? { x: $.__oldX, y: $.__oldY, rawX: $.__radialOldRawX, rawY: $.__radialOldRawY } : et, ht = M2.getLayout();
    _ ? (t2 = new Vgt(f2, i, null, { symbolInnerColor: N3, useNameLabel: true }), t2.x = at.x, t2.y = at.y) : t2.updateData(f2, i, null, { symbolInnerColor: N3, useNameLabel: true }), t2.__radialOldRawX = t2.__radialRawX, t2.__radialOldRawY = t2.__radialRawY, t2.__radialRawX = ht.rawX, t2.__radialRawY = ht.rawY, h.add(t2), f2.setItemGraphicEl(i, t2), t2.__oldX = t2.x, t2.__oldY = t2.y, jh2(t2, { x: ht.x, y: ht.y }, v4);
    var bt = t2.getSymbolPath();
    if (v4.get("layout") === "radial") {
      var _t = z3.children[0], Et = _t.getLayout(), zt = _t.children.length, Ft = void 0, fe2 = void 0;
      if (ht.x === Et.x && M2.isExpand === true) {
        var re2 = { x: (_t.children[0].getLayout().x + _t.children[zt - 1].getLayout().x) / 2, y: (_t.children[0].getLayout().y + _t.children[zt - 1].getLayout().y) / 2 };
        Ft = Math.atan2(re2.y - Et.y, re2.x - Et.x), Ft < 0 && (Ft = Math.PI * 2 + Ft), fe2 = re2.x < Et.x, fe2 && (Ft = Ft - Math.PI);
      } else
        Ft = Math.atan2(ht.y - Et.y, ht.x - Et.x), Ft < 0 && (Ft = Math.PI * 2 + Ft), M2.children.length === 0 || M2.children.length !== 0 && M2.isExpand === false ? (fe2 = ht.x < Et.x, fe2 && (Ft = Ft - Math.PI)) : (fe2 = ht.x > Et.x, fe2 || (Ft = Ft - Math.PI));
      var ye = fe2 ? "left" : "right", me2 = I2.getModel("label"), be2 = me2.get("rotate"), Te2 = be2 * (Math.PI / 180), We = bt.getTextContent();
      We && (bt.setTextConfig({ position: me2.get("position") || ye, rotation: be2 == null ? -Ft : Te2, origin: "center" }), We.setStyle("verticalAlign", "middle"));
    }
    var en = I2.get(["emphasis", "focus"]), Ue2 = en === "ancestor" ? M2.getAncestorsIndices() : en === "descendant" ? M2.getDescendantIndices() : null;
    Ue2 && (Du(t2).focus = Ue2), fbr(v4, M2, z3, t2, at, et, ht, h), t2.__edge && (t2.onHoverStateChange = function(Mn) {
      if (Mn !== "blur") {
        var Vn = M2.parentNode && f2.getItemGraphicEl(M2.parentNode.dataIndex);
        Vn && Vn.hoverState === Agt || vEt(t2.__edge, Mn);
      }
    });
  }
  function fbr(f2, i, t2, h, v4, _, M2, I2) {
    var P2 = i.getModel(), N3 = f2.get("edgeShape"), z3 = f2.get("layout"), H2 = f2.getOrient(), $ = f2.get(["lineStyle", "curveness"]), et = f2.get("edgeForkPosition"), at = P2.getModel("lineStyle").getLineStyle(), ht = h.__edge;
    if (N3 === "curve")
      i.parentNode && i.parentNode !== t2 && (ht || (ht = h.__edge = new mkt({ shape: xte(z3, H2, $, v4, v4) })), jh2(ht, { shape: xte(z3, H2, $, _, M2) }, f2));
    else if (N3 === "polyline" && z3 === "orthogonal" && i !== t2 && i.children && i.children.length !== 0 && i.isExpand === true) {
      for (var bt = i.children, _t = [], Et = 0; Et < bt.length; Et++) {
        var zt = bt[Et].getLayout();
        _t.push([zt.x, zt.y]);
      }
      ht || (ht = h.__edge = new ubr({ shape: { parentPoint: [M2.x, M2.y], childPoints: [[M2.x, M2.y]], orient: H2, forkPosition: et } })), jh2(ht, { shape: { parentPoint: [M2.x, M2.y], childPoints: _t } }, f2);
    }
    ht && (ht.useStyle(Ul({ strokeNoScale: true, fill: null }, at)), Hx(ht, P2, "lineStyle"), mU(ht), I2.add(ht));
  }
  function b9e(f2, i, t2, h, v4) {
    var _ = i.tree.root, M2 = $He(_, f2), I2 = M2.source, P2 = M2.sourceLayout, N3 = i.getItemGraphicEl(f2.dataIndex);
    if (!!N3) {
      var z3 = i.getItemGraphicEl(I2.dataIndex), H2 = z3.__edge, $ = N3.__edge || (I2.isExpand === false || I2.children.length === 1 ? H2 : void 0), et = h.get("edgeShape"), at = h.get("layout"), ht = h.get("orient"), bt = h.get(["lineStyle", "curveness"]);
      $ && (et === "curve" ? Q7($, { shape: xte(at, ht, bt, P2, P2), style: { opacity: 0 } }, h, { cb: function() {
        t2.remove($);
      }, removeOpt: v4 }) : et === "polyline" && h.get("layout") === "orthogonal" && Q7($, { shape: { parentPoint: [P2.x, P2.y], childPoints: [[P2.x, P2.y]] }, style: { opacity: 0 } }, h, { cb: function() {
        t2.remove($);
      }, removeOpt: v4 }));
    }
  }
  function $He(f2, i) {
    for (var t2 = i.parentNode === f2 ? i : i.parentNode || i, h; h = t2.getLayout(), h == null; )
      t2 = t2.parentNode === f2 ? t2 : t2.parentNode || t2;
    return { source: t2, sourceLayout: h };
  }
  function _9e(f2, i, t2, h, v4) {
    var _ = f2.tree.getNodeByDataIndex(i), M2 = f2.tree.root, I2 = $He(M2, _).sourceLayout, P2 = { duration: v4.get("animationDurationUpdate"), easing: v4.get("animationEasingUpdate") };
    Q7(t2, { x: I2.x + 1, y: I2.y + 1 }, v4, { cb: function() {
      h.remove(t2), f2.setItemGraphicEl(i, null);
    }, removeOpt: P2 }), t2.fadeOut(null, f2.hostModel, { fadeLabel: true, animation: P2 }), _.children.forEach(function(N3) {
      b9e(N3, f2, h, v4, P2);
    }), b9e(_, f2, h, v4, P2);
  }
  function xte(f2, i, t2, h, v4) {
    var _, M2, I2, P2, N3, z3, H2, $;
    if (f2 === "radial") {
      N3 = h.rawX, H2 = h.rawY, z3 = v4.rawX, $ = v4.rawY;
      var et = wdt(N3, H2), at = wdt(N3, H2 + ($ - H2) * t2), ht = wdt(z3, $ + (H2 - $) * t2), bt = wdt(z3, $);
      return { x1: et.x || 0, y1: et.y || 0, x2: bt.x || 0, y2: bt.y || 0, cpx1: at.x || 0, cpy1: at.y || 0, cpx2: ht.x || 0, cpy2: ht.y || 0 };
    } else
      N3 = h.x, H2 = h.y, z3 = v4.x, $ = v4.y, (i === "LR" || i === "RL") && (_ = N3 + (z3 - N3) * t2, M2 = H2, I2 = z3 + (N3 - z3) * t2, P2 = $), (i === "TB" || i === "BT") && (_ = N3, M2 = H2 + ($ - H2) * t2, I2 = z3, P2 = $ + (H2 - $) * t2);
    return { x1: N3, y1: H2, x2: z3, y2: $, cpx1: _, cpy1: M2, cpx2: I2, cpy2: P2 };
  }
  var hbr = cbr, JD = Wh2();
  function YHe(f2) {
    var i = f2.mainData, t2 = f2.datas;
    t2 || (t2 = { main: i }, f2.datasAttr = { main: "data" }), f2.datas = f2.mainData = null, KHe(i, t2, f2), Qe2(t2, function(h) {
      Qe2(i.TRANSFERABLE_METHODS, function(v4) {
        h.wrapMethod(v4, Ou(pbr, f2));
      });
    }), i.wrapMethod("cloneShallow", Ou(gbr, f2)), Qe2(i.CHANGABLE_METHODS, function(h) {
      i.wrapMethod(h, Ou(dbr, f2));
    }), z2(t2[i.dataType] === i);
  }
  function pbr(f2, i) {
    if (mbr(this)) {
      var t2 = ba2({}, JD(this).datas);
      t2[this.dataType] = i, KHe(i, t2, f2);
    } else
      Lne(i, this.dataType, JD(this).mainData, f2);
    return i;
  }
  function dbr(f2, i) {
    return f2.struct && f2.struct.update(), i;
  }
  function gbr(f2, i) {
    return Qe2(JD(i).datas, function(t2, h) {
      t2 !== i && Lne(t2.cloneShallow(), h, i, f2);
    }), i;
  }
  function vbr(f2) {
    var i = JD(this).mainData;
    return f2 == null || i == null ? i : JD(i).datas[f2];
  }
  function ybr() {
    var f2 = JD(this).mainData;
    return f2 == null ? [{ data: f2 }] : Xa2(Of2(JD(f2).datas), function(i) {
      return { type: i, data: JD(f2).datas[i] };
    });
  }
  function mbr(f2) {
    return JD(f2).mainData === f2;
  }
  function KHe(f2, i, t2) {
    JD(f2).datas = {}, Qe2(i, function(h, v4) {
      Lne(h, v4, f2, t2);
    });
  }
  function Lne(f2, i, t2, h) {
    JD(t2).datas[i] = f2, JD(f2).mainData = t2, f2.dataType = i, h.struct && (f2[h.structAttr] = h.struct, h.struct[h.datasAttr[i]] = f2), f2.getLinkedData = vbr, f2.getLinkedDataAll = ybr;
  }
  var bbr = function() {
    function f2(i, t2) {
      this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = i || "", this.hostTree = t2;
    }
    return f2.prototype.isRemoved = function() {
      return this.dataIndex < 0;
    }, f2.prototype.eachNode = function(i, t2, h) {
      Ol(i) && (h = t2, t2 = i, i = null), i = i || {}, ms(i) && (i = { order: i });
      var v4 = i.order || "preorder", _ = this[i.attr || "children"], M2;
      v4 === "preorder" && (M2 = t2.call(h, this));
      for (var I2 = 0; !M2 && I2 < _.length; I2++)
        _[I2].eachNode(i, t2, h);
      v4 === "postorder" && t2.call(h, this);
    }, f2.prototype.updateDepthAndHeight = function(i) {
      var t2 = 0;
      this.depth = i;
      for (var h = 0; h < this.children.length; h++) {
        var v4 = this.children[h];
        v4.updateDepthAndHeight(i + 1), v4.height > t2 && (t2 = v4.height);
      }
      this.height = t2 + 1;
    }, f2.prototype.getNodeById = function(i) {
      if (this.getId() === i)
        return this;
      for (var t2 = 0, h = this.children, v4 = h.length; t2 < v4; t2++) {
        var _ = h[t2].getNodeById(i);
        if (_)
          return _;
      }
    }, f2.prototype.contains = function(i) {
      if (i === this)
        return true;
      for (var t2 = 0, h = this.children, v4 = h.length; t2 < v4; t2++) {
        var _ = h[t2].contains(i);
        if (_)
          return _;
      }
    }, f2.prototype.getAncestors = function(i) {
      for (var t2 = [], h = i ? this : this.parentNode; h; )
        t2.push(h), h = h.parentNode;
      return t2.reverse(), t2;
    }, f2.prototype.getAncestorsIndices = function() {
      for (var i = [], t2 = this; t2; )
        i.push(t2.dataIndex), t2 = t2.parentNode;
      return i.reverse(), i;
    }, f2.prototype.getDescendantIndices = function() {
      var i = [];
      return this.eachNode(function(t2) {
        i.push(t2.dataIndex);
      }), i;
    }, f2.prototype.getValue = function(i) {
      var t2 = this.hostTree.data;
      return t2.getStore().get(t2.getDimensionIndex(i || "value"), this.dataIndex);
    }, f2.prototype.setLayout = function(i, t2) {
      this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, i, t2);
    }, f2.prototype.getLayout = function() {
      return this.hostTree.data.getItemLayout(this.dataIndex);
    }, f2.prototype.getModel = function(i) {
      if (!(this.dataIndex < 0)) {
        var t2 = this.hostTree, h = t2.data.getItemModel(this.dataIndex);
        return h.getModel(i);
      }
    }, f2.prototype.getLevelModel = function() {
      return (this.hostTree.levelModels || [])[this.depth];
    }, f2.prototype.setVisual = function(i, t2) {
      this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, i, t2);
    }, f2.prototype.getVisual = function(i) {
      return this.hostTree.data.getItemVisual(this.dataIndex, i);
    }, f2.prototype.getRawIndex = function() {
      return this.hostTree.data.getRawIndex(this.dataIndex);
    }, f2.prototype.getId = function() {
      return this.hostTree.data.getId(this.dataIndex);
    }, f2.prototype.getChildIndex = function() {
      if (this.parentNode) {
        for (var i = this.parentNode.children, t2 = 0; t2 < i.length; ++t2)
          if (i[t2] === this)
            return t2;
        return -1;
      }
      return -1;
    }, f2.prototype.isAncestorOf = function(i) {
      for (var t2 = i.parentNode; t2; ) {
        if (t2 === this)
          return true;
        t2 = t2.parentNode;
      }
      return false;
    }, f2.prototype.isDescendantOf = function(i) {
      return i !== this && i.isAncestorOf(this);
    }, f2;
  }(), _br = function() {
    function f2(i) {
      this.type = "tree", this._nodes = [], this.hostModel = i;
    }
    return f2.prototype.eachNode = function(i, t2, h) {
      this.root.eachNode(i, t2, h);
    }, f2.prototype.getNodeByDataIndex = function(i) {
      var t2 = this.data.getRawIndex(i);
      return this._nodes[t2];
    }, f2.prototype.getNodeById = function(i) {
      return this.root.getNodeById(i);
    }, f2.prototype.update = function() {
      for (var i = this.data, t2 = this._nodes, h = 0, v4 = t2.length; h < v4; h++)
        t2[h].dataIndex = -1;
      for (var h = 0, v4 = i.count(); h < v4; h++)
        t2[i.getRawIndex(h)].dataIndex = h;
    }, f2.prototype.clearLayouts = function() {
      this.data.clearItemLayouts();
    }, f2.createTree = function(i, t2, h) {
      var v4 = new f2(t2), _ = [], M2 = 1;
      I2(i);
      function I2(z3, H2) {
        var $ = z3.value;
        M2 = Math.max(M2, Za2($) ? $.length : 1), _.push(z3);
        var et = new bbr(l1(z3.name, ""), v4);
        H2 ? xbr(et, H2) : v4.root = et, v4._nodes.push(et);
        var at = z3.children;
        if (at)
          for (var ht = 0; ht < at.length; ht++)
            I2(at[ht], et);
      }
      v4.root.updateDepthAndHeight(0);
      var P2 = Rgt(_, { coordDimensions: ["value"], dimensionsCount: M2 }).dimensions, N3 = new B2(P2, t2);
      return N3.initData(_), h && h(N3), YHe({ mainData: N3, struct: v4, structAttr: "tree" }), v4.update(), v4;
    }, f2;
  }();
  function xbr(f2, i) {
    var t2 = i.children;
    f2.parentNode !== i && (t2.push(f2), f2.parentNode = i);
  }
  var One = _br;
  function pgt(f2, i, t2) {
    if (f2 && Pc2(i, f2.type) >= 0) {
      var h = t2.getData().tree.root, v4 = f2.targetNode;
      if (ms(v4) && (v4 = h.getNodeById(v4)), v4 && h.contains(v4))
        return { node: v4 };
      var _ = f2.targetNodeId;
      if (_ != null && (v4 = h.getNodeById(_)))
        return { node: v4 };
    }
  }
  function XHe(f2) {
    for (var i = []; f2; )
      f2 = f2.parentNode, f2 && i.push(f2);
    return i.reverse();
  }
  function Rne(f2, i) {
    var t2 = XHe(f2);
    return Pc2(t2, i) >= 0;
  }
  function zkt(f2, i) {
    for (var t2 = []; f2; ) {
      var h = f2.dataIndex;
      t2.push({ name: f2.name, dataIndex: h, value: i.getRawValue(h) }), f2 = f2.parentNode;
    }
    return t2.reverse(), t2;
  }
  var wbr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.hasSymbolVisual = true, t2.ignoreStyleOnData = true, t2;
    }
    return i.prototype.getInitialData = function(t2) {
      var h = { name: t2.name, children: t2.data }, v4 = t2.leaves || {}, _ = new Gg2(v4, this, this.ecModel), M2 = One.createTree(h, this, I2);
      function I2(H2) {
        H2.wrapMethod("getItemModel", function($, et) {
          var at = M2.getNodeByDataIndex(et);
          return at && at.children.length && at.isExpand || ($.parentModel = _), $;
        });
      }
      var P2 = 0;
      M2.eachNode("preorder", function(H2) {
        H2.depth > P2 && (P2 = H2.depth);
      });
      var N3 = t2.expandAndCollapse, z3 = N3 && t2.initialTreeDepth >= 0 ? t2.initialTreeDepth : P2;
      return M2.root.eachNode("preorder", function(H2) {
        var $ = H2.hostTree.data.getRawDataItem(H2.dataIndex);
        H2.isExpand = $ && $.collapsed != null ? !$.collapsed : H2.depth <= z3;
      }), M2.data;
    }, i.prototype.getOrient = function() {
      var t2 = this.get("orient");
      return t2 === "horizontal" ? t2 = "LR" : t2 === "vertical" && (t2 = "TB"), t2;
    }, i.prototype.setZoom = function(t2) {
      this.option.zoom = t2;
    }, i.prototype.setCenter = function(t2) {
      this.option.center = t2;
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      for (var _ = this.getData().tree, M2 = _.root.children[0], I2 = _.getNodeByDataIndex(t2), P2 = I2.getValue(), N3 = I2.name; I2 && I2 !== M2; )
        N3 = I2.parentNode.name + "." + N3, I2 = I2.parentNode;
      return pb2("nameValue", { name: N3, value: P2, noValue: isNaN(P2) || P2 == null });
    }, i.prototype.getDataParams = function(t2) {
      var h = f2.prototype.getDataParams.apply(this, arguments), v4 = this.getData().tree.getNodeByDataIndex(t2);
      return h.treeAncestors = zkt(v4, this), h;
    }, i.type = "series.tree", i.layoutMode = "box", i.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, i;
  }(Jv), Sbr = wbr;
  function Mbr(f2, i, t2) {
    for (var h = [f2], v4 = [], _; _ = h.pop(); )
      if (v4.push(_), _.isExpand) {
        var M2 = _.children;
        if (M2.length)
          for (var I2 = 0; I2 < M2.length; I2++)
            h.push(M2[I2]);
      }
    for (; _ = v4.pop(); )
      i(_, t2);
  }
  function rdt(f2, i) {
    for (var t2 = [f2], h; h = t2.pop(); )
      if (i(h), h.isExpand) {
        var v4 = h.children;
        if (v4.length)
          for (var _ = v4.length - 1; _ >= 0; _--)
            t2.push(v4[_]);
      }
  }
  function Cbr(f2, i) {
    f2.eachSeriesByType("tree", function(t2) {
      Tbr(t2, i);
    });
  }
  function Tbr(f2, i) {
    var t2 = nbr(f2, i);
    f2.layoutInfo = t2;
    var h = f2.get("layout"), v4 = 0, _ = 0, M2 = null;
    h === "radial" ? (v4 = 2 * Math.PI, _ = Math.min(t2.height, t2.width) / 2, M2 = v9e(function(zt, Ft) {
      return (zt.parentNode === Ft.parentNode ? 1 : 2) / zt.depth;
    })) : (v4 = t2.width, _ = t2.height, M2 = v9e());
    var I2 = f2.getData().tree.root, P2 = I2.children[0];
    if (P2) {
      J1r(I2), Mbr(P2, tbr, M2), I2.hierNode.modifier = -P2.hierNode.prelim, rdt(P2, ebr);
      var N3 = P2, z3 = P2, H2 = P2;
      rdt(P2, function(zt) {
        var Ft = zt.getLayout().x;
        Ft < N3.getLayout().x && (N3 = zt), Ft > z3.getLayout().x && (z3 = zt), zt.depth > H2.depth && (H2 = zt);
      });
      var $ = N3 === z3 ? 1 : M2(N3, z3) / 2, et = $ - N3.getLayout().x, at = 0, ht = 0, bt = 0, _t = 0;
      if (h === "radial")
        at = v4 / (z3.getLayout().x + $ + et), ht = _ / (H2.depth - 1 || 1), rdt(P2, function(zt) {
          bt = (zt.getLayout().x + et) * at, _t = (zt.depth - 1) * ht;
          var Ft = wdt(bt, _t);
          zt.setLayout({ x: Ft.x, y: Ft.y, rawX: bt, rawY: _t }, true);
        });
      else {
        var Et = f2.getOrient();
        Et === "RL" || Et === "LR" ? (ht = _ / (z3.getLayout().x + $ + et), at = v4 / (H2.depth - 1 || 1), rdt(P2, function(zt) {
          _t = (zt.getLayout().x + et) * ht, bt = Et === "LR" ? (zt.depth - 1) * at : v4 - (zt.depth - 1) * at, zt.setLayout({ x: bt, y: _t }, true);
        })) : (Et === "TB" || Et === "BT") && (at = v4 / (z3.getLayout().x + $ + et), ht = _ / (H2.depth - 1 || 1), rdt(P2, function(zt) {
          bt = (zt.getLayout().x + et) * at, _t = Et === "TB" ? (zt.depth - 1) * ht : _ - (zt.depth - 1) * ht, zt.setLayout({ x: bt, y: _t }, true);
        }));
      }
    }
  }
  function Abr(f2) {
    f2.eachSeriesByType("tree", function(i) {
      var t2 = i.getData(), h = t2.tree;
      h.eachNode(function(v4) {
        var _ = v4.getModel(), M2 = _.getModel("itemStyle").getItemStyle(), I2 = t2.ensureUniqueItemVisual(v4.dataIndex, "style");
        ba2(I2, M2);
      });
    });
  }
  function Ibr(f2) {
    f2.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(i, t2) {
      t2.eachComponent({ mainType: "series", subType: "tree", query: i }, function(h) {
        var v4 = i.dataIndex, _ = h.getData().tree, M2 = _.getNodeByDataIndex(v4);
        M2.isExpand = !M2.isExpand;
      });
    }), f2.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(i, t2) {
      t2.eachComponent({ mainType: "series", subType: "tree", query: i }, function(h) {
        var v4 = h.coordinateSystem, _ = Pne(v4, i);
        h.setCenter && h.setCenter(_.center), h.setZoom && h.setZoom(_.zoom);
      });
    });
  }
  function Dbr(f2) {
    f2.registerChartView(hbr), f2.registerSeriesModel(Sbr), f2.registerLayout(Cbr), f2.registerVisual(Abr), Ibr(f2);
  }
  var x9e = ["treemapZoomToNode", "treemapRender", "treemapMove"];
  function Ebr(f2) {
    for (var i = 0; i < x9e.length; i++)
      f2.registerAction({ type: x9e[i], update: "updateView" }, xm);
    f2.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(t2, h) {
      h.eachComponent({ mainType: "series", subType: "treemap", query: t2 }, v4);
      function v4(_, M2) {
        var I2 = ["treemapZoomToNode", "treemapRootToNode"], P2 = pgt(t2, I2, _);
        if (P2) {
          var N3 = _.getViewRoot();
          N3 && (t2.direction = Rne(N3, P2.node) ? "rollUp" : "drillDown"), _.resetViewRoot(P2.node);
        }
      }
    });
  }
  function QHe(f2) {
    var i = f2.getData(), t2 = i.tree, h = {};
    t2.eachNode(function(v4) {
      for (var _ = v4; _ && _.depth > 1; )
        _ = _.parentNode;
      var M2 = KJt(f2.ecModel, _.name || _.dataIndex + "", h);
      v4.setVisual("decal", M2);
    });
  }
  var kbr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.preventUsingHoverLayer = true, t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      var v4 = { name: t2.name, children: t2.data };
      JHe(v4);
      var _ = t2.levels || [], M2 = this.designatedVisualItemStyle = {}, I2 = new Gg2({ itemStyle: M2 }, this, h);
      _ = t2.levels = Pbr(_, h);
      var P2 = Xa2(_ || [], function(H2) {
        return new Gg2(H2, I2, h);
      }, this), N3 = One.createTree(v4, this, z3);
      function z3(H2) {
        H2.wrapMethod("getItemModel", function($, et) {
          var at = N3.getNodeByDataIndex(et), ht = at ? P2[at.depth] : null;
          return $.parentModel = ht || I2, $;
        });
      }
      return N3.data;
    }, i.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      var _ = this.getData(), M2 = this.getRawValue(t2), I2 = _.getName(t2);
      return pb2("nameValue", { name: I2, value: M2 });
    }, i.prototype.getDataParams = function(t2) {
      var h = f2.prototype.getDataParams.apply(this, arguments), v4 = this.getData().tree.getNodeByDataIndex(t2);
      return h.treeAncestors = zkt(v4, this), h.treePathInfo = h.treeAncestors, h;
    }, i.prototype.setLayoutInfo = function(t2) {
      this.layoutInfo = this.layoutInfo || {}, ba2(this.layoutInfo, t2);
    }, i.prototype.mapIdToIndex = function(t2) {
      var h = this._idIndexMap;
      h || (h = this._idIndexMap = Il(), this._idIndexMapCount = 0);
      var v4 = h.get(t2);
      return v4 == null && h.set(t2, v4 = this._idIndexMapCount++), v4;
    }, i.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, i.prototype.resetViewRoot = function(t2) {
      t2 ? this._viewRoot = t2 : t2 = this._viewRoot;
      var h = this.getRawData().tree.root;
      (!t2 || t2 !== h && !h.contains(t2)) && (this._viewRoot = h);
    }, i.prototype.enableAriaDecal = function() {
      QHe(this);
    }, i.type = "series.treemap", i.layoutMode = "box", i.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, i;
  }(Jv);
  function JHe(f2) {
    var i = 0;
    Qe2(f2.children, function(h) {
      JHe(h);
      var v4 = h.value;
      Za2(v4) && (v4 = v4[0]), i += v4;
    });
    var t2 = f2.value;
    Za2(t2) && (t2 = t2[0]), (t2 == null || isNaN(t2)) && (t2 = i), t2 < 0 && (t2 = 0), Za2(f2.value) ? f2.value[0] = t2 : f2.value = t2;
  }
  function Pbr(f2, i) {
    var t2 = Od2(i.get("color")), h = Od2(i.get(["aria", "decal", "decals"]));
    if (!!t2) {
      f2 = f2 || [];
      var v4, _;
      Qe2(f2, function(I2) {
        var P2 = new Gg2(I2), N3 = P2.get("color"), z3 = P2.get("decal");
        (P2.get(["itemStyle", "color"]) || N3 && N3 !== "none") && (v4 = true), (P2.get(["itemStyle", "decal"]) || z3 && z3 !== "none") && (_ = true);
      });
      var M2 = f2[0] || (f2[0] = {});
      return v4 || (M2.color = t2.slice()), !_ && h && (M2.decal = h.slice()), f2;
    }
  }
  var Lbr = kbr, Obr = 8, w9e = 8, aQt = 5, Rbr = function() {
    function f2(i) {
      this.group = new mu(), i.add(this.group);
    }
    return f2.prototype.render = function(i, t2, h, v4) {
      var _ = i.getModel("breadcrumb"), M2 = this.group;
      if (M2.removeAll(), !(!_.get("show") || !h)) {
        var I2 = _.getModel("itemStyle"), P2 = I2.getModel("textStyle"), N3 = { pos: { left: _.get("left"), right: _.get("right"), top: _.get("top"), bottom: _.get("bottom") }, box: { width: t2.getWidth(), height: t2.getHeight() }, emptyItemWidth: _.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
        this._prepare(h, N3, P2), this._renderContent(i, N3, I2, P2, v4), Akt(M2, N3.pos, N3.box);
      }
    }, f2.prototype._prepare = function(i, t2, h) {
      for (var v4 = i; v4; v4 = v4.parentNode) {
        var _ = l1(v4.getModel().get("name"), ""), M2 = h.getTextRect(_), I2 = Math.max(M2.width + Obr * 2, t2.emptyItemWidth);
        t2.totalWidth += I2 + w9e, t2.renderList.push({ node: v4, text: _, width: I2 });
      }
    }, f2.prototype._renderContent = function(i, t2, h, v4, _) {
      for (var M2 = 0, I2 = t2.emptyItemWidth, P2 = i.get(["breadcrumb", "height"]), N3 = Hhr(t2.pos, t2.box), z3 = t2.totalWidth, H2 = t2.renderList, $ = H2.length - 1; $ >= 0; $--) {
        var et = H2[$], at = et.node, ht = et.width, bt = et.text;
        z3 > N3.width && (z3 -= ht - I2, ht = I2, bt = null);
        var _t = new iC({ shape: { points: Nbr(M2, 0, ht, P2, $ === H2.length - 1, $ === 0) }, style: Ul(h.getItemStyle(), { lineJoin: "bevel" }), textContent: new op({ style: { text: bt, fill: v4.getTextColor(), font: v4.getFont() } }), textConfig: { position: "inside" }, z2: Jtt * 1e4, onclick: Ou(_, at) });
        _t.disableLabelAnimation = true, this.group.add(_t), Fbr(_t, i, at), M2 += ht + w9e;
      }
    }, f2.prototype.remove = function() {
      this.group.removeAll();
    }, f2;
  }();
  function Nbr(f2, i, t2, h, v4, _) {
    var M2 = [[v4 ? f2 : f2 - aQt, i], [f2 + t2, i], [f2 + t2, i + h], [v4 ? f2 : f2 - aQt, i + h]];
    return !_ && M2.splice(2, 0, [f2 + t2 + aQt, i + h / 2]), !v4 && M2.push([f2, i + h / 2]), M2;
  }
  function Fbr(f2, i, t2) {
    Du(f2).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: i.componentIndex, seriesIndex: i.seriesIndex, seriesName: i.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: t2 && t2.dataIndex, name: t2 && t2.name }, treePathInfo: t2 && zkt(t2, i) };
  }
  var Vbr = Rbr, Bbr = function() {
    function f2() {
      this._storage = [], this._elExistsMap = {};
    }
    return f2.prototype.add = function(i, t2, h, v4, _) {
      return this._elExistsMap[i.id] ? false : (this._elExistsMap[i.id] = true, this._storage.push({ el: i, target: t2, duration: h, delay: v4, easing: _ }), true);
    }, f2.prototype.finished = function(i) {
      return this._finishedCallback = i, this;
    }, f2.prototype.start = function() {
      for (var i = this, t2 = this._storage.length, h = function() {
        t2--, t2 <= 0 && (i._storage.length = 0, i._elExistsMap = {}, i._finishedCallback && i._finishedCallback());
      }, v4 = 0, _ = this._storage.length; v4 < _; v4++) {
        var M2 = this._storage[v4];
        M2.el.animateTo(M2.target, { duration: M2.duration, delay: M2.delay, easing: M2.easing, setToFinal: true, done: h, aborted: h });
      }
      return this;
    }, f2;
  }();
  function zbr() {
    return new Bbr();
  }
  var wte = mu, S9e = Sh2, M9e = 3, C9e = "label", T9e = "upperLabel", jbr = Jtt * 10, Wbr = Jtt * 2, Gbr = Jtt * 3, UH = yU([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), A9e = function(f2) {
    var i = UH(f2);
    return i.stroke = i.fill = i.lineWidth = null, i;
  }, BEt = Wh2(), Hbr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._state = "ready", t2._storage = idt(), t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      var M2 = h.findComponents({ mainType: "series", subType: "treemap", query: _ });
      if (!(Pc2(M2, t2) < 0)) {
        this.seriesModel = t2, this.api = v4, this.ecModel = h;
        var I2 = ["treemapZoomToNode", "treemapRootToNode"], P2 = pgt(_, I2, t2), N3 = _ && _.type, z3 = t2.layoutInfo, H2 = !this._oldTree, $ = this._storage, et = N3 === "treemapRootToNode" && P2 && $ ? { rootNodeGroup: $.nodeGroup[P2.node.getRawIndex()], direction: _.direction } : null, at = this._giveContainerGroup(z3), ht = t2.get("animation"), bt = this._doRender(at, t2, et);
        ht && !H2 && (!N3 || N3 === "treemapZoomToNode" || N3 === "treemapRootToNode") ? this._doAnimation(at, bt, t2, et) : bt.renderFinally(), this._resetController(v4), this._renderBreadcrumb(t2, v4, P2);
      }
    }, i.prototype._giveContainerGroup = function(t2) {
      var h = this._containerGroup;
      return h || (h = this._containerGroup = new wte(), this._initEvents(h), this.group.add(h)), h.x = t2.x, h.y = t2.y, h;
    }, i.prototype._doRender = function(t2, h, v4) {
      var _ = h.getData().tree, M2 = this._oldTree, I2 = idt(), P2 = idt(), N3 = this._storage, z3 = [];
      function H2(bt, _t, Et, zt) {
        return Ubr(h, P2, N3, v4, I2, z3, bt, _t, Et, zt);
      }
      et(_.root ? [_.root] : [], M2 && M2.root ? [M2.root] : [], t2, _ === M2 || !M2, 0);
      var $ = at(N3);
      return this._oldTree = _, this._storage = P2, { lastsForAnimation: I2, willDeleteEls: $, renderFinally: ht };
      function et(bt, _t, Et, zt, Ft) {
        zt ? (_t = bt, Qe2(bt, function(ye, me2) {
          !ye.isRemoved() && re2(me2, me2);
        })) : new eN(_t, bt, fe2, fe2).add(re2).update(re2).remove(Ou(re2, null)).execute();
        function fe2(ye) {
          return ye.getId();
        }
        function re2(ye, me2) {
          var be2 = ye != null ? bt[ye] : null, Te2 = me2 != null ? _t[me2] : null, We = H2(be2, Te2, Et, Ft);
          We && et(be2 && be2.viewChildren || [], Te2 && Te2.viewChildren || [], We, zt, Ft + 1);
        }
      }
      function at(bt) {
        var _t = idt();
        return bt && Qe2(bt, function(Et, zt) {
          var Ft = _t[zt];
          Qe2(Et, function(fe2) {
            fe2 && (Ft.push(fe2), BEt(fe2).willDelete = true);
          });
        }), _t;
      }
      function ht() {
        Qe2($, function(bt) {
          Qe2(bt, function(_t) {
            _t.parent && _t.parent.remove(_t);
          });
        }), Qe2(z3, function(bt) {
          bt.invisible = true, bt.dirty();
        });
      }
    }, i.prototype._doAnimation = function(t2, h, v4, _) {
      var M2 = v4.get("animationDurationUpdate"), I2 = v4.get("animationEasing"), P2 = (Ol(M2) ? 0 : M2) || 0, N3 = (Ol(I2) ? null : I2) || "cubicOut", z3 = zbr();
      Qe2(h.willDeleteEls, function(H2, $) {
        Qe2(H2, function(et, at) {
          if (!et.invisible) {
            var ht = et.parent, bt, _t = BEt(ht);
            if (_ && _.direction === "drillDown")
              bt = ht === _.rootNodeGroup ? { shape: { x: 0, y: 0, width: _t.nodeWidth, height: _t.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
            else {
              var Et = 0, zt = 0;
              _t.willDelete || (Et = _t.nodeWidth / 2, zt = _t.nodeHeight / 2), bt = $ === "nodeGroup" ? { x: Et, y: zt, style: { opacity: 0 } } : { shape: { x: Et, y: zt, width: 0, height: 0 }, style: { opacity: 0 } };
            }
            bt && z3.add(et, bt, P2, 0, N3);
          }
        });
      }), Qe2(this._storage, function(H2, $) {
        Qe2(H2, function(et, at) {
          var ht = h.lastsForAnimation[$][at], bt = {};
          !ht || (et instanceof mu ? ht.oldX != null && (bt.x = et.x, bt.y = et.y, et.x = ht.oldX, et.y = ht.oldY) : (ht.oldShape && (bt.shape = ba2({}, et.shape), et.setShape(ht.oldShape)), ht.fadein ? (et.setStyle("opacity", 0), bt.style = { opacity: 1 }) : et.style.opacity !== 1 && (bt.style = { opacity: 1 })), z3.add(et, bt, P2, 0, N3));
        });
      }, this), this._state = "animating", z3.finished(ks(function() {
        this._state = "ready", h.renderFinally();
      }, this)).start();
    }, i.prototype._resetController = function(t2) {
      var h = this._controller;
      h || (h = this._controller = new Ggt(t2.getZr()), h.enable(this.seriesModel.get("roam")), h.on("pan", ks(this._onPan, this)), h.on("zoom", ks(this._onZoom, this)));
      var v4 = new Lc2(0, 0, t2.getWidth(), t2.getHeight());
      h.setPointerChecker(function(_, M2, I2) {
        return v4.contain(M2, I2);
      });
    }, i.prototype._clearController = function() {
      var t2 = this._controller;
      t2 && (t2.dispose(), t2 = null);
    }, i.prototype._onPan = function(t2) {
      if (this._state !== "animating" && (Math.abs(t2.dx) > M9e || Math.abs(t2.dy) > M9e)) {
        var h = this.seriesModel.getData().tree.root;
        if (!h)
          return;
        var v4 = h.getLayout();
        if (!v4)
          return;
        this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: v4.x + t2.dx, y: v4.y + t2.dy, width: v4.width, height: v4.height } });
      }
    }, i.prototype._onZoom = function(t2) {
      var h = t2.originX, v4 = t2.originY;
      if (this._state !== "animating") {
        var _ = this.seriesModel.getData().tree.root;
        if (!_)
          return;
        var M2 = _.getLayout();
        if (!M2)
          return;
        var I2 = new Lc2(M2.x, M2.y, M2.width, M2.height), P2 = this.seriesModel.layoutInfo;
        h -= P2.x, v4 -= P2.y;
        var N3 = nE();
        jL(N3, N3, [-h, -v4]), Aee(N3, N3, [t2.scale, t2.scale]), jL(N3, N3, [h, v4]), I2.applyTransform(N3), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: I2.x, y: I2.y, width: I2.width, height: I2.height } });
      }
    }, i.prototype._initEvents = function(t2) {
      var h = this;
      t2.on("click", function(v4) {
        if (h._state === "ready") {
          var _ = h.seriesModel.get("nodeClick", true);
          if (!!_) {
            var M2 = h.findTarget(v4.offsetX, v4.offsetY);
            if (!!M2) {
              var I2 = M2.node;
              if (I2.getLayout().isLeafRoot)
                h._rootToNode(M2);
              else if (_ === "zoomToNode")
                h._zoomToNode(M2);
              else if (_ === "link") {
                var P2 = I2.hostTree.data.getItemModel(I2.dataIndex), N3 = P2.get("link", true), z3 = P2.get("target", true) || "blank";
                N3 && wEt(N3, z3);
              }
            }
          }
        }
      }, this);
    }, i.prototype._renderBreadcrumb = function(t2, h, v4) {
      var _ = this;
      v4 || (v4 = t2.get("leafDepth", true) != null ? { node: t2.getViewRoot() } : this.findTarget(h.getWidth() / 2, h.getHeight() / 2), v4 || (v4 = { node: t2.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new Vbr(this.group))).render(t2, h, v4.node, function(M2) {
        _._state !== "animating" && (Rne(t2.getViewRoot(), M2) ? _._rootToNode({ node: M2 }) : _._zoomToNode({ node: M2 }));
      });
    }, i.prototype.remove = function() {
      this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = idt(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
    }, i.prototype.dispose = function() {
      this._clearController();
    }, i.prototype._zoomToNode = function(t2) {
      this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: t2.node });
    }, i.prototype._rootToNode = function(t2) {
      this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: t2.node });
    }, i.prototype.findTarget = function(t2, h) {
      var v4, _ = this.seriesModel.getViewRoot();
      return _.eachNode({ attr: "viewChildren", order: "preorder" }, function(M2) {
        var I2 = this._storage.background[M2.getRawIndex()];
        if (I2) {
          var P2 = I2.transformCoordToLocal(t2, h), N3 = I2.shape;
          if (N3.x <= P2[0] && P2[0] <= N3.x + N3.width && N3.y <= P2[1] && P2[1] <= N3.y + N3.height)
            v4 = { node: M2, offsetX: P2[0], offsetY: P2[1] };
          else
            return false;
        }
      }, this), v4;
    }, i.type = "treemap", i;
  }(Hg2);
  function idt() {
    return { nodeGroup: [], background: [], content: [] };
  }
  function Ubr(f2, i, t2, h, v4, _, M2, I2, P2, N3) {
    if (!M2)
      return;
    var z3 = M2.getLayout(), H2 = f2.getData(), $ = M2.getModel();
    if (H2.setItemGraphicEl(M2.dataIndex, null), !z3 || !z3.isInView)
      return;
    var et = z3.width, at = z3.height, ht = z3.borderWidth, bt = z3.invisible, _t = M2.getRawIndex(), Et = I2 && I2.getRawIndex(), zt = M2.viewChildren, Ft = z3.upperHeight, fe2 = zt && zt.length, re2 = $.getModel("itemStyle"), ye = $.getModel(["emphasis", "itemStyle"]), me2 = $.getModel(["blur", "itemStyle"]), be2 = $.getModel(["select", "itemStyle"]), Te2 = re2.get("borderRadius") || 0, We = us("nodeGroup", wte);
    if (!We)
      return;
    if (P2.add(We), We.x = z3.x || 0, We.y = z3.y || 0, We.markRedraw(), BEt(We).nodeWidth = et, BEt(We).nodeHeight = at, z3.isAboveViewRoot)
      return We;
    var en = us("background", S9e, N3, Wbr);
    en && pr(We, en, fe2 && z3.upperLabelHeight);
    var Ue2 = $.getModel("emphasis"), Mn = Ue2.get("focus"), Vn = Ue2.get("blurScope"), xn = Ue2.get("disabled"), Zr = Mn === "ancestor" ? M2.getAncestorsIndices() : Mn === "descendant" ? M2.getDescendantIndices() : Mn;
    if (fe2)
      Jdt(We) && nU(We, false), en && (nU(en, !xn), H2.setItemGraphicEl(M2.dataIndex, en), WJt(en, Zr, Vn));
    else {
      var nr = us("content", S9e, N3, Gbr);
      nr && Nr(We, nr), en.disableMorphing = true, en && Jdt(en) && nU(en, false), nU(We, !xn), H2.setItemGraphicEl(M2.dataIndex, We), WJt(We, Zr, Vn);
    }
    return We;
    function pr(Rs, es, Ws) {
      var il = Du(es);
      if (il.dataIndex = M2.dataIndex, il.seriesIndex = f2.seriesIndex, es.setShape({ x: 0, y: 0, width: et, height: at, r: Te2 }), bt)
        ai2(es);
      else {
        es.invisible = false;
        var bs = M2.getVisual("style"), Rl = bs.stroke, Mh2 = A9e(re2);
        Mh2.fill = Rl;
        var au = UH(ye);
        au.fill = ye.get("borderColor");
        var eh2 = UH(me2);
        eh2.fill = me2.get("borderColor");
        var Gh2 = UH(be2);
        if (Gh2.fill = be2.get("borderColor"), Ws) {
          var Pp = et - 2 * ht;
          gi2(es, Rl, bs.opacity, { x: ht, y: 0, width: Pp, height: Ft });
        } else
          es.removeTextContent();
        es.setStyle(Mh2), es.ensureState("emphasis").style = au, es.ensureState("blur").style = eh2, es.ensureState("select").style = Gh2, mU(es);
      }
      Rs.add(es);
    }
    function Nr(Rs, es) {
      var Ws = Du(es);
      Ws.dataIndex = M2.dataIndex, Ws.seriesIndex = f2.seriesIndex;
      var il = Math.max(et - 2 * ht, 0), bs = Math.max(at - 2 * ht, 0);
      if (es.culling = true, es.setShape({ x: ht, y: ht, width: il, height: bs, r: Te2 }), bt)
        ai2(es);
      else {
        es.invisible = false;
        var Rl = M2.getVisual("style"), Mh2 = Rl.fill, au = A9e(re2);
        au.fill = Mh2, au.decal = Rl.decal;
        var eh2 = UH(ye), Gh2 = UH(me2), Pp = UH(be2);
        gi2(es, Mh2, Rl.opacity, null), es.setStyle(au), es.ensureState("emphasis").style = eh2, es.ensureState("blur").style = Gh2, es.ensureState("select").style = Pp, mU(es);
      }
      Rs.add(es);
    }
    function ai2(Rs) {
      !Rs.invisible && _.push(Rs);
    }
    function gi2(Rs, es, Ws, il) {
      var bs = $.getModel(il ? T9e : C9e), Rl = l1($.get("name"), null), Mh2 = bs.getShallow("show");
      SS(Rs, b_($, il ? T9e : C9e), { defaultText: Mh2 ? Rl : null, inheritColor: es, defaultOpacity: Ws, labelFetcher: f2, labelDataIndex: M2.dataIndex });
      var au = Rs.getTextContent();
      if (!!au) {
        var eh2 = au.style, Gh2 = wee(eh2.padding || 0);
        il && (Rs.setTextConfig({ layoutRect: il }), au.disableLabelLayout = true), au.beforeUpdate = function() {
          var zy = Math.max((il ? il.width : Rs.shape.width) - Gh2[1] - Gh2[3], 0), Rd2 = Math.max((il ? il.height : Rs.shape.height) - Gh2[0] - Gh2[2], 0);
          (eh2.width !== zy || eh2.height !== Rd2) && au.setStyle({ width: zy, height: Rd2 });
        }, eh2.truncateMinChar = 2, eh2.lineOverflow = "truncate", To(eh2, il, z3);
        var Pp = au.getState("emphasis");
        To(Pp ? Pp.style : null, il, z3);
      }
    }
    function To(Rs, es, Ws) {
      var il = Rs ? Rs.text : null;
      if (!es && Ws.isLeafRoot && il != null) {
        var bs = f2.get("drillDownIcon", true);
        Rs.text = bs ? bs + " " + il : il;
      }
    }
    function us(Rs, es, Ws, il) {
      var bs = Et != null && t2[Rs][Et], Rl = v4[Rs];
      return bs ? (t2[Rs][Et] = null, ml(Rl, bs)) : bt || (bs = new es(), bs instanceof rE && (bs.z2 = qbr(Ws, il)), ll(Rl, bs)), i[Rs][_t] = bs;
    }
    function ml(Rs, es) {
      var Ws = Rs[_t] = {};
      es instanceof wte ? (Ws.oldX = es.x, Ws.oldY = es.y) : Ws.oldShape = ba2({}, es.shape);
    }
    function ll(Rs, es) {
      var Ws = Rs[_t] = {}, il = M2.parentNode, bs = es instanceof mu;
      if (il && (!h || h.direction === "drillDown")) {
        var Rl = 0, Mh2 = 0, au = v4.background[il.getRawIndex()];
        !h && au && au.oldShape && (Rl = au.oldShape.width, Mh2 = au.oldShape.height), bs ? (Ws.oldX = 0, Ws.oldY = Mh2) : Ws.oldShape = { x: Rl, y: Mh2, width: 0, height: 0 };
      }
      Ws.fadein = !bs;
    }
  }
  function qbr(f2, i) {
    return f2 * jbr + i;
  }
  var Zbr = Hbr, dgt = Qe2, $br = Xl, zEt = -1, Nne = function() {
    function f2(i) {
      var t2 = i.mappingMethod, h = i.type, v4 = this.option = pu(i);
      this.type = h, this.mappingMethod = t2, this._normalizeData = Xbr[t2];
      var _ = f2.visualHandlers[h];
      this.applyVisual = _.applyVisual, this.getColorMapper = _.getColorMapper, this._normalizedToVisual = _._normalizedToVisual[t2], t2 === "piecewise" ? (oQt(v4), Ybr(v4)) : t2 === "category" ? v4.categories ? Kbr(v4) : oQt(v4, true) : (z2(t2 !== "linear" || v4.dataExtent), oQt(v4));
    }
    return f2.prototype.mapValueToVisual = function(i) {
      var t2 = this._normalizeData(i);
      return this._normalizedToVisual(t2, i);
    }, f2.prototype.getNormalizer = function() {
      return ks(this._normalizeData, this);
    }, f2.listVisualTypes = function() {
      return Of2(f2.visualHandlers);
    }, f2.isValidType = function(i) {
      return f2.visualHandlers.hasOwnProperty(i);
    }, f2.eachVisual = function(i, t2, h) {
      Xl(i) ? Qe2(i, t2, h) : t2.call(h, i);
    }, f2.mapVisual = function(i, t2, h) {
      var v4, _ = Za2(i) ? [] : Xl(i) ? {} : (v4 = true, null);
      return f2.eachVisual(i, function(M2, I2) {
        var P2 = t2.call(h, M2, I2);
        v4 ? _ = P2 : _[I2] = P2;
      }), _;
    }, f2.retrieveVisuals = function(i) {
      var t2 = {}, h;
      return i && dgt(f2.visualHandlers, function(v4, _) {
        i.hasOwnProperty(_) && (t2[_] = i[_], h = true);
      }), h ? t2 : null;
    }, f2.prepareVisualTypes = function(i) {
      if (Za2(i))
        i = i.slice();
      else if ($br(i)) {
        var t2 = [];
        dgt(i, function(h, v4) {
          t2.push(v4);
        }), i = t2;
      } else
        return [];
      return i.sort(function(h, v4) {
        return v4 === "color" && h !== "color" && h.indexOf("color") === 0 ? 1 : -1;
      }), i;
    }, f2.dependsOn = function(i, t2) {
      return t2 === "color" ? !!(i && i.indexOf(t2) === 0) : i === t2;
    }, f2.findPieceIndex = function(i, t2, h) {
      for (var v4, _ = 1 / 0, M2 = 0, I2 = t2.length; M2 < I2; M2++) {
        var P2 = t2[M2].value;
        if (P2 != null) {
          if (P2 === i || ms(P2) && P2 === i + "")
            return M2;
          h && $(P2, M2);
        }
      }
      for (var M2 = 0, I2 = t2.length; M2 < I2; M2++) {
        var N3 = t2[M2], z3 = N3.interval, H2 = N3.close;
        if (z3) {
          if (z3[0] === -1 / 0) {
            if (mDt(H2[1], i, z3[1]))
              return M2;
          } else if (z3[1] === 1 / 0) {
            if (mDt(H2[0], z3[0], i))
              return M2;
          } else if (mDt(H2[0], z3[0], i) && mDt(H2[1], i, z3[1]))
            return M2;
          h && $(z3[0], M2), h && $(z3[1], M2);
        }
      }
      if (h)
        return i === 1 / 0 ? t2.length - 1 : i === -1 / 0 ? 0 : v4;
      function $(et, at) {
        var ht = Math.abs(et - i);
        ht < _ && (_ = ht, v4 = at);
      }
    }, f2.visualHandlers = { color: { applyVisual: adt("color"), getColorMapper: function() {
      var i = this.option;
      return ks(i.mappingMethod === "category" ? function(t2, h) {
        return !h && (t2 = this._normalizeData(t2)), Sdt.call(this, t2);
      } : function(t2, h, v4) {
        var _ = !!v4;
        return !h && (t2 = this._normalizeData(t2)), v4 = jKt(t2, i.parsedVisual, v4), _ ? v4 : Z6(v4, "rgba");
      }, this);
    }, _normalizedToVisual: { linear: function(i) {
      return Z6(jKt(i, this.option.parsedVisual), "rgba");
    }, category: Sdt, piecewise: function(i, t2) {
      var h = Mte.call(this, t2);
      return h == null && (h = Z6(jKt(i, this.option.parsedVisual), "rgba")), h;
    }, fixed: qH } }, colorHue: yDt(function(i, t2) {
      return Idt(i, t2);
    }), colorSaturation: yDt(function(i, t2) {
      return Idt(i, null, t2);
    }), colorLightness: yDt(function(i, t2) {
      return Idt(i, null, null, t2);
    }), colorAlpha: yDt(function(i, t2) {
      return uEt(i, t2);
    }), decal: { applyVisual: adt("decal"), _normalizedToVisual: { linear: null, category: Sdt, piecewise: null, fixed: null } }, opacity: { applyVisual: adt("opacity"), _normalizedToVisual: Ste([0, 1]) }, liftZ: { applyVisual: adt("liftZ"), _normalizedToVisual: { linear: qH, category: qH, piecewise: qH, fixed: qH } }, symbol: { applyVisual: function(i, t2, h) {
      var v4 = this.mapValueToVisual(i);
      h("symbol", v4);
    }, _normalizedToVisual: { linear: I9e, category: Sdt, piecewise: function(i, t2) {
      var h = Mte.call(this, t2);
      return h == null && (h = I9e.call(this, i)), h;
    }, fixed: qH } }, symbolSize: { applyVisual: adt("symbolSize"), _normalizedToVisual: Ste([0, 1]) } }, f2;
  }();
  function Ybr(f2) {
    var i = f2.pieceList;
    f2.hasSpecialVisual = false, Qe2(i, function(t2, h) {
      t2.originIndex = h, t2.visual != null && (f2.hasSpecialVisual = true);
    });
  }
  function Kbr(f2) {
    var i = f2.categories, t2 = f2.categoryMap = {}, h = f2.visual;
    if (dgt(i, function(M2, I2) {
      t2[M2] = I2;
    }), !Za2(h)) {
      var v4 = [];
      Xl(h) ? dgt(h, function(M2, I2) {
        var P2 = t2[I2];
        v4[P2 != null ? P2 : zEt] = M2;
      }) : v4[zEt] = h, h = tUe(f2, v4);
    }
    for (var _ = i.length - 1; _ >= 0; _--)
      h[_] == null && (delete t2[i[_]], i.pop());
  }
  function oQt(f2, i) {
    var t2 = f2.visual, h = [];
    Xl(t2) ? dgt(t2, function(_) {
      h.push(_);
    }) : t2 != null && h.push(t2);
    var v4 = { color: 1, symbol: 1 };
    !i && h.length === 1 && !v4.hasOwnProperty(f2.type) && (h[1] = h[0]), tUe(f2, h);
  }
  function yDt(f2) {
    return { applyVisual: function(i, t2, h) {
      var v4 = this.mapValueToVisual(i);
      h("color", f2(t2("color"), v4));
    }, _normalizedToVisual: Ste([0, 1]) };
  }
  function I9e(f2) {
    var i = this.option.visual;
    return i[Math.round(cd2(f2, [0, 1], [0, i.length - 1], true))] || {};
  }
  function adt(f2) {
    return function(i, t2, h) {
      h(f2, this.mapValueToVisual(i));
    };
  }
  function Sdt(f2) {
    var i = this.option.visual;
    return i[this.option.loop && f2 !== zEt ? f2 % i.length : f2];
  }
  function qH() {
    return this.option.visual[0];
  }
  function Ste(f2) {
    return { linear: function(i) {
      return cd2(i, f2, this.option.visual, true);
    }, category: Sdt, piecewise: function(i, t2) {
      var h = Mte.call(this, t2);
      return h == null && (h = cd2(i, f2, this.option.visual, true)), h;
    }, fixed: qH };
  }
  function Mte(f2) {
    var i = this.option, t2 = i.pieceList;
    if (i.hasSpecialVisual) {
      var h = Nne.findPieceIndex(f2, t2), v4 = t2[h];
      if (v4 && v4.visual)
        return v4.visual[this.type];
    }
  }
  function tUe(f2, i) {
    return f2.visual = i, f2.type === "color" && (f2.parsedVisual = Xa2(i, function(t2) {
      return ZT(t2);
    })), i;
  }
  var Xbr = { linear: function(f2) {
    return cd2(f2, this.option.dataExtent, [0, 1], true);
  }, piecewise: function(f2) {
    var i = this.option.pieceList, t2 = Nne.findPieceIndex(f2, i, true);
    if (t2 != null)
      return cd2(t2, [0, i.length - 1], [0, 1], true);
  }, category: function(f2) {
    var i = this.option.categories ? this.option.categoryMap[f2] : f2;
    return i == null ? zEt : i;
  }, fixed: xm };
  function mDt(f2, i, t2) {
    return f2 ? i <= t2 : i < t2;
  }
  var Gx = Nne, Qbr = "itemStyle", eUe = Wh2(), Jbr = { seriesType: "treemap", reset: function(f2) {
    var i = f2.getData().tree, t2 = i.root;
    t2.isRemoved() || nUe(t2, {}, f2.getViewRoot().getAncestors(), f2);
  } };
  function nUe(f2, i, t2, h) {
    var v4 = f2.getModel(), _ = f2.getLayout(), M2 = f2.hostTree.data;
    if (!(!_ || _.invisible || !_.isInView)) {
      var I2 = v4.getModel(Qbr), P2 = t_r(I2, i, h), N3 = M2.ensureUniqueItemVisual(f2.dataIndex, "style"), z3 = I2.get("borderColor"), H2 = I2.get("borderColorSaturation"), $;
      H2 != null && ($ = D9e(P2), z3 = e_r(H2, $)), N3.stroke = z3;
      var et = f2.viewChildren;
      if (!et || !et.length)
        $ = D9e(P2), N3.fill = $;
      else {
        var at = n_r(f2, v4, _, I2, P2, et);
        Qe2(et, function(ht, bt) {
          if (ht.depth >= t2.length || ht === t2[ht.depth]) {
            var _t = r_r(v4, P2, ht, bt, at, h);
            nUe(ht, _t, t2, h);
          }
        });
      }
    }
  }
  function t_r(f2, i, t2) {
    var h = ba2({}, i), v4 = t2.designatedVisualItemStyle;
    return Qe2(["color", "colorAlpha", "colorSaturation"], function(_) {
      v4[_] = i[_];
      var M2 = f2.get(_);
      v4[_] = null, M2 != null && (h[_] = M2);
    }), h;
  }
  function D9e(f2) {
    var i = sQt(f2, "color");
    if (i) {
      var t2 = sQt(f2, "colorAlpha"), h = sQt(f2, "colorSaturation");
      return h && (i = Idt(i, null, null, h)), t2 && (i = uEt(i, t2)), i;
    }
  }
  function e_r(f2, i) {
    return i != null ? Idt(i, null, null, f2) : null;
  }
  function sQt(f2, i) {
    var t2 = f2[i];
    if (t2 != null && t2 !== "none")
      return t2;
  }
  function n_r(f2, i, t2, h, v4, _) {
    if (!(!_ || !_.length)) {
      var M2 = lQt(i, "color") || v4.color != null && v4.color !== "none" && (lQt(i, "colorAlpha") || lQt(i, "colorSaturation"));
      if (!!M2) {
        var I2 = i.get("visualMin"), P2 = i.get("visualMax"), N3 = t2.dataExtent.slice();
        I2 != null && I2 < N3[0] && (N3[0] = I2), P2 != null && P2 > N3[1] && (N3[1] = P2);
        var z3 = i.get("colorMappingBy"), H2 = { type: M2.name, dataExtent: N3, visual: M2.range };
        H2.type === "color" && (z3 === "index" || z3 === "id") ? (H2.mappingMethod = "category", H2.loop = true) : H2.mappingMethod = "linear";
        var $ = new Gx(H2);
        return eUe($).drColorMappingBy = z3, $;
      }
    }
  }
  function lQt(f2, i) {
    var t2 = f2.get(i);
    return Za2(t2) && t2.length ? { name: i, range: t2 } : null;
  }
  function r_r(f2, i, t2, h, v4, _) {
    var M2 = ba2({}, i);
    if (v4) {
      var I2 = v4.type, P2 = I2 === "color" && eUe(v4).drColorMappingBy, N3 = P2 === "index" ? h : P2 === "id" ? _.mapIdToIndex(t2.getId()) : t2.getValue(f2.get("visualDimension"));
      M2[I2] = v4.mapValueToVisual(N3);
    }
    return M2;
  }
  var ggt = Math.max, jEt = Math.min, E9e = y_, Fne = Qe2, rUe = ["itemStyle", "borderWidth"], i_r = ["itemStyle", "gapWidth"], a_r = ["upperLabel", "show"], o_r = ["upperLabel", "height"], s_r = { seriesType: "treemap", reset: function(f2, i, t2, h) {
    var v4 = t2.getWidth(), _ = t2.getHeight(), M2 = f2.option, I2 = u1(f2.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() }), P2 = M2.size || [], N3 = cs(E9e(I2.width, P2[0]), v4), z3 = cs(E9e(I2.height, P2[1]), _), H2 = h && h.type, $ = ["treemapZoomToNode", "treemapRootToNode"], et = pgt(h, $, f2), at = H2 === "treemapRender" || H2 === "treemapMove" ? h.rootRect : null, ht = f2.getViewRoot(), bt = XHe(ht);
    if (H2 !== "treemapMove") {
      var _t = H2 === "treemapZoomToNode" ? p_r(f2, et, ht, N3, z3) : at ? [at.width, at.height] : [N3, z3], Et = M2.sort;
      Et && Et !== "asc" && Et !== "desc" && (Et = "desc");
      var zt = { squareRatio: M2.squareRatio, sort: Et, leafDepth: M2.leafDepth };
      ht.hostTree.clearLayouts();
      var Ft = { x: 0, y: 0, width: _t[0], height: _t[1], area: _t[0] * _t[1] };
      ht.setLayout(Ft), iUe(ht, zt, false, 0), Ft = ht.getLayout(), Fne(bt, function(re2, ye) {
        var me2 = (bt[ye + 1] || ht).getValue();
        re2.setLayout(ba2({ dataExtent: [me2, me2], borderWidth: 0, upperHeight: 0 }, Ft));
      });
    }
    var fe2 = f2.getData().tree.root;
    fe2.setLayout(d_r(I2, at, et), true), f2.setLayoutInfo(I2), aUe(fe2, new Lc2(-I2.x, -I2.y, v4, _), bt, ht, 0);
  } };
  function iUe(f2, i, t2, h) {
    var v4, _;
    if (!f2.isRemoved()) {
      var M2 = f2.getLayout();
      v4 = M2.width, _ = M2.height;
      var I2 = f2.getModel(), P2 = I2.get(rUe), N3 = I2.get(i_r) / 2, z3 = oUe(I2), H2 = Math.max(P2, z3), $ = P2 - N3, et = H2 - N3;
      f2.setLayout({ borderWidth: P2, upperHeight: H2, upperLabelHeight: z3 }, true), v4 = ggt(v4 - 2 * $, 0), _ = ggt(_ - $ - et, 0);
      var at = v4 * _, ht = l_r(f2, I2, at, i, t2, h);
      if (!!ht.length) {
        var bt = { x: $, y: et, width: v4, height: _ }, _t = jEt(v4, _), Et = 1 / 0, zt = [];
        zt.area = 0;
        for (var Ft = 0, fe2 = ht.length; Ft < fe2; ) {
          var re2 = ht[Ft];
          zt.push(re2), zt.area += re2.getLayout().area;
          var ye = h_r(zt, _t, i.squareRatio);
          ye <= Et ? (Ft++, Et = ye) : (zt.area -= zt.pop().getLayout().area, k9e(zt, _t, bt, N3, false), _t = jEt(bt.width, bt.height), zt.length = zt.area = 0, Et = 1 / 0);
        }
        if (zt.length && k9e(zt, _t, bt, N3, true), !t2) {
          var me2 = I2.get("childrenVisibleMin");
          me2 != null && at < me2 && (t2 = true);
        }
        for (var Ft = 0, fe2 = ht.length; Ft < fe2; Ft++)
          iUe(ht[Ft], i, t2, h + 1);
      }
    }
  }
  function l_r(f2, i, t2, h, v4, _) {
    var M2 = f2.children || [], I2 = h.sort;
    I2 !== "asc" && I2 !== "desc" && (I2 = null);
    var P2 = h.leafDepth != null && h.leafDepth <= _;
    if (v4 && !P2)
      return f2.viewChildren = [];
    M2 = Ld2(M2, function(et) {
      return !et.isRemoved();
    }), c_r(M2, I2);
    var N3 = f_r(i, M2, I2);
    if (N3.sum === 0)
      return f2.viewChildren = [];
    if (N3.sum = u_r(i, t2, N3.sum, I2, M2), N3.sum === 0)
      return f2.viewChildren = [];
    for (var z3 = 0, H2 = M2.length; z3 < H2; z3++) {
      var $ = M2[z3].getValue() / N3.sum * t2;
      M2[z3].setLayout({ area: $ });
    }
    return P2 && (M2.length && f2.setLayout({ isLeafRoot: true }, true), M2.length = 0), f2.viewChildren = M2, f2.setLayout({ dataExtent: N3.dataExtent }, true), M2;
  }
  function u_r(f2, i, t2, h, v4) {
    if (!h)
      return t2;
    for (var _ = f2.get("visibleMin"), M2 = v4.length, I2 = M2, P2 = M2 - 1; P2 >= 0; P2--) {
      var N3 = v4[h === "asc" ? M2 - P2 - 1 : P2].getValue();
      N3 / t2 * i < _ && (I2 = P2, t2 -= N3);
    }
    return h === "asc" ? v4.splice(0, M2 - I2) : v4.splice(I2, M2 - I2), t2;
  }
  function c_r(f2, i) {
    return i && f2.sort(function(t2, h) {
      var v4 = i === "asc" ? t2.getValue() - h.getValue() : h.getValue() - t2.getValue();
      return v4 === 0 ? i === "asc" ? t2.dataIndex - h.dataIndex : h.dataIndex - t2.dataIndex : v4;
    }), f2;
  }
  function f_r(f2, i, t2) {
    for (var h = 0, v4 = 0, _ = i.length; v4 < _; v4++)
      h += i[v4].getValue();
    var M2 = f2.get("visualDimension"), I2;
    return !i || !i.length ? I2 = [NaN, NaN] : M2 === "value" && t2 ? (I2 = [i[i.length - 1].getValue(), i[0].getValue()], t2 === "asc" && I2.reverse()) : (I2 = [1 / 0, -1 / 0], Fne(i, function(P2) {
      var N3 = P2.getValue(M2);
      N3 < I2[0] && (I2[0] = N3), N3 > I2[1] && (I2[1] = N3);
    })), { sum: h, dataExtent: I2 };
  }
  function h_r(f2, i, t2) {
    for (var h = 0, v4 = 1 / 0, _ = 0, M2 = void 0, I2 = f2.length; _ < I2; _++)
      M2 = f2[_].getLayout().area, M2 && (M2 < v4 && (v4 = M2), M2 > h && (h = M2));
    var P2 = f2.area * f2.area, N3 = i * i * t2;
    return P2 ? ggt(N3 * h / P2, P2 / (N3 * v4)) : 1 / 0;
  }
  function k9e(f2, i, t2, h, v4) {
    var _ = i === t2.width ? 0 : 1, M2 = 1 - _, I2 = ["x", "y"], P2 = ["width", "height"], N3 = t2[I2[_]], z3 = i ? f2.area / i : 0;
    (v4 || z3 > t2[P2[M2]]) && (z3 = t2[P2[M2]]);
    for (var H2 = 0, $ = f2.length; H2 < $; H2++) {
      var et = f2[H2], at = {}, ht = z3 ? et.getLayout().area / z3 : 0, bt = at[P2[M2]] = ggt(z3 - 2 * h, 0), _t = t2[I2[_]] + t2[P2[_]] - N3, Et = H2 === $ - 1 || _t < ht ? _t : ht, zt = at[P2[_]] = ggt(Et - 2 * h, 0);
      at[I2[M2]] = t2[I2[M2]] + jEt(h, bt / 2), at[I2[_]] = N3 + jEt(h, zt / 2), N3 += Et, et.setLayout(at, true);
    }
    t2[I2[M2]] += z3, t2[P2[M2]] -= z3;
  }
  function p_r(f2, i, t2, h, v4) {
    var _ = (i || {}).node, M2 = [h, v4];
    if (!_ || _ === t2)
      return M2;
    for (var I2, P2 = h * v4, N3 = P2 * f2.option.zoomToNodeRatio; I2 = _.parentNode; ) {
      for (var z3 = 0, H2 = I2.children, $ = 0, et = H2.length; $ < et; $++)
        z3 += H2[$].getValue();
      var at = _.getValue();
      if (at === 0)
        return M2;
      N3 *= z3 / at;
      var ht = I2.getModel(), bt = ht.get(rUe), _t = Math.max(bt, oUe(ht));
      N3 += 4 * bt * bt + (3 * bt + _t) * Math.pow(N3, 0.5), N3 > W6e && (N3 = W6e), _ = I2;
    }
    N3 < P2 && (N3 = P2);
    var Et = Math.pow(N3 / P2, 0.5);
    return [h * Et, v4 * Et];
  }
  function d_r(f2, i, t2) {
    if (i)
      return { x: i.x, y: i.y };
    var h = { x: 0, y: 0 };
    if (!t2)
      return h;
    var v4 = t2.node, _ = v4.getLayout();
    if (!_)
      return h;
    for (var M2 = [_.width / 2, _.height / 2], I2 = v4; I2; ) {
      var P2 = I2.getLayout();
      M2[0] += P2.x, M2[1] += P2.y, I2 = I2.parentNode;
    }
    return { x: f2.width / 2 - M2[0], y: f2.height / 2 - M2[1] };
  }
  function aUe(f2, i, t2, h, v4) {
    var _ = f2.getLayout(), M2 = t2[v4], I2 = M2 && M2 === f2;
    if (!(M2 && !I2 || v4 === t2.length && f2 !== h)) {
      f2.setLayout({ isInView: true, invisible: !I2 && !i.intersect(_), isAboveViewRoot: I2 }, true);
      var P2 = new Lc2(i.x - _.x, i.y - _.y, i.width, i.height);
      Fne(f2.viewChildren || [], function(N3) {
        aUe(N3, P2, t2, h, v4 + 1);
      });
    }
  }
  function oUe(f2) {
    return f2.get(a_r) ? f2.get(o_r) : 0;
  }
  function g_r(f2) {
    f2.registerSeriesModel(Lbr), f2.registerChartView(Zbr), f2.registerVisual(Jbr), f2.registerLayout(s_r), Ebr(f2);
  }
  function v_r(f2) {
    var i = f2.findComponents({ mainType: "legend" });
    !i || !i.length || f2.eachSeriesByType("graph", function(t2) {
      var h = t2.getCategoriesData(), v4 = t2.getGraph(), _ = v4.data, M2 = h.mapArray(h.getName);
      _.filterSelf(function(I2) {
        var P2 = _.getItemModel(I2), N3 = P2.getShallow("category");
        if (N3 != null) {
          vp(N3) && (N3 = M2[N3]);
          for (var z3 = 0; z3 < i.length; z3++)
            if (!i[z3].isSelected(N3))
              return false;
        }
        return true;
      });
    });
  }
  function y_r(f2) {
    var i = {};
    f2.eachSeriesByType("graph", function(t2) {
      var h = t2.getCategoriesData(), v4 = t2.getData(), _ = {};
      h.each(function(M2) {
        var I2 = h.getName(M2);
        _["ec-" + I2] = M2;
        var P2 = h.getItemModel(M2), N3 = P2.getModel("itemStyle").getItemStyle();
        N3.fill || (N3.fill = t2.getColorFromPalette(I2, i)), h.setItemVisual(M2, "style", N3);
        for (var z3 = ["symbol", "symbolSize", "symbolKeepAspect"], H2 = 0; H2 < z3.length; H2++) {
          var $ = P2.getShallow(z3[H2], true);
          $ != null && h.setItemVisual(M2, z3[H2], $);
        }
      }), h.count() && v4.each(function(M2) {
        var I2 = v4.getItemModel(M2), P2 = I2.getShallow("category");
        if (P2 != null) {
          ms(P2) && (P2 = _["ec-" + P2]);
          var N3 = h.getItemVisual(P2, "style"), z3 = v4.ensureUniqueItemVisual(M2, "style");
          ba2(z3, N3);
          for (var H2 = ["symbol", "symbolSize", "symbolKeepAspect"], $ = 0; $ < H2.length; $++)
            v4.setItemVisual(M2, H2[$], h.getItemVisual(P2, H2[$]));
        }
      });
    });
  }
  function bDt(f2) {
    return f2 instanceof Array || (f2 = [f2, f2]), f2;
  }
  function m_r(f2) {
    f2.eachSeriesByType("graph", function(i) {
      var t2 = i.getGraph(), h = i.getEdgeData(), v4 = bDt(i.get("edgeSymbol")), _ = bDt(i.get("edgeSymbolSize"));
      h.setVisual("fromSymbol", v4 && v4[0]), h.setVisual("toSymbol", v4 && v4[1]), h.setVisual("fromSymbolSize", _ && _[0]), h.setVisual("toSymbolSize", _ && _[1]), h.setVisual("style", i.getModel("lineStyle").getLineStyle()), h.each(function(M2) {
        var I2 = h.getItemModel(M2), P2 = t2.getEdgeByIndex(M2), N3 = bDt(I2.getShallow("symbol", true)), z3 = bDt(I2.getShallow("symbolSize", true)), H2 = I2.getModel("lineStyle").getLineStyle(), $ = h.ensureUniqueItemVisual(M2, "style");
        switch (ba2($, H2), $.stroke) {
          case "source": {
            var et = P2.node1.getVisual("style");
            $.stroke = et && et.fill;
            break;
          }
          case "target": {
            var et = P2.node2.getVisual("style");
            $.stroke = et && et.fill;
            break;
          }
        }
        N3[0] && P2.setVisual("fromSymbol", N3[0]), N3[1] && P2.setVisual("toSymbol", N3[1]), z3[0] && P2.setVisual("fromSymbolSize", z3[0]), z3[1] && P2.setVisual("toSymbolSize", z3[1]);
      });
    });
  }
  var Cte = "-->", jkt = function(f2) {
    return f2.get("autoCurveness") || null;
  }, sUe = function(f2, i) {
    var t2 = jkt(f2), h = 20, v4 = [];
    if (vp(t2))
      h = t2;
    else if (Za2(t2)) {
      f2.__curvenessList = t2;
      return;
    }
    i > h && (h = i);
    var _ = h % 2 ? h + 2 : h + 3;
    v4 = [];
    for (var M2 = 0; M2 < _; M2++)
      v4.push((M2 % 2 ? M2 + 1 : M2) / 10 * (M2 % 2 ? -1 : 1));
    f2.__curvenessList = v4;
  }, vgt = function(f2, i, t2) {
    var h = [f2.id, f2.dataIndex].join("."), v4 = [i.id, i.dataIndex].join(".");
    return [t2.uid, h, v4].join(Cte);
  }, lUe = function(f2) {
    var i = f2.split(Cte);
    return [i[0], i[2], i[1]].join(Cte);
  }, b_r = function(f2, i) {
    var t2 = vgt(f2.node1, f2.node2, i);
    return i.__edgeMap[t2];
  }, __r = function(f2, i) {
    var t2 = Tte(vgt(f2.node1, f2.node2, i), i), h = Tte(vgt(f2.node2, f2.node1, i), i);
    return t2 + h;
  }, Tte = function(f2, i) {
    var t2 = i.__edgeMap;
    return t2[f2] ? t2[f2].length : 0;
  };
  function x_r(f2) {
    !jkt(f2) || (f2.__curvenessList = [], f2.__edgeMap = {}, sUe(f2));
  }
  function w_r(f2, i, t2, h) {
    if (!!jkt(t2)) {
      var v4 = vgt(f2, i, t2), _ = t2.__edgeMap, M2 = _[lUe(v4)];
      _[v4] && !M2 ? _[v4].isForward = true : M2 && _[v4] && (M2.isForward = true, _[v4].isForward = false), _[v4] = _[v4] || [], _[v4].push(h);
    }
  }
  function Vne(f2, i, t2, h) {
    var v4 = jkt(i), _ = Za2(v4);
    if (!v4)
      return null;
    var M2 = b_r(f2, i);
    if (!M2)
      return null;
    for (var I2 = -1, P2 = 0; P2 < M2.length; P2++)
      if (M2[P2] === t2) {
        I2 = P2;
        break;
      }
    var N3 = __r(f2, i);
    sUe(i, N3), f2.lineStyle = f2.lineStyle || {};
    var z3 = vgt(f2.node1, f2.node2, i), H2 = i.__curvenessList, $ = _ || N3 % 2 ? 0 : 1;
    if (M2.isForward)
      return H2[$ + I2];
    var et = lUe(z3), at = Tte(et, i), ht = H2[I2 + at + $];
    return h ? _ ? v4 && v4[0] === 0 ? (at + $) % 2 ? ht : -ht : ((at % 2 ? 0 : 1) + $) % 2 ? ht : -ht : (at + $) % 2 ? ht : -ht : H2[I2 + at + $];
  }
  function uUe(f2) {
    var i = f2.coordinateSystem;
    if (!(i && i.type !== "view")) {
      var t2 = f2.getGraph();
      t2.eachNode(function(h) {
        var v4 = h.getModel();
        h.setLayout([+v4.get("x"), +v4.get("y")]);
      }), cUe(t2, f2);
    }
  }
  function cUe(f2, i) {
    f2.eachEdge(function(t2, h) {
      var v4 = U6(t2.getModel().get(["lineStyle", "curveness"]), -Vne(t2, i, h, true), 0), _ = q6(t2.node1.getLayout()), M2 = q6(t2.node2.getLayout()), I2 = [_, M2];
      +v4 && I2.push([(_[0] + M2[0]) / 2 - (_[1] - M2[1]) * v4, (_[1] + M2[1]) / 2 - (M2[0] - _[0]) * v4]), t2.setLayout(I2);
    });
  }
  function S_r(f2, i) {
    f2.eachSeriesByType("graph", function(t2) {
      var h = t2.get("layout"), v4 = t2.coordinateSystem;
      if (v4 && v4.type !== "view") {
        var _ = t2.getData(), M2 = [];
        Qe2(v4.dimensions, function($) {
          M2 = M2.concat(_.mapDimensionsAll($));
        });
        for (var I2 = 0; I2 < _.count(); I2++) {
          for (var P2 = [], N3 = false, z3 = 0; z3 < M2.length; z3++) {
            var H2 = _.get(M2[z3], I2);
            isNaN(H2) || (N3 = true), P2.push(H2);
          }
          N3 ? _.setItemLayout(I2, v4.dataToPoint(P2)) : _.setItemLayout(I2, [NaN, NaN]);
        }
        cUe(_.graph, t2);
      } else
        (!h || h === "none") && uUe(t2);
    });
  }
  function Mdt(f2) {
    var i = f2.coordinateSystem;
    if (i.type !== "view")
      return 1;
    var t2 = f2.option.nodeScaleRatio, h = i.scaleX, v4 = i.getZoom(), _ = (v4 - 1) * t2 + 1;
    return _ / h;
  }
  function Cdt(f2) {
    var i = f2.getVisual("symbolSize");
    return i instanceof Array && (i = (i[0] + i[1]) / 2), +i;
  }
  var P9e = Math.PI, uQt = [];
  function fUe(f2, i) {
    var t2 = f2.coordinateSystem;
    if (!(t2 && t2.type !== "view")) {
      var h = t2.getBoundingRect(), v4 = f2.getData(), _ = v4.graph, M2 = h.width / 2 + h.x, I2 = h.height / 2 + h.y, P2 = Math.min(h.width, h.height) / 2, N3 = v4.count();
      v4.setLayout({ cx: M2, cy: I2 }), N3 && (M_r[i](f2, _, v4, P2, M2, I2, N3), _.eachEdge(function(z3, H2) {
        var $ = U6(z3.getModel().get(["lineStyle", "curveness"]), Vne(z3, f2, H2), 0), et = q6(z3.node1.getLayout()), at = q6(z3.node2.getLayout()), ht, bt = (et[0] + at[0]) / 2, _t = (et[1] + at[1]) / 2;
        +$ && ($ *= 3, ht = [M2 * $ + bt * (1 - $), I2 * $ + _t * (1 - $)]), z3.setLayout([et, at, ht]);
      }));
    }
  }
  var M_r = { value: function(f2, i, t2, h, v4, _, M2) {
    var I2 = 0, P2 = t2.getSum("value"), N3 = Math.PI * 2 / (P2 || M2);
    i.eachNode(function(z3) {
      var H2 = z3.getValue("value"), $ = N3 * (P2 ? H2 : 1) / 2;
      I2 += $, z3.setLayout([h * Math.cos(I2) + v4, h * Math.sin(I2) + _]), I2 += $;
    });
  }, symbolSize: function(f2, i, t2, h, v4, _, M2) {
    var I2 = 0;
    uQt.length = M2;
    var P2 = Mdt(f2);
    i.eachNode(function(H2) {
      var $ = Cdt(H2);
      isNaN($) && ($ = 2), $ < 0 && ($ = 0), $ *= P2;
      var et = Math.asin($ / 2 / h);
      isNaN(et) && (et = P9e / 2), uQt[H2.dataIndex] = et, I2 += et * 2;
    });
    var N3 = (2 * P9e - I2) / M2 / 2, z3 = 0;
    i.eachNode(function(H2) {
      var $ = N3 + uQt[H2.dataIndex];
      z3 += $, H2.setLayout([h * Math.cos(z3) + v4, h * Math.sin(z3) + _]), z3 += $;
    });
  } };
  function C_r(f2) {
    f2.eachSeriesByType("graph", function(i) {
      i.get("layout") === "circular" && fUe(i, "symbolSize");
    });
  }
  var ftt = dJt;
  function T_r(f2, i, t2) {
    for (var h = f2, v4 = i, _ = t2.rect, M2 = _.width, I2 = _.height, P2 = [_.x + M2 / 2, _.y + I2 / 2], N3 = t2.gravity == null ? 0.1 : t2.gravity, z3 = 0; z3 < h.length; z3++) {
      var H2 = h[z3];
      H2.p || (H2.p = wU(M2 * (Math.random() - 0.5) + P2[0], I2 * (Math.random() - 0.5) + P2[1])), H2.pp = q6(H2.p), H2.edges = null;
    }
    var $ = t2.friction == null ? 0.6 : t2.friction, et = $, at, ht;
    return { warmUp: function() {
      et = $ * 0.8;
    }, setFixed: function(bt) {
      h[bt].fixed = true;
    }, setUnfixed: function(bt) {
      h[bt].fixed = false;
    }, beforeStep: function(bt) {
      at = bt;
    }, afterStep: function(bt) {
      ht = bt;
    }, step: function(bt) {
      at && at(h, v4);
      for (var _t = [], Et = h.length, zt = 0; zt < v4.length; zt++) {
        var Ft = v4[zt];
        if (!Ft.ignoreForceLayout) {
          var fe2 = Ft.n1, re2 = Ft.n2;
          tU(_t, re2.p, fe2.p);
          var ye = gJt(_t) - Ft.d, me2 = re2.w / (fe2.w + re2.w);
          isNaN(me2) && (me2 = 0), Sgt(_t, _t), !fe2.fixed && ftt(fe2.p, fe2.p, _t, me2 * ye * et), !re2.fixed && ftt(re2.p, re2.p, _t, -(1 - me2) * ye * et);
        }
      }
      for (var zt = 0; zt < Et; zt++) {
        var be2 = h[zt];
        be2.fixed || (tU(_t, P2, be2.p), ftt(be2.p, be2.p, _t, N3 * et));
      }
      for (var zt = 0; zt < Et; zt++)
        for (var fe2 = h[zt], Te2 = zt + 1; Te2 < Et; Te2++) {
          var re2 = h[Te2];
          tU(_t, re2.p, fe2.p);
          var ye = gJt(_t);
          ye === 0 && (Elr(_t, Math.random() - 0.5, Math.random() - 0.5), ye = 1);
          var We = (fe2.rep + re2.rep) / ye / ye;
          !fe2.fixed && ftt(fe2.pp, fe2.pp, _t, We), !re2.fixed && ftt(re2.pp, re2.pp, _t, -We);
        }
      for (var en = [], zt = 0; zt < Et; zt++) {
        var be2 = h[zt];
        be2.fixed || (tU(en, be2.p, be2.pp), ftt(be2.p, be2.p, en, et), N2(be2.pp, be2.p));
      }
      et = et * 0.992;
      var Ue2 = et < 0.01;
      ht && ht(h, v4, Ue2), bt && bt(Ue2);
    } };
  }
  function A_r(f2) {
    f2.eachSeriesByType("graph", function(i) {
      var t2 = i.coordinateSystem;
      if (!(t2 && t2.type !== "view"))
        if (i.get("layout") === "force") {
          var h = i.preservedPoints || {}, v4 = i.getGraph(), _ = v4.data, M2 = v4.edgeData, I2 = i.getModel("force"), P2 = I2.get("initLayout");
          i.preservedPoints ? _.each(function(zt) {
            var Ft = _.getId(zt);
            _.setItemLayout(zt, h[Ft] || [NaN, NaN]);
          }) : !P2 || P2 === "none" ? uUe(i) : P2 === "circular" && fUe(i, "value");
          var N3 = _.getDataExtent("value"), z3 = M2.getDataExtent("value"), H2 = I2.get("repulsion"), $ = I2.get("edgeLength"), et = Za2(H2) ? H2 : [H2, H2], at = Za2($) ? $ : [$, $];
          at = [at[1], at[0]];
          var ht = _.mapArray("value", function(zt, Ft) {
            var fe2 = _.getItemLayout(Ft), re2 = cd2(zt, N3, et);
            return isNaN(re2) && (re2 = (et[0] + et[1]) / 2), { w: re2, rep: re2, fixed: _.getItemModel(Ft).get("fixed"), p: !fe2 || isNaN(fe2[0]) || isNaN(fe2[1]) ? null : fe2 };
          }), bt = M2.mapArray("value", function(zt, Ft) {
            var fe2 = v4.getEdgeByIndex(Ft), re2 = cd2(zt, z3, at);
            isNaN(re2) && (re2 = (at[0] + at[1]) / 2);
            var ye = fe2.getModel(), me2 = U6(fe2.getModel().get(["lineStyle", "curveness"]), -Vne(fe2, i, Ft, true), 0);
            return { n1: ht[fe2.node1.dataIndex], n2: ht[fe2.node2.dataIndex], d: re2, curveness: me2, ignoreForceLayout: ye.get("ignoreForceLayout") };
          }), _t = t2.getBoundingRect(), Et = T_r(ht, bt, { rect: _t, gravity: I2.get("gravity"), friction: I2.get("friction") });
          Et.beforeStep(function(zt, Ft) {
            for (var fe2 = 0, re2 = zt.length; fe2 < re2; fe2++)
              zt[fe2].fixed && N2(zt[fe2].p, v4.getNodeByIndex(fe2).getLayout());
          }), Et.afterStep(function(zt, Ft, fe2) {
            for (var re2 = 0, ye = zt.length; re2 < ye; re2++)
              zt[re2].fixed || v4.getNodeByIndex(re2).setLayout(zt[re2].p), h[_.getId(re2)] = zt[re2].p;
            for (var re2 = 0, ye = Ft.length; re2 < ye; re2++) {
              var me2 = Ft[re2], be2 = v4.getEdgeByIndex(re2), Te2 = me2.n1.p, We = me2.n2.p, en = be2.getLayout();
              en = en ? en.slice() : [], en[0] = en[0] || [], en[1] = en[1] || [], N2(en[0], Te2), N2(en[1], We), +me2.curveness && (en[2] = [(Te2[0] + We[0]) / 2 - (Te2[1] - We[1]) * me2.curveness, (Te2[1] + We[1]) / 2 - (We[0] - Te2[0]) * me2.curveness]), be2.setLayout(en);
            }
          }), i.forceLayout = Et, i.preservedPoints = h, Et.step();
        } else
          i.forceLayout = null;
    });
  }
  function I_r(f2, i, t2) {
    var h = ba2(f2.getBoxLayoutParams(), { aspect: t2 });
    return u1(h, { width: i.getWidth(), height: i.getHeight() });
  }
  function D_r(f2, i) {
    var t2 = [];
    return f2.eachSeriesByType("graph", function(h) {
      var v4 = h.get("coordinateSystem");
      if (!v4 || v4 === "view") {
        var _ = h.getData(), M2 = _.mapArray(function(bt) {
          var _t = _.getItemModel(bt);
          return [+_t.get("x"), +_t.get("y")];
        }), I2 = [], P2 = [];
        dkt(M2, I2, P2), P2[0] - I2[0] === 0 && (P2[0] += 1, I2[0] -= 1), P2[1] - I2[1] === 0 && (P2[1] += 1, I2[1] -= 1);
        var N3 = (P2[0] - I2[0]) / (P2[1] - I2[1]), z3 = I_r(h, i, N3);
        isNaN(N3) && (I2 = [z3.x, z3.y], P2 = [z3.x + z3.width, z3.y + z3.height]);
        var H2 = P2[0] - I2[0], $ = P2[1] - I2[1], et = z3.width, at = z3.height, ht = h.coordinateSystem = new Hgt();
        ht.zoomLimit = h.get("scaleLimit"), ht.setBoundingRect(I2[0], I2[1], H2, $), ht.setViewRect(z3.x, z3.y, et, at), ht.setCenter(h.get("center")), ht.setZoom(h.get("zoom")), t2.push(ht);
      }
    }), t2;
  }
  var L9e = m_.prototype, cQt = mkt.prototype, hUe = function() {
    function f2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return f2;
  }();
  (function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i;
  })(hUe);
  function fQt(f2) {
    return isNaN(+f2.cpx1) || isNaN(+f2.cpy1);
  }
  var E_r = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "ec-line", h;
    }
    return i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new hUe();
    }, i.prototype.buildPath = function(t2, h) {
      fQt(h) ? L9e.buildPath.call(this, t2, h) : cQt.buildPath.call(this, t2, h);
    }, i.prototype.pointAt = function(t2) {
      return fQt(this.shape) ? L9e.pointAt.call(this, t2) : cQt.pointAt.call(this, t2);
    }, i.prototype.tangentAt = function(t2) {
      var h = this.shape, v4 = fQt(h) ? [h.x2 - h.x1, h.y2 - h.y1] : cQt.tangentAt.call(this, t2);
      return Sgt(v4, v4);
    }, i;
  }(Uc2), k_r = E_r, hQt = ["fromSymbol", "toSymbol"];
  function O9e(f2) {
    return "_" + f2 + "Type";
  }
  function R9e(f2, i, t2) {
    var h = i.getItemVisual(t2, f2);
    if (!(!h || h === "none")) {
      var v4 = i.getItemVisual(t2, f2 + "Size"), _ = i.getItemVisual(t2, f2 + "Rotate"), M2 = i.getItemVisual(t2, f2 + "Offset"), I2 = i.getItemVisual(t2, f2 + "KeepAspect"), P2 = Ogt(v4), N3 = fet(M2 || 0, P2), z3 = wm(h, -P2[0] / 2 + N3[0], -P2[1] / 2 + N3[1], P2[0], P2[1], null, I2);
      return z3.__specifiedRotation = _ == null || isNaN(_) ? void 0 : +_ * Math.PI / 180 || 0, z3.name = f2, z3;
    }
  }
  function P_r(f2) {
    var i = new k_r({ name: "line", subPixelOptimize: true });
    return Ate(i.shape, f2), i;
  }
  function Ate(f2, i) {
    f2.x1 = i[0][0], f2.y1 = i[0][1], f2.x2 = i[1][0], f2.y2 = i[1][1], f2.percent = 1;
    var t2 = i[2];
    t2 ? (f2.cpx1 = t2[0], f2.cpy1 = t2[1]) : (f2.cpx1 = NaN, f2.cpy1 = NaN);
  }
  var L_r = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this) || this;
      return _._createLine(t2, h, v4), _;
    }
    return i.prototype._createLine = function(t2, h, v4) {
      var _ = t2.hostModel, M2 = t2.getItemLayout(h), I2 = P_r(M2);
      I2.shape.percent = 0, Qv(I2, { shape: { percent: 1 } }, _, h), this.add(I2), Qe2(hQt, function(P2) {
        var N3 = R9e(P2, t2, h);
        this.add(N3), this[O9e(P2)] = t2.getItemVisual(h, P2);
      }, this), this._updateCommonStl(t2, h, v4);
    }, i.prototype.updateData = function(t2, h, v4) {
      var _ = t2.hostModel, M2 = this.childOfName("line"), I2 = t2.getItemLayout(h), P2 = { shape: {} };
      Ate(P2.shape, I2), jh2(M2, P2, _, h), Qe2(hQt, function(N3) {
        var z3 = t2.getItemVisual(h, N3), H2 = O9e(N3);
        if (this[H2] !== z3) {
          this.remove(this.childOfName(N3));
          var $ = R9e(N3, t2, h);
          this.add($);
        }
        this[H2] = z3;
      }, this), this._updateCommonStl(t2, h, v4);
    }, i.prototype.getLinePath = function() {
      return this.childAt(0);
    }, i.prototype._updateCommonStl = function(t2, h, v4) {
      var _ = t2.hostModel, M2 = this.childOfName("line"), I2 = v4 && v4.emphasisLineStyle, P2 = v4 && v4.blurLineStyle, N3 = v4 && v4.selectLineStyle, z3 = v4 && v4.labelStatesModels, H2 = v4 && v4.emphasisDisabled, $ = v4 && v4.focus, et = v4 && v4.blurScope;
      if (!v4 || t2.hasItemOption) {
        var at = t2.getItemModel(h), ht = at.getModel("emphasis");
        I2 = ht.getModel("lineStyle").getLineStyle(), P2 = at.getModel(["blur", "lineStyle"]).getLineStyle(), N3 = at.getModel(["select", "lineStyle"]).getLineStyle(), H2 = ht.get("disabled"), $ = ht.get("focus"), et = ht.get("blurScope"), z3 = b_(at);
      }
      var bt = t2.getItemVisual(h, "style"), _t = bt.stroke;
      M2.useStyle(bt), M2.style.fill = null, M2.style.strokeNoScale = true, M2.ensureState("emphasis").style = I2, M2.ensureState("blur").style = P2, M2.ensureState("select").style = N3, Qe2(hQt, function(re2) {
        var ye = this.childOfName(re2);
        if (ye) {
          ye.setColor(_t), ye.style.opacity = bt.opacity;
          for (var me2 = 0; me2 < j2.length; me2++) {
            var be2 = j2[me2], Te2 = M2.getState(be2);
            if (Te2) {
              var We = Te2.style || {}, en = ye.ensureState(be2), Ue2 = en.style || (en.style = {});
              We.stroke != null && (Ue2[ye.__isEmptyBrush ? "stroke" : "fill"] = We.stroke), We.opacity != null && (Ue2.opacity = We.opacity);
            }
          }
          ye.markRedraw();
        }
      }, this);
      var Et = _.getRawValue(h);
      SS(this, z3, { labelDataIndex: h, labelFetcher: { getFormattedLabel: function(re2, ye) {
        return _.getFormattedLabel(re2, ye, t2.dataType);
      } }, inheritColor: _t || "#000", defaultOpacity: bt.opacity, defaultText: (Et == null ? t2.getName(h) : isFinite(Et) ? gy(Et) : Et) + "" });
      var zt = this.getTextContent();
      if (zt) {
        var Ft = z3.normal;
        zt.__align = zt.style.align, zt.__verticalAlign = zt.style.verticalAlign, zt.__position = Ft.get("position") || "middle";
        var fe2 = Ft.get("distance");
        Za2(fe2) || (fe2 = [fe2, fe2]), zt.__labelDistance = fe2;
      }
      this.setTextConfig({ position: null, local: true, inside: false }), vy(this, $, et, H2);
    }, i.prototype.highlight = function() {
      NL(this);
    }, i.prototype.downplay = function() {
      FL(this);
    }, i.prototype.updateLayout = function(t2, h) {
      this.setLinePoints(t2.getItemLayout(h));
    }, i.prototype.setLinePoints = function(t2) {
      var h = this.childOfName("line");
      Ate(h.shape, t2), h.dirty();
    }, i.prototype.beforeUpdate = function() {
      var t2 = this, h = t2.childOfName("fromSymbol"), v4 = t2.childOfName("toSymbol"), _ = t2.getTextContent();
      if (!h && !v4 && (!_ || _.ignore))
        return;
      for (var M2 = 1, I2 = this.parent; I2; )
        I2.scaleX && (M2 /= I2.scaleX), I2 = I2.parent;
      var P2 = t2.childOfName("line");
      if (!this.__dirty && !P2.__dirty)
        return;
      var N3 = P2.shape.percent, z3 = P2.pointAt(0), H2 = P2.pointAt(N3), $ = tU([], H2, z3);
      Sgt($, $);
      function et(Te2, We) {
        var en = Te2.__specifiedRotation;
        if (en == null) {
          var Ue2 = P2.tangentAt(We);
          Te2.attr("rotation", (We === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(Ue2[1], Ue2[0]));
        } else
          Te2.attr("rotation", en);
      }
      if (h && (h.setPosition(z3), et(h, 0), h.scaleX = h.scaleY = M2 * N3, h.markRedraw()), v4 && (v4.setPosition(H2), et(v4, 1), v4.scaleX = v4.scaleY = M2 * N3, v4.markRedraw()), _ && !_.ignore) {
        _.x = _.y = 0, _.originX = _.originY = 0;
        var at = void 0, ht = void 0, bt = _.__labelDistance, _t = bt[0] * M2, Et = bt[1] * M2, zt = N3 / 2, Ft = P2.tangentAt(zt), fe2 = [Ft[1], -Ft[0]], re2 = P2.pointAt(zt);
        fe2[1] > 0 && (fe2[0] = -fe2[0], fe2[1] = -fe2[1]);
        var ye = Ft[0] < 0 ? -1 : 1;
        if (_.__position !== "start" && _.__position !== "end") {
          var me2 = -Math.atan2(Ft[1], Ft[0]);
          H2[0] < z3[0] && (me2 = Math.PI + me2), _.rotation = me2;
        }
        var be2 = void 0;
        switch (_.__position) {
          case "insideStartTop":
          case "insideMiddleTop":
          case "insideEndTop":
          case "middle":
            be2 = -Et, ht = "bottom";
            break;
          case "insideStartBottom":
          case "insideMiddleBottom":
          case "insideEndBottom":
            be2 = Et, ht = "top";
            break;
          default:
            be2 = 0, ht = "middle";
        }
        switch (_.__position) {
          case "end":
            _.x = $[0] * _t + H2[0], _.y = $[1] * Et + H2[1], at = $[0] > 0.8 ? "left" : $[0] < -0.8 ? "right" : "center", ht = $[1] > 0.8 ? "top" : $[1] < -0.8 ? "bottom" : "middle";
            break;
          case "start":
            _.x = -$[0] * _t + z3[0], _.y = -$[1] * Et + z3[1], at = $[0] > 0.8 ? "right" : $[0] < -0.8 ? "left" : "center", ht = $[1] > 0.8 ? "bottom" : $[1] < -0.8 ? "top" : "middle";
            break;
          case "insideStartTop":
          case "insideStart":
          case "insideStartBottom":
            _.x = _t * ye + z3[0], _.y = z3[1] + be2, at = Ft[0] < 0 ? "right" : "left", _.originX = -_t * ye, _.originY = -be2;
            break;
          case "insideMiddleTop":
          case "insideMiddle":
          case "insideMiddleBottom":
          case "middle":
            _.x = re2[0], _.y = re2[1] + be2, at = "center", _.originY = -be2;
            break;
          case "insideEndTop":
          case "insideEnd":
          case "insideEndBottom":
            _.x = -_t * ye + H2[0], _.y = H2[1] + be2, at = Ft[0] >= 0 ? "right" : "left", _.originX = _t * ye, _.originY = -be2;
            break;
        }
        _.scaleX = _.scaleY = M2, _.setStyle({ verticalAlign: _.__verticalAlign || ht, align: _.__align || at });
      }
    }, i;
  }(mu), Bne = L_r, O_r = function() {
    function f2(i) {
      this.group = new mu(), this._LineCtor = i || Bne;
    }
    return f2.prototype.updateData = function(i) {
      var t2 = this;
      this._progressiveEls = null;
      var h = this, v4 = h.group, _ = h._lineData;
      h._lineData = i, _ || v4.removeAll();
      var M2 = N9e(i);
      i.diff(_).add(function(I2) {
        t2._doAdd(i, I2, M2);
      }).update(function(I2, P2) {
        t2._doUpdate(_, i, P2, I2, M2);
      }).remove(function(I2) {
        v4.remove(_.getItemGraphicEl(I2));
      }).execute();
    }, f2.prototype.updateLayout = function() {
      var i = this._lineData;
      !i || i.eachItemGraphicEl(function(t2, h) {
        t2.updateLayout(i, h);
      }, this);
    }, f2.prototype.incrementalPrepareUpdate = function(i) {
      this._seriesScope = N9e(i), this._lineData = null, this.group.removeAll();
    }, f2.prototype.incrementalUpdate = function(i, t2) {
      this._progressiveEls = [];
      function h(I2) {
        !I2.isGroup && !R_r(I2) && (I2.incremental = true, I2.ensureState("emphasis").hoverLayer = true);
      }
      for (var v4 = i.start; v4 < i.end; v4++) {
        var _ = t2.getItemLayout(v4);
        if (pQt(_)) {
          var M2 = new this._LineCtor(t2, v4, this._seriesScope);
          M2.traverse(h), this.group.add(M2), t2.setItemGraphicEl(v4, M2), this._progressiveEls.push(M2);
        }
      }
    }, f2.prototype.remove = function() {
      this.group.removeAll();
    }, f2.prototype.eachRendered = function(i) {
      oV(this._progressiveEls || this.group, i);
    }, f2.prototype._doAdd = function(i, t2, h) {
      var v4 = i.getItemLayout(t2);
      if (!!pQt(v4)) {
        var _ = new this._LineCtor(i, t2, h);
        i.setItemGraphicEl(t2, _), this.group.add(_);
      }
    }, f2.prototype._doUpdate = function(i, t2, h, v4, _) {
      var M2 = i.getItemGraphicEl(h);
      if (!pQt(t2.getItemLayout(v4))) {
        this.group.remove(M2);
        return;
      }
      M2 ? M2.updateData(t2, v4, _) : M2 = new this._LineCtor(t2, v4, _), t2.setItemGraphicEl(v4, M2), this.group.add(M2);
    }, f2;
  }();
  function R_r(f2) {
    return f2.animators && f2.animators.length > 0;
  }
  function N9e(f2) {
    var i = f2.hostModel, t2 = i.getModel("emphasis");
    return { lineStyle: i.getModel("lineStyle").getLineStyle(), emphasisLineStyle: t2.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: i.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: i.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: t2.get("disabled"), blurScope: t2.get("blurScope"), focus: t2.get("focus"), labelStatesModels: b_(i) };
  }
  function F9e(f2) {
    return isNaN(f2[0]) || isNaN(f2[1]);
  }
  function pQt(f2) {
    return f2 && !F9e(f2[0]) && !F9e(f2[1]);
  }
  var zne = O_r, dQt = [], gQt = [], vQt = [], htt = v_, yQt = oU, V9e = Math.abs;
  function B9e(f2, i, t2) {
    for (var h = f2[0], v4 = f2[1], _ = f2[2], M2 = 1 / 0, I2, P2 = t2 * t2, N3 = 0.1, z3 = 0.1; z3 <= 0.9; z3 += 0.1) {
      dQt[0] = htt(h[0], v4[0], _[0], z3), dQt[1] = htt(h[1], v4[1], _[1], z3);
      var H2 = V9e(yQt(dQt, i) - P2);
      H2 < M2 && (M2 = H2, I2 = z3);
    }
    for (var $ = 0; $ < 32; $++) {
      var et = I2 + N3;
      gQt[0] = htt(h[0], v4[0], _[0], I2), gQt[1] = htt(h[1], v4[1], _[1], I2), vQt[0] = htt(h[0], v4[0], _[0], et), vQt[1] = htt(h[1], v4[1], _[1], et);
      var H2 = yQt(gQt, i) - P2;
      if (V9e(H2) < 0.01)
        break;
      var at = yQt(vQt, i) - P2;
      N3 /= 2, H2 < 0 ? at >= 0 ? I2 = I2 + N3 : I2 = I2 - N3 : at >= 0 ? I2 = I2 - N3 : I2 = I2 + N3;
    }
    return I2;
  }
  function mQt(f2, i) {
    var t2 = [], h = $dt, v4 = [[], [], []], _ = [[], []], M2 = [];
    i /= 2, f2.eachEdge(function(I2, P2) {
      var N3 = I2.getLayout(), z3 = I2.getVisual("fromSymbol"), H2 = I2.getVisual("toSymbol");
      N3.__original || (N3.__original = [q6(N3[0]), q6(N3[1])], N3[2] && N3.__original.push(q6(N3[2])));
      var $ = N3.__original;
      if (N3[2] != null) {
        if (N2(v4[0], $[0]), N2(v4[1], $[2]), N2(v4[2], $[1]), z3 && z3 !== "none") {
          var et = Cdt(I2.node1), at = B9e(v4, $[0], et * i);
          h(v4[0][0], v4[1][0], v4[2][0], at, t2), v4[0][0] = t2[3], v4[1][0] = t2[4], h(v4[0][1], v4[1][1], v4[2][1], at, t2), v4[0][1] = t2[3], v4[1][1] = t2[4];
        }
        if (H2 && H2 !== "none") {
          var et = Cdt(I2.node2), at = B9e(v4, $[1], et * i);
          h(v4[0][0], v4[1][0], v4[2][0], at, t2), v4[1][0] = t2[1], v4[2][0] = t2[2], h(v4[0][1], v4[1][1], v4[2][1], at, t2), v4[1][1] = t2[1], v4[2][1] = t2[2];
        }
        N2(N3[0], v4[0]), N2(N3[1], v4[2]), N2(N3[2], v4[1]);
      } else {
        if (N2(_[0], $[0]), N2(_[1], $[1]), tU(M2, _[1], _[0]), Sgt(M2, M2), z3 && z3 !== "none") {
          var et = Cdt(I2.node1);
          dJt(_[0], _[0], M2, et * i);
        }
        if (H2 && H2 !== "none") {
          var et = Cdt(I2.node2);
          dJt(_[1], _[1], M2, -et * i);
        }
        N2(N3[0], _[0]), N2(N3[1], _[1]);
      }
    });
  }
  function z9e(f2) {
    return f2.type === "view";
  }
  var N_r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2, h) {
      var v4 = new Bgt(), _ = new zne(), M2 = this.group;
      this._controller = new Ggt(h.getZr()), this._controllerHost = { target: M2 }, M2.add(v4.group), M2.add(_.group), this._symbolDraw = v4, this._lineDraw = _, this._firstRender = true;
    }, i.prototype.render = function(t2, h, v4) {
      var _ = this, M2 = t2.coordinateSystem;
      this._model = t2;
      var I2 = this._symbolDraw, P2 = this._lineDraw, N3 = this.group;
      if (z9e(M2)) {
        var z3 = { x: M2.x, y: M2.y, scaleX: M2.scaleX, scaleY: M2.scaleY };
        this._firstRender ? N3.attr(z3) : jh2(N3, z3, t2);
      }
      mQt(t2.getGraph(), Mdt(t2));
      var H2 = t2.getData();
      I2.updateData(H2);
      var $ = t2.getEdgeData();
      P2.updateData($), this._updateNodeAndLinkScale(), this._updateController(t2, h, v4), clearTimeout(this._layoutTimeout);
      var et = t2.forceLayout, at = t2.get(["force", "layoutAnimation"]);
      et && this._startForceLayoutIteration(et, at), H2.graph.eachNode(function(Et) {
        var zt = Et.dataIndex, Ft = Et.getGraphicEl(), fe2 = Et.getModel();
        if (!!Ft) {
          Ft.off("drag").off("dragend");
          var re2 = fe2.get("draggable");
          re2 && Ft.on("drag", function() {
            et && (et.warmUp(), !_._layouting && _._startForceLayoutIteration(et, at), et.setFixed(zt), H2.setItemLayout(zt, [Ft.x, Ft.y]));
          }).on("dragend", function() {
            et && et.setUnfixed(zt);
          }), Ft.setDraggable(re2 && !!et);
          var ye = fe2.get(["emphasis", "focus"]);
          ye === "adjacency" && (Du(Ft).focus = Et.getAdjacentDataIndices());
        }
      }), H2.graph.eachEdge(function(Et) {
        var zt = Et.getGraphicEl(), Ft = Et.getModel().get(["emphasis", "focus"]);
        !zt || Ft === "adjacency" && (Du(zt).focus = { edge: [Et.dataIndex], node: [Et.node1.dataIndex, Et.node2.dataIndex] });
      });
      var ht = t2.get("layout") === "circular" && t2.get(["circular", "rotateLabel"]), bt = H2.getLayout("cx"), _t = H2.getLayout("cy");
      H2.eachItemGraphicEl(function(Et, zt) {
        var Ft = H2.getItemModel(zt), fe2 = Ft.get(["label", "rotate"]) || 0, re2 = Et.getSymbolPath();
        if (ht) {
          var ye = H2.getItemLayout(zt), me2 = Math.atan2(ye[1] - _t, ye[0] - bt);
          me2 < 0 && (me2 = Math.PI * 2 + me2);
          var be2 = ye[0] < bt;
          be2 && (me2 = me2 - Math.PI);
          var Te2 = be2 ? "left" : "right";
          re2.setTextConfig({ rotation: -me2, position: Te2, origin: "center" });
          var We = re2.ensureState("emphasis");
          ba2(We.textConfig || (We.textConfig = {}), { position: Te2 });
        } else
          re2.setTextConfig({ rotation: fe2 *= Math.PI / 180 });
      }), this._firstRender = false;
    }, i.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, i.prototype._startForceLayoutIteration = function(t2, h) {
      var v4 = this;
      (function _() {
        t2.step(function(M2) {
          v4.updateLayout(v4._model), (v4._layouting = !M2) && (h ? v4._layoutTimeout = setTimeout(_, 16) : _());
        });
      })();
    }, i.prototype._updateController = function(t2, h, v4) {
      var _ = this, M2 = this._controller, I2 = this._controllerHost, P2 = this.group;
      if (M2.setPointerChecker(function(N3, z3, H2) {
        var $ = P2.getBoundingRect();
        return $.applyTransform(P2.transform), $.contain(z3, H2) && !Vkt(N3, v4, t2);
      }), !z9e(t2.coordinateSystem)) {
        M2.disable();
        return;
      }
      M2.enable(t2.get("roam")), I2.zoomLimit = t2.get("scaleLimit"), I2.zoom = t2.coordinateSystem.getZoom(), M2.off("pan").off("zoom").on("pan", function(N3) {
        Dne(I2, N3.dx, N3.dy), v4.dispatchAction({ seriesId: t2.id, type: "graphRoam", dx: N3.dx, dy: N3.dy });
      }).on("zoom", function(N3) {
        Ene(I2, N3.scale, N3.originX, N3.originY), v4.dispatchAction({ seriesId: t2.id, type: "graphRoam", zoom: N3.scale, originX: N3.originX, originY: N3.originY }), _._updateNodeAndLinkScale(), mQt(t2.getGraph(), Mdt(t2)), _._lineDraw.updateLayout(), v4.updateLabelLayout();
      });
    }, i.prototype._updateNodeAndLinkScale = function() {
      var t2 = this._model, h = t2.getData(), v4 = Mdt(t2);
      h.eachItemGraphicEl(function(_, M2) {
        _ && _.setSymbolScale(v4);
      });
    }, i.prototype.updateLayout = function(t2) {
      mQt(t2.getGraph(), Mdt(t2)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
    }, i.prototype.remove = function(t2, h) {
      this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
    }, i.type = "graph", i;
  }(Hg2), F_r = N_r;
  function ptt(f2) {
    return "_EC_" + f2;
  }
  var V_r = function() {
    function f2(i) {
      this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = i || false;
    }
    return f2.prototype.isDirected = function() {
      return this._directed;
    }, f2.prototype.addNode = function(i, t2) {
      i = i == null ? "" + t2 : "" + i;
      var h = this._nodesMap;
      if (!h[ptt(i)]) {
        var v4 = new ZH(i, t2);
        return v4.hostGraph = this, this.nodes.push(v4), h[ptt(i)] = v4, v4;
      }
    }, f2.prototype.getNodeByIndex = function(i) {
      var t2 = this.data.getRawIndex(i);
      return this.nodes[t2];
    }, f2.prototype.getNodeById = function(i) {
      return this._nodesMap[ptt(i)];
    }, f2.prototype.addEdge = function(i, t2, h) {
      var v4 = this._nodesMap, _ = this._edgesMap;
      if (vp(i) && (i = this.nodes[i]), vp(t2) && (t2 = this.nodes[t2]), i instanceof ZH || (i = v4[ptt(i)]), t2 instanceof ZH || (t2 = v4[ptt(t2)]), !(!i || !t2)) {
        var M2 = i.id + "-" + t2.id, I2 = new pUe(i, t2, h);
        return I2.hostGraph = this, this._directed && (i.outEdges.push(I2), t2.inEdges.push(I2)), i.edges.push(I2), i !== t2 && t2.edges.push(I2), this.edges.push(I2), _[M2] = I2, I2;
      }
    }, f2.prototype.getEdgeByIndex = function(i) {
      var t2 = this.edgeData.getRawIndex(i);
      return this.edges[t2];
    }, f2.prototype.getEdge = function(i, t2) {
      i instanceof ZH && (i = i.id), t2 instanceof ZH && (t2 = t2.id);
      var h = this._edgesMap;
      return this._directed ? h[i + "-" + t2] : h[i + "-" + t2] || h[t2 + "-" + i];
    }, f2.prototype.eachNode = function(i, t2) {
      for (var h = this.nodes, v4 = h.length, _ = 0; _ < v4; _++)
        h[_].dataIndex >= 0 && i.call(t2, h[_], _);
    }, f2.prototype.eachEdge = function(i, t2) {
      for (var h = this.edges, v4 = h.length, _ = 0; _ < v4; _++)
        h[_].dataIndex >= 0 && h[_].node1.dataIndex >= 0 && h[_].node2.dataIndex >= 0 && i.call(t2, h[_], _);
    }, f2.prototype.breadthFirstTraverse = function(i, t2, h, v4) {
      if (t2 instanceof ZH || (t2 = this._nodesMap[ptt(t2)]), !!t2) {
        for (var _ = h === "out" ? "outEdges" : h === "in" ? "inEdges" : "edges", M2 = 0; M2 < this.nodes.length; M2++)
          this.nodes[M2].__visited = false;
        if (!i.call(v4, t2, null))
          for (var I2 = [t2]; I2.length; )
            for (var P2 = I2.shift(), N3 = P2[_], M2 = 0; M2 < N3.length; M2++) {
              var z3 = N3[M2], H2 = z3.node1 === P2 ? z3.node2 : z3.node1;
              if (!H2.__visited) {
                if (i.call(v4, H2, P2))
                  return;
                I2.push(H2), H2.__visited = true;
              }
            }
      }
    }, f2.prototype.update = function() {
      for (var i = this.data, t2 = this.edgeData, h = this.nodes, v4 = this.edges, _ = 0, M2 = h.length; _ < M2; _++)
        h[_].dataIndex = -1;
      for (var _ = 0, M2 = i.count(); _ < M2; _++)
        h[i.getRawIndex(_)].dataIndex = _;
      t2.filterSelf(function(I2) {
        var P2 = v4[t2.getRawIndex(I2)];
        return P2.node1.dataIndex >= 0 && P2.node2.dataIndex >= 0;
      });
      for (var _ = 0, M2 = v4.length; _ < M2; _++)
        v4[_].dataIndex = -1;
      for (var _ = 0, M2 = t2.count(); _ < M2; _++)
        v4[t2.getRawIndex(_)].dataIndex = _;
    }, f2.prototype.clone = function() {
      for (var i = new f2(this._directed), t2 = this.nodes, h = this.edges, v4 = 0; v4 < t2.length; v4++)
        i.addNode(t2[v4].id, t2[v4].dataIndex);
      for (var v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4];
        i.addEdge(_.node1.id, _.node2.id, _.dataIndex);
      }
      return i;
    }, f2;
  }(), ZH = function() {
    function f2(i, t2) {
      this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = i == null ? "" : i, this.dataIndex = t2 == null ? -1 : t2;
    }
    return f2.prototype.degree = function() {
      return this.edges.length;
    }, f2.prototype.inDegree = function() {
      return this.inEdges.length;
    }, f2.prototype.outDegree = function() {
      return this.outEdges.length;
    }, f2.prototype.getModel = function(i) {
      if (!(this.dataIndex < 0)) {
        var t2 = this.hostGraph, h = t2.data.getItemModel(this.dataIndex);
        return h.getModel(i);
      }
    }, f2.prototype.getAdjacentDataIndices = function() {
      for (var i = { edge: [], node: [] }, t2 = 0; t2 < this.edges.length; t2++) {
        var h = this.edges[t2];
        h.dataIndex < 0 || (i.edge.push(h.dataIndex), i.node.push(h.node1.dataIndex, h.node2.dataIndex));
      }
      return i;
    }, f2;
  }(), pUe = function() {
    function f2(i, t2, h) {
      this.dataIndex = -1, this.node1 = i, this.node2 = t2, this.dataIndex = h == null ? -1 : h;
    }
    return f2.prototype.getModel = function(i) {
      if (!(this.dataIndex < 0)) {
        var t2 = this.hostGraph, h = t2.edgeData.getItemModel(this.dataIndex);
        return h.getModel(i);
      }
    }, f2.prototype.getAdjacentDataIndices = function() {
      return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
    }, f2;
  }();
  function dUe(f2, i) {
    return { getValue: function(t2) {
      var h = this[f2][i];
      return h.getStore().get(h.getDimensionIndex(t2 || "value"), this.dataIndex);
    }, setVisual: function(t2, h) {
      this.dataIndex >= 0 && this[f2][i].setItemVisual(this.dataIndex, t2, h);
    }, getVisual: function(t2) {
      return this[f2][i].getItemVisual(this.dataIndex, t2);
    }, setLayout: function(t2, h) {
      this.dataIndex >= 0 && this[f2][i].setItemLayout(this.dataIndex, t2, h);
    }, getLayout: function() {
      return this[f2][i].getItemLayout(this.dataIndex);
    }, getGraphicEl: function() {
      return this[f2][i].getItemGraphicEl(this.dataIndex);
    }, getRawIndex: function() {
      return this[f2][i].getRawIndex(this.dataIndex);
    } };
  }
  Sm(ZH, dUe("hostGraph", "data"));
  Sm(pUe, dUe("hostGraph", "edgeData"));
  var B_r = V_r;
  function gUe(f2, i, t2, h, v4) {
    for (var _ = new B_r(h), M2 = 0; M2 < f2.length; M2++)
      _.addNode(y_(f2[M2].id, f2[M2].name, M2), M2);
    for (var I2 = [], P2 = [], N3 = 0, M2 = 0; M2 < i.length; M2++) {
      var z3 = i[M2], H2 = z3.source, $ = z3.target;
      _.addEdge(H2, $, N3) && (P2.push(z3), I2.push(y_(l1(z3.id, null), H2 + " > " + $)), N3++);
    }
    var et = t2.get("coordinateSystem"), at;
    if (et === "cartesian2d" || et === "polar")
      at = aN(f2, t2);
    else {
      var ht = Pgt.get(et), bt = ht ? ht.dimensions || [] : [];
      Pc2(bt, "value") < 0 && bt.concat(["value"]);
      var _t = Rgt(f2, { coordDimensions: bt, encodeDefine: t2.getEncode() }).dimensions;
      at = new B2(_t, t2), at.initData(f2);
    }
    var Et = new B2(["value"], t2);
    return Et.initData(P2, I2), v4 && v4(at, Et), YHe({ mainData: at, struct: _, structAttr: "graph", datas: { node: at, edge: Et }, datasAttr: { node: "data", edge: "edgeData" } }), _.update(), _;
  }
  var z_r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.hasSymbolVisual = true, t2;
    }
    return i.prototype.init = function(t2) {
      f2.prototype.init.apply(this, arguments);
      var h = this;
      function v4() {
        return h._categoriesData;
      }
      this.legendVisualProvider = new Wgt(v4, v4), this.fillDataTextStyle(t2.edges || t2.links), this._updateCategoriesData();
    }, i.prototype.mergeOption = function(t2) {
      f2.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(t2.edges || t2.links), this._updateCategoriesData();
    }, i.prototype.mergeDefaultAndTheme = function(t2) {
      f2.prototype.mergeDefaultAndTheme.apply(this, arguments), gU(t2, "edgeLabel", ["show"]);
    }, i.prototype.getInitialData = function(t2, h) {
      var v4 = t2.edges || t2.links || [], _ = t2.data || t2.nodes || [], M2 = this;
      if (_ && v4) {
        x_r(this);
        var I2 = gUe(_, v4, this, true, P2);
        return Qe2(I2.edges, function(N3) {
          w_r(N3.node1, N3.node2, this, N3.dataIndex);
        }, this), I2.data;
      }
      function P2(N3, z3) {
        N3.wrapMethod("getItemModel", function(at) {
          var ht = M2._categoriesModels, bt = at.getShallow("category"), _t = ht[bt];
          return _t && (_t.parentModel = at.parentModel, at.parentModel = _t), at;
        });
        var H2 = Gg2.prototype.getModel;
        function $(at, ht) {
          var bt = H2.call(this, at, ht);
          return bt.resolveParentPath = et, bt;
        }
        z3.wrapMethod("getItemModel", function(at) {
          return at.resolveParentPath = et, at.getModel = $, at;
        });
        function et(at) {
          if (at && (at[0] === "label" || at[1] === "label")) {
            var ht = at.slice();
            return at[0] === "label" ? ht[0] = "edgeLabel" : at[1] === "label" && (ht[1] = "edgeLabel"), ht;
          }
          return at;
        }
      }
    }, i.prototype.getGraph = function() {
      return this.getData().graph;
    }, i.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, i.prototype.getCategoriesData = function() {
      return this._categoriesData;
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      if (v4 === "edge") {
        var _ = this.getData(), M2 = this.getDataParams(t2, v4), I2 = _.graph.getEdgeByIndex(t2), P2 = _.getName(I2.node1.dataIndex), N3 = _.getName(I2.node2.dataIndex), z3 = [];
        return P2 != null && z3.push(P2), N3 != null && z3.push(N3), pb2("nameValue", { name: z3.join(" > "), value: M2.value, noValue: M2.value == null });
      }
      var H2 = FWe({ series: this, dataIndex: t2, multipleSeries: h });
      return H2;
    }, i.prototype._updateCategoriesData = function() {
      var t2 = Xa2(this.option.categories || [], function(v4) {
        return v4.value != null ? v4 : ba2({ value: 0 }, v4);
      }), h = new B2(["value"], this);
      h.initData(t2), this._categoriesData = h, this._categoriesModels = h.mapArray(function(v4) {
        return h.getItemModel(v4);
      });
    }, i.prototype.setZoom = function(t2) {
      this.option.zoom = t2;
    }, i.prototype.setCenter = function(t2) {
      this.option.center = t2;
    }, i.prototype.isAnimationEnabled = function() {
      return f2.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
    }, i.type = "series.graph", i.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], i.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, i;
  }(Jv), j_r = z_r, W_r = { type: "graphRoam", event: "graphRoam", update: "none" };
  function G_r(f2) {
    f2.registerChartView(F_r), f2.registerSeriesModel(j_r), f2.registerProcessor(v_r), f2.registerVisual(y_r), f2.registerVisual(m_r), f2.registerLayout(S_r), f2.registerLayout(f2.PRIORITY.VISUAL.POST_CHART_LAYOUT, C_r), f2.registerLayout(A_r), f2.registerCoordinateSystem("graphView", { dimensions: Hgt.dimensions, create: D_r }), f2.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, xm), f2.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, xm), f2.registerAction(W_r, function(i, t2) {
      t2.eachComponent({ mainType: "series", query: i }, function(h) {
        var v4 = h.coordinateSystem, _ = Pne(v4, i);
        h.setCenter && h.setCenter(_.center), h.setZoom && h.setZoom(_.zoom);
      });
    });
  }
  var H_r = function() {
    function f2() {
      this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
    }
    return f2;
  }(), U_r = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "pointer", h;
    }
    return i.prototype.getDefaultShape = function() {
      return new H_r();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = Math.cos, _ = Math.sin, M2 = h.r, I2 = h.width, P2 = h.angle, N3 = h.x - v4(P2) * I2 * (I2 >= M2 / 3 ? 1 : 2), z3 = h.y - _(P2) * I2 * (I2 >= M2 / 3 ? 1 : 2);
      P2 = h.angle - Math.PI / 2, t2.moveTo(N3, z3), t2.lineTo(h.x + v4(P2) * I2, h.y + _(P2) * I2), t2.lineTo(h.x + v4(h.angle) * M2, h.y + _(h.angle) * M2), t2.lineTo(h.x - v4(P2) * I2, h.y - _(P2) * I2), t2.lineTo(N3, z3);
    }, i;
  }(Uc2), q_r = U_r;
  function Z_r(f2, i) {
    var t2 = f2.get("center"), h = i.getWidth(), v4 = i.getHeight(), _ = Math.min(h, v4), M2 = cs(t2[0], i.getWidth()), I2 = cs(t2[1], i.getHeight()), P2 = cs(f2.get("radius"), _ / 2);
    return { cx: M2, cy: I2, r: P2 };
  }
  function _Dt(f2, i) {
    var t2 = f2 == null ? "" : f2 + "";
    return i && (ms(i) ? t2 = i.replace("{value}", t2) : Ol(i) && (t2 = i(f2))), t2;
  }
  var bQt = Math.PI * 2, $_r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      this.group.removeAll();
      var _ = t2.get(["axisLine", "lineStyle", "color"]), M2 = Z_r(t2, v4);
      this._renderMain(t2, h, v4, _, M2), this._data = t2.getData();
    }, i.prototype.dispose = function() {
    }, i.prototype._renderMain = function(t2, h, v4, _, M2) {
      for (var I2 = this.group, P2 = t2.get("clockwise"), N3 = -t2.get("startAngle") / 180 * Math.PI, z3 = -t2.get("endAngle") / 180 * Math.PI, H2 = t2.getModel("axisLine"), $ = H2.get("roundCap"), et = $ ? NEt : rC, at = H2.get("show"), ht = H2.getModel("lineStyle"), bt = ht.get("width"), _t = !((z3 - N3) % bQt) && z3 !== N3 ? bQt : (z3 - N3) % bQt, Et = N3, zt = 0; at && zt < _.length; zt++) {
        var Ft = Math.min(Math.max(_[zt][0], 0), 1);
        z3 = N3 + _t * Ft;
        var fe2 = new et({ shape: { startAngle: Et, endAngle: z3, cx: M2.cx, cy: M2.cy, clockwise: P2, r0: M2.r - bt, r: M2.r }, silent: true });
        fe2.setStyle({ fill: _[zt][1] }), fe2.setStyle(ht.getLineStyle(["color", "width"])), I2.add(fe2), Et = z3;
      }
      var re2 = function(me2) {
        if (me2 <= 0)
          return _[0][1];
        var be2;
        for (be2 = 0; be2 < _.length; be2++)
          if (_[be2][0] >= me2 && (be2 === 0 ? 0 : _[be2 - 1][0]) < me2)
            return _[be2][1];
        return _[be2 - 1][1];
      };
      if (!P2) {
        var ye = N3;
        N3 = z3, z3 = ye;
      }
      this._renderTicks(t2, h, v4, re2, M2, N3, z3, P2, bt), this._renderTitleAndDetail(t2, h, v4, re2, M2), this._renderAnchor(t2, M2), this._renderPointer(t2, h, v4, re2, M2, N3, z3, P2, bt);
    }, i.prototype._renderTicks = function(t2, h, v4, _, M2, I2, P2, N3, z3) {
      for (var H2 = this.group, $ = M2.cx, et = M2.cy, at = M2.r, ht = +t2.get("min"), bt = +t2.get("max"), _t = t2.getModel("splitLine"), Et = t2.getModel("axisTick"), zt = t2.getModel("axisLabel"), Ft = t2.get("splitNumber"), fe2 = Et.get("splitNumber"), re2 = cs(_t.get("length"), at), ye = cs(Et.get("length"), at), me2 = I2, be2 = (P2 - I2) / Ft, Te2 = be2 / fe2, We = _t.getModel("lineStyle").getLineStyle(), en = Et.getModel("lineStyle").getLineStyle(), Ue2 = _t.get("distance"), Mn, Vn, xn = 0; xn <= Ft; xn++) {
        if (Mn = Math.cos(me2), Vn = Math.sin(me2), _t.get("show")) {
          var Zr = Ue2 ? Ue2 + z3 : z3, nr = new m_({ shape: { x1: Mn * (at - Zr) + $, y1: Vn * (at - Zr) + et, x2: Mn * (at - re2 - Zr) + $, y2: Vn * (at - re2 - Zr) + et }, style: We, silent: true });
          We.stroke === "auto" && nr.setStyle({ stroke: _(xn / Ft) }), H2.add(nr);
        }
        if (zt.get("show")) {
          var Zr = zt.get("distance") + Ue2, pr = _Dt(gy(xn / Ft * (bt - ht) + ht), zt.get("formatter")), Nr = _(xn / Ft);
          H2.add(new op({ style: By(zt, { text: pr, x: Mn * (at - re2 - Zr) + $, y: Vn * (at - re2 - Zr) + et, verticalAlign: Vn < -0.8 ? "top" : Vn > 0.8 ? "bottom" : "middle", align: Mn < -0.4 ? "left" : Mn > 0.4 ? "right" : "center" }, { inheritColor: Nr }), silent: true }));
        }
        if (Et.get("show") && xn !== Ft) {
          var Zr = Et.get("distance");
          Zr = Zr ? Zr + z3 : z3;
          for (var ai2 = 0; ai2 <= fe2; ai2++) {
            Mn = Math.cos(me2), Vn = Math.sin(me2);
            var gi2 = new m_({ shape: { x1: Mn * (at - Zr) + $, y1: Vn * (at - Zr) + et, x2: Mn * (at - ye - Zr) + $, y2: Vn * (at - ye - Zr) + et }, silent: true, style: en });
            en.stroke === "auto" && gi2.setStyle({ stroke: _((xn + ai2 / fe2) / Ft) }), H2.add(gi2), me2 += Te2;
          }
          me2 -= Te2;
        } else
          me2 += be2;
      }
    }, i.prototype._renderPointer = function(t2, h, v4, _, M2, I2, P2, N3, z3) {
      var H2 = this.group, $ = this._data, et = this._progressEls, at = [], ht = t2.get(["pointer", "show"]), bt = t2.getModel("progress"), _t = bt.get("show"), Et = t2.getData(), zt = Et.mapDimension("value"), Ft = +t2.get("min"), fe2 = +t2.get("max"), re2 = [Ft, fe2], ye = [I2, P2];
      function me2(Te2, We) {
        var en = Et.getItemModel(Te2), Ue2 = en.getModel("pointer"), Mn = cs(Ue2.get("width"), M2.r), Vn = cs(Ue2.get("length"), M2.r), xn = t2.get(["pointer", "icon"]), Zr = Ue2.get("offsetCenter"), nr = cs(Zr[0], M2.r), pr = cs(Zr[1], M2.r), Nr = Ue2.get("keepAspect"), ai2;
        return xn ? ai2 = wm(xn, nr - Mn / 2, pr - Vn, Mn, Vn, null, Nr) : ai2 = new q_r({ shape: { angle: -Math.PI / 2, width: Mn, r: Vn, x: nr, y: pr } }), ai2.rotation = -(We + Math.PI / 2), ai2.x = M2.cx, ai2.y = M2.cy, ai2;
      }
      function be2(Te2, We) {
        var en = bt.get("roundCap"), Ue2 = en ? NEt : rC, Mn = bt.get("overlap"), Vn = Mn ? bt.get("width") : z3 / Et.count(), xn = Mn ? M2.r - Vn : M2.r - (Te2 + 1) * Vn, Zr = Mn ? M2.r : M2.r - Te2 * Vn, nr = new Ue2({ shape: { startAngle: I2, endAngle: We, cx: M2.cx, cy: M2.cy, clockwise: N3, r0: xn, r: Zr } });
        return Mn && (nr.z2 = fe2 - Et.get(zt, Te2) % fe2), nr;
      }
      (_t || ht) && (Et.diff($).add(function(Te2) {
        var We = Et.get(zt, Te2);
        if (ht) {
          var en = me2(Te2, I2);
          Qv(en, { rotation: -((isNaN(+We) ? ye[0] : cd2(We, re2, ye, true)) + Math.PI / 2) }, t2), H2.add(en), Et.setItemGraphicEl(Te2, en);
        }
        if (_t) {
          var Ue2 = be2(Te2, I2), Mn = bt.get("clip");
          Qv(Ue2, { shape: { endAngle: cd2(We, re2, ye, Mn) } }, t2), H2.add(Ue2), BJt(t2.seriesIndex, Et.dataType, Te2, Ue2), at[Te2] = Ue2;
        }
      }).update(function(Te2, We) {
        var en = Et.get(zt, Te2);
        if (ht) {
          var Ue2 = $.getItemGraphicEl(We), Mn = Ue2 ? Ue2.rotation : I2, Vn = me2(Te2, Mn);
          Vn.rotation = Mn, jh2(Vn, { rotation: -((isNaN(+en) ? ye[0] : cd2(en, re2, ye, true)) + Math.PI / 2) }, t2), H2.add(Vn), Et.setItemGraphicEl(Te2, Vn);
        }
        if (_t) {
          var xn = et[We], Zr = xn ? xn.shape.endAngle : I2, nr = be2(Te2, Zr), pr = bt.get("clip");
          jh2(nr, { shape: { endAngle: cd2(en, re2, ye, pr) } }, t2), H2.add(nr), BJt(t2.seriesIndex, Et.dataType, Te2, nr), at[Te2] = nr;
        }
      }).execute(), Et.each(function(Te2) {
        var We = Et.getItemModel(Te2), en = We.getModel("emphasis"), Ue2 = en.get("focus"), Mn = en.get("blurScope"), Vn = en.get("disabled");
        if (ht) {
          var xn = Et.getItemGraphicEl(Te2), Zr = Et.getItemVisual(Te2, "style"), nr = Zr.fill;
          if (xn instanceof Ux) {
            var pr = xn.style;
            xn.useStyle(ba2({ image: pr.image, x: pr.x, y: pr.y, width: pr.width, height: pr.height }, Zr));
          } else
            xn.useStyle(Zr), xn.type !== "pointer" && xn.setColor(nr);
          xn.setStyle(We.getModel(["pointer", "itemStyle"]).getItemStyle()), xn.style.fill === "auto" && xn.setStyle("fill", _(cd2(Et.get(zt, Te2), re2, [0, 1], true))), xn.z2EmphasisLift = 0, Hx(xn, We), vy(xn, Ue2, Mn, Vn);
        }
        if (_t) {
          var Nr = at[Te2];
          Nr.useStyle(Et.getItemVisual(Te2, "style")), Nr.setStyle(We.getModel(["progress", "itemStyle"]).getItemStyle()), Nr.z2EmphasisLift = 0, Hx(Nr, We), vy(Nr, Ue2, Mn, Vn);
        }
      }), this._progressEls = at);
    }, i.prototype._renderAnchor = function(t2, h) {
      var v4 = t2.getModel("anchor"), _ = v4.get("show");
      if (_) {
        var M2 = v4.get("size"), I2 = v4.get("icon"), P2 = v4.get("offsetCenter"), N3 = v4.get("keepAspect"), z3 = wm(I2, h.cx - M2 / 2 + cs(P2[0], h.r), h.cy - M2 / 2 + cs(P2[1], h.r), M2, M2, null, N3);
        z3.z2 = v4.get("showAbove") ? 1 : 0, z3.setStyle(v4.getModel("itemStyle").getItemStyle()), this.group.add(z3);
      }
    }, i.prototype._renderTitleAndDetail = function(t2, h, v4, _, M2) {
      var I2 = this, P2 = t2.getData(), N3 = P2.mapDimension("value"), z3 = +t2.get("min"), H2 = +t2.get("max"), $ = new mu(), et = [], at = [], ht = t2.isAnimationEnabled(), bt = t2.get(["pointer", "showAbove"]);
      P2.diff(this._data).add(function(_t) {
        et[_t] = new op({ silent: true }), at[_t] = new op({ silent: true });
      }).update(function(_t, Et) {
        et[_t] = I2._titleEls[Et], at[_t] = I2._detailEls[Et];
      }).execute(), P2.each(function(_t) {
        var Et = P2.getItemModel(_t), zt = P2.get(N3, _t), Ft = new mu(), fe2 = _(cd2(zt, [z3, H2], [0, 1], true)), re2 = Et.getModel("title");
        if (re2.get("show")) {
          var ye = re2.get("offsetCenter"), me2 = M2.cx + cs(ye[0], M2.r), be2 = M2.cy + cs(ye[1], M2.r), Te2 = et[_t];
          Te2.attr({ z2: bt ? 0 : 2, style: By(re2, { x: me2, y: be2, text: P2.getName(_t), align: "center", verticalAlign: "middle" }, { inheritColor: fe2 }) }), Ft.add(Te2);
        }
        var We = Et.getModel("detail");
        if (We.get("show")) {
          var en = We.get("offsetCenter"), Ue2 = M2.cx + cs(en[0], M2.r), Mn = M2.cy + cs(en[1], M2.r), Vn = cs(We.get("width"), M2.r), xn = cs(We.get("height"), M2.r), Zr = t2.get(["progress", "show"]) ? P2.getItemVisual(_t, "style").fill : fe2, Te2 = at[_t], nr = We.get("formatter");
          Te2.attr({ z2: bt ? 0 : 2, style: By(We, { x: Ue2, y: Mn, text: _Dt(zt, nr), width: isNaN(Vn) ? null : Vn, height: isNaN(xn) ? null : xn, align: "center", verticalAlign: "middle" }, { inheritColor: Zr }) }), Bje(Te2, { normal: We }, zt, function(Nr) {
            return _Dt(Nr, nr);
          }), ht && zje(Te2, _t, P2, t2, { getFormattedLabel: function(Nr, ai2, gi2, To, us, ml) {
            return _Dt(ml ? ml.interpolatedValue : zt, nr);
          } }), Ft.add(Te2);
        }
        $.add(Ft);
      }), this.group.add($), this._titleEls = et, this._detailEls = at;
    }, i.type = "gauge", i;
  }(Hg2), Y_r = $_r, K_r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.visualStyleAccessPath = "itemStyle", t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      return het(this, ["value"]);
    }, i.type = "series.gauge", i.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, i;
  }(Jv), X_r = K_r;
  function Q_r(f2) {
    f2.registerChartView(Y_r), f2.registerSeriesModel(X_r);
  }
  var J_r = ["itemStyle", "opacity"], txr = function(f2) {
    ii2(i, f2);
    function i(t2, h) {
      var v4 = f2.call(this) || this, _ = v4, M2 = new aC(), I2 = new op();
      return _.setTextContent(I2), v4.setTextGuideLine(M2), v4.updateData(t2, h, true), v4;
    }
    return i.prototype.updateData = function(t2, h, v4) {
      var _ = this, M2 = t2.hostModel, I2 = t2.getItemModel(h), P2 = t2.getItemLayout(h), N3 = I2.getModel("emphasis"), z3 = I2.get(J_r);
      z3 = z3 == null ? 1 : z3, v4 || A5(_), _.useStyle(t2.getItemVisual(h, "style")), _.style.lineJoin = "round", v4 ? (_.setShape({ points: P2.points }), _.style.opacity = 0, Qv(_, { style: { opacity: z3 } }, M2, h)) : jh2(_, { style: { opacity: z3 }, shape: { points: P2.points } }, M2, h), Hx(_, I2), this._updateLabel(t2, h), vy(this, N3.get("focus"), N3.get("blurScope"), N3.get("disabled"));
    }, i.prototype._updateLabel = function(t2, h) {
      var v4 = this, _ = this.getTextGuideLine(), M2 = v4.getTextContent(), I2 = t2.hostModel, P2 = t2.getItemModel(h), N3 = t2.getItemLayout(h), z3 = N3.label, H2 = t2.getItemVisual(h, "style"), $ = H2.fill;
      SS(M2, b_(P2), { labelFetcher: t2.hostModel, labelDataIndex: h, defaultOpacity: H2.opacity, defaultText: t2.getName(h) }, { normal: { align: z3.textAlign, verticalAlign: z3.verticalAlign } }), v4.setTextConfig({ local: true, inside: !!z3.inside, insideStroke: $, outsideFill: $ });
      var et = z3.linePoints;
      _.setShape({ points: et }), v4.textGuideLineConfig = { anchor: et ? new ac2(et[0][0], et[0][1]) : null }, jh2(M2, { style: { x: z3.x, y: z3.y } }, I2, h), M2.attr({ rotation: z3.rotation, originX: z3.x, originY: z3.y, z2: 10 }), _ne(v4, xne(P2), { stroke: $ });
    }, i;
  }(iC), exr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.ignoreLabelLineUpdate = true, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this._data, I2 = this.group;
      _.diff(M2).add(function(P2) {
        var N3 = new txr(_, P2);
        _.setItemGraphicEl(P2, N3), I2.add(N3);
      }).update(function(P2, N3) {
        var z3 = M2.getItemGraphicEl(N3);
        z3.updateData(_, P2), I2.add(z3), _.setItemGraphicEl(P2, z3);
      }).remove(function(P2) {
        var N3 = M2.getItemGraphicEl(P2);
        tgt(N3, t2, P2);
      }).execute(), this._data = _;
    }, i.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, i.prototype.dispose = function() {
    }, i.type = "funnel", i;
  }(Hg2), nxr = exr, rxr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2) {
      f2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Wgt(ks(this.getData, this), ks(this.getRawData, this)), this._defaultLabelLine(t2);
    }, i.prototype.getInitialData = function(t2, h) {
      return het(this, { coordDimensions: ["value"], encodeDefaulter: Ou(Kee, this) });
    }, i.prototype._defaultLabelLine = function(t2) {
      gU(t2, "labelLine", ["show"]);
      var h = t2.labelLine, v4 = t2.emphasis.labelLine;
      h.show = h.show && t2.label.show, v4.show = v4.show && t2.emphasis.label.show;
    }, i.prototype.getDataParams = function(t2) {
      var h = this.getData(), v4 = f2.prototype.getDataParams.call(this, t2), _ = h.mapDimension("value"), M2 = h.getSum(_);
      return v4.percent = M2 ? +(h.get(_, t2) / M2 * 100).toFixed(2) : 0, v4.$vars.push("percent"), v4;
    }, i.type = "series.funnel", i.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, i;
  }(Jv), ixr = rxr;
  function axr(f2, i) {
    return u1(f2.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
  }
  function oxr(f2, i) {
    for (var t2 = f2.mapDimension("value"), h = f2.mapArray(t2, function(P2) {
      return P2;
    }), v4 = [], _ = i === "ascending", M2 = 0, I2 = f2.count(); M2 < I2; M2++)
      v4[M2] = M2;
    return Ol(i) ? v4.sort(i) : i !== "none" && v4.sort(function(P2, N3) {
      return _ ? h[P2] - h[N3] : h[N3] - h[P2];
    }), v4;
  }
  function sxr(f2) {
    var i = f2.hostModel, t2 = i.get("orient");
    f2.each(function(h) {
      var v4 = f2.getItemModel(h), _ = v4.getModel("label"), M2 = _.get("position"), I2 = v4.getModel("labelLine"), P2 = f2.getItemLayout(h), N3 = P2.points, z3 = M2 === "inner" || M2 === "inside" || M2 === "center" || M2 === "insideLeft" || M2 === "insideRight", H2, $, et, at;
      if (z3)
        M2 === "insideLeft" ? ($ = (N3[0][0] + N3[3][0]) / 2 + 5, et = (N3[0][1] + N3[3][1]) / 2, H2 = "left") : M2 === "insideRight" ? ($ = (N3[1][0] + N3[2][0]) / 2 - 5, et = (N3[1][1] + N3[2][1]) / 2, H2 = "right") : ($ = (N3[0][0] + N3[1][0] + N3[2][0] + N3[3][0]) / 4, et = (N3[0][1] + N3[1][1] + N3[2][1] + N3[3][1]) / 4, H2 = "center"), at = [[$, et], [$, et]];
      else {
        var ht = void 0, bt = void 0, _t = void 0, Et = void 0, zt = I2.get("length");
        M2 === "left" ? (ht = (N3[3][0] + N3[0][0]) / 2, bt = (N3[3][1] + N3[0][1]) / 2, _t = ht - zt, $ = _t - 5, H2 = "right") : M2 === "right" ? (ht = (N3[1][0] + N3[2][0]) / 2, bt = (N3[1][1] + N3[2][1]) / 2, _t = ht + zt, $ = _t + 5, H2 = "left") : M2 === "top" ? (ht = (N3[3][0] + N3[0][0]) / 2, bt = (N3[3][1] + N3[0][1]) / 2, Et = bt - zt, et = Et - 5, H2 = "center") : M2 === "bottom" ? (ht = (N3[1][0] + N3[2][0]) / 2, bt = (N3[1][1] + N3[2][1]) / 2, Et = bt + zt, et = Et + 5, H2 = "center") : M2 === "rightTop" ? (ht = t2 === "horizontal" ? N3[3][0] : N3[1][0], bt = t2 === "horizontal" ? N3[3][1] : N3[1][1], t2 === "horizontal" ? (Et = bt - zt, et = Et - 5, H2 = "center") : (_t = ht + zt, $ = _t + 5, H2 = "top")) : M2 === "rightBottom" ? (ht = N3[2][0], bt = N3[2][1], t2 === "horizontal" ? (Et = bt + zt, et = Et + 5, H2 = "center") : (_t = ht + zt, $ = _t + 5, H2 = "bottom")) : M2 === "leftTop" ? (ht = N3[0][0], bt = t2 === "horizontal" ? N3[0][1] : N3[1][1], t2 === "horizontal" ? (Et = bt - zt, et = Et - 5, H2 = "center") : (_t = ht - zt, $ = _t - 5, H2 = "right")) : M2 === "leftBottom" ? (ht = t2 === "horizontal" ? N3[1][0] : N3[3][0], bt = t2 === "horizontal" ? N3[1][1] : N3[2][1], t2 === "horizontal" ? (Et = bt + zt, et = Et + 5, H2 = "center") : (_t = ht - zt, $ = _t - 5, H2 = "right")) : (ht = (N3[1][0] + N3[2][0]) / 2, bt = (N3[1][1] + N3[2][1]) / 2, t2 === "horizontal" ? (Et = bt + zt, et = Et + 5, H2 = "center") : (_t = ht + zt, $ = _t + 5, H2 = "left")), t2 === "horizontal" ? (_t = ht, $ = _t) : (Et = bt, et = Et), at = [[ht, bt], [_t, Et]];
      }
      P2.label = { linePoints: at, x: $, y: et, verticalAlign: "middle", textAlign: H2, inside: z3 };
    });
  }
  function lxr(f2, i) {
    f2.eachSeriesByType("funnel", function(t2) {
      var h = t2.getData(), v4 = h.mapDimension("value"), _ = t2.get("sort"), M2 = axr(t2, i), I2 = t2.get("orient"), P2 = M2.width, N3 = M2.height, z3 = oxr(h, _), H2 = M2.x, $ = M2.y, et = I2 === "horizontal" ? [cs(t2.get("minSize"), N3), cs(t2.get("maxSize"), N3)] : [cs(t2.get("minSize"), P2), cs(t2.get("maxSize"), P2)], at = h.getDataExtent(v4), ht = t2.get("min"), bt = t2.get("max");
      ht == null && (ht = Math.min(at[0], 0)), bt == null && (bt = at[1]);
      var _t = t2.get("funnelAlign"), Et = t2.get("gap"), zt = I2 === "horizontal" ? P2 : N3, Ft = (zt - Et * (h.count() - 1)) / h.count(), fe2 = function(Mn, Vn) {
        if (I2 === "horizontal") {
          var xn = h.get(v4, Mn) || 0, Zr = cd2(xn, [ht, bt], et, true), nr = void 0;
          switch (_t) {
            case "top":
              nr = $;
              break;
            case "center":
              nr = $ + (N3 - Zr) / 2;
              break;
            case "bottom":
              nr = $ + (N3 - Zr);
              break;
          }
          return [[Vn, nr], [Vn, nr + Zr]];
        }
        var pr = h.get(v4, Mn) || 0, Nr = cd2(pr, [ht, bt], et, true), ai2;
        switch (_t) {
          case "left":
            ai2 = H2;
            break;
          case "center":
            ai2 = H2 + (P2 - Nr) / 2;
            break;
          case "right":
            ai2 = H2 + P2 - Nr;
            break;
        }
        return [[ai2, Vn], [ai2 + Nr, Vn]];
      };
      _ === "ascending" && (Ft = -Ft, Et = -Et, I2 === "horizontal" ? H2 += P2 : $ += N3, z3 = z3.reverse());
      for (var re2 = 0; re2 < z3.length; re2++) {
        var ye = z3[re2], me2 = z3[re2 + 1], be2 = h.getItemModel(ye);
        if (I2 === "horizontal") {
          var Te2 = be2.get(["itemStyle", "width"]);
          Te2 == null ? Te2 = Ft : (Te2 = cs(Te2, P2), _ === "ascending" && (Te2 = -Te2));
          var We = fe2(ye, H2), en = fe2(me2, H2 + Te2);
          H2 += Te2 + Et, h.setItemLayout(ye, { points: We.concat(en.slice().reverse()) });
        } else {
          var Ue2 = be2.get(["itemStyle", "height"]);
          Ue2 == null ? Ue2 = Ft : (Ue2 = cs(Ue2, N3), _ === "ascending" && (Ue2 = -Ue2));
          var We = fe2(ye, $), en = fe2(me2, $ + Ue2);
          $ += Ue2 + Et, h.setItemLayout(ye, { points: We.concat(en.slice().reverse()) });
        }
      }
      sxr(h);
    });
  }
  function uxr(f2) {
    f2.registerChartView(nxr), f2.registerSeriesModel(ixr), f2.registerLayout(lxr), f2.registerProcessor(jgt("funnel"));
  }
  var cxr = 0.3, fxr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._dataGroup = new mu(), t2._initialized = false, t2;
    }
    return i.prototype.init = function() {
      this.group.add(this._dataGroup);
    }, i.prototype.render = function(t2, h, v4, _) {
      this._progressiveEls = null;
      var M2 = this._dataGroup, I2 = t2.getData(), P2 = this._data, N3 = t2.coordinateSystem, z3 = N3.dimensions, H2 = W9e(t2);
      I2.diff(P2).add($).update(et).remove(at).execute();
      function $(bt) {
        var _t = j9e(I2, M2, bt, z3, N3);
        _Qt(_t, I2, bt, H2);
      }
      function et(bt, _t) {
        var Et = P2.getItemGraphicEl(_t), zt = vUe(I2, bt, z3, N3);
        I2.setItemGraphicEl(bt, Et), jh2(Et, { shape: { points: zt } }, t2, bt), A5(Et), _Qt(Et, I2, bt, H2);
      }
      function at(bt) {
        var _t = P2.getItemGraphicEl(bt);
        M2.remove(_t);
      }
      if (!this._initialized) {
        this._initialized = true;
        var ht = hxr(N3, t2, function() {
          setTimeout(function() {
            M2.removeClipPath();
          });
        });
        M2.setClipPath(ht);
      }
      this._data = I2;
    }, i.prototype.incrementalPrepareRender = function(t2, h, v4) {
      this._initialized = true, this._data = null, this._dataGroup.removeAll();
    }, i.prototype.incrementalRender = function(t2, h, v4) {
      for (var _ = h.getData(), M2 = h.coordinateSystem, I2 = M2.dimensions, P2 = W9e(h), N3 = this._progressiveEls = [], z3 = t2.start; z3 < t2.end; z3++) {
        var H2 = j9e(_, this._dataGroup, z3, I2, M2);
        H2.incremental = true, _Qt(H2, _, z3, P2), N3.push(H2);
      }
    }, i.prototype.remove = function() {
      this._dataGroup && this._dataGroup.removeAll(), this._data = null;
    }, i.type = "parallel", i;
  }(Hg2);
  function hxr(f2, i, t2) {
    var h = f2.model, v4 = f2.getRect(), _ = new Sh2({ shape: { x: v4.x, y: v4.y, width: v4.width, height: v4.height } }), M2 = h.get("layout") === "horizontal" ? "width" : "height";
    return _.setShape(M2, 0), Qv(_, { shape: { width: v4.width, height: v4.height } }, i, t2), _;
  }
  function vUe(f2, i, t2, h) {
    for (var v4 = [], _ = 0; _ < t2.length; _++) {
      var M2 = t2[_], I2 = f2.get(f2.mapDimension(M2), i);
      pxr(I2, h.getAxis(M2).type) || v4.push(h.dataToPoint(I2, M2));
    }
    return v4;
  }
  function j9e(f2, i, t2, h, v4) {
    var _ = vUe(f2, t2, h, v4), M2 = new aC({ shape: { points: _ }, z2: 10 });
    return i.add(M2), f2.setItemGraphicEl(t2, M2), M2;
  }
  function W9e(f2) {
    var i = f2.get("smooth", true);
    return i === true && (i = cxr), i = tN(i), Zdt(i) && (i = 0), { smooth: i };
  }
  function _Qt(f2, i, t2, h) {
    f2.useStyle(i.getItemVisual(t2, "style")), f2.style.fill = null, f2.setShape("smooth", h.smooth);
    var v4 = i.getItemModel(t2), _ = v4.getModel("emphasis");
    Hx(f2, v4, "lineStyle"), vy(f2, _.get("focus"), _.get("blurScope"), _.get("disabled"));
  }
  function pxr(f2, i) {
    return i === "category" ? f2 == null : f2 == null || isNaN(f2);
  }
  var dxr = fxr, gxr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.visualStyleAccessPath = "lineStyle", t2.visualDrawType = "stroke", t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      return aN(null, this, { useEncodeDefaulter: ks(vxr, null, this) });
    }, i.prototype.getRawIndicesByActiveState = function(t2) {
      var h = this.coordinateSystem, v4 = this.getData(), _ = [];
      return h.eachActiveState(v4, function(M2, I2) {
        t2 === M2 && _.push(v4.getRawIndex(I2));
      }), _;
    }, i.type = "series.parallel", i.dependencies = ["parallel"], i.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, i;
  }(Jv);
  function vxr(f2) {
    var i = f2.ecModel.getComponent("parallel", f2.get("parallelIndex"));
    if (!!i) {
      var t2 = {};
      return Qe2(i.dimensions, function(h) {
        var v4 = yxr(h);
        t2[h] = v4;
      }), t2;
    }
  }
  function yxr(f2) {
    return +f2.replace("dim", "");
  }
  var mxr = gxr, bxr = ["lineStyle", "opacity"], _xr = { seriesType: "parallel", reset: function(f2, i) {
    var t2 = f2.coordinateSystem, h = { normal: f2.get(["lineStyle", "opacity"]), active: f2.get("activeOpacity"), inactive: f2.get("inactiveOpacity") };
    return { progress: function(v4, _) {
      t2.eachActiveState(_, function(M2, I2) {
        var P2 = h[M2];
        if (M2 === "normal" && _.hasItemOption) {
          var N3 = _.getItemModel(I2).get(bxr, true);
          N3 != null && (P2 = N3);
        }
        var z3 = _.ensureUniqueItemVisual(I2, "style");
        z3.opacity = P2;
      }, v4.start, v4.end);
    } };
  } }, xxr = _xr;
  function wxr(f2) {
    Sxr(f2), Mxr(f2);
  }
  function Sxr(f2) {
    if (!f2.parallel) {
      var i = false;
      Qe2(f2.series, function(t2) {
        t2 && t2.type === "parallel" && (i = true);
      }), i && (f2.parallel = [{}]);
    }
  }
  function Mxr(f2) {
    var i = Od2(f2.parallelAxis);
    Qe2(i, function(t2) {
      if (!!Xl(t2)) {
        var h = t2.parallelIndex || 0, v4 = Od2(f2.parallel)[h];
        v4 && v4.parallelAxisDefault && cc2(t2, v4.parallelAxisDefault, false);
      }
    });
  }
  var Cxr = 5, Txr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      this._model = t2, this._api = v4, this._handlers || (this._handlers = {}, Qe2(Axr, function(_, M2) {
        v4.getZr().on(M2, this._handlers[M2] = ks(_, this));
      }, this)), cet(this, "_throttledDispatchExpand", t2.get("axisExpandRate"), "fixRate");
    }, i.prototype.dispose = function(t2, h) {
      agt(this, "_throttledDispatchExpand"), Qe2(this._handlers, function(v4, _) {
        h.getZr().off(_, v4);
      }), this._handlers = null;
    }, i.prototype._throttledDispatchExpand = function(t2) {
      this._dispatchExpand(t2);
    }, i.prototype._dispatchExpand = function(t2) {
      t2 && this._api.dispatchAction(ba2({ type: "parallelAxisExpand" }, t2));
    }, i.type = "parallel", i;
  }(W0), Axr = { mousedown: function(f2) {
    xQt(this, "click") && (this._mouseDownPoint = [f2.offsetX, f2.offsetY]);
  }, mouseup: function(f2) {
    var i = this._mouseDownPoint;
    if (xQt(this, "click") && i) {
      var t2 = [f2.offsetX, f2.offsetY], h = Math.pow(i[0] - t2[0], 2) + Math.pow(i[1] - t2[1], 2);
      if (h > Cxr)
        return;
      var v4 = this._model.coordinateSystem.getSlidedAxisExpandWindow([f2.offsetX, f2.offsetY]);
      v4.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: v4.axisExpandWindow });
    }
    this._mouseDownPoint = null;
  }, mousemove: function(f2) {
    if (!(this._mouseDownPoint || !xQt(this, "mousemove"))) {
      var i = this._model, t2 = i.coordinateSystem.getSlidedAxisExpandWindow([f2.offsetX, f2.offsetY]), h = t2.behavior;
      h === "jump" && this._throttledDispatchExpand.debounceNextCall(i.get("axisExpandDebounce")), this._throttledDispatchExpand(h === "none" ? null : { axisExpandWindow: t2.axisExpandWindow, animation: h === "jump" ? null : { duration: 0 } });
    }
  } };
  function xQt(f2, i) {
    var t2 = f2._model;
    return t2.get("axisExpandable") && t2.get("axisExpandTriggerOn") === i;
  }
  var Ixr = Txr, Dxr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function() {
      f2.prototype.init.apply(this, arguments), this.mergeOption({});
    }, i.prototype.mergeOption = function(t2) {
      var h = this.option;
      t2 && cc2(h, t2, true), this._initDimensions();
    }, i.prototype.contains = function(t2, h) {
      var v4 = t2.get("parallelIndex");
      return v4 != null && h.getComponent("parallel", v4) === this;
    }, i.prototype.setAxisExpand = function(t2) {
      Qe2(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(h) {
        t2.hasOwnProperty(h) && (this.option[h] = t2[h]);
      }, this);
    }, i.prototype._initDimensions = function() {
      var t2 = this.dimensions = [], h = this.parallelAxisIndex = [], v4 = Ld2(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(_) {
        return (_.get("parallelIndex") || 0) === this.componentIndex;
      }, this);
      Qe2(v4, function(_) {
        t2.push("dim" + _.get("dim")), h.push(_.componentIndex);
      });
    }, i.type = "parallel", i.dependencies = ["parallelAxis"], i.layoutMode = "box", i.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, i;
  }(zh2), Exr = Dxr, kxr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _, M2) {
      var I2 = f2.call(this, t2, h, v4) || this;
      return I2.type = _ || "value", I2.axisIndex = M2, I2;
    }
    return i.prototype.isHorizontal = function() {
      return this.coordinateSystem.getModel().get("layout") !== "horizontal";
    }, i;
  }(D5), Pxr = kxr;
  function AU(f2, i, t2, h, v4, _) {
    f2 = f2 || 0;
    var M2 = t2[1] - t2[0];
    if (v4 != null && (v4 = dtt(v4, [0, M2])), _ != null && (_ = Math.max(_, v4 != null ? v4 : 0)), h === "all") {
      var I2 = Math.abs(i[1] - i[0]);
      I2 = dtt(I2, [0, M2]), v4 = _ = dtt(I2, [v4, _]), h = 0;
    }
    i[0] = dtt(i[0], t2), i[1] = dtt(i[1], t2);
    var P2 = wQt(i, h);
    i[h] += f2;
    var N3 = v4 || 0, z3 = t2.slice();
    P2.sign < 0 ? z3[0] += N3 : z3[1] -= N3, i[h] = dtt(i[h], z3);
    var H2;
    return H2 = wQt(i, h), v4 != null && (H2.sign !== P2.sign || H2.span < v4) && (i[1 - h] = i[h] + P2.sign * v4), H2 = wQt(i, h), _ != null && H2.span > _ && (i[1 - h] = i[h] + H2.sign * _), i;
  }
  function wQt(f2, i) {
    var t2 = f2[i] - f2[1 - i];
    return { span: Math.abs(t2), sign: t2 > 0 ? -1 : t2 < 0 ? 1 : i ? -1 : 1 };
  }
  function dtt(f2, i) {
    return Math.min(i[1] != null ? i[1] : 1 / 0, Math.max(i[0] != null ? i[0] : -1 / 0, f2));
  }
  var SQt = Qe2, yUe = Math.min, mUe = Math.max, G9e = Math.floor, Lxr = Math.ceil, H9e = gy, Oxr = Math.PI, Rxr = function() {
    function f2(i, t2, h) {
      this.type = "parallel", this._axesMap = Il(), this._axesLayout = {}, this.dimensions = i.dimensions, this._model = i, this._init(i, t2, h);
    }
    return f2.prototype._init = function(i, t2, h) {
      var v4 = i.dimensions, _ = i.parallelAxisIndex;
      SQt(v4, function(M2, I2) {
        var P2 = _[I2], N3 = t2.getComponent("parallelAxis", P2), z3 = this._axesMap.set(M2, new Pxr(M2, Rkt(N3), [0, 0], N3.get("type"), P2)), H2 = z3.type === "category";
        z3.onBand = H2 && N3.get("boundaryGap"), z3.inverse = N3.get("inverse"), N3.axis = z3, z3.model = N3, z3.coordinateSystem = N3.coordinateSystem = this;
      }, this);
    }, f2.prototype.update = function(i, t2) {
      this._updateAxesFromSeries(this._model, i);
    }, f2.prototype.containPoint = function(i) {
      var t2 = this._makeLayoutInfo(), h = t2.axisBase, v4 = t2.layoutBase, _ = t2.pixelDimIndex, M2 = i[1 - _], I2 = i[_];
      return M2 >= h && M2 <= h + t2.axisLength && I2 >= v4 && I2 <= v4 + t2.layoutLength;
    }, f2.prototype.getModel = function() {
      return this._model;
    }, f2.prototype._updateAxesFromSeries = function(i, t2) {
      t2.eachSeries(function(h) {
        if (!!i.contains(h, t2)) {
          var v4 = h.getData();
          SQt(this.dimensions, function(_) {
            var M2 = this._axesMap.get(_);
            M2.scale.unionExtentFromData(v4, v4.mapDimension(_)), Htt(M2.scale, M2.model);
          }, this);
        }
      }, this);
    }, f2.prototype.resize = function(i, t2) {
      this._rect = u1(i.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() }), this._layoutAxes();
    }, f2.prototype.getRect = function() {
      return this._rect;
    }, f2.prototype._makeLayoutInfo = function() {
      var i = this._model, t2 = this._rect, h = ["x", "y"], v4 = ["width", "height"], _ = i.get("layout"), M2 = _ === "horizontal" ? 0 : 1, I2 = t2[v4[M2]], P2 = [0, I2], N3 = this.dimensions.length, z3 = xDt(i.get("axisExpandWidth"), P2), H2 = xDt(i.get("axisExpandCount") || 0, [0, N3]), $ = i.get("axisExpandable") && N3 > 3 && N3 > H2 && H2 > 1 && z3 > 0 && I2 > 0, et = i.get("axisExpandWindow"), at;
      if (et)
        at = xDt(et[1] - et[0], P2), et[1] = et[0] + at;
      else {
        at = xDt(z3 * (H2 - 1), P2);
        var ht = i.get("axisExpandCenter") || G9e(N3 / 2);
        et = [z3 * ht - at / 2], et[1] = et[0] + at;
      }
      var bt = (I2 - at) / (N3 - H2);
      bt < 3 && (bt = 0);
      var _t = [G9e(H9e(et[0] / z3, 1)) + 1, Lxr(H9e(et[1] / z3, 1)) - 1], Et = bt / z3 * et[0];
      return { layout: _, pixelDimIndex: M2, layoutBase: t2[h[M2]], layoutLength: I2, axisBase: t2[h[1 - M2]], axisLength: t2[v4[1 - M2]], axisExpandable: $, axisExpandWidth: z3, axisCollapseWidth: bt, axisExpandWindow: et, axisCount: N3, winInnerIndices: _t, axisExpandWindow0Pos: Et };
    }, f2.prototype._layoutAxes = function() {
      var i = this._rect, t2 = this._axesMap, h = this.dimensions, v4 = this._makeLayoutInfo(), _ = v4.layout;
      t2.each(function(M2) {
        var I2 = [0, v4.axisLength], P2 = M2.inverse ? 1 : 0;
        M2.setExtent(I2[P2], I2[1 - P2]);
      }), SQt(h, function(M2, I2) {
        var P2 = (v4.axisExpandable ? Fxr : Nxr)(I2, v4), N3 = { horizontal: { x: P2.position, y: v4.axisLength }, vertical: { x: 0, y: P2.position } }, z3 = { horizontal: Oxr / 2, vertical: 0 }, H2 = [N3[_].x + i.x, N3[_].y + i.y], $ = z3[_], et = nE();
        SU(et, et, $), jL(et, et, H2), this._axesLayout[M2] = { position: H2, rotation: $, transform: et, axisNameAvailableWidth: P2.axisNameAvailableWidth, axisLabelShow: P2.axisLabelShow, nameTruncateMaxWidth: P2.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
      }, this);
    }, f2.prototype.getAxis = function(i) {
      return this._axesMap.get(i);
    }, f2.prototype.dataToPoint = function(i, t2) {
      return this.axisCoordToPoint(this._axesMap.get(t2).dataToCoord(i), t2);
    }, f2.prototype.eachActiveState = function(i, t2, h, v4) {
      h == null && (h = 0), v4 == null && (v4 = i.count());
      var _ = this._axesMap, M2 = this.dimensions, I2 = [], P2 = [];
      Qe2(M2, function(bt) {
        I2.push(i.mapDimension(bt)), P2.push(_.get(bt).model);
      });
      for (var N3 = this.hasAxisBrushed(), z3 = h; z3 < v4; z3++) {
        var H2 = void 0;
        if (!N3)
          H2 = "normal";
        else {
          H2 = "active";
          for (var $ = i.getValues(I2, z3), et = 0, at = M2.length; et < at; et++) {
            var ht = P2[et].getActiveState($[et]);
            if (ht === "inactive") {
              H2 = "inactive";
              break;
            }
          }
        }
        t2(H2, z3);
      }
    }, f2.prototype.hasAxisBrushed = function() {
      for (var i = this.dimensions, t2 = this._axesMap, h = false, v4 = 0, _ = i.length; v4 < _; v4++)
        t2.get(i[v4]).model.getActiveState() !== "normal" && (h = true);
      return h;
    }, f2.prototype.axisCoordToPoint = function(i, t2) {
      var h = this._axesLayout[t2];
      return C5([i, 0], h.transform);
    }, f2.prototype.getAxisLayout = function(i) {
      return pu(this._axesLayout[i]);
    }, f2.prototype.getSlidedAxisExpandWindow = function(i) {
      var t2 = this._makeLayoutInfo(), h = t2.pixelDimIndex, v4 = t2.axisExpandWindow.slice(), _ = v4[1] - v4[0], M2 = [0, t2.axisExpandWidth * (t2.axisCount - 1)];
      if (!this.containPoint(i))
        return { behavior: "none", axisExpandWindow: v4 };
      var I2 = i[h] - t2.layoutBase - t2.axisExpandWindow0Pos, P2, N3 = "slide", z3 = t2.axisCollapseWidth, H2 = this._model.get("axisExpandSlideTriggerArea"), $ = H2[0] != null;
      if (z3)
        $ && z3 && I2 < _ * H2[0] ? (N3 = "jump", P2 = I2 - _ * H2[2]) : $ && z3 && I2 > _ * (1 - H2[0]) ? (N3 = "jump", P2 = I2 - _ * (1 - H2[2])) : (P2 = I2 - _ * H2[1]) >= 0 && (P2 = I2 - _ * (1 - H2[1])) <= 0 && (P2 = 0), P2 *= t2.axisExpandWidth / z3, P2 ? AU(P2, v4, M2, "all") : N3 = "none";
      else {
        var et = v4[1] - v4[0], at = M2[1] * I2 / et;
        v4 = [mUe(0, at - et / 2)], v4[1] = yUe(M2[1], v4[0] + et), v4[0] = v4[1] - et;
      }
      return { axisExpandWindow: v4, behavior: N3 };
    }, f2;
  }();
  function xDt(f2, i) {
    return yUe(mUe(f2, i[0]), i[1]);
  }
  function Nxr(f2, i) {
    var t2 = i.layoutLength / (i.axisCount - 1);
    return { position: t2 * f2, axisNameAvailableWidth: t2, axisLabelShow: true };
  }
  function Fxr(f2, i) {
    var t2 = i.layoutLength, h = i.axisExpandWidth, v4 = i.axisCount, _ = i.axisCollapseWidth, M2 = i.winInnerIndices, I2, P2 = _, N3 = false, z3;
    return f2 < M2[0] ? (I2 = f2 * _, z3 = _) : f2 <= M2[1] ? (I2 = i.axisExpandWindow0Pos + f2 * h - i.axisExpandWindow[0], P2 = h, N3 = true) : (I2 = t2 - (v4 - 1 - f2) * _, z3 = _), { position: I2, axisNameAvailableWidth: P2, axisLabelShow: N3, nameTruncateMaxWidth: z3 };
  }
  var Vxr = Rxr;
  function Bxr(f2, i) {
    var t2 = [];
    return f2.eachComponent("parallel", function(h, v4) {
      var _ = new Vxr(h, f2, i);
      _.name = "parallel_" + v4, _.resize(h, i), h.coordinateSystem = _, _.model = h, t2.push(_);
    }), f2.eachSeries(function(h) {
      if (h.get("coordinateSystem") === "parallel") {
        var v4 = h.getReferringComponents("parallel", _m).models[0];
        h.coordinateSystem = v4.coordinateSystem;
      }
    }), t2;
  }
  var zxr = { create: Bxr }, jxr = zxr, bUe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.activeIntervals = [], t2;
    }
    return i.prototype.getAreaSelectStyle = function() {
      return yU([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
    }, i.prototype.setActiveIntervals = function(t2) {
      var h = this.activeIntervals = pu(t2);
      if (h)
        for (var v4 = h.length - 1; v4 >= 0; v4--)
          QD(h[v4]);
    }, i.prototype.getActiveState = function(t2) {
      var h = this.activeIntervals;
      if (!h.length)
        return "normal";
      if (t2 == null || isNaN(+t2))
        return "inactive";
      if (h.length === 1) {
        var v4 = h[0];
        if (v4[0] <= t2 && t2 <= v4[1])
          return "active";
      } else
        for (var _ = 0, M2 = h.length; _ < M2; _++)
          if (h[_][0] <= t2 && t2 <= h[_][1])
            return "active";
      return "inactive";
    }, i;
  }(zh2);
  Sm(bUe, Fgt);
  var U9e = bUe, _U = true, ygt = Math.min, Ztt = Math.max, Wxr = Math.pow, Gxr = 1e4, Hxr = 6, Uxr = 6, q9e = "globalPan", qxr = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, Zxr = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, Z9e = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, $xr = 0, Yxr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this) || this;
      return h._track = [], h._covers = [], h._handlers = {}, h._zr = t2, h.group = new mu(), h._uid = "brushController_" + $xr++, Qe2(nwr, function(v4, _) {
        this._handlers[_] = ks(v4, this);
      }, h), h;
    }
    return i.prototype.enableBrush = function(t2) {
      return this._brushType && this._doDisableBrush(), t2.brushType && this._doEnableBrush(t2), this;
    }, i.prototype._doEnableBrush = function(t2) {
      var h = this._zr;
      this._enableGlobalPan || a1r(h, q9e, this._uid), Qe2(this._handlers, function(v4, _) {
        h.on(_, v4);
      }), this._brushType = t2.brushType, this._brushOption = cc2(pu(Z9e), t2, true);
    }, i.prototype._doDisableBrush = function() {
      var t2 = this._zr;
      o1r(t2, q9e, this._uid), Qe2(this._handlers, function(h, v4) {
        t2.off(v4, h);
      }), this._brushType = this._brushOption = null;
    }, i.prototype.setPanels = function(t2) {
      if (t2 && t2.length) {
        var h = this._panels = {};
        Qe2(t2, function(v4) {
          h[v4.panelId] = pu(v4);
        });
      } else
        this._panels = null;
      return this;
    }, i.prototype.mount = function(t2) {
      t2 = t2 || {}, this._enableGlobalPan = t2.enableGlobalPan;
      var h = this.group;
      return this._zr.add(h), h.attr({ x: t2.x || 0, y: t2.y || 0, rotation: t2.rotation || 0, scaleX: t2.scaleX || 1, scaleY: t2.scaleY || 1 }), this._transform = h.getLocalTransform(), this;
    }, i.prototype.updateCovers = function(t2) {
      t2 = Xa2(t2, function($) {
        return cc2(pu(Z9e), $, true);
      });
      var h = "\0-brush-index-", v4 = this._covers, _ = this._covers = [], M2 = this, I2 = this._creatingCover;
      return new eN(v4, t2, N3, P2).add(z3).update(z3).remove(H2).execute(), this;
      function P2($, et) {
        return ($.id != null ? $.id : h + et) + "-" + $.brushType;
      }
      function N3($, et) {
        return P2($.__brushOption, et);
      }
      function z3($, et) {
        var at = t2[$];
        if (et != null && v4[et] === I2)
          _[$] = v4[et];
        else {
          var ht = _[$] = et != null ? (v4[et].__brushOption = at, v4[et]) : xUe(M2, _Ue(M2, at));
          jne(M2, ht);
        }
      }
      function H2($) {
        v4[$] !== I2 && M2.group.remove(v4[$]);
      }
    }, i.prototype.unmount = function() {
      return this.enableBrush(false), Ite(this), this._zr.remove(this.group), this;
    }, i.prototype.dispose = function() {
      this.unmount(), this.off();
    }, i;
  }(iE);
  function _Ue(f2, i) {
    var t2 = Wkt[i.brushType].createCover(f2, i);
    return t2.__brushOption = i, SUe(t2, i), f2.group.add(t2), t2;
  }
  function xUe(f2, i) {
    var t2 = Wne(i);
    return t2.endCreating && (t2.endCreating(f2, i), SUe(i, i.__brushOption)), i;
  }
  function wUe(f2, i) {
    var t2 = i.__brushOption;
    Wne(i).updateCoverShape(f2, i, t2.range, t2);
  }
  function SUe(f2, i) {
    var t2 = i.z;
    t2 == null && (t2 = Gxr), f2.traverse(function(h) {
      h.z = t2, h.z2 = t2;
    });
  }
  function jne(f2, i) {
    Wne(i).updateCommon(f2, i), wUe(f2, i);
  }
  function Wne(f2) {
    return Wkt[f2.__brushOption.brushType];
  }
  function Gne(f2, i, t2) {
    var h = f2._panels;
    if (!h)
      return _U;
    var v4, _ = f2._transform;
    return Qe2(h, function(M2) {
      M2.isTargetByCursor(i, t2, _) && (v4 = M2);
    }), v4;
  }
  function MUe(f2, i) {
    var t2 = f2._panels;
    if (!t2)
      return _U;
    var h = i.__brushOption.panelId;
    return h != null ? t2[h] : _U;
  }
  function Ite(f2) {
    var i = f2._covers, t2 = i.length;
    return Qe2(i, function(h) {
      f2.group.remove(h);
    }, f2), i.length = 0, !!t2;
  }
  function xU(f2, i) {
    var t2 = Xa2(f2._covers, function(h) {
      var v4 = h.__brushOption, _ = pu(v4.range);
      return { brushType: v4.brushType, panelId: v4.panelId, range: _ };
    });
    f2.trigger("brush", { areas: t2, isEnd: !!i.isEnd, removeOnClick: !!i.removeOnClick });
  }
  function Kxr(f2) {
    var i = f2._track;
    if (!i.length)
      return false;
    var t2 = i[i.length - 1], h = i[0], v4 = t2[0] - h[0], _ = t2[1] - h[1], M2 = Wxr(v4 * v4 + _ * _, 0.5);
    return M2 > Hxr;
  }
  function CUe(f2) {
    var i = f2.length - 1;
    return i < 0 && (i = 0), [f2[0], f2[i]];
  }
  function TUe(f2, i, t2, h) {
    var v4 = new mu();
    return v4.add(new Sh2({ name: "main", style: Hne(t2), silent: true, draggable: true, cursor: "move", drift: Ou($9e, f2, i, v4, ["n", "s", "w", "e"]), ondragend: Ou(xU, i, { isEnd: true }) })), Qe2(h, function(_) {
      v4.add(new Sh2({ name: _.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: Ou($9e, f2, i, v4, _), ondragend: Ou(xU, i, { isEnd: true }) }));
    }), v4;
  }
  function AUe(f2, i, t2, h) {
    var v4 = h.brushStyle.lineWidth || 0, _ = Ztt(v4, Uxr), M2 = t2[0][0], I2 = t2[1][0], P2 = M2 - v4 / 2, N3 = I2 - v4 / 2, z3 = t2[0][1], H2 = t2[1][1], $ = z3 - _ + v4 / 2, et = H2 - _ + v4 / 2, at = z3 - M2, ht = H2 - I2, bt = at + v4, _t = ht + v4;
    B6(f2, i, "main", M2, I2, at, ht), h.transformable && (B6(f2, i, "w", P2, N3, _, _t), B6(f2, i, "e", $, N3, _, _t), B6(f2, i, "n", P2, N3, bt, _), B6(f2, i, "s", P2, et, bt, _), B6(f2, i, "nw", P2, N3, _, _), B6(f2, i, "ne", $, N3, _, _), B6(f2, i, "sw", P2, et, _, _), B6(f2, i, "se", $, et, _, _));
  }
  function Dte(f2, i) {
    var t2 = i.__brushOption, h = t2.transformable, v4 = i.childAt(0);
    v4.useStyle(Hne(t2)), v4.attr({ silent: !h, cursor: h ? "move" : "default" }), Qe2([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(_) {
      var M2 = i.childOfName(_.join("")), I2 = _.length === 1 ? Ete(f2, _[0]) : Qxr(f2, _);
      M2 && M2.attr({ silent: !h, invisible: !h, cursor: h ? Zxr[I2] + "-resize" : null });
    });
  }
  function B6(f2, i, t2, h, v4, _, M2) {
    var I2 = i.childOfName(t2);
    I2 && I2.setShape(twr(Une(f2, i, [[h, v4], [h + _, v4 + M2]])));
  }
  function Hne(f2) {
    return Ul({ strokeNoScale: true }, f2.brushStyle);
  }
  function IUe(f2, i, t2, h) {
    var v4 = [ygt(f2, t2), ygt(i, h)], _ = [Ztt(f2, t2), Ztt(i, h)];
    return [[v4[0], _[0]], [v4[1], _[1]]];
  }
  function Xxr(f2) {
    return cU(f2.group);
  }
  function Ete(f2, i) {
    var t2 = { w: "left", e: "right", n: "top", s: "bottom" }, h = { left: "w", right: "e", top: "n", bottom: "s" }, v4 = _kt(t2[i], Xxr(f2));
    return h[v4];
  }
  function Qxr(f2, i) {
    var t2 = [Ete(f2, i[0]), Ete(f2, i[1])];
    return (t2[0] === "e" || t2[0] === "w") && t2.reverse(), t2.join("");
  }
  function $9e(f2, i, t2, h, v4, _) {
    var M2 = t2.__brushOption, I2 = f2.toRectRange(M2.range), P2 = DUe(i, v4, _);
    Qe2(h, function(N3) {
      var z3 = qxr[N3];
      I2[z3[0]][z3[1]] += P2[z3[0]];
    }), M2.range = f2.fromRectRange(IUe(I2[0][0], I2[1][0], I2[0][1], I2[1][1])), jne(i, t2), xU(i, { isEnd: false });
  }
  function Jxr(f2, i, t2, h) {
    var v4 = i.__brushOption.range, _ = DUe(f2, t2, h);
    Qe2(v4, function(M2) {
      M2[0] += _[0], M2[1] += _[1];
    }), jne(f2, i), xU(f2, { isEnd: false });
  }
  function DUe(f2, i, t2) {
    var h = f2.group, v4 = h.transformCoordToLocal(i, t2), _ = h.transformCoordToLocal(0, 0);
    return [v4[0] - _[0], v4[1] - _[1]];
  }
  function Une(f2, i, t2) {
    var h = MUe(f2, i);
    return h && h !== _U ? h.clipPath(t2, f2._transform) : pu(t2);
  }
  function twr(f2) {
    var i = ygt(f2[0][0], f2[1][0]), t2 = ygt(f2[0][1], f2[1][1]), h = Ztt(f2[0][0], f2[1][0]), v4 = Ztt(f2[0][1], f2[1][1]);
    return { x: i, y: t2, width: h - i, height: v4 - t2 };
  }
  function ewr(f2, i, t2) {
    if (!(!f2._brushType || rwr(f2, i.offsetX, i.offsetY))) {
      var h = f2._zr, v4 = f2._covers, _ = Gne(f2, i, t2);
      if (!f2._dragging)
        for (var M2 = 0; M2 < v4.length; M2++) {
          var I2 = v4[M2].__brushOption;
          if (_ && (_ === _U || I2.panelId === _.panelId) && Wkt[I2.brushType].contain(v4[M2], t2[0], t2[1]))
            return;
        }
      _ && h.setCursorStyle("crosshair");
    }
  }
  function kte(f2) {
    var i = f2.event;
    i.preventDefault && i.preventDefault();
  }
  function Pte(f2, i, t2) {
    return f2.childOfName("main").contain(i, t2);
  }
  function EUe(f2, i, t2, h) {
    var v4 = f2._creatingCover, _ = f2._creatingPanel, M2 = f2._brushOption, I2;
    if (f2._track.push(t2.slice()), Kxr(f2) || v4) {
      if (_ && !v4) {
        M2.brushMode === "single" && Ite(f2);
        var P2 = pu(M2);
        P2.brushType = Y9e(P2.brushType, _), P2.panelId = _ === _U ? null : _.panelId, v4 = f2._creatingCover = _Ue(f2, P2), f2._covers.push(v4);
      }
      if (v4) {
        var N3 = Wkt[Y9e(f2._brushType, _)], z3 = v4.__brushOption;
        z3.range = N3.getCreatingRange(Une(f2, v4, f2._track)), h && (xUe(f2, v4), N3.updateCommon(f2, v4)), wUe(f2, v4), I2 = { isEnd: h };
      }
    } else
      h && M2.brushMode === "single" && M2.removeOnClick && Gne(f2, i, t2) && Ite(f2) && (I2 = { isEnd: h, removeOnClick: true });
    return I2;
  }
  function Y9e(f2, i) {
    return f2 === "auto" ? i.defaultBrushType : f2;
  }
  var nwr = { mousedown: function(f2) {
    if (this._dragging)
      K9e(this, f2);
    else if (!f2.target || !f2.target.draggable) {
      kte(f2);
      var i = this.group.transformCoordToLocal(f2.offsetX, f2.offsetY);
      this._creatingCover = null;
      var t2 = this._creatingPanel = Gne(this, f2, i);
      t2 && (this._dragging = true, this._track = [i.slice()]);
    }
  }, mousemove: function(f2) {
    var i = f2.offsetX, t2 = f2.offsetY, h = this.group.transformCoordToLocal(i, t2);
    if (ewr(this, f2, h), this._dragging) {
      kte(f2);
      var v4 = EUe(this, f2, h, false);
      v4 && xU(this, v4);
    }
  }, mouseup: function(f2) {
    K9e(this, f2);
  } };
  function K9e(f2, i) {
    if (f2._dragging) {
      kte(i);
      var t2 = i.offsetX, h = i.offsetY, v4 = f2.group.transformCoordToLocal(t2, h), _ = EUe(f2, i, v4, true);
      f2._dragging = false, f2._track = [], f2._creatingCover = null, _ && xU(f2, _);
    }
  }
  function rwr(f2, i, t2) {
    var h = f2._zr;
    return i < 0 || i > h.getWidth() || t2 < 0 || t2 > h.getHeight();
  }
  var Wkt = { lineX: X9e(0), lineY: X9e(1), rect: { createCover: function(f2, i) {
    function t2(h) {
      return h;
    }
    return TUe({ toRectRange: t2, fromRectRange: t2 }, f2, i, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
  }, getCreatingRange: function(f2) {
    var i = CUe(f2);
    return IUe(i[1][0], i[1][1], i[0][0], i[0][1]);
  }, updateCoverShape: function(f2, i, t2, h) {
    AUe(f2, i, t2, h);
  }, updateCommon: Dte, contain: Pte }, polygon: { createCover: function(f2, i) {
    var t2 = new mu();
    return t2.add(new aC({ name: "main", style: Hne(i), silent: true })), t2;
  }, getCreatingRange: function(f2) {
    return f2;
  }, endCreating: function(f2, i) {
    i.remove(i.childAt(0)), i.add(new iC({ name: "main", draggable: true, drift: Ou(Jxr, f2, i), ondragend: Ou(xU, f2, { isEnd: true }) }));
  }, updateCoverShape: function(f2, i, t2, h) {
    i.childAt(0).setShape({ points: Une(f2, i, t2) });
  }, updateCommon: Dte, contain: Pte } };
  function X9e(f2) {
    return { createCover: function(i, t2) {
      return TUe({ toRectRange: function(h) {
        var v4 = [h, [0, 100]];
        return f2 && v4.reverse(), v4;
      }, fromRectRange: function(h) {
        return h[f2];
      } }, i, t2, [[["w"], ["e"]], [["n"], ["s"]]][f2]);
    }, getCreatingRange: function(i) {
      var t2 = CUe(i), h = ygt(t2[0][f2], t2[1][f2]), v4 = Ztt(t2[0][f2], t2[1][f2]);
      return [h, v4];
    }, updateCoverShape: function(i, t2, h, v4) {
      var _, M2 = MUe(i, t2);
      if (M2 !== _U && M2.getLinearBrushOtherExtent)
        _ = M2.getLinearBrushOtherExtent(f2);
      else {
        var I2 = i._zr;
        _ = [0, [I2.getWidth(), I2.getHeight()][1 - f2]];
      }
      var P2 = [h, _];
      f2 && P2.reverse(), AUe(i, t2, P2, v4);
    }, updateCommon: Dte, contain: Pte };
  }
  var qne = Yxr;
  function kUe(f2) {
    return f2 = Zne(f2), function(i) {
      return Rje(i, f2);
    };
  }
  function PUe(f2, i) {
    return f2 = Zne(f2), function(t2) {
      var h = i != null ? i : t2, v4 = h ? f2.width : f2.height, _ = h ? f2.x : f2.y;
      return [_, _ + (v4 || 0)];
    };
  }
  function LUe(f2, i, t2) {
    var h = Zne(f2);
    return function(v4, _) {
      return h.contain(_[0], _[1]) && !Vkt(v4, i, t2);
    };
  }
  function Zne(f2) {
    return Lc2.create(f2);
  }
  var iwr = ["axisLine", "axisTickLabel", "axisName"], awr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2, h) {
      f2.prototype.init.apply(this, arguments), (this._brushController = new qne(h.getZr())).on("brush", ks(this._onBrush, this));
    }, i.prototype.render = function(t2, h, v4, _) {
      if (!owr(t2, h, _)) {
        this.axisModel = t2, this.api = v4, this.group.removeAll();
        var M2 = this._axisGroup;
        if (this._axisGroup = new mu(), this.group.add(this._axisGroup), !!t2.get("show")) {
          var I2 = lwr(t2, h), P2 = I2.coordinateSystem, N3 = t2.getAreaSelectStyle(), z3 = N3.width, H2 = t2.axis.dim, $ = P2.getAxisLayout(H2), et = ba2({ strokeContainThreshold: z3 }, $), at = new nN(t2, et);
          Qe2(iwr, at.add, at), this._axisGroup.add(at.getGroup()), this._refreshBrushController(et, N3, t2, I2, z3, v4), Dgt(M2, this._axisGroup, t2);
        }
      }
    }, i.prototype._refreshBrushController = function(t2, h, v4, _, M2, I2) {
      var P2 = v4.axis.getExtent(), N3 = P2[1] - P2[0], z3 = Math.min(30, Math.abs(N3) * 0.1), H2 = Lc2.create({ x: P2[0], y: -M2 / 2, width: N3, height: M2 });
      H2.x -= z3, H2.width += 2 * z3, this._brushController.mount({ enableGlobalPan: true, rotation: t2.rotation, x: t2.position[0], y: t2.position[1] }).setPanels([{ panelId: "pl", clipPath: kUe(H2), isTargetByCursor: LUe(H2, I2, _), getLinearBrushOtherExtent: PUe(H2, 0) }]).enableBrush({ brushType: "lineX", brushStyle: h, removeOnClick: true }).updateCovers(swr(v4));
    }, i.prototype._onBrush = function(t2) {
      var h = t2.areas, v4 = this.axisModel, _ = v4.axis, M2 = Xa2(h, function(I2) {
        return [_.coordToData(I2.range[0], true), _.coordToData(I2.range[1], true)];
      });
      (!v4.option.realtime === t2.isEnd || t2.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: v4.id, intervals: M2 });
    }, i.prototype.dispose = function() {
      this._brushController.dispose();
    }, i.type = "parallelAxis", i;
  }(W0);
  function owr(f2, i, t2) {
    return t2 && t2.type === "axisAreaSelect" && i.findComponents({ mainType: "parallelAxis", query: t2 })[0] === f2;
  }
  function swr(f2) {
    var i = f2.axis;
    return Xa2(f2.activeIntervals, function(t2) {
      return { brushType: "lineX", panelId: "pl", range: [i.dataToCoord(t2[0], true), i.dataToCoord(t2[1], true)] };
    });
  }
  function lwr(f2, i) {
    return i.getComponent("parallel", f2.get("parallelIndex"));
  }
  var uwr = awr, cwr = { type: "axisAreaSelect", event: "axisAreaSelected" };
  function fwr(f2) {
    f2.registerAction(cwr, function(i, t2) {
      t2.eachComponent({ mainType: "parallelAxis", query: i }, function(h) {
        h.axis.model.setActiveIntervals(i.intervals);
      });
    }), f2.registerAction("parallelAxisExpand", function(i, t2) {
      t2.eachComponent({ mainType: "parallel", query: i }, function(h) {
        h.setAxisExpand(i);
      });
    });
  }
  var hwr = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
  function OUe(f2) {
    f2.registerComponentView(Ixr), f2.registerComponentModel(Exr), f2.registerCoordinateSystem("parallel", jxr), f2.registerPreprocessor(wxr), f2.registerComponentModel(U9e), f2.registerComponentView(uwr), qtt(f2, "parallel", U9e, hwr), fwr(f2);
  }
  function pwr(f2) {
    zc2(OUe), f2.registerChartView(dxr), f2.registerSeriesModel(mxr), f2.registerVisual(f2.PRIORITY.VISUAL.BRUSH, xxr);
  }
  var dwr = function() {
    function f2() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
    }
    return f2;
  }(), gwr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      return f2.call(this, t2) || this;
    }
    return i.prototype.getDefaultShape = function() {
      return new dwr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.extent;
      t2.moveTo(h.x1, h.y1), t2.bezierCurveTo(h.cpx1, h.cpy1, h.cpx2, h.cpy2, h.x2, h.y2), h.orient === "vertical" ? (t2.lineTo(h.x2 + v4, h.y2), t2.bezierCurveTo(h.cpx2 + v4, h.cpy2, h.cpx1 + v4, h.cpy1, h.x1 + v4, h.y1)) : (t2.lineTo(h.x2, h.y2 + v4), t2.bezierCurveTo(h.cpx2, h.cpy2 + v4, h.cpx1, h.cpy1 + v4, h.x1, h.y1 + v4)), t2.closePath();
    }, i.prototype.highlight = function() {
      NL(this);
    }, i.prototype.downplay = function() {
      FL(this);
    }, i;
  }(Uc2), vwr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._focusAdjacencyDisabled = false, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = this, M2 = t2.getGraph(), I2 = this.group, P2 = t2.layoutInfo, N3 = P2.width, z3 = P2.height, H2 = t2.getData(), $ = t2.getData("edge"), et = t2.get("orient");
      this._model = t2, I2.removeAll(), I2.x = P2.x, I2.y = P2.y, M2.eachEdge(function(at) {
        var ht = new gwr(), bt = Du(ht);
        bt.dataIndex = at.dataIndex, bt.seriesIndex = t2.seriesIndex, bt.dataType = "edge";
        var _t = at.getModel(), Et = _t.getModel("lineStyle"), zt = Et.get("curveness"), Ft = at.node1.getLayout(), fe2 = at.node1.getModel(), re2 = fe2.get("localX"), ye = fe2.get("localY"), me2 = at.node2.getLayout(), be2 = at.node2.getModel(), Te2 = be2.get("localX"), We = be2.get("localY"), en = at.getLayout(), Ue2, Mn, Vn, xn, Zr, nr, pr, Nr;
        switch (ht.shape.extent = Math.max(1, en.dy), ht.shape.orient = et, et === "vertical" ? (Ue2 = (re2 != null ? re2 * N3 : Ft.x) + en.sy, Mn = (ye != null ? ye * z3 : Ft.y) + Ft.dy, Vn = (Te2 != null ? Te2 * N3 : me2.x) + en.ty, xn = We != null ? We * z3 : me2.y, Zr = Ue2, nr = Mn * (1 - zt) + xn * zt, pr = Vn, Nr = Mn * zt + xn * (1 - zt)) : (Ue2 = (re2 != null ? re2 * N3 : Ft.x) + Ft.dx, Mn = (ye != null ? ye * z3 : Ft.y) + en.sy, Vn = Te2 != null ? Te2 * N3 : me2.x, xn = (We != null ? We * z3 : me2.y) + en.ty, Zr = Ue2 * (1 - zt) + Vn * zt, nr = Mn, pr = Ue2 * zt + Vn * (1 - zt), Nr = xn), ht.setShape({ x1: Ue2, y1: Mn, x2: Vn, y2: xn, cpx1: Zr, cpy1: nr, cpx2: pr, cpy2: Nr }), ht.useStyle(Et.getItemStyle()), ht.style.fill) {
          case "source":
            ht.style.fill = at.node1.getVisual("color"), ht.style.decal = at.node1.getVisual("style").decal;
            break;
          case "target":
            ht.style.fill = at.node2.getVisual("color"), ht.style.decal = at.node2.getVisual("style").decal;
            break;
          case "gradient":
            var ai2 = at.node1.getVisual("color"), gi2 = at.node2.getVisual("color");
            ms(ai2) && ms(gi2) && (ht.style.fill = new Igt(0, 0, +(et === "horizontal"), +(et === "vertical"), [{ color: ai2, offset: 0 }, { color: gi2, offset: 1 }]));
        }
        var To = _t.getModel("emphasis");
        Hx(ht, _t, "lineStyle", function(ml) {
          return ml.getItemStyle();
        }), I2.add(ht), $.setItemGraphicEl(at.dataIndex, ht);
        var us = To.get("focus");
        vy(ht, us === "adjacency" ? at.getAdjacentDataIndices() : us, To.get("blurScope"), To.get("disabled")), Du(ht).dataType = "edge";
      }), M2.eachNode(function(at) {
        var ht = at.getLayout(), bt = at.getModel(), _t = bt.get("localX"), Et = bt.get("localY"), zt = bt.getModel("emphasis"), Ft = new Sh2({ shape: { x: _t != null ? _t * N3 : ht.x, y: Et != null ? Et * z3 : ht.y, width: ht.dx, height: ht.dy }, style: bt.getModel("itemStyle").getItemStyle(), z2: 10 });
        SS(Ft, b_(bt), { labelFetcher: t2, labelDataIndex: at.dataIndex, defaultText: at.id }), Ft.disableLabelAnimation = true, Ft.setStyle("fill", at.getVisual("color")), Ft.setStyle("decal", at.getVisual("style").decal), Hx(Ft, bt), I2.add(Ft), H2.setItemGraphicEl(at.dataIndex, Ft), Du(Ft).dataType = "node";
        var fe2 = zt.get("focus");
        vy(Ft, fe2 === "adjacency" ? at.getAdjacentDataIndices() : fe2, zt.get("blurScope"), zt.get("disabled"));
      }), H2.eachItemGraphicEl(function(at, ht) {
        var bt = H2.getItemModel(ht);
        bt.get("draggable") && (at.drift = function(_t, Et) {
          _._focusAdjacencyDisabled = true, this.shape.x += _t, this.shape.y += Et, this.dirty(), v4.dispatchAction({ type: "dragNode", seriesId: t2.id, dataIndex: H2.getRawIndex(ht), localX: this.shape.x / N3, localY: this.shape.y / z3 });
        }, at.ondragend = function() {
          _._focusAdjacencyDisabled = false;
        }, at.draggable = true, at.cursor = "move");
      }), !this._data && t2.isAnimationEnabled() && I2.setClipPath(ywr(I2.getBoundingRect(), t2, function() {
        I2.removeClipPath();
      })), this._data = t2.getData();
    }, i.prototype.dispose = function() {
    }, i.type = "sankey", i;
  }(Hg2);
  function ywr(f2, i, t2) {
    var h = new Sh2({ shape: { x: f2.x - 10, y: f2.y - 10, width: 0, height: f2.height + 20 } });
    return Qv(h, { shape: { width: f2.width + 20 } }, i, t2), h;
  }
  var mwr = vwr, bwr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      var v4 = t2.edges || t2.links, _ = t2.data || t2.nodes, M2 = t2.levels;
      this.levelModels = [];
      for (var I2 = this.levelModels, P2 = 0; P2 < M2.length; P2++)
        M2[P2].depth != null && M2[P2].depth >= 0 && (I2[M2[P2].depth] = new Gg2(M2[P2], this, h));
      if (_ && v4) {
        var N3 = gUe(_, v4, this, true, z3);
        return N3.data;
      }
      function z3(H2, $) {
        H2.wrapMethod("getItemModel", function(et, at) {
          var ht = et.parentModel, bt = ht.getData().getItemLayout(at);
          if (bt) {
            var _t = bt.depth, Et = ht.levelModels[_t];
            Et && (et.parentModel = Et);
          }
          return et;
        }), $.wrapMethod("getItemModel", function(et, at) {
          var ht = et.parentModel, bt = ht.getGraph().getEdgeByIndex(at), _t = bt.node1.getLayout();
          if (_t) {
            var Et = _t.depth, zt = ht.levelModels[Et];
            zt && (et.parentModel = zt);
          }
          return et;
        });
      }
    }, i.prototype.setNodePosition = function(t2, h) {
      var v4 = this.option.data || this.option.nodes, _ = v4[t2];
      _.localX = h[0], _.localY = h[1];
    }, i.prototype.getGraph = function() {
      return this.getData().graph;
    }, i.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      function _(et) {
        return isNaN(et) || et == null;
      }
      if (v4 === "edge") {
        var M2 = this.getDataParams(t2, v4), I2 = M2.data, P2 = M2.value, N3 = I2.source + " -- " + I2.target;
        return pb2("nameValue", { name: N3, value: P2, noValue: _(P2) });
      } else {
        var z3 = this.getGraph().getNodeByIndex(t2), H2 = z3.getLayout().value, $ = this.getDataParams(t2, v4).data.name;
        return pb2("nameValue", { name: $ != null ? $ + "" : null, value: H2, noValue: _(H2) });
      }
    }, i.prototype.optionUpdated = function() {
    }, i.prototype.getDataParams = function(t2, h) {
      var v4 = f2.prototype.getDataParams.call(this, t2, h);
      if (v4.value == null && h === "node") {
        var _ = this.getGraph().getNodeByIndex(t2), M2 = _.getLayout().value;
        v4.value = M2;
      }
      return v4;
    }, i.type = "series.sankey", i.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, i;
  }(Jv), _wr = bwr;
  function xwr(f2, i) {
    f2.eachSeriesByType("sankey", function(t2) {
      var h = t2.get("nodeWidth"), v4 = t2.get("nodeGap"), _ = wwr(t2, i);
      t2.layoutInfo = _;
      var M2 = _.width, I2 = _.height, P2 = t2.getGraph(), N3 = P2.nodes, z3 = P2.edges;
      Mwr(N3);
      var H2 = Ld2(N3, function(ht) {
        return ht.getLayout().value === 0;
      }), $ = H2.length !== 0 ? 0 : t2.get("layoutIterations"), et = t2.get("orient"), at = t2.get("nodeAlign");
      Swr(N3, z3, h, v4, M2, I2, $, et, at);
    });
  }
  function wwr(f2, i) {
    return u1(f2.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
  }
  function Swr(f2, i, t2, h, v4, _, M2, I2, P2) {
    Cwr(f2, i, t2, v4, _, I2, P2), Dwr(f2, i, _, v4, h, M2, I2), Vwr(f2, I2);
  }
  function Mwr(f2) {
    Qe2(f2, function(i) {
      var t2 = Y7(i.outEdges, WEt), h = Y7(i.inEdges, WEt), v4 = i.getValue() || 0, _ = Math.max(t2, h, v4);
      i.setLayout({ value: _ }, true);
    });
  }
  function Cwr(f2, i, t2, h, v4, _, M2) {
    for (var I2 = [], P2 = [], N3 = [], z3 = [], H2 = 0, $ = 0; $ < i.length; $++)
      I2[$] = 1;
    for (var $ = 0; $ < f2.length; $++)
      P2[$] = f2[$].inEdges.length, P2[$] === 0 && N3.push(f2[$]);
    for (var et = -1; N3.length; ) {
      for (var at = 0; at < N3.length; at++) {
        var ht = N3[at], bt = ht.hostGraph.data.getRawDataItem(ht.dataIndex), _t = bt.depth != null && bt.depth >= 0;
        _t && bt.depth > et && (et = bt.depth), ht.setLayout({ depth: _t ? bt.depth : H2 }, true), _ === "vertical" ? ht.setLayout({ dy: t2 }, true) : ht.setLayout({ dx: t2 }, true);
        for (var Et = 0; Et < ht.outEdges.length; Et++) {
          var zt = ht.outEdges[Et], Ft = i.indexOf(zt);
          I2[Ft] = 0;
          var fe2 = zt.node2, re2 = f2.indexOf(fe2);
          --P2[re2] === 0 && z3.indexOf(fe2) < 0 && z3.push(fe2);
        }
      }
      ++H2, N3 = z3, z3 = [];
    }
    for (var $ = 0; $ < I2.length; $++)
      if (I2[$] === 1)
        throw new Error("Sankey is a DAG, the original data has cycle!");
    var ye = et > H2 - 1 ? et : H2 - 1;
    M2 && M2 !== "left" && Twr(f2, M2, _, ye);
    var me2 = _ === "vertical" ? (v4 - t2) / ye : (h - t2) / ye;
    Iwr(f2, me2, _);
  }
  function RUe(f2) {
    var i = f2.hostGraph.data.getRawDataItem(f2.dataIndex);
    return i.depth != null && i.depth >= 0;
  }
  function Twr(f2, i, t2, h) {
    if (i === "right") {
      for (var v4 = [], _ = f2, M2 = 0; _.length; ) {
        for (var I2 = 0; I2 < _.length; I2++) {
          var P2 = _[I2];
          P2.setLayout({ skNodeHeight: M2 }, true);
          for (var N3 = 0; N3 < P2.inEdges.length; N3++) {
            var z3 = P2.inEdges[N3];
            v4.indexOf(z3.node1) < 0 && v4.push(z3.node1);
          }
        }
        _ = v4, v4 = [], ++M2;
      }
      Qe2(f2, function(H2) {
        RUe(H2) || H2.setLayout({ depth: Math.max(0, h - H2.getLayout().skNodeHeight) }, true);
      });
    } else
      i === "justify" && Awr(f2, h);
  }
  function Awr(f2, i) {
    Qe2(f2, function(t2) {
      !RUe(t2) && !t2.outEdges.length && t2.setLayout({ depth: i }, true);
    });
  }
  function Iwr(f2, i, t2) {
    Qe2(f2, function(h) {
      var v4 = h.getLayout().depth * i;
      t2 === "vertical" ? h.setLayout({ y: v4 }, true) : h.setLayout({ x: v4 }, true);
    });
  }
  function Dwr(f2, i, t2, h, v4, _, M2) {
    var I2 = Ewr(f2, M2);
    kwr(I2, i, t2, h, v4, M2), MQt(I2, v4, t2, h, M2);
    for (var P2 = 1; _ > 0; _--)
      P2 *= 0.99, Pwr(I2, P2, M2), MQt(I2, v4, t2, h, M2), Fwr(I2, P2, M2), MQt(I2, v4, t2, h, M2);
  }
  function Ewr(f2, i) {
    var t2 = [], h = i === "vertical" ? "y" : "x", v4 = RJt(f2, function(_) {
      return _.getLayout()[h];
    });
    return v4.keys.sort(function(_, M2) {
      return _ - M2;
    }), Qe2(v4.keys, function(_) {
      t2.push(v4.buckets.get(_));
    }), t2;
  }
  function kwr(f2, i, t2, h, v4, _) {
    var M2 = 1 / 0;
    Qe2(f2, function(I2) {
      var P2 = I2.length, N3 = 0;
      Qe2(I2, function(H2) {
        N3 += H2.getLayout().value;
      });
      var z3 = _ === "vertical" ? (h - (P2 - 1) * v4) / N3 : (t2 - (P2 - 1) * v4) / N3;
      z3 < M2 && (M2 = z3);
    }), Qe2(f2, function(I2) {
      Qe2(I2, function(P2, N3) {
        var z3 = P2.getLayout().value * M2;
        _ === "vertical" ? (P2.setLayout({ x: N3 }, true), P2.setLayout({ dx: z3 }, true)) : (P2.setLayout({ y: N3 }, true), P2.setLayout({ dy: z3 }, true));
      });
    }), Qe2(i, function(I2) {
      var P2 = +I2.getValue() * M2;
      I2.setLayout({ dy: P2 }, true);
    });
  }
  function MQt(f2, i, t2, h, v4) {
    var _ = v4 === "vertical" ? "x" : "y";
    Qe2(f2, function(M2) {
      M2.sort(function(ht, bt) {
        return ht.getLayout()[_] - bt.getLayout()[_];
      });
      for (var I2, P2, N3, z3 = 0, H2 = M2.length, $ = v4 === "vertical" ? "dx" : "dy", et = 0; et < H2; et++)
        P2 = M2[et], N3 = z3 - P2.getLayout()[_], N3 > 0 && (I2 = P2.getLayout()[_] + N3, v4 === "vertical" ? P2.setLayout({ x: I2 }, true) : P2.setLayout({ y: I2 }, true)), z3 = P2.getLayout()[_] + P2.getLayout()[$] + i;
      var at = v4 === "vertical" ? h : t2;
      if (N3 = z3 - i - at, N3 > 0) {
        I2 = P2.getLayout()[_] - N3, v4 === "vertical" ? P2.setLayout({ x: I2 }, true) : P2.setLayout({ y: I2 }, true), z3 = I2;
        for (var et = H2 - 2; et >= 0; --et)
          P2 = M2[et], N3 = P2.getLayout()[_] + P2.getLayout()[$] + i - z3, N3 > 0 && (I2 = P2.getLayout()[_] - N3, v4 === "vertical" ? P2.setLayout({ x: I2 }, true) : P2.setLayout({ y: I2 }, true)), z3 = P2.getLayout()[_];
      }
    });
  }
  function Pwr(f2, i, t2) {
    Qe2(f2.slice().reverse(), function(h) {
      Qe2(h, function(v4) {
        if (v4.outEdges.length) {
          var _ = Y7(v4.outEdges, Lwr, t2) / Y7(v4.outEdges, WEt);
          if (isNaN(_)) {
            var M2 = v4.outEdges.length;
            _ = M2 ? Y7(v4.outEdges, Owr, t2) / M2 : 0;
          }
          if (t2 === "vertical") {
            var I2 = v4.getLayout().x + (_ - nV(v4, t2)) * i;
            v4.setLayout({ x: I2 }, true);
          } else {
            var P2 = v4.getLayout().y + (_ - nV(v4, t2)) * i;
            v4.setLayout({ y: P2 }, true);
          }
        }
      });
    });
  }
  function Lwr(f2, i) {
    return nV(f2.node2, i) * f2.getValue();
  }
  function Owr(f2, i) {
    return nV(f2.node2, i);
  }
  function Rwr(f2, i) {
    return nV(f2.node1, i) * f2.getValue();
  }
  function Nwr(f2, i) {
    return nV(f2.node1, i);
  }
  function nV(f2, i) {
    return i === "vertical" ? f2.getLayout().x + f2.getLayout().dx / 2 : f2.getLayout().y + f2.getLayout().dy / 2;
  }
  function WEt(f2) {
    return f2.getValue();
  }
  function Y7(f2, i, t2) {
    for (var h = 0, v4 = f2.length, _ = -1; ++_ < v4; ) {
      var M2 = +i(f2[_], t2);
      isNaN(M2) || (h += M2);
    }
    return h;
  }
  function Fwr(f2, i, t2) {
    Qe2(f2, function(h) {
      Qe2(h, function(v4) {
        if (v4.inEdges.length) {
          var _ = Y7(v4.inEdges, Rwr, t2) / Y7(v4.inEdges, WEt);
          if (isNaN(_)) {
            var M2 = v4.inEdges.length;
            _ = M2 ? Y7(v4.inEdges, Nwr, t2) / M2 : 0;
          }
          if (t2 === "vertical") {
            var I2 = v4.getLayout().x + (_ - nV(v4, t2)) * i;
            v4.setLayout({ x: I2 }, true);
          } else {
            var P2 = v4.getLayout().y + (_ - nV(v4, t2)) * i;
            v4.setLayout({ y: P2 }, true);
          }
        }
      });
    });
  }
  function Vwr(f2, i) {
    var t2 = i === "vertical" ? "x" : "y";
    Qe2(f2, function(h) {
      h.outEdges.sort(function(v4, _) {
        return v4.node2.getLayout()[t2] - _.node2.getLayout()[t2];
      }), h.inEdges.sort(function(v4, _) {
        return v4.node1.getLayout()[t2] - _.node1.getLayout()[t2];
      });
    }), Qe2(f2, function(h) {
      var v4 = 0, _ = 0;
      Qe2(h.outEdges, function(M2) {
        M2.setLayout({ sy: v4 }, true), v4 += M2.getLayout().dy;
      }), Qe2(h.inEdges, function(M2) {
        M2.setLayout({ ty: _ }, true), _ += M2.getLayout().dy;
      });
    });
  }
  function Bwr(f2) {
    f2.eachSeriesByType("sankey", function(i) {
      var t2 = i.getGraph(), h = t2.nodes;
      if (h.length) {
        var v4 = 1 / 0, _ = -1 / 0;
        Qe2(h, function(M2) {
          var I2 = M2.getLayout().value;
          I2 < v4 && (v4 = I2), I2 > _ && (_ = I2);
        }), Qe2(h, function(M2) {
          var I2 = new Gx({ type: "color", mappingMethod: "linear", dataExtent: [v4, _], visual: i.get("color") }), P2 = I2.mapValueToVisual(M2.getLayout().value), N3 = M2.getModel().get(["itemStyle", "color"]);
          N3 != null ? (M2.setVisual("color", N3), M2.setVisual("style", { fill: N3 })) : (M2.setVisual("color", P2), M2.setVisual("style", { fill: P2 }));
        });
      }
    });
  }
  function zwr(f2) {
    f2.registerChartView(mwr), f2.registerSeriesModel(_wr), f2.registerLayout(xwr), f2.registerVisual(Bwr), f2.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(i, t2) {
      t2.eachComponent({ mainType: "series", subType: "sankey", query: i }, function(h) {
        h.setNodePosition(i.dataIndex, [i.localX, i.localY]);
      });
    });
  }
  var NUe = function() {
    function f2() {
    }
    return f2.prototype.getInitialData = function(i, t2) {
      var h, v4 = t2.getComponent("xAxis", this.get("xAxisIndex")), _ = t2.getComponent("yAxis", this.get("yAxisIndex")), M2 = v4.get("type"), I2 = _.get("type"), P2;
      M2 === "category" ? (i.layout = "horizontal", h = v4.getOrdinalMeta(), P2 = true) : I2 === "category" ? (i.layout = "vertical", h = _.getOrdinalMeta(), P2 = true) : i.layout = i.layout || "horizontal";
      var N3 = ["x", "y"], z3 = i.layout === "horizontal" ? 0 : 1, H2 = this._baseAxisDim = N3[z3], $ = N3[1 - z3], et = [v4, _], at = et[z3].get("type"), ht = et[1 - z3].get("type"), bt = i.data;
      if (bt && P2) {
        var _t = [];
        Qe2(bt, function(Ft, fe2) {
          var re2;
          Za2(Ft) ? (re2 = Ft.slice(), Ft.unshift(fe2)) : Za2(Ft.value) ? (re2 = ba2({}, Ft), re2.value = re2.value.slice(), Ft.value.unshift(fe2)) : re2 = Ft, _t.push(re2);
        }), i.data = _t;
      }
      var Et = this.defaultValueDimensions, zt = [{ name: H2, type: EEt(at), ordinalMeta: h, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: $, type: EEt(ht), dimsDef: Et.slice() }];
      return het(this, { coordDimensions: zt, dimensionsCount: Et.length + 1, encodeDefaulter: Ou(lWe, zt, this) });
    }, f2.prototype.getBaseAxis = function() {
      var i = this._baseAxisDim;
      return this.ecModel.getComponent(i + "Axis", this.get(i + "AxisIndex")).axis;
    }, f2;
  }(), FUe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], t2.visualDrawType = "stroke", t2;
    }
    return i.type = "series.boxplot", i.dependencies = ["xAxis", "yAxis", "grid"], i.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, i;
  }(Jv);
  Sm(FUe, NUe, true);
  var jwr = FUe, Wwr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this.group, I2 = this._data;
      this._data || M2.removeAll();
      var P2 = t2.get("layout") === "horizontal" ? 1 : 0;
      _.diff(I2).add(function(N3) {
        if (_.hasValue(N3)) {
          var z3 = _.getItemLayout(N3), H2 = Q9e(z3, _, N3, P2, true);
          _.setItemGraphicEl(N3, H2), M2.add(H2);
        }
      }).update(function(N3, z3) {
        var H2 = I2.getItemGraphicEl(z3);
        if (!_.hasValue(N3)) {
          M2.remove(H2);
          return;
        }
        var $ = _.getItemLayout(N3);
        H2 ? (A5(H2), VUe($, H2, _, N3)) : H2 = Q9e($, _, N3, P2), M2.add(H2), _.setItemGraphicEl(N3, H2);
      }).remove(function(N3) {
        var z3 = I2.getItemGraphicEl(N3);
        z3 && M2.remove(z3);
      }).execute(), this._data = _;
    }, i.prototype.remove = function(t2) {
      var h = this.group, v4 = this._data;
      this._data = null, v4 && v4.eachItemGraphicEl(function(_) {
        _ && h.remove(_);
      });
    }, i.type = "boxplot", i;
  }(Hg2), Gwr = function() {
    function f2() {
    }
    return f2;
  }(), Hwr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "boxplotBoxPath", h;
    }
    return i.prototype.getDefaultShape = function() {
      return new Gwr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.points, _ = 0;
      for (t2.moveTo(v4[_][0], v4[_][1]), _++; _ < 4; _++)
        t2.lineTo(v4[_][0], v4[_][1]);
      for (t2.closePath(); _ < v4.length; _++)
        t2.moveTo(v4[_][0], v4[_][1]), _++, t2.lineTo(v4[_][0], v4[_][1]);
    }, i;
  }(Uc2);
  function Q9e(f2, i, t2, h, v4) {
    var _ = f2.ends, M2 = new Hwr({ shape: { points: v4 ? Uwr(_, h, f2) : _ } });
    return VUe(f2, M2, i, t2, v4), M2;
  }
  function VUe(f2, i, t2, h, v4) {
    var _ = t2.hostModel, M2 = kgt[v4 ? "initProps" : "updateProps"];
    M2(i, { shape: { points: f2.ends } }, _, h), i.useStyle(t2.getItemVisual(h, "style")), i.style.strokeNoScale = true, i.z2 = 100;
    var I2 = t2.getItemModel(h), P2 = I2.getModel("emphasis");
    Hx(i, I2), vy(i, P2.get("focus"), P2.get("blurScope"), P2.get("disabled"));
  }
  function Uwr(f2, i, t2) {
    return Xa2(f2, function(h) {
      return h = h.slice(), h[i] = t2.initBaseline, h;
    });
  }
  var qwr = Wwr;
  function Zwr(f2, i) {
  }
  var jdt = Qe2;
  function $wr(f2) {
    var i = Ywr(f2);
    jdt(i, function(t2) {
      var h = t2.seriesModels;
      !h.length || (Kwr(t2), jdt(h, function(v4, _) {
        Xwr(v4, t2.boxOffsetList[_], t2.boxWidthList[_]);
      }));
    });
  }
  function Ywr(f2) {
    var i = [], t2 = [];
    return f2.eachSeriesByType("boxplot", function(h) {
      var v4 = h.getBaseAxis(), _ = Pc2(t2, v4);
      _ < 0 && (_ = t2.length, t2[_] = v4, i[_] = { axis: v4, seriesModels: [] }), i[_].seriesModels.push(h);
    }), i;
  }
  function Kwr(f2) {
    var i = f2.axis, t2 = f2.seriesModels, h = t2.length, v4 = f2.boxWidthList = [], _ = f2.boxOffsetList = [], M2 = [], I2;
    if (i.type === "category")
      I2 = i.getBandWidth();
    else {
      var P2 = 0;
      jdt(t2, function(at) {
        P2 = Math.max(P2, at.getData().count());
      });
      var N3 = i.getExtent();
      I2 = Math.abs(N3[1] - N3[0]) / P2;
    }
    jdt(t2, function(at) {
      var ht = at.get("boxWidth");
      Za2(ht) || (ht = [ht, ht]), M2.push([cs(ht[0], I2) || 0, cs(ht[1], I2) || 0]);
    });
    var z3 = I2 * 0.8 - 2, H2 = z3 / h * 0.3, $ = (z3 - H2 * (h - 1)) / h, et = $ / 2 - z3 / 2;
    jdt(t2, function(at, ht) {
      _.push(et), et += H2 + $, v4.push(Math.min(Math.max($, M2[ht][0]), M2[ht][1]));
    });
  }
  function Xwr(f2, i, t2) {
    var h = f2.coordinateSystem, v4 = f2.getData(), _ = t2 / 2, M2 = f2.get("layout") === "horizontal" ? 0 : 1, I2 = 1 - M2, P2 = ["x", "y"], N3 = v4.mapDimension(P2[M2]), z3 = v4.mapDimensionsAll(P2[I2]);
    if (N3 == null || z3.length < 5)
      return;
    for (var H2 = 0; H2 < v4.count(); H2++) {
      var $ = v4.get(N3, H2), et = zt($, z3[2], H2), at = zt($, z3[0], H2), ht = zt($, z3[1], H2), bt = zt($, z3[3], H2), _t = zt($, z3[4], H2), Et = [];
      Ft(Et, ht, false), Ft(Et, bt, true), Et.push(at, ht, _t, bt), fe2(Et, at), fe2(Et, _t), fe2(Et, et), v4.setItemLayout(H2, { initBaseline: et[I2], ends: Et });
    }
    function zt(re2, ye, me2) {
      var be2 = v4.get(ye, me2), Te2 = [];
      Te2[M2] = re2, Te2[I2] = be2;
      var We;
      return isNaN(re2) || isNaN(be2) ? We = [NaN, NaN] : (We = h.dataToPoint(Te2), We[M2] += i), We;
    }
    function Ft(re2, ye, me2) {
      var be2 = ye.slice(), Te2 = ye.slice();
      be2[M2] += _, Te2[M2] -= _, me2 ? re2.push(be2, Te2) : re2.push(Te2, be2);
    }
    function fe2(re2, ye) {
      var me2 = ye.slice(), be2 = ye.slice();
      me2[M2] -= _, be2[M2] += _, re2.push(me2, be2);
    }
  }
  function Qwr(f2, i) {
    i = i || {};
    for (var t2 = [], h = [], v4 = i.boundIQR, _ = v4 === "none" || v4 === 0, M2 = 0; M2 < f2.length; M2++) {
      var I2 = QD(f2[M2].slice()), P2 = JKt(I2, 0.25), N3 = JKt(I2, 0.5), z3 = JKt(I2, 0.75), H2 = I2[0], $ = I2[I2.length - 1], et = (v4 == null ? 1.5 : v4) * (z3 - P2), at = _ ? H2 : Math.max(H2, P2 - et), ht = _ ? $ : Math.min($, z3 + et), bt = i.itemNameFormatter, _t = Ol(bt) ? bt({ value: M2 }) : ms(bt) ? bt.replace("{value}", M2 + "") : M2 + "";
      t2.push([_t, at, P2, N3, z3, ht]);
      for (var Et = 0; Et < I2.length; Et++) {
        var zt = I2[Et];
        if (zt < at || zt > ht) {
          var Ft = [_t, zt];
          h.push(Ft);
        }
      }
    }
    return { boxData: t2, outliers: h };
  }
  var Jwr = { type: "echarts:boxplot", transform: function(i) {
    var t2 = i.upstream;
    if (t2.sourceFormat !== wS) {
      var h = "";
      Ep(h);
    }
    var v4 = Qwr(t2.getRawData(), i.config);
    return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: v4.boxData }, { data: v4.outliers }];
  } };
  function tSr(f2) {
    f2.registerSeriesModel(jwr), f2.registerChartView(qwr), f2.registerVisual(Zwr), f2.registerLayout($wr), f2.registerTransform(Jwr);
  }
  var eSr = ["color", "borderColor"], nSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(t2), this._isLargeDraw ? this._renderLarge(t2) : this._renderNormal(t2);
    }, i.prototype.incrementalPrepareRender = function(t2, h, v4) {
      this._clear(), this._updateDrawMode(t2);
    }, i.prototype.incrementalRender = function(t2, h, v4, _) {
      this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(t2, h) : this._incrementalRenderNormal(t2, h);
    }, i.prototype.eachRendered = function(t2) {
      oV(this._progressiveEls || this.group, t2);
    }, i.prototype._updateDrawMode = function(t2) {
      var h = t2.pipelineContext.large;
      (this._isLargeDraw == null || h !== this._isLargeDraw) && (this._isLargeDraw = h, this._clear());
    }, i.prototype._renderNormal = function(t2) {
      var h = t2.getData(), v4 = this._data, _ = this.group, M2 = h.getLayout("isSimpleBox"), I2 = t2.get("clip", true), P2 = t2.coordinateSystem, N3 = P2.getArea && P2.getArea();
      this._data || _.removeAll(), h.diff(v4).add(function(z3) {
        if (h.hasValue(z3)) {
          var H2 = h.getItemLayout(z3);
          if (I2 && J9e(N3, H2))
            return;
          var $ = CQt(H2, z3, true);
          Qv($, { shape: { points: H2.ends } }, t2, z3), TQt($, h, z3, M2), _.add($), h.setItemGraphicEl(z3, $);
        }
      }).update(function(z3, H2) {
        var $ = v4.getItemGraphicEl(H2);
        if (!h.hasValue(z3)) {
          _.remove($);
          return;
        }
        var et = h.getItemLayout(z3);
        if (I2 && J9e(N3, et)) {
          _.remove($);
          return;
        }
        $ ? (jh2($, { shape: { points: et.ends } }, t2, z3), A5($)) : $ = CQt(et), TQt($, h, z3, M2), _.add($), h.setItemGraphicEl(z3, $);
      }).remove(function(z3) {
        var H2 = v4.getItemGraphicEl(z3);
        H2 && _.remove(H2);
      }).execute(), this._data = h;
    }, i.prototype._renderLarge = function(t2) {
      this._clear(), e7e(t2, this.group);
      var h = t2.get("clip", true) ? Fkt(t2.coordinateSystem, false, t2) : null;
      h ? this.group.setClipPath(h) : this.group.removeClipPath();
    }, i.prototype._incrementalRenderNormal = function(t2, h) {
      for (var v4 = h.getData(), _ = v4.getLayout("isSimpleBox"), M2; (M2 = t2.next()) != null; ) {
        var I2 = v4.getItemLayout(M2), P2 = CQt(I2);
        TQt(P2, v4, M2, _), P2.incremental = true, this.group.add(P2), this._progressiveEls.push(P2);
      }
    }, i.prototype._incrementalRenderLarge = function(t2, h) {
      e7e(h, this.group, this._progressiveEls, true);
    }, i.prototype.remove = function(t2) {
      this._clear();
    }, i.prototype._clear = function() {
      this.group.removeAll(), this._data = null;
    }, i.type = "candlestick", i;
  }(Hg2), rSr = function() {
    function f2() {
    }
    return f2;
  }(), iSr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "normalCandlestickBox", h;
    }
    return i.prototype.getDefaultShape = function() {
      return new rSr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.points;
      this.__simpleBox ? (t2.moveTo(v4[4][0], v4[4][1]), t2.lineTo(v4[6][0], v4[6][1])) : (t2.moveTo(v4[0][0], v4[0][1]), t2.lineTo(v4[1][0], v4[1][1]), t2.lineTo(v4[2][0], v4[2][1]), t2.lineTo(v4[3][0], v4[3][1]), t2.closePath(), t2.moveTo(v4[4][0], v4[4][1]), t2.lineTo(v4[5][0], v4[5][1]), t2.moveTo(v4[6][0], v4[6][1]), t2.lineTo(v4[7][0], v4[7][1]));
    }, i;
  }(Uc2);
  function CQt(f2, i, t2) {
    var h = f2.ends;
    return new iSr({ shape: { points: t2 ? aSr(h, f2) : h }, z2: 100 });
  }
  function J9e(f2, i) {
    for (var t2 = true, h = 0; h < i.ends.length; h++)
      if (f2.contain(i.ends[h][0], i.ends[h][1])) {
        t2 = false;
        break;
      }
    return t2;
  }
  function TQt(f2, i, t2, h) {
    var v4 = i.getItemModel(t2);
    f2.useStyle(i.getItemVisual(t2, "style")), f2.style.strokeNoScale = true, f2.__simpleBox = h, Hx(f2, v4);
  }
  function aSr(f2, i) {
    return Xa2(f2, function(t2) {
      return t2 = t2.slice(), t2[1] = i.initBaseline, t2;
    });
  }
  var oSr = function() {
    function f2() {
    }
    return f2;
  }(), t7e = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h.type = "largeCandlestickBox", h;
    }
    return i.prototype.getDefaultShape = function() {
      return new oSr();
    }, i.prototype.buildPath = function(t2, h) {
      for (var v4 = h.points, _ = 0; _ < v4.length; )
        if (this.__sign === v4[_++]) {
          var M2 = v4[_++];
          t2.moveTo(M2, v4[_++]), t2.lineTo(M2, v4[_++]);
        } else
          _ += 3;
    }, i;
  }(Uc2);
  function e7e(f2, i, t2, h) {
    var v4 = f2.getData(), _ = v4.getLayout("largePoints"), M2 = new t7e({ shape: { points: _ }, __sign: 1 });
    i.add(M2);
    var I2 = new t7e({ shape: { points: _ }, __sign: -1 });
    i.add(I2), n7e(1, M2, f2), n7e(-1, I2, f2), h && (M2.incremental = true, I2.incremental = true), t2 && t2.push(M2, I2);
  }
  function n7e(f2, i, t2, h) {
    var v4 = t2.get(["itemStyle", f2 > 0 ? "borderColor" : "borderColor0"]) || t2.get(["itemStyle", f2 > 0 ? "color" : "color0"]), _ = t2.getModel("itemStyle").getItemStyle(eSr);
    i.useStyle(_), i.style.fill = null, i.style.stroke = v4;
  }
  var sSr = nSr, BUe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], t2;
    }
    return i.prototype.getShadowDim = function() {
      return "open";
    }, i.prototype.brushSelector = function(t2, h, v4) {
      var _ = h.getItemLayout(t2);
      return _ && v4.rect(_.brushRect);
    }, i.type = "series.candlestick", i.dependencies = ["xAxis", "yAxis", "grid"], i.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, i;
  }(Jv);
  Sm(BUe, NUe, true);
  var lSr = BUe;
  function uSr(f2) {
    !f2 || !Za2(f2.series) || Qe2(f2.series, function(i) {
      Xl(i) && i.type === "k" && (i.type = "candlestick");
    });
  }
  var cSr = ["itemStyle", "borderColor"], fSr = ["itemStyle", "borderColor0"], hSr = ["itemStyle", "color"], pSr = ["itemStyle", "color0"], dSr = { seriesType: "candlestick", plan: uet(), performRawSeries: true, reset: function(f2, i) {
    function t2(_, M2) {
      return M2.get(_ > 0 ? hSr : pSr);
    }
    function h(_, M2) {
      return M2.get(_ > 0 ? cSr : fSr);
    }
    if (!i.isSeriesFiltered(f2)) {
      var v4 = f2.pipelineContext.large;
      return !v4 && { progress: function(_, M2) {
        for (var I2; (I2 = _.next()) != null; ) {
          var P2 = M2.getItemModel(I2), N3 = M2.getItemLayout(I2).sign, z3 = P2.getItemStyle();
          z3.fill = t2(N3, P2), z3.stroke = h(N3, P2) || z3.fill;
          var H2 = M2.ensureUniqueItemVisual(I2, "style");
          ba2(H2, z3);
        }
      } };
    }
  } }, gSr = dSr, vSr = { seriesType: "candlestick", plan: uet(), reset: function(f2) {
    var i = f2.coordinateSystem, t2 = f2.getData(), h = ySr(f2, t2), v4 = 0, _ = 1, M2 = ["x", "y"], I2 = t2.getDimensionIndex(t2.mapDimension(M2[v4])), P2 = Xa2(t2.mapDimensionsAll(M2[_]), t2.getDimensionIndex, t2), N3 = P2[0], z3 = P2[1], H2 = P2[2], $ = P2[3];
    if (t2.setLayout({ candleWidth: h, isSimpleBox: h <= 1.3 }), I2 < 0 || P2.length < 4)
      return;
    return { progress: f2.pipelineContext.large ? at : et };
    function et(ht, bt) {
      for (var _t, Et = bt.getStore(); (_t = ht.next()) != null; ) {
        var zt = Et.get(I2, _t), Ft = Et.get(N3, _t), fe2 = Et.get(z3, _t), re2 = Et.get(H2, _t), ye = Et.get($, _t), me2 = Math.min(Ft, fe2), be2 = Math.max(Ft, fe2), Te2 = Vn(me2, zt), We = Vn(be2, zt), en = Vn(re2, zt), Ue2 = Vn(ye, zt), Mn = [];
        xn(Mn, We, 0), xn(Mn, Te2, 1), Mn.push(nr(Ue2), nr(We), nr(en), nr(Te2)), bt.setItemLayout(_t, { sign: r7e(Et, _t, Ft, fe2, z3), initBaseline: Ft > fe2 ? We[_] : Te2[_], ends: Mn, brushRect: Zr(re2, ye, zt) });
      }
      function Vn(pr, Nr) {
        var ai2 = [];
        return ai2[v4] = Nr, ai2[_] = pr, isNaN(Nr) || isNaN(pr) ? [NaN, NaN] : i.dataToPoint(ai2);
      }
      function xn(pr, Nr, ai2) {
        var gi2 = Nr.slice(), To = Nr.slice();
        gi2[v4] = $Dt(gi2[v4] + h / 2, 1, false), To[v4] = $Dt(To[v4] - h / 2, 1, true), ai2 ? pr.push(gi2, To) : pr.push(To, gi2);
      }
      function Zr(pr, Nr, ai2) {
        var gi2 = Vn(pr, ai2), To = Vn(Nr, ai2);
        return gi2[v4] -= h / 2, To[v4] -= h / 2, { x: gi2[0], y: gi2[1], width: h, height: To[1] - gi2[1] };
      }
      function nr(pr) {
        return pr[v4] = $Dt(pr[v4], 1), pr;
      }
    }
    function at(ht, bt) {
      for (var _t = OL(ht.count * 4), Et = 0, zt, Ft = [], fe2 = [], re2, ye = bt.getStore(); (re2 = ht.next()) != null; ) {
        var me2 = ye.get(I2, re2), be2 = ye.get(N3, re2), Te2 = ye.get(z3, re2), We = ye.get(H2, re2), en = ye.get($, re2);
        if (isNaN(me2) || isNaN(We) || isNaN(en)) {
          _t[Et++] = NaN, Et += 3;
          continue;
        }
        _t[Et++] = r7e(ye, re2, be2, Te2, z3), Ft[v4] = me2, Ft[_] = We, zt = i.dataToPoint(Ft, null, fe2), _t[Et++] = zt ? zt[0] : NaN, _t[Et++] = zt ? zt[1] : NaN, Ft[_] = en, zt = i.dataToPoint(Ft, null, fe2), _t[Et++] = zt ? zt[1] : NaN;
      }
      bt.setLayout("largePoints", _t);
    }
  } };
  function r7e(f2, i, t2, h, v4) {
    var _;
    return t2 > h ? _ = -1 : t2 < h ? _ = 1 : _ = i > 0 ? f2.get(v4, i - 1) <= h ? 1 : -1 : 1, _;
  }
  function ySr(f2, i) {
    var t2 = f2.getBaseAxis(), h, v4 = t2.type === "category" ? t2.getBandWidth() : (h = t2.getExtent(), Math.abs(h[1] - h[0]) / i.count()), _ = cs(_c2(f2.get("barMaxWidth"), v4), v4), M2 = cs(_c2(f2.get("barMinWidth"), 1), v4), I2 = f2.get("barWidth");
    return I2 != null ? cs(I2, v4) : Math.max(Math.min(v4 / 2, _), M2);
  }
  var mSr = vSr;
  function bSr(f2) {
    f2.registerChartView(sSr), f2.registerSeriesModel(lSr), f2.registerPreprocessor(uSr), f2.registerVisual(gSr), f2.registerLayout(mSr);
  }
  function i7e(f2, i) {
    var t2 = i.rippleEffectColor || i.color;
    f2.eachChild(function(h) {
      h.attr({ z: i.z, zlevel: i.zlevel, style: { stroke: i.brushType === "stroke" ? t2 : null, fill: i.brushType === "fill" ? t2 : null } });
    });
  }
  var _Sr = function(f2) {
    ii2(i, f2);
    function i(t2, h) {
      var v4 = f2.call(this) || this, _ = new Vgt(t2, h), M2 = new mu();
      return v4.add(_), v4.add(M2), v4.updateData(t2, h), v4;
    }
    return i.prototype.stopEffectAnimation = function() {
      this.childAt(1).removeAll();
    }, i.prototype.startEffectAnimation = function(t2) {
      for (var h = t2.symbolType, v4 = t2.color, _ = t2.rippleNumber, M2 = this.childAt(1), I2 = 0; I2 < _; I2++) {
        var P2 = wm(h, -1, -1, 2, 2, v4);
        P2.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
        var N3 = -I2 / _ * t2.period + t2.effectOffset;
        P2.animate("", true).when(t2.period, { scaleX: t2.rippleScale / 2, scaleY: t2.rippleScale / 2 }).delay(N3).start(), P2.animateStyle(true).when(t2.period, { opacity: 0 }).delay(N3).start(), M2.add(P2);
      }
      i7e(M2, t2);
    }, i.prototype.updateEffectAnimation = function(t2) {
      for (var h = this._effectCfg, v4 = this.childAt(1), _ = ["symbolType", "period", "rippleScale", "rippleNumber"], M2 = 0; M2 < _.length; M2++) {
        var I2 = _[M2];
        if (h[I2] !== t2[I2]) {
          this.stopEffectAnimation(), this.startEffectAnimation(t2);
          return;
        }
      }
      i7e(v4, t2);
    }, i.prototype.highlight = function() {
      NL(this);
    }, i.prototype.downplay = function() {
      FL(this);
    }, i.prototype.getSymbolType = function() {
      var t2 = this.childAt(0);
      return t2 && t2.getSymbolType();
    }, i.prototype.updateData = function(t2, h) {
      var v4 = this, _ = t2.hostModel;
      this.childAt(0).updateData(t2, h);
      var M2 = this.childAt(1), I2 = t2.getItemModel(h), P2 = t2.getItemVisual(h, "symbol"), N3 = Ogt(t2.getItemVisual(h, "symbolSize")), z3 = t2.getItemVisual(h, "style"), H2 = z3 && z3.fill, $ = I2.getModel("emphasis");
      M2.setScale(N3), M2.traverse(function(bt) {
        bt.setStyle("fill", H2);
      });
      var et = fet(t2.getItemVisual(h, "symbolOffset"), N3);
      et && (M2.x = et[0], M2.y = et[1]);
      var at = t2.getItemVisual(h, "symbolRotate");
      M2.rotation = (at || 0) * Math.PI / 180 || 0;
      var ht = {};
      ht.showEffectOn = _.get("showEffectOn"), ht.rippleScale = I2.get(["rippleEffect", "scale"]), ht.brushType = I2.get(["rippleEffect", "brushType"]), ht.period = I2.get(["rippleEffect", "period"]) * 1e3, ht.effectOffset = h / t2.count(), ht.z = _.getShallow("z") || 0, ht.zlevel = _.getShallow("zlevel") || 0, ht.symbolType = P2, ht.color = H2, ht.rippleEffectColor = I2.get(["rippleEffect", "color"]), ht.rippleNumber = I2.get(["rippleEffect", "number"]), ht.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(ht) : this.startEffectAnimation(ht), this._effectCfg = ht) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(bt) {
        bt === "emphasis" ? ht.showEffectOn !== "render" && v4.startEffectAnimation(ht) : bt === "normal" && ht.showEffectOn !== "render" && v4.stopEffectAnimation();
      }), this._effectCfg = ht, vy(this, $.get("focus"), $.get("blurScope"), $.get("disabled"));
    }, i.prototype.fadeOut = function(t2) {
      t2 && t2();
    }, i;
  }(mu), xSr = _Sr, wSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function() {
      this._symbolDraw = new Bgt(xSr);
    }, i.prototype.render = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this._symbolDraw;
      M2.updateData(_, { clipShape: this._getClipShape(t2) }), this.group.add(M2.group);
    }, i.prototype._getClipShape = function(t2) {
      var h = t2.coordinateSystem, v4 = h && h.getArea && h.getArea();
      return t2.get("clip", true) ? v4 : null;
    }, i.prototype.updateTransform = function(t2, h, v4) {
      var _ = t2.getData();
      this.group.dirty();
      var M2 = zgt("").reset(t2, h, v4);
      M2.progress && M2.progress({ start: 0, end: _.count(), count: _.count() }, _), this._symbolDraw.updateLayout();
    }, i.prototype._updateGroupTransform = function(t2) {
      var h = t2.coordinateSystem;
      h && h.getRoamTransform && (this.group.transform = Bur(h.getRoamTransform()), this.group.decomposeTransform());
    }, i.prototype.remove = function(t2, h) {
      this._symbolDraw && this._symbolDraw.remove(true);
    }, i.type = "effectScatter", i;
  }(Hg2), SSr = wSr, MSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.hasSymbolVisual = true, t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      return aN(null, this, { useEncodeDefaulter: true });
    }, i.prototype.brushSelector = function(t2, h, v4) {
      return v4.point(h.getItemLayout(t2));
    }, i.type = "series.effectScatter", i.dependencies = ["grid", "polar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, i;
  }(Jv), CSr = MSr;
  function TSr(f2) {
    f2.registerChartView(SSr), f2.registerSeriesModel(CSr), f2.registerLayout(zgt("effectScatter"));
  }
  var ASr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this) || this;
      return _.add(_.createLine(t2, h, v4)), _._updateEffectSymbol(t2, h), _;
    }
    return i.prototype.createLine = function(t2, h, v4) {
      return new Bne(t2, h, v4);
    }, i.prototype._updateEffectSymbol = function(t2, h) {
      var v4 = t2.getItemModel(h), _ = v4.getModel("effect"), M2 = _.get("symbolSize"), I2 = _.get("symbol");
      Za2(M2) || (M2 = [M2, M2]);
      var P2 = t2.getItemVisual(h, "style"), N3 = _.get("color") || P2 && P2.stroke, z3 = this.childAt(1);
      this._symbolType !== I2 && (this.remove(z3), z3 = wm(I2, -0.5, -0.5, 1, 1, N3), z3.z2 = 100, z3.culling = true, this.add(z3)), z3 && (z3.setStyle("shadowColor", N3), z3.setStyle(_.getItemStyle(["color"])), z3.scaleX = M2[0], z3.scaleY = M2[1], z3.setColor(N3), this._symbolType = I2, this._symbolScale = M2, this._updateEffectAnimation(t2, _, h));
    }, i.prototype._updateEffectAnimation = function(t2, h, v4) {
      var _ = this.childAt(1);
      if (!!_) {
        var M2 = t2.getItemLayout(v4), I2 = h.get("period") * 1e3, P2 = h.get("loop"), N3 = h.get("constantSpeed"), z3 = y_(h.get("delay"), function($) {
          return $ / t2.count() * I2 / 3;
        });
        if (_.ignore = true, this._updateAnimationPoints(_, M2), N3 > 0 && (I2 = this._getLineLength(_) / N3 * 1e3), I2 !== this._period || P2 !== this._loop) {
          _.stopAnimation();
          var H2 = void 0;
          Ol(z3) ? H2 = z3(v4) : H2 = z3, _.__t > 0 && (H2 = -I2 * _.__t), this._animateSymbol(_, I2, H2, P2);
        }
        this._period = I2, this._loop = P2;
      }
    }, i.prototype._animateSymbol = function(t2, h, v4, _) {
      if (h > 0) {
        t2.__t = 0;
        var M2 = this, I2 = t2.animate("", _).when(h, { __t: 1 }).delay(v4).during(function() {
          M2._updateSymbolPosition(t2);
        });
        _ || I2.done(function() {
          M2.remove(t2);
        }), I2.start();
      }
    }, i.prototype._getLineLength = function(t2) {
      return R7(t2.__p1, t2.__cp1) + R7(t2.__cp1, t2.__p2);
    }, i.prototype._updateAnimationPoints = function(t2, h) {
      t2.__p1 = h[0], t2.__p2 = h[1], t2.__cp1 = h[2] || [(h[0][0] + h[1][0]) / 2, (h[0][1] + h[1][1]) / 2];
    }, i.prototype.updateData = function(t2, h, v4) {
      this.childAt(0).updateData(t2, h, v4), this._updateEffectSymbol(t2, h);
    }, i.prototype._updateSymbolPosition = function(t2) {
      var h = t2.__p1, v4 = t2.__p2, _ = t2.__cp1, M2 = t2.__t, I2 = [t2.x, t2.y], P2 = I2.slice(), N3 = v_, z3 = wJt;
      I2[0] = N3(h[0], _[0], v4[0], M2), I2[1] = N3(h[1], _[1], v4[1], M2);
      var H2 = z3(h[0], _[0], v4[0], M2), $ = z3(h[1], _[1], v4[1], M2);
      t2.rotation = -Math.atan2($, H2) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (t2.__lastT !== void 0 && t2.__lastT < t2.__t ? (t2.scaleY = R7(P2, I2) * 1.05, M2 === 1 && (I2[0] = P2[0] + (I2[0] - P2[0]) / 2, I2[1] = P2[1] + (I2[1] - P2[1]) / 2)) : t2.__lastT === 1 ? t2.scaleY = 2 * R7(h, I2) : t2.scaleY = this._symbolScale[1]), t2.__lastT = t2.__t, t2.ignore = false, t2.x = I2[0], t2.y = I2[1];
    }, i.prototype.updateLayout = function(t2, h) {
      this.childAt(0).updateLayout(t2, h);
      var v4 = t2.getItemModel(h).getModel("effect");
      this._updateEffectAnimation(t2, v4, h);
    }, i;
  }(mu), zUe = ASr, ISr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4) {
      var _ = f2.call(this) || this;
      return _._createPolyline(t2, h, v4), _;
    }
    return i.prototype._createPolyline = function(t2, h, v4) {
      var _ = t2.getItemLayout(h), M2 = new aC({ shape: { points: _ } });
      this.add(M2), this._updateCommonStl(t2, h, v4);
    }, i.prototype.updateData = function(t2, h, v4) {
      var _ = t2.hostModel, M2 = this.childAt(0), I2 = { shape: { points: t2.getItemLayout(h) } };
      jh2(M2, I2, _, h), this._updateCommonStl(t2, h, v4);
    }, i.prototype._updateCommonStl = function(t2, h, v4) {
      var _ = this.childAt(0), M2 = t2.getItemModel(h), I2 = v4 && v4.emphasisLineStyle, P2 = v4 && v4.focus, N3 = v4 && v4.blurScope, z3 = v4 && v4.emphasisDisabled;
      if (!v4 || t2.hasItemOption) {
        var H2 = M2.getModel("emphasis");
        I2 = H2.getModel("lineStyle").getLineStyle(), z3 = H2.get("disabled"), P2 = H2.get("focus"), N3 = H2.get("blurScope");
      }
      _.useStyle(t2.getItemVisual(h, "style")), _.style.fill = null, _.style.strokeNoScale = true;
      var $ = _.ensureState("emphasis");
      $.style = I2, vy(this, P2, N3, z3);
    }, i.prototype.updateLayout = function(t2, h) {
      var v4 = this.childAt(0);
      v4.setShape("points", t2.getItemLayout(h));
    }, i;
  }(mu), jUe = ISr, DSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2._lastFrame = 0, t2._lastFramePercent = 0, t2;
    }
    return i.prototype.createLine = function(t2, h, v4) {
      return new jUe(t2, h, v4);
    }, i.prototype._updateAnimationPoints = function(t2, h) {
      this._points = h;
      for (var v4 = [0], _ = 0, M2 = 1; M2 < h.length; M2++) {
        var I2 = h[M2 - 1], P2 = h[M2];
        _ += R7(I2, P2), v4.push(_);
      }
      if (_ === 0) {
        this._length = 0;
        return;
      }
      for (var M2 = 0; M2 < v4.length; M2++)
        v4[M2] /= _;
      this._offsets = v4, this._length = _;
    }, i.prototype._getLineLength = function() {
      return this._length;
    }, i.prototype._updateSymbolPosition = function(t2) {
      var h = t2.__t, v4 = this._points, _ = this._offsets, M2 = v4.length;
      if (!!_) {
        var I2 = this._lastFrame, P2;
        if (h < this._lastFramePercent) {
          var N3 = Math.min(I2 + 1, M2 - 1);
          for (P2 = N3; P2 >= 0 && !(_[P2] <= h); P2--)
            ;
          P2 = Math.min(P2, M2 - 2);
        } else {
          for (P2 = I2; P2 < M2 && !(_[P2] > h); P2++)
            ;
          P2 = Math.min(P2 - 1, M2 - 2);
        }
        var z3 = (h - _[P2]) / (_[P2 + 1] - _[P2]), H2 = v4[P2], $ = v4[P2 + 1];
        t2.x = H2[0] * (1 - z3) + z3 * $[0], t2.y = H2[1] * (1 - z3) + z3 * $[1];
        var et = $[0] - H2[0], at = $[1] - H2[1];
        t2.rotation = -Math.atan2(at, et) - Math.PI / 2, this._lastFrame = P2, this._lastFramePercent = h, t2.ignore = false;
      }
    }, i;
  }(zUe), ESr = DSr, kSr = function() {
    function f2() {
      this.polyline = false, this.curveness = 0, this.segs = [];
    }
    return f2;
  }(), PSr = function(f2) {
    ii2(i, f2);
    function i(t2) {
      var h = f2.call(this, t2) || this;
      return h._off = 0, h.hoverDataIdx = -1, h;
    }
    return i.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, i.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, i.prototype.getDefaultShape = function() {
      return new kSr();
    }, i.prototype.buildPath = function(t2, h) {
      var v4 = h.segs, _ = h.curveness, M2;
      if (h.polyline)
        for (M2 = this._off; M2 < v4.length; ) {
          var I2 = v4[M2++];
          if (I2 > 0) {
            t2.moveTo(v4[M2++], v4[M2++]);
            for (var P2 = 1; P2 < I2; P2++)
              t2.lineTo(v4[M2++], v4[M2++]);
          }
        }
      else
        for (M2 = this._off; M2 < v4.length; ) {
          var N3 = v4[M2++], z3 = v4[M2++], H2 = v4[M2++], $ = v4[M2++];
          if (t2.moveTo(N3, z3), _ > 0) {
            var et = (N3 + H2) / 2 - (z3 - $) * _, at = (z3 + $) / 2 - (H2 - N3) * _;
            t2.quadraticCurveTo(et, at, H2, $);
          } else
            t2.lineTo(H2, $);
        }
      this.incremental && (this._off = M2, this.notClear = true);
    }, i.prototype.findDataIndex = function(t2, h) {
      var v4 = this.shape, _ = v4.segs, M2 = v4.curveness, I2 = this.style.lineWidth;
      if (v4.polyline)
        for (var P2 = 0, N3 = 0; N3 < _.length; ) {
          var z3 = _[N3++];
          if (z3 > 0)
            for (var H2 = _[N3++], $ = _[N3++], et = 1; et < z3; et++) {
              var at = _[N3++], ht = _[N3++];
              if (L7(H2, $, at, ht, I2, t2, h))
                return P2;
            }
          P2++;
        }
      else
        for (var P2 = 0, N3 = 0; N3 < _.length; ) {
          var H2 = _[N3++], $ = _[N3++], at = _[N3++], ht = _[N3++];
          if (M2 > 0) {
            var bt = (H2 + at) / 2 - ($ - ht) * M2, _t = ($ + ht) / 2 - (at - H2) * M2;
            if (Zze(H2, $, bt, _t, at, ht, I2, t2, h))
              return P2;
          } else if (L7(H2, $, at, ht, I2, t2, h))
            return P2;
          P2++;
        }
      return -1;
    }, i.prototype.contain = function(t2, h) {
      var v4 = this.transformCoordToLocal(t2, h), _ = this.getBoundingRect();
      if (t2 = v4[0], h = v4[1], _.contain(t2, h)) {
        var M2 = this.hoverDataIdx = this.findDataIndex(t2, h);
        return M2 >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, i.prototype.getBoundingRect = function() {
      var t2 = this._rect;
      if (!t2) {
        for (var h = this.shape, v4 = h.segs, _ = 1 / 0, M2 = 1 / 0, I2 = -1 / 0, P2 = -1 / 0, N3 = 0; N3 < v4.length; ) {
          var z3 = v4[N3++], H2 = v4[N3++];
          _ = Math.min(z3, _), I2 = Math.max(z3, I2), M2 = Math.min(H2, M2), P2 = Math.max(H2, P2);
        }
        t2 = this._rect = new Lc2(_, M2, I2, P2);
      }
      return t2;
    }, i;
  }(Uc2), LSr = function() {
    function f2() {
      this.group = new mu();
    }
    return f2.prototype.updateData = function(i) {
      this._clear();
      var t2 = this._create();
      t2.setShape({ segs: i.getLayout("linesPoints") }), this._setCommon(t2, i);
    }, f2.prototype.incrementalPrepareUpdate = function(i) {
      this.group.removeAll(), this._clear();
    }, f2.prototype.incrementalUpdate = function(i, t2) {
      var h = this._newAdded[0], v4 = t2.getLayout("linesPoints"), _ = h && h.shape.segs;
      if (_ && _.length < 2e4) {
        var M2 = _.length, I2 = new Float32Array(M2 + v4.length);
        I2.set(_), I2.set(v4, M2), h.setShape({ segs: I2 });
      } else {
        this._newAdded = [];
        var P2 = this._create();
        P2.incremental = true, P2.setShape({ segs: v4 }), this._setCommon(P2, t2), P2.__startIndex = i.start;
      }
    }, f2.prototype.remove = function() {
      this._clear();
    }, f2.prototype.eachRendered = function(i) {
      this._newAdded[0] && i(this._newAdded[0]);
    }, f2.prototype._create = function() {
      var i = new PSr({ cursor: "default" });
      return this._newAdded.push(i), this.group.add(i), i;
    }, f2.prototype._setCommon = function(i, t2, h) {
      var v4 = t2.hostModel;
      i.setShape({ polyline: v4.get("polyline"), curveness: v4.get(["lineStyle", "curveness"]) }), i.useStyle(v4.getModel("lineStyle").getLineStyle()), i.style.strokeNoScale = true;
      var _ = t2.getVisual("style");
      _ && _.stroke && i.setStyle("stroke", _.stroke), i.setStyle("fill", null);
      var M2 = Du(i);
      M2.seriesIndex = v4.seriesIndex, i.on("mousemove", function(I2) {
        M2.dataIndex = null;
        var P2 = i.hoverDataIdx;
        P2 > 0 && (M2.dataIndex = P2 + i.__startIndex);
      });
    }, f2.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, f2;
  }(), OSr = LSr, RSr = { seriesType: "lines", plan: uet(), reset: function(f2) {
    var i = f2.coordinateSystem;
    if (!!i) {
      var t2 = f2.get("polyline"), h = f2.pipelineContext.large;
      return { progress: function(v4, _) {
        var M2 = [];
        if (h) {
          var I2 = void 0, P2 = v4.end - v4.start;
          if (t2) {
            for (var N3 = 0, z3 = v4.start; z3 < v4.end; z3++)
              N3 += f2.getLineCoordsCount(z3);
            I2 = new Float32Array(P2 + N3 * 2);
          } else
            I2 = new Float32Array(P2 * 4);
          for (var H2 = 0, $ = [], z3 = v4.start; z3 < v4.end; z3++) {
            var et = f2.getLineCoords(z3, M2);
            t2 && (I2[H2++] = et);
            for (var at = 0; at < et; at++)
              $ = i.dataToPoint(M2[at], false, $), I2[H2++] = $[0], I2[H2++] = $[1];
          }
          _.setLayout("linesPoints", I2);
        } else
          for (var z3 = v4.start; z3 < v4.end; z3++) {
            var ht = _.getItemModel(z3), et = f2.getLineCoords(z3, M2), bt = [];
            if (t2)
              for (var _t = 0; _t < et; _t++)
                bt.push(i.dataToPoint(M2[_t]));
            else {
              bt[0] = i.dataToPoint(M2[0]), bt[1] = i.dataToPoint(M2[1]);
              var Et = ht.get(["lineStyle", "curveness"]);
              +Et && (bt[2] = [(bt[0][0] + bt[1][0]) / 2 - (bt[0][1] - bt[1][1]) * Et, (bt[0][1] + bt[1][1]) / 2 - (bt[1][0] - bt[0][0]) * Et]);
            }
            _.setItemLayout(z3, bt);
          }
      } };
    }
  } }, WUe = RSr, NSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this._updateLineDraw(_, t2), I2 = t2.get("zlevel"), P2 = t2.get(["effect", "trailLength"]), N3 = v4.getZr(), z3 = N3.painter.getType() === "svg";
      z3 || N3.painter.getLayer(I2).clear(true), this._lastZlevel != null && !z3 && N3.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(t2) && P2 > 0 && (z3 || N3.configLayer(I2, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(P2 / 10 + 0.9, 1), 0) })), M2.updateData(_);
      var H2 = t2.get("clip", true) && Fkt(t2.coordinateSystem, false, t2);
      H2 ? this.group.setClipPath(H2) : this.group.removeClipPath(), this._lastZlevel = I2, this._finished = true;
    }, i.prototype.incrementalPrepareRender = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this._updateLineDraw(_, t2);
      M2.incrementalPrepareUpdate(_), this._clearLayer(v4), this._finished = false;
    }, i.prototype.incrementalRender = function(t2, h, v4) {
      this._lineDraw.incrementalUpdate(t2, h.getData()), this._finished = t2.end === h.getData().count();
    }, i.prototype.eachRendered = function(t2) {
      this._lineDraw && this._lineDraw.eachRendered(t2);
    }, i.prototype.updateTransform = function(t2, h, v4) {
      var _ = t2.getData(), M2 = t2.pipelineContext;
      if (!this._finished || M2.large || M2.progressiveRender)
        return { update: true };
      var I2 = WUe.reset(t2, h, v4);
      I2.progress && I2.progress({ start: 0, end: _.count(), count: _.count() }, _), this._lineDraw.updateLayout(), this._clearLayer(v4);
    }, i.prototype._updateLineDraw = function(t2, h) {
      var v4 = this._lineDraw, _ = this._showEffect(h), M2 = !!h.get("polyline"), I2 = h.pipelineContext, P2 = I2.large;
      return (!v4 || _ !== this._hasEffet || M2 !== this._isPolyline || P2 !== this._isLargeDraw) && (v4 && v4.remove(), v4 = this._lineDraw = P2 ? new OSr() : new zne(M2 ? _ ? ESr : jUe : _ ? zUe : Bne), this._hasEffet = _, this._isPolyline = M2, this._isLargeDraw = P2), this.group.add(v4.group), v4;
    }, i.prototype._showEffect = function(t2) {
      return !!t2.get(["effect", "show"]);
    }, i.prototype._clearLayer = function(t2) {
      var h = t2.getZr(), v4 = h.painter.getType() === "svg";
      !v4 && this._lastZlevel != null && h.painter.getLayer(this._lastZlevel).clear(true);
    }, i.prototype.remove = function(t2, h) {
      this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(h);
    }, i.prototype.dispose = function(t2, h) {
      this.remove(t2, h);
    }, i.type = "lines", i;
  }(Hg2), FSr = NSr, VSr = typeof Uint32Array == "undefined" ? Array : Uint32Array, BSr = typeof Float64Array == "undefined" ? Array : Float64Array;
  function a7e(f2) {
    var i = f2.data;
    i && i[0] && i[0][0] && i[0][0].coord && (f2.data = Xa2(i, function(t2) {
      var h = [t2[0].coord, t2[1].coord], v4 = { coords: h };
      return t2[0].name && (v4.fromName = t2[0].name), t2[1].name && (v4.toName = t2[1].name), _ee([v4, t2[0], t2[1]]);
    }));
  }
  var zSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.visualStyleAccessPath = "lineStyle", t2.visualDrawType = "stroke", t2;
    }
    return i.prototype.init = function(t2) {
      t2.data = t2.data || [], a7e(t2);
      var h = this._processFlatCoordsArray(t2.data);
      this._flatCoords = h.flatCoords, this._flatCoordsOffset = h.flatCoordsOffset, h.flatCoords && (t2.data = new Float32Array(h.count)), f2.prototype.init.apply(this, arguments);
    }, i.prototype.mergeOption = function(t2) {
      if (a7e(t2), t2.data) {
        var h = this._processFlatCoordsArray(t2.data);
        this._flatCoords = h.flatCoords, this._flatCoordsOffset = h.flatCoordsOffset, h.flatCoords && (t2.data = new Float32Array(h.count));
      }
      f2.prototype.mergeOption.apply(this, arguments);
    }, i.prototype.appendData = function(t2) {
      var h = this._processFlatCoordsArray(t2.data);
      h.flatCoords && (this._flatCoords ? (this._flatCoords = pJt(this._flatCoords, h.flatCoords), this._flatCoordsOffset = pJt(this._flatCoordsOffset, h.flatCoordsOffset)) : (this._flatCoords = h.flatCoords, this._flatCoordsOffset = h.flatCoordsOffset), t2.data = new Float32Array(h.count)), this.getRawData().appendData(t2.data);
    }, i.prototype._getCoordsFromItemModel = function(t2) {
      var h = this.getData().getItemModel(t2), v4 = h.option instanceof Array ? h.option : h.getShallow("coords");
      return v4;
    }, i.prototype.getLineCoordsCount = function(t2) {
      return this._flatCoordsOffset ? this._flatCoordsOffset[t2 * 2 + 1] : this._getCoordsFromItemModel(t2).length;
    }, i.prototype.getLineCoords = function(t2, h) {
      if (this._flatCoordsOffset) {
        for (var v4 = this._flatCoordsOffset[t2 * 2], _ = this._flatCoordsOffset[t2 * 2 + 1], M2 = 0; M2 < _; M2++)
          h[M2] = h[M2] || [], h[M2][0] = this._flatCoords[v4 + M2 * 2], h[M2][1] = this._flatCoords[v4 + M2 * 2 + 1];
        return _;
      } else {
        for (var I2 = this._getCoordsFromItemModel(t2), M2 = 0; M2 < I2.length; M2++)
          h[M2] = h[M2] || [], h[M2][0] = I2[M2][0], h[M2][1] = I2[M2][1];
        return I2.length;
      }
    }, i.prototype._processFlatCoordsArray = function(t2) {
      var h = 0;
      if (this._flatCoords && (h = this._flatCoords.length), vp(t2[0])) {
        for (var v4 = t2.length, _ = new VSr(v4), M2 = new BSr(v4), I2 = 0, P2 = 0, N3 = 0, z3 = 0; z3 < v4; ) {
          N3++;
          var H2 = t2[z3++];
          _[P2++] = I2 + h, _[P2++] = H2;
          for (var $ = 0; $ < H2; $++) {
            var et = t2[z3++], at = t2[z3++];
            M2[I2++] = et, M2[I2++] = at;
          }
        }
        return { flatCoordsOffset: new Uint32Array(_.buffer, 0, P2), flatCoords: M2, count: N3 };
      }
      return { flatCoordsOffset: null, flatCoords: null, count: t2.length };
    }, i.prototype.getInitialData = function(t2, h) {
      var v4 = new B2(["value"], this);
      return v4.hasItemOption = false, v4.initData(t2.data, [], function(_, M2, I2, P2) {
        if (_ instanceof Array)
          return NaN;
        v4.hasItemOption = true;
        var N3 = _.value;
        if (N3 != null)
          return N3 instanceof Array ? N3[P2] : N3;
      }), v4;
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      var _ = this.getData(), M2 = _.getItemModel(t2), I2 = M2.get("name");
      if (I2)
        return I2;
      var P2 = M2.get("fromName"), N3 = M2.get("toName"), z3 = [];
      return P2 != null && z3.push(P2), N3 != null && z3.push(N3), pb2("nameValue", { name: z3.join(" > ") });
    }, i.prototype.preventIncremental = function() {
      return !!this.get(["effect", "show"]);
    }, i.prototype.getProgressive = function() {
      var t2 = this.option.progressive;
      return t2 == null ? this.option.large ? 1e4 : this.get("progressive") : t2;
    }, i.prototype.getProgressiveThreshold = function() {
      var t2 = this.option.progressiveThreshold;
      return t2 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : t2;
    }, i.prototype.getZLevelKey = function() {
      var t2 = this.getModel("effect"), h = t2.get("trailLength");
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : t2.get("show") && h > 0 ? h + "" : "";
    }, i.type = "series.lines", i.dependencies = ["grid", "polar", "geo", "calendar"], i.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, i;
  }(Jv), jSr = zSr;
  function wDt(f2) {
    return f2 instanceof Array || (f2 = [f2, f2]), f2;
  }
  var WSr = { seriesType: "lines", reset: function(f2) {
    var i = wDt(f2.get("symbol")), t2 = wDt(f2.get("symbolSize")), h = f2.getData();
    h.setVisual("fromSymbol", i && i[0]), h.setVisual("toSymbol", i && i[1]), h.setVisual("fromSymbolSize", t2 && t2[0]), h.setVisual("toSymbolSize", t2 && t2[1]);
    function v4(_, M2) {
      var I2 = _.getItemModel(M2), P2 = wDt(I2.getShallow("symbol", true)), N3 = wDt(I2.getShallow("symbolSize", true));
      P2[0] && _.setItemVisual(M2, "fromSymbol", P2[0]), P2[1] && _.setItemVisual(M2, "toSymbol", P2[1]), N3[0] && _.setItemVisual(M2, "fromSymbolSize", N3[0]), N3[1] && _.setItemVisual(M2, "toSymbolSize", N3[1]);
    }
    return { dataEach: h.hasItemOption ? v4 : null };
  } }, GSr = WSr;
  function HSr(f2) {
    f2.registerChartView(FSr), f2.registerSeriesModel(jSr), f2.registerLayout(WUe), f2.registerVisual(GSr);
  }
  var USr = 256, qSr = function() {
    function f2() {
      this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
      var i = Q6.createCanvas();
      this.canvas = i;
    }
    return f2.prototype.update = function(i, t2, h, v4, _, M2) {
      var I2 = this._getBrush(), P2 = this._getGradient(_, "inRange"), N3 = this._getGradient(_, "outOfRange"), z3 = this.pointSize + this.blurSize, H2 = this.canvas, $ = H2.getContext("2d"), et = i.length;
      H2.width = t2, H2.height = h;
      for (var at = 0; at < et; ++at) {
        var ht = i[at], bt = ht[0], _t = ht[1], Et = ht[2], zt = v4(Et);
        $.globalAlpha = zt, $.drawImage(I2, bt - z3, _t - z3);
      }
      if (!H2.width || !H2.height)
        return H2;
      for (var Ft = $.getImageData(0, 0, H2.width, H2.height), fe2 = Ft.data, re2 = 0, ye = fe2.length, me2 = this.minOpacity, be2 = this.maxOpacity, Te2 = be2 - me2; re2 < ye; ) {
        var zt = fe2[re2 + 3] / 256, We = Math.floor(zt * (USr - 1)) * 4;
        if (zt > 0) {
          var en = M2(zt) ? P2 : N3;
          zt > 0 && (zt = zt * Te2 + me2), fe2[re2++] = en[We], fe2[re2++] = en[We + 1], fe2[re2++] = en[We + 2], fe2[re2++] = en[We + 3] * zt * 256;
        } else
          re2 += 4;
      }
      return $.putImageData(Ft, 0, 0), H2;
    }, f2.prototype._getBrush = function() {
      var i = this._brushCanvas || (this._brushCanvas = Q6.createCanvas()), t2 = this.pointSize + this.blurSize, h = t2 * 2;
      i.width = h, i.height = h;
      var v4 = i.getContext("2d");
      return v4.clearRect(0, 0, h, h), v4.shadowOffsetX = h, v4.shadowBlur = this.blurSize, v4.shadowColor = "#000", v4.beginPath(), v4.arc(-t2, t2, this.pointSize, 0, Math.PI * 2, true), v4.closePath(), v4.fill(), i;
    }, f2.prototype._getGradient = function(i, t2) {
      for (var h = this._gradientPixels, v4 = h[t2] || (h[t2] = new Uint8ClampedArray(256 * 4)), _ = [0, 0, 0, 0], M2 = 0, I2 = 0; I2 < 256; I2++)
        i[t2](I2 / 255, true, _), v4[M2++] = _[0], v4[M2++] = _[1], v4[M2++] = _[2], v4[M2++] = _[3];
      return v4;
    }, f2;
  }(), ZSr = qSr;
  function $Sr(f2, i, t2) {
    var h = f2[1] - f2[0];
    i = Xa2(i, function(M2) {
      return { interval: [(M2.interval[0] - f2[0]) / h, (M2.interval[1] - f2[0]) / h] };
    });
    var v4 = i.length, _ = 0;
    return function(M2) {
      var I2;
      for (I2 = _; I2 < v4; I2++) {
        var P2 = i[I2].interval;
        if (P2[0] <= M2 && M2 <= P2[1]) {
          _ = I2;
          break;
        }
      }
      if (I2 === v4)
        for (I2 = _ - 1; I2 >= 0; I2--) {
          var P2 = i[I2].interval;
          if (P2[0] <= M2 && M2 <= P2[1]) {
            _ = I2;
            break;
          }
        }
      return I2 >= 0 && I2 < v4 && t2[I2];
    };
  }
  function YSr(f2, i) {
    var t2 = f2[1] - f2[0];
    return i = [(i[0] - f2[0]) / t2, (i[1] - f2[0]) / t2], function(h) {
      return h >= i[0] && h <= i[1];
    };
  }
  function o7e(f2) {
    var i = f2.dimensions;
    return i[0] === "lng" && i[1] === "lat";
  }
  var KSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _;
      h.eachComponent("visualMap", function(I2) {
        I2.eachTargetSeries(function(P2) {
          P2 === t2 && (_ = I2);
        });
      }), this._progressiveEls = null, this.group.removeAll();
      var M2 = t2.coordinateSystem;
      M2.type === "cartesian2d" || M2.type === "calendar" ? this._renderOnCartesianAndCalendar(t2, v4, 0, t2.getData().count()) : o7e(M2) && this._renderOnGeo(M2, t2, _, v4);
    }, i.prototype.incrementalPrepareRender = function(t2, h, v4) {
      this.group.removeAll();
    }, i.prototype.incrementalRender = function(t2, h, v4, _) {
      var M2 = h.coordinateSystem;
      M2 && (o7e(M2) ? this.render(h, v4, _) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(h, _, t2.start, t2.end, true)));
    }, i.prototype.eachRendered = function(t2) {
      oV(this._progressiveEls || this.group, t2);
    }, i.prototype._renderOnCartesianAndCalendar = function(t2, h, v4, _, M2) {
      var I2 = t2.coordinateSystem, P2, N3, z3, H2;
      if (Y6(I2, "cartesian2d")) {
        var $ = I2.getAxis("x"), et = I2.getAxis("y");
        P2 = $.getBandWidth(), N3 = et.getBandWidth(), z3 = $.scale.getExtent(), H2 = et.scale.getExtent();
      }
      for (var at = this.group, ht = t2.getData(), bt = t2.getModel(["emphasis", "itemStyle"]).getItemStyle(), _t = t2.getModel(["blur", "itemStyle"]).getItemStyle(), Et = t2.getModel(["select", "itemStyle"]).getItemStyle(), zt = t2.get(["itemStyle", "borderRadius"]), Ft = b_(t2), fe2 = t2.getModel("emphasis"), re2 = fe2.get("focus"), ye = fe2.get("blurScope"), me2 = fe2.get("disabled"), be2 = Y6(I2, "cartesian2d") ? [ht.mapDimension("x"), ht.mapDimension("y"), ht.mapDimension("value")] : [ht.mapDimension("time"), ht.mapDimension("value")], Te2 = v4; Te2 < _; Te2++) {
        var We = void 0, en = ht.getItemVisual(Te2, "style");
        if (Y6(I2, "cartesian2d")) {
          var Ue2 = ht.get(be2[0], Te2), Mn = ht.get(be2[1], Te2);
          if (isNaN(ht.get(be2[2], Te2)) || Ue2 < z3[0] || Ue2 > z3[1] || Mn < H2[0] || Mn > H2[1])
            continue;
          var Vn = I2.dataToPoint([Ue2, Mn]);
          We = new Sh2({ shape: { x: Math.floor(Math.round(Vn[0]) - P2 / 2), y: Math.floor(Math.round(Vn[1]) - N3 / 2), width: Math.ceil(P2), height: Math.ceil(N3) }, style: en });
        } else {
          if (isNaN(ht.get(be2[1], Te2)))
            continue;
          We = new Sh2({ z2: 1, shape: I2.dataToRect([ht.get(be2[0], Te2)]).contentShape, style: en });
        }
        if (ht.hasItemOption) {
          var xn = ht.getItemModel(Te2), Zr = xn.getModel("emphasis");
          bt = Zr.getModel("itemStyle").getItemStyle(), _t = xn.getModel(["blur", "itemStyle"]).getItemStyle(), Et = xn.getModel(["select", "itemStyle"]).getItemStyle(), zt = xn.get(["itemStyle", "borderRadius"]), re2 = Zr.get("focus"), ye = Zr.get("blurScope"), me2 = Zr.get("disabled"), Ft = b_(xn);
        }
        We.shape.r = zt;
        var nr = t2.getRawValue(Te2), pr = "-";
        nr && nr[2] != null && (pr = nr[2] + ""), SS(We, Ft, { labelFetcher: t2, labelDataIndex: Te2, defaultOpacity: en.opacity, defaultText: pr }), We.ensureState("emphasis").style = bt, We.ensureState("blur").style = _t, We.ensureState("select").style = Et, vy(We, re2, ye, me2), We.incremental = M2, M2 && (We.states.emphasis.hoverLayer = true), at.add(We), ht.setItemGraphicEl(Te2, We), this._progressiveEls && this._progressiveEls.push(We);
      }
    }, i.prototype._renderOnGeo = function(t2, h, v4, _) {
      var M2 = v4.targetVisuals.inRange, I2 = v4.targetVisuals.outOfRange, P2 = h.getData(), N3 = this._hmLayer || this._hmLayer || new ZSr();
      N3.blurSize = h.get("blurSize"), N3.pointSize = h.get("pointSize"), N3.minOpacity = h.get("minOpacity"), N3.maxOpacity = h.get("maxOpacity");
      var z3 = t2.getViewRect().clone(), H2 = t2.getRoamTransform();
      z3.applyTransform(H2);
      var $ = Math.max(z3.x, 0), et = Math.max(z3.y, 0), at = Math.min(z3.width + z3.x, _.getWidth()), ht = Math.min(z3.height + z3.y, _.getHeight()), bt = at - $, _t = ht - et, Et = [P2.mapDimension("lng"), P2.mapDimension("lat"), P2.mapDimension("value")], zt = P2.mapArray(Et, function(ye, me2, be2) {
        var Te2 = t2.dataToPoint([ye, me2]);
        return Te2[0] -= $, Te2[1] -= et, Te2.push(be2), Te2;
      }), Ft = v4.getExtent(), fe2 = v4.type === "visualMap.continuous" ? YSr(Ft, v4.option.range) : $Sr(Ft, v4.getPieceList(), v4.option.selected);
      N3.update(zt, bt, _t, M2.color.getNormalizer(), { inRange: M2.color.getColorMapper(), outOfRange: I2.color.getColorMapper() }, fe2);
      var re2 = new Ux({ style: { width: bt, height: _t, x: $, y: et, image: N3.canvas }, silent: true });
      this.group.add(re2);
    }, i.type = "heatmap", i;
  }(Hg2), XSr = KSr, QSr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      return aN(null, this, { generateCoord: "value" });
    }, i.prototype.preventIncremental = function() {
      var t2 = Pgt.get(this.get("coordinateSystem"));
      if (t2 && t2.dimensions)
        return t2.dimensions[0] === "lng" && t2.dimensions[1] === "lat";
    }, i.type = "series.heatmap", i.dependencies = ["grid", "geo", "calendar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, i;
  }(Jv), JSr = QSr;
  function t2r(f2) {
    f2.registerChartView(XSr), f2.registerSeriesModel(JSr);
  }
  var e2r = ["itemStyle", "borderWidth"], s7e = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], AQt = new UL(), n2r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = this.group, M2 = t2.getData(), I2 = this._data, P2 = t2.coordinateSystem, N3 = P2.getBaseAxis(), z3 = N3.isHorizontal(), H2 = P2.master.getRect(), $ = { ecSize: { width: v4.getWidth(), height: v4.getHeight() }, seriesModel: t2, coordSys: P2, coordSysExtent: [[H2.x, H2.x + H2.width], [H2.y, H2.y + H2.height]], isHorizontal: z3, valueDim: s7e[+z3], categoryDim: s7e[1 - +z3] };
      return M2.diff(I2).add(function(et) {
        if (!!M2.hasValue(et)) {
          var at = u7e(M2, et), ht = l7e(M2, et, at, $), bt = c7e(M2, $, ht);
          M2.setItemGraphicEl(et, bt), _.add(bt), h7e(bt, $, ht);
        }
      }).update(function(et, at) {
        var ht = I2.getItemGraphicEl(at);
        if (!M2.hasValue(et)) {
          _.remove(ht);
          return;
        }
        var bt = u7e(M2, et), _t = l7e(M2, et, bt, $), Et = $Ue(M2, _t);
        ht && Et !== ht.__pictorialShapeStr && (_.remove(ht), M2.setItemGraphicEl(et, null), ht = null), ht ? u2r(ht, $, _t) : ht = c7e(M2, $, _t, true), M2.setItemGraphicEl(et, ht), ht.__pictorialSymbolMeta = _t, _.add(ht), h7e(ht, $, _t);
      }).remove(function(et) {
        var at = I2.getItemGraphicEl(et);
        at && f7e(I2, et, at.__pictorialSymbolMeta.animationModel, at);
      }).execute(), this._data = M2, this.group;
    }, i.prototype.remove = function(t2, h) {
      var v4 = this.group, _ = this._data;
      t2.get("animation") ? _ && _.eachItemGraphicEl(function(M2) {
        f7e(_, Du(M2).dataIndex, t2, M2);
      }) : v4.removeAll();
    }, i.type = "pictorialBar", i;
  }(Hg2);
  function l7e(f2, i, t2, h) {
    var v4 = f2.getItemLayout(i), _ = t2.get("symbolRepeat"), M2 = t2.get("symbolClip"), I2 = t2.get("symbolPosition") || "start", P2 = t2.get("symbolRotate"), N3 = (P2 || 0) * Math.PI / 180 || 0, z3 = t2.get("symbolPatternSize") || 2, H2 = t2.isAnimationEnabled(), $ = { dataIndex: i, layout: v4, itemModel: t2, symbolType: f2.getItemVisual(i, "symbol") || "circle", style: f2.getItemVisual(i, "style"), symbolClip: M2, symbolRepeat: _, symbolRepeatDirection: t2.get("symbolRepeatDirection"), symbolPatternSize: z3, rotation: N3, animationModel: H2 ? t2 : null, hoverScale: H2 && t2.get(["emphasis", "scale"]), z2: t2.getShallow("z", true) || 0 };
    r2r(t2, _, v4, h, $), i2r(f2, i, v4, _, M2, $.boundingLength, $.pxSign, z3, h, $), a2r(t2, $.symbolScale, N3, h, $);
    var et = $.symbolSize, at = fet(t2.get("symbolOffset"), et);
    return o2r(t2, et, v4, _, M2, at, I2, $.valueLineWidth, $.boundingLength, $.repeatCutLength, h, $), $;
  }
  function r2r(f2, i, t2, h, v4) {
    var _ = h.valueDim, M2 = f2.get("symbolBoundingData"), I2 = h.coordSys.getOtherAxis(h.coordSys.getBaseAxis()), P2 = I2.toGlobalCoord(I2.dataToCoord(0)), N3 = 1 - +(t2[_.wh] <= 0), z3;
    if (Za2(M2)) {
      var H2 = [IQt(I2, M2[0]) - P2, IQt(I2, M2[1]) - P2];
      H2[1] < H2[0] && H2.reverse(), z3 = H2[N3];
    } else
      M2 != null ? z3 = IQt(I2, M2) - P2 : i ? z3 = h.coordSysExtent[_.index][N3] - P2 : z3 = t2[_.wh];
    v4.boundingLength = z3, i && (v4.repeatCutLength = t2[_.wh]), v4.pxSign = z3 > 0 ? 1 : -1;
  }
  function IQt(f2, i) {
    return f2.toGlobalCoord(f2.dataToCoord(f2.scale.parse(i)));
  }
  function i2r(f2, i, t2, h, v4, _, M2, I2, P2, N3) {
    var z3 = P2.valueDim, H2 = P2.categoryDim, $ = Math.abs(t2[H2.wh]), et = f2.getItemVisual(i, "symbolSize"), at;
    Za2(et) ? at = et.slice() : et == null ? at = ["100%", "100%"] : at = [et, et], at[H2.index] = cs(at[H2.index], $), at[z3.index] = cs(at[z3.index], h ? $ : Math.abs(_)), N3.symbolSize = at;
    var ht = N3.symbolScale = [at[0] / I2, at[1] / I2];
    ht[z3.index] *= (P2.isHorizontal ? -1 : 1) * M2;
  }
  function a2r(f2, i, t2, h, v4) {
    var _ = f2.get(e2r) || 0;
    _ && (AQt.attr({ scaleX: i[0], scaleY: i[1], rotation: t2 }), AQt.updateTransform(), _ /= AQt.getLineScale(), _ *= i[h.valueDim.index]), v4.valueLineWidth = _ || 0;
  }
  function o2r(f2, i, t2, h, v4, _, M2, I2, P2, N3, z3, H2) {
    var $ = z3.categoryDim, et = z3.valueDim, at = H2.pxSign, ht = Math.max(i[et.index] + I2, 0), bt = ht;
    if (h) {
      var _t = Math.abs(P2), Et = y_(f2.get("symbolMargin"), "15%") + "", zt = false;
      Et.lastIndexOf("!") === Et.length - 1 && (zt = true, Et = Et.slice(0, Et.length - 1));
      var Ft = cs(Et, i[et.index]), fe2 = Math.max(ht + Ft * 2, 0), re2 = zt ? 0 : Ft * 2, ye = Lze(h), me2 = ye ? h : p7e((_t + re2) / fe2), be2 = _t - me2 * ht;
      Ft = be2 / 2 / (zt ? me2 : Math.max(me2 - 1, 1)), fe2 = ht + Ft * 2, re2 = zt ? 0 : Ft * 2, !ye && h !== "fixed" && (me2 = N3 ? p7e((Math.abs(N3) + re2) / fe2) : 0), bt = me2 * fe2 - re2, H2.repeatTimes = me2, H2.symbolMargin = Ft;
    }
    var Te2 = at * (bt / 2), We = H2.pathPosition = [];
    We[$.index] = t2[$.wh] / 2, We[et.index] = M2 === "start" ? Te2 : M2 === "end" ? P2 - Te2 : P2 / 2, _ && (We[0] += _[0], We[1] += _[1]);
    var en = H2.bundlePosition = [];
    en[$.index] = t2[$.xy], en[et.index] = t2[et.xy];
    var Ue2 = H2.barRectShape = ba2({}, t2);
    Ue2[et.wh] = at * Math.max(Math.abs(t2[et.wh]), Math.abs(We[et.index] + Te2)), Ue2[$.wh] = t2[$.wh];
    var Mn = H2.clipShape = {};
    Mn[$.xy] = -t2[$.xy], Mn[$.wh] = z3.ecSize[$.wh], Mn[et.xy] = 0, Mn[et.wh] = t2[et.wh];
  }
  function GUe(f2) {
    var i = f2.symbolPatternSize, t2 = wm(f2.symbolType, -i / 2, -i / 2, i, i);
    return t2.attr({ culling: true }), t2.type !== "image" && t2.setStyle({ strokeNoScale: true }), t2;
  }
  function HUe(f2, i, t2, h) {
    var v4 = f2.__pictorialBundle, _ = t2.symbolSize, M2 = t2.valueLineWidth, I2 = t2.pathPosition, P2 = i.valueDim, N3 = t2.repeatTimes || 0, z3 = 0, H2 = _[i.valueDim.index] + M2 + t2.symbolMargin * 2;
    for ($ne(f2, function(ht) {
      ht.__pictorialAnimationIndex = z3, ht.__pictorialRepeatTimes = N3, z3 < N3 ? Vtt(ht, null, at(z3), t2, h) : Vtt(ht, null, { scaleX: 0, scaleY: 0 }, t2, h, function() {
        v4.remove(ht);
      }), z3++;
    }); z3 < N3; z3++) {
      var $ = GUe(t2);
      $.__pictorialAnimationIndex = z3, $.__pictorialRepeatTimes = N3, v4.add($);
      var et = at(z3);
      Vtt($, { x: et.x, y: et.y, scaleX: 0, scaleY: 0 }, { scaleX: et.scaleX, scaleY: et.scaleY, rotation: et.rotation }, t2, h);
    }
    function at(ht) {
      var bt = I2.slice(), _t = t2.pxSign, Et = ht;
      return (t2.symbolRepeatDirection === "start" ? _t > 0 : _t < 0) && (Et = N3 - 1 - ht), bt[P2.index] = H2 * (Et - N3 / 2 + 0.5) + I2[P2.index], { x: bt[0], y: bt[1], scaleX: t2.symbolScale[0], scaleY: t2.symbolScale[1], rotation: t2.rotation };
    }
  }
  function UUe(f2, i, t2, h) {
    var v4 = f2.__pictorialBundle, _ = f2.__pictorialMainPath;
    _ ? Vtt(_, null, { x: t2.pathPosition[0], y: t2.pathPosition[1], scaleX: t2.symbolScale[0], scaleY: t2.symbolScale[1], rotation: t2.rotation }, t2, h) : (_ = f2.__pictorialMainPath = GUe(t2), v4.add(_), Vtt(_, { x: t2.pathPosition[0], y: t2.pathPosition[1], scaleX: 0, scaleY: 0, rotation: t2.rotation }, { scaleX: t2.symbolScale[0], scaleY: t2.symbolScale[1] }, t2, h));
  }
  function qUe(f2, i, t2) {
    var h = ba2({}, i.barRectShape), v4 = f2.__pictorialBarRect;
    v4 ? Vtt(v4, null, { shape: h }, i, t2) : (v4 = f2.__pictorialBarRect = new Sh2({ z2: 2, shape: h, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), v4.disableMorphing = true, f2.add(v4));
  }
  function ZUe(f2, i, t2, h) {
    if (t2.symbolClip) {
      var v4 = f2.__pictorialClipPath, _ = ba2({}, t2.clipShape), M2 = i.valueDim, I2 = t2.animationModel, P2 = t2.dataIndex;
      if (v4)
        jh2(v4, { shape: _ }, I2, P2);
      else {
        _[M2.wh] = 0, v4 = new Sh2({ shape: _ }), f2.__pictorialBundle.setClipPath(v4), f2.__pictorialClipPath = v4;
        var N3 = {};
        N3[M2.wh] = t2.clipShape[M2.wh], kgt[h ? "updateProps" : "initProps"](v4, { shape: N3 }, I2, P2);
      }
    }
  }
  function u7e(f2, i) {
    var t2 = f2.getItemModel(i);
    return t2.getAnimationDelayParams = s2r, t2.isAnimationEnabled = l2r, t2;
  }
  function s2r(f2) {
    return { index: f2.__pictorialAnimationIndex, count: f2.__pictorialRepeatTimes };
  }
  function l2r() {
    return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
  }
  function c7e(f2, i, t2, h) {
    var v4 = new mu(), _ = new mu();
    return v4.add(_), v4.__pictorialBundle = _, _.x = t2.bundlePosition[0], _.y = t2.bundlePosition[1], t2.symbolRepeat ? HUe(v4, i, t2) : UUe(v4, i, t2), qUe(v4, t2, h), ZUe(v4, i, t2, h), v4.__pictorialShapeStr = $Ue(f2, t2), v4.__pictorialSymbolMeta = t2, v4;
  }
  function u2r(f2, i, t2) {
    var h = t2.animationModel, v4 = t2.dataIndex, _ = f2.__pictorialBundle;
    jh2(_, { x: t2.bundlePosition[0], y: t2.bundlePosition[1] }, h, v4), t2.symbolRepeat ? HUe(f2, i, t2, true) : UUe(f2, i, t2, true), qUe(f2, t2, true), ZUe(f2, i, t2, true);
  }
  function f7e(f2, i, t2, h) {
    var v4 = h.__pictorialBarRect;
    v4 && v4.removeTextContent();
    var _ = [];
    $ne(h, function(M2) {
      _.push(M2);
    }), h.__pictorialMainPath && _.push(h.__pictorialMainPath), h.__pictorialClipPath && (t2 = null), Qe2(_, function(M2) {
      Q7(M2, { scaleX: 0, scaleY: 0 }, t2, i, function() {
        h.parent && h.parent.remove(h);
      });
    }), f2.setItemGraphicEl(i, null);
  }
  function $Ue(f2, i) {
    return [f2.getItemVisual(i.dataIndex, "symbol") || "none", !!i.symbolRepeat, !!i.symbolClip].join(":");
  }
  function $ne(f2, i, t2) {
    Qe2(f2.__pictorialBundle.children(), function(h) {
      h !== f2.__pictorialBarRect && i.call(t2, h);
    });
  }
  function Vtt(f2, i, t2, h, v4, _) {
    i && f2.attr(i), h.symbolClip && !v4 ? t2 && f2.attr(t2) : t2 && kgt[v4 ? "updateProps" : "initProps"](f2, t2, h.animationModel, h.dataIndex, _);
  }
  function h7e(f2, i, t2) {
    var h = t2.dataIndex, v4 = t2.itemModel, _ = v4.getModel("emphasis"), M2 = _.getModel("itemStyle").getItemStyle(), I2 = v4.getModel(["blur", "itemStyle"]).getItemStyle(), P2 = v4.getModel(["select", "itemStyle"]).getItemStyle(), N3 = v4.getShallow("cursor"), z3 = _.get("focus"), H2 = _.get("blurScope"), $ = _.get("scale");
    $ne(f2, function(ht) {
      if (ht instanceof Ux) {
        var bt = ht.style;
        ht.useStyle(ba2({ image: bt.image, x: bt.x, y: bt.y, width: bt.width, height: bt.height }, t2.style));
      } else
        ht.useStyle(t2.style);
      var _t = ht.ensureState("emphasis");
      _t.style = M2, $ && (_t.scaleX = ht.scaleX * 1.1, _t.scaleY = ht.scaleY * 1.1), ht.ensureState("blur").style = I2, ht.ensureState("select").style = P2, N3 && (ht.cursor = N3), ht.z2 = t2.z2;
    });
    var et = i.valueDim.posDesc[+(t2.boundingLength > 0)], at = f2.__pictorialBarRect;
    SS(at, b_(v4), { labelFetcher: i.seriesModel, labelDataIndex: h, defaultText: Utt(i.seriesModel.getData(), h), inheritColor: t2.style.fill, defaultOpacity: t2.style.opacity, defaultOutsidePosition: et }), vy(f2, z3, H2, _.get("disabled"));
  }
  function p7e(f2) {
    var i = Math.round(f2);
    return Math.abs(f2 - i) < 1e-4 ? i : Math.ceil(f2);
  }
  var c2r = n2r, f2r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.hasSymbolVisual = true, t2.defaultSymbol = "roundRect", t2;
    }
    return i.prototype.getInitialData = function(t2) {
      return t2.stack = null, f2.prototype.getInitialData.apply(this, arguments);
    }, i.type = "series.pictorialBar", i.dependencies = ["grid"], i.defaultOption = sV(REt.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), i;
  }(REt), h2r = f2r;
  function p2r(f2) {
    f2.registerChartView(c2r), f2.registerSeriesModel(h2r), f2.registerLayout(f2.PRIORITY.VISUAL.LAYOUT, Ou(EGe, "pictorialBar")), f2.registerLayout(f2.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, kGe("pictorialBar"));
  }
  var d2r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._layers = [], t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = t2.getData(), M2 = this, I2 = this.group, P2 = t2.getLayerSeries(), N3 = _.getLayout("layoutInfo"), z3 = N3.rect, H2 = N3.boundaryGap;
      I2.x = 0, I2.y = z3.y + H2[0];
      function $(bt) {
        return bt.name;
      }
      var et = new eN(this._layersSeries || [], P2, $, $), at = [];
      et.add(ks(ht, this, "add")).update(ks(ht, this, "update")).remove(ks(ht, this, "remove")).execute();
      function ht(bt, _t, Et) {
        var zt = M2._layers;
        if (bt === "remove") {
          I2.remove(zt[_t]);
          return;
        }
        for (var Ft = [], fe2 = [], re2, ye = P2[_t].indices, me2 = 0; me2 < ye.length; me2++) {
          var be2 = _.getItemLayout(ye[me2]), Te2 = be2.x, We = be2.y0, en = be2.y;
          Ft.push(Te2, We), fe2.push(Te2, We + en), re2 = _.getItemVisual(ye[me2], "style");
        }
        var Ue2, Mn = _.getItemLayout(ye[0]), Vn = t2.getModel("label"), xn = Vn.get("margin"), Zr = t2.getModel("emphasis");
        if (bt === "add") {
          var nr = at[_t] = new mu();
          Ue2 = new yHe({ shape: { points: Ft, stackedOnPoints: fe2, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), nr.add(Ue2), I2.add(nr), t2.isAnimationEnabled() && Ue2.setClipPath(g2r(Ue2.getBoundingRect(), t2, function() {
            Ue2.removeClipPath();
          }));
        } else {
          var nr = zt[Et];
          Ue2 = nr.childAt(0), I2.add(nr), at[_t] = nr, jh2(Ue2, { shape: { points: Ft, stackedOnPoints: fe2 } }, t2), A5(Ue2);
        }
        SS(Ue2, b_(t2), { labelDataIndex: ye[me2 - 1], defaultText: _.getName(ye[me2 - 1]), inheritColor: re2.fill }, { normal: { verticalAlign: "middle" } }), Ue2.setTextConfig({ position: null, local: true });
        var pr = Ue2.getTextContent();
        pr && (pr.x = Mn.x - xn, pr.y = Mn.y0 + Mn.y / 2), Ue2.useStyle(re2), _.setItemGraphicEl(_t, Ue2), Hx(Ue2, t2), vy(Ue2, Zr.get("focus"), Zr.get("blurScope"), Zr.get("disabled"));
      }
      this._layersSeries = P2, this._layers = at;
    }, i.type = "themeRiver", i;
  }(Hg2);
  function g2r(f2, i, t2) {
    var h = new Sh2({ shape: { x: f2.x - 10, y: f2.y - 10, width: 0, height: f2.height + 20 } });
    return Qv(h, { shape: { x: f2.x - 50, width: f2.width + 100, height: f2.height + 20 } }, i, t2), h;
  }
  var v2r = d2r, DQt = 2, y2r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2) {
      f2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Wgt(ks(this.getData, this), ks(this.getRawData, this));
    }, i.prototype.fixData = function(t2) {
      var h = t2.length, v4 = {}, _ = RJt(t2, function($) {
        return v4.hasOwnProperty($[0] + "") || (v4[$[0] + ""] = -1), $[2];
      }), M2 = [];
      _.buckets.each(function($, et) {
        M2.push({ name: et, dataList: $ });
      });
      for (var I2 = M2.length, P2 = 0; P2 < I2; ++P2) {
        for (var N3 = M2[P2].name, z3 = 0; z3 < M2[P2].dataList.length; ++z3) {
          var H2 = M2[P2].dataList[z3][0] + "";
          v4[H2] = P2;
        }
        for (var H2 in v4)
          v4.hasOwnProperty(H2) && v4[H2] !== P2 && (v4[H2] = P2, t2[h] = [H2, 0, N3], h++);
      }
      return t2;
    }, i.prototype.getInitialData = function(t2, h) {
      for (var v4 = this.getReferringComponents("singleAxis", _m).models[0], _ = v4.get("type"), M2 = Ld2(t2.data, function(at) {
        return at[2] !== void 0;
      }), I2 = this.fixData(M2 || []), P2 = [], N3 = this.nameMap = Il(), z3 = 0, H2 = 0; H2 < I2.length; ++H2)
        P2.push(I2[H2][DQt]), N3.get(I2[H2][DQt]) || (N3.set(I2[H2][DQt], z3), z3++);
      var $ = Rgt(I2, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: EEt(_) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, et = new B2($, this);
      return et.initData(I2), et;
    }, i.prototype.getLayerSeries = function() {
      for (var t2 = this.getData(), h = t2.count(), v4 = [], _ = 0; _ < h; ++_)
        v4[_] = _;
      var M2 = t2.mapDimension("single"), I2 = RJt(v4, function(N3) {
        return t2.get("name", N3);
      }), P2 = [];
      return I2.buckets.each(function(N3, z3) {
        N3.sort(function(H2, $) {
          return t2.get(M2, H2) - t2.get(M2, $);
        }), P2.push({ name: z3, indices: N3 });
      }), P2;
    }, i.prototype.getAxisTooltipData = function(t2, h, v4) {
      Za2(t2) || (t2 = t2 ? [t2] : []);
      for (var _ = this.getData(), M2 = this.getLayerSeries(), I2 = [], P2 = M2.length, N3, z3 = 0; z3 < P2; ++z3) {
        for (var H2 = Number.MAX_VALUE, $ = -1, et = M2[z3].indices.length, at = 0; at < et; ++at) {
          var ht = _.get(t2[0], M2[z3].indices[at]), bt = Math.abs(ht - h);
          bt <= H2 && (N3 = ht, H2 = bt, $ = M2[z3].indices[at]);
        }
        I2.push($);
      }
      return { dataIndices: I2, nestestValue: N3 };
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      var _ = this.getData(), M2 = _.getName(t2), I2 = _.get(_.mapDimension("value"), t2);
      return pb2("nameValue", { name: M2, value: I2 });
    }, i.type = "series.themeRiver", i.dependencies = ["singleAxis"], i.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, i;
  }(Jv), m2r = y2r;
  function b2r(f2, i) {
    f2.eachSeriesByType("themeRiver", function(t2) {
      var h = t2.getData(), v4 = t2.coordinateSystem, _ = {}, M2 = v4.getRect();
      _.rect = M2;
      var I2 = t2.get("boundaryGap"), P2 = v4.getAxis();
      if (_.boundaryGap = I2, P2.orient === "horizontal") {
        I2[0] = cs(I2[0], M2.height), I2[1] = cs(I2[1], M2.height);
        var N3 = M2.height - I2[0] - I2[1];
        d7e(h, t2, N3);
      } else {
        I2[0] = cs(I2[0], M2.width), I2[1] = cs(I2[1], M2.width);
        var z3 = M2.width - I2[0] - I2[1];
        d7e(h, t2, z3);
      }
      h.setLayout("layoutInfo", _);
    });
  }
  function d7e(f2, i, t2) {
    if (!!f2.count())
      for (var h = i.coordinateSystem, v4 = i.getLayerSeries(), _ = f2.mapDimension("single"), M2 = f2.mapDimension("value"), I2 = Xa2(v4, function(bt) {
        return Xa2(bt.indices, function(_t) {
          var Et = h.dataToPoint(f2.get(_, _t));
          return Et[1] = f2.get(M2, _t), Et;
        });
      }), P2 = _2r(I2), N3 = P2.y0, z3 = t2 / P2.max, H2 = v4.length, $ = v4[0].indices.length, et, at = 0; at < $; ++at) {
        et = N3[at] * z3, f2.setItemLayout(v4[0].indices[at], { layerIndex: 0, x: I2[0][at][0], y0: et, y: I2[0][at][1] * z3 });
        for (var ht = 1; ht < H2; ++ht)
          et += I2[ht - 1][at][1] * z3, f2.setItemLayout(v4[ht].indices[at], { layerIndex: ht, x: I2[ht][at][0], y0: et, y: I2[ht][at][1] * z3 });
      }
  }
  function _2r(f2) {
    for (var i = f2.length, t2 = f2[0].length, h = [], v4 = [], _ = 0, M2 = 0; M2 < t2; ++M2) {
      for (var I2 = 0, P2 = 0; P2 < i; ++P2)
        I2 += f2[P2][M2][1];
      I2 > _ && (_ = I2), h.push(I2);
    }
    for (var N3 = 0; N3 < t2; ++N3)
      v4[N3] = (_ - h[N3]) / 2;
    _ = 0;
    for (var z3 = 0; z3 < t2; ++z3) {
      var H2 = h[z3] + v4[z3];
      H2 > _ && (_ = H2);
    }
    return { y0: v4, max: _ };
  }
  function x2r(f2) {
    f2.registerChartView(v2r), f2.registerSeriesModel(m2r), f2.registerLayout(b2r), f2.registerProcessor(jgt("themeRiver"));
  }
  var w2r = 2, S2r = 4, M2r = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _) {
      var M2 = f2.call(this) || this;
      M2.z2 = w2r, M2.textConfig = { inside: true }, Du(M2).seriesIndex = h.seriesIndex;
      var I2 = new op({ z2: S2r, silent: t2.getModel().get(["label", "silent"]) });
      return M2.setTextContent(I2), M2.updateData(true, t2, h, v4, _), M2;
    }
    return i.prototype.updateData = function(t2, h, v4, _, M2) {
      this.node = h, h.piece = this, v4 = v4 || this._seriesModel, _ = _ || this._ecModel;
      var I2 = this;
      Du(I2).dataIndex = h.dataIndex;
      var P2 = h.getModel(), N3 = P2.getModel("emphasis"), z3 = h.getLayout(), H2 = ba2({}, z3);
      H2.label = null;
      var $ = h.getVisual("style");
      $.lineJoin = "bevel";
      var et = h.getVisual("decal");
      et && ($.decal = lgt(et, M2));
      var at = Ett(P2.getModel("itemStyle"), H2, true);
      ba2(H2, at), Qe2(j2, function(Et) {
        var zt = I2.ensureState(Et), Ft = P2.getModel([Et, "itemStyle"]);
        zt.style = Ft.getItemStyle();
        var fe2 = Ett(Ft, H2);
        fe2 && (zt.shape = fe2);
      }), t2 ? (I2.setShape(H2), I2.shape.r = z3.r0, jh2(I2, { shape: { r: z3.r } }, v4, h.dataIndex)) : (jh2(I2, { shape: H2 }, v4), A5(I2)), I2.useStyle($), this._updateLabel(v4);
      var ht = P2.getShallow("cursor");
      ht && I2.attr("cursor", ht), this._seriesModel = v4 || this._seriesModel, this._ecModel = _ || this._ecModel;
      var bt = N3.get("focus"), _t = bt === "ancestor" ? h.getAncestorsIndices() : bt === "descendant" ? h.getDescendantIndices() : bt;
      vy(this, _t, N3.get("blurScope"), N3.get("disabled"));
    }, i.prototype._updateLabel = function(t2) {
      var h = this, v4 = this.node.getModel(), _ = v4.getModel("label"), M2 = this.node.getLayout(), I2 = M2.endAngle - M2.startAngle, P2 = (M2.startAngle + M2.endAngle) / 2, N3 = Math.cos(P2), z3 = Math.sin(P2), H2 = this, $ = H2.getTextContent(), et = this.node.dataIndex, at = _.get("minAngle") / 180 * Math.PI, ht = _.get("show") && !(at != null && Math.abs(I2) < at);
      $.ignore = !ht, Qe2(Qdt, function(_t) {
        var Et = _t === "normal" ? v4.getModel("label") : v4.getModel([_t, "label"]), zt = _t === "normal", Ft = zt ? $ : $.ensureState(_t), fe2 = t2.getFormattedLabel(et, _t);
        zt && (fe2 = fe2 || h.node.name), Ft.style = By(Et, {}, null, _t !== "normal", true), fe2 && (Ft.style.text = fe2);
        var re2 = Et.get("show");
        re2 != null && !zt && (Ft.ignore = !re2);
        var ye = bt(Et, "position"), me2 = zt ? H2 : H2.states[_t], be2 = me2.style.fill;
        me2.textConfig = { outsideFill: Et.get("color") === "inherit" ? be2 : null, inside: ye !== "outside" };
        var Te2, We = bt(Et, "distance") || 0, en = bt(Et, "align");
        ye === "outside" ? (Te2 = M2.r + We, en = P2 > Math.PI / 2 ? "right" : "left") : !en || en === "center" ? (I2 === 2 * Math.PI && M2.r0 === 0 ? Te2 = 0 : Te2 = (M2.r + M2.r0) / 2, en = "center") : en === "left" ? (Te2 = M2.r0 + We, P2 > Math.PI / 2 && (en = "right")) : en === "right" && (Te2 = M2.r - We, P2 > Math.PI / 2 && (en = "left")), Ft.style.align = en, Ft.style.verticalAlign = bt(Et, "verticalAlign") || "middle", Ft.x = Te2 * N3 + M2.cx, Ft.y = Te2 * z3 + M2.cy;
        var Ue2 = bt(Et, "rotate"), Mn = 0;
        Ue2 === "radial" ? (Mn = -P2, Mn < -Math.PI / 2 && (Mn += Math.PI)) : Ue2 === "tangential" ? (Mn = Math.PI / 2 - P2, Mn > Math.PI / 2 ? Mn -= Math.PI : Mn < -Math.PI / 2 && (Mn += Math.PI)) : vp(Ue2) && (Mn = Ue2 * Math.PI / 180), Ft.rotation = Mn;
      });
      function bt(_t, Et) {
        var zt = _t.get(Et);
        return zt == null ? _.get(Et) : zt;
      }
      $.dirtyStyle();
    }, i;
  }(rC), g7e = M2r, Lte = "sunburstRootToNode", v7e = "sunburstHighlight", C2r = "sunburstUnhighlight";
  function T2r(f2) {
    f2.registerAction({ type: Lte, update: "updateView" }, function(i, t2) {
      t2.eachComponent({ mainType: "series", subType: "sunburst", query: i }, h);
      function h(v4, _) {
        var M2 = pgt(i, [Lte], v4);
        if (M2) {
          var I2 = v4.getViewRoot();
          I2 && (i.direction = Rne(I2, M2.node) ? "rollUp" : "drillDown"), v4.resetViewRoot(M2.node);
        }
      }
    }), f2.registerAction({ type: v7e, update: "none" }, function(i, t2, h) {
      i = ba2({}, i), t2.eachComponent({ mainType: "series", subType: "sunburst", query: i }, v4);
      function v4(_) {
        var M2 = pgt(i, [v7e], _);
        M2 && (i.dataIndex = M2.node.dataIndex);
      }
      h.dispatchAction(ba2(i, { type: "highlight" }));
    }), f2.registerAction({ type: C2r, update: "updateView" }, function(i, t2, h) {
      i = ba2({}, i), h.dispatchAction(ba2(i, { type: "downplay" }));
    });
  }
  var A2r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      var M2 = this;
      this.seriesModel = t2, this.api = v4, this.ecModel = h;
      var I2 = t2.getData(), P2 = I2.tree.root, N3 = t2.getViewRoot(), z3 = this.group, H2 = t2.get("renderLabelForZeroData"), $ = [];
      N3.eachNode(function(Et) {
        $.push(Et);
      });
      var et = this._oldChildren || [];
      at($, et), _t(P2, N3), this._initEvents(), this._oldChildren = $;
      function at(Et, zt) {
        if (Et.length === 0 && zt.length === 0)
          return;
        new eN(zt, Et, Ft, Ft).add(fe2).update(fe2).remove(Ou(fe2, null)).execute();
        function Ft(re2) {
          return re2.getId();
        }
        function fe2(re2, ye) {
          var me2 = re2 == null ? null : Et[re2], be2 = ye == null ? null : zt[ye];
          ht(me2, be2);
        }
      }
      function ht(Et, zt) {
        if (!H2 && Et && !Et.getValue() && (Et = null), Et !== P2 && zt !== P2) {
          if (zt && zt.piece)
            Et ? (zt.piece.updateData(false, Et, t2, h, v4), I2.setItemGraphicEl(Et.dataIndex, zt.piece)) : bt(zt);
          else if (Et) {
            var Ft = new g7e(Et, t2, h, v4);
            z3.add(Ft), I2.setItemGraphicEl(Et.dataIndex, Ft);
          }
        }
      }
      function bt(Et) {
        !Et || Et.piece && (z3.remove(Et.piece), Et.piece = null);
      }
      function _t(Et, zt) {
        zt.depth > 0 ? (M2.virtualPiece ? M2.virtualPiece.updateData(false, Et, t2, h, v4) : (M2.virtualPiece = new g7e(Et, t2, h, v4), z3.add(M2.virtualPiece)), zt.piece.off("click"), M2.virtualPiece.on("click", function(Ft) {
          M2._rootToNode(zt.parentNode);
        })) : M2.virtualPiece && (z3.remove(M2.virtualPiece), M2.virtualPiece = null);
      }
    }, i.prototype._initEvents = function() {
      var t2 = this;
      this.group.off("click"), this.group.on("click", function(h) {
        var v4 = false, _ = t2.seriesModel.getViewRoot();
        _.eachNode(function(M2) {
          if (!v4 && M2.piece && M2.piece === h.target) {
            var I2 = M2.getModel().get("nodeClick");
            if (I2 === "rootToNode")
              t2._rootToNode(M2);
            else if (I2 === "link") {
              var P2 = M2.getModel(), N3 = P2.get("link");
              if (N3) {
                var z3 = P2.get("target", true) || "_blank";
                wEt(N3, z3);
              }
            }
            v4 = true;
          }
        });
      });
    }, i.prototype._rootToNode = function(t2) {
      t2 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: Lte, from: this.uid, seriesId: this.seriesModel.id, targetNode: t2 });
    }, i.prototype.containPoint = function(t2, h) {
      var v4 = h.getData(), _ = v4.getItemLayout(0);
      if (_) {
        var M2 = t2[0] - _.cx, I2 = t2[1] - _.cy, P2 = Math.sqrt(M2 * M2 + I2 * I2);
        return P2 <= _.r && P2 >= _.r0;
      }
    }, i.type = "sunburst", i;
  }(Hg2), I2r = A2r, D2r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.ignoreStyleOnData = true, t2;
    }
    return i.prototype.getInitialData = function(t2, h) {
      var v4 = { name: t2.name, children: t2.data };
      YUe(v4);
      var _ = this._levelModels = Xa2(t2.levels || [], function(P2) {
        return new Gg2(P2, this, h);
      }, this), M2 = One.createTree(v4, this, I2);
      function I2(P2) {
        P2.wrapMethod("getItemModel", function(N3, z3) {
          var H2 = M2.getNodeByDataIndex(z3), $ = _[H2.depth];
          return $ && (N3.parentModel = $), N3;
        });
      }
      return M2.data;
    }, i.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, i.prototype.getDataParams = function(t2) {
      var h = f2.prototype.getDataParams.apply(this, arguments), v4 = this.getData().tree.getNodeByDataIndex(t2);
      return h.treePathInfo = zkt(v4, this), h;
    }, i.prototype.getLevelModel = function(t2) {
      return this._levelModels && this._levelModels[t2.depth];
    }, i.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, i.prototype.resetViewRoot = function(t2) {
      t2 ? this._viewRoot = t2 : t2 = this._viewRoot;
      var h = this.getRawData().tree.root;
      (!t2 || t2 !== h && !h.contains(t2)) && (this._viewRoot = h);
    }, i.prototype.enableAriaDecal = function() {
      QHe(this);
    }, i.type = "series.sunburst", i.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, i;
  }(Jv);
  function YUe(f2) {
    var i = 0;
    Qe2(f2.children, function(h) {
      YUe(h);
      var v4 = h.value;
      Za2(v4) && (v4 = v4[0]), i += v4;
    });
    var t2 = f2.value;
    Za2(t2) && (t2 = t2[0]), (t2 == null || isNaN(t2)) && (t2 = i), t2 < 0 && (t2 = 0), Za2(f2.value) ? f2.value[0] = t2 : f2.value = t2;
  }
  var E2r = D2r, y7e = Math.PI / 180;
  function k2r(f2, i, t2) {
    i.eachSeriesByType(f2, function(h) {
      var v4 = h.get("center"), _ = h.get("radius");
      Za2(_) || (_ = [0, _]), Za2(v4) || (v4 = [v4, v4]);
      var M2 = t2.getWidth(), I2 = t2.getHeight(), P2 = Math.min(M2, I2), N3 = cs(v4[0], M2), z3 = cs(v4[1], I2), H2 = cs(_[0], P2 / 2), $ = cs(_[1], P2 / 2), et = -h.get("startAngle") * y7e, at = h.get("minAngle") * y7e, ht = h.getData().tree.root, bt = h.getViewRoot(), _t = bt.depth, Et = h.get("sort");
      Et != null && KUe(bt, Et);
      var zt = 0;
      Qe2(bt.children, function(xn) {
        !isNaN(xn.getValue()) && zt++;
      });
      var Ft = bt.getValue(), fe2 = Math.PI / (Ft || zt) * 2, re2 = bt.depth > 0, ye = bt.height - (re2 ? -1 : 1), me2 = ($ - H2) / (ye || 1), be2 = h.get("clockwise"), Te2 = h.get("stillShowZeroSum"), We = be2 ? 1 : -1, en = function(xn, Zr) {
        if (!!xn) {
          var nr = Zr;
          if (xn !== ht) {
            var pr = xn.getValue(), Nr = Ft === 0 && Te2 ? fe2 : pr * fe2;
            Nr < at && (Nr = at), nr = Zr + We * Nr;
            var ai2 = xn.depth - _t - (re2 ? -1 : 1), gi2 = H2 + me2 * ai2, To = H2 + me2 * (ai2 + 1), us = h.getLevelModel(xn);
            if (us) {
              var ml = us.get("r0", true), ll = us.get("r", true), Rs = us.get("radius", true);
              Rs != null && (ml = Rs[0], ll = Rs[1]), ml != null && (gi2 = cs(ml, P2 / 2)), ll != null && (To = cs(ll, P2 / 2));
            }
            xn.setLayout({ angle: Nr, startAngle: Zr, endAngle: nr, clockwise: be2, cx: N3, cy: z3, r0: gi2, r: To });
          }
          if (xn.children && xn.children.length) {
            var es = 0;
            Qe2(xn.children, function(Ws) {
              es += en(Ws, Zr + es);
            });
          }
          return nr - Zr;
        }
      };
      if (re2) {
        var Ue2 = H2, Mn = H2 + me2, Vn = Math.PI * 2;
        ht.setLayout({ angle: Vn, startAngle: et, endAngle: et + Vn, clockwise: be2, cx: N3, cy: z3, r0: Ue2, r: Mn });
      }
      en(bt, et);
    });
  }
  function KUe(f2, i) {
    var t2 = f2.children || [];
    f2.children = P2r(t2, i), t2.length && Qe2(f2.children, function(h) {
      KUe(h, i);
    });
  }
  function P2r(f2, i) {
    if (Ol(i)) {
      var t2 = Xa2(f2, function(v4, _) {
        var M2 = v4.getValue();
        return { params: { depth: v4.depth, height: v4.height, dataIndex: v4.dataIndex, getValue: function() {
          return M2;
        } }, index: _ };
      });
      return t2.sort(function(v4, _) {
        return i(v4.params, _.params);
      }), Xa2(t2, function(v4) {
        return f2[v4.index];
      });
    } else {
      var h = i === "asc";
      return f2.sort(function(v4, _) {
        var M2 = (v4.getValue() - _.getValue()) * (h ? 1 : -1);
        return M2 === 0 ? (v4.dataIndex - _.dataIndex) * (h ? -1 : 1) : M2;
      });
    }
  }
  function L2r(f2) {
    var i = {};
    function t2(h, v4, _) {
      for (var M2 = h; M2 && M2.depth > 1; )
        M2 = M2.parentNode;
      var I2 = v4.getColorFromPalette(M2.name || M2.dataIndex + "", i);
      return h.depth > 1 && ms(I2) && (I2 = CJt(I2, (h.depth - 1) / (_ - 1) * 0.5)), I2;
    }
    f2.eachSeriesByType("sunburst", function(h) {
      var v4 = h.getData(), _ = v4.tree;
      _.eachNode(function(M2) {
        var I2 = M2.getModel(), P2 = I2.getModel("itemStyle").getItemStyle();
        P2.fill || (P2.fill = t2(M2, h, _.root.height));
        var N3 = v4.ensureUniqueItemVisual(M2.dataIndex, "style");
        ba2(N3, P2);
      });
    });
  }
  function O2r(f2) {
    f2.registerChartView(I2r), f2.registerSeriesModel(E2r), f2.registerLayout(Ou(k2r, "sunburst")), f2.registerProcessor(Ou(jgt, "sunburst")), f2.registerVisual(L2r), T2r(f2);
  }
  var m7e = { color: "fill", borderColor: "stroke" }, R2r = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, K6 = Wh2(), N2r = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.optionUpdated = function() {
      this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
    }, i.prototype.getInitialData = function(t2, h) {
      return aN(null, this);
    }, i.prototype.getDataParams = function(t2, h, v4) {
      var _ = f2.prototype.getDataParams.call(this, t2, h);
      return v4 && (_.info = K6(v4).info), _;
    }, i.type = "series.custom", i.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, i;
  }(Jv), F2r = N2r;
  function V2r(f2, i) {
    return i = i || [0, 0], Xa2(["x", "y"], function(t2, h) {
      var v4 = this.getAxis(t2), _ = i[h], M2 = f2[h] / 2;
      return v4.type === "category" ? v4.getBandWidth() : Math.abs(v4.dataToCoord(_ - M2) - v4.dataToCoord(_ + M2));
    }, this);
  }
  function B2r(f2) {
    var i = f2.master.getRect();
    return { coordSys: { type: "cartesian2d", x: i.x, y: i.y, width: i.width, height: i.height }, api: { coord: function(t2) {
      return f2.dataToPoint(t2);
    }, size: ks(V2r, f2) } };
  }
  function z2r(f2, i) {
    return i = i || [0, 0], Xa2([0, 1], function(t2) {
      var h = i[t2], v4 = f2[t2] / 2, _ = [], M2 = [];
      return _[t2] = h - v4, M2[t2] = h + v4, _[1 - t2] = M2[1 - t2] = i[1 - t2], Math.abs(this.dataToPoint(_)[t2] - this.dataToPoint(M2)[t2]);
    }, this);
  }
  function j2r(f2) {
    var i = f2.getBoundingRect();
    return { coordSys: { type: "geo", x: i.x, y: i.y, width: i.width, height: i.height, zoom: f2.getZoom() }, api: { coord: function(t2) {
      return f2.dataToPoint(t2);
    }, size: ks(z2r, f2) } };
  }
  function W2r(f2, i) {
    var t2 = this.getAxis(), h = i instanceof Array ? i[0] : i, v4 = (f2 instanceof Array ? f2[0] : f2) / 2;
    return t2.type === "category" ? t2.getBandWidth() : Math.abs(t2.dataToCoord(h - v4) - t2.dataToCoord(h + v4));
  }
  function G2r(f2) {
    var i = f2.getRect();
    return { coordSys: { type: "singleAxis", x: i.x, y: i.y, width: i.width, height: i.height }, api: { coord: function(t2) {
      return f2.dataToPoint(t2);
    }, size: ks(W2r, f2) } };
  }
  function H2r(f2, i) {
    return i = i || [0, 0], Xa2(["Radius", "Angle"], function(t2, h) {
      var v4 = "get" + t2 + "Axis", _ = this[v4](), M2 = i[h], I2 = f2[h] / 2, P2 = _.type === "category" ? _.getBandWidth() : Math.abs(_.dataToCoord(M2 - I2) - _.dataToCoord(M2 + I2));
      return t2 === "Angle" && (P2 = P2 * Math.PI / 180), P2;
    }, this);
  }
  function U2r(f2) {
    var i = f2.getRadiusAxis(), t2 = f2.getAngleAxis(), h = i.getExtent();
    return h[0] > h[1] && h.reverse(), { coordSys: { type: "polar", cx: f2.cx, cy: f2.cy, r: h[1], r0: h[0] }, api: { coord: function(v4) {
      var _ = i.dataToRadius(v4[0]), M2 = t2.dataToAngle(v4[1]), I2 = f2.coordToPoint([_, M2]);
      return I2.push(_, M2 * Math.PI / 180), I2;
    }, size: ks(H2r, f2) } };
  }
  function q2r(f2) {
    var i = f2.getRect(), t2 = f2.getRangeInfo();
    return { coordSys: { type: "calendar", x: i.x, y: i.y, width: i.width, height: i.height, cellWidth: f2.getCellWidth(), cellHeight: f2.getCellHeight(), rangeInfo: { start: t2.start, end: t2.end, weeks: t2.weeks, dayCount: t2.allDay } }, api: { coord: function(h, v4) {
      return f2.dataToPoint(h, v4);
    } } };
  }
  function XUe(f2, i, t2, h) {
    return f2 && (f2.legacy || f2.legacy !== false && !t2 && !h && i !== "tspan" && (i === "text" || qs(f2, "text")));
  }
  function QUe(f2, i, t2) {
    var h = f2, v4, _, M2;
    if (i === "text")
      M2 = h;
    else {
      M2 = {}, qs(h, "text") && (M2.text = h.text), qs(h, "rich") && (M2.rich = h.rich), qs(h, "textFill") && (M2.fill = h.textFill), qs(h, "textStroke") && (M2.stroke = h.textStroke), qs(h, "fontFamily") && (M2.fontFamily = h.fontFamily), qs(h, "fontSize") && (M2.fontSize = h.fontSize), qs(h, "fontStyle") && (M2.fontStyle = h.fontStyle), qs(h, "fontWeight") && (M2.fontWeight = h.fontWeight), _ = { type: "text", style: M2, silent: true }, v4 = {};
      var I2 = qs(h, "textPosition");
      t2 ? v4.position = I2 ? h.textPosition : "inside" : I2 && (v4.position = h.textPosition), qs(h, "textPosition") && (v4.position = h.textPosition), qs(h, "textOffset") && (v4.offset = h.textOffset), qs(h, "textRotation") && (v4.rotation = h.textRotation), qs(h, "textDistance") && (v4.distance = h.textDistance);
    }
    return b7e(M2, f2), Qe2(M2.rich, function(P2) {
      b7e(P2, P2);
    }), { textConfig: v4, textContent: _ };
  }
  function b7e(f2, i) {
    !i || (i.font = i.textFont || i.font, qs(i, "textStrokeWidth") && (f2.lineWidth = i.textStrokeWidth), qs(i, "textAlign") && (f2.align = i.textAlign), qs(i, "textVerticalAlign") && (f2.verticalAlign = i.textVerticalAlign), qs(i, "textLineHeight") && (f2.lineHeight = i.textLineHeight), qs(i, "textWidth") && (f2.width = i.textWidth), qs(i, "textHeight") && (f2.height = i.textHeight), qs(i, "textBackgroundColor") && (f2.backgroundColor = i.textBackgroundColor), qs(i, "textPadding") && (f2.padding = i.textPadding), qs(i, "textBorderColor") && (f2.borderColor = i.textBorderColor), qs(i, "textBorderWidth") && (f2.borderWidth = i.textBorderWidth), qs(i, "textBorderRadius") && (f2.borderRadius = i.textBorderRadius), qs(i, "textBoxShadowColor") && (f2.shadowColor = i.textBoxShadowColor), qs(i, "textBoxShadowBlur") && (f2.shadowBlur = i.textBoxShadowBlur), qs(i, "textBoxShadowOffsetX") && (f2.shadowOffsetX = i.textBoxShadowOffsetX), qs(i, "textBoxShadowOffsetY") && (f2.shadowOffsetY = i.textBoxShadowOffsetY));
  }
  function _7e(f2, i, t2) {
    var h = f2;
    h.textPosition = h.textPosition || t2.position || "inside", t2.offset != null && (h.textOffset = t2.offset), t2.rotation != null && (h.textRotation = t2.rotation), t2.distance != null && (h.textDistance = t2.distance);
    var v4 = h.textPosition.indexOf("inside") >= 0, _ = f2.fill || "#000";
    x7e(h, i);
    var M2 = h.textFill == null;
    return v4 ? M2 && (h.textFill = t2.insideFill || "#fff", !h.textStroke && t2.insideStroke && (h.textStroke = t2.insideStroke), !h.textStroke && (h.textStroke = _), h.textStrokeWidth == null && (h.textStrokeWidth = 2)) : (M2 && (h.textFill = f2.fill || t2.outsideFill || "#000"), !h.textStroke && t2.outsideStroke && (h.textStroke = t2.outsideStroke)), h.text = i.text, h.rich = i.rich, Qe2(i.rich, function(I2) {
      x7e(I2, I2);
    }), h;
  }
  function x7e(f2, i) {
    !i || (qs(i, "fill") && (f2.textFill = i.fill), qs(i, "stroke") && (f2.textStroke = i.fill), qs(i, "lineWidth") && (f2.textStrokeWidth = i.lineWidth), qs(i, "font") && (f2.font = i.font), qs(i, "fontStyle") && (f2.fontStyle = i.fontStyle), qs(i, "fontWeight") && (f2.fontWeight = i.fontWeight), qs(i, "fontSize") && (f2.fontSize = i.fontSize), qs(i, "fontFamily") && (f2.fontFamily = i.fontFamily), qs(i, "align") && (f2.textAlign = i.align), qs(i, "verticalAlign") && (f2.textVerticalAlign = i.verticalAlign), qs(i, "lineHeight") && (f2.textLineHeight = i.lineHeight), qs(i, "width") && (f2.textWidth = i.width), qs(i, "height") && (f2.textHeight = i.height), qs(i, "backgroundColor") && (f2.textBackgroundColor = i.backgroundColor), qs(i, "padding") && (f2.textPadding = i.padding), qs(i, "borderColor") && (f2.textBorderColor = i.borderColor), qs(i, "borderWidth") && (f2.textBorderWidth = i.borderWidth), qs(i, "borderRadius") && (f2.textBorderRadius = i.borderRadius), qs(i, "shadowColor") && (f2.textBoxShadowColor = i.shadowColor), qs(i, "shadowBlur") && (f2.textBoxShadowBlur = i.shadowBlur), qs(i, "shadowOffsetX") && (f2.textBoxShadowOffsetX = i.shadowOffsetX), qs(i, "shadowOffsetY") && (f2.textBoxShadowOffsetY = i.shadowOffsetY), qs(i, "textShadowColor") && (f2.textShadowColor = i.textShadowColor), qs(i, "textShadowBlur") && (f2.textShadowBlur = i.textShadowBlur), qs(i, "textShadowOffsetX") && (f2.textShadowOffsetX = i.textShadowOffsetX), qs(i, "textShadowOffsetY") && (f2.textShadowOffsetY = i.textShadowOffsetY));
  }
  var JUe = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, w7e = Of2(JUe);
  zL(WL, function(f2, i) {
    return f2[i] = 1, f2;
  }, {});
  WL.join(", ");
  var GEt = ["", "style", "shape", "extra"], $tt = Wh2();
  function Yne(f2, i, t2, h, v4) {
    var _ = f2 + "Animation", M2 = tet(f2, h, v4) || {}, I2 = $tt(i).userDuring;
    return M2.duration > 0 && (M2.during = I2 ? ks(X2r, { el: i, userDuring: I2 }) : null, M2.setToFinal = true, M2.scope = f2), ba2(M2, t2[_]), M2;
  }
  function tEt(f2, i, t2, h) {
    h = h || {};
    var v4 = h.dataIndex, _ = h.isInit, M2 = h.clearStyle, I2 = t2.isAnimationEnabled(), P2 = $tt(f2), N3 = i.style;
    P2.userDuring = i.during;
    var z3 = {}, H2 = {};
    if (J2r(f2, i, H2), M7e("shape", i, H2), M7e("extra", i, H2), !_ && I2 && (Q2r(f2, i, z3), S7e("shape", f2, i, z3), S7e("extra", f2, i, z3), tMr(f2, i, N3, z3)), H2.style = N3, Z2r(f2, H2, M2), Y2r(f2, i), I2)
      if (_) {
        var $ = {};
        Qe2(GEt, function(at) {
          var ht = at ? i[at] : i;
          ht && ht.enterFrom && (at && ($[at] = $[at] || {}), ba2(at ? $[at] : $, ht.enterFrom));
        });
        var et = Yne("enter", f2, i, t2, v4);
        et.duration > 0 && f2.animateFrom($, et);
      } else
        $2r(f2, i, v4 || 0, t2, z3);
    tqe(f2, i), N3 ? f2.dirty() : f2.markRedraw();
  }
  function tqe(f2, i) {
    for (var t2 = $tt(f2).leaveToProps, h = 0; h < GEt.length; h++) {
      var v4 = GEt[h], _ = v4 ? i[v4] : i;
      _ && _.leaveTo && (t2 || (t2 = $tt(f2).leaveToProps = {}), v4 && (t2[v4] = t2[v4] || {}), ba2(v4 ? t2[v4] : t2, _.leaveTo));
    }
  }
  function Gkt(f2, i, t2, h) {
    if (f2) {
      var v4 = f2.parent, _ = $tt(f2).leaveToProps;
      if (_) {
        var M2 = Yne("update", f2, i, t2, 0);
        M2.done = function() {
          v4.remove(f2), h && h();
        }, f2.animateTo(_, M2);
      } else
        v4.remove(f2), h && h();
    }
  }
  function dU(f2) {
    return f2 === "all";
  }
  function Z2r(f2, i, t2) {
    var h = i.style;
    if (!f2.isGroup && h) {
      if (t2) {
        f2.useStyle({});
        for (var v4 = f2.animators, _ = 0; _ < v4.length; _++) {
          var M2 = v4[_];
          M2.targetName === "style" && M2.changeTarget(f2.style);
        }
      }
      f2.setStyle(h);
    }
    i && (i.style = null, i && f2.attr(i), i.style = h);
  }
  function $2r(f2, i, t2, h, v4) {
    if (v4) {
      var _ = Yne("update", f2, i, h, t2);
      _.duration > 0 && f2.animateFrom(v4, _);
    }
  }
  function Y2r(f2, i) {
    qs(i, "silent") && (f2.silent = i.silent), qs(i, "ignore") && (f2.ignore = i.ignore), f2 instanceof rE && qs(i, "invisible") && (f2.invisible = i.invisible), f2 instanceof Uc2 && qs(i, "autoBatch") && (f2.autoBatch = i.autoBatch);
  }
  var AL = {}, K2r = { setTransform: function(f2, i) {
    return AL.el[f2] = i, this;
  }, getTransform: function(f2) {
    return AL.el[f2];
  }, setShape: function(f2, i) {
    var t2 = AL.el, h = t2.shape || (t2.shape = {});
    return h[f2] = i, t2.dirtyShape && t2.dirtyShape(), this;
  }, getShape: function(f2) {
    var i = AL.el.shape;
    if (i)
      return i[f2];
  }, setStyle: function(f2, i) {
    var t2 = AL.el, h = t2.style;
    return h && (h[f2] = i, t2.dirtyStyle && t2.dirtyStyle()), this;
  }, getStyle: function(f2) {
    var i = AL.el.style;
    if (i)
      return i[f2];
  }, setExtra: function(f2, i) {
    var t2 = AL.el.extra || (AL.el.extra = {});
    return t2[f2] = i, this;
  }, getExtra: function(f2) {
    var i = AL.el.extra;
    if (i)
      return i[f2];
  } };
  function X2r() {
    var f2 = this, i = f2.el;
    if (!!i) {
      var t2 = $tt(i).userDuring, h = f2.userDuring;
      if (t2 !== h) {
        f2.el = f2.userDuring = null;
        return;
      }
      AL.el = i, h(K2r);
    }
  }
  function S7e(f2, i, t2, h) {
    var v4 = t2[f2];
    if (!!v4) {
      var _ = i[f2], M2;
      if (_) {
        var I2 = t2.transition, P2 = v4.transition;
        if (P2)
          if (!M2 && (M2 = h[f2] = {}), dU(P2))
            ba2(M2, _);
          else
            for (var N3 = Od2(P2), z3 = 0; z3 < N3.length; z3++) {
              var H2 = N3[z3], $ = _[H2];
              M2[H2] = $;
            }
        else if (dU(I2) || Pc2(I2, f2) >= 0) {
          !M2 && (M2 = h[f2] = {});
          for (var et = Of2(_), z3 = 0; z3 < et.length; z3++) {
            var H2 = et[z3], $ = _[H2];
            eMr(v4[H2], $) && (M2[H2] = $);
          }
        }
      }
    }
  }
  function M7e(f2, i, t2) {
    var h = i[f2];
    if (!!h)
      for (var v4 = t2[f2] = {}, _ = Of2(h), M2 = 0; M2 < _.length; M2++) {
        var I2 = _[M2];
        v4[I2] = Ddt(h[I2]);
      }
  }
  function Q2r(f2, i, t2) {
    for (var h = i.transition, v4 = dU(h) ? WL : Od2(h || []), _ = 0; _ < v4.length; _++) {
      var M2 = v4[_];
      if (!(M2 === "style" || M2 === "shape" || M2 === "extra")) {
        var I2 = f2[M2];
        t2[M2] = I2;
      }
    }
  }
  function J2r(f2, i, t2) {
    for (var h = 0; h < w7e.length; h++) {
      var v4 = w7e[h], _ = JUe[v4], M2 = i[v4];
      M2 && (t2[_[0]] = M2[0], t2[_[1]] = M2[1]);
    }
    for (var h = 0; h < WL.length; h++) {
      var I2 = WL[h];
      i[I2] != null && (t2[I2] = i[I2]);
    }
  }
  function tMr(f2, i, t2, h) {
    if (!!t2) {
      var v4 = f2.style, _;
      if (v4) {
        var M2 = t2.transition, I2 = i.transition;
        if (M2 && !dU(M2)) {
          var P2 = Od2(M2);
          !_ && (_ = h.style = {});
          for (var N3 = 0; N3 < P2.length; N3++) {
            var z3 = P2[N3], H2 = v4[z3];
            _[z3] = H2;
          }
        } else if (f2.getAnimationStyleProps && (dU(I2) || dU(M2) || Pc2(I2, "style") >= 0)) {
          var $ = f2.getAnimationStyleProps(), et = $ ? $.style : null;
          if (et) {
            !_ && (_ = h.style = {});
            for (var at = Of2(t2), N3 = 0; N3 < at.length; N3++) {
              var z3 = at[N3];
              if (et[z3]) {
                var H2 = v4[z3];
                _[z3] = H2;
              }
            }
          }
        }
      }
    }
  }
  function eMr(f2, i) {
    return xS(f2) ? f2 !== i : f2 != null && isFinite(f2);
  }
  var eqe = Wh2(), nMr = ["percent", "easing", "shape", "style", "extra"];
  function nqe(f2) {
    f2.stopAnimation("keyframe"), f2.attr(eqe(f2));
  }
  function HEt(f2, i, t2) {
    if (!(!t2.isAnimationEnabled() || !i)) {
      if (Za2(i)) {
        Qe2(i, function(I2) {
          HEt(f2, I2, t2);
        });
        return;
      }
      var h = i.keyframes, v4 = i.duration;
      if (t2 && v4 == null) {
        var _ = tet("enter", t2, 0);
        v4 = _ && _.duration;
      }
      if (!(!h || !v4)) {
        var M2 = eqe(f2);
        Qe2(GEt, function(I2) {
          if (!(I2 && !f2[I2])) {
            var P2;
            h.sort(function(N3, z3) {
              return N3.percent - z3.percent;
            }), Qe2(h, function(N3) {
              var z3 = f2.animators, H2 = I2 ? N3[I2] : N3;
              if (!!H2) {
                var $ = Of2(H2);
                if (I2 || ($ = Ld2($, function(ht) {
                  return Pc2(nMr, ht) < 0;
                })), !!$.length) {
                  P2 || (P2 = f2.animate(I2, i.loop, true), P2.scope = "keyframe");
                  for (var et = 0; et < z3.length; et++)
                    z3[et] !== P2 && z3[et].targetName === P2.targetName && z3[et].stopTracks($);
                  I2 && (M2[I2] = M2[I2] || {});
                  var at = I2 ? M2[I2] : M2;
                  Qe2($, function(ht) {
                    at[ht] = ((I2 ? f2[I2] : f2) || {})[ht];
                  }), P2.whenWithKeys(v4 * N3.percent, H2, $, N3.easing);
                }
              }
            }), P2 && P2.delay(i.delay || 0).duration(v4).start(i.easing);
          }
        });
      }
    }
  }
  var X6 = "emphasis", G7 = "normal", Kne = "blur", Xne = "select", rV = [G7, X6, Kne, Xne], EQt = { normal: ["itemStyle"], emphasis: [X6, "itemStyle"], blur: [Kne, "itemStyle"], select: [Xne, "itemStyle"] }, kQt = { normal: ["label"], emphasis: [X6, "label"], blur: [Kne, "label"], select: [Xne, "label"] }, rMr = ["x", "y"], iMr = "e\0\0", zD = { normal: {}, emphasis: {}, blur: {}, select: {} }, aMr = { cartesian2d: B2r, geo: j2r, singleAxis: G2r, polar: U2r, calendar: q2r };
  function Ote(f2) {
    return f2 instanceof Uc2;
  }
  function Rte(f2) {
    return f2 instanceof rE;
  }
  function oMr(f2, i) {
    i.copyTransform(f2), Rte(i) && Rte(f2) && (i.setStyle(f2.style), i.z = f2.z, i.z2 = f2.z2, i.zlevel = f2.zlevel, i.invisible = f2.invisible, i.ignore = f2.ignore, Ote(i) && Ote(f2) && i.setShape(f2.shape));
  }
  var sMr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      this._progressiveEls = null;
      var M2 = this._data, I2 = t2.getData(), P2 = this.group, N3 = C7e(t2, I2, h, v4);
      M2 || P2.removeAll(), I2.diff(M2).add(function(H2) {
        PQt(v4, null, H2, N3(H2, _), t2, P2, I2);
      }).remove(function(H2) {
        var $ = M2.getItemGraphicEl(H2);
        Gkt($, K6($).option, t2);
      }).update(function(H2, $) {
        var et = M2.getItemGraphicEl($);
        PQt(v4, et, H2, N3(H2, _), t2, P2, I2);
      }).execute();
      var z3 = t2.get("clip", true) ? Fkt(t2.coordinateSystem, false, t2) : null;
      z3 ? P2.setClipPath(z3) : P2.removeClipPath(), this._data = I2;
    }, i.prototype.incrementalPrepareRender = function(t2, h, v4) {
      this.group.removeAll(), this._data = null;
    }, i.prototype.incrementalRender = function(t2, h, v4, _, M2) {
      var I2 = h.getData(), P2 = C7e(h, I2, v4, _), N3 = this._progressiveEls = [];
      function z3(et) {
        et.isGroup || (et.incremental = true, et.ensureState("emphasis").hoverLayer = true);
      }
      for (var H2 = t2.start; H2 < t2.end; H2++) {
        var $ = PQt(null, null, H2, P2(H2, M2), h, this.group, I2);
        $ && ($.traverse(z3), N3.push($));
      }
    }, i.prototype.eachRendered = function(t2) {
      oV(this._progressiveEls || this.group, t2);
    }, i.prototype.filterForExposedEvent = function(t2, h, v4, _) {
      var M2 = h.element;
      if (M2 == null || v4.name === M2)
        return true;
      for (; (v4 = v4.__hostTarget || v4.parent) && v4 !== this.group; )
        if (v4.name === M2)
          return true;
      return false;
    }, i.type = "custom", i;
  }(Hg2), lMr = sMr;
  function Qne(f2) {
    var i = f2.type, t2;
    if (i === "path") {
      var h = f2.shape, v4 = h.width != null && h.height != null ? { x: h.x || 0, y: h.y || 0, width: h.width, height: h.height } : null, _ = aqe(h);
      t2 = bkt(_, null, v4, h.layout || "center"), K6(t2).customPathData = _;
    } else if (i === "image")
      t2 = new Ux({}), K6(t2).customImagePath = f2.style.image;
    else if (i === "text")
      t2 = new op({});
    else if (i === "group")
      t2 = new mu();
    else {
      if (i === "compoundPath")
        throw new Error('"compoundPath" is not supported yet.');
      var M2 = Gee(i);
      if (!M2) {
        var I2 = "";
        Ep(I2);
      }
      t2 = new M2();
    }
    return K6(t2).customGraphicType = i, t2.name = f2.name, t2.z2EmphasisLift = 1, t2.z2SelectLift = 1, t2;
  }
  function Jne(f2, i, t2, h, v4, _, M2) {
    nqe(i);
    var I2 = v4 && v4.normal.cfg;
    I2 && i.setTextConfig(I2), h && h.transition == null && (h.transition = rMr);
    var P2 = h && h.style;
    if (P2) {
      if (i.type === "text") {
        var N3 = P2;
        qs(N3, "textFill") && (N3.fill = N3.textFill), qs(N3, "textStroke") && (N3.stroke = N3.textStroke);
      }
      var z3 = void 0, H2 = Ote(i) ? P2.decal : null;
      f2 && H2 && (H2.dirty = true, z3 = lgt(H2, f2)), P2.__decalPattern = z3;
    }
    if (Rte(i) && P2) {
      var z3 = P2.__decalPattern;
      z3 && (P2.decal = z3);
    }
    tEt(i, h, _, { dataIndex: t2, isInit: M2, clearStyle: true }), HEt(i, h.keyframeAnimation, _);
  }
  function rqe(f2, i, t2, h, v4) {
    var _ = i.isGroup ? null : i, M2 = v4 && v4[f2].cfg;
    if (_) {
      var I2 = _.ensureState(f2);
      if (h === false) {
        var P2 = _.getState(f2);
        P2 && (P2.style = null);
      } else
        I2.style = h || null;
      M2 && (I2.textConfig = M2), mU(_);
    }
  }
  function uMr(f2, i, t2) {
    if (!f2.isGroup) {
      var h = f2, v4 = t2.currentZ, _ = t2.currentZLevel;
      h.z = v4, h.zlevel = _;
      var M2 = i.z2;
      M2 != null && (h.z2 = M2 || 0);
      for (var I2 = 0; I2 < rV.length; I2++)
        cMr(h, i, rV[I2]);
    }
  }
  function cMr(f2, i, t2) {
    var h = t2 === G7, v4 = h ? i : UEt(i, t2), _ = v4 ? v4.z2 : null, M2;
    _ != null && (M2 = h ? f2 : f2.ensureState(t2), M2.z2 = _ || 0);
  }
  function C7e(f2, i, t2, h) {
    var v4 = f2.get("renderItem"), _ = f2.coordinateSystem, M2 = {};
    _ && (M2 = _.prepareCustoms ? _.prepareCustoms(_) : aMr[_.type](_));
    for (var I2 = Ul({ getWidth: h.getWidth, getHeight: h.getHeight, getZr: h.getZr, getDevicePixelRatio: h.getDevicePixelRatio, value: Ft, style: re2, ordinalRawValue: fe2, styleEmphasis: ye, visual: Te2, barLayout: We, currentSeriesIndices: en, font: Ue2 }, M2.api || {}), P2 = { context: {}, seriesId: f2.id, seriesName: f2.name, seriesIndex: f2.seriesIndex, coordSys: M2.coordSys, dataInsideLength: i.count(), encode: fMr(f2.getData()) }, N3, z3, H2 = {}, $ = {}, et = {}, at = {}, ht = 0; ht < rV.length; ht++) {
      var bt = rV[ht];
      et[bt] = f2.getModel(EQt[bt]), at[bt] = f2.getModel(kQt[bt]);
    }
    function _t(Mn) {
      return Mn === N3 ? z3 || (z3 = i.getItemModel(Mn)) : i.getItemModel(Mn);
    }
    function Et(Mn, Vn) {
      return i.hasItemOption ? Mn === N3 ? H2[Vn] || (H2[Vn] = _t(Mn).getModel(EQt[Vn])) : _t(Mn).getModel(EQt[Vn]) : et[Vn];
    }
    function zt(Mn, Vn) {
      return i.hasItemOption ? Mn === N3 ? $[Vn] || ($[Vn] = _t(Mn).getModel(kQt[Vn])) : _t(Mn).getModel(kQt[Vn]) : at[Vn];
    }
    return function(Mn, Vn) {
      return N3 = Mn, z3 = null, H2 = {}, $ = {}, v4 && v4(Ul({ dataIndexInside: Mn, dataIndex: i.getRawIndex(Mn), actionType: Vn ? Vn.type : null }, P2), I2);
    };
    function Ft(Mn, Vn) {
      return Vn == null && (Vn = N3), i.getStore().get(i.getDimensionIndex(Mn || 0), Vn);
    }
    function fe2(Mn, Vn) {
      Vn == null && (Vn = N3), Mn = Mn || 0;
      var xn = i.getDimensionInfo(Mn);
      if (!xn) {
        var Zr = i.getDimensionIndex(Mn);
        return Zr >= 0 ? i.getStore().get(Zr, Vn) : void 0;
      }
      var nr = i.get(xn.name, Vn), pr = xn && xn.ordinalMeta;
      return pr ? pr.categories[nr] : nr;
    }
    function re2(Mn, Vn) {
      Vn == null && (Vn = N3);
      var xn = i.getItemVisual(Vn, "style"), Zr = xn && xn.fill, nr = xn && xn.opacity, pr = Et(Vn, G7).getItemStyle();
      Zr != null && (pr.fill = Zr), nr != null && (pr.opacity = nr);
      var Nr = { inheritColor: ms(Zr) ? Zr : "#000" }, ai2 = zt(Vn, G7), gi2 = By(ai2, null, Nr, false, true);
      gi2.text = ai2.getShallow("show") ? _c2(f2.getFormattedLabel(Vn, G7), Utt(i, Vn)) : null;
      var To = _Et(ai2, Nr, false);
      return be2(Mn, pr), pr = _7e(pr, gi2, To), Mn && me2(pr, Mn), pr.legacy = true, pr;
    }
    function ye(Mn, Vn) {
      Vn == null && (Vn = N3);
      var xn = Et(Vn, X6).getItemStyle(), Zr = zt(Vn, X6), nr = By(Zr, null, null, true, true);
      nr.text = Zr.getShallow("show") ? U6(f2.getFormattedLabel(Vn, X6), f2.getFormattedLabel(Vn, G7), Utt(i, Vn)) : null;
      var pr = _Et(Zr, null, true);
      return be2(Mn, xn), xn = _7e(xn, nr, pr), Mn && me2(xn, Mn), xn.legacy = true, xn;
    }
    function me2(Mn, Vn) {
      for (var xn in Vn)
        qs(Vn, xn) && (Mn[xn] = Vn[xn]);
    }
    function be2(Mn, Vn) {
      Mn && (Mn.textFill && (Vn.textFill = Mn.textFill), Mn.textPosition && (Vn.textPosition = Mn.textPosition));
    }
    function Te2(Mn, Vn) {
      if (Vn == null && (Vn = N3), qs(m7e, Mn)) {
        var xn = i.getItemVisual(Vn, "style");
        return xn ? xn[m7e[Mn]] : null;
      }
      if (qs(R2r, Mn))
        return i.getItemVisual(Vn, Mn);
    }
    function We(Mn) {
      if (_.type === "cartesian2d") {
        var Vn = _.getBaseAxis();
        return hvr(Ul({ axis: Vn }, Mn));
      }
    }
    function en() {
      return t2.getCurrentSeriesIndices();
    }
    function Ue2(Mn) {
      return Vje(Mn, t2);
    }
  }
  function fMr(f2) {
    var i = {};
    return Qe2(f2.dimensions, function(t2) {
      var h = f2.getDimensionInfo(t2);
      if (!h.isExtraCoord) {
        var v4 = h.coordDim, _ = i[v4] = i[v4] || [];
        _[h.coordDimIndex] = f2.getDimensionIndex(t2);
      }
    }), i;
  }
  function PQt(f2, i, t2, h, v4, _, M2) {
    if (!h) {
      _.remove(i);
      return;
    }
    var I2 = tre(f2, i, t2, h, v4, _);
    return I2 && M2.setItemGraphicEl(t2, I2), I2 && vy(I2, h.focus, h.blurScope, h.emphasisDisabled), I2;
  }
  function tre(f2, i, t2, h, v4, _) {
    var M2 = -1, I2 = i;
    i && iqe(i, h, v4) && (M2 = Pc2(_.childrenRef(), i), i = null);
    var P2 = !i, N3 = i;
    N3 ? N3.clearStates() : (N3 = Qne(h), I2 && oMr(I2, N3)), h.morph === false ? N3.disableMorphing = true : N3.disableMorphing && (N3.disableMorphing = false), zD.normal.cfg = zD.normal.conOpt = zD.emphasis.cfg = zD.emphasis.conOpt = zD.blur.cfg = zD.blur.conOpt = zD.select.cfg = zD.select.conOpt = null, zD.isLegacy = false, pMr(N3, t2, h, v4, P2, zD), hMr(N3, t2, h, v4, P2), Jne(f2, N3, t2, h, zD, v4, P2), qs(h, "info") && (K6(N3).info = h.info);
    for (var z3 = 0; z3 < rV.length; z3++) {
      var H2 = rV[z3];
      if (H2 !== G7) {
        var $ = UEt(h, H2), et = ere(h, $, H2);
        rqe(H2, N3, $, et, zD);
      }
    }
    return uMr(N3, h, v4), h.type === "group" && dMr(f2, N3, t2, h, v4), M2 >= 0 ? _.replaceAt(N3, M2) : _.add(N3), N3;
  }
  function iqe(f2, i, t2) {
    var h = K6(f2), v4 = i.type, _ = i.shape, M2 = i.style;
    return t2.isUniversalTransitionEnabled() || v4 != null && v4 !== h.customGraphicType || v4 === "path" && yMr(_) && aqe(_) !== h.customPathData || v4 === "image" && qs(M2, "image") && M2.image !== h.customImagePath;
  }
  function hMr(f2, i, t2, h, v4) {
    var _ = t2.clipPath;
    if (_ === false)
      f2 && f2.getClipPath() && f2.removeClipPath();
    else if (_) {
      var M2 = f2.getClipPath();
      M2 && iqe(M2, _, h) && (M2 = null), M2 || (M2 = Qne(_), f2.setClipPath(M2)), Jne(null, M2, i, _, null, h, v4);
    }
  }
  function pMr(f2, i, t2, h, v4, _) {
    if (!f2.isGroup) {
      T7e(t2, null, _), T7e(t2, X6, _);
      var M2 = _.normal.conOpt, I2 = _.emphasis.conOpt, P2 = _.blur.conOpt, N3 = _.select.conOpt;
      if (M2 != null || I2 != null || N3 != null || P2 != null) {
        var z3 = f2.getTextContent();
        if (M2 === false)
          z3 && f2.removeTextContent();
        else {
          M2 = _.normal.conOpt = M2 || { type: "text" }, z3 ? z3.clearStates() : (z3 = Qne(M2), f2.setTextContent(z3)), Jne(null, z3, i, M2, null, h, v4);
          for (var H2 = M2 && M2.style, $ = 0; $ < rV.length; $++) {
            var et = rV[$];
            if (et !== G7) {
              var at = _[et].conOpt;
              rqe(et, z3, at, ere(M2, at, et), null);
            }
          }
          H2 ? z3.dirty() : z3.markRedraw();
        }
      }
    }
  }
  function T7e(f2, i, t2) {
    var h = i ? UEt(f2, i) : f2, v4 = i ? ere(f2, h, X6) : f2.style, _ = f2.type, M2 = h ? h.textConfig : null, I2 = f2.textContent, P2 = I2 ? i ? UEt(I2, i) : I2 : null;
    if (v4 && (t2.isLegacy || XUe(v4, _, !!M2, !!P2))) {
      t2.isLegacy = true;
      var N3 = QUe(v4, _, !i);
      !M2 && N3.textConfig && (M2 = N3.textConfig), !P2 && N3.textContent && (P2 = N3.textContent);
    }
    if (!i && P2) {
      var z3 = P2;
      !z3.type && (z3.type = "text");
    }
    var H2 = i ? t2[i] : t2.normal;
    H2.cfg = M2, H2.conOpt = P2;
  }
  function UEt(f2, i) {
    return i ? f2 ? f2[i] : null : f2;
  }
  function ere(f2, i, t2) {
    var h = i && i.style;
    return h == null && t2 === X6 && f2 && (h = f2.styleEmphasis), h;
  }
  function dMr(f2, i, t2, h, v4) {
    var _ = h.children, M2 = _ ? _.length : 0, I2 = h.$mergeChildren, P2 = I2 === "byName" || h.diffChildrenByName, N3 = I2 === false;
    if (!(!M2 && !P2 && !N3)) {
      if (P2) {
        gMr({ api: f2, oldChildren: i.children() || [], newChildren: _ || [], dataIndex: t2, seriesModel: v4, group: i });
        return;
      }
      N3 && i.removeAll();
      for (var z3 = 0; z3 < M2; z3++)
        _[z3] && tre(f2, i.childAt(z3), t2, _[z3], v4, i);
      for (var H2 = i.childCount() - 1; H2 >= z3; H2--) {
        var $ = i.childAt(H2);
        Gkt($, K6(i).option, v4);
      }
    }
  }
  function gMr(f2) {
    new eN(f2.oldChildren, f2.newChildren, A7e, A7e, f2).add(I7e).update(I7e).remove(vMr).execute();
  }
  function A7e(f2, i) {
    var t2 = f2 && f2.name;
    return t2 != null ? t2 : iMr + i;
  }
  function I7e(f2, i) {
    var t2 = this.context, h = f2 != null ? t2.newChildren[f2] : null, v4 = i != null ? t2.oldChildren[i] : null;
    tre(t2.api, v4, t2.dataIndex, h, t2.seriesModel, t2.group);
  }
  function vMr(f2) {
    var i = this.context, t2 = i.oldChildren[f2];
    Gkt(t2, K6(t2).option, i.seriesModel);
  }
  function aqe(f2) {
    return f2 && (f2.pathData || f2.d);
  }
  function yMr(f2) {
    return f2 && (qs(f2, "pathData") || qs(f2, "d"));
  }
  function mMr(f2) {
    f2.registerChartView(lMr), f2.registerSeriesModel(F2r);
  }
  var QH = Wh2(), D7e = pu, LQt = ks, bMr = function() {
    function f2() {
      this._dragging = false, this.animationThreshold = 15;
    }
    return f2.prototype.render = function(i, t2, h, v4) {
      var _ = t2.get("value"), M2 = t2.get("status");
      if (this._axisModel = i, this._axisPointerModel = t2, this._api = h, !(!v4 && this._lastValue === _ && this._lastStatus === M2)) {
        this._lastValue = _, this._lastStatus = M2;
        var I2 = this._group, P2 = this._handle;
        if (!M2 || M2 === "hide") {
          I2 && I2.hide(), P2 && P2.hide();
          return;
        }
        I2 && I2.show(), P2 && P2.show();
        var N3 = {};
        this.makeElOption(N3, _, i, t2, h);
        var z3 = N3.graphicKey;
        z3 !== this._lastGraphicKey && this.clear(h), this._lastGraphicKey = z3;
        var H2 = this._moveAnimation = this.determineAnimation(i, t2);
        if (!I2)
          I2 = this._group = new mu(), this.createPointerEl(I2, N3, i, t2), this.createLabelEl(I2, N3, i, t2), h.getZr().add(I2);
        else {
          var $ = Ou(E7e, t2, H2);
          this.updatePointerEl(I2, N3, $), this.updateLabelEl(I2, N3, $, t2);
        }
        P7e(I2, t2, true), this._renderHandle(_);
      }
    }, f2.prototype.remove = function(i) {
      this.clear(i);
    }, f2.prototype.dispose = function(i) {
      this.clear(i);
    }, f2.prototype.determineAnimation = function(i, t2) {
      var h = t2.get("animation"), v4 = i.axis, _ = v4.type === "category", M2 = t2.get("snap");
      if (!M2 && !_)
        return false;
      if (h === "auto" || h == null) {
        var I2 = this.animationThreshold;
        if (_ && v4.getBandWidth() > I2)
          return true;
        if (M2) {
          var P2 = Ane(i).seriesDataCount, N3 = v4.getExtent();
          return Math.abs(N3[0] - N3[1]) / P2 > I2;
        }
        return false;
      }
      return h === true;
    }, f2.prototype.makeElOption = function(i, t2, h, v4, _) {
    }, f2.prototype.createPointerEl = function(i, t2, h, v4) {
      var _ = t2.pointer;
      if (_) {
        var M2 = QH(i).pointerEl = new kgt[_.type](D7e(t2.pointer));
        i.add(M2);
      }
    }, f2.prototype.createLabelEl = function(i, t2, h, v4) {
      if (t2.label) {
        var _ = QH(i).labelEl = new op(D7e(t2.label));
        i.add(_), k7e(_, v4);
      }
    }, f2.prototype.updatePointerEl = function(i, t2, h) {
      var v4 = QH(i).pointerEl;
      v4 && t2.pointer && (v4.setStyle(t2.pointer.style), h(v4, { shape: t2.pointer.shape }));
    }, f2.prototype.updateLabelEl = function(i, t2, h, v4) {
      var _ = QH(i).labelEl;
      _ && (_.setStyle(t2.label.style), h(_, { x: t2.label.x, y: t2.label.y }), k7e(_, v4));
    }, f2.prototype._renderHandle = function(i) {
      if (!(this._dragging || !this.updateHandleTransform)) {
        var t2 = this._axisPointerModel, h = this._api.getZr(), v4 = this._handle, _ = t2.getModel("handle"), M2 = t2.get("status");
        if (!_.get("show") || !M2 || M2 === "hide") {
          v4 && h.remove(v4), this._handle = null;
          return;
        }
        var I2;
        this._handle || (I2 = true, v4 = this._handle = Egt(_.get("icon"), { cursor: "move", draggable: true, onmousemove: function(N3) {
          J6(N3.event);
        }, onmousedown: LQt(this._onHandleDragMove, this, 0, 0), drift: LQt(this._onHandleDragMove, this), ondragend: LQt(this._onHandleDragEnd, this) }), h.add(v4)), P7e(v4, t2, false), v4.setStyle(_.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
        var P2 = _.get("size");
        Za2(P2) || (P2 = [P2, P2]), v4.scaleX = P2[0] / 2, v4.scaleY = P2[1] / 2, cet(this, "_doDispatchAxisPointer", _.get("throttle") || 0, "fixRate"), this._moveHandleToValue(i, I2);
      }
    }, f2.prototype._moveHandleToValue = function(i, t2) {
      E7e(this._axisPointerModel, !t2 && this._moveAnimation, this._handle, OQt(this.getHandleTransform(i, this._axisModel, this._axisPointerModel)));
    }, f2.prototype._onHandleDragMove = function(i, t2) {
      var h = this._handle;
      if (!!h) {
        this._dragging = true;
        var v4 = this.updateHandleTransform(OQt(h), [i, t2], this._axisModel, this._axisPointerModel);
        this._payloadInfo = v4, h.stopAnimation(), h.attr(OQt(v4)), QH(h).lastProp = null, this._doDispatchAxisPointer();
      }
    }, f2.prototype._doDispatchAxisPointer = function() {
      var i = this._handle;
      if (!!i) {
        var t2 = this._payloadInfo, h = this._axisModel;
        this._api.dispatchAction({ type: "updateAxisPointer", x: t2.cursorPoint[0], y: t2.cursorPoint[1], tooltipOption: t2.tooltipOption, axesInfo: [{ axisDim: h.axis.dim, axisIndex: h.componentIndex }] });
      }
    }, f2.prototype._onHandleDragEnd = function() {
      this._dragging = false;
      var i = this._handle;
      if (!!i) {
        var t2 = this._axisPointerModel.get("value");
        this._moveHandleToValue(t2), this._api.dispatchAction({ type: "hideTip" });
      }
    }, f2.prototype.clear = function(i) {
      this._lastValue = null, this._lastStatus = null;
      var t2 = i.getZr(), h = this._group, v4 = this._handle;
      t2 && h && (this._lastGraphicKey = null, h && t2.remove(h), v4 && t2.remove(v4), this._group = null, this._handle = null, this._payloadInfo = null), agt(this, "_doDispatchAxisPointer");
    }, f2.prototype.doClear = function() {
    }, f2.prototype.buildLabel = function(i, t2, h) {
      return h = h || 0, { x: i[h], y: i[1 - h], width: t2[h], height: t2[1 - h] };
    }, f2;
  }();
  function E7e(f2, i, t2, h) {
    oqe(QH(t2).lastProp, h) || (QH(t2).lastProp = h, i ? jh2(t2, h, f2) : (t2.stopAnimation(), t2.attr(h)));
  }
  function oqe(f2, i) {
    if (Xl(f2) && Xl(i)) {
      var t2 = true;
      return Qe2(i, function(h, v4) {
        t2 = t2 && oqe(f2[v4], h);
      }), !!t2;
    } else
      return f2 === i;
  }
  function k7e(f2, i) {
    f2[i.get(["label", "show"]) ? "show" : "hide"]();
  }
  function OQt(f2) {
    return { x: f2.x || 0, y: f2.y || 0, rotation: f2.rotation || 0 };
  }
  function P7e(f2, i, t2) {
    var h = i.get("z"), v4 = i.get("zlevel");
    f2 && f2.traverse(function(_) {
      _.type !== "group" && (h != null && (_.z = h), v4 != null && (_.zlevel = v4), _.silent = t2);
    });
  }
  var nre = bMr;
  function rre(f2) {
    var i = f2.get("type"), t2 = f2.getModel(i + "Style"), h;
    return i === "line" ? (h = t2.getLineStyle(), h.fill = null) : i === "shadow" && (h = t2.getAreaStyle(), h.stroke = null), h;
  }
  function sqe(f2, i, t2, h, v4) {
    var _ = t2.get("value"), M2 = lqe(_, i.axis, i.ecModel, t2.get("seriesDataIndices"), { precision: t2.get(["label", "precision"]), formatter: t2.get(["label", "formatter"]) }), I2 = t2.getModel("label"), P2 = iet(I2.get("padding") || 0), N3 = I2.getFont(), z3 = Cgt(M2, N3), H2 = v4.position, $ = z3.width + P2[1] + P2[3], et = z3.height + P2[0] + P2[2], at = v4.align;
    at === "right" && (H2[0] -= $), at === "center" && (H2[0] -= $ / 2);
    var ht = v4.verticalAlign;
    ht === "bottom" && (H2[1] -= et), ht === "middle" && (H2[1] -= et / 2), _Mr(H2, $, et, h);
    var bt = I2.get("backgroundColor");
    (!bt || bt === "auto") && (bt = i.get(["axisLine", "lineStyle", "color"])), f2.label = { x: H2[0], y: H2[1], style: By(I2, { text: M2, font: N3, fill: I2.getTextColor(), padding: P2, backgroundColor: bt }), z2: 10 };
  }
  function _Mr(f2, i, t2, h) {
    var v4 = h.getWidth(), _ = h.getHeight();
    f2[0] = Math.min(f2[0] + i, v4) - i, f2[1] = Math.min(f2[1] + t2, _) - t2, f2[0] = Math.max(f2[0], 0), f2[1] = Math.max(f2[1], 0);
  }
  function lqe(f2, i, t2, h, v4) {
    f2 = i.scale.parse(f2);
    var _ = i.scale.getLabel({ value: f2 }, { precision: v4.precision }), M2 = v4.formatter;
    if (M2) {
      var I2 = { value: mne(i, { value: f2 }), axisDimension: i.dim, axisIndex: i.index, seriesData: [] };
      Qe2(h, function(P2) {
        var N3 = t2.getSeriesByIndex(P2.seriesIndex), z3 = P2.dataIndexInside, H2 = N3 && N3.getDataParams(z3);
        H2 && I2.seriesData.push(H2);
      }), ms(M2) ? _ = M2.replace("{value}", _) : Ol(M2) && (_ = M2(I2));
    }
    return _;
  }
  function ire(f2, i, t2) {
    var h = nE();
    return SU(h, h, t2.rotation), jL(h, h, t2.position), C5([f2.dataToCoord(i), (t2.labelOffset || 0) + (t2.labelDirection || 1) * (t2.labelMargin || 0)], h);
  }
  function uqe(f2, i, t2, h, v4, _) {
    var M2 = nN.innerTextLayout(t2.rotation, 0, t2.labelDirection);
    t2.labelMargin = v4.get(["label", "margin"]), sqe(i, h, v4, _, { position: ire(h.axis, f2, t2), align: M2.textAlign, verticalAlign: M2.textVerticalAlign });
  }
  function are(f2, i, t2) {
    return t2 = t2 || 0, { x1: f2[t2], y1: f2[1 - t2], x2: i[t2], y2: i[1 - t2] };
  }
  function cqe(f2, i, t2) {
    return t2 = t2 || 0, { x: f2[t2], y: f2[1 - t2], width: i[t2], height: i[1 - t2] };
  }
  function L7e(f2, i, t2, h, v4, _) {
    return { cx: f2, cy: i, r0: t2, r: h, startAngle: v4, endAngle: _, clockwise: true };
  }
  var xMr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.makeElOption = function(t2, h, v4, _, M2) {
      var I2 = v4.axis, P2 = I2.grid, N3 = _.get("type"), z3 = O7e(P2, I2).getOtherAxis(I2).getGlobalExtent(), H2 = I2.toGlobalCoord(I2.dataToCoord(h, true));
      if (N3 && N3 !== "none") {
        var $ = rre(_), et = wMr[N3](I2, H2, z3);
        et.style = $, t2.graphicKey = et.type, t2.pointer = et;
      }
      var at = yte(P2.model, v4);
      uqe(h, t2, at, v4, _, M2);
    }, i.prototype.getHandleTransform = function(t2, h, v4) {
      var _ = yte(h.axis.grid.model, h, { labelInside: false });
      _.labelMargin = v4.get(["handle", "margin"]);
      var M2 = ire(h.axis, t2, _);
      return { x: M2[0], y: M2[1], rotation: _.rotation + (_.labelDirection < 0 ? Math.PI : 0) };
    }, i.prototype.updateHandleTransform = function(t2, h, v4, _) {
      var M2 = v4.axis, I2 = M2.grid, P2 = M2.getGlobalExtent(true), N3 = O7e(I2, M2).getOtherAxis(M2).getGlobalExtent(), z3 = M2.dim === "x" ? 0 : 1, H2 = [t2.x, t2.y];
      H2[z3] += h[z3], H2[z3] = Math.min(P2[1], H2[z3]), H2[z3] = Math.max(P2[0], H2[z3]);
      var $ = (N3[1] + N3[0]) / 2, et = [$, $];
      et[z3] = H2[z3];
      var at = [{ verticalAlign: "middle" }, { align: "center" }];
      return { x: H2[0], y: H2[1], rotation: t2.rotation, cursorPoint: et, tooltipOption: at[z3] };
    }, i;
  }(nre);
  function O7e(f2, i) {
    var t2 = {};
    return t2[i.dim + "AxisIndex"] = i.index, f2.getCartesian(t2);
  }
  var wMr = { line: function(f2, i, t2) {
    var h = are([i, t2[0]], [i, t2[1]], R7e(f2));
    return { type: "Line", subPixelOptimize: true, shape: h };
  }, shadow: function(f2, i, t2) {
    var h = Math.max(1, f2.getBandWidth()), v4 = t2[1] - t2[0];
    return { type: "Rect", shape: cqe([i - h / 2, t2[0]], [h, v4], R7e(f2)) };
  } };
  function R7e(f2) {
    return f2.dim === "x" ? 0 : 1;
  }
  var SMr = xMr, MMr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "axisPointer", i.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, i;
  }(zh2), CMr = MMr, H6 = Wh2(), TMr = Qe2;
  function fqe(f2, i, t2) {
    if (!gp.node) {
      var h = i.getZr();
      H6(h).records || (H6(h).records = {}), AMr(h, i);
      var v4 = H6(h).records[f2] || (H6(h).records[f2] = {});
      v4.handler = t2;
    }
  }
  function AMr(f2, i) {
    if (H6(f2).initialized)
      return;
    H6(f2).initialized = true, t2("click", Ou(N7e, "click")), t2("mousemove", Ou(N7e, "mousemove")), t2("globalout", DMr);
    function t2(h, v4) {
      f2.on(h, function(_) {
        var M2 = EMr(i);
        TMr(H6(f2).records, function(I2) {
          I2 && v4(I2, _, M2.dispatchAction);
        }), IMr(M2.pendings, i);
      });
    }
  }
  function IMr(f2, i) {
    var t2 = f2.showTip.length, h = f2.hideTip.length, v4;
    t2 ? v4 = f2.showTip[t2 - 1] : h && (v4 = f2.hideTip[h - 1]), v4 && (v4.dispatchAction = null, i.dispatchAction(v4));
  }
  function DMr(f2, i, t2) {
    f2.handler("leave", null, t2);
  }
  function N7e(f2, i, t2, h) {
    i.handler(f2, t2, h);
  }
  function EMr(f2) {
    var i = { showTip: [], hideTip: [] }, t2 = function(h) {
      var v4 = i[h.type];
      v4 ? v4.push(h) : (h.dispatchAction = t2, f2.dispatchAction(h));
    };
    return { dispatchAction: t2, pendings: i };
  }
  function Nte(f2, i) {
    if (!gp.node) {
      var t2 = i.getZr(), h = (H6(t2).records || {})[f2];
      h && (H6(t2).records[f2] = null);
    }
  }
  var kMr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = h.getComponent("tooltip"), M2 = t2.get("triggerOn") || _ && _.get("triggerOn") || "mousemove|click";
      fqe("axisPointer", v4, function(I2, P2, N3) {
        M2 !== "none" && (I2 === "leave" || M2.indexOf(I2) >= 0) && N3({ type: "updateAxisPointer", currTrigger: I2, x: P2 && P2.offsetX, y: P2 && P2.offsetY });
      });
    }, i.prototype.remove = function(t2, h) {
      Nte("axisPointer", h);
    }, i.prototype.dispose = function(t2, h) {
      Nte("axisPointer", h);
    }, i.type = "axisPointer", i;
  }(W0), PMr = kMr;
  function hqe(f2, i) {
    var t2 = [], h = f2.seriesIndex, v4;
    if (h == null || !(v4 = i.getSeriesByIndex(h)))
      return { point: [] };
    var _ = v4.getData(), M2 = vU(_, f2);
    if (M2 == null || M2 < 0 || Za2(M2))
      return { point: [] };
    var I2 = _.getItemGraphicEl(M2), P2 = v4.coordinateSystem;
    if (v4.getTooltipPosition)
      t2 = v4.getTooltipPosition(M2) || [];
    else if (P2 && P2.dataToPoint)
      if (f2.isStacked) {
        var N3 = P2.getBaseAxis(), z3 = P2.getOtherAxis(N3), H2 = z3.dim, $ = N3.dim, et = H2 === "x" || H2 === "radius" ? 1 : 0, at = _.mapDimension($), ht = [];
        ht[et] = _.get(at, M2), ht[1 - et] = _.get(_.getCalculationInfo("stackResultDimension"), M2), t2 = P2.dataToPoint(ht) || [];
      } else
        t2 = P2.dataToPoint(_.getValues(Xa2(P2.dimensions, function(_t) {
          return _.mapDimension(_t);
        }), M2)) || [];
    else if (I2) {
      var bt = I2.getBoundingRect().clone();
      bt.applyTransform(I2.transform), t2 = [bt.x + bt.width / 2, bt.y + bt.height / 2];
    }
    return { point: t2, el: I2 };
  }
  var F7e = Wh2();
  function LMr(f2, i, t2) {
    var h = f2.currTrigger, v4 = [f2.x, f2.y], _ = f2, M2 = f2.dispatchAction || ks(t2.dispatchAction, t2), I2 = i.getComponent("axisPointer").coordSysAxesInfo;
    if (!!I2) {
      eEt(v4) && (v4 = hqe({ seriesIndex: _.seriesIndex, dataIndex: _.dataIndex }, i).point);
      var P2 = eEt(v4), N3 = _.axesInfo, z3 = I2.axesInfo, H2 = h === "leave" || eEt(v4), $ = {}, et = {}, at = { list: [], map: {} }, ht = { showPointer: Ou(RMr, et), showTooltip: Ou(NMr, at) };
      Qe2(I2.coordSysMap, function(_t, Et) {
        var zt = P2 || _t.containPoint(v4);
        Qe2(I2.coordSysAxesInfo[Et], function(Ft, fe2) {
          var re2 = Ft.axis, ye = zMr(N3, Ft);
          if (!H2 && zt && (!N3 || ye)) {
            var me2 = ye && ye.value;
            me2 == null && !P2 && (me2 = re2.pointToData(v4)), me2 != null && V7e(Ft, me2, ht, false, $);
          }
        });
      });
      var bt = {};
      return Qe2(z3, function(_t, Et) {
        var zt = _t.linkGroup;
        zt && !et[Et] && Qe2(zt.axesInfo, function(Ft, fe2) {
          var re2 = et[fe2];
          if (Ft !== _t && re2) {
            var ye = re2.value;
            zt.mapper && (ye = _t.axis.scale.parse(zt.mapper(ye, B7e(Ft), B7e(_t)))), bt[_t.key] = ye;
          }
        });
      }), Qe2(bt, function(_t, Et) {
        V7e(z3[Et], _t, ht, true, $);
      }), FMr(et, z3, $), VMr(at, v4, f2, M2), BMr(z3, M2, t2), $;
    }
  }
  function V7e(f2, i, t2, h, v4) {
    var _ = f2.axis;
    if (!(_.scale.isBlank() || !_.containData(i))) {
      if (!f2.involveSeries) {
        t2.showPointer(f2, i);
        return;
      }
      var M2 = OMr(i, f2), I2 = M2.payloadBatch, P2 = M2.snapToValue;
      I2[0] && v4.seriesIndex == null && ba2(v4, I2[0]), !h && f2.snap && _.containData(P2) && P2 != null && (i = P2), t2.showPointer(f2, i, I2), t2.showTooltip(f2, M2, P2);
    }
  }
  function OMr(f2, i) {
    var t2 = i.axis, h = t2.dim, v4 = f2, _ = [], M2 = Number.MAX_VALUE, I2 = -1;
    return Qe2(i.seriesModels, function(P2, N3) {
      var z3 = P2.getData().mapDimensionsAll(h), H2, $;
      if (P2.getAxisTooltipData) {
        var et = P2.getAxisTooltipData(z3, f2, t2);
        $ = et.dataIndices, H2 = et.nestestValue;
      } else {
        if ($ = P2.getData().indicesOfNearest(z3[0], f2, t2.type === "category" ? 0.5 : null), !$.length)
          return;
        H2 = P2.getData().get(z3[0], $[0]);
      }
      if (!(H2 == null || !isFinite(H2))) {
        var at = f2 - H2, ht = Math.abs(at);
        ht <= M2 && ((ht < M2 || at >= 0 && I2 < 0) && (M2 = ht, I2 = at, v4 = H2, _.length = 0), Qe2($, function(bt) {
          _.push({ seriesIndex: P2.seriesIndex, dataIndexInside: bt, dataIndex: P2.getData().getRawIndex(bt) });
        }));
      }
    }), { payloadBatch: _, snapToValue: v4 };
  }
  function RMr(f2, i, t2, h) {
    f2[i.key] = { value: t2, payloadBatch: h };
  }
  function NMr(f2, i, t2, h) {
    var v4 = t2.payloadBatch, _ = i.axis, M2 = _.model, I2 = i.axisPointerModel;
    if (!(!i.triggerTooltip || !v4.length)) {
      var P2 = i.coordSys.model, N3 = hgt(P2), z3 = f2.map[N3];
      z3 || (z3 = f2.map[N3] = { coordSysId: P2.id, coordSysIndex: P2.componentIndex, coordSysType: P2.type, coordSysMainType: P2.mainType, dataByAxis: [] }, f2.list.push(z3)), z3.dataByAxis.push({ axisDim: _.dim, axisIndex: M2.componentIndex, axisType: M2.type, axisId: M2.id, value: h, valueLabelOpt: { precision: I2.get(["label", "precision"]), formatter: I2.get(["label", "formatter"]) }, seriesDataIndices: v4.slice() });
    }
  }
  function FMr(f2, i, t2) {
    var h = t2.axesInfo = [];
    Qe2(i, function(v4, _) {
      var M2 = v4.axisPointerModel.option, I2 = f2[_];
      I2 ? (!v4.useHandle && (M2.status = "show"), M2.value = I2.value, M2.seriesDataIndices = (I2.payloadBatch || []).slice()) : !v4.useHandle && (M2.status = "hide"), M2.status === "show" && h.push({ axisDim: v4.axis.dim, axisIndex: v4.axis.model.componentIndex, value: M2.value });
    });
  }
  function VMr(f2, i, t2, h) {
    if (eEt(i) || !f2.list.length) {
      h({ type: "hideTip" });
      return;
    }
    var v4 = ((f2.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
    h({ type: "showTip", escapeConnect: true, x: i[0], y: i[1], tooltipOption: t2.tooltipOption, position: t2.position, dataIndexInside: v4.dataIndexInside, dataIndex: v4.dataIndex, seriesIndex: v4.seriesIndex, dataByCoordSys: f2.list });
  }
  function BMr(f2, i, t2) {
    var h = t2.getZr(), v4 = "axisPointerLastHighlights", _ = F7e(h)[v4] || {}, M2 = F7e(h)[v4] = {};
    Qe2(f2, function(N3, z3) {
      var H2 = N3.axisPointerModel.option;
      H2.status === "show" && Qe2(H2.seriesDataIndices, function($) {
        var et = $.seriesIndex + " | " + $.dataIndex;
        M2[et] = $;
      });
    });
    var I2 = [], P2 = [];
    Qe2(_, function(N3, z3) {
      !M2[z3] && P2.push(N3);
    }), Qe2(M2, function(N3, z3) {
      !_[z3] && I2.push(N3);
    }), P2.length && t2.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: P2 }), I2.length && t2.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: I2 });
  }
  function zMr(f2, i) {
    for (var t2 = 0; t2 < (f2 || []).length; t2++) {
      var h = f2[t2];
      if (i.axis.dim === h.axisDim && i.axis.model.componentIndex === h.axisIndex)
        return h;
    }
  }
  function B7e(f2) {
    var i = f2.axis.model, t2 = {}, h = t2.axisDim = f2.axis.dim;
    return t2.axisIndex = t2[h + "AxisIndex"] = i.componentIndex, t2.axisName = t2[h + "AxisName"] = i.name, t2.axisId = t2[h + "AxisId"] = i.id, t2;
  }
  function eEt(f2) {
    return !f2 || f2[0] == null || isNaN(f2[0]) || f2[1] == null || isNaN(f2[1]);
  }
  function Ugt(f2) {
    TU.registerAxisPointerClass("CartesianAxisPointer", SMr), f2.registerComponentModel(CMr), f2.registerComponentView(PMr), f2.registerPreprocessor(function(i) {
      if (i) {
        (!i.axisPointer || i.axisPointer.length === 0) && (i.axisPointer = {});
        var t2 = i.axisPointer.link;
        t2 && !Za2(t2) && (i.axisPointer.link = [t2]);
      }
    }), f2.registerProcessor(f2.PRIORITY.PROCESSOR.STATISTIC, function(i, t2) {
      i.getComponent("axisPointer").coordSysAxesInfo = Imr(i, t2);
    }), f2.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, LMr);
  }
  function jMr(f2) {
    zc2(FHe), zc2(Ugt);
  }
  var WMr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.makeElOption = function(t2, h, v4, _, M2) {
      var I2 = v4.axis;
      I2.dim === "angle" && (this.animationThreshold = Math.PI / 18);
      var P2 = I2.polar, N3 = P2.getOtherAxis(I2), z3 = N3.getExtent(), H2 = I2.dataToCoord(h), $ = _.get("type");
      if ($ && $ !== "none") {
        var et = rre(_), at = HMr[$](I2, P2, H2, z3);
        at.style = et, t2.graphicKey = at.type, t2.pointer = at;
      }
      var ht = _.get(["label", "margin"]), bt = GMr(h, v4, _, P2, ht);
      sqe(t2, v4, _, M2, bt);
    }, i;
  }(nre);
  function GMr(f2, i, t2, h, v4) {
    var _ = i.axis, M2 = _.dataToCoord(f2), I2 = h.getAngleAxis().getExtent()[0];
    I2 = I2 / 180 * Math.PI;
    var P2 = h.getRadiusAxis().getExtent(), N3, z3, H2;
    if (_.dim === "radius") {
      var $ = nE();
      SU($, $, I2), jL($, $, [h.cx, h.cy]), N3 = C5([M2, -v4], $);
      var et = i.getModel("axisLabel").get("rotate") || 0, at = nN.innerTextLayout(I2, et * Math.PI / 180, -1);
      z3 = at.textAlign, H2 = at.textVerticalAlign;
    } else {
      var ht = P2[1];
      N3 = h.coordToPoint([ht + v4, M2]);
      var bt = h.cx, _t = h.cy;
      z3 = Math.abs(N3[0] - bt) / ht < 0.3 ? "center" : N3[0] > bt ? "left" : "right", H2 = Math.abs(N3[1] - _t) / ht < 0.3 ? "middle" : N3[1] > _t ? "top" : "bottom";
    }
    return { position: N3, align: z3, verticalAlign: H2 };
  }
  var HMr = { line: function(f2, i, t2, h) {
    return f2.dim === "angle" ? { type: "Line", shape: are(i.coordToPoint([h[0], t2]), i.coordToPoint([h[1], t2])) } : { type: "Circle", shape: { cx: i.cx, cy: i.cy, r: t2 } };
  }, shadow: function(f2, i, t2, h) {
    var v4 = Math.max(1, f2.getBandWidth()), _ = Math.PI / 180;
    return f2.dim === "angle" ? { type: "Sector", shape: L7e(i.cx, i.cy, h[0], h[1], (-t2 - v4 / 2) * _, (-t2 + v4 / 2) * _) } : { type: "Sector", shape: L7e(i.cx, i.cy, t2 - v4 / 2, t2 + v4 / 2, 0, Math.PI * 2) };
  } }, UMr = WMr, qMr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.findAxisModel = function(t2) {
      var h, v4 = this.ecModel;
      return v4.eachComponent(t2, function(_) {
        _.getCoordSysModel() === this && (h = _);
      }, this), h;
    }, i.type = "polar", i.dependencies = ["radiusAxis", "angleAxis"], i.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, i;
  }(zh2), ZMr = qMr, ore = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("polar", _m).models[0];
    }, i.type = "polarAxis", i;
  }(zh2);
  Sm(ore, Fgt);
  var $Mr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "angleAxis", i;
  }(ore), YMr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "radiusAxis", i;
  }(ore), sre = function(f2) {
    ii2(i, f2);
    function i(t2, h) {
      return f2.call(this, "radius", t2, h) || this;
    }
    return i.prototype.pointToData = function(t2, h) {
      return this.polar.pointToData(t2, h)[this.dim === "radius" ? 0 : 1];
    }, i;
  }(D5);
  sre.prototype.dataToRadius = D5.prototype.dataToCoord;
  sre.prototype.radiusToData = D5.prototype.coordToData;
  var KMr = sre, XMr = Wh2(), lre = function(f2) {
    ii2(i, f2);
    function i(t2, h) {
      return f2.call(this, "angle", t2, h || [0, 360]) || this;
    }
    return i.prototype.pointToData = function(t2, h) {
      return this.polar.pointToData(t2, h)[this.dim === "radius" ? 0 : 1];
    }, i.prototype.calculateCategoryInterval = function() {
      var t2 = this, h = t2.getLabelModel(), v4 = t2.scale, _ = v4.getExtent(), M2 = v4.count();
      if (_[1] - _[0] < 1)
        return 0;
      var I2 = _[0], P2 = t2.dataToCoord(I2 + 1) - t2.dataToCoord(I2), N3 = Math.abs(P2), z3 = Cgt(I2 == null ? "" : I2 + "", h.getFont(), "center", "top"), H2 = Math.max(z3.height, 7), $ = H2 / N3;
      isNaN($) && ($ = 1 / 0);
      var et = Math.max(0, Math.floor($)), at = XMr(t2.model), ht = at.lastAutoInterval, bt = at.lastTickCount;
      return ht != null && bt != null && Math.abs(ht - et) <= 1 && Math.abs(bt - M2) <= 1 && ht > et ? et = ht : (at.lastTickCount = M2, at.lastAutoInterval = et), et;
    }, i;
  }(D5);
  lre.prototype.dataToAngle = D5.prototype.dataToCoord;
  lre.prototype.angleToData = D5.prototype.coordToData;
  var QMr = lre, pqe = ["radius", "angle"], JMr = function() {
    function f2(i) {
      this.dimensions = pqe, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new KMr(), this._angleAxis = new QMr(), this.axisPointerEnabled = true, this.name = i || "", this._radiusAxis.polar = this._angleAxis.polar = this;
    }
    return f2.prototype.containPoint = function(i) {
      var t2 = this.pointToCoord(i);
      return this._radiusAxis.contain(t2[0]) && this._angleAxis.contain(t2[1]);
    }, f2.prototype.containData = function(i) {
      return this._radiusAxis.containData(i[0]) && this._angleAxis.containData(i[1]);
    }, f2.prototype.getAxis = function(i) {
      var t2 = "_" + i + "Axis";
      return this[t2];
    }, f2.prototype.getAxes = function() {
      return [this._radiusAxis, this._angleAxis];
    }, f2.prototype.getAxesByScale = function(i) {
      var t2 = [], h = this._angleAxis, v4 = this._radiusAxis;
      return h.scale.type === i && t2.push(h), v4.scale.type === i && t2.push(v4), t2;
    }, f2.prototype.getAngleAxis = function() {
      return this._angleAxis;
    }, f2.prototype.getRadiusAxis = function() {
      return this._radiusAxis;
    }, f2.prototype.getOtherAxis = function(i) {
      var t2 = this._angleAxis;
      return i === t2 ? this._radiusAxis : t2;
    }, f2.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
    }, f2.prototype.getTooltipAxes = function(i) {
      var t2 = i != null && i !== "auto" ? this.getAxis(i) : this.getBaseAxis();
      return { baseAxes: [t2], otherAxes: [this.getOtherAxis(t2)] };
    }, f2.prototype.dataToPoint = function(i, t2) {
      return this.coordToPoint([this._radiusAxis.dataToRadius(i[0], t2), this._angleAxis.dataToAngle(i[1], t2)]);
    }, f2.prototype.pointToData = function(i, t2) {
      var h = this.pointToCoord(i);
      return [this._radiusAxis.radiusToData(h[0], t2), this._angleAxis.angleToData(h[1], t2)];
    }, f2.prototype.pointToCoord = function(i) {
      var t2 = i[0] - this.cx, h = i[1] - this.cy, v4 = this.getAngleAxis(), _ = v4.getExtent(), M2 = Math.min(_[0], _[1]), I2 = Math.max(_[0], _[1]);
      v4.inverse ? M2 = I2 - 360 : I2 = M2 + 360;
      var P2 = Math.sqrt(t2 * t2 + h * h);
      t2 /= P2, h /= P2;
      for (var N3 = Math.atan2(-h, t2) / Math.PI * 180, z3 = N3 < M2 ? 1 : -1; N3 < M2 || N3 > I2; )
        N3 += z3 * 360;
      return [P2, N3];
    }, f2.prototype.coordToPoint = function(i) {
      var t2 = i[0], h = i[1] / 180 * Math.PI, v4 = Math.cos(h) * t2 + this.cx, _ = -Math.sin(h) * t2 + this.cy;
      return [v4, _];
    }, f2.prototype.getArea = function() {
      var i = this.getAngleAxis(), t2 = this.getRadiusAxis(), h = t2.getExtent().slice();
      h[0] > h[1] && h.reverse();
      var v4 = i.getExtent(), _ = Math.PI / 180;
      return { cx: this.cx, cy: this.cy, r0: h[0], r: h[1], startAngle: -v4[0] * _, endAngle: -v4[1] * _, clockwise: i.inverse, contain: function(M2, I2) {
        var P2 = M2 - this.cx, N3 = I2 - this.cy, z3 = P2 * P2 + N3 * N3 - 1e-4, H2 = this.r, $ = this.r0;
        return z3 <= H2 * H2 && z3 >= $ * $;
      } };
    }, f2.prototype.convertToPixel = function(i, t2, h) {
      var v4 = z7e(t2);
      return v4 === this ? this.dataToPoint(h) : null;
    }, f2.prototype.convertFromPixel = function(i, t2, h) {
      var v4 = z7e(t2);
      return v4 === this ? this.pointToData(h) : null;
    }, f2;
  }();
  function z7e(f2) {
    var i = f2.seriesModel, t2 = f2.polarModel;
    return t2 && t2.coordinateSystem || i && i.coordinateSystem;
  }
  var tCr = JMr;
  function eCr(f2, i, t2) {
    var h = i.get("center"), v4 = t2.getWidth(), _ = t2.getHeight();
    f2.cx = cs(h[0], v4), f2.cy = cs(h[1], _);
    var M2 = f2.getRadiusAxis(), I2 = Math.min(v4, _) / 2, P2 = i.get("radius");
    P2 == null ? P2 = [0, "100%"] : Za2(P2) || (P2 = [0, P2]);
    var N3 = [cs(P2[0], I2), cs(P2[1], I2)];
    M2.inverse ? M2.setExtent(N3[1], N3[0]) : M2.setExtent(N3[0], N3[1]);
  }
  function nCr(f2, i) {
    var t2 = this, h = t2.getAngleAxis(), v4 = t2.getRadiusAxis();
    if (h.scale.setExtent(1 / 0, -1 / 0), v4.scale.setExtent(1 / 0, -1 / 0), f2.eachSeries(function(I2) {
      if (I2.coordinateSystem === t2) {
        var P2 = I2.getData();
        Qe2(kEt(P2, "radius"), function(N3) {
          v4.scale.unionExtentFromData(P2, N3);
        }), Qe2(kEt(P2, "angle"), function(N3) {
          h.scale.unionExtentFromData(P2, N3);
        });
      }
    }), Htt(h.scale, h.model), Htt(v4.scale, v4.model), h.type === "category" && !h.onBand) {
      var _ = h.getExtent(), M2 = 360 / h.scale.count();
      h.inverse ? _[1] += M2 : _[1] -= M2, h.setExtent(_[0], _[1]);
    }
  }
  function rCr(f2) {
    return f2.mainType === "angleAxis";
  }
  function j7e(f2, i) {
    if (f2.type = i.get("type"), f2.scale = Rkt(i), f2.onBand = i.get("boundaryGap") && f2.type === "category", f2.inverse = i.get("inverse"), rCr(i)) {
      f2.inverse = f2.inverse !== i.get("clockwise");
      var t2 = i.get("startAngle");
      f2.setExtent(t2, t2 + (f2.inverse ? -360 : 360));
    }
    i.axis = f2, f2.model = i;
  }
  var iCr = { dimensions: pqe, create: function(f2, i) {
    var t2 = [];
    return f2.eachComponent("polar", function(h, v4) {
      var _ = new tCr(v4 + "");
      _.update = nCr;
      var M2 = _.getRadiusAxis(), I2 = _.getAngleAxis(), P2 = h.findAxisModel("radiusAxis"), N3 = h.findAxisModel("angleAxis");
      j7e(M2, P2), j7e(I2, N3), eCr(_, h, i), t2.push(_), h.coordinateSystem = _, _.model = h;
    }), f2.eachSeries(function(h) {
      if (h.get("coordinateSystem") === "polar") {
        var v4 = h.getReferringComponents("polar", _m).models[0];
        h.coordinateSystem = v4.coordinateSystem;
      }
    }), t2;
  } }, aCr = iCr, oCr = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
  function SDt(f2, i, t2) {
    i[1] > i[0] && (i = i.slice().reverse());
    var h = f2.coordToPoint([i[0], t2]), v4 = f2.coordToPoint([i[1], t2]);
    return { x1: h[0], y1: h[1], x2: v4[0], y2: v4[1] };
  }
  function MDt(f2) {
    var i = f2.getRadiusAxis();
    return i.inverse ? 0 : 1;
  }
  function W7e(f2) {
    var i = f2[0], t2 = f2[f2.length - 1];
    i && t2 && Math.abs(Math.abs(i.coord - t2.coord) - 360) < 1e-4 && f2.pop();
  }
  var sCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.axisPointerClass = "PolarAxisPointer", t2;
    }
    return i.prototype.render = function(t2, h) {
      if (this.group.removeAll(), !!t2.get("show")) {
        var v4 = t2.axis, _ = v4.polar, M2 = _.getRadiusAxis().getExtent(), I2 = v4.getTicksCoords(), P2 = v4.getMinorTicksCoords(), N3 = Xa2(v4.getViewLabels(), function(z3) {
          z3 = pu(z3);
          var H2 = v4.scale, $ = H2.type === "ordinal" ? H2.getRawOrdinalNumber(z3.tickValue) : z3.tickValue;
          return z3.coord = v4.dataToCoord($), z3;
        });
        W7e(N3), W7e(I2), Qe2(oCr, function(z3) {
          t2.get([z3, "show"]) && (!v4.scale.isBlank() || z3 === "axisLine") && lCr[z3](this.group, t2, _, I2, P2, M2, N3);
        }, this);
      }
    }, i.type = "angleAxis", i;
  }(TU), lCr = { axisLine: function(f2, i, t2, h, v4, _) {
    var M2 = i.getModel(["axisLine", "lineStyle"]), I2 = MDt(t2), P2 = I2 ? 0 : 1, N3;
    _[P2] === 0 ? N3 = new UL({ shape: { cx: t2.cx, cy: t2.cy, r: _[I2] }, style: M2.getLineStyle(), z2: 1, silent: true }) : N3 = new ykt({ shape: { cx: t2.cx, cy: t2.cy, r: _[I2], r0: _[P2] }, style: M2.getLineStyle(), z2: 1, silent: true }), N3.style.fill = null, f2.add(N3);
  }, axisTick: function(f2, i, t2, h, v4, _) {
    var M2 = i.getModel("axisTick"), I2 = (M2.get("inside") ? -1 : 1) * M2.get("length"), P2 = _[MDt(t2)], N3 = Xa2(h, function(z3) {
      return new m_({ shape: SDt(t2, [P2, P2 + I2], z3.coord) });
    });
    f2.add(KD(N3, { style: Ul(M2.getModel("lineStyle").getLineStyle(), { stroke: i.get(["axisLine", "lineStyle", "color"]) }) }));
  }, minorTick: function(f2, i, t2, h, v4, _) {
    if (!!v4.length) {
      for (var M2 = i.getModel("axisTick"), I2 = i.getModel("minorTick"), P2 = (M2.get("inside") ? -1 : 1) * I2.get("length"), N3 = _[MDt(t2)], z3 = [], H2 = 0; H2 < v4.length; H2++)
        for (var $ = 0; $ < v4[H2].length; $++)
          z3.push(new m_({ shape: SDt(t2, [N3, N3 + P2], v4[H2][$].coord) }));
      f2.add(KD(z3, { style: Ul(I2.getModel("lineStyle").getLineStyle(), Ul(M2.getLineStyle(), { stroke: i.get(["axisLine", "lineStyle", "color"]) })) }));
    }
  }, axisLabel: function(f2, i, t2, h, v4, _, M2) {
    var I2 = i.getCategories(true), P2 = i.getModel("axisLabel"), N3 = P2.get("margin"), z3 = i.get("triggerEvent");
    Qe2(M2, function(H2, $) {
      var et = P2, at = H2.tickValue, ht = _[MDt(t2)], bt = t2.coordToPoint([ht + N3, H2.coord]), _t = t2.cx, Et = t2.cy, zt = Math.abs(bt[0] - _t) / ht < 0.3 ? "center" : bt[0] > _t ? "left" : "right", Ft = Math.abs(bt[1] - Et) / ht < 0.3 ? "middle" : bt[1] > Et ? "top" : "bottom";
      if (I2 && I2[at]) {
        var fe2 = I2[at];
        Xl(fe2) && fe2.textStyle && (et = new Gg2(fe2.textStyle, P2, P2.ecModel));
      }
      var re2 = new op({ silent: nN.isLabelSilent(i), style: By(et, { x: bt[0], y: bt[1], fill: et.getTextColor() || i.get(["axisLine", "lineStyle", "color"]), text: H2.formattedLabel, align: zt, verticalAlign: Ft }) });
      if (f2.add(re2), z3) {
        var ye = nN.makeAxisEventDataBase(i);
        ye.targetType = "axisLabel", ye.value = H2.rawLabel, Du(re2).eventData = ye;
      }
    }, this);
  }, splitLine: function(f2, i, t2, h, v4, _) {
    var M2 = i.getModel("splitLine"), I2 = M2.getModel("lineStyle"), P2 = I2.get("color"), N3 = 0;
    P2 = P2 instanceof Array ? P2 : [P2];
    for (var z3 = [], H2 = 0; H2 < h.length; H2++) {
      var $ = N3++ % P2.length;
      z3[$] = z3[$] || [], z3[$].push(new m_({ shape: SDt(t2, _, h[H2].coord) }));
    }
    for (var H2 = 0; H2 < z3.length; H2++)
      f2.add(KD(z3[H2], { style: Ul({ stroke: P2[H2 % P2.length] }, I2.getLineStyle()), silent: true, z: i.get("z") }));
  }, minorSplitLine: function(f2, i, t2, h, v4, _) {
    if (!!v4.length) {
      for (var M2 = i.getModel("minorSplitLine"), I2 = M2.getModel("lineStyle"), P2 = [], N3 = 0; N3 < v4.length; N3++)
        for (var z3 = 0; z3 < v4[N3].length; z3++)
          P2.push(new m_({ shape: SDt(t2, _, v4[N3][z3].coord) }));
      f2.add(KD(P2, { style: I2.getLineStyle(), silent: true, z: i.get("z") }));
    }
  }, splitArea: function(f2, i, t2, h, v4, _) {
    if (!!h.length) {
      var M2 = i.getModel("splitArea"), I2 = M2.getModel("areaStyle"), P2 = I2.get("color"), N3 = 0;
      P2 = P2 instanceof Array ? P2 : [P2];
      for (var z3 = [], H2 = Math.PI / 180, $ = -h[0].coord * H2, et = Math.min(_[0], _[1]), at = Math.max(_[0], _[1]), ht = i.get("clockwise"), bt = 1, _t = h.length; bt <= _t; bt++) {
        var Et = bt === _t ? h[0].coord : h[bt].coord, zt = N3++ % P2.length;
        z3[zt] = z3[zt] || [], z3[zt].push(new rC({ shape: { cx: t2.cx, cy: t2.cy, r0: et, r: at, startAngle: $, endAngle: -Et * H2, clockwise: ht }, silent: true })), $ = -Et * H2;
      }
      for (var bt = 0; bt < z3.length; bt++)
        f2.add(KD(z3[bt], { style: Ul({ fill: P2[bt % P2.length] }, I2.getAreaStyle()), silent: true }));
    }
  } }, uCr = sCr, cCr = ["axisLine", "axisTickLabel", "axisName"], fCr = ["splitLine", "splitArea", "minorSplitLine"], hCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.axisPointerClass = "PolarAxisPointer", t2;
    }
    return i.prototype.render = function(t2, h) {
      if (this.group.removeAll(), !!t2.get("show")) {
        var v4 = this._axisGroup, _ = this._axisGroup = new mu();
        this.group.add(_);
        var M2 = t2.axis, I2 = M2.polar, P2 = I2.getAngleAxis(), N3 = M2.getTicksCoords(), z3 = M2.getMinorTicksCoords(), H2 = P2.getExtent()[0], $ = M2.getExtent(), et = dCr(I2, t2, H2), at = new nN(t2, et);
        Qe2(cCr, at.add, at), _.add(at.getGroup()), Dgt(v4, _, t2), Qe2(fCr, function(ht) {
          t2.get([ht, "show"]) && !M2.scale.isBlank() && pCr[ht](this.group, t2, I2, H2, $, N3, z3);
        }, this);
      }
    }, i.type = "radiusAxis", i;
  }(TU), pCr = { splitLine: function(f2, i, t2, h, v4, _) {
    var M2 = i.getModel("splitLine"), I2 = M2.getModel("lineStyle"), P2 = I2.get("color"), N3 = 0;
    P2 = P2 instanceof Array ? P2 : [P2];
    for (var z3 = [], H2 = 0; H2 < _.length; H2++) {
      var $ = N3++ % P2.length;
      z3[$] = z3[$] || [], z3[$].push(new UL({ shape: { cx: t2.cx, cy: t2.cy, r: _[H2].coord } }));
    }
    for (var H2 = 0; H2 < z3.length; H2++)
      f2.add(KD(z3[H2], { style: Ul({ stroke: P2[H2 % P2.length], fill: null }, I2.getLineStyle()), silent: true }));
  }, minorSplitLine: function(f2, i, t2, h, v4, _, M2) {
    if (!!M2.length) {
      for (var I2 = i.getModel("minorSplitLine"), P2 = I2.getModel("lineStyle"), N3 = [], z3 = 0; z3 < M2.length; z3++)
        for (var H2 = 0; H2 < M2[z3].length; H2++)
          N3.push(new UL({ shape: { cx: t2.cx, cy: t2.cy, r: M2[z3][H2].coord } }));
      f2.add(KD(N3, { style: Ul({ fill: null }, P2.getLineStyle()), silent: true }));
    }
  }, splitArea: function(f2, i, t2, h, v4, _) {
    if (!!_.length) {
      var M2 = i.getModel("splitArea"), I2 = M2.getModel("areaStyle"), P2 = I2.get("color"), N3 = 0;
      P2 = P2 instanceof Array ? P2 : [P2];
      for (var z3 = [], H2 = _[0].coord, $ = 1; $ < _.length; $++) {
        var et = N3++ % P2.length;
        z3[et] = z3[et] || [], z3[et].push(new rC({ shape: { cx: t2.cx, cy: t2.cy, r0: H2, r: _[$].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), H2 = _[$].coord;
      }
      for (var $ = 0; $ < z3.length; $++)
        f2.add(KD(z3[$], { style: Ul({ fill: P2[$ % P2.length] }, I2.getAreaStyle()), silent: true }));
    }
  } };
  function dCr(f2, i, t2) {
    return { position: [f2.cx, f2.cy], rotation: t2 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: i.getModel("axisLabel").get("rotate"), z2: 1 };
  }
  var gCr = hCr;
  function dqe(f2) {
    return f2.get("stack") || "__ec_stack_" + f2.seriesIndex;
  }
  function gqe(f2, i) {
    return i.dim + f2.model.componentIndex;
  }
  function vCr(f2, i, t2) {
    var h = {}, v4 = yCr(Ld2(i.getSeriesByType(f2), function(_) {
      return !i.isSeriesFiltered(_) && _.coordinateSystem && _.coordinateSystem.type === "polar";
    }));
    i.eachSeriesByType(f2, function(_) {
      if (_.coordinateSystem.type === "polar") {
        var M2 = _.getData(), I2 = _.coordinateSystem, P2 = I2.getBaseAxis(), N3 = gqe(I2, P2), z3 = dqe(_), H2 = v4[N3][z3], $ = H2.offset, et = H2.width, at = I2.getOtherAxis(P2), ht = _.coordinateSystem.cx, bt = _.coordinateSystem.cy, _t = _.get("barMinHeight") || 0, Et = _.get("barMinAngle") || 0;
        h[z3] = h[z3] || [];
        for (var zt = M2.mapDimension(at.dim), Ft = M2.mapDimension(P2.dim), fe2 = tV(M2, zt), re2 = P2.dim !== "radius" || !_.get("roundCap", true), ye = at.dataToCoord(0), me2 = 0, be2 = M2.count(); me2 < be2; me2++) {
          var Te2 = M2.get(zt, me2), We = M2.get(Ft, me2), en = Te2 >= 0 ? "p" : "n", Ue2 = ye;
          fe2 && (h[z3][We] || (h[z3][We] = { p: ye, n: ye }), Ue2 = h[z3][We][en]);
          var Mn = void 0, Vn = void 0, xn = void 0, Zr = void 0;
          if (at.dim === "radius") {
            var nr = at.dataToCoord(Te2) - ye, pr = P2.dataToCoord(We);
            Math.abs(nr) < _t && (nr = (nr < 0 ? -1 : 1) * _t), Mn = Ue2, Vn = Ue2 + nr, xn = pr - $, Zr = xn - et, fe2 && (h[z3][We][en] = Vn);
          } else {
            var Nr = at.dataToCoord(Te2, re2) - ye, ai2 = P2.dataToCoord(We);
            Math.abs(Nr) < Et && (Nr = (Nr < 0 ? -1 : 1) * Et), Mn = ai2 + $, Vn = Mn + et, xn = Ue2, Zr = Ue2 + Nr, fe2 && (h[z3][We][en] = Zr);
          }
          M2.setItemLayout(me2, { cx: ht, cy: bt, r0: Mn, r: Vn, startAngle: -xn * Math.PI / 180, endAngle: -Zr * Math.PI / 180, clockwise: xn >= Zr });
        }
      }
    });
  }
  function yCr(f2) {
    var i = {};
    Qe2(f2, function(h, v4) {
      var _ = h.getData(), M2 = h.coordinateSystem, I2 = M2.getBaseAxis(), P2 = gqe(M2, I2), N3 = I2.getExtent(), z3 = I2.type === "category" ? I2.getBandWidth() : Math.abs(N3[1] - N3[0]) / _.count(), H2 = i[P2] || { bandWidth: z3, remainedWidth: z3, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, $ = H2.stacks;
      i[P2] = H2;
      var et = dqe(h);
      $[et] || H2.autoWidthCount++, $[et] = $[et] || { width: 0, maxWidth: 0 };
      var at = cs(h.get("barWidth"), z3), ht = cs(h.get("barMaxWidth"), z3), bt = h.get("barGap"), _t = h.get("barCategoryGap");
      at && !$[et].width && (at = Math.min(H2.remainedWidth, at), $[et].width = at, H2.remainedWidth -= at), ht && ($[et].maxWidth = ht), bt != null && (H2.gap = bt), _t != null && (H2.categoryGap = _t);
    });
    var t2 = {};
    return Qe2(i, function(h, v4) {
      t2[v4] = {};
      var _ = h.stacks, M2 = h.bandWidth, I2 = cs(h.categoryGap, M2), P2 = cs(h.gap, 1), N3 = h.remainedWidth, z3 = h.autoWidthCount, H2 = (N3 - I2) / (z3 + (z3 - 1) * P2);
      H2 = Math.max(H2, 0), Qe2(_, function(ht, bt) {
        var _t = ht.maxWidth;
        _t && _t < H2 && (_t = Math.min(_t, N3), ht.width && (_t = Math.min(_t, ht.width)), N3 -= _t, ht.width = _t, z3--);
      }), H2 = (N3 - I2) / (z3 + (z3 - 1) * P2), H2 = Math.max(H2, 0);
      var $ = 0, et;
      Qe2(_, function(ht, bt) {
        ht.width || (ht.width = H2), et = ht, $ += ht.width * (1 + P2);
      }), et && ($ -= et.width * P2);
      var at = -$ / 2;
      Qe2(_, function(ht, bt) {
        t2[v4][bt] = t2[v4][bt] || { offset: at, width: ht.width }, at += ht.width * (1 + P2);
      });
    }), t2;
  }
  var mCr = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, bCr = { splitNumber: 5 }, _Cr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "polar", i;
  }(W0);
  function xCr(f2) {
    zc2(Ugt), TU.registerAxisPointerClass("PolarAxisPointer", UMr), f2.registerCoordinateSystem("polar", aCr), f2.registerComponentModel(ZMr), f2.registerComponentView(_Cr), qtt(f2, "angle", $Mr, mCr), qtt(f2, "radius", YMr, bCr), f2.registerComponentView(uCr), f2.registerComponentView(gCr), f2.registerLayout(Ou(vCr, "bar"));
  }
  function Fte(f2, i) {
    i = i || {};
    var t2 = f2.coordinateSystem, h = f2.axis, v4 = {}, _ = h.position, M2 = h.orient, I2 = t2.getRect(), P2 = [I2.x, I2.x + I2.width, I2.y, I2.y + I2.height], N3 = { horizontal: { top: P2[2], bottom: P2[3] }, vertical: { left: P2[0], right: P2[1] } };
    v4.position = [M2 === "vertical" ? N3.vertical[_] : P2[0], M2 === "horizontal" ? N3.horizontal[_] : P2[3]];
    var z3 = { horizontal: 0, vertical: 1 };
    v4.rotation = Math.PI / 2 * z3[M2];
    var H2 = { top: -1, bottom: 1, right: 1, left: -1 };
    v4.labelDirection = v4.tickDirection = v4.nameDirection = H2[_], f2.get(["axisTick", "inside"]) && (v4.tickDirection = -v4.tickDirection), y_(i.labelInside, f2.get(["axisLabel", "inside"])) && (v4.labelDirection = -v4.labelDirection);
    var $ = i.rotate;
    return $ == null && ($ = f2.get(["axisLabel", "rotate"])), v4.labelRotation = _ === "top" ? -$ : $, v4.z2 = 1, v4;
  }
  var wCr = ["axisLine", "axisTickLabel", "axisName"], SCr = ["splitArea", "splitLine"], MCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.axisPointerClass = "SingleAxisPointer", t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      var M2 = this.group;
      M2.removeAll();
      var I2 = this._axisGroup;
      this._axisGroup = new mu();
      var P2 = Fte(t2), N3 = new nN(t2, P2);
      Qe2(wCr, N3.add, N3), M2.add(this._axisGroup), M2.add(N3.getGroup()), Qe2(SCr, function(z3) {
        t2.get([z3, "show"]) && CCr[z3](this, this.group, this._axisGroup, t2);
      }, this), Dgt(I2, this._axisGroup, t2), f2.prototype.render.call(this, t2, h, v4, _);
    }, i.prototype.remove = function() {
      OHe(this);
    }, i.type = "singleAxis", i;
  }(TU), CCr = { splitLine: function(f2, i, t2, h) {
    var v4 = h.axis;
    if (!v4.scale.isBlank()) {
      var _ = h.getModel("splitLine"), M2 = _.getModel("lineStyle"), I2 = M2.get("color");
      I2 = I2 instanceof Array ? I2 : [I2];
      for (var P2 = h.coordinateSystem.getRect(), N3 = v4.isHorizontal(), z3 = [], H2 = 0, $ = v4.getTicksCoords({ tickModel: _ }), et = [], at = [], ht = 0; ht < $.length; ++ht) {
        var bt = v4.toGlobalCoord($[ht].coord);
        N3 ? (et[0] = bt, et[1] = P2.y, at[0] = bt, at[1] = P2.y + P2.height) : (et[0] = P2.x, et[1] = bt, at[0] = P2.x + P2.width, at[1] = bt);
        var _t = H2++ % I2.length;
        z3[_t] = z3[_t] || [], z3[_t].push(new m_({ subPixelOptimize: true, shape: { x1: et[0], y1: et[1], x2: at[0], y2: at[1] }, silent: true }));
      }
      for (var Et = M2.getLineStyle(["color"]), ht = 0; ht < z3.length; ++ht)
        i.add(KD(z3[ht], { style: Ul({ stroke: I2[ht % I2.length] }, Et), silent: true }));
    }
  }, splitArea: function(f2, i, t2, h) {
    LHe(f2, t2, h, h);
  } }, TCr = MCr, vqe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.getCoordSysModel = function() {
      return this;
    }, i.type = "singleAxis", i.layoutMode = "box", i.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, i;
  }(zh2);
  Sm(vqe, Fgt.prototype);
  var RQt = vqe, ACr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _, M2) {
      var I2 = f2.call(this, t2, h, v4) || this;
      return I2.type = _ || "value", I2.position = M2 || "bottom", I2;
    }
    return i.prototype.isHorizontal = function() {
      var t2 = this.position;
      return t2 === "top" || t2 === "bottom";
    }, i.prototype.pointToData = function(t2, h) {
      return this.coordinateSystem.pointToData(t2)[0];
    }, i;
  }(D5), ICr = ACr, yqe = ["single"], DCr = function() {
    function f2(i, t2, h) {
      this.type = "single", this.dimension = "single", this.dimensions = yqe, this.axisPointerEnabled = true, this.model = i, this._init(i, t2, h);
    }
    return f2.prototype._init = function(i, t2, h) {
      var v4 = this.dimension, _ = new ICr(v4, Rkt(i), [0, 0], i.get("type"), i.get("position")), M2 = _.type === "category";
      _.onBand = M2 && i.get("boundaryGap"), _.inverse = i.get("inverse"), _.orient = i.get("orient"), i.axis = _, _.model = i, _.coordinateSystem = this, this._axis = _;
    }, f2.prototype.update = function(i, t2) {
      i.eachSeries(function(h) {
        if (h.coordinateSystem === this) {
          var v4 = h.getData();
          Qe2(v4.mapDimensionsAll(this.dimension), function(_) {
            this._axis.scale.unionExtentFromData(v4, _);
          }, this), Htt(this._axis.scale, this._axis.model);
        }
      }, this);
    }, f2.prototype.resize = function(i, t2) {
      this._rect = u1({ left: i.get("left"), top: i.get("top"), right: i.get("right"), bottom: i.get("bottom"), width: i.get("width"), height: i.get("height") }, { width: t2.getWidth(), height: t2.getHeight() }), this._adjustAxis();
    }, f2.prototype.getRect = function() {
      return this._rect;
    }, f2.prototype._adjustAxis = function() {
      var i = this._rect, t2 = this._axis, h = t2.isHorizontal(), v4 = h ? [0, i.width] : [0, i.height], _ = t2.reverse ? 1 : 0;
      t2.setExtent(v4[_], v4[1 - _]), this._updateAxisTransform(t2, h ? i.x : i.y);
    }, f2.prototype._updateAxisTransform = function(i, t2) {
      var h = i.getExtent(), v4 = h[0] + h[1], _ = i.isHorizontal();
      i.toGlobalCoord = _ ? function(M2) {
        return M2 + t2;
      } : function(M2) {
        return v4 - M2 + t2;
      }, i.toLocalCoord = _ ? function(M2) {
        return M2 - t2;
      } : function(M2) {
        return v4 - M2 + t2;
      };
    }, f2.prototype.getAxis = function() {
      return this._axis;
    }, f2.prototype.getBaseAxis = function() {
      return this._axis;
    }, f2.prototype.getAxes = function() {
      return [this._axis];
    }, f2.prototype.getTooltipAxes = function() {
      return { baseAxes: [this.getAxis()], otherAxes: [] };
    }, f2.prototype.containPoint = function(i) {
      var t2 = this.getRect(), h = this.getAxis(), v4 = h.orient;
      return v4 === "horizontal" ? h.contain(h.toLocalCoord(i[0])) && i[1] >= t2.y && i[1] <= t2.y + t2.height : h.contain(h.toLocalCoord(i[1])) && i[0] >= t2.y && i[0] <= t2.y + t2.height;
    }, f2.prototype.pointToData = function(i) {
      var t2 = this.getAxis();
      return [t2.coordToData(t2.toLocalCoord(i[t2.orient === "horizontal" ? 0 : 1]))];
    }, f2.prototype.dataToPoint = function(i) {
      var t2 = this.getAxis(), h = this.getRect(), v4 = [], _ = t2.orient === "horizontal" ? 0 : 1;
      return i instanceof Array && (i = i[0]), v4[_] = t2.toGlobalCoord(t2.dataToCoord(+i)), v4[1 - _] = _ === 0 ? h.y + h.height / 2 : h.x + h.width / 2, v4;
    }, f2.prototype.convertToPixel = function(i, t2, h) {
      var v4 = G7e(t2);
      return v4 === this ? this.dataToPoint(h) : null;
    }, f2.prototype.convertFromPixel = function(i, t2, h) {
      var v4 = G7e(t2);
      return v4 === this ? this.pointToData(h) : null;
    }, f2;
  }();
  function G7e(f2) {
    var i = f2.seriesModel, t2 = f2.singleAxisModel;
    return t2 && t2.coordinateSystem || i && i.coordinateSystem;
  }
  function ECr(f2, i) {
    var t2 = [];
    return f2.eachComponent("singleAxis", function(h, v4) {
      var _ = new DCr(h, f2, i);
      _.name = "single_" + v4, _.resize(h, i), h.coordinateSystem = _, t2.push(_);
    }), f2.eachSeries(function(h) {
      if (h.get("coordinateSystem") === "singleAxis") {
        var v4 = h.getReferringComponents("singleAxis", _m).models[0];
        h.coordinateSystem = v4 && v4.coordinateSystem;
      }
    }), t2;
  }
  var kCr = { create: ECr, dimensions: yqe }, PCr = kCr, H7e = ["x", "y"], LCr = ["width", "height"], OCr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.makeElOption = function(t2, h, v4, _, M2) {
      var I2 = v4.axis, P2 = I2.coordinateSystem, N3 = NQt(P2, 1 - qEt(I2)), z3 = P2.dataToPoint(h)[0], H2 = _.get("type");
      if (H2 && H2 !== "none") {
        var $ = rre(_), et = RCr[H2](I2, z3, N3);
        et.style = $, t2.graphicKey = et.type, t2.pointer = et;
      }
      var at = Fte(v4);
      uqe(h, t2, at, v4, _, M2);
    }, i.prototype.getHandleTransform = function(t2, h, v4) {
      var _ = Fte(h, { labelInside: false });
      _.labelMargin = v4.get(["handle", "margin"]);
      var M2 = ire(h.axis, t2, _);
      return { x: M2[0], y: M2[1], rotation: _.rotation + (_.labelDirection < 0 ? Math.PI : 0) };
    }, i.prototype.updateHandleTransform = function(t2, h, v4, _) {
      var M2 = v4.axis, I2 = M2.coordinateSystem, P2 = qEt(M2), N3 = NQt(I2, P2), z3 = [t2.x, t2.y];
      z3[P2] += h[P2], z3[P2] = Math.min(N3[1], z3[P2]), z3[P2] = Math.max(N3[0], z3[P2]);
      var H2 = NQt(I2, 1 - P2), $ = (H2[1] + H2[0]) / 2, et = [$, $];
      return et[P2] = z3[P2], { x: z3[0], y: z3[1], rotation: t2.rotation, cursorPoint: et, tooltipOption: { verticalAlign: "middle" } };
    }, i;
  }(nre), RCr = { line: function(f2, i, t2) {
    var h = are([i, t2[0]], [i, t2[1]], qEt(f2));
    return { type: "Line", subPixelOptimize: true, shape: h };
  }, shadow: function(f2, i, t2) {
    var h = f2.getBandWidth(), v4 = t2[1] - t2[0];
    return { type: "Rect", shape: cqe([i - h / 2, t2[0]], [h, v4], qEt(f2)) };
  } };
  function qEt(f2) {
    return f2.isHorizontal() ? 0 : 1;
  }
  function NQt(f2, i) {
    var t2 = f2.getRect();
    return [t2[H7e[i]], t2[H7e[i]] + t2[LCr[i]]];
  }
  var NCr = OCr, FCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "single", i;
  }(W0);
  function VCr(f2) {
    zc2(Ugt), TU.registerAxisPointerClass("SingleAxisPointer", NCr), f2.registerComponentView(FCr), f2.registerComponentView(TCr), f2.registerComponentModel(RQt), qtt(f2, "single", RQt, RQt.defaultOption), f2.registerCoordinateSystem("single", PCr);
  }
  var BCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      var _ = aet(t2);
      f2.prototype.init.apply(this, arguments), U7e(t2, _);
    }, i.prototype.mergeOption = function(t2) {
      f2.prototype.mergeOption.apply(this, arguments), U7e(this.option, t2);
    }, i.prototype.getCellSize = function() {
      return this.option.cellSize;
    }, i.type = "calendar", i.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, i;
  }(zh2);
  function U7e(f2, i) {
    var t2 = f2.cellSize, h;
    Za2(t2) ? h = t2 : h = f2.cellSize = [t2, t2], h.length === 1 && (h[1] = h[0]);
    var v4 = Xa2([0, 1], function(_) {
      return Uhr(i, _) && (h[_] = "auto"), h[_] != null && h[_] !== "auto";
    });
    J7(f2, i, { type: "box", ignoreSize: v4 });
  }
  var zCr = BCr, jCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _ = this.group;
      _.removeAll();
      var M2 = t2.coordinateSystem, I2 = M2.getRangeInfo(), P2 = M2.getOrient(), N3 = h.getLocaleModel();
      this._renderDayRect(t2, I2, _), this._renderLines(t2, I2, P2, _), this._renderYearText(t2, I2, P2, _), this._renderMonthText(t2, N3, P2, _), this._renderWeekText(t2, N3, I2, P2, _);
    }, i.prototype._renderDayRect = function(t2, h, v4) {
      for (var _ = t2.coordinateSystem, M2 = t2.getModel("itemStyle").getItemStyle(), I2 = _.getCellWidth(), P2 = _.getCellHeight(), N3 = h.start.time; N3 <= h.end.time; N3 = _.getNextNDay(N3, 1).time) {
        var z3 = _.dataToRect([N3], false).tl, H2 = new Sh2({ shape: { x: z3[0], y: z3[1], width: I2, height: P2 }, cursor: "default", style: M2 });
        v4.add(H2);
      }
    }, i.prototype._renderLines = function(t2, h, v4, _) {
      var M2 = this, I2 = t2.coordinateSystem, P2 = t2.getModel(["splitLine", "lineStyle"]).getLineStyle(), N3 = t2.get(["splitLine", "show"]), z3 = P2.lineWidth;
      this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
      for (var H2 = h.start, $ = 0; H2.time <= h.end.time; $++) {
        at(H2.formatedDate), $ === 0 && (H2 = I2.getDateInfo(h.start.y + "-" + h.start.m));
        var et = H2.date;
        et.setMonth(et.getMonth() + 1), H2 = I2.getDateInfo(et);
      }
      at(I2.getNextNDay(h.end.time, 1).formatedDate);
      function at(ht) {
        M2._firstDayOfMonth.push(I2.getDateInfo(ht)), M2._firstDayPoints.push(I2.dataToRect([ht], false).tl);
        var bt = M2._getLinePointsOfOneWeek(t2, ht, v4);
        M2._tlpoints.push(bt[0]), M2._blpoints.push(bt[bt.length - 1]), N3 && M2._drawSplitline(bt, P2, _);
      }
      N3 && this._drawSplitline(M2._getEdgesPoints(M2._tlpoints, z3, v4), P2, _), N3 && this._drawSplitline(M2._getEdgesPoints(M2._blpoints, z3, v4), P2, _);
    }, i.prototype._getEdgesPoints = function(t2, h, v4) {
      var _ = [t2[0].slice(), t2[t2.length - 1].slice()], M2 = v4 === "horizontal" ? 0 : 1;
      return _[0][M2] = _[0][M2] - h / 2, _[1][M2] = _[1][M2] + h / 2, _;
    }, i.prototype._drawSplitline = function(t2, h, v4) {
      var _ = new aC({ z2: 20, shape: { points: t2 }, style: h });
      v4.add(_);
    }, i.prototype._getLinePointsOfOneWeek = function(t2, h, v4) {
      for (var _ = t2.coordinateSystem, M2 = _.getDateInfo(h), I2 = [], P2 = 0; P2 < 7; P2++) {
        var N3 = _.getNextNDay(M2.time, P2), z3 = _.dataToRect([N3.time], false);
        I2[2 * N3.day] = z3.tl, I2[2 * N3.day + 1] = z3[v4 === "horizontal" ? "bl" : "tr"];
      }
      return I2;
    }, i.prototype._formatterLabel = function(t2, h) {
      return ms(t2) && t2 ? Whr(t2, h) : Ol(t2) ? t2(h) : h.nameMap;
    }, i.prototype._yearTextPositionControl = function(t2, h, v4, _, M2) {
      var I2 = h[0], P2 = h[1], N3 = ["center", "bottom"];
      _ === "bottom" ? (P2 += M2, N3 = ["center", "top"]) : _ === "left" ? I2 -= M2 : _ === "right" ? (I2 += M2, N3 = ["center", "top"]) : P2 -= M2;
      var z3 = 0;
      return (_ === "left" || _ === "right") && (z3 = Math.PI / 2), { rotation: z3, x: I2, y: P2, style: { align: N3[0], verticalAlign: N3[1] } };
    }, i.prototype._renderYearText = function(t2, h, v4, _) {
      var M2 = t2.getModel("yearLabel");
      if (!!M2.get("show")) {
        var I2 = M2.get("margin"), P2 = M2.get("position");
        P2 || (P2 = v4 !== "horizontal" ? "top" : "left");
        var N3 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], z3 = (N3[0][0] + N3[1][0]) / 2, H2 = (N3[0][1] + N3[1][1]) / 2, $ = v4 === "horizontal" ? 0 : 1, et = { top: [z3, N3[$][1]], bottom: [z3, N3[1 - $][1]], left: [N3[1 - $][0], H2], right: [N3[$][0], H2] }, at = h.start.y;
        +h.end.y > +h.start.y && (at = at + "-" + h.end.y);
        var ht = M2.get("formatter"), bt = { start: h.start.y, end: h.end.y, nameMap: at }, _t = this._formatterLabel(ht, bt), Et = new op({ z2: 30, style: By(M2, { text: _t }) });
        Et.attr(this._yearTextPositionControl(Et, et[P2], v4, P2, I2)), _.add(Et);
      }
    }, i.prototype._monthTextPositionControl = function(t2, h, v4, _, M2) {
      var I2 = "left", P2 = "top", N3 = t2[0], z3 = t2[1];
      return v4 === "horizontal" ? (z3 = z3 + M2, h && (I2 = "center"), _ === "start" && (P2 = "bottom")) : (N3 = N3 + M2, h && (P2 = "middle"), _ === "start" && (I2 = "right")), { x: N3, y: z3, align: I2, verticalAlign: P2 };
    }, i.prototype._renderMonthText = function(t2, h, v4, _) {
      var M2 = t2.getModel("monthLabel");
      if (!!M2.get("show")) {
        var I2 = M2.get("nameMap"), P2 = M2.get("margin"), N3 = M2.get("position"), z3 = M2.get("align"), H2 = [this._tlpoints, this._blpoints];
        (!I2 || ms(I2)) && (I2 && (h = ZJt(I2) || h), I2 = h.get(["time", "monthAbbr"]) || []);
        var $ = N3 === "start" ? 0 : 1, et = v4 === "horizontal" ? 0 : 1;
        P2 = N3 === "start" ? -P2 : P2;
        for (var at = z3 === "center", ht = 0; ht < H2[$].length - 1; ht++) {
          var bt = H2[$][ht].slice(), _t = this._firstDayOfMonth[ht];
          if (at) {
            var Et = this._firstDayPoints[ht];
            bt[et] = (Et[et] + H2[0][ht + 1][et]) / 2;
          }
          var zt = M2.get("formatter"), Ft = I2[+_t.m - 1], fe2 = { yyyy: _t.y, yy: (_t.y + "").slice(2), MM: _t.m, M: +_t.m, nameMap: Ft }, re2 = this._formatterLabel(zt, fe2), ye = new op({ z2: 30, style: ba2(By(M2, { text: re2 }), this._monthTextPositionControl(bt, at, v4, N3, P2)) });
          _.add(ye);
        }
      }
    }, i.prototype._weekTextPositionControl = function(t2, h, v4, _, M2) {
      var I2 = "center", P2 = "middle", N3 = t2[0], z3 = t2[1], H2 = v4 === "start";
      return h === "horizontal" ? (N3 = N3 + _ + (H2 ? 1 : -1) * M2[0] / 2, I2 = H2 ? "right" : "left") : (z3 = z3 + _ + (H2 ? 1 : -1) * M2[1] / 2, P2 = H2 ? "bottom" : "top"), { x: N3, y: z3, align: I2, verticalAlign: P2 };
    }, i.prototype._renderWeekText = function(t2, h, v4, _, M2) {
      var I2 = t2.getModel("dayLabel");
      if (!!I2.get("show")) {
        var P2 = t2.coordinateSystem, N3 = I2.get("position"), z3 = I2.get("nameMap"), H2 = I2.get("margin"), $ = P2.getFirstDayOfWeek();
        if (!z3 || ms(z3)) {
          z3 && (h = ZJt(z3) || h);
          var et = h.get(["time", "dayOfWeekShort"]);
          z3 = et || Xa2(h.get(["time", "dayOfWeekAbbr"]), function(fe2) {
            return fe2[0];
          });
        }
        var at = P2.getNextNDay(v4.end.time, 7 - v4.lweek).time, ht = [P2.getCellWidth(), P2.getCellHeight()];
        H2 = cs(H2, Math.min(ht[1], ht[0])), N3 === "start" && (at = P2.getNextNDay(v4.start.time, -(7 + v4.fweek)).time, H2 = -H2);
        for (var bt = 0; bt < 7; bt++) {
          var _t = P2.getNextNDay(at, bt), Et = P2.dataToRect([_t.time], false).center, zt = bt;
          zt = Math.abs((bt + $) % 7);
          var Ft = new op({ z2: 30, style: ba2(By(I2, { text: z3[zt] }), this._weekTextPositionControl(Et, _, N3, H2, ht)) });
          M2.add(Ft);
        }
      }
    }, i.type = "calendar", i;
  }(W0), WCr = jCr, FQt = 864e5, GCr = function() {
    function f2(i, t2, h) {
      this.type = "calendar", this.dimensions = f2.dimensions, this.getDimensionsInfo = f2.getDimensionsInfo, this._model = i;
    }
    return f2.getDimensionsInfo = function() {
      return [{ name: "time", type: "time" }, "value"];
    }, f2.prototype.getRangeInfo = function() {
      return this._rangeInfo;
    }, f2.prototype.getModel = function() {
      return this._model;
    }, f2.prototype.getRect = function() {
      return this._rect;
    }, f2.prototype.getCellWidth = function() {
      return this._sw;
    }, f2.prototype.getCellHeight = function() {
      return this._sh;
    }, f2.prototype.getOrient = function() {
      return this._orient;
    }, f2.prototype.getFirstDayOfWeek = function() {
      return this._firstDayOfWeek;
    }, f2.prototype.getDateInfo = function(i) {
      i = GL(i);
      var t2 = i.getFullYear(), h = i.getMonth() + 1, v4 = h < 10 ? "0" + h : "" + h, _ = i.getDate(), M2 = _ < 10 ? "0" + _ : "" + _, I2 = i.getDay();
      return I2 = Math.abs((I2 + 7 - this.getFirstDayOfWeek()) % 7), { y: t2 + "", m: v4, d: M2, day: I2, time: i.getTime(), formatedDate: t2 + "-" + v4 + "-" + M2, date: i };
    }, f2.prototype.getNextNDay = function(i, t2) {
      return t2 = t2 || 0, t2 === 0 ? this.getDateInfo(i) : (i = new Date(this.getDateInfo(i).time), i.setDate(i.getDate() + t2), this.getDateInfo(i));
    }, f2.prototype.update = function(i, t2) {
      this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
      var h = this._rangeInfo.weeks || 1, v4 = ["width", "height"], _ = this._model.getCellSize().slice(), M2 = this._model.getBoxLayoutParams(), I2 = this._orient === "horizontal" ? [h, 7] : [7, h];
      Qe2([0, 1], function(H2) {
        z3(_, H2) && (M2[v4[H2]] = _[H2] * I2[H2]);
      });
      var P2 = { width: t2.getWidth(), height: t2.getHeight() }, N3 = this._rect = u1(M2, P2);
      Qe2([0, 1], function(H2) {
        z3(_, H2) || (_[H2] = N3[v4[H2]] / I2[H2]);
      });
      function z3(H2, $) {
        return H2[$] != null && H2[$] !== "auto";
      }
      this._sw = _[0], this._sh = _[1];
    }, f2.prototype.dataToPoint = function(i, t2) {
      Za2(i) && (i = i[0]), t2 == null && (t2 = true);
      var h = this.getDateInfo(i), v4 = this._rangeInfo, _ = h.formatedDate;
      if (t2 && !(h.time >= v4.start.time && h.time < v4.end.time + FQt))
        return [NaN, NaN];
      var M2 = h.day, I2 = this._getRangeInfo([v4.start.time, _]).nthWeek;
      return this._orient === "vertical" ? [this._rect.x + M2 * this._sw + this._sw / 2, this._rect.y + I2 * this._sh + this._sh / 2] : [this._rect.x + I2 * this._sw + this._sw / 2, this._rect.y + M2 * this._sh + this._sh / 2];
    }, f2.prototype.pointToData = function(i) {
      var t2 = this.pointToDate(i);
      return t2 && t2.time;
    }, f2.prototype.dataToRect = function(i, t2) {
      var h = this.dataToPoint(i, t2);
      return { contentShape: { x: h[0] - (this._sw - this._lineWidth) / 2, y: h[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: h, tl: [h[0] - this._sw / 2, h[1] - this._sh / 2], tr: [h[0] + this._sw / 2, h[1] - this._sh / 2], br: [h[0] + this._sw / 2, h[1] + this._sh / 2], bl: [h[0] - this._sw / 2, h[1] + this._sh / 2] };
    }, f2.prototype.pointToDate = function(i) {
      var t2 = Math.floor((i[0] - this._rect.x) / this._sw) + 1, h = Math.floor((i[1] - this._rect.y) / this._sh) + 1, v4 = this._rangeInfo.range;
      return this._orient === "vertical" ? this._getDateByWeeksAndDay(h, t2 - 1, v4) : this._getDateByWeeksAndDay(t2, h - 1, v4);
    }, f2.prototype.convertToPixel = function(i, t2, h) {
      var v4 = q7e(t2);
      return v4 === this ? v4.dataToPoint(h) : null;
    }, f2.prototype.convertFromPixel = function(i, t2, h) {
      var v4 = q7e(t2);
      return v4 === this ? v4.pointToData(h) : null;
    }, f2.prototype.containPoint = function(i) {
      return console.warn("Not implemented."), false;
    }, f2.prototype._initRangeOption = function() {
      var i = this._model.get("range"), t2;
      if (Za2(i) && i.length === 1 && (i = i[0]), Za2(i))
        t2 = i;
      else {
        var h = i.toString();
        if (/^\d{4}$/.test(h) && (t2 = [h + "-01-01", h + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(h)) {
          var v4 = this.getDateInfo(h), _ = v4.date;
          _.setMonth(_.getMonth() + 1);
          var M2 = this.getNextNDay(_, -1);
          t2 = [v4.formatedDate, M2.formatedDate];
        }
        /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(h) && (t2 = [h, h]);
      }
      if (!t2)
        return i;
      var I2 = this._getRangeInfo(t2);
      return I2.start.time > I2.end.time && t2.reverse(), t2;
    }, f2.prototype._getRangeInfo = function(i) {
      var t2 = [this.getDateInfo(i[0]), this.getDateInfo(i[1])], h;
      t2[0].time > t2[1].time && (h = true, t2.reverse());
      var v4 = Math.floor(t2[1].time / FQt) - Math.floor(t2[0].time / FQt) + 1, _ = new Date(t2[0].time), M2 = _.getDate(), I2 = t2[1].date.getDate();
      _.setDate(M2 + v4 - 1);
      var P2 = _.getDate();
      if (P2 !== I2)
        for (var N3 = _.getTime() - t2[1].time > 0 ? 1 : -1; (P2 = _.getDate()) !== I2 && (_.getTime() - t2[1].time) * N3 > 0; )
          v4 -= N3, _.setDate(P2 - N3);
      var z3 = Math.floor((v4 + t2[0].day + 6) / 7), H2 = h ? -z3 + 1 : z3 - 1;
      return h && t2.reverse(), { range: [t2[0].formatedDate, t2[1].formatedDate], start: t2[0], end: t2[1], allDay: v4, weeks: z3, nthWeek: H2, fweek: t2[0].day, lweek: t2[1].day };
    }, f2.prototype._getDateByWeeksAndDay = function(i, t2, h) {
      var v4 = this._getRangeInfo(h);
      if (i > v4.weeks || i === 0 && t2 < v4.fweek || i === v4.weeks && t2 > v4.lweek)
        return null;
      var _ = (i - 1) * 7 - v4.fweek + t2, M2 = new Date(v4.start.time);
      return M2.setDate(+v4.start.d + _), this.getDateInfo(M2);
    }, f2.create = function(i, t2) {
      var h = [];
      return i.eachComponent("calendar", function(v4) {
        var _ = new f2(v4, i, t2);
        h.push(_), v4.coordinateSystem = _;
      }), i.eachSeries(function(v4) {
        v4.get("coordinateSystem") === "calendar" && (v4.coordinateSystem = h[v4.get("calendarIndex") || 0]);
      }), h;
    }, f2.dimensions = ["time", "value"], f2;
  }();
  function q7e(f2) {
    var i = f2.calendarModel, t2 = f2.seriesModel, h = i ? i.coordinateSystem : t2 ? t2.coordinateSystem : null;
    return h;
  }
  var HCr = GCr;
  function UCr(f2) {
    f2.registerComponentModel(zCr), f2.registerComponentView(WCr), f2.registerCoordinateSystem("calendar", HCr);
  }
  function qCr(f2, i) {
    var t2 = f2.existing;
    if (i.id = f2.keyInfo.id, !i.type && t2 && (i.type = t2.type), i.parentId == null) {
      var h = i.parentOption;
      h ? i.parentId = h.id : t2 && (i.parentId = t2.parentId);
    }
    i.parentOption = null;
  }
  function Z7e(f2, i) {
    var t2;
    return Qe2(i, function(h) {
      f2[h] != null && f2[h] !== "auto" && (t2 = true);
    }), t2;
  }
  function ZCr(f2, i, t2) {
    var h = ba2({}, t2), v4 = f2[i], _ = t2.$action || "merge";
    _ === "merge" ? v4 ? (cc2(v4, h, true), J7(v4, h, { ignoreSize: true }), rWe(t2, v4), CDt(t2, v4), CDt(t2, v4, "shape"), CDt(t2, v4, "style"), CDt(t2, v4, "extra"), t2.clipPath = v4.clipPath) : f2[i] = h : _ === "replace" ? f2[i] = h : _ === "remove" && v4 && (f2[i] = null);
  }
  var mqe = ["transition", "enterFrom", "leaveTo"], $Cr = mqe.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
  function CDt(f2, i, t2) {
    if (t2 && (!f2[t2] && i[t2] && (f2[t2] = {}), f2 = f2[t2], i = i[t2]), !(!f2 || !i))
      for (var h = t2 ? mqe : $Cr, v4 = 0; v4 < h.length; v4++) {
        var _ = h[v4];
        f2[_] == null && i[_] != null && (f2[_] = i[_]);
      }
  }
  function YCr(f2, i) {
    if (!!f2 && (f2.hv = i.hv = [Z7e(i, ["left", "right"]), Z7e(i, ["top", "bottom"])], f2.type === "group")) {
      var t2 = f2, h = i;
      t2.width == null && (t2.width = h.width = 0), t2.height == null && (t2.height = h.height = 0);
    }
  }
  var KCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.preventAutoZ = true, t2;
    }
    return i.prototype.mergeOption = function(t2, h) {
      var v4 = this.option.elements;
      this.option.elements = null, f2.prototype.mergeOption.call(this, t2, h), this.option.elements = v4;
    }, i.prototype.optionUpdated = function(t2, h) {
      var v4 = this.option, _ = (h ? v4 : t2).elements, M2 = v4.elements = h ? [] : v4.elements, I2 = [];
      this._flatten(_, I2, null);
      var P2 = Vze(M2, I2, "normalMerge"), N3 = this._elOptionsToUpdate = [];
      Qe2(P2, function(z3, H2) {
        var $ = z3.newOption;
        !$ || (N3.push($), qCr(z3, $), ZCr(M2, H2, $), YCr(M2[H2], $));
      }, this), v4.elements = Ld2(M2, function(z3) {
        return z3 && delete z3.$action, z3 != null;
      });
    }, i.prototype._flatten = function(t2, h, v4) {
      Qe2(t2, function(_) {
        if (!!_) {
          v4 && (_.parentOption = v4), h.push(_);
          var M2 = _.children;
          _.type === "group" && M2 && this._flatten(M2, h, _), delete _.children;
        }
      }, this);
    }, i.prototype.useElOptionsToUpdate = function() {
      var t2 = this._elOptionsToUpdate;
      return this._elOptionsToUpdate = null, t2;
    }, i.type = "graphic", i.defaultOption = { elements: [] }, i;
  }(zh2), $7e = { path: null, compoundPath: null, group: mu, image: Ux, text: op }, qD = Wh2(), XCr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function() {
      this._elMap = Il();
    }, i.prototype.render = function(t2, h, v4) {
      t2 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = t2, this._updateElements(t2), this._relocate(t2, v4);
    }, i.prototype._updateElements = function(t2) {
      var h = t2.useElOptionsToUpdate();
      if (!!h) {
        var v4 = this._elMap, _ = this.group, M2 = t2.get("z"), I2 = t2.get("zlevel");
        Qe2(h, function(P2) {
          var N3 = l1(P2.id, null), z3 = N3 != null ? v4.get(N3) : null, H2 = l1(P2.parentId, null), $ = H2 != null ? v4.get(H2) : _, et = P2.type, at = P2.style;
          et === "text" && at && P2.hv && P2.hv[1] && (at.textVerticalAlign = at.textBaseline = at.verticalAlign = at.align = null);
          var ht = P2.textContent, bt = P2.textConfig;
          if (at && XUe(at, et, !!bt, !!ht)) {
            var _t = QUe(at, et, true);
            !bt && _t.textConfig && (bt = P2.textConfig = _t.textConfig), !ht && _t.textContent && (ht = _t.textContent);
          }
          var Et = QCr(P2), zt = P2.$action || "merge", Ft = zt === "merge", fe2 = zt === "replace";
          if (Ft) {
            var re2 = !z3, ye = z3;
            re2 ? ye = Y7e(N3, $, P2.type, v4) : (ye && (qD(ye).isNew = false), nqe(ye)), ye && (tEt(ye, Et, t2, { isInit: re2 }), K7e(ye, P2, M2, I2));
          } else if (fe2) {
            nEt(z3, P2, v4, t2);
            var me2 = Y7e(N3, $, P2.type, v4);
            me2 && (tEt(me2, Et, t2, { isInit: true }), K7e(me2, P2, M2, I2));
          } else
            zt === "remove" && (tqe(z3, P2), nEt(z3, P2, v4, t2));
          var be2 = v4.get(N3);
          if (be2 && ht)
            if (Ft) {
              var Te2 = be2.getTextContent();
              Te2 ? Te2.attr(ht) : be2.setTextContent(new op(ht));
            } else
              fe2 && be2.setTextContent(new op(ht));
          if (be2) {
            var We = P2.clipPath;
            if (We) {
              var en = We.type, Ue2 = void 0, re2 = false;
              if (Ft) {
                var Mn = be2.getClipPath();
                re2 = !Mn || qD(Mn).type !== en, Ue2 = re2 ? Vte(en) : Mn;
              } else
                fe2 && (re2 = true, Ue2 = Vte(en));
              be2.setClipPath(Ue2), tEt(Ue2, We, t2, { isInit: re2 }), HEt(Ue2, We.keyframeAnimation, t2);
            }
            var Vn = qD(be2);
            be2.setTextConfig(bt), Vn.option = P2, JCr(be2, t2, P2), eet({ el: be2, componentModel: t2, itemName: be2.name, itemTooltipOption: P2.tooltip }), HEt(be2, P2.keyframeAnimation, t2);
          }
        });
      }
    }, i.prototype._relocate = function(t2, h) {
      for (var v4 = t2.option.elements, _ = this.group, M2 = this._elMap, I2 = h.getWidth(), P2 = h.getHeight(), N3 = ["x", "y"], z3 = 0; z3 < v4.length; z3++) {
        var H2 = v4[z3], $ = l1(H2.id, null), et = $ != null ? M2.get($) : null;
        if (!(!et || !et.isGroup)) {
          var at = et.parent, ht = at === _, bt = qD(et), _t = qD(at);
          bt.width = cs(bt.option.width, ht ? I2 : _t.width) || 0, bt.height = cs(bt.option.height, ht ? P2 : _t.height) || 0;
        }
      }
      for (var z3 = v4.length - 1; z3 >= 0; z3--) {
        var H2 = v4[z3], $ = l1(H2.id, null), et = $ != null ? M2.get($) : null;
        if (!!et) {
          var at = et.parent, _t = qD(at), Et = at === _ ? { width: I2, height: P2 } : { width: _t.width, height: _t.height }, zt = {}, Ft = Akt(et, H2, Et, null, { hv: H2.hv, boundingMode: H2.bounding }, zt);
          if (!qD(et).isNew && Ft) {
            for (var fe2 = H2.transition, re2 = {}, ye = 0; ye < N3.length; ye++) {
              var me2 = N3[ye], be2 = zt[me2];
              fe2 && (dU(fe2) || Pc2(fe2, me2) >= 0) ? re2[me2] = be2 : et[me2] = be2;
            }
            jh2(et, re2, t2, 0);
          } else
            et.attr(zt);
        }
      }
    }, i.prototype._clear = function() {
      var t2 = this, h = this._elMap;
      h.each(function(v4) {
        nEt(v4, qD(v4).option, h, t2._lastGraphicModel);
      }), this._elMap = Il();
    }, i.prototype.dispose = function() {
      this._clear();
    }, i.type = "graphic", i;
  }(W0);
  function Vte(f2) {
    var i = qs($7e, f2) ? $7e[f2] : Gee(f2), t2 = new i({});
    return qD(t2).type = f2, t2;
  }
  function Y7e(f2, i, t2, h) {
    var v4 = Vte(t2);
    return i.add(v4), h.set(f2, v4), qD(v4).id = f2, qD(v4).isNew = true, v4;
  }
  function nEt(f2, i, t2, h) {
    var v4 = f2 && f2.parent;
    v4 && (f2.type === "group" && f2.traverse(function(_) {
      nEt(_, i, t2, h);
    }), Gkt(f2, i, h), t2.removeKey(qD(f2).id));
  }
  function K7e(f2, i, t2, h) {
    if (!f2.isGroup) {
      var v4 = f2;
      v4.cursor = _c2(i.cursor, rE.prototype.cursor), v4.z = _c2(i.z, t2 || 0), v4.zlevel = _c2(i.zlevel, h || 0);
      var _ = i.z2;
      _ != null && (v4.z2 = _ || 0);
    }
    Qe2(Of2(i), function(M2) {
      var I2 = i[M2];
      M2.indexOf("on") === 0 && Ol(I2) && (f2[M2] = I2);
    }), f2.draggable = i.draggable, i.name != null && (f2.name = i.name), i.id != null && (f2.id = i.id);
  }
  function QCr(f2) {
    return f2 = ba2({}, f2), Qe2(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(nWe), function(i) {
      delete f2[i];
    }), f2;
  }
  function JCr(f2, i, t2) {
    var h = Du(f2).eventData;
    !f2.silent && !f2.ignore && !h && (h = Du(f2).eventData = { componentType: "graphic", componentIndex: i.componentIndex, name: f2.name }), h && (h.info = t2.info);
  }
  function tTr(f2) {
    f2.registerComponentModel(KCr), f2.registerComponentView(XCr), f2.registerPreprocessor(function(i) {
      var t2 = i.graphic;
      Za2(t2) ? !t2[0] || !t2[0].elements ? i.graphic = [{ elements: t2 }] : i.graphic = [i.graphic[0]] : t2 && !t2.elements && (i.graphic = [{ elements: [t2] }]);
    });
  }
  var X7e = ["x", "y", "radius", "angle", "single"], eTr = ["cartesian2d", "polar", "singleAxis"];
  function nTr(f2) {
    var i = f2.get("coordinateSystem");
    return Pc2(eTr, i) >= 0;
  }
  function H7(f2) {
    return f2 + "Axis";
  }
  function rTr(f2, i) {
    var t2 = Il(), h = [], v4 = Il();
    f2.eachComponent({ mainType: "dataZoom", query: i }, function(z3) {
      v4.get(z3.uid) || I2(z3);
    });
    var _;
    do
      _ = false, f2.eachComponent("dataZoom", M2);
    while (_);
    function M2(z3) {
      !v4.get(z3.uid) && P2(z3) && (I2(z3), _ = true);
    }
    function I2(z3) {
      v4.set(z3.uid, true), h.push(z3), N3(z3);
    }
    function P2(z3) {
      var H2 = false;
      return z3.eachTargetAxis(function($, et) {
        var at = t2.get($);
        at && at[et] && (H2 = true);
      }), H2;
    }
    function N3(z3) {
      z3.eachTargetAxis(function(H2, $) {
        (t2.get(H2) || t2.set(H2, []))[$] = true;
      });
    }
    return h;
  }
  function bqe(f2) {
    var i = f2.ecModel, t2 = { infoList: [], infoMap: Il() };
    return f2.eachTargetAxis(function(h, v4) {
      var _ = i.getComponent(H7(h), v4);
      if (!!_) {
        var M2 = _.getCoordSysModel();
        if (!!M2) {
          var I2 = M2.uid, P2 = t2.infoMap.get(I2);
          P2 || (P2 = { model: M2, axisModels: [] }, t2.infoList.push(P2), t2.infoMap.set(I2, P2)), P2.axisModels.push(_);
        }
      }
    }), t2;
  }
  var VQt = function() {
    function f2() {
      this.indexList = [], this.indexMap = [];
    }
    return f2.prototype.add = function(i) {
      this.indexMap[i] || (this.indexList.push(i), this.indexMap[i] = true);
    }, f2;
  }(), iTr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._autoThrottle = true, t2._noTarget = true, t2._rangePropMode = ["percent", "percent"], t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      var _ = Q7e(t2);
      this.settledOption = _, this.mergeDefaultAndTheme(t2, v4), this._doInit(_);
    }, i.prototype.mergeOption = function(t2) {
      var h = Q7e(t2);
      cc2(this.option, t2, true), cc2(this.settledOption, h, true), this._doInit(h);
    }, i.prototype._doInit = function(t2) {
      var h = this.option;
      this._setDefaultThrottle(t2), this._updateRangeUse(t2);
      var v4 = this.settledOption;
      Qe2([["start", "startValue"], ["end", "endValue"]], function(_, M2) {
        this._rangePropMode[M2] === "value" && (h[_[0]] = v4[_[0]] = null);
      }, this), this._resetTarget();
    }, i.prototype._resetTarget = function() {
      var t2 = this.get("orient", true), h = this._targetAxisInfoMap = Il(), v4 = this._fillSpecifiedTargetAxis(h);
      v4 ? this._orient = t2 || this._makeAutoOrientByTargetAxis() : (this._orient = t2 || "horizontal", this._fillAutoTargetAxisByOrient(h, this._orient)), this._noTarget = true, h.each(function(_) {
        _.indexList.length && (this._noTarget = false);
      }, this);
    }, i.prototype._fillSpecifiedTargetAxis = function(t2) {
      var h = false;
      return Qe2(X7e, function(v4) {
        var _ = this.getReferringComponents(H7(v4), ycr);
        if (!!_.specified) {
          h = true;
          var M2 = new VQt();
          Qe2(_.models, function(I2) {
            M2.add(I2.componentIndex);
          }), t2.set(v4, M2);
        }
      }, this), h;
    }, i.prototype._fillAutoTargetAxisByOrient = function(t2, h) {
      var v4 = this.ecModel, _ = true;
      if (_) {
        var M2 = h === "vertical" ? "y" : "x", I2 = v4.findComponents({ mainType: M2 + "Axis" });
        P2(I2, M2);
      }
      if (_) {
        var I2 = v4.findComponents({ mainType: "singleAxis", filter: function(z3) {
          return z3.get("orient", true) === h;
        } });
        P2(I2, "single");
      }
      function P2(N3, z3) {
        var H2 = N3[0];
        if (!!H2) {
          var $ = new VQt();
          if ($.add(H2.componentIndex), t2.set(z3, $), _ = false, z3 === "x" || z3 === "y") {
            var et = H2.getReferringComponents("grid", _m).models[0];
            et && Qe2(N3, function(at) {
              H2.componentIndex !== at.componentIndex && et === at.getReferringComponents("grid", _m).models[0] && $.add(at.componentIndex);
            });
          }
        }
      }
      _ && Qe2(X7e, function(N3) {
        if (!!_) {
          var z3 = v4.findComponents({ mainType: H7(N3), filter: function($) {
            return $.get("type", true) === "category";
          } });
          if (z3[0]) {
            var H2 = new VQt();
            H2.add(z3[0].componentIndex), t2.set(N3, H2), _ = false;
          }
        }
      }, this);
    }, i.prototype._makeAutoOrientByTargetAxis = function() {
      var t2;
      return this.eachTargetAxis(function(h) {
        !t2 && (t2 = h);
      }, this), t2 === "y" ? "vertical" : "horizontal";
    }, i.prototype._setDefaultThrottle = function(t2) {
      if (t2.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
        var h = this.ecModel.option;
        this.option.throttle = h.animation && h.animationDurationUpdate > 0 ? 100 : 20;
      }
    }, i.prototype._updateRangeUse = function(t2) {
      var h = this._rangePropMode, v4 = this.get("rangeMode");
      Qe2([["start", "startValue"], ["end", "endValue"]], function(_, M2) {
        var I2 = t2[_[0]] != null, P2 = t2[_[1]] != null;
        I2 && !P2 ? h[M2] = "percent" : !I2 && P2 ? h[M2] = "value" : v4 ? h[M2] = v4[M2] : I2 && (h[M2] = "percent");
      });
    }, i.prototype.noTarget = function() {
      return this._noTarget;
    }, i.prototype.getFirstTargetAxisModel = function() {
      var t2;
      return this.eachTargetAxis(function(h, v4) {
        t2 == null && (t2 = this.ecModel.getComponent(H7(h), v4));
      }, this), t2;
    }, i.prototype.eachTargetAxis = function(t2, h) {
      this._targetAxisInfoMap.each(function(v4, _) {
        Qe2(v4.indexList, function(M2) {
          t2.call(h, _, M2);
        });
      });
    }, i.prototype.getAxisProxy = function(t2, h) {
      var v4 = this.getAxisModel(t2, h);
      if (v4)
        return v4.__dzAxisProxy;
    }, i.prototype.getAxisModel = function(t2, h) {
      var v4 = this._targetAxisInfoMap.get(t2);
      if (v4 && v4.indexMap[h])
        return this.ecModel.getComponent(H7(t2), h);
    }, i.prototype.setRawRange = function(t2) {
      var h = this.option, v4 = this.settledOption;
      Qe2([["start", "startValue"], ["end", "endValue"]], function(_) {
        (t2[_[0]] != null || t2[_[1]] != null) && (h[_[0]] = v4[_[0]] = t2[_[0]], h[_[1]] = v4[_[1]] = t2[_[1]]);
      }, this), this._updateRangeUse(t2);
    }, i.prototype.setCalculatedRange = function(t2) {
      var h = this.option;
      Qe2(["start", "startValue", "end", "endValue"], function(v4) {
        h[v4] = t2[v4];
      });
    }, i.prototype.getPercentRange = function() {
      var t2 = this.findRepresentativeAxisProxy();
      if (t2)
        return t2.getDataPercentWindow();
    }, i.prototype.getValueRange = function(t2, h) {
      if (t2 == null && h == null) {
        var v4 = this.findRepresentativeAxisProxy();
        if (v4)
          return v4.getDataValueWindow();
      } else
        return this.getAxisProxy(t2, h).getDataValueWindow();
    }, i.prototype.findRepresentativeAxisProxy = function(t2) {
      if (t2)
        return t2.__dzAxisProxy;
      for (var h, v4 = this._targetAxisInfoMap.keys(), _ = 0; _ < v4.length; _++)
        for (var M2 = v4[_], I2 = this._targetAxisInfoMap.get(M2), P2 = 0; P2 < I2.indexList.length; P2++) {
          var N3 = this.getAxisProxy(M2, I2.indexList[P2]);
          if (N3.hostedBy(this))
            return N3;
          h || (h = N3);
        }
      return h;
    }, i.prototype.getRangePropMode = function() {
      return this._rangePropMode.slice();
    }, i.prototype.getOrient = function() {
      return this._orient;
    }, i.type = "dataZoom", i.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], i.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, i;
  }(zh2);
  function Q7e(f2) {
    var i = {};
    return Qe2(["start", "end", "startValue", "endValue", "throttle"], function(t2) {
      f2.hasOwnProperty(t2) && (i[t2] = f2[t2]);
    }), i;
  }
  var mgt = iTr, aTr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "dataZoom.select", i;
  }(mgt), oTr = aTr, sTr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      this.dataZoomModel = t2, this.ecModel = h, this.api = v4;
    }, i.type = "dataZoom", i;
  }(W0), ure = sTr, lTr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "dataZoom.select", i;
  }(ure), uTr = lTr, Stt = Qe2, J7e = QD, cTr = function() {
    function f2(i, t2, h, v4) {
      this._dimName = i, this._axisIndex = t2, this.ecModel = v4, this._dataZoomModel = h;
    }
    return f2.prototype.hostedBy = function(i) {
      return this._dataZoomModel === i;
    }, f2.prototype.getDataValueWindow = function() {
      return this._valueWindow.slice();
    }, f2.prototype.getDataPercentWindow = function() {
      return this._percentWindow.slice();
    }, f2.prototype.getTargetSeriesModels = function() {
      var i = [];
      return this.ecModel.eachSeries(function(t2) {
        if (nTr(t2)) {
          var h = H7(this._dimName), v4 = t2.getReferringComponents(h, _m).models[0];
          v4 && this._axisIndex === v4.componentIndex && i.push(t2);
        }
      }, this), i;
    }, f2.prototype.getAxisModel = function() {
      return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
    }, f2.prototype.getMinMaxSpan = function() {
      return pu(this._minMaxSpan);
    }, f2.prototype.calculateDataWindow = function(i) {
      var t2 = this._dataExtent, h = this.getAxisModel(), v4 = h.axis.scale, _ = this._dataZoomModel.getRangePropMode(), M2 = [0, 100], I2 = [], P2 = [], N3;
      Stt(["start", "end"], function($, et) {
        var at = i[$], ht = i[$ + "Value"];
        _[et] === "percent" ? (at == null && (at = M2[et]), ht = v4.parse(cd2(at, M2, t2))) : (N3 = true, ht = ht == null ? t2[et] : v4.parse(ht), at = cd2(ht, t2, M2)), P2[et] = ht, I2[et] = at;
      }), J7e(P2), J7e(I2);
      var z3 = this._minMaxSpan;
      N3 ? H2(P2, I2, t2, M2, false) : H2(I2, P2, M2, t2, true);
      function H2($, et, at, ht, bt) {
        var _t = bt ? "Span" : "ValueSpan";
        AU(0, $, at, "all", z3["min" + _t], z3["max" + _t]);
        for (var Et = 0; Et < 2; Et++)
          et[Et] = cd2($[Et], at, ht, true), bt && (et[Et] = v4.parse(et[Et]));
      }
      return { valueWindow: P2, percentWindow: I2 };
    }, f2.prototype.reset = function(i) {
      if (i === this._dataZoomModel) {
        var t2 = this.getTargetSeriesModels();
        this._dataExtent = fTr(this, this._dimName, t2), this._updateMinMaxSpan();
        var h = this.calculateDataWindow(i.settledOption);
        this._valueWindow = h.valueWindow, this._percentWindow = h.percentWindow, this._setAxisModel();
      }
    }, f2.prototype.filterData = function(i, t2) {
      if (i !== this._dataZoomModel)
        return;
      var h = this._dimName, v4 = this.getTargetSeriesModels(), _ = i.get("filterMode"), M2 = this._valueWindow;
      if (_ === "none")
        return;
      Stt(v4, function(P2) {
        var N3 = P2.getData(), z3 = N3.mapDimensionsAll(h);
        if (!!z3.length) {
          if (_ === "weakFilter") {
            var H2 = N3.getStore(), $ = Xa2(z3, function(et) {
              return N3.getDimensionIndex(et);
            }, N3);
            N3.filterSelf(function(et) {
              for (var at, ht, bt, _t = 0; _t < z3.length; _t++) {
                var Et = H2.get($[_t], et), zt = !isNaN(Et), Ft = Et < M2[0], fe2 = Et > M2[1];
                if (zt && !Ft && !fe2)
                  return true;
                zt && (bt = true), Ft && (at = true), fe2 && (ht = true);
              }
              return bt && at && ht;
            });
          } else
            Stt(z3, function(et) {
              if (_ === "empty")
                P2.setData(N3 = N3.map(et, function(ht) {
                  return I2(ht) ? ht : NaN;
                }));
              else {
                var at = {};
                at[et] = M2, N3.selectRange(at);
              }
            });
          Stt(z3, function(et) {
            N3.setApproximateExtent(M2, et);
          });
        }
      });
      function I2(P2) {
        return P2 >= M2[0] && P2 <= M2[1];
      }
    }, f2.prototype._updateMinMaxSpan = function() {
      var i = this._minMaxSpan = {}, t2 = this._dataZoomModel, h = this._dataExtent;
      Stt(["min", "max"], function(v4) {
        var _ = t2.get(v4 + "Span"), M2 = t2.get(v4 + "ValueSpan");
        M2 != null && (M2 = this.getAxisModel().axis.scale.parse(M2)), M2 != null ? _ = cd2(h[0] + M2, h, [0, 100], true) : _ != null && (M2 = cd2(_, [0, 100], h, true) - h[0]), i[v4 + "Span"] = _, i[v4 + "ValueSpan"] = M2;
      }, this);
    }, f2.prototype._setAxisModel = function() {
      var i = this.getAxisModel(), t2 = this._percentWindow, h = this._valueWindow;
      if (!!t2) {
        var v4 = Eze(h, [0, 500]);
        v4 = Math.min(v4, 20);
        var _ = i.axis.scale.rawExtentInfo;
        t2[0] !== 0 && _.setDeterminedMinMax("min", +h[0].toFixed(v4)), t2[1] !== 100 && _.setDeterminedMinMax("max", +h[1].toFixed(v4)), _.freeze();
      }
    }, f2;
  }();
  function fTr(f2, i, t2) {
    var h = [1 / 0, -1 / 0];
    Stt(t2, function(M2) {
      Rvr(h, M2.getData(), i);
    });
    var v4 = f2.getAxisModel(), _ = FGe(v4.axis.scale, v4, h).calculate();
    return [_.min, _.max];
  }
  var hTr = cTr, pTr = { getTargetSeries: function(f2) {
    function i(v4) {
      f2.eachComponent("dataZoom", function(_) {
        _.eachTargetAxis(function(M2, I2) {
          var P2 = f2.getComponent(H7(M2), I2);
          v4(M2, I2, P2, _);
        });
      });
    }
    i(function(v4, _, M2, I2) {
      M2.__dzAxisProxy = null;
    });
    var t2 = [];
    i(function(v4, _, M2, I2) {
      M2.__dzAxisProxy || (M2.__dzAxisProxy = new hTr(v4, _, I2, f2), t2.push(M2.__dzAxisProxy));
    });
    var h = Il();
    return Qe2(t2, function(v4) {
      Qe2(v4.getTargetSeriesModels(), function(_) {
        h.set(_.uid, _);
      });
    }), h;
  }, overallReset: function(f2, i) {
    f2.eachComponent("dataZoom", function(t2) {
      t2.eachTargetAxis(function(h, v4) {
        t2.getAxisProxy(h, v4).reset(t2);
      }), t2.eachTargetAxis(function(h, v4) {
        t2.getAxisProxy(h, v4).filterData(t2, i);
      });
    }), f2.eachComponent("dataZoom", function(t2) {
      var h = t2.findRepresentativeAxisProxy();
      if (h) {
        var v4 = h.getDataPercentWindow(), _ = h.getDataValueWindow();
        t2.setCalculatedRange({ start: v4[0], end: v4[1], startValue: _[0], endValue: _[1] });
      }
    });
  } }, dTr = pTr;
  function gTr(f2) {
    f2.registerAction("dataZoom", function(i, t2) {
      var h = rTr(t2, i);
      Qe2(h, function(v4) {
        v4.setRawRange({ start: i.start, end: i.end, startValue: i.startValue, endValue: i.endValue });
      });
    });
  }
  var tVe = false;
  function cre(f2) {
    tVe || (tVe = true, f2.registerProcessor(f2.PRIORITY.PROCESSOR.FILTER, dTr), gTr(f2), f2.registerSubTypeDefaulter("dataZoom", function() {
      return "slider";
    }));
  }
  function vTr(f2) {
    f2.registerComponentModel(oTr), f2.registerComponentView(uTr), cre(f2);
  }
  var $D = function() {
    function f2() {
    }
    return f2;
  }(), _qe = {};
  function Mtt(f2, i) {
    _qe[f2] = i;
  }
  function xqe(f2) {
    return _qe[f2];
  }
  var yTr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.optionUpdated = function() {
      f2.prototype.optionUpdated.apply(this, arguments);
      var t2 = this.ecModel;
      Qe2(this.option.feature, function(h, v4) {
        var _ = xqe(v4);
        _ && (_.getDefaultOption && (_.defaultOption = _.getDefaultOption(t2)), cc2(h, _.defaultOption));
      });
    }, i.type = "toolbox", i.layoutMode = { type: "box", ignoreSize: true }, i.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, i;
  }(zh2), mTr = yTr;
  function bTr(f2, i, t2) {
    var h = i.getBoxLayoutParams(), v4 = i.get("padding"), _ = { width: t2.getWidth(), height: t2.getHeight() }, M2 = u1(h, _, v4);
    fU(i.get("orient"), f2, i.get("itemGap"), M2.width, M2.height), Akt(f2, h, _, v4);
  }
  function wqe(f2, i) {
    var t2 = iet(i.get("padding")), h = i.getItemStyle(["color", "opacity"]);
    return h.fill = i.get("backgroundColor"), f2 = new Sh2({ shape: { x: f2.x - t2[3], y: f2.y - t2[0], width: f2.width + t2[1] + t2[3], height: f2.height + t2[0] + t2[2], r: i.get("borderRadius") }, style: h, silent: true, z2: -1 }), f2;
  }
  var _Tr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      var M2 = this.group;
      if (M2.removeAll(), !t2.get("show"))
        return;
      var I2 = +t2.get("itemSize"), P2 = t2.get("feature") || {}, N3 = this._features || (this._features = {}), z3 = [];
      Qe2(P2, function(et, at) {
        z3.push(at);
      }), new eN(this._featureNames || [], z3).add(H2).update(H2).remove(Ou(H2, null)).execute(), this._featureNames = z3;
      function H2(et, at) {
        var ht = z3[et], bt = z3[at], _t = P2[ht], Et = new Gg2(_t, t2, t2.ecModel), zt;
        if (_ && _.newTitle != null && _.featureName === ht && (_t.title = _.newTitle), ht && !bt) {
          if (xTr(ht))
            zt = { onclick: Et.option.onclick, featureName: ht };
          else {
            var Ft = xqe(ht);
            if (!Ft)
              return;
            zt = new Ft();
          }
          N3[ht] = zt;
        } else if (zt = N3[bt], !zt)
          return;
        zt.uid = ret("toolbox-feature"), zt.model = Et, zt.ecModel = h, zt.api = v4;
        var fe2 = zt instanceof $D;
        if (!ht && bt) {
          fe2 && zt.dispose && zt.dispose(h, v4);
          return;
        }
        if (!Et.get("show") || fe2 && zt.unusable) {
          fe2 && zt.remove && zt.remove(h, v4);
          return;
        }
        $(Et, zt, ht), Et.setIconStatus = function(re2, ye) {
          var me2 = this.option, be2 = this.iconPaths;
          me2.iconStatus = me2.iconStatus || {}, me2.iconStatus[re2] = ye, be2[re2] && (ye === "emphasis" ? NL : FL)(be2[re2]);
        }, zt instanceof $D && zt.render && zt.render(Et, h, v4, _);
      }
      function $(et, at, ht) {
        var bt = et.getModel("iconStyle"), _t = et.getModel(["emphasis", "iconStyle"]), Et = at instanceof $D && at.getIcons ? at.getIcons() : et.get("icon"), zt = et.get("title") || {}, Ft, fe2;
        ms(Et) ? (Ft = {}, Ft[ht] = Et) : Ft = Et, ms(zt) ? (fe2 = {}, fe2[ht] = zt) : fe2 = zt;
        var re2 = et.iconPaths = {};
        Qe2(Ft, function(ye, me2) {
          var be2 = Egt(ye, {}, { x: -I2 / 2, y: -I2 / 2, width: I2, height: I2 });
          be2.setStyle(bt.getItemStyle());
          var Te2 = be2.ensureState("emphasis");
          Te2.style = _t.getItemStyle();
          var We = new op({ style: { text: fe2[me2], align: _t.get("textAlign"), borderRadius: _t.get("textBorderRadius"), padding: _t.get("textPadding"), fill: null }, ignore: true });
          be2.setTextContent(We), eet({ el: be2, componentModel: t2, itemName: me2, formatterParamsExtra: { title: fe2[me2] } }), be2.__title = fe2[me2], be2.on("mouseover", function() {
            var en = _t.getItemStyle(), Ue2 = t2.get("orient") === "vertical" ? t2.get("right") == null ? "right" : "left" : t2.get("bottom") == null ? "bottom" : "top";
            We.setStyle({ fill: _t.get("textFill") || en.fill || en.stroke || "#000", backgroundColor: _t.get("textBackgroundColor") }), be2.setTextConfig({ position: _t.get("textPosition") || Ue2 }), We.ignore = !t2.get("showTitle"), NL(this);
          }).on("mouseout", function() {
            et.get(["iconStatus", me2]) !== "emphasis" && FL(this), We.hide();
          }), (et.get(["iconStatus", me2]) === "emphasis" ? NL : FL)(be2), M2.add(be2), be2.on("click", ks(at.onclick, at, h, v4, me2)), re2[me2] = be2;
        });
      }
      bTr(M2, t2, v4), M2.add(wqe(M2.getBoundingRect(), t2)), M2.eachChild(function(et) {
        var at = et.__title, ht = et.ensureState("emphasis"), bt = ht.textConfig || (ht.textConfig = {}), _t = et.getTextContent(), Et = _t && _t.states.emphasis;
        if (Et && !Ol(Et) && at) {
          var zt = Et.style || (Et.style = {}), Ft = Cgt(at, op.makeFont(zt)), fe2 = et.x + M2.x, re2 = et.y + M2.y + I2, ye = false;
          re2 + Ft.height > v4.getHeight() && (bt.position = "top", ye = true);
          var me2 = ye ? -5 - Ft.height : I2 + 8;
          fe2 + Ft.width / 2 > v4.getWidth() ? (bt.position = ["100%", me2], zt.align = "right") : fe2 - Ft.width / 2 < 0 && (bt.position = [0, me2], zt.align = "left");
        }
      });
    }, i.prototype.updateView = function(t2, h, v4, _) {
      Qe2(this._features, function(M2) {
        M2 instanceof $D && M2.updateView && M2.updateView(M2.model, h, v4, _);
      });
    }, i.prototype.remove = function(t2, h) {
      Qe2(this._features, function(v4) {
        v4 instanceof $D && v4.remove && v4.remove(t2, h);
      }), this.group.removeAll();
    }, i.prototype.dispose = function(t2, h) {
      Qe2(this._features, function(v4) {
        v4 instanceof $D && v4.dispose && v4.dispose(t2, h);
      });
    }, i.type = "toolbox", i;
  }(W0);
  function xTr(f2) {
    return f2.indexOf("my") === 0;
  }
  var wTr = _Tr, STr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.onclick = function(t2, h) {
      var v4 = this.model, _ = v4.get("name") || t2.get("title.0.text") || "echarts", M2 = h.getZr().painter.getType() === "svg", I2 = M2 ? "svg" : v4.get("type", true) || "png", P2 = h.getConnectedDataURL({ type: I2, backgroundColor: v4.get("backgroundColor", true) || t2.get("backgroundColor") || "#fff", connectedBackgroundColor: v4.get("connectedBackgroundColor"), excludeComponents: v4.get("excludeComponents"), pixelRatio: v4.get("pixelRatio") }), N3 = gp.browser;
      if (Ol(MouseEvent) && (N3.newEdge || !N3.ie && !N3.edge)) {
        var z3 = document.createElement("a");
        z3.download = _ + "." + I2, z3.target = "_blank", z3.href = P2;
        var H2 = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
        z3.dispatchEvent(H2);
      } else if (window.navigator.msSaveOrOpenBlob || M2) {
        var $ = P2.split(","), et = $[0].indexOf("base64") > -1, at = M2 ? decodeURIComponent($[1]) : $[1];
        et && (at = window.atob(at));
        var ht = _ + "." + I2;
        if (window.navigator.msSaveOrOpenBlob) {
          for (var bt = at.length, _t = new Uint8Array(bt); bt--; )
            _t[bt] = at.charCodeAt(bt);
          var Et = new Blob([_t]);
          window.navigator.msSaveOrOpenBlob(Et, ht);
        } else {
          var zt = document.createElement("iframe");
          document.body.appendChild(zt);
          var Ft = zt.contentWindow, fe2 = Ft.document;
          fe2.open("image/svg+xml", "replace"), fe2.write(at), fe2.close(), Ft.focus(), fe2.execCommand("SaveAs", true, ht), document.body.removeChild(zt);
        }
      } else {
        var re2 = v4.get("lang"), ye = '<body style="margin:0;"><img src="' + P2 + '" style="max-width:100%;" title="' + (re2 && re2[0] || "") + '" /></body>', me2 = window.open();
        me2.document.write(ye), me2.document.title = _;
      }
    }, i.getDefaultOption = function(t2) {
      var h = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: t2.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: t2.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
      return h;
    }, i;
  }($D), MTr = STr, eVe = "__ec_magicType_stack__", CTr = [["line", "bar"], ["stack"]], TTr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.getIcons = function() {
      var t2 = this.model, h = t2.get("icon"), v4 = {};
      return Qe2(t2.get("type"), function(_) {
        h[_] && (v4[_] = h[_]);
      }), v4;
    }, i.getDefaultOption = function(t2) {
      var h = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: t2.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
      return h;
    }, i.prototype.onclick = function(t2, h, v4) {
      var _ = this.model, M2 = _.get(["seriesIndex", v4]);
      if (!!nVe[v4]) {
        var I2 = { series: [] }, P2 = function(H2) {
          var $ = H2.subType, et = H2.id, at = nVe[v4]($, et, H2, _);
          at && (Ul(at, H2.option), I2.series.push(at));
          var ht = H2.coordinateSystem;
          if (ht && ht.type === "cartesian2d" && (v4 === "line" || v4 === "bar")) {
            var bt = ht.getAxesByScale("ordinal")[0];
            if (bt) {
              var _t = bt.dim, Et = _t + "Axis", zt = H2.getReferringComponents(Et, _m).models[0], Ft = zt.componentIndex;
              I2[Et] = I2[Et] || [];
              for (var fe2 = 0; fe2 <= Ft; fe2++)
                I2[Et][Ft] = I2[Et][Ft] || {};
              I2[Et][Ft].boundaryGap = v4 === "bar";
            }
          }
        };
        Qe2(CTr, function(H2) {
          Pc2(H2, v4) >= 0 && Qe2(H2, function($) {
            _.setIconStatus($, "normal");
          });
        }), _.setIconStatus(v4, "emphasis"), t2.eachComponent({ mainType: "series", query: M2 == null ? null : { seriesIndex: M2 } }, P2);
        var N3, z3 = v4;
        v4 === "stack" && (N3 = cc2({ stack: _.option.title.tiled, tiled: _.option.title.stack }, _.option.title), _.get(["iconStatus", v4]) !== "emphasis" && (z3 = "tiled")), h.dispatchAction({ type: "changeMagicType", currentType: z3, newOption: I2, newTitle: N3, featureName: "magicType" });
      }
    }, i;
  }($D), nVe = { line: function(f2, i, t2, h) {
    if (f2 === "bar")
      return cc2({ id: i, type: "line", data: t2.get("data"), stack: t2.get("stack"), markPoint: t2.get("markPoint"), markLine: t2.get("markLine") }, h.get(["option", "line"]) || {}, true);
  }, bar: function(f2, i, t2, h) {
    if (f2 === "line")
      return cc2({ id: i, type: "bar", data: t2.get("data"), stack: t2.get("stack"), markPoint: t2.get("markPoint"), markLine: t2.get("markLine") }, h.get(["option", "bar"]) || {}, true);
  }, stack: function(f2, i, t2, h) {
    var v4 = t2.get("stack") === eVe;
    if (f2 === "line" || f2 === "bar")
      return h.setIconStatus("stack", v4 ? "normal" : "emphasis"), cc2({ id: i, stack: v4 ? "" : eVe }, h.get(["option", "stack"]) || {}, true);
  } };
  ZL({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(f2, i) {
    i.mergeOption(f2.newOption);
  });
  var ATr = TTr, Hkt = new Array(60).join("-"), Ytt = "	";
  function ITr(f2) {
    var i = {}, t2 = [], h = [];
    return f2.eachRawSeries(function(v4) {
      var _ = v4.coordinateSystem;
      if (_ && (_.type === "cartesian2d" || _.type === "polar")) {
        var M2 = _.getBaseAxis();
        if (M2.type === "category") {
          var I2 = M2.dim + "_" + M2.index;
          i[I2] || (i[I2] = { categoryAxis: M2, valueAxis: _.getOtherAxis(M2), series: [] }, h.push({ axisDim: M2.dim, axisIndex: M2.index })), i[I2].series.push(v4);
        } else
          t2.push(v4);
      } else
        t2.push(v4);
    }), { seriesGroupByCategoryAxis: i, other: t2, meta: h };
  }
  function DTr(f2) {
    var i = [];
    return Qe2(f2, function(t2, h) {
      var v4 = t2.categoryAxis, _ = t2.valueAxis, M2 = _.dim, I2 = [" "].concat(Xa2(t2.series, function(et) {
        return et.name;
      })), P2 = [v4.model.getCategories()];
      Qe2(t2.series, function(et) {
        var at = et.getRawData();
        P2.push(et.getRawData().mapArray(at.mapDimension(M2), function(ht) {
          return ht;
        }));
      });
      for (var N3 = [I2.join(Ytt)], z3 = 0; z3 < P2[0].length; z3++) {
        for (var H2 = [], $ = 0; $ < P2.length; $++)
          H2.push(P2[$][z3]);
        N3.push(H2.join(Ytt));
      }
      i.push(N3.join(`
`));
    }), i.join(`

` + Hkt + `

`);
  }
  function ETr(f2) {
    return Xa2(f2, function(i) {
      var t2 = i.getRawData(), h = [i.name], v4 = [];
      return t2.each(t2.dimensions, function() {
        for (var _ = arguments.length, M2 = arguments[_ - 1], I2 = t2.getName(M2), P2 = 0; P2 < _ - 1; P2++)
          v4[P2] = arguments[P2];
        h.push((I2 ? I2 + Ytt : "") + v4.join(Ytt));
      }), h.join(`
`);
    }).join(`

` + Hkt + `

`);
  }
  function kTr(f2) {
    var i = ITr(f2);
    return { value: Ld2([DTr(i.seriesGroupByCategoryAxis), ETr(i.other)], function(t2) {
      return !!t2.replace(/[\n\t\s]/g, "");
    }).join(`

` + Hkt + `

`), meta: i.meta };
  }
  function ZEt(f2) {
    return f2.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
  }
  function PTr(f2) {
    var i = f2.slice(0, f2.indexOf(`
`));
    if (i.indexOf(Ytt) >= 0)
      return true;
  }
  var Bte = new RegExp("[" + Ytt + "]+", "g");
  function LTr(f2) {
    for (var i = f2.split(/\n+/g), t2 = ZEt(i.shift()).split(Bte), h = [], v4 = Xa2(t2, function(P2) {
      return { name: P2, data: [] };
    }), _ = 0; _ < i.length; _++) {
      var M2 = ZEt(i[_]).split(Bte);
      h.push(M2.shift());
      for (var I2 = 0; I2 < M2.length; I2++)
        v4[I2] && (v4[I2].data[_] = M2[I2]);
    }
    return { series: v4, categories: h };
  }
  function OTr(f2) {
    for (var i = f2.split(/\n+/g), t2 = ZEt(i.shift()), h = [], v4 = 0; v4 < i.length; v4++) {
      var _ = ZEt(i[v4]);
      if (!!_) {
        var M2 = _.split(Bte), I2 = "", P2 = void 0, N3 = false;
        isNaN(M2[0]) ? (N3 = true, I2 = M2[0], M2 = M2.slice(1), h[v4] = { name: I2, value: [] }, P2 = h[v4].value) : P2 = h[v4] = [];
        for (var z3 = 0; z3 < M2.length; z3++)
          P2.push(+M2[z3]);
        P2.length === 1 && (N3 ? h[v4].value = P2[0] : h[v4] = P2[0]);
      }
    }
    return { name: t2, data: h };
  }
  function RTr(f2, i) {
    var t2 = f2.split(new RegExp(`
*` + Hkt + `
*`, "g")), h = { series: [] };
    return Qe2(t2, function(v4, _) {
      if (PTr(v4)) {
        var M2 = LTr(v4), I2 = i[_], P2 = I2.axisDim + "Axis";
        I2 && (h[P2] = h[P2] || [], h[P2][I2.axisIndex] = { data: M2.categories }, h.series = h.series.concat(M2.series));
      } else {
        var M2 = OTr(v4);
        h.series.push(M2);
      }
    }), h;
  }
  var NTr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.onclick = function(t2, h) {
      setTimeout(function() {
        h.dispatchAction({ type: "hideTip" });
      });
      var v4 = h.getDom(), _ = this.model;
      this._dom && v4.removeChild(this._dom);
      var M2 = document.createElement("div");
      M2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", M2.style.backgroundColor = _.get("backgroundColor") || "#fff";
      var I2 = document.createElement("h4"), P2 = _.get("lang") || [];
      I2.innerHTML = P2[0] || _.get("title"), I2.style.cssText = "margin:10px 20px", I2.style.color = _.get("textColor");
      var N3 = document.createElement("div"), z3 = document.createElement("textarea");
      N3.style.cssText = "overflow:auto";
      var H2 = _.get("optionToContent"), $ = _.get("contentToOption"), et = kTr(t2);
      if (Ol(H2)) {
        var at = H2(h.getOption());
        ms(at) ? N3.innerHTML = at : qdt(at) && N3.appendChild(at);
      } else {
        z3.readOnly = _.get("readOnly");
        var ht = z3.style;
        ht.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", ht.color = _.get("textColor"), ht.borderColor = _.get("textareaBorderColor"), ht.backgroundColor = _.get("textareaColor"), z3.value = et.value, N3.appendChild(z3);
      }
      var bt = et.meta, _t = document.createElement("div");
      _t.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
      var Et = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", zt = document.createElement("div"), Ft = document.createElement("div");
      Et += ";background-color:" + _.get("buttonColor"), Et += ";color:" + _.get("buttonTextColor");
      var fe2 = this;
      function re2() {
        v4.removeChild(M2), fe2._dom = null;
      }
      _Jt(zt, "click", re2), _Jt(Ft, "click", function() {
        if ($ == null && H2 != null || $ != null && H2 == null) {
          re2();
          return;
        }
        var ye;
        try {
          Ol($) ? ye = $(N3, h.getOption()) : ye = RTr(z3.value, bt);
        } catch (me2) {
          throw re2(), new Error("Data view format error " + me2);
        }
        ye && h.dispatchAction({ type: "changeDataView", newOption: ye }), re2();
      }), zt.innerHTML = P2[1], Ft.innerHTML = P2[2], Ft.style.cssText = zt.style.cssText = Et, !_.get("readOnly") && _t.appendChild(Ft), _t.appendChild(zt), M2.appendChild(I2), M2.appendChild(N3), M2.appendChild(_t), N3.style.height = v4.clientHeight - 80 + "px", v4.appendChild(M2), this._dom = M2;
    }, i.prototype.remove = function(t2, h) {
      this._dom && h.getDom().removeChild(this._dom);
    }, i.prototype.dispose = function(t2, h) {
      this.remove(t2, h);
    }, i.getDefaultOption = function(t2) {
      var h = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: t2.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: t2.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
      return h;
    }, i;
  }($D);
  function FTr(f2, i) {
    return Xa2(f2, function(t2, h) {
      var v4 = i && i[h];
      if (Xl(v4) && !Za2(v4)) {
        var _ = Xl(t2) && !Za2(t2);
        _ || (t2 = { value: t2 });
        var M2 = v4.name != null && t2.name == null;
        return t2 = Ul(t2, v4), M2 && delete t2.name, t2;
      } else
        return t2;
    });
  }
  ZL({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(f2, i) {
    var t2 = [];
    Qe2(f2.newOption.series, function(h) {
      var v4 = i.getSeriesByName(h.name)[0];
      if (!v4)
        t2.push(ba2({ type: "scatter" }, h));
      else {
        var _ = v4.get("data");
        t2.push({ name: h.name, data: FTr(h.data, _) });
      }
    }), i.mergeOption(Ul({ series: t2 }, f2.newOption));
  });
  var VTr = NTr, Sqe = Qe2, Mqe = Wh2();
  function BTr(f2, i) {
    var t2 = fre(f2);
    Sqe(i, function(h, v4) {
      for (var _ = t2.length - 1; _ >= 0; _--) {
        var M2 = t2[_];
        if (M2[v4])
          break;
      }
      if (_ < 0) {
        var I2 = f2.queryComponents({ mainType: "dataZoom", subType: "select", id: v4 })[0];
        if (I2) {
          var P2 = I2.getPercentRange();
          t2[0][v4] = { dataZoomId: v4, start: P2[0], end: P2[1] };
        }
      }
    }), t2.push(i);
  }
  function zTr(f2) {
    var i = fre(f2), t2 = i[i.length - 1];
    i.length > 1 && i.pop();
    var h = {};
    return Sqe(t2, function(v4, _) {
      for (var M2 = i.length - 1; M2 >= 0; M2--)
        if (v4 = i[M2][_], v4) {
          h[_] = v4;
          break;
        }
    }), h;
  }
  function jTr(f2) {
    Mqe(f2).snapshots = null;
  }
  function WTr(f2) {
    return fre(f2).length;
  }
  function fre(f2) {
    var i = Mqe(f2);
    return i.snapshots || (i.snapshots = [{}]), i.snapshots;
  }
  var GTr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.onclick = function(t2, h) {
      jTr(t2), h.dispatchAction({ type: "restore", from: this.uid });
    }, i.getDefaultOption = function(t2) {
      var h = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: t2.getLocaleModel().get(["toolbox", "restore", "title"]) };
      return h;
    }, i;
  }($D);
  ZL({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(f2, i) {
    i.resetOption("recreate");
  });
  var HTr = GTr, UTr = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], qTr = function() {
    function f2(i, t2, h) {
      var v4 = this;
      this._targetInfoList = [];
      var _ = rVe(t2, i);
      Qe2(ZTr, function(M2, I2) {
        (!h || !h.include || Pc2(h.include, I2) >= 0) && M2(_, v4._targetInfoList);
      });
    }
    return f2.prototype.setOutputRanges = function(i, t2) {
      return this.matchOutputRanges(i, t2, function(h, v4, _) {
        if ((h.coordRanges || (h.coordRanges = [])).push(v4), !h.coordRange) {
          h.coordRange = v4;
          var M2 = BQt[h.brushType](0, _, v4);
          h.__rangeOffset = { offset: sVe[h.brushType](M2.values, h.range, [1, 1]), xyMinMax: M2.xyMinMax };
        }
      }), i;
    }, f2.prototype.matchOutputRanges = function(i, t2, h) {
      Qe2(i, function(v4) {
        var _ = this.findTargetInfo(v4, t2);
        _ && _ !== true && Qe2(_.coordSyses, function(M2) {
          var I2 = BQt[v4.brushType](1, M2, v4.range, true);
          h(v4, I2.values, M2, t2);
        });
      }, this);
    }, f2.prototype.setInputRanges = function(i, t2) {
      Qe2(i, function(h) {
        var v4 = this.findTargetInfo(h, t2);
        if (h.range = h.range || [], v4 && v4 !== true) {
          h.panelId = v4.panelId;
          var _ = BQt[h.brushType](0, v4.coordSys, h.coordRange), M2 = h.__rangeOffset;
          h.range = M2 ? sVe[h.brushType](_.values, M2.offset, $Tr(_.xyMinMax, M2.xyMinMax)) : _.values;
        }
      }, this);
    }, f2.prototype.makePanelOpts = function(i, t2) {
      return Xa2(this._targetInfoList, function(h) {
        var v4 = h.getPanelRect();
        return { panelId: h.panelId, defaultBrushType: t2 ? t2(h) : null, clipPath: kUe(v4), isTargetByCursor: LUe(v4, i, h.coordSysModel), getLinearBrushOtherExtent: PUe(v4) };
      });
    }, f2.prototype.controlSeries = function(i, t2, h) {
      var v4 = this.findTargetInfo(i, h);
      return v4 === true || v4 && Pc2(v4.coordSyses, t2.coordinateSystem) >= 0;
    }, f2.prototype.findTargetInfo = function(i, t2) {
      for (var h = this._targetInfoList, v4 = rVe(t2, i), _ = 0; _ < h.length; _++) {
        var M2 = h[_], I2 = i.panelId;
        if (I2) {
          if (M2.panelId === I2)
            return M2;
        } else
          for (var P2 = 0; P2 < iVe.length; P2++)
            if (iVe[P2](v4, M2))
              return M2;
      }
      return true;
    }, f2;
  }();
  function zte(f2) {
    return f2[0] > f2[1] && f2.reverse(), f2;
  }
  function rVe(f2, i) {
    return kdt(f2, i, { includeMainTypes: UTr });
  }
  var ZTr = { grid: function(f2, i) {
    var t2 = f2.xAxisModels, h = f2.yAxisModels, v4 = f2.gridModels, _ = Il(), M2 = {}, I2 = {};
    !t2 && !h && !v4 || (Qe2(t2, function(P2) {
      var N3 = P2.axis.grid.model;
      _.set(N3.id, N3), M2[N3.id] = true;
    }), Qe2(h, function(P2) {
      var N3 = P2.axis.grid.model;
      _.set(N3.id, N3), I2[N3.id] = true;
    }), Qe2(v4, function(P2) {
      _.set(P2.id, P2), M2[P2.id] = true, I2[P2.id] = true;
    }), _.each(function(P2) {
      var N3 = P2.coordinateSystem, z3 = [];
      Qe2(N3.getCartesians(), function(H2, $) {
        (Pc2(t2, H2.getAxis("x").model) >= 0 || Pc2(h, H2.getAxis("y").model) >= 0) && z3.push(H2);
      }), i.push({ panelId: "grid--" + P2.id, gridModel: P2, coordSysModel: P2, coordSys: z3[0], coordSyses: z3, getPanelRect: aVe.grid, xAxisDeclared: M2[P2.id], yAxisDeclared: I2[P2.id] });
    }));
  }, geo: function(f2, i) {
    Qe2(f2.geoModels, function(t2) {
      var h = t2.coordinateSystem;
      i.push({ panelId: "geo--" + t2.id, geoModel: t2, coordSysModel: t2, coordSys: h, coordSyses: [h], getPanelRect: aVe.geo });
    });
  } }, iVe = [function(f2, i) {
    var t2 = f2.xAxisModel, h = f2.yAxisModel, v4 = f2.gridModel;
    return !v4 && t2 && (v4 = t2.axis.grid.model), !v4 && h && (v4 = h.axis.grid.model), v4 && v4 === i.gridModel;
  }, function(f2, i) {
    var t2 = f2.geoModel;
    return t2 && t2 === i.geoModel;
  }], aVe = { grid: function() {
    return this.coordSys.master.getRect().clone();
  }, geo: function() {
    var f2 = this.coordSys, i = f2.getBoundingRect().clone();
    return i.applyTransform(cU(f2)), i;
  } }, BQt = { lineX: Ou(oVe, 0), lineY: Ou(oVe, 1), rect: function(f2, i, t2, h) {
    var v4 = f2 ? i.pointToData([t2[0][0], t2[1][0]], h) : i.dataToPoint([t2[0][0], t2[1][0]], h), _ = f2 ? i.pointToData([t2[0][1], t2[1][1]], h) : i.dataToPoint([t2[0][1], t2[1][1]], h), M2 = [zte([v4[0], _[0]]), zte([v4[1], _[1]])];
    return { values: M2, xyMinMax: M2 };
  }, polygon: function(f2, i, t2, h) {
    var v4 = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], _ = Xa2(t2, function(M2) {
      var I2 = f2 ? i.pointToData(M2, h) : i.dataToPoint(M2, h);
      return v4[0][0] = Math.min(v4[0][0], I2[0]), v4[1][0] = Math.min(v4[1][0], I2[1]), v4[0][1] = Math.max(v4[0][1], I2[0]), v4[1][1] = Math.max(v4[1][1], I2[1]), I2;
    });
    return { values: _, xyMinMax: v4 };
  } };
  function oVe(f2, i, t2, h) {
    var v4 = t2.getAxis(["x", "y"][f2]), _ = zte(Xa2([0, 1], function(I2) {
      return i ? v4.coordToData(v4.toLocalCoord(h[I2]), true) : v4.toGlobalCoord(v4.dataToCoord(h[I2]));
    })), M2 = [];
    return M2[f2] = _, M2[1 - f2] = [NaN, NaN], { values: _, xyMinMax: M2 };
  }
  var sVe = { lineX: Ou(lVe, 0), lineY: Ou(lVe, 1), rect: function(f2, i, t2) {
    return [[f2[0][0] - t2[0] * i[0][0], f2[0][1] - t2[0] * i[0][1]], [f2[1][0] - t2[1] * i[1][0], f2[1][1] - t2[1] * i[1][1]]];
  }, polygon: function(f2, i, t2) {
    return Xa2(f2, function(h, v4) {
      return [h[0] - t2[0] * i[v4][0], h[1] - t2[1] * i[v4][1]];
    });
  } };
  function lVe(f2, i, t2, h) {
    return [i[0] - h[f2] * t2[0], i[1] - h[f2] * t2[1]];
  }
  function $Tr(f2, i) {
    var t2 = uVe(f2), h = uVe(i), v4 = [t2[0] / h[0], t2[1] / h[1]];
    return isNaN(v4[0]) && (v4[0] = 1), isNaN(v4[1]) && (v4[1] = 1), v4;
  }
  function uVe(f2) {
    return f2 ? [f2[0][1] - f2[0][0], f2[1][1] - f2[1][0]] : [NaN, NaN];
  }
  var hre = qTr, jte = Qe2, YTr = hcr("toolbox-dataZoom_"), KTr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.render = function(t2, h, v4, _) {
      this._brushController || (this._brushController = new qne(v4.getZr()), this._brushController.on("brush", ks(this._onBrush, this)).mount()), JTr(t2, h, this, _, v4), QTr(t2, h);
    }, i.prototype.onclick = function(t2, h, v4) {
      XTr[v4].call(this);
    }, i.prototype.remove = function(t2, h) {
      this._brushController && this._brushController.unmount();
    }, i.prototype.dispose = function(t2, h) {
      this._brushController && this._brushController.dispose();
    }, i.prototype._onBrush = function(t2) {
      var h = t2.areas;
      if (!t2.isEnd || !h.length)
        return;
      var v4 = {}, _ = this.ecModel;
      this._brushController.updateCovers([]);
      var M2 = new hre(pre(this.model), _, { include: ["grid"] });
      M2.matchOutputRanges(h, _, function(N3, z3, H2) {
        if (H2.type === "cartesian2d") {
          var $ = N3.brushType;
          $ === "rect" ? (I2("x", H2, z3[0]), I2("y", H2, z3[1])) : I2({ lineX: "x", lineY: "y" }[$], H2, z3);
        }
      }), BTr(_, v4), this._dispatchZoomAction(v4);
      function I2(N3, z3, H2) {
        var $ = z3.getAxis(N3), et = $.model, at = P2(N3, et, _), ht = at.findRepresentativeAxisProxy(et).getMinMaxSpan();
        (ht.minValueSpan != null || ht.maxValueSpan != null) && (H2 = AU(0, H2.slice(), $.scale.getExtent(), 0, ht.minValueSpan, ht.maxValueSpan)), at && (v4[at.id] = { dataZoomId: at.id, startValue: H2[0], endValue: H2[1] });
      }
      function P2(N3, z3, H2) {
        var $;
        return H2.eachComponent({ mainType: "dataZoom", subType: "select" }, function(et) {
          var at = et.getAxisModel(N3, z3.componentIndex);
          at && ($ = et);
        }), $;
      }
    }, i.prototype._dispatchZoomAction = function(t2) {
      var h = [];
      jte(t2, function(v4, _) {
        h.push(pu(v4));
      }), h.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: h });
    }, i.getDefaultOption = function(t2) {
      var h = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: t2.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
      return h;
    }, i;
  }($D), XTr = { zoom: function() {
    var f2 = !this._isZoomActive;
    this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: f2 });
  }, back: function() {
    this._dispatchZoomAction(zTr(this.ecModel));
  } };
  function pre(f2) {
    var i = { xAxisIndex: f2.get("xAxisIndex", true), yAxisIndex: f2.get("yAxisIndex", true), xAxisId: f2.get("xAxisId", true), yAxisId: f2.get("yAxisId", true) };
    return i.xAxisIndex == null && i.xAxisId == null && (i.xAxisIndex = "all"), i.yAxisIndex == null && i.yAxisId == null && (i.yAxisIndex = "all"), i;
  }
  function QTr(f2, i) {
    f2.setIconStatus("back", WTr(i) > 1 ? "emphasis" : "normal");
  }
  function JTr(f2, i, t2, h, v4) {
    var _ = t2._isZoomActive;
    h && h.type === "takeGlobalCursor" && (_ = h.key === "dataZoomSelect" ? h.dataZoomSelectActive : false), t2._isZoomActive = _, f2.setIconStatus("zoom", _ ? "emphasis" : "normal");
    var M2 = new hre(pre(f2), i, { include: ["grid"] }), I2 = M2.makePanelOpts(v4, function(P2) {
      return P2.xAxisDeclared && !P2.yAxisDeclared ? "lineX" : !P2.xAxisDeclared && P2.yAxisDeclared ? "lineY" : "rect";
    });
    t2._brushController.setPanels(I2).enableBrush(_ && I2.length ? { brushType: "auto", brushStyle: f2.getModel("brushStyle").getItemStyle() } : false);
  }
  Xhr("dataZoom", function(f2) {
    var i = f2.getComponent("toolbox", 0), t2 = ["feature", "dataZoom"];
    if (!i || i.get(t2) == null)
      return;
    var h = i.getModel(t2), v4 = [], _ = pre(h), M2 = kdt(f2, _);
    jte(M2.xAxisModels, function(P2) {
      return I2(P2, "xAxis", "xAxisIndex");
    }), jte(M2.yAxisModels, function(P2) {
      return I2(P2, "yAxis", "yAxisIndex");
    });
    function I2(P2, N3, z3) {
      var H2 = P2.componentIndex, $ = { type: "select", $fromToolbox: true, filterMode: h.get("filterMode", true) || "filter", id: YTr + N3 + H2 };
      $[z3] = H2, v4.push($);
    }
    return v4;
  });
  var tAr = KTr;
  function eAr(f2) {
    f2.registerComponentModel(mTr), f2.registerComponentView(wTr), Mtt("saveAsImage", MTr), Mtt("magicType", ATr), Mtt("dataView", VTr), Mtt("dataZoom", tAr), Mtt("restore", HTr), zc2(vTr);
  }
  var nAr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "tooltip", i.dependencies = ["axisPointer"], i.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, i;
  }(zh2), rAr = nAr;
  function Cqe(f2) {
    var i = f2.get("confine");
    return i != null ? !!i : f2.get("renderMode") === "richText";
  }
  function Tqe(f2) {
    if (!!gp.domSupported) {
      for (var i = document.documentElement.style, t2 = 0, h = f2.length; t2 < h; t2++)
        if (f2[t2] in i)
          return f2[t2];
    }
  }
  var Aqe = Tqe(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), iAr = Tqe(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
  function Iqe(f2, i) {
    if (!f2)
      return i;
    i = tWe(i, true);
    var t2 = f2.indexOf(i);
    return f2 = t2 === -1 ? i : "-" + f2.slice(0, t2) + "-" + i, f2.toLowerCase();
  }
  function aAr(f2, i) {
    var t2 = f2.currentStyle || document.defaultView && document.defaultView.getComputedStyle(f2);
    return t2 ? i ? t2[i] : t2 : null;
  }
  var oAr = Iqe(iAr, "transition"), dre = Iqe(Aqe, "transform"), sAr = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (gp.transform3dSupported ? "will-change:transform;" : "");
  function lAr(f2) {
    return f2 = f2 === "left" ? "right" : f2 === "right" ? "left" : f2 === "top" ? "bottom" : "top", f2;
  }
  function uAr(f2, i, t2) {
    if (!ms(t2) || t2 === "inside")
      return "";
    var h = f2.get("backgroundColor"), v4 = f2.get("borderWidth");
    i = bU(i);
    var _ = lAr(t2), M2 = Math.max(Math.round(v4) * 1.5, 6), I2 = "", P2 = dre + ":", N3;
    Pc2(["left", "right"], _) > -1 ? (I2 += "top:50%", P2 += "translateY(-50%) rotate(" + (N3 = _ === "left" ? -225 : -45) + "deg)") : (I2 += "left:50%", P2 += "translateX(-50%) rotate(" + (N3 = _ === "top" ? 225 : 45) + "deg)");
    var z3 = N3 * Math.PI / 180, H2 = M2 + v4, $ = H2 * Math.abs(Math.cos(z3)) + H2 * Math.abs(Math.sin(z3)), et = Math.round((($ - Math.SQRT2 * v4) / 2 + Math.SQRT2 * v4 - ($ - H2) / 2) * 100) / 100;
    I2 += ";" + _ + ":-" + et + "px";
    var at = i + " solid " + v4 + "px;", ht = ["position:absolute;width:" + M2 + "px;height:" + M2 + "px;", I2 + ";" + P2 + ";", "border-bottom:" + at, "border-right:" + at, "background-color:" + h + ";"];
    return '<div style="' + ht.join("") + '"></div>';
  }
  function cAr(f2, i) {
    var t2 = "cubic-bezier(0.23,1,0.32,1)", h = " " + f2 / 2 + "s " + t2, v4 = "opacity" + h + ",visibility" + h;
    return i || (h = " " + f2 + "s " + t2, v4 += gp.transformSupported ? "," + dre + h : ",left" + h + ",top" + h), oAr + ":" + v4;
  }
  function cVe(f2, i, t2) {
    var h = f2.toFixed(0) + "px", v4 = i.toFixed(0) + "px";
    if (!gp.transformSupported)
      return t2 ? "top:" + v4 + ";left:" + h + ";" : [["top", v4], ["left", h]];
    var _ = gp.transform3dSupported, M2 = "translate" + (_ ? "3d" : "") + "(" + h + "," + v4 + (_ ? ",0" : "") + ")";
    return t2 ? "top:0;left:0;" + dre + ":" + M2 + ";" : [["top", 0], ["left", 0], [Aqe, M2]];
  }
  function fAr(f2) {
    var i = [], t2 = f2.get("fontSize"), h = f2.getTextColor();
    h && i.push("color:" + h), i.push("font:" + f2.getFont()), t2 && i.push("line-height:" + Math.round(t2 * 3 / 2) + "px");
    var v4 = f2.get("textShadowColor"), _ = f2.get("textShadowBlur") || 0, M2 = f2.get("textShadowOffsetX") || 0, I2 = f2.get("textShadowOffsetY") || 0;
    return v4 && _ && i.push("text-shadow:" + M2 + "px " + I2 + "px " + _ + "px " + v4), Qe2(["decoration", "align"], function(P2) {
      var N3 = f2.get(P2);
      N3 && i.push("text-" + P2 + ":" + N3);
    }), i.join(";");
  }
  function hAr(f2, i, t2) {
    var h = [], v4 = f2.get("transitionDuration"), _ = f2.get("backgroundColor"), M2 = f2.get("shadowBlur"), I2 = f2.get("shadowColor"), P2 = f2.get("shadowOffsetX"), N3 = f2.get("shadowOffsetY"), z3 = f2.getModel("textStyle"), H2 = NWe(f2, "html"), $ = P2 + "px " + N3 + "px " + M2 + "px " + I2;
    return h.push("box-shadow:" + $), i && v4 && h.push(cAr(v4, t2)), _ && h.push("background-color:" + _), Qe2(["width", "color", "radius"], function(et) {
      var at = "border-" + et, ht = tWe(at), bt = f2.get(ht);
      bt != null && h.push(at + ":" + bt + (et === "color" ? "" : "px"));
    }), h.push(fAr(z3)), H2 != null && h.push("padding:" + iet(H2).join("px ") + "px"), h.join(";") + ";";
  }
  function fVe(f2, i, t2, h, v4) {
    var _ = i && i.painter;
    if (t2) {
      var M2 = _ && _.getViewportRoot();
      M2 && Flr(f2, M2, document.body, h, v4);
    } else {
      f2[0] = h, f2[1] = v4;
      var I2 = _ && _.getViewportRootOffset();
      I2 && (f2[0] += I2.offsetLeft, f2[1] += I2.offsetTop);
    }
    f2[2] = f2[0] / i.getWidth(), f2[3] = f2[1] / i.getHeight();
  }
  var pAr = function() {
    function f2(i, t2, h) {
      if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, gp.wxa)
        return null;
      var v4 = document.createElement("div");
      v4.domBelongToZr = true, this.el = v4;
      var _ = this._zr = t2.getZr(), M2 = this._appendToBody = h && h.appendToBody;
      fVe(this._styleCoord, _, M2, t2.getWidth() / 2, t2.getHeight() / 2), M2 ? document.body.appendChild(v4) : i.appendChild(v4), this._container = i;
      var I2 = this;
      v4.onmouseenter = function() {
        I2._enterable && (clearTimeout(I2._hideTimeout), I2._show = true), I2._inContent = true;
      }, v4.onmousemove = function(P2) {
        if (P2 = P2 || window.event, !I2._enterable) {
          var N3 = _.handler, z3 = _.painter.getViewportRoot();
          GD(z3, P2, true), N3.dispatch("mousemove", P2);
        }
      }, v4.onmouseleave = function() {
        I2._inContent = false, I2._enterable && I2._show && I2.hideLater(I2._hideDelay);
      };
    }
    return f2.prototype.update = function(i) {
      var t2 = this._container, h = aAr(t2, "position"), v4 = t2.style;
      v4.position !== "absolute" && h !== "absolute" && (v4.position = "relative");
      var _ = i.get("alwaysShowContent");
      _ && this._moveIfResized(), this.el.className = i.get("className") || "";
    }, f2.prototype.show = function(i, t2) {
      clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
      var h = this.el, v4 = h.style, _ = this._styleCoord;
      h.innerHTML ? v4.cssText = sAr + hAr(i, !this._firstShow, this._longHide) + cVe(_[0], _[1], true) + ("border-color:" + bU(t2) + ";") + (i.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : v4.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
    }, f2.prototype.setContent = function(i, t2, h, v4, _) {
      var M2 = this.el;
      if (i == null) {
        M2.innerHTML = "";
        return;
      }
      var I2 = "";
      if (ms(_) && h.get("trigger") === "item" && !Cqe(h) && (I2 = uAr(h, v4, _)), ms(i))
        M2.innerHTML = i + I2;
      else if (i) {
        M2.innerHTML = "", Za2(i) || (i = [i]);
        for (var P2 = 0; P2 < i.length; P2++)
          qdt(i[P2]) && i[P2].parentNode !== M2 && M2.appendChild(i[P2]);
        if (I2 && M2.childNodes.length) {
          var N3 = document.createElement("div");
          N3.innerHTML = I2, M2.appendChild(N3);
        }
      }
    }, f2.prototype.setEnterable = function(i) {
      this._enterable = i;
    }, f2.prototype.getSize = function() {
      var i = this.el;
      return [i.offsetWidth, i.offsetHeight];
    }, f2.prototype.moveTo = function(i, t2) {
      var h = this._styleCoord;
      if (fVe(h, this._zr, this._appendToBody, i, t2), h[0] != null && h[1] != null) {
        var v4 = this.el.style, _ = cVe(h[0], h[1]);
        Qe2(_, function(M2) {
          v4[M2[0]] = M2[1];
        });
      }
    }, f2.prototype._moveIfResized = function() {
      var i = this._styleCoord[2], t2 = this._styleCoord[3];
      this.moveTo(i * this._zr.getWidth(), t2 * this._zr.getHeight());
    }, f2.prototype.hide = function() {
      var i = this, t2 = this.el.style;
      t2.visibility = "hidden", t2.opacity = "0", gp.transform3dSupported && (t2.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
        return i._longHide = true;
      }, 500);
    }, f2.prototype.hideLater = function(i) {
      this._show && !(this._inContent && this._enterable) && (i ? (this._hideDelay = i, this._show = false, this._hideTimeout = setTimeout(ks(this.hide, this), i)) : this.hide());
    }, f2.prototype.isShow = function() {
      return this._show;
    }, f2.prototype.dispose = function() {
      this.el.parentNode.removeChild(this.el);
    }, f2;
  }(), dAr = pAr, gAr = function() {
    function f2(i) {
      this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = i.getZr(), pVe(this._styleCoord, this._zr, i.getWidth() / 2, i.getHeight() / 2);
    }
    return f2.prototype.update = function(i) {
      var t2 = i.get("alwaysShowContent");
      t2 && this._moveIfResized();
    }, f2.prototype.show = function() {
      this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
    }, f2.prototype.setContent = function(i, t2, h, v4, _) {
      var M2 = this;
      Xl(i) && Ep(""), this.el && this._zr.remove(this.el);
      var I2 = h.getModel("textStyle");
      this.el = new op({ style: { rich: t2.richTextStyles, text: i, lineHeight: 22, borderWidth: 1, borderColor: v4, textShadowColor: I2.get("textShadowColor"), fill: h.get(["textStyle", "color"]), padding: NWe(h, "richText"), verticalAlign: "top", align: "left" }, z: h.get("z") }), Qe2(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(N3) {
        M2.el.style[N3] = h.get(N3);
      }), Qe2(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(N3) {
        M2.el.style[N3] = I2.get(N3) || 0;
      }), this._zr.add(this.el);
      var P2 = this;
      this.el.on("mouseover", function() {
        P2._enterable && (clearTimeout(P2._hideTimeout), P2._show = true), P2._inContent = true;
      }), this.el.on("mouseout", function() {
        P2._enterable && P2._show && P2.hideLater(P2._hideDelay), P2._inContent = false;
      });
    }, f2.prototype.setEnterable = function(i) {
      this._enterable = i;
    }, f2.prototype.getSize = function() {
      var i = this.el, t2 = this.el.getBoundingRect(), h = hVe(i.style);
      return [t2.width + h.left + h.right, t2.height + h.top + h.bottom];
    }, f2.prototype.moveTo = function(i, t2) {
      var h = this.el;
      if (h) {
        var v4 = this._styleCoord;
        pVe(v4, this._zr, i, t2), i = v4[0], t2 = v4[1];
        var _ = h.style, M2 = P7(_.borderWidth || 0), I2 = hVe(_);
        h.x = i + M2 + I2.left, h.y = t2 + M2 + I2.top, h.markRedraw();
      }
    }, f2.prototype._moveIfResized = function() {
      var i = this._styleCoord[2], t2 = this._styleCoord[3];
      this.moveTo(i * this._zr.getWidth(), t2 * this._zr.getHeight());
    }, f2.prototype.hide = function() {
      this.el && this.el.hide(), this._show = false;
    }, f2.prototype.hideLater = function(i) {
      this._show && !(this._inContent && this._enterable) && (i ? (this._hideDelay = i, this._show = false, this._hideTimeout = setTimeout(ks(this.hide, this), i)) : this.hide());
    }, f2.prototype.isShow = function() {
      return this._show;
    }, f2.prototype.dispose = function() {
      this._zr.remove(this.el);
    }, f2;
  }();
  function P7(f2) {
    return Math.max(0, f2);
  }
  function hVe(f2) {
    var i = P7(f2.shadowBlur || 0), t2 = P7(f2.shadowOffsetX || 0), h = P7(f2.shadowOffsetY || 0);
    return { left: P7(i - t2), right: P7(i + t2), top: P7(i - h), bottom: P7(i + h) };
  }
  function pVe(f2, i, t2, h) {
    f2[0] = t2, f2[1] = h, f2[2] = f2[0] / i.getWidth(), f2[3] = f2[1] / i.getHeight();
  }
  var vAr = gAr, yAr = new Sh2({ shape: { x: -1, y: -1, width: 2, height: 2 } }), mAr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2, h) {
      if (!(gp.node || !h.getDom())) {
        var v4 = t2.getComponent("tooltip"), _ = this._renderMode = bcr(v4.get("renderMode"));
        this._tooltipContent = _ === "richText" ? new vAr(h) : new dAr(h.getDom(), h, { appendToBody: v4.get("appendToBody", true) });
      }
    }, i.prototype.render = function(t2, h, v4) {
      if (!(gp.node || !v4.getDom())) {
        this.group.removeAll(), this._tooltipModel = t2, this._ecModel = h, this._api = v4, this._alwaysShowContent = t2.get("alwaysShowContent");
        var _ = this._tooltipContent;
        _.update(t2), _.setEnterable(t2.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && t2.get("transitionDuration") ? cet(this, "_updatePosition", 50, "fixRate") : agt(this, "_updatePosition");
      }
    }, i.prototype._initGlobalListener = function() {
      var t2 = this._tooltipModel, h = t2.get("triggerOn");
      fqe("itemTooltip", this._api, ks(function(v4, _, M2) {
        h !== "none" && (h.indexOf(v4) >= 0 ? this._tryShow(_, M2) : v4 === "leave" && this._hide(M2));
      }, this));
    }, i.prototype._keepShow = function() {
      var t2 = this._tooltipModel, h = this._ecModel, v4 = this._api;
      if (this._lastX != null && this._lastY != null && t2.get("triggerOn") !== "none") {
        var _ = this;
        clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
          !v4.isDisposed() && _.manuallyShowTip(t2, h, v4, { x: _._lastX, y: _._lastY, dataByCoordSys: _._lastDataByCoordSys });
        });
      }
    }, i.prototype.manuallyShowTip = function(t2, h, v4, _) {
      if (!(_.from === this.uid || gp.node || !v4.getDom())) {
        var M2 = dVe(_, v4);
        this._ticket = "";
        var I2 = _.dataByCoordSys, P2 = wAr(_, h, v4);
        if (P2) {
          var N3 = P2.el.getBoundingRect().clone();
          N3.applyTransform(P2.el.transform), this._tryShow({ offsetX: N3.x + N3.width / 2, offsetY: N3.y + N3.height / 2, target: P2.el, position: _.position, positionDefault: "bottom" }, M2);
        } else if (_.tooltip && _.x != null && _.y != null) {
          var z3 = yAr;
          z3.x = _.x, z3.y = _.y, z3.update(), Du(z3).tooltipConfig = { name: null, option: _.tooltip }, this._tryShow({ offsetX: _.x, offsetY: _.y, target: z3 }, M2);
        } else if (I2)
          this._tryShow({ offsetX: _.x, offsetY: _.y, position: _.position, dataByCoordSys: I2, tooltipOption: _.tooltipOption }, M2);
        else if (_.seriesIndex != null) {
          if (this._manuallyAxisShowTip(t2, h, v4, _))
            return;
          var H2 = hqe(_, h), $ = H2.point[0], et = H2.point[1];
          $ != null && et != null && this._tryShow({ offsetX: $, offsetY: et, target: H2.el, position: _.position, positionDefault: "bottom" }, M2);
        } else
          _.x != null && _.y != null && (v4.dispatchAction({ type: "updateAxisPointer", x: _.x, y: _.y }), this._tryShow({ offsetX: _.x, offsetY: _.y, position: _.position, target: v4.getZr().findHover(_.x, _.y).target }, M2));
      }
    }, i.prototype.manuallyHideTip = function(t2, h, v4, _) {
      var M2 = this._tooltipContent;
      !this._alwaysShowContent && this._tooltipModel && M2.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, _.from !== this.uid && this._hide(dVe(_, v4));
    }, i.prototype._manuallyAxisShowTip = function(t2, h, v4, _) {
      var M2 = _.seriesIndex, I2 = _.dataIndex, P2 = h.getComponent("axisPointer").coordSysAxesInfo;
      if (!(M2 == null || I2 == null || P2 == null)) {
        var N3 = h.getSeriesByIndex(M2);
        if (!!N3) {
          var z3 = N3.getData(), H2 = odt([z3.getItemModel(I2), N3, (N3.coordinateSystem || {}).model], this._tooltipModel);
          if (H2.get("trigger") === "axis")
            return v4.dispatchAction({ type: "updateAxisPointer", seriesIndex: M2, dataIndex: I2, position: _.position }), true;
        }
      }
    }, i.prototype._tryShow = function(t2, h) {
      var v4 = t2.target, _ = this._tooltipModel;
      if (!!_) {
        this._lastX = t2.offsetX, this._lastY = t2.offsetY;
        var M2 = t2.dataByCoordSys;
        if (M2 && M2.length)
          this._showAxisTooltip(M2, t2);
        else if (v4) {
          this._lastDataByCoordSys = null;
          var I2, P2;
          Itt(v4, function(N3) {
            if (Du(N3).dataIndex != null)
              return I2 = N3, true;
            if (Du(N3).tooltipConfig != null)
              return P2 = N3, true;
          }, true), I2 ? this._showSeriesItemTooltip(t2, I2, h) : P2 ? this._showComponentItemTooltip(t2, P2, h) : this._hide(h);
        } else
          this._lastDataByCoordSys = null, this._hide(h);
      }
    }, i.prototype._showOrMove = function(t2, h) {
      var v4 = t2.get("showDelay");
      h = ks(h, this), clearTimeout(this._showTimout), v4 > 0 ? this._showTimout = setTimeout(h, v4) : h();
    }, i.prototype._showAxisTooltip = function(t2, h) {
      var v4 = this._ecModel, _ = this._tooltipModel, M2 = [h.offsetX, h.offsetY], I2 = odt([h.tooltipOption], _), P2 = this._renderMode, N3 = [], z3 = pb2("section", { blocks: [], noHeader: true }), H2 = [], $ = new CXt();
      Qe2(t2, function(Et) {
        Qe2(Et.dataByAxis, function(zt) {
          var Ft = v4.getComponent(zt.axisDim + "Axis", zt.axisIndex), fe2 = zt.value;
          if (!(!Ft || fe2 == null)) {
            var re2 = lqe(fe2, Ft.axis, v4, zt.seriesDataIndices, zt.valueLabelOpt), ye = pb2("section", { header: re2, noHeader: !w5(re2), sortBlocks: true, blocks: [] });
            z3.blocks.push(ye), Qe2(zt.seriesDataIndices, function(me2) {
              var be2 = v4.getSeriesByIndex(me2.seriesIndex), Te2 = me2.dataIndexInside, We = be2.getDataParams(Te2);
              if (!(We.dataIndex < 0)) {
                We.axisDim = zt.axisDim, We.axisIndex = zt.axisIndex, We.axisType = zt.axisType, We.axisId = zt.axisId, We.axisValue = mne(Ft.axis, { value: fe2 }), We.axisValueLabel = re2, We.marker = $.makeTooltipMarker("item", bU(We.color), P2);
                var en = JNe(be2.formatTooltip(Te2, true, null)), Ue2 = en.frag;
                if (Ue2) {
                  var Mn = odt([be2], _).get("valueFormatter");
                  ye.blocks.push(Mn ? ba2({ valueFormatter: Mn }, Ue2) : Ue2);
                }
                en.text && H2.push(en.text), N3.push(We);
              }
            });
          }
        });
      }), z3.blocks.reverse(), H2.reverse();
      var et = h.position, at = I2.get("order"), ht = aFe(z3, $, P2, at, v4.get("useUTC"), I2.get("textStyle"));
      ht && H2.unshift(ht);
      var bt = P2 === "richText" ? `

` : "<br/>", _t = H2.join(bt);
      this._showOrMove(I2, function() {
        this._updateContentNotChangedOnAxis(t2, N3) ? this._updatePosition(I2, et, M2[0], M2[1], this._tooltipContent, N3) : this._showTooltipContent(I2, _t, N3, Math.random() + "", M2[0], M2[1], et, null, $);
      });
    }, i.prototype._showSeriesItemTooltip = function(t2, h, v4) {
      var _ = this._ecModel, M2 = Du(h), I2 = M2.seriesIndex, P2 = _.getSeriesByIndex(I2), N3 = M2.dataModel || P2, z3 = M2.dataIndex, H2 = M2.dataType, $ = N3.getData(H2), et = this._renderMode, at = t2.positionDefault, ht = odt([$.getItemModel(z3), N3, P2 && (P2.coordinateSystem || {}).model], this._tooltipModel, at ? { position: at } : null), bt = ht.get("trigger");
      if (!(bt != null && bt !== "item")) {
        var _t = N3.getDataParams(z3, H2), Et = new CXt();
        _t.marker = Et.makeTooltipMarker("item", bU(_t.color), et);
        var zt = JNe(N3.formatTooltip(z3, false, H2)), Ft = ht.get("order"), fe2 = ht.get("valueFormatter"), re2 = zt.frag, ye = re2 ? aFe(fe2 ? ba2({ valueFormatter: fe2 }, re2) : re2, Et, et, Ft, _.get("useUTC"), ht.get("textStyle")) : zt.text, me2 = "item_" + N3.name + "_" + z3;
        this._showOrMove(ht, function() {
          this._showTooltipContent(ht, ye, _t, me2, t2.offsetX, t2.offsetY, t2.position, t2.target, Et);
        }), v4({ type: "showTip", dataIndexInside: z3, dataIndex: $.getRawIndex(z3), seriesIndex: I2, from: this.uid });
      }
    }, i.prototype._showComponentItemTooltip = function(t2, h, v4) {
      var _ = Du(h), M2 = _.tooltipConfig, I2 = M2.option || {};
      if (ms(I2)) {
        var P2 = I2;
        I2 = { content: P2, formatter: P2 };
      }
      var N3 = [I2], z3 = this._ecModel.getComponent(_.componentMainType, _.componentIndex);
      z3 && N3.push(z3), N3.push({ formatter: I2.content });
      var H2 = t2.positionDefault, $ = odt(N3, this._tooltipModel, H2 ? { position: H2 } : null), et = $.get("content"), at = Math.random() + "", ht = new CXt();
      this._showOrMove($, function() {
        var bt = pu($.get("formatterParams") || {});
        this._showTooltipContent($, et, bt, at, t2.offsetX, t2.offsetY, t2.position, h, ht);
      }), v4({ type: "showTip", from: this.uid });
    }, i.prototype._showTooltipContent = function(t2, h, v4, _, M2, I2, P2, N3, z3) {
      if (this._ticket = "", !(!t2.get("showContent") || !t2.get("show"))) {
        var H2 = this._tooltipContent;
        H2.setEnterable(t2.get("enterable"));
        var $ = t2.get("formatter");
        P2 = P2 || t2.get("position");
        var et = h, at = this._getNearestPoint([M2, I2], v4, t2.get("trigger"), t2.get("borderColor")), ht = at.color;
        if ($)
          if (ms($)) {
            var bt = t2.ecModel.get("useUTC"), _t = Za2(v4) ? v4[0] : v4, Et = _t && _t.axisType && _t.axisType.indexOf("time") >= 0;
            et = $, Et && (et = wkt(_t.axisValue, et, bt)), et = eWe(et, v4, true);
          } else if (Ol($)) {
            var zt = ks(function(Ft, fe2) {
              Ft === this._ticket && (H2.setContent(fe2, z3, t2, ht, P2), this._updatePosition(t2, P2, M2, I2, H2, v4, N3));
            }, this);
            this._ticket = _, et = $(v4, _, zt);
          } else
            et = $;
        H2.setContent(et, z3, t2, ht, P2), H2.show(t2, ht), this._updatePosition(t2, P2, M2, I2, H2, v4, N3);
      }
    }, i.prototype._getNearestPoint = function(t2, h, v4, _) {
      if (v4 === "axis" || Za2(h))
        return { color: _ || (this._renderMode === "html" ? "#fff" : "none") };
      if (!Za2(h))
        return { color: _ || h.color || h.borderColor };
    }, i.prototype._updatePosition = function(t2, h, v4, _, M2, I2, P2) {
      var N3 = this._api.getWidth(), z3 = this._api.getHeight();
      h = h || t2.get("position");
      var H2 = M2.getSize(), $ = t2.get("align"), et = t2.get("verticalAlign"), at = P2 && P2.getBoundingRect().clone();
      if (P2 && at.applyTransform(P2.transform), Ol(h) && (h = h([v4, _], I2, M2.el, at, { viewSize: [N3, z3], contentSize: H2.slice() })), Za2(h))
        v4 = cs(h[0], N3), _ = cs(h[1], z3);
      else if (Xl(h)) {
        var ht = h;
        ht.width = H2[0], ht.height = H2[1];
        var bt = u1(ht, { width: N3, height: z3 });
        v4 = bt.x, _ = bt.y, $ = null, et = null;
      } else if (ms(h) && P2) {
        var _t = xAr(h, at, H2, t2.get("borderWidth"));
        v4 = _t[0], _ = _t[1];
      } else {
        var _t = bAr(v4, _, M2, N3, z3, $ ? null : 20, et ? null : 20);
        v4 = _t[0], _ = _t[1];
      }
      if ($ && (v4 -= gVe($) ? H2[0] / 2 : $ === "right" ? H2[0] : 0), et && (_ -= gVe(et) ? H2[1] / 2 : et === "bottom" ? H2[1] : 0), Cqe(t2)) {
        var _t = _Ar(v4, _, M2, N3, z3);
        v4 = _t[0], _ = _t[1];
      }
      M2.moveTo(v4, _);
    }, i.prototype._updateContentNotChangedOnAxis = function(t2, h) {
      var v4 = this._lastDataByCoordSys, _ = this._cbParamsList, M2 = !!v4 && v4.length === t2.length;
      return M2 && Qe2(v4, function(I2, P2) {
        var N3 = I2.dataByAxis || [], z3 = t2[P2] || {}, H2 = z3.dataByAxis || [];
        M2 = M2 && N3.length === H2.length, M2 && Qe2(N3, function($, et) {
          var at = H2[et] || {}, ht = $.seriesDataIndices || [], bt = at.seriesDataIndices || [];
          M2 = M2 && $.value === at.value && $.axisType === at.axisType && $.axisId === at.axisId && ht.length === bt.length, M2 && Qe2(ht, function(_t, Et) {
            var zt = bt[Et];
            M2 = M2 && _t.seriesIndex === zt.seriesIndex && _t.dataIndex === zt.dataIndex;
          }), _ && Qe2($.seriesDataIndices, function(_t) {
            var Et = _t.seriesIndex, zt = h[Et], Ft = _[Et];
            zt && Ft && Ft.data !== zt.data && (M2 = false);
          });
        });
      }), this._lastDataByCoordSys = t2, this._cbParamsList = h, !!M2;
    }, i.prototype._hide = function(t2) {
      this._lastDataByCoordSys = null, t2({ type: "hideTip", from: this.uid });
    }, i.prototype.dispose = function(t2, h) {
      gp.node || !h.getDom() || (agt(this, "_updatePosition"), this._tooltipContent.dispose(), Nte("itemTooltip", h));
    }, i.type = "tooltip", i;
  }(W0);
  function odt(f2, i, t2) {
    var h = i.ecModel, v4;
    t2 ? (v4 = new Gg2(t2, h, h), v4 = new Gg2(i.option, v4, h)) : v4 = i;
    for (var _ = f2.length - 1; _ >= 0; _--) {
      var M2 = f2[_];
      M2 && (M2 instanceof Gg2 && (M2 = M2.get("tooltip", true)), ms(M2) && (M2 = { formatter: M2 }), M2 && (v4 = new Gg2(M2, v4, h)));
    }
    return v4;
  }
  function dVe(f2, i) {
    return f2.dispatchAction || ks(i.dispatchAction, i);
  }
  function bAr(f2, i, t2, h, v4, _, M2) {
    var I2 = t2.getSize(), P2 = I2[0], N3 = I2[1];
    return _ != null && (f2 + P2 + _ + 2 > h ? f2 -= P2 + _ : f2 += _), M2 != null && (i + N3 + M2 > v4 ? i -= N3 + M2 : i += M2), [f2, i];
  }
  function _Ar(f2, i, t2, h, v4) {
    var _ = t2.getSize(), M2 = _[0], I2 = _[1];
    return f2 = Math.min(f2 + M2, h) - M2, i = Math.min(i + I2, v4) - I2, f2 = Math.max(f2, 0), i = Math.max(i, 0), [f2, i];
  }
  function xAr(f2, i, t2, h) {
    var v4 = t2[0], _ = t2[1], M2 = Math.ceil(Math.SQRT2 * h) + 8, I2 = 0, P2 = 0, N3 = i.width, z3 = i.height;
    switch (f2) {
      case "inside":
        I2 = i.x + N3 / 2 - v4 / 2, P2 = i.y + z3 / 2 - _ / 2;
        break;
      case "top":
        I2 = i.x + N3 / 2 - v4 / 2, P2 = i.y - _ - M2;
        break;
      case "bottom":
        I2 = i.x + N3 / 2 - v4 / 2, P2 = i.y + z3 + M2;
        break;
      case "left":
        I2 = i.x - v4 - M2, P2 = i.y + z3 / 2 - _ / 2;
        break;
      case "right":
        I2 = i.x + N3 + M2, P2 = i.y + z3 / 2 - _ / 2;
    }
    return [I2, P2];
  }
  function gVe(f2) {
    return f2 === "center" || f2 === "middle";
  }
  function wAr(f2, i, t2) {
    var h = kee(f2).queryOptionMap, v4 = h.keys()[0];
    if (!(!v4 || v4 === "series")) {
      var _ = Tgt(i, v4, h.get(v4), { useDefault: false, enableAll: false, enableNone: false }), M2 = _.models[0];
      if (!!M2) {
        var I2 = t2.getViewOfComponentModel(M2), P2;
        if (I2.group.traverse(function(N3) {
          var z3 = Du(N3).tooltipConfig;
          if (z3 && z3.name === f2.name)
            return P2 = N3, true;
        }), P2)
          return { componentMainType: v4, componentIndex: M2.componentIndex, el: P2 };
      }
    }
  }
  var SAr = mAr;
  function MAr(f2) {
    zc2(Ugt), f2.registerComponentModel(rAr), f2.registerComponentView(SAr), f2.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, xm), f2.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, xm);
  }
  var CAr = ["rect", "polygon", "keep", "clear"];
  function TAr(f2, i) {
    var t2 = Od2(f2 ? f2.brush : []);
    if (!!t2.length) {
      var h = [];
      Qe2(t2, function(P2) {
        var N3 = P2.hasOwnProperty("toolbox") ? P2.toolbox : [];
        N3 instanceof Array && (h = h.concat(N3));
      });
      var v4 = f2 && f2.toolbox;
      Za2(v4) && (v4 = v4[0]), v4 || (v4 = { feature: {} }, f2.toolbox = [v4]);
      var _ = v4.feature || (v4.feature = {}), M2 = _.brush || (_.brush = {}), I2 = M2.type || (M2.type = []);
      I2.push.apply(I2, h), AAr(I2), i && !I2.length && I2.push.apply(I2, CAr);
    }
  }
  function AAr(f2) {
    var i = {};
    Qe2(f2, function(t2) {
      i[t2] = 1;
    }), f2.length = 0, Qe2(i, function(t2, h) {
      f2.push(h);
    });
  }
  var vVe = Qe2;
  function yVe(f2) {
    if (f2) {
      for (var i in f2)
        if (f2.hasOwnProperty(i))
          return true;
    }
  }
  function Wte(f2, i, t2) {
    var h = {};
    return vVe(i, function(_) {
      var M2 = h[_] = v4();
      vVe(f2[_], function(I2, P2) {
        if (!!Gx.isValidType(P2)) {
          var N3 = { type: P2, visual: I2 };
          t2 && t2(N3, _), M2[P2] = new Gx(N3), P2 === "opacity" && (N3 = pu(N3), N3.type = "colorAlpha", M2.__hidden.__alphaForOpacity = new Gx(N3));
        }
      });
    }), h;
    function v4() {
      var _ = function() {
      };
      _.prototype.__hidden = _.prototype;
      var M2 = new _();
      return M2;
    }
  }
  function Dqe(f2, i, t2) {
    var h;
    Qe2(t2, function(v4) {
      i.hasOwnProperty(v4) && yVe(i[v4]) && (h = true);
    }), h && Qe2(t2, function(v4) {
      i.hasOwnProperty(v4) && yVe(i[v4]) ? f2[v4] = pu(i[v4]) : delete f2[v4];
    });
  }
  function IAr(f2, i, t2, h, v4, _) {
    var M2 = {};
    Qe2(f2, function(H2) {
      var $ = Gx.prepareVisualTypes(i[H2]);
      M2[H2] = $;
    });
    var I2;
    function P2(H2) {
      return sne(t2, I2, H2);
    }
    function N3(H2, $) {
      qWe(t2, I2, H2, $);
    }
    _ == null ? t2.each(z3) : t2.each([_], z3);
    function z3(H2, $) {
      I2 = _ == null ? H2 : $;
      var et = t2.getRawDataItem(I2);
      if (!(et && et.visualMap === false))
        for (var at = h.call(v4, H2), ht = i[at], bt = M2[at], _t = 0, Et = bt.length; _t < Et; _t++) {
          var zt = bt[_t];
          ht[zt] && ht[zt].applyVisual(H2, P2, N3);
        }
    }
  }
  function DAr(f2, i, t2, h) {
    var v4 = {};
    return Qe2(f2, function(_) {
      var M2 = Gx.prepareVisualTypes(i[_]);
      v4[_] = M2;
    }), { progress: function(M2, I2) {
      var P2;
      h != null && (P2 = I2.getDimensionIndex(h));
      function N3(fe2) {
        return sne(I2, H2, fe2);
      }
      function z3(fe2, re2) {
        qWe(I2, H2, fe2, re2);
      }
      for (var H2, $ = I2.getStore(); (H2 = M2.next()) != null; ) {
        var et = I2.getRawDataItem(H2);
        if (!(et && et.visualMap === false))
          for (var at = h != null ? $.get(P2, H2) : H2, ht = t2(at), bt = i[ht], _t = v4[ht], Et = 0, zt = _t.length; Et < zt; Et++) {
            var Ft = _t[Et];
            bt[Ft] && bt[Ft].applyVisual(at, N3, z3);
          }
      }
    } };
  }
  function EAr(f2) {
    var i = f2.brushType, t2 = { point: function(h) {
      return mVe[i].point(h, t2, f2);
    }, rect: function(h) {
      return mVe[i].rect(h, t2, f2);
    } };
    return t2;
  }
  var mVe = { lineX: bVe(0), lineY: bVe(1), rect: { point: function(f2, i, t2) {
    return f2 && t2.boundingRect.contain(f2[0], f2[1]);
  }, rect: function(f2, i, t2) {
    return f2 && t2.boundingRect.intersect(f2);
  } }, polygon: { point: function(f2, i, t2) {
    return f2 && t2.boundingRect.contain(f2[0], f2[1]) && KH(t2.range, f2[0], f2[1]);
  }, rect: function(f2, i, t2) {
    var h = t2.range;
    if (!f2 || h.length <= 1)
      return false;
    var v4 = f2.x, _ = f2.y, M2 = f2.width, I2 = f2.height, P2 = h[0];
    if (KH(h, v4, _) || KH(h, v4 + M2, _) || KH(h, v4, _ + I2) || KH(h, v4 + M2, _ + I2) || Lc2.create(f2).contain(P2[0], P2[1]) || mdt(v4, _, v4 + M2, _, h) || mdt(v4, _, v4, _ + I2, h) || mdt(v4 + M2, _, v4 + M2, _ + I2, h) || mdt(v4, _ + I2, v4 + M2, _ + I2, h))
      return true;
  } } };
  function bVe(f2) {
    var i = ["x", "y"], t2 = ["width", "height"];
    return { point: function(h, v4, _) {
      if (h) {
        var M2 = _.range, I2 = h[f2];
        return sdt(I2, M2);
      }
    }, rect: function(h, v4, _) {
      if (h) {
        var M2 = _.range, I2 = [h[i[f2]], h[i[f2]] + h[t2[f2]]];
        return I2[1] < I2[0] && I2.reverse(), sdt(I2[0], M2) || sdt(I2[1], M2) || sdt(M2[0], I2) || sdt(M2[1], I2);
      }
    } };
  }
  function sdt(f2, i) {
    return i[0] <= f2 && f2 <= i[1];
  }
  var _Ve = ["inBrush", "outOfBrush"], zQt = "__ecBrushSelect", Gte = "__ecInBrushSelectEvent";
  function Eqe(f2) {
    f2.eachComponent({ mainType: "brush" }, function(i) {
      var t2 = i.brushTargetManager = new hre(i.option, f2);
      t2.setInputRanges(i.areas, f2);
    });
  }
  function kAr(f2, i, t2) {
    var h = [], v4, _;
    f2.eachComponent({ mainType: "brush" }, function(M2) {
      t2 && t2.type === "takeGlobalCursor" && M2.setBrushOption(t2.key === "brush" ? t2.brushOption : { brushType: false });
    }), Eqe(f2), f2.eachComponent({ mainType: "brush" }, function(M2, I2) {
      var P2 = { brushId: M2.id, brushIndex: I2, brushName: M2.name, areas: pu(M2.areas), selected: [] };
      h.push(P2);
      var N3 = M2.option, z3 = N3.brushLink, H2 = [], $ = [], et = [], at = false;
      I2 || (v4 = N3.throttleType, _ = N3.throttleDelay);
      var ht = Xa2(M2.areas, function(fe2) {
        var re2 = RAr[fe2.brushType], ye = Ul({ boundingRect: re2 ? re2(fe2) : void 0 }, fe2);
        return ye.selectors = EAr(ye), ye;
      }), bt = Wte(M2.option, _Ve, function(fe2) {
        fe2.mappingMethod = "fixed";
      });
      Za2(z3) && Qe2(z3, function(fe2) {
        H2[fe2] = 1;
      });
      function _t(fe2) {
        return z3 === "all" || !!H2[fe2];
      }
      function Et(fe2) {
        return !!fe2.length;
      }
      f2.eachSeries(function(fe2, re2) {
        var ye = et[re2] = [];
        fe2.subType === "parallel" ? zt(fe2, re2) : Ft(fe2, re2, ye);
      });
      function zt(fe2, re2) {
        var ye = fe2.coordinateSystem;
        at = at || ye.hasAxisBrushed(), _t(re2) && ye.eachActiveState(fe2.getData(), function(me2, be2) {
          me2 === "active" && ($[be2] = 1);
        });
      }
      function Ft(fe2, re2, ye) {
        if (!(!fe2.brushSelector || OAr(M2, re2)) && (Qe2(ht, function(be2) {
          M2.brushTargetManager.controlSeries(be2, fe2, f2) && ye.push(be2), at = at || Et(ye);
        }), _t(re2) && Et(ye))) {
          var me2 = fe2.getData();
          me2.each(function(be2) {
            xVe(fe2, ye, me2, be2) && ($[be2] = 1);
          });
        }
      }
      f2.eachSeries(function(fe2, re2) {
        var ye = { seriesId: fe2.id, seriesIndex: re2, seriesName: fe2.name, dataIndex: [] };
        P2.selected.push(ye);
        var me2 = et[re2], be2 = fe2.getData(), Te2 = _t(re2) ? function(We) {
          return $[We] ? (ye.dataIndex.push(be2.getRawIndex(We)), "inBrush") : "outOfBrush";
        } : function(We) {
          return xVe(fe2, me2, be2, We) ? (ye.dataIndex.push(be2.getRawIndex(We)), "inBrush") : "outOfBrush";
        };
        (_t(re2) ? at : Et(me2)) && IAr(_Ve, bt, be2, Te2);
      });
    }), PAr(i, v4, _, h, t2);
  }
  function PAr(f2, i, t2, h, v4) {
    if (!!v4) {
      var _ = f2.getZr();
      if (!_[Gte]) {
        _[zQt] || (_[zQt] = LAr);
        var M2 = cet(_, zQt, t2, i);
        M2(f2, h);
      }
    }
  }
  function LAr(f2, i) {
    if (!f2.isDisposed()) {
      var t2 = f2.getZr();
      t2[Gte] = true, f2.dispatchAction({ type: "brushSelect", batch: i }), t2[Gte] = false;
    }
  }
  function xVe(f2, i, t2, h) {
    for (var v4 = 0, _ = i.length; v4 < _; v4++) {
      var M2 = i[v4];
      if (f2.brushSelector(h, t2, M2.selectors, M2))
        return true;
    }
  }
  function OAr(f2, i) {
    var t2 = f2.option.seriesIndex;
    return t2 != null && t2 !== "all" && (Za2(t2) ? Pc2(t2, i) < 0 : i !== t2);
  }
  var RAr = { rect: function(f2) {
    return wVe(f2.range);
  }, polygon: function(f2) {
    for (var i, t2 = f2.range, h = 0, v4 = t2.length; h < v4; h++) {
      i = i || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
      var _ = t2[h];
      _[0] < i[0][0] && (i[0][0] = _[0]), _[0] > i[0][1] && (i[0][1] = _[0]), _[1] < i[1][0] && (i[1][0] = _[1]), _[1] > i[1][1] && (i[1][1] = _[1]);
    }
    return i && wVe(i);
  } };
  function wVe(f2) {
    return new Lc2(f2[0][0], f2[1][0], f2[0][1] - f2[0][0], f2[1][1] - f2[1][0]);
  }
  var NAr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2, h) {
      this.ecModel = t2, this.api = h, this.model, (this._brushController = new qne(h.getZr())).on("brush", ks(this._onBrush, this)).mount();
    }, i.prototype.render = function(t2, h, v4, _) {
      this.model = t2, this._updateController(t2, h, v4, _);
    }, i.prototype.updateTransform = function(t2, h, v4, _) {
      Eqe(h), this._updateController(t2, h, v4, _);
    }, i.prototype.updateVisual = function(t2, h, v4, _) {
      this.updateTransform(t2, h, v4, _);
    }, i.prototype.updateView = function(t2, h, v4, _) {
      this._updateController(t2, h, v4, _);
    }, i.prototype._updateController = function(t2, h, v4, _) {
      (!_ || _.$from !== t2.id) && this._brushController.setPanels(t2.brushTargetManager.makePanelOpts(v4)).enableBrush(t2.brushOption).updateCovers(t2.areas.slice());
    }, i.prototype.dispose = function() {
      this._brushController.dispose();
    }, i.prototype._onBrush = function(t2) {
      var h = this.model.id, v4 = this.model.brushTargetManager.setOutputRanges(t2.areas, this.ecModel);
      (!t2.isEnd || t2.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: h, areas: pu(v4), $from: h }), t2.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: h, areas: pu(v4), $from: h });
    }, i.type = "brush", i;
  }(W0), FAr = NAr, VAr = "#ddd", BAr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.areas = [], t2.brushOption = {}, t2;
    }
    return i.prototype.optionUpdated = function(t2, h) {
      var v4 = this.option;
      !h && Dqe(v4, t2, ["inBrush", "outOfBrush"]);
      var _ = v4.inBrush = v4.inBrush || {};
      v4.outOfBrush = v4.outOfBrush || { color: VAr }, _.hasOwnProperty("liftZ") || (_.liftZ = 5);
    }, i.prototype.setAreas = function(t2) {
      !t2 || (this.areas = Xa2(t2, function(h) {
        return SVe(this.option, h);
      }, this));
    }, i.prototype.setBrushOption = function(t2) {
      this.brushOption = SVe(this.option, t2), this.brushType = this.brushOption.brushType;
    }, i.type = "brush", i.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], i.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, i;
  }(zh2);
  function SVe(f2, i) {
    return cc2({ brushType: f2.brushType, brushMode: f2.brushMode, transformable: f2.transformable, brushStyle: new Gg2(f2.brushStyle).getItemStyle(), removeOnClick: f2.removeOnClick, z: f2.z }, i, true);
  }
  var zAr = BAr, jAr = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], WAr = function(f2) {
    ii2(i, f2);
    function i() {
      return f2 !== null && f2.apply(this, arguments) || this;
    }
    return i.prototype.render = function(t2, h, v4) {
      var _, M2, I2;
      h.eachComponent({ mainType: "brush" }, function(P2) {
        _ = P2.brushType, M2 = P2.brushOption.brushMode || "single", I2 = I2 || !!P2.areas.length;
      }), this._brushType = _, this._brushMode = M2, Qe2(t2.get("type", true), function(P2) {
        t2.setIconStatus(P2, (P2 === "keep" ? M2 === "multiple" : P2 === "clear" ? I2 : P2 === _) ? "emphasis" : "normal");
      });
    }, i.prototype.updateView = function(t2, h, v4) {
      this.render(t2, h, v4);
    }, i.prototype.getIcons = function() {
      var t2 = this.model, h = t2.get("icon", true), v4 = {};
      return Qe2(t2.get("type", true), function(_) {
        h[_] && (v4[_] = h[_]);
      }), v4;
    }, i.prototype.onclick = function(t2, h, v4) {
      var _ = this._brushType, M2 = this._brushMode;
      v4 === "clear" ? (h.dispatchAction({ type: "axisAreaSelect", intervals: [] }), h.dispatchAction({ type: "brush", command: "clear", areas: [] })) : h.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: v4 === "keep" ? _ : _ === v4 ? false : v4, brushMode: v4 === "keep" ? M2 === "multiple" ? "single" : "multiple" : M2 } });
    }, i.getDefaultOption = function(t2) {
      var h = { show: true, type: jAr.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: t2.getLocaleModel().get(["toolbox", "brush", "title"]) };
      return h;
    }, i;
  }($D), GAr = WAr;
  function HAr(f2) {
    f2.registerComponentView(FAr), f2.registerComponentModel(zAr), f2.registerPreprocessor(TAr), f2.registerVisual(f2.PRIORITY.VISUAL.BRUSH, kAr), f2.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(i, t2) {
      t2.eachComponent({ mainType: "brush", query: i }, function(h) {
        h.setAreas(i.areas);
      });
    }), f2.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, xm), f2.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, xm), Mtt("brush", GAr);
  }
  var UAr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.layoutMode = { type: "box", ignoreSize: true }, t2;
    }
    return i.type = "title", i.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, i;
  }(zh2), qAr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      if (this.group.removeAll(), !!t2.get("show")) {
        var _ = this.group, M2 = t2.getModel("textStyle"), I2 = t2.getModel("subtextStyle"), P2 = t2.get("textAlign"), N3 = _c2(t2.get("textBaseline"), t2.get("textVerticalAlign")), z3 = new op({ style: By(M2, { text: t2.get("text"), fill: M2.getTextColor() }, { disableBox: true }), z2: 10 }), H2 = z3.getBoundingRect(), $ = t2.get("subtext"), et = new op({ style: By(I2, { text: $, fill: I2.getTextColor(), y: H2.height + t2.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), at = t2.get("link"), ht = t2.get("sublink"), bt = t2.get("triggerEvent", true);
        z3.silent = !at && !bt, et.silent = !ht && !bt, at && z3.on("click", function() {
          wEt(at, "_" + t2.get("target"));
        }), ht && et.on("click", function() {
          wEt(ht, "_" + t2.get("subtarget"));
        }), Du(z3).eventData = Du(et).eventData = bt ? { componentType: "title", componentIndex: t2.componentIndex } : null, _.add(z3), $ && _.add(et);
        var _t = _.getBoundingRect(), Et = t2.getBoxLayoutParams();
        Et.width = _t.width, Et.height = _t.height;
        var zt = u1(Et, { width: v4.getWidth(), height: v4.getHeight() }, t2.get("padding"));
        P2 || (P2 = t2.get("left") || t2.get("right"), P2 === "middle" && (P2 = "center"), P2 === "right" ? zt.x += zt.width : P2 === "center" && (zt.x += zt.width / 2)), N3 || (N3 = t2.get("top") || t2.get("bottom"), N3 === "center" && (N3 = "middle"), N3 === "bottom" ? zt.y += zt.height : N3 === "middle" && (zt.y += zt.height / 2), N3 = N3 || "top"), _.x = zt.x, _.y = zt.y, _.markRedraw();
        var Ft = { align: P2, verticalAlign: N3 };
        z3.setStyle(Ft), et.setStyle(Ft), _t = _.getBoundingRect();
        var fe2 = zt.margin, re2 = t2.getItemStyle(["color", "opacity"]);
        re2.fill = t2.get("backgroundColor");
        var ye = new Sh2({ shape: { x: _t.x - fe2[3], y: _t.y - fe2[0], width: _t.width + fe2[1] + fe2[3], height: _t.height + fe2[0] + fe2[2], r: t2.get("borderRadius") }, style: re2, subPixelOptimize: true, silent: true });
        _.add(ye);
      }
    }, i.type = "title", i;
  }(W0);
  function ZAr(f2) {
    f2.registerComponentModel(UAr), f2.registerComponentView(qAr);
  }
  var $Ar = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.layoutMode = "box", t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      this.mergeDefaultAndTheme(t2, v4), this._initData();
    }, i.prototype.mergeOption = function(t2) {
      f2.prototype.mergeOption.apply(this, arguments), this._initData();
    }, i.prototype.setCurrentIndex = function(t2) {
      t2 == null && (t2 = this.option.currentIndex);
      var h = this._data.count();
      this.option.loop ? t2 = (t2 % h + h) % h : (t2 >= h && (t2 = h - 1), t2 < 0 && (t2 = 0)), this.option.currentIndex = t2;
    }, i.prototype.getCurrentIndex = function() {
      return this.option.currentIndex;
    }, i.prototype.isIndexMax = function() {
      return this.getCurrentIndex() >= this._data.count() - 1;
    }, i.prototype.setPlayState = function(t2) {
      this.option.autoPlay = !!t2;
    }, i.prototype.getPlayState = function() {
      return !!this.option.autoPlay;
    }, i.prototype._initData = function() {
      var t2 = this.option, h = t2.data || [], v4 = t2.axisType, _ = this._names = [], M2;
      v4 === "category" ? (M2 = [], Qe2(h, function(N3, z3) {
        var H2 = l1(Qtt(N3), ""), $;
        Xl(N3) ? ($ = pu(N3), $.value = z3) : $ = z3, M2.push($), _.push(H2);
      })) : M2 = h;
      var I2 = { category: "ordinal", time: "time", value: "number" }[v4] || "number", P2 = this._data = new B2([{ name: "value", type: I2 }], this);
      P2.initData(M2, _);
    }, i.prototype.getData = function() {
      return this._data;
    }, i.prototype.getCategories = function() {
      if (this.get("axisType") === "category")
        return this._names.slice();
    }, i.type = "timeline", i.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, i;
  }(zh2), MVe = $Ar, kqe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "timeline.slider", i.defaultOption = sV(MVe.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), i;
  }(MVe);
  Sm(kqe, nne.prototype);
  var YAr = kqe, KAr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "timeline", i;
  }(W0), XAr = KAr, QAr = function(f2) {
    ii2(i, f2);
    function i(t2, h, v4, _) {
      var M2 = f2.call(this, t2, h, v4) || this;
      return M2.type = _ || "value", M2;
    }
    return i.prototype.getLabelModel = function() {
      return this.model.getModel("label");
    }, i.prototype.isHorizontal = function() {
      return this.model.get("orient") === "horizontal";
    }, i;
  }(D5), JAr = QAr, jQt = Math.PI, CVe = Wh2(), tIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function(t2, h) {
      this.api = h;
    }, i.prototype.render = function(t2, h, v4) {
      if (this.model = t2, this.api = v4, this.ecModel = h, this.group.removeAll(), t2.get("show", true)) {
        var _ = this._layout(t2, v4), M2 = this._createGroup("_mainGroup"), I2 = this._createGroup("_labelGroup"), P2 = this._axis = this._createAxis(_, t2);
        t2.formatTooltip = function(N3) {
          var z3 = P2.scale.getLabel({ value: N3 });
          return pb2("nameValue", { noName: true, value: z3 });
        }, Qe2(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(N3) {
          this["_render" + N3](_, M2, P2, t2);
        }, this), this._renderAxisLabel(_, I2, P2, t2), this._position(_, t2);
      }
      this._doPlayStop(), this._updateTicksStatus();
    }, i.prototype.remove = function() {
      this._clearTimer(), this.group.removeAll();
    }, i.prototype.dispose = function() {
      this._clearTimer();
    }, i.prototype._layout = function(t2, h) {
      var v4 = t2.get(["label", "position"]), _ = t2.get("orient"), M2 = nIr(t2, h), I2;
      v4 == null || v4 === "auto" ? I2 = _ === "horizontal" ? M2.y + M2.height / 2 < h.getHeight() / 2 ? "-" : "+" : M2.x + M2.width / 2 < h.getWidth() / 2 ? "+" : "-" : ms(v4) ? I2 = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[_][v4] : I2 = v4;
      var P2 = { horizontal: "center", vertical: I2 >= 0 || I2 === "+" ? "left" : "right" }, N3 = { horizontal: I2 >= 0 || I2 === "+" ? "top" : "bottom", vertical: "middle" }, z3 = { horizontal: 0, vertical: jQt / 2 }, H2 = _ === "vertical" ? M2.height : M2.width, $ = t2.getModel("controlStyle"), et = $.get("show", true), at = et ? $.get("itemSize") : 0, ht = et ? $.get("itemGap") : 0, bt = at + ht, _t = t2.get(["label", "rotate"]) || 0;
      _t = _t * jQt / 180;
      var Et, zt, Ft, fe2 = $.get("position", true), re2 = et && $.get("showPlayBtn", true), ye = et && $.get("showPrevBtn", true), me2 = et && $.get("showNextBtn", true), be2 = 0, Te2 = H2;
      fe2 === "left" || fe2 === "bottom" ? (re2 && (Et = [0, 0], be2 += bt), ye && (zt = [be2, 0], be2 += bt), me2 && (Ft = [Te2 - at, 0], Te2 -= bt)) : (re2 && (Et = [Te2 - at, 0], Te2 -= bt), ye && (zt = [0, 0], be2 += bt), me2 && (Ft = [Te2 - at, 0], Te2 -= bt));
      var We = [be2, Te2];
      return t2.get("inverse") && We.reverse(), { viewRect: M2, mainLength: H2, orient: _, rotation: z3[_], labelRotation: _t, labelPosOpt: I2, labelAlign: t2.get(["label", "align"]) || P2[_], labelBaseline: t2.get(["label", "verticalAlign"]) || t2.get(["label", "baseline"]) || N3[_], playPosition: Et, prevBtnPosition: zt, nextBtnPosition: Ft, axisExtent: We, controlSize: at, controlGap: ht };
    }, i.prototype._position = function(t2, h) {
      var v4 = this._mainGroup, _ = this._labelGroup, M2 = t2.viewRect;
      if (t2.orient === "vertical") {
        var I2 = nE(), P2 = M2.x, N3 = M2.y + M2.height;
        jL(I2, I2, [-P2, -N3]), SU(I2, I2, -jQt / 2), jL(I2, I2, [P2, N3]), M2 = M2.clone(), M2.applyTransform(I2);
      }
      var z3 = Et(M2), H2 = Et(v4.getBoundingRect()), $ = Et(_.getBoundingRect()), et = [v4.x, v4.y], at = [_.x, _.y];
      at[0] = et[0] = z3[0][0];
      var ht = t2.labelPosOpt;
      if (ht == null || ms(ht)) {
        var bt = ht === "+" ? 0 : 1;
        zt(et, H2, z3, 1, bt), zt(at, $, z3, 1, 1 - bt);
      } else {
        var bt = ht >= 0 ? 0 : 1;
        zt(et, H2, z3, 1, bt), at[1] = et[1] + ht;
      }
      v4.setPosition(et), _.setPosition(at), v4.rotation = _.rotation = t2.rotation, _t(v4), _t(_);
      function _t(Ft) {
        Ft.originX = z3[0][0] - Ft.x, Ft.originY = z3[1][0] - Ft.y;
      }
      function Et(Ft) {
        return [[Ft.x, Ft.x + Ft.width], [Ft.y, Ft.y + Ft.height]];
      }
      function zt(Ft, fe2, re2, ye, me2) {
        Ft[ye] += re2[ye][me2] - fe2[ye][me2];
      }
    }, i.prototype._createAxis = function(t2, h) {
      var v4 = h.getData(), _ = h.get("axisType"), M2 = eIr(h, _);
      M2.getTicks = function() {
        return v4.mapArray(["value"], function(N3) {
          return { value: N3 };
        });
      };
      var I2 = v4.getDataExtent("value");
      M2.setExtent(I2[0], I2[1]), M2.calcNiceTicks();
      var P2 = new JAr("value", M2, t2.axisExtent, _);
      return P2.model = h, P2;
    }, i.prototype._createGroup = function(t2) {
      var h = this[t2] = new mu();
      return this.group.add(h), h;
    }, i.prototype._renderAxisLine = function(t2, h, v4, _) {
      var M2 = v4.getExtent();
      if (!!_.get(["lineStyle", "show"])) {
        var I2 = new m_({ shape: { x1: M2[0], y1: 0, x2: M2[1], y2: 0 }, style: ba2({ lineCap: "round" }, _.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
        h.add(I2);
        var P2 = this._progressLine = new m_({ shape: { x1: M2[0], x2: this._currentPointer ? this._currentPointer.x : M2[0], y1: 0, y2: 0 }, style: Ul({ lineCap: "round", lineWidth: I2.style.lineWidth }, _.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
        h.add(P2);
      }
    }, i.prototype._renderAxisTick = function(t2, h, v4, _) {
      var M2 = this, I2 = _.getData(), P2 = v4.scale.getTicks();
      this._tickSymbols = [], Qe2(P2, function(N3) {
        var z3 = v4.dataToCoord(N3.value), H2 = I2.getItemModel(N3.value), $ = H2.getModel("itemStyle"), et = H2.getModel(["emphasis", "itemStyle"]), at = H2.getModel(["progress", "itemStyle"]), ht = { x: z3, y: 0, onclick: ks(M2._changeTimeline, M2, N3.value) }, bt = TVe(H2, $, h, ht);
        bt.ensureState("emphasis").style = et.getItemStyle(), bt.ensureState("progress").style = at.getItemStyle(), uU(bt);
        var _t = Du(bt);
        H2.get("tooltip") ? (_t.dataIndex = N3.value, _t.dataModel = _) : _t.dataIndex = _t.dataModel = null, M2._tickSymbols.push(bt);
      });
    }, i.prototype._renderAxisLabel = function(t2, h, v4, _) {
      var M2 = this, I2 = v4.getLabelModel();
      if (!!I2.get("show")) {
        var P2 = _.getData(), N3 = v4.getViewLabels();
        this._tickLabels = [], Qe2(N3, function(z3) {
          var H2 = z3.tickValue, $ = P2.getItemModel(H2), et = $.getModel("label"), at = $.getModel(["emphasis", "label"]), ht = $.getModel(["progress", "label"]), bt = v4.dataToCoord(z3.tickValue), _t = new op({ x: bt, y: 0, rotation: t2.labelRotation - t2.rotation, onclick: ks(M2._changeTimeline, M2, H2), silent: false, style: By(et, { text: z3.formattedLabel, align: t2.labelAlign, verticalAlign: t2.labelBaseline }) });
          _t.ensureState("emphasis").style = By(at), _t.ensureState("progress").style = By(ht), h.add(_t), uU(_t), CVe(_t).dataIndex = H2, M2._tickLabels.push(_t);
        });
      }
    }, i.prototype._renderControl = function(t2, h, v4, _) {
      var M2 = t2.controlSize, I2 = t2.rotation, P2 = _.getModel("controlStyle").getItemStyle(), N3 = _.getModel(["emphasis", "controlStyle"]).getItemStyle(), z3 = _.getPlayState(), H2 = _.get("inverse", true);
      $(t2.nextBtnPosition, "next", ks(this._changeTimeline, this, H2 ? "-" : "+")), $(t2.prevBtnPosition, "prev", ks(this._changeTimeline, this, H2 ? "+" : "-")), $(t2.playPosition, z3 ? "stop" : "play", ks(this._handlePlayClick, this, !z3), true);
      function $(et, at, ht, bt) {
        if (!!et) {
          var _t = T5(_c2(_.get(["controlStyle", at + "BtnSize"]), M2), M2), Et = [0, -_t / 2, _t, _t], zt = rIr(_, at + "Icon", Et, { x: et[0], y: et[1], originX: M2 / 2, originY: 0, rotation: bt ? -I2 : 0, rectHover: true, style: P2, onclick: ht });
          zt.ensureState("emphasis").style = N3, h.add(zt), uU(zt);
        }
      }
    }, i.prototype._renderCurrentPointer = function(t2, h, v4, _) {
      var M2 = _.getData(), I2 = _.getCurrentIndex(), P2 = M2.getItemModel(I2).getModel("checkpointStyle"), N3 = this, z3 = { onCreate: function(H2) {
        H2.draggable = true, H2.drift = ks(N3._handlePointerDrag, N3), H2.ondragend = ks(N3._handlePointerDragend, N3), AVe(H2, N3._progressLine, I2, v4, _, true);
      }, onUpdate: function(H2) {
        AVe(H2, N3._progressLine, I2, v4, _);
      } };
      this._currentPointer = TVe(P2, P2, this._mainGroup, {}, this._currentPointer, z3);
    }, i.prototype._handlePlayClick = function(t2) {
      this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: t2, from: this.uid });
    }, i.prototype._handlePointerDrag = function(t2, h, v4) {
      this._clearTimer(), this._pointerChangeTimeline([v4.offsetX, v4.offsetY]);
    }, i.prototype._handlePointerDragend = function(t2) {
      this._pointerChangeTimeline([t2.offsetX, t2.offsetY], true);
    }, i.prototype._pointerChangeTimeline = function(t2, h) {
      var v4 = this._toAxisCoord(t2)[0], _ = this._axis, M2 = QD(_.getExtent().slice());
      v4 > M2[1] && (v4 = M2[1]), v4 < M2[0] && (v4 = M2[0]), this._currentPointer.x = v4, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = v4, this._progressLine.dirty();
      var I2 = this._findNearestTick(v4), P2 = this.model;
      (h || I2 !== P2.getCurrentIndex() && P2.get("realtime")) && this._changeTimeline(I2);
    }, i.prototype._doPlayStop = function() {
      var t2 = this;
      this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
        var h = t2.model;
        t2._changeTimeline(h.getCurrentIndex() + (h.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval")));
    }, i.prototype._toAxisCoord = function(t2) {
      var h = this._mainGroup.getLocalTransform();
      return C5(t2, h, true);
    }, i.prototype._findNearestTick = function(t2) {
      var h = this.model.getData(), v4 = 1 / 0, _, M2 = this._axis;
      return h.each(["value"], function(I2, P2) {
        var N3 = M2.dataToCoord(I2), z3 = Math.abs(N3 - t2);
        z3 < v4 && (v4 = z3, _ = P2);
      }), _;
    }, i.prototype._clearTimer = function() {
      this._timer && (clearTimeout(this._timer), this._timer = null);
    }, i.prototype._changeTimeline = function(t2) {
      var h = this.model.getCurrentIndex();
      t2 === "+" ? t2 = h + 1 : t2 === "-" && (t2 = h - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: t2, from: this.uid });
    }, i.prototype._updateTicksStatus = function() {
      var t2 = this.model.getCurrentIndex(), h = this._tickSymbols, v4 = this._tickLabels;
      if (h)
        for (var _ = 0; _ < h.length; _++)
          h && h[_] && h[_].toggleState("progress", _ < t2);
      if (v4)
        for (var _ = 0; _ < v4.length; _++)
          v4 && v4[_] && v4[_].toggleState("progress", CVe(v4[_]).dataIndex <= t2);
    }, i.type = "timeline.slider", i;
  }(XAr);
  function eIr(f2, i) {
    if (i = i || f2.get("type"), i)
      switch (i) {
        case "category":
          return new dne({ ordinalMeta: f2.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new RGe({ locale: f2.ecModel.getLocaleModel(), useUTC: f2.ecModel.get("useUTC") });
        default:
          return new eV();
      }
  }
  function nIr(f2, i) {
    return u1(f2.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() }, f2.get("padding"));
  }
  function rIr(f2, i, t2, h) {
    var v4 = h.style, _ = Egt(f2.get(["controlStyle", i]), h || {}, new Lc2(t2[0], t2[1], t2[2], t2[3]));
    return v4 && _.setStyle(v4), _;
  }
  function TVe(f2, i, t2, h, v4, _) {
    var M2 = i.get("color");
    if (v4)
      v4.setColor(M2), t2.add(v4), _ && _.onUpdate(v4);
    else {
      var I2 = f2.get("symbol");
      v4 = wm(I2, -1, -1, 2, 2, M2), v4.setStyle("strokeNoScale", true), t2.add(v4), _ && _.onCreate(v4);
    }
    var P2 = i.getItemStyle(["color"]);
    v4.setStyle(P2), h = cc2({ rectHover: true, z2: 100 }, h, true);
    var N3 = Ogt(f2.get("symbolSize"));
    h.scaleX = N3[0] / 2, h.scaleY = N3[1] / 2;
    var z3 = fet(f2.get("symbolOffset"), N3);
    z3 && (h.x = (h.x || 0) + z3[0], h.y = (h.y || 0) + z3[1]);
    var H2 = f2.get("symbolRotate");
    return h.rotation = (H2 || 0) * Math.PI / 180 || 0, v4.attr(h), v4.updateTransform(), v4;
  }
  function AVe(f2, i, t2, h, v4, _) {
    if (!f2.dragging) {
      var M2 = v4.getModel("checkpointStyle"), I2 = h.dataToCoord(v4.getData().get("value", t2));
      if (_ || !M2.get("animation", true))
        f2.attr({ x: I2, y: 0 }), i && i.attr({ shape: { x2: I2 } });
      else {
        var P2 = { duration: M2.get("animationDuration", true), easing: M2.get("animationEasing", true) };
        f2.stopAnimation(null, true), f2.animateTo({ x: I2, y: 0 }, P2), i && i.animateTo({ shape: { x2: I2 } }, P2);
      }
    }
  }
  var iIr = tIr;
  function aIr(f2) {
    f2.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(i, t2, h) {
      var v4 = t2.getComponent("timeline");
      return v4 && i.currentIndex != null && (v4.setCurrentIndex(i.currentIndex), !v4.get("loop", true) && v4.isIndexMax() && v4.getPlayState() && (v4.setPlayState(false), h.dispatchAction({ type: "timelinePlayChange", playState: false, from: i.from }))), t2.resetOption("timeline", { replaceMerge: v4.get("replaceMerge", true) }), Ul({ currentIndex: v4.option.currentIndex }, i);
    }), f2.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(i, t2) {
      var h = t2.getComponent("timeline");
      h && i.playState != null && h.setPlayState(i.playState);
    });
  }
  function oIr(f2) {
    var i = f2 && f2.timeline;
    Za2(i) || (i = i ? [i] : []), Qe2(i, function(t2) {
      !t2 || sIr(t2);
    });
  }
  function sIr(f2) {
    var i = f2.type, t2 = { number: "value", time: "time" };
    if (t2[i] && (f2.axisType = t2[i], delete f2.type), IVe(f2), JH(f2, "controlPosition")) {
      var h = f2.controlStyle || (f2.controlStyle = {});
      JH(h, "position") || (h.position = f2.controlPosition), h.position === "none" && !JH(h, "show") && (h.show = false, delete h.position), delete f2.controlPosition;
    }
    Qe2(f2.data || [], function(v4) {
      Xl(v4) && !Za2(v4) && (!JH(v4, "value") && JH(v4, "name") && (v4.value = v4.name), IVe(v4));
    });
  }
  function IVe(f2) {
    var i = f2.itemStyle || (f2.itemStyle = {}), t2 = i.emphasis || (i.emphasis = {}), h = f2.label || f2.label || {}, v4 = h.normal || (h.normal = {}), _ = { normal: 1, emphasis: 1 };
    Qe2(h, function(M2, I2) {
      !_[I2] && !JH(v4, I2) && (v4[I2] = M2);
    }), t2.label && !JH(h, "emphasis") && (h.emphasis = t2.label, delete t2.label);
  }
  function JH(f2, i) {
    return f2.hasOwnProperty(i);
  }
  function lIr(f2) {
    f2.registerComponentModel(YAr), f2.registerComponentView(iIr), f2.registerSubTypeDefaulter("timeline", function() {
      return "slider";
    }), aIr(f2), f2.registerPreprocessor(oIr);
  }
  function gre(f2, i) {
    if (!f2)
      return false;
    for (var t2 = Za2(f2) ? f2 : [f2], h = 0; h < t2.length; h++)
      if (t2[h] && t2[h][i])
        return true;
    return false;
  }
  function TDt(f2) {
    gU(f2, "label", ["show"]);
  }
  var ADt = Wh2(), Pqe = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.createdBySelf = false, t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      this.mergeDefaultAndTheme(t2, v4), this._mergeOption(t2, v4, false, true);
    }, i.prototype.isAnimationEnabled = function() {
      if (gp.node)
        return false;
      var t2 = this.__hostSeries;
      return this.getShallow("animation") && t2 && t2.isAnimationEnabled();
    }, i.prototype.mergeOption = function(t2, h) {
      this._mergeOption(t2, h, false, false);
    }, i.prototype._mergeOption = function(t2, h, v4, _) {
      var M2 = this.mainType;
      v4 || h.eachSeries(function(I2) {
        var P2 = I2.get(this.mainType, true), N3 = ADt(I2)[M2];
        if (!P2 || !P2.data) {
          ADt(I2)[M2] = null;
          return;
        }
        N3 ? N3._mergeOption(P2, h, true) : (_ && TDt(P2), Qe2(P2.data, function(z3) {
          z3 instanceof Array ? (TDt(z3[0]), TDt(z3[1])) : TDt(z3);
        }), N3 = this.createMarkerModelFromSeries(P2, this, h), ba2(N3, { mainType: this.mainType, seriesIndex: I2.seriesIndex, name: I2.name, createdBySelf: true }), N3.__hostSeries = I2), ADt(I2)[M2] = N3;
      }, this);
    }, i.prototype.formatTooltip = function(t2, h, v4) {
      var _ = this.getData(), M2 = this.getRawValue(t2), I2 = _.getName(t2);
      return pb2("section", { header: this.name, blocks: [pb2("nameValue", { name: I2, value: M2, noName: !I2, noValue: M2 == null })] });
    }, i.prototype.getData = function() {
      return this._data;
    }, i.prototype.setData = function(t2) {
      this._data = t2;
    }, i.getMarkerModelFromSeries = function(t2, h) {
      return ADt(t2)[h];
    }, i.type = "marker", i.dependencies = ["series", "grid", "polar", "geo"], i;
  }(zh2);
  Sm(Pqe, nne.prototype);
  var iV = Pqe, uIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.createMarkerModelFromSeries = function(t2, h, v4) {
      return new i(t2, h, v4);
    }, i.type = "markPoint", i.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, i;
  }(iV), cIr = uIr;
  function fIr(f2) {
    return !(isNaN(parseFloat(f2.x)) && isNaN(parseFloat(f2.y)));
  }
  function hIr(f2) {
    return !isNaN(parseFloat(f2.x)) && !isNaN(parseFloat(f2.y));
  }
  function IDt(f2, i, t2, h, v4, _) {
    var M2 = [], I2 = tV(i, h), P2 = I2 ? i.getCalculationInfo("stackResultDimension") : h, N3 = vre(i, P2, f2), z3 = i.indicesOfNearest(P2, N3)[0];
    M2[v4] = i.get(t2, z3), M2[_] = i.get(P2, z3);
    var H2 = i.get(h, z3), $ = PL(i.get(h, z3));
    return $ = Math.min($, 20), $ >= 0 && (M2[_] = +M2[_].toFixed($)), [M2, H2];
  }
  var WQt = { min: Ou(IDt, "min"), max: Ou(IDt, "max"), average: Ou(IDt, "average"), median: Ou(IDt, "median") };
  function bgt(f2, i) {
    var t2 = f2.getData(), h = f2.coordinateSystem;
    if (i && !hIr(i) && !Za2(i.coord) && h) {
      var v4 = h.dimensions, _ = Lqe(i, t2, h, f2);
      if (i = pu(i), i.type && WQt[i.type] && _.baseAxis && _.valueAxis) {
        var M2 = Pc2(v4, _.baseAxis.dim), I2 = Pc2(v4, _.valueAxis.dim), P2 = WQt[i.type](t2, _.baseDataDim, _.valueDataDim, M2, I2);
        i.coord = P2[0], i.value = P2[1];
      } else {
        for (var N3 = [i.xAxis != null ? i.xAxis : i.radiusAxis, i.yAxis != null ? i.yAxis : i.angleAxis], z3 = 0; z3 < 2; z3++)
          WQt[N3[z3]] && (N3[z3] = vre(t2, t2.mapDimension(v4[z3]), N3[z3]));
        i.coord = N3;
      }
    }
    return i;
  }
  function Lqe(f2, i, t2, h) {
    var v4 = {};
    return f2.valueIndex != null || f2.valueDim != null ? (v4.valueDataDim = f2.valueIndex != null ? i.getDimension(f2.valueIndex) : f2.valueDim, v4.valueAxis = t2.getAxis(pIr(h, v4.valueDataDim)), v4.baseAxis = t2.getOtherAxis(v4.valueAxis), v4.baseDataDim = i.mapDimension(v4.baseAxis.dim)) : (v4.baseAxis = h.getBaseAxis(), v4.valueAxis = t2.getOtherAxis(v4.baseAxis), v4.baseDataDim = i.mapDimension(v4.baseAxis.dim), v4.valueDataDim = i.mapDimension(v4.valueAxis.dim)), v4;
  }
  function pIr(f2, i) {
    var t2 = f2.getData().getDimensionInfo(i);
    return t2 && t2.coordDim;
  }
  function _gt(f2, i) {
    return f2 && f2.containData && i.coord && !fIr(i) ? f2.containData(i.coord) : true;
  }
  function Oqe(f2, i) {
    return f2 ? function(t2, h, v4, _) {
      var M2 = _ < 2 ? t2.coord && t2.coord[_] : t2.value;
      return $7(M2, i[_]);
    } : function(t2, h, v4, _) {
      return $7(t2.value, i[_]);
    };
  }
  function vre(f2, i, t2) {
    if (t2 === "average") {
      var h = 0, v4 = 0;
      return f2.each(i, function(_, M2) {
        isNaN(_) || (h += _, v4++);
      }), h / v4;
    } else
      return t2 === "median" ? f2.getMedian(i) : f2.getDataExtent(i)[t2 === "max" ? 1 : 0];
  }
  var GQt = Wh2(), dIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.init = function() {
      this.markerGroupMap = Il();
    }, i.prototype.render = function(t2, h, v4) {
      var _ = this, M2 = this.markerGroupMap;
      M2.each(function(I2) {
        GQt(I2).keep = false;
      }), h.eachSeries(function(I2) {
        var P2 = iV.getMarkerModelFromSeries(I2, _.type);
        P2 && _.renderSeries(I2, P2, h, v4);
      }), M2.each(function(I2) {
        !GQt(I2).keep && _.group.remove(I2.group);
      });
    }, i.prototype.markKeep = function(t2) {
      GQt(t2).keep = true;
    }, i.prototype.blurSeries = function(t2) {
      var h = this;
      Qe2(t2, function(v4) {
        var _ = iV.getMarkerModelFromSeries(v4, h.type);
        if (_) {
          var M2 = _.getData();
          M2.eachItemGraphicEl(function(I2) {
            I2 && sje(I2);
          });
        }
      });
    }, i.type = "marker", i;
  }(W0), yre = dIr;
  function DVe(f2, i, t2) {
    var h = i.coordinateSystem;
    f2.each(function(v4) {
      var _ = f2.getItemModel(v4), M2, I2 = cs(_.get("x"), t2.getWidth()), P2 = cs(_.get("y"), t2.getHeight());
      if (!isNaN(I2) && !isNaN(P2))
        M2 = [I2, P2];
      else if (i.getMarkerPosition)
        M2 = i.getMarkerPosition(f2.getValues(f2.dimensions, v4));
      else if (h) {
        var N3 = f2.get(h.dimensions[0], v4), z3 = f2.get(h.dimensions[1], v4);
        M2 = h.dataToPoint([N3, z3]);
      }
      isNaN(I2) || (M2[0] = I2), isNaN(P2) || (M2[1] = P2), f2.setItemLayout(v4, M2);
    });
  }
  var gIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.updateTransform = function(t2, h, v4) {
      h.eachSeries(function(_) {
        var M2 = iV.getMarkerModelFromSeries(_, "markPoint");
        M2 && (DVe(M2.getData(), _, v4), this.markerGroupMap.get(_.id).updateLayout());
      }, this);
    }, i.prototype.renderSeries = function(t2, h, v4, _) {
      var M2 = t2.coordinateSystem, I2 = t2.id, P2 = t2.getData(), N3 = this.markerGroupMap, z3 = N3.get(I2) || N3.set(I2, new Bgt()), H2 = vIr(M2, t2, h);
      h.setData(H2), DVe(h.getData(), t2, _), H2.each(function($) {
        var et = H2.getItemModel($), at = et.getShallow("symbol"), ht = et.getShallow("symbolSize"), bt = et.getShallow("symbolRotate"), _t = et.getShallow("symbolOffset"), Et = et.getShallow("symbolKeepAspect");
        if (Ol(at) || Ol(ht) || Ol(bt) || Ol(_t)) {
          var zt = h.getRawValue($), Ft = h.getDataParams($);
          Ol(at) && (at = at(zt, Ft)), Ol(ht) && (ht = ht(zt, Ft)), Ol(bt) && (bt = bt(zt, Ft)), Ol(_t) && (_t = _t(zt, Ft));
        }
        var fe2 = et.getModel("itemStyle").getItemStyle(), re2 = Lgt(P2, "color");
        fe2.fill || (fe2.fill = re2), H2.setItemVisual($, { symbol: at, symbolSize: ht, symbolRotate: bt, symbolOffset: _t, symbolKeepAspect: Et, style: fe2 });
      }), z3.updateData(H2), this.group.add(z3.group), H2.eachItemGraphicEl(function($) {
        $.traverse(function(et) {
          Du(et).dataModel = h;
        });
      }), this.markKeep(z3), z3.group.silent = h.get("silent") || t2.get("silent");
    }, i.type = "markPoint", i;
  }(yre);
  function vIr(f2, i, t2) {
    var h;
    f2 ? h = Xa2(f2 && f2.dimensions, function(I2) {
      var P2 = i.getData().getDimensionInfo(i.getData().mapDimension(I2)) || {};
      return ba2(ba2({}, P2), { name: I2, ordinalMeta: null });
    }) : h = [{ name: "value", type: "float" }];
    var v4 = new B2(h, t2), _ = Xa2(t2.get("data"), Ou(bgt, i));
    f2 && (_ = Ld2(_, Ou(_gt, f2)));
    var M2 = Oqe(!!f2, h);
    return v4.initData(_, null, M2), v4;
  }
  var yIr = gIr;
  function mIr(f2) {
    f2.registerComponentModel(cIr), f2.registerComponentView(yIr), f2.registerPreprocessor(function(i) {
      gre(i.series, "markPoint") && (i.markPoint = i.markPoint || {});
    });
  }
  var bIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.createMarkerModelFromSeries = function(t2, h, v4) {
      return new i(t2, h, v4);
    }, i.type = "markLine", i.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, i;
  }(iV), _Ir = bIr, DDt = Wh2(), xIr = function(f2, i, t2, h) {
    var v4 = f2.getData(), _;
    if (Za2(h))
      _ = h;
    else {
      var M2 = h.type;
      if (M2 === "min" || M2 === "max" || M2 === "average" || M2 === "median" || h.xAxis != null || h.yAxis != null) {
        var I2 = void 0, P2 = void 0;
        if (h.yAxis != null || h.xAxis != null)
          I2 = i.getAxis(h.yAxis != null ? "y" : "x"), P2 = y_(h.yAxis, h.xAxis);
        else {
          var N3 = Lqe(h, v4, i, f2);
          I2 = N3.valueAxis;
          var z3 = xGe(v4, N3.valueDataDim);
          P2 = vre(v4, z3, M2);
        }
        var H2 = I2.dim === "x" ? 0 : 1, $ = 1 - H2, et = pu(h), at = { coord: [] };
        et.type = null, et.coord = [], et.coord[$] = -1 / 0, at.coord[$] = 1 / 0;
        var ht = t2.get("precision");
        ht >= 0 && vp(P2) && (P2 = +P2.toFixed(Math.min(ht, 20))), et.coord[H2] = at.coord[H2] = P2, _ = [et, at, { type: M2, valueIndex: h.valueIndex, value: P2 }];
      } else
        _ = [];
    }
    var bt = [bgt(f2, _[0]), bgt(f2, _[1]), ba2({}, _[2])];
    return bt[2].type = bt[2].type || null, cc2(bt[2], bt[0]), cc2(bt[2], bt[1]), bt;
  };
  function $Et(f2) {
    return !isNaN(f2) && !isFinite(f2);
  }
  function EVe(f2, i, t2, h) {
    var v4 = 1 - f2, _ = h.dimensions[f2];
    return $Et(i[v4]) && $Et(t2[v4]) && i[f2] === t2[f2] && h.getAxis(_).containData(i[f2]);
  }
  function wIr(f2, i) {
    if (f2.type === "cartesian2d") {
      var t2 = i[0].coord, h = i[1].coord;
      if (t2 && h && (EVe(1, t2, h, f2) || EVe(0, t2, h, f2)))
        return true;
    }
    return _gt(f2, i[0]) && _gt(f2, i[1]);
  }
  function HQt(f2, i, t2, h, v4) {
    var _ = h.coordinateSystem, M2 = f2.getItemModel(i), I2, P2 = cs(M2.get("x"), v4.getWidth()), N3 = cs(M2.get("y"), v4.getHeight());
    if (!isNaN(P2) && !isNaN(N3))
      I2 = [P2, N3];
    else {
      if (h.getMarkerPosition)
        I2 = h.getMarkerPosition(f2.getValues(f2.dimensions, i));
      else {
        var z3 = _.dimensions, H2 = f2.get(z3[0], i), $ = f2.get(z3[1], i);
        I2 = _.dataToPoint([H2, $]);
      }
      if (Y6(_, "cartesian2d")) {
        var et = _.getAxis("x"), at = _.getAxis("y"), z3 = _.dimensions;
        $Et(f2.get(z3[0], i)) ? I2[0] = et.toGlobalCoord(et.getExtent()[t2 ? 0 : 1]) : $Et(f2.get(z3[1], i)) && (I2[1] = at.toGlobalCoord(at.getExtent()[t2 ? 0 : 1]));
      }
      isNaN(P2) || (I2[0] = P2), isNaN(N3) || (I2[1] = N3);
    }
    f2.setItemLayout(i, I2);
  }
  var SIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.updateTransform = function(t2, h, v4) {
      h.eachSeries(function(_) {
        var M2 = iV.getMarkerModelFromSeries(_, "markLine");
        if (M2) {
          var I2 = M2.getData(), P2 = DDt(M2).from, N3 = DDt(M2).to;
          P2.each(function(z3) {
            HQt(P2, z3, true, _, v4), HQt(N3, z3, false, _, v4);
          }), I2.each(function(z3) {
            I2.setItemLayout(z3, [P2.getItemLayout(z3), N3.getItemLayout(z3)]);
          }), this.markerGroupMap.get(_.id).updateLayout();
        }
      }, this);
    }, i.prototype.renderSeries = function(t2, h, v4, _) {
      var M2 = t2.coordinateSystem, I2 = t2.id, P2 = t2.getData(), N3 = this.markerGroupMap, z3 = N3.get(I2) || N3.set(I2, new zne());
      this.group.add(z3.group);
      var H2 = MIr(M2, t2, h), $ = H2.from, et = H2.to, at = H2.line;
      DDt(h).from = $, DDt(h).to = et, h.setData(at);
      var ht = h.get("symbol"), bt = h.get("symbolSize"), _t = h.get("symbolRotate"), Et = h.get("symbolOffset");
      Za2(ht) || (ht = [ht, ht]), Za2(bt) || (bt = [bt, bt]), Za2(_t) || (_t = [_t, _t]), Za2(Et) || (Et = [Et, Et]), H2.from.each(function(Ft) {
        zt($, Ft, true), zt(et, Ft, false);
      }), at.each(function(Ft) {
        var fe2 = at.getItemModel(Ft).getModel("lineStyle").getLineStyle();
        at.setItemLayout(Ft, [$.getItemLayout(Ft), et.getItemLayout(Ft)]), fe2.stroke == null && (fe2.stroke = $.getItemVisual(Ft, "style").fill), at.setItemVisual(Ft, { fromSymbolKeepAspect: $.getItemVisual(Ft, "symbolKeepAspect"), fromSymbolOffset: $.getItemVisual(Ft, "symbolOffset"), fromSymbolRotate: $.getItemVisual(Ft, "symbolRotate"), fromSymbolSize: $.getItemVisual(Ft, "symbolSize"), fromSymbol: $.getItemVisual(Ft, "symbol"), toSymbolKeepAspect: et.getItemVisual(Ft, "symbolKeepAspect"), toSymbolOffset: et.getItemVisual(Ft, "symbolOffset"), toSymbolRotate: et.getItemVisual(Ft, "symbolRotate"), toSymbolSize: et.getItemVisual(Ft, "symbolSize"), toSymbol: et.getItemVisual(Ft, "symbol"), style: fe2 });
      }), z3.updateData(at), H2.line.eachItemGraphicEl(function(Ft, fe2) {
        Ft.traverse(function(re2) {
          Du(re2).dataModel = h;
        });
      });
      function zt(Ft, fe2, re2) {
        var ye = Ft.getItemModel(fe2);
        HQt(Ft, fe2, re2, t2, _);
        var me2 = ye.getModel("itemStyle").getItemStyle();
        me2.fill == null && (me2.fill = Lgt(P2, "color")), Ft.setItemVisual(fe2, { symbolKeepAspect: ye.get("symbolKeepAspect"), symbolOffset: _c2(ye.get("symbolOffset", true), Et[re2 ? 0 : 1]), symbolRotate: _c2(ye.get("symbolRotate", true), _t[re2 ? 0 : 1]), symbolSize: _c2(ye.get("symbolSize"), bt[re2 ? 0 : 1]), symbol: _c2(ye.get("symbol", true), ht[re2 ? 0 : 1]), style: me2 });
      }
      this.markKeep(z3), z3.group.silent = h.get("silent") || t2.get("silent");
    }, i.type = "markLine", i;
  }(yre);
  function MIr(f2, i, t2) {
    var h;
    f2 ? h = Xa2(f2 && f2.dimensions, function(N3) {
      var z3 = i.getData().getDimensionInfo(i.getData().mapDimension(N3)) || {};
      return ba2(ba2({}, z3), { name: N3, ordinalMeta: null });
    }) : h = [{ name: "value", type: "float" }];
    var v4 = new B2(h, t2), _ = new B2(h, t2), M2 = new B2([], t2), I2 = Xa2(t2.get("data"), Ou(xIr, i, f2, t2));
    f2 && (I2 = Ld2(I2, Ou(wIr, f2)));
    var P2 = Oqe(!!f2, h);
    return v4.initData(Xa2(I2, function(N3) {
      return N3[0];
    }), null, P2), _.initData(Xa2(I2, function(N3) {
      return N3[1];
    }), null, P2), M2.initData(Xa2(I2, function(N3) {
      return N3[2];
    })), M2.hasItemOption = true, { from: v4, to: _, line: M2 };
  }
  var CIr = SIr;
  function TIr(f2) {
    f2.registerComponentModel(_Ir), f2.registerComponentView(CIr), f2.registerPreprocessor(function(i) {
      gre(i.series, "markLine") && (i.markLine = i.markLine || {});
    });
  }
  var AIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.createMarkerModelFromSeries = function(t2, h, v4) {
      return new i(t2, h, v4);
    }, i.type = "markArea", i.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, i;
  }(iV), IIr = AIr, EDt = Wh2(), DIr = function(f2, i, t2, h) {
    var v4 = bgt(f2, h[0]), _ = bgt(f2, h[1]), M2 = v4.coord, I2 = _.coord;
    M2[0] = y_(M2[0], -1 / 0), M2[1] = y_(M2[1], -1 / 0), I2[0] = y_(I2[0], 1 / 0), I2[1] = y_(I2[1], 1 / 0);
    var P2 = _ee([{}, v4, _]);
    return P2.coord = [v4.coord, _.coord], P2.x0 = v4.x, P2.y0 = v4.y, P2.x1 = _.x, P2.y1 = _.y, P2;
  };
  function YEt(f2) {
    return !isNaN(f2) && !isFinite(f2);
  }
  function kVe(f2, i, t2, h) {
    var v4 = 1 - f2;
    return YEt(i[v4]) && YEt(t2[v4]);
  }
  function EIr(f2, i) {
    var t2 = i.coord[0], h = i.coord[1];
    return Y6(f2, "cartesian2d") && t2 && h && (kVe(1, t2, h) || kVe(0, t2, h)) ? true : _gt(f2, { coord: t2, x: i.x0, y: i.y0 }) || _gt(f2, { coord: h, x: i.x1, y: i.y1 });
  }
  function PVe(f2, i, t2, h, v4) {
    var _ = h.coordinateSystem, M2 = f2.getItemModel(i), I2, P2 = cs(M2.get(t2[0]), v4.getWidth()), N3 = cs(M2.get(t2[1]), v4.getHeight());
    if (!isNaN(P2) && !isNaN(N3))
      I2 = [P2, N3];
    else {
      if (h.getMarkerPosition)
        I2 = h.getMarkerPosition(f2.getValues(t2, i));
      else {
        var z3 = f2.get(t2[0], i), H2 = f2.get(t2[1], i), $ = [z3, H2];
        _.clampData && _.clampData($, $), I2 = _.dataToPoint($, true);
      }
      if (Y6(_, "cartesian2d")) {
        var et = _.getAxis("x"), at = _.getAxis("y"), z3 = f2.get(t2[0], i), H2 = f2.get(t2[1], i);
        YEt(z3) ? I2[0] = et.toGlobalCoord(et.getExtent()[t2[0] === "x0" ? 0 : 1]) : YEt(H2) && (I2[1] = at.toGlobalCoord(at.getExtent()[t2[1] === "y0" ? 0 : 1]));
      }
      isNaN(P2) || (I2[0] = P2), isNaN(N3) || (I2[1] = N3);
    }
    return I2;
  }
  var LVe = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], kIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.updateTransform = function(t2, h, v4) {
      h.eachSeries(function(_) {
        var M2 = iV.getMarkerModelFromSeries(_, "markArea");
        if (M2) {
          var I2 = M2.getData();
          I2.each(function(P2) {
            var N3 = Xa2(LVe, function(H2) {
              return PVe(I2, P2, H2, _, v4);
            });
            I2.setItemLayout(P2, N3);
            var z3 = I2.getItemGraphicEl(P2);
            z3.setShape("points", N3);
          });
        }
      }, this);
    }, i.prototype.renderSeries = function(t2, h, v4, _) {
      var M2 = t2.coordinateSystem, I2 = t2.id, P2 = t2.getData(), N3 = this.markerGroupMap, z3 = N3.get(I2) || N3.set(I2, { group: new mu() });
      this.group.add(z3.group), this.markKeep(z3);
      var H2 = PIr(M2, t2, h);
      h.setData(H2), H2.each(function($) {
        var et = Xa2(LVe, function(me2) {
          return PVe(H2, $, me2, t2, _);
        }), at = M2.getAxis("x").scale, ht = M2.getAxis("y").scale, bt = at.getExtent(), _t = ht.getExtent(), Et = [at.parse(H2.get("x0", $)), at.parse(H2.get("x1", $))], zt = [ht.parse(H2.get("y0", $)), ht.parse(H2.get("y1", $))];
        QD(Et), QD(zt);
        var Ft = !(bt[0] > Et[1] || bt[1] < Et[0] || _t[0] > zt[1] || _t[1] < zt[0]), fe2 = !Ft;
        H2.setItemLayout($, { points: et, allClipped: fe2 });
        var re2 = H2.getItemModel($).getModel("itemStyle").getItemStyle(), ye = Lgt(P2, "color");
        re2.fill || (re2.fill = ye, ms(re2.fill) && (re2.fill = uEt(re2.fill, 0.4))), re2.stroke || (re2.stroke = ye), H2.setItemVisual($, "style", re2);
      }), H2.diff(EDt(z3).data).add(function($) {
        var et = H2.getItemLayout($);
        if (!et.allClipped) {
          var at = new iC({ shape: { points: et.points } });
          H2.setItemGraphicEl($, at), z3.group.add(at);
        }
      }).update(function($, et) {
        var at = EDt(z3).data.getItemGraphicEl(et), ht = H2.getItemLayout($);
        ht.allClipped ? at && z3.group.remove(at) : (at ? jh2(at, { shape: { points: ht.points } }, h, $) : at = new iC({ shape: { points: ht.points } }), H2.setItemGraphicEl($, at), z3.group.add(at));
      }).remove(function($) {
        var et = EDt(z3).data.getItemGraphicEl($);
        z3.group.remove(et);
      }).execute(), H2.eachItemGraphicEl(function($, et) {
        var at = H2.getItemModel(et), ht = H2.getItemVisual(et, "style");
        $.useStyle(H2.getItemVisual(et, "style")), SS($, b_(at), { labelFetcher: h, labelDataIndex: et, defaultText: H2.getName(et) || "", inheritColor: ms(ht.fill) ? uEt(ht.fill, 1) : "#000" }), Hx($, at), vy($, null, null, at.get(["emphasis", "disabled"])), Du($).dataModel = h;
      }), EDt(z3).data = H2, z3.group.silent = h.get("silent") || t2.get("silent");
    }, i.type = "markArea", i;
  }(yre);
  function PIr(f2, i, t2) {
    var h, v4, _ = ["x0", "y0", "x1", "y1"];
    if (f2) {
      var M2 = Xa2(f2 && f2.dimensions, function(N3) {
        var z3 = i.getData(), H2 = z3.getDimensionInfo(z3.mapDimension(N3)) || {};
        return ba2(ba2({}, H2), { name: N3, ordinalMeta: null });
      });
      v4 = Xa2(_, function(N3, z3) {
        return { name: N3, type: M2[z3 % 2].type };
      }), h = new B2(v4, t2);
    } else
      v4 = [{ name: "value", type: "float" }], h = new B2(v4, t2);
    var I2 = Xa2(t2.get("data"), Ou(DIr, i, f2, t2));
    f2 && (I2 = Ld2(I2, Ou(EIr, f2)));
    var P2 = f2 ? function(N3, z3, H2, $) {
      var et = N3.coord[Math.floor($ / 2)][$ % 2];
      return $7(et, v4[$]);
    } : function(N3, z3, H2, $) {
      return $7(N3.value, v4[$]);
    };
    return h.initData(I2, null, P2), h.hasItemOption = true, h;
  }
  var LIr = kIr;
  function OIr(f2) {
    f2.registerComponentModel(IIr), f2.registerComponentView(LIr), f2.registerPreprocessor(function(i) {
      gre(i.series, "markArea") && (i.markArea = i.markArea || {});
    });
  }
  var RIr = function(f2, i) {
    if (i === "all")
      return { type: "all", title: f2.getLocaleModel().get(["legend", "selector", "all"]) };
    if (i === "inverse")
      return { type: "inverse", title: f2.getLocaleModel().get(["legend", "selector", "inverse"]) };
  }, NIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.layoutMode = { type: "box", ignoreSize: true }, t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      this.mergeDefaultAndTheme(t2, v4), t2.selected = t2.selected || {}, this._updateSelector(t2);
    }, i.prototype.mergeOption = function(t2, h) {
      f2.prototype.mergeOption.call(this, t2, h), this._updateSelector(t2);
    }, i.prototype._updateSelector = function(t2) {
      var h = t2.selector, v4 = this.ecModel;
      h === true && (h = t2.selector = ["all", "inverse"]), Za2(h) && Qe2(h, function(_, M2) {
        ms(_) && (_ = { type: _ }), h[M2] = cc2(_, RIr(v4, _.type));
      });
    }, i.prototype.optionUpdated = function() {
      this._updateData(this.ecModel);
      var t2 = this._data;
      if (t2[0] && this.get("selectedMode") === "single") {
        for (var h = false, v4 = 0; v4 < t2.length; v4++) {
          var _ = t2[v4].get("name");
          if (this.isSelected(_)) {
            this.select(_), h = true;
            break;
          }
        }
        !h && this.select(t2[0].get("name"));
      }
    }, i.prototype._updateData = function(t2) {
      var h = [], v4 = [];
      t2.eachRawSeries(function(I2) {
        var P2 = I2.name;
        v4.push(P2);
        var N3;
        if (I2.legendVisualProvider) {
          var z3 = I2.legendVisualProvider, H2 = z3.getAllNames();
          t2.isSeriesFiltered(I2) || (v4 = v4.concat(H2)), H2.length ? h = h.concat(H2) : N3 = true;
        } else
          N3 = true;
        N3 && Eee(I2) && h.push(I2.name);
      }), this._availableNames = v4;
      var _ = this.get("data") || h, M2 = Xa2(_, function(I2) {
        return (ms(I2) || vp(I2)) && (I2 = { name: I2 }), new Gg2(I2, this, this.ecModel);
      }, this);
      this._data = M2;
    }, i.prototype.getData = function() {
      return this._data;
    }, i.prototype.select = function(t2) {
      var h = this.option.selected, v4 = this.get("selectedMode");
      if (v4 === "single") {
        var _ = this._data;
        Qe2(_, function(M2) {
          h[M2.get("name")] = false;
        });
      }
      h[t2] = true;
    }, i.prototype.unSelect = function(t2) {
      this.get("selectedMode") !== "single" && (this.option.selected[t2] = false);
    }, i.prototype.toggleSelected = function(t2) {
      var h = this.option.selected;
      h.hasOwnProperty(t2) || (h[t2] = true), this[h[t2] ? "unSelect" : "select"](t2);
    }, i.prototype.allSelect = function() {
      var t2 = this._data, h = this.option.selected;
      Qe2(t2, function(v4) {
        h[v4.get("name", true)] = true;
      });
    }, i.prototype.inverseSelect = function() {
      var t2 = this._data, h = this.option.selected;
      Qe2(t2, function(v4) {
        var _ = v4.get("name", true);
        h.hasOwnProperty(_) || (h[_] = true), h[_] = !h[_];
      });
    }, i.prototype.isSelected = function(t2) {
      var h = this.option.selected;
      return !(h.hasOwnProperty(t2) && !h[t2]) && Pc2(this._availableNames, t2) >= 0;
    }, i.prototype.getOrient = function() {
      return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
    }, i.type = "legend.plain", i.dependencies = ["series"], i.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, i;
  }(zh2), Hte = NIr, gtt = Ou, Ute = Qe2, kDt = mu, FIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.newlineDisabled = false, t2;
    }
    return i.prototype.init = function() {
      this.group.add(this._contentGroup = new kDt()), this.group.add(this._selectorGroup = new kDt()), this._isFirstRender = true;
    }, i.prototype.getContentGroup = function() {
      return this._contentGroup;
    }, i.prototype.getSelectorGroup = function() {
      return this._selectorGroup;
    }, i.prototype.render = function(t2, h, v4) {
      var _ = this._isFirstRender;
      if (this._isFirstRender = false, this.resetInner(), !!t2.get("show", true)) {
        var M2 = t2.get("align"), I2 = t2.get("orient");
        (!M2 || M2 === "auto") && (M2 = t2.get("left") === "right" && I2 === "vertical" ? "right" : "left");
        var P2 = t2.get("selector", true), N3 = t2.get("selectorPosition", true);
        P2 && (!N3 || N3 === "auto") && (N3 = I2 === "horizontal" ? "end" : "start"), this.renderInner(M2, t2, h, v4, P2, I2, N3);
        var z3 = t2.getBoxLayoutParams(), H2 = { width: v4.getWidth(), height: v4.getHeight() }, $ = t2.get("padding"), et = u1(z3, H2, $), at = this.layoutInner(t2, M2, et, _, P2, N3), ht = u1(Ul({ width: at.width, height: at.height }, z3), H2, $);
        this.group.x = ht.x - at.x, this.group.y = ht.y - at.y, this.group.markRedraw(), this.group.add(this._backgroundEl = wqe(at, t2));
      }
    }, i.prototype.resetInner = function() {
      this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
    }, i.prototype.renderInner = function(t2, h, v4, _, M2, I2, P2) {
      var N3 = this.getContentGroup(), z3 = Il(), H2 = h.get("selectedMode"), $ = [];
      v4.eachRawSeries(function(et) {
        !et.get("legendHoverLink") && $.push(et.id);
      }), Ute(h.getData(), function(et, at) {
        var ht = et.get("name");
        if (!this.newlineDisabled && (ht === "" || ht === `
`)) {
          var bt = new kDt();
          bt.newline = true, N3.add(bt);
          return;
        }
        var _t = v4.getSeriesByName(ht)[0];
        if (!z3.get(ht))
          if (_t) {
            var Et = _t.getData(), zt = Et.getVisual("legendLineStyle") || {}, Ft = Et.getVisual("legendIcon"), fe2 = Et.getVisual("style"), re2 = this._createItem(_t, ht, at, et, h, t2, zt, fe2, Ft, H2);
            re2.on("click", gtt(OVe, ht, null, _, $)).on("mouseover", gtt(qte, _t.name, null, _, $)).on("mouseout", gtt(Zte, _t.name, null, _, $)), z3.set(ht, true);
          } else
            v4.eachRawSeries(function(ye) {
              if (!z3.get(ht) && ye.legendVisualProvider) {
                var me2 = ye.legendVisualProvider;
                if (!me2.containName(ht))
                  return;
                var be2 = me2.indexOfName(ht), Te2 = me2.getItemVisual(be2, "style"), We = me2.getItemVisual(be2, "legendIcon"), en = ZT(Te2.fill);
                en && en[3] === 0 && (en[3] = 0.2, Te2 = ba2(ba2({}, Te2), { fill: Z6(en, "rgba") }));
                var Ue2 = this._createItem(ye, ht, at, et, h, t2, {}, Te2, We, H2);
                Ue2.on("click", gtt(OVe, null, ht, _, $)).on("mouseover", gtt(qte, null, ht, _, $)).on("mouseout", gtt(Zte, null, ht, _, $)), z3.set(ht, true);
              }
            }, this);
      }, this), M2 && this._createSelector(M2, h, _, I2, P2);
    }, i.prototype._createSelector = function(t2, h, v4, _, M2) {
      var I2 = this.getSelectorGroup();
      Ute(t2, function(N3) {
        var z3 = N3.type, H2 = new op({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
          v4.dispatchAction({ type: z3 === "all" ? "legendAllSelect" : "legendInverseSelect" });
        } });
        I2.add(H2);
        var $ = h.getModel("selectorLabel"), et = h.getModel(["emphasis", "selectorLabel"]);
        SS(H2, { normal: $, emphasis: et }, { defaultText: N3.title }), uU(H2);
      });
    }, i.prototype._createItem = function(t2, h, v4, _, M2, I2, P2, N3, z3, H2) {
      var $ = t2.visualDrawType, et = M2.get("itemWidth"), at = M2.get("itemHeight"), ht = M2.isSelected(h), bt = _.get("symbolRotate"), _t = _.get("symbolKeepAspect"), Et = _.get("icon");
      z3 = Et || z3 || "roundRect";
      var zt = VIr(z3, _, P2, N3, $, ht), Ft = new kDt(), fe2 = _.getModel("textStyle");
      if (Ol(t2.getLegendIcon) && (!Et || Et === "inherit"))
        Ft.add(t2.getLegendIcon({ itemWidth: et, itemHeight: at, icon: z3, iconRotate: bt, itemStyle: zt.itemStyle, lineStyle: zt.lineStyle, symbolKeepAspect: _t }));
      else {
        var re2 = Et === "inherit" && t2.getData().getVisual("symbol") ? bt === "inherit" ? t2.getData().getVisual("symbolRotate") : bt : 0;
        Ft.add(BIr({ itemWidth: et, itemHeight: at, icon: z3, iconRotate: re2, itemStyle: zt.itemStyle, lineStyle: zt.lineStyle, symbolKeepAspect: _t }));
      }
      var ye = I2 === "left" ? et + 5 : -5, me2 = I2, be2 = M2.get("formatter"), Te2 = h;
      ms(be2) && be2 ? Te2 = be2.replace("{name}", h != null ? h : "") : Ol(be2) && (Te2 = be2(h));
      var We = _.get("inactiveColor");
      Ft.add(new op({ style: By(fe2, { text: Te2, x: ye, y: at / 2, fill: ht ? fe2.getTextColor() : We, align: me2, verticalAlign: "middle" }) }));
      var en = new Sh2({ shape: Ft.getBoundingRect(), invisible: true }), Ue2 = _.getModel("tooltip");
      return Ue2.get("show") && eet({ el: en, componentModel: M2, itemName: h, itemTooltipOption: Ue2.option }), Ft.add(en), Ft.eachChild(function(Mn) {
        Mn.silent = true;
      }), en.silent = !H2, this.getContentGroup().add(Ft), uU(Ft), Ft.__legendDataIndex = v4, Ft;
    }, i.prototype.layoutInner = function(t2, h, v4, _, M2, I2) {
      var P2 = this.getContentGroup(), N3 = this.getSelectorGroup();
      fU(t2.get("orient"), P2, t2.get("itemGap"), v4.width, v4.height);
      var z3 = P2.getBoundingRect(), H2 = [-z3.x, -z3.y];
      if (N3.markRedraw(), P2.markRedraw(), M2) {
        fU("horizontal", N3, t2.get("selectorItemGap", true));
        var $ = N3.getBoundingRect(), et = [-$.x, -$.y], at = t2.get("selectorButtonGap", true), ht = t2.getOrient().index, bt = ht === 0 ? "width" : "height", _t = ht === 0 ? "height" : "width", Et = ht === 0 ? "y" : "x";
        I2 === "end" ? et[ht] += z3[bt] + at : H2[ht] += $[bt] + at, et[1 - ht] += z3[_t] / 2 - $[_t] / 2, N3.x = et[0], N3.y = et[1], P2.x = H2[0], P2.y = H2[1];
        var zt = { x: 0, y: 0 };
        return zt[bt] = z3[bt] + at + $[bt], zt[_t] = Math.max(z3[_t], $[_t]), zt[Et] = Math.min(0, $[Et] + et[1 - ht]), zt;
      } else
        return P2.x = H2[0], P2.y = H2[1], this.group.getBoundingRect();
    }, i.prototype.remove = function() {
      this.getContentGroup().removeAll(), this._isFirstRender = true;
    }, i.type = "legend.plain", i;
  }(W0);
  function VIr(f2, i, t2, h, v4, _) {
    function M2(at, ht) {
      at.lineWidth === "auto" && (at.lineWidth = ht.lineWidth > 0 ? 2 : 0), Ute(at, function(bt, _t) {
        at[_t] === "inherit" && (at[_t] = ht[_t]);
      });
    }
    var I2 = i.getModel("itemStyle"), P2 = I2.getItemStyle(), N3 = f2.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
    P2.decal = h.decal, P2.fill === "inherit" && (P2.fill = h[v4]), P2.stroke === "inherit" && (P2.stroke = h[N3]), P2.opacity === "inherit" && (P2.opacity = (v4 === "fill" ? h : t2).opacity), M2(P2, h);
    var z3 = i.getModel("lineStyle"), H2 = z3.getLineStyle();
    if (M2(H2, t2), P2.fill === "auto" && (P2.fill = h.fill), P2.stroke === "auto" && (P2.stroke = h.fill), H2.stroke === "auto" && (H2.stroke = h.fill), !_) {
      var $ = i.get("inactiveBorderWidth"), et = P2[N3];
      P2.lineWidth = $ === "auto" ? h.lineWidth > 0 && et ? 2 : 0 : P2.lineWidth, P2.fill = i.get("inactiveColor"), P2.stroke = i.get("inactiveBorderColor"), H2.stroke = z3.get("inactiveColor"), H2.lineWidth = z3.get("inactiveWidth");
    }
    return { itemStyle: P2, lineStyle: H2 };
  }
  function BIr(f2) {
    var i = f2.icon || "roundRect", t2 = wm(i, 0, 0, f2.itemWidth, f2.itemHeight, f2.itemStyle.fill, f2.symbolKeepAspect);
    return t2.setStyle(f2.itemStyle), t2.rotation = (f2.iconRotate || 0) * Math.PI / 180, t2.setOrigin([f2.itemWidth / 2, f2.itemHeight / 2]), i.indexOf("empty") > -1 && (t2.style.stroke = t2.style.fill, t2.style.fill = "#fff", t2.style.lineWidth = 2), t2;
  }
  function OVe(f2, i, t2, h) {
    Zte(f2, i, t2, h), t2.dispatchAction({ type: "legendToggleSelect", name: f2 != null ? f2 : i }), qte(f2, i, t2, h);
  }
  function Rqe(f2) {
    for (var i = f2.getZr().storage.getDisplayList(), t2, h = 0, v4 = i.length; h < v4 && !(t2 = i[h].states.emphasis); )
      h++;
    return t2 && t2.hoverLayer;
  }
  function qte(f2, i, t2, h) {
    Rqe(t2) || t2.dispatchAction({ type: "highlight", seriesName: f2, name: i, excludeSeriesId: h });
  }
  function Zte(f2, i, t2, h) {
    Rqe(t2) || t2.dispatchAction({ type: "downplay", seriesName: f2, name: i, excludeSeriesId: h });
  }
  var Nqe = FIr;
  function zIr(f2) {
    var i = f2.findComponents({ mainType: "legend" });
    i && i.length && f2.filterSeries(function(t2) {
      for (var h = 0; h < i.length; h++)
        if (!i[h].isSelected(t2.name))
          return false;
      return true;
    });
  }
  function ldt(f2, i, t2) {
    var h = {}, v4 = f2 === "toggleSelected", _;
    return t2.eachComponent("legend", function(M2) {
      v4 && _ != null ? M2[_ ? "select" : "unSelect"](i.name) : f2 === "allSelect" || f2 === "inverseSelect" ? M2[f2]() : (M2[f2](i.name), _ = M2.isSelected(i.name));
      var I2 = M2.getData();
      Qe2(I2, function(P2) {
        var N3 = P2.get("name");
        if (!(N3 === `
` || N3 === "")) {
          var z3 = M2.isSelected(N3);
          h.hasOwnProperty(N3) ? h[N3] = h[N3] && z3 : h[N3] = z3;
        }
      });
    }), f2 === "allSelect" || f2 === "inverseSelect" ? { selected: h } : { name: i.name, selected: h };
  }
  function jIr(f2) {
    f2.registerAction("legendToggleSelect", "legendselectchanged", Ou(ldt, "toggleSelected")), f2.registerAction("legendAllSelect", "legendselectall", Ou(ldt, "allSelect")), f2.registerAction("legendInverseSelect", "legendinverseselect", Ou(ldt, "inverseSelect")), f2.registerAction("legendSelect", "legendselected", Ou(ldt, "select")), f2.registerAction("legendUnSelect", "legendunselected", Ou(ldt, "unSelect"));
  }
  function Fqe(f2) {
    f2.registerComponentModel(Hte), f2.registerComponentView(Nqe), f2.registerProcessor(f2.PRIORITY.PROCESSOR.SERIES_FILTER, zIr), f2.registerSubTypeDefaulter("legend", function() {
      return "plain";
    }), jIr(f2);
  }
  var WIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.setScrollDataIndex = function(t2) {
      this.option.scrollDataIndex = t2;
    }, i.prototype.init = function(t2, h, v4) {
      var _ = aet(t2);
      f2.prototype.init.call(this, t2, h, v4), RVe(this, t2, _);
    }, i.prototype.mergeOption = function(t2, h) {
      f2.prototype.mergeOption.call(this, t2, h), RVe(this, this.option, t2);
    }, i.type = "legend.scroll", i.defaultOption = sV(Hte.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), i;
  }(Hte);
  function RVe(f2, i, t2) {
    var h = f2.getOrient(), v4 = [1, 1];
    v4[h.index] = 0, J7(i, t2, { type: "box", ignoreSize: !!v4 });
  }
  var GIr = WIr, NVe = mu, UQt = ["width", "height"], qQt = ["x", "y"], HIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.newlineDisabled = true, t2._currentIndex = 0, t2;
    }
    return i.prototype.init = function() {
      f2.prototype.init.call(this), this.group.add(this._containerGroup = new NVe()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new NVe());
    }, i.prototype.resetInner = function() {
      f2.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
    }, i.prototype.renderInner = function(t2, h, v4, _, M2, I2, P2) {
      var N3 = this;
      f2.prototype.renderInner.call(this, t2, h, v4, _, M2, I2, P2);
      var z3 = this._controllerGroup, H2 = h.get("pageIconSize", true), $ = Za2(H2) ? H2 : [H2, H2];
      at("pagePrev", 0);
      var et = h.getModel("pageTextStyle");
      z3.add(new op({ name: "pageText", style: { text: "xx/xx", fill: et.getTextColor(), font: et.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), at("pageNext", 1);
      function at(ht, bt) {
        var _t = ht + "DataIndex", Et = Egt(h.get("pageIcons", true)[h.getOrient().name][bt], { onclick: ks(N3._pageGo, N3, _t, h, _) }, { x: -$[0] / 2, y: -$[1] / 2, width: $[0], height: $[1] });
        Et.name = ht, z3.add(Et);
      }
    }, i.prototype.layoutInner = function(t2, h, v4, _, M2, I2) {
      var P2 = this.getSelectorGroup(), N3 = t2.getOrient().index, z3 = UQt[N3], H2 = qQt[N3], $ = UQt[1 - N3], et = qQt[1 - N3];
      M2 && fU("horizontal", P2, t2.get("selectorItemGap", true));
      var at = t2.get("selectorButtonGap", true), ht = P2.getBoundingRect(), bt = [-ht.x, -ht.y], _t = pu(v4);
      M2 && (_t[z3] = v4[z3] - ht[z3] - at);
      var Et = this._layoutContentAndController(t2, _, _t, N3, z3, $, et, H2);
      if (M2) {
        if (I2 === "end")
          bt[N3] += Et[z3] + at;
        else {
          var zt = ht[z3] + at;
          bt[N3] -= zt, Et[H2] -= zt;
        }
        Et[z3] += ht[z3] + at, bt[1 - N3] += Et[et] + Et[$] / 2 - ht[$] / 2, Et[$] = Math.max(Et[$], ht[$]), Et[et] = Math.min(Et[et], ht[et] + bt[1 - N3]), P2.x = bt[0], P2.y = bt[1], P2.markRedraw();
      }
      return Et;
    }, i.prototype._layoutContentAndController = function(t2, h, v4, _, M2, I2, P2, N3) {
      var z3 = this.getContentGroup(), H2 = this._containerGroup, $ = this._controllerGroup;
      fU(t2.get("orient"), z3, t2.get("itemGap"), _ ? v4.width : null, _ ? null : v4.height), fU("horizontal", $, t2.get("pageButtonItemGap", true));
      var et = z3.getBoundingRect(), at = $.getBoundingRect(), ht = this._showController = et[M2] > v4[M2], bt = [-et.x, -et.y];
      h || (bt[_] = z3[N3]);
      var _t = [0, 0], Et = [-at.x, -at.y], zt = _c2(t2.get("pageButtonGap", true), t2.get("itemGap", true));
      if (ht) {
        var Ft = t2.get("pageButtonPosition", true);
        Ft === "end" ? Et[_] += v4[M2] - at[M2] : _t[_] += at[M2] + zt;
      }
      Et[1 - _] += et[I2] / 2 - at[I2] / 2, z3.setPosition(bt), H2.setPosition(_t), $.setPosition(Et);
      var fe2 = { x: 0, y: 0 };
      if (fe2[M2] = ht ? v4[M2] : et[M2], fe2[I2] = Math.max(et[I2], at[I2]), fe2[P2] = Math.min(0, at[P2] + Et[1 - _]), H2.__rectSize = v4[M2], ht) {
        var re2 = { x: 0, y: 0 };
        re2[M2] = Math.max(v4[M2] - at[M2] - zt, 0), re2[I2] = fe2[I2], H2.setClipPath(new Sh2({ shape: re2 })), H2.__rectSize = re2[M2];
      } else
        $.eachChild(function(me2) {
          me2.attr({ invisible: true, silent: true });
        });
      var ye = this._getPageInfo(t2);
      return ye.pageIndex != null && jh2(z3, { x: ye.contentPosition[0], y: ye.contentPosition[1] }, ht ? t2 : null), this._updatePageInfoView(t2, ye), fe2;
    }, i.prototype._pageGo = function(t2, h, v4) {
      var _ = this._getPageInfo(h)[t2];
      _ != null && v4.dispatchAction({ type: "legendScroll", scrollDataIndex: _, legendId: h.id });
    }, i.prototype._updatePageInfoView = function(t2, h) {
      var v4 = this._controllerGroup;
      Qe2(["pagePrev", "pageNext"], function(z3) {
        var H2 = z3 + "DataIndex", $ = h[H2] != null, et = v4.childOfName(z3);
        et && (et.setStyle("fill", $ ? t2.get("pageIconColor", true) : t2.get("pageIconInactiveColor", true)), et.cursor = $ ? "pointer" : "default");
      });
      var _ = v4.childOfName("pageText"), M2 = t2.get("pageFormatter"), I2 = h.pageIndex, P2 = I2 != null ? I2 + 1 : 0, N3 = h.pageCount;
      _ && M2 && _.setStyle("text", ms(M2) ? M2.replace("{current}", P2 == null ? "" : P2 + "").replace("{total}", N3 == null ? "" : N3 + "") : M2({ current: P2, total: N3 }));
    }, i.prototype._getPageInfo = function(t2) {
      var h = t2.get("scrollDataIndex", true), v4 = this.getContentGroup(), _ = this._containerGroup.__rectSize, M2 = t2.getOrient().index, I2 = UQt[M2], P2 = qQt[M2], N3 = this._findTargetItemIndex(h), z3 = v4.children(), H2 = z3[N3], $ = z3.length, et = $ ? 1 : 0, at = { contentPosition: [v4.x, v4.y], pageCount: et, pageIndex: et - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
      if (!H2)
        return at;
      var ht = Ft(H2);
      at.contentPosition[M2] = -ht.s;
      for (var bt = N3 + 1, _t = ht, Et = ht, zt = null; bt <= $; ++bt)
        zt = Ft(z3[bt]), (!zt && Et.e > _t.s + _ || zt && !fe2(zt, _t.s)) && (Et.i > _t.i ? _t = Et : _t = zt, _t && (at.pageNextDataIndex == null && (at.pageNextDataIndex = _t.i), ++at.pageCount)), Et = zt;
      for (var bt = N3 - 1, _t = ht, Et = ht, zt = null; bt >= -1; --bt)
        zt = Ft(z3[bt]), (!zt || !fe2(Et, zt.s)) && _t.i < Et.i && (Et = _t, at.pagePrevDataIndex == null && (at.pagePrevDataIndex = _t.i), ++at.pageCount, ++at.pageIndex), _t = zt;
      return at;
      function Ft(re2) {
        if (re2) {
          var ye = re2.getBoundingRect(), me2 = ye[P2] + re2[P2];
          return { s: me2, e: me2 + ye[I2], i: re2.__legendDataIndex };
        }
      }
      function fe2(re2, ye) {
        return re2.e >= ye && re2.s <= ye + _;
      }
    }, i.prototype._findTargetItemIndex = function(t2) {
      if (!this._showController)
        return 0;
      var h, v4 = this.getContentGroup(), _;
      return v4.eachChild(function(M2, I2) {
        var P2 = M2.__legendDataIndex;
        _ == null && P2 != null && (_ = I2), P2 === t2 && (h = I2);
      }), h != null ? h : _;
    }, i.type = "legend.scroll", i;
  }(Nqe), UIr = HIr;
  function qIr(f2) {
    f2.registerAction("legendScroll", "legendscroll", function(i, t2) {
      var h = i.scrollDataIndex;
      h != null && t2.eachComponent({ mainType: "legend", subType: "scroll", query: i }, function(v4) {
        v4.setScrollDataIndex(h);
      });
    });
  }
  function ZIr(f2) {
    zc2(Fqe), f2.registerComponentModel(GIr), f2.registerComponentView(UIr), qIr(f2);
  }
  function $Ir(f2) {
    zc2(Fqe), zc2(ZIr);
  }
  var YIr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "dataZoom.inside", i.defaultOption = sV(mgt.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), i;
  }(mgt), KIr = YIr, mre = Wh2();
  function XIr(f2, i, t2) {
    mre(f2).coordSysRecordMap.each(function(h) {
      var v4 = h.dataZoomInfoMap.get(i.uid);
      v4 && (v4.getRange = t2);
    });
  }
  function QIr(f2, i) {
    for (var t2 = mre(f2).coordSysRecordMap, h = t2.keys(), v4 = 0; v4 < h.length; v4++) {
      var _ = h[v4], M2 = t2.get(_), I2 = M2.dataZoomInfoMap;
      if (I2) {
        var P2 = i.uid, N3 = I2.get(P2);
        N3 && (I2.removeKey(P2), I2.keys().length || Vqe(t2, M2));
      }
    }
  }
  function Vqe(f2, i) {
    if (i) {
      f2.removeKey(i.model.uid);
      var t2 = i.controller;
      t2 && t2.dispose();
    }
  }
  function JIr(f2, i) {
    var t2 = { model: i, containsPoint: Ou(eDr, i), dispatchAction: Ou(tDr, f2), dataZoomInfoMap: null, controller: null }, h = t2.controller = new Ggt(f2.getZr());
    return Qe2(["pan", "zoom", "scrollMove"], function(v4) {
      h.on(v4, function(_) {
        var M2 = [];
        t2.dataZoomInfoMap.each(function(I2) {
          if (!!_.isAvailableBehavior(I2.model.option)) {
            var P2 = (I2.getRange || {})[v4], N3 = P2 && P2(I2.dzReferCoordSysInfo, t2.model.mainType, t2.controller, _);
            !I2.model.get("disabled", true) && N3 && M2.push({ dataZoomId: I2.model.id, start: N3[0], end: N3[1] });
          }
        }), M2.length && t2.dispatchAction(M2);
      });
    }), t2;
  }
  function tDr(f2, i) {
    f2.isDisposed() || f2.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: i });
  }
  function eDr(f2, i, t2, h) {
    return f2.coordinateSystem.containPoint([t2, h]);
  }
  function nDr(f2) {
    var i, t2 = "type_", h = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, v4 = true;
    return f2.each(function(_) {
      var M2 = _.model, I2 = M2.get("disabled", true) ? false : M2.get("zoomLock", true) ? "move" : true;
      h[t2 + I2] > h[t2 + i] && (i = I2), v4 = v4 && M2.get("preventDefaultMouseMove", true);
    }), { controlType: i, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!v4 } };
  }
  function rDr(f2) {
    f2.registerProcessor(f2.PRIORITY.PROCESSOR.FILTER, function(i, t2) {
      var h = mre(t2), v4 = h.coordSysRecordMap || (h.coordSysRecordMap = Il());
      v4.each(function(_) {
        _.dataZoomInfoMap = null;
      }), i.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(_) {
        var M2 = bqe(_);
        Qe2(M2.infoList, function(I2) {
          var P2 = I2.model.uid, N3 = v4.get(P2) || v4.set(P2, JIr(t2, I2.model)), z3 = N3.dataZoomInfoMap || (N3.dataZoomInfoMap = Il());
          z3.set(_.uid, { dzReferCoordSysInfo: I2, model: _, getRange: null });
        });
      }), v4.each(function(_) {
        var M2 = _.controller, I2, P2 = _.dataZoomInfoMap;
        if (P2) {
          var N3 = P2.keys()[0];
          N3 != null && (I2 = P2.get(N3));
        }
        if (!I2) {
          Vqe(v4, _);
          return;
        }
        var z3 = nDr(P2);
        M2.enable(z3.controlType, z3.opt), M2.setPointerChecker(_.containsPoint), cet(_, "dispatchAction", I2.model.get("throttle", true), "fixRate");
      });
    });
  }
  var iDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "dataZoom.inside", t2;
    }
    return i.prototype.render = function(t2, h, v4) {
      if (f2.prototype.render.apply(this, arguments), t2.noTarget()) {
        this._clear();
        return;
      }
      this.range = t2.getPercentRange(), XIr(v4, t2, { pan: ks(ZQt.pan, this), zoom: ks(ZQt.zoom, this), scrollMove: ks(ZQt.scrollMove, this) });
    }, i.prototype.dispose = function() {
      this._clear(), f2.prototype.dispose.apply(this, arguments);
    }, i.prototype._clear = function() {
      QIr(this.api, this.dataZoomModel), this.range = null;
    }, i.type = "dataZoom.inside", i;
  }(ure), ZQt = { zoom: function(f2, i, t2, h) {
    var v4 = this.range, _ = v4.slice(), M2 = f2.axisModels[0];
    if (!!M2) {
      var I2 = $Qt[i](null, [h.originX, h.originY], M2, t2, f2), P2 = (I2.signal > 0 ? I2.pixelStart + I2.pixelLength - I2.pixel : I2.pixel - I2.pixelStart) / I2.pixelLength * (_[1] - _[0]) + _[0], N3 = Math.max(1 / h.scale, 0);
      _[0] = (_[0] - P2) * N3 + P2, _[1] = (_[1] - P2) * N3 + P2;
      var z3 = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
      if (AU(0, _, [0, 100], 0, z3.minSpan, z3.maxSpan), this.range = _, v4[0] !== _[0] || v4[1] !== _[1])
        return _;
    }
  }, pan: FVe(function(f2, i, t2, h, v4, _) {
    var M2 = $Qt[h]([_.oldX, _.oldY], [_.newX, _.newY], i, v4, t2);
    return M2.signal * (f2[1] - f2[0]) * M2.pixel / M2.pixelLength;
  }), scrollMove: FVe(function(f2, i, t2, h, v4, _) {
    var M2 = $Qt[h]([0, 0], [_.scrollDelta, _.scrollDelta], i, v4, t2);
    return M2.signal * (f2[1] - f2[0]) * _.scrollDelta;
  }) };
  function FVe(f2) {
    return function(i, t2, h, v4) {
      var _ = this.range, M2 = _.slice(), I2 = i.axisModels[0];
      if (!!I2) {
        var P2 = f2(M2, I2, i, t2, h, v4);
        if (AU(P2, M2, [0, 100], "all"), this.range = M2, _[0] !== M2[0] || _[1] !== M2[1])
          return M2;
      }
    };
  }
  var $Qt = { grid: function(f2, i, t2, h, v4) {
    var _ = t2.axis, M2 = {}, I2 = v4.model.coordinateSystem.getRect();
    return f2 = f2 || [0, 0], _.dim === "x" ? (M2.pixel = i[0] - f2[0], M2.pixelLength = I2.width, M2.pixelStart = I2.x, M2.signal = _.inverse ? 1 : -1) : (M2.pixel = i[1] - f2[1], M2.pixelLength = I2.height, M2.pixelStart = I2.y, M2.signal = _.inverse ? -1 : 1), M2;
  }, polar: function(f2, i, t2, h, v4) {
    var _ = t2.axis, M2 = {}, I2 = v4.model.coordinateSystem, P2 = I2.getRadiusAxis().getExtent(), N3 = I2.getAngleAxis().getExtent();
    return f2 = f2 ? I2.pointToCoord(f2) : [0, 0], i = I2.pointToCoord(i), t2.mainType === "radiusAxis" ? (M2.pixel = i[0] - f2[0], M2.pixelLength = P2[1] - P2[0], M2.pixelStart = P2[0], M2.signal = _.inverse ? 1 : -1) : (M2.pixel = i[1] - f2[1], M2.pixelLength = N3[1] - N3[0], M2.pixelStart = N3[0], M2.signal = _.inverse ? -1 : 1), M2;
  }, singleAxis: function(f2, i, t2, h, v4) {
    var _ = t2.axis, M2 = v4.model.coordinateSystem.getRect(), I2 = {};
    return f2 = f2 || [0, 0], _.orient === "horizontal" ? (I2.pixel = i[0] - f2[0], I2.pixelLength = M2.width, I2.pixelStart = M2.x, I2.signal = _.inverse ? 1 : -1) : (I2.pixel = i[1] - f2[1], I2.pixelLength = M2.height, I2.pixelStart = M2.y, I2.signal = _.inverse ? -1 : 1), I2;
  } }, aDr = iDr;
  function Bqe(f2) {
    cre(f2), f2.registerComponentModel(KIr), f2.registerComponentView(aDr), rDr(f2);
  }
  var oDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.type = "dataZoom.slider", i.layoutMode = "box", i.defaultOption = sV(mgt.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), i;
  }(mgt), sDr = oDr, udt = Sh2, VVe = 7, lDr = 1, YQt = 30, uDr = 7, cdt = "horizontal", BVe = "vertical", cDr = 5, fDr = ["line", "bar", "candlestick", "scatter"], hDr = { easing: "cubicOut", duration: 100, delay: 0 }, pDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._displayables = {}, t2;
    }
    return i.prototype.init = function(t2, h) {
      this.api = h, this._onBrush = ks(this._onBrush, this), this._onBrushEnd = ks(this._onBrushEnd, this);
    }, i.prototype.render = function(t2, h, v4, _) {
      if (f2.prototype.render.apply(this, arguments), cet(this, "_dispatchZoomAction", t2.get("throttle"), "fixRate"), this._orient = t2.getOrient(), t2.get("show") === false) {
        this.group.removeAll();
        return;
      }
      if (t2.noTarget()) {
        this._clear(), this.group.removeAll();
        return;
      }
      (!_ || _.type !== "dataZoom" || _.from !== this.uid) && this._buildView(), this._updateView();
    }, i.prototype.dispose = function() {
      this._clear(), f2.prototype.dispose.apply(this, arguments);
    }, i.prototype._clear = function() {
      agt(this, "_dispatchZoomAction");
      var t2 = this.api.getZr();
      t2.off("mousemove", this._onBrush), t2.off("mouseup", this._onBrushEnd);
    }, i.prototype._buildView = function() {
      var t2 = this.group;
      t2.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
      var h = this._displayables.sliderGroup = new mu();
      this._renderBackground(), this._renderHandle(), this._renderDataShadow(), t2.add(h), this._positionGroup();
    }, i.prototype._resetLocation = function() {
      var t2 = this.dataZoomModel, h = this.api, v4 = t2.get("brushSelect"), _ = v4 ? uDr : 0, M2 = this._findCoordRect(), I2 = { width: h.getWidth(), height: h.getHeight() }, P2 = this._orient === cdt ? { right: I2.width - M2.x - M2.width, top: I2.height - YQt - VVe - _, width: M2.width, height: YQt } : { right: VVe, top: M2.y, width: YQt, height: M2.height }, N3 = aet(t2.option);
      Qe2(["right", "top", "width", "height"], function(H2) {
        N3[H2] === "ph" && (N3[H2] = P2[H2]);
      });
      var z3 = u1(N3, I2);
      this._location = { x: z3.x, y: z3.y }, this._size = [z3.width, z3.height], this._orient === BVe && this._size.reverse();
    }, i.prototype._positionGroup = function() {
      var t2 = this.group, h = this._location, v4 = this._orient, _ = this.dataZoomModel.getFirstTargetAxisModel(), M2 = _ && _.get("inverse"), I2 = this._displayables.sliderGroup, P2 = (this._dataShadowInfo || {}).otherAxisInverse;
      I2.attr(v4 === cdt && !M2 ? { scaleY: P2 ? 1 : -1, scaleX: 1 } : v4 === cdt && M2 ? { scaleY: P2 ? 1 : -1, scaleX: -1 } : v4 === BVe && !M2 ? { scaleY: P2 ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: P2 ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
      var N3 = t2.getBoundingRect([I2]);
      t2.x = h.x - N3.x, t2.y = h.y - N3.y, t2.markRedraw();
    }, i.prototype._getViewExtent = function() {
      return [0, this._size[0]];
    }, i.prototype._renderBackground = function() {
      var t2 = this.dataZoomModel, h = this._size, v4 = this._displayables.sliderGroup, _ = t2.get("brushSelect");
      v4.add(new udt({ silent: true, shape: { x: 0, y: 0, width: h[0], height: h[1] }, style: { fill: t2.get("backgroundColor") }, z2: -40 }));
      var M2 = new udt({ shape: { x: 0, y: 0, width: h[0], height: h[1] }, style: { fill: "transparent" }, z2: 0, onclick: ks(this._onClickPanel, this) }), I2 = this.api.getZr();
      _ ? (M2.on("mousedown", this._onBrushStart, this), M2.cursor = "crosshair", I2.on("mousemove", this._onBrush), I2.on("mouseup", this._onBrushEnd)) : (I2.off("mousemove", this._onBrush), I2.off("mouseup", this._onBrushEnd)), v4.add(M2);
    }, i.prototype._renderDataShadow = function() {
      var t2 = this._dataShadowInfo = this._prepareDataShadowInfo();
      if (this._displayables.dataShadowSegs = [], !t2)
        return;
      var h = this._size, v4 = this._shadowSize || [], _ = t2.series, M2 = _.getRawData(), I2 = _.getShadowDim ? _.getShadowDim() : t2.otherDim;
      if (I2 == null)
        return;
      var P2 = this._shadowPolygonPts, N3 = this._shadowPolylinePts;
      if (M2 !== this._shadowData || I2 !== this._shadowDim || h[0] !== v4[0] || h[1] !== v4[1]) {
        var z3 = M2.getDataExtent(I2), H2 = (z3[1] - z3[0]) * 0.3;
        z3 = [z3[0] - H2, z3[1] + H2];
        var $ = [0, h[1]], et = [0, h[0]], at = [[h[0], 0], [0, 0]], ht = [], bt = et[1] / (M2.count() - 1), _t = 0, Et = Math.round(M2.count() / h[0]), zt;
        M2.each([I2], function(me2, be2) {
          if (Et > 0 && be2 % Et) {
            _t += bt;
            return;
          }
          var Te2 = me2 == null || isNaN(me2) || me2 === "", We = Te2 ? 0 : cd2(me2, z3, $, true);
          Te2 && !zt && be2 ? (at.push([at[at.length - 1][0], 0]), ht.push([ht[ht.length - 1][0], 0])) : !Te2 && zt && (at.push([_t, 0]), ht.push([_t, 0])), at.push([_t, We]), ht.push([_t, We]), _t += bt, zt = Te2;
        }), P2 = this._shadowPolygonPts = at, N3 = this._shadowPolylinePts = ht;
      }
      this._shadowData = M2, this._shadowDim = I2, this._shadowSize = [h[0], h[1]];
      var Ft = this.dataZoomModel;
      function fe2(me2) {
        var be2 = Ft.getModel(me2 ? "selectedDataBackground" : "dataBackground"), Te2 = new mu(), We = new iC({ shape: { points: P2 }, segmentIgnoreThreshold: 1, style: be2.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), en = new aC({ shape: { points: N3 }, segmentIgnoreThreshold: 1, style: be2.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
        return Te2.add(We), Te2.add(en), Te2;
      }
      for (var re2 = 0; re2 < 3; re2++) {
        var ye = fe2(re2 === 1);
        this._displayables.sliderGroup.add(ye), this._displayables.dataShadowSegs.push(ye);
      }
    }, i.prototype._prepareDataShadowInfo = function() {
      var t2 = this.dataZoomModel, h = t2.get("showDataShadow");
      if (h !== false) {
        var v4, _ = this.ecModel;
        return t2.eachTargetAxis(function(M2, I2) {
          var P2 = t2.getAxisProxy(M2, I2).getTargetSeriesModels();
          Qe2(P2, function(N3) {
            if (!v4 && !(h !== true && Pc2(fDr, N3.get("type")) < 0)) {
              var z3 = _.getComponent(H7(M2), I2).axis, H2 = dDr(M2), $, et = N3.coordinateSystem;
              H2 != null && et.getOtherAxis && ($ = et.getOtherAxis(z3).inverse), H2 = N3.getData().mapDimension(H2), v4 = { thisAxis: z3, series: N3, thisDim: M2, otherDim: H2, otherAxisInverse: $ };
            }
          }, this);
        }, this), v4;
      }
    }, i.prototype._renderHandle = function() {
      var t2 = this.group, h = this._displayables, v4 = h.handles = [null, null], _ = h.handleLabels = [null, null], M2 = this._displayables.sliderGroup, I2 = this._size, P2 = this.dataZoomModel, N3 = this.api, z3 = P2.get("borderRadius") || 0, H2 = P2.get("brushSelect"), $ = h.filler = new udt({ silent: H2, style: { fill: P2.get("fillerColor") }, textConfig: { position: "inside" } });
      M2.add($), M2.add(new udt({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: I2[0], height: I2[1], r: z3 }, style: { stroke: P2.get("dataBackgroundColor") || P2.get("borderColor"), lineWidth: lDr, fill: "rgba(0,0,0,0)" } })), Qe2([0, 1], function(zt) {
        var Ft = P2.get("handleIcon");
        !CEt[Ft] && Ft.indexOf("path://") < 0 && Ft.indexOf("image://") < 0 && (Ft = "path://" + Ft);
        var fe2 = wm(Ft, -1, 0, 2, 2, null, true);
        fe2.attr({ cursor: zVe(this._orient), draggable: true, drift: ks(this._onDragMove, this, zt), ondragend: ks(this._onDragEnd, this), onmouseover: ks(this._showDataInfo, this, true), onmouseout: ks(this._showDataInfo, this, false), z2: 5 });
        var re2 = fe2.getBoundingRect(), ye = P2.get("handleSize");
        this._handleHeight = cs(ye, this._size[1]), this._handleWidth = re2.width / re2.height * this._handleHeight, fe2.setStyle(P2.getModel("handleStyle").getItemStyle()), fe2.style.strokeNoScale = true, fe2.rectHover = true, fe2.ensureState("emphasis").style = P2.getModel(["emphasis", "handleStyle"]).getItemStyle(), uU(fe2);
        var me2 = P2.get("handleColor");
        me2 != null && (fe2.style.fill = me2), M2.add(v4[zt] = fe2);
        var be2 = P2.getModel("textStyle");
        t2.add(_[zt] = new op({ silent: true, invisible: true, style: By(be2, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: be2.getTextColor(), font: be2.getFont() }), z2: 10 }));
      }, this);
      var et = $;
      if (H2) {
        var at = cs(P2.get("moveHandleSize"), I2[1]), ht = h.moveHandle = new Sh2({ style: P2.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: I2[1] - 0.5, height: at } }), bt = at * 0.8, _t = h.moveHandleIcon = wm(P2.get("moveHandleIcon"), -bt / 2, -bt / 2, bt, bt, "#fff", true);
        _t.silent = true, _t.y = I2[1] + at / 2 - 0.5, ht.ensureState("emphasis").style = P2.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
        var Et = Math.min(I2[1] / 2, Math.max(at, 10));
        et = h.moveZone = new Sh2({ invisible: true, shape: { y: I2[1] - Et, height: at + Et } }), et.on("mouseover", function() {
          N3.enterEmphasis(ht);
        }).on("mouseout", function() {
          N3.leaveEmphasis(ht);
        }), M2.add(ht), M2.add(_t), M2.add(et);
      }
      et.attr({ draggable: true, cursor: zVe(this._orient), drift: ks(this._onDragMove, this, "all"), ondragstart: ks(this._showDataInfo, this, true), ondragend: ks(this._onDragEnd, this), onmouseover: ks(this._showDataInfo, this, true), onmouseout: ks(this._showDataInfo, this, false) });
    }, i.prototype._resetInterval = function() {
      var t2 = this._range = this.dataZoomModel.getPercentRange(), h = this._getViewExtent();
      this._handleEnds = [cd2(t2[0], [0, 100], h, true), cd2(t2[1], [0, 100], h, true)];
    }, i.prototype._updateInterval = function(t2, h) {
      var v4 = this.dataZoomModel, _ = this._handleEnds, M2 = this._getViewExtent(), I2 = v4.findRepresentativeAxisProxy().getMinMaxSpan(), P2 = [0, 100];
      AU(h, _, M2, v4.get("zoomLock") ? "all" : t2, I2.minSpan != null ? cd2(I2.minSpan, P2, M2, true) : null, I2.maxSpan != null ? cd2(I2.maxSpan, P2, M2, true) : null);
      var N3 = this._range, z3 = this._range = QD([cd2(_[0], M2, P2, true), cd2(_[1], M2, P2, true)]);
      return !N3 || N3[0] !== z3[0] || N3[1] !== z3[1];
    }, i.prototype._updateView = function(t2) {
      var h = this._displayables, v4 = this._handleEnds, _ = QD(v4.slice()), M2 = this._size;
      Qe2([0, 1], function(et) {
        var at = h.handles[et], ht = this._handleHeight;
        at.attr({ scaleX: ht / 2, scaleY: ht / 2, x: v4[et] + (et ? -1 : 1), y: M2[1] / 2 - ht / 2 });
      }, this), h.filler.setShape({ x: _[0], y: 0, width: _[1] - _[0], height: M2[1] });
      var I2 = { x: _[0], width: _[1] - _[0] };
      h.moveHandle && (h.moveHandle.setShape(I2), h.moveZone.setShape(I2), h.moveZone.getBoundingRect(), h.moveHandleIcon && h.moveHandleIcon.attr("x", I2.x + I2.width / 2));
      for (var P2 = h.dataShadowSegs, N3 = [0, _[0], _[1], M2[0]], z3 = 0; z3 < P2.length; z3++) {
        var H2 = P2[z3], $ = H2.getClipPath();
        $ || ($ = new Sh2(), H2.setClipPath($)), $.setShape({ x: N3[z3], y: 0, width: N3[z3 + 1] - N3[z3], height: M2[1] });
      }
      this._updateDataInfo(t2);
    }, i.prototype._updateDataInfo = function(t2) {
      var h = this.dataZoomModel, v4 = this._displayables, _ = v4.handleLabels, M2 = this._orient, I2 = ["", ""];
      if (h.get("showDetail")) {
        var P2 = h.findRepresentativeAxisProxy();
        if (P2) {
          var N3 = P2.getAxisModel().axis, z3 = this._range, H2 = t2 ? P2.calculateDataWindow({ start: z3[0], end: z3[1] }).valueWindow : P2.getDataValueWindow();
          I2 = [this._formatLabel(H2[0], N3), this._formatLabel(H2[1], N3)];
        }
      }
      var $ = QD(this._handleEnds.slice());
      et.call(this, 0), et.call(this, 1);
      function et(at) {
        var ht = cU(v4.handles[at].parent, this.group), bt = _kt(at === 0 ? "right" : "left", ht), _t = this._handleWidth / 2 + cDr, Et = C5([$[at] + (at === 0 ? -_t : _t), this._size[1] / 2], ht);
        _[at].setStyle({ x: Et[0], y: Et[1], verticalAlign: M2 === cdt ? "middle" : bt, align: M2 === cdt ? bt : "center", text: I2[at] });
      }
    }, i.prototype._formatLabel = function(t2, h) {
      var v4 = this.dataZoomModel, _ = v4.get("labelFormatter"), M2 = v4.get("labelPrecision");
      (M2 == null || M2 === "auto") && (M2 = h.getPixelPrecision());
      var I2 = t2 == null || isNaN(t2) ? "" : h.type === "category" || h.type === "time" ? h.scale.getLabel({ value: Math.round(t2) }) : t2.toFixed(Math.min(M2, 20));
      return Ol(_) ? _(t2, I2) : ms(_) ? _.replace("{value}", I2) : I2;
    }, i.prototype._showDataInfo = function(t2) {
      t2 = this._dragging || t2;
      var h = this._displayables, v4 = h.handleLabels;
      v4[0].attr("invisible", !t2), v4[1].attr("invisible", !t2), h.moveHandle && this.api[t2 ? "enterEmphasis" : "leaveEmphasis"](h.moveHandle, 1);
    }, i.prototype._onDragMove = function(t2, h, v4, _) {
      this._dragging = true, J6(_.event);
      var M2 = this._displayables.sliderGroup.getLocalTransform(), I2 = C5([h, v4], M2, true), P2 = this._updateInterval(t2, I2[0]), N3 = this.dataZoomModel.get("realtime");
      this._updateView(!N3), P2 && N3 && this._dispatchZoomAction(true);
    }, i.prototype._onDragEnd = function() {
      this._dragging = false, this._showDataInfo(false);
      var t2 = this.dataZoomModel.get("realtime");
      !t2 && this._dispatchZoomAction(false);
    }, i.prototype._onClickPanel = function(t2) {
      var h = this._size, v4 = this._displayables.sliderGroup.transformCoordToLocal(t2.offsetX, t2.offsetY);
      if (!(v4[0] < 0 || v4[0] > h[0] || v4[1] < 0 || v4[1] > h[1])) {
        var _ = this._handleEnds, M2 = (_[0] + _[1]) / 2, I2 = this._updateInterval("all", v4[0] - M2);
        this._updateView(), I2 && this._dispatchZoomAction(false);
      }
    }, i.prototype._onBrushStart = function(t2) {
      var h = t2.offsetX, v4 = t2.offsetY;
      this._brushStart = new ac2(h, v4), this._brushing = true, this._brushStartTime = +new Date();
    }, i.prototype._onBrushEnd = function(t2) {
      if (!!this._brushing) {
        var h = this._displayables.brushRect;
        if (this._brushing = false, !!h) {
          h.attr("ignore", true);
          var v4 = h.shape, _ = +new Date();
          if (!(_ - this._brushStartTime < 200 && Math.abs(v4.width) < 5)) {
            var M2 = this._getViewExtent(), I2 = [0, 100];
            this._range = QD([cd2(v4.x, M2, I2, true), cd2(v4.x + v4.width, M2, I2, true)]), this._handleEnds = [v4.x, v4.x + v4.width], this._updateView(), this._dispatchZoomAction(false);
          }
        }
      }
    }, i.prototype._onBrush = function(t2) {
      this._brushing && (J6(t2.event), this._updateBrushRect(t2.offsetX, t2.offsetY));
    }, i.prototype._updateBrushRect = function(t2, h) {
      var v4 = this._displayables, _ = this.dataZoomModel, M2 = v4.brushRect;
      M2 || (M2 = v4.brushRect = new udt({ silent: true, style: _.getModel("brushStyle").getItemStyle() }), v4.sliderGroup.add(M2)), M2.attr("ignore", false);
      var I2 = this._brushStart, P2 = this._displayables.sliderGroup, N3 = P2.transformCoordToLocal(t2, h), z3 = P2.transformCoordToLocal(I2.x, I2.y), H2 = this._size;
      N3[0] = Math.max(Math.min(H2[0], N3[0]), 0), M2.setShape({ x: z3[0], y: 0, width: N3[0] - z3[0], height: H2[1] });
    }, i.prototype._dispatchZoomAction = function(t2) {
      var h = this._range;
      this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: t2 ? hDr : null, start: h[0], end: h[1] });
    }, i.prototype._findCoordRect = function() {
      var t2, h = bqe(this.dataZoomModel).infoList;
      if (!t2 && h.length) {
        var v4 = h[0].model.coordinateSystem;
        t2 = v4.getRect && v4.getRect();
      }
      if (!t2) {
        var _ = this.api.getWidth(), M2 = this.api.getHeight();
        t2 = { x: _ * 0.2, y: M2 * 0.2, width: _ * 0.6, height: M2 * 0.6 };
      }
      return t2;
    }, i.type = "dataZoom.slider", i;
  }(ure);
  function dDr(f2) {
    var i = { x: "y", y: "x", radius: "angle", angle: "radius" };
    return i[f2];
  }
  function zVe(f2) {
    return f2 === "vertical" ? "ns-resize" : "ew-resize";
  }
  var gDr = pDr;
  function zqe(f2) {
    f2.registerComponentModel(sDr), f2.registerComponentView(gDr), cre(f2);
  }
  function vDr(f2) {
    zc2(Bqe), zc2(zqe);
  }
  var yDr = { get: function(f2, i, t2) {
    var h = pu((mDr[f2] || {})[i]);
    return t2 && Za2(h) ? h[h.length - 1] : h;
  } }, mDr = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, jqe = yDr, jVe = Gx.mapVisual, bDr = Gx.eachVisual, _Dr = Za2, WVe = Qe2, xDr = QD, wDr = cd2, SDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.stateList = ["inRange", "outOfRange"], t2.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], t2.layoutMode = { type: "box", ignoreSize: true }, t2.dataBound = [-1 / 0, 1 / 0], t2.targetVisuals = {}, t2.controllerVisuals = {}, t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      this.mergeDefaultAndTheme(t2, v4);
    }, i.prototype.optionUpdated = function(t2, h) {
      var v4 = this.option;
      !h && Dqe(v4, t2, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
    }, i.prototype.resetVisual = function(t2) {
      var h = this.stateList;
      t2 = ks(t2, this), this.controllerVisuals = Wte(this.option.controller, h, t2), this.targetVisuals = Wte(this.option.target, h, t2);
    }, i.prototype.getItemSymbol = function() {
      return null;
    }, i.prototype.getTargetSeriesIndices = function() {
      var t2 = this.option.seriesIndex, h = [];
      return t2 == null || t2 === "all" ? this.ecModel.eachSeries(function(v4, _) {
        h.push(_);
      }) : h = Od2(t2), h;
    }, i.prototype.eachTargetSeries = function(t2, h) {
      Qe2(this.getTargetSeriesIndices(), function(v4) {
        var _ = this.ecModel.getSeriesByIndex(v4);
        _ && t2.call(h, _);
      }, this);
    }, i.prototype.isTargetSeries = function(t2) {
      var h = false;
      return this.eachTargetSeries(function(v4) {
        v4 === t2 && (h = true);
      }), h;
    }, i.prototype.formatValueText = function(t2, h, v4) {
      var _ = this.option, M2 = _.precision, I2 = this.dataBound, P2 = _.formatter, N3;
      v4 = v4 || ["<", ">"], Za2(t2) && (t2 = t2.slice(), N3 = true);
      var z3 = h ? t2 : N3 ? [H2(t2[0]), H2(t2[1])] : H2(t2);
      if (ms(P2))
        return P2.replace("{value}", N3 ? z3[0] : z3).replace("{value2}", N3 ? z3[1] : z3);
      if (Ol(P2))
        return N3 ? P2(t2[0], t2[1]) : P2(t2);
      if (N3)
        return t2[0] === I2[0] ? v4[0] + " " + z3[1] : t2[1] === I2[1] ? v4[1] + " " + z3[0] : z3[0] + " - " + z3[1];
      return z3;
      function H2($) {
        return $ === I2[0] ? "min" : $ === I2[1] ? "max" : (+$).toFixed(Math.min(M2, 20));
      }
    }, i.prototype.resetExtent = function() {
      var t2 = this.option, h = xDr([t2.min, t2.max]);
      this._dataExtent = h;
    }, i.prototype.getDataDimensionIndex = function(t2) {
      var h = this.option.dimension;
      if (h != null)
        return t2.getDimensionIndex(h);
      for (var v4 = t2.dimensions, _ = v4.length - 1; _ >= 0; _--) {
        var M2 = v4[_], I2 = t2.getDimensionInfo(M2);
        if (!I2.isCalculationCoord)
          return I2.storeDimIndex;
      }
    }, i.prototype.getExtent = function() {
      return this._dataExtent.slice();
    }, i.prototype.completeVisualOption = function() {
      var t2 = this.ecModel, h = this.option, v4 = { inRange: h.inRange, outOfRange: h.outOfRange }, _ = h.target || (h.target = {}), M2 = h.controller || (h.controller = {});
      cc2(_, v4), cc2(M2, v4);
      var I2 = this.isCategory();
      P2.call(this, _), P2.call(this, M2), N3.call(this, _, "inRange", "outOfRange"), z3.call(this, M2);
      function P2(H2) {
        _Dr(h.color) && !H2.inRange && (H2.inRange = { color: h.color.slice().reverse() }), H2.inRange = H2.inRange || { color: t2.get("gradientColor") };
      }
      function N3(H2, $, et) {
        var at = H2[$], ht = H2[et];
        at && !ht && (ht = H2[et] = {}, WVe(at, function(bt, _t) {
          if (!!Gx.isValidType(_t)) {
            var Et = jqe.get(_t, "inactive", I2);
            Et != null && (ht[_t] = Et, _t === "color" && !ht.hasOwnProperty("opacity") && !ht.hasOwnProperty("colorAlpha") && (ht.opacity = [0, 0]));
          }
        }));
      }
      function z3(H2) {
        var $ = (H2.inRange || {}).symbol || (H2.outOfRange || {}).symbol, et = (H2.inRange || {}).symbolSize || (H2.outOfRange || {}).symbolSize, at = this.get("inactiveColor"), ht = this.getItemSymbol(), bt = ht || "roundRect";
        WVe(this.stateList, function(_t) {
          var Et = this.itemSize, zt = H2[_t];
          zt || (zt = H2[_t] = { color: I2 ? at : [at] }), zt.symbol == null && (zt.symbol = $ && pu($) || (I2 ? bt : [bt])), zt.symbolSize == null && (zt.symbolSize = et && pu(et) || (I2 ? Et[0] : [Et[0], Et[0]])), zt.symbol = jVe(zt.symbol, function(re2) {
            return re2 === "none" ? bt : re2;
          });
          var Ft = zt.symbolSize;
          if (Ft != null) {
            var fe2 = -1 / 0;
            bDr(Ft, function(re2) {
              re2 > fe2 && (fe2 = re2);
            }), zt.symbolSize = jVe(Ft, function(re2) {
              return wDr(re2, [0, fe2], [0, Et[0]], true);
            });
          }
        }, this);
      }
    }, i.prototype.resetItemSize = function() {
      this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
    }, i.prototype.isCategory = function() {
      return !!this.option.categories;
    }, i.prototype.setSelected = function(t2) {
    }, i.prototype.getSelected = function() {
      return null;
    }, i.prototype.getValueState = function(t2) {
      return null;
    }, i.prototype.getVisualMeta = function(t2) {
      return null;
    }, i.type = "visualMap", i.dependencies = ["series"], i.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, i;
  }(zh2), KEt = SDr, GVe = [20, 140], MDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.optionUpdated = function(t2, h) {
      f2.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(v4) {
        v4.mappingMethod = "linear", v4.dataExtent = this.getExtent();
      }), this._resetRange();
    }, i.prototype.resetItemSize = function() {
      f2.prototype.resetItemSize.apply(this, arguments);
      var t2 = this.itemSize;
      (t2[0] == null || isNaN(t2[0])) && (t2[0] = GVe[0]), (t2[1] == null || isNaN(t2[1])) && (t2[1] = GVe[1]);
    }, i.prototype._resetRange = function() {
      var t2 = this.getExtent(), h = this.option.range;
      !h || h.auto ? (t2.auto = 1, this.option.range = t2) : Za2(h) && (h[0] > h[1] && h.reverse(), h[0] = Math.max(h[0], t2[0]), h[1] = Math.min(h[1], t2[1]));
    }, i.prototype.completeVisualOption = function() {
      f2.prototype.completeVisualOption.apply(this, arguments), Qe2(this.stateList, function(t2) {
        var h = this.option.controller[t2].symbolSize;
        h && h[0] !== h[1] && (h[0] = h[1] / 3);
      }, this);
    }, i.prototype.setSelected = function(t2) {
      this.option.range = t2.slice(), this._resetRange();
    }, i.prototype.getSelected = function() {
      var t2 = this.getExtent(), h = QD((this.get("range") || []).slice());
      return h[0] > t2[1] && (h[0] = t2[1]), h[1] > t2[1] && (h[1] = t2[1]), h[0] < t2[0] && (h[0] = t2[0]), h[1] < t2[0] && (h[1] = t2[0]), h;
    }, i.prototype.getValueState = function(t2) {
      var h = this.option.range, v4 = this.getExtent();
      return (h[0] <= v4[0] || h[0] <= t2) && (h[1] >= v4[1] || t2 <= h[1]) ? "inRange" : "outOfRange";
    }, i.prototype.findTargetDataIndices = function(t2) {
      var h = [];
      return this.eachTargetSeries(function(v4) {
        var _ = [], M2 = v4.getData();
        M2.each(this.getDataDimensionIndex(M2), function(I2, P2) {
          t2[0] <= I2 && I2 <= t2[1] && _.push(P2);
        }, this), h.push({ seriesId: v4.id, dataIndex: _ });
      }, this), h;
    }, i.prototype.getVisualMeta = function(t2) {
      var h = HVe(this, "outOfRange", this.getExtent()), v4 = HVe(this, "inRange", this.option.range.slice()), _ = [];
      function M2(et, at) {
        _.push({ value: et, color: t2(et, at) });
      }
      for (var I2 = 0, P2 = 0, N3 = v4.length, z3 = h.length; P2 < z3 && (!v4.length || h[P2] <= v4[0]); P2++)
        h[P2] < v4[I2] && M2(h[P2], "outOfRange");
      for (var H2 = 1; I2 < N3; I2++, H2 = 0)
        H2 && _.length && M2(v4[I2], "outOfRange"), M2(v4[I2], "inRange");
      for (var H2 = 1; P2 < z3; P2++)
        (!v4.length || v4[v4.length - 1] < h[P2]) && (H2 && (_.length && M2(_[_.length - 1].value, "outOfRange"), H2 = 0), M2(h[P2], "outOfRange"));
      var $ = _.length;
      return { stops: _, outerColors: [$ ? _[0].color : "transparent", $ ? _[$ - 1].color : "transparent"] };
    }, i.type = "visualMap.continuous", i.defaultOption = sV(KEt.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), i;
  }(KEt);
  function HVe(f2, i, t2) {
    if (t2[0] === t2[1])
      return t2.slice();
    for (var h = 200, v4 = (t2[1] - t2[0]) / h, _ = t2[0], M2 = [], I2 = 0; I2 <= h && _ < t2[1]; I2++)
      M2.push(_), _ += v4;
    return M2.push(t2[1]), M2;
  }
  var CDr = MDr, TDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, t2;
    }
    return i.prototype.init = function(t2, h) {
      this.ecModel = t2, this.api = h;
    }, i.prototype.render = function(t2, h, v4, _) {
      if (this.visualMapModel = t2, t2.get("show") === false) {
        this.group.removeAll();
        return;
      }
      this.doRender(t2, h, v4, _);
    }, i.prototype.renderBackground = function(t2) {
      var h = this.visualMapModel, v4 = iet(h.get("padding") || 0), _ = t2.getBoundingRect();
      t2.add(new Sh2({ z2: -1, silent: true, shape: { x: _.x - v4[3], y: _.y - v4[0], width: _.width + v4[3] + v4[1], height: _.height + v4[0] + v4[2] }, style: { fill: h.get("backgroundColor"), stroke: h.get("borderColor"), lineWidth: h.get("borderWidth") } }));
    }, i.prototype.getControllerVisual = function(t2, h, v4) {
      v4 = v4 || {};
      var _ = v4.forceState, M2 = this.visualMapModel, I2 = {};
      if (h === "color") {
        var P2 = M2.get("contentColor");
        I2.color = P2;
      }
      function N3(et) {
        return I2[et];
      }
      function z3(et, at) {
        I2[et] = at;
      }
      var H2 = M2.controllerVisuals[_ || M2.getValueState(t2)], $ = Gx.prepareVisualTypes(H2);
      return Qe2($, function(et) {
        var at = H2[et];
        v4.convertOpacityToAlpha && et === "opacity" && (et = "colorAlpha", at = H2.__alphaForOpacity), Gx.dependsOn(et, h) && at && at.applyVisual(t2, N3, z3);
      }), I2[h];
    }, i.prototype.positionGroup = function(t2) {
      var h = this.visualMapModel, v4 = this.api;
      Akt(t2, h.getBoxLayoutParams(), { width: v4.getWidth(), height: v4.getHeight() });
    }, i.prototype.doRender = function(t2, h, v4, _) {
    }, i.type = "visualMap", i;
  }(W0), Wqe = TDr, UVe = [["left", "right", "width"], ["top", "bottom", "height"]];
  function Gqe(f2, i, t2) {
    var h = f2.option, v4 = h.align;
    if (v4 != null && v4 !== "auto")
      return v4;
    for (var _ = { width: i.getWidth(), height: i.getHeight() }, M2 = h.orient === "horizontal" ? 1 : 0, I2 = UVe[M2], P2 = [0, null, 10], N3 = {}, z3 = 0; z3 < 3; z3++)
      N3[UVe[1 - M2][z3]] = P2[z3], N3[I2[z3]] = z3 === 2 ? t2[0] : h[I2[z3]];
    var H2 = [["x", "width", 3], ["y", "height", 0]][M2], $ = u1(N3, _, h.padding);
    return I2[($.margin[H2[2]] || 0) + $[H2[0]] + $[H2[1]] * 0.5 < _[H2[1]] * 0.5 ? 0 : 1];
  }
  function rEt(f2, i) {
    return Qe2(f2 || [], function(t2) {
      t2.dataIndex != null && (t2.dataIndexInside = t2.dataIndex, t2.dataIndex = null), t2.highlightKey = "visualMap" + (i ? i.componentIndex : "");
    }), f2;
  }
  var IL = cd2, ADr = Qe2, qVe = Math.min, KQt = Math.max, IDr = 12, DDr = 6, EDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._shapes = {}, t2._dataInterval = [], t2._handleEnds = [], t2._hoverLinkDataIndices = [], t2;
    }
    return i.prototype.doRender = function(t2, h, v4, _) {
      this._api = v4, (!_ || _.type !== "selectDataRange" || _.from !== this.uid) && this._buildView();
    }, i.prototype._buildView = function() {
      this.group.removeAll();
      var t2 = this.visualMapModel, h = this.group;
      this._orient = t2.get("orient"), this._useHandle = t2.get("calculable"), this._resetInterval(), this._renderBar(h);
      var v4 = t2.get("text");
      this._renderEndsText(h, v4, 0), this._renderEndsText(h, v4, 1), this._updateView(true), this.renderBackground(h), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(h);
    }, i.prototype._renderEndsText = function(t2, h, v4) {
      if (!!h) {
        var _ = h[1 - v4];
        _ = _ != null ? _ + "" : "";
        var M2 = this.visualMapModel, I2 = M2.get("textGap"), P2 = M2.itemSize, N3 = this._shapes.mainGroup, z3 = this._applyTransform([P2[0] / 2, v4 === 0 ? -I2 : P2[1] + I2], N3), H2 = this._applyTransform(v4 === 0 ? "bottom" : "top", N3), $ = this._orient, et = this.visualMapModel.textStyleModel;
        this.group.add(new op({ style: { x: z3[0], y: z3[1], verticalAlign: $ === "horizontal" ? "middle" : H2, align: $ === "horizontal" ? H2 : "center", text: _, font: et.getFont(), fill: et.getTextColor() } }));
      }
    }, i.prototype._renderBar = function(t2) {
      var h = this.visualMapModel, v4 = this._shapes, _ = h.itemSize, M2 = this._orient, I2 = this._useHandle, P2 = Gqe(h, this.api, _), N3 = v4.mainGroup = this._createBarGroup(P2), z3 = new mu();
      N3.add(z3), z3.add(v4.outOfRange = ZVe()), z3.add(v4.inRange = ZVe(null, I2 ? YVe(this._orient) : null, ks(this._dragHandle, this, "all", false), ks(this._dragHandle, this, "all", true))), z3.setClipPath(new Sh2({ shape: { x: 0, y: 0, width: _[0], height: _[1], r: 3 } }));
      var H2 = h.textStyleModel.getTextRect("\u56FD"), $ = KQt(H2.width, H2.height);
      I2 && (v4.handleThumbs = [], v4.handleLabels = [], v4.handleLabelPoints = [], this._createHandle(h, N3, 0, _, $, M2), this._createHandle(h, N3, 1, _, $, M2)), this._createIndicator(h, N3, _, $, M2), t2.add(N3);
    }, i.prototype._createHandle = function(t2, h, v4, _, M2, I2) {
      var P2 = ks(this._dragHandle, this, v4, false), N3 = ks(this._dragHandle, this, v4, true), z3 = T5(t2.get("handleSize"), _[0]), H2 = wm(t2.get("handleIcon"), -z3 / 2, -z3 / 2, z3, z3, null, true), $ = YVe(this._orient);
      H2.attr({ cursor: $, draggable: true, drift: P2, ondragend: N3, onmousemove: function(_t) {
        J6(_t.event);
      } }), H2.x = _[0] / 2, H2.useStyle(t2.getModel("handleStyle").getItemStyle()), H2.setStyle({ strokeNoScale: true, strokeFirst: true }), H2.style.lineWidth *= 2, H2.ensureState("emphasis").style = t2.getModel(["emphasis", "handleStyle"]).getItemStyle(), nU(H2, true), h.add(H2);
      var et = this.visualMapModel.textStyleModel, at = new op({ cursor: $, draggable: true, drift: P2, onmousemove: function(_t) {
        J6(_t.event);
      }, ondragend: N3, style: { x: 0, y: 0, text: "", font: et.getFont(), fill: et.getTextColor() } });
      at.ensureState("blur").style = { opacity: 0.1 }, at.stateTransition = { duration: 200 }, this.group.add(at);
      var ht = [z3, 0], bt = this._shapes;
      bt.handleThumbs[v4] = H2, bt.handleLabelPoints[v4] = ht, bt.handleLabels[v4] = at;
    }, i.prototype._createIndicator = function(t2, h, v4, _, M2) {
      var I2 = T5(t2.get("indicatorSize"), v4[0]), P2 = wm(t2.get("indicatorIcon"), -I2 / 2, -I2 / 2, I2, I2, null, true);
      P2.attr({ cursor: "move", invisible: true, silent: true, x: v4[0] / 2 });
      var N3 = t2.getModel("indicatorStyle").getItemStyle();
      if (P2 instanceof Ux) {
        var z3 = P2.style;
        P2.useStyle(ba2({ image: z3.image, x: z3.x, y: z3.y, width: z3.width, height: z3.height }, N3));
      } else
        P2.useStyle(N3);
      h.add(P2);
      var H2 = this.visualMapModel.textStyleModel, $ = new op({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: H2.getFont(), fill: H2.getTextColor() } });
      this.group.add($);
      var et = [(M2 === "horizontal" ? _ / 2 : DDr) + v4[0] / 2, 0], at = this._shapes;
      at.indicator = P2, at.indicatorLabel = $, at.indicatorLabelPoint = et, this._firstShowIndicator = true;
    }, i.prototype._dragHandle = function(t2, h, v4, _) {
      if (!!this._useHandle) {
        if (this._dragging = !h, !h) {
          var M2 = this._applyTransform([v4, _], this._shapes.mainGroup, true);
          this._updateInterval(t2, M2[1]), this._hideIndicator(), this._updateView();
        }
        h === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), h ? !this._hovering && this._clearHoverLinkToSeries() : $Ve(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[t2], false);
      }
    }, i.prototype._resetInterval = function() {
      var t2 = this.visualMapModel, h = this._dataInterval = t2.getSelected(), v4 = t2.getExtent(), _ = [0, t2.itemSize[1]];
      this._handleEnds = [IL(h[0], v4, _, true), IL(h[1], v4, _, true)];
    }, i.prototype._updateInterval = function(t2, h) {
      h = h || 0;
      var v4 = this.visualMapModel, _ = this._handleEnds, M2 = [0, v4.itemSize[1]];
      AU(h, _, M2, t2, 0);
      var I2 = v4.getExtent();
      this._dataInterval = [IL(_[0], M2, I2, true), IL(_[1], M2, I2, true)];
    }, i.prototype._updateView = function(t2) {
      var h = this.visualMapModel, v4 = h.getExtent(), _ = this._shapes, M2 = [0, h.itemSize[1]], I2 = t2 ? M2 : this._handleEnds, P2 = this._createBarVisual(this._dataInterval, v4, I2, "inRange"), N3 = this._createBarVisual(v4, v4, M2, "outOfRange");
      _.inRange.setStyle({ fill: P2.barColor }).setShape("points", P2.barPoints), _.outOfRange.setStyle({ fill: N3.barColor }).setShape("points", N3.barPoints), this._updateHandle(I2, P2);
    }, i.prototype._createBarVisual = function(t2, h, v4, _) {
      var M2 = { forceState: _, convertOpacityToAlpha: true }, I2 = this._makeColorGradient(t2, M2), P2 = [this.getControllerVisual(t2[0], "symbolSize", M2), this.getControllerVisual(t2[1], "symbolSize", M2)], N3 = this._createBarPoints(v4, P2);
      return { barColor: new Igt(0, 0, 0, 1, I2), barPoints: N3, handlesColor: [I2[0].color, I2[I2.length - 1].color] };
    }, i.prototype._makeColorGradient = function(t2, h) {
      var v4 = 100, _ = [], M2 = (t2[1] - t2[0]) / v4;
      _.push({ color: this.getControllerVisual(t2[0], "color", h), offset: 0 });
      for (var I2 = 1; I2 < v4; I2++) {
        var P2 = t2[0] + M2 * I2;
        if (P2 > t2[1])
          break;
        _.push({ color: this.getControllerVisual(P2, "color", h), offset: I2 / v4 });
      }
      return _.push({ color: this.getControllerVisual(t2[1], "color", h), offset: 1 }), _;
    }, i.prototype._createBarPoints = function(t2, h) {
      var v4 = this.visualMapModel.itemSize;
      return [[v4[0] - h[0], t2[0]], [v4[0], t2[0]], [v4[0], t2[1]], [v4[0] - h[1], t2[1]]];
    }, i.prototype._createBarGroup = function(t2) {
      var h = this._orient, v4 = this.visualMapModel.get("inverse");
      return new mu(h === "horizontal" && !v4 ? { scaleX: t2 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : h === "horizontal" && v4 ? { scaleX: t2 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : h === "vertical" && !v4 ? { scaleX: t2 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: t2 === "left" ? 1 : -1 });
    }, i.prototype._updateHandle = function(t2, h) {
      if (!!this._useHandle) {
        var v4 = this._shapes, _ = this.visualMapModel, M2 = v4.handleThumbs, I2 = v4.handleLabels, P2 = _.itemSize, N3 = _.getExtent();
        ADr([0, 1], function(z3) {
          var H2 = M2[z3];
          H2.setStyle("fill", h.handlesColor[z3]), H2.y = t2[z3];
          var $ = IL(t2[z3], [0, P2[1]], N3, true), et = this.getControllerVisual($, "symbolSize");
          H2.scaleX = H2.scaleY = et / P2[0], H2.x = P2[0] - et / 2;
          var at = C5(v4.handleLabelPoints[z3], cU(H2, this.group));
          I2[z3].setStyle({ x: at[0], y: at[1], text: _.formatValueText(this._dataInterval[z3]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", v4.mainGroup) : "center" });
        }, this);
      }
    }, i.prototype._showIndicator = function(t2, h, v4, _) {
      var M2 = this.visualMapModel, I2 = M2.getExtent(), P2 = M2.itemSize, N3 = [0, P2[1]], z3 = this._shapes, H2 = z3.indicator;
      if (!!H2) {
        H2.attr("invisible", false);
        var $ = { convertOpacityToAlpha: true }, et = this.getControllerVisual(t2, "color", $), at = this.getControllerVisual(t2, "symbolSize"), ht = IL(t2, I2, N3, true), bt = P2[0] - at / 2, _t = { x: H2.x, y: H2.y };
        H2.y = ht, H2.x = bt;
        var Et = C5(z3.indicatorLabelPoint, cU(H2, this.group)), zt = z3.indicatorLabel;
        zt.attr("invisible", false);
        var Ft = this._applyTransform("left", z3.mainGroup), fe2 = this._orient, re2 = fe2 === "horizontal";
        zt.setStyle({ text: (v4 || "") + M2.formatValueText(h), verticalAlign: re2 ? Ft : "middle", align: re2 ? "center" : Ft });
        var ye = { x: bt, y: ht, style: { fill: et } }, me2 = { style: { x: Et[0], y: Et[1] } };
        if (M2.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
          var be2 = { duration: 100, easing: "cubicInOut", additive: true };
          H2.x = _t.x, H2.y = _t.y, H2.animateTo(ye, be2), zt.animateTo(me2, be2);
        } else
          H2.attr(ye), zt.attr(me2);
        this._firstShowIndicator = false;
        var Te2 = this._shapes.handleLabels;
        if (Te2)
          for (var We = 0; We < Te2.length; We++)
            this._api.enterBlur(Te2[We]);
      }
    }, i.prototype._enableHoverLinkToSeries = function() {
      var t2 = this;
      this._shapes.mainGroup.on("mousemove", function(h) {
        if (t2._hovering = true, !t2._dragging) {
          var v4 = t2.visualMapModel.itemSize, _ = t2._applyTransform([h.offsetX, h.offsetY], t2._shapes.mainGroup, true, true);
          _[1] = qVe(KQt(0, _[1]), v4[1]), t2._doHoverLinkToSeries(_[1], 0 <= _[0] && _[0] <= v4[0]);
        }
      }).on("mouseout", function() {
        t2._hovering = false, !t2._dragging && t2._clearHoverLinkToSeries();
      });
    }, i.prototype._enableHoverLinkFromSeries = function() {
      var t2 = this.api.getZr();
      this.visualMapModel.option.hoverLink ? (t2.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), t2.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
    }, i.prototype._doHoverLinkToSeries = function(t2, h) {
      var v4 = this.visualMapModel, _ = v4.itemSize;
      if (!!v4.option.hoverLink) {
        var M2 = [0, _[1]], I2 = v4.getExtent();
        t2 = qVe(KQt(M2[0], t2), M2[1]);
        var P2 = kDr(v4, I2, M2), N3 = [t2 - P2, t2 + P2], z3 = IL(t2, M2, I2, true), H2 = [IL(N3[0], M2, I2, true), IL(N3[1], M2, I2, true)];
        N3[0] < M2[0] && (H2[0] = -1 / 0), N3[1] > M2[1] && (H2[1] = 1 / 0), h && (H2[0] === -1 / 0 ? this._showIndicator(z3, H2[1], "< ", P2) : H2[1] === 1 / 0 ? this._showIndicator(z3, H2[0], "> ", P2) : this._showIndicator(z3, z3, "\u2248 ", P2));
        var $ = this._hoverLinkDataIndices, et = [];
        (h || $Ve(v4)) && (et = this._hoverLinkDataIndices = v4.findTargetDataIndices(H2));
        var at = gcr($, et);
        this._dispatchHighDown("downplay", rEt(at[0], v4)), this._dispatchHighDown("highlight", rEt(at[1], v4));
      }
    }, i.prototype._hoverLinkFromSeriesMouseOver = function(t2) {
      var h = t2.target, v4 = this.visualMapModel;
      if (!(!h || Du(h).dataIndex == null)) {
        var _ = Du(h), M2 = this.ecModel.getSeriesByIndex(_.seriesIndex);
        if (!!v4.isTargetSeries(M2)) {
          var I2 = M2.getData(_.dataType), P2 = I2.getStore().get(v4.getDataDimensionIndex(I2), _.dataIndex);
          isNaN(P2) || this._showIndicator(P2, P2);
        }
      }
    }, i.prototype._hideIndicator = function() {
      var t2 = this._shapes;
      t2.indicator && t2.indicator.attr("invisible", true), t2.indicatorLabel && t2.indicatorLabel.attr("invisible", true);
      var h = this._shapes.handleLabels;
      if (h)
        for (var v4 = 0; v4 < h.length; v4++)
          this._api.leaveBlur(h[v4]);
    }, i.prototype._clearHoverLinkToSeries = function() {
      this._hideIndicator();
      var t2 = this._hoverLinkDataIndices;
      this._dispatchHighDown("downplay", rEt(t2, this.visualMapModel)), t2.length = 0;
    }, i.prototype._clearHoverLinkFromSeries = function() {
      this._hideIndicator();
      var t2 = this.api.getZr();
      t2.off("mouseover", this._hoverLinkFromSeriesMouseOver), t2.off("mouseout", this._hideIndicator);
    }, i.prototype._applyTransform = function(t2, h, v4, _) {
      var M2 = cU(h, _ ? null : this.group);
      return Za2(t2) ? C5(t2, M2, v4) : _kt(t2, M2, v4);
    }, i.prototype._dispatchHighDown = function(t2, h) {
      h && h.length && this.api.dispatchAction({ type: t2, batch: h });
    }, i.prototype.dispose = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, i.prototype.remove = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, i.type = "visualMap.continuous", i;
  }(Wqe);
  function ZVe(f2, i, t2, h) {
    return new iC({ shape: { points: f2 }, draggable: !!t2, cursor: i, drift: t2, onmousemove: function(v4) {
      J6(v4.event);
    }, ondragend: h });
  }
  function kDr(f2, i, t2) {
    var h = IDr / 2, v4 = f2.get("hoverLinkDataSize");
    return v4 && (h = IL(v4, i, t2, true) / 2), h;
  }
  function $Ve(f2) {
    var i = f2.get("hoverLinkOnHandle");
    return !!(i == null ? f2.get("realtime") : i);
  }
  function YVe(f2) {
    return f2 === "vertical" ? "ns-resize" : "ew-resize";
  }
  var PDr = EDr, LDr = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, ODr = function(f2, i) {
    i.eachComponent({ mainType: "visualMap", query: f2 }, function(t2) {
      t2.setSelected(f2.selected);
    });
  }, RDr = [{ createOnAllSeries: true, reset: function(f2, i) {
    var t2 = [];
    return i.eachComponent("visualMap", function(h) {
      var v4 = f2.pipelineContext;
      !h.isTargetSeries(f2) || v4 && v4.large || t2.push(DAr(h.stateList, h.targetVisuals, ks(h.getValueState, h), h.getDataDimensionIndex(f2.getData())));
    }), t2;
  } }, { createOnAllSeries: true, reset: function(f2, i) {
    var t2 = f2.getData(), h = [];
    i.eachComponent("visualMap", function(v4) {
      if (v4.isTargetSeries(f2)) {
        var _ = v4.getVisualMeta(ks(NDr, null, f2, v4)) || { stops: [], outerColors: [] }, M2 = v4.getDataDimensionIndex(t2);
        M2 >= 0 && (_.dimension = M2, h.push(_));
      }
    }), f2.getData().setVisual("visualMeta", h);
  } }];
  function NDr(f2, i, t2, h) {
    for (var v4 = i.targetVisuals[h], _ = Gx.prepareVisualTypes(v4), M2 = { color: Lgt(f2.getData(), "color") }, I2 = 0, P2 = _.length; I2 < P2; I2++) {
      var N3 = _[I2], z3 = v4[N3 === "opacity" ? "__alphaForOpacity" : N3];
      z3 && z3.applyVisual(t2, H2, $);
    }
    return M2.color;
    function H2(et) {
      return M2[et];
    }
    function $(et, at) {
      M2[et] = at;
    }
  }
  var KVe = Qe2;
  function FDr(f2) {
    var i = f2 && f2.visualMap;
    Za2(i) || (i = i ? [i] : []), KVe(i, function(t2) {
      if (!!t2) {
        vtt(t2, "splitList") && !vtt(t2, "pieces") && (t2.pieces = t2.splitList, delete t2.splitList);
        var h = t2.pieces;
        h && Za2(h) && KVe(h, function(v4) {
          Xl(v4) && (vtt(v4, "start") && !vtt(v4, "min") && (v4.min = v4.start), vtt(v4, "end") && !vtt(v4, "max") && (v4.max = v4.end));
        });
      }
    });
  }
  function vtt(f2, i) {
    return f2 && f2.hasOwnProperty && f2.hasOwnProperty(i);
  }
  var XVe = false;
  function Hqe(f2) {
    XVe || (XVe = true, f2.registerSubTypeDefaulter("visualMap", function(i) {
      return !i.categories && (!(i.pieces ? i.pieces.length > 0 : i.splitNumber > 0) || i.calculable) ? "continuous" : "piecewise";
    }), f2.registerAction(LDr, ODr), Qe2(RDr, function(i) {
      f2.registerVisual(f2.PRIORITY.VISUAL.COMPONENT, i);
    }), f2.registerPreprocessor(FDr));
  }
  function Uqe(f2) {
    f2.registerComponentModel(CDr), f2.registerComponentView(PDr), Hqe(f2);
  }
  var VDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2._pieceList = [], t2;
    }
    return i.prototype.optionUpdated = function(t2, h) {
      f2.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
      var v4 = this._mode = this._determineMode();
      this._pieceList = [], BDr[this._mode].call(this, this._pieceList), this._resetSelected(t2, h);
      var _ = this.option.categories;
      this.resetVisual(function(M2, I2) {
        v4 === "categories" ? (M2.mappingMethod = "category", M2.categories = pu(_)) : (M2.dataExtent = this.getExtent(), M2.mappingMethod = "piecewise", M2.pieceList = Xa2(this._pieceList, function(P2) {
          return P2 = pu(P2), I2 !== "inRange" && (P2.visual = null), P2;
        }));
      });
    }, i.prototype.completeVisualOption = function() {
      var t2 = this.option, h = {}, v4 = Gx.listVisualTypes(), _ = this.isCategory();
      Qe2(t2.pieces, function(I2) {
        Qe2(v4, function(P2) {
          I2.hasOwnProperty(P2) && (h[P2] = 1);
        });
      }), Qe2(h, function(I2, P2) {
        var N3 = false;
        Qe2(this.stateList, function(z3) {
          N3 = N3 || M2(t2, z3, P2) || M2(t2.target, z3, P2);
        }, this), !N3 && Qe2(this.stateList, function(z3) {
          (t2[z3] || (t2[z3] = {}))[P2] = jqe.get(P2, z3 === "inRange" ? "active" : "inactive", _);
        });
      }, this);
      function M2(I2, P2, N3) {
        return I2 && I2[P2] && I2[P2].hasOwnProperty(N3);
      }
      f2.prototype.completeVisualOption.apply(this, arguments);
    }, i.prototype._resetSelected = function(t2, h) {
      var v4 = this.option, _ = this._pieceList, M2 = (h ? v4 : t2).selected || {};
      if (v4.selected = M2, Qe2(_, function(P2, N3) {
        var z3 = this.getSelectedMapKey(P2);
        M2.hasOwnProperty(z3) || (M2[z3] = true);
      }, this), v4.selectedMode === "single") {
        var I2 = false;
        Qe2(_, function(P2, N3) {
          var z3 = this.getSelectedMapKey(P2);
          M2[z3] && (I2 ? M2[z3] = false : I2 = true);
        }, this);
      }
    }, i.prototype.getItemSymbol = function() {
      return this.get("itemSymbol");
    }, i.prototype.getSelectedMapKey = function(t2) {
      return this._mode === "categories" ? t2.value + "" : t2.index + "";
    }, i.prototype.getPieceList = function() {
      return this._pieceList;
    }, i.prototype._determineMode = function() {
      var t2 = this.option;
      return t2.pieces && t2.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
    }, i.prototype.setSelected = function(t2) {
      this.option.selected = pu(t2);
    }, i.prototype.getValueState = function(t2) {
      var h = Gx.findPieceIndex(t2, this._pieceList);
      return h != null && this.option.selected[this.getSelectedMapKey(this._pieceList[h])] ? "inRange" : "outOfRange";
    }, i.prototype.findTargetDataIndices = function(t2) {
      var h = [], v4 = this._pieceList;
      return this.eachTargetSeries(function(_) {
        var M2 = [], I2 = _.getData();
        I2.each(this.getDataDimensionIndex(I2), function(P2, N3) {
          var z3 = Gx.findPieceIndex(P2, v4);
          z3 === t2 && M2.push(N3);
        }, this), h.push({ seriesId: _.id, dataIndex: M2 });
      }, this), h;
    }, i.prototype.getRepresentValue = function(t2) {
      var h;
      if (this.isCategory())
        h = t2.value;
      else if (t2.value != null)
        h = t2.value;
      else {
        var v4 = t2.interval || [];
        h = v4[0] === -1 / 0 && v4[1] === 1 / 0 ? 0 : (v4[0] + v4[1]) / 2;
      }
      return h;
    }, i.prototype.getVisualMeta = function(t2) {
      if (this.isCategory())
        return;
      var h = [], v4 = ["", ""], _ = this;
      function M2(z3, H2) {
        var $ = _.getRepresentValue({ interval: z3 });
        H2 || (H2 = _.getValueState($));
        var et = t2($, H2);
        z3[0] === -1 / 0 ? v4[0] = et : z3[1] === 1 / 0 ? v4[1] = et : h.push({ value: z3[0], color: et }, { value: z3[1], color: et });
      }
      var I2 = this._pieceList.slice();
      if (!I2.length)
        I2.push({ interval: [-1 / 0, 1 / 0] });
      else {
        var P2 = I2[0].interval[0];
        P2 !== -1 / 0 && I2.unshift({ interval: [-1 / 0, P2] }), P2 = I2[I2.length - 1].interval[1], P2 !== 1 / 0 && I2.push({ interval: [P2, 1 / 0] });
      }
      var N3 = -1 / 0;
      return Qe2(I2, function(z3) {
        var H2 = z3.interval;
        H2 && (H2[0] > N3 && M2([N3, H2[0]], "outOfRange"), M2(H2.slice()), N3 = H2[1]);
      }, this), { stops: h, outerColors: v4 };
    }, i.type = "visualMap.piecewise", i.defaultOption = sV(KEt.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), i;
  }(KEt), BDr = { splitNumber: function(f2) {
    var i = this.option, t2 = Math.min(i.precision, 20), h = this.getExtent(), v4 = i.splitNumber;
    v4 = Math.max(parseInt(v4, 10), 1), i.splitNumber = v4;
    for (var _ = (h[1] - h[0]) / v4; +_.toFixed(t2) !== _ && t2 < 5; )
      t2++;
    i.precision = t2, _ = +_.toFixed(t2), i.minOpen && f2.push({ interval: [-1 / 0, h[0]], close: [0, 0] });
    for (var M2 = 0, I2 = h[0]; M2 < v4; I2 += _, M2++) {
      var P2 = M2 === v4 - 1 ? h[1] : I2 + _;
      f2.push({ interval: [I2, P2], close: [1, 1] });
    }
    i.maxOpen && f2.push({ interval: [h[1], 1 / 0], close: [0, 0] }), G6e(f2), Qe2(f2, function(N3, z3) {
      N3.index = z3, N3.text = this.formatValueText(N3.interval);
    }, this);
  }, categories: function(f2) {
    var i = this.option;
    Qe2(i.categories, function(t2) {
      f2.push({ text: this.formatValueText(t2, true), value: t2 });
    }, this), QVe(i, f2);
  }, pieces: function(f2) {
    var i = this.option;
    Qe2(i.pieces, function(t2, h) {
      Xl(t2) || (t2 = { value: t2 });
      var v4 = { text: "", index: h };
      if (t2.label != null && (v4.text = t2.label), t2.hasOwnProperty("value")) {
        var _ = v4.value = t2.value;
        v4.interval = [_, _], v4.close = [1, 1];
      } else {
        for (var M2 = v4.interval = [], I2 = v4.close = [0, 0], P2 = [1, 0, 1], N3 = [-1 / 0, 1 / 0], z3 = [], H2 = 0; H2 < 2; H2++) {
          for (var $ = [["gte", "gt", "min"], ["lte", "lt", "max"]][H2], et = 0; et < 3 && M2[H2] == null; et++)
            M2[H2] = t2[$[et]], I2[H2] = P2[et], z3[H2] = et === 2;
          M2[H2] == null && (M2[H2] = N3[H2]);
        }
        z3[0] && M2[1] === 1 / 0 && (I2[0] = 0), z3[1] && M2[0] === -1 / 0 && (I2[1] = 0), M2[0] === M2[1] && I2[0] && I2[1] && (v4.value = M2[0]);
      }
      v4.visual = Gx.retrieveVisuals(t2), f2.push(v4);
    }, this), QVe(i, f2), G6e(f2), Qe2(f2, function(t2) {
      var h = t2.close, v4 = [["<", "\u2264"][h[1]], [">", "\u2265"][h[0]]];
      t2.text = t2.text || this.formatValueText(t2.value != null ? t2.value : t2.interval, false, v4);
    }, this);
  } };
  function QVe(f2, i) {
    var t2 = f2.inverse;
    (f2.orient === "vertical" ? !t2 : t2) && i.reverse();
  }
  var zDr = VDr, jDr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = i.type, t2;
    }
    return i.prototype.doRender = function() {
      var t2 = this.group;
      t2.removeAll();
      var h = this.visualMapModel, v4 = h.get("textGap"), _ = h.textStyleModel, M2 = _.getFont(), I2 = _.getTextColor(), P2 = this._getItemAlign(), N3 = h.itemSize, z3 = this._getViewData(), H2 = z3.endsText, $ = y_(h.get("showLabel", true), !H2);
      H2 && this._renderEndsText(t2, H2[0], N3, $, P2), Qe2(z3.viewPieceList, function(et) {
        var at = et.piece, ht = new mu();
        ht.onclick = ks(this._onItemClick, this, at), this._enableHoverLink(ht, et.indexInModelPieceList);
        var bt = h.getRepresentValue(at);
        if (this._createItemSymbol(ht, bt, [0, 0, N3[0], N3[1]]), $) {
          var _t = this.visualMapModel.getValueState(bt);
          ht.add(new op({ style: { x: P2 === "right" ? -v4 : N3[0] + v4, y: N3[1] / 2, text: at.text, verticalAlign: "middle", align: P2, font: M2, fill: I2, opacity: _t === "outOfRange" ? 0.5 : 1 } }));
        }
        t2.add(ht);
      }, this), H2 && this._renderEndsText(t2, H2[1], N3, $, P2), fU(h.get("orient"), t2, h.get("itemGap")), this.renderBackground(t2), this.positionGroup(t2);
    }, i.prototype._enableHoverLink = function(t2, h) {
      var v4 = this;
      t2.on("mouseover", function() {
        return _("highlight");
      }).on("mouseout", function() {
        return _("downplay");
      });
      var _ = function(M2) {
        var I2 = v4.visualMapModel;
        I2.option.hoverLink && v4.api.dispatchAction({ type: M2, batch: rEt(I2.findTargetDataIndices(h), I2) });
      };
    }, i.prototype._getItemAlign = function() {
      var t2 = this.visualMapModel, h = t2.option;
      if (h.orient === "vertical")
        return Gqe(t2, this.api, t2.itemSize);
      var v4 = h.align;
      return (!v4 || v4 === "auto") && (v4 = "left"), v4;
    }, i.prototype._renderEndsText = function(t2, h, v4, _, M2) {
      if (!!h) {
        var I2 = new mu(), P2 = this.visualMapModel.textStyleModel;
        I2.add(new op({ style: { x: _ ? M2 === "right" ? v4[0] : 0 : v4[0] / 2, y: v4[1] / 2, verticalAlign: "middle", align: _ ? M2 : "center", text: h, font: P2.getFont(), fill: P2.getTextColor() } })), t2.add(I2);
      }
    }, i.prototype._getViewData = function() {
      var t2 = this.visualMapModel, h = Xa2(t2.getPieceList(), function(I2, P2) {
        return { piece: I2, indexInModelPieceList: P2 };
      }), v4 = t2.get("text"), _ = t2.get("orient"), M2 = t2.get("inverse");
      return (_ === "horizontal" ? M2 : !M2) ? h.reverse() : v4 && (v4 = v4.slice().reverse()), { viewPieceList: h, endsText: v4 };
    }, i.prototype._createItemSymbol = function(t2, h, v4) {
      t2.add(wm(this.getControllerVisual(h, "symbol"), v4[0], v4[1], v4[2], v4[3], this.getControllerVisual(h, "color")));
    }, i.prototype._onItemClick = function(t2) {
      var h = this.visualMapModel, v4 = h.option, _ = pu(v4.selected), M2 = h.getSelectedMapKey(t2);
      v4.selectedMode === "single" ? (_[M2] = true, Qe2(_, function(I2, P2) {
        _[P2] = P2 === M2;
      })) : _[M2] = !_[M2], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: _ });
    }, i.type = "visualMap.piecewise", i;
  }(Wqe), WDr = jDr;
  function qqe(f2) {
    f2.registerComponentModel(zDr), f2.registerComponentView(WDr), Hqe(f2);
  }
  function GDr(f2) {
    zc2(Uqe), zc2(qqe);
  }
  var HDr = { label: { enabled: true }, decal: { show: false } }, JVe = Wh2(), UDr = {};
  function qDr(f2, i) {
    var t2 = f2.getModel("aria");
    if (!t2.get("enabled"))
      return;
    var h = pu(HDr);
    cc2(h.label, f2.getLocaleModel().get("aria"), false), cc2(t2.option, h, false), v4(), _();
    function v4() {
      var N3 = t2.getModel("decal"), z3 = N3.get("show");
      if (z3) {
        var H2 = Il();
        f2.eachSeries(function($) {
          if (!$.isColorBySeries()) {
            var et = H2.get($.type);
            et || (et = {}, H2.set($.type, et)), JVe($).scope = et;
          }
        }), f2.eachRawSeries(function($) {
          if (f2.isSeriesFiltered($))
            return;
          if (Ol($.enableAriaDecal)) {
            $.enableAriaDecal();
            return;
          }
          var et = $.getData();
          if ($.isColorBySeries()) {
            var Et = KJt($.ecModel, $.name, UDr, f2.getSeriesCount()), zt = et.getVisual("decal");
            et.setVisual("decal", Ft(zt, Et));
          } else {
            var at = $.getRawData(), ht = {}, bt = JVe($).scope;
            et.each(function(fe2) {
              var re2 = et.getRawIndex(fe2);
              ht[re2] = fe2;
            });
            var _t = at.count();
            at.each(function(fe2) {
              var re2 = ht[fe2], ye = at.getName(fe2) || fe2 + "", me2 = KJt($.ecModel, ye, bt, _t), be2 = et.getItemVisual(re2, "decal");
              et.setItemVisual(re2, "decal", Ft(be2, me2));
            });
          }
          function Ft(fe2, re2) {
            var ye = fe2 ? ba2(ba2({}, re2), fe2) : re2;
            return ye.dirty = true, ye;
          }
        });
      }
    }
    function _() {
      var N3 = f2.getLocaleModel().get("aria"), z3 = t2.getModel("label");
      if (z3.option = Ul(z3.option, N3), !!z3.get("enabled")) {
        var H2 = i.getZr().dom;
        if (z3.get("description")) {
          H2.setAttribute("aria-label", z3.get("description"));
          return;
        }
        var $ = f2.getSeriesCount(), et = z3.get(["data", "maxCount"]) || 10, at = z3.get(["series", "maxCount"]) || 10, ht = Math.min($, at), bt;
        if (!($ < 1)) {
          var _t = I2();
          if (_t) {
            var Et = z3.get(["general", "withTitle"]);
            bt = M2(Et, { title: _t });
          } else
            bt = z3.get(["general", "withoutTitle"]);
          var zt = [], Ft = $ > 1 ? z3.get(["series", "multiple", "prefix"]) : z3.get(["series", "single", "prefix"]);
          bt += M2(Ft, { seriesCount: $ }), f2.eachSeries(function(me2, be2) {
            if (be2 < ht) {
              var Te2 = void 0, We = me2.get("name"), en = We ? "withName" : "withoutName";
              Te2 = $ > 1 ? z3.get(["series", "multiple", en]) : z3.get(["series", "single", en]), Te2 = M2(Te2, { seriesId: me2.seriesIndex, seriesName: me2.get("name"), seriesType: P2(me2.subType) });
              var Ue2 = me2.getData();
              if (Ue2.count() > et) {
                var Mn = z3.get(["data", "partialData"]);
                Te2 += M2(Mn, { displayCnt: et });
              } else
                Te2 += z3.get(["data", "allData"]);
              for (var Vn = z3.get(["data", "separator", "middle"]), xn = z3.get(["data", "separator", "end"]), Zr = [], nr = 0; nr < Ue2.count(); nr++)
                if (nr < et) {
                  var pr = Ue2.getName(nr), Nr = Ue2.getValues(nr), ai2 = z3.get(["data", pr ? "withName" : "withoutName"]);
                  Zr.push(M2(ai2, { name: pr, value: Nr.join(Vn) }));
                }
              Te2 += Zr.join(Vn) + xn, zt.push(Te2);
            }
          });
          var fe2 = z3.getModel(["series", "multiple", "separator"]), re2 = fe2.get("middle"), ye = fe2.get("end");
          bt += zt.join(re2) + ye, H2.setAttribute("aria-label", bt);
        }
      }
    }
    function M2(N3, z3) {
      if (!ms(N3))
        return N3;
      var H2 = N3;
      return Qe2(z3, function($, et) {
        H2 = H2.replace(new RegExp("\\{\\s*" + et + "\\s*\\}", "g"), $);
      }), H2;
    }
    function I2() {
      var N3 = f2.get("title");
      return N3 && N3.length && (N3 = N3[0]), N3 && N3.text;
    }
    function P2(N3) {
      return f2.getLocaleModel().get(["series", "typeNames"])[N3] || "\u81EA\u5B9A\u4E49\u56FE";
    }
  }
  function ZDr(f2) {
    if (!(!f2 || !f2.aria)) {
      var i = f2.aria;
      i.show != null && (i.enabled = i.show), i.label = i.label || {}, Qe2(["description", "general", "series", "data"], function(t2) {
        i[t2] != null && (i.label[t2] = i[t2]);
      });
    }
  }
  function $Dr(f2) {
    f2.registerPreprocessor(ZDr), f2.registerVisual(f2.PRIORITY.VISUAL.ARIA, qDr);
  }
  var tBe = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, YDr = function() {
    function f2(i) {
      var t2 = this._condVal = ms(i) ? new RegExp(i) : Ilr(i) ? i : null;
      if (t2 == null) {
        var h = "";
        Ep(h);
      }
    }
    return f2.prototype.evaluate = function(i) {
      var t2 = typeof i;
      return ms(t2) ? this._condVal.test(i) : vp(t2) ? this._condVal.test(i + "") : false;
    }, f2;
  }(), KDr = function() {
    function f2() {
    }
    return f2.prototype.evaluate = function() {
      return this.value;
    }, f2;
  }(), XDr = function() {
    function f2() {
    }
    return f2.prototype.evaluate = function() {
      for (var i = this.children, t2 = 0; t2 < i.length; t2++)
        if (!i[t2].evaluate())
          return false;
      return true;
    }, f2;
  }(), QDr = function() {
    function f2() {
    }
    return f2.prototype.evaluate = function() {
      for (var i = this.children, t2 = 0; t2 < i.length; t2++)
        if (i[t2].evaluate())
          return true;
      return false;
    }, f2;
  }(), JDr = function() {
    function f2() {
    }
    return f2.prototype.evaluate = function() {
      return !this.child.evaluate();
    }, f2;
  }(), tEr = function() {
    function f2() {
    }
    return f2.prototype.evaluate = function() {
      for (var i = !!this.valueParser, t2 = this.getValue, h = t2(this.valueGetterParam), v4 = i ? this.valueParser(h) : null, _ = 0; _ < this.subCondList.length; _++)
        if (!this.subCondList[_].evaluate(i ? v4 : h))
          return false;
      return true;
    }, f2;
  }();
  function bre(f2, i) {
    if (f2 === true || f2 === false) {
      var t2 = new KDr();
      return t2.value = f2, t2;
    }
    var h = "";
    return Zqe(f2) || Ep(h), f2.and ? eBe("and", f2, i) : f2.or ? eBe("or", f2, i) : f2.not ? eEr(f2, i) : nEr(f2, i);
  }
  function eBe(f2, i, t2) {
    var h = i[f2], v4 = "";
    Za2(h) || Ep(v4), h.length || Ep(v4);
    var _ = f2 === "and" ? new XDr() : new QDr();
    return _.children = Xa2(h, function(M2) {
      return bre(M2, t2);
    }), _.children.length || Ep(v4), _;
  }
  function eEr(f2, i) {
    var t2 = f2.not, h = "";
    Zqe(t2) || Ep(h);
    var v4 = new JDr();
    return v4.child = bre(t2, i), v4.child || Ep(h), v4;
  }
  function nEr(f2, i) {
    for (var t2 = "", h = i.prepareGetValue(f2), v4 = [], _ = Of2(f2), M2 = f2.parser, I2 = M2 ? SWe(M2) : null, P2 = 0; P2 < _.length; P2++) {
      var N3 = _[P2];
      if (!(N3 === "parser" || i.valueGetterAttrMap.get(N3))) {
        var z3 = qs(tBe, N3) ? tBe[N3] : N3, H2 = f2[N3], $ = I2 ? I2(H2) : H2, et = Rpr(z3, $) || z3 === "reg" && new YDr($);
        et || Ep(t2), v4.push(et);
      }
    }
    v4.length || Ep(t2);
    var at = new tEr();
    return at.valueGetterParam = h, at.valueParser = I2, at.getValue = i.getValue, at.subCondList = v4, at;
  }
  function Zqe(f2) {
    return Xl(f2) && !xS(f2);
  }
  var rEr = function() {
    function f2(i, t2) {
      this._cond = bre(i, t2);
    }
    return f2.prototype.evaluate = function() {
      return this._cond.evaluate();
    }, f2;
  }();
  function iEr(f2, i) {
    return new rEr(f2, i);
  }
  var aEr = { type: "echarts:filter", transform: function(f2) {
    for (var i = f2.upstream, t2, h = iEr(f2.config, { valueGetterAttrMap: Il({ dimension: true }), prepareGetValue: function(I2) {
      var P2 = "", N3 = I2.dimension;
      qs(I2, "dimension") || Ep(P2);
      var z3 = i.getDimensionInfo(N3);
      return z3 || Ep(P2), { dimIdx: z3.index };
    }, getValue: function(I2) {
      return i.retrieveValueFromItem(t2, I2.dimIdx);
    } }), v4 = [], _ = 0, M2 = i.count(); _ < M2; _++)
      t2 = i.getRawDataItem(_), h.evaluate() && v4.push(t2);
    return { data: v4 };
  } }, oEr = { type: "echarts:sort", transform: function(f2) {
    var i = f2.upstream, t2 = f2.config, h = "", v4 = Od2(t2);
    v4.length || Ep(h);
    var _ = [];
    Qe2(v4, function(z3) {
      var H2 = z3.dimension, $ = z3.order, et = z3.parser, at = z3.incomparable;
      if (H2 == null && Ep(h), $ !== "asc" && $ !== "desc" && Ep(h), at && at !== "min" && at !== "max") {
        var ht = "";
        Ep(ht);
      }
      if ($ !== "asc" && $ !== "desc") {
        var bt = "";
        Ep(bt);
      }
      var _t = i.getDimensionInfo(H2);
      _t || Ep(h);
      var Et = et ? SWe(et) : null;
      et && !Et && Ep(h), _.push({ dimIdx: _t.index, parser: Et, comparator: new CWe($, at) });
    });
    var M2 = i.sourceFormat;
    M2 !== wS && M2 !== oE && Ep(h);
    for (var I2 = [], P2 = 0, N3 = i.count(); P2 < N3; P2++)
      I2.push(i.getRawDataItem(P2));
    return I2.sort(function(z3, H2) {
      for (var $ = 0; $ < _.length; $++) {
        var et = _[$], at = i.retrieveValueFromItem(z3, et.dimIdx), ht = i.retrieveValueFromItem(H2, et.dimIdx);
        et.parser && (at = et.parser(at), ht = et.parser(ht));
        var bt = et.comparator.evaluate(at, ht);
        if (bt !== 0)
          return bt;
      }
      return 0;
    }), { data: I2 };
  } };
  function sEr(f2) {
    f2.registerTransform(aEr), f2.registerTransform(oEr);
  }
  var lEr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "dataset", t2;
    }
    return i.prototype.init = function(t2, h, v4) {
      f2.prototype.init.call(this, t2, h, v4), this._sourceManager = new DWe(this), rFe(this);
    }, i.prototype.mergeOption = function(t2, h) {
      f2.prototype.mergeOption.call(this, t2, h), rFe(this);
    }, i.prototype.optionUpdated = function() {
      this._sourceManager.dirty();
    }, i.prototype.getSourceManager = function() {
      return this._sourceManager;
    }, i.type = "dataset", i.defaultOption = { seriesLayoutBy: VL }, i;
  }(zh2), uEr = function(f2) {
    ii2(i, f2);
    function i() {
      var t2 = f2 !== null && f2.apply(this, arguments) || this;
      return t2.type = "dataset", t2;
    }
    return i.type = "dataset", i;
  }(W0);
  function cEr(f2) {
    f2.registerComponentModel(lEr), f2.registerComponentView(uEr);
  }
  var TL = HL.CMD;
  function ktt(f2, i) {
    return Math.abs(f2 - i) < 1e-5;
  }
  function $te(f2) {
    var i = f2.data, t2 = f2.len(), h = [], v4, _ = 0, M2 = 0, I2 = 0, P2 = 0;
    function N3(Ue2, Mn) {
      v4 && v4.length > 2 && h.push(v4), v4 = [Ue2, Mn];
    }
    function z3(Ue2, Mn, Vn, xn) {
      ktt(Ue2, Vn) && ktt(Mn, xn) || v4.push(Ue2, Mn, Vn, xn, Vn, xn);
    }
    function H2(Ue2, Mn, Vn, xn, Zr, nr) {
      var pr = Math.abs(Mn - Ue2), Nr = Math.tan(pr / 4) * 4 / 3, ai2 = Mn < Ue2 ? -1 : 1, gi2 = Math.cos(Ue2), To = Math.sin(Ue2), us = Math.cos(Mn), ml = Math.sin(Mn), ll = gi2 * Zr + Vn, Rs = To * nr + xn, es = us * Zr + Vn, Ws = ml * nr + xn, il = Zr * Nr * ai2, bs = nr * Nr * ai2;
      v4.push(ll - il * To, Rs + bs * gi2, es + il * ml, Ws - bs * us, es, Ws);
    }
    for (var $, et, at, ht, bt = 0; bt < t2; ) {
      var _t = i[bt++], Et = bt === 1;
      switch (Et && (_ = i[bt], M2 = i[bt + 1], I2 = _, P2 = M2, (_t === TL.L || _t === TL.C || _t === TL.Q) && (v4 = [I2, P2])), _t) {
        case TL.M:
          _ = I2 = i[bt++], M2 = P2 = i[bt++], N3(I2, P2);
          break;
        case TL.L:
          $ = i[bt++], et = i[bt++], z3(_, M2, $, et), _ = $, M2 = et;
          break;
        case TL.C:
          v4.push(i[bt++], i[bt++], i[bt++], i[bt++], _ = i[bt++], M2 = i[bt++]);
          break;
        case TL.Q:
          $ = i[bt++], et = i[bt++], at = i[bt++], ht = i[bt++], v4.push(_ + 2 / 3 * ($ - _), M2 + 2 / 3 * (et - M2), at + 2 / 3 * ($ - at), ht + 2 / 3 * (et - ht), at, ht), _ = at, M2 = ht;
          break;
        case TL.A:
          var zt = i[bt++], Ft = i[bt++], fe2 = i[bt++], re2 = i[bt++], ye = i[bt++], me2 = i[bt++] + ye;
          bt += 1;
          var be2 = !i[bt++];
          $ = Math.cos(ye) * fe2 + zt, et = Math.sin(ye) * re2 + Ft, Et ? (I2 = $, P2 = et, N3(I2, P2)) : z3(_, M2, $, et), _ = Math.cos(me2) * fe2 + zt, M2 = Math.sin(me2) * re2 + Ft;
          for (var Te2 = (be2 ? -1 : 1) * Math.PI / 2, We = ye; be2 ? We > me2 : We < me2; We += Te2) {
            var en = be2 ? Math.max(We + Te2, me2) : Math.min(We + Te2, me2);
            H2(We, en, zt, Ft, fe2, re2);
          }
          break;
        case TL.R:
          I2 = _ = i[bt++], P2 = M2 = i[bt++], $ = I2 + i[bt++], et = P2 + i[bt++], N3($, P2), z3($, P2, $, et), z3($, et, I2, et), z3(I2, et, I2, P2), z3(I2, P2, $, P2);
          break;
        case TL.Z:
          v4 && z3(_, M2, I2, P2), _ = I2, M2 = P2;
          break;
      }
    }
    return v4 && v4.length > 2 && h.push(v4), h;
  }
  function Yte(f2, i, t2, h, v4, _, M2, I2, P2, N3) {
    if (ktt(f2, t2) && ktt(i, h) && ktt(v4, M2) && ktt(_, I2)) {
      P2.push(M2, I2);
      return;
    }
    var z3 = 2 / N3, H2 = z3 * z3, $ = M2 - f2, et = I2 - i, at = Math.sqrt($ * $ + et * et);
    $ /= at, et /= at;
    var ht = t2 - f2, bt = h - i, _t = v4 - M2, Et = _ - I2, zt = ht * ht + bt * bt, Ft = _t * _t + Et * Et;
    if (zt < H2 && Ft < H2) {
      P2.push(M2, I2);
      return;
    }
    var fe2 = $ * ht + et * bt, re2 = -$ * _t - et * Et, ye = zt - fe2 * fe2, me2 = Ft - re2 * re2;
    if (ye < H2 && fe2 >= 0 && me2 < H2 && re2 >= 0) {
      P2.push(M2, I2);
      return;
    }
    var be2 = [], Te2 = [];
    X7(f2, t2, v4, M2, 0.5, be2), X7(i, h, _, I2, 0.5, Te2), Yte(be2[0], Te2[0], be2[1], Te2[1], be2[2], Te2[2], be2[3], Te2[3], P2, N3), Yte(be2[4], Te2[4], be2[5], Te2[5], be2[6], Te2[6], be2[7], Te2[7], P2, N3);
  }
  function fEr(f2, i) {
    var t2 = $te(f2), h = [];
    i = i || 1;
    for (var v4 = 0; v4 < t2.length; v4++) {
      var _ = t2[v4], M2 = [], I2 = _[0], P2 = _[1];
      M2.push(I2, P2);
      for (var N3 = 2; N3 < _.length; ) {
        var z3 = _[N3++], H2 = _[N3++], $ = _[N3++], et = _[N3++], at = _[N3++], ht = _[N3++];
        Yte(I2, P2, z3, H2, $, et, at, ht, M2, i), I2 = at, P2 = ht;
      }
      h.push(M2);
    }
    return h;
  }
  function $qe(f2, i, t2) {
    var h = f2[i], v4 = f2[1 - i], _ = Math.abs(h / v4), M2 = Math.ceil(Math.sqrt(_ * t2)), I2 = Math.floor(t2 / M2);
    I2 === 0 && (I2 = 1, M2 = t2);
    for (var P2 = [], N3 = 0; N3 < M2; N3++)
      P2.push(I2);
    var z3 = M2 * I2, H2 = t2 - z3;
    if (H2 > 0)
      for (var N3 = 0; N3 < H2; N3++)
        P2[N3 % M2] += 1;
    return P2;
  }
  function nBe(f2, i, t2) {
    for (var h = f2.r0, v4 = f2.r, _ = f2.startAngle, M2 = f2.endAngle, I2 = Math.abs(M2 - _), P2 = I2 * v4, N3 = v4 - h, z3 = P2 > Math.abs(N3), H2 = $qe([P2, N3], z3 ? 0 : 1, i), $ = (z3 ? I2 : N3) / H2.length, et = 0; et < H2.length; et++)
      for (var at = (z3 ? N3 : I2) / H2[et], ht = 0; ht < H2[et]; ht++) {
        var bt = {};
        z3 ? (bt.startAngle = _ + $ * et, bt.endAngle = _ + $ * (et + 1), bt.r0 = h + at * ht, bt.r = h + at * (ht + 1)) : (bt.startAngle = _ + at * ht, bt.endAngle = _ + at * (ht + 1), bt.r0 = h + $ * et, bt.r = h + $ * (et + 1)), bt.clockwise = f2.clockwise, bt.cx = f2.cx, bt.cy = f2.cy, t2.push(bt);
      }
  }
  function hEr(f2, i, t2) {
    for (var h = f2.width, v4 = f2.height, _ = h > v4, M2 = $qe([h, v4], _ ? 0 : 1, i), I2 = _ ? "width" : "height", P2 = _ ? "height" : "width", N3 = _ ? "x" : "y", z3 = _ ? "y" : "x", H2 = f2[I2] / M2.length, $ = 0; $ < M2.length; $++)
      for (var et = f2[P2] / M2[$], at = 0; at < M2[$]; at++) {
        var ht = {};
        ht[N3] = $ * H2, ht[z3] = at * et, ht[I2] = H2, ht[P2] = et, ht.x += f2.x, ht.y += f2.y, t2.push(ht);
      }
  }
  function rBe(f2, i, t2, h) {
    return f2 * h - t2 * i;
  }
  function pEr(f2, i, t2, h, v4, _, M2, I2) {
    var P2 = t2 - f2, N3 = h - i, z3 = M2 - v4, H2 = I2 - _, $ = rBe(z3, H2, P2, N3);
    if (Math.abs($) < 1e-6)
      return null;
    var et = f2 - v4, at = i - _, ht = rBe(et, at, z3, H2) / $;
    return ht < 0 || ht > 1 ? null : new ac2(ht * P2 + f2, ht * N3 + i);
  }
  function dEr(f2, i, t2) {
    var h = new ac2();
    ac2.sub(h, t2, i), h.normalize();
    var v4 = new ac2();
    ac2.sub(v4, f2, i);
    var _ = v4.dot(h);
    return _;
  }
  function ytt(f2, i) {
    var t2 = f2[f2.length - 1];
    t2 && t2[0] === i[0] && t2[1] === i[1] || f2.push(i);
  }
  function gEr(f2, i, t2) {
    for (var h = f2.length, v4 = [], _ = 0; _ < h; _++) {
      var M2 = f2[_], I2 = f2[(_ + 1) % h], P2 = pEr(M2[0], M2[1], I2[0], I2[1], i.x, i.y, t2.x, t2.y);
      P2 && v4.push({ projPt: dEr(P2, i, t2), pt: P2, idx: _ });
    }
    if (v4.length < 2)
      return [{ points: f2 }, { points: f2 }];
    v4.sort(function(bt, _t) {
      return bt.projPt - _t.projPt;
    });
    var N3 = v4[0], z3 = v4[v4.length - 1];
    if (z3.idx < N3.idx) {
      var H2 = N3;
      N3 = z3, z3 = H2;
    }
    for (var $ = [N3.pt.x, N3.pt.y], et = [z3.pt.x, z3.pt.y], at = [$], ht = [et], _ = N3.idx + 1; _ <= z3.idx; _++)
      ytt(at, f2[_].slice());
    ytt(at, et), ytt(at, $);
    for (var _ = z3.idx + 1; _ <= N3.idx + h; _++)
      ytt(ht, f2[_ % h].slice());
    return ytt(ht, $), ytt(ht, et), [{ points: at }, { points: ht }];
  }
  function iBe(f2) {
    var i = f2.points, t2 = [], h = [];
    dkt(i, t2, h);
    var v4 = new Lc2(t2[0], t2[1], h[0] - t2[0], h[1] - t2[1]), _ = v4.width, M2 = v4.height, I2 = v4.x, P2 = v4.y, N3 = new ac2(), z3 = new ac2();
    return _ > M2 ? (N3.x = z3.x = I2 + _ / 2, N3.y = P2, z3.y = P2 + M2) : (N3.y = z3.y = P2 + M2 / 2, N3.x = I2, z3.x = I2 + _), gEr(i, N3, z3);
  }
  function XEt(f2, i, t2, h) {
    if (t2 === 1)
      h.push(i);
    else {
      var v4 = Math.floor(t2 / 2), _ = f2(i);
      XEt(f2, _[0], v4, h), XEt(f2, _[1], t2 - v4, h);
    }
    return h;
  }
  function vEr(f2, i) {
    for (var t2 = [], h = 0; h < i; h++)
      t2.push(Vee(f2));
    return t2;
  }
  function yEr(f2, i) {
    i.setStyle(f2.style), i.z = f2.z, i.z2 = f2.z2, i.zlevel = f2.zlevel;
  }
  function mEr(f2) {
    for (var i = [], t2 = 0; t2 < f2.length; )
      i.push([f2[t2++], f2[t2++]]);
    return i;
  }
  function bEr(f2, i) {
    var t2 = [], h = f2.shape, v4;
    switch (f2.type) {
      case "rect":
        hEr(h, i, t2), v4 = Sh2;
        break;
      case "sector":
        nBe(h, i, t2), v4 = rC;
        break;
      case "circle":
        nBe({ r0: 0, r: h.r, startAngle: 0, endAngle: Math.PI * 2, cx: h.cx, cy: h.cy }, i, t2), v4 = rC;
        break;
      default:
        var _ = f2.getComputedTransform(), M2 = _ ? Math.sqrt(Math.max(_[0] * _[0] + _[1] * _[1], _[2] * _[2] + _[3] * _[3])) : 1, I2 = Xa2(fEr(f2.getUpdatedPathProxy(), M2), function(_t) {
          return mEr(_t);
        }), P2 = I2.length;
        if (P2 === 0)
          XEt(iBe, { points: I2[0] }, i, t2);
        else if (P2 === i)
          for (var N3 = 0; N3 < P2; N3++)
            t2.push({ points: I2[N3] });
        else {
          var z3 = 0, H2 = Xa2(I2, function(_t) {
            var Et = [], zt = [];
            dkt(_t, Et, zt);
            var Ft = (zt[1] - Et[1]) * (zt[0] - Et[0]);
            return z3 += Ft, { poly: _t, area: Ft };
          });
          H2.sort(function(_t, Et) {
            return Et.area - _t.area;
          });
          for (var $ = i, N3 = 0; N3 < P2; N3++) {
            var et = H2[N3];
            if ($ <= 0)
              break;
            var at = N3 === P2 - 1 ? $ : Math.ceil(et.area / z3 * i);
            at < 0 || (XEt(iBe, { points: et.poly }, at, t2), $ -= at);
          }
        }
        v4 = iC;
        break;
    }
    if (!v4)
      return vEr(f2, i);
    for (var ht = [], N3 = 0; N3 < t2.length; N3++) {
      var bt = new v4();
      bt.setShape(t2[N3]), yEr(f2, bt), ht.push(bt);
    }
    return ht;
  }
  function _Er(f2, i) {
    var t2 = f2.length, h = i.length;
    if (t2 === h)
      return [f2, i];
    for (var v4 = [], _ = [], M2 = t2 < h ? f2 : i, I2 = Math.min(t2, h), P2 = Math.abs(h - t2) / 6, N3 = (I2 - 2) / 6, z3 = Math.ceil(P2 / N3) + 1, H2 = [M2[0], M2[1]], $ = P2, et = 2; et < I2; ) {
      var at = M2[et - 2], ht = M2[et - 1], bt = M2[et++], _t = M2[et++], Et = M2[et++], zt = M2[et++], Ft = M2[et++], fe2 = M2[et++];
      if ($ <= 0) {
        H2.push(bt, _t, Et, zt, Ft, fe2);
        continue;
      }
      for (var re2 = Math.min($, z3 - 1) + 1, ye = 1; ye <= re2; ye++) {
        var me2 = ye / re2;
        X7(at, bt, Et, Ft, me2, v4), X7(ht, _t, zt, fe2, me2, _), at = v4[3], ht = _[3], H2.push(v4[1], _[1], v4[2], _[2], at, ht), bt = v4[5], _t = _[5], Et = v4[6], zt = _[6];
      }
      $ -= re2 - 1;
    }
    return M2 === f2 ? [H2, i] : [f2, H2];
  }
  function aBe(f2, i) {
    for (var t2 = f2.length, h = f2[t2 - 2], v4 = f2[t2 - 1], _ = [], M2 = 0; M2 < i.length; )
      _[M2++] = h, _[M2++] = v4;
    return _;
  }
  function xEr(f2, i) {
    for (var t2, h, v4, _ = [], M2 = [], I2 = 0; I2 < Math.max(f2.length, i.length); I2++) {
      var P2 = f2[I2], N3 = i[I2], z3 = void 0, H2 = void 0;
      P2 ? N3 ? (t2 = _Er(P2, N3), z3 = t2[0], H2 = t2[1], h = z3, v4 = H2) : (H2 = aBe(v4 || P2, P2), z3 = P2) : (z3 = aBe(h || N3, N3), H2 = N3), _.push(z3), M2.push(H2);
    }
    return [_, M2];
  }
  function oBe(f2) {
    for (var i = 0, t2 = 0, h = 0, v4 = f2.length, _ = 0, M2 = v4 - 2; _ < v4; M2 = _, _ += 2) {
      var I2 = f2[M2], P2 = f2[M2 + 1], N3 = f2[_], z3 = f2[_ + 1], H2 = I2 * z3 - N3 * P2;
      i += H2, t2 += (I2 + N3) * H2, h += (P2 + z3) * H2;
    }
    return i === 0 ? [f2[0] || 0, f2[1] || 0] : [t2 / i / 3, h / i / 3, i];
  }
  function wEr(f2, i, t2, h) {
    for (var v4 = (f2.length - 2) / 6, _ = 1 / 0, M2 = 0, I2 = f2.length, P2 = I2 - 2, N3 = 0; N3 < v4; N3++) {
      for (var z3 = N3 * 6, H2 = 0, $ = 0; $ < I2; $ += 2) {
        var et = $ === 0 ? z3 : (z3 + $ - 2) % P2 + 2, at = f2[et] - t2[0], ht = f2[et + 1] - t2[1], bt = i[$] - h[0], _t = i[$ + 1] - h[1], Et = bt - at, zt = _t - ht;
        H2 += Et * Et + zt * zt;
      }
      H2 < _ && (_ = H2, M2 = N3);
    }
    return M2;
  }
  function SEr(f2) {
    for (var i = [], t2 = f2.length, h = 0; h < t2; h += 2)
      i[h] = f2[t2 - h - 2], i[h + 1] = f2[t2 - h - 1];
    return i;
  }
  function MEr(f2, i, t2, h) {
    for (var v4 = [], _, M2 = 0; M2 < f2.length; M2++) {
      var I2 = f2[M2], P2 = i[M2], N3 = oBe(I2), z3 = oBe(P2);
      _ == null && (_ = N3[2] < 0 != z3[2] < 0);
      var H2 = [], $ = [], et = 0, at = 1 / 0, ht = [], bt = I2.length;
      _ && (I2 = SEr(I2));
      for (var _t = wEr(I2, P2, N3, z3) * 6, Et = bt - 2, zt = 0; zt < Et; zt += 2) {
        var Ft = (_t + zt) % Et + 2;
        H2[zt + 2] = I2[Ft] - N3[0], H2[zt + 3] = I2[Ft + 1] - N3[1];
      }
      if (H2[0] = I2[_t] - N3[0], H2[1] = I2[_t + 1] - N3[1], t2 > 0)
        for (var fe2 = h / t2, re2 = -h / 2; re2 <= h / 2; re2 += fe2) {
          for (var ye = Math.sin(re2), me2 = Math.cos(re2), be2 = 0, zt = 0; zt < I2.length; zt += 2) {
            var Te2 = H2[zt], We = H2[zt + 1], en = P2[zt] - z3[0], Ue2 = P2[zt + 1] - z3[1], Mn = en * me2 - Ue2 * ye, Vn = en * ye + Ue2 * me2;
            ht[zt] = Mn, ht[zt + 1] = Vn;
            var xn = Mn - Te2, Zr = Vn - We;
            be2 += xn * xn + Zr * Zr;
          }
          if (be2 < at) {
            at = be2, et = re2;
            for (var nr = 0; nr < ht.length; nr++)
              $[nr] = ht[nr];
          }
        }
      else
        for (var pr = 0; pr < bt; pr += 2)
          $[pr] = P2[pr] - z3[0], $[pr + 1] = P2[pr + 1] - z3[1];
      v4.push({ from: H2, to: $, fromCp: N3, toCp: z3, rotation: -et });
    }
    return v4;
  }
  function QEt(f2) {
    return f2.__isCombineMorphing;
  }
  var Yqe = "__mOriginal_";
  function JEt(f2, i, t2) {
    var h = Yqe + i, v4 = f2[h] || f2[i];
    f2[h] || (f2[h] = f2[i]);
    var _ = t2.replace, M2 = t2.after, I2 = t2.before;
    f2[i] = function() {
      var P2 = arguments, N3;
      return I2 && I2.apply(this, P2), _ ? N3 = _.apply(this, P2) : N3 = v4.apply(this, P2), M2 && M2.apply(this, P2), N3;
    };
  }
  function Wdt(f2, i) {
    var t2 = Yqe + i;
    f2[t2] && (f2[i] = f2[t2], f2[t2] = null);
  }
  function sBe(f2, i) {
    for (var t2 = 0; t2 < f2.length; t2++)
      for (var h = f2[t2], v4 = 0; v4 < h.length; ) {
        var _ = h[v4], M2 = h[v4 + 1];
        h[v4++] = i[0] * _ + i[2] * M2 + i[4], h[v4++] = i[1] * _ + i[3] * M2 + i[5];
      }
  }
  function Kqe(f2, i) {
    var t2 = f2.getUpdatedPathProxy(), h = i.getUpdatedPathProxy(), v4 = xEr($te(t2), $te(h)), _ = v4[0], M2 = v4[1], I2 = f2.getComputedTransform(), P2 = i.getComputedTransform();
    function N3() {
      this.transform = null;
    }
    I2 && sBe(_, I2), P2 && sBe(M2, P2), JEt(i, "updateTransform", { replace: N3 }), i.transform = null;
    var z3 = MEr(_, M2, 10, Math.PI), H2 = [];
    JEt(i, "buildPath", { replace: function($) {
      for (var et = i.__morphT, at = 1 - et, ht = [], bt = 0; bt < z3.length; bt++) {
        var _t = z3[bt], Et = _t.from, zt = _t.to, Ft = _t.rotation * et, fe2 = _t.fromCp, re2 = _t.toCp, ye = Math.sin(Ft), me2 = Math.cos(Ft);
        BDt(ht, fe2, re2, et);
        for (var be2 = 0; be2 < Et.length; be2 += 2) {
          var Te2 = Et[be2], We = Et[be2 + 1], en = zt[be2], Ue2 = zt[be2 + 1], Mn = Te2 * at + en * et, Vn = We * at + Ue2 * et;
          H2[be2] = Mn * me2 - Vn * ye + ht[0], H2[be2 + 1] = Mn * ye + Vn * me2 + ht[1];
        }
        var xn = H2[0], Zr = H2[1];
        $.moveTo(xn, Zr);
        for (var be2 = 2; be2 < Et.length; ) {
          var en = H2[be2++], Ue2 = H2[be2++], nr = H2[be2++], pr = H2[be2++], Nr = H2[be2++], ai2 = H2[be2++];
          xn === en && Zr === Ue2 && nr === Nr && pr === ai2 ? $.lineTo(Nr, ai2) : $.bezierCurveTo(en, Ue2, nr, pr, Nr, ai2), xn = Nr, Zr = ai2;
        }
      }
    } });
  }
  function _re(f2, i, t2) {
    if (!f2 || !i)
      return i;
    var h = t2.done, v4 = t2.during;
    Kqe(f2, i), i.__morphT = 0;
    function _() {
      Wdt(i, "buildPath"), Wdt(i, "updateTransform"), i.__morphT = -1, i.createPathProxy(), i.dirtyShape();
    }
    return i.animateTo({ __morphT: 1 }, Ul({ during: function(M2) {
      i.dirtyShape(), v4 && v4(M2);
    }, done: function() {
      _(), h && h();
    } }, t2)), i;
  }
  function CEr(f2, i, t2, h, v4, _) {
    var M2 = 16;
    f2 = v4 === t2 ? 0 : Math.round(32767 * (f2 - t2) / (v4 - t2)), i = _ === h ? 0 : Math.round(32767 * (i - h) / (_ - h));
    for (var I2 = 0, P2, N3 = (1 << M2) / 2; N3 > 0; N3 /= 2) {
      var z3 = 0, H2 = 0;
      (f2 & N3) > 0 && (z3 = 1), (i & N3) > 0 && (H2 = 1), I2 += N3 * N3 * (3 * z3 ^ H2), H2 === 0 && (z3 === 1 && (f2 = N3 - 1 - f2, i = N3 - 1 - i), P2 = f2, f2 = i, i = P2);
    }
    return I2;
  }
  function tkt(f2) {
    var i = 1 / 0, t2 = 1 / 0, h = -1 / 0, v4 = -1 / 0, _ = Xa2(f2, function(I2) {
      var P2 = I2.getBoundingRect(), N3 = I2.getComputedTransform(), z3 = P2.x + P2.width / 2 + (N3 ? N3[4] : 0), H2 = P2.y + P2.height / 2 + (N3 ? N3[5] : 0);
      return i = Math.min(z3, i), t2 = Math.min(H2, t2), h = Math.max(z3, h), v4 = Math.max(H2, v4), [z3, H2];
    }), M2 = Xa2(_, function(I2, P2) {
      return { cp: I2, z: CEr(I2[0], I2[1], i, t2, h, v4), path: f2[P2] };
    });
    return M2.sort(function(I2, P2) {
      return I2.z - P2.z;
    }).map(function(I2) {
      return I2.path;
    });
  }
  function Xqe(f2) {
    return bEr(f2.path, f2.count);
  }
  function Kte() {
    return { fromIndividuals: [], toIndividuals: [], count: 0 };
  }
  function TEr(f2, i, t2) {
    var h = [];
    function v4(fe2) {
      for (var re2 = 0; re2 < fe2.length; re2++) {
        var ye = fe2[re2];
        QEt(ye) ? v4(ye.childrenRef()) : ye instanceof Uc2 && h.push(ye);
      }
    }
    v4(f2);
    var _ = h.length;
    if (!_)
      return Kte();
    var M2 = t2.dividePath || Xqe, I2 = M2({ path: i, count: _ });
    if (I2.length !== _)
      return console.error("Invalid morphing: unmatched splitted path"), Kte();
    h = tkt(h), I2 = tkt(I2);
    for (var P2 = t2.done, N3 = t2.during, z3 = t2.individualDelay, H2 = new G6(), $ = 0; $ < _; $++) {
      var et = h[$], at = I2[$];
      at.parent = i, at.copyTransform(H2), z3 || Kqe(et, at);
    }
    i.__isCombineMorphing = true, i.childrenRef = function() {
      return I2;
    };
    function ht(fe2) {
      for (var re2 = 0; re2 < I2.length; re2++)
        I2[re2].addSelfToZr(fe2);
    }
    JEt(i, "addSelfToZr", { after: function(fe2) {
      ht(fe2);
    } }), JEt(i, "removeSelfFromZr", { after: function(fe2) {
      for (var re2 = 0; re2 < I2.length; re2++)
        I2[re2].removeSelfFromZr(fe2);
    } });
    function bt() {
      i.__isCombineMorphing = false, i.__morphT = -1, i.childrenRef = null, Wdt(i, "addSelfToZr"), Wdt(i, "removeSelfFromZr");
    }
    var _t = I2.length;
    if (z3)
      for (var Et = _t, zt = function() {
        Et--, Et === 0 && (bt(), P2 && P2());
      }, $ = 0; $ < _t; $++) {
        var Ft = z3 ? Ul({ delay: (t2.delay || 0) + z3($, _t, h[$], I2[$]), done: zt }, t2) : t2;
        _re(h[$], I2[$], Ft);
      }
    else
      i.__morphT = 0, i.animateTo({ __morphT: 1 }, Ul({ during: function(fe2) {
        for (var re2 = 0; re2 < _t; re2++) {
          var ye = I2[re2];
          ye.__morphT = i.__morphT, ye.dirtyShape();
        }
        N3 && N3(fe2);
      }, done: function() {
        bt();
        for (var fe2 = 0; fe2 < f2.length; fe2++)
          Wdt(f2[fe2], "updateTransform");
        P2 && P2();
      } }, t2));
    return i.__zr && ht(i.__zr), { fromIndividuals: h, toIndividuals: I2, count: _t };
  }
  function AEr(f2, i, t2) {
    var h = i.length, v4 = [], _ = t2.dividePath || Xqe;
    function M2(et) {
      for (var at = 0; at < et.length; at++) {
        var ht = et[at];
        QEt(ht) ? M2(ht.childrenRef()) : ht instanceof Uc2 && v4.push(ht);
      }
    }
    if (QEt(f2)) {
      M2(f2.childrenRef());
      var I2 = v4.length;
      if (I2 < h)
        for (var P2 = 0, N3 = I2; N3 < h; N3++)
          v4.push(Vee(v4[P2++ % I2]));
      v4.length = h;
    } else {
      v4 = _({ path: f2, count: h });
      for (var z3 = f2.getComputedTransform(), N3 = 0; N3 < v4.length; N3++)
        v4[N3].setLocalTransform(z3);
      if (v4.length !== h)
        return console.error("Invalid morphing: unmatched splitted path"), Kte();
    }
    v4 = tkt(v4), i = tkt(i);
    for (var H2 = t2.individualDelay, N3 = 0; N3 < h; N3++) {
      var $ = H2 ? Ul({ delay: (t2.delay || 0) + H2(N3, h, v4[N3], i[N3]) }, t2) : t2;
      _re(v4[N3], i[N3], $);
    }
    return { fromIndividuals: v4, toIndividuals: i, count: i.length };
  }
  function lBe(f2) {
    return Za2(f2[0]);
  }
  function uBe(f2, i) {
    for (var t2 = [], h = f2.length, v4 = 0; v4 < h; v4++)
      t2.push({ one: f2[v4], many: [] });
    for (var v4 = 0; v4 < i.length; v4++) {
      var _ = i[v4].length, M2 = void 0;
      for (M2 = 0; M2 < _; M2++)
        t2[M2 % h].many.push(i[v4][M2]);
    }
    for (var I2 = 0, v4 = h - 1; v4 >= 0; v4--)
      if (!t2[v4].many.length) {
        var P2 = t2[I2].many;
        if (P2.length <= 1)
          if (I2)
            I2 = 0;
          else
            return t2;
        var _ = P2.length, N3 = Math.ceil(_ / 2);
        t2[v4].many = P2.slice(N3, _), t2[I2].many = P2.slice(0, N3), I2++;
      }
    return t2;
  }
  var IEr = { clone: function(f2) {
    for (var i = [], t2 = 1 - Math.pow(1 - f2.path.style.opacity, 1 / f2.count), h = 0; h < f2.count; h++) {
      var v4 = Vee(f2.path);
      v4.setStyle("opacity", t2), i.push(v4);
    }
    return i;
  }, split: null };
  function XQt(f2, i, t2, h, v4, _) {
    if (!f2.length || !i.length)
      return;
    var M2 = tet("update", h, v4);
    if (!(M2 && M2.duration > 0))
      return;
    var I2 = h.getModel("universalTransition").get("delay"), P2 = Object.assign({ setToFinal: true }, M2), N3, z3;
    lBe(f2) && (N3 = f2, z3 = i), lBe(i) && (N3 = i, z3 = f2);
    function H2(_t, Et, zt, Ft, fe2) {
      var re2 = _t.many, ye = _t.one;
      if (re2.length === 1 && !fe2) {
        var me2 = Et ? re2[0] : ye, be2 = Et ? ye : re2[0];
        if (QEt(me2))
          H2({ many: [me2], one: be2 }, true, zt, Ft, true);
        else {
          var Te2 = I2 ? Ul({ delay: I2(zt, Ft) }, P2) : P2;
          _re(me2, be2, Te2), _(me2, be2, me2, be2, Te2);
        }
      } else
        for (var We = Ul({ dividePath: IEr[t2], individualDelay: I2 && function(Zr, nr, pr, Nr) {
          return I2(Zr + zt, Ft);
        } }, P2), en = Et ? TEr(re2, ye, We) : AEr(ye, re2, We), Ue2 = en.fromIndividuals, Mn = en.toIndividuals, Vn = Ue2.length, xn = 0; xn < Vn; xn++) {
          var Te2 = I2 ? Ul({ delay: I2(xn, Vn) }, P2) : P2;
          _(Ue2[xn], Mn[xn], Et ? re2[xn] : _t.one, Et ? _t.one : re2[xn], Te2);
        }
    }
    for (var $ = N3 ? N3 === f2 : f2.length > i.length, et = N3 ? uBe(z3, N3) : uBe($ ? i : f2, [$ ? f2 : i]), at = 0, ht = 0; ht < et.length; ht++)
      at += et[ht].many.length;
    for (var bt = 0, ht = 0; ht < et.length; ht++)
      H2(et[ht], $, bt, at), bt += et[ht].many.length;
  }
  function $H(f2) {
    if (!f2)
      return [];
    if (Za2(f2)) {
      for (var i = [], t2 = 0; t2 < f2.length; t2++)
        i.push($H(f2[t2]));
      return i;
    }
    var h = [];
    return f2.traverse(function(v4) {
      v4 instanceof Uc2 && !v4.disableMorphing && !v4.invisible && !v4.ignore && h.push(v4);
    }), h;
  }
  var Qqe = 1e4, DEr = Wh2();
  function EEr(f2) {
    for (var i = f2.dimensions, t2 = 0; t2 < i.length; t2++) {
      var h = f2.getDimensionInfo(i[t2]);
      if (h && h.otherDims.itemGroupId === 0)
        return i[t2];
    }
  }
  function cBe(f2) {
    var i = [];
    return Qe2(f2, function(t2) {
      var h = t2.data;
      if (!(h.count() > Qqe))
        for (var v4 = h.getIndices(), _ = EEr(h), M2 = 0; M2 < v4.length; M2++)
          i.push({ data: h, dim: t2.dim || _, divide: t2.divide, dataIndex: M2 });
    }), i;
  }
  function QQt(f2, i, t2) {
    f2.traverse(function(h) {
      h instanceof Uc2 && Qv(h, { style: { opacity: 0 } }, i, { dataIndex: t2, isFrom: true });
    });
  }
  function JQt(f2) {
    if (f2.parent) {
      var i = f2.getComputedTransform();
      f2.setLocalTransform(i), f2.parent.remove(f2);
    }
  }
  function mtt(f2) {
    f2.stopAnimation(), f2.isGroup && f2.traverse(function(i) {
      i.stopAnimation();
    });
  }
  function kEr(f2, i, t2) {
    var h = tet("update", t2, i);
    h && f2.traverse(function(v4) {
      if (v4 instanceof rE) {
        var _ = fhr(v4);
        _ && v4.animateFrom({ style: _ }, h);
      }
    });
  }
  function PEr(f2, i) {
    var t2 = f2.length;
    if (t2 !== i.length)
      return false;
    for (var h = 0; h < t2; h++) {
      var v4 = f2[h], _ = i[h];
      if (v4.data.getId(v4.dataIndex) !== _.data.getId(_.dataIndex))
        return false;
    }
    return true;
  }
  function Jqe(f2, i, t2) {
    var h = cBe(f2), v4 = cBe(i);
    function _(_t, Et, zt, Ft, fe2) {
      (zt || _t) && Et.animateFrom({ style: zt && zt !== _t ? ba2(ba2({}, zt.style), _t.style) : _t.style }, fe2);
    }
    function M2(_t) {
      for (var Et = 0; Et < _t.length; Et++)
        if (_t[Et].dim)
          return _t[Et].dim;
    }
    var I2 = M2(h), P2 = M2(v4), N3 = false;
    function z3(_t, Et) {
      return function(zt) {
        var Ft = zt.data, fe2 = zt.dataIndex;
        if (Et)
          return Ft.getId(fe2);
        var re2 = Ft.hostModel && Ft.hostModel.get("dataGroupId"), ye = _t ? I2 || P2 : P2 || I2, me2 = ye && Ft.getDimensionInfo(ye), be2 = me2 && me2.ordinalMeta;
        if (me2) {
          var Te2 = Ft.get(me2.name, fe2);
          return be2 && be2.categories[Te2] || Te2 + "";
        }
        var We = Ft.getRawDataItem(fe2);
        return We && We.groupId ? We.groupId + "" : re2 || Ft.getId(fe2);
      };
    }
    var H2 = PEr(h, v4), $ = {};
    if (!H2)
      for (var et = 0; et < v4.length; et++) {
        var at = v4[et], ht = at.data.getItemGraphicEl(at.dataIndex);
        ht && ($[ht.id] = true);
      }
    function bt(_t, Et) {
      var zt = h[Et], Ft = v4[_t], fe2 = Ft.data.hostModel, re2 = zt.data.getItemGraphicEl(zt.dataIndex), ye = Ft.data.getItemGraphicEl(Ft.dataIndex);
      if (re2 === ye) {
        ye && kEr(ye, Ft.dataIndex, fe2);
        return;
      }
      re2 && $[re2.id] || ye && (mtt(ye), re2 ? (mtt(re2), JQt(re2), N3 = true, XQt($H(re2), $H(ye), Ft.divide, fe2, _t, _)) : QQt(ye, fe2, _t));
    }
    new eN(h, v4, z3(true, H2), z3(false, H2), null, "multiple").update(bt).updateManyToOne(function(_t, Et) {
      var zt = v4[_t], Ft = zt.data, fe2 = Ft.hostModel, re2 = Ft.getItemGraphicEl(zt.dataIndex), ye = Ld2(Xa2(Et, function(me2) {
        return h[me2].data.getItemGraphicEl(h[me2].dataIndex);
      }), function(me2) {
        return me2 && me2 !== re2 && !$[me2.id];
      });
      re2 && (mtt(re2), ye.length ? (Qe2(ye, function(me2) {
        mtt(me2), JQt(me2);
      }), N3 = true, XQt($H(ye), $H(re2), zt.divide, fe2, _t, _)) : QQt(re2, fe2, zt.dataIndex));
    }).updateOneToMany(function(_t, Et) {
      var zt = h[Et], Ft = zt.data.getItemGraphicEl(zt.dataIndex);
      if (!(Ft && $[Ft.id])) {
        var fe2 = Ld2(Xa2(_t, function(ye) {
          return v4[ye].data.getItemGraphicEl(v4[ye].dataIndex);
        }), function(ye) {
          return ye && ye !== Ft;
        }), re2 = v4[_t[0]].data.hostModel;
        fe2.length && (Qe2(fe2, function(ye) {
          return mtt(ye);
        }), Ft ? (mtt(Ft), JQt(Ft), N3 = true, XQt($H(Ft), $H(fe2), zt.divide, re2, _t[0], _)) : Qe2(fe2, function(ye) {
          return QQt(ye, re2, _t[0]);
        }));
      }
    }).updateManyToMany(function(_t, Et) {
      new eN(Et, _t, function(zt) {
        return h[zt].data.getId(h[zt].dataIndex);
      }, function(zt) {
        return v4[zt].data.getId(v4[zt].dataIndex);
      }).update(function(zt, Ft) {
        bt(_t[zt], Et[Ft]);
      }).execute();
    }).execute(), N3 && Qe2(i, function(_t) {
      var Et = _t.data, zt = Et.hostModel, Ft = zt && t2.getViewOfSeriesModel(zt), fe2 = tet("update", zt, 0);
      Ft && zt.isAnimationEnabled() && fe2 && fe2.duration > 0 && Ft.group.traverse(function(re2) {
        re2 instanceof Uc2 && !re2.animators.length && re2.animateFrom({ style: { opacity: 0 } }, fe2);
      });
    });
  }
  function fBe(f2) {
    var i = f2.getModel("universalTransition").get("seriesKey");
    return i || f2.id;
  }
  function hBe(f2) {
    return Za2(f2) ? f2.sort().join(",") : f2;
  }
  function O7(f2) {
    if (f2.hostModel)
      return f2.hostModel.getModel("universalTransition").get("divideShape");
  }
  function LEr(f2, i) {
    var t2 = Il(), h = Il(), v4 = Il();
    return Qe2(f2.oldSeries, function(_, M2) {
      var I2 = f2.oldData[M2], P2 = fBe(_), N3 = hBe(P2);
      h.set(N3, I2), Za2(P2) && Qe2(P2, function(z3) {
        v4.set(z3, { data: I2, key: N3 });
      });
    }), Qe2(i.updatedSeries, function(_) {
      if (_.isUniversalTransitionEnabled() && _.isAnimationEnabled()) {
        var M2 = _.getData(), I2 = fBe(_), P2 = hBe(I2), N3 = h.get(P2);
        if (N3)
          t2.set(P2, { oldSeries: [{ divide: O7(N3), data: N3 }], newSeries: [{ divide: O7(M2), data: M2 }] });
        else if (Za2(I2)) {
          var z3 = [];
          Qe2(I2, function(et) {
            var at = h.get(et);
            at && z3.push({ divide: O7(at), data: at });
          }), z3.length && t2.set(P2, { oldSeries: z3, newSeries: [{ data: M2, divide: O7(M2) }] });
        } else {
          var H2 = v4.get(I2);
          if (H2) {
            var $ = t2.get(H2.key);
            $ || ($ = { oldSeries: [{ data: H2.data, divide: O7(H2.data) }], newSeries: [] }, t2.set(H2.key, $)), $.newSeries.push({ data: M2, divide: O7(M2) });
          }
        }
      }
    }), t2;
  }
  function pBe(f2, i) {
    for (var t2 = 0; t2 < f2.length; t2++) {
      var h = i.seriesIndex != null && i.seriesIndex === f2[t2].seriesIndex || i.seriesId != null && i.seriesId === f2[t2].id;
      if (h)
        return t2;
    }
  }
  function OEr(f2, i, t2, h) {
    var v4 = [], _ = [];
    Qe2(Od2(f2.from), function(M2) {
      var I2 = pBe(i.oldSeries, M2);
      I2 >= 0 && v4.push({ data: i.oldData[I2], divide: O7(i.oldData[I2]), dim: M2.dimension });
    }), Qe2(Od2(f2.to), function(M2) {
      var I2 = pBe(t2.updatedSeries, M2);
      if (I2 >= 0) {
        var P2 = t2.updatedSeries[I2].getData();
        _.push({ data: P2, divide: O7(P2), dim: M2.dimension });
      }
    }), v4.length > 0 && _.length > 0 && Jqe(v4, _, h);
  }
  function REr(f2) {
    f2.registerUpdateLifecycle("series:beforeupdate", function(i, t2, h) {
      Qe2(Od2(h.seriesTransition), function(v4) {
        Qe2(Od2(v4.to), function(_) {
          for (var M2 = h.updatedSeries, I2 = 0; I2 < M2.length; I2++)
            (_.seriesIndex != null && _.seriesIndex === M2[I2].seriesIndex || _.seriesId != null && _.seriesId === M2[I2].id) && (M2[I2][XDt] = true);
        });
      });
    }), f2.registerUpdateLifecycle("series:transition", function(i, t2, h) {
      var v4 = DEr(t2);
      if (v4.oldSeries && h.updatedSeries && h.optionChanged) {
        var _ = h.seriesTransition;
        if (_)
          Qe2(Od2(_), function($) {
            OEr($, v4, h, t2);
          });
        else {
          var M2 = LEr(v4, h);
          Qe2(M2.keys(), function($) {
            var et = M2.get($);
            Jqe(et.oldSeries, et.newSeries, t2);
          });
        }
        Qe2(h.updatedSeries, function($) {
          $[XDt] && ($[XDt] = false);
        });
      }
      for (var I2 = i.getSeries(), P2 = v4.oldSeries = [], N3 = v4.oldData = [], z3 = 0; z3 < I2.length; z3++) {
        var H2 = I2[z3].getData();
        H2.count() < Qqe && (P2.push(I2[z3]), N3.push(H2));
      }
    });
  }
  zc2([J0r]);
  zc2([q0r]);
  zc2([Syr, jyr, Jyr, jmr, i1r, Q1r, Dbr, g_r, G_r, Q_r, uxr, pwr, zwr, tSr, bSr, TSr, HSr, t2r, p2r, x2r, O2r, mMr]);
  zc2(jMr);
  zc2(xCr);
  zc2(ZHe);
  zc2(VCr);
  zc2(OUe);
  zc2(UCr);
  zc2(tTr);
  zc2(eAr);
  zc2(MAr);
  zc2(Ugt);
  zc2(HAr);
  zc2(ZAr);
  zc2(lIr);
  zc2(mIr);
  zc2(TIr);
  zc2(OIr);
  zc2($Ir);
  zc2(vDr);
  zc2(Bqe);
  zc2(zqe);
  zc2(GDr);
  zc2(Uqe);
  zc2(qqe);
  zc2($Dr);
  zc2(sEr);
  zc2(cEr);
  zc2(REr);
  zc2(f0r);
  function NEr(f2) {
    const { defaultOptions: i } = f2 != null ? f2 : {}, t2 = dp.useRef(null), h = dp.useRef(), v4 = dp.useRef(i);
    return dp.useEffect(() => {
      if (!t2.current)
        return;
      const _ = Agr(t2.current);
      h.current = _, v4.current && _.setOption(v4.current);
    }, []), dp.useEffect(() => () => {
      var _, M2, I2, P2;
      (M2 = (_ = h.current) == null ? void 0 : _.dispose) == null || M2.call(_), (P2 = (I2 = h.current) == null ? void 0 : I2.off) == null || P2.call(I2, "*"), h.current = void 0;
    }, []), flr("resize", () => {
      requestAnimationFrame(() => {
        var _, M2;
        (M2 = (_ = h == null ? void 0 : h.current) == null ? void 0 : _.resize) == null || M2.call(_);
      });
    }), { chart: h, container: t2 };
  }
  class FEr {
    constructor() {
      XM(this, "chartsEmitters", /* @__PURE__ */ new Map());
      XM(this, "add", (i, t2, h, v4) => {
        t2 && h ? this.chartsEmitters.set(i, { chart: t2, option: h, title: v4 }) : console.log("\u6DFB\u52A0\u5931\u8D25");
      });
      XM(this, "get", (i) => this.chartsEmitters.get(i));
      XM(this, "clear", () => {
        this.chartsEmitters.clear();
      });
      XM(this, "delete", (i) => {
        this.chartsEmitters.delete(i);
      });
      XM(this, "list", () => {
        var t2, h, v4;
        const i = [];
        for (const _ of this.chartsEmitters.keys())
          i.push({ id: _, chart: (t2 = this.chartsEmitters.get(_)) == null ? void 0 : t2.chart, option: (h = this.chartsEmitters.get(_)) == null ? void 0 : h.option, title: (v4 = this.chartsEmitters.get(_)) == null ? void 0 : v4.title });
        return i;
      });
    }
  }
  const VEr = new FEr();
  var ekt = { exports: {} };
  /**
  * @license
  * Lodash <https://lodash.com/>
  * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
  * Released under MIT license <https://lodash.com/license>
  * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
  * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
  */
  (function(f2, i) {
    (function() {
      var t2, h = "4.17.21", v4 = 200, _ = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", M2 = "Expected a function", I2 = "Invalid `variable` option passed into `_.template`", P2 = "__lodash_hash_undefined__", N3 = 500, z3 = "__lodash_placeholder__", H2 = 1, $ = 2, et = 4, at = 1, ht = 2, bt = 1, _t = 2, Et = 4, zt = 8, Ft = 16, fe2 = 32, re2 = 64, ye = 128, me2 = 256, be2 = 512, Te2 = 30, We = "...", en = 800, Ue2 = 16, Mn = 1, Vn = 2, xn = 3, Zr = 1 / 0, nr = 9007199254740991, pr = 17976931348623157e292, Nr = 0 / 0, ai2 = 4294967295, gi2 = ai2 - 1, To = ai2 >>> 1, us = [["ary", ye], ["bind", bt], ["bindKey", _t], ["curry", zt], ["curryRight", Ft], ["flip", be2], ["partial", fe2], ["partialRight", re2], ["rearg", me2]], ml = "[object Arguments]", ll = "[object Array]", Rs = "[object AsyncFunction]", es = "[object Boolean]", Ws = "[object Date]", il = "[object DOMException]", bs = "[object Error]", Rl = "[object Function]", Mh2 = "[object GeneratorFunction]", au = "[object Map]", eh2 = "[object Number]", Gh2 = "[object Null]", Pp = "[object Object]", zy = "[object Promise]", Rd2 = "[object Proxy]", c1 = "[object RegExp]", _d = "[object Set]", G0 = "[object String]", qg2 = "[object Symbol]", XT = "[object Undefined]", fo = "[object WeakMap]", ra2 = "[object WeakSet]", Ki2 = "[object ArrayBuffer]", ho = "[object DataView]", Bs = "[object Float32Array]", Ql = "[object Float64Array]", ff2 = "[object Int8Array]", hf2 = "[object Int16Array]", qp = "[object Int32Array]", sv = "[object Uint8Array]", lg2 = "[object Uint8ClampedArray]", H0 = "[object Uint16Array]", ug2 = "[object Uint32Array]", gb2 = /\b__p \+= '';/g, x_ = /\b(__p \+=) '' \+/g, W2 = /(__e\(.*?\)|\b__t\)) \+\n'';/g, w_ = /&(?:amp|lt|gt|quot|#39);/g, t0 = /[&<>"']/g, Hh2 = RegExp(w_.source), yy = RegExp(t0.source), f1 = /<%-([\s\S]+?)%>/g, G2 = /<%([\s\S]+?)%>/g, qx = /<%=([\s\S]+?)%>/g, S_ = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, MS = /^\w*$/, E5 = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, sE = /[\\^$.*+?()[\]{}|]/g, uV = RegExp(sE.source), lE = /^\s+/, get2 = /\s/, vet = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, yet = /\{\n\/\* \[wrapped with (.+)\] \*/, met = /,? & /, sN = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, _r = /[()=,{}\[\]\/\s]/, Er = /\\(\\)?/g, Ln = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, cr = /\w*$/, yr = /^[-+]0x[0-9a-f]+$/i, Ui2 = /^0b[01]+$/i, Qa2 = /^\[object .+?Constructor\]$/, Ea2 = /^0o[0-7]+$/i, Ci2 = /^(?:0|[1-9]\d*)$/, Jn = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, $l = /($^)/, $f2 = /['\n\r\u2028\u2029\\]/g, pf2 = "\\ud800-\\udfff", xd2 = "\\u0300-\\u036f", $s = "\\ufe20-\\ufe2f", Zp = "\\u20d0-\\u20ff", lv = xd2 + $s + Zp, Ru = "\\u2700-\\u27bf", U0 = "a-z\\xdf-\\xf6\\xf8-\\xff", M_ = "\\xac\\xb1\\xd7\\xf7", oC = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", lN = "\\u2000-\\u206f", sC = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", Zx = "A-Z\\xc0-\\xd6\\xd8-\\xde", QT = "\\ufe0e\\ufe0f", my = M_ + oC + lN + sC, C_ = "['\u2019]", JT = "[" + pf2 + "]", uE = "[" + my + "]", $L = "[" + lv + "]", cE = "\\d+", cV = "[" + Ru + "]", YL = "[" + U0 + "]", fE = "[^" + pf2 + my + cE + Ru + U0 + Zx + "]", hE = "\\ud83c[\\udffb-\\udfff]", k5 = "(?:" + $L + "|" + hE + ")", uN = "[^" + pf2 + "]", fV = "(?:\\ud83c[\\udde6-\\uddff]){2}", zl = "[\\ud800-\\udbff][\\udc00-\\udfff]", Mu = "[" + Zx + "]", IU = "\\u200d", la2 = "(?:" + YL + "|" + fE + ")", El = "(?:" + Mu + "|" + fE + ")", oc2 = "(?:" + C_ + "(?:d|ll|m|re|s|t|ve))?", Kgt = "(?:" + C_ + "(?:D|LL|M|RE|S|T|VE))?", v0 = k5 + "?", h1 = "[" + QT + "]?", Ke2 = "(?:" + IU + "(?:" + [uN, fV, zl].join("|") + ")" + h1 + v0 + ")*", $a2 = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", tA = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Lp = h1 + v0 + Ke2, a5t = "(?:" + [cV, fV, zl].join("|") + ")" + Lp, Qc2 = "(?:" + [uN + $L + "?", $L, fV, zl, JT].join("|") + ")", o5t = RegExp(C_, "g"), As = RegExp($L, "g"), xu = RegExp(hE + "(?=" + hE + ")|" + Qc2 + Lp, "g"), Ba2 = RegExp([Mu + "?" + YL + "+" + oc2 + "(?=" + [uE, Mu, "$"].join("|") + ")", El + "+" + Kgt + "(?=" + [uE, Mu + la2, "$"].join("|") + ")", Mu + "?" + la2 + "+" + oc2, Mu + "+" + Kgt, tA, $a2, cE, a5t].join("|"), "g"), wl = RegExp("[" + IU + pf2 + lv + QT + "]"), ps = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, bet = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], Ch2 = -1, vs = {};
      vs[Bs] = vs[Ql] = vs[ff2] = vs[hf2] = vs[qp] = vs[sv] = vs[lg2] = vs[H0] = vs[ug2] = true, vs[ml] = vs[ll] = vs[Ki2] = vs[es] = vs[ho] = vs[Ws] = vs[bs] = vs[Rl] = vs[au] = vs[eh2] = vs[Pp] = vs[c1] = vs[_d] = vs[G0] = vs[fo] = false;
      var cg2 = {};
      cg2[ml] = cg2[ll] = cg2[Ki2] = cg2[ho] = cg2[es] = cg2[Ws] = cg2[Bs] = cg2[Ql] = cg2[ff2] = cg2[hf2] = cg2[qp] = cg2[au] = cg2[eh2] = cg2[Pp] = cg2[c1] = cg2[_d] = cg2[G0] = cg2[qg2] = cg2[sv] = cg2[lg2] = cg2[H0] = cg2[ug2] = true, cg2[bs] = cg2[Rl] = cg2[fo] = false;
      var CS = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, hV = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, DU = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, s5t = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, l5t = parseFloat, pV = parseInt, jy = typeof YD == "object" && YD && YD.Object === Object && YD, $u = typeof self == "object" && self && self.Object === Object && self, uv = jy || $u || Function("return this")(), dV = i && !i.nodeType && i, pE = dV && true && f2 && !f2.nodeType && f2, vb2 = pE && pE.exports === dV, TS = vb2 && jy.process, AS = function() {
        try {
          var hi2 = pE && pE.require && pE.require("util").types;
          return hi2 || TS && TS.binding && TS.binding("util");
        } catch {
        }
      }(), gV = AS && AS.isArrayBuffer, cN = AS && AS.isDate, Xgt = AS && AS.isMap, fl = AS && AS.isRegExp, EU = AS && AS.isSet, vV = AS && AS.isTypedArray;
      function $x(hi2, io, Sa2) {
        switch (Sa2.length) {
          case 0:
            return hi2.call(io);
          case 1:
            return hi2.call(io, Sa2[0]);
          case 2:
            return hi2.call(io, Sa2[0], Sa2[1]);
          case 3:
            return hi2.call(io, Sa2[0], Sa2[1], Sa2[2]);
        }
        return hi2.apply(io, Sa2);
      }
      function Ns(hi2, io, Sa2, Nl) {
        for (var Jc2 = -1, Yp = hi2 == null ? 0 : hi2.length; ++Jc2 < Yp; ) {
          var e0 = hi2[Jc2];
          io(Nl, e0, Sa2(e0), hi2);
        }
        return Nl;
      }
      function $p(hi2, io) {
        for (var Sa2 = -1, Nl = hi2 == null ? 0 : hi2.length; ++Sa2 < Nl && io(hi2[Sa2], Sa2, hi2) !== false; )
          ;
        return hi2;
      }
      function kU(hi2, io) {
        for (var Sa2 = hi2 == null ? 0 : hi2.length; Sa2-- && io(hi2[Sa2], Sa2, hi2) !== false; )
          ;
        return hi2;
      }
      function P5(hi2, io) {
        for (var Sa2 = -1, Nl = hi2 == null ? 0 : hi2.length; ++Sa2 < Nl; )
          if (!io(hi2[Sa2], Sa2, hi2))
            return false;
        return true;
      }
      function y0(hi2, io) {
        for (var Sa2 = -1, Nl = hi2 == null ? 0 : hi2.length, Jc2 = 0, Yp = []; ++Sa2 < Nl; ) {
          var e0 = hi2[Sa2];
          io(e0, Sa2, hi2) && (Yp[Jc2++] = e0);
        }
        return Yp;
      }
      function H22(hi2, io) {
        var Sa2 = hi2 == null ? 0 : hi2.length;
        return !!Sa2 && U2(hi2, io, 0) > -1;
      }
      function _et(hi2, io, Sa2) {
        for (var Nl = -1, Jc2 = hi2 == null ? 0 : hi2.length; ++Nl < Jc2; )
          if (Sa2(io, hi2[Nl]))
            return true;
        return false;
      }
      function cv(hi2, io) {
        for (var Sa2 = -1, Nl = hi2 == null ? 0 : hi2.length, Jc2 = Array(Nl); ++Sa2 < Nl; )
          Jc2[Sa2] = io(hi2[Sa2], Sa2, hi2);
        return Jc2;
      }
      function eA(hi2, io) {
        for (var Sa2 = -1, Nl = io.length, Jc2 = hi2.length; ++Sa2 < Nl; )
          hi2[Jc2 + Sa2] = io[Sa2];
        return hi2;
      }
      function dE(hi2, io, Sa2, Nl) {
        var Jc2 = -1, Yp = hi2 == null ? 0 : hi2.length;
        for (Nl && Yp && (Sa2 = hi2[++Jc2]); ++Jc2 < Yp; )
          Sa2 = io(Sa2, hi2[Jc2], Jc2, hi2);
        return Sa2;
      }
      function xet(hi2, io, Sa2, Nl) {
        var Jc2 = hi2 == null ? 0 : hi2.length;
        for (Nl && Jc2 && (Sa2 = hi2[--Jc2]); Jc2--; )
          Sa2 = io(Sa2, hi2[Jc2], Jc2, hi2);
        return Sa2;
      }
      function wet(hi2, io) {
        for (var Sa2 = -1, Nl = hi2 == null ? 0 : hi2.length; ++Sa2 < Nl; )
          if (io(hi2[Sa2], Sa2, hi2))
            return true;
        return false;
      }
      var Met = nA("length");
      function yV(hi2) {
        return hi2.split("");
      }
      function Cet(hi2) {
        return hi2.match(sN) || [];
      }
      function gE(hi2, io, Sa2) {
        var Nl;
        return Sa2(hi2, function(Jc2, Yp, e0) {
          if (io(Jc2, Yp, e0))
            return Nl = Yp, false;
        }), Nl;
      }
      function PU(hi2, io, Sa2, Nl) {
        for (var Jc2 = hi2.length, Yp = Sa2 + (Nl ? 1 : -1); Nl ? Yp-- : ++Yp < Jc2; )
          if (io(hi2[Yp], Yp, hi2))
            return Yp;
        return -1;
      }
      function U2(hi2, io, Sa2) {
        return io === io ? yE(hi2, io, Sa2) : PU(hi2, Mm, Sa2);
      }
      function LU(hi2, io, Sa2, Nl) {
        for (var Jc2 = Sa2 - 1, Yp = hi2.length; ++Jc2 < Yp; )
          if (Nl(hi2[Jc2], io))
            return Jc2;
        return -1;
      }
      function Mm(hi2) {
        return hi2 !== hi2;
      }
      function vE(hi2, io) {
        var Sa2 = hi2 == null ? 0 : hi2.length;
        return Sa2 ? Tet(hi2, io) / Sa2 : Nr;
      }
      function nA(hi2) {
        return function(io) {
          return io == null ? t2 : io[hi2];
        };
      }
      function L5(hi2) {
        return function(io) {
          return hi2 == null ? t2 : hi2[io];
        };
      }
      function Qgt(hi2, io, Sa2, Nl, Jc2) {
        return Jc2(hi2, function(Yp, e0, fg2) {
          Sa2 = Nl ? (Nl = false, Yp) : io(Sa2, Yp, e0, fg2);
        }), Sa2;
      }
      function u5t(hi2, io) {
        var Sa2 = hi2.length;
        for (hi2.sort(io); Sa2--; )
          hi2[Sa2] = hi2[Sa2].value;
        return hi2;
      }
      function Tet(hi2, io) {
        for (var Sa2, Nl = -1, Jc2 = hi2.length; ++Nl < Jc2; ) {
          var Yp = io(hi2[Nl]);
          Yp !== t2 && (Sa2 = Sa2 === t2 ? Yp : Sa2 + Yp);
        }
        return Sa2;
      }
      function Yx(hi2, io) {
        for (var Sa2 = -1, Nl = Array(hi2); ++Sa2 < hi2; )
          Nl[Sa2] = io(Sa2);
        return Nl;
      }
      function c5t(hi2, io) {
        return cv(io, function(Sa2) {
          return [Sa2, hi2[Sa2]];
        });
      }
      function OU(hi2) {
        return hi2 && hi2.slice(0, rvt(hi2) + 1).replace(lE, "");
      }
      function Kx(hi2) {
        return function(io) {
          return hi2(io);
        };
      }
      function RU(hi2, io) {
        return cv(io, function(Sa2) {
          return hi2[Sa2];
        });
      }
      function KL(hi2, io) {
        return hi2.has(io);
      }
      function Jgt(hi2, io) {
        for (var Sa2 = -1, Nl = hi2.length; ++Sa2 < Nl && U2(io, hi2[Sa2], 0) > -1; )
          ;
        return Sa2;
      }
      function NU(hi2, io) {
        for (var Sa2 = hi2.length; Sa2-- && U2(io, hi2[Sa2], 0) > -1; )
          ;
        return Sa2;
      }
      function f5t(hi2, io) {
        for (var Sa2 = hi2.length, Nl = 0; Sa2--; )
          hi2[Sa2] === io && ++Nl;
        return Nl;
      }
      var h5t = L5(CS), tvt = L5(hV);
      function p5t(hi2) {
        return "\\" + s5t[hi2];
      }
      function Aet(hi2, io) {
        return hi2 == null ? t2 : hi2[io];
      }
      function fN(hi2) {
        return wl.test(hi2);
      }
      function Iet(hi2) {
        return ps.test(hi2);
      }
      function evt(hi2) {
        for (var io, Sa2 = []; !(io = hi2.next()).done; )
          Sa2.push(io.value);
        return Sa2;
      }
      function mV(hi2) {
        var io = -1, Sa2 = Array(hi2.size);
        return hi2.forEach(function(Nl, Jc2) {
          Sa2[++io] = [Jc2, Nl];
        }), Sa2;
      }
      function IS(hi2, io) {
        return function(Sa2) {
          return hi2(io(Sa2));
        };
      }
      function O5(hi2, io) {
        for (var Sa2 = -1, Nl = hi2.length, Jc2 = 0, Yp = []; ++Sa2 < Nl; ) {
          var e0 = hi2[Sa2];
          (e0 === io || e0 === z3) && (hi2[Sa2] = z3, Yp[Jc2++] = Sa2);
        }
        return Yp;
      }
      function hN(hi2) {
        var io = -1, Sa2 = Array(hi2.size);
        return hi2.forEach(function(Nl) {
          Sa2[++io] = Nl;
        }), Sa2;
      }
      function d5t(hi2) {
        var io = -1, Sa2 = Array(hi2.size);
        return hi2.forEach(function(Nl) {
          Sa2[++io] = [Nl, Nl];
        }), Sa2;
      }
      function yE(hi2, io, Sa2) {
        for (var Nl = Sa2 - 1, Jc2 = hi2.length; ++Nl < Jc2; )
          if (hi2[Nl] === io)
            return Nl;
        return -1;
      }
      function nvt(hi2, io, Sa2) {
        for (var Nl = Sa2 + 1; Nl--; )
          if (hi2[Nl] === io)
            return Nl;
        return Nl;
      }
      function pN(hi2) {
        return fN(hi2) ? ivt(hi2) : Met(hi2);
      }
      function q2(hi2) {
        return fN(hi2) ? g5t(hi2) : yV(hi2);
      }
      function rvt(hi2) {
        for (var io = hi2.length; io-- && get2.test(hi2.charAt(io)); )
          ;
        return io;
      }
      var Det = L5(DU);
      function ivt(hi2) {
        for (var io = xu.lastIndex = 0; xu.test(hi2); )
          ++io;
        return io;
      }
      function g5t(hi2) {
        return hi2.match(xu) || [];
      }
      function v5t(hi2) {
        return hi2.match(Ba2) || [];
      }
      var y5t = function hi2(io) {
        io = io == null ? uv : rA.defaults(uv.Object(), io, rA.pick(uv, bet));
        var Sa2 = io.Array, Nl = io.Date, Jc2 = io.Error, Yp = io.Function, e0 = io.Math, fg2 = io.Object, FU = io.RegExp, m5t = io.String, DS = io.TypeError, dN = Sa2.prototype, Eet = Yp.prototype, gN = fg2.prototype, XL = io["__core-js_shared__"], yb2 = Eet.toString, Op = gN.hasOwnProperty, vN = 0, ket = function() {
          var lt2 = /[^.]+$/.exec(XL && XL.keys && XL.keys.IE_PROTO || "");
          return lt2 ? "Symbol(src)_1." + lt2 : "";
        }(), yN = gN.toString, avt = yb2.call(fg2), b5t = uv._, _5t = FU("^" + yb2.call(Op).replace(sE, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), bV = vb2 ? io.Buffer : t2, iA = io.Symbol, QL = io.Uint8Array, Pet = bV ? bV.allocUnsafe : t2, JL = IS(fg2.getPrototypeOf, fg2), mE = fg2.create, _V = gN.propertyIsEnumerable, xV = dN.splice, Let = iA ? iA.isConcatSpreadable : t2, R5 = iA ? iA.iterator : t2, mb2 = iA ? iA.toStringTag : t2, T_ = function() {
          try {
            var lt2 = RS(fg2, "defineProperty");
            return lt2({}, "", {}), lt2;
          } catch {
          }
        }(), mN = io.clearTimeout !== uv.clearTimeout && io.clearTimeout, N5 = Nl && Nl.now !== uv.Date.now && Nl.now, ovt = io.setTimeout !== uv.setTimeout && io.setTimeout, m0 = e0.ceil, wV = e0.floor, bN = fg2.getOwnPropertySymbols, svt = bV ? bV.isBuffer : t2, bE = io.isFinite, lvt = dN.join, x5t = IS(fg2.keys, fg2), sp = e0.max, Cm = e0.min, w5t = Nl.now, uvt = io.parseInt, _N = e0.random, cvt = dN.reverse, Oet = RS(io, "DataView"), SV = RS(io, "Map"), MV = RS(io, "Promise"), xN = RS(io, "Set"), CV = RS(io, "WeakMap"), wN = RS(fg2, "create"), VU = CV && new CV(), SN = {}, TV = CE(Oet), fvt = CE(SV), lC = CE(MV), S5t = CE(xN), AV = CE(CV), MN = iA ? iA.prototype : t2, aA = MN ? MN.valueOf : t2, BU = MN ? MN.toString : t2;
        function In(lt2) {
          if ($g2(lt2) && !ns(lt2) && !(lt2 instanceof nh2)) {
            if (lt2 instanceof ES)
              return lt2;
            if (Op.call(lt2, "__wrapped__"))
              return unt(lt2);
          }
          return new ES(lt2);
        }
        var p1 = function() {
          function lt2() {
          }
          return function(wt) {
            if (!Zg2(wt))
              return {};
            if (mE)
              return mE(wt);
            lt2.prototype = wt;
            var Jt = new lt2();
            return lt2.prototype = t2, Jt;
          };
        }();
        function CN() {
        }
        function ES(lt2, wt) {
          this.__wrapped__ = lt2, this.__actions__ = [], this.__chain__ = !!wt, this.__index__ = 0, this.__values__ = t2;
        }
        In.templateSettings = { escape: f1, evaluate: G2, interpolate: qx, variable: "", imports: { _: In } }, In.prototype = CN.prototype, In.prototype.constructor = In, ES.prototype = p1(CN.prototype), ES.prototype.constructor = ES;
        function nh2(lt2) {
          this.__wrapped__ = lt2, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = ai2, this.__views__ = [];
        }
        function TN() {
          var lt2 = new nh2(this.__wrapped__);
          return lt2.__actions__ = E_(this.__actions__), lt2.__dir__ = this.__dir__, lt2.__filtered__ = this.__filtered__, lt2.__iteratees__ = E_(this.__iteratees__), lt2.__takeCount__ = this.__takeCount__, lt2.__views__ = E_(this.__views__), lt2;
        }
        function kS() {
          if (this.__filtered__) {
            var lt2 = new nh2(this);
            lt2.__dir__ = -1, lt2.__filtered__ = true;
          } else
            lt2 = this.clone(), lt2.__dir__ *= -1;
          return lt2;
        }
        function Ret() {
          var lt2 = this.__wrapped__.value(), wt = this.__dir__, Jt = ns(lt2), Ee2 = wt < 0, sn = Jt ? lt2.length : 0, Hn = W5t(0, sn, this.__views__), Fr = Hn.start, $r = Hn.end, ki2 = $r - Fr, Ja2 = Ee2 ? $r : Fr - 1, Io = this.__iteratees__, Xo = Io.length, ul = 0, su = Cm(ki2, this.__takeCount__);
          if (!Jt || !Ee2 && sn == ki2 && su == ki2)
            return Qet(lt2, this.__actions__);
          var Eu = [];
          t:
            for (; ki2-- && ul < su; ) {
              Ja2 += wt;
              for (var hc2 = -1, Wu = lt2[Ja2]; ++hc2 < Xo; ) {
                var Th2 = Io[hc2], mp = Th2.iteratee, m1 = Th2.type, wb2 = mp(Wu);
                if (m1 == Vn)
                  Wu = wb2;
                else if (!wb2) {
                  if (m1 == Mn)
                    continue t;
                  break t;
                }
              }
              Eu[ul++] = Wu;
            }
          return Eu;
        }
        nh2.prototype = p1(CN.prototype), nh2.prototype.constructor = nh2;
        function tO(lt2) {
          var wt = -1, Jt = lt2 == null ? 0 : lt2.length;
          for (this.clear(); ++wt < Jt; ) {
            var Ee2 = lt2[wt];
            this.set(Ee2[0], Ee2[1]);
          }
        }
        function Net() {
          this.__data__ = wN ? wN(null) : {}, this.size = 0;
        }
        function Fet(lt2) {
          var wt = this.has(lt2) && delete this.__data__[lt2];
          return this.size -= wt ? 1 : 0, wt;
        }
        function M5t(lt2) {
          var wt = this.__data__;
          if (wN) {
            var Jt = wt[lt2];
            return Jt === P2 ? t2 : Jt;
          }
          return Op.call(wt, lt2) ? wt[lt2] : t2;
        }
        function IV(lt2) {
          var wt = this.__data__;
          return wN ? wt[lt2] !== t2 : Op.call(wt, lt2);
        }
        function zU(lt2, wt) {
          var Jt = this.__data__;
          return this.size += this.has(lt2) ? 0 : 1, Jt[lt2] = wN && wt === t2 ? P2 : wt, this;
        }
        tO.prototype.clear = Net, tO.prototype.delete = Fet, tO.prototype.get = M5t, tO.prototype.has = IV, tO.prototype.set = zU;
        function d1(lt2) {
          var wt = -1, Jt = lt2 == null ? 0 : lt2.length;
          for (this.clear(); ++wt < Jt; ) {
            var Ee2 = lt2[wt];
            this.set(Ee2[0], Ee2[1]);
          }
        }
        function jU() {
          this.__data__ = [], this.size = 0;
        }
        function WU(lt2) {
          var wt = this.__data__, Jt = nO(wt, lt2);
          if (Jt < 0)
            return false;
          var Ee2 = wt.length - 1;
          return Jt == Ee2 ? wt.pop() : xV.call(wt, Jt, 1), --this.size, true;
        }
        function AN(lt2) {
          var wt = this.__data__, Jt = nO(wt, lt2);
          return Jt < 0 ? t2 : wt[Jt][1];
        }
        function hvt(lt2) {
          return nO(this.__data__, lt2) > -1;
        }
        function F5(lt2, wt) {
          var Jt = this.__data__, Ee2 = nO(Jt, lt2);
          return Ee2 < 0 ? (++this.size, Jt.push([lt2, wt])) : Jt[Ee2][1] = wt, this;
        }
        d1.prototype.clear = jU, d1.prototype.delete = WU, d1.prototype.get = AN, d1.prototype.has = hvt, d1.prototype.set = F5;
        function Z2(lt2) {
          var wt = -1, Jt = lt2 == null ? 0 : lt2.length;
          for (this.clear(); ++wt < Jt; ) {
            var Ee2 = lt2[wt];
            this.set(Ee2[0], Ee2[1]);
          }
        }
        function Vet() {
          this.size = 0, this.__data__ = { hash: new tO(), map: new (SV || d1)(), string: new tO() };
        }
        function C5t(lt2) {
          var wt = NV(this, lt2).delete(lt2);
          return this.size -= wt ? 1 : 0, wt;
        }
        function T5t(lt2) {
          return NV(this, lt2).get(lt2);
        }
        function A5t(lt2) {
          return NV(this, lt2).has(lt2);
        }
        function I5t(lt2, wt) {
          var Jt = NV(this, lt2), Ee2 = Jt.size;
          return Jt.set(lt2, wt), this.size += Jt.size == Ee2 ? 0 : 1, this;
        }
        Z2.prototype.clear = Vet, Z2.prototype.delete = C5t, Z2.prototype.get = T5t, Z2.prototype.has = A5t, Z2.prototype.set = I5t;
        function eO(lt2) {
          var wt = -1, Jt = lt2 == null ? 0 : lt2.length;
          for (this.__data__ = new Z2(); ++wt < Jt; )
            this.add(lt2[wt]);
        }
        function pvt(lt2) {
          return this.__data__.set(lt2, P2), this;
        }
        function D5t(lt2) {
          return this.__data__.has(lt2);
        }
        eO.prototype.add = eO.prototype.push = pvt, eO.prototype.has = D5t;
        function uC(lt2) {
          var wt = this.__data__ = new d1(lt2);
          this.size = wt.size;
        }
        function dvt() {
          this.__data__ = new d1(), this.size = 0;
        }
        function gvt(lt2) {
          var wt = this.__data__, Jt = wt.delete(lt2);
          return this.size = wt.size, Jt;
        }
        function E5t(lt2) {
          return this.__data__.get(lt2);
        }
        function GU(lt2) {
          return this.__data__.has(lt2);
        }
        function vvt(lt2, wt) {
          var Jt = this.__data__;
          if (Jt instanceof d1) {
            var Ee2 = Jt.__data__;
            if (!SV || Ee2.length < v4 - 1)
              return Ee2.push([lt2, wt]), this.size = ++Jt.size, this;
            Jt = this.__data__ = new Z2(Ee2);
          }
          return Jt.set(lt2, wt), this.size = Jt.size, this;
        }
        uC.prototype.clear = dvt, uC.prototype.delete = gvt, uC.prototype.get = E5t, uC.prototype.has = GU, uC.prototype.set = vvt;
        function Bet(lt2, wt) {
          var Jt = ns(lt2), Ee2 = !Jt && qc2(lt2), sn = !Jt && !Ee2 && mA(lt2), Hn = !Jt && !Ee2 && !sn && BN(lt2), Fr = Jt || Ee2 || sn || Hn, $r = Fr ? Yx(lt2.length, m5t) : [], ki2 = $r.length;
          for (var Ja2 in lt2)
            (wt || Op.call(lt2, Ja2)) && !(Fr && (Ja2 == "length" || sn && (Ja2 == "offset" || Ja2 == "parent") || Hn && (Ja2 == "buffer" || Ja2 == "byteLength" || Ja2 == "byteOffset") || Ud2(Ja2, ki2))) && $r.push(Ja2);
          return $r;
        }
        function yvt(lt2) {
          var wt = lt2.length;
          return wt ? lt2[j5(0, wt - 1)] : t2;
        }
        function zet(lt2, wt) {
          return NS(E_(lt2), rO(wt, 0, lt2.length));
        }
        function _E(lt2) {
          return NS(E_(lt2));
        }
        function DV(lt2, wt, Jt) {
          (Jt !== t2 && !X2(lt2[wt], Jt) || Jt === t2 && !(wt in lt2)) && PS(lt2, wt, Jt);
        }
        function EV(lt2, wt, Jt) {
          var Ee2 = lt2[wt];
          (!(Op.call(lt2, wt) && X2(Ee2, Jt)) || Jt === t2 && !(wt in lt2)) && PS(lt2, wt, Jt);
        }
        function nO(lt2, wt) {
          for (var Jt = lt2.length; Jt--; )
            if (X2(lt2[Jt][0], wt))
              return Jt;
          return -1;
        }
        function mvt(lt2, wt, Jt, Ee2) {
          return oA(lt2, function(sn, Hn, Fr) {
            wt(Ee2, sn, Jt(sn), Fr);
          }), Ee2;
        }
        function bvt(lt2, wt) {
          return lt2 && cC(wt, Hy(wt), lt2);
        }
        function k5t(lt2, wt) {
          return lt2 && cC(wt, ew(wt), lt2);
        }
        function PS(lt2, wt, Jt) {
          wt == "__proto__" && T_ ? T_(lt2, wt, { configurable: true, enumerable: true, value: Jt, writable: true }) : lt2[wt] = Jt;
        }
        function IN(lt2, wt) {
          for (var Jt = -1, Ee2 = wt.length, sn = Sa2(Ee2), Hn = lt2 == null; ++Jt < Ee2; )
            sn[Jt] = Hn ? t2 : Gy(lt2, wt[Jt]);
          return sn;
        }
        function rO(lt2, wt, Jt) {
          return lt2 === lt2 && (Jt !== t2 && (lt2 = lt2 <= Jt ? lt2 : Jt), wt !== t2 && (lt2 = lt2 >= wt ? lt2 : wt)), lt2;
        }
        function A_(lt2, wt, Jt, Ee2, sn, Hn) {
          var Fr, $r = wt & H2, ki2 = wt & $, Ja2 = wt & et;
          if (Jt && (Fr = sn ? Jt(lt2, Ee2, sn, Hn) : Jt(lt2)), Fr !== t2)
            return Fr;
          if (!Zg2(lt2))
            return lt2;
          var Io = ns(lt2);
          if (Io) {
            if (Fr = H5t(lt2), !$r)
              return E_(lt2, Fr);
          } else {
            var Xo = v12(lt2), ul = Xo == Rl || Xo == Mh2;
            if (mA(lt2))
              return Dvt(lt2, $r);
            if (Xo == Pp || Xo == ml || ul && !sn) {
              if (Fr = ki2 || ul ? {} : Zvt(lt2), !$r)
                return ki2 ? ou(lt2, k5t(Fr, lt2)) : Lvt(lt2, bvt(Fr, lt2));
            } else {
              if (!cg2[Xo])
                return sn ? lt2 : {};
              Fr = U5t(lt2, Xo, $r);
            }
          }
          Hn || (Hn = new uC());
          var su = Hn.get(lt2);
          if (su)
            return su;
          Hn.set(lt2, Fr), bA(lt2) ? lt2.forEach(function(Wu) {
            Fr.add(A_(Wu, wt, Jt, Wu, lt2, Hn));
          }) : xO(lt2) && lt2.forEach(function(Wu, Th2) {
            Fr.set(Th2, A_(Wu, wt, Jt, Th2, lt2, Hn));
          });
          var Eu = Ja2 ? ki2 ? lq : sq : ki2 ? ew : Hy, hc2 = Io ? t2 : Eu(lt2);
          return $p(hc2 || lt2, function(Wu, Th2) {
            hc2 && (Th2 = Wu, Wu = lt2[Th2]), EV(Fr, Th2, A_(Wu, wt, Jt, Th2, lt2, Hn));
          }), Fr;
        }
        function HU(lt2) {
          var wt = Hy(lt2);
          return function(Jt) {
            return jet(Jt, lt2, wt);
          };
        }
        function jet(lt2, wt, Jt) {
          var Ee2 = Jt.length;
          if (lt2 == null)
            return !Ee2;
          for (lt2 = fg2(lt2); Ee2--; ) {
            var sn = Jt[Ee2], Hn = wt[sn], Fr = lt2[sn];
            if (Fr === t2 && !(sn in lt2) || !Hn(Fr))
              return false;
          }
          return true;
        }
        function DN(lt2, wt, Jt) {
          if (typeof lt2 != "function")
            throw new DS(M2);
          return FN(function() {
            lt2.apply(t2, Jt);
          }, wt);
        }
        function iO(lt2, wt, Jt, Ee2) {
          var sn = -1, Hn = H22, Fr = true, $r = lt2.length, ki2 = [], Ja2 = wt.length;
          if (!$r)
            return ki2;
          Jt && (wt = cv(wt, Kx(Jt))), Ee2 ? (Hn = _et, Fr = false) : wt.length >= v4 && (Hn = KL, Fr = false, wt = new eO(wt));
          t:
            for (; ++sn < $r; ) {
              var Io = lt2[sn], Xo = Jt == null ? Io : Jt(Io);
              if (Io = Ee2 || Io !== 0 ? Io : 0, Fr && Xo === Xo) {
                for (var ul = Ja2; ul--; )
                  if (wt[ul] === Xo)
                    continue t;
                ki2.push(Io);
              } else
                Hn(wt, Xo, Ee2) || ki2.push(Io);
            }
          return ki2;
        }
        var oA = Ovt(sA), Wet = Ovt(Get, true);
        function _vt(lt2, wt) {
          var Jt = true;
          return oA(lt2, function(Ee2, sn, Hn) {
            return Jt = !!wt(Ee2, sn, Hn), Jt;
          }), Jt;
        }
        function aO(lt2, wt, Jt) {
          for (var Ee2 = -1, sn = lt2.length; ++Ee2 < sn; ) {
            var Hn = lt2[Ee2], Fr = wt(Hn);
            if (Fr != null && ($r === t2 ? Fr === Fr && !FS(Fr) : Jt(Fr, $r)))
              var $r = Fr, ki2 = Hn;
          }
          return ki2;
        }
        function kV(lt2, wt, Jt, Ee2) {
          var sn = lt2.length;
          for (Jt = fc2(Jt), Jt < 0 && (Jt = -Jt > sn ? 0 : sn + Jt), Ee2 = Ee2 === t2 || Ee2 > sn ? sn : fc2(Ee2), Ee2 < 0 && (Ee2 += sn), Ee2 = Jt > Ee2 ? 0 : Fnt(Ee2); Jt < Ee2; )
            lt2[Jt++] = wt;
          return lt2;
        }
        function xvt(lt2, wt) {
          var Jt = [];
          return oA(lt2, function(Ee2, sn, Hn) {
            wt(Ee2, sn, Hn) && Jt.push(Ee2);
          }), Jt;
        }
        function Wy(lt2, wt, Jt, Ee2, sn) {
          var Hn = -1, Fr = lt2.length;
          for (Jt || (Jt = FV), sn || (sn = []); ++Hn < Fr; ) {
            var $r = lt2[Hn];
            wt > 0 && Jt($r) ? wt > 1 ? Wy($r, wt - 1, Jt, Ee2, sn) : eA(sn, $r) : Ee2 || (sn[sn.length] = $r);
          }
          return sn;
        }
        var V5 = Rvt(), wvt = Rvt(true);
        function sA(lt2, wt) {
          return lt2 && V5(lt2, wt, Hy);
        }
        function Get(lt2, wt) {
          return lt2 && wvt(lt2, wt, Hy);
        }
        function EN(lt2, wt) {
          return y0(wt, function(Jt) {
            return R_(lt2[Jt]);
          });
        }
        function xE(lt2, wt) {
          wt = Tm(wt, lt2);
          for (var Jt = 0, Ee2 = wt.length; lt2 != null && Jt < Ee2; )
            lt2 = lt2[pA(wt[Jt++])];
          return Jt && Jt == Ee2 ? lt2 : t2;
        }
        function Het(lt2, wt, Jt) {
          var Ee2 = wt(lt2);
          return ns(lt2) ? Ee2 : eA(Ee2, Jt(lt2));
        }
        function bb2(lt2) {
          return lt2 == null ? lt2 === t2 ? XT : Gh2 : mb2 && mb2 in fg2(lt2) ? Hvt(lt2) : Y5t(lt2);
        }
        function PV(lt2, wt) {
          return lt2 > wt;
        }
        function P5t(lt2, wt) {
          return lt2 != null && Op.call(lt2, wt);
        }
        function Uet(lt2, wt) {
          return lt2 != null && wt in fg2(lt2);
        }
        function L5t(lt2, wt, Jt) {
          return lt2 >= Cm(wt, Jt) && lt2 < sp(wt, Jt);
        }
        function UU(lt2, wt, Jt) {
          for (var Ee2 = Jt ? _et : H22, sn = lt2[0].length, Hn = lt2.length, Fr = Hn, $r = Sa2(Hn), ki2 = 1 / 0, Ja2 = []; Fr--; ) {
            var Io = lt2[Fr];
            Fr && wt && (Io = cv(Io, Kx(wt))), ki2 = Cm(Io.length, ki2), $r[Fr] = !Jt && (wt || sn >= 120 && Io.length >= 120) ? new eO(Fr && Io) : t2;
          }
          Io = lt2[0];
          var Xo = -1, ul = $r[0];
          t:
            for (; ++Xo < sn && Ja2.length < ki2; ) {
              var su = Io[Xo], Eu = wt ? wt(su) : su;
              if (su = Jt || su !== 0 ? su : 0, !(ul ? KL(ul, Eu) : Ee2(Ja2, Eu, Jt))) {
                for (Fr = Hn; --Fr; ) {
                  var hc2 = $r[Fr];
                  if (!(hc2 ? KL(hc2, Eu) : Ee2(lt2[Fr], Eu, Jt)))
                    continue t;
                }
                ul && ul.push(Eu), Ja2.push(su);
              }
            }
          return Ja2;
        }
        function O5t(lt2, wt, Jt, Ee2) {
          return sA(lt2, function(sn, Hn, Fr) {
            wt(Ee2, Jt(sn), Hn, Fr);
          }), Ee2;
        }
        function I_(lt2, wt, Jt) {
          wt = Tm(wt, lt2), lt2 = ant(lt2, wt);
          var Ee2 = lt2 == null ? lt2 : lt2[pA(Qx(wt))];
          return Ee2 == null ? t2 : $x(Ee2, lt2, Jt);
        }
        function qU(lt2) {
          return $g2(lt2) && bb2(lt2) == ml;
        }
        function R5t(lt2) {
          return $g2(lt2) && bb2(lt2) == Ki2;
        }
        function N5t(lt2) {
          return $g2(lt2) && bb2(lt2) == Ws;
        }
        function B5(lt2, wt, Jt, Ee2, sn) {
          return lt2 === wt ? true : lt2 == null || wt == null || !$g2(lt2) && !$g2(wt) ? lt2 !== lt2 && wt !== wt : qet(lt2, wt, Jt, Ee2, B5, sn);
        }
        function qet(lt2, wt, Jt, Ee2, sn, Hn) {
          var Fr = ns(lt2), $r = ns(wt), ki2 = Fr ? ll : v12(lt2), Ja2 = $r ? ll : v12(wt);
          ki2 = ki2 == ml ? Pp : ki2, Ja2 = Ja2 == ml ? Pp : Ja2;
          var Io = ki2 == Pp, Xo = Ja2 == Pp, ul = ki2 == Ja2;
          if (ul && mA(lt2)) {
            if (!mA(wt))
              return false;
            Fr = true, Io = false;
          }
          if (ul && !Io)
            return Hn || (Hn = new uC()), Fr || BN(lt2) ? oq(lt2, wt, Jt, Ee2, sn, Hn) : Gvt(lt2, wt, ki2, Jt, Ee2, sn, Hn);
          if (!(Jt & at)) {
            var su = Io && Op.call(lt2, "__wrapped__"), Eu = Xo && Op.call(wt, "__wrapped__");
            if (su || Eu) {
              var hc2 = su ? lt2.value() : lt2, Wu = Eu ? wt.value() : wt;
              return Hn || (Hn = new uC()), sn(hc2, Wu, Jt, Ee2, Hn);
            }
          }
          return ul ? (Hn || (Hn = new uC()), ME(lt2, wt, Jt, Ee2, sn, Hn)) : false;
        }
        function Svt(lt2) {
          return $g2(lt2) && v12(lt2) == au;
        }
        function Zet(lt2, wt, Jt, Ee2) {
          var sn = Jt.length, Hn = sn, Fr = !Ee2;
          if (lt2 == null)
            return !Hn;
          for (lt2 = fg2(lt2); sn--; ) {
            var $r = Jt[sn];
            if (Fr && $r[2] ? $r[1] !== lt2[$r[0]] : !($r[0] in lt2))
              return false;
          }
          for (; ++sn < Hn; ) {
            $r = Jt[sn];
            var ki2 = $r[0], Ja2 = lt2[ki2], Io = $r[1];
            if (Fr && $r[2]) {
              if (Ja2 === t2 && !(ki2 in lt2))
                return false;
            } else {
              var Xo = new uC();
              if (Ee2)
                var ul = Ee2(Ja2, Io, ki2, lt2, wt, Xo);
              if (!(ul === t2 ? B5(Io, Ja2, at | ht, Ee2, Xo) : ul))
                return false;
            }
          }
          return true;
        }
        function Mvt(lt2) {
          if (!Zg2(lt2) || Z5t(lt2))
            return false;
          var wt = R_(lt2) ? _5t : Qa2;
          return wt.test(CE(lt2));
        }
        function Cvt(lt2) {
          return $g2(lt2) && bb2(lt2) == c1;
        }
        function ZU(lt2) {
          return $g2(lt2) && v12(lt2) == _d;
        }
        function $et(lt2) {
          return $g2(lt2) && rP(lt2.length) && !!vs[bb2(lt2)];
        }
        function $U(lt2) {
          return typeof lt2 == "function" ? lt2 : lt2 == null ? N_ : typeof lt2 == "object" ? ns(lt2) ? lA(lt2[0], lt2[1]) : YU(lt2) : trt(lt2);
        }
        function LV(lt2) {
          if (!fC(lt2))
            return x5t(lt2);
          var wt = [];
          for (var Jt in fg2(lt2))
            Op.call(lt2, Jt) && Jt != "constructor" && wt.push(Jt);
          return wt;
        }
        function F5t(lt2) {
          if (!Zg2(lt2))
            return q0(lt2);
          var wt = fC(lt2), Jt = [];
          for (var Ee2 in lt2)
            Ee2 == "constructor" && (wt || !Op.call(lt2, Ee2)) || Jt.push(Ee2);
          return Jt;
        }
        function Xx(lt2, wt) {
          return lt2 < wt;
        }
        function OV(lt2, wt) {
          var Jt = -1, Ee2 = L_(lt2) ? Sa2(lt2.length) : [];
          return oA(lt2, function(sn, Hn, Fr) {
            Ee2[++Jt] = wt(sn, Hn, Fr);
          }), Ee2;
        }
        function YU(lt2) {
          var wt = Mp(lt2);
          return wt.length == 1 && wt[0][2] ? Yvt(wt[0][0], wt[0][1]) : function(Jt) {
            return Jt === lt2 || Zet(Jt, lt2, wt);
          };
        }
        function lA(lt2, wt) {
          return pO(lt2) && Rf2(wt) ? Yvt(pA(lt2), wt) : function(Jt) {
            var Ee2 = Gy(Jt, lt2);
            return Ee2 === t2 && Ee2 === wt ? TO(Jt, lt2) : B5(wt, Ee2, at | ht);
          };
        }
        function LS(lt2, wt, Jt, Ee2, sn) {
          lt2 !== wt && V5(wt, function(Hn, Fr) {
            if (sn || (sn = new uC()), Zg2(Hn))
              oO(lt2, wt, Fr, Jt, LS, Ee2, sn);
            else {
              var $r = Ee2 ? Ee2(ont(lt2, Fr), Hn, Fr + "", lt2, wt, sn) : t2;
              $r === t2 && ($r = Hn), DV(lt2, Fr, $r);
            }
          }, ew);
        }
        function oO(lt2, wt, Jt, Ee2, sn, Hn, Fr) {
          var $r = ont(lt2, Jt), ki2 = ont(wt, Jt), Ja2 = Fr.get(ki2);
          if (Ja2) {
            DV(lt2, Jt, Ja2);
            return;
          }
          var Io = Hn ? Hn($r, ki2, Jt + "", lt2, wt, Fr) : t2, Xo = Io === t2;
          if (Xo) {
            var ul = ns(ki2), su = !ul && mA(ki2), Eu = !ul && !su && BN(ki2);
            Io = ki2, ul || su || Eu ? ns($r) ? Io = $r : b0($r) ? Io = E_($r) : su ? (Xo = false, Io = Dvt(ki2, true)) : Eu ? (Xo = false, Io = tq(ki2, true)) : Io = [] : ZV(ki2) || qc2(ki2) ? (Io = $r, qc2($r) ? Io = Vnt($r) : (!Zg2($r) || R_($r)) && (Io = Zvt(ki2))) : Xo = false;
          }
          Xo && (Fr.set(ki2, Io), sn(Io, ki2, Ee2, Hn, Fr), Fr.delete(ki2)), DV(lt2, Jt, Io);
        }
        function KU(lt2, wt) {
          var Jt = lt2.length;
          if (!!Jt)
            return wt += wt < 0 ? Jt : 0, Ud2(wt, Jt) ? lt2[wt] : t2;
        }
        function sO(lt2, wt, Jt) {
          wt.length ? wt = cv(wt, function(Hn) {
            return ns(Hn) ? function(Fr) {
              return xE(Fr, Hn.length === 1 ? Hn[0] : Hn);
            } : Hn;
          }) : wt = [N_];
          var Ee2 = -1;
          wt = cv(wt, Kx(Ku()));
          var sn = OV(lt2, function(Hn, Fr, $r) {
            var ki2 = cv(wt, function(Ja2) {
              return Ja2(Hn);
            });
            return { criteria: ki2, index: ++Ee2, value: Hn };
          });
          return u5t(sn, function(Hn, Fr) {
            return z5t(Hn, Fr, Jt);
          });
        }
        function V5t(lt2, wt) {
          return Yet(lt2, wt, function(Jt, Ee2) {
            return TO(lt2, Ee2);
          });
        }
        function Yet(lt2, wt, Jt) {
          for (var Ee2 = -1, sn = wt.length, Hn = {}; ++Ee2 < sn; ) {
            var Fr = wt[Ee2], $r = xE(lt2, Fr);
            Jt($r, Fr) && OS(Hn, Tm(Fr, lt2), $r);
          }
          return Hn;
        }
        function Tvt(lt2) {
          return function(wt) {
            return xE(wt, lt2);
          };
        }
        function wE(lt2, wt, Jt, Ee2) {
          var sn = Ee2 ? LU : U2, Hn = -1, Fr = wt.length, $r = lt2;
          for (lt2 === wt && (wt = E_(wt)), Jt && ($r = cv(lt2, Kx(Jt))); ++Hn < Fr; )
            for (var ki2 = 0, Ja2 = wt[Hn], Io = Jt ? Jt(Ja2) : Ja2; (ki2 = sn($r, Io, ki2, Ee2)) > -1; )
              $r !== lt2 && xV.call($r, ki2, 1), xV.call(lt2, ki2, 1);
          return lt2;
        }
        function z5(lt2, wt) {
          for (var Jt = lt2 ? wt.length : 0, Ee2 = Jt - 1; Jt--; ) {
            var sn = wt[Jt];
            if (Jt == Ee2 || sn !== Hn) {
              var Hn = sn;
              Ud2(sn) ? xV.call(lt2, sn, 1) : Yu(lt2, sn);
            }
          }
          return lt2;
        }
        function j5(lt2, wt) {
          return lt2 + wV(_N() * (wt - lt2 + 1));
        }
        function Ket(lt2, wt, Jt, Ee2) {
          for (var sn = -1, Hn = sp(m0((wt - lt2) / (Jt || 1)), 0), Fr = Sa2(Hn); Hn--; )
            Fr[Ee2 ? Hn : ++sn] = lt2, lt2 += Jt;
          return Fr;
        }
        function RV(lt2, wt) {
          var Jt = "";
          if (!lt2 || wt < 1 || wt > nr)
            return Jt;
          do
            wt % 2 && (Jt += lt2), wt = wV(wt / 2), wt && (lt2 += lt2);
          while (wt);
          return Jt;
        }
        function rh2(lt2, wt) {
          return snt(NN(lt2, wt, N_), lt2 + "");
        }
        function uA(lt2) {
          return yvt(AO(lt2));
        }
        function Avt(lt2, wt) {
          var Jt = AO(lt2);
          return NS(Jt, rO(wt, 0, Jt.length));
        }
        function OS(lt2, wt, Jt, Ee2) {
          if (!Zg2(lt2))
            return lt2;
          wt = Tm(wt, lt2);
          for (var sn = -1, Hn = wt.length, Fr = Hn - 1, $r = lt2; $r != null && ++sn < Hn; ) {
            var ki2 = pA(wt[sn]), Ja2 = Jt;
            if (ki2 === "__proto__" || ki2 === "constructor" || ki2 === "prototype")
              return lt2;
            if (sn != Fr) {
              var Io = $r[ki2];
              Ja2 = Ee2 ? Ee2(Io, ki2, $r) : t2, Ja2 === t2 && (Ja2 = Zg2(Io) ? Io : Ud2(wt[sn + 1]) ? [] : {});
            }
            EV($r, ki2, Ja2), $r = $r[ki2];
          }
          return lt2;
        }
        var Ivt = VU ? function(lt2, wt) {
          return VU.set(lt2, wt), lt2;
        } : N_, Nu = T_ ? function(lt2, wt) {
          return T_(lt2, "toString", { configurable: true, enumerable: false, value: Dq(wt), writable: true });
        } : N_;
        function XU(lt2) {
          return NS(AO(lt2));
        }
        function D_(lt2, wt, Jt) {
          var Ee2 = -1, sn = lt2.length;
          wt < 0 && (wt = -wt > sn ? 0 : sn + wt), Jt = Jt > sn ? sn : Jt, Jt < 0 && (Jt += sn), sn = wt > Jt ? 0 : Jt - wt >>> 0, wt >>>= 0;
          for (var Hn = Sa2(sn); ++Ee2 < sn; )
            Hn[Ee2] = lt2[Ee2 + wt];
          return Hn;
        }
        function lO(lt2, wt) {
          var Jt;
          return oA(lt2, function(Ee2, sn, Hn) {
            return Jt = wt(Ee2, sn, Hn), !Jt;
          }), !!Jt;
        }
        function cA(lt2, wt, Jt) {
          var Ee2 = 0, sn = lt2 == null ? Ee2 : lt2.length;
          if (typeof wt == "number" && wt === wt && sn <= To) {
            for (; Ee2 < sn; ) {
              var Hn = Ee2 + sn >>> 1, Fr = lt2[Hn];
              Fr !== null && !FS(Fr) && (Jt ? Fr <= wt : Fr < wt) ? Ee2 = Hn + 1 : sn = Hn;
            }
            return sn;
          }
          return SE(lt2, wt, N_, Jt);
        }
        function SE(lt2, wt, Jt, Ee2) {
          var sn = 0, Hn = lt2 == null ? 0 : lt2.length;
          if (Hn === 0)
            return 0;
          wt = Jt(wt);
          for (var Fr = wt !== wt, $r = wt === null, ki2 = FS(wt), Ja2 = wt === t2; sn < Hn; ) {
            var Io = wV((sn + Hn) / 2), Xo = Jt(lt2[Io]), ul = Xo !== t2, su = Xo === null, Eu = Xo === Xo, hc2 = FS(Xo);
            if (Fr)
              var Wu = Ee2 || Eu;
            else
              Ja2 ? Wu = Eu && (Ee2 || ul) : $r ? Wu = Eu && ul && (Ee2 || !su) : ki2 ? Wu = Eu && ul && !su && (Ee2 || !hc2) : su || hc2 ? Wu = false : Wu = Ee2 ? Xo <= wt : Xo < wt;
            Wu ? sn = Io + 1 : Hn = Io;
          }
          return Cm(Hn, gi2);
        }
        function W5(lt2, wt) {
          for (var Jt = -1, Ee2 = lt2.length, sn = 0, Hn = []; ++Jt < Ee2; ) {
            var Fr = lt2[Jt], $r = wt ? wt(Fr) : Fr;
            if (!Jt || !X2($r, ki2)) {
              var ki2 = $r;
              Hn[sn++] = Fr === 0 ? 0 : Fr;
            }
          }
          return Hn;
        }
        function kN(lt2) {
          return typeof lt2 == "number" ? lt2 : FS(lt2) ? Nr : +lt2;
        }
        function g1(lt2) {
          if (typeof lt2 == "string")
            return lt2;
          if (ns(lt2))
            return cv(lt2, g1) + "";
          if (FS(lt2))
            return BU ? BU.call(lt2) : "";
          var wt = lt2 + "";
          return wt == "0" && 1 / lt2 == -Zr ? "-0" : wt;
        }
        function G5(lt2, wt, Jt) {
          var Ee2 = -1, sn = H22, Hn = lt2.length, Fr = true, $r = [], ki2 = $r;
          if (Jt)
            Fr = false, sn = _et;
          else if (Hn >= v4) {
            var Ja2 = wt ? null : iq(lt2);
            if (Ja2)
              return hN(Ja2);
            Fr = false, sn = KL, ki2 = new eO();
          } else
            ki2 = wt ? [] : $r;
          t:
            for (; ++Ee2 < Hn; ) {
              var Io = lt2[Ee2], Xo = wt ? wt(Io) : Io;
              if (Io = Jt || Io !== 0 ? Io : 0, Fr && Xo === Xo) {
                for (var ul = ki2.length; ul--; )
                  if (ki2[ul] === Xo)
                    continue t;
                wt && ki2.push(Xo), $r.push(Io);
              } else
                sn(ki2, Xo, Jt) || (ki2 !== $r && ki2.push(Xo), $r.push(Io));
            }
          return $r;
        }
        function Yu(lt2, wt) {
          return wt = Tm(wt, lt2), lt2 = ant(lt2, wt), lt2 == null || delete lt2[pA(Qx(wt))];
        }
        function Xet(lt2, wt, Jt, Ee2) {
          return OS(lt2, wt, Jt(xE(lt2, wt)), Ee2);
        }
        function _b2(lt2, wt, Jt, Ee2) {
          for (var sn = lt2.length, Hn = Ee2 ? sn : -1; (Ee2 ? Hn-- : ++Hn < sn) && wt(lt2[Hn], Hn, lt2); )
            ;
          return Jt ? D_(lt2, Ee2 ? 0 : Hn, Ee2 ? Hn + 1 : sn) : D_(lt2, Ee2 ? Hn + 1 : 0, Ee2 ? sn : Hn);
        }
        function Qet(lt2, wt) {
          var Jt = lt2;
          return Jt instanceof nh2 && (Jt = Jt.value()), dE(wt, function(Ee2, sn) {
            return sn.func.apply(sn.thisArg, eA([Ee2], sn.args));
          }, Jt);
        }
        function uO(lt2, wt, Jt) {
          var Ee2 = lt2.length;
          if (Ee2 < 2)
            return Ee2 ? G5(lt2[0]) : [];
          for (var sn = -1, Hn = Sa2(Ee2); ++sn < Ee2; )
            for (var Fr = lt2[sn], $r = -1; ++$r < Ee2; )
              $r != sn && (Hn[sn] = iO(Hn[sn] || Fr, lt2[$r], wt, Jt));
          return G5(Wy(Hn, 1), wt, Jt);
        }
        function PN(lt2, wt, Jt) {
          for (var Ee2 = -1, sn = lt2.length, Hn = wt.length, Fr = {}; ++Ee2 < sn; ) {
            var $r = Ee2 < Hn ? wt[Ee2] : t2;
            Jt(Fr, lt2[Ee2], $r);
          }
          return Fr;
        }
        function H5(lt2) {
          return b0(lt2) ? lt2 : [];
        }
        function LN(lt2) {
          return typeof lt2 == "function" ? lt2 : N_;
        }
        function Tm(lt2, wt) {
          return ns(lt2) ? lt2 : pO(lt2, wt) ? [lt2] : Kvt(fd2(lt2));
        }
        var QU = rh2;
        function fA(lt2, wt, Jt) {
          var Ee2 = lt2.length;
          return Jt = Jt === t2 ? Ee2 : Jt, !wt && Jt >= Ee2 ? lt2 : D_(lt2, wt, Jt);
        }
        var JU = mN || function(lt2) {
          return uv.clearTimeout(lt2);
        };
        function Dvt(lt2, wt) {
          if (wt)
            return lt2.slice();
          var Jt = lt2.length, Ee2 = Pet ? Pet(Jt) : new lt2.constructor(Jt);
          return lt2.copy(Ee2), Ee2;
        }
        function U5(lt2) {
          var wt = new lt2.constructor(lt2.byteLength);
          return new QL(wt).set(new QL(lt2)), wt;
        }
        function B5t(lt2, wt) {
          var Jt = wt ? U5(lt2.buffer) : lt2.buffer;
          return new lt2.constructor(Jt, lt2.byteOffset, lt2.byteLength);
        }
        function Jet(lt2) {
          var wt = new lt2.constructor(lt2.source, cr.exec(lt2));
          return wt.lastIndex = lt2.lastIndex, wt;
        }
        function tnt(lt2) {
          return aA ? fg2(aA.call(lt2)) : {};
        }
        function tq(lt2, wt) {
          var Jt = wt ? U5(lt2.buffer) : lt2.buffer;
          return new lt2.constructor(Jt, lt2.byteOffset, lt2.length);
        }
        function Evt(lt2, wt) {
          if (lt2 !== wt) {
            var Jt = lt2 !== t2, Ee2 = lt2 === null, sn = lt2 === lt2, Hn = FS(lt2), Fr = wt !== t2, $r = wt === null, ki2 = wt === wt, Ja2 = FS(wt);
            if (!$r && !Ja2 && !Hn && lt2 > wt || Hn && Fr && ki2 && !$r && !Ja2 || Ee2 && Fr && ki2 || !Jt && ki2 || !sn)
              return 1;
            if (!Ee2 && !Hn && !Ja2 && lt2 < wt || Ja2 && Jt && sn && !Ee2 && !Hn || $r && Jt && sn || !Fr && sn || !ki2)
              return -1;
          }
          return 0;
        }
        function z5t(lt2, wt, Jt) {
          for (var Ee2 = -1, sn = lt2.criteria, Hn = wt.criteria, Fr = sn.length, $r = Jt.length; ++Ee2 < Fr; ) {
            var ki2 = Evt(sn[Ee2], Hn[Ee2]);
            if (ki2) {
              if (Ee2 >= $r)
                return ki2;
              var Ja2 = Jt[Ee2];
              return ki2 * (Ja2 == "desc" ? -1 : 1);
            }
          }
          return lt2.index - wt.index;
        }
        function kvt(lt2, wt, Jt, Ee2) {
          for (var sn = -1, Hn = lt2.length, Fr = Jt.length, $r = -1, ki2 = wt.length, Ja2 = sp(Hn - Fr, 0), Io = Sa2(ki2 + Ja2), Xo = !Ee2; ++$r < ki2; )
            Io[$r] = wt[$r];
          for (; ++sn < Fr; )
            (Xo || sn < Hn) && (Io[Jt[sn]] = lt2[sn]);
          for (; Ja2--; )
            Io[$r++] = lt2[sn++];
          return Io;
        }
        function Pvt(lt2, wt, Jt, Ee2) {
          for (var sn = -1, Hn = lt2.length, Fr = -1, $r = Jt.length, ki2 = -1, Ja2 = wt.length, Io = sp(Hn - $r, 0), Xo = Sa2(Io + Ja2), ul = !Ee2; ++sn < Io; )
            Xo[sn] = lt2[sn];
          for (var su = sn; ++ki2 < Ja2; )
            Xo[su + ki2] = wt[ki2];
          for (; ++Fr < $r; )
            (ul || sn < Hn) && (Xo[su + Jt[Fr]] = lt2[sn++]);
          return Xo;
        }
        function E_(lt2, wt) {
          var Jt = -1, Ee2 = lt2.length;
          for (wt || (wt = Sa2(Ee2)); ++Jt < Ee2; )
            wt[Jt] = lt2[Jt];
          return wt;
        }
        function cC(lt2, wt, Jt, Ee2) {
          var sn = !Jt;
          Jt || (Jt = {});
          for (var Hn = -1, Fr = wt.length; ++Hn < Fr; ) {
            var $r = wt[Hn], ki2 = Ee2 ? Ee2(Jt[$r], lt2[$r], $r, Jt, lt2) : t2;
            ki2 === t2 && (ki2 = lt2[$r]), sn ? PS(Jt, $r, ki2) : EV(Jt, $r, ki2);
          }
          return Jt;
        }
        function Lvt(lt2, wt) {
          return cC(lt2, q5(lt2), wt);
        }
        function ou(lt2, wt) {
          return cC(lt2, Uvt(lt2), wt);
        }
        function cO(lt2, wt) {
          return function(Jt, Ee2) {
            var sn = ns(Jt) ? Ns : mvt, Hn = wt ? wt() : {};
            return sn(Jt, lt2, Ku(Ee2, 2), Hn);
          };
        }
        function fO(lt2) {
          return rh2(function(wt, Jt) {
            var Ee2 = -1, sn = Jt.length, Hn = sn > 1 ? Jt[sn - 1] : t2, Fr = sn > 2 ? Jt[2] : t2;
            for (Hn = lt2.length > 3 && typeof Hn == "function" ? (sn--, Hn) : t2, Fr && y1(Jt[0], Jt[1], Fr) && (Hn = sn < 3 ? t2 : Hn, sn = 1), wt = fg2(wt); ++Ee2 < sn; ) {
              var $r = Jt[Ee2];
              $r && lt2(wt, $r, Ee2, Hn);
            }
            return wt;
          });
        }
        function Ovt(lt2, wt) {
          return function(Jt, Ee2) {
            if (Jt == null)
              return Jt;
            if (!L_(Jt))
              return lt2(Jt, Ee2);
            for (var sn = Jt.length, Hn = wt ? sn : -1, Fr = fg2(Jt); (wt ? Hn-- : ++Hn < sn) && Ee2(Fr[Hn], Hn, Fr) !== false; )
              ;
            return Jt;
          };
        }
        function Rvt(lt2) {
          return function(wt, Jt, Ee2) {
            for (var sn = -1, Hn = fg2(wt), Fr = Ee2(wt), $r = Fr.length; $r--; ) {
              var ki2 = Fr[lt2 ? $r : ++sn];
              if (Jt(Hn[ki2], ki2, Hn) === false)
                break;
            }
            return wt;
          };
        }
        function j5t(lt2, wt, Jt) {
          var Ee2 = wt & bt, sn = RN(lt2);
          function Hn() {
            var Fr = this && this !== uv && this instanceof Hn ? sn : lt2;
            return Fr.apply(Ee2 ? Jt : this, arguments);
          }
          return Hn;
        }
        function ent(lt2) {
          return function(wt) {
            wt = fd2(wt);
            var Jt = fN(wt) ? q2(wt) : t2, Ee2 = Jt ? Jt[0] : wt.charAt(0), sn = Jt ? fA(Jt, 1).join("") : wt.slice(1);
            return Ee2[lt2]() + sn;
          };
        }
        function ON(lt2) {
          return function(wt) {
            return dE(Xnt(Znt(wt).replace(o5t, "")), lt2, "");
          };
        }
        function RN(lt2) {
          return function() {
            var wt = arguments;
            switch (wt.length) {
              case 0:
                return new lt2();
              case 1:
                return new lt2(wt[0]);
              case 2:
                return new lt2(wt[0], wt[1]);
              case 3:
                return new lt2(wt[0], wt[1], wt[2]);
              case 4:
                return new lt2(wt[0], wt[1], wt[2], wt[3]);
              case 5:
                return new lt2(wt[0], wt[1], wt[2], wt[3], wt[4]);
              case 6:
                return new lt2(wt[0], wt[1], wt[2], wt[3], wt[4], wt[5]);
              case 7:
                return new lt2(wt[0], wt[1], wt[2], wt[3], wt[4], wt[5], wt[6]);
            }
            var Jt = p1(lt2.prototype), Ee2 = lt2.apply(Jt, wt);
            return Zg2(Ee2) ? Ee2 : Jt;
          };
        }
        function Nvt(lt2, wt, Jt) {
          var Ee2 = RN(lt2);
          function sn() {
            for (var Hn = arguments.length, Fr = Sa2(Hn), $r = Hn, ki2 = hO(sn); $r--; )
              Fr[$r] = arguments[$r];
            var Ja2 = Hn < 3 && Fr[0] !== ki2 && Fr[Hn - 1] !== ki2 ? [] : O5(Fr, ki2);
            if (Hn -= Ja2.length, Hn < Jt)
              return nnt(lt2, wt, Ko, sn.placeholder, t2, Fr, Ja2, t2, t2, Jt - Hn);
            var Io = this && this !== uv && this instanceof sn ? Ee2 : lt2;
            return $x(Io, this, Fr);
          }
          return sn;
        }
        function Fvt(lt2) {
          return function(wt, Jt, Ee2) {
            var sn = fg2(wt);
            if (!L_(wt)) {
              var Hn = Ku(Jt, 3);
              wt = Hy(wt), Jt = function($r) {
                return Hn(sn[$r], $r, sn);
              };
            }
            var Fr = lt2(wt, Jt, Ee2);
            return Fr > -1 ? sn[Hn ? wt[Fr] : Fr] : t2;
          };
        }
        function yp(lt2) {
          return hA(function(wt) {
            var Jt = wt.length, Ee2 = Jt, sn = ES.prototype.thru;
            for (lt2 && wt.reverse(); Ee2--; ) {
              var Hn = wt[Ee2];
              if (typeof Hn != "function")
                throw new DS(M2);
              if (sn && !Fr && ih2(Hn) == "wrapper")
                var Fr = new ES([], true);
            }
            for (Ee2 = Fr ? Ee2 : Jt; ++Ee2 < Jt; ) {
              Hn = wt[Ee2];
              var $r = ih2(Hn), ki2 = $r == "wrapper" ? uq(Hn) : t2;
              ki2 && rnt(ki2[0]) && ki2[1] == (ye | zt | fe2 | me2) && !ki2[4].length && ki2[9] == 1 ? Fr = Fr[ih2(ki2[0])].apply(Fr, ki2[3]) : Fr = Hn.length == 1 && rnt(Hn) ? Fr[$r]() : Fr.thru(Hn);
            }
            return function() {
              var Ja2 = arguments, Io = Ja2[0];
              if (Fr && Ja2.length == 1 && ns(Io))
                return Fr.plant(Io).value();
              for (var Xo = 0, ul = Jt ? wt[Xo].apply(this, Ja2) : Io; ++Xo < Jt; )
                ul = wt[Xo].call(this, ul);
              return ul;
            };
          });
        }
        function Ko(lt2, wt, Jt, Ee2, sn, Hn, Fr, $r, ki2, Ja2) {
          var Io = wt & ye, Xo = wt & bt, ul = wt & _t, su = wt & (zt | Ft), Eu = wt & be2, hc2 = ul ? t2 : RN(lt2);
          function Wu() {
            for (var Th2 = arguments.length, mp = Sa2(Th2), m1 = Th2; m1--; )
              mp[m1] = arguments[m1];
            if (su)
              var wb2 = hO(Wu), BS = f5t(mp, wb2);
            if (Ee2 && (mp = kvt(mp, Ee2, sn, su)), Hn && (mp = Pvt(mp, Hn, Fr, su)), Th2 -= BS, su && Th2 < Ja2) {
              var fv = O5(mp, wb2);
              return nnt(lt2, wt, Ko, Wu.placeholder, Jt, mp, fv, $r, ki2, Ja2 - Th2);
            }
            var F_ = Xo ? Jt : this, wA = ul ? F_[lt2] : lt2;
            return Th2 = mp.length, $r ? mp = K5t(mp, $r) : Eu && Th2 > 1 && mp.reverse(), Io && ki2 < Th2 && (mp.length = ki2), this && this !== uv && this instanceof Wu && (wA = hc2 || RN(wA)), wA.apply(F_, mp);
          }
          return Wu;
        }
        function kv(lt2, wt) {
          return function(Jt, Ee2) {
            return O5t(Jt, lt2, wt(Ee2), {});
          };
        }
        function k_(lt2, wt) {
          return function(Jt, Ee2) {
            var sn;
            if (Jt === t2 && Ee2 === t2)
              return wt;
            if (Jt !== t2 && (sn = Jt), Ee2 !== t2) {
              if (sn === t2)
                return Ee2;
              typeof Jt == "string" || typeof Ee2 == "string" ? (Jt = g1(Jt), Ee2 = g1(Ee2)) : (Jt = kN(Jt), Ee2 = kN(Ee2)), sn = lt2(Jt, Ee2);
            }
            return sn;
          };
        }
        function $2(lt2) {
          return hA(function(wt) {
            return wt = cv(wt, Kx(Ku())), rh2(function(Jt) {
              var Ee2 = this;
              return lt2(wt, function(sn) {
                return $x(sn, Ee2, Jt);
              });
            });
          });
        }
        function eq2(lt2, wt) {
          wt = wt === t2 ? " " : g1(wt);
          var Jt = wt.length;
          if (Jt < 2)
            return Jt ? RV(wt, lt2) : wt;
          var Ee2 = RV(wt, m0(lt2 / pN(wt)));
          return fN(wt) ? fA(q2(Ee2), 0, lt2).join("") : Ee2.slice(0, lt2);
        }
        function Vvt(lt2, wt, Jt, Ee2) {
          var sn = wt & bt, Hn = RN(lt2);
          function Fr() {
            for (var $r = -1, ki2 = arguments.length, Ja2 = -1, Io = Ee2.length, Xo = Sa2(Io + ki2), ul = this && this !== uv && this instanceof Fr ? Hn : lt2; ++Ja2 < Io; )
              Xo[Ja2] = Ee2[Ja2];
            for (; ki2--; )
              Xo[Ja2++] = arguments[++$r];
            return $x(ul, sn ? Jt : this, Xo);
          }
          return Fr;
        }
        function Bvt(lt2) {
          return function(wt, Jt, Ee2) {
            return Ee2 && typeof Ee2 != "number" && y1(wt, Jt, Ee2) && (Jt = Ee2 = t2), wt = Dm(wt), Jt === t2 ? (Jt = wt, wt = 0) : Jt = Dm(Jt), Ee2 = Ee2 === t2 ? wt < Jt ? 1 : -1 : Dm(Ee2), Ket(wt, Jt, Ee2, lt2);
          };
        }
        function nq(lt2) {
          return function(wt, Jt) {
            return typeof wt == "string" && typeof Jt == "string" || (wt = VS(wt), Jt = VS(Jt)), lt2(wt, Jt);
          };
        }
        function nnt(lt2, wt, Jt, Ee2, sn, Hn, Fr, $r, ki2, Ja2) {
          var Io = wt & zt, Xo = Io ? Fr : t2, ul = Io ? t2 : Fr, su = Io ? Hn : t2, Eu = Io ? t2 : Hn;
          wt |= Io ? fe2 : re2, wt &= ~(Io ? re2 : fe2), wt & Et || (wt &= ~(bt | _t));
          var hc2 = [lt2, wt, sn, su, Xo, Eu, ul, $r, ki2, Ja2], Wu = Jt.apply(t2, hc2);
          return rnt(lt2) && cq(Wu, hc2), Wu.placeholder = Ee2, Z5(Wu, lt2, wt);
        }
        function rq(lt2) {
          var wt = e0[lt2];
          return function(Jt, Ee2) {
            if (Jt = VS(Jt), Ee2 = Ee2 == null ? 0 : Cm(fc2(Ee2), 292), Ee2 && bE(Jt)) {
              var sn = (fd2(Jt) + "e").split("e"), Hn = wt(sn[0] + "e" + (+sn[1] + Ee2));
              return sn = (fd2(Hn) + "e").split("e"), +(sn[0] + "e" + (+sn[1] - Ee2));
            }
            return wt(Jt);
          };
        }
        var iq = xN && 1 / hN(new xN([, -0]))[1] == Zr ? function(lt2) {
          return new xN(lt2);
        } : Eq;
        function zvt(lt2) {
          return function(wt) {
            var Jt = v12(wt);
            return Jt == au ? mV(wt) : Jt == _d ? d5t(wt) : c5t(wt, lt2(wt));
          };
        }
        function Am(lt2, wt, Jt, Ee2, sn, Hn, Fr, $r) {
          var ki2 = wt & _t;
          if (!ki2 && typeof lt2 != "function")
            throw new DS(M2);
          var Ja2 = Ee2 ? Ee2.length : 0;
          if (Ja2 || (wt &= ~(fe2 | re2), Ee2 = sn = t2), Fr = Fr === t2 ? Fr : sp(fc2(Fr), 0), $r = $r === t2 ? $r : fc2($r), Ja2 -= sn ? sn.length : 0, wt & re2) {
            var Io = Ee2, Xo = sn;
            Ee2 = sn = t2;
          }
          var ul = ki2 ? t2 : uq(lt2), su = [lt2, wt, Jt, Ee2, sn, Io, Xo, Hn, Fr, $r];
          if (ul && int(su, ul), lt2 = su[0], wt = su[1], Jt = su[2], Ee2 = su[3], sn = su[4], $r = su[9] = su[9] === t2 ? ki2 ? 0 : lt2.length : sp(su[9] - Ja2, 0), !$r && wt & (zt | Ft) && (wt &= ~(zt | Ft)), !wt || wt == bt)
            var Eu = j5t(lt2, wt, Jt);
          else
            wt == zt || wt == Ft ? Eu = Nvt(lt2, wt, $r) : (wt == fe2 || wt == (bt | fe2)) && !sn.length ? Eu = Vvt(lt2, wt, Jt, Ee2) : Eu = Ko.apply(t2, su);
          var hc2 = ul ? Ivt : cq;
          return Z5(hc2(Eu, su), lt2, wt);
        }
        function jvt(lt2, wt, Jt, Ee2) {
          return lt2 === t2 || X2(lt2, gN[Jt]) && !Op.call(Ee2, Jt) ? wt : lt2;
        }
        function aq(lt2, wt, Jt, Ee2, sn, Hn) {
          return Zg2(lt2) && Zg2(wt) && (Hn.set(wt, lt2), LS(lt2, wt, t2, aq, Hn), Hn.delete(wt)), lt2;
        }
        function Wvt(lt2) {
          return ZV(lt2) ? t2 : lt2;
        }
        function oq(lt2, wt, Jt, Ee2, sn, Hn) {
          var Fr = Jt & at, $r = lt2.length, ki2 = wt.length;
          if ($r != ki2 && !(Fr && ki2 > $r))
            return false;
          var Ja2 = Hn.get(lt2), Io = Hn.get(wt);
          if (Ja2 && Io)
            return Ja2 == wt && Io == lt2;
          var Xo = -1, ul = true, su = Jt & ht ? new eO() : t2;
          for (Hn.set(lt2, wt), Hn.set(wt, lt2); ++Xo < $r; ) {
            var Eu = lt2[Xo], hc2 = wt[Xo];
            if (Ee2)
              var Wu = Fr ? Ee2(hc2, Eu, Xo, wt, lt2, Hn) : Ee2(Eu, hc2, Xo, lt2, wt, Hn);
            if (Wu !== t2) {
              if (Wu)
                continue;
              ul = false;
              break;
            }
            if (su) {
              if (!wet(wt, function(Th2, mp) {
                if (!KL(su, mp) && (Eu === Th2 || sn(Eu, Th2, Jt, Ee2, Hn)))
                  return su.push(mp);
              })) {
                ul = false;
                break;
              }
            } else if (!(Eu === hc2 || sn(Eu, hc2, Jt, Ee2, Hn))) {
              ul = false;
              break;
            }
          }
          return Hn.delete(lt2), Hn.delete(wt), ul;
        }
        function Gvt(lt2, wt, Jt, Ee2, sn, Hn, Fr) {
          switch (Jt) {
            case ho:
              if (lt2.byteLength != wt.byteLength || lt2.byteOffset != wt.byteOffset)
                return false;
              lt2 = lt2.buffer, wt = wt.buffer;
            case Ki2:
              return !(lt2.byteLength != wt.byteLength || !Hn(new QL(lt2), new QL(wt)));
            case es:
            case Ws:
            case eh2:
              return X2(+lt2, +wt);
            case bs:
              return lt2.name == wt.name && lt2.message == wt.message;
            case c1:
            case G0:
              return lt2 == wt + "";
            case au:
              var $r = mV;
            case _d:
              var ki2 = Ee2 & at;
              if ($r || ($r = hN), lt2.size != wt.size && !ki2)
                return false;
              var Ja2 = Fr.get(lt2);
              if (Ja2)
                return Ja2 == wt;
              Ee2 |= ht, Fr.set(lt2, wt);
              var Io = oq($r(lt2), $r(wt), Ee2, sn, Hn, Fr);
              return Fr.delete(lt2), Io;
            case qg2:
              if (aA)
                return aA.call(lt2) == aA.call(wt);
          }
          return false;
        }
        function ME(lt2, wt, Jt, Ee2, sn, Hn) {
          var Fr = Jt & at, $r = sq(lt2), ki2 = $r.length, Ja2 = sq(wt), Io = Ja2.length;
          if (ki2 != Io && !Fr)
            return false;
          for (var Xo = ki2; Xo--; ) {
            var ul = $r[Xo];
            if (!(Fr ? ul in wt : Op.call(wt, ul)))
              return false;
          }
          var su = Hn.get(lt2), Eu = Hn.get(wt);
          if (su && Eu)
            return su == wt && Eu == lt2;
          var hc2 = true;
          Hn.set(lt2, wt), Hn.set(wt, lt2);
          for (var Wu = Fr; ++Xo < ki2; ) {
            ul = $r[Xo];
            var Th2 = lt2[ul], mp = wt[ul];
            if (Ee2)
              var m1 = Fr ? Ee2(mp, Th2, ul, wt, lt2, Hn) : Ee2(Th2, mp, ul, lt2, wt, Hn);
            if (!(m1 === t2 ? Th2 === mp || sn(Th2, mp, Jt, Ee2, Hn) : m1)) {
              hc2 = false;
              break;
            }
            Wu || (Wu = ul == "constructor");
          }
          if (hc2 && !Wu) {
            var wb2 = lt2.constructor, BS = wt.constructor;
            wb2 != BS && "constructor" in lt2 && "constructor" in wt && !(typeof wb2 == "function" && wb2 instanceof wb2 && typeof BS == "function" && BS instanceof BS) && (hc2 = false);
          }
          return Hn.delete(lt2), Hn.delete(wt), hc2;
        }
        function hA(lt2) {
          return snt(NN(lt2, t2, BV), lt2 + "");
        }
        function sq(lt2) {
          return Het(lt2, Hy, q5);
        }
        function lq(lt2) {
          return Het(lt2, ew, Uvt);
        }
        var uq = VU ? function(lt2) {
          return VU.get(lt2);
        } : Eq;
        function ih2(lt2) {
          for (var wt = lt2.name + "", Jt = SN[wt], Ee2 = Op.call(SN, wt) ? Jt.length : 0; Ee2--; ) {
            var sn = Jt[Ee2], Hn = sn.func;
            if (Hn == null || Hn == lt2)
              return sn.name;
          }
          return wt;
        }
        function hO(lt2) {
          var wt = Op.call(In, "placeholder") ? In : lt2;
          return wt.placeholder;
        }
        function Ku() {
          var lt2 = In.iteratee || by;
          return lt2 = lt2 === by ? $U : lt2, arguments.length ? lt2(arguments[0], arguments[1]) : lt2;
        }
        function NV(lt2, wt) {
          var Jt = lt2.__data__;
          return q5t(wt) ? Jt[typeof wt == "string" ? "string" : "hash"] : Jt.map;
        }
        function Mp(lt2) {
          for (var wt = Hy(lt2), Jt = wt.length; Jt--; ) {
            var Ee2 = wt[Jt], sn = lt2[Ee2];
            wt[Jt] = [Ee2, sn, Rf2(sn)];
          }
          return wt;
        }
        function RS(lt2, wt) {
          var Jt = Aet(lt2, wt);
          return Mvt(Jt) ? Jt : t2;
        }
        function Hvt(lt2) {
          var wt = Op.call(lt2, mb2), Jt = lt2[mb2];
          try {
            lt2[mb2] = t2;
            var Ee2 = true;
          } catch {
          }
          var sn = yN.call(lt2);
          return Ee2 && (wt ? lt2[mb2] = Jt : delete lt2[mb2]), sn;
        }
        var q5 = bN ? function(lt2) {
          return lt2 == null ? [] : (lt2 = fg2(lt2), y0(bN(lt2), function(wt) {
            return _V.call(lt2, wt);
          }));
        } : kq, Uvt = bN ? function(lt2) {
          for (var wt = []; lt2; )
            eA(wt, q5(lt2)), lt2 = JL(lt2);
          return wt;
        } : kq, v12 = bb2;
        (Oet && v12(new Oet(new ArrayBuffer(1))) != ho || SV && v12(new SV()) != au || MV && v12(MV.resolve()) != zy || xN && v12(new xN()) != _d || CV && v12(new CV()) != fo) && (v12 = function(lt2) {
          var wt = bb2(lt2), Jt = wt == Pp ? lt2.constructor : t2, Ee2 = Jt ? CE(Jt) : "";
          if (Ee2)
            switch (Ee2) {
              case TV:
                return ho;
              case fvt:
                return au;
              case lC:
                return zy;
              case S5t:
                return _d;
              case AV:
                return fo;
            }
          return wt;
        });
        function W5t(lt2, wt, Jt) {
          for (var Ee2 = -1, sn = Jt.length; ++Ee2 < sn; ) {
            var Hn = Jt[Ee2], Fr = Hn.size;
            switch (Hn.type) {
              case "drop":
                lt2 += Fr;
                break;
              case "dropRight":
                wt -= Fr;
                break;
              case "take":
                wt = Cm(wt, lt2 + Fr);
                break;
              case "takeRight":
                lt2 = sp(lt2, wt - Fr);
                break;
            }
          }
          return { start: lt2, end: wt };
        }
        function G5t(lt2) {
          var wt = lt2.match(yet);
          return wt ? wt[1].split(met) : [];
        }
        function qvt(lt2, wt, Jt) {
          wt = Tm(wt, lt2);
          for (var Ee2 = -1, sn = wt.length, Hn = false; ++Ee2 < sn; ) {
            var Fr = pA(wt[Ee2]);
            if (!(Hn = lt2 != null && Jt(lt2, Fr)))
              break;
            lt2 = lt2[Fr];
          }
          return Hn || ++Ee2 != sn ? Hn : (sn = lt2 == null ? 0 : lt2.length, !!sn && rP(sn) && Ud2(Fr, sn) && (ns(lt2) || qc2(lt2)));
        }
        function H5t(lt2) {
          var wt = lt2.length, Jt = new lt2.constructor(wt);
          return wt && typeof lt2[0] == "string" && Op.call(lt2, "index") && (Jt.index = lt2.index, Jt.input = lt2.input), Jt;
        }
        function Zvt(lt2) {
          return typeof lt2.constructor == "function" && !fC(lt2) ? p1(JL(lt2)) : {};
        }
        function U5t(lt2, wt, Jt) {
          var Ee2 = lt2.constructor;
          switch (wt) {
            case Ki2:
              return U5(lt2);
            case es:
            case Ws:
              return new Ee2(+lt2);
            case ho:
              return B5t(lt2, Jt);
            case Bs:
            case Ql:
            case ff2:
            case hf2:
            case qp:
            case sv:
            case lg2:
            case H0:
            case ug2:
              return tq(lt2, Jt);
            case au:
              return new Ee2();
            case eh2:
            case G0:
              return new Ee2(lt2);
            case c1:
              return Jet(lt2);
            case _d:
              return new Ee2();
            case qg2:
              return tnt(lt2);
          }
        }
        function $vt(lt2, wt) {
          var Jt = wt.length;
          if (!Jt)
            return lt2;
          var Ee2 = Jt - 1;
          return wt[Ee2] = (Jt > 1 ? "& " : "") + wt[Ee2], wt = wt.join(Jt > 2 ? ", " : " "), lt2.replace(vet, `{
/* [wrapped with ` + wt + `] */
`);
        }
        function FV(lt2) {
          return ns(lt2) || qc2(lt2) || !!(Let && lt2 && lt2[Let]);
        }
        function Ud2(lt2, wt) {
          var Jt = typeof lt2;
          return wt = wt == null ? nr : wt, !!wt && (Jt == "number" || Jt != "symbol" && Ci2.test(lt2)) && lt2 > -1 && lt2 % 1 == 0 && lt2 < wt;
        }
        function y1(lt2, wt, Jt) {
          if (!Zg2(Jt))
            return false;
          var Ee2 = typeof wt;
          return (Ee2 == "number" ? L_(Jt) && Ud2(wt, Jt.length) : Ee2 == "string" && wt in Jt) ? X2(Jt[wt], lt2) : false;
        }
        function pO(lt2, wt) {
          if (ns(lt2))
            return false;
          var Jt = typeof lt2;
          return Jt == "number" || Jt == "symbol" || Jt == "boolean" || lt2 == null || FS(lt2) ? true : MS.test(lt2) || !S_.test(lt2) || wt != null && lt2 in fg2(wt);
        }
        function q5t(lt2) {
          var wt = typeof lt2;
          return wt == "string" || wt == "number" || wt == "symbol" || wt == "boolean" ? lt2 !== "__proto__" : lt2 === null;
        }
        function rnt(lt2) {
          var wt = ih2(lt2), Jt = In[wt];
          if (typeof Jt != "function" || !(wt in nh2.prototype))
            return false;
          if (lt2 === Jt)
            return true;
          var Ee2 = uq(Jt);
          return !!Ee2 && lt2 === Ee2[0];
        }
        function Z5t(lt2) {
          return !!ket && ket in lt2;
        }
        var $5t = XL ? R_ : IE;
        function fC(lt2) {
          var wt = lt2 && lt2.constructor, Jt = typeof wt == "function" && wt.prototype || gN;
          return lt2 === Jt;
        }
        function Rf2(lt2) {
          return lt2 === lt2 && !Zg2(lt2);
        }
        function Yvt(lt2, wt) {
          return function(Jt) {
            return Jt == null ? false : Jt[lt2] === wt && (wt !== t2 || lt2 in fg2(Jt));
          };
        }
        function VV(lt2) {
          var wt = _q(lt2, function(Ee2) {
            return Jt.size === N3 && Jt.clear(), Ee2;
          }), Jt = wt.cache;
          return wt;
        }
        function int(lt2, wt) {
          var Jt = lt2[1], Ee2 = wt[1], sn = Jt | Ee2, Hn = sn < (bt | _t | ye), Fr = Ee2 == ye && Jt == zt || Ee2 == ye && Jt == me2 && lt2[7].length <= wt[8] || Ee2 == (ye | me2) && wt[7].length <= wt[8] && Jt == zt;
          if (!(Hn || Fr))
            return lt2;
          Ee2 & bt && (lt2[2] = wt[2], sn |= Jt & bt ? 0 : Et);
          var $r = wt[3];
          if ($r) {
            var ki2 = lt2[3];
            lt2[3] = ki2 ? kvt(ki2, $r, wt[4]) : $r, lt2[4] = ki2 ? O5(lt2[3], z3) : wt[4];
          }
          return $r = wt[5], $r && (ki2 = lt2[5], lt2[5] = ki2 ? Pvt(ki2, $r, wt[6]) : $r, lt2[6] = ki2 ? O5(lt2[5], z3) : wt[6]), $r = wt[7], $r && (lt2[7] = $r), Ee2 & ye && (lt2[8] = lt2[8] == null ? wt[8] : Cm(lt2[8], wt[8])), lt2[9] == null && (lt2[9] = wt[9]), lt2[0] = wt[0], lt2[1] = sn, lt2;
        }
        function q0(lt2) {
          var wt = [];
          if (lt2 != null)
            for (var Jt in fg2(lt2))
              wt.push(Jt);
          return wt;
        }
        function Y5t(lt2) {
          return yN.call(lt2);
        }
        function NN(lt2, wt, Jt) {
          return wt = sp(wt === t2 ? lt2.length - 1 : wt, 0), function() {
            for (var Ee2 = arguments, sn = -1, Hn = sp(Ee2.length - wt, 0), Fr = Sa2(Hn); ++sn < Hn; )
              Fr[sn] = Ee2[wt + sn];
            sn = -1;
            for (var $r = Sa2(wt + 1); ++sn < wt; )
              $r[sn] = Ee2[sn];
            return $r[wt] = Jt(Fr), $x(lt2, this, $r);
          };
        }
        function ant(lt2, wt) {
          return wt.length < 2 ? lt2 : xE(lt2, D_(wt, 0, -1));
        }
        function K5t(lt2, wt) {
          for (var Jt = lt2.length, Ee2 = Cm(wt.length, Jt), sn = E_(lt2); Ee2--; ) {
            var Hn = wt[Ee2];
            lt2[Ee2] = Ud2(Hn, Jt) ? sn[Hn] : t2;
          }
          return lt2;
        }
        function ont(lt2, wt) {
          if (!(wt === "constructor" && typeof lt2[wt] == "function") && wt != "__proto__")
            return lt2[wt];
        }
        var cq = lnt(Ivt), FN = ovt || function(lt2, wt) {
          return uv.setTimeout(lt2, wt);
        }, snt = lnt(Nu);
        function Z5(lt2, wt, Jt) {
          var Ee2 = wt + "";
          return snt(lt2, $vt(Ee2, X5t(G5t(Ee2), Jt)));
        }
        function lnt(lt2) {
          var wt = 0, Jt = 0;
          return function() {
            var Ee2 = w5t(), sn = Ue2 - (Ee2 - Jt);
            if (Jt = Ee2, sn > 0) {
              if (++wt >= en)
                return arguments[0];
            } else
              wt = 0;
            return lt2.apply(t2, arguments);
          };
        }
        function NS(lt2, wt) {
          var Jt = -1, Ee2 = lt2.length, sn = Ee2 - 1;
          for (wt = wt === t2 ? Ee2 : wt; ++Jt < wt; ) {
            var Hn = j5(Jt, sn), Fr = lt2[Hn];
            lt2[Hn] = lt2[Jt], lt2[Jt] = Fr;
          }
          return lt2.length = wt, lt2;
        }
        var Kvt = VV(function(lt2) {
          var wt = [];
          return lt2.charCodeAt(0) === 46 && wt.push(""), lt2.replace(E5, function(Jt, Ee2, sn, Hn) {
            wt.push(sn ? Hn.replace(Er, "$1") : Ee2 || Jt);
          }), wt;
        });
        function pA(lt2) {
          if (typeof lt2 == "string" || FS(lt2))
            return lt2;
          var wt = lt2 + "";
          return wt == "0" && 1 / lt2 == -Zr ? "-0" : wt;
        }
        function CE(lt2) {
          if (lt2 != null) {
            try {
              return yb2.call(lt2);
            } catch {
            }
            try {
              return lt2 + "";
            } catch {
            }
          }
          return "";
        }
        function X5t(lt2, wt) {
          return $p(us, function(Jt) {
            var Ee2 = "_." + Jt[0];
            wt & Jt[1] && !H22(lt2, Ee2) && lt2.push(Ee2);
          }), lt2.sort();
        }
        function unt(lt2) {
          if (lt2 instanceof nh2)
            return lt2.clone();
          var wt = new ES(lt2.__wrapped__, lt2.__chain__);
          return wt.__actions__ = E_(lt2.__actions__), wt.__index__ = lt2.__index__, wt.__values__ = lt2.__values__, wt;
        }
        function Q5t(lt2, wt, Jt) {
          (Jt ? y1(lt2, wt, Jt) : wt === t2) ? wt = 1 : wt = sp(fc2(wt), 0);
          var Ee2 = lt2 == null ? 0 : lt2.length;
          if (!Ee2 || wt < 1)
            return [];
          for (var sn = 0, Hn = 0, Fr = Sa2(m0(Ee2 / wt)); sn < Ee2; )
            Fr[Hn++] = D_(lt2, sn, sn += wt);
          return Fr;
        }
        function J5t(lt2) {
          for (var wt = -1, Jt = lt2 == null ? 0 : lt2.length, Ee2 = 0, sn = []; ++wt < Jt; ) {
            var Hn = lt2[wt];
            Hn && (sn[Ee2++] = Hn);
          }
          return sn;
        }
        function tPt() {
          var lt2 = arguments.length;
          if (!lt2)
            return [];
          for (var wt = Sa2(lt2 - 1), Jt = arguments[0], Ee2 = lt2; Ee2--; )
            wt[Ee2 - 1] = arguments[Ee2];
          return eA(ns(Jt) ? E_(Jt) : [Jt], Wy(wt, 1));
        }
        var ePt = rh2(function(lt2, wt) {
          return b0(lt2) ? iO(lt2, Wy(wt, 1, b0, true)) : [];
        }), fq = rh2(function(lt2, wt) {
          var Jt = Qx(wt);
          return b0(Jt) && (Jt = t2), b0(lt2) ? iO(lt2, Wy(wt, 1, b0, true), Ku(Jt, 2)) : [];
        }), dO = rh2(function(lt2, wt) {
          var Jt = Qx(wt);
          return b0(Jt) && (Jt = t2), b0(lt2) ? iO(lt2, Wy(wt, 1, b0, true), t2, Jt) : [];
        });
        function nPt(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          return Ee2 ? (wt = Jt || wt === t2 ? 1 : fc2(wt), D_(lt2, wt < 0 ? 0 : wt, Ee2)) : [];
        }
        function rPt(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          return Ee2 ? (wt = Jt || wt === t2 ? 1 : fc2(wt), wt = Ee2 - wt, D_(lt2, 0, wt < 0 ? 0 : wt)) : [];
        }
        function iPt(lt2, wt) {
          return lt2 && lt2.length ? _b2(lt2, Ku(wt, 3), true, true) : [];
        }
        function cnt(lt2, wt) {
          return lt2 && lt2.length ? _b2(lt2, Ku(wt, 3), true) : [];
        }
        function aPt(lt2, wt, Jt, Ee2) {
          var sn = lt2 == null ? 0 : lt2.length;
          return sn ? (Jt && typeof Jt != "number" && y1(lt2, wt, Jt) && (Jt = 0, Ee2 = sn), kV(lt2, wt, Jt, Ee2)) : [];
        }
        function hq(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          if (!Ee2)
            return -1;
          var sn = Jt == null ? 0 : fc2(Jt);
          return sn < 0 && (sn = sp(Ee2 + sn, 0)), PU(lt2, Ku(wt, 3), sn);
        }
        function fnt(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          if (!Ee2)
            return -1;
          var sn = Ee2 - 1;
          return Jt !== t2 && (sn = fc2(Jt), sn = Jt < 0 ? sp(Ee2 + sn, 0) : Cm(sn, Ee2 - 1)), PU(lt2, Ku(wt, 3), sn, true);
        }
        function BV(lt2) {
          var wt = lt2 == null ? 0 : lt2.length;
          return wt ? Wy(lt2, 1) : [];
        }
        function hnt(lt2) {
          var wt = lt2 == null ? 0 : lt2.length;
          return wt ? Wy(lt2, Zr) : [];
        }
        function oPt(lt2, wt) {
          var Jt = lt2 == null ? 0 : lt2.length;
          return Jt ? (wt = wt === t2 ? 1 : fc2(wt), Wy(lt2, wt)) : [];
        }
        function Xvt(lt2) {
          for (var wt = -1, Jt = lt2 == null ? 0 : lt2.length, Ee2 = {}; ++wt < Jt; ) {
            var sn = lt2[wt];
            Ee2[sn[0]] = sn[1];
          }
          return Ee2;
        }
        function pnt(lt2) {
          return lt2 && lt2.length ? lt2[0] : t2;
        }
        function sPt(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          if (!Ee2)
            return -1;
          var sn = Jt == null ? 0 : fc2(Jt);
          return sn < 0 && (sn = sp(Ee2 + sn, 0)), U2(lt2, wt, sn);
        }
        function lPt(lt2) {
          var wt = lt2 == null ? 0 : lt2.length;
          return wt ? D_(lt2, 0, -1) : [];
        }
        var uPt = rh2(function(lt2) {
          var wt = cv(lt2, H5);
          return wt.length && wt[0] === lt2[0] ? UU(wt) : [];
        }), Qvt = rh2(function(lt2) {
          var wt = Qx(lt2), Jt = cv(lt2, H5);
          return wt === Qx(Jt) ? wt = t2 : Jt.pop(), Jt.length && Jt[0] === lt2[0] ? UU(Jt, Ku(wt, 2)) : [];
        }), cPt = rh2(function(lt2) {
          var wt = Qx(lt2), Jt = cv(lt2, H5);
          return wt = typeof wt == "function" ? wt : t2, wt && Jt.pop(), Jt.length && Jt[0] === lt2[0] ? UU(Jt, t2, wt) : [];
        });
        function fPt(lt2, wt) {
          return lt2 == null ? "" : lvt.call(lt2, wt);
        }
        function Qx(lt2) {
          var wt = lt2 == null ? 0 : lt2.length;
          return wt ? lt2[wt - 1] : t2;
        }
        function hPt(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          if (!Ee2)
            return -1;
          var sn = Ee2;
          return Jt !== t2 && (sn = fc2(Jt), sn = sn < 0 ? sp(Ee2 + sn, 0) : Cm(sn, Ee2 - 1)), wt === wt ? nvt(lt2, wt, sn) : PU(lt2, Mm, sn, true);
        }
        function pPt(lt2, wt) {
          return lt2 && lt2.length ? KU(lt2, fc2(wt)) : t2;
        }
        var dPt = rh2(dnt);
        function dnt(lt2, wt) {
          return lt2 && lt2.length && wt && wt.length ? wE(lt2, wt) : lt2;
        }
        function gnt(lt2, wt, Jt) {
          return lt2 && lt2.length && wt && wt.length ? wE(lt2, wt, Ku(Jt, 2)) : lt2;
        }
        function gO(lt2, wt, Jt) {
          return lt2 && lt2.length && wt && wt.length ? wE(lt2, wt, t2, Jt) : lt2;
        }
        var pq = hA(function(lt2, wt) {
          var Jt = lt2 == null ? 0 : lt2.length, Ee2 = IN(lt2, wt);
          return z5(lt2, cv(wt, function(sn) {
            return Ud2(sn, Jt) ? +sn : sn;
          }).sort(Evt)), Ee2;
        });
        function Jvt(lt2, wt) {
          var Jt = [];
          if (!(lt2 && lt2.length))
            return Jt;
          var Ee2 = -1, sn = [], Hn = lt2.length;
          for (wt = Ku(wt, 3); ++Ee2 < Hn; ) {
            var Fr = lt2[Ee2];
            wt(Fr, Ee2, lt2) && (Jt.push(Fr), sn.push(Ee2));
          }
          return z5(lt2, sn), Jt;
        }
        function vnt(lt2) {
          return lt2 == null ? lt2 : cvt.call(lt2);
        }
        function gPt(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          return Ee2 ? (Jt && typeof Jt != "number" && y1(lt2, wt, Jt) ? (wt = 0, Jt = Ee2) : (wt = wt == null ? 0 : fc2(wt), Jt = Jt === t2 ? Ee2 : fc2(Jt)), D_(lt2, wt, Jt)) : [];
        }
        function ynt(lt2, wt) {
          return cA(lt2, wt);
        }
        function mnt(lt2, wt, Jt) {
          return SE(lt2, wt, Ku(Jt, 2));
        }
        function vPt(lt2, wt) {
          var Jt = lt2 == null ? 0 : lt2.length;
          if (Jt) {
            var Ee2 = cA(lt2, wt);
            if (Ee2 < Jt && X2(lt2[Ee2], wt))
              return Ee2;
          }
          return -1;
        }
        function Y2(lt2, wt) {
          return cA(lt2, wt, true);
        }
        function Jx(lt2, wt, Jt) {
          return SE(lt2, wt, Ku(Jt, 2), true);
        }
        function tw(lt2, wt) {
          var Jt = lt2 == null ? 0 : lt2.length;
          if (Jt) {
            var Ee2 = cA(lt2, wt, true) - 1;
            if (X2(lt2[Ee2], wt))
              return Ee2;
          }
          return -1;
        }
        function bnt(lt2) {
          return lt2 && lt2.length ? W5(lt2) : [];
        }
        function _nt(lt2, wt) {
          return lt2 && lt2.length ? W5(lt2, Ku(wt, 2)) : [];
        }
        function vO(lt2) {
          var wt = lt2 == null ? 0 : lt2.length;
          return wt ? D_(lt2, 1, wt) : [];
        }
        function dq(lt2, wt, Jt) {
          return lt2 && lt2.length ? (wt = Jt || wt === t2 ? 1 : fc2(wt), D_(lt2, 0, wt < 0 ? 0 : wt)) : [];
        }
        function gq(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? 0 : lt2.length;
          return Ee2 ? (wt = Jt || wt === t2 ? 1 : fc2(wt), wt = Ee2 - wt, D_(lt2, wt < 0 ? 0 : wt, Ee2)) : [];
        }
        function vq(lt2, wt) {
          return lt2 && lt2.length ? _b2(lt2, Ku(wt, 3), false, true) : [];
        }
        function yq(lt2, wt) {
          return lt2 && lt2.length ? _b2(lt2, Ku(wt, 3)) : [];
        }
        var t0t = rh2(function(lt2) {
          return G5(Wy(lt2, 1, b0, true));
        }), e0t = rh2(function(lt2) {
          var wt = Qx(lt2);
          return b0(wt) && (wt = t2), G5(Wy(lt2, 1, b0, true), Ku(wt, 2));
        }), n0t = rh2(function(lt2) {
          var wt = Qx(lt2);
          return wt = typeof wt == "function" ? wt : t2, G5(Wy(lt2, 1, b0, true), t2, wt);
        });
        function yPt(lt2) {
          return lt2 && lt2.length ? G5(lt2) : [];
        }
        function mPt(lt2, wt) {
          return lt2 && lt2.length ? G5(lt2, Ku(wt, 2)) : [];
        }
        function bPt(lt2, wt) {
          return wt = typeof wt == "function" ? wt : t2, lt2 && lt2.length ? G5(lt2, t2, wt) : [];
        }
        function Kp(lt2) {
          if (!(lt2 && lt2.length))
            return [];
          var wt = 0;
          return lt2 = y0(lt2, function(Jt) {
            if (b0(Jt))
              return wt = sp(Jt.length, wt), true;
          }), Yx(wt, function(Jt) {
            return cv(lt2, nA(Jt));
          });
        }
        function $5(lt2, wt) {
          if (!(lt2 && lt2.length))
            return [];
          var Jt = Kp(lt2);
          return wt == null ? Jt : cv(Jt, function(Ee2) {
            return $x(wt, t2, Ee2);
          });
        }
        var yO = rh2(function(lt2, wt) {
          return b0(lt2) ? iO(lt2, wt) : [];
        }), dA = rh2(function(lt2) {
          return uO(y0(lt2, b0));
        }), Y5 = rh2(function(lt2) {
          var wt = Qx(lt2);
          return b0(wt) && (wt = t2), uO(y0(lt2, b0), Ku(wt, 2));
        }), gA = rh2(function(lt2) {
          var wt = Qx(lt2);
          return wt = typeof wt == "function" ? wt : t2, uO(y0(lt2, b0), t2, wt);
        }), vA = rh2(Kp);
        function xnt(lt2, wt) {
          return PN(lt2 || [], wt || [], EV);
        }
        function wnt(lt2, wt) {
          return PN(lt2 || [], wt || [], OS);
        }
        var mO = rh2(function(lt2) {
          var wt = lt2.length, Jt = wt > 1 ? lt2[wt - 1] : t2;
          return Jt = typeof Jt == "function" ? (lt2.pop(), Jt) : t2, $5(lt2, Jt);
        });
        function K5(lt2) {
          var wt = In(lt2);
          return wt.__chain__ = true, wt;
        }
        function TE(lt2, wt) {
          return wt(lt2), lt2;
        }
        function VN(lt2, wt) {
          return wt(lt2);
        }
        var X5 = hA(function(lt2) {
          var wt = lt2.length, Jt = wt ? lt2[0] : 0, Ee2 = this.__wrapped__, sn = function(Hn) {
            return IN(Hn, lt2);
          };
          return wt > 1 || this.__actions__.length || !(Ee2 instanceof nh2) || !Ud2(Jt) ? this.thru(sn) : (Ee2 = Ee2.slice(Jt, +Jt + (wt ? 1 : 0)), Ee2.__actions__.push({ func: VN, args: [sn], thisArg: t2 }), new ES(Ee2, this.__chain__).thru(function(Hn) {
            return wt && !Hn.length && Hn.push(t2), Hn;
          }));
        });
        function Snt() {
          return K5(this);
        }
        function zV() {
          return new ES(this.value(), this.__chain__);
        }
        function Mnt() {
          this.__values__ === t2 && (this.__values__ = Nnt(this.value()));
          var lt2 = this.__index__ >= this.__values__.length, wt = lt2 ? t2 : this.__values__[this.__index__++];
          return { done: lt2, value: wt };
        }
        function _Pt() {
          return this;
        }
        function xPt(lt2) {
          for (var wt, Jt = this; Jt instanceof CN; ) {
            var Ee2 = unt(Jt);
            Ee2.__index__ = 0, Ee2.__values__ = t2, wt ? sn.__wrapped__ = Ee2 : wt = Ee2;
            var sn = Ee2;
            Jt = Jt.__wrapped__;
          }
          return sn.__wrapped__ = lt2, wt;
        }
        function yA() {
          var lt2 = this.__wrapped__;
          if (lt2 instanceof nh2) {
            var wt = lt2;
            return this.__actions__.length && (wt = new nh2(this)), wt = wt.reverse(), wt.__actions__.push({ func: VN, args: [vnt], thisArg: t2 }), new ES(wt, this.__chain__);
          }
          return this.thru(vnt);
        }
        function Q5() {
          return Qet(this.__wrapped__, this.__actions__);
        }
        var wPt = cO(function(lt2, wt, Jt) {
          Op.call(lt2, Jt) ? ++lt2[Jt] : PS(lt2, Jt, 1);
        });
        function r0t(lt2, wt, Jt) {
          var Ee2 = ns(lt2) ? P5 : _vt;
          return Jt && y1(lt2, wt, Jt) && (wt = t2), Ee2(lt2, Ku(wt, 3));
        }
        function i0t(lt2, wt) {
          var Jt = ns(lt2) ? y0 : xvt;
          return Jt(lt2, Ku(wt, 3));
        }
        var J5 = Fvt(hq), jV = Fvt(fnt);
        function SPt(lt2, wt) {
          return Wy(mq(lt2, wt), 1);
        }
        function AE(lt2, wt) {
          return Wy(mq(lt2, wt), Zr);
        }
        function tP(lt2, wt, Jt) {
          return Jt = Jt === t2 ? 1 : fc2(Jt), Wy(mq(lt2, wt), Jt);
        }
        function eP(lt2, wt) {
          var Jt = ns(lt2) ? $p : oA;
          return Jt(lt2, Ku(wt, 3));
        }
        function a0t(lt2, wt) {
          var Jt = ns(lt2) ? kU : Wet;
          return Jt(lt2, Ku(wt, 3));
        }
        var MPt = cO(function(lt2, wt, Jt) {
          Op.call(lt2, Jt) ? lt2[Jt].push(wt) : PS(lt2, Jt, [wt]);
        });
        function P_(lt2, wt, Jt, Ee2) {
          lt2 = L_(lt2) ? lt2 : AO(lt2), Jt = Jt && !Ee2 ? fc2(Jt) : 0;
          var sn = lt2.length;
          return Jt < 0 && (Jt = sp(sn + Jt, 0)), wO(lt2) ? Jt <= sn && lt2.indexOf(wt, Jt) > -1 : !!sn && U2(lt2, wt, Jt) > -1;
        }
        var K2 = rh2(function(lt2, wt, Jt) {
          var Ee2 = -1, sn = typeof wt == "function", Hn = L_(lt2) ? Sa2(lt2.length) : [];
          return oA(lt2, function(Fr) {
            Hn[++Ee2] = sn ? $x(wt, Fr, Jt) : I_(Fr, wt, Jt);
          }), Hn;
        }), CPt = cO(function(lt2, wt, Jt) {
          PS(lt2, Jt, wt);
        });
        function mq(lt2, wt) {
          var Jt = ns(lt2) ? cv : OV;
          return Jt(lt2, Ku(wt, 3));
        }
        function TPt(lt2, wt, Jt, Ee2) {
          return lt2 == null ? [] : (ns(wt) || (wt = wt == null ? [] : [wt]), Jt = Ee2 ? t2 : Jt, ns(Jt) || (Jt = Jt == null ? [] : [Jt]), sO(lt2, wt, Jt));
        }
        var APt = cO(function(lt2, wt, Jt) {
          lt2[Jt ? 0 : 1].push(wt);
        }, function() {
          return [[], []];
        });
        function o0t(lt2, wt, Jt) {
          var Ee2 = ns(lt2) ? dE : Qgt, sn = arguments.length < 3;
          return Ee2(lt2, Ku(wt, 4), Jt, sn, oA);
        }
        function IPt(lt2, wt, Jt) {
          var Ee2 = ns(lt2) ? xet : Qgt, sn = arguments.length < 3;
          return Ee2(lt2, Ku(wt, 4), Jt, sn, Wet);
        }
        function DPt(lt2, wt) {
          var Jt = ns(lt2) ? y0 : xvt;
          return Jt(lt2, xq(Ku(wt, 3)));
        }
        function bq(lt2) {
          var wt = ns(lt2) ? yvt : uA;
          return wt(lt2);
        }
        function EPt(lt2, wt, Jt) {
          (Jt ? y1(lt2, wt, Jt) : wt === t2) ? wt = 1 : wt = fc2(wt);
          var Ee2 = ns(lt2) ? zet : Avt;
          return Ee2(lt2, wt);
        }
        function Cnt(lt2) {
          var wt = ns(lt2) ? _E : XU;
          return wt(lt2);
        }
        function kPt(lt2) {
          if (lt2 == null)
            return 0;
          if (L_(lt2))
            return wO(lt2) ? pN(lt2) : lt2.length;
          var wt = v12(lt2);
          return wt == au || wt == _d ? lt2.size : LV(lt2).length;
        }
        function wc2(lt2, wt, Jt) {
          var Ee2 = ns(lt2) ? wet : lO;
          return Jt && y1(lt2, wt, Jt) && (wt = t2), Ee2(lt2, Ku(wt, 3));
        }
        var PPt = rh2(function(lt2, wt) {
          if (lt2 == null)
            return [];
          var Jt = wt.length;
          return Jt > 1 && y1(lt2, wt[0], wt[1]) ? wt = [] : Jt > 2 && y1(wt[0], wt[1], wt[2]) && (wt = [wt[0]]), sO(lt2, Wy(wt, 1), []);
        }), WV = N5 || function() {
          return uv.Date.now();
        };
        function GV(lt2, wt) {
          if (typeof wt != "function")
            throw new DS(M2);
          return lt2 = fc2(lt2), function() {
            if (--lt2 < 1)
              return wt.apply(this, arguments);
          };
        }
        function s0t(lt2, wt, Jt) {
          return wt = Jt ? t2 : wt, wt = lt2 && wt == null ? lt2.length : wt, Am(lt2, ye, t2, t2, t2, t2, wt);
        }
        function l0t(lt2, wt) {
          var Jt;
          if (typeof wt != "function")
            throw new DS(M2);
          return lt2 = fc2(lt2), function() {
            return --lt2 > 0 && (Jt = wt.apply(this, arguments)), lt2 <= 1 && (wt = t2), Jt;
          };
        }
        var Tnt = rh2(function(lt2, wt, Jt) {
          var Ee2 = bt;
          if (Jt.length) {
            var sn = O5(Jt, hO(Tnt));
            Ee2 |= fe2;
          }
          return Am(lt2, Ee2, wt, Jt, sn);
        }), Ant = rh2(function(lt2, wt, Jt) {
          var Ee2 = bt | _t;
          if (Jt.length) {
            var sn = O5(Jt, hO(Ant));
            Ee2 |= fe2;
          }
          return Am(wt, Ee2, lt2, Jt, sn);
        });
        function Im(lt2, wt, Jt) {
          wt = Jt ? t2 : wt;
          var Ee2 = Am(lt2, zt, t2, t2, t2, t2, t2, wt);
          return Ee2.placeholder = Im.placeholder, Ee2;
        }
        function u0t(lt2, wt, Jt) {
          wt = Jt ? t2 : wt;
          var Ee2 = Am(lt2, Ft, t2, t2, t2, t2, t2, wt);
          return Ee2.placeholder = u0t.placeholder, Ee2;
        }
        function bO(lt2, wt, Jt) {
          var Ee2, sn, Hn, Fr, $r, ki2, Ja2 = 0, Io = false, Xo = false, ul = true;
          if (typeof lt2 != "function")
            throw new DS(M2);
          wt = VS(wt) || 0, Zg2(Jt) && (Io = !!Jt.leading, Xo = "maxWait" in Jt, Hn = Xo ? sp(VS(Jt.maxWait) || 0, wt) : Hn, ul = "trailing" in Jt ? !!Jt.trailing : ul);
          function su(fv) {
            var F_ = Ee2, wA = sn;
            return Ee2 = sn = t2, Ja2 = fv, Fr = lt2.apply(wA, F_), Fr;
          }
          function Eu(fv) {
            return Ja2 = fv, $r = FN(Th2, wt), Io ? su(fv) : Fr;
          }
          function hc2(fv) {
            var F_ = fv - ki2, wA = fv - Ja2, Fq = wt - F_;
            return Xo ? Cm(Fq, Hn - wA) : Fq;
          }
          function Wu(fv) {
            var F_ = fv - ki2, wA = fv - Ja2;
            return ki2 === t2 || F_ >= wt || F_ < 0 || Xo && wA >= Hn;
          }
          function Th2() {
            var fv = WV();
            if (Wu(fv))
              return mp(fv);
            $r = FN(Th2, hc2(fv));
          }
          function mp(fv) {
            return $r = t2, ul && Ee2 ? su(fv) : (Ee2 = sn = t2, Fr);
          }
          function m1() {
            $r !== t2 && JU($r), Ja2 = 0, Ee2 = ki2 = sn = $r = t2;
          }
          function wb2() {
            return $r === t2 ? Fr : mp(WV());
          }
          function BS() {
            var fv = WV(), F_ = Wu(fv);
            if (Ee2 = arguments, sn = this, ki2 = fv, F_) {
              if ($r === t2)
                return Eu(ki2);
              if (Xo)
                return JU($r), $r = FN(Th2, wt), su(ki2);
            }
            return $r === t2 && ($r = FN(Th2, wt)), Fr;
          }
          return BS.cancel = m1, BS.flush = wb2, BS;
        }
        var c0t = rh2(function(lt2, wt) {
          return DN(lt2, 1, wt);
        }), f0t = rh2(function(lt2, wt, Jt) {
          return DN(lt2, VS(wt) || 0, Jt);
        });
        function _O(lt2) {
          return Am(lt2, be2);
        }
        function _q(lt2, wt) {
          if (typeof lt2 != "function" || wt != null && typeof wt != "function")
            throw new DS(M2);
          var Jt = function() {
            var Ee2 = arguments, sn = wt ? wt.apply(this, Ee2) : Ee2[0], Hn = Jt.cache;
            if (Hn.has(sn))
              return Hn.get(sn);
            var Fr = lt2.apply(this, Ee2);
            return Jt.cache = Hn.set(sn, Fr) || Hn, Fr;
          };
          return Jt.cache = new (_q.Cache || Z2)(), Jt;
        }
        _q.Cache = Z2;
        function xq(lt2) {
          if (typeof lt2 != "function")
            throw new DS(M2);
          return function() {
            var wt = arguments;
            switch (wt.length) {
              case 0:
                return !lt2.call(this);
              case 1:
                return !lt2.call(this, wt[0]);
              case 2:
                return !lt2.call(this, wt[0], wt[1]);
              case 3:
                return !lt2.call(this, wt[0], wt[1], wt[2]);
            }
            return !lt2.apply(this, wt);
          };
        }
        function h0t(lt2) {
          return l0t(2, lt2);
        }
        var Nf2 = QU(function(lt2, wt) {
          wt = wt.length == 1 && ns(wt[0]) ? cv(wt[0], Kx(Ku())) : cv(Wy(wt, 1), Kx(Ku()));
          var Jt = wt.length;
          return rh2(function(Ee2) {
            for (var sn = -1, Hn = Cm(Ee2.length, Jt); ++sn < Hn; )
              Ee2[sn] = wt[sn].call(this, Ee2[sn]);
            return $x(lt2, this, Ee2);
          });
        }), wq = rh2(function(lt2, wt) {
          var Jt = O5(wt, hO(wq));
          return Am(lt2, fe2, t2, wt, Jt);
        }), Int = rh2(function(lt2, wt) {
          var Jt = O5(wt, hO(Int));
          return Am(lt2, re2, t2, wt, Jt);
        }), LPt = hA(function(lt2, wt) {
          return Am(lt2, me2, t2, t2, t2, wt);
        });
        function p0t(lt2, wt) {
          if (typeof lt2 != "function")
            throw new DS(M2);
          return wt = wt === t2 ? wt : fc2(wt), rh2(lt2, wt);
        }
        function OPt(lt2, wt) {
          if (typeof lt2 != "function")
            throw new DS(M2);
          return wt = wt == null ? 0 : sp(fc2(wt), 0), rh2(function(Jt) {
            var Ee2 = Jt[wt], sn = fA(Jt, 0, wt);
            return Ee2 && eA(sn, Ee2), $x(lt2, this, sn);
          });
        }
        function RPt(lt2, wt, Jt) {
          var Ee2 = true, sn = true;
          if (typeof lt2 != "function")
            throw new DS(M2);
          return Zg2(Jt) && (Ee2 = "leading" in Jt ? !!Jt.leading : Ee2, sn = "trailing" in Jt ? !!Jt.trailing : sn), bO(lt2, wt, { leading: Ee2, maxWait: wt, trailing: sn });
        }
        function d0t(lt2) {
          return s0t(lt2, 1);
        }
        function g0t(lt2, wt) {
          return wq(LN(wt), lt2);
        }
        function v0t() {
          if (!arguments.length)
            return [];
          var lt2 = arguments[0];
          return ns(lt2) ? lt2 : [lt2];
        }
        function y0t(lt2) {
          return A_(lt2, et);
        }
        function NPt(lt2, wt) {
          return wt = typeof wt == "function" ? wt : t2, A_(lt2, et, wt);
        }
        function m0t(lt2) {
          return A_(lt2, H2 | et);
        }
        function b0t(lt2, wt) {
          return wt = typeof wt == "function" ? wt : t2, A_(lt2, H2 | et, wt);
        }
        function _0t(lt2, wt) {
          return wt == null || jet(lt2, wt, Hy(wt));
        }
        function X2(lt2, wt) {
          return lt2 === wt || lt2 !== lt2 && wt !== wt;
        }
        var x0t = nq(PV), Dnt = nq(function(lt2, wt) {
          return lt2 >= wt;
        }), qc2 = qU(function() {
          return arguments;
        }()) ? qU : function(lt2) {
          return $g2(lt2) && Op.call(lt2, "callee") && !_V.call(lt2, "callee");
        }, ns = Sa2.isArray, Ent = gV ? Kx(gV) : R5t;
        function L_(lt2) {
          return lt2 != null && rP(lt2.length) && !R_(lt2);
        }
        function b0(lt2) {
          return $g2(lt2) && L_(lt2);
        }
        function w0t(lt2) {
          return lt2 === true || lt2 === false || $g2(lt2) && bb2(lt2) == es;
        }
        var mA = svt || IE, knt = cN ? Kx(cN) : N5t;
        function HV(lt2) {
          return $g2(lt2) && lt2.nodeType === 1 && !ZV(lt2);
        }
        function Sq(lt2) {
          if (lt2 == null)
            return true;
          if (L_(lt2) && (ns(lt2) || typeof lt2 == "string" || typeof lt2.splice == "function" || mA(lt2) || BN(lt2) || qc2(lt2)))
            return !lt2.length;
          var wt = v12(lt2);
          if (wt == au || wt == _d)
            return !lt2.size;
          if (fC(lt2))
            return !LV(lt2).length;
          for (var Jt in lt2)
            if (Op.call(lt2, Jt))
              return false;
          return true;
        }
        function O_(lt2, wt) {
          return B5(lt2, wt);
        }
        function UV(lt2, wt, Jt) {
          Jt = typeof Jt == "function" ? Jt : t2;
          var Ee2 = Jt ? Jt(lt2, wt) : t2;
          return Ee2 === t2 ? B5(lt2, wt, t2, Jt) : !!Ee2;
        }
        function nP(lt2) {
          if (!$g2(lt2))
            return false;
          var wt = bb2(lt2);
          return wt == bs || wt == il || typeof lt2.message == "string" && typeof lt2.name == "string" && !ZV(lt2);
        }
        function FPt(lt2) {
          return typeof lt2 == "number" && bE(lt2);
        }
        function R_(lt2) {
          if (!Zg2(lt2))
            return false;
          var wt = bb2(lt2);
          return wt == Rl || wt == Mh2 || wt == Rs || wt == Rd2;
        }
        function qV(lt2) {
          return typeof lt2 == "number" && lt2 == fc2(lt2);
        }
        function rP(lt2) {
          return typeof lt2 == "number" && lt2 > -1 && lt2 % 1 == 0 && lt2 <= nr;
        }
        function Zg2(lt2) {
          var wt = typeof lt2;
          return lt2 != null && (wt == "object" || wt == "function");
        }
        function $g2(lt2) {
          return lt2 != null && typeof lt2 == "object";
        }
        var xO = Xgt ? Kx(Xgt) : Svt;
        function S0t(lt2, wt) {
          return lt2 === wt || Zet(lt2, wt, Mp(wt));
        }
        function M0t(lt2, wt, Jt) {
          return Jt = typeof Jt == "function" ? Jt : t2, Zet(lt2, wt, Mp(wt), Jt);
        }
        function Mq(lt2) {
          return Lnt(lt2) && lt2 != +lt2;
        }
        function C0t(lt2) {
          if ($5t(lt2))
            throw new Jc2(_);
          return Mvt(lt2);
        }
        function T0t(lt2) {
          return lt2 === null;
        }
        function Pnt(lt2) {
          return lt2 == null;
        }
        function Lnt(lt2) {
          return typeof lt2 == "number" || $g2(lt2) && bb2(lt2) == eh2;
        }
        function ZV(lt2) {
          if (!$g2(lt2) || bb2(lt2) != Pp)
            return false;
          var wt = JL(lt2);
          if (wt === null)
            return true;
          var Jt = Op.call(wt, "constructor") && wt.constructor;
          return typeof Jt == "function" && Jt instanceof Jt && yb2.call(Jt) == avt;
        }
        var Ont = fl ? Kx(fl) : Cvt;
        function A0t(lt2) {
          return qV(lt2) && lt2 >= -nr && lt2 <= nr;
        }
        var bA = EU ? Kx(EU) : ZU;
        function wO(lt2) {
          return typeof lt2 == "string" || !ns(lt2) && $g2(lt2) && bb2(lt2) == G0;
        }
        function FS(lt2) {
          return typeof lt2 == "symbol" || $g2(lt2) && bb2(lt2) == qg2;
        }
        var BN = vV ? Kx(vV) : $et;
        function VPt(lt2) {
          return lt2 === t2;
        }
        function BPt(lt2) {
          return $g2(lt2) && v12(lt2) == fo;
        }
        function Rnt(lt2) {
          return $g2(lt2) && bb2(lt2) == ra2;
        }
        var SO = nq(Xx), I0t = nq(function(lt2, wt) {
          return lt2 <= wt;
        });
        function Nnt(lt2) {
          if (!lt2)
            return [];
          if (L_(lt2))
            return wO(lt2) ? q2(lt2) : E_(lt2);
          if (R5 && lt2[R5])
            return evt(lt2[R5]());
          var wt = v12(lt2), Jt = wt == au ? mV : wt == _d ? hN : AO;
          return Jt(lt2);
        }
        function Dm(lt2) {
          if (!lt2)
            return lt2 === 0 ? lt2 : 0;
          if (lt2 = VS(lt2), lt2 === Zr || lt2 === -Zr) {
            var wt = lt2 < 0 ? -1 : 1;
            return wt * pr;
          }
          return lt2 === lt2 ? lt2 : 0;
        }
        function fc2(lt2) {
          var wt = Dm(lt2), Jt = wt % 1;
          return wt === wt ? Jt ? wt - Jt : wt : 0;
        }
        function Fnt(lt2) {
          return lt2 ? rO(fc2(lt2), 0, ai2) : 0;
        }
        function VS(lt2) {
          if (typeof lt2 == "number")
            return lt2;
          if (FS(lt2))
            return Nr;
          if (Zg2(lt2)) {
            var wt = typeof lt2.valueOf == "function" ? lt2.valueOf() : lt2;
            lt2 = Zg2(wt) ? wt + "" : wt;
          }
          if (typeof lt2 != "string")
            return lt2 === 0 ? lt2 : +lt2;
          lt2 = OU(lt2);
          var Jt = Ui2.test(lt2);
          return Jt || Ea2.test(lt2) ? pV(lt2.slice(2), Jt ? 2 : 8) : yr.test(lt2) ? Nr : +lt2;
        }
        function Vnt(lt2) {
          return cC(lt2, ew(lt2));
        }
        function D0t(lt2) {
          return lt2 ? rO(fc2(lt2), -nr, nr) : lt2 === 0 ? lt2 : 0;
        }
        function fd2(lt2) {
          return lt2 == null ? "" : g1(lt2);
        }
        var E0t = fO(function(lt2, wt) {
          if (fC(wt) || L_(wt)) {
            cC(wt, Hy(wt), lt2);
            return;
          }
          for (var Jt in wt)
            Op.call(wt, Jt) && EV(lt2, Jt, wt[Jt]);
        }), Cq = fO(function(lt2, wt) {
          cC(wt, ew(wt), lt2);
        }), zN = fO(function(lt2, wt, Jt, Ee2) {
          cC(wt, ew(wt), lt2, Ee2);
        }), zPt = fO(function(lt2, wt, Jt, Ee2) {
          cC(wt, Hy(wt), lt2, Ee2);
        }), Bnt = hA(IN);
        function jPt(lt2, wt) {
          var Jt = p1(lt2);
          return wt == null ? Jt : bvt(Jt, wt);
        }
        var WPt = rh2(function(lt2, wt) {
          lt2 = fg2(lt2);
          var Jt = -1, Ee2 = wt.length, sn = Ee2 > 2 ? wt[2] : t2;
          for (sn && y1(wt[0], wt[1], sn) && (Ee2 = 1); ++Jt < Ee2; )
            for (var Hn = wt[Jt], Fr = ew(Hn), $r = -1, ki2 = Fr.length; ++$r < ki2; ) {
              var Ja2 = Fr[$r], Io = lt2[Ja2];
              (Io === t2 || X2(Io, gN[Ja2]) && !Op.call(lt2, Ja2)) && (lt2[Ja2] = Hn[Ja2]);
            }
          return lt2;
        }), GPt = rh2(function(lt2) {
          return lt2.push(t2, aq), $x(O0t, t2, lt2);
        });
        function k0t(lt2, wt) {
          return gE(lt2, Ku(wt, 3), sA);
        }
        function HPt(lt2, wt) {
          return gE(lt2, Ku(wt, 3), Get);
        }
        function MO(lt2, wt) {
          return lt2 == null ? lt2 : V5(lt2, Ku(wt, 3), ew);
        }
        function UPt(lt2, wt) {
          return lt2 == null ? lt2 : wvt(lt2, Ku(wt, 3), ew);
        }
        function n0(lt2, wt) {
          return lt2 && sA(lt2, Ku(wt, 3));
        }
        function znt(lt2, wt) {
          return lt2 && Get(lt2, Ku(wt, 3));
        }
        function P0t(lt2) {
          return lt2 == null ? [] : EN(lt2, Hy(lt2));
        }
        function qPt(lt2) {
          return lt2 == null ? [] : EN(lt2, ew(lt2));
        }
        function Gy(lt2, wt, Jt) {
          var Ee2 = lt2 == null ? t2 : xE(lt2, wt);
          return Ee2 === t2 ? Jt : Ee2;
        }
        function CO(lt2, wt) {
          return lt2 != null && qvt(lt2, wt, P5t);
        }
        function TO(lt2, wt) {
          return lt2 != null && qvt(lt2, wt, Uet);
        }
        var ZPt = kv(function(lt2, wt, Jt) {
          wt != null && typeof wt.toString != "function" && (wt = yN.call(wt)), lt2[wt] = Jt;
        }, Dq(N_)), $Pt = kv(function(lt2, wt, Jt) {
          wt != null && typeof wt.toString != "function" && (wt = yN.call(wt)), Op.call(lt2, wt) ? lt2[wt].push(Jt) : lt2[wt] = [Jt];
        }, Ku), jnt = rh2(I_);
        function Hy(lt2) {
          return L_(lt2) ? Bet(lt2) : LV(lt2);
        }
        function ew(lt2) {
          return L_(lt2) ? Bet(lt2, true) : F5t(lt2);
        }
        function jN(lt2, wt) {
          var Jt = {};
          return wt = Ku(wt, 3), sA(lt2, function(Ee2, sn, Hn) {
            PS(Jt, wt(Ee2, sn, Hn), Ee2);
          }), Jt;
        }
        function YPt(lt2, wt) {
          var Jt = {};
          return wt = Ku(wt, 3), sA(lt2, function(Ee2, sn, Hn) {
            PS(Jt, sn, wt(Ee2, sn, Hn));
          }), Jt;
        }
        var L0t = fO(function(lt2, wt, Jt) {
          LS(lt2, wt, Jt);
        }), O0t = fO(function(lt2, wt, Jt, Ee2) {
          LS(lt2, wt, Jt, Ee2);
        }), R0t = hA(function(lt2, wt) {
          var Jt = {};
          if (lt2 == null)
            return Jt;
          var Ee2 = false;
          wt = cv(wt, function(Hn) {
            return Hn = Tm(Hn, lt2), Ee2 || (Ee2 = Hn.length > 1), Hn;
          }), cC(lt2, lq(lt2), Jt), Ee2 && (Jt = A_(Jt, H2 | $ | et, Wvt));
          for (var sn = wt.length; sn--; )
            Yu(Jt, wt[sn]);
          return Jt;
        });
        function Wnt(lt2, wt) {
          return $V(lt2, xq(Ku(wt)));
        }
        var Tq = hA(function(lt2, wt) {
          return lt2 == null ? {} : V5t(lt2, wt);
        });
        function $V(lt2, wt) {
          if (lt2 == null)
            return {};
          var Jt = cv(lq(lt2), function(Ee2) {
            return [Ee2];
          });
          return wt = Ku(wt), Yet(lt2, Jt, function(Ee2, sn) {
            return wt(Ee2, sn[0]);
          });
        }
        function YV(lt2, wt, Jt) {
          wt = Tm(wt, lt2);
          var Ee2 = -1, sn = wt.length;
          for (sn || (sn = 1, lt2 = t2); ++Ee2 < sn; ) {
            var Hn = lt2 == null ? t2 : lt2[pA(wt[Ee2])];
            Hn === t2 && (Ee2 = sn, Hn = Jt), lt2 = R_(Hn) ? Hn.call(lt2) : Hn;
          }
          return lt2;
        }
        function N0t(lt2, wt, Jt) {
          return lt2 == null ? lt2 : OS(lt2, wt, Jt);
        }
        function Gnt(lt2, wt, Jt, Ee2) {
          return Ee2 = typeof Ee2 == "function" ? Ee2 : t2, lt2 == null ? lt2 : OS(lt2, wt, Jt, Ee2);
        }
        var Hnt = zvt(Hy), Unt = zvt(ew);
        function KPt(lt2, wt, Jt) {
          var Ee2 = ns(lt2), sn = Ee2 || mA(lt2) || BN(lt2);
          if (wt = Ku(wt, 4), Jt == null) {
            var Hn = lt2 && lt2.constructor;
            sn ? Jt = Ee2 ? new Hn() : [] : Zg2(lt2) ? Jt = R_(Hn) ? p1(JL(lt2)) : {} : Jt = {};
          }
          return (sn ? $p : sA)(lt2, function(Fr, $r, ki2) {
            return wt(Jt, Fr, $r, ki2);
          }), Jt;
        }
        function XPt(lt2, wt) {
          return lt2 == null ? true : Yu(lt2, wt);
        }
        function QPt(lt2, wt, Jt) {
          return lt2 == null ? lt2 : Xet(lt2, wt, LN(Jt));
        }
        function F0t(lt2, wt, Jt, Ee2) {
          return Ee2 = typeof Ee2 == "function" ? Ee2 : t2, lt2 == null ? lt2 : Xet(lt2, wt, LN(Jt), Ee2);
        }
        function AO(lt2) {
          return lt2 == null ? [] : RU(lt2, Hy(lt2));
        }
        function V0t(lt2) {
          return lt2 == null ? [] : RU(lt2, ew(lt2));
        }
        function B0t(lt2, wt, Jt) {
          return Jt === t2 && (Jt = wt, wt = t2), Jt !== t2 && (Jt = VS(Jt), Jt = Jt === Jt ? Jt : 0), wt !== t2 && (wt = VS(wt), wt = wt === wt ? wt : 0), rO(VS(lt2), wt, Jt);
        }
        function JPt(lt2, wt, Jt) {
          return wt = Dm(wt), Jt === t2 ? (Jt = wt, wt = 0) : Jt = Dm(Jt), lt2 = VS(lt2), L5t(lt2, wt, Jt);
        }
        function t3t(lt2, wt, Jt) {
          if (Jt && typeof Jt != "boolean" && y1(lt2, wt, Jt) && (wt = Jt = t2), Jt === t2 && (typeof wt == "boolean" ? (Jt = wt, wt = t2) : typeof lt2 == "boolean" && (Jt = lt2, lt2 = t2)), lt2 === t2 && wt === t2 ? (lt2 = 0, wt = 1) : (lt2 = Dm(lt2), wt === t2 ? (wt = lt2, lt2 = 0) : wt = Dm(wt)), lt2 > wt) {
            var Ee2 = lt2;
            lt2 = wt, wt = Ee2;
          }
          if (Jt || lt2 % 1 || wt % 1) {
            var sn = _N();
            return Cm(lt2 + sn * (wt - lt2 + l5t("1e-" + ((sn + "").length - 1))), wt);
          }
          return j5(lt2, wt);
        }
        var qnt = ON(function(lt2, wt, Jt) {
          return wt = wt.toLowerCase(), lt2 + (Jt ? z0t(wt) : wt);
        });
        function z0t(lt2) {
          return Knt(fd2(lt2).toLowerCase());
        }
        function Znt(lt2) {
          return lt2 = fd2(lt2), lt2 && lt2.replace(Jn, h5t).replace(As, "");
        }
        function _A(lt2, wt, Jt) {
          lt2 = fd2(lt2), wt = g1(wt);
          var Ee2 = lt2.length;
          Jt = Jt === t2 ? Ee2 : rO(fc2(Jt), 0, Ee2);
          var sn = Jt;
          return Jt -= wt.length, Jt >= 0 && lt2.slice(Jt, sn) == wt;
        }
        function e3t(lt2) {
          return lt2 = fd2(lt2), lt2 && yy.test(lt2) ? lt2.replace(t0, tvt) : lt2;
        }
        function j0t(lt2) {
          return lt2 = fd2(lt2), lt2 && uV.test(lt2) ? lt2.replace(sE, "\\$&") : lt2;
        }
        var $nt = ON(function(lt2, wt, Jt) {
          return lt2 + (Jt ? "-" : "") + wt.toLowerCase();
        }), W0t = ON(function(lt2, wt, Jt) {
          return lt2 + (Jt ? " " : "") + wt.toLowerCase();
        }), Ynt = ent("toLowerCase");
        function IO(lt2, wt, Jt) {
          lt2 = fd2(lt2), wt = fc2(wt);
          var Ee2 = wt ? pN(lt2) : 0;
          if (!wt || Ee2 >= wt)
            return lt2;
          var sn = (wt - Ee2) / 2;
          return eq2(wV(sn), Jt) + lt2 + eq2(m0(sn), Jt);
        }
        function WN(lt2, wt, Jt) {
          lt2 = fd2(lt2), wt = fc2(wt);
          var Ee2 = wt ? pN(lt2) : 0;
          return wt && Ee2 < wt ? lt2 + eq2(wt - Ee2, Jt) : lt2;
        }
        function n3t(lt2, wt, Jt) {
          lt2 = fd2(lt2), wt = fc2(wt);
          var Ee2 = wt ? pN(lt2) : 0;
          return wt && Ee2 < wt ? eq2(wt - Ee2, Jt) + lt2 : lt2;
        }
        function xb2(lt2, wt, Jt) {
          return Jt || wt == null ? wt = 0 : wt && (wt = +wt), uvt(fd2(lt2).replace(lE, ""), wt || 0);
        }
        function G0t(lt2, wt, Jt) {
          return (Jt ? y1(lt2, wt, Jt) : wt === t2) ? wt = 1 : wt = fc2(wt), RV(fd2(lt2), wt);
        }
        function KV() {
          var lt2 = arguments, wt = fd2(lt2[0]);
          return lt2.length < 3 ? wt : wt.replace(lt2[1], lt2[2]);
        }
        var XV = ON(function(lt2, wt, Jt) {
          return lt2 + (Jt ? "_" : "") + wt.toLowerCase();
        });
        function xA(lt2, wt, Jt) {
          return Jt && typeof Jt != "number" && y1(lt2, wt, Jt) && (wt = Jt = t2), Jt = Jt === t2 ? ai2 : Jt >>> 0, Jt ? (lt2 = fd2(lt2), lt2 && (typeof wt == "string" || wt != null && !Ont(wt)) && (wt = g1(wt), !wt && fN(lt2)) ? fA(q2(lt2), 0, Jt) : lt2.split(wt, Jt)) : [];
        }
        var hC = ON(function(lt2, wt, Jt) {
          return lt2 + (Jt ? " " : "") + Knt(wt);
        });
        function r3t(lt2, wt, Jt) {
          return lt2 = fd2(lt2), Jt = Jt == null ? 0 : rO(fc2(Jt), 0, lt2.length), wt = g1(wt), lt2.slice(Jt, Jt + wt.length) == wt;
        }
        function Aq(lt2, wt, Jt) {
          var Ee2 = In.templateSettings;
          Jt && y1(lt2, wt, Jt) && (wt = t2), lt2 = fd2(lt2), wt = zN({}, wt, Ee2, jvt);
          var sn = zN({}, wt.imports, Ee2.imports, jvt), Hn = Hy(sn), Fr = RU(sn, Hn), $r, ki2, Ja2 = 0, Io = wt.interpolate || $l, Xo = "__p += '", ul = FU((wt.escape || $l).source + "|" + Io.source + "|" + (Io === qx ? Ln : $l).source + "|" + (wt.evaluate || $l).source + "|$", "g"), su = "//# sourceURL=" + (Op.call(wt, "sourceURL") ? (wt.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++Ch2 + "]") + `
`;
          lt2.replace(ul, function(Wu, Th2, mp, m1, wb2, BS) {
            return mp || (mp = m1), Xo += lt2.slice(Ja2, BS).replace($f2, p5t), Th2 && ($r = true, Xo += `' +
__e(` + Th2 + `) +
'`), wb2 && (ki2 = true, Xo += `';
` + wb2 + `;
__p += '`), mp && (Xo += `' +
((__t = (` + mp + `)) == null ? '' : __t) +
'`), Ja2 = BS + Wu.length, Wu;
          }), Xo += `';
`;
          var Eu = Op.call(wt, "variable") && wt.variable;
          if (!Eu)
            Xo = `with (obj) {
` + Xo + `
}
`;
          else if (_r.test(Eu))
            throw new Jc2(I2);
          Xo = (ki2 ? Xo.replace(gb2, "") : Xo).replace(x_, "$1").replace(W2, "$1;"), Xo = "function(" + (Eu || "obj") + `) {
` + (Eu ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + ($r ? ", __e = _.escape" : "") + (ki2 ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Xo + `return __p
}`;
          var hc2 = q0t(function() {
            return Yp(Hn, su + "return " + Xo).apply(t2, Fr);
          });
          if (hc2.source = Xo, nP(hc2))
            throw hc2;
          return hc2;
        }
        function i3t(lt2) {
          return fd2(lt2).toLowerCase();
        }
        function a3t(lt2) {
          return fd2(lt2).toUpperCase();
        }
        function o3t(lt2, wt, Jt) {
          if (lt2 = fd2(lt2), lt2 && (Jt || wt === t2))
            return OU(lt2);
          if (!lt2 || !(wt = g1(wt)))
            return lt2;
          var Ee2 = q2(lt2), sn = q2(wt), Hn = Jgt(Ee2, sn), Fr = NU(Ee2, sn) + 1;
          return fA(Ee2, Hn, Fr).join("");
        }
        function H0t(lt2, wt, Jt) {
          if (lt2 = fd2(lt2), lt2 && (Jt || wt === t2))
            return lt2.slice(0, rvt(lt2) + 1);
          if (!lt2 || !(wt = g1(wt)))
            return lt2;
          var Ee2 = q2(lt2), sn = NU(Ee2, q2(wt)) + 1;
          return fA(Ee2, 0, sn).join("");
        }
        function nw(lt2, wt, Jt) {
          if (lt2 = fd2(lt2), lt2 && (Jt || wt === t2))
            return lt2.replace(lE, "");
          if (!lt2 || !(wt = g1(wt)))
            return lt2;
          var Ee2 = q2(lt2), sn = Jgt(Ee2, q2(wt));
          return fA(Ee2, sn).join("");
        }
        function s3t(lt2, wt) {
          var Jt = Te2, Ee2 = We;
          if (Zg2(wt)) {
            var sn = "separator" in wt ? wt.separator : sn;
            Jt = "length" in wt ? fc2(wt.length) : Jt, Ee2 = "omission" in wt ? g1(wt.omission) : Ee2;
          }
          lt2 = fd2(lt2);
          var Hn = lt2.length;
          if (fN(lt2)) {
            var Fr = q2(lt2);
            Hn = Fr.length;
          }
          if (Jt >= Hn)
            return lt2;
          var $r = Jt - pN(Ee2);
          if ($r < 1)
            return Ee2;
          var ki2 = Fr ? fA(Fr, 0, $r).join("") : lt2.slice(0, $r);
          if (sn === t2)
            return ki2 + Ee2;
          if (Fr && ($r += ki2.length - $r), Ont(sn)) {
            if (lt2.slice($r).search(sn)) {
              var Ja2, Io = ki2;
              for (sn.global || (sn = FU(sn.source, fd2(cr.exec(sn)) + "g")), sn.lastIndex = 0; Ja2 = sn.exec(Io); )
                var Xo = Ja2.index;
              ki2 = ki2.slice(0, Xo === t2 ? $r : Xo);
            }
          } else if (lt2.indexOf(g1(sn), $r) != $r) {
            var ul = ki2.lastIndexOf(sn);
            ul > -1 && (ki2 = ki2.slice(0, ul));
          }
          return ki2 + Ee2;
        }
        function U0t(lt2) {
          return lt2 = fd2(lt2), lt2 && Hh2.test(lt2) ? lt2.replace(w_, Det) : lt2;
        }
        var Iq = ON(function(lt2, wt, Jt) {
          return lt2 + (Jt ? " " : "") + wt.toUpperCase();
        }), Knt = ent("toUpperCase");
        function Xnt(lt2, wt, Jt) {
          return lt2 = fd2(lt2), wt = Jt ? t2 : wt, wt === t2 ? Iet(lt2) ? v5t(lt2) : Cet(lt2) : lt2.match(wt) || [];
        }
        var q0t = rh2(function(lt2, wt) {
          try {
            return $x(lt2, t2, wt);
          } catch (Jt) {
            return nP(Jt) ? Jt : new Jc2(Jt);
          }
        }), Z0t = hA(function(lt2, wt) {
          return $p(wt, function(Jt) {
            Jt = pA(Jt), PS(lt2, Jt, Tnt(lt2[Jt], lt2));
          }), lt2;
        });
        function rw(lt2) {
          var wt = lt2 == null ? 0 : lt2.length, Jt = Ku();
          return lt2 = wt ? cv(lt2, function(Ee2) {
            if (typeof Ee2[1] != "function")
              throw new DS(M2);
            return [Jt(Ee2[0]), Ee2[1]];
          }) : [], rh2(function(Ee2) {
            for (var sn = -1; ++sn < wt; ) {
              var Hn = lt2[sn];
              if ($x(Hn[0], this, Ee2))
                return $x(Hn[1], this, Ee2);
            }
          });
        }
        function l3t(lt2) {
          return HU(A_(lt2, H2));
        }
        function Dq(lt2) {
          return function() {
            return lt2;
          };
        }
        function iw(lt2, wt) {
          return lt2 == null || lt2 !== lt2 ? wt : lt2;
        }
        var u3t = yp(), c3t = yp(true);
        function N_(lt2) {
          return lt2;
        }
        function by(lt2) {
          return $U(typeof lt2 == "function" ? lt2 : A_(lt2, H2));
        }
        function aw(lt2) {
          return YU(A_(lt2, H2));
        }
        function f3t(lt2, wt) {
          return lA(lt2, A_(wt, H2));
        }
        var $0t = rh2(function(lt2, wt) {
          return function(Jt) {
            return I_(Jt, lt2, wt);
          };
        }), Y0t = rh2(function(lt2, wt) {
          return function(Jt) {
            return I_(lt2, Jt, wt);
          };
        });
        function GN(lt2, wt, Jt) {
          var Ee2 = Hy(wt), sn = EN(wt, Ee2);
          Jt == null && !(Zg2(wt) && (sn.length || !Ee2.length)) && (Jt = wt, wt = lt2, lt2 = this, sn = EN(wt, Hy(wt)));
          var Hn = !(Zg2(Jt) && "chain" in Jt) || !!Jt.chain, Fr = R_(lt2);
          return $p(sn, function($r) {
            var ki2 = wt[$r];
            lt2[$r] = ki2, Fr && (lt2.prototype[$r] = function() {
              var Ja2 = this.__chain__;
              if (Hn || Ja2) {
                var Io = lt2(this.__wrapped__), Xo = Io.__actions__ = E_(this.__actions__);
                return Xo.push({ func: ki2, args: arguments, thisArg: lt2 }), Io.__chain__ = Ja2, Io;
              }
              return ki2.apply(lt2, eA([this.value()], arguments));
            });
          }), lt2;
        }
        function h3t() {
          return uv._ === this && (uv._ = b5t), this;
        }
        function Eq() {
        }
        function Qnt(lt2) {
          return lt2 = fc2(lt2), rh2(function(wt) {
            return KU(wt, lt2);
          });
        }
        var p3t = $2(cv), Jnt = $2(P5), d3t = $2(wet);
        function trt(lt2) {
          return pO(lt2) ? nA(pA(lt2)) : Tvt(lt2);
        }
        function g3t(lt2) {
          return function(wt) {
            return lt2 == null ? t2 : xE(lt2, wt);
          };
        }
        var QV = Bvt(), v3t = Bvt(true);
        function kq() {
          return [];
        }
        function IE() {
          return false;
        }
        function DO() {
          return {};
        }
        function Pq() {
          return "";
        }
        function Lq() {
          return true;
        }
        function y3t(lt2, wt) {
          if (lt2 = fc2(lt2), lt2 < 1 || lt2 > nr)
            return [];
          var Jt = ai2, Ee2 = Cm(lt2, ai2);
          wt = Ku(wt), lt2 -= ai2;
          for (var sn = Yx(Ee2, wt); ++Jt < lt2; )
            wt(Jt);
          return sn;
        }
        function Oq(lt2) {
          return ns(lt2) ? cv(lt2, pA) : FS(lt2) ? [lt2] : E_(Kvt(fd2(lt2)));
        }
        function m3t(lt2) {
          var wt = ++vN;
          return fd2(lt2) + wt;
        }
        var b3t = k_(function(lt2, wt) {
          return lt2 + wt;
        }, 0), _3t = rq("ceil"), K0t = k_(function(lt2, wt) {
          return lt2 / wt;
        }, 1), HN = rq("floor");
        function ert(lt2) {
          return lt2 && lt2.length ? aO(lt2, N_, PV) : t2;
        }
        function Yf2(lt2, wt) {
          return lt2 && lt2.length ? aO(lt2, Ku(wt, 2), PV) : t2;
        }
        function Yg2(lt2) {
          return vE(lt2, N_);
        }
        function UN(lt2, wt) {
          return vE(lt2, Ku(wt, 2));
        }
        function iP(lt2) {
          return lt2 && lt2.length ? aO(lt2, N_, Xx) : t2;
        }
        function X0t(lt2, wt) {
          return lt2 && lt2.length ? aO(lt2, Ku(wt, 2), Xx) : t2;
        }
        var JV = k_(function(lt2, wt) {
          return lt2 * wt;
        }, 1), pC = rq("round"), x3t = k_(function(lt2, wt) {
          return lt2 - wt;
        }, 0);
        function Rq(lt2) {
          return lt2 && lt2.length ? Tet(lt2, N_) : 0;
        }
        function Nq(lt2, wt) {
          return lt2 && lt2.length ? Tet(lt2, Ku(wt, 2)) : 0;
        }
        return In.after = GV, In.ary = s0t, In.assign = E0t, In.assignIn = Cq, In.assignInWith = zN, In.assignWith = zPt, In.at = Bnt, In.before = l0t, In.bind = Tnt, In.bindAll = Z0t, In.bindKey = Ant, In.castArray = v0t, In.chain = K5, In.chunk = Q5t, In.compact = J5t, In.concat = tPt, In.cond = rw, In.conforms = l3t, In.constant = Dq, In.countBy = wPt, In.create = jPt, In.curry = Im, In.curryRight = u0t, In.debounce = bO, In.defaults = WPt, In.defaultsDeep = GPt, In.defer = c0t, In.delay = f0t, In.difference = ePt, In.differenceBy = fq, In.differenceWith = dO, In.drop = nPt, In.dropRight = rPt, In.dropRightWhile = iPt, In.dropWhile = cnt, In.fill = aPt, In.filter = i0t, In.flatMap = SPt, In.flatMapDeep = AE, In.flatMapDepth = tP, In.flatten = BV, In.flattenDeep = hnt, In.flattenDepth = oPt, In.flip = _O, In.flow = u3t, In.flowRight = c3t, In.fromPairs = Xvt, In.functions = P0t, In.functionsIn = qPt, In.groupBy = MPt, In.initial = lPt, In.intersection = uPt, In.intersectionBy = Qvt, In.intersectionWith = cPt, In.invert = ZPt, In.invertBy = $Pt, In.invokeMap = K2, In.iteratee = by, In.keyBy = CPt, In.keys = Hy, In.keysIn = ew, In.map = mq, In.mapKeys = jN, In.mapValues = YPt, In.matches = aw, In.matchesProperty = f3t, In.memoize = _q, In.merge = L0t, In.mergeWith = O0t, In.method = $0t, In.methodOf = Y0t, In.mixin = GN, In.negate = xq, In.nthArg = Qnt, In.omit = R0t, In.omitBy = Wnt, In.once = h0t, In.orderBy = TPt, In.over = p3t, In.overArgs = Nf2, In.overEvery = Jnt, In.overSome = d3t, In.partial = wq, In.partialRight = Int, In.partition = APt, In.pick = Tq, In.pickBy = $V, In.property = trt, In.propertyOf = g3t, In.pull = dPt, In.pullAll = dnt, In.pullAllBy = gnt, In.pullAllWith = gO, In.pullAt = pq, In.range = QV, In.rangeRight = v3t, In.rearg = LPt, In.reject = DPt, In.remove = Jvt, In.rest = p0t, In.reverse = vnt, In.sampleSize = EPt, In.set = N0t, In.setWith = Gnt, In.shuffle = Cnt, In.slice = gPt, In.sortBy = PPt, In.sortedUniq = bnt, In.sortedUniqBy = _nt, In.split = xA, In.spread = OPt, In.tail = vO, In.take = dq, In.takeRight = gq, In.takeRightWhile = vq, In.takeWhile = yq, In.tap = TE, In.throttle = RPt, In.thru = VN, In.toArray = Nnt, In.toPairs = Hnt, In.toPairsIn = Unt, In.toPath = Oq, In.toPlainObject = Vnt, In.transform = KPt, In.unary = d0t, In.union = t0t, In.unionBy = e0t, In.unionWith = n0t, In.uniq = yPt, In.uniqBy = mPt, In.uniqWith = bPt, In.unset = XPt, In.unzip = Kp, In.unzipWith = $5, In.update = QPt, In.updateWith = F0t, In.values = AO, In.valuesIn = V0t, In.without = yO, In.words = Xnt, In.wrap = g0t, In.xor = dA, In.xorBy = Y5, In.xorWith = gA, In.zip = vA, In.zipObject = xnt, In.zipObjectDeep = wnt, In.zipWith = mO, In.entries = Hnt, In.entriesIn = Unt, In.extend = Cq, In.extendWith = zN, GN(In, In), In.add = b3t, In.attempt = q0t, In.camelCase = qnt, In.capitalize = z0t, In.ceil = _3t, In.clamp = B0t, In.clone = y0t, In.cloneDeep = m0t, In.cloneDeepWith = b0t, In.cloneWith = NPt, In.conformsTo = _0t, In.deburr = Znt, In.defaultTo = iw, In.divide = K0t, In.endsWith = _A, In.eq = X2, In.escape = e3t, In.escapeRegExp = j0t, In.every = r0t, In.find = J5, In.findIndex = hq, In.findKey = k0t, In.findLast = jV, In.findLastIndex = fnt, In.findLastKey = HPt, In.floor = HN, In.forEach = eP, In.forEachRight = a0t, In.forIn = MO, In.forInRight = UPt, In.forOwn = n0, In.forOwnRight = znt, In.get = Gy, In.gt = x0t, In.gte = Dnt, In.has = CO, In.hasIn = TO, In.head = pnt, In.identity = N_, In.includes = P_, In.indexOf = sPt, In.inRange = JPt, In.invoke = jnt, In.isArguments = qc2, In.isArray = ns, In.isArrayBuffer = Ent, In.isArrayLike = L_, In.isArrayLikeObject = b0, In.isBoolean = w0t, In.isBuffer = mA, In.isDate = knt, In.isElement = HV, In.isEmpty = Sq, In.isEqual = O_, In.isEqualWith = UV, In.isError = nP, In.isFinite = FPt, In.isFunction = R_, In.isInteger = qV, In.isLength = rP, In.isMap = xO, In.isMatch = S0t, In.isMatchWith = M0t, In.isNaN = Mq, In.isNative = C0t, In.isNil = Pnt, In.isNull = T0t, In.isNumber = Lnt, In.isObject = Zg2, In.isObjectLike = $g2, In.isPlainObject = ZV, In.isRegExp = Ont, In.isSafeInteger = A0t, In.isSet = bA, In.isString = wO, In.isSymbol = FS, In.isTypedArray = BN, In.isUndefined = VPt, In.isWeakMap = BPt, In.isWeakSet = Rnt, In.join = fPt, In.kebabCase = $nt, In.last = Qx, In.lastIndexOf = hPt, In.lowerCase = W0t, In.lowerFirst = Ynt, In.lt = SO, In.lte = I0t, In.max = ert, In.maxBy = Yf2, In.mean = Yg2, In.meanBy = UN, In.min = iP, In.minBy = X0t, In.stubArray = kq, In.stubFalse = IE, In.stubObject = DO, In.stubString = Pq, In.stubTrue = Lq, In.multiply = JV, In.nth = pPt, In.noConflict = h3t, In.noop = Eq, In.now = WV, In.pad = IO, In.padEnd = WN, In.padStart = n3t, In.parseInt = xb2, In.random = t3t, In.reduce = o0t, In.reduceRight = IPt, In.repeat = G0t, In.replace = KV, In.result = YV, In.round = pC, In.runInContext = hi2, In.sample = bq, In.size = kPt, In.snakeCase = XV, In.some = wc2, In.sortedIndex = ynt, In.sortedIndexBy = mnt, In.sortedIndexOf = vPt, In.sortedLastIndex = Y2, In.sortedLastIndexBy = Jx, In.sortedLastIndexOf = tw, In.startCase = hC, In.startsWith = r3t, In.subtract = x3t, In.sum = Rq, In.sumBy = Nq, In.template = Aq, In.times = y3t, In.toFinite = Dm, In.toInteger = fc2, In.toLength = Fnt, In.toLower = i3t, In.toNumber = VS, In.toSafeInteger = D0t, In.toString = fd2, In.toUpper = a3t, In.trim = o3t, In.trimEnd = H0t, In.trimStart = nw, In.truncate = s3t, In.unescape = U0t, In.uniqueId = m3t, In.upperCase = Iq, In.upperFirst = Knt, In.each = eP, In.eachRight = a0t, In.first = pnt, GN(In, function() {
          var lt2 = {};
          return sA(In, function(wt, Jt) {
            Op.call(In.prototype, Jt) || (lt2[Jt] = wt);
          }), lt2;
        }(), { chain: false }), In.VERSION = h, $p(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(lt2) {
          In[lt2].placeholder = In;
        }), $p(["drop", "take"], function(lt2, wt) {
          nh2.prototype[lt2] = function(Jt) {
            Jt = Jt === t2 ? 1 : sp(fc2(Jt), 0);
            var Ee2 = this.__filtered__ && !wt ? new nh2(this) : this.clone();
            return Ee2.__filtered__ ? Ee2.__takeCount__ = Cm(Jt, Ee2.__takeCount__) : Ee2.__views__.push({ size: Cm(Jt, ai2), type: lt2 + (Ee2.__dir__ < 0 ? "Right" : "") }), Ee2;
          }, nh2.prototype[lt2 + "Right"] = function(Jt) {
            return this.reverse()[lt2](Jt).reverse();
          };
        }), $p(["filter", "map", "takeWhile"], function(lt2, wt) {
          var Jt = wt + 1, Ee2 = Jt == Mn || Jt == xn;
          nh2.prototype[lt2] = function(sn) {
            var Hn = this.clone();
            return Hn.__iteratees__.push({ iteratee: Ku(sn, 3), type: Jt }), Hn.__filtered__ = Hn.__filtered__ || Ee2, Hn;
          };
        }), $p(["head", "last"], function(lt2, wt) {
          var Jt = "take" + (wt ? "Right" : "");
          nh2.prototype[lt2] = function() {
            return this[Jt](1).value()[0];
          };
        }), $p(["initial", "tail"], function(lt2, wt) {
          var Jt = "drop" + (wt ? "" : "Right");
          nh2.prototype[lt2] = function() {
            return this.__filtered__ ? new nh2(this) : this[Jt](1);
          };
        }), nh2.prototype.compact = function() {
          return this.filter(N_);
        }, nh2.prototype.find = function(lt2) {
          return this.filter(lt2).head();
        }, nh2.prototype.findLast = function(lt2) {
          return this.reverse().find(lt2);
        }, nh2.prototype.invokeMap = rh2(function(lt2, wt) {
          return typeof lt2 == "function" ? new nh2(this) : this.map(function(Jt) {
            return I_(Jt, lt2, wt);
          });
        }), nh2.prototype.reject = function(lt2) {
          return this.filter(xq(Ku(lt2)));
        }, nh2.prototype.slice = function(lt2, wt) {
          lt2 = fc2(lt2);
          var Jt = this;
          return Jt.__filtered__ && (lt2 > 0 || wt < 0) ? new nh2(Jt) : (lt2 < 0 ? Jt = Jt.takeRight(-lt2) : lt2 && (Jt = Jt.drop(lt2)), wt !== t2 && (wt = fc2(wt), Jt = wt < 0 ? Jt.dropRight(-wt) : Jt.take(wt - lt2)), Jt);
        }, nh2.prototype.takeRightWhile = function(lt2) {
          return this.reverse().takeWhile(lt2).reverse();
        }, nh2.prototype.toArray = function() {
          return this.take(ai2);
        }, sA(nh2.prototype, function(lt2, wt) {
          var Jt = /^(?:filter|find|map|reject)|While$/.test(wt), Ee2 = /^(?:head|last)$/.test(wt), sn = In[Ee2 ? "take" + (wt == "last" ? "Right" : "") : wt], Hn = Ee2 || /^find/.test(wt);
          !sn || (In.prototype[wt] = function() {
            var Fr = this.__wrapped__, $r = Ee2 ? [1] : arguments, ki2 = Fr instanceof nh2, Ja2 = $r[0], Io = ki2 || ns(Fr), Xo = function(Th2) {
              var mp = sn.apply(In, eA([Th2], $r));
              return Ee2 && ul ? mp[0] : mp;
            };
            Io && Jt && typeof Ja2 == "function" && Ja2.length != 1 && (ki2 = Io = false);
            var ul = this.__chain__, su = !!this.__actions__.length, Eu = Hn && !ul, hc2 = ki2 && !su;
            if (!Hn && Io) {
              Fr = hc2 ? Fr : new nh2(this);
              var Wu = lt2.apply(Fr, $r);
              return Wu.__actions__.push({ func: VN, args: [Xo], thisArg: t2 }), new ES(Wu, ul);
            }
            return Eu && hc2 ? lt2.apply(this, $r) : (Wu = this.thru(Xo), Eu ? Ee2 ? Wu.value()[0] : Wu.value() : Wu);
          });
        }), $p(["pop", "push", "shift", "sort", "splice", "unshift"], function(lt2) {
          var wt = dN[lt2], Jt = /^(?:push|sort|unshift)$/.test(lt2) ? "tap" : "thru", Ee2 = /^(?:pop|shift)$/.test(lt2);
          In.prototype[lt2] = function() {
            var sn = arguments;
            if (Ee2 && !this.__chain__) {
              var Hn = this.value();
              return wt.apply(ns(Hn) ? Hn : [], sn);
            }
            return this[Jt](function(Fr) {
              return wt.apply(ns(Fr) ? Fr : [], sn);
            });
          };
        }), sA(nh2.prototype, function(lt2, wt) {
          var Jt = In[wt];
          if (Jt) {
            var Ee2 = Jt.name + "";
            Op.call(SN, Ee2) || (SN[Ee2] = []), SN[Ee2].push({ name: wt, func: Jt });
          }
        }), SN[Ko(t2, _t).name] = [{ name: "wrapper", func: t2 }], nh2.prototype.clone = TN, nh2.prototype.reverse = kS, nh2.prototype.value = Ret, In.prototype.at = X5, In.prototype.chain = Snt, In.prototype.commit = zV, In.prototype.next = Mnt, In.prototype.plant = xPt, In.prototype.reverse = yA, In.prototype.toJSON = In.prototype.valueOf = In.prototype.value = Q5, In.prototype.first = In.prototype.head, R5 && (In.prototype[R5] = _Pt), In;
      }, rA = y5t();
      pE ? ((pE.exports = rA)._ = rA, dV._ = rA) : uv._ = rA;
    }).call(YD);
  })(ekt, ekt.exports);
  class tZe {
    constructor() {
      XM(this, "subscriptions", /* @__PURE__ */ new Map());
      XM(this, "emitEffectCache", /* @__PURE__ */ new Map());
      XM(this, "useSubscription", (i, t2) => {
        const h = dp.useRef();
        dp.useEffect(() => {
          var M2, I2;
          h.current = t2;
          function v4(P2) {
            h.current && h.current(P2);
          }
          const _ = (I2 = (M2 = this.subscriptions) == null ? void 0 : M2.get(i)) != null ? I2 : [];
          return _.push(v4), this.subscriptions.set(i, _), this.emitEffect(i), () => {
            this.subscriptions.delete(i);
          };
        }, []);
      });
      XM(this, "emit", (i, ...t2) => {
        if (typeof i == "string" || typeof i == "number") {
          const h = this.subscriptions.get(i);
          h == null || h.forEach((v4) => {
            v4 == null || v4({ params: ekt.exports.cloneDeep(t2), event: i });
          }), this.emitEffectCache.set(i, { params: ekt.exports.cloneDeep(t2), event: i });
        } else
          throw new TypeError("event must be string or number !");
      });
      XM(this, "emitEffect", (i) => {
        const t2 = this.emitEffectCache.get(i), h = this.subscriptions.get(i);
        t2 && (h == null || h.forEach((v4) => {
          v4 == null || v4(o6e({}, t2));
        }));
      });
      XM(this, "removeListener", (i) => {
        this.subscriptions.delete(i);
      });
      XM(this, "clear", () => {
        this.subscriptions.clear();
      });
      this.clear();
    }
  }
  const BEr = new tZe();
  function xre(f2) {
    const i = dp.useRef(), t2 = dp.useMemo(() => f2 != null ? f2 : { global: false }, [f2]);
    return i.current || (i.current = t2.global ? i.current = BEr : i.current = new tZe()), dp.useEffect(() => () => {
      var h;
      return (h = i.current) == null ? void 0 : h.clear();
    }, []), i.current;
  }
  const wre = ({ id: f2, title: i, chart: t2, option: h }, v4) => {
    const _ = dp.useRef(VEr), M2 = xre({ global: true });
    return clr(() => {
      _.current && (t2 == null ? void 0 : t2.current) && f2 && h && (_.current.add(f2, t2 == null ? void 0 : t2.current, h, i), M2.emit("list"));
    }, v4 != null ? v4 : [], { wait: 100 }), { tool: _.current };
  };
  var zEr = dp.createContext({}), eZe = zEr;
  function sg2(f2, i, t2) {
    return i in f2 ? Object.defineProperty(f2, i, { value: t2, enumerable: true, configurable: true, writable: true }) : f2[i] = t2, f2;
  }
  function dBe(f2, i) {
    var t2 = Object.keys(f2);
    if (Object.getOwnPropertySymbols) {
      var h = Object.getOwnPropertySymbols(f2);
      i && (h = h.filter(function(v4) {
        return Object.getOwnPropertyDescriptor(f2, v4).enumerable;
      })), t2.push.apply(t2, h);
    }
    return t2;
  }
  function Af2(f2) {
    for (var i = 1; i < arguments.length; i++) {
      var t2 = arguments[i] != null ? arguments[i] : {};
      i % 2 ? dBe(Object(t2), true).forEach(function(h) {
        sg2(f2, h, t2[h]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(f2, Object.getOwnPropertyDescriptors(t2)) : dBe(Object(t2)).forEach(function(h) {
        Object.defineProperty(f2, h, Object.getOwnPropertyDescriptor(t2, h));
      });
    }
    return f2;
  }
  function nZe(f2) {
    if (Array.isArray(f2))
      return f2;
  }
  function jEr(f2, i) {
    var t2 = f2 == null ? null : typeof Symbol != "undefined" && f2[Symbol.iterator] || f2["@@iterator"];
    if (t2 != null) {
      var h = [], v4 = true, _ = false, M2, I2;
      try {
        for (t2 = t2.call(f2); !(v4 = (M2 = t2.next()).done) && (h.push(M2.value), !(i && h.length === i)); v4 = true)
          ;
      } catch (P2) {
        _ = true, I2 = P2;
      } finally {
        try {
          !v4 && t2.return != null && t2.return();
        } finally {
          if (_)
            throw I2;
        }
      }
      return h;
    }
  }
  function Xte(f2, i) {
    (i == null || i > f2.length) && (i = f2.length);
    for (var t2 = 0, h = new Array(i); t2 < i; t2++)
      h[t2] = f2[t2];
    return h;
  }
  function Sre(f2, i) {
    if (!!f2) {
      if (typeof f2 == "string")
        return Xte(f2, i);
      var t2 = Object.prototype.toString.call(f2).slice(8, -1);
      if (t2 === "Object" && f2.constructor && (t2 = f2.constructor.name), t2 === "Map" || t2 === "Set")
        return Array.from(f2);
      if (t2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t2))
        return Xte(f2, i);
    }
  }
  function rZe() {
    throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function tE(f2, i) {
    return nZe(f2) || jEr(f2, i) || Sre(f2, i) || rZe();
  }
  function WEr(f2, i) {
    if (f2 == null)
      return {};
    var t2 = {}, h = Object.keys(f2), v4, _;
    for (_ = 0; _ < h.length; _++)
      v4 = h[_], !(i.indexOf(v4) >= 0) && (t2[v4] = f2[v4]);
    return t2;
  }
  function pet(f2, i) {
    if (f2 == null)
      return {};
    var t2 = WEr(f2, i), h, v4;
    if (Object.getOwnPropertySymbols) {
      var _ = Object.getOwnPropertySymbols(f2);
      for (v4 = 0; v4 < _.length; v4++)
        h = _[v4], !(i.indexOf(h) >= 0) && (!Object.prototype.propertyIsEnumerable.call(f2, h) || (t2[h] = f2[h]));
    }
    return t2;
  }
  var iZe = { exports: {} };
  /*!
    Copyright (c) 2018 Jed Watson.
    Licensed under the MIT License (MIT), see
    http://jedwatson.github.io/classnames
  */
  (function(f2) {
    (function() {
      var i = {}.hasOwnProperty;
      function t2() {
        for (var h = [], v4 = 0; v4 < arguments.length; v4++) {
          var _ = arguments[v4];
          if (!!_) {
            var M2 = typeof _;
            if (M2 === "string" || M2 === "number")
              h.push(_);
            else if (Array.isArray(_)) {
              if (_.length) {
                var I2 = t2.apply(null, _);
                I2 && h.push(I2);
              }
            } else if (M2 === "object")
              if (_.toString === Object.prototype.toString)
                for (var P2 in _)
                  i.call(_, P2) && _[P2] && h.push(P2);
              else
                h.push(_.toString());
          }
        }
        return h.join(" ");
      }
      f2.exports ? (t2.default = t2, f2.exports = t2) : window.classNames = t2;
    })();
  })(iZe);
  var det = iZe.exports;
  function bS(f2) {
    return bS = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
      return typeof i;
    } : function(i) {
      return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
    }, bS(f2);
  }
  function eE(f2, i) {
    GEr(f2) && (f2 = "100%");
    var t2 = HEr(f2);
    return f2 = i === 360 ? f2 : Math.min(i, Math.max(0, parseFloat(f2))), t2 && (f2 = parseInt(String(f2 * i), 10) / 100), Math.abs(f2 - i) < 1e-6 ? 1 : (i === 360 ? f2 = (f2 < 0 ? f2 % i + i : f2 % i) / parseFloat(String(i)) : f2 = f2 % i / parseFloat(String(i)), f2);
  }
  function GEr(f2) {
    return typeof f2 == "string" && f2.indexOf(".") !== -1 && parseFloat(f2) === 1;
  }
  function HEr(f2) {
    return typeof f2 == "string" && f2.indexOf("%") !== -1;
  }
  function UEr(f2) {
    return f2 = parseFloat(f2), (isNaN(f2) || f2 < 0 || f2 > 1) && (f2 = 1), f2;
  }
  function PDt(f2) {
    return f2 <= 1 ? Number(f2) * 100 + "%" : f2;
  }
  function tJt(f2) {
    return f2.length === 1 ? "0" + f2 : String(f2);
  }
  function qEr(f2, i, t2) {
    return { r: eE(f2, 255) * 255, g: eE(i, 255) * 255, b: eE(t2, 255) * 255 };
  }
  function eJt(f2, i, t2) {
    return t2 < 0 && (t2 += 1), t2 > 1 && (t2 -= 1), t2 < 1 / 6 ? f2 + (i - f2) * (6 * t2) : t2 < 1 / 2 ? i : t2 < 2 / 3 ? f2 + (i - f2) * (2 / 3 - t2) * 6 : f2;
  }
  function ZEr(f2, i, t2) {
    var h, v4, _;
    if (f2 = eE(f2, 360), i = eE(i, 100), t2 = eE(t2, 100), i === 0)
      v4 = t2, _ = t2, h = t2;
    else {
      var M2 = t2 < 0.5 ? t2 * (1 + i) : t2 + i - t2 * i, I2 = 2 * t2 - M2;
      h = eJt(I2, M2, f2 + 1 / 3), v4 = eJt(I2, M2, f2), _ = eJt(I2, M2, f2 - 1 / 3);
    }
    return { r: h * 255, g: v4 * 255, b: _ * 255 };
  }
  function $Er(f2, i, t2) {
    f2 = eE(f2, 255), i = eE(i, 255), t2 = eE(t2, 255);
    var h = Math.max(f2, i, t2), v4 = Math.min(f2, i, t2), _ = 0, M2 = h, I2 = h - v4, P2 = h === 0 ? 0 : I2 / h;
    if (h === v4)
      _ = 0;
    else {
      switch (h) {
        case f2:
          _ = (i - t2) / I2 + (i < t2 ? 6 : 0);
          break;
        case i:
          _ = (t2 - f2) / I2 + 2;
          break;
        case t2:
          _ = (f2 - i) / I2 + 4;
          break;
      }
      _ /= 6;
    }
    return { h: _, s: P2, v: M2 };
  }
  function YEr(f2, i, t2) {
    f2 = eE(f2, 360) * 6, i = eE(i, 100), t2 = eE(t2, 100);
    var h = Math.floor(f2), v4 = f2 - h, _ = t2 * (1 - i), M2 = t2 * (1 - v4 * i), I2 = t2 * (1 - (1 - v4) * i), P2 = h % 6, N3 = [t2, M2, _, _, I2, t2][P2], z3 = [I2, t2, t2, M2, _, _][P2], H2 = [_, _, I2, t2, t2, M2][P2];
    return { r: N3 * 255, g: z3 * 255, b: H2 * 255 };
  }
  function KEr(f2, i, t2, h) {
    var v4 = [tJt(Math.round(f2).toString(16)), tJt(Math.round(i).toString(16)), tJt(Math.round(t2).toString(16))];
    return h && v4[0].startsWith(v4[0].charAt(1)) && v4[1].startsWith(v4[1].charAt(1)) && v4[2].startsWith(v4[2].charAt(1)) ? v4[0].charAt(0) + v4[1].charAt(0) + v4[2].charAt(0) : v4.join("");
  }
  function gBe(f2) {
    return GT(f2) / 255;
  }
  function GT(f2) {
    return parseInt(f2, 16);
  }
  var vBe = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
  function fdt(f2) {
    var i = { r: 0, g: 0, b: 0 }, t2 = 1, h = null, v4 = null, _ = null, M2 = false, I2 = false;
    return typeof f2 == "string" && (f2 = JEr(f2)), typeof f2 == "object" && (z6(f2.r) && z6(f2.g) && z6(f2.b) ? (i = qEr(f2.r, f2.g, f2.b), M2 = true, I2 = String(f2.r).substr(-1) === "%" ? "prgb" : "rgb") : z6(f2.h) && z6(f2.s) && z6(f2.v) ? (h = PDt(f2.s), v4 = PDt(f2.v), i = YEr(f2.h, h, v4), M2 = true, I2 = "hsv") : z6(f2.h) && z6(f2.s) && z6(f2.l) && (h = PDt(f2.s), _ = PDt(f2.l), i = ZEr(f2.h, h, _), M2 = true, I2 = "hsl"), Object.prototype.hasOwnProperty.call(f2, "a") && (t2 = f2.a)), t2 = UEr(t2), { ok: M2, format: f2.format || I2, r: Math.min(255, Math.max(i.r, 0)), g: Math.min(255, Math.max(i.g, 0)), b: Math.min(255, Math.max(i.b, 0)), a: t2 };
  }
  var XEr = "[-\\+]?\\d+%?", QEr = "[-\\+]?\\d*\\.\\d+%?", U7 = "(?:" + QEr + ")|(?:" + XEr + ")", nJt = "[\\s|\\(]+(" + U7 + ")[,|\\s]+(" + U7 + ")[,|\\s]+(" + U7 + ")\\s*\\)?", rJt = "[\\s|\\(]+(" + U7 + ")[,|\\s]+(" + U7 + ")[,|\\s]+(" + U7 + ")[,|\\s]+(" + U7 + ")\\s*\\)?", m5 = { CSS_UNIT: new RegExp(U7), rgb: new RegExp("rgb" + nJt), rgba: new RegExp("rgba" + rJt), hsl: new RegExp("hsl" + nJt), hsla: new RegExp("hsla" + rJt), hsv: new RegExp("hsv" + nJt), hsva: new RegExp("hsva" + rJt), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
  function JEr(f2) {
    if (f2 = f2.trim().toLowerCase(), f2.length === 0)
      return false;
    var i = false;
    if (vBe[f2])
      f2 = vBe[f2], i = true;
    else if (f2 === "transparent")
      return { r: 0, g: 0, b: 0, a: 0, format: "name" };
    var t2 = m5.rgb.exec(f2);
    return t2 ? { r: t2[1], g: t2[2], b: t2[3] } : (t2 = m5.rgba.exec(f2), t2 ? { r: t2[1], g: t2[2], b: t2[3], a: t2[4] } : (t2 = m5.hsl.exec(f2), t2 ? { h: t2[1], s: t2[2], l: t2[3] } : (t2 = m5.hsla.exec(f2), t2 ? { h: t2[1], s: t2[2], l: t2[3], a: t2[4] } : (t2 = m5.hsv.exec(f2), t2 ? { h: t2[1], s: t2[2], v: t2[3] } : (t2 = m5.hsva.exec(f2), t2 ? { h: t2[1], s: t2[2], v: t2[3], a: t2[4] } : (t2 = m5.hex8.exec(f2), t2 ? { r: GT(t2[1]), g: GT(t2[2]), b: GT(t2[3]), a: gBe(t2[4]), format: i ? "name" : "hex8" } : (t2 = m5.hex6.exec(f2), t2 ? { r: GT(t2[1]), g: GT(t2[2]), b: GT(t2[3]), format: i ? "name" : "hex" } : (t2 = m5.hex4.exec(f2), t2 ? { r: GT(t2[1] + t2[1]), g: GT(t2[2] + t2[2]), b: GT(t2[3] + t2[3]), a: gBe(t2[4] + t2[4]), format: i ? "name" : "hex8" } : (t2 = m5.hex3.exec(f2), t2 ? { r: GT(t2[1] + t2[1]), g: GT(t2[2] + t2[2]), b: GT(t2[3] + t2[3]), format: i ? "name" : "hex" } : false)))))))));
  }
  function z6(f2) {
    return Boolean(m5.CSS_UNIT.exec(String(f2)));
  }
  var LDt = 2, yBe = 0.16, tkr = 0.05, ekr = 0.05, nkr = 0.15, aZe = 5, oZe = 4, rkr = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
  function mBe(f2) {
    var i = f2.r, t2 = f2.g, h = f2.b, v4 = $Er(i, t2, h);
    return { h: v4.h * 360, s: v4.s, v: v4.v };
  }
  function ODt(f2) {
    var i = f2.r, t2 = f2.g, h = f2.b;
    return "#".concat(KEr(i, t2, h, false));
  }
  function ikr(f2, i, t2) {
    var h = t2 / 100, v4 = { r: (i.r - f2.r) * h + f2.r, g: (i.g - f2.g) * h + f2.g, b: (i.b - f2.b) * h + f2.b };
    return v4;
  }
  function bBe(f2, i, t2) {
    var h;
    return Math.round(f2.h) >= 60 && Math.round(f2.h) <= 240 ? h = t2 ? Math.round(f2.h) - LDt * i : Math.round(f2.h) + LDt * i : h = t2 ? Math.round(f2.h) + LDt * i : Math.round(f2.h) - LDt * i, h < 0 ? h += 360 : h >= 360 && (h -= 360), h;
  }
  function _Be(f2, i, t2) {
    if (f2.h === 0 && f2.s === 0)
      return f2.s;
    var h;
    return t2 ? h = f2.s - yBe * i : i === oZe ? h = f2.s + yBe : h = f2.s + tkr * i, h > 1 && (h = 1), t2 && i === aZe && h > 0.1 && (h = 0.1), h < 0.06 && (h = 0.06), Number(h.toFixed(2));
  }
  function xBe(f2, i, t2) {
    var h;
    return t2 ? h = f2.v + ekr * i : h = f2.v - nkr * i, h > 1 && (h = 1), Number(h.toFixed(2));
  }
  function Qte(f2) {
    for (var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t2 = [], h = fdt(f2), v4 = aZe; v4 > 0; v4 -= 1) {
      var _ = mBe(h), M2 = ODt(fdt({ h: bBe(_, v4, true), s: _Be(_, v4, true), v: xBe(_, v4, true) }));
      t2.push(M2);
    }
    t2.push(ODt(h));
    for (var I2 = 1; I2 <= oZe; I2 += 1) {
      var P2 = mBe(h), N3 = ODt(fdt({ h: bBe(P2, I2), s: _Be(P2, I2), v: xBe(P2, I2) }));
      t2.push(N3);
    }
    return i.theme === "dark" ? rkr.map(function(z3) {
      var H2 = z3.index, $ = z3.opacity, et = ODt(ikr(fdt(i.backgroundColor || "#141414"), fdt(t2[H2]), $ * 100));
      return et;
    }) : t2;
  }
  var iJt = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, _S = {}, aJt = {};
  Object.keys(iJt).forEach(function(f2) {
    _S[f2] = Qte(iJt[f2]), _S[f2].primary = _S[f2][5], aJt[f2] = Qte(iJt[f2], { theme: "dark", backgroundColor: "#141414" }), aJt[f2].primary = aJt[f2][5];
  });
  _S.red;
  _S.volcano;
  _S.gold;
  _S.orange;
  _S.yellow;
  _S.lime;
  _S.green;
  _S.cyan;
  _S.blue;
  _S.geekblue;
  _S.purple;
  _S.magenta;
  _S.grey;
  var wBe = {};
  function akr(f2, i) {
  }
  function okr(f2, i, t2) {
    !i && !wBe[t2] && (f2(false, t2), wBe[t2] = true);
  }
  function BL(f2, i) {
    okr(akr, f2, i);
  }
  function sZe() {
    return !!(typeof window != "undefined" && window.document && window.document.createElement);
  }
  var skr = "rc-util-key";
  function lZe() {
    var f2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, i = f2.mark;
    return i ? i.startsWith("data-") ? i : "data-".concat(i) : skr;
  }
  function Mre(f2) {
    if (f2.attachTo)
      return f2.attachTo;
    var i = document.querySelector("head");
    return i || document.body;
  }
  function SBe(f2) {
    var i, t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (!sZe())
      return null;
    var h = document.createElement("style");
    if (!((i = t2.csp) === null || i === void 0) && i.nonce) {
      var v4;
      h.nonce = (v4 = t2.csp) === null || v4 === void 0 ? void 0 : v4.nonce;
    }
    h.innerHTML = f2;
    var _ = Mre(t2), M2 = _.firstChild;
    return t2.prepend && _.prepend ? _.prepend(h) : t2.prepend && M2 ? _.insertBefore(h, M2) : _.appendChild(h), h;
  }
  var Jte = /* @__PURE__ */ new Map();
  function lkr(f2) {
    var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t2 = Mre(i);
    return Array.from(Jte.get(t2).children).find(function(h) {
      return h.tagName === "STYLE" && h.getAttribute(lZe(i)) === f2;
    });
  }
  function uZe(f2, i) {
    var t2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, h = Mre(t2);
    if (!Jte.has(h)) {
      var v4 = SBe("", t2), _ = v4.parentNode;
      Jte.set(h, _), _.removeChild(v4);
    }
    var M2 = lkr(i, t2);
    if (M2) {
      var I2, P2;
      if (((I2 = t2.csp) === null || I2 === void 0 ? void 0 : I2.nonce) && M2.nonce !== ((P2 = t2.csp) === null || P2 === void 0 ? void 0 : P2.nonce)) {
        var N3;
        M2.nonce = (N3 = t2.csp) === null || N3 === void 0 ? void 0 : N3.nonce;
      }
      return M2.innerHTML !== f2 && (M2.innerHTML = f2), M2;
    }
    var z3 = SBe(f2, t2);
    return z3.setAttribute(lZe(t2), i), z3;
  }
  function ukr(f2, i) {
    BL(f2, "[@ant-design/icons] ".concat(i));
  }
  function MBe(f2) {
    return bS(f2) === "object" && typeof f2.name == "string" && typeof f2.theme == "string" && (bS(f2.icon) === "object" || typeof f2.icon == "function");
  }
  function CBe() {
    var f2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return Object.keys(f2).reduce(function(i, t2) {
      var h = f2[t2];
      switch (t2) {
        case "class":
          i.className = h, delete i.class;
          break;
        default:
          i[t2] = h;
      }
      return i;
    }, {});
  }
  function tee(f2, i, t2) {
    return t2 ? ztt.default.createElement(f2.tag, Af2(Af2({ key: i }, CBe(f2.attrs)), t2), (f2.children || []).map(function(h, v4) {
      return tee(h, "".concat(i, "-").concat(f2.tag, "-").concat(v4));
    })) : ztt.default.createElement(f2.tag, Af2({ key: i }, CBe(f2.attrs)), (f2.children || []).map(function(h, v4) {
      return tee(h, "".concat(i, "-").concat(f2.tag, "-").concat(v4));
    }));
  }
  function cZe(f2) {
    return Qte(f2)[0];
  }
  function fZe(f2) {
    return f2 ? Array.isArray(f2) ? f2 : [f2] : [];
  }
  var ckr = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, fkr = function() {
    var i = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : ckr, t2 = dp.useContext(eZe), h = t2.csp;
    dp.useEffect(function() {
      uZe(i, "@ant-design-icons", { prepend: true, csp: h });
    }, []);
  }, hkr = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], Gdt = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
  function pkr(f2) {
    var i = f2.primaryColor, t2 = f2.secondaryColor;
    Gdt.primaryColor = i, Gdt.secondaryColor = t2 || cZe(i), Gdt.calculated = !!t2;
  }
  function dkr() {
    return Af2({}, Gdt);
  }
  var Ukt = function(i) {
    var t2 = i.icon, h = i.className, v4 = i.onClick, _ = i.style, M2 = i.primaryColor, I2 = i.secondaryColor, P2 = pet(i, hkr), N3 = Gdt;
    if (M2 && (N3 = { primaryColor: M2, secondaryColor: I2 || cZe(M2) }), fkr(), ukr(MBe(t2), "icon should be icon definiton, but got ".concat(t2)), !MBe(t2))
      return null;
    var z3 = t2;
    return z3 && typeof z3.icon == "function" && (z3 = Af2(Af2({}, z3), {}, { icon: z3.icon(N3.primaryColor, N3.secondaryColor) })), tee(z3.icon, "svg-".concat(z3.name), Af2({ className: h, onClick: v4, style: _, "data-icon": z3.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, P2));
  };
  Ukt.displayName = "IconReact";
  Ukt.getTwoToneColors = dkr;
  Ukt.setTwoToneColors = pkr;
  var Cre = Ukt;
  function hZe(f2) {
    var i = fZe(f2), t2 = tE(i, 2), h = t2[0], v4 = t2[1];
    return Cre.setTwoToneColors({ primaryColor: h, secondaryColor: v4 });
  }
  function gkr() {
    var f2 = Cre.getTwoToneColors();
    return f2.calculated ? [f2.primaryColor, f2.secondaryColor] : f2.primaryColor;
  }
  var vkr = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
  hZe("#1890ff");
  var qkt = Vo.forwardRef(function(f2, i) {
    var t2, h = f2.className, v4 = f2.icon, _ = f2.spin, M2 = f2.rotate, I2 = f2.tabIndex, P2 = f2.onClick, N3 = f2.twoToneColor, z3 = pet(f2, vkr), H2 = Vo.useContext(eZe), $ = H2.prefixCls, et = $ === void 0 ? "anticon" : $, at = det(et, (t2 = {}, sg2(t2, "".concat(et, "-").concat(v4.name), !!v4.name), sg2(t2, "".concat(et, "-spin"), !!_ || v4.name === "loading"), t2), h), ht = I2;
    ht === void 0 && P2 && (ht = -1);
    var bt = M2 ? { msTransform: "rotate(".concat(M2, "deg)"), transform: "rotate(".concat(M2, "deg)") } : void 0, _t = fZe(N3), Et = tE(_t, 2), zt = Et[0], Ft = Et[1];
    return Vo.createElement("span", Af2(Af2({ role: "img", "aria-label": v4.name }, z3), {}, { ref: i, tabIndex: ht, onClick: P2, className: at }), Vo.createElement(Cre, { icon: v4, primaryColor: zt, secondaryColor: Ft, style: bt }));
  });
  qkt.displayName = "AntdIcon";
  qkt.getTwoToneColor = gkr;
  qkt.setTwoToneColor = hZe;
  var ykr = qkt, mkr = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, bkr = mkr, pZe = function(i, t2) {
    return Vo.createElement(ykr, Af2(Af2({}, i), {}, { ref: t2, icon: bkr }));
  };
  pZe.displayName = "LoadingOutlined";
  var _kr = Vo.forwardRef(pZe);
  function s1() {
    return s1 = Object.assign || function(f2) {
      for (var i = 1; i < arguments.length; i++) {
        var t2 = arguments[i];
        for (var h in t2)
          Object.prototype.hasOwnProperty.call(t2, h) && (f2[h] = t2[h]);
      }
      return f2;
    }, s1.apply(this, arguments);
  }
  function qgt(f2, i) {
    if (!(f2 instanceof i))
      throw new TypeError("Cannot call a class as a function");
  }
  function TBe(f2, i) {
    for (var t2 = 0; t2 < i.length; t2++) {
      var h = i[t2];
      h.enumerable = h.enumerable || false, h.configurable = true, "value" in h && (h.writable = true), Object.defineProperty(f2, h.key, h);
    }
  }
  function Zgt(f2, i, t2) {
    return i && TBe(f2.prototype, i), t2 && TBe(f2, t2), Object.defineProperty(f2, "prototype", { writable: false }), f2;
  }
  function eee(f2, i) {
    return eee = Object.setPrototypeOf || function(h, v4) {
      return h.__proto__ = v4, h;
    }, eee(f2, i);
  }
  function Tre(f2, i) {
    if (typeof i != "function" && i !== null)
      throw new TypeError("Super expression must either be null or a function");
    f2.prototype = Object.create(i && i.prototype, { constructor: { value: f2, writable: true, configurable: true } }), Object.defineProperty(f2, "prototype", { writable: false }), i && eee(f2, i);
  }
  function nkt(f2) {
    return nkt = Object.setPrototypeOf ? Object.getPrototypeOf : function(t2) {
      return t2.__proto__ || Object.getPrototypeOf(t2);
    }, nkt(f2);
  }
  function xkr() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function Are(f2) {
    if (f2 === void 0)
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return f2;
  }
  function wkr(f2, i) {
    if (i && (bS(i) === "object" || typeof i == "function"))
      return i;
    if (i !== void 0)
      throw new TypeError("Derived constructors may only return object or undefined");
    return Are(f2);
  }
  function Ire(f2) {
    var i = xkr();
    return function() {
      var h = nkt(f2), v4;
      if (i) {
        var _ = nkt(this).constructor;
        v4 = Reflect.construct(h, arguments, _);
      } else
        v4 = h.apply(this, arguments);
      return wkr(this, v4);
    };
  }
  var Dre = { exports: {} }, Ug2 = {};
  /** @license React v16.13.1
  * react-is.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var __ = typeof Symbol == "function" && Symbol.for, Ere = __ ? Symbol.for("react.element") : 60103, kre = __ ? Symbol.for("react.portal") : 60106, Zkt = __ ? Symbol.for("react.fragment") : 60107, $kt = __ ? Symbol.for("react.strict_mode") : 60108, Ykt = __ ? Symbol.for("react.profiler") : 60114, Kkt = __ ? Symbol.for("react.provider") : 60109, Xkt = __ ? Symbol.for("react.context") : 60110, Pre = __ ? Symbol.for("react.async_mode") : 60111, Qkt = __ ? Symbol.for("react.concurrent_mode") : 60111, Jkt = __ ? Symbol.for("react.forward_ref") : 60112, t5t = __ ? Symbol.for("react.suspense") : 60113, Skr = __ ? Symbol.for("react.suspense_list") : 60120, e5t = __ ? Symbol.for("react.memo") : 60115, n5t = __ ? Symbol.for("react.lazy") : 60116, Mkr = __ ? Symbol.for("react.block") : 60121, Ckr = __ ? Symbol.for("react.fundamental") : 60117, Tkr = __ ? Symbol.for("react.responder") : 60118, Akr = __ ? Symbol.for("react.scope") : 60119;
  function KT(f2) {
    if (typeof f2 == "object" && f2 !== null) {
      var i = f2.$$typeof;
      switch (i) {
        case Ere:
          switch (f2 = f2.type, f2) {
            case Pre:
            case Qkt:
            case Zkt:
            case Ykt:
            case $kt:
            case t5t:
              return f2;
            default:
              switch (f2 = f2 && f2.$$typeof, f2) {
                case Xkt:
                case Jkt:
                case n5t:
                case e5t:
                case Kkt:
                  return f2;
                default:
                  return i;
              }
          }
        case kre:
          return i;
      }
    }
  }
  function dZe(f2) {
    return KT(f2) === Qkt;
  }
  Ug2.AsyncMode = Pre;
  Ug2.ConcurrentMode = Qkt;
  Ug2.ContextConsumer = Xkt;
  Ug2.ContextProvider = Kkt;
  Ug2.Element = Ere;
  Ug2.ForwardRef = Jkt;
  Ug2.Fragment = Zkt;
  Ug2.Lazy = n5t;
  Ug2.Memo = e5t;
  Ug2.Portal = kre;
  Ug2.Profiler = Ykt;
  Ug2.StrictMode = $kt;
  Ug2.Suspense = t5t;
  Ug2.isAsyncMode = function(f2) {
    return dZe(f2) || KT(f2) === Pre;
  };
  Ug2.isConcurrentMode = dZe;
  Ug2.isContextConsumer = function(f2) {
    return KT(f2) === Xkt;
  };
  Ug2.isContextProvider = function(f2) {
    return KT(f2) === Kkt;
  };
  Ug2.isElement = function(f2) {
    return typeof f2 == "object" && f2 !== null && f2.$$typeof === Ere;
  };
  Ug2.isForwardRef = function(f2) {
    return KT(f2) === Jkt;
  };
  Ug2.isFragment = function(f2) {
    return KT(f2) === Zkt;
  };
  Ug2.isLazy = function(f2) {
    return KT(f2) === n5t;
  };
  Ug2.isMemo = function(f2) {
    return KT(f2) === e5t;
  };
  Ug2.isPortal = function(f2) {
    return KT(f2) === kre;
  };
  Ug2.isProfiler = function(f2) {
    return KT(f2) === Ykt;
  };
  Ug2.isStrictMode = function(f2) {
    return KT(f2) === $kt;
  };
  Ug2.isSuspense = function(f2) {
    return KT(f2) === t5t;
  };
  Ug2.isValidElementType = function(f2) {
    return typeof f2 == "string" || typeof f2 == "function" || f2 === Zkt || f2 === Qkt || f2 === Ykt || f2 === $kt || f2 === t5t || f2 === Skr || typeof f2 == "object" && f2 !== null && (f2.$$typeof === n5t || f2.$$typeof === e5t || f2.$$typeof === Kkt || f2.$$typeof === Xkt || f2.$$typeof === Jkt || f2.$$typeof === Ckr || f2.$$typeof === Tkr || f2.$$typeof === Akr || f2.$$typeof === Mkr);
  };
  Ug2.typeOf = KT;
  Dre.exports = Ug2;
  function nee(f2) {
    var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t2 = [];
    return ztt.default.Children.forEach(f2, function(h) {
      h == null && !i.keepEmpty || (Array.isArray(h) ? t2 = t2.concat(nee(h)) : Dre.exports.isFragment(h) && h.props ? t2 = t2.concat(nee(h.props.children, i)) : t2.push(h));
    }), t2;
  }
  function Ikr(f2, i) {
    typeof f2 == "function" ? f2(i) : bS(f2) === "object" && f2 && "current" in f2 && (f2.current = i);
  }
  function Dkr() {
    for (var f2 = arguments.length, i = new Array(f2), t2 = 0; t2 < f2; t2++)
      i[t2] = arguments[t2];
    var h = i.filter(function(v4) {
      return v4;
    });
    return h.length <= 1 ? h[0] : function(v4) {
      i.forEach(function(_) {
        Ikr(_, v4);
      });
    };
  }
  function Ekr(f2) {
    var i, t2, h = Dre.exports.isMemo(f2) ? f2.type.type : f2.type;
    return !(typeof h == "function" && !(!((i = h.prototype) === null || i === void 0) && i.render) || typeof f2 == "function" && !(!((t2 = f2.prototype) === null || t2 === void 0) && t2.render));
  }
  function Okr() {
    try {
      if (!Object.assign)
        return false;
      var f2 = new String("abc");
      if (f2[5] = "de", Object.getOwnPropertyNames(f2)[0] === "5")
        return false;
      for (var i = {}, t2 = 0; t2 < 10; t2++)
        i["_" + String.fromCharCode(t2)] = t2;
      var h = Object.getOwnPropertyNames(i).map(function(_) {
        return i[_];
      });
      if (h.join("") !== "0123456789")
        return false;
      var v4 = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(_) {
        v4[_] = _;
      }), Object.keys(Object.assign({}, v4)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return false;
    }
  }
  Okr();
  function Rkr(f2) {
    if (Array.isArray(f2))
      return Xte(f2);
  }
  function gZe(f2) {
    if (typeof Symbol != "undefined" && f2[Symbol.iterator] != null || f2["@@iterator"] != null)
      return Array.from(f2);
  }
  function Nkr() {
    throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function Up(f2) {
    return Rkr(f2) || gZe(f2) || Sre(f2) || Nkr();
  }
  var Ptt = "RC_FORM_INTERNAL_HOOKS", g0 = function() {
    BL(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
  }, xgt = Vo.createContext({ getFieldValue: g0, getFieldsValue: g0, getFieldError: g0, getFieldWarning: g0, getFieldsError: g0, isFieldsTouched: g0, isFieldTouched: g0, isFieldValidating: g0, isFieldsValidating: g0, resetFields: g0, setFields: g0, setFieldsValue: g0, validateFields: g0, submit: g0, getInternalHooks: function() {
    return g0(), { dispatch: g0, initEntityValue: g0, registerField: g0, useSubscribe: g0, setInitialValues: g0, setCallbacks: g0, getFields: g0, setValidateMessages: g0, setPreserve: g0, getInitialValue: g0 };
  } });
  function ree(f2) {
    return f2 == null ? [] : Array.isArray(f2) ? f2 : [f2];
  }
  var vZe = { exports: {} };
  (function(f2) {
    var i = function(t2) {
      var h = Object.prototype, v4 = h.hasOwnProperty, _, M2 = typeof Symbol == "function" ? Symbol : {}, I2 = M2.iterator || "@@iterator", P2 = M2.asyncIterator || "@@asyncIterator", N3 = M2.toStringTag || "@@toStringTag";
      function z3(nr, pr, Nr) {
        return Object.defineProperty(nr, pr, { value: Nr, enumerable: true, configurable: true, writable: true }), nr[pr];
      }
      try {
        z3({}, "");
      } catch {
        z3 = function(pr, Nr, ai2) {
          return pr[Nr] = ai2;
        };
      }
      function H2(nr, pr, Nr, ai2) {
        var gi2 = pr && pr.prototype instanceof Et ? pr : Et, To = Object.create(gi2.prototype), us = new Vn(ai2 || []);
        return To._invoke = We(nr, Nr, us), To;
      }
      t2.wrap = H2;
      function $(nr, pr, Nr) {
        try {
          return { type: "normal", arg: nr.call(pr, Nr) };
        } catch (ai2) {
          return { type: "throw", arg: ai2 };
        }
      }
      var et = "suspendedStart", at = "suspendedYield", ht = "executing", bt = "completed", _t = {};
      function Et() {
      }
      function zt() {
      }
      function Ft() {
      }
      var fe2 = {};
      z3(fe2, I2, function() {
        return this;
      });
      var re2 = Object.getPrototypeOf, ye = re2 && re2(re2(xn([])));
      ye && ye !== h && v4.call(ye, I2) && (fe2 = ye);
      var me2 = Ft.prototype = Et.prototype = Object.create(fe2);
      zt.prototype = Ft, z3(me2, "constructor", Ft), z3(Ft, "constructor", zt), zt.displayName = z3(Ft, N3, "GeneratorFunction");
      function be2(nr) {
        ["next", "throw", "return"].forEach(function(pr) {
          z3(nr, pr, function(Nr) {
            return this._invoke(pr, Nr);
          });
        });
      }
      t2.isGeneratorFunction = function(nr) {
        var pr = typeof nr == "function" && nr.constructor;
        return pr ? pr === zt || (pr.displayName || pr.name) === "GeneratorFunction" : false;
      }, t2.mark = function(nr) {
        return Object.setPrototypeOf ? Object.setPrototypeOf(nr, Ft) : (nr.__proto__ = Ft, z3(nr, N3, "GeneratorFunction")), nr.prototype = Object.create(me2), nr;
      }, t2.awrap = function(nr) {
        return { __await: nr };
      };
      function Te2(nr, pr) {
        function Nr(To, us, ml, ll) {
          var Rs = $(nr[To], nr, us);
          if (Rs.type === "throw")
            ll(Rs.arg);
          else {
            var es = Rs.arg, Ws = es.value;
            return Ws && typeof Ws == "object" && v4.call(Ws, "__await") ? pr.resolve(Ws.__await).then(function(il) {
              Nr("next", il, ml, ll);
            }, function(il) {
              Nr("throw", il, ml, ll);
            }) : pr.resolve(Ws).then(function(il) {
              es.value = il, ml(es);
            }, function(il) {
              return Nr("throw", il, ml, ll);
            });
          }
        }
        var ai2;
        function gi2(To, us) {
          function ml() {
            return new pr(function(ll, Rs) {
              Nr(To, us, ll, Rs);
            });
          }
          return ai2 = ai2 ? ai2.then(ml, ml) : ml();
        }
        this._invoke = gi2;
      }
      be2(Te2.prototype), z3(Te2.prototype, P2, function() {
        return this;
      }), t2.AsyncIterator = Te2, t2.async = function(nr, pr, Nr, ai2, gi2) {
        gi2 === void 0 && (gi2 = Promise);
        var To = new Te2(H2(nr, pr, Nr, ai2), gi2);
        return t2.isGeneratorFunction(pr) ? To : To.next().then(function(us) {
          return us.done ? us.value : To.next();
        });
      };
      function We(nr, pr, Nr) {
        var ai2 = et;
        return function(To, us) {
          if (ai2 === ht)
            throw new Error("Generator is already running");
          if (ai2 === bt) {
            if (To === "throw")
              throw us;
            return Zr();
          }
          for (Nr.method = To, Nr.arg = us; ; ) {
            var ml = Nr.delegate;
            if (ml) {
              var ll = en(ml, Nr);
              if (ll) {
                if (ll === _t)
                  continue;
                return ll;
              }
            }
            if (Nr.method === "next")
              Nr.sent = Nr._sent = Nr.arg;
            else if (Nr.method === "throw") {
              if (ai2 === et)
                throw ai2 = bt, Nr.arg;
              Nr.dispatchException(Nr.arg);
            } else
              Nr.method === "return" && Nr.abrupt("return", Nr.arg);
            ai2 = ht;
            var Rs = $(nr, pr, Nr);
            if (Rs.type === "normal") {
              if (ai2 = Nr.done ? bt : at, Rs.arg === _t)
                continue;
              return { value: Rs.arg, done: Nr.done };
            } else
              Rs.type === "throw" && (ai2 = bt, Nr.method = "throw", Nr.arg = Rs.arg);
          }
        };
      }
      function en(nr, pr) {
        var Nr = nr.iterator[pr.method];
        if (Nr === _) {
          if (pr.delegate = null, pr.method === "throw") {
            if (nr.iterator.return && (pr.method = "return", pr.arg = _, en(nr, pr), pr.method === "throw"))
              return _t;
            pr.method = "throw", pr.arg = new TypeError("The iterator does not provide a 'throw' method");
          }
          return _t;
        }
        var ai2 = $(Nr, nr.iterator, pr.arg);
        if (ai2.type === "throw")
          return pr.method = "throw", pr.arg = ai2.arg, pr.delegate = null, _t;
        var gi2 = ai2.arg;
        if (!gi2)
          return pr.method = "throw", pr.arg = new TypeError("iterator result is not an object"), pr.delegate = null, _t;
        if (gi2.done)
          pr[nr.resultName] = gi2.value, pr.next = nr.nextLoc, pr.method !== "return" && (pr.method = "next", pr.arg = _);
        else
          return gi2;
        return pr.delegate = null, _t;
      }
      be2(me2), z3(me2, N3, "Generator"), z3(me2, I2, function() {
        return this;
      }), z3(me2, "toString", function() {
        return "[object Generator]";
      });
      function Ue2(nr) {
        var pr = { tryLoc: nr[0] };
        1 in nr && (pr.catchLoc = nr[1]), 2 in nr && (pr.finallyLoc = nr[2], pr.afterLoc = nr[3]), this.tryEntries.push(pr);
      }
      function Mn(nr) {
        var pr = nr.completion || {};
        pr.type = "normal", delete pr.arg, nr.completion = pr;
      }
      function Vn(nr) {
        this.tryEntries = [{ tryLoc: "root" }], nr.forEach(Ue2, this), this.reset(true);
      }
      t2.keys = function(nr) {
        var pr = [];
        for (var Nr in nr)
          pr.push(Nr);
        return pr.reverse(), function ai2() {
          for (; pr.length; ) {
            var gi2 = pr.pop();
            if (gi2 in nr)
              return ai2.value = gi2, ai2.done = false, ai2;
          }
          return ai2.done = true, ai2;
        };
      };
      function xn(nr) {
        if (nr) {
          var pr = nr[I2];
          if (pr)
            return pr.call(nr);
          if (typeof nr.next == "function")
            return nr;
          if (!isNaN(nr.length)) {
            var Nr = -1, ai2 = function gi2() {
              for (; ++Nr < nr.length; )
                if (v4.call(nr, Nr))
                  return gi2.value = nr[Nr], gi2.done = false, gi2;
              return gi2.value = _, gi2.done = true, gi2;
            };
            return ai2.next = ai2;
          }
        }
        return { next: Zr };
      }
      t2.values = xn;
      function Zr() {
        return { value: _, done: true };
      }
      return Vn.prototype = { constructor: Vn, reset: function(nr) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = _, this.done = false, this.delegate = null, this.method = "next", this.arg = _, this.tryEntries.forEach(Mn), !nr)
          for (var pr in this)
            pr.charAt(0) === "t" && v4.call(this, pr) && !isNaN(+pr.slice(1)) && (this[pr] = _);
      }, stop: function() {
        this.done = true;
        var nr = this.tryEntries[0], pr = nr.completion;
        if (pr.type === "throw")
          throw pr.arg;
        return this.rval;
      }, dispatchException: function(nr) {
        if (this.done)
          throw nr;
        var pr = this;
        function Nr(ll, Rs) {
          return To.type = "throw", To.arg = nr, pr.next = ll, Rs && (pr.method = "next", pr.arg = _), !!Rs;
        }
        for (var ai2 = this.tryEntries.length - 1; ai2 >= 0; --ai2) {
          var gi2 = this.tryEntries[ai2], To = gi2.completion;
          if (gi2.tryLoc === "root")
            return Nr("end");
          if (gi2.tryLoc <= this.prev) {
            var us = v4.call(gi2, "catchLoc"), ml = v4.call(gi2, "finallyLoc");
            if (us && ml) {
              if (this.prev < gi2.catchLoc)
                return Nr(gi2.catchLoc, true);
              if (this.prev < gi2.finallyLoc)
                return Nr(gi2.finallyLoc);
            } else if (us) {
              if (this.prev < gi2.catchLoc)
                return Nr(gi2.catchLoc, true);
            } else if (ml) {
              if (this.prev < gi2.finallyLoc)
                return Nr(gi2.finallyLoc);
            } else
              throw new Error("try statement without catch or finally");
          }
        }
      }, abrupt: function(nr, pr) {
        for (var Nr = this.tryEntries.length - 1; Nr >= 0; --Nr) {
          var ai2 = this.tryEntries[Nr];
          if (ai2.tryLoc <= this.prev && v4.call(ai2, "finallyLoc") && this.prev < ai2.finallyLoc) {
            var gi2 = ai2;
            break;
          }
        }
        gi2 && (nr === "break" || nr === "continue") && gi2.tryLoc <= pr && pr <= gi2.finallyLoc && (gi2 = null);
        var To = gi2 ? gi2.completion : {};
        return To.type = nr, To.arg = pr, gi2 ? (this.method = "next", this.next = gi2.finallyLoc, _t) : this.complete(To);
      }, complete: function(nr, pr) {
        if (nr.type === "throw")
          throw nr.arg;
        return nr.type === "break" || nr.type === "continue" ? this.next = nr.arg : nr.type === "return" ? (this.rval = this.arg = nr.arg, this.method = "return", this.next = "end") : nr.type === "normal" && pr && (this.next = pr), _t;
      }, finish: function(nr) {
        for (var pr = this.tryEntries.length - 1; pr >= 0; --pr) {
          var Nr = this.tryEntries[pr];
          if (Nr.finallyLoc === nr)
            return this.complete(Nr.completion, Nr.afterLoc), Mn(Nr), _t;
        }
      }, catch: function(nr) {
        for (var pr = this.tryEntries.length - 1; pr >= 0; --pr) {
          var Nr = this.tryEntries[pr];
          if (Nr.tryLoc === nr) {
            var ai2 = Nr.completion;
            if (ai2.type === "throw") {
              var gi2 = ai2.arg;
              Mn(Nr);
            }
            return gi2;
          }
        }
        throw new Error("illegal catch attempt");
      }, delegateYield: function(nr, pr, Nr) {
        return this.delegate = { iterator: xn(nr), resultName: pr, nextLoc: Nr }, this.method === "next" && (this.arg = _), _t;
      } }, t2;
    }(f2.exports);
    try {
      regeneratorRuntime = i;
    } catch {
      typeof globalThis == "object" ? globalThis.regeneratorRuntime = i : Function("r", "regeneratorRuntime = r")(i);
    }
  })(vZe);
  var aV = vZe.exports;
  function IBe(f2, i, t2, h, v4, _, M2) {
    try {
      var I2 = f2[_](M2), P2 = I2.value;
    } catch (N3) {
      t2(N3);
      return;
    }
    I2.done ? i(P2) : Promise.resolve(P2).then(h, v4);
  }
  function r5t(f2) {
    return function() {
      var i = this, t2 = arguments;
      return new Promise(function(h, v4) {
        var _ = f2.apply(i, t2);
        function M2(P2) {
          IBe(_, h, v4, M2, I2, "next", P2);
        }
        function I2(P2) {
          IBe(_, h, v4, M2, I2, "throw", P2);
        }
        M2(void 0);
      });
    };
  }
  function aU() {
    return aU = Object.assign || function(f2) {
      for (var i = 1; i < arguments.length; i++) {
        var t2 = arguments[i];
        for (var h in t2)
          Object.prototype.hasOwnProperty.call(t2, h) && (f2[h] = t2[h]);
      }
      return f2;
    }, aU.apply(this, arguments);
  }
  function Fkr(f2, i) {
    f2.prototype = Object.create(i.prototype), f2.prototype.constructor = f2, wgt(f2, i);
  }
  function iee(f2) {
    return iee = Object.setPrototypeOf ? Object.getPrototypeOf : function(t2) {
      return t2.__proto__ || Object.getPrototypeOf(t2);
    }, iee(f2);
  }
  function wgt(f2, i) {
    return wgt = Object.setPrototypeOf || function(h, v4) {
      return h.__proto__ = v4, h;
    }, wgt(f2, i);
  }
  function Vkr() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function iEt(f2, i, t2) {
    return Vkr() ? iEt = Reflect.construct : iEt = function(v4, _, M2) {
      var I2 = [null];
      I2.push.apply(I2, _);
      var P2 = Function.bind.apply(v4, I2), N3 = new P2();
      return M2 && wgt(N3, M2.prototype), N3;
    }, iEt.apply(null, arguments);
  }
  function Bkr(f2) {
    return Function.toString.call(f2).indexOf("[native code]") !== -1;
  }
  function aee(f2) {
    var i = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
    return aee = function(h) {
      if (h === null || !Bkr(h))
        return h;
      if (typeof h != "function")
        throw new TypeError("Super expression must either be null or a function");
      if (typeof i != "undefined") {
        if (i.has(h))
          return i.get(h);
        i.set(h, v4);
      }
      function v4() {
        return iEt(h, arguments, iee(this).constructor);
      }
      return v4.prototype = Object.create(h.prototype, { constructor: { value: v4, enumerable: false, writable: true, configurable: true } }), wgt(v4, h);
    }, aee(f2);
  }
  var zkr = /%[sdj%]/g, jkr = function() {
  };
  typeof process != "undefined" && process.env;
  function oee(f2) {
    if (!f2 || !f2.length)
      return null;
    var i = {};
    return f2.forEach(function(t2) {
      var h = t2.field;
      i[h] = i[h] || [], i[h].push(t2);
    }), i;
  }
  function qT(f2) {
    for (var i = arguments.length, t2 = new Array(i > 1 ? i - 1 : 0), h = 1; h < i; h++)
      t2[h - 1] = arguments[h];
    var v4 = 0, _ = t2.length;
    if (typeof f2 == "function")
      return f2.apply(null, t2);
    if (typeof f2 == "string") {
      var M2 = f2.replace(zkr, function(I2) {
        if (I2 === "%%")
          return "%";
        if (v4 >= _)
          return I2;
        switch (I2) {
          case "%s":
            return String(t2[v4++]);
          case "%d":
            return Number(t2[v4++]);
          case "%j":
            try {
              return JSON.stringify(t2[v4++]);
            } catch {
              return "[Circular]";
            }
            break;
          default:
            return I2;
        }
      });
      return M2;
    }
    return f2;
  }
  function Wkr(f2) {
    return f2 === "string" || f2 === "url" || f2 === "hex" || f2 === "email" || f2 === "date" || f2 === "pattern";
  }
  function db2(f2, i) {
    return !!(f2 == null || i === "array" && Array.isArray(f2) && !f2.length || Wkr(i) && typeof f2 == "string" && !f2);
  }
  function Gkr(f2, i, t2) {
    var h = [], v4 = 0, _ = f2.length;
    function M2(I2) {
      h.push.apply(h, I2 || []), v4++, v4 === _ && t2(h);
    }
    f2.forEach(function(I2) {
      i(I2, M2);
    });
  }
  function DBe(f2, i, t2) {
    var h = 0, v4 = f2.length;
    function _(M2) {
      if (M2 && M2.length) {
        t2(M2);
        return;
      }
      var I2 = h;
      h = h + 1, I2 < v4 ? i(f2[I2], _) : t2([]);
    }
    _([]);
  }
  function Hkr(f2) {
    var i = [];
    return Object.keys(f2).forEach(function(t2) {
      i.push.apply(i, f2[t2] || []);
    }), i;
  }
  var EBe = function(f2) {
    Fkr(i, f2);
    function i(t2, h) {
      var v4;
      return v4 = f2.call(this, "Async Validation Error") || this, v4.errors = t2, v4.fields = h, v4;
    }
    return i;
  }(aee(Error));
  function Ukr(f2, i, t2, h, v4) {
    if (i.first) {
      var _ = new Promise(function($, et) {
        var at = function(_t) {
          return h(_t), _t.length ? et(new EBe(_t, oee(_t))) : $(v4);
        }, ht = Hkr(f2);
        DBe(ht, t2, at);
      });
      return _.catch(function($) {
        return $;
      }), _;
    }
    var M2 = i.firstFields === true ? Object.keys(f2) : i.firstFields || [], I2 = Object.keys(f2), P2 = I2.length, N3 = 0, z3 = [], H2 = new Promise(function($, et) {
      var at = function(bt) {
        if (z3.push.apply(z3, bt), N3++, N3 === P2)
          return h(z3), z3.length ? et(new EBe(z3, oee(z3))) : $(v4);
      };
      I2.length || (h(z3), $(v4)), I2.forEach(function(ht) {
        var bt = f2[ht];
        M2.indexOf(ht) !== -1 ? DBe(bt, t2, at) : Gkr(bt, t2, at);
      });
    });
    return H2.catch(function($) {
      return $;
    }), H2;
  }
  function qkr(f2) {
    return !!(f2 && f2.message !== void 0);
  }
  function Zkr(f2, i) {
    for (var t2 = f2, h = 0; h < i.length; h++) {
      if (t2 == null)
        return t2;
      t2 = t2[i[h]];
    }
    return t2;
  }
  function kBe(f2, i) {
    return function(t2) {
      var h;
      return f2.fullFields ? h = Zkr(i, f2.fullFields) : h = i[t2.field || f2.fullField], qkr(t2) ? (t2.field = t2.field || f2.fullField, t2.fieldValue = h, t2) : { message: typeof t2 == "function" ? t2() : t2, fieldValue: h, field: t2.field || f2.fullField };
    };
  }
  function PBe(f2, i) {
    if (i) {
      for (var t2 in i)
        if (i.hasOwnProperty(t2)) {
          var h = i[t2];
          typeof h == "object" && typeof f2[t2] == "object" ? f2[t2] = aU({}, f2[t2], h) : f2[t2] = h;
        }
    }
    return f2;
  }
  var yZe = function(i, t2, h, v4, _, M2) {
    i.required && (!h.hasOwnProperty(i.field) || db2(t2, M2 || i.type)) && v4.push(qT(_.messages.required, i.fullField));
  }, $kr = function(i, t2, h, v4, _) {
    (/^\s+$/.test(t2) || t2 === "") && v4.push(qT(_.messages.whitespace, i.fullField));
  }, oJt = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, Tdt = { integer: function(i) {
    return Tdt.number(i) && parseInt(i, 10) === i;
  }, float: function(i) {
    return Tdt.number(i) && !Tdt.integer(i);
  }, array: function(i) {
    return Array.isArray(i);
  }, regexp: function(i) {
    if (i instanceof RegExp)
      return true;
    try {
      return !!new RegExp(i);
    } catch {
      return false;
    }
  }, date: function(i) {
    return typeof i.getTime == "function" && typeof i.getMonth == "function" && typeof i.getYear == "function" && !isNaN(i.getTime());
  }, number: function(i) {
    return isNaN(i) ? false : typeof i == "number";
  }, object: function(i) {
    return typeof i == "object" && !Tdt.array(i);
  }, method: function(i) {
    return typeof i == "function";
  }, email: function(i) {
    return typeof i == "string" && i.length <= 320 && !!i.match(oJt.email);
  }, url: function(i) {
    return typeof i == "string" && i.length <= 2048 && !!i.match(oJt.url);
  }, hex: function(i) {
    return typeof i == "string" && !!i.match(oJt.hex);
  } }, Ykr = function(i, t2, h, v4, _) {
    if (i.required && t2 === void 0) {
      yZe(i, t2, h, v4, _);
      return;
    }
    var M2 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], I2 = i.type;
    M2.indexOf(I2) > -1 ? Tdt[I2](t2) || v4.push(qT(_.messages.types[I2], i.fullField, i.type)) : I2 && typeof t2 !== i.type && v4.push(qT(_.messages.types[I2], i.fullField, i.type));
  }, Kkr = function(i, t2, h, v4, _) {
    var M2 = typeof i.len == "number", I2 = typeof i.min == "number", P2 = typeof i.max == "number", N3 = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, z3 = t2, H2 = null, $ = typeof t2 == "number", et = typeof t2 == "string", at = Array.isArray(t2);
    if ($ ? H2 = "number" : et ? H2 = "string" : at && (H2 = "array"), !H2)
      return false;
    at && (z3 = t2.length), et && (z3 = t2.replace(N3, "_").length), M2 ? z3 !== i.len && v4.push(qT(_.messages[H2].len, i.fullField, i.len)) : I2 && !P2 && z3 < i.min ? v4.push(qT(_.messages[H2].min, i.fullField, i.min)) : P2 && !I2 && z3 > i.max ? v4.push(qT(_.messages[H2].max, i.fullField, i.max)) : I2 && P2 && (z3 < i.min || z3 > i.max) && v4.push(qT(_.messages[H2].range, i.fullField, i.min, i.max));
  }, btt = "enum", Xkr = function(i, t2, h, v4, _) {
    i[btt] = Array.isArray(i[btt]) ? i[btt] : [], i[btt].indexOf(t2) === -1 && v4.push(qT(_.messages[btt], i.fullField, i[btt].join(", ")));
  }, Qkr = function(i, t2, h, v4, _) {
    if (i.pattern) {
      if (i.pattern instanceof RegExp)
        i.pattern.lastIndex = 0, i.pattern.test(t2) || v4.push(qT(_.messages.pattern.mismatch, i.fullField, t2, i.pattern));
      else if (typeof i.pattern == "string") {
        var M2 = new RegExp(i.pattern);
        M2.test(t2) || v4.push(qT(_.messages.pattern.mismatch, i.fullField, t2, i.pattern));
      }
    }
  }, kp = { required: yZe, whitespace: $kr, type: Ykr, range: Kkr, enum: Xkr, pattern: Qkr }, Jkr = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2, "string") && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _, "string"), db2(t2, "string") || (kp.type(i, t2, v4, M2, _), kp.range(i, t2, v4, M2, _), kp.pattern(i, t2, v4, M2, _), i.whitespace === true && kp.whitespace(i, t2, v4, M2, _));
    }
    h(M2);
  }, t5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), t2 !== void 0 && kp.type(i, t2, v4, M2, _);
    }
    h(M2);
  }, e5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (t2 === "" && (t2 = void 0), db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), t2 !== void 0 && (kp.type(i, t2, v4, M2, _), kp.range(i, t2, v4, M2, _));
    }
    h(M2);
  }, n5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), t2 !== void 0 && kp.type(i, t2, v4, M2, _);
    }
    h(M2);
  }, r5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), db2(t2) || kp.type(i, t2, v4, M2, _);
    }
    h(M2);
  }, i5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), t2 !== void 0 && (kp.type(i, t2, v4, M2, _), kp.range(i, t2, v4, M2, _));
    }
    h(M2);
  }, a5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), t2 !== void 0 && (kp.type(i, t2, v4, M2, _), kp.range(i, t2, v4, M2, _));
    }
    h(M2);
  }, o5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (t2 == null && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _, "array"), t2 != null && (kp.type(i, t2, v4, M2, _), kp.range(i, t2, v4, M2, _));
    }
    h(M2);
  }, s5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), t2 !== void 0 && kp.type(i, t2, v4, M2, _);
    }
    h(M2);
  }, l5r = "enum", u5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), t2 !== void 0 && kp[l5r](i, t2, v4, M2, _);
    }
    h(M2);
  }, c5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2, "string") && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _), db2(t2, "string") || kp.pattern(i, t2, v4, M2, _);
    }
    h(M2);
  }, f5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2, "date") && !i.required)
        return h();
      if (kp.required(i, t2, v4, M2, _), !db2(t2, "date")) {
        var P2;
        t2 instanceof Date ? P2 = t2 : P2 = new Date(t2), kp.type(i, P2, v4, M2, _), P2 && kp.range(i, P2.getTime(), v4, M2, _);
      }
    }
    h(M2);
  }, h5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = Array.isArray(t2) ? "array" : typeof t2;
    kp.required(i, t2, v4, M2, _, I2), h(M2);
  }, sJt = function(i, t2, h, v4, _) {
    var M2 = i.type, I2 = [], P2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (P2) {
      if (db2(t2, M2) && !i.required)
        return h();
      kp.required(i, t2, v4, I2, _, M2), db2(t2, M2) || kp.type(i, t2, v4, I2, _);
    }
    h(I2);
  }, p5r = function(i, t2, h, v4, _) {
    var M2 = [], I2 = i.required || !i.required && v4.hasOwnProperty(i.field);
    if (I2) {
      if (db2(t2) && !i.required)
        return h();
      kp.required(i, t2, v4, M2, _);
    }
    h(M2);
  }, Hdt = { string: Jkr, method: t5r, number: e5r, boolean: n5r, regexp: r5r, integer: i5r, float: a5r, array: o5r, object: s5r, enum: u5r, pattern: c5r, date: f5r, url: sJt, hex: sJt, email: sJt, required: h5r, any: p5r };
  function see() {
    return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
      var i = JSON.parse(JSON.stringify(this));
      return i.clone = this.clone, i;
    } };
  }
  var lee = see(), $gt = function() {
    function f2(t2) {
      this.rules = null, this._messages = lee, this.define(t2);
    }
    var i = f2.prototype;
    return i.define = function(h) {
      var v4 = this;
      if (!h)
        throw new Error("Cannot configure a schema with no rules");
      if (typeof h != "object" || Array.isArray(h))
        throw new Error("Rules must be an object");
      this.rules = {}, Object.keys(h).forEach(function(_) {
        var M2 = h[_];
        v4.rules[_] = Array.isArray(M2) ? M2 : [M2];
      });
    }, i.messages = function(h) {
      return h && (this._messages = PBe(see(), h)), this._messages;
    }, i.validate = function(h, v4, _) {
      var M2 = this;
      v4 === void 0 && (v4 = {}), _ === void 0 && (_ = function() {
      });
      var I2 = h, P2 = v4, N3 = _;
      if (typeof P2 == "function" && (N3 = P2, P2 = {}), !this.rules || Object.keys(this.rules).length === 0)
        return N3 && N3(null, I2), Promise.resolve(I2);
      function z3(ht) {
        var bt = [], _t = {};
        function Et(Ft) {
          if (Array.isArray(Ft)) {
            var fe2;
            bt = (fe2 = bt).concat.apply(fe2, Ft);
          } else
            bt.push(Ft);
        }
        for (var zt = 0; zt < ht.length; zt++)
          Et(ht[zt]);
        bt.length ? (_t = oee(bt), N3(bt, _t)) : N3(null, I2);
      }
      if (P2.messages) {
        var H2 = this.messages();
        H2 === lee && (H2 = see()), PBe(H2, P2.messages), P2.messages = H2;
      } else
        P2.messages = this.messages();
      var $ = {}, et = P2.keys || Object.keys(this.rules);
      et.forEach(function(ht) {
        var bt = M2.rules[ht], _t = I2[ht];
        bt.forEach(function(Et) {
          var zt = Et;
          typeof zt.transform == "function" && (I2 === h && (I2 = aU({}, I2)), _t = I2[ht] = zt.transform(_t)), typeof zt == "function" ? zt = { validator: zt } : zt = aU({}, zt), zt.validator = M2.getValidationMethod(zt), zt.validator && (zt.field = ht, zt.fullField = zt.fullField || ht, zt.type = M2.getType(zt), $[ht] = $[ht] || [], $[ht].push({ rule: zt, value: _t, source: I2, field: ht }));
        });
      });
      var at = {};
      return Ukr($, P2, function(ht, bt) {
        var _t = ht.rule, Et = (_t.type === "object" || _t.type === "array") && (typeof _t.fields == "object" || typeof _t.defaultField == "object");
        Et = Et && (_t.required || !_t.required && ht.value), _t.field = ht.field;
        function zt(re2, ye) {
          return aU({}, ye, { fullField: _t.fullField + "." + re2, fullFields: _t.fullFields ? [].concat(_t.fullFields, [re2]) : [re2] });
        }
        function Ft(re2) {
          re2 === void 0 && (re2 = []);
          var ye = Array.isArray(re2) ? re2 : [re2];
          !P2.suppressWarning && ye.length && f2.warning("async-validator:", ye), ye.length && _t.message !== void 0 && (ye = [].concat(_t.message));
          var me2 = ye.map(kBe(_t, I2));
          if (P2.first && me2.length)
            return at[_t.field] = 1, bt(me2);
          if (!Et)
            bt(me2);
          else {
            if (_t.required && !ht.value)
              return _t.message !== void 0 ? me2 = [].concat(_t.message).map(kBe(_t, I2)) : P2.error && (me2 = [P2.error(_t, qT(P2.messages.required, _t.field))]), bt(me2);
            var be2 = {};
            _t.defaultField && Object.keys(ht.value).map(function(en) {
              be2[en] = _t.defaultField;
            }), be2 = aU({}, be2, ht.rule.fields);
            var Te2 = {};
            Object.keys(be2).forEach(function(en) {
              var Ue2 = be2[en], Mn = Array.isArray(Ue2) ? Ue2 : [Ue2];
              Te2[en] = Mn.map(zt.bind(null, en));
            });
            var We = new f2(Te2);
            We.messages(P2.messages), ht.rule.options && (ht.rule.options.messages = P2.messages, ht.rule.options.error = P2.error), We.validate(ht.value, ht.rule.options || P2, function(en) {
              var Ue2 = [];
              me2 && me2.length && Ue2.push.apply(Ue2, me2), en && en.length && Ue2.push.apply(Ue2, en), bt(Ue2.length ? Ue2 : null);
            });
          }
        }
        var fe2;
        _t.asyncValidator ? fe2 = _t.asyncValidator(_t, ht.value, Ft, ht.source, P2) : _t.validator && (fe2 = _t.validator(_t, ht.value, Ft, ht.source, P2), fe2 === true ? Ft() : fe2 === false ? Ft(typeof _t.message == "function" ? _t.message(_t.fullField || _t.field) : _t.message || (_t.fullField || _t.field) + " fails") : fe2 instanceof Array ? Ft(fe2) : fe2 instanceof Error && Ft(fe2.message)), fe2 && fe2.then && fe2.then(function() {
          return Ft();
        }, function(re2) {
          return Ft(re2);
        });
      }, function(ht) {
        z3(ht);
      }, I2);
    }, i.getType = function(h) {
      if (h.type === void 0 && h.pattern instanceof RegExp && (h.type = "pattern"), typeof h.validator != "function" && h.type && !Hdt.hasOwnProperty(h.type))
        throw new Error(qT("Unknown rule type %s", h.type));
      return h.type || "string";
    }, i.getValidationMethod = function(h) {
      if (typeof h.validator == "function")
        return h.validator;
      var v4 = Object.keys(h), _ = v4.indexOf("message");
      return _ !== -1 && v4.splice(_, 1), v4.length === 1 && v4[0] === "required" ? Hdt.required : Hdt[this.getType(h)] || void 0;
    }, f2;
  }();
  $gt.register = function(i, t2) {
    if (typeof t2 != "function")
      throw new Error("Cannot register a validator by type, validator is not a function");
    Hdt[i] = t2;
  };
  $gt.warning = jkr;
  $gt.messages = lee;
  $gt.validators = Hdt;
  var jT = "'${name}' is not a valid ${type}", mZe = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: jT, method: jT, array: jT, object: jT, number: jT, date: jT, boolean: jT, integer: jT, float: jT, regexp: jT, email: jT, url: jT, hex: jT }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
  function bZe(f2, i) {
    for (var t2 = f2, h = 0; h < i.length; h += 1) {
      if (t2 == null)
        return;
      t2 = t2[i[h]];
    }
    return t2;
  }
  function d5r(f2) {
    return nZe(f2) || gZe(f2) || Sre(f2) || rZe();
  }
  function _Ze(f2, i, t2, h) {
    if (!i.length)
      return t2;
    var v4 = d5r(i), _ = v4[0], M2 = v4.slice(1), I2;
    return !f2 && typeof _ == "number" ? I2 = [] : Array.isArray(f2) ? I2 = Up(f2) : I2 = Af2({}, f2), h && t2 === void 0 && M2.length === 1 ? delete I2[_][M2[0]] : I2[_] = _Ze(I2[_], M2, t2, h), I2;
  }
  function g5r(f2, i, t2) {
    var h = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    return i.length && h && t2 === void 0 && !bZe(f2, i.slice(0, -1)) ? f2 : _Ze(f2, i, t2, h);
  }
  function o1(f2) {
    return ree(f2);
  }
  function Ltt(f2, i) {
    var t2 = bZe(f2, i);
    return t2;
  }
  function YH(f2, i, t2) {
    var h = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, v4 = g5r(f2, i, t2, h);
    return v4;
  }
  function LBe(f2, i) {
    var t2 = {};
    return i.forEach(function(h) {
      var v4 = Ltt(f2, h);
      t2 = YH(t2, h, v4);
    }), t2;
  }
  function Udt(f2, i) {
    return f2 && f2.some(function(t2) {
      return wZe(t2, i);
    });
  }
  function OBe(f2) {
    return bS(f2) === "object" && f2 !== null && Object.getPrototypeOf(f2) === Object.prototype;
  }
  function xZe(f2, i) {
    var t2 = Array.isArray(f2) ? Up(f2) : Af2({}, f2);
    return i && Object.keys(i).forEach(function(h) {
      var v4 = t2[h], _ = i[h], M2 = OBe(v4) && OBe(_);
      t2[h] = M2 ? xZe(v4, _ || {}) : _;
    }), t2;
  }
  function aEt(f2) {
    for (var i = arguments.length, t2 = new Array(i > 1 ? i - 1 : 0), h = 1; h < i; h++)
      t2[h - 1] = arguments[h];
    return t2.reduce(function(v4, _) {
      return xZe(v4, _);
    }, f2);
  }
  function wZe(f2, i) {
    return !f2 || !i || f2.length !== i.length ? false : f2.every(function(t2, h) {
      return i[h] === t2;
    });
  }
  function v5r(f2, i) {
    if (f2 === i)
      return true;
    if (!f2 && i || f2 && !i || !f2 || !i || bS(f2) !== "object" || bS(i) !== "object")
      return false;
    var t2 = Object.keys(f2), h = Object.keys(i), v4 = new Set([].concat(Up(t2), Up(h)));
    return Up(v4).every(function(_) {
      var M2 = f2[_], I2 = i[_];
      return typeof M2 == "function" && typeof I2 == "function" ? true : M2 === I2;
    });
  }
  function y5r(f2) {
    var i = arguments.length <= 1 ? void 0 : arguments[1];
    return i && i.target && bS(i.target) === "object" && f2 in i.target ? i.target[f2] : i;
  }
  function RBe(f2, i, t2) {
    var h = f2.length;
    if (i < 0 || i >= h || t2 < 0 || t2 >= h)
      return f2;
    var v4 = f2[i], _ = i - t2;
    return _ > 0 ? [].concat(Up(f2.slice(0, t2)), [v4], Up(f2.slice(t2, i)), Up(f2.slice(i + 1, h))) : _ < 0 ? [].concat(Up(f2.slice(0, i)), Up(f2.slice(i + 1, t2 + 1)), [v4], Up(f2.slice(t2 + 1, h))) : f2;
  }
  var m5r = $gt;
  function b5r(f2, i) {
    return f2.replace(/\$\{\w+\}/g, function(t2) {
      var h = t2.slice(2, -1);
      return i[h];
    });
  }
  function uee(f2, i, t2, h, v4) {
    return cee.apply(this, arguments);
  }
  function cee() {
    return cee = r5t(aV.mark(function f2(i, t2, h, v4, _) {
      var M2, I2, P2, N3, z3, H2, $, et;
      return aV.wrap(function(ht) {
        for (; ; )
          switch (ht.prev = ht.next) {
            case 0:
              return M2 = Af2({}, h), delete M2.ruleIndex, I2 = null, M2 && M2.type === "array" && M2.defaultField && (I2 = M2.defaultField, delete M2.defaultField), P2 = new m5r(sg2({}, i, [M2])), N3 = aEt({}, mZe, v4.validateMessages), P2.messages(N3), z3 = [], ht.prev = 8, ht.next = 11, Promise.resolve(P2.validate(sg2({}, i, t2), Af2({}, v4)));
            case 11:
              ht.next = 16;
              break;
            case 13:
              ht.prev = 13, ht.t0 = ht.catch(8), ht.t0.errors ? z3 = ht.t0.errors.map(function(bt, _t) {
                var Et = bt.message;
                return Vo.isValidElement(Et) ? Vo.cloneElement(Et, { key: "error_".concat(_t) }) : Et;
              }) : (console.error(ht.t0), z3 = [N3.default]);
            case 16:
              if (!(!z3.length && I2)) {
                ht.next = 21;
                break;
              }
              return ht.next = 19, Promise.all(t2.map(function(bt, _t) {
                return uee("".concat(i, ".").concat(_t), bt, I2, v4, _);
              }));
            case 19:
              return H2 = ht.sent, ht.abrupt("return", H2.reduce(function(bt, _t) {
                return [].concat(Up(bt), Up(_t));
              }, []));
            case 21:
              return $ = Af2(Af2({}, h), {}, { name: i, enum: (h.enum || []).join(", ") }, _), et = z3.map(function(bt) {
                return typeof bt == "string" ? b5r(bt, $) : bt;
              }), ht.abrupt("return", et);
            case 24:
            case "end":
              return ht.stop();
          }
      }, f2, null, [[8, 13]]);
    })), cee.apply(this, arguments);
  }
  function _5r(f2, i, t2, h, v4, _) {
    var M2 = f2.join("."), I2 = t2.map(function(z3, H2) {
      var $ = z3.validator, et = Af2(Af2({}, z3), {}, { ruleIndex: H2 });
      return $ && (et.validator = function(at, ht, bt) {
        var _t = false, Et = function() {
          for (var fe2 = arguments.length, re2 = new Array(fe2), ye = 0; ye < fe2; ye++)
            re2[ye] = arguments[ye];
          Promise.resolve().then(function() {
            BL(!_t, "Your validator function has already return a promise. `callback` will be ignored."), _t || bt.apply(void 0, re2);
          });
        }, zt = $(at, ht, Et);
        _t = zt && typeof zt.then == "function" && typeof zt.catch == "function", BL(_t, "`callback` is deprecated. Please return a promise instead."), _t && zt.then(function() {
          bt();
        }).catch(function(Ft) {
          bt(Ft || " ");
        });
      }), et;
    }).sort(function(z3, H2) {
      var $ = z3.warningOnly, et = z3.ruleIndex, at = H2.warningOnly, ht = H2.ruleIndex;
      return !!$ == !!at ? et - ht : $ ? 1 : -1;
    }), P2;
    if (v4 === true)
      P2 = new Promise(function() {
        var z3 = r5t(aV.mark(function H2($, et) {
          var at, ht, bt;
          return aV.wrap(function(Et) {
            for (; ; )
              switch (Et.prev = Et.next) {
                case 0:
                  at = 0;
                case 1:
                  if (!(at < I2.length)) {
                    Et.next = 12;
                    break;
                  }
                  return ht = I2[at], Et.next = 5, uee(M2, i, ht, h, _);
                case 5:
                  if (bt = Et.sent, !bt.length) {
                    Et.next = 9;
                    break;
                  }
                  return et([{ errors: bt, rule: ht }]), Et.abrupt("return");
                case 9:
                  at += 1, Et.next = 1;
                  break;
                case 12:
                  $([]);
                case 13:
                case "end":
                  return Et.stop();
              }
          }, H2);
        }));
        return function(H2, $) {
          return z3.apply(this, arguments);
        };
      }());
    else {
      var N3 = I2.map(function(z3) {
        return uee(M2, i, z3, h, _).then(function(H2) {
          return { errors: H2, rule: z3 };
        });
      });
      P2 = (v4 ? w5r(N3) : x5r(N3)).then(function(z3) {
        return Promise.reject(z3);
      });
    }
    return P2.catch(function(z3) {
      return z3;
    }), P2;
  }
  function x5r(f2) {
    return fee.apply(this, arguments);
  }
  function fee() {
    return fee = r5t(aV.mark(function f2(i) {
      return aV.wrap(function(h) {
        for (; ; )
          switch (h.prev = h.next) {
            case 0:
              return h.abrupt("return", Promise.all(i).then(function(v4) {
                var _, M2 = (_ = []).concat.apply(_, Up(v4));
                return M2;
              }));
            case 1:
            case "end":
              return h.stop();
          }
      }, f2);
    })), fee.apply(this, arguments);
  }
  function w5r(f2) {
    return hee.apply(this, arguments);
  }
  function hee() {
    return hee = r5t(aV.mark(function f2(i) {
      var t2;
      return aV.wrap(function(v4) {
        for (; ; )
          switch (v4.prev = v4.next) {
            case 0:
              return t2 = 0, v4.abrupt("return", new Promise(function(_) {
                i.forEach(function(M2) {
                  M2.then(function(I2) {
                    I2.errors.length && _([I2]), t2 += 1, t2 === i.length && _([]);
                  });
                });
              }));
            case 2:
            case "end":
              return v4.stop();
          }
      }, f2);
    })), hee.apply(this, arguments);
  }
  var S5r = ["name"], jD = [];
  function NBe(f2, i, t2, h, v4, _) {
    return typeof f2 == "function" ? f2(i, t2, "source" in _ ? { source: _.source } : {}) : h !== v4;
  }
  var Lre = function(f2) {
    Tre(t2, f2);
    var i = Ire(t2);
    function t2(h) {
      var v4;
      if (qgt(this, t2), v4 = i.call(this, h), v4.state = { resetCount: 0 }, v4.cancelRegisterFunc = null, v4.mounted = false, v4.touched = false, v4.dirty = false, v4.validatePromise = null, v4.prevValidating = void 0, v4.errors = jD, v4.warnings = jD, v4.cancelRegister = function() {
        var P2 = v4.props, N3 = P2.preserve, z3 = P2.isListField, H2 = P2.name;
        v4.cancelRegisterFunc && v4.cancelRegisterFunc(z3, N3, o1(H2)), v4.cancelRegisterFunc = null;
      }, v4.getNamePath = function() {
        var P2 = v4.props, N3 = P2.name, z3 = P2.fieldContext, H2 = z3.prefixName, $ = H2 === void 0 ? [] : H2;
        return N3 !== void 0 ? [].concat(Up($), Up(N3)) : [];
      }, v4.getRules = function() {
        var P2 = v4.props, N3 = P2.rules, z3 = N3 === void 0 ? [] : N3, H2 = P2.fieldContext;
        return z3.map(function($) {
          return typeof $ == "function" ? $(H2) : $;
        });
      }, v4.refresh = function() {
        !v4.mounted || v4.setState(function(P2) {
          var N3 = P2.resetCount;
          return { resetCount: N3 + 1 };
        });
      }, v4.triggerMetaEvent = function(P2) {
        var N3 = v4.props.onMetaChange;
        N3 == null || N3(Af2(Af2({}, v4.getMeta()), {}, { destroy: P2 }));
      }, v4.onStoreChange = function(P2, N3, z3) {
        var H2 = v4.props, $ = H2.shouldUpdate, et = H2.dependencies, at = et === void 0 ? [] : et, ht = H2.onReset, bt = z3.store, _t = v4.getNamePath(), Et = v4.getValue(P2), zt = v4.getValue(bt), Ft = N3 && Udt(N3, _t);
        switch (z3.type === "valueUpdate" && z3.source === "external" && Et !== zt && (v4.touched = true, v4.dirty = true, v4.validatePromise = null, v4.errors = jD, v4.warnings = jD, v4.triggerMetaEvent()), z3.type) {
          case "reset":
            if (!N3 || Ft) {
              v4.touched = false, v4.dirty = false, v4.validatePromise = null, v4.errors = jD, v4.warnings = jD, v4.triggerMetaEvent(), ht == null || ht(), v4.refresh();
              return;
            }
            break;
          case "remove": {
            if ($) {
              v4.reRender();
              return;
            }
            break;
          }
          case "setField": {
            if (Ft) {
              var fe2 = z3.data;
              "touched" in fe2 && (v4.touched = fe2.touched), "validating" in fe2 && !("originRCField" in fe2) && (v4.validatePromise = fe2.validating ? Promise.resolve([]) : null), "errors" in fe2 && (v4.errors = fe2.errors || jD), "warnings" in fe2 && (v4.warnings = fe2.warnings || jD), v4.dirty = true, v4.triggerMetaEvent(), v4.reRender();
              return;
            }
            if ($ && !_t.length && NBe($, P2, bt, Et, zt, z3)) {
              v4.reRender();
              return;
            }
            break;
          }
          case "dependenciesUpdate": {
            var re2 = at.map(o1);
            if (re2.some(function(ye) {
              return Udt(z3.relatedFields, ye);
            })) {
              v4.reRender();
              return;
            }
            break;
          }
          default:
            if (Ft || (!at.length || _t.length || $) && NBe($, P2, bt, Et, zt, z3)) {
              v4.reRender();
              return;
            }
            break;
        }
        $ === true && v4.reRender();
      }, v4.validateRules = function(P2) {
        var N3 = v4.getNamePath(), z3 = v4.getValue(), H2 = Promise.resolve().then(function() {
          if (!v4.mounted)
            return [];
          var $ = v4.props, et = $.validateFirst, at = et === void 0 ? false : et, ht = $.messageVariables, bt = P2 || {}, _t = bt.triggerName, Et = v4.getRules();
          _t && (Et = Et.filter(function(Ft) {
            var fe2 = Ft.validateTrigger;
            if (!fe2)
              return true;
            var re2 = ree(fe2);
            return re2.includes(_t);
          }));
          var zt = _5r(N3, z3, Et, P2, at, ht);
          return zt.catch(function(Ft) {
            return Ft;
          }).then(function() {
            var Ft = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : jD;
            if (v4.validatePromise === H2) {
              v4.validatePromise = null;
              var fe2 = [], re2 = [];
              Ft.forEach(function(ye) {
                var me2 = ye.rule.warningOnly, be2 = ye.errors, Te2 = be2 === void 0 ? jD : be2;
                me2 ? re2.push.apply(re2, Up(Te2)) : fe2.push.apply(fe2, Up(Te2));
              }), v4.errors = fe2, v4.warnings = re2, v4.triggerMetaEvent(), v4.reRender();
            }
          }), zt;
        });
        return v4.validatePromise = H2, v4.dirty = true, v4.errors = jD, v4.warnings = jD, v4.triggerMetaEvent(), v4.reRender(), H2;
      }, v4.isFieldValidating = function() {
        return !!v4.validatePromise;
      }, v4.isFieldTouched = function() {
        return v4.touched;
      }, v4.isFieldDirty = function() {
        if (v4.dirty || v4.props.initialValue !== void 0)
          return true;
        var P2 = v4.props.fieldContext, N3 = P2.getInternalHooks(Ptt), z3 = N3.getInitialValue;
        return z3(v4.getNamePath()) !== void 0;
      }, v4.getErrors = function() {
        return v4.errors;
      }, v4.getWarnings = function() {
        return v4.warnings;
      }, v4.isListField = function() {
        return v4.props.isListField;
      }, v4.isList = function() {
        return v4.props.isList;
      }, v4.isPreserve = function() {
        return v4.props.preserve;
      }, v4.getMeta = function() {
        v4.prevValidating = v4.isFieldValidating();
        var P2 = { touched: v4.isFieldTouched(), validating: v4.prevValidating, errors: v4.errors, warnings: v4.warnings, name: v4.getNamePath() };
        return P2;
      }, v4.getOnlyChild = function(P2) {
        if (typeof P2 == "function") {
          var N3 = v4.getMeta();
          return Af2(Af2({}, v4.getOnlyChild(P2(v4.getControlled(), N3, v4.props.fieldContext))), {}, { isFunction: true });
        }
        var z3 = nee(P2);
        return z3.length !== 1 || !Vo.isValidElement(z3[0]) ? { child: z3, isFunction: false } : { child: z3[0], isFunction: false };
      }, v4.getValue = function(P2) {
        var N3 = v4.props.fieldContext.getFieldsValue, z3 = v4.getNamePath();
        return Ltt(P2 || N3(true), z3);
      }, v4.getControlled = function() {
        var P2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, N3 = v4.props, z3 = N3.trigger, H2 = N3.validateTrigger, $ = N3.getValueFromEvent, et = N3.normalize, at = N3.valuePropName, ht = N3.getValueProps, bt = N3.fieldContext, _t = H2 !== void 0 ? H2 : bt.validateTrigger, Et = v4.getNamePath(), zt = bt.getInternalHooks, Ft = bt.getFieldsValue, fe2 = zt(Ptt), re2 = fe2.dispatch, ye = v4.getValue(), me2 = ht || function(en) {
          return sg2({}, at, en);
        }, be2 = P2[z3], Te2 = Af2(Af2({}, P2), me2(ye));
        Te2[z3] = function() {
          v4.touched = true, v4.dirty = true, v4.triggerMetaEvent();
          for (var en, Ue2 = arguments.length, Mn = new Array(Ue2), Vn = 0; Vn < Ue2; Vn++)
            Mn[Vn] = arguments[Vn];
          $ ? en = $.apply(void 0, Mn) : en = y5r.apply(void 0, [at].concat(Mn)), et && (en = et(en, ye, Ft(true))), re2({ type: "updateValue", namePath: Et, value: en }), be2 && be2.apply(void 0, Mn);
        };
        var We = ree(_t || []);
        return We.forEach(function(en) {
          var Ue2 = Te2[en];
          Te2[en] = function() {
            Ue2 && Ue2.apply(void 0, arguments);
            var Mn = v4.props.rules;
            Mn && Mn.length && re2({ type: "validateField", namePath: Et, triggerName: en });
          };
        }), Te2;
      }, h.fieldContext) {
        var _ = h.fieldContext.getInternalHooks, M2 = _(Ptt), I2 = M2.initEntityValue;
        I2(Are(v4));
      }
      return v4;
    }
    return Zgt(t2, [{ key: "componentDidMount", value: function() {
      var v4 = this.props, _ = v4.shouldUpdate, M2 = v4.fieldContext;
      if (this.mounted = true, M2) {
        var I2 = M2.getInternalHooks, P2 = I2(Ptt), N3 = P2.registerField;
        this.cancelRegisterFunc = N3(this);
      }
      _ === true && this.reRender();
    } }, { key: "componentWillUnmount", value: function() {
      this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
    } }, { key: "reRender", value: function() {
      !this.mounted || this.forceUpdate();
    } }, { key: "render", value: function() {
      var v4 = this.state.resetCount, _ = this.props.children, M2 = this.getOnlyChild(_), I2 = M2.child, P2 = M2.isFunction, N3;
      return P2 ? N3 = I2 : Vo.isValidElement(I2) ? N3 = Vo.cloneElement(I2, this.getControlled(I2.props)) : (BL(!I2, "`children` of Field is not validate ReactElement."), N3 = I2), Vo.createElement(Vo.Fragment, { key: v4 }, N3);
    } }]), t2;
  }(Vo.Component);
  Lre.contextType = xgt;
  Lre.defaultProps = { trigger: "onChange", valuePropName: "value" };
  function SZe(f2) {
    var i = f2.name, t2 = pet(f2, S5r), h = Vo.useContext(xgt), v4 = i !== void 0 ? o1(i) : void 0, _ = "keep";
    return t2.isListField || (_ = "_".concat((v4 || []).join("_"))), Vo.createElement(Lre, s1({ key: _, name: v4 }, t2, { fieldContext: h }));
  }
  var M5r = Vo.createContext(null), C5r = function(i) {
    var t2 = i.name, h = i.initialValue, v4 = i.children, _ = i.rules, M2 = i.validateTrigger, I2 = Vo.useContext(xgt), P2 = Vo.useRef({ keys: [], id: 0 }), N3 = P2.current, z3 = Vo.useMemo(function() {
      var at = o1(I2.prefixName) || [];
      return [].concat(Up(at), Up(o1(t2)));
    }, [I2.prefixName, t2]), H2 = Vo.useMemo(function() {
      return Af2(Af2({}, I2), {}, { prefixName: z3 });
    }, [I2, z3]), $ = Vo.useMemo(function() {
      return { getKey: function(ht) {
        var bt = z3.length, _t = ht[bt];
        return [N3.keys[_t], ht.slice(bt + 1)];
      } };
    }, [z3]);
    if (typeof v4 != "function")
      return BL(false, "Form.List only accepts function as children."), null;
    var et = function(ht, bt, _t) {
      var Et = _t.source;
      return Et === "internal" ? false : ht !== bt;
    };
    return Vo.createElement(M5r.Provider, { value: $ }, Vo.createElement(xgt.Provider, { value: H2 }, Vo.createElement(SZe, { name: [], shouldUpdate: et, rules: _, validateTrigger: M2, initialValue: h, isList: true }, function(at, ht) {
      var bt = at.value, _t = bt === void 0 ? [] : bt, Et = at.onChange, zt = I2.getFieldValue, Ft = function() {
        var me2 = zt(z3 || []);
        return me2 || [];
      }, fe2 = { add: function(me2, be2) {
        var Te2 = Ft();
        be2 >= 0 && be2 <= Te2.length ? (N3.keys = [].concat(Up(N3.keys.slice(0, be2)), [N3.id], Up(N3.keys.slice(be2))), Et([].concat(Up(Te2.slice(0, be2)), [me2], Up(Te2.slice(be2))))) : (N3.keys = [].concat(Up(N3.keys), [N3.id]), Et([].concat(Up(Te2), [me2]))), N3.id += 1;
      }, remove: function(me2) {
        var be2 = Ft(), Te2 = new Set(Array.isArray(me2) ? me2 : [me2]);
        Te2.size <= 0 || (N3.keys = N3.keys.filter(function(We, en) {
          return !Te2.has(en);
        }), Et(be2.filter(function(We, en) {
          return !Te2.has(en);
        })));
      }, move: function(me2, be2) {
        if (me2 !== be2) {
          var Te2 = Ft();
          me2 < 0 || me2 >= Te2.length || be2 < 0 || be2 >= Te2.length || (N3.keys = RBe(N3.keys, me2, be2), Et(RBe(Te2, me2, be2)));
        }
      } }, re2 = _t || [];
      return Array.isArray(re2) || (re2 = []), v4(re2.map(function(ye, me2) {
        var be2 = N3.keys[me2];
        return be2 === void 0 && (N3.keys[me2] = N3.id, be2 = N3.keys[me2], N3.id += 1), { name: me2, key: be2, isListField: true };
      }), fe2, ht);
    })));
  };
  function T5r(f2) {
    var i = false, t2 = f2.length, h = [];
    return f2.length ? new Promise(function(v4, _) {
      f2.forEach(function(M2, I2) {
        M2.catch(function(P2) {
          return i = true, P2;
        }).then(function(P2) {
          t2 -= 1, h[I2] = P2, !(t2 > 0) && (i && _(h), v4(h));
        });
      });
    }) : Promise.resolve([]);
  }
  var MZe = "__@field_split__";
  function lJt(f2) {
    return f2.map(function(i) {
      return "".concat(bS(i), ":").concat(i);
    }).join(MZe);
  }
  var hdt = function() {
    function f2() {
      qgt(this, f2), this.kvs = /* @__PURE__ */ new Map();
    }
    return Zgt(f2, [{ key: "set", value: function(t2, h) {
      this.kvs.set(lJt(t2), h);
    } }, { key: "get", value: function(t2) {
      return this.kvs.get(lJt(t2));
    } }, { key: "update", value: function(t2, h) {
      var v4 = this.get(t2), _ = h(v4);
      _ ? this.set(t2, _) : this.delete(t2);
    } }, { key: "delete", value: function(t2) {
      this.kvs.delete(lJt(t2));
    } }, { key: "map", value: function(t2) {
      return Up(this.kvs.entries()).map(function(h) {
        var v4 = tE(h, 2), _ = v4[0], M2 = v4[1], I2 = _.split(MZe);
        return t2({ key: I2.map(function(P2) {
          var N3 = P2.match(/^([^:]*):(.*)$/), z3 = tE(N3, 3), H2 = z3[1], $ = z3[2];
          return H2 === "number" ? Number($) : $;
        }), value: M2 });
      });
    } }, { key: "toJSON", value: function() {
      var t2 = {};
      return this.map(function(h) {
        var v4 = h.key, _ = h.value;
        return t2[v4.join(".")] = _, null;
      }), t2;
    } }]), f2;
  }(), A5r = ["name", "errors"], I5r = Zgt(function f2(i) {
    var t2 = this;
    qgt(this, f2), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
      return { getFieldValue: t2.getFieldValue, getFieldsValue: t2.getFieldsValue, getFieldError: t2.getFieldError, getFieldWarning: t2.getFieldWarning, getFieldsError: t2.getFieldsError, isFieldsTouched: t2.isFieldsTouched, isFieldTouched: t2.isFieldTouched, isFieldValidating: t2.isFieldValidating, isFieldsValidating: t2.isFieldsValidating, resetFields: t2.resetFields, setFields: t2.setFields, setFieldsValue: t2.setFieldsValue, validateFields: t2.validateFields, submit: t2.submit, getInternalHooks: t2.getInternalHooks };
    }, this.getInternalHooks = function(h) {
      return h === Ptt ? (t2.formHooked = true, { dispatch: t2.dispatch, initEntityValue: t2.initEntityValue, registerField: t2.registerField, useSubscribe: t2.useSubscribe, setInitialValues: t2.setInitialValues, setCallbacks: t2.setCallbacks, setValidateMessages: t2.setValidateMessages, getFields: t2.getFields, setPreserve: t2.setPreserve, getInitialValue: t2.getInitialValue }) : (BL(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
    }, this.useSubscribe = function(h) {
      t2.subscribable = h;
    }, this.setInitialValues = function(h, v4) {
      t2.initialValues = h || {}, v4 && (t2.store = aEt({}, h, t2.store));
    }, this.getInitialValue = function(h) {
      return Ltt(t2.initialValues, h);
    }, this.setCallbacks = function(h) {
      t2.callbacks = h;
    }, this.setValidateMessages = function(h) {
      t2.validateMessages = h;
    }, this.setPreserve = function(h) {
      t2.preserve = h;
    }, this.timeoutId = null, this.warningUnhooked = function() {
    }, this.getFieldEntities = function() {
      var h = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
      return h ? t2.fieldEntities.filter(function(v4) {
        return v4.getNamePath().length;
      }) : t2.fieldEntities;
    }, this.getFieldsMap = function() {
      var h = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, v4 = new hdt();
      return t2.getFieldEntities(h).forEach(function(_) {
        var M2 = _.getNamePath();
        v4.set(M2, _);
      }), v4;
    }, this.getFieldEntitiesForNamePathList = function(h) {
      if (!h)
        return t2.getFieldEntities(true);
      var v4 = t2.getFieldsMap(true);
      return h.map(function(_) {
        var M2 = o1(_);
        return v4.get(M2) || { INVALIDATE_NAME_PATH: o1(_) };
      });
    }, this.getFieldsValue = function(h, v4) {
      if (t2.warningUnhooked(), h === true && !v4)
        return t2.store;
      var _ = t2.getFieldEntitiesForNamePathList(Array.isArray(h) ? h : null), M2 = [];
      return _.forEach(function(I2) {
        var P2, N3 = "INVALIDATE_NAME_PATH" in I2 ? I2.INVALIDATE_NAME_PATH : I2.getNamePath();
        if (!(!h && ((P2 = I2.isListField) === null || P2 === void 0 ? void 0 : P2.call(I2))))
          if (!v4)
            M2.push(N3);
          else {
            var z3 = "getMeta" in I2 ? I2.getMeta() : null;
            v4(z3) && M2.push(N3);
          }
      }), LBe(t2.store, M2.map(o1));
    }, this.getFieldValue = function(h) {
      t2.warningUnhooked();
      var v4 = o1(h);
      return Ltt(t2.store, v4);
    }, this.getFieldsError = function(h) {
      t2.warningUnhooked();
      var v4 = t2.getFieldEntitiesForNamePathList(h);
      return v4.map(function(_, M2) {
        return _ && !("INVALIDATE_NAME_PATH" in _) ? { name: _.getNamePath(), errors: _.getErrors(), warnings: _.getWarnings() } : { name: o1(h[M2]), errors: [], warnings: [] };
      });
    }, this.getFieldError = function(h) {
      t2.warningUnhooked();
      var v4 = o1(h), _ = t2.getFieldsError([v4])[0];
      return _.errors;
    }, this.getFieldWarning = function(h) {
      t2.warningUnhooked();
      var v4 = o1(h), _ = t2.getFieldsError([v4])[0];
      return _.warnings;
    }, this.isFieldsTouched = function() {
      t2.warningUnhooked();
      for (var h = arguments.length, v4 = new Array(h), _ = 0; _ < h; _++)
        v4[_] = arguments[_];
      var M2 = v4[0], I2 = v4[1], P2, N3 = false;
      v4.length === 0 ? P2 = null : v4.length === 1 ? Array.isArray(M2) ? (P2 = M2.map(o1), N3 = false) : (P2 = null, N3 = M2) : (P2 = M2.map(o1), N3 = I2);
      var z3 = t2.getFieldEntities(true), H2 = function(bt) {
        return bt.isFieldTouched();
      };
      if (!P2)
        return N3 ? z3.every(H2) : z3.some(H2);
      var $ = new hdt();
      P2.forEach(function(ht) {
        $.set(ht, []);
      }), z3.forEach(function(ht) {
        var bt = ht.getNamePath();
        P2.forEach(function(_t) {
          _t.every(function(Et, zt) {
            return bt[zt] === Et;
          }) && $.update(_t, function(Et) {
            return [].concat(Up(Et), [ht]);
          });
        });
      });
      var et = function(bt) {
        return bt.some(H2);
      }, at = $.map(function(ht) {
        var bt = ht.value;
        return bt;
      });
      return N3 ? at.every(et) : at.some(et);
    }, this.isFieldTouched = function(h) {
      return t2.warningUnhooked(), t2.isFieldsTouched([h]);
    }, this.isFieldsValidating = function(h) {
      t2.warningUnhooked();
      var v4 = t2.getFieldEntities();
      if (!h)
        return v4.some(function(M2) {
          return M2.isFieldValidating();
        });
      var _ = h.map(o1);
      return v4.some(function(M2) {
        var I2 = M2.getNamePath();
        return Udt(_, I2) && M2.isFieldValidating();
      });
    }, this.isFieldValidating = function(h) {
      return t2.warningUnhooked(), t2.isFieldsValidating([h]);
    }, this.resetWithFieldInitialValue = function() {
      var h = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, v4 = new hdt(), _ = t2.getFieldEntities(true);
      _.forEach(function(P2) {
        var N3 = P2.props.initialValue, z3 = P2.getNamePath();
        if (N3 !== void 0) {
          var H2 = v4.get(z3) || /* @__PURE__ */ new Set();
          H2.add({ entity: P2, value: N3 }), v4.set(z3, H2);
        }
      });
      var M2 = function(N3) {
        N3.forEach(function(z3) {
          var H2 = z3.props.initialValue;
          if (H2 !== void 0) {
            var $ = z3.getNamePath(), et = t2.getInitialValue($);
            if (et !== void 0)
              BL(false, "Form already set 'initialValues' with path '".concat($.join("."), "'. Field can not overwrite it."));
            else {
              var at = v4.get($);
              if (at && at.size > 1)
                BL(false, "Multiple Field with path '".concat($.join("."), "' set 'initialValue'. Can not decide which one to pick."));
              else if (at) {
                var ht = t2.getFieldValue($);
                (!h.skipExist || ht === void 0) && (t2.store = YH(t2.store, $, Up(at)[0].value));
              }
            }
          }
        });
      }, I2;
      h.entities ? I2 = h.entities : h.namePathList ? (I2 = [], h.namePathList.forEach(function(P2) {
        var N3 = v4.get(P2);
        if (N3) {
          var z3;
          (z3 = I2).push.apply(z3, Up(Up(N3).map(function(H2) {
            return H2.entity;
          })));
        }
      })) : I2 = _, M2(I2);
    }, this.resetFields = function(h) {
      t2.warningUnhooked();
      var v4 = t2.store;
      if (!h) {
        t2.store = aEt({}, t2.initialValues), t2.resetWithFieldInitialValue(), t2.notifyObservers(v4, null, { type: "reset" });
        return;
      }
      var _ = h.map(o1);
      _.forEach(function(M2) {
        var I2 = t2.getInitialValue(M2);
        t2.store = YH(t2.store, M2, I2);
      }), t2.resetWithFieldInitialValue({ namePathList: _ }), t2.notifyObservers(v4, _, { type: "reset" });
    }, this.setFields = function(h) {
      t2.warningUnhooked();
      var v4 = t2.store;
      h.forEach(function(_) {
        var M2 = _.name;
        _.errors;
        var I2 = pet(_, A5r), P2 = o1(M2);
        "value" in I2 && (t2.store = YH(t2.store, P2, I2.value)), t2.notifyObservers(v4, [P2], { type: "setField", data: _ });
      });
    }, this.getFields = function() {
      var h = t2.getFieldEntities(true), v4 = h.map(function(_) {
        var M2 = _.getNamePath(), I2 = _.getMeta(), P2 = Af2(Af2({}, I2), {}, { name: M2, value: t2.getFieldValue(M2) });
        return Object.defineProperty(P2, "originRCField", { value: true }), P2;
      });
      return v4;
    }, this.initEntityValue = function(h) {
      var v4 = h.props.initialValue;
      if (v4 !== void 0) {
        var _ = h.getNamePath(), M2 = Ltt(t2.store, _);
        M2 === void 0 && (t2.store = YH(t2.store, _, v4));
      }
    }, this.registerField = function(h) {
      if (t2.fieldEntities.push(h), h.props.initialValue !== void 0) {
        var v4 = t2.store;
        t2.resetWithFieldInitialValue({ entities: [h], skipExist: true }), t2.notifyObservers(v4, [h.getNamePath()], { type: "valueUpdate", source: "internal" });
      }
      return function(_, M2) {
        var I2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
        t2.fieldEntities = t2.fieldEntities.filter(function($) {
          return $ !== h;
        });
        var P2 = M2 !== void 0 ? M2 : t2.preserve;
        if (P2 === false && (!_ || I2.length > 1)) {
          var N3 = h.getNamePath(), z3 = _ ? void 0 : Ltt(t2.initialValues, N3);
          if (N3.length && t2.getFieldValue(N3) !== z3 && t2.fieldEntities.every(function($) {
            return !wZe($.getNamePath(), N3);
          })) {
            var H2 = t2.store;
            t2.store = YH(H2, N3, z3, true), t2.notifyObservers(H2, [N3], { type: "remove" }), t2.triggerDependenciesUpdate(H2, N3);
          }
        }
      };
    }, this.dispatch = function(h) {
      switch (h.type) {
        case "updateValue": {
          var v4 = h.namePath, _ = h.value;
          t2.updateValue(v4, _);
          break;
        }
        case "validateField": {
          var M2 = h.namePath, I2 = h.triggerName;
          t2.validateFields([M2], { triggerName: I2 });
          break;
        }
      }
    }, this.notifyObservers = function(h, v4, _) {
      if (t2.subscribable) {
        var M2 = Af2(Af2({}, _), {}, { store: t2.getFieldsValue(true) });
        t2.getFieldEntities().forEach(function(I2) {
          var P2 = I2.onStoreChange;
          P2(h, v4, M2);
        });
      } else
        t2.forceRootUpdate();
    }, this.triggerDependenciesUpdate = function(h, v4) {
      var _ = t2.getDependencyChildrenFields(v4);
      return _.length && t2.validateFields(_), t2.notifyObservers(h, _, { type: "dependenciesUpdate", relatedFields: [v4].concat(Up(_)) }), _;
    }, this.updateValue = function(h, v4) {
      var _ = o1(h), M2 = t2.store;
      t2.store = YH(t2.store, _, v4), t2.notifyObservers(M2, [_], { type: "valueUpdate", source: "internal" });
      var I2 = t2.triggerDependenciesUpdate(M2, _), P2 = t2.callbacks.onValuesChange;
      if (P2) {
        var N3 = LBe(t2.store, [_]);
        P2(N3, t2.getFieldsValue());
      }
      t2.triggerOnFieldsChange([_].concat(Up(I2)));
    }, this.setFieldsValue = function(h) {
      t2.warningUnhooked();
      var v4 = t2.store;
      h && (t2.store = aEt(t2.store, h)), t2.notifyObservers(v4, null, { type: "valueUpdate", source: "external" });
    }, this.getDependencyChildrenFields = function(h) {
      var v4 = /* @__PURE__ */ new Set(), _ = [], M2 = new hdt();
      t2.getFieldEntities().forEach(function(P2) {
        var N3 = P2.props.dependencies;
        (N3 || []).forEach(function(z3) {
          var H2 = o1(z3);
          M2.update(H2, function() {
            var $ = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
            return $.add(P2), $;
          });
        });
      });
      var I2 = function P2(N3) {
        var z3 = M2.get(N3) || /* @__PURE__ */ new Set();
        z3.forEach(function(H2) {
          if (!v4.has(H2)) {
            v4.add(H2);
            var $ = H2.getNamePath();
            H2.isFieldDirty() && $.length && (_.push($), P2($));
          }
        });
      };
      return I2(h), _;
    }, this.triggerOnFieldsChange = function(h, v4) {
      var _ = t2.callbacks.onFieldsChange;
      if (_) {
        var M2 = t2.getFields();
        if (v4) {
          var I2 = new hdt();
          v4.forEach(function(N3) {
            var z3 = N3.name, H2 = N3.errors;
            I2.set(z3, H2);
          }), M2.forEach(function(N3) {
            N3.errors = I2.get(N3.name) || N3.errors;
          });
        }
        var P2 = M2.filter(function(N3) {
          var z3 = N3.name;
          return Udt(h, z3);
        });
        _(P2, M2);
      }
    }, this.validateFields = function(h, v4) {
      t2.warningUnhooked();
      var _ = !!h, M2 = _ ? h.map(o1) : [], I2 = [];
      t2.getFieldEntities(true).forEach(function(z3) {
        if (_ || M2.push(z3.getNamePath()), (v4 == null ? void 0 : v4.recursive) && _) {
          var H2 = z3.getNamePath();
          H2.every(function(at, ht) {
            return h[ht] === at || h[ht] === void 0;
          }) && M2.push(H2);
        }
        if (!(!z3.props.rules || !z3.props.rules.length)) {
          var $ = z3.getNamePath();
          if (!_ || Udt(M2, $)) {
            var et = z3.validateRules(Af2({ validateMessages: Af2(Af2({}, mZe), t2.validateMessages) }, v4));
            I2.push(et.then(function() {
              return { name: $, errors: [], warnings: [] };
            }).catch(function(at) {
              var ht = [], bt = [];
              return at.forEach(function(_t) {
                var Et = _t.rule.warningOnly, zt = _t.errors;
                Et ? bt.push.apply(bt, Up(zt)) : ht.push.apply(ht, Up(zt));
              }), ht.length ? Promise.reject({ name: $, errors: ht, warnings: bt }) : { name: $, errors: ht, warnings: bt };
            }));
          }
        }
      });
      var P2 = T5r(I2);
      t2.lastValidatePromise = P2, P2.catch(function(z3) {
        return z3;
      }).then(function(z3) {
        var H2 = z3.map(function($) {
          var et = $.name;
          return et;
        });
        t2.notifyObservers(t2.store, H2, { type: "validateFinish" }), t2.triggerOnFieldsChange(H2, z3);
      });
      var N3 = P2.then(function() {
        return t2.lastValidatePromise === P2 ? Promise.resolve(t2.getFieldsValue(M2)) : Promise.reject([]);
      }).catch(function(z3) {
        var H2 = z3.filter(function($) {
          return $ && $.errors.length;
        });
        return Promise.reject({ values: t2.getFieldsValue(M2), errorFields: H2, outOfDate: t2.lastValidatePromise !== P2 });
      });
      return N3.catch(function(z3) {
        return z3;
      }), N3;
    }, this.submit = function() {
      t2.warningUnhooked(), t2.validateFields().then(function(h) {
        var v4 = t2.callbacks.onFinish;
        if (v4)
          try {
            v4(h);
          } catch (_) {
            console.error(_);
          }
      }).catch(function(h) {
        var v4 = t2.callbacks.onFinishFailed;
        v4 && v4(h);
      });
    }, this.forceRootUpdate = i;
  });
  function CZe(f2) {
    var i = Vo.useRef(), t2 = Vo.useState({}), h = tE(t2, 2), v4 = h[1];
    if (!i.current)
      if (f2)
        i.current = f2;
      else {
        var _ = function() {
          v4({});
        }, M2 = new I5r(_);
        i.current = M2.getForm();
      }
    return [i.current];
  }
  var pee = Vo.createContext({ triggerFormChange: function() {
  }, triggerFormFinish: function() {
  }, registerForm: function() {
  }, unregisterForm: function() {
  } }), D5r = function(i) {
    var t2 = i.validateMessages, h = i.onFormChange, v4 = i.onFormFinish, _ = i.children, M2 = Vo.useContext(pee), I2 = Vo.useRef({});
    return Vo.createElement(pee.Provider, { value: Af2(Af2({}, M2), {}, { validateMessages: Af2(Af2({}, M2.validateMessages), t2), triggerFormChange: function(N3, z3) {
      h && h(N3, { changedFields: z3, forms: I2.current }), M2.triggerFormChange(N3, z3);
    }, triggerFormFinish: function(N3, z3) {
      v4 && v4(N3, { values: z3, forms: I2.current }), M2.triggerFormFinish(N3, z3);
    }, registerForm: function(N3, z3) {
      N3 && (I2.current = Af2(Af2({}, I2.current), {}, sg2({}, N3, z3))), M2.registerForm(N3, z3);
    }, unregisterForm: function(N3) {
      var z3 = Af2({}, I2.current);
      delete z3[N3], I2.current = z3, M2.unregisterForm(N3);
    } }) }, _);
  }, E5r = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], k5r = function(i, t2) {
    var h = i.name, v4 = i.initialValues, _ = i.fields, M2 = i.form, I2 = i.preserve, P2 = i.children, N3 = i.component, z3 = N3 === void 0 ? "form" : N3, H2 = i.validateMessages, $ = i.validateTrigger, et = $ === void 0 ? "onChange" : $, at = i.onValuesChange, ht = i.onFieldsChange, bt = i.onFinish, _t = i.onFinishFailed, Et = pet(i, E5r), zt = Vo.useContext(pee), Ft = CZe(M2), fe2 = tE(Ft, 1), re2 = fe2[0], ye = re2.getInternalHooks(Ptt), me2 = ye.useSubscribe, be2 = ye.setInitialValues, Te2 = ye.setCallbacks, We = ye.setValidateMessages, en = ye.setPreserve;
    Vo.useImperativeHandle(t2, function() {
      return re2;
    }), Vo.useEffect(function() {
      return zt.registerForm(h, re2), function() {
        zt.unregisterForm(h);
      };
    }, [zt, re2, h]), We(Af2(Af2({}, zt.validateMessages), H2)), Te2({ onValuesChange: at, onFieldsChange: function(ai2) {
      if (zt.triggerFormChange(h, ai2), ht) {
        for (var gi2 = arguments.length, To = new Array(gi2 > 1 ? gi2 - 1 : 0), us = 1; us < gi2; us++)
          To[us - 1] = arguments[us];
        ht.apply(void 0, [ai2].concat(To));
      }
    }, onFinish: function(ai2) {
      zt.triggerFormFinish(h, ai2), bt && bt(ai2);
    }, onFinishFailed: _t }), en(I2);
    var Ue2 = Vo.useRef(null);
    be2(v4, !Ue2.current), Ue2.current || (Ue2.current = true);
    var Mn = P2, Vn = typeof P2 == "function";
    if (Vn) {
      var xn = re2.getFieldsValue(true);
      Mn = P2(xn, re2);
    }
    me2(!Vn);
    var Zr = Vo.useRef();
    Vo.useEffect(function() {
      v5r(Zr.current || [], _ || []) || re2.setFields(_ || []), Zr.current = _;
    }, [_, re2]);
    var nr = Vo.useMemo(function() {
      return Af2(Af2({}, re2), {}, { validateTrigger: et });
    }, [re2, et]), pr = Vo.createElement(xgt.Provider, { value: nr }, Mn);
    return z3 === false ? pr : Vo.createElement(z3, s1({}, Et, { onSubmit: function(ai2) {
      ai2.preventDefault(), ai2.stopPropagation(), re2.submit();
    }, onReset: function(ai2) {
      var gi2;
      ai2.preventDefault(), re2.resetFields(), (gi2 = Et.onReset) === null || gi2 === void 0 || gi2.call(Et, ai2);
    } }), pr);
  }, P5r = Vo.forwardRef(k5r), i5t = P5r;
  i5t.FormProvider = D5r;
  i5t.Field = SZe;
  i5t.List = C5r;
  i5t.useForm = CZe;
  var L5r = function(f2, i, t2) {
    BL(f2, "[antd: ".concat(i, "] ").concat(t2));
  }, O5r = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, R5r = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, N5r = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, TZe = N5r, F5r = { lang: s1({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, R5r), timePickerLocale: s1({}, TZe) }, FBe = F5r, WT = "${label} is not a valid ${type}", V5r = { locale: "en", Pagination: O5r, DatePicker: FBe, TimePicker: TZe, Calendar: FBe, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: WT, method: WT, array: WT, object: WT, number: WT, date: WT, boolean: WT, integer: WT, float: WT, regexp: WT, email: WT, url: WT, hex: WT }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, VBe = V5r, B5r = dp.createContext(void 0), z5r = B5r, Ore = function(f2) {
    Tre(t2, f2);
    var i = Ire(t2);
    function t2() {
      return qgt(this, t2), i.apply(this, arguments);
    }
    return Zgt(t2, [{ key: "getLocale", value: function() {
      var v4 = this.props, _ = v4.componentName, M2 = v4.defaultLocale, I2 = M2 || VBe[_ != null ? _ : "global"], P2 = this.context, N3 = _ && P2 ? P2[_] : {};
      return s1(s1({}, I2 instanceof Function ? I2() : I2), N3 || {});
    } }, { key: "getLocaleCode", value: function() {
      var v4 = this.context, _ = v4 && v4.locale;
      return v4 && v4.exist && !_ ? VBe.locale : _;
    } }, { key: "render", value: function() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    } }]), t2;
  }(Vo.Component);
  Ore.defaultProps = { componentName: "global" };
  Ore.contextType = z5r;
  var j5r = function() {
    var i = Vo.useContext(lV), t2 = i.getPrefixCls, h = t2("empty-img-default");
    return Vo.createElement("svg", { className: h, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, Vo.createElement("g", { fill: "none", fillRule: "evenodd" }, Vo.createElement("g", { transform: "translate(24 31.67)" }, Vo.createElement("ellipse", { className: "".concat(h, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), Vo.createElement("path", { className: "".concat(h, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), Vo.createElement("path", { className: "".concat(h, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), Vo.createElement("path", { className: "".concat(h, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), Vo.createElement("path", { className: "".concat(h, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), Vo.createElement("path", { className: "".concat(h, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), Vo.createElement("g", { className: "".concat(h, "-g"), transform: "translate(149.65 15.383)" }, Vo.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), Vo.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
  }, W5r = j5r, G5r = function() {
    var i = Vo.useContext(lV), t2 = i.getPrefixCls, h = t2("empty-img-simple");
    return Vo.createElement("svg", { className: h, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, Vo.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, Vo.createElement("ellipse", { className: "".concat(h, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), Vo.createElement("g", { className: "".concat(h, "-g"), fillRule: "nonzero" }, Vo.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), Vo.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(h, "-path") }))));
  }, H5r = G5r, U5r = globalThis && globalThis.__rest || function(f2, i) {
    var t2 = {};
    for (var h in f2)
      Object.prototype.hasOwnProperty.call(f2, h) && i.indexOf(h) < 0 && (t2[h] = f2[h]);
    if (f2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var v4 = 0, h = Object.getOwnPropertySymbols(f2); v4 < h.length; v4++)
        i.indexOf(h[v4]) < 0 && Object.prototype.propertyIsEnumerable.call(f2, h[v4]) && (t2[h[v4]] = f2[h[v4]]);
    return t2;
  }, AZe = Vo.createElement(W5r, null), IZe = Vo.createElement(H5r, null), Rre = function(i) {
    var t2 = i.className, h = i.prefixCls, v4 = i.image, _ = v4 === void 0 ? AZe : v4, M2 = i.description, I2 = i.children, P2 = i.imageStyle, N3 = U5r(i, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), z3 = Vo.useContext(lV), H2 = z3.getPrefixCls, $ = z3.direction;
    return Vo.createElement(Ore, { componentName: "Empty" }, function(et) {
      var at, ht = H2("empty", h), bt = typeof M2 != "undefined" ? M2 : et.description, _t = typeof bt == "string" ? bt : "empty", Et = null;
      return typeof _ == "string" ? Et = Vo.createElement("img", { alt: _t, src: _ }) : Et = _, Vo.createElement("div", s1({ className: det(ht, (at = {}, sg2(at, "".concat(ht, "-normal"), _ === IZe), sg2(at, "".concat(ht, "-rtl"), $ === "rtl"), at), t2) }, N3), Vo.createElement("div", { className: "".concat(ht, "-image"), style: P2 }, Et), bt && Vo.createElement("div", { className: "".concat(ht, "-description") }, bt), I2 && Vo.createElement("div", { className: "".concat(ht, "-footer") }, I2));
    });
  };
  Rre.PRESENTED_IMAGE_DEFAULT = AZe;
  Rre.PRESENTED_IMAGE_SIMPLE = IZe;
  var pdt = Rre, q5r = function(i) {
    return Vo.createElement(DZe, null, function(t2) {
      var h = t2.getPrefixCls, v4 = h("empty");
      switch (i) {
        case "Table":
        case "List":
          return Vo.createElement(pdt, { image: pdt.PRESENTED_IMAGE_SIMPLE });
        case "Select":
        case "TreeSelect":
        case "Cascader":
        case "Transfer":
        case "Mentions":
          return Vo.createElement(pdt, { image: pdt.PRESENTED_IMAGE_SIMPLE, className: "".concat(v4, "-small") });
        default:
          return Vo.createElement(pdt, null);
      }
    });
  }, Z5r = q5r, $5r = function(i, t2) {
    return t2 || (i ? "ant-".concat(i) : "ant");
  }, lV = Vo.createContext({ getPrefixCls: $5r, renderEmpty: Z5r }), DZe = lV.Consumer, Y5r = Vo.createContext(void 0), K5r = Y5r, EZe = function(i) {
    return +setTimeout(i, 16);
  }, kZe = function(i) {
    return clearTimeout(i);
  };
  typeof window != "undefined" && "requestAnimationFrame" in window && (EZe = function(i) {
    return window.requestAnimationFrame(i);
  }, kZe = function(i) {
    return window.cancelAnimationFrame(i);
  });
  var BBe = 0, Nre = /* @__PURE__ */ new Map();
  function PZe(f2) {
    Nre.delete(f2);
  }
  function rkt(f2) {
    var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    BBe += 1;
    var t2 = BBe;
    function h(v4) {
      if (v4 === 0)
        PZe(t2), f2();
      else {
        var _ = EZe(function() {
          h(v4 - 1);
        });
        Nre.set(t2, _);
      }
    }
    return h(i), t2;
  }
  rkt.cancel = function(f2) {
    var i = Nre.get(f2);
    return PZe(i), kZe(i);
  };
  function X5r(f2, i) {
    var t2 = i || {}, h = t2.defaultValue, v4 = t2.value, _ = t2.onChange, M2 = t2.postState, I2 = Vo.useState(function() {
      return v4 !== void 0 ? v4 : h !== void 0 ? typeof h == "function" ? h() : h : typeof f2 == "function" ? f2() : f2;
    }), P2 = tE(I2, 2), N3 = P2[0], z3 = P2[1], H2 = v4 !== void 0 ? v4 : N3;
    M2 && (H2 = M2(H2));
    var $ = Vo.useRef(_);
    $.current = _;
    var et = Vo.useCallback(function(ht) {
      z3(ht), H2 !== ht && $.current && $.current(ht, H2);
    }, [H2, $]), at = Vo.useRef(true);
    return Vo.useEffect(function() {
      if (at.current) {
        at.current = false;
        return;
      }
      v4 === void 0 && z3(v4);
    }, [v4]), [H2, et];
  }
  var kc2 = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(i) {
    var t2 = i.keyCode;
    if (i.altKey && !i.ctrlKey || i.metaKey || t2 >= kc2.F1 && t2 <= kc2.F12)
      return false;
    switch (t2) {
      case kc2.ALT:
      case kc2.CAPS_LOCK:
      case kc2.CONTEXT_MENU:
      case kc2.CTRL:
      case kc2.DOWN:
      case kc2.END:
      case kc2.ESC:
      case kc2.HOME:
      case kc2.INSERT:
      case kc2.LEFT:
      case kc2.MAC_FF_META:
      case kc2.META:
      case kc2.NUMLOCK:
      case kc2.NUM_CENTER:
      case kc2.PAGE_DOWN:
      case kc2.PAGE_UP:
      case kc2.PAUSE:
      case kc2.PRINT_SCREEN:
      case kc2.RIGHT:
      case kc2.SHIFT:
      case kc2.UP:
      case kc2.WIN_KEY:
      case kc2.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  }, isCharacterKey: function(i) {
    if (i >= kc2.ZERO && i <= kc2.NINE || i >= kc2.NUM_ZERO && i <= kc2.NUM_MULTIPLY || i >= kc2.A && i <= kc2.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && i === 0)
      return true;
    switch (i) {
      case kc2.SPACE:
      case kc2.QUESTION_MARK:
      case kc2.NUM_PLUS:
      case kc2.NUM_MINUS:
      case kc2.NUM_PERIOD:
      case kc2.NUM_DIVISION:
      case kc2.SEMICOLON:
      case kc2.DASH:
      case kc2.EQUALS:
      case kc2.COMMA:
      case kc2.PERIOD:
      case kc2.SLASH:
      case kc2.APOSTROPHE:
      case kc2.SINGLE_QUOTE:
      case kc2.OPEN_SQUARE_BRACKET:
      case kc2.BACKSLASH:
      case kc2.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  } }, LZe = function() {
    for (var i = arguments.length, t2 = new Array(i), h = 0; h < i; h++)
      t2[h] = arguments[h];
    return t2;
  }, Q5r = Vo.isValidElement;
  function J5r(f2, i, t2) {
    return Q5r(f2) ? Vo.cloneElement(f2, typeof t2 == "function" ? t2(f2.props || {}) : t2) : i;
  }
  function tPr(f2, i) {
    return J5r(f2, f2, i);
  }
  var zBe = ["xxl", "xl", "lg", "md", "sm", "xs"], RDt = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, jH = /* @__PURE__ */ new Map(), uJt = -1, NDt = {}, ePr = { matchHandlers: {}, dispatch: function(i) {
    return NDt = i, jH.forEach(function(t2) {
      return t2(NDt);
    }), jH.size >= 1;
  }, subscribe: function(i) {
    return jH.size || this.register(), uJt += 1, jH.set(uJt, i), i(NDt), uJt;
  }, unsubscribe: function(i) {
    jH.delete(i), jH.size || this.unregister();
  }, unregister: function() {
    var i = this;
    Object.keys(RDt).forEach(function(t2) {
      var h = RDt[t2], v4 = i.matchHandlers[h];
      v4 == null || v4.mql.removeListener(v4 == null ? void 0 : v4.listener);
    }), jH.clear();
  }, register: function() {
    var i = this;
    Object.keys(RDt).forEach(function(t2) {
      var h = RDt[t2], v4 = function(I2) {
        var P2 = I2.matches;
        i.dispatch(s1(s1({}, NDt), sg2({}, t2, P2)));
      }, _ = window.matchMedia(h);
      _.addListener(v4), i.matchHandlers[h] = { mql: _, listener: v4 }, v4(_);
    });
  } }, jBe = ePr, nPr = 0, Btt = {};
  function ikt(f2) {
    var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, t2 = nPr++, h = i;
    function v4() {
      h -= 1, h <= 0 ? (f2(), delete Btt[t2]) : Btt[t2] = rkt(v4);
    }
    return Btt[t2] = rkt(v4), t2;
  }
  ikt.cancel = function(i) {
    i !== void 0 && (rkt.cancel(Btt[i]), delete Btt[i]);
  };
  ikt.ids = Btt;
  var cJt;
  function WBe(f2) {
    return !f2 || f2.offsetParent === null || f2.hidden;
  }
  function rPr(f2) {
    var i = (f2 || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
    return i && i[1] && i[2] && i[3] ? !(i[1] === i[2] && i[2] === i[3]) : true;
  }
  var OZe = function(f2) {
    Tre(t2, f2);
    var i = Ire(t2);
    function t2() {
      var h;
      return qgt(this, t2), h = i.apply(this, arguments), h.containerRef = Vo.createRef(), h.animationStart = false, h.destroyed = false, h.onClick = function(v4, _) {
        var M2, I2, P2 = h.props, N3 = P2.insertExtraNode, z3 = P2.disabled;
        if (!(z3 || !v4 || WBe(v4) || v4.className.indexOf("-leave") >= 0)) {
          h.extraNode = document.createElement("div");
          var H2 = Are(h), $ = H2.extraNode, et = h.context.getPrefixCls;
          $.className = "".concat(et(""), "-click-animating-node");
          var at = h.getAttributeName();
          if (v4.setAttribute(at, "true"), _ && _ !== "#ffffff" && _ !== "rgb(255, 255, 255)" && rPr(_) && !/rgba\((?:\d*, ){3}0\)/.test(_) && _ !== "transparent") {
            $.style.borderColor = _;
            var ht = ((M2 = v4.getRootNode) === null || M2 === void 0 ? void 0 : M2.call(v4)) || v4.ownerDocument, bt = ht instanceof Document ? ht.body : (I2 = ht.firstChild) !== null && I2 !== void 0 ? I2 : ht;
            cJt = uZe(`
      [`.concat(et(""), "-click-animating-without-extra-node='true']::after, .").concat(et(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(_, `;
      }`), "antd-wave", { csp: h.csp, attachTo: bt });
          }
          N3 && v4.appendChild($), ["transition", "animation"].forEach(function(_t) {
            v4.addEventListener("".concat(_t, "start"), h.onTransitionStart), v4.addEventListener("".concat(_t, "end"), h.onTransitionEnd);
          });
        }
      }, h.onTransitionStart = function(v4) {
        if (!h.destroyed) {
          var _ = h.containerRef.current;
          !v4 || v4.target !== _ || h.animationStart || h.resetEffect(_);
        }
      }, h.onTransitionEnd = function(v4) {
        !v4 || v4.animationName !== "fadeEffect" || h.resetEffect(v4.target);
      }, h.bindAnimationEvent = function(v4) {
        if (!(!v4 || !v4.getAttribute || v4.getAttribute("disabled") || v4.className.indexOf("disabled") >= 0)) {
          var _ = function(I2) {
            if (!(I2.target.tagName === "INPUT" || WBe(I2.target))) {
              h.resetEffect(v4);
              var P2 = getComputedStyle(v4).getPropertyValue("border-top-color") || getComputedStyle(v4).getPropertyValue("border-color") || getComputedStyle(v4).getPropertyValue("background-color");
              h.clickWaveTimeoutId = window.setTimeout(function() {
                return h.onClick(v4, P2);
              }, 0), ikt.cancel(h.animationStartId), h.animationStart = true, h.animationStartId = ikt(function() {
                h.animationStart = false;
              }, 10);
            }
          };
          return v4.addEventListener("click", _, true), { cancel: function() {
            v4.removeEventListener("click", _, true);
          } };
        }
      }, h.renderWave = function(v4) {
        var _ = v4.csp, M2 = h.props.children;
        if (h.csp = _, !Vo.isValidElement(M2))
          return M2;
        var I2 = h.containerRef;
        return Ekr(M2) && (I2 = Dkr(M2.ref, h.containerRef)), tPr(M2, { ref: I2 });
      }, h;
    }
    return Zgt(t2, [{ key: "componentDidMount", value: function() {
      var v4 = this.containerRef.current;
      !v4 || v4.nodeType !== 1 || (this.instance = this.bindAnimationEvent(v4));
    } }, { key: "componentWillUnmount", value: function() {
      this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
    } }, { key: "getAttributeName", value: function() {
      var v4 = this.context.getPrefixCls, _ = this.props.insertExtraNode;
      return _ ? "".concat(v4(""), "-click-animating") : "".concat(v4(""), "-click-animating-without-extra-node");
    } }, { key: "resetEffect", value: function(v4) {
      var _ = this;
      if (!(!v4 || v4 === this.extraNode || !(v4 instanceof Element))) {
        var M2 = this.props.insertExtraNode, I2 = this.getAttributeName();
        v4.setAttribute(I2, "false"), cJt && (cJt.innerHTML = ""), M2 && this.extraNode && v4.contains(this.extraNode) && v4.removeChild(this.extraNode), ["transition", "animation"].forEach(function(P2) {
          v4.removeEventListener("".concat(P2, "start"), _.onTransitionStart), v4.removeEventListener("".concat(P2, "end"), _.onTransitionEnd);
        });
      }
    } }, { key: "render", value: function() {
      return Vo.createElement(DZe, null, this.renderWave);
    } }]), t2;
  }(Vo.Component);
  OZe.contextType = lV;
  var Fre = { exports: {} }, Ygt = {};
  /** @license React v17.0.2
  * react-jsx-runtime.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var iPr = ztt.default, RZe = 60103;
  Ygt.Fragment = 60107;
  if (typeof Symbol == "function" && Symbol.for) {
    var GBe = Symbol.for;
    RZe = GBe("react.element"), Ygt.Fragment = GBe("react.fragment");
  }
  var aPr = iPr.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, oPr = Object.prototype.hasOwnProperty, sPr = { key: true, ref: true, __self: true, __source: true };
  function NZe(f2, i, t2) {
    var h, v4 = {}, _ = null, M2 = null;
    t2 !== void 0 && (_ = "" + t2), i.key !== void 0 && (_ = "" + i.key), i.ref !== void 0 && (M2 = i.ref);
    for (h in i)
      oPr.call(i, h) && !sPr.hasOwnProperty(h) && (v4[h] = i[h]);
    if (f2 && f2.defaultProps)
      for (h in i = f2.defaultProps, i)
        v4[h] === void 0 && (v4[h] = i[h]);
    return { $$typeof: RZe, type: f2, key: _, ref: M2, props: v4, _owner: aPr.current };
  }
  Ygt.jsx = NZe;
  Ygt.jsxs = NZe;
  Fre.exports = Ygt;
  const Ctt = Fre.exports.jsx, lPr = Fre.exports.jsxs;
  var uPr = dp.createContext({}), FZe = uPr, cPr = function() {
    return sZe() && window.document.documentElement;
  }, FDt, fPr = function() {
    if (!cPr())
      return false;
    if (FDt !== void 0)
      return FDt;
    var i = document.createElement("div");
    return i.style.display = "flex", i.style.flexDirection = "column", i.style.rowGap = "1px", i.appendChild(document.createElement("div")), i.appendChild(document.createElement("div")), document.body.appendChild(i), FDt = i.scrollHeight === 1, document.body.removeChild(i), FDt;
  }, hPr = function() {
    var f2 = Vo.useState(false), i = tE(f2, 2), t2 = i[0], h = i[1];
    return Vo.useEffect(function() {
      h(fPr());
    }, []), t2;
  }, pPr = globalThis && globalThis.__rest || function(f2, i) {
    var t2 = {};
    for (var h in f2)
      Object.prototype.hasOwnProperty.call(f2, h) && i.indexOf(h) < 0 && (t2[h] = f2[h]);
    if (f2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var v4 = 0, h = Object.getOwnPropertySymbols(f2); v4 < h.length; v4++)
        i.indexOf(h[v4]) < 0 && Object.prototype.propertyIsEnumerable.call(f2, h[v4]) && (t2[h[v4]] = f2[h[v4]]);
    return t2;
  };
  LZe("top", "middle", "bottom", "stretch");
  LZe("start", "end", "center", "space-around", "space-between");
  var VZe = Vo.forwardRef(function(f2, i) {
    var t2, h = f2.prefixCls, v4 = f2.justify, _ = f2.align, M2 = f2.className, I2 = f2.style, P2 = f2.children, N3 = f2.gutter, z3 = N3 === void 0 ? 0 : N3, H2 = f2.wrap, $ = pPr(f2, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), et = Vo.useContext(lV), at = et.getPrefixCls, ht = et.direction, bt = Vo.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), _t = tE(bt, 2), Et = _t[0], zt = _t[1], Ft = hPr(), fe2 = Vo.useRef(z3);
    Vo.useEffect(function() {
      var nr = jBe.subscribe(function(pr) {
        var Nr = fe2.current || 0;
        (!Array.isArray(Nr) && bS(Nr) === "object" || Array.isArray(Nr) && (bS(Nr[0]) === "object" || bS(Nr[1]) === "object")) && zt(pr);
      });
      return function() {
        return jBe.unsubscribe(nr);
      };
    }, []);
    var re2 = function() {
      var pr = [0, 0], Nr = Array.isArray(z3) ? z3 : [z3, 0];
      return Nr.forEach(function(ai2, gi2) {
        if (bS(ai2) === "object")
          for (var To = 0; To < zBe.length; To++) {
            var us = zBe[To];
            if (Et[us] && ai2[us] !== void 0) {
              pr[gi2] = ai2[us];
              break;
            }
          }
        else
          pr[gi2] = ai2 || 0;
      }), pr;
    }, ye = at("row", h), me2 = re2(), be2 = det(ye, (t2 = {}, sg2(t2, "".concat(ye, "-no-wrap"), H2 === false), sg2(t2, "".concat(ye, "-").concat(v4), v4), sg2(t2, "".concat(ye, "-").concat(_), _), sg2(t2, "".concat(ye, "-rtl"), ht === "rtl"), t2), M2), Te2 = {}, We = me2[0] > 0 ? me2[0] / -2 : void 0, en = me2[1] > 0 ? me2[1] / -2 : void 0;
    if (We && (Te2.marginLeft = We, Te2.marginRight = We), Ft) {
      var Ue2 = tE(me2, 2);
      Te2.rowGap = Ue2[1];
    } else
      en && (Te2.marginTop = en, Te2.marginBottom = en);
    var Mn = tE(me2, 2), Vn = Mn[0], xn = Mn[1], Zr = Vo.useMemo(function() {
      return { gutter: [Vn, xn], wrap: H2, supportFlexGap: Ft };
    }, [Vn, xn, H2, Ft]);
    return Vo.createElement(FZe.Provider, { value: Zr }, Vo.createElement("div", s1({}, $, { className: be2, style: s1(s1({}, Te2), I2), ref: i }), P2));
  });
  VZe.displayName = "Row";
  var dPr = VZe, gPr = globalThis && globalThis.__rest || function(f2, i) {
    var t2 = {};
    for (var h in f2)
      Object.prototype.hasOwnProperty.call(f2, h) && i.indexOf(h) < 0 && (t2[h] = f2[h]);
    if (f2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var v4 = 0, h = Object.getOwnPropertySymbols(f2); v4 < h.length; v4++)
        i.indexOf(h[v4]) < 0 && Object.prototype.propertyIsEnumerable.call(f2, h[v4]) && (t2[h[v4]] = f2[h[v4]]);
    return t2;
  };
  function vPr(f2) {
    return typeof f2 == "number" ? "".concat(f2, " ").concat(f2, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(f2) ? "0 0 ".concat(f2) : f2;
  }
  var yPr = ["xs", "sm", "md", "lg", "xl", "xxl"], BZe = Vo.forwardRef(function(f2, i) {
    var t2, h = Vo.useContext(lV), v4 = h.getPrefixCls, _ = h.direction, M2 = Vo.useContext(FZe), I2 = M2.gutter, P2 = M2.wrap, N3 = M2.supportFlexGap, z3 = f2.prefixCls, H2 = f2.span, $ = f2.order, et = f2.offset, at = f2.push, ht = f2.pull, bt = f2.className, _t = f2.children, Et = f2.flex, zt = f2.style, Ft = gPr(f2, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), fe2 = v4("col", z3), re2 = {};
    yPr.forEach(function(We) {
      var en, Ue2 = {}, Mn = f2[We];
      typeof Mn == "number" ? Ue2.span = Mn : bS(Mn) === "object" && (Ue2 = Mn || {}), delete Ft[We], re2 = s1(s1({}, re2), (en = {}, sg2(en, "".concat(fe2, "-").concat(We, "-").concat(Ue2.span), Ue2.span !== void 0), sg2(en, "".concat(fe2, "-").concat(We, "-order-").concat(Ue2.order), Ue2.order || Ue2.order === 0), sg2(en, "".concat(fe2, "-").concat(We, "-offset-").concat(Ue2.offset), Ue2.offset || Ue2.offset === 0), sg2(en, "".concat(fe2, "-").concat(We, "-push-").concat(Ue2.push), Ue2.push || Ue2.push === 0), sg2(en, "".concat(fe2, "-").concat(We, "-pull-").concat(Ue2.pull), Ue2.pull || Ue2.pull === 0), sg2(en, "".concat(fe2, "-rtl"), _ === "rtl"), en));
    });
    var ye = det(fe2, (t2 = {}, sg2(t2, "".concat(fe2, "-").concat(H2), H2 !== void 0), sg2(t2, "".concat(fe2, "-order-").concat($), $), sg2(t2, "".concat(fe2, "-offset-").concat(et), et), sg2(t2, "".concat(fe2, "-push-").concat(at), at), sg2(t2, "".concat(fe2, "-pull-").concat(ht), ht), t2), bt, re2), me2 = {};
    if (I2 && I2[0] > 0) {
      var be2 = I2[0] / 2;
      me2.paddingLeft = be2, me2.paddingRight = be2;
    }
    if (I2 && I2[1] > 0 && !N3) {
      var Te2 = I2[1] / 2;
      me2.paddingTop = Te2, me2.paddingBottom = Te2;
    }
    return Et && (me2.flex = vPr(Et), P2 === false && !me2.minWidth && (me2.minWidth = 0)), Vo.createElement("div", s1({}, Ft, { style: s1(s1({}, me2), zt), className: ye, ref: i }), _t);
  });
  BZe.displayName = "Col";
  var mPr = BZe, zZe = Vo.forwardRef(function(f2, i) {
    var t2, h = f2.prefixCls, v4 = h === void 0 ? "rc-switch" : h, _ = f2.className, M2 = f2.checked, I2 = f2.defaultChecked, P2 = f2.disabled, N3 = f2.loadingIcon, z3 = f2.checkedChildren, H2 = f2.unCheckedChildren, $ = f2.onClick, et = f2.onChange, at = f2.onKeyDown, ht = pet(f2, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), bt = X5r(false, { value: M2, defaultValue: I2 }), _t = tE(bt, 2), Et = _t[0], zt = _t[1];
    function Ft(me2, be2) {
      var Te2 = Et;
      return P2 || (Te2 = me2, zt(Te2), et == null || et(Te2, be2)), Te2;
    }
    function fe2(me2) {
      me2.which === kc2.LEFT ? Ft(false, me2) : me2.which === kc2.RIGHT && Ft(true, me2), at == null || at(me2);
    }
    function re2(me2) {
      var be2 = Ft(!Et, me2);
      $ == null || $(be2, me2);
    }
    var ye = det(v4, _, (t2 = {}, sg2(t2, "".concat(v4, "-checked"), Et), sg2(t2, "".concat(v4, "-disabled"), P2), t2));
    return Vo.createElement("button", Object.assign({}, ht, { type: "button", role: "switch", "aria-checked": Et, disabled: P2, className: ye, ref: i, onKeyDown: fe2, onClick: re2 }), N3, Vo.createElement("span", { className: "".concat(v4, "-inner") }, Et ? z3 : H2));
  });
  zZe.displayName = "Switch";
  var bPr = globalThis && globalThis.__rest || function(f2, i) {
    var t2 = {};
    for (var h in f2)
      Object.prototype.hasOwnProperty.call(f2, h) && i.indexOf(h) < 0 && (t2[h] = f2[h]);
    if (f2 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var v4 = 0, h = Object.getOwnPropertySymbols(f2); v4 < h.length; v4++)
        i.indexOf(h[v4]) < 0 && Object.prototype.propertyIsEnumerable.call(f2, h[v4]) && (t2[h[v4]] = f2[h[v4]]);
    return t2;
  }, Vre = Vo.forwardRef(function(f2, i) {
    var t2, h = f2.prefixCls, v4 = f2.size, _ = f2.loading, M2 = f2.className, I2 = M2 === void 0 ? "" : M2, P2 = f2.disabled, N3 = bPr(f2, ["prefixCls", "size", "loading", "className", "disabled"]);
    L5r("checked" in N3 || !("value" in N3), "Switch", "`value` is not a valid prop, do you mean `checked`?");
    var z3 = Vo.useContext(lV), H2 = z3.getPrefixCls, $ = z3.direction, et = Vo.useContext(K5r), at = H2("switch", h), ht = Vo.createElement("div", { className: "".concat(at, "-handle") }, _ && Vo.createElement(_kr, { className: "".concat(at, "-loading-icon") })), bt = det((t2 = {}, sg2(t2, "".concat(at, "-small"), (v4 || et) === "small"), sg2(t2, "".concat(at, "-loading"), _), sg2(t2, "".concat(at, "-rtl"), $ === "rtl"), t2), I2);
    return Vo.createElement(OZe, { insertExtraNode: true }, Vo.createElement(zZe, s1({}, N3, { prefixCls: at, className: bt, disabled: P2 || _, ref: i, loadingIcon: ht })));
  });
  Vre.__ANT_SWITCH = true;
  Vre.displayName = "Switch";
  var _Pr = Vre;
  const xPr = "_container_oi76t_1";
  var wPr = { container: xPr, function: "_function_oi76t_10" };
  var jZe = {};
  (function(f2) {
    var i = Object.defineProperty, t2 = Object.getOwnPropertySymbols, h = Object.prototype.hasOwnProperty, v4 = Object.prototype.propertyIsEnumerable, _ = (l2, a, e2) => a in l2 ? i(l2, a, { enumerable: true, configurable: true, writable: true, value: e2 }) : l2[a] = e2, M2 = (l2, a) => {
      for (var e2 in a || (a = {}))
        h.call(a, e2) && _(l2, e2, a[e2]);
      if (t2)
        for (var e2 of t2(a))
          v4.call(a, e2) && _(l2, e2, a[e2]);
      return l2;
    }, I2 = (l2, a, e2) => (_(l2, typeof a != "symbol" ? a + "" : a, e2), e2);
    Object.defineProperties(f2, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
    var P2 = ztt.default;
    function N3(l2) {
      return l2 && typeof l2 == "object" && "default" in l2 ? l2 : { default: l2 };
    }
    function z3(l2) {
      if (l2 && l2.__esModule)
        return l2;
      var a = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
      return l2 && Object.keys(l2).forEach(function(e2) {
        if (e2 !== "default") {
          var d2 = Object.getOwnPropertyDescriptor(l2, e2);
          Object.defineProperty(a, e2, d2.get ? d2 : { enumerable: true, get: function() {
            return l2[e2];
          } });
        }
      }), a.default = l2, Object.freeze(a);
    }
    var H2 = N3(P2), $ = z3(P2), et = globalThis && globalThis.__read || function(l2, a) {
      var e2 = typeof Symbol == "function" && l2[Symbol.iterator];
      if (!e2)
        return l2;
      var d2 = e2.call(l2), y2, x2 = [], C;
      try {
        for (; (a === void 0 || a-- > 0) && !(y2 = d2.next()).done; )
          x2.push(y2.value);
      } catch (D2) {
        C = { error: D2 };
      } finally {
        try {
          y2 && !y2.done && (e2 = d2.return) && e2.call(d2);
        } finally {
          if (C)
            throw C.error;
        }
      }
      return x2;
    };
    function at(l2, a) {
      l2 === void 0 && (l2 = false);
      var e2 = et(P2.useState(l2), 2), d2 = e2[0], y2 = e2[1], x2 = P2.useMemo(function() {
        var C = a === void 0 ? !l2 : a, D2 = function() {
          return y2(function(U3) {
            return U3 === l2 ? C : l2;
          });
        }, L = function(U3) {
          return y2(U3);
        }, F3 = function() {
          return y2(l2);
        }, j = function() {
          return y2(C);
        };
        return { toggle: D2, set: L, setLeft: F3, setRight: j };
      }, []);
      return [d2, x2];
    }
    var ht = globalThis && globalThis.__read || function(l2, a) {
      var e2 = typeof Symbol == "function" && l2[Symbol.iterator];
      if (!e2)
        return l2;
      var d2 = e2.call(l2), y2, x2 = [], C;
      try {
        for (; (a === void 0 || a-- > 0) && !(y2 = d2.next()).done; )
          x2.push(y2.value);
      } catch (D2) {
        C = { error: D2 };
      } finally {
        try {
          y2 && !y2.done && (e2 = d2.return) && e2.call(d2);
        } finally {
          if (C)
            throw C.error;
        }
      }
      return x2;
    };
    function bt(l2) {
      l2 === void 0 && (l2 = false);
      var a = ht(at(l2), 2), e2 = a[0], d2 = a[1], y2 = d2.toggle, x2 = d2.set, C = P2.useMemo(function() {
        var D2 = function() {
          return x2(true);
        }, L = function() {
          return x2(false);
        };
        return { toggle: y2, set: function(F3) {
          return x2(!!F3);
        }, setTrue: D2, setFalse: L };
      }, []);
      return [e2, C];
    }
    function _t(l2) {
      var a = P2.useRef(l2);
      return a.current = l2, a;
    }
    var Et = !!(typeof window != "undefined" && window.document && window.document.createElement), zt = Et;
    function Ft(l2, a) {
      if (zt) {
        if (!l2)
          return a;
        var e2;
        return typeof l2 == "function" ? e2 = l2() : "current" in l2 ? e2 = l2.current : e2 = l2, e2;
      }
    }
    var fe2 = function(l2) {
      var a = _t(l2);
      P2.useEffect(function() {
        return function() {
          a.current();
        };
      }, []);
    }, re2 = fe2;
    function ye(l2, a) {
      if (l2 === a)
        return true;
      for (var e2 = 0; e2 < l2.length; e2++)
        if (!Object.is(l2[e2], a[e2]))
          return false;
      return true;
    }
    var me2 = function(l2) {
      var a = function(e2, d2, y2) {
        var x2 = P2.useRef(false), C = P2.useRef([]), D2 = P2.useRef([]), L = P2.useRef();
        l2(function() {
          var F3, j = Array.isArray(y2) ? y2 : [y2], U3 = j.map(function(Y3) {
            return Ft(Y3);
          });
          if (!x2.current) {
            x2.current = true, C.current = U3, D2.current = d2, L.current = e2();
            return;
          }
          (U3.length !== C.current.length || !ye(U3, C.current) || !ye(d2, D2.current)) && ((F3 = L.current) === null || F3 === void 0 || F3.call(L), C.current = U3, D2.current = d2, L.current = e2());
        }), re2(function() {
          var F3;
          (F3 = L.current) === null || F3 === void 0 || F3.call(L), x2.current = false;
        });
      };
      return a;
    }, be2 = me2, Te2 = be2(P2.useEffect), We = Te2, en = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof YD != "undefined" ? YD : typeof self != "undefined" ? self : {};
    function Ue2(l2) {
      return l2 && l2.__esModule && Object.prototype.hasOwnProperty.call(l2, "default") ? l2.default : l2;
    }
    function Mn(l2) {
      var a = typeof l2;
      return l2 != null && (a == "object" || a == "function");
    }
    var Vn = Mn, xn = typeof en == "object" && en && en.Object === Object && en, Zr = xn, nr = Zr, pr = typeof self == "object" && self && self.Object === Object && self, Nr = nr || pr || Function("return this")(), ai2 = Nr, gi2 = ai2, To = function() {
      return gi2.Date.now();
    }, us = To, ml = /\s/;
    function ll(l2) {
      for (var a = l2.length; a-- && ml.test(l2.charAt(a)); )
        ;
      return a;
    }
    var Rs = ll, es = Rs, Ws = /^\s+/;
    function il(l2) {
      return l2 && l2.slice(0, es(l2) + 1).replace(Ws, "");
    }
    var bs = il, Rl = ai2, Mh2 = Rl.Symbol, au = Mh2, eh2 = au, Gh2 = Object.prototype, Pp = Gh2.hasOwnProperty, zy = Gh2.toString, Rd2 = eh2 ? eh2.toStringTag : void 0;
    function c1(l2) {
      var a = Pp.call(l2, Rd2), e2 = l2[Rd2];
      try {
        l2[Rd2] = void 0;
        var d2 = true;
      } catch {
      }
      var y2 = zy.call(l2);
      return d2 && (a ? l2[Rd2] = e2 : delete l2[Rd2]), y2;
    }
    var _d = c1, G0 = Object.prototype, qg2 = G0.toString;
    function XT(l2) {
      return qg2.call(l2);
    }
    var fo = XT, ra2 = au, Ki2 = _d, ho = fo, Bs = "[object Null]", Ql = "[object Undefined]", ff2 = ra2 ? ra2.toStringTag : void 0;
    function hf2(l2) {
      return l2 == null ? l2 === void 0 ? Ql : Bs : ff2 && ff2 in Object(l2) ? Ki2(l2) : ho(l2);
    }
    var qp = hf2;
    function sv(l2) {
      return l2 != null && typeof l2 == "object";
    }
    var lg2 = sv, H0 = qp, ug2 = lg2, gb2 = "[object Symbol]";
    function x_(l2) {
      return typeof l2 == "symbol" || ug2(l2) && H0(l2) == gb2;
    }
    var W2 = x_, w_ = bs, t0 = Vn, Hh2 = W2, yy = 0 / 0, f1 = /^[-+]0x[0-9a-f]+$/i, G2 = /^0b[01]+$/i, qx = /^0o[0-7]+$/i, S_ = parseInt;
    function MS(l2) {
      if (typeof l2 == "number")
        return l2;
      if (Hh2(l2))
        return yy;
      if (t0(l2)) {
        var a = typeof l2.valueOf == "function" ? l2.valueOf() : l2;
        l2 = t0(a) ? a + "" : a;
      }
      if (typeof l2 != "string")
        return l2 === 0 ? l2 : +l2;
      l2 = w_(l2);
      var e2 = G2.test(l2);
      return e2 || qx.test(l2) ? S_(l2.slice(2), e2 ? 2 : 8) : f1.test(l2) ? yy : +l2;
    }
    var E5 = MS, sE = Vn, uV = us, lE = E5, get2 = "Expected a function", vet = Math.max, yet = Math.min;
    function met(l2, a, e2) {
      var d2, y2, x2, C, D2, L, F3 = 0, j = false, U3 = false, Y3 = true;
      if (typeof l2 != "function")
        throw new TypeError(get2);
      a = lE(a) || 0, sE(e2) && (j = !!e2.leading, U3 = "maxWait" in e2, x2 = U3 ? vet(lE(e2.maxWait) || 0, a) : x2, Y3 = "trailing" in e2 ? !!e2.trailing : Y3);
      function Q(ne2) {
        var he2 = d2, _e = y2;
        return d2 = y2 = void 0, F3 = ne2, C = l2.apply(_e, he2), C;
      }
      function nt(ne2) {
        return F3 = ne2, D2 = setTimeout(Ct, a), j ? Q(ne2) : C;
      }
      function dt(ne2) {
        var he2 = ne2 - L, _e = ne2 - F3, Me2 = a - he2;
        return U3 ? yet(Me2, x2 - _e) : Me2;
      }
      function vt(ne2) {
        var he2 = ne2 - L, _e = ne2 - F3;
        return L === void 0 || he2 >= a || he2 < 0 || U3 && _e >= x2;
      }
      function Ct() {
        var ne2 = uV();
        if (vt(ne2))
          return Pt(ne2);
        D2 = setTimeout(Ct, dt(ne2));
      }
      function Pt(ne2) {
        return D2 = void 0, Y3 && d2 ? Q(ne2) : (d2 = y2 = void 0, C);
      }
      function jt() {
        D2 !== void 0 && clearTimeout(D2), F3 = 0, d2 = L = y2 = D2 = void 0;
      }
      function Rt() {
        return D2 === void 0 ? C : Pt(uV());
      }
      function le2() {
        var ne2 = uV(), he2 = vt(ne2);
        if (d2 = arguments, y2 = this, L = ne2, he2) {
          if (D2 === void 0)
            return nt(L);
          if (U3)
            return clearTimeout(D2), D2 = setTimeout(Ct, a), Q(L);
        }
        return D2 === void 0 && (D2 = setTimeout(Ct, a)), C;
      }
      return le2.cancel = jt, le2.flush = Rt, le2;
    }
    var sN = met, _r = globalThis && globalThis.__read || function(l2, a) {
      var e2 = typeof Symbol == "function" && l2[Symbol.iterator];
      if (!e2)
        return l2;
      var d2 = e2.call(l2), y2, x2 = [], C;
      try {
        for (; (a === void 0 || a-- > 0) && !(y2 = d2.next()).done; )
          x2.push(y2.value);
      } catch (D2) {
        C = { error: D2 };
      } finally {
        try {
          y2 && !y2.done && (e2 = d2.return) && e2.call(d2);
        } finally {
          if (C)
            throw C.error;
        }
      }
      return x2;
    }, Er = globalThis && globalThis.__spread || function() {
      for (var l2 = [], a = 0; a < arguments.length; a++)
        l2 = l2.concat(_r(arguments[a]));
      return l2;
    };
    function Ln(l2, a) {
      var e2, d2 = _t(l2), y2 = (e2 = a == null ? void 0 : a.wait) !== null && e2 !== void 0 ? e2 : 1e3, x2 = P2.useMemo(function() {
        return sN(function() {
          for (var C = [], D2 = 0; D2 < arguments.length; D2++)
            C[D2] = arguments[D2];
          return d2.current.apply(d2, Er(C));
        }, y2, a);
      }, []);
      return re2(function() {
        x2.cancel();
      }), { run: x2, cancel: x2.cancel, flush: x2.flush };
    }
    var cr = function(l2) {
      return function(a, e2) {
        var d2 = P2.useRef(false);
        l2(function() {
          return function() {
            d2.current = false;
          };
        }, []), l2(function() {
          if (!d2.current)
            d2.current = true;
          else
            return a();
        }, e2);
      };
    }, yr = cr(P2.useEffect), Ui2 = globalThis && globalThis.__read || function(l2, a) {
      var e2 = typeof Symbol == "function" && l2[Symbol.iterator];
      if (!e2)
        return l2;
      var d2 = e2.call(l2), y2, x2 = [], C;
      try {
        for (; (a === void 0 || a-- > 0) && !(y2 = d2.next()).done; )
          x2.push(y2.value);
      } catch (D2) {
        C = { error: D2 };
      } finally {
        try {
          y2 && !y2.done && (e2 = d2.return) && e2.call(d2);
        } finally {
          if (C)
            throw C.error;
        }
      }
      return x2;
    };
    function Qa2(l2, a, e2) {
      var d2 = Ui2(P2.useState({}), 2), y2 = d2[0], x2 = d2[1], C = Ln(function() {
        x2({});
      }, e2), D2 = C.run, L = C.cancel;
      P2.useEffect(function() {
        return D2();
      }, a), re2(L), yr(l2, [y2]);
    }
    function Ea2(l2, a, e2) {
      e2 === void 0 && (e2 = {});
      var d2 = _t(a);
      We(function() {
        var y2 = Ft(e2.target, window);
        if (y2 != null && y2.addEventListener) {
          var x2 = function(C) {
            return d2.current(C);
          };
          return y2.addEventListener(l2, x2, { capture: e2.capture, once: e2.once, passive: e2.passive }), function() {
            y2.removeEventListener(l2, x2, { capture: e2.capture });
          };
        }
      }, [l2, e2.capture, e2.once, e2.passive], e2.target);
    }
    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.
    
    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.
    
    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    var Ci2 = function(l2, a) {
      return Ci2 = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(e2, d2) {
        e2.__proto__ = d2;
      } || function(e2, d2) {
        for (var y2 in d2)
          Object.prototype.hasOwnProperty.call(d2, y2) && (e2[y2] = d2[y2]);
      }, Ci2(l2, a);
    };
    function Jn(l2, a) {
      if (typeof a != "function" && a !== null)
        throw new TypeError("Class extends value " + String(a) + " is not a constructor or null");
      Ci2(l2, a);
      function e2() {
        this.constructor = l2;
      }
      l2.prototype = a === null ? Object.create(a) : (e2.prototype = a.prototype, new e2());
    }
    var $l = function() {
      function l2() {
        this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
      }
      return l2;
    }(), $f2 = function() {
      function l2() {
        this.browser = new $l(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
      }
      return l2;
    }(), pf2 = new $f2();
    typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (pf2.wxa = true, pf2.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? pf2.worker = true : typeof navigator == "undefined" ? (pf2.node = true, pf2.svgSupported = true) : xd2(navigator.userAgent, pf2);
    function xd2(l2, a) {
      var e2 = a.browser, d2 = l2.match(/Firefox\/([\d.]+)/), y2 = l2.match(/MSIE\s([\d.]+)/) || l2.match(/Trident\/.+?rv:(([\d.]+))/), x2 = l2.match(/Edge?\/([\d.]+)/), C = /micromessenger/i.test(l2);
      d2 && (e2.firefox = true, e2.version = d2[1]), y2 && (e2.ie = true, e2.version = y2[1]), x2 && (e2.edge = true, e2.version = x2[1], e2.newEdge = +x2[1].split(".")[0] > 18), C && (e2.weChat = true), a.svgSupported = typeof SVGRect != "undefined", a.touchEventsSupported = "ontouchstart" in window && !e2.ie && !e2.edge, a.pointerEventsSupported = "onpointerdown" in window && (e2.edge || e2.ie && +e2.version >= 11), a.domSupported = typeof document != "undefined";
      var D2 = document.documentElement.style;
      a.transform3dSupported = (e2.ie && "transition" in D2 || e2.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in D2) && !("OTransition" in D2), a.transformSupported = a.transform3dSupported || e2.ie && +e2.version >= 9;
    }
    var $s = pf2, Zp = 12, lv = "sans-serif", Ru = Zp + "px " + lv, U0 = 20, M_ = 100, oC = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
    function lN(l2) {
      var a = {};
      if (typeof JSON == "undefined")
        return a;
      for (var e2 = 0; e2 < l2.length; e2++) {
        var d2 = String.fromCharCode(e2 + 32), y2 = (l2.charCodeAt(e2) - U0) / M_;
        a[d2] = y2;
      }
      return a;
    }
    var sC = lN(oC), Zx = { createCanvas: function() {
      return typeof document != "undefined" && document.createElement("canvas");
    }, measureText: function() {
      var l2, a;
      return function(e2, d2) {
        if (!l2) {
          var y2 = Zx.createCanvas();
          l2 = y2 && y2.getContext("2d");
        }
        if (l2)
          return a !== d2 && (a = l2.font = d2 || Ru), l2.measureText(e2);
        e2 = e2 || "", d2 = d2 || Ru;
        var x2 = /^([0-9]*?)px$/.exec(d2), C = +(x2 && x2[1]) || Zp, D2 = 0;
        if (d2.indexOf("mono") >= 0)
          D2 = C * e2.length;
        else
          for (var L = 0; L < e2.length; L++) {
            var F3 = sC[e2[L]];
            D2 += F3 == null ? C : F3 * C;
          }
        return { width: D2 };
      };
    }(), loadImage: function(l2, a, e2) {
      var d2 = new Image();
      return d2.onload = a, d2.onerror = e2, d2.src = l2, d2;
    } }, QT = tA(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(l2, a) {
      return l2["[object " + a + "]"] = true, l2;
    }, {}), my = tA(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(l2, a) {
      return l2["[object " + a + "Array]"] = true, l2;
    }, {}), C_ = Object.prototype.toString, JT = Array.prototype, uE = JT.forEach, $L = JT.filter, cE = JT.slice, cV = JT.map, YL = function() {
    }.constructor, fE = YL ? YL.prototype : null, hE = "__proto__", k5 = 2311;
    function uN() {
      return k5++;
    }
    function fV() {
      for (var l2 = [], a = 0; a < arguments.length; a++)
        l2[a] = arguments[a];
      typeof console != "undefined" && console.error.apply(console, l2);
    }
    function zl(l2) {
      if (l2 == null || typeof l2 != "object")
        return l2;
      var a = l2, e2 = C_.call(l2);
      if (e2 === "[object Array]") {
        if (!cN(l2)) {
          a = [];
          for (var d2 = 0, y2 = l2.length; d2 < y2; d2++)
            a[d2] = zl(l2[d2]);
        }
      } else if (my[e2]) {
        if (!cN(l2)) {
          var x2 = l2.constructor;
          if (x2.from)
            a = x2.from(l2);
          else {
            a = new x2(l2.length);
            for (var d2 = 0, y2 = l2.length; d2 < y2; d2++)
              a[d2] = l2[d2];
          }
        }
      } else if (!QT[e2] && !cN(l2) && !hV(l2)) {
        a = {};
        for (var C in l2)
          l2.hasOwnProperty(C) && C !== hE && (a[C] = zl(l2[C]));
      }
      return a;
    }
    function Mu(l2, a, e2) {
      if (!vs(a) || !vs(l2))
        return e2 ? zl(a) : l2;
      for (var d2 in a)
        if (a.hasOwnProperty(d2) && d2 !== hE) {
          var y2 = l2[d2], x2 = a[d2];
          vs(x2) && vs(y2) && !Ba2(x2) && !Ba2(y2) && !hV(x2) && !hV(y2) && !cg2(x2) && !cg2(y2) && !cN(x2) && !cN(y2) ? Mu(y2, x2, e2) : (e2 || !(d2 in l2)) && (l2[d2] = zl(a[d2]));
        }
      return l2;
    }
    function IU(l2, a) {
      for (var e2 = l2[0], d2 = 1, y2 = l2.length; d2 < y2; d2++)
        e2 = Mu(e2, l2[d2], a);
      return e2;
    }
    function la2(l2, a) {
      if (Object.assign)
        Object.assign(l2, a);
      else
        for (var e2 in a)
          a.hasOwnProperty(e2) && e2 !== hE && (l2[e2] = a[e2]);
      return l2;
    }
    function El(l2, a, e2) {
      for (var d2 = Qc2(a), y2 = 0; y2 < d2.length; y2++) {
        var x2 = d2[y2];
        (e2 ? a[x2] != null : l2[x2] == null) && (l2[x2] = a[x2]);
      }
      return l2;
    }
    function oc2(l2, a) {
      if (l2) {
        if (l2.indexOf)
          return l2.indexOf(a);
        for (var e2 = 0, d2 = l2.length; e2 < d2; e2++)
          if (l2[e2] === a)
            return e2;
      }
      return -1;
    }
    function Kgt(l2, a) {
      var e2 = l2.prototype;
      function d2() {
      }
      d2.prototype = a.prototype, l2.prototype = new d2();
      for (var y2 in e2)
        e2.hasOwnProperty(y2) && (l2.prototype[y2] = e2[y2]);
      l2.prototype.constructor = l2, l2.superClass = a;
    }
    function v0(l2, a, e2) {
      if (l2 = "prototype" in l2 ? l2.prototype : l2, a = "prototype" in a ? a.prototype : a, Object.getOwnPropertyNames)
        for (var d2 = Object.getOwnPropertyNames(a), y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2];
          x2 !== "constructor" && (e2 ? a[x2] != null : l2[x2] == null) && (l2[x2] = a[x2]);
        }
      else
        El(l2, a, e2);
    }
    function h1(l2) {
      return !l2 || typeof l2 == "string" ? false : typeof l2.length == "number";
    }
    function Ke2(l2, a, e2) {
      if (l2 && a)
        if (l2.forEach && l2.forEach === uE)
          l2.forEach(a, e2);
        else if (l2.length === +l2.length)
          for (var d2 = 0, y2 = l2.length; d2 < y2; d2++)
            a.call(e2, l2[d2], d2, l2);
        else
          for (var x2 in l2)
            l2.hasOwnProperty(x2) && a.call(e2, l2[x2], x2, l2);
    }
    function $a2(l2, a, e2) {
      if (!l2)
        return [];
      if (!a)
        return dV(l2);
      if (l2.map && l2.map === cV)
        return l2.map(a, e2);
      for (var d2 = [], y2 = 0, x2 = l2.length; y2 < x2; y2++)
        d2.push(a.call(e2, l2[y2], y2, l2));
      return d2;
    }
    function tA(l2, a, e2, d2) {
      if (l2 && a) {
        for (var y2 = 0, x2 = l2.length; y2 < x2; y2++)
          e2 = a.call(d2, e2, l2[y2], y2, l2);
        return e2;
      }
    }
    function Lp(l2, a, e2) {
      if (!l2)
        return [];
      if (!a)
        return dV(l2);
      if (l2.filter && l2.filter === $L)
        return l2.filter(a, e2);
      for (var d2 = [], y2 = 0, x2 = l2.length; y2 < x2; y2++)
        a.call(e2, l2[y2], y2, l2) && d2.push(l2[y2]);
      return d2;
    }
    function a5t(l2, a, e2) {
      if (l2 && a) {
        for (var d2 = 0, y2 = l2.length; d2 < y2; d2++)
          if (a.call(e2, l2[d2], d2, l2))
            return l2[d2];
      }
    }
    function Qc2(l2) {
      if (!l2)
        return [];
      if (Object.keys)
        return Object.keys(l2);
      var a = [];
      for (var e2 in l2)
        l2.hasOwnProperty(e2) && a.push(e2);
      return a;
    }
    function o5t(l2, a) {
      for (var e2 = [], d2 = 2; d2 < arguments.length; d2++)
        e2[d2 - 2] = arguments[d2];
      return function() {
        return l2.apply(a, e2.concat(cE.call(arguments)));
      };
    }
    var As = fE && wl(fE.bind) ? fE.call.bind(fE.bind) : o5t;
    function xu(l2) {
      for (var a = [], e2 = 1; e2 < arguments.length; e2++)
        a[e2 - 1] = arguments[e2];
      return function() {
        return l2.apply(this, a.concat(cE.call(arguments)));
      };
    }
    function Ba2(l2) {
      return Array.isArray ? Array.isArray(l2) : C_.call(l2) === "[object Array]";
    }
    function wl(l2) {
      return typeof l2 == "function";
    }
    function ps(l2) {
      return typeof l2 == "string";
    }
    function bet(l2) {
      return C_.call(l2) === "[object String]";
    }
    function Ch2(l2) {
      return typeof l2 == "number";
    }
    function vs(l2) {
      var a = typeof l2;
      return a === "function" || !!l2 && a === "object";
    }
    function cg2(l2) {
      return !!QT[C_.call(l2)];
    }
    function CS(l2) {
      return !!my[C_.call(l2)];
    }
    function hV(l2) {
      return typeof l2 == "object" && typeof l2.nodeType == "number" && typeof l2.ownerDocument == "object";
    }
    function DU(l2) {
      return l2.colorStops != null;
    }
    function s5t(l2) {
      return l2.image != null;
    }
    function l5t(l2) {
      return C_.call(l2) === "[object RegExp]";
    }
    function pV(l2) {
      return l2 !== l2;
    }
    function jy() {
      for (var l2 = [], a = 0; a < arguments.length; a++)
        l2[a] = arguments[a];
      for (var e2 = 0, d2 = l2.length; e2 < d2; e2++)
        if (l2[e2] != null)
          return l2[e2];
    }
    function $u(l2, a) {
      return l2 != null ? l2 : a;
    }
    function uv(l2, a, e2) {
      return l2 != null ? l2 : a != null ? a : e2;
    }
    function dV(l2) {
      for (var a = [], e2 = 1; e2 < arguments.length; e2++)
        a[e2 - 1] = arguments[e2];
      return cE.apply(l2, a);
    }
    function pE(l2) {
      if (typeof l2 == "number")
        return [l2, l2, l2, l2];
      var a = l2.length;
      return a === 2 ? [l2[0], l2[1], l2[0], l2[1]] : a === 3 ? [l2[0], l2[1], l2[2], l2[1]] : l2;
    }
    function vb2(l2, a) {
      if (!l2)
        throw new Error(a);
    }
    function TS(l2) {
      return l2 == null ? null : typeof l2.trim == "function" ? l2.trim() : l2.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
    }
    var AS = "__ec_primitive__";
    function gV(l2) {
      l2[AS] = true;
    }
    function cN(l2) {
      return l2[AS];
    }
    var Xgt = function() {
      function l2(a) {
        this.data = {};
        var e2 = Ba2(a);
        this.data = {};
        var d2 = this;
        a instanceof l2 ? a.each(y2) : a && Ke2(a, y2);
        function y2(x2, C) {
          e2 ? d2.set(x2, C) : d2.set(C, x2);
        }
      }
      return l2.prototype.get = function(a) {
        return this.data.hasOwnProperty(a) ? this.data[a] : null;
      }, l2.prototype.set = function(a, e2) {
        return this.data[a] = e2;
      }, l2.prototype.each = function(a, e2) {
        for (var d2 in this.data)
          this.data.hasOwnProperty(d2) && a.call(e2, this.data[d2], d2);
      }, l2.prototype.keys = function() {
        return Qc2(this.data);
      }, l2.prototype.removeKey = function(a) {
        delete this.data[a];
      }, l2;
    }();
    function fl(l2) {
      return new Xgt(l2);
    }
    function EU(l2, a) {
      for (var e2 = new l2.constructor(l2.length + a.length), d2 = 0; d2 < l2.length; d2++)
        e2[d2] = l2[d2];
      for (var y2 = l2.length, d2 = 0; d2 < a.length; d2++)
        e2[d2 + y2] = a[d2];
      return e2;
    }
    function vV(l2, a) {
      var e2;
      if (Object.create)
        e2 = Object.create(l2);
      else {
        var d2 = function() {
        };
        d2.prototype = l2, e2 = new d2();
      }
      return a && la2(e2, a), e2;
    }
    function $x(l2) {
      var a = l2.style;
      a.webkitUserSelect = "none", a.userSelect = "none", a.webkitTapHighlightColor = "rgba(0,0,0,0)", a["-webkit-touch-callout"] = "none";
    }
    function Ns(l2, a) {
      return l2.hasOwnProperty(a);
    }
    function $p() {
    }
    var kU = 180 / Math.PI;
    function P5(l2, a) {
      return l2 == null && (l2 = 0), a == null && (a = 0), [l2, a];
    }
    function y0(l2, a) {
      return l2[0] = a[0], l2[1] = a[1], l2;
    }
    function H22(l2) {
      return [l2[0], l2[1]];
    }
    function _et(l2, a, e2) {
      return l2[0] = a, l2[1] = e2, l2;
    }
    function cv(l2, a, e2) {
      return l2[0] = a[0] + e2[0], l2[1] = a[1] + e2[1], l2;
    }
    function eA(l2, a, e2, d2) {
      return l2[0] = a[0] + e2[0] * d2, l2[1] = a[1] + e2[1] * d2, l2;
    }
    function dE(l2, a, e2) {
      return l2[0] = a[0] - e2[0], l2[1] = a[1] - e2[1], l2;
    }
    function xet(l2) {
      return Math.sqrt(wet(l2));
    }
    function wet(l2) {
      return l2[0] * l2[0] + l2[1] * l2[1];
    }
    function Met(l2, a, e2) {
      return l2[0] = a[0] * e2, l2[1] = a[1] * e2, l2;
    }
    function yV(l2, a) {
      var e2 = xet(a);
      return e2 === 0 ? (l2[0] = 0, l2[1] = 0) : (l2[0] = a[0] / e2, l2[1] = a[1] / e2), l2;
    }
    function Cet(l2, a) {
      return Math.sqrt((l2[0] - a[0]) * (l2[0] - a[0]) + (l2[1] - a[1]) * (l2[1] - a[1]));
    }
    var gE = Cet;
    function PU(l2, a) {
      return (l2[0] - a[0]) * (l2[0] - a[0]) + (l2[1] - a[1]) * (l2[1] - a[1]);
    }
    var U2 = PU;
    function LU(l2, a, e2, d2) {
      return l2[0] = a[0] + d2 * (e2[0] - a[0]), l2[1] = a[1] + d2 * (e2[1] - a[1]), l2;
    }
    function Mm(l2, a, e2) {
      var d2 = a[0], y2 = a[1];
      return l2[0] = e2[0] * d2 + e2[2] * y2 + e2[4], l2[1] = e2[1] * d2 + e2[3] * y2 + e2[5], l2;
    }
    function vE(l2, a, e2) {
      return l2[0] = Math.min(a[0], e2[0]), l2[1] = Math.min(a[1], e2[1]), l2;
    }
    function nA(l2, a, e2) {
      return l2[0] = Math.max(a[0], e2[0]), l2[1] = Math.max(a[1], e2[1]), l2;
    }
    var L5 = function() {
      function l2(a, e2) {
        this.target = a, this.topTarget = e2 && e2.topTarget;
      }
      return l2;
    }(), Qgt = function() {
      function l2(a) {
        this.handler = a, a.on("mousedown", this._dragStart, this), a.on("mousemove", this._drag, this), a.on("mouseup", this._dragEnd, this);
      }
      return l2.prototype._dragStart = function(a) {
        for (var e2 = a.target; e2 && !e2.draggable; )
          e2 = e2.parent || e2.__hostTarget;
        e2 && (this._draggingTarget = e2, e2.dragging = true, this._x = a.offsetX, this._y = a.offsetY, this.handler.dispatchToElement(new L5(e2, a), "dragstart", a.event));
      }, l2.prototype._drag = function(a) {
        var e2 = this._draggingTarget;
        if (e2) {
          var d2 = a.offsetX, y2 = a.offsetY, x2 = d2 - this._x, C = y2 - this._y;
          this._x = d2, this._y = y2, e2.drift(x2, C, a), this.handler.dispatchToElement(new L5(e2, a), "drag", a.event);
          var D2 = this.handler.findHover(d2, y2, e2).target, L = this._dropTarget;
          this._dropTarget = D2, e2 !== D2 && (L && D2 !== L && this.handler.dispatchToElement(new L5(L, a), "dragleave", a.event), D2 && D2 !== L && this.handler.dispatchToElement(new L5(D2, a), "dragenter", a.event));
        }
      }, l2.prototype._dragEnd = function(a) {
        var e2 = this._draggingTarget;
        e2 && (e2.dragging = false), this.handler.dispatchToElement(new L5(e2, a), "dragend", a.event), this._dropTarget && this.handler.dispatchToElement(new L5(this._dropTarget, a), "drop", a.event), this._draggingTarget = null, this._dropTarget = null;
      }, l2;
    }(), u5t = Qgt, Tet = function() {
      function l2(a) {
        a && (this._$eventProcessor = a);
      }
      return l2.prototype.on = function(a, e2, d2, y2) {
        this._$handlers || (this._$handlers = {});
        var x2 = this._$handlers;
        if (typeof e2 == "function" && (y2 = d2, d2 = e2, e2 = null), !d2 || !a)
          return this;
        var C = this._$eventProcessor;
        e2 != null && C && C.normalizeQuery && (e2 = C.normalizeQuery(e2)), x2[a] || (x2[a] = []);
        for (var D2 = 0; D2 < x2[a].length; D2++)
          if (x2[a][D2].h === d2)
            return this;
        var L = { h: d2, query: e2, ctx: y2 || this, callAtLast: d2.zrEventfulCallAtLast }, F3 = x2[a].length - 1, j = x2[a][F3];
        return j && j.callAtLast ? x2[a].splice(F3, 0, L) : x2[a].push(L), this;
      }, l2.prototype.isSilent = function(a) {
        var e2 = this._$handlers;
        return !e2 || !e2[a] || !e2[a].length;
      }, l2.prototype.off = function(a, e2) {
        var d2 = this._$handlers;
        if (!d2)
          return this;
        if (!a)
          return this._$handlers = {}, this;
        if (e2) {
          if (d2[a]) {
            for (var y2 = [], x2 = 0, C = d2[a].length; x2 < C; x2++)
              d2[a][x2].h !== e2 && y2.push(d2[a][x2]);
            d2[a] = y2;
          }
          d2[a] && d2[a].length === 0 && delete d2[a];
        } else
          delete d2[a];
        return this;
      }, l2.prototype.trigger = function(a) {
        for (var e2 = [], d2 = 1; d2 < arguments.length; d2++)
          e2[d2 - 1] = arguments[d2];
        if (!this._$handlers)
          return this;
        var y2 = this._$handlers[a], x2 = this._$eventProcessor;
        if (y2)
          for (var C = e2.length, D2 = y2.length, L = 0; L < D2; L++) {
            var F3 = y2[L];
            if (!(x2 && x2.filter && F3.query != null && !x2.filter(a, F3.query)))
              switch (C) {
                case 0:
                  F3.h.call(F3.ctx);
                  break;
                case 1:
                  F3.h.call(F3.ctx, e2[0]);
                  break;
                case 2:
                  F3.h.call(F3.ctx, e2[0], e2[1]);
                  break;
                default:
                  F3.h.apply(F3.ctx, e2);
                  break;
              }
          }
        return x2 && x2.afterTrigger && x2.afterTrigger(a), this;
      }, l2.prototype.triggerWithContext = function(a) {
        for (var e2 = [], d2 = 1; d2 < arguments.length; d2++)
          e2[d2 - 1] = arguments[d2];
        if (!this._$handlers)
          return this;
        var y2 = this._$handlers[a], x2 = this._$eventProcessor;
        if (y2)
          for (var C = e2.length, D2 = e2[C - 1], L = y2.length, F3 = 0; F3 < L; F3++) {
            var j = y2[F3];
            if (!(x2 && x2.filter && j.query != null && !x2.filter(a, j.query)))
              switch (C) {
                case 0:
                  j.h.call(D2);
                  break;
                case 1:
                  j.h.call(D2, e2[0]);
                  break;
                case 2:
                  j.h.call(D2, e2[0], e2[1]);
                  break;
                default:
                  j.h.apply(D2, e2.slice(1, C - 1));
                  break;
              }
          }
        return x2 && x2.afterTrigger && x2.afterTrigger(a), this;
      }, l2;
    }(), Yx = Tet, c5t = Math.log(2);
    function OU(l2, a, e2, d2, y2, x2) {
      var C = d2 + "-" + y2, D2 = l2.length;
      if (x2.hasOwnProperty(C))
        return x2[C];
      if (a === 1) {
        var L = Math.round(Math.log((1 << D2) - 1 & ~y2) / c5t);
        return l2[e2][L];
      }
      for (var F3 = d2 | 1 << e2, j = e2 + 1; d2 & 1 << j; )
        j++;
      for (var U3 = 0, Y3 = 0, Q = 0; Y3 < D2; Y3++) {
        var nt = 1 << Y3;
        nt & y2 || (U3 += (Q % 2 ? -1 : 1) * l2[e2][Y3] * OU(l2, a - 1, j, F3, y2 | nt, x2), Q++);
      }
      return x2[C] = U3, U3;
    }
    function Kx(l2, a) {
      var e2 = [[l2[0], l2[1], 1, 0, 0, 0, -a[0] * l2[0], -a[0] * l2[1]], [0, 0, 0, l2[0], l2[1], 1, -a[1] * l2[0], -a[1] * l2[1]], [l2[2], l2[3], 1, 0, 0, 0, -a[2] * l2[2], -a[2] * l2[3]], [0, 0, 0, l2[2], l2[3], 1, -a[3] * l2[2], -a[3] * l2[3]], [l2[4], l2[5], 1, 0, 0, 0, -a[4] * l2[4], -a[4] * l2[5]], [0, 0, 0, l2[4], l2[5], 1, -a[5] * l2[4], -a[5] * l2[5]], [l2[6], l2[7], 1, 0, 0, 0, -a[6] * l2[6], -a[6] * l2[7]], [0, 0, 0, l2[6], l2[7], 1, -a[7] * l2[6], -a[7] * l2[7]]], d2 = {}, y2 = OU(e2, 8, 0, 0, 0, d2);
      if (y2 !== 0) {
        for (var x2 = [], C = 0; C < 8; C++)
          for (var D2 = 0; D2 < 8; D2++)
            x2[D2] == null && (x2[D2] = 0), x2[D2] += ((C + D2) % 2 ? -1 : 1) * OU(e2, 7, C === 0 ? 1 : 0, 1 << C, 1 << D2, d2) / y2 * a[C];
        return function(L, F3, j) {
          var U3 = F3 * x2[6] + j * x2[7] + 1;
          L[0] = (F3 * x2[0] + j * x2[1] + x2[2]) / U3, L[1] = (F3 * x2[3] + j * x2[4] + x2[5]) / U3;
        };
      }
    }
    var RU = "___zrEVENTSAVED", KL = [];
    function Jgt(l2, a, e2, d2, y2) {
      return NU(KL, a, d2, y2, true) && NU(l2, e2, KL[0], KL[1]);
    }
    function NU(l2, a, e2, d2, y2) {
      if (a.getBoundingClientRect && $s.domSupported && !tvt(a)) {
        var x2 = a[RU] || (a[RU] = {}), C = f5t(a, x2), D2 = h5t(C, x2, y2);
        if (D2)
          return D2(l2, e2, d2), true;
      }
      return false;
    }
    function f5t(l2, a) {
      var e2 = a.markers;
      if (e2)
        return e2;
      e2 = a.markers = [];
      for (var d2 = ["left", "right"], y2 = ["top", "bottom"], x2 = 0; x2 < 4; x2++) {
        var C = document.createElement("div"), D2 = C.style, L = x2 % 2, F3 = (x2 >> 1) % 2;
        D2.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", d2[L] + ":0", y2[F3] + ":0", d2[1 - L] + ":auto", y2[1 - F3] + ":auto", ""].join("!important;"), l2.appendChild(C), e2.push(C);
      }
      return e2;
    }
    function h5t(l2, a, e2) {
      for (var d2 = e2 ? "invTrans" : "trans", y2 = a[d2], x2 = a.srcCoords, C = [], D2 = [], L = true, F3 = 0; F3 < 4; F3++) {
        var j = l2[F3].getBoundingClientRect(), U3 = 2 * F3, Y3 = j.left, Q = j.top;
        C.push(Y3, Q), L = L && x2 && Y3 === x2[U3] && Q === x2[U3 + 1], D2.push(l2[F3].offsetLeft, l2[F3].offsetTop);
      }
      return L && y2 ? y2 : (a.srcCoords = C, a[d2] = e2 ? Kx(D2, C) : Kx(C, D2));
    }
    function tvt(l2) {
      return l2.nodeName.toUpperCase() === "CANVAS";
    }
    var p5t = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, Aet = [], fN = $s.browser.firefox && +$s.browser.version.split(".")[0] < 39;
    function Iet(l2, a, e2, d2) {
      return e2 = e2 || {}, d2 ? evt(l2, a, e2) : fN && a.layerX != null && a.layerX !== a.offsetX ? (e2.zrX = a.layerX, e2.zrY = a.layerY) : a.offsetX != null ? (e2.zrX = a.offsetX, e2.zrY = a.offsetY) : evt(l2, a, e2), e2;
    }
    function evt(l2, a, e2) {
      if ($s.domSupported && l2.getBoundingClientRect) {
        var d2 = a.clientX, y2 = a.clientY;
        if (tvt(l2)) {
          var x2 = l2.getBoundingClientRect();
          e2.zrX = d2 - x2.left, e2.zrY = y2 - x2.top;
          return;
        } else if (NU(Aet, l2, d2, y2)) {
          e2.zrX = Aet[0], e2.zrY = Aet[1];
          return;
        }
      }
      e2.zrX = e2.zrY = 0;
    }
    function mV(l2) {
      return l2 || window.event;
    }
    function IS(l2, a, e2) {
      if (a = mV(a), a.zrX != null)
        return a;
      var d2 = a.type, y2 = d2 && d2.indexOf("touch") >= 0;
      if (y2) {
        var x2 = d2 !== "touchend" ? a.targetTouches[0] : a.changedTouches[0];
        x2 && Iet(l2, x2, a, e2);
      } else {
        Iet(l2, a, a, e2);
        var C = O5(a);
        a.zrDelta = C ? C / 120 : -(a.detail || 0) / 3;
      }
      var D2 = a.button;
      return a.which == null && D2 !== void 0 && p5t.test(a.type) && (a.which = D2 & 1 ? 1 : D2 & 2 ? 3 : D2 & 4 ? 2 : 0), a;
    }
    function O5(l2) {
      var a = l2.wheelDelta;
      if (a)
        return a;
      var e2 = l2.deltaX, d2 = l2.deltaY;
      if (e2 == null || d2 == null)
        return a;
      var y2 = Math.abs(d2 !== 0 ? d2 : e2), x2 = d2 > 0 ? -1 : d2 < 0 ? 1 : e2 > 0 ? -1 : 1;
      return 3 * y2 * x2;
    }
    function hN(l2, a, e2, d2) {
      l2.addEventListener(a, e2, d2);
    }
    function d5t(l2, a, e2, d2) {
      l2.removeEventListener(a, e2, d2);
    }
    var yE = function(l2) {
      l2.preventDefault(), l2.stopPropagation(), l2.cancelBubble = true;
    };
    function nvt(l2) {
      return l2.which === 2 || l2.which === 3;
    }
    var pN = function() {
      function l2() {
        this._track = [];
      }
      return l2.prototype.recognize = function(a, e2, d2) {
        return this._doTrack(a, e2, d2), this._recognize(a);
      }, l2.prototype.clear = function() {
        return this._track.length = 0, this;
      }, l2.prototype._doTrack = function(a, e2, d2) {
        var y2 = a.touches;
        if (y2) {
          for (var x2 = { points: [], touches: [], target: e2, event: a }, C = 0, D2 = y2.length; C < D2; C++) {
            var L = y2[C], F3 = Iet(d2, L, {});
            x2.points.push([F3.zrX, F3.zrY]), x2.touches.push(L);
          }
          this._track.push(x2);
        }
      }, l2.prototype._recognize = function(a) {
        for (var e2 in Det)
          if (Det.hasOwnProperty(e2)) {
            var d2 = Det[e2](this._track, a);
            if (d2)
              return d2;
          }
      }, l2;
    }();
    function q2(l2) {
      var a = l2[1][0] - l2[0][0], e2 = l2[1][1] - l2[0][1];
      return Math.sqrt(a * a + e2 * e2);
    }
    function rvt(l2) {
      return [(l2[0][0] + l2[1][0]) / 2, (l2[0][1] + l2[1][1]) / 2];
    }
    var Det = { pinch: function(l2, a) {
      var e2 = l2.length;
      if (e2) {
        var d2 = (l2[e2 - 1] || {}).points, y2 = (l2[e2 - 2] || {}).points || d2;
        if (y2 && y2.length > 1 && d2 && d2.length > 1) {
          var x2 = q2(d2) / q2(y2);
          !isFinite(x2) && (x2 = 1), a.pinchScale = x2;
          var C = rvt(d2);
          return a.pinchX = C[0], a.pinchY = C[1], { type: "pinch", target: l2[0].target, event: a };
        }
      }
    } }, ivt = "silent";
    function g5t(l2, a, e2) {
      return { type: l2, event: e2, target: a.target, topTarget: a.topTarget, cancelBubble: false, offsetX: e2.zrX, offsetY: e2.zrY, gestureEvent: e2.gestureEvent, pinchX: e2.pinchX, pinchY: e2.pinchY, pinchScale: e2.pinchScale, wheelDelta: e2.zrDelta, zrByTouch: e2.zrByTouch, which: e2.which, stop: v5t };
    }
    function v5t() {
      yE(this.event);
    }
    var y5t = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.handler = null, e2;
      }
      return a.prototype.dispose = function() {
      }, a.prototype.setCursor = function() {
      }, a;
    }(Yx), rA = function() {
      function l2(a, e2) {
        this.x = a, this.y = e2;
      }
      return l2;
    }(), hi2 = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], io = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2) {
        var C = l2.call(this) || this;
        return C._hovered = new rA(0, 0), C.storage = e2, C.painter = d2, C.painterRoot = x2, y2 = y2 || new y5t(), C.proxy = null, C.setHandlerProxy(y2), C._draggingMgr = new u5t(C), C;
      }
      return a.prototype.setHandlerProxy = function(e2) {
        this.proxy && this.proxy.dispose(), e2 && (Ke2(hi2, function(d2) {
          e2.on && e2.on(d2, this[d2], this);
        }, this), e2.handler = this), this.proxy = e2;
      }, a.prototype.mousemove = function(e2) {
        var d2 = e2.zrX, y2 = e2.zrY, x2 = Nl(this, d2, y2), C = this._hovered, D2 = C.target;
        D2 && !D2.__zr && (C = this.findHover(C.x, C.y), D2 = C.target);
        var L = this._hovered = x2 ? new rA(d2, y2) : this.findHover(d2, y2), F3 = L.target, j = this.proxy;
        j.setCursor && j.setCursor(F3 ? F3.cursor : "default"), D2 && F3 !== D2 && this.dispatchToElement(C, "mouseout", e2), this.dispatchToElement(L, "mousemove", e2), F3 && F3 !== D2 && this.dispatchToElement(L, "mouseover", e2);
      }, a.prototype.mouseout = function(e2) {
        var d2 = e2.zrEventControl;
        d2 !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", e2), d2 !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: e2 });
      }, a.prototype.resize = function() {
        this._hovered = new rA(0, 0);
      }, a.prototype.dispatch = function(e2, d2) {
        var y2 = this[e2];
        y2 && y2.call(this, d2);
      }, a.prototype.dispose = function() {
        this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
      }, a.prototype.setCursorStyle = function(e2) {
        var d2 = this.proxy;
        d2.setCursor && d2.setCursor(e2);
      }, a.prototype.dispatchToElement = function(e2, d2, y2) {
        e2 = e2 || {};
        var x2 = e2.target;
        if (!(x2 && x2.silent)) {
          for (var C = "on" + d2, D2 = g5t(d2, e2, y2); x2 && (x2[C] && (D2.cancelBubble = !!x2[C].call(x2, D2)), x2.trigger(d2, D2), x2 = x2.__hostTarget ? x2.__hostTarget : x2.parent, !D2.cancelBubble); )
            ;
          D2.cancelBubble || (this.trigger(d2, D2), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(L) {
            typeof L[C] == "function" && L[C].call(L, D2), L.trigger && L.trigger(d2, D2);
          }));
        }
      }, a.prototype.findHover = function(e2, d2, y2) {
        for (var x2 = this.storage.getDisplayList(), C = new rA(e2, d2), D2 = x2.length - 1; D2 >= 0; D2--) {
          var L = void 0;
          if (x2[D2] !== y2 && !x2[D2].ignore && (L = Sa2(x2[D2], e2, d2)) && (!C.topTarget && (C.topTarget = x2[D2]), L !== ivt)) {
            C.target = x2[D2];
            break;
          }
        }
        return C;
      }, a.prototype.processGesture = function(e2, d2) {
        this._gestureMgr || (this._gestureMgr = new pN());
        var y2 = this._gestureMgr;
        d2 === "start" && y2.clear();
        var x2 = y2.recognize(e2, this.findHover(e2.zrX, e2.zrY, null).target, this.proxy.dom);
        if (d2 === "end" && y2.clear(), x2) {
          var C = x2.type;
          e2.gestureEvent = C;
          var D2 = new rA();
          D2.target = x2.target, this.dispatchToElement(D2, C, x2.event);
        }
      }, a;
    }(Yx);
    Ke2(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(l2) {
      io.prototype[l2] = function(a) {
        var e2 = a.zrX, d2 = a.zrY, y2 = Nl(this, e2, d2), x2, C;
        if ((l2 !== "mouseup" || !y2) && (x2 = this.findHover(e2, d2), C = x2.target), l2 === "mousedown")
          this._downEl = C, this._downPoint = [a.zrX, a.zrY], this._upEl = C;
        else if (l2 === "mouseup")
          this._upEl = C;
        else if (l2 === "click") {
          if (this._downEl !== this._upEl || !this._downPoint || gE(this._downPoint, [a.zrX, a.zrY]) > 4)
            return;
          this._downPoint = null;
        }
        this.dispatchToElement(x2, l2, a);
      };
    });
    function Sa2(l2, a, e2) {
      if (l2[l2.rectHover ? "rectContain" : "contain"](a, e2)) {
        for (var d2 = l2, y2 = void 0, x2 = false; d2; ) {
          if (d2.ignoreClip && (x2 = true), !x2) {
            var C = d2.getClipPath();
            if (C && !C.contain(a, e2))
              return false;
            d2.silent && (y2 = true);
          }
          var D2 = d2.__hostTarget;
          d2 = D2 || d2.parent;
        }
        return y2 ? ivt : true;
      }
      return false;
    }
    function Nl(l2, a, e2) {
      var d2 = l2.painter;
      return a < 0 || a > d2.getWidth() || e2 < 0 || e2 > d2.getHeight();
    }
    var Jc2 = io, Yp = 32, e0 = 7;
    function fg2(l2) {
      for (var a = 0; l2 >= Yp; )
        a |= l2 & 1, l2 >>= 1;
      return l2 + a;
    }
    function FU(l2, a, e2, d2) {
      var y2 = a + 1;
      if (y2 === e2)
        return 1;
      if (d2(l2[y2++], l2[a]) < 0) {
        for (; y2 < e2 && d2(l2[y2], l2[y2 - 1]) < 0; )
          y2++;
        m5t(l2, a, y2);
      } else
        for (; y2 < e2 && d2(l2[y2], l2[y2 - 1]) >= 0; )
          y2++;
      return y2 - a;
    }
    function m5t(l2, a, e2) {
      for (e2--; a < e2; ) {
        var d2 = l2[a];
        l2[a++] = l2[e2], l2[e2--] = d2;
      }
    }
    function DS(l2, a, e2, d2, y2) {
      for (d2 === a && d2++; d2 < e2; d2++) {
        for (var x2 = l2[d2], C = a, D2 = d2, L; C < D2; )
          L = C + D2 >>> 1, y2(x2, l2[L]) < 0 ? D2 = L : C = L + 1;
        var F3 = d2 - C;
        switch (F3) {
          case 3:
            l2[C + 3] = l2[C + 2];
          case 2:
            l2[C + 2] = l2[C + 1];
          case 1:
            l2[C + 1] = l2[C];
            break;
          default:
            for (; F3 > 0; )
              l2[C + F3] = l2[C + F3 - 1], F3--;
        }
        l2[C] = x2;
      }
    }
    function dN(l2, a, e2, d2, y2, x2) {
      var C = 0, D2 = 0, L = 1;
      if (x2(l2, a[e2 + y2]) > 0) {
        for (D2 = d2 - y2; L < D2 && x2(l2, a[e2 + y2 + L]) > 0; )
          C = L, L = (L << 1) + 1, L <= 0 && (L = D2);
        L > D2 && (L = D2), C += y2, L += y2;
      } else {
        for (D2 = y2 + 1; L < D2 && x2(l2, a[e2 + y2 - L]) <= 0; )
          C = L, L = (L << 1) + 1, L <= 0 && (L = D2);
        L > D2 && (L = D2);
        var F3 = C;
        C = y2 - L, L = y2 - F3;
      }
      for (C++; C < L; ) {
        var j = C + (L - C >>> 1);
        x2(l2, a[e2 + j]) > 0 ? C = j + 1 : L = j;
      }
      return L;
    }
    function Eet(l2, a, e2, d2, y2, x2) {
      var C = 0, D2 = 0, L = 1;
      if (x2(l2, a[e2 + y2]) < 0) {
        for (D2 = y2 + 1; L < D2 && x2(l2, a[e2 + y2 - L]) < 0; )
          C = L, L = (L << 1) + 1, L <= 0 && (L = D2);
        L > D2 && (L = D2);
        var F3 = C;
        C = y2 - L, L = y2 - F3;
      } else {
        for (D2 = d2 - y2; L < D2 && x2(l2, a[e2 + y2 + L]) >= 0; )
          C = L, L = (L << 1) + 1, L <= 0 && (L = D2);
        L > D2 && (L = D2), C += y2, L += y2;
      }
      for (C++; C < L; ) {
        var j = C + (L - C >>> 1);
        x2(l2, a[e2 + j]) < 0 ? L = j : C = j + 1;
      }
      return L;
    }
    function gN(l2, a) {
      var e2 = e0, d2, y2, x2 = 0, C = [];
      d2 = [], y2 = [];
      function D2(Q, nt) {
        d2[x2] = Q, y2[x2] = nt, x2 += 1;
      }
      function L() {
        for (; x2 > 1; ) {
          var Q = x2 - 2;
          if (Q >= 1 && y2[Q - 1] <= y2[Q] + y2[Q + 1] || Q >= 2 && y2[Q - 2] <= y2[Q] + y2[Q - 1])
            y2[Q - 1] < y2[Q + 1] && Q--;
          else if (y2[Q] > y2[Q + 1])
            break;
          j(Q);
        }
      }
      function F3() {
        for (; x2 > 1; ) {
          var Q = x2 - 2;
          Q > 0 && y2[Q - 1] < y2[Q + 1] && Q--, j(Q);
        }
      }
      function j(Q) {
        var nt = d2[Q], dt = y2[Q], vt = d2[Q + 1], Ct = y2[Q + 1];
        y2[Q] = dt + Ct, Q === x2 - 3 && (d2[Q + 1] = d2[Q + 2], y2[Q + 1] = y2[Q + 2]), x2--;
        var Pt = Eet(l2[vt], l2, nt, dt, 0, a);
        nt += Pt, dt -= Pt, dt !== 0 && (Ct = dN(l2[nt + dt - 1], l2, vt, Ct, Ct - 1, a), Ct !== 0 && (dt <= Ct ? U3(nt, dt, vt, Ct) : Y3(nt, dt, vt, Ct)));
      }
      function U3(Q, nt, dt, vt) {
        var Ct = 0;
        for (Ct = 0; Ct < nt; Ct++)
          C[Ct] = l2[Q + Ct];
        var Pt = 0, jt = dt, Rt = Q;
        if (l2[Rt++] = l2[jt++], --vt === 0) {
          for (Ct = 0; Ct < nt; Ct++)
            l2[Rt + Ct] = C[Pt + Ct];
          return;
        }
        if (nt === 1) {
          for (Ct = 0; Ct < vt; Ct++)
            l2[Rt + Ct] = l2[jt + Ct];
          l2[Rt + vt] = C[Pt];
          return;
        }
        for (var le2 = e2, ne2, he2, _e; ; ) {
          ne2 = 0, he2 = 0, _e = false;
          do
            if (a(l2[jt], C[Pt]) < 0) {
              if (l2[Rt++] = l2[jt++], he2++, ne2 = 0, --vt === 0) {
                _e = true;
                break;
              }
            } else if (l2[Rt++] = C[Pt++], ne2++, he2 = 0, --nt === 1) {
              _e = true;
              break;
            }
          while ((ne2 | he2) < le2);
          if (_e)
            break;
          do {
            if (ne2 = Eet(l2[jt], C, Pt, nt, 0, a), ne2 !== 0) {
              for (Ct = 0; Ct < ne2; Ct++)
                l2[Rt + Ct] = C[Pt + Ct];
              if (Rt += ne2, Pt += ne2, nt -= ne2, nt <= 1) {
                _e = true;
                break;
              }
            }
            if (l2[Rt++] = l2[jt++], --vt === 0) {
              _e = true;
              break;
            }
            if (he2 = dN(C[Pt], l2, jt, vt, 0, a), he2 !== 0) {
              for (Ct = 0; Ct < he2; Ct++)
                l2[Rt + Ct] = l2[jt + Ct];
              if (Rt += he2, jt += he2, vt -= he2, vt === 0) {
                _e = true;
                break;
              }
            }
            if (l2[Rt++] = C[Pt++], --nt === 1) {
              _e = true;
              break;
            }
            le2--;
          } while (ne2 >= e0 || he2 >= e0);
          if (_e)
            break;
          le2 < 0 && (le2 = 0), le2 += 2;
        }
        if (e2 = le2, e2 < 1 && (e2 = 1), nt === 1) {
          for (Ct = 0; Ct < vt; Ct++)
            l2[Rt + Ct] = l2[jt + Ct];
          l2[Rt + vt] = C[Pt];
        } else {
          if (nt === 0)
            throw new Error();
          for (Ct = 0; Ct < nt; Ct++)
            l2[Rt + Ct] = C[Pt + Ct];
        }
      }
      function Y3(Q, nt, dt, vt) {
        var Ct = 0;
        for (Ct = 0; Ct < vt; Ct++)
          C[Ct] = l2[dt + Ct];
        var Pt = Q + nt - 1, jt = vt - 1, Rt = dt + vt - 1, le2 = 0, ne2 = 0;
        if (l2[Rt--] = l2[Pt--], --nt === 0) {
          for (le2 = Rt - (vt - 1), Ct = 0; Ct < vt; Ct++)
            l2[le2 + Ct] = C[Ct];
          return;
        }
        if (vt === 1) {
          for (Rt -= nt, Pt -= nt, ne2 = Rt + 1, le2 = Pt + 1, Ct = nt - 1; Ct >= 0; Ct--)
            l2[ne2 + Ct] = l2[le2 + Ct];
          l2[Rt] = C[jt];
          return;
        }
        for (var he2 = e2; ; ) {
          var _e = 0, Me2 = 0, Pe2 = false;
          do
            if (a(C[jt], l2[Pt]) < 0) {
              if (l2[Rt--] = l2[Pt--], _e++, Me2 = 0, --nt === 0) {
                Pe2 = true;
                break;
              }
            } else if (l2[Rt--] = C[jt--], Me2++, _e = 0, --vt === 1) {
              Pe2 = true;
              break;
            }
          while ((_e | Me2) < he2);
          if (Pe2)
            break;
          do {
            if (_e = nt - Eet(C[jt], l2, Q, nt, nt - 1, a), _e !== 0) {
              for (Rt -= _e, Pt -= _e, nt -= _e, ne2 = Rt + 1, le2 = Pt + 1, Ct = _e - 1; Ct >= 0; Ct--)
                l2[ne2 + Ct] = l2[le2 + Ct];
              if (nt === 0) {
                Pe2 = true;
                break;
              }
            }
            if (l2[Rt--] = C[jt--], --vt === 1) {
              Pe2 = true;
              break;
            }
            if (Me2 = vt - dN(l2[Pt], C, 0, vt, vt - 1, a), Me2 !== 0) {
              for (Rt -= Me2, jt -= Me2, vt -= Me2, ne2 = Rt + 1, le2 = jt + 1, Ct = 0; Ct < Me2; Ct++)
                l2[ne2 + Ct] = C[le2 + Ct];
              if (vt <= 1) {
                Pe2 = true;
                break;
              }
            }
            if (l2[Rt--] = l2[Pt--], --nt === 0) {
              Pe2 = true;
              break;
            }
            he2--;
          } while (_e >= e0 || Me2 >= e0);
          if (Pe2)
            break;
          he2 < 0 && (he2 = 0), he2 += 2;
        }
        if (e2 = he2, e2 < 1 && (e2 = 1), vt === 1) {
          for (Rt -= nt, Pt -= nt, ne2 = Rt + 1, le2 = Pt + 1, Ct = nt - 1; Ct >= 0; Ct--)
            l2[ne2 + Ct] = l2[le2 + Ct];
          l2[Rt] = C[jt];
        } else {
          if (vt === 0)
            throw new Error();
          for (le2 = Rt - (vt - 1), Ct = 0; Ct < vt; Ct++)
            l2[le2 + Ct] = C[Ct];
        }
      }
      return { mergeRuns: L, forceMergeRuns: F3, pushRun: D2 };
    }
    function XL(l2, a, e2, d2) {
      e2 || (e2 = 0), d2 || (d2 = l2.length);
      var y2 = d2 - e2;
      if (!(y2 < 2)) {
        var x2 = 0;
        if (y2 < Yp) {
          x2 = FU(l2, e2, d2, a), DS(l2, e2, d2, e2 + x2, a);
          return;
        }
        var C = gN(l2, a), D2 = fg2(y2);
        do {
          if (x2 = FU(l2, e2, d2, a), x2 < D2) {
            var L = y2;
            L > D2 && (L = D2), DS(l2, e2, e2 + L, e2 + x2, a), x2 = L;
          }
          C.pushRun(e2, x2), C.mergeRuns(), y2 -= x2, e2 += x2;
        } while (y2 !== 0);
        C.forceMergeRuns();
      }
    }
    var yb2 = 1, Op = 2, vN = 4, ket = false;
    function yN() {
      ket || (ket = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
    }
    function avt(l2, a) {
      return l2.zlevel === a.zlevel ? l2.z === a.z ? l2.z2 - a.z2 : l2.z - a.z : l2.zlevel - a.zlevel;
    }
    var b5t = function() {
      function l2() {
        this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = avt;
      }
      return l2.prototype.traverse = function(a, e2) {
        for (var d2 = 0; d2 < this._roots.length; d2++)
          this._roots[d2].traverse(a, e2);
      }, l2.prototype.getDisplayList = function(a, e2) {
        e2 = e2 || false;
        var d2 = this._displayList;
        return (a || !d2.length) && this.updateDisplayList(e2), d2;
      }, l2.prototype.updateDisplayList = function(a) {
        this._displayListLen = 0;
        for (var e2 = this._roots, d2 = this._displayList, y2 = 0, x2 = e2.length; y2 < x2; y2++)
          this._updateAndAddDisplayable(e2[y2], null, a);
        d2.length = this._displayListLen, XL(d2, avt);
      }, l2.prototype._updateAndAddDisplayable = function(a, e2, d2) {
        if (!(a.ignore && !d2)) {
          a.beforeUpdate(), a.update(), a.afterUpdate();
          var y2 = a.getClipPath();
          if (a.ignoreClip)
            e2 = null;
          else if (y2) {
            e2 ? e2 = e2.slice() : e2 = [];
            for (var x2 = y2, C = a; x2; )
              x2.parent = C, x2.updateTransform(), e2.push(x2), C = x2, x2 = x2.getClipPath();
          }
          if (a.childrenRef) {
            for (var D2 = a.childrenRef(), L = 0; L < D2.length; L++) {
              var F3 = D2[L];
              a.__dirty && (F3.__dirty |= yb2), this._updateAndAddDisplayable(F3, e2, d2);
            }
            a.__dirty = 0;
          } else {
            var j = a;
            e2 && e2.length ? j.__clipPaths = e2 : j.__clipPaths && j.__clipPaths.length > 0 && (j.__clipPaths = []), isNaN(j.z) && (yN(), j.z = 0), isNaN(j.z2) && (yN(), j.z2 = 0), isNaN(j.zlevel) && (yN(), j.zlevel = 0), this._displayList[this._displayListLen++] = j;
          }
          var U3 = a.getDecalElement && a.getDecalElement();
          U3 && this._updateAndAddDisplayable(U3, e2, d2);
          var Y3 = a.getTextGuideLine();
          Y3 && this._updateAndAddDisplayable(Y3, e2, d2);
          var Q = a.getTextContent();
          Q && this._updateAndAddDisplayable(Q, e2, d2);
        }
      }, l2.prototype.addRoot = function(a) {
        a.__zr && a.__zr.storage === this || this._roots.push(a);
      }, l2.prototype.delRoot = function(a) {
        if (a instanceof Array) {
          for (var e2 = 0, d2 = a.length; e2 < d2; e2++)
            this.delRoot(a[e2]);
          return;
        }
        var y2 = oc2(this._roots, a);
        y2 >= 0 && this._roots.splice(y2, 1);
      }, l2.prototype.delAllRoots = function() {
        this._roots = [], this._displayList = [], this._displayListLen = 0;
      }, l2.prototype.getRoots = function() {
        return this._roots;
      }, l2.prototype.dispose = function() {
        this._displayList = null, this._roots = null;
      }, l2;
    }(), _5t = b5t, bV;
    bV = $s.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(l2) {
      return setTimeout(l2, 16);
    };
    var iA = bV, QL = { linear: function(l2) {
      return l2;
    }, quadraticIn: function(l2) {
      return l2 * l2;
    }, quadraticOut: function(l2) {
      return l2 * (2 - l2);
    }, quadraticInOut: function(l2) {
      return (l2 *= 2) < 1 ? 0.5 * l2 * l2 : -0.5 * (--l2 * (l2 - 2) - 1);
    }, cubicIn: function(l2) {
      return l2 * l2 * l2;
    }, cubicOut: function(l2) {
      return --l2 * l2 * l2 + 1;
    }, cubicInOut: function(l2) {
      return (l2 *= 2) < 1 ? 0.5 * l2 * l2 * l2 : 0.5 * ((l2 -= 2) * l2 * l2 + 2);
    }, quarticIn: function(l2) {
      return l2 * l2 * l2 * l2;
    }, quarticOut: function(l2) {
      return 1 - --l2 * l2 * l2 * l2;
    }, quarticInOut: function(l2) {
      return (l2 *= 2) < 1 ? 0.5 * l2 * l2 * l2 * l2 : -0.5 * ((l2 -= 2) * l2 * l2 * l2 - 2);
    }, quinticIn: function(l2) {
      return l2 * l2 * l2 * l2 * l2;
    }, quinticOut: function(l2) {
      return --l2 * l2 * l2 * l2 * l2 + 1;
    }, quinticInOut: function(l2) {
      return (l2 *= 2) < 1 ? 0.5 * l2 * l2 * l2 * l2 * l2 : 0.5 * ((l2 -= 2) * l2 * l2 * l2 * l2 + 2);
    }, sinusoidalIn: function(l2) {
      return 1 - Math.cos(l2 * Math.PI / 2);
    }, sinusoidalOut: function(l2) {
      return Math.sin(l2 * Math.PI / 2);
    }, sinusoidalInOut: function(l2) {
      return 0.5 * (1 - Math.cos(Math.PI * l2));
    }, exponentialIn: function(l2) {
      return l2 === 0 ? 0 : Math.pow(1024, l2 - 1);
    }, exponentialOut: function(l2) {
      return l2 === 1 ? 1 : 1 - Math.pow(2, -10 * l2);
    }, exponentialInOut: function(l2) {
      return l2 === 0 ? 0 : l2 === 1 ? 1 : (l2 *= 2) < 1 ? 0.5 * Math.pow(1024, l2 - 1) : 0.5 * (-Math.pow(2, -10 * (l2 - 1)) + 2);
    }, circularIn: function(l2) {
      return 1 - Math.sqrt(1 - l2 * l2);
    }, circularOut: function(l2) {
      return Math.sqrt(1 - --l2 * l2);
    }, circularInOut: function(l2) {
      return (l2 *= 2) < 1 ? -0.5 * (Math.sqrt(1 - l2 * l2) - 1) : 0.5 * (Math.sqrt(1 - (l2 -= 2) * l2) + 1);
    }, elasticIn: function(l2) {
      var a, e2 = 0.1, d2 = 0.4;
      return l2 === 0 ? 0 : l2 === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, a = d2 / 4) : a = d2 * Math.asin(1 / e2) / (2 * Math.PI), -(e2 * Math.pow(2, 10 * (l2 -= 1)) * Math.sin((l2 - a) * (2 * Math.PI) / d2)));
    }, elasticOut: function(l2) {
      var a, e2 = 0.1, d2 = 0.4;
      return l2 === 0 ? 0 : l2 === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, a = d2 / 4) : a = d2 * Math.asin(1 / e2) / (2 * Math.PI), e2 * Math.pow(2, -10 * l2) * Math.sin((l2 - a) * (2 * Math.PI) / d2) + 1);
    }, elasticInOut: function(l2) {
      var a, e2 = 0.1, d2 = 0.4;
      return l2 === 0 ? 0 : l2 === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, a = d2 / 4) : a = d2 * Math.asin(1 / e2) / (2 * Math.PI), (l2 *= 2) < 1 ? -0.5 * (e2 * Math.pow(2, 10 * (l2 -= 1)) * Math.sin((l2 - a) * (2 * Math.PI) / d2)) : e2 * Math.pow(2, -10 * (l2 -= 1)) * Math.sin((l2 - a) * (2 * Math.PI) / d2) * 0.5 + 1);
    }, backIn: function(l2) {
      var a = 1.70158;
      return l2 * l2 * ((a + 1) * l2 - a);
    }, backOut: function(l2) {
      var a = 1.70158;
      return --l2 * l2 * ((a + 1) * l2 + a) + 1;
    }, backInOut: function(l2) {
      var a = 2.5949095;
      return (l2 *= 2) < 1 ? 0.5 * (l2 * l2 * ((a + 1) * l2 - a)) : 0.5 * ((l2 -= 2) * l2 * ((a + 1) * l2 + a) + 2);
    }, bounceIn: function(l2) {
      return 1 - QL.bounceOut(1 - l2);
    }, bounceOut: function(l2) {
      return l2 < 1 / 2.75 ? 7.5625 * l2 * l2 : l2 < 2 / 2.75 ? 7.5625 * (l2 -= 1.5 / 2.75) * l2 + 0.75 : l2 < 2.5 / 2.75 ? 7.5625 * (l2 -= 2.25 / 2.75) * l2 + 0.9375 : 7.5625 * (l2 -= 2.625 / 2.75) * l2 + 0.984375;
    }, bounceInOut: function(l2) {
      return l2 < 0.5 ? QL.bounceIn(l2 * 2) * 0.5 : QL.bounceOut(l2 * 2 - 1) * 0.5 + 0.5;
    } }, Pet = QL, JL = Math.pow, mE = Math.sqrt, _V = 1e-8, xV = 1e-4, Let = mE(3), R5 = 1 / 3, mb2 = P5(), T_ = P5(), mN = P5();
    function N5(l2) {
      return l2 > -_V && l2 < _V;
    }
    function ovt(l2) {
      return l2 > _V || l2 < -_V;
    }
    function m0(l2, a, e2, d2, y2) {
      var x2 = 1 - y2;
      return x2 * x2 * (x2 * l2 + 3 * y2 * a) + y2 * y2 * (y2 * d2 + 3 * x2 * e2);
    }
    function wV(l2, a, e2, d2, y2) {
      var x2 = 1 - y2;
      return 3 * (((a - l2) * x2 + 2 * (e2 - a) * y2) * x2 + (d2 - e2) * y2 * y2);
    }
    function bN(l2, a, e2, d2, y2, x2) {
      var C = d2 + 3 * (a - e2) - l2, D2 = 3 * (e2 - a * 2 + l2), L = 3 * (a - l2), F3 = l2 - y2, j = D2 * D2 - 3 * C * L, U3 = D2 * L - 9 * C * F3, Y3 = L * L - 3 * D2 * F3, Q = 0;
      if (N5(j) && N5(U3))
        if (N5(D2))
          x2[0] = 0;
        else {
          var nt = -L / D2;
          nt >= 0 && nt <= 1 && (x2[Q++] = nt);
        }
      else {
        var dt = U3 * U3 - 4 * j * Y3;
        if (N5(dt)) {
          var vt = U3 / j, nt = -D2 / C + vt, Ct = -vt / 2;
          nt >= 0 && nt <= 1 && (x2[Q++] = nt), Ct >= 0 && Ct <= 1 && (x2[Q++] = Ct);
        } else if (dt > 0) {
          var Pt = mE(dt), jt = j * D2 + 1.5 * C * (-U3 + Pt), Rt = j * D2 + 1.5 * C * (-U3 - Pt);
          jt < 0 ? jt = -JL(-jt, R5) : jt = JL(jt, R5), Rt < 0 ? Rt = -JL(-Rt, R5) : Rt = JL(Rt, R5);
          var nt = (-D2 - (jt + Rt)) / (3 * C);
          nt >= 0 && nt <= 1 && (x2[Q++] = nt);
        } else {
          var le2 = (2 * j * D2 - 3 * C * U3) / (2 * mE(j * j * j)), ne2 = Math.acos(le2) / 3, he2 = mE(j), _e = Math.cos(ne2), nt = (-D2 - 2 * he2 * _e) / (3 * C), Ct = (-D2 + he2 * (_e + Let * Math.sin(ne2))) / (3 * C), Me2 = (-D2 + he2 * (_e - Let * Math.sin(ne2))) / (3 * C);
          nt >= 0 && nt <= 1 && (x2[Q++] = nt), Ct >= 0 && Ct <= 1 && (x2[Q++] = Ct), Me2 >= 0 && Me2 <= 1 && (x2[Q++] = Me2);
        }
      }
      return Q;
    }
    function svt(l2, a, e2, d2, y2) {
      var x2 = 6 * e2 - 12 * a + 6 * l2, C = 9 * a + 3 * d2 - 3 * l2 - 9 * e2, D2 = 3 * a - 3 * l2, L = 0;
      if (N5(C)) {
        if (ovt(x2)) {
          var F3 = -D2 / x2;
          F3 >= 0 && F3 <= 1 && (y2[L++] = F3);
        }
      } else {
        var j = x2 * x2 - 4 * C * D2;
        if (N5(j))
          y2[0] = -x2 / (2 * C);
        else if (j > 0) {
          var U3 = mE(j), F3 = (-x2 + U3) / (2 * C), Y3 = (-x2 - U3) / (2 * C);
          F3 >= 0 && F3 <= 1 && (y2[L++] = F3), Y3 >= 0 && Y3 <= 1 && (y2[L++] = Y3);
        }
      }
      return L;
    }
    function bE(l2, a, e2, d2, y2, x2) {
      var C = (a - l2) * y2 + l2, D2 = (e2 - a) * y2 + a, L = (d2 - e2) * y2 + e2, F3 = (D2 - C) * y2 + C, j = (L - D2) * y2 + D2, U3 = (j - F3) * y2 + F3;
      x2[0] = l2, x2[1] = C, x2[2] = F3, x2[3] = U3, x2[4] = U3, x2[5] = j, x2[6] = L, x2[7] = d2;
    }
    function lvt(l2, a, e2, d2, y2, x2, C, D2, L, F3, j) {
      var U3, Y3 = 5e-3, Q = 1 / 0, nt, dt, vt, Ct;
      mb2[0] = L, mb2[1] = F3;
      for (var Pt = 0; Pt < 1; Pt += 0.05)
        T_[0] = m0(l2, e2, y2, C, Pt), T_[1] = m0(a, d2, x2, D2, Pt), vt = U2(mb2, T_), vt < Q && (U3 = Pt, Q = vt);
      Q = 1 / 0;
      for (var jt = 0; jt < 32 && !(Y3 < xV); jt++)
        nt = U3 - Y3, dt = U3 + Y3, T_[0] = m0(l2, e2, y2, C, nt), T_[1] = m0(a, d2, x2, D2, nt), vt = U2(T_, mb2), nt >= 0 && vt < Q ? (U3 = nt, Q = vt) : (mN[0] = m0(l2, e2, y2, C, dt), mN[1] = m0(a, d2, x2, D2, dt), Ct = U2(mN, mb2), dt <= 1 && Ct < Q ? (U3 = dt, Q = Ct) : Y3 *= 0.5);
      return j && (j[0] = m0(l2, e2, y2, C, U3), j[1] = m0(a, d2, x2, D2, U3)), mE(Q);
    }
    function x5t(l2, a, e2, d2, y2, x2, C, D2, L) {
      for (var F3 = l2, j = a, U3 = 0, Y3 = 1 / L, Q = 1; Q <= L; Q++) {
        var nt = Q * Y3, dt = m0(l2, e2, y2, C, nt), vt = m0(a, d2, x2, D2, nt), Ct = dt - F3, Pt = vt - j;
        U3 += Math.sqrt(Ct * Ct + Pt * Pt), F3 = dt, j = vt;
      }
      return U3;
    }
    function sp(l2, a, e2, d2) {
      var y2 = 1 - d2;
      return y2 * (y2 * l2 + 2 * d2 * a) + d2 * d2 * e2;
    }
    function Cm(l2, a, e2, d2) {
      return 2 * ((1 - d2) * (a - l2) + d2 * (e2 - a));
    }
    function w5t(l2, a, e2, d2, y2) {
      var x2 = l2 - 2 * a + e2, C = 2 * (a - l2), D2 = l2 - d2, L = 0;
      if (N5(x2)) {
        if (ovt(C)) {
          var F3 = -D2 / C;
          F3 >= 0 && F3 <= 1 && (y2[L++] = F3);
        }
      } else {
        var j = C * C - 4 * x2 * D2;
        if (N5(j)) {
          var F3 = -C / (2 * x2);
          F3 >= 0 && F3 <= 1 && (y2[L++] = F3);
        } else if (j > 0) {
          var U3 = mE(j), F3 = (-C + U3) / (2 * x2), Y3 = (-C - U3) / (2 * x2);
          F3 >= 0 && F3 <= 1 && (y2[L++] = F3), Y3 >= 0 && Y3 <= 1 && (y2[L++] = Y3);
        }
      }
      return L;
    }
    function uvt(l2, a, e2) {
      var d2 = l2 + e2 - 2 * a;
      return d2 === 0 ? 0.5 : (l2 - a) / d2;
    }
    function _N(l2, a, e2, d2, y2) {
      var x2 = (a - l2) * d2 + l2, C = (e2 - a) * d2 + a, D2 = (C - x2) * d2 + x2;
      y2[0] = l2, y2[1] = x2, y2[2] = D2, y2[3] = D2, y2[4] = C, y2[5] = e2;
    }
    function cvt(l2, a, e2, d2, y2, x2, C, D2, L) {
      var F3, j = 5e-3, U3 = 1 / 0;
      mb2[0] = C, mb2[1] = D2;
      for (var Y3 = 0; Y3 < 1; Y3 += 0.05) {
        T_[0] = sp(l2, e2, y2, Y3), T_[1] = sp(a, d2, x2, Y3);
        var Q = U2(mb2, T_);
        Q < U3 && (F3 = Y3, U3 = Q);
      }
      U3 = 1 / 0;
      for (var nt = 0; nt < 32 && !(j < xV); nt++) {
        var dt = F3 - j, vt = F3 + j;
        T_[0] = sp(l2, e2, y2, dt), T_[1] = sp(a, d2, x2, dt);
        var Q = U2(T_, mb2);
        if (dt >= 0 && Q < U3)
          F3 = dt, U3 = Q;
        else {
          mN[0] = sp(l2, e2, y2, vt), mN[1] = sp(a, d2, x2, vt);
          var Ct = U2(mN, mb2);
          vt <= 1 && Ct < U3 ? (F3 = vt, U3 = Ct) : j *= 0.5;
        }
      }
      return L && (L[0] = sp(l2, e2, y2, F3), L[1] = sp(a, d2, x2, F3)), mE(U3);
    }
    function Oet(l2, a, e2, d2, y2, x2, C) {
      for (var D2 = l2, L = a, F3 = 0, j = 1 / C, U3 = 1; U3 <= C; U3++) {
        var Y3 = U3 * j, Q = sp(l2, e2, y2, Y3), nt = sp(a, d2, x2, Y3), dt = Q - D2, vt = nt - L;
        F3 += Math.sqrt(dt * dt + vt * vt), D2 = Q, L = nt;
      }
      return F3;
    }
    var SV = /cubic-bezier\(([0-9,\.e ]+)\)/;
    function MV(l2) {
      var a = l2 && SV.exec(l2);
      if (a) {
        var e2 = a[1].split(","), d2 = +TS(e2[0]), y2 = +TS(e2[1]), x2 = +TS(e2[2]), C = +TS(e2[3]);
        if (isNaN(d2 + y2 + x2 + C))
          return;
        var D2 = [];
        return function(L) {
          return L <= 0 ? 0 : L >= 1 ? 1 : bN(0, d2, x2, 1, L, D2) && m0(0, y2, C, 1, D2[0]);
        };
      }
    }
    var xN = function() {
      function l2(a) {
        this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = a.life || 1e3, this._delay = a.delay || 0, this.loop = a.loop || false, this.onframe = a.onframe || $p, this.ondestroy = a.ondestroy || $p, this.onrestart = a.onrestart || $p, a.easing && this.setEasing(a.easing);
      }
      return l2.prototype.step = function(a, e2) {
        if (this._inited || (this._startTime = a + this._delay, this._inited = true), this._paused) {
          this._pausedTime += e2;
          return;
        }
        var d2 = this._life, y2 = a - this._startTime - this._pausedTime, x2 = y2 / d2;
        x2 < 0 && (x2 = 0), x2 = Math.min(x2, 1);
        var C = this.easingFunc, D2 = C ? C(x2) : x2;
        if (this.onframe(D2), x2 === 1)
          if (this.loop) {
            var L = y2 % d2;
            this._startTime = a - L, this._pausedTime = 0, this.onrestart();
          } else
            return true;
        return false;
      }, l2.prototype.pause = function() {
        this._paused = true;
      }, l2.prototype.resume = function() {
        this._paused = false;
      }, l2.prototype.setEasing = function(a) {
        this.easing = a, this.easingFunc = wl(a) ? a : Pet[a] || MV(a);
      }, l2;
    }(), CV = xN, wN = function() {
      function l2(a) {
        this.value = a;
      }
      return l2;
    }(), VU = function() {
      function l2() {
        this._len = 0;
      }
      return l2.prototype.insert = function(a) {
        var e2 = new wN(a);
        return this.insertEntry(e2), e2;
      }, l2.prototype.insertEntry = function(a) {
        this.head ? (this.tail.next = a, a.prev = this.tail, a.next = null, this.tail = a) : this.head = this.tail = a, this._len++;
      }, l2.prototype.remove = function(a) {
        var e2 = a.prev, d2 = a.next;
        e2 ? e2.next = d2 : this.head = d2, d2 ? d2.prev = e2 : this.tail = e2, a.next = a.prev = null, this._len--;
      }, l2.prototype.len = function() {
        return this._len;
      }, l2.prototype.clear = function() {
        this.head = this.tail = null, this._len = 0;
      }, l2;
    }(), SN = function() {
      function l2(a) {
        this._list = new VU(), this._maxSize = 10, this._map = {}, this._maxSize = a;
      }
      return l2.prototype.put = function(a, e2) {
        var d2 = this._list, y2 = this._map, x2 = null;
        if (y2[a] == null) {
          var C = d2.len(), D2 = this._lastRemovedEntry;
          if (C >= this._maxSize && C > 0) {
            var L = d2.head;
            d2.remove(L), delete y2[L.key], x2 = L.value, this._lastRemovedEntry = L;
          }
          D2 ? D2.value = e2 : D2 = new wN(e2), D2.key = a, d2.insertEntry(D2), y2[a] = D2;
        }
        return x2;
      }, l2.prototype.get = function(a) {
        var e2 = this._map[a], d2 = this._list;
        if (e2 != null)
          return e2 !== d2.tail && (d2.remove(e2), d2.insertEntry(e2)), e2.value;
      }, l2.prototype.clear = function() {
        this._list.clear(), this._map = {};
      }, l2.prototype.len = function() {
        return this._list.len();
      }, l2;
    }(), TV = SN, fvt = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
    function lC(l2) {
      return l2 = Math.round(l2), l2 < 0 ? 0 : l2 > 255 ? 255 : l2;
    }
    function S5t(l2) {
      return l2 = Math.round(l2), l2 < 0 ? 0 : l2 > 360 ? 360 : l2;
    }
    function AV(l2) {
      return l2 < 0 ? 0 : l2 > 1 ? 1 : l2;
    }
    function MN(l2) {
      var a = l2;
      return a.length && a.charAt(a.length - 1) === "%" ? lC(parseFloat(a) / 100 * 255) : lC(parseInt(a, 10));
    }
    function aA(l2) {
      var a = l2;
      return a.length && a.charAt(a.length - 1) === "%" ? AV(parseFloat(a) / 100) : AV(parseFloat(a));
    }
    function BU(l2, a, e2) {
      return e2 < 0 ? e2 += 1 : e2 > 1 && (e2 -= 1), e2 * 6 < 1 ? l2 + (a - l2) * e2 * 6 : e2 * 2 < 1 ? a : e2 * 3 < 2 ? l2 + (a - l2) * (2 / 3 - e2) * 6 : l2;
    }
    function In(l2, a, e2) {
      return l2 + (a - l2) * e2;
    }
    function p1(l2, a, e2, d2, y2) {
      return l2[0] = a, l2[1] = e2, l2[2] = d2, l2[3] = y2, l2;
    }
    function CN(l2, a) {
      return l2[0] = a[0], l2[1] = a[1], l2[2] = a[2], l2[3] = a[3], l2;
    }
    var ES = new TV(20), nh2 = null;
    function TN(l2, a) {
      nh2 && CN(nh2, a), nh2 = ES.put(l2, nh2 || a.slice());
    }
    function kS(l2, a) {
      if (l2) {
        a = a || [];
        var e2 = ES.get(l2);
        if (e2)
          return CN(a, e2);
        l2 = l2 + "";
        var d2 = l2.replace(/ /g, "").toLowerCase();
        if (d2 in fvt)
          return CN(a, fvt[d2]), TN(l2, a), a;
        var y2 = d2.length;
        if (d2.charAt(0) === "#") {
          if (y2 === 4 || y2 === 5) {
            var x2 = parseInt(d2.slice(1, 4), 16);
            if (!(x2 >= 0 && x2 <= 4095)) {
              p1(a, 0, 0, 0, 1);
              return;
            }
            return p1(a, (x2 & 3840) >> 4 | (x2 & 3840) >> 8, x2 & 240 | (x2 & 240) >> 4, x2 & 15 | (x2 & 15) << 4, y2 === 5 ? parseInt(d2.slice(4), 16) / 15 : 1), TN(l2, a), a;
          } else if (y2 === 7 || y2 === 9) {
            var x2 = parseInt(d2.slice(1, 7), 16);
            if (!(x2 >= 0 && x2 <= 16777215)) {
              p1(a, 0, 0, 0, 1);
              return;
            }
            return p1(a, (x2 & 16711680) >> 16, (x2 & 65280) >> 8, x2 & 255, y2 === 9 ? parseInt(d2.slice(7), 16) / 255 : 1), TN(l2, a), a;
          }
          return;
        }
        var C = d2.indexOf("("), D2 = d2.indexOf(")");
        if (C !== -1 && D2 + 1 === y2) {
          var L = d2.substr(0, C), F3 = d2.substr(C + 1, D2 - (C + 1)).split(","), j = 1;
          switch (L) {
            case "rgba":
              if (F3.length !== 4)
                return F3.length === 3 ? p1(a, +F3[0], +F3[1], +F3[2], 1) : p1(a, 0, 0, 0, 1);
              j = aA(F3.pop());
            case "rgb":
              if (F3.length !== 3) {
                p1(a, 0, 0, 0, 1);
                return;
              }
              return p1(a, MN(F3[0]), MN(F3[1]), MN(F3[2]), j), TN(l2, a), a;
            case "hsla":
              if (F3.length !== 4) {
                p1(a, 0, 0, 0, 1);
                return;
              }
              return F3[3] = aA(F3[3]), Ret(F3, a), TN(l2, a), a;
            case "hsl":
              if (F3.length !== 3) {
                p1(a, 0, 0, 0, 1);
                return;
              }
              return Ret(F3, a), TN(l2, a), a;
            default:
              return;
          }
        }
        p1(a, 0, 0, 0, 1);
      }
    }
    function Ret(l2, a) {
      var e2 = (parseFloat(l2[0]) % 360 + 360) % 360 / 360, d2 = aA(l2[1]), y2 = aA(l2[2]), x2 = y2 <= 0.5 ? y2 * (d2 + 1) : y2 + d2 - y2 * d2, C = y2 * 2 - x2;
      return a = a || [], p1(a, lC(BU(C, x2, e2 + 1 / 3) * 255), lC(BU(C, x2, e2) * 255), lC(BU(C, x2, e2 - 1 / 3) * 255), 1), l2.length === 4 && (a[3] = l2[3]), a;
    }
    function tO(l2) {
      if (l2) {
        var a = l2[0] / 255, e2 = l2[1] / 255, d2 = l2[2] / 255, y2 = Math.min(a, e2, d2), x2 = Math.max(a, e2, d2), C = x2 - y2, D2 = (x2 + y2) / 2, L, F3;
        if (C === 0)
          L = 0, F3 = 0;
        else {
          D2 < 0.5 ? F3 = C / (x2 + y2) : F3 = C / (2 - x2 - y2);
          var j = ((x2 - a) / 6 + C / 2) / C, U3 = ((x2 - e2) / 6 + C / 2) / C, Y3 = ((x2 - d2) / 6 + C / 2) / C;
          a === x2 ? L = Y3 - U3 : e2 === x2 ? L = 1 / 3 + j - Y3 : d2 === x2 && (L = 2 / 3 + U3 - j), L < 0 && (L += 1), L > 1 && (L -= 1);
        }
        var Q = [L * 360, F3, D2];
        return l2[3] != null && Q.push(l2[3]), Q;
      }
    }
    function Net(l2, a) {
      var e2 = kS(l2);
      if (e2) {
        for (var d2 = 0; d2 < 3; d2++)
          a < 0 ? e2[d2] = e2[d2] * (1 - a) | 0 : e2[d2] = (255 - e2[d2]) * a + e2[d2] | 0, e2[d2] > 255 ? e2[d2] = 255 : e2[d2] < 0 && (e2[d2] = 0);
        return d1(e2, e2.length === 4 ? "rgba" : "rgb");
      }
    }
    function Fet(l2, a, e2) {
      if (!(!(a && a.length) || !(l2 >= 0 && l2 <= 1))) {
        e2 = e2 || [];
        var d2 = l2 * (a.length - 1), y2 = Math.floor(d2), x2 = Math.ceil(d2), C = a[y2], D2 = a[x2], L = d2 - y2;
        return e2[0] = lC(In(C[0], D2[0], L)), e2[1] = lC(In(C[1], D2[1], L)), e2[2] = lC(In(C[2], D2[2], L)), e2[3] = AV(In(C[3], D2[3], L)), e2;
      }
    }
    function M5t(l2, a, e2) {
      if (!(!(a && a.length) || !(l2 >= 0 && l2 <= 1))) {
        var d2 = l2 * (a.length - 1), y2 = Math.floor(d2), x2 = Math.ceil(d2), C = kS(a[y2]), D2 = kS(a[x2]), L = d2 - y2, F3 = d1([lC(In(C[0], D2[0], L)), lC(In(C[1], D2[1], L)), lC(In(C[2], D2[2], L)), AV(In(C[3], D2[3], L))], "rgba");
        return e2 ? { color: F3, leftIndex: y2, rightIndex: x2, value: d2 } : F3;
      }
    }
    function IV(l2, a, e2, d2) {
      var y2 = kS(l2);
      if (l2)
        return y2 = tO(y2), a != null && (y2[0] = S5t(a)), e2 != null && (y2[1] = aA(e2)), d2 != null && (y2[2] = aA(d2)), d1(Ret(y2), "rgba");
    }
    function zU(l2, a) {
      var e2 = kS(l2);
      if (e2 && a != null)
        return e2[3] = AV(a), d1(e2, "rgba");
    }
    function d1(l2, a) {
      if (!(!l2 || !l2.length)) {
        var e2 = l2[0] + "," + l2[1] + "," + l2[2];
        return (a === "rgba" || a === "hsva" || a === "hsla") && (e2 += "," + l2[3]), a + "(" + e2 + ")";
      }
    }
    function jU(l2, a) {
      var e2 = kS(l2);
      return e2 ? (0.299 * e2[0] + 0.587 * e2[1] + 0.114 * e2[2]) * e2[3] / 255 + (1 - e2[3]) * a : 0;
    }
    var WU = Math.round;
    function AN(l2) {
      var a;
      if (!l2 || l2 === "transparent")
        l2 = "none";
      else if (typeof l2 == "string" && l2.indexOf("rgba") > -1) {
        var e2 = kS(l2);
        e2 && (l2 = "rgb(" + e2[0] + "," + e2[1] + "," + e2[2] + ")", a = e2[3]);
      }
      return { color: l2, opacity: a == null ? 1 : a };
    }
    var hvt = 1e-4;
    function F5(l2) {
      return l2 < hvt && l2 > -hvt;
    }
    function Z2(l2) {
      return WU(l2 * 1e3) / 1e3;
    }
    function Vet(l2) {
      return WU(l2 * 1e4) / 1e4;
    }
    function C5t(l2) {
      return "matrix(" + Z2(l2[0]) + "," + Z2(l2[1]) + "," + Z2(l2[2]) + "," + Z2(l2[3]) + "," + Vet(l2[4]) + "," + Vet(l2[5]) + ")";
    }
    var T5t = { left: "start", right: "end", center: "middle", middle: "middle" };
    function A5t(l2, a, e2) {
      return e2 === "top" ? l2 += a / 2 : e2 === "bottom" && (l2 -= a / 2), l2;
    }
    function I5t(l2) {
      return l2 && (l2.shadowBlur || l2.shadowOffsetX || l2.shadowOffsetY);
    }
    function eO(l2) {
      var a = l2.style, e2 = l2.getGlobalScale();
      return [a.shadowColor, (a.shadowBlur || 0).toFixed(2), (a.shadowOffsetX || 0).toFixed(2), (a.shadowOffsetY || 0).toFixed(2), e2[0], e2[1]].join(",");
    }
    function pvt(l2) {
      return l2 && !!l2.image;
    }
    function D5t(l2) {
      return l2 && !!l2.svgElement;
    }
    function uC(l2) {
      return pvt(l2) || D5t(l2);
    }
    function dvt(l2) {
      return l2.type === "linear";
    }
    function gvt(l2) {
      return l2.type === "radial";
    }
    function E5t(l2) {
      return l2 && (l2.type === "linear" || l2.type === "radial");
    }
    function GU(l2) {
      return "url(#" + l2 + ")";
    }
    function vvt(l2) {
      var a = l2.getGlobalScale(), e2 = Math.max(a[0], a[1]);
      return Math.max(Math.ceil(Math.log(e2) / Math.log(10)), 1);
    }
    function Bet(l2) {
      var a = l2.x || 0, e2 = l2.y || 0, d2 = (l2.rotation || 0) * kU, y2 = $u(l2.scaleX, 1), x2 = $u(l2.scaleY, 1), C = l2.skewX || 0, D2 = l2.skewY || 0, L = [];
      return (a || e2) && L.push("translate(" + a + "px," + e2 + "px)"), d2 && L.push("rotate(" + d2 + ")"), (y2 !== 1 || x2 !== 1) && L.push("scale(" + y2 + "," + x2 + ")"), (C || D2) && L.push("skew(" + WU(C * kU) + "deg, " + WU(D2 * kU) + "deg)"), L.join(" ");
    }
    var yvt = function() {
      return $s.hasGlobalWindow && wl(window.btoa) ? function(l2) {
        return window.btoa(unescape(l2));
      } : typeof Buffer != "undefined" ? function(l2) {
        return Buffer.from(l2).toString("base64");
      } : function(l2) {
        return null;
      };
    }(), zet = Array.prototype.slice;
    function _E(l2, a, e2) {
      return (a - l2) * e2 + l2;
    }
    function DV(l2, a, e2, d2) {
      for (var y2 = a.length, x2 = 0; x2 < y2; x2++)
        l2[x2] = _E(a[x2], e2[x2], d2);
      return l2;
    }
    function EV(l2, a, e2, d2) {
      for (var y2 = a.length, x2 = y2 && a[0].length, C = 0; C < y2; C++) {
        l2[C] || (l2[C] = []);
        for (var D2 = 0; D2 < x2; D2++)
          l2[C][D2] = _E(a[C][D2], e2[C][D2], d2);
      }
      return l2;
    }
    function nO(l2, a, e2, d2) {
      for (var y2 = a.length, x2 = 0; x2 < y2; x2++)
        l2[x2] = a[x2] + e2[x2] * d2;
      return l2;
    }
    function mvt(l2, a, e2, d2) {
      for (var y2 = a.length, x2 = y2 && a[0].length, C = 0; C < y2; C++) {
        l2[C] || (l2[C] = []);
        for (var D2 = 0; D2 < x2; D2++)
          l2[C][D2] = a[C][D2] + e2[C][D2] * d2;
      }
      return l2;
    }
    function bvt(l2, a) {
      for (var e2 = l2.length, d2 = a.length, y2 = e2 > d2 ? a : l2, x2 = Math.min(e2, d2), C = y2[x2 - 1] || { color: [0, 0, 0, 0], offset: 0 }, D2 = x2; D2 < Math.max(e2, d2); D2++)
        y2.push({ offset: C.offset, color: C.color.slice() });
    }
    function k5t(l2, a, e2) {
      var d2 = l2, y2 = a;
      if (!(!d2.push || !y2.push)) {
        var x2 = d2.length, C = y2.length;
        if (x2 !== C) {
          var D2 = x2 > C;
          if (D2)
            d2.length = C;
          else
            for (var L = x2; L < C; L++)
              d2.push(e2 === 1 ? y2[L] : zet.call(y2[L]));
        }
        for (var F3 = d2[0] && d2[0].length, L = 0; L < d2.length; L++)
          if (e2 === 1)
            isNaN(d2[L]) && (d2[L] = y2[L]);
          else
            for (var j = 0; j < F3; j++)
              isNaN(d2[L][j]) && (d2[L][j] = y2[L][j]);
      }
    }
    function PS(l2) {
      if (h1(l2)) {
        var a = l2.length;
        if (h1(l2[0])) {
          for (var e2 = [], d2 = 0; d2 < a; d2++)
            e2.push(zet.call(l2[d2]));
          return e2;
        }
        return zet.call(l2);
      }
      return l2;
    }
    function IN(l2) {
      return l2[0] = Math.floor(l2[0]) || 0, l2[1] = Math.floor(l2[1]) || 0, l2[2] = Math.floor(l2[2]) || 0, l2[3] = l2[3] == null ? 1 : l2[3], "rgba(" + l2.join(",") + ")";
    }
    function rO(l2) {
      return h1(l2 && l2[0]) ? 2 : 1;
    }
    var A_ = 0, HU = 1, jet = 2, DN = 3, iO = 4, oA = 5, Wet = 6;
    function _vt(l2) {
      return l2 === iO || l2 === oA;
    }
    function aO(l2) {
      return l2 === HU || l2 === jet;
    }
    var kV = [0, 0, 0, 0], xvt = function() {
      function l2(a) {
        this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = a;
      }
      return l2.prototype.isFinished = function() {
        return this._finished;
      }, l2.prototype.setFinished = function() {
        this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
      }, l2.prototype.needsAnimate = function() {
        return this.keyframes.length >= 1;
      }, l2.prototype.getAdditiveTrack = function() {
        return this._additiveTrack;
      }, l2.prototype.addKeyframe = function(a, e2, d2) {
        this._needsSort = true;
        var y2 = this.keyframes, x2 = y2.length, C = false, D2 = Wet, L = e2;
        if (h1(e2)) {
          var F3 = rO(e2);
          D2 = F3, (F3 === 1 && !Ch2(e2[0]) || F3 === 2 && !Ch2(e2[0][0])) && (C = true);
        } else if (Ch2(e2) && !pV(e2))
          D2 = A_;
        else if (ps(e2))
          if (!isNaN(+e2))
            D2 = A_;
          else {
            var j = kS(e2);
            j && (L = j, D2 = DN);
          }
        else if (DU(e2)) {
          var U3 = la2({}, L);
          U3.colorStops = $a2(e2.colorStops, function(Q) {
            return { offset: Q.offset, color: kS(Q.color) };
          }), dvt(e2) ? D2 = iO : gvt(e2) && (D2 = oA), L = U3;
        }
        x2 === 0 ? this.valType = D2 : (D2 !== this.valType || D2 === Wet) && (C = true), this.discrete = this.discrete || C;
        var Y3 = { time: a, value: L, rawValue: e2, percent: 0 };
        return d2 && (Y3.easing = d2, Y3.easingFunc = wl(d2) ? d2 : Pet[d2] || MV(d2)), y2.push(Y3), Y3;
      }, l2.prototype.prepare = function(a, e2) {
        var d2 = this.keyframes;
        this._needsSort && d2.sort(function(dt, vt) {
          return dt.time - vt.time;
        });
        for (var y2 = this.valType, x2 = d2.length, C = d2[x2 - 1], D2 = this.discrete, L = aO(y2), F3 = _vt(y2), j = 0; j < x2; j++) {
          var U3 = d2[j], Y3 = U3.value, Q = C.value;
          U3.percent = U3.time / a, D2 || (L && j !== x2 - 1 ? k5t(Y3, Q, y2) : F3 && bvt(Y3.colorStops, Q.colorStops));
        }
        if (!D2 && y2 !== oA && e2 && this.needsAnimate() && e2.needsAnimate() && y2 === e2.valType && !e2._finished) {
          this._additiveTrack = e2;
          for (var nt = d2[0].value, j = 0; j < x2; j++)
            y2 === A_ ? d2[j].additiveValue = d2[j].value - nt : y2 === DN ? d2[j].additiveValue = nO([], d2[j].value, nt, -1) : aO(y2) && (d2[j].additiveValue = y2 === HU ? nO([], d2[j].value, nt, -1) : mvt([], d2[j].value, nt, -1));
        }
      }, l2.prototype.step = function(a, e2) {
        if (!this._finished) {
          this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
          var d2 = this._additiveTrack != null, y2 = d2 ? "additiveValue" : "value", x2 = this.valType, C = this.keyframes, D2 = C.length, L = this.propName, F3 = x2 === DN, j, U3 = this._lastFr, Y3 = Math.min, Q, nt;
          if (D2 === 1)
            Q = nt = C[0];
          else {
            if (e2 < 0)
              j = 0;
            else if (e2 < this._lastFrP) {
              var dt = Y3(U3 + 1, D2 - 1);
              for (j = dt; j >= 0 && !(C[j].percent <= e2); j--)
                ;
              j = Y3(j, D2 - 2);
            } else {
              for (j = U3; j < D2 && !(C[j].percent > e2); j++)
                ;
              j = Y3(j - 1, D2 - 2);
            }
            nt = C[j + 1], Q = C[j];
          }
          if (Q && nt) {
            this._lastFr = j, this._lastFrP = e2;
            var vt = nt.percent - Q.percent, Ct = vt === 0 ? 1 : Y3((e2 - Q.percent) / vt, 1);
            nt.easingFunc && (Ct = nt.easingFunc(Ct));
            var Pt = d2 ? this._additiveValue : F3 ? kV : a[L];
            if ((aO(x2) || F3) && !Pt && (Pt = this._additiveValue = []), this.discrete)
              a[L] = Ct < 1 ? Q.rawValue : nt.rawValue;
            else if (aO(x2))
              x2 === HU ? DV(Pt, Q[y2], nt[y2], Ct) : EV(Pt, Q[y2], nt[y2], Ct);
            else if (_vt(x2)) {
              var jt = Q[y2], Rt = nt[y2], le2 = x2 === iO;
              a[L] = { type: le2 ? "linear" : "radial", x: _E(jt.x, Rt.x, Ct), y: _E(jt.y, Rt.y, Ct), colorStops: $a2(jt.colorStops, function(he2, _e) {
                var Me2 = Rt.colorStops[_e];
                return { offset: _E(he2.offset, Me2.offset, Ct), color: IN(DV([], he2.color, Me2.color, Ct)) };
              }), global: Rt.global }, le2 ? (a[L].x2 = _E(jt.x2, Rt.x2, Ct), a[L].y2 = _E(jt.y2, Rt.y2, Ct)) : a[L].r = _E(jt.r, Rt.r, Ct);
            } else if (F3)
              DV(Pt, Q[y2], nt[y2], Ct), d2 || (a[L] = IN(Pt));
            else {
              var ne2 = _E(Q[y2], nt[y2], Ct);
              d2 ? this._additiveValue = ne2 : a[L] = ne2;
            }
            d2 && this._addToTarget(a);
          }
        }
      }, l2.prototype._addToTarget = function(a) {
        var e2 = this.valType, d2 = this.propName, y2 = this._additiveValue;
        e2 === A_ ? a[d2] = a[d2] + y2 : e2 === DN ? (kS(a[d2], kV), nO(kV, kV, y2, 1), a[d2] = IN(kV)) : e2 === HU ? nO(a[d2], a[d2], y2, 1) : e2 === jet && mvt(a[d2], a[d2], y2, 1);
      }, l2;
    }(), Wy = function() {
      function l2(a, e2, d2, y2) {
        if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = a, this._loop = e2, e2 && y2) {
          fV("Can' use additive animation on looped animation.");
          return;
        }
        this._additiveAnimators = y2, this._allowDiscrete = d2;
      }
      return l2.prototype.getMaxTime = function() {
        return this._maxTime;
      }, l2.prototype.getDelay = function() {
        return this._delay;
      }, l2.prototype.getLoop = function() {
        return this._loop;
      }, l2.prototype.getTarget = function() {
        return this._target;
      }, l2.prototype.changeTarget = function(a) {
        this._target = a;
      }, l2.prototype.when = function(a, e2, d2) {
        return this.whenWithKeys(a, e2, Qc2(e2), d2);
      }, l2.prototype.whenWithKeys = function(a, e2, d2, y2) {
        for (var x2 = this._tracks, C = 0; C < d2.length; C++) {
          var D2 = d2[C], L = x2[D2];
          if (!L) {
            L = x2[D2] = new xvt(D2);
            var F3 = void 0, j = this._getAdditiveTrack(D2);
            if (j) {
              var U3 = j.keyframes, Y3 = U3[U3.length - 1];
              F3 = Y3 && Y3.value, j.valType === DN && F3 && (F3 = IN(F3));
            } else
              F3 = this._target[D2];
            if (F3 == null)
              continue;
            a > 0 && L.addKeyframe(0, PS(F3), y2), this._trackKeys.push(D2);
          }
          L.addKeyframe(a, PS(e2[D2]), y2);
        }
        return this._maxTime = Math.max(this._maxTime, a), this;
      }, l2.prototype.pause = function() {
        this._clip.pause(), this._paused = true;
      }, l2.prototype.resume = function() {
        this._clip.resume(), this._paused = false;
      }, l2.prototype.isPaused = function() {
        return !!this._paused;
      }, l2.prototype.duration = function(a) {
        return this._maxTime = a, this._force = true, this;
      }, l2.prototype._doneCallback = function() {
        this._setTracksFinished(), this._clip = null;
        var a = this._doneCbs;
        if (a)
          for (var e2 = a.length, d2 = 0; d2 < e2; d2++)
            a[d2].call(this);
      }, l2.prototype._abortedCallback = function() {
        this._setTracksFinished();
        var a = this.animation, e2 = this._abortedCbs;
        if (a && a.removeClip(this._clip), this._clip = null, e2)
          for (var d2 = 0; d2 < e2.length; d2++)
            e2[d2].call(this);
      }, l2.prototype._setTracksFinished = function() {
        for (var a = this._tracks, e2 = this._trackKeys, d2 = 0; d2 < e2.length; d2++)
          a[e2[d2]].setFinished();
      }, l2.prototype._getAdditiveTrack = function(a) {
        var e2, d2 = this._additiveAnimators;
        if (d2)
          for (var y2 = 0; y2 < d2.length; y2++) {
            var x2 = d2[y2].getTrack(a);
            x2 && (e2 = x2);
          }
        return e2;
      }, l2.prototype.start = function(a) {
        if (!(this._started > 0)) {
          this._started = 1;
          for (var e2 = this, d2 = [], y2 = this._maxTime || 0, x2 = 0; x2 < this._trackKeys.length; x2++) {
            var C = this._trackKeys[x2], D2 = this._tracks[C], L = this._getAdditiveTrack(C), F3 = D2.keyframes, j = F3.length;
            if (D2.prepare(y2, L), D2.needsAnimate())
              if (!this._allowDiscrete && D2.discrete) {
                var U3 = F3[j - 1];
                U3 && (e2._target[D2.propName] = U3.rawValue), D2.setFinished();
              } else
                d2.push(D2);
          }
          if (d2.length || this._force) {
            var Y3 = new CV({ life: y2, loop: this._loop, delay: this._delay || 0, onframe: function(Q) {
              e2._started = 2;
              var nt = e2._additiveAnimators;
              if (nt) {
                for (var dt = false, vt = 0; vt < nt.length; vt++)
                  if (nt[vt]._clip) {
                    dt = true;
                    break;
                  }
                dt || (e2._additiveAnimators = null);
              }
              for (var vt = 0; vt < d2.length; vt++)
                d2[vt].step(e2._target, Q);
              var Ct = e2._onframeCbs;
              if (Ct)
                for (var vt = 0; vt < Ct.length; vt++)
                  Ct[vt](e2._target, Q);
            }, ondestroy: function() {
              e2._doneCallback();
            } });
            this._clip = Y3, this.animation && this.animation.addClip(Y3), a && Y3.setEasing(a);
          } else
            this._doneCallback();
          return this;
        }
      }, l2.prototype.stop = function(a) {
        if (this._clip) {
          var e2 = this._clip;
          a && e2.onframe(1), this._abortedCallback();
        }
      }, l2.prototype.delay = function(a) {
        return this._delay = a, this;
      }, l2.prototype.during = function(a) {
        return a && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(a)), this;
      }, l2.prototype.done = function(a) {
        return a && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(a)), this;
      }, l2.prototype.aborted = function(a) {
        return a && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(a)), this;
      }, l2.prototype.getClip = function() {
        return this._clip;
      }, l2.prototype.getTrack = function(a) {
        return this._tracks[a];
      }, l2.prototype.getTracks = function() {
        var a = this;
        return $a2(this._trackKeys, function(e2) {
          return a._tracks[e2];
        });
      }, l2.prototype.stopTracks = function(a, e2) {
        if (!a.length || !this._clip)
          return true;
        for (var d2 = this._tracks, y2 = this._trackKeys, x2 = 0; x2 < a.length; x2++) {
          var C = d2[a[x2]];
          C && !C.isFinished() && (e2 ? C.step(this._target, 1) : this._started === 1 && C.step(this._target, 0), C.setFinished());
        }
        for (var D2 = true, x2 = 0; x2 < y2.length; x2++)
          if (!d2[y2[x2]].isFinished()) {
            D2 = false;
            break;
          }
        return D2 && this._abortedCallback(), D2;
      }, l2.prototype.saveTo = function(a, e2, d2) {
        if (a) {
          e2 = e2 || this._trackKeys;
          for (var y2 = 0; y2 < e2.length; y2++) {
            var x2 = e2[y2], C = this._tracks[x2];
            if (!(!C || C.isFinished())) {
              var D2 = C.keyframes, L = D2[d2 ? 0 : D2.length - 1];
              L && (a[x2] = PS(L.rawValue));
            }
          }
        }
      }, l2.prototype.__changeFinalValue = function(a, e2) {
        e2 = e2 || Qc2(a);
        for (var d2 = 0; d2 < e2.length; d2++) {
          var y2 = e2[d2], x2 = this._tracks[y2];
          if (x2) {
            var C = x2.keyframes;
            if (C.length > 1) {
              var D2 = C.pop();
              x2.addKeyframe(D2.time, a[y2]), x2.prepare(this._maxTime, x2.getAdditiveTrack());
            }
          }
        }
      }, l2;
    }();
    function V5() {
      return new Date().getTime();
    }
    var wvt = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this) || this;
        return d2._running = false, d2._time = 0, d2._pausedTime = 0, d2._pauseStart = 0, d2._paused = false, e2 = e2 || {}, d2.stage = e2.stage || {}, d2;
      }
      return a.prototype.addClip = function(e2) {
        e2.animation && this.removeClip(e2), this._head ? (this._tail.next = e2, e2.prev = this._tail, e2.next = null, this._tail = e2) : this._head = this._tail = e2, e2.animation = this;
      }, a.prototype.addAnimator = function(e2) {
        e2.animation = this;
        var d2 = e2.getClip();
        d2 && this.addClip(d2);
      }, a.prototype.removeClip = function(e2) {
        if (e2.animation) {
          var d2 = e2.prev, y2 = e2.next;
          d2 ? d2.next = y2 : this._head = y2, y2 ? y2.prev = d2 : this._tail = d2, e2.next = e2.prev = e2.animation = null;
        }
      }, a.prototype.removeAnimator = function(e2) {
        var d2 = e2.getClip();
        d2 && this.removeClip(d2), e2.animation = null;
      }, a.prototype.update = function(e2) {
        for (var d2 = V5() - this._pausedTime, y2 = d2 - this._time, x2 = this._head; x2; ) {
          var C = x2.next, D2 = x2.step(d2, y2);
          D2 && (x2.ondestroy(), this.removeClip(x2)), x2 = C;
        }
        this._time = d2, e2 || (this.trigger("frame", y2), this.stage.update && this.stage.update());
      }, a.prototype._startLoop = function() {
        var e2 = this;
        this._running = true;
        function d2() {
          e2._running && (iA(d2), !e2._paused && e2.update());
        }
        iA(d2);
      }, a.prototype.start = function() {
        this._running || (this._time = V5(), this._pausedTime = 0, this._startLoop());
      }, a.prototype.stop = function() {
        this._running = false;
      }, a.prototype.pause = function() {
        this._paused || (this._pauseStart = V5(), this._paused = true);
      }, a.prototype.resume = function() {
        this._paused && (this._pausedTime += V5() - this._pauseStart, this._paused = false);
      }, a.prototype.clear = function() {
        for (var e2 = this._head; e2; ) {
          var d2 = e2.next;
          e2.prev = e2.next = e2.animation = null, e2 = d2;
        }
        this._head = this._tail = null;
      }, a.prototype.isFinished = function() {
        return this._head == null;
      }, a.prototype.animate = function(e2, d2) {
        d2 = d2 || {}, this.start();
        var y2 = new Wy(e2, d2.loop);
        return this.addAnimator(y2), y2;
      }, a;
    }(Yx), sA = wvt, Get = 300, EN = $s.domSupported, xE = function() {
      var l2 = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], a = ["touchstart", "touchend", "touchmove"], e2 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, d2 = $a2(l2, function(y2) {
        var x2 = y2.replace("mouse", "pointer");
        return e2.hasOwnProperty(x2) ? x2 : y2;
      });
      return { mouse: l2, touch: a, pointer: d2 };
    }(), Het = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, bb2 = false;
    function PV(l2) {
      var a = l2.pointerType;
      return a === "pen" || a === "touch";
    }
    function P5t(l2) {
      l2.touching = true, l2.touchTimer != null && (clearTimeout(l2.touchTimer), l2.touchTimer = null), l2.touchTimer = setTimeout(function() {
        l2.touching = false, l2.touchTimer = null;
      }, 700);
    }
    function Uet(l2) {
      l2 && (l2.zrByTouch = true);
    }
    function L5t(l2, a) {
      return IS(l2.dom, new O5t(l2, a), true);
    }
    function UU(l2, a) {
      for (var e2 = a, d2 = false; e2 && e2.nodeType !== 9 && !(d2 = e2.domBelongToZr || e2 !== a && e2 === l2.painterRoot); )
        e2 = e2.parentNode;
      return d2;
    }
    var O5t = function() {
      function l2(a, e2) {
        this.stopPropagation = $p, this.stopImmediatePropagation = $p, this.preventDefault = $p, this.type = e2.type, this.target = this.currentTarget = a.dom, this.pointerType = e2.pointerType, this.clientX = e2.clientX, this.clientY = e2.clientY;
      }
      return l2;
    }(), I_ = { mousedown: function(l2) {
      l2 = IS(this.dom, l2), this.__mayPointerCapture = [l2.zrX, l2.zrY], this.trigger("mousedown", l2);
    }, mousemove: function(l2) {
      l2 = IS(this.dom, l2);
      var a = this.__mayPointerCapture;
      a && (l2.zrX !== a[0] || l2.zrY !== a[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", l2);
    }, mouseup: function(l2) {
      l2 = IS(this.dom, l2), this.__togglePointerCapture(false), this.trigger("mouseup", l2);
    }, mouseout: function(l2) {
      l2 = IS(this.dom, l2);
      var a = l2.toElement || l2.relatedTarget;
      UU(this, a) || (this.__pointerCapturing && (l2.zrEventControl = "no_globalout"), this.trigger("mouseout", l2));
    }, wheel: function(l2) {
      bb2 = true, l2 = IS(this.dom, l2), this.trigger("mousewheel", l2);
    }, mousewheel: function(l2) {
      bb2 || (l2 = IS(this.dom, l2), this.trigger("mousewheel", l2));
    }, touchstart: function(l2) {
      l2 = IS(this.dom, l2), Uet(l2), this.__lastTouchMoment = new Date(), this.handler.processGesture(l2, "start"), I_.mousemove.call(this, l2), I_.mousedown.call(this, l2);
    }, touchmove: function(l2) {
      l2 = IS(this.dom, l2), Uet(l2), this.handler.processGesture(l2, "change"), I_.mousemove.call(this, l2);
    }, touchend: function(l2) {
      l2 = IS(this.dom, l2), Uet(l2), this.handler.processGesture(l2, "end"), I_.mouseup.call(this, l2), +new Date() - +this.__lastTouchMoment < Get && I_.click.call(this, l2);
    }, pointerdown: function(l2) {
      I_.mousedown.call(this, l2);
    }, pointermove: function(l2) {
      PV(l2) || I_.mousemove.call(this, l2);
    }, pointerup: function(l2) {
      I_.mouseup.call(this, l2);
    }, pointerout: function(l2) {
      PV(l2) || I_.mouseout.call(this, l2);
    } };
    Ke2(["click", "dblclick", "contextmenu"], function(l2) {
      I_[l2] = function(a) {
        a = IS(this.dom, a), this.trigger(l2, a);
      };
    });
    var qU = { pointermove: function(l2) {
      PV(l2) || qU.mousemove.call(this, l2);
    }, pointerup: function(l2) {
      qU.mouseup.call(this, l2);
    }, mousemove: function(l2) {
      this.trigger("mousemove", l2);
    }, mouseup: function(l2) {
      var a = this.__pointerCapturing;
      this.__togglePointerCapture(false), this.trigger("mouseup", l2), a && (l2.zrEventControl = "only_globalout", this.trigger("mouseout", l2));
    } };
    function R5t(l2, a) {
      var e2 = a.domHandlers;
      $s.pointerEventsSupported ? Ke2(xE.pointer, function(d2) {
        B5(a, d2, function(y2) {
          e2[d2].call(l2, y2);
        });
      }) : ($s.touchEventsSupported && Ke2(xE.touch, function(d2) {
        B5(a, d2, function(y2) {
          e2[d2].call(l2, y2), P5t(a);
        });
      }), Ke2(xE.mouse, function(d2) {
        B5(a, d2, function(y2) {
          y2 = mV(y2), a.touching || e2[d2].call(l2, y2);
        });
      }));
    }
    function N5t(l2, a) {
      $s.pointerEventsSupported ? Ke2(Het.pointer, e2) : $s.touchEventsSupported || Ke2(Het.mouse, e2);
      function e2(d2) {
        function y2(x2) {
          x2 = mV(x2), UU(l2, x2.target) || (x2 = L5t(l2, x2), a.domHandlers[d2].call(l2, x2));
        }
        B5(a, d2, y2, { capture: true });
      }
    }
    function B5(l2, a, e2, d2) {
      l2.mounted[a] = e2, l2.listenerOpts[a] = d2, hN(l2.domTarget, a, e2, d2);
    }
    function qet(l2) {
      var a = l2.mounted;
      for (var e2 in a)
        a.hasOwnProperty(e2) && d5t(l2.domTarget, e2, a[e2], l2.listenerOpts[e2]);
      l2.mounted = {};
    }
    var Svt = function() {
      function l2(a, e2) {
        this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = a, this.domHandlers = e2;
      }
      return l2;
    }(), Zet = function(l2) {
      Jn(a, l2);
      function a(e2, d2) {
        var y2 = l2.call(this) || this;
        return y2.__pointerCapturing = false, y2.dom = e2, y2.painterRoot = d2, y2._localHandlerScope = new Svt(e2, I_), EN && (y2._globalHandlerScope = new Svt(document, qU)), R5t(y2, y2._localHandlerScope), y2;
      }
      return a.prototype.dispose = function() {
        qet(this._localHandlerScope), EN && qet(this._globalHandlerScope);
      }, a.prototype.setCursor = function(e2) {
        this.dom.style && (this.dom.style.cursor = e2 || "default");
      }, a.prototype.__togglePointerCapture = function(e2) {
        if (this.__mayPointerCapture = null, EN && +this.__pointerCapturing ^ +e2) {
          this.__pointerCapturing = e2;
          var d2 = this._globalHandlerScope;
          e2 ? N5t(this, d2) : qet(d2);
        }
      }, a;
    }(Yx), Mvt = Zet, Cvt = 1;
    $s.hasGlobalWindow && (Cvt = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
    var ZU = Cvt, $et = 0.4, $U = "#333", LV = "#ccc", F5t = "#eee";
    function Xx() {
      return [1, 0, 0, 1, 0, 0];
    }
    function OV(l2) {
      return l2[0] = 1, l2[1] = 0, l2[2] = 0, l2[3] = 1, l2[4] = 0, l2[5] = 0, l2;
    }
    function YU(l2, a) {
      return l2[0] = a[0], l2[1] = a[1], l2[2] = a[2], l2[3] = a[3], l2[4] = a[4], l2[5] = a[5], l2;
    }
    function lA(l2, a, e2) {
      var d2 = a[0] * e2[0] + a[2] * e2[1], y2 = a[1] * e2[0] + a[3] * e2[1], x2 = a[0] * e2[2] + a[2] * e2[3], C = a[1] * e2[2] + a[3] * e2[3], D2 = a[0] * e2[4] + a[2] * e2[5] + a[4], L = a[1] * e2[4] + a[3] * e2[5] + a[5];
      return l2[0] = d2, l2[1] = y2, l2[2] = x2, l2[3] = C, l2[4] = D2, l2[5] = L, l2;
    }
    function LS(l2, a, e2) {
      return l2[0] = a[0], l2[1] = a[1], l2[2] = a[2], l2[3] = a[3], l2[4] = a[4] + e2[0], l2[5] = a[5] + e2[1], l2;
    }
    function oO(l2, a, e2) {
      var d2 = a[0], y2 = a[2], x2 = a[4], C = a[1], D2 = a[3], L = a[5], F3 = Math.sin(e2), j = Math.cos(e2);
      return l2[0] = d2 * j + C * F3, l2[1] = -d2 * F3 + C * j, l2[2] = y2 * j + D2 * F3, l2[3] = -y2 * F3 + j * D2, l2[4] = j * x2 + F3 * L, l2[5] = j * L - F3 * x2, l2;
    }
    function KU(l2, a, e2) {
      var d2 = e2[0], y2 = e2[1];
      return l2[0] = a[0] * d2, l2[1] = a[1] * y2, l2[2] = a[2] * d2, l2[3] = a[3] * y2, l2[4] = a[4] * d2, l2[5] = a[5] * y2, l2;
    }
    function sO(l2, a) {
      var e2 = a[0], d2 = a[2], y2 = a[4], x2 = a[1], C = a[3], D2 = a[5], L = e2 * C - x2 * d2;
      return L ? (L = 1 / L, l2[0] = C * L, l2[1] = -x2 * L, l2[2] = -d2 * L, l2[3] = e2 * L, l2[4] = (d2 * D2 - C * y2) * L, l2[5] = (x2 * y2 - e2 * D2) * L, l2) : null;
    }
    function V5t(l2) {
      var a = Xx();
      return YU(a, l2), a;
    }
    var Yet = OV, Tvt = 5e-5;
    function wE(l2) {
      return l2 > Tvt || l2 < -Tvt;
    }
    var z5 = [], j5 = [], Ket = Xx(), RV = Math.abs, rh2 = function() {
      function l2() {
      }
      return l2.prototype.getLocalTransform = function(a) {
        return l2.getLocalTransform(this, a);
      }, l2.prototype.setPosition = function(a) {
        this.x = a[0], this.y = a[1];
      }, l2.prototype.setScale = function(a) {
        this.scaleX = a[0], this.scaleY = a[1];
      }, l2.prototype.setSkew = function(a) {
        this.skewX = a[0], this.skewY = a[1];
      }, l2.prototype.setOrigin = function(a) {
        this.originX = a[0], this.originY = a[1];
      }, l2.prototype.needLocalTransform = function() {
        return wE(this.rotation) || wE(this.x) || wE(this.y) || wE(this.scaleX - 1) || wE(this.scaleY - 1) || wE(this.skewX) || wE(this.skewY);
      }, l2.prototype.updateTransform = function() {
        var a = this.parent && this.parent.transform, e2 = this.needLocalTransform(), d2 = this.transform;
        if (!(e2 || a)) {
          d2 && Yet(d2);
          return;
        }
        d2 = d2 || Xx(), e2 ? this.getLocalTransform(d2) : Yet(d2), a && (e2 ? lA(d2, a, d2) : YU(d2, a)), this.transform = d2, this._resolveGlobalScaleRatio(d2);
      }, l2.prototype._resolveGlobalScaleRatio = function(a) {
        var e2 = this.globalScaleRatio;
        if (e2 != null && e2 !== 1) {
          this.getGlobalScale(z5);
          var d2 = z5[0] < 0 ? -1 : 1, y2 = z5[1] < 0 ? -1 : 1, x2 = ((z5[0] - d2) * e2 + d2) / z5[0] || 0, C = ((z5[1] - y2) * e2 + y2) / z5[1] || 0;
          a[0] *= x2, a[1] *= x2, a[2] *= C, a[3] *= C;
        }
        this.invTransform = this.invTransform || Xx(), sO(this.invTransform, a);
      }, l2.prototype.getComputedTransform = function() {
        for (var a = this, e2 = []; a; )
          e2.push(a), a = a.parent;
        for (; a = e2.pop(); )
          a.updateTransform();
        return this.transform;
      }, l2.prototype.setLocalTransform = function(a) {
        if (a) {
          var e2 = a[0] * a[0] + a[1] * a[1], d2 = a[2] * a[2] + a[3] * a[3], y2 = Math.atan2(a[1], a[0]), x2 = Math.PI / 2 + y2 - Math.atan2(a[3], a[2]);
          d2 = Math.sqrt(d2) * Math.cos(x2), e2 = Math.sqrt(e2), this.skewX = x2, this.skewY = 0, this.rotation = -y2, this.x = +a[4], this.y = +a[5], this.scaleX = e2, this.scaleY = d2, this.originX = 0, this.originY = 0;
        }
      }, l2.prototype.decomposeTransform = function() {
        if (this.transform) {
          var a = this.parent, e2 = this.transform;
          a && a.transform && (lA(j5, a.invTransform, e2), e2 = j5);
          var d2 = this.originX, y2 = this.originY;
          (d2 || y2) && (Ket[4] = d2, Ket[5] = y2, lA(j5, e2, Ket), j5[4] -= d2, j5[5] -= y2, e2 = j5), this.setLocalTransform(e2);
        }
      }, l2.prototype.getGlobalScale = function(a) {
        var e2 = this.transform;
        return a = a || [], e2 ? (a[0] = Math.sqrt(e2[0] * e2[0] + e2[1] * e2[1]), a[1] = Math.sqrt(e2[2] * e2[2] + e2[3] * e2[3]), e2[0] < 0 && (a[0] = -a[0]), e2[3] < 0 && (a[1] = -a[1]), a) : (a[0] = 1, a[1] = 1, a);
      }, l2.prototype.transformCoordToLocal = function(a, e2) {
        var d2 = [a, e2], y2 = this.invTransform;
        return y2 && Mm(d2, d2, y2), d2;
      }, l2.prototype.transformCoordToGlobal = function(a, e2) {
        var d2 = [a, e2], y2 = this.transform;
        return y2 && Mm(d2, d2, y2), d2;
      }, l2.prototype.getLineScale = function() {
        var a = this.transform;
        return a && RV(a[0] - 1) > 1e-10 && RV(a[3] - 1) > 1e-10 ? Math.sqrt(RV(a[0] * a[3] - a[2] * a[1])) : 1;
      }, l2.prototype.copyTransform = function(a) {
        Avt(this, a);
      }, l2.getLocalTransform = function(a, e2) {
        e2 = e2 || [];
        var d2 = a.originX || 0, y2 = a.originY || 0, x2 = a.scaleX, C = a.scaleY, D2 = a.anchorX, L = a.anchorY, F3 = a.rotation || 0, j = a.x, U3 = a.y, Y3 = a.skewX ? Math.tan(a.skewX) : 0, Q = a.skewY ? Math.tan(-a.skewY) : 0;
        if (d2 || y2 || D2 || L) {
          var nt = d2 + D2, dt = y2 + L;
          e2[4] = -nt * x2 - Y3 * dt * C, e2[5] = -dt * C - Q * nt * x2;
        } else
          e2[4] = e2[5] = 0;
        return e2[0] = x2, e2[3] = C, e2[1] = Q * x2, e2[2] = Y3 * C, F3 && oO(e2, e2, F3), e2[4] += d2 + j, e2[5] += y2 + U3, e2;
      }, l2.initDefaultProps = function() {
        var a = l2.prototype;
        a.scaleX = a.scaleY = a.globalScaleRatio = 1, a.x = a.y = a.originX = a.originY = a.skewX = a.skewY = a.rotation = a.anchorX = a.anchorY = 0;
      }(), l2;
    }(), uA = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
    function Avt(l2, a) {
      for (var e2 = 0; e2 < uA.length; e2++) {
        var d2 = uA[e2];
        l2[d2] = a[d2];
      }
    }
    var OS = rh2, Ivt = function() {
      function l2(a, e2) {
        this.x = a || 0, this.y = e2 || 0;
      }
      return l2.prototype.copy = function(a) {
        return this.x = a.x, this.y = a.y, this;
      }, l2.prototype.clone = function() {
        return new l2(this.x, this.y);
      }, l2.prototype.set = function(a, e2) {
        return this.x = a, this.y = e2, this;
      }, l2.prototype.equal = function(a) {
        return a.x === this.x && a.y === this.y;
      }, l2.prototype.add = function(a) {
        return this.x += a.x, this.y += a.y, this;
      }, l2.prototype.scale = function(a) {
        this.x *= a, this.y *= a;
      }, l2.prototype.scaleAndAdd = function(a, e2) {
        this.x += a.x * e2, this.y += a.y * e2;
      }, l2.prototype.sub = function(a) {
        return this.x -= a.x, this.y -= a.y, this;
      }, l2.prototype.dot = function(a) {
        return this.x * a.x + this.y * a.y;
      }, l2.prototype.len = function() {
        return Math.sqrt(this.x * this.x + this.y * this.y);
      }, l2.prototype.lenSquare = function() {
        return this.x * this.x + this.y * this.y;
      }, l2.prototype.normalize = function() {
        var a = this.len();
        return this.x /= a, this.y /= a, this;
      }, l2.prototype.distance = function(a) {
        var e2 = this.x - a.x, d2 = this.y - a.y;
        return Math.sqrt(e2 * e2 + d2 * d2);
      }, l2.prototype.distanceSquare = function(a) {
        var e2 = this.x - a.x, d2 = this.y - a.y;
        return e2 * e2 + d2 * d2;
      }, l2.prototype.negate = function() {
        return this.x = -this.x, this.y = -this.y, this;
      }, l2.prototype.transform = function(a) {
        if (a) {
          var e2 = this.x, d2 = this.y;
          return this.x = a[0] * e2 + a[2] * d2 + a[4], this.y = a[1] * e2 + a[3] * d2 + a[5], this;
        }
      }, l2.prototype.toArray = function(a) {
        return a[0] = this.x, a[1] = this.y, a;
      }, l2.prototype.fromArray = function(a) {
        this.x = a[0], this.y = a[1];
      }, l2.set = function(a, e2, d2) {
        a.x = e2, a.y = d2;
      }, l2.copy = function(a, e2) {
        a.x = e2.x, a.y = e2.y;
      }, l2.len = function(a) {
        return Math.sqrt(a.x * a.x + a.y * a.y);
      }, l2.lenSquare = function(a) {
        return a.x * a.x + a.y * a.y;
      }, l2.dot = function(a, e2) {
        return a.x * e2.x + a.y * e2.y;
      }, l2.add = function(a, e2, d2) {
        a.x = e2.x + d2.x, a.y = e2.y + d2.y;
      }, l2.sub = function(a, e2, d2) {
        a.x = e2.x - d2.x, a.y = e2.y - d2.y;
      }, l2.scale = function(a, e2, d2) {
        a.x = e2.x * d2, a.y = e2.y * d2;
      }, l2.scaleAndAdd = function(a, e2, d2, y2) {
        a.x = e2.x + d2.x * y2, a.y = e2.y + d2.y * y2;
      }, l2.lerp = function(a, e2, d2, y2) {
        var x2 = 1 - y2;
        a.x = x2 * e2.x + y2 * d2.x, a.y = x2 * e2.y + y2 * d2.y;
      }, l2;
    }(), Nu = Ivt, XU = Math.min, D_ = Math.max, lO = new Nu(), cA = new Nu(), SE = new Nu(), W5 = new Nu(), kN = new Nu(), g1 = new Nu(), G5 = function() {
      function l2(a, e2, d2, y2) {
        d2 < 0 && (a = a + d2, d2 = -d2), y2 < 0 && (e2 = e2 + y2, y2 = -y2), this.x = a, this.y = e2, this.width = d2, this.height = y2;
      }
      return l2.prototype.union = function(a) {
        var e2 = XU(a.x, this.x), d2 = XU(a.y, this.y);
        isFinite(this.x) && isFinite(this.width) ? this.width = D_(a.x + a.width, this.x + this.width) - e2 : this.width = a.width, isFinite(this.y) && isFinite(this.height) ? this.height = D_(a.y + a.height, this.y + this.height) - d2 : this.height = a.height, this.x = e2, this.y = d2;
      }, l2.prototype.applyTransform = function(a) {
        l2.applyTransform(this, this, a);
      }, l2.prototype.calculateTransform = function(a) {
        var e2 = this, d2 = a.width / e2.width, y2 = a.height / e2.height, x2 = Xx();
        return LS(x2, x2, [-e2.x, -e2.y]), KU(x2, x2, [d2, y2]), LS(x2, x2, [a.x, a.y]), x2;
      }, l2.prototype.intersect = function(a, e2) {
        if (!a)
          return false;
        a instanceof l2 || (a = l2.create(a));
        var d2 = this, y2 = d2.x, x2 = d2.x + d2.width, C = d2.y, D2 = d2.y + d2.height, L = a.x, F3 = a.x + a.width, j = a.y, U3 = a.y + a.height, Y3 = !(x2 < L || F3 < y2 || D2 < j || U3 < C);
        if (e2) {
          var Q = 1 / 0, nt = 0, dt = Math.abs(x2 - L), vt = Math.abs(F3 - y2), Ct = Math.abs(D2 - j), Pt = Math.abs(U3 - C), jt = Math.min(dt, vt), Rt = Math.min(Ct, Pt);
          x2 < L || F3 < y2 ? jt > nt && (nt = jt, dt < vt ? Nu.set(g1, -dt, 0) : Nu.set(g1, vt, 0)) : jt < Q && (Q = jt, dt < vt ? Nu.set(kN, dt, 0) : Nu.set(kN, -vt, 0)), D2 < j || U3 < C ? Rt > nt && (nt = Rt, Ct < Pt ? Nu.set(g1, 0, -Ct) : Nu.set(g1, 0, Pt)) : jt < Q && (Q = jt, Ct < Pt ? Nu.set(kN, 0, Ct) : Nu.set(kN, 0, -Pt));
        }
        return e2 && Nu.copy(e2, Y3 ? kN : g1), Y3;
      }, l2.prototype.contain = function(a, e2) {
        var d2 = this;
        return a >= d2.x && a <= d2.x + d2.width && e2 >= d2.y && e2 <= d2.y + d2.height;
      }, l2.prototype.clone = function() {
        return new l2(this.x, this.y, this.width, this.height);
      }, l2.prototype.copy = function(a) {
        l2.copy(this, a);
      }, l2.prototype.plain = function() {
        return { x: this.x, y: this.y, width: this.width, height: this.height };
      }, l2.prototype.isFinite = function() {
        return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
      }, l2.prototype.isZero = function() {
        return this.width === 0 || this.height === 0;
      }, l2.create = function(a) {
        return new l2(a.x, a.y, a.width, a.height);
      }, l2.copy = function(a, e2) {
        a.x = e2.x, a.y = e2.y, a.width = e2.width, a.height = e2.height;
      }, l2.applyTransform = function(a, e2, d2) {
        if (!d2) {
          a !== e2 && l2.copy(a, e2);
          return;
        }
        if (d2[1] < 1e-5 && d2[1] > -1e-5 && d2[2] < 1e-5 && d2[2] > -1e-5) {
          var y2 = d2[0], x2 = d2[3], C = d2[4], D2 = d2[5];
          a.x = e2.x * y2 + C, a.y = e2.y * x2 + D2, a.width = e2.width * y2, a.height = e2.height * x2, a.width < 0 && (a.x += a.width, a.width = -a.width), a.height < 0 && (a.y += a.height, a.height = -a.height);
          return;
        }
        lO.x = SE.x = e2.x, lO.y = W5.y = e2.y, cA.x = W5.x = e2.x + e2.width, cA.y = SE.y = e2.y + e2.height, lO.transform(d2), W5.transform(d2), cA.transform(d2), SE.transform(d2), a.x = XU(lO.x, cA.x, SE.x, W5.x), a.y = XU(lO.y, cA.y, SE.y, W5.y);
        var L = D_(lO.x, cA.x, SE.x, W5.x), F3 = D_(lO.y, cA.y, SE.y, W5.y);
        a.width = L - a.x, a.height = F3 - a.y;
      }, l2;
    }(), Yu = G5, Xet = {};
    function _b2(l2, a) {
      a = a || Ru;
      var e2 = Xet[a];
      e2 || (e2 = Xet[a] = new TV(500));
      var d2 = e2.get(l2);
      return d2 == null && (d2 = Zx.measureText(l2, a).width, e2.put(l2, d2)), d2;
    }
    function Qet(l2, a, e2, d2) {
      var y2 = _b2(l2, a), x2 = LN(a), C = PN(0, y2, e2), D2 = H5(0, x2, d2), L = new Yu(C, D2, y2, x2);
      return L;
    }
    function uO(l2, a, e2, d2) {
      var y2 = ((l2 || "") + "").split(`
`), x2 = y2.length;
      if (x2 === 1)
        return Qet(y2[0], a, e2, d2);
      for (var C = new Yu(0, 0, 0, 0), D2 = 0; D2 < y2.length; D2++) {
        var L = Qet(y2[D2], a, e2, d2);
        D2 === 0 ? C.copy(L) : C.union(L);
      }
      return C;
    }
    function PN(l2, a, e2) {
      return e2 === "right" ? l2 -= a : e2 === "center" && (l2 -= a / 2), l2;
    }
    function H5(l2, a, e2) {
      return e2 === "middle" ? l2 -= a / 2 : e2 === "bottom" && (l2 -= a), l2;
    }
    function LN(l2) {
      return _b2("\u56FD", l2);
    }
    function Tm(l2, a) {
      return typeof l2 == "string" ? l2.lastIndexOf("%") >= 0 ? parseFloat(l2) / 100 * a : parseFloat(l2) : l2;
    }
    function QU(l2, a, e2) {
      var d2 = a.position || "inside", y2 = a.distance != null ? a.distance : 5, x2 = e2.height, C = e2.width, D2 = x2 / 2, L = e2.x, F3 = e2.y, j = "left", U3 = "top";
      if (d2 instanceof Array)
        L += Tm(d2[0], e2.width), F3 += Tm(d2[1], e2.height), j = null, U3 = null;
      else
        switch (d2) {
          case "left":
            L -= y2, F3 += D2, j = "right", U3 = "middle";
            break;
          case "right":
            L += y2 + C, F3 += D2, U3 = "middle";
            break;
          case "top":
            L += C / 2, F3 -= y2, j = "center", U3 = "bottom";
            break;
          case "bottom":
            L += C / 2, F3 += x2 + y2, j = "center";
            break;
          case "inside":
            L += C / 2, F3 += D2, j = "center", U3 = "middle";
            break;
          case "insideLeft":
            L += y2, F3 += D2, U3 = "middle";
            break;
          case "insideRight":
            L += C - y2, F3 += D2, j = "right", U3 = "middle";
            break;
          case "insideTop":
            L += C / 2, F3 += y2, j = "center";
            break;
          case "insideBottom":
            L += C / 2, F3 += x2 - y2, j = "center", U3 = "bottom";
            break;
          case "insideTopLeft":
            L += y2, F3 += y2;
            break;
          case "insideTopRight":
            L += C - y2, F3 += y2, j = "right";
            break;
          case "insideBottomLeft":
            L += y2, F3 += x2 - y2, U3 = "bottom";
            break;
          case "insideBottomRight":
            L += C - y2, F3 += x2 - y2, j = "right", U3 = "bottom";
            break;
        }
      return l2 = l2 || {}, l2.x = L, l2.y = F3, l2.align = j, l2.verticalAlign = U3, l2;
    }
    var fA = "__zr_normal__", JU = uA.concat(["ignore"]), Dvt = tA(uA, function(l2, a) {
      return l2[a] = true, l2;
    }, { ignore: false }), U5 = {}, B5t = new Yu(0, 0, 0, 0), Jet = function() {
      function l2(a) {
        this.id = uN(), this.animators = [], this.currentStates = [], this.states = {}, this._init(a);
      }
      return l2.prototype._init = function(a) {
        this.attr(a);
      }, l2.prototype.drift = function(a, e2, d2) {
        switch (this.draggable) {
          case "horizontal":
            e2 = 0;
            break;
          case "vertical":
            a = 0;
            break;
        }
        var y2 = this.transform;
        y2 || (y2 = this.transform = [1, 0, 0, 1, 0, 0]), y2[4] += a, y2[5] += e2, this.decomposeTransform(), this.markRedraw();
      }, l2.prototype.beforeUpdate = function() {
      }, l2.prototype.afterUpdate = function() {
      }, l2.prototype.update = function() {
        this.updateTransform(), this.__dirty && this.updateInnerText();
      }, l2.prototype.updateInnerText = function(a) {
        var e2 = this._textContent;
        if (e2 && (!e2.ignore || a)) {
          this.textConfig || (this.textConfig = {});
          var d2 = this.textConfig, y2 = d2.local, x2 = e2.innerTransformable, C = void 0, D2 = void 0, L = false;
          x2.parent = y2 ? this : null;
          var F3 = false;
          if (x2.copyTransform(e2), d2.position != null) {
            var j = B5t;
            d2.layoutRect ? j.copy(d2.layoutRect) : j.copy(this.getBoundingRect()), y2 || j.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(U5, d2, j) : QU(U5, d2, j), x2.x = U5.x, x2.y = U5.y, C = U5.align, D2 = U5.verticalAlign;
            var U3 = d2.origin;
            if (U3 && d2.rotation != null) {
              var Y3 = void 0, Q = void 0;
              U3 === "center" ? (Y3 = j.width * 0.5, Q = j.height * 0.5) : (Y3 = Tm(U3[0], j.width), Q = Tm(U3[1], j.height)), F3 = true, x2.originX = -x2.x + Y3 + (y2 ? 0 : j.x), x2.originY = -x2.y + Q + (y2 ? 0 : j.y);
            }
          }
          d2.rotation != null && (x2.rotation = d2.rotation);
          var nt = d2.offset;
          nt && (x2.x += nt[0], x2.y += nt[1], F3 || (x2.originX = -nt[0], x2.originY = -nt[1]));
          var dt = d2.inside == null ? typeof d2.position == "string" && d2.position.indexOf("inside") >= 0 : d2.inside, vt = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), Ct = void 0, Pt = void 0, jt = void 0;
          dt && this.canBeInsideText() ? (Ct = d2.insideFill, Pt = d2.insideStroke, (Ct == null || Ct === "auto") && (Ct = this.getInsideTextFill()), (Pt == null || Pt === "auto") && (Pt = this.getInsideTextStroke(Ct), jt = true)) : (Ct = d2.outsideFill, Pt = d2.outsideStroke, (Ct == null || Ct === "auto") && (Ct = this.getOutsideFill()), (Pt == null || Pt === "auto") && (Pt = this.getOutsideStroke(Ct), jt = true)), Ct = Ct || "#000", (Ct !== vt.fill || Pt !== vt.stroke || jt !== vt.autoStroke || C !== vt.align || D2 !== vt.verticalAlign) && (L = true, vt.fill = Ct, vt.stroke = Pt, vt.autoStroke = jt, vt.align = C, vt.verticalAlign = D2, e2.setDefaultTextStyle(vt)), e2.__dirty |= yb2, L && e2.dirtyStyle(true);
        }
      }, l2.prototype.canBeInsideText = function() {
        return true;
      }, l2.prototype.getInsideTextFill = function() {
        return "#fff";
      }, l2.prototype.getInsideTextStroke = function(a) {
        return "#000";
      }, l2.prototype.getOutsideFill = function() {
        return this.__zr && this.__zr.isDarkMode() ? LV : $U;
      }, l2.prototype.getOutsideStroke = function(a) {
        var e2 = this.__zr && this.__zr.getBackgroundColor(), d2 = typeof e2 == "string" && kS(e2);
        d2 || (d2 = [255, 255, 255, 1]);
        for (var y2 = d2[3], x2 = this.__zr.isDarkMode(), C = 0; C < 3; C++)
          d2[C] = d2[C] * y2 + (x2 ? 0 : 255) * (1 - y2);
        return d2[3] = 1, d1(d2, "rgba");
      }, l2.prototype.traverse = function(a, e2) {
      }, l2.prototype.attrKV = function(a, e2) {
        a === "textConfig" ? this.setTextConfig(e2) : a === "textContent" ? this.setTextContent(e2) : a === "clipPath" ? this.setClipPath(e2) : a === "extra" ? (this.extra = this.extra || {}, la2(this.extra, e2)) : this[a] = e2;
      }, l2.prototype.hide = function() {
        this.ignore = true, this.markRedraw();
      }, l2.prototype.show = function() {
        this.ignore = false, this.markRedraw();
      }, l2.prototype.attr = function(a, e2) {
        if (typeof a == "string")
          this.attrKV(a, e2);
        else if (vs(a))
          for (var d2 = a, y2 = Qc2(d2), x2 = 0; x2 < y2.length; x2++) {
            var C = y2[x2];
            this.attrKV(C, a[C]);
          }
        return this.markRedraw(), this;
      }, l2.prototype.saveCurrentToNormalState = function(a) {
        this._innerSaveToNormal(a);
        for (var e2 = this._normalState, d2 = 0; d2 < this.animators.length; d2++) {
          var y2 = this.animators[d2], x2 = y2.__fromStateTransition;
          if (!(y2.getLoop() || x2 && x2 !== fA)) {
            var C = y2.targetName, D2 = C ? e2[C] : e2;
            y2.saveTo(D2);
          }
        }
      }, l2.prototype._innerSaveToNormal = function(a) {
        var e2 = this._normalState;
        e2 || (e2 = this._normalState = {}), a.textConfig && !e2.textConfig && (e2.textConfig = this.textConfig), this._savePrimaryToNormal(a, e2, JU);
      }, l2.prototype._savePrimaryToNormal = function(a, e2, d2) {
        for (var y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2];
          a[x2] != null && !(x2 in e2) && (e2[x2] = this[x2]);
        }
      }, l2.prototype.hasState = function() {
        return this.currentStates.length > 0;
      }, l2.prototype.getState = function(a) {
        return this.states[a];
      }, l2.prototype.ensureState = function(a) {
        var e2 = this.states;
        return e2[a] || (e2[a] = {}), e2[a];
      }, l2.prototype.clearStates = function(a) {
        this.useState(fA, false, a);
      }, l2.prototype.useState = function(a, e2, d2, y2) {
        var x2 = a === fA, C = this.hasState();
        if (!(!C && x2)) {
          var D2 = this.currentStates, L = this.stateTransition;
          if (!(oc2(D2, a) >= 0 && (e2 || D2.length === 1))) {
            var F3;
            if (this.stateProxy && !x2 && (F3 = this.stateProxy(a)), F3 || (F3 = this.states && this.states[a]), !F3 && !x2) {
              fV("State " + a + " not exists.");
              return;
            }
            x2 || this.saveCurrentToNormalState(F3);
            var j = !!(F3 && F3.hoverLayer || y2);
            j && this._toggleHoverLayerFlag(true), this._applyStateObj(a, F3, this._normalState, e2, !d2 && !this.__inHover && L && L.duration > 0, L);
            var U3 = this._textContent, Y3 = this._textGuide;
            return U3 && U3.useState(a, e2, d2, j), Y3 && Y3.useState(a, e2, d2, j), x2 ? (this.currentStates = [], this._normalState = {}) : e2 ? this.currentStates.push(a) : this.currentStates = [a], this._updateAnimationTargets(), this.markRedraw(), !j && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~yb2), F3;
          }
        }
      }, l2.prototype.useStates = function(a, e2, d2) {
        if (!a.length)
          this.clearStates();
        else {
          var y2 = [], x2 = this.currentStates, C = a.length, D2 = C === x2.length;
          if (D2) {
            for (var L = 0; L < C; L++)
              if (a[L] !== x2[L]) {
                D2 = false;
                break;
              }
          }
          if (D2)
            return;
          for (var L = 0; L < C; L++) {
            var F3 = a[L], j = void 0;
            this.stateProxy && (j = this.stateProxy(F3, a)), j || (j = this.states[F3]), j && y2.push(j);
          }
          var U3 = y2[C - 1], Y3 = !!(U3 && U3.hoverLayer || d2);
          Y3 && this._toggleHoverLayerFlag(true);
          var Q = this._mergeStates(y2), nt = this.stateTransition;
          this.saveCurrentToNormalState(Q), this._applyStateObj(a.join(","), Q, this._normalState, false, !e2 && !this.__inHover && nt && nt.duration > 0, nt);
          var dt = this._textContent, vt = this._textGuide;
          dt && dt.useStates(a, e2, Y3), vt && vt.useStates(a, e2, Y3), this._updateAnimationTargets(), this.currentStates = a.slice(), this.markRedraw(), !Y3 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~yb2);
        }
      }, l2.prototype._updateAnimationTargets = function() {
        for (var a = 0; a < this.animators.length; a++) {
          var e2 = this.animators[a];
          e2.targetName && e2.changeTarget(this[e2.targetName]);
        }
      }, l2.prototype.removeState = function(a) {
        var e2 = oc2(this.currentStates, a);
        if (e2 >= 0) {
          var d2 = this.currentStates.slice();
          d2.splice(e2, 1), this.useStates(d2);
        }
      }, l2.prototype.replaceState = function(a, e2, d2) {
        var y2 = this.currentStates.slice(), x2 = oc2(y2, a), C = oc2(y2, e2) >= 0;
        x2 >= 0 ? C ? y2.splice(x2, 1) : y2[x2] = e2 : d2 && !C && y2.push(e2), this.useStates(y2);
      }, l2.prototype.toggleState = function(a, e2) {
        e2 ? this.useState(a, true) : this.removeState(a);
      }, l2.prototype._mergeStates = function(a) {
        for (var e2 = {}, d2, y2 = 0; y2 < a.length; y2++) {
          var x2 = a[y2];
          la2(e2, x2), x2.textConfig && (d2 = d2 || {}, la2(d2, x2.textConfig));
        }
        return d2 && (e2.textConfig = d2), e2;
      }, l2.prototype._applyStateObj = function(a, e2, d2, y2, x2, C) {
        var D2 = !(e2 && y2);
        e2 && e2.textConfig ? (this.textConfig = la2({}, y2 ? this.textConfig : d2.textConfig), la2(this.textConfig, e2.textConfig)) : D2 && d2.textConfig && (this.textConfig = d2.textConfig);
        for (var L = {}, F3 = false, j = 0; j < JU.length; j++) {
          var U3 = JU[j], Y3 = x2 && Dvt[U3];
          e2 && e2[U3] != null ? Y3 ? (F3 = true, L[U3] = e2[U3]) : this[U3] = e2[U3] : D2 && d2[U3] != null && (Y3 ? (F3 = true, L[U3] = d2[U3]) : this[U3] = d2[U3]);
        }
        if (!x2)
          for (var j = 0; j < this.animators.length; j++) {
            var Q = this.animators[j], nt = Q.targetName;
            Q.getLoop() || Q.__changeFinalValue(nt ? (e2 || d2)[nt] : e2 || d2);
          }
        F3 && this._transitionState(a, L, C);
      }, l2.prototype._attachComponent = function(a) {
        if (!(a.__zr && !a.__hostTarget) && a !== this) {
          var e2 = this.__zr;
          e2 && a.addSelfToZr(e2), a.__zr = e2, a.__hostTarget = this;
        }
      }, l2.prototype._detachComponent = function(a) {
        a.__zr && a.removeSelfFromZr(a.__zr), a.__zr = null, a.__hostTarget = null;
      }, l2.prototype.getClipPath = function() {
        return this._clipPath;
      }, l2.prototype.setClipPath = function(a) {
        this._clipPath && this._clipPath !== a && this.removeClipPath(), this._attachComponent(a), this._clipPath = a, this.markRedraw();
      }, l2.prototype.removeClipPath = function() {
        var a = this._clipPath;
        a && (this._detachComponent(a), this._clipPath = null, this.markRedraw());
      }, l2.prototype.getTextContent = function() {
        return this._textContent;
      }, l2.prototype.setTextContent = function(a) {
        var e2 = this._textContent;
        e2 !== a && (e2 && e2 !== a && this.removeTextContent(), a.innerTransformable = new OS(), this._attachComponent(a), this._textContent = a, this.markRedraw());
      }, l2.prototype.setTextConfig = function(a) {
        this.textConfig || (this.textConfig = {}), la2(this.textConfig, a), this.markRedraw();
      }, l2.prototype.removeTextConfig = function() {
        this.textConfig = null, this.markRedraw();
      }, l2.prototype.removeTextContent = function() {
        var a = this._textContent;
        a && (a.innerTransformable = null, this._detachComponent(a), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
      }, l2.prototype.getTextGuideLine = function() {
        return this._textGuide;
      }, l2.prototype.setTextGuideLine = function(a) {
        this._textGuide && this._textGuide !== a && this.removeTextGuideLine(), this._attachComponent(a), this._textGuide = a, this.markRedraw();
      }, l2.prototype.removeTextGuideLine = function() {
        var a = this._textGuide;
        a && (this._detachComponent(a), this._textGuide = null, this.markRedraw());
      }, l2.prototype.markRedraw = function() {
        this.__dirty |= yb2;
        var a = this.__zr;
        a && (this.__inHover ? a.refreshHover() : a.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
      }, l2.prototype.dirty = function() {
        this.markRedraw();
      }, l2.prototype._toggleHoverLayerFlag = function(a) {
        this.__inHover = a;
        var e2 = this._textContent, d2 = this._textGuide;
        e2 && (e2.__inHover = a), d2 && (d2.__inHover = a);
      }, l2.prototype.addSelfToZr = function(a) {
        if (this.__zr !== a) {
          this.__zr = a;
          var e2 = this.animators;
          if (e2)
            for (var d2 = 0; d2 < e2.length; d2++)
              a.animation.addAnimator(e2[d2]);
          this._clipPath && this._clipPath.addSelfToZr(a), this._textContent && this._textContent.addSelfToZr(a), this._textGuide && this._textGuide.addSelfToZr(a);
        }
      }, l2.prototype.removeSelfFromZr = function(a) {
        if (this.__zr) {
          this.__zr = null;
          var e2 = this.animators;
          if (e2)
            for (var d2 = 0; d2 < e2.length; d2++)
              a.animation.removeAnimator(e2[d2]);
          this._clipPath && this._clipPath.removeSelfFromZr(a), this._textContent && this._textContent.removeSelfFromZr(a), this._textGuide && this._textGuide.removeSelfFromZr(a);
        }
      }, l2.prototype.animate = function(a, e2, d2) {
        var y2 = a ? this[a] : this, x2 = new Wy(y2, e2, d2);
        return a && (x2.targetName = a), this.addAnimator(x2, a), x2;
      }, l2.prototype.addAnimator = function(a, e2) {
        var d2 = this.__zr, y2 = this;
        a.during(function() {
          y2.updateDuringAnimation(e2);
        }).done(function() {
          var x2 = y2.animators, C = oc2(x2, a);
          C >= 0 && x2.splice(C, 1);
        }), this.animators.push(a), d2 && d2.animation.addAnimator(a), d2 && d2.wakeUp();
      }, l2.prototype.updateDuringAnimation = function(a) {
        this.markRedraw();
      }, l2.prototype.stopAnimation = function(a, e2) {
        for (var d2 = this.animators, y2 = d2.length, x2 = [], C = 0; C < y2; C++) {
          var D2 = d2[C];
          !a || a === D2.scope ? D2.stop(e2) : x2.push(D2);
        }
        return this.animators = x2, this;
      }, l2.prototype.animateTo = function(a, e2, d2) {
        tnt(this, a, e2, d2);
      }, l2.prototype.animateFrom = function(a, e2, d2) {
        tnt(this, a, e2, d2, true);
      }, l2.prototype._transitionState = function(a, e2, d2, y2) {
        for (var x2 = tnt(this, e2, d2, y2), C = 0; C < x2.length; C++)
          x2[C].__fromStateTransition = a;
      }, l2.prototype.getBoundingRect = function() {
        return null;
      }, l2.prototype.getPaintRect = function() {
        return null;
      }, l2.initDefaultProps = function() {
        var a = l2.prototype;
        a.type = "element", a.name = "", a.ignore = a.silent = a.isGroup = a.draggable = a.dragging = a.ignoreClip = a.__inHover = false, a.__dirty = yb2;
        function e2(d2, y2, x2, C) {
          Object.defineProperty(a, d2, { get: function() {
            if (!this[y2]) {
              var L = this[y2] = [];
              D2(this, L);
            }
            return this[y2];
          }, set: function(L) {
            this[x2] = L[0], this[C] = L[1], this[y2] = L, D2(this, L);
          } });
          function D2(L, F3) {
            Object.defineProperty(F3, 0, { get: function() {
              return L[x2];
            }, set: function(j) {
              L[x2] = j;
            } }), Object.defineProperty(F3, 1, { get: function() {
              return L[C];
            }, set: function(j) {
              L[C] = j;
            } });
          }
        }
        Object.defineProperty && (e2("position", "_legacyPos", "x", "y"), e2("scale", "_legacyScale", "scaleX", "scaleY"), e2("origin", "_legacyOrigin", "originX", "originY"));
      }(), l2;
    }();
    v0(Jet, Yx), v0(Jet, OS);
    function tnt(l2, a, e2, d2, y2) {
      e2 = e2 || {};
      var x2 = [];
      E_(l2, "", l2, a, e2, d2, x2, y2);
      var C = x2.length, D2 = false, L = e2.done, F3 = e2.aborted, j = function() {
        D2 = true, C--, C <= 0 && (D2 ? L && L() : F3 && F3());
      }, U3 = function() {
        C--, C <= 0 && (D2 ? L && L() : F3 && F3());
      };
      C || L && L(), x2.length > 0 && e2.during && x2[0].during(function(nt, dt) {
        e2.during(dt);
      });
      for (var Y3 = 0; Y3 < x2.length; Y3++) {
        var Q = x2[Y3];
        j && Q.done(j), U3 && Q.aborted(U3), e2.force && Q.duration(e2.duration), Q.start(e2.easing);
      }
      return x2;
    }
    function tq(l2, a, e2) {
      for (var d2 = 0; d2 < e2; d2++)
        l2[d2] = a[d2];
    }
    function Evt(l2) {
      return h1(l2[0]);
    }
    function z5t(l2, a, e2) {
      if (h1(a[e2]))
        if (h1(l2[e2]) || (l2[e2] = []), CS(a[e2])) {
          var d2 = a[e2].length;
          l2[e2].length !== d2 && (l2[e2] = new a[e2].constructor(d2), tq(l2[e2], a[e2], d2));
        } else {
          var y2 = a[e2], x2 = l2[e2], C = y2.length;
          if (Evt(y2))
            for (var D2 = y2[0].length, L = 0; L < C; L++)
              x2[L] ? tq(x2[L], y2[L], D2) : x2[L] = Array.prototype.slice.call(y2[L]);
          else
            tq(x2, y2, C);
          x2.length = y2.length;
        }
      else
        l2[e2] = a[e2];
    }
    function kvt(l2, a) {
      return l2 === a || h1(l2) && h1(a) && Pvt(l2, a);
    }
    function Pvt(l2, a) {
      var e2 = l2.length;
      if (e2 !== a.length)
        return false;
      for (var d2 = 0; d2 < e2; d2++)
        if (l2[d2] !== a[d2])
          return false;
      return true;
    }
    function E_(l2, a, e2, d2, y2, x2, C, D2) {
      for (var L = Qc2(d2), F3 = y2.duration, j = y2.delay, U3 = y2.additive, Y3 = y2.setToFinal, Q = !vs(x2), nt = l2.animators, dt = [], vt = 0; vt < L.length; vt++) {
        var Ct = L[vt], Pt = d2[Ct];
        if (Pt != null && e2[Ct] != null && (Q || x2[Ct]))
          if (vs(Pt) && !h1(Pt) && !DU(Pt)) {
            if (a) {
              D2 || (e2[Ct] = Pt, l2.updateDuringAnimation(a));
              continue;
            }
            E_(l2, Ct, e2[Ct], Pt, y2, x2 && x2[Ct], C, D2);
          } else
            dt.push(Ct);
        else
          D2 || (e2[Ct] = Pt, l2.updateDuringAnimation(a), dt.push(Ct));
      }
      var jt = dt.length;
      if (!U3 && jt)
        for (var Rt = 0; Rt < nt.length; Rt++) {
          var le2 = nt[Rt];
          if (le2.targetName === a) {
            var ne2 = le2.stopTracks(dt);
            if (ne2) {
              var he2 = oc2(nt, le2);
              nt.splice(he2, 1);
            }
          }
        }
      if (y2.force || (dt = Lp(dt, function(Be2) {
        return !kvt(d2[Be2], e2[Be2]);
      }), jt = dt.length), jt > 0 || y2.force && !C.length) {
        var _e = void 0, Me2 = void 0, Pe2 = void 0;
        if (D2) {
          Me2 = {}, Y3 && (_e = {});
          for (var Rt = 0; Rt < jt; Rt++) {
            var Ct = dt[Rt];
            Me2[Ct] = e2[Ct], Y3 ? _e[Ct] = d2[Ct] : e2[Ct] = d2[Ct];
          }
        } else if (Y3) {
          Pe2 = {};
          for (var Rt = 0; Rt < jt; Rt++) {
            var Ct = dt[Rt];
            Pe2[Ct] = PS(e2[Ct]), z5t(e2, d2, Ct);
          }
        }
        var le2 = new Wy(e2, false, false, U3 ? Lp(nt, function(Je2) {
          return Je2.targetName === a;
        }) : null);
        le2.targetName = a, y2.scope && (le2.scope = y2.scope), Y3 && _e && le2.whenWithKeys(0, _e, dt), Pe2 && le2.whenWithKeys(0, Pe2, dt), le2.whenWithKeys(F3 == null ? 500 : F3, D2 ? Me2 : d2, dt).delay(j || 0), l2.addAnimator(le2, a), C.push(le2);
      }
    }
    var cC = Jet, Lvt = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this) || this;
        return d2.isGroup = true, d2._children = [], d2.attr(e2), d2;
      }
      return a.prototype.childrenRef = function() {
        return this._children;
      }, a.prototype.children = function() {
        return this._children.slice();
      }, a.prototype.childAt = function(e2) {
        return this._children[e2];
      }, a.prototype.childOfName = function(e2) {
        for (var d2 = this._children, y2 = 0; y2 < d2.length; y2++)
          if (d2[y2].name === e2)
            return d2[y2];
      }, a.prototype.childCount = function() {
        return this._children.length;
      }, a.prototype.add = function(e2) {
        return e2 && e2 !== this && e2.parent !== this && (this._children.push(e2), this._doAdd(e2)), this;
      }, a.prototype.addBefore = function(e2, d2) {
        if (e2 && e2 !== this && e2.parent !== this && d2 && d2.parent === this) {
          var y2 = this._children, x2 = y2.indexOf(d2);
          x2 >= 0 && (y2.splice(x2, 0, e2), this._doAdd(e2));
        }
        return this;
      }, a.prototype.replace = function(e2, d2) {
        var y2 = oc2(this._children, e2);
        return y2 >= 0 && this.replaceAt(d2, y2), this;
      }, a.prototype.replaceAt = function(e2, d2) {
        var y2 = this._children, x2 = y2[d2];
        if (e2 && e2 !== this && e2.parent !== this && e2 !== x2) {
          y2[d2] = e2, x2.parent = null;
          var C = this.__zr;
          C && x2.removeSelfFromZr(C), this._doAdd(e2);
        }
        return this;
      }, a.prototype._doAdd = function(e2) {
        e2.parent && e2.parent.remove(e2), e2.parent = this;
        var d2 = this.__zr;
        d2 && d2 !== e2.__zr && e2.addSelfToZr(d2), d2 && d2.refresh();
      }, a.prototype.remove = function(e2) {
        var d2 = this.__zr, y2 = this._children, x2 = oc2(y2, e2);
        return x2 < 0 ? this : (y2.splice(x2, 1), e2.parent = null, d2 && e2.removeSelfFromZr(d2), d2 && d2.refresh(), this);
      }, a.prototype.removeAll = function() {
        for (var e2 = this._children, d2 = this.__zr, y2 = 0; y2 < e2.length; y2++) {
          var x2 = e2[y2];
          d2 && x2.removeSelfFromZr(d2), x2.parent = null;
        }
        return e2.length = 0, this;
      }, a.prototype.eachChild = function(e2, d2) {
        for (var y2 = this._children, x2 = 0; x2 < y2.length; x2++) {
          var C = y2[x2];
          e2.call(d2, C, x2);
        }
        return this;
      }, a.prototype.traverse = function(e2, d2) {
        for (var y2 = 0; y2 < this._children.length; y2++) {
          var x2 = this._children[y2], C = e2.call(d2, x2);
          x2.isGroup && !C && x2.traverse(e2, d2);
        }
        return this;
      }, a.prototype.addSelfToZr = function(e2) {
        l2.prototype.addSelfToZr.call(this, e2);
        for (var d2 = 0; d2 < this._children.length; d2++) {
          var y2 = this._children[d2];
          y2.addSelfToZr(e2);
        }
      }, a.prototype.removeSelfFromZr = function(e2) {
        l2.prototype.removeSelfFromZr.call(this, e2);
        for (var d2 = 0; d2 < this._children.length; d2++) {
          var y2 = this._children[d2];
          y2.removeSelfFromZr(e2);
        }
      }, a.prototype.getBoundingRect = function(e2) {
        for (var d2 = new Yu(0, 0, 0, 0), y2 = e2 || this._children, x2 = [], C = null, D2 = 0; D2 < y2.length; D2++) {
          var L = y2[D2];
          if (!(L.ignore || L.invisible)) {
            var F3 = L.getBoundingRect(), j = L.getLocalTransform(x2);
            j ? (Yu.applyTransform(d2, F3, j), C = C || d2.clone(), C.union(d2)) : (C = C || F3.clone(), C.union(F3));
          }
        }
        return C || d2;
      }, a;
    }(cC);
    Lvt.prototype.type = "group";
    var ou = Lvt;
    /*!
    * ZRender, a high performance 2d drawing library.
    *
    * Copyright (c) 2013, Baidu Inc.
    * All rights reserved.
    *
    * LICENSE
    * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
    */
    var cO = {}, fO = {};
    function Ovt(l2) {
      delete fO[l2];
    }
    function Rvt(l2) {
      if (!l2)
        return false;
      if (typeof l2 == "string")
        return jU(l2, 1) < $et;
      if (l2.colorStops) {
        for (var a = l2.colorStops, e2 = 0, d2 = a.length, y2 = 0; y2 < d2; y2++)
          e2 += jU(a[y2].color, 1);
        return e2 /= d2, e2 < $et;
      }
      return false;
    }
    var j5t = function() {
      function l2(a, e2, d2) {
        var y2 = this;
        this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, d2 = d2 || {}, this.dom = e2, this.id = a;
        var x2 = new _5t(), C = d2.renderer || "canvas";
        cO[C] || (C = Qc2(cO)[0]), d2.useDirtyRect = d2.useDirtyRect == null ? false : d2.useDirtyRect;
        var D2 = new cO[C](e2, x2, d2, a), L = d2.ssr || D2.ssrOnly;
        this.storage = x2, this.painter = D2;
        var F3 = !$s.node && !$s.worker && !L ? new Mvt(D2.getViewportRoot(), D2.root) : null;
        this.handler = new Jc2(x2, D2, F3, D2.root), this.animation = new sA({ stage: { update: L ? null : function() {
          return y2._flush(true);
        } } }), L || this.animation.start();
      }
      return l2.prototype.add = function(a) {
        !a || (this.storage.addRoot(a), a.addSelfToZr(this), this.refresh());
      }, l2.prototype.remove = function(a) {
        !a || (this.storage.delRoot(a), a.removeSelfFromZr(this), this.refresh());
      }, l2.prototype.configLayer = function(a, e2) {
        this.painter.configLayer && this.painter.configLayer(a, e2), this.refresh();
      }, l2.prototype.setBackgroundColor = function(a) {
        this.painter.setBackgroundColor && this.painter.setBackgroundColor(a), this.refresh(), this._backgroundColor = a, this._darkMode = Rvt(a);
      }, l2.prototype.getBackgroundColor = function() {
        return this._backgroundColor;
      }, l2.prototype.setDarkMode = function(a) {
        this._darkMode = a;
      }, l2.prototype.isDarkMode = function() {
        return this._darkMode;
      }, l2.prototype.refreshImmediately = function(a) {
        a || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
      }, l2.prototype.refresh = function() {
        this._needsRefresh = true, this.animation.start();
      }, l2.prototype.flush = function() {
        this._flush(false);
      }, l2.prototype._flush = function(a) {
        var e2, d2 = V5();
        this._needsRefresh && (e2 = true, this.refreshImmediately(a)), this._needsRefreshHover && (e2 = true, this.refreshHoverImmediately());
        var y2 = V5();
        e2 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: y2 - d2 })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
      }, l2.prototype.setSleepAfterStill = function(a) {
        this._sleepAfterStill = a;
      }, l2.prototype.wakeUp = function() {
        this.animation.start(), this._stillFrameAccum = 0;
      }, l2.prototype.refreshHover = function() {
        this._needsRefreshHover = true;
      }, l2.prototype.refreshHoverImmediately = function() {
        this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
      }, l2.prototype.resize = function(a) {
        a = a || {}, this.painter.resize(a.width, a.height), this.handler.resize();
      }, l2.prototype.clearAnimation = function() {
        this.animation.clear();
      }, l2.prototype.getWidth = function() {
        return this.painter.getWidth();
      }, l2.prototype.getHeight = function() {
        return this.painter.getHeight();
      }, l2.prototype.setCursorStyle = function(a) {
        this.handler.setCursorStyle(a);
      }, l2.prototype.findHover = function(a, e2) {
        return this.handler.findHover(a, e2);
      }, l2.prototype.on = function(a, e2, d2) {
        return this.handler.on(a, e2, d2), this;
      }, l2.prototype.off = function(a, e2) {
        this.handler.off(a, e2);
      }, l2.prototype.trigger = function(a, e2) {
        this.handler.trigger(a, e2);
      }, l2.prototype.clear = function() {
        for (var a = this.storage.getRoots(), e2 = 0; e2 < a.length; e2++)
          a[e2] instanceof ou && a[e2].removeSelfFromZr(this);
        this.storage.delAllRoots(), this.painter.clear();
      }, l2.prototype.dispose = function() {
        this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, Ovt(this.id);
      }, l2;
    }();
    function ent(l2, a) {
      var e2 = new j5t(uN(), l2, a);
      return fO[e2.id] = e2, e2;
    }
    function ON(l2, a) {
      cO[l2] = a;
    }
    var RN = 1e-4, Nvt = 20;
    function Fvt(l2) {
      return l2.replace(/^\s+|\s+$/g, "");
    }
    function yp(l2, a, e2, d2) {
      var y2 = a[0], x2 = a[1], C = e2[0], D2 = e2[1], L = x2 - y2, F3 = D2 - C;
      if (L === 0)
        return F3 === 0 ? C : (C + D2) / 2;
      if (d2)
        if (L > 0) {
          if (l2 <= y2)
            return C;
          if (l2 >= x2)
            return D2;
        } else {
          if (l2 >= y2)
            return C;
          if (l2 <= x2)
            return D2;
        }
      else {
        if (l2 === y2)
          return C;
        if (l2 === x2)
          return D2;
      }
      return (l2 - y2) / L * F3 + C;
    }
    function Ko(l2, a) {
      switch (l2) {
        case "center":
        case "middle":
          l2 = "50%";
          break;
        case "left":
        case "top":
          l2 = "0%";
          break;
        case "right":
        case "bottom":
          l2 = "100%";
          break;
      }
      return ps(l2) ? Fvt(l2).match(/%$/) ? parseFloat(l2) / 100 * a : parseFloat(l2) : l2 == null ? NaN : +l2;
    }
    function kv(l2, a, e2) {
      return a == null && (a = 10), a = Math.min(Math.max(0, a), Nvt), l2 = (+l2).toFixed(a), e2 ? l2 : +l2;
    }
    function k_(l2) {
      return l2.sort(function(a, e2) {
        return a - e2;
      }), l2;
    }
    function $2(l2) {
      if (l2 = +l2, isNaN(l2))
        return 0;
      if (l2 > 1e-14) {
        for (var a = 1, e2 = 0; e2 < 15; e2++, a *= 10)
          if (Math.round(l2 * a) / a === l2)
            return e2;
      }
      return eq2(l2);
    }
    function eq2(l2) {
      var a = l2.toString().toLowerCase(), e2 = a.indexOf("e"), d2 = e2 > 0 ? +a.slice(e2 + 1) : 0, y2 = e2 > 0 ? e2 : a.length, x2 = a.indexOf("."), C = x2 < 0 ? 0 : y2 - 1 - x2;
      return Math.max(0, C - d2);
    }
    function Vvt(l2, a) {
      var e2 = Math.log, d2 = Math.LN10, y2 = Math.floor(e2(l2[1] - l2[0]) / d2), x2 = Math.round(e2(Math.abs(a[1] - a[0])) / d2), C = Math.min(Math.max(-y2 + x2, 0), 20);
      return isFinite(C) ? C : 20;
    }
    function Bvt(l2, a, e2) {
      if (!l2[a])
        return 0;
      var d2 = tA(l2, function(nt, dt) {
        return nt + (isNaN(dt) ? 0 : dt);
      }, 0);
      if (d2 === 0)
        return 0;
      for (var y2 = Math.pow(10, e2), x2 = $a2(l2, function(nt) {
        return (isNaN(nt) ? 0 : nt) / d2 * y2 * 100;
      }), C = y2 * 100, D2 = $a2(x2, function(nt) {
        return Math.floor(nt);
      }), L = tA(D2, function(nt, dt) {
        return nt + dt;
      }, 0), F3 = $a2(x2, function(nt, dt) {
        return nt - D2[dt];
      }); L < C; ) {
        for (var j = Number.NEGATIVE_INFINITY, U3 = null, Y3 = 0, Q = F3.length; Y3 < Q; ++Y3)
          F3[Y3] > j && (j = F3[Y3], U3 = Y3);
        ++D2[U3], F3[U3] = 0, ++L;
      }
      return D2[a] / y2;
    }
    function nq(l2, a) {
      var e2 = Math.max($2(l2), $2(a)), d2 = l2 + a;
      return e2 > Nvt ? d2 : kv(d2, e2);
    }
    var nnt = 9007199254740991;
    function rq(l2) {
      var a = Math.PI * 2;
      return (l2 % a + a) % a;
    }
    function iq(l2) {
      return l2 > -RN && l2 < RN;
    }
    var zvt = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
    function Am(l2) {
      if (l2 instanceof Date)
        return l2;
      if (ps(l2)) {
        var a = zvt.exec(l2);
        if (!a)
          return new Date(NaN);
        if (a[8]) {
          var e2 = +a[4] || 0;
          return a[8].toUpperCase() !== "Z" && (e2 -= +a[8].slice(0, 3)), new Date(Date.UTC(+a[1], +(a[2] || 1) - 1, +a[3] || 1, e2, +(a[5] || 0), +a[6] || 0, a[7] ? +a[7].substring(0, 3) : 0));
        } else
          return new Date(+a[1], +(a[2] || 1) - 1, +a[3] || 1, +a[4] || 0, +(a[5] || 0), +a[6] || 0, a[7] ? +a[7].substring(0, 3) : 0);
      } else if (l2 == null)
        return new Date(NaN);
      return new Date(Math.round(l2));
    }
    function jvt(l2) {
      return Math.pow(10, aq(l2));
    }
    function aq(l2) {
      if (l2 === 0)
        return 0;
      var a = Math.floor(Math.log(l2) / Math.LN10);
      return l2 / Math.pow(10, a) >= 10 && a++, a;
    }
    function Wvt(l2, a) {
      var e2 = aq(l2), d2 = Math.pow(10, e2), y2 = l2 / d2, x2;
      return a ? y2 < 1.5 ? x2 = 1 : y2 < 2.5 ? x2 = 2 : y2 < 4 ? x2 = 3 : y2 < 7 ? x2 = 5 : x2 = 10 : y2 < 1 ? x2 = 1 : y2 < 2 ? x2 = 2 : y2 < 3 ? x2 = 3 : y2 < 5 ? x2 = 5 : x2 = 10, l2 = x2 * d2, e2 >= -20 ? +l2.toFixed(e2 < 0 ? -e2 : 0) : l2;
    }
    function oq(l2, a) {
      var e2 = (l2.length - 1) * a + 1, d2 = Math.floor(e2), y2 = +l2[d2 - 1], x2 = e2 - d2;
      return x2 ? y2 + x2 * (l2[d2] - y2) : y2;
    }
    function Gvt(l2) {
      l2.sort(function(L, F3) {
        return D2(L, F3, 0) ? -1 : 1;
      });
      for (var a = -1 / 0, e2 = 1, d2 = 0; d2 < l2.length; ) {
        for (var y2 = l2[d2].interval, x2 = l2[d2].close, C = 0; C < 2; C++)
          y2[C] <= a && (y2[C] = a, x2[C] = C ? 1 : 1 - e2), a = y2[C], e2 = x2[C];
        y2[0] === y2[1] && x2[0] * x2[1] !== 1 ? l2.splice(d2, 1) : d2++;
      }
      return l2;
      function D2(L, F3, j) {
        return L.interval[j] < F3.interval[j] || L.interval[j] === F3.interval[j] && (L.close[j] - F3.close[j] === (j ? -1 : 1) || !j && D2(L, F3, 1));
      }
    }
    function ME(l2) {
      var a = parseFloat(l2);
      return a == l2 && (a !== 0 || !ps(l2) || l2.indexOf("x") <= 0) ? a : NaN;
    }
    function hA(l2) {
      return !isNaN(ME(l2));
    }
    function sq() {
      return Math.round(Math.random() * 9);
    }
    function lq(l2, a) {
      return a === 0 ? l2 : lq(a, l2 % a);
    }
    function uq(l2, a) {
      return l2 == null ? a : a == null ? l2 : l2 * a / lq(l2, a);
    }
    function ih2(l2) {
      throw new Error(l2);
    }
    function hO(l2, a, e2) {
      return (a - l2) * e2 + l2;
    }
    var Ku = "series\0", NV = "\0_ec_\0";
    function Mp(l2) {
      return l2 instanceof Array ? l2 : l2 == null ? [] : [l2];
    }
    function RS(l2, a, e2) {
      if (l2) {
        l2[a] = l2[a] || {}, l2.emphasis = l2.emphasis || {}, l2.emphasis[a] = l2.emphasis[a] || {};
        for (var d2 = 0, y2 = e2.length; d2 < y2; d2++) {
          var x2 = e2[d2];
          !l2.emphasis[a].hasOwnProperty(x2) && l2[a].hasOwnProperty(x2) && (l2.emphasis[a][x2] = l2[a][x2]);
        }
      }
    }
    var Hvt = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
    function q5(l2) {
      return vs(l2) && !Ba2(l2) && !(l2 instanceof Date) ? l2.value : l2;
    }
    function Uvt(l2) {
      return vs(l2) && !(l2 instanceof Array);
    }
    function v12(l2, a, e2) {
      var d2 = e2 === "normalMerge", y2 = e2 === "replaceMerge", x2 = e2 === "replaceAll";
      l2 = l2 || [], a = (a || []).slice();
      var C = fl();
      Ke2(a, function(L, F3) {
        if (!vs(L)) {
          a[F3] = null;
          return;
        }
      });
      var D2 = W5t(l2, C, e2);
      return (d2 || y2) && G5t(D2, l2, C, a), d2 && qvt(D2, a), d2 || y2 ? H5t(D2, a, y2) : x2 && Zvt(D2, a), U5t(D2), D2;
    }
    function W5t(l2, a, e2) {
      var d2 = [];
      if (e2 === "replaceAll")
        return d2;
      for (var y2 = 0; y2 < l2.length; y2++) {
        var x2 = l2[y2];
        x2 && x2.id != null && a.set(x2.id, y2), d2.push({ existing: e2 === "replaceMerge" || pO(x2) ? null : x2, newOption: null, keyInfo: null, brandNew: null });
      }
      return d2;
    }
    function G5t(l2, a, e2, d2) {
      Ke2(d2, function(y2, x2) {
        if (!(!y2 || y2.id == null)) {
          var C = FV(y2.id), D2 = e2.get(C);
          if (D2 != null) {
            var L = l2[D2];
            vb2(!L.newOption, 'Duplicated option on id "' + C + '".'), L.newOption = y2, L.existing = a[D2], d2[x2] = null;
          }
        }
      });
    }
    function qvt(l2, a) {
      Ke2(a, function(e2, d2) {
        if (!(!e2 || e2.name == null))
          for (var y2 = 0; y2 < l2.length; y2++) {
            var x2 = l2[y2].existing;
            if (!l2[y2].newOption && x2 && (x2.id == null || e2.id == null) && !pO(e2) && !pO(x2) && $vt("name", x2, e2)) {
              l2[y2].newOption = e2, a[d2] = null;
              return;
            }
          }
      });
    }
    function H5t(l2, a, e2) {
      Ke2(a, function(d2) {
        if (d2) {
          for (var y2, x2 = 0; (y2 = l2[x2]) && (y2.newOption || pO(y2.existing) || y2.existing && d2.id != null && !$vt("id", d2, y2.existing)); )
            x2++;
          y2 ? (y2.newOption = d2, y2.brandNew = e2) : l2.push({ newOption: d2, brandNew: e2, existing: null, keyInfo: null }), x2++;
        }
      });
    }
    function Zvt(l2, a) {
      Ke2(a, function(e2) {
        l2.push({ newOption: e2, brandNew: true, existing: null, keyInfo: null });
      });
    }
    function U5t(l2) {
      var a = fl();
      Ke2(l2, function(e2) {
        var d2 = e2.existing;
        d2 && a.set(d2.id, e2);
      }), Ke2(l2, function(e2) {
        var d2 = e2.newOption;
        vb2(!d2 || d2.id == null || !a.get(d2.id) || a.get(d2.id) === e2, "id duplicates: " + (d2 && d2.id)), d2 && d2.id != null && a.set(d2.id, e2), !e2.keyInfo && (e2.keyInfo = {});
      }), Ke2(l2, function(e2, d2) {
        var y2 = e2.existing, x2 = e2.newOption, C = e2.keyInfo;
        if (vs(x2)) {
          if (C.name = x2.name != null ? FV(x2.name) : y2 ? y2.name : Ku + d2, y2)
            C.id = FV(y2.id);
          else if (x2.id != null)
            C.id = FV(x2.id);
          else {
            var D2 = 0;
            do
              C.id = "\0" + C.name + "\0" + D2++;
            while (a.get(C.id));
          }
          a.set(C.id, e2);
        }
      });
    }
    function $vt(l2, a, e2) {
      var d2 = Ud2(a[l2], null), y2 = Ud2(e2[l2], null);
      return d2 != null && y2 != null && d2 === y2;
    }
    function FV(l2) {
      return Ud2(l2, "");
    }
    function Ud2(l2, a) {
      return l2 == null ? a : ps(l2) ? l2 : Ch2(l2) || bet(l2) ? l2 + "" : a;
    }
    function y1(l2) {
      var a = l2.name;
      return !!(a && a.indexOf(Ku));
    }
    function pO(l2) {
      return l2 && l2.id != null && FV(l2.id).indexOf(NV) === 0;
    }
    function q5t(l2) {
      return NV + l2;
    }
    function rnt(l2, a, e2) {
      Ke2(l2, function(d2) {
        var y2 = d2.newOption;
        vs(y2) && (d2.keyInfo.mainType = a, d2.keyInfo.subType = Z5t(a, y2, d2.existing, e2));
      });
    }
    function Z5t(l2, a, e2, d2) {
      var y2 = a.type ? a.type : e2 ? e2.subType : d2.determineSubType(l2, a);
      return y2;
    }
    function $5t(l2, a) {
      var e2 = {}, d2 = {};
      return y2(l2 || [], e2), y2(a || [], d2, e2), [x2(e2), x2(d2)];
      function y2(C, D2, L) {
        for (var F3 = 0, j = C.length; F3 < j; F3++) {
          var U3 = Ud2(C[F3].seriesId, null);
          if (U3 == null)
            return;
          for (var Y3 = Mp(C[F3].dataIndex), Q = L && L[U3], nt = 0, dt = Y3.length; nt < dt; nt++) {
            var vt = Y3[nt];
            Q && Q[vt] ? Q[vt] = null : (D2[U3] || (D2[U3] = {}))[vt] = 1;
          }
        }
      }
      function x2(C, D2) {
        var L = [];
        for (var F3 in C)
          if (C.hasOwnProperty(F3) && C[F3] != null)
            if (D2)
              L.push(+F3);
            else {
              var j = x2(C[F3], true);
              j.length && L.push({ seriesId: F3, dataIndex: j });
            }
        return L;
      }
    }
    function fC(l2, a) {
      if (a.dataIndexInside != null)
        return a.dataIndexInside;
      if (a.dataIndex != null)
        return Ba2(a.dataIndex) ? $a2(a.dataIndex, function(e2) {
          return l2.indexOfRawIndex(e2);
        }) : l2.indexOfRawIndex(a.dataIndex);
      if (a.name != null)
        return Ba2(a.name) ? $a2(a.name, function(e2) {
          return l2.indexOfName(e2);
        }) : l2.indexOfName(a.name);
    }
    function Rf2() {
      var l2 = "__ec_inner_" + Yvt++;
      return function(a) {
        return a[l2] || (a[l2] = {});
      };
    }
    var Yvt = sq();
    function VV(l2, a, e2) {
      var d2 = int(a, e2), y2 = d2.mainTypeSpecified, x2 = d2.queryOptionMap, C = d2.others, D2 = C, L = e2 ? e2.defaultMainType : null;
      return !y2 && L && x2.set(L, {}), x2.each(function(F3, j) {
        var U3 = NN(l2, j, F3, { useDefault: L === j, enableAll: e2 && e2.enableAll != null ? e2.enableAll : true, enableNone: e2 && e2.enableNone != null ? e2.enableNone : true });
        D2[j + "Models"] = U3.models, D2[j + "Model"] = U3.models[0];
      }), D2;
    }
    function int(l2, a) {
      var e2;
      if (ps(l2)) {
        var d2 = {};
        d2[l2 + "Index"] = 0, e2 = d2;
      } else
        e2 = l2;
      var y2 = fl(), x2 = {}, C = false;
      return Ke2(e2, function(D2, L) {
        if (L === "dataIndex" || L === "dataIndexInside") {
          x2[L] = D2;
          return;
        }
        var F3 = L.match(/^(\w+)(Index|Id|Name)$/) || [], j = F3[1], U3 = (F3[2] || "").toLowerCase();
        if (!(!j || !U3 || a && a.includeMainTypes && oc2(a.includeMainTypes, j) < 0)) {
          C = C || !!j;
          var Y3 = y2.get(j) || y2.set(j, {});
          Y3[U3] = D2;
        }
      }), { mainTypeSpecified: C, queryOptionMap: y2, others: x2 };
    }
    var q0 = { useDefault: true, enableAll: false, enableNone: false }, Y5t = { useDefault: false, enableAll: true, enableNone: true };
    function NN(l2, a, e2, d2) {
      d2 = d2 || q0;
      var y2 = e2.index, x2 = e2.id, C = e2.name, D2 = { models: null, specified: y2 != null || x2 != null || C != null };
      if (!D2.specified) {
        var L = void 0;
        return D2.models = d2.useDefault && (L = l2.getComponent(a)) ? [L] : [], D2;
      }
      return y2 === "none" || y2 === false ? (vb2(d2.enableNone, '`"none"` or `false` is not a valid value on index option.'), D2.models = [], D2) : (y2 === "all" && (vb2(d2.enableAll, '`"all"` is not a valid value on index option.'), y2 = x2 = C = null), D2.models = l2.queryComponents({ mainType: a, index: y2, id: x2, name: C }), D2);
    }
    function ant(l2, a, e2) {
      l2.setAttribute ? l2.setAttribute(a, e2) : l2[a] = e2;
    }
    function K5t(l2, a) {
      return l2.getAttribute ? l2.getAttribute(a) : l2[a];
    }
    function ont(l2) {
      return l2 === "auto" ? $s.domSupported ? "html" : "richText" : l2 || "html";
    }
    function cq(l2, a) {
      var e2 = fl(), d2 = [];
      return Ke2(l2, function(y2) {
        var x2 = a(y2);
        (e2.get(x2) || (d2.push(x2), e2.set(x2, []))).push(y2);
      }), { keys: d2, buckets: e2 };
    }
    function FN(l2, a, e2, d2, y2) {
      var x2 = a == null || a === "auto";
      if (d2 == null)
        return d2;
      if (Ch2(d2)) {
        var C = hO(e2 || 0, d2, y2);
        return kv(C, x2 ? Math.max($2(e2 || 0), $2(d2)) : a);
      } else {
        if (ps(d2))
          return y2 < 1 ? e2 : d2;
        for (var D2 = [], L = e2, F3 = d2, j = Math.max(L ? L.length : 0, F3.length), U3 = 0; U3 < j; ++U3) {
          var Y3 = l2.getDimensionInfo(U3);
          if (Y3 && Y3.type === "ordinal")
            D2[U3] = (y2 < 1 && L ? L : F3)[U3];
          else {
            var Q = L && L[U3] ? L[U3] : 0, nt = F3[U3], C = hO(Q, nt, y2);
            D2[U3] = kv(C, x2 ? Math.max($2(Q), $2(nt)) : a);
          }
        }
        return D2;
      }
    }
    var snt = ".", Z5 = "___EC__COMPONENT__CONTAINER___", lnt = "___EC__EXTENDED_CLASS___";
    function NS(l2) {
      var a = { main: "", sub: "" };
      if (l2) {
        var e2 = l2.split(snt);
        a.main = e2[0] || "", a.sub = e2[1] || "";
      }
      return a;
    }
    function Kvt(l2) {
      vb2(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(l2), 'componentType "' + l2 + '" illegal');
    }
    function pA(l2) {
      return !!(l2 && l2[lnt]);
    }
    function CE(l2, a) {
      l2.$constructor = l2, l2.extend = function(e2) {
        var d2 = this, y2;
        return X5t(d2) ? y2 = function(x2) {
          Jn(C, x2);
          function C() {
            return x2.apply(this, arguments) || this;
          }
          return C;
        }(d2) : (y2 = function() {
          (e2.$constructor || d2).apply(this, arguments);
        }, Kgt(y2, this)), la2(y2.prototype, e2), y2[lnt] = true, y2.extend = this.extend, y2.superCall = tPt, y2.superApply = ePt, y2.superClass = d2, y2;
      };
    }
    function X5t(l2) {
      return wl(l2) && /^class\s/.test(Function.prototype.toString.call(l2));
    }
    function unt(l2, a) {
      l2.extend = a.extend;
    }
    var Q5t = Math.round(Math.random() * 10);
    function J5t(l2) {
      var a = ["__\0is_clz", Q5t++].join("_");
      l2.prototype[a] = true, l2.isInstance = function(e2) {
        return !!(e2 && e2[a]);
      };
    }
    function tPt(l2, a) {
      for (var e2 = [], d2 = 2; d2 < arguments.length; d2++)
        e2[d2 - 2] = arguments[d2];
      return this.superClass.prototype[a].apply(l2, e2);
    }
    function ePt(l2, a, e2) {
      return this.superClass.prototype[a].apply(l2, e2);
    }
    function fq(l2) {
      var a = {};
      l2.registerClass = function(d2) {
        var y2 = d2.type || d2.prototype.type;
        if (y2) {
          Kvt(y2), d2.prototype.type = y2;
          var x2 = NS(y2);
          if (!x2.sub)
            a[x2.main] = d2;
          else if (x2.sub !== Z5) {
            var C = e2(x2);
            C[x2.sub] = d2;
          }
        }
        return d2;
      }, l2.getClass = function(d2, y2, x2) {
        var C = a[d2];
        if (C && C[Z5] && (C = y2 ? C[y2] : null), x2 && !C)
          throw new Error(y2 ? "Component " + d2 + "." + (y2 || "") + " is used but not imported." : d2 + ".type should be specified.");
        return C;
      }, l2.getClassesByMainType = function(d2) {
        var y2 = NS(d2), x2 = [], C = a[y2.main];
        return C && C[Z5] ? Ke2(C, function(D2, L) {
          L !== Z5 && x2.push(D2);
        }) : x2.push(C), x2;
      }, l2.hasClass = function(d2) {
        var y2 = NS(d2);
        return !!a[y2.main];
      }, l2.getAllClassMainTypes = function() {
        var d2 = [];
        return Ke2(a, function(y2, x2) {
          d2.push(x2);
        }), d2;
      }, l2.hasSubTypes = function(d2) {
        var y2 = NS(d2), x2 = a[y2.main];
        return x2 && x2[Z5];
      };
      function e2(d2) {
        var y2 = a[d2.main];
        return (!y2 || !y2[Z5]) && (y2 = a[d2.main] = {}, y2[Z5] = true), y2;
      }
    }
    function dO(l2, a) {
      for (var e2 = 0; e2 < l2.length; e2++)
        l2[e2][1] || (l2[e2][1] = l2[e2][0]);
      return a = a || false, function(d2, y2, x2) {
        for (var C = {}, D2 = 0; D2 < l2.length; D2++) {
          var L = l2[D2][1];
          if (!(y2 && oc2(y2, L) >= 0 || x2 && oc2(x2, L) < 0)) {
            var F3 = d2.getShallow(L, a);
            F3 != null && (C[l2[D2][0]] = F3);
          }
        }
        return C;
      };
    }
    var nPt = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], rPt = dO(nPt), iPt = function() {
      function l2() {
      }
      return l2.prototype.getAreaStyle = function(a, e2) {
        return rPt(this, a, e2);
      }, l2;
    }(), cnt = new TV(50);
    function aPt(l2) {
      if (typeof l2 == "string") {
        var a = cnt.get(l2);
        return a && a.image;
      } else
        return l2;
    }
    function hq(l2, a, e2, d2, y2) {
      if (l2)
        if (typeof l2 == "string") {
          if (a && a.__zrImageSrc === l2 || !e2)
            return a;
          var x2 = cnt.get(l2), C = { hostEl: e2, cb: d2, cbPayload: y2 };
          if (x2)
            a = x2.image, !BV(a) && x2.pending.push(C);
          else {
            var D2 = Zx.loadImage(l2, fnt, fnt);
            D2.__zrImageSrc = l2, cnt.put(l2, D2.__cachedImgObj = { image: D2, pending: [C] });
          }
          return a;
        } else
          return l2;
      else
        return a;
    }
    function fnt() {
      var l2 = this.__cachedImgObj;
      this.onload = this.onerror = this.__cachedImgObj = null;
      for (var a = 0; a < l2.pending.length; a++) {
        var e2 = l2.pending[a], d2 = e2.cb;
        d2 && d2(this, e2.cbPayload), e2.hostEl.dirty();
      }
      l2.pending.length = 0;
    }
    function BV(l2) {
      return l2 && l2.width && l2.height;
    }
    var hnt = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
    function oPt(l2, a, e2, d2, y2) {
      if (!a)
        return "";
      var x2 = (l2 + "").split(`
`);
      y2 = Xvt(a, e2, d2, y2);
      for (var C = 0, D2 = x2.length; C < D2; C++)
        x2[C] = pnt(x2[C], y2);
      return x2.join(`
`);
    }
    function Xvt(l2, a, e2, d2) {
      d2 = d2 || {};
      var y2 = la2({}, d2);
      y2.font = a, e2 = $u(e2, "..."), y2.maxIterations = $u(d2.maxIterations, 2);
      var x2 = y2.minChar = $u(d2.minChar, 0);
      y2.cnCharWidth = _b2("\u56FD", a);
      var C = y2.ascCharWidth = _b2("a", a);
      y2.placeholder = $u(d2.placeholder, "");
      for (var D2 = l2 = Math.max(0, l2 - 1), L = 0; L < x2 && D2 >= C; L++)
        D2 -= C;
      var F3 = _b2(e2, a);
      return F3 > D2 && (e2 = "", F3 = 0), D2 = l2 - F3, y2.ellipsis = e2, y2.ellipsisWidth = F3, y2.contentWidth = D2, y2.containerWidth = l2, y2;
    }
    function pnt(l2, a) {
      var e2 = a.containerWidth, d2 = a.font, y2 = a.contentWidth;
      if (!e2)
        return "";
      var x2 = _b2(l2, d2);
      if (x2 <= e2)
        return l2;
      for (var C = 0; ; C++) {
        if (x2 <= y2 || C >= a.maxIterations) {
          l2 += a.ellipsis;
          break;
        }
        var D2 = C === 0 ? sPt(l2, y2, a.ascCharWidth, a.cnCharWidth) : x2 > 0 ? Math.floor(l2.length * y2 / x2) : 0;
        l2 = l2.substr(0, D2), x2 = _b2(l2, d2);
      }
      return l2 === "" && (l2 = a.placeholder), l2;
    }
    function sPt(l2, a, e2, d2) {
      for (var y2 = 0, x2 = 0, C = l2.length; x2 < C && y2 < a; x2++) {
        var D2 = l2.charCodeAt(x2);
        y2 += 0 <= D2 && D2 <= 127 ? e2 : d2;
      }
      return x2;
    }
    function lPt(l2, a) {
      l2 != null && (l2 += "");
      var e2 = a.overflow, d2 = a.padding, y2 = a.font, x2 = e2 === "truncate", C = LN(y2), D2 = $u(a.lineHeight, C), L = !!a.backgroundColor, F3 = a.lineOverflow === "truncate", j = a.width, U3;
      j != null && (e2 === "break" || e2 === "breakAll") ? U3 = l2 ? dnt(l2, a.font, j, e2 === "breakAll", 0).lines : [] : U3 = l2 ? l2.split(`
`) : [];
      var Y3 = U3.length * D2, Q = $u(a.height, Y3);
      if (Y3 > Q && F3) {
        var nt = Math.floor(Q / D2);
        U3 = U3.slice(0, nt);
      }
      if (l2 && x2 && j != null)
        for (var dt = Xvt(j, y2, a.ellipsis, { minChar: a.truncateMinChar, placeholder: a.placeholder }), vt = 0; vt < U3.length; vt++)
          U3[vt] = pnt(U3[vt], dt);
      for (var Ct = Q, Pt = 0, vt = 0; vt < U3.length; vt++)
        Pt = Math.max(_b2(U3[vt], y2), Pt);
      j == null && (j = Pt);
      var jt = Pt;
      return d2 && (Ct += d2[0] + d2[2], jt += d2[1] + d2[3], j += d2[1] + d2[3]), L && (jt = j), { lines: U3, height: Q, outerWidth: jt, outerHeight: Ct, lineHeight: D2, calculatedLineHeight: C, contentWidth: Pt, contentHeight: Y3, width: j };
    }
    var uPt = function() {
      function l2() {
      }
      return l2;
    }(), Qvt = function() {
      function l2(a) {
        this.tokens = [], a && (this.tokens = a);
      }
      return l2;
    }(), cPt = function() {
      function l2() {
        this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
      }
      return l2;
    }();
    function fPt(l2, a) {
      var e2 = new cPt();
      if (l2 != null && (l2 += ""), !l2)
        return e2;
      for (var d2 = a.width, y2 = a.height, x2 = a.overflow, C = (x2 === "break" || x2 === "breakAll") && d2 != null ? { width: d2, accumWidth: 0, breakAll: x2 === "breakAll" } : null, D2 = hnt.lastIndex = 0, L; (L = hnt.exec(l2)) != null; ) {
        var F3 = L.index;
        F3 > D2 && Qx(e2, l2.substring(D2, F3), a, C), Qx(e2, L[2], a, C, L[1]), D2 = hnt.lastIndex;
      }
      D2 < l2.length && Qx(e2, l2.substring(D2, l2.length), a, C);
      var j = [], U3 = 0, Y3 = 0, Q = a.padding, nt = x2 === "truncate", dt = a.lineOverflow === "truncate";
      function vt(Kn, ar, Cr) {
        Kn.width = ar, Kn.lineHeight = Cr, U3 += Cr, Y3 = Math.max(Y3, ar);
      }
      t:
        for (var Ct = 0; Ct < e2.lines.length; Ct++) {
          for (var Pt = e2.lines[Ct], jt = 0, Rt = 0, le2 = 0; le2 < Pt.tokens.length; le2++) {
            var ne2 = Pt.tokens[le2], he2 = ne2.styleName && a.rich[ne2.styleName] || {}, _e = ne2.textPadding = he2.padding, Me2 = _e ? _e[1] + _e[3] : 0, Pe2 = ne2.font = he2.font || a.font;
            ne2.contentHeight = LN(Pe2);
            var Be2 = $u(he2.height, ne2.contentHeight);
            if (ne2.innerHeight = Be2, _e && (Be2 += _e[0] + _e[2]), ne2.height = Be2, ne2.lineHeight = uv(he2.lineHeight, a.lineHeight, Be2), ne2.align = he2 && he2.align || a.align, ne2.verticalAlign = he2 && he2.verticalAlign || "middle", dt && y2 != null && U3 + ne2.lineHeight > y2) {
              le2 > 0 ? (Pt.tokens = Pt.tokens.slice(0, le2), vt(Pt, Rt, jt), e2.lines = e2.lines.slice(0, Ct + 1)) : e2.lines = e2.lines.slice(0, Ct);
              break t;
            }
            var Je2 = he2.width, Ze2 = Je2 == null || Je2 === "auto";
            if (typeof Je2 == "string" && Je2.charAt(Je2.length - 1) === "%")
              ne2.percentWidth = Je2, j.push(ne2), ne2.contentWidth = _b2(ne2.text, Pe2);
            else {
              if (Ze2) {
                var Cn = he2.backgroundColor, Bn = Cn && Cn.image;
                Bn && (Bn = aPt(Bn), BV(Bn) && (ne2.width = Math.max(ne2.width, Bn.width * Be2 / Bn.height)));
              }
              var mn = nt && d2 != null ? d2 - Rt : null;
              mn != null && mn < ne2.width ? !Ze2 || mn < Me2 ? (ne2.text = "", ne2.width = ne2.contentWidth = 0) : (ne2.text = oPt(ne2.text, mn - Me2, Pe2, a.ellipsis, { minChar: a.truncateMinChar }), ne2.width = ne2.contentWidth = _b2(ne2.text, Pe2)) : ne2.contentWidth = _b2(ne2.text, Pe2);
            }
            ne2.width += Me2, Rt += ne2.width, he2 && (jt = Math.max(jt, ne2.lineHeight));
          }
          vt(Pt, Rt, jt);
        }
      e2.outerWidth = e2.width = $u(d2, Y3), e2.outerHeight = e2.height = $u(y2, U3), e2.contentHeight = U3, e2.contentWidth = Y3, Q && (e2.outerWidth += Q[1] + Q[3], e2.outerHeight += Q[0] + Q[2]);
      for (var Ct = 0; Ct < j.length; Ct++) {
        var ne2 = j[Ct], Kr = ne2.percentWidth;
        ne2.width = parseInt(Kr, 10) / 100 * e2.width;
      }
      return e2;
    }
    function Qx(l2, a, e2, d2, y2) {
      var x2 = a === "", C = y2 && e2.rich[y2] || {}, D2 = l2.lines, L = C.font || e2.font, F3 = false, j, U3;
      if (d2) {
        var Y3 = C.padding, Q = Y3 ? Y3[1] + Y3[3] : 0;
        if (C.width != null && C.width !== "auto") {
          var nt = Tm(C.width, d2.width) + Q;
          D2.length > 0 && nt + d2.accumWidth > d2.width && (j = a.split(`
`), F3 = true), d2.accumWidth = nt;
        } else {
          var dt = dnt(a, L, d2.width, d2.breakAll, d2.accumWidth);
          d2.accumWidth = dt.accumWidth + Q, U3 = dt.linesWidths, j = dt.lines;
        }
      } else
        j = a.split(`
`);
      for (var vt = 0; vt < j.length; vt++) {
        var Ct = j[vt], Pt = new uPt();
        if (Pt.styleName = y2, Pt.text = Ct, Pt.isLineHolder = !Ct && !x2, typeof C.width == "number" ? Pt.width = C.width : Pt.width = U3 ? U3[vt] : _b2(Ct, L), !vt && !F3) {
          var jt = (D2[D2.length - 1] || (D2[0] = new Qvt())).tokens, Rt = jt.length;
          Rt === 1 && jt[0].isLineHolder ? jt[0] = Pt : (Ct || !Rt || x2) && jt.push(Pt);
        } else
          D2.push(new Qvt([Pt]));
      }
    }
    function hPt(l2) {
      var a = l2.charCodeAt(0);
      return a >= 33 && a <= 383;
    }
    var pPt = tA(",&?/;] ".split(""), function(l2, a) {
      return l2[a] = true, l2;
    }, {});
    function dPt(l2) {
      return hPt(l2) ? !!pPt[l2] : true;
    }
    function dnt(l2, a, e2, d2, y2) {
      for (var x2 = [], C = [], D2 = "", L = "", F3 = 0, j = 0, U3 = 0; U3 < l2.length; U3++) {
        var Y3 = l2.charAt(U3);
        if (Y3 === `
`) {
          L && (D2 += L, j += F3), x2.push(D2), C.push(j), D2 = "", L = "", F3 = 0, j = 0;
          continue;
        }
        var Q = _b2(Y3, a), nt = d2 ? false : !dPt(Y3);
        if (x2.length ? j + Q > e2 : y2 + j + Q > e2) {
          j ? (D2 || L) && (nt ? (D2 || (D2 = L, L = "", F3 = 0, j = F3), x2.push(D2), C.push(j - F3), L += Y3, F3 += Q, D2 = "", j = F3) : (L && (D2 += L, L = "", F3 = 0), x2.push(D2), C.push(j), D2 = Y3, j = Q)) : nt ? (x2.push(L), C.push(F3), L = Y3, F3 = Q) : (x2.push(Y3), C.push(Q));
          continue;
        }
        j += Q, nt ? (L += Y3, F3 += Q) : (L && (D2 += L, L = "", F3 = 0), D2 += Y3);
      }
      return !x2.length && !D2 && (D2 = l2, L = "", F3 = 0), L && (D2 += L), D2 && (x2.push(D2), C.push(j)), x2.length === 1 && (j += y2), { accumWidth: j, lines: x2, linesWidths: C };
    }
    var gnt = "__zr_style_" + Math.round(Math.random() * 10), gO = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, pq = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
    gO[gnt] = true;
    var Jvt = ["z", "z2", "invisible"], vnt = ["invisible"], gPt = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype._init = function(e2) {
        for (var d2 = Qc2(e2), y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2];
          x2 === "style" ? this.useStyle(e2[x2]) : l2.prototype.attrKV.call(this, x2, e2[x2]);
        }
        this.style || this.useStyle({});
      }, a.prototype.beforeBrush = function() {
      }, a.prototype.afterBrush = function() {
      }, a.prototype.innerBeforeBrush = function() {
      }, a.prototype.innerAfterBrush = function() {
      }, a.prototype.shouldBePainted = function(e2, d2, y2, x2) {
        var C = this.transform;
        if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && vPt(this, e2, d2) || C && !C[0] && !C[3])
          return false;
        if (y2 && this.__clipPaths) {
          for (var D2 = 0; D2 < this.__clipPaths.length; ++D2)
            if (this.__clipPaths[D2].isZeroArea())
              return false;
        }
        if (x2 && this.parent)
          for (var L = this.parent; L; ) {
            if (L.ignore)
              return false;
            L = L.parent;
          }
        return true;
      }, a.prototype.contain = function(e2, d2) {
        return this.rectContain(e2, d2);
      }, a.prototype.traverse = function(e2, d2) {
        e2.call(d2, this);
      }, a.prototype.rectContain = function(e2, d2) {
        var y2 = this.transformCoordToLocal(e2, d2), x2 = this.getBoundingRect();
        return x2.contain(y2[0], y2[1]);
      }, a.prototype.getPaintRect = function() {
        var e2 = this._paintRect;
        if (!this._paintRect || this.__dirty) {
          var d2 = this.transform, y2 = this.getBoundingRect(), x2 = this.style, C = x2.shadowBlur || 0, D2 = x2.shadowOffsetX || 0, L = x2.shadowOffsetY || 0;
          e2 = this._paintRect || (this._paintRect = new Yu(0, 0, 0, 0)), d2 ? Yu.applyTransform(e2, y2, d2) : e2.copy(y2), (C || D2 || L) && (e2.width += C * 2 + Math.abs(D2), e2.height += C * 2 + Math.abs(L), e2.x = Math.min(e2.x, e2.x + D2 - C), e2.y = Math.min(e2.y, e2.y + L - C));
          var F3 = this.dirtyRectTolerance;
          e2.isZero() || (e2.x = Math.floor(e2.x - F3), e2.y = Math.floor(e2.y - F3), e2.width = Math.ceil(e2.width + 1 + F3 * 2), e2.height = Math.ceil(e2.height + 1 + F3 * 2));
        }
        return e2;
      }, a.prototype.setPrevPaintRect = function(e2) {
        e2 ? (this._prevPaintRect = this._prevPaintRect || new Yu(0, 0, 0, 0), this._prevPaintRect.copy(e2)) : this._prevPaintRect = null;
      }, a.prototype.getPrevPaintRect = function() {
        return this._prevPaintRect;
      }, a.prototype.animateStyle = function(e2) {
        return this.animate("style", e2);
      }, a.prototype.updateDuringAnimation = function(e2) {
        e2 === "style" ? this.dirtyStyle() : this.markRedraw();
      }, a.prototype.attrKV = function(e2, d2) {
        e2 !== "style" ? l2.prototype.attrKV.call(this, e2, d2) : this.style ? this.setStyle(d2) : this.useStyle(d2);
      }, a.prototype.setStyle = function(e2, d2) {
        return typeof e2 == "string" ? this.style[e2] = d2 : la2(this.style, e2), this.dirtyStyle(), this;
      }, a.prototype.dirtyStyle = function(e2) {
        e2 || this.markRedraw(), this.__dirty |= Op, this._rect && (this._rect = null);
      }, a.prototype.dirty = function() {
        this.dirtyStyle();
      }, a.prototype.styleChanged = function() {
        return !!(this.__dirty & Op);
      }, a.prototype.styleUpdated = function() {
        this.__dirty &= ~Op;
      }, a.prototype.createStyle = function(e2) {
        return vV(gO, e2);
      }, a.prototype.useStyle = function(e2) {
        e2[gnt] || (e2 = this.createStyle(e2)), this.__inHover ? this.__hoverStyle = e2 : this.style = e2, this.dirtyStyle();
      }, a.prototype.isStyleObject = function(e2) {
        return e2[gnt];
      }, a.prototype._innerSaveToNormal = function(e2) {
        l2.prototype._innerSaveToNormal.call(this, e2);
        var d2 = this._normalState;
        e2.style && !d2.style && (d2.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(e2, d2, Jvt);
      }, a.prototype._applyStateObj = function(e2, d2, y2, x2, C, D2) {
        l2.prototype._applyStateObj.call(this, e2, d2, y2, x2, C, D2);
        var L = !(d2 && x2), F3;
        if (d2 && d2.style ? C ? x2 ? F3 = d2.style : (F3 = this._mergeStyle(this.createStyle(), y2.style), this._mergeStyle(F3, d2.style)) : (F3 = this._mergeStyle(this.createStyle(), x2 ? this.style : y2.style), this._mergeStyle(F3, d2.style)) : L && (F3 = y2.style), F3)
          if (C) {
            var j = this.style;
            if (this.style = this.createStyle(L ? {} : j), L)
              for (var U3 = Qc2(j), Y3 = 0; Y3 < U3.length; Y3++) {
                var Q = U3[Y3];
                Q in F3 && (F3[Q] = F3[Q], this.style[Q] = j[Q]);
              }
            for (var nt = Qc2(F3), Y3 = 0; Y3 < nt.length; Y3++) {
              var Q = nt[Y3];
              this.style[Q] = this.style[Q];
            }
            this._transitionState(e2, { style: F3 }, D2, this.getAnimationStyleProps());
          } else
            this.useStyle(F3);
        for (var dt = this.__inHover ? vnt : Jvt, Y3 = 0; Y3 < dt.length; Y3++) {
          var Q = dt[Y3];
          d2 && d2[Q] != null ? this[Q] = d2[Q] : L && y2[Q] != null && (this[Q] = y2[Q]);
        }
      }, a.prototype._mergeStates = function(e2) {
        for (var d2 = l2.prototype._mergeStates.call(this, e2), y2, x2 = 0; x2 < e2.length; x2++) {
          var C = e2[x2];
          C.style && (y2 = y2 || {}, this._mergeStyle(y2, C.style));
        }
        return y2 && (d2.style = y2), d2;
      }, a.prototype._mergeStyle = function(e2, d2) {
        return la2(e2, d2), e2;
      }, a.prototype.getAnimationStyleProps = function() {
        return pq;
      }, a.initDefaultProps = function() {
        var e2 = a.prototype;
        e2.type = "displayable", e2.invisible = false, e2.z = 0, e2.z2 = 0, e2.zlevel = 0, e2.culling = false, e2.cursor = "pointer", e2.rectHover = false, e2.incremental = false, e2._rect = null, e2.dirtyRectTolerance = 0, e2.__dirty = yb2 | Op;
      }(), a;
    }(cC), ynt = new Yu(0, 0, 0, 0), mnt = new Yu(0, 0, 0, 0);
    function vPt(l2, a, e2) {
      return ynt.copy(l2.getBoundingRect()), l2.transform && ynt.applyTransform(l2.transform), mnt.width = a, mnt.height = e2, !ynt.intersect(mnt);
    }
    var Y2 = gPt, Jx = Math.min, tw = Math.max, bnt = Math.sin, _nt = Math.cos, vO = Math.PI * 2, dq = P5(), gq = P5(), vq = P5();
    function yq(l2, a, e2) {
      if (l2.length !== 0) {
        for (var d2 = l2[0], y2 = d2[0], x2 = d2[0], C = d2[1], D2 = d2[1], L = 1; L < l2.length; L++)
          d2 = l2[L], y2 = Jx(y2, d2[0]), x2 = tw(x2, d2[0]), C = Jx(C, d2[1]), D2 = tw(D2, d2[1]);
        a[0] = y2, a[1] = C, e2[0] = x2, e2[1] = D2;
      }
    }
    function t0t(l2, a, e2, d2, y2, x2) {
      y2[0] = Jx(l2, e2), y2[1] = Jx(a, d2), x2[0] = tw(l2, e2), x2[1] = tw(a, d2);
    }
    var e0t = [], n0t = [];
    function yPt(l2, a, e2, d2, y2, x2, C, D2, L, F3) {
      var j = svt, U3 = m0, Y3 = j(l2, e2, y2, C, e0t);
      L[0] = 1 / 0, L[1] = 1 / 0, F3[0] = -1 / 0, F3[1] = -1 / 0;
      for (var Q = 0; Q < Y3; Q++) {
        var nt = U3(l2, e2, y2, C, e0t[Q]);
        L[0] = Jx(nt, L[0]), F3[0] = tw(nt, F3[0]);
      }
      Y3 = j(a, d2, x2, D2, n0t);
      for (var Q = 0; Q < Y3; Q++) {
        var dt = U3(a, d2, x2, D2, n0t[Q]);
        L[1] = Jx(dt, L[1]), F3[1] = tw(dt, F3[1]);
      }
      L[0] = Jx(l2, L[0]), F3[0] = tw(l2, F3[0]), L[0] = Jx(C, L[0]), F3[0] = tw(C, F3[0]), L[1] = Jx(a, L[1]), F3[1] = tw(a, F3[1]), L[1] = Jx(D2, L[1]), F3[1] = tw(D2, F3[1]);
    }
    function mPt(l2, a, e2, d2, y2, x2, C, D2) {
      var L = uvt, F3 = sp, j = tw(Jx(L(l2, e2, y2), 1), 0), U3 = tw(Jx(L(a, d2, x2), 1), 0), Y3 = F3(l2, e2, y2, j), Q = F3(a, d2, x2, U3);
      C[0] = Jx(l2, y2, Y3), C[1] = Jx(a, x2, Q), D2[0] = tw(l2, y2, Y3), D2[1] = tw(a, x2, Q);
    }
    function bPt(l2, a, e2, d2, y2, x2, C, D2, L) {
      var F3 = vE, j = nA, U3 = Math.abs(y2 - x2);
      if (U3 % vO < 1e-4 && U3 > 1e-4) {
        D2[0] = l2 - e2, D2[1] = a - d2, L[0] = l2 + e2, L[1] = a + d2;
        return;
      }
      if (dq[0] = _nt(y2) * e2 + l2, dq[1] = bnt(y2) * d2 + a, gq[0] = _nt(x2) * e2 + l2, gq[1] = bnt(x2) * d2 + a, F3(D2, dq, gq), j(L, dq, gq), y2 = y2 % vO, y2 < 0 && (y2 = y2 + vO), x2 = x2 % vO, x2 < 0 && (x2 = x2 + vO), y2 > x2 && !C ? x2 += vO : y2 < x2 && C && (y2 += vO), C) {
        var Y3 = x2;
        x2 = y2, y2 = Y3;
      }
      for (var Q = 0; Q < x2; Q += Math.PI / 2)
        Q > y2 && (vq[0] = _nt(Q) * e2 + l2, vq[1] = bnt(Q) * d2 + a, F3(D2, vq, D2), j(L, vq, L));
    }
    var Kp = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, $5 = [], yO = [], dA = [], Y5 = [], gA = [], vA = [], xnt = Math.min, wnt = Math.max, mO = Math.cos, K5 = Math.sin, TE = Math.abs, VN = Math.PI, X5 = VN * 2, Snt = typeof Float32Array != "undefined", zV = [];
    function Mnt(l2) {
      var a = Math.round(l2 / VN * 1e8) / 1e8;
      return a % 2 * VN;
    }
    function _Pt(l2, a) {
      var e2 = Mnt(l2[0]);
      e2 < 0 && (e2 += X5);
      var d2 = e2 - l2[0], y2 = l2[1];
      y2 += d2, !a && y2 - e2 >= X5 ? y2 = e2 + X5 : a && e2 - y2 >= X5 ? y2 = e2 - X5 : !a && e2 > y2 ? y2 = e2 + (X5 - Mnt(e2 - y2)) : a && e2 < y2 && (y2 = e2 - (X5 - Mnt(y2 - e2))), l2[0] = e2, l2[1] = y2;
    }
    var xPt = function() {
      function l2(a) {
        this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, a && (this._saveData = false), this._saveData && (this.data = []);
      }
      return l2.prototype.increaseVersion = function() {
        this._version++;
      }, l2.prototype.getVersion = function() {
        return this._version;
      }, l2.prototype.setScale = function(a, e2, d2) {
        d2 = d2 || 0, d2 > 0 && (this._ux = TE(d2 / ZU / a) || 0, this._uy = TE(d2 / ZU / e2) || 0);
      }, l2.prototype.setDPR = function(a) {
        this.dpr = a;
      }, l2.prototype.setContext = function(a) {
        this._ctx = a;
      }, l2.prototype.getContext = function() {
        return this._ctx;
      }, l2.prototype.beginPath = function() {
        return this._ctx && this._ctx.beginPath(), this.reset(), this;
      }, l2.prototype.reset = function() {
        this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
      }, l2.prototype.moveTo = function(a, e2) {
        return this._drawPendingPt(), this.addData(Kp.M, a, e2), this._ctx && this._ctx.moveTo(a, e2), this._x0 = a, this._y0 = e2, this._xi = a, this._yi = e2, this;
      }, l2.prototype.lineTo = function(a, e2) {
        var d2 = TE(a - this._xi), y2 = TE(e2 - this._yi), x2 = d2 > this._ux || y2 > this._uy;
        if (this.addData(Kp.L, a, e2), this._ctx && x2 && this._ctx.lineTo(a, e2), x2)
          this._xi = a, this._yi = e2, this._pendingPtDist = 0;
        else {
          var C = d2 * d2 + y2 * y2;
          C > this._pendingPtDist && (this._pendingPtX = a, this._pendingPtY = e2, this._pendingPtDist = C);
        }
        return this;
      }, l2.prototype.bezierCurveTo = function(a, e2, d2, y2, x2, C) {
        return this._drawPendingPt(), this.addData(Kp.C, a, e2, d2, y2, x2, C), this._ctx && this._ctx.bezierCurveTo(a, e2, d2, y2, x2, C), this._xi = x2, this._yi = C, this;
      }, l2.prototype.quadraticCurveTo = function(a, e2, d2, y2) {
        return this._drawPendingPt(), this.addData(Kp.Q, a, e2, d2, y2), this._ctx && this._ctx.quadraticCurveTo(a, e2, d2, y2), this._xi = d2, this._yi = y2, this;
      }, l2.prototype.arc = function(a, e2, d2, y2, x2, C) {
        this._drawPendingPt(), zV[0] = y2, zV[1] = x2, _Pt(zV, C), y2 = zV[0], x2 = zV[1];
        var D2 = x2 - y2;
        return this.addData(Kp.A, a, e2, d2, d2, y2, D2, 0, C ? 0 : 1), this._ctx && this._ctx.arc(a, e2, d2, y2, x2, C), this._xi = mO(x2) * d2 + a, this._yi = K5(x2) * d2 + e2, this;
      }, l2.prototype.arcTo = function(a, e2, d2, y2, x2) {
        return this._drawPendingPt(), this._ctx && this._ctx.arcTo(a, e2, d2, y2, x2), this;
      }, l2.prototype.rect = function(a, e2, d2, y2) {
        return this._drawPendingPt(), this._ctx && this._ctx.rect(a, e2, d2, y2), this.addData(Kp.R, a, e2, d2, y2), this;
      }, l2.prototype.closePath = function() {
        this._drawPendingPt(), this.addData(Kp.Z);
        var a = this._ctx, e2 = this._x0, d2 = this._y0;
        return a && a.closePath(), this._xi = e2, this._yi = d2, this;
      }, l2.prototype.fill = function(a) {
        a && a.fill(), this.toStatic();
      }, l2.prototype.stroke = function(a) {
        a && a.stroke(), this.toStatic();
      }, l2.prototype.len = function() {
        return this._len;
      }, l2.prototype.setData = function(a) {
        var e2 = a.length;
        !(this.data && this.data.length === e2) && Snt && (this.data = new Float32Array(e2));
        for (var d2 = 0; d2 < e2; d2++)
          this.data[d2] = a[d2];
        this._len = e2;
      }, l2.prototype.appendPath = function(a) {
        a instanceof Array || (a = [a]);
        for (var e2 = a.length, d2 = 0, y2 = this._len, x2 = 0; x2 < e2; x2++)
          d2 += a[x2].len();
        Snt && this.data instanceof Float32Array && (this.data = new Float32Array(y2 + d2));
        for (var x2 = 0; x2 < e2; x2++)
          for (var C = a[x2].data, D2 = 0; D2 < C.length; D2++)
            this.data[y2++] = C[D2];
        this._len = y2;
      }, l2.prototype.addData = function(a, e2, d2, y2, x2, C, D2, L, F3) {
        if (this._saveData) {
          var j = this.data;
          this._len + arguments.length > j.length && (this._expandData(), j = this.data);
          for (var U3 = 0; U3 < arguments.length; U3++)
            j[this._len++] = arguments[U3];
        }
      }, l2.prototype._drawPendingPt = function() {
        this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
      }, l2.prototype._expandData = function() {
        if (!(this.data instanceof Array)) {
          for (var a = [], e2 = 0; e2 < this._len; e2++)
            a[e2] = this.data[e2];
          this.data = a;
        }
      }, l2.prototype.toStatic = function() {
        if (this._saveData) {
          this._drawPendingPt();
          var a = this.data;
          a instanceof Array && (a.length = this._len, Snt && this._len > 11 && (this.data = new Float32Array(a)));
        }
      }, l2.prototype.getBoundingRect = function() {
        dA[0] = dA[1] = gA[0] = gA[1] = Number.MAX_VALUE, Y5[0] = Y5[1] = vA[0] = vA[1] = -Number.MAX_VALUE;
        var a = this.data, e2 = 0, d2 = 0, y2 = 0, x2 = 0, C;
        for (C = 0; C < this._len; ) {
          var D2 = a[C++], L = C === 1;
          switch (L && (e2 = a[C], d2 = a[C + 1], y2 = e2, x2 = d2), D2) {
            case Kp.M:
              e2 = y2 = a[C++], d2 = x2 = a[C++], gA[0] = y2, gA[1] = x2, vA[0] = y2, vA[1] = x2;
              break;
            case Kp.L:
              t0t(e2, d2, a[C], a[C + 1], gA, vA), e2 = a[C++], d2 = a[C++];
              break;
            case Kp.C:
              yPt(e2, d2, a[C++], a[C++], a[C++], a[C++], a[C], a[C + 1], gA, vA), e2 = a[C++], d2 = a[C++];
              break;
            case Kp.Q:
              mPt(e2, d2, a[C++], a[C++], a[C], a[C + 1], gA, vA), e2 = a[C++], d2 = a[C++];
              break;
            case Kp.A:
              var F3 = a[C++], j = a[C++], U3 = a[C++], Y3 = a[C++], Q = a[C++], nt = a[C++] + Q;
              C += 1;
              var dt = !a[C++];
              L && (y2 = mO(Q) * U3 + F3, x2 = K5(Q) * Y3 + j), bPt(F3, j, U3, Y3, Q, nt, dt, gA, vA), e2 = mO(nt) * U3 + F3, d2 = K5(nt) * Y3 + j;
              break;
            case Kp.R:
              y2 = e2 = a[C++], x2 = d2 = a[C++];
              var vt = a[C++], Ct = a[C++];
              t0t(y2, x2, y2 + vt, x2 + Ct, gA, vA);
              break;
            case Kp.Z:
              e2 = y2, d2 = x2;
              break;
          }
          vE(dA, dA, gA), nA(Y5, Y5, vA);
        }
        return C === 0 && (dA[0] = dA[1] = Y5[0] = Y5[1] = 0), new Yu(dA[0], dA[1], Y5[0] - dA[0], Y5[1] - dA[1]);
      }, l2.prototype._calculateLength = function() {
        var a = this.data, e2 = this._len, d2 = this._ux, y2 = this._uy, x2 = 0, C = 0, D2 = 0, L = 0;
        this._pathSegLen || (this._pathSegLen = []);
        for (var F3 = this._pathSegLen, j = 0, U3 = 0, Y3 = 0; Y3 < e2; ) {
          var Q = a[Y3++], nt = Y3 === 1;
          nt && (x2 = a[Y3], C = a[Y3 + 1], D2 = x2, L = C);
          var dt = -1;
          switch (Q) {
            case Kp.M:
              x2 = D2 = a[Y3++], C = L = a[Y3++];
              break;
            case Kp.L: {
              var vt = a[Y3++], Ct = a[Y3++], Pt = vt - x2, jt = Ct - C;
              (TE(Pt) > d2 || TE(jt) > y2 || Y3 === e2 - 1) && (dt = Math.sqrt(Pt * Pt + jt * jt), x2 = vt, C = Ct);
              break;
            }
            case Kp.C: {
              var Rt = a[Y3++], le2 = a[Y3++], vt = a[Y3++], Ct = a[Y3++], ne2 = a[Y3++], he2 = a[Y3++];
              dt = x5t(x2, C, Rt, le2, vt, Ct, ne2, he2, 10), x2 = ne2, C = he2;
              break;
            }
            case Kp.Q: {
              var Rt = a[Y3++], le2 = a[Y3++], vt = a[Y3++], Ct = a[Y3++];
              dt = Oet(x2, C, Rt, le2, vt, Ct, 10), x2 = vt, C = Ct;
              break;
            }
            case Kp.A:
              var _e = a[Y3++], Me2 = a[Y3++], Pe2 = a[Y3++], Be2 = a[Y3++], Je2 = a[Y3++], Ze2 = a[Y3++], Cn = Ze2 + Je2;
              Y3 += 1, a[Y3++], nt && (D2 = mO(Je2) * Pe2 + _e, L = K5(Je2) * Be2 + Me2), dt = wnt(Pe2, Be2) * xnt(X5, Math.abs(Ze2)), x2 = mO(Cn) * Pe2 + _e, C = K5(Cn) * Be2 + Me2;
              break;
            case Kp.R: {
              D2 = x2 = a[Y3++], L = C = a[Y3++];
              var Bn = a[Y3++], mn = a[Y3++];
              dt = Bn * 2 + mn * 2;
              break;
            }
            case Kp.Z: {
              var Pt = D2 - x2, jt = L - C;
              dt = Math.sqrt(Pt * Pt + jt * jt), x2 = D2, C = L;
              break;
            }
          }
          dt >= 0 && (F3[U3++] = dt, j += dt);
        }
        return this._pathLen = j, j;
      }, l2.prototype.rebuildPath = function(a, e2) {
        var d2 = this.data, y2 = this._ux, x2 = this._uy, C = this._len, D2, L, F3, j, U3, Y3, Q = e2 < 1, nt, dt, vt = 0, Ct = 0, Pt, jt = 0, Rt, le2;
        if (Q && (this._pathSegLen || this._calculateLength(), nt = this._pathSegLen, dt = this._pathLen, Pt = e2 * dt, !Pt))
          return;
        t:
          for (var ne2 = 0; ne2 < C; ) {
            var he2 = d2[ne2++], _e = ne2 === 1;
            switch (_e && (F3 = d2[ne2], j = d2[ne2 + 1], D2 = F3, L = j), he2 !== Kp.L && jt > 0 && (a.lineTo(Rt, le2), jt = 0), he2) {
              case Kp.M:
                D2 = F3 = d2[ne2++], L = j = d2[ne2++], a.moveTo(F3, j);
                break;
              case Kp.L: {
                U3 = d2[ne2++], Y3 = d2[ne2++];
                var Me2 = TE(U3 - F3), Pe2 = TE(Y3 - j);
                if (Me2 > y2 || Pe2 > x2) {
                  if (Q) {
                    var Be2 = nt[Ct++];
                    if (vt + Be2 > Pt) {
                      var Je2 = (Pt - vt) / Be2;
                      a.lineTo(F3 * (1 - Je2) + U3 * Je2, j * (1 - Je2) + Y3 * Je2);
                      break t;
                    }
                    vt += Be2;
                  }
                  a.lineTo(U3, Y3), F3 = U3, j = Y3, jt = 0;
                } else {
                  var Ze2 = Me2 * Me2 + Pe2 * Pe2;
                  Ze2 > jt && (Rt = U3, le2 = Y3, jt = Ze2);
                }
                break;
              }
              case Kp.C: {
                var Cn = d2[ne2++], Bn = d2[ne2++], mn = d2[ne2++], Kr = d2[ne2++], Kn = d2[ne2++], ar = d2[ne2++];
                if (Q) {
                  var Be2 = nt[Ct++];
                  if (vt + Be2 > Pt) {
                    var Je2 = (Pt - vt) / Be2;
                    bE(F3, Cn, mn, Kn, Je2, $5), bE(j, Bn, Kr, ar, Je2, yO), a.bezierCurveTo($5[1], yO[1], $5[2], yO[2], $5[3], yO[3]);
                    break t;
                  }
                  vt += Be2;
                }
                a.bezierCurveTo(Cn, Bn, mn, Kr, Kn, ar), F3 = Kn, j = ar;
                break;
              }
              case Kp.Q: {
                var Cn = d2[ne2++], Bn = d2[ne2++], mn = d2[ne2++], Kr = d2[ne2++];
                if (Q) {
                  var Be2 = nt[Ct++];
                  if (vt + Be2 > Pt) {
                    var Je2 = (Pt - vt) / Be2;
                    _N(F3, Cn, mn, Je2, $5), _N(j, Bn, Kr, Je2, yO), a.quadraticCurveTo($5[1], yO[1], $5[2], yO[2]);
                    break t;
                  }
                  vt += Be2;
                }
                a.quadraticCurveTo(Cn, Bn, mn, Kr), F3 = mn, j = Kr;
                break;
              }
              case Kp.A:
                var Cr = d2[ne2++], ui2 = d2[ne2++], vi2 = d2[ne2++], ko = d2[ne2++], Ss = d2[ne2++], hl = d2[ne2++], Qs = d2[ne2++], Js = !d2[ne2++], rs = vi2 > ko ? vi2 : ko, Gs = TE(vi2 - ko) > 1e-3, al = Ss + hl, _s = false;
                if (Q) {
                  var Be2 = nt[Ct++];
                  vt + Be2 > Pt && (al = Ss + hl * (Pt - vt) / Be2, _s = true), vt += Be2;
                }
                if (Gs && a.ellipse ? a.ellipse(Cr, ui2, vi2, ko, Qs, Ss, al, Js) : a.arc(Cr, ui2, rs, Ss, al, Js), _s)
                  break t;
                _e && (D2 = mO(Ss) * vi2 + Cr, L = K5(Ss) * ko + ui2), F3 = mO(al) * vi2 + Cr, j = K5(al) * ko + ui2;
                break;
              case Kp.R:
                D2 = F3 = d2[ne2], L = j = d2[ne2 + 1], U3 = d2[ne2++], Y3 = d2[ne2++];
                var Fl = d2[ne2++], Ih2 = d2[ne2++];
                if (Q) {
                  var Be2 = nt[Ct++];
                  if (vt + Be2 > Pt) {
                    var lu = Pt - vt;
                    a.moveTo(U3, Y3), a.lineTo(U3 + xnt(lu, Fl), Y3), lu -= Fl, lu > 0 && a.lineTo(U3 + Fl, Y3 + xnt(lu, Ih2)), lu -= Ih2, lu > 0 && a.lineTo(U3 + wnt(Fl - lu, 0), Y3 + Ih2), lu -= Fl, lu > 0 && a.lineTo(U3, Y3 + wnt(Ih2 - lu, 0));
                    break t;
                  }
                  vt += Be2;
                }
                a.rect(U3, Y3, Fl, Ih2);
                break;
              case Kp.Z:
                if (Q) {
                  var Be2 = nt[Ct++];
                  if (vt + Be2 > Pt) {
                    var Je2 = (Pt - vt) / Be2;
                    a.lineTo(F3 * (1 - Je2) + D2 * Je2, j * (1 - Je2) + L * Je2);
                    break t;
                  }
                  vt += Be2;
                }
                a.closePath(), F3 = D2, j = L;
            }
          }
      }, l2.prototype.clone = function() {
        var a = new l2(), e2 = this.data;
        return a.data = e2.slice ? e2.slice() : Array.prototype.slice.call(e2), a._len = this._len, a;
      }, l2.CMD = Kp, l2.initDefaultProps = function() {
        var a = l2.prototype;
        a._saveData = true, a._ux = 0, a._uy = 0, a._pendingPtDist = 0, a._version = 0;
      }(), l2;
    }(), yA = xPt;
    function Q5(l2, a, e2, d2, y2, x2, C) {
      if (y2 === 0)
        return false;
      var D2 = y2, L = 0, F3 = l2;
      if (C > a + D2 && C > d2 + D2 || C < a - D2 && C < d2 - D2 || x2 > l2 + D2 && x2 > e2 + D2 || x2 < l2 - D2 && x2 < e2 - D2)
        return false;
      if (l2 !== e2)
        L = (a - d2) / (l2 - e2), F3 = (l2 * d2 - e2 * a) / (l2 - e2);
      else
        return Math.abs(x2 - l2) <= D2 / 2;
      var j = L * x2 - C + F3, U3 = j * j / (L * L + 1);
      return U3 <= D2 / 2 * D2 / 2;
    }
    function wPt(l2, a, e2, d2, y2, x2, C, D2, L, F3, j) {
      if (L === 0)
        return false;
      var U3 = L;
      if (j > a + U3 && j > d2 + U3 && j > x2 + U3 && j > D2 + U3 || j < a - U3 && j < d2 - U3 && j < x2 - U3 && j < D2 - U3 || F3 > l2 + U3 && F3 > e2 + U3 && F3 > y2 + U3 && F3 > C + U3 || F3 < l2 - U3 && F3 < e2 - U3 && F3 < y2 - U3 && F3 < C - U3)
        return false;
      var Y3 = lvt(l2, a, e2, d2, y2, x2, C, D2, F3, j, null);
      return Y3 <= U3 / 2;
    }
    function r0t(l2, a, e2, d2, y2, x2, C, D2, L) {
      if (C === 0)
        return false;
      var F3 = C;
      if (L > a + F3 && L > d2 + F3 && L > x2 + F3 || L < a - F3 && L < d2 - F3 && L < x2 - F3 || D2 > l2 + F3 && D2 > e2 + F3 && D2 > y2 + F3 || D2 < l2 - F3 && D2 < e2 - F3 && D2 < y2 - F3)
        return false;
      var j = cvt(l2, a, e2, d2, y2, x2, D2, L, null);
      return j <= F3 / 2;
    }
    var i0t = Math.PI * 2;
    function J5(l2) {
      return l2 %= i0t, l2 < 0 && (l2 += i0t), l2;
    }
    var jV = Math.PI * 2;
    function SPt(l2, a, e2, d2, y2, x2, C, D2, L) {
      if (C === 0)
        return false;
      var F3 = C;
      D2 -= l2, L -= a;
      var j = Math.sqrt(D2 * D2 + L * L);
      if (j - F3 > e2 || j + F3 < e2)
        return false;
      if (Math.abs(d2 - y2) % jV < 1e-4)
        return true;
      if (x2) {
        var U3 = d2;
        d2 = J5(y2), y2 = J5(U3);
      } else
        d2 = J5(d2), y2 = J5(y2);
      d2 > y2 && (y2 += jV);
      var Y3 = Math.atan2(L, D2);
      return Y3 < 0 && (Y3 += jV), Y3 >= d2 && Y3 <= y2 || Y3 + jV >= d2 && Y3 + jV <= y2;
    }
    function AE(l2, a, e2, d2, y2, x2) {
      if (x2 > a && x2 > d2 || x2 < a && x2 < d2 || d2 === a)
        return 0;
      var C = (x2 - a) / (d2 - a), D2 = d2 < a ? 1 : -1;
      (C === 1 || C === 0) && (D2 = d2 < a ? 0.5 : -0.5);
      var L = C * (e2 - l2) + l2;
      return L === y2 ? 1 / 0 : L > y2 ? D2 : 0;
    }
    var tP = yA.CMD, eP = Math.PI * 2, a0t = 1e-4;
    function MPt(l2, a) {
      return Math.abs(l2 - a) < a0t;
    }
    var P_ = [-1, -1, -1], K2 = [-1, -1];
    function CPt() {
      var l2 = K2[0];
      K2[0] = K2[1], K2[1] = l2;
    }
    function mq(l2, a, e2, d2, y2, x2, C, D2, L, F3) {
      if (F3 > a && F3 > d2 && F3 > x2 && F3 > D2 || F3 < a && F3 < d2 && F3 < x2 && F3 < D2)
        return 0;
      var j = bN(a, d2, x2, D2, F3, P_);
      if (j === 0)
        return 0;
      for (var U3 = 0, Y3 = -1, Q = void 0, nt = void 0, dt = 0; dt < j; dt++) {
        var vt = P_[dt], Ct = vt === 0 || vt === 1 ? 0.5 : 1, Pt = m0(l2, e2, y2, C, vt);
        Pt < L || (Y3 < 0 && (Y3 = svt(a, d2, x2, D2, K2), K2[1] < K2[0] && Y3 > 1 && CPt(), Q = m0(a, d2, x2, D2, K2[0]), Y3 > 1 && (nt = m0(a, d2, x2, D2, K2[1]))), Y3 === 2 ? vt < K2[0] ? U3 += Q < a ? Ct : -Ct : vt < K2[1] ? U3 += nt < Q ? Ct : -Ct : U3 += D2 < nt ? Ct : -Ct : vt < K2[0] ? U3 += Q < a ? Ct : -Ct : U3 += D2 < Q ? Ct : -Ct);
      }
      return U3;
    }
    function TPt(l2, a, e2, d2, y2, x2, C, D2) {
      if (D2 > a && D2 > d2 && D2 > x2 || D2 < a && D2 < d2 && D2 < x2)
        return 0;
      var L = w5t(a, d2, x2, D2, P_);
      if (L === 0)
        return 0;
      var F3 = uvt(a, d2, x2);
      if (F3 >= 0 && F3 <= 1) {
        for (var j = 0, U3 = sp(a, d2, x2, F3), Y3 = 0; Y3 < L; Y3++) {
          var Q = P_[Y3] === 0 || P_[Y3] === 1 ? 0.5 : 1, nt = sp(l2, e2, y2, P_[Y3]);
          nt < C || (P_[Y3] < F3 ? j += U3 < a ? Q : -Q : j += x2 < U3 ? Q : -Q);
        }
        return j;
      } else {
        var Q = P_[0] === 0 || P_[0] === 1 ? 0.5 : 1, nt = sp(l2, e2, y2, P_[0]);
        return nt < C ? 0 : x2 < a ? Q : -Q;
      }
    }
    function APt(l2, a, e2, d2, y2, x2, C, D2) {
      if (D2 -= a, D2 > e2 || D2 < -e2)
        return 0;
      var L = Math.sqrt(e2 * e2 - D2 * D2);
      P_[0] = -L, P_[1] = L;
      var F3 = Math.abs(d2 - y2);
      if (F3 < 1e-4)
        return 0;
      if (F3 >= eP - 1e-4) {
        d2 = 0, y2 = eP;
        var j = x2 ? 1 : -1;
        return C >= P_[0] + l2 && C <= P_[1] + l2 ? j : 0;
      }
      if (d2 > y2) {
        var U3 = d2;
        d2 = y2, y2 = U3;
      }
      d2 < 0 && (d2 += eP, y2 += eP);
      for (var Y3 = 0, Q = 0; Q < 2; Q++) {
        var nt = P_[Q];
        if (nt + l2 > C) {
          var dt = Math.atan2(D2, nt), j = x2 ? 1 : -1;
          dt < 0 && (dt = eP + dt), (dt >= d2 && dt <= y2 || dt + eP >= d2 && dt + eP <= y2) && (dt > Math.PI / 2 && dt < Math.PI * 1.5 && (j = -j), Y3 += j);
        }
      }
      return Y3;
    }
    function o0t(l2, a, e2, d2, y2) {
      for (var x2 = l2.data, C = l2.len(), D2 = 0, L = 0, F3 = 0, j = 0, U3 = 0, Y3, Q, nt = 0; nt < C; ) {
        var dt = x2[nt++], vt = nt === 1;
        switch (dt === tP.M && nt > 1 && (e2 || (D2 += AE(L, F3, j, U3, d2, y2))), vt && (L = x2[nt], F3 = x2[nt + 1], j = L, U3 = F3), dt) {
          case tP.M:
            j = x2[nt++], U3 = x2[nt++], L = j, F3 = U3;
            break;
          case tP.L:
            if (e2) {
              if (Q5(L, F3, x2[nt], x2[nt + 1], a, d2, y2))
                return true;
            } else
              D2 += AE(L, F3, x2[nt], x2[nt + 1], d2, y2) || 0;
            L = x2[nt++], F3 = x2[nt++];
            break;
          case tP.C:
            if (e2) {
              if (wPt(L, F3, x2[nt++], x2[nt++], x2[nt++], x2[nt++], x2[nt], x2[nt + 1], a, d2, y2))
                return true;
            } else
              D2 += mq(L, F3, x2[nt++], x2[nt++], x2[nt++], x2[nt++], x2[nt], x2[nt + 1], d2, y2) || 0;
            L = x2[nt++], F3 = x2[nt++];
            break;
          case tP.Q:
            if (e2) {
              if (r0t(L, F3, x2[nt++], x2[nt++], x2[nt], x2[nt + 1], a, d2, y2))
                return true;
            } else
              D2 += TPt(L, F3, x2[nt++], x2[nt++], x2[nt], x2[nt + 1], d2, y2) || 0;
            L = x2[nt++], F3 = x2[nt++];
            break;
          case tP.A:
            var Ct = x2[nt++], Pt = x2[nt++], jt = x2[nt++], Rt = x2[nt++], le2 = x2[nt++], ne2 = x2[nt++];
            nt += 1;
            var he2 = !!(1 - x2[nt++]);
            Y3 = Math.cos(le2) * jt + Ct, Q = Math.sin(le2) * Rt + Pt, vt ? (j = Y3, U3 = Q) : D2 += AE(L, F3, Y3, Q, d2, y2);
            var _e = (d2 - Ct) * Rt / jt + Ct;
            if (e2) {
              if (SPt(Ct, Pt, Rt, le2, le2 + ne2, he2, a, _e, y2))
                return true;
            } else
              D2 += APt(Ct, Pt, Rt, le2, le2 + ne2, he2, _e, y2);
            L = Math.cos(le2 + ne2) * jt + Ct, F3 = Math.sin(le2 + ne2) * Rt + Pt;
            break;
          case tP.R:
            j = L = x2[nt++], U3 = F3 = x2[nt++];
            var Me2 = x2[nt++], Pe2 = x2[nt++];
            if (Y3 = j + Me2, Q = U3 + Pe2, e2) {
              if (Q5(j, U3, Y3, U3, a, d2, y2) || Q5(Y3, U3, Y3, Q, a, d2, y2) || Q5(Y3, Q, j, Q, a, d2, y2) || Q5(j, Q, j, U3, a, d2, y2))
                return true;
            } else
              D2 += AE(Y3, U3, Y3, Q, d2, y2), D2 += AE(j, Q, j, U3, d2, y2);
            break;
          case tP.Z:
            if (e2) {
              if (Q5(L, F3, j, U3, a, d2, y2))
                return true;
            } else
              D2 += AE(L, F3, j, U3, d2, y2);
            L = j, F3 = U3;
            break;
        }
      }
      return !e2 && !MPt(F3, U3) && (D2 += AE(L, F3, j, U3, d2, y2) || 0), D2 !== 0;
    }
    function IPt(l2, a, e2) {
      return o0t(l2, 0, false, a, e2);
    }
    function DPt(l2, a, e2, d2) {
      return o0t(l2, a, true, e2, d2);
    }
    var bq = El({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, gO), EPt = { style: El({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, pq.style) }, Cnt = uA.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), kPt = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.update = function() {
        var e2 = this;
        l2.prototype.update.call(this);
        var d2 = this.style;
        if (d2.decal) {
          var y2 = this._decalEl = this._decalEl || new a();
          y2.buildPath === a.prototype.buildPath && (y2.buildPath = function(L) {
            e2.buildPath(L, e2.shape);
          }), y2.silent = true;
          var x2 = y2.style;
          for (var C in d2)
            x2[C] !== d2[C] && (x2[C] = d2[C]);
          x2.fill = d2.fill ? d2.decal : null, x2.decal = null, x2.shadowColor = null, d2.strokeFirst && (x2.stroke = null);
          for (var D2 = 0; D2 < Cnt.length; ++D2)
            y2[Cnt[D2]] = this[Cnt[D2]];
          y2.__dirty |= yb2;
        } else
          this._decalEl && (this._decalEl = null);
      }, a.prototype.getDecalElement = function() {
        return this._decalEl;
      }, a.prototype._init = function(e2) {
        var d2 = Qc2(e2);
        this.shape = this.getDefaultShape();
        var y2 = this.getDefaultStyle();
        y2 && this.useStyle(y2);
        for (var x2 = 0; x2 < d2.length; x2++) {
          var C = d2[x2], D2 = e2[C];
          C === "style" ? this.style ? la2(this.style, D2) : this.useStyle(D2) : C === "shape" ? la2(this.shape, D2) : l2.prototype.attrKV.call(this, C, D2);
        }
        this.style || this.useStyle({});
      }, a.prototype.getDefaultStyle = function() {
        return null;
      }, a.prototype.getDefaultShape = function() {
        return {};
      }, a.prototype.canBeInsideText = function() {
        return this.hasFill();
      }, a.prototype.getInsideTextFill = function() {
        var e2 = this.style.fill;
        if (e2 !== "none") {
          if (ps(e2)) {
            var d2 = jU(e2, 0);
            return d2 > 0.5 ? $U : d2 > 0.2 ? F5t : LV;
          } else if (e2)
            return LV;
        }
        return $U;
      }, a.prototype.getInsideTextStroke = function(e2) {
        var d2 = this.style.fill;
        if (ps(d2)) {
          var y2 = this.__zr, x2 = !!(y2 && y2.isDarkMode()), C = jU(e2, 0) < $et;
          if (x2 === C)
            return d2;
        }
      }, a.prototype.buildPath = function(e2, d2, y2) {
      }, a.prototype.pathUpdated = function() {
        this.__dirty &= ~vN;
      }, a.prototype.getUpdatedPathProxy = function(e2) {
        return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, e2), this.path;
      }, a.prototype.createPathProxy = function() {
        this.path = new yA(false);
      }, a.prototype.hasStroke = function() {
        var e2 = this.style, d2 = e2.stroke;
        return !(d2 == null || d2 === "none" || !(e2.lineWidth > 0));
      }, a.prototype.hasFill = function() {
        var e2 = this.style, d2 = e2.fill;
        return d2 != null && d2 !== "none";
      }, a.prototype.getBoundingRect = function() {
        var e2 = this._rect, d2 = this.style, y2 = !e2;
        if (y2) {
          var x2 = false;
          this.path || (x2 = true, this.createPathProxy());
          var C = this.path;
          (x2 || this.__dirty & vN) && (C.beginPath(), this.buildPath(C, this.shape, false), this.pathUpdated()), e2 = C.getBoundingRect();
        }
        if (this._rect = e2, this.hasStroke() && this.path && this.path.len() > 0) {
          var D2 = this._rectStroke || (this._rectStroke = e2.clone());
          if (this.__dirty || y2) {
            D2.copy(e2);
            var L = d2.strokeNoScale ? this.getLineScale() : 1, F3 = d2.lineWidth;
            if (!this.hasFill()) {
              var j = this.strokeContainThreshold;
              F3 = Math.max(F3, j == null ? 4 : j);
            }
            L > 1e-10 && (D2.width += F3 / L, D2.height += F3 / L, D2.x -= F3 / L / 2, D2.y -= F3 / L / 2);
          }
          return D2;
        }
        return e2;
      }, a.prototype.contain = function(e2, d2) {
        var y2 = this.transformCoordToLocal(e2, d2), x2 = this.getBoundingRect(), C = this.style;
        if (e2 = y2[0], d2 = y2[1], x2.contain(e2, d2)) {
          var D2 = this.path;
          if (this.hasStroke()) {
            var L = C.lineWidth, F3 = C.strokeNoScale ? this.getLineScale() : 1;
            if (F3 > 1e-10 && (this.hasFill() || (L = Math.max(L, this.strokeContainThreshold)), DPt(D2, L / F3, e2, d2)))
              return true;
          }
          if (this.hasFill())
            return IPt(D2, e2, d2);
        }
        return false;
      }, a.prototype.dirtyShape = function() {
        this.__dirty |= vN, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
      }, a.prototype.dirty = function() {
        this.dirtyStyle(), this.dirtyShape();
      }, a.prototype.animateShape = function(e2) {
        return this.animate("shape", e2);
      }, a.prototype.updateDuringAnimation = function(e2) {
        e2 === "style" ? this.dirtyStyle() : e2 === "shape" ? this.dirtyShape() : this.markRedraw();
      }, a.prototype.attrKV = function(e2, d2) {
        e2 === "shape" ? this.setShape(d2) : l2.prototype.attrKV.call(this, e2, d2);
      }, a.prototype.setShape = function(e2, d2) {
        var y2 = this.shape;
        return y2 || (y2 = this.shape = {}), typeof e2 == "string" ? y2[e2] = d2 : la2(y2, e2), this.dirtyShape(), this;
      }, a.prototype.shapeChanged = function() {
        return !!(this.__dirty & vN);
      }, a.prototype.createStyle = function(e2) {
        return vV(bq, e2);
      }, a.prototype._innerSaveToNormal = function(e2) {
        l2.prototype._innerSaveToNormal.call(this, e2);
        var d2 = this._normalState;
        e2.shape && !d2.shape && (d2.shape = la2({}, this.shape));
      }, a.prototype._applyStateObj = function(e2, d2, y2, x2, C, D2) {
        l2.prototype._applyStateObj.call(this, e2, d2, y2, x2, C, D2);
        var L = !(d2 && x2), F3;
        if (d2 && d2.shape ? C ? x2 ? F3 = d2.shape : (F3 = la2({}, y2.shape), la2(F3, d2.shape)) : (F3 = la2({}, x2 ? this.shape : y2.shape), la2(F3, d2.shape)) : L && (F3 = y2.shape), F3)
          if (C) {
            this.shape = la2({}, this.shape);
            for (var j = {}, U3 = Qc2(F3), Y3 = 0; Y3 < U3.length; Y3++) {
              var Q = U3[Y3];
              typeof F3[Q] == "object" ? this.shape[Q] = F3[Q] : j[Q] = F3[Q];
            }
            this._transitionState(e2, { shape: j }, D2);
          } else
            this.shape = F3, this.dirtyShape();
      }, a.prototype._mergeStates = function(e2) {
        for (var d2 = l2.prototype._mergeStates.call(this, e2), y2, x2 = 0; x2 < e2.length; x2++) {
          var C = e2[x2];
          C.shape && (y2 = y2 || {}, this._mergeStyle(y2, C.shape));
        }
        return y2 && (d2.shape = y2), d2;
      }, a.prototype.getAnimationStyleProps = function() {
        return EPt;
      }, a.prototype.isZeroArea = function() {
        return false;
      }, a.extend = function(e2) {
        var d2 = function(x2) {
          Jn(C, x2);
          function C(D2) {
            var L = x2.call(this, D2) || this;
            return e2.init && e2.init.call(L, D2), L;
          }
          return C.prototype.getDefaultStyle = function() {
            return zl(e2.style);
          }, C.prototype.getDefaultShape = function() {
            return zl(e2.shape);
          }, C;
        }(a);
        for (var y2 in e2)
          typeof e2[y2] == "function" && (d2.prototype[y2] = e2[y2]);
        return d2;
      }, a.initDefaultProps = function() {
        var e2 = a.prototype;
        e2.type = "path", e2.strokeContainThreshold = 5, e2.segmentIgnoreThreshold = 0, e2.subPixelOptimize = false, e2.autoBatch = false, e2.__dirty = yb2 | Op | vN;
      }(), a;
    }(Y2), wc2 = kPt, PPt = El({ strokeFirst: true, font: Ru, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, bq), WV = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.hasStroke = function() {
        var e2 = this.style, d2 = e2.stroke;
        return d2 != null && d2 !== "none" && e2.lineWidth > 0;
      }, a.prototype.hasFill = function() {
        var e2 = this.style, d2 = e2.fill;
        return d2 != null && d2 !== "none";
      }, a.prototype.createStyle = function(e2) {
        return vV(PPt, e2);
      }, a.prototype.setBoundingRect = function(e2) {
        this._rect = e2;
      }, a.prototype.getBoundingRect = function() {
        var e2 = this.style;
        if (!this._rect) {
          var d2 = e2.text;
          d2 != null ? d2 += "" : d2 = "";
          var y2 = uO(d2, e2.font, e2.textAlign, e2.textBaseline);
          if (y2.x += e2.x || 0, y2.y += e2.y || 0, this.hasStroke()) {
            var x2 = e2.lineWidth;
            y2.x -= x2 / 2, y2.y -= x2 / 2, y2.width += x2, y2.height += x2;
          }
          this._rect = y2;
        }
        return this._rect;
      }, a.initDefaultProps = function() {
        var e2 = a.prototype;
        e2.dirtyRectTolerance = 10;
      }(), a;
    }(Y2);
    WV.prototype.type = "tspan";
    var GV = WV, s0t = El({ x: 0, y: 0 }, gO), l0t = { style: El({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, pq.style) };
    function Tnt(l2) {
      return !!(l2 && typeof l2 != "string" && l2.width && l2.height);
    }
    var Ant = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.createStyle = function(e2) {
        return vV(s0t, e2);
      }, a.prototype._getSize = function(e2) {
        var d2 = this.style, y2 = d2[e2];
        if (y2 != null)
          return y2;
        var x2 = Tnt(d2.image) ? d2.image : this.__image;
        if (!x2)
          return 0;
        var C = e2 === "width" ? "height" : "width", D2 = d2[C];
        return D2 == null ? x2[e2] : x2[e2] / x2[C] * D2;
      }, a.prototype.getWidth = function() {
        return this._getSize("width");
      }, a.prototype.getHeight = function() {
        return this._getSize("height");
      }, a.prototype.getAnimationStyleProps = function() {
        return l0t;
      }, a.prototype.getBoundingRect = function() {
        var e2 = this.style;
        return this._rect || (this._rect = new Yu(e2.x || 0, e2.y || 0, this.getWidth(), this.getHeight())), this._rect;
      }, a;
    }(Y2);
    Ant.prototype.type = "image";
    var Im = Ant;
    function u0t(l2, a) {
      var e2 = a.x, d2 = a.y, y2 = a.width, x2 = a.height, C = a.r, D2, L, F3, j;
      y2 < 0 && (e2 = e2 + y2, y2 = -y2), x2 < 0 && (d2 = d2 + x2, x2 = -x2), typeof C == "number" ? D2 = L = F3 = j = C : C instanceof Array ? C.length === 1 ? D2 = L = F3 = j = C[0] : C.length === 2 ? (D2 = F3 = C[0], L = j = C[1]) : C.length === 3 ? (D2 = C[0], L = j = C[1], F3 = C[2]) : (D2 = C[0], L = C[1], F3 = C[2], j = C[3]) : D2 = L = F3 = j = 0;
      var U3;
      D2 + L > y2 && (U3 = D2 + L, D2 *= y2 / U3, L *= y2 / U3), F3 + j > y2 && (U3 = F3 + j, F3 *= y2 / U3, j *= y2 / U3), L + F3 > x2 && (U3 = L + F3, L *= x2 / U3, F3 *= x2 / U3), D2 + j > x2 && (U3 = D2 + j, D2 *= x2 / U3, j *= x2 / U3), l2.moveTo(e2 + D2, d2), l2.lineTo(e2 + y2 - L, d2), L !== 0 && l2.arc(e2 + y2 - L, d2 + L, L, -Math.PI / 2, 0), l2.lineTo(e2 + y2, d2 + x2 - F3), F3 !== 0 && l2.arc(e2 + y2 - F3, d2 + x2 - F3, F3, 0, Math.PI / 2), l2.lineTo(e2 + j, d2 + x2), j !== 0 && l2.arc(e2 + j, d2 + x2 - j, j, Math.PI / 2, Math.PI), l2.lineTo(e2, d2 + D2), D2 !== 0 && l2.arc(e2 + D2, d2 + D2, D2, Math.PI, Math.PI * 1.5);
    }
    var bO = Math.round;
    function c0t(l2, a, e2) {
      if (a) {
        var d2 = a.x1, y2 = a.x2, x2 = a.y1, C = a.y2;
        l2.x1 = d2, l2.x2 = y2, l2.y1 = x2, l2.y2 = C;
        var D2 = e2 && e2.lineWidth;
        return D2 && (bO(d2 * 2) === bO(y2 * 2) && (l2.x1 = l2.x2 = _O(d2, D2, true)), bO(x2 * 2) === bO(C * 2) && (l2.y1 = l2.y2 = _O(x2, D2, true))), l2;
      }
    }
    function f0t(l2, a, e2) {
      if (a) {
        var d2 = a.x, y2 = a.y, x2 = a.width, C = a.height;
        l2.x = d2, l2.y = y2, l2.width = x2, l2.height = C;
        var D2 = e2 && e2.lineWidth;
        return D2 && (l2.x = _O(d2, D2, true), l2.y = _O(y2, D2, true), l2.width = Math.max(_O(d2 + x2, D2, false) - l2.x, x2 === 0 ? 0 : 1), l2.height = Math.max(_O(y2 + C, D2, false) - l2.y, C === 0 ? 0 : 1)), l2;
      }
    }
    function _O(l2, a, e2) {
      if (!a)
        return l2;
      var d2 = bO(l2 * 2);
      return (d2 + bO(a)) % 2 === 0 ? d2 / 2 : (d2 + (e2 ? 1 : -1)) / 2;
    }
    var _q = function() {
      function l2() {
        this.x = 0, this.y = 0, this.width = 0, this.height = 0;
      }
      return l2;
    }(), xq = {}, h0t = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultShape = function() {
        return new _q();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2, x2, C, D2;
        if (this.subPixelOptimize) {
          var L = f0t(xq, d2, this.style);
          y2 = L.x, x2 = L.y, C = L.width, D2 = L.height, L.r = d2.r, d2 = L;
        } else
          y2 = d2.x, x2 = d2.y, C = d2.width, D2 = d2.height;
        d2.r ? u0t(e2, d2) : e2.rect(y2, x2, C, D2);
      }, a.prototype.isZeroArea = function() {
        return !this.shape.width || !this.shape.height;
      }, a;
    }(wc2);
    h0t.prototype.type = "rect";
    var Nf2 = h0t, wq = { fill: "#000" }, Int = 2, LPt = { style: El({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, pq.style) }, p0t = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this) || this;
        return d2.type = "text", d2._children = [], d2._defaultStyle = wq, d2.attr(e2), d2;
      }
      return a.prototype.childrenRef = function() {
        return this._children;
      }, a.prototype.update = function() {
        l2.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
        for (var e2 = 0; e2 < this._children.length; e2++) {
          var d2 = this._children[e2];
          d2.zlevel = this.zlevel, d2.z = this.z, d2.z2 = this.z2, d2.culling = this.culling, d2.cursor = this.cursor, d2.invisible = this.invisible;
        }
      }, a.prototype.updateTransform = function() {
        var e2 = this.innerTransformable;
        e2 ? (e2.updateTransform(), e2.transform && (this.transform = e2.transform)) : l2.prototype.updateTransform.call(this);
      }, a.prototype.getLocalTransform = function(e2) {
        var d2 = this.innerTransformable;
        return d2 ? d2.getLocalTransform(e2) : l2.prototype.getLocalTransform.call(this, e2);
      }, a.prototype.getComputedTransform = function() {
        return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), l2.prototype.getComputedTransform.call(this);
      }, a.prototype._updateSubTexts = function() {
        this._childCursor = 0, NPt(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
      }, a.prototype.addSelfToZr = function(e2) {
        l2.prototype.addSelfToZr.call(this, e2);
        for (var d2 = 0; d2 < this._children.length; d2++)
          this._children[d2].__zr = e2;
      }, a.prototype.removeSelfFromZr = function(e2) {
        l2.prototype.removeSelfFromZr.call(this, e2);
        for (var d2 = 0; d2 < this._children.length; d2++)
          this._children[d2].__zr = null;
      }, a.prototype.getBoundingRect = function() {
        if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
          for (var e2 = new Yu(0, 0, 0, 0), d2 = this._children, y2 = [], x2 = null, C = 0; C < d2.length; C++) {
            var D2 = d2[C], L = D2.getBoundingRect(), F3 = D2.getLocalTransform(y2);
            F3 ? (e2.copy(L), e2.applyTransform(F3), x2 = x2 || e2.clone(), x2.union(e2)) : (x2 = x2 || L.clone(), x2.union(L));
          }
          this._rect = x2 || e2;
        }
        return this._rect;
      }, a.prototype.setDefaultTextStyle = function(e2) {
        this._defaultStyle = e2 || wq;
      }, a.prototype.setTextContent = function(e2) {
      }, a.prototype._mergeStyle = function(e2, d2) {
        if (!d2)
          return e2;
        var y2 = d2.rich, x2 = e2.rich || y2 && {};
        return la2(e2, d2), y2 && x2 ? (this._mergeRich(x2, y2), e2.rich = x2) : x2 && (e2.rich = x2), e2;
      }, a.prototype._mergeRich = function(e2, d2) {
        for (var y2 = Qc2(d2), x2 = 0; x2 < y2.length; x2++) {
          var C = y2[x2];
          e2[C] = e2[C] || {}, la2(e2[C], d2[C]);
        }
      }, a.prototype.getAnimationStyleProps = function() {
        return LPt;
      }, a.prototype._getOrCreateChild = function(e2) {
        var d2 = this._children[this._childCursor];
        return (!d2 || !(d2 instanceof e2)) && (d2 = new e2()), this._children[this._childCursor++] = d2, d2.__zr = this.__zr, d2.parent = this, d2;
      }, a.prototype._updatePlainTexts = function() {
        var e2 = this.style, d2 = e2.font || Ru, y2 = e2.padding, x2 = x0t(e2), C = lPt(x2, e2), D2 = Dnt(e2), L = !!e2.backgroundColor, F3 = C.outerHeight, j = C.outerWidth, U3 = C.contentWidth, Y3 = C.lines, Q = C.lineHeight, nt = this._defaultStyle, dt = e2.x || 0, vt = e2.y || 0, Ct = e2.align || nt.align || "left", Pt = e2.verticalAlign || nt.verticalAlign || "top", jt = dt, Rt = H5(vt, C.contentHeight, Pt);
        if (D2 || y2) {
          var le2 = PN(dt, j, Ct), ne2 = H5(vt, F3, Pt);
          D2 && this._renderBackground(e2, e2, le2, ne2, j, F3);
        }
        Rt += Q / 2, y2 && (jt = X2(dt, Ct, y2), Pt === "top" ? Rt += y2[0] : Pt === "bottom" && (Rt -= y2[2]));
        for (var he2 = 0, _e = false, Me2 = _0t("fill" in e2 ? e2.fill : (_e = true, nt.fill)), Pe2 = b0t("stroke" in e2 ? e2.stroke : !L && (!nt.autoStroke || _e) ? (he2 = Int, nt.stroke) : null), Be2 = e2.textShadowBlur > 0, Je2 = e2.width != null && (e2.overflow === "truncate" || e2.overflow === "break" || e2.overflow === "breakAll"), Ze2 = C.calculatedLineHeight, Cn = 0; Cn < Y3.length; Cn++) {
          var Bn = this._getOrCreateChild(GV), mn = Bn.createStyle();
          Bn.useStyle(mn), mn.text = Y3[Cn], mn.x = jt, mn.y = Rt, Ct && (mn.textAlign = Ct), mn.textBaseline = "middle", mn.opacity = e2.opacity, mn.strokeFirst = true, Be2 && (mn.shadowBlur = e2.textShadowBlur || 0, mn.shadowColor = e2.textShadowColor || "transparent", mn.shadowOffsetX = e2.textShadowOffsetX || 0, mn.shadowOffsetY = e2.textShadowOffsetY || 0), mn.stroke = Pe2, mn.fill = Me2, Pe2 && (mn.lineWidth = e2.lineWidth || he2, mn.lineDash = e2.lineDash, mn.lineDashOffset = e2.lineDashOffset || 0), mn.font = d2, v0t(mn, e2), Rt += Q, Je2 && Bn.setBoundingRect(new Yu(PN(mn.x, e2.width, mn.textAlign), H5(mn.y, Ze2, mn.textBaseline), U3, Ze2));
        }
      }, a.prototype._updateRichTexts = function() {
        var e2 = this.style, d2 = x0t(e2), y2 = fPt(d2, e2), x2 = y2.width, C = y2.outerWidth, D2 = y2.outerHeight, L = e2.padding, F3 = e2.x || 0, j = e2.y || 0, U3 = this._defaultStyle, Y3 = e2.align || U3.align, Q = e2.verticalAlign || U3.verticalAlign, nt = PN(F3, C, Y3), dt = H5(j, D2, Q), vt = nt, Ct = dt;
        L && (vt += L[3], Ct += L[0]);
        var Pt = vt + x2;
        Dnt(e2) && this._renderBackground(e2, e2, nt, dt, C, D2);
        for (var jt = !!e2.backgroundColor, Rt = 0; Rt < y2.lines.length; Rt++) {
          for (var le2 = y2.lines[Rt], ne2 = le2.tokens, he2 = ne2.length, _e = le2.lineHeight, Me2 = le2.width, Pe2 = 0, Be2 = vt, Je2 = Pt, Ze2 = he2 - 1, Cn = void 0; Pe2 < he2 && (Cn = ne2[Pe2], !Cn.align || Cn.align === "left"); )
            this._placeToken(Cn, e2, _e, Ct, Be2, "left", jt), Me2 -= Cn.width, Be2 += Cn.width, Pe2++;
          for (; Ze2 >= 0 && (Cn = ne2[Ze2], Cn.align === "right"); )
            this._placeToken(Cn, e2, _e, Ct, Je2, "right", jt), Me2 -= Cn.width, Je2 -= Cn.width, Ze2--;
          for (Be2 += (x2 - (Be2 - vt) - (Pt - Je2) - Me2) / 2; Pe2 <= Ze2; )
            Cn = ne2[Pe2], this._placeToken(Cn, e2, _e, Ct, Be2 + Cn.width / 2, "center", jt), Be2 += Cn.width, Pe2++;
          Ct += _e;
        }
      }, a.prototype._placeToken = function(e2, d2, y2, x2, C, D2, L) {
        var F3 = d2.rich[e2.styleName] || {};
        F3.text = e2.text;
        var j = e2.verticalAlign, U3 = x2 + y2 / 2;
        j === "top" ? U3 = x2 + e2.height / 2 : j === "bottom" && (U3 = x2 + y2 - e2.height / 2);
        var Y3 = !e2.isLineHolder && Dnt(F3);
        Y3 && this._renderBackground(F3, d2, D2 === "right" ? C - e2.width : D2 === "center" ? C - e2.width / 2 : C, U3 - e2.height / 2, e2.width, e2.height);
        var Q = !!F3.backgroundColor, nt = e2.textPadding;
        nt && (C = X2(C, D2, nt), U3 -= e2.height / 2 - nt[0] - e2.innerHeight / 2);
        var dt = this._getOrCreateChild(GV), vt = dt.createStyle();
        dt.useStyle(vt);
        var Ct = this._defaultStyle, Pt = false, jt = 0, Rt = _0t("fill" in F3 ? F3.fill : "fill" in d2 ? d2.fill : (Pt = true, Ct.fill)), le2 = b0t("stroke" in F3 ? F3.stroke : "stroke" in d2 ? d2.stroke : !Q && !L && (!Ct.autoStroke || Pt) ? (jt = Int, Ct.stroke) : null), ne2 = F3.textShadowBlur > 0 || d2.textShadowBlur > 0;
        vt.text = e2.text, vt.x = C, vt.y = U3, ne2 && (vt.shadowBlur = F3.textShadowBlur || d2.textShadowBlur || 0, vt.shadowColor = F3.textShadowColor || d2.textShadowColor || "transparent", vt.shadowOffsetX = F3.textShadowOffsetX || d2.textShadowOffsetX || 0, vt.shadowOffsetY = F3.textShadowOffsetY || d2.textShadowOffsetY || 0), vt.textAlign = D2, vt.textBaseline = "middle", vt.font = e2.font || Ru, vt.opacity = uv(F3.opacity, d2.opacity, 1), v0t(vt, F3), le2 && (vt.lineWidth = uv(F3.lineWidth, d2.lineWidth, jt), vt.lineDash = $u(F3.lineDash, d2.lineDash), vt.lineDashOffset = d2.lineDashOffset || 0, vt.stroke = le2), Rt && (vt.fill = Rt);
        var he2 = e2.contentWidth, _e = e2.contentHeight;
        dt.setBoundingRect(new Yu(PN(vt.x, he2, vt.textAlign), H5(vt.y, _e, vt.textBaseline), he2, _e));
      }, a.prototype._renderBackground = function(e2, d2, y2, x2, C, D2) {
        var L = e2.backgroundColor, F3 = e2.borderWidth, j = e2.borderColor, U3 = L && L.image, Y3 = L && !U3, Q = e2.borderRadius, nt = this, dt, vt;
        if (Y3 || e2.lineHeight || F3 && j) {
          dt = this._getOrCreateChild(Nf2), dt.useStyle(dt.createStyle()), dt.style.fill = null;
          var Ct = dt.shape;
          Ct.x = y2, Ct.y = x2, Ct.width = C, Ct.height = D2, Ct.r = Q, dt.dirtyShape();
        }
        if (Y3) {
          var Pt = dt.style;
          Pt.fill = L || null, Pt.fillOpacity = $u(e2.fillOpacity, 1);
        } else if (U3) {
          vt = this._getOrCreateChild(Im), vt.onload = function() {
            nt.dirtyStyle();
          };
          var jt = vt.style;
          jt.image = L.image, jt.x = y2, jt.y = x2, jt.width = C, jt.height = D2;
        }
        if (F3 && j) {
          var Pt = dt.style;
          Pt.lineWidth = F3, Pt.stroke = j, Pt.strokeOpacity = $u(e2.strokeOpacity, 1), Pt.lineDash = e2.borderDash, Pt.lineDashOffset = e2.borderDashOffset || 0, dt.strokeContainThreshold = 0, dt.hasFill() && dt.hasStroke() && (Pt.strokeFirst = true, Pt.lineWidth *= 2);
        }
        var Rt = (dt || vt).style;
        Rt.shadowBlur = e2.shadowBlur || 0, Rt.shadowColor = e2.shadowColor || "transparent", Rt.shadowOffsetX = e2.shadowOffsetX || 0, Rt.shadowOffsetY = e2.shadowOffsetY || 0, Rt.opacity = uv(e2.opacity, d2.opacity, 1);
      }, a.makeFont = function(e2) {
        var d2 = "";
        return y0t(e2) && (d2 = [e2.fontStyle, e2.fontWeight, g0t(e2.fontSize), e2.fontFamily || "sans-serif"].join(" ")), d2 && TS(d2) || e2.textFont || e2.font;
      }, a;
    }(Y2), OPt = { left: true, right: 1, center: 1 }, RPt = { top: 1, bottom: 1, middle: 1 }, d0t = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
    function g0t(l2) {
      return typeof l2 == "string" && (l2.indexOf("px") !== -1 || l2.indexOf("rem") !== -1 || l2.indexOf("em") !== -1) ? l2 : isNaN(+l2) ? Zp + "px" : l2 + "px";
    }
    function v0t(l2, a) {
      for (var e2 = 0; e2 < d0t.length; e2++) {
        var d2 = d0t[e2], y2 = a[d2];
        y2 != null && (l2[d2] = y2);
      }
    }
    function y0t(l2) {
      return l2.fontSize != null || l2.fontFamily || l2.fontWeight;
    }
    function NPt(l2) {
      return m0t(l2), Ke2(l2.rich, m0t), l2;
    }
    function m0t(l2) {
      if (l2) {
        l2.font = p0t.makeFont(l2);
        var a = l2.align;
        a === "middle" && (a = "center"), l2.align = a == null || OPt[a] ? a : "left";
        var e2 = l2.verticalAlign;
        e2 === "center" && (e2 = "middle"), l2.verticalAlign = e2 == null || RPt[e2] ? e2 : "top";
        var d2 = l2.padding;
        d2 && (l2.padding = pE(l2.padding));
      }
    }
    function b0t(l2, a) {
      return l2 == null || a <= 0 || l2 === "transparent" || l2 === "none" ? null : l2.image || l2.colorStops ? "#000" : l2;
    }
    function _0t(l2) {
      return l2 == null || l2 === "none" ? null : l2.image || l2.colorStops ? "#000" : l2;
    }
    function X2(l2, a, e2) {
      return a === "right" ? l2 - e2[1] : a === "center" ? l2 + e2[3] / 2 - e2[1] / 2 : l2 + e2[3];
    }
    function x0t(l2) {
      var a = l2.text;
      return a != null && (a += ""), a;
    }
    function Dnt(l2) {
      return !!(l2.backgroundColor || l2.lineHeight || l2.borderWidth && l2.borderColor);
    }
    var qc2 = p0t, ns = Rf2(), Ent = function(l2, a, e2, d2) {
      if (d2) {
        var y2 = ns(d2);
        y2.dataIndex = e2, y2.dataType = a, y2.seriesIndex = l2, d2.type === "group" && d2.traverse(function(x2) {
          var C = ns(x2);
          C.seriesIndex = l2, C.dataIndex = e2, C.dataType = a;
        });
      }
    }, L_ = 1, b0 = {}, w0t = Rf2(), mA = Rf2(), knt = 0, HV = 1, Sq = 2, O_ = ["emphasis", "blur", "select"], UV = ["normal", "emphasis", "blur", "select"], nP = 10, FPt = 9, R_ = "highlight", qV = "downplay", rP = "select", Zg2 = "unselect", $g2 = "toggleSelect";
    function xO(l2) {
      return l2 != null && l2 !== "none";
    }
    var S0t = new TV(100);
    function M0t(l2) {
      if (ps(l2)) {
        var a = S0t.get(l2);
        return a || (a = Net(l2, -0.1), S0t.put(l2, a)), a;
      } else if (DU(l2)) {
        var e2 = la2({}, l2);
        return e2.colorStops = $a2(l2.colorStops, function(d2) {
          return { offset: d2.offset, color: Net(d2.color, -0.1) };
        }), e2;
      }
      return l2;
    }
    function Mq(l2, a, e2) {
      l2.onHoverStateChange && (l2.hoverState || 0) !== e2 && l2.onHoverStateChange(a), l2.hoverState = e2;
    }
    function C0t(l2) {
      Mq(l2, "emphasis", Sq);
    }
    function T0t(l2) {
      l2.hoverState === Sq && Mq(l2, "normal", knt);
    }
    function Pnt(l2) {
      Mq(l2, "blur", HV);
    }
    function Lnt(l2) {
      l2.hoverState === HV && Mq(l2, "normal", knt);
    }
    function ZV(l2) {
      l2.selected = true;
    }
    function Ont(l2) {
      l2.selected = false;
    }
    function A0t(l2, a, e2) {
      a(l2, e2);
    }
    function bA(l2, a, e2) {
      A0t(l2, a, e2), l2.isGroup && l2.traverse(function(d2) {
        A0t(d2, a, e2);
      });
    }
    function wO(l2, a) {
      switch (a) {
        case "emphasis":
          l2.hoverState = Sq;
          break;
        case "normal":
          l2.hoverState = knt;
          break;
        case "blur":
          l2.hoverState = HV;
          break;
        case "select":
          l2.selected = true;
      }
    }
    function FS(l2, a, e2, d2) {
      for (var y2 = l2.style, x2 = {}, C = 0; C < a.length; C++) {
        var D2 = a[C], L = y2[D2];
        x2[D2] = L == null ? d2 && d2[D2] : L;
      }
      for (var C = 0; C < l2.animators.length; C++) {
        var F3 = l2.animators[C];
        F3.__fromStateTransition && F3.__fromStateTransition.indexOf(e2) < 0 && F3.targetName === "style" && F3.saveTo(x2, a);
      }
      return x2;
    }
    function BN(l2, a, e2, d2) {
      var y2 = e2 && oc2(e2, "select") >= 0, x2 = false;
      if (l2 instanceof wc2) {
        var C = w0t(l2), D2 = y2 && C.selectFill || C.normalFill, L = y2 && C.selectStroke || C.normalStroke;
        if (xO(D2) || xO(L)) {
          d2 = d2 || {};
          var F3 = d2.style || {};
          F3.fill === "inherit" ? (x2 = true, d2 = la2({}, d2), F3 = la2({}, F3), F3.fill = D2) : !xO(F3.fill) && xO(D2) ? (x2 = true, d2 = la2({}, d2), F3 = la2({}, F3), F3.fill = M0t(D2)) : !xO(F3.stroke) && xO(L) && (x2 || (d2 = la2({}, d2), F3 = la2({}, F3)), F3.stroke = M0t(L)), d2.style = F3;
        }
      }
      if (d2 && d2.z2 == null) {
        x2 || (d2 = la2({}, d2));
        var j = l2.z2EmphasisLift;
        d2.z2 = l2.z2 + (j != null ? j : nP);
      }
      return d2;
    }
    function VPt(l2, a, e2) {
      if (e2 && e2.z2 == null) {
        e2 = la2({}, e2);
        var d2 = l2.z2SelectLift;
        e2.z2 = l2.z2 + (d2 != null ? d2 : FPt);
      }
      return e2;
    }
    function BPt(l2, a, e2) {
      var d2 = oc2(l2.currentStates, a) >= 0, y2 = l2.style.opacity, x2 = d2 ? null : FS(l2, ["opacity"], a, { opacity: 1 });
      e2 = e2 || {};
      var C = e2.style || {};
      return C.opacity == null && (e2 = la2({}, e2), C = la2({ opacity: d2 ? y2 : x2.opacity * 0.1 }, C), e2.style = C), e2;
    }
    function Rnt(l2, a) {
      var e2 = this.states[l2];
      if (this.style) {
        if (l2 === "emphasis")
          return BN(this, l2, a, e2);
        if (l2 === "blur")
          return BPt(this, l2, e2);
        if (l2 === "select")
          return VPt(this, l2, e2);
      }
      return e2;
    }
    function SO(l2) {
      l2.stateProxy = Rnt;
      var a = l2.getTextContent(), e2 = l2.getTextGuideLine();
      a && (a.stateProxy = Rnt), e2 && (e2.stateProxy = Rnt);
    }
    function I0t(l2, a) {
      !fd2(l2, a) && !l2.__highByOuter && bA(l2, C0t);
    }
    function Nnt(l2, a) {
      !fd2(l2, a) && !l2.__highByOuter && bA(l2, T0t);
    }
    function Dm(l2, a) {
      l2.__highByOuter |= 1 << (a || 0), bA(l2, C0t);
    }
    function fc2(l2, a) {
      !(l2.__highByOuter &= ~(1 << (a || 0))) && bA(l2, T0t);
    }
    function Fnt(l2) {
      bA(l2, Pnt);
    }
    function VS(l2) {
      bA(l2, Lnt);
    }
    function Vnt(l2) {
      bA(l2, ZV);
    }
    function D0t(l2) {
      bA(l2, Ont);
    }
    function fd2(l2, a) {
      return l2.__highDownSilentOnTouch && a.zrByTouch;
    }
    function E0t(l2) {
      var a = l2.getModel();
      a.eachComponent(function(e2, d2) {
        var y2 = mA(d2);
        if (y2.isBlured) {
          var x2 = e2 === "series" ? l2.getViewOfSeriesModel(d2) : l2.getViewOfComponentModel(d2);
          x2.group.traverse(function(C) {
            Lnt(C);
          });
        }
        y2.isBlured = false;
      });
    }
    function Cq(l2, a, e2, d2) {
      var y2 = d2.getModel();
      e2 = e2 || "coordinateSystem";
      function x2(F3, j) {
        for (var U3 = 0; U3 < j.length; U3++) {
          var Y3 = F3.getItemGraphicEl(j[U3]);
          Y3 && VS(Y3);
        }
      }
      if (l2 != null && !(!a || a === "none")) {
        var C = y2.getSeriesByIndex(l2), D2 = C.coordinateSystem;
        D2 && D2.master && (D2 = D2.master);
        var L = [];
        y2.eachSeries(function(F3) {
          var j = C === F3, U3 = F3.coordinateSystem;
          U3 && U3.master && (U3 = U3.master);
          var Y3 = U3 && D2 ? U3 === D2 : j;
          if (!(e2 === "series" && !j || e2 === "coordinateSystem" && !Y3 || a === "series" && j)) {
            var Q = d2.getViewOfSeriesModel(F3);
            if (Q.group.traverse(function(vt) {
              Pnt(vt);
            }), h1(a))
              x2(F3.getData(), a);
            else if (vs(a))
              for (var nt = Qc2(a), dt = 0; dt < nt.length; dt++)
                x2(F3.getData(nt[dt]), a[nt[dt]]);
            L.push(F3), mA(F3).isBlured = true;
          }
        }), y2.eachComponent(function(F3, j) {
          if (F3 !== "series") {
            var U3 = d2.getViewOfComponentModel(j);
            U3 && U3.blurSeries && U3.blurSeries(L, y2);
          }
        });
      }
    }
    function zN(l2, a, e2) {
      if (!(l2 == null || a == null)) {
        var d2 = e2.getModel().getComponent(l2, a);
        if (d2) {
          mA(d2).isBlured = true;
          var y2 = e2.getViewOfComponentModel(d2);
          !y2 || !y2.focusBlurEnabled || y2.group.traverse(function(x2) {
            Pnt(x2);
          });
        }
      }
    }
    function zPt(l2, a, e2) {
      var d2 = l2.seriesIndex, y2 = l2.getData(a.dataType);
      if (y2) {
        var x2 = fC(y2, a);
        x2 = (Ba2(x2) ? x2[0] : x2) || 0;
        var C = y2.getItemGraphicEl(x2);
        if (!C)
          for (var D2 = y2.count(), L = 0; !C && L < D2; )
            C = y2.getItemGraphicEl(L++);
        if (C) {
          var F3 = ns(C);
          Cq(d2, F3.focus, F3.blurScope, e2);
        } else {
          var j = l2.get(["emphasis", "focus"]), U3 = l2.get(["emphasis", "blurScope"]);
          j != null && Cq(d2, j, U3, e2);
        }
      }
    }
    function Bnt(l2, a, e2, d2) {
      var y2 = { focusSelf: false, dispatchers: null };
      if (l2 == null || l2 === "series" || a == null || e2 == null)
        return y2;
      var x2 = d2.getModel().getComponent(l2, a);
      if (!x2)
        return y2;
      var C = d2.getViewOfComponentModel(x2);
      if (!C || !C.findHighDownDispatchers)
        return y2;
      for (var D2 = C.findHighDownDispatchers(e2), L, F3 = 0; F3 < D2.length; F3++)
        if (ns(D2[F3]).focus === "self") {
          L = true;
          break;
        }
      return { focusSelf: L, dispatchers: D2 };
    }
    function jPt(l2, a, e2) {
      var d2 = ns(l2), y2 = Bnt(d2.componentMainType, d2.componentIndex, d2.componentHighDownName, e2), x2 = y2.dispatchers, C = y2.focusSelf;
      x2 ? (C && zN(d2.componentMainType, d2.componentIndex, e2), Ke2(x2, function(D2) {
        return I0t(D2, a);
      })) : (Cq(d2.seriesIndex, d2.focus, d2.blurScope, e2), d2.focus === "self" && zN(d2.componentMainType, d2.componentIndex, e2), I0t(l2, a));
    }
    function WPt(l2, a, e2) {
      E0t(e2);
      var d2 = ns(l2), y2 = Bnt(d2.componentMainType, d2.componentIndex, d2.componentHighDownName, e2).dispatchers;
      y2 ? Ke2(y2, function(x2) {
        return Nnt(x2, a);
      }) : Nnt(l2, a);
    }
    function GPt(l2, a, e2) {
      if (jnt(a)) {
        var d2 = a.dataType, y2 = l2.getData(d2), x2 = fC(y2, a);
        Ba2(x2) || (x2 = [x2]), l2[a.type === $g2 ? "toggleSelect" : a.type === rP ? "select" : "unselect"](x2, d2);
      }
    }
    function k0t(l2) {
      var a = l2.getAllData();
      Ke2(a, function(e2) {
        var d2 = e2.data, y2 = e2.type;
        d2.eachItemGraphicEl(function(x2, C) {
          l2.isSelected(C, y2) ? Vnt(x2) : D0t(x2);
        });
      });
    }
    function HPt(l2) {
      var a = [];
      return l2.eachSeries(function(e2) {
        var d2 = e2.getAllData();
        Ke2(d2, function(y2) {
          y2.data;
          var x2 = y2.type, C = e2.getSelectedDataIndices();
          if (C.length > 0) {
            var D2 = { dataIndex: C, seriesIndex: e2.seriesIndex };
            x2 != null && (D2.dataType = x2), a.push(D2);
          }
        });
      }), a;
    }
    function MO(l2, a, e2) {
      CO(l2, true), bA(l2, SO), znt(l2, a, e2);
    }
    function UPt(l2) {
      CO(l2, false);
    }
    function n0(l2, a, e2, d2) {
      d2 ? UPt(l2) : MO(l2, a, e2);
    }
    function znt(l2, a, e2) {
      var d2 = ns(l2);
      a != null ? (d2.focus = a, d2.blurScope = e2) : d2.focus && (d2.focus = null);
    }
    var P0t = ["emphasis", "blur", "select"], qPt = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
    function Gy(l2, a, e2, d2) {
      e2 = e2 || "itemStyle";
      for (var y2 = 0; y2 < P0t.length; y2++) {
        var x2 = P0t[y2], C = a.getModel([x2, e2]), D2 = l2.ensureState(x2);
        D2.style = d2 ? d2(C) : C[qPt[e2]]();
      }
    }
    function CO(l2, a) {
      var e2 = a === false, d2 = l2;
      l2.highDownSilentOnTouch && (d2.__highDownSilentOnTouch = l2.highDownSilentOnTouch), (!e2 || d2.__highDownDispatcher) && (d2.__highByOuter = d2.__highByOuter || 0, d2.__highDownDispatcher = !e2);
    }
    function TO(l2) {
      return !!(l2 && l2.__highDownDispatcher);
    }
    function ZPt(l2, a, e2) {
      var d2 = ns(l2);
      d2.componentMainType = a.mainType, d2.componentIndex = a.componentIndex, d2.componentHighDownName = e2;
    }
    function $Pt(l2) {
      var a = b0[l2];
      return a == null && L_ <= 32 && (a = b0[l2] = L_++), a;
    }
    function jnt(l2) {
      var a = l2.type;
      return a === rP || a === Zg2 || a === $g2;
    }
    function Hy(l2) {
      var a = l2.type;
      return a === R_ || a === qV;
    }
    function ew(l2) {
      var a = w0t(l2);
      a.normalFill = l2.style.fill, a.normalStroke = l2.style.stroke;
      var e2 = l2.states.select || {};
      a.selectFill = e2.style && e2.style.fill || null, a.selectStroke = e2.style && e2.style.stroke || null;
    }
    var jN = yA.CMD, YPt = [[], [], []], L0t = Math.sqrt, O0t = Math.atan2;
    function R0t(l2, a) {
      if (a) {
        var e2 = l2.data, d2 = l2.len(), y2, x2, C, D2, L, F3, j = jN.M, U3 = jN.C, Y3 = jN.L, Q = jN.R, nt = jN.A, dt = jN.Q;
        for (C = 0, D2 = 0; C < d2; ) {
          switch (y2 = e2[C++], D2 = C, x2 = 0, y2) {
            case j:
              x2 = 1;
              break;
            case Y3:
              x2 = 1;
              break;
            case U3:
              x2 = 3;
              break;
            case dt:
              x2 = 2;
              break;
            case nt:
              var vt = a[4], Ct = a[5], Pt = L0t(a[0] * a[0] + a[1] * a[1]), jt = L0t(a[2] * a[2] + a[3] * a[3]), Rt = O0t(-a[1] / jt, a[0] / Pt);
              e2[C] *= Pt, e2[C++] += vt, e2[C] *= jt, e2[C++] += Ct, e2[C++] *= Pt, e2[C++] *= jt, e2[C++] += Rt, e2[C++] += Rt, C += 2, D2 = C;
              break;
            case Q:
              F3[0] = e2[C++], F3[1] = e2[C++], Mm(F3, F3, a), e2[D2++] = F3[0], e2[D2++] = F3[1], F3[0] += e2[C++], F3[1] += e2[C++], Mm(F3, F3, a), e2[D2++] = F3[0], e2[D2++] = F3[1];
          }
          for (L = 0; L < x2; L++) {
            var le2 = YPt[L];
            le2[0] = e2[C++], le2[1] = e2[C++], Mm(le2, le2, a), e2[D2++] = le2[0], e2[D2++] = le2[1];
          }
        }
        l2.increaseVersion();
      }
    }
    var Wnt = Math.sqrt, Tq = Math.sin, $V = Math.cos, YV = Math.PI;
    function N0t(l2) {
      return Math.sqrt(l2[0] * l2[0] + l2[1] * l2[1]);
    }
    function Gnt(l2, a) {
      return (l2[0] * a[0] + l2[1] * a[1]) / (N0t(l2) * N0t(a));
    }
    function Hnt(l2, a) {
      return (l2[0] * a[1] < l2[1] * a[0] ? -1 : 1) * Math.acos(Gnt(l2, a));
    }
    function Unt(l2, a, e2, d2, y2, x2, C, D2, L, F3, j) {
      var U3 = L * (YV / 180), Y3 = $V(U3) * (l2 - e2) / 2 + Tq(U3) * (a - d2) / 2, Q = -1 * Tq(U3) * (l2 - e2) / 2 + $V(U3) * (a - d2) / 2, nt = Y3 * Y3 / (C * C) + Q * Q / (D2 * D2);
      nt > 1 && (C *= Wnt(nt), D2 *= Wnt(nt));
      var dt = (y2 === x2 ? -1 : 1) * Wnt((C * C * (D2 * D2) - C * C * (Q * Q) - D2 * D2 * (Y3 * Y3)) / (C * C * (Q * Q) + D2 * D2 * (Y3 * Y3))) || 0, vt = dt * C * Q / D2, Ct = dt * -D2 * Y3 / C, Pt = (l2 + e2) / 2 + $V(U3) * vt - Tq(U3) * Ct, jt = (a + d2) / 2 + Tq(U3) * vt + $V(U3) * Ct, Rt = Hnt([1, 0], [(Y3 - vt) / C, (Q - Ct) / D2]), le2 = [(Y3 - vt) / C, (Q - Ct) / D2], ne2 = [(-1 * Y3 - vt) / C, (-1 * Q - Ct) / D2], he2 = Hnt(le2, ne2);
      if (Gnt(le2, ne2) <= -1 && (he2 = YV), Gnt(le2, ne2) >= 1 && (he2 = 0), he2 < 0) {
        var _e = Math.round(he2 / YV * 1e6) / 1e6;
        he2 = YV * 2 + _e % 2 * YV;
      }
      j.addData(F3, Pt, jt, C, D2, Rt, he2, U3, x2);
    }
    var KPt = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, XPt = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
    function QPt(l2) {
      var a = new yA();
      if (!l2)
        return a;
      var e2 = 0, d2 = 0, y2 = e2, x2 = d2, C, D2 = yA.CMD, L = l2.match(KPt);
      if (!L)
        return a;
      for (var F3 = 0; F3 < L.length; F3++) {
        for (var j = L[F3], U3 = j.charAt(0), Y3 = void 0, Q = j.match(XPt) || [], nt = Q.length, dt = 0; dt < nt; dt++)
          Q[dt] = parseFloat(Q[dt]);
        for (var vt = 0; vt < nt; ) {
          var Ct = void 0, Pt = void 0, jt = void 0, Rt = void 0, le2 = void 0, ne2 = void 0, he2 = void 0, _e = e2, Me2 = d2, Pe2 = void 0, Be2 = void 0;
          switch (U3) {
            case "l":
              e2 += Q[vt++], d2 += Q[vt++], Y3 = D2.L, a.addData(Y3, e2, d2);
              break;
            case "L":
              e2 = Q[vt++], d2 = Q[vt++], Y3 = D2.L, a.addData(Y3, e2, d2);
              break;
            case "m":
              e2 += Q[vt++], d2 += Q[vt++], Y3 = D2.M, a.addData(Y3, e2, d2), y2 = e2, x2 = d2, U3 = "l";
              break;
            case "M":
              e2 = Q[vt++], d2 = Q[vt++], Y3 = D2.M, a.addData(Y3, e2, d2), y2 = e2, x2 = d2, U3 = "L";
              break;
            case "h":
              e2 += Q[vt++], Y3 = D2.L, a.addData(Y3, e2, d2);
              break;
            case "H":
              e2 = Q[vt++], Y3 = D2.L, a.addData(Y3, e2, d2);
              break;
            case "v":
              d2 += Q[vt++], Y3 = D2.L, a.addData(Y3, e2, d2);
              break;
            case "V":
              d2 = Q[vt++], Y3 = D2.L, a.addData(Y3, e2, d2);
              break;
            case "C":
              Y3 = D2.C, a.addData(Y3, Q[vt++], Q[vt++], Q[vt++], Q[vt++], Q[vt++], Q[vt++]), e2 = Q[vt - 2], d2 = Q[vt - 1];
              break;
            case "c":
              Y3 = D2.C, a.addData(Y3, Q[vt++] + e2, Q[vt++] + d2, Q[vt++] + e2, Q[vt++] + d2, Q[vt++] + e2, Q[vt++] + d2), e2 += Q[vt - 2], d2 += Q[vt - 1];
              break;
            case "S":
              Ct = e2, Pt = d2, Pe2 = a.len(), Be2 = a.data, C === D2.C && (Ct += e2 - Be2[Pe2 - 4], Pt += d2 - Be2[Pe2 - 3]), Y3 = D2.C, _e = Q[vt++], Me2 = Q[vt++], e2 = Q[vt++], d2 = Q[vt++], a.addData(Y3, Ct, Pt, _e, Me2, e2, d2);
              break;
            case "s":
              Ct = e2, Pt = d2, Pe2 = a.len(), Be2 = a.data, C === D2.C && (Ct += e2 - Be2[Pe2 - 4], Pt += d2 - Be2[Pe2 - 3]), Y3 = D2.C, _e = e2 + Q[vt++], Me2 = d2 + Q[vt++], e2 += Q[vt++], d2 += Q[vt++], a.addData(Y3, Ct, Pt, _e, Me2, e2, d2);
              break;
            case "Q":
              _e = Q[vt++], Me2 = Q[vt++], e2 = Q[vt++], d2 = Q[vt++], Y3 = D2.Q, a.addData(Y3, _e, Me2, e2, d2);
              break;
            case "q":
              _e = Q[vt++] + e2, Me2 = Q[vt++] + d2, e2 += Q[vt++], d2 += Q[vt++], Y3 = D2.Q, a.addData(Y3, _e, Me2, e2, d2);
              break;
            case "T":
              Ct = e2, Pt = d2, Pe2 = a.len(), Be2 = a.data, C === D2.Q && (Ct += e2 - Be2[Pe2 - 4], Pt += d2 - Be2[Pe2 - 3]), e2 = Q[vt++], d2 = Q[vt++], Y3 = D2.Q, a.addData(Y3, Ct, Pt, e2, d2);
              break;
            case "t":
              Ct = e2, Pt = d2, Pe2 = a.len(), Be2 = a.data, C === D2.Q && (Ct += e2 - Be2[Pe2 - 4], Pt += d2 - Be2[Pe2 - 3]), e2 += Q[vt++], d2 += Q[vt++], Y3 = D2.Q, a.addData(Y3, Ct, Pt, e2, d2);
              break;
            case "A":
              jt = Q[vt++], Rt = Q[vt++], le2 = Q[vt++], ne2 = Q[vt++], he2 = Q[vt++], _e = e2, Me2 = d2, e2 = Q[vt++], d2 = Q[vt++], Y3 = D2.A, Unt(_e, Me2, e2, d2, ne2, he2, jt, Rt, le2, Y3, a);
              break;
            case "a":
              jt = Q[vt++], Rt = Q[vt++], le2 = Q[vt++], ne2 = Q[vt++], he2 = Q[vt++], _e = e2, Me2 = d2, e2 += Q[vt++], d2 += Q[vt++], Y3 = D2.A, Unt(_e, Me2, e2, d2, ne2, he2, jt, Rt, le2, Y3, a);
              break;
          }
        }
        (U3 === "z" || U3 === "Z") && (Y3 = D2.Z, a.addData(Y3), e2 = y2, d2 = x2), C = Y3;
      }
      return a.toStatic(), a;
    }
    var F0t = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.applyTransform = function(e2) {
      }, a;
    }(wc2);
    function AO(l2) {
      return l2.setData != null;
    }
    function V0t(l2, a) {
      var e2 = QPt(l2), d2 = la2({}, a);
      return d2.buildPath = function(y2) {
        if (AO(y2)) {
          y2.setData(e2.data);
          var x2 = y2.getContext();
          x2 && y2.rebuildPath(x2, 1);
        } else {
          var x2 = y2;
          e2.rebuildPath(x2, 1);
        }
      }, d2.applyTransform = function(y2) {
        R0t(e2, y2), this.dirtyShape();
      }, d2;
    }
    function B0t(l2, a) {
      return new F0t(V0t(l2, a));
    }
    function JPt(l2, a) {
      var e2 = V0t(l2, a), d2 = function(y2) {
        Jn(x2, y2);
        function x2(C) {
          var D2 = y2.call(this, C) || this;
          return D2.applyTransform = e2.applyTransform, D2.buildPath = e2.buildPath, D2;
        }
        return x2;
      }(F0t);
      return d2;
    }
    function t3t(l2, a) {
      for (var e2 = [], d2 = l2.length, y2 = 0; y2 < d2; y2++) {
        var x2 = l2[y2];
        e2.push(x2.getUpdatedPathProxy(true));
      }
      var C = new wc2(a);
      return C.createPathProxy(), C.buildPath = function(D2) {
        if (AO(D2)) {
          D2.appendPath(e2);
          var L = D2.getContext();
          L && D2.rebuildPath(L, 1);
        }
      }, C;
    }
    function qnt(l2, a) {
      a = a || {};
      var e2 = new wc2();
      return l2.shape && e2.setShape(l2.shape), e2.setStyle(l2.style), a.bakeTransform ? R0t(e2.path, l2.getComputedTransform()) : a.toLocal ? e2.setLocalTransform(l2.getComputedTransform()) : e2.copyTransform(l2), e2.buildPath = l2.buildPath, e2.applyTransform = e2.applyTransform, e2.z = l2.z, e2.z2 = l2.z2, e2.zlevel = l2.zlevel, e2;
    }
    var z0t = function() {
      function l2() {
        this.cx = 0, this.cy = 0, this.r = 0;
      }
      return l2;
    }(), Znt = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultShape = function() {
        return new z0t();
      }, a.prototype.buildPath = function(e2, d2) {
        e2.moveTo(d2.cx + d2.r, d2.cy), e2.arc(d2.cx, d2.cy, d2.r, 0, Math.PI * 2);
      }, a;
    }(wc2);
    Znt.prototype.type = "circle";
    var _A = Znt, e3t = function() {
      function l2() {
        this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
      }
      return l2;
    }(), j0t = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultShape = function() {
        return new e3t();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = 0.5522848, x2 = d2.cx, C = d2.cy, D2 = d2.rx, L = d2.ry, F3 = D2 * y2, j = L * y2;
        e2.moveTo(x2 - D2, C), e2.bezierCurveTo(x2 - D2, C - j, x2 - F3, C - L, x2, C - L), e2.bezierCurveTo(x2 + F3, C - L, x2 + D2, C - j, x2 + D2, C), e2.bezierCurveTo(x2 + D2, C + j, x2 + F3, C + L, x2, C + L), e2.bezierCurveTo(x2 - F3, C + L, x2 - D2, C + j, x2 - D2, C), e2.closePath();
      }, a;
    }(wc2);
    j0t.prototype.type = "ellipse";
    var $nt = j0t, W0t = Math.PI, Ynt = W0t * 2, IO = Math.sin, WN = Math.cos, n3t = Math.acos, xb2 = Math.atan2, G0t = Math.abs, KV = Math.sqrt, XV = Math.max, xA = Math.min, hC = 1e-4;
    function r3t(l2, a, e2, d2, y2, x2, C, D2) {
      var L = e2 - l2, F3 = d2 - a, j = C - y2, U3 = D2 - x2, Y3 = U3 * L - j * F3;
      if (!(Y3 * Y3 < hC))
        return Y3 = (j * (a - x2) - U3 * (l2 - y2)) / Y3, [l2 + Y3 * L, a + Y3 * F3];
    }
    function Aq(l2, a, e2, d2, y2, x2, C) {
      var D2 = l2 - e2, L = a - d2, F3 = (C ? x2 : -x2) / KV(D2 * D2 + L * L), j = F3 * L, U3 = -F3 * D2, Y3 = l2 + j, Q = a + U3, nt = e2 + j, dt = d2 + U3, vt = (Y3 + nt) / 2, Ct = (Q + dt) / 2, Pt = nt - Y3, jt = dt - Q, Rt = Pt * Pt + jt * jt, le2 = y2 - x2, ne2 = Y3 * dt - nt * Q, he2 = (jt < 0 ? -1 : 1) * KV(XV(0, le2 * le2 * Rt - ne2 * ne2)), _e = (ne2 * jt - Pt * he2) / Rt, Me2 = (-ne2 * Pt - jt * he2) / Rt, Pe2 = (ne2 * jt + Pt * he2) / Rt, Be2 = (-ne2 * Pt + jt * he2) / Rt, Je2 = _e - vt, Ze2 = Me2 - Ct, Cn = Pe2 - vt, Bn = Be2 - Ct;
      return Je2 * Je2 + Ze2 * Ze2 > Cn * Cn + Bn * Bn && (_e = Pe2, Me2 = Be2), { cx: _e, cy: Me2, x0: -j, y0: -U3, x1: _e * (y2 / le2 - 1), y1: Me2 * (y2 / le2 - 1) };
    }
    function i3t(l2) {
      var a;
      if (Ba2(l2)) {
        var e2 = l2.length;
        if (!e2)
          return l2;
        e2 === 1 ? a = [l2[0], l2[0], 0, 0] : e2 === 2 ? a = [l2[0], l2[0], l2[1], l2[1]] : e2 === 3 ? a = l2.concat(l2[2]) : a = l2;
      } else
        a = [l2, l2, l2, l2];
      return a;
    }
    function a3t(l2, a) {
      var e2, d2 = XV(a.r, 0), y2 = XV(a.r0 || 0, 0), x2 = d2 > 0, C = y2 > 0;
      if (!(!x2 && !C)) {
        if (x2 || (d2 = y2, y2 = 0), y2 > d2) {
          var D2 = d2;
          d2 = y2, y2 = D2;
        }
        var L = a.startAngle, F3 = a.endAngle;
        if (!(isNaN(L) || isNaN(F3))) {
          var j = a.cx, U3 = a.cy, Y3 = !!a.clockwise, Q = G0t(F3 - L), nt = Q > Ynt && Q % Ynt;
          if (nt > hC && (Q = nt), !(d2 > hC))
            l2.moveTo(j, U3);
          else if (Q > Ynt - hC)
            l2.moveTo(j + d2 * WN(L), U3 + d2 * IO(L)), l2.arc(j, U3, d2, L, F3, !Y3), y2 > hC && (l2.moveTo(j + y2 * WN(F3), U3 + y2 * IO(F3)), l2.arc(j, U3, y2, F3, L, Y3));
          else {
            var dt = void 0, vt = void 0, Ct = void 0, Pt = void 0, jt = void 0, Rt = void 0, le2 = void 0, ne2 = void 0, he2 = void 0, _e = void 0, Me2 = void 0, Pe2 = void 0, Be2 = void 0, Je2 = void 0, Ze2 = void 0, Cn = void 0, Bn = d2 * WN(L), mn = d2 * IO(L), Kr = y2 * WN(F3), Kn = y2 * IO(F3), ar = Q > hC;
            if (ar) {
              var Cr = a.cornerRadius;
              Cr && (e2 = i3t(Cr), dt = e2[0], vt = e2[1], Ct = e2[2], Pt = e2[3]);
              var ui2 = G0t(d2 - y2) / 2;
              if (jt = xA(ui2, Ct), Rt = xA(ui2, Pt), le2 = xA(ui2, dt), ne2 = xA(ui2, vt), Me2 = he2 = XV(jt, Rt), Pe2 = _e = XV(le2, ne2), (he2 > hC || _e > hC) && (Be2 = d2 * WN(F3), Je2 = d2 * IO(F3), Ze2 = y2 * WN(L), Cn = y2 * IO(L), Q < W0t)) {
                var vi2 = r3t(Bn, mn, Ze2, Cn, Be2, Je2, Kr, Kn);
                if (vi2) {
                  var ko = Bn - vi2[0], Ss = mn - vi2[1], hl = Be2 - vi2[0], Qs = Je2 - vi2[1], Js = 1 / IO(n3t((ko * hl + Ss * Qs) / (KV(ko * ko + Ss * Ss) * KV(hl * hl + Qs * Qs))) / 2), rs = KV(vi2[0] * vi2[0] + vi2[1] * vi2[1]);
                  Me2 = xA(he2, (d2 - rs) / (Js + 1)), Pe2 = xA(_e, (y2 - rs) / (Js - 1));
                }
              }
            }
            if (!ar)
              l2.moveTo(j + Bn, U3 + mn);
            else if (Me2 > hC) {
              var Gs = xA(Ct, Me2), al = xA(Pt, Me2), _s = Aq(Ze2, Cn, Bn, mn, d2, Gs, Y3), Fl = Aq(Be2, Je2, Kr, Kn, d2, al, Y3);
              l2.moveTo(j + _s.cx + _s.x0, U3 + _s.cy + _s.y0), Me2 < he2 && Gs === al ? l2.arc(j + _s.cx, U3 + _s.cy, Me2, xb2(_s.y0, _s.x0), xb2(Fl.y0, Fl.x0), !Y3) : (Gs > 0 && l2.arc(j + _s.cx, U3 + _s.cy, Gs, xb2(_s.y0, _s.x0), xb2(_s.y1, _s.x1), !Y3), l2.arc(j, U3, d2, xb2(_s.cy + _s.y1, _s.cx + _s.x1), xb2(Fl.cy + Fl.y1, Fl.cx + Fl.x1), !Y3), al > 0 && l2.arc(j + Fl.cx, U3 + Fl.cy, al, xb2(Fl.y1, Fl.x1), xb2(Fl.y0, Fl.x0), !Y3));
            } else
              l2.moveTo(j + Bn, U3 + mn), l2.arc(j, U3, d2, L, F3, !Y3);
            if (!(y2 > hC) || !ar)
              l2.lineTo(j + Kr, U3 + Kn);
            else if (Pe2 > hC) {
              var Gs = xA(dt, Pe2), al = xA(vt, Pe2), _s = Aq(Kr, Kn, Be2, Je2, y2, -al, Y3), Fl = Aq(Bn, mn, Ze2, Cn, y2, -Gs, Y3);
              l2.lineTo(j + _s.cx + _s.x0, U3 + _s.cy + _s.y0), Pe2 < _e && Gs === al ? l2.arc(j + _s.cx, U3 + _s.cy, Pe2, xb2(_s.y0, _s.x0), xb2(Fl.y0, Fl.x0), !Y3) : (al > 0 && l2.arc(j + _s.cx, U3 + _s.cy, al, xb2(_s.y0, _s.x0), xb2(_s.y1, _s.x1), !Y3), l2.arc(j, U3, y2, xb2(_s.cy + _s.y1, _s.cx + _s.x1), xb2(Fl.cy + Fl.y1, Fl.cx + Fl.x1), Y3), Gs > 0 && l2.arc(j + Fl.cx, U3 + Fl.cy, Gs, xb2(Fl.y1, Fl.x1), xb2(Fl.y0, Fl.x0), !Y3));
            } else
              l2.lineTo(j + Kr, U3 + Kn), l2.arc(j, U3, y2, F3, L, Y3);
          }
          l2.closePath();
        }
      }
    }
    var o3t = function() {
      function l2() {
        this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
      }
      return l2;
    }(), H0t = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultShape = function() {
        return new o3t();
      }, a.prototype.buildPath = function(e2, d2) {
        a3t(e2, d2);
      }, a.prototype.isZeroArea = function() {
        return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
      }, a;
    }(wc2);
    H0t.prototype.type = "sector";
    var nw = H0t, s3t = function() {
      function l2() {
        this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
      }
      return l2;
    }(), U0t = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultShape = function() {
        return new s3t();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.cx, x2 = d2.cy, C = Math.PI * 2;
        e2.moveTo(y2 + d2.r, x2), e2.arc(y2, x2, d2.r, 0, C, false), e2.moveTo(y2 + d2.r0, x2), e2.arc(y2, x2, d2.r0, 0, C, true);
      }, a;
    }(wc2);
    U0t.prototype.type = "ring";
    var Iq = U0t;
    function Knt(l2, a, e2, d2) {
      var y2 = [], x2 = [], C = [], D2 = [], L, F3, j, U3;
      if (d2) {
        j = [1 / 0, 1 / 0], U3 = [-1 / 0, -1 / 0];
        for (var Y3 = 0, Q = l2.length; Y3 < Q; Y3++)
          vE(j, j, l2[Y3]), nA(U3, U3, l2[Y3]);
        vE(j, j, d2[0]), nA(U3, U3, d2[1]);
      }
      for (var Y3 = 0, Q = l2.length; Y3 < Q; Y3++) {
        var nt = l2[Y3];
        if (e2)
          L = l2[Y3 ? Y3 - 1 : Q - 1], F3 = l2[(Y3 + 1) % Q];
        else if (Y3 === 0 || Y3 === Q - 1) {
          y2.push(H22(l2[Y3]));
          continue;
        } else
          L = l2[Y3 - 1], F3 = l2[Y3 + 1];
        dE(x2, F3, L), Met(x2, x2, a);
        var dt = Cet(nt, L), vt = Cet(nt, F3), Ct = dt + vt;
        Ct !== 0 && (dt /= Ct, vt /= Ct), Met(C, x2, -dt), Met(D2, x2, vt);
        var Pt = cv([], nt, C), jt = cv([], nt, D2);
        d2 && (nA(Pt, Pt, j), vE(Pt, Pt, U3), nA(jt, jt, j), vE(jt, jt, U3)), y2.push(Pt), y2.push(jt);
      }
      return e2 && y2.push(y2.shift()), y2;
    }
    function Xnt(l2, a, e2) {
      var d2 = a.smooth, y2 = a.points;
      if (y2 && y2.length >= 2) {
        if (d2) {
          var x2 = Knt(y2, d2, e2, a.smoothConstraint);
          l2.moveTo(y2[0][0], y2[0][1]);
          for (var C = y2.length, D2 = 0; D2 < (e2 ? C : C - 1); D2++) {
            var L = x2[D2 * 2], F3 = x2[D2 * 2 + 1], j = y2[(D2 + 1) % C];
            l2.bezierCurveTo(L[0], L[1], F3[0], F3[1], j[0], j[1]);
          }
        } else {
          l2.moveTo(y2[0][0], y2[0][1]);
          for (var D2 = 1, U3 = y2.length; D2 < U3; D2++)
            l2.lineTo(y2[D2][0], y2[D2][1]);
        }
        e2 && l2.closePath();
      }
    }
    var q0t = function() {
      function l2() {
        this.points = null, this.smooth = 0, this.smoothConstraint = null;
      }
      return l2;
    }(), Z0t = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultShape = function() {
        return new q0t();
      }, a.prototype.buildPath = function(e2, d2) {
        Xnt(e2, d2, true);
      }, a;
    }(wc2);
    Z0t.prototype.type = "polygon";
    var rw = Z0t, l3t = function() {
      function l2() {
        this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
      }
      return l2;
    }(), Dq = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new l3t();
      }, a.prototype.buildPath = function(e2, d2) {
        Xnt(e2, d2, false);
      }, a;
    }(wc2);
    Dq.prototype.type = "polyline";
    var iw = Dq, u3t = {}, c3t = function() {
      function l2() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
      }
      return l2;
    }(), N_ = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new c3t();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2, x2, C, D2;
        if (this.subPixelOptimize) {
          var L = c0t(u3t, d2, this.style);
          y2 = L.x1, x2 = L.y1, C = L.x2, D2 = L.y2;
        } else
          y2 = d2.x1, x2 = d2.y1, C = d2.x2, D2 = d2.y2;
        var F3 = d2.percent;
        F3 !== 0 && (e2.moveTo(y2, x2), F3 < 1 && (C = y2 * (1 - F3) + C * F3, D2 = x2 * (1 - F3) + D2 * F3), e2.lineTo(C, D2));
      }, a.prototype.pointAt = function(e2) {
        var d2 = this.shape;
        return [d2.x1 * (1 - e2) + d2.x2 * e2, d2.y1 * (1 - e2) + d2.y2 * e2];
      }, a;
    }(wc2);
    N_.prototype.type = "line";
    var by = N_, aw = [], f3t = function() {
      function l2() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
      }
      return l2;
    }();
    function $0t(l2, a, e2) {
      var d2 = l2.cpx2, y2 = l2.cpy2;
      return d2 != null || y2 != null ? [(e2 ? wV : m0)(l2.x1, l2.cpx1, l2.cpx2, l2.x2, a), (e2 ? wV : m0)(l2.y1, l2.cpy1, l2.cpy2, l2.y2, a)] : [(e2 ? Cm : sp)(l2.x1, l2.cpx1, l2.x2, a), (e2 ? Cm : sp)(l2.y1, l2.cpy1, l2.y2, a)];
    }
    var Y0t = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new f3t();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.x1, x2 = d2.y1, C = d2.x2, D2 = d2.y2, L = d2.cpx1, F3 = d2.cpy1, j = d2.cpx2, U3 = d2.cpy2, Y3 = d2.percent;
        Y3 !== 0 && (e2.moveTo(y2, x2), j == null || U3 == null ? (Y3 < 1 && (_N(y2, L, C, Y3, aw), L = aw[1], C = aw[2], _N(x2, F3, D2, Y3, aw), F3 = aw[1], D2 = aw[2]), e2.quadraticCurveTo(L, F3, C, D2)) : (Y3 < 1 && (bE(y2, L, j, C, Y3, aw), L = aw[1], j = aw[2], C = aw[3], bE(x2, F3, U3, D2, Y3, aw), F3 = aw[1], U3 = aw[2], D2 = aw[3]), e2.bezierCurveTo(L, F3, j, U3, C, D2)));
      }, a.prototype.pointAt = function(e2) {
        return $0t(this.shape, e2, false);
      }, a.prototype.tangentAt = function(e2) {
        var d2 = $0t(this.shape, e2, true);
        return yV(d2, d2);
      }, a;
    }(wc2);
    Y0t.prototype.type = "bezier-curve";
    var GN = Y0t, h3t = function() {
      function l2() {
        this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
      }
      return l2;
    }(), Eq = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new h3t();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.cx, x2 = d2.cy, C = Math.max(d2.r, 0), D2 = d2.startAngle, L = d2.endAngle, F3 = d2.clockwise, j = Math.cos(D2), U3 = Math.sin(D2);
        e2.moveTo(j * C + y2, U3 * C + x2), e2.arc(y2, x2, C, D2, L, !F3);
      }, a;
    }(wc2);
    Eq.prototype.type = "arc";
    var Qnt = Eq, p3t = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "compound", e2;
      }
      return a.prototype._updatePathDirty = function() {
        for (var e2 = this.shape.paths, d2 = this.shapeChanged(), y2 = 0; y2 < e2.length; y2++)
          d2 = d2 || e2[y2].shapeChanged();
        d2 && this.dirtyShape();
      }, a.prototype.beforeBrush = function() {
        this._updatePathDirty();
        for (var e2 = this.shape.paths || [], d2 = this.getGlobalScale(), y2 = 0; y2 < e2.length; y2++)
          e2[y2].path || e2[y2].createPathProxy(), e2[y2].path.setScale(d2[0], d2[1], e2[y2].segmentIgnoreThreshold);
      }, a.prototype.buildPath = function(e2, d2) {
        for (var y2 = d2.paths || [], x2 = 0; x2 < y2.length; x2++)
          y2[x2].buildPath(e2, y2[x2].shape, true);
      }, a.prototype.afterBrush = function() {
        for (var e2 = this.shape.paths || [], d2 = 0; d2 < e2.length; d2++)
          e2[d2].pathUpdated();
      }, a.prototype.getBoundingRect = function() {
        return this._updatePathDirty.call(this), wc2.prototype.getBoundingRect.call(this);
      }, a;
    }(wc2), Jnt = p3t, d3t = function() {
      function l2(a) {
        this.colorStops = a || [];
      }
      return l2.prototype.addColorStop = function(a, e2) {
        this.colorStops.push({ offset: a, color: e2 });
      }, l2;
    }(), trt = d3t, g3t = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2, C, D2) {
        var L = l2.call(this, C) || this;
        return L.x = e2 == null ? 0 : e2, L.y = d2 == null ? 0 : d2, L.x2 = y2 == null ? 1 : y2, L.y2 = x2 == null ? 0 : x2, L.type = "linear", L.global = D2 || false, L;
      }
      return a;
    }(trt), QV = g3t, v3t = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2, C) {
        var D2 = l2.call(this, x2) || this;
        return D2.x = e2 == null ? 0.5 : e2, D2.y = d2 == null ? 0.5 : d2, D2.r = y2 == null ? 0.5 : y2, D2.type = "radial", D2.global = C || false, D2;
      }
      return a;
    }(trt), kq = v3t, IE = [0, 0], DO = [0, 0], Pq = new Nu(), Lq = new Nu(), y3t = function() {
      function l2(a, e2) {
        this._corners = [], this._axes = [], this._origin = [0, 0];
        for (var d2 = 0; d2 < 4; d2++)
          this._corners[d2] = new Nu();
        for (var d2 = 0; d2 < 2; d2++)
          this._axes[d2] = new Nu();
        a && this.fromBoundingRect(a, e2);
      }
      return l2.prototype.fromBoundingRect = function(a, e2) {
        var d2 = this._corners, y2 = this._axes, x2 = a.x, C = a.y, D2 = x2 + a.width, L = C + a.height;
        if (d2[0].set(x2, C), d2[1].set(D2, C), d2[2].set(D2, L), d2[3].set(x2, L), e2)
          for (var F3 = 0; F3 < 4; F3++)
            d2[F3].transform(e2);
        Nu.sub(y2[0], d2[1], d2[0]), Nu.sub(y2[1], d2[3], d2[0]), y2[0].normalize(), y2[1].normalize();
        for (var F3 = 0; F3 < 2; F3++)
          this._origin[F3] = y2[F3].dot(d2[0]);
      }, l2.prototype.intersect = function(a, e2) {
        var d2 = true, y2 = !e2;
        return Pq.set(1 / 0, 1 / 0), Lq.set(0, 0), !this._intersectCheckOneSide(this, a, Pq, Lq, y2, 1) && (d2 = false, y2) || !this._intersectCheckOneSide(a, this, Pq, Lq, y2, -1) && (d2 = false, y2) || y2 || Nu.copy(e2, d2 ? Pq : Lq), d2;
      }, l2.prototype._intersectCheckOneSide = function(a, e2, d2, y2, x2, C) {
        for (var D2 = true, L = 0; L < 2; L++) {
          var F3 = this._axes[L];
          if (this._getProjMinMaxOnAxis(L, a._corners, IE), this._getProjMinMaxOnAxis(L, e2._corners, DO), IE[1] < DO[0] || IE[0] > DO[1]) {
            if (D2 = false, x2)
              return D2;
            var j = Math.abs(DO[0] - IE[1]), U3 = Math.abs(IE[0] - DO[1]);
            Math.min(j, U3) > y2.len() && (j < U3 ? Nu.scale(y2, F3, -j * C) : Nu.scale(y2, F3, U3 * C));
          } else if (d2) {
            var j = Math.abs(DO[0] - IE[1]), U3 = Math.abs(IE[0] - DO[1]);
            Math.min(j, U3) < d2.len() && (j < U3 ? Nu.scale(d2, F3, j * C) : Nu.scale(d2, F3, -U3 * C));
          }
        }
        return D2;
      }, l2.prototype._getProjMinMaxOnAxis = function(a, e2, d2) {
        for (var y2 = this._axes[a], x2 = this._origin, C = e2[0].dot(y2) + x2[a], D2 = C, L = C, F3 = 1; F3 < e2.length; F3++) {
          var j = e2[F3].dot(y2) + x2[a];
          D2 = Math.min(j, D2), L = Math.max(j, L);
        }
        d2[0] = D2, d2[1] = L;
      }, l2;
    }(), Oq = y3t, m3t = [], b3t = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.notClear = true, e2.incremental = true, e2._displayables = [], e2._temporaryDisplayables = [], e2._cursor = 0, e2;
      }
      return a.prototype.traverse = function(e2, d2) {
        e2.call(d2, this);
      }, a.prototype.useStyle = function() {
        this.style = {};
      }, a.prototype.getCursor = function() {
        return this._cursor;
      }, a.prototype.innerAfterBrush = function() {
        this._cursor = this._displayables.length;
      }, a.prototype.clearDisplaybles = function() {
        this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
      }, a.prototype.clearTemporalDisplayables = function() {
        this._temporaryDisplayables = [];
      }, a.prototype.addDisplayable = function(e2, d2) {
        d2 ? this._temporaryDisplayables.push(e2) : this._displayables.push(e2), this.markRedraw();
      }, a.prototype.addDisplayables = function(e2, d2) {
        d2 = d2 || false;
        for (var y2 = 0; y2 < e2.length; y2++)
          this.addDisplayable(e2[y2], d2);
      }, a.prototype.getDisplayables = function() {
        return this._displayables;
      }, a.prototype.getTemporalDisplayables = function() {
        return this._temporaryDisplayables;
      }, a.prototype.eachPendingDisplayable = function(e2) {
        for (var d2 = this._cursor; d2 < this._displayables.length; d2++)
          e2 && e2(this._displayables[d2]);
        for (var d2 = 0; d2 < this._temporaryDisplayables.length; d2++)
          e2 && e2(this._temporaryDisplayables[d2]);
      }, a.prototype.update = function() {
        this.updateTransform();
        for (var e2 = this._cursor; e2 < this._displayables.length; e2++) {
          var d2 = this._displayables[e2];
          d2.parent = this, d2.update(), d2.parent = null;
        }
        for (var e2 = 0; e2 < this._temporaryDisplayables.length; e2++) {
          var d2 = this._temporaryDisplayables[e2];
          d2.parent = this, d2.update(), d2.parent = null;
        }
      }, a.prototype.getBoundingRect = function() {
        if (!this._rect) {
          for (var e2 = new Yu(1 / 0, 1 / 0, -1 / 0, -1 / 0), d2 = 0; d2 < this._displayables.length; d2++) {
            var y2 = this._displayables[d2], x2 = y2.getBoundingRect().clone();
            y2.needLocalTransform() && x2.applyTransform(y2.getLocalTransform(m3t)), e2.union(x2);
          }
          this._rect = e2;
        }
        return this._rect;
      }, a.prototype.contain = function(e2, d2) {
        var y2 = this.transformCoordToLocal(e2, d2), x2 = this.getBoundingRect();
        if (x2.contain(y2[0], y2[1]))
          for (var C = 0; C < this._displayables.length; C++) {
            var D2 = this._displayables[C];
            if (D2.contain(e2, d2))
              return true;
          }
        return false;
      }, a;
    }(Y2), _3t = b3t, K0t = Rf2();
    function HN(l2, a, e2, d2, y2) {
      var x2;
      if (a && a.ecModel) {
        var C = a.ecModel.getUpdatePayload();
        x2 = C && C.animation;
      }
      var D2 = a && a.isAnimationEnabled(), L = l2 === "update";
      if (D2) {
        var F3 = void 0, j = void 0, U3 = void 0;
        d2 ? (F3 = $u(d2.duration, 200), j = $u(d2.easing, "cubicOut"), U3 = 0) : (F3 = a.getShallow(L ? "animationDurationUpdate" : "animationDuration"), j = a.getShallow(L ? "animationEasingUpdate" : "animationEasing"), U3 = a.getShallow(L ? "animationDelayUpdate" : "animationDelay")), x2 && (x2.duration != null && (F3 = x2.duration), x2.easing != null && (j = x2.easing), x2.delay != null && (U3 = x2.delay)), wl(U3) && (U3 = U3(e2, y2)), wl(F3) && (F3 = F3(e2));
        var Y3 = { duration: F3 || 0, delay: U3, easing: j };
        return Y3;
      } else
        return null;
    }
    function ert(l2, a, e2, d2, y2, x2, C) {
      var D2 = false, L;
      wl(y2) ? (C = x2, x2 = y2, y2 = null) : vs(y2) && (x2 = y2.cb, C = y2.during, D2 = y2.isFrom, L = y2.removeOpt, y2 = y2.dataIndex);
      var F3 = l2 === "leave";
      F3 || a.stopAnimation("leave");
      var j = HN(l2, d2, y2, F3 ? L || {} : null, d2 && d2.getAnimationDelayParams ? d2.getAnimationDelayParams(a, y2) : null);
      if (j && j.duration > 0) {
        var U3 = j.duration, Y3 = j.delay, Q = j.easing, nt = { duration: U3, delay: Y3 || 0, easing: Q, done: x2, force: !!x2 || !!C, setToFinal: !F3, scope: l2, during: C };
        D2 ? a.animateFrom(e2, nt) : a.animateTo(e2, nt);
      } else
        a.stopAnimation(), !D2 && a.attr(e2), C && C(1), x2 && x2();
    }
    function Yf2(l2, a, e2, d2, y2, x2) {
      ert("update", l2, a, e2, d2, y2, x2);
    }
    function Yg2(l2, a, e2, d2, y2, x2) {
      ert("enter", l2, a, e2, d2, y2, x2);
    }
    function UN(l2) {
      if (!l2.__zr)
        return true;
      for (var a = 0; a < l2.animators.length; a++) {
        var e2 = l2.animators[a];
        if (e2.scope === "leave")
          return true;
      }
      return false;
    }
    function iP(l2, a, e2, d2, y2, x2) {
      UN(l2) || ert("leave", l2, a, e2, d2, y2, x2);
    }
    function X0t(l2, a, e2, d2) {
      l2.removeTextContent(), l2.removeTextGuideLine(), iP(l2, { style: { opacity: 0 } }, a, e2, d2);
    }
    function JV(l2, a, e2) {
      function d2() {
        l2.parent && l2.parent.remove(l2);
      }
      l2.isGroup ? l2.traverse(function(y2) {
        y2.isGroup || X0t(y2, a, e2, d2);
      }) : X0t(l2, a, e2, d2);
    }
    function pC(l2) {
      K0t(l2).oldStyle = l2.style;
    }
    function x3t(l2) {
      return K0t(l2).oldStyle;
    }
    var Rq = Math.max, Nq = Math.min, lt2 = {};
    function wt(l2) {
      return wc2.extend(l2);
    }
    var Jt = JPt;
    function Ee2(l2, a) {
      return Jt(l2, a);
    }
    function sn(l2, a) {
      lt2[l2] = a;
    }
    function Hn(l2) {
      if (lt2.hasOwnProperty(l2))
        return lt2[l2];
    }
    function Fr(l2, a, e2, d2) {
      var y2 = B0t(l2, a);
      return e2 && (d2 === "center" && (e2 = ki2(e2, y2.getBoundingRect())), Io(y2, e2)), y2;
    }
    function $r(l2, a, e2) {
      var d2 = new Im({ style: { image: l2, x: a.x, y: a.y, width: a.width, height: a.height }, onload: function(y2) {
        if (e2 === "center") {
          var x2 = { width: y2.width, height: y2.height };
          d2.setStyle(ki2(a, x2));
        }
      } });
      return d2;
    }
    function ki2(l2, a) {
      var e2 = a.width / a.height, d2 = l2.height * e2, y2;
      d2 <= l2.width ? y2 = l2.height : (d2 = l2.width, y2 = d2 / e2);
      var x2 = l2.x + l2.width / 2, C = l2.y + l2.height / 2;
      return { x: x2 - d2 / 2, y: C - y2 / 2, width: d2, height: y2 };
    }
    var Ja2 = t3t;
    function Io(l2, a) {
      if (l2.applyTransform) {
        var e2 = l2.getBoundingRect(), d2 = e2.calculateTransform(a);
        l2.applyTransform(d2);
      }
    }
    function Xo(l2) {
      return c0t(l2.shape, l2.shape, l2.style), l2;
    }
    function ul(l2) {
      return f0t(l2.shape, l2.shape, l2.style), l2;
    }
    var su = _O;
    function Eu(l2, a) {
      for (var e2 = OV([]); l2 && l2 !== a; )
        lA(e2, l2.getLocalTransform(), e2), l2 = l2.parent;
      return e2;
    }
    function hc2(l2, a, e2) {
      return a && !h1(a) && (a = OS.getLocalTransform(a)), e2 && (a = sO([], a)), Mm([], l2, a);
    }
    function Wu(l2, a, e2) {
      var d2 = a[4] === 0 || a[5] === 0 || a[0] === 0 ? 1 : Math.abs(2 * a[4] / a[0]), y2 = a[4] === 0 || a[5] === 0 || a[2] === 0 ? 1 : Math.abs(2 * a[4] / a[2]), x2 = [l2 === "left" ? -d2 : l2 === "right" ? d2 : 0, l2 === "top" ? -y2 : l2 === "bottom" ? y2 : 0];
      return x2 = hc2(x2, a, e2), Math.abs(x2[0]) > Math.abs(x2[1]) ? x2[0] > 0 ? "right" : "left" : x2[1] > 0 ? "bottom" : "top";
    }
    function Th2(l2) {
      return !l2.isGroup;
    }
    function mp(l2) {
      return l2.shape != null;
    }
    function m1(l2, a, e2) {
      if (!l2 || !a)
        return;
      function d2(C) {
        var D2 = {};
        return C.traverse(function(L) {
          Th2(L) && L.anid && (D2[L.anid] = L);
        }), D2;
      }
      function y2(C) {
        var D2 = { x: C.x, y: C.y, rotation: C.rotation };
        return mp(C) && (D2.shape = la2({}, C.shape)), D2;
      }
      var x2 = d2(l2);
      a.traverse(function(C) {
        if (Th2(C) && C.anid) {
          var D2 = x2[C.anid];
          if (D2) {
            var L = y2(C);
            C.attr(y2(D2)), Yf2(C, L, e2, ns(C).dataIndex);
          }
        }
      });
    }
    function wb2(l2, a) {
      return $a2(l2, function(e2) {
        var d2 = e2[0];
        d2 = Rq(d2, a.x), d2 = Nq(d2, a.x + a.width);
        var y2 = e2[1];
        return y2 = Rq(y2, a.y), y2 = Nq(y2, a.y + a.height), [d2, y2];
      });
    }
    function BS(l2, a) {
      var e2 = Rq(l2.x, a.x), d2 = Nq(l2.x + l2.width, a.x + a.width), y2 = Rq(l2.y, a.y), x2 = Nq(l2.y + l2.height, a.y + a.height);
      if (d2 >= e2 && x2 >= y2)
        return { x: e2, y: y2, width: d2 - e2, height: x2 - y2 };
    }
    function fv(l2, a, e2) {
      var d2 = la2({ rectHover: true }, a), y2 = d2.style = { strokeNoScale: true };
      if (e2 = e2 || { x: -1, y: -1, width: 2, height: 2 }, l2)
        return l2.indexOf("image://") === 0 ? (y2.image = l2.slice(8), El(y2, e2), new Im(d2)) : Fr(l2.replace("path://", ""), d2, e2, "center");
    }
    function F_(l2, a, e2, d2, y2) {
      for (var x2 = 0, C = y2[y2.length - 1]; x2 < y2.length; x2++) {
        var D2 = y2[x2];
        if (wA(l2, a, e2, d2, D2[0], D2[1], C[0], C[1]))
          return true;
        C = D2;
      }
    }
    function wA(l2, a, e2, d2, y2, x2, C, D2) {
      var L = e2 - l2, F3 = d2 - a, j = C - y2, U3 = D2 - x2, Y3 = Fq(j, U3, L, F3);
      if (GZe(Y3))
        return false;
      var Q = l2 - y2, nt = a - x2, dt = Fq(Q, nt, L, F3) / Y3;
      if (dt < 0 || dt > 1)
        return false;
      var vt = Fq(Q, nt, j, U3) / Y3;
      return !(vt < 0 || vt > 1);
    }
    function Fq(l2, a, e2, d2) {
      return l2 * d2 - e2 * a;
    }
    function GZe(l2) {
      return l2 <= 1e-6 && l2 >= -1e-6;
    }
    function Vq(l2) {
      var a = l2.itemTooltipOption, e2 = l2.componentModel, d2 = l2.itemName, y2 = ps(a) ? { formatter: a } : a, x2 = e2.mainType, C = e2.componentIndex, D2 = { componentType: x2, name: d2, $vars: ["name"] };
      D2[x2 + "Index"] = C;
      var L = l2.formatterParamsExtra;
      L && Ke2(Qc2(L), function(j) {
        Ns(D2, j) || (D2[j] = L[j], D2.$vars.push(j));
      });
      var F3 = ns(l2.el);
      F3.componentMainType = x2, F3.componentIndex = C, F3.tooltipConfig = { name: d2, option: El({ content: d2, formatterParams: D2 }, y2) };
    }
    function Bre(l2, a) {
      var e2;
      l2.isGroup && (e2 = a(l2)), e2 || l2.traverse(a);
    }
    function qN(l2, a) {
      if (l2)
        if (Ba2(l2))
          for (var e2 = 0; e2 < l2.length; e2++)
            Bre(l2[e2], a);
        else
          Bre(l2, a);
    }
    sn("circle", _A), sn("ellipse", $nt), sn("sector", nw), sn("ring", Iq), sn("polygon", rw), sn("polyline", iw), sn("rect", Nf2), sn("line", by), sn("bezierCurve", GN), sn("arc", Qnt);
    var nrt = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: Yf2, initProps: Yg2, removeElement: iP, removeElementWithFadeOut: JV, isElementRemoved: UN, extendShape: wt, extendPath: Ee2, registerShape: sn, getShapeClass: Hn, makePath: Fr, makeImage: $r, mergePath: Ja2, resizePath: Io, subPixelOptimizeLine: Xo, subPixelOptimizeRect: ul, subPixelOptimize: su, getTransform: Eu, applyTransform: hc2, transformDirection: Wu, groupTransition: m1, clipPointsByRect: wb2, clipRectByRect: BS, createIcon: fv, linePolygonIntersect: F_, lineLineIntersect: wA, setTooltipConfig: Vq, traverseElements: qN, Group: ou, Image: Im, Text: qc2, Circle: _A, Ellipse: $nt, Sector: nw, Ring: Iq, Polygon: rw, Polyline: iw, Rect: Nf2, Line: by, BezierCurve: GN, Arc: Qnt, IncrementalDisplayable: _3t, CompoundPath: Jnt, LinearGradient: QV, RadialGradient: kq, BoundingRect: Yu, OrientedBoundingRect: Oq, Point: Nu, Path: wc2 }, Symbol.toStringTag, { value: "Module" })), Q0t = {};
    function zre(l2, a) {
      for (var e2 = 0; e2 < O_.length; e2++) {
        var d2 = O_[e2], y2 = a[d2], x2 = l2.ensureState(d2);
        x2.style = x2.style || {}, x2.style.text = y2;
      }
      var C = l2.currentStates.slice();
      l2.clearStates(true), l2.setStyle({ text: a.normal }), l2.useStates(C, true);
    }
    function w3t(l2, a, e2) {
      var d2 = l2.labelFetcher, y2 = l2.labelDataIndex, x2 = l2.labelDimIndex, C = a.normal, D2;
      d2 && (D2 = d2.getFormattedLabel(y2, "normal", null, x2, C && C.get("formatter"), e2 != null ? { interpolatedValue: e2 } : null)), D2 == null && (D2 = wl(l2.defaultText) ? l2.defaultText(y2, l2, e2) : l2.defaultText);
      for (var L = { normal: D2 }, F3 = 0; F3 < O_.length; F3++) {
        var j = O_[F3], U3 = a[j];
        L[j] = $u(d2 ? d2.getFormattedLabel(y2, j, null, x2, U3 && U3.get("formatter")) : null, D2);
      }
      return L;
    }
    function ow(l2, a, e2, d2) {
      e2 = e2 || Q0t;
      for (var y2 = l2 instanceof qc2, x2 = false, C = 0; C < UV.length; C++) {
        var D2 = a[UV[C]];
        if (D2 && D2.getShallow("show")) {
          x2 = true;
          break;
        }
      }
      var L = y2 ? l2 : l2.getTextContent();
      if (x2) {
        y2 || (L || (L = new qc2(), l2.setTextContent(L)), l2.stateProxy && (L.stateProxy = l2.stateProxy));
        var F3 = w3t(e2, a), j = a.normal, U3 = !!j.getShallow("show"), Y3 = _y(j, d2 && d2.normal, e2, false, !y2);
        Y3.text = F3.normal, y2 || l2.setTextConfig(J0t(j, e2, false));
        for (var C = 0; C < O_.length; C++) {
          var Q = O_[C], D2 = a[Q];
          if (D2) {
            var nt = L.ensureState(Q), dt = !!$u(D2.getShallow("show"), U3);
            if (dt !== U3 && (nt.ignore = !dt), nt.style = _y(D2, d2 && d2[Q], e2, true, !y2), nt.style.text = F3[Q], !y2) {
              var vt = l2.ensureState(Q);
              vt.textConfig = J0t(D2, e2, true);
            }
          }
        }
        L.silent = !!j.getShallow("silent"), L.style.x != null && (Y3.x = L.style.x), L.style.y != null && (Y3.y = L.style.y), L.ignore = !U3, L.useStyle(Y3), L.dirty(), e2.enableTextSetter && (Bq(L).setLabelText = function(Ct) {
          var Pt = w3t(e2, a, Ct);
          zre(L, Pt);
        });
      } else
        L && (L.ignore = true);
      l2.dirty();
    }
    function Sb2(l2, a) {
      a = a || "label";
      for (var e2 = { normal: l2.getModel(a) }, d2 = 0; d2 < O_.length; d2++) {
        var y2 = O_[d2];
        e2[y2] = l2.getModel([y2, a]);
      }
      return e2;
    }
    function _y(l2, a, e2, d2, y2) {
      var x2 = {};
      return HZe(x2, l2, e2, d2, y2), a && la2(x2, a), x2;
    }
    function J0t(l2, a, e2) {
      a = a || {};
      var d2 = {}, y2, x2 = l2.getShallow("rotate"), C = $u(l2.getShallow("distance"), e2 ? null : 5), D2 = l2.getShallow("offset");
      return y2 = l2.getShallow("position") || (e2 ? null : "inside"), y2 === "outside" && (y2 = a.defaultOutsidePosition || "top"), y2 != null && (d2.position = y2), D2 != null && (d2.offset = D2), x2 != null && (x2 *= Math.PI / 180, d2.rotation = x2), C != null && (d2.distance = C), d2.outsideFill = l2.get("color") === "inherit" ? a.inheritColor || null : "auto", d2;
    }
    function HZe(l2, a, e2, d2, y2) {
      e2 = e2 || Q0t;
      var x2 = a.ecModel, C = x2 && x2.option.textStyle, D2 = UZe(a), L;
      if (D2) {
        L = {};
        for (var F3 in D2)
          if (D2.hasOwnProperty(F3)) {
            var j = a.getModel(["rich", F3]);
            Hre(L[F3] = {}, j, C, e2, d2, y2, false, true);
          }
      }
      L && (l2.rich = L);
      var U3 = a.get("overflow");
      U3 && (l2.overflow = U3);
      var Y3 = a.get("minMargin");
      Y3 != null && (l2.margin = Y3), Hre(l2, a, C, e2, d2, y2, true, false);
    }
    function UZe(l2) {
      for (var a; l2 && l2 !== l2.ecModel; ) {
        var e2 = (l2.option || Q0t).rich;
        if (e2) {
          a = a || {};
          for (var d2 = Qc2(e2), y2 = 0; y2 < d2.length; y2++) {
            var x2 = d2[y2];
            a[x2] = 1;
          }
        }
        l2 = l2.parentModel;
      }
      return a;
    }
    var jre = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], Wre = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], Gre = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
    function Hre(l2, a, e2, d2, y2, x2, C, D2) {
      e2 = !y2 && e2 || Q0t;
      var L = d2 && d2.inheritColor, F3 = a.getShallow("color"), j = a.getShallow("textBorderColor"), U3 = $u(a.getShallow("opacity"), e2.opacity);
      (F3 === "inherit" || F3 === "auto") && (L ? F3 = L : F3 = null), (j === "inherit" || j === "auto") && (L ? j = L : j = null), x2 || (F3 = F3 || e2.color, j = j || e2.textBorderColor), F3 != null && (l2.fill = F3), j != null && (l2.stroke = j);
      var Y3 = $u(a.getShallow("textBorderWidth"), e2.textBorderWidth);
      Y3 != null && (l2.lineWidth = Y3);
      var Q = $u(a.getShallow("textBorderType"), e2.textBorderType);
      Q != null && (l2.lineDash = Q);
      var nt = $u(a.getShallow("textBorderDashOffset"), e2.textBorderDashOffset);
      nt != null && (l2.lineDashOffset = nt), !y2 && U3 == null && !D2 && (U3 = d2 && d2.defaultOpacity), U3 != null && (l2.opacity = U3), !y2 && !x2 && l2.fill == null && d2.inheritColor && (l2.fill = d2.inheritColor);
      for (var dt = 0; dt < jre.length; dt++) {
        var vt = jre[dt], Ct = $u(a.getShallow(vt), e2[vt]);
        Ct != null && (l2[vt] = Ct);
      }
      for (var dt = 0; dt < Wre.length; dt++) {
        var vt = Wre[dt], Ct = a.getShallow(vt);
        Ct != null && (l2[vt] = Ct);
      }
      if (l2.verticalAlign == null) {
        var Pt = a.getShallow("baseline");
        Pt != null && (l2.verticalAlign = Pt);
      }
      if (!C || !d2.disableBox) {
        for (var dt = 0; dt < Gre.length; dt++) {
          var vt = Gre[dt], Ct = a.getShallow(vt);
          Ct != null && (l2[vt] = Ct);
        }
        var jt = a.getShallow("borderType");
        jt != null && (l2.borderDash = jt), (l2.backgroundColor === "auto" || l2.backgroundColor === "inherit") && L && (l2.backgroundColor = L), (l2.borderColor === "auto" || l2.borderColor === "inherit") && L && (l2.borderColor = L);
      }
    }
    function Ure(l2, a) {
      var e2 = a && a.getModel("textStyle");
      return TS([l2.fontStyle || e2 && e2.getShallow("fontStyle") || "", l2.fontWeight || e2 && e2.getShallow("fontWeight") || "", (l2.fontSize || e2 && e2.getShallow("fontSize") || 12) + "px", l2.fontFamily || e2 && e2.getShallow("fontFamily") || "sans-serif"].join(" "));
    }
    var Bq = Rf2();
    function qre(l2, a, e2, d2) {
      if (l2) {
        var y2 = Bq(l2);
        y2.prevValue = y2.value, y2.value = e2;
        var x2 = a.normal;
        y2.valueAnimation = x2.get("valueAnimation"), y2.valueAnimation && (y2.precision = x2.get("precision"), y2.defaultInterpolatedText = d2, y2.statesModels = a);
      }
    }
    function Zre(l2, a, e2, d2, y2) {
      var x2 = Bq(l2);
      if (!x2.valueAnimation || x2.prevValue === x2.value)
        return;
      var C = x2.defaultInterpolatedText, D2 = $u(x2.interpolatedValue, x2.prevValue), L = x2.value;
      function F3(j) {
        var U3 = FN(e2, x2.precision, D2, L, j);
        x2.interpolatedValue = j === 1 ? null : U3;
        var Y3 = w3t({ labelDataIndex: a, labelFetcher: y2, defaultText: C ? C(U3) : U3 + "" }, x2.statesModels, U3);
        zre(l2, Y3);
      }
      l2.percent = 0, (x2.prevValue == null ? Yg2 : Yf2)(l2, { percent: 1 }, d2, a, null, F3);
    }
    var qZe = ["textStyle", "color"], S3t = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], M3t = new qc2(), ZZe = function() {
      function l2() {
      }
      return l2.prototype.getTextColor = function(a) {
        var e2 = this.ecModel;
        return this.getShallow("color") || (!a && e2 ? e2.get(qZe) : null);
      }, l2.prototype.getFont = function() {
        return Ure({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
      }, l2.prototype.getTextRect = function(a) {
        for (var e2 = { text: a, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, d2 = 0; d2 < S3t.length; d2++)
          e2[S3t[d2]] = this.getShallow(S3t[d2]);
        return M3t.useStyle(e2), M3t.update(), M3t.getBoundingRect();
      }, l2;
    }(), $Ze = ZZe, $re = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], YZe = dO($re), KZe = function() {
      function l2() {
      }
      return l2.prototype.getLineStyle = function(a) {
        return YZe(this, a);
      }, l2;
    }(), Yre = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], XZe = dO(Yre), QZe = function() {
      function l2() {
      }
      return l2.prototype.getItemStyle = function(a, e2) {
        return XZe(this, a, e2);
      }, l2;
    }(), tB = function() {
      function l2(a, e2, d2) {
        this.parentModel = e2, this.ecModel = d2, this.option = a;
      }
      return l2.prototype.init = function(a, e2, d2) {
        for (var y2 = [], x2 = 3; x2 < arguments.length; x2++)
          y2[x2 - 3] = arguments[x2];
      }, l2.prototype.mergeOption = function(a, e2) {
        Mu(this.option, a, true);
      }, l2.prototype.get = function(a, e2) {
        return a == null ? this.option : this._doGet(this.parsePath(a), !e2 && this.parentModel);
      }, l2.prototype.getShallow = function(a, e2) {
        var d2 = this.option, y2 = d2 == null ? d2 : d2[a];
        if (y2 == null && !e2) {
          var x2 = this.parentModel;
          x2 && (y2 = x2.getShallow(a));
        }
        return y2;
      }, l2.prototype.getModel = function(a, e2) {
        var d2 = a != null, y2 = d2 ? this.parsePath(a) : null, x2 = d2 ? this._doGet(y2) : this.option;
        return e2 = e2 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(y2)), new l2(x2, e2, this.ecModel);
      }, l2.prototype.isEmpty = function() {
        return this.option == null;
      }, l2.prototype.restoreData = function() {
      }, l2.prototype.clone = function() {
        var a = this.constructor;
        return new a(zl(this.option));
      }, l2.prototype.parsePath = function(a) {
        return typeof a == "string" ? a.split(".") : a;
      }, l2.prototype.resolveParentPath = function(a) {
        return a;
      }, l2.prototype.isAnimationEnabled = function() {
        if (!$s.node && this.option) {
          if (this.option.animation != null)
            return !!this.option.animation;
          if (this.parentModel)
            return this.parentModel.isAnimationEnabled();
        }
      }, l2.prototype._doGet = function(a, e2) {
        var d2 = this.option;
        if (!a)
          return d2;
        for (var y2 = 0; y2 < a.length && !(!!a[y2] && (d2 = d2 && typeof d2 == "object" ? d2[a[y2]] : null, d2 == null)); y2++)
          ;
        return d2 == null && e2 && (d2 = e2._doGet(this.resolveParentPath(a), e2.parentModel)), d2;
      }, l2;
    }();
    CE(tB), J5t(tB), v0(tB, KZe), v0(tB, QZe), v0(tB, iPt), v0(tB, $Ze);
    var hg2 = tB, JZe = Math.round(Math.random() * 10);
    function zq(l2) {
      return [l2 || "", JZe++].join("_");
    }
    function t$e(l2) {
      var a = {};
      l2.registerSubTypeDefaulter = function(e2, d2) {
        var y2 = NS(e2);
        a[y2.main] = d2;
      }, l2.determineSubType = function(e2, d2) {
        var y2 = d2.type;
        if (!y2) {
          var x2 = NS(e2).main;
          l2.hasSubTypes(e2) && a[x2] && (y2 = a[x2](d2));
        }
        return y2;
      };
    }
    function e$e(l2, a) {
      l2.topologicalTravel = function(x2, C, D2, L) {
        if (!x2.length)
          return;
        var F3 = e2(C), j = F3.graph, U3 = F3.noEntryList, Y3 = {};
        for (Ke2(x2, function(Pt) {
          Y3[Pt] = true;
        }); U3.length; ) {
          var Q = U3.pop(), nt = j[Q], dt = !!Y3[Q];
          dt && (D2.call(L, Q, nt.originalDeps.slice()), delete Y3[Q]), Ke2(nt.successor, dt ? Ct : vt);
        }
        Ke2(Y3, function() {
          var Pt = "";
          throw new Error(Pt);
        });
        function vt(Pt) {
          j[Pt].entryCount--, j[Pt].entryCount === 0 && U3.push(Pt);
        }
        function Ct(Pt) {
          Y3[Pt] = true, vt(Pt);
        }
      };
      function e2(x2) {
        var C = {}, D2 = [];
        return Ke2(x2, function(L) {
          var F3 = d2(C, L), j = F3.originalDeps = a(L), U3 = y2(j, x2);
          F3.entryCount = U3.length, F3.entryCount === 0 && D2.push(L), Ke2(U3, function(Y3) {
            oc2(F3.predecessor, Y3) < 0 && F3.predecessor.push(Y3);
            var Q = d2(C, Y3);
            oc2(Q.successor, Y3) < 0 && Q.successor.push(L);
          });
        }), { graph: C, noEntryList: D2 };
      }
      function d2(x2, C) {
        return x2[C] || (x2[C] = { predecessor: [], successor: [] }), x2[C];
      }
      function y2(x2, C) {
        var D2 = [];
        return Ke2(x2, function(L) {
          oc2(C, L) >= 0 && D2.push(L);
        }), D2;
      }
    }
    function ZN(l2, a) {
      return Mu(Mu({}, l2, true), a, true);
    }
    var n$e = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, r$e = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, tyt = "ZH", C3t = "EN", rrt = C3t, eyt = {}, T3t = {}, Kre = $s.domSupported ? function() {
      var l2 = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
      return l2.indexOf(tyt) > -1 ? tyt : rrt;
    }() : rrt;
    function Xre(l2, a) {
      l2 = l2.toUpperCase(), T3t[l2] = new hg2(a), eyt[l2] = a;
    }
    function i$e(l2) {
      if (ps(l2)) {
        var a = eyt[l2.toUpperCase()] || {};
        return l2 === tyt || l2 === C3t ? zl(a) : Mu(zl(a), zl(eyt[rrt]), false);
      } else
        return Mu(zl(l2), zl(eyt[rrt]), false);
    }
    function A3t(l2) {
      return T3t[l2];
    }
    function a$e() {
      return T3t[rrt];
    }
    Xre(C3t, n$e), Xre(tyt, r$e);
    var I3t = 1e3, D3t = I3t * 60, irt = D3t * 60, SA = irt * 24, Qre = SA * 365, art = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, nyt = "{yyyy}-{MM}-{dd}", Jre = { year: "{yyyy}", month: "{yyyy}-{MM}", day: nyt, hour: nyt + " " + art.hour, minute: nyt + " " + art.minute, second: nyt + " " + art.second, millisecond: art.none }, E3t = ["year", "month", "day", "hour", "minute", "second", "millisecond"], tie = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
    function eB(l2, a) {
      return l2 += "", "0000".substr(0, a - l2.length) + l2;
    }
    function jq(l2) {
      switch (l2) {
        case "half-year":
        case "quarter":
          return "month";
        case "week":
        case "half-week":
          return "day";
        case "half-day":
        case "quarter-day":
          return "hour";
        default:
          return l2;
      }
    }
    function o$e(l2) {
      return l2 === jq(l2);
    }
    function s$e(l2) {
      switch (l2) {
        case "year":
        case "month":
          return "day";
        case "millisecond":
          return "millisecond";
        default:
          return "second";
      }
    }
    function ryt(l2, a, e2, d2) {
      var y2 = Am(l2), x2 = y2[k3t(e2)](), C = y2[Wq(e2)]() + 1, D2 = Math.floor((C - 1) / 4) + 1, L = y2[iyt(e2)](), F3 = y2["get" + (e2 ? "UTC" : "") + "Day"](), j = y2[ort(e2)](), U3 = (j - 1) % 12 + 1, Y3 = y2[ayt(e2)](), Q = y2[oyt(e2)](), nt = y2[syt(e2)](), dt = d2 instanceof hg2 ? d2 : A3t(d2 || Kre) || a$e(), vt = dt.getModel("time"), Ct = vt.get("month"), Pt = vt.get("monthAbbr"), jt = vt.get("dayOfWeek"), Rt = vt.get("dayOfWeekAbbr");
      return (a || "").replace(/{yyyy}/g, x2 + "").replace(/{yy}/g, x2 % 100 + "").replace(/{Q}/g, D2 + "").replace(/{MMMM}/g, Ct[C - 1]).replace(/{MMM}/g, Pt[C - 1]).replace(/{MM}/g, eB(C, 2)).replace(/{M}/g, C + "").replace(/{dd}/g, eB(L, 2)).replace(/{d}/g, L + "").replace(/{eeee}/g, jt[F3]).replace(/{ee}/g, Rt[F3]).replace(/{e}/g, F3 + "").replace(/{HH}/g, eB(j, 2)).replace(/{H}/g, j + "").replace(/{hh}/g, eB(U3 + "", 2)).replace(/{h}/g, U3 + "").replace(/{mm}/g, eB(Y3, 2)).replace(/{m}/g, Y3 + "").replace(/{ss}/g, eB(Q, 2)).replace(/{s}/g, Q + "").replace(/{SSS}/g, eB(nt, 3)).replace(/{S}/g, nt + "");
    }
    function l$e(l2, a, e2, d2, y2) {
      var x2 = null;
      if (ps(e2))
        x2 = e2;
      else if (wl(e2))
        x2 = e2(l2.value, a, { level: l2.level });
      else {
        var C = la2({}, art);
        if (l2.level > 0)
          for (var D2 = 0; D2 < E3t.length; ++D2)
            C[E3t[D2]] = "{primary|" + C[E3t[D2]] + "}";
        var L = e2 ? e2.inherit === false ? e2 : El(e2, C) : C, F3 = eie(l2.value, y2);
        if (L[F3])
          x2 = L[F3];
        else if (L.inherit) {
          for (var j = tie.indexOf(F3), D2 = j - 1; D2 >= 0; --D2)
            if (L[F3]) {
              x2 = L[F3];
              break;
            }
          x2 = x2 || C.none;
        }
        if (Ba2(x2)) {
          var U3 = l2.level == null ? 0 : l2.level >= 0 ? l2.level : x2.length + l2.level;
          U3 = Math.min(U3, x2.length - 1), x2 = x2[U3];
        }
      }
      return ryt(new Date(l2.value), x2, y2, d2);
    }
    function eie(l2, a) {
      var e2 = Am(l2), d2 = e2[Wq(a)]() + 1, y2 = e2[iyt(a)](), x2 = e2[ort(a)](), C = e2[ayt(a)](), D2 = e2[oyt(a)](), L = e2[syt(a)](), F3 = L === 0, j = F3 && D2 === 0, U3 = j && C === 0, Y3 = U3 && x2 === 0, Q = Y3 && y2 === 1, nt = Q && d2 === 1;
      return nt ? "year" : Q ? "month" : Y3 ? "day" : U3 ? "hour" : j ? "minute" : F3 ? "second" : "millisecond";
    }
    function nie(l2, a, e2) {
      var d2 = Ch2(l2) ? Am(l2) : l2;
      switch (a = a || eie(l2, e2), a) {
        case "year":
          return d2[k3t(e2)]();
        case "half-year":
          return d2[Wq(e2)]() >= 6 ? 1 : 0;
        case "quarter":
          return Math.floor((d2[Wq(e2)]() + 1) / 4);
        case "month":
          return d2[Wq(e2)]();
        case "day":
          return d2[iyt(e2)]();
        case "half-day":
          return d2[ort(e2)]() / 24;
        case "hour":
          return d2[ort(e2)]();
        case "minute":
          return d2[ayt(e2)]();
        case "second":
          return d2[oyt(e2)]();
        case "millisecond":
          return d2[syt(e2)]();
      }
    }
    function k3t(l2) {
      return l2 ? "getUTCFullYear" : "getFullYear";
    }
    function Wq(l2) {
      return l2 ? "getUTCMonth" : "getMonth";
    }
    function iyt(l2) {
      return l2 ? "getUTCDate" : "getDate";
    }
    function ort(l2) {
      return l2 ? "getUTCHours" : "getHours";
    }
    function ayt(l2) {
      return l2 ? "getUTCMinutes" : "getMinutes";
    }
    function oyt(l2) {
      return l2 ? "getUTCSeconds" : "getSeconds";
    }
    function syt(l2) {
      return l2 ? "getUTCMilliseconds" : "getMilliseconds";
    }
    function u$e(l2) {
      return l2 ? "setUTCFullYear" : "setFullYear";
    }
    function rie(l2) {
      return l2 ? "setUTCMonth" : "setMonth";
    }
    function iie(l2) {
      return l2 ? "setUTCDate" : "setDate";
    }
    function aie(l2) {
      return l2 ? "setUTCHours" : "setHours";
    }
    function oie(l2) {
      return l2 ? "setUTCMinutes" : "setMinutes";
    }
    function sie(l2) {
      return l2 ? "setUTCSeconds" : "setSeconds";
    }
    function lie(l2) {
      return l2 ? "setUTCMilliseconds" : "setMilliseconds";
    }
    function uie(l2) {
      if (!hA(l2))
        return ps(l2) ? l2 : "-";
      var a = (l2 + "").split(".");
      return a[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (a.length > 1 ? "." + a[1] : "");
    }
    function cie(l2, a) {
      return l2 = (l2 || "").toLowerCase().replace(/-(.)/g, function(e2, d2) {
        return d2.toUpperCase();
      }), a && l2 && (l2 = l2.charAt(0).toUpperCase() + l2.slice(1)), l2;
    }
    var Gq = pE, c$e = /([&<>"'])/g, f$e = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
    function dC(l2) {
      return l2 == null ? "" : (l2 + "").replace(c$e, function(a, e2) {
        return f$e[e2];
      });
    }
    function P3t(l2, a, e2) {
      var d2 = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
      function y2(j) {
        return j && TS(j) ? j : "-";
      }
      function x2(j) {
        return !!(j != null && !isNaN(j) && isFinite(j));
      }
      var C = a === "time", D2 = l2 instanceof Date;
      if (C || D2) {
        var L = C ? Am(l2) : l2;
        if (isNaN(+L)) {
          if (D2)
            return "-";
        } else
          return ryt(L, d2, e2);
      }
      if (a === "ordinal")
        return bet(l2) ? y2(l2) : Ch2(l2) && x2(l2) ? l2 + "" : "-";
      var F3 = ME(l2);
      return x2(F3) ? uie(F3) : bet(l2) ? y2(l2) : typeof l2 == "boolean" ? l2 + "" : "-";
    }
    var fie = ["a", "b", "c", "d", "e", "f", "g"], L3t = function(l2, a) {
      return "{" + l2 + (a == null ? "" : a) + "}";
    };
    function hie(l2, a, e2) {
      Ba2(a) || (a = [a]);
      var d2 = a.length;
      if (!d2)
        return "";
      for (var y2 = a[0].$vars || [], x2 = 0; x2 < y2.length; x2++) {
        var C = fie[x2];
        l2 = l2.replace(L3t(C), L3t(C, 0));
      }
      for (var D2 = 0; D2 < d2; D2++)
        for (var L = 0; L < y2.length; L++) {
          var F3 = a[D2][y2[L]];
          l2 = l2.replace(L3t(fie[L], D2), e2 ? dC(F3) : F3);
        }
      return l2;
    }
    function h$e(l2, a, e2) {
      return Ke2(a, function(d2, y2) {
        l2 = l2.replace("{" + y2 + "}", e2 ? dC(d2) : d2);
      }), l2;
    }
    function p$e(l2, a) {
      var e2 = ps(l2) ? { color: l2, extraCssText: a } : l2 || {}, d2 = e2.color, y2 = e2.type;
      a = e2.extraCssText;
      var x2 = e2.renderMode || "html";
      if (!d2)
        return "";
      if (x2 === "html")
        return y2 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + dC(d2) + ";" + (a || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + dC(d2) + ";" + (a || "") + '"></span>';
      var C = e2.markerId || "markerX";
      return { renderMode: x2, content: "{" + C + "|}  ", style: y2 === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: d2 } : { width: 10, height: 10, borderRadius: 5, backgroundColor: d2 } };
    }
    function nB(l2, a) {
      return a = a || "transparent", ps(l2) ? l2 : vs(l2) && l2.colorStops && (l2.colorStops[0] || {}).color || a;
    }
    function lyt(l2, a) {
      if (a === "_blank" || a === "blank") {
        var e2 = window.open();
        e2.opener = null, e2.location.href = l2;
      } else
        window.open(l2, a);
    }
    var uyt = Ke2, pie = ["left", "right", "top", "bottom", "width", "height"], rB = [["width", "left", "right"], ["height", "top", "bottom"]];
    function O3t(l2, a, e2, d2, y2) {
      var x2 = 0, C = 0;
      d2 == null && (d2 = 1 / 0), y2 == null && (y2 = 1 / 0);
      var D2 = 0;
      a.eachChild(function(L, F3) {
        var j = L.getBoundingRect(), U3 = a.childAt(F3 + 1), Y3 = U3 && U3.getBoundingRect(), Q, nt;
        if (l2 === "horizontal") {
          var dt = j.width + (Y3 ? -Y3.x + j.x : 0);
          Q = x2 + dt, Q > d2 || L.newline ? (x2 = 0, Q = dt, C += D2 + e2, D2 = j.height) : D2 = Math.max(D2, j.height);
        } else {
          var vt = j.height + (Y3 ? -Y3.y + j.y : 0);
          nt = C + vt, nt > y2 || L.newline ? (x2 += D2 + e2, C = 0, nt = vt, D2 = j.width) : D2 = Math.max(D2, j.width);
        }
        L.newline || (L.x = x2, L.y = C, L.markRedraw(), l2 === "horizontal" ? x2 = Q + e2 : C = nt + e2);
      });
    }
    var iB = O3t;
    xu(O3t, "vertical"), xu(O3t, "horizontal");
    function d$e(l2, a, e2) {
      var d2 = a.width, y2 = a.height, x2 = Ko(l2.left, d2), C = Ko(l2.top, y2), D2 = Ko(l2.right, d2), L = Ko(l2.bottom, y2);
      return (isNaN(x2) || isNaN(parseFloat(l2.left))) && (x2 = 0), (isNaN(D2) || isNaN(parseFloat(l2.right))) && (D2 = d2), (isNaN(C) || isNaN(parseFloat(l2.top))) && (C = 0), (isNaN(L) || isNaN(parseFloat(l2.bottom))) && (L = y2), e2 = Gq(e2 || 0), { width: Math.max(D2 - x2 - e2[1] - e2[3], 0), height: Math.max(L - C - e2[0] - e2[2], 0) };
    }
    function Em(l2, a, e2) {
      e2 = Gq(e2 || 0);
      var d2 = a.width, y2 = a.height, x2 = Ko(l2.left, d2), C = Ko(l2.top, y2), D2 = Ko(l2.right, d2), L = Ko(l2.bottom, y2), F3 = Ko(l2.width, d2), j = Ko(l2.height, y2), U3 = e2[2] + e2[0], Y3 = e2[1] + e2[3], Q = l2.aspect;
      switch (isNaN(F3) && (F3 = d2 - D2 - Y3 - x2), isNaN(j) && (j = y2 - L - U3 - C), Q != null && (isNaN(F3) && isNaN(j) && (Q > d2 / y2 ? F3 = d2 * 0.8 : j = y2 * 0.8), isNaN(F3) && (F3 = Q * j), isNaN(j) && (j = F3 / Q)), isNaN(x2) && (x2 = d2 - D2 - F3 - Y3), isNaN(C) && (C = y2 - L - j - U3), l2.left || l2.right) {
        case "center":
          x2 = d2 / 2 - F3 / 2 - e2[3];
          break;
        case "right":
          x2 = d2 - F3 - Y3;
          break;
      }
      switch (l2.top || l2.bottom) {
        case "middle":
        case "center":
          C = y2 / 2 - j / 2 - e2[0];
          break;
        case "bottom":
          C = y2 - j - U3;
          break;
      }
      x2 = x2 || 0, C = C || 0, isNaN(F3) && (F3 = d2 - Y3 - x2 - (D2 || 0)), isNaN(j) && (j = y2 - U3 - C - (L || 0));
      var nt = new Yu(x2 + e2[3], C + e2[0], F3, j);
      return nt.margin = e2, nt;
    }
    function cyt(l2, a, e2, d2, y2, x2) {
      var C = !y2 || !y2.hv || y2.hv[0], D2 = !y2 || !y2.hv || y2.hv[1], L = y2 && y2.boundingMode || "all";
      if (x2 = x2 || l2, x2.x = l2.x, x2.y = l2.y, !C && !D2)
        return false;
      var F3;
      if (L === "raw")
        F3 = l2.type === "group" ? new Yu(0, 0, +a.width || 0, +a.height || 0) : l2.getBoundingRect();
      else if (F3 = l2.getBoundingRect(), l2.needLocalTransform()) {
        var j = l2.getLocalTransform();
        F3 = F3.clone(), F3.applyTransform(j);
      }
      var U3 = Em(El({ width: F3.width, height: F3.height }, a), e2, d2), Y3 = C ? U3.x - F3.x : 0, Q = D2 ? U3.y - F3.y : 0;
      return L === "raw" ? (x2.x = Y3, x2.y = Q) : (x2.x += Y3, x2.y += Q), x2 === l2 && l2.markRedraw(), true;
    }
    function g$e(l2, a) {
      return l2[rB[a][0]] != null || l2[rB[a][1]] != null && l2[rB[a][2]] != null;
    }
    function srt(l2) {
      var a = l2.layoutMode || l2.constructor.layoutMode;
      return vs(a) ? a : a ? { type: a } : null;
    }
    function $N(l2, a, e2) {
      var d2 = e2 && e2.ignoreSize;
      !Ba2(d2) && (d2 = [d2, d2]);
      var y2 = C(rB[0], 0), x2 = C(rB[1], 1);
      F3(rB[0], l2, y2), F3(rB[1], l2, x2);
      function C(j, U3) {
        var Y3 = {}, Q = 0, nt = {}, dt = 0, vt = 2;
        if (uyt(j, function(jt) {
          nt[jt] = l2[jt];
        }), uyt(j, function(jt) {
          D2(a, jt) && (Y3[jt] = nt[jt] = a[jt]), L(Y3, jt) && Q++, L(nt, jt) && dt++;
        }), d2[U3])
          return L(a, j[1]) ? nt[j[2]] = null : L(a, j[2]) && (nt[j[1]] = null), nt;
        if (dt === vt || !Q)
          return nt;
        if (Q >= vt)
          return Y3;
        for (var Ct = 0; Ct < j.length; Ct++) {
          var Pt = j[Ct];
          if (!D2(Y3, Pt) && D2(l2, Pt)) {
            Y3[Pt] = l2[Pt];
            break;
          }
        }
        return Y3;
      }
      function D2(j, U3) {
        return j.hasOwnProperty(U3);
      }
      function L(j, U3) {
        return j[U3] != null && j[U3] !== "auto";
      }
      function F3(j, U3, Y3) {
        uyt(j, function(Q) {
          U3[Q] = Y3[Q];
        });
      }
    }
    function Hq(l2) {
      return die({}, l2);
    }
    function die(l2, a) {
      return a && l2 && uyt(pie, function(e2) {
        a.hasOwnProperty(e2) && (l2[e2] = a[e2]);
      }), l2;
    }
    var v$e = Rf2(), Uq = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this, e2, d2, y2) || this;
        return x2.uid = zq("ec_cpt_model"), x2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        this.mergeDefaultAndTheme(e2, y2);
      }, a.prototype.mergeDefaultAndTheme = function(e2, d2) {
        var y2 = srt(this), x2 = y2 ? Hq(e2) : {}, C = d2.getTheme();
        Mu(e2, C.get(this.mainType)), Mu(e2, this.getDefaultOption()), y2 && $N(e2, x2, y2);
      }, a.prototype.mergeOption = function(e2, d2) {
        Mu(this.option, e2, true);
        var y2 = srt(this);
        y2 && $N(this.option, e2, y2);
      }, a.prototype.optionUpdated = function(e2, d2) {
      }, a.prototype.getDefaultOption = function() {
        var e2 = this.constructor;
        if (!pA(e2))
          return e2.defaultOption;
        var d2 = v$e(this);
        if (!d2.defaultOption) {
          for (var y2 = [], x2 = e2; x2; ) {
            var C = x2.prototype.defaultOption;
            C && y2.push(C), x2 = x2.superClass;
          }
          for (var D2 = {}, L = y2.length - 1; L >= 0; L--)
            D2 = Mu(D2, y2[L], true);
          d2.defaultOption = D2;
        }
        return d2.defaultOption;
      }, a.prototype.getReferringComponents = function(e2, d2) {
        var y2 = e2 + "Index", x2 = e2 + "Id";
        return NN(this.ecModel, e2, { index: this.get(y2, true), id: this.get(x2, true) }, d2);
      }, a.prototype.getBoxLayoutParams = function() {
        var e2 = this;
        return { left: e2.get("left"), top: e2.get("top"), right: e2.get("right"), bottom: e2.get("bottom"), width: e2.get("width"), height: e2.get("height") };
      }, a.prototype.getZLevelKey = function() {
        return "";
      }, a.prototype.setZLevel = function(e2) {
        this.option.zlevel = e2;
      }, a.protoInitialize = function() {
        var e2 = a.prototype;
        e2.type = "component", e2.id = "", e2.name = "", e2.mainType = "", e2.subType = "", e2.componentIndex = 0;
      }(), a;
    }(hg2);
    unt(Uq, hg2), fq(Uq), t$e(Uq), e$e(Uq, y$e);
    function y$e(l2) {
      var a = [];
      return Ke2(Uq.getClassesByMainType(l2), function(e2) {
        a = a.concat(e2.dependencies || e2.prototype.dependencies || []);
      }), a = $a2(a, function(e2) {
        return NS(e2).main;
      }), l2 !== "dataset" && oc2(a, "dataset") <= 0 && a.unshift("dataset"), a;
    }
    var Ah2 = Uq, gie = "";
    typeof navigator != "undefined" && (gie = navigator.platform || "");
    var qq = "rgba(0, 0, 0, 0.2)", m$e = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: qq, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: qq, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: qq, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: qq, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: qq, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: qq, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: gie.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, vie = fl(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), MA = "original", sw = "arrayRows", CA = "objectRows", aP = "keyedColumns", YN = "typedArray", yie = "unknown", oP = "column", Zq = "row", V_ = { Must: 1, Might: 2, Not: 3 }, mie = Rf2();
    function b$e(l2) {
      mie(l2).datasetMap = fl();
    }
    function bie(l2, a, e2) {
      var d2 = {}, y2 = N3t(a);
      if (!y2 || !l2)
        return d2;
      var x2 = [], C = [], D2 = a.ecModel, L = mie(D2).datasetMap, F3 = y2.uid + "_" + e2.seriesLayoutBy, j, U3;
      l2 = l2.slice(), Ke2(l2, function(dt, vt) {
        var Ct = vs(dt) ? dt : l2[vt] = { name: dt };
        Ct.type === "ordinal" && j == null && (j = vt, U3 = nt(Ct)), d2[Ct.name] = [];
      });
      var Y3 = L.get(F3) || L.set(F3, { categoryWayDim: U3, valueWayDim: 0 });
      Ke2(l2, function(dt, vt) {
        var Ct = dt.name, Pt = nt(dt);
        if (j == null) {
          var jt = Y3.valueWayDim;
          Q(d2[Ct], jt, Pt), Q(C, jt, Pt), Y3.valueWayDim += Pt;
        } else if (j === vt)
          Q(d2[Ct], 0, Pt), Q(x2, 0, Pt);
        else {
          var jt = Y3.categoryWayDim;
          Q(d2[Ct], jt, Pt), Q(C, jt, Pt), Y3.categoryWayDim += Pt;
        }
      });
      function Q(dt, vt, Ct) {
        for (var Pt = 0; Pt < Ct; Pt++)
          dt.push(vt + Pt);
      }
      function nt(dt) {
        var vt = dt.dimsDef;
        return vt ? vt.length : 1;
      }
      return x2.length && (d2.itemName = x2), C.length && (d2.seriesName = C), d2;
    }
    function R3t(l2, a, e2) {
      var d2 = {}, y2 = N3t(l2);
      if (!y2)
        return d2;
      var x2 = a.sourceFormat, C = a.dimensionsDefine, D2;
      (x2 === CA || x2 === aP) && Ke2(C, function(j, U3) {
        (vs(j) ? j.name : j) === "name" && (D2 = U3);
      });
      var L = function() {
        for (var j = {}, U3 = {}, Y3 = [], Q = 0, nt = Math.min(5, e2); Q < nt; Q++) {
          var dt = xie(a.data, x2, a.seriesLayoutBy, C, a.startIndex, Q);
          Y3.push(dt);
          var vt = dt === V_.Not;
          if (vt && j.v == null && Q !== D2 && (j.v = Q), (j.n == null || j.n === j.v || !vt && Y3[j.n] === V_.Not) && (j.n = Q), Ct(j) && Y3[j.n] !== V_.Not)
            return j;
          vt || (dt === V_.Might && U3.v == null && Q !== D2 && (U3.v = Q), (U3.n == null || U3.n === U3.v) && (U3.n = Q));
        }
        function Ct(Pt) {
          return Pt.v != null && Pt.n != null;
        }
        return Ct(j) ? j : Ct(U3) ? U3 : null;
      }();
      if (L) {
        d2.value = [L.v];
        var F3 = D2 != null ? D2 : L.n;
        d2.itemName = [F3], d2.seriesName = [F3];
      }
      return d2;
    }
    function N3t(l2) {
      var a = l2.get("data", true);
      if (!a)
        return NN(l2.ecModel, "dataset", { index: l2.get("datasetIndex", true), id: l2.get("datasetId", true) }, q0).models[0];
    }
    function _$e(l2) {
      return !l2.get("transform", true) && !l2.get("fromTransformResult", true) ? [] : NN(l2.ecModel, "dataset", { index: l2.get("fromDatasetIndex", true), id: l2.get("fromDatasetId", true) }, q0).models;
    }
    function _ie(l2, a) {
      return xie(l2.data, l2.sourceFormat, l2.seriesLayoutBy, l2.dimensionsDefine, l2.startIndex, a);
    }
    function xie(l2, a, e2, d2, y2, x2) {
      var C, D2 = 5;
      if (CS(l2))
        return V_.Not;
      var L, F3;
      if (d2) {
        var j = d2[x2];
        vs(j) ? (L = j.name, F3 = j.type) : ps(j) && (L = j);
      }
      if (F3 != null)
        return F3 === "ordinal" ? V_.Must : V_.Not;
      if (a === sw) {
        var U3 = l2;
        if (e2 === Zq) {
          for (var Y3 = U3[x2], Q = 0; Q < (Y3 || []).length && Q < D2; Q++)
            if ((C = Rt(Y3[y2 + Q])) != null)
              return C;
        } else
          for (var Q = 0; Q < U3.length && Q < D2; Q++) {
            var nt = U3[y2 + Q];
            if (nt && (C = Rt(nt[x2])) != null)
              return C;
          }
      } else if (a === CA) {
        var dt = l2;
        if (!L)
          return V_.Not;
        for (var Q = 0; Q < dt.length && Q < D2; Q++) {
          var vt = dt[Q];
          if (vt && (C = Rt(vt[L])) != null)
            return C;
        }
      } else if (a === aP) {
        var Ct = l2;
        if (!L)
          return V_.Not;
        var Y3 = Ct[L];
        if (!Y3 || CS(Y3))
          return V_.Not;
        for (var Q = 0; Q < Y3.length && Q < D2; Q++)
          if ((C = Rt(Y3[Q])) != null)
            return C;
      } else if (a === MA)
        for (var Pt = l2, Q = 0; Q < Pt.length && Q < D2; Q++) {
          var vt = Pt[Q], jt = q5(vt);
          if (!Ba2(jt))
            return V_.Not;
          if ((C = Rt(jt[x2])) != null)
            return C;
        }
      function Rt(le2) {
        var ne2 = ps(le2);
        if (le2 != null && isFinite(le2) && le2 !== "")
          return ne2 ? V_.Might : V_.Not;
        if (ne2 && le2 !== "-")
          return V_.Must;
      }
      return V_.Not;
    }
    var F3t = fl();
    function x$e(l2, a) {
      vb2(F3t.get(l2) == null && a), F3t.set(l2, a);
    }
    function w$e(l2, a, e2) {
      var d2 = F3t.get(a);
      if (!d2)
        return e2;
      var y2 = d2(l2);
      return y2 ? e2.concat(y2) : e2;
    }
    var wie = Rf2(), S$e = Rf2(), V3t = function() {
      function l2() {
      }
      return l2.prototype.getColorFromPalette = function(a, e2, d2) {
        var y2 = Mp(this.get("color", true)), x2 = this.get("colorLayer", true);
        return Sie(this, wie, y2, x2, a, e2, d2);
      }, l2.prototype.clearColorPalette = function() {
        C$e(this, wie);
      }, l2;
    }();
    function B3t(l2, a, e2, d2) {
      var y2 = Mp(l2.get(["aria", "decal", "decals"]));
      return Sie(l2, S$e, y2, null, a, e2, d2);
    }
    function M$e(l2, a) {
      for (var e2 = l2.length, d2 = 0; d2 < e2; d2++)
        if (l2[d2].length > a)
          return l2[d2];
      return l2[e2 - 1];
    }
    function Sie(l2, a, e2, d2, y2, x2, C) {
      x2 = x2 || l2;
      var D2 = a(x2), L = D2.paletteIdx || 0, F3 = D2.paletteNameMap = D2.paletteNameMap || {};
      if (F3.hasOwnProperty(y2))
        return F3[y2];
      var j = C == null || !d2 ? e2 : M$e(d2, C);
      if (j = j || e2, !(!j || !j.length)) {
        var U3 = j[L];
        return y2 && (F3[y2] = U3), D2.paletteIdx = (L + 1) % j.length, U3;
      }
    }
    function C$e(l2, a) {
      a(l2).paletteIdx = 0, a(l2).paletteNameMap = {};
    }
    var fyt, lrt, Mie, Cie = "\0_ec_inner", T$e = 1, Tie = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.init = function(e2, d2, y2, x2, C, D2) {
        x2 = x2 || {}, this.option = null, this._theme = new hg2(x2), this._locale = new hg2(C), this._optionManager = D2;
      }, a.prototype.setOption = function(e2, d2, y2) {
        var x2 = Die(d2);
        this._optionManager.setOption(e2, y2, x2), this._resetOption(null, x2);
      }, a.prototype.resetOption = function(e2, d2) {
        return this._resetOption(e2, Die(d2));
      }, a.prototype._resetOption = function(e2, d2) {
        var y2 = false, x2 = this._optionManager;
        if (!e2 || e2 === "recreate") {
          var C = x2.mountOption(e2 === "recreate");
          !this.option || e2 === "recreate" ? Mie(this, C) : (this.restoreData(), this._mergeOption(C, d2)), y2 = true;
        }
        if ((e2 === "timeline" || e2 === "media") && this.restoreData(), !e2 || e2 === "recreate" || e2 === "timeline") {
          var D2 = x2.getTimelineOption(this);
          D2 && (y2 = true, this._mergeOption(D2, d2));
        }
        if (!e2 || e2 === "recreate" || e2 === "media") {
          var L = x2.getMediaOption(this);
          L.length && Ke2(L, function(F3) {
            y2 = true, this._mergeOption(F3, d2);
          }, this);
        }
        return y2;
      }, a.prototype.mergeOption = function(e2) {
        this._mergeOption(e2, null);
      }, a.prototype._mergeOption = function(e2, d2) {
        var y2 = this.option, x2 = this._componentsMap, C = this._componentsCount, D2 = [], L = fl(), F3 = d2 && d2.replaceMergeMainTypeMap;
        b$e(this), Ke2(e2, function(U3, Y3) {
          U3 != null && (Ah2.hasClass(Y3) ? Y3 && (D2.push(Y3), L.set(Y3, true)) : y2[Y3] = y2[Y3] == null ? zl(U3) : Mu(y2[Y3], U3, true));
        }), F3 && F3.each(function(U3, Y3) {
          Ah2.hasClass(Y3) && !L.get(Y3) && (D2.push(Y3), L.set(Y3, true));
        }), Ah2.topologicalTravel(D2, Ah2.getAllClassMainTypes(), j, this);
        function j(U3) {
          var Y3 = w$e(this, U3, Mp(e2[U3])), Q = x2.get(U3), nt = Q ? F3 && F3.get(U3) ? "replaceMerge" : "normalMerge" : "replaceAll", dt = v12(Q, Y3, nt);
          rnt(dt, U3, Ah2), y2[U3] = null, x2.set(U3, null), C.set(U3, 0);
          var vt = [], Ct = [], Pt = 0, jt;
          Ke2(dt, function(Rt, le2) {
            var ne2 = Rt.existing, he2 = Rt.newOption;
            if (!he2)
              ne2 && (ne2.mergeOption({}, this), ne2.optionUpdated({}, false));
            else {
              var _e = U3 === "series", Me2 = Ah2.getClass(U3, Rt.keyInfo.subType, !_e);
              if (!Me2)
                return;
              if (U3 === "tooltip") {
                if (jt)
                  return;
                jt = true;
              }
              if (ne2 && ne2.constructor === Me2)
                ne2.name = Rt.keyInfo.name, ne2.mergeOption(he2, this), ne2.optionUpdated(he2, false);
              else {
                var Pe2 = la2({ componentIndex: le2 }, Rt.keyInfo);
                ne2 = new Me2(he2, this, this, Pe2), la2(ne2, Pe2), Rt.brandNew && (ne2.__requireNewView = true), ne2.init(he2, this, this), ne2.optionUpdated(null, true);
              }
            }
            ne2 ? (vt.push(ne2.option), Ct.push(ne2), Pt++) : (vt.push(void 0), Ct.push(void 0));
          }, this), y2[U3] = vt, x2.set(U3, Ct), C.set(U3, Pt), U3 === "series" && fyt(this);
        }
        this._seriesIndices || fyt(this);
      }, a.prototype.getOption = function() {
        var e2 = zl(this.option);
        return Ke2(e2, function(d2, y2) {
          if (Ah2.hasClass(y2)) {
            for (var x2 = Mp(d2), C = x2.length, D2 = false, L = C - 1; L >= 0; L--)
              x2[L] && !pO(x2[L]) ? D2 = true : (x2[L] = null, !D2 && C--);
            x2.length = C, e2[y2] = x2;
          }
        }), delete e2[Cie], e2;
      }, a.prototype.getTheme = function() {
        return this._theme;
      }, a.prototype.getLocaleModel = function() {
        return this._locale;
      }, a.prototype.setUpdatePayload = function(e2) {
        this._payload = e2;
      }, a.prototype.getUpdatePayload = function() {
        return this._payload;
      }, a.prototype.getComponent = function(e2, d2) {
        var y2 = this._componentsMap.get(e2);
        if (y2) {
          var x2 = y2[d2 || 0];
          if (x2)
            return x2;
          if (d2 == null) {
            for (var C = 0; C < y2.length; C++)
              if (y2[C])
                return y2[C];
          }
        }
      }, a.prototype.queryComponents = function(e2) {
        var d2 = e2.mainType;
        if (!d2)
          return [];
        var y2 = e2.index, x2 = e2.id, C = e2.name, D2 = this._componentsMap.get(d2);
        if (!D2 || !D2.length)
          return [];
        var L;
        return y2 != null ? (L = [], Ke2(Mp(y2), function(F3) {
          D2[F3] && L.push(D2[F3]);
        })) : x2 != null ? L = Aie("id", x2, D2) : C != null ? L = Aie("name", C, D2) : L = Lp(D2, function(F3) {
          return !!F3;
        }), Iie(L, e2);
      }, a.prototype.findComponents = function(e2) {
        var d2 = e2.query, y2 = e2.mainType, x2 = D2(d2), C = x2 ? this.queryComponents(x2) : Lp(this._componentsMap.get(y2), function(F3) {
          return !!F3;
        });
        return L(Iie(C, e2));
        function D2(F3) {
          var j = y2 + "Index", U3 = y2 + "Id", Y3 = y2 + "Name";
          return F3 && (F3[j] != null || F3[U3] != null || F3[Y3] != null) ? { mainType: y2, index: F3[j], id: F3[U3], name: F3[Y3] } : null;
        }
        function L(F3) {
          return e2.filter ? Lp(F3, e2.filter) : F3;
        }
      }, a.prototype.eachComponent = function(e2, d2, y2) {
        var x2 = this._componentsMap;
        if (wl(e2)) {
          var C = d2, D2 = e2;
          x2.each(function(U3, Y3) {
            for (var Q = 0; U3 && Q < U3.length; Q++) {
              var nt = U3[Q];
              nt && D2.call(C, Y3, nt, nt.componentIndex);
            }
          });
        } else
          for (var L = ps(e2) ? x2.get(e2) : vs(e2) ? this.findComponents(e2) : null, F3 = 0; L && F3 < L.length; F3++) {
            var j = L[F3];
            j && d2.call(y2, j, j.componentIndex);
          }
      }, a.prototype.getSeriesByName = function(e2) {
        var d2 = Ud2(e2, null);
        return Lp(this._componentsMap.get("series"), function(y2) {
          return !!y2 && d2 != null && y2.name === d2;
        });
      }, a.prototype.getSeriesByIndex = function(e2) {
        return this._componentsMap.get("series")[e2];
      }, a.prototype.getSeriesByType = function(e2) {
        return Lp(this._componentsMap.get("series"), function(d2) {
          return !!d2 && d2.subType === e2;
        });
      }, a.prototype.getSeries = function() {
        return Lp(this._componentsMap.get("series"), function(e2) {
          return !!e2;
        });
      }, a.prototype.getSeriesCount = function() {
        return this._componentsCount.get("series");
      }, a.prototype.eachSeries = function(e2, d2) {
        lrt(this), Ke2(this._seriesIndices, function(y2) {
          var x2 = this._componentsMap.get("series")[y2];
          e2.call(d2, x2, y2);
        }, this);
      }, a.prototype.eachRawSeries = function(e2, d2) {
        Ke2(this._componentsMap.get("series"), function(y2) {
          y2 && e2.call(d2, y2, y2.componentIndex);
        });
      }, a.prototype.eachSeriesByType = function(e2, d2, y2) {
        lrt(this), Ke2(this._seriesIndices, function(x2) {
          var C = this._componentsMap.get("series")[x2];
          C.subType === e2 && d2.call(y2, C, x2);
        }, this);
      }, a.prototype.eachRawSeriesByType = function(e2, d2, y2) {
        return Ke2(this.getSeriesByType(e2), d2, y2);
      }, a.prototype.isSeriesFiltered = function(e2) {
        return lrt(this), this._seriesIndicesMap.get(e2.componentIndex) == null;
      }, a.prototype.getCurrentSeriesIndices = function() {
        return (this._seriesIndices || []).slice();
      }, a.prototype.filterSeries = function(e2, d2) {
        lrt(this);
        var y2 = [];
        Ke2(this._seriesIndices, function(x2) {
          var C = this._componentsMap.get("series")[x2];
          e2.call(d2, C, x2) && y2.push(x2);
        }, this), this._seriesIndices = y2, this._seriesIndicesMap = fl(y2);
      }, a.prototype.restoreData = function(e2) {
        fyt(this);
        var d2 = this._componentsMap, y2 = [];
        d2.each(function(x2, C) {
          Ah2.hasClass(C) && y2.push(C);
        }), Ah2.topologicalTravel(y2, Ah2.getAllClassMainTypes(), function(x2) {
          Ke2(d2.get(x2), function(C) {
            C && (x2 !== "series" || !A$e(C, e2)) && C.restoreData();
          });
        });
      }, a.internalField = function() {
        fyt = function(e2) {
          var d2 = e2._seriesIndices = [];
          Ke2(e2._componentsMap.get("series"), function(y2) {
            y2 && d2.push(y2.componentIndex);
          }), e2._seriesIndicesMap = fl(d2);
        }, lrt = function(e2) {
        }, Mie = function(e2, d2) {
          e2.option = {}, e2.option[Cie] = T$e, e2._componentsMap = fl({ series: [] }), e2._componentsCount = fl();
          var y2 = d2.aria;
          vs(y2) && y2.enabled == null && (y2.enabled = true), I$e(d2, e2._theme.option), Mu(d2, m$e, false), e2._mergeOption(d2, null);
        };
      }(), a;
    }(hg2);
    function A$e(l2, a) {
      if (a) {
        var e2 = a.seriesIndex, d2 = a.seriesId, y2 = a.seriesName;
        return e2 != null && l2.componentIndex !== e2 || d2 != null && l2.id !== d2 || y2 != null && l2.name !== y2;
      }
    }
    function I$e(l2, a) {
      var e2 = l2.color && !l2.colorLayer;
      Ke2(a, function(d2, y2) {
        y2 === "colorLayer" && e2 || Ah2.hasClass(y2) || (typeof d2 == "object" ? l2[y2] = l2[y2] ? Mu(l2[y2], d2, false) : zl(d2) : l2[y2] == null && (l2[y2] = d2));
      });
    }
    function Aie(l2, a, e2) {
      if (Ba2(a)) {
        var d2 = fl();
        return Ke2(a, function(x2) {
          if (x2 != null) {
            var C = Ud2(x2, null);
            C != null && d2.set(x2, true);
          }
        }), Lp(e2, function(x2) {
          return x2 && d2.get(x2[l2]);
        });
      } else {
        var y2 = Ud2(a, null);
        return Lp(e2, function(x2) {
          return x2 && y2 != null && x2[l2] === y2;
        });
      }
    }
    function Iie(l2, a) {
      return a.hasOwnProperty("subType") ? Lp(l2, function(e2) {
        return e2 && e2.subType === a.subType;
      }) : l2;
    }
    function Die(l2) {
      var a = fl();
      return l2 && Ke2(Mp(l2.replaceMerge), function(e2) {
        a.set(e2, true);
      }), { replaceMergeMainTypeMap: a };
    }
    v0(Tie, V3t);
    var Eie = Tie, D$e = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], E$e = function() {
      function l2(a) {
        Ke2(D$e, function(e2) {
          this[e2] = As(a[e2], a);
        }, this);
      }
      return l2;
    }(), kie = E$e, z3t = {}, k$e = function() {
      function l2() {
        this._coordinateSystems = [];
      }
      return l2.prototype.create = function(a, e2) {
        var d2 = [];
        Ke2(z3t, function(y2, x2) {
          var C = y2.create(a, e2);
          d2 = d2.concat(C || []);
        }), this._coordinateSystems = d2;
      }, l2.prototype.update = function(a, e2) {
        Ke2(this._coordinateSystems, function(d2) {
          d2.update && d2.update(a, e2);
        });
      }, l2.prototype.getCoordinateSystems = function() {
        return this._coordinateSystems.slice();
      }, l2.register = function(a, e2) {
        z3t[a] = e2;
      }, l2.get = function(a) {
        return z3t[a];
      }, l2;
    }(), urt = k$e, P$e = /^(min|max)?(.+)$/, L$e = function() {
      function l2(a) {
        this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = a;
      }
      return l2.prototype.setOption = function(a, e2, d2) {
        a && (Ke2(Mp(a.series), function(C) {
          C && C.data && CS(C.data) && gV(C.data);
        }), Ke2(Mp(a.dataset), function(C) {
          C && C.source && CS(C.source) && gV(C.source);
        })), a = zl(a);
        var y2 = this._optionBackup, x2 = O$e(a, e2, !y2);
        this._newBaseOption = x2.baseOption, y2 ? (x2.timelineOptions.length && (y2.timelineOptions = x2.timelineOptions), x2.mediaList.length && (y2.mediaList = x2.mediaList), x2.mediaDefault && (y2.mediaDefault = x2.mediaDefault)) : this._optionBackup = x2;
      }, l2.prototype.mountOption = function(a) {
        var e2 = this._optionBackup;
        return this._timelineOptions = e2.timelineOptions, this._mediaList = e2.mediaList, this._mediaDefault = e2.mediaDefault, this._currentMediaIndices = [], zl(a ? e2.baseOption : this._newBaseOption);
      }, l2.prototype.getTimelineOption = function(a) {
        var e2, d2 = this._timelineOptions;
        if (d2.length) {
          var y2 = a.getComponent("timeline");
          y2 && (e2 = zl(d2[y2.getCurrentIndex()]));
        }
        return e2;
      }, l2.prototype.getMediaOption = function(a) {
        var e2 = this._api.getWidth(), d2 = this._api.getHeight(), y2 = this._mediaList, x2 = this._mediaDefault, C = [], D2 = [];
        if (!y2.length && !x2)
          return D2;
        for (var L = 0, F3 = y2.length; L < F3; L++)
          R$e(y2[L].query, e2, d2) && C.push(L);
        return !C.length && x2 && (C = [-1]), C.length && !F$e(C, this._currentMediaIndices) && (D2 = $a2(C, function(j) {
          return zl(j === -1 ? x2.option : y2[j].option);
        })), this._currentMediaIndices = C, D2;
      }, l2;
    }();
    function O$e(l2, a, e2) {
      var d2 = [], y2, x2, C = l2.baseOption, D2 = l2.timeline, L = l2.options, F3 = l2.media, j = !!l2.media, U3 = !!(L || D2 || C && C.timeline);
      C ? (x2 = C, x2.timeline || (x2.timeline = D2)) : ((U3 || j) && (l2.options = l2.media = null), x2 = l2), j && Ba2(F3) && Ke2(F3, function(Q) {
        Q && Q.option && (Q.query ? d2.push(Q) : y2 || (y2 = Q));
      }), Y3(x2), Ke2(L, function(Q) {
        return Y3(Q);
      }), Ke2(d2, function(Q) {
        return Y3(Q.option);
      });
      function Y3(Q) {
        Ke2(a, function(nt) {
          nt(Q, e2);
        });
      }
      return { baseOption: x2, timelineOptions: L || [], mediaDefault: y2, mediaList: d2 };
    }
    function R$e(l2, a, e2) {
      var d2 = { width: a, height: e2, aspectratio: a / e2 }, y2 = true;
      return Ke2(l2, function(x2, C) {
        var D2 = C.match(P$e);
        if (!(!D2 || !D2[1] || !D2[2])) {
          var L = D2[1], F3 = D2[2].toLowerCase();
          N$e(d2[F3], x2, L) || (y2 = false);
        }
      }), y2;
    }
    function N$e(l2, a, e2) {
      return e2 === "min" ? l2 >= a : e2 === "max" ? l2 <= a : l2 === a;
    }
    function F$e(l2, a) {
      return l2.join(",") === a.join(",");
    }
    var V$e = L$e, DE = Ke2, crt = vs, Pie = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
    function j3t(l2) {
      var a = l2 && l2.itemStyle;
      if (a)
        for (var e2 = 0, d2 = Pie.length; e2 < d2; e2++) {
          var y2 = Pie[e2], x2 = a.normal, C = a.emphasis;
          x2 && x2[y2] && (l2[y2] = l2[y2] || {}, l2[y2].normal ? Mu(l2[y2].normal, x2[y2]) : l2[y2].normal = x2[y2], x2[y2] = null), C && C[y2] && (l2[y2] = l2[y2] || {}, l2[y2].emphasis ? Mu(l2[y2].emphasis, C[y2]) : l2[y2].emphasis = C[y2], C[y2] = null);
        }
    }
    function lw(l2, a, e2) {
      if (l2 && l2[a] && (l2[a].normal || l2[a].emphasis)) {
        var d2 = l2[a].normal, y2 = l2[a].emphasis;
        d2 && (e2 ? (l2[a].normal = l2[a].emphasis = null, El(l2[a], d2)) : l2[a] = d2), y2 && (l2.emphasis = l2.emphasis || {}, l2.emphasis[a] = y2, y2.focus && (l2.emphasis.focus = y2.focus), y2.blurScope && (l2.emphasis.blurScope = y2.blurScope));
      }
    }
    function frt(l2) {
      lw(l2, "itemStyle"), lw(l2, "lineStyle"), lw(l2, "areaStyle"), lw(l2, "label"), lw(l2, "labelLine"), lw(l2, "upperLabel"), lw(l2, "edgeLabel");
    }
    function Uy(l2, a) {
      var e2 = crt(l2) && l2[a], d2 = crt(e2) && e2.textStyle;
      if (d2)
        for (var y2 = 0, x2 = Hvt.length; y2 < x2; y2++) {
          var C = Hvt[y2];
          d2.hasOwnProperty(C) && (e2[C] = d2[C]);
        }
    }
    function TA(l2) {
      l2 && (frt(l2), Uy(l2, "label"), l2.emphasis && Uy(l2.emphasis, "label"));
    }
    function B$e(l2) {
      if (crt(l2)) {
        j3t(l2), frt(l2), Uy(l2, "label"), Uy(l2, "upperLabel"), Uy(l2, "edgeLabel"), l2.emphasis && (Uy(l2.emphasis, "label"), Uy(l2.emphasis, "upperLabel"), Uy(l2.emphasis, "edgeLabel"));
        var a = l2.markPoint;
        a && (j3t(a), TA(a));
        var e2 = l2.markLine;
        e2 && (j3t(e2), TA(e2));
        var d2 = l2.markArea;
        d2 && TA(d2);
        var y2 = l2.data;
        if (l2.type === "graph") {
          y2 = y2 || l2.nodes;
          var x2 = l2.links || l2.edges;
          if (x2 && !CS(x2))
            for (var C = 0; C < x2.length; C++)
              TA(x2[C]);
          Ke2(l2.categories, function(F3) {
            frt(F3);
          });
        }
        if (y2 && !CS(y2))
          for (var C = 0; C < y2.length; C++)
            TA(y2[C]);
        if (a = l2.markPoint, a && a.data)
          for (var D2 = a.data, C = 0; C < D2.length; C++)
            TA(D2[C]);
        if (e2 = l2.markLine, e2 && e2.data)
          for (var L = e2.data, C = 0; C < L.length; C++)
            Ba2(L[C]) ? (TA(L[C][0]), TA(L[C][1])) : TA(L[C]);
        l2.type === "gauge" ? (Uy(l2, "axisLabel"), Uy(l2, "title"), Uy(l2, "detail")) : l2.type === "treemap" ? (lw(l2.breadcrumb, "itemStyle"), Ke2(l2.levels, function(F3) {
          frt(F3);
        })) : l2.type === "tree" && frt(l2.leaves);
      }
    }
    function EO(l2) {
      return Ba2(l2) ? l2 : l2 ? [l2] : [];
    }
    function Lie(l2) {
      return (Ba2(l2) ? l2[0] : l2) || {};
    }
    function z$e(l2, a) {
      DE(EO(l2.series), function(d2) {
        crt(d2) && B$e(d2);
      });
      var e2 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
      a && e2.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), DE(e2, function(d2) {
        DE(EO(l2[d2]), function(y2) {
          y2 && (Uy(y2, "axisLabel"), Uy(y2.axisPointer, "label"));
        });
      }), DE(EO(l2.parallel), function(d2) {
        var y2 = d2 && d2.parallelAxisDefault;
        Uy(y2, "axisLabel"), Uy(y2 && y2.axisPointer, "label");
      }), DE(EO(l2.calendar), function(d2) {
        lw(d2, "itemStyle"), Uy(d2, "dayLabel"), Uy(d2, "monthLabel"), Uy(d2, "yearLabel");
      }), DE(EO(l2.radar), function(d2) {
        Uy(d2, "name"), d2.name && d2.axisName == null && (d2.axisName = d2.name, delete d2.name), d2.nameGap != null && d2.axisNameGap == null && (d2.axisNameGap = d2.nameGap, delete d2.nameGap);
      }), DE(EO(l2.geo), function(d2) {
        crt(d2) && (TA(d2), DE(EO(d2.regions), function(y2) {
          TA(y2);
        }));
      }), DE(EO(l2.timeline), function(d2) {
        TA(d2), lw(d2, "label"), lw(d2, "itemStyle"), lw(d2, "controlStyle", true);
        var y2 = d2.data;
        Ba2(y2) && Ke2(y2, function(x2) {
          vs(x2) && (lw(x2, "label"), lw(x2, "itemStyle"));
        });
      }), DE(EO(l2.toolbox), function(d2) {
        lw(d2, "iconStyle"), DE(d2.feature, function(y2) {
          lw(y2, "iconStyle");
        });
      }), Uy(Lie(l2.axisPointer), "label"), Uy(Lie(l2.tooltip).axisPointer, "label");
    }
    function j$e(l2, a) {
      for (var e2 = a.split(","), d2 = l2, y2 = 0; y2 < e2.length && (d2 = d2 && d2[e2[y2]], d2 != null); y2++)
        ;
      return d2;
    }
    function W$e(l2, a, e2, d2) {
      for (var y2 = a.split(","), x2 = l2, C, D2 = 0; D2 < y2.length - 1; D2++)
        C = y2[D2], x2[C] == null && (x2[C] = {}), x2 = x2[C];
      (d2 || x2[y2[D2]] == null) && (x2[y2[D2]] = e2);
    }
    function Oie(l2) {
      l2 && Ke2(G$e, function(a) {
        a[0] in l2 && !(a[1] in l2) && (l2[a[1]] = l2[a[0]]);
      });
    }
    var G$e = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], H$e = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], W3t = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
    function hrt(l2) {
      var a = l2 && l2.itemStyle;
      if (a)
        for (var e2 = 0; e2 < W3t.length; e2++) {
          var d2 = W3t[e2][1], y2 = W3t[e2][0];
          a[d2] != null && (a[y2] = a[d2]);
        }
    }
    function Rie(l2) {
      !l2 || l2.alignTo === "edge" && l2.margin != null && l2.edgeDistance == null && (l2.edgeDistance = l2.margin);
    }
    function Nie(l2) {
      !l2 || l2.downplay && !l2.blur && (l2.blur = l2.downplay);
    }
    function U$e(l2) {
      !l2 || l2.focusNodeAdjacency != null && (l2.emphasis = l2.emphasis || {}, l2.emphasis.focus == null && (l2.emphasis.focus = "adjacency"));
    }
    function Fie(l2, a) {
      if (l2)
        for (var e2 = 0; e2 < l2.length; e2++)
          a(l2[e2]), l2[e2] && Fie(l2[e2].children, a);
    }
    function Vie(l2, a) {
      z$e(l2, a), l2.series = Mp(l2.series), Ke2(l2.series, function(e2) {
        if (vs(e2)) {
          var d2 = e2.type;
          if (d2 === "line")
            e2.clipOverflow != null && (e2.clip = e2.clipOverflow);
          else if (d2 === "pie" || d2 === "gauge") {
            e2.clockWise != null && (e2.clockwise = e2.clockWise), Rie(e2.label);
            var y2 = e2.data;
            if (y2 && !CS(y2))
              for (var x2 = 0; x2 < y2.length; x2++)
                Rie(y2[x2]);
            e2.hoverOffset != null && (e2.emphasis = e2.emphasis || {}, (e2.emphasis.scaleSize = null) && (e2.emphasis.scaleSize = e2.hoverOffset));
          } else if (d2 === "gauge") {
            var C = j$e(e2, "pointer.color");
            C != null && W$e(e2, "itemStyle.color", C);
          } else if (d2 === "bar") {
            hrt(e2), hrt(e2.backgroundStyle), hrt(e2.emphasis);
            var y2 = e2.data;
            if (y2 && !CS(y2))
              for (var x2 = 0; x2 < y2.length; x2++)
                typeof y2[x2] == "object" && (hrt(y2[x2]), hrt(y2[x2] && y2[x2].emphasis));
          } else if (d2 === "sunburst") {
            var D2 = e2.highlightPolicy;
            D2 && (e2.emphasis = e2.emphasis || {}, e2.emphasis.focus || (e2.emphasis.focus = D2)), Nie(e2), Fie(e2.data, Nie);
          } else
            d2 === "graph" || d2 === "sankey" ? U$e(e2) : d2 === "map" && (e2.mapType && !e2.map && (e2.map = e2.mapType), e2.mapLocation && El(e2, e2.mapLocation));
          e2.hoverAnimation != null && (e2.emphasis = e2.emphasis || {}, e2.emphasis && e2.emphasis.scale == null && (e2.emphasis.scale = e2.hoverAnimation)), Oie(e2);
        }
      }), l2.dataRange && (l2.visualMap = l2.dataRange), Ke2(H$e, function(e2) {
        var d2 = l2[e2];
        d2 && (Ba2(d2) || (d2 = [d2]), Ke2(d2, function(y2) {
          Oie(y2);
        }));
      });
    }
    function q$e(l2) {
      var a = fl();
      l2.eachSeries(function(e2) {
        var d2 = e2.get("stack");
        if (d2) {
          var y2 = a.get(d2) || a.set(d2, []), x2 = e2.getData(), C = { stackResultDimension: x2.getCalculationInfo("stackResultDimension"), stackedOverDimension: x2.getCalculationInfo("stackedOverDimension"), stackedDimension: x2.getCalculationInfo("stackedDimension"), stackedByDimension: x2.getCalculationInfo("stackedByDimension"), isStackedByIndex: x2.getCalculationInfo("isStackedByIndex"), data: x2, seriesModel: e2 };
          if (!C.stackedDimension || !(C.isStackedByIndex || C.stackedByDimension))
            return;
          y2.length && x2.setCalculationInfo("stackedOnSeries", y2[y2.length - 1].seriesModel), y2.push(C);
        }
      }), a.each(Z$e);
    }
    function Z$e(l2) {
      Ke2(l2, function(a, e2) {
        var d2 = [], y2 = [NaN, NaN], x2 = [a.stackResultDimension, a.stackedOverDimension], C = a.data, D2 = a.isStackedByIndex;
        C.modify(x2, function(L, F3, j) {
          var U3 = C.get(a.stackedDimension, j);
          if (isNaN(U3))
            return y2;
          var Y3, Q;
          D2 ? Q = C.getRawIndex(j) : Y3 = C.get(a.stackedByDimension, j);
          for (var nt = NaN, dt = e2 - 1; dt >= 0; dt--) {
            var vt = l2[dt];
            if (D2 || (Q = vt.data.rawIndexOf(vt.stackedByDimension, Y3)), Q >= 0) {
              var Ct = vt.data.getByRawIndex(vt.stackResultDimension, Q);
              if (U3 >= 0 && Ct > 0 || U3 <= 0 && Ct < 0) {
                U3 = nq(U3, Ct), nt = Ct;
                break;
              }
            }
          }
          return d2[0] = U3, d2[1] = nt, d2;
        });
      });
    }
    var hyt = function() {
      function l2(a) {
        this.data = a.data || (a.sourceFormat === aP ? {} : []), this.sourceFormat = a.sourceFormat || yie, this.seriesLayoutBy = a.seriesLayoutBy || oP, this.startIndex = a.startIndex || 0, this.dimensionsDetectedCount = a.dimensionsDetectedCount, this.metaRawOption = a.metaRawOption;
        var e2 = this.dimensionsDefine = a.dimensionsDefine;
        if (e2)
          for (var d2 = 0; d2 < e2.length; d2++) {
            var y2 = e2[d2];
            y2.type == null && _ie(this, d2) === V_.Must && (y2.type = "ordinal");
          }
      }
      return l2;
    }();
    function G3t(l2) {
      return l2 instanceof hyt;
    }
    function H3t(l2, a, e2) {
      e2 = e2 || Bie(l2);
      var d2 = a.seriesLayoutBy, y2 = Y$e(l2, e2, d2, a.sourceHeader, a.dimensions), x2 = new hyt({ data: l2, sourceFormat: e2, seriesLayoutBy: d2, dimensionsDefine: y2.dimensionsDefine, startIndex: y2.startIndex, dimensionsDetectedCount: y2.dimensionsDetectedCount, metaRawOption: zl(a) });
      return x2;
    }
    function U3t(l2) {
      return new hyt({ data: l2, sourceFormat: CS(l2) ? YN : MA });
    }
    function $$e(l2) {
      return new hyt({ data: l2.data, sourceFormat: l2.sourceFormat, seriesLayoutBy: l2.seriesLayoutBy, dimensionsDefine: zl(l2.dimensionsDefine), startIndex: l2.startIndex, dimensionsDetectedCount: l2.dimensionsDetectedCount });
    }
    function Bie(l2) {
      var a = yie;
      if (CS(l2))
        a = YN;
      else if (Ba2(l2)) {
        l2.length === 0 && (a = sw);
        for (var e2 = 0, d2 = l2.length; e2 < d2; e2++) {
          var y2 = l2[e2];
          if (y2 != null) {
            if (Ba2(y2)) {
              a = sw;
              break;
            } else if (vs(y2)) {
              a = CA;
              break;
            }
          }
        }
      } else if (vs(l2)) {
        for (var x2 in l2)
          if (Ns(l2, x2) && h1(l2[x2])) {
            a = aP;
            break;
          }
      }
      return a;
    }
    function Y$e(l2, a, e2, d2, y2) {
      var x2, C;
      if (!l2)
        return { dimensionsDefine: zie(y2), startIndex: C, dimensionsDetectedCount: x2 };
      if (a === sw) {
        var D2 = l2;
        d2 === "auto" || d2 == null ? jie(function(F3) {
          F3 != null && F3 !== "-" && (ps(F3) ? C == null && (C = 1) : C = 0);
        }, e2, D2, 10) : C = Ch2(d2) ? d2 : d2 ? 1 : 0, !y2 && C === 1 && (y2 = [], jie(function(F3, j) {
          y2[j] = F3 != null ? F3 + "" : "";
        }, e2, D2, 1 / 0)), x2 = y2 ? y2.length : e2 === Zq ? D2.length : D2[0] ? D2[0].length : null;
      } else if (a === CA)
        y2 || (y2 = K$e(l2));
      else if (a === aP)
        y2 || (y2 = [], Ke2(l2, function(F3, j) {
          y2.push(j);
        }));
      else if (a === MA) {
        var L = q5(l2[0]);
        x2 = Ba2(L) && L.length || 1;
      }
      return { startIndex: C, dimensionsDefine: zie(y2), dimensionsDetectedCount: x2 };
    }
    function K$e(l2) {
      for (var a = 0, e2; a < l2.length && !(e2 = l2[a++]); )
        ;
      if (e2) {
        var d2 = [];
        return Ke2(e2, function(y2, x2) {
          d2.push(x2);
        }), d2;
      }
    }
    function zie(l2) {
      if (l2) {
        var a = fl();
        return $a2(l2, function(e2, d2) {
          e2 = vs(e2) ? e2 : { name: e2 };
          var y2 = { name: e2.name, displayName: e2.displayName, type: e2.type };
          if (y2.name == null)
            return y2;
          y2.name += "", y2.displayName == null && (y2.displayName = y2.name);
          var x2 = a.get(y2.name);
          return x2 ? y2.name += "-" + x2.count++ : a.set(y2.name, { count: 1 }), y2;
        });
      }
    }
    function jie(l2, a, e2, d2) {
      if (a === Zq)
        for (var y2 = 0; y2 < e2.length && y2 < d2; y2++)
          l2(e2[y2] ? e2[y2][0] : null, y2);
      else
        for (var x2 = e2[0] || [], y2 = 0; y2 < x2.length && y2 < d2; y2++)
          l2(x2[y2], y2);
    }
    function Wie(l2) {
      var a = l2.sourceFormat;
      return a === CA || a === aP;
    }
    var aB, oB, sB, Gie, Hie, Uie = function() {
      function l2(a, e2) {
        var d2 = G3t(a) ? a : U3t(a);
        this._source = d2;
        var y2 = this._data = d2.data;
        d2.sourceFormat === YN && (this._offset = 0, this._dimSize = e2, this._data = y2), Hie(this, y2, d2);
      }
      return l2.prototype.getSource = function() {
        return this._source;
      }, l2.prototype.count = function() {
        return 0;
      }, l2.prototype.getItem = function(a, e2) {
      }, l2.prototype.appendData = function(a) {
      }, l2.prototype.clean = function() {
      }, l2.protoInitialize = function() {
        var a = l2.prototype;
        a.pure = false, a.persistent = true;
      }(), l2.internalField = function() {
        var a;
        Hie = function(C, D2, L) {
          var F3 = L.sourceFormat, j = L.seriesLayoutBy, U3 = L.startIndex, Y3 = L.dimensionsDefine, Q = Gie[Z3t(F3, j)];
          if (la2(C, Q), F3 === YN)
            C.getItem = e2, C.count = y2, C.fillStorage = d2;
          else {
            var nt = Zie(F3, j);
            C.getItem = As(nt, null, D2, U3, Y3);
            var dt = Yie(F3, j);
            C.count = As(dt, null, D2, U3, Y3);
          }
        };
        var e2 = function(C, D2) {
          C = C - this._offset, D2 = D2 || [];
          for (var L = this._data, F3 = this._dimSize, j = F3 * C, U3 = 0; U3 < F3; U3++)
            D2[U3] = L[j + U3];
          return D2;
        }, d2 = function(C, D2, L, F3) {
          for (var j = this._data, U3 = this._dimSize, Y3 = 0; Y3 < U3; Y3++) {
            for (var Q = F3[Y3], nt = Q[0] == null ? 1 / 0 : Q[0], dt = Q[1] == null ? -1 / 0 : Q[1], vt = D2 - C, Ct = L[Y3], Pt = 0; Pt < vt; Pt++) {
              var jt = j[Pt * U3 + Y3];
              Ct[C + Pt] = jt, jt < nt && (nt = jt), jt > dt && (dt = jt);
            }
            Q[0] = nt, Q[1] = dt;
          }
        }, y2 = function() {
          return this._data ? this._data.length / this._dimSize : 0;
        };
        Gie = (a = {}, a[sw + "_" + oP] = { pure: true, appendData: x2 }, a[sw + "_" + Zq] = { pure: true, appendData: function() {
          throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
        } }, a[CA] = { pure: true, appendData: x2 }, a[aP] = { pure: true, appendData: function(C) {
          var D2 = this._data;
          Ke2(C, function(L, F3) {
            for (var j = D2[F3] || (D2[F3] = []), U3 = 0; U3 < (L || []).length; U3++)
              j.push(L[U3]);
          });
        } }, a[MA] = { appendData: x2 }, a[YN] = { persistent: false, pure: true, appendData: function(C) {
          this._data = C;
        }, clean: function() {
          this._offset += this.count(), this._data = null;
        } }, a);
        function x2(C) {
          for (var D2 = 0; D2 < C.length; D2++)
            this._data.push(C[D2]);
        }
      }(), l2;
    }(), qie = function(l2, a, e2, d2) {
      return l2[d2];
    }, X$e = (aB = {}, aB[sw + "_" + oP] = function(l2, a, e2, d2) {
      return l2[d2 + a];
    }, aB[sw + "_" + Zq] = function(l2, a, e2, d2, y2) {
      d2 += a;
      for (var x2 = y2 || [], C = l2, D2 = 0; D2 < C.length; D2++) {
        var L = C[D2];
        x2[D2] = L ? L[d2] : null;
      }
      return x2;
    }, aB[CA] = qie, aB[aP] = function(l2, a, e2, d2, y2) {
      for (var x2 = y2 || [], C = 0; C < e2.length; C++) {
        var D2 = e2[C].name, L = l2[D2];
        x2[C] = L ? L[d2] : null;
      }
      return x2;
    }, aB[MA] = qie, aB);
    function Zie(l2, a) {
      var e2 = X$e[Z3t(l2, a)];
      return e2;
    }
    var $ie = function(l2, a, e2) {
      return l2.length;
    }, Q$e = (oB = {}, oB[sw + "_" + oP] = function(l2, a, e2) {
      return Math.max(0, l2.length - a);
    }, oB[sw + "_" + Zq] = function(l2, a, e2) {
      var d2 = l2[0];
      return d2 ? Math.max(0, d2.length - a) : 0;
    }, oB[CA] = $ie, oB[aP] = function(l2, a, e2) {
      var d2 = e2[0].name, y2 = l2[d2];
      return y2 ? y2.length : 0;
    }, oB[MA] = $ie, oB);
    function Yie(l2, a) {
      var e2 = Q$e[Z3t(l2, a)];
      return e2;
    }
    var q3t = function(l2, a, e2) {
      return l2[a];
    }, J$e = (sB = {}, sB[sw] = q3t, sB[CA] = function(l2, a, e2) {
      return l2[e2];
    }, sB[aP] = q3t, sB[MA] = function(l2, a, e2) {
      var d2 = q5(l2);
      return d2 instanceof Array ? d2[a] : d2;
    }, sB[YN] = q3t, sB);
    function Kie(l2) {
      var a = J$e[l2];
      return a;
    }
    function Z3t(l2, a) {
      return l2 === sw ? l2 + "_" + a : l2;
    }
    function $q(l2, a, e2) {
      if (l2) {
        var d2 = l2.getRawDataItem(a);
        if (d2 != null) {
          var y2 = l2.getStore(), x2 = y2.getSource().sourceFormat;
          if (e2 != null) {
            var C = l2.getDimensionIndex(e2), D2 = y2.getDimensionProperty(C);
            return Kie(x2)(d2, C, D2);
          } else {
            var L = d2;
            return x2 === MA && (L = q5(d2)), L;
          }
        }
      }
    }
    var tYe = /\{@(.+?)\}/g, $3t = function() {
      function l2() {
      }
      return l2.prototype.getDataParams = function(a, e2) {
        var d2 = this.getData(e2), y2 = this.getRawValue(a, e2), x2 = d2.getRawIndex(a), C = d2.getName(a), D2 = d2.getRawDataItem(a), L = d2.getItemVisual(a, "style"), F3 = L && L[d2.getItemVisual(a, "drawType") || "fill"], j = L && L.stroke, U3 = this.mainType, Y3 = U3 === "series", Q = d2.userOutput && d2.userOutput.get();
        return { componentType: U3, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: Y3 ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: Y3 ? this.id : null, seriesName: Y3 ? this.name : null, name: C, dataIndex: x2, data: D2, dataType: e2, value: y2, color: F3, borderColor: j, dimensionNames: Q ? Q.fullDimensions : null, encode: Q ? Q.encode : null, $vars: ["seriesName", "name", "value"] };
      }, l2.prototype.getFormattedLabel = function(a, e2, d2, y2, x2, C) {
        e2 = e2 || "normal";
        var D2 = this.getData(d2), L = this.getDataParams(a, d2);
        if (C && (L.value = C.interpolatedValue), y2 != null && Ba2(L.value) && (L.value = L.value[y2]), !x2) {
          var F3 = D2.getItemModel(a);
          x2 = F3.get(e2 === "normal" ? ["label", "formatter"] : [e2, "label", "formatter"]);
        }
        if (wl(x2))
          return L.status = e2, L.dimensionIndex = y2, x2(L);
        if (ps(x2)) {
          var j = hie(x2, L);
          return j.replace(tYe, function(U3, Y3) {
            var Q = Y3.length, nt = Y3;
            nt.charAt(0) === "[" && nt.charAt(Q - 1) === "]" && (nt = +nt.slice(1, Q - 1));
            var dt = $q(D2, a, nt);
            if (C && Ba2(C.interpolatedValue)) {
              var vt = D2.getDimensionIndex(nt);
              vt >= 0 && (dt = C.interpolatedValue[vt]);
            }
            return dt != null ? dt + "" : "";
          });
        }
      }, l2.prototype.getRawValue = function(a, e2) {
        return $q(this.getData(e2), a);
      }, l2.prototype.formatTooltip = function(a, e2, d2) {
      }, l2;
    }();
    function Xie(l2) {
      var a, e2;
      return vs(l2) ? l2.type && (e2 = l2) : a = l2, { text: a, frag: e2 };
    }
    function prt(l2) {
      return new eYe(l2);
    }
    var eYe = function() {
      function l2(a) {
        a = a || {}, this._reset = a.reset, this._plan = a.plan, this._count = a.count, this._onDirty = a.onDirty, this._dirty = true;
      }
      return l2.prototype.perform = function(a) {
        var e2 = this._upstream, d2 = a && a.skip;
        if (this._dirty && e2) {
          var y2 = this.context;
          y2.data = y2.outputData = e2.context.outputData;
        }
        this.__pipeline && (this.__pipeline.currentTask = this);
        var x2;
        this._plan && !d2 && (x2 = this._plan(this.context));
        var C = j(this._modBy), D2 = this._modDataCount || 0, L = j(a && a.modBy), F3 = a && a.modDataCount || 0;
        (C !== L || D2 !== F3) && (x2 = "reset");
        function j(Pt) {
          return !(Pt >= 1) && (Pt = 1), Pt;
        }
        var U3;
        (this._dirty || x2 === "reset") && (this._dirty = false, U3 = this._doReset(d2)), this._modBy = L, this._modDataCount = F3;
        var Y3 = a && a.step;
        if (e2 ? this._dueEnd = e2._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
          var Q = this._dueIndex, nt = Math.min(Y3 != null ? this._dueIndex + Y3 : 1 / 0, this._dueEnd);
          if (!d2 && (U3 || Q < nt)) {
            var dt = this._progress;
            if (Ba2(dt))
              for (var vt = 0; vt < dt.length; vt++)
                this._doProgress(dt[vt], Q, nt, L, F3);
            else
              this._doProgress(dt, Q, nt, L, F3);
          }
          this._dueIndex = nt;
          var Ct = this._settedOutputEnd != null ? this._settedOutputEnd : nt;
          this._outputDueEnd = Ct;
        } else
          this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
        return this.unfinished();
      }, l2.prototype.dirty = function() {
        this._dirty = true, this._onDirty && this._onDirty(this.context);
      }, l2.prototype._doProgress = function(a, e2, d2, y2, x2) {
        Qie.reset(e2, d2, y2, x2), this._callingProgress = a, this._callingProgress({ start: e2, end: d2, count: d2 - e2, next: Qie.next }, this.context);
      }, l2.prototype._doReset = function(a) {
        this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
        var e2, d2;
        !a && this._reset && (e2 = this._reset(this.context), e2 && e2.progress && (d2 = e2.forceFirstProgress, e2 = e2.progress), Ba2(e2) && !e2.length && (e2 = null)), this._progress = e2, this._modBy = this._modDataCount = null;
        var y2 = this._downstream;
        return y2 && y2.dirty(), d2;
      }, l2.prototype.unfinished = function() {
        return this._progress && this._dueIndex < this._dueEnd;
      }, l2.prototype.pipe = function(a) {
        (this._downstream !== a || this._dirty) && (this._downstream = a, a._upstream = this, a.dirty());
      }, l2.prototype.dispose = function() {
        this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
      }, l2.prototype.getUpstream = function() {
        return this._upstream;
      }, l2.prototype.getDownstream = function() {
        return this._downstream;
      }, l2.prototype.setOutputEnd = function(a) {
        this._outputDueEnd = this._settedOutputEnd = a;
      }, l2;
    }(), Qie = function() {
      var l2, a, e2, d2, y2, x2 = { reset: function(L, F3, j, U3) {
        a = L, l2 = F3, e2 = j, d2 = U3, y2 = Math.ceil(d2 / e2), x2.next = e2 > 1 && d2 > 0 ? D2 : C;
      } };
      return x2;
      function C() {
        return a < l2 ? a++ : null;
      }
      function D2() {
        var L = a % y2 * e2 + Math.ceil(a / y2), F3 = a >= l2 ? null : L < d2 ? L : a;
        return a++, F3;
      }
    }();
    function KN(l2, a) {
      var e2 = a && a.type;
      return e2 === "ordinal" ? l2 : (e2 === "time" && !Ch2(l2) && l2 != null && l2 !== "-" && (l2 = +Am(l2)), l2 == null || l2 === "" ? NaN : +l2);
    }
    var nYe = fl({ number: function(l2) {
      return parseFloat(l2);
    }, time: function(l2) {
      return +Am(l2);
    }, trim: function(l2) {
      return ps(l2) ? TS(l2) : l2;
    } });
    function Jie(l2) {
      return nYe.get(l2);
    }
    var tae = { lt: function(l2, a) {
      return l2 < a;
    }, lte: function(l2, a) {
      return l2 <= a;
    }, gt: function(l2, a) {
      return l2 > a;
    }, gte: function(l2, a) {
      return l2 >= a;
    } }, rYe = function() {
      function l2(a, e2) {
        if (!Ch2(e2)) {
          var d2 = "";
          ih2(d2);
        }
        this._opFn = tae[a], this._rvalFloat = ME(e2);
      }
      return l2.prototype.evaluate = function(a) {
        return Ch2(a) ? this._opFn(a, this._rvalFloat) : this._opFn(ME(a), this._rvalFloat);
      }, l2;
    }(), eae = function() {
      function l2(a, e2) {
        var d2 = a === "desc";
        this._resultLT = d2 ? 1 : -1, e2 == null && (e2 = d2 ? "min" : "max"), this._incomparable = e2 === "min" ? -1 / 0 : 1 / 0;
      }
      return l2.prototype.evaluate = function(a, e2) {
        var d2 = Ch2(a) ? a : ME(a), y2 = Ch2(e2) ? e2 : ME(e2), x2 = isNaN(d2), C = isNaN(y2);
        if (x2 && (d2 = this._incomparable), C && (y2 = this._incomparable), x2 && C) {
          var D2 = ps(a), L = ps(e2);
          D2 && (d2 = L ? a : 0), L && (y2 = D2 ? e2 : 0);
        }
        return d2 < y2 ? this._resultLT : d2 > y2 ? -this._resultLT : 0;
      }, l2;
    }(), iYe = function() {
      function l2(a, e2) {
        this._rval = e2, this._isEQ = a, this._rvalTypeof = typeof e2, this._rvalFloat = ME(e2);
      }
      return l2.prototype.evaluate = function(a) {
        var e2 = a === this._rval;
        if (!e2) {
          var d2 = typeof a;
          d2 !== this._rvalTypeof && (d2 === "number" || this._rvalTypeof === "number") && (e2 = ME(a) === this._rvalFloat);
        }
        return this._isEQ ? e2 : !e2;
      }, l2;
    }();
    function aYe(l2, a) {
      return l2 === "eq" || l2 === "ne" ? new iYe(l2 === "eq", a) : Ns(tae, l2) ? new rYe(l2, a) : null;
    }
    var oYe = function() {
      function l2() {
      }
      return l2.prototype.getRawData = function() {
        throw new Error("not supported");
      }, l2.prototype.getRawDataItem = function(a) {
        throw new Error("not supported");
      }, l2.prototype.cloneRawData = function() {
      }, l2.prototype.getDimensionInfo = function(a) {
      }, l2.prototype.cloneAllDimensionInfo = function() {
      }, l2.prototype.count = function() {
      }, l2.prototype.retrieveValue = function(a, e2) {
      }, l2.prototype.retrieveValueFromItem = function(a, e2) {
      }, l2.prototype.convertValue = function(a, e2) {
        return KN(a, e2);
      }, l2;
    }();
    function sYe(l2, a) {
      var e2 = new oYe(), d2 = l2.data, y2 = e2.sourceFormat = l2.sourceFormat, x2 = l2.startIndex, C = "";
      l2.seriesLayoutBy !== oP && ih2(C);
      var D2 = [], L = {}, F3 = l2.dimensionsDefine;
      if (F3)
        Ke2(F3, function(dt, vt) {
          var Ct = dt.name, Pt = { index: vt, name: Ct, displayName: dt.displayName };
          if (D2.push(Pt), Ct != null) {
            var jt = "";
            Ns(L, Ct) && ih2(jt), L[Ct] = Pt;
          }
        });
      else
        for (var j = 0; j < l2.dimensionsDetectedCount; j++)
          D2.push({ index: j });
      var U3 = Zie(y2, oP);
      a.__isBuiltIn && (e2.getRawDataItem = function(dt) {
        return U3(d2, x2, D2, dt);
      }, e2.getRawData = As(lYe, null, l2)), e2.cloneRawData = As(uYe, null, l2);
      var Y3 = Yie(y2, oP);
      e2.count = As(Y3, null, d2, x2, D2);
      var Q = Kie(y2);
      e2.retrieveValue = function(dt, vt) {
        var Ct = U3(d2, x2, D2, dt);
        return nt(Ct, vt);
      };
      var nt = e2.retrieveValueFromItem = function(dt, vt) {
        if (dt != null) {
          var Ct = D2[vt];
          if (Ct)
            return Q(dt, vt, Ct.name);
        }
      };
      return e2.getDimensionInfo = As(cYe, null, D2, L), e2.cloneAllDimensionInfo = As(fYe, null, D2), e2;
    }
    function lYe(l2) {
      var a = l2.sourceFormat;
      if (!Y3t(a)) {
        var e2 = "";
        ih2(e2);
      }
      return l2.data;
    }
    function uYe(l2) {
      var a = l2.sourceFormat, e2 = l2.data;
      if (!Y3t(a)) {
        var d2 = "";
        ih2(d2);
      }
      if (a === sw) {
        for (var y2 = [], x2 = 0, C = e2.length; x2 < C; x2++)
          y2.push(e2[x2].slice());
        return y2;
      } else if (a === CA) {
        for (var y2 = [], x2 = 0, C = e2.length; x2 < C; x2++)
          y2.push(la2({}, e2[x2]));
        return y2;
      }
    }
    function cYe(l2, a, e2) {
      if (e2 != null) {
        if (Ch2(e2) || !isNaN(e2) && !Ns(a, e2))
          return l2[e2];
        if (Ns(a, e2))
          return a[e2];
      }
    }
    function fYe(l2) {
      return zl(l2);
    }
    var nae = fl();
    function hYe(l2) {
      l2 = zl(l2);
      var a = l2.type, e2 = "";
      a || ih2(e2);
      var d2 = a.split(":");
      d2.length !== 2 && ih2(e2);
      var y2 = false;
      d2[0] === "echarts" && (a = d2[1], y2 = true), l2.__isBuiltIn = y2, nae.set(a, l2);
    }
    function pYe(l2, a, e2) {
      var d2 = Mp(l2), y2 = d2.length, x2 = "";
      y2 || ih2(x2);
      for (var C = 0, D2 = y2; C < D2; C++) {
        var L = d2[C];
        a = dYe(L, a), C !== D2 - 1 && (a.length = Math.max(a.length, 1));
      }
      return a;
    }
    function dYe(l2, a, e2, d2) {
      var y2 = "";
      a.length || ih2(y2), vs(l2) || ih2(y2);
      var x2 = l2.type, C = nae.get(x2);
      C || ih2(y2);
      var D2 = $a2(a, function(F3) {
        return sYe(F3, C);
      }), L = Mp(C.transform({ upstream: D2[0], upstreamList: D2, config: zl(l2.config) }));
      return $a2(L, function(F3, j) {
        var U3 = "";
        vs(F3) || ih2(U3), F3.data || ih2(U3);
        var Y3 = Bie(F3.data);
        Y3t(Y3) || ih2(U3);
        var Q, nt = a[0];
        if (nt && j === 0 && !F3.dimensions) {
          var dt = nt.startIndex;
          dt && (F3.data = nt.data.slice(0, dt).concat(F3.data)), Q = { seriesLayoutBy: oP, sourceHeader: dt, dimensions: nt.metaRawOption.dimensions };
        } else
          Q = { seriesLayoutBy: oP, sourceHeader: 0, dimensions: F3.dimensions };
        return H3t(F3.data, Q, null);
      });
    }
    function Y3t(l2) {
      return l2 === sw || l2 === CA;
    }
    var pyt = "undefined", gYe = typeof Uint32Array === pyt ? Array : Uint32Array, vYe = typeof Uint16Array === pyt ? Array : Uint16Array, rae = typeof Int32Array === pyt ? Array : Int32Array, iae = typeof Float64Array === pyt ? Array : Float64Array, aae = { float: iae, int: rae, ordinal: Array, number: Array, time: iae }, K3t;
    function drt(l2) {
      return l2 > 65535 ? gYe : vYe;
    }
    function Yq() {
      return [1 / 0, -1 / 0];
    }
    function yYe(l2) {
      var a = l2.constructor;
      return a === Array ? l2.slice() : new a(l2);
    }
    function oae(l2, a, e2, d2, y2) {
      var x2 = aae[e2 || "float"];
      if (y2) {
        var C = l2[a], D2 = C && C.length;
        if (D2 !== d2) {
          for (var L = new x2(d2), F3 = 0; F3 < D2; F3++)
            L[F3] = C[F3];
          l2[a] = L;
        }
      } else
        l2[a] = new x2(d2);
    }
    var X3t = function() {
      function l2() {
        this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = fl();
      }
      return l2.prototype.initData = function(a, e2, d2) {
        this._provider = a, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
        var y2 = a.getSource(), x2 = this.defaultDimValueGetter = K3t[y2.sourceFormat];
        this._dimValueGetter = d2 || x2, this._rawExtent = [], Wie(y2), this._dimensions = $a2(e2, function(C) {
          return { type: C.type, property: C.property };
        }), this._initDataFromProvider(0, a.count());
      }, l2.prototype.getProvider = function() {
        return this._provider;
      }, l2.prototype.getSource = function() {
        return this._provider.getSource();
      }, l2.prototype.ensureCalculationDimension = function(a, e2) {
        var d2 = this._calcDimNameToIdx, y2 = this._dimensions, x2 = d2.get(a);
        if (x2 != null) {
          if (y2[x2].type === e2)
            return x2;
        } else
          x2 = y2.length;
        return y2[x2] = { type: e2 }, d2.set(a, x2), this._chunks[x2] = new aae[e2 || "float"](this._rawCount), this._rawExtent[x2] = Yq(), x2;
      }, l2.prototype.collectOrdinalMeta = function(a, e2) {
        var d2 = this._chunks[a], y2 = this._dimensions[a], x2 = this._rawExtent, C = y2.ordinalOffset || 0, D2 = d2.length;
        C === 0 && (x2[a] = Yq());
        for (var L = x2[a], F3 = C; F3 < D2; F3++) {
          var j = d2[F3] = e2.parseAndCollect(d2[F3]);
          L[0] = Math.min(j, L[0]), L[1] = Math.max(j, L[1]);
        }
        y2.ordinalMeta = e2, y2.ordinalOffset = D2, y2.type = "ordinal";
      }, l2.prototype.getOrdinalMeta = function(a) {
        var e2 = this._dimensions[a], d2 = e2.ordinalMeta;
        return d2;
      }, l2.prototype.getDimensionProperty = function(a) {
        var e2 = this._dimensions[a];
        return e2 && e2.property;
      }, l2.prototype.appendData = function(a) {
        var e2 = this._provider, d2 = this.count();
        e2.appendData(a);
        var y2 = e2.count();
        return e2.persistent || (y2 += d2), d2 < y2 && this._initDataFromProvider(d2, y2, true), [d2, y2];
      }, l2.prototype.appendValues = function(a, e2) {
        for (var d2 = this._chunks, y2 = this._dimensions, x2 = y2.length, C = this._rawExtent, D2 = this.count(), L = D2 + Math.max(a.length, e2 || 0), F3 = 0; F3 < x2; F3++) {
          var j = y2[F3];
          oae(d2, F3, j.type, L, true);
        }
        for (var U3 = [], Y3 = D2; Y3 < L; Y3++)
          for (var Q = Y3 - D2, nt = 0; nt < x2; nt++) {
            var j = y2[nt], dt = K3t.arrayRows.call(this, a[Q] || U3, j.property, Q, nt);
            d2[nt][Y3] = dt;
            var vt = C[nt];
            dt < vt[0] && (vt[0] = dt), dt > vt[1] && (vt[1] = dt);
          }
        return this._rawCount = this._count = L, { start: D2, end: L };
      }, l2.prototype._initDataFromProvider = function(a, e2, d2) {
        for (var y2 = this._provider, x2 = this._chunks, C = this._dimensions, D2 = C.length, L = this._rawExtent, F3 = $a2(C, function(Pt) {
          return Pt.property;
        }), j = 0; j < D2; j++) {
          var U3 = C[j];
          L[j] || (L[j] = Yq()), oae(x2, j, U3.type, e2, d2);
        }
        if (y2.fillStorage)
          y2.fillStorage(a, e2, x2, L);
        else
          for (var Y3 = [], Q = a; Q < e2; Q++) {
            Y3 = y2.getItem(Q, Y3);
            for (var nt = 0; nt < D2; nt++) {
              var dt = x2[nt], vt = this._dimValueGetter(Y3, F3[nt], Q, nt);
              dt[Q] = vt;
              var Ct = L[nt];
              vt < Ct[0] && (Ct[0] = vt), vt > Ct[1] && (Ct[1] = vt);
            }
          }
        !y2.persistent && y2.clean && y2.clean(), this._rawCount = this._count = e2, this._extent = [];
      }, l2.prototype.count = function() {
        return this._count;
      }, l2.prototype.get = function(a, e2) {
        if (!(e2 >= 0 && e2 < this._count))
          return NaN;
        var d2 = this._chunks[a];
        return d2 ? d2[this.getRawIndex(e2)] : NaN;
      }, l2.prototype.getValues = function(a, e2) {
        var d2 = [], y2 = [];
        if (e2 == null) {
          e2 = a, a = [];
          for (var x2 = 0; x2 < this._dimensions.length; x2++)
            y2.push(x2);
        } else
          y2 = a;
        for (var x2 = 0, C = y2.length; x2 < C; x2++)
          d2.push(this.get(y2[x2], e2));
        return d2;
      }, l2.prototype.getByRawIndex = function(a, e2) {
        if (!(e2 >= 0 && e2 < this._rawCount))
          return NaN;
        var d2 = this._chunks[a];
        return d2 ? d2[e2] : NaN;
      }, l2.prototype.getSum = function(a) {
        var e2 = this._chunks[a], d2 = 0;
        if (e2)
          for (var y2 = 0, x2 = this.count(); y2 < x2; y2++) {
            var C = this.get(a, y2);
            isNaN(C) || (d2 += C);
          }
        return d2;
      }, l2.prototype.getMedian = function(a) {
        var e2 = [];
        this.each([a], function(x2) {
          isNaN(x2) || e2.push(x2);
        });
        var d2 = e2.sort(function(x2, C) {
          return x2 - C;
        }), y2 = this.count();
        return y2 === 0 ? 0 : y2 % 2 === 1 ? d2[(y2 - 1) / 2] : (d2[y2 / 2] + d2[y2 / 2 - 1]) / 2;
      }, l2.prototype.indexOfRawIndex = function(a) {
        if (a >= this._rawCount || a < 0)
          return -1;
        if (!this._indices)
          return a;
        var e2 = this._indices, d2 = e2[a];
        if (d2 != null && d2 < this._count && d2 === a)
          return a;
        for (var y2 = 0, x2 = this._count - 1; y2 <= x2; ) {
          var C = (y2 + x2) / 2 | 0;
          if (e2[C] < a)
            y2 = C + 1;
          else if (e2[C] > a)
            x2 = C - 1;
          else
            return C;
        }
        return -1;
      }, l2.prototype.indicesOfNearest = function(a, e2, d2) {
        var y2 = this._chunks, x2 = y2[a], C = [];
        if (!x2)
          return C;
        d2 == null && (d2 = 1 / 0);
        for (var D2 = 1 / 0, L = -1, F3 = 0, j = 0, U3 = this.count(); j < U3; j++) {
          var Y3 = this.getRawIndex(j), Q = e2 - x2[Y3], nt = Math.abs(Q);
          nt <= d2 && ((nt < D2 || nt === D2 && Q >= 0 && L < 0) && (D2 = nt, L = Q, F3 = 0), Q === L && (C[F3++] = j));
        }
        return C.length = F3, C;
      }, l2.prototype.getIndices = function() {
        var a, e2 = this._indices;
        if (e2) {
          var d2 = e2.constructor, y2 = this._count;
          if (d2 === Array) {
            a = new d2(y2);
            for (var x2 = 0; x2 < y2; x2++)
              a[x2] = e2[x2];
          } else
            a = new d2(e2.buffer, 0, y2);
        } else {
          var d2 = drt(this._rawCount);
          a = new d2(this.count());
          for (var x2 = 0; x2 < a.length; x2++)
            a[x2] = x2;
        }
        return a;
      }, l2.prototype.filter = function(a, e2) {
        if (!this._count)
          return this;
        for (var d2 = this.clone(), y2 = d2.count(), x2 = drt(d2._rawCount), C = new x2(y2), D2 = [], L = a.length, F3 = 0, j = a[0], U3 = d2._chunks, Y3 = 0; Y3 < y2; Y3++) {
          var Q = void 0, nt = d2.getRawIndex(Y3);
          if (L === 0)
            Q = e2(Y3);
          else if (L === 1) {
            var dt = U3[j][nt];
            Q = e2(dt, Y3);
          } else {
            for (var vt = 0; vt < L; vt++)
              D2[vt] = U3[a[vt]][nt];
            D2[vt] = Y3, Q = e2.apply(null, D2);
          }
          Q && (C[F3++] = nt);
        }
        return F3 < y2 && (d2._indices = C), d2._count = F3, d2._extent = [], d2._updateGetRawIdx(), d2;
      }, l2.prototype.selectRange = function(a) {
        var e2 = this.clone(), d2 = e2._count;
        if (!d2)
          return this;
        var y2 = Qc2(a), x2 = y2.length;
        if (!x2)
          return this;
        var C = e2.count(), D2 = drt(e2._rawCount), L = new D2(C), F3 = 0, j = y2[0], U3 = a[j][0], Y3 = a[j][1], Q = e2._chunks, nt = false;
        if (!e2._indices) {
          var dt = 0;
          if (x2 === 1) {
            for (var vt = Q[y2[0]], Ct = 0; Ct < d2; Ct++) {
              var Pt = vt[Ct];
              (Pt >= U3 && Pt <= Y3 || isNaN(Pt)) && (L[F3++] = dt), dt++;
            }
            nt = true;
          } else if (x2 === 2) {
            for (var vt = Q[y2[0]], jt = Q[y2[1]], Rt = a[y2[1]][0], le2 = a[y2[1]][1], Ct = 0; Ct < d2; Ct++) {
              var Pt = vt[Ct], ne2 = jt[Ct];
              (Pt >= U3 && Pt <= Y3 || isNaN(Pt)) && (ne2 >= Rt && ne2 <= le2 || isNaN(ne2)) && (L[F3++] = dt), dt++;
            }
            nt = true;
          }
        }
        if (!nt)
          if (x2 === 1)
            for (var Ct = 0; Ct < C; Ct++) {
              var he2 = e2.getRawIndex(Ct), Pt = Q[y2[0]][he2];
              (Pt >= U3 && Pt <= Y3 || isNaN(Pt)) && (L[F3++] = he2);
            }
          else
            for (var Ct = 0; Ct < C; Ct++) {
              for (var _e = true, he2 = e2.getRawIndex(Ct), Me2 = 0; Me2 < x2; Me2++) {
                var Pe2 = y2[Me2], Pt = Q[Pe2][he2];
                (Pt < a[Pe2][0] || Pt > a[Pe2][1]) && (_e = false);
              }
              _e && (L[F3++] = e2.getRawIndex(Ct));
            }
        return F3 < C && (e2._indices = L), e2._count = F3, e2._extent = [], e2._updateGetRawIdx(), e2;
      }, l2.prototype.map = function(a, e2) {
        var d2 = this.clone(a);
        return this._updateDims(d2, a, e2), d2;
      }, l2.prototype.modify = function(a, e2) {
        this._updateDims(this, a, e2);
      }, l2.prototype._updateDims = function(a, e2, d2) {
        for (var y2 = a._chunks, x2 = [], C = e2.length, D2 = a.count(), L = [], F3 = a._rawExtent, j = 0; j < e2.length; j++)
          F3[e2[j]] = Yq();
        for (var U3 = 0; U3 < D2; U3++) {
          for (var Y3 = a.getRawIndex(U3), Q = 0; Q < C; Q++)
            L[Q] = y2[e2[Q]][Y3];
          L[C] = U3;
          var nt = d2 && d2.apply(null, L);
          if (nt != null) {
            typeof nt != "object" && (x2[0] = nt, nt = x2);
            for (var j = 0; j < nt.length; j++) {
              var dt = e2[j], vt = nt[j], Ct = F3[dt], Pt = y2[dt];
              Pt && (Pt[Y3] = vt), vt < Ct[0] && (Ct[0] = vt), vt > Ct[1] && (Ct[1] = vt);
            }
          }
        }
      }, l2.prototype.lttbDownSample = function(a, e2) {
        var d2 = this.clone([a], true), y2 = d2._chunks, x2 = y2[a], C = this.count(), D2 = 0, L = Math.floor(1 / e2), F3 = this.getRawIndex(0), j, U3, Y3, Q = new (drt(this._rawCount))(Math.min((Math.ceil(C / L) + 2) * 2, C));
        Q[D2++] = F3;
        for (var nt = 1; nt < C - 1; nt += L) {
          for (var dt = Math.min(nt + L, C - 1), vt = Math.min(nt + L * 2, C), Ct = (vt + dt) / 2, Pt = 0, jt = dt; jt < vt; jt++) {
            var Rt = this.getRawIndex(jt), le2 = x2[Rt];
            isNaN(le2) || (Pt += le2);
          }
          Pt /= vt - dt;
          var ne2 = nt, he2 = Math.min(nt + L, C), _e = nt - 1, Me2 = x2[F3];
          j = -1, Y3 = ne2;
          for (var Pe2 = -1, Be2 = 0, jt = ne2; jt < he2; jt++) {
            var Rt = this.getRawIndex(jt), le2 = x2[Rt];
            if (isNaN(le2)) {
              Be2++, Pe2 < 0 && (Pe2 = Rt);
              continue;
            }
            U3 = Math.abs((_e - Ct) * (le2 - Me2) - (_e - jt) * (Pt - Me2)), U3 > j && (j = U3, Y3 = Rt);
          }
          Be2 > 0 && Be2 < he2 - ne2 && (Q[D2++] = Math.min(Pe2, Y3), Y3 = Math.max(Pe2, Y3)), Q[D2++] = Y3, F3 = Y3;
        }
        return Q[D2++] = this.getRawIndex(C - 1), d2._count = D2, d2._indices = Q, d2.getRawIndex = this._getRawIdx, d2;
      }, l2.prototype.downSample = function(a, e2, d2, y2) {
        for (var x2 = this.clone([a], true), C = x2._chunks, D2 = [], L = Math.floor(1 / e2), F3 = C[a], j = this.count(), U3 = x2._rawExtent[a] = Yq(), Y3 = new (drt(this._rawCount))(Math.ceil(j / L)), Q = 0, nt = 0; nt < j; nt += L) {
          L > j - nt && (L = j - nt, D2.length = L);
          for (var dt = 0; dt < L; dt++) {
            var vt = this.getRawIndex(nt + dt);
            D2[dt] = F3[vt];
          }
          var Ct = d2(D2), Pt = this.getRawIndex(Math.min(nt + y2(D2, Ct) || 0, j - 1));
          F3[Pt] = Ct, Ct < U3[0] && (U3[0] = Ct), Ct > U3[1] && (U3[1] = Ct), Y3[Q++] = Pt;
        }
        return x2._count = Q, x2._indices = Y3, x2._updateGetRawIdx(), x2;
      }, l2.prototype.each = function(a, e2) {
        if (this._count)
          for (var d2 = a.length, y2 = this._chunks, x2 = 0, C = this.count(); x2 < C; x2++) {
            var D2 = this.getRawIndex(x2);
            switch (d2) {
              case 0:
                e2(x2);
                break;
              case 1:
                e2(y2[a[0]][D2], x2);
                break;
              case 2:
                e2(y2[a[0]][D2], y2[a[1]][D2], x2);
                break;
              default:
                for (var L = 0, F3 = []; L < d2; L++)
                  F3[L] = y2[a[L]][D2];
                F3[L] = x2, e2.apply(null, F3);
            }
          }
      }, l2.prototype.getDataExtent = function(a) {
        var e2 = this._chunks[a], d2 = Yq();
        if (!e2)
          return d2;
        var y2 = this.count(), x2 = !this._indices, C;
        if (x2)
          return this._rawExtent[a].slice();
        if (C = this._extent[a], C)
          return C.slice();
        C = d2;
        for (var D2 = C[0], L = C[1], F3 = 0; F3 < y2; F3++) {
          var j = this.getRawIndex(F3), U3 = e2[j];
          U3 < D2 && (D2 = U3), U3 > L && (L = U3);
        }
        return C = [D2, L], this._extent[a] = C, C;
      }, l2.prototype.getRawDataItem = function(a) {
        var e2 = this.getRawIndex(a);
        if (this._provider.persistent)
          return this._provider.getItem(e2);
        for (var d2 = [], y2 = this._chunks, x2 = 0; x2 < y2.length; x2++)
          d2.push(y2[x2][e2]);
        return d2;
      }, l2.prototype.clone = function(a, e2) {
        var d2 = new l2(), y2 = this._chunks, x2 = a && tA(a, function(D2, L) {
          return D2[L] = true, D2;
        }, {});
        if (x2)
          for (var C = 0; C < y2.length; C++)
            d2._chunks[C] = x2[C] ? yYe(y2[C]) : y2[C];
        else
          d2._chunks = y2;
        return this._copyCommonProps(d2), e2 || (d2._indices = this._cloneIndices()), d2._updateGetRawIdx(), d2;
      }, l2.prototype._copyCommonProps = function(a) {
        a._count = this._count, a._rawCount = this._rawCount, a._provider = this._provider, a._dimensions = this._dimensions, a._extent = zl(this._extent), a._rawExtent = zl(this._rawExtent);
      }, l2.prototype._cloneIndices = function() {
        if (this._indices) {
          var a = this._indices.constructor, e2 = void 0;
          if (a === Array) {
            var d2 = this._indices.length;
            e2 = new a(d2);
            for (var y2 = 0; y2 < d2; y2++)
              e2[y2] = this._indices[y2];
          } else
            e2 = new a(this._indices);
          return e2;
        }
        return null;
      }, l2.prototype._getRawIdxIdentity = function(a) {
        return a;
      }, l2.prototype._getRawIdx = function(a) {
        return a < this._count && a >= 0 ? this._indices[a] : -1;
      }, l2.prototype._updateGetRawIdx = function() {
        this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
      }, l2.internalField = function() {
        function a(e2, d2, y2, x2) {
          return KN(e2[x2], this._dimensions[x2]);
        }
        K3t = { arrayRows: a, objectRows: function(e2, d2, y2, x2) {
          return KN(e2[d2], this._dimensions[x2]);
        }, keyedColumns: a, original: function(e2, d2, y2, x2) {
          var C = e2 && (e2.value == null ? e2 : e2.value);
          return KN(C instanceof Array ? C[x2] : C, this._dimensions[x2]);
        }, typedArray: function(e2, d2, y2, x2) {
          return e2[x2];
        } };
      }(), l2;
    }(), sae = function() {
      function l2(a) {
        this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = a;
      }
      return l2.prototype.dirty = function() {
        this._setLocalSource([], []), this._storeList = [], this._dirty = true;
      }, l2.prototype._setLocalSource = function(a, e2) {
        this._sourceList = a, this._upstreamSignList = e2, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
      }, l2.prototype._getVersionSign = function() {
        return this._sourceHost.uid + "_" + this._versionSignBase;
      }, l2.prototype.prepareSource = function() {
        this._isDirty() && (this._createSource(), this._dirty = false);
      }, l2.prototype._createSource = function() {
        this._setLocalSource([], []);
        var a = this._sourceHost, e2 = this._getUpstreamSourceManagers(), d2 = !!e2.length, y2, x2;
        if (dyt(a)) {
          var C = a, D2 = void 0, L = void 0, F3 = void 0;
          if (d2) {
            var j = e2[0];
            j.prepareSource(), F3 = j.getSource(), D2 = F3.data, L = F3.sourceFormat, x2 = [j._getVersionSign()];
          } else
            D2 = C.get("data", true), L = CS(D2) ? YN : MA, x2 = [];
          var U3 = this._getSourceMetaRawOption() || {}, Y3 = F3 && F3.metaRawOption || {}, Q = $u(U3.seriesLayoutBy, Y3.seriesLayoutBy) || null, nt = $u(U3.sourceHeader, Y3.sourceHeader), dt = $u(U3.dimensions, Y3.dimensions), vt = Q !== Y3.seriesLayoutBy || !!nt != !!Y3.sourceHeader || dt;
          y2 = vt ? [H3t(D2, { seriesLayoutBy: Q, sourceHeader: nt, dimensions: dt }, L)] : [];
        } else {
          var Ct = a;
          if (d2) {
            var Pt = this._applyTransform(e2);
            y2 = Pt.sourceList, x2 = Pt.upstreamSignList;
          } else {
            var jt = Ct.get("source", true);
            y2 = [H3t(jt, this._getSourceMetaRawOption(), null)], x2 = [];
          }
        }
        this._setLocalSource(y2, x2);
      }, l2.prototype._applyTransform = function(a) {
        var e2 = this._sourceHost, d2 = e2.get("transform", true), y2 = e2.get("fromTransformResult", true);
        if (y2 != null) {
          var x2 = "";
          a.length !== 1 && uae(x2);
        }
        var C, D2 = [], L = [];
        return Ke2(a, function(F3) {
          F3.prepareSource();
          var j = F3.getSource(y2 || 0), U3 = "";
          y2 != null && !j && uae(U3), D2.push(j), L.push(F3._getVersionSign());
        }), d2 ? C = pYe(d2, D2, { datasetIndex: e2.componentIndex }) : y2 != null && (C = [$$e(D2[0])]), { sourceList: C, upstreamSignList: L };
      }, l2.prototype._isDirty = function() {
        if (this._dirty)
          return true;
        for (var a = this._getUpstreamSourceManagers(), e2 = 0; e2 < a.length; e2++) {
          var d2 = a[e2];
          if (d2._isDirty() || this._upstreamSignList[e2] !== d2._getVersionSign())
            return true;
        }
      }, l2.prototype.getSource = function(a) {
        a = a || 0;
        var e2 = this._sourceList[a];
        if (!e2) {
          var d2 = this._getUpstreamSourceManagers();
          return d2[0] && d2[0].getSource(a);
        }
        return e2;
      }, l2.prototype.getSharedDataStore = function(a) {
        var e2 = a.makeStoreSchema();
        return this._innerGetDataStore(e2.dimensions, a.source, e2.hash);
      }, l2.prototype._innerGetDataStore = function(a, e2, d2) {
        var y2 = 0, x2 = this._storeList, C = x2[y2];
        C || (C = x2[y2] = {});
        var D2 = C[d2];
        if (!D2) {
          var L = this._getUpstreamSourceManagers()[0];
          dyt(this._sourceHost) && L ? D2 = L._innerGetDataStore(a, e2, d2) : (D2 = new X3t(), D2.initData(new Uie(e2, a.length), a)), C[d2] = D2;
        }
        return D2;
      }, l2.prototype._getUpstreamSourceManagers = function() {
        var a = this._sourceHost;
        if (dyt(a)) {
          var e2 = N3t(a);
          return e2 ? [e2.getSourceManager()] : [];
        } else
          return $a2(_$e(a), function(d2) {
            return d2.getSourceManager();
          });
      }, l2.prototype._getSourceMetaRawOption = function() {
        var a = this._sourceHost, e2, d2, y2;
        if (dyt(a))
          e2 = a.get("seriesLayoutBy", true), d2 = a.get("sourceHeader", true), y2 = a.get("dimensions", true);
        else if (!this._getUpstreamSourceManagers().length) {
          var x2 = a;
          e2 = x2.get("seriesLayoutBy", true), d2 = x2.get("sourceHeader", true), y2 = x2.get("dimensions", true);
        }
        return { seriesLayoutBy: e2, sourceHeader: d2, dimensions: y2 };
      }, l2;
    }();
    function lae(l2) {
      var a = l2.option.transform;
      a && gV(l2.option.transform);
    }
    function dyt(l2) {
      return l2.mainType === "series";
    }
    function uae(l2) {
      throw new Error(l2);
    }
    var cae = "line-height:1";
    function fae(l2, a) {
      var e2 = l2.color || "#6e7079", d2 = l2.fontSize || 12, y2 = l2.fontWeight || "400", x2 = l2.color || "#464646", C = l2.fontSize || 14, D2 = l2.fontWeight || "900";
      return a === "html" ? { nameStyle: "font-size:" + dC(d2 + "") + "px;color:" + dC(e2) + ";font-weight:" + dC(y2 + ""), valueStyle: "font-size:" + dC(C + "") + "px;color:" + dC(x2) + ";font-weight:" + dC(D2 + "") } : { nameStyle: { fontSize: d2, fill: e2, fontWeight: y2 }, valueStyle: { fontSize: C, fill: x2, fontWeight: D2 } };
    }
    var mYe = [0, 10, 20, 30], bYe = ["", `
`, `

`, `


`];
    function b1(l2, a) {
      return a.type = l2, a;
    }
    function Q3t(l2) {
      return l2.type === "section";
    }
    function hae(l2) {
      return Q3t(l2) ? _Ye : xYe;
    }
    function pae(l2) {
      if (Q3t(l2)) {
        var a = 0, e2 = l2.blocks.length, d2 = e2 > 1 || e2 > 0 && !l2.noHeader;
        return Ke2(l2.blocks, function(y2) {
          var x2 = pae(y2);
          x2 >= a && (a = x2 + +(d2 && (!x2 || Q3t(y2) && !y2.noHeader)));
        }), a;
      }
      return 0;
    }
    function _Ye(l2, a, e2, d2) {
      var y2 = a.noHeader, x2 = wYe(pae(a)), C = [], D2 = a.blocks || [];
      vb2(!D2 || Ba2(D2)), D2 = D2 || [];
      var L = l2.orderMode;
      if (a.sortBlocks && L) {
        D2 = D2.slice();
        var F3 = { valueAsc: "asc", valueDesc: "desc" };
        if (Ns(F3, L)) {
          var j = new eae(F3[L], null);
          D2.sort(function(nt, dt) {
            return j.evaluate(nt.sortParam, dt.sortParam);
          });
        } else
          L === "seriesDesc" && D2.reverse();
      }
      Ke2(D2, function(nt, dt) {
        var vt = a.valueFormatter, Ct = hae(nt)(vt ? la2(la2({}, l2), { valueFormatter: vt }) : l2, nt, dt > 0 ? x2.html : 0, d2);
        Ct != null && C.push(Ct);
      });
      var U3 = l2.renderMode === "richText" ? C.join(x2.richText) : J3t(C.join(""), y2 ? e2 : x2.html);
      if (y2)
        return U3;
      var Y3 = P3t(a.header, "ordinal", l2.useUTC), Q = fae(d2, l2.renderMode).nameStyle;
      return l2.renderMode === "richText" ? gae(l2, Y3, Q) + x2.richText + U3 : J3t('<div style="' + Q + ";" + cae + ';">' + dC(Y3) + "</div>" + U3, e2);
    }
    function xYe(l2, a, e2, d2) {
      var y2 = l2.renderMode, x2 = a.noName, C = a.noValue, D2 = !a.markerType, L = a.name, F3 = l2.useUTC, j = a.valueFormatter || l2.valueFormatter || function(Rt) {
        return Rt = Ba2(Rt) ? Rt : [Rt], $a2(Rt, function(le2, ne2) {
          return P3t(le2, Ba2(Q) ? Q[ne2] : Q, F3);
        });
      };
      if (!(x2 && C)) {
        var U3 = D2 ? "" : l2.markupStyleCreator.makeTooltipMarker(a.markerType, a.markerColor || "#333", y2), Y3 = x2 ? "" : P3t(L, "ordinal", F3), Q = a.valueType, nt = C ? [] : j(a.value), dt = !D2 || !x2, vt = !D2 && x2, Ct = fae(d2, y2), Pt = Ct.nameStyle, jt = Ct.valueStyle;
        return y2 === "richText" ? (D2 ? "" : U3) + (x2 ? "" : gae(l2, Y3, Pt)) + (C ? "" : CYe(l2, nt, dt, vt, jt)) : J3t((D2 ? "" : U3) + (x2 ? "" : SYe(Y3, !D2, Pt)) + (C ? "" : MYe(nt, dt, vt, jt)), e2);
      }
    }
    function dae(l2, a, e2, d2, y2, x2) {
      if (l2) {
        var C = hae(l2), D2 = { useUTC: y2, renderMode: e2, orderMode: d2, markupStyleCreator: a, valueFormatter: l2.valueFormatter };
        return C(D2, l2, 0, x2);
      }
    }
    function wYe(l2) {
      return { html: mYe[l2], richText: bYe[l2] };
    }
    function J3t(l2, a) {
      var e2 = '<div style="clear:both"></div>', d2 = "margin: " + a + "px 0 0";
      return '<div style="' + d2 + ";" + cae + ';">' + l2 + e2 + "</div>";
    }
    function SYe(l2, a, e2) {
      var d2 = a ? "margin-left:2px" : "";
      return '<span style="' + e2 + ";" + d2 + '">' + dC(l2) + "</span>";
    }
    function MYe(l2, a, e2, d2) {
      var y2 = e2 ? "10px" : "20px", x2 = a ? "float:right;margin-left:" + y2 : "";
      return l2 = Ba2(l2) ? l2 : [l2], '<span style="' + x2 + ";" + d2 + '">' + $a2(l2, function(C) {
        return dC(C);
      }).join("&nbsp;&nbsp;") + "</span>";
    }
    function gae(l2, a, e2) {
      return l2.markupStyleCreator.wrapRichTextStyle(a, e2);
    }
    function CYe(l2, a, e2, d2, y2) {
      var x2 = [y2], C = d2 ? 10 : 20;
      return e2 && x2.push({ padding: [0, 0, 0, C], align: "right" }), l2.markupStyleCreator.wrapRichTextStyle(Ba2(a) ? a.join("  ") : a, x2);
    }
    function vae(l2, a) {
      var e2 = l2.getData().getItemVisual(a, "style"), d2 = e2[l2.visualDrawType];
      return nB(d2);
    }
    function yae(l2, a) {
      var e2 = l2.get("padding");
      return e2 != null ? e2 : a === "richText" ? [8, 10] : 10;
    }
    var tLt = function() {
      function l2() {
        this.richTextStyles = {}, this._nextStyleNameId = sq();
      }
      return l2.prototype._generateStyleName = function() {
        return "__EC_aUTo_" + this._nextStyleNameId++;
      }, l2.prototype.makeTooltipMarker = function(a, e2, d2) {
        var y2 = d2 === "richText" ? this._generateStyleName() : null, x2 = p$e({ color: e2, type: a, renderMode: d2, markerId: y2 });
        return ps(x2) ? x2 : (this.richTextStyles[y2] = x2.style, x2.content);
      }, l2.prototype.wrapRichTextStyle = function(a, e2) {
        var d2 = {};
        Ba2(e2) ? Ke2(e2, function(x2) {
          return la2(d2, x2);
        }) : la2(d2, e2);
        var y2 = this._generateStyleName();
        return this.richTextStyles[y2] = d2, "{" + y2 + "|" + a + "}";
      }, l2;
    }();
    function mae(l2) {
      var a = l2.series, e2 = l2.dataIndex, d2 = l2.multipleSeries, y2 = a.getData(), x2 = y2.mapDimensionsAll("defaultedTooltip"), C = x2.length, D2 = a.getRawValue(e2), L = Ba2(D2), F3 = vae(a, e2), j, U3, Y3, Q;
      if (C > 1 || L && !C) {
        var nt = TYe(D2, a, e2, x2, F3);
        j = nt.inlineValues, U3 = nt.inlineValueTypes, Y3 = nt.blocks, Q = nt.inlineValues[0];
      } else if (C) {
        var dt = y2.getDimensionInfo(x2[0]);
        Q = j = $q(y2, e2, x2[0]), U3 = dt.type;
      } else
        Q = j = L ? D2[0] : D2;
      var vt = y1(a), Ct = vt && a.name || "", Pt = y2.getName(e2), jt = d2 ? Ct : Pt;
      return b1("section", { header: Ct, noHeader: d2 || !vt, sortParam: Q, blocks: [b1("nameValue", { markerType: "item", markerColor: F3, name: jt, noName: !TS(jt), value: j, valueType: U3 })].concat(Y3 || []) });
    }
    function TYe(l2, a, e2, d2, y2) {
      var x2 = a.getData(), C = tA(l2, function(U3, Y3, Q) {
        var nt = x2.getDimensionInfo(Q);
        return U3 = U3 || nt && nt.tooltip !== false && nt.displayName != null;
      }, false), D2 = [], L = [], F3 = [];
      d2.length ? Ke2(d2, function(U3) {
        j($q(x2, e2, U3), U3);
      }) : Ke2(l2, j);
      function j(U3, Y3) {
        var Q = x2.getDimensionInfo(Y3);
        !Q || Q.otherDims.tooltip === false || (C ? F3.push(b1("nameValue", { markerType: "subItem", markerColor: y2, name: Q.displayName, value: U3, valueType: Q.type })) : (D2.push(U3), L.push(Q.type)));
      }
      return { inlineValues: D2, inlineValueTypes: L, blocks: F3 };
    }
    var XN = Rf2();
    function gyt(l2, a) {
      return l2.getName(a) || l2.getId(a);
    }
    var vyt = "__universalTransitionEnabled", yyt = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2._selectedDataIndicesMap = {}, e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        this.seriesIndex = this.componentIndex, this.dataTask = prt({ count: IYe, reset: DYe }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(e2, y2);
        var x2 = XN(this).sourceManager = new sae(this);
        x2.prepareSource();
        var C = this.getInitialData(e2, y2);
        _ae(C, this), this.dataTask.context.data = C, XN(this).dataBeforeProcessed = C, bae(this), this._initSelectedMapFromData(C);
      }, a.prototype.mergeDefaultAndTheme = function(e2, d2) {
        var y2 = srt(this), x2 = y2 ? Hq(e2) : {}, C = this.subType;
        Ah2.hasClass(C) && (C += "Series"), Mu(e2, d2.getTheme().get(this.subType)), Mu(e2, this.getDefaultOption()), RS(e2, "label", ["show"]), this.fillDataTextStyle(e2.data), y2 && $N(e2, x2, y2);
      }, a.prototype.mergeOption = function(e2, d2) {
        e2 = Mu(this.option, e2, true), this.fillDataTextStyle(e2.data);
        var y2 = srt(this);
        y2 && $N(this.option, e2, y2);
        var x2 = XN(this).sourceManager;
        x2.dirty(), x2.prepareSource();
        var C = this.getInitialData(e2, d2);
        _ae(C, this), this.dataTask.dirty(), this.dataTask.context.data = C, XN(this).dataBeforeProcessed = C, bae(this), this._initSelectedMapFromData(C);
      }, a.prototype.fillDataTextStyle = function(e2) {
        if (e2 && !CS(e2))
          for (var d2 = ["show"], y2 = 0; y2 < e2.length; y2++)
            e2[y2] && e2[y2].label && RS(e2[y2], "label", d2);
      }, a.prototype.getInitialData = function(e2, d2) {
      }, a.prototype.appendData = function(e2) {
        var d2 = this.getRawData();
        d2.appendData(e2.data);
      }, a.prototype.getData = function(e2) {
        var d2 = eLt(this);
        if (d2) {
          var y2 = d2.context.data;
          return e2 == null ? y2 : y2.getLinkedData(e2);
        } else
          return XN(this).data;
      }, a.prototype.getAllData = function() {
        var e2 = this.getData();
        return e2 && e2.getLinkedDataAll ? e2.getLinkedDataAll() : [{ data: e2 }];
      }, a.prototype.setData = function(e2) {
        var d2 = eLt(this);
        if (d2) {
          var y2 = d2.context;
          y2.outputData = e2, d2 !== this.dataTask && (y2.data = e2);
        }
        XN(this).data = e2;
      }, a.prototype.getEncode = function() {
        var e2 = this.get("encode", true);
        if (e2)
          return fl(e2);
      }, a.prototype.getSourceManager = function() {
        return XN(this).sourceManager;
      }, a.prototype.getSource = function() {
        return this.getSourceManager().getSource();
      }, a.prototype.getRawData = function() {
        return XN(this).dataBeforeProcessed;
      }, a.prototype.getColorBy = function() {
        var e2 = this.get("colorBy");
        return e2 || "series";
      }, a.prototype.isColorBySeries = function() {
        return this.getColorBy() === "series";
      }, a.prototype.getBaseAxis = function() {
        var e2 = this.coordinateSystem;
        return e2 && e2.getBaseAxis && e2.getBaseAxis();
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        return mae({ series: this, dataIndex: e2, multipleSeries: d2 });
      }, a.prototype.isAnimationEnabled = function() {
        var e2 = this.ecModel;
        if ($s.node && !(e2 && e2.ssr))
          return false;
        var d2 = this.getShallow("animation");
        return d2 && this.getData().count() > this.getShallow("animationThreshold") && (d2 = false), !!d2;
      }, a.prototype.restoreData = function() {
        this.dataTask.dirty();
      }, a.prototype.getColorFromPalette = function(e2, d2, y2) {
        var x2 = this.ecModel, C = V3t.prototype.getColorFromPalette.call(this, e2, d2, y2);
        return C || (C = x2.getColorFromPalette(e2, d2, y2)), C;
      }, a.prototype.coordDimToDataDim = function(e2) {
        return this.getRawData().mapDimensionsAll(e2);
      }, a.prototype.getProgressive = function() {
        return this.get("progressive");
      }, a.prototype.getProgressiveThreshold = function() {
        return this.get("progressiveThreshold");
      }, a.prototype.select = function(e2, d2) {
        this._innerSelect(this.getData(d2), e2);
      }, a.prototype.unselect = function(e2, d2) {
        var y2 = this.option.selectedMap;
        if (y2) {
          var x2 = this.option.selectedMode, C = this.getData(d2);
          if (x2 === "series" || y2 === "all") {
            this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
            return;
          }
          for (var D2 = 0; D2 < e2.length; D2++) {
            var L = e2[D2], F3 = gyt(C, L);
            y2[F3] = false, this._selectedDataIndicesMap[F3] = -1;
          }
        }
      }, a.prototype.toggleSelect = function(e2, d2) {
        for (var y2 = [], x2 = 0; x2 < e2.length; x2++)
          y2[0] = e2[x2], this.isSelected(e2[x2], d2) ? this.unselect(y2, d2) : this.select(y2, d2);
      }, a.prototype.getSelectedDataIndices = function() {
        if (this.option.selectedMap === "all")
          return [].slice.call(this.getData().getIndices());
        for (var e2 = this._selectedDataIndicesMap, d2 = Qc2(e2), y2 = [], x2 = 0; x2 < d2.length; x2++) {
          var C = e2[d2[x2]];
          C >= 0 && y2.push(C);
        }
        return y2;
      }, a.prototype.isSelected = function(e2, d2) {
        var y2 = this.option.selectedMap;
        if (!y2)
          return false;
        var x2 = this.getData(d2);
        return (y2 === "all" || y2[gyt(x2, e2)]) && !x2.getItemModel(e2).get(["select", "disabled"]);
      }, a.prototype.isUniversalTransitionEnabled = function() {
        if (this[vyt])
          return true;
        var e2 = this.option.universalTransition;
        return e2 ? e2 === true ? true : e2 && e2.enabled : false;
      }, a.prototype._innerSelect = function(e2, d2) {
        var y2, x2, C = this.option, D2 = C.selectedMode, L = d2.length;
        if (!(!D2 || !L)) {
          if (D2 === "series")
            C.selectedMap = "all";
          else if (D2 === "multiple") {
            vs(C.selectedMap) || (C.selectedMap = {});
            for (var F3 = C.selectedMap, j = 0; j < L; j++) {
              var U3 = d2[j], Y3 = gyt(e2, U3);
              F3[Y3] = true, this._selectedDataIndicesMap[Y3] = e2.getRawIndex(U3);
            }
          } else if (D2 === "single" || D2 === true) {
            var Q = d2[L - 1], Y3 = gyt(e2, Q);
            C.selectedMap = (y2 = {}, y2[Y3] = true, y2), this._selectedDataIndicesMap = (x2 = {}, x2[Y3] = e2.getRawIndex(Q), x2);
          }
        }
      }, a.prototype._initSelectedMapFromData = function(e2) {
        if (!this.option.selectedMap) {
          var d2 = [];
          e2.hasItemOption && e2.each(function(y2) {
            var x2 = e2.getRawDataItem(y2);
            x2 && x2.selected && d2.push(y2);
          }), d2.length > 0 && this._innerSelect(e2, d2);
        }
      }, a.registerClass = function(e2) {
        return Ah2.registerClass(e2);
      }, a.protoInitialize = function() {
        var e2 = a.prototype;
        e2.type = "series.__base__", e2.seriesIndex = 0, e2.ignoreStyleOnData = false, e2.hasSymbolVisual = false, e2.defaultSymbol = "circle", e2.visualStyleAccessPath = "itemStyle", e2.visualDrawType = "fill";
      }(), a;
    }(Ah2);
    v0(yyt, $3t), v0(yyt, V3t), unt(yyt, Ah2);
    function bae(l2) {
      var a = l2.name;
      y1(l2) || (l2.name = AYe(l2) || a);
    }
    function AYe(l2) {
      var a = l2.getRawData(), e2 = a.mapDimensionsAll("seriesName"), d2 = [];
      return Ke2(e2, function(y2) {
        var x2 = a.getDimensionInfo(y2);
        x2.displayName && d2.push(x2.displayName);
      }), d2.join(" ");
    }
    function IYe(l2) {
      return l2.model.getRawData().count();
    }
    function DYe(l2) {
      var a = l2.model;
      return a.setData(a.getRawData().cloneShallow()), EYe;
    }
    function EYe(l2, a) {
      a.outputData && l2.end > a.outputData.count() && a.model.getRawData().cloneShallow(a.outputData);
    }
    function _ae(l2, a) {
      Ke2(EU(l2.CHANGABLE_METHODS, l2.DOWNSAMPLE_METHODS), function(e2) {
        l2.wrapMethod(e2, xu(kYe, a));
      });
    }
    function kYe(l2, a) {
      var e2 = eLt(l2);
      return e2 && e2.setOutputEnd((a || this).count()), a;
    }
    function eLt(l2) {
      var a = (l2.ecModel || {}).scheduler, e2 = a && a.getPipeline(l2.uid);
      if (e2) {
        var d2 = e2.currentTask;
        if (d2) {
          var y2 = d2.agentStubMap;
          y2 && (d2 = y2.get(l2.uid));
        }
        return d2;
      }
    }
    var Pv = yyt, nLt = function() {
      function l2() {
        this.group = new ou(), this.uid = zq("viewComponent");
      }
      return l2.prototype.init = function(a, e2) {
      }, l2.prototype.render = function(a, e2, d2, y2) {
      }, l2.prototype.dispose = function(a, e2) {
      }, l2.prototype.updateView = function(a, e2, d2, y2) {
      }, l2.prototype.updateLayout = function(a, e2, d2, y2) {
      }, l2.prototype.updateVisual = function(a, e2, d2, y2) {
      }, l2.prototype.blurSeries = function(a, e2) {
      }, l2.prototype.eachRendered = function(a) {
        var e2 = this.group;
        e2 && e2.traverse(a);
      }, l2;
    }();
    CE(nLt), fq(nLt);
    var _0 = nLt;
    function Kq() {
      var l2 = Rf2();
      return function(a) {
        var e2 = l2(a), d2 = a.pipelineContext, y2 = !!e2.large, x2 = !!e2.progressiveRender, C = e2.large = !!(d2 && d2.large), D2 = e2.progressiveRender = !!(d2 && d2.progressiveRender);
        return (y2 !== C || x2 !== D2) && "reset";
      };
    }
    var xae = Rf2(), PYe = Kq(), rLt = function() {
      function l2() {
        this.group = new ou(), this.uid = zq("viewChart"), this.renderTask = prt({ plan: LYe, reset: OYe }), this.renderTask.context = { view: this };
      }
      return l2.prototype.init = function(a, e2) {
      }, l2.prototype.render = function(a, e2, d2, y2) {
      }, l2.prototype.highlight = function(a, e2, d2, y2) {
        var x2 = a.getData(y2 && y2.dataType);
        !x2 || Sae(x2, y2, "emphasis");
      }, l2.prototype.downplay = function(a, e2, d2, y2) {
        var x2 = a.getData(y2 && y2.dataType);
        !x2 || Sae(x2, y2, "normal");
      }, l2.prototype.remove = function(a, e2) {
        this.group.removeAll();
      }, l2.prototype.dispose = function(a, e2) {
      }, l2.prototype.updateView = function(a, e2, d2, y2) {
        this.render(a, e2, d2, y2);
      }, l2.prototype.updateLayout = function(a, e2, d2, y2) {
        this.render(a, e2, d2, y2);
      }, l2.prototype.updateVisual = function(a, e2, d2, y2) {
        this.render(a, e2, d2, y2);
      }, l2.prototype.eachRendered = function(a) {
        qN(this.group, a);
      }, l2.markUpdateMethod = function(a, e2) {
        xae(a).updateMethod = e2;
      }, l2.protoInitialize = function() {
        var a = l2.prototype;
        a.type = "chart";
      }(), l2;
    }();
    function wae(l2, a, e2) {
      l2 && TO(l2) && (a === "emphasis" ? Dm : fc2)(l2, e2);
    }
    function Sae(l2, a, e2) {
      var d2 = fC(l2, a), y2 = a && a.highlightKey != null ? $Pt(a.highlightKey) : null;
      d2 != null ? Ke2(Mp(d2), function(x2) {
        wae(l2.getItemGraphicEl(x2), e2, y2);
      }) : l2.eachItemGraphicEl(function(x2) {
        wae(x2, e2, y2);
      });
    }
    CE(rLt), fq(rLt);
    function LYe(l2) {
      return PYe(l2.model);
    }
    function OYe(l2) {
      var a = l2.model, e2 = l2.ecModel, d2 = l2.api, y2 = l2.payload, x2 = a.pipelineContext.progressiveRender, C = l2.view, D2 = y2 && xae(y2).updateMethod, L = x2 ? "incrementalPrepareRender" : D2 && C[D2] ? D2 : "render";
      return L !== "render" && C[L](a, e2, d2, y2), RYe[L];
    }
    var RYe = { incrementalPrepareRender: { progress: function(l2, a) {
      a.view.incrementalRender(l2, a.model, a.ecModel, a.api, a.payload);
    } }, render: { forceFirstProgress: true, progress: function(l2, a) {
      a.view.render(a.model, a.ecModel, a.api, a.payload);
    } } }, pg2 = rLt, myt = "\0__throttleOriginMethod", Mae = "\0__throttleRate", Cae = "\0__throttleType";
    function iLt(l2, a, e2) {
      var d2, y2 = 0, x2 = 0, C = null, D2, L, F3, j;
      a = a || 0;
      function U3() {
        x2 = new Date().getTime(), C = null, l2.apply(L, F3 || []);
      }
      var Y3 = function() {
        for (var Q = [], nt = 0; nt < arguments.length; nt++)
          Q[nt] = arguments[nt];
        d2 = new Date().getTime(), L = this, F3 = Q;
        var dt = j || a, vt = j || e2;
        j = null, D2 = d2 - (vt ? y2 : x2) - dt, clearTimeout(C), vt ? C = setTimeout(U3, dt) : D2 >= 0 ? U3() : C = setTimeout(U3, -D2), y2 = d2;
      };
      return Y3.clear = function() {
        C && (clearTimeout(C), C = null);
      }, Y3.debounceNextCall = function(Q) {
        j = Q;
      }, Y3;
    }
    function Xq(l2, a, e2, d2) {
      var y2 = l2[a];
      if (y2) {
        var x2 = y2[myt] || y2, C = y2[Cae], D2 = y2[Mae];
        if (D2 !== e2 || C !== d2) {
          if (e2 == null || !d2)
            return l2[a] = x2;
          y2 = l2[a] = iLt(x2, e2, d2 === "debounce"), y2[myt] = x2, y2[Cae] = d2, y2[Mae] = e2;
        }
        return y2;
      }
    }
    function grt(l2, a) {
      var e2 = l2[a];
      e2 && e2[myt] && (e2.clear && e2.clear(), l2[a] = e2[myt]);
    }
    var Tae = Rf2(), Aae = { itemStyle: dO(Yre, true), lineStyle: dO($re, true) }, NYe = { lineStyle: "stroke", itemStyle: "fill" };
    function Iae(l2, a) {
      var e2 = l2.visualStyleMapper || Aae[a];
      return e2 || (console.warn("Unkown style type '" + a + "'."), Aae.itemStyle);
    }
    function Dae(l2, a) {
      var e2 = l2.visualDrawType || NYe[a];
      return e2 || (console.warn("Unkown style type '" + a + "'."), "fill");
    }
    var FYe = { createOnAllSeries: true, performRawSeries: true, reset: function(l2, a) {
      var e2 = l2.getData(), d2 = l2.visualStyleAccessPath || "itemStyle", y2 = l2.getModel(d2), x2 = Iae(l2, d2), C = x2(y2), D2 = y2.getShallow("decal");
      D2 && (e2.setVisual("decal", D2), D2.dirty = true);
      var L = Dae(l2, d2), F3 = C[L], j = wl(F3) ? F3 : null, U3 = C.fill === "auto" || C.stroke === "auto";
      if (!C[L] || j || U3) {
        var Y3 = l2.getColorFromPalette(l2.name, null, a.getSeriesCount());
        C[L] || (C[L] = Y3, e2.setVisual("colorFromPalette", true)), C.fill = C.fill === "auto" || wl(C.fill) ? Y3 : C.fill, C.stroke = C.stroke === "auto" || wl(C.stroke) ? Y3 : C.stroke;
      }
      if (e2.setVisual("style", C), e2.setVisual("drawType", L), !a.isSeriesFiltered(l2) && j)
        return e2.setVisual("colorFromPalette", false), { dataEach: function(Q, nt) {
          var dt = l2.getDataParams(nt), vt = la2({}, C);
          vt[L] = j(dt), Q.setItemVisual(nt, "style", vt);
        } };
    } }, vrt = new hg2(), VYe = { createOnAllSeries: true, performRawSeries: true, reset: function(l2, a) {
      if (!(l2.ignoreStyleOnData || a.isSeriesFiltered(l2))) {
        var e2 = l2.getData(), d2 = l2.visualStyleAccessPath || "itemStyle", y2 = Iae(l2, d2), x2 = e2.getVisual("drawType");
        return { dataEach: e2.hasItemOption ? function(C, D2) {
          var L = C.getRawDataItem(D2);
          if (L && L[d2]) {
            vrt.option = L[d2];
            var F3 = y2(vrt), j = C.ensureUniqueItemVisual(D2, "style");
            la2(j, F3), vrt.option.decal && (C.setItemVisual(D2, "decal", vrt.option.decal), vrt.option.decal.dirty = true), x2 in F3 && C.setItemVisual(D2, "colorFromPalette", false);
          }
        } : null };
      }
    } }, BYe = { performRawSeries: true, overallReset: function(l2) {
      var a = fl();
      l2.eachSeries(function(e2) {
        var d2 = e2.getColorBy();
        if (!e2.isColorBySeries()) {
          var y2 = e2.type + "-" + d2, x2 = a.get(y2);
          x2 || (x2 = {}, a.set(y2, x2)), Tae(e2).scope = x2;
        }
      }), l2.eachSeries(function(e2) {
        if (!(e2.isColorBySeries() || l2.isSeriesFiltered(e2))) {
          var d2 = e2.getRawData(), y2 = {}, x2 = e2.getData(), C = Tae(e2).scope, D2 = e2.visualStyleAccessPath || "itemStyle", L = Dae(e2, D2);
          x2.each(function(F3) {
            var j = x2.getRawIndex(F3);
            y2[j] = F3;
          }), d2.each(function(F3) {
            var j = y2[F3], U3 = x2.getItemVisual(j, "colorFromPalette");
            if (U3) {
              var Y3 = x2.ensureUniqueItemVisual(j, "style"), Q = d2.getName(F3) || F3 + "", nt = d2.count();
              Y3[L] = e2.getColorFromPalette(Q, C, nt);
            }
          });
        }
      });
    } }, byt = Math.PI;
    function zYe(l2, a) {
      a = a || {}, El(a, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
      var e2 = new ou(), d2 = new Nf2({ style: { fill: a.maskColor }, zlevel: a.zlevel, z: 1e4 });
      e2.add(d2);
      var y2 = new qc2({ style: { text: a.text, fill: a.textColor, fontSize: a.fontSize, fontWeight: a.fontWeight, fontStyle: a.fontStyle, fontFamily: a.fontFamily }, zlevel: a.zlevel, z: 10001 }), x2 = new Nf2({ style: { fill: "none" }, textContent: y2, textConfig: { position: "right", distance: 10 }, zlevel: a.zlevel, z: 10001 });
      e2.add(x2);
      var C;
      return a.showSpinner && (C = new Qnt({ shape: { startAngle: -byt / 2, endAngle: -byt / 2 + 0.1, r: a.spinnerRadius }, style: { stroke: a.color, lineCap: "round", lineWidth: a.lineWidth }, zlevel: a.zlevel, z: 10001 }), C.animateShape(true).when(1e3, { endAngle: byt * 3 / 2 }).start("circularInOut"), C.animateShape(true).when(1e3, { startAngle: byt * 3 / 2 }).delay(300).start("circularInOut"), e2.add(C)), e2.resize = function() {
        var D2 = y2.getBoundingRect().width, L = a.showSpinner ? a.spinnerRadius : 0, F3 = (l2.getWidth() - L * 2 - (a.showSpinner && D2 ? 10 : 0) - D2) / 2 - (a.showSpinner && D2 ? 0 : 5 + D2 / 2) + (a.showSpinner ? 0 : D2 / 2) + (D2 ? 0 : L), j = l2.getHeight() / 2;
        a.showSpinner && C.setShape({ cx: F3, cy: j }), x2.setShape({ x: F3 - L, y: j - L, width: L * 2, height: L * 2 }), d2.setShape({ x: 0, y: 0, width: l2.getWidth(), height: l2.getHeight() });
      }, e2.resize(), e2;
    }
    var jYe = function() {
      function l2(a, e2, d2, y2) {
        this._stageTaskMap = fl(), this.ecInstance = a, this.api = e2, d2 = this._dataProcessorHandlers = d2.slice(), y2 = this._visualHandlers = y2.slice(), this._allHandlers = d2.concat(y2);
      }
      return l2.prototype.restoreData = function(a, e2) {
        a.restoreData(e2), this._stageTaskMap.each(function(d2) {
          var y2 = d2.overallTask;
          y2 && y2.dirty();
        });
      }, l2.prototype.getPerformArgs = function(a, e2) {
        if (a.__pipeline) {
          var d2 = this._pipelineMap.get(a.__pipeline.id), y2 = d2.context, x2 = !e2 && d2.progressiveEnabled && (!y2 || y2.progressiveRender) && a.__idxInPipeline > d2.blockIndex, C = x2 ? d2.step : null, D2 = y2 && y2.modDataCount, L = D2 != null ? Math.ceil(D2 / C) : null;
          return { step: C, modBy: L, modDataCount: D2 };
        }
      }, l2.prototype.getPipeline = function(a) {
        return this._pipelineMap.get(a);
      }, l2.prototype.updateStreamModes = function(a, e2) {
        var d2 = this._pipelineMap.get(a.uid), y2 = a.getData(), x2 = y2.count(), C = d2.progressiveEnabled && e2.incrementalPrepareRender && x2 >= d2.threshold, D2 = a.get("large") && x2 >= a.get("largeThreshold"), L = a.get("progressiveChunkMode") === "mod" ? x2 : null;
        a.pipelineContext = d2.context = { progressiveRender: C, modDataCount: L, large: D2 };
      }, l2.prototype.restorePipelines = function(a) {
        var e2 = this, d2 = e2._pipelineMap = fl();
        a.eachSeries(function(y2) {
          var x2 = y2.getProgressive(), C = y2.uid;
          d2.set(C, { id: C, head: null, tail: null, threshold: y2.getProgressiveThreshold(), progressiveEnabled: x2 && !(y2.preventIncremental && y2.preventIncremental()), blockIndex: -1, step: Math.round(x2 || 700), count: 0 }), e2._pipe(y2, y2.dataTask);
        });
      }, l2.prototype.prepareStageTasks = function() {
        var a = this._stageTaskMap, e2 = this.api.getModel(), d2 = this.api;
        Ke2(this._allHandlers, function(y2) {
          var x2 = a.get(y2.uid) || a.set(y2.uid, {}), C = "";
          vb2(!(y2.reset && y2.overallReset), C), y2.reset && this._createSeriesStageTask(y2, x2, e2, d2), y2.overallReset && this._createOverallStageTask(y2, x2, e2, d2);
        }, this);
      }, l2.prototype.prepareView = function(a, e2, d2, y2) {
        var x2 = a.renderTask, C = x2.context;
        C.model = e2, C.ecModel = d2, C.api = y2, x2.__block = !a.incrementalPrepareRender, this._pipe(e2, x2);
      }, l2.prototype.performDataProcessorTasks = function(a, e2) {
        this._performStageTasks(this._dataProcessorHandlers, a, e2, { block: true });
      }, l2.prototype.performVisualTasks = function(a, e2, d2) {
        this._performStageTasks(this._visualHandlers, a, e2, d2);
      }, l2.prototype._performStageTasks = function(a, e2, d2, y2) {
        y2 = y2 || {};
        var x2 = false, C = this;
        Ke2(a, function(L, F3) {
          if (!(y2.visualType && y2.visualType !== L.visualType)) {
            var j = C._stageTaskMap.get(L.uid), U3 = j.seriesTaskMap, Y3 = j.overallTask;
            if (Y3) {
              var Q, nt = Y3.agentStubMap;
              nt.each(function(vt) {
                D2(y2, vt) && (vt.dirty(), Q = true);
              }), Q && Y3.dirty(), C.updatePayload(Y3, d2);
              var dt = C.getPerformArgs(Y3, y2.block);
              nt.each(function(vt) {
                vt.perform(dt);
              }), Y3.perform(dt) && (x2 = true);
            } else
              U3 && U3.each(function(vt, Ct) {
                D2(y2, vt) && vt.dirty();
                var Pt = C.getPerformArgs(vt, y2.block);
                Pt.skip = !L.performRawSeries && e2.isSeriesFiltered(vt.context.model), C.updatePayload(vt, d2), vt.perform(Pt) && (x2 = true);
              });
          }
        });
        function D2(L, F3) {
          return L.setDirty && (!L.dirtyMap || L.dirtyMap.get(F3.__pipeline.id));
        }
        this.unfinished = x2 || this.unfinished;
      }, l2.prototype.performSeriesTasks = function(a) {
        var e2;
        a.eachSeries(function(d2) {
          e2 = d2.dataTask.perform() || e2;
        }), this.unfinished = e2 || this.unfinished;
      }, l2.prototype.plan = function() {
        this._pipelineMap.each(function(a) {
          var e2 = a.tail;
          do {
            if (e2.__block) {
              a.blockIndex = e2.__idxInPipeline;
              break;
            }
            e2 = e2.getUpstream();
          } while (e2);
        });
      }, l2.prototype.updatePayload = function(a, e2) {
        e2 !== "remain" && (a.context.payload = e2);
      }, l2.prototype._createSeriesStageTask = function(a, e2, d2, y2) {
        var x2 = this, C = e2.seriesTaskMap, D2 = e2.seriesTaskMap = fl(), L = a.seriesType, F3 = a.getTargetSeries;
        a.createOnAllSeries ? d2.eachRawSeries(j) : L ? d2.eachRawSeriesByType(L, j) : F3 && F3(d2, y2).each(j);
        function j(U3) {
          var Y3 = U3.uid, Q = D2.set(Y3, C && C.get(Y3) || prt({ plan: qYe, reset: ZYe, count: YYe }));
          Q.context = { model: U3, ecModel: d2, api: y2, useClearVisual: a.isVisual && !a.isLayout, plan: a.plan, reset: a.reset, scheduler: x2 }, x2._pipe(U3, Q);
        }
      }, l2.prototype._createOverallStageTask = function(a, e2, d2, y2) {
        var x2 = this, C = e2.overallTask = e2.overallTask || prt({ reset: WYe });
        C.context = { ecModel: d2, api: y2, overallReset: a.overallReset, scheduler: x2 };
        var D2 = C.agentStubMap, L = C.agentStubMap = fl(), F3 = a.seriesType, j = a.getTargetSeries, U3 = true, Y3 = false, Q = "";
        vb2(!a.createOnAllSeries, Q), F3 ? d2.eachRawSeriesByType(F3, nt) : j ? j(d2, y2).each(nt) : (U3 = false, Ke2(d2.getSeries(), nt));
        function nt(dt) {
          var vt = dt.uid, Ct = L.set(vt, D2 && D2.get(vt) || (Y3 = true, prt({ reset: GYe, onDirty: UYe })));
          Ct.context = { model: dt, overallProgress: U3 }, Ct.agent = C, Ct.__block = U3, x2._pipe(dt, Ct);
        }
        Y3 && C.dirty();
      }, l2.prototype._pipe = function(a, e2) {
        var d2 = a.uid, y2 = this._pipelineMap.get(d2);
        !y2.head && (y2.head = e2), y2.tail && y2.tail.pipe(e2), y2.tail = e2, e2.__idxInPipeline = y2.count++, e2.__pipeline = y2;
      }, l2.wrapStageHandler = function(a, e2) {
        return wl(a) && (a = { overallReset: a, seriesType: KYe(a) }), a.uid = zq("stageHandler"), e2 && (a.visualType = e2), a;
      }, l2;
    }();
    function WYe(l2) {
      l2.overallReset(l2.ecModel, l2.api, l2.payload);
    }
    function GYe(l2) {
      return l2.overallProgress && HYe;
    }
    function HYe() {
      this.agent.dirty(), this.getDownstream().dirty();
    }
    function UYe() {
      this.agent && this.agent.dirty();
    }
    function qYe(l2) {
      return l2.plan ? l2.plan(l2.model, l2.ecModel, l2.api, l2.payload) : null;
    }
    function ZYe(l2) {
      l2.useClearVisual && l2.data.clearAllVisual();
      var a = l2.resetDefines = Mp(l2.reset(l2.model, l2.ecModel, l2.api, l2.payload));
      return a.length > 1 ? $a2(a, function(e2, d2) {
        return Eae(d2);
      }) : $Ye;
    }
    var $Ye = Eae(0);
    function Eae(l2) {
      return function(a, e2) {
        var d2 = e2.data, y2 = e2.resetDefines[l2];
        if (y2 && y2.dataEach)
          for (var x2 = a.start; x2 < a.end; x2++)
            y2.dataEach(d2, x2);
        else
          y2 && y2.progress && y2.progress(a, d2);
      };
    }
    function YYe(l2) {
      return l2.data.count();
    }
    function KYe(l2) {
      _yt = null;
      try {
        l2(yrt, kae);
      } catch {
      }
      return _yt;
    }
    var yrt = {}, kae = {}, _yt;
    Pae(yrt, Eie), Pae(kae, kie), yrt.eachSeriesByType = yrt.eachRawSeriesByType = function(l2) {
      _yt = l2;
    }, yrt.eachComponent = function(l2) {
      l2.mainType === "series" && l2.subType && (_yt = l2.subType);
    };
    function Pae(l2, a) {
      for (var e2 in a.prototype)
        l2[e2] = $p;
    }
    var Lae = jYe, Oae = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], XYe = { color: Oae, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], Oae] }, zS = "#B9B8CE", Rae = "#100C2A", xyt = function() {
      return { axisLine: { lineStyle: { color: zS } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
    }, Nae = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], Fae = { darkMode: true, color: Nae, backgroundColor: Rae, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: zS } }, textStyle: { color: zS }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: zS } }, dataZoom: { borderColor: "#71708A", textStyle: { color: zS }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: zS } }, timeline: { lineStyle: { color: zS }, label: { color: zS }, controlStyle: { color: zS, borderColor: zS } }, calendar: { itemStyle: { color: Rae }, dayLabel: { color: zS }, monthLabel: { color: zS }, yearLabel: { color: zS } }, timeAxis: xyt(), logAxis: xyt(), valueAxis: xyt(), categoryAxis: xyt(), line: { symbol: "circle" }, graph: { color: Nae }, gauge: { title: { color: zS }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: zS }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
    Fae.categoryAxis.splitLine.show = false;
    var QYe = Fae, JYe = function() {
      function l2() {
      }
      return l2.prototype.normalizeQuery = function(a) {
        var e2 = {}, d2 = {}, y2 = {};
        if (ps(a)) {
          var x2 = NS(a);
          e2.mainType = x2.main || null, e2.subType = x2.sub || null;
        } else {
          var C = ["Index", "Name", "Id"], D2 = { name: 1, dataIndex: 1, dataType: 1 };
          Ke2(a, function(L, F3) {
            for (var j = false, U3 = 0; U3 < C.length; U3++) {
              var Y3 = C[U3], Q = F3.lastIndexOf(Y3);
              if (Q > 0 && Q === F3.length - Y3.length) {
                var nt = F3.slice(0, Q);
                nt !== "data" && (e2.mainType = nt, e2[Y3.toLowerCase()] = L, j = true);
              }
            }
            D2.hasOwnProperty(F3) && (d2[F3] = L, j = true), j || (y2[F3] = L);
          });
        }
        return { cptQuery: e2, dataQuery: d2, otherQuery: y2 };
      }, l2.prototype.filter = function(a, e2) {
        var d2 = this.eventInfo;
        if (!d2)
          return true;
        var y2 = d2.targetEl, x2 = d2.packedEvent, C = d2.model, D2 = d2.view;
        if (!C || !D2)
          return true;
        var L = e2.cptQuery, F3 = e2.dataQuery;
        return j(L, C, "mainType") && j(L, C, "subType") && j(L, C, "index", "componentIndex") && j(L, C, "name") && j(L, C, "id") && j(F3, x2, "name") && j(F3, x2, "dataIndex") && j(F3, x2, "dataType") && (!D2.filterForExposedEvent || D2.filterForExposedEvent(a, e2.otherQuery, y2, x2));
        function j(U3, Y3, Q, nt) {
          return U3[Q] == null || Y3[nt || Q] === U3[Q];
        }
      }, l2.prototype.afterTrigger = function() {
        this.eventInfo = null;
      }, l2;
    }(), aLt = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], Vae = aLt.concat(["symbolKeepAspect"]), tKe = { createOnAllSeries: true, performRawSeries: true, reset: function(l2, a) {
      var e2 = l2.getData();
      if (l2.legendIcon && e2.setVisual("legendIcon", l2.legendIcon), !l2.hasSymbolVisual)
        return;
      for (var d2 = {}, y2 = {}, x2 = false, C = 0; C < aLt.length; C++) {
        var D2 = aLt[C], L = l2.get(D2);
        wl(L) ? (x2 = true, y2[D2] = L) : d2[D2] = L;
      }
      if (d2.symbol = d2.symbol || l2.defaultSymbol, e2.setVisual(la2({ legendIcon: l2.legendIcon || d2.symbol, symbolKeepAspect: l2.get("symbolKeepAspect") }, d2)), a.isSeriesFiltered(l2))
        return;
      var F3 = Qc2(y2);
      function j(U3, Y3) {
        for (var Q = l2.getRawValue(Y3), nt = l2.getDataParams(Y3), dt = 0; dt < F3.length; dt++) {
          var vt = F3[dt];
          U3.setItemVisual(Y3, vt, y2[vt](Q, nt));
        }
      }
      return { dataEach: x2 ? j : null };
    } }, eKe = { createOnAllSeries: true, performRawSeries: true, reset: function(l2, a) {
      if (!l2.hasSymbolVisual || a.isSeriesFiltered(l2))
        return;
      var e2 = l2.getData();
      function d2(y2, x2) {
        for (var C = y2.getItemModel(x2), D2 = 0; D2 < Vae.length; D2++) {
          var L = Vae[D2], F3 = C.getShallow(L, true);
          F3 != null && y2.setItemVisual(x2, L, F3);
        }
      }
      return { dataEach: e2.hasItemOption ? d2 : null };
    } };
    function oLt(l2, a, e2) {
      switch (e2) {
        case "color":
          var d2 = l2.getItemVisual(a, "style");
          return d2[l2.getVisual("drawType")];
        case "opacity":
          return l2.getItemVisual(a, "style").opacity;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          return l2.getItemVisual(a, e2);
      }
    }
    function mrt(l2, a) {
      switch (a) {
        case "color":
          var e2 = l2.getVisual("style");
          return e2[l2.getVisual("drawType")];
        case "opacity":
          return l2.getVisual("style").opacity;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          return l2.getVisual(a);
      }
    }
    function Bae(l2, a, e2, d2) {
      switch (e2) {
        case "color":
          var y2 = l2.ensureUniqueItemVisual(a, "style");
          y2[l2.getVisual("drawType")] = d2, l2.setItemVisual(a, "colorFromPalette", false);
          break;
        case "opacity":
          l2.ensureUniqueItemVisual(a, "style").opacity = d2;
          break;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          l2.setItemVisual(a, e2, d2);
          break;
      }
    }
    function zae(l2, a) {
      function e2(d2, y2) {
        var x2 = [];
        return d2.eachComponent({ mainType: "series", subType: l2, query: y2 }, function(C) {
          x2.push(C.seriesIndex);
        }), x2;
      }
      Ke2([[l2 + "ToggleSelect", "toggleSelect"], [l2 + "Select", "select"], [l2 + "UnSelect", "unselect"]], function(d2) {
        a(d2[0], function(y2, x2, C) {
          y2 = la2({}, y2), C.dispatchAction(la2(y2, { type: d2[1], seriesIndex: e2(x2, y2) }));
        });
      });
    }
    function Qq(l2, a, e2, d2, y2) {
      var x2 = l2 + a;
      e2.isSilent(x2) || d2.eachComponent({ mainType: "series", subType: "pie" }, function(C) {
        for (var D2 = C.seriesIndex, L = C.option.selectedMap, F3 = y2.selected, j = 0; j < F3.length; j++)
          if (F3[j].seriesIndex === D2) {
            var U3 = C.getData(), Y3 = fC(U3, y2.fromActionPayload);
            e2.trigger(x2, { type: x2, seriesId: C.id, name: Ba2(Y3) ? U3.getName(Y3[0]) : U3.getName(Y3), selected: ps(L) ? L : la2({}, L) });
          }
      });
    }
    function nKe(l2, a, e2) {
      l2.on("selectchanged", function(d2) {
        var y2 = e2.getModel();
        d2.isFromClick ? (Qq("map", "selectchanged", a, y2, d2), Qq("pie", "selectchanged", a, y2, d2)) : d2.fromAction === "select" ? (Qq("map", "selected", a, y2, d2), Qq("pie", "selected", a, y2, d2)) : d2.fromAction === "unselect" && (Qq("map", "unselected", a, y2, d2), Qq("pie", "unselected", a, y2, d2));
      });
    }
    function Jq(l2, a, e2) {
      for (var d2; l2 && !(a(l2) && (d2 = l2, e2)); )
        l2 = l2.__hostTarget || l2.parent;
      return d2;
    }
    var rKe = Math.round(Math.random() * 9), iKe = typeof Object.defineProperty == "function", aKe = function() {
      function l2() {
        this._id = "__ec_inner_" + rKe++;
      }
      return l2.prototype.get = function(a) {
        return this._guard(a)[this._id];
      }, l2.prototype.set = function(a, e2) {
        var d2 = this._guard(a);
        return iKe ? Object.defineProperty(d2, this._id, { value: e2, enumerable: false, configurable: true }) : d2[this._id] = e2, this;
      }, l2.prototype.delete = function(a) {
        return this.has(a) ? (delete this._guard(a)[this._id], true) : false;
      }, l2.prototype.has = function(a) {
        return !!this._guard(a)[this._id];
      }, l2.prototype._guard = function(a) {
        if (a !== Object(a))
          throw TypeError("Value of WeakMap is not a non-null object.");
        return a;
      }, l2;
    }(), oKe = aKe, sKe = wc2.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(l2, a) {
      var e2 = a.cx, d2 = a.cy, y2 = a.width / 2, x2 = a.height / 2;
      l2.moveTo(e2, d2 - x2), l2.lineTo(e2 + y2, d2 + x2), l2.lineTo(e2 - y2, d2 + x2), l2.closePath();
    } }), lKe = wc2.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(l2, a) {
      var e2 = a.cx, d2 = a.cy, y2 = a.width / 2, x2 = a.height / 2;
      l2.moveTo(e2, d2 - x2), l2.lineTo(e2 + y2, d2), l2.lineTo(e2, d2 + x2), l2.lineTo(e2 - y2, d2), l2.closePath();
    } }), uKe = wc2.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(l2, a) {
      var e2 = a.x, d2 = a.y, y2 = a.width / 5 * 3, x2 = Math.max(y2, a.height), C = y2 / 2, D2 = C * C / (x2 - C), L = d2 - x2 + C + D2, F3 = Math.asin(D2 / C), j = Math.cos(F3) * C, U3 = Math.sin(F3), Y3 = Math.cos(F3), Q = C * 0.6, nt = C * 0.7;
      l2.moveTo(e2 - j, L + D2), l2.arc(e2, L, C, Math.PI - F3, Math.PI * 2 + F3), l2.bezierCurveTo(e2 + j - U3 * Q, L + D2 + Y3 * Q, e2, d2 - nt, e2, d2), l2.bezierCurveTo(e2, d2 - nt, e2 - j + U3 * Q, L + D2 + Y3 * Q, e2 - j, L + D2), l2.closePath();
    } }), cKe = wc2.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(l2, a) {
      var e2 = a.height, d2 = a.width, y2 = a.x, x2 = a.y, C = d2 / 3 * 2;
      l2.moveTo(y2, x2), l2.lineTo(y2 + C, x2 + e2), l2.lineTo(y2, x2 + e2 / 4 * 3), l2.lineTo(y2 - C, x2 + e2), l2.lineTo(y2, x2), l2.closePath();
    } }), fKe = { line: by, rect: Nf2, roundRect: Nf2, square: Nf2, circle: _A, diamond: lKe, pin: uKe, arrow: cKe, triangle: sKe }, hKe = { line: function(l2, a, e2, d2, y2) {
      y2.x1 = l2, y2.y1 = a + d2 / 2, y2.x2 = l2 + e2, y2.y2 = a + d2 / 2;
    }, rect: function(l2, a, e2, d2, y2) {
      y2.x = l2, y2.y = a, y2.width = e2, y2.height = d2;
    }, roundRect: function(l2, a, e2, d2, y2) {
      y2.x = l2, y2.y = a, y2.width = e2, y2.height = d2, y2.r = Math.min(e2, d2) / 4;
    }, square: function(l2, a, e2, d2, y2) {
      var x2 = Math.min(e2, d2);
      y2.x = l2, y2.y = a, y2.width = x2, y2.height = x2;
    }, circle: function(l2, a, e2, d2, y2) {
      y2.cx = l2 + e2 / 2, y2.cy = a + d2 / 2, y2.r = Math.min(e2, d2) / 2;
    }, diamond: function(l2, a, e2, d2, y2) {
      y2.cx = l2 + e2 / 2, y2.cy = a + d2 / 2, y2.width = e2, y2.height = d2;
    }, pin: function(l2, a, e2, d2, y2) {
      y2.x = l2 + e2 / 2, y2.y = a + d2 / 2, y2.width = e2, y2.height = d2;
    }, arrow: function(l2, a, e2, d2, y2) {
      y2.x = l2 + e2 / 2, y2.y = a + d2 / 2, y2.width = e2, y2.height = d2;
    }, triangle: function(l2, a, e2, d2, y2) {
      y2.cx = l2 + e2 / 2, y2.cy = a + d2 / 2, y2.width = e2, y2.height = d2;
    } }, wyt = {};
    Ke2(fKe, function(l2, a) {
      wyt[a] = new l2();
    });
    var pKe = wc2.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(l2, a, e2) {
      var d2 = QU(l2, a, e2), y2 = this.shape;
      return y2 && y2.symbolType === "pin" && a.position === "inside" && (d2.y = e2.y + e2.height * 0.4), d2;
    }, buildPath: function(l2, a, e2) {
      var d2 = a.symbolType;
      if (d2 !== "none") {
        var y2 = wyt[d2];
        y2 || (d2 = "rect", y2 = wyt[d2]), hKe[d2](a.x, a.y, a.width, a.height, y2.shape), y2.buildPath(l2, y2.shape, e2);
      }
    } });
    function dKe(l2, a) {
      if (this.type !== "image") {
        var e2 = this.style;
        this.__isEmptyBrush ? (e2.stroke = l2, e2.fill = a || "#fff", e2.lineWidth = 2) : this.shape.symbolType === "line" ? e2.stroke = l2 : e2.fill = l2, this.markRedraw();
      }
    }
    function qy(l2, a, e2, d2, y2, x2, C) {
      var D2 = l2.indexOf("empty") === 0;
      D2 && (l2 = l2.substr(5, 1).toLowerCase() + l2.substr(6));
      var L;
      return l2.indexOf("image://") === 0 ? L = $r(l2.slice(8), new Yu(a, e2, d2, y2), C ? "center" : "cover") : l2.indexOf("path://") === 0 ? L = Fr(l2.slice(7), {}, new Yu(a, e2, d2, y2), C ? "center" : "cover") : L = new pKe({ shape: { symbolType: l2, x: a, y: e2, width: d2, height: y2 } }), L.__isEmptyBrush = D2, L.setColor = dKe, x2 && L.setColor(x2), L;
    }
    function brt(l2) {
      return Ba2(l2) || (l2 = [+l2, +l2]), [l2[0] || 0, l2[1] || 0];
    }
    function tZ(l2, a) {
      if (l2 != null)
        return Ba2(l2) || (l2 = [l2, l2]), [Ko(l2[0], a[0]) || 0, Ko($u(l2[1], l2[0]), a[1]) || 0];
    }
    function gKe(l2, a, e2) {
      var d2 = a.x == null ? 0 : a.x, y2 = a.x2 == null ? 1 : a.x2, x2 = a.y == null ? 0 : a.y, C = a.y2 == null ? 0 : a.y2;
      a.global || (d2 = d2 * e2.width + e2.x, y2 = y2 * e2.width + e2.x, x2 = x2 * e2.height + e2.y, C = C * e2.height + e2.y), d2 = isNaN(d2) ? 0 : d2, y2 = isNaN(y2) ? 1 : y2, x2 = isNaN(x2) ? 0 : x2, C = isNaN(C) ? 0 : C;
      var D2 = l2.createLinearGradient(d2, x2, y2, C);
      return D2;
    }
    function vKe(l2, a, e2) {
      var d2 = e2.width, y2 = e2.height, x2 = Math.min(d2, y2), C = a.x == null ? 0.5 : a.x, D2 = a.y == null ? 0.5 : a.y, L = a.r == null ? 0.5 : a.r;
      a.global || (C = C * d2 + e2.x, D2 = D2 * y2 + e2.y, L = L * x2);
      var F3 = l2.createRadialGradient(C, D2, 0, C, D2, L);
      return F3;
    }
    function sLt(l2, a, e2) {
      for (var d2 = a.type === "radial" ? vKe(l2, a, e2) : gKe(l2, a, e2), y2 = a.colorStops, x2 = 0; x2 < y2.length; x2++)
        d2.addColorStop(y2[x2].offset, y2[x2].color);
      return d2;
    }
    function yKe(l2, a) {
      if (l2 === a || !l2 && !a)
        return false;
      if (!l2 || !a || l2.length !== a.length)
        return true;
      for (var e2 = 0; e2 < l2.length; e2++)
        if (l2[e2] !== a[e2])
          return true;
      return false;
    }
    function Syt(l2) {
      return parseInt(l2, 10);
    }
    function eZ(l2, a, e2) {
      var d2 = ["width", "height"][a], y2 = ["clientWidth", "clientHeight"][a], x2 = ["paddingLeft", "paddingTop"][a], C = ["paddingRight", "paddingBottom"][a];
      if (e2[d2] != null && e2[d2] !== "auto")
        return parseFloat(e2[d2]);
      var D2 = document.defaultView.getComputedStyle(l2);
      return (l2[y2] || Syt(D2[d2]) || Syt(l2.style[d2])) - (Syt(D2[x2]) || 0) - (Syt(D2[C]) || 0) | 0;
    }
    function mKe(l2, a) {
      return !l2 || l2 === "solid" || !(a > 0) ? null : l2 === "dashed" ? [4 * a, 2 * a] : l2 === "dotted" ? [a] : Ch2(l2) ? [l2] : Ba2(l2) ? l2 : null;
    }
    function lLt(l2) {
      var a = l2.style, e2 = a.lineDash && a.lineWidth > 0 && mKe(a.lineDash, a.lineWidth), d2 = a.lineDashOffset;
      if (e2) {
        var y2 = a.strokeNoScale && l2.getLineScale ? l2.getLineScale() : 1;
        y2 && y2 !== 1 && (e2 = $a2(e2, function(x2) {
          return x2 / y2;
        }), d2 /= y2);
      }
      return [e2, d2];
    }
    var bKe = new yA(true);
    function Myt(l2) {
      var a = l2.stroke;
      return !(a == null || a === "none" || !(l2.lineWidth > 0));
    }
    function jae(l2) {
      return typeof l2 == "string" && l2 !== "none";
    }
    function Cyt(l2) {
      var a = l2.fill;
      return a != null && a !== "none";
    }
    function Wae(l2, a) {
      if (a.fillOpacity != null && a.fillOpacity !== 1) {
        var e2 = l2.globalAlpha;
        l2.globalAlpha = a.fillOpacity * a.opacity, l2.fill(), l2.globalAlpha = e2;
      } else
        l2.fill();
    }
    function Gae(l2, a) {
      if (a.strokeOpacity != null && a.strokeOpacity !== 1) {
        var e2 = l2.globalAlpha;
        l2.globalAlpha = a.strokeOpacity * a.opacity, l2.stroke(), l2.globalAlpha = e2;
      } else
        l2.stroke();
    }
    function uLt(l2, a, e2) {
      var d2 = hq(a.image, a.__image, e2);
      if (BV(d2)) {
        var y2 = l2.createPattern(d2, a.repeat || "repeat");
        if (typeof DOMMatrix == "function" && y2 && y2.setTransform) {
          var x2 = new DOMMatrix();
          x2.translateSelf(a.x || 0, a.y || 0), x2.rotateSelf(0, 0, (a.rotation || 0) * kU), x2.scaleSelf(a.scaleX || 1, a.scaleY || 1), y2.setTransform(x2);
        }
        return y2;
      }
    }
    function _Ke(l2, a, e2, d2) {
      var y2, x2 = Myt(e2), C = Cyt(e2), D2 = e2.strokePercent, L = D2 < 1, F3 = !a.path;
      (!a.silent || L) && F3 && a.createPathProxy();
      var j = a.path || bKe, U3 = a.__dirty;
      if (!d2) {
        var Y3 = e2.fill, Q = e2.stroke, nt = C && !!Y3.colorStops, dt = x2 && !!Q.colorStops, vt = C && !!Y3.image, Ct = x2 && !!Q.image, Pt = void 0, jt = void 0, Rt = void 0, le2 = void 0, ne2 = void 0;
        (nt || dt) && (ne2 = a.getBoundingRect()), nt && (Pt = U3 ? sLt(l2, Y3, ne2) : a.__canvasFillGradient, a.__canvasFillGradient = Pt), dt && (jt = U3 ? sLt(l2, Q, ne2) : a.__canvasStrokeGradient, a.__canvasStrokeGradient = jt), vt && (Rt = U3 || !a.__canvasFillPattern ? uLt(l2, Y3, a) : a.__canvasFillPattern, a.__canvasFillPattern = Rt), Ct && (le2 = U3 || !a.__canvasStrokePattern ? uLt(l2, Q, a) : a.__canvasStrokePattern, a.__canvasStrokePattern = Rt), nt ? l2.fillStyle = Pt : vt && (Rt ? l2.fillStyle = Rt : C = false), dt ? l2.strokeStyle = jt : Ct && (le2 ? l2.strokeStyle = le2 : x2 = false);
      }
      var he2 = a.getGlobalScale();
      j.setScale(he2[0], he2[1], a.segmentIgnoreThreshold);
      var _e, Me2;
      l2.setLineDash && e2.lineDash && (y2 = lLt(a), _e = y2[0], Me2 = y2[1]);
      var Pe2 = true;
      (F3 || U3 & vN) && (j.setDPR(l2.dpr), L ? j.setContext(null) : (j.setContext(l2), Pe2 = false), j.reset(), a.buildPath(j, a.shape, d2), j.toStatic(), a.pathUpdated()), Pe2 && j.rebuildPath(l2, L ? D2 : 1), _e && (l2.setLineDash(_e), l2.lineDashOffset = Me2), d2 || (e2.strokeFirst ? (x2 && Gae(l2, e2), C && Wae(l2, e2)) : (C && Wae(l2, e2), x2 && Gae(l2, e2))), _e && l2.setLineDash([]);
    }
    function xKe(l2, a, e2) {
      var d2 = a.__image = hq(e2.image, a.__image, a, a.onload);
      if (!(!d2 || !BV(d2))) {
        var y2 = e2.x || 0, x2 = e2.y || 0, C = a.getWidth(), D2 = a.getHeight(), L = d2.width / d2.height;
        if (C == null && D2 != null ? C = D2 * L : D2 == null && C != null ? D2 = C / L : C == null && D2 == null && (C = d2.width, D2 = d2.height), e2.sWidth && e2.sHeight) {
          var F3 = e2.sx || 0, j = e2.sy || 0;
          l2.drawImage(d2, F3, j, e2.sWidth, e2.sHeight, y2, x2, C, D2);
        } else if (e2.sx && e2.sy) {
          var F3 = e2.sx, j = e2.sy, U3 = C - F3, Y3 = D2 - j;
          l2.drawImage(d2, F3, j, U3, Y3, y2, x2, C, D2);
        } else
          l2.drawImage(d2, y2, x2, C, D2);
      }
    }
    function wKe(l2, a, e2) {
      var d2, y2 = e2.text;
      if (y2 != null && (y2 += ""), y2) {
        l2.font = e2.font || Ru, l2.textAlign = e2.textAlign, l2.textBaseline = e2.textBaseline;
        var x2 = void 0, C = void 0;
        l2.setLineDash && e2.lineDash && (d2 = lLt(a), x2 = d2[0], C = d2[1]), x2 && (l2.setLineDash(x2), l2.lineDashOffset = C), e2.strokeFirst ? (Myt(e2) && l2.strokeText(y2, e2.x, e2.y), Cyt(e2) && l2.fillText(y2, e2.x, e2.y)) : (Cyt(e2) && l2.fillText(y2, e2.x, e2.y), Myt(e2) && l2.strokeText(y2, e2.x, e2.y)), x2 && l2.setLineDash([]);
      }
    }
    var Hae = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], Uae = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
    function qae(l2, a, e2, d2, y2) {
      var x2 = false;
      if (!d2 && (e2 = e2 || {}, a === e2))
        return false;
      if (d2 || a.opacity !== e2.opacity) {
        Q2(l2, y2), x2 = true;
        var C = Math.max(Math.min(a.opacity, 1), 0);
        l2.globalAlpha = isNaN(C) ? gO.opacity : C;
      }
      (d2 || a.blend !== e2.blend) && (x2 || (Q2(l2, y2), x2 = true), l2.globalCompositeOperation = a.blend || gO.blend);
      for (var D2 = 0; D2 < Hae.length; D2++) {
        var L = Hae[D2];
        (d2 || a[L] !== e2[L]) && (x2 || (Q2(l2, y2), x2 = true), l2[L] = l2.dpr * (a[L] || 0));
      }
      return (d2 || a.shadowColor !== e2.shadowColor) && (x2 || (Q2(l2, y2), x2 = true), l2.shadowColor = a.shadowColor || gO.shadowColor), x2;
    }
    function Zae(l2, a, e2, d2, y2) {
      var x2 = _rt(a, y2.inHover), C = d2 ? null : e2 && _rt(e2, y2.inHover) || {};
      if (x2 === C)
        return false;
      var D2 = qae(l2, x2, C, d2, y2);
      if ((d2 || x2.fill !== C.fill) && (D2 || (Q2(l2, y2), D2 = true), jae(x2.fill) && (l2.fillStyle = x2.fill)), (d2 || x2.stroke !== C.stroke) && (D2 || (Q2(l2, y2), D2 = true), jae(x2.stroke) && (l2.strokeStyle = x2.stroke)), (d2 || x2.opacity !== C.opacity) && (D2 || (Q2(l2, y2), D2 = true), l2.globalAlpha = x2.opacity == null ? 1 : x2.opacity), a.hasStroke()) {
        var L = x2.lineWidth, F3 = L / (x2.strokeNoScale && a.getLineScale ? a.getLineScale() : 1);
        l2.lineWidth !== F3 && (D2 || (Q2(l2, y2), D2 = true), l2.lineWidth = F3);
      }
      for (var j = 0; j < Uae.length; j++) {
        var U3 = Uae[j], Y3 = U3[0];
        (d2 || x2[Y3] !== C[Y3]) && (D2 || (Q2(l2, y2), D2 = true), l2[Y3] = x2[Y3] || U3[1]);
      }
      return D2;
    }
    function SKe(l2, a, e2, d2, y2) {
      return qae(l2, _rt(a, y2.inHover), e2 && _rt(e2, y2.inHover), d2, y2);
    }
    function $ae(l2, a) {
      var e2 = a.transform, d2 = l2.dpr || 1;
      e2 ? l2.setTransform(d2 * e2[0], d2 * e2[1], d2 * e2[2], d2 * e2[3], d2 * e2[4], d2 * e2[5]) : l2.setTransform(d2, 0, 0, d2, 0, 0);
    }
    function MKe(l2, a, e2) {
      for (var d2 = false, y2 = 0; y2 < l2.length; y2++) {
        var x2 = l2[y2];
        d2 = d2 || x2.isZeroArea(), $ae(a, x2), a.beginPath(), x2.buildPath(a, x2.shape), a.clip();
      }
      e2.allClipped = d2;
    }
    function CKe(l2, a) {
      return l2 && a ? l2[0] !== a[0] || l2[1] !== a[1] || l2[2] !== a[2] || l2[3] !== a[3] || l2[4] !== a[4] || l2[5] !== a[5] : !(!l2 && !a);
    }
    var Yae = 1, Kae = 2, Xae = 3, Qae = 4;
    function TKe(l2) {
      var a = Cyt(l2), e2 = Myt(l2);
      return !(l2.lineDash || !(+a ^ +e2) || a && typeof l2.fill != "string" || e2 && typeof l2.stroke != "string" || l2.strokePercent < 1 || l2.strokeOpacity < 1 || l2.fillOpacity < 1);
    }
    function Q2(l2, a) {
      a.batchFill && l2.fill(), a.batchStroke && l2.stroke(), a.batchFill = "", a.batchStroke = "";
    }
    function _rt(l2, a) {
      return a && l2.__hoverStyle || l2.style;
    }
    function Jae(l2, a) {
      lB(l2, a, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
    }
    function lB(l2, a, e2, d2) {
      var y2 = a.transform;
      if (!a.shouldBePainted(e2.viewWidth, e2.viewHeight, false, false)) {
        a.__dirty &= ~yb2, a.__isRendered = false;
        return;
      }
      var x2 = a.__clipPaths, C = e2.prevElClipPaths, D2 = false, L = false;
      if ((!C || yKe(x2, C)) && (C && C.length && (Q2(l2, e2), l2.restore(), L = D2 = true, e2.prevElClipPaths = null, e2.allClipped = false, e2.prevEl = null), x2 && x2.length && (Q2(l2, e2), l2.save(), MKe(x2, l2, e2), D2 = true), e2.prevElClipPaths = x2), e2.allClipped) {
        a.__isRendered = false;
        return;
      }
      a.beforeBrush && a.beforeBrush(), a.innerBeforeBrush();
      var F3 = e2.prevEl;
      F3 || (L = D2 = true);
      var j = a instanceof wc2 && a.autoBatch && TKe(a.style);
      D2 || CKe(y2, F3.transform) ? (Q2(l2, e2), $ae(l2, a)) : j || Q2(l2, e2);
      var U3 = _rt(a, e2.inHover);
      a instanceof wc2 ? (e2.lastDrawType !== Yae && (L = true, e2.lastDrawType = Yae), Zae(l2, a, F3, L, e2), (!j || !e2.batchFill && !e2.batchStroke) && l2.beginPath(), _Ke(l2, a, U3, j), j && (e2.batchFill = U3.fill || "", e2.batchStroke = U3.stroke || "")) : a instanceof GV ? (e2.lastDrawType !== Xae && (L = true, e2.lastDrawType = Xae), Zae(l2, a, F3, L, e2), wKe(l2, a, U3)) : a instanceof Im ? (e2.lastDrawType !== Kae && (L = true, e2.lastDrawType = Kae), SKe(l2, a, F3, L, e2), xKe(l2, a, U3)) : a.getTemporalDisplayables && (e2.lastDrawType !== Qae && (L = true, e2.lastDrawType = Qae), AKe(l2, a, e2)), j && d2 && Q2(l2, e2), a.innerAfterBrush(), a.afterBrush && a.afterBrush(), e2.prevEl = a, a.__dirty = 0, a.__isRendered = true;
    }
    function AKe(l2, a, e2) {
      var d2 = a.getDisplayables(), y2 = a.getTemporalDisplayables();
      l2.save();
      var x2 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: e2.viewWidth, viewHeight: e2.viewHeight, inHover: e2.inHover }, C, D2;
      for (C = a.getCursor(), D2 = d2.length; C < D2; C++) {
        var L = d2[C];
        L.beforeBrush && L.beforeBrush(), L.innerBeforeBrush(), lB(l2, L, x2, C === D2 - 1), L.innerAfterBrush(), L.afterBrush && L.afterBrush(), x2.prevEl = L;
      }
      for (var F3 = 0, j = y2.length; F3 < j; F3++) {
        var L = y2[F3];
        L.beforeBrush && L.beforeBrush(), L.innerBeforeBrush(), lB(l2, L, x2, F3 === j - 1), L.innerAfterBrush(), L.afterBrush && L.afterBrush(), x2.prevEl = L;
      }
      a.clearTemporalDisplayables(), a.notClear = true, l2.restore();
    }
    var cLt = new oKe(), toe = new TV(100), eoe = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
    function xrt(l2, a) {
      if (l2 === "none")
        return null;
      var e2 = a.getDevicePixelRatio(), d2 = a.getZr(), y2 = d2.painter.type === "svg";
      l2.dirty && cLt.delete(l2);
      var x2 = cLt.get(l2);
      if (x2)
        return x2;
      var C = El(l2, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
      C.backgroundColor === "none" && (C.backgroundColor = null);
      var D2 = { repeat: "repeat" };
      return L(D2), D2.rotation = C.rotation, D2.scaleX = D2.scaleY = y2 ? 1 : 1 / e2, cLt.set(l2, D2), l2.dirty = false, D2;
      function L(F3) {
        for (var j = [e2], U3 = true, Y3 = 0; Y3 < eoe.length; ++Y3) {
          var Q = C[eoe[Y3]];
          if (Q != null && !Ba2(Q) && !ps(Q) && !Ch2(Q) && typeof Q != "boolean") {
            U3 = false;
            break;
          }
          j.push(Q);
        }
        var nt;
        if (U3) {
          nt = j.join(",") + (y2 ? "-svg" : "");
          var dt = toe.get(nt);
          dt && (y2 ? F3.svgElement = dt : F3.image = dt);
        }
        var vt = roe(C.dashArrayX), Ct = IKe(C.dashArrayY), Pt = noe(C.symbol), jt = DKe(vt), Rt = ioe(Ct), le2 = !y2 && Zx.createCanvas(), ne2 = y2 && { tag: "g", attrs: {}, key: "dcl", children: [] }, he2 = Me2(), _e;
        le2 && (le2.width = he2.width * e2, le2.height = he2.height * e2, _e = le2.getContext("2d")), Pe2(), U3 && toe.put(nt, le2 || ne2), F3.image = le2, F3.svgElement = ne2, F3.svgWidth = he2.width, F3.svgHeight = he2.height;
        function Me2() {
          for (var Be2 = 1, Je2 = 0, Ze2 = jt.length; Je2 < Ze2; ++Je2)
            Be2 = uq(Be2, jt[Je2]);
          for (var Cn = 1, Je2 = 0, Ze2 = Pt.length; Je2 < Ze2; ++Je2)
            Cn = uq(Cn, Pt[Je2].length);
          Be2 *= Cn;
          var Bn = Rt * jt.length * Pt.length;
          return { width: Math.max(1, Math.min(Be2, C.maxTileWidth)), height: Math.max(1, Math.min(Bn, C.maxTileHeight)) };
        }
        function Pe2() {
          _e && (_e.clearRect(0, 0, le2.width, le2.height), C.backgroundColor && (_e.fillStyle = C.backgroundColor, _e.fillRect(0, 0, le2.width, le2.height)));
          for (var Be2 = 0, Je2 = 0; Je2 < Ct.length; ++Je2)
            Be2 += Ct[Je2];
          if (Be2 <= 0)
            return;
          for (var Ze2 = -Rt, Cn = 0, Bn = 0, mn = 0; Ze2 < he2.height; ) {
            if (Cn % 2 === 0) {
              for (var Kr = Bn / 2 % Pt.length, Kn = 0, ar = 0, Cr = 0; Kn < he2.width * 2; ) {
                for (var ui2 = 0, Je2 = 0; Je2 < vt[mn].length; ++Je2)
                  ui2 += vt[mn][Je2];
                if (ui2 <= 0)
                  break;
                if (ar % 2 === 0) {
                  var vi2 = (1 - C.symbolSize) * 0.5, ko = Kn + vt[mn][ar] * vi2, Ss = Ze2 + Ct[Cn] * vi2, hl = vt[mn][ar] * C.symbolSize, Qs = Ct[Cn] * C.symbolSize, Js = Cr / 2 % Pt[Kr].length;
                  rs(ko, Ss, hl, Qs, Pt[Kr][Js]);
                }
                Kn += vt[mn][ar], ++Cr, ++ar, ar === vt[mn].length && (ar = 0);
              }
              ++mn, mn === vt.length && (mn = 0);
            }
            Ze2 += Ct[Cn], ++Bn, ++Cn, Cn === Ct.length && (Cn = 0);
          }
          function rs(Gs, al, _s, Fl, Ih2) {
            var lu = y2 ? 1 : e2, ah2 = qy(Ih2, Gs * lu, al * lu, _s * lu, Fl * lu, C.color, C.symbolKeepAspect);
            if (y2) {
              var Uh2 = d2.painter.renderOneToVNode(ah2);
              Uh2 && ne2.children.push(Uh2);
            } else
              Jae(_e, ah2);
          }
        }
      }
    }
    function noe(l2) {
      if (!l2 || l2.length === 0)
        return [["rect"]];
      if (ps(l2))
        return [[l2]];
      for (var a = true, e2 = 0; e2 < l2.length; ++e2)
        if (!ps(l2[e2])) {
          a = false;
          break;
        }
      if (a)
        return noe([l2]);
      for (var d2 = [], e2 = 0; e2 < l2.length; ++e2)
        ps(l2[e2]) ? d2.push([l2[e2]]) : d2.push(l2[e2]);
      return d2;
    }
    function roe(l2) {
      if (!l2 || l2.length === 0)
        return [[0, 0]];
      if (Ch2(l2)) {
        var a = Math.ceil(l2);
        return [[a, a]];
      }
      for (var e2 = true, d2 = 0; d2 < l2.length; ++d2)
        if (!Ch2(l2[d2])) {
          e2 = false;
          break;
        }
      if (e2)
        return roe([l2]);
      for (var y2 = [], d2 = 0; d2 < l2.length; ++d2)
        if (Ch2(l2[d2])) {
          var a = Math.ceil(l2[d2]);
          y2.push([a, a]);
        } else {
          var a = $a2(l2[d2], function(D2) {
            return Math.ceil(D2);
          });
          a.length % 2 === 1 ? y2.push(a.concat(a)) : y2.push(a);
        }
      return y2;
    }
    function IKe(l2) {
      if (!l2 || typeof l2 == "object" && l2.length === 0)
        return [0, 0];
      if (Ch2(l2)) {
        var a = Math.ceil(l2);
        return [a, a];
      }
      var e2 = $a2(l2, function(d2) {
        return Math.ceil(d2);
      });
      return l2.length % 2 ? e2.concat(e2) : e2;
    }
    function DKe(l2) {
      return $a2(l2, function(a) {
        return ioe(a);
      });
    }
    function ioe(l2) {
      for (var a = 0, e2 = 0; e2 < l2.length; ++e2)
        a += l2[e2];
      return l2.length % 2 === 1 ? a * 2 : a;
    }
    function EKe(l2, a) {
      l2.eachRawSeries(function(e2) {
        if (!l2.isSeriesFiltered(e2)) {
          var d2 = e2.getData();
          d2.hasItemVisual() && d2.each(function(C) {
            var D2 = d2.getItemVisual(C, "decal");
            if (D2) {
              var L = d2.ensureUniqueItemVisual(C, "style");
              L.decal = xrt(D2, a);
            }
          });
          var y2 = d2.getVisual("decal");
          if (y2) {
            var x2 = d2.getVisual("style");
            x2.decal = xrt(y2, a);
          }
        }
      });
    }
    var kKe = new Yx(), EE = kKe, aoe = {};
    function PKe(l2, a) {
      aoe[l2] = a;
    }
    function LKe(l2) {
      return aoe[l2];
    }
    var OKe = typeof window != "undefined", RKe = 1, NKe = 800, FKe = 900, VKe = 1e3, BKe = 2e3, zKe = 5e3, ooe = 1e3, jKe = 1100, fLt = 2e3, soe = 3e3, WKe = 4e3, Tyt = 4500, GKe = 4600, HKe = 5e3, UKe = 6e3, loe = 7e3, qKe = { PROCESSOR: { FILTER: VKe, SERIES_FILTER: NKe, STATISTIC: zKe }, VISUAL: { LAYOUT: ooe, PROGRESSIVE_LAYOUT: jKe, GLOBAL: fLt, CHART: soe, POST_CHART_LAYOUT: GKe, COMPONENT: WKe, BRUSH: HKe, CHART_ITEM: Tyt, ARIA: UKe, DECAL: loe } }, uw = "__flagInMainProcess", J2 = "__pendingUpdate", hLt = "__needsUpdateStatus", uoe = /^[a-zA-Z0-9_]+$/, pLt = "__connectUpdateStatus", coe = 0, ZKe = 1, $Ke = 2;
    function foe(l2) {
      return function() {
        for (var a = [], e2 = 0; e2 < arguments.length; e2++)
          a[e2] = arguments[e2];
        if (this.isDisposed()) {
          this.id;
          return;
        }
        return poe(this, l2, a);
      };
    }
    function hoe(l2) {
      return function() {
        for (var a = [], e2 = 0; e2 < arguments.length; e2++)
          a[e2] = arguments[e2];
        return poe(this, l2, a);
      };
    }
    function poe(l2, a, e2) {
      return e2[0] = e2[0] && e2[0].toLowerCase(), Yx.prototype[a].apply(l2, e2);
    }
    var doe = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a;
    }(Yx), goe = doe.prototype;
    goe.on = hoe("on"), goe.off = hoe("off");
    var nZ, dLt, Ayt, QN, gLt, vLt, yLt, wrt, Srt, voe, yoe, mLt, moe, Iyt, boe, _oe, AA, xoe, woe = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this, new JYe()) || this;
        x2._chartsViews = [], x2._chartsMap = {}, x2._componentsViews = [], x2._componentsMap = {}, x2._pendingActions = [], y2 = y2 || {}, ps(d2) && (d2 = Soe[d2]), x2._dom = e2;
        var C = "canvas", D2 = false, L = x2._zr = ent(e2, { renderer: y2.renderer || C, devicePixelRatio: y2.devicePixelRatio, width: y2.width, height: y2.height, ssr: y2.ssr, useDirtyRect: y2.useDirtyRect == null ? D2 : y2.useDirtyRect });
        x2._ssr = y2.ssr, x2._throttledZrFlush = iLt(As(L.flush, L), 17), d2 = zl(d2), d2 && Vie(d2, true), x2._theme = d2, x2._locale = i$e(y2.locale || Kre), x2._coordSysMgr = new urt();
        var F3 = x2._api = boe(x2);
        function j(U3, Y3) {
          return U3.__prio - Y3.__prio;
        }
        return XL(Eyt, j), XL(_Lt, j), x2._scheduler = new Lae(x2, F3, _Lt, Eyt), x2._messageCenter = new doe(), x2._initEvents(), x2.resize = As(x2.resize, x2), L.animation.on("frame", x2._onframe, x2), voe(L, x2), yoe(L, x2), gV(x2), x2;
      }
      return a.prototype._onframe = function() {
        if (!this._disposed) {
          xoe(this);
          var e2 = this._scheduler;
          if (this[J2]) {
            var d2 = this[J2].silent;
            this[uw] = true;
            try {
              nZ(this), QN.update.call(this, null, this[J2].updateParams);
            } catch (L) {
              throw this[uw] = false, this[J2] = null, L;
            }
            this._zr.flush(), this[uw] = false, this[J2] = null, wrt.call(this, d2), Srt.call(this, d2);
          } else if (e2.unfinished) {
            var y2 = RKe, x2 = this._model, C = this._api;
            e2.unfinished = false;
            do {
              var D2 = +new Date();
              e2.performSeriesTasks(x2), e2.performDataProcessorTasks(x2), vLt(this, x2), e2.performVisualTasks(x2), Iyt(this, this._model, C, "remain", {}), y2 -= +new Date() - D2;
            } while (y2 > 0 && e2.unfinished);
            e2.unfinished || this._zr.flush();
          }
        }
      }, a.prototype.getDom = function() {
        return this._dom;
      }, a.prototype.getId = function() {
        return this.id;
      }, a.prototype.getZr = function() {
        return this._zr;
      }, a.prototype.isSSR = function() {
        return this._ssr;
      }, a.prototype.setOption = function(e2, d2, y2) {
        if (!this[uw]) {
          if (this._disposed) {
            this.id;
            return;
          }
          var x2, C, D2;
          if (vs(d2) && (y2 = d2.lazyUpdate, x2 = d2.silent, C = d2.replaceMerge, D2 = d2.transition, d2 = d2.notMerge), this[uw] = true, !this._model || d2) {
            var L = new V$e(this._api), F3 = this._theme, j = this._model = new Eie();
            j.scheduler = this._scheduler, j.ssr = this._ssr, j.init(null, null, null, F3, this._locale, L);
          }
          this._model.setOption(e2, { replaceMerge: C }, xLt);
          var U3 = { seriesTransition: D2, optionChanged: true };
          if (y2)
            this[J2] = { silent: x2, updateParams: U3 }, this[uw] = false, this.getZr().wakeUp();
          else {
            try {
              nZ(this), QN.update.call(this, null, U3);
            } catch (Y3) {
              throw this[J2] = null, this[uw] = false, Y3;
            }
            this._ssr || this._zr.flush(), this[J2] = null, this[uw] = false, wrt.call(this, x2), Srt.call(this, x2);
          }
        }
      }, a.prototype.setTheme = function() {
      }, a.prototype.getModel = function() {
        return this._model;
      }, a.prototype.getOption = function() {
        return this._model && this._model.getOption();
      }, a.prototype.getWidth = function() {
        return this._zr.getWidth();
      }, a.prototype.getHeight = function() {
        return this._zr.getHeight();
      }, a.prototype.getDevicePixelRatio = function() {
        return this._zr.painter.dpr || OKe && window.devicePixelRatio || 1;
      }, a.prototype.getRenderedCanvas = function(e2) {
        return this.renderToCanvas(e2);
      }, a.prototype.renderToCanvas = function(e2) {
        e2 = e2 || {};
        var d2 = this._zr.painter;
        return d2.getRenderedCanvas({ backgroundColor: e2.backgroundColor || this._model.get("backgroundColor"), pixelRatio: e2.pixelRatio || this.getDevicePixelRatio() });
      }, a.prototype.renderToSVGString = function(e2) {
        e2 = e2 || {};
        var d2 = this._zr.painter;
        return d2.renderToString({ useViewBox: e2.useViewBox });
      }, a.prototype.getSvgDataURL = function() {
        if ($s.svgSupported) {
          var e2 = this._zr, d2 = e2.storage.getDisplayList();
          return Ke2(d2, function(y2) {
            y2.stopAnimation(null, true);
          }), e2.painter.toDataURL();
        }
      }, a.prototype.getDataURL = function(e2) {
        if (this._disposed) {
          this.id;
          return;
        }
        e2 = e2 || {};
        var d2 = e2.excludeComponents, y2 = this._model, x2 = [], C = this;
        Ke2(d2, function(L) {
          y2.eachComponent({ mainType: L }, function(F3) {
            var j = C._componentsMap[F3.__viewId];
            j.group.ignore || (x2.push(j), j.group.ignore = true);
          });
        });
        var D2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(e2).toDataURL("image/" + (e2 && e2.type || "png"));
        return Ke2(x2, function(L) {
          L.group.ignore = false;
        }), D2;
      }, a.prototype.getConnectedDataURL = function(e2) {
        if (this._disposed) {
          this.id;
          return;
        }
        var d2 = e2.type === "svg", y2 = this.group, x2 = Math.min, C = Math.max, D2 = 1 / 0;
        if (Moe[y2]) {
          var L = D2, F3 = D2, j = -D2, U3 = -D2, Y3 = [], Q = e2 && e2.pixelRatio || this.getDevicePixelRatio();
          Ke2(Crt, function(jt, Rt) {
            if (jt.group === y2) {
              var le2 = d2 ? jt.getZr().painter.getSvgDom().innerHTML : jt.renderToCanvas(zl(e2)), ne2 = jt.getDom().getBoundingClientRect();
              L = x2(ne2.left, L), F3 = x2(ne2.top, F3), j = C(ne2.right, j), U3 = C(ne2.bottom, U3), Y3.push({ dom: le2, left: ne2.left, top: ne2.top });
            }
          }), L *= Q, F3 *= Q, j *= Q, U3 *= Q;
          var nt = j - L, dt = U3 - F3, vt = Zx.createCanvas(), Ct = ent(vt, { renderer: d2 ? "svg" : "canvas" });
          if (Ct.resize({ width: nt, height: dt }), d2) {
            var Pt = "";
            return Ke2(Y3, function(jt) {
              var Rt = jt.left - L, le2 = jt.top - F3;
              Pt += '<g transform="translate(' + Rt + "," + le2 + ')">' + jt.dom + "</g>";
            }), Ct.painter.getSvgRoot().innerHTML = Pt, e2.connectedBackgroundColor && Ct.painter.setBackgroundColor(e2.connectedBackgroundColor), Ct.refreshImmediately(), Ct.painter.toDataURL();
          } else
            return e2.connectedBackgroundColor && Ct.add(new Nf2({ shape: { x: 0, y: 0, width: nt, height: dt }, style: { fill: e2.connectedBackgroundColor } })), Ke2(Y3, function(jt) {
              var Rt = new Im({ style: { x: jt.left * Q - L, y: jt.top * Q - F3, image: jt.dom } });
              Ct.add(Rt);
            }), Ct.refreshImmediately(), vt.toDataURL("image/" + (e2 && e2.type || "png"));
        } else
          return this.getDataURL(e2);
      }, a.prototype.convertToPixel = function(e2, d2) {
        return gLt(this, "convertToPixel", e2, d2);
      }, a.prototype.convertFromPixel = function(e2, d2) {
        return gLt(this, "convertFromPixel", e2, d2);
      }, a.prototype.containPixel = function(e2, d2) {
        if (this._disposed) {
          this.id;
          return;
        }
        var y2 = this._model, x2, C = VV(y2, e2);
        return Ke2(C, function(D2, L) {
          L.indexOf("Models") >= 0 && Ke2(D2, function(F3) {
            var j = F3.coordinateSystem;
            if (j && j.containPoint)
              x2 = x2 || !!j.containPoint(d2);
            else if (L === "seriesModels") {
              var U3 = this._chartsMap[F3.__viewId];
              U3 && U3.containPoint && (x2 = x2 || U3.containPoint(d2, F3));
            }
          }, this);
        }, this), !!x2;
      }, a.prototype.getVisual = function(e2, d2) {
        var y2 = this._model, x2 = VV(y2, e2, { defaultMainType: "series" }), C = x2.seriesModel, D2 = C.getData(), L = x2.hasOwnProperty("dataIndexInside") ? x2.dataIndexInside : x2.hasOwnProperty("dataIndex") ? D2.indexOfRawIndex(x2.dataIndex) : null;
        return L != null ? oLt(D2, L, d2) : mrt(D2, d2);
      }, a.prototype.getViewOfComponentModel = function(e2) {
        return this._componentsMap[e2.__viewId];
      }, a.prototype.getViewOfSeriesModel = function(e2) {
        return this._chartsMap[e2.__viewId];
      }, a.prototype._initEvents = function() {
        var e2 = this;
        Ke2(YKe, function(d2) {
          var y2 = function(x2) {
            var C = e2.getModel(), D2 = x2.target, L, F3 = d2 === "globalout";
            if (F3 ? L = {} : D2 && Jq(D2, function(nt) {
              var dt = ns(nt);
              if (dt && dt.dataIndex != null) {
                var vt = dt.dataModel || C.getSeriesByIndex(dt.seriesIndex);
                return L = vt && vt.getDataParams(dt.dataIndex, dt.dataType) || {}, true;
              } else if (dt.eventData)
                return L = la2({}, dt.eventData), true;
            }, true), L) {
              var j = L.componentType, U3 = L.componentIndex;
              (j === "markLine" || j === "markPoint" || j === "markArea") && (j = "series", U3 = L.seriesIndex);
              var Y3 = j && U3 != null && C.getComponent(j, U3), Q = Y3 && e2[Y3.mainType === "series" ? "_chartsMap" : "_componentsMap"][Y3.__viewId];
              L.event = x2, L.type = d2, e2._$eventProcessor.eventInfo = { targetEl: D2, packedEvent: L, model: Y3, view: Q }, e2.trigger(d2, L);
            }
          };
          y2.zrEventfulCallAtLast = true, e2._zr.on(d2, y2, e2);
        }), Ke2(Mrt, function(d2, y2) {
          e2._messageCenter.on(y2, function(x2) {
            this.trigger(y2, x2);
          }, e2);
        }), Ke2(["selectchanged"], function(d2) {
          e2._messageCenter.on(d2, function(y2) {
            this.trigger(d2, y2);
          }, e2);
        }), nKe(this._messageCenter, this, this._api);
      }, a.prototype.isDisposed = function() {
        return this._disposed;
      }, a.prototype.clear = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this.setOption({ series: [] }, true);
      }, a.prototype.dispose = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this._disposed = true;
        var e2 = this.getDom();
        e2 && ant(this.getDom(), SLt, "");
        var d2 = this, y2 = d2._api, x2 = d2._model;
        Ke2(d2._componentsViews, function(C) {
          C.dispose(x2, y2);
        }), Ke2(d2._chartsViews, function(C) {
          C.dispose(x2, y2);
        }), d2._zr.dispose(), d2._dom = d2._model = d2._chartsMap = d2._componentsMap = d2._chartsViews = d2._componentsViews = d2._scheduler = d2._api = d2._zr = d2._throttledZrFlush = d2._theme = d2._coordSysMgr = d2._messageCenter = null, delete Crt[d2.id];
      }, a.prototype.resize = function(e2) {
        if (!this[uw]) {
          if (this._disposed) {
            this.id;
            return;
          }
          this._zr.resize(e2);
          var d2 = this._model;
          if (this._loadingFX && this._loadingFX.resize(), !!d2) {
            var y2 = d2.resetOption("media"), x2 = e2 && e2.silent;
            this[J2] && (x2 == null && (x2 = this[J2].silent), y2 = true, this[J2] = null), this[uw] = true;
            try {
              y2 && nZ(this), QN.update.call(this, { type: "resize", animation: la2({ duration: 0 }, e2 && e2.animation) });
            } catch (C) {
              throw this[uw] = false, C;
            }
            this[uw] = false, wrt.call(this, x2), Srt.call(this, x2);
          }
        }
      }, a.prototype.showLoading = function(e2, d2) {
        if (this._disposed) {
          this.id;
          return;
        }
        if (vs(e2) && (d2 = e2, e2 = ""), e2 = e2 || "default", this.hideLoading(), !!wLt[e2]) {
          var y2 = wLt[e2](this._api, d2), x2 = this._zr;
          this._loadingFX = y2, x2.add(y2);
        }
      }, a.prototype.hideLoading = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
      }, a.prototype.makeActionFromEvent = function(e2) {
        var d2 = la2({}, e2);
        return d2.type = Mrt[e2.type], d2;
      }, a.prototype.dispatchAction = function(e2, d2) {
        if (this._disposed) {
          this.id;
          return;
        }
        if (vs(d2) || (d2 = { silent: !!d2 }), !!Dyt[e2.type] && !!this._model) {
          if (this[uw]) {
            this._pendingActions.push(e2);
            return;
          }
          var y2 = d2.silent;
          yLt.call(this, e2, y2);
          var x2 = d2.flush;
          x2 ? this._zr.flush() : x2 !== false && $s.browser.weChat && this._throttledZrFlush(), wrt.call(this, y2), Srt.call(this, y2);
        }
      }, a.prototype.updateLabelLayout = function() {
        EE.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
      }, a.prototype.appendData = function(e2) {
        if (this._disposed) {
          this.id;
          return;
        }
        var d2 = e2.seriesIndex, y2 = this.getModel(), x2 = y2.getSeriesByIndex(d2);
        x2.appendData(e2), this._scheduler.unfinished = true, this.getZr().wakeUp();
      }, a.internalField = function() {
        nZ = function(U3) {
          var Y3 = U3._scheduler;
          Y3.restorePipelines(U3._model), Y3.prepareStageTasks(), dLt(U3, true), dLt(U3, false), Y3.plan();
        }, dLt = function(U3, Y3) {
          for (var Q = U3._model, nt = U3._scheduler, dt = Y3 ? U3._componentsViews : U3._chartsViews, vt = Y3 ? U3._componentsMap : U3._chartsMap, Ct = U3._zr, Pt = U3._api, jt = 0; jt < dt.length; jt++)
            dt[jt].__alive = false;
          Y3 ? Q.eachComponent(function(ne2, he2) {
            ne2 !== "series" && Rt(he2);
          }) : Q.eachSeries(Rt);
          function Rt(ne2) {
            var he2 = ne2.__requireNewView;
            ne2.__requireNewView = false;
            var _e = "_ec_" + ne2.id + "_" + ne2.type, Me2 = !he2 && vt[_e];
            if (!Me2) {
              var Pe2 = NS(ne2.type), Be2 = Y3 ? _0.getClass(Pe2.main, Pe2.sub) : pg2.getClass(Pe2.sub);
              Me2 = new Be2(), Me2.init(Q, Pt), vt[_e] = Me2, dt.push(Me2), Ct.add(Me2.group);
            }
            ne2.__viewId = Me2.__id = _e, Me2.__alive = true, Me2.__model = ne2, Me2.group.__ecComponentInfo = { mainType: ne2.mainType, index: ne2.componentIndex }, !Y3 && nt.prepareView(Me2, ne2, Q, Pt);
          }
          for (var jt = 0; jt < dt.length; ) {
            var le2 = dt[jt];
            le2.__alive ? jt++ : (!Y3 && le2.renderTask.dispose(), Ct.remove(le2.group), le2.dispose(Q, Pt), dt.splice(jt, 1), vt[le2.__id] === le2 && delete vt[le2.__id], le2.__id = le2.group.__ecComponentInfo = null);
          }
        }, Ayt = function(U3, Y3, Q, nt, dt) {
          var vt = U3._model;
          if (vt.setUpdatePayload(Q), !nt) {
            Ke2([].concat(U3._componentsViews).concat(U3._chartsViews), le2);
            return;
          }
          var Ct = {};
          Ct[nt + "Id"] = Q[nt + "Id"], Ct[nt + "Index"] = Q[nt + "Index"], Ct[nt + "Name"] = Q[nt + "Name"];
          var Pt = { mainType: nt, query: Ct };
          dt && (Pt.subType = dt);
          var jt = Q.excludeSeriesId, Rt;
          jt != null && (Rt = fl(), Ke2(Mp(jt), function(ne2) {
            var he2 = Ud2(ne2, null);
            he2 != null && Rt.set(he2, true);
          })), vt && vt.eachComponent(Pt, function(ne2) {
            var he2 = Rt && Rt.get(ne2.id) !== null;
            if (!he2)
              if (Hy(Q))
                if (ne2 instanceof Pv)
                  Q.type === R_ && !Q.notBlur && !ne2.get(["emphasis", "disabled"]) && zPt(ne2, Q, U3._api);
                else {
                  var _e = Bnt(ne2.mainType, ne2.componentIndex, Q.name, U3._api), Me2 = _e.focusSelf, Pe2 = _e.dispatchers;
                  Q.type === R_ && Me2 && !Q.notBlur && zN(ne2.mainType, ne2.componentIndex, U3._api), Pe2 && Ke2(Pe2, function(Be2) {
                    Q.type === R_ ? Dm(Be2) : fc2(Be2);
                  });
                }
              else
                jnt(Q) && ne2 instanceof Pv && (GPt(ne2, Q, U3._api), k0t(ne2), AA(U3));
          }, U3), vt && vt.eachComponent(Pt, function(ne2) {
            var he2 = Rt && Rt.get(ne2.id) !== null;
            he2 || le2(U3[nt === "series" ? "_chartsMap" : "_componentsMap"][ne2.__viewId]);
          }, U3);
          function le2(ne2) {
            ne2 && ne2.__alive && ne2[Y3] && ne2[Y3](ne2.__model, vt, U3._api, Q);
          }
        }, QN = { prepareAndUpdate: function(U3) {
          nZ(this), QN.update.call(this, U3, { optionChanged: U3.newOption != null });
        }, update: function(U3, Y3) {
          var Q = this._model, nt = this._api, dt = this._zr, vt = this._coordSysMgr, Ct = this._scheduler;
          if (Q) {
            Q.setUpdatePayload(U3), Ct.restoreData(Q, U3), Ct.performSeriesTasks(Q), vt.create(Q, nt), Ct.performDataProcessorTasks(Q, U3), vLt(this, Q), vt.update(Q, nt), e2(Q), Ct.performVisualTasks(Q, U3), mLt(this, Q, nt, U3, Y3);
            var Pt = Q.get("backgroundColor") || "transparent", jt = Q.get("darkMode");
            dt.setBackgroundColor(Pt), jt != null && jt !== "auto" && dt.setDarkMode(jt), EE.trigger("afterupdate", Q, nt);
          }
        }, updateTransform: function(U3) {
          var Y3 = this, Q = this._model, nt = this._api;
          if (Q) {
            Q.setUpdatePayload(U3);
            var dt = [];
            Q.eachComponent(function(Ct, Pt) {
              if (Ct !== "series") {
                var jt = Y3.getViewOfComponentModel(Pt);
                if (jt && jt.__alive)
                  if (jt.updateTransform) {
                    var Rt = jt.updateTransform(Pt, Q, nt, U3);
                    Rt && Rt.update && dt.push(jt);
                  } else
                    dt.push(jt);
              }
            });
            var vt = fl();
            Q.eachSeries(function(Ct) {
              var Pt = Y3._chartsMap[Ct.__viewId];
              if (Pt.updateTransform) {
                var jt = Pt.updateTransform(Ct, Q, nt, U3);
                jt && jt.update && vt.set(Ct.uid, 1);
              } else
                vt.set(Ct.uid, 1);
            }), e2(Q), this._scheduler.performVisualTasks(Q, U3, { setDirty: true, dirtyMap: vt }), Iyt(this, Q, nt, U3, {}, vt), EE.trigger("afterupdate", Q, nt);
          }
        }, updateView: function(U3) {
          var Y3 = this._model;
          !Y3 || (Y3.setUpdatePayload(U3), pg2.markUpdateMethod(U3, "updateView"), e2(Y3), this._scheduler.performVisualTasks(Y3, U3, { setDirty: true }), mLt(this, Y3, this._api, U3, {}), EE.trigger("afterupdate", Y3, this._api));
        }, updateVisual: function(U3) {
          var Y3 = this, Q = this._model;
          !Q || (Q.setUpdatePayload(U3), Q.eachSeries(function(nt) {
            nt.getData().clearAllVisual();
          }), pg2.markUpdateMethod(U3, "updateVisual"), e2(Q), this._scheduler.performVisualTasks(Q, U3, { visualType: "visual", setDirty: true }), Q.eachComponent(function(nt, dt) {
            if (nt !== "series") {
              var vt = Y3.getViewOfComponentModel(dt);
              vt && vt.__alive && vt.updateVisual(dt, Q, Y3._api, U3);
            }
          }), Q.eachSeries(function(nt) {
            var dt = Y3._chartsMap[nt.__viewId];
            dt.updateVisual(nt, Q, Y3._api, U3);
          }), EE.trigger("afterupdate", Q, this._api));
        }, updateLayout: function(U3) {
          QN.update.call(this, U3);
        } }, gLt = function(U3, Y3, Q, nt) {
          if (U3._disposed) {
            U3.id;
            return;
          }
          for (var dt = U3._model, vt = U3._coordSysMgr.getCoordinateSystems(), Ct, Pt = VV(dt, Q), jt = 0; jt < vt.length; jt++) {
            var Rt = vt[jt];
            if (Rt[Y3] && (Ct = Rt[Y3](dt, Pt, nt)) != null)
              return Ct;
          }
        }, vLt = function(U3, Y3) {
          var Q = U3._chartsMap, nt = U3._scheduler;
          Y3.eachSeries(function(dt) {
            nt.updateStreamModes(dt, Q[dt.__viewId]);
          });
        }, yLt = function(U3, Y3) {
          var Q = this, nt = this.getModel(), dt = U3.type, vt = U3.escapeConnect, Ct = Dyt[dt], Pt = Ct.actionInfo, jt = (Pt.update || "update").split(":"), Rt = jt.pop(), le2 = jt[0] != null && NS(jt[0]);
          this[uw] = true;
          var ne2 = [U3], he2 = false;
          U3.batch && (he2 = true, ne2 = $a2(U3.batch, function(Cn) {
            return Cn = El(la2({}, Cn), U3), Cn.batch = null, Cn;
          }));
          var _e = [], Me2, Pe2 = jnt(U3), Be2 = Hy(U3);
          if (Be2 && E0t(this._api), Ke2(ne2, function(Cn) {
            if (Me2 = Ct.action(Cn, Q._model, Q._api), Me2 = Me2 || la2({}, Cn), Me2.type = Pt.event || Me2.type, _e.push(Me2), Be2) {
              var Bn = int(U3), mn = Bn.queryOptionMap, Kr = Bn.mainTypeSpecified, Kn = Kr ? mn.keys()[0] : "series";
              Ayt(Q, Rt, Cn, Kn), AA(Q);
            } else
              Pe2 ? (Ayt(Q, Rt, Cn, "series"), AA(Q)) : le2 && Ayt(Q, Rt, Cn, le2.main, le2.sub);
          }), Rt !== "none" && !Be2 && !Pe2 && !le2)
            try {
              this[J2] ? (nZ(this), QN.update.call(this, U3), this[J2] = null) : QN[Rt].call(this, U3);
            } catch (Cn) {
              throw this[uw] = false, Cn;
            }
          if (he2 ? Me2 = { type: Pt.event || dt, escapeConnect: vt, batch: _e } : Me2 = _e[0], this[uw] = false, !Y3) {
            var Je2 = this._messageCenter;
            if (Je2.trigger(Me2.type, Me2), Pe2) {
              var Ze2 = { type: "selectchanged", escapeConnect: vt, selected: HPt(nt), isFromClick: U3.isFromClick || false, fromAction: U3.type, fromActionPayload: U3 };
              Je2.trigger(Ze2.type, Ze2);
            }
          }
        }, wrt = function(U3) {
          for (var Y3 = this._pendingActions; Y3.length; ) {
            var Q = Y3.shift();
            yLt.call(this, Q, U3);
          }
        }, Srt = function(U3) {
          !U3 && this.trigger("updated");
        }, voe = function(U3, Y3) {
          U3.on("rendered", function(Q) {
            Y3.trigger("rendered", Q), U3.animation.isFinished() && !Y3[J2] && !Y3._scheduler.unfinished && !Y3._pendingActions.length && Y3.trigger("finished");
          });
        }, yoe = function(U3, Y3) {
          U3.on("mouseover", function(Q) {
            var nt = Q.target, dt = Jq(nt, TO);
            dt && (jPt(dt, Q, Y3._api), AA(Y3));
          }).on("mouseout", function(Q) {
            var nt = Q.target, dt = Jq(nt, TO);
            dt && (WPt(dt, Q, Y3._api), AA(Y3));
          }).on("click", function(Q) {
            var nt = Q.target, dt = Jq(nt, function(Pt) {
              return ns(Pt).dataIndex != null;
            }, true);
            if (dt) {
              var vt = dt.selected ? "unselect" : "select", Ct = ns(dt);
              Y3._api.dispatchAction({ type: vt, dataType: Ct.dataType, dataIndexInside: Ct.dataIndex, seriesIndex: Ct.seriesIndex, isFromClick: true });
            }
          });
        };
        function e2(U3) {
          U3.clearColorPalette(), U3.eachSeries(function(Y3) {
            Y3.clearColorPalette();
          });
        }
        function d2(U3) {
          var Y3 = [], Q = [], nt = false;
          if (U3.eachComponent(function(Pt, jt) {
            var Rt = jt.get("zlevel") || 0, le2 = jt.get("z") || 0, ne2 = jt.getZLevelKey();
            nt = nt || !!ne2, (Pt === "series" ? Q : Y3).push({ zlevel: Rt, z: le2, idx: jt.componentIndex, type: Pt, key: ne2 });
          }), nt) {
            var dt = Y3.concat(Q), vt, Ct;
            XL(dt, function(Pt, jt) {
              return Pt.zlevel === jt.zlevel ? Pt.z - jt.z : Pt.zlevel - jt.zlevel;
            }), Ke2(dt, function(Pt) {
              var jt = U3.getComponent(Pt.type, Pt.idx), Rt = Pt.zlevel, le2 = Pt.key;
              vt != null && (Rt = Math.max(vt, Rt)), le2 ? (Rt === vt && le2 !== Ct && Rt++, Ct = le2) : Ct && (Rt === vt && Rt++, Ct = ""), vt = Rt, jt.setZLevel(Rt);
            });
          }
        }
        mLt = function(U3, Y3, Q, nt, dt) {
          d2(Y3), moe(U3, Y3, Q, nt, dt), Ke2(U3._chartsViews, function(vt) {
            vt.__alive = false;
          }), Iyt(U3, Y3, Q, nt, dt), Ke2(U3._chartsViews, function(vt) {
            vt.__alive || vt.remove(Y3, Q);
          });
        }, moe = function(U3, Y3, Q, nt, dt, vt) {
          Ke2(vt || U3._componentsViews, function(Ct) {
            var Pt = Ct.__model;
            F3(Pt, Ct), Ct.render(Pt, Y3, Q, nt), D2(Pt, Ct), j(Pt, Ct);
          });
        }, Iyt = function(U3, Y3, Q, nt, dt, vt) {
          var Ct = U3._scheduler;
          dt = la2(dt || {}, { updatedSeries: Y3.getSeries() }), EE.trigger("series:beforeupdate", Y3, Q, dt);
          var Pt = false;
          Y3.eachSeries(function(jt) {
            var Rt = U3._chartsMap[jt.__viewId];
            Rt.__alive = true;
            var le2 = Rt.renderTask;
            Ct.updatePayload(le2, nt), F3(jt, Rt), vt && vt.get(jt.uid) && le2.dirty(), le2.perform(Ct.getPerformArgs(le2)) && (Pt = true), Rt.group.silent = !!jt.get("silent"), C(jt, Rt), k0t(jt);
          }), Ct.unfinished = Pt || Ct.unfinished, EE.trigger("series:layoutlabels", Y3, Q, dt), EE.trigger("series:transition", Y3, Q, dt), Y3.eachSeries(function(jt) {
            var Rt = U3._chartsMap[jt.__viewId];
            D2(jt, Rt), j(jt, Rt);
          }), x2(U3, Y3), EE.trigger("series:afterupdate", Y3, Q, dt);
        }, AA = function(U3) {
          U3[hLt] = true, U3.getZr().wakeUp();
        }, xoe = function(U3) {
          !U3[hLt] || (U3.getZr().storage.traverse(function(Y3) {
            UN(Y3) || y2(Y3);
          }), U3[hLt] = false);
        };
        function y2(U3) {
          for (var Y3 = [], Q = U3.currentStates, nt = 0; nt < Q.length; nt++) {
            var dt = Q[nt];
            dt === "emphasis" || dt === "blur" || dt === "select" || Y3.push(dt);
          }
          U3.selected && U3.states.select && Y3.push("select"), U3.hoverState === Sq && U3.states.emphasis ? Y3.push("emphasis") : U3.hoverState === HV && U3.states.blur && Y3.push("blur"), U3.useStates(Y3);
        }
        function x2(U3, Y3) {
          var Q = U3._zr, nt = Q.storage, dt = 0;
          nt.traverse(function(vt) {
            vt.isGroup || dt++;
          }), dt > Y3.get("hoverLayerThreshold") && !$s.node && !$s.worker && Y3.eachSeries(function(vt) {
            if (!vt.preventUsingHoverLayer) {
              var Ct = U3._chartsMap[vt.__viewId];
              Ct.__alive && Ct.eachRendered(function(Pt) {
                Pt.states.emphasis && (Pt.states.emphasis.hoverLayer = true);
              });
            }
          });
        }
        function C(U3, Y3) {
          var Q = U3.get("blendMode") || null;
          Y3.eachRendered(function(nt) {
            nt.isGroup || (nt.style.blend = Q);
          });
        }
        function D2(U3, Y3) {
          if (!U3.preventAutoZ) {
            var Q = U3.get("z") || 0, nt = U3.get("zlevel") || 0;
            Y3.eachRendered(function(dt) {
              return L(dt, Q, nt, -1 / 0), true;
            });
          }
        }
        function L(U3, Y3, Q, nt) {
          var dt = U3.getTextContent(), vt = U3.getTextGuideLine(), Ct = U3.isGroup;
          if (Ct)
            for (var Pt = U3.childrenRef(), jt = 0; jt < Pt.length; jt++)
              nt = Math.max(L(Pt[jt], Y3, Q, nt), nt);
          else
            U3.z = Y3, U3.zlevel = Q, nt = Math.max(U3.z2, nt);
          if (dt && (dt.z = Y3, dt.zlevel = Q, isFinite(nt) && (dt.z2 = nt + 2)), vt) {
            var Rt = U3.textGuideLineConfig;
            vt.z = Y3, vt.zlevel = Q, isFinite(nt) && (vt.z2 = nt + (Rt && Rt.showAbove ? 1 : -1));
          }
          return nt;
        }
        function F3(U3, Y3) {
          Y3.eachRendered(function(Q) {
            if (!UN(Q)) {
              var nt = Q.getTextContent(), dt = Q.getTextGuideLine();
              Q.stateTransition && (Q.stateTransition = null), nt && nt.stateTransition && (nt.stateTransition = null), dt && dt.stateTransition && (dt.stateTransition = null), Q.hasState() ? (Q.prevStates = Q.currentStates, Q.clearStates()) : Q.prevStates && (Q.prevStates = null);
            }
          });
        }
        function j(U3, Y3) {
          var Q = U3.getModel("stateAnimation"), nt = U3.isAnimationEnabled(), dt = Q.get("duration"), vt = dt > 0 ? { duration: dt, delay: Q.get("delay"), easing: Q.get("easing") } : null;
          Y3.eachRendered(function(Ct) {
            if (Ct.states && Ct.states.emphasis) {
              if (UN(Ct))
                return;
              if (Ct instanceof wc2 && ew(Ct), Ct.__dirty) {
                var Pt = Ct.prevStates;
                Pt && Ct.useStates(Pt);
              }
              if (nt) {
                Ct.stateTransition = vt;
                var jt = Ct.getTextContent(), Rt = Ct.getTextGuideLine();
                jt && (jt.stateTransition = vt), Rt && (Rt.stateTransition = vt);
              }
              Ct.__dirty && y2(Ct);
            }
          });
        }
        boe = function(U3) {
          return new (function(Y3) {
            Jn(Q, Y3);
            function Q() {
              return Y3 !== null && Y3.apply(this, arguments) || this;
            }
            return Q.prototype.getCoordinateSystems = function() {
              return U3._coordSysMgr.getCoordinateSystems();
            }, Q.prototype.getComponentByElement = function(nt) {
              for (; nt; ) {
                var dt = nt.__ecComponentInfo;
                if (dt != null)
                  return U3._model.getComponent(dt.mainType, dt.index);
                nt = nt.parent;
              }
            }, Q.prototype.enterEmphasis = function(nt, dt) {
              Dm(nt, dt), AA(U3);
            }, Q.prototype.leaveEmphasis = function(nt, dt) {
              fc2(nt, dt), AA(U3);
            }, Q.prototype.enterBlur = function(nt) {
              Fnt(nt), AA(U3);
            }, Q.prototype.leaveBlur = function(nt) {
              VS(nt), AA(U3);
            }, Q.prototype.enterSelect = function(nt) {
              Vnt(nt), AA(U3);
            }, Q.prototype.leaveSelect = function(nt) {
              D0t(nt), AA(U3);
            }, Q.prototype.getModel = function() {
              return U3.getModel();
            }, Q.prototype.getViewOfComponentModel = function(nt) {
              return U3.getViewOfComponentModel(nt);
            }, Q.prototype.getViewOfSeriesModel = function(nt) {
              return U3.getViewOfSeriesModel(nt);
            }, Q;
          }(kie))(U3);
        }, _oe = function(U3) {
          function Y3(Q, nt) {
            for (var dt = 0; dt < Q.length; dt++) {
              var vt = Q[dt];
              vt[pLt] = nt;
            }
          }
          Ke2(Mrt, function(Q, nt) {
            U3._messageCenter.on(nt, function(dt) {
              if (Moe[U3.group] && U3[pLt] !== coe) {
                if (dt && dt.escapeConnect)
                  return;
                var vt = U3.makeActionFromEvent(dt), Ct = [];
                Ke2(Crt, function(Pt) {
                  Pt !== U3 && Pt.group === U3.group && Ct.push(Pt);
                }), Y3(Ct, coe), Ke2(Ct, function(Pt) {
                  Pt[pLt] !== ZKe && Pt.dispatchAction(vt);
                }), Y3(Ct, $Ke);
              }
            });
          });
        };
      }(), a;
    }(Yx), bLt = woe.prototype;
    bLt.on = foe("on"), bLt.off = foe("off"), bLt.one = function(l2, a, e2) {
      var d2 = this;
      function y2() {
        for (var x2 = [], C = 0; C < arguments.length; C++)
          x2[C] = arguments[C];
        a && a.apply && a.apply(this, x2), d2.off(l2, y2);
      }
      this.on.call(this, l2, y2, e2);
    };
    var YKe = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"], Dyt = {}, Mrt = {}, _Lt = [], xLt = [], Eyt = [], Soe = {}, wLt = {}, Crt = {}, Moe = {}, KKe = +new Date() - 0, SLt = "_echarts_instance_";
    function XKe(l2, a, e2) {
      var d2 = !(e2 && e2.ssr);
      if (d2) {
        var y2 = QKe(l2);
        if (y2)
          return y2;
      }
      var x2 = new woe(l2, a, e2);
      return x2.id = "ec_" + KKe++, Crt[x2.id] = x2, d2 && ant(l2, SLt, x2.id), _oe(x2), EE.trigger("afterinit", x2), x2;
    }
    function QKe(l2) {
      return Crt[K5t(l2, SLt)];
    }
    function Coe(l2, a) {
      Soe[l2] = a;
    }
    function Toe(l2) {
      oc2(xLt, l2) < 0 && xLt.push(l2);
    }
    function Aoe(l2, a) {
      CLt(_Lt, l2, a, BKe);
    }
    function JKe(l2) {
      MLt("afterinit", l2);
    }
    function tXe(l2) {
      MLt("afterupdate", l2);
    }
    function MLt(l2, a) {
      EE.on(l2, a);
    }
    function sP(l2, a, e2) {
      wl(a) && (e2 = a, a = "");
      var d2 = vs(l2) ? l2.type : [l2, l2 = { event: a }][0];
      l2.event = (l2.event || d2).toLowerCase(), a = l2.event, !Mrt[a] && (vb2(uoe.test(d2) && uoe.test(a)), Dyt[d2] || (Dyt[d2] = { action: e2, actionInfo: l2 }), Mrt[a] = d2);
    }
    function eXe(l2, a) {
      urt.register(l2, a);
    }
    function nXe(l2, a) {
      CLt(Eyt, l2, a, ooe, "layout");
    }
    function uB(l2, a) {
      CLt(Eyt, l2, a, soe, "visual");
    }
    var Ioe = [];
    function CLt(l2, a, e2, d2, y2) {
      if ((wl(a) || vs(a)) && (e2 = a, a = d2), !(oc2(Ioe, e2) >= 0)) {
        Ioe.push(e2);
        var x2 = Lae.wrapStageHandler(e2, y2);
        x2.__prio = a, x2.__raw = e2, l2.push(x2);
      }
    }
    function Doe(l2, a) {
      wLt[l2] = a;
    }
    function rXe(l2, a, e2) {
      var d2 = LKe("registerMap");
      d2 && d2(l2, a, e2);
    }
    var iXe = hYe;
    uB(fLt, FYe), uB(Tyt, VYe), uB(Tyt, BYe), uB(fLt, tKe), uB(Tyt, eKe), uB(loe, EKe), Toe(Vie), Aoe(FKe, q$e), Doe("default", zYe), sP({ type: R_, event: R_, update: R_ }, $p), sP({ type: qV, event: qV, update: qV }, $p), sP({ type: rP, event: rP, update: rP }, $p), sP({ type: Zg2, event: Zg2, update: Zg2 }, $p), sP({ type: $g2, event: $g2, update: $g2 }, $p), Coe("light", XYe), Coe("dark", QYe);
    var Eoe = [], aXe = { registerPreprocessor: Toe, registerProcessor: Aoe, registerPostInit: JKe, registerPostUpdate: tXe, registerUpdateLifecycle: MLt, registerAction: sP, registerCoordinateSystem: eXe, registerLayout: nXe, registerVisual: uB, registerTransform: iXe, registerLoading: Doe, registerMap: rXe, registerImpl: PKe, PRIORITY: qKe, ComponentModel: Ah2, ComponentView: _0, SeriesModel: Pv, ChartView: pg2, registerComponentModel: function(l2) {
      Ah2.registerClass(l2);
    }, registerComponentView: function(l2) {
      _0.registerClass(l2);
    }, registerSeriesModel: function(l2) {
      Pv.registerClass(l2);
    }, registerChartView: function(l2) {
      pg2.registerClass(l2);
    }, registerSubTypeDefaulter: function(l2, a) {
      Ah2.registerSubTypeDefaulter(l2, a);
    }, registerPainter: function(l2, a) {
      ON(l2, a);
    } };
    function Oc2(l2) {
      if (Ba2(l2)) {
        Ke2(l2, function(a) {
          Oc2(a);
        });
        return;
      }
      oc2(Eoe, l2) >= 0 || (Eoe.push(l2), wl(l2) && (l2 = { install: l2 }), l2.install(aXe));
    }
    function Trt(l2) {
      return l2 == null ? 0 : l2.length || 1;
    }
    function koe(l2) {
      return l2;
    }
    var oXe = function() {
      function l2(a, e2, d2, y2, x2, C) {
        this._old = a, this._new = e2, this._oldKeyGetter = d2 || koe, this._newKeyGetter = y2 || koe, this.context = x2, this._diffModeMultiple = C === "multiple";
      }
      return l2.prototype.add = function(a) {
        return this._add = a, this;
      }, l2.prototype.update = function(a) {
        return this._update = a, this;
      }, l2.prototype.updateManyToOne = function(a) {
        return this._updateManyToOne = a, this;
      }, l2.prototype.updateOneToMany = function(a) {
        return this._updateOneToMany = a, this;
      }, l2.prototype.updateManyToMany = function(a) {
        return this._updateManyToMany = a, this;
      }, l2.prototype.remove = function(a) {
        return this._remove = a, this;
      }, l2.prototype.execute = function() {
        this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
      }, l2.prototype._executeOneToOne = function() {
        var a = this._old, e2 = this._new, d2 = {}, y2 = new Array(a.length), x2 = new Array(e2.length);
        this._initIndexMap(a, null, y2, "_oldKeyGetter"), this._initIndexMap(e2, d2, x2, "_newKeyGetter");
        for (var C = 0; C < a.length; C++) {
          var D2 = y2[C], L = d2[D2], F3 = Trt(L);
          if (F3 > 1) {
            var j = L.shift();
            L.length === 1 && (d2[D2] = L[0]), this._update && this._update(j, C);
          } else
            F3 === 1 ? (d2[D2] = null, this._update && this._update(L, C)) : this._remove && this._remove(C);
        }
        this._performRestAdd(x2, d2);
      }, l2.prototype._executeMultiple = function() {
        var a = this._old, e2 = this._new, d2 = {}, y2 = {}, x2 = [], C = [];
        this._initIndexMap(a, d2, x2, "_oldKeyGetter"), this._initIndexMap(e2, y2, C, "_newKeyGetter");
        for (var D2 = 0; D2 < x2.length; D2++) {
          var L = x2[D2], F3 = d2[L], j = y2[L], U3 = Trt(F3), Y3 = Trt(j);
          if (U3 > 1 && Y3 === 1)
            this._updateManyToOne && this._updateManyToOne(j, F3), y2[L] = null;
          else if (U3 === 1 && Y3 > 1)
            this._updateOneToMany && this._updateOneToMany(j, F3), y2[L] = null;
          else if (U3 === 1 && Y3 === 1)
            this._update && this._update(j, F3), y2[L] = null;
          else if (U3 > 1 && Y3 > 1)
            this._updateManyToMany && this._updateManyToMany(j, F3), y2[L] = null;
          else if (U3 > 1)
            for (var Q = 0; Q < U3; Q++)
              this._remove && this._remove(F3[Q]);
          else
            this._remove && this._remove(F3);
        }
        this._performRestAdd(C, y2);
      }, l2.prototype._performRestAdd = function(a, e2) {
        for (var d2 = 0; d2 < a.length; d2++) {
          var y2 = a[d2], x2 = e2[y2], C = Trt(x2);
          if (C > 1)
            for (var D2 = 0; D2 < C; D2++)
              this._add && this._add(x2[D2]);
          else
            C === 1 && this._add && this._add(x2);
          e2[y2] = null;
        }
      }, l2.prototype._initIndexMap = function(a, e2, d2, y2) {
        for (var x2 = this._diffModeMultiple, C = 0; C < a.length; C++) {
          var D2 = "_ec_" + this[y2](a[C], C);
          if (x2 || (d2[C] = D2), !!e2) {
            var L = e2[D2], F3 = Trt(L);
            F3 === 0 ? (e2[D2] = C, x2 && d2.push(D2)) : F3 === 1 ? e2[D2] = [L, C] : L.push(C);
          }
        }
      }, l2;
    }(), kO = oXe, sXe = function() {
      function l2(a, e2) {
        this._encode = a, this._schema = e2;
      }
      return l2.prototype.get = function() {
        return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
      }, l2.prototype._getFullDimensionNames = function() {
        return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
      }, l2;
    }();
    function lXe(l2, a) {
      var e2 = {}, d2 = e2.encode = {}, y2 = fl(), x2 = [], C = [], D2 = {};
      Ke2(l2.dimensions, function(Y3) {
        var Q = l2.getDimensionInfo(Y3), nt = Q.coordDim;
        if (nt) {
          var dt = Q.coordDimIndex;
          TLt(d2, nt)[dt] = Y3, Q.isExtraCoord || (y2.set(nt, 1), uXe(Q.type) && (x2[0] = Y3), TLt(D2, nt)[dt] = l2.getDimensionIndex(Q.name)), Q.defaultTooltip && C.push(Y3);
        }
        vie.each(function(vt, Ct) {
          var Pt = TLt(d2, Ct), jt = Q.otherDims[Ct];
          jt != null && jt !== false && (Pt[jt] = Q.name);
        });
      });
      var L = [], F3 = {};
      y2.each(function(Y3, Q) {
        var nt = d2[Q];
        F3[Q] = nt[0], L = L.concat(nt);
      }), e2.dataDimsOnCoord = L, e2.dataDimIndicesOnCoord = $a2(L, function(Y3) {
        return l2.getDimensionInfo(Y3).storeDimIndex;
      }), e2.encodeFirstDimNotExtra = F3;
      var j = d2.label;
      j && j.length && (x2 = j.slice());
      var U3 = d2.tooltip;
      return U3 && U3.length ? C = U3.slice() : C.length || (C = x2.slice()), d2.defaultedLabel = x2, d2.defaultedTooltip = C, e2.userOutput = new sXe(D2, a), e2;
    }
    function TLt(l2, a) {
      return l2.hasOwnProperty(a) || (l2[a] = []), l2[a];
    }
    function kyt(l2) {
      return l2 === "category" ? "ordinal" : l2 === "time" ? "time" : "float";
    }
    function uXe(l2) {
      return !(l2 === "ordinal" || l2 === "time");
    }
    var cXe = function() {
      function l2(a) {
        this.otherDims = {}, a != null && la2(this, a);
      }
      return l2;
    }(), Pyt = cXe, fXe = Rf2(), hXe = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, Poe = function() {
      function l2(a) {
        this.dimensions = a.dimensions, this._dimOmitted = a.dimensionOmitted, this.source = a.source, this._fullDimCount = a.fullDimensionCount, this._updateDimOmitted(a.dimensionOmitted);
      }
      return l2.prototype.isDimensionOmitted = function() {
        return this._dimOmitted;
      }, l2.prototype._updateDimOmitted = function(a) {
        this._dimOmitted = a, a && (this._dimNameMap || (this._dimNameMap = Roe(this.source)));
      }, l2.prototype.getSourceDimensionIndex = function(a) {
        return $u(this._dimNameMap.get(a), -1);
      }, l2.prototype.getSourceDimension = function(a) {
        var e2 = this.source.dimensionsDefine;
        if (e2)
          return e2[a];
      }, l2.prototype.makeStoreSchema = function() {
        for (var a = this._fullDimCount, e2 = Wie(this.source), d2 = !Noe(a), y2 = "", x2 = [], C = 0, D2 = 0; C < a; C++) {
          var L = void 0, F3 = void 0, j = void 0, U3 = this.dimensions[D2];
          if (U3 && U3.storeDimIndex === C)
            L = e2 ? U3.name : null, F3 = U3.type, j = U3.ordinalMeta, D2++;
          else {
            var Y3 = this.getSourceDimension(C);
            Y3 && (L = e2 ? Y3.name : null, F3 = Y3.type);
          }
          x2.push({ property: L, type: F3, ordinalMeta: j }), e2 && L != null && (!U3 || !U3.isCalculationCoord) && (y2 += d2 ? L.replace(/\`/g, "`1").replace(/\$/g, "`2") : L), y2 += "$", y2 += hXe[F3] || "f", j && (y2 += j.uid), y2 += "$";
        }
        var Q = this.source, nt = [Q.seriesLayoutBy, Q.startIndex, y2].join("$$");
        return { dimensions: x2, hash: nt };
      }, l2.prototype.makeOutputDimensionNames = function() {
        for (var a = [], e2 = 0, d2 = 0; e2 < this._fullDimCount; e2++) {
          var y2 = void 0, x2 = this.dimensions[d2];
          if (x2 && x2.storeDimIndex === e2)
            x2.isCalculationCoord || (y2 = x2.name), d2++;
          else {
            var C = this.getSourceDimension(e2);
            C && (y2 = C.name);
          }
          a.push(y2);
        }
        return a;
      }, l2.prototype.appendCalculationDimension = function(a) {
        this.dimensions.push(a), a.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
      }, l2;
    }();
    function Loe(l2) {
      return l2 instanceof Poe;
    }
    function Ooe(l2) {
      for (var a = fl(), e2 = 0; e2 < (l2 || []).length; e2++) {
        var d2 = l2[e2], y2 = vs(d2) ? d2.name : d2;
        y2 != null && a.get(y2) == null && a.set(y2, e2);
      }
      return a;
    }
    function Roe(l2) {
      var a = fXe(l2);
      return a.dimNameMap || (a.dimNameMap = Ooe(l2.dimensionsDefine));
    }
    function Noe(l2) {
      return l2 > 30;
    }
    var Art = vs, JN = $a2, pXe = typeof Int32Array == "undefined" ? Array : Int32Array, dXe = "e\0\0", Foe = -1, gXe = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], vXe = ["_approximateExtent"], Voe, Lyt, Irt, Drt, ALt, Oyt, ILt, yXe = function() {
      function l2(a, e2) {
        this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
        var d2, y2 = false;
        Loe(a) ? (d2 = a.dimensions, this._dimOmitted = a.isDimensionOmitted(), this._schema = a) : (y2 = true, d2 = a), d2 = d2 || ["x", "y"];
        for (var x2 = {}, C = [], D2 = {}, L = false, F3 = {}, j = 0; j < d2.length; j++) {
          var U3 = d2[j], Y3 = ps(U3) ? new Pyt({ name: U3 }) : U3 instanceof Pyt ? U3 : new Pyt(U3), Q = Y3.name;
          Y3.type = Y3.type || "float", Y3.coordDim || (Y3.coordDim = Q, Y3.coordDimIndex = 0);
          var nt = Y3.otherDims = Y3.otherDims || {};
          C.push(Q), x2[Q] = Y3, F3[Q] != null && (L = true), Y3.createInvertedIndices && (D2[Q] = []), nt.itemName === 0 && (this._nameDimIdx = j), nt.itemId === 0 && (this._idDimIdx = j), y2 && (Y3.storeDimIndex = j);
        }
        if (this.dimensions = C, this._dimInfos = x2, this._initGetDimensionInfo(L), this.hostModel = e2, this._invertedIndicesMap = D2, this._dimOmitted) {
          var dt = this._dimIdxToName = fl();
          Ke2(C, function(vt) {
            dt.set(x2[vt].storeDimIndex, vt);
          });
        }
      }
      return l2.prototype.getDimension = function(a) {
        var e2 = this._recognizeDimIndex(a);
        if (e2 == null)
          return a;
        if (e2 = a, !this._dimOmitted)
          return this.dimensions[e2];
        var d2 = this._dimIdxToName.get(e2);
        if (d2 != null)
          return d2;
        var y2 = this._schema.getSourceDimension(e2);
        if (y2)
          return y2.name;
      }, l2.prototype.getDimensionIndex = function(a) {
        var e2 = this._recognizeDimIndex(a);
        if (e2 != null)
          return e2;
        if (a == null)
          return -1;
        var d2 = this._getDimInfo(a);
        return d2 ? d2.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(a) : -1;
      }, l2.prototype._recognizeDimIndex = function(a) {
        if (Ch2(a) || a != null && !isNaN(a) && !this._getDimInfo(a) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(a) < 0))
          return +a;
      }, l2.prototype._getStoreDimIndex = function(a) {
        var e2 = this.getDimensionIndex(a);
        return e2;
      }, l2.prototype.getDimensionInfo = function(a) {
        return this._getDimInfo(this.getDimension(a));
      }, l2.prototype._initGetDimensionInfo = function(a) {
        var e2 = this._dimInfos;
        this._getDimInfo = a ? function(d2) {
          return e2.hasOwnProperty(d2) ? e2[d2] : void 0;
        } : function(d2) {
          return e2[d2];
        };
      }, l2.prototype.getDimensionsOnCoord = function() {
        return this._dimSummary.dataDimsOnCoord.slice();
      }, l2.prototype.mapDimension = function(a, e2) {
        var d2 = this._dimSummary;
        if (e2 == null)
          return d2.encodeFirstDimNotExtra[a];
        var y2 = d2.encode[a];
        return y2 ? y2[e2] : null;
      }, l2.prototype.mapDimensionsAll = function(a) {
        var e2 = this._dimSummary, d2 = e2.encode[a];
        return (d2 || []).slice();
      }, l2.prototype.getStore = function() {
        return this._store;
      }, l2.prototype.initData = function(a, e2, d2) {
        var y2 = this, x2;
        if (a instanceof X3t && (x2 = a), !x2) {
          var C = this.dimensions, D2 = G3t(a) || h1(a) ? new Uie(a, C.length) : a;
          x2 = new X3t();
          var L = JN(C, function(F3) {
            return { type: y2._dimInfos[F3].type, property: F3 };
          });
          x2.initData(D2, L, d2);
        }
        this._store = x2, this._nameList = (e2 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, x2.count()), this._dimSummary = lXe(this, this._schema), this.userOutput = this._dimSummary.userOutput;
      }, l2.prototype.appendData = function(a) {
        var e2 = this._store.appendData(a);
        this._doInit(e2[0], e2[1]);
      }, l2.prototype.appendValues = function(a, e2) {
        var d2 = this._store.appendValues(a, e2.length), y2 = d2.start, x2 = d2.end, C = this._shouldMakeIdFromName();
        if (this._updateOrdinalMeta(), e2)
          for (var D2 = y2; D2 < x2; D2++) {
            var L = D2 - y2;
            this._nameList[D2] = e2[L], C && ILt(this, D2);
          }
      }, l2.prototype._updateOrdinalMeta = function() {
        for (var a = this._store, e2 = this.dimensions, d2 = 0; d2 < e2.length; d2++) {
          var y2 = this._dimInfos[e2[d2]];
          y2.ordinalMeta && a.collectOrdinalMeta(y2.storeDimIndex, y2.ordinalMeta);
        }
      }, l2.prototype._shouldMakeIdFromName = function() {
        var a = this._store.getProvider();
        return this._idDimIdx == null && a.getSource().sourceFormat !== YN && !a.fillStorage;
      }, l2.prototype._doInit = function(a, e2) {
        if (!(a >= e2)) {
          var d2 = this._store, y2 = d2.getProvider();
          this._updateOrdinalMeta();
          var x2 = this._nameList, C = this._idList, D2 = y2.getSource().sourceFormat, L = D2 === MA;
          if (L && !y2.pure)
            for (var F3 = [], j = a; j < e2; j++) {
              var U3 = y2.getItem(j, F3);
              if (!this.hasItemOption && Uvt(U3) && (this.hasItemOption = true), U3) {
                var Y3 = U3.name;
                x2[j] == null && Y3 != null && (x2[j] = Ud2(Y3, null));
                var Q = U3.id;
                C[j] == null && Q != null && (C[j] = Ud2(Q, null));
              }
            }
          if (this._shouldMakeIdFromName())
            for (var j = a; j < e2; j++)
              ILt(this, j);
          Voe(this);
        }
      }, l2.prototype.getApproximateExtent = function(a) {
        return this._approximateExtent[a] || this._store.getDataExtent(this._getStoreDimIndex(a));
      }, l2.prototype.setApproximateExtent = function(a, e2) {
        e2 = this.getDimension(e2), this._approximateExtent[e2] = a.slice();
      }, l2.prototype.getCalculationInfo = function(a) {
        return this._calculationInfo[a];
      }, l2.prototype.setCalculationInfo = function(a, e2) {
        Art(a) ? la2(this._calculationInfo, a) : this._calculationInfo[a] = e2;
      }, l2.prototype.getName = function(a) {
        var e2 = this.getRawIndex(a), d2 = this._nameList[e2];
        return d2 == null && this._nameDimIdx != null && (d2 = Irt(this, this._nameDimIdx, e2)), d2 == null && (d2 = ""), d2;
      }, l2.prototype._getCategory = function(a, e2) {
        var d2 = this._store.get(a, e2), y2 = this._store.getOrdinalMeta(a);
        return y2 ? y2.categories[d2] : d2;
      }, l2.prototype.getId = function(a) {
        return Lyt(this, this.getRawIndex(a));
      }, l2.prototype.count = function() {
        return this._store.count();
      }, l2.prototype.get = function(a, e2) {
        var d2 = this._store, y2 = this._dimInfos[a];
        if (y2)
          return d2.get(y2.storeDimIndex, e2);
      }, l2.prototype.getByRawIndex = function(a, e2) {
        var d2 = this._store, y2 = this._dimInfos[a];
        if (y2)
          return d2.getByRawIndex(y2.storeDimIndex, e2);
      }, l2.prototype.getIndices = function() {
        return this._store.getIndices();
      }, l2.prototype.getDataExtent = function(a) {
        return this._store.getDataExtent(this._getStoreDimIndex(a));
      }, l2.prototype.getSum = function(a) {
        return this._store.getSum(this._getStoreDimIndex(a));
      }, l2.prototype.getMedian = function(a) {
        return this._store.getMedian(this._getStoreDimIndex(a));
      }, l2.prototype.getValues = function(a, e2) {
        var d2 = this, y2 = this._store;
        return Ba2(a) ? y2.getValues(JN(a, function(x2) {
          return d2._getStoreDimIndex(x2);
        }), e2) : y2.getValues(a);
      }, l2.prototype.hasValue = function(a) {
        for (var e2 = this._dimSummary.dataDimIndicesOnCoord, d2 = 0, y2 = e2.length; d2 < y2; d2++)
          if (isNaN(this._store.get(e2[d2], a)))
            return false;
        return true;
      }, l2.prototype.indexOfName = function(a) {
        for (var e2 = 0, d2 = this._store.count(); e2 < d2; e2++)
          if (this.getName(e2) === a)
            return e2;
        return -1;
      }, l2.prototype.getRawIndex = function(a) {
        return this._store.getRawIndex(a);
      }, l2.prototype.indexOfRawIndex = function(a) {
        return this._store.indexOfRawIndex(a);
      }, l2.prototype.rawIndexOf = function(a, e2) {
        var d2 = a && this._invertedIndicesMap[a], y2 = d2[e2];
        return y2 == null || isNaN(y2) ? Foe : y2;
      }, l2.prototype.indicesOfNearest = function(a, e2, d2) {
        return this._store.indicesOfNearest(this._getStoreDimIndex(a), e2, d2);
      }, l2.prototype.each = function(a, e2, d2) {
        wl(a) && (d2 = e2, e2 = a, a = []);
        var y2 = d2 || this, x2 = JN(Drt(a), this._getStoreDimIndex, this);
        this._store.each(x2, y2 ? As(e2, y2) : e2);
      }, l2.prototype.filterSelf = function(a, e2, d2) {
        wl(a) && (d2 = e2, e2 = a, a = []);
        var y2 = d2 || this, x2 = JN(Drt(a), this._getStoreDimIndex, this);
        return this._store = this._store.filter(x2, y2 ? As(e2, y2) : e2), this;
      }, l2.prototype.selectRange = function(a) {
        var e2 = this, d2 = {}, y2 = Qc2(a);
        return Ke2(y2, function(x2) {
          var C = e2._getStoreDimIndex(x2);
          d2[C] = a[x2];
        }), this._store = this._store.selectRange(d2), this;
      }, l2.prototype.mapArray = function(a, e2, d2) {
        wl(a) && (d2 = e2, e2 = a, a = []), d2 = d2 || this;
        var y2 = [];
        return this.each(a, function() {
          y2.push(e2 && e2.apply(this, arguments));
        }, d2), y2;
      }, l2.prototype.map = function(a, e2, d2, y2) {
        var x2 = d2 || y2 || this, C = JN(Drt(a), this._getStoreDimIndex, this), D2 = Oyt(this);
        return D2._store = this._store.map(C, x2 ? As(e2, x2) : e2), D2;
      }, l2.prototype.modify = function(a, e2, d2, y2) {
        var x2 = d2 || y2 || this, C = JN(Drt(a), this._getStoreDimIndex, this);
        this._store.modify(C, x2 ? As(e2, x2) : e2);
      }, l2.prototype.downSample = function(a, e2, d2, y2) {
        var x2 = Oyt(this);
        return x2._store = this._store.downSample(this._getStoreDimIndex(a), e2, d2, y2), x2;
      }, l2.prototype.lttbDownSample = function(a, e2) {
        var d2 = Oyt(this);
        return d2._store = this._store.lttbDownSample(this._getStoreDimIndex(a), e2), d2;
      }, l2.prototype.getRawDataItem = function(a) {
        return this._store.getRawDataItem(a);
      }, l2.prototype.getItemModel = function(a) {
        var e2 = this.hostModel, d2 = this.getRawDataItem(a);
        return new hg2(d2, e2, e2 && e2.ecModel);
      }, l2.prototype.diff = function(a) {
        var e2 = this;
        return new kO(a ? a.getStore().getIndices() : [], this.getStore().getIndices(), function(d2) {
          return Lyt(a, d2);
        }, function(d2) {
          return Lyt(e2, d2);
        });
      }, l2.prototype.getVisual = function(a) {
        var e2 = this._visual;
        return e2 && e2[a];
      }, l2.prototype.setVisual = function(a, e2) {
        this._visual = this._visual || {}, Art(a) ? la2(this._visual, a) : this._visual[a] = e2;
      }, l2.prototype.getItemVisual = function(a, e2) {
        var d2 = this._itemVisuals[a], y2 = d2 && d2[e2];
        return y2 == null ? this.getVisual(e2) : y2;
      }, l2.prototype.hasItemVisual = function() {
        return this._itemVisuals.length > 0;
      }, l2.prototype.ensureUniqueItemVisual = function(a, e2) {
        var d2 = this._itemVisuals, y2 = d2[a];
        y2 || (y2 = d2[a] = {});
        var x2 = y2[e2];
        return x2 == null && (x2 = this.getVisual(e2), Ba2(x2) ? x2 = x2.slice() : Art(x2) && (x2 = la2({}, x2)), y2[e2] = x2), x2;
      }, l2.prototype.setItemVisual = function(a, e2, d2) {
        var y2 = this._itemVisuals[a] || {};
        this._itemVisuals[a] = y2, Art(e2) ? la2(y2, e2) : y2[e2] = d2;
      }, l2.prototype.clearAllVisual = function() {
        this._visual = {}, this._itemVisuals = [];
      }, l2.prototype.setLayout = function(a, e2) {
        Art(a) ? la2(this._layout, a) : this._layout[a] = e2;
      }, l2.prototype.getLayout = function(a) {
        return this._layout[a];
      }, l2.prototype.getItemLayout = function(a) {
        return this._itemLayouts[a];
      }, l2.prototype.setItemLayout = function(a, e2, d2) {
        this._itemLayouts[a] = d2 ? la2(this._itemLayouts[a] || {}, e2) : e2;
      }, l2.prototype.clearItemLayouts = function() {
        this._itemLayouts.length = 0;
      }, l2.prototype.setItemGraphicEl = function(a, e2) {
        var d2 = this.hostModel && this.hostModel.seriesIndex;
        Ent(d2, this.dataType, a, e2), this._graphicEls[a] = e2;
      }, l2.prototype.getItemGraphicEl = function(a) {
        return this._graphicEls[a];
      }, l2.prototype.eachItemGraphicEl = function(a, e2) {
        Ke2(this._graphicEls, function(d2, y2) {
          d2 && a && a.call(e2, d2, y2);
        });
      }, l2.prototype.cloneShallow = function(a) {
        return a || (a = new l2(this._schema ? this._schema : JN(this.dimensions, this._getDimInfo, this), this.hostModel)), ALt(a, this), a._store = this._store, a;
      }, l2.prototype.wrapMethod = function(a, e2) {
        var d2 = this[a];
        !wl(d2) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(a), this[a] = function() {
          var y2 = d2.apply(this, arguments);
          return e2.apply(this, [y2].concat(dV(arguments)));
        });
      }, l2.internalField = function() {
        Voe = function(a) {
          var e2 = a._invertedIndicesMap;
          Ke2(e2, function(d2, y2) {
            var x2 = a._dimInfos[y2], C = x2.ordinalMeta, D2 = a._store;
            if (C) {
              d2 = e2[y2] = new pXe(C.categories.length);
              for (var L = 0; L < d2.length; L++)
                d2[L] = Foe;
              for (var L = 0; L < D2.count(); L++)
                d2[D2.get(x2.storeDimIndex, L)] = L;
            }
          });
        }, Irt = function(a, e2, d2) {
          return Ud2(a._getCategory(e2, d2), null);
        }, Lyt = function(a, e2) {
          var d2 = a._idList[e2];
          return d2 == null && a._idDimIdx != null && (d2 = Irt(a, a._idDimIdx, e2)), d2 == null && (d2 = dXe + e2), d2;
        }, Drt = function(a) {
          return Ba2(a) || (a = a != null ? [a] : []), a;
        }, Oyt = function(a) {
          var e2 = new l2(a._schema ? a._schema : JN(a.dimensions, a._getDimInfo, a), a.hostModel);
          return ALt(e2, a), e2;
        }, ALt = function(a, e2) {
          Ke2(gXe.concat(e2.__wrappedMethods || []), function(d2) {
            e2.hasOwnProperty(d2) && (a[d2] = e2[d2]);
          }), a.__wrappedMethods = e2.__wrappedMethods, Ke2(vXe, function(d2) {
            a[d2] = zl(e2[d2]);
          }), a._calculationInfo = la2({}, e2._calculationInfo);
        }, ILt = function(a, e2) {
          var d2 = a._nameList, y2 = a._idList, x2 = a._nameDimIdx, C = a._idDimIdx, D2 = d2[e2], L = y2[e2];
          if (D2 == null && x2 != null && (d2[e2] = D2 = Irt(a, x2, e2)), L == null && C != null && (y2[e2] = L = Irt(a, C, e2)), L == null && D2 != null) {
            var F3 = a._nameRepeatCount, j = F3[D2] = (F3[D2] || 0) + 1;
            L = D2, j > 1 && (L += "__ec__" + j), y2[e2] = L;
          }
        };
      }(), l2;
    }(), jS = yXe;
    function Ert(l2, a) {
      G3t(l2) || (l2 = U3t(l2)), a = a || {};
      var e2 = a.coordDimensions || [], d2 = a.dimensionsDefine || l2.dimensionsDefine || [], y2 = fl(), x2 = [], C = bXe(l2, e2, d2, a.dimensionsCount), D2 = a.canOmitUnusedDimensions && Noe(C), L = d2 === l2.dimensionsDefine, F3 = L ? Roe(l2) : Ooe(d2), j = a.encodeDefine;
      !j && a.encodeDefaulter && (j = a.encodeDefaulter(l2, C));
      for (var U3 = fl(j), Y3 = new rae(C), Q = 0; Q < Y3.length; Q++)
        Y3[Q] = -1;
      function nt(Me2) {
        var Pe2 = Y3[Me2];
        if (Pe2 < 0) {
          var Be2 = d2[Me2], Je2 = vs(Be2) ? Be2 : { name: Be2 }, Ze2 = new Pyt(), Cn = Je2.name;
          Cn != null && F3.get(Cn) != null && (Ze2.name = Ze2.displayName = Cn), Je2.type != null && (Ze2.type = Je2.type), Je2.displayName != null && (Ze2.displayName = Je2.displayName);
          var Bn = x2.length;
          return Y3[Me2] = Bn, Ze2.storeDimIndex = Me2, x2.push(Ze2), Ze2;
        }
        return x2[Pe2];
      }
      if (!D2)
        for (var Q = 0; Q < C; Q++)
          nt(Q);
      U3.each(function(Me2, Pe2) {
        var Be2 = Mp(Me2).slice();
        if (Be2.length === 1 && !ps(Be2[0]) && Be2[0] < 0) {
          U3.set(Pe2, false);
          return;
        }
        var Je2 = U3.set(Pe2, []);
        Ke2(Be2, function(Ze2, Cn) {
          var Bn = ps(Ze2) ? F3.get(Ze2) : Ze2;
          Bn != null && Bn < C && (Je2[Cn] = Bn, vt(nt(Bn), Pe2, Cn));
        });
      });
      var dt = 0;
      Ke2(e2, function(Me2) {
        var Pe2, Be2, Je2, Ze2;
        if (ps(Me2))
          Pe2 = Me2, Ze2 = {};
        else {
          Ze2 = Me2, Pe2 = Ze2.name;
          var Cn = Ze2.ordinalMeta;
          Ze2.ordinalMeta = null, Ze2 = la2({}, Ze2), Ze2.ordinalMeta = Cn, Be2 = Ze2.dimsDef, Je2 = Ze2.otherDims, Ze2.name = Ze2.coordDim = Ze2.coordDimIndex = Ze2.dimsDef = Ze2.otherDims = null;
        }
        var Bn = U3.get(Pe2);
        if (Bn !== false) {
          if (Bn = Mp(Bn), !Bn.length)
            for (var mn = 0; mn < (Be2 && Be2.length || 1); mn++) {
              for (; dt < C && nt(dt).coordDim != null; )
                dt++;
              dt < C && Bn.push(dt++);
            }
          Ke2(Bn, function(Kr, Kn) {
            var ar = nt(Kr);
            if (L && Ze2.type != null && (ar.type = Ze2.type), vt(El(ar, Ze2), Pe2, Kn), ar.name == null && Be2) {
              var Cr = Be2[Kn];
              !vs(Cr) && (Cr = { name: Cr }), ar.name = ar.displayName = Cr.name, ar.defaultTooltip = Cr.defaultTooltip;
            }
            Je2 && El(ar.otherDims, Je2);
          });
        }
      });
      function vt(Me2, Pe2, Be2) {
        vie.get(Pe2) != null ? Me2.otherDims[Pe2] = Be2 : (Me2.coordDim = Pe2, Me2.coordDimIndex = Be2, y2.set(Pe2, true));
      }
      var Ct = a.generateCoord, Pt = a.generateCoordCount, jt = Pt != null;
      Pt = Ct ? Pt || 1 : 0;
      var Rt = Ct || "value";
      function le2(Me2) {
        Me2.name == null && (Me2.name = Me2.coordDim);
      }
      if (D2)
        Ke2(x2, function(Me2) {
          le2(Me2);
        }), x2.sort(function(Me2, Pe2) {
          return Me2.storeDimIndex - Pe2.storeDimIndex;
        });
      else
        for (var ne2 = 0; ne2 < C; ne2++) {
          var he2 = nt(ne2), _e = he2.coordDim;
          _e == null && (he2.coordDim = _Xe(Rt, y2, jt), he2.coordDimIndex = 0, (!Ct || Pt <= 0) && (he2.isExtraCoord = true), Pt--), le2(he2), he2.type == null && (_ie(l2, ne2) === V_.Must || he2.isExtraCoord && (he2.otherDims.itemName != null || he2.otherDims.seriesName != null)) && (he2.type = "ordinal");
        }
      return mXe(x2), new Poe({ source: l2, dimensions: x2, fullDimensionCount: C, dimensionOmitted: D2 });
    }
    function mXe(l2) {
      for (var a = fl(), e2 = 0; e2 < l2.length; e2++) {
        var d2 = l2[e2], y2 = d2.name, x2 = a.get(y2) || 0;
        x2 > 0 && (d2.name = y2 + (x2 - 1)), x2++, a.set(y2, x2);
      }
    }
    function bXe(l2, a, e2, d2) {
      var y2 = Math.max(l2.dimensionsDetectedCount || 1, a.length, e2.length, d2 || 0);
      return Ke2(a, function(x2) {
        var C;
        vs(x2) && (C = x2.dimsDef) && (y2 = Math.max(y2, C.length));
      }), y2;
    }
    function _Xe(l2, a, e2) {
      var d2 = a.data;
      if (e2 || d2.hasOwnProperty(l2)) {
        for (var y2 = 0; d2.hasOwnProperty(l2 + y2); )
          y2++;
        l2 += y2;
      }
      return a.set(l2, true), l2;
    }
    var xXe = function() {
      function l2(a) {
        this.coordSysDims = [], this.axisMap = fl(), this.categoryAxisMap = fl(), this.coordSysName = a;
      }
      return l2;
    }();
    function wXe(l2) {
      var a = l2.get("coordinateSystem"), e2 = new xXe(a), d2 = SXe[a];
      if (d2)
        return d2(l2, e2, e2.axisMap, e2.categoryAxisMap), e2;
    }
    var SXe = { cartesian2d: function(l2, a, e2, d2) {
      var y2 = l2.getReferringComponents("xAxis", q0).models[0], x2 = l2.getReferringComponents("yAxis", q0).models[0];
      a.coordSysDims = ["x", "y"], e2.set("x", y2), e2.set("y", x2), rZ(y2) && (d2.set("x", y2), a.firstCategoryDimIndex = 0), rZ(x2) && (d2.set("y", x2), a.firstCategoryDimIndex == null && (a.firstCategoryDimIndex = 1));
    }, singleAxis: function(l2, a, e2, d2) {
      var y2 = l2.getReferringComponents("singleAxis", q0).models[0];
      a.coordSysDims = ["single"], e2.set("single", y2), rZ(y2) && (d2.set("single", y2), a.firstCategoryDimIndex = 0);
    }, polar: function(l2, a, e2, d2) {
      var y2 = l2.getReferringComponents("polar", q0).models[0], x2 = y2.findAxisModel("radiusAxis"), C = y2.findAxisModel("angleAxis");
      a.coordSysDims = ["radius", "angle"], e2.set("radius", x2), e2.set("angle", C), rZ(x2) && (d2.set("radius", x2), a.firstCategoryDimIndex = 0), rZ(C) && (d2.set("angle", C), a.firstCategoryDimIndex == null && (a.firstCategoryDimIndex = 1));
    }, geo: function(l2, a, e2, d2) {
      a.coordSysDims = ["lng", "lat"];
    }, parallel: function(l2, a, e2, d2) {
      var y2 = l2.ecModel, x2 = y2.getComponent("parallel", l2.get("parallelIndex")), C = a.coordSysDims = x2.dimensions.slice();
      Ke2(x2.parallelAxisIndex, function(D2, L) {
        var F3 = y2.getComponent("parallelAxis", D2), j = C[L];
        e2.set(j, F3), rZ(F3) && (d2.set(j, F3), a.firstCategoryDimIndex == null && (a.firstCategoryDimIndex = L));
      });
    } };
    function rZ(l2) {
      return l2.get("type") === "category";
    }
    function MXe(l2, a, e2) {
      e2 = e2 || {};
      var d2 = e2.byIndex, y2 = e2.stackedCoordDimension, x2, C, D2;
      CXe(a) ? x2 = a : (C = a.schema, x2 = C.dimensions, D2 = a.store);
      var L = !!(l2 && l2.get("stack")), F3, j, U3, Y3;
      if (Ke2(x2, function(Pt, jt) {
        ps(Pt) && (x2[jt] = Pt = { name: Pt }), L && !Pt.isExtraCoord && (!d2 && !F3 && Pt.ordinalMeta && (F3 = Pt), !j && Pt.type !== "ordinal" && Pt.type !== "time" && (!y2 || y2 === Pt.coordDim) && (j = Pt));
      }), j && !d2 && !F3 && (d2 = true), j) {
        U3 = "__\0ecstackresult_" + l2.id, Y3 = "__\0ecstackedover_" + l2.id, F3 && (F3.createInvertedIndices = true);
        var Q = j.coordDim, nt = j.type, dt = 0;
        Ke2(x2, function(Pt) {
          Pt.coordDim === Q && dt++;
        });
        var vt = { name: U3, coordDim: Q, coordDimIndex: dt, type: nt, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: x2.length }, Ct = { name: Y3, coordDim: Y3, coordDimIndex: dt + 1, type: nt, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: x2.length + 1 };
        C ? (D2 && (vt.storeDimIndex = D2.ensureCalculationDimension(Y3, nt), Ct.storeDimIndex = D2.ensureCalculationDimension(U3, nt)), C.appendCalculationDimension(vt), C.appendCalculationDimension(Ct)) : (x2.push(vt), x2.push(Ct));
      }
      return { stackedDimension: j && j.name, stackedByDimension: F3 && F3.name, isStackedByIndex: d2, stackedOverDimension: Y3, stackResultDimension: U3 };
    }
    function CXe(l2) {
      return !Loe(l2.schema);
    }
    function tF(l2, a) {
      return !!a && a === l2.getCalculationInfo("stackedDimension");
    }
    function Boe(l2, a) {
      return tF(l2, a) ? l2.getCalculationInfo("stackResultDimension") : a;
    }
    function TXe(l2, a) {
      var e2 = l2.get("coordinateSystem"), d2 = urt.get(e2), y2;
      return a && a.coordSysDims && (y2 = $a2(a.coordSysDims, function(x2) {
        var C = { name: x2 }, D2 = a.axisMap.get(x2);
        if (D2) {
          var L = D2.get("type");
          C.type = kyt(L);
        }
        return C;
      })), y2 || (y2 = d2 && (d2.getDimensionsInfo ? d2.getDimensionsInfo() : d2.dimensions.slice()) || ["x", "y"]), y2;
    }
    function AXe(l2, a, e2) {
      var d2, y2;
      return e2 && Ke2(l2, function(x2, C) {
        var D2 = x2.coordDim, L = e2.categoryAxisMap.get(D2);
        L && (d2 == null && (d2 = C), x2.ordinalMeta = L.getOrdinalMeta(), a && (x2.createInvertedIndices = true)), x2.otherDims.itemName != null && (y2 = true);
      }), !y2 && d2 != null && (l2[d2].otherDims.itemName = 0), d2;
    }
    function PO(l2, a, e2) {
      e2 = e2 || {};
      var d2 = a.getSourceManager(), y2, x2 = false;
      l2 ? (x2 = true, y2 = U3t(l2)) : (y2 = d2.getSource(), x2 = y2.sourceFormat === MA);
      var C = wXe(a), D2 = TXe(a, C), L = e2.useEncodeDefaulter, F3 = wl(L) ? L : L ? xu(bie, D2, a) : null, j = { coordDimensions: D2, generateCoord: e2.generateCoord, encodeDefine: a.getEncode(), encodeDefaulter: F3, canOmitUnusedDimensions: !x2 }, U3 = Ert(y2, j), Y3 = AXe(U3.dimensions, e2.createInvertedIndices, C), Q = x2 ? null : d2.getSharedDataStore(U3), nt = MXe(a, { schema: U3, store: Q }), dt = new jS(U3, a);
      dt.setCalculationInfo(nt);
      var vt = Y3 != null && IXe(y2) ? function(Ct, Pt, jt, Rt) {
        return Rt === Y3 ? jt : this.defaultDimValueGetter(Ct, Pt, jt, Rt);
      } : null;
      return dt.hasItemOption = false, dt.initData(x2 ? y2 : Q, null, vt), dt;
    }
    function IXe(l2) {
      if (l2.sourceFormat === MA) {
        var a = DXe(l2.data || []);
        return !Ba2(q5(a));
      }
    }
    function DXe(l2) {
      for (var a = 0; a < l2.length && l2[a] == null; )
        a++;
      return l2[a];
    }
    var zoe = function() {
      function l2(a) {
        this._setting = a || {}, this._extent = [1 / 0, -1 / 0];
      }
      return l2.prototype.getSetting = function(a) {
        return this._setting[a];
      }, l2.prototype.unionExtent = function(a) {
        var e2 = this._extent;
        a[0] < e2[0] && (e2[0] = a[0]), a[1] > e2[1] && (e2[1] = a[1]);
      }, l2.prototype.unionExtentFromData = function(a, e2) {
        this.unionExtent(a.getApproximateExtent(e2));
      }, l2.prototype.getExtent = function() {
        return this._extent.slice();
      }, l2.prototype.setExtent = function(a, e2) {
        var d2 = this._extent;
        isNaN(a) || (d2[0] = a), isNaN(e2) || (d2[1] = e2);
      }, l2.prototype.isInExtentRange = function(a) {
        return this._extent[0] <= a && this._extent[1] >= a;
      }, l2.prototype.isBlank = function() {
        return this._isBlank;
      }, l2.prototype.setBlank = function(a) {
        this._isBlank = a;
      }, l2;
    }();
    fq(zoe);
    var LO = zoe, EXe = 0, kXe = function() {
      function l2(a) {
        this.categories = a.categories || [], this._needCollect = a.needCollect, this._deduplication = a.deduplication, this.uid = ++EXe;
      }
      return l2.createByAxisModel = function(a) {
        var e2 = a.option, d2 = e2.data, y2 = d2 && $a2(d2, PXe);
        return new l2({ categories: y2, needCollect: !y2, deduplication: e2.dedplication !== false });
      }, l2.prototype.getOrdinal = function(a) {
        return this._getOrCreateMap().get(a);
      }, l2.prototype.parseAndCollect = function(a) {
        var e2, d2 = this._needCollect;
        if (!ps(a) && !d2)
          return a;
        if (d2 && !this._deduplication)
          return e2 = this.categories.length, this.categories[e2] = a, e2;
        var y2 = this._getOrCreateMap();
        return e2 = y2.get(a), e2 == null && (d2 ? (e2 = this.categories.length, this.categories[e2] = a, y2.set(a, e2)) : e2 = NaN), e2;
      }, l2.prototype._getOrCreateMap = function() {
        return this._map || (this._map = fl(this.categories));
      }, l2;
    }();
    function PXe(l2) {
      return vs(l2) && l2.value != null ? l2.value : l2 + "";
    }
    var DLt = kXe;
    function ELt(l2) {
      return l2.type === "interval" || l2.type === "log";
    }
    function LXe(l2, a, e2, d2) {
      var y2 = {}, x2 = l2[1] - l2[0], C = y2.interval = Wvt(x2 / a, true);
      e2 != null && C < e2 && (C = y2.interval = e2), d2 != null && C > d2 && (C = y2.interval = d2);
      var D2 = y2.intervalPrecision = joe(C), L = y2.niceTickExtent = [kv(Math.ceil(l2[0] / C) * C, D2), kv(Math.floor(l2[1] / C) * C, D2)];
      return OXe(L, l2), y2;
    }
    function kLt(l2) {
      var a = Math.pow(10, aq(l2)), e2 = l2 / a;
      return e2 ? e2 === 2 ? e2 = 3 : e2 === 3 ? e2 = 5 : e2 *= 2 : e2 = 1, kv(e2 * a);
    }
    function joe(l2) {
      return $2(l2) + 2;
    }
    function Woe(l2, a, e2) {
      l2[a] = Math.max(Math.min(l2[a], e2[1]), e2[0]);
    }
    function OXe(l2, a) {
      !isFinite(l2[0]) && (l2[0] = a[0]), !isFinite(l2[1]) && (l2[1] = a[1]), Woe(l2, 0, a), Woe(l2, 1, a), l2[0] > l2[1] && (l2[0] = l2[1]);
    }
    function Ryt(l2, a) {
      return l2 >= a[0] && l2 <= a[1];
    }
    function Nyt(l2, a) {
      return a[1] === a[0] ? 0.5 : (l2 - a[0]) / (a[1] - a[0]);
    }
    function Fyt(l2, a) {
      return l2 * (a[1] - a[0]) + a[0];
    }
    var Goe = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        d2.type = "ordinal";
        var y2 = d2.getSetting("ordinalMeta");
        return y2 || (y2 = new DLt({})), Ba2(y2) && (y2 = new DLt({ categories: $a2(y2, function(x2) {
          return vs(x2) ? x2.value : x2;
        }) })), d2._ordinalMeta = y2, d2._extent = d2.getSetting("extent") || [0, y2.categories.length - 1], d2;
      }
      return a.prototype.parse = function(e2) {
        return ps(e2) ? this._ordinalMeta.getOrdinal(e2) : Math.round(e2);
      }, a.prototype.contain = function(e2) {
        return e2 = this.parse(e2), Ryt(e2, this._extent) && this._ordinalMeta.categories[e2] != null;
      }, a.prototype.normalize = function(e2) {
        return e2 = this._getTickNumber(this.parse(e2)), Nyt(e2, this._extent);
      }, a.prototype.scale = function(e2) {
        return e2 = Math.round(Fyt(e2, this._extent)), this.getRawOrdinalNumber(e2);
      }, a.prototype.getTicks = function() {
        for (var e2 = [], d2 = this._extent, y2 = d2[0]; y2 <= d2[1]; )
          e2.push({ value: y2 }), y2++;
        return e2;
      }, a.prototype.getMinorTicks = function(e2) {
      }, a.prototype.setSortInfo = function(e2) {
        if (e2 == null) {
          this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
          return;
        }
        for (var d2 = e2.ordinalNumbers, y2 = this._ordinalNumbersByTick = [], x2 = this._ticksByOrdinalNumber = [], C = 0, D2 = this._ordinalMeta.categories.length, L = Math.min(D2, d2.length); C < L; ++C) {
          var F3 = d2[C];
          y2[C] = F3, x2[F3] = C;
        }
        for (var j = 0; C < D2; ++C) {
          for (; x2[j] != null; )
            j++;
          y2.push(j), x2[j] = C;
        }
      }, a.prototype._getTickNumber = function(e2) {
        var d2 = this._ticksByOrdinalNumber;
        return d2 && e2 >= 0 && e2 < d2.length ? d2[e2] : e2;
      }, a.prototype.getRawOrdinalNumber = function(e2) {
        var d2 = this._ordinalNumbersByTick;
        return d2 && e2 >= 0 && e2 < d2.length ? d2[e2] : e2;
      }, a.prototype.getLabel = function(e2) {
        if (!this.isBlank()) {
          var d2 = this.getRawOrdinalNumber(e2.value), y2 = this._ordinalMeta.categories[d2];
          return y2 == null ? "" : y2 + "";
        }
      }, a.prototype.count = function() {
        return this._extent[1] - this._extent[0] + 1;
      }, a.prototype.unionExtentFromData = function(e2, d2) {
        this.unionExtent(e2.getApproximateExtent(d2));
      }, a.prototype.isInExtentRange = function(e2) {
        return e2 = this._getTickNumber(e2), this._extent[0] <= e2 && this._extent[1] >= e2;
      }, a.prototype.getOrdinalMeta = function() {
        return this._ordinalMeta;
      }, a.prototype.calcNiceTicks = function() {
      }, a.prototype.calcNiceExtent = function() {
      }, a.type = "ordinal", a;
    }(LO);
    LO.registerClass(Goe);
    var PLt = Goe, cB = kv, Hoe = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "interval", e2._interval = 0, e2._intervalPrecision = 2, e2;
      }
      return a.prototype.parse = function(e2) {
        return e2;
      }, a.prototype.contain = function(e2) {
        return Ryt(e2, this._extent);
      }, a.prototype.normalize = function(e2) {
        return Nyt(e2, this._extent);
      }, a.prototype.scale = function(e2) {
        return Fyt(e2, this._extent);
      }, a.prototype.setExtent = function(e2, d2) {
        var y2 = this._extent;
        isNaN(e2) || (y2[0] = parseFloat(e2)), isNaN(d2) || (y2[1] = parseFloat(d2));
      }, a.prototype.unionExtent = function(e2) {
        var d2 = this._extent;
        e2[0] < d2[0] && (d2[0] = e2[0]), e2[1] > d2[1] && (d2[1] = e2[1]), this.setExtent(d2[0], d2[1]);
      }, a.prototype.getInterval = function() {
        return this._interval;
      }, a.prototype.setInterval = function(e2) {
        this._interval = e2, this._niceExtent = this._extent.slice(), this._intervalPrecision = joe(e2);
      }, a.prototype.getTicks = function(e2) {
        var d2 = this._interval, y2 = this._extent, x2 = this._niceExtent, C = this._intervalPrecision, D2 = [];
        if (!d2)
          return D2;
        var L = 1e4;
        y2[0] < x2[0] && (e2 ? D2.push({ value: cB(x2[0] - d2, C) }) : D2.push({ value: y2[0] }));
        for (var F3 = x2[0]; F3 <= x2[1] && (D2.push({ value: F3 }), F3 = cB(F3 + d2, C), F3 !== D2[D2.length - 1].value); )
          if (D2.length > L)
            return [];
        var j = D2.length ? D2[D2.length - 1].value : x2[1];
        return y2[1] > j && (e2 ? D2.push({ value: cB(j + d2, C) }) : D2.push({ value: y2[1] })), D2;
      }, a.prototype.getMinorTicks = function(e2) {
        for (var d2 = this.getTicks(true), y2 = [], x2 = this.getExtent(), C = 1; C < d2.length; C++) {
          for (var D2 = d2[C], L = d2[C - 1], F3 = 0, j = [], U3 = D2.value - L.value, Y3 = U3 / e2; F3 < e2 - 1; ) {
            var Q = cB(L.value + (F3 + 1) * Y3);
            Q > x2[0] && Q < x2[1] && j.push(Q), F3++;
          }
          y2.push(j);
        }
        return y2;
      }, a.prototype.getLabel = function(e2, d2) {
        if (e2 == null)
          return "";
        var y2 = d2 && d2.precision;
        y2 == null ? y2 = $2(e2.value) || 0 : y2 === "auto" && (y2 = this._intervalPrecision);
        var x2 = cB(e2.value, y2, true);
        return uie(x2);
      }, a.prototype.calcNiceTicks = function(e2, d2, y2) {
        e2 = e2 || 5;
        var x2 = this._extent, C = x2[1] - x2[0];
        if (isFinite(C)) {
          C < 0 && (C = -C, x2.reverse());
          var D2 = LXe(x2, e2, d2, y2);
          this._intervalPrecision = D2.intervalPrecision, this._interval = D2.interval, this._niceExtent = D2.niceTickExtent;
        }
      }, a.prototype.calcNiceExtent = function(e2) {
        var d2 = this._extent;
        if (d2[0] === d2[1])
          if (d2[0] !== 0) {
            var y2 = d2[0];
            e2.fixMax || (d2[1] += y2 / 2), d2[0] -= y2 / 2;
          } else
            d2[1] = 1;
        var x2 = d2[1] - d2[0];
        isFinite(x2) || (d2[0] = 0, d2[1] = 1), this.calcNiceTicks(e2.splitNumber, e2.minInterval, e2.maxInterval);
        var C = this._interval;
        e2.fixMin || (d2[0] = cB(Math.floor(d2[0] / C) * C)), e2.fixMax || (d2[1] = cB(Math.ceil(d2[1] / C) * C));
      }, a.prototype.setNiceExtent = function(e2, d2) {
        this._niceExtent = [e2, d2];
      }, a.type = "interval", a;
    }(LO);
    LO.registerClass(Hoe);
    var eF = Hoe, Uoe = typeof Float32Array != "undefined", RXe = Uoe ? Float32Array : Array;
    function lP(l2) {
      return Ba2(l2) ? Uoe ? new Float32Array(l2) : l2 : new RXe(l2);
    }
    var LLt = "__ec_stack_";
    function OLt(l2) {
      return l2.get("stack") || LLt + l2.seriesIndex;
    }
    function RLt(l2) {
      return l2.dim + l2.index;
    }
    function NXe(l2) {
      var a = [], e2 = l2.axis, d2 = "axis0";
      if (e2.type === "category") {
        for (var y2 = e2.getBandWidth(), x2 = 0; x2 < l2.count; x2++)
          a.push(El({ bandWidth: y2, axisKey: d2, stackId: LLt + x2 }, l2));
        for (var C = $oe(a), D2 = [], x2 = 0; x2 < l2.count; x2++) {
          var L = C[d2][LLt + x2];
          L.offsetCenter = L.offset + L.width / 2, D2.push(L);
        }
        return D2;
      }
    }
    function qoe(l2, a) {
      var e2 = [];
      return a.eachSeriesByType(l2, function(d2) {
        Xoe(d2) && e2.push(d2);
      }), e2;
    }
    function FXe(l2) {
      var a = {};
      Ke2(l2, function(L) {
        var F3 = L.coordinateSystem, j = F3.getBaseAxis();
        if (!(j.type !== "time" && j.type !== "value"))
          for (var U3 = L.getData(), Y3 = j.dim + "_" + j.index, Q = U3.getDimensionIndex(U3.mapDimension(j.dim)), nt = U3.getStore(), dt = 0, vt = nt.count(); dt < vt; ++dt) {
            var Ct = nt.get(Q, dt);
            a[Y3] ? a[Y3].push(Ct) : a[Y3] = [Ct];
          }
      });
      var e2 = {};
      for (var d2 in a)
        if (a.hasOwnProperty(d2)) {
          var y2 = a[d2];
          if (y2) {
            y2.sort(function(L, F3) {
              return L - F3;
            });
            for (var x2 = null, C = 1; C < y2.length; ++C) {
              var D2 = y2[C] - y2[C - 1];
              D2 > 0 && (x2 = x2 === null ? D2 : Math.min(x2, D2));
            }
            e2[d2] = x2;
          }
        }
      return e2;
    }
    function Zoe(l2) {
      var a = FXe(l2), e2 = [];
      return Ke2(l2, function(d2) {
        var y2 = d2.coordinateSystem, x2 = y2.getBaseAxis(), C = x2.getExtent(), D2;
        if (x2.type === "category")
          D2 = x2.getBandWidth();
        else if (x2.type === "value" || x2.type === "time") {
          var L = x2.dim + "_" + x2.index, F3 = a[L], j = Math.abs(C[1] - C[0]), U3 = x2.scale.getExtent(), Y3 = Math.abs(U3[1] - U3[0]);
          D2 = F3 ? j / Y3 * F3 : j;
        } else {
          var Q = d2.getData();
          D2 = Math.abs(C[1] - C[0]) / Q.count();
        }
        var nt = Ko(d2.get("barWidth"), D2), dt = Ko(d2.get("barMaxWidth"), D2), vt = Ko(d2.get("barMinWidth") || (Qoe(d2) ? 0.5 : 1), D2), Ct = d2.get("barGap"), Pt = d2.get("barCategoryGap");
        e2.push({ bandWidth: D2, barWidth: nt, barMaxWidth: dt, barMinWidth: vt, barGap: Ct, barCategoryGap: Pt, axisKey: RLt(x2), stackId: OLt(d2) });
      }), $oe(e2);
    }
    function $oe(l2) {
      var a = {};
      Ke2(l2, function(d2, y2) {
        var x2 = d2.axisKey, C = d2.bandWidth, D2 = a[x2] || { bandWidth: C, remainedWidth: C, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, L = D2.stacks;
        a[x2] = D2;
        var F3 = d2.stackId;
        L[F3] || D2.autoWidthCount++, L[F3] = L[F3] || { width: 0, maxWidth: 0 };
        var j = d2.barWidth;
        j && !L[F3].width && (L[F3].width = j, j = Math.min(D2.remainedWidth, j), D2.remainedWidth -= j);
        var U3 = d2.barMaxWidth;
        U3 && (L[F3].maxWidth = U3);
        var Y3 = d2.barMinWidth;
        Y3 && (L[F3].minWidth = Y3);
        var Q = d2.barGap;
        Q != null && (D2.gap = Q);
        var nt = d2.barCategoryGap;
        nt != null && (D2.categoryGap = nt);
      });
      var e2 = {};
      return Ke2(a, function(d2, y2) {
        e2[y2] = {};
        var x2 = d2.stacks, C = d2.bandWidth, D2 = d2.categoryGap;
        if (D2 == null) {
          var L = Qc2(x2).length;
          D2 = Math.max(35 - L * 4, 15) + "%";
        }
        var F3 = Ko(D2, C), j = Ko(d2.gap, 1), U3 = d2.remainedWidth, Y3 = d2.autoWidthCount, Q = (U3 - F3) / (Y3 + (Y3 - 1) * j);
        Q = Math.max(Q, 0), Ke2(x2, function(Ct) {
          var Pt = Ct.maxWidth, jt = Ct.minWidth;
          if (Ct.width) {
            var Rt = Ct.width;
            Pt && (Rt = Math.min(Rt, Pt)), jt && (Rt = Math.max(Rt, jt)), Ct.width = Rt, U3 -= Rt + j * Rt, Y3--;
          } else {
            var Rt = Q;
            Pt && Pt < Rt && (Rt = Math.min(Pt, U3)), jt && jt > Rt && (Rt = jt), Rt !== Q && (Ct.width = Rt, U3 -= Rt + j * Rt, Y3--);
          }
        }), Q = (U3 - F3) / (Y3 + (Y3 - 1) * j), Q = Math.max(Q, 0);
        var nt = 0, dt;
        Ke2(x2, function(Ct, Pt) {
          Ct.width || (Ct.width = Q), dt = Ct, nt += Ct.width * (1 + j);
        }), dt && (nt -= dt.width * j);
        var vt = -nt / 2;
        Ke2(x2, function(Ct, Pt) {
          e2[y2][Pt] = e2[y2][Pt] || { bandWidth: C, offset: vt, width: Ct.width }, vt += Ct.width * (1 + j);
        });
      }), e2;
    }
    function VXe(l2, a, e2) {
      if (l2 && a) {
        var d2 = l2[RLt(a)];
        return d2 != null && e2 != null ? d2[OLt(e2)] : d2;
      }
    }
    function Yoe(l2, a) {
      var e2 = qoe(l2, a), d2 = Zoe(e2);
      Ke2(e2, function(y2) {
        var x2 = y2.getData(), C = y2.coordinateSystem, D2 = C.getBaseAxis(), L = OLt(y2), F3 = d2[RLt(D2)][L], j = F3.offset, U3 = F3.width;
        x2.setLayout({ bandWidth: F3.bandWidth, offset: j, size: U3 });
      });
    }
    function Koe(l2) {
      return { seriesType: l2, plan: Kq(), reset: function(a) {
        if (Xoe(a)) {
          var e2 = a.getData(), d2 = a.coordinateSystem, y2 = d2.getBaseAxis(), x2 = d2.getOtherAxis(y2), C = e2.getDimensionIndex(e2.mapDimension(x2.dim)), D2 = e2.getDimensionIndex(e2.mapDimension(y2.dim)), L = a.get("showBackground", true), F3 = e2.mapDimension(x2.dim), j = e2.getCalculationInfo("stackResultDimension"), U3 = tF(e2, F3) && !!e2.getCalculationInfo("stackedOnSeries"), Y3 = x2.isHorizontal(), Q = BXe(y2, x2), nt = Qoe(a), dt = a.get("barMinHeight") || 0, vt = j && e2.getDimensionIndex(j), Ct = e2.getLayout("size"), Pt = e2.getLayout("offset");
          return { progress: function(jt, Rt) {
            for (var le2 = jt.count, ne2 = nt && lP(le2 * 3), he2 = nt && L && lP(le2 * 3), _e = nt && lP(le2), Me2 = d2.master.getRect(), Pe2 = Y3 ? Me2.width : Me2.height, Be2, Je2 = Rt.getStore(), Ze2 = 0; (Be2 = jt.next()) != null; ) {
              var Cn = Je2.get(U3 ? vt : C, Be2), Bn = Je2.get(D2, Be2), mn = Q, Kr = void 0;
              U3 && (Kr = +Cn - Je2.get(C, Be2));
              var Kn = void 0, ar = void 0, Cr = void 0, ui2 = void 0;
              if (Y3) {
                var vi2 = d2.dataToPoint([Cn, Bn]);
                if (U3) {
                  var ko = d2.dataToPoint([Kr, Bn]);
                  mn = ko[0];
                }
                Kn = mn, ar = vi2[1] + Pt, Cr = vi2[0] - mn, ui2 = Ct, Math.abs(Cr) < dt && (Cr = (Cr < 0 ? -1 : 1) * dt);
              } else {
                var vi2 = d2.dataToPoint([Bn, Cn]);
                if (U3) {
                  var ko = d2.dataToPoint([Bn, Kr]);
                  mn = ko[1];
                }
                Kn = vi2[0] + Pt, ar = mn, Cr = Ct, ui2 = vi2[1] - mn, Math.abs(ui2) < dt && (ui2 = (ui2 <= 0 ? -1 : 1) * dt);
              }
              nt ? (ne2[Ze2] = Kn, ne2[Ze2 + 1] = ar, ne2[Ze2 + 2] = Y3 ? Cr : ui2, he2 && (he2[Ze2] = Y3 ? Me2.x : Kn, he2[Ze2 + 1] = Y3 ? ar : Me2.y, he2[Ze2 + 2] = Pe2), _e[Be2] = Be2) : Rt.setItemLayout(Be2, { x: Kn, y: ar, width: Cr, height: ui2 }), Ze2 += 3;
            }
            nt && Rt.setLayout({ largePoints: ne2, largeDataIndices: _e, largeBackgroundPoints: he2, valueAxisHorizontal: Y3 });
          } };
        }
      } };
    }
    function Xoe(l2) {
      return l2.coordinateSystem && l2.coordinateSystem.type === "cartesian2d";
    }
    function Qoe(l2) {
      return l2.pipelineContext && l2.pipelineContext.large;
    }
    function BXe(l2, a) {
      return a.toGlobalCoord(a.dataToCoord(a.type === "log" ? 1 : 0));
    }
    var zXe = function(l2, a, e2, d2) {
      for (; e2 < d2; ) {
        var y2 = e2 + d2 >>> 1;
        l2[y2][1] < a ? e2 = y2 + 1 : d2 = y2;
      }
      return e2;
    }, Joe = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "time", d2;
      }
      return a.prototype.getLabel = function(e2) {
        var d2 = this.getSetting("useUTC");
        return ryt(e2.value, Jre[s$e(jq(this._minLevelUnit))] || Jre.second, d2, this.getSetting("locale"));
      }, a.prototype.getFormattedLabel = function(e2, d2, y2) {
        var x2 = this.getSetting("useUTC"), C = this.getSetting("locale");
        return l$e(e2, d2, y2, C, x2);
      }, a.prototype.getTicks = function() {
        var e2 = this._interval, d2 = this._extent, y2 = [];
        if (!e2)
          return y2;
        y2.push({ value: d2[0], level: 0 });
        var x2 = this.getSetting("useUTC"), C = ZXe(this._minLevelUnit, this._approxInterval, x2, d2);
        return y2 = y2.concat(C), y2.push({ value: d2[1], level: 0 }), y2;
      }, a.prototype.calcNiceExtent = function(e2) {
        var d2 = this._extent;
        if (d2[0] === d2[1] && (d2[0] -= SA, d2[1] += SA), d2[1] === -1 / 0 && d2[0] === 1 / 0) {
          var y2 = new Date();
          d2[1] = +new Date(y2.getFullYear(), y2.getMonth(), y2.getDate()), d2[0] = d2[1] - SA;
        }
        this.calcNiceTicks(e2.splitNumber, e2.minInterval, e2.maxInterval);
      }, a.prototype.calcNiceTicks = function(e2, d2, y2) {
        e2 = e2 || 10;
        var x2 = this._extent, C = x2[1] - x2[0];
        this._approxInterval = C / e2, d2 != null && this._approxInterval < d2 && (this._approxInterval = d2), y2 != null && this._approxInterval > y2 && (this._approxInterval = y2);
        var D2 = Vyt.length, L = Math.min(zXe(Vyt, this._approxInterval, 0, D2), D2 - 1);
        this._interval = Vyt[L][1], this._minLevelUnit = Vyt[Math.max(L - 1, 0)][0];
      }, a.prototype.parse = function(e2) {
        return Ch2(e2) ? e2 : +Am(e2);
      }, a.prototype.contain = function(e2) {
        return Ryt(this.parse(e2), this._extent);
      }, a.prototype.normalize = function(e2) {
        return Nyt(this.parse(e2), this._extent);
      }, a.prototype.scale = function(e2) {
        return Fyt(e2, this._extent);
      }, a.type = "time", a;
    }(eF), Vyt = [["second", I3t], ["minute", D3t], ["hour", irt], ["quarter-day", irt * 6], ["half-day", irt * 12], ["day", SA * 1.2], ["half-week", SA * 3.5], ["week", SA * 7], ["month", SA * 31], ["quarter", SA * 95], ["half-year", Qre / 2], ["year", Qre]];
    function jXe(l2, a, e2, d2) {
      var y2 = Am(a), x2 = Am(e2), C = function(nt) {
        return nie(y2, nt, d2) === nie(x2, nt, d2);
      }, D2 = function() {
        return C("year");
      }, L = function() {
        return D2() && C("month");
      }, F3 = function() {
        return L() && C("day");
      }, j = function() {
        return F3() && C("hour");
      }, U3 = function() {
        return j() && C("minute");
      }, Y3 = function() {
        return U3() && C("second");
      }, Q = function() {
        return Y3() && C("millisecond");
      };
      switch (l2) {
        case "year":
          return D2();
        case "month":
          return L();
        case "day":
          return F3();
        case "hour":
          return j();
        case "minute":
          return U3();
        case "second":
          return Y3();
        case "millisecond":
          return Q();
      }
    }
    function WXe(l2, a) {
      return l2 /= SA, l2 > 16 ? 16 : l2 > 7.5 ? 7 : l2 > 3.5 ? 4 : l2 > 1.5 ? 2 : 1;
    }
    function GXe(l2) {
      var a = 30 * SA;
      return l2 /= a, l2 > 6 ? 6 : l2 > 3 ? 3 : l2 > 2 ? 2 : 1;
    }
    function HXe(l2) {
      return l2 /= irt, l2 > 12 ? 12 : l2 > 6 ? 6 : l2 > 3.5 ? 4 : l2 > 2 ? 2 : 1;
    }
    function tse(l2, a) {
      return l2 /= a ? D3t : I3t, l2 > 30 ? 30 : l2 > 20 ? 20 : l2 > 15 ? 15 : l2 > 10 ? 10 : l2 > 5 ? 5 : l2 > 2 ? 2 : 1;
    }
    function UXe(l2) {
      return Wvt(l2, true);
    }
    function qXe(l2, a, e2) {
      var d2 = new Date(l2);
      switch (jq(a)) {
        case "year":
        case "month":
          d2[rie(e2)](0);
        case "day":
          d2[iie(e2)](1);
        case "hour":
          d2[aie(e2)](0);
        case "minute":
          d2[oie(e2)](0);
        case "second":
          d2[sie(e2)](0), d2[lie(e2)](0);
      }
      return d2.getTime();
    }
    function ZXe(l2, a, e2, d2) {
      var y2 = 1e4, x2 = tie, C = 0;
      function D2(Pe2, Be2, Je2, Ze2, Cn, Bn, mn) {
        for (var Kr = new Date(Be2), Kn = Be2, ar = Kr[Ze2](); Kn < Je2 && Kn <= d2[1]; )
          mn.push({ value: Kn }), ar += Pe2, Kr[Cn](ar), Kn = Kr.getTime();
        mn.push({ value: Kn, notAdd: true });
      }
      function L(Pe2, Be2, Je2) {
        var Ze2 = [], Cn = !Be2.length;
        if (!jXe(jq(Pe2), d2[0], d2[1], e2)) {
          Cn && (Be2 = [{ value: qXe(new Date(d2[0]), Pe2, e2) }, { value: d2[1] }]);
          for (var Bn = 0; Bn < Be2.length - 1; Bn++) {
            var mn = Be2[Bn].value, Kr = Be2[Bn + 1].value;
            if (mn !== Kr) {
              var Kn = void 0, ar = void 0, Cr = void 0, ui2 = false;
              switch (Pe2) {
                case "year":
                  Kn = Math.max(1, Math.round(a / SA / 365)), ar = k3t(e2), Cr = u$e(e2);
                  break;
                case "half-year":
                case "quarter":
                case "month":
                  Kn = GXe(a), ar = Wq(e2), Cr = rie(e2);
                  break;
                case "week":
                case "half-week":
                case "day":
                  Kn = WXe(a), ar = iyt(e2), Cr = iie(e2), ui2 = true;
                  break;
                case "half-day":
                case "quarter-day":
                case "hour":
                  Kn = HXe(a), ar = ort(e2), Cr = aie(e2);
                  break;
                case "minute":
                  Kn = tse(a, true), ar = ayt(e2), Cr = oie(e2);
                  break;
                case "second":
                  Kn = tse(a, false), ar = oyt(e2), Cr = sie(e2);
                  break;
                case "millisecond":
                  Kn = UXe(a), ar = syt(e2), Cr = lie(e2);
                  break;
              }
              D2(Kn, mn, Kr, ar, Cr, ui2, Ze2), Pe2 === "year" && Je2.length > 1 && Bn === 0 && Je2.unshift({ value: Je2[0].value - Kn });
            }
          }
          for (var Bn = 0; Bn < Ze2.length; Bn++)
            Je2.push(Ze2[Bn]);
          return Ze2;
        }
      }
      for (var F3 = [], j = [], U3 = 0, Y3 = 0, Q = 0; Q < x2.length && C++ < y2; ++Q) {
        var nt = jq(x2[Q]);
        if (o$e(x2[Q])) {
          L(x2[Q], F3[F3.length - 1] || [], j);
          var dt = x2[Q + 1] ? jq(x2[Q + 1]) : null;
          if (nt !== dt) {
            if (j.length) {
              Y3 = U3, j.sort(function(Pe2, Be2) {
                return Pe2.value - Be2.value;
              });
              for (var vt = [], Ct = 0; Ct < j.length; ++Ct) {
                var Pt = j[Ct].value;
                (Ct === 0 || j[Ct - 1].value !== Pt) && (vt.push(j[Ct]), Pt >= d2[0] && Pt <= d2[1] && U3++);
              }
              var jt = (d2[1] - d2[0]) / a;
              if (U3 > jt * 1.5 && Y3 > jt / 1.5 || (F3.push(vt), U3 > jt || l2 === x2[Q]))
                break;
            }
            j = [];
          }
        }
      }
      for (var Rt = Lp($a2(F3, function(Be2) {
        return Lp(Be2, function(Je2) {
          return Je2.value >= d2[0] && Je2.value <= d2[1] && !Je2.notAdd;
        });
      }), function(Be2) {
        return Be2.length > 0;
      }), le2 = [], ne2 = Rt.length - 1, Q = 0; Q < Rt.length; ++Q)
        for (var he2 = Rt[Q], _e = 0; _e < he2.length; ++_e)
          le2.push({ value: he2[_e].value, level: ne2 - Q });
      le2.sort(function(Pe2, Be2) {
        return Pe2.value - Be2.value;
      });
      for (var Me2 = [], Q = 0; Q < le2.length; ++Q)
        (Q === 0 || le2[Q].value !== le2[Q - 1].value) && Me2.push(le2[Q]);
      return Me2;
    }
    LO.registerClass(Joe);
    var ese = Joe, nse = LO.prototype, krt = eF.prototype, $Xe = kv, YXe = Math.floor, KXe = Math.ceil, Byt = Math.pow, IA = Math.log, NLt = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "log", e2.base = 10, e2._originalScale = new eF(), e2._interval = 0, e2;
      }
      return a.prototype.getTicks = function(e2) {
        var d2 = this._originalScale, y2 = this._extent, x2 = d2.getExtent(), C = krt.getTicks.call(this, e2);
        return $a2(C, function(D2) {
          var L = D2.value, F3 = kv(Byt(this.base, L));
          return F3 = L === y2[0] && this._fixMin ? zyt(F3, x2[0]) : F3, F3 = L === y2[1] && this._fixMax ? zyt(F3, x2[1]) : F3, { value: F3 };
        }, this);
      }, a.prototype.setExtent = function(e2, d2) {
        var y2 = this.base;
        e2 = IA(e2) / IA(y2), d2 = IA(d2) / IA(y2), krt.setExtent.call(this, e2, d2);
      }, a.prototype.getExtent = function() {
        var e2 = this.base, d2 = nse.getExtent.call(this);
        d2[0] = Byt(e2, d2[0]), d2[1] = Byt(e2, d2[1]);
        var y2 = this._originalScale, x2 = y2.getExtent();
        return this._fixMin && (d2[0] = zyt(d2[0], x2[0])), this._fixMax && (d2[1] = zyt(d2[1], x2[1])), d2;
      }, a.prototype.unionExtent = function(e2) {
        this._originalScale.unionExtent(e2);
        var d2 = this.base;
        e2[0] = IA(e2[0]) / IA(d2), e2[1] = IA(e2[1]) / IA(d2), nse.unionExtent.call(this, e2);
      }, a.prototype.unionExtentFromData = function(e2, d2) {
        this.unionExtent(e2.getApproximateExtent(d2));
      }, a.prototype.calcNiceTicks = function(e2) {
        e2 = e2 || 10;
        var d2 = this._extent, y2 = d2[1] - d2[0];
        if (!(y2 === 1 / 0 || y2 <= 0)) {
          var x2 = jvt(y2), C = e2 / y2 * x2;
          for (C <= 0.5 && (x2 *= 10); !isNaN(x2) && Math.abs(x2) < 1 && Math.abs(x2) > 0; )
            x2 *= 10;
          var D2 = [kv(KXe(d2[0] / x2) * x2), kv(YXe(d2[1] / x2) * x2)];
          this._interval = x2, this._niceExtent = D2;
        }
      }, a.prototype.calcNiceExtent = function(e2) {
        krt.calcNiceExtent.call(this, e2), this._fixMin = e2.fixMin, this._fixMax = e2.fixMax;
      }, a.prototype.parse = function(e2) {
        return e2;
      }, a.prototype.contain = function(e2) {
        return e2 = IA(e2) / IA(this.base), Ryt(e2, this._extent);
      }, a.prototype.normalize = function(e2) {
        return e2 = IA(e2) / IA(this.base), Nyt(e2, this._extent);
      }, a.prototype.scale = function(e2) {
        return e2 = Fyt(e2, this._extent), Byt(this.base, e2);
      }, a.type = "log", a;
    }(LO), rse = NLt.prototype;
    rse.getMinorTicks = krt.getMinorTicks, rse.getLabel = krt.getLabel;
    function zyt(l2, a) {
      return $Xe(l2, $2(a));
    }
    LO.registerClass(NLt);
    var XXe = NLt, QXe = function() {
      function l2(a, e2, d2) {
        this._prepareParams(a, e2, d2);
      }
      return l2.prototype._prepareParams = function(a, e2, d2) {
        d2[1] < d2[0] && (d2 = [NaN, NaN]), this._dataMin = d2[0], this._dataMax = d2[1];
        var y2 = this._isOrdinal = a.type === "ordinal";
        this._needCrossZero = a.type === "interval" && e2.getNeedCrossZero && e2.getNeedCrossZero();
        var x2 = this._modelMinRaw = e2.get("min", true);
        wl(x2) ? this._modelMinNum = jyt(a, x2({ min: d2[0], max: d2[1] })) : x2 !== "dataMin" && (this._modelMinNum = jyt(a, x2));
        var C = this._modelMaxRaw = e2.get("max", true);
        if (wl(C) ? this._modelMaxNum = jyt(a, C({ min: d2[0], max: d2[1] })) : C !== "dataMax" && (this._modelMaxNum = jyt(a, C)), y2)
          this._axisDataLen = e2.getCategories().length;
        else {
          var D2 = e2.get("boundaryGap"), L = Ba2(D2) ? D2 : [D2 || 0, D2 || 0];
          typeof L[0] == "boolean" || typeof L[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [Tm(L[0], 1), Tm(L[1], 1)];
        }
      }, l2.prototype.calculate = function() {
        var a = this._isOrdinal, e2 = this._dataMin, d2 = this._dataMax, y2 = this._axisDataLen, x2 = this._boundaryGapInner, C = a ? null : d2 - e2 || Math.abs(e2), D2 = this._modelMinRaw === "dataMin" ? e2 : this._modelMinNum, L = this._modelMaxRaw === "dataMax" ? d2 : this._modelMaxNum, F3 = D2 != null, j = L != null;
        D2 == null && (D2 = a ? y2 ? 0 : NaN : e2 - x2[0] * C), L == null && (L = a ? y2 ? y2 - 1 : NaN : d2 + x2[1] * C), (D2 == null || !isFinite(D2)) && (D2 = NaN), (L == null || !isFinite(L)) && (L = NaN);
        var U3 = pV(D2) || pV(L) || a && !y2;
        this._needCrossZero && (D2 > 0 && L > 0 && !F3 && (D2 = 0), D2 < 0 && L < 0 && !j && (L = 0));
        var Y3 = this._determinedMin, Q = this._determinedMax;
        return Y3 != null && (D2 = Y3, F3 = true), Q != null && (L = Q, j = true), { min: D2, max: L, minFixed: F3, maxFixed: j, isBlank: U3 };
      }, l2.prototype.modifyDataMinMax = function(a, e2) {
        this[tQe[a]] = e2;
      }, l2.prototype.setDeterminedMinMax = function(a, e2) {
        var d2 = JXe[a];
        this[d2] = e2;
      }, l2.prototype.freeze = function() {
        this.frozen = true;
      }, l2;
    }(), JXe = { min: "_determinedMin", max: "_determinedMax" }, tQe = { min: "_dataMin", max: "_dataMax" };
    function ise(l2, a, e2) {
      var d2 = l2.rawExtentInfo;
      return d2 || (d2 = new QXe(l2, a, e2), l2.rawExtentInfo = d2, d2);
    }
    function jyt(l2, a) {
      return a == null ? null : pV(a) ? NaN : l2.parse(a);
    }
    function ase(l2, a) {
      var e2 = l2.type, d2 = ise(l2, a, l2.getExtent()).calculate();
      l2.setBlank(d2.isBlank);
      var y2 = d2.min, x2 = d2.max, C = a.ecModel;
      if (C && e2 === "time") {
        var D2 = qoe("bar", C), L = false;
        if (Ke2(D2, function(U3) {
          L = L || U3.getBaseAxis() === a.axis;
        }), L) {
          var F3 = Zoe(D2), j = eQe(y2, x2, a, F3);
          y2 = j.min, x2 = j.max;
        }
      }
      return { extent: [y2, x2], fixMin: d2.minFixed, fixMax: d2.maxFixed };
    }
    function eQe(l2, a, e2, d2) {
      var y2 = e2.axis.getExtent(), x2 = y2[1] - y2[0], C = VXe(d2, e2.axis);
      if (C === void 0)
        return { min: l2, max: a };
      var D2 = 1 / 0;
      Ke2(C, function(Q) {
        D2 = Math.min(Q.offset, D2);
      });
      var L = -1 / 0;
      Ke2(C, function(Q) {
        L = Math.max(Q.offset + Q.width, L);
      }), D2 = Math.abs(D2), L = Math.abs(L);
      var F3 = D2 + L, j = a - l2, U3 = 1 - (D2 + L) / x2, Y3 = j / U3 - j;
      return a += Y3 * (L / F3), l2 -= Y3 * (D2 / F3), { min: l2, max: a };
    }
    function iZ(l2, a) {
      var e2 = a, d2 = ase(l2, e2), y2 = d2.extent, x2 = e2.get("splitNumber");
      l2 instanceof XXe && (l2.base = e2.get("logBase"));
      var C = l2.type, D2 = e2.get("interval"), L = C === "interval" || C === "time";
      l2.setExtent(y2[0], y2[1]), l2.calcNiceExtent({ splitNumber: x2, fixMin: d2.fixMin, fixMax: d2.fixMax, minInterval: L ? e2.get("minInterval") : null, maxInterval: L ? e2.get("maxInterval") : null }), D2 != null && l2.setInterval && l2.setInterval(D2);
    }
    function Wyt(l2, a) {
      if (a = a || l2.get("type"), a)
        switch (a) {
          case "category":
            return new PLt({ ordinalMeta: l2.getOrdinalMeta ? l2.getOrdinalMeta() : l2.getCategories(), extent: [1 / 0, -1 / 0] });
          case "time":
            return new ese({ locale: l2.ecModel.getLocaleModel(), useUTC: l2.ecModel.get("useUTC") });
          default:
            return new (LO.getClass(a) || eF)();
        }
    }
    function nQe(l2) {
      var a = l2.scale.getExtent(), e2 = a[0], d2 = a[1];
      return !(e2 > 0 && d2 > 0 || e2 < 0 && d2 < 0);
    }
    function Prt(l2) {
      var a = l2.getLabelModel().get("formatter"), e2 = l2.type === "category" ? l2.scale.getExtent()[0] : null;
      return l2.scale.type === "time" ? function(d2) {
        return function(y2, x2) {
          return l2.scale.getFormattedLabel(y2, x2, d2);
        };
      }(a) : ps(a) ? function(d2) {
        return function(y2) {
          var x2 = l2.scale.getLabel(y2), C = d2.replace("{value}", x2 != null ? x2 : "");
          return C;
        };
      }(a) : wl(a) ? function(d2) {
        return function(y2, x2) {
          return e2 != null && (x2 = y2.value - e2), d2(FLt(l2, y2), x2, y2.level != null ? { level: y2.level } : null);
        };
      }(a) : function(d2) {
        return l2.scale.getLabel(d2);
      };
    }
    function FLt(l2, a) {
      return l2.type === "category" ? l2.scale.getLabel(a) : a.value;
    }
    function rQe(l2) {
      var a = l2.model, e2 = l2.scale;
      if (!(!a.get(["axisLabel", "show"]) || e2.isBlank())) {
        var d2, y2, x2 = e2.getExtent();
        e2 instanceof PLt ? y2 = e2.count() : (d2 = e2.getTicks(), y2 = d2.length);
        var C = l2.getLabelModel(), D2 = Prt(l2), L, F3 = 1;
        y2 > 40 && (F3 = Math.ceil(y2 / 40));
        for (var j = 0; j < y2; j += F3) {
          var U3 = d2 ? d2[j] : { value: x2[0] + j }, Y3 = D2(U3, j), Q = C.getTextRect(Y3), nt = iQe(Q, C.get("rotate") || 0);
          L ? L.union(nt) : L = nt;
        }
        return L;
      }
    }
    function iQe(l2, a) {
      var e2 = a * Math.PI / 180, d2 = l2.width, y2 = l2.height, x2 = d2 * Math.abs(Math.cos(e2)) + Math.abs(y2 * Math.sin(e2)), C = d2 * Math.abs(Math.sin(e2)) + Math.abs(y2 * Math.cos(e2)), D2 = new Yu(l2.x, l2.y, x2, C);
      return D2;
    }
    function VLt(l2) {
      var a = l2.get("interval");
      return a == null ? "auto" : a;
    }
    function ose(l2) {
      return l2.type === "category" && VLt(l2.getLabelModel()) === 0;
    }
    function Gyt(l2, a) {
      var e2 = {};
      return Ke2(l2.mapDimensionsAll(a), function(d2) {
        e2[Boe(l2, d2)] = true;
      }), Qc2(e2);
    }
    function aQe(l2, a, e2) {
      a && Ke2(Gyt(a, e2), function(d2) {
        var y2 = a.getApproximateExtent(d2);
        y2[0] < l2[0] && (l2[0] = y2[0]), y2[1] > l2[1] && (l2[1] = y2[1]);
      });
    }
    var Lrt = function() {
      function l2() {
      }
      return l2.prototype.getNeedCrossZero = function() {
        var a = this.option;
        return !a.scale;
      }, l2.prototype.getCoordSysModel = function() {
      }, l2;
    }(), oQe = 1e-8;
    function sse(l2, a) {
      return Math.abs(l2 - a) < oQe;
    }
    function fB(l2, a, e2) {
      var d2 = 0, y2 = l2[0];
      if (!y2)
        return false;
      for (var x2 = 1; x2 < l2.length; x2++) {
        var C = l2[x2];
        d2 += AE(y2[0], y2[1], C[0], C[1], a, e2), y2 = C;
      }
      var D2 = l2[0];
      return (!sse(y2[0], D2[0]) || !sse(y2[1], D2[1])) && (d2 += AE(y2[0], y2[1], D2[0], D2[1], a, e2)), d2 !== 0;
    }
    var sQe = [];
    function BLt(l2, a) {
      for (var e2 = 0; e2 < l2.length; e2++)
        Mm(l2[e2], l2[e2], a);
    }
    function lse(l2, a, e2, d2) {
      for (var y2 = 0; y2 < l2.length; y2++) {
        var x2 = l2[y2];
        d2 && (x2 = d2.project(x2)), x2 && isFinite(x2[0]) && isFinite(x2[1]) && (vE(a, a, x2), nA(e2, e2, x2));
      }
    }
    function lQe(l2) {
      for (var a = 0, e2 = 0, d2 = 0, y2 = l2.length, x2 = l2[y2 - 1][0], C = l2[y2 - 1][1], D2 = 0; D2 < y2; D2++) {
        var L = l2[D2][0], F3 = l2[D2][1], j = x2 * F3 - L * C;
        a += j, e2 += (x2 + L) * j, d2 += (C + F3) * j, x2 = L, C = F3;
      }
      return a ? [e2 / a / 3, d2 / a / 3, a] : [l2[0][0] || 0, l2[0][1] || 0];
    }
    var use2 = function() {
      function l2(a) {
        this.name = a;
      }
      return l2.prototype.setCenter = function(a) {
        this._center = a;
      }, l2.prototype.getCenter = function() {
        var a = this._center;
        return a || (a = this._center = this.calcCenter()), a;
      }, l2;
    }(), cse = function() {
      function l2(a, e2) {
        this.type = "polygon", this.exterior = a, this.interiors = e2;
      }
      return l2;
    }(), fse = function() {
      function l2(a) {
        this.type = "linestring", this.points = a;
      }
      return l2;
    }(), hse = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this, e2) || this;
        return x2.type = "geoJSON", x2.geometries = d2, x2._center = y2 && [y2[0], y2[1]], x2;
      }
      return a.prototype.calcCenter = function() {
        for (var e2 = this.geometries, d2, y2 = 0, x2 = 0; x2 < e2.length; x2++) {
          var C = e2[x2], D2 = C.exterior, L = D2 && D2.length;
          L > y2 && (d2 = C, y2 = L);
        }
        if (d2)
          return lQe(d2.exterior);
        var F3 = this.getBoundingRect();
        return [F3.x + F3.width / 2, F3.y + F3.height / 2];
      }, a.prototype.getBoundingRect = function(e2) {
        var d2 = this._rect;
        if (d2 && !e2)
          return d2;
        var y2 = [1 / 0, 1 / 0], x2 = [-1 / 0, -1 / 0], C = this.geometries;
        return Ke2(C, function(D2) {
          D2.type === "polygon" ? lse(D2.exterior, y2, x2, e2) : Ke2(D2.points, function(L) {
            lse(L, y2, x2, e2);
          });
        }), isFinite(y2[0]) && isFinite(y2[1]) && isFinite(x2[0]) && isFinite(x2[1]) || (y2[0] = y2[1] = x2[0] = x2[1] = 0), d2 = new Yu(y2[0], y2[1], x2[0] - y2[0], x2[1] - y2[1]), e2 || (this._rect = d2), d2;
      }, a.prototype.contain = function(e2) {
        var d2 = this.getBoundingRect(), y2 = this.geometries;
        if (!d2.contain(e2[0], e2[1]))
          return false;
        t:
          for (var x2 = 0, C = y2.length; x2 < C; x2++) {
            var D2 = y2[x2];
            if (D2.type === "polygon") {
              var L = D2.exterior, F3 = D2.interiors;
              if (fB(L, e2[0], e2[1])) {
                for (var j = 0; j < (F3 ? F3.length : 0); j++)
                  if (fB(F3[j], e2[0], e2[1]))
                    continue t;
                return true;
              }
            }
          }
        return false;
      }, a.prototype.transformTo = function(e2, d2, y2, x2) {
        var C = this.getBoundingRect(), D2 = C.width / C.height;
        y2 ? x2 || (x2 = y2 / D2) : y2 = D2 * x2;
        for (var L = new Yu(e2, d2, y2, x2), F3 = C.calculateTransform(L), j = this.geometries, U3 = 0; U3 < j.length; U3++) {
          var Y3 = j[U3];
          Y3.type === "polygon" ? (BLt(Y3.exterior, F3), Ke2(Y3.interiors, function(Q) {
            BLt(Q, F3);
          })) : Ke2(Y3.points, function(Q) {
            BLt(Q, F3);
          });
        }
        C = this._rect, C.copy(L), this._center = [C.x + C.width / 2, C.y + C.height / 2];
      }, a.prototype.cloneShallow = function(e2) {
        e2 == null && (e2 = this.name);
        var d2 = new a(e2, this.geometries, this._center);
        return d2._rect = this._rect, d2.transformTo = null, d2;
      }, a;
    }(use2), uQe = function(l2) {
      Jn(a, l2);
      function a(e2, d2) {
        var y2 = l2.call(this, e2) || this;
        return y2.type = "geoSVG", y2._elOnlyForCalculate = d2, y2;
      }
      return a.prototype.calcCenter = function() {
        for (var e2 = this._elOnlyForCalculate, d2 = e2.getBoundingRect(), y2 = [d2.x + d2.width / 2, d2.y + d2.height / 2], x2 = OV(sQe), C = e2; C && !C.isGeoSVGGraphicRoot; )
          lA(x2, C.getLocalTransform(), x2), C = C.parent;
        return sO(x2, x2), Mm(y2, y2, x2), y2;
      }, a;
    }(use2);
    function cQe(l2) {
      if (!l2.UTF8Encoding)
        return l2;
      var a = l2, e2 = a.UTF8Scale;
      e2 == null && (e2 = 1024);
      var d2 = a.features;
      return Ke2(d2, function(y2) {
        var x2 = y2.geometry, C = x2.encodeOffsets, D2 = x2.coordinates;
        if (C)
          switch (x2.type) {
            case "LineString":
              x2.coordinates = pse(D2, C, e2);
              break;
            case "Polygon":
              zLt(D2, C, e2);
              break;
            case "MultiLineString":
              zLt(D2, C, e2);
              break;
            case "MultiPolygon":
              Ke2(D2, function(L, F3) {
                return zLt(L, C[F3], e2);
              });
          }
      }), a.UTF8Encoding = false, a;
    }
    function zLt(l2, a, e2) {
      for (var d2 = 0; d2 < l2.length; d2++)
        l2[d2] = pse(l2[d2], a[d2], e2);
    }
    function pse(l2, a, e2) {
      for (var d2 = [], y2 = a[0], x2 = a[1], C = 0; C < l2.length; C += 2) {
        var D2 = l2.charCodeAt(C) - 64, L = l2.charCodeAt(C + 1) - 64;
        D2 = D2 >> 1 ^ -(D2 & 1), L = L >> 1 ^ -(L & 1), D2 += y2, L += x2, y2 = D2, x2 = L, d2.push([D2 / e2, L / e2]);
      }
      return d2;
    }
    function fQe(l2, a) {
      return l2 = cQe(l2), $a2(Lp(l2.features, function(e2) {
        return e2.geometry && e2.properties && e2.geometry.coordinates.length > 0;
      }), function(e2) {
        var d2 = e2.properties, y2 = e2.geometry, x2 = [];
        switch (y2.type) {
          case "Polygon":
            var C = y2.coordinates;
            x2.push(new cse(C[0], C.slice(1)));
            break;
          case "MultiPolygon":
            Ke2(y2.coordinates, function(L) {
              L[0] && x2.push(new cse(L[0], L.slice(1)));
            });
            break;
          case "LineString":
            x2.push(new fse([y2.coordinates]));
            break;
          case "MultiLineString":
            x2.push(new fse(y2.coordinates));
        }
        var D2 = new hse(d2[a || "name"], x2, d2.cp);
        return D2.properties = d2, D2;
      });
    }
    var Ort = Rf2();
    function hQe(l2) {
      return l2.type === "category" ? dQe(l2) : vQe(l2);
    }
    function pQe(l2, a) {
      return l2.type === "category" ? gQe(l2, a) : { ticks: $a2(l2.scale.getTicks(), function(e2) {
        return e2.value;
      }) };
    }
    function dQe(l2) {
      var a = l2.getLabelModel(), e2 = dse(l2, a);
      return !a.get("show") || l2.scale.isBlank() ? { labels: [], labelCategoryInterval: e2.labelCategoryInterval } : e2;
    }
    function dse(l2, a) {
      var e2 = gse(l2, "labels"), d2 = VLt(a), y2 = vse(e2, d2);
      if (y2)
        return y2;
      var x2, C;
      return wl(d2) ? x2 = bse(l2, d2) : (C = d2 === "auto" ? yQe(l2) : d2, x2 = mse(l2, C)), yse(e2, d2, { labels: x2, labelCategoryInterval: C });
    }
    function gQe(l2, a) {
      var e2 = gse(l2, "ticks"), d2 = VLt(a), y2 = vse(e2, d2);
      if (y2)
        return y2;
      var x2, C;
      if ((!a.get("show") || l2.scale.isBlank()) && (x2 = []), wl(d2))
        x2 = bse(l2, d2, true);
      else if (d2 === "auto") {
        var D2 = dse(l2, l2.getLabelModel());
        C = D2.labelCategoryInterval, x2 = $a2(D2.labels, function(L) {
          return L.tickValue;
        });
      } else
        C = d2, x2 = mse(l2, C, true);
      return yse(e2, d2, { ticks: x2, tickCategoryInterval: C });
    }
    function vQe(l2) {
      var a = l2.scale.getTicks(), e2 = Prt(l2);
      return { labels: $a2(a, function(d2, y2) {
        return { level: d2.level, formattedLabel: e2(d2, y2), rawLabel: l2.scale.getLabel(d2), tickValue: d2.value };
      }) };
    }
    function gse(l2, a) {
      return Ort(l2)[a] || (Ort(l2)[a] = []);
    }
    function vse(l2, a) {
      for (var e2 = 0; e2 < l2.length; e2++)
        if (l2[e2].key === a)
          return l2[e2].value;
    }
    function yse(l2, a, e2) {
      return l2.push({ key: a, value: e2 }), e2;
    }
    function yQe(l2) {
      var a = Ort(l2).autoInterval;
      return a != null ? a : Ort(l2).autoInterval = l2.calculateCategoryInterval();
    }
    function mQe(l2) {
      var a = bQe(l2), e2 = Prt(l2), d2 = (a.axisRotate - a.labelRotate) / 180 * Math.PI, y2 = l2.scale, x2 = y2.getExtent(), C = y2.count();
      if (x2[1] - x2[0] < 1)
        return 0;
      var D2 = 1;
      C > 40 && (D2 = Math.max(1, Math.floor(C / 40)));
      for (var L = x2[0], F3 = l2.dataToCoord(L + 1) - l2.dataToCoord(L), j = Math.abs(F3 * Math.cos(d2)), U3 = Math.abs(F3 * Math.sin(d2)), Y3 = 0, Q = 0; L <= x2[1]; L += D2) {
        var nt = 0, dt = 0, vt = uO(e2({ value: L }), a.font, "center", "top");
        nt = vt.width * 1.3, dt = vt.height * 1.3, Y3 = Math.max(Y3, nt, 7), Q = Math.max(Q, dt, 7);
      }
      var Ct = Y3 / j, Pt = Q / U3;
      isNaN(Ct) && (Ct = 1 / 0), isNaN(Pt) && (Pt = 1 / 0);
      var jt = Math.max(0, Math.floor(Math.min(Ct, Pt))), Rt = Ort(l2.model), le2 = l2.getExtent(), ne2 = Rt.lastAutoInterval, he2 = Rt.lastTickCount;
      return ne2 != null && he2 != null && Math.abs(ne2 - jt) <= 1 && Math.abs(he2 - C) <= 1 && ne2 > jt && Rt.axisExtent0 === le2[0] && Rt.axisExtent1 === le2[1] ? jt = ne2 : (Rt.lastTickCount = C, Rt.lastAutoInterval = jt, Rt.axisExtent0 = le2[0], Rt.axisExtent1 = le2[1]), jt;
    }
    function bQe(l2) {
      var a = l2.getLabelModel();
      return { axisRotate: l2.getRotate ? l2.getRotate() : l2.isHorizontal && !l2.isHorizontal() ? 90 : 0, labelRotate: a.get("rotate") || 0, font: a.getFont() };
    }
    function mse(l2, a, e2) {
      var d2 = Prt(l2), y2 = l2.scale, x2 = y2.getExtent(), C = l2.getLabelModel(), D2 = [], L = Math.max((a || 0) + 1, 1), F3 = x2[0], j = y2.count();
      F3 !== 0 && L > 1 && j / L > 2 && (F3 = Math.round(Math.ceil(F3 / L) * L));
      var U3 = ose(l2), Y3 = C.get("showMinLabel") || U3, Q = C.get("showMaxLabel") || U3;
      Y3 && F3 !== x2[0] && dt(x2[0]);
      for (var nt = F3; nt <= x2[1]; nt += L)
        dt(nt);
      Q && nt - L !== x2[1] && dt(x2[1]);
      function dt(vt) {
        var Ct = { value: vt };
        D2.push(e2 ? vt : { formattedLabel: d2(Ct), rawLabel: y2.getLabel(Ct), tickValue: vt });
      }
      return D2;
    }
    function bse(l2, a, e2) {
      var d2 = l2.scale, y2 = Prt(l2), x2 = [];
      return Ke2(d2.getTicks(), function(C) {
        var D2 = d2.getLabel(C), L = C.value;
        a(C.value, D2) && x2.push(e2 ? L : { formattedLabel: y2(C), rawLabel: D2, tickValue: L });
      }), x2;
    }
    var _se = [0, 1], _Qe = function() {
      function l2(a, e2, d2) {
        this.onBand = false, this.inverse = false, this.dim = a, this.scale = e2, this._extent = d2 || [0, 0];
      }
      return l2.prototype.contain = function(a) {
        var e2 = this._extent, d2 = Math.min(e2[0], e2[1]), y2 = Math.max(e2[0], e2[1]);
        return a >= d2 && a <= y2;
      }, l2.prototype.containData = function(a) {
        return this.scale.contain(a);
      }, l2.prototype.getExtent = function() {
        return this._extent.slice();
      }, l2.prototype.getPixelPrecision = function(a) {
        return Vvt(a || this.scale.getExtent(), this._extent);
      }, l2.prototype.setExtent = function(a, e2) {
        var d2 = this._extent;
        d2[0] = a, d2[1] = e2;
      }, l2.prototype.dataToCoord = function(a, e2) {
        var d2 = this._extent, y2 = this.scale;
        return a = y2.normalize(a), this.onBand && y2.type === "ordinal" && (d2 = d2.slice(), xse(d2, y2.count())), yp(a, _se, d2, e2);
      }, l2.prototype.coordToData = function(a, e2) {
        var d2 = this._extent, y2 = this.scale;
        this.onBand && y2.type === "ordinal" && (d2 = d2.slice(), xse(d2, y2.count()));
        var x2 = yp(a, d2, _se, e2);
        return this.scale.scale(x2);
      }, l2.prototype.pointToData = function(a, e2) {
      }, l2.prototype.getTicksCoords = function(a) {
        a = a || {};
        var e2 = a.tickModel || this.getTickModel(), d2 = pQe(this, e2), y2 = d2.ticks, x2 = $a2(y2, function(D2) {
          return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(D2) : D2), tickValue: D2 };
        }, this), C = e2.get("alignWithLabel");
        return xQe(this, x2, C, a.clamp), x2;
      }, l2.prototype.getMinorTicksCoords = function() {
        if (this.scale.type === "ordinal")
          return [];
        var a = this.model.getModel("minorTick"), e2 = a.get("splitNumber");
        e2 > 0 && e2 < 100 || (e2 = 5);
        var d2 = this.scale.getMinorTicks(e2), y2 = $a2(d2, function(x2) {
          return $a2(x2, function(C) {
            return { coord: this.dataToCoord(C), tickValue: C };
          }, this);
        }, this);
        return y2;
      }, l2.prototype.getViewLabels = function() {
        return hQe(this).labels;
      }, l2.prototype.getLabelModel = function() {
        return this.model.getModel("axisLabel");
      }, l2.prototype.getTickModel = function() {
        return this.model.getModel("axisTick");
      }, l2.prototype.getBandWidth = function() {
        var a = this._extent, e2 = this.scale.getExtent(), d2 = e2[1] - e2[0] + (this.onBand ? 1 : 0);
        d2 === 0 && (d2 = 1);
        var y2 = Math.abs(a[1] - a[0]);
        return Math.abs(y2) / d2;
      }, l2.prototype.calculateCategoryInterval = function() {
        return mQe(this);
      }, l2;
    }();
    function xse(l2, a) {
      var e2 = l2[1] - l2[0], d2 = a, y2 = e2 / d2 / 2;
      l2[0] += y2, l2[1] -= y2;
    }
    function xQe(l2, a, e2, d2) {
      var y2 = a.length;
      if (!l2.onBand || e2 || !y2)
        return;
      var x2 = l2.getExtent(), C, D2;
      if (y2 === 1)
        a[0].coord = x2[0], C = a[1] = { coord: x2[0] };
      else {
        var L = a[y2 - 1].tickValue - a[0].tickValue, F3 = (a[y2 - 1].coord - a[0].coord) / L;
        Ke2(a, function(Q) {
          Q.coord -= F3 / 2;
        });
        var j = l2.scale.getExtent();
        D2 = 1 + j[1] - a[y2 - 1].tickValue, C = { coord: a[y2 - 1].coord + F3 * D2 }, a.push(C);
      }
      var U3 = x2[0] > x2[1];
      Y3(a[0].coord, x2[0]) && (d2 ? a[0].coord = x2[0] : a.shift()), d2 && Y3(x2[0], a[0].coord) && a.unshift({ coord: x2[0] }), Y3(x2[1], C.coord) && (d2 ? C.coord = x2[1] : a.pop()), d2 && Y3(C.coord, x2[1]) && a.push({ coord: x2[1] });
      function Y3(Q, nt) {
        return Q = kv(Q), nt = kv(nt), U3 ? Q > nt : Q < nt;
      }
    }
    var kE = _Qe, Rrt = Math.PI * 2, hB = yA.CMD, wQe = ["top", "right", "bottom", "left"];
    function SQe(l2, a, e2, d2, y2) {
      var x2 = e2.width, C = e2.height;
      switch (l2) {
        case "top":
          d2.set(e2.x + x2 / 2, e2.y - a), y2.set(0, -1);
          break;
        case "bottom":
          d2.set(e2.x + x2 / 2, e2.y + C + a), y2.set(0, 1);
          break;
        case "left":
          d2.set(e2.x - a, e2.y + C / 2), y2.set(-1, 0);
          break;
        case "right":
          d2.set(e2.x + x2 + a, e2.y + C / 2), y2.set(1, 0);
          break;
      }
    }
    function MQe(l2, a, e2, d2, y2, x2, C, D2, L) {
      C -= l2, D2 -= a;
      var F3 = Math.sqrt(C * C + D2 * D2);
      C /= F3, D2 /= F3;
      var j = C * e2 + l2, U3 = D2 * e2 + a;
      if (Math.abs(d2 - y2) % Rrt < 1e-4)
        return L[0] = j, L[1] = U3, F3 - e2;
      if (x2) {
        var Y3 = d2;
        d2 = J5(y2), y2 = J5(Y3);
      } else
        d2 = J5(d2), y2 = J5(y2);
      d2 > y2 && (y2 += Rrt);
      var Q = Math.atan2(D2, C);
      if (Q < 0 && (Q += Rrt), Q >= d2 && Q <= y2 || Q + Rrt >= d2 && Q + Rrt <= y2)
        return L[0] = j, L[1] = U3, F3 - e2;
      var nt = e2 * Math.cos(d2) + l2, dt = e2 * Math.sin(d2) + a, vt = e2 * Math.cos(y2) + l2, Ct = e2 * Math.sin(y2) + a, Pt = (nt - C) * (nt - C) + (dt - D2) * (dt - D2), jt = (vt - C) * (vt - C) + (Ct - D2) * (Ct - D2);
      return Pt < jt ? (L[0] = nt, L[1] = dt, Math.sqrt(Pt)) : (L[0] = vt, L[1] = Ct, Math.sqrt(jt));
    }
    function Hyt(l2, a, e2, d2, y2, x2, C, D2) {
      var L = y2 - l2, F3 = x2 - a, j = e2 - l2, U3 = d2 - a, Y3 = Math.sqrt(j * j + U3 * U3);
      j /= Y3, U3 /= Y3;
      var Q = L * j + F3 * U3, nt = Q / Y3;
      D2 && (nt = Math.min(Math.max(nt, 0), 1)), nt *= Y3;
      var dt = C[0] = l2 + nt * j, vt = C[1] = a + nt * U3;
      return Math.sqrt((dt - y2) * (dt - y2) + (vt - x2) * (vt - x2));
    }
    function wse(l2, a, e2, d2, y2, x2, C) {
      e2 < 0 && (l2 = l2 + e2, e2 = -e2), d2 < 0 && (a = a + d2, d2 = -d2);
      var D2 = l2 + e2, L = a + d2, F3 = C[0] = Math.min(Math.max(y2, l2), D2), j = C[1] = Math.min(Math.max(x2, a), L);
      return Math.sqrt((F3 - y2) * (F3 - y2) + (j - x2) * (j - x2));
    }
    var PE = [];
    function CQe(l2, a, e2) {
      var d2 = wse(a.x, a.y, a.width, a.height, l2.x, l2.y, PE);
      return e2.set(PE[0], PE[1]), d2;
    }
    function TQe(l2, a, e2) {
      for (var d2 = 0, y2 = 0, x2 = 0, C = 0, D2, L, F3 = 1 / 0, j = a.data, U3 = l2.x, Y3 = l2.y, Q = 0; Q < j.length; ) {
        var nt = j[Q++];
        Q === 1 && (d2 = j[Q], y2 = j[Q + 1], x2 = d2, C = y2);
        var dt = F3;
        switch (nt) {
          case hB.M:
            x2 = j[Q++], C = j[Q++], d2 = x2, y2 = C;
            break;
          case hB.L:
            dt = Hyt(d2, y2, j[Q], j[Q + 1], U3, Y3, PE, true), d2 = j[Q++], y2 = j[Q++];
            break;
          case hB.C:
            dt = lvt(d2, y2, j[Q++], j[Q++], j[Q++], j[Q++], j[Q], j[Q + 1], U3, Y3, PE), d2 = j[Q++], y2 = j[Q++];
            break;
          case hB.Q:
            dt = cvt(d2, y2, j[Q++], j[Q++], j[Q], j[Q + 1], U3, Y3, PE), d2 = j[Q++], y2 = j[Q++];
            break;
          case hB.A:
            var vt = j[Q++], Ct = j[Q++], Pt = j[Q++], jt = j[Q++], Rt = j[Q++], le2 = j[Q++];
            Q += 1;
            var ne2 = !!(1 - j[Q++]);
            D2 = Math.cos(Rt) * Pt + vt, L = Math.sin(Rt) * jt + Ct, Q <= 1 && (x2 = D2, C = L);
            var he2 = (U3 - vt) * jt / Pt + vt;
            dt = MQe(vt, Ct, jt, Rt, Rt + le2, ne2, he2, Y3, PE), d2 = Math.cos(Rt + le2) * Pt + vt, y2 = Math.sin(Rt + le2) * jt + Ct;
            break;
          case hB.R:
            x2 = d2 = j[Q++], C = y2 = j[Q++];
            var _e = j[Q++], Me2 = j[Q++];
            dt = wse(x2, C, _e, Me2, U3, Y3, PE);
            break;
          case hB.Z:
            dt = Hyt(d2, y2, x2, C, U3, Y3, PE, true), d2 = x2, y2 = C;
            break;
        }
        dt < F3 && (F3 = dt, e2.set(PE[0], PE[1]));
      }
      return F3;
    }
    var LE = new Nu(), dg2 = new Nu(), xy = new Nu(), uP = new Nu(), cP = new Nu();
    function Sse(l2, a) {
      if (l2) {
        var e2 = l2.getTextGuideLine(), d2 = l2.getTextContent();
        if (d2 && e2) {
          var y2 = l2.textGuideLineConfig || {}, x2 = [[0, 0], [0, 0], [0, 0]], C = y2.candidates || wQe, D2 = d2.getBoundingRect().clone();
          D2.applyTransform(d2.getComputedTransform());
          var L = 1 / 0, F3 = y2.anchor, j = l2.getComputedTransform(), U3 = j && sO([], j), Y3 = a.get("length2") || 0;
          F3 && xy.copy(F3);
          for (var Q = 0; Q < C.length; Q++) {
            var nt = C[Q];
            SQe(nt, 0, D2, LE, uP), Nu.scaleAndAdd(dg2, LE, uP, Y3), dg2.transform(U3);
            var dt = l2.getBoundingRect(), vt = F3 ? F3.distance(dg2) : l2 instanceof wc2 ? TQe(dg2, l2.path, xy) : CQe(dg2, dt, xy);
            vt < L && (L = vt, dg2.transform(j), xy.transform(j), xy.toArray(x2[0]), dg2.toArray(x2[1]), LE.toArray(x2[2]));
          }
          Mse(x2, a.get("minTurnAngle")), e2.setShape({ points: x2 });
        }
      }
    }
    var Uyt = [], WS = new Nu();
    function Mse(l2, a) {
      if (a <= 180 && a > 0) {
        a = a / 180 * Math.PI, LE.fromArray(l2[0]), dg2.fromArray(l2[1]), xy.fromArray(l2[2]), Nu.sub(uP, LE, dg2), Nu.sub(cP, xy, dg2);
        var e2 = uP.len(), d2 = cP.len();
        if (!(e2 < 1e-3 || d2 < 1e-3)) {
          uP.scale(1 / e2), cP.scale(1 / d2);
          var y2 = uP.dot(cP), x2 = Math.cos(a);
          if (x2 < y2) {
            var C = Hyt(dg2.x, dg2.y, xy.x, xy.y, LE.x, LE.y, Uyt, false);
            WS.fromArray(Uyt), WS.scaleAndAdd(cP, C / Math.tan(Math.PI - a));
            var D2 = xy.x !== dg2.x ? (WS.x - dg2.x) / (xy.x - dg2.x) : (WS.y - dg2.y) / (xy.y - dg2.y);
            if (isNaN(D2))
              return;
            D2 < 0 ? Nu.copy(WS, dg2) : D2 > 1 && Nu.copy(WS, xy), WS.toArray(l2[1]);
          }
        }
      }
    }
    function AQe(l2, a, e2) {
      if (e2 <= 180 && e2 > 0) {
        e2 = e2 / 180 * Math.PI, LE.fromArray(l2[0]), dg2.fromArray(l2[1]), xy.fromArray(l2[2]), Nu.sub(uP, dg2, LE), Nu.sub(cP, xy, dg2);
        var d2 = uP.len(), y2 = cP.len();
        if (!(d2 < 1e-3 || y2 < 1e-3)) {
          uP.scale(1 / d2), cP.scale(1 / y2);
          var x2 = uP.dot(a), C = Math.cos(e2);
          if (x2 < C) {
            var D2 = Hyt(dg2.x, dg2.y, xy.x, xy.y, LE.x, LE.y, Uyt, false);
            WS.fromArray(Uyt);
            var L = Math.PI / 2, F3 = Math.acos(cP.dot(a)), j = L + F3 - e2;
            if (j >= L)
              Nu.copy(WS, xy);
            else {
              WS.scaleAndAdd(cP, D2 / Math.tan(Math.PI / 2 - j));
              var U3 = xy.x !== dg2.x ? (WS.x - dg2.x) / (xy.x - dg2.x) : (WS.y - dg2.y) / (xy.y - dg2.y);
              if (isNaN(U3))
                return;
              U3 < 0 ? Nu.copy(WS, dg2) : U3 > 1 && Nu.copy(WS, xy);
            }
            WS.toArray(l2[1]);
          }
        }
      }
    }
    function Cse(l2, a, e2, d2) {
      var y2 = e2 === "normal", x2 = y2 ? l2 : l2.ensureState(e2);
      x2.ignore = a;
      var C = d2.get("smooth");
      C && C === true && (C = 0.3), x2.shape = x2.shape || {}, C > 0 && (x2.shape.smooth = C);
      var D2 = d2.getModel("lineStyle").getLineStyle();
      y2 ? l2.useStyle(D2) : x2.style = D2;
    }
    function IQe(l2, a) {
      var e2 = a.smooth, d2 = a.points;
      if (d2)
        if (l2.moveTo(d2[0][0], d2[0][1]), e2 > 0 && d2.length >= 3) {
          var y2 = gE(d2[0], d2[1]), x2 = gE(d2[1], d2[2]);
          if (!y2 || !x2) {
            l2.lineTo(d2[1][0], d2[1][1]), l2.lineTo(d2[2][0], d2[2][1]);
            return;
          }
          var C = Math.min(y2, x2) * e2, D2 = LU([], d2[1], d2[0], C / y2), L = LU([], d2[1], d2[2], C / x2), F3 = LU([], D2, L, 0.5);
          l2.bezierCurveTo(D2[0], D2[1], D2[0], D2[1], F3[0], F3[1]), l2.bezierCurveTo(L[0], L[1], L[0], L[1], d2[2][0], d2[2][1]);
        } else
          for (var j = 1; j < d2.length; j++)
            l2.lineTo(d2[j][0], d2[j][1]);
    }
    function jLt(l2, a, e2) {
      var d2 = l2.getTextGuideLine(), y2 = l2.getTextContent();
      if (!y2) {
        d2 && l2.removeTextGuideLine();
        return;
      }
      for (var x2 = a.normal, C = x2.get("show"), D2 = y2.ignore, L = 0; L < UV.length; L++) {
        var F3 = UV[L], j = a[F3], U3 = F3 === "normal";
        if (j) {
          var Y3 = j.get("show"), Q = U3 ? D2 : $u(y2.states[F3] && y2.states[F3].ignore, D2);
          if (Q || !$u(Y3, C)) {
            var nt = U3 ? d2 : d2 && d2.states.normal;
            nt && (nt.ignore = true);
            continue;
          }
          d2 || (d2 = new iw(), l2.setTextGuideLine(d2), !U3 && (D2 || !C) && Cse(d2, true, "normal", a.normal), l2.stateProxy && (d2.stateProxy = l2.stateProxy)), Cse(d2, false, F3, j);
        }
      }
      if (d2) {
        El(d2.style, e2), d2.style.fill = null;
        var dt = x2.get("showAbove"), vt = l2.textGuideLineConfig = l2.textGuideLineConfig || {};
        vt.showAbove = dt || false, d2.buildPath = IQe;
      }
    }
    function WLt(l2, a) {
      a = a || "labelLine";
      for (var e2 = { normal: l2.getModel(a) }, d2 = 0; d2 < O_.length; d2++) {
        var y2 = O_[d2];
        e2[y2] = l2.getModel([y2, a]);
      }
      return e2;
    }
    function Tse(l2) {
      for (var a = [], e2 = 0; e2 < l2.length; e2++) {
        var d2 = l2[e2];
        if (!d2.defaultAttr.ignore) {
          var y2 = d2.label, x2 = y2.getComputedTransform(), C = y2.getBoundingRect(), D2 = !x2 || x2[1] < 1e-5 && x2[2] < 1e-5, L = y2.style.margin || 0, F3 = C.clone();
          F3.applyTransform(x2), F3.x -= L / 2, F3.y -= L / 2, F3.width += L, F3.height += L;
          var j = D2 ? new Oq(C, x2) : null;
          a.push({ label: y2, labelLine: d2.labelLine, rect: F3, localRect: C, obb: j, priority: d2.priority, defaultAttr: d2.defaultAttr, layoutOption: d2.computedLayoutOption, axisAligned: D2, transform: x2 });
        }
      }
      return a;
    }
    function Ase(l2, a, e2, d2, y2, x2) {
      var C = l2.length;
      if (C < 2)
        return;
      l2.sort(function(_e, Me2) {
        return _e.rect[a] - Me2.rect[a];
      });
      for (var D2 = 0, L, F3 = false, j = 0, U3 = 0; U3 < C; U3++) {
        var Y3 = l2[U3], Q = Y3.rect;
        L = Q[a] - D2, L < 0 && (Q[a] -= L, Y3.label[a] -= L, F3 = true);
        var nt = Math.max(-L, 0);
        j += nt, D2 = Q[a] + Q[e2];
      }
      j > 0 && x2 && le2(-j / C, 0, C);
      var dt = l2[0], vt = l2[C - 1], Ct, Pt;
      jt(), Ct < 0 && ne2(-Ct, 0.8), Pt < 0 && ne2(Pt, 0.8), jt(), Rt(Ct, Pt, 1), Rt(Pt, Ct, -1), jt(), Ct < 0 && he2(-Ct), Pt < 0 && he2(Pt);
      function jt() {
        Ct = dt.rect[a] - d2, Pt = y2 - vt.rect[a] - vt.rect[e2];
      }
      function Rt(_e, Me2, Pe2) {
        if (_e < 0) {
          var Be2 = Math.min(Me2, -_e);
          if (Be2 > 0) {
            le2(Be2 * Pe2, 0, C);
            var Je2 = Be2 + _e;
            Je2 < 0 && ne2(-Je2 * Pe2, 1);
          } else
            ne2(-_e * Pe2, 1);
        }
      }
      function le2(_e, Me2, Pe2) {
        _e !== 0 && (F3 = true);
        for (var Be2 = Me2; Be2 < Pe2; Be2++) {
          var Je2 = l2[Be2], Ze2 = Je2.rect;
          Ze2[a] += _e, Je2.label[a] += _e;
        }
      }
      function ne2(_e, Me2) {
        for (var Pe2 = [], Be2 = 0, Je2 = 1; Je2 < C; Je2++) {
          var Ze2 = l2[Je2 - 1].rect, Cn = Math.max(l2[Je2].rect[a] - Ze2[a] - Ze2[e2], 0);
          Pe2.push(Cn), Be2 += Cn;
        }
        if (Be2) {
          var Bn = Math.min(Math.abs(_e) / Be2, Me2);
          if (_e > 0)
            for (var Je2 = 0; Je2 < C - 1; Je2++) {
              var mn = Pe2[Je2] * Bn;
              le2(mn, 0, Je2 + 1);
            }
          else
            for (var Je2 = C - 1; Je2 > 0; Je2--) {
              var mn = Pe2[Je2 - 1] * Bn;
              le2(-mn, Je2, C);
            }
        }
      }
      function he2(_e) {
        var Me2 = _e < 0 ? -1 : 1;
        _e = Math.abs(_e);
        for (var Pe2 = Math.ceil(_e / (C - 1)), Be2 = 0; Be2 < C - 1; Be2++)
          if (Me2 > 0 ? le2(Pe2, 0, Be2 + 1) : le2(-Pe2, C - Be2 - 1, C), _e -= Pe2, _e <= 0)
            return;
      }
      return F3;
    }
    function DQe(l2, a, e2, d2) {
      return Ase(l2, "x", "width", a, e2, d2);
    }
    function Ise(l2, a, e2, d2) {
      return Ase(l2, "y", "height", a, e2, d2);
    }
    function Dse(l2) {
      var a = [];
      l2.sort(function(dt, vt) {
        return vt.priority - dt.priority;
      });
      var e2 = new Yu(0, 0, 0, 0);
      function d2(dt) {
        if (!dt.ignore) {
          var vt = dt.ensureState("emphasis");
          vt.ignore == null && (vt.ignore = false);
        }
        dt.ignore = true;
      }
      for (var y2 = 0; y2 < l2.length; y2++) {
        var x2 = l2[y2], C = x2.axisAligned, D2 = x2.localRect, L = x2.transform, F3 = x2.label, j = x2.labelLine;
        e2.copy(x2.rect), e2.width -= 0.1, e2.height -= 0.1, e2.x += 0.05, e2.y += 0.05;
        for (var U3 = x2.obb, Y3 = false, Q = 0; Q < a.length; Q++) {
          var nt = a[Q];
          if (e2.intersect(nt.rect)) {
            if (C && nt.axisAligned) {
              Y3 = true;
              break;
            }
            if (nt.obb || (nt.obb = new Oq(nt.localRect, nt.transform)), U3 || (U3 = new Oq(D2, L)), U3.intersect(nt.obb)) {
              Y3 = true;
              break;
            }
          }
        }
        Y3 ? (d2(F3), j && d2(j)) : (F3.attr("ignore", x2.defaultAttr.ignore), j && j.attr("ignore", x2.defaultAttr.labelGuideIgnore), a.push(x2));
      }
    }
    function EQe(l2) {
      if (l2) {
        for (var a = [], e2 = 0; e2 < l2.length; e2++)
          a.push(l2[e2].slice());
        return a;
      }
    }
    function kQe(l2, a) {
      var e2 = l2.label, d2 = a && a.getTextGuideLine();
      return { dataIndex: l2.dataIndex, dataType: l2.dataType, seriesIndex: l2.seriesModel.seriesIndex, text: l2.label.style.text, rect: l2.hostRect, labelRect: l2.rect, align: e2.style.align, verticalAlign: e2.style.verticalAlign, labelLinePoints: EQe(d2 && d2.shape.points) };
    }
    var Ese = ["align", "verticalAlign", "width", "height", "fontSize"], gC = new OS(), GLt = Rf2(), PQe = Rf2();
    function qyt(l2, a, e2) {
      for (var d2 = 0; d2 < e2.length; d2++) {
        var y2 = e2[d2];
        a[y2] != null && (l2[y2] = a[y2]);
      }
    }
    var Zyt = ["x", "y", "rotation"], LQe = function() {
      function l2() {
        this._labelList = [], this._chartViewList = [];
      }
      return l2.prototype.clearLabels = function() {
        this._labelList = [], this._chartViewList = [];
      }, l2.prototype._addLabel = function(a, e2, d2, y2, x2) {
        var C = y2.style, D2 = y2.__hostTarget, L = D2.textConfig || {}, F3 = y2.getComputedTransform(), j = y2.getBoundingRect().plain();
        Yu.applyTransform(j, j, F3), F3 ? gC.setLocalTransform(F3) : (gC.x = gC.y = gC.rotation = gC.originX = gC.originY = 0, gC.scaleX = gC.scaleY = 1);
        var U3 = y2.__hostTarget, Y3;
        if (U3) {
          Y3 = U3.getBoundingRect().plain();
          var Q = U3.getComputedTransform();
          Yu.applyTransform(Y3, Y3, Q);
        }
        var nt = Y3 && U3.getTextGuideLine();
        this._labelList.push({ label: y2, labelLine: nt, seriesModel: d2, dataIndex: a, dataType: e2, layoutOption: x2, computedLayoutOption: null, rect: j, hostRect: Y3, priority: Y3 ? Y3.width * Y3.height : 0, defaultAttr: { ignore: y2.ignore, labelGuideIgnore: nt && nt.ignore, x: gC.x, y: gC.y, scaleX: gC.scaleX, scaleY: gC.scaleY, rotation: gC.rotation, style: { x: C.x, y: C.y, align: C.align, verticalAlign: C.verticalAlign, width: C.width, height: C.height, fontSize: C.fontSize }, cursor: y2.cursor, attachedPos: L.position, attachedRot: L.rotation } });
      }, l2.prototype.addLabelsOfSeries = function(a) {
        var e2 = this;
        this._chartViewList.push(a);
        var d2 = a.__model, y2 = d2.get("labelLayout");
        !(wl(y2) || Qc2(y2).length) || a.group.traverse(function(x2) {
          if (x2.ignore)
            return true;
          var C = x2.getTextContent(), D2 = ns(x2);
          C && !C.disableLabelLayout && e2._addLabel(D2.dataIndex, D2.dataType, d2, C, y2);
        });
      }, l2.prototype.updateLayoutConfig = function(a) {
        var e2 = a.getWidth(), d2 = a.getHeight();
        function y2(jt, Rt) {
          return function() {
            Sse(jt, Rt);
          };
        }
        for (var x2 = 0; x2 < this._labelList.length; x2++) {
          var C = this._labelList[x2], D2 = C.label, L = D2.__hostTarget, F3 = C.defaultAttr, j = void 0;
          wl(C.layoutOption) ? j = C.layoutOption(kQe(C, L)) : j = C.layoutOption, j = j || {}, C.computedLayoutOption = j;
          var U3 = Math.PI / 180;
          L && L.setTextConfig({ local: false, position: j.x != null || j.y != null ? null : F3.attachedPos, rotation: j.rotate != null ? j.rotate * U3 : F3.attachedRot, offset: [j.dx || 0, j.dy || 0] });
          var Y3 = false;
          if (j.x != null ? (D2.x = Ko(j.x, e2), D2.setStyle("x", 0), Y3 = true) : (D2.x = F3.x, D2.setStyle("x", F3.style.x)), j.y != null ? (D2.y = Ko(j.y, d2), D2.setStyle("y", 0), Y3 = true) : (D2.y = F3.y, D2.setStyle("y", F3.style.y)), j.labelLinePoints) {
            var Q = L.getTextGuideLine();
            Q && (Q.setShape({ points: j.labelLinePoints }), Y3 = false);
          }
          var nt = GLt(D2);
          nt.needsUpdateLabelLine = Y3, D2.rotation = j.rotate != null ? j.rotate * U3 : F3.rotation, D2.scaleX = F3.scaleX, D2.scaleY = F3.scaleY;
          for (var dt = 0; dt < Ese.length; dt++) {
            var vt = Ese[dt];
            D2.setStyle(vt, j[vt] != null ? j[vt] : F3.style[vt]);
          }
          if (j.draggable) {
            if (D2.draggable = true, D2.cursor = "move", L) {
              var Ct = C.seriesModel;
              if (C.dataIndex != null) {
                var Pt = C.seriesModel.getData(C.dataType);
                Ct = Pt.getItemModel(C.dataIndex);
              }
              D2.on("drag", y2(L, Ct.getModel("labelLine")));
            }
          } else
            D2.off("drag"), D2.cursor = F3.cursor;
        }
      }, l2.prototype.layout = function(a) {
        var e2 = a.getWidth(), d2 = a.getHeight(), y2 = Tse(this._labelList), x2 = Lp(y2, function(L) {
          return L.layoutOption.moveOverlap === "shiftX";
        }), C = Lp(y2, function(L) {
          return L.layoutOption.moveOverlap === "shiftY";
        });
        DQe(x2, 0, e2), Ise(C, 0, d2);
        var D2 = Lp(y2, function(L) {
          return L.layoutOption.hideOverlap;
        });
        Dse(D2);
      }, l2.prototype.processLabelsOverall = function() {
        var a = this;
        Ke2(this._chartViewList, function(e2) {
          var d2 = e2.__model, y2 = e2.ignoreLabelLineUpdate, x2 = d2.isAnimationEnabled();
          e2.group.traverse(function(C) {
            if (C.ignore && !C.forceLabelAnimation)
              return true;
            var D2 = !y2, L = C.getTextContent();
            !D2 && L && (D2 = GLt(L).needsUpdateLabelLine), D2 && a._updateLabelLine(C, d2), x2 && a._animateLabels(C, d2);
          });
        });
      }, l2.prototype._updateLabelLine = function(a, e2) {
        var d2 = a.getTextContent(), y2 = ns(a), x2 = y2.dataIndex;
        if (d2 && x2 != null) {
          var C = e2.getData(y2.dataType), D2 = C.getItemModel(x2), L = {}, F3 = C.getItemVisual(x2, "style"), j = C.getVisual("drawType");
          L.stroke = F3[j];
          var U3 = D2.getModel("labelLine");
          jLt(a, WLt(D2), L), Sse(a, U3);
        }
      }, l2.prototype._animateLabels = function(a, e2) {
        var d2 = a.getTextContent(), y2 = a.getTextGuideLine();
        if (d2 && (a.forceLabelAnimation || !d2.ignore && !d2.invisible && !a.disableLabelAnimation && !UN(a))) {
          var x2 = GLt(d2), C = x2.oldLayout, D2 = ns(a), L = D2.dataIndex, F3 = { x: d2.x, y: d2.y, rotation: d2.rotation }, j = e2.getData(D2.dataType);
          if (C) {
            d2.attr(C);
            var U3 = a.prevStates;
            U3 && (oc2(U3, "select") >= 0 && d2.attr(x2.oldLayoutSelect), oc2(U3, "emphasis") >= 0 && d2.attr(x2.oldLayoutEmphasis)), Yf2(d2, F3, e2, L);
          } else if (d2.attr(F3), !Bq(d2).valueAnimation) {
            var Y3 = $u(d2.style.opacity, 1);
            d2.style.opacity = 0, Yg2(d2, { style: { opacity: Y3 } }, e2, L);
          }
          if (x2.oldLayout = F3, d2.states.select) {
            var Q = x2.oldLayoutSelect = {};
            qyt(Q, F3, Zyt), qyt(Q, d2.states.select, Zyt);
          }
          if (d2.states.emphasis) {
            var nt = x2.oldLayoutEmphasis = {};
            qyt(nt, F3, Zyt), qyt(nt, d2.states.emphasis, Zyt);
          }
          Zre(d2, L, j, e2, e2);
        }
        if (y2 && !y2.ignore && !y2.invisible) {
          var x2 = PQe(y2), C = x2.oldLayout, dt = { points: y2.shape.points };
          C ? (y2.attr({ shape: C }), Yf2(y2, { shape: dt }, e2)) : (y2.setShape(dt), y2.style.strokePercent = 0, Yg2(y2, { style: { strokePercent: 1 } }, e2)), x2.oldLayout = dt;
        }
      }, l2;
    }(), OQe = LQe, HLt = Rf2();
    function RQe(l2) {
      l2.registerUpdateLifecycle("series:beforeupdate", function(a, e2, d2) {
        var y2 = HLt(e2).labelManager;
        y2 || (y2 = HLt(e2).labelManager = new OQe()), y2.clearLabels();
      }), l2.registerUpdateLifecycle("series:layoutlabels", function(a, e2, d2) {
        var y2 = HLt(e2).labelManager;
        d2.updatedSeries.forEach(function(x2) {
          y2.addLabelsOfSeries(e2.getViewOfSeriesModel(x2));
        }), y2.updateLayoutConfig(e2), y2.layout(e2), y2.processLabelsOverall();
      });
    }
    var ULt = Math.sin, qLt = Math.cos, kse = Math.PI, pB = Math.PI * 2, NQe = 180 / kse, FQe = function() {
      function l2() {
      }
      return l2.prototype.reset = function(a) {
        this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, a || 4);
      }, l2.prototype.moveTo = function(a, e2) {
        this._add("M", a, e2);
      }, l2.prototype.lineTo = function(a, e2) {
        this._add("L", a, e2);
      }, l2.prototype.bezierCurveTo = function(a, e2, d2, y2, x2, C) {
        this._add("C", a, e2, d2, y2, x2, C);
      }, l2.prototype.quadraticCurveTo = function(a, e2, d2, y2) {
        this._add("Q", a, e2, d2, y2);
      }, l2.prototype.arc = function(a, e2, d2, y2, x2, C) {
        this.ellipse(a, e2, d2, d2, 0, y2, x2, C);
      }, l2.prototype.ellipse = function(a, e2, d2, y2, x2, C, D2, L) {
        var F3 = D2 - C, j = !L, U3 = Math.abs(F3), Y3 = F5(U3 - pB) || (j ? F3 >= pB : -F3 >= pB), Q = F3 > 0 ? F3 % pB : F3 % pB + pB, nt = false;
        Y3 ? nt = true : F5(U3) ? nt = false : nt = Q >= kse == !!j;
        var dt = a + d2 * qLt(C), vt = e2 + y2 * ULt(C);
        this._start && this._add("M", dt, vt);
        var Ct = Math.round(x2 * NQe);
        if (Y3) {
          var Pt = 1 / this._p, jt = (j ? 1 : -1) * (pB - Pt);
          this._add("A", d2, y2, Ct, 1, +j, a + d2 * qLt(C + jt), e2 + y2 * ULt(C + jt)), Pt > 0.01 && this._add("A", d2, y2, Ct, 0, +j, dt, vt);
        } else {
          var Rt = a + d2 * qLt(D2), le2 = e2 + y2 * ULt(D2);
          this._add("A", d2, y2, Ct, +nt, +j, Rt, le2);
        }
      }, l2.prototype.rect = function(a, e2, d2, y2) {
        this._add("M", a, e2), this._add("l", d2, 0), this._add("l", 0, y2), this._add("l", -d2, 0), this._add("Z");
      }, l2.prototype.closePath = function() {
        this._d.length > 0 && this._add("Z");
      }, l2.prototype._add = function(a, e2, d2, y2, x2, C, D2, L, F3) {
        for (var j = [], U3 = this._p, Y3 = 1; Y3 < arguments.length; Y3++) {
          var Q = arguments[Y3];
          if (isNaN(Q)) {
            this._invalid = true;
            return;
          }
          j.push(Math.round(Q * U3) / U3);
        }
        this._d.push(a + j.join(" ")), this._start = a === "Z";
      }, l2.prototype.generateStr = function() {
        this._str = this._invalid ? "" : this._d.join(""), this._d = [];
      }, l2.prototype.getStr = function() {
        return this._str;
      }, l2;
    }(), Pse = FQe, Nrt = "none", VQe = Math.round;
    function BQe(l2) {
      var a = l2.fill;
      return a != null && a !== Nrt;
    }
    function zQe(l2) {
      var a = l2.stroke;
      return a != null && a !== Nrt;
    }
    var ZLt = ["lineCap", "miterLimit", "lineJoin"], jQe = $a2(ZLt, function(l2) {
      return "stroke-" + l2.toLowerCase();
    });
    function WQe(l2, a, e2, d2) {
      var y2 = a.opacity == null ? 1 : a.opacity;
      if (e2 instanceof Im) {
        l2("opacity", y2);
        return;
      }
      if (BQe(a)) {
        var x2 = AN(a.fill);
        l2("fill", x2.color);
        var C = a.fillOpacity != null ? a.fillOpacity * x2.opacity * y2 : x2.opacity * y2;
        (d2 || C < 1) && l2("fill-opacity", C);
      } else
        l2("fill", Nrt);
      if (zQe(a)) {
        var D2 = AN(a.stroke);
        l2("stroke", D2.color);
        var L = a.strokeNoScale ? e2.getLineScale() : 1, F3 = L ? (a.lineWidth || 0) / L : 0, j = a.strokeOpacity != null ? a.strokeOpacity * D2.opacity * y2 : D2.opacity * y2, U3 = a.strokeFirst;
        if ((d2 || F3 !== 1) && l2("stroke-width", F3), (d2 || U3) && l2("paint-order", U3 ? "stroke" : "fill"), (d2 || j < 1) && l2("stroke-opacity", j), a.lineDash) {
          var Y3 = lLt(e2), Q = Y3[0], nt = Y3[1];
          Q && (nt = VQe(nt || 0), l2("stroke-dasharray", Q.join(",")), (nt || d2) && l2("stroke-dashoffset", nt));
        } else
          d2 && l2("stroke-dasharray", Nrt);
        for (var dt = 0; dt < ZLt.length; dt++) {
          var vt = ZLt[dt];
          if (d2 || a[vt] !== bq[vt]) {
            var Ct = a[vt] || bq[vt];
            Ct && l2(jQe[dt], Ct);
          }
        }
      } else
        d2 && l2("stroke", Nrt);
    }
    var Lse = "http://www.w3.org/2000/svg", Ose = "http://www.w3.org/1999/xlink", GQe = "http://www.w3.org/2000/xmlns/", HQe = "http://www.w3.org/XML/1998/namespace";
    function Rse(l2) {
      return document.createElementNS(Lse, l2);
    }
    function _1(l2, a, e2, d2, y2) {
      return { tag: l2, attrs: e2 || {}, children: d2, text: y2, key: a };
    }
    function UQe(l2, a) {
      var e2 = [];
      if (a)
        for (var d2 in a) {
          var y2 = a[d2], x2 = d2;
          y2 !== false && (y2 !== true && y2 != null && (x2 += '="' + y2 + '"'), e2.push(x2));
        }
      return "<" + l2 + " " + e2.join(" ") + ">";
    }
    function qQe(l2) {
      return "</" + l2 + ">";
    }
    function $Lt(l2, a) {
      a = a || {};
      var e2 = a.newline ? `
` : "";
      function d2(y2) {
        var x2 = y2.children, C = y2.tag, D2 = y2.attrs;
        return UQe(C, D2) + (y2.text || "") + (x2 ? "" + e2 + $a2(x2, function(L) {
          return d2(L);
        }).join(e2) + e2 : "") + qQe(C);
      }
      return d2(l2);
    }
    function ZQe(l2, a, e2) {
      e2 = e2 || {};
      var d2 = e2.newline ? `
` : "", y2 = " {" + d2, x2 = d2 + "}", C = $a2(Qc2(l2), function(L) {
        return L + y2 + $a2(Qc2(l2[L]), function(F3) {
          return F3 + ":" + l2[L][F3] + ";";
        }).join(d2) + x2;
      }).join(d2), D2 = $a2(Qc2(a), function(L) {
        return "@keyframes " + L + y2 + $a2(Qc2(a[L]), function(F3) {
          return F3 + y2 + $a2(Qc2(a[L][F3]), function(j) {
            var U3 = a[L][F3][j];
            return j === "d" && (U3 = 'path("' + U3 + '")'), j + ":" + U3 + ";";
          }).join(d2) + x2;
        }).join(d2) + x2;
      }).join(d2);
      return !C && !D2 ? "" : ["<![CDATA[", C, D2, "]]>"].join(d2);
    }
    function YLt(l2) {
      return { zrId: l2, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
    }
    function Nse(l2, a, e2, d2) {
      return _1("svg", "root", { width: l2, height: a, xmlns: Lse, "xmlns:xlink": Ose, version: "1.1", baseProfile: "full", viewBox: d2 ? "0 0 " + l2 + " " + a : false }, e2);
    }
    var Fse = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, dB = "transform-origin";
    function $Qe(l2, a, e2) {
      var d2 = la2({}, l2.shape);
      la2(d2, a), l2.buildPath(e2, d2);
      var y2 = new Pse();
      return y2.reset(vvt(l2)), e2.rebuildPath(y2, 1), y2.generateStr(), y2.getStr();
    }
    function YQe(l2, a) {
      var e2 = a.originX, d2 = a.originY;
      (e2 || d2) && (l2[dB] = e2 + "px " + d2 + "px");
    }
    var KQe = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
    function Vse(l2, a) {
      var e2 = a.zrId + "-ani-" + a.cssAnimIdx++;
      return a.cssAnims[e2] = l2, e2;
    }
    function XQe(l2, a, e2) {
      var d2 = l2.shape.paths, y2 = {}, x2, C;
      if (Ke2(d2, function(L) {
        var F3 = YLt(e2.zrId);
        F3.animation = true, $yt(L, {}, F3, true);
        var j = F3.cssAnims, U3 = F3.cssNodes, Y3 = Qc2(j), Q = Y3.length;
        if (Q) {
          C = Y3[Q - 1];
          var nt = j[C];
          for (var dt in nt) {
            var vt = nt[dt];
            y2[dt] = y2[dt] || { d: "" }, y2[dt].d += vt.d || "";
          }
          for (var Ct in U3) {
            var Pt = U3[Ct].animation;
            Pt.indexOf(C) >= 0 && (x2 = Pt);
          }
        }
      }), !!x2) {
        a.d = false;
        var D2 = Vse(y2, e2);
        return x2.replace(C, D2);
      }
    }
    function Bse(l2) {
      return ps(l2) ? Fse[l2] ? "cubic-bezier(" + Fse[l2] + ")" : MV(l2) ? l2 : "" : "";
    }
    function $yt(l2, a, e2, d2) {
      var y2 = l2.animators, x2 = y2.length, C = [];
      if (l2 instanceof Jnt) {
        var D2 = XQe(l2, a, e2);
        if (D2)
          C.push(D2);
        else if (!x2)
          return;
      } else if (!x2)
        return;
      for (var L = {}, F3 = 0; F3 < x2; F3++) {
        var j = y2[F3], U3 = [j.getMaxTime() / 1e3 + "s"], Y3 = Bse(j.getClip().easing), Q = j.getDelay();
        Y3 ? U3.push(Y3) : U3.push("linear"), Q && U3.push(Q / 1e3 + "s"), j.getLoop() && U3.push("infinite");
        var nt = U3.join(" ");
        L[nt] = L[nt] || [nt, []], L[nt][1].push(j);
      }
      function dt(Pt) {
        var jt = Pt[1], Rt = jt.length, le2 = {}, ne2 = {}, he2 = {}, _e = "animation-timing-function";
        function Me2(rs, Gs, al) {
          for (var _s = rs.getTracks(), Fl = rs.getMaxTime(), Ih2 = 0; Ih2 < _s.length; Ih2++) {
            var lu = _s[Ih2];
            if (lu.needsAnimate()) {
              var ah2 = lu.keyframes, Uh2 = lu.propName;
              if (al && (Uh2 = al(Uh2)), Uh2)
                for (var Np = 0; Np < ah2.length; Np++) {
                  var Zy = ah2[Np], Nd2 = Math.round(Zy.time / Fl * 100) + "%", w1 = Bse(Zy.easing), Zd2 = Zy.rawValue;
                  (ps(Zd2) || Ch2(Zd2)) && (Gs[Nd2] = Gs[Nd2] || {}, Gs[Nd2][Uh2] = Zy.rawValue, w1 && (Gs[Nd2][_e] = w1));
                }
            }
          }
        }
        for (var Pe2 = 0; Pe2 < Rt; Pe2++) {
          var Be2 = jt[Pe2], Je2 = Be2.targetName;
          Je2 ? Je2 === "shape" && Me2(Be2, ne2) : !d2 && Me2(Be2, le2);
        }
        for (var Ze2 in le2) {
          var Cn = {};
          Avt(Cn, l2), la2(Cn, le2[Ze2]);
          var Bn = Bet(Cn), mn = le2[Ze2][_e];
          he2[Ze2] = Bn ? { transform: Bn } : {}, YQe(he2[Ze2], Cn), mn && (he2[Ze2][_e] = mn);
        }
        var Kr, Kn = true;
        for (var Ze2 in ne2) {
          he2[Ze2] = he2[Ze2] || {};
          var ar = !Kr, mn = ne2[Ze2][_e];
          ar && (Kr = new yA());
          var Cr = Kr.len();
          Kr.reset(), he2[Ze2].d = $Qe(l2, ne2[Ze2], Kr);
          var ui2 = Kr.len();
          if (!ar && Cr !== ui2) {
            Kn = false;
            break;
          }
          mn && (he2[Ze2][_e] = mn);
        }
        if (!Kn)
          for (var Ze2 in he2)
            delete he2[Ze2].d;
        if (!d2)
          for (var Pe2 = 0; Pe2 < Rt; Pe2++) {
            var Be2 = jt[Pe2], Je2 = Be2.targetName;
            Je2 === "style" && Me2(Be2, he2, function(_s) {
              return KQe[_s];
            });
          }
        for (var vi2 = Qc2(he2), ko = true, Ss, Pe2 = 1; Pe2 < vi2.length; Pe2++) {
          var hl = vi2[Pe2 - 1], Qs = vi2[Pe2];
          if (he2[hl][dB] !== he2[Qs][dB]) {
            ko = false;
            break;
          }
          Ss = he2[hl][dB];
        }
        if (ko && Ss) {
          for (var Ze2 in he2)
            he2[Ze2][dB] && delete he2[Ze2][dB];
          a[dB] = Ss;
        }
        if (Lp(vi2, function(rs) {
          return Qc2(he2[rs]).length > 0;
        }).length) {
          var Js = Vse(he2, e2);
          return Js + " " + Pt[0] + " both";
        }
      }
      for (var vt in L) {
        var D2 = dt(L[vt]);
        D2 && C.push(D2);
      }
      if (C.length) {
        var Ct = e2.zrId + "-cls-" + e2.cssClassIdx++;
        e2.cssNodes["." + Ct] = { animation: C.join(",") }, a.class = Ct;
      }
    }
    var Frt = Math.round;
    function zse(l2) {
      return l2 && ps(l2.src);
    }
    function jse(l2) {
      return l2 && wl(l2.toDataURL);
    }
    function KLt(l2, a, e2, d2) {
      WQe(function(y2, x2) {
        var C = y2 === "fill" || y2 === "stroke";
        C && E5t(x2) ? aJe(a, l2, y2, d2) : C && uC(x2) ? oJe(e2, l2, y2, d2) : l2[y2] = x2;
      }, a, e2, false), iJe(e2, l2, d2);
    }
    function Wse(l2) {
      return F5(l2[0] - 1) && F5(l2[1]) && F5(l2[2]) && F5(l2[3] - 1);
    }
    function QQe(l2) {
      return F5(l2[4]) && F5(l2[5]);
    }
    function XLt(l2, a, e2) {
      if (a && !(QQe(a) && Wse(a))) {
        var d2 = e2 ? 10 : 1e4;
        l2.transform = Wse(a) ? "translate(" + Frt(a[4] * d2) / d2 + " " + Frt(a[5] * d2) / d2 + ")" : C5t(a);
      }
    }
    function Gse(l2, a, e2) {
      for (var d2 = l2.points, y2 = [], x2 = 0; x2 < d2.length; x2++)
        y2.push(Frt(d2[x2][0] * e2) / e2), y2.push(Frt(d2[x2][1] * e2) / e2);
      a.points = y2.join(" ");
    }
    function Hse(l2) {
      return !l2.smooth;
    }
    function JQe(l2) {
      var a = $a2(l2, function(e2) {
        return typeof e2 == "string" ? [e2, e2] : e2;
      });
      return function(e2, d2, y2) {
        for (var x2 = 0; x2 < a.length; x2++) {
          var C = a[x2], D2 = e2[C[0]];
          D2 != null && (d2[C[1]] = Frt(D2 * y2) / y2);
        }
      };
    }
    var tJe = { circle: [JQe(["cx", "cy", "r"])], polyline: [Gse, Hse], polygon: [Gse, Hse] };
    function eJe(l2) {
      for (var a = l2.animators, e2 = 0; e2 < a.length; e2++)
        if (a[e2].targetName === "shape")
          return true;
      return false;
    }
    function Use(l2, a) {
      var e2 = l2.style, d2 = l2.shape, y2 = tJe[l2.type], x2 = {}, C = a.animation, D2 = "path", L = l2.style.strokePercent, F3 = a.compress && vvt(l2) || 4;
      if (y2 && !a.willUpdate && !(y2[1] && !y2[1](d2)) && !(C && eJe(l2)) && !(L < 1)) {
        D2 = l2.type;
        var j = Math.pow(10, F3);
        y2[0](d2, x2, j);
      } else {
        l2.path || l2.createPathProxy();
        var U3 = l2.path;
        l2.shapeChanged() && (U3.beginPath(), l2.buildPath(U3, l2.shape), l2.pathUpdated());
        var Y3 = U3.getVersion(), Q = l2, nt = Q.__svgPathBuilder;
        (Q.__svgPathVersion !== Y3 || !nt || L !== Q.__svgPathStrokePercent) && (nt || (nt = Q.__svgPathBuilder = new Pse()), nt.reset(F3), U3.rebuildPath(nt, L), nt.generateStr(), Q.__svgPathVersion = Y3, Q.__svgPathStrokePercent = L), x2.d = nt.getStr();
      }
      return XLt(x2, l2.transform), KLt(x2, e2, l2, a), a.animation && $yt(l2, x2, a), _1(D2, l2.id + "", x2);
    }
    function nJe(l2, a) {
      var e2 = l2.style, d2 = e2.image;
      if (d2 && !ps(d2) && (zse(d2) ? d2 = d2.src : jse(d2) && (d2 = d2.toDataURL())), !!d2) {
        var y2 = e2.x || 0, x2 = e2.y || 0, C = e2.width, D2 = e2.height, L = { href: d2, width: C, height: D2 };
        return y2 && (L.x = y2), x2 && (L.y = x2), XLt(L, l2.transform), KLt(L, e2, l2, a), a.animation && $yt(l2, L, a), _1("image", l2.id + "", L);
      }
    }
    function rJe(l2, a) {
      var e2 = l2.style, d2 = e2.text;
      if (d2 != null && (d2 += ""), !(!d2 || isNaN(e2.x) || isNaN(e2.y))) {
        var y2 = e2.font || Ru, x2 = e2.x || 0, C = A5t(e2.y || 0, LN(y2), e2.textBaseline), D2 = T5t[e2.textAlign] || e2.textAlign, L = { "dominant-baseline": "central", "text-anchor": D2 };
        if (y0t(e2)) {
          var F3 = "", j = e2.fontStyle, U3 = g0t(e2.fontSize);
          if (!parseFloat(U3))
            return;
          var Y3 = e2.fontFamily || lv, Q = e2.fontWeight;
          F3 += "font-size:" + U3 + ";font-family:" + Y3 + ";", j && j !== "normal" && (F3 += "font-style:" + j + ";"), Q && Q !== "normal" && (F3 += "font-weight:" + Q + ";"), L.style = F3;
        } else
          L.style = "font: " + y2;
        return d2.match(/\s/) && (L["xml:space"] = "preserve"), x2 && (L.x = x2), C && (L.y = C), XLt(L, l2.transform), KLt(L, e2, l2, a), a.animation && $yt(l2, L, a), _1("text", l2.id + "", L, void 0, d2);
      }
    }
    function qse(l2, a) {
      if (l2 instanceof wc2)
        return Use(l2, a);
      if (l2 instanceof Im)
        return nJe(l2, a);
      if (l2 instanceof GV)
        return rJe(l2, a);
    }
    function iJe(l2, a, e2) {
      var d2 = l2.style;
      if (I5t(d2)) {
        var y2 = eO(l2), x2 = e2.shadowCache, C = x2[y2];
        if (!C) {
          var D2 = l2.getGlobalScale(), L = D2[0], F3 = D2[1];
          if (!L || !F3)
            return;
          var j = d2.shadowOffsetX || 0, U3 = d2.shadowOffsetY || 0, Y3 = d2.shadowBlur, Q = AN(d2.shadowColor), nt = Q.opacity, dt = Q.color, vt = Y3 / 2 / L, Ct = Y3 / 2 / F3, Pt = vt + " " + Ct;
          C = e2.zrId + "-s" + e2.shadowIdx++, e2.defs[C] = _1("filter", C, { id: C, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [_1("feDropShadow", "", { dx: j / L, dy: U3 / F3, stdDeviation: Pt, "flood-color": dt, "flood-opacity": nt })]), x2[y2] = C;
        }
        a.filter = GU(C);
      }
    }
    function aJe(l2, a, e2, d2) {
      var y2 = l2[e2], x2, C = { gradientUnits: y2.global ? "userSpaceOnUse" : "objectBoundingBox" };
      if (dvt(y2))
        x2 = "linearGradient", C.x1 = y2.x, C.y1 = y2.y, C.x2 = y2.x2, C.y2 = y2.y2;
      else if (gvt(y2))
        x2 = "radialGradient", C.cx = $u(y2.x, 0.5), C.cy = $u(y2.y, 0.5), C.r = $u(y2.r, 0.5);
      else
        return;
      for (var D2 = y2.colorStops, L = [], F3 = 0, j = D2.length; F3 < j; ++F3) {
        var U3 = Vet(D2[F3].offset) * 100 + "%", Y3 = D2[F3].color, Q = AN(Y3), nt = Q.color, dt = Q.opacity, vt = { offset: U3 };
        vt["stop-color"] = nt, dt < 1 && (vt["stop-opacity"] = dt), L.push(_1("stop", F3 + "", vt));
      }
      var Ct = _1(x2, "", C, L), Pt = $Lt(Ct), jt = d2.gradientCache, Rt = jt[Pt];
      Rt || (Rt = d2.zrId + "-g" + d2.gradientIdx++, jt[Pt] = Rt, C.id = Rt, d2.defs[Rt] = _1(x2, Rt, C, L)), a[e2] = GU(Rt);
    }
    function oJe(l2, a, e2, d2) {
      var y2 = l2.style[e2], x2 = { patternUnits: "userSpaceOnUse" }, C;
      if (pvt(y2)) {
        var D2 = y2.imageWidth, L = y2.imageHeight, F3 = void 0, j = y2.image;
        if (ps(j) ? F3 = j : zse(j) ? F3 = j.src : jse(j) && (F3 = j.toDataURL()), typeof Image == "undefined") {
          var U3 = "Image width/height must been given explictly in svg-ssr renderer.";
          vb2(D2, U3), vb2(L, U3);
        } else if (D2 == null || L == null) {
          var Y3 = function(Pt, jt) {
            if (Pt) {
              var Rt = Pt.elm, le2 = Pt.attrs.width = D2 || jt.width, ne2 = Pt.attrs.height = L || jt.height;
              Rt && (Rt.setAttribute("width", le2), Rt.setAttribute("height", ne2));
            }
          }, Q = hq(F3, null, l2, function(Pt) {
            Y3(nt, Pt), Y3(C, Pt);
          });
          Q && Q.width && Q.height && (D2 = D2 || Q.width, L = L || Q.height);
        }
        C = _1("image", "img", { href: F3, width: D2, height: L }), x2.width = D2, x2.height = L;
      } else
        y2.svgElement && (C = zl(y2.svgElement), x2.width = y2.svgWidth, x2.height = y2.svgHeight);
      if (C) {
        x2.patternTransform = Bet(y2);
        var nt = _1("pattern", "", x2, [C]), dt = $Lt(nt), vt = d2.patternCache, Ct = vt[dt];
        Ct || (Ct = d2.zrId + "-p" + d2.patternIdx++, vt[dt] = Ct, x2.id = Ct, nt = d2.defs[Ct] = _1("pattern", Ct, x2, [C])), a[e2] = GU(Ct);
      }
    }
    function sJe(l2, a, e2) {
      var d2 = e2.clipPathCache, y2 = e2.defs, x2 = d2[l2.id];
      if (!x2) {
        x2 = e2.zrId + "-c" + e2.clipPathIdx++;
        var C = { id: x2 };
        d2[l2.id] = x2, y2[x2] = _1("clipPath", x2, C, [Use(l2, e2)]);
      }
      a["clip-path"] = GU(x2);
    }
    function Zse(l2) {
      return document.createTextNode(l2);
    }
    function gB(l2, a, e2) {
      l2.insertBefore(a, e2);
    }
    function $se(l2, a) {
      l2.removeChild(a);
    }
    function Yse(l2, a) {
      l2.appendChild(a);
    }
    function Kse(l2) {
      return l2.parentNode;
    }
    function Xse(l2) {
      return l2.nextSibling;
    }
    function QLt(l2, a) {
      l2.textContent = a;
    }
    var Qse = 58, lJe = 120, uJe = _1("", "");
    function JLt(l2) {
      return l2 === void 0;
    }
    function fP(l2) {
      return l2 !== void 0;
    }
    function cJe(l2, a, e2) {
      for (var d2 = {}, y2 = a; y2 <= e2; ++y2) {
        var x2 = l2[y2].key;
        x2 !== void 0 && (d2[x2] = y2);
      }
      return d2;
    }
    function Vrt(l2, a) {
      var e2 = l2.key === a.key, d2 = l2.tag === a.tag;
      return d2 && e2;
    }
    function Brt(l2) {
      var a, e2 = l2.children, d2 = l2.tag;
      if (fP(d2)) {
        var y2 = l2.elm = Rse(d2);
        if (tOt(uJe, l2), Ba2(e2))
          for (a = 0; a < e2.length; ++a) {
            var x2 = e2[a];
            x2 != null && Yse(y2, Brt(x2));
          }
        else
          fP(l2.text) && !vs(l2.text) && Yse(y2, Zse(l2.text));
      } else
        l2.elm = Zse(l2.text);
      return l2.elm;
    }
    function Jse(l2, a, e2, d2, y2) {
      for (; d2 <= y2; ++d2) {
        var x2 = e2[d2];
        x2 != null && gB(l2, Brt(x2), a);
      }
    }
    function Yyt(l2, a, e2, d2) {
      for (; e2 <= d2; ++e2) {
        var y2 = a[e2];
        if (y2 != null)
          if (fP(y2.tag)) {
            var x2 = Kse(y2.elm);
            $se(x2, y2.elm);
          } else
            $se(l2, y2.elm);
      }
    }
    function tOt(l2, a) {
      var e2, d2 = a.elm, y2 = l2 && l2.attrs || {}, x2 = a.attrs || {};
      if (y2 !== x2) {
        for (e2 in x2) {
          var C = x2[e2], D2 = y2[e2];
          D2 !== C && (C === true ? d2.setAttribute(e2, "") : C === false ? d2.removeAttribute(e2) : e2.charCodeAt(0) !== lJe ? d2.setAttribute(e2, C) : e2 === "xmlns:xlink" || e2 === "xmlns" ? d2.setAttributeNS(GQe, e2, C) : e2.charCodeAt(3) === Qse ? d2.setAttributeNS(HQe, e2, C) : e2.charCodeAt(5) === Qse ? d2.setAttributeNS(Ose, e2, C) : d2.setAttribute(e2, C));
        }
        for (e2 in y2)
          e2 in x2 || d2.removeAttribute(e2);
      }
    }
    function fJe(l2, a, e2) {
      for (var d2 = 0, y2 = 0, x2 = a.length - 1, C = a[0], D2 = a[x2], L = e2.length - 1, F3 = e2[0], j = e2[L], U3, Y3, Q, nt; d2 <= x2 && y2 <= L; )
        C == null ? C = a[++d2] : D2 == null ? D2 = a[--x2] : F3 == null ? F3 = e2[++y2] : j == null ? j = e2[--L] : Vrt(C, F3) ? (aZ(C, F3), C = a[++d2], F3 = e2[++y2]) : Vrt(D2, j) ? (aZ(D2, j), D2 = a[--x2], j = e2[--L]) : Vrt(C, j) ? (aZ(C, j), gB(l2, C.elm, Xse(D2.elm)), C = a[++d2], j = e2[--L]) : Vrt(D2, F3) ? (aZ(D2, F3), gB(l2, D2.elm, C.elm), D2 = a[--x2], F3 = e2[++y2]) : (JLt(U3) && (U3 = cJe(a, d2, x2)), Y3 = U3[F3.key], JLt(Y3) ? gB(l2, Brt(F3), C.elm) : (Q = a[Y3], Q.tag !== F3.tag ? gB(l2, Brt(F3), C.elm) : (aZ(Q, F3), a[Y3] = void 0, gB(l2, Q.elm, C.elm))), F3 = e2[++y2]);
      (d2 <= x2 || y2 <= L) && (d2 > x2 ? (nt = e2[L + 1] == null ? null : e2[L + 1].elm, Jse(l2, nt, e2, y2, L)) : Yyt(l2, a, d2, x2));
    }
    function aZ(l2, a) {
      var e2 = a.elm = l2.elm, d2 = l2.children, y2 = a.children;
      l2 !== a && (tOt(l2, a), JLt(a.text) ? fP(d2) && fP(y2) ? d2 !== y2 && fJe(e2, d2, y2) : fP(y2) ? (fP(l2.text) && QLt(e2, ""), Jse(e2, null, y2, 0, y2.length - 1)) : fP(d2) ? Yyt(e2, d2, 0, d2.length - 1) : fP(l2.text) && QLt(e2, "") : l2.text !== a.text && (fP(d2) && Yyt(e2, d2, 0, d2.length - 1), QLt(e2, a.text)));
    }
    function hJe(l2, a) {
      if (Vrt(l2, a))
        aZ(l2, a);
      else {
        var e2 = l2.elm, d2 = Kse(e2);
        Brt(a), d2 !== null && (gB(d2, a.elm, Xse(e2)), Yyt(d2, [l2], 0, 0));
      }
      return a;
    }
    var pJe = 0, dJe = function() {
      function l2(a, e2, d2) {
        if (this.type = "svg", this.refreshHover = tle(), this.configLayer = tle(), this.storage = e2, this._opts = d2 = la2({}, d2), this.root = a, this._id = "zr" + pJe++, this._oldVNode = Nse(d2.width, d2.height), a && !d2.ssr) {
          var y2 = this._viewport = document.createElement("div");
          y2.style.cssText = "position:relative;overflow:hidden";
          var x2 = this._svgDom = this._oldVNode.elm = Rse("svg");
          tOt(null, this._oldVNode), y2.appendChild(x2), a.appendChild(y2);
        }
        this.resize(d2.width, d2.height);
      }
      return l2.prototype.getType = function() {
        return this.type;
      }, l2.prototype.getViewportRoot = function() {
        return this._viewport;
      }, l2.prototype.getViewportRootOffset = function() {
        var a = this.getViewportRoot();
        if (a)
          return { offsetLeft: a.offsetLeft || 0, offsetTop: a.offsetTop || 0 };
      }, l2.prototype.getSvgDom = function() {
        return this._svgDom;
      }, l2.prototype.refresh = function() {
        if (this.root) {
          var a = this.renderToVNode({ willUpdate: true });
          a.attrs.style = "position:absolute;left:0;top:0;user-select:none", hJe(this._oldVNode, a), this._oldVNode = a;
        }
      }, l2.prototype.renderOneToVNode = function(a) {
        return qse(a, YLt(this._id));
      }, l2.prototype.renderToVNode = function(a) {
        a = a || {};
        var e2 = this.storage.getDisplayList(true), d2 = this._backgroundColor, y2 = this._width, x2 = this._height, C = YLt(this._id);
        C.animation = a.animation, C.willUpdate = a.willUpdate, C.compress = a.compress;
        var D2 = [];
        if (d2 && d2 !== "none") {
          var L = AN(d2), F3 = L.color, j = L.opacity;
          this._bgVNode = _1("rect", "bg", { width: y2, height: x2, x: "0", y: "0", id: "0", fill: F3, "fill-opacity": j }), D2.push(this._bgVNode);
        } else
          this._bgVNode = null;
        var U3 = a.compress ? null : this._mainVNode = _1("g", "main", {}, []);
        this._paintList(e2, C, U3 ? U3.children : D2), U3 && D2.push(U3);
        var Y3 = $a2(Qc2(C.defs), function(dt) {
          return C.defs[dt];
        });
        if (Y3.length && D2.push(_1("defs", "defs", {}, Y3)), a.animation) {
          var Q = ZQe(C.cssNodes, C.cssAnims, { newline: true });
          if (Q) {
            var nt = _1("style", "stl", {}, [], Q);
            D2.push(nt);
          }
        }
        return Nse(y2, x2, D2, a.useViewBox);
      }, l2.prototype.renderToString = function(a) {
        return a = a || {}, $Lt(this.renderToVNode({ animation: $u(a.cssAnimation, true), willUpdate: false, compress: true, useViewBox: $u(a.useViewBox, true) }), { newline: true });
      }, l2.prototype.setBackgroundColor = function(a) {
        this._backgroundColor = a;
        var e2 = this._bgVNode;
        if (e2 && e2.elm) {
          var d2 = AN(a), y2 = d2.color, x2 = d2.opacity;
          e2.elm.setAttribute("fill", y2), x2 < 1 && e2.elm.setAttribute("fill-opacity", x2);
        }
      }, l2.prototype.getSvgRoot = function() {
        return this._mainVNode && this._mainVNode.elm;
      }, l2.prototype._paintList = function(a, e2, d2) {
        for (var y2 = a.length, x2 = [], C = 0, D2, L, F3 = 0, j = 0; j < y2; j++) {
          var U3 = a[j];
          if (!U3.invisible) {
            var Y3 = U3.__clipPaths, Q = Y3 && Y3.length || 0, nt = L && L.length || 0, dt = void 0;
            for (dt = Math.max(Q - 1, nt - 1); dt >= 0 && !(Y3 && L && Y3[dt] === L[dt]); dt--)
              ;
            for (var vt = nt - 1; vt > dt; vt--)
              C--, D2 = x2[C - 1];
            for (var Ct = dt + 1; Ct < Q; Ct++) {
              var Pt = {};
              sJe(Y3[Ct], Pt, e2);
              var jt = _1("g", "clip-g-" + F3++, Pt, []);
              (D2 ? D2.children : d2).push(jt), x2[C++] = jt, D2 = jt;
            }
            L = Y3;
            var Rt = qse(U3, e2);
            Rt && (D2 ? D2.children : d2).push(Rt);
          }
        }
      }, l2.prototype.resize = function(a, e2) {
        var d2 = this._opts, y2 = this.root, x2 = this._viewport;
        if (a != null && (d2.width = a), e2 != null && (d2.height = e2), y2 && x2 && (x2.style.display = "none", a = eZ(y2, 0, d2), e2 = eZ(y2, 1, d2), x2.style.display = ""), this._width !== a || this._height !== e2) {
          if (this._width = a, this._height = e2, x2) {
            var C = x2.style;
            C.width = a + "px", C.height = e2 + "px";
          }
          var D2 = this._svgDom;
          D2 && (D2.setAttribute("width", a), D2.setAttribute("height", e2));
        }
      }, l2.prototype.getWidth = function() {
        return this._width;
      }, l2.prototype.getHeight = function() {
        return this._height;
      }, l2.prototype.dispose = function() {
        this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
      }, l2.prototype.clear = function() {
        this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
      }, l2.prototype.toDataURL = function(a) {
        var e2 = encodeURIComponent(this.renderToString()), d2 = "data:image/svg+xml;";
        return a ? (e2 = yvt(e2), e2 && d2 + "base64," + e2) : d2 + "charset=UTF-8," + e2;
      }, l2;
    }();
    function tle(l2) {
      return function() {
      };
    }
    var gJe = dJe;
    function vJe(l2) {
      l2.registerPainter("svg", gJe);
    }
    function ele(l2, a, e2) {
      var d2 = Zx.createCanvas(), y2 = a.getWidth(), x2 = a.getHeight(), C = d2.style;
      return C && (C.position = "absolute", C.left = "0", C.top = "0", C.width = y2 + "px", C.height = x2 + "px", d2.setAttribute("data-zr-dom-id", l2)), d2.width = y2 * e2, d2.height = x2 * e2, d2;
    }
    var yJe = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this) || this;
        x2.motionBlur = false, x2.lastFrameAlpha = 0.7, x2.dpr = 1, x2.virtual = false, x2.config = {}, x2.incremental = false, x2.zlevel = 0, x2.maxRepaintRectCount = 5, x2.__dirty = true, x2.__firstTimePaint = true, x2.__used = false, x2.__drawIndex = 0, x2.__startIndex = 0, x2.__endIndex = 0, x2.__prevStartIndex = null, x2.__prevEndIndex = null;
        var C;
        y2 = y2 || ZU, typeof e2 == "string" ? C = ele(e2, d2, y2) : vs(e2) && (C = e2, e2 = C.id), x2.id = e2, x2.dom = C;
        var D2 = C.style;
        return D2 && ($x(C), C.onselectstart = function() {
          return false;
        }, D2.padding = "0", D2.margin = "0", D2.borderWidth = "0"), x2.painter = d2, x2.dpr = y2, x2;
      }
      return a.prototype.getElementCount = function() {
        return this.__endIndex - this.__startIndex;
      }, a.prototype.afterBrush = function() {
        this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
      }, a.prototype.initContext = function() {
        this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
      }, a.prototype.setUnpainted = function() {
        this.__firstTimePaint = true;
      }, a.prototype.createBackBuffer = function() {
        var e2 = this.dpr;
        this.domBack = ele("back-" + this.id, this.painter, e2), this.ctxBack = this.domBack.getContext("2d"), e2 !== 1 && this.ctxBack.scale(e2, e2);
      }, a.prototype.createRepaintRects = function(e2, d2, y2, x2) {
        if (this.__firstTimePaint)
          return this.__firstTimePaint = false, null;
        var C = [], D2 = this.maxRepaintRectCount, L = false, F3 = new Yu(0, 0, 0, 0);
        function j(Pt) {
          if (!(!Pt.isFinite() || Pt.isZero()))
            if (C.length === 0) {
              var jt = new Yu(0, 0, 0, 0);
              jt.copy(Pt), C.push(jt);
            } else {
              for (var Rt = false, le2 = 1 / 0, ne2 = 0, he2 = 0; he2 < C.length; ++he2) {
                var _e = C[he2];
                if (_e.intersect(Pt)) {
                  var Me2 = new Yu(0, 0, 0, 0);
                  Me2.copy(_e), Me2.union(Pt), C[he2] = Me2, Rt = true;
                  break;
                } else if (L) {
                  F3.copy(Pt), F3.union(_e);
                  var Pe2 = Pt.width * Pt.height, Be2 = _e.width * _e.height, Je2 = F3.width * F3.height, Ze2 = Je2 - Pe2 - Be2;
                  Ze2 < le2 && (le2 = Ze2, ne2 = he2);
                }
              }
              if (L && (C[ne2].union(Pt), Rt = true), !Rt) {
                var jt = new Yu(0, 0, 0, 0);
                jt.copy(Pt), C.push(jt);
              }
              L || (L = C.length >= D2);
            }
        }
        for (var U3 = this.__startIndex; U3 < this.__endIndex; ++U3) {
          var Y3 = e2[U3];
          if (Y3) {
            var Q = Y3.shouldBePainted(y2, x2, true, true), nt = Y3.__isRendered && (Y3.__dirty & yb2 || !Q) ? Y3.getPrevPaintRect() : null;
            nt && j(nt);
            var dt = Q && (Y3.__dirty & yb2 || !Y3.__isRendered) ? Y3.getPaintRect() : null;
            dt && j(dt);
          }
        }
        for (var U3 = this.__prevStartIndex; U3 < this.__prevEndIndex; ++U3) {
          var Y3 = d2[U3], Q = Y3.shouldBePainted(y2, x2, true, true);
          if (Y3 && (!Q || !Y3.__zr) && Y3.__isRendered) {
            var nt = Y3.getPrevPaintRect();
            nt && j(nt);
          }
        }
        var vt;
        do {
          vt = false;
          for (var U3 = 0; U3 < C.length; ) {
            if (C[U3].isZero()) {
              C.splice(U3, 1);
              continue;
            }
            for (var Ct = U3 + 1; Ct < C.length; )
              C[U3].intersect(C[Ct]) ? (vt = true, C[U3].union(C[Ct]), C.splice(Ct, 1)) : Ct++;
            U3++;
          }
        } while (vt);
        return this._paintRects = C, C;
      }, a.prototype.debugGetPaintRects = function() {
        return (this._paintRects || []).slice();
      }, a.prototype.resize = function(e2, d2) {
        var y2 = this.dpr, x2 = this.dom, C = x2.style, D2 = this.domBack;
        C && (C.width = e2 + "px", C.height = d2 + "px"), x2.width = e2 * y2, x2.height = d2 * y2, D2 && (D2.width = e2 * y2, D2.height = d2 * y2, y2 !== 1 && this.ctxBack.scale(y2, y2));
      }, a.prototype.clear = function(e2, d2, y2) {
        var x2 = this.dom, C = this.ctx, D2 = x2.width, L = x2.height;
        d2 = d2 || this.clearColor;
        var F3 = this.motionBlur && !e2, j = this.lastFrameAlpha, U3 = this.dpr, Y3 = this;
        F3 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(x2, 0, 0, D2 / U3, L / U3));
        var Q = this.domBack;
        function nt(dt, vt, Ct, Pt) {
          if (C.clearRect(dt, vt, Ct, Pt), d2 && d2 !== "transparent") {
            var jt = void 0;
            DU(d2) ? (jt = d2.__canvasGradient || sLt(C, d2, { x: 0, y: 0, width: Ct, height: Pt }), d2.__canvasGradient = jt) : s5t(d2) && (jt = uLt(C, d2, { dirty: function() {
              Y3.setUnpainted(), Y3.__painter.refresh();
            } })), C.save(), C.fillStyle = jt || d2, C.fillRect(dt, vt, Ct, Pt), C.restore();
          }
          F3 && (C.save(), C.globalAlpha = j, C.drawImage(Q, dt, vt, Ct, Pt), C.restore());
        }
        !y2 || F3 ? nt(0, 0, D2, L) : y2.length && Ke2(y2, function(dt) {
          nt(dt.x * U3, dt.y * U3, dt.width * U3, dt.height * U3);
        });
      }, a;
    }(Yx), eOt = yJe, nle = 1e5, vB = 314159, Kyt = 0.01, mJe = 1e-3;
    function bJe(l2) {
      return l2 ? l2.__builtin__ ? true : !(typeof l2.resize != "function" || typeof l2.refresh != "function") : false;
    }
    function _Je(l2, a) {
      var e2 = document.createElement("div");
      return e2.style.cssText = ["position:relative", "width:" + l2 + "px", "height:" + a + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", e2;
    }
    var xJe = function() {
      function l2(a, e2, d2, y2) {
        this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
        var x2 = !a.nodeName || a.nodeName.toUpperCase() === "CANVAS";
        this._opts = d2 = la2({}, d2 || {}), this.dpr = d2.devicePixelRatio || ZU, this._singleCanvas = x2, this.root = a;
        var C = a.style;
        C && ($x(a), a.innerHTML = ""), this.storage = e2;
        var D2 = this._zlevelList;
        this._prevDisplayList = [];
        var L = this._layers;
        if (x2) {
          var F3 = a, j = F3.width, U3 = F3.height;
          d2.width != null && (j = d2.width), d2.height != null && (U3 = d2.height), this.dpr = d2.devicePixelRatio || 1, F3.width = j * this.dpr, F3.height = U3 * this.dpr, this._width = j, this._height = U3;
          var Y3 = new eOt(F3, this, this.dpr);
          Y3.__builtin__ = true, Y3.initContext(), L[vB] = Y3, Y3.zlevel = vB, D2.push(vB), this._domRoot = a;
        } else {
          this._width = eZ(a, 0, d2), this._height = eZ(a, 1, d2);
          var Q = this._domRoot = _Je(this._width, this._height);
          a.appendChild(Q);
        }
      }
      return l2.prototype.getType = function() {
        return "canvas";
      }, l2.prototype.isSingleCanvas = function() {
        return this._singleCanvas;
      }, l2.prototype.getViewportRoot = function() {
        return this._domRoot;
      }, l2.prototype.getViewportRootOffset = function() {
        var a = this.getViewportRoot();
        if (a)
          return { offsetLeft: a.offsetLeft || 0, offsetTop: a.offsetTop || 0 };
      }, l2.prototype.refresh = function(a) {
        var e2 = this.storage.getDisplayList(true), d2 = this._prevDisplayList, y2 = this._zlevelList;
        this._redrawId = Math.random(), this._paintList(e2, d2, a, this._redrawId);
        for (var x2 = 0; x2 < y2.length; x2++) {
          var C = y2[x2], D2 = this._layers[C];
          if (!D2.__builtin__ && D2.refresh) {
            var L = x2 === 0 ? this._backgroundColor : null;
            D2.refresh(L);
          }
        }
        return this._opts.useDirtyRect && (this._prevDisplayList = e2.slice()), this;
      }, l2.prototype.refreshHover = function() {
        this._paintHoverList(this.storage.getDisplayList(false));
      }, l2.prototype._paintHoverList = function(a) {
        var e2 = a.length, d2 = this._hoverlayer;
        if (d2 && d2.clear(), !!e2) {
          for (var y2 = { inHover: true, viewWidth: this._width, viewHeight: this._height }, x2, C = 0; C < e2; C++) {
            var D2 = a[C];
            D2.__inHover && (d2 || (d2 = this._hoverlayer = this.getLayer(nle)), x2 || (x2 = d2.ctx, x2.save()), lB(x2, D2, y2, C === e2 - 1));
          }
          x2 && x2.restore();
        }
      }, l2.prototype.getHoverLayer = function() {
        return this.getLayer(nle);
      }, l2.prototype.paintOne = function(a, e2) {
        Jae(a, e2);
      }, l2.prototype._paintList = function(a, e2, d2, y2) {
        if (this._redrawId === y2) {
          d2 = d2 || false, this._updateLayerStatus(a);
          var x2 = this._doPaintList(a, e2, d2), C = x2.finished, D2 = x2.needsRefreshHover;
          if (this._needsManuallyCompositing && this._compositeManually(), D2 && this._paintHoverList(a), C)
            this.eachLayer(function(F3) {
              F3.afterBrush && F3.afterBrush();
            });
          else {
            var L = this;
            iA(function() {
              L._paintList(a, e2, d2, y2);
            });
          }
        }
      }, l2.prototype._compositeManually = function() {
        var a = this.getLayer(vB).ctx, e2 = this._domRoot.width, d2 = this._domRoot.height;
        a.clearRect(0, 0, e2, d2), this.eachBuiltinLayer(function(y2) {
          y2.virtual && a.drawImage(y2.dom, 0, 0, e2, d2);
        });
      }, l2.prototype._doPaintList = function(a, e2, d2) {
        for (var y2 = this, x2 = [], C = this._opts.useDirtyRect, D2 = 0; D2 < this._zlevelList.length; D2++) {
          var L = this._zlevelList[D2], F3 = this._layers[L];
          F3.__builtin__ && F3 !== this._hoverlayer && (F3.__dirty || d2) && x2.push(F3);
        }
        for (var j = true, U3 = false, Y3 = function(dt) {
          var vt = x2[dt], Ct = vt.ctx, Pt = C && vt.createRepaintRects(a, e2, Q._width, Q._height), jt = d2 ? vt.__startIndex : vt.__drawIndex, Rt = !d2 && vt.incremental && Date.now, le2 = Rt && Date.now(), ne2 = vt.zlevel === Q._zlevelList[0] ? Q._backgroundColor : null;
          if (vt.__startIndex === vt.__endIndex)
            vt.clear(false, ne2, Pt);
          else if (jt === vt.__startIndex) {
            var he2 = a[jt];
            (!he2.incremental || !he2.notClear || d2) && vt.clear(false, ne2, Pt);
          }
          jt === -1 && (console.error("For some unknown reason. drawIndex is -1"), jt = vt.__startIndex);
          var _e, Me2 = function(Ze2) {
            var Cn = { inHover: false, allClipped: false, prevEl: null, viewWidth: y2._width, viewHeight: y2._height };
            for (_e = jt; _e < vt.__endIndex; _e++) {
              var Bn = a[_e];
              if (Bn.__inHover && (U3 = true), y2._doPaintEl(Bn, vt, C, Ze2, Cn, _e === vt.__endIndex - 1), Rt) {
                var mn = Date.now() - le2;
                if (mn > 15)
                  break;
              }
            }
            Cn.prevElClipPaths && Ct.restore();
          };
          if (Pt)
            if (Pt.length === 0)
              _e = vt.__endIndex;
            else
              for (var Pe2 = Q.dpr, Be2 = 0; Be2 < Pt.length; ++Be2) {
                var Je2 = Pt[Be2];
                Ct.save(), Ct.beginPath(), Ct.rect(Je2.x * Pe2, Je2.y * Pe2, Je2.width * Pe2, Je2.height * Pe2), Ct.clip(), Me2(Je2), Ct.restore();
              }
          else
            Ct.save(), Me2(), Ct.restore();
          vt.__drawIndex = _e, vt.__drawIndex < vt.__endIndex && (j = false);
        }, Q = this, nt = 0; nt < x2.length; nt++)
          Y3(nt);
        return $s.wxa && Ke2(this._layers, function(dt) {
          dt && dt.ctx && dt.ctx.draw && dt.ctx.draw();
        }), { finished: j, needsRefreshHover: U3 };
      }, l2.prototype._doPaintEl = function(a, e2, d2, y2, x2, C) {
        var D2 = e2.ctx;
        if (d2) {
          var L = a.getPaintRect();
          (!y2 || L && L.intersect(y2)) && (lB(D2, a, x2, C), a.setPrevPaintRect(L));
        } else
          lB(D2, a, x2, C);
      }, l2.prototype.getLayer = function(a, e2) {
        this._singleCanvas && !this._needsManuallyCompositing && (a = vB);
        var d2 = this._layers[a];
        return d2 || (d2 = new eOt("zr_" + a, this, this.dpr), d2.zlevel = a, d2.__builtin__ = true, this._layerConfig[a] ? Mu(d2, this._layerConfig[a], true) : this._layerConfig[a - Kyt] && Mu(d2, this._layerConfig[a - Kyt], true), e2 && (d2.virtual = e2), this.insertLayer(a, d2), d2.initContext()), d2;
      }, l2.prototype.insertLayer = function(a, e2) {
        var d2 = this._layers, y2 = this._zlevelList, x2 = y2.length, C = this._domRoot, D2 = null, L = -1;
        if (!d2[a] && !!bJe(e2)) {
          if (x2 > 0 && a > y2[0]) {
            for (L = 0; L < x2 - 1 && !(y2[L] < a && y2[L + 1] > a); L++)
              ;
            D2 = d2[y2[L]];
          }
          if (y2.splice(L + 1, 0, a), d2[a] = e2, !e2.virtual)
            if (D2) {
              var F3 = D2.dom;
              F3.nextSibling ? C.insertBefore(e2.dom, F3.nextSibling) : C.appendChild(e2.dom);
            } else
              C.firstChild ? C.insertBefore(e2.dom, C.firstChild) : C.appendChild(e2.dom);
          e2.__painter = this;
        }
      }, l2.prototype.eachLayer = function(a, e2) {
        for (var d2 = this._zlevelList, y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2];
          a.call(e2, this._layers[x2], x2);
        }
      }, l2.prototype.eachBuiltinLayer = function(a, e2) {
        for (var d2 = this._zlevelList, y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2], C = this._layers[x2];
          C.__builtin__ && a.call(e2, C, x2);
        }
      }, l2.prototype.eachOtherLayer = function(a, e2) {
        for (var d2 = this._zlevelList, y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2], C = this._layers[x2];
          C.__builtin__ || a.call(e2, C, x2);
        }
      }, l2.prototype.getLayers = function() {
        return this._layers;
      }, l2.prototype._updateLayerStatus = function(a) {
        this.eachBuiltinLayer(function(U3, Y3) {
          U3.__dirty = U3.__used = false;
        });
        function e2(U3) {
          x2 && (x2.__endIndex !== U3 && (x2.__dirty = true), x2.__endIndex = U3);
        }
        if (this._singleCanvas)
          for (var d2 = 1; d2 < a.length; d2++) {
            var y2 = a[d2];
            if (y2.zlevel !== a[d2 - 1].zlevel || y2.incremental) {
              this._needsManuallyCompositing = true;
              break;
            }
          }
        var x2 = null, C = 0, D2, L;
        for (L = 0; L < a.length; L++) {
          var y2 = a[L], F3 = y2.zlevel, j = void 0;
          D2 !== F3 && (D2 = F3, C = 0), y2.incremental ? (j = this.getLayer(F3 + mJe, this._needsManuallyCompositing), j.incremental = true, C = 1) : j = this.getLayer(F3 + (C > 0 ? Kyt : 0), this._needsManuallyCompositing), j.__builtin__ || fV("ZLevel " + F3 + " has been used by unkown layer " + j.id), j !== x2 && (j.__used = true, j.__startIndex !== L && (j.__dirty = true), j.__startIndex = L, j.incremental ? j.__drawIndex = -1 : j.__drawIndex = L, e2(L), x2 = j), y2.__dirty & yb2 && !y2.__inHover && (j.__dirty = true, j.incremental && j.__drawIndex < 0 && (j.__drawIndex = L));
        }
        e2(L), this.eachBuiltinLayer(function(U3, Y3) {
          !U3.__used && U3.getElementCount() > 0 && (U3.__dirty = true, U3.__startIndex = U3.__endIndex = U3.__drawIndex = 0), U3.__dirty && U3.__drawIndex < 0 && (U3.__drawIndex = U3.__startIndex);
        });
      }, l2.prototype.clear = function() {
        return this.eachBuiltinLayer(this._clearLayer), this;
      }, l2.prototype._clearLayer = function(a) {
        a.clear();
      }, l2.prototype.setBackgroundColor = function(a) {
        this._backgroundColor = a, Ke2(this._layers, function(e2) {
          e2.setUnpainted();
        });
      }, l2.prototype.configLayer = function(a, e2) {
        if (e2) {
          var d2 = this._layerConfig;
          d2[a] ? Mu(d2[a], e2, true) : d2[a] = e2;
          for (var y2 = 0; y2 < this._zlevelList.length; y2++) {
            var x2 = this._zlevelList[y2];
            if (x2 === a || x2 === a + Kyt) {
              var C = this._layers[x2];
              Mu(C, d2[a], true);
            }
          }
        }
      }, l2.prototype.delLayer = function(a) {
        var e2 = this._layers, d2 = this._zlevelList, y2 = e2[a];
        !y2 || (y2.dom.parentNode.removeChild(y2.dom), delete e2[a], d2.splice(oc2(d2, a), 1));
      }, l2.prototype.resize = function(a, e2) {
        if (this._domRoot.style) {
          var d2 = this._domRoot;
          d2.style.display = "none";
          var y2 = this._opts, x2 = this.root;
          if (a != null && (y2.width = a), e2 != null && (y2.height = e2), a = eZ(x2, 0, y2), e2 = eZ(x2, 1, y2), d2.style.display = "", this._width !== a || e2 !== this._height) {
            d2.style.width = a + "px", d2.style.height = e2 + "px";
            for (var C in this._layers)
              this._layers.hasOwnProperty(C) && this._layers[C].resize(a, e2);
            this.refresh(true);
          }
          this._width = a, this._height = e2;
        } else {
          if (a == null || e2 == null)
            return;
          this._width = a, this._height = e2, this.getLayer(vB).resize(a, e2);
        }
        return this;
      }, l2.prototype.clearLayer = function(a) {
        var e2 = this._layers[a];
        e2 && e2.clear();
      }, l2.prototype.dispose = function() {
        this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
      }, l2.prototype.getRenderedCanvas = function(a) {
        if (a = a || {}, this._singleCanvas && !this._compositeManually)
          return this._layers[vB].dom;
        var e2 = new eOt("image", this, a.pixelRatio || this.dpr);
        e2.initContext(), e2.clear(false, a.backgroundColor || this._backgroundColor);
        var d2 = e2.ctx;
        if (a.pixelRatio <= this.dpr) {
          this.refresh();
          var y2 = e2.dom.width, x2 = e2.dom.height;
          this.eachLayer(function(U3) {
            U3.__builtin__ ? d2.drawImage(U3.dom, 0, 0, y2, x2) : U3.renderToCanvas && (d2.save(), U3.renderToCanvas(d2), d2.restore());
          });
        } else
          for (var C = { inHover: false, viewWidth: this._width, viewHeight: this._height }, D2 = this.storage.getDisplayList(true), L = 0, F3 = D2.length; L < F3; L++) {
            var j = D2[L];
            lB(d2, j, C, L === F3 - 1);
          }
        return e2.dom;
      }, l2.prototype.getWidth = function() {
        return this._width;
      }, l2.prototype.getHeight = function() {
        return this._height;
      }, l2;
    }(), wJe = xJe;
    function SJe(l2) {
      l2.registerPainter("canvas", wJe);
    }
    var MJe = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.hasSymbolVisual = true, e2;
      }
      return a.prototype.getInitialData = function(e2) {
        return PO(null, this, { useEncodeDefaulter: true });
      }, a.prototype.getLegendIcon = function(e2) {
        var d2 = new ou(), y2 = qy("line", 0, e2.itemHeight / 2, e2.itemWidth, 0, e2.lineStyle.stroke, false);
        d2.add(y2), y2.setStyle(e2.lineStyle);
        var x2 = this.getData().getVisual("symbol"), C = this.getData().getVisual("symbolRotate"), D2 = x2 === "none" ? "circle" : x2, L = e2.itemHeight * 0.8, F3 = qy(D2, (e2.itemWidth - L) / 2, (e2.itemHeight - L) / 2, L, L, e2.itemStyle.fill);
        d2.add(F3), F3.setStyle(e2.itemStyle);
        var j = e2.iconRotate === "inherit" ? C : e2.iconRotate || 0;
        return F3.rotation = j * Math.PI / 180, F3.setOrigin([e2.itemWidth / 2, e2.itemHeight / 2]), D2.indexOf("empty") > -1 && (F3.style.stroke = F3.style.fill, F3.style.fill = "#fff", F3.style.lineWidth = 2), d2;
      }, a.type = "series.line", a.dependencies = ["grid", "polar"], a.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, a;
    }(Pv), CJe = MJe;
    function oZ(l2, a) {
      var e2 = l2.mapDimensionsAll("defaultedLabel"), d2 = e2.length;
      if (d2 === 1) {
        var y2 = $q(l2, a, e2[0]);
        return y2 != null ? y2 + "" : null;
      } else if (d2) {
        for (var x2 = [], C = 0; C < e2.length; C++)
          x2.push($q(l2, a, e2[C]));
        return x2.join(" ");
      }
    }
    function rle(l2, a) {
      var e2 = l2.mapDimensionsAll("defaultedLabel");
      if (!Ba2(a))
        return a + "";
      for (var d2 = [], y2 = 0; y2 < e2.length; y2++) {
        var x2 = l2.getDimensionIndex(e2[y2]);
        x2 >= 0 && d2.push(a[x2]);
      }
      return d2.join(" ");
    }
    var TJe = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2) {
        var C = l2.call(this) || this;
        return C.updateData(e2, d2, y2, x2), C;
      }
      return a.prototype._createSymbol = function(e2, d2, y2, x2, C) {
        this.removeAll();
        var D2 = qy(e2, -1, -1, 2, 2, null, C);
        D2.attr({ z2: 100, culling: true, scaleX: x2[0] / 2, scaleY: x2[1] / 2 }), D2.drift = AJe, this._symbolType = e2, this.add(D2);
      }, a.prototype.stopSymbolAnimation = function(e2) {
        this.childAt(0).stopAnimation(null, e2);
      }, a.prototype.getSymbolType = function() {
        return this._symbolType;
      }, a.prototype.getSymbolPath = function() {
        return this.childAt(0);
      }, a.prototype.highlight = function() {
        Dm(this.childAt(0));
      }, a.prototype.downplay = function() {
        fc2(this.childAt(0));
      }, a.prototype.setZ = function(e2, d2) {
        var y2 = this.childAt(0);
        y2.zlevel = e2, y2.z = d2;
      }, a.prototype.setDraggable = function(e2) {
        var d2 = this.childAt(0);
        d2.draggable = e2, d2.cursor = e2 ? "move" : d2.cursor;
      }, a.prototype.updateData = function(e2, d2, y2, x2) {
        this.silent = false;
        var C = e2.getItemVisual(d2, "symbol") || "circle", D2 = e2.hostModel, L = a.getSymbolSize(e2, d2), F3 = C !== this._symbolType, j = x2 && x2.disableAnimation;
        if (F3) {
          var U3 = e2.getItemVisual(d2, "symbolKeepAspect");
          this._createSymbol(C, e2, d2, L, U3);
        } else {
          var Y3 = this.childAt(0);
          Y3.silent = false;
          var Q = { scaleX: L[0] / 2, scaleY: L[1] / 2 };
          j ? Y3.attr(Q) : Yf2(Y3, Q, D2, d2), pC(Y3);
        }
        if (this._updateCommon(e2, d2, L, y2, x2), F3) {
          var Y3 = this.childAt(0);
          if (!j) {
            var Q = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: Y3.style.opacity } };
            Y3.scaleX = Y3.scaleY = 0, Y3.style.opacity = 0, Yg2(Y3, Q, D2, d2);
          }
        }
        j && this.childAt(0).stopAnimation("leave");
      }, a.prototype._updateCommon = function(e2, d2, y2, x2, C) {
        var D2 = this.childAt(0), L = e2.hostModel, F3, j, U3, Y3, Q, nt, dt, vt, Ct;
        if (x2 && (F3 = x2.emphasisItemStyle, j = x2.blurItemStyle, U3 = x2.selectItemStyle, Y3 = x2.focus, Q = x2.blurScope, dt = x2.labelStatesModels, vt = x2.hoverScale, Ct = x2.cursorStyle, nt = x2.emphasisDisabled), !x2 || e2.hasItemOption) {
          var Pt = x2 && x2.itemModel ? x2.itemModel : e2.getItemModel(d2), jt = Pt.getModel("emphasis");
          F3 = jt.getModel("itemStyle").getItemStyle(), U3 = Pt.getModel(["select", "itemStyle"]).getItemStyle(), j = Pt.getModel(["blur", "itemStyle"]).getItemStyle(), Y3 = jt.get("focus"), Q = jt.get("blurScope"), nt = jt.get("disabled"), dt = Sb2(Pt), vt = jt.getShallow("scale"), Ct = Pt.getShallow("cursor");
        }
        var Rt = e2.getItemVisual(d2, "symbolRotate");
        D2.attr("rotation", (Rt || 0) * Math.PI / 180 || 0);
        var le2 = tZ(e2.getItemVisual(d2, "symbolOffset"), y2);
        le2 && (D2.x = le2[0], D2.y = le2[1]), Ct && D2.attr("cursor", Ct);
        var ne2 = e2.getItemVisual(d2, "style"), he2 = ne2.fill;
        if (D2 instanceof Im) {
          var _e = D2.style;
          D2.useStyle(la2({ image: _e.image, x: _e.x, y: _e.y, width: _e.width, height: _e.height }, ne2));
        } else
          D2.__isEmptyBrush ? D2.useStyle(la2({}, ne2)) : D2.useStyle(ne2), D2.style.decal = null, D2.setColor(he2, C && C.symbolInnerColor), D2.style.strokeNoScale = true;
        var Me2 = e2.getItemVisual(d2, "liftZ"), Pe2 = this._z2;
        Me2 != null ? Pe2 == null && (this._z2 = D2.z2, D2.z2 += Me2) : Pe2 != null && (D2.z2 = Pe2, this._z2 = null);
        var Be2 = C && C.useNameLabel;
        ow(D2, dt, { labelFetcher: L, labelDataIndex: d2, defaultText: Je2, inheritColor: he2, defaultOpacity: ne2.opacity });
        function Je2(Bn) {
          return Be2 ? e2.getName(Bn) : oZ(e2, Bn);
        }
        this._sizeX = y2[0] / 2, this._sizeY = y2[1] / 2;
        var Ze2 = D2.ensureState("emphasis");
        if (Ze2.style = F3, D2.ensureState("select").style = U3, D2.ensureState("blur").style = j, vt) {
          var Cn = Math.max(1.1, 3 / this._sizeY);
          Ze2.scaleX = this._sizeX * Cn, Ze2.scaleY = this._sizeY * Cn;
        }
        this.setSymbolScale(1), n0(this, Y3, Q, nt);
      }, a.prototype.setSymbolScale = function(e2) {
        this.scaleX = this.scaleY = e2;
      }, a.prototype.fadeOut = function(e2, d2, y2) {
        var x2 = this.childAt(0), C = ns(this).dataIndex, D2 = y2 && y2.animation;
        if (this.silent = x2.silent = true, y2 && y2.fadeLabel) {
          var L = x2.getTextContent();
          L && iP(L, { style: { opacity: 0 } }, d2, { dataIndex: C, removeOpt: D2, cb: function() {
            x2.removeTextContent();
          } });
        } else
          x2.removeTextContent();
        iP(x2, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, d2, { dataIndex: C, cb: e2, removeOpt: D2 });
      }, a.getSymbolSize = function(e2, d2) {
        return brt(e2.getItemVisual(d2, "symbolSize"));
      }, a;
    }(ou);
    function AJe(l2, a) {
      this.parent.drift(l2, a);
    }
    var zrt = TJe;
    function nOt(l2, a, e2, d2) {
      return a && !isNaN(a[0]) && !isNaN(a[1]) && !(d2.isIgnore && d2.isIgnore(e2)) && !(d2.clipShape && !d2.clipShape.contain(a[0], a[1])) && l2.getItemVisual(e2, "symbol") !== "none";
    }
    function ile(l2) {
      return l2 != null && !vs(l2) && (l2 = { isIgnore: l2 }), l2 || {};
    }
    function ale(l2) {
      var a = l2.hostModel, e2 = a.getModel("emphasis");
      return { emphasisItemStyle: e2.getModel("itemStyle").getItemStyle(), blurItemStyle: a.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: a.getModel(["select", "itemStyle"]).getItemStyle(), focus: e2.get("focus"), blurScope: e2.get("blurScope"), emphasisDisabled: e2.get("disabled"), hoverScale: e2.get("scale"), labelStatesModels: Sb2(a), cursorStyle: a.get("cursor") };
    }
    var IJe = function() {
      function l2(a) {
        this.group = new ou(), this._SymbolCtor = a || zrt;
      }
      return l2.prototype.updateData = function(a, e2) {
        this._progressiveEls = null, e2 = ile(e2);
        var d2 = this.group, y2 = a.hostModel, x2 = this._data, C = this._SymbolCtor, D2 = e2.disableAnimation, L = ale(a), F3 = { disableAnimation: D2 }, j = e2.getSymbolPoint || function(U3) {
          return a.getItemLayout(U3);
        };
        x2 || d2.removeAll(), a.diff(x2).add(function(U3) {
          var Y3 = j(U3);
          if (nOt(a, Y3, U3, e2)) {
            var Q = new C(a, U3, L, F3);
            Q.setPosition(Y3), a.setItemGraphicEl(U3, Q), d2.add(Q);
          }
        }).update(function(U3, Y3) {
          var Q = x2.getItemGraphicEl(Y3), nt = j(U3);
          if (!nOt(a, nt, U3, e2)) {
            d2.remove(Q);
            return;
          }
          var dt = a.getItemVisual(U3, "symbol") || "circle", vt = Q && Q.getSymbolType && Q.getSymbolType();
          if (!Q || vt && vt !== dt)
            d2.remove(Q), Q = new C(a, U3, L, F3), Q.setPosition(nt);
          else {
            Q.updateData(a, U3, L, F3);
            var Ct = { x: nt[0], y: nt[1] };
            D2 ? Q.attr(Ct) : Yf2(Q, Ct, y2);
          }
          d2.add(Q), a.setItemGraphicEl(U3, Q);
        }).remove(function(U3) {
          var Y3 = x2.getItemGraphicEl(U3);
          Y3 && Y3.fadeOut(function() {
            d2.remove(Y3);
          }, y2);
        }).execute(), this._getSymbolPoint = j, this._data = a;
      }, l2.prototype.updateLayout = function() {
        var a = this, e2 = this._data;
        e2 && e2.eachItemGraphicEl(function(d2, y2) {
          var x2 = a._getSymbolPoint(y2);
          d2.setPosition(x2), d2.markRedraw();
        });
      }, l2.prototype.incrementalPrepareUpdate = function(a) {
        this._seriesScope = ale(a), this._data = null, this.group.removeAll();
      }, l2.prototype.incrementalUpdate = function(a, e2, d2) {
        this._progressiveEls = [], d2 = ile(d2);
        function y2(L) {
          L.isGroup || (L.incremental = true, L.ensureState("emphasis").hoverLayer = true);
        }
        for (var x2 = a.start; x2 < a.end; x2++) {
          var C = e2.getItemLayout(x2);
          if (nOt(e2, C, x2, d2)) {
            var D2 = new this._SymbolCtor(e2, x2, this._seriesScope);
            D2.traverse(y2), D2.setPosition(C), this.group.add(D2), e2.setItemGraphicEl(x2, D2), this._progressiveEls.push(D2);
          }
        }
      }, l2.prototype.eachRendered = function(a) {
        qN(this._progressiveEls || this.group, a);
      }, l2.prototype.remove = function(a) {
        var e2 = this.group, d2 = this._data;
        d2 && a ? d2.eachItemGraphicEl(function(y2) {
          y2.fadeOut(function() {
            e2.remove(y2);
          }, d2.hostModel);
        }) : e2.removeAll();
      }, l2;
    }(), jrt = IJe;
    function ole(l2, a, e2) {
      var d2 = l2.getBaseAxis(), y2 = l2.getOtherAxis(d2), x2 = DJe(y2, e2), C = d2.dim, D2 = y2.dim, L = a.mapDimension(D2), F3 = a.mapDimension(C), j = D2 === "x" || D2 === "radius" ? 1 : 0, U3 = $a2(l2.dimensions, function(nt) {
        return a.mapDimension(nt);
      }), Y3 = false, Q = a.getCalculationInfo("stackResultDimension");
      return tF(a, U3[0]) && (Y3 = true, U3[0] = Q), tF(a, U3[1]) && (Y3 = true, U3[1] = Q), { dataDimsForPoint: U3, valueStart: x2, valueAxisDim: D2, baseAxisDim: C, stacked: !!Y3, valueDim: L, baseDim: F3, baseDataOffset: j, stackedOverDimension: a.getCalculationInfo("stackedOverDimension") };
    }
    function DJe(l2, a) {
      var e2 = 0, d2 = l2.scale.getExtent();
      return a === "start" ? e2 = d2[0] : a === "end" ? e2 = d2[1] : d2[0] > 0 ? e2 = d2[0] : d2[1] < 0 && (e2 = d2[1]), e2;
    }
    function sle(l2, a, e2, d2) {
      var y2 = NaN;
      l2.stacked && (y2 = e2.get(e2.getCalculationInfo("stackedOverDimension"), d2)), isNaN(y2) && (y2 = l2.valueStart);
      var x2 = l2.baseDataOffset, C = [];
      return C[x2] = e2.get(l2.baseDim, d2), C[1 - x2] = y2, a.dataToPoint(C);
    }
    function EJe(l2, a) {
      var e2 = [];
      return a.diff(l2).add(function(d2) {
        e2.push({ cmd: "+", idx: d2 });
      }).update(function(d2, y2) {
        e2.push({ cmd: "=", idx: y2, idx1: d2 });
      }).remove(function(d2) {
        e2.push({ cmd: "-", idx: d2 });
      }).execute(), e2;
    }
    function kJe(l2, a, e2, d2, y2, x2, C, D2) {
      for (var L = EJe(l2, a), F3 = [], j = [], U3 = [], Y3 = [], Q = [], nt = [], dt = [], vt = ole(y2, a, C), Ct = l2.getLayout("points") || [], Pt = a.getLayout("points") || [], jt = 0; jt < L.length; jt++) {
        var Rt = L[jt], le2 = true, ne2 = void 0, he2 = void 0;
        switch (Rt.cmd) {
          case "=":
            ne2 = Rt.idx * 2, he2 = Rt.idx1 * 2;
            var _e = Ct[ne2], Me2 = Ct[ne2 + 1], Pe2 = Pt[he2], Be2 = Pt[he2 + 1];
            (isNaN(_e) || isNaN(Me2)) && (_e = Pe2, Me2 = Be2), F3.push(_e, Me2), j.push(Pe2, Be2), U3.push(e2[ne2], e2[ne2 + 1]), Y3.push(d2[he2], d2[he2 + 1]), dt.push(a.getRawIndex(Rt.idx1));
            break;
          case "+":
            var Je2 = Rt.idx, Ze2 = vt.dataDimsForPoint, Cn = y2.dataToPoint([a.get(Ze2[0], Je2), a.get(Ze2[1], Je2)]);
            he2 = Je2 * 2, F3.push(Cn[0], Cn[1]), j.push(Pt[he2], Pt[he2 + 1]);
            var Bn = sle(vt, y2, a, Je2);
            U3.push(Bn[0], Bn[1]), Y3.push(d2[he2], d2[he2 + 1]), dt.push(a.getRawIndex(Je2));
            break;
          case "-":
            le2 = false;
        }
        le2 && (Q.push(Rt), nt.push(nt.length));
      }
      nt.sort(function(hl, Qs) {
        return dt[hl] - dt[Qs];
      });
      for (var mn = F3.length, Kr = lP(mn), Kn = lP(mn), ar = lP(mn), Cr = lP(mn), ui2 = [], jt = 0; jt < nt.length; jt++) {
        var vi2 = nt[jt], ko = jt * 2, Ss = vi2 * 2;
        Kr[ko] = F3[Ss], Kr[ko + 1] = F3[Ss + 1], Kn[ko] = j[Ss], Kn[ko + 1] = j[Ss + 1], ar[ko] = U3[Ss], ar[ko + 1] = U3[Ss + 1], Cr[ko] = Y3[Ss], Cr[ko + 1] = Y3[Ss + 1], ui2[jt] = Q[vi2];
      }
      return { current: Kr, next: Kn, stackedOnCurrent: ar, stackedOnNext: Cr, status: ui2 };
    }
    var nF = Math.min, rF = Math.max;
    function yB(l2, a) {
      return isNaN(l2) || isNaN(a);
    }
    function rOt(l2, a, e2, d2, y2, x2, C, D2, L) {
      for (var F3, j, U3, Y3, Q, nt, dt = e2, vt = 0; vt < d2; vt++) {
        var Ct = a[dt * 2], Pt = a[dt * 2 + 1];
        if (dt >= y2 || dt < 0)
          break;
        if (yB(Ct, Pt)) {
          if (L) {
            dt += x2;
            continue;
          }
          break;
        }
        if (dt === e2)
          l2[x2 > 0 ? "moveTo" : "lineTo"](Ct, Pt), U3 = Ct, Y3 = Pt;
        else {
          var jt = Ct - F3, Rt = Pt - j;
          if (jt * jt + Rt * Rt < 0.5) {
            dt += x2;
            continue;
          }
          if (C > 0) {
            for (var le2 = dt + x2, ne2 = a[le2 * 2], he2 = a[le2 * 2 + 1]; ne2 === Ct && he2 === Pt && vt < d2; )
              vt++, le2 += x2, dt += x2, ne2 = a[le2 * 2], he2 = a[le2 * 2 + 1], Ct = a[dt * 2], Pt = a[dt * 2 + 1], jt = Ct - F3, Rt = Pt - j;
            var _e = vt + 1;
            if (L)
              for (; yB(ne2, he2) && _e < d2; )
                _e++, le2 += x2, ne2 = a[le2 * 2], he2 = a[le2 * 2 + 1];
            var Me2 = 0.5, Pe2 = 0, Be2 = 0, Je2 = void 0, Ze2 = void 0;
            if (_e >= d2 || yB(ne2, he2))
              Q = Ct, nt = Pt;
            else {
              Pe2 = ne2 - F3, Be2 = he2 - j;
              var Cn = Ct - F3, Bn = ne2 - Ct, mn = Pt - j, Kr = he2 - Pt, Kn = void 0, ar = void 0;
              if (D2 === "x") {
                Kn = Math.abs(Cn), ar = Math.abs(Bn);
                var Cr = Pe2 > 0 ? 1 : -1;
                Q = Ct - Cr * Kn * C, nt = Pt, Je2 = Ct + Cr * ar * C, Ze2 = Pt;
              } else if (D2 === "y") {
                Kn = Math.abs(mn), ar = Math.abs(Kr);
                var ui2 = Be2 > 0 ? 1 : -1;
                Q = Ct, nt = Pt - ui2 * Kn * C, Je2 = Ct, Ze2 = Pt + ui2 * ar * C;
              } else
                Kn = Math.sqrt(Cn * Cn + mn * mn), ar = Math.sqrt(Bn * Bn + Kr * Kr), Me2 = ar / (ar + Kn), Q = Ct - Pe2 * C * (1 - Me2), nt = Pt - Be2 * C * (1 - Me2), Je2 = Ct + Pe2 * C * Me2, Ze2 = Pt + Be2 * C * Me2, Je2 = nF(Je2, rF(ne2, Ct)), Ze2 = nF(Ze2, rF(he2, Pt)), Je2 = rF(Je2, nF(ne2, Ct)), Ze2 = rF(Ze2, nF(he2, Pt)), Pe2 = Je2 - Ct, Be2 = Ze2 - Pt, Q = Ct - Pe2 * Kn / ar, nt = Pt - Be2 * Kn / ar, Q = nF(Q, rF(F3, Ct)), nt = nF(nt, rF(j, Pt)), Q = rF(Q, nF(F3, Ct)), nt = rF(nt, nF(j, Pt)), Pe2 = Ct - Q, Be2 = Pt - nt, Je2 = Ct + Pe2 * ar / Kn, Ze2 = Pt + Be2 * ar / Kn;
            }
            l2.bezierCurveTo(U3, Y3, Q, nt, Ct, Pt), U3 = Je2, Y3 = Ze2;
          } else
            l2.lineTo(Ct, Pt);
        }
        F3 = Ct, j = Pt, dt += x2;
      }
      return vt;
    }
    var lle = function() {
      function l2() {
        this.smooth = 0, this.smoothConstraint = true;
      }
      return l2;
    }(), PJe = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "ec-polyline", d2;
      }
      return a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new lle();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.points, x2 = 0, C = y2.length / 2;
        if (d2.connectNulls) {
          for (; C > 0 && yB(y2[C * 2 - 2], y2[C * 2 - 1]); C--)
            ;
          for (; x2 < C && yB(y2[x2 * 2], y2[x2 * 2 + 1]); x2++)
            ;
        }
        for (; x2 < C; )
          x2 += rOt(e2, y2, x2, C, C, 1, d2.smooth, d2.smoothMonotone, d2.connectNulls) + 1;
      }, a.prototype.getPointOn = function(e2, d2) {
        this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
        for (var y2 = this.path, x2 = y2.data, C = yA.CMD, D2, L, F3 = d2 === "x", j = [], U3 = 0; U3 < x2.length; ) {
          var Y3 = x2[U3++], Q = void 0, nt = void 0, dt = void 0, vt = void 0, Ct = void 0, Pt = void 0, jt = void 0;
          switch (Y3) {
            case C.M:
              D2 = x2[U3++], L = x2[U3++];
              break;
            case C.L:
              if (Q = x2[U3++], nt = x2[U3++], jt = F3 ? (e2 - D2) / (Q - D2) : (e2 - L) / (nt - L), jt <= 1 && jt >= 0) {
                var Rt = F3 ? (nt - L) * jt + L : (Q - D2) * jt + D2;
                return F3 ? [e2, Rt] : [Rt, e2];
              }
              D2 = Q, L = nt;
              break;
            case C.C:
              Q = x2[U3++], nt = x2[U3++], dt = x2[U3++], vt = x2[U3++], Ct = x2[U3++], Pt = x2[U3++];
              var le2 = F3 ? bN(D2, Q, dt, Ct, e2, j) : bN(L, nt, vt, Pt, e2, j);
              if (le2 > 0)
                for (var ne2 = 0; ne2 < le2; ne2++) {
                  var he2 = j[ne2];
                  if (he2 <= 1 && he2 >= 0) {
                    var Rt = F3 ? m0(L, nt, vt, Pt, he2) : m0(D2, Q, dt, Ct, he2);
                    return F3 ? [e2, Rt] : [Rt, e2];
                  }
                }
              D2 = Ct, L = Pt;
              break;
          }
        }
      }, a;
    }(wc2), LJe = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a;
    }(lle), ule = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "ec-polygon", d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new LJe();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.points, x2 = d2.stackedOnPoints, C = 0, D2 = y2.length / 2, L = d2.smoothMonotone;
        if (d2.connectNulls) {
          for (; D2 > 0 && yB(y2[D2 * 2 - 2], y2[D2 * 2 - 1]); D2--)
            ;
          for (; C < D2 && yB(y2[C * 2], y2[C * 2 + 1]); C++)
            ;
        }
        for (; C < D2; ) {
          var F3 = rOt(e2, y2, C, D2, D2, 1, d2.smooth, L, d2.connectNulls);
          rOt(e2, x2, C + F3 - 1, F3, D2, -1, d2.stackedOnSmooth, L, d2.connectNulls), C += F3 + 1, e2.closePath();
        }
      }, a;
    }(wc2);
    function cle(l2, a, e2, d2, y2) {
      var x2 = l2.getArea(), C = x2.x, D2 = x2.y, L = x2.width, F3 = x2.height, j = e2.get(["lineStyle", "width"]) || 2;
      C -= j / 2, D2 -= j / 2, L += j, F3 += j, C = Math.floor(C), L = Math.round(L);
      var U3 = new Nf2({ shape: { x: C, y: D2, width: L, height: F3 } });
      if (a) {
        var Y3 = l2.getBaseAxis(), Q = Y3.isHorizontal(), nt = Y3.inverse;
        Q ? (nt && (U3.shape.x += L), U3.shape.width = 0) : (nt || (U3.shape.y += F3), U3.shape.height = 0);
        var dt = wl(y2) ? function(vt) {
          y2(vt, U3);
        } : null;
        Yg2(U3, { shape: { width: L, height: F3, x: C, y: D2 } }, e2, null, d2, dt);
      }
      return U3;
    }
    function fle(l2, a, e2) {
      var d2 = l2.getArea(), y2 = kv(d2.r0, 1), x2 = kv(d2.r, 1), C = new nw({ shape: { cx: kv(l2.cx, 1), cy: kv(l2.cy, 1), r0: y2, r: x2, startAngle: d2.startAngle, endAngle: d2.endAngle, clockwise: d2.clockwise } });
      if (a) {
        var D2 = l2.getBaseAxis().dim === "angle";
        D2 ? C.shape.endAngle = d2.startAngle : C.shape.r = y2, Yg2(C, { shape: { endAngle: d2.endAngle, r: x2 } }, e2);
      }
      return C;
    }
    function Xyt(l2, a, e2, d2, y2) {
      if (l2) {
        if (l2.type === "polar")
          return fle(l2, a, e2);
        if (l2.type === "cartesian2d")
          return cle(l2, a, e2, d2, y2);
      } else
        return null;
      return null;
    }
    function OO(l2, a) {
      return l2.type === a;
    }
    function hle(l2, a) {
      if (l2.length === a.length) {
        for (var e2 = 0; e2 < l2.length; e2++)
          if (l2[e2] !== a[e2])
            return;
        return true;
      }
    }
    function ple(l2) {
      for (var a = 1 / 0, e2 = 1 / 0, d2 = -1 / 0, y2 = -1 / 0, x2 = 0; x2 < l2.length; ) {
        var C = l2[x2++], D2 = l2[x2++];
        isNaN(C) || (a = Math.min(C, a), d2 = Math.max(C, d2)), isNaN(D2) || (e2 = Math.min(D2, e2), y2 = Math.max(D2, y2));
      }
      return [[a, e2], [d2, y2]];
    }
    function dle(l2, a) {
      var e2 = ple(l2), d2 = e2[0], y2 = e2[1], x2 = ple(a), C = x2[0], D2 = x2[1];
      return Math.max(Math.abs(d2[0] - C[0]), Math.abs(d2[1] - C[1]), Math.abs(y2[0] - D2[0]), Math.abs(y2[1] - D2[1]));
    }
    function gle(l2) {
      return Ch2(l2) ? l2 : l2 ? 0.5 : 0;
    }
    function OJe(l2, a, e2) {
      if (!e2.valueDim)
        return [];
      for (var d2 = a.count(), y2 = lP(d2 * 2), x2 = 0; x2 < d2; x2++) {
        var C = sle(e2, l2, a, x2);
        y2[x2 * 2] = C[0], y2[x2 * 2 + 1] = C[1];
      }
      return y2;
    }
    function iF(l2, a, e2, d2) {
      var y2 = a.getBaseAxis(), x2 = y2.dim === "x" || y2.dim === "radius" ? 0 : 1, C = [], D2 = 0, L = [], F3 = [], j = [], U3 = [];
      if (d2) {
        for (D2 = 0; D2 < l2.length; D2 += 2)
          !isNaN(l2[D2]) && !isNaN(l2[D2 + 1]) && U3.push(l2[D2], l2[D2 + 1]);
        l2 = U3;
      }
      for (D2 = 0; D2 < l2.length - 2; D2 += 2)
        switch (j[0] = l2[D2 + 2], j[1] = l2[D2 + 3], F3[0] = l2[D2], F3[1] = l2[D2 + 1], C.push(F3[0], F3[1]), e2) {
          case "end":
            L[x2] = j[x2], L[1 - x2] = F3[1 - x2], C.push(L[0], L[1]);
            break;
          case "middle":
            var Y3 = (F3[x2] + j[x2]) / 2, Q = [];
            L[x2] = Q[x2] = Y3, L[1 - x2] = F3[1 - x2], Q[1 - x2] = j[1 - x2], C.push(L[0], L[1]), C.push(Q[0], Q[1]);
            break;
          default:
            L[x2] = F3[x2], L[1 - x2] = j[1 - x2], C.push(L[0], L[1]);
        }
      return C.push(l2[D2++], l2[D2++]), C;
    }
    function RJe(l2, a) {
      var e2 = [], d2 = l2.length, y2, x2;
      function C(j, U3, Y3) {
        var Q = j.coord, nt = (Y3 - Q) / (U3.coord - Q), dt = M5t(nt, [j.color, U3.color]);
        return { coord: Y3, color: dt };
      }
      for (var D2 = 0; D2 < d2; D2++) {
        var L = l2[D2], F3 = L.coord;
        if (F3 < 0)
          y2 = L;
        else if (F3 > a) {
          x2 ? e2.push(C(x2, L, a)) : y2 && e2.push(C(y2, L, 0), C(y2, L, a));
          break;
        } else
          y2 && (e2.push(C(y2, L, 0)), y2 = null), e2.push(L), x2 = L;
      }
      return e2;
    }
    function NJe(l2, a, e2) {
      var d2 = l2.getVisual("visualMeta");
      if (!(!d2 || !d2.length || !l2.count()) && a.type === "cartesian2d") {
        for (var y2, x2, C = d2.length - 1; C >= 0; C--) {
          var D2 = l2.getDimensionInfo(d2[C].dimension);
          if (y2 = D2 && D2.coordDim, y2 === "x" || y2 === "y") {
            x2 = d2[C];
            break;
          }
        }
        if (x2) {
          var L = a.getAxis(y2), F3 = $a2(x2.stops, function(jt) {
            return { coord: L.toGlobalCoord(L.dataToCoord(jt.value)), color: jt.color };
          }), j = F3.length, U3 = x2.outerColors.slice();
          j && F3[0].coord > F3[j - 1].coord && (F3.reverse(), U3.reverse());
          var Y3 = RJe(F3, y2 === "x" ? e2.getWidth() : e2.getHeight()), Q = Y3.length;
          if (!Q && j)
            return F3[0].coord < 0 ? U3[1] ? U3[1] : F3[j - 1].color : U3[0] ? U3[0] : F3[0].color;
          var nt = 10, dt = Y3[0].coord - nt, vt = Y3[Q - 1].coord + nt, Ct = vt - dt;
          if (Ct < 1e-3)
            return "transparent";
          Ke2(Y3, function(jt) {
            jt.offset = (jt.coord - dt) / Ct;
          }), Y3.push({ offset: Q ? Y3[Q - 1].offset : 0.5, color: U3[1] || "transparent" }), Y3.unshift({ offset: Q ? Y3[0].offset : 0.5, color: U3[0] || "transparent" });
          var Pt = new QV(0, 0, 0, 0, Y3, true);
          return Pt[y2] = dt, Pt[y2 + "2"] = vt, Pt;
        }
      }
    }
    function FJe(l2, a, e2) {
      var d2 = l2.get("showAllSymbol"), y2 = d2 === "auto";
      if (!(d2 && !y2)) {
        var x2 = e2.getAxesByScale("ordinal")[0];
        if (!!x2 && !(y2 && VJe(x2, a))) {
          var C = a.mapDimension(x2.dim), D2 = {};
          return Ke2(x2.getViewLabels(), function(L) {
            var F3 = x2.scale.getRawOrdinalNumber(L.tickValue);
            D2[F3] = 1;
          }), function(L) {
            return !D2.hasOwnProperty(a.get(C, L));
          };
        }
      }
    }
    function VJe(l2, a) {
      var e2 = l2.getExtent(), d2 = Math.abs(e2[1] - e2[0]) / l2.scale.count();
      isNaN(d2) && (d2 = 0);
      for (var y2 = a.count(), x2 = Math.max(1, Math.round(y2 / 5)), C = 0; C < y2; C += x2)
        if (zrt.getSymbolSize(a, C)[l2.isHorizontal() ? 1 : 0] * 1.5 > d2)
          return false;
      return true;
    }
    function BJe(l2, a) {
      return isNaN(l2) || isNaN(a);
    }
    function zJe(l2) {
      for (var a = l2.length / 2; a > 0 && BJe(l2[a * 2 - 2], l2[a * 2 - 1]); a--)
        ;
      return a - 1;
    }
    function vle(l2, a) {
      return [l2[a * 2], l2[a * 2 + 1]];
    }
    function jJe(l2, a, e2) {
      for (var d2 = l2.length / 2, y2 = e2 === "x" ? 0 : 1, x2, C, D2 = 0, L = -1, F3 = 0; F3 < d2; F3++)
        if (C = l2[F3 * 2 + y2], !(isNaN(C) || isNaN(l2[F3 * 2 + 1 - y2]))) {
          if (F3 === 0) {
            x2 = C;
            continue;
          }
          if (x2 <= a && C >= a || x2 >= a && C <= a) {
            L = F3;
            break;
          }
          D2 = F3, x2 = C;
        }
      return { range: [D2, L], t: (a - x2) / (C - x2) };
    }
    function yle(l2) {
      if (l2.get(["endLabel", "show"]))
        return true;
      for (var a = 0; a < O_.length; a++)
        if (l2.get([O_[a], "endLabel", "show"]))
          return true;
      return false;
    }
    function iOt(l2, a, e2, d2) {
      if (OO(a, "cartesian2d")) {
        var y2 = d2.getModel("endLabel"), x2 = y2.get("valueAnimation"), C = d2.getData(), D2 = { lastFrameIndex: 0 }, L = yle(d2) ? function(Q, nt) {
          l2._endLabelOnDuring(Q, nt, C, D2, x2, y2, a);
        } : null, F3 = a.getBaseAxis().isHorizontal(), j = cle(a, e2, d2, function() {
          var Q = l2._endLabel;
          Q && e2 && D2.originalX != null && Q.attr({ x: D2.originalX, y: D2.originalY });
        }, L);
        if (!d2.get("clip", true)) {
          var U3 = j.shape, Y3 = Math.max(U3.width, U3.height);
          F3 ? (U3.y -= Y3, U3.height += Y3 * 2) : (U3.x -= Y3, U3.width += Y3 * 2);
        }
        return L && L(1, j), j;
      } else
        return fle(a, e2, d2);
    }
    function WJe(l2, a) {
      var e2 = a.getBaseAxis(), d2 = e2.isHorizontal(), y2 = e2.inverse, x2 = d2 ? y2 ? "right" : "left" : "center", C = d2 ? "middle" : y2 ? "top" : "bottom";
      return { normal: { align: l2.get("align") || x2, verticalAlign: l2.get("verticalAlign") || C } };
    }
    var GJe = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.init = function() {
        var e2 = new ou(), d2 = new jrt();
        this.group.add(d2.group), this._symbolDraw = d2, this._lineGroup = e2;
      }, a.prototype.render = function(e2, d2, y2) {
        var x2 = this, C = e2.coordinateSystem, D2 = this.group, L = e2.getData(), F3 = e2.getModel("lineStyle"), j = e2.getModel("areaStyle"), U3 = L.getLayout("points") || [], Y3 = C.type === "polar", Q = this._coordSys, nt = this._symbolDraw, dt = this._polyline, vt = this._polygon, Ct = this._lineGroup, Pt = e2.get("animation"), jt = !j.isEmpty(), Rt = j.get("origin"), le2 = ole(C, L, Rt), ne2 = jt && OJe(C, L, le2), he2 = e2.get("showSymbol"), _e = e2.get("connectNulls"), Me2 = he2 && !Y3 && FJe(e2, L, C), Pe2 = this._data;
        Pe2 && Pe2.eachItemGraphicEl(function(Qs, Js) {
          Qs.__temp && (D2.remove(Qs), Pe2.setItemGraphicEl(Js, null));
        }), he2 || nt.remove(), D2.add(Ct);
        var Be2 = Y3 ? false : e2.get("step"), Je2;
        C && C.getArea && e2.get("clip", true) && (Je2 = C.getArea(), Je2.width != null ? (Je2.x -= 0.1, Je2.y -= 0.1, Je2.width += 0.2, Je2.height += 0.2) : Je2.r0 && (Je2.r0 -= 0.5, Je2.r += 0.5)), this._clipShapeForSymbol = Je2;
        var Ze2 = NJe(L, C, y2) || L.getVisual("style")[L.getVisual("drawType")];
        if (!(dt && Q.type === C.type && Be2 === this._step))
          he2 && nt.updateData(L, { isIgnore: Me2, clipShape: Je2, disableAnimation: true, getSymbolPoint: function(Qs) {
            return [U3[Qs * 2], U3[Qs * 2 + 1]];
          } }), Pt && this._initSymbolLabelAnimation(L, C, Je2), Be2 && (U3 = iF(U3, C, Be2, _e), ne2 && (ne2 = iF(ne2, C, Be2, _e))), dt = this._newPolyline(U3), jt && (vt = this._newPolygon(U3, ne2)), Y3 || this._initOrUpdateEndLabel(e2, C, nB(Ze2)), Ct.setClipPath(iOt(this, C, true, e2));
        else {
          jt && !vt ? vt = this._newPolygon(U3, ne2) : vt && !jt && (Ct.remove(vt), vt = this._polygon = null), Y3 || this._initOrUpdateEndLabel(e2, C, nB(Ze2));
          var Cn = Ct.getClipPath();
          if (Cn) {
            var Bn = iOt(this, C, false, e2);
            Yg2(Cn, { shape: Bn.shape }, e2);
          } else
            Ct.setClipPath(iOt(this, C, true, e2));
          he2 && nt.updateData(L, { isIgnore: Me2, clipShape: Je2, disableAnimation: true, getSymbolPoint: function(Qs) {
            return [U3[Qs * 2], U3[Qs * 2 + 1]];
          } }), (!hle(this._stackedOnPoints, ne2) || !hle(this._points, U3)) && (Pt ? this._doUpdateAnimation(L, ne2, C, y2, Be2, Rt, _e) : (Be2 && (U3 = iF(U3, C, Be2, _e), ne2 && (ne2 = iF(ne2, C, Be2, _e))), dt.setShape({ points: U3 }), vt && vt.setShape({ points: U3, stackedOnPoints: ne2 })));
        }
        var mn = e2.getModel("emphasis"), Kr = mn.get("focus"), Kn = mn.get("blurScope"), ar = mn.get("disabled");
        if (dt.useStyle(El(F3.getLineStyle(), { fill: "none", stroke: Ze2, lineJoin: "bevel" })), Gy(dt, e2, "lineStyle"), dt.style.lineWidth > 0 && e2.get(["emphasis", "lineStyle", "width"]) === "bolder") {
          var Cr = dt.getState("emphasis").style;
          Cr.lineWidth = +dt.style.lineWidth + 1;
        }
        ns(dt).seriesIndex = e2.seriesIndex, n0(dt, Kr, Kn, ar);
        var ui2 = gle(e2.get("smooth")), vi2 = e2.get("smoothMonotone");
        if (dt.setShape({ smooth: ui2, smoothMonotone: vi2, connectNulls: _e }), vt) {
          var ko = L.getCalculationInfo("stackedOnSeries"), Ss = 0;
          vt.useStyle(El(j.getAreaStyle(), { fill: Ze2, opacity: 0.7, lineJoin: "bevel", decal: L.getVisual("style").decal })), ko && (Ss = gle(ko.get("smooth"))), vt.setShape({ smooth: ui2, stackedOnSmooth: Ss, smoothMonotone: vi2, connectNulls: _e }), Gy(vt, e2, "areaStyle"), ns(vt).seriesIndex = e2.seriesIndex, n0(vt, Kr, Kn, ar);
        }
        var hl = function(Qs) {
          x2._changePolyState(Qs);
        };
        L.eachItemGraphicEl(function(Qs) {
          Qs && (Qs.onHoverStateChange = hl);
        }), this._polyline.onHoverStateChange = hl, this._data = L, this._coordSys = C, this._stackedOnPoints = ne2, this._points = U3, this._step = Be2, this._valueOrigin = Rt, e2.get("triggerLineEvent") && (this.packEventData(e2, dt), vt && this.packEventData(e2, vt));
      }, a.prototype.packEventData = function(e2, d2) {
        ns(d2).eventData = { componentType: "series", componentSubType: "line", componentIndex: e2.componentIndex, seriesIndex: e2.seriesIndex, seriesName: e2.name, seriesType: "line" };
      }, a.prototype.highlight = function(e2, d2, y2, x2) {
        var C = e2.getData(), D2 = fC(C, x2);
        if (this._changePolyState("emphasis"), !(D2 instanceof Array) && D2 != null && D2 >= 0) {
          var L = C.getLayout("points"), F3 = C.getItemGraphicEl(D2);
          if (!F3) {
            var j = L[D2 * 2], U3 = L[D2 * 2 + 1];
            if (isNaN(j) || isNaN(U3) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(j, U3))
              return;
            var Y3 = e2.get("zlevel"), Q = e2.get("z");
            F3 = new zrt(C, D2), F3.x = j, F3.y = U3, F3.setZ(Y3, Q);
            var nt = F3.getSymbolPath().getTextContent();
            nt && (nt.zlevel = Y3, nt.z = Q, nt.z2 = this._polyline.z2 + 1), F3.__temp = true, C.setItemGraphicEl(D2, F3), F3.stopSymbolAnimation(true), this.group.add(F3);
          }
          F3.highlight();
        } else
          pg2.prototype.highlight.call(this, e2, d2, y2, x2);
      }, a.prototype.downplay = function(e2, d2, y2, x2) {
        var C = e2.getData(), D2 = fC(C, x2);
        if (this._changePolyState("normal"), D2 != null && D2 >= 0) {
          var L = C.getItemGraphicEl(D2);
          L && (L.__temp ? (C.setItemGraphicEl(D2, null), this.group.remove(L)) : L.downplay());
        } else
          pg2.prototype.downplay.call(this, e2, d2, y2, x2);
      }, a.prototype._changePolyState = function(e2) {
        var d2 = this._polygon;
        wO(this._polyline, e2), d2 && wO(d2, e2);
      }, a.prototype._newPolyline = function(e2) {
        var d2 = this._polyline;
        return d2 && this._lineGroup.remove(d2), d2 = new PJe({ shape: { points: e2 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(d2), this._polyline = d2, d2;
      }, a.prototype._newPolygon = function(e2, d2) {
        var y2 = this._polygon;
        return y2 && this._lineGroup.remove(y2), y2 = new ule({ shape: { points: e2, stackedOnPoints: d2 }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(y2), this._polygon = y2, y2;
      }, a.prototype._initSymbolLabelAnimation = function(e2, d2, y2) {
        var x2, C, D2 = d2.getBaseAxis(), L = D2.inverse;
        d2.type === "cartesian2d" ? (x2 = D2.isHorizontal(), C = false) : d2.type === "polar" && (x2 = D2.dim === "angle", C = true);
        var F3 = e2.hostModel, j = F3.get("animationDuration");
        wl(j) && (j = j(null));
        var U3 = F3.get("animationDelay") || 0, Y3 = wl(U3) ? U3(null) : U3;
        e2.eachItemGraphicEl(function(Q, nt) {
          var dt = Q;
          if (dt) {
            var vt = [Q.x, Q.y], Ct = void 0, Pt = void 0, jt = void 0;
            if (y2)
              if (C) {
                var Rt = y2, le2 = d2.pointToCoord(vt);
                x2 ? (Ct = Rt.startAngle, Pt = Rt.endAngle, jt = -le2[1] / 180 * Math.PI) : (Ct = Rt.r0, Pt = Rt.r, jt = le2[0]);
              } else {
                var ne2 = y2;
                x2 ? (Ct = ne2.x, Pt = ne2.x + ne2.width, jt = Q.x) : (Ct = ne2.y + ne2.height, Pt = ne2.y, jt = Q.y);
              }
            var he2 = Pt === Ct ? 0 : (jt - Ct) / (Pt - Ct);
            L && (he2 = 1 - he2);
            var _e = wl(U3) ? U3(nt) : j * he2 + Y3, Me2 = dt.getSymbolPath(), Pe2 = Me2.getTextContent();
            dt.attr({ scaleX: 0, scaleY: 0 }), dt.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: _e }), Pe2 && Pe2.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: _e }), Me2.disableLabelAnimation = true;
          }
        });
      }, a.prototype._initOrUpdateEndLabel = function(e2, d2, y2) {
        var x2 = e2.getModel("endLabel");
        if (yle(e2)) {
          var C = e2.getData(), D2 = this._polyline, L = C.getLayout("points");
          if (!L) {
            D2.removeTextContent(), this._endLabel = null;
            return;
          }
          var F3 = this._endLabel;
          F3 || (F3 = this._endLabel = new qc2({ z2: 200 }), F3.ignoreClip = true, D2.setTextContent(this._endLabel), D2.disableLabelAnimation = true);
          var j = zJe(L);
          j >= 0 && (ow(D2, Sb2(e2, "endLabel"), { inheritColor: y2, labelFetcher: e2, labelDataIndex: j, defaultText: function(U3, Y3, Q) {
            return Q != null ? rle(C, Q) : oZ(C, U3);
          }, enableTextSetter: true }, WJe(x2, d2)), D2.textConfig.position = null);
        } else
          this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
      }, a.prototype._endLabelOnDuring = function(e2, d2, y2, x2, C, D2, L) {
        var F3 = this._endLabel, j = this._polyline;
        if (F3) {
          e2 < 1 && x2.originalX == null && (x2.originalX = F3.x, x2.originalY = F3.y);
          var U3 = y2.getLayout("points"), Y3 = y2.hostModel, Q = Y3.get("connectNulls"), nt = D2.get("precision"), dt = D2.get("distance") || 0, vt = L.getBaseAxis(), Ct = vt.isHorizontal(), Pt = vt.inverse, jt = d2.shape, Rt = Pt ? Ct ? jt.x : jt.y + jt.height : Ct ? jt.x + jt.width : jt.y, le2 = (Ct ? dt : 0) * (Pt ? -1 : 1), ne2 = (Ct ? 0 : -dt) * (Pt ? -1 : 1), he2 = Ct ? "x" : "y", _e = jJe(U3, Rt, he2), Me2 = _e.range, Pe2 = Me2[1] - Me2[0], Be2 = void 0;
          if (Pe2 >= 1) {
            if (Pe2 > 1 && !Q) {
              var Je2 = vle(U3, Me2[0]);
              F3.attr({ x: Je2[0] + le2, y: Je2[1] + ne2 }), C && (Be2 = Y3.getRawValue(Me2[0]));
            } else {
              var Je2 = j.getPointOn(Rt, he2);
              Je2 && F3.attr({ x: Je2[0] + le2, y: Je2[1] + ne2 });
              var Ze2 = Y3.getRawValue(Me2[0]), Cn = Y3.getRawValue(Me2[1]);
              C && (Be2 = FN(y2, nt, Ze2, Cn, _e.t));
            }
            x2.lastFrameIndex = Me2[0];
          } else {
            var Bn = e2 === 1 || x2.lastFrameIndex > 0 ? Me2[0] : 0, Je2 = vle(U3, Bn);
            C && (Be2 = Y3.getRawValue(Bn)), F3.attr({ x: Je2[0] + le2, y: Je2[1] + ne2 });
          }
          C && Bq(F3).setLabelText(Be2);
        }
      }, a.prototype._doUpdateAnimation = function(e2, d2, y2, x2, C, D2, L) {
        var F3 = this._polyline, j = this._polygon, U3 = e2.hostModel, Y3 = kJe(this._data, e2, this._stackedOnPoints, d2, this._coordSys, y2, this._valueOrigin), Q = Y3.current, nt = Y3.stackedOnCurrent, dt = Y3.next, vt = Y3.stackedOnNext;
        if (C && (Q = iF(Y3.current, y2, C, L), nt = iF(Y3.stackedOnCurrent, y2, C, L), dt = iF(Y3.next, y2, C, L), vt = iF(Y3.stackedOnNext, y2, C, L)), dle(Q, dt) > 3e3 || j && dle(nt, vt) > 3e3) {
          F3.stopAnimation(), F3.setShape({ points: dt }), j && (j.stopAnimation(), j.setShape({ points: dt, stackedOnPoints: vt }));
          return;
        }
        F3.shape.__points = Y3.current, F3.shape.points = Q;
        var Ct = { shape: { points: dt } };
        Y3.current !== Q && (Ct.shape.__points = Y3.next), F3.stopAnimation(), Yf2(F3, Ct, U3), j && (j.setShape({ points: Q, stackedOnPoints: nt }), j.stopAnimation(), Yf2(j, { shape: { stackedOnPoints: vt } }, U3), F3.shape.points !== j.shape.points && (j.shape.points = F3.shape.points));
        for (var Pt = [], jt = Y3.status, Rt = 0; Rt < jt.length; Rt++) {
          var le2 = jt[Rt].cmd;
          if (le2 === "=") {
            var ne2 = e2.getItemGraphicEl(jt[Rt].idx1);
            ne2 && Pt.push({ el: ne2, ptIdx: Rt });
          }
        }
        F3.animators && F3.animators.length && F3.animators[0].during(function() {
          j && j.dirtyShape();
          for (var he2 = F3.shape.__points, _e = 0; _e < Pt.length; _e++) {
            var Me2 = Pt[_e].el, Pe2 = Pt[_e].ptIdx * 2;
            Me2.x = he2[Pe2], Me2.y = he2[Pe2 + 1], Me2.markRedraw();
          }
        });
      }, a.prototype.remove = function(e2) {
        var d2 = this.group, y2 = this._data;
        this._lineGroup.removeAll(), this._symbolDraw.remove(true), y2 && y2.eachItemGraphicEl(function(x2, C) {
          x2.__temp && (d2.remove(x2), y2.setItemGraphicEl(C, null));
        }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
      }, a.type = "line", a;
    }(pg2), HJe = GJe;
    function Wrt(l2, a) {
      return { seriesType: l2, plan: Kq(), reset: function(e2) {
        var d2 = e2.getData(), y2 = e2.coordinateSystem, x2 = e2.pipelineContext, C = a || x2.large;
        if (y2) {
          var D2 = $a2(y2.dimensions, function(Q) {
            return d2.mapDimension(Q);
          }).slice(0, 2), L = D2.length, F3 = d2.getCalculationInfo("stackResultDimension");
          tF(d2, D2[0]) && (D2[0] = F3), tF(d2, D2[1]) && (D2[1] = F3);
          var j = d2.getStore(), U3 = d2.getDimensionIndex(D2[0]), Y3 = d2.getDimensionIndex(D2[1]);
          return L && { progress: function(Q, nt) {
            for (var dt = Q.end - Q.start, vt = C && lP(dt * L), Ct = [], Pt = [], jt = Q.start, Rt = 0; jt < Q.end; jt++) {
              var le2 = void 0;
              if (L === 1) {
                var ne2 = j.get(U3, jt);
                le2 = y2.dataToPoint(ne2, null, Pt);
              } else
                Ct[0] = j.get(U3, jt), Ct[1] = j.get(Y3, jt), le2 = y2.dataToPoint(Ct, null, Pt);
              C ? (vt[Rt++] = le2[0], vt[Rt++] = le2[1]) : nt.setItemLayout(jt, le2.slice());
            }
            C && nt.setLayout("points", vt);
          } };
        }
      } };
    }
    var UJe = { average: function(l2) {
      for (var a = 0, e2 = 0, d2 = 0; d2 < l2.length; d2++)
        isNaN(l2[d2]) || (a += l2[d2], e2++);
      return e2 === 0 ? NaN : a / e2;
    }, sum: function(l2) {
      for (var a = 0, e2 = 0; e2 < l2.length; e2++)
        a += l2[e2] || 0;
      return a;
    }, max: function(l2) {
      for (var a = -1 / 0, e2 = 0; e2 < l2.length; e2++)
        l2[e2] > a && (a = l2[e2]);
      return isFinite(a) ? a : NaN;
    }, min: function(l2) {
      for (var a = 1 / 0, e2 = 0; e2 < l2.length; e2++)
        l2[e2] < a && (a = l2[e2]);
      return isFinite(a) ? a : NaN;
    }, nearest: function(l2) {
      return l2[0];
    } }, qJe = function(l2) {
      return Math.round(l2.length / 2);
    };
    function mle(l2) {
      return { seriesType: l2, reset: function(a, e2, d2) {
        var y2 = a.getData(), x2 = a.get("sampling"), C = a.coordinateSystem, D2 = y2.count();
        if (D2 > 10 && C.type === "cartesian2d" && x2) {
          var L = C.getBaseAxis(), F3 = C.getOtherAxis(L), j = L.getExtent(), U3 = d2.getDevicePixelRatio(), Y3 = Math.abs(j[1] - j[0]) * (U3 || 1), Q = Math.round(D2 / Y3);
          if (isFinite(Q) && Q > 1) {
            x2 === "lttb" && a.setData(y2.lttbDownSample(y2.mapDimension(F3.dim), 1 / Q));
            var nt = void 0;
            ps(x2) ? nt = UJe[x2] : wl(x2) && (nt = x2), nt && a.setData(y2.downSample(y2.mapDimension(F3.dim), 1 / Q, nt, qJe));
          }
        }
      } };
    }
    function ZJe(l2) {
      l2.registerChartView(HJe), l2.registerSeriesModel(CJe), l2.registerLayout(Wrt("line", true)), l2.registerVisual({ seriesType: "line", reset: function(a) {
        var e2 = a.getData(), d2 = a.getModel("lineStyle").getLineStyle();
        d2 && !d2.stroke && (d2.stroke = e2.getVisual("style").fill), e2.setVisual("legendLineStyle", d2);
      } }), l2.registerProcessor(l2.PRIORITY.PROCESSOR.STATISTIC, mle("line"));
    }
    var ble = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        return PO(null, this, { useEncodeDefaulter: true });
      }, a.prototype.getMarkerPosition = function(e2) {
        var d2 = this.coordinateSystem;
        if (d2 && d2.clampData) {
          var y2 = d2.dataToPoint(d2.clampData(e2)), x2 = this.getData(), C = x2.getLayout("offset"), D2 = x2.getLayout("size"), L = d2.getBaseAxis().isHorizontal() ? 0 : 1;
          return y2[L] += C + D2 / 2, y2;
        }
        return [NaN, NaN];
      }, a.type = "series.__base_bar__", a.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, a;
    }(Pv);
    Pv.registerClass(ble);
    var Qyt = ble, $Je = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.getInitialData = function() {
        return PO(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
      }, a.prototype.getProgressive = function() {
        return this.get("large") ? this.get("progressive") : false;
      }, a.prototype.getProgressiveThreshold = function() {
        var e2 = this.get("progressiveThreshold"), d2 = this.get("largeThreshold");
        return d2 > e2 && (e2 = d2), e2;
      }, a.prototype.brushSelector = function(e2, d2, y2) {
        return y2.rect(d2.getItemLayout(e2));
      }, a.type = "series.bar", a.dependencies = ["grid", "polar"], a.defaultOption = ZN(Qyt.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), a;
    }(Qyt), YJe = $Je, KJe = function() {
      function l2() {
        this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
      }
      return l2;
    }(), XJe = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "sausage", d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new KJe();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.cx, x2 = d2.cy, C = Math.max(d2.r0 || 0, 0), D2 = Math.max(d2.r, 0), L = (D2 - C) * 0.5, F3 = C + L, j = d2.startAngle, U3 = d2.endAngle, Y3 = d2.clockwise, Q = Math.PI * 2, nt = Y3 ? U3 - j < Q : j - U3 < Q;
        nt || (j = U3 - (Y3 ? Q : -Q));
        var dt = Math.cos(j), vt = Math.sin(j), Ct = Math.cos(U3), Pt = Math.sin(U3);
        nt ? (e2.moveTo(dt * C + y2, vt * C + x2), e2.arc(dt * F3 + y2, vt * F3 + x2, L, -Math.PI + j, j, !Y3)) : e2.moveTo(dt * D2 + y2, vt * D2 + x2), e2.arc(y2, x2, D2, j, U3, !Y3), e2.arc(Ct * F3 + y2, Pt * F3 + x2, L, U3 - Math.PI * 2, U3 - Math.PI, !Y3), C !== 0 && e2.arc(y2, x2, C, U3, j, Y3);
      }, a;
    }(wc2), Jyt = XJe;
    function QJe(l2, a) {
      a = a || {};
      var e2 = a.isRoundCap;
      return function(d2, y2, x2) {
        var C = y2.position;
        if (!C || C instanceof Array)
          return QU(d2, y2, x2);
        var D2 = l2(C), L = y2.distance != null ? y2.distance : 5, F3 = this.shape, j = F3.cx, U3 = F3.cy, Y3 = F3.r, Q = F3.r0, nt = (Y3 + Q) / 2, dt = F3.startAngle, vt = F3.endAngle, Ct = (dt + vt) / 2, Pt = e2 ? Math.abs(Y3 - Q) / 2 : 0, jt = Math.cos, Rt = Math.sin, le2 = j + Y3 * jt(dt), ne2 = U3 + Y3 * Rt(dt), he2 = "left", _e = "top";
        switch (D2) {
          case "startArc":
            le2 = j + (Q - L) * jt(Ct), ne2 = U3 + (Q - L) * Rt(Ct), he2 = "center", _e = "top";
            break;
          case "insideStartArc":
            le2 = j + (Q + L) * jt(Ct), ne2 = U3 + (Q + L) * Rt(Ct), he2 = "center", _e = "bottom";
            break;
          case "startAngle":
            le2 = j + nt * jt(dt) + tmt(dt, L + Pt, false), ne2 = U3 + nt * Rt(dt) + emt(dt, L + Pt, false), he2 = "right", _e = "middle";
            break;
          case "insideStartAngle":
            le2 = j + nt * jt(dt) + tmt(dt, -L + Pt, false), ne2 = U3 + nt * Rt(dt) + emt(dt, -L + Pt, false), he2 = "left", _e = "middle";
            break;
          case "middle":
            le2 = j + nt * jt(Ct), ne2 = U3 + nt * Rt(Ct), he2 = "center", _e = "middle";
            break;
          case "endArc":
            le2 = j + (Y3 + L) * jt(Ct), ne2 = U3 + (Y3 + L) * Rt(Ct), he2 = "center", _e = "bottom";
            break;
          case "insideEndArc":
            le2 = j + (Y3 - L) * jt(Ct), ne2 = U3 + (Y3 - L) * Rt(Ct), he2 = "center", _e = "top";
            break;
          case "endAngle":
            le2 = j + nt * jt(vt) + tmt(vt, L + Pt, true), ne2 = U3 + nt * Rt(vt) + emt(vt, L + Pt, true), he2 = "left", _e = "middle";
            break;
          case "insideEndAngle":
            le2 = j + nt * jt(vt) + tmt(vt, -L + Pt, true), ne2 = U3 + nt * Rt(vt) + emt(vt, -L + Pt, true), he2 = "right", _e = "middle";
            break;
          default:
            return QU(d2, y2, x2);
        }
        return d2 = d2 || {}, d2.x = le2, d2.y = ne2, d2.align = he2, d2.verticalAlign = _e, d2;
      };
    }
    function JJe(l2, a, e2, d2) {
      if (Ch2(d2)) {
        l2.setTextConfig({ rotation: d2 });
        return;
      } else if (Ba2(a)) {
        l2.setTextConfig({ rotation: 0 });
        return;
      }
      var y2 = l2.shape, x2 = y2.clockwise ? y2.startAngle : y2.endAngle, C = y2.clockwise ? y2.endAngle : y2.startAngle, D2 = (x2 + C) / 2, L, F3 = e2(a);
      switch (F3) {
        case "startArc":
        case "insideStartArc":
        case "middle":
        case "insideEndArc":
        case "endArc":
          L = D2;
          break;
        case "startAngle":
        case "insideStartAngle":
          L = x2;
          break;
        case "endAngle":
        case "insideEndAngle":
          L = C;
          break;
        default:
          l2.setTextConfig({ rotation: 0 });
          return;
      }
      var j = Math.PI * 1.5 - L;
      F3 === "middle" && j > Math.PI / 2 && j < Math.PI * 1.5 && (j -= Math.PI), l2.setTextConfig({ rotation: j });
    }
    function tmt(l2, a, e2) {
      return a * Math.sin(l2) * (e2 ? -1 : 1);
    }
    function emt(l2, a, e2) {
      return a * Math.cos(l2) * (e2 ? 1 : -1);
    }
    var aOt = Math.max, oOt = Math.min;
    function ttn(l2, a) {
      var e2 = l2.getArea && l2.getArea();
      if (OO(l2, "cartesian2d")) {
        var d2 = l2.getBaseAxis();
        if (d2.type !== "category" || !d2.onBand) {
          var y2 = a.getLayout("bandWidth");
          d2.isHorizontal() ? (e2.x -= y2, e2.width += y2 * 2) : (e2.y -= y2, e2.height += y2 * 2);
        }
      }
      return e2;
    }
    var etn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2.call(this) || this;
        return e2.type = a.type, e2._isFirstFrame = true, e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        this._model = e2, this._removeOnRenderedListener(y2), this._updateDrawMode(e2);
        var C = e2.get("coordinateSystem");
        (C === "cartesian2d" || C === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(e2, d2, y2) : this._renderNormal(e2, d2, y2, x2));
      }, a.prototype.incrementalPrepareRender = function(e2) {
        this._clear(), this._updateDrawMode(e2), this._updateLargeClip(e2);
      }, a.prototype.incrementalRender = function(e2, d2) {
        this._progressiveEls = [], this._incrementalRenderLarge(e2, d2);
      }, a.prototype.eachRendered = function(e2) {
        qN(this._progressiveEls || this.group, e2);
      }, a.prototype._updateDrawMode = function(e2) {
        var d2 = e2.pipelineContext.large;
        (this._isLargeDraw == null || d2 !== this._isLargeDraw) && (this._isLargeDraw = d2, this._clear());
      }, a.prototype._renderNormal = function(e2, d2, y2, x2) {
        var C = this.group, D2 = e2.getData(), L = this._data, F3 = e2.coordinateSystem, j = F3.getBaseAxis(), U3;
        F3.type === "cartesian2d" ? U3 = j.isHorizontal() : F3.type === "polar" && (U3 = j.dim === "angle");
        var Y3 = e2.isAnimationEnabled() ? e2 : null, Q = ntn(e2, F3);
        Q && this._enableRealtimeSort(Q, D2, y2);
        var nt = e2.get("clip", true) || Q, dt = ttn(F3, D2);
        C.removeClipPath();
        var vt = e2.get("roundCap", true), Ct = e2.get("showBackground", true), Pt = e2.getModel("backgroundStyle"), jt = Pt.get("borderRadius") || 0, Rt = [], le2 = this._backgroundEls, ne2 = x2 && x2.isInitSort, he2 = x2 && x2.type === "changeAxisOrder";
        function _e(Be2) {
          var Je2 = nmt[F3.type](D2, Be2), Ze2 = utn(F3, U3, Je2);
          return Ze2.useStyle(Pt.getItemStyle()), F3.type === "cartesian2d" && Ze2.setShape("r", jt), Rt[Be2] = Ze2, Ze2;
        }
        D2.diff(L).add(function(Be2) {
          var Je2 = D2.getItemModel(Be2), Ze2 = nmt[F3.type](D2, Be2, Je2);
          if (Ct && _e(Be2), !(!D2.hasValue(Be2) || !Mle[F3.type](Ze2))) {
            var Cn = false;
            nt && (Cn = _le[F3.type](dt, Ze2));
            var Bn = xle[F3.type](e2, D2, Be2, Ze2, U3, Y3, j.model, false, vt);
            Q && (Bn.forceLabelAnimation = true), Tle(Bn, D2, Be2, Je2, Ze2, e2, U3, F3.type === "polar"), ne2 ? Bn.attr({ shape: Ze2 }) : Q ? wle(Q, Y3, Bn, Ze2, Be2, U3, false, false) : Yg2(Bn, { shape: Ze2 }, e2, Be2), D2.setItemGraphicEl(Be2, Bn), C.add(Bn), Bn.ignore = Cn;
          }
        }).update(function(Be2, Je2) {
          var Ze2 = D2.getItemModel(Be2), Cn = nmt[F3.type](D2, Be2, Ze2);
          if (Ct) {
            var Bn = void 0;
            le2.length === 0 ? Bn = _e(Je2) : (Bn = le2[Je2], Bn.useStyle(Pt.getItemStyle()), F3.type === "cartesian2d" && Bn.setShape("r", jt), Rt[Be2] = Bn);
            var mn = nmt[F3.type](D2, Be2), Kr = Ele(U3, mn, F3);
            Yf2(Bn, { shape: Kr }, Y3, Be2);
          }
          var Kn = L.getItemGraphicEl(Je2);
          if (!D2.hasValue(Be2) || !Mle[F3.type](Cn)) {
            C.remove(Kn);
            return;
          }
          var ar = false;
          if (nt && (ar = _le[F3.type](dt, Cn), ar && C.remove(Kn)), Kn ? pC(Kn) : Kn = xle[F3.type](e2, D2, Be2, Cn, U3, Y3, j.model, !!Kn, vt), Q && (Kn.forceLabelAnimation = true), he2) {
            var Cr = Kn.getTextContent();
            if (Cr) {
              var ui2 = Bq(Cr);
              ui2.prevValue != null && (ui2.prevValue = ui2.value);
            }
          } else
            Tle(Kn, D2, Be2, Ze2, Cn, e2, U3, F3.type === "polar");
          ne2 ? Kn.attr({ shape: Cn }) : Q ? wle(Q, Y3, Kn, Cn, Be2, U3, true, he2) : Yf2(Kn, { shape: Cn }, e2, Be2, null), D2.setItemGraphicEl(Be2, Kn), Kn.ignore = ar, C.add(Kn);
        }).remove(function(Be2) {
          var Je2 = L.getItemGraphicEl(Be2);
          Je2 && JV(Je2, e2, Be2);
        }).execute();
        var Me2 = this._backgroundGroup || (this._backgroundGroup = new ou());
        Me2.removeAll();
        for (var Pe2 = 0; Pe2 < Rt.length; ++Pe2)
          Me2.add(Rt[Pe2]);
        C.add(Me2), this._backgroundEls = Rt, this._data = D2;
      }, a.prototype._renderLarge = function(e2, d2, y2) {
        this._clear(), Ile(e2, this.group), this._updateLargeClip(e2);
      }, a.prototype._incrementalRenderLarge = function(e2, d2) {
        this._removeBackground(), Ile(d2, this.group, this._progressiveEls, true);
      }, a.prototype._updateLargeClip = function(e2) {
        var d2 = e2.get("clip", true) && Xyt(e2.coordinateSystem, false, e2), y2 = this.group;
        d2 ? y2.setClipPath(d2) : y2.removeClipPath();
      }, a.prototype._enableRealtimeSort = function(e2, d2, y2) {
        var x2 = this;
        if (d2.count()) {
          var C = e2.baseAxis;
          if (this._isFirstFrame)
            this._dispatchInitSort(d2, e2, y2), this._isFirstFrame = false;
          else {
            var D2 = function(L) {
              var F3 = d2.getItemGraphicEl(L), j = F3 && F3.shape;
              return j && Math.abs(C.isHorizontal() ? j.height : j.width) || 0;
            };
            this._onRendered = function() {
              x2._updateSortWithinSameData(d2, D2, C, y2);
            }, y2.getZr().on("rendered", this._onRendered);
          }
        }
      }, a.prototype._dataSort = function(e2, d2, y2) {
        var x2 = [];
        return e2.each(e2.mapDimension(d2.dim), function(C, D2) {
          var L = y2(D2);
          L = L == null ? NaN : L, x2.push({ dataIndex: D2, mappedValue: L, ordinalNumber: C });
        }), x2.sort(function(C, D2) {
          return D2.mappedValue - C.mappedValue;
        }), { ordinalNumbers: $a2(x2, function(C) {
          return C.ordinalNumber;
        }) };
      }, a.prototype._isOrderChangedWithinSameData = function(e2, d2, y2) {
        for (var x2 = y2.scale, C = e2.mapDimension(y2.dim), D2 = Number.MAX_VALUE, L = 0, F3 = x2.getOrdinalMeta().categories.length; L < F3; ++L) {
          var j = e2.rawIndexOf(C, x2.getRawOrdinalNumber(L)), U3 = j < 0 ? Number.MIN_VALUE : d2(e2.indexOfRawIndex(j));
          if (U3 > D2)
            return true;
          D2 = U3;
        }
        return false;
      }, a.prototype._isOrderDifferentInView = function(e2, d2) {
        for (var y2 = d2.scale, x2 = y2.getExtent(), C = Math.max(0, x2[0]), D2 = Math.min(x2[1], y2.getOrdinalMeta().categories.length - 1); C <= D2; ++C)
          if (e2.ordinalNumbers[C] !== y2.getRawOrdinalNumber(C))
            return true;
      }, a.prototype._updateSortWithinSameData = function(e2, d2, y2, x2) {
        if (this._isOrderChangedWithinSameData(e2, d2, y2)) {
          var C = this._dataSort(e2, y2, d2);
          this._isOrderDifferentInView(C, y2) && (this._removeOnRenderedListener(x2), x2.dispatchAction({ type: "changeAxisOrder", componentType: y2.dim + "Axis", axisId: y2.index, sortInfo: C }));
        }
      }, a.prototype._dispatchInitSort = function(e2, d2, y2) {
        var x2 = d2.baseAxis, C = this._dataSort(e2, x2, function(D2) {
          return e2.get(e2.mapDimension(d2.otherAxis.dim), D2);
        });
        y2.dispatchAction({ type: "changeAxisOrder", componentType: x2.dim + "Axis", isInitSort: true, axisId: x2.index, sortInfo: C });
      }, a.prototype.remove = function(e2, d2) {
        this._clear(this._model), this._removeOnRenderedListener(d2);
      }, a.prototype.dispose = function(e2, d2) {
        this._removeOnRenderedListener(d2);
      }, a.prototype._removeOnRenderedListener = function(e2) {
        this._onRendered && (e2.getZr().off("rendered", this._onRendered), this._onRendered = null);
      }, a.prototype._clear = function(e2) {
        var d2 = this.group, y2 = this._data;
        e2 && e2.isAnimationEnabled() && y2 && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], y2.eachItemGraphicEl(function(x2) {
          JV(x2, e2, ns(x2).dataIndex);
        })) : d2.removeAll(), this._data = null, this._isFirstFrame = true;
      }, a.prototype._removeBackground = function() {
        this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
      }, a.type = "bar", a;
    }(pg2), _le = { cartesian2d: function(l2, a) {
      var e2 = a.width < 0 ? -1 : 1, d2 = a.height < 0 ? -1 : 1;
      e2 < 0 && (a.x += a.width, a.width = -a.width), d2 < 0 && (a.y += a.height, a.height = -a.height);
      var y2 = l2.x + l2.width, x2 = l2.y + l2.height, C = aOt(a.x, l2.x), D2 = oOt(a.x + a.width, y2), L = aOt(a.y, l2.y), F3 = oOt(a.y + a.height, x2), j = D2 < C, U3 = F3 < L;
      return a.x = j && C > y2 ? D2 : C, a.y = U3 && L > x2 ? F3 : L, a.width = j ? 0 : D2 - C, a.height = U3 ? 0 : F3 - L, e2 < 0 && (a.x += a.width, a.width = -a.width), d2 < 0 && (a.y += a.height, a.height = -a.height), j || U3;
    }, polar: function(l2, a) {
      var e2 = a.r0 <= a.r ? 1 : -1;
      if (e2 < 0) {
        var d2 = a.r;
        a.r = a.r0, a.r0 = d2;
      }
      var y2 = oOt(a.r, l2.r), x2 = aOt(a.r0, l2.r0);
      a.r = y2, a.r0 = x2;
      var C = y2 - x2 < 0;
      if (e2 < 0) {
        var d2 = a.r;
        a.r = a.r0, a.r0 = d2;
      }
      return C;
    } }, xle = { cartesian2d: function(l2, a, e2, d2, y2, x2, C, D2, L) {
      var F3 = new Nf2({ shape: la2({}, d2), z2: 1 });
      if (F3.__dataIndex = e2, F3.name = "item", x2) {
        var j = F3.shape, U3 = y2 ? "height" : "width";
        j[U3] = 0;
      }
      return F3;
    }, polar: function(l2, a, e2, d2, y2, x2, C, D2, L) {
      var F3 = !y2 && L ? Jyt : nw, j = new F3({ shape: d2, z2: 1 });
      j.name = "item";
      var U3 = Cle(y2);
      if (j.calculateTextPosition = QJe(U3, { isRoundCap: F3 === Jyt }), x2) {
        var Y3 = j.shape, Q = y2 ? "r" : "endAngle", nt = {};
        Y3[Q] = y2 ? 0 : d2.startAngle, nt[Q] = d2[Q], (D2 ? Yf2 : Yg2)(j, { shape: nt }, x2);
      }
      return j;
    } };
    function ntn(l2, a) {
      var e2 = l2.get("realtimeSort", true), d2 = a.getBaseAxis();
      if (e2 && d2.type === "category" && a.type === "cartesian2d")
        return { baseAxis: d2, otherAxis: a.getOtherAxis(d2) };
    }
    function wle(l2, a, e2, d2, y2, x2, C, D2) {
      var L, F3;
      x2 ? (F3 = { x: d2.x, width: d2.width }, L = { y: d2.y, height: d2.height }) : (F3 = { y: d2.y, height: d2.height }, L = { x: d2.x, width: d2.width }), D2 || (C ? Yf2 : Yg2)(e2, { shape: L }, a, y2, null);
      var j = a ? l2.baseAxis.model : null;
      (C ? Yf2 : Yg2)(e2, { shape: F3 }, j, y2);
    }
    function Sle(l2, a) {
      for (var e2 = 0; e2 < a.length; e2++)
        if (!isFinite(l2[a[e2]]))
          return true;
      return false;
    }
    var rtn = ["x", "y", "width", "height"], itn = ["cx", "cy", "r", "startAngle", "endAngle"], Mle = { cartesian2d: function(l2) {
      return !Sle(l2, rtn);
    }, polar: function(l2) {
      return !Sle(l2, itn);
    } }, nmt = { cartesian2d: function(l2, a, e2) {
      var d2 = l2.getItemLayout(a), y2 = e2 ? otn(e2, d2) : 0, x2 = d2.width > 0 ? 1 : -1, C = d2.height > 0 ? 1 : -1;
      return { x: d2.x + x2 * y2 / 2, y: d2.y + C * y2 / 2, width: d2.width - x2 * y2, height: d2.height - C * y2 };
    }, polar: function(l2, a, e2) {
      var d2 = l2.getItemLayout(a);
      return { cx: d2.cx, cy: d2.cy, r0: d2.r0, r: d2.r, startAngle: d2.startAngle, endAngle: d2.endAngle, clockwise: d2.clockwise };
    } };
    function atn(l2) {
      return l2.startAngle != null && l2.endAngle != null && l2.startAngle === l2.endAngle;
    }
    function Cle(l2) {
      return function(a) {
        var e2 = a ? "Arc" : "Angle";
        return function(d2) {
          switch (d2) {
            case "start":
            case "insideStart":
            case "end":
            case "insideEnd":
              return d2 + e2;
            default:
              return d2;
          }
        };
      }(l2);
    }
    function Tle(l2, a, e2, d2, y2, x2, C, D2) {
      var L = a.getItemVisual(e2, "style");
      D2 || l2.setShape("r", d2.get(["itemStyle", "borderRadius"]) || 0), l2.useStyle(L);
      var F3 = d2.getShallow("cursor");
      F3 && l2.attr("cursor", F3);
      var j = D2 ? C ? y2.r >= y2.r0 ? "endArc" : "startArc" : y2.endAngle >= y2.startAngle ? "endAngle" : "startAngle" : C ? y2.height >= 0 ? "bottom" : "top" : y2.width >= 0 ? "right" : "left", U3 = Sb2(d2);
      ow(l2, U3, { labelFetcher: x2, labelDataIndex: e2, defaultText: oZ(x2.getData(), e2), inheritColor: L.fill, defaultOpacity: L.opacity, defaultOutsidePosition: j });
      var Y3 = l2.getTextContent();
      if (D2 && Y3) {
        var Q = d2.get(["label", "position"]);
        l2.textConfig.inside = Q === "middle" ? true : null, JJe(l2, Q === "outside" ? j : Q, Cle(C), d2.get(["label", "rotate"]));
      }
      qre(Y3, U3, x2.getRawValue(e2), function(dt) {
        return rle(a, dt);
      });
      var nt = d2.getModel(["emphasis"]);
      n0(l2, nt.get("focus"), nt.get("blurScope"), nt.get("disabled")), Gy(l2, d2), atn(y2) && (l2.style.fill = "none", l2.style.stroke = "none", Ke2(l2.states, function(dt) {
        dt.style && (dt.style.fill = dt.style.stroke = "none");
      }));
    }
    function otn(l2, a) {
      var e2 = l2.get(["itemStyle", "borderColor"]);
      if (!e2 || e2 === "none")
        return 0;
      var d2 = l2.get(["itemStyle", "borderWidth"]) || 0, y2 = isNaN(a.width) ? Number.MAX_VALUE : Math.abs(a.width), x2 = isNaN(a.height) ? Number.MAX_VALUE : Math.abs(a.height);
      return Math.min(d2, y2, x2);
    }
    var stn = function() {
      function l2() {
      }
      return l2;
    }(), Ale = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "largeBar", d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new stn();
      }, a.prototype.buildPath = function(e2, d2) {
        for (var y2 = d2.points, x2 = this.baseDimIdx, C = 1 - this.baseDimIdx, D2 = [], L = [], F3 = this.barWidth, j = 0; j < y2.length; j += 3)
          L[x2] = F3, L[C] = y2[j + 2], D2[x2] = y2[j + x2], D2[C] = y2[j + C], e2.rect(D2[0], D2[1], L[0], L[1]);
      }, a;
    }(wc2);
    function Ile(l2, a, e2, d2) {
      var y2 = l2.getData(), x2 = y2.getLayout("valueAxisHorizontal") ? 1 : 0, C = y2.getLayout("largeDataIndices"), D2 = y2.getLayout("size"), L = l2.getModel("backgroundStyle"), F3 = y2.getLayout("largeBackgroundPoints");
      if (F3) {
        var j = new Ale({ shape: { points: F3 }, incremental: !!d2, silent: true, z2: 0 });
        j.baseDimIdx = x2, j.largeDataIndices = C, j.barWidth = D2, j.useStyle(L.getItemStyle()), a.add(j), e2 && e2.push(j);
      }
      var U3 = new Ale({ shape: { points: y2.getLayout("largePoints") }, incremental: !!d2, z2: 1 });
      U3.baseDimIdx = x2, U3.largeDataIndices = C, U3.barWidth = D2, a.add(U3), U3.useStyle(y2.getVisual("style")), ns(U3).seriesIndex = l2.seriesIndex, l2.get("silent") || (U3.on("mousedown", Dle), U3.on("mousemove", Dle)), e2 && e2.push(U3);
    }
    var Dle = iLt(function(l2) {
      var a = this, e2 = ltn(a, l2.offsetX, l2.offsetY);
      ns(a).dataIndex = e2 >= 0 ? e2 : null;
    }, 30, false);
    function ltn(l2, a, e2) {
      for (var d2 = l2.baseDimIdx, y2 = 1 - d2, x2 = l2.shape.points, C = l2.largeDataIndices, D2 = [], L = [], F3 = l2.barWidth, j = 0, U3 = x2.length / 3; j < U3; j++) {
        var Y3 = j * 3;
        if (L[d2] = F3, L[y2] = x2[Y3 + 2], D2[d2] = x2[Y3 + d2], D2[y2] = x2[Y3 + y2], L[y2] < 0 && (D2[y2] += L[y2], L[y2] = -L[y2]), a >= D2[0] && a <= D2[0] + L[0] && e2 >= D2[1] && e2 <= D2[1] + L[1])
          return C[j];
      }
      return -1;
    }
    function Ele(l2, a, e2) {
      if (OO(e2, "cartesian2d")) {
        var d2 = a, y2 = e2.getArea();
        return { x: l2 ? d2.x : y2.x, y: l2 ? y2.y : d2.y, width: l2 ? d2.width : y2.width, height: l2 ? y2.height : d2.height };
      } else {
        var y2 = e2.getArea(), x2 = a;
        return { cx: y2.cx, cy: y2.cy, r0: l2 ? y2.r0 : x2.r0, r: l2 ? y2.r : x2.r, startAngle: l2 ? x2.startAngle : 0, endAngle: l2 ? x2.endAngle : Math.PI * 2 };
      }
    }
    function utn(l2, a, e2) {
      var d2 = l2.type === "polar" ? nw : Nf2;
      return new d2({ shape: Ele(a, e2, l2), silent: true, z2: 0 });
    }
    var ctn = etn;
    function ftn(l2) {
      l2.registerChartView(ctn), l2.registerSeriesModel(YJe), l2.registerLayout(l2.PRIORITY.VISUAL.LAYOUT, xu(Yoe, "bar")), l2.registerLayout(l2.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, Koe("bar")), l2.registerProcessor(l2.PRIORITY.PROCESSOR.STATISTIC, mle("bar")), l2.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(a, e2) {
        var d2 = a.componentType || "series";
        e2.eachComponent({ mainType: d2, query: a }, function(y2) {
          a.sortInfo && y2.axis.setCategorySortInfo(a.sortInfo);
        });
      });
    }
    var rmt = Math.PI * 2, kle = Math.PI / 180;
    function Ple(l2, a) {
      return Em(l2.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
    }
    function Lle(l2, a) {
      var e2 = Ple(l2, a), d2 = l2.get("center"), y2 = l2.get("radius");
      Ba2(y2) || (y2 = [0, y2]), Ba2(d2) || (d2 = [d2, d2]);
      var x2 = Ko(e2.width, a.getWidth()), C = Ko(e2.height, a.getHeight()), D2 = Math.min(x2, C), L = Ko(d2[0], x2) + e2.x, F3 = Ko(d2[1], C) + e2.y, j = Ko(y2[0], D2 / 2), U3 = Ko(y2[1], D2 / 2);
      return { cx: L, cy: F3, r0: j, r: U3 };
    }
    function htn(l2, a, e2) {
      a.eachSeriesByType(l2, function(d2) {
        var y2 = d2.getData(), x2 = y2.mapDimension("value"), C = Ple(d2, e2), D2 = Lle(d2, e2), L = D2.cx, F3 = D2.cy, j = D2.r, U3 = D2.r0, Y3 = -d2.get("startAngle") * kle, Q = d2.get("minAngle") * kle, nt = 0;
        y2.each(x2, function(Pe2) {
          !isNaN(Pe2) && nt++;
        });
        var dt = y2.getSum(x2), vt = Math.PI / (dt || nt) * 2, Ct = d2.get("clockwise"), Pt = d2.get("roseType"), jt = d2.get("stillShowZeroSum"), Rt = y2.getDataExtent(x2);
        Rt[0] = 0;
        var le2 = rmt, ne2 = 0, he2 = Y3, _e = Ct ? 1 : -1;
        if (y2.setLayout({ viewRect: C, r: j }), y2.each(x2, function(Pe2, Be2) {
          var Je2;
          if (isNaN(Pe2)) {
            y2.setItemLayout(Be2, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: Ct, cx: L, cy: F3, r0: U3, r: Pt ? NaN : j });
            return;
          }
          Pt !== "area" ? Je2 = dt === 0 && jt ? vt : Pe2 * vt : Je2 = rmt / nt, Je2 < Q ? (Je2 = Q, le2 -= Q) : ne2 += Pe2;
          var Ze2 = he2 + _e * Je2;
          y2.setItemLayout(Be2, { angle: Je2, startAngle: he2, endAngle: Ze2, clockwise: Ct, cx: L, cy: F3, r0: U3, r: Pt ? yp(Pe2, Rt, [U3, j]) : j }), he2 = Ze2;
        }), le2 < rmt && nt)
          if (le2 <= 1e-3) {
            var Me2 = rmt / nt;
            y2.each(x2, function(Pe2, Be2) {
              if (!isNaN(Pe2)) {
                var Je2 = y2.getItemLayout(Be2);
                Je2.angle = Me2, Je2.startAngle = Y3 + _e * Be2 * Me2, Je2.endAngle = Y3 + _e * (Be2 + 1) * Me2;
              }
            });
          } else
            vt = le2 / ne2, he2 = Y3, y2.each(x2, function(Pe2, Be2) {
              if (!isNaN(Pe2)) {
                var Je2 = y2.getItemLayout(Be2), Ze2 = Je2.angle === Q ? Q : Pe2 * vt;
                Je2.startAngle = he2, Je2.endAngle = he2 + _e * Ze2, he2 += _e * Ze2;
              }
            });
      });
    }
    function Grt(l2) {
      return { seriesType: l2, reset: function(a, e2) {
        var d2 = e2.findComponents({ mainType: "legend" });
        if (!(!d2 || !d2.length)) {
          var y2 = a.getData();
          y2.filterSelf(function(x2) {
            for (var C = y2.getName(x2), D2 = 0; D2 < d2.length; D2++)
              if (!d2[D2].isSelected(C))
                return false;
            return true;
          });
        }
      } };
    }
    var ptn = Math.PI / 180;
    function Ole(l2, a, e2, d2, y2, x2, C, D2, L, F3) {
      if (l2.length < 2)
        return;
      function j(dt) {
        for (var vt = dt.rB, Ct = vt * vt, Pt = 0; Pt < dt.list.length; Pt++) {
          var jt = dt.list[Pt], Rt = Math.abs(jt.label.y - e2), le2 = d2 + jt.len, ne2 = le2 * le2, he2 = Math.sqrt((1 - Math.abs(Rt * Rt / Ct)) * ne2), _e = a + (he2 + jt.len2) * y2, Me2 = _e - jt.label.x, Pe2 = jt.targetTextWidth - Me2 * y2;
          Rle(jt, Pe2, true), jt.label.x = _e;
        }
      }
      function U3(dt) {
        for (var vt = { list: [], maxY: 0 }, Ct = { list: [], maxY: 0 }, Pt = 0; Pt < dt.length; Pt++)
          if (dt[Pt].labelAlignTo === "none") {
            var jt = dt[Pt], Rt = jt.label.y > e2 ? Ct : vt, le2 = Math.abs(jt.label.y - e2);
            if (le2 >= Rt.maxY) {
              var ne2 = jt.label.x - a - jt.len2 * y2, he2 = d2 + jt.len, _e = Math.abs(ne2) < he2 ? Math.sqrt(le2 * le2 / (1 - ne2 * ne2 / he2 / he2)) : he2;
              Rt.rB = _e, Rt.maxY = le2;
            }
            Rt.list.push(jt);
          }
        j(vt), j(Ct);
      }
      for (var Y3 = l2.length, Q = 0; Q < Y3; Q++)
        if (l2[Q].position === "outer" && l2[Q].labelAlignTo === "labelLine") {
          var nt = l2[Q].label.x - F3;
          l2[Q].linePoints[1][0] += nt, l2[Q].label.x = F3;
        }
      Ise(l2, L, L + C) && U3(l2);
    }
    function dtn(l2, a, e2, d2, y2, x2, C, D2) {
      for (var L = [], F3 = [], j = Number.MAX_VALUE, U3 = -Number.MAX_VALUE, Y3 = 0; Y3 < l2.length; Y3++) {
        var Q = l2[Y3].label;
        sOt(l2[Y3]) || (Q.x < a ? (j = Math.min(j, Q.x), L.push(l2[Y3])) : (U3 = Math.max(U3, Q.x), F3.push(l2[Y3])));
      }
      for (var Y3 = 0; Y3 < l2.length; Y3++) {
        var nt = l2[Y3];
        if (!sOt(nt) && nt.linePoints) {
          if (nt.labelStyleWidth != null)
            continue;
          var Q = nt.label, dt = nt.linePoints, vt = void 0;
          nt.labelAlignTo === "edge" ? Q.x < a ? vt = dt[2][0] - nt.labelDistance - C - nt.edgeDistance : vt = C + y2 - nt.edgeDistance - dt[2][0] - nt.labelDistance : nt.labelAlignTo === "labelLine" ? Q.x < a ? vt = j - C - nt.bleedMargin : vt = C + y2 - U3 - nt.bleedMargin : Q.x < a ? vt = Q.x - C - nt.bleedMargin : vt = C + y2 - Q.x - nt.bleedMargin, nt.targetTextWidth = vt, Rle(nt, vt);
        }
      }
      Ole(F3, a, e2, d2, 1, y2, x2, C, D2, U3), Ole(L, a, e2, d2, -1, y2, x2, C, D2, j);
      for (var Y3 = 0; Y3 < l2.length; Y3++) {
        var nt = l2[Y3];
        if (!sOt(nt) && nt.linePoints) {
          var Q = nt.label, dt = nt.linePoints, Ct = nt.labelAlignTo === "edge", Pt = Q.style.padding, jt = Pt ? Pt[1] + Pt[3] : 0, Rt = Q.style.backgroundColor ? 0 : jt, le2 = nt.rect.width + Rt, ne2 = dt[1][0] - dt[2][0];
          Ct ? Q.x < a ? dt[2][0] = C + nt.edgeDistance + le2 + nt.labelDistance : dt[2][0] = C + y2 - nt.edgeDistance - le2 - nt.labelDistance : (Q.x < a ? dt[2][0] = Q.x + nt.labelDistance : dt[2][0] = Q.x - nt.labelDistance, dt[1][0] = dt[2][0] + ne2), dt[1][1] = dt[2][1] = Q.y;
        }
      }
    }
    function Rle(l2, a, e2) {
      if (e2 === void 0 && (e2 = false), l2.labelStyleWidth == null) {
        var d2 = l2.label, y2 = d2.style, x2 = l2.rect, C = y2.backgroundColor, D2 = y2.padding, L = D2 ? D2[1] + D2[3] : 0, F3 = y2.overflow, j = x2.width + (C ? 0 : L);
        if (a < j || e2) {
          var U3 = x2.height;
          if (F3 && F3.match("break")) {
            d2.setStyle("backgroundColor", null), d2.setStyle("width", a - L);
            var Y3 = d2.getBoundingRect();
            d2.setStyle("width", Math.ceil(Y3.width)), d2.setStyle("backgroundColor", C);
          } else {
            var Q = a - L, nt = a < j ? Q : e2 ? Q > l2.unconstrainedWidth ? null : Q : null;
            d2.setStyle("width", nt);
          }
          var dt = d2.getBoundingRect();
          x2.width = dt.width;
          var vt = (d2.style.margin || 0) + 2.1;
          x2.height = dt.height + vt, x2.y -= (x2.height - U3) / 2;
        }
      }
    }
    function sOt(l2) {
      return l2.position === "center";
    }
    function gtn(l2) {
      var a = l2.getData(), e2 = [], d2, y2, x2 = false, C = (l2.get("minShowLabelAngle") || 0) * ptn, D2 = a.getLayout("viewRect"), L = a.getLayout("r"), F3 = D2.width, j = D2.x, U3 = D2.y, Y3 = D2.height;
      function Q(ne2) {
        ne2.ignore = true;
      }
      function nt(ne2) {
        if (!ne2.ignore)
          return true;
        for (var he2 in ne2.states)
          if (ne2.states[he2].ignore === false)
            return true;
        return false;
      }
      a.each(function(ne2) {
        var he2 = a.getItemGraphicEl(ne2), _e = he2.shape, Me2 = he2.getTextContent(), Pe2 = he2.getTextGuideLine(), Be2 = a.getItemModel(ne2), Je2 = Be2.getModel("label"), Ze2 = Je2.get("position") || Be2.get(["emphasis", "label", "position"]), Cn = Je2.get("distanceToLabelLine"), Bn = Je2.get("alignTo"), mn = Ko(Je2.get("edgeDistance"), F3), Kr = Je2.get("bleedMargin"), Kn = Be2.getModel("labelLine"), ar = Kn.get("length");
        ar = Ko(ar, F3);
        var Cr = Kn.get("length2");
        if (Cr = Ko(Cr, F3), Math.abs(_e.endAngle - _e.startAngle) < C) {
          Ke2(Me2.states, Q), Me2.ignore = true;
          return;
        }
        if (nt(Me2)) {
          var ui2 = (_e.startAngle + _e.endAngle) / 2, vi2 = Math.cos(ui2), ko = Math.sin(ui2), Ss, hl, Qs, Js;
          d2 = _e.cx, y2 = _e.cy;
          var rs = Ze2 === "inside" || Ze2 === "inner";
          if (Ze2 === "center")
            Ss = _e.cx, hl = _e.cy, Js = "center";
          else {
            var Gs = (rs ? (_e.r + _e.r0) / 2 * vi2 : _e.r * vi2) + d2, al = (rs ? (_e.r + _e.r0) / 2 * ko : _e.r * ko) + y2;
            if (Ss = Gs + vi2 * 3, hl = al + ko * 3, !rs) {
              var _s = Gs + vi2 * (ar + L - _e.r), Fl = al + ko * (ar + L - _e.r), Ih2 = _s + (vi2 < 0 ? -1 : 1) * Cr, lu = Fl;
              Bn === "edge" ? Ss = vi2 < 0 ? j + mn : j + F3 - mn : Ss = Ih2 + (vi2 < 0 ? -Cn : Cn), hl = lu, Qs = [[Gs, al], [_s, Fl], [Ih2, lu]];
            }
            Js = rs ? "center" : Bn === "edge" ? vi2 > 0 ? "right" : "left" : vi2 > 0 ? "left" : "right";
          }
          var ah2 = Math.PI, Uh2 = 0, Np = Je2.get("rotate");
          if (Ch2(Np))
            Uh2 = Np * (ah2 / 180);
          else if (Ze2 === "center")
            Uh2 = 0;
          else if (Np === "radial" || Np === true) {
            var Zy = vi2 < 0 ? -ui2 + ah2 : -ui2;
            Uh2 = Zy;
          } else if (Np === "tangential" && Ze2 !== "outside" && Ze2 !== "outer") {
            var Nd2 = Math.atan2(vi2, ko);
            Nd2 < 0 && (Nd2 = ah2 * 2 + Nd2);
            var w1 = ko > 0;
            w1 && (Nd2 = ah2 + Nd2), Uh2 = Nd2 - ah2;
          }
          if (x2 = !!Uh2, Me2.x = Ss, Me2.y = hl, Me2.rotation = Uh2, Me2.setStyle({ verticalAlign: "middle" }), rs) {
            Me2.setStyle({ align: Js });
            var Zd2 = Me2.states.select;
            Zd2 && (Zd2.x += Me2.x, Zd2.y += Me2.y);
          } else {
            var Lv = Me2.getBoundingRect().clone();
            Lv.applyTransform(Me2.getComputedTransform());
            var hv = (Me2.style.margin || 0) + 2.1;
            Lv.y -= hv / 2, Lv.height += hv, e2.push({ label: Me2, labelLine: Pe2, position: Ze2, len: ar, len2: Cr, minTurnAngle: Kn.get("minTurnAngle"), maxSurfaceAngle: Kn.get("maxSurfaceAngle"), surfaceNormal: new Nu(vi2, ko), linePoints: Qs, textAlign: Js, labelDistance: Cn, labelAlignTo: Bn, edgeDistance: mn, bleedMargin: Kr, rect: Lv, unconstrainedWidth: Lv.width, labelStyleWidth: Me2.style.width });
          }
          he2.setTextConfig({ inside: rs });
        }
      }), !x2 && l2.get("avoidLabelOverlap") && dtn(e2, d2, y2, L, F3, Y3, j, U3);
      for (var dt = 0; dt < e2.length; dt++) {
        var vt = e2[dt], Ct = vt.label, Pt = vt.labelLine, jt = isNaN(Ct.x) || isNaN(Ct.y);
        if (Ct) {
          Ct.setStyle({ align: vt.textAlign }), jt && (Ke2(Ct.states, Q), Ct.ignore = true);
          var Rt = Ct.states.select;
          Rt && (Rt.x += Ct.x, Rt.y += Ct.y);
        }
        if (Pt) {
          var le2 = vt.linePoints;
          jt || !le2 ? (Ke2(Pt.states, Q), Pt.ignore = true) : (Mse(le2, vt.minTurnAngle), AQe(le2, vt.surfaceNormal, vt.maxSurfaceAngle), Pt.setShape({ points: le2 }), Ct.__hostTarget.textGuideLineConfig = { anchor: new Nu(le2[0][0], le2[0][1]) });
        }
      }
    }
    function sZ(l2, a, e2) {
      var d2 = l2.get("borderRadius");
      if (d2 == null)
        return e2 ? { cornerRadius: 0 } : null;
      Ba2(d2) || (d2 = [d2, d2, d2, d2]);
      var y2 = Math.abs(a.r || 0 - a.r0 || 0);
      return { cornerRadius: $a2(d2, function(x2) {
        return Tm(x2, y2);
      }) };
    }
    var vtn = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this) || this;
        x2.z2 = 2;
        var C = new qc2();
        return x2.setTextContent(C), x2.updateData(e2, d2, y2, true), x2;
      }
      return a.prototype.updateData = function(e2, d2, y2, x2) {
        var C = this, D2 = e2.hostModel, L = e2.getItemModel(d2), F3 = L.getModel("emphasis"), j = e2.getItemLayout(d2), U3 = la2(sZ(L.getModel("itemStyle"), j, true), j);
        if (isNaN(U3.startAngle)) {
          C.setShape(U3);
          return;
        }
        if (x2) {
          C.setShape(U3);
          var Y3 = D2.getShallow("animationType");
          D2.ecModel.ssr ? (Yg2(C, { scaleX: 0, scaleY: 0 }, D2, { dataIndex: d2, isFrom: true }), C.originX = U3.cx, C.originY = U3.cy) : Y3 === "scale" ? (C.shape.r = j.r0, Yg2(C, { shape: { r: j.r } }, D2, d2)) : y2 != null ? (C.setShape({ startAngle: y2, endAngle: y2 }), Yg2(C, { shape: { startAngle: j.startAngle, endAngle: j.endAngle } }, D2, d2)) : (C.shape.endAngle = j.startAngle, Yf2(C, { shape: { endAngle: j.endAngle } }, D2, d2));
        } else
          pC(C), Yf2(C, { shape: U3 }, D2, d2);
        C.useStyle(e2.getItemVisual(d2, "style")), Gy(C, L);
        var Q = (j.startAngle + j.endAngle) / 2, nt = D2.get("selectedOffset"), dt = Math.cos(Q) * nt, vt = Math.sin(Q) * nt, Ct = L.getShallow("cursor");
        Ct && C.attr("cursor", Ct), this._updateLabel(D2, e2, d2), C.ensureState("emphasis").shape = la2({ r: j.r + (F3.get("scale") && F3.get("scaleSize") || 0) }, sZ(F3.getModel("itemStyle"), j)), la2(C.ensureState("select"), { x: dt, y: vt, shape: sZ(L.getModel(["select", "itemStyle"]), j) }), la2(C.ensureState("blur"), { shape: sZ(L.getModel(["blur", "itemStyle"]), j) });
        var Pt = C.getTextGuideLine(), jt = C.getTextContent();
        Pt && la2(Pt.ensureState("select"), { x: dt, y: vt }), la2(jt.ensureState("select"), { x: dt, y: vt }), n0(this, F3.get("focus"), F3.get("blurScope"), F3.get("disabled"));
      }, a.prototype._updateLabel = function(e2, d2, y2) {
        var x2 = this, C = d2.getItemModel(y2), D2 = C.getModel("labelLine"), L = d2.getItemVisual(y2, "style"), F3 = L && L.fill, j = L && L.opacity;
        ow(x2, Sb2(C), { labelFetcher: d2.hostModel, labelDataIndex: y2, inheritColor: F3, defaultOpacity: j, defaultText: e2.getFormattedLabel(y2, "normal") || d2.getName(y2) });
        var U3 = x2.getTextContent();
        x2.setTextConfig({ position: null, rotation: null }), U3.attr({ z2: 10 });
        var Y3 = e2.get(["label", "position"]);
        if (Y3 !== "outside" && Y3 !== "outer")
          x2.removeTextGuideLine();
        else {
          var Q = this.getTextGuideLine();
          Q || (Q = new iw(), this.setTextGuideLine(Q)), jLt(this, WLt(C), { stroke: F3, opacity: uv(D2.get(["lineStyle", "opacity"]), j, 1) });
        }
      }, a;
    }(nw), ytn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.ignoreLabelLineUpdate = true, e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        var C = e2.getData(), D2 = this._data, L = this.group, F3;
        if (!D2 && C.count() > 0) {
          for (var j = C.getItemLayout(0), U3 = 1; isNaN(j && j.startAngle) && U3 < C.count(); ++U3)
            j = C.getItemLayout(U3);
          j && (F3 = j.startAngle);
        }
        if (this._emptyCircleSector && L.remove(this._emptyCircleSector), C.count() === 0 && e2.get("showEmptyCircle")) {
          var Y3 = new nw({ shape: Lle(e2, y2) });
          Y3.useStyle(e2.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = Y3, L.add(Y3);
        }
        C.diff(D2).add(function(Q) {
          var nt = new vtn(C, Q, F3);
          C.setItemGraphicEl(Q, nt), L.add(nt);
        }).update(function(Q, nt) {
          var dt = D2.getItemGraphicEl(nt);
          dt.updateData(C, Q, F3), dt.off("click"), L.add(dt), C.setItemGraphicEl(Q, dt);
        }).remove(function(Q) {
          var nt = D2.getItemGraphicEl(Q);
          JV(nt, e2, Q);
        }).execute(), gtn(e2), e2.get("animationTypeUpdate") !== "expansion" && (this._data = C);
      }, a.prototype.dispose = function() {
      }, a.prototype.containPoint = function(e2, d2) {
        var y2 = d2.getData(), x2 = y2.getItemLayout(0);
        if (x2) {
          var C = e2[0] - x2.cx, D2 = e2[1] - x2.cy, L = Math.sqrt(C * C + D2 * D2);
          return L <= x2.r && L >= x2.r0;
        }
      }, a.type = "pie", a;
    }(pg2), mtn = ytn;
    function lZ(l2, a, e2) {
      a = Ba2(a) && { coordDimensions: a } || la2({ encodeDefine: l2.getEncode() }, a);
      var d2 = l2.getSource(), y2 = Ert(d2, a).dimensions, x2 = new jS(y2, l2);
      return x2.initData(d2, e2), x2;
    }
    var btn = function() {
      function l2(a, e2) {
        this._getDataWithEncodedVisual = a, this._getRawData = e2;
      }
      return l2.prototype.getAllNames = function() {
        var a = this._getRawData();
        return a.mapArray(a.getName);
      }, l2.prototype.containName = function(a) {
        var e2 = this._getRawData();
        return e2.indexOfName(a) >= 0;
      }, l2.prototype.indexOfName = function(a) {
        var e2 = this._getDataWithEncodedVisual();
        return e2.indexOfName(a);
      }, l2.prototype.getItemVisual = function(a, e2) {
        var d2 = this._getDataWithEncodedVisual();
        return d2.getItemVisual(a, e2);
      }, l2;
    }(), Hrt = btn, _tn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.init = function(e2) {
        l2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Hrt(As(this.getData, this), As(this.getRawData, this)), this._defaultLabelLine(e2);
      }, a.prototype.mergeOption = function() {
        l2.prototype.mergeOption.apply(this, arguments);
      }, a.prototype.getInitialData = function() {
        return lZ(this, { coordDimensions: ["value"], encodeDefaulter: xu(R3t, this) });
      }, a.prototype.getDataParams = function(e2) {
        var d2 = this.getData(), y2 = l2.prototype.getDataParams.call(this, e2), x2 = [];
        return d2.each(d2.mapDimension("value"), function(C) {
          x2.push(C);
        }), y2.percent = Bvt(x2, e2, d2.hostModel.get("percentPrecision")), y2.$vars.push("percent"), y2;
      }, a.prototype._defaultLabelLine = function(e2) {
        RS(e2, "labelLine", ["show"]);
        var d2 = e2.labelLine, y2 = e2.emphasis.labelLine;
        d2.show = d2.show && e2.label.show, y2.show = y2.show && e2.emphasis.label.show;
      }, a.type = "series.pie", a.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, a;
    }(Pv), xtn = _tn;
    function wtn(l2) {
      return { seriesType: l2, reset: function(a, e2) {
        var d2 = a.getData();
        d2.filterSelf(function(y2) {
          var x2 = d2.mapDimension("value"), C = d2.get(x2, y2);
          return !(Ch2(C) && !isNaN(C) && C < 0);
        });
      } };
    }
    function Stn(l2) {
      l2.registerChartView(mtn), l2.registerSeriesModel(xtn), zae("pie", l2.registerAction), l2.registerLayout(xu(htn, "pie")), l2.registerProcessor(Grt("pie")), l2.registerProcessor(wtn("pie"));
    }
    var Mtn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.hasSymbolVisual = true, e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        return PO(null, this, { useEncodeDefaulter: true });
      }, a.prototype.getProgressive = function() {
        var e2 = this.option.progressive;
        return e2 == null ? this.option.large ? 5e3 : this.get("progressive") : e2;
      }, a.prototype.getProgressiveThreshold = function() {
        var e2 = this.option.progressiveThreshold;
        return e2 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : e2;
      }, a.prototype.brushSelector = function(e2, d2, y2) {
        return y2.point(d2.getItemLayout(e2));
      }, a.prototype.getZLevelKey = function() {
        return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
      }, a.type = "series.scatter", a.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, a;
    }(Pv), Ctn = Mtn, Nle = 4, Ttn = function() {
      function l2() {
      }
      return l2;
    }(), Atn = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2._off = 0, d2.hoverDataIdx = -1, d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new Ttn();
      }, a.prototype.reset = function() {
        this.notClear = false, this._off = 0;
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.points, x2 = d2.size, C = this.symbolProxy, D2 = C.shape, L = e2.getContext ? e2.getContext() : e2, F3 = L && x2[0] < Nle, j = this.softClipShape, U3;
        if (F3) {
          this._ctx = L;
          return;
        }
        for (this._ctx = null, U3 = this._off; U3 < y2.length; ) {
          var Y3 = y2[U3++], Q = y2[U3++];
          isNaN(Y3) || isNaN(Q) || j && !j.contain(Y3, Q) || (D2.x = Y3 - x2[0] / 2, D2.y = Q - x2[1] / 2, D2.width = x2[0], D2.height = x2[1], C.buildPath(e2, D2, true));
        }
        this.incremental && (this._off = U3, this.notClear = true);
      }, a.prototype.afterBrush = function() {
        var e2 = this.shape, d2 = e2.points, y2 = e2.size, x2 = this._ctx, C = this.softClipShape, D2;
        if (x2) {
          for (D2 = this._off; D2 < d2.length; ) {
            var L = d2[D2++], F3 = d2[D2++];
            isNaN(L) || isNaN(F3) || C && !C.contain(L, F3) || x2.fillRect(L - y2[0] / 2, F3 - y2[1] / 2, y2[0], y2[1]);
          }
          this.incremental && (this._off = D2, this.notClear = true);
        }
      }, a.prototype.findDataIndex = function(e2, d2) {
        for (var y2 = this.shape, x2 = y2.points, C = y2.size, D2 = Math.max(C[0], 4), L = Math.max(C[1], 4), F3 = x2.length / 2 - 1; F3 >= 0; F3--) {
          var j = F3 * 2, U3 = x2[j] - D2 / 2, Y3 = x2[j + 1] - L / 2;
          if (e2 >= U3 && d2 >= Y3 && e2 <= U3 + D2 && d2 <= Y3 + L)
            return F3;
        }
        return -1;
      }, a.prototype.contain = function(e2, d2) {
        var y2 = this.transformCoordToLocal(e2, d2), x2 = this.getBoundingRect();
        if (e2 = y2[0], d2 = y2[1], x2.contain(e2, d2)) {
          var C = this.hoverDataIdx = this.findDataIndex(e2, d2);
          return C >= 0;
        }
        return this.hoverDataIdx = -1, false;
      }, a.prototype.getBoundingRect = function() {
        var e2 = this._rect;
        if (!e2) {
          for (var d2 = this.shape, y2 = d2.points, x2 = d2.size, C = x2[0], D2 = x2[1], L = 1 / 0, F3 = 1 / 0, j = -1 / 0, U3 = -1 / 0, Y3 = 0; Y3 < y2.length; ) {
            var Q = y2[Y3++], nt = y2[Y3++];
            L = Math.min(Q, L), j = Math.max(Q, j), F3 = Math.min(nt, F3), U3 = Math.max(nt, U3);
          }
          e2 = this._rect = new Yu(L - C / 2, F3 - D2 / 2, j - L + C, U3 - F3 + D2);
        }
        return e2;
      }, a;
    }(wc2), Itn = function() {
      function l2() {
        this.group = new ou();
      }
      return l2.prototype.updateData = function(a, e2) {
        this._clear();
        var d2 = this._create();
        d2.setShape({ points: a.getLayout("points") }), this._setCommon(d2, a, e2);
      }, l2.prototype.updateLayout = function(a) {
        var e2 = a.getLayout("points");
        this.group.eachChild(function(d2) {
          if (d2.startIndex != null) {
            var y2 = (d2.endIndex - d2.startIndex) * 2, x2 = d2.startIndex * 4 * 2;
            e2 = new Float32Array(e2.buffer, x2, y2);
          }
          d2.setShape("points", e2), d2.reset();
        });
      }, l2.prototype.incrementalPrepareUpdate = function(a) {
        this._clear();
      }, l2.prototype.incrementalUpdate = function(a, e2, d2) {
        var y2 = this._newAdded[0], x2 = e2.getLayout("points"), C = y2 && y2.shape.points;
        if (C && C.length < 2e4) {
          var D2 = C.length, L = new Float32Array(D2 + x2.length);
          L.set(C), L.set(x2, D2), y2.endIndex = a.end, y2.setShape({ points: L });
        } else {
          this._newAdded = [];
          var F3 = this._create();
          F3.startIndex = a.start, F3.endIndex = a.end, F3.incremental = true, F3.setShape({ points: x2 }), this._setCommon(F3, e2, d2);
        }
      }, l2.prototype.eachRendered = function(a) {
        this._newAdded[0] && a(this._newAdded[0]);
      }, l2.prototype._create = function() {
        var a = new Atn({ cursor: "default" });
        return this.group.add(a), this._newAdded.push(a), a;
      }, l2.prototype._setCommon = function(a, e2, d2) {
        var y2 = e2.hostModel;
        d2 = d2 || {};
        var x2 = e2.getVisual("symbolSize");
        a.setShape("size", x2 instanceof Array ? x2 : [x2, x2]), a.softClipShape = d2.clipShape || null, a.symbolProxy = qy(e2.getVisual("symbol"), 0, 0, 0, 0), a.setColor = a.symbolProxy.setColor;
        var C = a.shape.size[0] < Nle;
        a.useStyle(y2.getModel("itemStyle").getItemStyle(C ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
        var D2 = e2.getVisual("style"), L = D2 && D2.fill;
        L && a.setColor(L);
        var F3 = ns(a);
        F3.seriesIndex = y2.seriesIndex, a.on("mousemove", function(j) {
          F3.dataIndex = null;
          var U3 = a.hoverDataIdx;
          U3 >= 0 && (F3.dataIndex = U3 + (a.startIndex || 0));
        });
      }, l2.prototype.remove = function() {
        this._clear();
      }, l2.prototype._clear = function() {
        this._newAdded = [], this.group.removeAll();
      }, l2;
    }(), Dtn = Itn, Etn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this._updateSymbolDraw(x2, e2);
        C.updateData(x2, { clipShape: this._getClipShape(e2) }), this._finished = true;
      }, a.prototype.incrementalPrepareRender = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this._updateSymbolDraw(x2, e2);
        C.incrementalPrepareUpdate(x2), this._finished = false;
      }, a.prototype.incrementalRender = function(e2, d2, y2) {
        this._symbolDraw.incrementalUpdate(e2, d2.getData(), { clipShape: this._getClipShape(d2) }), this._finished = e2.end === d2.getData().count();
      }, a.prototype.updateTransform = function(e2, d2, y2) {
        var x2 = e2.getData();
        if (this.group.dirty(), !this._finished || x2.count() > 1e4)
          return { update: true };
        var C = Wrt("").reset(e2, d2, y2);
        C.progress && C.progress({ start: 0, end: x2.count(), count: x2.count() }, x2), this._symbolDraw.updateLayout(x2);
      }, a.prototype.eachRendered = function(e2) {
        this._symbolDraw && this._symbolDraw.eachRendered(e2);
      }, a.prototype._getClipShape = function(e2) {
        var d2 = e2.coordinateSystem, y2 = d2 && d2.getArea && d2.getArea();
        return e2.get("clip", true) ? y2 : null;
      }, a.prototype._updateSymbolDraw = function(e2, d2) {
        var y2 = this._symbolDraw, x2 = d2.pipelineContext, C = x2.large;
        return (!y2 || C !== this._isLargeDraw) && (y2 && y2.remove(), y2 = this._symbolDraw = C ? new Dtn() : new jrt(), this._isLargeDraw = C, this.group.removeAll()), this.group.add(y2.group), y2;
      }, a.prototype.remove = function(e2, d2) {
        this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
      }, a.prototype.dispose = function() {
      }, a.type = "scatter", a;
    }(pg2), ktn = Etn, Ptn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.type = "grid", a.dependencies = ["xAxis", "yAxis"], a.layoutMode = "box", a.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, a;
    }(Ah2), Ltn = Ptn, lOt = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.getCoordSysModel = function() {
        return this.getReferringComponents("grid", q0).models[0];
      }, a.type = "cartesian2dAxis", a;
    }(Ah2);
    v0(lOt, Lrt);
    var Fle = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, Otn = Mu({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, Fle), uOt = Mu({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, Fle), Rtn = Mu({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, uOt), Ntn = El({ logBase: 10 }, uOt), Vle = { category: Otn, value: uOt, time: Rtn, log: Ntn }, Ftn = { value: 1, category: 1, time: 1, log: 1 };
    function uZ(l2, a, e2, d2) {
      Ke2(Ftn, function(y2, x2) {
        var C = Mu(Mu({}, Vle[x2], true), d2, true), D2 = function(L) {
          Jn(F3, L);
          function F3() {
            var j = L !== null && L.apply(this, arguments) || this;
            return j.type = a + "Axis." + x2, j;
          }
          return F3.prototype.mergeDefaultAndTheme = function(j, U3) {
            var Y3 = srt(this), Q = Y3 ? Hq(j) : {}, nt = U3.getTheme();
            Mu(j, nt.get(x2 + "Axis")), Mu(j, this.getDefaultOption()), j.type = Ble(j), Y3 && $N(j, Q, Y3);
          }, F3.prototype.optionUpdated = function() {
            var j = this.option;
            j.type === "category" && (this.__ordinalMeta = DLt.createByAxisModel(this));
          }, F3.prototype.getCategories = function(j) {
            var U3 = this.option;
            if (U3.type === "category")
              return j ? U3.data : this.__ordinalMeta.categories;
          }, F3.prototype.getOrdinalMeta = function() {
            return this.__ordinalMeta;
          }, F3.type = a + "Axis." + x2, F3.defaultOption = C, F3;
        }(e2);
        l2.registerComponentModel(D2);
      }), l2.registerSubTypeDefaulter(a + "Axis", Ble);
    }
    function Ble(l2) {
      return l2.type || (l2.data ? "category" : "value");
    }
    var Vtn = function() {
      function l2(a) {
        this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = a || "";
      }
      return l2.prototype.getAxis = function(a) {
        return this._axes[a];
      }, l2.prototype.getAxes = function() {
        return $a2(this._dimList, function(a) {
          return this._axes[a];
        }, this);
      }, l2.prototype.getAxesByScale = function(a) {
        return a = a.toLowerCase(), Lp(this.getAxes(), function(e2) {
          return e2.scale.type === a;
        });
      }, l2.prototype.addAxis = function(a) {
        var e2 = a.dim;
        this._axes[e2] = a, this._dimList.push(e2);
      }, l2;
    }(), Btn = Vtn, cOt = ["x", "y"];
    function zle(l2) {
      return l2.type === "interval" || l2.type === "time";
    }
    var ztn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "cartesian2d", e2.dimensions = cOt, e2;
      }
      return a.prototype.calcAffineTransform = function() {
        this._transform = this._invTransform = null;
        var e2 = this.getAxis("x").scale, d2 = this.getAxis("y").scale;
        if (!(!zle(e2) || !zle(d2))) {
          var y2 = e2.getExtent(), x2 = d2.getExtent(), C = this.dataToPoint([y2[0], x2[0]]), D2 = this.dataToPoint([y2[1], x2[1]]), L = y2[1] - y2[0], F3 = x2[1] - x2[0];
          if (!(!L || !F3)) {
            var j = (D2[0] - C[0]) / L, U3 = (D2[1] - C[1]) / F3, Y3 = C[0] - y2[0] * j, Q = C[1] - x2[0] * U3, nt = this._transform = [j, 0, 0, U3, Y3, Q];
            this._invTransform = sO([], nt);
          }
        }
      }, a.prototype.getBaseAxis = function() {
        return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
      }, a.prototype.containPoint = function(e2) {
        var d2 = this.getAxis("x"), y2 = this.getAxis("y");
        return d2.contain(d2.toLocalCoord(e2[0])) && y2.contain(y2.toLocalCoord(e2[1]));
      }, a.prototype.containData = function(e2) {
        return this.getAxis("x").containData(e2[0]) && this.getAxis("y").containData(e2[1]);
      }, a.prototype.dataToPoint = function(e2, d2, y2) {
        y2 = y2 || [];
        var x2 = e2[0], C = e2[1];
        if (this._transform && x2 != null && isFinite(x2) && C != null && isFinite(C))
          return Mm(y2, e2, this._transform);
        var D2 = this.getAxis("x"), L = this.getAxis("y");
        return y2[0] = D2.toGlobalCoord(D2.dataToCoord(x2, d2)), y2[1] = L.toGlobalCoord(L.dataToCoord(C, d2)), y2;
      }, a.prototype.clampData = function(e2, d2) {
        var y2 = this.getAxis("x").scale, x2 = this.getAxis("y").scale, C = y2.getExtent(), D2 = x2.getExtent(), L = y2.parse(e2[0]), F3 = x2.parse(e2[1]);
        return d2 = d2 || [], d2[0] = Math.min(Math.max(Math.min(C[0], C[1]), L), Math.max(C[0], C[1])), d2[1] = Math.min(Math.max(Math.min(D2[0], D2[1]), F3), Math.max(D2[0], D2[1])), d2;
      }, a.prototype.pointToData = function(e2, d2) {
        var y2 = [];
        if (this._invTransform)
          return Mm(y2, e2, this._invTransform);
        var x2 = this.getAxis("x"), C = this.getAxis("y");
        return y2[0] = x2.coordToData(x2.toLocalCoord(e2[0]), d2), y2[1] = C.coordToData(C.toLocalCoord(e2[1]), d2), y2;
      }, a.prototype.getOtherAxis = function(e2) {
        return this.getAxis(e2.dim === "x" ? "y" : "x");
      }, a.prototype.getArea = function() {
        var e2 = this.getAxis("x").getGlobalExtent(), d2 = this.getAxis("y").getGlobalExtent(), y2 = Math.min(e2[0], e2[1]), x2 = Math.min(d2[0], d2[1]), C = Math.max(e2[0], e2[1]) - y2, D2 = Math.max(d2[0], d2[1]) - x2;
        return new Yu(y2, x2, C, D2);
      }, a;
    }(Btn), jtn = ztn, Wtn = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2, C) {
        var D2 = l2.call(this, e2, d2, y2) || this;
        return D2.index = 0, D2.type = x2 || "value", D2.position = C || "bottom", D2;
      }
      return a.prototype.isHorizontal = function() {
        var e2 = this.position;
        return e2 === "top" || e2 === "bottom";
      }, a.prototype.getGlobalExtent = function(e2) {
        var d2 = this.getExtent();
        return d2[0] = this.toGlobalCoord(d2[0]), d2[1] = this.toGlobalCoord(d2[1]), e2 && d2[0] > d2[1] && d2.reverse(), d2;
      }, a.prototype.pointToData = function(e2, d2) {
        return this.coordToData(this.toLocalCoord(e2[this.dim === "x" ? 0 : 1]), d2);
      }, a.prototype.setCategorySortInfo = function(e2) {
        if (this.type !== "category")
          return false;
        this.model.option.categorySortInfo = e2, this.scale.setSortInfo(e2);
      }, a;
    }(kE), Gtn = Wtn;
    function fOt(l2, a, e2) {
      e2 = e2 || {};
      var d2 = l2.coordinateSystem, y2 = a.axis, x2 = {}, C = y2.getAxesOnZeroOf()[0], D2 = y2.position, L = C ? "onZero" : D2, F3 = y2.dim, j = d2.getRect(), U3 = [j.x, j.x + j.width, j.y, j.y + j.height], Y3 = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, Q = a.get("offset") || 0, nt = F3 === "x" ? [U3[2] - Q, U3[3] + Q] : [U3[0] - Q, U3[1] + Q];
      if (C) {
        var dt = C.toGlobalCoord(C.dataToCoord(0));
        nt[Y3.onZero] = Math.max(Math.min(dt, nt[1]), nt[0]);
      }
      x2.position = [F3 === "y" ? nt[Y3[L]] : U3[0], F3 === "x" ? nt[Y3[L]] : U3[3]], x2.rotation = Math.PI / 2 * (F3 === "x" ? 0 : 1);
      var vt = { top: -1, bottom: 1, left: -1, right: 1 };
      x2.labelDirection = x2.tickDirection = x2.nameDirection = vt[D2], x2.labelOffset = C ? nt[Y3[D2]] - nt[Y3.onZero] : 0, a.get(["axisTick", "inside"]) && (x2.tickDirection = -x2.tickDirection), jy(e2.labelInside, a.get(["axisLabel", "inside"])) && (x2.labelDirection = -x2.labelDirection);
      var Ct = a.get(["axisLabel", "rotate"]);
      return x2.labelRotate = L === "top" ? -Ct : Ct, x2.z2 = 1, x2;
    }
    function jle(l2) {
      return l2.get("coordinateSystem") === "cartesian2d";
    }
    function Wle(l2) {
      var a = { xAxisModel: null, yAxisModel: null };
      return Ke2(a, function(e2, d2) {
        var y2 = d2.replace(/Model$/, ""), x2 = l2.getReferringComponents(y2, q0).models[0];
        a[d2] = x2;
      }), a;
    }
    var hOt = Math.log;
    function Gle(l2, a, e2) {
      var d2 = eF.prototype, y2 = d2.getTicks.call(e2), x2 = d2.getTicks.call(e2, true), C = y2.length - 1, D2 = d2.getInterval.call(e2), L = ase(l2, a), F3 = L.extent, j = L.fixMin, U3 = L.fixMax;
      if (l2.type === "log") {
        var Y3 = hOt(l2.base);
        F3 = [hOt(F3[0]) / Y3, hOt(F3[1]) / Y3];
      }
      l2.setExtent(F3[0], F3[1]), l2.calcNiceExtent({ splitNumber: C, fixMin: j, fixMax: U3 });
      var Q = d2.getExtent.call(l2);
      j && (F3[0] = Q[0]), U3 && (F3[1] = Q[1]);
      var nt = d2.getInterval.call(l2), dt = F3[0], vt = F3[1];
      if (j && U3)
        nt = (vt - dt) / C;
      else if (j)
        for (vt = F3[0] + nt * C; vt < F3[1] && isFinite(vt) && isFinite(F3[1]); )
          nt = kLt(nt), vt = F3[0] + nt * C;
      else if (U3)
        for (dt = F3[1] - nt * C; dt > F3[0] && isFinite(dt) && isFinite(F3[0]); )
          nt = kLt(nt), dt = F3[1] - nt * C;
      else {
        var Ct = l2.getTicks().length - 1;
        Ct > C && (nt = kLt(nt));
        var Pt = nt * C;
        vt = Math.ceil(F3[1] / nt) * nt, dt = kv(vt - Pt), dt < 0 && F3[0] >= 0 ? (dt = 0, vt = kv(Pt)) : vt > 0 && F3[1] <= 0 && (vt = 0, dt = -kv(Pt));
      }
      var jt = (y2[0].value - x2[0].value) / D2, Rt = (y2[C].value - x2[C].value) / D2;
      d2.setExtent.call(l2, dt + nt * jt, vt + nt * Rt), d2.setInterval.call(l2, nt), (jt || Rt) && d2.setNiceExtent.call(l2, dt + nt, vt - nt);
    }
    var Htn = function() {
      function l2(a, e2, d2) {
        this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = cOt, this._initCartesian(a, e2, d2), this.model = a;
      }
      return l2.prototype.getRect = function() {
        return this._rect;
      }, l2.prototype.update = function(a, e2) {
        var d2 = this._axesMap;
        this._updateScale(a, this.model);
        function y2(C) {
          var D2, L = Qc2(C), F3 = L.length;
          if (F3) {
            for (var j = [], U3 = F3 - 1; U3 >= 0; U3--) {
              var Y3 = +L[U3], Q = C[Y3], nt = Q.model, dt = Q.scale;
              ELt(dt) && nt.get("alignTicks") && nt.get("interval") == null ? j.push(Q) : (iZ(dt, nt), ELt(dt) && (D2 = Q));
            }
            j.length && (D2 || (D2 = j.pop(), iZ(D2.scale, D2.model)), Ke2(j, function(vt) {
              Gle(vt.scale, vt.model, D2.scale);
            }));
          }
        }
        y2(d2.x), y2(d2.y);
        var x2 = {};
        Ke2(d2.x, function(C) {
          Hle(d2, "y", C, x2);
        }), Ke2(d2.y, function(C) {
          Hle(d2, "x", C, x2);
        }), this.resize(this.model, e2);
      }, l2.prototype.resize = function(a, e2, d2) {
        var y2 = a.getBoxLayoutParams(), x2 = !d2 && a.get("containLabel"), C = Em(y2, { width: e2.getWidth(), height: e2.getHeight() });
        this._rect = C;
        var D2 = this._axesList;
        L(), x2 && (Ke2(D2, function(F3) {
          if (!F3.model.get(["axisLabel", "inside"])) {
            var j = rQe(F3);
            if (j) {
              var U3 = F3.isHorizontal() ? "height" : "width", Y3 = F3.model.get(["axisLabel", "margin"]);
              C[U3] -= j[U3] + Y3, F3.position === "top" ? C.y += j.height + Y3 : F3.position === "left" && (C.x += j.width + Y3);
            }
          }
        }), L()), Ke2(this._coordsList, function(F3) {
          F3.calcAffineTransform();
        });
        function L() {
          Ke2(D2, function(F3) {
            var j = F3.isHorizontal(), U3 = j ? [0, C.width] : [0, C.height], Y3 = F3.inverse ? 1 : 0;
            F3.setExtent(U3[Y3], U3[1 - Y3]), Utn(F3, j ? C.x : C.y);
          });
        }
      }, l2.prototype.getAxis = function(a, e2) {
        var d2 = this._axesMap[a];
        if (d2 != null)
          return d2[e2 || 0];
      }, l2.prototype.getAxes = function() {
        return this._axesList.slice();
      }, l2.prototype.getCartesian = function(a, e2) {
        if (a != null && e2 != null) {
          var d2 = "x" + a + "y" + e2;
          return this._coordsMap[d2];
        }
        vs(a) && (e2 = a.yAxisIndex, a = a.xAxisIndex);
        for (var y2 = 0, x2 = this._coordsList; y2 < x2.length; y2++)
          if (x2[y2].getAxis("x").index === a || x2[y2].getAxis("y").index === e2)
            return x2[y2];
      }, l2.prototype.getCartesians = function() {
        return this._coordsList.slice();
      }, l2.prototype.convertToPixel = function(a, e2, d2) {
        var y2 = this._findConvertTarget(e2);
        return y2.cartesian ? y2.cartesian.dataToPoint(d2) : y2.axis ? y2.axis.toGlobalCoord(y2.axis.dataToCoord(d2)) : null;
      }, l2.prototype.convertFromPixel = function(a, e2, d2) {
        var y2 = this._findConvertTarget(e2);
        return y2.cartesian ? y2.cartesian.pointToData(d2) : y2.axis ? y2.axis.coordToData(y2.axis.toLocalCoord(d2)) : null;
      }, l2.prototype._findConvertTarget = function(a) {
        var e2 = a.seriesModel, d2 = a.xAxisModel || e2 && e2.getReferringComponents("xAxis", q0).models[0], y2 = a.yAxisModel || e2 && e2.getReferringComponents("yAxis", q0).models[0], x2 = a.gridModel, C = this._coordsList, D2, L;
        if (e2)
          D2 = e2.coordinateSystem, oc2(C, D2) < 0 && (D2 = null);
        else if (d2 && y2)
          D2 = this.getCartesian(d2.componentIndex, y2.componentIndex);
        else if (d2)
          L = this.getAxis("x", d2.componentIndex);
        else if (y2)
          L = this.getAxis("y", y2.componentIndex);
        else if (x2) {
          var F3 = x2.coordinateSystem;
          F3 === this && (D2 = this._coordsList[0]);
        }
        return { cartesian: D2, axis: L };
      }, l2.prototype.containPoint = function(a) {
        var e2 = this._coordsList[0];
        if (e2)
          return e2.containPoint(a);
      }, l2.prototype._initCartesian = function(a, e2, d2) {
        var y2 = this, x2 = this, C = { left: false, right: false, top: false, bottom: false }, D2 = { x: {}, y: {} }, L = { x: 0, y: 0 };
        if (e2.eachComponent("xAxis", F3("x"), this), e2.eachComponent("yAxis", F3("y"), this), !L.x || !L.y) {
          this._axesMap = {}, this._axesList = [];
          return;
        }
        this._axesMap = D2, Ke2(D2.x, function(j, U3) {
          Ke2(D2.y, function(Y3, Q) {
            var nt = "x" + U3 + "y" + Q, dt = new jtn(nt);
            dt.master = y2, dt.model = a, y2._coordsMap[nt] = dt, y2._coordsList.push(dt), dt.addAxis(j), dt.addAxis(Y3);
          });
        });
        function F3(j) {
          return function(U3, Y3) {
            if (pOt(U3, a)) {
              var Q = U3.get("position");
              j === "x" ? Q !== "top" && Q !== "bottom" && (Q = C.bottom ? "top" : "bottom") : Q !== "left" && Q !== "right" && (Q = C.left ? "right" : "left"), C[Q] = true;
              var nt = new Gtn(j, Wyt(U3), [0, 0], U3.get("type"), Q), dt = nt.type === "category";
              nt.onBand = dt && U3.get("boundaryGap"), nt.inverse = U3.get("inverse"), U3.axis = nt, nt.model = U3, nt.grid = x2, nt.index = Y3, x2._axesList.push(nt), D2[j][Y3] = nt, L[j]++;
            }
          };
        }
      }, l2.prototype._updateScale = function(a, e2) {
        Ke2(this._axesList, function(y2) {
          if (y2.scale.setExtent(1 / 0, -1 / 0), y2.type === "category") {
            var x2 = y2.model.get("categorySortInfo");
            y2.scale.setSortInfo(x2);
          }
        }), a.eachSeries(function(y2) {
          if (jle(y2)) {
            var x2 = Wle(y2), C = x2.xAxisModel, D2 = x2.yAxisModel;
            if (!pOt(C, e2) || !pOt(D2, e2))
              return;
            var L = this.getCartesian(C.componentIndex, D2.componentIndex), F3 = y2.getData(), j = L.getAxis("x"), U3 = L.getAxis("y");
            d2(F3, j), d2(F3, U3);
          }
        }, this);
        function d2(y2, x2) {
          Ke2(Gyt(y2, x2.dim), function(C) {
            x2.scale.unionExtentFromData(y2, C);
          });
        }
      }, l2.prototype.getTooltipAxes = function(a) {
        var e2 = [], d2 = [];
        return Ke2(this.getCartesians(), function(y2) {
          var x2 = a != null && a !== "auto" ? y2.getAxis(a) : y2.getBaseAxis(), C = y2.getOtherAxis(x2);
          oc2(e2, x2) < 0 && e2.push(x2), oc2(d2, C) < 0 && d2.push(C);
        }), { baseAxes: e2, otherAxes: d2 };
      }, l2.create = function(a, e2) {
        var d2 = [];
        return a.eachComponent("grid", function(y2, x2) {
          var C = new l2(y2, a, e2);
          C.name = "grid_" + x2, C.resize(y2, e2, true), y2.coordinateSystem = C, d2.push(C);
        }), a.eachSeries(function(y2) {
          if (jle(y2)) {
            var x2 = Wle(y2), C = x2.xAxisModel, D2 = x2.yAxisModel, L = C.getCoordSysModel(), F3 = L.coordinateSystem;
            y2.coordinateSystem = F3.getCartesian(C.componentIndex, D2.componentIndex);
          }
        }), d2;
      }, l2.dimensions = cOt, l2;
    }();
    function pOt(l2, a) {
      return l2.getCoordSysModel() === a;
    }
    function Hle(l2, a, e2, d2) {
      e2.getAxesOnZeroOf = function() {
        return x2 ? [x2] : [];
      };
      var y2 = l2[a], x2, C = e2.model, D2 = C.get(["axisLine", "onZero"]), L = C.get(["axisLine", "onZeroAxisIndex"]);
      if (!D2)
        return;
      if (L != null)
        Ule(y2[L]) && (x2 = y2[L]);
      else
        for (var F3 in y2)
          if (y2.hasOwnProperty(F3) && Ule(y2[F3]) && !d2[j(y2[F3])]) {
            x2 = y2[F3];
            break;
          }
      x2 && (d2[j(x2)] = true);
      function j(U3) {
        return U3.dim + "_" + U3.index;
      }
    }
    function Ule(l2) {
      return l2 && l2.type !== "category" && l2.type !== "time" && nQe(l2);
    }
    function Utn(l2, a) {
      var e2 = l2.getExtent(), d2 = e2[0] + e2[1];
      l2.toGlobalCoord = l2.dim === "x" ? function(y2) {
        return y2 + a;
      } : function(y2) {
        return d2 - y2 + a;
      }, l2.toLocalCoord = l2.dim === "x" ? function(y2) {
        return y2 - a;
      } : function(y2) {
        return d2 - y2 + a;
      };
    }
    var qtn = Htn, aF = Math.PI, mB = function() {
      function l2(a, e2) {
        this.group = new ou(), this.opt = e2, this.axisModel = a, El(e2, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
          return true;
        } });
        var d2 = new ou({ x: e2.position[0], y: e2.position[1], rotation: e2.rotation });
        d2.updateTransform(), this._transformGroup = d2;
      }
      return l2.prototype.hasBuilder = function(a) {
        return !!qle[a];
      }, l2.prototype.add = function(a) {
        qle[a](this.opt, this.axisModel, this.group, this._transformGroup);
      }, l2.prototype.getGroup = function() {
        return this.group;
      }, l2.innerTextLayout = function(a, e2, d2) {
        var y2 = rq(e2 - a), x2, C;
        return iq(y2) ? (C = d2 > 0 ? "top" : "bottom", x2 = "center") : iq(y2 - aF) ? (C = d2 > 0 ? "bottom" : "top", x2 = "center") : (C = "middle", y2 > 0 && y2 < aF ? x2 = d2 > 0 ? "right" : "left" : x2 = d2 > 0 ? "left" : "right"), { rotation: y2, textAlign: x2, textVerticalAlign: C };
      }, l2.makeAxisEventDataBase = function(a) {
        var e2 = { componentType: a.mainType, componentIndex: a.componentIndex };
        return e2[a.mainType + "Index"] = a.componentIndex, e2;
      }, l2.isLabelSilent = function(a) {
        var e2 = a.get("tooltip");
        return a.get("silent") || !(a.get("triggerEvent") || e2 && e2.show);
      }, l2;
    }(), qle = { axisLine: function(l2, a, e2, d2) {
      var y2 = a.get(["axisLine", "show"]);
      if (y2 === "auto" && l2.handleAutoShown && (y2 = l2.handleAutoShown("axisLine")), !!y2) {
        var x2 = a.axis.getExtent(), C = d2.transform, D2 = [x2[0], 0], L = [x2[1], 0];
        C && (Mm(D2, D2, C), Mm(L, L, C));
        var F3 = la2({ lineCap: "round" }, a.getModel(["axisLine", "lineStyle"]).getLineStyle()), j = new by({ subPixelOptimize: true, shape: { x1: D2[0], y1: D2[1], x2: L[0], y2: L[1] }, style: F3, strokeContainThreshold: l2.strokeContainThreshold || 5, silent: true, z2: 1 });
        j.anid = "line", e2.add(j);
        var U3 = a.get(["axisLine", "symbol"]);
        if (U3 != null) {
          var Y3 = a.get(["axisLine", "symbolSize"]);
          ps(U3) && (U3 = [U3, U3]), (ps(Y3) || Ch2(Y3)) && (Y3 = [Y3, Y3]);
          var Q = tZ(a.get(["axisLine", "symbolOffset"]) || 0, Y3), nt = Y3[0], dt = Y3[1];
          Ke2([{ rotate: l2.rotation + Math.PI / 2, offset: Q[0], r: 0 }, { rotate: l2.rotation - Math.PI / 2, offset: Q[1], r: Math.sqrt((D2[0] - L[0]) * (D2[0] - L[0]) + (D2[1] - L[1]) * (D2[1] - L[1])) }], function(vt, Ct) {
            if (U3[Ct] !== "none" && U3[Ct] != null) {
              var Pt = qy(U3[Ct], -nt / 2, -dt / 2, nt, dt, F3.stroke, true), jt = vt.r + vt.offset;
              Pt.attr({ rotation: vt.rotate, x: D2[0] + jt * Math.cos(l2.rotation), y: D2[1] - jt * Math.sin(l2.rotation), silent: true, z2: 11 }), e2.add(Pt);
            }
          });
        }
      }
    }, axisTickLabel: function(l2, a, e2, d2) {
      var y2 = Ytn(e2, d2, a, l2), x2 = Xtn(e2, d2, a, l2);
      if ($tn(a, x2, y2), Ktn(e2, d2, a, l2.tickDirection), a.get(["axisLabel", "hideOverlap"])) {
        var C = Tse($a2(x2, function(D2) {
          return { label: D2, priority: D2.z2, defaultAttr: { ignore: D2.ignore } };
        }));
        Dse(C);
      }
    }, axisName: function(l2, a, e2, d2) {
      var y2 = jy(l2.axisName, a.get("name"));
      if (y2) {
        var x2 = a.get("nameLocation"), C = l2.nameDirection, D2 = a.getModel("nameTextStyle"), L = a.get("nameGap") || 0, F3 = a.axis.getExtent(), j = F3[0] > F3[1] ? -1 : 1, U3 = [x2 === "start" ? F3[0] - j * L : x2 === "end" ? F3[1] + j * L : (F3[0] + F3[1]) / 2, $le(x2) ? l2.labelOffset + C * L : 0], Y3, Q = a.get("nameRotate");
        Q != null && (Q = Q * aF / 180);
        var nt;
        $le(x2) ? Y3 = mB.innerTextLayout(l2.rotation, Q != null ? Q : l2.rotation, C) : (Y3 = Ztn(l2.rotation, x2, Q || 0, F3), nt = l2.axisNameAvailableWidth, nt != null && (nt = Math.abs(nt / Math.sin(Y3.rotation)), !isFinite(nt) && (nt = null)));
        var dt = D2.getFont(), vt = a.get("nameTruncate", true) || {}, Ct = vt.ellipsis, Pt = jy(l2.nameTruncateMaxWidth, vt.maxWidth, nt), jt = new qc2({ x: U3[0], y: U3[1], rotation: Y3.rotation, silent: mB.isLabelSilent(a), style: _y(D2, { text: y2, font: dt, overflow: "truncate", width: Pt, ellipsis: Ct, fill: D2.getTextColor() || a.get(["axisLine", "lineStyle", "color"]), align: D2.get("align") || Y3.textAlign, verticalAlign: D2.get("verticalAlign") || Y3.textVerticalAlign }), z2: 1 });
        if (Vq({ el: jt, componentModel: a, itemName: y2 }), jt.__fullText = y2, jt.anid = "name", a.get("triggerEvent")) {
          var Rt = mB.makeAxisEventDataBase(a);
          Rt.targetType = "axisName", Rt.name = y2, ns(jt).eventData = Rt;
        }
        d2.add(jt), jt.updateTransform(), e2.add(jt), jt.decomposeTransform();
      }
    } };
    function Ztn(l2, a, e2, d2) {
      var y2 = rq(e2 - l2), x2, C, D2 = d2[0] > d2[1], L = a === "start" && !D2 || a !== "start" && D2;
      return iq(y2 - aF / 2) ? (C = L ? "bottom" : "top", x2 = "center") : iq(y2 - aF * 1.5) ? (C = L ? "top" : "bottom", x2 = "center") : (C = "middle", y2 < aF * 1.5 && y2 > aF / 2 ? x2 = L ? "left" : "right" : x2 = L ? "right" : "left"), { rotation: y2, textAlign: x2, textVerticalAlign: C };
    }
    function $tn(l2, a, e2) {
      if (!ose(l2.axis)) {
        var d2 = l2.get(["axisLabel", "showMinLabel"]), y2 = l2.get(["axisLabel", "showMaxLabel"]);
        a = a || [], e2 = e2 || [];
        var x2 = a[0], C = a[1], D2 = a[a.length - 1], L = a[a.length - 2], F3 = e2[0], j = e2[1], U3 = e2[e2.length - 1], Y3 = e2[e2.length - 2];
        d2 === false ? (DA(x2), DA(F3)) : Zle(x2, C) && (d2 ? (DA(C), DA(j)) : (DA(x2), DA(F3))), y2 === false ? (DA(D2), DA(U3)) : Zle(L, D2) && (y2 ? (DA(L), DA(Y3)) : (DA(D2), DA(U3)));
      }
    }
    function DA(l2) {
      l2 && (l2.ignore = true);
    }
    function Zle(l2, a) {
      var e2 = l2 && l2.getBoundingRect().clone(), d2 = a && a.getBoundingRect().clone();
      if (!(!e2 || !d2)) {
        var y2 = OV([]);
        return oO(y2, y2, -l2.rotation), e2.applyTransform(lA([], y2, l2.getLocalTransform())), d2.applyTransform(lA([], y2, a.getLocalTransform())), e2.intersect(d2);
      }
    }
    function $le(l2) {
      return l2 === "middle" || l2 === "center";
    }
    function Yle(l2, a, e2, d2, y2) {
      for (var x2 = [], C = [], D2 = [], L = 0; L < l2.length; L++) {
        var F3 = l2[L].coord;
        C[0] = F3, C[1] = 0, D2[0] = F3, D2[1] = e2, a && (Mm(C, C, a), Mm(D2, D2, a));
        var j = new by({ subPixelOptimize: true, shape: { x1: C[0], y1: C[1], x2: D2[0], y2: D2[1] }, style: d2, z2: 2, autoBatch: true, silent: true });
        j.anid = y2 + "_" + l2[L].tickValue, x2.push(j);
      }
      return x2;
    }
    function Ytn(l2, a, e2, d2) {
      var y2 = e2.axis, x2 = e2.getModel("axisTick"), C = x2.get("show");
      if (C === "auto" && d2.handleAutoShown && (C = d2.handleAutoShown("axisTick")), !(!C || y2.scale.isBlank())) {
        for (var D2 = x2.getModel("lineStyle"), L = d2.tickDirection * x2.get("length"), F3 = y2.getTicksCoords(), j = Yle(F3, a.transform, L, El(D2.getLineStyle(), { stroke: e2.get(["axisLine", "lineStyle", "color"]) }), "ticks"), U3 = 0; U3 < j.length; U3++)
          l2.add(j[U3]);
        return j;
      }
    }
    function Ktn(l2, a, e2, d2) {
      var y2 = e2.axis, x2 = e2.getModel("minorTick");
      if (!(!x2.get("show") || y2.scale.isBlank())) {
        var C = y2.getMinorTicksCoords();
        if (C.length)
          for (var D2 = x2.getModel("lineStyle"), L = d2 * x2.get("length"), F3 = El(D2.getLineStyle(), El(e2.getModel("axisTick").getLineStyle(), { stroke: e2.get(["axisLine", "lineStyle", "color"]) })), j = 0; j < C.length; j++)
            for (var U3 = Yle(C[j], a.transform, L, F3, "minorticks_" + j), Y3 = 0; Y3 < U3.length; Y3++)
              l2.add(U3[Y3]);
      }
    }
    function Xtn(l2, a, e2, d2) {
      var y2 = e2.axis, x2 = jy(d2.axisLabelShow, e2.get(["axisLabel", "show"]));
      if (!(!x2 || y2.scale.isBlank())) {
        var C = e2.getModel("axisLabel"), D2 = C.get("margin"), L = y2.getViewLabels(), F3 = (jy(d2.labelRotate, C.get("rotate")) || 0) * aF / 180, j = mB.innerTextLayout(d2.rotation, F3, d2.labelDirection), U3 = e2.getCategories && e2.getCategories(true), Y3 = [], Q = mB.isLabelSilent(e2), nt = e2.get("triggerEvent");
        return Ke2(L, function(dt, vt) {
          var Ct = y2.scale.type === "ordinal" ? y2.scale.getRawOrdinalNumber(dt.tickValue) : dt.tickValue, Pt = dt.formattedLabel, jt = dt.rawLabel, Rt = C;
          if (U3 && U3[Ct]) {
            var le2 = U3[Ct];
            vs(le2) && le2.textStyle && (Rt = new hg2(le2.textStyle, C, e2.ecModel));
          }
          var ne2 = Rt.getTextColor() || e2.get(["axisLine", "lineStyle", "color"]), he2 = y2.dataToCoord(Ct), _e = new qc2({ x: he2, y: d2.labelOffset + d2.labelDirection * D2, rotation: j.rotation, silent: Q, z2: 10 + (dt.level || 0), style: _y(Rt, { text: Pt, align: Rt.getShallow("align", true) || j.textAlign, verticalAlign: Rt.getShallow("verticalAlign", true) || Rt.getShallow("baseline", true) || j.textVerticalAlign, fill: wl(ne2) ? ne2(y2.type === "category" ? jt : y2.type === "value" ? Ct + "" : Ct, vt) : ne2 }) });
          if (_e.anid = "label_" + Ct, nt) {
            var Me2 = mB.makeAxisEventDataBase(e2);
            Me2.targetType = "axisLabel", Me2.value = jt, Me2.tickIndex = vt, y2.type === "category" && (Me2.dataIndex = Ct), ns(_e).eventData = Me2;
          }
          a.add(_e), _e.updateTransform(), Y3.push(_e), l2.add(_e), _e.decomposeTransform();
        }), Y3;
      }
    }
    var RO = mB;
    function Qtn(l2, a) {
      var e2 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
      return Jtn(e2, l2, a), e2.seriesInvolved && een(e2, l2), e2;
    }
    function Jtn(l2, a, e2) {
      var d2 = a.getComponent("tooltip"), y2 = a.getComponent("axisPointer"), x2 = y2.get("link", true) || [], C = [];
      Ke2(e2.getCoordinateSystems(), function(D2) {
        if (!D2.axisPointerEnabled)
          return;
        var L = Urt(D2.model), F3 = l2.coordSysAxesInfo[L] = {};
        l2.coordSysMap[L] = D2;
        var j = D2.model, U3 = j.getModel("tooltip", d2);
        if (Ke2(D2.getAxes(), xu(dt, false, null)), D2.getTooltipAxes && d2 && U3.get("show")) {
          var Y3 = U3.get("trigger") === "axis", Q = U3.get(["axisPointer", "type"]) === "cross", nt = D2.getTooltipAxes(U3.get(["axisPointer", "axis"]));
          (Y3 || Q) && Ke2(nt.baseAxes, xu(dt, Q ? "cross" : true, Y3)), Q && Ke2(nt.otherAxes, xu(dt, "cross", false));
        }
        function dt(vt, Ct, Pt) {
          var jt = Pt.model.getModel("axisPointer", y2), Rt = jt.get("show");
          if (!(!Rt || Rt === "auto" && !vt && !vOt(jt))) {
            Ct == null && (Ct = jt.get("triggerTooltip")), jt = vt ? ten(Pt, U3, y2, a, vt, Ct) : jt;
            var le2 = jt.get("snap"), ne2 = Urt(Pt.model), he2 = Ct || le2 || Pt.type === "category", _e = l2.axesInfo[ne2] = { key: ne2, axis: Pt, coordSys: D2, axisPointerModel: jt, triggerTooltip: Ct, involveSeries: he2, snap: le2, useHandle: vOt(jt), seriesModels: [], linkGroup: null };
            F3[ne2] = _e, l2.seriesInvolved = l2.seriesInvolved || he2;
            var Me2 = nen(x2, Pt);
            if (Me2 != null) {
              var Pe2 = C[Me2] || (C[Me2] = { axesInfo: {} });
              Pe2.axesInfo[ne2] = _e, Pe2.mapper = x2[Me2].mapper, _e.linkGroup = Pe2;
            }
          }
        }
      });
    }
    function ten(l2, a, e2, d2, y2, x2) {
      var C = a.getModel("axisPointer"), D2 = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], L = {};
      Ke2(D2, function(Y3) {
        L[Y3] = zl(C.get(Y3));
      }), L.snap = l2.type !== "category" && !!x2, C.get("type") === "cross" && (L.type = "line");
      var F3 = L.label || (L.label = {});
      if (F3.show == null && (F3.show = false), y2 === "cross") {
        var j = C.get(["label", "show"]);
        if (F3.show = j != null ? j : true, !x2) {
          var U3 = L.lineStyle = C.get("crossStyle");
          U3 && El(F3, U3.textStyle);
        }
      }
      return l2.model.getModel("axisPointer", new hg2(L, e2, d2));
    }
    function een(l2, a) {
      a.eachSeries(function(e2) {
        var d2 = e2.coordinateSystem, y2 = e2.get(["tooltip", "trigger"], true), x2 = e2.get(["tooltip", "show"], true);
        !d2 || y2 === "none" || y2 === false || y2 === "item" || x2 === false || e2.get(["axisPointer", "show"], true) === false || Ke2(l2.coordSysAxesInfo[Urt(d2.model)], function(C) {
          var D2 = C.axis;
          d2.getAxis(D2.dim) === D2 && (C.seriesModels.push(e2), C.seriesDataCount == null && (C.seriesDataCount = 0), C.seriesDataCount += e2.getData().count());
        });
      });
    }
    function nen(l2, a) {
      for (var e2 = a.model, d2 = a.dim, y2 = 0; y2 < l2.length; y2++) {
        var x2 = l2[y2] || {};
        if (dOt(x2[d2 + "AxisId"], e2.id) || dOt(x2[d2 + "AxisIndex"], e2.componentIndex) || dOt(x2[d2 + "AxisName"], e2.name))
          return y2;
      }
    }
    function dOt(l2, a) {
      return l2 === "all" || Ba2(l2) && oc2(l2, a) >= 0 || l2 === a;
    }
    function ren(l2) {
      var a = gOt(l2);
      if (a) {
        var e2 = a.axisPointerModel, d2 = a.axis.scale, y2 = e2.option, x2 = e2.get("status"), C = e2.get("value");
        C != null && (C = d2.parse(C));
        var D2 = vOt(e2);
        x2 == null && (y2.status = D2 ? "show" : "hide");
        var L = d2.getExtent().slice();
        L[0] > L[1] && L.reverse(), (C == null || C > L[1]) && (C = L[1]), C < L[0] && (C = L[0]), y2.value = C, D2 && (y2.status = a.axis.scale.isBlank() ? "hide" : "show");
      }
    }
    function gOt(l2) {
      var a = (l2.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
      return a && a.axesInfo[Urt(l2)];
    }
    function ien(l2) {
      var a = gOt(l2);
      return a && a.axisPointerModel;
    }
    function vOt(l2) {
      return !!l2.get(["handle", "show"]);
    }
    function Urt(l2) {
      return l2.type + "||" + l2.id;
    }
    var Kle = {}, aen = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        this.axisPointerClass && ren(e2), l2.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(e2, y2, true);
      }, a.prototype.updateAxisPointer = function(e2, d2, y2, x2) {
        this._doUpdateAxisPointerClass(e2, y2, false);
      }, a.prototype.remove = function(e2, d2) {
        var y2 = this._axisPointer;
        y2 && y2.remove(d2);
      }, a.prototype.dispose = function(e2, d2) {
        this._disposeAxisPointer(d2), l2.prototype.dispose.apply(this, arguments);
      }, a.prototype._doUpdateAxisPointerClass = function(e2, d2, y2) {
        var x2 = a.getAxisPointerClass(this.axisPointerClass);
        if (x2) {
          var C = ien(e2);
          C ? (this._axisPointer || (this._axisPointer = new x2())).render(e2, C, d2, y2) : this._disposeAxisPointer(d2);
        }
      }, a.prototype._disposeAxisPointer = function(e2) {
        this._axisPointer && this._axisPointer.dispose(e2), this._axisPointer = null;
      }, a.registerAxisPointerClass = function(e2, d2) {
        Kle[e2] = d2;
      }, a.getAxisPointerClass = function(e2) {
        return e2 && Kle[e2];
      }, a.type = "axis", a;
    }(_0), bB = aen, yOt = Rf2();
    function Xle(l2, a, e2, d2) {
      var y2 = e2.axis;
      if (!y2.scale.isBlank()) {
        var x2 = e2.getModel("splitArea"), C = x2.getModel("areaStyle"), D2 = C.get("color"), L = d2.coordinateSystem.getRect(), F3 = y2.getTicksCoords({ tickModel: x2, clamp: true });
        if (F3.length) {
          var j = D2.length, U3 = yOt(l2).splitAreaColors, Y3 = fl(), Q = 0;
          if (U3)
            for (var nt = 0; nt < F3.length; nt++) {
              var dt = U3.get(F3[nt].tickValue);
              if (dt != null) {
                Q = (dt + (j - 1) * nt) % j;
                break;
              }
            }
          var vt = y2.toGlobalCoord(F3[0].coord), Ct = C.getAreaStyle();
          D2 = Ba2(D2) ? D2 : [D2];
          for (var nt = 1; nt < F3.length; nt++) {
            var Pt = y2.toGlobalCoord(F3[nt].coord), jt = void 0, Rt = void 0, le2 = void 0, ne2 = void 0;
            y2.isHorizontal() ? (jt = vt, Rt = L.y, le2 = Pt - jt, ne2 = L.height, vt = jt + le2) : (jt = L.x, Rt = vt, le2 = L.width, ne2 = Pt - Rt, vt = Rt + ne2);
            var he2 = F3[nt - 1].tickValue;
            he2 != null && Y3.set(he2, Q), a.add(new Nf2({ anid: he2 != null ? "area_" + he2 : null, shape: { x: jt, y: Rt, width: le2, height: ne2 }, style: El({ fill: D2[Q] }, Ct), autoBatch: true, silent: true })), Q = (Q + 1) % j;
          }
          yOt(l2).splitAreaColors = Y3;
        }
      }
    }
    function Qle(l2) {
      yOt(l2).splitAreaColors = null;
    }
    var oen = ["axisLine", "axisTickLabel", "axisName"], sen = ["splitArea", "splitLine", "minorSplitLine"], Jle = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.axisPointerClass = "CartesianAxisPointer", e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        this.group.removeAll();
        var C = this._axisGroup;
        if (this._axisGroup = new ou(), this.group.add(this._axisGroup), !!e2.get("show")) {
          var D2 = e2.getCoordSysModel(), L = fOt(D2, e2), F3 = new RO(e2, la2({ handleAutoShown: function(U3) {
            for (var Y3 = D2.coordinateSystem.getCartesians(), Q = 0; Q < Y3.length; Q++)
              if (ELt(Y3[Q].getOtherAxis(e2.axis).scale))
                return true;
            return false;
          } }, L));
          Ke2(oen, F3.add, F3), this._axisGroup.add(F3.getGroup()), Ke2(sen, function(U3) {
            e2.get([U3, "show"]) && len2[U3](this, this._axisGroup, e2, D2);
          }, this);
          var j = x2 && x2.type === "changeAxisOrder" && x2.isInitSort;
          j || m1(C, this._axisGroup, e2), l2.prototype.render.call(this, e2, d2, y2, x2);
        }
      }, a.prototype.remove = function() {
        Qle(this);
      }, a.type = "cartesianAxis", a;
    }(bB), len2 = { splitLine: function(l2, a, e2, d2) {
      var y2 = e2.axis;
      if (!y2.scale.isBlank()) {
        var x2 = e2.getModel("splitLine"), C = x2.getModel("lineStyle"), D2 = C.get("color");
        D2 = Ba2(D2) ? D2 : [D2];
        for (var L = d2.coordinateSystem.getRect(), F3 = y2.isHorizontal(), j = 0, U3 = y2.getTicksCoords({ tickModel: x2 }), Y3 = [], Q = [], nt = C.getLineStyle(), dt = 0; dt < U3.length; dt++) {
          var vt = y2.toGlobalCoord(U3[dt].coord);
          F3 ? (Y3[0] = vt, Y3[1] = L.y, Q[0] = vt, Q[1] = L.y + L.height) : (Y3[0] = L.x, Y3[1] = vt, Q[0] = L.x + L.width, Q[1] = vt);
          var Ct = j++ % D2.length, Pt = U3[dt].tickValue;
          a.add(new by({ anid: Pt != null ? "line_" + U3[dt].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: Y3[0], y1: Y3[1], x2: Q[0], y2: Q[1] }, style: El({ stroke: D2[Ct] }, nt), silent: true }));
        }
      }
    }, minorSplitLine: function(l2, a, e2, d2) {
      var y2 = e2.axis, x2 = e2.getModel("minorSplitLine"), C = x2.getModel("lineStyle"), D2 = d2.coordinateSystem.getRect(), L = y2.isHorizontal(), F3 = y2.getMinorTicksCoords();
      if (F3.length)
        for (var j = [], U3 = [], Y3 = C.getLineStyle(), Q = 0; Q < F3.length; Q++)
          for (var nt = 0; nt < F3[Q].length; nt++) {
            var dt = y2.toGlobalCoord(F3[Q][nt].coord);
            L ? (j[0] = dt, j[1] = D2.y, U3[0] = dt, U3[1] = D2.y + D2.height) : (j[0] = D2.x, j[1] = dt, U3[0] = D2.x + D2.width, U3[1] = dt), a.add(new by({ anid: "minor_line_" + F3[Q][nt].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: j[0], y1: j[1], x2: U3[0], y2: U3[1] }, style: Y3, silent: true }));
          }
    }, splitArea: function(l2, a, e2, d2) {
      Xle(l2, a, e2, d2);
    } }, tue = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "xAxis", a;
    }(Jle), uen = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = tue.type, e2;
      }
      return a.type = "yAxis", a;
    }(Jle), cen = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "grid", e2;
      }
      return a.prototype.render = function(e2, d2) {
        this.group.removeAll(), e2.get("show") && this.group.add(new Nf2({ shape: e2.coordinateSystem.getRect(), style: El({ fill: e2.get("backgroundColor") }, e2.getItemStyle()), silent: true, z2: -1 }));
      }, a.type = "grid", a;
    }(_0), eue = { offset: 0 };
    function nue(l2) {
      l2.registerComponentView(cen), l2.registerComponentModel(Ltn), l2.registerCoordinateSystem("cartesian2d", qtn), uZ(l2, "x", lOt, eue), uZ(l2, "y", lOt, eue), l2.registerComponentView(tue), l2.registerComponentView(uen), l2.registerPreprocessor(function(a) {
        a.xAxis && a.yAxis && !a.grid && (a.grid = {});
      });
    }
    function fen(l2) {
      Oc2(nue), l2.registerSeriesModel(Ctn), l2.registerChartView(ktn), l2.registerLayout(Wrt("scatter"));
    }
    function hen(l2) {
      l2.eachSeriesByType("radar", function(a) {
        var e2 = a.getData(), d2 = [], y2 = a.coordinateSystem;
        if (y2) {
          var x2 = y2.getIndicatorAxes();
          Ke2(x2, function(C, D2) {
            e2.each(e2.mapDimension(x2[D2].dim), function(L, F3) {
              d2[F3] = d2[F3] || [];
              var j = y2.dataToPoint(L, D2);
              d2[F3][D2] = rue(j) ? j : iue(y2);
            });
          }), e2.each(function(C) {
            var D2 = a5t(d2[C], function(L) {
              return rue(L);
            }) || iue(y2);
            d2[C].push(D2.slice()), e2.setItemLayout(C, d2[C]);
          });
        }
      });
    }
    function rue(l2) {
      return !isNaN(l2[0]) && !isNaN(l2[1]);
    }
    function iue(l2) {
      return [l2.cx, l2.cy];
    }
    function pen(l2) {
      var a = l2.polar;
      if (a) {
        Ba2(a) || (a = [a]);
        var e2 = [];
        Ke2(a, function(d2, y2) {
          d2.indicator ? (d2.type && !d2.shape && (d2.shape = d2.type), l2.radar = l2.radar || [], Ba2(l2.radar) || (l2.radar = [l2.radar]), l2.radar.push(d2)) : e2.push(d2);
        }), l2.polar = e2;
      }
      Ke2(l2.series, function(d2) {
        d2 && d2.type === "radar" && d2.polarIndex && (d2.radarIndex = d2.polarIndex);
      });
    }
    var den = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.coordinateSystem, C = this.group, D2 = e2.getData(), L = this._data;
        function F3(Y3, Q) {
          var nt = Y3.getItemVisual(Q, "symbol") || "circle";
          if (nt !== "none") {
            var dt = brt(Y3.getItemVisual(Q, "symbolSize")), vt = qy(nt, -1, -1, 2, 2), Ct = Y3.getItemVisual(Q, "symbolRotate") || 0;
            return vt.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: dt[0] / 2, scaleY: dt[1] / 2, rotation: Ct * Math.PI / 180 || 0 }), vt;
          }
        }
        function j(Y3, Q, nt, dt, vt, Ct) {
          nt.removeAll();
          for (var Pt = 0; Pt < Q.length - 1; Pt++) {
            var jt = F3(dt, vt);
            jt && (jt.__dimIdx = Pt, Y3[Pt] ? (jt.setPosition(Y3[Pt]), nrt[Ct ? "initProps" : "updateProps"](jt, { x: Q[Pt][0], y: Q[Pt][1] }, e2, vt)) : jt.setPosition(Q[Pt]), nt.add(jt));
          }
        }
        function U3(Y3) {
          return $a2(Y3, function(Q) {
            return [x2.cx, x2.cy];
          });
        }
        D2.diff(L).add(function(Y3) {
          var Q = D2.getItemLayout(Y3);
          if (Q) {
            var nt = new rw(), dt = new iw(), vt = { shape: { points: Q } };
            nt.shape.points = U3(Q), dt.shape.points = U3(Q), Yg2(nt, vt, e2, Y3), Yg2(dt, vt, e2, Y3);
            var Ct = new ou(), Pt = new ou();
            Ct.add(dt), Ct.add(nt), Ct.add(Pt), j(dt.shape.points, Q, Pt, D2, Y3, true), D2.setItemGraphicEl(Y3, Ct);
          }
        }).update(function(Y3, Q) {
          var nt = L.getItemGraphicEl(Q), dt = nt.childAt(0), vt = nt.childAt(1), Ct = nt.childAt(2), Pt = { shape: { points: D2.getItemLayout(Y3) } };
          !Pt.shape.points || (j(dt.shape.points, Pt.shape.points, Ct, D2, Y3, false), pC(vt), pC(dt), Yf2(dt, Pt, e2), Yf2(vt, Pt, e2), D2.setItemGraphicEl(Y3, nt));
        }).remove(function(Y3) {
          C.remove(L.getItemGraphicEl(Y3));
        }).execute(), D2.eachItemGraphicEl(function(Y3, Q) {
          var nt = D2.getItemModel(Q), dt = Y3.childAt(0), vt = Y3.childAt(1), Ct = Y3.childAt(2), Pt = D2.getItemVisual(Q, "style"), jt = Pt.fill;
          C.add(Y3), dt.useStyle(El(nt.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: jt })), Gy(dt, nt, "lineStyle"), Gy(vt, nt, "areaStyle");
          var Rt = nt.getModel("areaStyle"), le2 = Rt.isEmpty() && Rt.parentModel.isEmpty();
          vt.ignore = le2, Ke2(["emphasis", "select", "blur"], function(_e) {
            var Me2 = nt.getModel([_e, "areaStyle"]), Pe2 = Me2.isEmpty() && Me2.parentModel.isEmpty();
            vt.ensureState(_e).ignore = Pe2 && le2;
          }), vt.useStyle(El(Rt.getAreaStyle(), { fill: jt, opacity: 0.7, decal: Pt.decal }));
          var ne2 = nt.getModel("emphasis"), he2 = ne2.getModel("itemStyle").getItemStyle();
          Ct.eachChild(function(_e) {
            if (_e instanceof Im) {
              var Me2 = _e.style;
              _e.useStyle(la2({ image: Me2.image, x: Me2.x, y: Me2.y, width: Me2.width, height: Me2.height }, Pt));
            } else
              _e.useStyle(Pt), _e.setColor(jt), _e.style.strokeNoScale = true;
            var Pe2 = _e.ensureState("emphasis");
            Pe2.style = zl(he2);
            var Be2 = D2.getStore().get(D2.getDimensionIndex(_e.__dimIdx), Q);
            (Be2 == null || isNaN(Be2)) && (Be2 = ""), ow(_e, Sb2(nt), { labelFetcher: D2.hostModel, labelDataIndex: Q, labelDimIndex: _e.__dimIdx, defaultText: Be2, inheritColor: jt, defaultOpacity: Pt.opacity });
          }), n0(Y3, ne2.get("focus"), ne2.get("blurScope"), ne2.get("disabled"));
        }), this._data = D2;
      }, a.prototype.remove = function() {
        this.group.removeAll(), this._data = null;
      }, a.type = "radar", a;
    }(pg2), gen = den, ven = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.hasSymbolVisual = true, e2;
      }
      return a.prototype.init = function(e2) {
        l2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Hrt(As(this.getData, this), As(this.getRawData, this));
      }, a.prototype.getInitialData = function(e2, d2) {
        return lZ(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        var x2 = this.getData(), C = this.coordinateSystem, D2 = C.getIndicatorAxes(), L = this.getData().getName(e2), F3 = L === "" ? this.name : L, j = vae(this, e2);
        return b1("section", { header: F3, sortBlocks: true, blocks: $a2(D2, function(U3) {
          var Y3 = x2.get(x2.mapDimension(U3.dim), e2);
          return b1("nameValue", { markerType: "subItem", markerColor: j, name: U3.name, value: Y3, sortParam: Y3 });
        }) });
      }, a.prototype.getTooltipPosition = function(e2) {
        if (e2 != null) {
          for (var d2 = this.getData(), y2 = this.coordinateSystem, x2 = d2.getValues($a2(y2.dimensions, function(F3) {
            return d2.mapDimension(F3);
          }), e2), C = 0, D2 = x2.length; C < D2; C++)
            if (!isNaN(x2[C])) {
              var L = y2.getIndicatorAxes();
              return y2.coordToPoint(L[C].dataToCoord(x2[C]), C);
            }
        }
      }, a.type = "series.radar", a.dependencies = ["radar"], a.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, a;
    }(Pv), yen = ven, qrt = Vle.value;
    function imt(l2, a) {
      return El({ show: a }, l2);
    }
    var men = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.optionUpdated = function() {
        var e2 = this.get("boundaryGap"), d2 = this.get("splitNumber"), y2 = this.get("scale"), x2 = this.get("axisLine"), C = this.get("axisTick"), D2 = this.get("axisLabel"), L = this.get("axisName"), F3 = this.get(["axisName", "show"]), j = this.get(["axisName", "formatter"]), U3 = this.get("axisNameGap"), Y3 = this.get("triggerEvent"), Q = $a2(this.get("indicator") || [], function(nt) {
          nt.max != null && nt.max > 0 && !nt.min ? nt.min = 0 : nt.min != null && nt.min < 0 && !nt.max && (nt.max = 0);
          var dt = L;
          nt.color != null && (dt = El({ color: nt.color }, L));
          var vt = Mu(zl(nt), { boundaryGap: e2, splitNumber: d2, scale: y2, axisLine: x2, axisTick: C, axisLabel: D2, name: nt.text, showName: F3, nameLocation: "end", nameGap: U3, nameTextStyle: dt, triggerEvent: Y3 }, false);
          if (F3 || (vt.name = ""), ps(j)) {
            var Ct = vt.name;
            vt.name = j.replace("{value}", Ct != null ? Ct : "");
          } else
            wl(j) && (vt.name = j(vt.name, vt));
          var Pt = new hg2(vt, null, this.ecModel);
          return v0(Pt, Lrt.prototype), Pt.mainType = "radar", Pt.componentIndex = this.componentIndex, Pt;
        }, this);
        this._indicatorModels = Q;
      }, a.prototype.getIndicatorModels = function() {
        return this._indicatorModels;
      }, a.type = "radar", a.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: Mu({ lineStyle: { color: "#bbb" } }, qrt.axisLine), axisLabel: imt(qrt.axisLabel, false), axisTick: imt(qrt.axisTick, false), splitLine: imt(qrt.splitLine, true), splitArea: imt(qrt.splitArea, true), indicator: [] }, a;
    }(Ah2), ben = men, _en = ["axisLine", "axisTickLabel", "axisName"], xen = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = this.group;
        x2.removeAll(), this._buildAxes(e2), this._buildSplitLineAndArea(e2);
      }, a.prototype._buildAxes = function(e2) {
        var d2 = e2.coordinateSystem, y2 = d2.getIndicatorAxes(), x2 = $a2(y2, function(C) {
          var D2 = C.model.get("showName") ? C.name : "", L = new RO(C.model, { axisName: D2, position: [d2.cx, d2.cy], rotation: C.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
          return L;
        });
        Ke2(x2, function(C) {
          Ke2(_en, C.add, C), this.group.add(C.getGroup());
        }, this);
      }, a.prototype._buildSplitLineAndArea = function(e2) {
        var d2 = e2.coordinateSystem, y2 = d2.getIndicatorAxes();
        if (!y2.length)
          return;
        var x2 = e2.get("shape"), C = e2.getModel("splitLine"), D2 = e2.getModel("splitArea"), L = C.getModel("lineStyle"), F3 = D2.getModel("areaStyle"), j = C.get("show"), U3 = D2.get("show"), Y3 = L.get("color"), Q = F3.get("color"), nt = Ba2(Y3) ? Y3 : [Y3], dt = Ba2(Q) ? Q : [Q], vt = [], Ct = [];
        function Pt(Bn, mn, Kr) {
          var Kn = Kr % mn.length;
          return Bn[Kn] = Bn[Kn] || [], Kn;
        }
        if (x2 === "circle")
          for (var jt = y2[0].getTicksCoords(), Rt = d2.cx, le2 = d2.cy, ne2 = 0; ne2 < jt.length; ne2++) {
            if (j) {
              var he2 = Pt(vt, nt, ne2);
              vt[he2].push(new _A({ shape: { cx: Rt, cy: le2, r: jt[ne2].coord } }));
            }
            if (U3 && ne2 < jt.length - 1) {
              var he2 = Pt(Ct, dt, ne2);
              Ct[he2].push(new Iq({ shape: { cx: Rt, cy: le2, r0: jt[ne2].coord, r: jt[ne2 + 1].coord } }));
            }
          }
        else
          for (var _e, Me2 = $a2(y2, function(mn, Kr) {
            var Kn = mn.getTicksCoords();
            return _e = _e == null ? Kn.length - 1 : Math.min(Kn.length - 1, _e), $a2(Kn, function(ar) {
              return d2.coordToPoint(ar.coord, Kr);
            });
          }), Pe2 = [], ne2 = 0; ne2 <= _e; ne2++) {
            for (var Be2 = [], Je2 = 0; Je2 < y2.length; Je2++)
              Be2.push(Me2[Je2][ne2]);
            if (Be2[0] && Be2.push(Be2[0].slice()), j) {
              var he2 = Pt(vt, nt, ne2);
              vt[he2].push(new iw({ shape: { points: Be2 } }));
            }
            if (U3 && Pe2) {
              var he2 = Pt(Ct, dt, ne2 - 1);
              Ct[he2].push(new rw({ shape: { points: Be2.concat(Pe2) } }));
            }
            Pe2 = Be2.slice().reverse();
          }
        var Ze2 = L.getLineStyle(), Cn = F3.getAreaStyle();
        Ke2(Ct, function(Bn, mn) {
          this.group.add(Ja2(Bn, { style: El({ stroke: "none", fill: dt[mn % dt.length] }, Cn), silent: true }));
        }, this), Ke2(vt, function(Bn, mn) {
          this.group.add(Ja2(Bn, { style: El({ fill: "none", stroke: nt[mn % nt.length] }, Ze2), silent: true }));
        }, this);
      }, a.type = "radar", a;
    }(_0), wen = xen, Sen = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this, e2, d2, y2) || this;
        return x2.type = "value", x2.angle = 0, x2.name = "", x2;
      }
      return a;
    }(kE), Men = Sen, Cen = function() {
      function l2(a, e2, d2) {
        this.dimensions = [], this._model = a, this._indicatorAxes = $a2(a.getIndicatorModels(), function(y2, x2) {
          var C = "indicator_" + x2, D2 = new Men(C, new eF());
          return D2.name = y2.get("name"), D2.model = y2, y2.axis = D2, this.dimensions.push(C), D2;
        }, this), this.resize(a, d2);
      }
      return l2.prototype.getIndicatorAxes = function() {
        return this._indicatorAxes;
      }, l2.prototype.dataToPoint = function(a, e2) {
        var d2 = this._indicatorAxes[e2];
        return this.coordToPoint(d2.dataToCoord(a), e2);
      }, l2.prototype.coordToPoint = function(a, e2) {
        var d2 = this._indicatorAxes[e2], y2 = d2.angle, x2 = this.cx + a * Math.cos(y2), C = this.cy - a * Math.sin(y2);
        return [x2, C];
      }, l2.prototype.pointToData = function(a) {
        var e2 = a[0] - this.cx, d2 = a[1] - this.cy, y2 = Math.sqrt(e2 * e2 + d2 * d2);
        e2 /= y2, d2 /= y2;
        for (var x2 = Math.atan2(-d2, e2), C = 1 / 0, D2, L = -1, F3 = 0; F3 < this._indicatorAxes.length; F3++) {
          var j = this._indicatorAxes[F3], U3 = Math.abs(x2 - j.angle);
          U3 < C && (D2 = j, L = F3, C = U3);
        }
        return [L, +(D2 && D2.coordToData(y2))];
      }, l2.prototype.resize = function(a, e2) {
        var d2 = a.get("center"), y2 = e2.getWidth(), x2 = e2.getHeight(), C = Math.min(y2, x2) / 2;
        this.cx = Ko(d2[0], y2), this.cy = Ko(d2[1], x2), this.startAngle = a.get("startAngle") * Math.PI / 180;
        var D2 = a.get("radius");
        (ps(D2) || Ch2(D2)) && (D2 = [0, D2]), this.r0 = Ko(D2[0], C), this.r = Ko(D2[1], C), Ke2(this._indicatorAxes, function(L, F3) {
          L.setExtent(this.r0, this.r);
          var j = this.startAngle + F3 * Math.PI * 2 / this._indicatorAxes.length;
          j = Math.atan2(Math.sin(j), Math.cos(j)), L.angle = j;
        }, this);
      }, l2.prototype.update = function(a, e2) {
        var d2 = this._indicatorAxes, y2 = this._model;
        Ke2(d2, function(D2) {
          D2.scale.setExtent(1 / 0, -1 / 0);
        }), a.eachSeriesByType("radar", function(D2, L) {
          if (!(D2.get("coordinateSystem") !== "radar" || a.getComponent("radar", D2.get("radarIndex")) !== y2)) {
            var F3 = D2.getData();
            Ke2(d2, function(j) {
              j.scale.unionExtentFromData(F3, F3.mapDimension(j.dim));
            });
          }
        }, this);
        var x2 = y2.get("splitNumber"), C = new eF();
        C.setExtent(0, x2), C.setInterval(1), Ke2(d2, function(D2, L) {
          Gle(D2.scale, D2.model, C);
        });
      }, l2.prototype.convertToPixel = function(a, e2, d2) {
        return console.warn("Not implemented."), null;
      }, l2.prototype.convertFromPixel = function(a, e2, d2) {
        return console.warn("Not implemented."), null;
      }, l2.prototype.containPoint = function(a) {
        return console.warn("Not implemented."), false;
      }, l2.create = function(a, e2) {
        var d2 = [];
        return a.eachComponent("radar", function(y2) {
          var x2 = new l2(y2, a, e2);
          d2.push(x2), y2.coordinateSystem = x2;
        }), a.eachSeriesByType("radar", function(y2) {
          y2.get("coordinateSystem") === "radar" && (y2.coordinateSystem = d2[y2.get("radarIndex") || 0]);
        }), d2;
      }, l2.dimensions = [], l2;
    }(), Ten = Cen;
    function Aen(l2) {
      l2.registerCoordinateSystem("radar", Ten), l2.registerComponentModel(ben), l2.registerComponentView(wen), l2.registerVisual({ seriesType: "radar", reset: function(a) {
        var e2 = a.getData();
        e2.each(function(d2) {
          e2.setItemVisual(d2, "legendIcon", "roundRect");
        }), e2.setVisual("legendIcon", "roundRect");
      } });
    }
    function Ien(l2) {
      Oc2(Aen), l2.registerChartView(gen), l2.registerSeriesModel(yen), l2.registerLayout(hen), l2.registerProcessor(Grt("radar")), l2.registerPreprocessor(pen);
    }
    var aue = "\0_ec_interaction_mutex";
    function Den(l2, a, e2) {
      var d2 = mOt(l2);
      d2[a] = e2;
    }
    function Een(l2, a, e2) {
      var d2 = mOt(l2), y2 = d2[a];
      y2 === e2 && (d2[a] = null);
    }
    function oue(l2, a) {
      return !!mOt(l2)[a];
    }
    function mOt(l2) {
      return l2[aue] || (l2[aue] = {});
    }
    sP({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, $p);
    var ken = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this) || this;
        d2._zr = e2;
        var y2 = As(d2._mousedownHandler, d2), x2 = As(d2._mousemoveHandler, d2), C = As(d2._mouseupHandler, d2), D2 = As(d2._mousewheelHandler, d2), L = As(d2._pinchHandler, d2);
        return d2.enable = function(F3, j) {
          this.disable(), this._opt = El(zl(j) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), F3 == null && (F3 = true), (F3 === true || F3 === "move" || F3 === "pan") && (e2.on("mousedown", y2), e2.on("mousemove", x2), e2.on("mouseup", C)), (F3 === true || F3 === "scale" || F3 === "zoom") && (e2.on("mousewheel", D2), e2.on("pinch", L));
        }, d2.disable = function() {
          e2.off("mousedown", y2), e2.off("mousemove", x2), e2.off("mouseup", C), e2.off("mousewheel", D2), e2.off("pinch", L);
        }, d2;
      }
      return a.prototype.isDragging = function() {
        return this._dragging;
      }, a.prototype.isPinching = function() {
        return this._pinching;
      }, a.prototype.setPointerChecker = function(e2) {
        this.pointerChecker = e2;
      }, a.prototype.dispose = function() {
        this.disable();
      }, a.prototype._mousedownHandler = function(e2) {
        if (!(nvt(e2) || e2.target && e2.target.draggable)) {
          var d2 = e2.offsetX, y2 = e2.offsetY;
          this.pointerChecker && this.pointerChecker(e2, d2, y2) && (this._x = d2, this._y = y2, this._dragging = true);
        }
      }, a.prototype._mousemoveHandler = function(e2) {
        if (!(!this._dragging || !amt("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || oue(this._zr, "globalPan"))) {
          var d2 = e2.offsetX, y2 = e2.offsetY, x2 = this._x, C = this._y, D2 = d2 - x2, L = y2 - C;
          this._x = d2, this._y = y2, this._opt.preventDefaultMouseMove && yE(e2.event), sue(this, "pan", "moveOnMouseMove", e2, { dx: D2, dy: L, oldX: x2, oldY: C, newX: d2, newY: y2, isAvailableBehavior: null });
        }
      }, a.prototype._mouseupHandler = function(e2) {
        nvt(e2) || (this._dragging = false);
      }, a.prototype._mousewheelHandler = function(e2) {
        var d2 = amt("zoomOnMouseWheel", e2, this._opt), y2 = amt("moveOnMouseWheel", e2, this._opt), x2 = e2.wheelDelta, C = Math.abs(x2), D2 = e2.offsetX, L = e2.offsetY;
        if (!(x2 === 0 || !d2 && !y2)) {
          if (d2) {
            var F3 = C > 3 ? 1.4 : C > 1 ? 1.2 : 1.1, j = x2 > 0 ? F3 : 1 / F3;
            bOt(this, "zoom", "zoomOnMouseWheel", e2, { scale: j, originX: D2, originY: L, isAvailableBehavior: null });
          }
          if (y2) {
            var U3 = Math.abs(x2), Y3 = (x2 > 0 ? 1 : -1) * (U3 > 3 ? 0.4 : U3 > 1 ? 0.15 : 0.05);
            bOt(this, "scrollMove", "moveOnMouseWheel", e2, { scrollDelta: Y3, originX: D2, originY: L, isAvailableBehavior: null });
          }
        }
      }, a.prototype._pinchHandler = function(e2) {
        if (!oue(this._zr, "globalPan")) {
          var d2 = e2.pinchScale > 1 ? 1.1 : 0.9090909090909091;
          bOt(this, "zoom", null, e2, { scale: d2, originX: e2.pinchX, originY: e2.pinchY, isAvailableBehavior: null });
        }
      }, a;
    }(Yx);
    function bOt(l2, a, e2, d2, y2) {
      l2.pointerChecker && l2.pointerChecker(d2, y2.originX, y2.originY) && (yE(d2.event), sue(l2, a, e2, d2, y2));
    }
    function sue(l2, a, e2, d2, y2) {
      y2.isAvailableBehavior = As(amt, null, e2, d2), l2.trigger(a, y2);
    }
    function amt(l2, a, e2) {
      var d2 = e2[l2];
      return !l2 || d2 && (!ps(d2) || a.event[d2 + "Key"]);
    }
    var Zrt = ken;
    function _Ot(l2, a, e2) {
      var d2 = l2.target;
      d2.x += a, d2.y += e2, d2.dirty();
    }
    function xOt(l2, a, e2, d2) {
      var y2 = l2.target, x2 = l2.zoomLimit, C = l2.zoom = l2.zoom || 1;
      if (C *= a, x2) {
        var D2 = x2.min || 0, L = x2.max || 1 / 0;
        C = Math.max(Math.min(L, C), D2);
      }
      var F3 = C / l2.zoom;
      l2.zoom = C, y2.x -= (e2 - y2.x) * (F3 - 1), y2.y -= (d2 - y2.y) * (F3 - 1), y2.scaleX *= F3, y2.scaleY *= F3, y2.dirty();
    }
    var Pen = { axisPointer: 1, tooltip: 1, brush: 1 };
    function omt(l2, a, e2) {
      var d2 = a.getComponentByElement(l2.topTarget), y2 = d2 && d2.coordinateSystem;
      return d2 && d2 !== e2 && !Pen.hasOwnProperty(d2.mainType) && y2 && y2.model !== e2;
    }
    function lue(l2) {
      if (ps(l2)) {
        var a = new DOMParser();
        l2 = a.parseFromString(l2, "text/xml");
      }
      var e2 = l2;
      for (e2.nodeType === 9 && (e2 = e2.firstChild); e2.nodeName.toLowerCase() !== "svg" || e2.nodeType !== 1; )
        e2 = e2.nextSibling;
      return e2;
    }
    var wOt, smt = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, uue = Qc2(smt), lmt = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, cue = Qc2(lmt), Len = function() {
      function l2() {
        this._defs = {}, this._root = null;
      }
      return l2.prototype.parse = function(a, e2) {
        e2 = e2 || {};
        var d2 = lue(a);
        this._defsUsePending = [];
        var y2 = new ou();
        this._root = y2;
        var x2 = [], C = d2.getAttribute("viewBox") || "", D2 = parseFloat(d2.getAttribute("width") || e2.width), L = parseFloat(d2.getAttribute("height") || e2.height);
        isNaN(D2) && (D2 = null), isNaN(L) && (L = null), vC(d2, y2, null, true, false);
        for (var F3 = d2.firstChild; F3; )
          this._parseNode(F3, y2, x2, null, false, false), F3 = F3.nextSibling;
        Nen(this._defs, this._defsUsePending), this._defsUsePending = [];
        var j, U3;
        if (C) {
          var Y3 = umt(C);
          Y3.length >= 4 && (j = { x: parseFloat(Y3[0] || 0), y: parseFloat(Y3[1] || 0), width: parseFloat(Y3[2]), height: parseFloat(Y3[3]) });
        }
        if (j && D2 != null && L != null && (U3 = mue(j, { x: 0, y: 0, width: D2, height: L }), !e2.ignoreViewBox)) {
          var Q = y2;
          y2 = new ou(), y2.add(Q), Q.scaleX = Q.scaleY = U3.scale, Q.x = U3.x, Q.y = U3.y;
        }
        return !e2.ignoreRootClip && D2 != null && L != null && y2.setClipPath(new Nf2({ shape: { x: 0, y: 0, width: D2, height: L } })), { root: y2, width: D2, height: L, viewBoxRect: j, viewBoxTransform: U3, named: x2 };
      }, l2.prototype._parseNode = function(a, e2, d2, y2, x2, C) {
        var D2 = a.nodeName.toLowerCase(), L, F3 = y2;
        if (D2 === "defs" && (x2 = true), D2 === "text" && (C = true), D2 === "defs" || D2 === "switch")
          L = e2;
        else {
          if (!x2) {
            var j = wOt[D2];
            if (j && Ns(wOt, D2)) {
              L = j.call(this, a, e2);
              var U3 = a.getAttribute("name");
              if (U3) {
                var Y3 = { name: U3, namedFrom: null, svgNodeTagLower: D2, el: L };
                d2.push(Y3), D2 === "g" && (F3 = Y3);
              } else
                y2 && d2.push({ name: y2.name, namedFrom: y2, svgNodeTagLower: D2, el: L });
              e2.add(L);
            }
          }
          var Q = fue[D2];
          if (Q && Ns(fue, D2)) {
            var nt = Q.call(this, a), dt = a.getAttribute("id");
            dt && (this._defs[dt] = nt);
          }
        }
        if (L && L.isGroup)
          for (var vt = a.firstChild; vt; )
            vt.nodeType === 1 ? this._parseNode(vt, L, d2, F3, x2, C) : vt.nodeType === 3 && C && this._parseText(vt, L), vt = vt.nextSibling;
      }, l2.prototype._parseText = function(a, e2) {
        var d2 = new GV({ style: { text: a.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
        EA(e2, d2), vC(a, d2, this._defsUsePending, false, false), Oen(d2, e2);
        var y2 = d2.style, x2 = y2.fontSize;
        x2 && x2 < 9 && (y2.fontSize = 9, d2.scaleX *= x2 / 9, d2.scaleY *= x2 / 9);
        var C = (y2.fontSize || y2.fontFamily) && [y2.fontStyle, y2.fontWeight, (y2.fontSize || 12) + "px", y2.fontFamily || "sans-serif"].join(" ");
        y2.font = C;
        var D2 = d2.getBoundingRect();
        return this._textX += D2.width, e2.add(d2), d2;
      }, l2.internalField = function() {
        wOt = { g: function(a, e2) {
          var d2 = new ou();
          return EA(e2, d2), vC(a, d2, this._defsUsePending, false, false), d2;
        }, rect: function(a, e2) {
          var d2 = new Nf2();
          return EA(e2, d2), vC(a, d2, this._defsUsePending, false, false), d2.setShape({ x: parseFloat(a.getAttribute("x") || "0"), y: parseFloat(a.getAttribute("y") || "0"), width: parseFloat(a.getAttribute("width") || "0"), height: parseFloat(a.getAttribute("height") || "0") }), d2.silent = true, d2;
        }, circle: function(a, e2) {
          var d2 = new _A();
          return EA(e2, d2), vC(a, d2, this._defsUsePending, false, false), d2.setShape({ cx: parseFloat(a.getAttribute("cx") || "0"), cy: parseFloat(a.getAttribute("cy") || "0"), r: parseFloat(a.getAttribute("r") || "0") }), d2.silent = true, d2;
        }, line: function(a, e2) {
          var d2 = new by();
          return EA(e2, d2), vC(a, d2, this._defsUsePending, false, false), d2.setShape({ x1: parseFloat(a.getAttribute("x1") || "0"), y1: parseFloat(a.getAttribute("y1") || "0"), x2: parseFloat(a.getAttribute("x2") || "0"), y2: parseFloat(a.getAttribute("y2") || "0") }), d2.silent = true, d2;
        }, ellipse: function(a, e2) {
          var d2 = new $nt();
          return EA(e2, d2), vC(a, d2, this._defsUsePending, false, false), d2.setShape({ cx: parseFloat(a.getAttribute("cx") || "0"), cy: parseFloat(a.getAttribute("cy") || "0"), rx: parseFloat(a.getAttribute("rx") || "0"), ry: parseFloat(a.getAttribute("ry") || "0") }), d2.silent = true, d2;
        }, polygon: function(a, e2) {
          var d2 = a.getAttribute("points"), y2;
          d2 && (y2 = due(d2));
          var x2 = new rw({ shape: { points: y2 || [] }, silent: true });
          return EA(e2, x2), vC(a, x2, this._defsUsePending, false, false), x2;
        }, polyline: function(a, e2) {
          var d2 = a.getAttribute("points"), y2;
          d2 && (y2 = due(d2));
          var x2 = new iw({ shape: { points: y2 || [] }, silent: true });
          return EA(e2, x2), vC(a, x2, this._defsUsePending, false, false), x2;
        }, image: function(a, e2) {
          var d2 = new Im();
          return EA(e2, d2), vC(a, d2, this._defsUsePending, false, false), d2.setStyle({ image: a.getAttribute("xlink:href") || a.getAttribute("href"), x: +a.getAttribute("x"), y: +a.getAttribute("y"), width: +a.getAttribute("width"), height: +a.getAttribute("height") }), d2.silent = true, d2;
        }, text: function(a, e2) {
          var d2 = a.getAttribute("x") || "0", y2 = a.getAttribute("y") || "0", x2 = a.getAttribute("dx") || "0", C = a.getAttribute("dy") || "0";
          this._textX = parseFloat(d2) + parseFloat(x2), this._textY = parseFloat(y2) + parseFloat(C);
          var D2 = new ou();
          return EA(e2, D2), vC(a, D2, this._defsUsePending, false, true), D2;
        }, tspan: function(a, e2) {
          var d2 = a.getAttribute("x"), y2 = a.getAttribute("y");
          d2 != null && (this._textX = parseFloat(d2)), y2 != null && (this._textY = parseFloat(y2));
          var x2 = a.getAttribute("dx") || "0", C = a.getAttribute("dy") || "0", D2 = new ou();
          return EA(e2, D2), vC(a, D2, this._defsUsePending, false, true), this._textX += parseFloat(x2), this._textY += parseFloat(C), D2;
        }, path: function(a, e2) {
          var d2 = a.getAttribute("d") || "", y2 = B0t(d2);
          return EA(e2, y2), vC(a, y2, this._defsUsePending, false, false), y2.silent = true, y2;
        } };
      }(), l2;
    }(), fue = { lineargradient: function(l2) {
      var a = parseInt(l2.getAttribute("x1") || "0", 10), e2 = parseInt(l2.getAttribute("y1") || "0", 10), d2 = parseInt(l2.getAttribute("x2") || "10", 10), y2 = parseInt(l2.getAttribute("y2") || "0", 10), x2 = new QV(a, e2, d2, y2);
      return hue(l2, x2), pue(l2, x2), x2;
    }, radialgradient: function(l2) {
      var a = parseInt(l2.getAttribute("cx") || "0", 10), e2 = parseInt(l2.getAttribute("cy") || "0", 10), d2 = parseInt(l2.getAttribute("r") || "0", 10), y2 = new kq(a, e2, d2);
      return hue(l2, y2), pue(l2, y2), y2;
    } };
    function hue(l2, a) {
      var e2 = l2.getAttribute("gradientUnits");
      e2 === "userSpaceOnUse" && (a.global = true);
    }
    function pue(l2, a) {
      for (var e2 = l2.firstChild; e2; ) {
        if (e2.nodeType === 1 && e2.nodeName.toLocaleLowerCase() === "stop") {
          var d2 = e2.getAttribute("offset"), y2 = void 0;
          d2 && d2.indexOf("%") > 0 ? y2 = parseInt(d2, 10) / 100 : d2 ? y2 = parseFloat(d2) : y2 = 0;
          var x2 = {};
          yue(e2, x2, x2);
          var C = x2.stopColor || e2.getAttribute("stop-color") || "#000000";
          a.colorStops.push({ offset: y2, color: C });
        }
        e2 = e2.nextSibling;
      }
    }
    function EA(l2, a) {
      l2 && l2.__inheritedStyle && (a.__inheritedStyle || (a.__inheritedStyle = {}), El(a.__inheritedStyle, l2.__inheritedStyle));
    }
    function due(l2) {
      for (var a = umt(l2), e2 = [], d2 = 0; d2 < a.length; d2 += 2) {
        var y2 = parseFloat(a[d2]), x2 = parseFloat(a[d2 + 1]);
        e2.push([y2, x2]);
      }
      return e2;
    }
    function vC(l2, a, e2, d2, y2) {
      var x2 = a, C = x2.__inheritedStyle = x2.__inheritedStyle || {}, D2 = {};
      l2.nodeType === 1 && (Ben(l2, a), yue(l2, C, D2), d2 || zen(l2, C, D2)), x2.style = x2.style || {}, C.fill != null && (x2.style.fill = gue(x2, "fill", C.fill, e2)), C.stroke != null && (x2.style.stroke = gue(x2, "stroke", C.stroke, e2)), Ke2(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(L) {
        C[L] != null && (x2.style[L] = parseFloat(C[L]));
      }), Ke2(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(L) {
        C[L] != null && (x2.style[L] = C[L]);
      }), y2 && (x2.__selfStyle = D2), C.lineDash && (x2.style.lineDash = $a2(umt(C.lineDash), function(L) {
        return parseFloat(L);
      })), (C.visibility === "hidden" || C.visibility === "collapse") && (x2.invisible = true), C.display === "none" && (x2.ignore = true);
    }
    function Oen(l2, a) {
      var e2 = a.__selfStyle;
      if (e2) {
        var d2 = e2.textBaseline, y2 = d2;
        !d2 || d2 === "auto" || d2 === "baseline" ? y2 = "alphabetic" : d2 === "before-edge" || d2 === "text-before-edge" ? y2 = "top" : d2 === "after-edge" || d2 === "text-after-edge" ? y2 = "bottom" : (d2 === "central" || d2 === "mathematical") && (y2 = "middle"), l2.style.textBaseline = y2;
      }
      var x2 = a.__inheritedStyle;
      if (x2) {
        var C = x2.textAlign, D2 = C;
        C && (C === "middle" && (D2 = "center"), l2.style.textAlign = D2);
      }
    }
    var Ren = /^url\(\s*#(.*?)\)/;
    function gue(l2, a, e2, d2) {
      var y2 = e2 && e2.match(Ren);
      if (y2) {
        var x2 = TS(y2[1]);
        d2.push([l2, a, x2]);
        return;
      }
      return e2 === "none" && (e2 = null), e2;
    }
    function Nen(l2, a) {
      for (var e2 = 0; e2 < a.length; e2++) {
        var d2 = a[e2];
        d2[0].style[d2[1]] = l2[d2[2]];
      }
    }
    var Fen = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
    function umt(l2) {
      return l2.match(Fen) || [];
    }
    var Ven = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, SOt = Math.PI / 180;
    function Ben(l2, a) {
      var e2 = l2.getAttribute("transform");
      if (e2) {
        e2 = e2.replace(/,/g, " ");
        var d2 = [], y2 = null;
        e2.replace(Ven, function(U3, Y3, Q) {
          return d2.push(Y3, Q), "";
        });
        for (var x2 = d2.length - 1; x2 > 0; x2 -= 2) {
          var C = d2[x2], D2 = d2[x2 - 1], L = umt(C);
          switch (y2 = y2 || Xx(), D2) {
            case "translate":
              LS(y2, y2, [parseFloat(L[0]), parseFloat(L[1] || "0")]);
              break;
            case "scale":
              KU(y2, y2, [parseFloat(L[0]), parseFloat(L[1] || L[0])]);
              break;
            case "rotate":
              oO(y2, y2, -parseFloat(L[0]) * SOt);
              break;
            case "skewX":
              var F3 = Math.tan(parseFloat(L[0]) * SOt);
              lA(y2, [1, 0, F3, 1, 0, 0], y2);
              break;
            case "skewY":
              var j = Math.tan(parseFloat(L[0]) * SOt);
              lA(y2, [1, j, 0, 1, 0, 0], y2);
              break;
            case "matrix":
              y2[0] = parseFloat(L[0]), y2[1] = parseFloat(L[1]), y2[2] = parseFloat(L[2]), y2[3] = parseFloat(L[3]), y2[4] = parseFloat(L[4]), y2[5] = parseFloat(L[5]);
              break;
          }
        }
        a.setLocalTransform(y2);
      }
    }
    var vue = /([^\s:;]+)\s*:\s*([^:;]+)/g;
    function yue(l2, a, e2) {
      var d2 = l2.getAttribute("style");
      if (d2) {
        vue.lastIndex = 0;
        for (var y2; (y2 = vue.exec(d2)) != null; ) {
          var x2 = y2[1], C = Ns(smt, x2) ? smt[x2] : null;
          C && (a[C] = y2[2]);
          var D2 = Ns(lmt, x2) ? lmt[x2] : null;
          D2 && (e2[D2] = y2[2]);
        }
      }
    }
    function zen(l2, a, e2) {
      for (var d2 = 0; d2 < uue.length; d2++) {
        var y2 = uue[d2], x2 = l2.getAttribute(y2);
        x2 != null && (a[smt[y2]] = x2);
      }
      for (var d2 = 0; d2 < cue.length; d2++) {
        var y2 = cue[d2], x2 = l2.getAttribute(y2);
        x2 != null && (e2[lmt[y2]] = x2);
      }
    }
    function mue(l2, a) {
      var e2 = a.width / l2.width, d2 = a.height / l2.height, y2 = Math.min(e2, d2);
      return { scale: y2, x: -(l2.x + l2.width / 2) * y2 + (a.x + a.width / 2), y: -(l2.y + l2.height / 2) * y2 + (a.y + a.height / 2) };
    }
    function jen(l2, a) {
      var e2 = new Len();
      return e2.parse(l2, a);
    }
    var Wen = fl(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), Gen = function() {
      function l2(a, e2) {
        this.type = "geoSVG", this._usedGraphicMap = fl(), this._freedGraphics = [], this._mapName = a, this._parsedXML = lue(e2);
      }
      return l2.prototype.load = function() {
        var a = this._firstGraphic;
        if (!a) {
          a = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(a), this._boundingRect = this._firstGraphic.boundingRect.clone();
          var e2 = Uen(a.named), d2 = e2.regions, y2 = e2.regionsMap;
          this._regions = d2, this._regionsMap = y2;
        }
        return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
      }, l2.prototype._buildGraphic = function(a) {
        var e2, d2;
        try {
          e2 = a && jen(a, { ignoreViewBox: true, ignoreRootClip: true }) || {}, d2 = e2.root, vb2(d2 != null);
        } catch (vt) {
          throw new Error(`Invalid svg format
` + vt.message);
        }
        var y2 = new ou();
        y2.add(d2), y2.isGeoSVGGraphicRoot = true;
        var x2 = e2.width, C = e2.height, D2 = e2.viewBoxRect, L = this._boundingRect;
        if (!L) {
          var F3 = void 0, j = void 0, U3 = void 0, Y3 = void 0;
          if (x2 != null ? (F3 = 0, U3 = x2) : D2 && (F3 = D2.x, U3 = D2.width), C != null ? (j = 0, Y3 = C) : D2 && (j = D2.y, Y3 = D2.height), F3 == null || j == null) {
            var Q = d2.getBoundingRect();
            F3 == null && (F3 = Q.x, U3 = Q.width), j == null && (j = Q.y, Y3 = Q.height);
          }
          L = this._boundingRect = new Yu(F3, j, U3, Y3);
        }
        if (D2) {
          var nt = mue(D2, L);
          d2.scaleX = d2.scaleY = nt.scale, d2.x = nt.x, d2.y = nt.y;
        }
        y2.setClipPath(new Nf2({ shape: L.plain() }));
        var dt = [];
        return Ke2(e2.named, function(vt) {
          Wen.get(vt.svgNodeTagLower) != null && (dt.push(vt), Hen(vt.el));
        }), { root: y2, boundingRect: L, named: dt };
      }, l2.prototype.useGraphic = function(a) {
        var e2 = this._usedGraphicMap, d2 = e2.get(a);
        return d2 || (d2 = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), e2.set(a, d2), d2);
      }, l2.prototype.freeGraphic = function(a) {
        var e2 = this._usedGraphicMap, d2 = e2.get(a);
        d2 && (e2.removeKey(a), this._freedGraphics.push(d2));
      }, l2;
    }();
    function Hen(l2) {
      l2.silent = false, l2.isGroup && l2.traverse(function(a) {
        a.silent = false;
      });
    }
    function Uen(l2) {
      var a = [], e2 = fl();
      return Ke2(l2, function(d2) {
        if (d2.namedFrom == null) {
          var y2 = new uQe(d2.name, d2.el);
          a.push(y2), e2.set(d2.name, y2);
        }
      }), { regions: a, regionsMap: e2 };
    }
    for (var MOt = [126, 25], bue = "\u5357\u6D77\u8BF8\u5C9B", _B = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]], xB = 0; xB < _B.length; xB++)
      for (var cZ = 0; cZ < _B[xB].length; cZ++)
        _B[xB][cZ][0] /= 10.5, _B[xB][cZ][1] /= -10.5 / 0.75, _B[xB][cZ][0] += MOt[0], _B[xB][cZ][1] += MOt[1];
    function qen(l2, a) {
      if (l2 === "china") {
        for (var e2 = 0; e2 < a.length; e2++)
          if (a[e2].name === bue)
            return;
        a.push(new hse(bue, $a2(_B, function(d2) {
          return { type: "polygon", exterior: d2 };
        }), MOt));
      }
    }
    var Zen = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
    function $en(l2, a) {
      if (l2 === "china") {
        var e2 = Zen[a.name];
        if (e2) {
          var d2 = a.getCenter();
          d2[0] += e2[0] / 10.5, d2[1] += -e2[1] / (10.5 / 0.75), a.setCenter(d2);
        }
      }
    }
    var Yen = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
    function Ken(l2, a) {
      l2 === "china" && a.name === "\u53F0\u6E7E" && a.geometries.push({ type: "polygon", exterior: Yen[0] });
    }
    var Xen = "name", Qen = function() {
      function l2(a, e2, d2) {
        this.type = "geoJSON", this._parsedMap = fl(), this._mapName = a, this._specialAreas = d2, this._geoJSON = tnn(e2);
      }
      return l2.prototype.load = function(a, e2) {
        e2 = e2 || Xen;
        var d2 = this._parsedMap.get(e2);
        if (!d2) {
          var y2 = this._parseToRegions(e2);
          d2 = this._parsedMap.set(e2, { regions: y2, boundingRect: Jen(y2) });
        }
        var x2 = fl(), C = [];
        return Ke2(d2.regions, function(D2) {
          var L = D2.name;
          a && Ns(a, L) && (D2 = D2.cloneShallow(L = a[L])), C.push(D2), x2.set(L, D2);
        }), { regions: C, boundingRect: d2.boundingRect || new Yu(0, 0, 0, 0), regionsMap: x2 };
      }, l2.prototype._parseToRegions = function(a) {
        var e2 = this._mapName, d2 = this._geoJSON, y2;
        try {
          y2 = d2 ? fQe(d2, a) : [];
        } catch (x2) {
          throw new Error(`Invalid geoJson format
` + x2.message);
        }
        return qen(e2, y2), Ke2(y2, function(x2) {
          var C = x2.name;
          $en(e2, x2), Ken(e2, x2);
          var D2 = this._specialAreas && this._specialAreas[C];
          D2 && x2.transformTo(D2.left, D2.top, D2.width, D2.height);
        }, this), y2;
      }, l2.prototype.getMapForUser = function() {
        return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
      }, l2;
    }();
    function Jen(l2) {
      for (var a, e2 = 0; e2 < l2.length; e2++) {
        var d2 = l2[e2].getBoundingRect();
        a = a || d2.clone(), a.union(d2);
      }
      return a;
    }
    function tnn(l2) {
      return ps(l2) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(l2) : new Function("return (" + l2 + ");")() : l2;
    }
    var $rt = fl(), NO = { registerMap: function(l2, a, e2) {
      if (a.svg) {
        var d2 = new Gen(l2, a.svg);
        $rt.set(l2, d2);
      } else {
        var y2 = a.geoJson || a.geoJSON;
        y2 && !a.features ? e2 = a.specialAreas : y2 = a;
        var d2 = new Qen(l2, y2, e2);
        $rt.set(l2, d2);
      }
    }, getGeoResource: function(l2) {
      return $rt.get(l2);
    }, getMapForUser: function(l2) {
      var a = $rt.get(l2);
      return a && a.type === "geoJSON" && a.getMapForUser();
    }, load: function(l2, a, e2) {
      var d2 = $rt.get(l2);
      if (d2)
        return d2.load(a, e2);
    } }, COt = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], enn = fl(COt), nnn = fl(COt.concat(["g"])), rnn = fl(COt.concat(["g"])), _ue = Rf2();
    function cmt(l2) {
      var a = l2.getItemStyle(), e2 = l2.get("areaColor");
      return e2 != null && (a.fill = e2), a;
    }
    function xue(l2) {
      var a = l2.style;
      a && (a.stroke = a.stroke || a.fill, a.fill = null);
    }
    var inn = function() {
      function l2(a) {
        var e2 = new ou();
        this.uid = zq("ec_map_draw"), this._controller = new Zrt(a.getZr()), this._controllerHost = { target: e2 }, this.group = e2, e2.add(this._regionsGroup = new ou()), e2.add(this._svgGroup = new ou());
      }
      return l2.prototype.draw = function(a, e2, d2, y2, x2) {
        var C = a.mainType === "geo", D2 = a.getData && a.getData();
        C && e2.eachComponent({ mainType: "series", subType: "map" }, function(Ct) {
          !D2 && Ct.getHostGeoModel() === a && (D2 = Ct.getData());
        });
        var L = a.coordinateSystem, F3 = this._regionsGroup, j = this.group, U3 = L.getTransformInfo(), Y3 = U3.raw, Q = U3.roam, nt = !F3.childAt(0) || x2;
        nt ? (j.x = Q.x, j.y = Q.y, j.scaleX = Q.scaleX, j.scaleY = Q.scaleY, j.dirty()) : Yf2(j, Q, a);
        var dt = D2 && D2.getVisual("visualMeta") && D2.getVisual("visualMeta").length > 0, vt = { api: d2, geo: L, mapOrGeoModel: a, data: D2, isVisualEncodedByVisualMap: dt, isGeo: C, transformInfoRaw: Y3 };
        L.resourceType === "geoJSON" ? this._buildGeoJSON(vt) : L.resourceType === "geoSVG" && this._buildSVG(vt), this._updateController(a, e2, d2), this._updateMapSelectHandler(a, F3, d2, y2);
      }, l2.prototype._buildGeoJSON = function(a) {
        var e2 = this._regionsGroupByName = fl(), d2 = fl(), y2 = this._regionsGroup, x2 = a.transformInfoRaw, C = a.mapOrGeoModel, D2 = a.data, L = a.geo.projection, F3 = L && L.stream;
        function j(Q, nt) {
          return nt && (Q = nt(Q)), Q && [Q[0] * x2.scaleX + x2.x, Q[1] * x2.scaleY + x2.y];
        }
        function U3(Q) {
          for (var nt = [], dt = !F3 && L && L.project, vt = 0; vt < Q.length; ++vt) {
            var Ct = j(Q[vt], dt);
            Ct && nt.push(Ct);
          }
          return nt;
        }
        function Y3(Q) {
          return { shape: { points: U3(Q) } };
        }
        y2.removeAll(), Ke2(a.geo.regions, function(Q) {
          var nt = Q.name, dt = e2.get(nt), vt = d2.get(nt) || {}, Ct = vt.dataIdx, Pt = vt.regionModel;
          dt || (dt = e2.set(nt, new ou()), y2.add(dt), Ct = D2 ? D2.indexOfName(nt) : null, Pt = a.isGeo ? C.getRegionModel(nt) : D2 ? D2.getItemModel(Ct) : null, d2.set(nt, { dataIdx: Ct, regionModel: Pt }));
          var jt = [], Rt = [];
          Ke2(Q.geometries, function(he2) {
            if (he2.type === "polygon") {
              var _e = [he2.exterior].concat(he2.interiors || []);
              F3 && (_e = Aue(_e, F3)), Ke2(_e, function(Pe2) {
                jt.push(new rw(Y3(Pe2)));
              });
            } else {
              var Me2 = he2.points;
              F3 && (Me2 = Aue(Me2, F3, true)), Ke2(Me2, function(Pe2) {
                Rt.push(new iw(Y3(Pe2)));
              });
            }
          });
          var le2 = j(Q.getCenter(), L && L.project);
          function ne2(he2, _e) {
            if (he2.length) {
              var Me2 = new Jnt({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: he2 } });
              dt.add(Me2), wue(a, Me2, Ct, Pt), Sue(a, Me2, nt, Pt, C, Ct, le2), _e && (xue(Me2), Ke2(Me2.states, xue));
            }
          }
          ne2(jt), ne2(Rt, true);
        }), e2.each(function(Q, nt) {
          var dt = d2.get(nt), vt = dt.dataIdx, Ct = dt.regionModel;
          Mue(a, Q, nt, Ct, C, vt), Cue(a, Q, nt, Ct, C), Tue(a, Q, nt, Ct, C);
        }, this);
      }, l2.prototype._buildSVG = function(a) {
        var e2 = a.geo.map, d2 = a.transformInfoRaw;
        this._svgGroup.x = d2.x, this._svgGroup.y = d2.y, this._svgGroup.scaleX = d2.scaleX, this._svgGroup.scaleY = d2.scaleY, this._svgResourceChanged(e2) && (this._freeSVG(), this._useSVG(e2));
        var y2 = this._svgDispatcherMap = fl(), x2 = false;
        Ke2(this._svgGraphicRecord.named, function(C) {
          var D2 = C.name, L = a.mapOrGeoModel, F3 = a.data, j = C.svgNodeTagLower, U3 = C.el, Y3 = F3 ? F3.indexOfName(D2) : null, Q = L.getRegionModel(D2);
          if (enn.get(j) != null && U3 instanceof Y2 && wue(a, U3, Y3, Q), U3 instanceof Y2 && (U3.culling = true), U3.z2EmphasisLift = 0, !C.namedFrom && (rnn.get(j) != null && Sue(a, U3, D2, Q, L, Y3, null), Mue(a, U3, D2, Q, L, Y3), Cue(a, U3, D2, Q, L), nnn.get(j) != null)) {
            var nt = Tue(a, U3, D2, Q, L);
            nt === "self" && (x2 = true);
            var dt = y2.get(D2) || y2.set(D2, []);
            dt.push(U3);
          }
        }, this), this._enableBlurEntireSVG(x2, a);
      }, l2.prototype._enableBlurEntireSVG = function(a, e2) {
        if (a && e2.isGeo) {
          var d2 = e2.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), y2 = d2.opacity;
          this._svgGraphicRecord.root.traverse(function(x2) {
            if (!x2.isGroup) {
              SO(x2);
              var C = x2.ensureState("blur").style || {};
              C.opacity == null && y2 != null && (C.opacity = y2), x2.ensureState("emphasis");
            }
          });
        }
      }, l2.prototype.remove = function() {
        this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
      }, l2.prototype.findHighDownDispatchers = function(a, e2) {
        if (a == null)
          return [];
        var d2 = e2.coordinateSystem;
        if (d2.resourceType === "geoJSON") {
          var y2 = this._regionsGroupByName;
          if (y2) {
            var x2 = y2.get(a);
            return x2 ? [x2] : [];
          }
        } else if (d2.resourceType === "geoSVG")
          return this._svgDispatcherMap && this._svgDispatcherMap.get(a) || [];
      }, l2.prototype._svgResourceChanged = function(a) {
        return this._svgMapName !== a;
      }, l2.prototype._useSVG = function(a) {
        var e2 = NO.getGeoResource(a);
        if (e2 && e2.type === "geoSVG") {
          var d2 = e2.useGraphic(this.uid);
          this._svgGroup.add(d2.root), this._svgGraphicRecord = d2, this._svgMapName = a;
        }
      }, l2.prototype._freeSVG = function() {
        var a = this._svgMapName;
        if (a != null) {
          var e2 = NO.getGeoResource(a);
          e2 && e2.type === "geoSVG" && e2.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
        }
      }, l2.prototype._updateController = function(a, e2, d2) {
        var y2 = a.coordinateSystem, x2 = this._controller, C = this._controllerHost;
        C.zoomLimit = a.get("scaleLimit"), C.zoom = y2.getZoom(), x2.enable(a.get("roam") || false);
        var D2 = a.mainType;
        function L() {
          var F3 = { type: "geoRoam", componentType: D2 };
          return F3[D2 + "Id"] = a.id, F3;
        }
        x2.off("pan").on("pan", function(F3) {
          this._mouseDownFlag = false, _Ot(C, F3.dx, F3.dy), d2.dispatchAction(la2(L(), { dx: F3.dx, dy: F3.dy, animation: { duration: 0 } }));
        }, this), x2.off("zoom").on("zoom", function(F3) {
          this._mouseDownFlag = false, xOt(C, F3.scale, F3.originX, F3.originY), d2.dispatchAction(la2(L(), { zoom: F3.scale, originX: F3.originX, originY: F3.originY, animation: { duration: 0 } }));
        }, this), x2.setPointerChecker(function(F3, j, U3) {
          return y2.containPoint([j, U3]) && !omt(F3, d2, a);
        });
      }, l2.prototype.resetForLabelLayout = function() {
        this.group.traverse(function(a) {
          var e2 = a.getTextContent();
          e2 && (e2.ignore = _ue(e2).ignore);
        });
      }, l2.prototype._updateMapSelectHandler = function(a, e2, d2, y2) {
        var x2 = this;
        e2.off("mousedown"), e2.off("click"), a.get("selectedMode") && (e2.on("mousedown", function() {
          x2._mouseDownFlag = true;
        }), e2.on("click", function(C) {
          !x2._mouseDownFlag || (x2._mouseDownFlag = false);
        }));
      }, l2;
    }();
    function wue(l2, a, e2, d2) {
      var y2 = d2.getModel("itemStyle"), x2 = d2.getModel(["emphasis", "itemStyle"]), C = d2.getModel(["blur", "itemStyle"]), D2 = d2.getModel(["select", "itemStyle"]), L = cmt(y2), F3 = cmt(x2), j = cmt(D2), U3 = cmt(C), Y3 = l2.data;
      if (Y3) {
        var Q = Y3.getItemVisual(e2, "style"), nt = Y3.getItemVisual(e2, "decal");
        l2.isVisualEncodedByVisualMap && Q.fill && (L.fill = Q.fill), nt && (L.decal = xrt(nt, l2.api));
      }
      a.setStyle(L), a.style.strokeNoScale = true, a.ensureState("emphasis").style = F3, a.ensureState("select").style = j, a.ensureState("blur").style = U3, SO(a);
    }
    function Sue(l2, a, e2, d2, y2, x2, C) {
      var D2 = l2.data, L = l2.isGeo, F3 = D2 && isNaN(D2.get(D2.mapDimension("value"), x2)), j = D2 && D2.getItemLayout(x2);
      if (L || F3 || j && j.showLabel) {
        var U3 = L ? e2 : x2, Y3 = void 0;
        (!D2 || x2 >= 0) && (Y3 = y2);
        var Q = C ? { normal: { align: "center", verticalAlign: "middle" } } : null;
        ow(a, Sb2(d2), { labelFetcher: Y3, labelDataIndex: U3, defaultText: e2 }, Q);
        var nt = a.getTextContent();
        if (nt && (_ue(nt).ignore = nt.ignore, a.textConfig && C)) {
          var dt = a.getBoundingRect().clone();
          a.textConfig.layoutRect = dt, a.textConfig.position = [(C[0] - dt.x) / dt.width * 100 + "%", (C[1] - dt.y) / dt.height * 100 + "%"];
        }
        a.disableLabelAnimation = true;
      } else
        a.removeTextContent(), a.removeTextConfig(), a.disableLabelAnimation = null;
    }
    function Mue(l2, a, e2, d2, y2, x2) {
      l2.data ? l2.data.setItemGraphicEl(x2, a) : ns(a).eventData = { componentType: "geo", componentIndex: y2.componentIndex, geoIndex: y2.componentIndex, name: e2, region: d2 && d2.option || {} };
    }
    function Cue(l2, a, e2, d2, y2) {
      l2.data || Vq({ el: a, componentModel: y2, itemName: e2, itemTooltipOption: d2.get("tooltip") });
    }
    function Tue(l2, a, e2, d2, y2) {
      a.highDownSilentOnTouch = !!y2.get("selectedMode");
      var x2 = d2.getModel("emphasis"), C = x2.get("focus");
      return n0(a, C, x2.get("blurScope"), x2.get("disabled")), l2.isGeo && ZPt(a, y2, e2), C;
    }
    function Aue(l2, a, e2) {
      var d2 = [], y2;
      function x2() {
        y2 = [];
      }
      function C() {
        y2.length && (d2.push(y2), y2 = []);
      }
      var D2 = a({ polygonStart: x2, polygonEnd: C, lineStart: x2, lineEnd: C, point: function(L, F3) {
        isFinite(L) && isFinite(F3) && y2.push([L, F3]);
      }, sphere: function() {
      } });
      return !e2 && D2.polygonStart(), Ke2(l2, function(L) {
        D2.lineStart();
        for (var F3 = 0; F3 < L.length; F3++)
          D2.point(L[F3][0], L[F3][1]);
        D2.lineEnd();
      }), !e2 && D2.polygonEnd(), d2;
    }
    var Iue = inn, ann = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        if (!(x2 && x2.type === "mapToggleSelect" && x2.from === this.uid)) {
          var C = this.group;
          if (C.removeAll(), !e2.getHostGeoModel()) {
            if (this._mapDraw && x2 && x2.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), x2 && x2.type === "geoRoam" && x2.componentType === "series" && x2.seriesId === e2.id) {
              var D2 = this._mapDraw;
              D2 && C.add(D2.group);
            } else if (e2.needsDrawMap) {
              var D2 = this._mapDraw || new Iue(y2);
              C.add(D2.group), D2.draw(e2, d2, y2, this, x2), this._mapDraw = D2;
            } else
              this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
            e2.get("showLegendSymbol") && d2.getComponent("legend") && this._renderSymbols(e2, d2, y2);
          }
        }
      }, a.prototype.remove = function() {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
      }, a.prototype.dispose = function() {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
      }, a.prototype._renderSymbols = function(e2, d2, y2) {
        var x2 = e2.originalData, C = this.group;
        x2.each(x2.mapDimension("value"), function(D2, L) {
          if (!isNaN(D2)) {
            var F3 = x2.getItemLayout(L);
            if (!(!F3 || !F3.point)) {
              var j = F3.point, U3 = F3.offset, Y3 = new _A({ style: { fill: e2.getData().getVisual("style").fill }, shape: { cx: j[0] + U3 * 9, cy: j[1], r: 3 }, silent: true, z2: 8 + (U3 ? 0 : nP + 1) });
              if (!U3) {
                var Q = e2.mainSeries.getData(), nt = x2.getName(L), dt = Q.indexOfName(nt), vt = x2.getItemModel(L), Ct = vt.getModel("label"), Pt = Q.getItemGraphicEl(dt);
                ow(Y3, Sb2(vt), { labelFetcher: { getFormattedLabel: function(jt, Rt) {
                  return e2.getFormattedLabel(dt, Rt);
                } }, defaultText: nt }), Y3.disableLabelAnimation = true, Ct.get("position") || Y3.setTextConfig({ position: "bottom" }), Pt.onHoverStateChange = function(jt) {
                  wO(Y3, jt);
                };
              }
              C.add(Y3);
            }
          }
        });
      }, a.type = "map", a;
    }(pg2), onn = ann, snn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.needsDrawMap = false, e2.seriesGroup = [], e2.getTooltipPosition = function(d2) {
          if (d2 != null) {
            var y2 = this.getData().getName(d2), x2 = this.coordinateSystem, C = x2.getRegion(y2);
            return C && x2.dataToPoint(C.getCenter());
          }
        }, e2;
      }
      return a.prototype.getInitialData = function(e2) {
        for (var d2 = lZ(this, { coordDimensions: ["value"], encodeDefaulter: xu(R3t, this) }), y2 = fl(), x2 = [], C = 0, D2 = d2.count(); C < D2; C++) {
          var L = d2.getName(C);
          y2.set(L, true);
        }
        var F3 = NO.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
        return Ke2(F3.regions, function(j) {
          var U3 = j.name;
          y2.get(U3) || x2.push(U3);
        }), d2.appendValues([], x2), d2;
      }, a.prototype.getHostGeoModel = function() {
        var e2 = this.option.geoIndex;
        return e2 != null ? this.ecModel.getComponent("geo", e2) : null;
      }, a.prototype.getMapType = function() {
        return (this.getHostGeoModel() || this).option.map;
      }, a.prototype.getRawValue = function(e2) {
        var d2 = this.getData();
        return d2.get(d2.mapDimension("value"), e2);
      }, a.prototype.getRegionModel = function(e2) {
        var d2 = this.getData();
        return d2.getItemModel(d2.indexOfName(e2));
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        for (var x2 = this.getData(), C = this.getRawValue(e2), D2 = x2.getName(e2), L = this.seriesGroup, F3 = [], j = 0; j < L.length; j++) {
          var U3 = L[j].originalData.indexOfName(D2), Y3 = x2.mapDimension("value");
          isNaN(L[j].originalData.get(Y3, U3)) || F3.push(L[j].name);
        }
        return b1("section", { header: F3.join(", "), noHeader: !F3.length, blocks: [b1("nameValue", { name: D2, value: C })] });
      }, a.prototype.setZoom = function(e2) {
        this.option.zoom = e2;
      }, a.prototype.setCenter = function(e2) {
        this.option.center = e2;
      }, a.prototype.getLegendIcon = function(e2) {
        var d2 = e2.icon || "roundRect", y2 = qy(d2, 0, 0, e2.itemWidth, e2.itemHeight, e2.itemStyle.fill);
        return y2.setStyle(e2.itemStyle), y2.style.stroke = "none", d2.indexOf("empty") > -1 && (y2.style.stroke = y2.style.fill, y2.style.fill = "#fff", y2.style.lineWidth = 2), y2;
      }, a.type = "series.map", a.dependencies = ["geo"], a.layoutMode = "box", a.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, a;
    }(Pv), lnn = snn;
    function unn(l2, a) {
      var e2 = {};
      return Ke2(l2, function(d2) {
        d2.each(d2.mapDimension("value"), function(y2, x2) {
          var C = "ec-" + d2.getName(x2);
          e2[C] = e2[C] || [], isNaN(y2) || e2[C].push(y2);
        });
      }), l2[0].map(l2[0].mapDimension("value"), function(d2, y2) {
        for (var x2 = "ec-" + l2[0].getName(y2), C = 0, D2 = 1 / 0, L = -1 / 0, F3 = e2[x2].length, j = 0; j < F3; j++)
          D2 = Math.min(D2, e2[x2][j]), L = Math.max(L, e2[x2][j]), C += e2[x2][j];
        var U3;
        return a === "min" ? U3 = D2 : a === "max" ? U3 = L : a === "average" ? U3 = C / F3 : U3 = C, F3 === 0 ? NaN : U3;
      });
    }
    function cnn(l2) {
      var a = {};
      l2.eachSeriesByType("map", function(e2) {
        var d2 = e2.getHostGeoModel(), y2 = d2 ? "o" + d2.id : "i" + e2.getMapType();
        (a[y2] = a[y2] || []).push(e2);
      }), Ke2(a, function(e2, d2) {
        for (var y2 = unn($a2(e2, function(C) {
          return C.getData();
        }), e2[0].get("mapValueCalculation")), x2 = 0; x2 < e2.length; x2++)
          e2[x2].originalData = e2[x2].getData();
        for (var x2 = 0; x2 < e2.length; x2++)
          e2[x2].seriesGroup = e2, e2[x2].needsDrawMap = x2 === 0 && !e2[x2].getHostGeoModel(), e2[x2].setData(y2.cloneShallow()), e2[x2].mainSeries = e2[0];
      });
    }
    function fnn(l2) {
      var a = {};
      l2.eachSeriesByType("map", function(e2) {
        var d2 = e2.getMapType();
        if (!(e2.getHostGeoModel() || a[d2])) {
          var y2 = {};
          Ke2(e2.seriesGroup, function(C) {
            var D2 = C.coordinateSystem, L = C.originalData;
            C.get("showLegendSymbol") && l2.getComponent("legend") && L.each(L.mapDimension("value"), function(F3, j) {
              var U3 = L.getName(j), Y3 = D2.getRegion(U3);
              if (!(!Y3 || isNaN(F3))) {
                var Q = y2[U3] || 0, nt = D2.dataToPoint(Y3.getCenter());
                y2[U3] = Q + 1, L.setItemLayout(j, { point: nt, offset: Q });
              }
            });
          });
          var x2 = e2.getData();
          x2.each(function(C) {
            var D2 = x2.getName(C), L = x2.getItemLayout(C) || {};
            L.showLabel = !y2[D2], x2.setItemLayout(C, L);
          }), a[d2] = true;
        }
      });
    }
    var Due = Mm, hnn = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this) || this;
        return d2.type = "view", d2.dimensions = ["x", "y"], d2._roamTransformable = new OS(), d2._rawTransformable = new OS(), d2.name = e2, d2;
      }
      return a.prototype.setBoundingRect = function(e2, d2, y2, x2) {
        return this._rect = new Yu(e2, d2, y2, x2), this._rect;
      }, a.prototype.getBoundingRect = function() {
        return this._rect;
      }, a.prototype.setViewRect = function(e2, d2, y2, x2) {
        this._transformTo(e2, d2, y2, x2), this._viewRect = new Yu(e2, d2, y2, x2);
      }, a.prototype._transformTo = function(e2, d2, y2, x2) {
        var C = this.getBoundingRect(), D2 = this._rawTransformable;
        D2.transform = C.calculateTransform(new Yu(e2, d2, y2, x2));
        var L = D2.parent;
        D2.parent = null, D2.decomposeTransform(), D2.parent = L, this._updateTransform();
      }, a.prototype.setCenter = function(e2) {
        !e2 || (this._center = e2, this._updateCenterAndZoom());
      }, a.prototype.setZoom = function(e2) {
        e2 = e2 || 1;
        var d2 = this.zoomLimit;
        d2 && (d2.max != null && (e2 = Math.min(d2.max, e2)), d2.min != null && (e2 = Math.max(d2.min, e2))), this._zoom = e2, this._updateCenterAndZoom();
      }, a.prototype.getDefaultCenter = function() {
        var e2 = this.getBoundingRect(), d2 = e2.x + e2.width / 2, y2 = e2.y + e2.height / 2;
        return [d2, y2];
      }, a.prototype.getCenter = function() {
        return this._center || this.getDefaultCenter();
      }, a.prototype.getZoom = function() {
        return this._zoom || 1;
      }, a.prototype.getRoamTransform = function() {
        return this._roamTransformable.getLocalTransform();
      }, a.prototype._updateCenterAndZoom = function() {
        var e2 = this._rawTransformable.getLocalTransform(), d2 = this._roamTransformable, y2 = this.getDefaultCenter(), x2 = this.getCenter(), C = this.getZoom();
        x2 = Mm([], x2, e2), y2 = Mm([], y2, e2), d2.originX = x2[0], d2.originY = x2[1], d2.x = y2[0] - x2[0], d2.y = y2[1] - x2[1], d2.scaleX = d2.scaleY = C, this._updateTransform();
      }, a.prototype._updateTransform = function() {
        var e2 = this._roamTransformable, d2 = this._rawTransformable;
        d2.parent = e2, e2.updateTransform(), d2.updateTransform(), YU(this.transform || (this.transform = []), d2.transform || Xx()), this._rawTransform = d2.getLocalTransform(), this.invTransform = this.invTransform || [], sO(this.invTransform, this.transform), this.decomposeTransform();
      }, a.prototype.getTransformInfo = function() {
        var e2 = this._rawTransformable, d2 = this._roamTransformable, y2 = new OS();
        return y2.transform = d2.transform, y2.decomposeTransform(), { roam: { x: y2.x, y: y2.y, scaleX: y2.scaleX, scaleY: y2.scaleY }, raw: { x: e2.x, y: e2.y, scaleX: e2.scaleX, scaleY: e2.scaleY } };
      }, a.prototype.getViewRect = function() {
        return this._viewRect;
      }, a.prototype.getViewRectAfterRoam = function() {
        var e2 = this.getBoundingRect().clone();
        return e2.applyTransform(this.transform), e2;
      }, a.prototype.dataToPoint = function(e2, d2, y2) {
        var x2 = d2 ? this._rawTransform : this.transform;
        return y2 = y2 || [], x2 ? Due(y2, e2, x2) : y0(y2, e2);
      }, a.prototype.pointToData = function(e2) {
        var d2 = this.invTransform;
        return d2 ? Due([], e2, d2) : [e2[0], e2[1]];
      }, a.prototype.convertToPixel = function(e2, d2, y2) {
        var x2 = Eue(d2);
        return x2 === this ? x2.dataToPoint(y2) : null;
      }, a.prototype.convertFromPixel = function(e2, d2, y2) {
        var x2 = Eue(d2);
        return x2 === this ? x2.pointToData(y2) : null;
      }, a.prototype.containPoint = function(e2) {
        return this.getViewRectAfterRoam().contain(e2[0], e2[1]);
      }, a.dimensions = ["x", "y"], a;
    }(OS);
    function Eue(l2) {
      var a = l2.seriesModel;
      return a ? a.coordinateSystem : null;
    }
    var Yrt = hnn, pnn = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, kue = ["lng", "lat"], Pue = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this, e2) || this;
        x2.dimensions = kue, x2.type = "geo", x2._nameCoordMap = fl(), x2.map = d2;
        var C = y2.projection, D2 = NO.load(d2, y2.nameMap, y2.nameProperty), L = NO.getGeoResource(d2);
        x2.resourceType = L ? L.type : null;
        var F3 = x2.regions = D2.regions, j = pnn[L.type];
        x2._regionsMap = D2.regionsMap, x2.regions = D2.regions, x2.projection = C;
        var U3;
        if (C)
          for (var Y3 = 0; Y3 < F3.length; Y3++) {
            var Q = F3[Y3].getBoundingRect(C);
            U3 = U3 || Q.clone(), U3.union(Q);
          }
        else
          U3 = D2.boundingRect;
        return x2.setBoundingRect(U3.x, U3.y, U3.width, U3.height), x2.aspectScale = C ? 1 : $u(y2.aspectScale, j.aspectScale), x2._invertLongitute = C ? false : j.invertLongitute, x2;
      }
      return a.prototype._transformTo = function(e2, d2, y2, x2) {
        var C = this.getBoundingRect(), D2 = this._invertLongitute;
        C = C.clone(), D2 && (C.y = -C.y - C.height);
        var L = this._rawTransformable;
        L.transform = C.calculateTransform(new Yu(e2, d2, y2, x2));
        var F3 = L.parent;
        L.parent = null, L.decomposeTransform(), L.parent = F3, D2 && (L.scaleY = -L.scaleY), this._updateTransform();
      }, a.prototype.getRegion = function(e2) {
        return this._regionsMap.get(e2);
      }, a.prototype.getRegionByCoord = function(e2) {
        for (var d2 = this.regions, y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2];
          if (x2.type === "geoJSON" && x2.contain(e2))
            return d2[y2];
        }
      }, a.prototype.addGeoCoord = function(e2, d2) {
        this._nameCoordMap.set(e2, d2);
      }, a.prototype.getGeoCoord = function(e2) {
        var d2 = this._regionsMap.get(e2);
        return this._nameCoordMap.get(e2) || d2 && d2.getCenter();
      }, a.prototype.dataToPoint = function(e2, d2, y2) {
        if (ps(e2) && (e2 = this.getGeoCoord(e2)), e2) {
          var x2 = this.projection;
          return x2 && (e2 = x2.project(e2)), e2 && this.projectedToPoint(e2);
        }
      }, a.prototype.pointToData = function(e2) {
        var d2 = this.projection;
        return d2 && (e2 = d2.unproject(e2)), e2 && this.pointToProjected(e2);
      }, a.prototype.pointToProjected = function(e2) {
        return l2.prototype.pointToData.call(this, e2);
      }, a.prototype.projectedToPoint = function(e2, d2, y2) {
        return l2.prototype.dataToPoint.call(this, e2, d2, y2);
      }, a.prototype.convertToPixel = function(e2, d2, y2) {
        var x2 = Lue(d2);
        return x2 === this ? x2.dataToPoint(y2) : null;
      }, a.prototype.convertFromPixel = function(e2, d2, y2) {
        var x2 = Lue(d2);
        return x2 === this ? x2.pointToData(y2) : null;
      }, a;
    }(Yrt);
    v0(Pue, Yrt);
    function Lue(l2) {
      var a = l2.geoModel, e2 = l2.seriesModel;
      return a ? a.coordinateSystem : e2 ? e2.coordinateSystem || (e2.getReferringComponents("geo", q0).models[0] || {}).coordinateSystem : null;
    }
    var Oue = Pue;
    function Rue(l2, a) {
      var e2 = l2.get("boundingCoords");
      if (e2 != null) {
        var d2 = e2[0], y2 = e2[1];
        if (isFinite(d2[0]) && isFinite(d2[1]) && isFinite(y2[0]) && isFinite(y2[1])) {
          var x2 = this.projection;
          if (x2) {
            var C = d2[0], D2 = d2[1], L = y2[0], F3 = y2[1];
            d2 = [1 / 0, 1 / 0], y2 = [-1 / 0, -1 / 0];
            var j = function(ne2, he2, _e, Me2) {
              for (var Pe2 = _e - ne2, Be2 = Me2 - he2, Je2 = 0; Je2 <= 100; Je2++) {
                var Ze2 = Je2 / 100, Cn = x2.project([ne2 + Pe2 * Ze2, he2 + Be2 * Ze2]);
                vE(d2, d2, Cn), nA(y2, y2, Cn);
              }
            };
            j(C, D2, L, D2), j(L, D2, L, F3), j(L, F3, C, F3), j(C, F3, L, D2);
          }
          this.setBoundingRect(d2[0], d2[1], y2[0] - d2[0], y2[1] - d2[1]);
        }
      }
      var U3 = this.getBoundingRect(), Y3 = l2.get("layoutCenter"), Q = l2.get("layoutSize"), nt = a.getWidth(), dt = a.getHeight(), vt = U3.width / U3.height * this.aspectScale, Ct = false, Pt, jt;
      Y3 && Q && (Pt = [Ko(Y3[0], nt), Ko(Y3[1], dt)], jt = Ko(Q, Math.min(nt, dt)), !isNaN(Pt[0]) && !isNaN(Pt[1]) && !isNaN(jt) && (Ct = true));
      var Rt;
      if (Ct)
        Rt = {}, vt > 1 ? (Rt.width = jt, Rt.height = jt / vt) : (Rt.height = jt, Rt.width = jt * vt), Rt.y = Pt[1] - Rt.height / 2, Rt.x = Pt[0] - Rt.width / 2;
      else {
        var le2 = l2.getBoxLayoutParams();
        le2.aspect = vt, Rt = Em(le2, { width: nt, height: dt });
      }
      this.setViewRect(Rt.x, Rt.y, Rt.width, Rt.height), this.setCenter(l2.get("center")), this.setZoom(l2.get("zoom"));
    }
    function dnn(l2, a) {
      Ke2(a.get("geoCoord"), function(e2, d2) {
        l2.addGeoCoord(d2, e2);
      });
    }
    var gnn = function() {
      function l2() {
        this.dimensions = kue;
      }
      return l2.prototype.create = function(a, e2) {
        var d2 = [];
        function y2(C) {
          return { nameProperty: C.get("nameProperty"), aspectScale: C.get("aspectScale"), projection: C.get("projection") };
        }
        a.eachComponent("geo", function(C, D2) {
          var L = C.get("map"), F3 = new Oue(L + D2, L, la2({ nameMap: C.get("nameMap") }, y2(C)));
          F3.zoomLimit = C.get("scaleLimit"), d2.push(F3), C.coordinateSystem = F3, F3.model = C, F3.resize = Rue, F3.resize(C, e2);
        }), a.eachSeries(function(C) {
          var D2 = C.get("coordinateSystem");
          if (D2 === "geo") {
            var L = C.get("geoIndex") || 0;
            C.coordinateSystem = d2[L];
          }
        });
        var x2 = {};
        return a.eachSeriesByType("map", function(C) {
          if (!C.getHostGeoModel()) {
            var D2 = C.getMapType();
            x2[D2] = x2[D2] || [], x2[D2].push(C);
          }
        }), Ke2(x2, function(C, D2) {
          var L = $a2(C, function(j) {
            return j.get("nameMap");
          }), F3 = new Oue(D2, D2, la2({ nameMap: IU(L) }, y2(C[0])));
          F3.zoomLimit = jy.apply(null, $a2(C, function(j) {
            return j.get("scaleLimit");
          })), d2.push(F3), F3.resize = Rue, F3.resize(C[0], e2), Ke2(C, function(j) {
            j.coordinateSystem = F3, dnn(F3, j);
          });
        }), d2;
      }, l2.prototype.getFilledRegions = function(a, e2, d2, y2) {
        for (var x2 = (a || []).slice(), C = fl(), D2 = 0; D2 < x2.length; D2++)
          C.set(x2[D2].name, x2[D2]);
        var L = NO.load(e2, d2, y2);
        return Ke2(L.regions, function(F3) {
          var j = F3.name;
          !C.get(j) && x2.push({ name: j });
        }), x2;
      }, l2;
    }(), vnn = new gnn(), Nue = vnn, ynn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        var x2 = NO.getGeoResource(e2.map);
        if (x2 && x2.type === "geoJSON") {
          var C = e2.itemStyle = e2.itemStyle || {};
          "color" in C || (C.color = "#eee");
        }
        this.mergeDefaultAndTheme(e2, y2), RS(e2, "label", ["show"]);
      }, a.prototype.optionUpdated = function() {
        var e2 = this, d2 = this.option;
        d2.regions = Nue.getFilledRegions(d2.regions, d2.map, d2.nameMap, d2.nameProperty);
        var y2 = {};
        this._optionModelMap = tA(d2.regions || [], function(x2, C) {
          var D2 = C.name;
          return D2 && (x2.set(D2, new hg2(C, e2, e2.ecModel)), C.selected && (y2[D2] = true)), x2;
        }, fl()), d2.selectedMap || (d2.selectedMap = y2);
      }, a.prototype.getRegionModel = function(e2) {
        return this._optionModelMap.get(e2) || new hg2(null, this, this.ecModel);
      }, a.prototype.getFormattedLabel = function(e2, d2) {
        var y2 = this.getRegionModel(e2), x2 = d2 === "normal" ? y2.get(["label", "formatter"]) : y2.get(["emphasis", "label", "formatter"]), C = { name: e2 };
        if (wl(x2))
          return C.status = d2, x2(C);
        if (ps(x2))
          return x2.replace("{a}", e2 != null ? e2 : "");
      }, a.prototype.setZoom = function(e2) {
        this.option.zoom = e2;
      }, a.prototype.setCenter = function(e2) {
        this.option.center = e2;
      }, a.prototype.select = function(e2) {
        var d2 = this.option, y2 = d2.selectedMode;
        if (y2) {
          y2 !== "multiple" && (d2.selectedMap = null);
          var x2 = d2.selectedMap || (d2.selectedMap = {});
          x2[e2] = true;
        }
      }, a.prototype.unSelect = function(e2) {
        var d2 = this.option.selectedMap;
        d2 && (d2[e2] = false);
      }, a.prototype.toggleSelected = function(e2) {
        this[this.isSelected(e2) ? "unSelect" : "select"](e2);
      }, a.prototype.isSelected = function(e2) {
        var d2 = this.option.selectedMap;
        return !!(d2 && d2[e2]);
      }, a.type = "geo", a.layoutMode = "box", a.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, a;
    }(Ah2), mnn = ynn;
    function Fue(l2, a) {
      return l2.pointToProjected ? l2.pointToProjected(a) : l2.pointToData(a);
    }
    function TOt(l2, a, e2) {
      var d2 = l2.getZoom(), y2 = l2.getCenter(), x2 = a.zoom, C = l2.projectedToPoint ? l2.projectedToPoint(y2) : l2.dataToPoint(y2);
      if (a.dx != null && a.dy != null && (C[0] -= a.dx, C[1] -= a.dy, l2.setCenter(Fue(l2, C))), x2 != null) {
        if (e2) {
          var D2 = e2.min || 0, L = e2.max || 1 / 0;
          x2 = Math.max(Math.min(d2 * x2, L), D2) / d2;
        }
        l2.scaleX *= x2, l2.scaleY *= x2;
        var F3 = (a.originX - l2.x) * (x2 - 1), j = (a.originY - l2.y) * (x2 - 1);
        l2.x -= F3, l2.y -= j, l2.updateTransform(), l2.setCenter(Fue(l2, C)), l2.setZoom(x2 * d2);
      }
      return { center: l2.getCenter(), zoom: l2.getZoom() };
    }
    var bnn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.focusBlurEnabled = true, e2;
      }
      return a.prototype.init = function(e2, d2) {
        this._api = d2;
      }, a.prototype.render = function(e2, d2, y2, x2) {
        if (this._model = e2, !e2.get("show")) {
          this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          return;
        }
        this._mapDraw || (this._mapDraw = new Iue(y2));
        var C = this._mapDraw;
        C.draw(e2, d2, y2, this, x2), C.group.on("click", this._handleRegionClick, this), C.group.silent = e2.get("silent"), this.group.add(C.group), this.updateSelectStatus(e2, d2, y2);
      }, a.prototype._handleRegionClick = function(e2) {
        var d2;
        Jq(e2.target, function(y2) {
          return (d2 = ns(y2).eventData) != null;
        }, true), d2 && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: d2.name });
      }, a.prototype.updateSelectStatus = function(e2, d2, y2) {
        var x2 = this;
        this._mapDraw.group.traverse(function(C) {
          var D2 = ns(C).eventData;
          if (D2)
            return x2._model.isSelected(D2.name) ? y2.enterSelect(C) : y2.leaveSelect(C), true;
        });
      }, a.prototype.findHighDownDispatchers = function(e2) {
        return this._mapDraw && this._mapDraw.findHighDownDispatchers(e2, this._model);
      }, a.prototype.dispose = function() {
        this._mapDraw && this._mapDraw.remove();
      }, a.type = "geo", a;
    }(_0), _nn = bnn;
    function xnn(l2, a, e2) {
      NO.registerMap(l2, a, e2);
    }
    function Vue(l2) {
      l2.registerCoordinateSystem("geo", Nue), l2.registerComponentModel(mnn), l2.registerComponentView(_nn), l2.registerImpl("registerMap", xnn), l2.registerImpl("getMap", function(e2) {
        return NO.getMapForUser(e2);
      });
      function a(e2, d2) {
        d2.update = "geo:updateSelectStatus", l2.registerAction(d2, function(y2, x2) {
          var C = {}, D2 = [];
          return x2.eachComponent({ mainType: "geo", query: y2 }, function(L) {
            L[e2](y2.name);
            var F3 = L.coordinateSystem;
            Ke2(F3.regions, function(U3) {
              C[U3.name] = L.isSelected(U3.name) || false;
            });
            var j = [];
            Ke2(C, function(U3, Y3) {
              C[Y3] && j.push(Y3);
            }), D2.push({ geoIndex: L.componentIndex, name: j });
          }), { selected: C, allSelected: D2, name: y2.name };
        });
      }
      a("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), a("select", { type: "geoSelect", event: "geoselected" }), a("unSelect", { type: "geoUnSelect", event: "geounselected" }), l2.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(e2, d2) {
        var y2 = e2.componentType || "series";
        d2.eachComponent({ mainType: y2, query: e2 }, function(x2) {
          var C = x2.coordinateSystem;
          if (C.type === "geo") {
            var D2 = TOt(C, e2, x2.get("scaleLimit"));
            x2.setCenter && x2.setCenter(D2.center), x2.setZoom && x2.setZoom(D2.zoom), y2 === "series" && Ke2(x2.seriesGroup, function(L) {
              L.setCenter(D2.center), L.setZoom(D2.zoom);
            });
          }
        });
      });
    }
    function wnn(l2) {
      Oc2(Vue), l2.registerChartView(onn), l2.registerSeriesModel(lnn), l2.registerLayout(fnn), l2.registerProcessor(l2.PRIORITY.PROCESSOR.STATISTIC, cnn), zae("map", l2.registerAction);
    }
    function Snn(l2) {
      var a = l2;
      a.hierNode = { defaultAncestor: null, ancestor: a, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
      for (var e2 = [a], d2, y2; d2 = e2.pop(); )
        if (y2 = d2.children, d2.isExpand && y2.length)
          for (var x2 = y2.length, C = x2 - 1; C >= 0; C--) {
            var D2 = y2[C];
            D2.hierNode = { defaultAncestor: null, ancestor: D2, prelim: 0, modifier: 0, change: 0, shift: 0, i: C, thread: null }, e2.push(D2);
          }
    }
    function Mnn(l2, a) {
      var e2 = l2.isExpand ? l2.children : [], d2 = l2.parentNode.children, y2 = l2.hierNode.i ? d2[l2.hierNode.i - 1] : null;
      if (e2.length) {
        Ann(l2);
        var x2 = (e2[0].hierNode.prelim + e2[e2.length - 1].hierNode.prelim) / 2;
        y2 ? (l2.hierNode.prelim = y2.hierNode.prelim + a(l2, y2), l2.hierNode.modifier = l2.hierNode.prelim - x2) : l2.hierNode.prelim = x2;
      } else
        y2 && (l2.hierNode.prelim = y2.hierNode.prelim + a(l2, y2));
      l2.parentNode.hierNode.defaultAncestor = Inn(l2, y2, l2.parentNode.hierNode.defaultAncestor || d2[0], a);
    }
    function Cnn(l2) {
      var a = l2.hierNode.prelim + l2.parentNode.hierNode.modifier;
      l2.setLayout({ x: a }, true), l2.hierNode.modifier += l2.parentNode.hierNode.modifier;
    }
    function Bue(l2) {
      return arguments.length ? l2 : knn;
    }
    function Krt(l2, a) {
      return l2 -= Math.PI / 2, { x: a * Math.cos(l2), y: a * Math.sin(l2) };
    }
    function Tnn(l2, a) {
      return Em(l2.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
    }
    function Ann(l2) {
      for (var a = l2.children, e2 = a.length, d2 = 0, y2 = 0; --e2 >= 0; ) {
        var x2 = a[e2];
        x2.hierNode.prelim += d2, x2.hierNode.modifier += d2, y2 += x2.hierNode.change, d2 += x2.hierNode.shift + y2;
      }
    }
    function Inn(l2, a, e2, d2) {
      if (a) {
        for (var y2 = l2, x2 = l2, C = x2.parentNode.children[0], D2 = a, L = y2.hierNode.modifier, F3 = x2.hierNode.modifier, j = C.hierNode.modifier, U3 = D2.hierNode.modifier; D2 = AOt(D2), x2 = IOt(x2), D2 && x2; ) {
          y2 = AOt(y2), C = IOt(C), y2.hierNode.ancestor = l2;
          var Y3 = D2.hierNode.prelim + U3 - x2.hierNode.prelim - F3 + d2(D2, x2);
          Y3 > 0 && (Enn(Dnn(D2, l2, e2), l2, Y3), F3 += Y3, L += Y3), U3 += D2.hierNode.modifier, F3 += x2.hierNode.modifier, L += y2.hierNode.modifier, j += C.hierNode.modifier;
        }
        D2 && !AOt(y2) && (y2.hierNode.thread = D2, y2.hierNode.modifier += U3 - L), x2 && !IOt(C) && (C.hierNode.thread = x2, C.hierNode.modifier += F3 - j, e2 = l2);
      }
      return e2;
    }
    function AOt(l2) {
      var a = l2.children;
      return a.length && l2.isExpand ? a[a.length - 1] : l2.hierNode.thread;
    }
    function IOt(l2) {
      var a = l2.children;
      return a.length && l2.isExpand ? a[0] : l2.hierNode.thread;
    }
    function Dnn(l2, a, e2) {
      return l2.hierNode.ancestor.parentNode === a.parentNode ? l2.hierNode.ancestor : e2;
    }
    function Enn(l2, a, e2) {
      var d2 = e2 / (a.hierNode.i - l2.hierNode.i);
      a.hierNode.change -= d2, a.hierNode.shift += e2, a.hierNode.modifier += e2, a.hierNode.prelim += e2, l2.hierNode.change += d2;
    }
    function knn(l2, a) {
      return l2.parentNode === a.parentNode ? 1 : 2;
    }
    var Pnn = function() {
      function l2() {
        this.parentPoint = [], this.childPoints = [];
      }
      return l2;
    }(), Lnn = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new Pnn();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.childPoints, x2 = y2.length, C = d2.parentPoint, D2 = y2[0], L = y2[x2 - 1];
        if (x2 === 1) {
          e2.moveTo(C[0], C[1]), e2.lineTo(D2[0], D2[1]);
          return;
        }
        var F3 = d2.orient, j = F3 === "TB" || F3 === "BT" ? 0 : 1, U3 = 1 - j, Y3 = Ko(d2.forkPosition, 1), Q = [];
        Q[j] = C[j], Q[U3] = C[U3] + (L[U3] - C[U3]) * Y3, e2.moveTo(C[0], C[1]), e2.lineTo(Q[0], Q[1]), e2.moveTo(D2[0], D2[1]), Q[j] = D2[j], e2.lineTo(Q[0], Q[1]), Q[j] = L[j], e2.lineTo(Q[0], Q[1]), e2.lineTo(L[0], L[1]);
        for (var nt = 1; nt < x2 - 1; nt++) {
          var dt = y2[nt];
          e2.moveTo(dt[0], dt[1]), Q[j] = dt[j], e2.lineTo(Q[0], Q[1]);
        }
      }, a;
    }(wc2), Onn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._mainGroup = new ou(), e2;
      }
      return a.prototype.init = function(e2, d2) {
        this._controller = new Zrt(d2.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
      }, a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.getData(), C = e2.layoutInfo, D2 = this._mainGroup, L = e2.get("layout");
        L === "radial" ? (D2.x = C.x + C.width / 2, D2.y = C.y + C.height / 2) : (D2.x = C.x, D2.y = C.y), this._updateViewCoordSys(e2), this._updateController(e2, d2, y2);
        var F3 = this._data;
        x2.diff(F3).add(function(j) {
          zue(x2, j) && jue(x2, j, null, D2, e2);
        }).update(function(j, U3) {
          var Y3 = F3.getItemGraphicEl(U3);
          if (!zue(x2, j)) {
            Y3 && Hue(F3, U3, Y3, D2, e2);
            return;
          }
          jue(x2, j, Y3, D2, e2);
        }).remove(function(j) {
          var U3 = F3.getItemGraphicEl(j);
          U3 && Hue(F3, j, U3, D2, e2);
        }).execute(), this._nodeScaleRatio = e2.get("nodeScaleRatio"), this._updateNodeAndLinkScale(e2), e2.get("expandAndCollapse") === true && x2.eachItemGraphicEl(function(j, U3) {
          j.off("click").on("click", function() {
            y2.dispatchAction({ type: "treeExpandAndCollapse", seriesId: e2.id, dataIndex: U3 });
          });
        }), this._data = x2;
      }, a.prototype._updateViewCoordSys = function(e2) {
        var d2 = e2.getData(), y2 = [];
        d2.each(function(j) {
          var U3 = d2.getItemLayout(j);
          U3 && !isNaN(U3.x) && !isNaN(U3.y) && y2.push([+U3.x, +U3.y]);
        });
        var x2 = [], C = [];
        yq(y2, x2, C);
        var D2 = this._min, L = this._max;
        C[0] - x2[0] === 0 && (x2[0] = D2 ? D2[0] : x2[0] - 1, C[0] = L ? L[0] : C[0] + 1), C[1] - x2[1] === 0 && (x2[1] = D2 ? D2[1] : x2[1] - 1, C[1] = L ? L[1] : C[1] + 1);
        var F3 = e2.coordinateSystem = new Yrt();
        F3.zoomLimit = e2.get("scaleLimit"), F3.setBoundingRect(x2[0], x2[1], C[0] - x2[0], C[1] - x2[1]), F3.setCenter(e2.get("center")), F3.setZoom(e2.get("zoom")), this.group.attr({ x: F3.x, y: F3.y, scaleX: F3.scaleX, scaleY: F3.scaleY }), this._min = x2, this._max = C;
      }, a.prototype._updateController = function(e2, d2, y2) {
        var x2 = this, C = this._controller, D2 = this._controllerHost, L = this.group;
        C.setPointerChecker(function(F3, j, U3) {
          var Y3 = L.getBoundingRect();
          return Y3.applyTransform(L.transform), Y3.contain(j, U3) && !omt(F3, y2, e2);
        }), C.enable(e2.get("roam")), D2.zoomLimit = e2.get("scaleLimit"), D2.zoom = e2.coordinateSystem.getZoom(), C.off("pan").off("zoom").on("pan", function(F3) {
          _Ot(D2, F3.dx, F3.dy), y2.dispatchAction({ seriesId: e2.id, type: "treeRoam", dx: F3.dx, dy: F3.dy });
        }).on("zoom", function(F3) {
          xOt(D2, F3.scale, F3.originX, F3.originY), y2.dispatchAction({ seriesId: e2.id, type: "treeRoam", zoom: F3.scale, originX: F3.originX, originY: F3.originY }), x2._updateNodeAndLinkScale(e2), y2.updateLabelLayout();
        });
      }, a.prototype._updateNodeAndLinkScale = function(e2) {
        var d2 = e2.getData(), y2 = this._getNodeGlobalScale(e2);
        d2.eachItemGraphicEl(function(x2, C) {
          x2.setSymbolScale(y2);
        });
      }, a.prototype._getNodeGlobalScale = function(e2) {
        var d2 = e2.coordinateSystem;
        if (d2.type !== "view")
          return 1;
        var y2 = this._nodeScaleRatio, x2 = d2.scaleX || 1, C = d2.getZoom(), D2 = (C - 1) * y2 + 1;
        return D2 / x2;
      }, a.prototype.dispose = function() {
        this._controller && this._controller.dispose(), this._controllerHost = null;
      }, a.prototype.remove = function() {
        this._mainGroup.removeAll(), this._data = null;
      }, a.type = "tree", a;
    }(pg2);
    function zue(l2, a) {
      var e2 = l2.getItemLayout(a);
      return e2 && !isNaN(e2.x) && !isNaN(e2.y);
    }
    function jue(l2, a, e2, d2, y2) {
      var x2 = !e2, C = l2.tree.getNodeByDataIndex(a), D2 = C.getModel(), L = C.getVisual("style").fill, F3 = C.isExpand === false && C.children.length !== 0 ? L : "#fff", j = l2.tree.root, U3 = C.parentNode === j ? C : C.parentNode || C, Y3 = l2.getItemGraphicEl(U3.dataIndex), Q = U3.getLayout(), nt = Y3 ? { x: Y3.__oldX, y: Y3.__oldY, rawX: Y3.__radialOldRawX, rawY: Y3.__radialOldRawY } : Q, dt = C.getLayout();
      x2 ? (e2 = new zrt(l2, a, null, { symbolInnerColor: F3, useNameLabel: true }), e2.x = nt.x, e2.y = nt.y) : e2.updateData(l2, a, null, { symbolInnerColor: F3, useNameLabel: true }), e2.__radialOldRawX = e2.__radialRawX, e2.__radialOldRawY = e2.__radialRawY, e2.__radialRawX = dt.rawX, e2.__radialRawY = dt.rawY, d2.add(e2), l2.setItemGraphicEl(a, e2), e2.__oldX = e2.x, e2.__oldY = e2.y, Yf2(e2, { x: dt.x, y: dt.y }, y2);
      var vt = e2.getSymbolPath();
      if (y2.get("layout") === "radial") {
        var Ct = j.children[0], Pt = Ct.getLayout(), jt = Ct.children.length, Rt = void 0, le2 = void 0;
        if (dt.x === Pt.x && C.isExpand === true) {
          var ne2 = { x: (Ct.children[0].getLayout().x + Ct.children[jt - 1].getLayout().x) / 2, y: (Ct.children[0].getLayout().y + Ct.children[jt - 1].getLayout().y) / 2 };
          Rt = Math.atan2(ne2.y - Pt.y, ne2.x - Pt.x), Rt < 0 && (Rt = Math.PI * 2 + Rt), le2 = ne2.x < Pt.x, le2 && (Rt = Rt - Math.PI);
        } else
          Rt = Math.atan2(dt.y - Pt.y, dt.x - Pt.x), Rt < 0 && (Rt = Math.PI * 2 + Rt), C.children.length === 0 || C.children.length !== 0 && C.isExpand === false ? (le2 = dt.x < Pt.x, le2 && (Rt = Rt - Math.PI)) : (le2 = dt.x > Pt.x, le2 || (Rt = Rt - Math.PI));
        var he2 = le2 ? "left" : "right", _e = D2.getModel("label"), Me2 = _e.get("rotate"), Pe2 = Me2 * (Math.PI / 180), Be2 = vt.getTextContent();
        Be2 && (vt.setTextConfig({ position: _e.get("position") || he2, rotation: Me2 == null ? -Rt : Pe2, origin: "center" }), Be2.setStyle("verticalAlign", "middle"));
      }
      var Je2 = D2.get(["emphasis", "focus"]), Ze2 = Je2 === "ancestor" ? C.getAncestorsIndices() : Je2 === "descendant" ? C.getDescendantIndices() : null;
      Ze2 && (ns(e2).focus = Ze2), Rnn(y2, C, j, e2, nt, Q, dt, d2), e2.__edge && (e2.onHoverStateChange = function(Cn) {
        if (Cn !== "blur") {
          var Bn = C.parentNode && l2.getItemGraphicEl(C.parentNode.dataIndex);
          Bn && Bn.hoverState === HV || wO(e2.__edge, Cn);
        }
      });
    }
    function Rnn(l2, a, e2, d2, y2, x2, C, D2) {
      var L = a.getModel(), F3 = l2.get("edgeShape"), j = l2.get("layout"), U3 = l2.getOrient(), Y3 = l2.get(["lineStyle", "curveness"]), Q = l2.get("edgeForkPosition"), nt = L.getModel("lineStyle").getLineStyle(), dt = d2.__edge;
      if (F3 === "curve")
        a.parentNode && a.parentNode !== e2 && (dt || (dt = d2.__edge = new GN({ shape: DOt(j, U3, Y3, y2, y2) })), Yf2(dt, { shape: DOt(j, U3, Y3, x2, C) }, l2));
      else if (F3 === "polyline" && j === "orthogonal" && a !== e2 && a.children && a.children.length !== 0 && a.isExpand === true) {
        for (var vt = a.children, Ct = [], Pt = 0; Pt < vt.length; Pt++) {
          var jt = vt[Pt].getLayout();
          Ct.push([jt.x, jt.y]);
        }
        dt || (dt = d2.__edge = new Lnn({ shape: { parentPoint: [C.x, C.y], childPoints: [[C.x, C.y]], orient: U3, forkPosition: Q } })), Yf2(dt, { shape: { parentPoint: [C.x, C.y], childPoints: Ct } }, l2);
      }
      dt && (dt.useStyle(El({ strokeNoScale: true, fill: null }, nt)), Gy(dt, L, "lineStyle"), SO(dt), D2.add(dt));
    }
    function Wue(l2, a, e2, d2, y2) {
      var x2 = a.tree.root, C = Gue(x2, l2), D2 = C.source, L = C.sourceLayout, F3 = a.getItemGraphicEl(l2.dataIndex);
      if (F3) {
        var j = a.getItemGraphicEl(D2.dataIndex), U3 = j.__edge, Y3 = F3.__edge || (D2.isExpand === false || D2.children.length === 1 ? U3 : void 0), Q = d2.get("edgeShape"), nt = d2.get("layout"), dt = d2.get("orient"), vt = d2.get(["lineStyle", "curveness"]);
        Y3 && (Q === "curve" ? iP(Y3, { shape: DOt(nt, dt, vt, L, L), style: { opacity: 0 } }, d2, { cb: function() {
          e2.remove(Y3);
        }, removeOpt: y2 }) : Q === "polyline" && d2.get("layout") === "orthogonal" && iP(Y3, { shape: { parentPoint: [L.x, L.y], childPoints: [[L.x, L.y]] }, style: { opacity: 0 } }, d2, { cb: function() {
          e2.remove(Y3);
        }, removeOpt: y2 }));
      }
    }
    function Gue(l2, a) {
      for (var e2 = a.parentNode === l2 ? a : a.parentNode || a, d2; d2 = e2.getLayout(), d2 == null; )
        e2 = e2.parentNode === l2 ? e2 : e2.parentNode || e2;
      return { source: e2, sourceLayout: d2 };
    }
    function Hue(l2, a, e2, d2, y2) {
      var x2 = l2.tree.getNodeByDataIndex(a), C = l2.tree.root, D2 = Gue(C, x2).sourceLayout, L = { duration: y2.get("animationDurationUpdate"), easing: y2.get("animationEasingUpdate") };
      iP(e2, { x: D2.x + 1, y: D2.y + 1 }, y2, { cb: function() {
        d2.remove(e2), l2.setItemGraphicEl(a, null);
      }, removeOpt: L }), e2.fadeOut(null, l2.hostModel, { fadeLabel: true, animation: L }), x2.children.forEach(function(F3) {
        Wue(F3, l2, d2, y2, L);
      }), Wue(x2, l2, d2, y2, L);
    }
    function DOt(l2, a, e2, d2, y2) {
      var x2, C, D2, L, F3, j, U3, Y3;
      if (l2 === "radial") {
        F3 = d2.rawX, U3 = d2.rawY, j = y2.rawX, Y3 = y2.rawY;
        var Q = Krt(F3, U3), nt = Krt(F3, U3 + (Y3 - U3) * e2), dt = Krt(j, Y3 + (U3 - Y3) * e2), vt = Krt(j, Y3);
        return { x1: Q.x || 0, y1: Q.y || 0, x2: vt.x || 0, y2: vt.y || 0, cpx1: nt.x || 0, cpy1: nt.y || 0, cpx2: dt.x || 0, cpy2: dt.y || 0 };
      } else
        F3 = d2.x, U3 = d2.y, j = y2.x, Y3 = y2.y, (a === "LR" || a === "RL") && (x2 = F3 + (j - F3) * e2, C = U3, D2 = j + (F3 - j) * e2, L = Y3), (a === "TB" || a === "BT") && (x2 = F3, C = U3 + (Y3 - U3) * e2, D2 = j, L = Y3 + (U3 - Y3) * e2);
      return { x1: F3, y1: U3, x2: j, y2: Y3, cpx1: x2, cpy1: C, cpx2: D2, cpy2: L };
    }
    var Nnn = Onn, kA = Rf2();
    function Uue(l2) {
      var a = l2.mainData, e2 = l2.datas;
      e2 || (e2 = { main: a }, l2.datasAttr = { main: "data" }), l2.datas = l2.mainData = null, que(a, e2, l2), Ke2(e2, function(d2) {
        Ke2(a.TRANSFERABLE_METHODS, function(y2) {
          d2.wrapMethod(y2, xu(Fnn, l2));
        });
      }), a.wrapMethod("cloneShallow", xu(Bnn, l2)), Ke2(a.CHANGABLE_METHODS, function(d2) {
        a.wrapMethod(d2, xu(Vnn, l2));
      }), vb2(e2[a.dataType] === a);
    }
    function Fnn(l2, a) {
      if (Wnn(this)) {
        var e2 = la2({}, kA(this).datas);
        e2[this.dataType] = a, que(a, e2, l2);
      } else
        EOt(a, this.dataType, kA(this).mainData, l2);
      return a;
    }
    function Vnn(l2, a) {
      return l2.struct && l2.struct.update(), a;
    }
    function Bnn(l2, a) {
      return Ke2(kA(a).datas, function(e2, d2) {
        e2 !== a && EOt(e2.cloneShallow(), d2, a, l2);
      }), a;
    }
    function znn(l2) {
      var a = kA(this).mainData;
      return l2 == null || a == null ? a : kA(a).datas[l2];
    }
    function jnn() {
      var l2 = kA(this).mainData;
      return l2 == null ? [{ data: l2 }] : $a2(Qc2(kA(l2).datas), function(a) {
        return { type: a, data: kA(l2).datas[a] };
      });
    }
    function Wnn(l2) {
      return kA(l2).mainData === l2;
    }
    function que(l2, a, e2) {
      kA(l2).datas = {}, Ke2(a, function(d2, y2) {
        EOt(d2, y2, l2, e2);
      });
    }
    function EOt(l2, a, e2, d2) {
      kA(e2).datas[a] = l2, kA(l2).mainData = e2, l2.dataType = a, d2.struct && (l2[d2.structAttr] = d2.struct, d2.struct[d2.datasAttr[a]] = l2), l2.getLinkedData = znn, l2.getLinkedDataAll = jnn;
    }
    var Gnn = function() {
      function l2(a, e2) {
        this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = a || "", this.hostTree = e2;
      }
      return l2.prototype.isRemoved = function() {
        return this.dataIndex < 0;
      }, l2.prototype.eachNode = function(a, e2, d2) {
        wl(a) && (d2 = e2, e2 = a, a = null), a = a || {}, ps(a) && (a = { order: a });
        var y2 = a.order || "preorder", x2 = this[a.attr || "children"], C;
        y2 === "preorder" && (C = e2.call(d2, this));
        for (var D2 = 0; !C && D2 < x2.length; D2++)
          x2[D2].eachNode(a, e2, d2);
        y2 === "postorder" && e2.call(d2, this);
      }, l2.prototype.updateDepthAndHeight = function(a) {
        var e2 = 0;
        this.depth = a;
        for (var d2 = 0; d2 < this.children.length; d2++) {
          var y2 = this.children[d2];
          y2.updateDepthAndHeight(a + 1), y2.height > e2 && (e2 = y2.height);
        }
        this.height = e2 + 1;
      }, l2.prototype.getNodeById = function(a) {
        if (this.getId() === a)
          return this;
        for (var e2 = 0, d2 = this.children, y2 = d2.length; e2 < y2; e2++) {
          var x2 = d2[e2].getNodeById(a);
          if (x2)
            return x2;
        }
      }, l2.prototype.contains = function(a) {
        if (a === this)
          return true;
        for (var e2 = 0, d2 = this.children, y2 = d2.length; e2 < y2; e2++) {
          var x2 = d2[e2].contains(a);
          if (x2)
            return x2;
        }
      }, l2.prototype.getAncestors = function(a) {
        for (var e2 = [], d2 = a ? this : this.parentNode; d2; )
          e2.push(d2), d2 = d2.parentNode;
        return e2.reverse(), e2;
      }, l2.prototype.getAncestorsIndices = function() {
        for (var a = [], e2 = this; e2; )
          a.push(e2.dataIndex), e2 = e2.parentNode;
        return a.reverse(), a;
      }, l2.prototype.getDescendantIndices = function() {
        var a = [];
        return this.eachNode(function(e2) {
          a.push(e2.dataIndex);
        }), a;
      }, l2.prototype.getValue = function(a) {
        var e2 = this.hostTree.data;
        return e2.getStore().get(e2.getDimensionIndex(a || "value"), this.dataIndex);
      }, l2.prototype.setLayout = function(a, e2) {
        this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, a, e2);
      }, l2.prototype.getLayout = function() {
        return this.hostTree.data.getItemLayout(this.dataIndex);
      }, l2.prototype.getModel = function(a) {
        if (!(this.dataIndex < 0)) {
          var e2 = this.hostTree, d2 = e2.data.getItemModel(this.dataIndex);
          return d2.getModel(a);
        }
      }, l2.prototype.getLevelModel = function() {
        return (this.hostTree.levelModels || [])[this.depth];
      }, l2.prototype.setVisual = function(a, e2) {
        this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, a, e2);
      }, l2.prototype.getVisual = function(a) {
        return this.hostTree.data.getItemVisual(this.dataIndex, a);
      }, l2.prototype.getRawIndex = function() {
        return this.hostTree.data.getRawIndex(this.dataIndex);
      }, l2.prototype.getId = function() {
        return this.hostTree.data.getId(this.dataIndex);
      }, l2.prototype.getChildIndex = function() {
        if (this.parentNode) {
          for (var a = this.parentNode.children, e2 = 0; e2 < a.length; ++e2)
            if (a[e2] === this)
              return e2;
          return -1;
        }
        return -1;
      }, l2.prototype.isAncestorOf = function(a) {
        for (var e2 = a.parentNode; e2; ) {
          if (e2 === this)
            return true;
          e2 = e2.parentNode;
        }
        return false;
      }, l2.prototype.isDescendantOf = function(a) {
        return a !== this && a.isAncestorOf(this);
      }, l2;
    }(), Hnn = function() {
      function l2(a) {
        this.type = "tree", this._nodes = [], this.hostModel = a;
      }
      return l2.prototype.eachNode = function(a, e2, d2) {
        this.root.eachNode(a, e2, d2);
      }, l2.prototype.getNodeByDataIndex = function(a) {
        var e2 = this.data.getRawIndex(a);
        return this._nodes[e2];
      }, l2.prototype.getNodeById = function(a) {
        return this.root.getNodeById(a);
      }, l2.prototype.update = function() {
        for (var a = this.data, e2 = this._nodes, d2 = 0, y2 = e2.length; d2 < y2; d2++)
          e2[d2].dataIndex = -1;
        for (var d2 = 0, y2 = a.count(); d2 < y2; d2++)
          e2[a.getRawIndex(d2)].dataIndex = d2;
      }, l2.prototype.clearLayouts = function() {
        this.data.clearItemLayouts();
      }, l2.createTree = function(a, e2, d2) {
        var y2 = new l2(e2), x2 = [], C = 1;
        D2(a);
        function D2(j, U3) {
          var Y3 = j.value;
          C = Math.max(C, Ba2(Y3) ? Y3.length : 1), x2.push(j);
          var Q = new Gnn(Ud2(j.name, ""), y2);
          U3 ? Unn(Q, U3) : y2.root = Q, y2._nodes.push(Q);
          var nt = j.children;
          if (nt)
            for (var dt = 0; dt < nt.length; dt++)
              D2(nt[dt], Q);
        }
        y2.root.updateDepthAndHeight(0);
        var L = Ert(x2, { coordDimensions: ["value"], dimensionsCount: C }).dimensions, F3 = new jS(L, e2);
        return F3.initData(x2), d2 && d2(F3), Uue({ mainData: F3, struct: y2, structAttr: "tree" }), y2.update(), y2;
      }, l2;
    }();
    function Unn(l2, a) {
      var e2 = a.children;
      l2.parentNode !== a && (e2.push(l2), l2.parentNode = a);
    }
    var kOt = Hnn;
    function Xrt(l2, a, e2) {
      if (l2 && oc2(a, l2.type) >= 0) {
        var d2 = e2.getData().tree.root, y2 = l2.targetNode;
        if (ps(y2) && (y2 = d2.getNodeById(y2)), y2 && d2.contains(y2))
          return { node: y2 };
        var x2 = l2.targetNodeId;
        if (x2 != null && (y2 = d2.getNodeById(x2)))
          return { node: y2 };
      }
    }
    function Zue(l2) {
      for (var a = []; l2; )
        l2 = l2.parentNode, l2 && a.push(l2);
      return a.reverse();
    }
    function POt(l2, a) {
      var e2 = Zue(l2);
      return oc2(e2, a) >= 0;
    }
    function fmt(l2, a) {
      for (var e2 = []; l2; ) {
        var d2 = l2.dataIndex;
        e2.push({ name: l2.name, dataIndex: d2, value: a.getRawValue(d2) }), l2 = l2.parentNode;
      }
      return e2.reverse(), e2;
    }
    var qnn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.hasSymbolVisual = true, e2.ignoreStyleOnData = true, e2;
      }
      return a.prototype.getInitialData = function(e2) {
        var d2 = { name: e2.name, children: e2.data }, y2 = e2.leaves || {}, x2 = new hg2(y2, this, this.ecModel), C = kOt.createTree(d2, this, D2);
        function D2(U3) {
          U3.wrapMethod("getItemModel", function(Y3, Q) {
            var nt = C.getNodeByDataIndex(Q);
            return nt && nt.children.length && nt.isExpand || (Y3.parentModel = x2), Y3;
          });
        }
        var L = 0;
        C.eachNode("preorder", function(U3) {
          U3.depth > L && (L = U3.depth);
        });
        var F3 = e2.expandAndCollapse, j = F3 && e2.initialTreeDepth >= 0 ? e2.initialTreeDepth : L;
        return C.root.eachNode("preorder", function(U3) {
          var Y3 = U3.hostTree.data.getRawDataItem(U3.dataIndex);
          U3.isExpand = Y3 && Y3.collapsed != null ? !Y3.collapsed : U3.depth <= j;
        }), C.data;
      }, a.prototype.getOrient = function() {
        var e2 = this.get("orient");
        return e2 === "horizontal" ? e2 = "LR" : e2 === "vertical" && (e2 = "TB"), e2;
      }, a.prototype.setZoom = function(e2) {
        this.option.zoom = e2;
      }, a.prototype.setCenter = function(e2) {
        this.option.center = e2;
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        for (var x2 = this.getData().tree, C = x2.root.children[0], D2 = x2.getNodeByDataIndex(e2), L = D2.getValue(), F3 = D2.name; D2 && D2 !== C; )
          F3 = D2.parentNode.name + "." + F3, D2 = D2.parentNode;
        return b1("nameValue", { name: F3, value: L, noValue: isNaN(L) || L == null });
      }, a.prototype.getDataParams = function(e2) {
        var d2 = l2.prototype.getDataParams.apply(this, arguments), y2 = this.getData().tree.getNodeByDataIndex(e2);
        return d2.treeAncestors = fmt(y2, this), d2;
      }, a.type = "series.tree", a.layoutMode = "box", a.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, a;
    }(Pv), Znn = qnn;
    function $nn(l2, a, e2) {
      for (var d2 = [l2], y2 = [], x2; x2 = d2.pop(); )
        if (y2.push(x2), x2.isExpand) {
          var C = x2.children;
          if (C.length)
            for (var D2 = 0; D2 < C.length; D2++)
              d2.push(C[D2]);
        }
      for (; x2 = y2.pop(); )
        a(x2, e2);
    }
    function Qrt(l2, a) {
      for (var e2 = [l2], d2; d2 = e2.pop(); )
        if (a(d2), d2.isExpand) {
          var y2 = d2.children;
          if (y2.length)
            for (var x2 = y2.length - 1; x2 >= 0; x2--)
              e2.push(y2[x2]);
        }
    }
    function Ynn(l2, a) {
      l2.eachSeriesByType("tree", function(e2) {
        Knn(e2, a);
      });
    }
    function Knn(l2, a) {
      var e2 = Tnn(l2, a);
      l2.layoutInfo = e2;
      var d2 = l2.get("layout"), y2 = 0, x2 = 0, C = null;
      d2 === "radial" ? (y2 = 2 * Math.PI, x2 = Math.min(e2.height, e2.width) / 2, C = Bue(function(jt, Rt) {
        return (jt.parentNode === Rt.parentNode ? 1 : 2) / jt.depth;
      })) : (y2 = e2.width, x2 = e2.height, C = Bue());
      var D2 = l2.getData().tree.root, L = D2.children[0];
      if (L) {
        Snn(D2), $nn(L, Mnn, C), D2.hierNode.modifier = -L.hierNode.prelim, Qrt(L, Cnn);
        var F3 = L, j = L, U3 = L;
        Qrt(L, function(jt) {
          var Rt = jt.getLayout().x;
          Rt < F3.getLayout().x && (F3 = jt), Rt > j.getLayout().x && (j = jt), jt.depth > U3.depth && (U3 = jt);
        });
        var Y3 = F3 === j ? 1 : C(F3, j) / 2, Q = Y3 - F3.getLayout().x, nt = 0, dt = 0, vt = 0, Ct = 0;
        if (d2 === "radial")
          nt = y2 / (j.getLayout().x + Y3 + Q), dt = x2 / (U3.depth - 1 || 1), Qrt(L, function(jt) {
            vt = (jt.getLayout().x + Q) * nt, Ct = (jt.depth - 1) * dt;
            var Rt = Krt(vt, Ct);
            jt.setLayout({ x: Rt.x, y: Rt.y, rawX: vt, rawY: Ct }, true);
          });
        else {
          var Pt = l2.getOrient();
          Pt === "RL" || Pt === "LR" ? (dt = x2 / (j.getLayout().x + Y3 + Q), nt = y2 / (U3.depth - 1 || 1), Qrt(L, function(jt) {
            Ct = (jt.getLayout().x + Q) * dt, vt = Pt === "LR" ? (jt.depth - 1) * nt : y2 - (jt.depth - 1) * nt, jt.setLayout({ x: vt, y: Ct }, true);
          })) : (Pt === "TB" || Pt === "BT") && (nt = y2 / (j.getLayout().x + Y3 + Q), dt = x2 / (U3.depth - 1 || 1), Qrt(L, function(jt) {
            vt = (jt.getLayout().x + Q) * nt, Ct = Pt === "TB" ? (jt.depth - 1) * dt : x2 - (jt.depth - 1) * dt, jt.setLayout({ x: vt, y: Ct }, true);
          }));
        }
      }
    }
    function Xnn(l2) {
      l2.eachSeriesByType("tree", function(a) {
        var e2 = a.getData(), d2 = e2.tree;
        d2.eachNode(function(y2) {
          var x2 = y2.getModel(), C = x2.getModel("itemStyle").getItemStyle(), D2 = e2.ensureUniqueItemVisual(y2.dataIndex, "style");
          la2(D2, C);
        });
      });
    }
    function Qnn(l2) {
      l2.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(a, e2) {
        e2.eachComponent({ mainType: "series", subType: "tree", query: a }, function(d2) {
          var y2 = a.dataIndex, x2 = d2.getData().tree, C = x2.getNodeByDataIndex(y2);
          C.isExpand = !C.isExpand;
        });
      }), l2.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(a, e2) {
        e2.eachComponent({ mainType: "series", subType: "tree", query: a }, function(d2) {
          var y2 = d2.coordinateSystem, x2 = TOt(y2, a);
          d2.setCenter && d2.setCenter(x2.center), d2.setZoom && d2.setZoom(x2.zoom);
        });
      });
    }
    function Jnn(l2) {
      l2.registerChartView(Nnn), l2.registerSeriesModel(Znn), l2.registerLayout(Ynn), l2.registerVisual(Xnn), Qnn(l2);
    }
    var $ue = ["treemapZoomToNode", "treemapRender", "treemapMove"];
    function trn(l2) {
      for (var a = 0; a < $ue.length; a++)
        l2.registerAction({ type: $ue[a], update: "updateView" }, $p);
      l2.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(e2, d2) {
        d2.eachComponent({ mainType: "series", subType: "treemap", query: e2 }, y2);
        function y2(x2, C) {
          var D2 = ["treemapZoomToNode", "treemapRootToNode"], L = Xrt(e2, D2, x2);
          if (L) {
            var F3 = x2.getViewRoot();
            F3 && (e2.direction = POt(F3, L.node) ? "rollUp" : "drillDown"), x2.resetViewRoot(L.node);
          }
        }
      });
    }
    function Yue(l2) {
      var a = l2.getData(), e2 = a.tree, d2 = {};
      e2.eachNode(function(y2) {
        for (var x2 = y2; x2 && x2.depth > 1; )
          x2 = x2.parentNode;
        var C = B3t(l2.ecModel, x2.name || x2.dataIndex + "", d2);
        y2.setVisual("decal", C);
      });
    }
    var ern = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.preventUsingHoverLayer = true, e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        var y2 = { name: e2.name, children: e2.data };
        Kue(y2);
        var x2 = e2.levels || [], C = this.designatedVisualItemStyle = {}, D2 = new hg2({ itemStyle: C }, this, d2);
        x2 = e2.levels = nrn(x2, d2);
        var L = $a2(x2 || [], function(U3) {
          return new hg2(U3, D2, d2);
        }, this), F3 = kOt.createTree(y2, this, j);
        function j(U3) {
          U3.wrapMethod("getItemModel", function(Y3, Q) {
            var nt = F3.getNodeByDataIndex(Q), dt = nt ? L[nt.depth] : null;
            return Y3.parentModel = dt || D2, Y3;
          });
        }
        return F3.data;
      }, a.prototype.optionUpdated = function() {
        this.resetViewRoot();
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        var x2 = this.getData(), C = this.getRawValue(e2), D2 = x2.getName(e2);
        return b1("nameValue", { name: D2, value: C });
      }, a.prototype.getDataParams = function(e2) {
        var d2 = l2.prototype.getDataParams.apply(this, arguments), y2 = this.getData().tree.getNodeByDataIndex(e2);
        return d2.treeAncestors = fmt(y2, this), d2.treePathInfo = d2.treeAncestors, d2;
      }, a.prototype.setLayoutInfo = function(e2) {
        this.layoutInfo = this.layoutInfo || {}, la2(this.layoutInfo, e2);
      }, a.prototype.mapIdToIndex = function(e2) {
        var d2 = this._idIndexMap;
        d2 || (d2 = this._idIndexMap = fl(), this._idIndexMapCount = 0);
        var y2 = d2.get(e2);
        return y2 == null && d2.set(e2, y2 = this._idIndexMapCount++), y2;
      }, a.prototype.getViewRoot = function() {
        return this._viewRoot;
      }, a.prototype.resetViewRoot = function(e2) {
        e2 ? this._viewRoot = e2 : e2 = this._viewRoot;
        var d2 = this.getRawData().tree.root;
        (!e2 || e2 !== d2 && !d2.contains(e2)) && (this._viewRoot = d2);
      }, a.prototype.enableAriaDecal = function() {
        Yue(this);
      }, a.type = "series.treemap", a.layoutMode = "box", a.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, a;
    }(Pv);
    function Kue(l2) {
      var a = 0;
      Ke2(l2.children, function(d2) {
        Kue(d2);
        var y2 = d2.value;
        Ba2(y2) && (y2 = y2[0]), a += y2;
      });
      var e2 = l2.value;
      Ba2(e2) && (e2 = e2[0]), (e2 == null || isNaN(e2)) && (e2 = a), e2 < 0 && (e2 = 0), Ba2(l2.value) ? l2.value[0] = e2 : l2.value = e2;
    }
    function nrn(l2, a) {
      var e2 = Mp(a.get("color")), d2 = Mp(a.get(["aria", "decal", "decals"]));
      if (e2) {
        l2 = l2 || [];
        var y2, x2;
        Ke2(l2, function(D2) {
          var L = new hg2(D2), F3 = L.get("color"), j = L.get("decal");
          (L.get(["itemStyle", "color"]) || F3 && F3 !== "none") && (y2 = true), (L.get(["itemStyle", "decal"]) || j && j !== "none") && (x2 = true);
        });
        var C = l2[0] || (l2[0] = {});
        return y2 || (C.color = e2.slice()), !x2 && d2 && (C.decal = d2.slice()), l2;
      }
    }
    var rrn = ern, irn = 8, Xue = 8, LOt = 5, arn = function() {
      function l2(a) {
        this.group = new ou(), a.add(this.group);
      }
      return l2.prototype.render = function(a, e2, d2, y2) {
        var x2 = a.getModel("breadcrumb"), C = this.group;
        if (C.removeAll(), !(!x2.get("show") || !d2)) {
          var D2 = x2.getModel("itemStyle"), L = D2.getModel("textStyle"), F3 = { pos: { left: x2.get("left"), right: x2.get("right"), top: x2.get("top"), bottom: x2.get("bottom") }, box: { width: e2.getWidth(), height: e2.getHeight() }, emptyItemWidth: x2.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
          this._prepare(d2, F3, L), this._renderContent(a, F3, D2, L, y2), cyt(C, F3.pos, F3.box);
        }
      }, l2.prototype._prepare = function(a, e2, d2) {
        for (var y2 = a; y2; y2 = y2.parentNode) {
          var x2 = Ud2(y2.getModel().get("name"), ""), C = d2.getTextRect(x2), D2 = Math.max(C.width + irn * 2, e2.emptyItemWidth);
          e2.totalWidth += D2 + Xue, e2.renderList.push({ node: y2, text: x2, width: D2 });
        }
      }, l2.prototype._renderContent = function(a, e2, d2, y2, x2) {
        for (var C = 0, D2 = e2.emptyItemWidth, L = a.get(["breadcrumb", "height"]), F3 = d$e(e2.pos, e2.box), j = e2.totalWidth, U3 = e2.renderList, Y3 = U3.length - 1; Y3 >= 0; Y3--) {
          var Q = U3[Y3], nt = Q.node, dt = Q.width, vt = Q.text;
          j > F3.width && (j -= dt - D2, dt = D2, vt = null);
          var Ct = new rw({ shape: { points: orn(C, 0, dt, L, Y3 === U3.length - 1, Y3 === 0) }, style: El(d2.getItemStyle(), { lineJoin: "bevel" }), textContent: new qc2({ style: { text: vt, fill: y2.getTextColor(), font: y2.getFont() } }), textConfig: { position: "inside" }, z2: nP * 1e4, onclick: xu(x2, nt) });
          Ct.disableLabelAnimation = true, this.group.add(Ct), srn(Ct, a, nt), C += dt + Xue;
        }
      }, l2.prototype.remove = function() {
        this.group.removeAll();
      }, l2;
    }();
    function orn(l2, a, e2, d2, y2, x2) {
      var C = [[y2 ? l2 : l2 - LOt, a], [l2 + e2, a], [l2 + e2, a + d2], [y2 ? l2 : l2 - LOt, a + d2]];
      return !x2 && C.splice(2, 0, [l2 + e2 + LOt, a + d2 / 2]), !y2 && C.push([l2, a + d2 / 2]), C;
    }
    function srn(l2, a, e2) {
      ns(l2).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: a.componentIndex, seriesIndex: a.seriesIndex, seriesName: a.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: e2 && e2.dataIndex, name: e2 && e2.name }, treePathInfo: e2 && fmt(e2, a) };
    }
    var lrn = arn, urn = function() {
      function l2() {
        this._storage = [], this._elExistsMap = {};
      }
      return l2.prototype.add = function(a, e2, d2, y2, x2) {
        return this._elExistsMap[a.id] ? false : (this._elExistsMap[a.id] = true, this._storage.push({ el: a, target: e2, duration: d2, delay: y2, easing: x2 }), true);
      }, l2.prototype.finished = function(a) {
        return this._finishedCallback = a, this;
      }, l2.prototype.start = function() {
        for (var a = this, e2 = this._storage.length, d2 = function() {
          e2--, e2 <= 0 && (a._storage.length = 0, a._elExistsMap = {}, a._finishedCallback && a._finishedCallback());
        }, y2 = 0, x2 = this._storage.length; y2 < x2; y2++) {
          var C = this._storage[y2];
          C.el.animateTo(C.target, { duration: C.duration, delay: C.delay, easing: C.easing, setToFinal: true, done: d2, aborted: d2 });
        }
        return this;
      }, l2;
    }();
    function crn() {
      return new urn();
    }
    var OOt = ou, Que = Nf2, Jue = 3, tce = "label", ece = "upperLabel", frn = nP * 10, hrn = nP * 2, prn = nP * 3, wB = dO([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), nce = function(l2) {
      var a = wB(l2);
      return a.stroke = a.fill = a.lineWidth = null, a;
    }, hmt = Rf2(), drn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._state = "ready", e2._storage = Jrt(), e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        var C = d2.findComponents({ mainType: "series", subType: "treemap", query: x2 });
        if (!(oc2(C, e2) < 0)) {
          this.seriesModel = e2, this.api = y2, this.ecModel = d2;
          var D2 = ["treemapZoomToNode", "treemapRootToNode"], L = Xrt(x2, D2, e2), F3 = x2 && x2.type, j = e2.layoutInfo, U3 = !this._oldTree, Y3 = this._storage, Q = F3 === "treemapRootToNode" && L && Y3 ? { rootNodeGroup: Y3.nodeGroup[L.node.getRawIndex()], direction: x2.direction } : null, nt = this._giveContainerGroup(j), dt = e2.get("animation"), vt = this._doRender(nt, e2, Q);
          dt && !U3 && (!F3 || F3 === "treemapZoomToNode" || F3 === "treemapRootToNode") ? this._doAnimation(nt, vt, e2, Q) : vt.renderFinally(), this._resetController(y2), this._renderBreadcrumb(e2, y2, L);
        }
      }, a.prototype._giveContainerGroup = function(e2) {
        var d2 = this._containerGroup;
        return d2 || (d2 = this._containerGroup = new OOt(), this._initEvents(d2), this.group.add(d2)), d2.x = e2.x, d2.y = e2.y, d2;
      }, a.prototype._doRender = function(e2, d2, y2) {
        var x2 = d2.getData().tree, C = this._oldTree, D2 = Jrt(), L = Jrt(), F3 = this._storage, j = [];
        function U3(vt, Ct, Pt, jt) {
          return grn(d2, L, F3, y2, D2, j, vt, Ct, Pt, jt);
        }
        Q(x2.root ? [x2.root] : [], C && C.root ? [C.root] : [], e2, x2 === C || !C, 0);
        var Y3 = nt(F3);
        return this._oldTree = x2, this._storage = L, { lastsForAnimation: D2, willDeleteEls: Y3, renderFinally: dt };
        function Q(vt, Ct, Pt, jt, Rt) {
          jt ? (Ct = vt, Ke2(vt, function(he2, _e) {
            !he2.isRemoved() && ne2(_e, _e);
          })) : new kO(Ct, vt, le2, le2).add(ne2).update(ne2).remove(xu(ne2, null)).execute();
          function le2(he2) {
            return he2.getId();
          }
          function ne2(he2, _e) {
            var Me2 = he2 != null ? vt[he2] : null, Pe2 = _e != null ? Ct[_e] : null, Be2 = U3(Me2, Pe2, Pt, Rt);
            Be2 && Q(Me2 && Me2.viewChildren || [], Pe2 && Pe2.viewChildren || [], Be2, jt, Rt + 1);
          }
        }
        function nt(vt) {
          var Ct = Jrt();
          return vt && Ke2(vt, function(Pt, jt) {
            var Rt = Ct[jt];
            Ke2(Pt, function(le2) {
              le2 && (Rt.push(le2), hmt(le2).willDelete = true);
            });
          }), Ct;
        }
        function dt() {
          Ke2(Y3, function(vt) {
            Ke2(vt, function(Ct) {
              Ct.parent && Ct.parent.remove(Ct);
            });
          }), Ke2(j, function(vt) {
            vt.invisible = true, vt.dirty();
          });
        }
      }, a.prototype._doAnimation = function(e2, d2, y2, x2) {
        var C = y2.get("animationDurationUpdate"), D2 = y2.get("animationEasing"), L = (wl(C) ? 0 : C) || 0, F3 = (wl(D2) ? null : D2) || "cubicOut", j = crn();
        Ke2(d2.willDeleteEls, function(U3, Y3) {
          Ke2(U3, function(Q, nt) {
            if (!Q.invisible) {
              var dt = Q.parent, vt, Ct = hmt(dt);
              if (x2 && x2.direction === "drillDown")
                vt = dt === x2.rootNodeGroup ? { shape: { x: 0, y: 0, width: Ct.nodeWidth, height: Ct.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
              else {
                var Pt = 0, jt = 0;
                Ct.willDelete || (Pt = Ct.nodeWidth / 2, jt = Ct.nodeHeight / 2), vt = Y3 === "nodeGroup" ? { x: Pt, y: jt, style: { opacity: 0 } } : { shape: { x: Pt, y: jt, width: 0, height: 0 }, style: { opacity: 0 } };
              }
              vt && j.add(Q, vt, L, 0, F3);
            }
          });
        }), Ke2(this._storage, function(U3, Y3) {
          Ke2(U3, function(Q, nt) {
            var dt = d2.lastsForAnimation[Y3][nt], vt = {};
            !dt || (Q instanceof ou ? dt.oldX != null && (vt.x = Q.x, vt.y = Q.y, Q.x = dt.oldX, Q.y = dt.oldY) : (dt.oldShape && (vt.shape = la2({}, Q.shape), Q.setShape(dt.oldShape)), dt.fadein ? (Q.setStyle("opacity", 0), vt.style = { opacity: 1 }) : Q.style.opacity !== 1 && (vt.style = { opacity: 1 })), j.add(Q, vt, L, 0, F3));
          });
        }, this), this._state = "animating", j.finished(As(function() {
          this._state = "ready", d2.renderFinally();
        }, this)).start();
      }, a.prototype._resetController = function(e2) {
        var d2 = this._controller;
        d2 || (d2 = this._controller = new Zrt(e2.getZr()), d2.enable(this.seriesModel.get("roam")), d2.on("pan", As(this._onPan, this)), d2.on("zoom", As(this._onZoom, this)));
        var y2 = new Yu(0, 0, e2.getWidth(), e2.getHeight());
        d2.setPointerChecker(function(x2, C, D2) {
          return y2.contain(C, D2);
        });
      }, a.prototype._clearController = function() {
        var e2 = this._controller;
        e2 && (e2.dispose(), e2 = null);
      }, a.prototype._onPan = function(e2) {
        if (this._state !== "animating" && (Math.abs(e2.dx) > Jue || Math.abs(e2.dy) > Jue)) {
          var d2 = this.seriesModel.getData().tree.root;
          if (!d2)
            return;
          var y2 = d2.getLayout();
          if (!y2)
            return;
          this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: y2.x + e2.dx, y: y2.y + e2.dy, width: y2.width, height: y2.height } });
        }
      }, a.prototype._onZoom = function(e2) {
        var d2 = e2.originX, y2 = e2.originY;
        if (this._state !== "animating") {
          var x2 = this.seriesModel.getData().tree.root;
          if (!x2)
            return;
          var C = x2.getLayout();
          if (!C)
            return;
          var D2 = new Yu(C.x, C.y, C.width, C.height), L = this.seriesModel.layoutInfo;
          d2 -= L.x, y2 -= L.y;
          var F3 = Xx();
          LS(F3, F3, [-d2, -y2]), KU(F3, F3, [e2.scale, e2.scale]), LS(F3, F3, [d2, y2]), D2.applyTransform(F3), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: D2.x, y: D2.y, width: D2.width, height: D2.height } });
        }
      }, a.prototype._initEvents = function(e2) {
        var d2 = this;
        e2.on("click", function(y2) {
          if (d2._state === "ready") {
            var x2 = d2.seriesModel.get("nodeClick", true);
            if (x2) {
              var C = d2.findTarget(y2.offsetX, y2.offsetY);
              if (C) {
                var D2 = C.node;
                if (D2.getLayout().isLeafRoot)
                  d2._rootToNode(C);
                else if (x2 === "zoomToNode")
                  d2._zoomToNode(C);
                else if (x2 === "link") {
                  var L = D2.hostTree.data.getItemModel(D2.dataIndex), F3 = L.get("link", true), j = L.get("target", true) || "blank";
                  F3 && lyt(F3, j);
                }
              }
            }
          }
        }, this);
      }, a.prototype._renderBreadcrumb = function(e2, d2, y2) {
        var x2 = this;
        y2 || (y2 = e2.get("leafDepth", true) != null ? { node: e2.getViewRoot() } : this.findTarget(d2.getWidth() / 2, d2.getHeight() / 2), y2 || (y2 = { node: e2.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new lrn(this.group))).render(e2, d2, y2.node, function(C) {
          x2._state !== "animating" && (POt(e2.getViewRoot(), C) ? x2._rootToNode({ node: C }) : x2._zoomToNode({ node: C }));
        });
      }, a.prototype.remove = function() {
        this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = Jrt(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
      }, a.prototype.dispose = function() {
        this._clearController();
      }, a.prototype._zoomToNode = function(e2) {
        this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e2.node });
      }, a.prototype._rootToNode = function(e2) {
        this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e2.node });
      }, a.prototype.findTarget = function(e2, d2) {
        var y2, x2 = this.seriesModel.getViewRoot();
        return x2.eachNode({ attr: "viewChildren", order: "preorder" }, function(C) {
          var D2 = this._storage.background[C.getRawIndex()];
          if (D2) {
            var L = D2.transformCoordToLocal(e2, d2), F3 = D2.shape;
            if (F3.x <= L[0] && L[0] <= F3.x + F3.width && F3.y <= L[1] && L[1] <= F3.y + F3.height)
              y2 = { node: C, offsetX: L[0], offsetY: L[1] };
            else
              return false;
          }
        }, this), y2;
      }, a.type = "treemap", a;
    }(pg2);
    function Jrt() {
      return { nodeGroup: [], background: [], content: [] };
    }
    function grn(l2, a, e2, d2, y2, x2, C, D2, L, F3) {
      if (!C)
        return;
      var j = C.getLayout(), U3 = l2.getData(), Y3 = C.getModel();
      if (U3.setItemGraphicEl(C.dataIndex, null), !j || !j.isInView)
        return;
      var Q = j.width, nt = j.height, dt = j.borderWidth, vt = j.invisible, Ct = C.getRawIndex(), Pt = D2 && D2.getRawIndex(), jt = C.viewChildren, Rt = j.upperHeight, le2 = jt && jt.length, ne2 = Y3.getModel("itemStyle"), he2 = Y3.getModel(["emphasis", "itemStyle"]), _e = Y3.getModel(["blur", "itemStyle"]), Me2 = Y3.getModel(["select", "itemStyle"]), Pe2 = ne2.get("borderRadius") || 0, Be2 = Ss("nodeGroup", OOt);
      if (!Be2)
        return;
      if (L.add(Be2), Be2.x = j.x || 0, Be2.y = j.y || 0, Be2.markRedraw(), hmt(Be2).nodeWidth = Q, hmt(Be2).nodeHeight = nt, j.isAboveViewRoot)
        return Be2;
      var Je2 = Ss("background", Que, F3, hrn);
      Je2 && ar(Be2, Je2, le2 && j.upperLabelHeight);
      var Ze2 = Y3.getModel("emphasis"), Cn = Ze2.get("focus"), Bn = Ze2.get("blurScope"), mn = Ze2.get("disabled"), Kr = Cn === "ancestor" ? C.getAncestorsIndices() : Cn === "descendant" ? C.getDescendantIndices() : Cn;
      if (le2)
        TO(Be2) && CO(Be2, false), Je2 && (CO(Je2, !mn), U3.setItemGraphicEl(C.dataIndex, Je2), znt(Je2, Kr, Bn));
      else {
        var Kn = Ss("content", Que, F3, prn);
        Kn && Cr(Be2, Kn), Je2.disableMorphing = true, Je2 && TO(Je2) && CO(Je2, false), CO(Be2, !mn), U3.setItemGraphicEl(C.dataIndex, Be2), znt(Be2, Kr, Bn);
      }
      return Be2;
      function ar(Js, rs, Gs) {
        var al = ns(rs);
        if (al.dataIndex = C.dataIndex, al.seriesIndex = l2.seriesIndex, rs.setShape({ x: 0, y: 0, width: Q, height: nt, r: Pe2 }), vt)
          ui2(rs);
        else {
          rs.invisible = false;
          var _s = C.getVisual("style"), Fl = _s.stroke, Ih2 = nce(ne2);
          Ih2.fill = Fl;
          var lu = wB(he2);
          lu.fill = he2.get("borderColor");
          var ah2 = wB(_e);
          ah2.fill = _e.get("borderColor");
          var Uh2 = wB(Me2);
          if (Uh2.fill = Me2.get("borderColor"), Gs) {
            var Np = Q - 2 * dt;
            vi2(rs, Fl, _s.opacity, { x: dt, y: 0, width: Np, height: Rt });
          } else
            rs.removeTextContent();
          rs.setStyle(Ih2), rs.ensureState("emphasis").style = lu, rs.ensureState("blur").style = ah2, rs.ensureState("select").style = Uh2, SO(rs);
        }
        Js.add(rs);
      }
      function Cr(Js, rs) {
        var Gs = ns(rs);
        Gs.dataIndex = C.dataIndex, Gs.seriesIndex = l2.seriesIndex;
        var al = Math.max(Q - 2 * dt, 0), _s = Math.max(nt - 2 * dt, 0);
        if (rs.culling = true, rs.setShape({ x: dt, y: dt, width: al, height: _s, r: Pe2 }), vt)
          ui2(rs);
        else {
          rs.invisible = false;
          var Fl = C.getVisual("style"), Ih2 = Fl.fill, lu = nce(ne2);
          lu.fill = Ih2, lu.decal = Fl.decal;
          var ah2 = wB(he2), Uh2 = wB(_e), Np = wB(Me2);
          vi2(rs, Ih2, Fl.opacity, null), rs.setStyle(lu), rs.ensureState("emphasis").style = ah2, rs.ensureState("blur").style = Uh2, rs.ensureState("select").style = Np, SO(rs);
        }
        Js.add(rs);
      }
      function ui2(Js) {
        !Js.invisible && x2.push(Js);
      }
      function vi2(Js, rs, Gs, al) {
        var _s = Y3.getModel(al ? ece : tce), Fl = Ud2(Y3.get("name"), null), Ih2 = _s.getShallow("show");
        ow(Js, Sb2(Y3, al ? ece : tce), { defaultText: Ih2 ? Fl : null, inheritColor: rs, defaultOpacity: Gs, labelFetcher: l2, labelDataIndex: C.dataIndex });
        var lu = Js.getTextContent();
        if (lu) {
          var ah2 = lu.style, Uh2 = pE(ah2.padding || 0);
          al && (Js.setTextConfig({ layoutRect: al }), lu.disableLabelLayout = true), lu.beforeUpdate = function() {
            var Zy = Math.max((al ? al.width : Js.shape.width) - Uh2[1] - Uh2[3], 0), Nd2 = Math.max((al ? al.height : Js.shape.height) - Uh2[0] - Uh2[2], 0);
            (ah2.width !== Zy || ah2.height !== Nd2) && lu.setStyle({ width: Zy, height: Nd2 });
          }, ah2.truncateMinChar = 2, ah2.lineOverflow = "truncate", ko(ah2, al, j);
          var Np = lu.getState("emphasis");
          ko(Np ? Np.style : null, al, j);
        }
      }
      function ko(Js, rs, Gs) {
        var al = Js ? Js.text : null;
        if (!rs && Gs.isLeafRoot && al != null) {
          var _s = l2.get("drillDownIcon", true);
          Js.text = _s ? _s + " " + al : al;
        }
      }
      function Ss(Js, rs, Gs, al) {
        var _s = Pt != null && e2[Js][Pt], Fl = y2[Js];
        return _s ? (e2[Js][Pt] = null, hl(Fl, _s)) : vt || (_s = new rs(), _s instanceof Y2 && (_s.z2 = vrn(Gs, al)), Qs(Fl, _s)), a[Js][Ct] = _s;
      }
      function hl(Js, rs) {
        var Gs = Js[Ct] = {};
        rs instanceof OOt ? (Gs.oldX = rs.x, Gs.oldY = rs.y) : Gs.oldShape = la2({}, rs.shape);
      }
      function Qs(Js, rs) {
        var Gs = Js[Ct] = {}, al = C.parentNode, _s = rs instanceof ou;
        if (al && (!d2 || d2.direction === "drillDown")) {
          var Fl = 0, Ih2 = 0, lu = y2.background[al.getRawIndex()];
          !d2 && lu && lu.oldShape && (Fl = lu.oldShape.width, Ih2 = lu.oldShape.height), _s ? (Gs.oldX = 0, Gs.oldY = Ih2) : Gs.oldShape = { x: Fl, y: Ih2, width: 0, height: 0 };
        }
        Gs.fadein = !_s;
      }
    }
    function vrn(l2, a) {
      return l2 * frn + a;
    }
    var yrn = drn, tit = Ke2, mrn = vs, pmt = -1, ROt = function() {
      function l2(a) {
        var e2 = a.mappingMethod, d2 = a.type, y2 = this.option = zl(a);
        this.type = d2, this.mappingMethod = e2, this._normalizeData = xrn[e2];
        var x2 = l2.visualHandlers[d2];
        this.applyVisual = x2.applyVisual, this.getColorMapper = x2.getColorMapper, this._normalizedToVisual = x2._normalizedToVisual[e2], e2 === "piecewise" ? (NOt(y2), brn(y2)) : e2 === "category" ? y2.categories ? _rn(y2) : NOt(y2, true) : (vb2(e2 !== "linear" || y2.dataExtent), NOt(y2));
      }
      return l2.prototype.mapValueToVisual = function(a) {
        var e2 = this._normalizeData(a);
        return this._normalizedToVisual(e2, a);
      }, l2.prototype.getNormalizer = function() {
        return As(this._normalizeData, this);
      }, l2.listVisualTypes = function() {
        return Qc2(l2.visualHandlers);
      }, l2.isValidType = function(a) {
        return l2.visualHandlers.hasOwnProperty(a);
      }, l2.eachVisual = function(a, e2, d2) {
        vs(a) ? Ke2(a, e2, d2) : e2.call(d2, a);
      }, l2.mapVisual = function(a, e2, d2) {
        var y2, x2 = Ba2(a) ? [] : vs(a) ? {} : (y2 = true, null);
        return l2.eachVisual(a, function(C, D2) {
          var L = e2.call(d2, C, D2);
          y2 ? x2 = L : x2[D2] = L;
        }), x2;
      }, l2.retrieveVisuals = function(a) {
        var e2 = {}, d2;
        return a && tit(l2.visualHandlers, function(y2, x2) {
          a.hasOwnProperty(x2) && (e2[x2] = a[x2], d2 = true);
        }), d2 ? e2 : null;
      }, l2.prepareVisualTypes = function(a) {
        if (Ba2(a))
          a = a.slice();
        else if (mrn(a)) {
          var e2 = [];
          tit(a, function(d2, y2) {
            e2.push(y2);
          }), a = e2;
        } else
          return [];
        return a.sort(function(d2, y2) {
          return y2 === "color" && d2 !== "color" && d2.indexOf("color") === 0 ? 1 : -1;
        }), a;
      }, l2.dependsOn = function(a, e2) {
        return e2 === "color" ? !!(a && a.indexOf(e2) === 0) : a === e2;
      }, l2.findPieceIndex = function(a, e2, d2) {
        for (var y2, x2 = 1 / 0, C = 0, D2 = e2.length; C < D2; C++) {
          var L = e2[C].value;
          if (L != null) {
            if (L === a || ps(L) && L === a + "")
              return C;
            d2 && Y3(L, C);
          }
        }
        for (var C = 0, D2 = e2.length; C < D2; C++) {
          var F3 = e2[C], j = F3.interval, U3 = F3.close;
          if (j) {
            if (j[0] === -1 / 0) {
              if (gmt(U3[1], a, j[1]))
                return C;
            } else if (j[1] === 1 / 0) {
              if (gmt(U3[0], j[0], a))
                return C;
            } else if (gmt(U3[0], j[0], a) && gmt(U3[1], a, j[1]))
              return C;
            d2 && Y3(j[0], C), d2 && Y3(j[1], C);
          }
        }
        if (d2)
          return a === 1 / 0 ? e2.length - 1 : a === -1 / 0 ? 0 : y2;
        function Y3(Q, nt) {
          var dt = Math.abs(Q - a);
          dt < x2 && (x2 = dt, y2 = nt);
        }
      }, l2.visualHandlers = { color: { applyVisual: eit("color"), getColorMapper: function() {
        var a = this.option;
        return As(a.mappingMethod === "category" ? function(e2, d2) {
          return !d2 && (e2 = this._normalizeData(e2)), nit.call(this, e2);
        } : function(e2, d2, y2) {
          var x2 = !!y2;
          return !d2 && (e2 = this._normalizeData(e2)), y2 = Fet(e2, a.parsedVisual, y2), x2 ? y2 : d1(y2, "rgba");
        }, this);
      }, _normalizedToVisual: { linear: function(a) {
        return d1(Fet(a, this.option.parsedVisual), "rgba");
      }, category: nit, piecewise: function(a, e2) {
        var d2 = VOt.call(this, e2);
        return d2 == null && (d2 = d1(Fet(a, this.option.parsedVisual), "rgba")), d2;
      }, fixed: SB } }, colorHue: dmt(function(a, e2) {
        return IV(a, e2);
      }), colorSaturation: dmt(function(a, e2) {
        return IV(a, null, e2);
      }), colorLightness: dmt(function(a, e2) {
        return IV(a, null, null, e2);
      }), colorAlpha: dmt(function(a, e2) {
        return zU(a, e2);
      }), decal: { applyVisual: eit("decal"), _normalizedToVisual: { linear: null, category: nit, piecewise: null, fixed: null } }, opacity: { applyVisual: eit("opacity"), _normalizedToVisual: FOt([0, 1]) }, liftZ: { applyVisual: eit("liftZ"), _normalizedToVisual: { linear: SB, category: SB, piecewise: SB, fixed: SB } }, symbol: { applyVisual: function(a, e2, d2) {
        var y2 = this.mapValueToVisual(a);
        d2("symbol", y2);
      }, _normalizedToVisual: { linear: rce, category: nit, piecewise: function(a, e2) {
        var d2 = VOt.call(this, e2);
        return d2 == null && (d2 = rce.call(this, a)), d2;
      }, fixed: SB } }, symbolSize: { applyVisual: eit("symbolSize"), _normalizedToVisual: FOt([0, 1]) } }, l2;
    }();
    function brn(l2) {
      var a = l2.pieceList;
      l2.hasSpecialVisual = false, Ke2(a, function(e2, d2) {
        e2.originIndex = d2, e2.visual != null && (l2.hasSpecialVisual = true);
      });
    }
    function _rn(l2) {
      var a = l2.categories, e2 = l2.categoryMap = {}, d2 = l2.visual;
      if (tit(a, function(C, D2) {
        e2[C] = D2;
      }), !Ba2(d2)) {
        var y2 = [];
        vs(d2) ? tit(d2, function(C, D2) {
          var L = e2[D2];
          y2[L != null ? L : pmt] = C;
        }) : y2[pmt] = d2, d2 = ice(l2, y2);
      }
      for (var x2 = a.length - 1; x2 >= 0; x2--)
        d2[x2] == null && (delete e2[a[x2]], a.pop());
    }
    function NOt(l2, a) {
      var e2 = l2.visual, d2 = [];
      vs(e2) ? tit(e2, function(x2) {
        d2.push(x2);
      }) : e2 != null && d2.push(e2);
      var y2 = { color: 1, symbol: 1 };
      !a && d2.length === 1 && !y2.hasOwnProperty(l2.type) && (d2[1] = d2[0]), ice(l2, d2);
    }
    function dmt(l2) {
      return { applyVisual: function(a, e2, d2) {
        var y2 = this.mapValueToVisual(a);
        d2("color", l2(e2("color"), y2));
      }, _normalizedToVisual: FOt([0, 1]) };
    }
    function rce(l2) {
      var a = this.option.visual;
      return a[Math.round(yp(l2, [0, 1], [0, a.length - 1], true))] || {};
    }
    function eit(l2) {
      return function(a, e2, d2) {
        d2(l2, this.mapValueToVisual(a));
      };
    }
    function nit(l2) {
      var a = this.option.visual;
      return a[this.option.loop && l2 !== pmt ? l2 % a.length : l2];
    }
    function SB() {
      return this.option.visual[0];
    }
    function FOt(l2) {
      return { linear: function(a) {
        return yp(a, l2, this.option.visual, true);
      }, category: nit, piecewise: function(a, e2) {
        var d2 = VOt.call(this, e2);
        return d2 == null && (d2 = yp(a, l2, this.option.visual, true)), d2;
      }, fixed: SB };
    }
    function VOt(l2) {
      var a = this.option, e2 = a.pieceList;
      if (a.hasSpecialVisual) {
        var d2 = ROt.findPieceIndex(l2, e2), y2 = e2[d2];
        if (y2 && y2.visual)
          return y2.visual[this.type];
      }
    }
    function ice(l2, a) {
      return l2.visual = a, l2.type === "color" && (l2.parsedVisual = $a2(a, function(e2) {
        return kS(e2);
      })), a;
    }
    var xrn = { linear: function(l2) {
      return yp(l2, this.option.dataExtent, [0, 1], true);
    }, piecewise: function(l2) {
      var a = this.option.pieceList, e2 = ROt.findPieceIndex(l2, a, true);
      if (e2 != null)
        return yp(e2, [0, a.length - 1], [0, 1], true);
    }, category: function(l2) {
      var a = this.option.categories ? this.option.categoryMap[l2] : l2;
      return a == null ? pmt : a;
    }, fixed: $p };
    function gmt(l2, a, e2) {
      return l2 ? a <= e2 : a < e2;
    }
    var B_ = ROt, wrn = "itemStyle", ace = Rf2(), Srn = { seriesType: "treemap", reset: function(l2) {
      var a = l2.getData().tree, e2 = a.root;
      e2.isRemoved() || oce(e2, {}, l2.getViewRoot().getAncestors(), l2);
    } };
    function oce(l2, a, e2, d2) {
      var y2 = l2.getModel(), x2 = l2.getLayout(), C = l2.hostTree.data;
      if (!(!x2 || x2.invisible || !x2.isInView)) {
        var D2 = y2.getModel(wrn), L = Mrn(D2, a, d2), F3 = C.ensureUniqueItemVisual(l2.dataIndex, "style"), j = D2.get("borderColor"), U3 = D2.get("borderColorSaturation"), Y3;
        U3 != null && (Y3 = sce(L), j = Crn(U3, Y3)), F3.stroke = j;
        var Q = l2.viewChildren;
        if (!Q || !Q.length)
          Y3 = sce(L), F3.fill = Y3;
        else {
          var nt = Trn(l2, y2, x2, D2, L, Q);
          Ke2(Q, function(dt, vt) {
            if (dt.depth >= e2.length || dt === e2[dt.depth]) {
              var Ct = Arn(y2, L, dt, vt, nt, d2);
              oce(dt, Ct, e2, d2);
            }
          });
        }
      }
    }
    function Mrn(l2, a, e2) {
      var d2 = la2({}, a), y2 = e2.designatedVisualItemStyle;
      return Ke2(["color", "colorAlpha", "colorSaturation"], function(x2) {
        y2[x2] = a[x2];
        var C = l2.get(x2);
        y2[x2] = null, C != null && (d2[x2] = C);
      }), d2;
    }
    function sce(l2) {
      var a = BOt(l2, "color");
      if (a) {
        var e2 = BOt(l2, "colorAlpha"), d2 = BOt(l2, "colorSaturation");
        return d2 && (a = IV(a, null, null, d2)), e2 && (a = zU(a, e2)), a;
      }
    }
    function Crn(l2, a) {
      return a != null ? IV(a, null, null, l2) : null;
    }
    function BOt(l2, a) {
      var e2 = l2[a];
      if (e2 != null && e2 !== "none")
        return e2;
    }
    function Trn(l2, a, e2, d2, y2, x2) {
      if (!(!x2 || !x2.length)) {
        var C = zOt(a, "color") || y2.color != null && y2.color !== "none" && (zOt(a, "colorAlpha") || zOt(a, "colorSaturation"));
        if (C) {
          var D2 = a.get("visualMin"), L = a.get("visualMax"), F3 = e2.dataExtent.slice();
          D2 != null && D2 < F3[0] && (F3[0] = D2), L != null && L > F3[1] && (F3[1] = L);
          var j = a.get("colorMappingBy"), U3 = { type: C.name, dataExtent: F3, visual: C.range };
          U3.type === "color" && (j === "index" || j === "id") ? (U3.mappingMethod = "category", U3.loop = true) : U3.mappingMethod = "linear";
          var Y3 = new B_(U3);
          return ace(Y3).drColorMappingBy = j, Y3;
        }
      }
    }
    function zOt(l2, a) {
      var e2 = l2.get(a);
      return Ba2(e2) && e2.length ? { name: a, range: e2 } : null;
    }
    function Arn(l2, a, e2, d2, y2, x2) {
      var C = la2({}, a);
      if (y2) {
        var D2 = y2.type, L = D2 === "color" && ace(y2).drColorMappingBy, F3 = L === "index" ? d2 : L === "id" ? x2.mapIdToIndex(e2.getId()) : e2.getValue(l2.get("visualDimension"));
        C[D2] = y2.mapValueToVisual(F3);
      }
      return C;
    }
    var rit = Math.max, vmt = Math.min, lce = jy, jOt = Ke2, uce = ["itemStyle", "borderWidth"], Irn = ["itemStyle", "gapWidth"], Drn = ["upperLabel", "show"], Ern = ["upperLabel", "height"], krn = { seriesType: "treemap", reset: function(l2, a, e2, d2) {
      var y2 = e2.getWidth(), x2 = e2.getHeight(), C = l2.option, D2 = Em(l2.getBoxLayoutParams(), { width: e2.getWidth(), height: e2.getHeight() }), L = C.size || [], F3 = Ko(lce(D2.width, L[0]), y2), j = Ko(lce(D2.height, L[1]), x2), U3 = d2 && d2.type, Y3 = ["treemapZoomToNode", "treemapRootToNode"], Q = Xrt(d2, Y3, l2), nt = U3 === "treemapRender" || U3 === "treemapMove" ? d2.rootRect : null, dt = l2.getViewRoot(), vt = Zue(dt);
      if (U3 !== "treemapMove") {
        var Ct = U3 === "treemapZoomToNode" ? Frn(l2, Q, dt, F3, j) : nt ? [nt.width, nt.height] : [F3, j], Pt = C.sort;
        Pt && Pt !== "asc" && Pt !== "desc" && (Pt = "desc");
        var jt = { squareRatio: C.squareRatio, sort: Pt, leafDepth: C.leafDepth };
        dt.hostTree.clearLayouts();
        var Rt = { x: 0, y: 0, width: Ct[0], height: Ct[1], area: Ct[0] * Ct[1] };
        dt.setLayout(Rt), cce(dt, jt, false, 0), Rt = dt.getLayout(), jOt(vt, function(ne2, he2) {
          var _e = (vt[he2 + 1] || dt).getValue();
          ne2.setLayout(la2({ dataExtent: [_e, _e], borderWidth: 0, upperHeight: 0 }, Rt));
        });
      }
      var le2 = l2.getData().tree.root;
      le2.setLayout(Vrn(D2, nt, Q), true), l2.setLayoutInfo(D2), hce(le2, new Yu(-D2.x, -D2.y, y2, x2), vt, dt, 0);
    } };
    function cce(l2, a, e2, d2) {
      var y2, x2;
      if (!l2.isRemoved()) {
        var C = l2.getLayout();
        y2 = C.width, x2 = C.height;
        var D2 = l2.getModel(), L = D2.get(uce), F3 = D2.get(Irn) / 2, j = pce(D2), U3 = Math.max(L, j), Y3 = L - F3, Q = U3 - F3;
        l2.setLayout({ borderWidth: L, upperHeight: U3, upperLabelHeight: j }, true), y2 = rit(y2 - 2 * Y3, 0), x2 = rit(x2 - Y3 - Q, 0);
        var nt = y2 * x2, dt = Prn(l2, D2, nt, a, e2, d2);
        if (dt.length) {
          var vt = { x: Y3, y: Q, width: y2, height: x2 }, Ct = vmt(y2, x2), Pt = 1 / 0, jt = [];
          jt.area = 0;
          for (var Rt = 0, le2 = dt.length; Rt < le2; ) {
            var ne2 = dt[Rt];
            jt.push(ne2), jt.area += ne2.getLayout().area;
            var he2 = Nrn(jt, Ct, a.squareRatio);
            he2 <= Pt ? (Rt++, Pt = he2) : (jt.area -= jt.pop().getLayout().area, fce(jt, Ct, vt, F3, false), Ct = vmt(vt.width, vt.height), jt.length = jt.area = 0, Pt = 1 / 0);
          }
          if (jt.length && fce(jt, Ct, vt, F3, true), !e2) {
            var _e = D2.get("childrenVisibleMin");
            _e != null && nt < _e && (e2 = true);
          }
          for (var Rt = 0, le2 = dt.length; Rt < le2; Rt++)
            cce(dt[Rt], a, e2, d2 + 1);
        }
      }
    }
    function Prn(l2, a, e2, d2, y2, x2) {
      var C = l2.children || [], D2 = d2.sort;
      D2 !== "asc" && D2 !== "desc" && (D2 = null);
      var L = d2.leafDepth != null && d2.leafDepth <= x2;
      if (y2 && !L)
        return l2.viewChildren = [];
      C = Lp(C, function(Q) {
        return !Q.isRemoved();
      }), Orn(C, D2);
      var F3 = Rrn(a, C, D2);
      if (F3.sum === 0)
        return l2.viewChildren = [];
      if (F3.sum = Lrn(a, e2, F3.sum, D2, C), F3.sum === 0)
        return l2.viewChildren = [];
      for (var j = 0, U3 = C.length; j < U3; j++) {
        var Y3 = C[j].getValue() / F3.sum * e2;
        C[j].setLayout({ area: Y3 });
      }
      return L && (C.length && l2.setLayout({ isLeafRoot: true }, true), C.length = 0), l2.viewChildren = C, l2.setLayout({ dataExtent: F3.dataExtent }, true), C;
    }
    function Lrn(l2, a, e2, d2, y2) {
      if (!d2)
        return e2;
      for (var x2 = l2.get("visibleMin"), C = y2.length, D2 = C, L = C - 1; L >= 0; L--) {
        var F3 = y2[d2 === "asc" ? C - L - 1 : L].getValue();
        F3 / e2 * a < x2 && (D2 = L, e2 -= F3);
      }
      return d2 === "asc" ? y2.splice(0, C - D2) : y2.splice(D2, C - D2), e2;
    }
    function Orn(l2, a) {
      return a && l2.sort(function(e2, d2) {
        var y2 = a === "asc" ? e2.getValue() - d2.getValue() : d2.getValue() - e2.getValue();
        return y2 === 0 ? a === "asc" ? e2.dataIndex - d2.dataIndex : d2.dataIndex - e2.dataIndex : y2;
      }), l2;
    }
    function Rrn(l2, a, e2) {
      for (var d2 = 0, y2 = 0, x2 = a.length; y2 < x2; y2++)
        d2 += a[y2].getValue();
      var C = l2.get("visualDimension"), D2;
      return !a || !a.length ? D2 = [NaN, NaN] : C === "value" && e2 ? (D2 = [a[a.length - 1].getValue(), a[0].getValue()], e2 === "asc" && D2.reverse()) : (D2 = [1 / 0, -1 / 0], jOt(a, function(L) {
        var F3 = L.getValue(C);
        F3 < D2[0] && (D2[0] = F3), F3 > D2[1] && (D2[1] = F3);
      })), { sum: d2, dataExtent: D2 };
    }
    function Nrn(l2, a, e2) {
      for (var d2 = 0, y2 = 1 / 0, x2 = 0, C = void 0, D2 = l2.length; x2 < D2; x2++)
        C = l2[x2].getLayout().area, C && (C < y2 && (y2 = C), C > d2 && (d2 = C));
      var L = l2.area * l2.area, F3 = a * a * e2;
      return L ? rit(F3 * d2 / L, L / (F3 * y2)) : 1 / 0;
    }
    function fce(l2, a, e2, d2, y2) {
      var x2 = a === e2.width ? 0 : 1, C = 1 - x2, D2 = ["x", "y"], L = ["width", "height"], F3 = e2[D2[x2]], j = a ? l2.area / a : 0;
      (y2 || j > e2[L[C]]) && (j = e2[L[C]]);
      for (var U3 = 0, Y3 = l2.length; U3 < Y3; U3++) {
        var Q = l2[U3], nt = {}, dt = j ? Q.getLayout().area / j : 0, vt = nt[L[C]] = rit(j - 2 * d2, 0), Ct = e2[D2[x2]] + e2[L[x2]] - F3, Pt = U3 === Y3 - 1 || Ct < dt ? Ct : dt, jt = nt[L[x2]] = rit(Pt - 2 * d2, 0);
        nt[D2[C]] = e2[D2[C]] + vmt(d2, vt / 2), nt[D2[x2]] = F3 + vmt(d2, jt / 2), F3 += Pt, Q.setLayout(nt, true);
      }
      e2[D2[C]] += j, e2[L[C]] -= j;
    }
    function Frn(l2, a, e2, d2, y2) {
      var x2 = (a || {}).node, C = [d2, y2];
      if (!x2 || x2 === e2)
        return C;
      for (var D2, L = d2 * y2, F3 = L * l2.option.zoomToNodeRatio; D2 = x2.parentNode; ) {
        for (var j = 0, U3 = D2.children, Y3 = 0, Q = U3.length; Y3 < Q; Y3++)
          j += U3[Y3].getValue();
        var nt = x2.getValue();
        if (nt === 0)
          return C;
        F3 *= j / nt;
        var dt = D2.getModel(), vt = dt.get(uce), Ct = Math.max(vt, pce(dt));
        F3 += 4 * vt * vt + (3 * vt + Ct) * Math.pow(F3, 0.5), F3 > nnt && (F3 = nnt), x2 = D2;
      }
      F3 < L && (F3 = L);
      var Pt = Math.pow(F3 / L, 0.5);
      return [d2 * Pt, y2 * Pt];
    }
    function Vrn(l2, a, e2) {
      if (a)
        return { x: a.x, y: a.y };
      var d2 = { x: 0, y: 0 };
      if (!e2)
        return d2;
      var y2 = e2.node, x2 = y2.getLayout();
      if (!x2)
        return d2;
      for (var C = [x2.width / 2, x2.height / 2], D2 = y2; D2; ) {
        var L = D2.getLayout();
        C[0] += L.x, C[1] += L.y, D2 = D2.parentNode;
      }
      return { x: l2.width / 2 - C[0], y: l2.height / 2 - C[1] };
    }
    function hce(l2, a, e2, d2, y2) {
      var x2 = l2.getLayout(), C = e2[y2], D2 = C && C === l2;
      if (!(C && !D2 || y2 === e2.length && l2 !== d2)) {
        l2.setLayout({ isInView: true, invisible: !D2 && !a.intersect(x2), isAboveViewRoot: D2 }, true);
        var L = new Yu(a.x - x2.x, a.y - x2.y, a.width, a.height);
        jOt(l2.viewChildren || [], function(F3) {
          hce(F3, L, e2, d2, y2 + 1);
        });
      }
    }
    function pce(l2) {
      return l2.get(Drn) ? l2.get(Ern) : 0;
    }
    function Brn(l2) {
      l2.registerSeriesModel(rrn), l2.registerChartView(yrn), l2.registerVisual(Srn), l2.registerLayout(krn), trn(l2);
    }
    function zrn(l2) {
      var a = l2.findComponents({ mainType: "legend" });
      !a || !a.length || l2.eachSeriesByType("graph", function(e2) {
        var d2 = e2.getCategoriesData(), y2 = e2.getGraph(), x2 = y2.data, C = d2.mapArray(d2.getName);
        x2.filterSelf(function(D2) {
          var L = x2.getItemModel(D2), F3 = L.getShallow("category");
          if (F3 != null) {
            Ch2(F3) && (F3 = C[F3]);
            for (var j = 0; j < a.length; j++)
              if (!a[j].isSelected(F3))
                return false;
          }
          return true;
        });
      });
    }
    function jrn(l2) {
      var a = {};
      l2.eachSeriesByType("graph", function(e2) {
        var d2 = e2.getCategoriesData(), y2 = e2.getData(), x2 = {};
        d2.each(function(C) {
          var D2 = d2.getName(C);
          x2["ec-" + D2] = C;
          var L = d2.getItemModel(C), F3 = L.getModel("itemStyle").getItemStyle();
          F3.fill || (F3.fill = e2.getColorFromPalette(D2, a)), d2.setItemVisual(C, "style", F3);
          for (var j = ["symbol", "symbolSize", "symbolKeepAspect"], U3 = 0; U3 < j.length; U3++) {
            var Y3 = L.getShallow(j[U3], true);
            Y3 != null && d2.setItemVisual(C, j[U3], Y3);
          }
        }), d2.count() && y2.each(function(C) {
          var D2 = y2.getItemModel(C), L = D2.getShallow("category");
          if (L != null) {
            ps(L) && (L = x2["ec-" + L]);
            var F3 = d2.getItemVisual(L, "style"), j = y2.ensureUniqueItemVisual(C, "style");
            la2(j, F3);
            for (var U3 = ["symbol", "symbolSize", "symbolKeepAspect"], Y3 = 0; Y3 < U3.length; Y3++)
              y2.setItemVisual(C, U3[Y3], d2.getItemVisual(L, U3[Y3]));
          }
        });
      });
    }
    function ymt(l2) {
      return l2 instanceof Array || (l2 = [l2, l2]), l2;
    }
    function Wrn(l2) {
      l2.eachSeriesByType("graph", function(a) {
        var e2 = a.getGraph(), d2 = a.getEdgeData(), y2 = ymt(a.get("edgeSymbol")), x2 = ymt(a.get("edgeSymbolSize"));
        d2.setVisual("fromSymbol", y2 && y2[0]), d2.setVisual("toSymbol", y2 && y2[1]), d2.setVisual("fromSymbolSize", x2 && x2[0]), d2.setVisual("toSymbolSize", x2 && x2[1]), d2.setVisual("style", a.getModel("lineStyle").getLineStyle()), d2.each(function(C) {
          var D2 = d2.getItemModel(C), L = e2.getEdgeByIndex(C), F3 = ymt(D2.getShallow("symbol", true)), j = ymt(D2.getShallow("symbolSize", true)), U3 = D2.getModel("lineStyle").getLineStyle(), Y3 = d2.ensureUniqueItemVisual(C, "style");
          switch (la2(Y3, U3), Y3.stroke) {
            case "source": {
              var Q = L.node1.getVisual("style");
              Y3.stroke = Q && Q.fill;
              break;
            }
            case "target": {
              var Q = L.node2.getVisual("style");
              Y3.stroke = Q && Q.fill;
              break;
            }
          }
          F3[0] && L.setVisual("fromSymbol", F3[0]), F3[1] && L.setVisual("toSymbol", F3[1]), j[0] && L.setVisual("fromSymbolSize", j[0]), j[1] && L.setVisual("toSymbolSize", j[1]);
        });
      });
    }
    var WOt = "-->", mmt = function(l2) {
      return l2.get("autoCurveness") || null;
    }, dce = function(l2, a) {
      var e2 = mmt(l2), d2 = 20, y2 = [];
      if (Ch2(e2))
        d2 = e2;
      else if (Ba2(e2)) {
        l2.__curvenessList = e2;
        return;
      }
      a > d2 && (d2 = a);
      var x2 = d2 % 2 ? d2 + 2 : d2 + 3;
      y2 = [];
      for (var C = 0; C < x2; C++)
        y2.push((C % 2 ? C + 1 : C) / 10 * (C % 2 ? -1 : 1));
      l2.__curvenessList = y2;
    }, iit = function(l2, a, e2) {
      var d2 = [l2.id, l2.dataIndex].join("."), y2 = [a.id, a.dataIndex].join(".");
      return [e2.uid, d2, y2].join(WOt);
    }, gce = function(l2) {
      var a = l2.split(WOt);
      return [a[0], a[2], a[1]].join(WOt);
    }, Grn = function(l2, a) {
      var e2 = iit(l2.node1, l2.node2, a);
      return a.__edgeMap[e2];
    }, Hrn = function(l2, a) {
      var e2 = GOt(iit(l2.node1, l2.node2, a), a), d2 = GOt(iit(l2.node2, l2.node1, a), a);
      return e2 + d2;
    }, GOt = function(l2, a) {
      var e2 = a.__edgeMap;
      return e2[l2] ? e2[l2].length : 0;
    };
    function Urn(l2) {
      !mmt(l2) || (l2.__curvenessList = [], l2.__edgeMap = {}, dce(l2));
    }
    function qrn(l2, a, e2, d2) {
      if (mmt(e2)) {
        var y2 = iit(l2, a, e2), x2 = e2.__edgeMap, C = x2[gce(y2)];
        x2[y2] && !C ? x2[y2].isForward = true : C && x2[y2] && (C.isForward = true, x2[y2].isForward = false), x2[y2] = x2[y2] || [], x2[y2].push(d2);
      }
    }
    function HOt(l2, a, e2, d2) {
      var y2 = mmt(a), x2 = Ba2(y2);
      if (!y2)
        return null;
      var C = Grn(l2, a);
      if (!C)
        return null;
      for (var D2 = -1, L = 0; L < C.length; L++)
        if (C[L] === e2) {
          D2 = L;
          break;
        }
      var F3 = Hrn(l2, a);
      dce(a, F3), l2.lineStyle = l2.lineStyle || {};
      var j = iit(l2.node1, l2.node2, a), U3 = a.__curvenessList, Y3 = x2 || F3 % 2 ? 0 : 1;
      if (C.isForward)
        return U3[Y3 + D2];
      var Q = gce(j), nt = GOt(Q, a), dt = U3[D2 + nt + Y3];
      return d2 ? x2 ? y2 && y2[0] === 0 ? (nt + Y3) % 2 ? dt : -dt : ((nt % 2 ? 0 : 1) + Y3) % 2 ? dt : -dt : (nt + Y3) % 2 ? dt : -dt : U3[D2 + nt + Y3];
    }
    function vce(l2) {
      var a = l2.coordinateSystem;
      if (!(a && a.type !== "view")) {
        var e2 = l2.getGraph();
        e2.eachNode(function(d2) {
          var y2 = d2.getModel();
          d2.setLayout([+y2.get("x"), +y2.get("y")]);
        }), yce(e2, l2);
      }
    }
    function yce(l2, a) {
      l2.eachEdge(function(e2, d2) {
        var y2 = uv(e2.getModel().get(["lineStyle", "curveness"]), -HOt(e2, a, d2, true), 0), x2 = H22(e2.node1.getLayout()), C = H22(e2.node2.getLayout()), D2 = [x2, C];
        +y2 && D2.push([(x2[0] + C[0]) / 2 - (x2[1] - C[1]) * y2, (x2[1] + C[1]) / 2 - (C[0] - x2[0]) * y2]), e2.setLayout(D2);
      });
    }
    function Zrn(l2, a) {
      l2.eachSeriesByType("graph", function(e2) {
        var d2 = e2.get("layout"), y2 = e2.coordinateSystem;
        if (y2 && y2.type !== "view") {
          var x2 = e2.getData(), C = [];
          Ke2(y2.dimensions, function(Y3) {
            C = C.concat(x2.mapDimensionsAll(Y3));
          });
          for (var D2 = 0; D2 < x2.count(); D2++) {
            for (var L = [], F3 = false, j = 0; j < C.length; j++) {
              var U3 = x2.get(C[j], D2);
              isNaN(U3) || (F3 = true), L.push(U3);
            }
            F3 ? x2.setItemLayout(D2, y2.dataToPoint(L)) : x2.setItemLayout(D2, [NaN, NaN]);
          }
          yce(x2.graph, e2);
        } else
          (!d2 || d2 === "none") && vce(e2);
      });
    }
    function ait(l2) {
      var a = l2.coordinateSystem;
      if (a.type !== "view")
        return 1;
      var e2 = l2.option.nodeScaleRatio, d2 = a.scaleX, y2 = a.getZoom(), x2 = (y2 - 1) * e2 + 1;
      return x2 / d2;
    }
    function oit(l2) {
      var a = l2.getVisual("symbolSize");
      return a instanceof Array && (a = (a[0] + a[1]) / 2), +a;
    }
    var mce = Math.PI, UOt = [];
    function bce(l2, a) {
      var e2 = l2.coordinateSystem;
      if (!(e2 && e2.type !== "view")) {
        var d2 = e2.getBoundingRect(), y2 = l2.getData(), x2 = y2.graph, C = d2.width / 2 + d2.x, D2 = d2.height / 2 + d2.y, L = Math.min(d2.width, d2.height) / 2, F3 = y2.count();
        y2.setLayout({ cx: C, cy: D2 }), F3 && ($rn[a](l2, x2, y2, L, C, D2, F3), x2.eachEdge(function(j, U3) {
          var Y3 = uv(j.getModel().get(["lineStyle", "curveness"]), HOt(j, l2, U3), 0), Q = H22(j.node1.getLayout()), nt = H22(j.node2.getLayout()), dt, vt = (Q[0] + nt[0]) / 2, Ct = (Q[1] + nt[1]) / 2;
          +Y3 && (Y3 *= 3, dt = [C * Y3 + vt * (1 - Y3), D2 * Y3 + Ct * (1 - Y3)]), j.setLayout([Q, nt, dt]);
        }));
      }
    }
    var $rn = { value: function(l2, a, e2, d2, y2, x2, C) {
      var D2 = 0, L = e2.getSum("value"), F3 = Math.PI * 2 / (L || C);
      a.eachNode(function(j) {
        var U3 = j.getValue("value"), Y3 = F3 * (L ? U3 : 1) / 2;
        D2 += Y3, j.setLayout([d2 * Math.cos(D2) + y2, d2 * Math.sin(D2) + x2]), D2 += Y3;
      });
    }, symbolSize: function(l2, a, e2, d2, y2, x2, C) {
      var D2 = 0;
      UOt.length = C;
      var L = ait(l2);
      a.eachNode(function(U3) {
        var Y3 = oit(U3);
        isNaN(Y3) && (Y3 = 2), Y3 < 0 && (Y3 = 0), Y3 *= L;
        var Q = Math.asin(Y3 / 2 / d2);
        isNaN(Q) && (Q = mce / 2), UOt[U3.dataIndex] = Q, D2 += Q * 2;
      });
      var F3 = (2 * mce - D2) / C / 2, j = 0;
      a.eachNode(function(U3) {
        var Y3 = F3 + UOt[U3.dataIndex];
        j += Y3, U3.setLayout([d2 * Math.cos(j) + y2, d2 * Math.sin(j) + x2]), j += Y3;
      });
    } };
    function Yrn(l2) {
      l2.eachSeriesByType("graph", function(a) {
        a.get("layout") === "circular" && bce(a, "symbolSize");
      });
    }
    var fZ = eA;
    function Krn(l2, a, e2) {
      for (var d2 = l2, y2 = a, x2 = e2.rect, C = x2.width, D2 = x2.height, L = [x2.x + C / 2, x2.y + D2 / 2], F3 = e2.gravity == null ? 0.1 : e2.gravity, j = 0; j < d2.length; j++) {
        var U3 = d2[j];
        U3.p || (U3.p = P5(C * (Math.random() - 0.5) + L[0], D2 * (Math.random() - 0.5) + L[1])), U3.pp = H22(U3.p), U3.edges = null;
      }
      var Y3 = e2.friction == null ? 0.6 : e2.friction, Q = Y3, nt, dt;
      return { warmUp: function() {
        Q = Y3 * 0.8;
      }, setFixed: function(vt) {
        d2[vt].fixed = true;
      }, setUnfixed: function(vt) {
        d2[vt].fixed = false;
      }, beforeStep: function(vt) {
        nt = vt;
      }, afterStep: function(vt) {
        dt = vt;
      }, step: function(vt) {
        nt && nt(d2, y2);
        for (var Ct = [], Pt = d2.length, jt = 0; jt < y2.length; jt++) {
          var Rt = y2[jt];
          if (!Rt.ignoreForceLayout) {
            var le2 = Rt.n1, ne2 = Rt.n2;
            dE(Ct, ne2.p, le2.p);
            var he2 = xet(Ct) - Rt.d, _e = ne2.w / (le2.w + ne2.w);
            isNaN(_e) && (_e = 0), yV(Ct, Ct), !le2.fixed && fZ(le2.p, le2.p, Ct, _e * he2 * Q), !ne2.fixed && fZ(ne2.p, ne2.p, Ct, -(1 - _e) * he2 * Q);
          }
        }
        for (var jt = 0; jt < Pt; jt++) {
          var Me2 = d2[jt];
          Me2.fixed || (dE(Ct, L, Me2.p), fZ(Me2.p, Me2.p, Ct, F3 * Q));
        }
        for (var jt = 0; jt < Pt; jt++)
          for (var le2 = d2[jt], Pe2 = jt + 1; Pe2 < Pt; Pe2++) {
            var ne2 = d2[Pe2];
            dE(Ct, ne2.p, le2.p);
            var he2 = xet(Ct);
            he2 === 0 && (_et(Ct, Math.random() - 0.5, Math.random() - 0.5), he2 = 1);
            var Be2 = (le2.rep + ne2.rep) / he2 / he2;
            !le2.fixed && fZ(le2.pp, le2.pp, Ct, Be2), !ne2.fixed && fZ(ne2.pp, ne2.pp, Ct, -Be2);
          }
        for (var Je2 = [], jt = 0; jt < Pt; jt++) {
          var Me2 = d2[jt];
          Me2.fixed || (dE(Je2, Me2.p, Me2.pp), fZ(Me2.p, Me2.p, Je2, Q), y0(Me2.pp, Me2.p));
        }
        Q = Q * 0.992;
        var Ze2 = Q < 0.01;
        dt && dt(d2, y2, Ze2), vt && vt(Ze2);
      } };
    }
    function Xrn(l2) {
      l2.eachSeriesByType("graph", function(a) {
        var e2 = a.coordinateSystem;
        if (!(e2 && e2.type !== "view"))
          if (a.get("layout") === "force") {
            var d2 = a.preservedPoints || {}, y2 = a.getGraph(), x2 = y2.data, C = y2.edgeData, D2 = a.getModel("force"), L = D2.get("initLayout");
            a.preservedPoints ? x2.each(function(jt) {
              var Rt = x2.getId(jt);
              x2.setItemLayout(jt, d2[Rt] || [NaN, NaN]);
            }) : !L || L === "none" ? vce(a) : L === "circular" && bce(a, "value");
            var F3 = x2.getDataExtent("value"), j = C.getDataExtent("value"), U3 = D2.get("repulsion"), Y3 = D2.get("edgeLength"), Q = Ba2(U3) ? U3 : [U3, U3], nt = Ba2(Y3) ? Y3 : [Y3, Y3];
            nt = [nt[1], nt[0]];
            var dt = x2.mapArray("value", function(jt, Rt) {
              var le2 = x2.getItemLayout(Rt), ne2 = yp(jt, F3, Q);
              return isNaN(ne2) && (ne2 = (Q[0] + Q[1]) / 2), { w: ne2, rep: ne2, fixed: x2.getItemModel(Rt).get("fixed"), p: !le2 || isNaN(le2[0]) || isNaN(le2[1]) ? null : le2 };
            }), vt = C.mapArray("value", function(jt, Rt) {
              var le2 = y2.getEdgeByIndex(Rt), ne2 = yp(jt, j, nt);
              isNaN(ne2) && (ne2 = (nt[0] + nt[1]) / 2);
              var he2 = le2.getModel(), _e = uv(le2.getModel().get(["lineStyle", "curveness"]), -HOt(le2, a, Rt, true), 0);
              return { n1: dt[le2.node1.dataIndex], n2: dt[le2.node2.dataIndex], d: ne2, curveness: _e, ignoreForceLayout: he2.get("ignoreForceLayout") };
            }), Ct = e2.getBoundingRect(), Pt = Krn(dt, vt, { rect: Ct, gravity: D2.get("gravity"), friction: D2.get("friction") });
            Pt.beforeStep(function(jt, Rt) {
              for (var le2 = 0, ne2 = jt.length; le2 < ne2; le2++)
                jt[le2].fixed && y0(jt[le2].p, y2.getNodeByIndex(le2).getLayout());
            }), Pt.afterStep(function(jt, Rt, le2) {
              for (var ne2 = 0, he2 = jt.length; ne2 < he2; ne2++)
                jt[ne2].fixed || y2.getNodeByIndex(ne2).setLayout(jt[ne2].p), d2[x2.getId(ne2)] = jt[ne2].p;
              for (var ne2 = 0, he2 = Rt.length; ne2 < he2; ne2++) {
                var _e = Rt[ne2], Me2 = y2.getEdgeByIndex(ne2), Pe2 = _e.n1.p, Be2 = _e.n2.p, Je2 = Me2.getLayout();
                Je2 = Je2 ? Je2.slice() : [], Je2[0] = Je2[0] || [], Je2[1] = Je2[1] || [], y0(Je2[0], Pe2), y0(Je2[1], Be2), +_e.curveness && (Je2[2] = [(Pe2[0] + Be2[0]) / 2 - (Pe2[1] - Be2[1]) * _e.curveness, (Pe2[1] + Be2[1]) / 2 - (Be2[0] - Pe2[0]) * _e.curveness]), Me2.setLayout(Je2);
              }
            }), a.forceLayout = Pt, a.preservedPoints = d2, Pt.step();
          } else
            a.forceLayout = null;
      });
    }
    function Qrn(l2, a, e2) {
      var d2 = la2(l2.getBoxLayoutParams(), { aspect: e2 });
      return Em(d2, { width: a.getWidth(), height: a.getHeight() });
    }
    function Jrn(l2, a) {
      var e2 = [];
      return l2.eachSeriesByType("graph", function(d2) {
        var y2 = d2.get("coordinateSystem");
        if (!y2 || y2 === "view") {
          var x2 = d2.getData(), C = x2.mapArray(function(vt) {
            var Ct = x2.getItemModel(vt);
            return [+Ct.get("x"), +Ct.get("y")];
          }), D2 = [], L = [];
          yq(C, D2, L), L[0] - D2[0] === 0 && (L[0] += 1, D2[0] -= 1), L[1] - D2[1] === 0 && (L[1] += 1, D2[1] -= 1);
          var F3 = (L[0] - D2[0]) / (L[1] - D2[1]), j = Qrn(d2, a, F3);
          isNaN(F3) && (D2 = [j.x, j.y], L = [j.x + j.width, j.y + j.height]);
          var U3 = L[0] - D2[0], Y3 = L[1] - D2[1], Q = j.width, nt = j.height, dt = d2.coordinateSystem = new Yrt();
          dt.zoomLimit = d2.get("scaleLimit"), dt.setBoundingRect(D2[0], D2[1], U3, Y3), dt.setViewRect(j.x, j.y, Q, nt), dt.setCenter(d2.get("center")), dt.setZoom(d2.get("zoom")), e2.push(dt);
        }
      }), e2;
    }
    var _ce = by.prototype, qOt = GN.prototype, xce = function() {
      function l2() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
      }
      return l2;
    }();
    (function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a;
    })(xce);
    function ZOt(l2) {
      return isNaN(+l2.cpx1) || isNaN(+l2.cpy1);
    }
    var tin = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "ec-line", d2;
      }
      return a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new xce();
      }, a.prototype.buildPath = function(e2, d2) {
        ZOt(d2) ? _ce.buildPath.call(this, e2, d2) : qOt.buildPath.call(this, e2, d2);
      }, a.prototype.pointAt = function(e2) {
        return ZOt(this.shape) ? _ce.pointAt.call(this, e2) : qOt.pointAt.call(this, e2);
      }, a.prototype.tangentAt = function(e2) {
        var d2 = this.shape, y2 = ZOt(d2) ? [d2.x2 - d2.x1, d2.y2 - d2.y1] : qOt.tangentAt.call(this, e2);
        return yV(y2, y2);
      }, a;
    }(wc2), ein = tin, $Ot = ["fromSymbol", "toSymbol"];
    function wce(l2) {
      return "_" + l2 + "Type";
    }
    function Sce(l2, a, e2) {
      var d2 = a.getItemVisual(e2, l2);
      if (!(!d2 || d2 === "none")) {
        var y2 = a.getItemVisual(e2, l2 + "Size"), x2 = a.getItemVisual(e2, l2 + "Rotate"), C = a.getItemVisual(e2, l2 + "Offset"), D2 = a.getItemVisual(e2, l2 + "KeepAspect"), L = brt(y2), F3 = tZ(C || 0, L), j = qy(d2, -L[0] / 2 + F3[0], -L[1] / 2 + F3[1], L[0], L[1], null, D2);
        return j.__specifiedRotation = x2 == null || isNaN(x2) ? void 0 : +x2 * Math.PI / 180 || 0, j.name = l2, j;
      }
    }
    function nin(l2) {
      var a = new ein({ name: "line", subPixelOptimize: true });
      return YOt(a.shape, l2), a;
    }
    function YOt(l2, a) {
      l2.x1 = a[0][0], l2.y1 = a[0][1], l2.x2 = a[1][0], l2.y2 = a[1][1], l2.percent = 1;
      var e2 = a[2];
      e2 ? (l2.cpx1 = e2[0], l2.cpy1 = e2[1]) : (l2.cpx1 = NaN, l2.cpy1 = NaN);
    }
    var rin = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this) || this;
        return x2._createLine(e2, d2, y2), x2;
      }
      return a.prototype._createLine = function(e2, d2, y2) {
        var x2 = e2.hostModel, C = e2.getItemLayout(d2), D2 = nin(C);
        D2.shape.percent = 0, Yg2(D2, { shape: { percent: 1 } }, x2, d2), this.add(D2), Ke2($Ot, function(L) {
          var F3 = Sce(L, e2, d2);
          this.add(F3), this[wce(L)] = e2.getItemVisual(d2, L);
        }, this), this._updateCommonStl(e2, d2, y2);
      }, a.prototype.updateData = function(e2, d2, y2) {
        var x2 = e2.hostModel, C = this.childOfName("line"), D2 = e2.getItemLayout(d2), L = { shape: {} };
        YOt(L.shape, D2), Yf2(C, L, x2, d2), Ke2($Ot, function(F3) {
          var j = e2.getItemVisual(d2, F3), U3 = wce(F3);
          if (this[U3] !== j) {
            this.remove(this.childOfName(F3));
            var Y3 = Sce(F3, e2, d2);
            this.add(Y3);
          }
          this[U3] = j;
        }, this), this._updateCommonStl(e2, d2, y2);
      }, a.prototype.getLinePath = function() {
        return this.childAt(0);
      }, a.prototype._updateCommonStl = function(e2, d2, y2) {
        var x2 = e2.hostModel, C = this.childOfName("line"), D2 = y2 && y2.emphasisLineStyle, L = y2 && y2.blurLineStyle, F3 = y2 && y2.selectLineStyle, j = y2 && y2.labelStatesModels, U3 = y2 && y2.emphasisDisabled, Y3 = y2 && y2.focus, Q = y2 && y2.blurScope;
        if (!y2 || e2.hasItemOption) {
          var nt = e2.getItemModel(d2), dt = nt.getModel("emphasis");
          D2 = dt.getModel("lineStyle").getLineStyle(), L = nt.getModel(["blur", "lineStyle"]).getLineStyle(), F3 = nt.getModel(["select", "lineStyle"]).getLineStyle(), U3 = dt.get("disabled"), Y3 = dt.get("focus"), Q = dt.get("blurScope"), j = Sb2(nt);
        }
        var vt = e2.getItemVisual(d2, "style"), Ct = vt.stroke;
        C.useStyle(vt), C.style.fill = null, C.style.strokeNoScale = true, C.ensureState("emphasis").style = D2, C.ensureState("blur").style = L, C.ensureState("select").style = F3, Ke2($Ot, function(ne2) {
          var he2 = this.childOfName(ne2);
          if (he2) {
            he2.setColor(Ct), he2.style.opacity = vt.opacity;
            for (var _e = 0; _e < O_.length; _e++) {
              var Me2 = O_[_e], Pe2 = C.getState(Me2);
              if (Pe2) {
                var Be2 = Pe2.style || {}, Je2 = he2.ensureState(Me2), Ze2 = Je2.style || (Je2.style = {});
                Be2.stroke != null && (Ze2[he2.__isEmptyBrush ? "stroke" : "fill"] = Be2.stroke), Be2.opacity != null && (Ze2.opacity = Be2.opacity);
              }
            }
            he2.markRedraw();
          }
        }, this);
        var Pt = x2.getRawValue(d2);
        ow(this, j, { labelDataIndex: d2, labelFetcher: { getFormattedLabel: function(ne2, he2) {
          return x2.getFormattedLabel(ne2, he2, e2.dataType);
        } }, inheritColor: Ct || "#000", defaultOpacity: vt.opacity, defaultText: (Pt == null ? e2.getName(d2) : isFinite(Pt) ? kv(Pt) : Pt) + "" });
        var jt = this.getTextContent();
        if (jt) {
          var Rt = j.normal;
          jt.__align = jt.style.align, jt.__verticalAlign = jt.style.verticalAlign, jt.__position = Rt.get("position") || "middle";
          var le2 = Rt.get("distance");
          Ba2(le2) || (le2 = [le2, le2]), jt.__labelDistance = le2;
        }
        this.setTextConfig({ position: null, local: true, inside: false }), n0(this, Y3, Q, U3);
      }, a.prototype.highlight = function() {
        Dm(this);
      }, a.prototype.downplay = function() {
        fc2(this);
      }, a.prototype.updateLayout = function(e2, d2) {
        this.setLinePoints(e2.getItemLayout(d2));
      }, a.prototype.setLinePoints = function(e2) {
        var d2 = this.childOfName("line");
        YOt(d2.shape, e2), d2.dirty();
      }, a.prototype.beforeUpdate = function() {
        var e2 = this, d2 = e2.childOfName("fromSymbol"), y2 = e2.childOfName("toSymbol"), x2 = e2.getTextContent();
        if (!d2 && !y2 && (!x2 || x2.ignore))
          return;
        for (var C = 1, D2 = this.parent; D2; )
          D2.scaleX && (C /= D2.scaleX), D2 = D2.parent;
        var L = e2.childOfName("line");
        if (!this.__dirty && !L.__dirty)
          return;
        var F3 = L.shape.percent, j = L.pointAt(0), U3 = L.pointAt(F3), Y3 = dE([], U3, j);
        yV(Y3, Y3);
        function Q(Pe2, Be2) {
          var Je2 = Pe2.__specifiedRotation;
          if (Je2 == null) {
            var Ze2 = L.tangentAt(Be2);
            Pe2.attr("rotation", (Be2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(Ze2[1], Ze2[0]));
          } else
            Pe2.attr("rotation", Je2);
        }
        if (d2 && (d2.setPosition(j), Q(d2, 0), d2.scaleX = d2.scaleY = C * F3, d2.markRedraw()), y2 && (y2.setPosition(U3), Q(y2, 1), y2.scaleX = y2.scaleY = C * F3, y2.markRedraw()), x2 && !x2.ignore) {
          x2.x = x2.y = 0, x2.originX = x2.originY = 0;
          var nt = void 0, dt = void 0, vt = x2.__labelDistance, Ct = vt[0] * C, Pt = vt[1] * C, jt = F3 / 2, Rt = L.tangentAt(jt), le2 = [Rt[1], -Rt[0]], ne2 = L.pointAt(jt);
          le2[1] > 0 && (le2[0] = -le2[0], le2[1] = -le2[1]);
          var he2 = Rt[0] < 0 ? -1 : 1;
          if (x2.__position !== "start" && x2.__position !== "end") {
            var _e = -Math.atan2(Rt[1], Rt[0]);
            U3[0] < j[0] && (_e = Math.PI + _e), x2.rotation = _e;
          }
          var Me2 = void 0;
          switch (x2.__position) {
            case "insideStartTop":
            case "insideMiddleTop":
            case "insideEndTop":
            case "middle":
              Me2 = -Pt, dt = "bottom";
              break;
            case "insideStartBottom":
            case "insideMiddleBottom":
            case "insideEndBottom":
              Me2 = Pt, dt = "top";
              break;
            default:
              Me2 = 0, dt = "middle";
          }
          switch (x2.__position) {
            case "end":
              x2.x = Y3[0] * Ct + U3[0], x2.y = Y3[1] * Pt + U3[1], nt = Y3[0] > 0.8 ? "left" : Y3[0] < -0.8 ? "right" : "center", dt = Y3[1] > 0.8 ? "top" : Y3[1] < -0.8 ? "bottom" : "middle";
              break;
            case "start":
              x2.x = -Y3[0] * Ct + j[0], x2.y = -Y3[1] * Pt + j[1], nt = Y3[0] > 0.8 ? "right" : Y3[0] < -0.8 ? "left" : "center", dt = Y3[1] > 0.8 ? "bottom" : Y3[1] < -0.8 ? "top" : "middle";
              break;
            case "insideStartTop":
            case "insideStart":
            case "insideStartBottom":
              x2.x = Ct * he2 + j[0], x2.y = j[1] + Me2, nt = Rt[0] < 0 ? "right" : "left", x2.originX = -Ct * he2, x2.originY = -Me2;
              break;
            case "insideMiddleTop":
            case "insideMiddle":
            case "insideMiddleBottom":
            case "middle":
              x2.x = ne2[0], x2.y = ne2[1] + Me2, nt = "center", x2.originY = -Me2;
              break;
            case "insideEndTop":
            case "insideEnd":
            case "insideEndBottom":
              x2.x = -Ct * he2 + U3[0], x2.y = U3[1] + Me2, nt = Rt[0] >= 0 ? "right" : "left", x2.originX = Ct * he2, x2.originY = -Me2;
              break;
          }
          x2.scaleX = x2.scaleY = C, x2.setStyle({ verticalAlign: x2.__verticalAlign || dt, align: x2.__align || nt });
        }
      }, a;
    }(ou), KOt = rin, iin = function() {
      function l2(a) {
        this.group = new ou(), this._LineCtor = a || KOt;
      }
      return l2.prototype.updateData = function(a) {
        var e2 = this;
        this._progressiveEls = null;
        var d2 = this, y2 = d2.group, x2 = d2._lineData;
        d2._lineData = a, x2 || y2.removeAll();
        var C = Mce(a);
        a.diff(x2).add(function(D2) {
          e2._doAdd(a, D2, C);
        }).update(function(D2, L) {
          e2._doUpdate(x2, a, L, D2, C);
        }).remove(function(D2) {
          y2.remove(x2.getItemGraphicEl(D2));
        }).execute();
      }, l2.prototype.updateLayout = function() {
        var a = this._lineData;
        !a || a.eachItemGraphicEl(function(e2, d2) {
          e2.updateLayout(a, d2);
        }, this);
      }, l2.prototype.incrementalPrepareUpdate = function(a) {
        this._seriesScope = Mce(a), this._lineData = null, this.group.removeAll();
      }, l2.prototype.incrementalUpdate = function(a, e2) {
        this._progressiveEls = [];
        function d2(D2) {
          !D2.isGroup && !ain(D2) && (D2.incremental = true, D2.ensureState("emphasis").hoverLayer = true);
        }
        for (var y2 = a.start; y2 < a.end; y2++) {
          var x2 = e2.getItemLayout(y2);
          if (XOt(x2)) {
            var C = new this._LineCtor(e2, y2, this._seriesScope);
            C.traverse(d2), this.group.add(C), e2.setItemGraphicEl(y2, C), this._progressiveEls.push(C);
          }
        }
      }, l2.prototype.remove = function() {
        this.group.removeAll();
      }, l2.prototype.eachRendered = function(a) {
        qN(this._progressiveEls || this.group, a);
      }, l2.prototype._doAdd = function(a, e2, d2) {
        var y2 = a.getItemLayout(e2);
        if (XOt(y2)) {
          var x2 = new this._LineCtor(a, e2, d2);
          a.setItemGraphicEl(e2, x2), this.group.add(x2);
        }
      }, l2.prototype._doUpdate = function(a, e2, d2, y2, x2) {
        var C = a.getItemGraphicEl(d2);
        if (!XOt(e2.getItemLayout(y2))) {
          this.group.remove(C);
          return;
        }
        C ? C.updateData(e2, y2, x2) : C = new this._LineCtor(e2, y2, x2), e2.setItemGraphicEl(y2, C), this.group.add(C);
      }, l2;
    }();
    function ain(l2) {
      return l2.animators && l2.animators.length > 0;
    }
    function Mce(l2) {
      var a = l2.hostModel, e2 = a.getModel("emphasis");
      return { lineStyle: a.getModel("lineStyle").getLineStyle(), emphasisLineStyle: e2.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: a.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: a.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: e2.get("disabled"), blurScope: e2.get("blurScope"), focus: e2.get("focus"), labelStatesModels: Sb2(a) };
    }
    function Cce(l2) {
      return isNaN(l2[0]) || isNaN(l2[1]);
    }
    function XOt(l2) {
      return l2 && !Cce(l2[0]) && !Cce(l2[1]);
    }
    var QOt = iin, JOt = [], t4t = [], e4t = [], hZ = sp, n4t = U2, Tce = Math.abs;
    function Ace(l2, a, e2) {
      for (var d2 = l2[0], y2 = l2[1], x2 = l2[2], C = 1 / 0, D2, L = e2 * e2, F3 = 0.1, j = 0.1; j <= 0.9; j += 0.1) {
        JOt[0] = hZ(d2[0], y2[0], x2[0], j), JOt[1] = hZ(d2[1], y2[1], x2[1], j);
        var U3 = Tce(n4t(JOt, a) - L);
        U3 < C && (C = U3, D2 = j);
      }
      for (var Y3 = 0; Y3 < 32; Y3++) {
        var Q = D2 + F3;
        t4t[0] = hZ(d2[0], y2[0], x2[0], D2), t4t[1] = hZ(d2[1], y2[1], x2[1], D2), e4t[0] = hZ(d2[0], y2[0], x2[0], Q), e4t[1] = hZ(d2[1], y2[1], x2[1], Q);
        var U3 = n4t(t4t, a) - L;
        if (Tce(U3) < 0.01)
          break;
        var nt = n4t(e4t, a) - L;
        F3 /= 2, U3 < 0 ? nt >= 0 ? D2 = D2 + F3 : D2 = D2 - F3 : nt >= 0 ? D2 = D2 - F3 : D2 = D2 + F3;
      }
      return D2;
    }
    function r4t(l2, a) {
      var e2 = [], d2 = _N, y2 = [[], [], []], x2 = [[], []], C = [];
      a /= 2, l2.eachEdge(function(D2, L) {
        var F3 = D2.getLayout(), j = D2.getVisual("fromSymbol"), U3 = D2.getVisual("toSymbol");
        F3.__original || (F3.__original = [H22(F3[0]), H22(F3[1])], F3[2] && F3.__original.push(H22(F3[2])));
        var Y3 = F3.__original;
        if (F3[2] != null) {
          if (y0(y2[0], Y3[0]), y0(y2[1], Y3[2]), y0(y2[2], Y3[1]), j && j !== "none") {
            var Q = oit(D2.node1), nt = Ace(y2, Y3[0], Q * a);
            d2(y2[0][0], y2[1][0], y2[2][0], nt, e2), y2[0][0] = e2[3], y2[1][0] = e2[4], d2(y2[0][1], y2[1][1], y2[2][1], nt, e2), y2[0][1] = e2[3], y2[1][1] = e2[4];
          }
          if (U3 && U3 !== "none") {
            var Q = oit(D2.node2), nt = Ace(y2, Y3[1], Q * a);
            d2(y2[0][0], y2[1][0], y2[2][0], nt, e2), y2[1][0] = e2[1], y2[2][0] = e2[2], d2(y2[0][1], y2[1][1], y2[2][1], nt, e2), y2[1][1] = e2[1], y2[2][1] = e2[2];
          }
          y0(F3[0], y2[0]), y0(F3[1], y2[2]), y0(F3[2], y2[1]);
        } else {
          if (y0(x2[0], Y3[0]), y0(x2[1], Y3[1]), dE(C, x2[1], x2[0]), yV(C, C), j && j !== "none") {
            var Q = oit(D2.node1);
            eA(x2[0], x2[0], C, Q * a);
          }
          if (U3 && U3 !== "none") {
            var Q = oit(D2.node2);
            eA(x2[1], x2[1], C, -Q * a);
          }
          y0(F3[0], x2[0]), y0(F3[1], x2[1]);
        }
      });
    }
    function Ice(l2) {
      return l2.type === "view";
    }
    var oin = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2, d2) {
        var y2 = new jrt(), x2 = new QOt(), C = this.group;
        this._controller = new Zrt(d2.getZr()), this._controllerHost = { target: C }, C.add(y2.group), C.add(x2.group), this._symbolDraw = y2, this._lineDraw = x2, this._firstRender = true;
      }, a.prototype.render = function(e2, d2, y2) {
        var x2 = this, C = e2.coordinateSystem;
        this._model = e2;
        var D2 = this._symbolDraw, L = this._lineDraw, F3 = this.group;
        if (Ice(C)) {
          var j = { x: C.x, y: C.y, scaleX: C.scaleX, scaleY: C.scaleY };
          this._firstRender ? F3.attr(j) : Yf2(F3, j, e2);
        }
        r4t(e2.getGraph(), ait(e2));
        var U3 = e2.getData();
        D2.updateData(U3);
        var Y3 = e2.getEdgeData();
        L.updateData(Y3), this._updateNodeAndLinkScale(), this._updateController(e2, d2, y2), clearTimeout(this._layoutTimeout);
        var Q = e2.forceLayout, nt = e2.get(["force", "layoutAnimation"]);
        Q && this._startForceLayoutIteration(Q, nt), U3.graph.eachNode(function(Pt) {
          var jt = Pt.dataIndex, Rt = Pt.getGraphicEl(), le2 = Pt.getModel();
          if (Rt) {
            Rt.off("drag").off("dragend");
            var ne2 = le2.get("draggable");
            ne2 && Rt.on("drag", function() {
              Q && (Q.warmUp(), !x2._layouting && x2._startForceLayoutIteration(Q, nt), Q.setFixed(jt), U3.setItemLayout(jt, [Rt.x, Rt.y]));
            }).on("dragend", function() {
              Q && Q.setUnfixed(jt);
            }), Rt.setDraggable(ne2 && !!Q);
            var he2 = le2.get(["emphasis", "focus"]);
            he2 === "adjacency" && (ns(Rt).focus = Pt.getAdjacentDataIndices());
          }
        }), U3.graph.eachEdge(function(Pt) {
          var jt = Pt.getGraphicEl(), Rt = Pt.getModel().get(["emphasis", "focus"]);
          !jt || Rt === "adjacency" && (ns(jt).focus = { edge: [Pt.dataIndex], node: [Pt.node1.dataIndex, Pt.node2.dataIndex] });
        });
        var dt = e2.get("layout") === "circular" && e2.get(["circular", "rotateLabel"]), vt = U3.getLayout("cx"), Ct = U3.getLayout("cy");
        U3.eachItemGraphicEl(function(Pt, jt) {
          var Rt = U3.getItemModel(jt), le2 = Rt.get(["label", "rotate"]) || 0, ne2 = Pt.getSymbolPath();
          if (dt) {
            var he2 = U3.getItemLayout(jt), _e = Math.atan2(he2[1] - Ct, he2[0] - vt);
            _e < 0 && (_e = Math.PI * 2 + _e);
            var Me2 = he2[0] < vt;
            Me2 && (_e = _e - Math.PI);
            var Pe2 = Me2 ? "left" : "right";
            ne2.setTextConfig({ rotation: -_e, position: Pe2, origin: "center" });
            var Be2 = ne2.ensureState("emphasis");
            la2(Be2.textConfig || (Be2.textConfig = {}), { position: Pe2 });
          } else
            ne2.setTextConfig({ rotation: le2 *= Math.PI / 180 });
        }), this._firstRender = false;
      }, a.prototype.dispose = function() {
        this._controller && this._controller.dispose(), this._controllerHost = null;
      }, a.prototype._startForceLayoutIteration = function(e2, d2) {
        var y2 = this;
        (function x2() {
          e2.step(function(C) {
            y2.updateLayout(y2._model), (y2._layouting = !C) && (d2 ? y2._layoutTimeout = setTimeout(x2, 16) : x2());
          });
        })();
      }, a.prototype._updateController = function(e2, d2, y2) {
        var x2 = this, C = this._controller, D2 = this._controllerHost, L = this.group;
        if (C.setPointerChecker(function(F3, j, U3) {
          var Y3 = L.getBoundingRect();
          return Y3.applyTransform(L.transform), Y3.contain(j, U3) && !omt(F3, y2, e2);
        }), !Ice(e2.coordinateSystem)) {
          C.disable();
          return;
        }
        C.enable(e2.get("roam")), D2.zoomLimit = e2.get("scaleLimit"), D2.zoom = e2.coordinateSystem.getZoom(), C.off("pan").off("zoom").on("pan", function(F3) {
          _Ot(D2, F3.dx, F3.dy), y2.dispatchAction({ seriesId: e2.id, type: "graphRoam", dx: F3.dx, dy: F3.dy });
        }).on("zoom", function(F3) {
          xOt(D2, F3.scale, F3.originX, F3.originY), y2.dispatchAction({ seriesId: e2.id, type: "graphRoam", zoom: F3.scale, originX: F3.originX, originY: F3.originY }), x2._updateNodeAndLinkScale(), r4t(e2.getGraph(), ait(e2)), x2._lineDraw.updateLayout(), y2.updateLabelLayout();
        });
      }, a.prototype._updateNodeAndLinkScale = function() {
        var e2 = this._model, d2 = e2.getData(), y2 = ait(e2);
        d2.eachItemGraphicEl(function(x2, C) {
          x2 && x2.setSymbolScale(y2);
        });
      }, a.prototype.updateLayout = function(e2) {
        r4t(e2.getGraph(), ait(e2)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
      }, a.prototype.remove = function(e2, d2) {
        this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
      }, a.type = "graph", a;
    }(pg2), sin = oin;
    function pZ(l2) {
      return "_EC_" + l2;
    }
    var lin = function() {
      function l2(a) {
        this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = a || false;
      }
      return l2.prototype.isDirected = function() {
        return this._directed;
      }, l2.prototype.addNode = function(a, e2) {
        a = a == null ? "" + e2 : "" + a;
        var d2 = this._nodesMap;
        if (!d2[pZ(a)]) {
          var y2 = new MB(a, e2);
          return y2.hostGraph = this, this.nodes.push(y2), d2[pZ(a)] = y2, y2;
        }
      }, l2.prototype.getNodeByIndex = function(a) {
        var e2 = this.data.getRawIndex(a);
        return this.nodes[e2];
      }, l2.prototype.getNodeById = function(a) {
        return this._nodesMap[pZ(a)];
      }, l2.prototype.addEdge = function(a, e2, d2) {
        var y2 = this._nodesMap, x2 = this._edgesMap;
        if (Ch2(a) && (a = this.nodes[a]), Ch2(e2) && (e2 = this.nodes[e2]), a instanceof MB || (a = y2[pZ(a)]), e2 instanceof MB || (e2 = y2[pZ(e2)]), !(!a || !e2)) {
          var C = a.id + "-" + e2.id, D2 = new Dce(a, e2, d2);
          return D2.hostGraph = this, this._directed && (a.outEdges.push(D2), e2.inEdges.push(D2)), a.edges.push(D2), a !== e2 && e2.edges.push(D2), this.edges.push(D2), x2[C] = D2, D2;
        }
      }, l2.prototype.getEdgeByIndex = function(a) {
        var e2 = this.edgeData.getRawIndex(a);
        return this.edges[e2];
      }, l2.prototype.getEdge = function(a, e2) {
        a instanceof MB && (a = a.id), e2 instanceof MB && (e2 = e2.id);
        var d2 = this._edgesMap;
        return this._directed ? d2[a + "-" + e2] : d2[a + "-" + e2] || d2[e2 + "-" + a];
      }, l2.prototype.eachNode = function(a, e2) {
        for (var d2 = this.nodes, y2 = d2.length, x2 = 0; x2 < y2; x2++)
          d2[x2].dataIndex >= 0 && a.call(e2, d2[x2], x2);
      }, l2.prototype.eachEdge = function(a, e2) {
        for (var d2 = this.edges, y2 = d2.length, x2 = 0; x2 < y2; x2++)
          d2[x2].dataIndex >= 0 && d2[x2].node1.dataIndex >= 0 && d2[x2].node2.dataIndex >= 0 && a.call(e2, d2[x2], x2);
      }, l2.prototype.breadthFirstTraverse = function(a, e2, d2, y2) {
        if (e2 instanceof MB || (e2 = this._nodesMap[pZ(e2)]), !!e2) {
          for (var x2 = d2 === "out" ? "outEdges" : d2 === "in" ? "inEdges" : "edges", C = 0; C < this.nodes.length; C++)
            this.nodes[C].__visited = false;
          if (!a.call(y2, e2, null))
            for (var D2 = [e2]; D2.length; )
              for (var L = D2.shift(), F3 = L[x2], C = 0; C < F3.length; C++) {
                var j = F3[C], U3 = j.node1 === L ? j.node2 : j.node1;
                if (!U3.__visited) {
                  if (a.call(y2, U3, L))
                    return;
                  D2.push(U3), U3.__visited = true;
                }
              }
        }
      }, l2.prototype.update = function() {
        for (var a = this.data, e2 = this.edgeData, d2 = this.nodes, y2 = this.edges, x2 = 0, C = d2.length; x2 < C; x2++)
          d2[x2].dataIndex = -1;
        for (var x2 = 0, C = a.count(); x2 < C; x2++)
          d2[a.getRawIndex(x2)].dataIndex = x2;
        e2.filterSelf(function(D2) {
          var L = y2[e2.getRawIndex(D2)];
          return L.node1.dataIndex >= 0 && L.node2.dataIndex >= 0;
        });
        for (var x2 = 0, C = y2.length; x2 < C; x2++)
          y2[x2].dataIndex = -1;
        for (var x2 = 0, C = e2.count(); x2 < C; x2++)
          y2[e2.getRawIndex(x2)].dataIndex = x2;
      }, l2.prototype.clone = function() {
        for (var a = new l2(this._directed), e2 = this.nodes, d2 = this.edges, y2 = 0; y2 < e2.length; y2++)
          a.addNode(e2[y2].id, e2[y2].dataIndex);
        for (var y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2];
          a.addEdge(x2.node1.id, x2.node2.id, x2.dataIndex);
        }
        return a;
      }, l2;
    }(), MB = function() {
      function l2(a, e2) {
        this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = a == null ? "" : a, this.dataIndex = e2 == null ? -1 : e2;
      }
      return l2.prototype.degree = function() {
        return this.edges.length;
      }, l2.prototype.inDegree = function() {
        return this.inEdges.length;
      }, l2.prototype.outDegree = function() {
        return this.outEdges.length;
      }, l2.prototype.getModel = function(a) {
        if (!(this.dataIndex < 0)) {
          var e2 = this.hostGraph, d2 = e2.data.getItemModel(this.dataIndex);
          return d2.getModel(a);
        }
      }, l2.prototype.getAdjacentDataIndices = function() {
        for (var a = { edge: [], node: [] }, e2 = 0; e2 < this.edges.length; e2++) {
          var d2 = this.edges[e2];
          d2.dataIndex < 0 || (a.edge.push(d2.dataIndex), a.node.push(d2.node1.dataIndex, d2.node2.dataIndex));
        }
        return a;
      }, l2;
    }(), Dce = function() {
      function l2(a, e2, d2) {
        this.dataIndex = -1, this.node1 = a, this.node2 = e2, this.dataIndex = d2 == null ? -1 : d2;
      }
      return l2.prototype.getModel = function(a) {
        if (!(this.dataIndex < 0)) {
          var e2 = this.hostGraph, d2 = e2.edgeData.getItemModel(this.dataIndex);
          return d2.getModel(a);
        }
      }, l2.prototype.getAdjacentDataIndices = function() {
        return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
      }, l2;
    }();
    function Ece(l2, a) {
      return { getValue: function(e2) {
        var d2 = this[l2][a];
        return d2.getStore().get(d2.getDimensionIndex(e2 || "value"), this.dataIndex);
      }, setVisual: function(e2, d2) {
        this.dataIndex >= 0 && this[l2][a].setItemVisual(this.dataIndex, e2, d2);
      }, getVisual: function(e2) {
        return this[l2][a].getItemVisual(this.dataIndex, e2);
      }, setLayout: function(e2, d2) {
        this.dataIndex >= 0 && this[l2][a].setItemLayout(this.dataIndex, e2, d2);
      }, getLayout: function() {
        return this[l2][a].getItemLayout(this.dataIndex);
      }, getGraphicEl: function() {
        return this[l2][a].getItemGraphicEl(this.dataIndex);
      }, getRawIndex: function() {
        return this[l2][a].getRawIndex(this.dataIndex);
      } };
    }
    v0(MB, Ece("hostGraph", "data")), v0(Dce, Ece("hostGraph", "edgeData"));
    var uin = lin;
    function kce(l2, a, e2, d2, y2) {
      for (var x2 = new uin(d2), C = 0; C < l2.length; C++)
        x2.addNode(jy(l2[C].id, l2[C].name, C), C);
      for (var D2 = [], L = [], F3 = 0, C = 0; C < a.length; C++) {
        var j = a[C], U3 = j.source, Y3 = j.target;
        x2.addEdge(U3, Y3, F3) && (L.push(j), D2.push(jy(Ud2(j.id, null), U3 + " > " + Y3)), F3++);
      }
      var Q = e2.get("coordinateSystem"), nt;
      if (Q === "cartesian2d" || Q === "polar")
        nt = PO(l2, e2);
      else {
        var dt = urt.get(Q), vt = dt ? dt.dimensions || [] : [];
        oc2(vt, "value") < 0 && vt.concat(["value"]);
        var Ct = Ert(l2, { coordDimensions: vt, encodeDefine: e2.getEncode() }).dimensions;
        nt = new jS(Ct, e2), nt.initData(l2);
      }
      var Pt = new jS(["value"], e2);
      return Pt.initData(L, D2), y2 && y2(nt, Pt), Uue({ mainData: nt, struct: x2, structAttr: "graph", datas: { node: nt, edge: Pt }, datasAttr: { node: "data", edge: "edgeData" } }), x2.update(), x2;
    }
    var cin = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.hasSymbolVisual = true, e2;
      }
      return a.prototype.init = function(e2) {
        l2.prototype.init.apply(this, arguments);
        var d2 = this;
        function y2() {
          return d2._categoriesData;
        }
        this.legendVisualProvider = new Hrt(y2, y2), this.fillDataTextStyle(e2.edges || e2.links), this._updateCategoriesData();
      }, a.prototype.mergeOption = function(e2) {
        l2.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(e2.edges || e2.links), this._updateCategoriesData();
      }, a.prototype.mergeDefaultAndTheme = function(e2) {
        l2.prototype.mergeDefaultAndTheme.apply(this, arguments), RS(e2, "edgeLabel", ["show"]);
      }, a.prototype.getInitialData = function(e2, d2) {
        var y2 = e2.edges || e2.links || [], x2 = e2.data || e2.nodes || [], C = this;
        if (x2 && y2) {
          Urn(this);
          var D2 = kce(x2, y2, this, true, L);
          return Ke2(D2.edges, function(F3) {
            qrn(F3.node1, F3.node2, this, F3.dataIndex);
          }, this), D2.data;
        }
        function L(F3, j) {
          F3.wrapMethod("getItemModel", function(nt) {
            var dt = C._categoriesModels, vt = nt.getShallow("category"), Ct = dt[vt];
            return Ct && (Ct.parentModel = nt.parentModel, nt.parentModel = Ct), nt;
          });
          var U3 = hg2.prototype.getModel;
          function Y3(nt, dt) {
            var vt = U3.call(this, nt, dt);
            return vt.resolveParentPath = Q, vt;
          }
          j.wrapMethod("getItemModel", function(nt) {
            return nt.resolveParentPath = Q, nt.getModel = Y3, nt;
          });
          function Q(nt) {
            if (nt && (nt[0] === "label" || nt[1] === "label")) {
              var dt = nt.slice();
              return nt[0] === "label" ? dt[0] = "edgeLabel" : nt[1] === "label" && (dt[1] = "edgeLabel"), dt;
            }
            return nt;
          }
        }
      }, a.prototype.getGraph = function() {
        return this.getData().graph;
      }, a.prototype.getEdgeData = function() {
        return this.getGraph().edgeData;
      }, a.prototype.getCategoriesData = function() {
        return this._categoriesData;
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        if (y2 === "edge") {
          var x2 = this.getData(), C = this.getDataParams(e2, y2), D2 = x2.graph.getEdgeByIndex(e2), L = x2.getName(D2.node1.dataIndex), F3 = x2.getName(D2.node2.dataIndex), j = [];
          return L != null && j.push(L), F3 != null && j.push(F3), b1("nameValue", { name: j.join(" > "), value: C.value, noValue: C.value == null });
        }
        var U3 = mae({ series: this, dataIndex: e2, multipleSeries: d2 });
        return U3;
      }, a.prototype._updateCategoriesData = function() {
        var e2 = $a2(this.option.categories || [], function(y2) {
          return y2.value != null ? y2 : la2({ value: 0 }, y2);
        }), d2 = new jS(["value"], this);
        d2.initData(e2), this._categoriesData = d2, this._categoriesModels = d2.mapArray(function(y2) {
          return d2.getItemModel(y2);
        });
      }, a.prototype.setZoom = function(e2) {
        this.option.zoom = e2;
      }, a.prototype.setCenter = function(e2) {
        this.option.center = e2;
      }, a.prototype.isAnimationEnabled = function() {
        return l2.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
      }, a.type = "series.graph", a.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], a.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, a;
    }(Pv), fin = cin, hin = { type: "graphRoam", event: "graphRoam", update: "none" };
    function pin(l2) {
      l2.registerChartView(sin), l2.registerSeriesModel(fin), l2.registerProcessor(zrn), l2.registerVisual(jrn), l2.registerVisual(Wrn), l2.registerLayout(Zrn), l2.registerLayout(l2.PRIORITY.VISUAL.POST_CHART_LAYOUT, Yrn), l2.registerLayout(Xrn), l2.registerCoordinateSystem("graphView", { dimensions: Yrt.dimensions, create: Jrn }), l2.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, $p), l2.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, $p), l2.registerAction(hin, function(a, e2) {
        e2.eachComponent({ mainType: "series", query: a }, function(d2) {
          var y2 = d2.coordinateSystem, x2 = TOt(y2, a);
          d2.setCenter && d2.setCenter(x2.center), d2.setZoom && d2.setZoom(x2.zoom);
        });
      });
    }
    var din = function() {
      function l2() {
        this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
      }
      return l2;
    }(), gin = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "pointer", d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new din();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = Math.cos, x2 = Math.sin, C = d2.r, D2 = d2.width, L = d2.angle, F3 = d2.x - y2(L) * D2 * (D2 >= C / 3 ? 1 : 2), j = d2.y - x2(L) * D2 * (D2 >= C / 3 ? 1 : 2);
        L = d2.angle - Math.PI / 2, e2.moveTo(F3, j), e2.lineTo(d2.x + y2(L) * D2, d2.y + x2(L) * D2), e2.lineTo(d2.x + y2(d2.angle) * C, d2.y + x2(d2.angle) * C), e2.lineTo(d2.x - y2(L) * D2, d2.y - x2(L) * D2), e2.lineTo(F3, j);
      }, a;
    }(wc2), vin = gin;
    function yin(l2, a) {
      var e2 = l2.get("center"), d2 = a.getWidth(), y2 = a.getHeight(), x2 = Math.min(d2, y2), C = Ko(e2[0], a.getWidth()), D2 = Ko(e2[1], a.getHeight()), L = Ko(l2.get("radius"), x2 / 2);
      return { cx: C, cy: D2, r: L };
    }
    function bmt(l2, a) {
      var e2 = l2 == null ? "" : l2 + "";
      return a && (ps(a) ? e2 = a.replace("{value}", e2) : wl(a) && (e2 = a(l2))), e2;
    }
    var i4t = Math.PI * 2, min3 = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        this.group.removeAll();
        var x2 = e2.get(["axisLine", "lineStyle", "color"]), C = yin(e2, y2);
        this._renderMain(e2, d2, y2, x2, C), this._data = e2.getData();
      }, a.prototype.dispose = function() {
      }, a.prototype._renderMain = function(e2, d2, y2, x2, C) {
        for (var D2 = this.group, L = e2.get("clockwise"), F3 = -e2.get("startAngle") / 180 * Math.PI, j = -e2.get("endAngle") / 180 * Math.PI, U3 = e2.getModel("axisLine"), Y3 = U3.get("roundCap"), Q = Y3 ? Jyt : nw, nt = U3.get("show"), dt = U3.getModel("lineStyle"), vt = dt.get("width"), Ct = !((j - F3) % i4t) && j !== F3 ? i4t : (j - F3) % i4t, Pt = F3, jt = 0; nt && jt < x2.length; jt++) {
          var Rt = Math.min(Math.max(x2[jt][0], 0), 1);
          j = F3 + Ct * Rt;
          var le2 = new Q({ shape: { startAngle: Pt, endAngle: j, cx: C.cx, cy: C.cy, clockwise: L, r0: C.r - vt, r: C.r }, silent: true });
          le2.setStyle({ fill: x2[jt][1] }), le2.setStyle(dt.getLineStyle(["color", "width"])), D2.add(le2), Pt = j;
        }
        var ne2 = function(_e) {
          if (_e <= 0)
            return x2[0][1];
          var Me2;
          for (Me2 = 0; Me2 < x2.length; Me2++)
            if (x2[Me2][0] >= _e && (Me2 === 0 ? 0 : x2[Me2 - 1][0]) < _e)
              return x2[Me2][1];
          return x2[Me2 - 1][1];
        };
        if (!L) {
          var he2 = F3;
          F3 = j, j = he2;
        }
        this._renderTicks(e2, d2, y2, ne2, C, F3, j, L, vt), this._renderTitleAndDetail(e2, d2, y2, ne2, C), this._renderAnchor(e2, C), this._renderPointer(e2, d2, y2, ne2, C, F3, j, L, vt);
      }, a.prototype._renderTicks = function(e2, d2, y2, x2, C, D2, L, F3, j) {
        for (var U3 = this.group, Y3 = C.cx, Q = C.cy, nt = C.r, dt = +e2.get("min"), vt = +e2.get("max"), Ct = e2.getModel("splitLine"), Pt = e2.getModel("axisTick"), jt = e2.getModel("axisLabel"), Rt = e2.get("splitNumber"), le2 = Pt.get("splitNumber"), ne2 = Ko(Ct.get("length"), nt), he2 = Ko(Pt.get("length"), nt), _e = D2, Me2 = (L - D2) / Rt, Pe2 = Me2 / le2, Be2 = Ct.getModel("lineStyle").getLineStyle(), Je2 = Pt.getModel("lineStyle").getLineStyle(), Ze2 = Ct.get("distance"), Cn, Bn, mn = 0; mn <= Rt; mn++) {
          if (Cn = Math.cos(_e), Bn = Math.sin(_e), Ct.get("show")) {
            var Kr = Ze2 ? Ze2 + j : j, Kn = new by({ shape: { x1: Cn * (nt - Kr) + Y3, y1: Bn * (nt - Kr) + Q, x2: Cn * (nt - ne2 - Kr) + Y3, y2: Bn * (nt - ne2 - Kr) + Q }, style: Be2, silent: true });
            Be2.stroke === "auto" && Kn.setStyle({ stroke: x2(mn / Rt) }), U3.add(Kn);
          }
          if (jt.get("show")) {
            var Kr = jt.get("distance") + Ze2, ar = bmt(kv(mn / Rt * (vt - dt) + dt), jt.get("formatter")), Cr = x2(mn / Rt);
            U3.add(new qc2({ style: _y(jt, { text: ar, x: Cn * (nt - ne2 - Kr) + Y3, y: Bn * (nt - ne2 - Kr) + Q, verticalAlign: Bn < -0.8 ? "top" : Bn > 0.8 ? "bottom" : "middle", align: Cn < -0.4 ? "left" : Cn > 0.4 ? "right" : "center" }, { inheritColor: Cr }), silent: true }));
          }
          if (Pt.get("show") && mn !== Rt) {
            var Kr = Pt.get("distance");
            Kr = Kr ? Kr + j : j;
            for (var ui2 = 0; ui2 <= le2; ui2++) {
              Cn = Math.cos(_e), Bn = Math.sin(_e);
              var vi2 = new by({ shape: { x1: Cn * (nt - Kr) + Y3, y1: Bn * (nt - Kr) + Q, x2: Cn * (nt - he2 - Kr) + Y3, y2: Bn * (nt - he2 - Kr) + Q }, silent: true, style: Je2 });
              Je2.stroke === "auto" && vi2.setStyle({ stroke: x2((mn + ui2 / le2) / Rt) }), U3.add(vi2), _e += Pe2;
            }
            _e -= Pe2;
          } else
            _e += Me2;
        }
      }, a.prototype._renderPointer = function(e2, d2, y2, x2, C, D2, L, F3, j) {
        var U3 = this.group, Y3 = this._data, Q = this._progressEls, nt = [], dt = e2.get(["pointer", "show"]), vt = e2.getModel("progress"), Ct = vt.get("show"), Pt = e2.getData(), jt = Pt.mapDimension("value"), Rt = +e2.get("min"), le2 = +e2.get("max"), ne2 = [Rt, le2], he2 = [D2, L];
        function _e(Pe2, Be2) {
          var Je2 = Pt.getItemModel(Pe2), Ze2 = Je2.getModel("pointer"), Cn = Ko(Ze2.get("width"), C.r), Bn = Ko(Ze2.get("length"), C.r), mn = e2.get(["pointer", "icon"]), Kr = Ze2.get("offsetCenter"), Kn = Ko(Kr[0], C.r), ar = Ko(Kr[1], C.r), Cr = Ze2.get("keepAspect"), ui2;
          return mn ? ui2 = qy(mn, Kn - Cn / 2, ar - Bn, Cn, Bn, null, Cr) : ui2 = new vin({ shape: { angle: -Math.PI / 2, width: Cn, r: Bn, x: Kn, y: ar } }), ui2.rotation = -(Be2 + Math.PI / 2), ui2.x = C.cx, ui2.y = C.cy, ui2;
        }
        function Me2(Pe2, Be2) {
          var Je2 = vt.get("roundCap"), Ze2 = Je2 ? Jyt : nw, Cn = vt.get("overlap"), Bn = Cn ? vt.get("width") : j / Pt.count(), mn = Cn ? C.r - Bn : C.r - (Pe2 + 1) * Bn, Kr = Cn ? C.r : C.r - Pe2 * Bn, Kn = new Ze2({ shape: { startAngle: D2, endAngle: Be2, cx: C.cx, cy: C.cy, clockwise: F3, r0: mn, r: Kr } });
          return Cn && (Kn.z2 = le2 - Pt.get(jt, Pe2) % le2), Kn;
        }
        (Ct || dt) && (Pt.diff(Y3).add(function(Pe2) {
          var Be2 = Pt.get(jt, Pe2);
          if (dt) {
            var Je2 = _e(Pe2, D2);
            Yg2(Je2, { rotation: -((isNaN(+Be2) ? he2[0] : yp(Be2, ne2, he2, true)) + Math.PI / 2) }, e2), U3.add(Je2), Pt.setItemGraphicEl(Pe2, Je2);
          }
          if (Ct) {
            var Ze2 = Me2(Pe2, D2), Cn = vt.get("clip");
            Yg2(Ze2, { shape: { endAngle: yp(Be2, ne2, he2, Cn) } }, e2), U3.add(Ze2), Ent(e2.seriesIndex, Pt.dataType, Pe2, Ze2), nt[Pe2] = Ze2;
          }
        }).update(function(Pe2, Be2) {
          var Je2 = Pt.get(jt, Pe2);
          if (dt) {
            var Ze2 = Y3.getItemGraphicEl(Be2), Cn = Ze2 ? Ze2.rotation : D2, Bn = _e(Pe2, Cn);
            Bn.rotation = Cn, Yf2(Bn, { rotation: -((isNaN(+Je2) ? he2[0] : yp(Je2, ne2, he2, true)) + Math.PI / 2) }, e2), U3.add(Bn), Pt.setItemGraphicEl(Pe2, Bn);
          }
          if (Ct) {
            var mn = Q[Be2], Kr = mn ? mn.shape.endAngle : D2, Kn = Me2(Pe2, Kr), ar = vt.get("clip");
            Yf2(Kn, { shape: { endAngle: yp(Je2, ne2, he2, ar) } }, e2), U3.add(Kn), Ent(e2.seriesIndex, Pt.dataType, Pe2, Kn), nt[Pe2] = Kn;
          }
        }).execute(), Pt.each(function(Pe2) {
          var Be2 = Pt.getItemModel(Pe2), Je2 = Be2.getModel("emphasis"), Ze2 = Je2.get("focus"), Cn = Je2.get("blurScope"), Bn = Je2.get("disabled");
          if (dt) {
            var mn = Pt.getItemGraphicEl(Pe2), Kr = Pt.getItemVisual(Pe2, "style"), Kn = Kr.fill;
            if (mn instanceof Im) {
              var ar = mn.style;
              mn.useStyle(la2({ image: ar.image, x: ar.x, y: ar.y, width: ar.width, height: ar.height }, Kr));
            } else
              mn.useStyle(Kr), mn.type !== "pointer" && mn.setColor(Kn);
            mn.setStyle(Be2.getModel(["pointer", "itemStyle"]).getItemStyle()), mn.style.fill === "auto" && mn.setStyle("fill", x2(yp(Pt.get(jt, Pe2), ne2, [0, 1], true))), mn.z2EmphasisLift = 0, Gy(mn, Be2), n0(mn, Ze2, Cn, Bn);
          }
          if (Ct) {
            var Cr = nt[Pe2];
            Cr.useStyle(Pt.getItemVisual(Pe2, "style")), Cr.setStyle(Be2.getModel(["progress", "itemStyle"]).getItemStyle()), Cr.z2EmphasisLift = 0, Gy(Cr, Be2), n0(Cr, Ze2, Cn, Bn);
          }
        }), this._progressEls = nt);
      }, a.prototype._renderAnchor = function(e2, d2) {
        var y2 = e2.getModel("anchor"), x2 = y2.get("show");
        if (x2) {
          var C = y2.get("size"), D2 = y2.get("icon"), L = y2.get("offsetCenter"), F3 = y2.get("keepAspect"), j = qy(D2, d2.cx - C / 2 + Ko(L[0], d2.r), d2.cy - C / 2 + Ko(L[1], d2.r), C, C, null, F3);
          j.z2 = y2.get("showAbove") ? 1 : 0, j.setStyle(y2.getModel("itemStyle").getItemStyle()), this.group.add(j);
        }
      }, a.prototype._renderTitleAndDetail = function(e2, d2, y2, x2, C) {
        var D2 = this, L = e2.getData(), F3 = L.mapDimension("value"), j = +e2.get("min"), U3 = +e2.get("max"), Y3 = new ou(), Q = [], nt = [], dt = e2.isAnimationEnabled(), vt = e2.get(["pointer", "showAbove"]);
        L.diff(this._data).add(function(Ct) {
          Q[Ct] = new qc2({ silent: true }), nt[Ct] = new qc2({ silent: true });
        }).update(function(Ct, Pt) {
          Q[Ct] = D2._titleEls[Pt], nt[Ct] = D2._detailEls[Pt];
        }).execute(), L.each(function(Ct) {
          var Pt = L.getItemModel(Ct), jt = L.get(F3, Ct), Rt = new ou(), le2 = x2(yp(jt, [j, U3], [0, 1], true)), ne2 = Pt.getModel("title");
          if (ne2.get("show")) {
            var he2 = ne2.get("offsetCenter"), _e = C.cx + Ko(he2[0], C.r), Me2 = C.cy + Ko(he2[1], C.r), Pe2 = Q[Ct];
            Pe2.attr({ z2: vt ? 0 : 2, style: _y(ne2, { x: _e, y: Me2, text: L.getName(Ct), align: "center", verticalAlign: "middle" }, { inheritColor: le2 }) }), Rt.add(Pe2);
          }
          var Be2 = Pt.getModel("detail");
          if (Be2.get("show")) {
            var Je2 = Be2.get("offsetCenter"), Ze2 = C.cx + Ko(Je2[0], C.r), Cn = C.cy + Ko(Je2[1], C.r), Bn = Ko(Be2.get("width"), C.r), mn = Ko(Be2.get("height"), C.r), Kr = e2.get(["progress", "show"]) ? L.getItemVisual(Ct, "style").fill : le2, Pe2 = nt[Ct], Kn = Be2.get("formatter");
            Pe2.attr({ z2: vt ? 0 : 2, style: _y(Be2, { x: Ze2, y: Cn, text: bmt(jt, Kn), width: isNaN(Bn) ? null : Bn, height: isNaN(mn) ? null : mn, align: "center", verticalAlign: "middle" }, { inheritColor: Kr }) }), qre(Pe2, { normal: Be2 }, jt, function(Cr) {
              return bmt(Cr, Kn);
            }), dt && Zre(Pe2, Ct, L, e2, { getFormattedLabel: function(Cr, ui2, vi2, ko, Ss, hl) {
              return bmt(hl ? hl.interpolatedValue : jt, Kn);
            } }), Rt.add(Pe2);
          }
          Y3.add(Rt);
        }), this.group.add(Y3), this._titleEls = Q, this._detailEls = nt;
      }, a.type = "gauge", a;
    }(pg2), bin = min3, _in = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.visualStyleAccessPath = "itemStyle", e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        return lZ(this, ["value"]);
      }, a.type = "series.gauge", a.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, a;
    }(Pv), xin = _in;
    function win(l2) {
      l2.registerChartView(bin), l2.registerSeriesModel(xin);
    }
    var Sin = ["itemStyle", "opacity"], Min = function(l2) {
      Jn(a, l2);
      function a(e2, d2) {
        var y2 = l2.call(this) || this, x2 = y2, C = new iw(), D2 = new qc2();
        return x2.setTextContent(D2), y2.setTextGuideLine(C), y2.updateData(e2, d2, true), y2;
      }
      return a.prototype.updateData = function(e2, d2, y2) {
        var x2 = this, C = e2.hostModel, D2 = e2.getItemModel(d2), L = e2.getItemLayout(d2), F3 = D2.getModel("emphasis"), j = D2.get(Sin);
        j = j == null ? 1 : j, y2 || pC(x2), x2.useStyle(e2.getItemVisual(d2, "style")), x2.style.lineJoin = "round", y2 ? (x2.setShape({ points: L.points }), x2.style.opacity = 0, Yg2(x2, { style: { opacity: j } }, C, d2)) : Yf2(x2, { style: { opacity: j }, shape: { points: L.points } }, C, d2), Gy(x2, D2), this._updateLabel(e2, d2), n0(this, F3.get("focus"), F3.get("blurScope"), F3.get("disabled"));
      }, a.prototype._updateLabel = function(e2, d2) {
        var y2 = this, x2 = this.getTextGuideLine(), C = y2.getTextContent(), D2 = e2.hostModel, L = e2.getItemModel(d2), F3 = e2.getItemLayout(d2), j = F3.label, U3 = e2.getItemVisual(d2, "style"), Y3 = U3.fill;
        ow(C, Sb2(L), { labelFetcher: e2.hostModel, labelDataIndex: d2, defaultOpacity: U3.opacity, defaultText: e2.getName(d2) }, { normal: { align: j.textAlign, verticalAlign: j.verticalAlign } }), y2.setTextConfig({ local: true, inside: !!j.inside, insideStroke: Y3, outsideFill: Y3 });
        var Q = j.linePoints;
        x2.setShape({ points: Q }), y2.textGuideLineConfig = { anchor: Q ? new Nu(Q[0][0], Q[0][1]) : null }, Yf2(C, { style: { x: j.x, y: j.y } }, D2, d2), C.attr({ rotation: j.rotation, originX: j.x, originY: j.y, z2: 10 }), jLt(y2, WLt(L), { stroke: Y3 });
      }, a;
    }(rw), Cin = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.ignoreLabelLineUpdate = true, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this._data, D2 = this.group;
        x2.diff(C).add(function(L) {
          var F3 = new Min(x2, L);
          x2.setItemGraphicEl(L, F3), D2.add(F3);
        }).update(function(L, F3) {
          var j = C.getItemGraphicEl(F3);
          j.updateData(x2, L), D2.add(j), x2.setItemGraphicEl(L, j);
        }).remove(function(L) {
          var F3 = C.getItemGraphicEl(L);
          JV(F3, e2, L);
        }).execute(), this._data = x2;
      }, a.prototype.remove = function() {
        this.group.removeAll(), this._data = null;
      }, a.prototype.dispose = function() {
      }, a.type = "funnel", a;
    }(pg2), Tin = Cin, Ain = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2) {
        l2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Hrt(As(this.getData, this), As(this.getRawData, this)), this._defaultLabelLine(e2);
      }, a.prototype.getInitialData = function(e2, d2) {
        return lZ(this, { coordDimensions: ["value"], encodeDefaulter: xu(R3t, this) });
      }, a.prototype._defaultLabelLine = function(e2) {
        RS(e2, "labelLine", ["show"]);
        var d2 = e2.labelLine, y2 = e2.emphasis.labelLine;
        d2.show = d2.show && e2.label.show, y2.show = y2.show && e2.emphasis.label.show;
      }, a.prototype.getDataParams = function(e2) {
        var d2 = this.getData(), y2 = l2.prototype.getDataParams.call(this, e2), x2 = d2.mapDimension("value"), C = d2.getSum(x2);
        return y2.percent = C ? +(d2.get(x2, e2) / C * 100).toFixed(2) : 0, y2.$vars.push("percent"), y2;
      }, a.type = "series.funnel", a.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, a;
    }(Pv), Iin = Ain;
    function Din(l2, a) {
      return Em(l2.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
    }
    function Ein(l2, a) {
      for (var e2 = l2.mapDimension("value"), d2 = l2.mapArray(e2, function(L) {
        return L;
      }), y2 = [], x2 = a === "ascending", C = 0, D2 = l2.count(); C < D2; C++)
        y2[C] = C;
      return wl(a) ? y2.sort(a) : a !== "none" && y2.sort(function(L, F3) {
        return x2 ? d2[L] - d2[F3] : d2[F3] - d2[L];
      }), y2;
    }
    function kin(l2) {
      var a = l2.hostModel, e2 = a.get("orient");
      l2.each(function(d2) {
        var y2 = l2.getItemModel(d2), x2 = y2.getModel("label"), C = x2.get("position"), D2 = y2.getModel("labelLine"), L = l2.getItemLayout(d2), F3 = L.points, j = C === "inner" || C === "inside" || C === "center" || C === "insideLeft" || C === "insideRight", U3, Y3, Q, nt;
        if (j)
          C === "insideLeft" ? (Y3 = (F3[0][0] + F3[3][0]) / 2 + 5, Q = (F3[0][1] + F3[3][1]) / 2, U3 = "left") : C === "insideRight" ? (Y3 = (F3[1][0] + F3[2][0]) / 2 - 5, Q = (F3[1][1] + F3[2][1]) / 2, U3 = "right") : (Y3 = (F3[0][0] + F3[1][0] + F3[2][0] + F3[3][0]) / 4, Q = (F3[0][1] + F3[1][1] + F3[2][1] + F3[3][1]) / 4, U3 = "center"), nt = [[Y3, Q], [Y3, Q]];
        else {
          var dt = void 0, vt = void 0, Ct = void 0, Pt = void 0, jt = D2.get("length");
          C === "left" ? (dt = (F3[3][0] + F3[0][0]) / 2, vt = (F3[3][1] + F3[0][1]) / 2, Ct = dt - jt, Y3 = Ct - 5, U3 = "right") : C === "right" ? (dt = (F3[1][0] + F3[2][0]) / 2, vt = (F3[1][1] + F3[2][1]) / 2, Ct = dt + jt, Y3 = Ct + 5, U3 = "left") : C === "top" ? (dt = (F3[3][0] + F3[0][0]) / 2, vt = (F3[3][1] + F3[0][1]) / 2, Pt = vt - jt, Q = Pt - 5, U3 = "center") : C === "bottom" ? (dt = (F3[1][0] + F3[2][0]) / 2, vt = (F3[1][1] + F3[2][1]) / 2, Pt = vt + jt, Q = Pt + 5, U3 = "center") : C === "rightTop" ? (dt = e2 === "horizontal" ? F3[3][0] : F3[1][0], vt = e2 === "horizontal" ? F3[3][1] : F3[1][1], e2 === "horizontal" ? (Pt = vt - jt, Q = Pt - 5, U3 = "center") : (Ct = dt + jt, Y3 = Ct + 5, U3 = "top")) : C === "rightBottom" ? (dt = F3[2][0], vt = F3[2][1], e2 === "horizontal" ? (Pt = vt + jt, Q = Pt + 5, U3 = "center") : (Ct = dt + jt, Y3 = Ct + 5, U3 = "bottom")) : C === "leftTop" ? (dt = F3[0][0], vt = e2 === "horizontal" ? F3[0][1] : F3[1][1], e2 === "horizontal" ? (Pt = vt - jt, Q = Pt - 5, U3 = "center") : (Ct = dt - jt, Y3 = Ct - 5, U3 = "right")) : C === "leftBottom" ? (dt = e2 === "horizontal" ? F3[1][0] : F3[3][0], vt = e2 === "horizontal" ? F3[1][1] : F3[2][1], e2 === "horizontal" ? (Pt = vt + jt, Q = Pt + 5, U3 = "center") : (Ct = dt - jt, Y3 = Ct - 5, U3 = "right")) : (dt = (F3[1][0] + F3[2][0]) / 2, vt = (F3[1][1] + F3[2][1]) / 2, e2 === "horizontal" ? (Pt = vt + jt, Q = Pt + 5, U3 = "center") : (Ct = dt + jt, Y3 = Ct + 5, U3 = "left")), e2 === "horizontal" ? (Ct = dt, Y3 = Ct) : (Pt = vt, Q = Pt), nt = [[dt, vt], [Ct, Pt]];
        }
        L.label = { linePoints: nt, x: Y3, y: Q, verticalAlign: "middle", textAlign: U3, inside: j };
      });
    }
    function Pin2(l2, a) {
      l2.eachSeriesByType("funnel", function(e2) {
        var d2 = e2.getData(), y2 = d2.mapDimension("value"), x2 = e2.get("sort"), C = Din(e2, a), D2 = e2.get("orient"), L = C.width, F3 = C.height, j = Ein(d2, x2), U3 = C.x, Y3 = C.y, Q = D2 === "horizontal" ? [Ko(e2.get("minSize"), F3), Ko(e2.get("maxSize"), F3)] : [Ko(e2.get("minSize"), L), Ko(e2.get("maxSize"), L)], nt = d2.getDataExtent(y2), dt = e2.get("min"), vt = e2.get("max");
        dt == null && (dt = Math.min(nt[0], 0)), vt == null && (vt = nt[1]);
        var Ct = e2.get("funnelAlign"), Pt = e2.get("gap"), jt = D2 === "horizontal" ? L : F3, Rt = (jt - Pt * (d2.count() - 1)) / d2.count(), le2 = function(Cn, Bn) {
          if (D2 === "horizontal") {
            var mn = d2.get(y2, Cn) || 0, Kr = yp(mn, [dt, vt], Q, true), Kn = void 0;
            switch (Ct) {
              case "top":
                Kn = Y3;
                break;
              case "center":
                Kn = Y3 + (F3 - Kr) / 2;
                break;
              case "bottom":
                Kn = Y3 + (F3 - Kr);
                break;
            }
            return [[Bn, Kn], [Bn, Kn + Kr]];
          }
          var ar = d2.get(y2, Cn) || 0, Cr = yp(ar, [dt, vt], Q, true), ui2;
          switch (Ct) {
            case "left":
              ui2 = U3;
              break;
            case "center":
              ui2 = U3 + (L - Cr) / 2;
              break;
            case "right":
              ui2 = U3 + L - Cr;
              break;
          }
          return [[ui2, Bn], [ui2 + Cr, Bn]];
        };
        x2 === "ascending" && (Rt = -Rt, Pt = -Pt, D2 === "horizontal" ? U3 += L : Y3 += F3, j = j.reverse());
        for (var ne2 = 0; ne2 < j.length; ne2++) {
          var he2 = j[ne2], _e = j[ne2 + 1], Me2 = d2.getItemModel(he2);
          if (D2 === "horizontal") {
            var Pe2 = Me2.get(["itemStyle", "width"]);
            Pe2 == null ? Pe2 = Rt : (Pe2 = Ko(Pe2, L), x2 === "ascending" && (Pe2 = -Pe2));
            var Be2 = le2(he2, U3), Je2 = le2(_e, U3 + Pe2);
            U3 += Pe2 + Pt, d2.setItemLayout(he2, { points: Be2.concat(Je2.slice().reverse()) });
          } else {
            var Ze2 = Me2.get(["itemStyle", "height"]);
            Ze2 == null ? Ze2 = Rt : (Ze2 = Ko(Ze2, F3), x2 === "ascending" && (Ze2 = -Ze2));
            var Be2 = le2(he2, Y3), Je2 = le2(_e, Y3 + Ze2);
            Y3 += Ze2 + Pt, d2.setItemLayout(he2, { points: Be2.concat(Je2.slice().reverse()) });
          }
        }
        kin(d2);
      });
    }
    function Lin(l2) {
      l2.registerChartView(Tin), l2.registerSeriesModel(Iin), l2.registerLayout(Pin2), l2.registerProcessor(Grt("funnel"));
    }
    var Oin = 0.3, Rin = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._dataGroup = new ou(), e2._initialized = false, e2;
      }
      return a.prototype.init = function() {
        this.group.add(this._dataGroup);
      }, a.prototype.render = function(e2, d2, y2, x2) {
        this._progressiveEls = null;
        var C = this._dataGroup, D2 = e2.getData(), L = this._data, F3 = e2.coordinateSystem, j = F3.dimensions, U3 = Oce(e2);
        D2.diff(L).add(Y3).update(Q).remove(nt).execute();
        function Y3(vt) {
          var Ct = Lce(D2, C, vt, j, F3);
          a4t(Ct, D2, vt, U3);
        }
        function Q(vt, Ct) {
          var Pt = L.getItemGraphicEl(Ct), jt = Pce(D2, vt, j, F3);
          D2.setItemGraphicEl(vt, Pt), Yf2(Pt, { shape: { points: jt } }, e2, vt), pC(Pt), a4t(Pt, D2, vt, U3);
        }
        function nt(vt) {
          var Ct = L.getItemGraphicEl(vt);
          C.remove(Ct);
        }
        if (!this._initialized) {
          this._initialized = true;
          var dt = Nin(F3, e2, function() {
            setTimeout(function() {
              C.removeClipPath();
            });
          });
          C.setClipPath(dt);
        }
        this._data = D2;
      }, a.prototype.incrementalPrepareRender = function(e2, d2, y2) {
        this._initialized = true, this._data = null, this._dataGroup.removeAll();
      }, a.prototype.incrementalRender = function(e2, d2, y2) {
        for (var x2 = d2.getData(), C = d2.coordinateSystem, D2 = C.dimensions, L = Oce(d2), F3 = this._progressiveEls = [], j = e2.start; j < e2.end; j++) {
          var U3 = Lce(x2, this._dataGroup, j, D2, C);
          U3.incremental = true, a4t(U3, x2, j, L), F3.push(U3);
        }
      }, a.prototype.remove = function() {
        this._dataGroup && this._dataGroup.removeAll(), this._data = null;
      }, a.type = "parallel", a;
    }(pg2);
    function Nin(l2, a, e2) {
      var d2 = l2.model, y2 = l2.getRect(), x2 = new Nf2({ shape: { x: y2.x, y: y2.y, width: y2.width, height: y2.height } }), C = d2.get("layout") === "horizontal" ? "width" : "height";
      return x2.setShape(C, 0), Yg2(x2, { shape: { width: y2.width, height: y2.height } }, a, e2), x2;
    }
    function Pce(l2, a, e2, d2) {
      for (var y2 = [], x2 = 0; x2 < e2.length; x2++) {
        var C = e2[x2], D2 = l2.get(l2.mapDimension(C), a);
        Fin(D2, d2.getAxis(C).type) || y2.push(d2.dataToPoint(D2, C));
      }
      return y2;
    }
    function Lce(l2, a, e2, d2, y2) {
      var x2 = Pce(l2, e2, d2, y2), C = new iw({ shape: { points: x2 }, z2: 10 });
      return a.add(C), l2.setItemGraphicEl(e2, C), C;
    }
    function Oce(l2) {
      var a = l2.get("smooth", true);
      return a === true && (a = Oin), a = ME(a), pV(a) && (a = 0), { smooth: a };
    }
    function a4t(l2, a, e2, d2) {
      l2.useStyle(a.getItemVisual(e2, "style")), l2.style.fill = null, l2.setShape("smooth", d2.smooth);
      var y2 = a.getItemModel(e2), x2 = y2.getModel("emphasis");
      Gy(l2, y2, "lineStyle"), n0(l2, x2.get("focus"), x2.get("blurScope"), x2.get("disabled"));
    }
    function Fin(l2, a) {
      return a === "category" ? l2 == null : l2 == null || isNaN(l2);
    }
    var Vin = Rin, Bin = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.visualStyleAccessPath = "lineStyle", e2.visualDrawType = "stroke", e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        return PO(null, this, { useEncodeDefaulter: As(zin, null, this) });
      }, a.prototype.getRawIndicesByActiveState = function(e2) {
        var d2 = this.coordinateSystem, y2 = this.getData(), x2 = [];
        return d2.eachActiveState(y2, function(C, D2) {
          e2 === C && x2.push(y2.getRawIndex(D2));
        }), x2;
      }, a.type = "series.parallel", a.dependencies = ["parallel"], a.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, a;
    }(Pv);
    function zin(l2) {
      var a = l2.ecModel.getComponent("parallel", l2.get("parallelIndex"));
      if (a) {
        var e2 = {};
        return Ke2(a.dimensions, function(d2) {
          var y2 = jin(d2);
          e2[d2] = y2;
        }), e2;
      }
    }
    function jin(l2) {
      return +l2.replace("dim", "");
    }
    var Win = Bin, Gin = ["lineStyle", "opacity"], Hin = { seriesType: "parallel", reset: function(l2, a) {
      var e2 = l2.coordinateSystem, d2 = { normal: l2.get(["lineStyle", "opacity"]), active: l2.get("activeOpacity"), inactive: l2.get("inactiveOpacity") };
      return { progress: function(y2, x2) {
        e2.eachActiveState(x2, function(C, D2) {
          var L = d2[C];
          if (C === "normal" && x2.hasItemOption) {
            var F3 = x2.getItemModel(D2).get(Gin, true);
            F3 != null && (L = F3);
          }
          var j = x2.ensureUniqueItemVisual(D2, "style");
          j.opacity = L;
        }, y2.start, y2.end);
      } };
    } }, Uin = Hin;
    function qin(l2) {
      Zin(l2), $in(l2);
    }
    function Zin(l2) {
      if (!l2.parallel) {
        var a = false;
        Ke2(l2.series, function(e2) {
          e2 && e2.type === "parallel" && (a = true);
        }), a && (l2.parallel = [{}]);
      }
    }
    function $in(l2) {
      var a = Mp(l2.parallelAxis);
      Ke2(a, function(e2) {
        if (vs(e2)) {
          var d2 = e2.parallelIndex || 0, y2 = Mp(l2.parallel)[d2];
          y2 && y2.parallelAxisDefault && Mu(e2, y2.parallelAxisDefault, false);
        }
      });
    }
    var Yin = 5, Kin = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        this._model = e2, this._api = y2, this._handlers || (this._handlers = {}, Ke2(Xin, function(x2, C) {
          y2.getZr().on(C, this._handlers[C] = As(x2, this));
        }, this)), Xq(this, "_throttledDispatchExpand", e2.get("axisExpandRate"), "fixRate");
      }, a.prototype.dispose = function(e2, d2) {
        grt(this, "_throttledDispatchExpand"), Ke2(this._handlers, function(y2, x2) {
          d2.getZr().off(x2, y2);
        }), this._handlers = null;
      }, a.prototype._throttledDispatchExpand = function(e2) {
        this._dispatchExpand(e2);
      }, a.prototype._dispatchExpand = function(e2) {
        e2 && this._api.dispatchAction(la2({ type: "parallelAxisExpand" }, e2));
      }, a.type = "parallel", a;
    }(_0), Xin = { mousedown: function(l2) {
      o4t(this, "click") && (this._mouseDownPoint = [l2.offsetX, l2.offsetY]);
    }, mouseup: function(l2) {
      var a = this._mouseDownPoint;
      if (o4t(this, "click") && a) {
        var e2 = [l2.offsetX, l2.offsetY], d2 = Math.pow(a[0] - e2[0], 2) + Math.pow(a[1] - e2[1], 2);
        if (d2 > Yin)
          return;
        var y2 = this._model.coordinateSystem.getSlidedAxisExpandWindow([l2.offsetX, l2.offsetY]);
        y2.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: y2.axisExpandWindow });
      }
      this._mouseDownPoint = null;
    }, mousemove: function(l2) {
      if (!(this._mouseDownPoint || !o4t(this, "mousemove"))) {
        var a = this._model, e2 = a.coordinateSystem.getSlidedAxisExpandWindow([l2.offsetX, l2.offsetY]), d2 = e2.behavior;
        d2 === "jump" && this._throttledDispatchExpand.debounceNextCall(a.get("axisExpandDebounce")), this._throttledDispatchExpand(d2 === "none" ? null : { axisExpandWindow: e2.axisExpandWindow, animation: d2 === "jump" ? null : { duration: 0 } });
      }
    } };
    function o4t(l2, a) {
      var e2 = l2._model;
      return e2.get("axisExpandable") && e2.get("axisExpandTriggerOn") === a;
    }
    var Qin = Kin, Jin = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function() {
        l2.prototype.init.apply(this, arguments), this.mergeOption({});
      }, a.prototype.mergeOption = function(e2) {
        var d2 = this.option;
        e2 && Mu(d2, e2, true), this._initDimensions();
      }, a.prototype.contains = function(e2, d2) {
        var y2 = e2.get("parallelIndex");
        return y2 != null && d2.getComponent("parallel", y2) === this;
      }, a.prototype.setAxisExpand = function(e2) {
        Ke2(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(d2) {
          e2.hasOwnProperty(d2) && (this.option[d2] = e2[d2]);
        }, this);
      }, a.prototype._initDimensions = function() {
        var e2 = this.dimensions = [], d2 = this.parallelAxisIndex = [], y2 = Lp(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(x2) {
          return (x2.get("parallelIndex") || 0) === this.componentIndex;
        }, this);
        Ke2(y2, function(x2) {
          e2.push("dim" + x2.get("dim")), d2.push(x2.componentIndex);
        });
      }, a.type = "parallel", a.dependencies = ["parallelAxis"], a.layoutMode = "box", a.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, a;
    }(Ah2), tan = Jin, ean = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2, C) {
        var D2 = l2.call(this, e2, d2, y2) || this;
        return D2.type = x2 || "value", D2.axisIndex = C, D2;
      }
      return a.prototype.isHorizontal = function() {
        return this.coordinateSystem.getModel().get("layout") !== "horizontal";
      }, a;
    }(kE), nan = ean;
    function CB(l2, a, e2, d2, y2, x2) {
      l2 = l2 || 0;
      var C = e2[1] - e2[0];
      if (y2 != null && (y2 = dZ(y2, [0, C])), x2 != null && (x2 = Math.max(x2, y2 != null ? y2 : 0)), d2 === "all") {
        var D2 = Math.abs(a[1] - a[0]);
        D2 = dZ(D2, [0, C]), y2 = x2 = dZ(D2, [y2, x2]), d2 = 0;
      }
      a[0] = dZ(a[0], e2), a[1] = dZ(a[1], e2);
      var L = s4t(a, d2);
      a[d2] += l2;
      var F3 = y2 || 0, j = e2.slice();
      L.sign < 0 ? j[0] += F3 : j[1] -= F3, a[d2] = dZ(a[d2], j);
      var U3;
      return U3 = s4t(a, d2), y2 != null && (U3.sign !== L.sign || U3.span < y2) && (a[1 - d2] = a[d2] + L.sign * y2), U3 = s4t(a, d2), x2 != null && U3.span > x2 && (a[1 - d2] = a[d2] + U3.sign * x2), a;
    }
    function s4t(l2, a) {
      var e2 = l2[a] - l2[1 - a];
      return { span: Math.abs(e2), sign: e2 > 0 ? -1 : e2 < 0 ? 1 : a ? -1 : 1 };
    }
    function dZ(l2, a) {
      return Math.min(a[1] != null ? a[1] : 1 / 0, Math.max(a[0] != null ? a[0] : -1 / 0, l2));
    }
    var l4t = Ke2, Rce = Math.min, Nce = Math.max, Fce = Math.floor, ran = Math.ceil, Vce = kv, ian = Math.PI, aan = function() {
      function l2(a, e2, d2) {
        this.type = "parallel", this._axesMap = fl(), this._axesLayout = {}, this.dimensions = a.dimensions, this._model = a, this._init(a, e2, d2);
      }
      return l2.prototype._init = function(a, e2, d2) {
        var y2 = a.dimensions, x2 = a.parallelAxisIndex;
        l4t(y2, function(C, D2) {
          var L = x2[D2], F3 = e2.getComponent("parallelAxis", L), j = this._axesMap.set(C, new nan(C, Wyt(F3), [0, 0], F3.get("type"), L)), U3 = j.type === "category";
          j.onBand = U3 && F3.get("boundaryGap"), j.inverse = F3.get("inverse"), F3.axis = j, j.model = F3, j.coordinateSystem = F3.coordinateSystem = this;
        }, this);
      }, l2.prototype.update = function(a, e2) {
        this._updateAxesFromSeries(this._model, a);
      }, l2.prototype.containPoint = function(a) {
        var e2 = this._makeLayoutInfo(), d2 = e2.axisBase, y2 = e2.layoutBase, x2 = e2.pixelDimIndex, C = a[1 - x2], D2 = a[x2];
        return C >= d2 && C <= d2 + e2.axisLength && D2 >= y2 && D2 <= y2 + e2.layoutLength;
      }, l2.prototype.getModel = function() {
        return this._model;
      }, l2.prototype._updateAxesFromSeries = function(a, e2) {
        e2.eachSeries(function(d2) {
          if (a.contains(d2, e2)) {
            var y2 = d2.getData();
            l4t(this.dimensions, function(x2) {
              var C = this._axesMap.get(x2);
              C.scale.unionExtentFromData(y2, y2.mapDimension(x2)), iZ(C.scale, C.model);
            }, this);
          }
        }, this);
      }, l2.prototype.resize = function(a, e2) {
        this._rect = Em(a.getBoxLayoutParams(), { width: e2.getWidth(), height: e2.getHeight() }), this._layoutAxes();
      }, l2.prototype.getRect = function() {
        return this._rect;
      }, l2.prototype._makeLayoutInfo = function() {
        var a = this._model, e2 = this._rect, d2 = ["x", "y"], y2 = ["width", "height"], x2 = a.get("layout"), C = x2 === "horizontal" ? 0 : 1, D2 = e2[y2[C]], L = [0, D2], F3 = this.dimensions.length, j = _mt(a.get("axisExpandWidth"), L), U3 = _mt(a.get("axisExpandCount") || 0, [0, F3]), Y3 = a.get("axisExpandable") && F3 > 3 && F3 > U3 && U3 > 1 && j > 0 && D2 > 0, Q = a.get("axisExpandWindow"), nt;
        if (Q)
          nt = _mt(Q[1] - Q[0], L), Q[1] = Q[0] + nt;
        else {
          nt = _mt(j * (U3 - 1), L);
          var dt = a.get("axisExpandCenter") || Fce(F3 / 2);
          Q = [j * dt - nt / 2], Q[1] = Q[0] + nt;
        }
        var vt = (D2 - nt) / (F3 - U3);
        vt < 3 && (vt = 0);
        var Ct = [Fce(Vce(Q[0] / j, 1)) + 1, ran(Vce(Q[1] / j, 1)) - 1], Pt = vt / j * Q[0];
        return { layout: x2, pixelDimIndex: C, layoutBase: e2[d2[C]], layoutLength: D2, axisBase: e2[d2[1 - C]], axisLength: e2[y2[1 - C]], axisExpandable: Y3, axisExpandWidth: j, axisCollapseWidth: vt, axisExpandWindow: Q, axisCount: F3, winInnerIndices: Ct, axisExpandWindow0Pos: Pt };
      }, l2.prototype._layoutAxes = function() {
        var a = this._rect, e2 = this._axesMap, d2 = this.dimensions, y2 = this._makeLayoutInfo(), x2 = y2.layout;
        e2.each(function(C) {
          var D2 = [0, y2.axisLength], L = C.inverse ? 1 : 0;
          C.setExtent(D2[L], D2[1 - L]);
        }), l4t(d2, function(C, D2) {
          var L = (y2.axisExpandable ? san : oan)(D2, y2), F3 = { horizontal: { x: L.position, y: y2.axisLength }, vertical: { x: 0, y: L.position } }, j = { horizontal: ian / 2, vertical: 0 }, U3 = [F3[x2].x + a.x, F3[x2].y + a.y], Y3 = j[x2], Q = Xx();
          oO(Q, Q, Y3), LS(Q, Q, U3), this._axesLayout[C] = { position: U3, rotation: Y3, transform: Q, axisNameAvailableWidth: L.axisNameAvailableWidth, axisLabelShow: L.axisLabelShow, nameTruncateMaxWidth: L.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
        }, this);
      }, l2.prototype.getAxis = function(a) {
        return this._axesMap.get(a);
      }, l2.prototype.dataToPoint = function(a, e2) {
        return this.axisCoordToPoint(this._axesMap.get(e2).dataToCoord(a), e2);
      }, l2.prototype.eachActiveState = function(a, e2, d2, y2) {
        d2 == null && (d2 = 0), y2 == null && (y2 = a.count());
        var x2 = this._axesMap, C = this.dimensions, D2 = [], L = [];
        Ke2(C, function(vt) {
          D2.push(a.mapDimension(vt)), L.push(x2.get(vt).model);
        });
        for (var F3 = this.hasAxisBrushed(), j = d2; j < y2; j++) {
          var U3 = void 0;
          if (!F3)
            U3 = "normal";
          else {
            U3 = "active";
            for (var Y3 = a.getValues(D2, j), Q = 0, nt = C.length; Q < nt; Q++) {
              var dt = L[Q].getActiveState(Y3[Q]);
              if (dt === "inactive") {
                U3 = "inactive";
                break;
              }
            }
          }
          e2(U3, j);
        }
      }, l2.prototype.hasAxisBrushed = function() {
        for (var a = this.dimensions, e2 = this._axesMap, d2 = false, y2 = 0, x2 = a.length; y2 < x2; y2++)
          e2.get(a[y2]).model.getActiveState() !== "normal" && (d2 = true);
        return d2;
      }, l2.prototype.axisCoordToPoint = function(a, e2) {
        var d2 = this._axesLayout[e2];
        return hc2([a, 0], d2.transform);
      }, l2.prototype.getAxisLayout = function(a) {
        return zl(this._axesLayout[a]);
      }, l2.prototype.getSlidedAxisExpandWindow = function(a) {
        var e2 = this._makeLayoutInfo(), d2 = e2.pixelDimIndex, y2 = e2.axisExpandWindow.slice(), x2 = y2[1] - y2[0], C = [0, e2.axisExpandWidth * (e2.axisCount - 1)];
        if (!this.containPoint(a))
          return { behavior: "none", axisExpandWindow: y2 };
        var D2 = a[d2] - e2.layoutBase - e2.axisExpandWindow0Pos, L, F3 = "slide", j = e2.axisCollapseWidth, U3 = this._model.get("axisExpandSlideTriggerArea"), Y3 = U3[0] != null;
        if (j)
          Y3 && j && D2 < x2 * U3[0] ? (F3 = "jump", L = D2 - x2 * U3[2]) : Y3 && j && D2 > x2 * (1 - U3[0]) ? (F3 = "jump", L = D2 - x2 * (1 - U3[2])) : (L = D2 - x2 * U3[1]) >= 0 && (L = D2 - x2 * (1 - U3[1])) <= 0 && (L = 0), L *= e2.axisExpandWidth / j, L ? CB(L, y2, C, "all") : F3 = "none";
        else {
          var Q = y2[1] - y2[0], nt = C[1] * D2 / Q;
          y2 = [Nce(0, nt - Q / 2)], y2[1] = Rce(C[1], y2[0] + Q), y2[0] = y2[1] - Q;
        }
        return { axisExpandWindow: y2, behavior: F3 };
      }, l2;
    }();
    function _mt(l2, a) {
      return Rce(Nce(l2, a[0]), a[1]);
    }
    function oan(l2, a) {
      var e2 = a.layoutLength / (a.axisCount - 1);
      return { position: e2 * l2, axisNameAvailableWidth: e2, axisLabelShow: true };
    }
    function san(l2, a) {
      var e2 = a.layoutLength, d2 = a.axisExpandWidth, y2 = a.axisCount, x2 = a.axisCollapseWidth, C = a.winInnerIndices, D2, L = x2, F3 = false, j;
      return l2 < C[0] ? (D2 = l2 * x2, j = x2) : l2 <= C[1] ? (D2 = a.axisExpandWindow0Pos + l2 * d2 - a.axisExpandWindow[0], L = d2, F3 = true) : (D2 = e2 - (y2 - 1 - l2) * x2, j = x2), { position: D2, axisNameAvailableWidth: L, axisLabelShow: F3, nameTruncateMaxWidth: j };
    }
    var lan = aan;
    function uan(l2, a) {
      var e2 = [];
      return l2.eachComponent("parallel", function(d2, y2) {
        var x2 = new lan(d2, l2, a);
        x2.name = "parallel_" + y2, x2.resize(d2, a), d2.coordinateSystem = x2, x2.model = d2, e2.push(x2);
      }), l2.eachSeries(function(d2) {
        if (d2.get("coordinateSystem") === "parallel") {
          var y2 = d2.getReferringComponents("parallel", q0).models[0];
          d2.coordinateSystem = y2.coordinateSystem;
        }
      }), e2;
    }
    var can = { create: uan }, fan = can, Bce = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.activeIntervals = [], e2;
      }
      return a.prototype.getAreaSelectStyle = function() {
        return dO([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
      }, a.prototype.setActiveIntervals = function(e2) {
        var d2 = this.activeIntervals = zl(e2);
        if (d2)
          for (var y2 = d2.length - 1; y2 >= 0; y2--)
            k_(d2[y2]);
      }, a.prototype.getActiveState = function(e2) {
        var d2 = this.activeIntervals;
        if (!d2.length)
          return "normal";
        if (e2 == null || isNaN(+e2))
          return "inactive";
        if (d2.length === 1) {
          var y2 = d2[0];
          if (y2[0] <= e2 && e2 <= y2[1])
            return "active";
        } else
          for (var x2 = 0, C = d2.length; x2 < C; x2++)
            if (d2[x2][0] <= e2 && e2 <= d2[x2][1])
              return "active";
        return "inactive";
      }, a;
    }(Ah2);
    v0(Bce, Lrt);
    var zce = Bce, TB = true, sit = Math.min, gZ = Math.max, han = Math.pow, pan = 1e4, dan = 6, gan = 6, jce = "globalPan", van = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, yan = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, Wce = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, man = 0, ban = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this) || this;
        return d2._track = [], d2._covers = [], d2._handlers = {}, d2._zr = e2, d2.group = new ou(), d2._uid = "brushController_" + man++, Ke2(Tan, function(y2, x2) {
          this._handlers[x2] = As(y2, this);
        }, d2), d2;
      }
      return a.prototype.enableBrush = function(e2) {
        return this._brushType && this._doDisableBrush(), e2.brushType && this._doEnableBrush(e2), this;
      }, a.prototype._doEnableBrush = function(e2) {
        var d2 = this._zr;
        this._enableGlobalPan || Den(d2, jce, this._uid), Ke2(this._handlers, function(y2, x2) {
          d2.on(x2, y2);
        }), this._brushType = e2.brushType, this._brushOption = Mu(zl(Wce), e2, true);
      }, a.prototype._doDisableBrush = function() {
        var e2 = this._zr;
        Een(e2, jce, this._uid), Ke2(this._handlers, function(d2, y2) {
          e2.off(y2, d2);
        }), this._brushType = this._brushOption = null;
      }, a.prototype.setPanels = function(e2) {
        if (e2 && e2.length) {
          var d2 = this._panels = {};
          Ke2(e2, function(y2) {
            d2[y2.panelId] = zl(y2);
          });
        } else
          this._panels = null;
        return this;
      }, a.prototype.mount = function(e2) {
        e2 = e2 || {}, this._enableGlobalPan = e2.enableGlobalPan;
        var d2 = this.group;
        return this._zr.add(d2), d2.attr({ x: e2.x || 0, y: e2.y || 0, rotation: e2.rotation || 0, scaleX: e2.scaleX || 1, scaleY: e2.scaleY || 1 }), this._transform = d2.getLocalTransform(), this;
      }, a.prototype.updateCovers = function(e2) {
        e2 = $a2(e2, function(Y3) {
          return Mu(zl(Wce), Y3, true);
        });
        var d2 = "\0-brush-index-", y2 = this._covers, x2 = this._covers = [], C = this, D2 = this._creatingCover;
        return new kO(y2, e2, F3, L).add(j).update(j).remove(U3).execute(), this;
        function L(Y3, Q) {
          return (Y3.id != null ? Y3.id : d2 + Q) + "-" + Y3.brushType;
        }
        function F3(Y3, Q) {
          return L(Y3.__brushOption, Q);
        }
        function j(Y3, Q) {
          var nt = e2[Y3];
          if (Q != null && y2[Q] === D2)
            x2[Y3] = y2[Q];
          else {
            var dt = x2[Y3] = Q != null ? (y2[Q].__brushOption = nt, y2[Q]) : Hce(C, Gce(C, nt));
            u4t(C, dt);
          }
        }
        function U3(Y3) {
          y2[Y3] !== D2 && C.group.remove(y2[Y3]);
        }
      }, a.prototype.unmount = function() {
        return this.enableBrush(false), h4t(this), this._zr.remove(this.group), this;
      }, a.prototype.dispose = function() {
        this.unmount(), this.off();
      }, a;
    }(Yx);
    function Gce(l2, a) {
      var e2 = xmt[a.brushType].createCover(l2, a);
      return e2.__brushOption = a, qce(e2, a), l2.group.add(e2), e2;
    }
    function Hce(l2, a) {
      var e2 = c4t(a);
      return e2.endCreating && (e2.endCreating(l2, a), qce(a, a.__brushOption)), a;
    }
    function Uce(l2, a) {
      var e2 = a.__brushOption;
      c4t(a).updateCoverShape(l2, a, e2.range, e2);
    }
    function qce(l2, a) {
      var e2 = a.z;
      e2 == null && (e2 = pan), l2.traverse(function(d2) {
        d2.z = e2, d2.z2 = e2;
      });
    }
    function u4t(l2, a) {
      c4t(a).updateCommon(l2, a), Uce(l2, a);
    }
    function c4t(l2) {
      return xmt[l2.__brushOption.brushType];
    }
    function f4t(l2, a, e2) {
      var d2 = l2._panels;
      if (!d2)
        return TB;
      var y2, x2 = l2._transform;
      return Ke2(d2, function(C) {
        C.isTargetByCursor(a, e2, x2) && (y2 = C);
      }), y2;
    }
    function Zce(l2, a) {
      var e2 = l2._panels;
      if (!e2)
        return TB;
      var d2 = a.__brushOption.panelId;
      return d2 != null ? e2[d2] : TB;
    }
    function h4t(l2) {
      var a = l2._covers, e2 = a.length;
      return Ke2(a, function(d2) {
        l2.group.remove(d2);
      }, l2), a.length = 0, !!e2;
    }
    function AB(l2, a) {
      var e2 = $a2(l2._covers, function(d2) {
        var y2 = d2.__brushOption, x2 = zl(y2.range);
        return { brushType: y2.brushType, panelId: y2.panelId, range: x2 };
      });
      l2.trigger("brush", { areas: e2, isEnd: !!a.isEnd, removeOnClick: !!a.removeOnClick });
    }
    function _an(l2) {
      var a = l2._track;
      if (!a.length)
        return false;
      var e2 = a[a.length - 1], d2 = a[0], y2 = e2[0] - d2[0], x2 = e2[1] - d2[1], C = han(y2 * y2 + x2 * x2, 0.5);
      return C > dan;
    }
    function $ce(l2) {
      var a = l2.length - 1;
      return a < 0 && (a = 0), [l2[0], l2[a]];
    }
    function Yce(l2, a, e2, d2) {
      var y2 = new ou();
      return y2.add(new Nf2({ name: "main", style: d4t(e2), silent: true, draggable: true, cursor: "move", drift: xu(Qce, l2, a, y2, ["n", "s", "w", "e"]), ondragend: xu(AB, a, { isEnd: true }) })), Ke2(d2, function(x2) {
        y2.add(new Nf2({ name: x2.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: xu(Qce, l2, a, y2, x2), ondragend: xu(AB, a, { isEnd: true }) }));
      }), y2;
    }
    function Kce(l2, a, e2, d2) {
      var y2 = d2.brushStyle.lineWidth || 0, x2 = gZ(y2, gan), C = e2[0][0], D2 = e2[1][0], L = C - y2 / 2, F3 = D2 - y2 / 2, j = e2[0][1], U3 = e2[1][1], Y3 = j - x2 + y2 / 2, Q = U3 - x2 + y2 / 2, nt = j - C, dt = U3 - D2, vt = nt + y2, Ct = dt + y2;
      FO(l2, a, "main", C, D2, nt, dt), d2.transformable && (FO(l2, a, "w", L, F3, x2, Ct), FO(l2, a, "e", Y3, F3, x2, Ct), FO(l2, a, "n", L, F3, vt, x2), FO(l2, a, "s", L, Q, vt, x2), FO(l2, a, "nw", L, F3, x2, x2), FO(l2, a, "ne", Y3, F3, x2, x2), FO(l2, a, "sw", L, Q, x2, x2), FO(l2, a, "se", Y3, Q, x2, x2));
    }
    function p4t(l2, a) {
      var e2 = a.__brushOption, d2 = e2.transformable, y2 = a.childAt(0);
      y2.useStyle(d4t(e2)), y2.attr({ silent: !d2, cursor: d2 ? "move" : "default" }), Ke2([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(x2) {
        var C = a.childOfName(x2.join("")), D2 = x2.length === 1 ? g4t(l2, x2[0]) : wan(l2, x2);
        C && C.attr({ silent: !d2, invisible: !d2, cursor: d2 ? yan[D2] + "-resize" : null });
      });
    }
    function FO(l2, a, e2, d2, y2, x2, C) {
      var D2 = a.childOfName(e2);
      D2 && D2.setShape(Man(v4t(l2, a, [[d2, y2], [d2 + x2, y2 + C]])));
    }
    function d4t(l2) {
      return El({ strokeNoScale: true }, l2.brushStyle);
    }
    function Xce(l2, a, e2, d2) {
      var y2 = [sit(l2, e2), sit(a, d2)], x2 = [gZ(l2, e2), gZ(a, d2)];
      return [[y2[0], x2[0]], [y2[1], x2[1]]];
    }
    function xan(l2) {
      return Eu(l2.group);
    }
    function g4t(l2, a) {
      var e2 = { w: "left", e: "right", n: "top", s: "bottom" }, d2 = { left: "w", right: "e", top: "n", bottom: "s" }, y2 = Wu(e2[a], xan(l2));
      return d2[y2];
    }
    function wan(l2, a) {
      var e2 = [g4t(l2, a[0]), g4t(l2, a[1])];
      return (e2[0] === "e" || e2[0] === "w") && e2.reverse(), e2.join("");
    }
    function Qce(l2, a, e2, d2, y2, x2) {
      var C = e2.__brushOption, D2 = l2.toRectRange(C.range), L = Jce(a, y2, x2);
      Ke2(d2, function(F3) {
        var j = van[F3];
        D2[j[0]][j[1]] += L[j[0]];
      }), C.range = l2.fromRectRange(Xce(D2[0][0], D2[1][0], D2[0][1], D2[1][1])), u4t(a, e2), AB(a, { isEnd: false });
    }
    function San(l2, a, e2, d2) {
      var y2 = a.__brushOption.range, x2 = Jce(l2, e2, d2);
      Ke2(y2, function(C) {
        C[0] += x2[0], C[1] += x2[1];
      }), u4t(l2, a), AB(l2, { isEnd: false });
    }
    function Jce(l2, a, e2) {
      var d2 = l2.group, y2 = d2.transformCoordToLocal(a, e2), x2 = d2.transformCoordToLocal(0, 0);
      return [y2[0] - x2[0], y2[1] - x2[1]];
    }
    function v4t(l2, a, e2) {
      var d2 = Zce(l2, a);
      return d2 && d2 !== TB ? d2.clipPath(e2, l2._transform) : zl(e2);
    }
    function Man(l2) {
      var a = sit(l2[0][0], l2[1][0]), e2 = sit(l2[0][1], l2[1][1]), d2 = gZ(l2[0][0], l2[1][0]), y2 = gZ(l2[0][1], l2[1][1]);
      return { x: a, y: e2, width: d2 - a, height: y2 - e2 };
    }
    function Can(l2, a, e2) {
      if (!(!l2._brushType || Aan(l2, a.offsetX, a.offsetY))) {
        var d2 = l2._zr, y2 = l2._covers, x2 = f4t(l2, a, e2);
        if (!l2._dragging)
          for (var C = 0; C < y2.length; C++) {
            var D2 = y2[C].__brushOption;
            if (x2 && (x2 === TB || D2.panelId === x2.panelId) && xmt[D2.brushType].contain(y2[C], e2[0], e2[1]))
              return;
          }
        x2 && d2.setCursorStyle("crosshair");
      }
    }
    function y4t(l2) {
      var a = l2.event;
      a.preventDefault && a.preventDefault();
    }
    function m4t(l2, a, e2) {
      return l2.childOfName("main").contain(a, e2);
    }
    function tfe(l2, a, e2, d2) {
      var y2 = l2._creatingCover, x2 = l2._creatingPanel, C = l2._brushOption, D2;
      if (l2._track.push(e2.slice()), _an(l2) || y2) {
        if (x2 && !y2) {
          C.brushMode === "single" && h4t(l2);
          var L = zl(C);
          L.brushType = efe(L.brushType, x2), L.panelId = x2 === TB ? null : x2.panelId, y2 = l2._creatingCover = Gce(l2, L), l2._covers.push(y2);
        }
        if (y2) {
          var F3 = xmt[efe(l2._brushType, x2)], j = y2.__brushOption;
          j.range = F3.getCreatingRange(v4t(l2, y2, l2._track)), d2 && (Hce(l2, y2), F3.updateCommon(l2, y2)), Uce(l2, y2), D2 = { isEnd: d2 };
        }
      } else
        d2 && C.brushMode === "single" && C.removeOnClick && f4t(l2, a, e2) && h4t(l2) && (D2 = { isEnd: d2, removeOnClick: true });
      return D2;
    }
    function efe(l2, a) {
      return l2 === "auto" ? a.defaultBrushType : l2;
    }
    var Tan = { mousedown: function(l2) {
      if (this._dragging)
        nfe(this, l2);
      else if (!l2.target || !l2.target.draggable) {
        y4t(l2);
        var a = this.group.transformCoordToLocal(l2.offsetX, l2.offsetY);
        this._creatingCover = null;
        var e2 = this._creatingPanel = f4t(this, l2, a);
        e2 && (this._dragging = true, this._track = [a.slice()]);
      }
    }, mousemove: function(l2) {
      var a = l2.offsetX, e2 = l2.offsetY, d2 = this.group.transformCoordToLocal(a, e2);
      if (Can(this, l2, d2), this._dragging) {
        y4t(l2);
        var y2 = tfe(this, l2, d2, false);
        y2 && AB(this, y2);
      }
    }, mouseup: function(l2) {
      nfe(this, l2);
    } };
    function nfe(l2, a) {
      if (l2._dragging) {
        y4t(a);
        var e2 = a.offsetX, d2 = a.offsetY, y2 = l2.group.transformCoordToLocal(e2, d2), x2 = tfe(l2, a, y2, true);
        l2._dragging = false, l2._track = [], l2._creatingCover = null, x2 && AB(l2, x2);
      }
    }
    function Aan(l2, a, e2) {
      var d2 = l2._zr;
      return a < 0 || a > d2.getWidth() || e2 < 0 || e2 > d2.getHeight();
    }
    var xmt = { lineX: rfe(0), lineY: rfe(1), rect: { createCover: function(l2, a) {
      function e2(d2) {
        return d2;
      }
      return Yce({ toRectRange: e2, fromRectRange: e2 }, l2, a, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    }, getCreatingRange: function(l2) {
      var a = $ce(l2);
      return Xce(a[1][0], a[1][1], a[0][0], a[0][1]);
    }, updateCoverShape: function(l2, a, e2, d2) {
      Kce(l2, a, e2, d2);
    }, updateCommon: p4t, contain: m4t }, polygon: { createCover: function(l2, a) {
      var e2 = new ou();
      return e2.add(new iw({ name: "main", style: d4t(a), silent: true })), e2;
    }, getCreatingRange: function(l2) {
      return l2;
    }, endCreating: function(l2, a) {
      a.remove(a.childAt(0)), a.add(new rw({ name: "main", draggable: true, drift: xu(San, l2, a), ondragend: xu(AB, l2, { isEnd: true }) }));
    }, updateCoverShape: function(l2, a, e2, d2) {
      a.childAt(0).setShape({ points: v4t(l2, a, e2) });
    }, updateCommon: p4t, contain: m4t } };
    function rfe(l2) {
      return { createCover: function(a, e2) {
        return Yce({ toRectRange: function(d2) {
          var y2 = [d2, [0, 100]];
          return l2 && y2.reverse(), y2;
        }, fromRectRange: function(d2) {
          return d2[l2];
        } }, a, e2, [[["w"], ["e"]], [["n"], ["s"]]][l2]);
      }, getCreatingRange: function(a) {
        var e2 = $ce(a), d2 = sit(e2[0][l2], e2[1][l2]), y2 = gZ(e2[0][l2], e2[1][l2]);
        return [d2, y2];
      }, updateCoverShape: function(a, e2, d2, y2) {
        var x2, C = Zce(a, e2);
        if (C !== TB && C.getLinearBrushOtherExtent)
          x2 = C.getLinearBrushOtherExtent(l2);
        else {
          var D2 = a._zr;
          x2 = [0, [D2.getWidth(), D2.getHeight()][1 - l2]];
        }
        var L = [d2, x2];
        l2 && L.reverse(), Kce(a, e2, L, y2);
      }, updateCommon: p4t, contain: m4t };
    }
    var b4t = ban;
    function ife(l2) {
      return l2 = _4t(l2), function(a) {
        return wb2(a, l2);
      };
    }
    function afe(l2, a) {
      return l2 = _4t(l2), function(e2) {
        var d2 = a != null ? a : e2, y2 = d2 ? l2.width : l2.height, x2 = d2 ? l2.x : l2.y;
        return [x2, x2 + (y2 || 0)];
      };
    }
    function ofe(l2, a, e2) {
      var d2 = _4t(l2);
      return function(y2, x2) {
        return d2.contain(x2[0], x2[1]) && !omt(y2, a, e2);
      };
    }
    function _4t(l2) {
      return Yu.create(l2);
    }
    var Ian = ["axisLine", "axisTickLabel", "axisName"], Dan = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2, d2) {
        l2.prototype.init.apply(this, arguments), (this._brushController = new b4t(d2.getZr())).on("brush", As(this._onBrush, this));
      }, a.prototype.render = function(e2, d2, y2, x2) {
        if (!Ean(e2, d2, x2)) {
          this.axisModel = e2, this.api = y2, this.group.removeAll();
          var C = this._axisGroup;
          if (this._axisGroup = new ou(), this.group.add(this._axisGroup), !!e2.get("show")) {
            var D2 = Pan(e2, d2), L = D2.coordinateSystem, F3 = e2.getAreaSelectStyle(), j = F3.width, U3 = e2.axis.dim, Y3 = L.getAxisLayout(U3), Q = la2({ strokeContainThreshold: j }, Y3), nt = new RO(e2, Q);
            Ke2(Ian, nt.add, nt), this._axisGroup.add(nt.getGroup()), this._refreshBrushController(Q, F3, e2, D2, j, y2), m1(C, this._axisGroup, e2);
          }
        }
      }, a.prototype._refreshBrushController = function(e2, d2, y2, x2, C, D2) {
        var L = y2.axis.getExtent(), F3 = L[1] - L[0], j = Math.min(30, Math.abs(F3) * 0.1), U3 = Yu.create({ x: L[0], y: -C / 2, width: F3, height: C });
        U3.x -= j, U3.width += 2 * j, this._brushController.mount({ enableGlobalPan: true, rotation: e2.rotation, x: e2.position[0], y: e2.position[1] }).setPanels([{ panelId: "pl", clipPath: ife(U3), isTargetByCursor: ofe(U3, D2, x2), getLinearBrushOtherExtent: afe(U3, 0) }]).enableBrush({ brushType: "lineX", brushStyle: d2, removeOnClick: true }).updateCovers(kan(y2));
      }, a.prototype._onBrush = function(e2) {
        var d2 = e2.areas, y2 = this.axisModel, x2 = y2.axis, C = $a2(d2, function(D2) {
          return [x2.coordToData(D2.range[0], true), x2.coordToData(D2.range[1], true)];
        });
        (!y2.option.realtime === e2.isEnd || e2.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: y2.id, intervals: C });
      }, a.prototype.dispose = function() {
        this._brushController.dispose();
      }, a.type = "parallelAxis", a;
    }(_0);
    function Ean(l2, a, e2) {
      return e2 && e2.type === "axisAreaSelect" && a.findComponents({ mainType: "parallelAxis", query: e2 })[0] === l2;
    }
    function kan(l2) {
      var a = l2.axis;
      return $a2(l2.activeIntervals, function(e2) {
        return { brushType: "lineX", panelId: "pl", range: [a.dataToCoord(e2[0], true), a.dataToCoord(e2[1], true)] };
      });
    }
    function Pan(l2, a) {
      return a.getComponent("parallel", l2.get("parallelIndex"));
    }
    var Lan = Dan, Oan = { type: "axisAreaSelect", event: "axisAreaSelected" };
    function Ran(l2) {
      l2.registerAction(Oan, function(a, e2) {
        e2.eachComponent({ mainType: "parallelAxis", query: a }, function(d2) {
          d2.axis.model.setActiveIntervals(a.intervals);
        });
      }), l2.registerAction("parallelAxisExpand", function(a, e2) {
        e2.eachComponent({ mainType: "parallel", query: a }, function(d2) {
          d2.setAxisExpand(a);
        });
      });
    }
    var Nan = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
    function sfe(l2) {
      l2.registerComponentView(Qin), l2.registerComponentModel(tan), l2.registerCoordinateSystem("parallel", fan), l2.registerPreprocessor(qin), l2.registerComponentModel(zce), l2.registerComponentView(Lan), uZ(l2, "parallel", zce, Nan), Ran(l2);
    }
    function Fan(l2) {
      Oc2(sfe), l2.registerChartView(Vin), l2.registerSeriesModel(Win), l2.registerVisual(l2.PRIORITY.VISUAL.BRUSH, Uin);
    }
    var Van = function() {
      function l2() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
      }
      return l2;
    }(), Ban = function(l2) {
      Jn(a, l2);
      function a(e2) {
        return l2.call(this, e2) || this;
      }
      return a.prototype.getDefaultShape = function() {
        return new Van();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.extent;
        e2.moveTo(d2.x1, d2.y1), e2.bezierCurveTo(d2.cpx1, d2.cpy1, d2.cpx2, d2.cpy2, d2.x2, d2.y2), d2.orient === "vertical" ? (e2.lineTo(d2.x2 + y2, d2.y2), e2.bezierCurveTo(d2.cpx2 + y2, d2.cpy2, d2.cpx1 + y2, d2.cpy1, d2.x1 + y2, d2.y1)) : (e2.lineTo(d2.x2, d2.y2 + y2), e2.bezierCurveTo(d2.cpx2, d2.cpy2 + y2, d2.cpx1, d2.cpy1 + y2, d2.x1, d2.y1 + y2)), e2.closePath();
      }, a.prototype.highlight = function() {
        Dm(this);
      }, a.prototype.downplay = function() {
        fc2(this);
      }, a;
    }(wc2), zan = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._focusAdjacencyDisabled = false, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = this, C = e2.getGraph(), D2 = this.group, L = e2.layoutInfo, F3 = L.width, j = L.height, U3 = e2.getData(), Y3 = e2.getData("edge"), Q = e2.get("orient");
        this._model = e2, D2.removeAll(), D2.x = L.x, D2.y = L.y, C.eachEdge(function(nt) {
          var dt = new Ban(), vt = ns(dt);
          vt.dataIndex = nt.dataIndex, vt.seriesIndex = e2.seriesIndex, vt.dataType = "edge";
          var Ct = nt.getModel(), Pt = Ct.getModel("lineStyle"), jt = Pt.get("curveness"), Rt = nt.node1.getLayout(), le2 = nt.node1.getModel(), ne2 = le2.get("localX"), he2 = le2.get("localY"), _e = nt.node2.getLayout(), Me2 = nt.node2.getModel(), Pe2 = Me2.get("localX"), Be2 = Me2.get("localY"), Je2 = nt.getLayout(), Ze2, Cn, Bn, mn, Kr, Kn, ar, Cr;
          switch (dt.shape.extent = Math.max(1, Je2.dy), dt.shape.orient = Q, Q === "vertical" ? (Ze2 = (ne2 != null ? ne2 * F3 : Rt.x) + Je2.sy, Cn = (he2 != null ? he2 * j : Rt.y) + Rt.dy, Bn = (Pe2 != null ? Pe2 * F3 : _e.x) + Je2.ty, mn = Be2 != null ? Be2 * j : _e.y, Kr = Ze2, Kn = Cn * (1 - jt) + mn * jt, ar = Bn, Cr = Cn * jt + mn * (1 - jt)) : (Ze2 = (ne2 != null ? ne2 * F3 : Rt.x) + Rt.dx, Cn = (he2 != null ? he2 * j : Rt.y) + Je2.sy, Bn = Pe2 != null ? Pe2 * F3 : _e.x, mn = (Be2 != null ? Be2 * j : _e.y) + Je2.ty, Kr = Ze2 * (1 - jt) + Bn * jt, Kn = Cn, ar = Ze2 * jt + Bn * (1 - jt), Cr = mn), dt.setShape({ x1: Ze2, y1: Cn, x2: Bn, y2: mn, cpx1: Kr, cpy1: Kn, cpx2: ar, cpy2: Cr }), dt.useStyle(Pt.getItemStyle()), dt.style.fill) {
            case "source":
              dt.style.fill = nt.node1.getVisual("color"), dt.style.decal = nt.node1.getVisual("style").decal;
              break;
            case "target":
              dt.style.fill = nt.node2.getVisual("color"), dt.style.decal = nt.node2.getVisual("style").decal;
              break;
            case "gradient":
              var ui2 = nt.node1.getVisual("color"), vi2 = nt.node2.getVisual("color");
              ps(ui2) && ps(vi2) && (dt.style.fill = new QV(0, 0, +(Q === "horizontal"), +(Q === "vertical"), [{ color: ui2, offset: 0 }, { color: vi2, offset: 1 }]));
          }
          var ko = Ct.getModel("emphasis");
          Gy(dt, Ct, "lineStyle", function(hl) {
            return hl.getItemStyle();
          }), D2.add(dt), Y3.setItemGraphicEl(nt.dataIndex, dt);
          var Ss = ko.get("focus");
          n0(dt, Ss === "adjacency" ? nt.getAdjacentDataIndices() : Ss, ko.get("blurScope"), ko.get("disabled")), ns(dt).dataType = "edge";
        }), C.eachNode(function(nt) {
          var dt = nt.getLayout(), vt = nt.getModel(), Ct = vt.get("localX"), Pt = vt.get("localY"), jt = vt.getModel("emphasis"), Rt = new Nf2({ shape: { x: Ct != null ? Ct * F3 : dt.x, y: Pt != null ? Pt * j : dt.y, width: dt.dx, height: dt.dy }, style: vt.getModel("itemStyle").getItemStyle(), z2: 10 });
          ow(Rt, Sb2(vt), { labelFetcher: e2, labelDataIndex: nt.dataIndex, defaultText: nt.id }), Rt.disableLabelAnimation = true, Rt.setStyle("fill", nt.getVisual("color")), Rt.setStyle("decal", nt.getVisual("style").decal), Gy(Rt, vt), D2.add(Rt), U3.setItemGraphicEl(nt.dataIndex, Rt), ns(Rt).dataType = "node";
          var le2 = jt.get("focus");
          n0(Rt, le2 === "adjacency" ? nt.getAdjacentDataIndices() : le2, jt.get("blurScope"), jt.get("disabled"));
        }), U3.eachItemGraphicEl(function(nt, dt) {
          var vt = U3.getItemModel(dt);
          vt.get("draggable") && (nt.drift = function(Ct, Pt) {
            x2._focusAdjacencyDisabled = true, this.shape.x += Ct, this.shape.y += Pt, this.dirty(), y2.dispatchAction({ type: "dragNode", seriesId: e2.id, dataIndex: U3.getRawIndex(dt), localX: this.shape.x / F3, localY: this.shape.y / j });
          }, nt.ondragend = function() {
            x2._focusAdjacencyDisabled = false;
          }, nt.draggable = true, nt.cursor = "move");
        }), !this._data && e2.isAnimationEnabled() && D2.setClipPath(jan(D2.getBoundingRect(), e2, function() {
          D2.removeClipPath();
        })), this._data = e2.getData();
      }, a.prototype.dispose = function() {
      }, a.type = "sankey", a;
    }(pg2);
    function jan(l2, a, e2) {
      var d2 = new Nf2({ shape: { x: l2.x - 10, y: l2.y - 10, width: 0, height: l2.height + 20 } });
      return Yg2(d2, { shape: { width: l2.width + 20 } }, a, e2), d2;
    }
    var Wan = zan, Gan = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        var y2 = e2.edges || e2.links, x2 = e2.data || e2.nodes, C = e2.levels;
        this.levelModels = [];
        for (var D2 = this.levelModels, L = 0; L < C.length; L++)
          C[L].depth != null && C[L].depth >= 0 && (D2[C[L].depth] = new hg2(C[L], this, d2));
        if (x2 && y2) {
          var F3 = kce(x2, y2, this, true, j);
          return F3.data;
        }
        function j(U3, Y3) {
          U3.wrapMethod("getItemModel", function(Q, nt) {
            var dt = Q.parentModel, vt = dt.getData().getItemLayout(nt);
            if (vt) {
              var Ct = vt.depth, Pt = dt.levelModels[Ct];
              Pt && (Q.parentModel = Pt);
            }
            return Q;
          }), Y3.wrapMethod("getItemModel", function(Q, nt) {
            var dt = Q.parentModel, vt = dt.getGraph().getEdgeByIndex(nt), Ct = vt.node1.getLayout();
            if (Ct) {
              var Pt = Ct.depth, jt = dt.levelModels[Pt];
              jt && (Q.parentModel = jt);
            }
            return Q;
          });
        }
      }, a.prototype.setNodePosition = function(e2, d2) {
        var y2 = this.option.data || this.option.nodes, x2 = y2[e2];
        x2.localX = d2[0], x2.localY = d2[1];
      }, a.prototype.getGraph = function() {
        return this.getData().graph;
      }, a.prototype.getEdgeData = function() {
        return this.getGraph().edgeData;
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        function x2(Q) {
          return isNaN(Q) || Q == null;
        }
        if (y2 === "edge") {
          var C = this.getDataParams(e2, y2), D2 = C.data, L = C.value, F3 = D2.source + " -- " + D2.target;
          return b1("nameValue", { name: F3, value: L, noValue: x2(L) });
        } else {
          var j = this.getGraph().getNodeByIndex(e2), U3 = j.getLayout().value, Y3 = this.getDataParams(e2, y2).data.name;
          return b1("nameValue", { name: Y3 != null ? Y3 + "" : null, value: U3, noValue: x2(U3) });
        }
      }, a.prototype.optionUpdated = function() {
      }, a.prototype.getDataParams = function(e2, d2) {
        var y2 = l2.prototype.getDataParams.call(this, e2, d2);
        if (y2.value == null && d2 === "node") {
          var x2 = this.getGraph().getNodeByIndex(e2), C = x2.getLayout().value;
          y2.value = C;
        }
        return y2;
      }, a.type = "series.sankey", a.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, a;
    }(Pv), Han = Gan;
    function Uan(l2, a) {
      l2.eachSeriesByType("sankey", function(e2) {
        var d2 = e2.get("nodeWidth"), y2 = e2.get("nodeGap"), x2 = qan(e2, a);
        e2.layoutInfo = x2;
        var C = x2.width, D2 = x2.height, L = e2.getGraph(), F3 = L.nodes, j = L.edges;
        $an(F3);
        var U3 = Lp(F3, function(dt) {
          return dt.getLayout().value === 0;
        }), Y3 = U3.length !== 0 ? 0 : e2.get("layoutIterations"), Q = e2.get("orient"), nt = e2.get("nodeAlign");
        Zan(F3, j, d2, y2, C, D2, Y3, Q, nt);
      });
    }
    function qan(l2, a) {
      return Em(l2.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
    }
    function Zan(l2, a, e2, d2, y2, x2, C, D2, L) {
      Yan(l2, a, e2, y2, x2, D2, L), Jan(l2, a, x2, y2, d2, C, D2), lon(l2, D2);
    }
    function $an(l2) {
      Ke2(l2, function(a) {
        var e2 = sF(a.outEdges, wmt), d2 = sF(a.inEdges, wmt), y2 = a.getValue() || 0, x2 = Math.max(e2, d2, y2);
        a.setLayout({ value: x2 }, true);
      });
    }
    function Yan(l2, a, e2, d2, y2, x2, C) {
      for (var D2 = [], L = [], F3 = [], j = [], U3 = 0, Y3 = 0; Y3 < a.length; Y3++)
        D2[Y3] = 1;
      for (var Y3 = 0; Y3 < l2.length; Y3++)
        L[Y3] = l2[Y3].inEdges.length, L[Y3] === 0 && F3.push(l2[Y3]);
      for (var Q = -1; F3.length; ) {
        for (var nt = 0; nt < F3.length; nt++) {
          var dt = F3[nt], vt = dt.hostGraph.data.getRawDataItem(dt.dataIndex), Ct = vt.depth != null && vt.depth >= 0;
          Ct && vt.depth > Q && (Q = vt.depth), dt.setLayout({ depth: Ct ? vt.depth : U3 }, true), x2 === "vertical" ? dt.setLayout({ dy: e2 }, true) : dt.setLayout({ dx: e2 }, true);
          for (var Pt = 0; Pt < dt.outEdges.length; Pt++) {
            var jt = dt.outEdges[Pt], Rt = a.indexOf(jt);
            D2[Rt] = 0;
            var le2 = jt.node2, ne2 = l2.indexOf(le2);
            --L[ne2] === 0 && j.indexOf(le2) < 0 && j.push(le2);
          }
        }
        ++U3, F3 = j, j = [];
      }
      for (var Y3 = 0; Y3 < D2.length; Y3++)
        if (D2[Y3] === 1)
          throw new Error("Sankey is a DAG, the original data has cycle!");
      var he2 = Q > U3 - 1 ? Q : U3 - 1;
      C && C !== "left" && Kan(l2, C, x2, he2);
      var _e = x2 === "vertical" ? (y2 - e2) / he2 : (d2 - e2) / he2;
      Qan(l2, _e, x2);
    }
    function lfe(l2) {
      var a = l2.hostGraph.data.getRawDataItem(l2.dataIndex);
      return a.depth != null && a.depth >= 0;
    }
    function Kan(l2, a, e2, d2) {
      if (a === "right") {
        for (var y2 = [], x2 = l2, C = 0; x2.length; ) {
          for (var D2 = 0; D2 < x2.length; D2++) {
            var L = x2[D2];
            L.setLayout({ skNodeHeight: C }, true);
            for (var F3 = 0; F3 < L.inEdges.length; F3++) {
              var j = L.inEdges[F3];
              y2.indexOf(j.node1) < 0 && y2.push(j.node1);
            }
          }
          x2 = y2, y2 = [], ++C;
        }
        Ke2(l2, function(U3) {
          lfe(U3) || U3.setLayout({ depth: Math.max(0, d2 - U3.getLayout().skNodeHeight) }, true);
        });
      } else
        a === "justify" && Xan(l2, d2);
    }
    function Xan(l2, a) {
      Ke2(l2, function(e2) {
        !lfe(e2) && !e2.outEdges.length && e2.setLayout({ depth: a }, true);
      });
    }
    function Qan(l2, a, e2) {
      Ke2(l2, function(d2) {
        var y2 = d2.getLayout().depth * a;
        e2 === "vertical" ? d2.setLayout({ y: y2 }, true) : d2.setLayout({ x: y2 }, true);
      });
    }
    function Jan(l2, a, e2, d2, y2, x2, C) {
      var D2 = ton(l2, C);
      eon(D2, a, e2, d2, y2, C), x4t(D2, y2, e2, d2, C);
      for (var L = 1; x2 > 0; x2--)
        L *= 0.99, non(D2, L, C), x4t(D2, y2, e2, d2, C), son(D2, L, C), x4t(D2, y2, e2, d2, C);
    }
    function ton(l2, a) {
      var e2 = [], d2 = a === "vertical" ? "y" : "x", y2 = cq(l2, function(x2) {
        return x2.getLayout()[d2];
      });
      return y2.keys.sort(function(x2, C) {
        return x2 - C;
      }), Ke2(y2.keys, function(x2) {
        e2.push(y2.buckets.get(x2));
      }), e2;
    }
    function eon(l2, a, e2, d2, y2, x2) {
      var C = 1 / 0;
      Ke2(l2, function(D2) {
        var L = D2.length, F3 = 0;
        Ke2(D2, function(U3) {
          F3 += U3.getLayout().value;
        });
        var j = x2 === "vertical" ? (d2 - (L - 1) * y2) / F3 : (e2 - (L - 1) * y2) / F3;
        j < C && (C = j);
      }), Ke2(l2, function(D2) {
        Ke2(D2, function(L, F3) {
          var j = L.getLayout().value * C;
          x2 === "vertical" ? (L.setLayout({ x: F3 }, true), L.setLayout({ dx: j }, true)) : (L.setLayout({ y: F3 }, true), L.setLayout({ dy: j }, true));
        });
      }), Ke2(a, function(D2) {
        var L = +D2.getValue() * C;
        D2.setLayout({ dy: L }, true);
      });
    }
    function x4t(l2, a, e2, d2, y2) {
      var x2 = y2 === "vertical" ? "x" : "y";
      Ke2(l2, function(C) {
        C.sort(function(dt, vt) {
          return dt.getLayout()[x2] - vt.getLayout()[x2];
        });
        for (var D2, L, F3, j = 0, U3 = C.length, Y3 = y2 === "vertical" ? "dx" : "dy", Q = 0; Q < U3; Q++)
          L = C[Q], F3 = j - L.getLayout()[x2], F3 > 0 && (D2 = L.getLayout()[x2] + F3, y2 === "vertical" ? L.setLayout({ x: D2 }, true) : L.setLayout({ y: D2 }, true)), j = L.getLayout()[x2] + L.getLayout()[Y3] + a;
        var nt = y2 === "vertical" ? d2 : e2;
        if (F3 = j - a - nt, F3 > 0) {
          D2 = L.getLayout()[x2] - F3, y2 === "vertical" ? L.setLayout({ x: D2 }, true) : L.setLayout({ y: D2 }, true), j = D2;
          for (var Q = U3 - 2; Q >= 0; --Q)
            L = C[Q], F3 = L.getLayout()[x2] + L.getLayout()[Y3] + a - j, F3 > 0 && (D2 = L.getLayout()[x2] - F3, y2 === "vertical" ? L.setLayout({ x: D2 }, true) : L.setLayout({ y: D2 }, true)), j = L.getLayout()[x2];
        }
      });
    }
    function non(l2, a, e2) {
      Ke2(l2.slice().reverse(), function(d2) {
        Ke2(d2, function(y2) {
          if (y2.outEdges.length) {
            var x2 = sF(y2.outEdges, ron, e2) / sF(y2.outEdges, wmt);
            if (isNaN(x2)) {
              var C = y2.outEdges.length;
              x2 = C ? sF(y2.outEdges, ion, e2) / C : 0;
            }
            if (e2 === "vertical") {
              var D2 = y2.getLayout().x + (x2 - oF(y2, e2)) * a;
              y2.setLayout({ x: D2 }, true);
            } else {
              var L = y2.getLayout().y + (x2 - oF(y2, e2)) * a;
              y2.setLayout({ y: L }, true);
            }
          }
        });
      });
    }
    function ron(l2, a) {
      return oF(l2.node2, a) * l2.getValue();
    }
    function ion(l2, a) {
      return oF(l2.node2, a);
    }
    function aon(l2, a) {
      return oF(l2.node1, a) * l2.getValue();
    }
    function oon(l2, a) {
      return oF(l2.node1, a);
    }
    function oF(l2, a) {
      return a === "vertical" ? l2.getLayout().x + l2.getLayout().dx / 2 : l2.getLayout().y + l2.getLayout().dy / 2;
    }
    function wmt(l2) {
      return l2.getValue();
    }
    function sF(l2, a, e2) {
      for (var d2 = 0, y2 = l2.length, x2 = -1; ++x2 < y2; ) {
        var C = +a(l2[x2], e2);
        isNaN(C) || (d2 += C);
      }
      return d2;
    }
    function son(l2, a, e2) {
      Ke2(l2, function(d2) {
        Ke2(d2, function(y2) {
          if (y2.inEdges.length) {
            var x2 = sF(y2.inEdges, aon, e2) / sF(y2.inEdges, wmt);
            if (isNaN(x2)) {
              var C = y2.inEdges.length;
              x2 = C ? sF(y2.inEdges, oon, e2) / C : 0;
            }
            if (e2 === "vertical") {
              var D2 = y2.getLayout().x + (x2 - oF(y2, e2)) * a;
              y2.setLayout({ x: D2 }, true);
            } else {
              var L = y2.getLayout().y + (x2 - oF(y2, e2)) * a;
              y2.setLayout({ y: L }, true);
            }
          }
        });
      });
    }
    function lon(l2, a) {
      var e2 = a === "vertical" ? "x" : "y";
      Ke2(l2, function(d2) {
        d2.outEdges.sort(function(y2, x2) {
          return y2.node2.getLayout()[e2] - x2.node2.getLayout()[e2];
        }), d2.inEdges.sort(function(y2, x2) {
          return y2.node1.getLayout()[e2] - x2.node1.getLayout()[e2];
        });
      }), Ke2(l2, function(d2) {
        var y2 = 0, x2 = 0;
        Ke2(d2.outEdges, function(C) {
          C.setLayout({ sy: y2 }, true), y2 += C.getLayout().dy;
        }), Ke2(d2.inEdges, function(C) {
          C.setLayout({ ty: x2 }, true), x2 += C.getLayout().dy;
        });
      });
    }
    function uon(l2) {
      l2.eachSeriesByType("sankey", function(a) {
        var e2 = a.getGraph(), d2 = e2.nodes;
        if (d2.length) {
          var y2 = 1 / 0, x2 = -1 / 0;
          Ke2(d2, function(C) {
            var D2 = C.getLayout().value;
            D2 < y2 && (y2 = D2), D2 > x2 && (x2 = D2);
          }), Ke2(d2, function(C) {
            var D2 = new B_({ type: "color", mappingMethod: "linear", dataExtent: [y2, x2], visual: a.get("color") }), L = D2.mapValueToVisual(C.getLayout().value), F3 = C.getModel().get(["itemStyle", "color"]);
            F3 != null ? (C.setVisual("color", F3), C.setVisual("style", { fill: F3 })) : (C.setVisual("color", L), C.setVisual("style", { fill: L }));
          });
        }
      });
    }
    function con(l2) {
      l2.registerChartView(Wan), l2.registerSeriesModel(Han), l2.registerLayout(Uan), l2.registerVisual(uon), l2.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(a, e2) {
        e2.eachComponent({ mainType: "series", subType: "sankey", query: a }, function(d2) {
          d2.setNodePosition(a.dataIndex, [a.localX, a.localY]);
        });
      });
    }
    var ufe = function() {
      function l2() {
      }
      return l2.prototype.getInitialData = function(a, e2) {
        var d2, y2 = e2.getComponent("xAxis", this.get("xAxisIndex")), x2 = e2.getComponent("yAxis", this.get("yAxisIndex")), C = y2.get("type"), D2 = x2.get("type"), L;
        C === "category" ? (a.layout = "horizontal", d2 = y2.getOrdinalMeta(), L = true) : D2 === "category" ? (a.layout = "vertical", d2 = x2.getOrdinalMeta(), L = true) : a.layout = a.layout || "horizontal";
        var F3 = ["x", "y"], j = a.layout === "horizontal" ? 0 : 1, U3 = this._baseAxisDim = F3[j], Y3 = F3[1 - j], Q = [y2, x2], nt = Q[j].get("type"), dt = Q[1 - j].get("type"), vt = a.data;
        if (vt && L) {
          var Ct = [];
          Ke2(vt, function(Rt, le2) {
            var ne2;
            Ba2(Rt) ? (ne2 = Rt.slice(), Rt.unshift(le2)) : Ba2(Rt.value) ? (ne2 = la2({}, Rt), ne2.value = ne2.value.slice(), Rt.value.unshift(le2)) : ne2 = Rt, Ct.push(ne2);
          }), a.data = Ct;
        }
        var Pt = this.defaultValueDimensions, jt = [{ name: U3, type: kyt(nt), ordinalMeta: d2, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: Y3, type: kyt(dt), dimsDef: Pt.slice() }];
        return lZ(this, { coordDimensions: jt, dimensionsCount: Pt.length + 1, encodeDefaulter: xu(bie, jt, this) });
      }, l2.prototype.getBaseAxis = function() {
        var a = this._baseAxisDim;
        return this.ecModel.getComponent(a + "Axis", this.get(a + "AxisIndex")).axis;
      }, l2;
    }(), cfe = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], e2.visualDrawType = "stroke", e2;
      }
      return a.type = "series.boxplot", a.dependencies = ["xAxis", "yAxis", "grid"], a.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, a;
    }(Pv);
    v0(cfe, ufe, true);
    var fon = cfe, hon = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this.group, D2 = this._data;
        this._data || C.removeAll();
        var L = e2.get("layout") === "horizontal" ? 1 : 0;
        x2.diff(D2).add(function(F3) {
          if (x2.hasValue(F3)) {
            var j = x2.getItemLayout(F3), U3 = ffe(j, x2, F3, L, true);
            x2.setItemGraphicEl(F3, U3), C.add(U3);
          }
        }).update(function(F3, j) {
          var U3 = D2.getItemGraphicEl(j);
          if (!x2.hasValue(F3)) {
            C.remove(U3);
            return;
          }
          var Y3 = x2.getItemLayout(F3);
          U3 ? (pC(U3), hfe(Y3, U3, x2, F3)) : U3 = ffe(Y3, x2, F3, L), C.add(U3), x2.setItemGraphicEl(F3, U3);
        }).remove(function(F3) {
          var j = D2.getItemGraphicEl(F3);
          j && C.remove(j);
        }).execute(), this._data = x2;
      }, a.prototype.remove = function(e2) {
        var d2 = this.group, y2 = this._data;
        this._data = null, y2 && y2.eachItemGraphicEl(function(x2) {
          x2 && d2.remove(x2);
        });
      }, a.type = "boxplot", a;
    }(pg2), pon = function() {
      function l2() {
      }
      return l2;
    }(), don = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "boxplotBoxPath", d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new pon();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.points, x2 = 0;
        for (e2.moveTo(y2[x2][0], y2[x2][1]), x2++; x2 < 4; x2++)
          e2.lineTo(y2[x2][0], y2[x2][1]);
        for (e2.closePath(); x2 < y2.length; x2++)
          e2.moveTo(y2[x2][0], y2[x2][1]), x2++, e2.lineTo(y2[x2][0], y2[x2][1]);
      }, a;
    }(wc2);
    function ffe(l2, a, e2, d2, y2) {
      var x2 = l2.ends, C = new don({ shape: { points: y2 ? gon(x2, d2, l2) : x2 } });
      return hfe(l2, C, a, e2, y2), C;
    }
    function hfe(l2, a, e2, d2, y2) {
      var x2 = e2.hostModel, C = nrt[y2 ? "initProps" : "updateProps"];
      C(a, { shape: { points: l2.ends } }, x2, d2), a.useStyle(e2.getItemVisual(d2, "style")), a.style.strokeNoScale = true, a.z2 = 100;
      var D2 = e2.getItemModel(d2), L = D2.getModel("emphasis");
      Gy(a, D2), n0(a, L.get("focus"), L.get("blurScope"), L.get("disabled"));
    }
    function gon(l2, a, e2) {
      return $a2(l2, function(d2) {
        return d2 = d2.slice(), d2[a] = e2.initBaseline, d2;
      });
    }
    var von = hon;
    function yon(l2, a) {
    }
    var lit = Ke2;
    function mon(l2) {
      var a = bon(l2);
      lit(a, function(e2) {
        var d2 = e2.seriesModels;
        !d2.length || (_on(e2), lit(d2, function(y2, x2) {
          xon(y2, e2.boxOffsetList[x2], e2.boxWidthList[x2]);
        }));
      });
    }
    function bon(l2) {
      var a = [], e2 = [];
      return l2.eachSeriesByType("boxplot", function(d2) {
        var y2 = d2.getBaseAxis(), x2 = oc2(e2, y2);
        x2 < 0 && (x2 = e2.length, e2[x2] = y2, a[x2] = { axis: y2, seriesModels: [] }), a[x2].seriesModels.push(d2);
      }), a;
    }
    function _on(l2) {
      var a = l2.axis, e2 = l2.seriesModels, d2 = e2.length, y2 = l2.boxWidthList = [], x2 = l2.boxOffsetList = [], C = [], D2;
      if (a.type === "category")
        D2 = a.getBandWidth();
      else {
        var L = 0;
        lit(e2, function(nt) {
          L = Math.max(L, nt.getData().count());
        });
        var F3 = a.getExtent();
        D2 = Math.abs(F3[1] - F3[0]) / L;
      }
      lit(e2, function(nt) {
        var dt = nt.get("boxWidth");
        Ba2(dt) || (dt = [dt, dt]), C.push([Ko(dt[0], D2) || 0, Ko(dt[1], D2) || 0]);
      });
      var j = D2 * 0.8 - 2, U3 = j / d2 * 0.3, Y3 = (j - U3 * (d2 - 1)) / d2, Q = Y3 / 2 - j / 2;
      lit(e2, function(nt, dt) {
        x2.push(Q), Q += U3 + Y3, y2.push(Math.min(Math.max(Y3, C[dt][0]), C[dt][1]));
      });
    }
    function xon(l2, a, e2) {
      var d2 = l2.coordinateSystem, y2 = l2.getData(), x2 = e2 / 2, C = l2.get("layout") === "horizontal" ? 0 : 1, D2 = 1 - C, L = ["x", "y"], F3 = y2.mapDimension(L[C]), j = y2.mapDimensionsAll(L[D2]);
      if (F3 == null || j.length < 5)
        return;
      for (var U3 = 0; U3 < y2.count(); U3++) {
        var Y3 = y2.get(F3, U3), Q = jt(Y3, j[2], U3), nt = jt(Y3, j[0], U3), dt = jt(Y3, j[1], U3), vt = jt(Y3, j[3], U3), Ct = jt(Y3, j[4], U3), Pt = [];
        Rt(Pt, dt, false), Rt(Pt, vt, true), Pt.push(nt, dt, Ct, vt), le2(Pt, nt), le2(Pt, Ct), le2(Pt, Q), y2.setItemLayout(U3, { initBaseline: Q[D2], ends: Pt });
      }
      function jt(ne2, he2, _e) {
        var Me2 = y2.get(he2, _e), Pe2 = [];
        Pe2[C] = ne2, Pe2[D2] = Me2;
        var Be2;
        return isNaN(ne2) || isNaN(Me2) ? Be2 = [NaN, NaN] : (Be2 = d2.dataToPoint(Pe2), Be2[C] += a), Be2;
      }
      function Rt(ne2, he2, _e) {
        var Me2 = he2.slice(), Pe2 = he2.slice();
        Me2[C] += x2, Pe2[C] -= x2, _e ? ne2.push(Me2, Pe2) : ne2.push(Pe2, Me2);
      }
      function le2(ne2, he2) {
        var _e = he2.slice(), Me2 = he2.slice();
        _e[C] -= x2, Me2[C] += x2, ne2.push(_e, Me2);
      }
    }
    function won(l2, a) {
      a = a || {};
      for (var e2 = [], d2 = [], y2 = a.boundIQR, x2 = y2 === "none" || y2 === 0, C = 0; C < l2.length; C++) {
        var D2 = k_(l2[C].slice()), L = oq(D2, 0.25), F3 = oq(D2, 0.5), j = oq(D2, 0.75), U3 = D2[0], Y3 = D2[D2.length - 1], Q = (y2 == null ? 1.5 : y2) * (j - L), nt = x2 ? U3 : Math.max(U3, L - Q), dt = x2 ? Y3 : Math.min(Y3, j + Q), vt = a.itemNameFormatter, Ct = wl(vt) ? vt({ value: C }) : ps(vt) ? vt.replace("{value}", C + "") : C + "";
        e2.push([Ct, nt, L, F3, j, dt]);
        for (var Pt = 0; Pt < D2.length; Pt++) {
          var jt = D2[Pt];
          if (jt < nt || jt > dt) {
            var Rt = [Ct, jt];
            d2.push(Rt);
          }
        }
      }
      return { boxData: e2, outliers: d2 };
    }
    var Son = { type: "echarts:boxplot", transform: function(l2) {
      var a = l2.upstream;
      if (a.sourceFormat !== sw) {
        var e2 = "";
        ih2(e2);
      }
      var d2 = won(a.getRawData(), l2.config);
      return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: d2.boxData }, { data: d2.outliers }];
    } };
    function Mon(l2) {
      l2.registerSeriesModel(fon), l2.registerChartView(von), l2.registerVisual(yon), l2.registerLayout(mon), l2.registerTransform(Son);
    }
    var Con = ["color", "borderColor"], Ton = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(e2), this._isLargeDraw ? this._renderLarge(e2) : this._renderNormal(e2);
      }, a.prototype.incrementalPrepareRender = function(e2, d2, y2) {
        this._clear(), this._updateDrawMode(e2);
      }, a.prototype.incrementalRender = function(e2, d2, y2, x2) {
        this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(e2, d2) : this._incrementalRenderNormal(e2, d2);
      }, a.prototype.eachRendered = function(e2) {
        qN(this._progressiveEls || this.group, e2);
      }, a.prototype._updateDrawMode = function(e2) {
        var d2 = e2.pipelineContext.large;
        (this._isLargeDraw == null || d2 !== this._isLargeDraw) && (this._isLargeDraw = d2, this._clear());
      }, a.prototype._renderNormal = function(e2) {
        var d2 = e2.getData(), y2 = this._data, x2 = this.group, C = d2.getLayout("isSimpleBox"), D2 = e2.get("clip", true), L = e2.coordinateSystem, F3 = L.getArea && L.getArea();
        this._data || x2.removeAll(), d2.diff(y2).add(function(j) {
          if (d2.hasValue(j)) {
            var U3 = d2.getItemLayout(j);
            if (D2 && pfe(F3, U3))
              return;
            var Y3 = w4t(U3, j, true);
            Yg2(Y3, { shape: { points: U3.ends } }, e2, j), S4t(Y3, d2, j, C), x2.add(Y3), d2.setItemGraphicEl(j, Y3);
          }
        }).update(function(j, U3) {
          var Y3 = y2.getItemGraphicEl(U3);
          if (!d2.hasValue(j)) {
            x2.remove(Y3);
            return;
          }
          var Q = d2.getItemLayout(j);
          if (D2 && pfe(F3, Q)) {
            x2.remove(Y3);
            return;
          }
          Y3 ? (Yf2(Y3, { shape: { points: Q.ends } }, e2, j), pC(Y3)) : Y3 = w4t(Q), S4t(Y3, d2, j, C), x2.add(Y3), d2.setItemGraphicEl(j, Y3);
        }).remove(function(j) {
          var U3 = y2.getItemGraphicEl(j);
          U3 && x2.remove(U3);
        }).execute(), this._data = d2;
      }, a.prototype._renderLarge = function(e2) {
        this._clear(), gfe(e2, this.group);
        var d2 = e2.get("clip", true) ? Xyt(e2.coordinateSystem, false, e2) : null;
        d2 ? this.group.setClipPath(d2) : this.group.removeClipPath();
      }, a.prototype._incrementalRenderNormal = function(e2, d2) {
        for (var y2 = d2.getData(), x2 = y2.getLayout("isSimpleBox"), C; (C = e2.next()) != null; ) {
          var D2 = y2.getItemLayout(C), L = w4t(D2);
          S4t(L, y2, C, x2), L.incremental = true, this.group.add(L), this._progressiveEls.push(L);
        }
      }, a.prototype._incrementalRenderLarge = function(e2, d2) {
        gfe(d2, this.group, this._progressiveEls, true);
      }, a.prototype.remove = function(e2) {
        this._clear();
      }, a.prototype._clear = function() {
        this.group.removeAll(), this._data = null;
      }, a.type = "candlestick", a;
    }(pg2), Aon = function() {
      function l2() {
      }
      return l2;
    }(), Ion = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "normalCandlestickBox", d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new Aon();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.points;
        this.__simpleBox ? (e2.moveTo(y2[4][0], y2[4][1]), e2.lineTo(y2[6][0], y2[6][1])) : (e2.moveTo(y2[0][0], y2[0][1]), e2.lineTo(y2[1][0], y2[1][1]), e2.lineTo(y2[2][0], y2[2][1]), e2.lineTo(y2[3][0], y2[3][1]), e2.closePath(), e2.moveTo(y2[4][0], y2[4][1]), e2.lineTo(y2[5][0], y2[5][1]), e2.moveTo(y2[6][0], y2[6][1]), e2.lineTo(y2[7][0], y2[7][1]));
      }, a;
    }(wc2);
    function w4t(l2, a, e2) {
      var d2 = l2.ends;
      return new Ion({ shape: { points: e2 ? Don(d2, l2) : d2 }, z2: 100 });
    }
    function pfe(l2, a) {
      for (var e2 = true, d2 = 0; d2 < a.ends.length; d2++)
        if (l2.contain(a.ends[d2][0], a.ends[d2][1])) {
          e2 = false;
          break;
        }
      return e2;
    }
    function S4t(l2, a, e2, d2) {
      var y2 = a.getItemModel(e2);
      l2.useStyle(a.getItemVisual(e2, "style")), l2.style.strokeNoScale = true, l2.__simpleBox = d2, Gy(l2, y2);
    }
    function Don(l2, a) {
      return $a2(l2, function(e2) {
        return e2 = e2.slice(), e2[1] = a.initBaseline, e2;
      });
    }
    var Eon = function() {
      function l2() {
      }
      return l2;
    }(), dfe = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2.type = "largeCandlestickBox", d2;
      }
      return a.prototype.getDefaultShape = function() {
        return new Eon();
      }, a.prototype.buildPath = function(e2, d2) {
        for (var y2 = d2.points, x2 = 0; x2 < y2.length; )
          if (this.__sign === y2[x2++]) {
            var C = y2[x2++];
            e2.moveTo(C, y2[x2++]), e2.lineTo(C, y2[x2++]);
          } else
            x2 += 3;
      }, a;
    }(wc2);
    function gfe(l2, a, e2, d2) {
      var y2 = l2.getData(), x2 = y2.getLayout("largePoints"), C = new dfe({ shape: { points: x2 }, __sign: 1 });
      a.add(C);
      var D2 = new dfe({ shape: { points: x2 }, __sign: -1 });
      a.add(D2), vfe(1, C, l2), vfe(-1, D2, l2), d2 && (C.incremental = true, D2.incremental = true), e2 && e2.push(C, D2);
    }
    function vfe(l2, a, e2, d2) {
      var y2 = e2.get(["itemStyle", l2 > 0 ? "borderColor" : "borderColor0"]) || e2.get(["itemStyle", l2 > 0 ? "color" : "color0"]), x2 = e2.getModel("itemStyle").getItemStyle(Con);
      a.useStyle(x2), a.style.fill = null, a.style.stroke = y2;
    }
    var kon = Ton, yfe = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], e2;
      }
      return a.prototype.getShadowDim = function() {
        return "open";
      }, a.prototype.brushSelector = function(e2, d2, y2) {
        var x2 = d2.getItemLayout(e2);
        return x2 && y2.rect(x2.brushRect);
      }, a.type = "series.candlestick", a.dependencies = ["xAxis", "yAxis", "grid"], a.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, a;
    }(Pv);
    v0(yfe, ufe, true);
    var Pon = yfe;
    function Lon(l2) {
      !l2 || !Ba2(l2.series) || Ke2(l2.series, function(a) {
        vs(a) && a.type === "k" && (a.type = "candlestick");
      });
    }
    var Oon = ["itemStyle", "borderColor"], Ron = ["itemStyle", "borderColor0"], Non = ["itemStyle", "color"], Fon = ["itemStyle", "color0"], Von = { seriesType: "candlestick", plan: Kq(), performRawSeries: true, reset: function(l2, a) {
      function e2(x2, C) {
        return C.get(x2 > 0 ? Non : Fon);
      }
      function d2(x2, C) {
        return C.get(x2 > 0 ? Oon : Ron);
      }
      if (!a.isSeriesFiltered(l2)) {
        var y2 = l2.pipelineContext.large;
        return !y2 && { progress: function(x2, C) {
          for (var D2; (D2 = x2.next()) != null; ) {
            var L = C.getItemModel(D2), F3 = C.getItemLayout(D2).sign, j = L.getItemStyle();
            j.fill = e2(F3, L), j.stroke = d2(F3, L) || j.fill;
            var U3 = C.ensureUniqueItemVisual(D2, "style");
            la2(U3, j);
          }
        } };
      }
    } }, Bon = Von, zon = { seriesType: "candlestick", plan: Kq(), reset: function(l2) {
      var a = l2.coordinateSystem, e2 = l2.getData(), d2 = jon(l2, e2), y2 = 0, x2 = 1, C = ["x", "y"], D2 = e2.getDimensionIndex(e2.mapDimension(C[y2])), L = $a2(e2.mapDimensionsAll(C[x2]), e2.getDimensionIndex, e2), F3 = L[0], j = L[1], U3 = L[2], Y3 = L[3];
      if (e2.setLayout({ candleWidth: d2, isSimpleBox: d2 <= 1.3 }), D2 < 0 || L.length < 4)
        return;
      return { progress: l2.pipelineContext.large ? nt : Q };
      function Q(dt, vt) {
        for (var Ct, Pt = vt.getStore(); (Ct = dt.next()) != null; ) {
          var jt = Pt.get(D2, Ct), Rt = Pt.get(F3, Ct), le2 = Pt.get(j, Ct), ne2 = Pt.get(U3, Ct), he2 = Pt.get(Y3, Ct), _e = Math.min(Rt, le2), Me2 = Math.max(Rt, le2), Pe2 = Bn(_e, jt), Be2 = Bn(Me2, jt), Je2 = Bn(ne2, jt), Ze2 = Bn(he2, jt), Cn = [];
          mn(Cn, Be2, 0), mn(Cn, Pe2, 1), Cn.push(Kn(Ze2), Kn(Be2), Kn(Je2), Kn(Pe2)), vt.setItemLayout(Ct, { sign: mfe(Pt, Ct, Rt, le2, j), initBaseline: Rt > le2 ? Be2[x2] : Pe2[x2], ends: Cn, brushRect: Kr(ne2, he2, jt) });
        }
        function Bn(ar, Cr) {
          var ui2 = [];
          return ui2[y2] = Cr, ui2[x2] = ar, isNaN(Cr) || isNaN(ar) ? [NaN, NaN] : a.dataToPoint(ui2);
        }
        function mn(ar, Cr, ui2) {
          var vi2 = Cr.slice(), ko = Cr.slice();
          vi2[y2] = su(vi2[y2] + d2 / 2, 1, false), ko[y2] = su(ko[y2] - d2 / 2, 1, true), ui2 ? ar.push(vi2, ko) : ar.push(ko, vi2);
        }
        function Kr(ar, Cr, ui2) {
          var vi2 = Bn(ar, ui2), ko = Bn(Cr, ui2);
          return vi2[y2] -= d2 / 2, ko[y2] -= d2 / 2, { x: vi2[0], y: vi2[1], width: d2, height: ko[1] - vi2[1] };
        }
        function Kn(ar) {
          return ar[y2] = su(ar[y2], 1), ar;
        }
      }
      function nt(dt, vt) {
        for (var Ct = lP(dt.count * 4), Pt = 0, jt, Rt = [], le2 = [], ne2, he2 = vt.getStore(); (ne2 = dt.next()) != null; ) {
          var _e = he2.get(D2, ne2), Me2 = he2.get(F3, ne2), Pe2 = he2.get(j, ne2), Be2 = he2.get(U3, ne2), Je2 = he2.get(Y3, ne2);
          if (isNaN(_e) || isNaN(Be2) || isNaN(Je2)) {
            Ct[Pt++] = NaN, Pt += 3;
            continue;
          }
          Ct[Pt++] = mfe(he2, ne2, Me2, Pe2, j), Rt[y2] = _e, Rt[x2] = Be2, jt = a.dataToPoint(Rt, null, le2), Ct[Pt++] = jt ? jt[0] : NaN, Ct[Pt++] = jt ? jt[1] : NaN, Rt[x2] = Je2, jt = a.dataToPoint(Rt, null, le2), Ct[Pt++] = jt ? jt[1] : NaN;
        }
        vt.setLayout("largePoints", Ct);
      }
    } };
    function mfe(l2, a, e2, d2, y2) {
      var x2;
      return e2 > d2 ? x2 = -1 : e2 < d2 ? x2 = 1 : x2 = a > 0 ? l2.get(y2, a - 1) <= d2 ? 1 : -1 : 1, x2;
    }
    function jon(l2, a) {
      var e2 = l2.getBaseAxis(), d2, y2 = e2.type === "category" ? e2.getBandWidth() : (d2 = e2.getExtent(), Math.abs(d2[1] - d2[0]) / a.count()), x2 = Ko($u(l2.get("barMaxWidth"), y2), y2), C = Ko($u(l2.get("barMinWidth"), 1), y2), D2 = l2.get("barWidth");
      return D2 != null ? Ko(D2, y2) : Math.max(Math.min(y2 / 2, x2), C);
    }
    var Won = zon;
    function Gon(l2) {
      l2.registerChartView(kon), l2.registerSeriesModel(Pon), l2.registerPreprocessor(Lon), l2.registerVisual(Bon), l2.registerLayout(Won);
    }
    function bfe(l2, a) {
      var e2 = a.rippleEffectColor || a.color;
      l2.eachChild(function(d2) {
        d2.attr({ z: a.z, zlevel: a.zlevel, style: { stroke: a.brushType === "stroke" ? e2 : null, fill: a.brushType === "fill" ? e2 : null } });
      });
    }
    var Hon = function(l2) {
      Jn(a, l2);
      function a(e2, d2) {
        var y2 = l2.call(this) || this, x2 = new zrt(e2, d2), C = new ou();
        return y2.add(x2), y2.add(C), y2.updateData(e2, d2), y2;
      }
      return a.prototype.stopEffectAnimation = function() {
        this.childAt(1).removeAll();
      }, a.prototype.startEffectAnimation = function(e2) {
        for (var d2 = e2.symbolType, y2 = e2.color, x2 = e2.rippleNumber, C = this.childAt(1), D2 = 0; D2 < x2; D2++) {
          var L = qy(d2, -1, -1, 2, 2, y2);
          L.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
          var F3 = -D2 / x2 * e2.period + e2.effectOffset;
          L.animate("", true).when(e2.period, { scaleX: e2.rippleScale / 2, scaleY: e2.rippleScale / 2 }).delay(F3).start(), L.animateStyle(true).when(e2.period, { opacity: 0 }).delay(F3).start(), C.add(L);
        }
        bfe(C, e2);
      }, a.prototype.updateEffectAnimation = function(e2) {
        for (var d2 = this._effectCfg, y2 = this.childAt(1), x2 = ["symbolType", "period", "rippleScale", "rippleNumber"], C = 0; C < x2.length; C++) {
          var D2 = x2[C];
          if (d2[D2] !== e2[D2]) {
            this.stopEffectAnimation(), this.startEffectAnimation(e2);
            return;
          }
        }
        bfe(y2, e2);
      }, a.prototype.highlight = function() {
        Dm(this);
      }, a.prototype.downplay = function() {
        fc2(this);
      }, a.prototype.getSymbolType = function() {
        var e2 = this.childAt(0);
        return e2 && e2.getSymbolType();
      }, a.prototype.updateData = function(e2, d2) {
        var y2 = this, x2 = e2.hostModel;
        this.childAt(0).updateData(e2, d2);
        var C = this.childAt(1), D2 = e2.getItemModel(d2), L = e2.getItemVisual(d2, "symbol"), F3 = brt(e2.getItemVisual(d2, "symbolSize")), j = e2.getItemVisual(d2, "style"), U3 = j && j.fill, Y3 = D2.getModel("emphasis");
        C.setScale(F3), C.traverse(function(vt) {
          vt.setStyle("fill", U3);
        });
        var Q = tZ(e2.getItemVisual(d2, "symbolOffset"), F3);
        Q && (C.x = Q[0], C.y = Q[1]);
        var nt = e2.getItemVisual(d2, "symbolRotate");
        C.rotation = (nt || 0) * Math.PI / 180 || 0;
        var dt = {};
        dt.showEffectOn = x2.get("showEffectOn"), dt.rippleScale = D2.get(["rippleEffect", "scale"]), dt.brushType = D2.get(["rippleEffect", "brushType"]), dt.period = D2.get(["rippleEffect", "period"]) * 1e3, dt.effectOffset = d2 / e2.count(), dt.z = x2.getShallow("z") || 0, dt.zlevel = x2.getShallow("zlevel") || 0, dt.symbolType = L, dt.color = U3, dt.rippleEffectColor = D2.get(["rippleEffect", "color"]), dt.rippleNumber = D2.get(["rippleEffect", "number"]), dt.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(dt) : this.startEffectAnimation(dt), this._effectCfg = dt) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(vt) {
          vt === "emphasis" ? dt.showEffectOn !== "render" && y2.startEffectAnimation(dt) : vt === "normal" && dt.showEffectOn !== "render" && y2.stopEffectAnimation();
        }), this._effectCfg = dt, n0(this, Y3.get("focus"), Y3.get("blurScope"), Y3.get("disabled"));
      }, a.prototype.fadeOut = function(e2) {
        e2 && e2();
      }, a;
    }(ou), Uon = Hon, qon = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function() {
        this._symbolDraw = new jrt(Uon);
      }, a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this._symbolDraw;
        C.updateData(x2, { clipShape: this._getClipShape(e2) }), this.group.add(C.group);
      }, a.prototype._getClipShape = function(e2) {
        var d2 = e2.coordinateSystem, y2 = d2 && d2.getArea && d2.getArea();
        return e2.get("clip", true) ? y2 : null;
      }, a.prototype.updateTransform = function(e2, d2, y2) {
        var x2 = e2.getData();
        this.group.dirty();
        var C = Wrt("").reset(e2, d2, y2);
        C.progress && C.progress({ start: 0, end: x2.count(), count: x2.count() }, x2), this._symbolDraw.updateLayout();
      }, a.prototype._updateGroupTransform = function(e2) {
        var d2 = e2.coordinateSystem;
        d2 && d2.getRoamTransform && (this.group.transform = V5t(d2.getRoamTransform()), this.group.decomposeTransform());
      }, a.prototype.remove = function(e2, d2) {
        this._symbolDraw && this._symbolDraw.remove(true);
      }, a.type = "effectScatter", a;
    }(pg2), Zon = qon, $on = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.hasSymbolVisual = true, e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        return PO(null, this, { useEncodeDefaulter: true });
      }, a.prototype.brushSelector = function(e2, d2, y2) {
        return y2.point(d2.getItemLayout(e2));
      }, a.type = "series.effectScatter", a.dependencies = ["grid", "polar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, a;
    }(Pv), Yon = $on;
    function Kon(l2) {
      l2.registerChartView(Zon), l2.registerSeriesModel(Yon), l2.registerLayout(Wrt("effectScatter"));
    }
    var Xon = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this) || this;
        return x2.add(x2.createLine(e2, d2, y2)), x2._updateEffectSymbol(e2, d2), x2;
      }
      return a.prototype.createLine = function(e2, d2, y2) {
        return new KOt(e2, d2, y2);
      }, a.prototype._updateEffectSymbol = function(e2, d2) {
        var y2 = e2.getItemModel(d2), x2 = y2.getModel("effect"), C = x2.get("symbolSize"), D2 = x2.get("symbol");
        Ba2(C) || (C = [C, C]);
        var L = e2.getItemVisual(d2, "style"), F3 = x2.get("color") || L && L.stroke, j = this.childAt(1);
        this._symbolType !== D2 && (this.remove(j), j = qy(D2, -0.5, -0.5, 1, 1, F3), j.z2 = 100, j.culling = true, this.add(j)), j && (j.setStyle("shadowColor", F3), j.setStyle(x2.getItemStyle(["color"])), j.scaleX = C[0], j.scaleY = C[1], j.setColor(F3), this._symbolType = D2, this._symbolScale = C, this._updateEffectAnimation(e2, x2, d2));
      }, a.prototype._updateEffectAnimation = function(e2, d2, y2) {
        var x2 = this.childAt(1);
        if (x2) {
          var C = e2.getItemLayout(y2), D2 = d2.get("period") * 1e3, L = d2.get("loop"), F3 = d2.get("constantSpeed"), j = jy(d2.get("delay"), function(Y3) {
            return Y3 / e2.count() * D2 / 3;
          });
          if (x2.ignore = true, this._updateAnimationPoints(x2, C), F3 > 0 && (D2 = this._getLineLength(x2) / F3 * 1e3), D2 !== this._period || L !== this._loop) {
            x2.stopAnimation();
            var U3 = void 0;
            wl(j) ? U3 = j(y2) : U3 = j, x2.__t > 0 && (U3 = -D2 * x2.__t), this._animateSymbol(x2, D2, U3, L);
          }
          this._period = D2, this._loop = L;
        }
      }, a.prototype._animateSymbol = function(e2, d2, y2, x2) {
        if (d2 > 0) {
          e2.__t = 0;
          var C = this, D2 = e2.animate("", x2).when(d2, { __t: 1 }).delay(y2).during(function() {
            C._updateSymbolPosition(e2);
          });
          x2 || D2.done(function() {
            C.remove(e2);
          }), D2.start();
        }
      }, a.prototype._getLineLength = function(e2) {
        return gE(e2.__p1, e2.__cp1) + gE(e2.__cp1, e2.__p2);
      }, a.prototype._updateAnimationPoints = function(e2, d2) {
        e2.__p1 = d2[0], e2.__p2 = d2[1], e2.__cp1 = d2[2] || [(d2[0][0] + d2[1][0]) / 2, (d2[0][1] + d2[1][1]) / 2];
      }, a.prototype.updateData = function(e2, d2, y2) {
        this.childAt(0).updateData(e2, d2, y2), this._updateEffectSymbol(e2, d2);
      }, a.prototype._updateSymbolPosition = function(e2) {
        var d2 = e2.__p1, y2 = e2.__p2, x2 = e2.__cp1, C = e2.__t, D2 = [e2.x, e2.y], L = D2.slice(), F3 = sp, j = Cm;
        D2[0] = F3(d2[0], x2[0], y2[0], C), D2[1] = F3(d2[1], x2[1], y2[1], C);
        var U3 = j(d2[0], x2[0], y2[0], C), Y3 = j(d2[1], x2[1], y2[1], C);
        e2.rotation = -Math.atan2(Y3, U3) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (e2.__lastT !== void 0 && e2.__lastT < e2.__t ? (e2.scaleY = gE(L, D2) * 1.05, C === 1 && (D2[0] = L[0] + (D2[0] - L[0]) / 2, D2[1] = L[1] + (D2[1] - L[1]) / 2)) : e2.__lastT === 1 ? e2.scaleY = 2 * gE(d2, D2) : e2.scaleY = this._symbolScale[1]), e2.__lastT = e2.__t, e2.ignore = false, e2.x = D2[0], e2.y = D2[1];
      }, a.prototype.updateLayout = function(e2, d2) {
        this.childAt(0).updateLayout(e2, d2);
        var y2 = e2.getItemModel(d2).getModel("effect");
        this._updateEffectAnimation(e2, y2, d2);
      }, a;
    }(ou), _fe = Xon, Qon = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2) {
        var x2 = l2.call(this) || this;
        return x2._createPolyline(e2, d2, y2), x2;
      }
      return a.prototype._createPolyline = function(e2, d2, y2) {
        var x2 = e2.getItemLayout(d2), C = new iw({ shape: { points: x2 } });
        this.add(C), this._updateCommonStl(e2, d2, y2);
      }, a.prototype.updateData = function(e2, d2, y2) {
        var x2 = e2.hostModel, C = this.childAt(0), D2 = { shape: { points: e2.getItemLayout(d2) } };
        Yf2(C, D2, x2, d2), this._updateCommonStl(e2, d2, y2);
      }, a.prototype._updateCommonStl = function(e2, d2, y2) {
        var x2 = this.childAt(0), C = e2.getItemModel(d2), D2 = y2 && y2.emphasisLineStyle, L = y2 && y2.focus, F3 = y2 && y2.blurScope, j = y2 && y2.emphasisDisabled;
        if (!y2 || e2.hasItemOption) {
          var U3 = C.getModel("emphasis");
          D2 = U3.getModel("lineStyle").getLineStyle(), j = U3.get("disabled"), L = U3.get("focus"), F3 = U3.get("blurScope");
        }
        x2.useStyle(e2.getItemVisual(d2, "style")), x2.style.fill = null, x2.style.strokeNoScale = true;
        var Y3 = x2.ensureState("emphasis");
        Y3.style = D2, n0(this, L, F3, j);
      }, a.prototype.updateLayout = function(e2, d2) {
        var y2 = this.childAt(0);
        y2.setShape("points", e2.getItemLayout(d2));
      }, a;
    }(ou), xfe = Qon, Jon = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2._lastFrame = 0, e2._lastFramePercent = 0, e2;
      }
      return a.prototype.createLine = function(e2, d2, y2) {
        return new xfe(e2, d2, y2);
      }, a.prototype._updateAnimationPoints = function(e2, d2) {
        this._points = d2;
        for (var y2 = [0], x2 = 0, C = 1; C < d2.length; C++) {
          var D2 = d2[C - 1], L = d2[C];
          x2 += gE(D2, L), y2.push(x2);
        }
        if (x2 === 0) {
          this._length = 0;
          return;
        }
        for (var C = 0; C < y2.length; C++)
          y2[C] /= x2;
        this._offsets = y2, this._length = x2;
      }, a.prototype._getLineLength = function() {
        return this._length;
      }, a.prototype._updateSymbolPosition = function(e2) {
        var d2 = e2.__t, y2 = this._points, x2 = this._offsets, C = y2.length;
        if (x2) {
          var D2 = this._lastFrame, L;
          if (d2 < this._lastFramePercent) {
            var F3 = Math.min(D2 + 1, C - 1);
            for (L = F3; L >= 0 && !(x2[L] <= d2); L--)
              ;
            L = Math.min(L, C - 2);
          } else {
            for (L = D2; L < C && !(x2[L] > d2); L++)
              ;
            L = Math.min(L - 1, C - 2);
          }
          var j = (d2 - x2[L]) / (x2[L + 1] - x2[L]), U3 = y2[L], Y3 = y2[L + 1];
          e2.x = U3[0] * (1 - j) + j * Y3[0], e2.y = U3[1] * (1 - j) + j * Y3[1];
          var Q = Y3[0] - U3[0], nt = Y3[1] - U3[1];
          e2.rotation = -Math.atan2(nt, Q) - Math.PI / 2, this._lastFrame = L, this._lastFramePercent = d2, e2.ignore = false;
        }
      }, a;
    }(_fe), tsn = Jon, esn = function() {
      function l2() {
        this.polyline = false, this.curveness = 0, this.segs = [];
      }
      return l2;
    }(), nsn = function(l2) {
      Jn(a, l2);
      function a(e2) {
        var d2 = l2.call(this, e2) || this;
        return d2._off = 0, d2.hoverDataIdx = -1, d2;
      }
      return a.prototype.reset = function() {
        this.notClear = false, this._off = 0;
      }, a.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, a.prototype.getDefaultShape = function() {
        return new esn();
      }, a.prototype.buildPath = function(e2, d2) {
        var y2 = d2.segs, x2 = d2.curveness, C;
        if (d2.polyline)
          for (C = this._off; C < y2.length; ) {
            var D2 = y2[C++];
            if (D2 > 0) {
              e2.moveTo(y2[C++], y2[C++]);
              for (var L = 1; L < D2; L++)
                e2.lineTo(y2[C++], y2[C++]);
            }
          }
        else
          for (C = this._off; C < y2.length; ) {
            var F3 = y2[C++], j = y2[C++], U3 = y2[C++], Y3 = y2[C++];
            if (e2.moveTo(F3, j), x2 > 0) {
              var Q = (F3 + U3) / 2 - (j - Y3) * x2, nt = (j + Y3) / 2 - (U3 - F3) * x2;
              e2.quadraticCurveTo(Q, nt, U3, Y3);
            } else
              e2.lineTo(U3, Y3);
          }
        this.incremental && (this._off = C, this.notClear = true);
      }, a.prototype.findDataIndex = function(e2, d2) {
        var y2 = this.shape, x2 = y2.segs, C = y2.curveness, D2 = this.style.lineWidth;
        if (y2.polyline)
          for (var L = 0, F3 = 0; F3 < x2.length; ) {
            var j = x2[F3++];
            if (j > 0)
              for (var U3 = x2[F3++], Y3 = x2[F3++], Q = 1; Q < j; Q++) {
                var nt = x2[F3++], dt = x2[F3++];
                if (Q5(U3, Y3, nt, dt, D2, e2, d2))
                  return L;
              }
            L++;
          }
        else
          for (var L = 0, F3 = 0; F3 < x2.length; ) {
            var U3 = x2[F3++], Y3 = x2[F3++], nt = x2[F3++], dt = x2[F3++];
            if (C > 0) {
              var vt = (U3 + nt) / 2 - (Y3 - dt) * C, Ct = (Y3 + dt) / 2 - (nt - U3) * C;
              if (r0t(U3, Y3, vt, Ct, nt, dt, D2, e2, d2))
                return L;
            } else if (Q5(U3, Y3, nt, dt, D2, e2, d2))
              return L;
            L++;
          }
        return -1;
      }, a.prototype.contain = function(e2, d2) {
        var y2 = this.transformCoordToLocal(e2, d2), x2 = this.getBoundingRect();
        if (e2 = y2[0], d2 = y2[1], x2.contain(e2, d2)) {
          var C = this.hoverDataIdx = this.findDataIndex(e2, d2);
          return C >= 0;
        }
        return this.hoverDataIdx = -1, false;
      }, a.prototype.getBoundingRect = function() {
        var e2 = this._rect;
        if (!e2) {
          for (var d2 = this.shape, y2 = d2.segs, x2 = 1 / 0, C = 1 / 0, D2 = -1 / 0, L = -1 / 0, F3 = 0; F3 < y2.length; ) {
            var j = y2[F3++], U3 = y2[F3++];
            x2 = Math.min(j, x2), D2 = Math.max(j, D2), C = Math.min(U3, C), L = Math.max(U3, L);
          }
          e2 = this._rect = new Yu(x2, C, D2, L);
        }
        return e2;
      }, a;
    }(wc2), rsn = function() {
      function l2() {
        this.group = new ou();
      }
      return l2.prototype.updateData = function(a) {
        this._clear();
        var e2 = this._create();
        e2.setShape({ segs: a.getLayout("linesPoints") }), this._setCommon(e2, a);
      }, l2.prototype.incrementalPrepareUpdate = function(a) {
        this.group.removeAll(), this._clear();
      }, l2.prototype.incrementalUpdate = function(a, e2) {
        var d2 = this._newAdded[0], y2 = e2.getLayout("linesPoints"), x2 = d2 && d2.shape.segs;
        if (x2 && x2.length < 2e4) {
          var C = x2.length, D2 = new Float32Array(C + y2.length);
          D2.set(x2), D2.set(y2, C), d2.setShape({ segs: D2 });
        } else {
          this._newAdded = [];
          var L = this._create();
          L.incremental = true, L.setShape({ segs: y2 }), this._setCommon(L, e2), L.__startIndex = a.start;
        }
      }, l2.prototype.remove = function() {
        this._clear();
      }, l2.prototype.eachRendered = function(a) {
        this._newAdded[0] && a(this._newAdded[0]);
      }, l2.prototype._create = function() {
        var a = new nsn({ cursor: "default" });
        return this._newAdded.push(a), this.group.add(a), a;
      }, l2.prototype._setCommon = function(a, e2, d2) {
        var y2 = e2.hostModel;
        a.setShape({ polyline: y2.get("polyline"), curveness: y2.get(["lineStyle", "curveness"]) }), a.useStyle(y2.getModel("lineStyle").getLineStyle()), a.style.strokeNoScale = true;
        var x2 = e2.getVisual("style");
        x2 && x2.stroke && a.setStyle("stroke", x2.stroke), a.setStyle("fill", null);
        var C = ns(a);
        C.seriesIndex = y2.seriesIndex, a.on("mousemove", function(D2) {
          C.dataIndex = null;
          var L = a.hoverDataIdx;
          L > 0 && (C.dataIndex = L + a.__startIndex);
        });
      }, l2.prototype._clear = function() {
        this._newAdded = [], this.group.removeAll();
      }, l2;
    }(), isn = rsn, asn = { seriesType: "lines", plan: Kq(), reset: function(l2) {
      var a = l2.coordinateSystem;
      if (a) {
        var e2 = l2.get("polyline"), d2 = l2.pipelineContext.large;
        return { progress: function(y2, x2) {
          var C = [];
          if (d2) {
            var D2 = void 0, L = y2.end - y2.start;
            if (e2) {
              for (var F3 = 0, j = y2.start; j < y2.end; j++)
                F3 += l2.getLineCoordsCount(j);
              D2 = new Float32Array(L + F3 * 2);
            } else
              D2 = new Float32Array(L * 4);
            for (var U3 = 0, Y3 = [], j = y2.start; j < y2.end; j++) {
              var Q = l2.getLineCoords(j, C);
              e2 && (D2[U3++] = Q);
              for (var nt = 0; nt < Q; nt++)
                Y3 = a.dataToPoint(C[nt], false, Y3), D2[U3++] = Y3[0], D2[U3++] = Y3[1];
            }
            x2.setLayout("linesPoints", D2);
          } else
            for (var j = y2.start; j < y2.end; j++) {
              var dt = x2.getItemModel(j), Q = l2.getLineCoords(j, C), vt = [];
              if (e2)
                for (var Ct = 0; Ct < Q; Ct++)
                  vt.push(a.dataToPoint(C[Ct]));
              else {
                vt[0] = a.dataToPoint(C[0]), vt[1] = a.dataToPoint(C[1]);
                var Pt = dt.get(["lineStyle", "curveness"]);
                +Pt && (vt[2] = [(vt[0][0] + vt[1][0]) / 2 - (vt[0][1] - vt[1][1]) * Pt, (vt[0][1] + vt[1][1]) / 2 - (vt[1][0] - vt[0][0]) * Pt]);
              }
              x2.setItemLayout(j, vt);
            }
        } };
      }
    } }, wfe = asn, osn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this._updateLineDraw(x2, e2), D2 = e2.get("zlevel"), L = e2.get(["effect", "trailLength"]), F3 = y2.getZr(), j = F3.painter.getType() === "svg";
        j || F3.painter.getLayer(D2).clear(true), this._lastZlevel != null && !j && F3.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(e2) && L > 0 && (j || F3.configLayer(D2, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(L / 10 + 0.9, 1), 0) })), C.updateData(x2);
        var U3 = e2.get("clip", true) && Xyt(e2.coordinateSystem, false, e2);
        U3 ? this.group.setClipPath(U3) : this.group.removeClipPath(), this._lastZlevel = D2, this._finished = true;
      }, a.prototype.incrementalPrepareRender = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this._updateLineDraw(x2, e2);
        C.incrementalPrepareUpdate(x2), this._clearLayer(y2), this._finished = false;
      }, a.prototype.incrementalRender = function(e2, d2, y2) {
        this._lineDraw.incrementalUpdate(e2, d2.getData()), this._finished = e2.end === d2.getData().count();
      }, a.prototype.eachRendered = function(e2) {
        this._lineDraw && this._lineDraw.eachRendered(e2);
      }, a.prototype.updateTransform = function(e2, d2, y2) {
        var x2 = e2.getData(), C = e2.pipelineContext;
        if (!this._finished || C.large || C.progressiveRender)
          return { update: true };
        var D2 = wfe.reset(e2, d2, y2);
        D2.progress && D2.progress({ start: 0, end: x2.count(), count: x2.count() }, x2), this._lineDraw.updateLayout(), this._clearLayer(y2);
      }, a.prototype._updateLineDraw = function(e2, d2) {
        var y2 = this._lineDraw, x2 = this._showEffect(d2), C = !!d2.get("polyline"), D2 = d2.pipelineContext, L = D2.large;
        return (!y2 || x2 !== this._hasEffet || C !== this._isPolyline || L !== this._isLargeDraw) && (y2 && y2.remove(), y2 = this._lineDraw = L ? new isn() : new QOt(C ? x2 ? tsn : xfe : x2 ? _fe : KOt), this._hasEffet = x2, this._isPolyline = C, this._isLargeDraw = L), this.group.add(y2.group), y2;
      }, a.prototype._showEffect = function(e2) {
        return !!e2.get(["effect", "show"]);
      }, a.prototype._clearLayer = function(e2) {
        var d2 = e2.getZr(), y2 = d2.painter.getType() === "svg";
        !y2 && this._lastZlevel != null && d2.painter.getLayer(this._lastZlevel).clear(true);
      }, a.prototype.remove = function(e2, d2) {
        this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(d2);
      }, a.prototype.dispose = function(e2, d2) {
        this.remove(e2, d2);
      }, a.type = "lines", a;
    }(pg2), ssn = osn, lsn = typeof Uint32Array == "undefined" ? Array : Uint32Array, usn = typeof Float64Array == "undefined" ? Array : Float64Array;
    function Sfe(l2) {
      var a = l2.data;
      a && a[0] && a[0][0] && a[0][0].coord && (l2.data = $a2(a, function(e2) {
        var d2 = [e2[0].coord, e2[1].coord], y2 = { coords: d2 };
        return e2[0].name && (y2.fromName = e2[0].name), e2[1].name && (y2.toName = e2[1].name), IU([y2, e2[0], e2[1]]);
      }));
    }
    var csn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.visualStyleAccessPath = "lineStyle", e2.visualDrawType = "stroke", e2;
      }
      return a.prototype.init = function(e2) {
        e2.data = e2.data || [], Sfe(e2);
        var d2 = this._processFlatCoordsArray(e2.data);
        this._flatCoords = d2.flatCoords, this._flatCoordsOffset = d2.flatCoordsOffset, d2.flatCoords && (e2.data = new Float32Array(d2.count)), l2.prototype.init.apply(this, arguments);
      }, a.prototype.mergeOption = function(e2) {
        if (Sfe(e2), e2.data) {
          var d2 = this._processFlatCoordsArray(e2.data);
          this._flatCoords = d2.flatCoords, this._flatCoordsOffset = d2.flatCoordsOffset, d2.flatCoords && (e2.data = new Float32Array(d2.count));
        }
        l2.prototype.mergeOption.apply(this, arguments);
      }, a.prototype.appendData = function(e2) {
        var d2 = this._processFlatCoordsArray(e2.data);
        d2.flatCoords && (this._flatCoords ? (this._flatCoords = EU(this._flatCoords, d2.flatCoords), this._flatCoordsOffset = EU(this._flatCoordsOffset, d2.flatCoordsOffset)) : (this._flatCoords = d2.flatCoords, this._flatCoordsOffset = d2.flatCoordsOffset), e2.data = new Float32Array(d2.count)), this.getRawData().appendData(e2.data);
      }, a.prototype._getCoordsFromItemModel = function(e2) {
        var d2 = this.getData().getItemModel(e2), y2 = d2.option instanceof Array ? d2.option : d2.getShallow("coords");
        return y2;
      }, a.prototype.getLineCoordsCount = function(e2) {
        return this._flatCoordsOffset ? this._flatCoordsOffset[e2 * 2 + 1] : this._getCoordsFromItemModel(e2).length;
      }, a.prototype.getLineCoords = function(e2, d2) {
        if (this._flatCoordsOffset) {
          for (var y2 = this._flatCoordsOffset[e2 * 2], x2 = this._flatCoordsOffset[e2 * 2 + 1], C = 0; C < x2; C++)
            d2[C] = d2[C] || [], d2[C][0] = this._flatCoords[y2 + C * 2], d2[C][1] = this._flatCoords[y2 + C * 2 + 1];
          return x2;
        } else {
          for (var D2 = this._getCoordsFromItemModel(e2), C = 0; C < D2.length; C++)
            d2[C] = d2[C] || [], d2[C][0] = D2[C][0], d2[C][1] = D2[C][1];
          return D2.length;
        }
      }, a.prototype._processFlatCoordsArray = function(e2) {
        var d2 = 0;
        if (this._flatCoords && (d2 = this._flatCoords.length), Ch2(e2[0])) {
          for (var y2 = e2.length, x2 = new lsn(y2), C = new usn(y2), D2 = 0, L = 0, F3 = 0, j = 0; j < y2; ) {
            F3++;
            var U3 = e2[j++];
            x2[L++] = D2 + d2, x2[L++] = U3;
            for (var Y3 = 0; Y3 < U3; Y3++) {
              var Q = e2[j++], nt = e2[j++];
              C[D2++] = Q, C[D2++] = nt;
            }
          }
          return { flatCoordsOffset: new Uint32Array(x2.buffer, 0, L), flatCoords: C, count: F3 };
        }
        return { flatCoordsOffset: null, flatCoords: null, count: e2.length };
      }, a.prototype.getInitialData = function(e2, d2) {
        var y2 = new jS(["value"], this);
        return y2.hasItemOption = false, y2.initData(e2.data, [], function(x2, C, D2, L) {
          if (x2 instanceof Array)
            return NaN;
          y2.hasItemOption = true;
          var F3 = x2.value;
          if (F3 != null)
            return F3 instanceof Array ? F3[L] : F3;
        }), y2;
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        var x2 = this.getData(), C = x2.getItemModel(e2), D2 = C.get("name");
        if (D2)
          return D2;
        var L = C.get("fromName"), F3 = C.get("toName"), j = [];
        return L != null && j.push(L), F3 != null && j.push(F3), b1("nameValue", { name: j.join(" > ") });
      }, a.prototype.preventIncremental = function() {
        return !!this.get(["effect", "show"]);
      }, a.prototype.getProgressive = function() {
        var e2 = this.option.progressive;
        return e2 == null ? this.option.large ? 1e4 : this.get("progressive") : e2;
      }, a.prototype.getProgressiveThreshold = function() {
        var e2 = this.option.progressiveThreshold;
        return e2 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : e2;
      }, a.prototype.getZLevelKey = function() {
        var e2 = this.getModel("effect"), d2 = e2.get("trailLength");
        return this.getData().count() > this.getProgressiveThreshold() ? this.id : e2.get("show") && d2 > 0 ? d2 + "" : "";
      }, a.type = "series.lines", a.dependencies = ["grid", "polar", "geo", "calendar"], a.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, a;
    }(Pv), fsn = csn;
    function Smt(l2) {
      return l2 instanceof Array || (l2 = [l2, l2]), l2;
    }
    var hsn = { seriesType: "lines", reset: function(l2) {
      var a = Smt(l2.get("symbol")), e2 = Smt(l2.get("symbolSize")), d2 = l2.getData();
      d2.setVisual("fromSymbol", a && a[0]), d2.setVisual("toSymbol", a && a[1]), d2.setVisual("fromSymbolSize", e2 && e2[0]), d2.setVisual("toSymbolSize", e2 && e2[1]);
      function y2(x2, C) {
        var D2 = x2.getItemModel(C), L = Smt(D2.getShallow("symbol", true)), F3 = Smt(D2.getShallow("symbolSize", true));
        L[0] && x2.setItemVisual(C, "fromSymbol", L[0]), L[1] && x2.setItemVisual(C, "toSymbol", L[1]), F3[0] && x2.setItemVisual(C, "fromSymbolSize", F3[0]), F3[1] && x2.setItemVisual(C, "toSymbolSize", F3[1]);
      }
      return { dataEach: d2.hasItemOption ? y2 : null };
    } }, psn = hsn;
    function dsn(l2) {
      l2.registerChartView(ssn), l2.registerSeriesModel(fsn), l2.registerLayout(wfe), l2.registerVisual(psn);
    }
    var gsn = 256, vsn = function() {
      function l2() {
        this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
        var a = Zx.createCanvas();
        this.canvas = a;
      }
      return l2.prototype.update = function(a, e2, d2, y2, x2, C) {
        var D2 = this._getBrush(), L = this._getGradient(x2, "inRange"), F3 = this._getGradient(x2, "outOfRange"), j = this.pointSize + this.blurSize, U3 = this.canvas, Y3 = U3.getContext("2d"), Q = a.length;
        U3.width = e2, U3.height = d2;
        for (var nt = 0; nt < Q; ++nt) {
          var dt = a[nt], vt = dt[0], Ct = dt[1], Pt = dt[2], jt = y2(Pt);
          Y3.globalAlpha = jt, Y3.drawImage(D2, vt - j, Ct - j);
        }
        if (!U3.width || !U3.height)
          return U3;
        for (var Rt = Y3.getImageData(0, 0, U3.width, U3.height), le2 = Rt.data, ne2 = 0, he2 = le2.length, _e = this.minOpacity, Me2 = this.maxOpacity, Pe2 = Me2 - _e; ne2 < he2; ) {
          var jt = le2[ne2 + 3] / 256, Be2 = Math.floor(jt * (gsn - 1)) * 4;
          if (jt > 0) {
            var Je2 = C(jt) ? L : F3;
            jt > 0 && (jt = jt * Pe2 + _e), le2[ne2++] = Je2[Be2], le2[ne2++] = Je2[Be2 + 1], le2[ne2++] = Je2[Be2 + 2], le2[ne2++] = Je2[Be2 + 3] * jt * 256;
          } else
            ne2 += 4;
        }
        return Y3.putImageData(Rt, 0, 0), U3;
      }, l2.prototype._getBrush = function() {
        var a = this._brushCanvas || (this._brushCanvas = Zx.createCanvas()), e2 = this.pointSize + this.blurSize, d2 = e2 * 2;
        a.width = d2, a.height = d2;
        var y2 = a.getContext("2d");
        return y2.clearRect(0, 0, d2, d2), y2.shadowOffsetX = d2, y2.shadowBlur = this.blurSize, y2.shadowColor = "#000", y2.beginPath(), y2.arc(-e2, e2, this.pointSize, 0, Math.PI * 2, true), y2.closePath(), y2.fill(), a;
      }, l2.prototype._getGradient = function(a, e2) {
        for (var d2 = this._gradientPixels, y2 = d2[e2] || (d2[e2] = new Uint8ClampedArray(256 * 4)), x2 = [0, 0, 0, 0], C = 0, D2 = 0; D2 < 256; D2++)
          a[e2](D2 / 255, true, x2), y2[C++] = x2[0], y2[C++] = x2[1], y2[C++] = x2[2], y2[C++] = x2[3];
        return y2;
      }, l2;
    }(), ysn = vsn;
    function msn(l2, a, e2) {
      var d2 = l2[1] - l2[0];
      a = $a2(a, function(C) {
        return { interval: [(C.interval[0] - l2[0]) / d2, (C.interval[1] - l2[0]) / d2] };
      });
      var y2 = a.length, x2 = 0;
      return function(C) {
        var D2;
        for (D2 = x2; D2 < y2; D2++) {
          var L = a[D2].interval;
          if (L[0] <= C && C <= L[1]) {
            x2 = D2;
            break;
          }
        }
        if (D2 === y2)
          for (D2 = x2 - 1; D2 >= 0; D2--) {
            var L = a[D2].interval;
            if (L[0] <= C && C <= L[1]) {
              x2 = D2;
              break;
            }
          }
        return D2 >= 0 && D2 < y2 && e2[D2];
      };
    }
    function bsn(l2, a) {
      var e2 = l2[1] - l2[0];
      return a = [(a[0] - l2[0]) / e2, (a[1] - l2[0]) / e2], function(d2) {
        return d2 >= a[0] && d2 <= a[1];
      };
    }
    function Mfe(l2) {
      var a = l2.dimensions;
      return a[0] === "lng" && a[1] === "lat";
    }
    var _sn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2;
        d2.eachComponent("visualMap", function(D2) {
          D2.eachTargetSeries(function(L) {
            L === e2 && (x2 = D2);
          });
        }), this._progressiveEls = null, this.group.removeAll();
        var C = e2.coordinateSystem;
        C.type === "cartesian2d" || C.type === "calendar" ? this._renderOnCartesianAndCalendar(e2, y2, 0, e2.getData().count()) : Mfe(C) && this._renderOnGeo(C, e2, x2, y2);
      }, a.prototype.incrementalPrepareRender = function(e2, d2, y2) {
        this.group.removeAll();
      }, a.prototype.incrementalRender = function(e2, d2, y2, x2) {
        var C = d2.coordinateSystem;
        C && (Mfe(C) ? this.render(d2, y2, x2) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(d2, x2, e2.start, e2.end, true)));
      }, a.prototype.eachRendered = function(e2) {
        qN(this._progressiveEls || this.group, e2);
      }, a.prototype._renderOnCartesianAndCalendar = function(e2, d2, y2, x2, C) {
        var D2 = e2.coordinateSystem, L, F3, j, U3;
        if (OO(D2, "cartesian2d")) {
          var Y3 = D2.getAxis("x"), Q = D2.getAxis("y");
          L = Y3.getBandWidth(), F3 = Q.getBandWidth(), j = Y3.scale.getExtent(), U3 = Q.scale.getExtent();
        }
        for (var nt = this.group, dt = e2.getData(), vt = e2.getModel(["emphasis", "itemStyle"]).getItemStyle(), Ct = e2.getModel(["blur", "itemStyle"]).getItemStyle(), Pt = e2.getModel(["select", "itemStyle"]).getItemStyle(), jt = e2.get(["itemStyle", "borderRadius"]), Rt = Sb2(e2), le2 = e2.getModel("emphasis"), ne2 = le2.get("focus"), he2 = le2.get("blurScope"), _e = le2.get("disabled"), Me2 = OO(D2, "cartesian2d") ? [dt.mapDimension("x"), dt.mapDimension("y"), dt.mapDimension("value")] : [dt.mapDimension("time"), dt.mapDimension("value")], Pe2 = y2; Pe2 < x2; Pe2++) {
          var Be2 = void 0, Je2 = dt.getItemVisual(Pe2, "style");
          if (OO(D2, "cartesian2d")) {
            var Ze2 = dt.get(Me2[0], Pe2), Cn = dt.get(Me2[1], Pe2);
            if (isNaN(dt.get(Me2[2], Pe2)) || Ze2 < j[0] || Ze2 > j[1] || Cn < U3[0] || Cn > U3[1])
              continue;
            var Bn = D2.dataToPoint([Ze2, Cn]);
            Be2 = new Nf2({ shape: { x: Math.floor(Math.round(Bn[0]) - L / 2), y: Math.floor(Math.round(Bn[1]) - F3 / 2), width: Math.ceil(L), height: Math.ceil(F3) }, style: Je2 });
          } else {
            if (isNaN(dt.get(Me2[1], Pe2)))
              continue;
            Be2 = new Nf2({ z2: 1, shape: D2.dataToRect([dt.get(Me2[0], Pe2)]).contentShape, style: Je2 });
          }
          if (dt.hasItemOption) {
            var mn = dt.getItemModel(Pe2), Kr = mn.getModel("emphasis");
            vt = Kr.getModel("itemStyle").getItemStyle(), Ct = mn.getModel(["blur", "itemStyle"]).getItemStyle(), Pt = mn.getModel(["select", "itemStyle"]).getItemStyle(), jt = mn.get(["itemStyle", "borderRadius"]), ne2 = Kr.get("focus"), he2 = Kr.get("blurScope"), _e = Kr.get("disabled"), Rt = Sb2(mn);
          }
          Be2.shape.r = jt;
          var Kn = e2.getRawValue(Pe2), ar = "-";
          Kn && Kn[2] != null && (ar = Kn[2] + ""), ow(Be2, Rt, { labelFetcher: e2, labelDataIndex: Pe2, defaultOpacity: Je2.opacity, defaultText: ar }), Be2.ensureState("emphasis").style = vt, Be2.ensureState("blur").style = Ct, Be2.ensureState("select").style = Pt, n0(Be2, ne2, he2, _e), Be2.incremental = C, C && (Be2.states.emphasis.hoverLayer = true), nt.add(Be2), dt.setItemGraphicEl(Pe2, Be2), this._progressiveEls && this._progressiveEls.push(Be2);
        }
      }, a.prototype._renderOnGeo = function(e2, d2, y2, x2) {
        var C = y2.targetVisuals.inRange, D2 = y2.targetVisuals.outOfRange, L = d2.getData(), F3 = this._hmLayer || this._hmLayer || new ysn();
        F3.blurSize = d2.get("blurSize"), F3.pointSize = d2.get("pointSize"), F3.minOpacity = d2.get("minOpacity"), F3.maxOpacity = d2.get("maxOpacity");
        var j = e2.getViewRect().clone(), U3 = e2.getRoamTransform();
        j.applyTransform(U3);
        var Y3 = Math.max(j.x, 0), Q = Math.max(j.y, 0), nt = Math.min(j.width + j.x, x2.getWidth()), dt = Math.min(j.height + j.y, x2.getHeight()), vt = nt - Y3, Ct = dt - Q, Pt = [L.mapDimension("lng"), L.mapDimension("lat"), L.mapDimension("value")], jt = L.mapArray(Pt, function(he2, _e, Me2) {
          var Pe2 = e2.dataToPoint([he2, _e]);
          return Pe2[0] -= Y3, Pe2[1] -= Q, Pe2.push(Me2), Pe2;
        }), Rt = y2.getExtent(), le2 = y2.type === "visualMap.continuous" ? bsn(Rt, y2.option.range) : msn(Rt, y2.getPieceList(), y2.option.selected);
        F3.update(jt, vt, Ct, C.color.getNormalizer(), { inRange: C.color.getColorMapper(), outOfRange: D2.color.getColorMapper() }, le2);
        var ne2 = new Im({ style: { width: vt, height: Ct, x: Y3, y: Q, image: F3.canvas }, silent: true });
        this.group.add(ne2);
      }, a.type = "heatmap", a;
    }(pg2), xsn = _sn, wsn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        return PO(null, this, { generateCoord: "value" });
      }, a.prototype.preventIncremental = function() {
        var e2 = urt.get(this.get("coordinateSystem"));
        if (e2 && e2.dimensions)
          return e2.dimensions[0] === "lng" && e2.dimensions[1] === "lat";
      }, a.type = "series.heatmap", a.dependencies = ["grid", "geo", "calendar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, a;
    }(Pv), Ssn = wsn;
    function Msn(l2) {
      l2.registerChartView(xsn), l2.registerSeriesModel(Ssn);
    }
    var Csn = ["itemStyle", "borderWidth"], Cfe = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], M4t = new _A(), Tsn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = this.group, C = e2.getData(), D2 = this._data, L = e2.coordinateSystem, F3 = L.getBaseAxis(), j = F3.isHorizontal(), U3 = L.master.getRect(), Y3 = { ecSize: { width: y2.getWidth(), height: y2.getHeight() }, seriesModel: e2, coordSys: L, coordSysExtent: [[U3.x, U3.x + U3.width], [U3.y, U3.y + U3.height]], isHorizontal: j, valueDim: Cfe[+j], categoryDim: Cfe[1 - +j] };
        return C.diff(D2).add(function(Q) {
          if (C.hasValue(Q)) {
            var nt = Pfe(C, Q), dt = Tfe(C, Q, nt, Y3), vt = Lfe(C, Y3, dt);
            C.setItemGraphicEl(Q, vt), x2.add(vt), Nfe(vt, Y3, dt);
          }
        }).update(function(Q, nt) {
          var dt = D2.getItemGraphicEl(nt);
          if (!C.hasValue(Q)) {
            x2.remove(dt);
            return;
          }
          var vt = Pfe(C, Q), Ct = Tfe(C, Q, vt, Y3), Pt = Rfe(C, Ct);
          dt && Pt !== dt.__pictorialShapeStr && (x2.remove(dt), C.setItemGraphicEl(Q, null), dt = null), dt ? Lsn(dt, Y3, Ct) : dt = Lfe(C, Y3, Ct, true), C.setItemGraphicEl(Q, dt), dt.__pictorialSymbolMeta = Ct, x2.add(dt), Nfe(dt, Y3, Ct);
        }).remove(function(Q) {
          var nt = D2.getItemGraphicEl(Q);
          nt && Ofe(D2, Q, nt.__pictorialSymbolMeta.animationModel, nt);
        }).execute(), this._data = C, this.group;
      }, a.prototype.remove = function(e2, d2) {
        var y2 = this.group, x2 = this._data;
        e2.get("animation") ? x2 && x2.eachItemGraphicEl(function(C) {
          Ofe(x2, ns(C).dataIndex, e2, C);
        }) : y2.removeAll();
      }, a.type = "pictorialBar", a;
    }(pg2);
    function Tfe(l2, a, e2, d2) {
      var y2 = l2.getItemLayout(a), x2 = e2.get("symbolRepeat"), C = e2.get("symbolClip"), D2 = e2.get("symbolPosition") || "start", L = e2.get("symbolRotate"), F3 = (L || 0) * Math.PI / 180 || 0, j = e2.get("symbolPatternSize") || 2, U3 = e2.isAnimationEnabled(), Y3 = { dataIndex: a, layout: y2, itemModel: e2, symbolType: l2.getItemVisual(a, "symbol") || "circle", style: l2.getItemVisual(a, "style"), symbolClip: C, symbolRepeat: x2, symbolRepeatDirection: e2.get("symbolRepeatDirection"), symbolPatternSize: j, rotation: F3, animationModel: U3 ? e2 : null, hoverScale: U3 && e2.get(["emphasis", "scale"]), z2: e2.getShallow("z", true) || 0 };
      Asn(e2, x2, y2, d2, Y3), Isn(l2, a, y2, x2, C, Y3.boundingLength, Y3.pxSign, j, d2, Y3), Dsn(e2, Y3.symbolScale, F3, d2, Y3);
      var Q = Y3.symbolSize, nt = tZ(e2.get("symbolOffset"), Q);
      return Esn(e2, Q, y2, x2, C, nt, D2, Y3.valueLineWidth, Y3.boundingLength, Y3.repeatCutLength, d2, Y3), Y3;
    }
    function Asn(l2, a, e2, d2, y2) {
      var x2 = d2.valueDim, C = l2.get("symbolBoundingData"), D2 = d2.coordSys.getOtherAxis(d2.coordSys.getBaseAxis()), L = D2.toGlobalCoord(D2.dataToCoord(0)), F3 = 1 - +(e2[x2.wh] <= 0), j;
      if (Ba2(C)) {
        var U3 = [C4t(D2, C[0]) - L, C4t(D2, C[1]) - L];
        U3[1] < U3[0] && U3.reverse(), j = U3[F3];
      } else
        C != null ? j = C4t(D2, C) - L : a ? j = d2.coordSysExtent[x2.index][F3] - L : j = e2[x2.wh];
      y2.boundingLength = j, a && (y2.repeatCutLength = e2[x2.wh]), y2.pxSign = j > 0 ? 1 : -1;
    }
    function C4t(l2, a) {
      return l2.toGlobalCoord(l2.dataToCoord(l2.scale.parse(a)));
    }
    function Isn(l2, a, e2, d2, y2, x2, C, D2, L, F3) {
      var j = L.valueDim, U3 = L.categoryDim, Y3 = Math.abs(e2[U3.wh]), Q = l2.getItemVisual(a, "symbolSize"), nt;
      Ba2(Q) ? nt = Q.slice() : Q == null ? nt = ["100%", "100%"] : nt = [Q, Q], nt[U3.index] = Ko(nt[U3.index], Y3), nt[j.index] = Ko(nt[j.index], d2 ? Y3 : Math.abs(x2)), F3.symbolSize = nt;
      var dt = F3.symbolScale = [nt[0] / D2, nt[1] / D2];
      dt[j.index] *= (L.isHorizontal ? -1 : 1) * C;
    }
    function Dsn(l2, a, e2, d2, y2) {
      var x2 = l2.get(Csn) || 0;
      x2 && (M4t.attr({ scaleX: a[0], scaleY: a[1], rotation: e2 }), M4t.updateTransform(), x2 /= M4t.getLineScale(), x2 *= a[d2.valueDim.index]), y2.valueLineWidth = x2 || 0;
    }
    function Esn(l2, a, e2, d2, y2, x2, C, D2, L, F3, j, U3) {
      var Y3 = j.categoryDim, Q = j.valueDim, nt = U3.pxSign, dt = Math.max(a[Q.index] + D2, 0), vt = dt;
      if (d2) {
        var Ct = Math.abs(L), Pt = jy(l2.get("symbolMargin"), "15%") + "", jt = false;
        Pt.lastIndexOf("!") === Pt.length - 1 && (jt = true, Pt = Pt.slice(0, Pt.length - 1));
        var Rt = Ko(Pt, a[Q.index]), le2 = Math.max(dt + Rt * 2, 0), ne2 = jt ? 0 : Rt * 2, he2 = hA(d2), _e = he2 ? d2 : Ffe((Ct + ne2) / le2), Me2 = Ct - _e * dt;
        Rt = Me2 / 2 / (jt ? _e : Math.max(_e - 1, 1)), le2 = dt + Rt * 2, ne2 = jt ? 0 : Rt * 2, !he2 && d2 !== "fixed" && (_e = F3 ? Ffe((Math.abs(F3) + ne2) / le2) : 0), vt = _e * le2 - ne2, U3.repeatTimes = _e, U3.symbolMargin = Rt;
      }
      var Pe2 = nt * (vt / 2), Be2 = U3.pathPosition = [];
      Be2[Y3.index] = e2[Y3.wh] / 2, Be2[Q.index] = C === "start" ? Pe2 : C === "end" ? L - Pe2 : L / 2, x2 && (Be2[0] += x2[0], Be2[1] += x2[1]);
      var Je2 = U3.bundlePosition = [];
      Je2[Y3.index] = e2[Y3.xy], Je2[Q.index] = e2[Q.xy];
      var Ze2 = U3.barRectShape = la2({}, e2);
      Ze2[Q.wh] = nt * Math.max(Math.abs(e2[Q.wh]), Math.abs(Be2[Q.index] + Pe2)), Ze2[Y3.wh] = e2[Y3.wh];
      var Cn = U3.clipShape = {};
      Cn[Y3.xy] = -e2[Y3.xy], Cn[Y3.wh] = j.ecSize[Y3.wh], Cn[Q.xy] = 0, Cn[Q.wh] = e2[Q.wh];
    }
    function Afe(l2) {
      var a = l2.symbolPatternSize, e2 = qy(l2.symbolType, -a / 2, -a / 2, a, a);
      return e2.attr({ culling: true }), e2.type !== "image" && e2.setStyle({ strokeNoScale: true }), e2;
    }
    function Ife(l2, a, e2, d2) {
      var y2 = l2.__pictorialBundle, x2 = e2.symbolSize, C = e2.valueLineWidth, D2 = e2.pathPosition, L = a.valueDim, F3 = e2.repeatTimes || 0, j = 0, U3 = x2[a.valueDim.index] + C + e2.symbolMargin * 2;
      for (T4t(l2, function(dt) {
        dt.__pictorialAnimationIndex = j, dt.__pictorialRepeatTimes = F3, j < F3 ? vZ(dt, null, nt(j), e2, d2) : vZ(dt, null, { scaleX: 0, scaleY: 0 }, e2, d2, function() {
          y2.remove(dt);
        }), j++;
      }); j < F3; j++) {
        var Y3 = Afe(e2);
        Y3.__pictorialAnimationIndex = j, Y3.__pictorialRepeatTimes = F3, y2.add(Y3);
        var Q = nt(j);
        vZ(Y3, { x: Q.x, y: Q.y, scaleX: 0, scaleY: 0 }, { scaleX: Q.scaleX, scaleY: Q.scaleY, rotation: Q.rotation }, e2, d2);
      }
      function nt(dt) {
        var vt = D2.slice(), Ct = e2.pxSign, Pt = dt;
        return (e2.symbolRepeatDirection === "start" ? Ct > 0 : Ct < 0) && (Pt = F3 - 1 - dt), vt[L.index] = U3 * (Pt - F3 / 2 + 0.5) + D2[L.index], { x: vt[0], y: vt[1], scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1], rotation: e2.rotation };
      }
    }
    function Dfe(l2, a, e2, d2) {
      var y2 = l2.__pictorialBundle, x2 = l2.__pictorialMainPath;
      x2 ? vZ(x2, null, { x: e2.pathPosition[0], y: e2.pathPosition[1], scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1], rotation: e2.rotation }, e2, d2) : (x2 = l2.__pictorialMainPath = Afe(e2), y2.add(x2), vZ(x2, { x: e2.pathPosition[0], y: e2.pathPosition[1], scaleX: 0, scaleY: 0, rotation: e2.rotation }, { scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1] }, e2, d2));
    }
    function Efe(l2, a, e2) {
      var d2 = la2({}, a.barRectShape), y2 = l2.__pictorialBarRect;
      y2 ? vZ(y2, null, { shape: d2 }, a, e2) : (y2 = l2.__pictorialBarRect = new Nf2({ z2: 2, shape: d2, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), y2.disableMorphing = true, l2.add(y2));
    }
    function kfe(l2, a, e2, d2) {
      if (e2.symbolClip) {
        var y2 = l2.__pictorialClipPath, x2 = la2({}, e2.clipShape), C = a.valueDim, D2 = e2.animationModel, L = e2.dataIndex;
        if (y2)
          Yf2(y2, { shape: x2 }, D2, L);
        else {
          x2[C.wh] = 0, y2 = new Nf2({ shape: x2 }), l2.__pictorialBundle.setClipPath(y2), l2.__pictorialClipPath = y2;
          var F3 = {};
          F3[C.wh] = e2.clipShape[C.wh], nrt[d2 ? "updateProps" : "initProps"](y2, { shape: F3 }, D2, L);
        }
      }
    }
    function Pfe(l2, a) {
      var e2 = l2.getItemModel(a);
      return e2.getAnimationDelayParams = ksn, e2.isAnimationEnabled = Psn, e2;
    }
    function ksn(l2) {
      return { index: l2.__pictorialAnimationIndex, count: l2.__pictorialRepeatTimes };
    }
    function Psn() {
      return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
    }
    function Lfe(l2, a, e2, d2) {
      var y2 = new ou(), x2 = new ou();
      return y2.add(x2), y2.__pictorialBundle = x2, x2.x = e2.bundlePosition[0], x2.y = e2.bundlePosition[1], e2.symbolRepeat ? Ife(y2, a, e2) : Dfe(y2, a, e2), Efe(y2, e2, d2), kfe(y2, a, e2, d2), y2.__pictorialShapeStr = Rfe(l2, e2), y2.__pictorialSymbolMeta = e2, y2;
    }
    function Lsn(l2, a, e2) {
      var d2 = e2.animationModel, y2 = e2.dataIndex, x2 = l2.__pictorialBundle;
      Yf2(x2, { x: e2.bundlePosition[0], y: e2.bundlePosition[1] }, d2, y2), e2.symbolRepeat ? Ife(l2, a, e2, true) : Dfe(l2, a, e2, true), Efe(l2, e2, true), kfe(l2, a, e2, true);
    }
    function Ofe(l2, a, e2, d2) {
      var y2 = d2.__pictorialBarRect;
      y2 && y2.removeTextContent();
      var x2 = [];
      T4t(d2, function(C) {
        x2.push(C);
      }), d2.__pictorialMainPath && x2.push(d2.__pictorialMainPath), d2.__pictorialClipPath && (e2 = null), Ke2(x2, function(C) {
        iP(C, { scaleX: 0, scaleY: 0 }, e2, a, function() {
          d2.parent && d2.parent.remove(d2);
        });
      }), l2.setItemGraphicEl(a, null);
    }
    function Rfe(l2, a) {
      return [l2.getItemVisual(a.dataIndex, "symbol") || "none", !!a.symbolRepeat, !!a.symbolClip].join(":");
    }
    function T4t(l2, a, e2) {
      Ke2(l2.__pictorialBundle.children(), function(d2) {
        d2 !== l2.__pictorialBarRect && a.call(e2, d2);
      });
    }
    function vZ(l2, a, e2, d2, y2, x2) {
      a && l2.attr(a), d2.symbolClip && !y2 ? e2 && l2.attr(e2) : e2 && nrt[y2 ? "updateProps" : "initProps"](l2, e2, d2.animationModel, d2.dataIndex, x2);
    }
    function Nfe(l2, a, e2) {
      var d2 = e2.dataIndex, y2 = e2.itemModel, x2 = y2.getModel("emphasis"), C = x2.getModel("itemStyle").getItemStyle(), D2 = y2.getModel(["blur", "itemStyle"]).getItemStyle(), L = y2.getModel(["select", "itemStyle"]).getItemStyle(), F3 = y2.getShallow("cursor"), j = x2.get("focus"), U3 = x2.get("blurScope"), Y3 = x2.get("scale");
      T4t(l2, function(dt) {
        if (dt instanceof Im) {
          var vt = dt.style;
          dt.useStyle(la2({ image: vt.image, x: vt.x, y: vt.y, width: vt.width, height: vt.height }, e2.style));
        } else
          dt.useStyle(e2.style);
        var Ct = dt.ensureState("emphasis");
        Ct.style = C, Y3 && (Ct.scaleX = dt.scaleX * 1.1, Ct.scaleY = dt.scaleY * 1.1), dt.ensureState("blur").style = D2, dt.ensureState("select").style = L, F3 && (dt.cursor = F3), dt.z2 = e2.z2;
      });
      var Q = a.valueDim.posDesc[+(e2.boundingLength > 0)], nt = l2.__pictorialBarRect;
      ow(nt, Sb2(y2), { labelFetcher: a.seriesModel, labelDataIndex: d2, defaultText: oZ(a.seriesModel.getData(), d2), inheritColor: e2.style.fill, defaultOpacity: e2.style.opacity, defaultOutsidePosition: Q }), n0(l2, j, U3, x2.get("disabled"));
    }
    function Ffe(l2) {
      var a = Math.round(l2);
      return Math.abs(l2 - a) < 1e-4 ? a : Math.ceil(l2);
    }
    var Osn = Tsn, Rsn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.hasSymbolVisual = true, e2.defaultSymbol = "roundRect", e2;
      }
      return a.prototype.getInitialData = function(e2) {
        return e2.stack = null, l2.prototype.getInitialData.apply(this, arguments);
      }, a.type = "series.pictorialBar", a.dependencies = ["grid"], a.defaultOption = ZN(Qyt.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), a;
    }(Qyt), Nsn = Rsn;
    function Fsn(l2) {
      l2.registerChartView(Osn), l2.registerSeriesModel(Nsn), l2.registerLayout(l2.PRIORITY.VISUAL.LAYOUT, xu(Yoe, "pictorialBar")), l2.registerLayout(l2.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, Koe("pictorialBar"));
    }
    var Vsn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._layers = [], e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = e2.getData(), C = this, D2 = this.group, L = e2.getLayerSeries(), F3 = x2.getLayout("layoutInfo"), j = F3.rect, U3 = F3.boundaryGap;
        D2.x = 0, D2.y = j.y + U3[0];
        function Y3(vt) {
          return vt.name;
        }
        var Q = new kO(this._layersSeries || [], L, Y3, Y3), nt = [];
        Q.add(As(dt, this, "add")).update(As(dt, this, "update")).remove(As(dt, this, "remove")).execute();
        function dt(vt, Ct, Pt) {
          var jt = C._layers;
          if (vt === "remove") {
            D2.remove(jt[Ct]);
            return;
          }
          for (var Rt = [], le2 = [], ne2, he2 = L[Ct].indices, _e = 0; _e < he2.length; _e++) {
            var Me2 = x2.getItemLayout(he2[_e]), Pe2 = Me2.x, Be2 = Me2.y0, Je2 = Me2.y;
            Rt.push(Pe2, Be2), le2.push(Pe2, Be2 + Je2), ne2 = x2.getItemVisual(he2[_e], "style");
          }
          var Ze2, Cn = x2.getItemLayout(he2[0]), Bn = e2.getModel("label"), mn = Bn.get("margin"), Kr = e2.getModel("emphasis");
          if (vt === "add") {
            var Kn = nt[Ct] = new ou();
            Ze2 = new ule({ shape: { points: Rt, stackedOnPoints: le2, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), Kn.add(Ze2), D2.add(Kn), e2.isAnimationEnabled() && Ze2.setClipPath(Bsn(Ze2.getBoundingRect(), e2, function() {
              Ze2.removeClipPath();
            }));
          } else {
            var Kn = jt[Pt];
            Ze2 = Kn.childAt(0), D2.add(Kn), nt[Ct] = Kn, Yf2(Ze2, { shape: { points: Rt, stackedOnPoints: le2 } }, e2), pC(Ze2);
          }
          ow(Ze2, Sb2(e2), { labelDataIndex: he2[_e - 1], defaultText: x2.getName(he2[_e - 1]), inheritColor: ne2.fill }, { normal: { verticalAlign: "middle" } }), Ze2.setTextConfig({ position: null, local: true });
          var ar = Ze2.getTextContent();
          ar && (ar.x = Cn.x - mn, ar.y = Cn.y0 + Cn.y / 2), Ze2.useStyle(ne2), x2.setItemGraphicEl(Ct, Ze2), Gy(Ze2, e2), n0(Ze2, Kr.get("focus"), Kr.get("blurScope"), Kr.get("disabled"));
        }
        this._layersSeries = L, this._layers = nt;
      }, a.type = "themeRiver", a;
    }(pg2);
    function Bsn(l2, a, e2) {
      var d2 = new Nf2({ shape: { x: l2.x - 10, y: l2.y - 10, width: 0, height: l2.height + 20 } });
      return Yg2(d2, { shape: { x: l2.x - 50, width: l2.width + 100, height: l2.height + 20 } }, a, e2), d2;
    }
    var zsn = Vsn, A4t = 2, jsn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2) {
        l2.prototype.init.apply(this, arguments), this.legendVisualProvider = new Hrt(As(this.getData, this), As(this.getRawData, this));
      }, a.prototype.fixData = function(e2) {
        var d2 = e2.length, y2 = {}, x2 = cq(e2, function(Y3) {
          return y2.hasOwnProperty(Y3[0] + "") || (y2[Y3[0] + ""] = -1), Y3[2];
        }), C = [];
        x2.buckets.each(function(Y3, Q) {
          C.push({ name: Q, dataList: Y3 });
        });
        for (var D2 = C.length, L = 0; L < D2; ++L) {
          for (var F3 = C[L].name, j = 0; j < C[L].dataList.length; ++j) {
            var U3 = C[L].dataList[j][0] + "";
            y2[U3] = L;
          }
          for (var U3 in y2)
            y2.hasOwnProperty(U3) && y2[U3] !== L && (y2[U3] = L, e2[d2] = [U3, 0, F3], d2++);
        }
        return e2;
      }, a.prototype.getInitialData = function(e2, d2) {
        for (var y2 = this.getReferringComponents("singleAxis", q0).models[0], x2 = y2.get("type"), C = Lp(e2.data, function(nt) {
          return nt[2] !== void 0;
        }), D2 = this.fixData(C || []), L = [], F3 = this.nameMap = fl(), j = 0, U3 = 0; U3 < D2.length; ++U3)
          L.push(D2[U3][A4t]), F3.get(D2[U3][A4t]) || (F3.set(D2[U3][A4t], j), j++);
        var Y3 = Ert(D2, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: kyt(x2) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, Q = new jS(Y3, this);
        return Q.initData(D2), Q;
      }, a.prototype.getLayerSeries = function() {
        for (var e2 = this.getData(), d2 = e2.count(), y2 = [], x2 = 0; x2 < d2; ++x2)
          y2[x2] = x2;
        var C = e2.mapDimension("single"), D2 = cq(y2, function(F3) {
          return e2.get("name", F3);
        }), L = [];
        return D2.buckets.each(function(F3, j) {
          F3.sort(function(U3, Y3) {
            return e2.get(C, U3) - e2.get(C, Y3);
          }), L.push({ name: j, indices: F3 });
        }), L;
      }, a.prototype.getAxisTooltipData = function(e2, d2, y2) {
        Ba2(e2) || (e2 = e2 ? [e2] : []);
        for (var x2 = this.getData(), C = this.getLayerSeries(), D2 = [], L = C.length, F3, j = 0; j < L; ++j) {
          for (var U3 = Number.MAX_VALUE, Y3 = -1, Q = C[j].indices.length, nt = 0; nt < Q; ++nt) {
            var dt = x2.get(e2[0], C[j].indices[nt]), vt = Math.abs(dt - d2);
            vt <= U3 && (F3 = dt, U3 = vt, Y3 = C[j].indices[nt]);
          }
          D2.push(Y3);
        }
        return { dataIndices: D2, nestestValue: F3 };
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        var x2 = this.getData(), C = x2.getName(e2), D2 = x2.get(x2.mapDimension("value"), e2);
        return b1("nameValue", { name: C, value: D2 });
      }, a.type = "series.themeRiver", a.dependencies = ["singleAxis"], a.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, a;
    }(Pv), Wsn = jsn;
    function Gsn(l2, a) {
      l2.eachSeriesByType("themeRiver", function(e2) {
        var d2 = e2.getData(), y2 = e2.coordinateSystem, x2 = {}, C = y2.getRect();
        x2.rect = C;
        var D2 = e2.get("boundaryGap"), L = y2.getAxis();
        if (x2.boundaryGap = D2, L.orient === "horizontal") {
          D2[0] = Ko(D2[0], C.height), D2[1] = Ko(D2[1], C.height);
          var F3 = C.height - D2[0] - D2[1];
          Vfe(d2, e2, F3);
        } else {
          D2[0] = Ko(D2[0], C.width), D2[1] = Ko(D2[1], C.width);
          var j = C.width - D2[0] - D2[1];
          Vfe(d2, e2, j);
        }
        d2.setLayout("layoutInfo", x2);
      });
    }
    function Vfe(l2, a, e2) {
      if (l2.count())
        for (var d2 = a.coordinateSystem, y2 = a.getLayerSeries(), x2 = l2.mapDimension("single"), C = l2.mapDimension("value"), D2 = $a2(y2, function(vt) {
          return $a2(vt.indices, function(Ct) {
            var Pt = d2.dataToPoint(l2.get(x2, Ct));
            return Pt[1] = l2.get(C, Ct), Pt;
          });
        }), L = Hsn(D2), F3 = L.y0, j = e2 / L.max, U3 = y2.length, Y3 = y2[0].indices.length, Q, nt = 0; nt < Y3; ++nt) {
          Q = F3[nt] * j, l2.setItemLayout(y2[0].indices[nt], { layerIndex: 0, x: D2[0][nt][0], y0: Q, y: D2[0][nt][1] * j });
          for (var dt = 1; dt < U3; ++dt)
            Q += D2[dt - 1][nt][1] * j, l2.setItemLayout(y2[dt].indices[nt], { layerIndex: dt, x: D2[dt][nt][0], y0: Q, y: D2[dt][nt][1] * j });
        }
    }
    function Hsn(l2) {
      for (var a = l2.length, e2 = l2[0].length, d2 = [], y2 = [], x2 = 0, C = 0; C < e2; ++C) {
        for (var D2 = 0, L = 0; L < a; ++L)
          D2 += l2[L][C][1];
        D2 > x2 && (x2 = D2), d2.push(D2);
      }
      for (var F3 = 0; F3 < e2; ++F3)
        y2[F3] = (x2 - d2[F3]) / 2;
      x2 = 0;
      for (var j = 0; j < e2; ++j) {
        var U3 = d2[j] + y2[j];
        U3 > x2 && (x2 = U3);
      }
      return { y0: y2, max: x2 };
    }
    function Usn(l2) {
      l2.registerChartView(zsn), l2.registerSeriesModel(Wsn), l2.registerLayout(Gsn), l2.registerProcessor(Grt("themeRiver"));
    }
    var qsn = 2, Zsn = 4, $sn = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2) {
        var C = l2.call(this) || this;
        C.z2 = qsn, C.textConfig = { inside: true }, ns(C).seriesIndex = d2.seriesIndex;
        var D2 = new qc2({ z2: Zsn, silent: e2.getModel().get(["label", "silent"]) });
        return C.setTextContent(D2), C.updateData(true, e2, d2, y2, x2), C;
      }
      return a.prototype.updateData = function(e2, d2, y2, x2, C) {
        this.node = d2, d2.piece = this, y2 = y2 || this._seriesModel, x2 = x2 || this._ecModel;
        var D2 = this;
        ns(D2).dataIndex = d2.dataIndex;
        var L = d2.getModel(), F3 = L.getModel("emphasis"), j = d2.getLayout(), U3 = la2({}, j);
        U3.label = null;
        var Y3 = d2.getVisual("style");
        Y3.lineJoin = "bevel";
        var Q = d2.getVisual("decal");
        Q && (Y3.decal = xrt(Q, C));
        var nt = sZ(L.getModel("itemStyle"), U3, true);
        la2(U3, nt), Ke2(O_, function(Pt) {
          var jt = D2.ensureState(Pt), Rt = L.getModel([Pt, "itemStyle"]);
          jt.style = Rt.getItemStyle();
          var le2 = sZ(Rt, U3);
          le2 && (jt.shape = le2);
        }), e2 ? (D2.setShape(U3), D2.shape.r = j.r0, Yf2(D2, { shape: { r: j.r } }, y2, d2.dataIndex)) : (Yf2(D2, { shape: U3 }, y2), pC(D2)), D2.useStyle(Y3), this._updateLabel(y2);
        var dt = L.getShallow("cursor");
        dt && D2.attr("cursor", dt), this._seriesModel = y2 || this._seriesModel, this._ecModel = x2 || this._ecModel;
        var vt = F3.get("focus"), Ct = vt === "ancestor" ? d2.getAncestorsIndices() : vt === "descendant" ? d2.getDescendantIndices() : vt;
        n0(this, Ct, F3.get("blurScope"), F3.get("disabled"));
      }, a.prototype._updateLabel = function(e2) {
        var d2 = this, y2 = this.node.getModel(), x2 = y2.getModel("label"), C = this.node.getLayout(), D2 = C.endAngle - C.startAngle, L = (C.startAngle + C.endAngle) / 2, F3 = Math.cos(L), j = Math.sin(L), U3 = this, Y3 = U3.getTextContent(), Q = this.node.dataIndex, nt = x2.get("minAngle") / 180 * Math.PI, dt = x2.get("show") && !(nt != null && Math.abs(D2) < nt);
        Y3.ignore = !dt, Ke2(UV, function(Ct) {
          var Pt = Ct === "normal" ? y2.getModel("label") : y2.getModel([Ct, "label"]), jt = Ct === "normal", Rt = jt ? Y3 : Y3.ensureState(Ct), le2 = e2.getFormattedLabel(Q, Ct);
          jt && (le2 = le2 || d2.node.name), Rt.style = _y(Pt, {}, null, Ct !== "normal", true), le2 && (Rt.style.text = le2);
          var ne2 = Pt.get("show");
          ne2 != null && !jt && (Rt.ignore = !ne2);
          var he2 = vt(Pt, "position"), _e = jt ? U3 : U3.states[Ct], Me2 = _e.style.fill;
          _e.textConfig = { outsideFill: Pt.get("color") === "inherit" ? Me2 : null, inside: he2 !== "outside" };
          var Pe2, Be2 = vt(Pt, "distance") || 0, Je2 = vt(Pt, "align");
          he2 === "outside" ? (Pe2 = C.r + Be2, Je2 = L > Math.PI / 2 ? "right" : "left") : !Je2 || Je2 === "center" ? (D2 === 2 * Math.PI && C.r0 === 0 ? Pe2 = 0 : Pe2 = (C.r + C.r0) / 2, Je2 = "center") : Je2 === "left" ? (Pe2 = C.r0 + Be2, L > Math.PI / 2 && (Je2 = "right")) : Je2 === "right" && (Pe2 = C.r - Be2, L > Math.PI / 2 && (Je2 = "left")), Rt.style.align = Je2, Rt.style.verticalAlign = vt(Pt, "verticalAlign") || "middle", Rt.x = Pe2 * F3 + C.cx, Rt.y = Pe2 * j + C.cy;
          var Ze2 = vt(Pt, "rotate"), Cn = 0;
          Ze2 === "radial" ? (Cn = -L, Cn < -Math.PI / 2 && (Cn += Math.PI)) : Ze2 === "tangential" ? (Cn = Math.PI / 2 - L, Cn > Math.PI / 2 ? Cn -= Math.PI : Cn < -Math.PI / 2 && (Cn += Math.PI)) : Ch2(Ze2) && (Cn = Ze2 * Math.PI / 180), Rt.rotation = Cn;
        });
        function vt(Ct, Pt) {
          var jt = Ct.get(Pt);
          return jt == null ? x2.get(Pt) : jt;
        }
        Y3.dirtyStyle();
      }, a;
    }(nw), Bfe = $sn, I4t = "sunburstRootToNode", zfe = "sunburstHighlight", Ysn = "sunburstUnhighlight";
    function Ksn(l2) {
      l2.registerAction({ type: I4t, update: "updateView" }, function(a, e2) {
        e2.eachComponent({ mainType: "series", subType: "sunburst", query: a }, d2);
        function d2(y2, x2) {
          var C = Xrt(a, [I4t], y2);
          if (C) {
            var D2 = y2.getViewRoot();
            D2 && (a.direction = POt(D2, C.node) ? "rollUp" : "drillDown"), y2.resetViewRoot(C.node);
          }
        }
      }), l2.registerAction({ type: zfe, update: "none" }, function(a, e2, d2) {
        a = la2({}, a), e2.eachComponent({ mainType: "series", subType: "sunburst", query: a }, y2);
        function y2(x2) {
          var C = Xrt(a, [zfe], x2);
          C && (a.dataIndex = C.node.dataIndex);
        }
        d2.dispatchAction(la2(a, { type: "highlight" }));
      }), l2.registerAction({ type: Ysn, update: "updateView" }, function(a, e2, d2) {
        a = la2({}, a), d2.dispatchAction(la2(a, { type: "downplay" }));
      });
    }
    var Xsn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        var C = this;
        this.seriesModel = e2, this.api = y2, this.ecModel = d2;
        var D2 = e2.getData(), L = D2.tree.root, F3 = e2.getViewRoot(), j = this.group, U3 = e2.get("renderLabelForZeroData"), Y3 = [];
        F3.eachNode(function(Pt) {
          Y3.push(Pt);
        });
        var Q = this._oldChildren || [];
        nt(Y3, Q), Ct(L, F3), this._initEvents(), this._oldChildren = Y3;
        function nt(Pt, jt) {
          if (Pt.length === 0 && jt.length === 0)
            return;
          new kO(jt, Pt, Rt, Rt).add(le2).update(le2).remove(xu(le2, null)).execute();
          function Rt(ne2) {
            return ne2.getId();
          }
          function le2(ne2, he2) {
            var _e = ne2 == null ? null : Pt[ne2], Me2 = he2 == null ? null : jt[he2];
            dt(_e, Me2);
          }
        }
        function dt(Pt, jt) {
          if (!U3 && Pt && !Pt.getValue() && (Pt = null), Pt !== L && jt !== L) {
            if (jt && jt.piece)
              Pt ? (jt.piece.updateData(false, Pt, e2, d2, y2), D2.setItemGraphicEl(Pt.dataIndex, jt.piece)) : vt(jt);
            else if (Pt) {
              var Rt = new Bfe(Pt, e2, d2, y2);
              j.add(Rt), D2.setItemGraphicEl(Pt.dataIndex, Rt);
            }
          }
        }
        function vt(Pt) {
          !Pt || Pt.piece && (j.remove(Pt.piece), Pt.piece = null);
        }
        function Ct(Pt, jt) {
          jt.depth > 0 ? (C.virtualPiece ? C.virtualPiece.updateData(false, Pt, e2, d2, y2) : (C.virtualPiece = new Bfe(Pt, e2, d2, y2), j.add(C.virtualPiece)), jt.piece.off("click"), C.virtualPiece.on("click", function(Rt) {
            C._rootToNode(jt.parentNode);
          })) : C.virtualPiece && (j.remove(C.virtualPiece), C.virtualPiece = null);
        }
      }, a.prototype._initEvents = function() {
        var e2 = this;
        this.group.off("click"), this.group.on("click", function(d2) {
          var y2 = false, x2 = e2.seriesModel.getViewRoot();
          x2.eachNode(function(C) {
            if (!y2 && C.piece && C.piece === d2.target) {
              var D2 = C.getModel().get("nodeClick");
              if (D2 === "rootToNode")
                e2._rootToNode(C);
              else if (D2 === "link") {
                var L = C.getModel(), F3 = L.get("link");
                if (F3) {
                  var j = L.get("target", true) || "_blank";
                  lyt(F3, j);
                }
              }
              y2 = true;
            }
          });
        });
      }, a.prototype._rootToNode = function(e2) {
        e2 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: I4t, from: this.uid, seriesId: this.seriesModel.id, targetNode: e2 });
      }, a.prototype.containPoint = function(e2, d2) {
        var y2 = d2.getData(), x2 = y2.getItemLayout(0);
        if (x2) {
          var C = e2[0] - x2.cx, D2 = e2[1] - x2.cy, L = Math.sqrt(C * C + D2 * D2);
          return L <= x2.r && L >= x2.r0;
        }
      }, a.type = "sunburst", a;
    }(pg2), Qsn = Xsn, Jsn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.ignoreStyleOnData = true, e2;
      }
      return a.prototype.getInitialData = function(e2, d2) {
        var y2 = { name: e2.name, children: e2.data };
        jfe(y2);
        var x2 = this._levelModels = $a2(e2.levels || [], function(L) {
          return new hg2(L, this, d2);
        }, this), C = kOt.createTree(y2, this, D2);
        function D2(L) {
          L.wrapMethod("getItemModel", function(F3, j) {
            var U3 = C.getNodeByDataIndex(j), Y3 = x2[U3.depth];
            return Y3 && (F3.parentModel = Y3), F3;
          });
        }
        return C.data;
      }, a.prototype.optionUpdated = function() {
        this.resetViewRoot();
      }, a.prototype.getDataParams = function(e2) {
        var d2 = l2.prototype.getDataParams.apply(this, arguments), y2 = this.getData().tree.getNodeByDataIndex(e2);
        return d2.treePathInfo = fmt(y2, this), d2;
      }, a.prototype.getLevelModel = function(e2) {
        return this._levelModels && this._levelModels[e2.depth];
      }, a.prototype.getViewRoot = function() {
        return this._viewRoot;
      }, a.prototype.resetViewRoot = function(e2) {
        e2 ? this._viewRoot = e2 : e2 = this._viewRoot;
        var d2 = this.getRawData().tree.root;
        (!e2 || e2 !== d2 && !d2.contains(e2)) && (this._viewRoot = d2);
      }, a.prototype.enableAriaDecal = function() {
        Yue(this);
      }, a.type = "series.sunburst", a.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, a;
    }(Pv);
    function jfe(l2) {
      var a = 0;
      Ke2(l2.children, function(d2) {
        jfe(d2);
        var y2 = d2.value;
        Ba2(y2) && (y2 = y2[0]), a += y2;
      });
      var e2 = l2.value;
      Ba2(e2) && (e2 = e2[0]), (e2 == null || isNaN(e2)) && (e2 = a), e2 < 0 && (e2 = 0), Ba2(l2.value) ? l2.value[0] = e2 : l2.value = e2;
    }
    var tln = Jsn, Wfe = Math.PI / 180;
    function eln(l2, a, e2) {
      a.eachSeriesByType(l2, function(d2) {
        var y2 = d2.get("center"), x2 = d2.get("radius");
        Ba2(x2) || (x2 = [0, x2]), Ba2(y2) || (y2 = [y2, y2]);
        var C = e2.getWidth(), D2 = e2.getHeight(), L = Math.min(C, D2), F3 = Ko(y2[0], C), j = Ko(y2[1], D2), U3 = Ko(x2[0], L / 2), Y3 = Ko(x2[1], L / 2), Q = -d2.get("startAngle") * Wfe, nt = d2.get("minAngle") * Wfe, dt = d2.getData().tree.root, vt = d2.getViewRoot(), Ct = vt.depth, Pt = d2.get("sort");
        Pt != null && Gfe(vt, Pt);
        var jt = 0;
        Ke2(vt.children, function(mn) {
          !isNaN(mn.getValue()) && jt++;
        });
        var Rt = vt.getValue(), le2 = Math.PI / (Rt || jt) * 2, ne2 = vt.depth > 0, he2 = vt.height - (ne2 ? -1 : 1), _e = (Y3 - U3) / (he2 || 1), Me2 = d2.get("clockwise"), Pe2 = d2.get("stillShowZeroSum"), Be2 = Me2 ? 1 : -1, Je2 = function(mn, Kr) {
          if (mn) {
            var Kn = Kr;
            if (mn !== dt) {
              var ar = mn.getValue(), Cr = Rt === 0 && Pe2 ? le2 : ar * le2;
              Cr < nt && (Cr = nt), Kn = Kr + Be2 * Cr;
              var ui2 = mn.depth - Ct - (ne2 ? -1 : 1), vi2 = U3 + _e * ui2, ko = U3 + _e * (ui2 + 1), Ss = d2.getLevelModel(mn);
              if (Ss) {
                var hl = Ss.get("r0", true), Qs = Ss.get("r", true), Js = Ss.get("radius", true);
                Js != null && (hl = Js[0], Qs = Js[1]), hl != null && (vi2 = Ko(hl, L / 2)), Qs != null && (ko = Ko(Qs, L / 2));
              }
              mn.setLayout({ angle: Cr, startAngle: Kr, endAngle: Kn, clockwise: Me2, cx: F3, cy: j, r0: vi2, r: ko });
            }
            if (mn.children && mn.children.length) {
              var rs = 0;
              Ke2(mn.children, function(Gs) {
                rs += Je2(Gs, Kr + rs);
              });
            }
            return Kn - Kr;
          }
        };
        if (ne2) {
          var Ze2 = U3, Cn = U3 + _e, Bn = Math.PI * 2;
          dt.setLayout({ angle: Bn, startAngle: Q, endAngle: Q + Bn, clockwise: Me2, cx: F3, cy: j, r0: Ze2, r: Cn });
        }
        Je2(vt, Q);
      });
    }
    function Gfe(l2, a) {
      var e2 = l2.children || [];
      l2.children = nln(e2, a), e2.length && Ke2(l2.children, function(d2) {
        Gfe(d2, a);
      });
    }
    function nln(l2, a) {
      if (wl(a)) {
        var e2 = $a2(l2, function(y2, x2) {
          var C = y2.getValue();
          return { params: { depth: y2.depth, height: y2.height, dataIndex: y2.dataIndex, getValue: function() {
            return C;
          } }, index: x2 };
        });
        return e2.sort(function(y2, x2) {
          return a(y2.params, x2.params);
        }), $a2(e2, function(y2) {
          return l2[y2.index];
        });
      } else {
        var d2 = a === "asc";
        return l2.sort(function(y2, x2) {
          var C = (y2.getValue() - x2.getValue()) * (d2 ? 1 : -1);
          return C === 0 ? (y2.dataIndex - x2.dataIndex) * (d2 ? -1 : 1) : C;
        });
      }
    }
    function rln(l2) {
      var a = {};
      function e2(d2, y2, x2) {
        for (var C = d2; C && C.depth > 1; )
          C = C.parentNode;
        var D2 = y2.getColorFromPalette(C.name || C.dataIndex + "", a);
        return d2.depth > 1 && ps(D2) && (D2 = Net(D2, (d2.depth - 1) / (x2 - 1) * 0.5)), D2;
      }
      l2.eachSeriesByType("sunburst", function(d2) {
        var y2 = d2.getData(), x2 = y2.tree;
        x2.eachNode(function(C) {
          var D2 = C.getModel(), L = D2.getModel("itemStyle").getItemStyle();
          L.fill || (L.fill = e2(C, d2, x2.root.height));
          var F3 = y2.ensureUniqueItemVisual(C.dataIndex, "style");
          la2(F3, L);
        });
      });
    }
    function iln(l2) {
      l2.registerChartView(Qsn), l2.registerSeriesModel(tln), l2.registerLayout(xu(eln, "sunburst")), l2.registerProcessor(xu(Grt, "sunburst")), l2.registerVisual(rln), Ksn(l2);
    }
    var Hfe = { color: "fill", borderColor: "stroke" }, aln = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, VO = Rf2(), oln = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.optionUpdated = function() {
        this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
      }, a.prototype.getInitialData = function(e2, d2) {
        return PO(null, this);
      }, a.prototype.getDataParams = function(e2, d2, y2) {
        var x2 = l2.prototype.getDataParams.call(this, e2, d2);
        return y2 && (x2.info = VO(y2).info), x2;
      }, a.type = "series.custom", a.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, a;
    }(Pv), sln = oln;
    function lln(l2, a) {
      return a = a || [0, 0], $a2(["x", "y"], function(e2, d2) {
        var y2 = this.getAxis(e2), x2 = a[d2], C = l2[d2] / 2;
        return y2.type === "category" ? y2.getBandWidth() : Math.abs(y2.dataToCoord(x2 - C) - y2.dataToCoord(x2 + C));
      }, this);
    }
    function uln(l2) {
      var a = l2.master.getRect();
      return { coordSys: { type: "cartesian2d", x: a.x, y: a.y, width: a.width, height: a.height }, api: { coord: function(e2) {
        return l2.dataToPoint(e2);
      }, size: As(lln, l2) } };
    }
    function cln(l2, a) {
      return a = a || [0, 0], $a2([0, 1], function(e2) {
        var d2 = a[e2], y2 = l2[e2] / 2, x2 = [], C = [];
        return x2[e2] = d2 - y2, C[e2] = d2 + y2, x2[1 - e2] = C[1 - e2] = a[1 - e2], Math.abs(this.dataToPoint(x2)[e2] - this.dataToPoint(C)[e2]);
      }, this);
    }
    function fln(l2) {
      var a = l2.getBoundingRect();
      return { coordSys: { type: "geo", x: a.x, y: a.y, width: a.width, height: a.height, zoom: l2.getZoom() }, api: { coord: function(e2) {
        return l2.dataToPoint(e2);
      }, size: As(cln, l2) } };
    }
    function hln(l2, a) {
      var e2 = this.getAxis(), d2 = a instanceof Array ? a[0] : a, y2 = (l2 instanceof Array ? l2[0] : l2) / 2;
      return e2.type === "category" ? e2.getBandWidth() : Math.abs(e2.dataToCoord(d2 - y2) - e2.dataToCoord(d2 + y2));
    }
    function pln(l2) {
      var a = l2.getRect();
      return { coordSys: { type: "singleAxis", x: a.x, y: a.y, width: a.width, height: a.height }, api: { coord: function(e2) {
        return l2.dataToPoint(e2);
      }, size: As(hln, l2) } };
    }
    function dln(l2, a) {
      return a = a || [0, 0], $a2(["Radius", "Angle"], function(e2, d2) {
        var y2 = "get" + e2 + "Axis", x2 = this[y2](), C = a[d2], D2 = l2[d2] / 2, L = x2.type === "category" ? x2.getBandWidth() : Math.abs(x2.dataToCoord(C - D2) - x2.dataToCoord(C + D2));
        return e2 === "Angle" && (L = L * Math.PI / 180), L;
      }, this);
    }
    function gln(l2) {
      var a = l2.getRadiusAxis(), e2 = l2.getAngleAxis(), d2 = a.getExtent();
      return d2[0] > d2[1] && d2.reverse(), { coordSys: { type: "polar", cx: l2.cx, cy: l2.cy, r: d2[1], r0: d2[0] }, api: { coord: function(y2) {
        var x2 = a.dataToRadius(y2[0]), C = e2.dataToAngle(y2[1]), D2 = l2.coordToPoint([x2, C]);
        return D2.push(x2, C * Math.PI / 180), D2;
      }, size: As(dln, l2) } };
    }
    function vln(l2) {
      var a = l2.getRect(), e2 = l2.getRangeInfo();
      return { coordSys: { type: "calendar", x: a.x, y: a.y, width: a.width, height: a.height, cellWidth: l2.getCellWidth(), cellHeight: l2.getCellHeight(), rangeInfo: { start: e2.start, end: e2.end, weeks: e2.weeks, dayCount: e2.allDay } }, api: { coord: function(d2, y2) {
        return l2.dataToPoint(d2, y2);
      } } };
    }
    function Ufe(l2, a, e2, d2) {
      return l2 && (l2.legacy || l2.legacy !== false && !e2 && !d2 && a !== "tspan" && (a === "text" || Ns(l2, "text")));
    }
    function qfe(l2, a, e2) {
      var d2 = l2, y2, x2, C;
      if (a === "text")
        C = d2;
      else {
        C = {}, Ns(d2, "text") && (C.text = d2.text), Ns(d2, "rich") && (C.rich = d2.rich), Ns(d2, "textFill") && (C.fill = d2.textFill), Ns(d2, "textStroke") && (C.stroke = d2.textStroke), Ns(d2, "fontFamily") && (C.fontFamily = d2.fontFamily), Ns(d2, "fontSize") && (C.fontSize = d2.fontSize), Ns(d2, "fontStyle") && (C.fontStyle = d2.fontStyle), Ns(d2, "fontWeight") && (C.fontWeight = d2.fontWeight), x2 = { type: "text", style: C, silent: true }, y2 = {};
        var D2 = Ns(d2, "textPosition");
        e2 ? y2.position = D2 ? d2.textPosition : "inside" : D2 && (y2.position = d2.textPosition), Ns(d2, "textPosition") && (y2.position = d2.textPosition), Ns(d2, "textOffset") && (y2.offset = d2.textOffset), Ns(d2, "textRotation") && (y2.rotation = d2.textRotation), Ns(d2, "textDistance") && (y2.distance = d2.textDistance);
      }
      return Zfe(C, l2), Ke2(C.rich, function(L) {
        Zfe(L, L);
      }), { textConfig: y2, textContent: x2 };
    }
    function Zfe(l2, a) {
      !a || (a.font = a.textFont || a.font, Ns(a, "textStrokeWidth") && (l2.lineWidth = a.textStrokeWidth), Ns(a, "textAlign") && (l2.align = a.textAlign), Ns(a, "textVerticalAlign") && (l2.verticalAlign = a.textVerticalAlign), Ns(a, "textLineHeight") && (l2.lineHeight = a.textLineHeight), Ns(a, "textWidth") && (l2.width = a.textWidth), Ns(a, "textHeight") && (l2.height = a.textHeight), Ns(a, "textBackgroundColor") && (l2.backgroundColor = a.textBackgroundColor), Ns(a, "textPadding") && (l2.padding = a.textPadding), Ns(a, "textBorderColor") && (l2.borderColor = a.textBorderColor), Ns(a, "textBorderWidth") && (l2.borderWidth = a.textBorderWidth), Ns(a, "textBorderRadius") && (l2.borderRadius = a.textBorderRadius), Ns(a, "textBoxShadowColor") && (l2.shadowColor = a.textBoxShadowColor), Ns(a, "textBoxShadowBlur") && (l2.shadowBlur = a.textBoxShadowBlur), Ns(a, "textBoxShadowOffsetX") && (l2.shadowOffsetX = a.textBoxShadowOffsetX), Ns(a, "textBoxShadowOffsetY") && (l2.shadowOffsetY = a.textBoxShadowOffsetY));
    }
    function $fe(l2, a, e2) {
      var d2 = l2;
      d2.textPosition = d2.textPosition || e2.position || "inside", e2.offset != null && (d2.textOffset = e2.offset), e2.rotation != null && (d2.textRotation = e2.rotation), e2.distance != null && (d2.textDistance = e2.distance);
      var y2 = d2.textPosition.indexOf("inside") >= 0, x2 = l2.fill || "#000";
      Yfe(d2, a);
      var C = d2.textFill == null;
      return y2 ? C && (d2.textFill = e2.insideFill || "#fff", !d2.textStroke && e2.insideStroke && (d2.textStroke = e2.insideStroke), !d2.textStroke && (d2.textStroke = x2), d2.textStrokeWidth == null && (d2.textStrokeWidth = 2)) : (C && (d2.textFill = l2.fill || e2.outsideFill || "#000"), !d2.textStroke && e2.outsideStroke && (d2.textStroke = e2.outsideStroke)), d2.text = a.text, d2.rich = a.rich, Ke2(a.rich, function(D2) {
        Yfe(D2, D2);
      }), d2;
    }
    function Yfe(l2, a) {
      !a || (Ns(a, "fill") && (l2.textFill = a.fill), Ns(a, "stroke") && (l2.textStroke = a.fill), Ns(a, "lineWidth") && (l2.textStrokeWidth = a.lineWidth), Ns(a, "font") && (l2.font = a.font), Ns(a, "fontStyle") && (l2.fontStyle = a.fontStyle), Ns(a, "fontWeight") && (l2.fontWeight = a.fontWeight), Ns(a, "fontSize") && (l2.fontSize = a.fontSize), Ns(a, "fontFamily") && (l2.fontFamily = a.fontFamily), Ns(a, "align") && (l2.textAlign = a.align), Ns(a, "verticalAlign") && (l2.textVerticalAlign = a.verticalAlign), Ns(a, "lineHeight") && (l2.textLineHeight = a.lineHeight), Ns(a, "width") && (l2.textWidth = a.width), Ns(a, "height") && (l2.textHeight = a.height), Ns(a, "backgroundColor") && (l2.textBackgroundColor = a.backgroundColor), Ns(a, "padding") && (l2.textPadding = a.padding), Ns(a, "borderColor") && (l2.textBorderColor = a.borderColor), Ns(a, "borderWidth") && (l2.textBorderWidth = a.borderWidth), Ns(a, "borderRadius") && (l2.textBorderRadius = a.borderRadius), Ns(a, "shadowColor") && (l2.textBoxShadowColor = a.shadowColor), Ns(a, "shadowBlur") && (l2.textBoxShadowBlur = a.shadowBlur), Ns(a, "shadowOffsetX") && (l2.textBoxShadowOffsetX = a.shadowOffsetX), Ns(a, "shadowOffsetY") && (l2.textBoxShadowOffsetY = a.shadowOffsetY), Ns(a, "textShadowColor") && (l2.textShadowColor = a.textShadowColor), Ns(a, "textShadowBlur") && (l2.textShadowBlur = a.textShadowBlur), Ns(a, "textShadowOffsetX") && (l2.textShadowOffsetX = a.textShadowOffsetX), Ns(a, "textShadowOffsetY") && (l2.textShadowOffsetY = a.textShadowOffsetY));
    }
    var Kfe = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, Xfe = Qc2(Kfe);
    tA(uA, function(l2, a) {
      return l2[a] = 1, l2;
    }, {}), uA.join(", ");
    var Mmt = ["", "style", "shape", "extra"], yZ = Rf2();
    function D4t(l2, a, e2, d2, y2) {
      var x2 = l2 + "Animation", C = HN(l2, d2, y2) || {}, D2 = yZ(a).userDuring;
      return C.duration > 0 && (C.during = D2 ? As(xln, { el: a, userDuring: D2 }) : null, C.setToFinal = true, C.scope = l2), la2(C, e2[x2]), C;
    }
    function Cmt(l2, a, e2, d2) {
      d2 = d2 || {};
      var y2 = d2.dataIndex, x2 = d2.isInit, C = d2.clearStyle, D2 = e2.isAnimationEnabled(), L = yZ(l2), F3 = a.style;
      L.userDuring = a.during;
      var j = {}, U3 = {};
      if (Sln(l2, a, U3), the("shape", a, U3), the("extra", a, U3), !x2 && D2 && (wln(l2, a, j), Jfe("shape", l2, a, j), Jfe("extra", l2, a, j), Mln(l2, a, F3, j)), U3.style = F3, yln(l2, U3, C), bln(l2, a), D2)
        if (x2) {
          var Y3 = {};
          Ke2(Mmt, function(nt) {
            var dt = nt ? a[nt] : a;
            dt && dt.enterFrom && (nt && (Y3[nt] = Y3[nt] || {}), la2(nt ? Y3[nt] : Y3, dt.enterFrom));
          });
          var Q = D4t("enter", l2, a, e2, y2);
          Q.duration > 0 && l2.animateFrom(Y3, Q);
        } else
          mln(l2, a, y2 || 0, e2, j);
      Qfe(l2, a), F3 ? l2.dirty() : l2.markRedraw();
    }
    function Qfe(l2, a) {
      for (var e2 = yZ(l2).leaveToProps, d2 = 0; d2 < Mmt.length; d2++) {
        var y2 = Mmt[d2], x2 = y2 ? a[y2] : a;
        x2 && x2.leaveTo && (e2 || (e2 = yZ(l2).leaveToProps = {}), y2 && (e2[y2] = e2[y2] || {}), la2(y2 ? e2[y2] : e2, x2.leaveTo));
      }
    }
    function Tmt(l2, a, e2, d2) {
      if (l2) {
        var y2 = l2.parent, x2 = yZ(l2).leaveToProps;
        if (x2) {
          var C = D4t("update", l2, a, e2, 0);
          C.done = function() {
            y2.remove(l2), d2 && d2();
          }, l2.animateTo(x2, C);
        } else
          y2.remove(l2), d2 && d2();
      }
    }
    function IB(l2) {
      return l2 === "all";
    }
    function yln(l2, a, e2) {
      var d2 = a.style;
      if (!l2.isGroup && d2) {
        if (e2) {
          l2.useStyle({});
          for (var y2 = l2.animators, x2 = 0; x2 < y2.length; x2++) {
            var C = y2[x2];
            C.targetName === "style" && C.changeTarget(l2.style);
          }
        }
        l2.setStyle(d2);
      }
      a && (a.style = null, a && l2.attr(a), a.style = d2);
    }
    function mln(l2, a, e2, d2, y2) {
      if (y2) {
        var x2 = D4t("update", l2, a, d2, e2);
        x2.duration > 0 && l2.animateFrom(y2, x2);
      }
    }
    function bln(l2, a) {
      Ns(a, "silent") && (l2.silent = a.silent), Ns(a, "ignore") && (l2.ignore = a.ignore), l2 instanceof Y2 && Ns(a, "invisible") && (l2.invisible = a.invisible), l2 instanceof wc2 && Ns(a, "autoBatch") && (l2.autoBatch = a.autoBatch);
    }
    var hP = {}, _ln = { setTransform: function(l2, a) {
      return hP.el[l2] = a, this;
    }, getTransform: function(l2) {
      return hP.el[l2];
    }, setShape: function(l2, a) {
      var e2 = hP.el, d2 = e2.shape || (e2.shape = {});
      return d2[l2] = a, e2.dirtyShape && e2.dirtyShape(), this;
    }, getShape: function(l2) {
      var a = hP.el.shape;
      if (a)
        return a[l2];
    }, setStyle: function(l2, a) {
      var e2 = hP.el, d2 = e2.style;
      return d2 && (d2[l2] = a, e2.dirtyStyle && e2.dirtyStyle()), this;
    }, getStyle: function(l2) {
      var a = hP.el.style;
      if (a)
        return a[l2];
    }, setExtra: function(l2, a) {
      var e2 = hP.el.extra || (hP.el.extra = {});
      return e2[l2] = a, this;
    }, getExtra: function(l2) {
      var a = hP.el.extra;
      if (a)
        return a[l2];
    } };
    function xln() {
      var l2 = this, a = l2.el;
      if (a) {
        var e2 = yZ(a).userDuring, d2 = l2.userDuring;
        if (e2 !== d2) {
          l2.el = l2.userDuring = null;
          return;
        }
        hP.el = a, d2(_ln);
      }
    }
    function Jfe(l2, a, e2, d2) {
      var y2 = e2[l2];
      if (y2) {
        var x2 = a[l2], C;
        if (x2) {
          var D2 = e2.transition, L = y2.transition;
          if (L)
            if (!C && (C = d2[l2] = {}), IB(L))
              la2(C, x2);
            else
              for (var F3 = Mp(L), j = 0; j < F3.length; j++) {
                var U3 = F3[j], Y3 = x2[U3];
                C[U3] = Y3;
              }
          else if (IB(D2) || oc2(D2, l2) >= 0) {
            !C && (C = d2[l2] = {});
            for (var Q = Qc2(x2), j = 0; j < Q.length; j++) {
              var U3 = Q[j], Y3 = x2[U3];
              Cln(y2[U3], Y3) && (C[U3] = Y3);
            }
          }
        }
      }
    }
    function the(l2, a, e2) {
      var d2 = a[l2];
      if (d2)
        for (var y2 = e2[l2] = {}, x2 = Qc2(d2), C = 0; C < x2.length; C++) {
          var D2 = x2[C];
          y2[D2] = PS(d2[D2]);
        }
    }
    function wln(l2, a, e2) {
      for (var d2 = a.transition, y2 = IB(d2) ? uA : Mp(d2 || []), x2 = 0; x2 < y2.length; x2++) {
        var C = y2[x2];
        if (!(C === "style" || C === "shape" || C === "extra")) {
          var D2 = l2[C];
          e2[C] = D2;
        }
      }
    }
    function Sln(l2, a, e2) {
      for (var d2 = 0; d2 < Xfe.length; d2++) {
        var y2 = Xfe[d2], x2 = Kfe[y2], C = a[y2];
        C && (e2[x2[0]] = C[0], e2[x2[1]] = C[1]);
      }
      for (var d2 = 0; d2 < uA.length; d2++) {
        var D2 = uA[d2];
        a[D2] != null && (e2[D2] = a[D2]);
      }
    }
    function Mln(l2, a, e2, d2) {
      if (e2) {
        var y2 = l2.style, x2;
        if (y2) {
          var C = e2.transition, D2 = a.transition;
          if (C && !IB(C)) {
            var L = Mp(C);
            !x2 && (x2 = d2.style = {});
            for (var F3 = 0; F3 < L.length; F3++) {
              var j = L[F3], U3 = y2[j];
              x2[j] = U3;
            }
          } else if (l2.getAnimationStyleProps && (IB(D2) || IB(C) || oc2(D2, "style") >= 0)) {
            var Y3 = l2.getAnimationStyleProps(), Q = Y3 ? Y3.style : null;
            if (Q) {
              !x2 && (x2 = d2.style = {});
              for (var nt = Qc2(e2), F3 = 0; F3 < nt.length; F3++) {
                var j = nt[F3];
                if (Q[j]) {
                  var U3 = y2[j];
                  x2[j] = U3;
                }
              }
            }
          }
        }
      }
    }
    function Cln(l2, a) {
      return h1(l2) ? l2 !== a : l2 != null && isFinite(l2);
    }
    var ehe = Rf2(), Tln = ["percent", "easing", "shape", "style", "extra"];
    function nhe(l2) {
      l2.stopAnimation("keyframe"), l2.attr(ehe(l2));
    }
    function Amt(l2, a, e2) {
      if (!(!e2.isAnimationEnabled() || !a)) {
        if (Ba2(a)) {
          Ke2(a, function(D2) {
            Amt(l2, D2, e2);
          });
          return;
        }
        var d2 = a.keyframes, y2 = a.duration;
        if (e2 && y2 == null) {
          var x2 = HN("enter", e2, 0);
          y2 = x2 && x2.duration;
        }
        if (!(!d2 || !y2)) {
          var C = ehe(l2);
          Ke2(Mmt, function(D2) {
            if (!(D2 && !l2[D2])) {
              var L;
              d2.sort(function(F3, j) {
                return F3.percent - j.percent;
              }), Ke2(d2, function(F3) {
                var j = l2.animators, U3 = D2 ? F3[D2] : F3;
                if (U3) {
                  var Y3 = Qc2(U3);
                  if (D2 || (Y3 = Lp(Y3, function(dt) {
                    return oc2(Tln, dt) < 0;
                  })), !!Y3.length) {
                    L || (L = l2.animate(D2, a.loop, true), L.scope = "keyframe");
                    for (var Q = 0; Q < j.length; Q++)
                      j[Q] !== L && j[Q].targetName === L.targetName && j[Q].stopTracks(Y3);
                    D2 && (C[D2] = C[D2] || {});
                    var nt = D2 ? C[D2] : C;
                    Ke2(Y3, function(dt) {
                      nt[dt] = ((D2 ? l2[D2] : l2) || {})[dt];
                    }), L.whenWithKeys(y2 * F3.percent, U3, Y3, F3.easing);
                  }
                }
              }), L && L.delay(a.delay || 0).duration(y2).start(a.easing);
            }
          });
        }
      }
    }
    var BO = "emphasis", lF = "normal", E4t = "blur", k4t = "select", uF = [lF, BO, E4t, k4t], P4t = { normal: ["itemStyle"], emphasis: [BO, "itemStyle"], blur: [E4t, "itemStyle"], select: [k4t, "itemStyle"] }, L4t = { normal: ["label"], emphasis: [BO, "label"], blur: [E4t, "label"], select: [k4t, "label"] }, Aln = ["x", "y"], Iln = "e\0\0", PA = { normal: {}, emphasis: {}, blur: {}, select: {} }, Dln = { cartesian2d: uln, geo: fln, singleAxis: pln, polar: gln, calendar: vln };
    function O4t(l2) {
      return l2 instanceof wc2;
    }
    function R4t(l2) {
      return l2 instanceof Y2;
    }
    function Eln(l2, a) {
      a.copyTransform(l2), R4t(a) && R4t(l2) && (a.setStyle(l2.style), a.z = l2.z, a.z2 = l2.z2, a.zlevel = l2.zlevel, a.invisible = l2.invisible, a.ignore = l2.ignore, O4t(a) && O4t(l2) && a.setShape(l2.shape));
    }
    var kln = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        this._progressiveEls = null;
        var C = this._data, D2 = e2.getData(), L = this.group, F3 = ihe(e2, D2, d2, y2);
        C || L.removeAll(), D2.diff(C).add(function(U3) {
          V4t(y2, null, U3, F3(U3, x2), e2, L, D2);
        }).remove(function(U3) {
          var Y3 = C.getItemGraphicEl(U3);
          Tmt(Y3, VO(Y3).option, e2);
        }).update(function(U3, Y3) {
          var Q = C.getItemGraphicEl(Y3);
          V4t(y2, Q, U3, F3(U3, x2), e2, L, D2);
        }).execute();
        var j = e2.get("clip", true) ? Xyt(e2.coordinateSystem, false, e2) : null;
        j ? L.setClipPath(j) : L.removeClipPath(), this._data = D2;
      }, a.prototype.incrementalPrepareRender = function(e2, d2, y2) {
        this.group.removeAll(), this._data = null;
      }, a.prototype.incrementalRender = function(e2, d2, y2, x2, C) {
        var D2 = d2.getData(), L = ihe(d2, D2, y2, x2), F3 = this._progressiveEls = [];
        function j(Q) {
          Q.isGroup || (Q.incremental = true, Q.ensureState("emphasis").hoverLayer = true);
        }
        for (var U3 = e2.start; U3 < e2.end; U3++) {
          var Y3 = V4t(null, null, U3, L(U3, C), d2, this.group, D2);
          Y3 && (Y3.traverse(j), F3.push(Y3));
        }
      }, a.prototype.eachRendered = function(e2) {
        qN(this._progressiveEls || this.group, e2);
      }, a.prototype.filterForExposedEvent = function(e2, d2, y2, x2) {
        var C = d2.element;
        if (C == null || y2.name === C)
          return true;
        for (; (y2 = y2.__hostTarget || y2.parent) && y2 !== this.group; )
          if (y2.name === C)
            return true;
        return false;
      }, a.type = "custom", a;
    }(pg2), Pln = kln;
    function N4t(l2) {
      var a = l2.type, e2;
      if (a === "path") {
        var d2 = l2.shape, y2 = d2.width != null && d2.height != null ? { x: d2.x || 0, y: d2.y || 0, width: d2.width, height: d2.height } : null, x2 = uhe(d2);
        e2 = Fr(x2, null, y2, d2.layout || "center"), VO(e2).customPathData = x2;
      } else if (a === "image")
        e2 = new Im({}), VO(e2).customImagePath = l2.style.image;
      else if (a === "text")
        e2 = new qc2({});
      else if (a === "group")
        e2 = new ou();
      else {
        if (a === "compoundPath")
          throw new Error('"compoundPath" is not supported yet.');
        var C = Hn(a);
        if (!C) {
          var D2 = "";
          ih2(D2);
        }
        e2 = new C();
      }
      return VO(e2).customGraphicType = a, e2.name = l2.name, e2.z2EmphasisLift = 1, e2.z2SelectLift = 1, e2;
    }
    function F4t(l2, a, e2, d2, y2, x2, C) {
      nhe(a);
      var D2 = y2 && y2.normal.cfg;
      D2 && a.setTextConfig(D2), d2 && d2.transition == null && (d2.transition = Aln);
      var L = d2 && d2.style;
      if (L) {
        if (a.type === "text") {
          var F3 = L;
          Ns(F3, "textFill") && (F3.fill = F3.textFill), Ns(F3, "textStroke") && (F3.stroke = F3.textStroke);
        }
        var j = void 0, U3 = O4t(a) ? L.decal : null;
        l2 && U3 && (U3.dirty = true, j = xrt(U3, l2)), L.__decalPattern = j;
      }
      if (R4t(a) && L) {
        var j = L.__decalPattern;
        j && (L.decal = j);
      }
      Cmt(a, d2, x2, { dataIndex: e2, isInit: C, clearStyle: true }), Amt(a, d2.keyframeAnimation, x2);
    }
    function rhe(l2, a, e2, d2, y2) {
      var x2 = a.isGroup ? null : a, C = y2 && y2[l2].cfg;
      if (x2) {
        var D2 = x2.ensureState(l2);
        if (d2 === false) {
          var L = x2.getState(l2);
          L && (L.style = null);
        } else
          D2.style = d2 || null;
        C && (D2.textConfig = C), SO(x2);
      }
    }
    function Lln(l2, a, e2) {
      if (!l2.isGroup) {
        var d2 = l2, y2 = e2.currentZ, x2 = e2.currentZLevel;
        d2.z = y2, d2.zlevel = x2;
        var C = a.z2;
        C != null && (d2.z2 = C || 0);
        for (var D2 = 0; D2 < uF.length; D2++)
          Oln(d2, a, uF[D2]);
      }
    }
    function Oln(l2, a, e2) {
      var d2 = e2 === lF, y2 = d2 ? a : Imt(a, e2), x2 = y2 ? y2.z2 : null, C;
      x2 != null && (C = d2 ? l2 : l2.ensureState(e2), C.z2 = x2 || 0);
    }
    function ihe(l2, a, e2, d2) {
      var y2 = l2.get("renderItem"), x2 = l2.coordinateSystem, C = {};
      x2 && (C = x2.prepareCustoms ? x2.prepareCustoms(x2) : Dln[x2.type](x2));
      for (var D2 = El({ getWidth: d2.getWidth, getHeight: d2.getHeight, getZr: d2.getZr, getDevicePixelRatio: d2.getDevicePixelRatio, value: Rt, style: ne2, ordinalRawValue: le2, styleEmphasis: he2, visual: Pe2, barLayout: Be2, currentSeriesIndices: Je2, font: Ze2 }, C.api || {}), L = { context: {}, seriesId: l2.id, seriesName: l2.name, seriesIndex: l2.seriesIndex, coordSys: C.coordSys, dataInsideLength: a.count(), encode: Rln(l2.getData()) }, F3, j, U3 = {}, Y3 = {}, Q = {}, nt = {}, dt = 0; dt < uF.length; dt++) {
        var vt = uF[dt];
        Q[vt] = l2.getModel(P4t[vt]), nt[vt] = l2.getModel(L4t[vt]);
      }
      function Ct(Cn) {
        return Cn === F3 ? j || (j = a.getItemModel(Cn)) : a.getItemModel(Cn);
      }
      function Pt(Cn, Bn) {
        return a.hasItemOption ? Cn === F3 ? U3[Bn] || (U3[Bn] = Ct(Cn).getModel(P4t[Bn])) : Ct(Cn).getModel(P4t[Bn]) : Q[Bn];
      }
      function jt(Cn, Bn) {
        return a.hasItemOption ? Cn === F3 ? Y3[Bn] || (Y3[Bn] = Ct(Cn).getModel(L4t[Bn])) : Ct(Cn).getModel(L4t[Bn]) : nt[Bn];
      }
      return function(Cn, Bn) {
        return F3 = Cn, j = null, U3 = {}, Y3 = {}, y2 && y2(El({ dataIndexInside: Cn, dataIndex: a.getRawIndex(Cn), actionType: Bn ? Bn.type : null }, L), D2);
      };
      function Rt(Cn, Bn) {
        return Bn == null && (Bn = F3), a.getStore().get(a.getDimensionIndex(Cn || 0), Bn);
      }
      function le2(Cn, Bn) {
        Bn == null && (Bn = F3), Cn = Cn || 0;
        var mn = a.getDimensionInfo(Cn);
        if (!mn) {
          var Kr = a.getDimensionIndex(Cn);
          return Kr >= 0 ? a.getStore().get(Kr, Bn) : void 0;
        }
        var Kn = a.get(mn.name, Bn), ar = mn && mn.ordinalMeta;
        return ar ? ar.categories[Kn] : Kn;
      }
      function ne2(Cn, Bn) {
        Bn == null && (Bn = F3);
        var mn = a.getItemVisual(Bn, "style"), Kr = mn && mn.fill, Kn = mn && mn.opacity, ar = Pt(Bn, lF).getItemStyle();
        Kr != null && (ar.fill = Kr), Kn != null && (ar.opacity = Kn);
        var Cr = { inheritColor: ps(Kr) ? Kr : "#000" }, ui2 = jt(Bn, lF), vi2 = _y(ui2, null, Cr, false, true);
        vi2.text = ui2.getShallow("show") ? $u(l2.getFormattedLabel(Bn, lF), oZ(a, Bn)) : null;
        var ko = J0t(ui2, Cr, false);
        return Me2(Cn, ar), ar = $fe(ar, vi2, ko), Cn && _e(ar, Cn), ar.legacy = true, ar;
      }
      function he2(Cn, Bn) {
        Bn == null && (Bn = F3);
        var mn = Pt(Bn, BO).getItemStyle(), Kr = jt(Bn, BO), Kn = _y(Kr, null, null, true, true);
        Kn.text = Kr.getShallow("show") ? uv(l2.getFormattedLabel(Bn, BO), l2.getFormattedLabel(Bn, lF), oZ(a, Bn)) : null;
        var ar = J0t(Kr, null, true);
        return Me2(Cn, mn), mn = $fe(mn, Kn, ar), Cn && _e(mn, Cn), mn.legacy = true, mn;
      }
      function _e(Cn, Bn) {
        for (var mn in Bn)
          Ns(Bn, mn) && (Cn[mn] = Bn[mn]);
      }
      function Me2(Cn, Bn) {
        Cn && (Cn.textFill && (Bn.textFill = Cn.textFill), Cn.textPosition && (Bn.textPosition = Cn.textPosition));
      }
      function Pe2(Cn, Bn) {
        if (Bn == null && (Bn = F3), Ns(Hfe, Cn)) {
          var mn = a.getItemVisual(Bn, "style");
          return mn ? mn[Hfe[Cn]] : null;
        }
        if (Ns(aln, Cn))
          return a.getItemVisual(Bn, Cn);
      }
      function Be2(Cn) {
        if (x2.type === "cartesian2d") {
          var Bn = x2.getBaseAxis();
          return NXe(El({ axis: Bn }, Cn));
        }
      }
      function Je2() {
        return e2.getCurrentSeriesIndices();
      }
      function Ze2(Cn) {
        return Ure(Cn, e2);
      }
    }
    function Rln(l2) {
      var a = {};
      return Ke2(l2.dimensions, function(e2) {
        var d2 = l2.getDimensionInfo(e2);
        if (!d2.isExtraCoord) {
          var y2 = d2.coordDim, x2 = a[y2] = a[y2] || [];
          x2[d2.coordDimIndex] = l2.getDimensionIndex(e2);
        }
      }), a;
    }
    function V4t(l2, a, e2, d2, y2, x2, C) {
      if (!d2) {
        x2.remove(a);
        return;
      }
      var D2 = B4t(l2, a, e2, d2, y2, x2);
      return D2 && C.setItemGraphicEl(e2, D2), D2 && n0(D2, d2.focus, d2.blurScope, d2.emphasisDisabled), D2;
    }
    function B4t(l2, a, e2, d2, y2, x2) {
      var C = -1, D2 = a;
      a && ahe(a, d2, y2) && (C = oc2(x2.childrenRef(), a), a = null);
      var L = !a, F3 = a;
      F3 ? F3.clearStates() : (F3 = N4t(d2), D2 && Eln(D2, F3)), d2.morph === false ? F3.disableMorphing = true : F3.disableMorphing && (F3.disableMorphing = false), PA.normal.cfg = PA.normal.conOpt = PA.emphasis.cfg = PA.emphasis.conOpt = PA.blur.cfg = PA.blur.conOpt = PA.select.cfg = PA.select.conOpt = null, PA.isLegacy = false, Fln(F3, e2, d2, y2, L, PA), Nln(F3, e2, d2, y2, L), F4t(l2, F3, e2, d2, PA, y2, L), Ns(d2, "info") && (VO(F3).info = d2.info);
      for (var j = 0; j < uF.length; j++) {
        var U3 = uF[j];
        if (U3 !== lF) {
          var Y3 = Imt(d2, U3), Q = z4t(d2, Y3, U3);
          rhe(U3, F3, Y3, Q, PA);
        }
      }
      return Lln(F3, d2, y2), d2.type === "group" && Vln(l2, F3, e2, d2, y2), C >= 0 ? x2.replaceAt(F3, C) : x2.add(F3), F3;
    }
    function ahe(l2, a, e2) {
      var d2 = VO(l2), y2 = a.type, x2 = a.shape, C = a.style;
      return e2.isUniversalTransitionEnabled() || y2 != null && y2 !== d2.customGraphicType || y2 === "path" && jln(x2) && uhe(x2) !== d2.customPathData || y2 === "image" && Ns(C, "image") && C.image !== d2.customImagePath;
    }
    function Nln(l2, a, e2, d2, y2) {
      var x2 = e2.clipPath;
      if (x2 === false)
        l2 && l2.getClipPath() && l2.removeClipPath();
      else if (x2) {
        var C = l2.getClipPath();
        C && ahe(C, x2, d2) && (C = null), C || (C = N4t(x2), l2.setClipPath(C)), F4t(null, C, a, x2, null, d2, y2);
      }
    }
    function Fln(l2, a, e2, d2, y2, x2) {
      if (!l2.isGroup) {
        ohe(e2, null, x2), ohe(e2, BO, x2);
        var C = x2.normal.conOpt, D2 = x2.emphasis.conOpt, L = x2.blur.conOpt, F3 = x2.select.conOpt;
        if (C != null || D2 != null || F3 != null || L != null) {
          var j = l2.getTextContent();
          if (C === false)
            j && l2.removeTextContent();
          else {
            C = x2.normal.conOpt = C || { type: "text" }, j ? j.clearStates() : (j = N4t(C), l2.setTextContent(j)), F4t(null, j, a, C, null, d2, y2);
            for (var U3 = C && C.style, Y3 = 0; Y3 < uF.length; Y3++) {
              var Q = uF[Y3];
              if (Q !== lF) {
                var nt = x2[Q].conOpt;
                rhe(Q, j, nt, z4t(C, nt, Q), null);
              }
            }
            U3 ? j.dirty() : j.markRedraw();
          }
        }
      }
    }
    function ohe(l2, a, e2) {
      var d2 = a ? Imt(l2, a) : l2, y2 = a ? z4t(l2, d2, BO) : l2.style, x2 = l2.type, C = d2 ? d2.textConfig : null, D2 = l2.textContent, L = D2 ? a ? Imt(D2, a) : D2 : null;
      if (y2 && (e2.isLegacy || Ufe(y2, x2, !!C, !!L))) {
        e2.isLegacy = true;
        var F3 = qfe(y2, x2, !a);
        !C && F3.textConfig && (C = F3.textConfig), !L && F3.textContent && (L = F3.textContent);
      }
      if (!a && L) {
        var j = L;
        !j.type && (j.type = "text");
      }
      var U3 = a ? e2[a] : e2.normal;
      U3.cfg = C, U3.conOpt = L;
    }
    function Imt(l2, a) {
      return a ? l2 ? l2[a] : null : l2;
    }
    function z4t(l2, a, e2) {
      var d2 = a && a.style;
      return d2 == null && e2 === BO && l2 && (d2 = l2.styleEmphasis), d2;
    }
    function Vln(l2, a, e2, d2, y2) {
      var x2 = d2.children, C = x2 ? x2.length : 0, D2 = d2.$mergeChildren, L = D2 === "byName" || d2.diffChildrenByName, F3 = D2 === false;
      if (!(!C && !L && !F3)) {
        if (L) {
          Bln({ api: l2, oldChildren: a.children() || [], newChildren: x2 || [], dataIndex: e2, seriesModel: y2, group: a });
          return;
        }
        F3 && a.removeAll();
        for (var j = 0; j < C; j++)
          x2[j] && B4t(l2, a.childAt(j), e2, x2[j], y2, a);
        for (var U3 = a.childCount() - 1; U3 >= j; U3--) {
          var Y3 = a.childAt(U3);
          Tmt(Y3, VO(a).option, y2);
        }
      }
    }
    function Bln(l2) {
      new kO(l2.oldChildren, l2.newChildren, she, she, l2).add(lhe).update(lhe).remove(zln).execute();
    }
    function she(l2, a) {
      var e2 = l2 && l2.name;
      return e2 != null ? e2 : Iln + a;
    }
    function lhe(l2, a) {
      var e2 = this.context, d2 = l2 != null ? e2.newChildren[l2] : null, y2 = a != null ? e2.oldChildren[a] : null;
      B4t(e2.api, y2, e2.dataIndex, d2, e2.seriesModel, e2.group);
    }
    function zln(l2) {
      var a = this.context, e2 = a.oldChildren[l2];
      Tmt(e2, VO(e2).option, a.seriesModel);
    }
    function uhe(l2) {
      return l2 && (l2.pathData || l2.d);
    }
    function jln(l2) {
      return l2 && (Ns(l2, "pathData") || Ns(l2, "d"));
    }
    function Wln(l2) {
      l2.registerChartView(Pln), l2.registerSeriesModel(sln);
    }
    var DB = Rf2(), che = zl, j4t = As, Gln = function() {
      function l2() {
        this._dragging = false, this.animationThreshold = 15;
      }
      return l2.prototype.render = function(a, e2, d2, y2) {
        var x2 = e2.get("value"), C = e2.get("status");
        if (this._axisModel = a, this._axisPointerModel = e2, this._api = d2, !(!y2 && this._lastValue === x2 && this._lastStatus === C)) {
          this._lastValue = x2, this._lastStatus = C;
          var D2 = this._group, L = this._handle;
          if (!C || C === "hide") {
            D2 && D2.hide(), L && L.hide();
            return;
          }
          D2 && D2.show(), L && L.show();
          var F3 = {};
          this.makeElOption(F3, x2, a, e2, d2);
          var j = F3.graphicKey;
          j !== this._lastGraphicKey && this.clear(d2), this._lastGraphicKey = j;
          var U3 = this._moveAnimation = this.determineAnimation(a, e2);
          if (!D2)
            D2 = this._group = new ou(), this.createPointerEl(D2, F3, a, e2), this.createLabelEl(D2, F3, a, e2), d2.getZr().add(D2);
          else {
            var Y3 = xu(fhe, e2, U3);
            this.updatePointerEl(D2, F3, Y3), this.updateLabelEl(D2, F3, Y3, e2);
          }
          dhe(D2, e2, true), this._renderHandle(x2);
        }
      }, l2.prototype.remove = function(a) {
        this.clear(a);
      }, l2.prototype.dispose = function(a) {
        this.clear(a);
      }, l2.prototype.determineAnimation = function(a, e2) {
        var d2 = e2.get("animation"), y2 = a.axis, x2 = y2.type === "category", C = e2.get("snap");
        if (!C && !x2)
          return false;
        if (d2 === "auto" || d2 == null) {
          var D2 = this.animationThreshold;
          if (x2 && y2.getBandWidth() > D2)
            return true;
          if (C) {
            var L = gOt(a).seriesDataCount, F3 = y2.getExtent();
            return Math.abs(F3[0] - F3[1]) / L > D2;
          }
          return false;
        }
        return d2 === true;
      }, l2.prototype.makeElOption = function(a, e2, d2, y2, x2) {
      }, l2.prototype.createPointerEl = function(a, e2, d2, y2) {
        var x2 = e2.pointer;
        if (x2) {
          var C = DB(a).pointerEl = new nrt[x2.type](che(e2.pointer));
          a.add(C);
        }
      }, l2.prototype.createLabelEl = function(a, e2, d2, y2) {
        if (e2.label) {
          var x2 = DB(a).labelEl = new qc2(che(e2.label));
          a.add(x2), phe(x2, y2);
        }
      }, l2.prototype.updatePointerEl = function(a, e2, d2) {
        var y2 = DB(a).pointerEl;
        y2 && e2.pointer && (y2.setStyle(e2.pointer.style), d2(y2, { shape: e2.pointer.shape }));
      }, l2.prototype.updateLabelEl = function(a, e2, d2, y2) {
        var x2 = DB(a).labelEl;
        x2 && (x2.setStyle(e2.label.style), d2(x2, { x: e2.label.x, y: e2.label.y }), phe(x2, y2));
      }, l2.prototype._renderHandle = function(a) {
        if (!(this._dragging || !this.updateHandleTransform)) {
          var e2 = this._axisPointerModel, d2 = this._api.getZr(), y2 = this._handle, x2 = e2.getModel("handle"), C = e2.get("status");
          if (!x2.get("show") || !C || C === "hide") {
            y2 && d2.remove(y2), this._handle = null;
            return;
          }
          var D2;
          this._handle || (D2 = true, y2 = this._handle = fv(x2.get("icon"), { cursor: "move", draggable: true, onmousemove: function(F3) {
            yE(F3.event);
          }, onmousedown: j4t(this._onHandleDragMove, this, 0, 0), drift: j4t(this._onHandleDragMove, this), ondragend: j4t(this._onHandleDragEnd, this) }), d2.add(y2)), dhe(y2, e2, false), y2.setStyle(x2.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
          var L = x2.get("size");
          Ba2(L) || (L = [L, L]), y2.scaleX = L[0] / 2, y2.scaleY = L[1] / 2, Xq(this, "_doDispatchAxisPointer", x2.get("throttle") || 0, "fixRate"), this._moveHandleToValue(a, D2);
        }
      }, l2.prototype._moveHandleToValue = function(a, e2) {
        fhe(this._axisPointerModel, !e2 && this._moveAnimation, this._handle, W4t(this.getHandleTransform(a, this._axisModel, this._axisPointerModel)));
      }, l2.prototype._onHandleDragMove = function(a, e2) {
        var d2 = this._handle;
        if (d2) {
          this._dragging = true;
          var y2 = this.updateHandleTransform(W4t(d2), [a, e2], this._axisModel, this._axisPointerModel);
          this._payloadInfo = y2, d2.stopAnimation(), d2.attr(W4t(y2)), DB(d2).lastProp = null, this._doDispatchAxisPointer();
        }
      }, l2.prototype._doDispatchAxisPointer = function() {
        var a = this._handle;
        if (a) {
          var e2 = this._payloadInfo, d2 = this._axisModel;
          this._api.dispatchAction({ type: "updateAxisPointer", x: e2.cursorPoint[0], y: e2.cursorPoint[1], tooltipOption: e2.tooltipOption, axesInfo: [{ axisDim: d2.axis.dim, axisIndex: d2.componentIndex }] });
        }
      }, l2.prototype._onHandleDragEnd = function() {
        this._dragging = false;
        var a = this._handle;
        if (a) {
          var e2 = this._axisPointerModel.get("value");
          this._moveHandleToValue(e2), this._api.dispatchAction({ type: "hideTip" });
        }
      }, l2.prototype.clear = function(a) {
        this._lastValue = null, this._lastStatus = null;
        var e2 = a.getZr(), d2 = this._group, y2 = this._handle;
        e2 && d2 && (this._lastGraphicKey = null, d2 && e2.remove(d2), y2 && e2.remove(y2), this._group = null, this._handle = null, this._payloadInfo = null), grt(this, "_doDispatchAxisPointer");
      }, l2.prototype.doClear = function() {
      }, l2.prototype.buildLabel = function(a, e2, d2) {
        return d2 = d2 || 0, { x: a[d2], y: a[1 - d2], width: e2[d2], height: e2[1 - d2] };
      }, l2;
    }();
    function fhe(l2, a, e2, d2) {
      hhe(DB(e2).lastProp, d2) || (DB(e2).lastProp = d2, a ? Yf2(e2, d2, l2) : (e2.stopAnimation(), e2.attr(d2)));
    }
    function hhe(l2, a) {
      if (vs(l2) && vs(a)) {
        var e2 = true;
        return Ke2(a, function(d2, y2) {
          e2 = e2 && hhe(l2[y2], d2);
        }), !!e2;
      } else
        return l2 === a;
    }
    function phe(l2, a) {
      l2[a.get(["label", "show"]) ? "show" : "hide"]();
    }
    function W4t(l2) {
      return { x: l2.x || 0, y: l2.y || 0, rotation: l2.rotation || 0 };
    }
    function dhe(l2, a, e2) {
      var d2 = a.get("z"), y2 = a.get("zlevel");
      l2 && l2.traverse(function(x2) {
        x2.type !== "group" && (d2 != null && (x2.z = d2), y2 != null && (x2.zlevel = y2), x2.silent = e2);
      });
    }
    var G4t = Gln;
    function H4t(l2) {
      var a = l2.get("type"), e2 = l2.getModel(a + "Style"), d2;
      return a === "line" ? (d2 = e2.getLineStyle(), d2.fill = null) : a === "shadow" && (d2 = e2.getAreaStyle(), d2.stroke = null), d2;
    }
    function ghe(l2, a, e2, d2, y2) {
      var x2 = e2.get("value"), C = vhe(x2, a.axis, a.ecModel, e2.get("seriesDataIndices"), { precision: e2.get(["label", "precision"]), formatter: e2.get(["label", "formatter"]) }), D2 = e2.getModel("label"), L = Gq(D2.get("padding") || 0), F3 = D2.getFont(), j = uO(C, F3), U3 = y2.position, Y3 = j.width + L[1] + L[3], Q = j.height + L[0] + L[2], nt = y2.align;
      nt === "right" && (U3[0] -= Y3), nt === "center" && (U3[0] -= Y3 / 2);
      var dt = y2.verticalAlign;
      dt === "bottom" && (U3[1] -= Q), dt === "middle" && (U3[1] -= Q / 2), Hln(U3, Y3, Q, d2);
      var vt = D2.get("backgroundColor");
      (!vt || vt === "auto") && (vt = a.get(["axisLine", "lineStyle", "color"])), l2.label = { x: U3[0], y: U3[1], style: _y(D2, { text: C, font: F3, fill: D2.getTextColor(), padding: L, backgroundColor: vt }), z2: 10 };
    }
    function Hln(l2, a, e2, d2) {
      var y2 = d2.getWidth(), x2 = d2.getHeight();
      l2[0] = Math.min(l2[0] + a, y2) - a, l2[1] = Math.min(l2[1] + e2, x2) - e2, l2[0] = Math.max(l2[0], 0), l2[1] = Math.max(l2[1], 0);
    }
    function vhe(l2, a, e2, d2, y2) {
      l2 = a.scale.parse(l2);
      var x2 = a.scale.getLabel({ value: l2 }, { precision: y2.precision }), C = y2.formatter;
      if (C) {
        var D2 = { value: FLt(a, { value: l2 }), axisDimension: a.dim, axisIndex: a.index, seriesData: [] };
        Ke2(d2, function(L) {
          var F3 = e2.getSeriesByIndex(L.seriesIndex), j = L.dataIndexInside, U3 = F3 && F3.getDataParams(j);
          U3 && D2.seriesData.push(U3);
        }), ps(C) ? x2 = C.replace("{value}", x2) : wl(C) && (x2 = C(D2));
      }
      return x2;
    }
    function U4t(l2, a, e2) {
      var d2 = Xx();
      return oO(d2, d2, e2.rotation), LS(d2, d2, e2.position), hc2([l2.dataToCoord(a), (e2.labelOffset || 0) + (e2.labelDirection || 1) * (e2.labelMargin || 0)], d2);
    }
    function yhe(l2, a, e2, d2, y2, x2) {
      var C = RO.innerTextLayout(e2.rotation, 0, e2.labelDirection);
      e2.labelMargin = y2.get(["label", "margin"]), ghe(a, d2, y2, x2, { position: U4t(d2.axis, l2, e2), align: C.textAlign, verticalAlign: C.textVerticalAlign });
    }
    function q4t(l2, a, e2) {
      return e2 = e2 || 0, { x1: l2[e2], y1: l2[1 - e2], x2: a[e2], y2: a[1 - e2] };
    }
    function mhe(l2, a, e2) {
      return e2 = e2 || 0, { x: l2[e2], y: l2[1 - e2], width: a[e2], height: a[1 - e2] };
    }
    function bhe(l2, a, e2, d2, y2, x2) {
      return { cx: l2, cy: a, r0: e2, r: d2, startAngle: y2, endAngle: x2, clockwise: true };
    }
    var Uln = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.makeElOption = function(e2, d2, y2, x2, C) {
        var D2 = y2.axis, L = D2.grid, F3 = x2.get("type"), j = _he(L, D2).getOtherAxis(D2).getGlobalExtent(), U3 = D2.toGlobalCoord(D2.dataToCoord(d2, true));
        if (F3 && F3 !== "none") {
          var Y3 = H4t(x2), Q = qln[F3](D2, U3, j);
          Q.style = Y3, e2.graphicKey = Q.type, e2.pointer = Q;
        }
        var nt = fOt(L.model, y2);
        yhe(d2, e2, nt, y2, x2, C);
      }, a.prototype.getHandleTransform = function(e2, d2, y2) {
        var x2 = fOt(d2.axis.grid.model, d2, { labelInside: false });
        x2.labelMargin = y2.get(["handle", "margin"]);
        var C = U4t(d2.axis, e2, x2);
        return { x: C[0], y: C[1], rotation: x2.rotation + (x2.labelDirection < 0 ? Math.PI : 0) };
      }, a.prototype.updateHandleTransform = function(e2, d2, y2, x2) {
        var C = y2.axis, D2 = C.grid, L = C.getGlobalExtent(true), F3 = _he(D2, C).getOtherAxis(C).getGlobalExtent(), j = C.dim === "x" ? 0 : 1, U3 = [e2.x, e2.y];
        U3[j] += d2[j], U3[j] = Math.min(L[1], U3[j]), U3[j] = Math.max(L[0], U3[j]);
        var Y3 = (F3[1] + F3[0]) / 2, Q = [Y3, Y3];
        Q[j] = U3[j];
        var nt = [{ verticalAlign: "middle" }, { align: "center" }];
        return { x: U3[0], y: U3[1], rotation: e2.rotation, cursorPoint: Q, tooltipOption: nt[j] };
      }, a;
    }(G4t);
    function _he(l2, a) {
      var e2 = {};
      return e2[a.dim + "AxisIndex"] = a.index, l2.getCartesian(e2);
    }
    var qln = { line: function(l2, a, e2) {
      var d2 = q4t([a, e2[0]], [a, e2[1]], xhe(l2));
      return { type: "Line", subPixelOptimize: true, shape: d2 };
    }, shadow: function(l2, a, e2) {
      var d2 = Math.max(1, l2.getBandWidth()), y2 = e2[1] - e2[0];
      return { type: "Rect", shape: mhe([a - d2 / 2, e2[0]], [d2, y2], xhe(l2)) };
    } };
    function xhe(l2) {
      return l2.dim === "x" ? 0 : 1;
    }
    var Zln = Uln, $ln = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "axisPointer", a.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, a;
    }(Ah2), Yln = $ln, zO = Rf2(), Kln = Ke2;
    function whe(l2, a, e2) {
      if (!$s.node) {
        var d2 = a.getZr();
        zO(d2).records || (zO(d2).records = {}), Xln(d2, a);
        var y2 = zO(d2).records[l2] || (zO(d2).records[l2] = {});
        y2.handler = e2;
      }
    }
    function Xln(l2, a) {
      if (zO(l2).initialized)
        return;
      zO(l2).initialized = true, e2("click", xu(She, "click")), e2("mousemove", xu(She, "mousemove")), e2("globalout", Jln);
      function e2(d2, y2) {
        l2.on(d2, function(x2) {
          var C = tun(a);
          Kln(zO(l2).records, function(D2) {
            D2 && y2(D2, x2, C.dispatchAction);
          }), Qln(C.pendings, a);
        });
      }
    }
    function Qln(l2, a) {
      var e2 = l2.showTip.length, d2 = l2.hideTip.length, y2;
      e2 ? y2 = l2.showTip[e2 - 1] : d2 && (y2 = l2.hideTip[d2 - 1]), y2 && (y2.dispatchAction = null, a.dispatchAction(y2));
    }
    function Jln(l2, a, e2) {
      l2.handler("leave", null, e2);
    }
    function She(l2, a, e2, d2) {
      a.handler(l2, e2, d2);
    }
    function tun(l2) {
      var a = { showTip: [], hideTip: [] }, e2 = function(d2) {
        var y2 = a[d2.type];
        y2 ? y2.push(d2) : (d2.dispatchAction = e2, l2.dispatchAction(d2));
      };
      return { dispatchAction: e2, pendings: a };
    }
    function Z4t(l2, a) {
      if (!$s.node) {
        var e2 = a.getZr(), d2 = (zO(e2).records || {})[l2];
        d2 && (zO(e2).records[l2] = null);
      }
    }
    var eun = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = d2.getComponent("tooltip"), C = e2.get("triggerOn") || x2 && x2.get("triggerOn") || "mousemove|click";
        whe("axisPointer", y2, function(D2, L, F3) {
          C !== "none" && (D2 === "leave" || C.indexOf(D2) >= 0) && F3({ type: "updateAxisPointer", currTrigger: D2, x: L && L.offsetX, y: L && L.offsetY });
        });
      }, a.prototype.remove = function(e2, d2) {
        Z4t("axisPointer", d2);
      }, a.prototype.dispose = function(e2, d2) {
        Z4t("axisPointer", d2);
      }, a.type = "axisPointer", a;
    }(_0), nun = eun;
    function Mhe(l2, a) {
      var e2 = [], d2 = l2.seriesIndex, y2;
      if (d2 == null || !(y2 = a.getSeriesByIndex(d2)))
        return { point: [] };
      var x2 = y2.getData(), C = fC(x2, l2);
      if (C == null || C < 0 || Ba2(C))
        return { point: [] };
      var D2 = x2.getItemGraphicEl(C), L = y2.coordinateSystem;
      if (y2.getTooltipPosition)
        e2 = y2.getTooltipPosition(C) || [];
      else if (L && L.dataToPoint)
        if (l2.isStacked) {
          var F3 = L.getBaseAxis(), j = L.getOtherAxis(F3), U3 = j.dim, Y3 = F3.dim, Q = U3 === "x" || U3 === "radius" ? 1 : 0, nt = x2.mapDimension(Y3), dt = [];
          dt[Q] = x2.get(nt, C), dt[1 - Q] = x2.get(x2.getCalculationInfo("stackResultDimension"), C), e2 = L.dataToPoint(dt) || [];
        } else
          e2 = L.dataToPoint(x2.getValues($a2(L.dimensions, function(Ct) {
            return x2.mapDimension(Ct);
          }), C)) || [];
      else if (D2) {
        var vt = D2.getBoundingRect().clone();
        vt.applyTransform(D2.transform), e2 = [vt.x + vt.width / 2, vt.y + vt.height / 2];
      }
      return { point: e2, el: D2 };
    }
    var Che = Rf2();
    function run(l2, a, e2) {
      var d2 = l2.currTrigger, y2 = [l2.x, l2.y], x2 = l2, C = l2.dispatchAction || As(e2.dispatchAction, e2), D2 = a.getComponent("axisPointer").coordSysAxesInfo;
      if (D2) {
        Dmt(y2) && (y2 = Mhe({ seriesIndex: x2.seriesIndex, dataIndex: x2.dataIndex }, a).point);
        var L = Dmt(y2), F3 = x2.axesInfo, j = D2.axesInfo, U3 = d2 === "leave" || Dmt(y2), Y3 = {}, Q = {}, nt = { list: [], map: {} }, dt = { showPointer: xu(aun, Q), showTooltip: xu(oun, nt) };
        Ke2(D2.coordSysMap, function(Ct, Pt) {
          var jt = L || Ct.containPoint(y2);
          Ke2(D2.coordSysAxesInfo[Pt], function(Rt, le2) {
            var ne2 = Rt.axis, he2 = cun(F3, Rt);
            if (!U3 && jt && (!F3 || he2)) {
              var _e = he2 && he2.value;
              _e == null && !L && (_e = ne2.pointToData(y2)), _e != null && The(Rt, _e, dt, false, Y3);
            }
          });
        });
        var vt = {};
        return Ke2(j, function(Ct, Pt) {
          var jt = Ct.linkGroup;
          jt && !Q[Pt] && Ke2(jt.axesInfo, function(Rt, le2) {
            var ne2 = Q[le2];
            if (Rt !== Ct && ne2) {
              var he2 = ne2.value;
              jt.mapper && (he2 = Ct.axis.scale.parse(jt.mapper(he2, Ahe(Rt), Ahe(Ct)))), vt[Ct.key] = he2;
            }
          });
        }), Ke2(vt, function(Ct, Pt) {
          The(j[Pt], Ct, dt, true, Y3);
        }), sun(Q, j, Y3), lun(nt, y2, l2, C), uun(j, C, e2), Y3;
      }
    }
    function The(l2, a, e2, d2, y2) {
      var x2 = l2.axis;
      if (!(x2.scale.isBlank() || !x2.containData(a))) {
        if (!l2.involveSeries) {
          e2.showPointer(l2, a);
          return;
        }
        var C = iun(a, l2), D2 = C.payloadBatch, L = C.snapToValue;
        D2[0] && y2.seriesIndex == null && la2(y2, D2[0]), !d2 && l2.snap && x2.containData(L) && L != null && (a = L), e2.showPointer(l2, a, D2), e2.showTooltip(l2, C, L);
      }
    }
    function iun(l2, a) {
      var e2 = a.axis, d2 = e2.dim, y2 = l2, x2 = [], C = Number.MAX_VALUE, D2 = -1;
      return Ke2(a.seriesModels, function(L, F3) {
        var j = L.getData().mapDimensionsAll(d2), U3, Y3;
        if (L.getAxisTooltipData) {
          var Q = L.getAxisTooltipData(j, l2, e2);
          Y3 = Q.dataIndices, U3 = Q.nestestValue;
        } else {
          if (Y3 = L.getData().indicesOfNearest(j[0], l2, e2.type === "category" ? 0.5 : null), !Y3.length)
            return;
          U3 = L.getData().get(j[0], Y3[0]);
        }
        if (!(U3 == null || !isFinite(U3))) {
          var nt = l2 - U3, dt = Math.abs(nt);
          dt <= C && ((dt < C || nt >= 0 && D2 < 0) && (C = dt, D2 = nt, y2 = U3, x2.length = 0), Ke2(Y3, function(vt) {
            x2.push({ seriesIndex: L.seriesIndex, dataIndexInside: vt, dataIndex: L.getData().getRawIndex(vt) });
          }));
        }
      }), { payloadBatch: x2, snapToValue: y2 };
    }
    function aun(l2, a, e2, d2) {
      l2[a.key] = { value: e2, payloadBatch: d2 };
    }
    function oun(l2, a, e2, d2) {
      var y2 = e2.payloadBatch, x2 = a.axis, C = x2.model, D2 = a.axisPointerModel;
      if (!(!a.triggerTooltip || !y2.length)) {
        var L = a.coordSys.model, F3 = Urt(L), j = l2.map[F3];
        j || (j = l2.map[F3] = { coordSysId: L.id, coordSysIndex: L.componentIndex, coordSysType: L.type, coordSysMainType: L.mainType, dataByAxis: [] }, l2.list.push(j)), j.dataByAxis.push({ axisDim: x2.dim, axisIndex: C.componentIndex, axisType: C.type, axisId: C.id, value: d2, valueLabelOpt: { precision: D2.get(["label", "precision"]), formatter: D2.get(["label", "formatter"]) }, seriesDataIndices: y2.slice() });
      }
    }
    function sun(l2, a, e2) {
      var d2 = e2.axesInfo = [];
      Ke2(a, function(y2, x2) {
        var C = y2.axisPointerModel.option, D2 = l2[x2];
        D2 ? (!y2.useHandle && (C.status = "show"), C.value = D2.value, C.seriesDataIndices = (D2.payloadBatch || []).slice()) : !y2.useHandle && (C.status = "hide"), C.status === "show" && d2.push({ axisDim: y2.axis.dim, axisIndex: y2.axis.model.componentIndex, value: C.value });
      });
    }
    function lun(l2, a, e2, d2) {
      if (Dmt(a) || !l2.list.length) {
        d2({ type: "hideTip" });
        return;
      }
      var y2 = ((l2.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
      d2({ type: "showTip", escapeConnect: true, x: a[0], y: a[1], tooltipOption: e2.tooltipOption, position: e2.position, dataIndexInside: y2.dataIndexInside, dataIndex: y2.dataIndex, seriesIndex: y2.seriesIndex, dataByCoordSys: l2.list });
    }
    function uun(l2, a, e2) {
      var d2 = e2.getZr(), y2 = "axisPointerLastHighlights", x2 = Che(d2)[y2] || {}, C = Che(d2)[y2] = {};
      Ke2(l2, function(F3, j) {
        var U3 = F3.axisPointerModel.option;
        U3.status === "show" && Ke2(U3.seriesDataIndices, function(Y3) {
          var Q = Y3.seriesIndex + " | " + Y3.dataIndex;
          C[Q] = Y3;
        });
      });
      var D2 = [], L = [];
      Ke2(x2, function(F3, j) {
        !C[j] && L.push(F3);
      }), Ke2(C, function(F3, j) {
        !x2[j] && D2.push(F3);
      }), L.length && e2.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: L }), D2.length && e2.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: D2 });
    }
    function cun(l2, a) {
      for (var e2 = 0; e2 < (l2 || []).length; e2++) {
        var d2 = l2[e2];
        if (a.axis.dim === d2.axisDim && a.axis.model.componentIndex === d2.axisIndex)
          return d2;
      }
    }
    function Ahe(l2) {
      var a = l2.axis.model, e2 = {}, d2 = e2.axisDim = l2.axis.dim;
      return e2.axisIndex = e2[d2 + "AxisIndex"] = a.componentIndex, e2.axisName = e2[d2 + "AxisName"] = a.name, e2.axisId = e2[d2 + "AxisId"] = a.id, e2;
    }
    function Dmt(l2) {
      return !l2 || l2[0] == null || isNaN(l2[0]) || l2[1] == null || isNaN(l2[1]);
    }
    function uit(l2) {
      bB.registerAxisPointerClass("CartesianAxisPointer", Zln), l2.registerComponentModel(Yln), l2.registerComponentView(nun), l2.registerPreprocessor(function(a) {
        if (a) {
          (!a.axisPointer || a.axisPointer.length === 0) && (a.axisPointer = {});
          var e2 = a.axisPointer.link;
          e2 && !Ba2(e2) && (a.axisPointer.link = [e2]);
        }
      }), l2.registerProcessor(l2.PRIORITY.PROCESSOR.STATISTIC, function(a, e2) {
        a.getComponent("axisPointer").coordSysAxesInfo = Qtn(a, e2);
      }), l2.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, run);
    }
    function fun(l2) {
      Oc2(nue), Oc2(uit);
    }
    var hun = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.makeElOption = function(e2, d2, y2, x2, C) {
        var D2 = y2.axis;
        D2.dim === "angle" && (this.animationThreshold = Math.PI / 18);
        var L = D2.polar, F3 = L.getOtherAxis(D2), j = F3.getExtent(), U3 = D2.dataToCoord(d2), Y3 = x2.get("type");
        if (Y3 && Y3 !== "none") {
          var Q = H4t(x2), nt = dun[Y3](D2, L, U3, j);
          nt.style = Q, e2.graphicKey = nt.type, e2.pointer = nt;
        }
        var dt = x2.get(["label", "margin"]), vt = pun(d2, y2, x2, L, dt);
        ghe(e2, y2, x2, C, vt);
      }, a;
    }(G4t);
    function pun(l2, a, e2, d2, y2) {
      var x2 = a.axis, C = x2.dataToCoord(l2), D2 = d2.getAngleAxis().getExtent()[0];
      D2 = D2 / 180 * Math.PI;
      var L = d2.getRadiusAxis().getExtent(), F3, j, U3;
      if (x2.dim === "radius") {
        var Y3 = Xx();
        oO(Y3, Y3, D2), LS(Y3, Y3, [d2.cx, d2.cy]), F3 = hc2([C, -y2], Y3);
        var Q = a.getModel("axisLabel").get("rotate") || 0, nt = RO.innerTextLayout(D2, Q * Math.PI / 180, -1);
        j = nt.textAlign, U3 = nt.textVerticalAlign;
      } else {
        var dt = L[1];
        F3 = d2.coordToPoint([dt + y2, C]);
        var vt = d2.cx, Ct = d2.cy;
        j = Math.abs(F3[0] - vt) / dt < 0.3 ? "center" : F3[0] > vt ? "left" : "right", U3 = Math.abs(F3[1] - Ct) / dt < 0.3 ? "middle" : F3[1] > Ct ? "top" : "bottom";
      }
      return { position: F3, align: j, verticalAlign: U3 };
    }
    var dun = { line: function(l2, a, e2, d2) {
      return l2.dim === "angle" ? { type: "Line", shape: q4t(a.coordToPoint([d2[0], e2]), a.coordToPoint([d2[1], e2])) } : { type: "Circle", shape: { cx: a.cx, cy: a.cy, r: e2 } };
    }, shadow: function(l2, a, e2, d2) {
      var y2 = Math.max(1, l2.getBandWidth()), x2 = Math.PI / 180;
      return l2.dim === "angle" ? { type: "Sector", shape: bhe(a.cx, a.cy, d2[0], d2[1], (-e2 - y2 / 2) * x2, (-e2 + y2 / 2) * x2) } : { type: "Sector", shape: bhe(a.cx, a.cy, e2 - y2 / 2, e2 + y2 / 2, 0, Math.PI * 2) };
    } }, gun = hun, vun = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.findAxisModel = function(e2) {
        var d2, y2 = this.ecModel;
        return y2.eachComponent(e2, function(x2) {
          x2.getCoordSysModel() === this && (d2 = x2);
        }, this), d2;
      }, a.type = "polar", a.dependencies = ["radiusAxis", "angleAxis"], a.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, a;
    }(Ah2), yun = vun, $4t = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.getCoordSysModel = function() {
        return this.getReferringComponents("polar", q0).models[0];
      }, a.type = "polarAxis", a;
    }(Ah2);
    v0($4t, Lrt);
    var mun = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "angleAxis", a;
    }($4t), bun = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "radiusAxis", a;
    }($4t), Y4t = function(l2) {
      Jn(a, l2);
      function a(e2, d2) {
        return l2.call(this, "radius", e2, d2) || this;
      }
      return a.prototype.pointToData = function(e2, d2) {
        return this.polar.pointToData(e2, d2)[this.dim === "radius" ? 0 : 1];
      }, a;
    }(kE);
    Y4t.prototype.dataToRadius = kE.prototype.dataToCoord, Y4t.prototype.radiusToData = kE.prototype.coordToData;
    var _un = Y4t, xun = Rf2(), K4t = function(l2) {
      Jn(a, l2);
      function a(e2, d2) {
        return l2.call(this, "angle", e2, d2 || [0, 360]) || this;
      }
      return a.prototype.pointToData = function(e2, d2) {
        return this.polar.pointToData(e2, d2)[this.dim === "radius" ? 0 : 1];
      }, a.prototype.calculateCategoryInterval = function() {
        var e2 = this, d2 = e2.getLabelModel(), y2 = e2.scale, x2 = y2.getExtent(), C = y2.count();
        if (x2[1] - x2[0] < 1)
          return 0;
        var D2 = x2[0], L = e2.dataToCoord(D2 + 1) - e2.dataToCoord(D2), F3 = Math.abs(L), j = uO(D2 == null ? "" : D2 + "", d2.getFont(), "center", "top"), U3 = Math.max(j.height, 7), Y3 = U3 / F3;
        isNaN(Y3) && (Y3 = 1 / 0);
        var Q = Math.max(0, Math.floor(Y3)), nt = xun(e2.model), dt = nt.lastAutoInterval, vt = nt.lastTickCount;
        return dt != null && vt != null && Math.abs(dt - Q) <= 1 && Math.abs(vt - C) <= 1 && dt > Q ? Q = dt : (nt.lastTickCount = C, nt.lastAutoInterval = Q), Q;
      }, a;
    }(kE);
    K4t.prototype.dataToAngle = kE.prototype.dataToCoord, K4t.prototype.angleToData = kE.prototype.coordToData;
    var wun = K4t, Ihe = ["radius", "angle"], Sun = function() {
      function l2(a) {
        this.dimensions = Ihe, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new _un(), this._angleAxis = new wun(), this.axisPointerEnabled = true, this.name = a || "", this._radiusAxis.polar = this._angleAxis.polar = this;
      }
      return l2.prototype.containPoint = function(a) {
        var e2 = this.pointToCoord(a);
        return this._radiusAxis.contain(e2[0]) && this._angleAxis.contain(e2[1]);
      }, l2.prototype.containData = function(a) {
        return this._radiusAxis.containData(a[0]) && this._angleAxis.containData(a[1]);
      }, l2.prototype.getAxis = function(a) {
        var e2 = "_" + a + "Axis";
        return this[e2];
      }, l2.prototype.getAxes = function() {
        return [this._radiusAxis, this._angleAxis];
      }, l2.prototype.getAxesByScale = function(a) {
        var e2 = [], d2 = this._angleAxis, y2 = this._radiusAxis;
        return d2.scale.type === a && e2.push(d2), y2.scale.type === a && e2.push(y2), e2;
      }, l2.prototype.getAngleAxis = function() {
        return this._angleAxis;
      }, l2.prototype.getRadiusAxis = function() {
        return this._radiusAxis;
      }, l2.prototype.getOtherAxis = function(a) {
        var e2 = this._angleAxis;
        return a === e2 ? this._radiusAxis : e2;
      }, l2.prototype.getBaseAxis = function() {
        return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
      }, l2.prototype.getTooltipAxes = function(a) {
        var e2 = a != null && a !== "auto" ? this.getAxis(a) : this.getBaseAxis();
        return { baseAxes: [e2], otherAxes: [this.getOtherAxis(e2)] };
      }, l2.prototype.dataToPoint = function(a, e2) {
        return this.coordToPoint([this._radiusAxis.dataToRadius(a[0], e2), this._angleAxis.dataToAngle(a[1], e2)]);
      }, l2.prototype.pointToData = function(a, e2) {
        var d2 = this.pointToCoord(a);
        return [this._radiusAxis.radiusToData(d2[0], e2), this._angleAxis.angleToData(d2[1], e2)];
      }, l2.prototype.pointToCoord = function(a) {
        var e2 = a[0] - this.cx, d2 = a[1] - this.cy, y2 = this.getAngleAxis(), x2 = y2.getExtent(), C = Math.min(x2[0], x2[1]), D2 = Math.max(x2[0], x2[1]);
        y2.inverse ? C = D2 - 360 : D2 = C + 360;
        var L = Math.sqrt(e2 * e2 + d2 * d2);
        e2 /= L, d2 /= L;
        for (var F3 = Math.atan2(-d2, e2) / Math.PI * 180, j = F3 < C ? 1 : -1; F3 < C || F3 > D2; )
          F3 += j * 360;
        return [L, F3];
      }, l2.prototype.coordToPoint = function(a) {
        var e2 = a[0], d2 = a[1] / 180 * Math.PI, y2 = Math.cos(d2) * e2 + this.cx, x2 = -Math.sin(d2) * e2 + this.cy;
        return [y2, x2];
      }, l2.prototype.getArea = function() {
        var a = this.getAngleAxis(), e2 = this.getRadiusAxis(), d2 = e2.getExtent().slice();
        d2[0] > d2[1] && d2.reverse();
        var y2 = a.getExtent(), x2 = Math.PI / 180;
        return { cx: this.cx, cy: this.cy, r0: d2[0], r: d2[1], startAngle: -y2[0] * x2, endAngle: -y2[1] * x2, clockwise: a.inverse, contain: function(C, D2) {
          var L = C - this.cx, F3 = D2 - this.cy, j = L * L + F3 * F3 - 1e-4, U3 = this.r, Y3 = this.r0;
          return j <= U3 * U3 && j >= Y3 * Y3;
        } };
      }, l2.prototype.convertToPixel = function(a, e2, d2) {
        var y2 = Dhe(e2);
        return y2 === this ? this.dataToPoint(d2) : null;
      }, l2.prototype.convertFromPixel = function(a, e2, d2) {
        var y2 = Dhe(e2);
        return y2 === this ? this.pointToData(d2) : null;
      }, l2;
    }();
    function Dhe(l2) {
      var a = l2.seriesModel, e2 = l2.polarModel;
      return e2 && e2.coordinateSystem || a && a.coordinateSystem;
    }
    var Mun = Sun;
    function Cun(l2, a, e2) {
      var d2 = a.get("center"), y2 = e2.getWidth(), x2 = e2.getHeight();
      l2.cx = Ko(d2[0], y2), l2.cy = Ko(d2[1], x2);
      var C = l2.getRadiusAxis(), D2 = Math.min(y2, x2) / 2, L = a.get("radius");
      L == null ? L = [0, "100%"] : Ba2(L) || (L = [0, L]);
      var F3 = [Ko(L[0], D2), Ko(L[1], D2)];
      C.inverse ? C.setExtent(F3[1], F3[0]) : C.setExtent(F3[0], F3[1]);
    }
    function Tun(l2, a) {
      var e2 = this, d2 = e2.getAngleAxis(), y2 = e2.getRadiusAxis();
      if (d2.scale.setExtent(1 / 0, -1 / 0), y2.scale.setExtent(1 / 0, -1 / 0), l2.eachSeries(function(D2) {
        if (D2.coordinateSystem === e2) {
          var L = D2.getData();
          Ke2(Gyt(L, "radius"), function(F3) {
            y2.scale.unionExtentFromData(L, F3);
          }), Ke2(Gyt(L, "angle"), function(F3) {
            d2.scale.unionExtentFromData(L, F3);
          });
        }
      }), iZ(d2.scale, d2.model), iZ(y2.scale, y2.model), d2.type === "category" && !d2.onBand) {
        var x2 = d2.getExtent(), C = 360 / d2.scale.count();
        d2.inverse ? x2[1] += C : x2[1] -= C, d2.setExtent(x2[0], x2[1]);
      }
    }
    function Aun(l2) {
      return l2.mainType === "angleAxis";
    }
    function Ehe(l2, a) {
      if (l2.type = a.get("type"), l2.scale = Wyt(a), l2.onBand = a.get("boundaryGap") && l2.type === "category", l2.inverse = a.get("inverse"), Aun(a)) {
        l2.inverse = l2.inverse !== a.get("clockwise");
        var e2 = a.get("startAngle");
        l2.setExtent(e2, e2 + (l2.inverse ? -360 : 360));
      }
      a.axis = l2, l2.model = a;
    }
    var Iun = { dimensions: Ihe, create: function(l2, a) {
      var e2 = [];
      return l2.eachComponent("polar", function(d2, y2) {
        var x2 = new Mun(y2 + "");
        x2.update = Tun;
        var C = x2.getRadiusAxis(), D2 = x2.getAngleAxis(), L = d2.findAxisModel("radiusAxis"), F3 = d2.findAxisModel("angleAxis");
        Ehe(C, L), Ehe(D2, F3), Cun(x2, d2, a), e2.push(x2), d2.coordinateSystem = x2, x2.model = d2;
      }), l2.eachSeries(function(d2) {
        if (d2.get("coordinateSystem") === "polar") {
          var y2 = d2.getReferringComponents("polar", q0).models[0];
          d2.coordinateSystem = y2.coordinateSystem;
        }
      }), e2;
    } }, Dun = Iun, Eun = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
    function Emt(l2, a, e2) {
      a[1] > a[0] && (a = a.slice().reverse());
      var d2 = l2.coordToPoint([a[0], e2]), y2 = l2.coordToPoint([a[1], e2]);
      return { x1: d2[0], y1: d2[1], x2: y2[0], y2: y2[1] };
    }
    function kmt(l2) {
      var a = l2.getRadiusAxis();
      return a.inverse ? 0 : 1;
    }
    function khe(l2) {
      var a = l2[0], e2 = l2[l2.length - 1];
      a && e2 && Math.abs(Math.abs(a.coord - e2.coord) - 360) < 1e-4 && l2.pop();
    }
    var kun = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.axisPointerClass = "PolarAxisPointer", e2;
      }
      return a.prototype.render = function(e2, d2) {
        if (this.group.removeAll(), !!e2.get("show")) {
          var y2 = e2.axis, x2 = y2.polar, C = x2.getRadiusAxis().getExtent(), D2 = y2.getTicksCoords(), L = y2.getMinorTicksCoords(), F3 = $a2(y2.getViewLabels(), function(j) {
            j = zl(j);
            var U3 = y2.scale, Y3 = U3.type === "ordinal" ? U3.getRawOrdinalNumber(j.tickValue) : j.tickValue;
            return j.coord = y2.dataToCoord(Y3), j;
          });
          khe(F3), khe(D2), Ke2(Eun, function(j) {
            e2.get([j, "show"]) && (!y2.scale.isBlank() || j === "axisLine") && Pun[j](this.group, e2, x2, D2, L, C, F3);
          }, this);
        }
      }, a.type = "angleAxis", a;
    }(bB), Pun = { axisLine: function(l2, a, e2, d2, y2, x2) {
      var C = a.getModel(["axisLine", "lineStyle"]), D2 = kmt(e2), L = D2 ? 0 : 1, F3;
      x2[L] === 0 ? F3 = new _A({ shape: { cx: e2.cx, cy: e2.cy, r: x2[D2] }, style: C.getLineStyle(), z2: 1, silent: true }) : F3 = new Iq({ shape: { cx: e2.cx, cy: e2.cy, r: x2[D2], r0: x2[L] }, style: C.getLineStyle(), z2: 1, silent: true }), F3.style.fill = null, l2.add(F3);
    }, axisTick: function(l2, a, e2, d2, y2, x2) {
      var C = a.getModel("axisTick"), D2 = (C.get("inside") ? -1 : 1) * C.get("length"), L = x2[kmt(e2)], F3 = $a2(d2, function(j) {
        return new by({ shape: Emt(e2, [L, L + D2], j.coord) });
      });
      l2.add(Ja2(F3, { style: El(C.getModel("lineStyle").getLineStyle(), { stroke: a.get(["axisLine", "lineStyle", "color"]) }) }));
    }, minorTick: function(l2, a, e2, d2, y2, x2) {
      if (y2.length) {
        for (var C = a.getModel("axisTick"), D2 = a.getModel("minorTick"), L = (C.get("inside") ? -1 : 1) * D2.get("length"), F3 = x2[kmt(e2)], j = [], U3 = 0; U3 < y2.length; U3++)
          for (var Y3 = 0; Y3 < y2[U3].length; Y3++)
            j.push(new by({ shape: Emt(e2, [F3, F3 + L], y2[U3][Y3].coord) }));
        l2.add(Ja2(j, { style: El(D2.getModel("lineStyle").getLineStyle(), El(C.getLineStyle(), { stroke: a.get(["axisLine", "lineStyle", "color"]) })) }));
      }
    }, axisLabel: function(l2, a, e2, d2, y2, x2, C) {
      var D2 = a.getCategories(true), L = a.getModel("axisLabel"), F3 = L.get("margin"), j = a.get("triggerEvent");
      Ke2(C, function(U3, Y3) {
        var Q = L, nt = U3.tickValue, dt = x2[kmt(e2)], vt = e2.coordToPoint([dt + F3, U3.coord]), Ct = e2.cx, Pt = e2.cy, jt = Math.abs(vt[0] - Ct) / dt < 0.3 ? "center" : vt[0] > Ct ? "left" : "right", Rt = Math.abs(vt[1] - Pt) / dt < 0.3 ? "middle" : vt[1] > Pt ? "top" : "bottom";
        if (D2 && D2[nt]) {
          var le2 = D2[nt];
          vs(le2) && le2.textStyle && (Q = new hg2(le2.textStyle, L, L.ecModel));
        }
        var ne2 = new qc2({ silent: RO.isLabelSilent(a), style: _y(Q, { x: vt[0], y: vt[1], fill: Q.getTextColor() || a.get(["axisLine", "lineStyle", "color"]), text: U3.formattedLabel, align: jt, verticalAlign: Rt }) });
        if (l2.add(ne2), j) {
          var he2 = RO.makeAxisEventDataBase(a);
          he2.targetType = "axisLabel", he2.value = U3.rawLabel, ns(ne2).eventData = he2;
        }
      }, this);
    }, splitLine: function(l2, a, e2, d2, y2, x2) {
      var C = a.getModel("splitLine"), D2 = C.getModel("lineStyle"), L = D2.get("color"), F3 = 0;
      L = L instanceof Array ? L : [L];
      for (var j = [], U3 = 0; U3 < d2.length; U3++) {
        var Y3 = F3++ % L.length;
        j[Y3] = j[Y3] || [], j[Y3].push(new by({ shape: Emt(e2, x2, d2[U3].coord) }));
      }
      for (var U3 = 0; U3 < j.length; U3++)
        l2.add(Ja2(j[U3], { style: El({ stroke: L[U3 % L.length] }, D2.getLineStyle()), silent: true, z: a.get("z") }));
    }, minorSplitLine: function(l2, a, e2, d2, y2, x2) {
      if (y2.length) {
        for (var C = a.getModel("minorSplitLine"), D2 = C.getModel("lineStyle"), L = [], F3 = 0; F3 < y2.length; F3++)
          for (var j = 0; j < y2[F3].length; j++)
            L.push(new by({ shape: Emt(e2, x2, y2[F3][j].coord) }));
        l2.add(Ja2(L, { style: D2.getLineStyle(), silent: true, z: a.get("z") }));
      }
    }, splitArea: function(l2, a, e2, d2, y2, x2) {
      if (d2.length) {
        var C = a.getModel("splitArea"), D2 = C.getModel("areaStyle"), L = D2.get("color"), F3 = 0;
        L = L instanceof Array ? L : [L];
        for (var j = [], U3 = Math.PI / 180, Y3 = -d2[0].coord * U3, Q = Math.min(x2[0], x2[1]), nt = Math.max(x2[0], x2[1]), dt = a.get("clockwise"), vt = 1, Ct = d2.length; vt <= Ct; vt++) {
          var Pt = vt === Ct ? d2[0].coord : d2[vt].coord, jt = F3++ % L.length;
          j[jt] = j[jt] || [], j[jt].push(new nw({ shape: { cx: e2.cx, cy: e2.cy, r0: Q, r: nt, startAngle: Y3, endAngle: -Pt * U3, clockwise: dt }, silent: true })), Y3 = -Pt * U3;
        }
        for (var vt = 0; vt < j.length; vt++)
          l2.add(Ja2(j[vt], { style: El({ fill: L[vt % L.length] }, D2.getAreaStyle()), silent: true }));
      }
    } }, Lun = kun, Oun = ["axisLine", "axisTickLabel", "axisName"], Run = ["splitLine", "splitArea", "minorSplitLine"], Nun = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.axisPointerClass = "PolarAxisPointer", e2;
      }
      return a.prototype.render = function(e2, d2) {
        if (this.group.removeAll(), !!e2.get("show")) {
          var y2 = this._axisGroup, x2 = this._axisGroup = new ou();
          this.group.add(x2);
          var C = e2.axis, D2 = C.polar, L = D2.getAngleAxis(), F3 = C.getTicksCoords(), j = C.getMinorTicksCoords(), U3 = L.getExtent()[0], Y3 = C.getExtent(), Q = Vun(D2, e2, U3), nt = new RO(e2, Q);
          Ke2(Oun, nt.add, nt), x2.add(nt.getGroup()), m1(y2, x2, e2), Ke2(Run, function(dt) {
            e2.get([dt, "show"]) && !C.scale.isBlank() && Fun[dt](this.group, e2, D2, U3, Y3, F3, j);
          }, this);
        }
      }, a.type = "radiusAxis", a;
    }(bB), Fun = { splitLine: function(l2, a, e2, d2, y2, x2) {
      var C = a.getModel("splitLine"), D2 = C.getModel("lineStyle"), L = D2.get("color"), F3 = 0;
      L = L instanceof Array ? L : [L];
      for (var j = [], U3 = 0; U3 < x2.length; U3++) {
        var Y3 = F3++ % L.length;
        j[Y3] = j[Y3] || [], j[Y3].push(new _A({ shape: { cx: e2.cx, cy: e2.cy, r: x2[U3].coord } }));
      }
      for (var U3 = 0; U3 < j.length; U3++)
        l2.add(Ja2(j[U3], { style: El({ stroke: L[U3 % L.length], fill: null }, D2.getLineStyle()), silent: true }));
    }, minorSplitLine: function(l2, a, e2, d2, y2, x2, C) {
      if (C.length) {
        for (var D2 = a.getModel("minorSplitLine"), L = D2.getModel("lineStyle"), F3 = [], j = 0; j < C.length; j++)
          for (var U3 = 0; U3 < C[j].length; U3++)
            F3.push(new _A({ shape: { cx: e2.cx, cy: e2.cy, r: C[j][U3].coord } }));
        l2.add(Ja2(F3, { style: El({ fill: null }, L.getLineStyle()), silent: true }));
      }
    }, splitArea: function(l2, a, e2, d2, y2, x2) {
      if (x2.length) {
        var C = a.getModel("splitArea"), D2 = C.getModel("areaStyle"), L = D2.get("color"), F3 = 0;
        L = L instanceof Array ? L : [L];
        for (var j = [], U3 = x2[0].coord, Y3 = 1; Y3 < x2.length; Y3++) {
          var Q = F3++ % L.length;
          j[Q] = j[Q] || [], j[Q].push(new nw({ shape: { cx: e2.cx, cy: e2.cy, r0: U3, r: x2[Y3].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), U3 = x2[Y3].coord;
        }
        for (var Y3 = 0; Y3 < j.length; Y3++)
          l2.add(Ja2(j[Y3], { style: El({ fill: L[Y3 % L.length] }, D2.getAreaStyle()), silent: true }));
      }
    } };
    function Vun(l2, a, e2) {
      return { position: [l2.cx, l2.cy], rotation: e2 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: a.getModel("axisLabel").get("rotate"), z2: 1 };
    }
    var Bun = Nun;
    function Phe(l2) {
      return l2.get("stack") || "__ec_stack_" + l2.seriesIndex;
    }
    function Lhe(l2, a) {
      return a.dim + l2.model.componentIndex;
    }
    function zun(l2, a, e2) {
      var d2 = {}, y2 = jun(Lp(a.getSeriesByType(l2), function(x2) {
        return !a.isSeriesFiltered(x2) && x2.coordinateSystem && x2.coordinateSystem.type === "polar";
      }));
      a.eachSeriesByType(l2, function(x2) {
        if (x2.coordinateSystem.type === "polar") {
          var C = x2.getData(), D2 = x2.coordinateSystem, L = D2.getBaseAxis(), F3 = Lhe(D2, L), j = Phe(x2), U3 = y2[F3][j], Y3 = U3.offset, Q = U3.width, nt = D2.getOtherAxis(L), dt = x2.coordinateSystem.cx, vt = x2.coordinateSystem.cy, Ct = x2.get("barMinHeight") || 0, Pt = x2.get("barMinAngle") || 0;
          d2[j] = d2[j] || [];
          for (var jt = C.mapDimension(nt.dim), Rt = C.mapDimension(L.dim), le2 = tF(C, jt), ne2 = L.dim !== "radius" || !x2.get("roundCap", true), he2 = nt.dataToCoord(0), _e = 0, Me2 = C.count(); _e < Me2; _e++) {
            var Pe2 = C.get(jt, _e), Be2 = C.get(Rt, _e), Je2 = Pe2 >= 0 ? "p" : "n", Ze2 = he2;
            le2 && (d2[j][Be2] || (d2[j][Be2] = { p: he2, n: he2 }), Ze2 = d2[j][Be2][Je2]);
            var Cn = void 0, Bn = void 0, mn = void 0, Kr = void 0;
            if (nt.dim === "radius") {
              var Kn = nt.dataToCoord(Pe2) - he2, ar = L.dataToCoord(Be2);
              Math.abs(Kn) < Ct && (Kn = (Kn < 0 ? -1 : 1) * Ct), Cn = Ze2, Bn = Ze2 + Kn, mn = ar - Y3, Kr = mn - Q, le2 && (d2[j][Be2][Je2] = Bn);
            } else {
              var Cr = nt.dataToCoord(Pe2, ne2) - he2, ui2 = L.dataToCoord(Be2);
              Math.abs(Cr) < Pt && (Cr = (Cr < 0 ? -1 : 1) * Pt), Cn = ui2 + Y3, Bn = Cn + Q, mn = Ze2, Kr = Ze2 + Cr, le2 && (d2[j][Be2][Je2] = Kr);
            }
            C.setItemLayout(_e, { cx: dt, cy: vt, r0: Cn, r: Bn, startAngle: -mn * Math.PI / 180, endAngle: -Kr * Math.PI / 180, clockwise: mn >= Kr });
          }
        }
      });
    }
    function jun(l2) {
      var a = {};
      Ke2(l2, function(d2, y2) {
        var x2 = d2.getData(), C = d2.coordinateSystem, D2 = C.getBaseAxis(), L = Lhe(C, D2), F3 = D2.getExtent(), j = D2.type === "category" ? D2.getBandWidth() : Math.abs(F3[1] - F3[0]) / x2.count(), U3 = a[L] || { bandWidth: j, remainedWidth: j, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, Y3 = U3.stacks;
        a[L] = U3;
        var Q = Phe(d2);
        Y3[Q] || U3.autoWidthCount++, Y3[Q] = Y3[Q] || { width: 0, maxWidth: 0 };
        var nt = Ko(d2.get("barWidth"), j), dt = Ko(d2.get("barMaxWidth"), j), vt = d2.get("barGap"), Ct = d2.get("barCategoryGap");
        nt && !Y3[Q].width && (nt = Math.min(U3.remainedWidth, nt), Y3[Q].width = nt, U3.remainedWidth -= nt), dt && (Y3[Q].maxWidth = dt), vt != null && (U3.gap = vt), Ct != null && (U3.categoryGap = Ct);
      });
      var e2 = {};
      return Ke2(a, function(d2, y2) {
        e2[y2] = {};
        var x2 = d2.stacks, C = d2.bandWidth, D2 = Ko(d2.categoryGap, C), L = Ko(d2.gap, 1), F3 = d2.remainedWidth, j = d2.autoWidthCount, U3 = (F3 - D2) / (j + (j - 1) * L);
        U3 = Math.max(U3, 0), Ke2(x2, function(dt, vt) {
          var Ct = dt.maxWidth;
          Ct && Ct < U3 && (Ct = Math.min(Ct, F3), dt.width && (Ct = Math.min(Ct, dt.width)), F3 -= Ct, dt.width = Ct, j--);
        }), U3 = (F3 - D2) / (j + (j - 1) * L), U3 = Math.max(U3, 0);
        var Y3 = 0, Q;
        Ke2(x2, function(dt, vt) {
          dt.width || (dt.width = U3), Q = dt, Y3 += dt.width * (1 + L);
        }), Q && (Y3 -= Q.width * L);
        var nt = -Y3 / 2;
        Ke2(x2, function(dt, vt) {
          e2[y2][vt] = e2[y2][vt] || { offset: nt, width: dt.width }, nt += dt.width * (1 + L);
        });
      }), e2;
    }
    var Wun = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, Gun = { splitNumber: 5 }, Hun = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "polar", a;
    }(_0);
    function Uun(l2) {
      Oc2(uit), bB.registerAxisPointerClass("PolarAxisPointer", gun), l2.registerCoordinateSystem("polar", Dun), l2.registerComponentModel(yun), l2.registerComponentView(Hun), uZ(l2, "angle", mun, Wun), uZ(l2, "radius", bun, Gun), l2.registerComponentView(Lun), l2.registerComponentView(Bun), l2.registerLayout(xu(zun, "bar"));
    }
    function X4t(l2, a) {
      a = a || {};
      var e2 = l2.coordinateSystem, d2 = l2.axis, y2 = {}, x2 = d2.position, C = d2.orient, D2 = e2.getRect(), L = [D2.x, D2.x + D2.width, D2.y, D2.y + D2.height], F3 = { horizontal: { top: L[2], bottom: L[3] }, vertical: { left: L[0], right: L[1] } };
      y2.position = [C === "vertical" ? F3.vertical[x2] : L[0], C === "horizontal" ? F3.horizontal[x2] : L[3]];
      var j = { horizontal: 0, vertical: 1 };
      y2.rotation = Math.PI / 2 * j[C];
      var U3 = { top: -1, bottom: 1, right: 1, left: -1 };
      y2.labelDirection = y2.tickDirection = y2.nameDirection = U3[x2], l2.get(["axisTick", "inside"]) && (y2.tickDirection = -y2.tickDirection), jy(a.labelInside, l2.get(["axisLabel", "inside"])) && (y2.labelDirection = -y2.labelDirection);
      var Y3 = a.rotate;
      return Y3 == null && (Y3 = l2.get(["axisLabel", "rotate"])), y2.labelRotation = x2 === "top" ? -Y3 : Y3, y2.z2 = 1, y2;
    }
    var qun = ["axisLine", "axisTickLabel", "axisName"], Zun = ["splitArea", "splitLine"], $un = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.axisPointerClass = "SingleAxisPointer", e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        var C = this.group;
        C.removeAll();
        var D2 = this._axisGroup;
        this._axisGroup = new ou();
        var L = X4t(e2), F3 = new RO(e2, L);
        Ke2(qun, F3.add, F3), C.add(this._axisGroup), C.add(F3.getGroup()), Ke2(Zun, function(j) {
          e2.get([j, "show"]) && Yun[j](this, this.group, this._axisGroup, e2);
        }, this), m1(D2, this._axisGroup, e2), l2.prototype.render.call(this, e2, d2, y2, x2);
      }, a.prototype.remove = function() {
        Qle(this);
      }, a.type = "singleAxis", a;
    }(bB), Yun = { splitLine: function(l2, a, e2, d2) {
      var y2 = d2.axis;
      if (!y2.scale.isBlank()) {
        var x2 = d2.getModel("splitLine"), C = x2.getModel("lineStyle"), D2 = C.get("color");
        D2 = D2 instanceof Array ? D2 : [D2];
        for (var L = d2.coordinateSystem.getRect(), F3 = y2.isHorizontal(), j = [], U3 = 0, Y3 = y2.getTicksCoords({ tickModel: x2 }), Q = [], nt = [], dt = 0; dt < Y3.length; ++dt) {
          var vt = y2.toGlobalCoord(Y3[dt].coord);
          F3 ? (Q[0] = vt, Q[1] = L.y, nt[0] = vt, nt[1] = L.y + L.height) : (Q[0] = L.x, Q[1] = vt, nt[0] = L.x + L.width, nt[1] = vt);
          var Ct = U3++ % D2.length;
          j[Ct] = j[Ct] || [], j[Ct].push(new by({ subPixelOptimize: true, shape: { x1: Q[0], y1: Q[1], x2: nt[0], y2: nt[1] }, silent: true }));
        }
        for (var Pt = C.getLineStyle(["color"]), dt = 0; dt < j.length; ++dt)
          a.add(Ja2(j[dt], { style: El({ stroke: D2[dt % D2.length] }, Pt), silent: true }));
      }
    }, splitArea: function(l2, a, e2, d2) {
      Xle(l2, e2, d2, d2);
    } }, Kun = $un, Ohe = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.getCoordSysModel = function() {
        return this;
      }, a.type = "singleAxis", a.layoutMode = "box", a.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, a;
    }(Ah2);
    v0(Ohe, Lrt.prototype);
    var Q4t = Ohe, Xun = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2, C) {
        var D2 = l2.call(this, e2, d2, y2) || this;
        return D2.type = x2 || "value", D2.position = C || "bottom", D2;
      }
      return a.prototype.isHorizontal = function() {
        var e2 = this.position;
        return e2 === "top" || e2 === "bottom";
      }, a.prototype.pointToData = function(e2, d2) {
        return this.coordinateSystem.pointToData(e2)[0];
      }, a;
    }(kE), Qun = Xun, Rhe = ["single"], Jun = function() {
      function l2(a, e2, d2) {
        this.type = "single", this.dimension = "single", this.dimensions = Rhe, this.axisPointerEnabled = true, this.model = a, this._init(a, e2, d2);
      }
      return l2.prototype._init = function(a, e2, d2) {
        var y2 = this.dimension, x2 = new Qun(y2, Wyt(a), [0, 0], a.get("type"), a.get("position")), C = x2.type === "category";
        x2.onBand = C && a.get("boundaryGap"), x2.inverse = a.get("inverse"), x2.orient = a.get("orient"), a.axis = x2, x2.model = a, x2.coordinateSystem = this, this._axis = x2;
      }, l2.prototype.update = function(a, e2) {
        a.eachSeries(function(d2) {
          if (d2.coordinateSystem === this) {
            var y2 = d2.getData();
            Ke2(y2.mapDimensionsAll(this.dimension), function(x2) {
              this._axis.scale.unionExtentFromData(y2, x2);
            }, this), iZ(this._axis.scale, this._axis.model);
          }
        }, this);
      }, l2.prototype.resize = function(a, e2) {
        this._rect = Em({ left: a.get("left"), top: a.get("top"), right: a.get("right"), bottom: a.get("bottom"), width: a.get("width"), height: a.get("height") }, { width: e2.getWidth(), height: e2.getHeight() }), this._adjustAxis();
      }, l2.prototype.getRect = function() {
        return this._rect;
      }, l2.prototype._adjustAxis = function() {
        var a = this._rect, e2 = this._axis, d2 = e2.isHorizontal(), y2 = d2 ? [0, a.width] : [0, a.height], x2 = e2.reverse ? 1 : 0;
        e2.setExtent(y2[x2], y2[1 - x2]), this._updateAxisTransform(e2, d2 ? a.x : a.y);
      }, l2.prototype._updateAxisTransform = function(a, e2) {
        var d2 = a.getExtent(), y2 = d2[0] + d2[1], x2 = a.isHorizontal();
        a.toGlobalCoord = x2 ? function(C) {
          return C + e2;
        } : function(C) {
          return y2 - C + e2;
        }, a.toLocalCoord = x2 ? function(C) {
          return C - e2;
        } : function(C) {
          return y2 - C + e2;
        };
      }, l2.prototype.getAxis = function() {
        return this._axis;
      }, l2.prototype.getBaseAxis = function() {
        return this._axis;
      }, l2.prototype.getAxes = function() {
        return [this._axis];
      }, l2.prototype.getTooltipAxes = function() {
        return { baseAxes: [this.getAxis()], otherAxes: [] };
      }, l2.prototype.containPoint = function(a) {
        var e2 = this.getRect(), d2 = this.getAxis(), y2 = d2.orient;
        return y2 === "horizontal" ? d2.contain(d2.toLocalCoord(a[0])) && a[1] >= e2.y && a[1] <= e2.y + e2.height : d2.contain(d2.toLocalCoord(a[1])) && a[0] >= e2.y && a[0] <= e2.y + e2.height;
      }, l2.prototype.pointToData = function(a) {
        var e2 = this.getAxis();
        return [e2.coordToData(e2.toLocalCoord(a[e2.orient === "horizontal" ? 0 : 1]))];
      }, l2.prototype.dataToPoint = function(a) {
        var e2 = this.getAxis(), d2 = this.getRect(), y2 = [], x2 = e2.orient === "horizontal" ? 0 : 1;
        return a instanceof Array && (a = a[0]), y2[x2] = e2.toGlobalCoord(e2.dataToCoord(+a)), y2[1 - x2] = x2 === 0 ? d2.y + d2.height / 2 : d2.x + d2.width / 2, y2;
      }, l2.prototype.convertToPixel = function(a, e2, d2) {
        var y2 = Nhe(e2);
        return y2 === this ? this.dataToPoint(d2) : null;
      }, l2.prototype.convertFromPixel = function(a, e2, d2) {
        var y2 = Nhe(e2);
        return y2 === this ? this.pointToData(d2) : null;
      }, l2;
    }();
    function Nhe(l2) {
      var a = l2.seriesModel, e2 = l2.singleAxisModel;
      return e2 && e2.coordinateSystem || a && a.coordinateSystem;
    }
    function tcn(l2, a) {
      var e2 = [];
      return l2.eachComponent("singleAxis", function(d2, y2) {
        var x2 = new Jun(d2, l2, a);
        x2.name = "single_" + y2, x2.resize(d2, a), d2.coordinateSystem = x2, e2.push(x2);
      }), l2.eachSeries(function(d2) {
        if (d2.get("coordinateSystem") === "singleAxis") {
          var y2 = d2.getReferringComponents("singleAxis", q0).models[0];
          d2.coordinateSystem = y2 && y2.coordinateSystem;
        }
      }), e2;
    }
    var ecn = { create: tcn, dimensions: Rhe }, ncn = ecn, Fhe = ["x", "y"], rcn = ["width", "height"], icn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.makeElOption = function(e2, d2, y2, x2, C) {
        var D2 = y2.axis, L = D2.coordinateSystem, F3 = J4t(L, 1 - Pmt(D2)), j = L.dataToPoint(d2)[0], U3 = x2.get("type");
        if (U3 && U3 !== "none") {
          var Y3 = H4t(x2), Q = acn[U3](D2, j, F3);
          Q.style = Y3, e2.graphicKey = Q.type, e2.pointer = Q;
        }
        var nt = X4t(y2);
        yhe(d2, e2, nt, y2, x2, C);
      }, a.prototype.getHandleTransform = function(e2, d2, y2) {
        var x2 = X4t(d2, { labelInside: false });
        x2.labelMargin = y2.get(["handle", "margin"]);
        var C = U4t(d2.axis, e2, x2);
        return { x: C[0], y: C[1], rotation: x2.rotation + (x2.labelDirection < 0 ? Math.PI : 0) };
      }, a.prototype.updateHandleTransform = function(e2, d2, y2, x2) {
        var C = y2.axis, D2 = C.coordinateSystem, L = Pmt(C), F3 = J4t(D2, L), j = [e2.x, e2.y];
        j[L] += d2[L], j[L] = Math.min(F3[1], j[L]), j[L] = Math.max(F3[0], j[L]);
        var U3 = J4t(D2, 1 - L), Y3 = (U3[1] + U3[0]) / 2, Q = [Y3, Y3];
        return Q[L] = j[L], { x: j[0], y: j[1], rotation: e2.rotation, cursorPoint: Q, tooltipOption: { verticalAlign: "middle" } };
      }, a;
    }(G4t), acn = { line: function(l2, a, e2) {
      var d2 = q4t([a, e2[0]], [a, e2[1]], Pmt(l2));
      return { type: "Line", subPixelOptimize: true, shape: d2 };
    }, shadow: function(l2, a, e2) {
      var d2 = l2.getBandWidth(), y2 = e2[1] - e2[0];
      return { type: "Rect", shape: mhe([a - d2 / 2, e2[0]], [d2, y2], Pmt(l2)) };
    } };
    function Pmt(l2) {
      return l2.isHorizontal() ? 0 : 1;
    }
    function J4t(l2, a) {
      var e2 = l2.getRect();
      return [e2[Fhe[a]], e2[Fhe[a]] + e2[rcn[a]]];
    }
    var ocn = icn, scn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "single", a;
    }(_0);
    function lcn(l2) {
      Oc2(uit), bB.registerAxisPointerClass("SingleAxisPointer", ocn), l2.registerComponentView(scn), l2.registerComponentView(Kun), l2.registerComponentModel(Q4t), uZ(l2, "single", Q4t, Q4t.defaultOption), l2.registerCoordinateSystem("single", ncn);
    }
    var ucn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        var x2 = Hq(e2);
        l2.prototype.init.apply(this, arguments), Vhe(e2, x2);
      }, a.prototype.mergeOption = function(e2) {
        l2.prototype.mergeOption.apply(this, arguments), Vhe(this.option, e2);
      }, a.prototype.getCellSize = function() {
        return this.option.cellSize;
      }, a.type = "calendar", a.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, a;
    }(Ah2);
    function Vhe(l2, a) {
      var e2 = l2.cellSize, d2;
      Ba2(e2) ? d2 = e2 : d2 = l2.cellSize = [e2, e2], d2.length === 1 && (d2[1] = d2[0]);
      var y2 = $a2([0, 1], function(x2) {
        return g$e(a, x2) && (d2[x2] = "auto"), d2[x2] != null && d2[x2] !== "auto";
      });
      $N(l2, a, { type: "box", ignoreSize: y2 });
    }
    var ccn = ucn, fcn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2 = this.group;
        x2.removeAll();
        var C = e2.coordinateSystem, D2 = C.getRangeInfo(), L = C.getOrient(), F3 = d2.getLocaleModel();
        this._renderDayRect(e2, D2, x2), this._renderLines(e2, D2, L, x2), this._renderYearText(e2, D2, L, x2), this._renderMonthText(e2, F3, L, x2), this._renderWeekText(e2, F3, D2, L, x2);
      }, a.prototype._renderDayRect = function(e2, d2, y2) {
        for (var x2 = e2.coordinateSystem, C = e2.getModel("itemStyle").getItemStyle(), D2 = x2.getCellWidth(), L = x2.getCellHeight(), F3 = d2.start.time; F3 <= d2.end.time; F3 = x2.getNextNDay(F3, 1).time) {
          var j = x2.dataToRect([F3], false).tl, U3 = new Nf2({ shape: { x: j[0], y: j[1], width: D2, height: L }, cursor: "default", style: C });
          y2.add(U3);
        }
      }, a.prototype._renderLines = function(e2, d2, y2, x2) {
        var C = this, D2 = e2.coordinateSystem, L = e2.getModel(["splitLine", "lineStyle"]).getLineStyle(), F3 = e2.get(["splitLine", "show"]), j = L.lineWidth;
        this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
        for (var U3 = d2.start, Y3 = 0; U3.time <= d2.end.time; Y3++) {
          nt(U3.formatedDate), Y3 === 0 && (U3 = D2.getDateInfo(d2.start.y + "-" + d2.start.m));
          var Q = U3.date;
          Q.setMonth(Q.getMonth() + 1), U3 = D2.getDateInfo(Q);
        }
        nt(D2.getNextNDay(d2.end.time, 1).formatedDate);
        function nt(dt) {
          C._firstDayOfMonth.push(D2.getDateInfo(dt)), C._firstDayPoints.push(D2.dataToRect([dt], false).tl);
          var vt = C._getLinePointsOfOneWeek(e2, dt, y2);
          C._tlpoints.push(vt[0]), C._blpoints.push(vt[vt.length - 1]), F3 && C._drawSplitline(vt, L, x2);
        }
        F3 && this._drawSplitline(C._getEdgesPoints(C._tlpoints, j, y2), L, x2), F3 && this._drawSplitline(C._getEdgesPoints(C._blpoints, j, y2), L, x2);
      }, a.prototype._getEdgesPoints = function(e2, d2, y2) {
        var x2 = [e2[0].slice(), e2[e2.length - 1].slice()], C = y2 === "horizontal" ? 0 : 1;
        return x2[0][C] = x2[0][C] - d2 / 2, x2[1][C] = x2[1][C] + d2 / 2, x2;
      }, a.prototype._drawSplitline = function(e2, d2, y2) {
        var x2 = new iw({ z2: 20, shape: { points: e2 }, style: d2 });
        y2.add(x2);
      }, a.prototype._getLinePointsOfOneWeek = function(e2, d2, y2) {
        for (var x2 = e2.coordinateSystem, C = x2.getDateInfo(d2), D2 = [], L = 0; L < 7; L++) {
          var F3 = x2.getNextNDay(C.time, L), j = x2.dataToRect([F3.time], false);
          D2[2 * F3.day] = j.tl, D2[2 * F3.day + 1] = j[y2 === "horizontal" ? "bl" : "tr"];
        }
        return D2;
      }, a.prototype._formatterLabel = function(e2, d2) {
        return ps(e2) && e2 ? h$e(e2, d2) : wl(e2) ? e2(d2) : d2.nameMap;
      }, a.prototype._yearTextPositionControl = function(e2, d2, y2, x2, C) {
        var D2 = d2[0], L = d2[1], F3 = ["center", "bottom"];
        x2 === "bottom" ? (L += C, F3 = ["center", "top"]) : x2 === "left" ? D2 -= C : x2 === "right" ? (D2 += C, F3 = ["center", "top"]) : L -= C;
        var j = 0;
        return (x2 === "left" || x2 === "right") && (j = Math.PI / 2), { rotation: j, x: D2, y: L, style: { align: F3[0], verticalAlign: F3[1] } };
      }, a.prototype._renderYearText = function(e2, d2, y2, x2) {
        var C = e2.getModel("yearLabel");
        if (C.get("show")) {
          var D2 = C.get("margin"), L = C.get("position");
          L || (L = y2 !== "horizontal" ? "top" : "left");
          var F3 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], j = (F3[0][0] + F3[1][0]) / 2, U3 = (F3[0][1] + F3[1][1]) / 2, Y3 = y2 === "horizontal" ? 0 : 1, Q = { top: [j, F3[Y3][1]], bottom: [j, F3[1 - Y3][1]], left: [F3[1 - Y3][0], U3], right: [F3[Y3][0], U3] }, nt = d2.start.y;
          +d2.end.y > +d2.start.y && (nt = nt + "-" + d2.end.y);
          var dt = C.get("formatter"), vt = { start: d2.start.y, end: d2.end.y, nameMap: nt }, Ct = this._formatterLabel(dt, vt), Pt = new qc2({ z2: 30, style: _y(C, { text: Ct }) });
          Pt.attr(this._yearTextPositionControl(Pt, Q[L], y2, L, D2)), x2.add(Pt);
        }
      }, a.prototype._monthTextPositionControl = function(e2, d2, y2, x2, C) {
        var D2 = "left", L = "top", F3 = e2[0], j = e2[1];
        return y2 === "horizontal" ? (j = j + C, d2 && (D2 = "center"), x2 === "start" && (L = "bottom")) : (F3 = F3 + C, d2 && (L = "middle"), x2 === "start" && (D2 = "right")), { x: F3, y: j, align: D2, verticalAlign: L };
      }, a.prototype._renderMonthText = function(e2, d2, y2, x2) {
        var C = e2.getModel("monthLabel");
        if (C.get("show")) {
          var D2 = C.get("nameMap"), L = C.get("margin"), F3 = C.get("position"), j = C.get("align"), U3 = [this._tlpoints, this._blpoints];
          (!D2 || ps(D2)) && (D2 && (d2 = A3t(D2) || d2), D2 = d2.get(["time", "monthAbbr"]) || []);
          var Y3 = F3 === "start" ? 0 : 1, Q = y2 === "horizontal" ? 0 : 1;
          L = F3 === "start" ? -L : L;
          for (var nt = j === "center", dt = 0; dt < U3[Y3].length - 1; dt++) {
            var vt = U3[Y3][dt].slice(), Ct = this._firstDayOfMonth[dt];
            if (nt) {
              var Pt = this._firstDayPoints[dt];
              vt[Q] = (Pt[Q] + U3[0][dt + 1][Q]) / 2;
            }
            var jt = C.get("formatter"), Rt = D2[+Ct.m - 1], le2 = { yyyy: Ct.y, yy: (Ct.y + "").slice(2), MM: Ct.m, M: +Ct.m, nameMap: Rt }, ne2 = this._formatterLabel(jt, le2), he2 = new qc2({ z2: 30, style: la2(_y(C, { text: ne2 }), this._monthTextPositionControl(vt, nt, y2, F3, L)) });
            x2.add(he2);
          }
        }
      }, a.prototype._weekTextPositionControl = function(e2, d2, y2, x2, C) {
        var D2 = "center", L = "middle", F3 = e2[0], j = e2[1], U3 = y2 === "start";
        return d2 === "horizontal" ? (F3 = F3 + x2 + (U3 ? 1 : -1) * C[0] / 2, D2 = U3 ? "right" : "left") : (j = j + x2 + (U3 ? 1 : -1) * C[1] / 2, L = U3 ? "bottom" : "top"), { x: F3, y: j, align: D2, verticalAlign: L };
      }, a.prototype._renderWeekText = function(e2, d2, y2, x2, C) {
        var D2 = e2.getModel("dayLabel");
        if (D2.get("show")) {
          var L = e2.coordinateSystem, F3 = D2.get("position"), j = D2.get("nameMap"), U3 = D2.get("margin"), Y3 = L.getFirstDayOfWeek();
          if (!j || ps(j)) {
            j && (d2 = A3t(j) || d2);
            var Q = d2.get(["time", "dayOfWeekShort"]);
            j = Q || $a2(d2.get(["time", "dayOfWeekAbbr"]), function(le2) {
              return le2[0];
            });
          }
          var nt = L.getNextNDay(y2.end.time, 7 - y2.lweek).time, dt = [L.getCellWidth(), L.getCellHeight()];
          U3 = Ko(U3, Math.min(dt[1], dt[0])), F3 === "start" && (nt = L.getNextNDay(y2.start.time, -(7 + y2.fweek)).time, U3 = -U3);
          for (var vt = 0; vt < 7; vt++) {
            var Ct = L.getNextNDay(nt, vt), Pt = L.dataToRect([Ct.time], false).center, jt = vt;
            jt = Math.abs((vt + Y3) % 7);
            var Rt = new qc2({ z2: 30, style: la2(_y(D2, { text: j[jt] }), this._weekTextPositionControl(Pt, x2, F3, U3, dt)) });
            C.add(Rt);
          }
        }
      }, a.type = "calendar", a;
    }(_0), hcn = fcn, tRt = 864e5, pcn = function() {
      function l2(a, e2, d2) {
        this.type = "calendar", this.dimensions = l2.dimensions, this.getDimensionsInfo = l2.getDimensionsInfo, this._model = a;
      }
      return l2.getDimensionsInfo = function() {
        return [{ name: "time", type: "time" }, "value"];
      }, l2.prototype.getRangeInfo = function() {
        return this._rangeInfo;
      }, l2.prototype.getModel = function() {
        return this._model;
      }, l2.prototype.getRect = function() {
        return this._rect;
      }, l2.prototype.getCellWidth = function() {
        return this._sw;
      }, l2.prototype.getCellHeight = function() {
        return this._sh;
      }, l2.prototype.getOrient = function() {
        return this._orient;
      }, l2.prototype.getFirstDayOfWeek = function() {
        return this._firstDayOfWeek;
      }, l2.prototype.getDateInfo = function(a) {
        a = Am(a);
        var e2 = a.getFullYear(), d2 = a.getMonth() + 1, y2 = d2 < 10 ? "0" + d2 : "" + d2, x2 = a.getDate(), C = x2 < 10 ? "0" + x2 : "" + x2, D2 = a.getDay();
        return D2 = Math.abs((D2 + 7 - this.getFirstDayOfWeek()) % 7), { y: e2 + "", m: y2, d: C, day: D2, time: a.getTime(), formatedDate: e2 + "-" + y2 + "-" + C, date: a };
      }, l2.prototype.getNextNDay = function(a, e2) {
        return e2 = e2 || 0, e2 === 0 ? this.getDateInfo(a) : (a = new Date(this.getDateInfo(a).time), a.setDate(a.getDate() + e2), this.getDateInfo(a));
      }, l2.prototype.update = function(a, e2) {
        this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
        var d2 = this._rangeInfo.weeks || 1, y2 = ["width", "height"], x2 = this._model.getCellSize().slice(), C = this._model.getBoxLayoutParams(), D2 = this._orient === "horizontal" ? [d2, 7] : [7, d2];
        Ke2([0, 1], function(U3) {
          j(x2, U3) && (C[y2[U3]] = x2[U3] * D2[U3]);
        });
        var L = { width: e2.getWidth(), height: e2.getHeight() }, F3 = this._rect = Em(C, L);
        Ke2([0, 1], function(U3) {
          j(x2, U3) || (x2[U3] = F3[y2[U3]] / D2[U3]);
        });
        function j(U3, Y3) {
          return U3[Y3] != null && U3[Y3] !== "auto";
        }
        this._sw = x2[0], this._sh = x2[1];
      }, l2.prototype.dataToPoint = function(a, e2) {
        Ba2(a) && (a = a[0]), e2 == null && (e2 = true);
        var d2 = this.getDateInfo(a), y2 = this._rangeInfo, x2 = d2.formatedDate;
        if (e2 && !(d2.time >= y2.start.time && d2.time < y2.end.time + tRt))
          return [NaN, NaN];
        var C = d2.day, D2 = this._getRangeInfo([y2.start.time, x2]).nthWeek;
        return this._orient === "vertical" ? [this._rect.x + C * this._sw + this._sw / 2, this._rect.y + D2 * this._sh + this._sh / 2] : [this._rect.x + D2 * this._sw + this._sw / 2, this._rect.y + C * this._sh + this._sh / 2];
      }, l2.prototype.pointToData = function(a) {
        var e2 = this.pointToDate(a);
        return e2 && e2.time;
      }, l2.prototype.dataToRect = function(a, e2) {
        var d2 = this.dataToPoint(a, e2);
        return { contentShape: { x: d2[0] - (this._sw - this._lineWidth) / 2, y: d2[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: d2, tl: [d2[0] - this._sw / 2, d2[1] - this._sh / 2], tr: [d2[0] + this._sw / 2, d2[1] - this._sh / 2], br: [d2[0] + this._sw / 2, d2[1] + this._sh / 2], bl: [d2[0] - this._sw / 2, d2[1] + this._sh / 2] };
      }, l2.prototype.pointToDate = function(a) {
        var e2 = Math.floor((a[0] - this._rect.x) / this._sw) + 1, d2 = Math.floor((a[1] - this._rect.y) / this._sh) + 1, y2 = this._rangeInfo.range;
        return this._orient === "vertical" ? this._getDateByWeeksAndDay(d2, e2 - 1, y2) : this._getDateByWeeksAndDay(e2, d2 - 1, y2);
      }, l2.prototype.convertToPixel = function(a, e2, d2) {
        var y2 = Bhe(e2);
        return y2 === this ? y2.dataToPoint(d2) : null;
      }, l2.prototype.convertFromPixel = function(a, e2, d2) {
        var y2 = Bhe(e2);
        return y2 === this ? y2.pointToData(d2) : null;
      }, l2.prototype.containPoint = function(a) {
        return console.warn("Not implemented."), false;
      }, l2.prototype._initRangeOption = function() {
        var a = this._model.get("range"), e2;
        if (Ba2(a) && a.length === 1 && (a = a[0]), Ba2(a))
          e2 = a;
        else {
          var d2 = a.toString();
          if (/^\d{4}$/.test(d2) && (e2 = [d2 + "-01-01", d2 + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(d2)) {
            var y2 = this.getDateInfo(d2), x2 = y2.date;
            x2.setMonth(x2.getMonth() + 1);
            var C = this.getNextNDay(x2, -1);
            e2 = [y2.formatedDate, C.formatedDate];
          }
          /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(d2) && (e2 = [d2, d2]);
        }
        if (!e2)
          return a;
        var D2 = this._getRangeInfo(e2);
        return D2.start.time > D2.end.time && e2.reverse(), e2;
      }, l2.prototype._getRangeInfo = function(a) {
        var e2 = [this.getDateInfo(a[0]), this.getDateInfo(a[1])], d2;
        e2[0].time > e2[1].time && (d2 = true, e2.reverse());
        var y2 = Math.floor(e2[1].time / tRt) - Math.floor(e2[0].time / tRt) + 1, x2 = new Date(e2[0].time), C = x2.getDate(), D2 = e2[1].date.getDate();
        x2.setDate(C + y2 - 1);
        var L = x2.getDate();
        if (L !== D2)
          for (var F3 = x2.getTime() - e2[1].time > 0 ? 1 : -1; (L = x2.getDate()) !== D2 && (x2.getTime() - e2[1].time) * F3 > 0; )
            y2 -= F3, x2.setDate(L - F3);
        var j = Math.floor((y2 + e2[0].day + 6) / 7), U3 = d2 ? -j + 1 : j - 1;
        return d2 && e2.reverse(), { range: [e2[0].formatedDate, e2[1].formatedDate], start: e2[0], end: e2[1], allDay: y2, weeks: j, nthWeek: U3, fweek: e2[0].day, lweek: e2[1].day };
      }, l2.prototype._getDateByWeeksAndDay = function(a, e2, d2) {
        var y2 = this._getRangeInfo(d2);
        if (a > y2.weeks || a === 0 && e2 < y2.fweek || a === y2.weeks && e2 > y2.lweek)
          return null;
        var x2 = (a - 1) * 7 - y2.fweek + e2, C = new Date(y2.start.time);
        return C.setDate(+y2.start.d + x2), this.getDateInfo(C);
      }, l2.create = function(a, e2) {
        var d2 = [];
        return a.eachComponent("calendar", function(y2) {
          var x2 = new l2(y2, a, e2);
          d2.push(x2), y2.coordinateSystem = x2;
        }), a.eachSeries(function(y2) {
          y2.get("coordinateSystem") === "calendar" && (y2.coordinateSystem = d2[y2.get("calendarIndex") || 0]);
        }), d2;
      }, l2.dimensions = ["time", "value"], l2;
    }();
    function Bhe(l2) {
      var a = l2.calendarModel, e2 = l2.seriesModel, d2 = a ? a.coordinateSystem : e2 ? e2.coordinateSystem : null;
      return d2;
    }
    var dcn = pcn;
    function gcn(l2) {
      l2.registerComponentModel(ccn), l2.registerComponentView(hcn), l2.registerCoordinateSystem("calendar", dcn);
    }
    function vcn(l2, a) {
      var e2 = l2.existing;
      if (a.id = l2.keyInfo.id, !a.type && e2 && (a.type = e2.type), a.parentId == null) {
        var d2 = a.parentOption;
        d2 ? a.parentId = d2.id : e2 && (a.parentId = e2.parentId);
      }
      a.parentOption = null;
    }
    function zhe(l2, a) {
      var e2;
      return Ke2(a, function(d2) {
        l2[d2] != null && l2[d2] !== "auto" && (e2 = true);
      }), e2;
    }
    function ycn(l2, a, e2) {
      var d2 = la2({}, e2), y2 = l2[a], x2 = e2.$action || "merge";
      x2 === "merge" ? y2 ? (Mu(y2, d2, true), $N(y2, d2, { ignoreSize: true }), die(e2, y2), Lmt(e2, y2), Lmt(e2, y2, "shape"), Lmt(e2, y2, "style"), Lmt(e2, y2, "extra"), e2.clipPath = y2.clipPath) : l2[a] = d2 : x2 === "replace" ? l2[a] = d2 : x2 === "remove" && y2 && (l2[a] = null);
    }
    var jhe = ["transition", "enterFrom", "leaveTo"], mcn = jhe.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
    function Lmt(l2, a, e2) {
      if (e2 && (!l2[e2] && a[e2] && (l2[e2] = {}), l2 = l2[e2], a = a[e2]), !(!l2 || !a))
        for (var d2 = e2 ? jhe : mcn, y2 = 0; y2 < d2.length; y2++) {
          var x2 = d2[y2];
          l2[x2] == null && a[x2] != null && (l2[x2] = a[x2]);
        }
    }
    function bcn(l2, a) {
      if (!!l2 && (l2.hv = a.hv = [zhe(a, ["left", "right"]), zhe(a, ["top", "bottom"])], l2.type === "group")) {
        var e2 = l2, d2 = a;
        e2.width == null && (e2.width = d2.width = 0), e2.height == null && (e2.height = d2.height = 0);
      }
    }
    var _cn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.preventAutoZ = true, e2;
      }
      return a.prototype.mergeOption = function(e2, d2) {
        var y2 = this.option.elements;
        this.option.elements = null, l2.prototype.mergeOption.call(this, e2, d2), this.option.elements = y2;
      }, a.prototype.optionUpdated = function(e2, d2) {
        var y2 = this.option, x2 = (d2 ? y2 : e2).elements, C = y2.elements = d2 ? [] : y2.elements, D2 = [];
        this._flatten(x2, D2, null);
        var L = v12(C, D2, "normalMerge"), F3 = this._elOptionsToUpdate = [];
        Ke2(L, function(j, U3) {
          var Y3 = j.newOption;
          !Y3 || (F3.push(Y3), vcn(j, Y3), ycn(C, U3, Y3), bcn(C[U3], Y3));
        }, this), y2.elements = Lp(C, function(j) {
          return j && delete j.$action, j != null;
        });
      }, a.prototype._flatten = function(e2, d2, y2) {
        Ke2(e2, function(x2) {
          if (x2) {
            y2 && (x2.parentOption = y2), d2.push(x2);
            var C = x2.children;
            x2.type === "group" && C && this._flatten(C, d2, x2), delete x2.children;
          }
        }, this);
      }, a.prototype.useElOptionsToUpdate = function() {
        var e2 = this._elOptionsToUpdate;
        return this._elOptionsToUpdate = null, e2;
      }, a.type = "graphic", a.defaultOption = { elements: [] }, a;
    }(Ah2), Whe = { path: null, compoundPath: null, group: ou, image: Im, text: qc2 }, LA = Rf2(), xcn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function() {
        this._elMap = fl();
      }, a.prototype.render = function(e2, d2, y2) {
        e2 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = e2, this._updateElements(e2), this._relocate(e2, y2);
      }, a.prototype._updateElements = function(e2) {
        var d2 = e2.useElOptionsToUpdate();
        if (d2) {
          var y2 = this._elMap, x2 = this.group, C = e2.get("z"), D2 = e2.get("zlevel");
          Ke2(d2, function(L) {
            var F3 = Ud2(L.id, null), j = F3 != null ? y2.get(F3) : null, U3 = Ud2(L.parentId, null), Y3 = U3 != null ? y2.get(U3) : x2, Q = L.type, nt = L.style;
            Q === "text" && nt && L.hv && L.hv[1] && (nt.textVerticalAlign = nt.textBaseline = nt.verticalAlign = nt.align = null);
            var dt = L.textContent, vt = L.textConfig;
            if (nt && Ufe(nt, Q, !!vt, !!dt)) {
              var Ct = qfe(nt, Q, true);
              !vt && Ct.textConfig && (vt = L.textConfig = Ct.textConfig), !dt && Ct.textContent && (dt = Ct.textContent);
            }
            var Pt = wcn(L), jt = L.$action || "merge", Rt = jt === "merge", le2 = jt === "replace";
            if (Rt) {
              var ne2 = !j, he2 = j;
              ne2 ? he2 = Ghe(F3, Y3, L.type, y2) : (he2 && (LA(he2).isNew = false), nhe(he2)), he2 && (Cmt(he2, Pt, e2, { isInit: ne2 }), Hhe(he2, L, C, D2));
            } else if (le2) {
              Omt(j, L, y2, e2);
              var _e = Ghe(F3, Y3, L.type, y2);
              _e && (Cmt(_e, Pt, e2, { isInit: true }), Hhe(_e, L, C, D2));
            } else
              jt === "remove" && (Qfe(j, L), Omt(j, L, y2, e2));
            var Me2 = y2.get(F3);
            if (Me2 && dt)
              if (Rt) {
                var Pe2 = Me2.getTextContent();
                Pe2 ? Pe2.attr(dt) : Me2.setTextContent(new qc2(dt));
              } else
                le2 && Me2.setTextContent(new qc2(dt));
            if (Me2) {
              var Be2 = L.clipPath;
              if (Be2) {
                var Je2 = Be2.type, Ze2 = void 0, ne2 = false;
                if (Rt) {
                  var Cn = Me2.getClipPath();
                  ne2 = !Cn || LA(Cn).type !== Je2, Ze2 = ne2 ? eRt(Je2) : Cn;
                } else
                  le2 && (ne2 = true, Ze2 = eRt(Je2));
                Me2.setClipPath(Ze2), Cmt(Ze2, Be2, e2, { isInit: ne2 }), Amt(Ze2, Be2.keyframeAnimation, e2);
              }
              var Bn = LA(Me2);
              Me2.setTextConfig(vt), Bn.option = L, Scn(Me2, e2, L), Vq({ el: Me2, componentModel: e2, itemName: Me2.name, itemTooltipOption: L.tooltip }), Amt(Me2, L.keyframeAnimation, e2);
            }
          });
        }
      }, a.prototype._relocate = function(e2, d2) {
        for (var y2 = e2.option.elements, x2 = this.group, C = this._elMap, D2 = d2.getWidth(), L = d2.getHeight(), F3 = ["x", "y"], j = 0; j < y2.length; j++) {
          var U3 = y2[j], Y3 = Ud2(U3.id, null), Q = Y3 != null ? C.get(Y3) : null;
          if (!(!Q || !Q.isGroup)) {
            var nt = Q.parent, dt = nt === x2, vt = LA(Q), Ct = LA(nt);
            vt.width = Ko(vt.option.width, dt ? D2 : Ct.width) || 0, vt.height = Ko(vt.option.height, dt ? L : Ct.height) || 0;
          }
        }
        for (var j = y2.length - 1; j >= 0; j--) {
          var U3 = y2[j], Y3 = Ud2(U3.id, null), Q = Y3 != null ? C.get(Y3) : null;
          if (Q) {
            var nt = Q.parent, Ct = LA(nt), Pt = nt === x2 ? { width: D2, height: L } : { width: Ct.width, height: Ct.height }, jt = {}, Rt = cyt(Q, U3, Pt, null, { hv: U3.hv, boundingMode: U3.bounding }, jt);
            if (!LA(Q).isNew && Rt) {
              for (var le2 = U3.transition, ne2 = {}, he2 = 0; he2 < F3.length; he2++) {
                var _e = F3[he2], Me2 = jt[_e];
                le2 && (IB(le2) || oc2(le2, _e) >= 0) ? ne2[_e] = Me2 : Q[_e] = Me2;
              }
              Yf2(Q, ne2, e2, 0);
            } else
              Q.attr(jt);
          }
        }
      }, a.prototype._clear = function() {
        var e2 = this, d2 = this._elMap;
        d2.each(function(y2) {
          Omt(y2, LA(y2).option, d2, e2._lastGraphicModel);
        }), this._elMap = fl();
      }, a.prototype.dispose = function() {
        this._clear();
      }, a.type = "graphic", a;
    }(_0);
    function eRt(l2) {
      var a = Ns(Whe, l2) ? Whe[l2] : Hn(l2), e2 = new a({});
      return LA(e2).type = l2, e2;
    }
    function Ghe(l2, a, e2, d2) {
      var y2 = eRt(e2);
      return a.add(y2), d2.set(l2, y2), LA(y2).id = l2, LA(y2).isNew = true, y2;
    }
    function Omt(l2, a, e2, d2) {
      var y2 = l2 && l2.parent;
      y2 && (l2.type === "group" && l2.traverse(function(x2) {
        Omt(x2, a, e2, d2);
      }), Tmt(l2, a, d2), e2.removeKey(LA(l2).id));
    }
    function Hhe(l2, a, e2, d2) {
      if (!l2.isGroup) {
        var y2 = l2;
        y2.cursor = $u(a.cursor, Y2.prototype.cursor), y2.z = $u(a.z, e2 || 0), y2.zlevel = $u(a.zlevel, d2 || 0);
        var x2 = a.z2;
        x2 != null && (y2.z2 = x2 || 0);
      }
      Ke2(Qc2(a), function(C) {
        var D2 = a[C];
        C.indexOf("on") === 0 && wl(D2) && (l2[C] = D2);
      }), l2.draggable = a.draggable, a.name != null && (l2.name = a.name), a.id != null && (l2.id = a.id);
    }
    function wcn(l2) {
      return l2 = la2({}, l2), Ke2(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(pie), function(a) {
        delete l2[a];
      }), l2;
    }
    function Scn(l2, a, e2) {
      var d2 = ns(l2).eventData;
      !l2.silent && !l2.ignore && !d2 && (d2 = ns(l2).eventData = { componentType: "graphic", componentIndex: a.componentIndex, name: l2.name }), d2 && (d2.info = e2.info);
    }
    function Mcn(l2) {
      l2.registerComponentModel(_cn), l2.registerComponentView(xcn), l2.registerPreprocessor(function(a) {
        var e2 = a.graphic;
        Ba2(e2) ? !e2[0] || !e2[0].elements ? a.graphic = [{ elements: e2 }] : a.graphic = [a.graphic[0]] : e2 && !e2.elements && (a.graphic = [{ elements: [e2] }]);
      });
    }
    var Uhe = ["x", "y", "radius", "angle", "single"], Ccn = ["cartesian2d", "polar", "singleAxis"];
    function Tcn(l2) {
      var a = l2.get("coordinateSystem");
      return oc2(Ccn, a) >= 0;
    }
    function cF(l2) {
      return l2 + "Axis";
    }
    function Acn(l2, a) {
      var e2 = fl(), d2 = [], y2 = fl();
      l2.eachComponent({ mainType: "dataZoom", query: a }, function(j) {
        y2.get(j.uid) || D2(j);
      });
      var x2;
      do
        x2 = false, l2.eachComponent("dataZoom", C);
      while (x2);
      function C(j) {
        !y2.get(j.uid) && L(j) && (D2(j), x2 = true);
      }
      function D2(j) {
        y2.set(j.uid, true), d2.push(j), F3(j);
      }
      function L(j) {
        var U3 = false;
        return j.eachTargetAxis(function(Y3, Q) {
          var nt = e2.get(Y3);
          nt && nt[Q] && (U3 = true);
        }), U3;
      }
      function F3(j) {
        j.eachTargetAxis(function(U3, Y3) {
          (e2.get(U3) || e2.set(U3, []))[Y3] = true;
        });
      }
      return d2;
    }
    function qhe(l2) {
      var a = l2.ecModel, e2 = { infoList: [], infoMap: fl() };
      return l2.eachTargetAxis(function(d2, y2) {
        var x2 = a.getComponent(cF(d2), y2);
        if (x2) {
          var C = x2.getCoordSysModel();
          if (C) {
            var D2 = C.uid, L = e2.infoMap.get(D2);
            L || (L = { model: C, axisModels: [] }, e2.infoList.push(L), e2.infoMap.set(D2, L)), L.axisModels.push(x2);
          }
        }
      }), e2;
    }
    var nRt = function() {
      function l2() {
        this.indexList = [], this.indexMap = [];
      }
      return l2.prototype.add = function(a) {
        this.indexMap[a] || (this.indexList.push(a), this.indexMap[a] = true);
      }, l2;
    }(), Icn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._autoThrottle = true, e2._noTarget = true, e2._rangePropMode = ["percent", "percent"], e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        var x2 = Zhe(e2);
        this.settledOption = x2, this.mergeDefaultAndTheme(e2, y2), this._doInit(x2);
      }, a.prototype.mergeOption = function(e2) {
        var d2 = Zhe(e2);
        Mu(this.option, e2, true), Mu(this.settledOption, d2, true), this._doInit(d2);
      }, a.prototype._doInit = function(e2) {
        var d2 = this.option;
        this._setDefaultThrottle(e2), this._updateRangeUse(e2);
        var y2 = this.settledOption;
        Ke2([["start", "startValue"], ["end", "endValue"]], function(x2, C) {
          this._rangePropMode[C] === "value" && (d2[x2[0]] = y2[x2[0]] = null);
        }, this), this._resetTarget();
      }, a.prototype._resetTarget = function() {
        var e2 = this.get("orient", true), d2 = this._targetAxisInfoMap = fl(), y2 = this._fillSpecifiedTargetAxis(d2);
        y2 ? this._orient = e2 || this._makeAutoOrientByTargetAxis() : (this._orient = e2 || "horizontal", this._fillAutoTargetAxisByOrient(d2, this._orient)), this._noTarget = true, d2.each(function(x2) {
          x2.indexList.length && (this._noTarget = false);
        }, this);
      }, a.prototype._fillSpecifiedTargetAxis = function(e2) {
        var d2 = false;
        return Ke2(Uhe, function(y2) {
          var x2 = this.getReferringComponents(cF(y2), Y5t);
          if (x2.specified) {
            d2 = true;
            var C = new nRt();
            Ke2(x2.models, function(D2) {
              C.add(D2.componentIndex);
            }), e2.set(y2, C);
          }
        }, this), d2;
      }, a.prototype._fillAutoTargetAxisByOrient = function(e2, d2) {
        var y2 = this.ecModel, x2 = true;
        if (x2) {
          var C = d2 === "vertical" ? "y" : "x", D2 = y2.findComponents({ mainType: C + "Axis" });
          L(D2, C);
        }
        if (x2) {
          var D2 = y2.findComponents({ mainType: "singleAxis", filter: function(j) {
            return j.get("orient", true) === d2;
          } });
          L(D2, "single");
        }
        function L(F3, j) {
          var U3 = F3[0];
          if (U3) {
            var Y3 = new nRt();
            if (Y3.add(U3.componentIndex), e2.set(j, Y3), x2 = false, j === "x" || j === "y") {
              var Q = U3.getReferringComponents("grid", q0).models[0];
              Q && Ke2(F3, function(nt) {
                U3.componentIndex !== nt.componentIndex && Q === nt.getReferringComponents("grid", q0).models[0] && Y3.add(nt.componentIndex);
              });
            }
          }
        }
        x2 && Ke2(Uhe, function(F3) {
          if (x2) {
            var j = y2.findComponents({ mainType: cF(F3), filter: function(Y3) {
              return Y3.get("type", true) === "category";
            } });
            if (j[0]) {
              var U3 = new nRt();
              U3.add(j[0].componentIndex), e2.set(F3, U3), x2 = false;
            }
          }
        }, this);
      }, a.prototype._makeAutoOrientByTargetAxis = function() {
        var e2;
        return this.eachTargetAxis(function(d2) {
          !e2 && (e2 = d2);
        }, this), e2 === "y" ? "vertical" : "horizontal";
      }, a.prototype._setDefaultThrottle = function(e2) {
        if (e2.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
          var d2 = this.ecModel.option;
          this.option.throttle = d2.animation && d2.animationDurationUpdate > 0 ? 100 : 20;
        }
      }, a.prototype._updateRangeUse = function(e2) {
        var d2 = this._rangePropMode, y2 = this.get("rangeMode");
        Ke2([["start", "startValue"], ["end", "endValue"]], function(x2, C) {
          var D2 = e2[x2[0]] != null, L = e2[x2[1]] != null;
          D2 && !L ? d2[C] = "percent" : !D2 && L ? d2[C] = "value" : y2 ? d2[C] = y2[C] : D2 && (d2[C] = "percent");
        });
      }, a.prototype.noTarget = function() {
        return this._noTarget;
      }, a.prototype.getFirstTargetAxisModel = function() {
        var e2;
        return this.eachTargetAxis(function(d2, y2) {
          e2 == null && (e2 = this.ecModel.getComponent(cF(d2), y2));
        }, this), e2;
      }, a.prototype.eachTargetAxis = function(e2, d2) {
        this._targetAxisInfoMap.each(function(y2, x2) {
          Ke2(y2.indexList, function(C) {
            e2.call(d2, x2, C);
          });
        });
      }, a.prototype.getAxisProxy = function(e2, d2) {
        var y2 = this.getAxisModel(e2, d2);
        if (y2)
          return y2.__dzAxisProxy;
      }, a.prototype.getAxisModel = function(e2, d2) {
        var y2 = this._targetAxisInfoMap.get(e2);
        if (y2 && y2.indexMap[d2])
          return this.ecModel.getComponent(cF(e2), d2);
      }, a.prototype.setRawRange = function(e2) {
        var d2 = this.option, y2 = this.settledOption;
        Ke2([["start", "startValue"], ["end", "endValue"]], function(x2) {
          (e2[x2[0]] != null || e2[x2[1]] != null) && (d2[x2[0]] = y2[x2[0]] = e2[x2[0]], d2[x2[1]] = y2[x2[1]] = e2[x2[1]]);
        }, this), this._updateRangeUse(e2);
      }, a.prototype.setCalculatedRange = function(e2) {
        var d2 = this.option;
        Ke2(["start", "startValue", "end", "endValue"], function(y2) {
          d2[y2] = e2[y2];
        });
      }, a.prototype.getPercentRange = function() {
        var e2 = this.findRepresentativeAxisProxy();
        if (e2)
          return e2.getDataPercentWindow();
      }, a.prototype.getValueRange = function(e2, d2) {
        if (e2 == null && d2 == null) {
          var y2 = this.findRepresentativeAxisProxy();
          if (y2)
            return y2.getDataValueWindow();
        } else
          return this.getAxisProxy(e2, d2).getDataValueWindow();
      }, a.prototype.findRepresentativeAxisProxy = function(e2) {
        if (e2)
          return e2.__dzAxisProxy;
        for (var d2, y2 = this._targetAxisInfoMap.keys(), x2 = 0; x2 < y2.length; x2++)
          for (var C = y2[x2], D2 = this._targetAxisInfoMap.get(C), L = 0; L < D2.indexList.length; L++) {
            var F3 = this.getAxisProxy(C, D2.indexList[L]);
            if (F3.hostedBy(this))
              return F3;
            d2 || (d2 = F3);
          }
        return d2;
      }, a.prototype.getRangePropMode = function() {
        return this._rangePropMode.slice();
      }, a.prototype.getOrient = function() {
        return this._orient;
      }, a.type = "dataZoom", a.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], a.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, a;
    }(Ah2);
    function Zhe(l2) {
      var a = {};
      return Ke2(["start", "end", "startValue", "endValue", "throttle"], function(e2) {
        l2.hasOwnProperty(e2) && (a[e2] = l2[e2]);
      }), a;
    }
    var cit = Icn, Dcn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "dataZoom.select", a;
    }(cit), Ecn = Dcn, kcn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        this.dataZoomModel = e2, this.ecModel = d2, this.api = y2;
      }, a.type = "dataZoom", a;
    }(_0), rRt = kcn, Pcn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "dataZoom.select", a;
    }(rRt), Lcn = Pcn, mZ = Ke2, $he = k_, Ocn = function() {
      function l2(a, e2, d2, y2) {
        this._dimName = a, this._axisIndex = e2, this.ecModel = y2, this._dataZoomModel = d2;
      }
      return l2.prototype.hostedBy = function(a) {
        return this._dataZoomModel === a;
      }, l2.prototype.getDataValueWindow = function() {
        return this._valueWindow.slice();
      }, l2.prototype.getDataPercentWindow = function() {
        return this._percentWindow.slice();
      }, l2.prototype.getTargetSeriesModels = function() {
        var a = [];
        return this.ecModel.eachSeries(function(e2) {
          if (Tcn(e2)) {
            var d2 = cF(this._dimName), y2 = e2.getReferringComponents(d2, q0).models[0];
            y2 && this._axisIndex === y2.componentIndex && a.push(e2);
          }
        }, this), a;
      }, l2.prototype.getAxisModel = function() {
        return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
      }, l2.prototype.getMinMaxSpan = function() {
        return zl(this._minMaxSpan);
      }, l2.prototype.calculateDataWindow = function(a) {
        var e2 = this._dataExtent, d2 = this.getAxisModel(), y2 = d2.axis.scale, x2 = this._dataZoomModel.getRangePropMode(), C = [0, 100], D2 = [], L = [], F3;
        mZ(["start", "end"], function(Y3, Q) {
          var nt = a[Y3], dt = a[Y3 + "Value"];
          x2[Q] === "percent" ? (nt == null && (nt = C[Q]), dt = y2.parse(yp(nt, C, e2))) : (F3 = true, dt = dt == null ? e2[Q] : y2.parse(dt), nt = yp(dt, e2, C)), L[Q] = dt, D2[Q] = nt;
        }), $he(L), $he(D2);
        var j = this._minMaxSpan;
        F3 ? U3(L, D2, e2, C, false) : U3(D2, L, C, e2, true);
        function U3(Y3, Q, nt, dt, vt) {
          var Ct = vt ? "Span" : "ValueSpan";
          CB(0, Y3, nt, "all", j["min" + Ct], j["max" + Ct]);
          for (var Pt = 0; Pt < 2; Pt++)
            Q[Pt] = yp(Y3[Pt], nt, dt, true), vt && (Q[Pt] = y2.parse(Q[Pt]));
        }
        return { valueWindow: L, percentWindow: D2 };
      }, l2.prototype.reset = function(a) {
        if (a === this._dataZoomModel) {
          var e2 = this.getTargetSeriesModels();
          this._dataExtent = Rcn(this, this._dimName, e2), this._updateMinMaxSpan();
          var d2 = this.calculateDataWindow(a.settledOption);
          this._valueWindow = d2.valueWindow, this._percentWindow = d2.percentWindow, this._setAxisModel();
        }
      }, l2.prototype.filterData = function(a, e2) {
        if (a !== this._dataZoomModel)
          return;
        var d2 = this._dimName, y2 = this.getTargetSeriesModels(), x2 = a.get("filterMode"), C = this._valueWindow;
        if (x2 === "none")
          return;
        mZ(y2, function(L) {
          var F3 = L.getData(), j = F3.mapDimensionsAll(d2);
          if (j.length) {
            if (x2 === "weakFilter") {
              var U3 = F3.getStore(), Y3 = $a2(j, function(Q) {
                return F3.getDimensionIndex(Q);
              }, F3);
              F3.filterSelf(function(Q) {
                for (var nt, dt, vt, Ct = 0; Ct < j.length; Ct++) {
                  var Pt = U3.get(Y3[Ct], Q), jt = !isNaN(Pt), Rt = Pt < C[0], le2 = Pt > C[1];
                  if (jt && !Rt && !le2)
                    return true;
                  jt && (vt = true), Rt && (nt = true), le2 && (dt = true);
                }
                return vt && nt && dt;
              });
            } else
              mZ(j, function(Q) {
                if (x2 === "empty")
                  L.setData(F3 = F3.map(Q, function(dt) {
                    return D2(dt) ? dt : NaN;
                  }));
                else {
                  var nt = {};
                  nt[Q] = C, F3.selectRange(nt);
                }
              });
            mZ(j, function(Q) {
              F3.setApproximateExtent(C, Q);
            });
          }
        });
        function D2(L) {
          return L >= C[0] && L <= C[1];
        }
      }, l2.prototype._updateMinMaxSpan = function() {
        var a = this._minMaxSpan = {}, e2 = this._dataZoomModel, d2 = this._dataExtent;
        mZ(["min", "max"], function(y2) {
          var x2 = e2.get(y2 + "Span"), C = e2.get(y2 + "ValueSpan");
          C != null && (C = this.getAxisModel().axis.scale.parse(C)), C != null ? x2 = yp(d2[0] + C, d2, [0, 100], true) : x2 != null && (C = yp(x2, [0, 100], d2, true) - d2[0]), a[y2 + "Span"] = x2, a[y2 + "ValueSpan"] = C;
        }, this);
      }, l2.prototype._setAxisModel = function() {
        var a = this.getAxisModel(), e2 = this._percentWindow, d2 = this._valueWindow;
        if (e2) {
          var y2 = Vvt(d2, [0, 500]);
          y2 = Math.min(y2, 20);
          var x2 = a.axis.scale.rawExtentInfo;
          e2[0] !== 0 && x2.setDeterminedMinMax("min", +d2[0].toFixed(y2)), e2[1] !== 100 && x2.setDeterminedMinMax("max", +d2[1].toFixed(y2)), x2.freeze();
        }
      }, l2;
    }();
    function Rcn(l2, a, e2) {
      var d2 = [1 / 0, -1 / 0];
      mZ(e2, function(C) {
        aQe(d2, C.getData(), a);
      });
      var y2 = l2.getAxisModel(), x2 = ise(y2.axis.scale, y2, d2).calculate();
      return [x2.min, x2.max];
    }
    var Ncn = Ocn, Fcn = { getTargetSeries: function(l2) {
      function a(y2) {
        l2.eachComponent("dataZoom", function(x2) {
          x2.eachTargetAxis(function(C, D2) {
            var L = l2.getComponent(cF(C), D2);
            y2(C, D2, L, x2);
          });
        });
      }
      a(function(y2, x2, C, D2) {
        C.__dzAxisProxy = null;
      });
      var e2 = [];
      a(function(y2, x2, C, D2) {
        C.__dzAxisProxy || (C.__dzAxisProxy = new Ncn(y2, x2, D2, l2), e2.push(C.__dzAxisProxy));
      });
      var d2 = fl();
      return Ke2(e2, function(y2) {
        Ke2(y2.getTargetSeriesModels(), function(x2) {
          d2.set(x2.uid, x2);
        });
      }), d2;
    }, overallReset: function(l2, a) {
      l2.eachComponent("dataZoom", function(e2) {
        e2.eachTargetAxis(function(d2, y2) {
          e2.getAxisProxy(d2, y2).reset(e2);
        }), e2.eachTargetAxis(function(d2, y2) {
          e2.getAxisProxy(d2, y2).filterData(e2, a);
        });
      }), l2.eachComponent("dataZoom", function(e2) {
        var d2 = e2.findRepresentativeAxisProxy();
        if (d2) {
          var y2 = d2.getDataPercentWindow(), x2 = d2.getDataValueWindow();
          e2.setCalculatedRange({ start: y2[0], end: y2[1], startValue: x2[0], endValue: x2[1] });
        }
      });
    } }, Vcn = Fcn;
    function Bcn(l2) {
      l2.registerAction("dataZoom", function(a, e2) {
        var d2 = Acn(e2, a);
        Ke2(d2, function(y2) {
          y2.setRawRange({ start: a.start, end: a.end, startValue: a.startValue, endValue: a.endValue });
        });
      });
    }
    var Yhe = false;
    function iRt(l2) {
      Yhe || (Yhe = true, l2.registerProcessor(l2.PRIORITY.PROCESSOR.FILTER, Vcn), Bcn(l2), l2.registerSubTypeDefaulter("dataZoom", function() {
        return "slider";
      }));
    }
    function zcn(l2) {
      l2.registerComponentModel(Ecn), l2.registerComponentView(Lcn), iRt(l2);
    }
    var OA = function() {
      function l2() {
      }
      return l2;
    }(), Khe = {};
    function bZ(l2, a) {
      Khe[l2] = a;
    }
    function Xhe(l2) {
      return Khe[l2];
    }
    var jcn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.optionUpdated = function() {
        l2.prototype.optionUpdated.apply(this, arguments);
        var e2 = this.ecModel;
        Ke2(this.option.feature, function(d2, y2) {
          var x2 = Xhe(y2);
          x2 && (x2.getDefaultOption && (x2.defaultOption = x2.getDefaultOption(e2)), Mu(d2, x2.defaultOption));
        });
      }, a.type = "toolbox", a.layoutMode = { type: "box", ignoreSize: true }, a.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, a;
    }(Ah2), Wcn = jcn;
    function Gcn(l2, a, e2) {
      var d2 = a.getBoxLayoutParams(), y2 = a.get("padding"), x2 = { width: e2.getWidth(), height: e2.getHeight() }, C = Em(d2, x2, y2);
      iB(a.get("orient"), l2, a.get("itemGap"), C.width, C.height), cyt(l2, d2, x2, y2);
    }
    function Qhe(l2, a) {
      var e2 = Gq(a.get("padding")), d2 = a.getItemStyle(["color", "opacity"]);
      return d2.fill = a.get("backgroundColor"), l2 = new Nf2({ shape: { x: l2.x - e2[3], y: l2.y - e2[0], width: l2.width + e2[1] + e2[3], height: l2.height + e2[0] + e2[2], r: a.get("borderRadius") }, style: d2, silent: true, z2: -1 }), l2;
    }
    var Hcn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        var C = this.group;
        if (C.removeAll(), !e2.get("show"))
          return;
        var D2 = +e2.get("itemSize"), L = e2.get("feature") || {}, F3 = this._features || (this._features = {}), j = [];
        Ke2(L, function(Q, nt) {
          j.push(nt);
        }), new kO(this._featureNames || [], j).add(U3).update(U3).remove(xu(U3, null)).execute(), this._featureNames = j;
        function U3(Q, nt) {
          var dt = j[Q], vt = j[nt], Ct = L[dt], Pt = new hg2(Ct, e2, e2.ecModel), jt;
          if (x2 && x2.newTitle != null && x2.featureName === dt && (Ct.title = x2.newTitle), dt && !vt) {
            if (Ucn(dt))
              jt = { onclick: Pt.option.onclick, featureName: dt };
            else {
              var Rt = Xhe(dt);
              if (!Rt)
                return;
              jt = new Rt();
            }
            F3[dt] = jt;
          } else if (jt = F3[vt], !jt)
            return;
          jt.uid = zq("toolbox-feature"), jt.model = Pt, jt.ecModel = d2, jt.api = y2;
          var le2 = jt instanceof OA;
          if (!dt && vt) {
            le2 && jt.dispose && jt.dispose(d2, y2);
            return;
          }
          if (!Pt.get("show") || le2 && jt.unusable) {
            le2 && jt.remove && jt.remove(d2, y2);
            return;
          }
          Y3(Pt, jt, dt), Pt.setIconStatus = function(ne2, he2) {
            var _e = this.option, Me2 = this.iconPaths;
            _e.iconStatus = _e.iconStatus || {}, _e.iconStatus[ne2] = he2, Me2[ne2] && (he2 === "emphasis" ? Dm : fc2)(Me2[ne2]);
          }, jt instanceof OA && jt.render && jt.render(Pt, d2, y2, x2);
        }
        function Y3(Q, nt, dt) {
          var vt = Q.getModel("iconStyle"), Ct = Q.getModel(["emphasis", "iconStyle"]), Pt = nt instanceof OA && nt.getIcons ? nt.getIcons() : Q.get("icon"), jt = Q.get("title") || {}, Rt, le2;
          ps(Pt) ? (Rt = {}, Rt[dt] = Pt) : Rt = Pt, ps(jt) ? (le2 = {}, le2[dt] = jt) : le2 = jt;
          var ne2 = Q.iconPaths = {};
          Ke2(Rt, function(he2, _e) {
            var Me2 = fv(he2, {}, { x: -D2 / 2, y: -D2 / 2, width: D2, height: D2 });
            Me2.setStyle(vt.getItemStyle());
            var Pe2 = Me2.ensureState("emphasis");
            Pe2.style = Ct.getItemStyle();
            var Be2 = new qc2({ style: { text: le2[_e], align: Ct.get("textAlign"), borderRadius: Ct.get("textBorderRadius"), padding: Ct.get("textPadding"), fill: null }, ignore: true });
            Me2.setTextContent(Be2), Vq({ el: Me2, componentModel: e2, itemName: _e, formatterParamsExtra: { title: le2[_e] } }), Me2.__title = le2[_e], Me2.on("mouseover", function() {
              var Je2 = Ct.getItemStyle(), Ze2 = e2.get("orient") === "vertical" ? e2.get("right") == null ? "right" : "left" : e2.get("bottom") == null ? "bottom" : "top";
              Be2.setStyle({ fill: Ct.get("textFill") || Je2.fill || Je2.stroke || "#000", backgroundColor: Ct.get("textBackgroundColor") }), Me2.setTextConfig({ position: Ct.get("textPosition") || Ze2 }), Be2.ignore = !e2.get("showTitle"), Dm(this);
            }).on("mouseout", function() {
              Q.get(["iconStatus", _e]) !== "emphasis" && fc2(this), Be2.hide();
            }), (Q.get(["iconStatus", _e]) === "emphasis" ? Dm : fc2)(Me2), C.add(Me2), Me2.on("click", As(nt.onclick, nt, d2, y2, _e)), ne2[_e] = Me2;
          });
        }
        Gcn(C, e2, y2), C.add(Qhe(C.getBoundingRect(), e2)), C.eachChild(function(Q) {
          var nt = Q.__title, dt = Q.ensureState("emphasis"), vt = dt.textConfig || (dt.textConfig = {}), Ct = Q.getTextContent(), Pt = Ct && Ct.states.emphasis;
          if (Pt && !wl(Pt) && nt) {
            var jt = Pt.style || (Pt.style = {}), Rt = uO(nt, qc2.makeFont(jt)), le2 = Q.x + C.x, ne2 = Q.y + C.y + D2, he2 = false;
            ne2 + Rt.height > y2.getHeight() && (vt.position = "top", he2 = true);
            var _e = he2 ? -5 - Rt.height : D2 + 8;
            le2 + Rt.width / 2 > y2.getWidth() ? (vt.position = ["100%", _e], jt.align = "right") : le2 - Rt.width / 2 < 0 && (vt.position = [0, _e], jt.align = "left");
          }
        });
      }, a.prototype.updateView = function(e2, d2, y2, x2) {
        Ke2(this._features, function(C) {
          C instanceof OA && C.updateView && C.updateView(C.model, d2, y2, x2);
        });
      }, a.prototype.remove = function(e2, d2) {
        Ke2(this._features, function(y2) {
          y2 instanceof OA && y2.remove && y2.remove(e2, d2);
        }), this.group.removeAll();
      }, a.prototype.dispose = function(e2, d2) {
        Ke2(this._features, function(y2) {
          y2 instanceof OA && y2.dispose && y2.dispose(e2, d2);
        });
      }, a.type = "toolbox", a;
    }(_0);
    function Ucn(l2) {
      return l2.indexOf("my") === 0;
    }
    var qcn = Hcn, Zcn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.onclick = function(e2, d2) {
        var y2 = this.model, x2 = y2.get("name") || e2.get("title.0.text") || "echarts", C = d2.getZr().painter.getType() === "svg", D2 = C ? "svg" : y2.get("type", true) || "png", L = d2.getConnectedDataURL({ type: D2, backgroundColor: y2.get("backgroundColor", true) || e2.get("backgroundColor") || "#fff", connectedBackgroundColor: y2.get("connectedBackgroundColor"), excludeComponents: y2.get("excludeComponents"), pixelRatio: y2.get("pixelRatio") }), F3 = $s.browser;
        if (wl(MouseEvent) && (F3.newEdge || !F3.ie && !F3.edge)) {
          var j = document.createElement("a");
          j.download = x2 + "." + D2, j.target = "_blank", j.href = L;
          var U3 = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
          j.dispatchEvent(U3);
        } else if (window.navigator.msSaveOrOpenBlob || C) {
          var Y3 = L.split(","), Q = Y3[0].indexOf("base64") > -1, nt = C ? decodeURIComponent(Y3[1]) : Y3[1];
          Q && (nt = window.atob(nt));
          var dt = x2 + "." + D2;
          if (window.navigator.msSaveOrOpenBlob) {
            for (var vt = nt.length, Ct = new Uint8Array(vt); vt--; )
              Ct[vt] = nt.charCodeAt(vt);
            var Pt = new Blob([Ct]);
            window.navigator.msSaveOrOpenBlob(Pt, dt);
          } else {
            var jt = document.createElement("iframe");
            document.body.appendChild(jt);
            var Rt = jt.contentWindow, le2 = Rt.document;
            le2.open("image/svg+xml", "replace"), le2.write(nt), le2.close(), Rt.focus(), le2.execCommand("SaveAs", true, dt), document.body.removeChild(jt);
          }
        } else {
          var ne2 = y2.get("lang"), he2 = '<body style="margin:0;"><img src="' + L + '" style="max-width:100%;" title="' + (ne2 && ne2[0] || "") + '" /></body>', _e = window.open();
          _e.document.write(he2), _e.document.title = x2;
        }
      }, a.getDefaultOption = function(e2) {
        var d2 = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: e2.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: e2.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
        return d2;
      }, a;
    }(OA), $cn = Zcn, Jhe = "__ec_magicType_stack__", Ycn = [["line", "bar"], ["stack"]], Kcn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.getIcons = function() {
        var e2 = this.model, d2 = e2.get("icon"), y2 = {};
        return Ke2(e2.get("type"), function(x2) {
          d2[x2] && (y2[x2] = d2[x2]);
        }), y2;
      }, a.getDefaultOption = function(e2) {
        var d2 = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: e2.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
        return d2;
      }, a.prototype.onclick = function(e2, d2, y2) {
        var x2 = this.model, C = x2.get(["seriesIndex", y2]);
        if (tpe[y2]) {
          var D2 = { series: [] }, L = function(U3) {
            var Y3 = U3.subType, Q = U3.id, nt = tpe[y2](Y3, Q, U3, x2);
            nt && (El(nt, U3.option), D2.series.push(nt));
            var dt = U3.coordinateSystem;
            if (dt && dt.type === "cartesian2d" && (y2 === "line" || y2 === "bar")) {
              var vt = dt.getAxesByScale("ordinal")[0];
              if (vt) {
                var Ct = vt.dim, Pt = Ct + "Axis", jt = U3.getReferringComponents(Pt, q0).models[0], Rt = jt.componentIndex;
                D2[Pt] = D2[Pt] || [];
                for (var le2 = 0; le2 <= Rt; le2++)
                  D2[Pt][Rt] = D2[Pt][Rt] || {};
                D2[Pt][Rt].boundaryGap = y2 === "bar";
              }
            }
          };
          Ke2(Ycn, function(U3) {
            oc2(U3, y2) >= 0 && Ke2(U3, function(Y3) {
              x2.setIconStatus(Y3, "normal");
            });
          }), x2.setIconStatus(y2, "emphasis"), e2.eachComponent({ mainType: "series", query: C == null ? null : { seriesIndex: C } }, L);
          var F3, j = y2;
          y2 === "stack" && (F3 = Mu({ stack: x2.option.title.tiled, tiled: x2.option.title.stack }, x2.option.title), x2.get(["iconStatus", y2]) !== "emphasis" && (j = "tiled")), d2.dispatchAction({ type: "changeMagicType", currentType: j, newOption: D2, newTitle: F3, featureName: "magicType" });
        }
      }, a;
    }(OA), tpe = { line: function(l2, a, e2, d2) {
      if (l2 === "bar")
        return Mu({ id: a, type: "line", data: e2.get("data"), stack: e2.get("stack"), markPoint: e2.get("markPoint"), markLine: e2.get("markLine") }, d2.get(["option", "line"]) || {}, true);
    }, bar: function(l2, a, e2, d2) {
      if (l2 === "line")
        return Mu({ id: a, type: "bar", data: e2.get("data"), stack: e2.get("stack"), markPoint: e2.get("markPoint"), markLine: e2.get("markLine") }, d2.get(["option", "bar"]) || {}, true);
    }, stack: function(l2, a, e2, d2) {
      var y2 = e2.get("stack") === Jhe;
      if (l2 === "line" || l2 === "bar")
        return d2.setIconStatus("stack", y2 ? "normal" : "emphasis"), Mu({ id: a, stack: y2 ? "" : Jhe }, d2.get(["option", "stack"]) || {}, true);
    } };
    sP({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(l2, a) {
      a.mergeOption(l2.newOption);
    });
    var Xcn = Kcn, Rmt = new Array(60).join("-"), _Z = "	";
    function Qcn(l2) {
      var a = {}, e2 = [], d2 = [];
      return l2.eachRawSeries(function(y2) {
        var x2 = y2.coordinateSystem;
        if (x2 && (x2.type === "cartesian2d" || x2.type === "polar")) {
          var C = x2.getBaseAxis();
          if (C.type === "category") {
            var D2 = C.dim + "_" + C.index;
            a[D2] || (a[D2] = { categoryAxis: C, valueAxis: x2.getOtherAxis(C), series: [] }, d2.push({ axisDim: C.dim, axisIndex: C.index })), a[D2].series.push(y2);
          } else
            e2.push(y2);
        } else
          e2.push(y2);
      }), { seriesGroupByCategoryAxis: a, other: e2, meta: d2 };
    }
    function Jcn(l2) {
      var a = [];
      return Ke2(l2, function(e2, d2) {
        var y2 = e2.categoryAxis, x2 = e2.valueAxis, C = x2.dim, D2 = [" "].concat($a2(e2.series, function(Q) {
          return Q.name;
        })), L = [y2.model.getCategories()];
        Ke2(e2.series, function(Q) {
          var nt = Q.getRawData();
          L.push(Q.getRawData().mapArray(nt.mapDimension(C), function(dt) {
            return dt;
          }));
        });
        for (var F3 = [D2.join(_Z)], j = 0; j < L[0].length; j++) {
          for (var U3 = [], Y3 = 0; Y3 < L.length; Y3++)
            U3.push(L[Y3][j]);
          F3.push(U3.join(_Z));
        }
        a.push(F3.join(`
`));
      }), a.join(`

` + Rmt + `

`);
    }
    function tfn(l2) {
      return $a2(l2, function(a) {
        var e2 = a.getRawData(), d2 = [a.name], y2 = [];
        return e2.each(e2.dimensions, function() {
          for (var x2 = arguments.length, C = arguments[x2 - 1], D2 = e2.getName(C), L = 0; L < x2 - 1; L++)
            y2[L] = arguments[L];
          d2.push((D2 ? D2 + _Z : "") + y2.join(_Z));
        }), d2.join(`
`);
      }).join(`

` + Rmt + `

`);
    }
    function efn(l2) {
      var a = Qcn(l2);
      return { value: Lp([Jcn(a.seriesGroupByCategoryAxis), tfn(a.other)], function(e2) {
        return !!e2.replace(/[\n\t\s]/g, "");
      }).join(`

` + Rmt + `

`), meta: a.meta };
    }
    function Nmt(l2) {
      return l2.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
    }
    function nfn(l2) {
      var a = l2.slice(0, l2.indexOf(`
`));
      if (a.indexOf(_Z) >= 0)
        return true;
    }
    var aRt = new RegExp("[" + _Z + "]+", "g");
    function rfn(l2) {
      for (var a = l2.split(/\n+/g), e2 = Nmt(a.shift()).split(aRt), d2 = [], y2 = $a2(e2, function(L) {
        return { name: L, data: [] };
      }), x2 = 0; x2 < a.length; x2++) {
        var C = Nmt(a[x2]).split(aRt);
        d2.push(C.shift());
        for (var D2 = 0; D2 < C.length; D2++)
          y2[D2] && (y2[D2].data[x2] = C[D2]);
      }
      return { series: y2, categories: d2 };
    }
    function ifn(l2) {
      for (var a = l2.split(/\n+/g), e2 = Nmt(a.shift()), d2 = [], y2 = 0; y2 < a.length; y2++) {
        var x2 = Nmt(a[y2]);
        if (x2) {
          var C = x2.split(aRt), D2 = "", L = void 0, F3 = false;
          isNaN(C[0]) ? (F3 = true, D2 = C[0], C = C.slice(1), d2[y2] = { name: D2, value: [] }, L = d2[y2].value) : L = d2[y2] = [];
          for (var j = 0; j < C.length; j++)
            L.push(+C[j]);
          L.length === 1 && (F3 ? d2[y2].value = L[0] : d2[y2] = L[0]);
        }
      }
      return { name: e2, data: d2 };
    }
    function afn(l2, a) {
      var e2 = l2.split(new RegExp(`
*` + Rmt + `
*`, "g")), d2 = { series: [] };
      return Ke2(e2, function(y2, x2) {
        if (nfn(y2)) {
          var C = rfn(y2), D2 = a[x2], L = D2.axisDim + "Axis";
          D2 && (d2[L] = d2[L] || [], d2[L][D2.axisIndex] = { data: C.categories }, d2.series = d2.series.concat(C.series));
        } else {
          var C = ifn(y2);
          d2.series.push(C);
        }
      }), d2;
    }
    var ofn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.onclick = function(e2, d2) {
        setTimeout(function() {
          d2.dispatchAction({ type: "hideTip" });
        });
        var y2 = d2.getDom(), x2 = this.model;
        this._dom && y2.removeChild(this._dom);
        var C = document.createElement("div");
        C.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", C.style.backgroundColor = x2.get("backgroundColor") || "#fff";
        var D2 = document.createElement("h4"), L = x2.get("lang") || [];
        D2.innerHTML = L[0] || x2.get("title"), D2.style.cssText = "margin:10px 20px", D2.style.color = x2.get("textColor");
        var F3 = document.createElement("div"), j = document.createElement("textarea");
        F3.style.cssText = "overflow:auto";
        var U3 = x2.get("optionToContent"), Y3 = x2.get("contentToOption"), Q = efn(e2);
        if (wl(U3)) {
          var nt = U3(d2.getOption());
          ps(nt) ? F3.innerHTML = nt : hV(nt) && F3.appendChild(nt);
        } else {
          j.readOnly = x2.get("readOnly");
          var dt = j.style;
          dt.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", dt.color = x2.get("textColor"), dt.borderColor = x2.get("textareaBorderColor"), dt.backgroundColor = x2.get("textareaColor"), j.value = Q.value, F3.appendChild(j);
        }
        var vt = Q.meta, Ct = document.createElement("div");
        Ct.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
        var Pt = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", jt = document.createElement("div"), Rt = document.createElement("div");
        Pt += ";background-color:" + x2.get("buttonColor"), Pt += ";color:" + x2.get("buttonTextColor");
        var le2 = this;
        function ne2() {
          y2.removeChild(C), le2._dom = null;
        }
        hN(jt, "click", ne2), hN(Rt, "click", function() {
          if (Y3 == null && U3 != null || Y3 != null && U3 == null) {
            ne2();
            return;
          }
          var he2;
          try {
            wl(Y3) ? he2 = Y3(F3, d2.getOption()) : he2 = afn(j.value, vt);
          } catch (_e) {
            throw ne2(), new Error("Data view format error " + _e);
          }
          he2 && d2.dispatchAction({ type: "changeDataView", newOption: he2 }), ne2();
        }), jt.innerHTML = L[1], Rt.innerHTML = L[2], Rt.style.cssText = jt.style.cssText = Pt, !x2.get("readOnly") && Ct.appendChild(Rt), Ct.appendChild(jt), C.appendChild(D2), C.appendChild(F3), C.appendChild(Ct), F3.style.height = y2.clientHeight - 80 + "px", y2.appendChild(C), this._dom = C;
      }, a.prototype.remove = function(e2, d2) {
        this._dom && d2.getDom().removeChild(this._dom);
      }, a.prototype.dispose = function(e2, d2) {
        this.remove(e2, d2);
      }, a.getDefaultOption = function(e2) {
        var d2 = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: e2.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: e2.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
        return d2;
      }, a;
    }(OA);
    function sfn(l2, a) {
      return $a2(l2, function(e2, d2) {
        var y2 = a && a[d2];
        if (vs(y2) && !Ba2(y2)) {
          var x2 = vs(e2) && !Ba2(e2);
          x2 || (e2 = { value: e2 });
          var C = y2.name != null && e2.name == null;
          return e2 = El(e2, y2), C && delete e2.name, e2;
        } else
          return e2;
      });
    }
    sP({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(l2, a) {
      var e2 = [];
      Ke2(l2.newOption.series, function(d2) {
        var y2 = a.getSeriesByName(d2.name)[0];
        if (!y2)
          e2.push(la2({ type: "scatter" }, d2));
        else {
          var x2 = y2.get("data");
          e2.push({ name: d2.name, data: sfn(d2.data, x2) });
        }
      }), a.mergeOption(El({ series: e2 }, l2.newOption));
    });
    var lfn = ofn, epe = Ke2, npe = Rf2();
    function ufn(l2, a) {
      var e2 = oRt(l2);
      epe(a, function(d2, y2) {
        for (var x2 = e2.length - 1; x2 >= 0; x2--) {
          var C = e2[x2];
          if (C[y2])
            break;
        }
        if (x2 < 0) {
          var D2 = l2.queryComponents({ mainType: "dataZoom", subType: "select", id: y2 })[0];
          if (D2) {
            var L = D2.getPercentRange();
            e2[0][y2] = { dataZoomId: y2, start: L[0], end: L[1] };
          }
        }
      }), e2.push(a);
    }
    function cfn(l2) {
      var a = oRt(l2), e2 = a[a.length - 1];
      a.length > 1 && a.pop();
      var d2 = {};
      return epe(e2, function(y2, x2) {
        for (var C = a.length - 1; C >= 0; C--)
          if (y2 = a[C][x2], y2) {
            d2[x2] = y2;
            break;
          }
      }), d2;
    }
    function ffn(l2) {
      npe(l2).snapshots = null;
    }
    function hfn(l2) {
      return oRt(l2).length;
    }
    function oRt(l2) {
      var a = npe(l2);
      return a.snapshots || (a.snapshots = [{}]), a.snapshots;
    }
    var pfn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.onclick = function(e2, d2) {
        ffn(e2), d2.dispatchAction({ type: "restore", from: this.uid });
      }, a.getDefaultOption = function(e2) {
        var d2 = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: e2.getLocaleModel().get(["toolbox", "restore", "title"]) };
        return d2;
      }, a;
    }(OA);
    sP({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(l2, a) {
      a.resetOption("recreate");
    });
    var dfn = pfn, gfn = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], vfn = function() {
      function l2(a, e2, d2) {
        var y2 = this;
        this._targetInfoList = [];
        var x2 = rpe(e2, a);
        Ke2(yfn, function(C, D2) {
          (!d2 || !d2.include || oc2(d2.include, D2) >= 0) && C(x2, y2._targetInfoList);
        });
      }
      return l2.prototype.setOutputRanges = function(a, e2) {
        return this.matchOutputRanges(a, e2, function(d2, y2, x2) {
          if ((d2.coordRanges || (d2.coordRanges = [])).push(y2), !d2.coordRange) {
            d2.coordRange = y2;
            var C = lRt[d2.brushType](0, x2, y2);
            d2.__rangeOffset = { offset: spe[d2.brushType](C.values, d2.range, [1, 1]), xyMinMax: C.xyMinMax };
          }
        }), a;
      }, l2.prototype.matchOutputRanges = function(a, e2, d2) {
        Ke2(a, function(y2) {
          var x2 = this.findTargetInfo(y2, e2);
          x2 && x2 !== true && Ke2(x2.coordSyses, function(C) {
            var D2 = lRt[y2.brushType](1, C, y2.range, true);
            d2(y2, D2.values, C, e2);
          });
        }, this);
      }, l2.prototype.setInputRanges = function(a, e2) {
        Ke2(a, function(d2) {
          var y2 = this.findTargetInfo(d2, e2);
          if (d2.range = d2.range || [], y2 && y2 !== true) {
            d2.panelId = y2.panelId;
            var x2 = lRt[d2.brushType](0, y2.coordSys, d2.coordRange), C = d2.__rangeOffset;
            d2.range = C ? spe[d2.brushType](x2.values, C.offset, mfn(x2.xyMinMax, C.xyMinMax)) : x2.values;
          }
        }, this);
      }, l2.prototype.makePanelOpts = function(a, e2) {
        return $a2(this._targetInfoList, function(d2) {
          var y2 = d2.getPanelRect();
          return { panelId: d2.panelId, defaultBrushType: e2 ? e2(d2) : null, clipPath: ife(y2), isTargetByCursor: ofe(y2, a, d2.coordSysModel), getLinearBrushOtherExtent: afe(y2) };
        });
      }, l2.prototype.controlSeries = function(a, e2, d2) {
        var y2 = this.findTargetInfo(a, d2);
        return y2 === true || y2 && oc2(y2.coordSyses, e2.coordinateSystem) >= 0;
      }, l2.prototype.findTargetInfo = function(a, e2) {
        for (var d2 = this._targetInfoList, y2 = rpe(e2, a), x2 = 0; x2 < d2.length; x2++) {
          var C = d2[x2], D2 = a.panelId;
          if (D2) {
            if (C.panelId === D2)
              return C;
          } else
            for (var L = 0; L < ipe.length; L++)
              if (ipe[L](y2, C))
                return C;
        }
        return true;
      }, l2;
    }();
    function sRt(l2) {
      return l2[0] > l2[1] && l2.reverse(), l2;
    }
    function rpe(l2, a) {
      return VV(l2, a, { includeMainTypes: gfn });
    }
    var yfn = { grid: function(l2, a) {
      var e2 = l2.xAxisModels, d2 = l2.yAxisModels, y2 = l2.gridModels, x2 = fl(), C = {}, D2 = {};
      !e2 && !d2 && !y2 || (Ke2(e2, function(L) {
        var F3 = L.axis.grid.model;
        x2.set(F3.id, F3), C[F3.id] = true;
      }), Ke2(d2, function(L) {
        var F3 = L.axis.grid.model;
        x2.set(F3.id, F3), D2[F3.id] = true;
      }), Ke2(y2, function(L) {
        x2.set(L.id, L), C[L.id] = true, D2[L.id] = true;
      }), x2.each(function(L) {
        var F3 = L.coordinateSystem, j = [];
        Ke2(F3.getCartesians(), function(U3, Y3) {
          (oc2(e2, U3.getAxis("x").model) >= 0 || oc2(d2, U3.getAxis("y").model) >= 0) && j.push(U3);
        }), a.push({ panelId: "grid--" + L.id, gridModel: L, coordSysModel: L, coordSys: j[0], coordSyses: j, getPanelRect: ape.grid, xAxisDeclared: C[L.id], yAxisDeclared: D2[L.id] });
      }));
    }, geo: function(l2, a) {
      Ke2(l2.geoModels, function(e2) {
        var d2 = e2.coordinateSystem;
        a.push({ panelId: "geo--" + e2.id, geoModel: e2, coordSysModel: e2, coordSys: d2, coordSyses: [d2], getPanelRect: ape.geo });
      });
    } }, ipe = [function(l2, a) {
      var e2 = l2.xAxisModel, d2 = l2.yAxisModel, y2 = l2.gridModel;
      return !y2 && e2 && (y2 = e2.axis.grid.model), !y2 && d2 && (y2 = d2.axis.grid.model), y2 && y2 === a.gridModel;
    }, function(l2, a) {
      var e2 = l2.geoModel;
      return e2 && e2 === a.geoModel;
    }], ape = { grid: function() {
      return this.coordSys.master.getRect().clone();
    }, geo: function() {
      var l2 = this.coordSys, a = l2.getBoundingRect().clone();
      return a.applyTransform(Eu(l2)), a;
    } }, lRt = { lineX: xu(ope, 0), lineY: xu(ope, 1), rect: function(l2, a, e2, d2) {
      var y2 = l2 ? a.pointToData([e2[0][0], e2[1][0]], d2) : a.dataToPoint([e2[0][0], e2[1][0]], d2), x2 = l2 ? a.pointToData([e2[0][1], e2[1][1]], d2) : a.dataToPoint([e2[0][1], e2[1][1]], d2), C = [sRt([y2[0], x2[0]]), sRt([y2[1], x2[1]])];
      return { values: C, xyMinMax: C };
    }, polygon: function(l2, a, e2, d2) {
      var y2 = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], x2 = $a2(e2, function(C) {
        var D2 = l2 ? a.pointToData(C, d2) : a.dataToPoint(C, d2);
        return y2[0][0] = Math.min(y2[0][0], D2[0]), y2[1][0] = Math.min(y2[1][0], D2[1]), y2[0][1] = Math.max(y2[0][1], D2[0]), y2[1][1] = Math.max(y2[1][1], D2[1]), D2;
      });
      return { values: x2, xyMinMax: y2 };
    } };
    function ope(l2, a, e2, d2) {
      var y2 = e2.getAxis(["x", "y"][l2]), x2 = sRt($a2([0, 1], function(D2) {
        return a ? y2.coordToData(y2.toLocalCoord(d2[D2]), true) : y2.toGlobalCoord(y2.dataToCoord(d2[D2]));
      })), C = [];
      return C[l2] = x2, C[1 - l2] = [NaN, NaN], { values: x2, xyMinMax: C };
    }
    var spe = { lineX: xu(lpe, 0), lineY: xu(lpe, 1), rect: function(l2, a, e2) {
      return [[l2[0][0] - e2[0] * a[0][0], l2[0][1] - e2[0] * a[0][1]], [l2[1][0] - e2[1] * a[1][0], l2[1][1] - e2[1] * a[1][1]]];
    }, polygon: function(l2, a, e2) {
      return $a2(l2, function(d2, y2) {
        return [d2[0] - e2[0] * a[y2][0], d2[1] - e2[1] * a[y2][1]];
      });
    } };
    function lpe(l2, a, e2, d2) {
      return [a[0] - d2[l2] * e2[0], a[1] - d2[l2] * e2[1]];
    }
    function mfn(l2, a) {
      var e2 = upe(l2), d2 = upe(a), y2 = [e2[0] / d2[0], e2[1] / d2[1]];
      return isNaN(y2[0]) && (y2[0] = 1), isNaN(y2[1]) && (y2[1] = 1), y2;
    }
    function upe(l2) {
      return l2 ? [l2[0][1] - l2[0][0], l2[1][1] - l2[1][0]] : [NaN, NaN];
    }
    var uRt = vfn, cRt = Ke2, bfn = q5t("toolbox-dataZoom_"), _fn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.render = function(e2, d2, y2, x2) {
        this._brushController || (this._brushController = new b4t(y2.getZr()), this._brushController.on("brush", As(this._onBrush, this)).mount()), Sfn(e2, d2, this, x2, y2), wfn(e2, d2);
      }, a.prototype.onclick = function(e2, d2, y2) {
        xfn[y2].call(this);
      }, a.prototype.remove = function(e2, d2) {
        this._brushController && this._brushController.unmount();
      }, a.prototype.dispose = function(e2, d2) {
        this._brushController && this._brushController.dispose();
      }, a.prototype._onBrush = function(e2) {
        var d2 = e2.areas;
        if (!e2.isEnd || !d2.length)
          return;
        var y2 = {}, x2 = this.ecModel;
        this._brushController.updateCovers([]);
        var C = new uRt(fRt(this.model), x2, { include: ["grid"] });
        C.matchOutputRanges(d2, x2, function(F3, j, U3) {
          if (U3.type === "cartesian2d") {
            var Y3 = F3.brushType;
            Y3 === "rect" ? (D2("x", U3, j[0]), D2("y", U3, j[1])) : D2({ lineX: "x", lineY: "y" }[Y3], U3, j);
          }
        }), ufn(x2, y2), this._dispatchZoomAction(y2);
        function D2(F3, j, U3) {
          var Y3 = j.getAxis(F3), Q = Y3.model, nt = L(F3, Q, x2), dt = nt.findRepresentativeAxisProxy(Q).getMinMaxSpan();
          (dt.minValueSpan != null || dt.maxValueSpan != null) && (U3 = CB(0, U3.slice(), Y3.scale.getExtent(), 0, dt.minValueSpan, dt.maxValueSpan)), nt && (y2[nt.id] = { dataZoomId: nt.id, startValue: U3[0], endValue: U3[1] });
        }
        function L(F3, j, U3) {
          var Y3;
          return U3.eachComponent({ mainType: "dataZoom", subType: "select" }, function(Q) {
            var nt = Q.getAxisModel(F3, j.componentIndex);
            nt && (Y3 = Q);
          }), Y3;
        }
      }, a.prototype._dispatchZoomAction = function(e2) {
        var d2 = [];
        cRt(e2, function(y2, x2) {
          d2.push(zl(y2));
        }), d2.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: d2 });
      }, a.getDefaultOption = function(e2) {
        var d2 = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: e2.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
        return d2;
      }, a;
    }(OA), xfn = { zoom: function() {
      var l2 = !this._isZoomActive;
      this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: l2 });
    }, back: function() {
      this._dispatchZoomAction(cfn(this.ecModel));
    } };
    function fRt(l2) {
      var a = { xAxisIndex: l2.get("xAxisIndex", true), yAxisIndex: l2.get("yAxisIndex", true), xAxisId: l2.get("xAxisId", true), yAxisId: l2.get("yAxisId", true) };
      return a.xAxisIndex == null && a.xAxisId == null && (a.xAxisIndex = "all"), a.yAxisIndex == null && a.yAxisId == null && (a.yAxisIndex = "all"), a;
    }
    function wfn(l2, a) {
      l2.setIconStatus("back", hfn(a) > 1 ? "emphasis" : "normal");
    }
    function Sfn(l2, a, e2, d2, y2) {
      var x2 = e2._isZoomActive;
      d2 && d2.type === "takeGlobalCursor" && (x2 = d2.key === "dataZoomSelect" ? d2.dataZoomSelectActive : false), e2._isZoomActive = x2, l2.setIconStatus("zoom", x2 ? "emphasis" : "normal");
      var C = new uRt(fRt(l2), a, { include: ["grid"] }), D2 = C.makePanelOpts(y2, function(L) {
        return L.xAxisDeclared && !L.yAxisDeclared ? "lineX" : !L.xAxisDeclared && L.yAxisDeclared ? "lineY" : "rect";
      });
      e2._brushController.setPanels(D2).enableBrush(x2 && D2.length ? { brushType: "auto", brushStyle: l2.getModel("brushStyle").getItemStyle() } : false);
    }
    x$e("dataZoom", function(l2) {
      var a = l2.getComponent("toolbox", 0), e2 = ["feature", "dataZoom"];
      if (!a || a.get(e2) == null)
        return;
      var d2 = a.getModel(e2), y2 = [], x2 = fRt(d2), C = VV(l2, x2);
      cRt(C.xAxisModels, function(L) {
        return D2(L, "xAxis", "xAxisIndex");
      }), cRt(C.yAxisModels, function(L) {
        return D2(L, "yAxis", "yAxisIndex");
      });
      function D2(L, F3, j) {
        var U3 = L.componentIndex, Y3 = { type: "select", $fromToolbox: true, filterMode: d2.get("filterMode", true) || "filter", id: bfn + F3 + U3 };
        Y3[j] = U3, y2.push(Y3);
      }
      return y2;
    });
    var Mfn = _fn;
    function Cfn(l2) {
      l2.registerComponentModel(Wcn), l2.registerComponentView(qcn), bZ("saveAsImage", $cn), bZ("magicType", Xcn), bZ("dataView", lfn), bZ("dataZoom", Mfn), bZ("restore", dfn), Oc2(zcn);
    }
    var Tfn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "tooltip", a.dependencies = ["axisPointer"], a.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, a;
    }(Ah2), Afn = Tfn;
    function cpe(l2) {
      var a = l2.get("confine");
      return a != null ? !!a : l2.get("renderMode") === "richText";
    }
    function fpe(l2) {
      if ($s.domSupported) {
        for (var a = document.documentElement.style, e2 = 0, d2 = l2.length; e2 < d2; e2++)
          if (l2[e2] in a)
            return l2[e2];
      }
    }
    var hpe = fpe(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), Ifn = fpe(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
    function ppe(l2, a) {
      if (!l2)
        return a;
      a = cie(a, true);
      var e2 = l2.indexOf(a);
      return l2 = e2 === -1 ? a : "-" + l2.slice(0, e2) + "-" + a, l2.toLowerCase();
    }
    function Dfn(l2, a) {
      var e2 = l2.currentStyle || document.defaultView && document.defaultView.getComputedStyle(l2);
      return e2 ? a ? e2[a] : e2 : null;
    }
    var Efn = ppe(Ifn, "transition"), hRt = ppe(hpe, "transform"), kfn = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + ($s.transform3dSupported ? "will-change:transform;" : "");
    function Pfn(l2) {
      return l2 = l2 === "left" ? "right" : l2 === "right" ? "left" : l2 === "top" ? "bottom" : "top", l2;
    }
    function Lfn(l2, a, e2) {
      if (!ps(e2) || e2 === "inside")
        return "";
      var d2 = l2.get("backgroundColor"), y2 = l2.get("borderWidth");
      a = nB(a);
      var x2 = Pfn(e2), C = Math.max(Math.round(y2) * 1.5, 6), D2 = "", L = hRt + ":", F3;
      oc2(["left", "right"], x2) > -1 ? (D2 += "top:50%", L += "translateY(-50%) rotate(" + (F3 = x2 === "left" ? -225 : -45) + "deg)") : (D2 += "left:50%", L += "translateX(-50%) rotate(" + (F3 = x2 === "top" ? 225 : 45) + "deg)");
      var j = F3 * Math.PI / 180, U3 = C + y2, Y3 = U3 * Math.abs(Math.cos(j)) + U3 * Math.abs(Math.sin(j)), Q = Math.round(((Y3 - Math.SQRT2 * y2) / 2 + Math.SQRT2 * y2 - (Y3 - U3) / 2) * 100) / 100;
      D2 += ";" + x2 + ":-" + Q + "px";
      var nt = a + " solid " + y2 + "px;", dt = ["position:absolute;width:" + C + "px;height:" + C + "px;", D2 + ";" + L + ";", "border-bottom:" + nt, "border-right:" + nt, "background-color:" + d2 + ";"];
      return '<div style="' + dt.join("") + '"></div>';
    }
    function Ofn(l2, a) {
      var e2 = "cubic-bezier(0.23,1,0.32,1)", d2 = " " + l2 / 2 + "s " + e2, y2 = "opacity" + d2 + ",visibility" + d2;
      return a || (d2 = " " + l2 + "s " + e2, y2 += $s.transformSupported ? "," + hRt + d2 : ",left" + d2 + ",top" + d2), Efn + ":" + y2;
    }
    function dpe(l2, a, e2) {
      var d2 = l2.toFixed(0) + "px", y2 = a.toFixed(0) + "px";
      if (!$s.transformSupported)
        return e2 ? "top:" + y2 + ";left:" + d2 + ";" : [["top", y2], ["left", d2]];
      var x2 = $s.transform3dSupported, C = "translate" + (x2 ? "3d" : "") + "(" + d2 + "," + y2 + (x2 ? ",0" : "") + ")";
      return e2 ? "top:0;left:0;" + hRt + ":" + C + ";" : [["top", 0], ["left", 0], [hpe, C]];
    }
    function Rfn(l2) {
      var a = [], e2 = l2.get("fontSize"), d2 = l2.getTextColor();
      d2 && a.push("color:" + d2), a.push("font:" + l2.getFont()), e2 && a.push("line-height:" + Math.round(e2 * 3 / 2) + "px");
      var y2 = l2.get("textShadowColor"), x2 = l2.get("textShadowBlur") || 0, C = l2.get("textShadowOffsetX") || 0, D2 = l2.get("textShadowOffsetY") || 0;
      return y2 && x2 && a.push("text-shadow:" + C + "px " + D2 + "px " + x2 + "px " + y2), Ke2(["decoration", "align"], function(L) {
        var F3 = l2.get(L);
        F3 && a.push("text-" + L + ":" + F3);
      }), a.join(";");
    }
    function Nfn(l2, a, e2) {
      var d2 = [], y2 = l2.get("transitionDuration"), x2 = l2.get("backgroundColor"), C = l2.get("shadowBlur"), D2 = l2.get("shadowColor"), L = l2.get("shadowOffsetX"), F3 = l2.get("shadowOffsetY"), j = l2.getModel("textStyle"), U3 = yae(l2, "html"), Y3 = L + "px " + F3 + "px " + C + "px " + D2;
      return d2.push("box-shadow:" + Y3), a && y2 && d2.push(Ofn(y2, e2)), x2 && d2.push("background-color:" + x2), Ke2(["width", "color", "radius"], function(Q) {
        var nt = "border-" + Q, dt = cie(nt), vt = l2.get(dt);
        vt != null && d2.push(nt + ":" + vt + (Q === "color" ? "" : "px"));
      }), d2.push(Rfn(j)), U3 != null && d2.push("padding:" + Gq(U3).join("px ") + "px"), d2.join(";") + ";";
    }
    function gpe(l2, a, e2, d2, y2) {
      var x2 = a && a.painter;
      if (e2) {
        var C = x2 && x2.getViewportRoot();
        C && Jgt(l2, C, document.body, d2, y2);
      } else {
        l2[0] = d2, l2[1] = y2;
        var D2 = x2 && x2.getViewportRootOffset();
        D2 && (l2[0] += D2.offsetLeft, l2[1] += D2.offsetTop);
      }
      l2[2] = l2[0] / a.getWidth(), l2[3] = l2[1] / a.getHeight();
    }
    var Ffn = function() {
      function l2(a, e2, d2) {
        if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, $s.wxa)
          return null;
        var y2 = document.createElement("div");
        y2.domBelongToZr = true, this.el = y2;
        var x2 = this._zr = e2.getZr(), C = this._appendToBody = d2 && d2.appendToBody;
        gpe(this._styleCoord, x2, C, e2.getWidth() / 2, e2.getHeight() / 2), C ? document.body.appendChild(y2) : a.appendChild(y2), this._container = a;
        var D2 = this;
        y2.onmouseenter = function() {
          D2._enterable && (clearTimeout(D2._hideTimeout), D2._show = true), D2._inContent = true;
        }, y2.onmousemove = function(L) {
          if (L = L || window.event, !D2._enterable) {
            var F3 = x2.handler, j = x2.painter.getViewportRoot();
            IS(j, L, true), F3.dispatch("mousemove", L);
          }
        }, y2.onmouseleave = function() {
          D2._inContent = false, D2._enterable && D2._show && D2.hideLater(D2._hideDelay);
        };
      }
      return l2.prototype.update = function(a) {
        var e2 = this._container, d2 = Dfn(e2, "position"), y2 = e2.style;
        y2.position !== "absolute" && d2 !== "absolute" && (y2.position = "relative");
        var x2 = a.get("alwaysShowContent");
        x2 && this._moveIfResized(), this.el.className = a.get("className") || "";
      }, l2.prototype.show = function(a, e2) {
        clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
        var d2 = this.el, y2 = d2.style, x2 = this._styleCoord;
        d2.innerHTML ? y2.cssText = kfn + Nfn(a, !this._firstShow, this._longHide) + dpe(x2[0], x2[1], true) + ("border-color:" + nB(e2) + ";") + (a.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : y2.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
      }, l2.prototype.setContent = function(a, e2, d2, y2, x2) {
        var C = this.el;
        if (a == null) {
          C.innerHTML = "";
          return;
        }
        var D2 = "";
        if (ps(x2) && d2.get("trigger") === "item" && !cpe(d2) && (D2 = Lfn(d2, y2, x2)), ps(a))
          C.innerHTML = a + D2;
        else if (a) {
          C.innerHTML = "", Ba2(a) || (a = [a]);
          for (var L = 0; L < a.length; L++)
            hV(a[L]) && a[L].parentNode !== C && C.appendChild(a[L]);
          if (D2 && C.childNodes.length) {
            var F3 = document.createElement("div");
            F3.innerHTML = D2, C.appendChild(F3);
          }
        }
      }, l2.prototype.setEnterable = function(a) {
        this._enterable = a;
      }, l2.prototype.getSize = function() {
        var a = this.el;
        return [a.offsetWidth, a.offsetHeight];
      }, l2.prototype.moveTo = function(a, e2) {
        var d2 = this._styleCoord;
        if (gpe(d2, this._zr, this._appendToBody, a, e2), d2[0] != null && d2[1] != null) {
          var y2 = this.el.style, x2 = dpe(d2[0], d2[1]);
          Ke2(x2, function(C) {
            y2[C[0]] = C[1];
          });
        }
      }, l2.prototype._moveIfResized = function() {
        var a = this._styleCoord[2], e2 = this._styleCoord[3];
        this.moveTo(a * this._zr.getWidth(), e2 * this._zr.getHeight());
      }, l2.prototype.hide = function() {
        var a = this, e2 = this.el.style;
        e2.visibility = "hidden", e2.opacity = "0", $s.transform3dSupported && (e2.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
          return a._longHide = true;
        }, 500);
      }, l2.prototype.hideLater = function(a) {
        this._show && !(this._inContent && this._enterable) && (a ? (this._hideDelay = a, this._show = false, this._hideTimeout = setTimeout(As(this.hide, this), a)) : this.hide());
      }, l2.prototype.isShow = function() {
        return this._show;
      }, l2.prototype.dispose = function() {
        this.el.parentNode.removeChild(this.el);
      }, l2;
    }(), Vfn = Ffn, Bfn = function() {
      function l2(a) {
        this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = a.getZr(), ype(this._styleCoord, this._zr, a.getWidth() / 2, a.getHeight() / 2);
      }
      return l2.prototype.update = function(a) {
        var e2 = a.get("alwaysShowContent");
        e2 && this._moveIfResized();
      }, l2.prototype.show = function() {
        this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
      }, l2.prototype.setContent = function(a, e2, d2, y2, x2) {
        var C = this;
        vs(a) && ih2(""), this.el && this._zr.remove(this.el);
        var D2 = d2.getModel("textStyle");
        this.el = new qc2({ style: { rich: e2.richTextStyles, text: a, lineHeight: 22, borderWidth: 1, borderColor: y2, textShadowColor: D2.get("textShadowColor"), fill: d2.get(["textStyle", "color"]), padding: yae(d2, "richText"), verticalAlign: "top", align: "left" }, z: d2.get("z") }), Ke2(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(F3) {
          C.el.style[F3] = d2.get(F3);
        }), Ke2(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(F3) {
          C.el.style[F3] = D2.get(F3) || 0;
        }), this._zr.add(this.el);
        var L = this;
        this.el.on("mouseover", function() {
          L._enterable && (clearTimeout(L._hideTimeout), L._show = true), L._inContent = true;
        }), this.el.on("mouseout", function() {
          L._enterable && L._show && L.hideLater(L._hideDelay), L._inContent = false;
        });
      }, l2.prototype.setEnterable = function(a) {
        this._enterable = a;
      }, l2.prototype.getSize = function() {
        var a = this.el, e2 = this.el.getBoundingRect(), d2 = vpe(a.style);
        return [e2.width + d2.left + d2.right, e2.height + d2.top + d2.bottom];
      }, l2.prototype.moveTo = function(a, e2) {
        var d2 = this.el;
        if (d2) {
          var y2 = this._styleCoord;
          ype(y2, this._zr, a, e2), a = y2[0], e2 = y2[1];
          var x2 = d2.style, C = fF(x2.borderWidth || 0), D2 = vpe(x2);
          d2.x = a + C + D2.left, d2.y = e2 + C + D2.top, d2.markRedraw();
        }
      }, l2.prototype._moveIfResized = function() {
        var a = this._styleCoord[2], e2 = this._styleCoord[3];
        this.moveTo(a * this._zr.getWidth(), e2 * this._zr.getHeight());
      }, l2.prototype.hide = function() {
        this.el && this.el.hide(), this._show = false;
      }, l2.prototype.hideLater = function(a) {
        this._show && !(this._inContent && this._enterable) && (a ? (this._hideDelay = a, this._show = false, this._hideTimeout = setTimeout(As(this.hide, this), a)) : this.hide());
      }, l2.prototype.isShow = function() {
        return this._show;
      }, l2.prototype.dispose = function() {
        this._zr.remove(this.el);
      }, l2;
    }();
    function fF(l2) {
      return Math.max(0, l2);
    }
    function vpe(l2) {
      var a = fF(l2.shadowBlur || 0), e2 = fF(l2.shadowOffsetX || 0), d2 = fF(l2.shadowOffsetY || 0);
      return { left: fF(a - e2), right: fF(a + e2), top: fF(a - d2), bottom: fF(a + d2) };
    }
    function ype(l2, a, e2, d2) {
      l2[0] = e2, l2[1] = d2, l2[2] = l2[0] / a.getWidth(), l2[3] = l2[1] / a.getHeight();
    }
    var zfn = Bfn, jfn = new Nf2({ shape: { x: -1, y: -1, width: 2, height: 2 } }), Wfn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2, d2) {
        if (!($s.node || !d2.getDom())) {
          var y2 = e2.getComponent("tooltip"), x2 = this._renderMode = ont(y2.get("renderMode"));
          this._tooltipContent = x2 === "richText" ? new zfn(d2) : new Vfn(d2.getDom(), d2, { appendToBody: y2.get("appendToBody", true) });
        }
      }, a.prototype.render = function(e2, d2, y2) {
        if (!($s.node || !y2.getDom())) {
          this.group.removeAll(), this._tooltipModel = e2, this._ecModel = d2, this._api = y2, this._alwaysShowContent = e2.get("alwaysShowContent");
          var x2 = this._tooltipContent;
          x2.update(e2), x2.setEnterable(e2.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && e2.get("transitionDuration") ? Xq(this, "_updatePosition", 50, "fixRate") : grt(this, "_updatePosition");
        }
      }, a.prototype._initGlobalListener = function() {
        var e2 = this._tooltipModel, d2 = e2.get("triggerOn");
        whe("itemTooltip", this._api, As(function(y2, x2, C) {
          d2 !== "none" && (d2.indexOf(y2) >= 0 ? this._tryShow(x2, C) : y2 === "leave" && this._hide(C));
        }, this));
      }, a.prototype._keepShow = function() {
        var e2 = this._tooltipModel, d2 = this._ecModel, y2 = this._api;
        if (this._lastX != null && this._lastY != null && e2.get("triggerOn") !== "none") {
          var x2 = this;
          clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
            !y2.isDisposed() && x2.manuallyShowTip(e2, d2, y2, { x: x2._lastX, y: x2._lastY, dataByCoordSys: x2._lastDataByCoordSys });
          });
        }
      }, a.prototype.manuallyShowTip = function(e2, d2, y2, x2) {
        if (!(x2.from === this.uid || $s.node || !y2.getDom())) {
          var C = mpe(x2, y2);
          this._ticket = "";
          var D2 = x2.dataByCoordSys, L = qfn(x2, d2, y2);
          if (L) {
            var F3 = L.el.getBoundingRect().clone();
            F3.applyTransform(L.el.transform), this._tryShow({ offsetX: F3.x + F3.width / 2, offsetY: F3.y + F3.height / 2, target: L.el, position: x2.position, positionDefault: "bottom" }, C);
          } else if (x2.tooltip && x2.x != null && x2.y != null) {
            var j = jfn;
            j.x = x2.x, j.y = x2.y, j.update(), ns(j).tooltipConfig = { name: null, option: x2.tooltip }, this._tryShow({ offsetX: x2.x, offsetY: x2.y, target: j }, C);
          } else if (D2)
            this._tryShow({ offsetX: x2.x, offsetY: x2.y, position: x2.position, dataByCoordSys: D2, tooltipOption: x2.tooltipOption }, C);
          else if (x2.seriesIndex != null) {
            if (this._manuallyAxisShowTip(e2, d2, y2, x2))
              return;
            var U3 = Mhe(x2, d2), Y3 = U3.point[0], Q = U3.point[1];
            Y3 != null && Q != null && this._tryShow({ offsetX: Y3, offsetY: Q, target: U3.el, position: x2.position, positionDefault: "bottom" }, C);
          } else
            x2.x != null && x2.y != null && (y2.dispatchAction({ type: "updateAxisPointer", x: x2.x, y: x2.y }), this._tryShow({ offsetX: x2.x, offsetY: x2.y, position: x2.position, target: y2.getZr().findHover(x2.x, x2.y).target }, C));
        }
      }, a.prototype.manuallyHideTip = function(e2, d2, y2, x2) {
        var C = this._tooltipContent;
        !this._alwaysShowContent && this._tooltipModel && C.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, x2.from !== this.uid && this._hide(mpe(x2, y2));
      }, a.prototype._manuallyAxisShowTip = function(e2, d2, y2, x2) {
        var C = x2.seriesIndex, D2 = x2.dataIndex, L = d2.getComponent("axisPointer").coordSysAxesInfo;
        if (!(C == null || D2 == null || L == null)) {
          var F3 = d2.getSeriesByIndex(C);
          if (F3) {
            var j = F3.getData(), U3 = fit([j.getItemModel(D2), F3, (F3.coordinateSystem || {}).model], this._tooltipModel);
            if (U3.get("trigger") === "axis")
              return y2.dispatchAction({ type: "updateAxisPointer", seriesIndex: C, dataIndex: D2, position: x2.position }), true;
          }
        }
      }, a.prototype._tryShow = function(e2, d2) {
        var y2 = e2.target, x2 = this._tooltipModel;
        if (x2) {
          this._lastX = e2.offsetX, this._lastY = e2.offsetY;
          var C = e2.dataByCoordSys;
          if (C && C.length)
            this._showAxisTooltip(C, e2);
          else if (y2) {
            this._lastDataByCoordSys = null;
            var D2, L;
            Jq(y2, function(F3) {
              if (ns(F3).dataIndex != null)
                return D2 = F3, true;
              if (ns(F3).tooltipConfig != null)
                return L = F3, true;
            }, true), D2 ? this._showSeriesItemTooltip(e2, D2, d2) : L ? this._showComponentItemTooltip(e2, L, d2) : this._hide(d2);
          } else
            this._lastDataByCoordSys = null, this._hide(d2);
        }
      }, a.prototype._showOrMove = function(e2, d2) {
        var y2 = e2.get("showDelay");
        d2 = As(d2, this), clearTimeout(this._showTimout), y2 > 0 ? this._showTimout = setTimeout(d2, y2) : d2();
      }, a.prototype._showAxisTooltip = function(e2, d2) {
        var y2 = this._ecModel, x2 = this._tooltipModel, C = [d2.offsetX, d2.offsetY], D2 = fit([d2.tooltipOption], x2), L = this._renderMode, F3 = [], j = b1("section", { blocks: [], noHeader: true }), U3 = [], Y3 = new tLt();
        Ke2(e2, function(Pt) {
          Ke2(Pt.dataByAxis, function(jt) {
            var Rt = y2.getComponent(jt.axisDim + "Axis", jt.axisIndex), le2 = jt.value;
            if (!(!Rt || le2 == null)) {
              var ne2 = vhe(le2, Rt.axis, y2, jt.seriesDataIndices, jt.valueLabelOpt), he2 = b1("section", { header: ne2, noHeader: !TS(ne2), sortBlocks: true, blocks: [] });
              j.blocks.push(he2), Ke2(jt.seriesDataIndices, function(_e) {
                var Me2 = y2.getSeriesByIndex(_e.seriesIndex), Pe2 = _e.dataIndexInside, Be2 = Me2.getDataParams(Pe2);
                if (!(Be2.dataIndex < 0)) {
                  Be2.axisDim = jt.axisDim, Be2.axisIndex = jt.axisIndex, Be2.axisType = jt.axisType, Be2.axisId = jt.axisId, Be2.axisValue = FLt(Rt.axis, { value: le2 }), Be2.axisValueLabel = ne2, Be2.marker = Y3.makeTooltipMarker("item", nB(Be2.color), L);
                  var Je2 = Xie(Me2.formatTooltip(Pe2, true, null)), Ze2 = Je2.frag;
                  if (Ze2) {
                    var Cn = fit([Me2], x2).get("valueFormatter");
                    he2.blocks.push(Cn ? la2({ valueFormatter: Cn }, Ze2) : Ze2);
                  }
                  Je2.text && U3.push(Je2.text), F3.push(Be2);
                }
              });
            }
          });
        }), j.blocks.reverse(), U3.reverse();
        var Q = d2.position, nt = D2.get("order"), dt = dae(j, Y3, L, nt, y2.get("useUTC"), D2.get("textStyle"));
        dt && U3.unshift(dt);
        var vt = L === "richText" ? `

` : "<br/>", Ct = U3.join(vt);
        this._showOrMove(D2, function() {
          this._updateContentNotChangedOnAxis(e2, F3) ? this._updatePosition(D2, Q, C[0], C[1], this._tooltipContent, F3) : this._showTooltipContent(D2, Ct, F3, Math.random() + "", C[0], C[1], Q, null, Y3);
        });
      }, a.prototype._showSeriesItemTooltip = function(e2, d2, y2) {
        var x2 = this._ecModel, C = ns(d2), D2 = C.seriesIndex, L = x2.getSeriesByIndex(D2), F3 = C.dataModel || L, j = C.dataIndex, U3 = C.dataType, Y3 = F3.getData(U3), Q = this._renderMode, nt = e2.positionDefault, dt = fit([Y3.getItemModel(j), F3, L && (L.coordinateSystem || {}).model], this._tooltipModel, nt ? { position: nt } : null), vt = dt.get("trigger");
        if (!(vt != null && vt !== "item")) {
          var Ct = F3.getDataParams(j, U3), Pt = new tLt();
          Ct.marker = Pt.makeTooltipMarker("item", nB(Ct.color), Q);
          var jt = Xie(F3.formatTooltip(j, false, U3)), Rt = dt.get("order"), le2 = dt.get("valueFormatter"), ne2 = jt.frag, he2 = ne2 ? dae(le2 ? la2({ valueFormatter: le2 }, ne2) : ne2, Pt, Q, Rt, x2.get("useUTC"), dt.get("textStyle")) : jt.text, _e = "item_" + F3.name + "_" + j;
          this._showOrMove(dt, function() {
            this._showTooltipContent(dt, he2, Ct, _e, e2.offsetX, e2.offsetY, e2.position, e2.target, Pt);
          }), y2({ type: "showTip", dataIndexInside: j, dataIndex: Y3.getRawIndex(j), seriesIndex: D2, from: this.uid });
        }
      }, a.prototype._showComponentItemTooltip = function(e2, d2, y2) {
        var x2 = ns(d2), C = x2.tooltipConfig, D2 = C.option || {};
        if (ps(D2)) {
          var L = D2;
          D2 = { content: L, formatter: L };
        }
        var F3 = [D2], j = this._ecModel.getComponent(x2.componentMainType, x2.componentIndex);
        j && F3.push(j), F3.push({ formatter: D2.content });
        var U3 = e2.positionDefault, Y3 = fit(F3, this._tooltipModel, U3 ? { position: U3 } : null), Q = Y3.get("content"), nt = Math.random() + "", dt = new tLt();
        this._showOrMove(Y3, function() {
          var vt = zl(Y3.get("formatterParams") || {});
          this._showTooltipContent(Y3, Q, vt, nt, e2.offsetX, e2.offsetY, e2.position, d2, dt);
        }), y2({ type: "showTip", from: this.uid });
      }, a.prototype._showTooltipContent = function(e2, d2, y2, x2, C, D2, L, F3, j) {
        if (this._ticket = "", !(!e2.get("showContent") || !e2.get("show"))) {
          var U3 = this._tooltipContent;
          U3.setEnterable(e2.get("enterable"));
          var Y3 = e2.get("formatter");
          L = L || e2.get("position");
          var Q = d2, nt = this._getNearestPoint([C, D2], y2, e2.get("trigger"), e2.get("borderColor")), dt = nt.color;
          if (Y3)
            if (ps(Y3)) {
              var vt = e2.ecModel.get("useUTC"), Ct = Ba2(y2) ? y2[0] : y2, Pt = Ct && Ct.axisType && Ct.axisType.indexOf("time") >= 0;
              Q = Y3, Pt && (Q = ryt(Ct.axisValue, Q, vt)), Q = hie(Q, y2, true);
            } else if (wl(Y3)) {
              var jt = As(function(Rt, le2) {
                Rt === this._ticket && (U3.setContent(le2, j, e2, dt, L), this._updatePosition(e2, L, C, D2, U3, y2, F3));
              }, this);
              this._ticket = x2, Q = Y3(y2, x2, jt);
            } else
              Q = Y3;
          U3.setContent(Q, j, e2, dt, L), U3.show(e2, dt), this._updatePosition(e2, L, C, D2, U3, y2, F3);
        }
      }, a.prototype._getNearestPoint = function(e2, d2, y2, x2) {
        if (y2 === "axis" || Ba2(d2))
          return { color: x2 || (this._renderMode === "html" ? "#fff" : "none") };
        if (!Ba2(d2))
          return { color: x2 || d2.color || d2.borderColor };
      }, a.prototype._updatePosition = function(e2, d2, y2, x2, C, D2, L) {
        var F3 = this._api.getWidth(), j = this._api.getHeight();
        d2 = d2 || e2.get("position");
        var U3 = C.getSize(), Y3 = e2.get("align"), Q = e2.get("verticalAlign"), nt = L && L.getBoundingRect().clone();
        if (L && nt.applyTransform(L.transform), wl(d2) && (d2 = d2([y2, x2], D2, C.el, nt, { viewSize: [F3, j], contentSize: U3.slice() })), Ba2(d2))
          y2 = Ko(d2[0], F3), x2 = Ko(d2[1], j);
        else if (vs(d2)) {
          var dt = d2;
          dt.width = U3[0], dt.height = U3[1];
          var vt = Em(dt, { width: F3, height: j });
          y2 = vt.x, x2 = vt.y, Y3 = null, Q = null;
        } else if (ps(d2) && L) {
          var Ct = Ufn(d2, nt, U3, e2.get("borderWidth"));
          y2 = Ct[0], x2 = Ct[1];
        } else {
          var Ct = Gfn(y2, x2, C, F3, j, Y3 ? null : 20, Q ? null : 20);
          y2 = Ct[0], x2 = Ct[1];
        }
        if (Y3 && (y2 -= bpe(Y3) ? U3[0] / 2 : Y3 === "right" ? U3[0] : 0), Q && (x2 -= bpe(Q) ? U3[1] / 2 : Q === "bottom" ? U3[1] : 0), cpe(e2)) {
          var Ct = Hfn(y2, x2, C, F3, j);
          y2 = Ct[0], x2 = Ct[1];
        }
        C.moveTo(y2, x2);
      }, a.prototype._updateContentNotChangedOnAxis = function(e2, d2) {
        var y2 = this._lastDataByCoordSys, x2 = this._cbParamsList, C = !!y2 && y2.length === e2.length;
        return C && Ke2(y2, function(D2, L) {
          var F3 = D2.dataByAxis || [], j = e2[L] || {}, U3 = j.dataByAxis || [];
          C = C && F3.length === U3.length, C && Ke2(F3, function(Y3, Q) {
            var nt = U3[Q] || {}, dt = Y3.seriesDataIndices || [], vt = nt.seriesDataIndices || [];
            C = C && Y3.value === nt.value && Y3.axisType === nt.axisType && Y3.axisId === nt.axisId && dt.length === vt.length, C && Ke2(dt, function(Ct, Pt) {
              var jt = vt[Pt];
              C = C && Ct.seriesIndex === jt.seriesIndex && Ct.dataIndex === jt.dataIndex;
            }), x2 && Ke2(Y3.seriesDataIndices, function(Ct) {
              var Pt = Ct.seriesIndex, jt = d2[Pt], Rt = x2[Pt];
              jt && Rt && Rt.data !== jt.data && (C = false);
            });
          });
        }), this._lastDataByCoordSys = e2, this._cbParamsList = d2, !!C;
      }, a.prototype._hide = function(e2) {
        this._lastDataByCoordSys = null, e2({ type: "hideTip", from: this.uid });
      }, a.prototype.dispose = function(e2, d2) {
        $s.node || !d2.getDom() || (grt(this, "_updatePosition"), this._tooltipContent.dispose(), Z4t("itemTooltip", d2));
      }, a.type = "tooltip", a;
    }(_0);
    function fit(l2, a, e2) {
      var d2 = a.ecModel, y2;
      e2 ? (y2 = new hg2(e2, d2, d2), y2 = new hg2(a.option, y2, d2)) : y2 = a;
      for (var x2 = l2.length - 1; x2 >= 0; x2--) {
        var C = l2[x2];
        C && (C instanceof hg2 && (C = C.get("tooltip", true)), ps(C) && (C = { formatter: C }), C && (y2 = new hg2(C, y2, d2)));
      }
      return y2;
    }
    function mpe(l2, a) {
      return l2.dispatchAction || As(a.dispatchAction, a);
    }
    function Gfn(l2, a, e2, d2, y2, x2, C) {
      var D2 = e2.getSize(), L = D2[0], F3 = D2[1];
      return x2 != null && (l2 + L + x2 + 2 > d2 ? l2 -= L + x2 : l2 += x2), C != null && (a + F3 + C > y2 ? a -= F3 + C : a += C), [l2, a];
    }
    function Hfn(l2, a, e2, d2, y2) {
      var x2 = e2.getSize(), C = x2[0], D2 = x2[1];
      return l2 = Math.min(l2 + C, d2) - C, a = Math.min(a + D2, y2) - D2, l2 = Math.max(l2, 0), a = Math.max(a, 0), [l2, a];
    }
    function Ufn(l2, a, e2, d2) {
      var y2 = e2[0], x2 = e2[1], C = Math.ceil(Math.SQRT2 * d2) + 8, D2 = 0, L = 0, F3 = a.width, j = a.height;
      switch (l2) {
        case "inside":
          D2 = a.x + F3 / 2 - y2 / 2, L = a.y + j / 2 - x2 / 2;
          break;
        case "top":
          D2 = a.x + F3 / 2 - y2 / 2, L = a.y - x2 - C;
          break;
        case "bottom":
          D2 = a.x + F3 / 2 - y2 / 2, L = a.y + j + C;
          break;
        case "left":
          D2 = a.x - y2 - C, L = a.y + j / 2 - x2 / 2;
          break;
        case "right":
          D2 = a.x + F3 + C, L = a.y + j / 2 - x2 / 2;
      }
      return [D2, L];
    }
    function bpe(l2) {
      return l2 === "center" || l2 === "middle";
    }
    function qfn(l2, a, e2) {
      var d2 = int(l2).queryOptionMap, y2 = d2.keys()[0];
      if (!(!y2 || y2 === "series")) {
        var x2 = NN(a, y2, d2.get(y2), { useDefault: false, enableAll: false, enableNone: false }), C = x2.models[0];
        if (C) {
          var D2 = e2.getViewOfComponentModel(C), L;
          if (D2.group.traverse(function(F3) {
            var j = ns(F3).tooltipConfig;
            if (j && j.name === l2.name)
              return L = F3, true;
          }), L)
            return { componentMainType: y2, componentIndex: C.componentIndex, el: L };
        }
      }
    }
    var Zfn = Wfn;
    function $fn(l2) {
      Oc2(uit), l2.registerComponentModel(Afn), l2.registerComponentView(Zfn), l2.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, $p), l2.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, $p);
    }
    var Yfn = ["rect", "polygon", "keep", "clear"];
    function Kfn(l2, a) {
      var e2 = Mp(l2 ? l2.brush : []);
      if (e2.length) {
        var d2 = [];
        Ke2(e2, function(L) {
          var F3 = L.hasOwnProperty("toolbox") ? L.toolbox : [];
          F3 instanceof Array && (d2 = d2.concat(F3));
        });
        var y2 = l2 && l2.toolbox;
        Ba2(y2) && (y2 = y2[0]), y2 || (y2 = { feature: {} }, l2.toolbox = [y2]);
        var x2 = y2.feature || (y2.feature = {}), C = x2.brush || (x2.brush = {}), D2 = C.type || (C.type = []);
        D2.push.apply(D2, d2), Xfn(D2), a && !D2.length && D2.push.apply(D2, Yfn);
      }
    }
    function Xfn(l2) {
      var a = {};
      Ke2(l2, function(e2) {
        a[e2] = 1;
      }), l2.length = 0, Ke2(a, function(e2, d2) {
        l2.push(d2);
      });
    }
    var _pe = Ke2;
    function xpe(l2) {
      if (l2) {
        for (var a in l2)
          if (l2.hasOwnProperty(a))
            return true;
      }
    }
    function pRt(l2, a, e2) {
      var d2 = {};
      return _pe(a, function(x2) {
        var C = d2[x2] = y2();
        _pe(l2[x2], function(D2, L) {
          if (B_.isValidType(L)) {
            var F3 = { type: L, visual: D2 };
            e2 && e2(F3, x2), C[L] = new B_(F3), L === "opacity" && (F3 = zl(F3), F3.type = "colorAlpha", C.__hidden.__alphaForOpacity = new B_(F3));
          }
        });
      }), d2;
      function y2() {
        var x2 = function() {
        };
        x2.prototype.__hidden = x2.prototype;
        var C = new x2();
        return C;
      }
    }
    function wpe(l2, a, e2) {
      var d2;
      Ke2(e2, function(y2) {
        a.hasOwnProperty(y2) && xpe(a[y2]) && (d2 = true);
      }), d2 && Ke2(e2, function(y2) {
        a.hasOwnProperty(y2) && xpe(a[y2]) ? l2[y2] = zl(a[y2]) : delete l2[y2];
      });
    }
    function Qfn(l2, a, e2, d2, y2, x2) {
      var C = {};
      Ke2(l2, function(U3) {
        var Y3 = B_.prepareVisualTypes(a[U3]);
        C[U3] = Y3;
      });
      var D2;
      function L(U3) {
        return oLt(e2, D2, U3);
      }
      function F3(U3, Y3) {
        Bae(e2, D2, U3, Y3);
      }
      x2 == null ? e2.each(j) : e2.each([x2], j);
      function j(U3, Y3) {
        D2 = x2 == null ? U3 : Y3;
        var Q = e2.getRawDataItem(D2);
        if (!(Q && Q.visualMap === false))
          for (var nt = d2.call(y2, U3), dt = a[nt], vt = C[nt], Ct = 0, Pt = vt.length; Ct < Pt; Ct++) {
            var jt = vt[Ct];
            dt[jt] && dt[jt].applyVisual(U3, L, F3);
          }
      }
    }
    function Jfn(l2, a, e2, d2) {
      var y2 = {};
      return Ke2(l2, function(x2) {
        var C = B_.prepareVisualTypes(a[x2]);
        y2[x2] = C;
      }), { progress: function(x2, C) {
        var D2;
        d2 != null && (D2 = C.getDimensionIndex(d2));
        function L(Rt) {
          return oLt(C, j, Rt);
        }
        function F3(Rt, le2) {
          Bae(C, j, Rt, le2);
        }
        for (var j, U3 = C.getStore(); (j = x2.next()) != null; ) {
          var Y3 = C.getRawDataItem(j);
          if (!(Y3 && Y3.visualMap === false))
            for (var Q = d2 != null ? U3.get(D2, j) : j, nt = e2(Q), dt = a[nt], vt = y2[nt], Ct = 0, Pt = vt.length; Ct < Pt; Ct++) {
              var jt = vt[Ct];
              dt[jt] && dt[jt].applyVisual(Q, L, F3);
            }
        }
      } };
    }
    function thn(l2) {
      var a = l2.brushType, e2 = { point: function(d2) {
        return Spe[a].point(d2, e2, l2);
      }, rect: function(d2) {
        return Spe[a].rect(d2, e2, l2);
      } };
      return e2;
    }
    var Spe = { lineX: Mpe(0), lineY: Mpe(1), rect: { point: function(l2, a, e2) {
      return l2 && e2.boundingRect.contain(l2[0], l2[1]);
    }, rect: function(l2, a, e2) {
      return l2 && e2.boundingRect.intersect(l2);
    } }, polygon: { point: function(l2, a, e2) {
      return l2 && e2.boundingRect.contain(l2[0], l2[1]) && fB(e2.range, l2[0], l2[1]);
    }, rect: function(l2, a, e2) {
      var d2 = e2.range;
      if (!l2 || d2.length <= 1)
        return false;
      var y2 = l2.x, x2 = l2.y, C = l2.width, D2 = l2.height, L = d2[0];
      if (fB(d2, y2, x2) || fB(d2, y2 + C, x2) || fB(d2, y2, x2 + D2) || fB(d2, y2 + C, x2 + D2) || Yu.create(l2).contain(L[0], L[1]) || F_(y2, x2, y2 + C, x2, d2) || F_(y2, x2, y2, x2 + D2, d2) || F_(y2 + C, x2, y2 + C, x2 + D2, d2) || F_(y2, x2 + D2, y2 + C, x2 + D2, d2))
        return true;
    } } };
    function Mpe(l2) {
      var a = ["x", "y"], e2 = ["width", "height"];
      return { point: function(d2, y2, x2) {
        if (d2) {
          var C = x2.range, D2 = d2[l2];
          return hit(D2, C);
        }
      }, rect: function(d2, y2, x2) {
        if (d2) {
          var C = x2.range, D2 = [d2[a[l2]], d2[a[l2]] + d2[e2[l2]]];
          return D2[1] < D2[0] && D2.reverse(), hit(D2[0], C) || hit(D2[1], C) || hit(C[0], D2) || hit(C[1], D2);
        }
      } };
    }
    function hit(l2, a) {
      return a[0] <= l2 && l2 <= a[1];
    }
    var Cpe = ["inBrush", "outOfBrush"], dRt = "__ecBrushSelect", gRt = "__ecInBrushSelectEvent";
    function Tpe(l2) {
      l2.eachComponent({ mainType: "brush" }, function(a) {
        var e2 = a.brushTargetManager = new uRt(a.option, l2);
        e2.setInputRanges(a.areas, l2);
      });
    }
    function ehn(l2, a, e2) {
      var d2 = [], y2, x2;
      l2.eachComponent({ mainType: "brush" }, function(C) {
        e2 && e2.type === "takeGlobalCursor" && C.setBrushOption(e2.key === "brush" ? e2.brushOption : { brushType: false });
      }), Tpe(l2), l2.eachComponent({ mainType: "brush" }, function(C, D2) {
        var L = { brushId: C.id, brushIndex: D2, brushName: C.name, areas: zl(C.areas), selected: [] };
        d2.push(L);
        var F3 = C.option, j = F3.brushLink, U3 = [], Y3 = [], Q = [], nt = false;
        D2 || (y2 = F3.throttleType, x2 = F3.throttleDelay);
        var dt = $a2(C.areas, function(le2) {
          var ne2 = ahn[le2.brushType], he2 = El({ boundingRect: ne2 ? ne2(le2) : void 0 }, le2);
          return he2.selectors = thn(he2), he2;
        }), vt = pRt(C.option, Cpe, function(le2) {
          le2.mappingMethod = "fixed";
        });
        Ba2(j) && Ke2(j, function(le2) {
          U3[le2] = 1;
        });
        function Ct(le2) {
          return j === "all" || !!U3[le2];
        }
        function Pt(le2) {
          return !!le2.length;
        }
        l2.eachSeries(function(le2, ne2) {
          var he2 = Q[ne2] = [];
          le2.subType === "parallel" ? jt(le2, ne2) : Rt(le2, ne2, he2);
        });
        function jt(le2, ne2) {
          var he2 = le2.coordinateSystem;
          nt = nt || he2.hasAxisBrushed(), Ct(ne2) && he2.eachActiveState(le2.getData(), function(_e, Me2) {
            _e === "active" && (Y3[Me2] = 1);
          });
        }
        function Rt(le2, ne2, he2) {
          if (!(!le2.brushSelector || ihn(C, ne2)) && (Ke2(dt, function(Me2) {
            C.brushTargetManager.controlSeries(Me2, le2, l2) && he2.push(Me2), nt = nt || Pt(he2);
          }), Ct(ne2) && Pt(he2))) {
            var _e = le2.getData();
            _e.each(function(Me2) {
              Ape(le2, he2, _e, Me2) && (Y3[Me2] = 1);
            });
          }
        }
        l2.eachSeries(function(le2, ne2) {
          var he2 = { seriesId: le2.id, seriesIndex: ne2, seriesName: le2.name, dataIndex: [] };
          L.selected.push(he2);
          var _e = Q[ne2], Me2 = le2.getData(), Pe2 = Ct(ne2) ? function(Be2) {
            return Y3[Be2] ? (he2.dataIndex.push(Me2.getRawIndex(Be2)), "inBrush") : "outOfBrush";
          } : function(Be2) {
            return Ape(le2, _e, Me2, Be2) ? (he2.dataIndex.push(Me2.getRawIndex(Be2)), "inBrush") : "outOfBrush";
          };
          (Ct(ne2) ? nt : Pt(_e)) && Qfn(Cpe, vt, Me2, Pe2);
        });
      }), nhn(a, y2, x2, d2, e2);
    }
    function nhn(l2, a, e2, d2, y2) {
      if (y2) {
        var x2 = l2.getZr();
        if (!x2[gRt]) {
          x2[dRt] || (x2[dRt] = rhn);
          var C = Xq(x2, dRt, e2, a);
          C(l2, d2);
        }
      }
    }
    function rhn(l2, a) {
      if (!l2.isDisposed()) {
        var e2 = l2.getZr();
        e2[gRt] = true, l2.dispatchAction({ type: "brushSelect", batch: a }), e2[gRt] = false;
      }
    }
    function Ape(l2, a, e2, d2) {
      for (var y2 = 0, x2 = a.length; y2 < x2; y2++) {
        var C = a[y2];
        if (l2.brushSelector(d2, e2, C.selectors, C))
          return true;
      }
    }
    function ihn(l2, a) {
      var e2 = l2.option.seriesIndex;
      return e2 != null && e2 !== "all" && (Ba2(e2) ? oc2(e2, a) < 0 : a !== e2);
    }
    var ahn = { rect: function(l2) {
      return Ipe(l2.range);
    }, polygon: function(l2) {
      for (var a, e2 = l2.range, d2 = 0, y2 = e2.length; d2 < y2; d2++) {
        a = a || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
        var x2 = e2[d2];
        x2[0] < a[0][0] && (a[0][0] = x2[0]), x2[0] > a[0][1] && (a[0][1] = x2[0]), x2[1] < a[1][0] && (a[1][0] = x2[1]), x2[1] > a[1][1] && (a[1][1] = x2[1]);
      }
      return a && Ipe(a);
    } };
    function Ipe(l2) {
      return new Yu(l2[0][0], l2[1][0], l2[0][1] - l2[0][0], l2[1][1] - l2[1][0]);
    }
    var ohn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2, d2) {
        this.ecModel = e2, this.api = d2, this.model, (this._brushController = new b4t(d2.getZr())).on("brush", As(this._onBrush, this)).mount();
      }, a.prototype.render = function(e2, d2, y2, x2) {
        this.model = e2, this._updateController(e2, d2, y2, x2);
      }, a.prototype.updateTransform = function(e2, d2, y2, x2) {
        Tpe(d2), this._updateController(e2, d2, y2, x2);
      }, a.prototype.updateVisual = function(e2, d2, y2, x2) {
        this.updateTransform(e2, d2, y2, x2);
      }, a.prototype.updateView = function(e2, d2, y2, x2) {
        this._updateController(e2, d2, y2, x2);
      }, a.prototype._updateController = function(e2, d2, y2, x2) {
        (!x2 || x2.$from !== e2.id) && this._brushController.setPanels(e2.brushTargetManager.makePanelOpts(y2)).enableBrush(e2.brushOption).updateCovers(e2.areas.slice());
      }, a.prototype.dispose = function() {
        this._brushController.dispose();
      }, a.prototype._onBrush = function(e2) {
        var d2 = this.model.id, y2 = this.model.brushTargetManager.setOutputRanges(e2.areas, this.ecModel);
        (!e2.isEnd || e2.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: d2, areas: zl(y2), $from: d2 }), e2.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: d2, areas: zl(y2), $from: d2 });
      }, a.type = "brush", a;
    }(_0), shn = ohn, lhn = "#ddd", uhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.areas = [], e2.brushOption = {}, e2;
      }
      return a.prototype.optionUpdated = function(e2, d2) {
        var y2 = this.option;
        !d2 && wpe(y2, e2, ["inBrush", "outOfBrush"]);
        var x2 = y2.inBrush = y2.inBrush || {};
        y2.outOfBrush = y2.outOfBrush || { color: lhn }, x2.hasOwnProperty("liftZ") || (x2.liftZ = 5);
      }, a.prototype.setAreas = function(e2) {
        !e2 || (this.areas = $a2(e2, function(d2) {
          return Dpe(this.option, d2);
        }, this));
      }, a.prototype.setBrushOption = function(e2) {
        this.brushOption = Dpe(this.option, e2), this.brushType = this.brushOption.brushType;
      }, a.type = "brush", a.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], a.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, a;
    }(Ah2);
    function Dpe(l2, a) {
      return Mu({ brushType: l2.brushType, brushMode: l2.brushMode, transformable: l2.transformable, brushStyle: new hg2(l2.brushStyle).getItemStyle(), removeOnClick: l2.removeOnClick, z: l2.z }, a, true);
    }
    var chn = uhn, fhn = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], hhn = function(l2) {
      Jn(a, l2);
      function a() {
        return l2 !== null && l2.apply(this, arguments) || this;
      }
      return a.prototype.render = function(e2, d2, y2) {
        var x2, C, D2;
        d2.eachComponent({ mainType: "brush" }, function(L) {
          x2 = L.brushType, C = L.brushOption.brushMode || "single", D2 = D2 || !!L.areas.length;
        }), this._brushType = x2, this._brushMode = C, Ke2(e2.get("type", true), function(L) {
          e2.setIconStatus(L, (L === "keep" ? C === "multiple" : L === "clear" ? D2 : L === x2) ? "emphasis" : "normal");
        });
      }, a.prototype.updateView = function(e2, d2, y2) {
        this.render(e2, d2, y2);
      }, a.prototype.getIcons = function() {
        var e2 = this.model, d2 = e2.get("icon", true), y2 = {};
        return Ke2(e2.get("type", true), function(x2) {
          d2[x2] && (y2[x2] = d2[x2]);
        }), y2;
      }, a.prototype.onclick = function(e2, d2, y2) {
        var x2 = this._brushType, C = this._brushMode;
        y2 === "clear" ? (d2.dispatchAction({ type: "axisAreaSelect", intervals: [] }), d2.dispatchAction({ type: "brush", command: "clear", areas: [] })) : d2.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: y2 === "keep" ? x2 : x2 === y2 ? false : y2, brushMode: y2 === "keep" ? C === "multiple" ? "single" : "multiple" : C } });
      }, a.getDefaultOption = function(e2) {
        var d2 = { show: true, type: fhn.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: e2.getLocaleModel().get(["toolbox", "brush", "title"]) };
        return d2;
      }, a;
    }(OA), phn = hhn;
    function dhn(l2) {
      l2.registerComponentView(shn), l2.registerComponentModel(chn), l2.registerPreprocessor(Kfn), l2.registerVisual(l2.PRIORITY.VISUAL.BRUSH, ehn), l2.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(a, e2) {
        e2.eachComponent({ mainType: "brush", query: a }, function(d2) {
          d2.setAreas(a.areas);
        });
      }), l2.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, $p), l2.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, $p), bZ("brush", phn);
    }
    var ghn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.layoutMode = { type: "box", ignoreSize: true }, e2;
      }
      return a.type = "title", a.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, a;
    }(Ah2), vhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        if (this.group.removeAll(), !!e2.get("show")) {
          var x2 = this.group, C = e2.getModel("textStyle"), D2 = e2.getModel("subtextStyle"), L = e2.get("textAlign"), F3 = $u(e2.get("textBaseline"), e2.get("textVerticalAlign")), j = new qc2({ style: _y(C, { text: e2.get("text"), fill: C.getTextColor() }, { disableBox: true }), z2: 10 }), U3 = j.getBoundingRect(), Y3 = e2.get("subtext"), Q = new qc2({ style: _y(D2, { text: Y3, fill: D2.getTextColor(), y: U3.height + e2.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), nt = e2.get("link"), dt = e2.get("sublink"), vt = e2.get("triggerEvent", true);
          j.silent = !nt && !vt, Q.silent = !dt && !vt, nt && j.on("click", function() {
            lyt(nt, "_" + e2.get("target"));
          }), dt && Q.on("click", function() {
            lyt(dt, "_" + e2.get("subtarget"));
          }), ns(j).eventData = ns(Q).eventData = vt ? { componentType: "title", componentIndex: e2.componentIndex } : null, x2.add(j), Y3 && x2.add(Q);
          var Ct = x2.getBoundingRect(), Pt = e2.getBoxLayoutParams();
          Pt.width = Ct.width, Pt.height = Ct.height;
          var jt = Em(Pt, { width: y2.getWidth(), height: y2.getHeight() }, e2.get("padding"));
          L || (L = e2.get("left") || e2.get("right"), L === "middle" && (L = "center"), L === "right" ? jt.x += jt.width : L === "center" && (jt.x += jt.width / 2)), F3 || (F3 = e2.get("top") || e2.get("bottom"), F3 === "center" && (F3 = "middle"), F3 === "bottom" ? jt.y += jt.height : F3 === "middle" && (jt.y += jt.height / 2), F3 = F3 || "top"), x2.x = jt.x, x2.y = jt.y, x2.markRedraw();
          var Rt = { align: L, verticalAlign: F3 };
          j.setStyle(Rt), Q.setStyle(Rt), Ct = x2.getBoundingRect();
          var le2 = jt.margin, ne2 = e2.getItemStyle(["color", "opacity"]);
          ne2.fill = e2.get("backgroundColor");
          var he2 = new Nf2({ shape: { x: Ct.x - le2[3], y: Ct.y - le2[0], width: Ct.width + le2[1] + le2[3], height: Ct.height + le2[0] + le2[2], r: e2.get("borderRadius") }, style: ne2, subPixelOptimize: true, silent: true });
          x2.add(he2);
        }
      }, a.type = "title", a;
    }(_0);
    function yhn(l2) {
      l2.registerComponentModel(ghn), l2.registerComponentView(vhn);
    }
    var mhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.layoutMode = "box", e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        this.mergeDefaultAndTheme(e2, y2), this._initData();
      }, a.prototype.mergeOption = function(e2) {
        l2.prototype.mergeOption.apply(this, arguments), this._initData();
      }, a.prototype.setCurrentIndex = function(e2) {
        e2 == null && (e2 = this.option.currentIndex);
        var d2 = this._data.count();
        this.option.loop ? e2 = (e2 % d2 + d2) % d2 : (e2 >= d2 && (e2 = d2 - 1), e2 < 0 && (e2 = 0)), this.option.currentIndex = e2;
      }, a.prototype.getCurrentIndex = function() {
        return this.option.currentIndex;
      }, a.prototype.isIndexMax = function() {
        return this.getCurrentIndex() >= this._data.count() - 1;
      }, a.prototype.setPlayState = function(e2) {
        this.option.autoPlay = !!e2;
      }, a.prototype.getPlayState = function() {
        return !!this.option.autoPlay;
      }, a.prototype._initData = function() {
        var e2 = this.option, d2 = e2.data || [], y2 = e2.axisType, x2 = this._names = [], C;
        y2 === "category" ? (C = [], Ke2(d2, function(F3, j) {
          var U3 = Ud2(q5(F3), ""), Y3;
          vs(F3) ? (Y3 = zl(F3), Y3.value = j) : Y3 = j, C.push(Y3), x2.push(U3);
        })) : C = d2;
        var D2 = { category: "ordinal", time: "time", value: "number" }[y2] || "number", L = this._data = new jS([{ name: "value", type: D2 }], this);
        L.initData(C, x2);
      }, a.prototype.getData = function() {
        return this._data;
      }, a.prototype.getCategories = function() {
        if (this.get("axisType") === "category")
          return this._names.slice();
      }, a.type = "timeline", a.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, a;
    }(Ah2), Epe = mhn, kpe = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "timeline.slider", a.defaultOption = ZN(Epe.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), a;
    }(Epe);
    v0(kpe, $3t.prototype);
    var bhn = kpe, _hn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "timeline", a;
    }(_0), xhn = _hn, whn = function(l2) {
      Jn(a, l2);
      function a(e2, d2, y2, x2) {
        var C = l2.call(this, e2, d2, y2) || this;
        return C.type = x2 || "value", C;
      }
      return a.prototype.getLabelModel = function() {
        return this.model.getModel("label");
      }, a.prototype.isHorizontal = function() {
        return this.model.get("orient") === "horizontal";
      }, a;
    }(kE), Shn = whn, vRt = Math.PI, Ppe = Rf2(), Mhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function(e2, d2) {
        this.api = d2;
      }, a.prototype.render = function(e2, d2, y2) {
        if (this.model = e2, this.api = y2, this.ecModel = d2, this.group.removeAll(), e2.get("show", true)) {
          var x2 = this._layout(e2, y2), C = this._createGroup("_mainGroup"), D2 = this._createGroup("_labelGroup"), L = this._axis = this._createAxis(x2, e2);
          e2.formatTooltip = function(F3) {
            var j = L.scale.getLabel({ value: F3 });
            return b1("nameValue", { noName: true, value: j });
          }, Ke2(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(F3) {
            this["_render" + F3](x2, C, L, e2);
          }, this), this._renderAxisLabel(x2, D2, L, e2), this._position(x2, e2);
        }
        this._doPlayStop(), this._updateTicksStatus();
      }, a.prototype.remove = function() {
        this._clearTimer(), this.group.removeAll();
      }, a.prototype.dispose = function() {
        this._clearTimer();
      }, a.prototype._layout = function(e2, d2) {
        var y2 = e2.get(["label", "position"]), x2 = e2.get("orient"), C = Thn(e2, d2), D2;
        y2 == null || y2 === "auto" ? D2 = x2 === "horizontal" ? C.y + C.height / 2 < d2.getHeight() / 2 ? "-" : "+" : C.x + C.width / 2 < d2.getWidth() / 2 ? "+" : "-" : ps(y2) ? D2 = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[x2][y2] : D2 = y2;
        var L = { horizontal: "center", vertical: D2 >= 0 || D2 === "+" ? "left" : "right" }, F3 = { horizontal: D2 >= 0 || D2 === "+" ? "top" : "bottom", vertical: "middle" }, j = { horizontal: 0, vertical: vRt / 2 }, U3 = x2 === "vertical" ? C.height : C.width, Y3 = e2.getModel("controlStyle"), Q = Y3.get("show", true), nt = Q ? Y3.get("itemSize") : 0, dt = Q ? Y3.get("itemGap") : 0, vt = nt + dt, Ct = e2.get(["label", "rotate"]) || 0;
        Ct = Ct * vRt / 180;
        var Pt, jt, Rt, le2 = Y3.get("position", true), ne2 = Q && Y3.get("showPlayBtn", true), he2 = Q && Y3.get("showPrevBtn", true), _e = Q && Y3.get("showNextBtn", true), Me2 = 0, Pe2 = U3;
        le2 === "left" || le2 === "bottom" ? (ne2 && (Pt = [0, 0], Me2 += vt), he2 && (jt = [Me2, 0], Me2 += vt), _e && (Rt = [Pe2 - nt, 0], Pe2 -= vt)) : (ne2 && (Pt = [Pe2 - nt, 0], Pe2 -= vt), he2 && (jt = [0, 0], Me2 += vt), _e && (Rt = [Pe2 - nt, 0], Pe2 -= vt));
        var Be2 = [Me2, Pe2];
        return e2.get("inverse") && Be2.reverse(), { viewRect: C, mainLength: U3, orient: x2, rotation: j[x2], labelRotation: Ct, labelPosOpt: D2, labelAlign: e2.get(["label", "align"]) || L[x2], labelBaseline: e2.get(["label", "verticalAlign"]) || e2.get(["label", "baseline"]) || F3[x2], playPosition: Pt, prevBtnPosition: jt, nextBtnPosition: Rt, axisExtent: Be2, controlSize: nt, controlGap: dt };
      }, a.prototype._position = function(e2, d2) {
        var y2 = this._mainGroup, x2 = this._labelGroup, C = e2.viewRect;
        if (e2.orient === "vertical") {
          var D2 = Xx(), L = C.x, F3 = C.y + C.height;
          LS(D2, D2, [-L, -F3]), oO(D2, D2, -vRt / 2), LS(D2, D2, [L, F3]), C = C.clone(), C.applyTransform(D2);
        }
        var j = Pt(C), U3 = Pt(y2.getBoundingRect()), Y3 = Pt(x2.getBoundingRect()), Q = [y2.x, y2.y], nt = [x2.x, x2.y];
        nt[0] = Q[0] = j[0][0];
        var dt = e2.labelPosOpt;
        if (dt == null || ps(dt)) {
          var vt = dt === "+" ? 0 : 1;
          jt(Q, U3, j, 1, vt), jt(nt, Y3, j, 1, 1 - vt);
        } else {
          var vt = dt >= 0 ? 0 : 1;
          jt(Q, U3, j, 1, vt), nt[1] = Q[1] + dt;
        }
        y2.setPosition(Q), x2.setPosition(nt), y2.rotation = x2.rotation = e2.rotation, Ct(y2), Ct(x2);
        function Ct(Rt) {
          Rt.originX = j[0][0] - Rt.x, Rt.originY = j[1][0] - Rt.y;
        }
        function Pt(Rt) {
          return [[Rt.x, Rt.x + Rt.width], [Rt.y, Rt.y + Rt.height]];
        }
        function jt(Rt, le2, ne2, he2, _e) {
          Rt[he2] += ne2[he2][_e] - le2[he2][_e];
        }
      }, a.prototype._createAxis = function(e2, d2) {
        var y2 = d2.getData(), x2 = d2.get("axisType"), C = Chn(d2, x2);
        C.getTicks = function() {
          return y2.mapArray(["value"], function(F3) {
            return { value: F3 };
          });
        };
        var D2 = y2.getDataExtent("value");
        C.setExtent(D2[0], D2[1]), C.calcNiceTicks();
        var L = new Shn("value", C, e2.axisExtent, x2);
        return L.model = d2, L;
      }, a.prototype._createGroup = function(e2) {
        var d2 = this[e2] = new ou();
        return this.group.add(d2), d2;
      }, a.prototype._renderAxisLine = function(e2, d2, y2, x2) {
        var C = y2.getExtent();
        if (x2.get(["lineStyle", "show"])) {
          var D2 = new by({ shape: { x1: C[0], y1: 0, x2: C[1], y2: 0 }, style: la2({ lineCap: "round" }, x2.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
          d2.add(D2);
          var L = this._progressLine = new by({ shape: { x1: C[0], x2: this._currentPointer ? this._currentPointer.x : C[0], y1: 0, y2: 0 }, style: El({ lineCap: "round", lineWidth: D2.style.lineWidth }, x2.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
          d2.add(L);
        }
      }, a.prototype._renderAxisTick = function(e2, d2, y2, x2) {
        var C = this, D2 = x2.getData(), L = y2.scale.getTicks();
        this._tickSymbols = [], Ke2(L, function(F3) {
          var j = y2.dataToCoord(F3.value), U3 = D2.getItemModel(F3.value), Y3 = U3.getModel("itemStyle"), Q = U3.getModel(["emphasis", "itemStyle"]), nt = U3.getModel(["progress", "itemStyle"]), dt = { x: j, y: 0, onclick: As(C._changeTimeline, C, F3.value) }, vt = Lpe(U3, Y3, d2, dt);
          vt.ensureState("emphasis").style = Q.getItemStyle(), vt.ensureState("progress").style = nt.getItemStyle(), MO(vt);
          var Ct = ns(vt);
          U3.get("tooltip") ? (Ct.dataIndex = F3.value, Ct.dataModel = x2) : Ct.dataIndex = Ct.dataModel = null, C._tickSymbols.push(vt);
        });
      }, a.prototype._renderAxisLabel = function(e2, d2, y2, x2) {
        var C = this, D2 = y2.getLabelModel();
        if (D2.get("show")) {
          var L = x2.getData(), F3 = y2.getViewLabels();
          this._tickLabels = [], Ke2(F3, function(j) {
            var U3 = j.tickValue, Y3 = L.getItemModel(U3), Q = Y3.getModel("label"), nt = Y3.getModel(["emphasis", "label"]), dt = Y3.getModel(["progress", "label"]), vt = y2.dataToCoord(j.tickValue), Ct = new qc2({ x: vt, y: 0, rotation: e2.labelRotation - e2.rotation, onclick: As(C._changeTimeline, C, U3), silent: false, style: _y(Q, { text: j.formattedLabel, align: e2.labelAlign, verticalAlign: e2.labelBaseline }) });
            Ct.ensureState("emphasis").style = _y(nt), Ct.ensureState("progress").style = _y(dt), d2.add(Ct), MO(Ct), Ppe(Ct).dataIndex = U3, C._tickLabels.push(Ct);
          });
        }
      }, a.prototype._renderControl = function(e2, d2, y2, x2) {
        var C = e2.controlSize, D2 = e2.rotation, L = x2.getModel("controlStyle").getItemStyle(), F3 = x2.getModel(["emphasis", "controlStyle"]).getItemStyle(), j = x2.getPlayState(), U3 = x2.get("inverse", true);
        Y3(e2.nextBtnPosition, "next", As(this._changeTimeline, this, U3 ? "-" : "+")), Y3(e2.prevBtnPosition, "prev", As(this._changeTimeline, this, U3 ? "+" : "-")), Y3(e2.playPosition, j ? "stop" : "play", As(this._handlePlayClick, this, !j), true);
        function Y3(Q, nt, dt, vt) {
          if (Q) {
            var Ct = Tm($u(x2.get(["controlStyle", nt + "BtnSize"]), C), C), Pt = [0, -Ct / 2, Ct, Ct], jt = Ahn(x2, nt + "Icon", Pt, { x: Q[0], y: Q[1], originX: C / 2, originY: 0, rotation: vt ? -D2 : 0, rectHover: true, style: L, onclick: dt });
            jt.ensureState("emphasis").style = F3, d2.add(jt), MO(jt);
          }
        }
      }, a.prototype._renderCurrentPointer = function(e2, d2, y2, x2) {
        var C = x2.getData(), D2 = x2.getCurrentIndex(), L = C.getItemModel(D2).getModel("checkpointStyle"), F3 = this, j = { onCreate: function(U3) {
          U3.draggable = true, U3.drift = As(F3._handlePointerDrag, F3), U3.ondragend = As(F3._handlePointerDragend, F3), Ope(U3, F3._progressLine, D2, y2, x2, true);
        }, onUpdate: function(U3) {
          Ope(U3, F3._progressLine, D2, y2, x2);
        } };
        this._currentPointer = Lpe(L, L, this._mainGroup, {}, this._currentPointer, j);
      }, a.prototype._handlePlayClick = function(e2) {
        this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: e2, from: this.uid });
      }, a.prototype._handlePointerDrag = function(e2, d2, y2) {
        this._clearTimer(), this._pointerChangeTimeline([y2.offsetX, y2.offsetY]);
      }, a.prototype._handlePointerDragend = function(e2) {
        this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
      }, a.prototype._pointerChangeTimeline = function(e2, d2) {
        var y2 = this._toAxisCoord(e2)[0], x2 = this._axis, C = k_(x2.getExtent().slice());
        y2 > C[1] && (y2 = C[1]), y2 < C[0] && (y2 = C[0]), this._currentPointer.x = y2, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = y2, this._progressLine.dirty();
        var D2 = this._findNearestTick(y2), L = this.model;
        (d2 || D2 !== L.getCurrentIndex() && L.get("realtime")) && this._changeTimeline(D2);
      }, a.prototype._doPlayStop = function() {
        var e2 = this;
        this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
          var d2 = e2.model;
          e2._changeTimeline(d2.getCurrentIndex() + (d2.get("rewind", true) ? -1 : 1));
        }, this.model.get("playInterval")));
      }, a.prototype._toAxisCoord = function(e2) {
        var d2 = this._mainGroup.getLocalTransform();
        return hc2(e2, d2, true);
      }, a.prototype._findNearestTick = function(e2) {
        var d2 = this.model.getData(), y2 = 1 / 0, x2, C = this._axis;
        return d2.each(["value"], function(D2, L) {
          var F3 = C.dataToCoord(D2), j = Math.abs(F3 - e2);
          j < y2 && (y2 = j, x2 = L);
        }), x2;
      }, a.prototype._clearTimer = function() {
        this._timer && (clearTimeout(this._timer), this._timer = null);
      }, a.prototype._changeTimeline = function(e2) {
        var d2 = this.model.getCurrentIndex();
        e2 === "+" ? e2 = d2 + 1 : e2 === "-" && (e2 = d2 - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: e2, from: this.uid });
      }, a.prototype._updateTicksStatus = function() {
        var e2 = this.model.getCurrentIndex(), d2 = this._tickSymbols, y2 = this._tickLabels;
        if (d2)
          for (var x2 = 0; x2 < d2.length; x2++)
            d2 && d2[x2] && d2[x2].toggleState("progress", x2 < e2);
        if (y2)
          for (var x2 = 0; x2 < y2.length; x2++)
            y2 && y2[x2] && y2[x2].toggleState("progress", Ppe(y2[x2]).dataIndex <= e2);
      }, a.type = "timeline.slider", a;
    }(xhn);
    function Chn(l2, a) {
      if (a = a || l2.get("type"), a)
        switch (a) {
          case "category":
            return new PLt({ ordinalMeta: l2.getCategories(), extent: [1 / 0, -1 / 0] });
          case "time":
            return new ese({ locale: l2.ecModel.getLocaleModel(), useUTC: l2.ecModel.get("useUTC") });
          default:
            return new eF();
        }
    }
    function Thn(l2, a) {
      return Em(l2.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() }, l2.get("padding"));
    }
    function Ahn(l2, a, e2, d2) {
      var y2 = d2.style, x2 = fv(l2.get(["controlStyle", a]), d2 || {}, new Yu(e2[0], e2[1], e2[2], e2[3]));
      return y2 && x2.setStyle(y2), x2;
    }
    function Lpe(l2, a, e2, d2, y2, x2) {
      var C = a.get("color");
      if (y2)
        y2.setColor(C), e2.add(y2), x2 && x2.onUpdate(y2);
      else {
        var D2 = l2.get("symbol");
        y2 = qy(D2, -1, -1, 2, 2, C), y2.setStyle("strokeNoScale", true), e2.add(y2), x2 && x2.onCreate(y2);
      }
      var L = a.getItemStyle(["color"]);
      y2.setStyle(L), d2 = Mu({ rectHover: true, z2: 100 }, d2, true);
      var F3 = brt(l2.get("symbolSize"));
      d2.scaleX = F3[0] / 2, d2.scaleY = F3[1] / 2;
      var j = tZ(l2.get("symbolOffset"), F3);
      j && (d2.x = (d2.x || 0) + j[0], d2.y = (d2.y || 0) + j[1]);
      var U3 = l2.get("symbolRotate");
      return d2.rotation = (U3 || 0) * Math.PI / 180 || 0, y2.attr(d2), y2.updateTransform(), y2;
    }
    function Ope(l2, a, e2, d2, y2, x2) {
      if (!l2.dragging) {
        var C = y2.getModel("checkpointStyle"), D2 = d2.dataToCoord(y2.getData().get("value", e2));
        if (x2 || !C.get("animation", true))
          l2.attr({ x: D2, y: 0 }), a && a.attr({ shape: { x2: D2 } });
        else {
          var L = { duration: C.get("animationDuration", true), easing: C.get("animationEasing", true) };
          l2.stopAnimation(null, true), l2.animateTo({ x: D2, y: 0 }, L), a && a.animateTo({ shape: { x2: D2 } }, L);
        }
      }
    }
    var Ihn = Mhn;
    function Dhn(l2) {
      l2.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(a, e2, d2) {
        var y2 = e2.getComponent("timeline");
        return y2 && a.currentIndex != null && (y2.setCurrentIndex(a.currentIndex), !y2.get("loop", true) && y2.isIndexMax() && y2.getPlayState() && (y2.setPlayState(false), d2.dispatchAction({ type: "timelinePlayChange", playState: false, from: a.from }))), e2.resetOption("timeline", { replaceMerge: y2.get("replaceMerge", true) }), El({ currentIndex: y2.option.currentIndex }, a);
      }), l2.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(a, e2) {
        var d2 = e2.getComponent("timeline");
        d2 && a.playState != null && d2.setPlayState(a.playState);
      });
    }
    function Ehn(l2) {
      var a = l2 && l2.timeline;
      Ba2(a) || (a = a ? [a] : []), Ke2(a, function(e2) {
        !e2 || khn(e2);
      });
    }
    function khn(l2) {
      var a = l2.type, e2 = { number: "value", time: "time" };
      if (e2[a] && (l2.axisType = e2[a], delete l2.type), Rpe(l2), EB(l2, "controlPosition")) {
        var d2 = l2.controlStyle || (l2.controlStyle = {});
        EB(d2, "position") || (d2.position = l2.controlPosition), d2.position === "none" && !EB(d2, "show") && (d2.show = false, delete d2.position), delete l2.controlPosition;
      }
      Ke2(l2.data || [], function(y2) {
        vs(y2) && !Ba2(y2) && (!EB(y2, "value") && EB(y2, "name") && (y2.value = y2.name), Rpe(y2));
      });
    }
    function Rpe(l2) {
      var a = l2.itemStyle || (l2.itemStyle = {}), e2 = a.emphasis || (a.emphasis = {}), d2 = l2.label || l2.label || {}, y2 = d2.normal || (d2.normal = {}), x2 = { normal: 1, emphasis: 1 };
      Ke2(d2, function(C, D2) {
        !x2[D2] && !EB(y2, D2) && (y2[D2] = C);
      }), e2.label && !EB(d2, "emphasis") && (d2.emphasis = e2.label, delete e2.label);
    }
    function EB(l2, a) {
      return l2.hasOwnProperty(a);
    }
    function Phn(l2) {
      l2.registerComponentModel(bhn), l2.registerComponentView(Ihn), l2.registerSubTypeDefaulter("timeline", function() {
        return "slider";
      }), Dhn(l2), l2.registerPreprocessor(Ehn);
    }
    function yRt(l2, a) {
      if (!l2)
        return false;
      for (var e2 = Ba2(l2) ? l2 : [l2], d2 = 0; d2 < e2.length; d2++)
        if (e2[d2] && e2[d2][a])
          return true;
      return false;
    }
    function Fmt(l2) {
      RS(l2, "label", ["show"]);
    }
    var Vmt = Rf2(), Npe = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.createdBySelf = false, e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        this.mergeDefaultAndTheme(e2, y2), this._mergeOption(e2, y2, false, true);
      }, a.prototype.isAnimationEnabled = function() {
        if ($s.node)
          return false;
        var e2 = this.__hostSeries;
        return this.getShallow("animation") && e2 && e2.isAnimationEnabled();
      }, a.prototype.mergeOption = function(e2, d2) {
        this._mergeOption(e2, d2, false, false);
      }, a.prototype._mergeOption = function(e2, d2, y2, x2) {
        var C = this.mainType;
        y2 || d2.eachSeries(function(D2) {
          var L = D2.get(this.mainType, true), F3 = Vmt(D2)[C];
          if (!L || !L.data) {
            Vmt(D2)[C] = null;
            return;
          }
          F3 ? F3._mergeOption(L, d2, true) : (x2 && Fmt(L), Ke2(L.data, function(j) {
            j instanceof Array ? (Fmt(j[0]), Fmt(j[1])) : Fmt(j);
          }), F3 = this.createMarkerModelFromSeries(L, this, d2), la2(F3, { mainType: this.mainType, seriesIndex: D2.seriesIndex, name: D2.name, createdBySelf: true }), F3.__hostSeries = D2), Vmt(D2)[C] = F3;
        }, this);
      }, a.prototype.formatTooltip = function(e2, d2, y2) {
        var x2 = this.getData(), C = this.getRawValue(e2), D2 = x2.getName(e2);
        return b1("section", { header: this.name, blocks: [b1("nameValue", { name: D2, value: C, noName: !D2, noValue: C == null })] });
      }, a.prototype.getData = function() {
        return this._data;
      }, a.prototype.setData = function(e2) {
        this._data = e2;
      }, a.getMarkerModelFromSeries = function(e2, d2) {
        return Vmt(e2)[d2];
      }, a.type = "marker", a.dependencies = ["series", "grid", "polar", "geo"], a;
    }(Ah2);
    v0(Npe, $3t.prototype);
    var hF = Npe, Lhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.createMarkerModelFromSeries = function(e2, d2, y2) {
        return new a(e2, d2, y2);
      }, a.type = "markPoint", a.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, a;
    }(hF), Ohn = Lhn;
    function Rhn(l2) {
      return !(isNaN(parseFloat(l2.x)) && isNaN(parseFloat(l2.y)));
    }
    function Nhn(l2) {
      return !isNaN(parseFloat(l2.x)) && !isNaN(parseFloat(l2.y));
    }
    function Bmt(l2, a, e2, d2, y2, x2) {
      var C = [], D2 = tF(a, d2), L = D2 ? a.getCalculationInfo("stackResultDimension") : d2, F3 = bRt(a, L, l2), j = a.indicesOfNearest(L, F3)[0];
      C[y2] = a.get(e2, j), C[x2] = a.get(L, j);
      var U3 = a.get(d2, j), Y3 = $2(a.get(d2, j));
      return Y3 = Math.min(Y3, 20), Y3 >= 0 && (C[x2] = +C[x2].toFixed(Y3)), [C, U3];
    }
    var mRt = { min: xu(Bmt, "min"), max: xu(Bmt, "max"), average: xu(Bmt, "average"), median: xu(Bmt, "median") };
    function pit(l2, a) {
      var e2 = l2.getData(), d2 = l2.coordinateSystem;
      if (a && !Nhn(a) && !Ba2(a.coord) && d2) {
        var y2 = d2.dimensions, x2 = Fpe(a, e2, d2, l2);
        if (a = zl(a), a.type && mRt[a.type] && x2.baseAxis && x2.valueAxis) {
          var C = oc2(y2, x2.baseAxis.dim), D2 = oc2(y2, x2.valueAxis.dim), L = mRt[a.type](e2, x2.baseDataDim, x2.valueDataDim, C, D2);
          a.coord = L[0], a.value = L[1];
        } else {
          for (var F3 = [a.xAxis != null ? a.xAxis : a.radiusAxis, a.yAxis != null ? a.yAxis : a.angleAxis], j = 0; j < 2; j++)
            mRt[F3[j]] && (F3[j] = bRt(e2, e2.mapDimension(y2[j]), F3[j]));
          a.coord = F3;
        }
      }
      return a;
    }
    function Fpe(l2, a, e2, d2) {
      var y2 = {};
      return l2.valueIndex != null || l2.valueDim != null ? (y2.valueDataDim = l2.valueIndex != null ? a.getDimension(l2.valueIndex) : l2.valueDim, y2.valueAxis = e2.getAxis(Fhn(d2, y2.valueDataDim)), y2.baseAxis = e2.getOtherAxis(y2.valueAxis), y2.baseDataDim = a.mapDimension(y2.baseAxis.dim)) : (y2.baseAxis = d2.getBaseAxis(), y2.valueAxis = e2.getOtherAxis(y2.baseAxis), y2.baseDataDim = a.mapDimension(y2.baseAxis.dim), y2.valueDataDim = a.mapDimension(y2.valueAxis.dim)), y2;
    }
    function Fhn(l2, a) {
      var e2 = l2.getData().getDimensionInfo(a);
      return e2 && e2.coordDim;
    }
    function dit(l2, a) {
      return l2 && l2.containData && a.coord && !Rhn(a) ? l2.containData(a.coord) : true;
    }
    function Vpe(l2, a) {
      return l2 ? function(e2, d2, y2, x2) {
        var C = x2 < 2 ? e2.coord && e2.coord[x2] : e2.value;
        return KN(C, a[x2]);
      } : function(e2, d2, y2, x2) {
        return KN(e2.value, a[x2]);
      };
    }
    function bRt(l2, a, e2) {
      if (e2 === "average") {
        var d2 = 0, y2 = 0;
        return l2.each(a, function(x2, C) {
          isNaN(x2) || (d2 += x2, y2++);
        }), d2 / y2;
      } else
        return e2 === "median" ? l2.getMedian(a) : l2.getDataExtent(a)[e2 === "max" ? 1 : 0];
    }
    var _Rt = Rf2(), Vhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.init = function() {
        this.markerGroupMap = fl();
      }, a.prototype.render = function(e2, d2, y2) {
        var x2 = this, C = this.markerGroupMap;
        C.each(function(D2) {
          _Rt(D2).keep = false;
        }), d2.eachSeries(function(D2) {
          var L = hF.getMarkerModelFromSeries(D2, x2.type);
          L && x2.renderSeries(D2, L, d2, y2);
        }), C.each(function(D2) {
          !_Rt(D2).keep && x2.group.remove(D2.group);
        });
      }, a.prototype.markKeep = function(e2) {
        _Rt(e2).keep = true;
      }, a.prototype.blurSeries = function(e2) {
        var d2 = this;
        Ke2(e2, function(y2) {
          var x2 = hF.getMarkerModelFromSeries(y2, d2.type);
          if (x2) {
            var C = x2.getData();
            C.eachItemGraphicEl(function(D2) {
              D2 && Fnt(D2);
            });
          }
        });
      }, a.type = "marker", a;
    }(_0), xRt = Vhn;
    function Bpe(l2, a, e2) {
      var d2 = a.coordinateSystem;
      l2.each(function(y2) {
        var x2 = l2.getItemModel(y2), C, D2 = Ko(x2.get("x"), e2.getWidth()), L = Ko(x2.get("y"), e2.getHeight());
        if (!isNaN(D2) && !isNaN(L))
          C = [D2, L];
        else if (a.getMarkerPosition)
          C = a.getMarkerPosition(l2.getValues(l2.dimensions, y2));
        else if (d2) {
          var F3 = l2.get(d2.dimensions[0], y2), j = l2.get(d2.dimensions[1], y2);
          C = d2.dataToPoint([F3, j]);
        }
        isNaN(D2) || (C[0] = D2), isNaN(L) || (C[1] = L), l2.setItemLayout(y2, C);
      });
    }
    var Bhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.updateTransform = function(e2, d2, y2) {
        d2.eachSeries(function(x2) {
          var C = hF.getMarkerModelFromSeries(x2, "markPoint");
          C && (Bpe(C.getData(), x2, y2), this.markerGroupMap.get(x2.id).updateLayout());
        }, this);
      }, a.prototype.renderSeries = function(e2, d2, y2, x2) {
        var C = e2.coordinateSystem, D2 = e2.id, L = e2.getData(), F3 = this.markerGroupMap, j = F3.get(D2) || F3.set(D2, new jrt()), U3 = zhn(C, e2, d2);
        d2.setData(U3), Bpe(d2.getData(), e2, x2), U3.each(function(Y3) {
          var Q = U3.getItemModel(Y3), nt = Q.getShallow("symbol"), dt = Q.getShallow("symbolSize"), vt = Q.getShallow("symbolRotate"), Ct = Q.getShallow("symbolOffset"), Pt = Q.getShallow("symbolKeepAspect");
          if (wl(nt) || wl(dt) || wl(vt) || wl(Ct)) {
            var jt = d2.getRawValue(Y3), Rt = d2.getDataParams(Y3);
            wl(nt) && (nt = nt(jt, Rt)), wl(dt) && (dt = dt(jt, Rt)), wl(vt) && (vt = vt(jt, Rt)), wl(Ct) && (Ct = Ct(jt, Rt));
          }
          var le2 = Q.getModel("itemStyle").getItemStyle(), ne2 = mrt(L, "color");
          le2.fill || (le2.fill = ne2), U3.setItemVisual(Y3, { symbol: nt, symbolSize: dt, symbolRotate: vt, symbolOffset: Ct, symbolKeepAspect: Pt, style: le2 });
        }), j.updateData(U3), this.group.add(j.group), U3.eachItemGraphicEl(function(Y3) {
          Y3.traverse(function(Q) {
            ns(Q).dataModel = d2;
          });
        }), this.markKeep(j), j.group.silent = d2.get("silent") || e2.get("silent");
      }, a.type = "markPoint", a;
    }(xRt);
    function zhn(l2, a, e2) {
      var d2;
      l2 ? d2 = $a2(l2 && l2.dimensions, function(D2) {
        var L = a.getData().getDimensionInfo(a.getData().mapDimension(D2)) || {};
        return la2(la2({}, L), { name: D2, ordinalMeta: null });
      }) : d2 = [{ name: "value", type: "float" }];
      var y2 = new jS(d2, e2), x2 = $a2(e2.get("data"), xu(pit, a));
      l2 && (x2 = Lp(x2, xu(dit, l2)));
      var C = Vpe(!!l2, d2);
      return y2.initData(x2, null, C), y2;
    }
    var jhn = Bhn;
    function Whn(l2) {
      l2.registerComponentModel(Ohn), l2.registerComponentView(jhn), l2.registerPreprocessor(function(a) {
        yRt(a.series, "markPoint") && (a.markPoint = a.markPoint || {});
      });
    }
    var Ghn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.createMarkerModelFromSeries = function(e2, d2, y2) {
        return new a(e2, d2, y2);
      }, a.type = "markLine", a.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, a;
    }(hF), Hhn = Ghn, zmt = Rf2(), Uhn = function(l2, a, e2, d2) {
      var y2 = l2.getData(), x2;
      if (Ba2(d2))
        x2 = d2;
      else {
        var C = d2.type;
        if (C === "min" || C === "max" || C === "average" || C === "median" || d2.xAxis != null || d2.yAxis != null) {
          var D2 = void 0, L = void 0;
          if (d2.yAxis != null || d2.xAxis != null)
            D2 = a.getAxis(d2.yAxis != null ? "y" : "x"), L = jy(d2.yAxis, d2.xAxis);
          else {
            var F3 = Fpe(d2, y2, a, l2);
            D2 = F3.valueAxis;
            var j = Boe(y2, F3.valueDataDim);
            L = bRt(y2, j, C);
          }
          var U3 = D2.dim === "x" ? 0 : 1, Y3 = 1 - U3, Q = zl(d2), nt = { coord: [] };
          Q.type = null, Q.coord = [], Q.coord[Y3] = -1 / 0, nt.coord[Y3] = 1 / 0;
          var dt = e2.get("precision");
          dt >= 0 && Ch2(L) && (L = +L.toFixed(Math.min(dt, 20))), Q.coord[U3] = nt.coord[U3] = L, x2 = [Q, nt, { type: C, valueIndex: d2.valueIndex, value: L }];
        } else
          x2 = [];
      }
      var vt = [pit(l2, x2[0]), pit(l2, x2[1]), la2({}, x2[2])];
      return vt[2].type = vt[2].type || null, Mu(vt[2], vt[0]), Mu(vt[2], vt[1]), vt;
    };
    function jmt(l2) {
      return !isNaN(l2) && !isFinite(l2);
    }
    function zpe(l2, a, e2, d2) {
      var y2 = 1 - l2, x2 = d2.dimensions[l2];
      return jmt(a[y2]) && jmt(e2[y2]) && a[l2] === e2[l2] && d2.getAxis(x2).containData(a[l2]);
    }
    function qhn(l2, a) {
      if (l2.type === "cartesian2d") {
        var e2 = a[0].coord, d2 = a[1].coord;
        if (e2 && d2 && (zpe(1, e2, d2, l2) || zpe(0, e2, d2, l2)))
          return true;
      }
      return dit(l2, a[0]) && dit(l2, a[1]);
    }
    function wRt(l2, a, e2, d2, y2) {
      var x2 = d2.coordinateSystem, C = l2.getItemModel(a), D2, L = Ko(C.get("x"), y2.getWidth()), F3 = Ko(C.get("y"), y2.getHeight());
      if (!isNaN(L) && !isNaN(F3))
        D2 = [L, F3];
      else {
        if (d2.getMarkerPosition)
          D2 = d2.getMarkerPosition(l2.getValues(l2.dimensions, a));
        else {
          var j = x2.dimensions, U3 = l2.get(j[0], a), Y3 = l2.get(j[1], a);
          D2 = x2.dataToPoint([U3, Y3]);
        }
        if (OO(x2, "cartesian2d")) {
          var Q = x2.getAxis("x"), nt = x2.getAxis("y"), j = x2.dimensions;
          jmt(l2.get(j[0], a)) ? D2[0] = Q.toGlobalCoord(Q.getExtent()[e2 ? 0 : 1]) : jmt(l2.get(j[1], a)) && (D2[1] = nt.toGlobalCoord(nt.getExtent()[e2 ? 0 : 1]));
        }
        isNaN(L) || (D2[0] = L), isNaN(F3) || (D2[1] = F3);
      }
      l2.setItemLayout(a, D2);
    }
    var Zhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.updateTransform = function(e2, d2, y2) {
        d2.eachSeries(function(x2) {
          var C = hF.getMarkerModelFromSeries(x2, "markLine");
          if (C) {
            var D2 = C.getData(), L = zmt(C).from, F3 = zmt(C).to;
            L.each(function(j) {
              wRt(L, j, true, x2, y2), wRt(F3, j, false, x2, y2);
            }), D2.each(function(j) {
              D2.setItemLayout(j, [L.getItemLayout(j), F3.getItemLayout(j)]);
            }), this.markerGroupMap.get(x2.id).updateLayout();
          }
        }, this);
      }, a.prototype.renderSeries = function(e2, d2, y2, x2) {
        var C = e2.coordinateSystem, D2 = e2.id, L = e2.getData(), F3 = this.markerGroupMap, j = F3.get(D2) || F3.set(D2, new QOt());
        this.group.add(j.group);
        var U3 = $hn(C, e2, d2), Y3 = U3.from, Q = U3.to, nt = U3.line;
        zmt(d2).from = Y3, zmt(d2).to = Q, d2.setData(nt);
        var dt = d2.get("symbol"), vt = d2.get("symbolSize"), Ct = d2.get("symbolRotate"), Pt = d2.get("symbolOffset");
        Ba2(dt) || (dt = [dt, dt]), Ba2(vt) || (vt = [vt, vt]), Ba2(Ct) || (Ct = [Ct, Ct]), Ba2(Pt) || (Pt = [Pt, Pt]), U3.from.each(function(Rt) {
          jt(Y3, Rt, true), jt(Q, Rt, false);
        }), nt.each(function(Rt) {
          var le2 = nt.getItemModel(Rt).getModel("lineStyle").getLineStyle();
          nt.setItemLayout(Rt, [Y3.getItemLayout(Rt), Q.getItemLayout(Rt)]), le2.stroke == null && (le2.stroke = Y3.getItemVisual(Rt, "style").fill), nt.setItemVisual(Rt, { fromSymbolKeepAspect: Y3.getItemVisual(Rt, "symbolKeepAspect"), fromSymbolOffset: Y3.getItemVisual(Rt, "symbolOffset"), fromSymbolRotate: Y3.getItemVisual(Rt, "symbolRotate"), fromSymbolSize: Y3.getItemVisual(Rt, "symbolSize"), fromSymbol: Y3.getItemVisual(Rt, "symbol"), toSymbolKeepAspect: Q.getItemVisual(Rt, "symbolKeepAspect"), toSymbolOffset: Q.getItemVisual(Rt, "symbolOffset"), toSymbolRotate: Q.getItemVisual(Rt, "symbolRotate"), toSymbolSize: Q.getItemVisual(Rt, "symbolSize"), toSymbol: Q.getItemVisual(Rt, "symbol"), style: le2 });
        }), j.updateData(nt), U3.line.eachItemGraphicEl(function(Rt, le2) {
          Rt.traverse(function(ne2) {
            ns(ne2).dataModel = d2;
          });
        });
        function jt(Rt, le2, ne2) {
          var he2 = Rt.getItemModel(le2);
          wRt(Rt, le2, ne2, e2, x2);
          var _e = he2.getModel("itemStyle").getItemStyle();
          _e.fill == null && (_e.fill = mrt(L, "color")), Rt.setItemVisual(le2, { symbolKeepAspect: he2.get("symbolKeepAspect"), symbolOffset: $u(he2.get("symbolOffset", true), Pt[ne2 ? 0 : 1]), symbolRotate: $u(he2.get("symbolRotate", true), Ct[ne2 ? 0 : 1]), symbolSize: $u(he2.get("symbolSize"), vt[ne2 ? 0 : 1]), symbol: $u(he2.get("symbol", true), dt[ne2 ? 0 : 1]), style: _e });
        }
        this.markKeep(j), j.group.silent = d2.get("silent") || e2.get("silent");
      }, a.type = "markLine", a;
    }(xRt);
    function $hn(l2, a, e2) {
      var d2;
      l2 ? d2 = $a2(l2 && l2.dimensions, function(F3) {
        var j = a.getData().getDimensionInfo(a.getData().mapDimension(F3)) || {};
        return la2(la2({}, j), { name: F3, ordinalMeta: null });
      }) : d2 = [{ name: "value", type: "float" }];
      var y2 = new jS(d2, e2), x2 = new jS(d2, e2), C = new jS([], e2), D2 = $a2(e2.get("data"), xu(Uhn, a, l2, e2));
      l2 && (D2 = Lp(D2, xu(qhn, l2)));
      var L = Vpe(!!l2, d2);
      return y2.initData($a2(D2, function(F3) {
        return F3[0];
      }), null, L), x2.initData($a2(D2, function(F3) {
        return F3[1];
      }), null, L), C.initData($a2(D2, function(F3) {
        return F3[2];
      })), C.hasItemOption = true, { from: y2, to: x2, line: C };
    }
    var Yhn = Zhn;
    function Khn(l2) {
      l2.registerComponentModel(Hhn), l2.registerComponentView(Yhn), l2.registerPreprocessor(function(a) {
        yRt(a.series, "markLine") && (a.markLine = a.markLine || {});
      });
    }
    var Xhn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.createMarkerModelFromSeries = function(e2, d2, y2) {
        return new a(e2, d2, y2);
      }, a.type = "markArea", a.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, a;
    }(hF), Qhn = Xhn, Wmt = Rf2(), Jhn = function(l2, a, e2, d2) {
      var y2 = pit(l2, d2[0]), x2 = pit(l2, d2[1]), C = y2.coord, D2 = x2.coord;
      C[0] = jy(C[0], -1 / 0), C[1] = jy(C[1], -1 / 0), D2[0] = jy(D2[0], 1 / 0), D2[1] = jy(D2[1], 1 / 0);
      var L = IU([{}, y2, x2]);
      return L.coord = [y2.coord, x2.coord], L.x0 = y2.x, L.y0 = y2.y, L.x1 = x2.x, L.y1 = x2.y, L;
    };
    function Gmt(l2) {
      return !isNaN(l2) && !isFinite(l2);
    }
    function jpe(l2, a, e2, d2) {
      var y2 = 1 - l2;
      return Gmt(a[y2]) && Gmt(e2[y2]);
    }
    function tpn(l2, a) {
      var e2 = a.coord[0], d2 = a.coord[1];
      return OO(l2, "cartesian2d") && e2 && d2 && (jpe(1, e2, d2) || jpe(0, e2, d2)) ? true : dit(l2, { coord: e2, x: a.x0, y: a.y0 }) || dit(l2, { coord: d2, x: a.x1, y: a.y1 });
    }
    function Wpe(l2, a, e2, d2, y2) {
      var x2 = d2.coordinateSystem, C = l2.getItemModel(a), D2, L = Ko(C.get(e2[0]), y2.getWidth()), F3 = Ko(C.get(e2[1]), y2.getHeight());
      if (!isNaN(L) && !isNaN(F3))
        D2 = [L, F3];
      else {
        if (d2.getMarkerPosition)
          D2 = d2.getMarkerPosition(l2.getValues(e2, a));
        else {
          var j = l2.get(e2[0], a), U3 = l2.get(e2[1], a), Y3 = [j, U3];
          x2.clampData && x2.clampData(Y3, Y3), D2 = x2.dataToPoint(Y3, true);
        }
        if (OO(x2, "cartesian2d")) {
          var Q = x2.getAxis("x"), nt = x2.getAxis("y"), j = l2.get(e2[0], a), U3 = l2.get(e2[1], a);
          Gmt(j) ? D2[0] = Q.toGlobalCoord(Q.getExtent()[e2[0] === "x0" ? 0 : 1]) : Gmt(U3) && (D2[1] = nt.toGlobalCoord(nt.getExtent()[e2[1] === "y0" ? 0 : 1]));
        }
        isNaN(L) || (D2[0] = L), isNaN(F3) || (D2[1] = F3);
      }
      return D2;
    }
    var Gpe = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], epn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.updateTransform = function(e2, d2, y2) {
        d2.eachSeries(function(x2) {
          var C = hF.getMarkerModelFromSeries(x2, "markArea");
          if (C) {
            var D2 = C.getData();
            D2.each(function(L) {
              var F3 = $a2(Gpe, function(U3) {
                return Wpe(D2, L, U3, x2, y2);
              });
              D2.setItemLayout(L, F3);
              var j = D2.getItemGraphicEl(L);
              j.setShape("points", F3);
            });
          }
        }, this);
      }, a.prototype.renderSeries = function(e2, d2, y2, x2) {
        var C = e2.coordinateSystem, D2 = e2.id, L = e2.getData(), F3 = this.markerGroupMap, j = F3.get(D2) || F3.set(D2, { group: new ou() });
        this.group.add(j.group), this.markKeep(j);
        var U3 = npn(C, e2, d2);
        d2.setData(U3), U3.each(function(Y3) {
          var Q = $a2(Gpe, function(_e) {
            return Wpe(U3, Y3, _e, e2, x2);
          }), nt = C.getAxis("x").scale, dt = C.getAxis("y").scale, vt = nt.getExtent(), Ct = dt.getExtent(), Pt = [nt.parse(U3.get("x0", Y3)), nt.parse(U3.get("x1", Y3))], jt = [dt.parse(U3.get("y0", Y3)), dt.parse(U3.get("y1", Y3))];
          k_(Pt), k_(jt);
          var Rt = !(vt[0] > Pt[1] || vt[1] < Pt[0] || Ct[0] > jt[1] || Ct[1] < jt[0]), le2 = !Rt;
          U3.setItemLayout(Y3, { points: Q, allClipped: le2 });
          var ne2 = U3.getItemModel(Y3).getModel("itemStyle").getItemStyle(), he2 = mrt(L, "color");
          ne2.fill || (ne2.fill = he2, ps(ne2.fill) && (ne2.fill = zU(ne2.fill, 0.4))), ne2.stroke || (ne2.stroke = he2), U3.setItemVisual(Y3, "style", ne2);
        }), U3.diff(Wmt(j).data).add(function(Y3) {
          var Q = U3.getItemLayout(Y3);
          if (!Q.allClipped) {
            var nt = new rw({ shape: { points: Q.points } });
            U3.setItemGraphicEl(Y3, nt), j.group.add(nt);
          }
        }).update(function(Y3, Q) {
          var nt = Wmt(j).data.getItemGraphicEl(Q), dt = U3.getItemLayout(Y3);
          dt.allClipped ? nt && j.group.remove(nt) : (nt ? Yf2(nt, { shape: { points: dt.points } }, d2, Y3) : nt = new rw({ shape: { points: dt.points } }), U3.setItemGraphicEl(Y3, nt), j.group.add(nt));
        }).remove(function(Y3) {
          var Q = Wmt(j).data.getItemGraphicEl(Y3);
          j.group.remove(Q);
        }).execute(), U3.eachItemGraphicEl(function(Y3, Q) {
          var nt = U3.getItemModel(Q), dt = U3.getItemVisual(Q, "style");
          Y3.useStyle(U3.getItemVisual(Q, "style")), ow(Y3, Sb2(nt), { labelFetcher: d2, labelDataIndex: Q, defaultText: U3.getName(Q) || "", inheritColor: ps(dt.fill) ? zU(dt.fill, 1) : "#000" }), Gy(Y3, nt), n0(Y3, null, null, nt.get(["emphasis", "disabled"])), ns(Y3).dataModel = d2;
        }), Wmt(j).data = U3, j.group.silent = d2.get("silent") || e2.get("silent");
      }, a.type = "markArea", a;
    }(xRt);
    function npn(l2, a, e2) {
      var d2, y2, x2 = ["x0", "y0", "x1", "y1"];
      if (l2) {
        var C = $a2(l2 && l2.dimensions, function(F3) {
          var j = a.getData(), U3 = j.getDimensionInfo(j.mapDimension(F3)) || {};
          return la2(la2({}, U3), { name: F3, ordinalMeta: null });
        });
        y2 = $a2(x2, function(F3, j) {
          return { name: F3, type: C[j % 2].type };
        }), d2 = new jS(y2, e2);
      } else
        y2 = [{ name: "value", type: "float" }], d2 = new jS(y2, e2);
      var D2 = $a2(e2.get("data"), xu(Jhn, a, l2, e2));
      l2 && (D2 = Lp(D2, xu(tpn, l2)));
      var L = l2 ? function(F3, j, U3, Y3) {
        var Q = F3.coord[Math.floor(Y3 / 2)][Y3 % 2];
        return KN(Q, y2[Y3]);
      } : function(F3, j, U3, Y3) {
        return KN(F3.value, y2[Y3]);
      };
      return d2.initData(D2, null, L), d2.hasItemOption = true, d2;
    }
    var rpn = epn;
    function ipn(l2) {
      l2.registerComponentModel(Qhn), l2.registerComponentView(rpn), l2.registerPreprocessor(function(a) {
        yRt(a.series, "markArea") && (a.markArea = a.markArea || {});
      });
    }
    var apn = function(l2, a) {
      if (a === "all")
        return { type: "all", title: l2.getLocaleModel().get(["legend", "selector", "all"]) };
      if (a === "inverse")
        return { type: "inverse", title: l2.getLocaleModel().get(["legend", "selector", "inverse"]) };
    }, opn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.layoutMode = { type: "box", ignoreSize: true }, e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        this.mergeDefaultAndTheme(e2, y2), e2.selected = e2.selected || {}, this._updateSelector(e2);
      }, a.prototype.mergeOption = function(e2, d2) {
        l2.prototype.mergeOption.call(this, e2, d2), this._updateSelector(e2);
      }, a.prototype._updateSelector = function(e2) {
        var d2 = e2.selector, y2 = this.ecModel;
        d2 === true && (d2 = e2.selector = ["all", "inverse"]), Ba2(d2) && Ke2(d2, function(x2, C) {
          ps(x2) && (x2 = { type: x2 }), d2[C] = Mu(x2, apn(y2, x2.type));
        });
      }, a.prototype.optionUpdated = function() {
        this._updateData(this.ecModel);
        var e2 = this._data;
        if (e2[0] && this.get("selectedMode") === "single") {
          for (var d2 = false, y2 = 0; y2 < e2.length; y2++) {
            var x2 = e2[y2].get("name");
            if (this.isSelected(x2)) {
              this.select(x2), d2 = true;
              break;
            }
          }
          !d2 && this.select(e2[0].get("name"));
        }
      }, a.prototype._updateData = function(e2) {
        var d2 = [], y2 = [];
        e2.eachRawSeries(function(D2) {
          var L = D2.name;
          y2.push(L);
          var F3;
          if (D2.legendVisualProvider) {
            var j = D2.legendVisualProvider, U3 = j.getAllNames();
            e2.isSeriesFiltered(D2) || (y2 = y2.concat(U3)), U3.length ? d2 = d2.concat(U3) : F3 = true;
          } else
            F3 = true;
          F3 && y1(D2) && d2.push(D2.name);
        }), this._availableNames = y2;
        var x2 = this.get("data") || d2, C = $a2(x2, function(D2) {
          return (ps(D2) || Ch2(D2)) && (D2 = { name: D2 }), new hg2(D2, this, this.ecModel);
        }, this);
        this._data = C;
      }, a.prototype.getData = function() {
        return this._data;
      }, a.prototype.select = function(e2) {
        var d2 = this.option.selected, y2 = this.get("selectedMode");
        if (y2 === "single") {
          var x2 = this._data;
          Ke2(x2, function(C) {
            d2[C.get("name")] = false;
          });
        }
        d2[e2] = true;
      }, a.prototype.unSelect = function(e2) {
        this.get("selectedMode") !== "single" && (this.option.selected[e2] = false);
      }, a.prototype.toggleSelected = function(e2) {
        var d2 = this.option.selected;
        d2.hasOwnProperty(e2) || (d2[e2] = true), this[d2[e2] ? "unSelect" : "select"](e2);
      }, a.prototype.allSelect = function() {
        var e2 = this._data, d2 = this.option.selected;
        Ke2(e2, function(y2) {
          d2[y2.get("name", true)] = true;
        });
      }, a.prototype.inverseSelect = function() {
        var e2 = this._data, d2 = this.option.selected;
        Ke2(e2, function(y2) {
          var x2 = y2.get("name", true);
          d2.hasOwnProperty(x2) || (d2[x2] = true), d2[x2] = !d2[x2];
        });
      }, a.prototype.isSelected = function(e2) {
        var d2 = this.option.selected;
        return !(d2.hasOwnProperty(e2) && !d2[e2]) && oc2(this._availableNames, e2) >= 0;
      }, a.prototype.getOrient = function() {
        return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
      }, a.type = "legend.plain", a.dependencies = ["series"], a.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, a;
    }(Ah2), SRt = opn, xZ = xu, MRt = Ke2, Hmt = ou, spn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.newlineDisabled = false, e2;
      }
      return a.prototype.init = function() {
        this.group.add(this._contentGroup = new Hmt()), this.group.add(this._selectorGroup = new Hmt()), this._isFirstRender = true;
      }, a.prototype.getContentGroup = function() {
        return this._contentGroup;
      }, a.prototype.getSelectorGroup = function() {
        return this._selectorGroup;
      }, a.prototype.render = function(e2, d2, y2) {
        var x2 = this._isFirstRender;
        if (this._isFirstRender = false, this.resetInner(), !!e2.get("show", true)) {
          var C = e2.get("align"), D2 = e2.get("orient");
          (!C || C === "auto") && (C = e2.get("left") === "right" && D2 === "vertical" ? "right" : "left");
          var L = e2.get("selector", true), F3 = e2.get("selectorPosition", true);
          L && (!F3 || F3 === "auto") && (F3 = D2 === "horizontal" ? "end" : "start"), this.renderInner(C, e2, d2, y2, L, D2, F3);
          var j = e2.getBoxLayoutParams(), U3 = { width: y2.getWidth(), height: y2.getHeight() }, Y3 = e2.get("padding"), Q = Em(j, U3, Y3), nt = this.layoutInner(e2, C, Q, x2, L, F3), dt = Em(El({ width: nt.width, height: nt.height }, j), U3, Y3);
          this.group.x = dt.x - nt.x, this.group.y = dt.y - nt.y, this.group.markRedraw(), this.group.add(this._backgroundEl = Qhe(nt, e2));
        }
      }, a.prototype.resetInner = function() {
        this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
      }, a.prototype.renderInner = function(e2, d2, y2, x2, C, D2, L) {
        var F3 = this.getContentGroup(), j = fl(), U3 = d2.get("selectedMode"), Y3 = [];
        y2.eachRawSeries(function(Q) {
          !Q.get("legendHoverLink") && Y3.push(Q.id);
        }), MRt(d2.getData(), function(Q, nt) {
          var dt = Q.get("name");
          if (!this.newlineDisabled && (dt === "" || dt === `
`)) {
            var vt = new Hmt();
            vt.newline = true, F3.add(vt);
            return;
          }
          var Ct = y2.getSeriesByName(dt)[0];
          if (!j.get(dt))
            if (Ct) {
              var Pt = Ct.getData(), jt = Pt.getVisual("legendLineStyle") || {}, Rt = Pt.getVisual("legendIcon"), le2 = Pt.getVisual("style"), ne2 = this._createItem(Ct, dt, nt, Q, d2, e2, jt, le2, Rt, U3);
              ne2.on("click", xZ(Hpe, dt, null, x2, Y3)).on("mouseover", xZ(CRt, Ct.name, null, x2, Y3)).on("mouseout", xZ(TRt, Ct.name, null, x2, Y3)), j.set(dt, true);
            } else
              y2.eachRawSeries(function(he2) {
                if (!j.get(dt) && he2.legendVisualProvider) {
                  var _e = he2.legendVisualProvider;
                  if (!_e.containName(dt))
                    return;
                  var Me2 = _e.indexOfName(dt), Pe2 = _e.getItemVisual(Me2, "style"), Be2 = _e.getItemVisual(Me2, "legendIcon"), Je2 = kS(Pe2.fill);
                  Je2 && Je2[3] === 0 && (Je2[3] = 0.2, Pe2 = la2(la2({}, Pe2), { fill: d1(Je2, "rgba") }));
                  var Ze2 = this._createItem(he2, dt, nt, Q, d2, e2, {}, Pe2, Be2, U3);
                  Ze2.on("click", xZ(Hpe, null, dt, x2, Y3)).on("mouseover", xZ(CRt, null, dt, x2, Y3)).on("mouseout", xZ(TRt, null, dt, x2, Y3)), j.set(dt, true);
                }
              }, this);
        }, this), C && this._createSelector(C, d2, x2, D2, L);
      }, a.prototype._createSelector = function(e2, d2, y2, x2, C) {
        var D2 = this.getSelectorGroup();
        MRt(e2, function(L) {
          var F3 = L.type, j = new qc2({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
            y2.dispatchAction({ type: F3 === "all" ? "legendAllSelect" : "legendInverseSelect" });
          } });
          D2.add(j);
          var U3 = d2.getModel("selectorLabel"), Y3 = d2.getModel(["emphasis", "selectorLabel"]);
          ow(j, { normal: U3, emphasis: Y3 }, { defaultText: L.title }), MO(j);
        });
      }, a.prototype._createItem = function(e2, d2, y2, x2, C, D2, L, F3, j, U3) {
        var Y3 = e2.visualDrawType, Q = C.get("itemWidth"), nt = C.get("itemHeight"), dt = C.isSelected(d2), vt = x2.get("symbolRotate"), Ct = x2.get("symbolKeepAspect"), Pt = x2.get("icon");
        j = Pt || j || "roundRect";
        var jt = lpn(j, x2, L, F3, Y3, dt), Rt = new Hmt(), le2 = x2.getModel("textStyle");
        if (wl(e2.getLegendIcon) && (!Pt || Pt === "inherit"))
          Rt.add(e2.getLegendIcon({ itemWidth: Q, itemHeight: nt, icon: j, iconRotate: vt, itemStyle: jt.itemStyle, lineStyle: jt.lineStyle, symbolKeepAspect: Ct }));
        else {
          var ne2 = Pt === "inherit" && e2.getData().getVisual("symbol") ? vt === "inherit" ? e2.getData().getVisual("symbolRotate") : vt : 0;
          Rt.add(upn({ itemWidth: Q, itemHeight: nt, icon: j, iconRotate: ne2, itemStyle: jt.itemStyle, lineStyle: jt.lineStyle, symbolKeepAspect: Ct }));
        }
        var he2 = D2 === "left" ? Q + 5 : -5, _e = D2, Me2 = C.get("formatter"), Pe2 = d2;
        ps(Me2) && Me2 ? Pe2 = Me2.replace("{name}", d2 != null ? d2 : "") : wl(Me2) && (Pe2 = Me2(d2));
        var Be2 = x2.get("inactiveColor");
        Rt.add(new qc2({ style: _y(le2, { text: Pe2, x: he2, y: nt / 2, fill: dt ? le2.getTextColor() : Be2, align: _e, verticalAlign: "middle" }) }));
        var Je2 = new Nf2({ shape: Rt.getBoundingRect(), invisible: true }), Ze2 = x2.getModel("tooltip");
        return Ze2.get("show") && Vq({ el: Je2, componentModel: C, itemName: d2, itemTooltipOption: Ze2.option }), Rt.add(Je2), Rt.eachChild(function(Cn) {
          Cn.silent = true;
        }), Je2.silent = !U3, this.getContentGroup().add(Rt), MO(Rt), Rt.__legendDataIndex = y2, Rt;
      }, a.prototype.layoutInner = function(e2, d2, y2, x2, C, D2) {
        var L = this.getContentGroup(), F3 = this.getSelectorGroup();
        iB(e2.get("orient"), L, e2.get("itemGap"), y2.width, y2.height);
        var j = L.getBoundingRect(), U3 = [-j.x, -j.y];
        if (F3.markRedraw(), L.markRedraw(), C) {
          iB("horizontal", F3, e2.get("selectorItemGap", true));
          var Y3 = F3.getBoundingRect(), Q = [-Y3.x, -Y3.y], nt = e2.get("selectorButtonGap", true), dt = e2.getOrient().index, vt = dt === 0 ? "width" : "height", Ct = dt === 0 ? "height" : "width", Pt = dt === 0 ? "y" : "x";
          D2 === "end" ? Q[dt] += j[vt] + nt : U3[dt] += Y3[vt] + nt, Q[1 - dt] += j[Ct] / 2 - Y3[Ct] / 2, F3.x = Q[0], F3.y = Q[1], L.x = U3[0], L.y = U3[1];
          var jt = { x: 0, y: 0 };
          return jt[vt] = j[vt] + nt + Y3[vt], jt[Ct] = Math.max(j[Ct], Y3[Ct]), jt[Pt] = Math.min(0, Y3[Pt] + Q[1 - dt]), jt;
        } else
          return L.x = U3[0], L.y = U3[1], this.group.getBoundingRect();
      }, a.prototype.remove = function() {
        this.getContentGroup().removeAll(), this._isFirstRender = true;
      }, a.type = "legend.plain", a;
    }(_0);
    function lpn(l2, a, e2, d2, y2, x2) {
      function C(nt, dt) {
        nt.lineWidth === "auto" && (nt.lineWidth = dt.lineWidth > 0 ? 2 : 0), MRt(nt, function(vt, Ct) {
          nt[Ct] === "inherit" && (nt[Ct] = dt[Ct]);
        });
      }
      var D2 = a.getModel("itemStyle"), L = D2.getItemStyle(), F3 = l2.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
      L.decal = d2.decal, L.fill === "inherit" && (L.fill = d2[y2]), L.stroke === "inherit" && (L.stroke = d2[F3]), L.opacity === "inherit" && (L.opacity = (y2 === "fill" ? d2 : e2).opacity), C(L, d2);
      var j = a.getModel("lineStyle"), U3 = j.getLineStyle();
      if (C(U3, e2), L.fill === "auto" && (L.fill = d2.fill), L.stroke === "auto" && (L.stroke = d2.fill), U3.stroke === "auto" && (U3.stroke = d2.fill), !x2) {
        var Y3 = a.get("inactiveBorderWidth"), Q = L[F3];
        L.lineWidth = Y3 === "auto" ? d2.lineWidth > 0 && Q ? 2 : 0 : L.lineWidth, L.fill = a.get("inactiveColor"), L.stroke = a.get("inactiveBorderColor"), U3.stroke = j.get("inactiveColor"), U3.lineWidth = j.get("inactiveWidth");
      }
      return { itemStyle: L, lineStyle: U3 };
    }
    function upn(l2) {
      var a = l2.icon || "roundRect", e2 = qy(a, 0, 0, l2.itemWidth, l2.itemHeight, l2.itemStyle.fill, l2.symbolKeepAspect);
      return e2.setStyle(l2.itemStyle), e2.rotation = (l2.iconRotate || 0) * Math.PI / 180, e2.setOrigin([l2.itemWidth / 2, l2.itemHeight / 2]), a.indexOf("empty") > -1 && (e2.style.stroke = e2.style.fill, e2.style.fill = "#fff", e2.style.lineWidth = 2), e2;
    }
    function Hpe(l2, a, e2, d2) {
      TRt(l2, a, e2, d2), e2.dispatchAction({ type: "legendToggleSelect", name: l2 != null ? l2 : a }), CRt(l2, a, e2, d2);
    }
    function Upe(l2) {
      for (var a = l2.getZr().storage.getDisplayList(), e2, d2 = 0, y2 = a.length; d2 < y2 && !(e2 = a[d2].states.emphasis); )
        d2++;
      return e2 && e2.hoverLayer;
    }
    function CRt(l2, a, e2, d2) {
      Upe(e2) || e2.dispatchAction({ type: "highlight", seriesName: l2, name: a, excludeSeriesId: d2 });
    }
    function TRt(l2, a, e2, d2) {
      Upe(e2) || e2.dispatchAction({ type: "downplay", seriesName: l2, name: a, excludeSeriesId: d2 });
    }
    var qpe = spn;
    function cpn(l2) {
      var a = l2.findComponents({ mainType: "legend" });
      a && a.length && l2.filterSeries(function(e2) {
        for (var d2 = 0; d2 < a.length; d2++)
          if (!a[d2].isSelected(e2.name))
            return false;
        return true;
      });
    }
    function git(l2, a, e2) {
      var d2 = {}, y2 = l2 === "toggleSelected", x2;
      return e2.eachComponent("legend", function(C) {
        y2 && x2 != null ? C[x2 ? "select" : "unSelect"](a.name) : l2 === "allSelect" || l2 === "inverseSelect" ? C[l2]() : (C[l2](a.name), x2 = C.isSelected(a.name));
        var D2 = C.getData();
        Ke2(D2, function(L) {
          var F3 = L.get("name");
          if (!(F3 === `
` || F3 === "")) {
            var j = C.isSelected(F3);
            d2.hasOwnProperty(F3) ? d2[F3] = d2[F3] && j : d2[F3] = j;
          }
        });
      }), l2 === "allSelect" || l2 === "inverseSelect" ? { selected: d2 } : { name: a.name, selected: d2 };
    }
    function fpn(l2) {
      l2.registerAction("legendToggleSelect", "legendselectchanged", xu(git, "toggleSelected")), l2.registerAction("legendAllSelect", "legendselectall", xu(git, "allSelect")), l2.registerAction("legendInverseSelect", "legendinverseselect", xu(git, "inverseSelect")), l2.registerAction("legendSelect", "legendselected", xu(git, "select")), l2.registerAction("legendUnSelect", "legendunselected", xu(git, "unSelect"));
    }
    function Zpe(l2) {
      l2.registerComponentModel(SRt), l2.registerComponentView(qpe), l2.registerProcessor(l2.PRIORITY.PROCESSOR.SERIES_FILTER, cpn), l2.registerSubTypeDefaulter("legend", function() {
        return "plain";
      }), fpn(l2);
    }
    var hpn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.setScrollDataIndex = function(e2) {
        this.option.scrollDataIndex = e2;
      }, a.prototype.init = function(e2, d2, y2) {
        var x2 = Hq(e2);
        l2.prototype.init.call(this, e2, d2, y2), $pe(this, e2, x2);
      }, a.prototype.mergeOption = function(e2, d2) {
        l2.prototype.mergeOption.call(this, e2, d2), $pe(this, this.option, e2);
      }, a.type = "legend.scroll", a.defaultOption = ZN(SRt.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), a;
    }(SRt);
    function $pe(l2, a, e2) {
      var d2 = l2.getOrient(), y2 = [1, 1];
      y2[d2.index] = 0, $N(a, e2, { type: "box", ignoreSize: !!y2 });
    }
    var ppn = hpn, Ype = ou, ARt = ["width", "height"], IRt = ["x", "y"], dpn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.newlineDisabled = true, e2._currentIndex = 0, e2;
      }
      return a.prototype.init = function() {
        l2.prototype.init.call(this), this.group.add(this._containerGroup = new Ype()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new Ype());
      }, a.prototype.resetInner = function() {
        l2.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
      }, a.prototype.renderInner = function(e2, d2, y2, x2, C, D2, L) {
        var F3 = this;
        l2.prototype.renderInner.call(this, e2, d2, y2, x2, C, D2, L);
        var j = this._controllerGroup, U3 = d2.get("pageIconSize", true), Y3 = Ba2(U3) ? U3 : [U3, U3];
        nt("pagePrev", 0);
        var Q = d2.getModel("pageTextStyle");
        j.add(new qc2({ name: "pageText", style: { text: "xx/xx", fill: Q.getTextColor(), font: Q.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), nt("pageNext", 1);
        function nt(dt, vt) {
          var Ct = dt + "DataIndex", Pt = fv(d2.get("pageIcons", true)[d2.getOrient().name][vt], { onclick: As(F3._pageGo, F3, Ct, d2, x2) }, { x: -Y3[0] / 2, y: -Y3[1] / 2, width: Y3[0], height: Y3[1] });
          Pt.name = dt, j.add(Pt);
        }
      }, a.prototype.layoutInner = function(e2, d2, y2, x2, C, D2) {
        var L = this.getSelectorGroup(), F3 = e2.getOrient().index, j = ARt[F3], U3 = IRt[F3], Y3 = ARt[1 - F3], Q = IRt[1 - F3];
        C && iB("horizontal", L, e2.get("selectorItemGap", true));
        var nt = e2.get("selectorButtonGap", true), dt = L.getBoundingRect(), vt = [-dt.x, -dt.y], Ct = zl(y2);
        C && (Ct[j] = y2[j] - dt[j] - nt);
        var Pt = this._layoutContentAndController(e2, x2, Ct, F3, j, Y3, Q, U3);
        if (C) {
          if (D2 === "end")
            vt[F3] += Pt[j] + nt;
          else {
            var jt = dt[j] + nt;
            vt[F3] -= jt, Pt[U3] -= jt;
          }
          Pt[j] += dt[j] + nt, vt[1 - F3] += Pt[Q] + Pt[Y3] / 2 - dt[Y3] / 2, Pt[Y3] = Math.max(Pt[Y3], dt[Y3]), Pt[Q] = Math.min(Pt[Q], dt[Q] + vt[1 - F3]), L.x = vt[0], L.y = vt[1], L.markRedraw();
        }
        return Pt;
      }, a.prototype._layoutContentAndController = function(e2, d2, y2, x2, C, D2, L, F3) {
        var j = this.getContentGroup(), U3 = this._containerGroup, Y3 = this._controllerGroup;
        iB(e2.get("orient"), j, e2.get("itemGap"), x2 ? y2.width : null, x2 ? null : y2.height), iB("horizontal", Y3, e2.get("pageButtonItemGap", true));
        var Q = j.getBoundingRect(), nt = Y3.getBoundingRect(), dt = this._showController = Q[C] > y2[C], vt = [-Q.x, -Q.y];
        d2 || (vt[x2] = j[F3]);
        var Ct = [0, 0], Pt = [-nt.x, -nt.y], jt = $u(e2.get("pageButtonGap", true), e2.get("itemGap", true));
        if (dt) {
          var Rt = e2.get("pageButtonPosition", true);
          Rt === "end" ? Pt[x2] += y2[C] - nt[C] : Ct[x2] += nt[C] + jt;
        }
        Pt[1 - x2] += Q[D2] / 2 - nt[D2] / 2, j.setPosition(vt), U3.setPosition(Ct), Y3.setPosition(Pt);
        var le2 = { x: 0, y: 0 };
        if (le2[C] = dt ? y2[C] : Q[C], le2[D2] = Math.max(Q[D2], nt[D2]), le2[L] = Math.min(0, nt[L] + Pt[1 - x2]), U3.__rectSize = y2[C], dt) {
          var ne2 = { x: 0, y: 0 };
          ne2[C] = Math.max(y2[C] - nt[C] - jt, 0), ne2[D2] = le2[D2], U3.setClipPath(new Nf2({ shape: ne2 })), U3.__rectSize = ne2[C];
        } else
          Y3.eachChild(function(_e) {
            _e.attr({ invisible: true, silent: true });
          });
        var he2 = this._getPageInfo(e2);
        return he2.pageIndex != null && Yf2(j, { x: he2.contentPosition[0], y: he2.contentPosition[1] }, dt ? e2 : null), this._updatePageInfoView(e2, he2), le2;
      }, a.prototype._pageGo = function(e2, d2, y2) {
        var x2 = this._getPageInfo(d2)[e2];
        x2 != null && y2.dispatchAction({ type: "legendScroll", scrollDataIndex: x2, legendId: d2.id });
      }, a.prototype._updatePageInfoView = function(e2, d2) {
        var y2 = this._controllerGroup;
        Ke2(["pagePrev", "pageNext"], function(j) {
          var U3 = j + "DataIndex", Y3 = d2[U3] != null, Q = y2.childOfName(j);
          Q && (Q.setStyle("fill", Y3 ? e2.get("pageIconColor", true) : e2.get("pageIconInactiveColor", true)), Q.cursor = Y3 ? "pointer" : "default");
        });
        var x2 = y2.childOfName("pageText"), C = e2.get("pageFormatter"), D2 = d2.pageIndex, L = D2 != null ? D2 + 1 : 0, F3 = d2.pageCount;
        x2 && C && x2.setStyle("text", ps(C) ? C.replace("{current}", L == null ? "" : L + "").replace("{total}", F3 == null ? "" : F3 + "") : C({ current: L, total: F3 }));
      }, a.prototype._getPageInfo = function(e2) {
        var d2 = e2.get("scrollDataIndex", true), y2 = this.getContentGroup(), x2 = this._containerGroup.__rectSize, C = e2.getOrient().index, D2 = ARt[C], L = IRt[C], F3 = this._findTargetItemIndex(d2), j = y2.children(), U3 = j[F3], Y3 = j.length, Q = Y3 ? 1 : 0, nt = { contentPosition: [y2.x, y2.y], pageCount: Q, pageIndex: Q - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
        if (!U3)
          return nt;
        var dt = Rt(U3);
        nt.contentPosition[C] = -dt.s;
        for (var vt = F3 + 1, Ct = dt, Pt = dt, jt = null; vt <= Y3; ++vt)
          jt = Rt(j[vt]), (!jt && Pt.e > Ct.s + x2 || jt && !le2(jt, Ct.s)) && (Pt.i > Ct.i ? Ct = Pt : Ct = jt, Ct && (nt.pageNextDataIndex == null && (nt.pageNextDataIndex = Ct.i), ++nt.pageCount)), Pt = jt;
        for (var vt = F3 - 1, Ct = dt, Pt = dt, jt = null; vt >= -1; --vt)
          jt = Rt(j[vt]), (!jt || !le2(Pt, jt.s)) && Ct.i < Pt.i && (Pt = Ct, nt.pagePrevDataIndex == null && (nt.pagePrevDataIndex = Ct.i), ++nt.pageCount, ++nt.pageIndex), Ct = jt;
        return nt;
        function Rt(ne2) {
          if (ne2) {
            var he2 = ne2.getBoundingRect(), _e = he2[L] + ne2[L];
            return { s: _e, e: _e + he2[D2], i: ne2.__legendDataIndex };
          }
        }
        function le2(ne2, he2) {
          return ne2.e >= he2 && ne2.s <= he2 + x2;
        }
      }, a.prototype._findTargetItemIndex = function(e2) {
        if (!this._showController)
          return 0;
        var d2, y2 = this.getContentGroup(), x2;
        return y2.eachChild(function(C, D2) {
          var L = C.__legendDataIndex;
          x2 == null && L != null && (x2 = D2), L === e2 && (d2 = D2);
        }), d2 != null ? d2 : x2;
      }, a.type = "legend.scroll", a;
    }(qpe), gpn = dpn;
    function vpn(l2) {
      l2.registerAction("legendScroll", "legendscroll", function(a, e2) {
        var d2 = a.scrollDataIndex;
        d2 != null && e2.eachComponent({ mainType: "legend", subType: "scroll", query: a }, function(y2) {
          y2.setScrollDataIndex(d2);
        });
      });
    }
    function ypn(l2) {
      Oc2(Zpe), l2.registerComponentModel(ppn), l2.registerComponentView(gpn), vpn(l2);
    }
    function mpn(l2) {
      Oc2(Zpe), Oc2(ypn);
    }
    var bpn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "dataZoom.inside", a.defaultOption = ZN(cit.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), a;
    }(cit), _pn = bpn, DRt = Rf2();
    function xpn(l2, a, e2) {
      DRt(l2).coordSysRecordMap.each(function(d2) {
        var y2 = d2.dataZoomInfoMap.get(a.uid);
        y2 && (y2.getRange = e2);
      });
    }
    function wpn(l2, a) {
      for (var e2 = DRt(l2).coordSysRecordMap, d2 = e2.keys(), y2 = 0; y2 < d2.length; y2++) {
        var x2 = d2[y2], C = e2.get(x2), D2 = C.dataZoomInfoMap;
        if (D2) {
          var L = a.uid, F3 = D2.get(L);
          F3 && (D2.removeKey(L), D2.keys().length || Kpe(e2, C));
        }
      }
    }
    function Kpe(l2, a) {
      if (a) {
        l2.removeKey(a.model.uid);
        var e2 = a.controller;
        e2 && e2.dispose();
      }
    }
    function Spn(l2, a) {
      var e2 = { model: a, containsPoint: xu(Cpn, a), dispatchAction: xu(Mpn, l2), dataZoomInfoMap: null, controller: null }, d2 = e2.controller = new Zrt(l2.getZr());
      return Ke2(["pan", "zoom", "scrollMove"], function(y2) {
        d2.on(y2, function(x2) {
          var C = [];
          e2.dataZoomInfoMap.each(function(D2) {
            if (x2.isAvailableBehavior(D2.model.option)) {
              var L = (D2.getRange || {})[y2], F3 = L && L(D2.dzReferCoordSysInfo, e2.model.mainType, e2.controller, x2);
              !D2.model.get("disabled", true) && F3 && C.push({ dataZoomId: D2.model.id, start: F3[0], end: F3[1] });
            }
          }), C.length && e2.dispatchAction(C);
        });
      }), e2;
    }
    function Mpn(l2, a) {
      l2.isDisposed() || l2.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: a });
    }
    function Cpn(l2, a, e2, d2) {
      return l2.coordinateSystem.containPoint([e2, d2]);
    }
    function Tpn(l2) {
      var a, e2 = "type_", d2 = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, y2 = true;
      return l2.each(function(x2) {
        var C = x2.model, D2 = C.get("disabled", true) ? false : C.get("zoomLock", true) ? "move" : true;
        d2[e2 + D2] > d2[e2 + a] && (a = D2), y2 = y2 && C.get("preventDefaultMouseMove", true);
      }), { controlType: a, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!y2 } };
    }
    function Apn(l2) {
      l2.registerProcessor(l2.PRIORITY.PROCESSOR.FILTER, function(a, e2) {
        var d2 = DRt(e2), y2 = d2.coordSysRecordMap || (d2.coordSysRecordMap = fl());
        y2.each(function(x2) {
          x2.dataZoomInfoMap = null;
        }), a.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(x2) {
          var C = qhe(x2);
          Ke2(C.infoList, function(D2) {
            var L = D2.model.uid, F3 = y2.get(L) || y2.set(L, Spn(e2, D2.model)), j = F3.dataZoomInfoMap || (F3.dataZoomInfoMap = fl());
            j.set(x2.uid, { dzReferCoordSysInfo: D2, model: x2, getRange: null });
          });
        }), y2.each(function(x2) {
          var C = x2.controller, D2, L = x2.dataZoomInfoMap;
          if (L) {
            var F3 = L.keys()[0];
            F3 != null && (D2 = L.get(F3));
          }
          if (!D2) {
            Kpe(y2, x2);
            return;
          }
          var j = Tpn(L);
          C.enable(j.controlType, j.opt), C.setPointerChecker(x2.containsPoint), Xq(x2, "dispatchAction", D2.model.get("throttle", true), "fixRate");
        });
      });
    }
    var Ipn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "dataZoom.inside", e2;
      }
      return a.prototype.render = function(e2, d2, y2) {
        if (l2.prototype.render.apply(this, arguments), e2.noTarget()) {
          this._clear();
          return;
        }
        this.range = e2.getPercentRange(), xpn(y2, e2, { pan: As(ERt.pan, this), zoom: As(ERt.zoom, this), scrollMove: As(ERt.scrollMove, this) });
      }, a.prototype.dispose = function() {
        this._clear(), l2.prototype.dispose.apply(this, arguments);
      }, a.prototype._clear = function() {
        wpn(this.api, this.dataZoomModel), this.range = null;
      }, a.type = "dataZoom.inside", a;
    }(rRt), ERt = { zoom: function(l2, a, e2, d2) {
      var y2 = this.range, x2 = y2.slice(), C = l2.axisModels[0];
      if (C) {
        var D2 = kRt[a](null, [d2.originX, d2.originY], C, e2, l2), L = (D2.signal > 0 ? D2.pixelStart + D2.pixelLength - D2.pixel : D2.pixel - D2.pixelStart) / D2.pixelLength * (x2[1] - x2[0]) + x2[0], F3 = Math.max(1 / d2.scale, 0);
        x2[0] = (x2[0] - L) * F3 + L, x2[1] = (x2[1] - L) * F3 + L;
        var j = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
        if (CB(0, x2, [0, 100], 0, j.minSpan, j.maxSpan), this.range = x2, y2[0] !== x2[0] || y2[1] !== x2[1])
          return x2;
      }
    }, pan: Xpe(function(l2, a, e2, d2, y2, x2) {
      var C = kRt[d2]([x2.oldX, x2.oldY], [x2.newX, x2.newY], a, y2, e2);
      return C.signal * (l2[1] - l2[0]) * C.pixel / C.pixelLength;
    }), scrollMove: Xpe(function(l2, a, e2, d2, y2, x2) {
      var C = kRt[d2]([0, 0], [x2.scrollDelta, x2.scrollDelta], a, y2, e2);
      return C.signal * (l2[1] - l2[0]) * x2.scrollDelta;
    }) };
    function Xpe(l2) {
      return function(a, e2, d2, y2) {
        var x2 = this.range, C = x2.slice(), D2 = a.axisModels[0];
        if (D2) {
          var L = l2(C, D2, a, e2, d2, y2);
          if (CB(L, C, [0, 100], "all"), this.range = C, x2[0] !== C[0] || x2[1] !== C[1])
            return C;
        }
      };
    }
    var kRt = { grid: function(l2, a, e2, d2, y2) {
      var x2 = e2.axis, C = {}, D2 = y2.model.coordinateSystem.getRect();
      return l2 = l2 || [0, 0], x2.dim === "x" ? (C.pixel = a[0] - l2[0], C.pixelLength = D2.width, C.pixelStart = D2.x, C.signal = x2.inverse ? 1 : -1) : (C.pixel = a[1] - l2[1], C.pixelLength = D2.height, C.pixelStart = D2.y, C.signal = x2.inverse ? -1 : 1), C;
    }, polar: function(l2, a, e2, d2, y2) {
      var x2 = e2.axis, C = {}, D2 = y2.model.coordinateSystem, L = D2.getRadiusAxis().getExtent(), F3 = D2.getAngleAxis().getExtent();
      return l2 = l2 ? D2.pointToCoord(l2) : [0, 0], a = D2.pointToCoord(a), e2.mainType === "radiusAxis" ? (C.pixel = a[0] - l2[0], C.pixelLength = L[1] - L[0], C.pixelStart = L[0], C.signal = x2.inverse ? 1 : -1) : (C.pixel = a[1] - l2[1], C.pixelLength = F3[1] - F3[0], C.pixelStart = F3[0], C.signal = x2.inverse ? -1 : 1), C;
    }, singleAxis: function(l2, a, e2, d2, y2) {
      var x2 = e2.axis, C = y2.model.coordinateSystem.getRect(), D2 = {};
      return l2 = l2 || [0, 0], x2.orient === "horizontal" ? (D2.pixel = a[0] - l2[0], D2.pixelLength = C.width, D2.pixelStart = C.x, D2.signal = x2.inverse ? 1 : -1) : (D2.pixel = a[1] - l2[1], D2.pixelLength = C.height, D2.pixelStart = C.y, D2.signal = x2.inverse ? -1 : 1), D2;
    } }, Dpn = Ipn;
    function Qpe(l2) {
      iRt(l2), l2.registerComponentModel(_pn), l2.registerComponentView(Dpn), Apn(l2);
    }
    var Epn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.type = "dataZoom.slider", a.layoutMode = "box", a.defaultOption = ZN(cit.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), a;
    }(cit), kpn = Epn, vit = Nf2, Jpe = 7, Ppn = 1, PRt = 30, Lpn = 7, yit = "horizontal", tde = "vertical", Opn = 5, Rpn = ["line", "bar", "candlestick", "scatter"], Npn = { easing: "cubicOut", duration: 100, delay: 0 }, Fpn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._displayables = {}, e2;
      }
      return a.prototype.init = function(e2, d2) {
        this.api = d2, this._onBrush = As(this._onBrush, this), this._onBrushEnd = As(this._onBrushEnd, this);
      }, a.prototype.render = function(e2, d2, y2, x2) {
        if (l2.prototype.render.apply(this, arguments), Xq(this, "_dispatchZoomAction", e2.get("throttle"), "fixRate"), this._orient = e2.getOrient(), e2.get("show") === false) {
          this.group.removeAll();
          return;
        }
        if (e2.noTarget()) {
          this._clear(), this.group.removeAll();
          return;
        }
        (!x2 || x2.type !== "dataZoom" || x2.from !== this.uid) && this._buildView(), this._updateView();
      }, a.prototype.dispose = function() {
        this._clear(), l2.prototype.dispose.apply(this, arguments);
      }, a.prototype._clear = function() {
        grt(this, "_dispatchZoomAction");
        var e2 = this.api.getZr();
        e2.off("mousemove", this._onBrush), e2.off("mouseup", this._onBrushEnd);
      }, a.prototype._buildView = function() {
        var e2 = this.group;
        e2.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
        var d2 = this._displayables.sliderGroup = new ou();
        this._renderBackground(), this._renderHandle(), this._renderDataShadow(), e2.add(d2), this._positionGroup();
      }, a.prototype._resetLocation = function() {
        var e2 = this.dataZoomModel, d2 = this.api, y2 = e2.get("brushSelect"), x2 = y2 ? Lpn : 0, C = this._findCoordRect(), D2 = { width: d2.getWidth(), height: d2.getHeight() }, L = this._orient === yit ? { right: D2.width - C.x - C.width, top: D2.height - PRt - Jpe - x2, width: C.width, height: PRt } : { right: Jpe, top: C.y, width: PRt, height: C.height }, F3 = Hq(e2.option);
        Ke2(["right", "top", "width", "height"], function(U3) {
          F3[U3] === "ph" && (F3[U3] = L[U3]);
        });
        var j = Em(F3, D2);
        this._location = { x: j.x, y: j.y }, this._size = [j.width, j.height], this._orient === tde && this._size.reverse();
      }, a.prototype._positionGroup = function() {
        var e2 = this.group, d2 = this._location, y2 = this._orient, x2 = this.dataZoomModel.getFirstTargetAxisModel(), C = x2 && x2.get("inverse"), D2 = this._displayables.sliderGroup, L = (this._dataShadowInfo || {}).otherAxisInverse;
        D2.attr(y2 === yit && !C ? { scaleY: L ? 1 : -1, scaleX: 1 } : y2 === yit && C ? { scaleY: L ? 1 : -1, scaleX: -1 } : y2 === tde && !C ? { scaleY: L ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: L ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
        var F3 = e2.getBoundingRect([D2]);
        e2.x = d2.x - F3.x, e2.y = d2.y - F3.y, e2.markRedraw();
      }, a.prototype._getViewExtent = function() {
        return [0, this._size[0]];
      }, a.prototype._renderBackground = function() {
        var e2 = this.dataZoomModel, d2 = this._size, y2 = this._displayables.sliderGroup, x2 = e2.get("brushSelect");
        y2.add(new vit({ silent: true, shape: { x: 0, y: 0, width: d2[0], height: d2[1] }, style: { fill: e2.get("backgroundColor") }, z2: -40 }));
        var C = new vit({ shape: { x: 0, y: 0, width: d2[0], height: d2[1] }, style: { fill: "transparent" }, z2: 0, onclick: As(this._onClickPanel, this) }), D2 = this.api.getZr();
        x2 ? (C.on("mousedown", this._onBrushStart, this), C.cursor = "crosshair", D2.on("mousemove", this._onBrush), D2.on("mouseup", this._onBrushEnd)) : (D2.off("mousemove", this._onBrush), D2.off("mouseup", this._onBrushEnd)), y2.add(C);
      }, a.prototype._renderDataShadow = function() {
        var e2 = this._dataShadowInfo = this._prepareDataShadowInfo();
        if (this._displayables.dataShadowSegs = [], !e2)
          return;
        var d2 = this._size, y2 = this._shadowSize || [], x2 = e2.series, C = x2.getRawData(), D2 = x2.getShadowDim ? x2.getShadowDim() : e2.otherDim;
        if (D2 == null)
          return;
        var L = this._shadowPolygonPts, F3 = this._shadowPolylinePts;
        if (C !== this._shadowData || D2 !== this._shadowDim || d2[0] !== y2[0] || d2[1] !== y2[1]) {
          var j = C.getDataExtent(D2), U3 = (j[1] - j[0]) * 0.3;
          j = [j[0] - U3, j[1] + U3];
          var Y3 = [0, d2[1]], Q = [0, d2[0]], nt = [[d2[0], 0], [0, 0]], dt = [], vt = Q[1] / (C.count() - 1), Ct = 0, Pt = Math.round(C.count() / d2[0]), jt;
          C.each([D2], function(_e, Me2) {
            if (Pt > 0 && Me2 % Pt) {
              Ct += vt;
              return;
            }
            var Pe2 = _e == null || isNaN(_e) || _e === "", Be2 = Pe2 ? 0 : yp(_e, j, Y3, true);
            Pe2 && !jt && Me2 ? (nt.push([nt[nt.length - 1][0], 0]), dt.push([dt[dt.length - 1][0], 0])) : !Pe2 && jt && (nt.push([Ct, 0]), dt.push([Ct, 0])), nt.push([Ct, Be2]), dt.push([Ct, Be2]), Ct += vt, jt = Pe2;
          }), L = this._shadowPolygonPts = nt, F3 = this._shadowPolylinePts = dt;
        }
        this._shadowData = C, this._shadowDim = D2, this._shadowSize = [d2[0], d2[1]];
        var Rt = this.dataZoomModel;
        function le2(_e) {
          var Me2 = Rt.getModel(_e ? "selectedDataBackground" : "dataBackground"), Pe2 = new ou(), Be2 = new rw({ shape: { points: L }, segmentIgnoreThreshold: 1, style: Me2.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), Je2 = new iw({ shape: { points: F3 }, segmentIgnoreThreshold: 1, style: Me2.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
          return Pe2.add(Be2), Pe2.add(Je2), Pe2;
        }
        for (var ne2 = 0; ne2 < 3; ne2++) {
          var he2 = le2(ne2 === 1);
          this._displayables.sliderGroup.add(he2), this._displayables.dataShadowSegs.push(he2);
        }
      }, a.prototype._prepareDataShadowInfo = function() {
        var e2 = this.dataZoomModel, d2 = e2.get("showDataShadow");
        if (d2 !== false) {
          var y2, x2 = this.ecModel;
          return e2.eachTargetAxis(function(C, D2) {
            var L = e2.getAxisProxy(C, D2).getTargetSeriesModels();
            Ke2(L, function(F3) {
              if (!y2 && !(d2 !== true && oc2(Rpn, F3.get("type")) < 0)) {
                var j = x2.getComponent(cF(C), D2).axis, U3 = Vpn(C), Y3, Q = F3.coordinateSystem;
                U3 != null && Q.getOtherAxis && (Y3 = Q.getOtherAxis(j).inverse), U3 = F3.getData().mapDimension(U3), y2 = { thisAxis: j, series: F3, thisDim: C, otherDim: U3, otherAxisInverse: Y3 };
              }
            }, this);
          }, this), y2;
        }
      }, a.prototype._renderHandle = function() {
        var e2 = this.group, d2 = this._displayables, y2 = d2.handles = [null, null], x2 = d2.handleLabels = [null, null], C = this._displayables.sliderGroup, D2 = this._size, L = this.dataZoomModel, F3 = this.api, j = L.get("borderRadius") || 0, U3 = L.get("brushSelect"), Y3 = d2.filler = new vit({ silent: U3, style: { fill: L.get("fillerColor") }, textConfig: { position: "inside" } });
        C.add(Y3), C.add(new vit({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: D2[0], height: D2[1], r: j }, style: { stroke: L.get("dataBackgroundColor") || L.get("borderColor"), lineWidth: Ppn, fill: "rgba(0,0,0,0)" } })), Ke2([0, 1], function(jt) {
          var Rt = L.get("handleIcon");
          !wyt[Rt] && Rt.indexOf("path://") < 0 && Rt.indexOf("image://") < 0 && (Rt = "path://" + Rt);
          var le2 = qy(Rt, -1, 0, 2, 2, null, true);
          le2.attr({ cursor: ede(this._orient), draggable: true, drift: As(this._onDragMove, this, jt), ondragend: As(this._onDragEnd, this), onmouseover: As(this._showDataInfo, this, true), onmouseout: As(this._showDataInfo, this, false), z2: 5 });
          var ne2 = le2.getBoundingRect(), he2 = L.get("handleSize");
          this._handleHeight = Ko(he2, this._size[1]), this._handleWidth = ne2.width / ne2.height * this._handleHeight, le2.setStyle(L.getModel("handleStyle").getItemStyle()), le2.style.strokeNoScale = true, le2.rectHover = true, le2.ensureState("emphasis").style = L.getModel(["emphasis", "handleStyle"]).getItemStyle(), MO(le2);
          var _e = L.get("handleColor");
          _e != null && (le2.style.fill = _e), C.add(y2[jt] = le2);
          var Me2 = L.getModel("textStyle");
          e2.add(x2[jt] = new qc2({ silent: true, invisible: true, style: _y(Me2, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: Me2.getTextColor(), font: Me2.getFont() }), z2: 10 }));
        }, this);
        var Q = Y3;
        if (U3) {
          var nt = Ko(L.get("moveHandleSize"), D2[1]), dt = d2.moveHandle = new Nf2({ style: L.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: D2[1] - 0.5, height: nt } }), vt = nt * 0.8, Ct = d2.moveHandleIcon = qy(L.get("moveHandleIcon"), -vt / 2, -vt / 2, vt, vt, "#fff", true);
          Ct.silent = true, Ct.y = D2[1] + nt / 2 - 0.5, dt.ensureState("emphasis").style = L.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
          var Pt = Math.min(D2[1] / 2, Math.max(nt, 10));
          Q = d2.moveZone = new Nf2({ invisible: true, shape: { y: D2[1] - Pt, height: nt + Pt } }), Q.on("mouseover", function() {
            F3.enterEmphasis(dt);
          }).on("mouseout", function() {
            F3.leaveEmphasis(dt);
          }), C.add(dt), C.add(Ct), C.add(Q);
        }
        Q.attr({ draggable: true, cursor: ede(this._orient), drift: As(this._onDragMove, this, "all"), ondragstart: As(this._showDataInfo, this, true), ondragend: As(this._onDragEnd, this), onmouseover: As(this._showDataInfo, this, true), onmouseout: As(this._showDataInfo, this, false) });
      }, a.prototype._resetInterval = function() {
        var e2 = this._range = this.dataZoomModel.getPercentRange(), d2 = this._getViewExtent();
        this._handleEnds = [yp(e2[0], [0, 100], d2, true), yp(e2[1], [0, 100], d2, true)];
      }, a.prototype._updateInterval = function(e2, d2) {
        var y2 = this.dataZoomModel, x2 = this._handleEnds, C = this._getViewExtent(), D2 = y2.findRepresentativeAxisProxy().getMinMaxSpan(), L = [0, 100];
        CB(d2, x2, C, y2.get("zoomLock") ? "all" : e2, D2.minSpan != null ? yp(D2.minSpan, L, C, true) : null, D2.maxSpan != null ? yp(D2.maxSpan, L, C, true) : null);
        var F3 = this._range, j = this._range = k_([yp(x2[0], C, L, true), yp(x2[1], C, L, true)]);
        return !F3 || F3[0] !== j[0] || F3[1] !== j[1];
      }, a.prototype._updateView = function(e2) {
        var d2 = this._displayables, y2 = this._handleEnds, x2 = k_(y2.slice()), C = this._size;
        Ke2([0, 1], function(Q) {
          var nt = d2.handles[Q], dt = this._handleHeight;
          nt.attr({ scaleX: dt / 2, scaleY: dt / 2, x: y2[Q] + (Q ? -1 : 1), y: C[1] / 2 - dt / 2 });
        }, this), d2.filler.setShape({ x: x2[0], y: 0, width: x2[1] - x2[0], height: C[1] });
        var D2 = { x: x2[0], width: x2[1] - x2[0] };
        d2.moveHandle && (d2.moveHandle.setShape(D2), d2.moveZone.setShape(D2), d2.moveZone.getBoundingRect(), d2.moveHandleIcon && d2.moveHandleIcon.attr("x", D2.x + D2.width / 2));
        for (var L = d2.dataShadowSegs, F3 = [0, x2[0], x2[1], C[0]], j = 0; j < L.length; j++) {
          var U3 = L[j], Y3 = U3.getClipPath();
          Y3 || (Y3 = new Nf2(), U3.setClipPath(Y3)), Y3.setShape({ x: F3[j], y: 0, width: F3[j + 1] - F3[j], height: C[1] });
        }
        this._updateDataInfo(e2);
      }, a.prototype._updateDataInfo = function(e2) {
        var d2 = this.dataZoomModel, y2 = this._displayables, x2 = y2.handleLabels, C = this._orient, D2 = ["", ""];
        if (d2.get("showDetail")) {
          var L = d2.findRepresentativeAxisProxy();
          if (L) {
            var F3 = L.getAxisModel().axis, j = this._range, U3 = e2 ? L.calculateDataWindow({ start: j[0], end: j[1] }).valueWindow : L.getDataValueWindow();
            D2 = [this._formatLabel(U3[0], F3), this._formatLabel(U3[1], F3)];
          }
        }
        var Y3 = k_(this._handleEnds.slice());
        Q.call(this, 0), Q.call(this, 1);
        function Q(nt) {
          var dt = Eu(y2.handles[nt].parent, this.group), vt = Wu(nt === 0 ? "right" : "left", dt), Ct = this._handleWidth / 2 + Opn, Pt = hc2([Y3[nt] + (nt === 0 ? -Ct : Ct), this._size[1] / 2], dt);
          x2[nt].setStyle({ x: Pt[0], y: Pt[1], verticalAlign: C === yit ? "middle" : vt, align: C === yit ? vt : "center", text: D2[nt] });
        }
      }, a.prototype._formatLabel = function(e2, d2) {
        var y2 = this.dataZoomModel, x2 = y2.get("labelFormatter"), C = y2.get("labelPrecision");
        (C == null || C === "auto") && (C = d2.getPixelPrecision());
        var D2 = e2 == null || isNaN(e2) ? "" : d2.type === "category" || d2.type === "time" ? d2.scale.getLabel({ value: Math.round(e2) }) : e2.toFixed(Math.min(C, 20));
        return wl(x2) ? x2(e2, D2) : ps(x2) ? x2.replace("{value}", D2) : D2;
      }, a.prototype._showDataInfo = function(e2) {
        e2 = this._dragging || e2;
        var d2 = this._displayables, y2 = d2.handleLabels;
        y2[0].attr("invisible", !e2), y2[1].attr("invisible", !e2), d2.moveHandle && this.api[e2 ? "enterEmphasis" : "leaveEmphasis"](d2.moveHandle, 1);
      }, a.prototype._onDragMove = function(e2, d2, y2, x2) {
        this._dragging = true, yE(x2.event);
        var C = this._displayables.sliderGroup.getLocalTransform(), D2 = hc2([d2, y2], C, true), L = this._updateInterval(e2, D2[0]), F3 = this.dataZoomModel.get("realtime");
        this._updateView(!F3), L && F3 && this._dispatchZoomAction(true);
      }, a.prototype._onDragEnd = function() {
        this._dragging = false, this._showDataInfo(false);
        var e2 = this.dataZoomModel.get("realtime");
        !e2 && this._dispatchZoomAction(false);
      }, a.prototype._onClickPanel = function(e2) {
        var d2 = this._size, y2 = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
        if (!(y2[0] < 0 || y2[0] > d2[0] || y2[1] < 0 || y2[1] > d2[1])) {
          var x2 = this._handleEnds, C = (x2[0] + x2[1]) / 2, D2 = this._updateInterval("all", y2[0] - C);
          this._updateView(), D2 && this._dispatchZoomAction(false);
        }
      }, a.prototype._onBrushStart = function(e2) {
        var d2 = e2.offsetX, y2 = e2.offsetY;
        this._brushStart = new Nu(d2, y2), this._brushing = true, this._brushStartTime = +new Date();
      }, a.prototype._onBrushEnd = function(e2) {
        if (this._brushing) {
          var d2 = this._displayables.brushRect;
          if (this._brushing = false, !!d2) {
            d2.attr("ignore", true);
            var y2 = d2.shape, x2 = +new Date();
            if (!(x2 - this._brushStartTime < 200 && Math.abs(y2.width) < 5)) {
              var C = this._getViewExtent(), D2 = [0, 100];
              this._range = k_([yp(y2.x, C, D2, true), yp(y2.x + y2.width, C, D2, true)]), this._handleEnds = [y2.x, y2.x + y2.width], this._updateView(), this._dispatchZoomAction(false);
            }
          }
        }
      }, a.prototype._onBrush = function(e2) {
        this._brushing && (yE(e2.event), this._updateBrushRect(e2.offsetX, e2.offsetY));
      }, a.prototype._updateBrushRect = function(e2, d2) {
        var y2 = this._displayables, x2 = this.dataZoomModel, C = y2.brushRect;
        C || (C = y2.brushRect = new vit({ silent: true, style: x2.getModel("brushStyle").getItemStyle() }), y2.sliderGroup.add(C)), C.attr("ignore", false);
        var D2 = this._brushStart, L = this._displayables.sliderGroup, F3 = L.transformCoordToLocal(e2, d2), j = L.transformCoordToLocal(D2.x, D2.y), U3 = this._size;
        F3[0] = Math.max(Math.min(U3[0], F3[0]), 0), C.setShape({ x: j[0], y: 0, width: F3[0] - j[0], height: U3[1] });
      }, a.prototype._dispatchZoomAction = function(e2) {
        var d2 = this._range;
        this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: e2 ? Npn : null, start: d2[0], end: d2[1] });
      }, a.prototype._findCoordRect = function() {
        var e2, d2 = qhe(this.dataZoomModel).infoList;
        if (!e2 && d2.length) {
          var y2 = d2[0].model.coordinateSystem;
          e2 = y2.getRect && y2.getRect();
        }
        if (!e2) {
          var x2 = this.api.getWidth(), C = this.api.getHeight();
          e2 = { x: x2 * 0.2, y: C * 0.2, width: x2 * 0.6, height: C * 0.6 };
        }
        return e2;
      }, a.type = "dataZoom.slider", a;
    }(rRt);
    function Vpn(l2) {
      var a = { x: "y", y: "x", radius: "angle", angle: "radius" };
      return a[l2];
    }
    function ede(l2) {
      return l2 === "vertical" ? "ns-resize" : "ew-resize";
    }
    var Bpn = Fpn;
    function nde(l2) {
      l2.registerComponentModel(kpn), l2.registerComponentView(Bpn), iRt(l2);
    }
    function zpn(l2) {
      Oc2(Qpe), Oc2(nde);
    }
    var jpn = { get: function(l2, a, e2) {
      var d2 = zl((Wpn[l2] || {})[a]);
      return e2 && Ba2(d2) ? d2[d2.length - 1] : d2;
    } }, Wpn = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, rde = jpn, ide = B_.mapVisual, Gpn = B_.eachVisual, Hpn = Ba2, ade = Ke2, Upn = k_, qpn = yp, Zpn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.stateList = ["inRange", "outOfRange"], e2.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], e2.layoutMode = { type: "box", ignoreSize: true }, e2.dataBound = [-1 / 0, 1 / 0], e2.targetVisuals = {}, e2.controllerVisuals = {}, e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        this.mergeDefaultAndTheme(e2, y2);
      }, a.prototype.optionUpdated = function(e2, d2) {
        var y2 = this.option;
        !d2 && wpe(y2, e2, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
      }, a.prototype.resetVisual = function(e2) {
        var d2 = this.stateList;
        e2 = As(e2, this), this.controllerVisuals = pRt(this.option.controller, d2, e2), this.targetVisuals = pRt(this.option.target, d2, e2);
      }, a.prototype.getItemSymbol = function() {
        return null;
      }, a.prototype.getTargetSeriesIndices = function() {
        var e2 = this.option.seriesIndex, d2 = [];
        return e2 == null || e2 === "all" ? this.ecModel.eachSeries(function(y2, x2) {
          d2.push(x2);
        }) : d2 = Mp(e2), d2;
      }, a.prototype.eachTargetSeries = function(e2, d2) {
        Ke2(this.getTargetSeriesIndices(), function(y2) {
          var x2 = this.ecModel.getSeriesByIndex(y2);
          x2 && e2.call(d2, x2);
        }, this);
      }, a.prototype.isTargetSeries = function(e2) {
        var d2 = false;
        return this.eachTargetSeries(function(y2) {
          y2 === e2 && (d2 = true);
        }), d2;
      }, a.prototype.formatValueText = function(e2, d2, y2) {
        var x2 = this.option, C = x2.precision, D2 = this.dataBound, L = x2.formatter, F3;
        y2 = y2 || ["<", ">"], Ba2(e2) && (e2 = e2.slice(), F3 = true);
        var j = d2 ? e2 : F3 ? [U3(e2[0]), U3(e2[1])] : U3(e2);
        if (ps(L))
          return L.replace("{value}", F3 ? j[0] : j).replace("{value2}", F3 ? j[1] : j);
        if (wl(L))
          return F3 ? L(e2[0], e2[1]) : L(e2);
        if (F3)
          return e2[0] === D2[0] ? y2[0] + " " + j[1] : e2[1] === D2[1] ? y2[1] + " " + j[0] : j[0] + " - " + j[1];
        return j;
        function U3(Y3) {
          return Y3 === D2[0] ? "min" : Y3 === D2[1] ? "max" : (+Y3).toFixed(Math.min(C, 20));
        }
      }, a.prototype.resetExtent = function() {
        var e2 = this.option, d2 = Upn([e2.min, e2.max]);
        this._dataExtent = d2;
      }, a.prototype.getDataDimensionIndex = function(e2) {
        var d2 = this.option.dimension;
        if (d2 != null)
          return e2.getDimensionIndex(d2);
        for (var y2 = e2.dimensions, x2 = y2.length - 1; x2 >= 0; x2--) {
          var C = y2[x2], D2 = e2.getDimensionInfo(C);
          if (!D2.isCalculationCoord)
            return D2.storeDimIndex;
        }
      }, a.prototype.getExtent = function() {
        return this._dataExtent.slice();
      }, a.prototype.completeVisualOption = function() {
        var e2 = this.ecModel, d2 = this.option, y2 = { inRange: d2.inRange, outOfRange: d2.outOfRange }, x2 = d2.target || (d2.target = {}), C = d2.controller || (d2.controller = {});
        Mu(x2, y2), Mu(C, y2);
        var D2 = this.isCategory();
        L.call(this, x2), L.call(this, C), F3.call(this, x2, "inRange", "outOfRange"), j.call(this, C);
        function L(U3) {
          Hpn(d2.color) && !U3.inRange && (U3.inRange = { color: d2.color.slice().reverse() }), U3.inRange = U3.inRange || { color: e2.get("gradientColor") };
        }
        function F3(U3, Y3, Q) {
          var nt = U3[Y3], dt = U3[Q];
          nt && !dt && (dt = U3[Q] = {}, ade(nt, function(vt, Ct) {
            if (B_.isValidType(Ct)) {
              var Pt = rde.get(Ct, "inactive", D2);
              Pt != null && (dt[Ct] = Pt, Ct === "color" && !dt.hasOwnProperty("opacity") && !dt.hasOwnProperty("colorAlpha") && (dt.opacity = [0, 0]));
            }
          }));
        }
        function j(U3) {
          var Y3 = (U3.inRange || {}).symbol || (U3.outOfRange || {}).symbol, Q = (U3.inRange || {}).symbolSize || (U3.outOfRange || {}).symbolSize, nt = this.get("inactiveColor"), dt = this.getItemSymbol(), vt = dt || "roundRect";
          ade(this.stateList, function(Ct) {
            var Pt = this.itemSize, jt = U3[Ct];
            jt || (jt = U3[Ct] = { color: D2 ? nt : [nt] }), jt.symbol == null && (jt.symbol = Y3 && zl(Y3) || (D2 ? vt : [vt])), jt.symbolSize == null && (jt.symbolSize = Q && zl(Q) || (D2 ? Pt[0] : [Pt[0], Pt[0]])), jt.symbol = ide(jt.symbol, function(ne2) {
              return ne2 === "none" ? vt : ne2;
            });
            var Rt = jt.symbolSize;
            if (Rt != null) {
              var le2 = -1 / 0;
              Gpn(Rt, function(ne2) {
                ne2 > le2 && (le2 = ne2);
              }), jt.symbolSize = ide(Rt, function(ne2) {
                return qpn(ne2, [0, le2], [0, Pt[0]], true);
              });
            }
          }, this);
        }
      }, a.prototype.resetItemSize = function() {
        this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
      }, a.prototype.isCategory = function() {
        return !!this.option.categories;
      }, a.prototype.setSelected = function(e2) {
      }, a.prototype.getSelected = function() {
        return null;
      }, a.prototype.getValueState = function(e2) {
        return null;
      }, a.prototype.getVisualMeta = function(e2) {
        return null;
      }, a.type = "visualMap", a.dependencies = ["series"], a.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, a;
    }(Ah2), Umt = Zpn, ode = [20, 140], $pn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.optionUpdated = function(e2, d2) {
        l2.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(y2) {
          y2.mappingMethod = "linear", y2.dataExtent = this.getExtent();
        }), this._resetRange();
      }, a.prototype.resetItemSize = function() {
        l2.prototype.resetItemSize.apply(this, arguments);
        var e2 = this.itemSize;
        (e2[0] == null || isNaN(e2[0])) && (e2[0] = ode[0]), (e2[1] == null || isNaN(e2[1])) && (e2[1] = ode[1]);
      }, a.prototype._resetRange = function() {
        var e2 = this.getExtent(), d2 = this.option.range;
        !d2 || d2.auto ? (e2.auto = 1, this.option.range = e2) : Ba2(d2) && (d2[0] > d2[1] && d2.reverse(), d2[0] = Math.max(d2[0], e2[0]), d2[1] = Math.min(d2[1], e2[1]));
      }, a.prototype.completeVisualOption = function() {
        l2.prototype.completeVisualOption.apply(this, arguments), Ke2(this.stateList, function(e2) {
          var d2 = this.option.controller[e2].symbolSize;
          d2 && d2[0] !== d2[1] && (d2[0] = d2[1] / 3);
        }, this);
      }, a.prototype.setSelected = function(e2) {
        this.option.range = e2.slice(), this._resetRange();
      }, a.prototype.getSelected = function() {
        var e2 = this.getExtent(), d2 = k_((this.get("range") || []).slice());
        return d2[0] > e2[1] && (d2[0] = e2[1]), d2[1] > e2[1] && (d2[1] = e2[1]), d2[0] < e2[0] && (d2[0] = e2[0]), d2[1] < e2[0] && (d2[1] = e2[0]), d2;
      }, a.prototype.getValueState = function(e2) {
        var d2 = this.option.range, y2 = this.getExtent();
        return (d2[0] <= y2[0] || d2[0] <= e2) && (d2[1] >= y2[1] || e2 <= d2[1]) ? "inRange" : "outOfRange";
      }, a.prototype.findTargetDataIndices = function(e2) {
        var d2 = [];
        return this.eachTargetSeries(function(y2) {
          var x2 = [], C = y2.getData();
          C.each(this.getDataDimensionIndex(C), function(D2, L) {
            e2[0] <= D2 && D2 <= e2[1] && x2.push(L);
          }, this), d2.push({ seriesId: y2.id, dataIndex: x2 });
        }, this), d2;
      }, a.prototype.getVisualMeta = function(e2) {
        var d2 = sde(this, "outOfRange", this.getExtent()), y2 = sde(this, "inRange", this.option.range.slice()), x2 = [];
        function C(Q, nt) {
          x2.push({ value: Q, color: e2(Q, nt) });
        }
        for (var D2 = 0, L = 0, F3 = y2.length, j = d2.length; L < j && (!y2.length || d2[L] <= y2[0]); L++)
          d2[L] < y2[D2] && C(d2[L], "outOfRange");
        for (var U3 = 1; D2 < F3; D2++, U3 = 0)
          U3 && x2.length && C(y2[D2], "outOfRange"), C(y2[D2], "inRange");
        for (var U3 = 1; L < j; L++)
          (!y2.length || y2[y2.length - 1] < d2[L]) && (U3 && (x2.length && C(x2[x2.length - 1].value, "outOfRange"), U3 = 0), C(d2[L], "outOfRange"));
        var Y3 = x2.length;
        return { stops: x2, outerColors: [Y3 ? x2[0].color : "transparent", Y3 ? x2[Y3 - 1].color : "transparent"] };
      }, a.type = "visualMap.continuous", a.defaultOption = ZN(Umt.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), a;
    }(Umt);
    function sde(l2, a, e2) {
      if (e2[0] === e2[1])
        return e2.slice();
      for (var d2 = 200, y2 = (e2[1] - e2[0]) / d2, x2 = e2[0], C = [], D2 = 0; D2 <= d2 && x2 < e2[1]; D2++)
        C.push(x2), x2 += y2;
      return C.push(e2[1]), C;
    }
    var Ypn = $pn, Kpn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, e2;
      }
      return a.prototype.init = function(e2, d2) {
        this.ecModel = e2, this.api = d2;
      }, a.prototype.render = function(e2, d2, y2, x2) {
        if (this.visualMapModel = e2, e2.get("show") === false) {
          this.group.removeAll();
          return;
        }
        this.doRender(e2, d2, y2, x2);
      }, a.prototype.renderBackground = function(e2) {
        var d2 = this.visualMapModel, y2 = Gq(d2.get("padding") || 0), x2 = e2.getBoundingRect();
        e2.add(new Nf2({ z2: -1, silent: true, shape: { x: x2.x - y2[3], y: x2.y - y2[0], width: x2.width + y2[3] + y2[1], height: x2.height + y2[0] + y2[2] }, style: { fill: d2.get("backgroundColor"), stroke: d2.get("borderColor"), lineWidth: d2.get("borderWidth") } }));
      }, a.prototype.getControllerVisual = function(e2, d2, y2) {
        y2 = y2 || {};
        var x2 = y2.forceState, C = this.visualMapModel, D2 = {};
        if (d2 === "color") {
          var L = C.get("contentColor");
          D2.color = L;
        }
        function F3(Q) {
          return D2[Q];
        }
        function j(Q, nt) {
          D2[Q] = nt;
        }
        var U3 = C.controllerVisuals[x2 || C.getValueState(e2)], Y3 = B_.prepareVisualTypes(U3);
        return Ke2(Y3, function(Q) {
          var nt = U3[Q];
          y2.convertOpacityToAlpha && Q === "opacity" && (Q = "colorAlpha", nt = U3.__alphaForOpacity), B_.dependsOn(Q, d2) && nt && nt.applyVisual(e2, F3, j);
        }), D2[d2];
      }, a.prototype.positionGroup = function(e2) {
        var d2 = this.visualMapModel, y2 = this.api;
        cyt(e2, d2.getBoxLayoutParams(), { width: y2.getWidth(), height: y2.getHeight() });
      }, a.prototype.doRender = function(e2, d2, y2, x2) {
      }, a.type = "visualMap", a;
    }(_0), lde = Kpn, ude = [["left", "right", "width"], ["top", "bottom", "height"]];
    function cde(l2, a, e2) {
      var d2 = l2.option, y2 = d2.align;
      if (y2 != null && y2 !== "auto")
        return y2;
      for (var x2 = { width: a.getWidth(), height: a.getHeight() }, C = d2.orient === "horizontal" ? 1 : 0, D2 = ude[C], L = [0, null, 10], F3 = {}, j = 0; j < 3; j++)
        F3[ude[1 - C][j]] = L[j], F3[D2[j]] = j === 2 ? e2[0] : d2[D2[j]];
      var U3 = [["x", "width", 3], ["y", "height", 0]][C], Y3 = Em(F3, x2, d2.padding);
      return D2[(Y3.margin[U3[2]] || 0) + Y3[U3[0]] + Y3[U3[1]] * 0.5 < x2[U3[1]] * 0.5 ? 0 : 1];
    }
    function qmt(l2, a) {
      return Ke2(l2 || [], function(e2) {
        e2.dataIndex != null && (e2.dataIndexInside = e2.dataIndex, e2.dataIndex = null), e2.highlightKey = "visualMap" + (a ? a.componentIndex : "");
      }), l2;
    }
    var pP = yp, Xpn = Ke2, fde = Math.min, LRt = Math.max, Qpn = 12, Jpn = 6, tdn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._shapes = {}, e2._dataInterval = [], e2._handleEnds = [], e2._hoverLinkDataIndices = [], e2;
      }
      return a.prototype.doRender = function(e2, d2, y2, x2) {
        this._api = y2, (!x2 || x2.type !== "selectDataRange" || x2.from !== this.uid) && this._buildView();
      }, a.prototype._buildView = function() {
        this.group.removeAll();
        var e2 = this.visualMapModel, d2 = this.group;
        this._orient = e2.get("orient"), this._useHandle = e2.get("calculable"), this._resetInterval(), this._renderBar(d2);
        var y2 = e2.get("text");
        this._renderEndsText(d2, y2, 0), this._renderEndsText(d2, y2, 1), this._updateView(true), this.renderBackground(d2), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(d2);
      }, a.prototype._renderEndsText = function(e2, d2, y2) {
        if (d2) {
          var x2 = d2[1 - y2];
          x2 = x2 != null ? x2 + "" : "";
          var C = this.visualMapModel, D2 = C.get("textGap"), L = C.itemSize, F3 = this._shapes.mainGroup, j = this._applyTransform([L[0] / 2, y2 === 0 ? -D2 : L[1] + D2], F3), U3 = this._applyTransform(y2 === 0 ? "bottom" : "top", F3), Y3 = this._orient, Q = this.visualMapModel.textStyleModel;
          this.group.add(new qc2({ style: { x: j[0], y: j[1], verticalAlign: Y3 === "horizontal" ? "middle" : U3, align: Y3 === "horizontal" ? U3 : "center", text: x2, font: Q.getFont(), fill: Q.getTextColor() } }));
        }
      }, a.prototype._renderBar = function(e2) {
        var d2 = this.visualMapModel, y2 = this._shapes, x2 = d2.itemSize, C = this._orient, D2 = this._useHandle, L = cde(d2, this.api, x2), F3 = y2.mainGroup = this._createBarGroup(L), j = new ou();
        F3.add(j), j.add(y2.outOfRange = hde()), j.add(y2.inRange = hde(null, D2 ? dde(this._orient) : null, As(this._dragHandle, this, "all", false), As(this._dragHandle, this, "all", true))), j.setClipPath(new Nf2({ shape: { x: 0, y: 0, width: x2[0], height: x2[1], r: 3 } }));
        var U3 = d2.textStyleModel.getTextRect("\u56FD"), Y3 = LRt(U3.width, U3.height);
        D2 && (y2.handleThumbs = [], y2.handleLabels = [], y2.handleLabelPoints = [], this._createHandle(d2, F3, 0, x2, Y3, C), this._createHandle(d2, F3, 1, x2, Y3, C)), this._createIndicator(d2, F3, x2, Y3, C), e2.add(F3);
      }, a.prototype._createHandle = function(e2, d2, y2, x2, C, D2) {
        var L = As(this._dragHandle, this, y2, false), F3 = As(this._dragHandle, this, y2, true), j = Tm(e2.get("handleSize"), x2[0]), U3 = qy(e2.get("handleIcon"), -j / 2, -j / 2, j, j, null, true), Y3 = dde(this._orient);
        U3.attr({ cursor: Y3, draggable: true, drift: L, ondragend: F3, onmousemove: function(Ct) {
          yE(Ct.event);
        } }), U3.x = x2[0] / 2, U3.useStyle(e2.getModel("handleStyle").getItemStyle()), U3.setStyle({ strokeNoScale: true, strokeFirst: true }), U3.style.lineWidth *= 2, U3.ensureState("emphasis").style = e2.getModel(["emphasis", "handleStyle"]).getItemStyle(), CO(U3, true), d2.add(U3);
        var Q = this.visualMapModel.textStyleModel, nt = new qc2({ cursor: Y3, draggable: true, drift: L, onmousemove: function(Ct) {
          yE(Ct.event);
        }, ondragend: F3, style: { x: 0, y: 0, text: "", font: Q.getFont(), fill: Q.getTextColor() } });
        nt.ensureState("blur").style = { opacity: 0.1 }, nt.stateTransition = { duration: 200 }, this.group.add(nt);
        var dt = [j, 0], vt = this._shapes;
        vt.handleThumbs[y2] = U3, vt.handleLabelPoints[y2] = dt, vt.handleLabels[y2] = nt;
      }, a.prototype._createIndicator = function(e2, d2, y2, x2, C) {
        var D2 = Tm(e2.get("indicatorSize"), y2[0]), L = qy(e2.get("indicatorIcon"), -D2 / 2, -D2 / 2, D2, D2, null, true);
        L.attr({ cursor: "move", invisible: true, silent: true, x: y2[0] / 2 });
        var F3 = e2.getModel("indicatorStyle").getItemStyle();
        if (L instanceof Im) {
          var j = L.style;
          L.useStyle(la2({ image: j.image, x: j.x, y: j.y, width: j.width, height: j.height }, F3));
        } else
          L.useStyle(F3);
        d2.add(L);
        var U3 = this.visualMapModel.textStyleModel, Y3 = new qc2({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: U3.getFont(), fill: U3.getTextColor() } });
        this.group.add(Y3);
        var Q = [(C === "horizontal" ? x2 / 2 : Jpn) + y2[0] / 2, 0], nt = this._shapes;
        nt.indicator = L, nt.indicatorLabel = Y3, nt.indicatorLabelPoint = Q, this._firstShowIndicator = true;
      }, a.prototype._dragHandle = function(e2, d2, y2, x2) {
        if (this._useHandle) {
          if (this._dragging = !d2, !d2) {
            var C = this._applyTransform([y2, x2], this._shapes.mainGroup, true);
            this._updateInterval(e2, C[1]), this._hideIndicator(), this._updateView();
          }
          d2 === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), d2 ? !this._hovering && this._clearHoverLinkToSeries() : pde(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[e2], false);
        }
      }, a.prototype._resetInterval = function() {
        var e2 = this.visualMapModel, d2 = this._dataInterval = e2.getSelected(), y2 = e2.getExtent(), x2 = [0, e2.itemSize[1]];
        this._handleEnds = [pP(d2[0], y2, x2, true), pP(d2[1], y2, x2, true)];
      }, a.prototype._updateInterval = function(e2, d2) {
        d2 = d2 || 0;
        var y2 = this.visualMapModel, x2 = this._handleEnds, C = [0, y2.itemSize[1]];
        CB(d2, x2, C, e2, 0);
        var D2 = y2.getExtent();
        this._dataInterval = [pP(x2[0], C, D2, true), pP(x2[1], C, D2, true)];
      }, a.prototype._updateView = function(e2) {
        var d2 = this.visualMapModel, y2 = d2.getExtent(), x2 = this._shapes, C = [0, d2.itemSize[1]], D2 = e2 ? C : this._handleEnds, L = this._createBarVisual(this._dataInterval, y2, D2, "inRange"), F3 = this._createBarVisual(y2, y2, C, "outOfRange");
        x2.inRange.setStyle({ fill: L.barColor }).setShape("points", L.barPoints), x2.outOfRange.setStyle({ fill: F3.barColor }).setShape("points", F3.barPoints), this._updateHandle(D2, L);
      }, a.prototype._createBarVisual = function(e2, d2, y2, x2) {
        var C = { forceState: x2, convertOpacityToAlpha: true }, D2 = this._makeColorGradient(e2, C), L = [this.getControllerVisual(e2[0], "symbolSize", C), this.getControllerVisual(e2[1], "symbolSize", C)], F3 = this._createBarPoints(y2, L);
        return { barColor: new QV(0, 0, 0, 1, D2), barPoints: F3, handlesColor: [D2[0].color, D2[D2.length - 1].color] };
      }, a.prototype._makeColorGradient = function(e2, d2) {
        var y2 = 100, x2 = [], C = (e2[1] - e2[0]) / y2;
        x2.push({ color: this.getControllerVisual(e2[0], "color", d2), offset: 0 });
        for (var D2 = 1; D2 < y2; D2++) {
          var L = e2[0] + C * D2;
          if (L > e2[1])
            break;
          x2.push({ color: this.getControllerVisual(L, "color", d2), offset: D2 / y2 });
        }
        return x2.push({ color: this.getControllerVisual(e2[1], "color", d2), offset: 1 }), x2;
      }, a.prototype._createBarPoints = function(e2, d2) {
        var y2 = this.visualMapModel.itemSize;
        return [[y2[0] - d2[0], e2[0]], [y2[0], e2[0]], [y2[0], e2[1]], [y2[0] - d2[1], e2[1]]];
      }, a.prototype._createBarGroup = function(e2) {
        var d2 = this._orient, y2 = this.visualMapModel.get("inverse");
        return new ou(d2 === "horizontal" && !y2 ? { scaleX: e2 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : d2 === "horizontal" && y2 ? { scaleX: e2 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : d2 === "vertical" && !y2 ? { scaleX: e2 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: e2 === "left" ? 1 : -1 });
      }, a.prototype._updateHandle = function(e2, d2) {
        if (this._useHandle) {
          var y2 = this._shapes, x2 = this.visualMapModel, C = y2.handleThumbs, D2 = y2.handleLabels, L = x2.itemSize, F3 = x2.getExtent();
          Xpn([0, 1], function(j) {
            var U3 = C[j];
            U3.setStyle("fill", d2.handlesColor[j]), U3.y = e2[j];
            var Y3 = pP(e2[j], [0, L[1]], F3, true), Q = this.getControllerVisual(Y3, "symbolSize");
            U3.scaleX = U3.scaleY = Q / L[0], U3.x = L[0] - Q / 2;
            var nt = hc2(y2.handleLabelPoints[j], Eu(U3, this.group));
            D2[j].setStyle({ x: nt[0], y: nt[1], text: x2.formatValueText(this._dataInterval[j]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", y2.mainGroup) : "center" });
          }, this);
        }
      }, a.prototype._showIndicator = function(e2, d2, y2, x2) {
        var C = this.visualMapModel, D2 = C.getExtent(), L = C.itemSize, F3 = [0, L[1]], j = this._shapes, U3 = j.indicator;
        if (U3) {
          U3.attr("invisible", false);
          var Y3 = { convertOpacityToAlpha: true }, Q = this.getControllerVisual(e2, "color", Y3), nt = this.getControllerVisual(e2, "symbolSize"), dt = pP(e2, D2, F3, true), vt = L[0] - nt / 2, Ct = { x: U3.x, y: U3.y };
          U3.y = dt, U3.x = vt;
          var Pt = hc2(j.indicatorLabelPoint, Eu(U3, this.group)), jt = j.indicatorLabel;
          jt.attr("invisible", false);
          var Rt = this._applyTransform("left", j.mainGroup), le2 = this._orient, ne2 = le2 === "horizontal";
          jt.setStyle({ text: (y2 || "") + C.formatValueText(d2), verticalAlign: ne2 ? Rt : "middle", align: ne2 ? "center" : Rt });
          var he2 = { x: vt, y: dt, style: { fill: Q } }, _e = { style: { x: Pt[0], y: Pt[1] } };
          if (C.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
            var Me2 = { duration: 100, easing: "cubicInOut", additive: true };
            U3.x = Ct.x, U3.y = Ct.y, U3.animateTo(he2, Me2), jt.animateTo(_e, Me2);
          } else
            U3.attr(he2), jt.attr(_e);
          this._firstShowIndicator = false;
          var Pe2 = this._shapes.handleLabels;
          if (Pe2)
            for (var Be2 = 0; Be2 < Pe2.length; Be2++)
              this._api.enterBlur(Pe2[Be2]);
        }
      }, a.prototype._enableHoverLinkToSeries = function() {
        var e2 = this;
        this._shapes.mainGroup.on("mousemove", function(d2) {
          if (e2._hovering = true, !e2._dragging) {
            var y2 = e2.visualMapModel.itemSize, x2 = e2._applyTransform([d2.offsetX, d2.offsetY], e2._shapes.mainGroup, true, true);
            x2[1] = fde(LRt(0, x2[1]), y2[1]), e2._doHoverLinkToSeries(x2[1], 0 <= x2[0] && x2[0] <= y2[0]);
          }
        }).on("mouseout", function() {
          e2._hovering = false, !e2._dragging && e2._clearHoverLinkToSeries();
        });
      }, a.prototype._enableHoverLinkFromSeries = function() {
        var e2 = this.api.getZr();
        this.visualMapModel.option.hoverLink ? (e2.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), e2.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
      }, a.prototype._doHoverLinkToSeries = function(e2, d2) {
        var y2 = this.visualMapModel, x2 = y2.itemSize;
        if (y2.option.hoverLink) {
          var C = [0, x2[1]], D2 = y2.getExtent();
          e2 = fde(LRt(C[0], e2), C[1]);
          var L = edn(y2, D2, C), F3 = [e2 - L, e2 + L], j = pP(e2, C, D2, true), U3 = [pP(F3[0], C, D2, true), pP(F3[1], C, D2, true)];
          F3[0] < C[0] && (U3[0] = -1 / 0), F3[1] > C[1] && (U3[1] = 1 / 0), d2 && (U3[0] === -1 / 0 ? this._showIndicator(j, U3[1], "< ", L) : U3[1] === 1 / 0 ? this._showIndicator(j, U3[0], "> ", L) : this._showIndicator(j, j, "\u2248 ", L));
          var Y3 = this._hoverLinkDataIndices, Q = [];
          (d2 || pde(y2)) && (Q = this._hoverLinkDataIndices = y2.findTargetDataIndices(U3));
          var nt = $5t(Y3, Q);
          this._dispatchHighDown("downplay", qmt(nt[0], y2)), this._dispatchHighDown("highlight", qmt(nt[1], y2));
        }
      }, a.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
        var d2 = e2.target, y2 = this.visualMapModel;
        if (!(!d2 || ns(d2).dataIndex == null)) {
          var x2 = ns(d2), C = this.ecModel.getSeriesByIndex(x2.seriesIndex);
          if (y2.isTargetSeries(C)) {
            var D2 = C.getData(x2.dataType), L = D2.getStore().get(y2.getDataDimensionIndex(D2), x2.dataIndex);
            isNaN(L) || this._showIndicator(L, L);
          }
        }
      }, a.prototype._hideIndicator = function() {
        var e2 = this._shapes;
        e2.indicator && e2.indicator.attr("invisible", true), e2.indicatorLabel && e2.indicatorLabel.attr("invisible", true);
        var d2 = this._shapes.handleLabels;
        if (d2)
          for (var y2 = 0; y2 < d2.length; y2++)
            this._api.leaveBlur(d2[y2]);
      }, a.prototype._clearHoverLinkToSeries = function() {
        this._hideIndicator();
        var e2 = this._hoverLinkDataIndices;
        this._dispatchHighDown("downplay", qmt(e2, this.visualMapModel)), e2.length = 0;
      }, a.prototype._clearHoverLinkFromSeries = function() {
        this._hideIndicator();
        var e2 = this.api.getZr();
        e2.off("mouseover", this._hoverLinkFromSeriesMouseOver), e2.off("mouseout", this._hideIndicator);
      }, a.prototype._applyTransform = function(e2, d2, y2, x2) {
        var C = Eu(d2, x2 ? null : this.group);
        return Ba2(e2) ? hc2(e2, C, y2) : Wu(e2, C, y2);
      }, a.prototype._dispatchHighDown = function(e2, d2) {
        d2 && d2.length && this.api.dispatchAction({ type: e2, batch: d2 });
      }, a.prototype.dispose = function() {
        this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
      }, a.prototype.remove = function() {
        this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
      }, a.type = "visualMap.continuous", a;
    }(lde);
    function hde(l2, a, e2, d2) {
      return new rw({ shape: { points: l2 }, draggable: !!e2, cursor: a, drift: e2, onmousemove: function(y2) {
        yE(y2.event);
      }, ondragend: d2 });
    }
    function edn(l2, a, e2) {
      var d2 = Qpn / 2, y2 = l2.get("hoverLinkDataSize");
      return y2 && (d2 = pP(y2, a, e2, true) / 2), d2;
    }
    function pde(l2) {
      var a = l2.get("hoverLinkOnHandle");
      return !!(a == null ? l2.get("realtime") : a);
    }
    function dde(l2) {
      return l2 === "vertical" ? "ns-resize" : "ew-resize";
    }
    var ndn = tdn, rdn = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, idn = function(l2, a) {
      a.eachComponent({ mainType: "visualMap", query: l2 }, function(e2) {
        e2.setSelected(l2.selected);
      });
    }, adn = [{ createOnAllSeries: true, reset: function(l2, a) {
      var e2 = [];
      return a.eachComponent("visualMap", function(d2) {
        var y2 = l2.pipelineContext;
        !d2.isTargetSeries(l2) || y2 && y2.large || e2.push(Jfn(d2.stateList, d2.targetVisuals, As(d2.getValueState, d2), d2.getDataDimensionIndex(l2.getData())));
      }), e2;
    } }, { createOnAllSeries: true, reset: function(l2, a) {
      var e2 = l2.getData(), d2 = [];
      a.eachComponent("visualMap", function(y2) {
        if (y2.isTargetSeries(l2)) {
          var x2 = y2.getVisualMeta(As(odn, null, l2, y2)) || { stops: [], outerColors: [] }, C = y2.getDataDimensionIndex(e2);
          C >= 0 && (x2.dimension = C, d2.push(x2));
        }
      }), l2.getData().setVisual("visualMeta", d2);
    } }];
    function odn(l2, a, e2, d2) {
      for (var y2 = a.targetVisuals[d2], x2 = B_.prepareVisualTypes(y2), C = { color: mrt(l2.getData(), "color") }, D2 = 0, L = x2.length; D2 < L; D2++) {
        var F3 = x2[D2], j = y2[F3 === "opacity" ? "__alphaForOpacity" : F3];
        j && j.applyVisual(e2, U3, Y3);
      }
      return C.color;
      function U3(Q) {
        return C[Q];
      }
      function Y3(Q, nt) {
        C[Q] = nt;
      }
    }
    var gde = Ke2;
    function sdn(l2) {
      var a = l2 && l2.visualMap;
      Ba2(a) || (a = a ? [a] : []), gde(a, function(e2) {
        if (e2) {
          wZ(e2, "splitList") && !wZ(e2, "pieces") && (e2.pieces = e2.splitList, delete e2.splitList);
          var d2 = e2.pieces;
          d2 && Ba2(d2) && gde(d2, function(y2) {
            vs(y2) && (wZ(y2, "start") && !wZ(y2, "min") && (y2.min = y2.start), wZ(y2, "end") && !wZ(y2, "max") && (y2.max = y2.end));
          });
        }
      });
    }
    function wZ(l2, a) {
      return l2 && l2.hasOwnProperty && l2.hasOwnProperty(a);
    }
    var vde = false;
    function yde(l2) {
      vde || (vde = true, l2.registerSubTypeDefaulter("visualMap", function(a) {
        return !a.categories && (!(a.pieces ? a.pieces.length > 0 : a.splitNumber > 0) || a.calculable) ? "continuous" : "piecewise";
      }), l2.registerAction(rdn, idn), Ke2(adn, function(a) {
        l2.registerVisual(l2.PRIORITY.VISUAL.COMPONENT, a);
      }), l2.registerPreprocessor(sdn));
    }
    function mde(l2) {
      l2.registerComponentModel(Ypn), l2.registerComponentView(ndn), yde(l2);
    }
    var ldn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2._pieceList = [], e2;
      }
      return a.prototype.optionUpdated = function(e2, d2) {
        l2.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
        var y2 = this._mode = this._determineMode();
        this._pieceList = [], udn[this._mode].call(this, this._pieceList), this._resetSelected(e2, d2);
        var x2 = this.option.categories;
        this.resetVisual(function(C, D2) {
          y2 === "categories" ? (C.mappingMethod = "category", C.categories = zl(x2)) : (C.dataExtent = this.getExtent(), C.mappingMethod = "piecewise", C.pieceList = $a2(this._pieceList, function(L) {
            return L = zl(L), D2 !== "inRange" && (L.visual = null), L;
          }));
        });
      }, a.prototype.completeVisualOption = function() {
        var e2 = this.option, d2 = {}, y2 = B_.listVisualTypes(), x2 = this.isCategory();
        Ke2(e2.pieces, function(D2) {
          Ke2(y2, function(L) {
            D2.hasOwnProperty(L) && (d2[L] = 1);
          });
        }), Ke2(d2, function(D2, L) {
          var F3 = false;
          Ke2(this.stateList, function(j) {
            F3 = F3 || C(e2, j, L) || C(e2.target, j, L);
          }, this), !F3 && Ke2(this.stateList, function(j) {
            (e2[j] || (e2[j] = {}))[L] = rde.get(L, j === "inRange" ? "active" : "inactive", x2);
          });
        }, this);
        function C(D2, L, F3) {
          return D2 && D2[L] && D2[L].hasOwnProperty(F3);
        }
        l2.prototype.completeVisualOption.apply(this, arguments);
      }, a.prototype._resetSelected = function(e2, d2) {
        var y2 = this.option, x2 = this._pieceList, C = (d2 ? y2 : e2).selected || {};
        if (y2.selected = C, Ke2(x2, function(L, F3) {
          var j = this.getSelectedMapKey(L);
          C.hasOwnProperty(j) || (C[j] = true);
        }, this), y2.selectedMode === "single") {
          var D2 = false;
          Ke2(x2, function(L, F3) {
            var j = this.getSelectedMapKey(L);
            C[j] && (D2 ? C[j] = false : D2 = true);
          }, this);
        }
      }, a.prototype.getItemSymbol = function() {
        return this.get("itemSymbol");
      }, a.prototype.getSelectedMapKey = function(e2) {
        return this._mode === "categories" ? e2.value + "" : e2.index + "";
      }, a.prototype.getPieceList = function() {
        return this._pieceList;
      }, a.prototype._determineMode = function() {
        var e2 = this.option;
        return e2.pieces && e2.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
      }, a.prototype.setSelected = function(e2) {
        this.option.selected = zl(e2);
      }, a.prototype.getValueState = function(e2) {
        var d2 = B_.findPieceIndex(e2, this._pieceList);
        return d2 != null && this.option.selected[this.getSelectedMapKey(this._pieceList[d2])] ? "inRange" : "outOfRange";
      }, a.prototype.findTargetDataIndices = function(e2) {
        var d2 = [], y2 = this._pieceList;
        return this.eachTargetSeries(function(x2) {
          var C = [], D2 = x2.getData();
          D2.each(this.getDataDimensionIndex(D2), function(L, F3) {
            var j = B_.findPieceIndex(L, y2);
            j === e2 && C.push(F3);
          }, this), d2.push({ seriesId: x2.id, dataIndex: C });
        }, this), d2;
      }, a.prototype.getRepresentValue = function(e2) {
        var d2;
        if (this.isCategory())
          d2 = e2.value;
        else if (e2.value != null)
          d2 = e2.value;
        else {
          var y2 = e2.interval || [];
          d2 = y2[0] === -1 / 0 && y2[1] === 1 / 0 ? 0 : (y2[0] + y2[1]) / 2;
        }
        return d2;
      }, a.prototype.getVisualMeta = function(e2) {
        if (this.isCategory())
          return;
        var d2 = [], y2 = ["", ""], x2 = this;
        function C(j, U3) {
          var Y3 = x2.getRepresentValue({ interval: j });
          U3 || (U3 = x2.getValueState(Y3));
          var Q = e2(Y3, U3);
          j[0] === -1 / 0 ? y2[0] = Q : j[1] === 1 / 0 ? y2[1] = Q : d2.push({ value: j[0], color: Q }, { value: j[1], color: Q });
        }
        var D2 = this._pieceList.slice();
        if (!D2.length)
          D2.push({ interval: [-1 / 0, 1 / 0] });
        else {
          var L = D2[0].interval[0];
          L !== -1 / 0 && D2.unshift({ interval: [-1 / 0, L] }), L = D2[D2.length - 1].interval[1], L !== 1 / 0 && D2.push({ interval: [L, 1 / 0] });
        }
        var F3 = -1 / 0;
        return Ke2(D2, function(j) {
          var U3 = j.interval;
          U3 && (U3[0] > F3 && C([F3, U3[0]], "outOfRange"), C(U3.slice()), F3 = U3[1]);
        }, this), { stops: d2, outerColors: y2 };
      }, a.type = "visualMap.piecewise", a.defaultOption = ZN(Umt.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), a;
    }(Umt), udn = { splitNumber: function(l2) {
      var a = this.option, e2 = Math.min(a.precision, 20), d2 = this.getExtent(), y2 = a.splitNumber;
      y2 = Math.max(parseInt(y2, 10), 1), a.splitNumber = y2;
      for (var x2 = (d2[1] - d2[0]) / y2; +x2.toFixed(e2) !== x2 && e2 < 5; )
        e2++;
      a.precision = e2, x2 = +x2.toFixed(e2), a.minOpen && l2.push({ interval: [-1 / 0, d2[0]], close: [0, 0] });
      for (var C = 0, D2 = d2[0]; C < y2; D2 += x2, C++) {
        var L = C === y2 - 1 ? d2[1] : D2 + x2;
        l2.push({ interval: [D2, L], close: [1, 1] });
      }
      a.maxOpen && l2.push({ interval: [d2[1], 1 / 0], close: [0, 0] }), Gvt(l2), Ke2(l2, function(F3, j) {
        F3.index = j, F3.text = this.formatValueText(F3.interval);
      }, this);
    }, categories: function(l2) {
      var a = this.option;
      Ke2(a.categories, function(e2) {
        l2.push({ text: this.formatValueText(e2, true), value: e2 });
      }, this), bde(a, l2);
    }, pieces: function(l2) {
      var a = this.option;
      Ke2(a.pieces, function(e2, d2) {
        vs(e2) || (e2 = { value: e2 });
        var y2 = { text: "", index: d2 };
        if (e2.label != null && (y2.text = e2.label), e2.hasOwnProperty("value")) {
          var x2 = y2.value = e2.value;
          y2.interval = [x2, x2], y2.close = [1, 1];
        } else {
          for (var C = y2.interval = [], D2 = y2.close = [0, 0], L = [1, 0, 1], F3 = [-1 / 0, 1 / 0], j = [], U3 = 0; U3 < 2; U3++) {
            for (var Y3 = [["gte", "gt", "min"], ["lte", "lt", "max"]][U3], Q = 0; Q < 3 && C[U3] == null; Q++)
              C[U3] = e2[Y3[Q]], D2[U3] = L[Q], j[U3] = Q === 2;
            C[U3] == null && (C[U3] = F3[U3]);
          }
          j[0] && C[1] === 1 / 0 && (D2[0] = 0), j[1] && C[0] === -1 / 0 && (D2[1] = 0), C[0] === C[1] && D2[0] && D2[1] && (y2.value = C[0]);
        }
        y2.visual = B_.retrieveVisuals(e2), l2.push(y2);
      }, this), bde(a, l2), Gvt(l2), Ke2(l2, function(e2) {
        var d2 = e2.close, y2 = [["<", "\u2264"][d2[1]], [">", "\u2265"][d2[0]]];
        e2.text = e2.text || this.formatValueText(e2.value != null ? e2.value : e2.interval, false, y2);
      }, this);
    } };
    function bde(l2, a) {
      var e2 = l2.inverse;
      (l2.orient === "vertical" ? !e2 : e2) && a.reverse();
    }
    var cdn = ldn, fdn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = a.type, e2;
      }
      return a.prototype.doRender = function() {
        var e2 = this.group;
        e2.removeAll();
        var d2 = this.visualMapModel, y2 = d2.get("textGap"), x2 = d2.textStyleModel, C = x2.getFont(), D2 = x2.getTextColor(), L = this._getItemAlign(), F3 = d2.itemSize, j = this._getViewData(), U3 = j.endsText, Y3 = jy(d2.get("showLabel", true), !U3);
        U3 && this._renderEndsText(e2, U3[0], F3, Y3, L), Ke2(j.viewPieceList, function(Q) {
          var nt = Q.piece, dt = new ou();
          dt.onclick = As(this._onItemClick, this, nt), this._enableHoverLink(dt, Q.indexInModelPieceList);
          var vt = d2.getRepresentValue(nt);
          if (this._createItemSymbol(dt, vt, [0, 0, F3[0], F3[1]]), Y3) {
            var Ct = this.visualMapModel.getValueState(vt);
            dt.add(new qc2({ style: { x: L === "right" ? -y2 : F3[0] + y2, y: F3[1] / 2, text: nt.text, verticalAlign: "middle", align: L, font: C, fill: D2, opacity: Ct === "outOfRange" ? 0.5 : 1 } }));
          }
          e2.add(dt);
        }, this), U3 && this._renderEndsText(e2, U3[1], F3, Y3, L), iB(d2.get("orient"), e2, d2.get("itemGap")), this.renderBackground(e2), this.positionGroup(e2);
      }, a.prototype._enableHoverLink = function(e2, d2) {
        var y2 = this;
        e2.on("mouseover", function() {
          return x2("highlight");
        }).on("mouseout", function() {
          return x2("downplay");
        });
        var x2 = function(C) {
          var D2 = y2.visualMapModel;
          D2.option.hoverLink && y2.api.dispatchAction({ type: C, batch: qmt(D2.findTargetDataIndices(d2), D2) });
        };
      }, a.prototype._getItemAlign = function() {
        var e2 = this.visualMapModel, d2 = e2.option;
        if (d2.orient === "vertical")
          return cde(e2, this.api, e2.itemSize);
        var y2 = d2.align;
        return (!y2 || y2 === "auto") && (y2 = "left"), y2;
      }, a.prototype._renderEndsText = function(e2, d2, y2, x2, C) {
        if (d2) {
          var D2 = new ou(), L = this.visualMapModel.textStyleModel;
          D2.add(new qc2({ style: { x: x2 ? C === "right" ? y2[0] : 0 : y2[0] / 2, y: y2[1] / 2, verticalAlign: "middle", align: x2 ? C : "center", text: d2, font: L.getFont(), fill: L.getTextColor() } })), e2.add(D2);
        }
      }, a.prototype._getViewData = function() {
        var e2 = this.visualMapModel, d2 = $a2(e2.getPieceList(), function(D2, L) {
          return { piece: D2, indexInModelPieceList: L };
        }), y2 = e2.get("text"), x2 = e2.get("orient"), C = e2.get("inverse");
        return (x2 === "horizontal" ? C : !C) ? d2.reverse() : y2 && (y2 = y2.slice().reverse()), { viewPieceList: d2, endsText: y2 };
      }, a.prototype._createItemSymbol = function(e2, d2, y2) {
        e2.add(qy(this.getControllerVisual(d2, "symbol"), y2[0], y2[1], y2[2], y2[3], this.getControllerVisual(d2, "color")));
      }, a.prototype._onItemClick = function(e2) {
        var d2 = this.visualMapModel, y2 = d2.option, x2 = zl(y2.selected), C = d2.getSelectedMapKey(e2);
        y2.selectedMode === "single" ? (x2[C] = true, Ke2(x2, function(D2, L) {
          x2[L] = L === C;
        })) : x2[C] = !x2[C], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: x2 });
      }, a.type = "visualMap.piecewise", a;
    }(lde), hdn = fdn;
    function _de(l2) {
      l2.registerComponentModel(cdn), l2.registerComponentView(hdn), yde(l2);
    }
    function pdn(l2) {
      Oc2(mde), Oc2(_de);
    }
    var ddn = { label: { enabled: true }, decal: { show: false } }, xde = Rf2(), gdn = {};
    function vdn(l2, a) {
      var e2 = l2.getModel("aria");
      if (!e2.get("enabled"))
        return;
      var d2 = zl(ddn);
      Mu(d2.label, l2.getLocaleModel().get("aria"), false), Mu(e2.option, d2, false), y2(), x2();
      function y2() {
        var F3 = e2.getModel("decal"), j = F3.get("show");
        if (j) {
          var U3 = fl();
          l2.eachSeries(function(Y3) {
            if (!Y3.isColorBySeries()) {
              var Q = U3.get(Y3.type);
              Q || (Q = {}, U3.set(Y3.type, Q)), xde(Y3).scope = Q;
            }
          }), l2.eachRawSeries(function(Y3) {
            if (l2.isSeriesFiltered(Y3))
              return;
            if (wl(Y3.enableAriaDecal)) {
              Y3.enableAriaDecal();
              return;
            }
            var Q = Y3.getData();
            if (Y3.isColorBySeries()) {
              var nt = B3t(Y3.ecModel, Y3.name, gdn, l2.getSeriesCount()), dt = Q.getVisual("decal");
              Q.setVisual("decal", Rt(dt, nt));
            } else {
              var vt = Y3.getRawData(), Ct = {}, Pt = xde(Y3).scope;
              Q.each(function(le2) {
                var ne2 = Q.getRawIndex(le2);
                Ct[ne2] = le2;
              });
              var jt = vt.count();
              vt.each(function(le2) {
                var ne2 = Ct[le2], he2 = vt.getName(le2) || le2 + "", _e = B3t(Y3.ecModel, he2, Pt, jt), Me2 = Q.getItemVisual(ne2, "decal");
                Q.setItemVisual(ne2, "decal", Rt(Me2, _e));
              });
            }
            function Rt(le2, ne2) {
              var he2 = le2 ? la2(la2({}, ne2), le2) : ne2;
              return he2.dirty = true, he2;
            }
          });
        }
      }
      function x2() {
        var F3 = l2.getLocaleModel().get("aria"), j = e2.getModel("label");
        if (j.option = El(j.option, F3), !!j.get("enabled")) {
          var U3 = a.getZr().dom;
          if (j.get("description")) {
            U3.setAttribute("aria-label", j.get("description"));
            return;
          }
          var Y3 = l2.getSeriesCount(), Q = j.get(["data", "maxCount"]) || 10, nt = j.get(["series", "maxCount"]) || 10, dt = Math.min(Y3, nt), vt;
          if (!(Y3 < 1)) {
            var Ct = D2();
            if (Ct) {
              var Pt = j.get(["general", "withTitle"]);
              vt = C(Pt, { title: Ct });
            } else
              vt = j.get(["general", "withoutTitle"]);
            var jt = [], Rt = Y3 > 1 ? j.get(["series", "multiple", "prefix"]) : j.get(["series", "single", "prefix"]);
            vt += C(Rt, { seriesCount: Y3 }), l2.eachSeries(function(_e, Me2) {
              if (Me2 < dt) {
                var Pe2 = void 0, Be2 = _e.get("name"), Je2 = Be2 ? "withName" : "withoutName";
                Pe2 = Y3 > 1 ? j.get(["series", "multiple", Je2]) : j.get(["series", "single", Je2]), Pe2 = C(Pe2, { seriesId: _e.seriesIndex, seriesName: _e.get("name"), seriesType: L(_e.subType) });
                var Ze2 = _e.getData();
                if (Ze2.count() > Q) {
                  var Cn = j.get(["data", "partialData"]);
                  Pe2 += C(Cn, { displayCnt: Q });
                } else
                  Pe2 += j.get(["data", "allData"]);
                for (var Bn = j.get(["data", "separator", "middle"]), mn = j.get(["data", "separator", "end"]), Kr = [], Kn = 0; Kn < Ze2.count(); Kn++)
                  if (Kn < Q) {
                    var ar = Ze2.getName(Kn), Cr = Ze2.getValues(Kn), ui2 = j.get(["data", ar ? "withName" : "withoutName"]);
                    Kr.push(C(ui2, { name: ar, value: Cr.join(Bn) }));
                  }
                Pe2 += Kr.join(Bn) + mn, jt.push(Pe2);
              }
            });
            var le2 = j.getModel(["series", "multiple", "separator"]), ne2 = le2.get("middle"), he2 = le2.get("end");
            vt += jt.join(ne2) + he2, U3.setAttribute("aria-label", vt);
          }
        }
      }
      function C(F3, j) {
        if (!ps(F3))
          return F3;
        var U3 = F3;
        return Ke2(j, function(Y3, Q) {
          U3 = U3.replace(new RegExp("\\{\\s*" + Q + "\\s*\\}", "g"), Y3);
        }), U3;
      }
      function D2() {
        var F3 = l2.get("title");
        return F3 && F3.length && (F3 = F3[0]), F3 && F3.text;
      }
      function L(F3) {
        return l2.getLocaleModel().get(["series", "typeNames"])[F3] || "\u81EA\u5B9A\u4E49\u56FE";
      }
    }
    function ydn(l2) {
      if (!(!l2 || !l2.aria)) {
        var a = l2.aria;
        a.show != null && (a.enabled = a.show), a.label = a.label || {}, Ke2(["description", "general", "series", "data"], function(e2) {
          a[e2] != null && (a.label[e2] = a[e2]);
        });
      }
    }
    function mdn(l2) {
      l2.registerPreprocessor(ydn), l2.registerVisual(l2.PRIORITY.VISUAL.ARIA, vdn);
    }
    var wde = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, bdn = function() {
      function l2(a) {
        var e2 = this._condVal = ps(a) ? new RegExp(a) : l5t(a) ? a : null;
        if (e2 == null) {
          var d2 = "";
          ih2(d2);
        }
      }
      return l2.prototype.evaluate = function(a) {
        var e2 = typeof a;
        return ps(e2) ? this._condVal.test(a) : Ch2(e2) ? this._condVal.test(a + "") : false;
      }, l2;
    }(), _dn = function() {
      function l2() {
      }
      return l2.prototype.evaluate = function() {
        return this.value;
      }, l2;
    }(), xdn = function() {
      function l2() {
      }
      return l2.prototype.evaluate = function() {
        for (var a = this.children, e2 = 0; e2 < a.length; e2++)
          if (!a[e2].evaluate())
            return false;
        return true;
      }, l2;
    }(), wdn = function() {
      function l2() {
      }
      return l2.prototype.evaluate = function() {
        for (var a = this.children, e2 = 0; e2 < a.length; e2++)
          if (a[e2].evaluate())
            return true;
        return false;
      }, l2;
    }(), Sdn = function() {
      function l2() {
      }
      return l2.prototype.evaluate = function() {
        return !this.child.evaluate();
      }, l2;
    }(), Mdn = function() {
      function l2() {
      }
      return l2.prototype.evaluate = function() {
        for (var a = !!this.valueParser, e2 = this.getValue, d2 = e2(this.valueGetterParam), y2 = a ? this.valueParser(d2) : null, x2 = 0; x2 < this.subCondList.length; x2++)
          if (!this.subCondList[x2].evaluate(a ? y2 : d2))
            return false;
        return true;
      }, l2;
    }();
    function ORt(l2, a) {
      if (l2 === true || l2 === false) {
        var e2 = new _dn();
        return e2.value = l2, e2;
      }
      var d2 = "";
      return Mde(l2) || ih2(d2), l2.and ? Sde("and", l2, a) : l2.or ? Sde("or", l2, a) : l2.not ? Cdn(l2, a) : Tdn(l2, a);
    }
    function Sde(l2, a, e2) {
      var d2 = a[l2], y2 = "";
      Ba2(d2) || ih2(y2), d2.length || ih2(y2);
      var x2 = l2 === "and" ? new xdn() : new wdn();
      return x2.children = $a2(d2, function(C) {
        return ORt(C, e2);
      }), x2.children.length || ih2(y2), x2;
    }
    function Cdn(l2, a) {
      var e2 = l2.not, d2 = "";
      Mde(e2) || ih2(d2);
      var y2 = new Sdn();
      return y2.child = ORt(e2, a), y2.child || ih2(d2), y2;
    }
    function Tdn(l2, a) {
      for (var e2 = "", d2 = a.prepareGetValue(l2), y2 = [], x2 = Qc2(l2), C = l2.parser, D2 = C ? Jie(C) : null, L = 0; L < x2.length; L++) {
        var F3 = x2[L];
        if (!(F3 === "parser" || a.valueGetterAttrMap.get(F3))) {
          var j = Ns(wde, F3) ? wde[F3] : F3, U3 = l2[F3], Y3 = D2 ? D2(U3) : U3, Q = aYe(j, Y3) || j === "reg" && new bdn(Y3);
          Q || ih2(e2), y2.push(Q);
        }
      }
      y2.length || ih2(e2);
      var nt = new Mdn();
      return nt.valueGetterParam = d2, nt.valueParser = D2, nt.getValue = a.getValue, nt.subCondList = y2, nt;
    }
    function Mde(l2) {
      return vs(l2) && !h1(l2);
    }
    var Adn = function() {
      function l2(a, e2) {
        this._cond = ORt(a, e2);
      }
      return l2.prototype.evaluate = function() {
        return this._cond.evaluate();
      }, l2;
    }();
    function Idn(l2, a) {
      return new Adn(l2, a);
    }
    var Ddn = { type: "echarts:filter", transform: function(l2) {
      for (var a = l2.upstream, e2, d2 = Idn(l2.config, { valueGetterAttrMap: fl({ dimension: true }), prepareGetValue: function(D2) {
        var L = "", F3 = D2.dimension;
        Ns(D2, "dimension") || ih2(L);
        var j = a.getDimensionInfo(F3);
        return j || ih2(L), { dimIdx: j.index };
      }, getValue: function(D2) {
        return a.retrieveValueFromItem(e2, D2.dimIdx);
      } }), y2 = [], x2 = 0, C = a.count(); x2 < C; x2++)
        e2 = a.getRawDataItem(x2), d2.evaluate() && y2.push(e2);
      return { data: y2 };
    } }, Edn = { type: "echarts:sort", transform: function(l2) {
      var a = l2.upstream, e2 = l2.config, d2 = "", y2 = Mp(e2);
      y2.length || ih2(d2);
      var x2 = [];
      Ke2(y2, function(j) {
        var U3 = j.dimension, Y3 = j.order, Q = j.parser, nt = j.incomparable;
        if (U3 == null && ih2(d2), Y3 !== "asc" && Y3 !== "desc" && ih2(d2), nt && nt !== "min" && nt !== "max") {
          var dt = "";
          ih2(dt);
        }
        if (Y3 !== "asc" && Y3 !== "desc") {
          var vt = "";
          ih2(vt);
        }
        var Ct = a.getDimensionInfo(U3);
        Ct || ih2(d2);
        var Pt = Q ? Jie(Q) : null;
        Q && !Pt && ih2(d2), x2.push({ dimIdx: Ct.index, parser: Pt, comparator: new eae(Y3, nt) });
      });
      var C = a.sourceFormat;
      C !== sw && C !== CA && ih2(d2);
      for (var D2 = [], L = 0, F3 = a.count(); L < F3; L++)
        D2.push(a.getRawDataItem(L));
      return D2.sort(function(j, U3) {
        for (var Y3 = 0; Y3 < x2.length; Y3++) {
          var Q = x2[Y3], nt = a.retrieveValueFromItem(j, Q.dimIdx), dt = a.retrieveValueFromItem(U3, Q.dimIdx);
          Q.parser && (nt = Q.parser(nt), dt = Q.parser(dt));
          var vt = Q.comparator.evaluate(nt, dt);
          if (vt !== 0)
            return vt;
        }
        return 0;
      }), { data: D2 };
    } };
    function kdn(l2) {
      l2.registerTransform(Ddn), l2.registerTransform(Edn);
    }
    var Pdn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "dataset", e2;
      }
      return a.prototype.init = function(e2, d2, y2) {
        l2.prototype.init.call(this, e2, d2, y2), this._sourceManager = new sae(this), lae(this);
      }, a.prototype.mergeOption = function(e2, d2) {
        l2.prototype.mergeOption.call(this, e2, d2), lae(this);
      }, a.prototype.optionUpdated = function() {
        this._sourceManager.dirty();
      }, a.prototype.getSourceManager = function() {
        return this._sourceManager;
      }, a.type = "dataset", a.defaultOption = { seriesLayoutBy: oP }, a;
    }(Ah2), Ldn = function(l2) {
      Jn(a, l2);
      function a() {
        var e2 = l2 !== null && l2.apply(this, arguments) || this;
        return e2.type = "dataset", e2;
      }
      return a.type = "dataset", a;
    }(_0);
    function Odn(l2) {
      l2.registerComponentModel(Pdn), l2.registerComponentView(Ldn);
    }
    var dP = yA.CMD;
    function SZ(l2, a) {
      return Math.abs(l2 - a) < 1e-5;
    }
    function RRt(l2) {
      var a = l2.data, e2 = l2.len(), d2 = [], y2, x2 = 0, C = 0, D2 = 0, L = 0;
      function F3(Ze2, Cn) {
        y2 && y2.length > 2 && d2.push(y2), y2 = [Ze2, Cn];
      }
      function j(Ze2, Cn, Bn, mn) {
        SZ(Ze2, Bn) && SZ(Cn, mn) || y2.push(Ze2, Cn, Bn, mn, Bn, mn);
      }
      function U3(Ze2, Cn, Bn, mn, Kr, Kn) {
        var ar = Math.abs(Cn - Ze2), Cr = Math.tan(ar / 4) * 4 / 3, ui2 = Cn < Ze2 ? -1 : 1, vi2 = Math.cos(Ze2), ko = Math.sin(Ze2), Ss = Math.cos(Cn), hl = Math.sin(Cn), Qs = vi2 * Kr + Bn, Js = ko * Kn + mn, rs = Ss * Kr + Bn, Gs = hl * Kn + mn, al = Kr * Cr * ui2, _s = Kn * Cr * ui2;
        y2.push(Qs - al * ko, Js + _s * vi2, rs + al * hl, Gs - _s * Ss, rs, Gs);
      }
      for (var Y3, Q, nt, dt, vt = 0; vt < e2; ) {
        var Ct = a[vt++], Pt = vt === 1;
        switch (Pt && (x2 = a[vt], C = a[vt + 1], D2 = x2, L = C, (Ct === dP.L || Ct === dP.C || Ct === dP.Q) && (y2 = [D2, L])), Ct) {
          case dP.M:
            x2 = D2 = a[vt++], C = L = a[vt++], F3(D2, L);
            break;
          case dP.L:
            Y3 = a[vt++], Q = a[vt++], j(x2, C, Y3, Q), x2 = Y3, C = Q;
            break;
          case dP.C:
            y2.push(a[vt++], a[vt++], a[vt++], a[vt++], x2 = a[vt++], C = a[vt++]);
            break;
          case dP.Q:
            Y3 = a[vt++], Q = a[vt++], nt = a[vt++], dt = a[vt++], y2.push(x2 + 2 / 3 * (Y3 - x2), C + 2 / 3 * (Q - C), nt + 2 / 3 * (Y3 - nt), dt + 2 / 3 * (Q - dt), nt, dt), x2 = nt, C = dt;
            break;
          case dP.A:
            var jt = a[vt++], Rt = a[vt++], le2 = a[vt++], ne2 = a[vt++], he2 = a[vt++], _e = a[vt++] + he2;
            vt += 1;
            var Me2 = !a[vt++];
            Y3 = Math.cos(he2) * le2 + jt, Q = Math.sin(he2) * ne2 + Rt, Pt ? (D2 = Y3, L = Q, F3(D2, L)) : j(x2, C, Y3, Q), x2 = Math.cos(_e) * le2 + jt, C = Math.sin(_e) * ne2 + Rt;
            for (var Pe2 = (Me2 ? -1 : 1) * Math.PI / 2, Be2 = he2; Me2 ? Be2 > _e : Be2 < _e; Be2 += Pe2) {
              var Je2 = Me2 ? Math.max(Be2 + Pe2, _e) : Math.min(Be2 + Pe2, _e);
              U3(Be2, Je2, jt, Rt, le2, ne2);
            }
            break;
          case dP.R:
            D2 = x2 = a[vt++], L = C = a[vt++], Y3 = D2 + a[vt++], Q = L + a[vt++], F3(Y3, L), j(Y3, L, Y3, Q), j(Y3, Q, D2, Q), j(D2, Q, D2, L), j(D2, L, Y3, L);
            break;
          case dP.Z:
            y2 && j(x2, C, D2, L), x2 = D2, C = L;
            break;
        }
      }
      return y2 && y2.length > 2 && d2.push(y2), d2;
    }
    function NRt(l2, a, e2, d2, y2, x2, C, D2, L, F3) {
      if (SZ(l2, e2) && SZ(a, d2) && SZ(y2, C) && SZ(x2, D2)) {
        L.push(C, D2);
        return;
      }
      var j = 2 / F3, U3 = j * j, Y3 = C - l2, Q = D2 - a, nt = Math.sqrt(Y3 * Y3 + Q * Q);
      Y3 /= nt, Q /= nt;
      var dt = e2 - l2, vt = d2 - a, Ct = y2 - C, Pt = x2 - D2, jt = dt * dt + vt * vt, Rt = Ct * Ct + Pt * Pt;
      if (jt < U3 && Rt < U3) {
        L.push(C, D2);
        return;
      }
      var le2 = Y3 * dt + Q * vt, ne2 = -Y3 * Ct - Q * Pt, he2 = jt - le2 * le2, _e = Rt - ne2 * ne2;
      if (he2 < U3 && le2 >= 0 && _e < U3 && ne2 >= 0) {
        L.push(C, D2);
        return;
      }
      var Me2 = [], Pe2 = [];
      bE(l2, e2, y2, C, 0.5, Me2), bE(a, d2, x2, D2, 0.5, Pe2), NRt(Me2[0], Pe2[0], Me2[1], Pe2[1], Me2[2], Pe2[2], Me2[3], Pe2[3], L, F3), NRt(Me2[4], Pe2[4], Me2[5], Pe2[5], Me2[6], Pe2[6], Me2[7], Pe2[7], L, F3);
    }
    function Rdn(l2, a) {
      var e2 = RRt(l2), d2 = [];
      a = a || 1;
      for (var y2 = 0; y2 < e2.length; y2++) {
        var x2 = e2[y2], C = [], D2 = x2[0], L = x2[1];
        C.push(D2, L);
        for (var F3 = 2; F3 < x2.length; ) {
          var j = x2[F3++], U3 = x2[F3++], Y3 = x2[F3++], Q = x2[F3++], nt = x2[F3++], dt = x2[F3++];
          NRt(D2, L, j, U3, Y3, Q, nt, dt, C, a), D2 = nt, L = dt;
        }
        d2.push(C);
      }
      return d2;
    }
    function Cde(l2, a, e2) {
      var d2 = l2[a], y2 = l2[1 - a], x2 = Math.abs(d2 / y2), C = Math.ceil(Math.sqrt(x2 * e2)), D2 = Math.floor(e2 / C);
      D2 === 0 && (D2 = 1, C = e2);
      for (var L = [], F3 = 0; F3 < C; F3++)
        L.push(D2);
      var j = C * D2, U3 = e2 - j;
      if (U3 > 0)
        for (var F3 = 0; F3 < U3; F3++)
          L[F3 % C] += 1;
      return L;
    }
    function Tde(l2, a, e2) {
      for (var d2 = l2.r0, y2 = l2.r, x2 = l2.startAngle, C = l2.endAngle, D2 = Math.abs(C - x2), L = D2 * y2, F3 = y2 - d2, j = L > Math.abs(F3), U3 = Cde([L, F3], j ? 0 : 1, a), Y3 = (j ? D2 : F3) / U3.length, Q = 0; Q < U3.length; Q++)
        for (var nt = (j ? F3 : D2) / U3[Q], dt = 0; dt < U3[Q]; dt++) {
          var vt = {};
          j ? (vt.startAngle = x2 + Y3 * Q, vt.endAngle = x2 + Y3 * (Q + 1), vt.r0 = d2 + nt * dt, vt.r = d2 + nt * (dt + 1)) : (vt.startAngle = x2 + nt * dt, vt.endAngle = x2 + nt * (dt + 1), vt.r0 = d2 + Y3 * Q, vt.r = d2 + Y3 * (Q + 1)), vt.clockwise = l2.clockwise, vt.cx = l2.cx, vt.cy = l2.cy, e2.push(vt);
        }
    }
    function Ndn(l2, a, e2) {
      for (var d2 = l2.width, y2 = l2.height, x2 = d2 > y2, C = Cde([d2, y2], x2 ? 0 : 1, a), D2 = x2 ? "width" : "height", L = x2 ? "height" : "width", F3 = x2 ? "x" : "y", j = x2 ? "y" : "x", U3 = l2[D2] / C.length, Y3 = 0; Y3 < C.length; Y3++)
        for (var Q = l2[L] / C[Y3], nt = 0; nt < C[Y3]; nt++) {
          var dt = {};
          dt[F3] = Y3 * U3, dt[j] = nt * Q, dt[D2] = U3, dt[L] = Q, dt.x += l2.x, dt.y += l2.y, e2.push(dt);
        }
    }
    function Ade(l2, a, e2, d2) {
      return l2 * d2 - e2 * a;
    }
    function Fdn(l2, a, e2, d2, y2, x2, C, D2) {
      var L = e2 - l2, F3 = d2 - a, j = C - y2, U3 = D2 - x2, Y3 = Ade(j, U3, L, F3);
      if (Math.abs(Y3) < 1e-6)
        return null;
      var Q = l2 - y2, nt = a - x2, dt = Ade(Q, nt, j, U3) / Y3;
      return dt < 0 || dt > 1 ? null : new Nu(dt * L + l2, dt * F3 + a);
    }
    function Vdn(l2, a, e2) {
      var d2 = new Nu();
      Nu.sub(d2, e2, a), d2.normalize();
      var y2 = new Nu();
      Nu.sub(y2, l2, a);
      var x2 = y2.dot(d2);
      return x2;
    }
    function MZ(l2, a) {
      var e2 = l2[l2.length - 1];
      e2 && e2[0] === a[0] && e2[1] === a[1] || l2.push(a);
    }
    function Bdn(l2, a, e2) {
      for (var d2 = l2.length, y2 = [], x2 = 0; x2 < d2; x2++) {
        var C = l2[x2], D2 = l2[(x2 + 1) % d2], L = Fdn(C[0], C[1], D2[0], D2[1], a.x, a.y, e2.x, e2.y);
        L && y2.push({ projPt: Vdn(L, a, e2), pt: L, idx: x2 });
      }
      if (y2.length < 2)
        return [{ points: l2 }, { points: l2 }];
      y2.sort(function(vt, Ct) {
        return vt.projPt - Ct.projPt;
      });
      var F3 = y2[0], j = y2[y2.length - 1];
      if (j.idx < F3.idx) {
        var U3 = F3;
        F3 = j, j = U3;
      }
      for (var Y3 = [F3.pt.x, F3.pt.y], Q = [j.pt.x, j.pt.y], nt = [Y3], dt = [Q], x2 = F3.idx + 1; x2 <= j.idx; x2++)
        MZ(nt, l2[x2].slice());
      MZ(nt, Q), MZ(nt, Y3);
      for (var x2 = j.idx + 1; x2 <= F3.idx + d2; x2++)
        MZ(dt, l2[x2 % d2].slice());
      return MZ(dt, Y3), MZ(dt, Q), [{ points: nt }, { points: dt }];
    }
    function Ide(l2) {
      var a = l2.points, e2 = [], d2 = [];
      yq(a, e2, d2);
      var y2 = new Yu(e2[0], e2[1], d2[0] - e2[0], d2[1] - e2[1]), x2 = y2.width, C = y2.height, D2 = y2.x, L = y2.y, F3 = new Nu(), j = new Nu();
      return x2 > C ? (F3.x = j.x = D2 + x2 / 2, F3.y = L, j.y = L + C) : (F3.y = j.y = L + C / 2, F3.x = D2, j.x = D2 + x2), Bdn(a, F3, j);
    }
    function Zmt(l2, a, e2, d2) {
      if (e2 === 1)
        d2.push(a);
      else {
        var y2 = Math.floor(e2 / 2), x2 = l2(a);
        Zmt(l2, x2[0], y2, d2), Zmt(l2, x2[1], e2 - y2, d2);
      }
      return d2;
    }
    function zdn(l2, a) {
      for (var e2 = [], d2 = 0; d2 < a; d2++)
        e2.push(qnt(l2));
      return e2;
    }
    function jdn(l2, a) {
      a.setStyle(l2.style), a.z = l2.z, a.z2 = l2.z2, a.zlevel = l2.zlevel;
    }
    function Wdn(l2) {
      for (var a = [], e2 = 0; e2 < l2.length; )
        a.push([l2[e2++], l2[e2++]]);
      return a;
    }
    function Gdn(l2, a) {
      var e2 = [], d2 = l2.shape, y2;
      switch (l2.type) {
        case "rect":
          Ndn(d2, a, e2), y2 = Nf2;
          break;
        case "sector":
          Tde(d2, a, e2), y2 = nw;
          break;
        case "circle":
          Tde({ r0: 0, r: d2.r, startAngle: 0, endAngle: Math.PI * 2, cx: d2.cx, cy: d2.cy }, a, e2), y2 = nw;
          break;
        default:
          var x2 = l2.getComputedTransform(), C = x2 ? Math.sqrt(Math.max(x2[0] * x2[0] + x2[1] * x2[1], x2[2] * x2[2] + x2[3] * x2[3])) : 1, D2 = $a2(Rdn(l2.getUpdatedPathProxy(), C), function(Ct) {
            return Wdn(Ct);
          }), L = D2.length;
          if (L === 0)
            Zmt(Ide, { points: D2[0] }, a, e2);
          else if (L === a)
            for (var F3 = 0; F3 < L; F3++)
              e2.push({ points: D2[F3] });
          else {
            var j = 0, U3 = $a2(D2, function(Ct) {
              var Pt = [], jt = [];
              yq(Ct, Pt, jt);
              var Rt = (jt[1] - Pt[1]) * (jt[0] - Pt[0]);
              return j += Rt, { poly: Ct, area: Rt };
            });
            U3.sort(function(Ct, Pt) {
              return Pt.area - Ct.area;
            });
            for (var Y3 = a, F3 = 0; F3 < L; F3++) {
              var Q = U3[F3];
              if (Y3 <= 0)
                break;
              var nt = F3 === L - 1 ? Y3 : Math.ceil(Q.area / j * a);
              nt < 0 || (Zmt(Ide, { points: Q.poly }, nt, e2), Y3 -= nt);
            }
          }
          y2 = rw;
          break;
      }
      if (!y2)
        return zdn(l2, a);
      for (var dt = [], F3 = 0; F3 < e2.length; F3++) {
        var vt = new y2();
        vt.setShape(e2[F3]), jdn(l2, vt), dt.push(vt);
      }
      return dt;
    }
    function Hdn(l2, a) {
      var e2 = l2.length, d2 = a.length;
      if (e2 === d2)
        return [l2, a];
      for (var y2 = [], x2 = [], C = e2 < d2 ? l2 : a, D2 = Math.min(e2, d2), L = Math.abs(d2 - e2) / 6, F3 = (D2 - 2) / 6, j = Math.ceil(L / F3) + 1, U3 = [C[0], C[1]], Y3 = L, Q = 2; Q < D2; ) {
        var nt = C[Q - 2], dt = C[Q - 1], vt = C[Q++], Ct = C[Q++], Pt = C[Q++], jt = C[Q++], Rt = C[Q++], le2 = C[Q++];
        if (Y3 <= 0) {
          U3.push(vt, Ct, Pt, jt, Rt, le2);
          continue;
        }
        for (var ne2 = Math.min(Y3, j - 1) + 1, he2 = 1; he2 <= ne2; he2++) {
          var _e = he2 / ne2;
          bE(nt, vt, Pt, Rt, _e, y2), bE(dt, Ct, jt, le2, _e, x2), nt = y2[3], dt = x2[3], U3.push(y2[1], x2[1], y2[2], x2[2], nt, dt), vt = y2[5], Ct = x2[5], Pt = y2[6], jt = x2[6];
        }
        Y3 -= ne2 - 1;
      }
      return C === l2 ? [U3, a] : [l2, U3];
    }
    function Dde(l2, a) {
      for (var e2 = l2.length, d2 = l2[e2 - 2], y2 = l2[e2 - 1], x2 = [], C = 0; C < a.length; )
        x2[C++] = d2, x2[C++] = y2;
      return x2;
    }
    function Udn(l2, a) {
      for (var e2, d2, y2, x2 = [], C = [], D2 = 0; D2 < Math.max(l2.length, a.length); D2++) {
        var L = l2[D2], F3 = a[D2], j = void 0, U3 = void 0;
        L ? F3 ? (e2 = Hdn(L, F3), j = e2[0], U3 = e2[1], d2 = j, y2 = U3) : (U3 = Dde(y2 || L, L), j = L) : (j = Dde(d2 || F3, F3), U3 = F3), x2.push(j), C.push(U3);
      }
      return [x2, C];
    }
    function Ede(l2) {
      for (var a = 0, e2 = 0, d2 = 0, y2 = l2.length, x2 = 0, C = y2 - 2; x2 < y2; C = x2, x2 += 2) {
        var D2 = l2[C], L = l2[C + 1], F3 = l2[x2], j = l2[x2 + 1], U3 = D2 * j - F3 * L;
        a += U3, e2 += (D2 + F3) * U3, d2 += (L + j) * U3;
      }
      return a === 0 ? [l2[0] || 0, l2[1] || 0] : [e2 / a / 3, d2 / a / 3, a];
    }
    function qdn(l2, a, e2, d2) {
      for (var y2 = (l2.length - 2) / 6, x2 = 1 / 0, C = 0, D2 = l2.length, L = D2 - 2, F3 = 0; F3 < y2; F3++) {
        for (var j = F3 * 6, U3 = 0, Y3 = 0; Y3 < D2; Y3 += 2) {
          var Q = Y3 === 0 ? j : (j + Y3 - 2) % L + 2, nt = l2[Q] - e2[0], dt = l2[Q + 1] - e2[1], vt = a[Y3] - d2[0], Ct = a[Y3 + 1] - d2[1], Pt = vt - nt, jt = Ct - dt;
          U3 += Pt * Pt + jt * jt;
        }
        U3 < x2 && (x2 = U3, C = F3);
      }
      return C;
    }
    function Zdn(l2) {
      for (var a = [], e2 = l2.length, d2 = 0; d2 < e2; d2 += 2)
        a[d2] = l2[e2 - d2 - 2], a[d2 + 1] = l2[e2 - d2 - 1];
      return a;
    }
    function $dn(l2, a, e2, d2) {
      for (var y2 = [], x2, C = 0; C < l2.length; C++) {
        var D2 = l2[C], L = a[C], F3 = Ede(D2), j = Ede(L);
        x2 == null && (x2 = F3[2] < 0 != j[2] < 0);
        var U3 = [], Y3 = [], Q = 0, nt = 1 / 0, dt = [], vt = D2.length;
        x2 && (D2 = Zdn(D2));
        for (var Ct = qdn(D2, L, F3, j) * 6, Pt = vt - 2, jt = 0; jt < Pt; jt += 2) {
          var Rt = (Ct + jt) % Pt + 2;
          U3[jt + 2] = D2[Rt] - F3[0], U3[jt + 3] = D2[Rt + 1] - F3[1];
        }
        if (U3[0] = D2[Ct] - F3[0], U3[1] = D2[Ct + 1] - F3[1], e2 > 0)
          for (var le2 = d2 / e2, ne2 = -d2 / 2; ne2 <= d2 / 2; ne2 += le2) {
            for (var he2 = Math.sin(ne2), _e = Math.cos(ne2), Me2 = 0, jt = 0; jt < D2.length; jt += 2) {
              var Pe2 = U3[jt], Be2 = U3[jt + 1], Je2 = L[jt] - j[0], Ze2 = L[jt + 1] - j[1], Cn = Je2 * _e - Ze2 * he2, Bn = Je2 * he2 + Ze2 * _e;
              dt[jt] = Cn, dt[jt + 1] = Bn;
              var mn = Cn - Pe2, Kr = Bn - Be2;
              Me2 += mn * mn + Kr * Kr;
            }
            if (Me2 < nt) {
              nt = Me2, Q = ne2;
              for (var Kn = 0; Kn < dt.length; Kn++)
                Y3[Kn] = dt[Kn];
            }
          }
        else
          for (var ar = 0; ar < vt; ar += 2)
            Y3[ar] = L[ar] - j[0], Y3[ar + 1] = L[ar + 1] - j[1];
        y2.push({ from: U3, to: Y3, fromCp: F3, toCp: j, rotation: -Q });
      }
      return y2;
    }
    function $mt(l2) {
      return l2.__isCombineMorphing;
    }
    var kde = "__mOriginal_";
    function Ymt(l2, a, e2) {
      var d2 = kde + a, y2 = l2[d2] || l2[a];
      l2[d2] || (l2[d2] = l2[a]);
      var x2 = e2.replace, C = e2.after, D2 = e2.before;
      l2[a] = function() {
        var L = arguments, F3;
        return D2 && D2.apply(this, L), x2 ? F3 = x2.apply(this, L) : F3 = y2.apply(this, L), C && C.apply(this, L), F3;
      };
    }
    function mit(l2, a) {
      var e2 = kde + a;
      l2[e2] && (l2[a] = l2[e2], l2[e2] = null);
    }
    function Pde(l2, a) {
      for (var e2 = 0; e2 < l2.length; e2++)
        for (var d2 = l2[e2], y2 = 0; y2 < d2.length; ) {
          var x2 = d2[y2], C = d2[y2 + 1];
          d2[y2++] = a[0] * x2 + a[2] * C + a[4], d2[y2++] = a[1] * x2 + a[3] * C + a[5];
        }
    }
    function Lde(l2, a) {
      var e2 = l2.getUpdatedPathProxy(), d2 = a.getUpdatedPathProxy(), y2 = Udn(RRt(e2), RRt(d2)), x2 = y2[0], C = y2[1], D2 = l2.getComputedTransform(), L = a.getComputedTransform();
      function F3() {
        this.transform = null;
      }
      D2 && Pde(x2, D2), L && Pde(C, L), Ymt(a, "updateTransform", { replace: F3 }), a.transform = null;
      var j = $dn(x2, C, 10, Math.PI), U3 = [];
      Ymt(a, "buildPath", { replace: function(Y3) {
        for (var Q = a.__morphT, nt = 1 - Q, dt = [], vt = 0; vt < j.length; vt++) {
          var Ct = j[vt], Pt = Ct.from, jt = Ct.to, Rt = Ct.rotation * Q, le2 = Ct.fromCp, ne2 = Ct.toCp, he2 = Math.sin(Rt), _e = Math.cos(Rt);
          LU(dt, le2, ne2, Q);
          for (var Me2 = 0; Me2 < Pt.length; Me2 += 2) {
            var Pe2 = Pt[Me2], Be2 = Pt[Me2 + 1], Je2 = jt[Me2], Ze2 = jt[Me2 + 1], Cn = Pe2 * nt + Je2 * Q, Bn = Be2 * nt + Ze2 * Q;
            U3[Me2] = Cn * _e - Bn * he2 + dt[0], U3[Me2 + 1] = Cn * he2 + Bn * _e + dt[1];
          }
          var mn = U3[0], Kr = U3[1];
          Y3.moveTo(mn, Kr);
          for (var Me2 = 2; Me2 < Pt.length; ) {
            var Je2 = U3[Me2++], Ze2 = U3[Me2++], Kn = U3[Me2++], ar = U3[Me2++], Cr = U3[Me2++], ui2 = U3[Me2++];
            mn === Je2 && Kr === Ze2 && Kn === Cr && ar === ui2 ? Y3.lineTo(Cr, ui2) : Y3.bezierCurveTo(Je2, Ze2, Kn, ar, Cr, ui2), mn = Cr, Kr = ui2;
          }
        }
      } });
    }
    function FRt(l2, a, e2) {
      if (!l2 || !a)
        return a;
      var d2 = e2.done, y2 = e2.during;
      Lde(l2, a), a.__morphT = 0;
      function x2() {
        mit(a, "buildPath"), mit(a, "updateTransform"), a.__morphT = -1, a.createPathProxy(), a.dirtyShape();
      }
      return a.animateTo({ __morphT: 1 }, El({ during: function(C) {
        a.dirtyShape(), y2 && y2(C);
      }, done: function() {
        x2(), d2 && d2();
      } }, e2)), a;
    }
    function Ydn(l2, a, e2, d2, y2, x2) {
      var C = 16;
      l2 = y2 === e2 ? 0 : Math.round(32767 * (l2 - e2) / (y2 - e2)), a = x2 === d2 ? 0 : Math.round(32767 * (a - d2) / (x2 - d2));
      for (var D2 = 0, L, F3 = (1 << C) / 2; F3 > 0; F3 /= 2) {
        var j = 0, U3 = 0;
        (l2 & F3) > 0 && (j = 1), (a & F3) > 0 && (U3 = 1), D2 += F3 * F3 * (3 * j ^ U3), U3 === 0 && (j === 1 && (l2 = F3 - 1 - l2, a = F3 - 1 - a), L = l2, l2 = a, a = L);
      }
      return D2;
    }
    function Kmt(l2) {
      var a = 1 / 0, e2 = 1 / 0, d2 = -1 / 0, y2 = -1 / 0, x2 = $a2(l2, function(D2) {
        var L = D2.getBoundingRect(), F3 = D2.getComputedTransform(), j = L.x + L.width / 2 + (F3 ? F3[4] : 0), U3 = L.y + L.height / 2 + (F3 ? F3[5] : 0);
        return a = Math.min(j, a), e2 = Math.min(U3, e2), d2 = Math.max(j, d2), y2 = Math.max(U3, y2), [j, U3];
      }), C = $a2(x2, function(D2, L) {
        return { cp: D2, z: Ydn(D2[0], D2[1], a, e2, d2, y2), path: l2[L] };
      });
      return C.sort(function(D2, L) {
        return D2.z - L.z;
      }).map(function(D2) {
        return D2.path;
      });
    }
    function Ode(l2) {
      return Gdn(l2.path, l2.count);
    }
    function VRt() {
      return { fromIndividuals: [], toIndividuals: [], count: 0 };
    }
    function Kdn(l2, a, e2) {
      var d2 = [];
      function y2(le2) {
        for (var ne2 = 0; ne2 < le2.length; ne2++) {
          var he2 = le2[ne2];
          $mt(he2) ? y2(he2.childrenRef()) : he2 instanceof wc2 && d2.push(he2);
        }
      }
      y2(l2);
      var x2 = d2.length;
      if (!x2)
        return VRt();
      var C = e2.dividePath || Ode, D2 = C({ path: a, count: x2 });
      if (D2.length !== x2)
        return console.error("Invalid morphing: unmatched splitted path"), VRt();
      d2 = Kmt(d2), D2 = Kmt(D2);
      for (var L = e2.done, F3 = e2.during, j = e2.individualDelay, U3 = new OS(), Y3 = 0; Y3 < x2; Y3++) {
        var Q = d2[Y3], nt = D2[Y3];
        nt.parent = a, nt.copyTransform(U3), j || Lde(Q, nt);
      }
      a.__isCombineMorphing = true, a.childrenRef = function() {
        return D2;
      };
      function dt(le2) {
        for (var ne2 = 0; ne2 < D2.length; ne2++)
          D2[ne2].addSelfToZr(le2);
      }
      Ymt(a, "addSelfToZr", { after: function(le2) {
        dt(le2);
      } }), Ymt(a, "removeSelfFromZr", { after: function(le2) {
        for (var ne2 = 0; ne2 < D2.length; ne2++)
          D2[ne2].removeSelfFromZr(le2);
      } });
      function vt() {
        a.__isCombineMorphing = false, a.__morphT = -1, a.childrenRef = null, mit(a, "addSelfToZr"), mit(a, "removeSelfFromZr");
      }
      var Ct = D2.length;
      if (j)
        for (var Pt = Ct, jt = function() {
          Pt--, Pt === 0 && (vt(), L && L());
        }, Y3 = 0; Y3 < Ct; Y3++) {
          var Rt = j ? El({ delay: (e2.delay || 0) + j(Y3, Ct, d2[Y3], D2[Y3]), done: jt }, e2) : e2;
          FRt(d2[Y3], D2[Y3], Rt);
        }
      else
        a.__morphT = 0, a.animateTo({ __morphT: 1 }, El({ during: function(le2) {
          for (var ne2 = 0; ne2 < Ct; ne2++) {
            var he2 = D2[ne2];
            he2.__morphT = a.__morphT, he2.dirtyShape();
          }
          F3 && F3(le2);
        }, done: function() {
          vt();
          for (var le2 = 0; le2 < l2.length; le2++)
            mit(l2[le2], "updateTransform");
          L && L();
        } }, e2));
      return a.__zr && dt(a.__zr), { fromIndividuals: d2, toIndividuals: D2, count: Ct };
    }
    function Xdn(l2, a, e2) {
      var d2 = a.length, y2 = [], x2 = e2.dividePath || Ode;
      function C(Q) {
        for (var nt = 0; nt < Q.length; nt++) {
          var dt = Q[nt];
          $mt(dt) ? C(dt.childrenRef()) : dt instanceof wc2 && y2.push(dt);
        }
      }
      if ($mt(l2)) {
        C(l2.childrenRef());
        var D2 = y2.length;
        if (D2 < d2)
          for (var L = 0, F3 = D2; F3 < d2; F3++)
            y2.push(qnt(y2[L++ % D2]));
        y2.length = d2;
      } else {
        y2 = x2({ path: l2, count: d2 });
        for (var j = l2.getComputedTransform(), F3 = 0; F3 < y2.length; F3++)
          y2[F3].setLocalTransform(j);
        if (y2.length !== d2)
          return console.error("Invalid morphing: unmatched splitted path"), VRt();
      }
      y2 = Kmt(y2), a = Kmt(a);
      for (var U3 = e2.individualDelay, F3 = 0; F3 < d2; F3++) {
        var Y3 = U3 ? El({ delay: (e2.delay || 0) + U3(F3, d2, y2[F3], a[F3]) }, e2) : e2;
        FRt(y2[F3], a[F3], Y3);
      }
      return { fromIndividuals: y2, toIndividuals: a, count: a.length };
    }
    function Rde(l2) {
      return Ba2(l2[0]);
    }
    function Nde(l2, a) {
      for (var e2 = [], d2 = l2.length, y2 = 0; y2 < d2; y2++)
        e2.push({ one: l2[y2], many: [] });
      for (var y2 = 0; y2 < a.length; y2++) {
        var x2 = a[y2].length, C = void 0;
        for (C = 0; C < x2; C++)
          e2[C % d2].many.push(a[y2][C]);
      }
      for (var D2 = 0, y2 = d2 - 1; y2 >= 0; y2--)
        if (!e2[y2].many.length) {
          var L = e2[D2].many;
          if (L.length <= 1)
            if (D2)
              D2 = 0;
            else
              return e2;
          var x2 = L.length, F3 = Math.ceil(x2 / 2);
          e2[y2].many = L.slice(F3, x2), e2[D2].many = L.slice(0, F3), D2++;
        }
      return e2;
    }
    var Qdn = { clone: function(l2) {
      for (var a = [], e2 = 1 - Math.pow(1 - l2.path.style.opacity, 1 / l2.count), d2 = 0; d2 < l2.count; d2++) {
        var y2 = qnt(l2.path);
        y2.setStyle("opacity", e2), a.push(y2);
      }
      return a;
    }, split: null };
    function BRt(l2, a, e2, d2, y2, x2) {
      if (!l2.length || !a.length)
        return;
      var C = HN("update", d2, y2);
      if (!(C && C.duration > 0))
        return;
      var D2 = d2.getModel("universalTransition").get("delay"), L = Object.assign({ setToFinal: true }, C), F3, j;
      Rde(l2) && (F3 = l2, j = a), Rde(a) && (F3 = a, j = l2);
      function U3(Ct, Pt, jt, Rt, le2) {
        var ne2 = Ct.many, he2 = Ct.one;
        if (ne2.length === 1 && !le2) {
          var _e = Pt ? ne2[0] : he2, Me2 = Pt ? he2 : ne2[0];
          if ($mt(_e))
            U3({ many: [_e], one: Me2 }, true, jt, Rt, true);
          else {
            var Pe2 = D2 ? El({ delay: D2(jt, Rt) }, L) : L;
            FRt(_e, Me2, Pe2), x2(_e, Me2, _e, Me2, Pe2);
          }
        } else
          for (var Be2 = El({ dividePath: Qdn[e2], individualDelay: D2 && function(Kr, Kn, ar, Cr) {
            return D2(Kr + jt, Rt);
          } }, L), Je2 = Pt ? Kdn(ne2, he2, Be2) : Xdn(he2, ne2, Be2), Ze2 = Je2.fromIndividuals, Cn = Je2.toIndividuals, Bn = Ze2.length, mn = 0; mn < Bn; mn++) {
            var Pe2 = D2 ? El({ delay: D2(mn, Bn) }, L) : L;
            x2(Ze2[mn], Cn[mn], Pt ? ne2[mn] : Ct.one, Pt ? Ct.one : ne2[mn], Pe2);
          }
      }
      for (var Y3 = F3 ? F3 === l2 : l2.length > a.length, Q = F3 ? Nde(j, F3) : Nde(Y3 ? a : l2, [Y3 ? l2 : a]), nt = 0, dt = 0; dt < Q.length; dt++)
        nt += Q[dt].many.length;
      for (var vt = 0, dt = 0; dt < Q.length; dt++)
        U3(Q[dt], Y3, vt, nt), vt += Q[dt].many.length;
    }
    function kB(l2) {
      if (!l2)
        return [];
      if (Ba2(l2)) {
        for (var a = [], e2 = 0; e2 < l2.length; e2++)
          a.push(kB(l2[e2]));
        return a;
      }
      var d2 = [];
      return l2.traverse(function(y2) {
        y2 instanceof wc2 && !y2.disableMorphing && !y2.invisible && !y2.ignore && d2.push(y2);
      }), d2;
    }
    var Fde = 1e4, Jdn = Rf2();
    function tgn(l2) {
      for (var a = l2.dimensions, e2 = 0; e2 < a.length; e2++) {
        var d2 = l2.getDimensionInfo(a[e2]);
        if (d2 && d2.otherDims.itemGroupId === 0)
          return a[e2];
      }
    }
    function Vde(l2) {
      var a = [];
      return Ke2(l2, function(e2) {
        var d2 = e2.data;
        if (!(d2.count() > Fde))
          for (var y2 = d2.getIndices(), x2 = tgn(d2), C = 0; C < y2.length; C++)
            a.push({ data: d2, dim: e2.dim || x2, divide: e2.divide, dataIndex: C });
      }), a;
    }
    function zRt(l2, a, e2) {
      l2.traverse(function(d2) {
        d2 instanceof wc2 && Yg2(d2, { style: { opacity: 0 } }, a, { dataIndex: e2, isFrom: true });
      });
    }
    function jRt(l2) {
      if (l2.parent) {
        var a = l2.getComputedTransform();
        l2.setLocalTransform(a), l2.parent.remove(l2);
      }
    }
    function CZ(l2) {
      l2.stopAnimation(), l2.isGroup && l2.traverse(function(a) {
        a.stopAnimation();
      });
    }
    function egn(l2, a, e2) {
      var d2 = HN("update", e2, a);
      d2 && l2.traverse(function(y2) {
        if (y2 instanceof Y2) {
          var x2 = x3t(y2);
          x2 && y2.animateFrom({ style: x2 }, d2);
        }
      });
    }
    function ngn(l2, a) {
      var e2 = l2.length;
      if (e2 !== a.length)
        return false;
      for (var d2 = 0; d2 < e2; d2++) {
        var y2 = l2[d2], x2 = a[d2];
        if (y2.data.getId(y2.dataIndex) !== x2.data.getId(x2.dataIndex))
          return false;
      }
      return true;
    }
    function Bde(l2, a, e2) {
      var d2 = Vde(l2), y2 = Vde(a);
      function x2(Ct, Pt, jt, Rt, le2) {
        (jt || Ct) && Pt.animateFrom({ style: jt && jt !== Ct ? la2(la2({}, jt.style), Ct.style) : Ct.style }, le2);
      }
      function C(Ct) {
        for (var Pt = 0; Pt < Ct.length; Pt++)
          if (Ct[Pt].dim)
            return Ct[Pt].dim;
      }
      var D2 = C(d2), L = C(y2), F3 = false;
      function j(Ct, Pt) {
        return function(jt) {
          var Rt = jt.data, le2 = jt.dataIndex;
          if (Pt)
            return Rt.getId(le2);
          var ne2 = Rt.hostModel && Rt.hostModel.get("dataGroupId"), he2 = Ct ? D2 || L : L || D2, _e = he2 && Rt.getDimensionInfo(he2), Me2 = _e && _e.ordinalMeta;
          if (_e) {
            var Pe2 = Rt.get(_e.name, le2);
            return Me2 && Me2.categories[Pe2] || Pe2 + "";
          }
          var Be2 = Rt.getRawDataItem(le2);
          return Be2 && Be2.groupId ? Be2.groupId + "" : ne2 || Rt.getId(le2);
        };
      }
      var U3 = ngn(d2, y2), Y3 = {};
      if (!U3)
        for (var Q = 0; Q < y2.length; Q++) {
          var nt = y2[Q], dt = nt.data.getItemGraphicEl(nt.dataIndex);
          dt && (Y3[dt.id] = true);
        }
      function vt(Ct, Pt) {
        var jt = d2[Pt], Rt = y2[Ct], le2 = Rt.data.hostModel, ne2 = jt.data.getItemGraphicEl(jt.dataIndex), he2 = Rt.data.getItemGraphicEl(Rt.dataIndex);
        if (ne2 === he2) {
          he2 && egn(he2, Rt.dataIndex, le2);
          return;
        }
        ne2 && Y3[ne2.id] || he2 && (CZ(he2), ne2 ? (CZ(ne2), jRt(ne2), F3 = true, BRt(kB(ne2), kB(he2), Rt.divide, le2, Ct, x2)) : zRt(he2, le2, Ct));
      }
      new kO(d2, y2, j(true, U3), j(false, U3), null, "multiple").update(vt).updateManyToOne(function(Ct, Pt) {
        var jt = y2[Ct], Rt = jt.data, le2 = Rt.hostModel, ne2 = Rt.getItemGraphicEl(jt.dataIndex), he2 = Lp($a2(Pt, function(_e) {
          return d2[_e].data.getItemGraphicEl(d2[_e].dataIndex);
        }), function(_e) {
          return _e && _e !== ne2 && !Y3[_e.id];
        });
        ne2 && (CZ(ne2), he2.length ? (Ke2(he2, function(_e) {
          CZ(_e), jRt(_e);
        }), F3 = true, BRt(kB(he2), kB(ne2), jt.divide, le2, Ct, x2)) : zRt(ne2, le2, jt.dataIndex));
      }).updateOneToMany(function(Ct, Pt) {
        var jt = d2[Pt], Rt = jt.data.getItemGraphicEl(jt.dataIndex);
        if (!(Rt && Y3[Rt.id])) {
          var le2 = Lp($a2(Ct, function(he2) {
            return y2[he2].data.getItemGraphicEl(y2[he2].dataIndex);
          }), function(he2) {
            return he2 && he2 !== Rt;
          }), ne2 = y2[Ct[0]].data.hostModel;
          le2.length && (Ke2(le2, function(he2) {
            return CZ(he2);
          }), Rt ? (CZ(Rt), jRt(Rt), F3 = true, BRt(kB(Rt), kB(le2), jt.divide, ne2, Ct[0], x2)) : Ke2(le2, function(he2) {
            return zRt(he2, ne2, Ct[0]);
          }));
        }
      }).updateManyToMany(function(Ct, Pt) {
        new kO(Pt, Ct, function(jt) {
          return d2[jt].data.getId(d2[jt].dataIndex);
        }, function(jt) {
          return y2[jt].data.getId(y2[jt].dataIndex);
        }).update(function(jt, Rt) {
          vt(Ct[jt], Pt[Rt]);
        }).execute();
      }).execute(), F3 && Ke2(a, function(Ct) {
        var Pt = Ct.data, jt = Pt.hostModel, Rt = jt && e2.getViewOfSeriesModel(jt), le2 = HN("update", jt, 0);
        Rt && jt.isAnimationEnabled() && le2 && le2.duration > 0 && Rt.group.traverse(function(ne2) {
          ne2 instanceof wc2 && !ne2.animators.length && ne2.animateFrom({ style: { opacity: 0 } }, le2);
        });
      });
    }
    function zde(l2) {
      var a = l2.getModel("universalTransition").get("seriesKey");
      return a || l2.id;
    }
    function jde(l2) {
      return Ba2(l2) ? l2.sort().join(",") : l2;
    }
    function pF(l2) {
      if (l2.hostModel)
        return l2.hostModel.getModel("universalTransition").get("divideShape");
    }
    function rgn(l2, a) {
      var e2 = fl(), d2 = fl(), y2 = fl();
      return Ke2(l2.oldSeries, function(x2, C) {
        var D2 = l2.oldData[C], L = zde(x2), F3 = jde(L);
        d2.set(F3, D2), Ba2(L) && Ke2(L, function(j) {
          y2.set(j, { data: D2, key: F3 });
        });
      }), Ke2(a.updatedSeries, function(x2) {
        if (x2.isUniversalTransitionEnabled() && x2.isAnimationEnabled()) {
          var C = x2.getData(), D2 = zde(x2), L = jde(D2), F3 = d2.get(L);
          if (F3)
            e2.set(L, { oldSeries: [{ divide: pF(F3), data: F3 }], newSeries: [{ divide: pF(C), data: C }] });
          else if (Ba2(D2)) {
            var j = [];
            Ke2(D2, function(Q) {
              var nt = d2.get(Q);
              nt && j.push({ divide: pF(nt), data: nt });
            }), j.length && e2.set(L, { oldSeries: j, newSeries: [{ data: C, divide: pF(C) }] });
          } else {
            var U3 = y2.get(D2);
            if (U3) {
              var Y3 = e2.get(U3.key);
              Y3 || (Y3 = { oldSeries: [{ data: U3.data, divide: pF(U3.data) }], newSeries: [] }, e2.set(U3.key, Y3)), Y3.newSeries.push({ data: C, divide: pF(C) });
            }
          }
        }
      }), e2;
    }
    function Wde(l2, a) {
      for (var e2 = 0; e2 < l2.length; e2++) {
        var d2 = a.seriesIndex != null && a.seriesIndex === l2[e2].seriesIndex || a.seriesId != null && a.seriesId === l2[e2].id;
        if (d2)
          return e2;
      }
    }
    function ign(l2, a, e2, d2) {
      var y2 = [], x2 = [];
      Ke2(Mp(l2.from), function(C) {
        var D2 = Wde(a.oldSeries, C);
        D2 >= 0 && y2.push({ data: a.oldData[D2], divide: pF(a.oldData[D2]), dim: C.dimension });
      }), Ke2(Mp(l2.to), function(C) {
        var D2 = Wde(e2.updatedSeries, C);
        if (D2 >= 0) {
          var L = e2.updatedSeries[D2].getData();
          x2.push({ data: L, divide: pF(L), dim: C.dimension });
        }
      }), y2.length > 0 && x2.length > 0 && Bde(y2, x2, d2);
    }
    function agn(l2) {
      l2.registerUpdateLifecycle("series:beforeupdate", function(a, e2, d2) {
        Ke2(Mp(d2.seriesTransition), function(y2) {
          Ke2(Mp(y2.to), function(x2) {
            for (var C = d2.updatedSeries, D2 = 0; D2 < C.length; D2++)
              (x2.seriesIndex != null && x2.seriesIndex === C[D2].seriesIndex || x2.seriesId != null && x2.seriesId === C[D2].id) && (C[D2][vyt] = true);
          });
        });
      }), l2.registerUpdateLifecycle("series:transition", function(a, e2, d2) {
        var y2 = Jdn(e2);
        if (y2.oldSeries && d2.updatedSeries && d2.optionChanged) {
          var x2 = d2.seriesTransition;
          if (x2)
            Ke2(Mp(x2), function(Y3) {
              ign(Y3, y2, d2, e2);
            });
          else {
            var C = rgn(y2, d2);
            Ke2(C.keys(), function(Y3) {
              var Q = C.get(Y3);
              Bde(Q.oldSeries, Q.newSeries, e2);
            });
          }
          Ke2(d2.updatedSeries, function(Y3) {
            Y3[vyt] && (Y3[vyt] = false);
          });
        }
        for (var D2 = a.getSeries(), L = y2.oldSeries = [], F3 = y2.oldData = [], j = 0; j < D2.length; j++) {
          var U3 = D2[j].getData();
          U3.count() < Fde && (L.push(D2[j]), F3.push(U3));
        }
      });
    }
    Oc2([SJe]), Oc2([vJe]), Oc2([ZJe, ftn, Stn, fen, Ien, wnn, Jnn, Brn, pin, win, Lin, Fan, con, Mon, Gon, Kon, dsn, Msn, Fsn, Usn, iln, Wln]), Oc2(fun), Oc2(Uun), Oc2(Vue), Oc2(lcn), Oc2(sfe), Oc2(gcn), Oc2(Mcn), Oc2(Cfn), Oc2($fn), Oc2(uit), Oc2(dhn), Oc2(yhn), Oc2(Phn), Oc2(Whn), Oc2(Khn), Oc2(ipn), Oc2(mpn), Oc2(zpn), Oc2(Qpe), Oc2(nde), Oc2(pdn), Oc2(mde), Oc2(_de), Oc2(mdn), Oc2(kdn), Oc2(Odn), Oc2(agn), Oc2(RQe);
    function ogn(l2) {
      const { defaultOptions: a } = l2 != null ? l2 : {}, e2 = P2.useRef(null), d2 = P2.useRef(), y2 = P2.useRef(a);
      return P2.useEffect(() => {
        if (!e2.current)
          return;
        const x2 = XKe(e2.current);
        d2.current = x2, y2.current && x2.setOption(y2.current);
      }, []), P2.useEffect(() => () => {
        var x2, C, D2, L;
        (C = (x2 = d2.current) == null ? void 0 : x2.dispose) == null || C.call(x2), (L = (D2 = d2.current) == null ? void 0 : D2.off) == null || L.call(D2, "*"), d2.current = void 0;
      }, []), Ea2("resize", () => {
        requestAnimationFrame(() => {
          var x2, C;
          (C = (x2 = d2 == null ? void 0 : d2.current) == null ? void 0 : x2.resize) == null || C.call(x2);
        });
      }), { chart: d2, container: e2 };
    }
    class sgn {
      constructor() {
        I2(this, "chartsEmitters", /* @__PURE__ */ new Map()), I2(this, "add", (a, e2, d2, y2) => {
          e2 && d2 ? this.chartsEmitters.set(a, { chart: e2, option: d2, title: y2 }) : console.log("\u6DFB\u52A0\u5931\u8D25");
        }), I2(this, "get", (a) => this.chartsEmitters.get(a)), I2(this, "clear", () => {
          this.chartsEmitters.clear();
        }), I2(this, "delete", (a) => {
          this.chartsEmitters.delete(a);
        }), I2(this, "list", () => {
          var a, e2, d2;
          const y2 = [];
          for (const x2 of this.chartsEmitters.keys())
            y2.push({ id: x2, chart: (a = this.chartsEmitters.get(x2)) == null ? void 0 : a.chart, option: (e2 = this.chartsEmitters.get(x2)) == null ? void 0 : e2.option, title: (d2 = this.chartsEmitters.get(x2)) == null ? void 0 : d2.title });
          return y2;
        });
      }
    }
    const lgn = new sgn();
    var Xmt = { exports: {} };
    /**
    * @license
    * Lodash <https://lodash.com/>
    * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
    * Released under MIT license <https://lodash.com/license>
    * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
    * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
    */
    (function(l2, a) {
      (function() {
        var e2, d2 = "4.17.21", y2 = 200, x2 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", C = "Expected a function", D2 = "Invalid `variable` option passed into `_.template`", L = "__lodash_hash_undefined__", F3 = 500, j = "__lodash_placeholder__", U3 = 1, Y3 = 2, Q = 4, nt = 1, dt = 2, vt = 1, Ct = 2, Pt = 4, jt = 8, Rt = 16, le2 = 32, ne2 = 64, he2 = 128, _e = 256, Me2 = 512, Pe2 = 30, Be2 = "...", Je2 = 800, Ze2 = 16, Cn = 1, Bn = 2, mn = 3, Kr = 1 / 0, Kn = 9007199254740991, ar = 17976931348623157e292, Cr = 0 / 0, ui2 = 4294967295, vi2 = ui2 - 1, ko = ui2 >>> 1, Ss = [["ary", he2], ["bind", vt], ["bindKey", Ct], ["curry", jt], ["curryRight", Rt], ["flip", Me2], ["partial", le2], ["partialRight", ne2], ["rearg", _e]], hl = "[object Arguments]", Qs = "[object Array]", Js = "[object AsyncFunction]", rs = "[object Boolean]", Gs = "[object Date]", al = "[object DOMException]", _s = "[object Error]", Fl = "[object Function]", Ih2 = "[object GeneratorFunction]", lu = "[object Map]", ah2 = "[object Number]", Uh2 = "[object Null]", Np = "[object Object]", Zy = "[object Promise]", Nd2 = "[object Proxy]", w1 = "[object RegExp]", Zd2 = "[object Set]", Lv = "[object String]", hv = "[object Symbol]", VA = "[object Undefined]", po = "[object WeakMap]", ia2 = "[object WeakSet]", Ji2 = "[object ArrayBuffer]", mo = "[object DataView]", zs = "[object Float32Array]", Jl = "[object Float64Array]", gf2 = "[object Int8Array]", vf2 = "[object Int16Array]", Xp = "[object Int32Array]", pv = "[object Uint8Array]", vg2 = "[object Uint8ClampedArray]", Z0 = "[object Uint16Array]", yg2 = "[object Uint32Array]", Cb2 = /\b__p \+= '';/g, z_ = /\b(__p \+=) '' \+/g, tM = /(__e\(.*?\)|\b__t\)) \+\n'';/g, j_ = /&(?:amp|lt|gt|quot|#39);/g, i0 = /[&<>"']/g, qh2 = RegExp(j_.source), wy = RegExp(i0.source), S1 = /<%-([\s\S]+?)%>/g, eM = /<%([\s\S]+?)%>/g, hw = /<%=([\s\S]+?)%>/g, W_ = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, GS = /^\w*$/, vP = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, RE = /[\\^$.*+?()[\]{}|]/g, RB = RegExp(RE.source), NE = /^\s+/, Pit = /\s/, Lit = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Oit = /\{\n\/\* \[wrapped with (.+)\] \*/, Rit = /,? & /, yF = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, xr = /[()=,{}\[\]\/\s]/, kr = /\\(\\)?/g, Rn = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, fr = /\w*$/, mr = /^[-+]0x[0-9a-f]+$/i, qi2 = /^0b[01]+$/i, to = /^\[object .+?Constructor\]$/, ka2 = /^0o[0-7]+$/i, Ti2 = /^(?:0|[1-9]\d*)$/, tr = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, tu = /($^)/, Kf2 = /['\n\r\u2028\u2029\\]/g, yf2 = "\\ud800-\\udfff", wd2 = "\\u0300-\\u036f", Ys = "\\ufe20-\\ufe2f", Qp = "\\u20d0-\\u20ff", dv = wd2 + Ys + Qp, Fu = "\\u2700-\\u27bf", $0 = "a-z\\xdf-\\xf6\\xf8-\\xff", G_ = "\\xac\\xb1\\xd7\\xf7", wC = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", mF = "\\u2000-\\u206f", SC = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", pw = "A-Z\\xc0-\\xd6\\xd8-\\xde", BA = "\\ufe0e\\ufe0f", Sy = G_ + wC + mF + SC, H_ = "['\u2019]", zA = "[" + yf2 + "]", FE = "[" + Sy + "]", WO = "[" + dv + "]", VE = "\\d+", NB = "[" + Fu + "]", GO = "[" + $0 + "]", BE = "[^" + yf2 + Sy + VE + Fu + $0 + pw + "]", zE = "\\ud83c[\\udffb-\\udfff]", yP = "(?:" + WO + "|" + zE + ")", bF = "[^" + yf2 + "]", FB = "(?:\\ud83c[\\udde6-\\uddff]){2}", jl = "[\\ud800-\\udbff][\\udc00-\\udfff]", Cu = "[" + pw + "]", LZ = "\\u200d", ua2 = "(?:" + GO + "|" + BE + ")", kl = "(?:" + Cu + "|" + BE + ")", sc2 = "(?:" + H_ + "(?:d|ll|m|re|s|t|ve))?", M1t = "(?:" + H_ + "(?:D|LL|M|RE|S|T|VE))?", x0 = yP + "?", M1 = "[" + BA + "]?", Xe2 = "(?:" + LZ + "(?:" + [bF, FB, jl].join("|") + ")" + M1 + x0 + ")*", Ya2 = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", jA = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Fp = M1 + x0 + Xe2, P6t = "(?:" + [NB, FB, jl].join("|") + ")" + Fp, tf2 = "(?:" + [bF + WO + "?", WO, FB, jl, zA].join("|") + ")", L6t = RegExp(H_, "g"), Is = RegExp(WO, "g"), wu = RegExp(zE + "(?=" + zE + ")|" + tf2 + Fp, "g"), za2 = RegExp([Cu + "?" + GO + "+" + sc2 + "(?=" + [FE, Cu, "$"].join("|") + ")", kl + "+" + M1t + "(?=" + [FE, Cu + ua2, "$"].join("|") + ")", Cu + "?" + ua2 + "+" + sc2, Cu + "+" + M1t, jA, Ya2, VE, P6t].join("|"), "g"), Sl = RegExp("[" + LZ + yf2 + dv + BA + "]"), ds = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, Nit = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], Dh2 = -1, ys = {};
        ys[zs] = ys[Jl] = ys[gf2] = ys[vf2] = ys[Xp] = ys[pv] = ys[vg2] = ys[Z0] = ys[yg2] = true, ys[hl] = ys[Qs] = ys[Ji2] = ys[rs] = ys[mo] = ys[Gs] = ys[_s] = ys[Fl] = ys[lu] = ys[ah2] = ys[Np] = ys[w1] = ys[Zd2] = ys[Lv] = ys[po] = false;
        var mg2 = {};
        mg2[hl] = mg2[Qs] = mg2[Ji2] = mg2[mo] = mg2[rs] = mg2[Gs] = mg2[zs] = mg2[Jl] = mg2[gf2] = mg2[vf2] = mg2[Xp] = mg2[lu] = mg2[ah2] = mg2[Np] = mg2[w1] = mg2[Zd2] = mg2[Lv] = mg2[hv] = mg2[pv] = mg2[vg2] = mg2[Z0] = mg2[yg2] = true, mg2[_s] = mg2[Fl] = mg2[po] = false;
        var HS = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, VB = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, OZ = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, O6t = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, R6t = parseFloat, BB = parseInt, $y = typeof en == "object" && en && en.Object === Object && en, Xu = typeof self == "object" && self && self.Object === Object && self, gv = $y || Xu || Function("return this")(), zB = a && !a.nodeType && a, jE = zB && true && l2 && !l2.nodeType && l2, Tb2 = jE && jE.exports === zB, US = Tb2 && $y.process, qS = function() {
          try {
            var xi2 = jE && jE.require && jE.require("util").types;
            return xi2 || US && US.binding && US.binding("util");
          } catch {
          }
        }(), jB = qS && qS.isArrayBuffer, _F = qS && qS.isDate, C1t = qS && qS.isMap, pl = qS && qS.isRegExp, RZ = qS && qS.isSet, WB = qS && qS.isTypedArray;
        function dw(xi2, ao, Ma2) {
          switch (Ma2.length) {
            case 0:
              return xi2.call(ao);
            case 1:
              return xi2.call(ao, Ma2[0]);
            case 2:
              return xi2.call(ao, Ma2[0], Ma2[1]);
            case 3:
              return xi2.call(ao, Ma2[0], Ma2[1], Ma2[2]);
          }
          return xi2.apply(ao, Ma2);
        }
        function Fs(xi2, ao, Ma2, Vl) {
          for (var ef2 = -1, td2 = xi2 == null ? 0 : xi2.length; ++ef2 < td2; ) {
            var a0 = xi2[ef2];
            ao(Vl, a0, Ma2(a0), xi2);
          }
          return Vl;
        }
        function Jp(xi2, ao) {
          for (var Ma2 = -1, Vl = xi2 == null ? 0 : xi2.length; ++Ma2 < Vl && ao(xi2[Ma2], Ma2, xi2) !== false; )
            ;
          return xi2;
        }
        function NZ(xi2, ao) {
          for (var Ma2 = xi2 == null ? 0 : xi2.length; Ma2-- && ao(xi2[Ma2], Ma2, xi2) !== false; )
            ;
          return xi2;
        }
        function mP(xi2, ao) {
          for (var Ma2 = -1, Vl = xi2 == null ? 0 : xi2.length; ++Ma2 < Vl; )
            if (!ao(xi2[Ma2], Ma2, xi2))
              return false;
          return true;
        }
        function w0(xi2, ao) {
          for (var Ma2 = -1, Vl = xi2 == null ? 0 : xi2.length, ef2 = 0, td2 = []; ++Ma2 < Vl; ) {
            var a0 = xi2[Ma2];
            ao(a0, Ma2, xi2) && (td2[ef2++] = a0);
          }
          return td2;
        }
        function nM(xi2, ao) {
          var Ma2 = xi2 == null ? 0 : xi2.length;
          return !!Ma2 && rM(xi2, ao, 0) > -1;
        }
        function Fit(xi2, ao, Ma2) {
          for (var Vl = -1, ef2 = xi2 == null ? 0 : xi2.length; ++Vl < ef2; )
            if (Ma2(ao, xi2[Vl]))
              return true;
          return false;
        }
        function vv(xi2, ao) {
          for (var Ma2 = -1, Vl = xi2 == null ? 0 : xi2.length, ef2 = Array(Vl); ++Ma2 < Vl; )
            ef2[Ma2] = ao(xi2[Ma2], Ma2, xi2);
          return ef2;
        }
        function WA(xi2, ao) {
          for (var Ma2 = -1, Vl = ao.length, ef2 = xi2.length; ++Ma2 < Vl; )
            xi2[ef2 + Ma2] = ao[Ma2];
          return xi2;
        }
        function WE(xi2, ao, Ma2, Vl) {
          var ef2 = -1, td2 = xi2 == null ? 0 : xi2.length;
          for (Vl && td2 && (Ma2 = xi2[++ef2]); ++ef2 < td2; )
            Ma2 = ao(Ma2, xi2[ef2], ef2, xi2);
          return Ma2;
        }
        function Vit(xi2, ao, Ma2, Vl) {
          var ef2 = xi2 == null ? 0 : xi2.length;
          for (Vl && ef2 && (Ma2 = xi2[--ef2]); ef2--; )
            Ma2 = ao(Ma2, xi2[ef2], ef2, xi2);
          return Ma2;
        }
        function Bit(xi2, ao) {
          for (var Ma2 = -1, Vl = xi2 == null ? 0 : xi2.length; ++Ma2 < Vl; )
            if (ao(xi2[Ma2], Ma2, xi2))
              return true;
          return false;
        }
        var zit = GA("length");
        function GB(xi2) {
          return xi2.split("");
        }
        function jit(xi2) {
          return xi2.match(yF) || [];
        }
        function GE(xi2, ao, Ma2) {
          var Vl;
          return Ma2(xi2, function(ef2, td2, a0) {
            if (ao(ef2, td2, a0))
              return Vl = td2, false;
          }), Vl;
        }
        function FZ(xi2, ao, Ma2, Vl) {
          for (var ef2 = xi2.length, td2 = Ma2 + (Vl ? 1 : -1); Vl ? td2-- : ++td2 < ef2; )
            if (ao(xi2[td2], td2, xi2))
              return td2;
          return -1;
        }
        function rM(xi2, ao, Ma2) {
          return ao === ao ? UE(xi2, ao, Ma2) : FZ(xi2, Lm, Ma2);
        }
        function VZ(xi2, ao, Ma2, Vl) {
          for (var ef2 = Ma2 - 1, td2 = xi2.length; ++ef2 < td2; )
            if (Vl(xi2[ef2], ao))
              return ef2;
          return -1;
        }
        function Lm(xi2) {
          return xi2 !== xi2;
        }
        function HE(xi2, ao) {
          var Ma2 = xi2 == null ? 0 : xi2.length;
          return Ma2 ? Wit(xi2, ao) / Ma2 : Cr;
        }
        function GA(xi2) {
          return function(ao) {
            return ao == null ? e2 : ao[xi2];
          };
        }
        function bP(xi2) {
          return function(ao) {
            return xi2 == null ? e2 : xi2[ao];
          };
        }
        function T1t(xi2, ao, Ma2, Vl, ef2) {
          return ef2(xi2, function(td2, a0, bg2) {
            Ma2 = Vl ? (Vl = false, td2) : ao(Ma2, td2, a0, bg2);
          }), Ma2;
        }
        function N6t(xi2, ao) {
          var Ma2 = xi2.length;
          for (xi2.sort(ao); Ma2--; )
            xi2[Ma2] = xi2[Ma2].value;
          return xi2;
        }
        function Wit(xi2, ao) {
          for (var Ma2, Vl = -1, ef2 = xi2.length; ++Vl < ef2; ) {
            var td2 = ao(xi2[Vl]);
            td2 !== e2 && (Ma2 = Ma2 === e2 ? td2 : Ma2 + td2);
          }
          return Ma2;
        }
        function gw(xi2, ao) {
          for (var Ma2 = -1, Vl = Array(xi2); ++Ma2 < xi2; )
            Vl[Ma2] = ao(Ma2);
          return Vl;
        }
        function F6t(xi2, ao) {
          return vv(ao, function(Ma2) {
            return [Ma2, xi2[Ma2]];
          });
        }
        function BZ(xi2) {
          return xi2 && xi2.slice(0, k1t(xi2) + 1).replace(NE, "");
        }
        function vw(xi2) {
          return function(ao) {
            return xi2(ao);
          };
        }
        function zZ(xi2, ao) {
          return vv(ao, function(Ma2) {
            return xi2[Ma2];
          });
        }
        function HO(xi2, ao) {
          return xi2.has(ao);
        }
        function A1t(xi2, ao) {
          for (var Ma2 = -1, Vl = xi2.length; ++Ma2 < Vl && rM(ao, xi2[Ma2], 0) > -1; )
            ;
          return Ma2;
        }
        function jZ(xi2, ao) {
          for (var Ma2 = xi2.length; Ma2-- && rM(ao, xi2[Ma2], 0) > -1; )
            ;
          return Ma2;
        }
        function V6t(xi2, ao) {
          for (var Ma2 = xi2.length, Vl = 0; Ma2--; )
            xi2[Ma2] === ao && ++Vl;
          return Vl;
        }
        var B6t = bP(HS), I1t = bP(VB);
        function z6t(xi2) {
          return "\\" + O6t[xi2];
        }
        function Git(xi2, ao) {
          return xi2 == null ? e2 : xi2[ao];
        }
        function xF(xi2) {
          return Sl.test(xi2);
        }
        function Hit(xi2) {
          return ds.test(xi2);
        }
        function D1t(xi2) {
          for (var ao, Ma2 = []; !(ao = xi2.next()).done; )
            Ma2.push(ao.value);
          return Ma2;
        }
        function HB(xi2) {
          var ao = -1, Ma2 = Array(xi2.size);
          return xi2.forEach(function(Vl, ef2) {
            Ma2[++ao] = [ef2, Vl];
          }), Ma2;
        }
        function ZS(xi2, ao) {
          return function(Ma2) {
            return xi2(ao(Ma2));
          };
        }
        function _P(xi2, ao) {
          for (var Ma2 = -1, Vl = xi2.length, ef2 = 0, td2 = []; ++Ma2 < Vl; ) {
            var a0 = xi2[Ma2];
            (a0 === ao || a0 === j) && (xi2[Ma2] = j, td2[ef2++] = Ma2);
          }
          return td2;
        }
        function wF(xi2) {
          var ao = -1, Ma2 = Array(xi2.size);
          return xi2.forEach(function(Vl) {
            Ma2[++ao] = Vl;
          }), Ma2;
        }
        function j6t(xi2) {
          var ao = -1, Ma2 = Array(xi2.size);
          return xi2.forEach(function(Vl) {
            Ma2[++ao] = [Vl, Vl];
          }), Ma2;
        }
        function UE(xi2, ao, Ma2) {
          for (var Vl = Ma2 - 1, ef2 = xi2.length; ++Vl < ef2; )
            if (xi2[Vl] === ao)
              return Vl;
          return -1;
        }
        function E1t(xi2, ao, Ma2) {
          for (var Vl = Ma2 + 1; Vl--; )
            if (xi2[Vl] === ao)
              return Vl;
          return Vl;
        }
        function SF(xi2) {
          return xF(xi2) ? P1t(xi2) : zit(xi2);
        }
        function iM(xi2) {
          return xF(xi2) ? W6t(xi2) : GB(xi2);
        }
        function k1t(xi2) {
          for (var ao = xi2.length; ao-- && Pit.test(xi2.charAt(ao)); )
            ;
          return ao;
        }
        var Uit = bP(OZ);
        function P1t(xi2) {
          for (var ao = wu.lastIndex = 0; wu.test(xi2); )
            ++ao;
          return ao;
        }
        function W6t(xi2) {
          return xi2.match(wu) || [];
        }
        function G6t(xi2) {
          return xi2.match(za2) || [];
        }
        var H6t = function xi2(ao) {
          ao = ao == null ? gv : HA.defaults(gv.Object(), ao, HA.pick(gv, Nit));
          var Ma2 = ao.Array, Vl = ao.Date, ef2 = ao.Error, td2 = ao.Function, a0 = ao.Math, bg2 = ao.Object, WZ = ao.RegExp, U6t = ao.String, $S = ao.TypeError, MF = Ma2.prototype, qit = td2.prototype, CF = bg2.prototype, UO = ao["__core-js_shared__"], Ab2 = qit.toString, Vp = CF.hasOwnProperty, TF = 0, Zit = function() {
            var ut = /[^.]+$/.exec(UO && UO.keys && UO.keys.IE_PROTO || "");
            return ut ? "Symbol(src)_1." + ut : "";
          }(), AF = CF.toString, L1t = Ab2.call(bg2), q6t = gv._, Z6t = WZ("^" + Ab2.call(Vp).replace(RE, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), UB = Tb2 ? ao.Buffer : e2, UA = ao.Symbol, qO = ao.Uint8Array, $it = UB ? UB.allocUnsafe : e2, ZO = ZS(bg2.getPrototypeOf, bg2), qE = bg2.create, qB = CF.propertyIsEnumerable, ZB = MF.splice, Yit = UA ? UA.isConcatSpreadable : e2, xP = UA ? UA.iterator : e2, Ib2 = UA ? UA.toStringTag : e2, U_ = function() {
            try {
              var ut = t22(bg2, "defineProperty");
              return ut({}, "", {}), ut;
            } catch {
            }
          }(), IF = ao.clearTimeout !== gv.clearTimeout && ao.clearTimeout, wP = Vl && Vl.now !== gv.Date.now && Vl.now, O1t = ao.setTimeout !== gv.setTimeout && ao.setTimeout, S0 = a0.ceil, $B = a0.floor, DF = bg2.getOwnPropertySymbols, R1t = UB ? UB.isBuffer : e2, ZE = ao.isFinite, N1t = MF.join, $6t = ZS(bg2.keys, bg2), lp = a0.max, Om = a0.min, Y6t = Vl.now, F1t = ao.parseInt, EF = a0.random, V1t = MF.reverse, Kit = t22(ao, "DataView"), YB = t22(ao, "Map"), KB = t22(ao, "Promise"), kF = t22(ao, "Set"), XB = t22(ao, "WeakMap"), PF = t22(bg2, "create"), GZ = XB && new XB(), LF = {}, QB = JE(Kit), B1t = JE(YB), MC = JE(KB), K6t = JE(kF), JB = JE(XB), OF = UA ? UA.prototype : e2, qA = OF ? OF.valueOf : e2, HZ = OF ? OF.toString : e2;
          function Dn(ut) {
            if (Xg2(ut) && !is(ut) && !(ut instanceof oh2)) {
              if (ut instanceof YS)
                return ut;
              if (Vp.call(ut, "__wrapped__"))
                return Cat(ut);
            }
            return new YS(ut);
          }
          var C1 = function() {
            function ut() {
            }
            return function(Tt) {
              if (!Kg2(Tt))
                return {};
              if (qE)
                return qE(Tt);
              ut.prototype = Tt;
              var te2 = new ut();
              return ut.prototype = e2, te2;
            };
          }();
          function RF() {
          }
          function YS(ut, Tt) {
            this.__wrapped__ = ut, this.__actions__ = [], this.__chain__ = !!Tt, this.__index__ = 0, this.__values__ = e2;
          }
          Dn.templateSettings = { escape: S1, evaluate: eM, interpolate: hw, variable: "", imports: { _: Dn } }, Dn.prototype = RF.prototype, Dn.prototype.constructor = Dn, YS.prototype = C1(RF.prototype), YS.prototype.constructor = YS;
          function oh2(ut) {
            this.__wrapped__ = ut, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = ui2, this.__views__ = [];
          }
          function NF() {
            var ut = new oh2(this.__wrapped__);
            return ut.__actions__ = Y_(this.__actions__), ut.__dir__ = this.__dir__, ut.__filtered__ = this.__filtered__, ut.__iteratees__ = Y_(this.__iteratees__), ut.__takeCount__ = this.__takeCount__, ut.__views__ = Y_(this.__views__), ut;
          }
          function KS() {
            if (this.__filtered__) {
              var ut = new oh2(this);
              ut.__dir__ = -1, ut.__filtered__ = true;
            } else
              ut = this.clone(), ut.__dir__ *= -1;
            return ut;
          }
          function Xit() {
            var ut = this.__wrapped__.value(), Tt = this.__dir__, te2 = is(ut), ke2 = Tt < 0, ln = te2 ? ut.length : 0, qn = gNt(0, ln, this.__views__), Vr = qn.start, Yr = qn.end, Pi2 = Yr - Vr, eo = ke2 ? Yr : Vr - 1, Do = this.__iteratees__, Jo = Do.length, cl = 0, cu = Om(Pi2, this.__takeCount__);
            if (!te2 || !ke2 && ln == Pi2 && cu == Pi2)
              return dat(ut, this.__actions__);
            var ku = [];
            t:
              for (; Pi2-- && cl < cu; ) {
                eo += Tt;
                for (var dc2 = -1, Gu = ut[eo]; ++dc2 < Jo; ) {
                  var Eh2 = Do[dc2], _p = Eh2.iteratee, E1 = Eh2.type, Pb2 = _p(Gu);
                  if (E1 == Bn)
                    Gu = Pb2;
                  else if (!Pb2) {
                    if (E1 == Cn)
                      continue t;
                    break t;
                  }
                }
                ku[cl++] = Gu;
              }
            return ku;
          }
          oh2.prototype = C1(RF.prototype), oh2.prototype.constructor = oh2;
          function $O(ut) {
            var Tt = -1, te2 = ut == null ? 0 : ut.length;
            for (this.clear(); ++Tt < te2; ) {
              var ke2 = ut[Tt];
              this.set(ke2[0], ke2[1]);
            }
          }
          function Qit() {
            this.__data__ = PF ? PF(null) : {}, this.size = 0;
          }
          function Jit(ut) {
            var Tt = this.has(ut) && delete this.__data__[ut];
            return this.size -= Tt ? 1 : 0, Tt;
          }
          function X6t(ut) {
            var Tt = this.__data__;
            if (PF) {
              var te2 = Tt[ut];
              return te2 === L ? e2 : te2;
            }
            return Vp.call(Tt, ut) ? Tt[ut] : e2;
          }
          function tz(ut) {
            var Tt = this.__data__;
            return PF ? Tt[ut] !== e2 : Vp.call(Tt, ut);
          }
          function UZ(ut, Tt) {
            var te2 = this.__data__;
            return this.size += this.has(ut) ? 0 : 1, te2[ut] = PF && Tt === e2 ? L : Tt, this;
          }
          $O.prototype.clear = Qit, $O.prototype.delete = Jit, $O.prototype.get = X6t, $O.prototype.has = tz, $O.prototype.set = UZ;
          function T1(ut) {
            var Tt = -1, te2 = ut == null ? 0 : ut.length;
            for (this.clear(); ++Tt < te2; ) {
              var ke2 = ut[Tt];
              this.set(ke2[0], ke2[1]);
            }
          }
          function qZ() {
            this.__data__ = [], this.size = 0;
          }
          function ZZ(ut) {
            var Tt = this.__data__, te2 = KO(Tt, ut);
            if (te2 < 0)
              return false;
            var ke2 = Tt.length - 1;
            return te2 == ke2 ? Tt.pop() : ZB.call(Tt, te2, 1), --this.size, true;
          }
          function FF(ut) {
            var Tt = this.__data__, te2 = KO(Tt, ut);
            return te2 < 0 ? e2 : Tt[te2][1];
          }
          function z1t(ut) {
            return KO(this.__data__, ut) > -1;
          }
          function SP(ut, Tt) {
            var te2 = this.__data__, ke2 = KO(te2, ut);
            return ke2 < 0 ? (++this.size, te2.push([ut, Tt])) : te2[ke2][1] = Tt, this;
          }
          T1.prototype.clear = qZ, T1.prototype.delete = ZZ, T1.prototype.get = FF, T1.prototype.has = z1t, T1.prototype.set = SP;
          function aM(ut) {
            var Tt = -1, te2 = ut == null ? 0 : ut.length;
            for (this.clear(); ++Tt < te2; ) {
              var ke2 = ut[Tt];
              this.set(ke2[0], ke2[1]);
            }
          }
          function tat() {
            this.size = 0, this.__data__ = { hash: new $O(), map: new (YB || T1)(), string: new $O() };
          }
          function Q6t(ut) {
            var Tt = lz(this, ut).delete(ut);
            return this.size -= Tt ? 1 : 0, Tt;
          }
          function J6t(ut) {
            return lz(this, ut).get(ut);
          }
          function tNt(ut) {
            return lz(this, ut).has(ut);
          }
          function eNt(ut, Tt) {
            var te2 = lz(this, ut), ke2 = te2.size;
            return te2.set(ut, Tt), this.size += te2.size == ke2 ? 0 : 1, this;
          }
          aM.prototype.clear = tat, aM.prototype.delete = Q6t, aM.prototype.get = J6t, aM.prototype.has = tNt, aM.prototype.set = eNt;
          function YO(ut) {
            var Tt = -1, te2 = ut == null ? 0 : ut.length;
            for (this.__data__ = new aM(); ++Tt < te2; )
              this.add(ut[Tt]);
          }
          function j1t(ut) {
            return this.__data__.set(ut, L), this;
          }
          function nNt(ut) {
            return this.__data__.has(ut);
          }
          YO.prototype.add = YO.prototype.push = j1t, YO.prototype.has = nNt;
          function CC(ut) {
            var Tt = this.__data__ = new T1(ut);
            this.size = Tt.size;
          }
          function W1t() {
            this.__data__ = new T1(), this.size = 0;
          }
          function G1t(ut) {
            var Tt = this.__data__, te2 = Tt.delete(ut);
            return this.size = Tt.size, te2;
          }
          function rNt(ut) {
            return this.__data__.get(ut);
          }
          function $Z(ut) {
            return this.__data__.has(ut);
          }
          function H1t(ut, Tt) {
            var te2 = this.__data__;
            if (te2 instanceof T1) {
              var ke2 = te2.__data__;
              if (!YB || ke2.length < y2 - 1)
                return ke2.push([ut, Tt]), this.size = ++te2.size, this;
              te2 = this.__data__ = new aM(ke2);
            }
            return te2.set(ut, Tt), this.size = te2.size, this;
          }
          CC.prototype.clear = W1t, CC.prototype.delete = G1t, CC.prototype.get = rNt, CC.prototype.has = $Z, CC.prototype.set = H1t;
          function eat(ut, Tt) {
            var te2 = is(ut), ke2 = !te2 && Zc2(ut), ln = !te2 && !ke2 && aI(ut), qn = !te2 && !ke2 && !ln && YF(ut), Vr = te2 || ke2 || ln || qn, Yr = Vr ? gw(ut.length, U6t) : [], Pi2 = Yr.length;
            for (var eo in ut)
              (Tt || Vp.call(ut, eo)) && !(Vr && (eo == "length" || ln && (eo == "offset" || eo == "parent") || qn && (eo == "buffer" || eo == "byteLength" || eo == "byteOffset") || $d2(eo, Pi2))) && Yr.push(eo);
            return Yr;
          }
          function U1t(ut) {
            var Tt = ut.length;
            return Tt ? ut[AP(0, Tt - 1)] : e2;
          }
          function nat(ut, Tt) {
            return e22(Y_(ut), XO(Tt, 0, ut.length));
          }
          function $E(ut) {
            return e22(Y_(ut));
          }
          function ez(ut, Tt, te2) {
            (te2 !== e2 && !uM(ut[Tt], te2) || te2 === e2 && !(Tt in ut)) && XS(ut, Tt, te2);
          }
          function nz(ut, Tt, te2) {
            var ke2 = ut[Tt];
            (!(Vp.call(ut, Tt) && uM(ke2, te2)) || te2 === e2 && !(Tt in ut)) && XS(ut, Tt, te2);
          }
          function KO(ut, Tt) {
            for (var te2 = ut.length; te2--; )
              if (uM(ut[te2][0], Tt))
                return te2;
            return -1;
          }
          function q1t(ut, Tt, te2, ke2) {
            return ZA(ut, function(ln, qn, Vr) {
              Tt(ke2, ln, te2(ln), Vr);
            }), ke2;
          }
          function Z1t(ut, Tt) {
            return ut && TC(Tt, Xy(Tt), ut);
          }
          function iNt(ut, Tt) {
            return ut && TC(Tt, xw(Tt), ut);
          }
          function XS(ut, Tt, te2) {
            Tt == "__proto__" && U_ ? U_(ut, Tt, { configurable: true, enumerable: true, value: te2, writable: true }) : ut[Tt] = te2;
          }
          function VF(ut, Tt) {
            for (var te2 = -1, ke2 = Tt.length, ln = Ma2(ke2), qn = ut == null; ++te2 < ke2; )
              ln[te2] = qn ? e2 : Ky(ut, Tt[te2]);
            return ln;
          }
          function XO(ut, Tt, te2) {
            return ut === ut && (te2 !== e2 && (ut = ut <= te2 ? ut : te2), Tt !== e2 && (ut = ut >= Tt ? ut : Tt)), ut;
          }
          function q_(ut, Tt, te2, ke2, ln, qn) {
            var Vr, Yr = Tt & U3, Pi2 = Tt & Y3, eo = Tt & Q;
            if (te2 && (Vr = ln ? te2(ut, ke2, ln, qn) : te2(ut)), Vr !== e2)
              return Vr;
            if (!Kg2(ut))
              return ut;
            var Do = is(ut);
            if (Do) {
              if (Vr = yNt(ut), !Yr)
                return Y_(ut, Vr);
            } else {
              var Jo = I1(ut), cl = Jo == Fl || Jo == Ih2;
              if (aI(ut))
                return rbt(ut, Yr);
              if (Jo == Np || Jo == hl || cl && !ln) {
                if (Vr = Pi2 || cl ? {} : xbt(ut), !Yr)
                  return Pi2 ? uu(ut, iNt(Vr, ut)) : sbt(ut, Z1t(Vr, ut));
              } else {
                if (!mg2[Jo])
                  return ln ? ut : {};
                Vr = mNt(ut, Jo, Yr);
              }
            }
            qn || (qn = new CC());
            var cu = qn.get(ut);
            if (cu)
              return cu;
            qn.set(ut, Vr), oI(ut) ? ut.forEach(function(Gu) {
              Vr.add(q_(Gu, Tt, te2, Gu, ut, qn));
            }) : g4(ut) && ut.forEach(function(Gu, Eh2) {
              Vr.set(Eh2, q_(Gu, Tt, te2, Eh2, ut, qn));
            });
            var ku = eo ? Pi2 ? p$ : h$ : Pi2 ? xw : Xy, dc2 = Do ? e2 : ku(ut);
            return Jp(dc2 || ut, function(Gu, Eh2) {
              dc2 && (Eh2 = Gu, Gu = ut[Eh2]), nz(Vr, Eh2, q_(Gu, Tt, te2, Eh2, ut, qn));
            }), Vr;
          }
          function YZ(ut) {
            var Tt = Xy(ut);
            return function(te2) {
              return rat(te2, ut, Tt);
            };
          }
          function rat(ut, Tt, te2) {
            var ke2 = te2.length;
            if (ut == null)
              return !ke2;
            for (ut = bg2(ut); ke2--; ) {
              var ln = te2[ke2], qn = Tt[ln], Vr = ut[ln];
              if (Vr === e2 && !(ln in ut) || !qn(Vr))
                return false;
            }
            return true;
          }
          function BF(ut, Tt, te2) {
            if (typeof ut != "function")
              throw new $S(C);
            return ZF(function() {
              ut.apply(e2, te2);
            }, Tt);
          }
          function QO(ut, Tt, te2, ke2) {
            var ln = -1, qn = nM, Vr = true, Yr = ut.length, Pi2 = [], eo = Tt.length;
            if (!Yr)
              return Pi2;
            te2 && (Tt = vv(Tt, vw(te2))), ke2 ? (qn = Fit, Vr = false) : Tt.length >= y2 && (qn = HO, Vr = false, Tt = new YO(Tt));
            t:
              for (; ++ln < Yr; ) {
                var Do = ut[ln], Jo = te2 == null ? Do : te2(Do);
                if (Do = ke2 || Do !== 0 ? Do : 0, Vr && Jo === Jo) {
                  for (var cl = eo; cl--; )
                    if (Tt[cl] === Jo)
                      continue t;
                  Pi2.push(Do);
                } else
                  qn(Tt, Jo, ke2) || Pi2.push(Do);
              }
            return Pi2;
          }
          var ZA = lbt($A), iat = lbt(aat, true);
          function $1t(ut, Tt) {
            var te2 = true;
            return ZA(ut, function(ke2, ln, qn) {
              return te2 = !!Tt(ke2, ln, qn), te2;
            }), te2;
          }
          function JO(ut, Tt, te2) {
            for (var ke2 = -1, ln = ut.length; ++ke2 < ln; ) {
              var qn = ut[ke2], Vr = Tt(qn);
              if (Vr != null && (Yr === e2 ? Vr === Vr && !n2(Vr) : te2(Vr, Yr)))
                var Yr = Vr, Pi2 = qn;
            }
            return Pi2;
          }
          function rz(ut, Tt, te2, ke2) {
            var ln = ut.length;
            for (te2 = pc2(te2), te2 < 0 && (te2 = -te2 > ln ? 0 : ln + te2), ke2 = ke2 === e2 || ke2 > ln ? ln : pc2(ke2), ke2 < 0 && (ke2 += ln), ke2 = te2 > ke2 ? 0 : Jat(ke2); te2 < ke2; )
              ut[te2++] = Tt;
            return ut;
          }
          function Y1t(ut, Tt) {
            var te2 = [];
            return ZA(ut, function(ke2, ln, qn) {
              Tt(ke2, ln, qn) && te2.push(ke2);
            }), te2;
          }
          function Yy(ut, Tt, te2, ke2, ln) {
            var qn = -1, Vr = ut.length;
            for (te2 || (te2 = uz), ln || (ln = []); ++qn < Vr; ) {
              var Yr = ut[qn];
              Tt > 0 && te2(Yr) ? Tt > 1 ? Yy(Yr, Tt - 1, te2, ke2, ln) : WA(ln, Yr) : ke2 || (ln[ln.length] = Yr);
            }
            return ln;
          }
          var MP = ubt(), K1t = ubt(true);
          function $A(ut, Tt) {
            return ut && MP(ut, Tt, Xy);
          }
          function aat(ut, Tt) {
            return ut && K1t(ut, Tt, Xy);
          }
          function zF(ut, Tt) {
            return w0(Tt, function(te2) {
              return tx(ut[te2]);
            });
          }
          function YE(ut, Tt) {
            Tt = Rm(Tt, ut);
            for (var te2 = 0, ke2 = Tt.length; ut != null && te2 < ke2; )
              ut = ut[tI(Tt[te2++])];
            return te2 && te2 == ke2 ? ut : e2;
          }
          function oat(ut, Tt, te2) {
            var ke2 = Tt(ut);
            return is(ut) ? ke2 : WA(ke2, te2(ut));
          }
          function Db2(ut) {
            return ut == null ? ut === e2 ? VA : Uh2 : Ib2 && Ib2 in bg2(ut) ? mbt(ut) : wNt(ut);
          }
          function iz(ut, Tt) {
            return ut > Tt;
          }
          function aNt(ut, Tt) {
            return ut != null && Vp.call(ut, Tt);
          }
          function sat(ut, Tt) {
            return ut != null && Tt in bg2(ut);
          }
          function oNt(ut, Tt, te2) {
            return ut >= Om(Tt, te2) && ut < lp(Tt, te2);
          }
          function KZ(ut, Tt, te2) {
            for (var ke2 = te2 ? Fit : nM, ln = ut[0].length, qn = ut.length, Vr = qn, Yr = Ma2(qn), Pi2 = 1 / 0, eo = []; Vr--; ) {
              var Do = ut[Vr];
              Vr && Tt && (Do = vv(Do, vw(Tt))), Pi2 = Om(Do.length, Pi2), Yr[Vr] = !te2 && (Tt || ln >= 120 && Do.length >= 120) ? new YO(Vr && Do) : e2;
            }
            Do = ut[0];
            var Jo = -1, cl = Yr[0];
            t:
              for (; ++Jo < ln && eo.length < Pi2; ) {
                var cu = Do[Jo], ku = Tt ? Tt(cu) : cu;
                if (cu = te2 || cu !== 0 ? cu : 0, !(cl ? HO(cl, ku) : ke2(eo, ku, te2))) {
                  for (Vr = qn; --Vr; ) {
                    var dc2 = Yr[Vr];
                    if (!(dc2 ? HO(dc2, ku) : ke2(ut[Vr], ku, te2)))
                      continue t;
                  }
                  cl && cl.push(ku), eo.push(cu);
                }
              }
            return eo;
          }
          function sNt(ut, Tt, te2, ke2) {
            return $A(ut, function(ln, qn, Vr) {
              Tt(ke2, te2(ln), qn, Vr);
            }), ke2;
          }
          function Z_(ut, Tt, te2) {
            Tt = Rm(Tt, ut), ut = xat(ut, Tt);
            var ke2 = ut == null ? ut : ut[tI(mw(Tt))];
            return ke2 == null ? e2 : dw(ke2, ut, te2);
          }
          function XZ(ut) {
            return Xg2(ut) && Db2(ut) == hl;
          }
          function lNt(ut) {
            return Xg2(ut) && Db2(ut) == Ji2;
          }
          function uNt(ut) {
            return Xg2(ut) && Db2(ut) == Gs;
          }
          function CP(ut, Tt, te2, ke2, ln) {
            return ut === Tt ? true : ut == null || Tt == null || !Xg2(ut) && !Xg2(Tt) ? ut !== ut && Tt !== Tt : lat(ut, Tt, te2, ke2, CP, ln);
          }
          function lat(ut, Tt, te2, ke2, ln, qn) {
            var Vr = is(ut), Yr = is(Tt), Pi2 = Vr ? Qs : I1(ut), eo = Yr ? Qs : I1(Tt);
            Pi2 = Pi2 == hl ? Np : Pi2, eo = eo == hl ? Np : eo;
            var Do = Pi2 == Np, Jo = eo == Np, cl = Pi2 == eo;
            if (cl && aI(ut)) {
              if (!aI(Tt))
                return false;
              Vr = true, Do = false;
            }
            if (cl && !Do)
              return qn || (qn = new CC()), Vr || YF(ut) ? f$(ut, Tt, te2, ke2, ln, qn) : ybt(ut, Tt, Pi2, te2, ke2, ln, qn);
            if (!(te2 & nt)) {
              var cu = Do && Vp.call(ut, "__wrapped__"), ku = Jo && Vp.call(Tt, "__wrapped__");
              if (cu || ku) {
                var dc2 = cu ? ut.value() : ut, Gu = ku ? Tt.value() : Tt;
                return qn || (qn = new CC()), ln(dc2, Gu, te2, ke2, qn);
              }
            }
            return cl ? (qn || (qn = new CC()), QE(ut, Tt, te2, ke2, ln, qn)) : false;
          }
          function X1t(ut) {
            return Xg2(ut) && I1(ut) == lu;
          }
          function uat(ut, Tt, te2, ke2) {
            var ln = te2.length, qn = ln, Vr = !ke2;
            if (ut == null)
              return !qn;
            for (ut = bg2(ut); ln--; ) {
              var Yr = te2[ln];
              if (Vr && Yr[2] ? Yr[1] !== ut[Yr[0]] : !(Yr[0] in ut))
                return false;
            }
            for (; ++ln < qn; ) {
              Yr = te2[ln];
              var Pi2 = Yr[0], eo = ut[Pi2], Do = Yr[1];
              if (Vr && Yr[2]) {
                if (eo === e2 && !(Pi2 in ut))
                  return false;
              } else {
                var Jo = new CC();
                if (ke2)
                  var cl = ke2(eo, Do, Pi2, ut, Tt, Jo);
                if (!(cl === e2 ? CP(Do, eo, nt | dt, ke2, Jo) : cl))
                  return false;
              }
            }
            return true;
          }
          function Q1t(ut) {
            if (!Kg2(ut) || _Nt(ut))
              return false;
            var Tt = tx(ut) ? Z6t : to;
            return Tt.test(JE(ut));
          }
          function J1t(ut) {
            return Xg2(ut) && Db2(ut) == w1;
          }
          function QZ(ut) {
            return Xg2(ut) && I1(ut) == Zd2;
          }
          function cat(ut) {
            return Xg2(ut) && GP(ut.length) && !!ys[Db2(ut)];
          }
          function JZ(ut) {
            return typeof ut == "function" ? ut : ut == null ? ex : typeof ut == "object" ? is(ut) ? YA(ut[0], ut[1]) : t$(ut) : vot(ut);
          }
          function az(ut) {
            if (!AC(ut))
              return $6t(ut);
            var Tt = [];
            for (var te2 in bg2(ut))
              Vp.call(ut, te2) && te2 != "constructor" && Tt.push(te2);
            return Tt;
          }
          function cNt(ut) {
            if (!Kg2(ut))
              return Y0(ut);
            var Tt = AC(ut), te2 = [];
            for (var ke2 in ut)
              ke2 == "constructor" && (Tt || !Vp.call(ut, ke2)) || te2.push(ke2);
            return te2;
          }
          function yw(ut, Tt) {
            return ut < Tt;
          }
          function oz(ut, Tt) {
            var te2 = -1, ke2 = Q_(ut) ? Ma2(ut.length) : [];
            return ZA(ut, function(ln, qn, Vr) {
              ke2[++te2] = Tt(ln, qn, Vr);
            }), ke2;
          }
          function t$(ut) {
            var Tt = Tp(ut);
            return Tt.length == 1 && Tt[0][2] ? Sbt(Tt[0][0], Tt[0][1]) : function(te2) {
              return te2 === ut || uat(te2, ut, Tt);
            };
          }
          function YA(ut, Tt) {
            return s4(ut) && Ff2(Tt) ? Sbt(tI(ut), Tt) : function(te2) {
              var ke2 = Ky(te2, ut);
              return ke2 === e2 && ke2 === Tt ? _4(te2, ut) : CP(Tt, ke2, nt | dt);
            };
          }
          function QS(ut, Tt, te2, ke2, ln) {
            ut !== Tt && MP(Tt, function(qn, Vr) {
              if (ln || (ln = new CC()), Kg2(qn))
                t4(ut, Tt, Vr, te2, QS, ke2, ln);
              else {
                var Yr = ke2 ? ke2(wat(ut, Vr), qn, Vr + "", ut, Tt, ln) : e2;
                Yr === e2 && (Yr = qn), ez(ut, Vr, Yr);
              }
            }, xw);
          }
          function t4(ut, Tt, te2, ke2, ln, qn, Vr) {
            var Yr = wat(ut, te2), Pi2 = wat(Tt, te2), eo = Vr.get(Pi2);
            if (eo) {
              ez(ut, te2, eo);
              return;
            }
            var Do = qn ? qn(Yr, Pi2, te2 + "", ut, Tt, Vr) : e2, Jo = Do === e2;
            if (Jo) {
              var cl = is(Pi2), cu = !cl && aI(Pi2), ku = !cl && !cu && YF(Pi2);
              Do = Pi2, cl || cu || ku ? is(Yr) ? Do = Yr : M0(Yr) ? Do = Y_(Yr) : cu ? (Jo = false, Do = rbt(Pi2, true)) : ku ? (Jo = false, Do = a$(Pi2, true)) : Do = [] : bz(Pi2) || Zc2(Pi2) ? (Do = Yr, Zc2(Yr) ? Do = tot(Yr) : (!Kg2(Yr) || tx(Yr)) && (Do = xbt(Pi2))) : Jo = false;
            }
            Jo && (Vr.set(Pi2, Do), ln(Do, Pi2, ke2, qn, Vr), Vr.delete(Pi2)), ez(ut, te2, Do);
          }
          function e$(ut, Tt) {
            var te2 = ut.length;
            if (te2)
              return Tt += Tt < 0 ? te2 : 0, $d2(Tt, te2) ? ut[Tt] : e2;
          }
          function e4(ut, Tt, te2) {
            Tt.length ? Tt = vv(Tt, function(qn) {
              return is(qn) ? function(Vr) {
                return YE(Vr, qn.length === 1 ? qn[0] : qn);
              } : qn;
            }) : Tt = [ex];
            var ke2 = -1;
            Tt = vv(Tt, vw(Ju()));
            var ln = oz(ut, function(qn, Vr, Yr) {
              var Pi2 = vv(Tt, function(eo) {
                return eo(qn);
              });
              return { criteria: Pi2, index: ++ke2, value: qn };
            });
            return N6t(ln, function(qn, Vr) {
              return pNt(qn, Vr, te2);
            });
          }
          function fNt(ut, Tt) {
            return fat(ut, Tt, function(te2, ke2) {
              return _4(ut, ke2);
            });
          }
          function fat(ut, Tt, te2) {
            for (var ke2 = -1, ln = Tt.length, qn = {}; ++ke2 < ln; ) {
              var Vr = Tt[ke2], Yr = YE(ut, Vr);
              te2(Yr, Vr) && JS(qn, Rm(Vr, ut), Yr);
            }
            return qn;
          }
          function tbt(ut) {
            return function(Tt) {
              return YE(Tt, ut);
            };
          }
          function KE(ut, Tt, te2, ke2) {
            var ln = ke2 ? VZ : rM, qn = -1, Vr = Tt.length, Yr = ut;
            for (ut === Tt && (Tt = Y_(Tt)), te2 && (Yr = vv(ut, vw(te2))); ++qn < Vr; )
              for (var Pi2 = 0, eo = Tt[qn], Do = te2 ? te2(eo) : eo; (Pi2 = ln(Yr, Do, Pi2, ke2)) > -1; )
                Yr !== ut && ZB.call(Yr, Pi2, 1), ZB.call(ut, Pi2, 1);
            return ut;
          }
          function TP(ut, Tt) {
            for (var te2 = ut ? Tt.length : 0, ke2 = te2 - 1; te2--; ) {
              var ln = Tt[te2];
              if (te2 == ke2 || ln !== qn) {
                var qn = ln;
                $d2(ln) ? ZB.call(ut, ln, 1) : Qu(ut, ln);
              }
            }
            return ut;
          }
          function AP(ut, Tt) {
            return ut + $B(EF() * (Tt - ut + 1));
          }
          function hat(ut, Tt, te2, ke2) {
            for (var ln = -1, qn = lp(S0((Tt - ut) / (te2 || 1)), 0), Vr = Ma2(qn); qn--; )
              Vr[ke2 ? qn : ++ln] = ut, ut += te2;
            return Vr;
          }
          function sz(ut, Tt) {
            var te2 = "";
            if (!ut || Tt < 1 || Tt > Kn)
              return te2;
            do
              Tt % 2 && (te2 += ut), Tt = $B(Tt / 2), Tt && (ut += ut);
            while (Tt);
            return te2;
          }
          function sh2(ut, Tt) {
            return Sat(qF(ut, Tt, ex), ut + "");
          }
          function KA(ut) {
            return U1t(x4(ut));
          }
          function ebt(ut, Tt) {
            var te2 = x4(ut);
            return e22(te2, XO(Tt, 0, te2.length));
          }
          function JS(ut, Tt, te2, ke2) {
            if (!Kg2(ut))
              return ut;
            Tt = Rm(Tt, ut);
            for (var ln = -1, qn = Tt.length, Vr = qn - 1, Yr = ut; Yr != null && ++ln < qn; ) {
              var Pi2 = tI(Tt[ln]), eo = te2;
              if (Pi2 === "__proto__" || Pi2 === "constructor" || Pi2 === "prototype")
                return ut;
              if (ln != Vr) {
                var Do = Yr[Pi2];
                eo = ke2 ? ke2(Do, Pi2, Yr) : e2, eo === e2 && (eo = Kg2(Do) ? Do : $d2(Tt[ln + 1]) ? [] : {});
              }
              nz(Yr, Pi2, eo), Yr = Yr[Pi2];
            }
            return ut;
          }
          var nbt = GZ ? function(ut, Tt) {
            return GZ.set(ut, Tt), ut;
          } : ex, Vu = U_ ? function(ut, Tt) {
            return U_(ut, "toString", { configurable: true, enumerable: false, value: O$(Tt), writable: true });
          } : ex;
          function n$(ut) {
            return e22(x4(ut));
          }
          function $_(ut, Tt, te2) {
            var ke2 = -1, ln = ut.length;
            Tt < 0 && (Tt = -Tt > ln ? 0 : ln + Tt), te2 = te2 > ln ? ln : te2, te2 < 0 && (te2 += ln), ln = Tt > te2 ? 0 : te2 - Tt >>> 0, Tt >>>= 0;
            for (var qn = Ma2(ln); ++ke2 < ln; )
              qn[ke2] = ut[ke2 + Tt];
            return qn;
          }
          function n4(ut, Tt) {
            var te2;
            return ZA(ut, function(ke2, ln, qn) {
              return te2 = Tt(ke2, ln, qn), !te2;
            }), !!te2;
          }
          function XA(ut, Tt, te2) {
            var ke2 = 0, ln = ut == null ? ke2 : ut.length;
            if (typeof Tt == "number" && Tt === Tt && ln <= ko) {
              for (; ke2 < ln; ) {
                var qn = ke2 + ln >>> 1, Vr = ut[qn];
                Vr !== null && !n2(Vr) && (te2 ? Vr <= Tt : Vr < Tt) ? ke2 = qn + 1 : ln = qn;
              }
              return ln;
            }
            return XE(ut, Tt, ex, te2);
          }
          function XE(ut, Tt, te2, ke2) {
            var ln = 0, qn = ut == null ? 0 : ut.length;
            if (qn === 0)
              return 0;
            Tt = te2(Tt);
            for (var Vr = Tt !== Tt, Yr = Tt === null, Pi2 = n2(Tt), eo = Tt === e2; ln < qn; ) {
              var Do = $B((ln + qn) / 2), Jo = te2(ut[Do]), cl = Jo !== e2, cu = Jo === null, ku = Jo === Jo, dc2 = n2(Jo);
              if (Vr)
                var Gu = ke2 || ku;
              else
                eo ? Gu = ku && (ke2 || cl) : Yr ? Gu = ku && cl && (ke2 || !cu) : Pi2 ? Gu = ku && cl && !cu && (ke2 || !dc2) : cu || dc2 ? Gu = false : Gu = ke2 ? Jo <= Tt : Jo < Tt;
              Gu ? ln = Do + 1 : qn = Do;
            }
            return Om(qn, vi2);
          }
          function IP(ut, Tt) {
            for (var te2 = -1, ke2 = ut.length, ln = 0, qn = []; ++te2 < ke2; ) {
              var Vr = ut[te2], Yr = Tt ? Tt(Vr) : Vr;
              if (!te2 || !uM(Yr, Pi2)) {
                var Pi2 = Yr;
                qn[ln++] = Vr === 0 ? 0 : Vr;
              }
            }
            return qn;
          }
          function jF(ut) {
            return typeof ut == "number" ? ut : n2(ut) ? Cr : +ut;
          }
          function A1(ut) {
            if (typeof ut == "string")
              return ut;
            if (is(ut))
              return vv(ut, A1) + "";
            if (n2(ut))
              return HZ ? HZ.call(ut) : "";
            var Tt = ut + "";
            return Tt == "0" && 1 / ut == -Kr ? "-0" : Tt;
          }
          function DP(ut, Tt, te2) {
            var ke2 = -1, ln = nM, qn = ut.length, Vr = true, Yr = [], Pi2 = Yr;
            if (te2)
              Vr = false, ln = Fit;
            else if (qn >= y2) {
              var eo = Tt ? null : u$(ut);
              if (eo)
                return wF(eo);
              Vr = false, ln = HO, Pi2 = new YO();
            } else
              Pi2 = Tt ? [] : Yr;
            t:
              for (; ++ke2 < qn; ) {
                var Do = ut[ke2], Jo = Tt ? Tt(Do) : Do;
                if (Do = te2 || Do !== 0 ? Do : 0, Vr && Jo === Jo) {
                  for (var cl = Pi2.length; cl--; )
                    if (Pi2[cl] === Jo)
                      continue t;
                  Tt && Pi2.push(Jo), Yr.push(Do);
                } else
                  ln(Pi2, Jo, te2) || (Pi2 !== Yr && Pi2.push(Jo), Yr.push(Do));
              }
            return Yr;
          }
          function Qu(ut, Tt) {
            return Tt = Rm(Tt, ut), ut = xat(ut, Tt), ut == null || delete ut[tI(mw(Tt))];
          }
          function pat(ut, Tt, te2, ke2) {
            return JS(ut, Tt, te2(YE(ut, Tt)), ke2);
          }
          function Eb2(ut, Tt, te2, ke2) {
            for (var ln = ut.length, qn = ke2 ? ln : -1; (ke2 ? qn-- : ++qn < ln) && Tt(ut[qn], qn, ut); )
              ;
            return te2 ? $_(ut, ke2 ? 0 : qn, ke2 ? qn + 1 : ln) : $_(ut, ke2 ? qn + 1 : 0, ke2 ? ln : qn);
          }
          function dat(ut, Tt) {
            var te2 = ut;
            return te2 instanceof oh2 && (te2 = te2.value()), WE(Tt, function(ke2, ln) {
              return ln.func.apply(ln.thisArg, WA([ke2], ln.args));
            }, te2);
          }
          function r4(ut, Tt, te2) {
            var ke2 = ut.length;
            if (ke2 < 2)
              return ke2 ? DP(ut[0]) : [];
            for (var ln = -1, qn = Ma2(ke2); ++ln < ke2; )
              for (var Vr = ut[ln], Yr = -1; ++Yr < ke2; )
                Yr != ln && (qn[ln] = QO(qn[ln] || Vr, ut[Yr], Tt, te2));
            return DP(Yy(qn, 1), Tt, te2);
          }
          function WF(ut, Tt, te2) {
            for (var ke2 = -1, ln = ut.length, qn = Tt.length, Vr = {}; ++ke2 < ln; ) {
              var Yr = ke2 < qn ? Tt[ke2] : e2;
              te2(Vr, ut[ke2], Yr);
            }
            return Vr;
          }
          function EP(ut) {
            return M0(ut) ? ut : [];
          }
          function GF(ut) {
            return typeof ut == "function" ? ut : ex;
          }
          function Rm(ut, Tt) {
            return is(ut) ? ut : s4(ut, Tt) ? [ut] : Mbt(hd2(ut));
          }
          var r$ = sh2;
          function QA(ut, Tt, te2) {
            var ke2 = ut.length;
            return te2 = te2 === e2 ? ke2 : te2, !Tt && te2 >= ke2 ? ut : $_(ut, Tt, te2);
          }
          var i$ = IF || function(ut) {
            return gv.clearTimeout(ut);
          };
          function rbt(ut, Tt) {
            if (Tt)
              return ut.slice();
            var te2 = ut.length, ke2 = $it ? $it(te2) : new ut.constructor(te2);
            return ut.copy(ke2), ke2;
          }
          function kP(ut) {
            var Tt = new ut.constructor(ut.byteLength);
            return new qO(Tt).set(new qO(ut)), Tt;
          }
          function hNt(ut, Tt) {
            var te2 = Tt ? kP(ut.buffer) : ut.buffer;
            return new ut.constructor(te2, ut.byteOffset, ut.byteLength);
          }
          function gat(ut) {
            var Tt = new ut.constructor(ut.source, fr.exec(ut));
            return Tt.lastIndex = ut.lastIndex, Tt;
          }
          function vat(ut) {
            return qA ? bg2(qA.call(ut)) : {};
          }
          function a$(ut, Tt) {
            var te2 = Tt ? kP(ut.buffer) : ut.buffer;
            return new ut.constructor(te2, ut.byteOffset, ut.length);
          }
          function ibt(ut, Tt) {
            if (ut !== Tt) {
              var te2 = ut !== e2, ke2 = ut === null, ln = ut === ut, qn = n2(ut), Vr = Tt !== e2, Yr = Tt === null, Pi2 = Tt === Tt, eo = n2(Tt);
              if (!Yr && !eo && !qn && ut > Tt || qn && Vr && Pi2 && !Yr && !eo || ke2 && Vr && Pi2 || !te2 && Pi2 || !ln)
                return 1;
              if (!ke2 && !qn && !eo && ut < Tt || eo && te2 && ln && !ke2 && !qn || Yr && te2 && ln || !Vr && ln || !Pi2)
                return -1;
            }
            return 0;
          }
          function pNt(ut, Tt, te2) {
            for (var ke2 = -1, ln = ut.criteria, qn = Tt.criteria, Vr = ln.length, Yr = te2.length; ++ke2 < Vr; ) {
              var Pi2 = ibt(ln[ke2], qn[ke2]);
              if (Pi2) {
                if (ke2 >= Yr)
                  return Pi2;
                var eo = te2[ke2];
                return Pi2 * (eo == "desc" ? -1 : 1);
              }
            }
            return ut.index - Tt.index;
          }
          function abt(ut, Tt, te2, ke2) {
            for (var ln = -1, qn = ut.length, Vr = te2.length, Yr = -1, Pi2 = Tt.length, eo = lp(qn - Vr, 0), Do = Ma2(Pi2 + eo), Jo = !ke2; ++Yr < Pi2; )
              Do[Yr] = Tt[Yr];
            for (; ++ln < Vr; )
              (Jo || ln < qn) && (Do[te2[ln]] = ut[ln]);
            for (; eo--; )
              Do[Yr++] = ut[ln++];
            return Do;
          }
          function obt(ut, Tt, te2, ke2) {
            for (var ln = -1, qn = ut.length, Vr = -1, Yr = te2.length, Pi2 = -1, eo = Tt.length, Do = lp(qn - Yr, 0), Jo = Ma2(Do + eo), cl = !ke2; ++ln < Do; )
              Jo[ln] = ut[ln];
            for (var cu = ln; ++Pi2 < eo; )
              Jo[cu + Pi2] = Tt[Pi2];
            for (; ++Vr < Yr; )
              (cl || ln < qn) && (Jo[cu + te2[Vr]] = ut[ln++]);
            return Jo;
          }
          function Y_(ut, Tt) {
            var te2 = -1, ke2 = ut.length;
            for (Tt || (Tt = Ma2(ke2)); ++te2 < ke2; )
              Tt[te2] = ut[te2];
            return Tt;
          }
          function TC(ut, Tt, te2, ke2) {
            var ln = !te2;
            te2 || (te2 = {});
            for (var qn = -1, Vr = Tt.length; ++qn < Vr; ) {
              var Yr = Tt[qn], Pi2 = ke2 ? ke2(te2[Yr], ut[Yr], Yr, te2, ut) : e2;
              Pi2 === e2 && (Pi2 = ut[Yr]), ln ? XS(te2, Yr, Pi2) : nz(te2, Yr, Pi2);
            }
            return te2;
          }
          function sbt(ut, Tt) {
            return TC(ut, PP(ut), Tt);
          }
          function uu(ut, Tt) {
            return TC(ut, bbt(ut), Tt);
          }
          function i4(ut, Tt) {
            return function(te2, ke2) {
              var ln = is(te2) ? Fs : q1t, qn = Tt ? Tt() : {};
              return ln(te2, ut, Ju(ke2, 2), qn);
            };
          }
          function a4(ut) {
            return sh2(function(Tt, te2) {
              var ke2 = -1, ln = te2.length, qn = ln > 1 ? te2[ln - 1] : e2, Vr = ln > 2 ? te2[2] : e2;
              for (qn = ut.length > 3 && typeof qn == "function" ? (ln--, qn) : e2, Vr && D1(te2[0], te2[1], Vr) && (qn = ln < 3 ? e2 : qn, ln = 1), Tt = bg2(Tt); ++ke2 < ln; ) {
                var Yr = te2[ke2];
                Yr && ut(Tt, Yr, ke2, qn);
              }
              return Tt;
            });
          }
          function lbt(ut, Tt) {
            return function(te2, ke2) {
              if (te2 == null)
                return te2;
              if (!Q_(te2))
                return ut(te2, ke2);
              for (var ln = te2.length, qn = Tt ? ln : -1, Vr = bg2(te2); (Tt ? qn-- : ++qn < ln) && ke2(Vr[qn], qn, Vr) !== false; )
                ;
              return te2;
            };
          }
          function ubt(ut) {
            return function(Tt, te2, ke2) {
              for (var ln = -1, qn = bg2(Tt), Vr = ke2(Tt), Yr = Vr.length; Yr--; ) {
                var Pi2 = Vr[ut ? Yr : ++ln];
                if (te2(qn[Pi2], Pi2, qn) === false)
                  break;
              }
              return Tt;
            };
          }
          function dNt(ut, Tt, te2) {
            var ke2 = Tt & vt, ln = UF(ut);
            function qn() {
              var Vr = this && this !== gv && this instanceof qn ? ln : ut;
              return Vr.apply(ke2 ? te2 : this, arguments);
            }
            return qn;
          }
          function yat(ut) {
            return function(Tt) {
              Tt = hd2(Tt);
              var te2 = xF(Tt) ? iM(Tt) : e2, ke2 = te2 ? te2[0] : Tt.charAt(0), ln = te2 ? QA(te2, 1).join("") : Tt.slice(1);
              return ke2[ut]() + ln;
            };
          }
          function HF(ut) {
            return function(Tt) {
              return WE(pot(uot(Tt).replace(L6t, "")), ut, "");
            };
          }
          function UF(ut) {
            return function() {
              var Tt = arguments;
              switch (Tt.length) {
                case 0:
                  return new ut();
                case 1:
                  return new ut(Tt[0]);
                case 2:
                  return new ut(Tt[0], Tt[1]);
                case 3:
                  return new ut(Tt[0], Tt[1], Tt[2]);
                case 4:
                  return new ut(Tt[0], Tt[1], Tt[2], Tt[3]);
                case 5:
                  return new ut(Tt[0], Tt[1], Tt[2], Tt[3], Tt[4]);
                case 6:
                  return new ut(Tt[0], Tt[1], Tt[2], Tt[3], Tt[4], Tt[5]);
                case 7:
                  return new ut(Tt[0], Tt[1], Tt[2], Tt[3], Tt[4], Tt[5], Tt[6]);
              }
              var te2 = C1(ut.prototype), ke2 = ut.apply(te2, Tt);
              return Kg2(ke2) ? ke2 : te2;
            };
          }
          function cbt(ut, Tt, te2) {
            var ke2 = UF(ut);
            function ln() {
              for (var qn = arguments.length, Vr = Ma2(qn), Yr = qn, Pi2 = o4(ln); Yr--; )
                Vr[Yr] = arguments[Yr];
              var eo = qn < 3 && Vr[0] !== Pi2 && Vr[qn - 1] !== Pi2 ? [] : _P(Vr, Pi2);
              if (qn -= eo.length, qn < te2)
                return mat(ut, Tt, Qo, ln.placeholder, e2, Vr, eo, e2, e2, te2 - qn);
              var Do = this && this !== gv && this instanceof ln ? ke2 : ut;
              return dw(Do, this, Vr);
            }
            return ln;
          }
          function fbt(ut) {
            return function(Tt, te2, ke2) {
              var ln = bg2(Tt);
              if (!Q_(Tt)) {
                var qn = Ju(te2, 3);
                Tt = Xy(Tt), te2 = function(Yr) {
                  return qn(ln[Yr], Yr, ln);
                };
              }
              var Vr = ut(Tt, te2, ke2);
              return Vr > -1 ? ln[qn ? Tt[Vr] : Vr] : e2;
            };
          }
          function bp(ut) {
            return JA(function(Tt) {
              var te2 = Tt.length, ke2 = te2, ln = YS.prototype.thru;
              for (ut && Tt.reverse(); ke2--; ) {
                var qn = Tt[ke2];
                if (typeof qn != "function")
                  throw new $S(C);
                if (ln && !Vr && lh2(qn) == "wrapper")
                  var Vr = new YS([], true);
              }
              for (ke2 = Vr ? ke2 : te2; ++ke2 < te2; ) {
                qn = Tt[ke2];
                var Yr = lh2(qn), Pi2 = Yr == "wrapper" ? d$(qn) : e2;
                Pi2 && bat(Pi2[0]) && Pi2[1] == (he2 | jt | le2 | _e) && !Pi2[4].length && Pi2[9] == 1 ? Vr = Vr[lh2(Pi2[0])].apply(Vr, Pi2[3]) : Vr = qn.length == 1 && bat(qn) ? Vr[Yr]() : Vr.thru(qn);
              }
              return function() {
                var eo = arguments, Do = eo[0];
                if (Vr && eo.length == 1 && is(Do))
                  return Vr.plant(Do).value();
                for (var Jo = 0, cl = te2 ? Tt[Jo].apply(this, eo) : Do; ++Jo < te2; )
                  cl = Tt[Jo].call(this, cl);
                return cl;
              };
            });
          }
          function Qo(ut, Tt, te2, ke2, ln, qn, Vr, Yr, Pi2, eo) {
            var Do = Tt & he2, Jo = Tt & vt, cl = Tt & Ct, cu = Tt & (jt | Rt), ku = Tt & Me2, dc2 = cl ? e2 : UF(ut);
            function Gu() {
              for (var Eh2 = arguments.length, _p = Ma2(Eh2), E1 = Eh2; E1--; )
                _p[E1] = arguments[E1];
              if (cu)
                var Pb2 = o4(Gu), i2 = V6t(_p, Pb2);
              if (ke2 && (_p = abt(_p, ke2, ln, cu)), qn && (_p = obt(_p, qn, Vr, cu)), Eh2 -= i2, cu && Eh2 < eo) {
                var yv = _P(_p, Pb2);
                return mat(ut, Tt, Qo, Gu.placeholder, te2, _p, yv, Yr, Pi2, eo - Eh2);
              }
              var nx = Jo ? te2 : this, uI = cl ? nx[ut] : ut;
              return Eh2 = _p.length, Yr ? _p = SNt(_p, Yr) : ku && Eh2 > 1 && _p.reverse(), Do && Pi2 < Eh2 && (_p.length = Pi2), this && this !== gv && this instanceof Gu && (uI = dc2 || UF(uI)), uI.apply(nx, _p);
            }
            return Gu;
          }
          function Ov(ut, Tt) {
            return function(te2, ke2) {
              return sNt(te2, ut, Tt(ke2), {});
            };
          }
          function K_(ut, Tt) {
            return function(te2, ke2) {
              var ln;
              if (te2 === e2 && ke2 === e2)
                return Tt;
              if (te2 !== e2 && (ln = te2), ke2 !== e2) {
                if (ln === e2)
                  return ke2;
                typeof te2 == "string" || typeof ke2 == "string" ? (te2 = A1(te2), ke2 = A1(ke2)) : (te2 = jF(te2), ke2 = jF(ke2)), ln = ut(te2, ke2);
              }
              return ln;
            };
          }
          function oM(ut) {
            return JA(function(Tt) {
              return Tt = vv(Tt, vw(Ju())), sh2(function(te2) {
                var ke2 = this;
                return ut(Tt, function(ln) {
                  return dw(ln, ke2, te2);
                });
              });
            });
          }
          function o$(ut, Tt) {
            Tt = Tt === e2 ? " " : A1(Tt);
            var te2 = Tt.length;
            if (te2 < 2)
              return te2 ? sz(Tt, ut) : Tt;
            var ke2 = sz(Tt, S0(ut / SF(Tt)));
            return xF(Tt) ? QA(iM(ke2), 0, ut).join("") : ke2.slice(0, ut);
          }
          function hbt(ut, Tt, te2, ke2) {
            var ln = Tt & vt, qn = UF(ut);
            function Vr() {
              for (var Yr = -1, Pi2 = arguments.length, eo = -1, Do = ke2.length, Jo = Ma2(Do + Pi2), cl = this && this !== gv && this instanceof Vr ? qn : ut; ++eo < Do; )
                Jo[eo] = ke2[eo];
              for (; Pi2--; )
                Jo[eo++] = arguments[++Yr];
              return dw(cl, ln ? te2 : this, Jo);
            }
            return Vr;
          }
          function pbt(ut) {
            return function(Tt, te2, ke2) {
              return ke2 && typeof ke2 != "number" && D1(Tt, te2, ke2) && (te2 = ke2 = e2), Tt = Vm(Tt), te2 === e2 ? (te2 = Tt, Tt = 0) : te2 = Vm(te2), ke2 = ke2 === e2 ? Tt < te2 ? 1 : -1 : Vm(ke2), hat(Tt, te2, ke2, ut);
            };
          }
          function s$(ut) {
            return function(Tt, te2) {
              return typeof Tt == "string" && typeof te2 == "string" || (Tt = r2(Tt), te2 = r2(te2)), ut(Tt, te2);
            };
          }
          function mat(ut, Tt, te2, ke2, ln, qn, Vr, Yr, Pi2, eo) {
            var Do = Tt & jt, Jo = Do ? Vr : e2, cl = Do ? e2 : Vr, cu = Do ? qn : e2, ku = Do ? e2 : qn;
            Tt |= Do ? le2 : ne2, Tt &= ~(Do ? ne2 : le2), Tt & Pt || (Tt &= ~(vt | Ct));
            var dc2 = [ut, Tt, ln, cu, Jo, ku, cl, Yr, Pi2, eo], Gu = te2.apply(e2, dc2);
            return bat(ut) && g$(Gu, dc2), Gu.placeholder = ke2, LP(Gu, ut, Tt);
          }
          function l$(ut) {
            var Tt = a0[ut];
            return function(te2, ke2) {
              if (te2 = r2(te2), ke2 = ke2 == null ? 0 : Om(pc2(ke2), 292), ke2 && ZE(te2)) {
                var ln = (hd2(te2) + "e").split("e"), qn = Tt(ln[0] + "e" + (+ln[1] + ke2));
                return ln = (hd2(qn) + "e").split("e"), +(ln[0] + "e" + (+ln[1] - ke2));
              }
              return Tt(te2);
            };
          }
          var u$ = kF && 1 / wF(new kF([, -0]))[1] == Kr ? function(ut) {
            return new kF(ut);
          } : R$;
          function dbt(ut) {
            return function(Tt) {
              var te2 = I1(Tt);
              return te2 == lu ? HB(Tt) : te2 == Zd2 ? j6t(Tt) : F6t(Tt, ut(Tt));
            };
          }
          function Nm(ut, Tt, te2, ke2, ln, qn, Vr, Yr) {
            var Pi2 = Tt & Ct;
            if (!Pi2 && typeof ut != "function")
              throw new $S(C);
            var eo = ke2 ? ke2.length : 0;
            if (eo || (Tt &= ~(le2 | ne2), ke2 = ln = e2), Vr = Vr === e2 ? Vr : lp(pc2(Vr), 0), Yr = Yr === e2 ? Yr : pc2(Yr), eo -= ln ? ln.length : 0, Tt & ne2) {
              var Do = ke2, Jo = ln;
              ke2 = ln = e2;
            }
            var cl = Pi2 ? e2 : d$(ut), cu = [ut, Tt, te2, ke2, ln, Do, Jo, qn, Vr, Yr];
            if (cl && _at(cu, cl), ut = cu[0], Tt = cu[1], te2 = cu[2], ke2 = cu[3], ln = cu[4], Yr = cu[9] = cu[9] === e2 ? Pi2 ? 0 : ut.length : lp(cu[9] - eo, 0), !Yr && Tt & (jt | Rt) && (Tt &= ~(jt | Rt)), !Tt || Tt == vt)
              var ku = dNt(ut, Tt, te2);
            else
              Tt == jt || Tt == Rt ? ku = cbt(ut, Tt, Yr) : (Tt == le2 || Tt == (vt | le2)) && !ln.length ? ku = hbt(ut, Tt, te2, ke2) : ku = Qo.apply(e2, cu);
            var dc2 = cl ? nbt : g$;
            return LP(dc2(ku, cu), ut, Tt);
          }
          function gbt(ut, Tt, te2, ke2) {
            return ut === e2 || uM(ut, CF[te2]) && !Vp.call(ke2, te2) ? Tt : ut;
          }
          function c$(ut, Tt, te2, ke2, ln, qn) {
            return Kg2(ut) && Kg2(Tt) && (qn.set(Tt, ut), QS(ut, Tt, e2, c$, qn), qn.delete(Tt)), ut;
          }
          function vbt(ut) {
            return bz(ut) ? e2 : ut;
          }
          function f$(ut, Tt, te2, ke2, ln, qn) {
            var Vr = te2 & nt, Yr = ut.length, Pi2 = Tt.length;
            if (Yr != Pi2 && !(Vr && Pi2 > Yr))
              return false;
            var eo = qn.get(ut), Do = qn.get(Tt);
            if (eo && Do)
              return eo == Tt && Do == ut;
            var Jo = -1, cl = true, cu = te2 & dt ? new YO() : e2;
            for (qn.set(ut, Tt), qn.set(Tt, ut); ++Jo < Yr; ) {
              var ku = ut[Jo], dc2 = Tt[Jo];
              if (ke2)
                var Gu = Vr ? ke2(dc2, ku, Jo, Tt, ut, qn) : ke2(ku, dc2, Jo, ut, Tt, qn);
              if (Gu !== e2) {
                if (Gu)
                  continue;
                cl = false;
                break;
              }
              if (cu) {
                if (!Bit(Tt, function(Eh2, _p) {
                  if (!HO(cu, _p) && (ku === Eh2 || ln(ku, Eh2, te2, ke2, qn)))
                    return cu.push(_p);
                })) {
                  cl = false;
                  break;
                }
              } else if (!(ku === dc2 || ln(ku, dc2, te2, ke2, qn))) {
                cl = false;
                break;
              }
            }
            return qn.delete(ut), qn.delete(Tt), cl;
          }
          function ybt(ut, Tt, te2, ke2, ln, qn, Vr) {
            switch (te2) {
              case mo:
                if (ut.byteLength != Tt.byteLength || ut.byteOffset != Tt.byteOffset)
                  return false;
                ut = ut.buffer, Tt = Tt.buffer;
              case Ji2:
                return !(ut.byteLength != Tt.byteLength || !qn(new qO(ut), new qO(Tt)));
              case rs:
              case Gs:
              case ah2:
                return uM(+ut, +Tt);
              case _s:
                return ut.name == Tt.name && ut.message == Tt.message;
              case w1:
              case Lv:
                return ut == Tt + "";
              case lu:
                var Yr = HB;
              case Zd2:
                var Pi2 = ke2 & nt;
                if (Yr || (Yr = wF), ut.size != Tt.size && !Pi2)
                  return false;
                var eo = Vr.get(ut);
                if (eo)
                  return eo == Tt;
                ke2 |= dt, Vr.set(ut, Tt);
                var Do = f$(Yr(ut), Yr(Tt), ke2, ln, qn, Vr);
                return Vr.delete(ut), Do;
              case hv:
                if (qA)
                  return qA.call(ut) == qA.call(Tt);
            }
            return false;
          }
          function QE(ut, Tt, te2, ke2, ln, qn) {
            var Vr = te2 & nt, Yr = h$(ut), Pi2 = Yr.length, eo = h$(Tt), Do = eo.length;
            if (Pi2 != Do && !Vr)
              return false;
            for (var Jo = Pi2; Jo--; ) {
              var cl = Yr[Jo];
              if (!(Vr ? cl in Tt : Vp.call(Tt, cl)))
                return false;
            }
            var cu = qn.get(ut), ku = qn.get(Tt);
            if (cu && ku)
              return cu == Tt && ku == ut;
            var dc2 = true;
            qn.set(ut, Tt), qn.set(Tt, ut);
            for (var Gu = Vr; ++Jo < Pi2; ) {
              cl = Yr[Jo];
              var Eh2 = ut[cl], _p = Tt[cl];
              if (ke2)
                var E1 = Vr ? ke2(_p, Eh2, cl, Tt, ut, qn) : ke2(Eh2, _p, cl, ut, Tt, qn);
              if (!(E1 === e2 ? Eh2 === _p || ln(Eh2, _p, te2, ke2, qn) : E1)) {
                dc2 = false;
                break;
              }
              Gu || (Gu = cl == "constructor");
            }
            if (dc2 && !Gu) {
              var Pb2 = ut.constructor, i2 = Tt.constructor;
              Pb2 != i2 && "constructor" in ut && "constructor" in Tt && !(typeof Pb2 == "function" && Pb2 instanceof Pb2 && typeof i2 == "function" && i2 instanceof i2) && (dc2 = false);
            }
            return qn.delete(ut), qn.delete(Tt), dc2;
          }
          function JA(ut) {
            return Sat(qF(ut, e2, fz), ut + "");
          }
          function h$(ut) {
            return oat(ut, Xy, PP);
          }
          function p$(ut) {
            return oat(ut, xw, bbt);
          }
          var d$ = GZ ? function(ut) {
            return GZ.get(ut);
          } : R$;
          function lh2(ut) {
            for (var Tt = ut.name + "", te2 = LF[Tt], ke2 = Vp.call(LF, Tt) ? te2.length : 0; ke2--; ) {
              var ln = te2[ke2], qn = ln.func;
              if (qn == null || qn == ut)
                return ln.name;
            }
            return Tt;
          }
          function o4(ut) {
            var Tt = Vp.call(Dn, "placeholder") ? Dn : ut;
            return Tt.placeholder;
          }
          function Ju() {
            var ut = Dn.iteratee || My;
            return ut = ut === My ? JZ : ut, arguments.length ? ut(arguments[0], arguments[1]) : ut;
          }
          function lz(ut, Tt) {
            var te2 = ut.__data__;
            return bNt(Tt) ? te2[typeof Tt == "string" ? "string" : "hash"] : te2.map;
          }
          function Tp(ut) {
            for (var Tt = Xy(ut), te2 = Tt.length; te2--; ) {
              var ke2 = Tt[te2], ln = ut[ke2];
              Tt[te2] = [ke2, ln, Ff2(ln)];
            }
            return Tt;
          }
          function t22(ut, Tt) {
            var te2 = Git(ut, Tt);
            return Q1t(te2) ? te2 : e2;
          }
          function mbt(ut) {
            var Tt = Vp.call(ut, Ib2), te2 = ut[Ib2];
            try {
              ut[Ib2] = e2;
              var ke2 = true;
            } catch {
            }
            var ln = AF.call(ut);
            return ke2 && (Tt ? ut[Ib2] = te2 : delete ut[Ib2]), ln;
          }
          var PP = DF ? function(ut) {
            return ut == null ? [] : (ut = bg2(ut), w0(DF(ut), function(Tt) {
              return qB.call(ut, Tt);
            }));
          } : N$, bbt = DF ? function(ut) {
            for (var Tt = []; ut; )
              WA(Tt, PP(ut)), ut = ZO(ut);
            return Tt;
          } : N$, I1 = Db2;
          (Kit && I1(new Kit(new ArrayBuffer(1))) != mo || YB && I1(new YB()) != lu || KB && I1(KB.resolve()) != Zy || kF && I1(new kF()) != Zd2 || XB && I1(new XB()) != po) && (I1 = function(ut) {
            var Tt = Db2(ut), te2 = Tt == Np ? ut.constructor : e2, ke2 = te2 ? JE(te2) : "";
            if (ke2)
              switch (ke2) {
                case QB:
                  return mo;
                case B1t:
                  return lu;
                case MC:
                  return Zy;
                case K6t:
                  return Zd2;
                case JB:
                  return po;
              }
            return Tt;
          });
          function gNt(ut, Tt, te2) {
            for (var ke2 = -1, ln = te2.length; ++ke2 < ln; ) {
              var qn = te2[ke2], Vr = qn.size;
              switch (qn.type) {
                case "drop":
                  ut += Vr;
                  break;
                case "dropRight":
                  Tt -= Vr;
                  break;
                case "take":
                  Tt = Om(Tt, ut + Vr);
                  break;
                case "takeRight":
                  ut = lp(ut, Tt - Vr);
                  break;
              }
            }
            return { start: ut, end: Tt };
          }
          function vNt(ut) {
            var Tt = ut.match(Oit);
            return Tt ? Tt[1].split(Rit) : [];
          }
          function _bt(ut, Tt, te2) {
            Tt = Rm(Tt, ut);
            for (var ke2 = -1, ln = Tt.length, qn = false; ++ke2 < ln; ) {
              var Vr = tI(Tt[ke2]);
              if (!(qn = ut != null && te2(ut, Vr)))
                break;
              ut = ut[Vr];
            }
            return qn || ++ke2 != ln ? qn : (ln = ut == null ? 0 : ut.length, !!ln && GP(ln) && $d2(Vr, ln) && (is(ut) || Zc2(ut)));
          }
          function yNt(ut) {
            var Tt = ut.length, te2 = new ut.constructor(Tt);
            return Tt && typeof ut[0] == "string" && Vp.call(ut, "index") && (te2.index = ut.index, te2.input = ut.input), te2;
          }
          function xbt(ut) {
            return typeof ut.constructor == "function" && !AC(ut) ? C1(ZO(ut)) : {};
          }
          function mNt(ut, Tt, te2) {
            var ke2 = ut.constructor;
            switch (Tt) {
              case Ji2:
                return kP(ut);
              case rs:
              case Gs:
                return new ke2(+ut);
              case mo:
                return hNt(ut, te2);
              case zs:
              case Jl:
              case gf2:
              case vf2:
              case Xp:
              case pv:
              case vg2:
              case Z0:
              case yg2:
                return a$(ut, te2);
              case lu:
                return new ke2();
              case ah2:
              case Lv:
                return new ke2(ut);
              case w1:
                return gat(ut);
              case Zd2:
                return new ke2();
              case hv:
                return vat(ut);
            }
          }
          function wbt(ut, Tt) {
            var te2 = Tt.length;
            if (!te2)
              return ut;
            var ke2 = te2 - 1;
            return Tt[ke2] = (te2 > 1 ? "& " : "") + Tt[ke2], Tt = Tt.join(te2 > 2 ? ", " : " "), ut.replace(Lit, `{
/* [wrapped with ` + Tt + `] */
`);
          }
          function uz(ut) {
            return is(ut) || Zc2(ut) || !!(Yit && ut && ut[Yit]);
          }
          function $d2(ut, Tt) {
            var te2 = typeof ut;
            return Tt = Tt == null ? Kn : Tt, !!Tt && (te2 == "number" || te2 != "symbol" && Ti2.test(ut)) && ut > -1 && ut % 1 == 0 && ut < Tt;
          }
          function D1(ut, Tt, te2) {
            if (!Kg2(te2))
              return false;
            var ke2 = typeof Tt;
            return (ke2 == "number" ? Q_(te2) && $d2(Tt, te2.length) : ke2 == "string" && Tt in te2) ? uM(te2[Tt], ut) : false;
          }
          function s4(ut, Tt) {
            if (is(ut))
              return false;
            var te2 = typeof ut;
            return te2 == "number" || te2 == "symbol" || te2 == "boolean" || ut == null || n2(ut) ? true : GS.test(ut) || !W_.test(ut) || Tt != null && ut in bg2(Tt);
          }
          function bNt(ut) {
            var Tt = typeof ut;
            return Tt == "string" || Tt == "number" || Tt == "symbol" || Tt == "boolean" ? ut !== "__proto__" : ut === null;
          }
          function bat(ut) {
            var Tt = lh2(ut), te2 = Dn[Tt];
            if (typeof te2 != "function" || !(Tt in oh2.prototype))
              return false;
            if (ut === te2)
              return true;
            var ke2 = d$(te2);
            return !!ke2 && ut === ke2[0];
          }
          function _Nt(ut) {
            return !!Zit && Zit in ut;
          }
          var xNt = UO ? tx : nk2;
          function AC(ut) {
            var Tt = ut && ut.constructor, te2 = typeof Tt == "function" && Tt.prototype || CF;
            return ut === te2;
          }
          function Ff2(ut) {
            return ut === ut && !Kg2(ut);
          }
          function Sbt(ut, Tt) {
            return function(te2) {
              return te2 == null ? false : te2[ut] === Tt && (Tt !== e2 || ut in bg2(te2));
            };
          }
          function cz(ut) {
            var Tt = C$(ut, function(ke2) {
              return te2.size === F3 && te2.clear(), ke2;
            }), te2 = Tt.cache;
            return Tt;
          }
          function _at(ut, Tt) {
            var te2 = ut[1], ke2 = Tt[1], ln = te2 | ke2, qn = ln < (vt | Ct | he2), Vr = ke2 == he2 && te2 == jt || ke2 == he2 && te2 == _e && ut[7].length <= Tt[8] || ke2 == (he2 | _e) && Tt[7].length <= Tt[8] && te2 == jt;
            if (!(qn || Vr))
              return ut;
            ke2 & vt && (ut[2] = Tt[2], ln |= te2 & vt ? 0 : Pt);
            var Yr = Tt[3];
            if (Yr) {
              var Pi2 = ut[3];
              ut[3] = Pi2 ? abt(Pi2, Yr, Tt[4]) : Yr, ut[4] = Pi2 ? _P(ut[3], j) : Tt[4];
            }
            return Yr = Tt[5], Yr && (Pi2 = ut[5], ut[5] = Pi2 ? obt(Pi2, Yr, Tt[6]) : Yr, ut[6] = Pi2 ? _P(ut[5], j) : Tt[6]), Yr = Tt[7], Yr && (ut[7] = Yr), ke2 & he2 && (ut[8] = ut[8] == null ? Tt[8] : Om(ut[8], Tt[8])), ut[9] == null && (ut[9] = Tt[9]), ut[0] = Tt[0], ut[1] = ln, ut;
          }
          function Y0(ut) {
            var Tt = [];
            if (ut != null)
              for (var te2 in bg2(ut))
                Tt.push(te2);
            return Tt;
          }
          function wNt(ut) {
            return AF.call(ut);
          }
          function qF(ut, Tt, te2) {
            return Tt = lp(Tt === e2 ? ut.length - 1 : Tt, 0), function() {
              for (var ke2 = arguments, ln = -1, qn = lp(ke2.length - Tt, 0), Vr = Ma2(qn); ++ln < qn; )
                Vr[ln] = ke2[Tt + ln];
              ln = -1;
              for (var Yr = Ma2(Tt + 1); ++ln < Tt; )
                Yr[ln] = ke2[ln];
              return Yr[Tt] = te2(Vr), dw(ut, this, Yr);
            };
          }
          function xat(ut, Tt) {
            return Tt.length < 2 ? ut : YE(ut, $_(Tt, 0, -1));
          }
          function SNt(ut, Tt) {
            for (var te2 = ut.length, ke2 = Om(Tt.length, te2), ln = Y_(ut); ke2--; ) {
              var qn = Tt[ke2];
              ut[ke2] = $d2(qn, te2) ? ln[qn] : e2;
            }
            return ut;
          }
          function wat(ut, Tt) {
            if (!(Tt === "constructor" && typeof ut[Tt] == "function") && Tt != "__proto__")
              return ut[Tt];
          }
          var g$ = Mat(nbt), ZF = O1t || function(ut, Tt) {
            return gv.setTimeout(ut, Tt);
          }, Sat = Mat(Vu);
          function LP(ut, Tt, te2) {
            var ke2 = Tt + "";
            return Sat(ut, wbt(ke2, MNt(vNt(ke2), te2)));
          }
          function Mat(ut) {
            var Tt = 0, te2 = 0;
            return function() {
              var ke2 = Y6t(), ln = Ze2 - (ke2 - te2);
              if (te2 = ke2, ln > 0) {
                if (++Tt >= Je2)
                  return arguments[0];
              } else
                Tt = 0;
              return ut.apply(e2, arguments);
            };
          }
          function e22(ut, Tt) {
            var te2 = -1, ke2 = ut.length, ln = ke2 - 1;
            for (Tt = Tt === e2 ? ke2 : Tt; ++te2 < Tt; ) {
              var qn = AP(te2, ln), Vr = ut[qn];
              ut[qn] = ut[te2], ut[te2] = Vr;
            }
            return ut.length = Tt, ut;
          }
          var Mbt = cz(function(ut) {
            var Tt = [];
            return ut.charCodeAt(0) === 46 && Tt.push(""), ut.replace(vP, function(te2, ke2, ln, qn) {
              Tt.push(ln ? qn.replace(kr, "$1") : ke2 || te2);
            }), Tt;
          });
          function tI(ut) {
            if (typeof ut == "string" || n2(ut))
              return ut;
            var Tt = ut + "";
            return Tt == "0" && 1 / ut == -Kr ? "-0" : Tt;
          }
          function JE(ut) {
            if (ut != null) {
              try {
                return Ab2.call(ut);
              } catch {
              }
              try {
                return ut + "";
              } catch {
              }
            }
            return "";
          }
          function MNt(ut, Tt) {
            return Jp(Ss, function(te2) {
              var ke2 = "_." + te2[0];
              Tt & te2[1] && !nM(ut, ke2) && ut.push(ke2);
            }), ut.sort();
          }
          function Cat(ut) {
            if (ut instanceof oh2)
              return ut.clone();
            var Tt = new YS(ut.__wrapped__, ut.__chain__);
            return Tt.__actions__ = Y_(ut.__actions__), Tt.__index__ = ut.__index__, Tt.__values__ = ut.__values__, Tt;
          }
          function CNt(ut, Tt, te2) {
            (te2 ? D1(ut, Tt, te2) : Tt === e2) ? Tt = 1 : Tt = lp(pc2(Tt), 0);
            var ke2 = ut == null ? 0 : ut.length;
            if (!ke2 || Tt < 1)
              return [];
            for (var ln = 0, qn = 0, Vr = Ma2(S0(ke2 / Tt)); ln < ke2; )
              Vr[qn++] = $_(ut, ln, ln += Tt);
            return Vr;
          }
          function TNt(ut) {
            for (var Tt = -1, te2 = ut == null ? 0 : ut.length, ke2 = 0, ln = []; ++Tt < te2; ) {
              var qn = ut[Tt];
              qn && (ln[ke2++] = qn);
            }
            return ln;
          }
          function ANt() {
            var ut = arguments.length;
            if (!ut)
              return [];
            for (var Tt = Ma2(ut - 1), te2 = arguments[0], ke2 = ut; ke2--; )
              Tt[ke2 - 1] = arguments[ke2];
            return WA(is(te2) ? Y_(te2) : [te2], Yy(Tt, 1));
          }
          var INt = sh2(function(ut, Tt) {
            return M0(ut) ? QO(ut, Yy(Tt, 1, M0, true)) : [];
          }), v$ = sh2(function(ut, Tt) {
            var te2 = mw(Tt);
            return M0(te2) && (te2 = e2), M0(ut) ? QO(ut, Yy(Tt, 1, M0, true), Ju(te2, 2)) : [];
          }), l4 = sh2(function(ut, Tt) {
            var te2 = mw(Tt);
            return M0(te2) && (te2 = e2), M0(ut) ? QO(ut, Yy(Tt, 1, M0, true), e2, te2) : [];
          });
          function DNt(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            return ke2 ? (Tt = te2 || Tt === e2 ? 1 : pc2(Tt), $_(ut, Tt < 0 ? 0 : Tt, ke2)) : [];
          }
          function ENt(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            return ke2 ? (Tt = te2 || Tt === e2 ? 1 : pc2(Tt), Tt = ke2 - Tt, $_(ut, 0, Tt < 0 ? 0 : Tt)) : [];
          }
          function kNt(ut, Tt) {
            return ut && ut.length ? Eb2(ut, Ju(Tt, 3), true, true) : [];
          }
          function Tat(ut, Tt) {
            return ut && ut.length ? Eb2(ut, Ju(Tt, 3), true) : [];
          }
          function PNt(ut, Tt, te2, ke2) {
            var ln = ut == null ? 0 : ut.length;
            return ln ? (te2 && typeof te2 != "number" && D1(ut, Tt, te2) && (te2 = 0, ke2 = ln), rz(ut, Tt, te2, ke2)) : [];
          }
          function y$(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            if (!ke2)
              return -1;
            var ln = te2 == null ? 0 : pc2(te2);
            return ln < 0 && (ln = lp(ke2 + ln, 0)), FZ(ut, Ju(Tt, 3), ln);
          }
          function Aat(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            if (!ke2)
              return -1;
            var ln = ke2 - 1;
            return te2 !== e2 && (ln = pc2(te2), ln = te2 < 0 ? lp(ke2 + ln, 0) : Om(ln, ke2 - 1)), FZ(ut, Ju(Tt, 3), ln, true);
          }
          function fz(ut) {
            var Tt = ut == null ? 0 : ut.length;
            return Tt ? Yy(ut, 1) : [];
          }
          function Iat(ut) {
            var Tt = ut == null ? 0 : ut.length;
            return Tt ? Yy(ut, Kr) : [];
          }
          function LNt(ut, Tt) {
            var te2 = ut == null ? 0 : ut.length;
            return te2 ? (Tt = Tt === e2 ? 1 : pc2(Tt), Yy(ut, Tt)) : [];
          }
          function Cbt(ut) {
            for (var Tt = -1, te2 = ut == null ? 0 : ut.length, ke2 = {}; ++Tt < te2; ) {
              var ln = ut[Tt];
              ke2[ln[0]] = ln[1];
            }
            return ke2;
          }
          function Dat(ut) {
            return ut && ut.length ? ut[0] : e2;
          }
          function ONt(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            if (!ke2)
              return -1;
            var ln = te2 == null ? 0 : pc2(te2);
            return ln < 0 && (ln = lp(ke2 + ln, 0)), rM(ut, Tt, ln);
          }
          function RNt(ut) {
            var Tt = ut == null ? 0 : ut.length;
            return Tt ? $_(ut, 0, -1) : [];
          }
          var NNt = sh2(function(ut) {
            var Tt = vv(ut, EP);
            return Tt.length && Tt[0] === ut[0] ? KZ(Tt) : [];
          }), Tbt = sh2(function(ut) {
            var Tt = mw(ut), te2 = vv(ut, EP);
            return Tt === mw(te2) ? Tt = e2 : te2.pop(), te2.length && te2[0] === ut[0] ? KZ(te2, Ju(Tt, 2)) : [];
          }), FNt = sh2(function(ut) {
            var Tt = mw(ut), te2 = vv(ut, EP);
            return Tt = typeof Tt == "function" ? Tt : e2, Tt && te2.pop(), te2.length && te2[0] === ut[0] ? KZ(te2, e2, Tt) : [];
          });
          function VNt(ut, Tt) {
            return ut == null ? "" : N1t.call(ut, Tt);
          }
          function mw(ut) {
            var Tt = ut == null ? 0 : ut.length;
            return Tt ? ut[Tt - 1] : e2;
          }
          function BNt(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            if (!ke2)
              return -1;
            var ln = ke2;
            return te2 !== e2 && (ln = pc2(te2), ln = ln < 0 ? lp(ke2 + ln, 0) : Om(ln, ke2 - 1)), Tt === Tt ? E1t(ut, Tt, ln) : FZ(ut, Lm, ln, true);
          }
          function zNt(ut, Tt) {
            return ut && ut.length ? e$(ut, pc2(Tt)) : e2;
          }
          var jNt = sh2(Eat);
          function Eat(ut, Tt) {
            return ut && ut.length && Tt && Tt.length ? KE(ut, Tt) : ut;
          }
          function kat(ut, Tt, te2) {
            return ut && ut.length && Tt && Tt.length ? KE(ut, Tt, Ju(te2, 2)) : ut;
          }
          function u4(ut, Tt, te2) {
            return ut && ut.length && Tt && Tt.length ? KE(ut, Tt, e2, te2) : ut;
          }
          var m$ = JA(function(ut, Tt) {
            var te2 = ut == null ? 0 : ut.length, ke2 = VF(ut, Tt);
            return TP(ut, vv(Tt, function(ln) {
              return $d2(ln, te2) ? +ln : ln;
            }).sort(ibt)), ke2;
          });
          function Abt(ut, Tt) {
            var te2 = [];
            if (!(ut && ut.length))
              return te2;
            var ke2 = -1, ln = [], qn = ut.length;
            for (Tt = Ju(Tt, 3); ++ke2 < qn; ) {
              var Vr = ut[ke2];
              Tt(Vr, ke2, ut) && (te2.push(Vr), ln.push(ke2));
            }
            return TP(ut, ln), te2;
          }
          function Pat(ut) {
            return ut == null ? ut : V1t.call(ut);
          }
          function WNt(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            return ke2 ? (te2 && typeof te2 != "number" && D1(ut, Tt, te2) ? (Tt = 0, te2 = ke2) : (Tt = Tt == null ? 0 : pc2(Tt), te2 = te2 === e2 ? ke2 : pc2(te2)), $_(ut, Tt, te2)) : [];
          }
          function Lat(ut, Tt) {
            return XA(ut, Tt);
          }
          function Oat(ut, Tt, te2) {
            return XE(ut, Tt, Ju(te2, 2));
          }
          function GNt(ut, Tt) {
            var te2 = ut == null ? 0 : ut.length;
            if (te2) {
              var ke2 = XA(ut, Tt);
              if (ke2 < te2 && uM(ut[ke2], Tt))
                return ke2;
            }
            return -1;
          }
          function sM(ut, Tt) {
            return XA(ut, Tt, true);
          }
          function bw(ut, Tt, te2) {
            return XE(ut, Tt, Ju(te2, 2), true);
          }
          function _w(ut, Tt) {
            var te2 = ut == null ? 0 : ut.length;
            if (te2) {
              var ke2 = XA(ut, Tt, true) - 1;
              if (uM(ut[ke2], Tt))
                return ke2;
            }
            return -1;
          }
          function Rat(ut) {
            return ut && ut.length ? IP(ut) : [];
          }
          function Nat(ut, Tt) {
            return ut && ut.length ? IP(ut, Ju(Tt, 2)) : [];
          }
          function c4(ut) {
            var Tt = ut == null ? 0 : ut.length;
            return Tt ? $_(ut, 1, Tt) : [];
          }
          function b$(ut, Tt, te2) {
            return ut && ut.length ? (Tt = te2 || Tt === e2 ? 1 : pc2(Tt), $_(ut, 0, Tt < 0 ? 0 : Tt)) : [];
          }
          function _$(ut, Tt, te2) {
            var ke2 = ut == null ? 0 : ut.length;
            return ke2 ? (Tt = te2 || Tt === e2 ? 1 : pc2(Tt), Tt = ke2 - Tt, $_(ut, Tt < 0 ? 0 : Tt, ke2)) : [];
          }
          function x$(ut, Tt) {
            return ut && ut.length ? Eb2(ut, Ju(Tt, 3), false, true) : [];
          }
          function w$(ut, Tt) {
            return ut && ut.length ? Eb2(ut, Ju(Tt, 3)) : [];
          }
          var Ibt = sh2(function(ut) {
            return DP(Yy(ut, 1, M0, true));
          }), Dbt = sh2(function(ut) {
            var Tt = mw(ut);
            return M0(Tt) && (Tt = e2), DP(Yy(ut, 1, M0, true), Ju(Tt, 2));
          }), Ebt = sh2(function(ut) {
            var Tt = mw(ut);
            return Tt = typeof Tt == "function" ? Tt : e2, DP(Yy(ut, 1, M0, true), e2, Tt);
          });
          function HNt(ut) {
            return ut && ut.length ? DP(ut) : [];
          }
          function UNt(ut, Tt) {
            return ut && ut.length ? DP(ut, Ju(Tt, 2)) : [];
          }
          function qNt(ut, Tt) {
            return Tt = typeof Tt == "function" ? Tt : e2, ut && ut.length ? DP(ut, e2, Tt) : [];
          }
          function ed2(ut) {
            if (!(ut && ut.length))
              return [];
            var Tt = 0;
            return ut = w0(ut, function(te2) {
              if (M0(te2))
                return Tt = lp(te2.length, Tt), true;
            }), gw(Tt, function(te2) {
              return vv(ut, GA(te2));
            });
          }
          function OP(ut, Tt) {
            if (!(ut && ut.length))
              return [];
            var te2 = ed2(ut);
            return Tt == null ? te2 : vv(te2, function(ke2) {
              return dw(Tt, e2, ke2);
            });
          }
          var f4 = sh2(function(ut, Tt) {
            return M0(ut) ? QO(ut, Tt) : [];
          }), eI = sh2(function(ut) {
            return r4(w0(ut, M0));
          }), RP = sh2(function(ut) {
            var Tt = mw(ut);
            return M0(Tt) && (Tt = e2), r4(w0(ut, M0), Ju(Tt, 2));
          }), nI = sh2(function(ut) {
            var Tt = mw(ut);
            return Tt = typeof Tt == "function" ? Tt : e2, r4(w0(ut, M0), e2, Tt);
          }), rI = sh2(ed2);
          function Fat(ut, Tt) {
            return WF(ut || [], Tt || [], nz);
          }
          function Vat(ut, Tt) {
            return WF(ut || [], Tt || [], JS);
          }
          var h4 = sh2(function(ut) {
            var Tt = ut.length, te2 = Tt > 1 ? ut[Tt - 1] : e2;
            return te2 = typeof te2 == "function" ? (ut.pop(), te2) : e2, OP(ut, te2);
          });
          function NP(ut) {
            var Tt = Dn(ut);
            return Tt.__chain__ = true, Tt;
          }
          function tk2(ut, Tt) {
            return Tt(ut), ut;
          }
          function $F(ut, Tt) {
            return Tt(ut);
          }
          var FP = JA(function(ut) {
            var Tt = ut.length, te2 = Tt ? ut[0] : 0, ke2 = this.__wrapped__, ln = function(qn) {
              return VF(qn, ut);
            };
            return Tt > 1 || this.__actions__.length || !(ke2 instanceof oh2) || !$d2(te2) ? this.thru(ln) : (ke2 = ke2.slice(te2, +te2 + (Tt ? 1 : 0)), ke2.__actions__.push({ func: $F, args: [ln], thisArg: e2 }), new YS(ke2, this.__chain__).thru(function(qn) {
              return Tt && !qn.length && qn.push(e2), qn;
            }));
          });
          function Bat() {
            return NP(this);
          }
          function hz() {
            return new YS(this.value(), this.__chain__);
          }
          function zat() {
            this.__values__ === e2 && (this.__values__ = Qat(this.value()));
            var ut = this.__index__ >= this.__values__.length, Tt = ut ? e2 : this.__values__[this.__index__++];
            return { done: ut, value: Tt };
          }
          function ZNt() {
            return this;
          }
          function $Nt(ut) {
            for (var Tt, te2 = this; te2 instanceof RF; ) {
              var ke2 = Cat(te2);
              ke2.__index__ = 0, ke2.__values__ = e2, Tt ? ln.__wrapped__ = ke2 : Tt = ke2;
              var ln = ke2;
              te2 = te2.__wrapped__;
            }
            return ln.__wrapped__ = ut, Tt;
          }
          function iI() {
            var ut = this.__wrapped__;
            if (ut instanceof oh2) {
              var Tt = ut;
              return this.__actions__.length && (Tt = new oh2(this)), Tt = Tt.reverse(), Tt.__actions__.push({ func: $F, args: [Pat], thisArg: e2 }), new YS(Tt, this.__chain__);
            }
            return this.thru(Pat);
          }
          function VP() {
            return dat(this.__wrapped__, this.__actions__);
          }
          var YNt = i4(function(ut, Tt, te2) {
            Vp.call(ut, te2) ? ++ut[te2] : XS(ut, te2, 1);
          });
          function kbt(ut, Tt, te2) {
            var ke2 = is(ut) ? mP : $1t;
            return te2 && D1(ut, Tt, te2) && (Tt = e2), ke2(ut, Ju(Tt, 3));
          }
          function Pbt(ut, Tt) {
            var te2 = is(ut) ? w0 : Y1t;
            return te2(ut, Ju(Tt, 3));
          }
          var BP = fbt(y$), pz = fbt(Aat);
          function KNt(ut, Tt) {
            return Yy(S$(ut, Tt), 1);
          }
          function ek2(ut, Tt) {
            return Yy(S$(ut, Tt), Kr);
          }
          function zP(ut, Tt, te2) {
            return te2 = te2 === e2 ? 1 : pc2(te2), Yy(S$(ut, Tt), te2);
          }
          function jP(ut, Tt) {
            var te2 = is(ut) ? Jp : ZA;
            return te2(ut, Ju(Tt, 3));
          }
          function Lbt(ut, Tt) {
            var te2 = is(ut) ? NZ : iat;
            return te2(ut, Ju(Tt, 3));
          }
          var XNt = i4(function(ut, Tt, te2) {
            Vp.call(ut, te2) ? ut[te2].push(Tt) : XS(ut, te2, [Tt]);
          });
          function X_(ut, Tt, te2, ke2) {
            ut = Q_(ut) ? ut : x4(ut), te2 = te2 && !ke2 ? pc2(te2) : 0;
            var ln = ut.length;
            return te2 < 0 && (te2 = lp(ln + te2, 0)), v42(ut) ? te2 <= ln && ut.indexOf(Tt, te2) > -1 : !!ln && rM(ut, Tt, te2) > -1;
          }
          var lM = sh2(function(ut, Tt, te2) {
            var ke2 = -1, ln = typeof Tt == "function", qn = Q_(ut) ? Ma2(ut.length) : [];
            return ZA(ut, function(Vr) {
              qn[++ke2] = ln ? dw(Tt, Vr, te2) : Z_(Vr, Tt, te2);
            }), qn;
          }), QNt = i4(function(ut, Tt, te2) {
            XS(ut, te2, Tt);
          });
          function S$(ut, Tt) {
            var te2 = is(ut) ? vv : oz;
            return te2(ut, Ju(Tt, 3));
          }
          function JNt(ut, Tt, te2, ke2) {
            return ut == null ? [] : (is(Tt) || (Tt = Tt == null ? [] : [Tt]), te2 = ke2 ? e2 : te2, is(te2) || (te2 = te2 == null ? [] : [te2]), e4(ut, Tt, te2));
          }
          var tFt = i4(function(ut, Tt, te2) {
            ut[te2 ? 0 : 1].push(Tt);
          }, function() {
            return [[], []];
          });
          function Obt(ut, Tt, te2) {
            var ke2 = is(ut) ? WE : T1t, ln = arguments.length < 3;
            return ke2(ut, Ju(Tt, 4), te2, ln, ZA);
          }
          function eFt(ut, Tt, te2) {
            var ke2 = is(ut) ? Vit : T1t, ln = arguments.length < 3;
            return ke2(ut, Ju(Tt, 4), te2, ln, iat);
          }
          function nFt(ut, Tt) {
            var te2 = is(ut) ? w0 : Y1t;
            return te2(ut, T$(Ju(Tt, 3)));
          }
          function M$(ut) {
            var Tt = is(ut) ? U1t : KA;
            return Tt(ut);
          }
          function rFt(ut, Tt, te2) {
            (te2 ? D1(ut, Tt, te2) : Tt === e2) ? Tt = 1 : Tt = pc2(Tt);
            var ke2 = is(ut) ? nat : ebt;
            return ke2(ut, Tt);
          }
          function jat(ut) {
            var Tt = is(ut) ? $E : n$;
            return Tt(ut);
          }
          function iFt(ut) {
            if (ut == null)
              return 0;
            if (Q_(ut))
              return v42(ut) ? SF(ut) : ut.length;
            var Tt = I1(ut);
            return Tt == lu || Tt == Zd2 ? ut.size : az(ut).length;
          }
          function Mc2(ut, Tt, te2) {
            var ke2 = is(ut) ? Bit : n4;
            return te2 && D1(ut, Tt, te2) && (Tt = e2), ke2(ut, Ju(Tt, 3));
          }
          var aFt = sh2(function(ut, Tt) {
            if (ut == null)
              return [];
            var te2 = Tt.length;
            return te2 > 1 && D1(ut, Tt[0], Tt[1]) ? Tt = [] : te2 > 2 && D1(Tt[0], Tt[1], Tt[2]) && (Tt = [Tt[0]]), e4(ut, Yy(Tt, 1), []);
          }), dz = wP || function() {
            return gv.Date.now();
          };
          function gz(ut, Tt) {
            if (typeof Tt != "function")
              throw new $S(C);
            return ut = pc2(ut), function() {
              if (--ut < 1)
                return Tt.apply(this, arguments);
            };
          }
          function Rbt(ut, Tt, te2) {
            return Tt = te2 ? e2 : Tt, Tt = ut && Tt == null ? ut.length : Tt, Nm(ut, he2, e2, e2, e2, e2, Tt);
          }
          function Nbt(ut, Tt) {
            var te2;
            if (typeof Tt != "function")
              throw new $S(C);
            return ut = pc2(ut), function() {
              return --ut > 0 && (te2 = Tt.apply(this, arguments)), ut <= 1 && (Tt = e2), te2;
            };
          }
          var Wat = sh2(function(ut, Tt, te2) {
            var ke2 = vt;
            if (te2.length) {
              var ln = _P(te2, o4(Wat));
              ke2 |= le2;
            }
            return Nm(ut, ke2, Tt, te2, ln);
          }), Gat = sh2(function(ut, Tt, te2) {
            var ke2 = vt | Ct;
            if (te2.length) {
              var ln = _P(te2, o4(Gat));
              ke2 |= le2;
            }
            return Nm(Tt, ke2, ut, te2, ln);
          });
          function Fm(ut, Tt, te2) {
            Tt = te2 ? e2 : Tt;
            var ke2 = Nm(ut, jt, e2, e2, e2, e2, e2, Tt);
            return ke2.placeholder = Fm.placeholder, ke2;
          }
          function Fbt(ut, Tt, te2) {
            Tt = te2 ? e2 : Tt;
            var ke2 = Nm(ut, Rt, e2, e2, e2, e2, e2, Tt);
            return ke2.placeholder = Fbt.placeholder, ke2;
          }
          function p4(ut, Tt, te2) {
            var ke2, ln, qn, Vr, Yr, Pi2, eo = 0, Do = false, Jo = false, cl = true;
            if (typeof ut != "function")
              throw new $S(C);
            Tt = r2(Tt) || 0, Kg2(te2) && (Do = !!te2.leading, Jo = "maxWait" in te2, qn = Jo ? lp(r2(te2.maxWait) || 0, Tt) : qn, cl = "trailing" in te2 ? !!te2.trailing : cl);
            function cu(yv) {
              var nx = ke2, uI = ln;
              return ke2 = ln = e2, eo = yv, Vr = ut.apply(uI, nx), Vr;
            }
            function ku(yv) {
              return eo = yv, Yr = ZF(Eh2, Tt), Do ? cu(yv) : Vr;
            }
            function dc2(yv) {
              var nx = yv - Pi2, uI = yv - eo, W$ = Tt - nx;
              return Jo ? Om(W$, qn - uI) : W$;
            }
            function Gu(yv) {
              var nx = yv - Pi2, uI = yv - eo;
              return Pi2 === e2 || nx >= Tt || nx < 0 || Jo && uI >= qn;
            }
            function Eh2() {
              var yv = dz();
              if (Gu(yv))
                return _p(yv);
              Yr = ZF(Eh2, dc2(yv));
            }
            function _p(yv) {
              return Yr = e2, cl && ke2 ? cu(yv) : (ke2 = ln = e2, Vr);
            }
            function E1() {
              Yr !== e2 && i$(Yr), eo = 0, ke2 = Pi2 = ln = Yr = e2;
            }
            function Pb2() {
              return Yr === e2 ? Vr : _p(dz());
            }
            function i2() {
              var yv = dz(), nx = Gu(yv);
              if (ke2 = arguments, ln = this, Pi2 = yv, nx) {
                if (Yr === e2)
                  return ku(Pi2);
                if (Jo)
                  return i$(Yr), Yr = ZF(Eh2, Tt), cu(Pi2);
              }
              return Yr === e2 && (Yr = ZF(Eh2, Tt)), Vr;
            }
            return i2.cancel = E1, i2.flush = Pb2, i2;
          }
          var Vbt = sh2(function(ut, Tt) {
            return BF(ut, 1, Tt);
          }), Bbt = sh2(function(ut, Tt, te2) {
            return BF(ut, r2(Tt) || 0, te2);
          });
          function d4(ut) {
            return Nm(ut, Me2);
          }
          function C$(ut, Tt) {
            if (typeof ut != "function" || Tt != null && typeof Tt != "function")
              throw new $S(C);
            var te2 = function() {
              var ke2 = arguments, ln = Tt ? Tt.apply(this, ke2) : ke2[0], qn = te2.cache;
              if (qn.has(ln))
                return qn.get(ln);
              var Vr = ut.apply(this, ke2);
              return te2.cache = qn.set(ln, Vr) || qn, Vr;
            };
            return te2.cache = new (C$.Cache || aM)(), te2;
          }
          C$.Cache = aM;
          function T$(ut) {
            if (typeof ut != "function")
              throw new $S(C);
            return function() {
              var Tt = arguments;
              switch (Tt.length) {
                case 0:
                  return !ut.call(this);
                case 1:
                  return !ut.call(this, Tt[0]);
                case 2:
                  return !ut.call(this, Tt[0], Tt[1]);
                case 3:
                  return !ut.call(this, Tt[0], Tt[1], Tt[2]);
              }
              return !ut.apply(this, Tt);
            };
          }
          function zbt(ut) {
            return Nbt(2, ut);
          }
          var Vf2 = r$(function(ut, Tt) {
            Tt = Tt.length == 1 && is(Tt[0]) ? vv(Tt[0], vw(Ju())) : vv(Yy(Tt, 1), vw(Ju()));
            var te2 = Tt.length;
            return sh2(function(ke2) {
              for (var ln = -1, qn = Om(ke2.length, te2); ++ln < qn; )
                ke2[ln] = Tt[ln].call(this, ke2[ln]);
              return dw(ut, this, ke2);
            });
          }), A$ = sh2(function(ut, Tt) {
            var te2 = _P(Tt, o4(A$));
            return Nm(ut, le2, e2, Tt, te2);
          }), Hat = sh2(function(ut, Tt) {
            var te2 = _P(Tt, o4(Hat));
            return Nm(ut, ne2, e2, Tt, te2);
          }), oFt = JA(function(ut, Tt) {
            return Nm(ut, _e, e2, e2, e2, Tt);
          });
          function jbt(ut, Tt) {
            if (typeof ut != "function")
              throw new $S(C);
            return Tt = Tt === e2 ? Tt : pc2(Tt), sh2(ut, Tt);
          }
          function sFt(ut, Tt) {
            if (typeof ut != "function")
              throw new $S(C);
            return Tt = Tt == null ? 0 : lp(pc2(Tt), 0), sh2(function(te2) {
              var ke2 = te2[Tt], ln = QA(te2, 0, Tt);
              return ke2 && WA(ln, ke2), dw(ut, this, ln);
            });
          }
          function lFt(ut, Tt, te2) {
            var ke2 = true, ln = true;
            if (typeof ut != "function")
              throw new $S(C);
            return Kg2(te2) && (ke2 = "leading" in te2 ? !!te2.leading : ke2, ln = "trailing" in te2 ? !!te2.trailing : ln), p4(ut, Tt, { leading: ke2, maxWait: Tt, trailing: ln });
          }
          function Wbt(ut) {
            return Rbt(ut, 1);
          }
          function Gbt(ut, Tt) {
            return A$(GF(Tt), ut);
          }
          function Hbt() {
            if (!arguments.length)
              return [];
            var ut = arguments[0];
            return is(ut) ? ut : [ut];
          }
          function Ubt(ut) {
            return q_(ut, Q);
          }
          function uFt(ut, Tt) {
            return Tt = typeof Tt == "function" ? Tt : e2, q_(ut, Q, Tt);
          }
          function qbt(ut) {
            return q_(ut, U3 | Q);
          }
          function Zbt(ut, Tt) {
            return Tt = typeof Tt == "function" ? Tt : e2, q_(ut, U3 | Q, Tt);
          }
          function $bt(ut, Tt) {
            return Tt == null || rat(ut, Tt, Xy(Tt));
          }
          function uM(ut, Tt) {
            return ut === Tt || ut !== ut && Tt !== Tt;
          }
          var Ybt = s$(iz), Uat = s$(function(ut, Tt) {
            return ut >= Tt;
          }), Zc2 = XZ(function() {
            return arguments;
          }()) ? XZ : function(ut) {
            return Xg2(ut) && Vp.call(ut, "callee") && !qB.call(ut, "callee");
          }, is = Ma2.isArray, qat = jB ? vw(jB) : lNt;
          function Q_(ut) {
            return ut != null && GP(ut.length) && !tx(ut);
          }
          function M0(ut) {
            return Xg2(ut) && Q_(ut);
          }
          function Kbt(ut) {
            return ut === true || ut === false || Xg2(ut) && Db2(ut) == rs;
          }
          var aI = R1t || nk2, Zat = _F ? vw(_F) : uNt;
          function vz(ut) {
            return Xg2(ut) && ut.nodeType === 1 && !bz(ut);
          }
          function I$(ut) {
            if (ut == null)
              return true;
            if (Q_(ut) && (is(ut) || typeof ut == "string" || typeof ut.splice == "function" || aI(ut) || YF(ut) || Zc2(ut)))
              return !ut.length;
            var Tt = I1(ut);
            if (Tt == lu || Tt == Zd2)
              return !ut.size;
            if (AC(ut))
              return !az(ut).length;
            for (var te2 in ut)
              if (Vp.call(ut, te2))
                return false;
            return true;
          }
          function J_(ut, Tt) {
            return CP(ut, Tt);
          }
          function yz(ut, Tt, te2) {
            te2 = typeof te2 == "function" ? te2 : e2;
            var ke2 = te2 ? te2(ut, Tt) : e2;
            return ke2 === e2 ? CP(ut, Tt, e2, te2) : !!ke2;
          }
          function WP(ut) {
            if (!Xg2(ut))
              return false;
            var Tt = Db2(ut);
            return Tt == _s || Tt == al || typeof ut.message == "string" && typeof ut.name == "string" && !bz(ut);
          }
          function cFt(ut) {
            return typeof ut == "number" && ZE(ut);
          }
          function tx(ut) {
            if (!Kg2(ut))
              return false;
            var Tt = Db2(ut);
            return Tt == Fl || Tt == Ih2 || Tt == Js || Tt == Nd2;
          }
          function mz(ut) {
            return typeof ut == "number" && ut == pc2(ut);
          }
          function GP(ut) {
            return typeof ut == "number" && ut > -1 && ut % 1 == 0 && ut <= Kn;
          }
          function Kg2(ut) {
            var Tt = typeof ut;
            return ut != null && (Tt == "object" || Tt == "function");
          }
          function Xg2(ut) {
            return ut != null && typeof ut == "object";
          }
          var g4 = C1t ? vw(C1t) : X1t;
          function Xbt(ut, Tt) {
            return ut === Tt || uat(ut, Tt, Tp(Tt));
          }
          function Qbt(ut, Tt, te2) {
            return te2 = typeof te2 == "function" ? te2 : e2, uat(ut, Tt, Tp(Tt), te2);
          }
          function D$(ut) {
            return Yat(ut) && ut != +ut;
          }
          function Jbt(ut) {
            if (xNt(ut))
              throw new ef2(x2);
            return Q1t(ut);
          }
          function t_t(ut) {
            return ut === null;
          }
          function $at(ut) {
            return ut == null;
          }
          function Yat(ut) {
            return typeof ut == "number" || Xg2(ut) && Db2(ut) == ah2;
          }
          function bz(ut) {
            if (!Xg2(ut) || Db2(ut) != Np)
              return false;
            var Tt = ZO(ut);
            if (Tt === null)
              return true;
            var te2 = Vp.call(Tt, "constructor") && Tt.constructor;
            return typeof te2 == "function" && te2 instanceof te2 && Ab2.call(te2) == L1t;
          }
          var Kat = pl ? vw(pl) : J1t;
          function e_t(ut) {
            return mz(ut) && ut >= -Kn && ut <= Kn;
          }
          var oI = RZ ? vw(RZ) : QZ;
          function v42(ut) {
            return typeof ut == "string" || !is(ut) && Xg2(ut) && Db2(ut) == Lv;
          }
          function n2(ut) {
            return typeof ut == "symbol" || Xg2(ut) && Db2(ut) == hv;
          }
          var YF = WB ? vw(WB) : cat;
          function fFt(ut) {
            return ut === e2;
          }
          function hFt(ut) {
            return Xg2(ut) && I1(ut) == po;
          }
          function Xat(ut) {
            return Xg2(ut) && Db2(ut) == ia2;
          }
          var y4 = s$(yw), n_t = s$(function(ut, Tt) {
            return ut <= Tt;
          });
          function Qat(ut) {
            if (!ut)
              return [];
            if (Q_(ut))
              return v42(ut) ? iM(ut) : Y_(ut);
            if (xP && ut[xP])
              return D1t(ut[xP]());
            var Tt = I1(ut), te2 = Tt == lu ? HB : Tt == Zd2 ? wF : x4;
            return te2(ut);
          }
          function Vm(ut) {
            if (!ut)
              return ut === 0 ? ut : 0;
            if (ut = r2(ut), ut === Kr || ut === -Kr) {
              var Tt = ut < 0 ? -1 : 1;
              return Tt * ar;
            }
            return ut === ut ? ut : 0;
          }
          function pc2(ut) {
            var Tt = Vm(ut), te2 = Tt % 1;
            return Tt === Tt ? te2 ? Tt - te2 : Tt : 0;
          }
          function Jat(ut) {
            return ut ? XO(pc2(ut), 0, ui2) : 0;
          }
          function r2(ut) {
            if (typeof ut == "number")
              return ut;
            if (n2(ut))
              return Cr;
            if (Kg2(ut)) {
              var Tt = typeof ut.valueOf == "function" ? ut.valueOf() : ut;
              ut = Kg2(Tt) ? Tt + "" : Tt;
            }
            if (typeof ut != "string")
              return ut === 0 ? ut : +ut;
            ut = BZ(ut);
            var te2 = qi2.test(ut);
            return te2 || ka2.test(ut) ? BB(ut.slice(2), te2 ? 2 : 8) : mr.test(ut) ? Cr : +ut;
          }
          function tot(ut) {
            return TC(ut, xw(ut));
          }
          function r_t(ut) {
            return ut ? XO(pc2(ut), -Kn, Kn) : ut === 0 ? ut : 0;
          }
          function hd2(ut) {
            return ut == null ? "" : A1(ut);
          }
          var i_t = a4(function(ut, Tt) {
            if (AC(Tt) || Q_(Tt)) {
              TC(Tt, Xy(Tt), ut);
              return;
            }
            for (var te2 in Tt)
              Vp.call(Tt, te2) && nz(ut, te2, Tt[te2]);
          }), E$ = a4(function(ut, Tt) {
            TC(Tt, xw(Tt), ut);
          }), KF = a4(function(ut, Tt, te2, ke2) {
            TC(Tt, xw(Tt), ut, ke2);
          }), pFt = a4(function(ut, Tt, te2, ke2) {
            TC(Tt, Xy(Tt), ut, ke2);
          }), eot = JA(VF);
          function dFt(ut, Tt) {
            var te2 = C1(ut);
            return Tt == null ? te2 : Z1t(te2, Tt);
          }
          var gFt = sh2(function(ut, Tt) {
            ut = bg2(ut);
            var te2 = -1, ke2 = Tt.length, ln = ke2 > 2 ? Tt[2] : e2;
            for (ln && D1(Tt[0], Tt[1], ln) && (ke2 = 1); ++te2 < ke2; )
              for (var qn = Tt[te2], Vr = xw(qn), Yr = -1, Pi2 = Vr.length; ++Yr < Pi2; ) {
                var eo = Vr[Yr], Do = ut[eo];
                (Do === e2 || uM(Do, CF[eo]) && !Vp.call(ut, eo)) && (ut[eo] = qn[eo]);
              }
            return ut;
          }), vFt = sh2(function(ut) {
            return ut.push(e2, c$), dw(l_t, e2, ut);
          });
          function a_t(ut, Tt) {
            return GE(ut, Ju(Tt, 3), $A);
          }
          function yFt(ut, Tt) {
            return GE(ut, Ju(Tt, 3), aat);
          }
          function m4(ut, Tt) {
            return ut == null ? ut : MP(ut, Ju(Tt, 3), xw);
          }
          function mFt(ut, Tt) {
            return ut == null ? ut : K1t(ut, Ju(Tt, 3), xw);
          }
          function o0(ut, Tt) {
            return ut && $A(ut, Ju(Tt, 3));
          }
          function not(ut, Tt) {
            return ut && aat(ut, Ju(Tt, 3));
          }
          function o_t(ut) {
            return ut == null ? [] : zF(ut, Xy(ut));
          }
          function bFt(ut) {
            return ut == null ? [] : zF(ut, xw(ut));
          }
          function Ky(ut, Tt, te2) {
            var ke2 = ut == null ? e2 : YE(ut, Tt);
            return ke2 === e2 ? te2 : ke2;
          }
          function b4(ut, Tt) {
            return ut != null && _bt(ut, Tt, aNt);
          }
          function _4(ut, Tt) {
            return ut != null && _bt(ut, Tt, sat);
          }
          var _Ft = Ov(function(ut, Tt, te2) {
            Tt != null && typeof Tt.toString != "function" && (Tt = AF.call(Tt)), ut[Tt] = te2;
          }, O$(ex)), xFt = Ov(function(ut, Tt, te2) {
            Tt != null && typeof Tt.toString != "function" && (Tt = AF.call(Tt)), Vp.call(ut, Tt) ? ut[Tt].push(te2) : ut[Tt] = [te2];
          }, Ju), rot = sh2(Z_);
          function Xy(ut) {
            return Q_(ut) ? eat(ut) : az(ut);
          }
          function xw(ut) {
            return Q_(ut) ? eat(ut, true) : cNt(ut);
          }
          function XF(ut, Tt) {
            var te2 = {};
            return Tt = Ju(Tt, 3), $A(ut, function(ke2, ln, qn) {
              XS(te2, Tt(ke2, ln, qn), ke2);
            }), te2;
          }
          function wFt(ut, Tt) {
            var te2 = {};
            return Tt = Ju(Tt, 3), $A(ut, function(ke2, ln, qn) {
              XS(te2, ln, Tt(ke2, ln, qn));
            }), te2;
          }
          var s_t = a4(function(ut, Tt, te2) {
            QS(ut, Tt, te2);
          }), l_t = a4(function(ut, Tt, te2, ke2) {
            QS(ut, Tt, te2, ke2);
          }), u_t = JA(function(ut, Tt) {
            var te2 = {};
            if (ut == null)
              return te2;
            var ke2 = false;
            Tt = vv(Tt, function(qn) {
              return qn = Rm(qn, ut), ke2 || (ke2 = qn.length > 1), qn;
            }), TC(ut, p$(ut), te2), ke2 && (te2 = q_(te2, U3 | Y3 | Q, vbt));
            for (var ln = Tt.length; ln--; )
              Qu(te2, Tt[ln]);
            return te2;
          });
          function iot(ut, Tt) {
            return _z(ut, T$(Ju(Tt)));
          }
          var k$ = JA(function(ut, Tt) {
            return ut == null ? {} : fNt(ut, Tt);
          });
          function _z(ut, Tt) {
            if (ut == null)
              return {};
            var te2 = vv(p$(ut), function(ke2) {
              return [ke2];
            });
            return Tt = Ju(Tt), fat(ut, te2, function(ke2, ln) {
              return Tt(ke2, ln[0]);
            });
          }
          function xz(ut, Tt, te2) {
            Tt = Rm(Tt, ut);
            var ke2 = -1, ln = Tt.length;
            for (ln || (ln = 1, ut = e2); ++ke2 < ln; ) {
              var qn = ut == null ? e2 : ut[tI(Tt[ke2])];
              qn === e2 && (ke2 = ln, qn = te2), ut = tx(qn) ? qn.call(ut) : qn;
            }
            return ut;
          }
          function c_t(ut, Tt, te2) {
            return ut == null ? ut : JS(ut, Tt, te2);
          }
          function aot(ut, Tt, te2, ke2) {
            return ke2 = typeof ke2 == "function" ? ke2 : e2, ut == null ? ut : JS(ut, Tt, te2, ke2);
          }
          var oot = dbt(Xy), sot = dbt(xw);
          function SFt(ut, Tt, te2) {
            var ke2 = is(ut), ln = ke2 || aI(ut) || YF(ut);
            if (Tt = Ju(Tt, 4), te2 == null) {
              var qn = ut && ut.constructor;
              ln ? te2 = ke2 ? new qn() : [] : Kg2(ut) ? te2 = tx(qn) ? C1(ZO(ut)) : {} : te2 = {};
            }
            return (ln ? Jp : $A)(ut, function(Vr, Yr, Pi2) {
              return Tt(te2, Vr, Yr, Pi2);
            }), te2;
          }
          function MFt(ut, Tt) {
            return ut == null ? true : Qu(ut, Tt);
          }
          function CFt(ut, Tt, te2) {
            return ut == null ? ut : pat(ut, Tt, GF(te2));
          }
          function f_t(ut, Tt, te2, ke2) {
            return ke2 = typeof ke2 == "function" ? ke2 : e2, ut == null ? ut : pat(ut, Tt, GF(te2), ke2);
          }
          function x4(ut) {
            return ut == null ? [] : zZ(ut, Xy(ut));
          }
          function h_t(ut) {
            return ut == null ? [] : zZ(ut, xw(ut));
          }
          function p_t(ut, Tt, te2) {
            return te2 === e2 && (te2 = Tt, Tt = e2), te2 !== e2 && (te2 = r2(te2), te2 = te2 === te2 ? te2 : 0), Tt !== e2 && (Tt = r2(Tt), Tt = Tt === Tt ? Tt : 0), XO(r2(ut), Tt, te2);
          }
          function TFt(ut, Tt, te2) {
            return Tt = Vm(Tt), te2 === e2 ? (te2 = Tt, Tt = 0) : te2 = Vm(te2), ut = r2(ut), oNt(ut, Tt, te2);
          }
          function AFt(ut, Tt, te2) {
            if (te2 && typeof te2 != "boolean" && D1(ut, Tt, te2) && (Tt = te2 = e2), te2 === e2 && (typeof Tt == "boolean" ? (te2 = Tt, Tt = e2) : typeof ut == "boolean" && (te2 = ut, ut = e2)), ut === e2 && Tt === e2 ? (ut = 0, Tt = 1) : (ut = Vm(ut), Tt === e2 ? (Tt = ut, ut = 0) : Tt = Vm(Tt)), ut > Tt) {
              var ke2 = ut;
              ut = Tt, Tt = ke2;
            }
            if (te2 || ut % 1 || Tt % 1) {
              var ln = EF();
              return Om(ut + ln * (Tt - ut + R6t("1e-" + ((ln + "").length - 1))), Tt);
            }
            return AP(ut, Tt);
          }
          var lot = HF(function(ut, Tt, te2) {
            return Tt = Tt.toLowerCase(), ut + (te2 ? d_t(Tt) : Tt);
          });
          function d_t(ut) {
            return hot(hd2(ut).toLowerCase());
          }
          function uot(ut) {
            return ut = hd2(ut), ut && ut.replace(tr, B6t).replace(Is, "");
          }
          function sI(ut, Tt, te2) {
            ut = hd2(ut), Tt = A1(Tt);
            var ke2 = ut.length;
            te2 = te2 === e2 ? ke2 : XO(pc2(te2), 0, ke2);
            var ln = te2;
            return te2 -= Tt.length, te2 >= 0 && ut.slice(te2, ln) == Tt;
          }
          function IFt(ut) {
            return ut = hd2(ut), ut && wy.test(ut) ? ut.replace(i0, I1t) : ut;
          }
          function g_t(ut) {
            return ut = hd2(ut), ut && RB.test(ut) ? ut.replace(RE, "\\$&") : ut;
          }
          var cot = HF(function(ut, Tt, te2) {
            return ut + (te2 ? "-" : "") + Tt.toLowerCase();
          }), v_t = HF(function(ut, Tt, te2) {
            return ut + (te2 ? " " : "") + Tt.toLowerCase();
          }), fot = yat("toLowerCase");
          function w4(ut, Tt, te2) {
            ut = hd2(ut), Tt = pc2(Tt);
            var ke2 = Tt ? SF(ut) : 0;
            if (!Tt || ke2 >= Tt)
              return ut;
            var ln = (Tt - ke2) / 2;
            return o$($B(ln), te2) + ut + o$(S0(ln), te2);
          }
          function QF(ut, Tt, te2) {
            ut = hd2(ut), Tt = pc2(Tt);
            var ke2 = Tt ? SF(ut) : 0;
            return Tt && ke2 < Tt ? ut + o$(Tt - ke2, te2) : ut;
          }
          function DFt(ut, Tt, te2) {
            ut = hd2(ut), Tt = pc2(Tt);
            var ke2 = Tt ? SF(ut) : 0;
            return Tt && ke2 < Tt ? o$(Tt - ke2, te2) + ut : ut;
          }
          function kb2(ut, Tt, te2) {
            return te2 || Tt == null ? Tt = 0 : Tt && (Tt = +Tt), F1t(hd2(ut).replace(NE, ""), Tt || 0);
          }
          function y_t(ut, Tt, te2) {
            return (te2 ? D1(ut, Tt, te2) : Tt === e2) ? Tt = 1 : Tt = pc2(Tt), sz(hd2(ut), Tt);
          }
          function wz() {
            var ut = arguments, Tt = hd2(ut[0]);
            return ut.length < 3 ? Tt : Tt.replace(ut[1], ut[2]);
          }
          var Sz = HF(function(ut, Tt, te2) {
            return ut + (te2 ? "_" : "") + Tt.toLowerCase();
          });
          function lI(ut, Tt, te2) {
            return te2 && typeof te2 != "number" && D1(ut, Tt, te2) && (Tt = te2 = e2), te2 = te2 === e2 ? ui2 : te2 >>> 0, te2 ? (ut = hd2(ut), ut && (typeof Tt == "string" || Tt != null && !Kat(Tt)) && (Tt = A1(Tt), !Tt && xF(ut)) ? QA(iM(ut), 0, te2) : ut.split(Tt, te2)) : [];
          }
          var IC = HF(function(ut, Tt, te2) {
            return ut + (te2 ? " " : "") + hot(Tt);
          });
          function EFt(ut, Tt, te2) {
            return ut = hd2(ut), te2 = te2 == null ? 0 : XO(pc2(te2), 0, ut.length), Tt = A1(Tt), ut.slice(te2, te2 + Tt.length) == Tt;
          }
          function P$(ut, Tt, te2) {
            var ke2 = Dn.templateSettings;
            te2 && D1(ut, Tt, te2) && (Tt = e2), ut = hd2(ut), Tt = KF({}, Tt, ke2, gbt);
            var ln = KF({}, Tt.imports, ke2.imports, gbt), qn = Xy(ln), Vr = zZ(ln, qn), Yr, Pi2, eo = 0, Do = Tt.interpolate || tu, Jo = "__p += '", cl = WZ((Tt.escape || tu).source + "|" + Do.source + "|" + (Do === hw ? Rn : tu).source + "|" + (Tt.evaluate || tu).source + "|$", "g"), cu = "//# sourceURL=" + (Vp.call(Tt, "sourceURL") ? (Tt.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++Dh2 + "]") + `
`;
            ut.replace(cl, function(Gu, Eh2, _p, E1, Pb2, i2) {
              return _p || (_p = E1), Jo += ut.slice(eo, i2).replace(Kf2, z6t), Eh2 && (Yr = true, Jo += `' +
__e(` + Eh2 + `) +
'`), Pb2 && (Pi2 = true, Jo += `';
` + Pb2 + `;
__p += '`), _p && (Jo += `' +
((__t = (` + _p + `)) == null ? '' : __t) +
'`), eo = i2 + Gu.length, Gu;
            }), Jo += `';
`;
            var ku = Vp.call(Tt, "variable") && Tt.variable;
            if (!ku)
              Jo = `with (obj) {
` + Jo + `
}
`;
            else if (xr.test(ku))
              throw new ef2(D2);
            Jo = (Pi2 ? Jo.replace(Cb2, "") : Jo).replace(z_, "$1").replace(tM, "$1;"), Jo = "function(" + (ku || "obj") + `) {
` + (ku ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (Yr ? ", __e = _.escape" : "") + (Pi2 ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Jo + `return __p
}`;
            var dc2 = __t(function() {
              return td2(qn, cu + "return " + Jo).apply(e2, Vr);
            });
            if (dc2.source = Jo, WP(dc2))
              throw dc2;
            return dc2;
          }
          function kFt(ut) {
            return hd2(ut).toLowerCase();
          }
          function PFt(ut) {
            return hd2(ut).toUpperCase();
          }
          function LFt(ut, Tt, te2) {
            if (ut = hd2(ut), ut && (te2 || Tt === e2))
              return BZ(ut);
            if (!ut || !(Tt = A1(Tt)))
              return ut;
            var ke2 = iM(ut), ln = iM(Tt), qn = A1t(ke2, ln), Vr = jZ(ke2, ln) + 1;
            return QA(ke2, qn, Vr).join("");
          }
          function m_t(ut, Tt, te2) {
            if (ut = hd2(ut), ut && (te2 || Tt === e2))
              return ut.slice(0, k1t(ut) + 1);
            if (!ut || !(Tt = A1(Tt)))
              return ut;
            var ke2 = iM(ut), ln = jZ(ke2, iM(Tt)) + 1;
            return QA(ke2, 0, ln).join("");
          }
          function ww(ut, Tt, te2) {
            if (ut = hd2(ut), ut && (te2 || Tt === e2))
              return ut.replace(NE, "");
            if (!ut || !(Tt = A1(Tt)))
              return ut;
            var ke2 = iM(ut), ln = A1t(ke2, iM(Tt));
            return QA(ke2, ln).join("");
          }
          function OFt(ut, Tt) {
            var te2 = Pe2, ke2 = Be2;
            if (Kg2(Tt)) {
              var ln = "separator" in Tt ? Tt.separator : ln;
              te2 = "length" in Tt ? pc2(Tt.length) : te2, ke2 = "omission" in Tt ? A1(Tt.omission) : ke2;
            }
            ut = hd2(ut);
            var qn = ut.length;
            if (xF(ut)) {
              var Vr = iM(ut);
              qn = Vr.length;
            }
            if (te2 >= qn)
              return ut;
            var Yr = te2 - SF(ke2);
            if (Yr < 1)
              return ke2;
            var Pi2 = Vr ? QA(Vr, 0, Yr).join("") : ut.slice(0, Yr);
            if (ln === e2)
              return Pi2 + ke2;
            if (Vr && (Yr += Pi2.length - Yr), Kat(ln)) {
              if (ut.slice(Yr).search(ln)) {
                var eo, Do = Pi2;
                for (ln.global || (ln = WZ(ln.source, hd2(fr.exec(ln)) + "g")), ln.lastIndex = 0; eo = ln.exec(Do); )
                  var Jo = eo.index;
                Pi2 = Pi2.slice(0, Jo === e2 ? Yr : Jo);
              }
            } else if (ut.indexOf(A1(ln), Yr) != Yr) {
              var cl = Pi2.lastIndexOf(ln);
              cl > -1 && (Pi2 = Pi2.slice(0, cl));
            }
            return Pi2 + ke2;
          }
          function b_t(ut) {
            return ut = hd2(ut), ut && qh2.test(ut) ? ut.replace(j_, Uit) : ut;
          }
          var L$ = HF(function(ut, Tt, te2) {
            return ut + (te2 ? " " : "") + Tt.toUpperCase();
          }), hot = yat("toUpperCase");
          function pot(ut, Tt, te2) {
            return ut = hd2(ut), Tt = te2 ? e2 : Tt, Tt === e2 ? Hit(ut) ? G6t(ut) : jit(ut) : ut.match(Tt) || [];
          }
          var __t = sh2(function(ut, Tt) {
            try {
              return dw(ut, e2, Tt);
            } catch (te2) {
              return WP(te2) ? te2 : new ef2(te2);
            }
          }), x_t = JA(function(ut, Tt) {
            return Jp(Tt, function(te2) {
              te2 = tI(te2), XS(ut, te2, Wat(ut[te2], ut));
            }), ut;
          });
          function Sw(ut) {
            var Tt = ut == null ? 0 : ut.length, te2 = Ju();
            return ut = Tt ? vv(ut, function(ke2) {
              if (typeof ke2[1] != "function")
                throw new $S(C);
              return [te2(ke2[0]), ke2[1]];
            }) : [], sh2(function(ke2) {
              for (var ln = -1; ++ln < Tt; ) {
                var qn = ut[ln];
                if (dw(qn[0], this, ke2))
                  return dw(qn[1], this, ke2);
              }
            });
          }
          function RFt(ut) {
            return YZ(q_(ut, U3));
          }
          function O$(ut) {
            return function() {
              return ut;
            };
          }
          function Mw(ut, Tt) {
            return ut == null || ut !== ut ? Tt : ut;
          }
          var NFt = bp(), FFt = bp(true);
          function ex(ut) {
            return ut;
          }
          function My(ut) {
            return JZ(typeof ut == "function" ? ut : q_(ut, U3));
          }
          function Cw(ut) {
            return t$(q_(ut, U3));
          }
          function VFt(ut, Tt) {
            return YA(ut, q_(Tt, U3));
          }
          var w_t = sh2(function(ut, Tt) {
            return function(te2) {
              return Z_(te2, ut, Tt);
            };
          }), S_t = sh2(function(ut, Tt) {
            return function(te2) {
              return Z_(ut, te2, Tt);
            };
          });
          function JF(ut, Tt, te2) {
            var ke2 = Xy(Tt), ln = zF(Tt, ke2);
            te2 == null && !(Kg2(Tt) && (ln.length || !ke2.length)) && (te2 = Tt, Tt = ut, ut = this, ln = zF(Tt, Xy(Tt)));
            var qn = !(Kg2(te2) && "chain" in te2) || !!te2.chain, Vr = tx(ut);
            return Jp(ln, function(Yr) {
              var Pi2 = Tt[Yr];
              ut[Yr] = Pi2, Vr && (ut.prototype[Yr] = function() {
                var eo = this.__chain__;
                if (qn || eo) {
                  var Do = ut(this.__wrapped__), Jo = Do.__actions__ = Y_(this.__actions__);
                  return Jo.push({ func: Pi2, args: arguments, thisArg: ut }), Do.__chain__ = eo, Do;
                }
                return Pi2.apply(ut, WA([this.value()], arguments));
              });
            }), ut;
          }
          function BFt() {
            return gv._ === this && (gv._ = q6t), this;
          }
          function R$() {
          }
          function dot(ut) {
            return ut = pc2(ut), sh2(function(Tt) {
              return e$(Tt, ut);
            });
          }
          var zFt = oM(vv), got = oM(mP), jFt = oM(Bit);
          function vot(ut) {
            return s4(ut) ? GA(tI(ut)) : tbt(ut);
          }
          function WFt(ut) {
            return function(Tt) {
              return ut == null ? e2 : YE(ut, Tt);
            };
          }
          var Mz = pbt(), GFt = pbt(true);
          function N$() {
            return [];
          }
          function nk2() {
            return false;
          }
          function S4() {
            return {};
          }
          function F$() {
            return "";
          }
          function V$() {
            return true;
          }
          function HFt(ut, Tt) {
            if (ut = pc2(ut), ut < 1 || ut > Kn)
              return [];
            var te2 = ui2, ke2 = Om(ut, ui2);
            Tt = Ju(Tt), ut -= ui2;
            for (var ln = gw(ke2, Tt); ++te2 < ut; )
              Tt(te2);
            return ln;
          }
          function B$(ut) {
            return is(ut) ? vv(ut, tI) : n2(ut) ? [ut] : Y_(Mbt(hd2(ut)));
          }
          function UFt(ut) {
            var Tt = ++TF;
            return hd2(ut) + Tt;
          }
          var qFt = K_(function(ut, Tt) {
            return ut + Tt;
          }, 0), ZFt = l$("ceil"), M_t = K_(function(ut, Tt) {
            return ut / Tt;
          }, 1), t8 = l$("floor");
          function yot(ut) {
            return ut && ut.length ? JO(ut, ex, iz) : e2;
          }
          function Xf2(ut, Tt) {
            return ut && ut.length ? JO(ut, Ju(Tt, 2), iz) : e2;
          }
          function Qg2(ut) {
            return HE(ut, ex);
          }
          function e8(ut, Tt) {
            return HE(ut, Ju(Tt, 2));
          }
          function HP(ut) {
            return ut && ut.length ? JO(ut, ex, yw) : e2;
          }
          function C_t(ut, Tt) {
            return ut && ut.length ? JO(ut, Ju(Tt, 2), yw) : e2;
          }
          var Cz = K_(function(ut, Tt) {
            return ut * Tt;
          }, 1), DC = l$("round"), $Ft = K_(function(ut, Tt) {
            return ut - Tt;
          }, 0);
          function z$(ut) {
            return ut && ut.length ? Wit(ut, ex) : 0;
          }
          function j$(ut, Tt) {
            return ut && ut.length ? Wit(ut, Ju(Tt, 2)) : 0;
          }
          return Dn.after = gz, Dn.ary = Rbt, Dn.assign = i_t, Dn.assignIn = E$, Dn.assignInWith = KF, Dn.assignWith = pFt, Dn.at = eot, Dn.before = Nbt, Dn.bind = Wat, Dn.bindAll = x_t, Dn.bindKey = Gat, Dn.castArray = Hbt, Dn.chain = NP, Dn.chunk = CNt, Dn.compact = TNt, Dn.concat = ANt, Dn.cond = Sw, Dn.conforms = RFt, Dn.constant = O$, Dn.countBy = YNt, Dn.create = dFt, Dn.curry = Fm, Dn.curryRight = Fbt, Dn.debounce = p4, Dn.defaults = gFt, Dn.defaultsDeep = vFt, Dn.defer = Vbt, Dn.delay = Bbt, Dn.difference = INt, Dn.differenceBy = v$, Dn.differenceWith = l4, Dn.drop = DNt, Dn.dropRight = ENt, Dn.dropRightWhile = kNt, Dn.dropWhile = Tat, Dn.fill = PNt, Dn.filter = Pbt, Dn.flatMap = KNt, Dn.flatMapDeep = ek2, Dn.flatMapDepth = zP, Dn.flatten = fz, Dn.flattenDeep = Iat, Dn.flattenDepth = LNt, Dn.flip = d4, Dn.flow = NFt, Dn.flowRight = FFt, Dn.fromPairs = Cbt, Dn.functions = o_t, Dn.functionsIn = bFt, Dn.groupBy = XNt, Dn.initial = RNt, Dn.intersection = NNt, Dn.intersectionBy = Tbt, Dn.intersectionWith = FNt, Dn.invert = _Ft, Dn.invertBy = xFt, Dn.invokeMap = lM, Dn.iteratee = My, Dn.keyBy = QNt, Dn.keys = Xy, Dn.keysIn = xw, Dn.map = S$, Dn.mapKeys = XF, Dn.mapValues = wFt, Dn.matches = Cw, Dn.matchesProperty = VFt, Dn.memoize = C$, Dn.merge = s_t, Dn.mergeWith = l_t, Dn.method = w_t, Dn.methodOf = S_t, Dn.mixin = JF, Dn.negate = T$, Dn.nthArg = dot, Dn.omit = u_t, Dn.omitBy = iot, Dn.once = zbt, Dn.orderBy = JNt, Dn.over = zFt, Dn.overArgs = Vf2, Dn.overEvery = got, Dn.overSome = jFt, Dn.partial = A$, Dn.partialRight = Hat, Dn.partition = tFt, Dn.pick = k$, Dn.pickBy = _z, Dn.property = vot, Dn.propertyOf = WFt, Dn.pull = jNt, Dn.pullAll = Eat, Dn.pullAllBy = kat, Dn.pullAllWith = u4, Dn.pullAt = m$, Dn.range = Mz, Dn.rangeRight = GFt, Dn.rearg = oFt, Dn.reject = nFt, Dn.remove = Abt, Dn.rest = jbt, Dn.reverse = Pat, Dn.sampleSize = rFt, Dn.set = c_t, Dn.setWith = aot, Dn.shuffle = jat, Dn.slice = WNt, Dn.sortBy = aFt, Dn.sortedUniq = Rat, Dn.sortedUniqBy = Nat, Dn.split = lI, Dn.spread = sFt, Dn.tail = c4, Dn.take = b$, Dn.takeRight = _$, Dn.takeRightWhile = x$, Dn.takeWhile = w$, Dn.tap = tk2, Dn.throttle = lFt, Dn.thru = $F, Dn.toArray = Qat, Dn.toPairs = oot, Dn.toPairsIn = sot, Dn.toPath = B$, Dn.toPlainObject = tot, Dn.transform = SFt, Dn.unary = Wbt, Dn.union = Ibt, Dn.unionBy = Dbt, Dn.unionWith = Ebt, Dn.uniq = HNt, Dn.uniqBy = UNt, Dn.uniqWith = qNt, Dn.unset = MFt, Dn.unzip = ed2, Dn.unzipWith = OP, Dn.update = CFt, Dn.updateWith = f_t, Dn.values = x4, Dn.valuesIn = h_t, Dn.without = f4, Dn.words = pot, Dn.wrap = Gbt, Dn.xor = eI, Dn.xorBy = RP, Dn.xorWith = nI, Dn.zip = rI, Dn.zipObject = Fat, Dn.zipObjectDeep = Vat, Dn.zipWith = h4, Dn.entries = oot, Dn.entriesIn = sot, Dn.extend = E$, Dn.extendWith = KF, JF(Dn, Dn), Dn.add = qFt, Dn.attempt = __t, Dn.camelCase = lot, Dn.capitalize = d_t, Dn.ceil = ZFt, Dn.clamp = p_t, Dn.clone = Ubt, Dn.cloneDeep = qbt, Dn.cloneDeepWith = Zbt, Dn.cloneWith = uFt, Dn.conformsTo = $bt, Dn.deburr = uot, Dn.defaultTo = Mw, Dn.divide = M_t, Dn.endsWith = sI, Dn.eq = uM, Dn.escape = IFt, Dn.escapeRegExp = g_t, Dn.every = kbt, Dn.find = BP, Dn.findIndex = y$, Dn.findKey = a_t, Dn.findLast = pz, Dn.findLastIndex = Aat, Dn.findLastKey = yFt, Dn.floor = t8, Dn.forEach = jP, Dn.forEachRight = Lbt, Dn.forIn = m4, Dn.forInRight = mFt, Dn.forOwn = o0, Dn.forOwnRight = not, Dn.get = Ky, Dn.gt = Ybt, Dn.gte = Uat, Dn.has = b4, Dn.hasIn = _4, Dn.head = Dat, Dn.identity = ex, Dn.includes = X_, Dn.indexOf = ONt, Dn.inRange = TFt, Dn.invoke = rot, Dn.isArguments = Zc2, Dn.isArray = is, Dn.isArrayBuffer = qat, Dn.isArrayLike = Q_, Dn.isArrayLikeObject = M0, Dn.isBoolean = Kbt, Dn.isBuffer = aI, Dn.isDate = Zat, Dn.isElement = vz, Dn.isEmpty = I$, Dn.isEqual = J_, Dn.isEqualWith = yz, Dn.isError = WP, Dn.isFinite = cFt, Dn.isFunction = tx, Dn.isInteger = mz, Dn.isLength = GP, Dn.isMap = g4, Dn.isMatch = Xbt, Dn.isMatchWith = Qbt, Dn.isNaN = D$, Dn.isNative = Jbt, Dn.isNil = $at, Dn.isNull = t_t, Dn.isNumber = Yat, Dn.isObject = Kg2, Dn.isObjectLike = Xg2, Dn.isPlainObject = bz, Dn.isRegExp = Kat, Dn.isSafeInteger = e_t, Dn.isSet = oI, Dn.isString = v42, Dn.isSymbol = n2, Dn.isTypedArray = YF, Dn.isUndefined = fFt, Dn.isWeakMap = hFt, Dn.isWeakSet = Xat, Dn.join = VNt, Dn.kebabCase = cot, Dn.last = mw, Dn.lastIndexOf = BNt, Dn.lowerCase = v_t, Dn.lowerFirst = fot, Dn.lt = y4, Dn.lte = n_t, Dn.max = yot, Dn.maxBy = Xf2, Dn.mean = Qg2, Dn.meanBy = e8, Dn.min = HP, Dn.minBy = C_t, Dn.stubArray = N$, Dn.stubFalse = nk2, Dn.stubObject = S4, Dn.stubString = F$, Dn.stubTrue = V$, Dn.multiply = Cz, Dn.nth = zNt, Dn.noConflict = BFt, Dn.noop = R$, Dn.now = dz, Dn.pad = w4, Dn.padEnd = QF, Dn.padStart = DFt, Dn.parseInt = kb2, Dn.random = AFt, Dn.reduce = Obt, Dn.reduceRight = eFt, Dn.repeat = y_t, Dn.replace = wz, Dn.result = xz, Dn.round = DC, Dn.runInContext = xi2, Dn.sample = M$, Dn.size = iFt, Dn.snakeCase = Sz, Dn.some = Mc2, Dn.sortedIndex = Lat, Dn.sortedIndexBy = Oat, Dn.sortedIndexOf = GNt, Dn.sortedLastIndex = sM, Dn.sortedLastIndexBy = bw, Dn.sortedLastIndexOf = _w, Dn.startCase = IC, Dn.startsWith = EFt, Dn.subtract = $Ft, Dn.sum = z$, Dn.sumBy = j$, Dn.template = P$, Dn.times = HFt, Dn.toFinite = Vm, Dn.toInteger = pc2, Dn.toLength = Jat, Dn.toLower = kFt, Dn.toNumber = r2, Dn.toSafeInteger = r_t, Dn.toString = hd2, Dn.toUpper = PFt, Dn.trim = LFt, Dn.trimEnd = m_t, Dn.trimStart = ww, Dn.truncate = OFt, Dn.unescape = b_t, Dn.uniqueId = UFt, Dn.upperCase = L$, Dn.upperFirst = hot, Dn.each = jP, Dn.eachRight = Lbt, Dn.first = Dat, JF(Dn, function() {
            var ut = {};
            return $A(Dn, function(Tt, te2) {
              Vp.call(Dn.prototype, te2) || (ut[te2] = Tt);
            }), ut;
          }(), { chain: false }), Dn.VERSION = d2, Jp(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(ut) {
            Dn[ut].placeholder = Dn;
          }), Jp(["drop", "take"], function(ut, Tt) {
            oh2.prototype[ut] = function(te2) {
              te2 = te2 === e2 ? 1 : lp(pc2(te2), 0);
              var ke2 = this.__filtered__ && !Tt ? new oh2(this) : this.clone();
              return ke2.__filtered__ ? ke2.__takeCount__ = Om(te2, ke2.__takeCount__) : ke2.__views__.push({ size: Om(te2, ui2), type: ut + (ke2.__dir__ < 0 ? "Right" : "") }), ke2;
            }, oh2.prototype[ut + "Right"] = function(te2) {
              return this.reverse()[ut](te2).reverse();
            };
          }), Jp(["filter", "map", "takeWhile"], function(ut, Tt) {
            var te2 = Tt + 1, ke2 = te2 == Cn || te2 == mn;
            oh2.prototype[ut] = function(ln) {
              var qn = this.clone();
              return qn.__iteratees__.push({ iteratee: Ju(ln, 3), type: te2 }), qn.__filtered__ = qn.__filtered__ || ke2, qn;
            };
          }), Jp(["head", "last"], function(ut, Tt) {
            var te2 = "take" + (Tt ? "Right" : "");
            oh2.prototype[ut] = function() {
              return this[te2](1).value()[0];
            };
          }), Jp(["initial", "tail"], function(ut, Tt) {
            var te2 = "drop" + (Tt ? "" : "Right");
            oh2.prototype[ut] = function() {
              return this.__filtered__ ? new oh2(this) : this[te2](1);
            };
          }), oh2.prototype.compact = function() {
            return this.filter(ex);
          }, oh2.prototype.find = function(ut) {
            return this.filter(ut).head();
          }, oh2.prototype.findLast = function(ut) {
            return this.reverse().find(ut);
          }, oh2.prototype.invokeMap = sh2(function(ut, Tt) {
            return typeof ut == "function" ? new oh2(this) : this.map(function(te2) {
              return Z_(te2, ut, Tt);
            });
          }), oh2.prototype.reject = function(ut) {
            return this.filter(T$(Ju(ut)));
          }, oh2.prototype.slice = function(ut, Tt) {
            ut = pc2(ut);
            var te2 = this;
            return te2.__filtered__ && (ut > 0 || Tt < 0) ? new oh2(te2) : (ut < 0 ? te2 = te2.takeRight(-ut) : ut && (te2 = te2.drop(ut)), Tt !== e2 && (Tt = pc2(Tt), te2 = Tt < 0 ? te2.dropRight(-Tt) : te2.take(Tt - ut)), te2);
          }, oh2.prototype.takeRightWhile = function(ut) {
            return this.reverse().takeWhile(ut).reverse();
          }, oh2.prototype.toArray = function() {
            return this.take(ui2);
          }, $A(oh2.prototype, function(ut, Tt) {
            var te2 = /^(?:filter|find|map|reject)|While$/.test(Tt), ke2 = /^(?:head|last)$/.test(Tt), ln = Dn[ke2 ? "take" + (Tt == "last" ? "Right" : "") : Tt], qn = ke2 || /^find/.test(Tt);
            !ln || (Dn.prototype[Tt] = function() {
              var Vr = this.__wrapped__, Yr = ke2 ? [1] : arguments, Pi2 = Vr instanceof oh2, eo = Yr[0], Do = Pi2 || is(Vr), Jo = function(Eh2) {
                var _p = ln.apply(Dn, WA([Eh2], Yr));
                return ke2 && cl ? _p[0] : _p;
              };
              Do && te2 && typeof eo == "function" && eo.length != 1 && (Pi2 = Do = false);
              var cl = this.__chain__, cu = !!this.__actions__.length, ku = qn && !cl, dc2 = Pi2 && !cu;
              if (!qn && Do) {
                Vr = dc2 ? Vr : new oh2(this);
                var Gu = ut.apply(Vr, Yr);
                return Gu.__actions__.push({ func: $F, args: [Jo], thisArg: e2 }), new YS(Gu, cl);
              }
              return ku && dc2 ? ut.apply(this, Yr) : (Gu = this.thru(Jo), ku ? ke2 ? Gu.value()[0] : Gu.value() : Gu);
            });
          }), Jp(["pop", "push", "shift", "sort", "splice", "unshift"], function(ut) {
            var Tt = MF[ut], te2 = /^(?:push|sort|unshift)$/.test(ut) ? "tap" : "thru", ke2 = /^(?:pop|shift)$/.test(ut);
            Dn.prototype[ut] = function() {
              var ln = arguments;
              if (ke2 && !this.__chain__) {
                var qn = this.value();
                return Tt.apply(is(qn) ? qn : [], ln);
              }
              return this[te2](function(Vr) {
                return Tt.apply(is(Vr) ? Vr : [], ln);
              });
            };
          }), $A(oh2.prototype, function(ut, Tt) {
            var te2 = Dn[Tt];
            if (te2) {
              var ke2 = te2.name + "";
              Vp.call(LF, ke2) || (LF[ke2] = []), LF[ke2].push({ name: Tt, func: te2 });
            }
          }), LF[Qo(e2, Ct).name] = [{ name: "wrapper", func: e2 }], oh2.prototype.clone = NF, oh2.prototype.reverse = KS, oh2.prototype.value = Xit, Dn.prototype.at = FP, Dn.prototype.chain = Bat, Dn.prototype.commit = hz, Dn.prototype.next = zat, Dn.prototype.plant = $Nt, Dn.prototype.reverse = iI, Dn.prototype.toJSON = Dn.prototype.valueOf = Dn.prototype.value = VP, Dn.prototype.first = Dn.prototype.head, xP && (Dn.prototype[xP] = ZNt), Dn;
        }, HA = H6t();
        jE ? ((jE.exports = HA)._ = HA, zB._ = HA) : gv._ = HA;
      }).call(en);
    })(Xmt, Xmt.exports);
    class Gde {
      constructor() {
        I2(this, "subscriptions", /* @__PURE__ */ new Map()), I2(this, "emitEffectCache", /* @__PURE__ */ new Map()), I2(this, "useSubscription", (a, e2) => {
          const d2 = P2.useRef();
          P2.useEffect(() => {
            var y2, x2;
            d2.current = e2;
            function C(L) {
              d2.current && d2.current(L);
            }
            const D2 = (x2 = (y2 = this.subscriptions) == null ? void 0 : y2.get(a)) != null ? x2 : [];
            return D2.push(C), this.subscriptions.set(a, D2), this.emitEffect(a), () => {
              this.subscriptions.delete(a);
            };
          }, []);
        }), I2(this, "emit", (a, ...e2) => {
          if (typeof a == "string" || typeof a == "number") {
            const d2 = this.subscriptions.get(a);
            d2 == null || d2.forEach((y2) => {
              y2 == null || y2({ params: Xmt.exports.cloneDeep(e2), event: a });
            }), this.emitEffectCache.set(a, { params: Xmt.exports.cloneDeep(e2), event: a });
          } else
            throw new TypeError("event must be string or number !");
        }), I2(this, "emitEffect", (a) => {
          const e2 = this.emitEffectCache.get(a), d2 = this.subscriptions.get(a);
          e2 && (d2 == null || d2.forEach((y2) => {
            y2 == null || y2(M2({}, e2));
          }));
        }), I2(this, "removeListener", (a) => {
          this.subscriptions.delete(a);
        }), I2(this, "clear", () => {
          this.subscriptions.clear();
        }), this.clear();
      }
    }
    const ugn = new Gde();
    function Hde(l2) {
      const a = P2.useRef(), e2 = P2.useMemo(() => l2 != null ? l2 : { global: false }, [l2]);
      return a.current || (a.current = e2.global ? a.current = ugn : a.current = new Gde()), P2.useEffect(() => () => {
        var d2;
        return (d2 = a.current) == null ? void 0 : d2.clear();
      }, []), a.current;
    }
    const Ude = ({ id: l2, title: a, chart: e2, option: d2 }, y2) => {
      const x2 = P2.useRef(lgn), C = Hde({ global: true });
      return Qa2(() => {
        console.log("id", l2), console.log("chart", e2 == null ? void 0 : e2.current), x2.current && (e2 == null ? void 0 : e2.current) && l2 && d2 && (x2.current.add(l2, e2 == null ? void 0 : e2.current, d2, a), C.emit("list"));
      }, y2 != null ? y2 : [], { wait: 100 }), { tool: x2.current };
    };
    var cgn = P2.createContext({}), qde = cgn;
    function qd2(l2, a, e2) {
      return a in l2 ? Object.defineProperty(l2, a, { value: e2, enumerable: true, configurable: true, writable: true }) : l2[a] = e2, l2;
    }
    function Zde(l2, a) {
      var e2 = Object.keys(l2);
      if (Object.getOwnPropertySymbols) {
        var d2 = Object.getOwnPropertySymbols(l2);
        a && (d2 = d2.filter(function(y2) {
          return Object.getOwnPropertyDescriptor(l2, y2).enumerable;
        })), e2.push.apply(e2, d2);
      }
      return e2;
    }
    function df2(l2) {
      for (var a = 1; a < arguments.length; a++) {
        var e2 = arguments[a] != null ? arguments[a] : {};
        a % 2 ? Zde(Object(e2), true).forEach(function(d2) {
          qd2(l2, d2, e2[d2]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(l2, Object.getOwnPropertyDescriptors(e2)) : Zde(Object(e2)).forEach(function(d2) {
          Object.defineProperty(l2, d2, Object.getOwnPropertyDescriptor(e2, d2));
        });
      }
      return l2;
    }
    function $de(l2) {
      if (Array.isArray(l2))
        return l2;
    }
    function fgn(l2, a) {
      var e2 = l2 == null ? null : typeof Symbol != "undefined" && l2[Symbol.iterator] || l2["@@iterator"];
      if (e2 != null) {
        var d2 = [], y2 = true, x2 = false, C, D2;
        try {
          for (e2 = e2.call(l2); !(y2 = (C = e2.next()).done) && (d2.push(C.value), !(a && d2.length === a)); y2 = true)
            ;
        } catch (L) {
          x2 = true, D2 = L;
        } finally {
          try {
            !y2 && e2.return != null && e2.return();
          } finally {
            if (x2)
              throw D2;
          }
        }
        return d2;
      }
    }
    function WRt(l2, a) {
      (a == null || a > l2.length) && (a = l2.length);
      for (var e2 = 0, d2 = new Array(a); e2 < a; e2++)
        d2[e2] = l2[e2];
      return d2;
    }
    function GRt(l2, a) {
      if (l2) {
        if (typeof l2 == "string")
          return WRt(l2, a);
        var e2 = Object.prototype.toString.call(l2).slice(8, -1);
        if (e2 === "Object" && l2.constructor && (e2 = l2.constructor.name), e2 === "Map" || e2 === "Set")
          return Array.from(l2);
        if (e2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(e2))
          return WRt(l2, a);
      }
    }
    function Yde() {
      throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function RA(l2, a) {
      return $de(l2) || fgn(l2, a) || GRt(l2, a) || Yde();
    }
    function hgn(l2, a) {
      if (l2 == null)
        return {};
      var e2 = {}, d2 = Object.keys(l2), y2, x2;
      for (x2 = 0; x2 < d2.length; x2++)
        y2 = d2[x2], !(a.indexOf(y2) >= 0) && (e2[y2] = l2[y2]);
      return e2;
    }
    function TZ(l2, a) {
      if (l2 == null)
        return {};
      var e2 = hgn(l2, a), d2, y2;
      if (Object.getOwnPropertySymbols) {
        var x2 = Object.getOwnPropertySymbols(l2);
        for (y2 = 0; y2 < x2.length; y2++)
          d2 = x2[y2], !(a.indexOf(d2) >= 0) && (!Object.prototype.propertyIsEnumerable.call(l2, d2) || (e2[d2] = l2[d2]));
      }
      return e2;
    }
    var Kde = { exports: {} };
    /*!
      Copyright (c) 2018 Jed Watson.
      Licensed under the MIT License (MIT), see
      http://jedwatson.github.io/classnames
    */
    (function(l2) {
      (function() {
        var a = {}.hasOwnProperty;
        function e2() {
          for (var d2 = [], y2 = 0; y2 < arguments.length; y2++) {
            var x2 = arguments[y2];
            if (x2) {
              var C = typeof x2;
              if (C === "string" || C === "number")
                d2.push(x2);
              else if (Array.isArray(x2)) {
                if (x2.length) {
                  var D2 = e2.apply(null, x2);
                  D2 && d2.push(D2);
                }
              } else if (C === "object")
                if (x2.toString === Object.prototype.toString)
                  for (var L in x2)
                    a.call(x2, L) && x2[L] && d2.push(L);
                else
                  d2.push(x2.toString());
            }
          }
          return d2.join(" ");
        }
        l2.exports ? (e2.default = e2, l2.exports = e2) : window.classNames = e2;
      })();
    })(Kde);
    var AZ = Kde.exports;
    function cw(l2) {
      return cw = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(a) {
        return typeof a;
      } : function(a) {
        return a && typeof Symbol == "function" && a.constructor === Symbol && a !== Symbol.prototype ? "symbol" : typeof a;
      }, cw(l2);
    }
    function NA(l2, a) {
      pgn(l2) && (l2 = "100%");
      var e2 = dgn(l2);
      return l2 = a === 360 ? l2 : Math.min(a, Math.max(0, parseFloat(l2))), e2 && (l2 = parseInt(String(l2 * a), 10) / 100), Math.abs(l2 - a) < 1e-6 ? 1 : (a === 360 ? l2 = (l2 < 0 ? l2 % a + a : l2 % a) / parseFloat(String(a)) : l2 = l2 % a / parseFloat(String(a)), l2);
    }
    function pgn(l2) {
      return typeof l2 == "string" && l2.indexOf(".") !== -1 && parseFloat(l2) === 1;
    }
    function dgn(l2) {
      return typeof l2 == "string" && l2.indexOf("%") !== -1;
    }
    function ggn(l2) {
      return l2 = parseFloat(l2), (isNaN(l2) || l2 < 0 || l2 > 1) && (l2 = 1), l2;
    }
    function Qmt(l2) {
      return l2 <= 1 ? Number(l2) * 100 + "%" : l2;
    }
    function HRt(l2) {
      return l2.length === 1 ? "0" + l2 : String(l2);
    }
    function vgn(l2, a, e2) {
      return { r: NA(l2, 255) * 255, g: NA(a, 255) * 255, b: NA(e2, 255) * 255 };
    }
    function URt(l2, a, e2) {
      return e2 < 0 && (e2 += 1), e2 > 1 && (e2 -= 1), e2 < 1 / 6 ? l2 + (a - l2) * (6 * e2) : e2 < 1 / 2 ? a : e2 < 2 / 3 ? l2 + (a - l2) * (2 / 3 - e2) * 6 : l2;
    }
    function ygn(l2, a, e2) {
      var d2, y2, x2;
      if (l2 = NA(l2, 360), a = NA(a, 100), e2 = NA(e2, 100), a === 0)
        y2 = e2, x2 = e2, d2 = e2;
      else {
        var C = e2 < 0.5 ? e2 * (1 + a) : e2 + a - e2 * a, D2 = 2 * e2 - C;
        d2 = URt(D2, C, l2 + 1 / 3), y2 = URt(D2, C, l2), x2 = URt(D2, C, l2 - 1 / 3);
      }
      return { r: d2 * 255, g: y2 * 255, b: x2 * 255 };
    }
    function mgn(l2, a, e2) {
      l2 = NA(l2, 255), a = NA(a, 255), e2 = NA(e2, 255);
      var d2 = Math.max(l2, a, e2), y2 = Math.min(l2, a, e2), x2 = 0, C = d2, D2 = d2 - y2, L = d2 === 0 ? 0 : D2 / d2;
      if (d2 === y2)
        x2 = 0;
      else {
        switch (d2) {
          case l2:
            x2 = (a - e2) / D2 + (a < e2 ? 6 : 0);
            break;
          case a:
            x2 = (e2 - l2) / D2 + 2;
            break;
          case e2:
            x2 = (l2 - a) / D2 + 4;
            break;
        }
        x2 /= 6;
      }
      return { h: x2, s: L, v: C };
    }
    function bgn(l2, a, e2) {
      l2 = NA(l2, 360) * 6, a = NA(a, 100), e2 = NA(e2, 100);
      var d2 = Math.floor(l2), y2 = l2 - d2, x2 = e2 * (1 - a), C = e2 * (1 - y2 * a), D2 = e2 * (1 - (1 - y2) * a), L = d2 % 6, F3 = [e2, C, x2, x2, D2, e2][L], j = [D2, e2, e2, C, x2, x2][L], U3 = [x2, x2, D2, e2, e2, C][L];
      return { r: F3 * 255, g: j * 255, b: U3 * 255 };
    }
    function _gn(l2, a, e2, d2) {
      var y2 = [HRt(Math.round(l2).toString(16)), HRt(Math.round(a).toString(16)), HRt(Math.round(e2).toString(16))];
      return d2 && y2[0].startsWith(y2[0].charAt(1)) && y2[1].startsWith(y2[1].charAt(1)) && y2[2].startsWith(y2[2].charAt(1)) ? y2[0].charAt(0) + y2[1].charAt(0) + y2[2].charAt(0) : y2.join("");
    }
    function Xde(l2) {
      return yC(l2) / 255;
    }
    function yC(l2) {
      return parseInt(l2, 16);
    }
    var Qde = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
    function bit(l2) {
      var a = { r: 0, g: 0, b: 0 }, e2 = 1, d2 = null, y2 = null, x2 = null, C = false, D2 = false;
      return typeof l2 == "string" && (l2 = Sgn(l2)), typeof l2 == "object" && (jO(l2.r) && jO(l2.g) && jO(l2.b) ? (a = vgn(l2.r, l2.g, l2.b), C = true, D2 = String(l2.r).substr(-1) === "%" ? "prgb" : "rgb") : jO(l2.h) && jO(l2.s) && jO(l2.v) ? (d2 = Qmt(l2.s), y2 = Qmt(l2.v), a = bgn(l2.h, d2, y2), C = true, D2 = "hsv") : jO(l2.h) && jO(l2.s) && jO(l2.l) && (d2 = Qmt(l2.s), x2 = Qmt(l2.l), a = ygn(l2.h, d2, x2), C = true, D2 = "hsl"), Object.prototype.hasOwnProperty.call(l2, "a") && (e2 = l2.a)), e2 = ggn(e2), { ok: C, format: l2.format || D2, r: Math.min(255, Math.max(a.r, 0)), g: Math.min(255, Math.max(a.g, 0)), b: Math.min(255, Math.max(a.b, 0)), a: e2 };
    }
    var xgn = "[-\\+]?\\d+%?", wgn = "[-\\+]?\\d*\\.\\d+%?", dF = "(?:" + wgn + ")|(?:" + xgn + ")", qRt = "[\\s|\\(]+(" + dF + ")[,|\\s]+(" + dF + ")[,|\\s]+(" + dF + ")\\s*\\)?", ZRt = "[\\s|\\(]+(" + dF + ")[,|\\s]+(" + dF + ")[,|\\s]+(" + dF + ")[,|\\s]+(" + dF + ")\\s*\\)?", OE = { CSS_UNIT: new RegExp(dF), rgb: new RegExp("rgb" + qRt), rgba: new RegExp("rgba" + ZRt), hsl: new RegExp("hsl" + qRt), hsla: new RegExp("hsla" + ZRt), hsv: new RegExp("hsv" + qRt), hsva: new RegExp("hsva" + ZRt), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
    function Sgn(l2) {
      if (l2 = l2.trim().toLowerCase(), l2.length === 0)
        return false;
      var a = false;
      if (Qde[l2])
        l2 = Qde[l2], a = true;
      else if (l2 === "transparent")
        return { r: 0, g: 0, b: 0, a: 0, format: "name" };
      var e2 = OE.rgb.exec(l2);
      return e2 ? { r: e2[1], g: e2[2], b: e2[3] } : (e2 = OE.rgba.exec(l2), e2 ? { r: e2[1], g: e2[2], b: e2[3], a: e2[4] } : (e2 = OE.hsl.exec(l2), e2 ? { h: e2[1], s: e2[2], l: e2[3] } : (e2 = OE.hsla.exec(l2), e2 ? { h: e2[1], s: e2[2], l: e2[3], a: e2[4] } : (e2 = OE.hsv.exec(l2), e2 ? { h: e2[1], s: e2[2], v: e2[3] } : (e2 = OE.hsva.exec(l2), e2 ? { h: e2[1], s: e2[2], v: e2[3], a: e2[4] } : (e2 = OE.hex8.exec(l2), e2 ? { r: yC(e2[1]), g: yC(e2[2]), b: yC(e2[3]), a: Xde(e2[4]), format: a ? "name" : "hex8" } : (e2 = OE.hex6.exec(l2), e2 ? { r: yC(e2[1]), g: yC(e2[2]), b: yC(e2[3]), format: a ? "name" : "hex" } : (e2 = OE.hex4.exec(l2), e2 ? { r: yC(e2[1] + e2[1]), g: yC(e2[2] + e2[2]), b: yC(e2[3] + e2[3]), a: Xde(e2[4] + e2[4]), format: a ? "name" : "hex8" } : (e2 = OE.hex3.exec(l2), e2 ? { r: yC(e2[1] + e2[1]), g: yC(e2[2] + e2[2]), b: yC(e2[3] + e2[3]), format: a ? "name" : "hex" } : false)))))))));
    }
    function jO(l2) {
      return Boolean(OE.CSS_UNIT.exec(String(l2)));
    }
    var Jmt = 2, Jde = 0.16, Mgn = 0.05, Cgn = 0.05, Tgn = 0.15, tge = 5, ege = 4, Agn = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
    function nge(l2) {
      var a = l2.r, e2 = l2.g, d2 = l2.b, y2 = mgn(a, e2, d2);
      return { h: y2.h * 360, s: y2.s, v: y2.v };
    }
    function t1t(l2) {
      var a = l2.r, e2 = l2.g, d2 = l2.b;
      return "#".concat(_gn(a, e2, d2, false));
    }
    function Ign(l2, a, e2) {
      var d2 = e2 / 100, y2 = { r: (a.r - l2.r) * d2 + l2.r, g: (a.g - l2.g) * d2 + l2.g, b: (a.b - l2.b) * d2 + l2.b };
      return y2;
    }
    function rge(l2, a, e2) {
      var d2;
      return Math.round(l2.h) >= 60 && Math.round(l2.h) <= 240 ? d2 = e2 ? Math.round(l2.h) - Jmt * a : Math.round(l2.h) + Jmt * a : d2 = e2 ? Math.round(l2.h) + Jmt * a : Math.round(l2.h) - Jmt * a, d2 < 0 ? d2 += 360 : d2 >= 360 && (d2 -= 360), d2;
    }
    function ige(l2, a, e2) {
      if (l2.h === 0 && l2.s === 0)
        return l2.s;
      var d2;
      return e2 ? d2 = l2.s - Jde * a : a === ege ? d2 = l2.s + Jde : d2 = l2.s + Mgn * a, d2 > 1 && (d2 = 1), e2 && a === tge && d2 > 0.1 && (d2 = 0.1), d2 < 0.06 && (d2 = 0.06), Number(d2.toFixed(2));
    }
    function age(l2, a, e2) {
      var d2;
      return e2 ? d2 = l2.v + Cgn * a : d2 = l2.v - Tgn * a, d2 > 1 && (d2 = 1), Number(d2.toFixed(2));
    }
    function $Rt(l2) {
      for (var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = [], d2 = bit(l2), y2 = tge; y2 > 0; y2 -= 1) {
        var x2 = nge(d2), C = t1t(bit({ h: rge(x2, y2, true), s: ige(x2, y2, true), v: age(x2, y2, true) }));
        e2.push(C);
      }
      e2.push(t1t(d2));
      for (var D2 = 1; D2 <= ege; D2 += 1) {
        var L = nge(d2), F3 = t1t(bit({ h: rge(L, D2), s: ige(L, D2), v: age(L, D2) }));
        e2.push(F3);
      }
      return a.theme === "dark" ? Agn.map(function(j) {
        var U3 = j.index, Y3 = j.opacity, Q = t1t(Ign(bit(a.backgroundColor || "#141414"), bit(e2[U3]), Y3 * 100));
        return Q;
      }) : e2;
    }
    var YRt = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, fw = {}, KRt = {};
    Object.keys(YRt).forEach(function(l2) {
      fw[l2] = $Rt(YRt[l2]), fw[l2].primary = fw[l2][5], KRt[l2] = $Rt(YRt[l2], { theme: "dark", backgroundColor: "#141414" }), KRt[l2].primary = KRt[l2][5];
    }), fw.red, fw.volcano, fw.gold, fw.orange, fw.yellow, fw.lime, fw.green, fw.cyan, fw.blue, fw.geekblue, fw.purple, fw.magenta, fw.grey;
    var oge = {};
    function Dgn(l2, a) {
    }
    function Egn(l2, a, e2) {
      !a && !oge[e2] && (l2(false, e2), oge[e2] = true);
    }
    function gP(l2, a) {
      Egn(Dgn, l2, a);
    }
    function sge() {
      return !!(typeof window != "undefined" && window.document && window.document.createElement);
    }
    var kgn = "rc-util-key";
    function lge() {
      var l2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, a = l2.mark;
      return a ? a.startsWith("data-") ? a : "data-".concat(a) : kgn;
    }
    function XRt(l2) {
      if (l2.attachTo)
        return l2.attachTo;
      var a = document.querySelector("head");
      return a || document.body;
    }
    function uge(l2) {
      var a, e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      if (!sge())
        return null;
      var d2 = document.createElement("style");
      if (!((a = e2.csp) === null || a === void 0) && a.nonce) {
        var y2;
        d2.nonce = (y2 = e2.csp) === null || y2 === void 0 ? void 0 : y2.nonce;
      }
      d2.innerHTML = l2;
      var x2 = XRt(e2), C = x2.firstChild;
      return e2.prepend && x2.prepend ? x2.prepend(d2) : e2.prepend && C ? x2.insertBefore(d2, C) : x2.appendChild(d2), d2;
    }
    var QRt = /* @__PURE__ */ new Map();
    function Pgn(l2) {
      var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = XRt(a);
      return Array.from(QRt.get(e2).children).find(function(d2) {
        return d2.tagName === "STYLE" && d2.getAttribute(lge(a)) === l2;
      });
    }
    function cge(l2, a) {
      var e2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, d2 = XRt(e2);
      if (!QRt.has(d2)) {
        var y2 = uge("", e2), x2 = y2.parentNode;
        QRt.set(d2, x2), x2.removeChild(y2);
      }
      var C = Pgn(a, e2);
      if (C) {
        var D2, L;
        if (((D2 = e2.csp) === null || D2 === void 0 ? void 0 : D2.nonce) && C.nonce !== ((L = e2.csp) === null || L === void 0 ? void 0 : L.nonce)) {
          var F3;
          C.nonce = (F3 = e2.csp) === null || F3 === void 0 ? void 0 : F3.nonce;
        }
        return C.innerHTML !== l2 && (C.innerHTML = l2), C;
      }
      var j = uge(l2, e2);
      return j.setAttribute(lge(e2), a), j;
    }
    function Lgn(l2, a) {
      gP(l2, "[@ant-design/icons] ".concat(a));
    }
    function fge(l2) {
      return cw(l2) === "object" && typeof l2.name == "string" && typeof l2.theme == "string" && (cw(l2.icon) === "object" || typeof l2.icon == "function");
    }
    function hge() {
      var l2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      return Object.keys(l2).reduce(function(a, e2) {
        var d2 = l2[e2];
        switch (e2) {
          case "class":
            a.className = d2, delete a.class;
            break;
          default:
            a[e2] = d2;
        }
        return a;
      }, {});
    }
    function JRt(l2, a, e2) {
      return e2 ? H2.default.createElement(l2.tag, df2(df2({ key: a }, hge(l2.attrs)), e2), (l2.children || []).map(function(d2, y2) {
        return JRt(d2, "".concat(a, "-").concat(l2.tag, "-").concat(y2));
      })) : H2.default.createElement(l2.tag, df2({ key: a }, hge(l2.attrs)), (l2.children || []).map(function(d2, y2) {
        return JRt(d2, "".concat(a, "-").concat(l2.tag, "-").concat(y2));
      }));
    }
    function pge(l2) {
      return $Rt(l2)[0];
    }
    function dge(l2) {
      return l2 ? Array.isArray(l2) ? l2 : [l2] : [];
    }
    var Ogn = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, Rgn = function() {
      var l2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Ogn, a = P2.useContext(qde), e2 = a.csp;
      P2.useEffect(function() {
        cge(l2, "@ant-design-icons", { prepend: true, csp: e2 });
      }, []);
    }, Ngn = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], _it = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
    function Fgn(l2) {
      var a = l2.primaryColor, e2 = l2.secondaryColor;
      _it.primaryColor = a, _it.secondaryColor = e2 || pge(a), _it.calculated = !!e2;
    }
    function Vgn() {
      return df2({}, _it);
    }
    var e1t = function(l2) {
      var a = l2.icon, e2 = l2.className, d2 = l2.onClick, y2 = l2.style, x2 = l2.primaryColor, C = l2.secondaryColor, D2 = TZ(l2, Ngn), L = _it;
      if (x2 && (L = { primaryColor: x2, secondaryColor: C || pge(x2) }), Rgn(), Lgn(fge(a), "icon should be icon definiton, but got ".concat(a)), !fge(a))
        return null;
      var F3 = a;
      return F3 && typeof F3.icon == "function" && (F3 = df2(df2({}, F3), {}, { icon: F3.icon(L.primaryColor, L.secondaryColor) })), JRt(F3.icon, "svg-".concat(F3.name), df2({ className: e2, onClick: d2, style: y2, "data-icon": F3.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, D2));
    };
    e1t.displayName = "IconReact", e1t.getTwoToneColors = Vgn, e1t.setTwoToneColors = Fgn;
    var t6t = e1t;
    function gge(l2) {
      var a = dge(l2), e2 = RA(a, 2), d2 = e2[0], y2 = e2[1];
      return t6t.setTwoToneColors({ primaryColor: d2, secondaryColor: y2 });
    }
    function Bgn() {
      var l2 = t6t.getTwoToneColors();
      return l2.calculated ? [l2.primaryColor, l2.secondaryColor] : l2.primaryColor;
    }
    var zgn = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
    gge("#1890ff");
    var n1t = $.forwardRef(function(l2, a) {
      var e2, d2 = l2.className, y2 = l2.icon, x2 = l2.spin, C = l2.rotate, D2 = l2.tabIndex, L = l2.onClick, F3 = l2.twoToneColor, j = TZ(l2, zgn), U3 = $.useContext(qde), Y3 = U3.prefixCls, Q = Y3 === void 0 ? "anticon" : Y3, nt = AZ(Q, (e2 = {}, qd2(e2, "".concat(Q, "-").concat(y2.name), !!y2.name), qd2(e2, "".concat(Q, "-spin"), !!x2 || y2.name === "loading"), e2), d2), dt = D2;
      dt === void 0 && L && (dt = -1);
      var vt = C ? { msTransform: "rotate(".concat(C, "deg)"), transform: "rotate(".concat(C, "deg)") } : void 0, Ct = dge(F3), Pt = RA(Ct, 2), jt = Pt[0], Rt = Pt[1];
      return $.createElement("span", df2(df2({ role: "img", "aria-label": y2.name }, j), {}, { ref: a, tabIndex: dt, onClick: L, className: nt }), $.createElement(t6t, { icon: y2, primaryColor: jt, secondaryColor: Rt, style: vt }));
    });
    n1t.displayName = "AntdIcon", n1t.getTwoToneColor = Bgn, n1t.setTwoToneColor = gge;
    var jgn = n1t, Wgn = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, Ggn = Wgn, vge = function(l2, a) {
      return $.createElement(jgn, df2(df2({}, l2), {}, { ref: a, icon: Ggn }));
    };
    vge.displayName = "LoadingOutlined";
    var Hgn = $.forwardRef(vge);
    function km() {
      return km = Object.assign || function(l2) {
        for (var a = 1; a < arguments.length; a++) {
          var e2 = arguments[a];
          for (var d2 in e2)
            Object.prototype.hasOwnProperty.call(e2, d2) && (l2[d2] = e2[d2]);
        }
        return l2;
      }, km.apply(this, arguments);
    }
    function xit(l2, a) {
      if (!(l2 instanceof a))
        throw new TypeError("Cannot call a class as a function");
    }
    function yge(l2, a) {
      for (var e2 = 0; e2 < a.length; e2++) {
        var d2 = a[e2];
        d2.enumerable = d2.enumerable || false, d2.configurable = true, "value" in d2 && (d2.writable = true), Object.defineProperty(l2, d2.key, d2);
      }
    }
    function wit(l2, a, e2) {
      return a && yge(l2.prototype, a), e2 && yge(l2, e2), Object.defineProperty(l2, "prototype", { writable: false }), l2;
    }
    function e6t(l2, a) {
      return e6t = Object.setPrototypeOf || function(e2, d2) {
        return e2.__proto__ = d2, e2;
      }, e6t(l2, a);
    }
    function n6t(l2, a) {
      if (typeof a != "function" && a !== null)
        throw new TypeError("Super expression must either be null or a function");
      l2.prototype = Object.create(a && a.prototype, { constructor: { value: l2, writable: true, configurable: true } }), Object.defineProperty(l2, "prototype", { writable: false }), a && e6t(l2, a);
    }
    function r1t(l2) {
      return r1t = Object.setPrototypeOf ? Object.getPrototypeOf : function(a) {
        return a.__proto__ || Object.getPrototypeOf(a);
      }, r1t(l2);
    }
    function Ugn() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function r6t(l2) {
      if (l2 === void 0)
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      return l2;
    }
    function qgn(l2, a) {
      if (a && (cw(a) === "object" || typeof a == "function"))
        return a;
      if (a !== void 0)
        throw new TypeError("Derived constructors may only return object or undefined");
      return r6t(l2);
    }
    function i6t(l2) {
      var a = Ugn();
      return function() {
        var e2 = r1t(l2), d2;
        if (a) {
          var y2 = r1t(this).constructor;
          d2 = Reflect.construct(e2, arguments, y2);
        } else
          d2 = e2.apply(this, arguments);
        return qgn(this, d2);
      };
    }
    var a6t = { exports: {} }, gg2 = {};
    /** @license React v16.13.1
    * react-is.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var Mb2 = typeof Symbol == "function" && Symbol.for, o6t = Mb2 ? Symbol.for("react.element") : 60103, s6t = Mb2 ? Symbol.for("react.portal") : 60106, i1t = Mb2 ? Symbol.for("react.fragment") : 60107, a1t = Mb2 ? Symbol.for("react.strict_mode") : 60108, o1t = Mb2 ? Symbol.for("react.profiler") : 60114, s1t = Mb2 ? Symbol.for("react.provider") : 60109, l1t = Mb2 ? Symbol.for("react.context") : 60110, l6t = Mb2 ? Symbol.for("react.async_mode") : 60111, u1t = Mb2 ? Symbol.for("react.concurrent_mode") : 60111, c1t = Mb2 ? Symbol.for("react.forward_ref") : 60112, f1t = Mb2 ? Symbol.for("react.suspense") : 60113, Zgn = Mb2 ? Symbol.for("react.suspense_list") : 60120, h1t = Mb2 ? Symbol.for("react.memo") : 60115, p1t = Mb2 ? Symbol.for("react.lazy") : 60116, $gn = Mb2 ? Symbol.for("react.block") : 60121, Ygn = Mb2 ? Symbol.for("react.fundamental") : 60117, Kgn = Mb2 ? Symbol.for("react.responder") : 60118, Xgn = Mb2 ? Symbol.for("react.scope") : 60119;
    function mC(l2) {
      if (typeof l2 == "object" && l2 !== null) {
        var a = l2.$$typeof;
        switch (a) {
          case o6t:
            switch (l2 = l2.type, l2) {
              case l6t:
              case u1t:
              case i1t:
              case o1t:
              case a1t:
              case f1t:
                return l2;
              default:
                switch (l2 = l2 && l2.$$typeof, l2) {
                  case l1t:
                  case c1t:
                  case p1t:
                  case h1t:
                  case s1t:
                    return l2;
                  default:
                    return a;
                }
            }
          case s6t:
            return a;
        }
      }
    }
    function mge(l2) {
      return mC(l2) === u1t;
    }
    gg2.AsyncMode = l6t, gg2.ConcurrentMode = u1t, gg2.ContextConsumer = l1t, gg2.ContextProvider = s1t, gg2.Element = o6t, gg2.ForwardRef = c1t, gg2.Fragment = i1t, gg2.Lazy = p1t, gg2.Memo = h1t, gg2.Portal = s6t, gg2.Profiler = o1t, gg2.StrictMode = a1t, gg2.Suspense = f1t, gg2.isAsyncMode = function(l2) {
      return mge(l2) || mC(l2) === l6t;
    }, gg2.isConcurrentMode = mge, gg2.isContextConsumer = function(l2) {
      return mC(l2) === l1t;
    }, gg2.isContextProvider = function(l2) {
      return mC(l2) === s1t;
    }, gg2.isElement = function(l2) {
      return typeof l2 == "object" && l2 !== null && l2.$$typeof === o6t;
    }, gg2.isForwardRef = function(l2) {
      return mC(l2) === c1t;
    }, gg2.isFragment = function(l2) {
      return mC(l2) === i1t;
    }, gg2.isLazy = function(l2) {
      return mC(l2) === p1t;
    }, gg2.isMemo = function(l2) {
      return mC(l2) === h1t;
    }, gg2.isPortal = function(l2) {
      return mC(l2) === s6t;
    }, gg2.isProfiler = function(l2) {
      return mC(l2) === o1t;
    }, gg2.isStrictMode = function(l2) {
      return mC(l2) === a1t;
    }, gg2.isSuspense = function(l2) {
      return mC(l2) === f1t;
    }, gg2.isValidElementType = function(l2) {
      return typeof l2 == "string" || typeof l2 == "function" || l2 === i1t || l2 === u1t || l2 === o1t || l2 === a1t || l2 === f1t || l2 === Zgn || typeof l2 == "object" && l2 !== null && (l2.$$typeof === p1t || l2.$$typeof === h1t || l2.$$typeof === s1t || l2.$$typeof === l1t || l2.$$typeof === c1t || l2.$$typeof === Ygn || l2.$$typeof === Kgn || l2.$$typeof === Xgn || l2.$$typeof === $gn);
    }, gg2.typeOf = mC, a6t.exports = gg2;
    function u6t(l2) {
      var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = [];
      return H2.default.Children.forEach(l2, function(d2) {
        d2 == null && !a.keepEmpty || (Array.isArray(d2) ? e2 = e2.concat(u6t(d2)) : a6t.exports.isFragment(d2) && d2.props ? e2 = e2.concat(u6t(d2.props.children, a)) : e2.push(d2));
      }), e2;
    }
    function Qgn(l2, a) {
      typeof l2 == "function" ? l2(a) : cw(l2) === "object" && l2 && "current" in l2 && (l2.current = a);
    }
    function Jgn() {
      for (var l2 = arguments.length, a = new Array(l2), e2 = 0; e2 < l2; e2++)
        a[e2] = arguments[e2];
      var d2 = a.filter(function(y2) {
        return y2;
      });
      return d2.length <= 1 ? d2[0] : function(y2) {
        a.forEach(function(x2) {
          Qgn(x2, y2);
        });
      };
    }
    function tvn(l2) {
      var a, e2, d2 = a6t.exports.isMemo(l2) ? l2.type.type : l2.type;
      return !(typeof d2 == "function" && !(!((a = d2.prototype) === null || a === void 0) && a.render) || typeof l2 == "function" && !(!((e2 = l2.prototype) === null || e2 === void 0) && e2.render));
    }
    function evn() {
      try {
        if (!Object.assign)
          return false;
        var l2 = new String("abc");
        if (l2[5] = "de", Object.getOwnPropertyNames(l2)[0] === "5")
          return false;
        for (var a = {}, e2 = 0; e2 < 10; e2++)
          a["_" + String.fromCharCode(e2)] = e2;
        var d2 = Object.getOwnPropertyNames(a).map(function(x2) {
          return a[x2];
        });
        if (d2.join("") !== "0123456789")
          return false;
        var y2 = {};
        return "abcdefghijklmnopqrst".split("").forEach(function(x2) {
          y2[x2] = x2;
        }), Object.keys(Object.assign({}, y2)).join("") === "abcdefghijklmnopqrst";
      } catch {
        return false;
      }
    }
    evn();
    function nvn(l2) {
      if (Array.isArray(l2))
        return WRt(l2);
    }
    function bge(l2) {
      if (typeof Symbol != "undefined" && l2[Symbol.iterator] != null || l2["@@iterator"] != null)
        return Array.from(l2);
    }
    function rvn() {
      throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function Rp(l2) {
      return nvn(l2) || bge(l2) || GRt(l2) || rvn();
    }
    var IZ = "RC_FORM_INTERNAL_HOOKS", r0 = function() {
      gP(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
    }, Sit = $.createContext({ getFieldValue: r0, getFieldsValue: r0, getFieldError: r0, getFieldWarning: r0, getFieldsError: r0, isFieldsTouched: r0, isFieldTouched: r0, isFieldValidating: r0, isFieldsValidating: r0, resetFields: r0, setFields: r0, setFieldsValue: r0, validateFields: r0, submit: r0, getInternalHooks: function() {
      return r0(), { dispatch: r0, initEntityValue: r0, registerField: r0, useSubscribe: r0, setInitialValues: r0, setCallbacks: r0, getFields: r0, setValidateMessages: r0, setPreserve: r0, getInitialValue: r0 };
    } });
    function c6t(l2) {
      return l2 == null ? [] : Array.isArray(l2) ? l2 : [l2];
    }
    var _ge = { exports: {} };
    (function(l2) {
      var a = function(e2) {
        var d2 = Object.prototype, y2 = d2.hasOwnProperty, x2, C = typeof Symbol == "function" ? Symbol : {}, D2 = C.iterator || "@@iterator", L = C.asyncIterator || "@@asyncIterator", F3 = C.toStringTag || "@@toStringTag";
        function j(Kn, ar, Cr) {
          return Object.defineProperty(Kn, ar, { value: Cr, enumerable: true, configurable: true, writable: true }), Kn[ar];
        }
        try {
          j({}, "");
        } catch {
          j = function(Kn, ar, Cr) {
            return Kn[ar] = Cr;
          };
        }
        function U3(Kn, ar, Cr, ui2) {
          var vi2 = ar && ar.prototype instanceof Pt ? ar : Pt, ko = Object.create(vi2.prototype), Ss = new Bn(ui2 || []);
          return ko._invoke = Be2(Kn, Cr, Ss), ko;
        }
        e2.wrap = U3;
        function Y3(Kn, ar, Cr) {
          try {
            return { type: "normal", arg: Kn.call(ar, Cr) };
          } catch (ui2) {
            return { type: "throw", arg: ui2 };
          }
        }
        var Q = "suspendedStart", nt = "suspendedYield", dt = "executing", vt = "completed", Ct = {};
        function Pt() {
        }
        function jt() {
        }
        function Rt() {
        }
        var le2 = {};
        j(le2, D2, function() {
          return this;
        });
        var ne2 = Object.getPrototypeOf, he2 = ne2 && ne2(ne2(mn([])));
        he2 && he2 !== d2 && y2.call(he2, D2) && (le2 = he2);
        var _e = Rt.prototype = Pt.prototype = Object.create(le2);
        jt.prototype = Rt, j(_e, "constructor", Rt), j(Rt, "constructor", jt), jt.displayName = j(Rt, F3, "GeneratorFunction");
        function Me2(Kn) {
          ["next", "throw", "return"].forEach(function(ar) {
            j(Kn, ar, function(Cr) {
              return this._invoke(ar, Cr);
            });
          });
        }
        e2.isGeneratorFunction = function(Kn) {
          var ar = typeof Kn == "function" && Kn.constructor;
          return ar ? ar === jt || (ar.displayName || ar.name) === "GeneratorFunction" : false;
        }, e2.mark = function(Kn) {
          return Object.setPrototypeOf ? Object.setPrototypeOf(Kn, Rt) : (Kn.__proto__ = Rt, j(Kn, F3, "GeneratorFunction")), Kn.prototype = Object.create(_e), Kn;
        }, e2.awrap = function(Kn) {
          return { __await: Kn };
        };
        function Pe2(Kn, ar) {
          function Cr(ko, Ss, hl, Qs) {
            var Js = Y3(Kn[ko], Kn, Ss);
            if (Js.type === "throw")
              Qs(Js.arg);
            else {
              var rs = Js.arg, Gs = rs.value;
              return Gs && typeof Gs == "object" && y2.call(Gs, "__await") ? ar.resolve(Gs.__await).then(function(al) {
                Cr("next", al, hl, Qs);
              }, function(al) {
                Cr("throw", al, hl, Qs);
              }) : ar.resolve(Gs).then(function(al) {
                rs.value = al, hl(rs);
              }, function(al) {
                return Cr("throw", al, hl, Qs);
              });
            }
          }
          var ui2;
          function vi2(ko, Ss) {
            function hl() {
              return new ar(function(Qs, Js) {
                Cr(ko, Ss, Qs, Js);
              });
            }
            return ui2 = ui2 ? ui2.then(hl, hl) : hl();
          }
          this._invoke = vi2;
        }
        Me2(Pe2.prototype), j(Pe2.prototype, L, function() {
          return this;
        }), e2.AsyncIterator = Pe2, e2.async = function(Kn, ar, Cr, ui2, vi2) {
          vi2 === void 0 && (vi2 = Promise);
          var ko = new Pe2(U3(Kn, ar, Cr, ui2), vi2);
          return e2.isGeneratorFunction(ar) ? ko : ko.next().then(function(Ss) {
            return Ss.done ? Ss.value : ko.next();
          });
        };
        function Be2(Kn, ar, Cr) {
          var ui2 = Q;
          return function(vi2, ko) {
            if (ui2 === dt)
              throw new Error("Generator is already running");
            if (ui2 === vt) {
              if (vi2 === "throw")
                throw ko;
              return Kr();
            }
            for (Cr.method = vi2, Cr.arg = ko; ; ) {
              var Ss = Cr.delegate;
              if (Ss) {
                var hl = Je2(Ss, Cr);
                if (hl) {
                  if (hl === Ct)
                    continue;
                  return hl;
                }
              }
              if (Cr.method === "next")
                Cr.sent = Cr._sent = Cr.arg;
              else if (Cr.method === "throw") {
                if (ui2 === Q)
                  throw ui2 = vt, Cr.arg;
                Cr.dispatchException(Cr.arg);
              } else
                Cr.method === "return" && Cr.abrupt("return", Cr.arg);
              ui2 = dt;
              var Qs = Y3(Kn, ar, Cr);
              if (Qs.type === "normal") {
                if (ui2 = Cr.done ? vt : nt, Qs.arg === Ct)
                  continue;
                return { value: Qs.arg, done: Cr.done };
              } else
                Qs.type === "throw" && (ui2 = vt, Cr.method = "throw", Cr.arg = Qs.arg);
            }
          };
        }
        function Je2(Kn, ar) {
          var Cr = Kn.iterator[ar.method];
          if (Cr === x2) {
            if (ar.delegate = null, ar.method === "throw") {
              if (Kn.iterator.return && (ar.method = "return", ar.arg = x2, Je2(Kn, ar), ar.method === "throw"))
                return Ct;
              ar.method = "throw", ar.arg = new TypeError("The iterator does not provide a 'throw' method");
            }
            return Ct;
          }
          var ui2 = Y3(Cr, Kn.iterator, ar.arg);
          if (ui2.type === "throw")
            return ar.method = "throw", ar.arg = ui2.arg, ar.delegate = null, Ct;
          var vi2 = ui2.arg;
          if (!vi2)
            return ar.method = "throw", ar.arg = new TypeError("iterator result is not an object"), ar.delegate = null, Ct;
          if (vi2.done)
            ar[Kn.resultName] = vi2.value, ar.next = Kn.nextLoc, ar.method !== "return" && (ar.method = "next", ar.arg = x2);
          else
            return vi2;
          return ar.delegate = null, Ct;
        }
        Me2(_e), j(_e, F3, "Generator"), j(_e, D2, function() {
          return this;
        }), j(_e, "toString", function() {
          return "[object Generator]";
        });
        function Ze2(Kn) {
          var ar = { tryLoc: Kn[0] };
          1 in Kn && (ar.catchLoc = Kn[1]), 2 in Kn && (ar.finallyLoc = Kn[2], ar.afterLoc = Kn[3]), this.tryEntries.push(ar);
        }
        function Cn(Kn) {
          var ar = Kn.completion || {};
          ar.type = "normal", delete ar.arg, Kn.completion = ar;
        }
        function Bn(Kn) {
          this.tryEntries = [{ tryLoc: "root" }], Kn.forEach(Ze2, this), this.reset(true);
        }
        e2.keys = function(Kn) {
          var ar = [];
          for (var Cr in Kn)
            ar.push(Cr);
          return ar.reverse(), function ui2() {
            for (; ar.length; ) {
              var vi2 = ar.pop();
              if (vi2 in Kn)
                return ui2.value = vi2, ui2.done = false, ui2;
            }
            return ui2.done = true, ui2;
          };
        };
        function mn(Kn) {
          if (Kn) {
            var ar = Kn[D2];
            if (ar)
              return ar.call(Kn);
            if (typeof Kn.next == "function")
              return Kn;
            if (!isNaN(Kn.length)) {
              var Cr = -1, ui2 = function vi2() {
                for (; ++Cr < Kn.length; )
                  if (y2.call(Kn, Cr))
                    return vi2.value = Kn[Cr], vi2.done = false, vi2;
                return vi2.value = x2, vi2.done = true, vi2;
              };
              return ui2.next = ui2;
            }
          }
          return { next: Kr };
        }
        e2.values = mn;
        function Kr() {
          return { value: x2, done: true };
        }
        return Bn.prototype = { constructor: Bn, reset: function(Kn) {
          if (this.prev = 0, this.next = 0, this.sent = this._sent = x2, this.done = false, this.delegate = null, this.method = "next", this.arg = x2, this.tryEntries.forEach(Cn), !Kn)
            for (var ar in this)
              ar.charAt(0) === "t" && y2.call(this, ar) && !isNaN(+ar.slice(1)) && (this[ar] = x2);
        }, stop: function() {
          this.done = true;
          var Kn = this.tryEntries[0], ar = Kn.completion;
          if (ar.type === "throw")
            throw ar.arg;
          return this.rval;
        }, dispatchException: function(Kn) {
          if (this.done)
            throw Kn;
          var ar = this;
          function Cr(Qs, Js) {
            return ko.type = "throw", ko.arg = Kn, ar.next = Qs, Js && (ar.method = "next", ar.arg = x2), !!Js;
          }
          for (var ui2 = this.tryEntries.length - 1; ui2 >= 0; --ui2) {
            var vi2 = this.tryEntries[ui2], ko = vi2.completion;
            if (vi2.tryLoc === "root")
              return Cr("end");
            if (vi2.tryLoc <= this.prev) {
              var Ss = y2.call(vi2, "catchLoc"), hl = y2.call(vi2, "finallyLoc");
              if (Ss && hl) {
                if (this.prev < vi2.catchLoc)
                  return Cr(vi2.catchLoc, true);
                if (this.prev < vi2.finallyLoc)
                  return Cr(vi2.finallyLoc);
              } else if (Ss) {
                if (this.prev < vi2.catchLoc)
                  return Cr(vi2.catchLoc, true);
              } else if (hl) {
                if (this.prev < vi2.finallyLoc)
                  return Cr(vi2.finallyLoc);
              } else
                throw new Error("try statement without catch or finally");
            }
          }
        }, abrupt: function(Kn, ar) {
          for (var Cr = this.tryEntries.length - 1; Cr >= 0; --Cr) {
            var ui2 = this.tryEntries[Cr];
            if (ui2.tryLoc <= this.prev && y2.call(ui2, "finallyLoc") && this.prev < ui2.finallyLoc) {
              var vi2 = ui2;
              break;
            }
          }
          vi2 && (Kn === "break" || Kn === "continue") && vi2.tryLoc <= ar && ar <= vi2.finallyLoc && (vi2 = null);
          var ko = vi2 ? vi2.completion : {};
          return ko.type = Kn, ko.arg = ar, vi2 ? (this.method = "next", this.next = vi2.finallyLoc, Ct) : this.complete(ko);
        }, complete: function(Kn, ar) {
          if (Kn.type === "throw")
            throw Kn.arg;
          return Kn.type === "break" || Kn.type === "continue" ? this.next = Kn.arg : Kn.type === "return" ? (this.rval = this.arg = Kn.arg, this.method = "return", this.next = "end") : Kn.type === "normal" && ar && (this.next = ar), Ct;
        }, finish: function(Kn) {
          for (var ar = this.tryEntries.length - 1; ar >= 0; --ar) {
            var Cr = this.tryEntries[ar];
            if (Cr.finallyLoc === Kn)
              return this.complete(Cr.completion, Cr.afterLoc), Cn(Cr), Ct;
          }
        }, catch: function(Kn) {
          for (var ar = this.tryEntries.length - 1; ar >= 0; --ar) {
            var Cr = this.tryEntries[ar];
            if (Cr.tryLoc === Kn) {
              var ui2 = Cr.completion;
              if (ui2.type === "throw") {
                var vi2 = ui2.arg;
                Cn(Cr);
              }
              return vi2;
            }
          }
          throw new Error("illegal catch attempt");
        }, delegateYield: function(Kn, ar, Cr) {
          return this.delegate = { iterator: mn(Kn), resultName: ar, nextLoc: Cr }, this.method === "next" && (this.arg = x2), Ct;
        } }, e2;
      }(l2.exports);
      try {
        regeneratorRuntime = a;
      } catch {
        typeof globalThis == "object" ? globalThis.regeneratorRuntime = a : Function("r", "regeneratorRuntime = r")(a);
      }
    })(_ge);
    var gF = _ge.exports;
    function xge(l2, a, e2, d2, y2, x2, C) {
      try {
        var D2 = l2[x2](C), L = D2.value;
      } catch (F3) {
        e2(F3);
        return;
      }
      D2.done ? a(L) : Promise.resolve(L).then(d2, y2);
    }
    function d1t(l2) {
      return function() {
        var a = this, e2 = arguments;
        return new Promise(function(d2, y2) {
          var x2 = l2.apply(a, e2);
          function C(L) {
            xge(x2, d2, y2, C, D2, "next", L);
          }
          function D2(L) {
            xge(x2, d2, y2, C, D2, "throw", L);
          }
          C(void 0);
        });
      };
    }
    function PB() {
      return PB = Object.assign || function(l2) {
        for (var a = 1; a < arguments.length; a++) {
          var e2 = arguments[a];
          for (var d2 in e2)
            Object.prototype.hasOwnProperty.call(e2, d2) && (l2[d2] = e2[d2]);
        }
        return l2;
      }, PB.apply(this, arguments);
    }
    function ivn(l2, a) {
      l2.prototype = Object.create(a.prototype), l2.prototype.constructor = l2, Mit(l2, a);
    }
    function f6t(l2) {
      return f6t = Object.setPrototypeOf ? Object.getPrototypeOf : function(a) {
        return a.__proto__ || Object.getPrototypeOf(a);
      }, f6t(l2);
    }
    function Mit(l2, a) {
      return Mit = Object.setPrototypeOf || function(e2, d2) {
        return e2.__proto__ = d2, e2;
      }, Mit(l2, a);
    }
    function avn() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function g1t(l2, a, e2) {
      return avn() ? g1t = Reflect.construct : g1t = function(d2, y2, x2) {
        var C = [null];
        C.push.apply(C, y2);
        var D2 = Function.bind.apply(d2, C), L = new D2();
        return x2 && Mit(L, x2.prototype), L;
      }, g1t.apply(null, arguments);
    }
    function ovn(l2) {
      return Function.toString.call(l2).indexOf("[native code]") !== -1;
    }
    function h6t(l2) {
      var a = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
      return h6t = function(e2) {
        if (e2 === null || !ovn(e2))
          return e2;
        if (typeof e2 != "function")
          throw new TypeError("Super expression must either be null or a function");
        if (typeof a != "undefined") {
          if (a.has(e2))
            return a.get(e2);
          a.set(e2, d2);
        }
        function d2() {
          return g1t(e2, arguments, f6t(this).constructor);
        }
        return d2.prototype = Object.create(e2.prototype, { constructor: { value: d2, enumerable: false, writable: true, configurable: true } }), Mit(d2, e2);
      }, h6t(l2);
    }
    var svn = /%[sdj%]/g, lvn = function() {
    };
    typeof process != "undefined" && process.env;
    function p6t(l2) {
      if (!l2 || !l2.length)
        return null;
      var a = {};
      return l2.forEach(function(e2) {
        var d2 = e2.field;
        a[d2] = a[d2] || [], a[d2].push(e2);
      }), a;
    }
    function bC(l2) {
      for (var a = arguments.length, e2 = new Array(a > 1 ? a - 1 : 0), d2 = 1; d2 < a; d2++)
        e2[d2 - 1] = arguments[d2];
      var y2 = 0, x2 = e2.length;
      if (typeof l2 == "function")
        return l2.apply(null, e2);
      if (typeof l2 == "string") {
        var C = l2.replace(svn, function(D2) {
          if (D2 === "%%")
            return "%";
          if (y2 >= x2)
            return D2;
          switch (D2) {
            case "%s":
              return String(e2[y2++]);
            case "%d":
              return Number(e2[y2++]);
            case "%j":
              try {
                return JSON.stringify(e2[y2++]);
              } catch {
                return "[Circular]";
              }
              break;
            default:
              return D2;
          }
        });
        return C;
      }
      return l2;
    }
    function uvn(l2) {
      return l2 === "string" || l2 === "url" || l2 === "hex" || l2 === "email" || l2 === "date" || l2 === "pattern";
    }
    function x1(l2, a) {
      return !!(l2 == null || a === "array" && Array.isArray(l2) && !l2.length || uvn(a) && typeof l2 == "string" && !l2);
    }
    function cvn(l2, a, e2) {
      var d2 = [], y2 = 0, x2 = l2.length;
      function C(D2) {
        d2.push.apply(d2, D2 || []), y2++, y2 === x2 && e2(d2);
      }
      l2.forEach(function(D2) {
        a(D2, C);
      });
    }
    function wge(l2, a, e2) {
      var d2 = 0, y2 = l2.length;
      function x2(C) {
        if (C && C.length) {
          e2(C);
          return;
        }
        var D2 = d2;
        d2 = d2 + 1, D2 < y2 ? a(l2[D2], x2) : e2([]);
      }
      x2([]);
    }
    function fvn(l2) {
      var a = [];
      return Object.keys(l2).forEach(function(e2) {
        a.push.apply(a, l2[e2] || []);
      }), a;
    }
    var Sge = function(l2) {
      ivn(a, l2);
      function a(e2, d2) {
        var y2;
        return y2 = l2.call(this, "Async Validation Error") || this, y2.errors = e2, y2.fields = d2, y2;
      }
      return a;
    }(h6t(Error));
    function hvn(l2, a, e2, d2, y2) {
      if (a.first) {
        var x2 = new Promise(function(Y3, Q) {
          var nt = function(vt) {
            return d2(vt), vt.length ? Q(new Sge(vt, p6t(vt))) : Y3(y2);
          }, dt = fvn(l2);
          wge(dt, e2, nt);
        });
        return x2.catch(function(Y3) {
          return Y3;
        }), x2;
      }
      var C = a.firstFields === true ? Object.keys(l2) : a.firstFields || [], D2 = Object.keys(l2), L = D2.length, F3 = 0, j = [], U3 = new Promise(function(Y3, Q) {
        var nt = function(dt) {
          if (j.push.apply(j, dt), F3++, F3 === L)
            return d2(j), j.length ? Q(new Sge(j, p6t(j))) : Y3(y2);
        };
        D2.length || (d2(j), Y3(y2)), D2.forEach(function(dt) {
          var vt = l2[dt];
          C.indexOf(dt) !== -1 ? wge(vt, e2, nt) : cvn(vt, e2, nt);
        });
      });
      return U3.catch(function(Y3) {
        return Y3;
      }), U3;
    }
    function pvn(l2) {
      return !!(l2 && l2.message !== void 0);
    }
    function dvn(l2, a) {
      for (var e2 = l2, d2 = 0; d2 < a.length; d2++) {
        if (e2 == null)
          return e2;
        e2 = e2[a[d2]];
      }
      return e2;
    }
    function Mge(l2, a) {
      return function(e2) {
        var d2;
        return l2.fullFields ? d2 = dvn(a, l2.fullFields) : d2 = a[e2.field || l2.fullField], pvn(e2) ? (e2.field = e2.field || l2.fullField, e2.fieldValue = d2, e2) : { message: typeof e2 == "function" ? e2() : e2, fieldValue: d2, field: e2.field || l2.fullField };
      };
    }
    function Cge(l2, a) {
      if (a) {
        for (var e2 in a)
          if (a.hasOwnProperty(e2)) {
            var d2 = a[e2];
            typeof d2 == "object" && typeof l2[e2] == "object" ? l2[e2] = PB({}, l2[e2], d2) : l2[e2] = d2;
          }
      }
      return l2;
    }
    var Tge = function(l2, a, e2, d2, y2, x2) {
      l2.required && (!e2.hasOwnProperty(l2.field) || x1(a, x2 || l2.type)) && d2.push(bC(y2.messages.required, l2.fullField));
    }, gvn = function(l2, a, e2, d2, y2) {
      (/^\s+$/.test(a) || a === "") && d2.push(bC(y2.messages.whitespace, l2.fullField));
    }, d6t = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, Cit = { integer: function(l2) {
      return Cit.number(l2) && parseInt(l2, 10) === l2;
    }, float: function(l2) {
      return Cit.number(l2) && !Cit.integer(l2);
    }, array: function(l2) {
      return Array.isArray(l2);
    }, regexp: function(l2) {
      if (l2 instanceof RegExp)
        return true;
      try {
        return !!new RegExp(l2);
      } catch {
        return false;
      }
    }, date: function(l2) {
      return typeof l2.getTime == "function" && typeof l2.getMonth == "function" && typeof l2.getYear == "function" && !isNaN(l2.getTime());
    }, number: function(l2) {
      return isNaN(l2) ? false : typeof l2 == "number";
    }, object: function(l2) {
      return typeof l2 == "object" && !Cit.array(l2);
    }, method: function(l2) {
      return typeof l2 == "function";
    }, email: function(l2) {
      return typeof l2 == "string" && l2.length <= 320 && !!l2.match(d6t.email);
    }, url: function(l2) {
      return typeof l2 == "string" && l2.length <= 2048 && !!l2.match(d6t.url);
    }, hex: function(l2) {
      return typeof l2 == "string" && !!l2.match(d6t.hex);
    } }, vvn = function(l2, a, e2, d2, y2) {
      if (l2.required && a === void 0) {
        Tge(l2, a, e2, d2, y2);
        return;
      }
      var x2 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], C = l2.type;
      x2.indexOf(C) > -1 ? Cit[C](a) || d2.push(bC(y2.messages.types[C], l2.fullField, l2.type)) : C && typeof a !== l2.type && d2.push(bC(y2.messages.types[C], l2.fullField, l2.type));
    }, yvn = function(l2, a, e2, d2, y2) {
      var x2 = typeof l2.len == "number", C = typeof l2.min == "number", D2 = typeof l2.max == "number", L = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, F3 = a, j = null, U3 = typeof a == "number", Y3 = typeof a == "string", Q = Array.isArray(a);
      if (U3 ? j = "number" : Y3 ? j = "string" : Q && (j = "array"), !j)
        return false;
      Q && (F3 = a.length), Y3 && (F3 = a.replace(L, "_").length), x2 ? F3 !== l2.len && d2.push(bC(y2.messages[j].len, l2.fullField, l2.len)) : C && !D2 && F3 < l2.min ? d2.push(bC(y2.messages[j].min, l2.fullField, l2.min)) : D2 && !C && F3 > l2.max ? d2.push(bC(y2.messages[j].max, l2.fullField, l2.max)) : C && D2 && (F3 < l2.min || F3 > l2.max) && d2.push(bC(y2.messages[j].range, l2.fullField, l2.min, l2.max));
    }, DZ = "enum", mvn = function(l2, a, e2, d2, y2) {
      l2[DZ] = Array.isArray(l2[DZ]) ? l2[DZ] : [], l2[DZ].indexOf(a) === -1 && d2.push(bC(y2.messages[DZ], l2.fullField, l2[DZ].join(", ")));
    }, bvn = function(l2, a, e2, d2, y2) {
      if (l2.pattern) {
        if (l2.pattern instanceof RegExp)
          l2.pattern.lastIndex = 0, l2.pattern.test(a) || d2.push(bC(y2.messages.pattern.mismatch, l2.fullField, a, l2.pattern));
        else if (typeof l2.pattern == "string") {
          var x2 = new RegExp(l2.pattern);
          x2.test(a) || d2.push(bC(y2.messages.pattern.mismatch, l2.fullField, a, l2.pattern));
        }
      }
    }, Cp = { required: Tge, whitespace: gvn, type: vvn, range: yvn, enum: mvn, pattern: bvn }, _vn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a, "string") && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2, "string"), x1(a, "string") || (Cp.type(l2, a, d2, x2, y2), Cp.range(l2, a, d2, x2, y2), Cp.pattern(l2, a, d2, x2, y2), l2.whitespace === true && Cp.whitespace(l2, a, d2, x2, y2));
      }
      e2(x2);
    }, xvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), a !== void 0 && Cp.type(l2, a, d2, x2, y2);
      }
      e2(x2);
    }, wvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (a === "" && (a = void 0), x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), a !== void 0 && (Cp.type(l2, a, d2, x2, y2), Cp.range(l2, a, d2, x2, y2));
      }
      e2(x2);
    }, Svn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), a !== void 0 && Cp.type(l2, a, d2, x2, y2);
      }
      e2(x2);
    }, Mvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), x1(a) || Cp.type(l2, a, d2, x2, y2);
      }
      e2(x2);
    }, Cvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), a !== void 0 && (Cp.type(l2, a, d2, x2, y2), Cp.range(l2, a, d2, x2, y2));
      }
      e2(x2);
    }, Tvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), a !== void 0 && (Cp.type(l2, a, d2, x2, y2), Cp.range(l2, a, d2, x2, y2));
      }
      e2(x2);
    }, Avn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (a == null && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2, "array"), a != null && (Cp.type(l2, a, d2, x2, y2), Cp.range(l2, a, d2, x2, y2));
      }
      e2(x2);
    }, Ivn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), a !== void 0 && Cp.type(l2, a, d2, x2, y2);
      }
      e2(x2);
    }, Dvn = "enum", Evn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), a !== void 0 && Cp[Dvn](l2, a, d2, x2, y2);
      }
      e2(x2);
    }, kvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a, "string") && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2), x1(a, "string") || Cp.pattern(l2, a, d2, x2, y2);
      }
      e2(x2);
    }, Pvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a, "date") && !l2.required)
          return e2();
        if (Cp.required(l2, a, d2, x2, y2), !x1(a, "date")) {
          var D2;
          a instanceof Date ? D2 = a : D2 = new Date(a), Cp.type(l2, D2, d2, x2, y2), D2 && Cp.range(l2, D2.getTime(), d2, x2, y2);
        }
      }
      e2(x2);
    }, Lvn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = Array.isArray(a) ? "array" : typeof a;
      Cp.required(l2, a, d2, x2, y2, C), e2(x2);
    }, g6t = function(l2, a, e2, d2, y2) {
      var x2 = l2.type, C = [], D2 = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (D2) {
        if (x1(a, x2) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, C, y2, x2), x1(a, x2) || Cp.type(l2, a, d2, C, y2);
      }
      e2(C);
    }, Ovn = function(l2, a, e2, d2, y2) {
      var x2 = [], C = l2.required || !l2.required && d2.hasOwnProperty(l2.field);
      if (C) {
        if (x1(a) && !l2.required)
          return e2();
        Cp.required(l2, a, d2, x2, y2);
      }
      e2(x2);
    }, Tit = { string: _vn, method: xvn, number: wvn, boolean: Svn, regexp: Mvn, integer: Cvn, float: Tvn, array: Avn, object: Ivn, enum: Evn, pattern: kvn, date: Pvn, url: g6t, hex: g6t, email: g6t, required: Lvn, any: Ovn };
    function v6t() {
      return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
        var l2 = JSON.parse(JSON.stringify(this));
        return l2.clone = this.clone, l2;
      } };
    }
    var y6t = v6t(), Ait = function() {
      function l2(e2) {
        this.rules = null, this._messages = y6t, this.define(e2);
      }
      var a = l2.prototype;
      return a.define = function(e2) {
        var d2 = this;
        if (!e2)
          throw new Error("Cannot configure a schema with no rules");
        if (typeof e2 != "object" || Array.isArray(e2))
          throw new Error("Rules must be an object");
        this.rules = {}, Object.keys(e2).forEach(function(y2) {
          var x2 = e2[y2];
          d2.rules[y2] = Array.isArray(x2) ? x2 : [x2];
        });
      }, a.messages = function(e2) {
        return e2 && (this._messages = Cge(v6t(), e2)), this._messages;
      }, a.validate = function(e2, d2, y2) {
        var x2 = this;
        d2 === void 0 && (d2 = {}), y2 === void 0 && (y2 = function() {
        });
        var C = e2, D2 = d2, L = y2;
        if (typeof D2 == "function" && (L = D2, D2 = {}), !this.rules || Object.keys(this.rules).length === 0)
          return L && L(null, C), Promise.resolve(C);
        function F3(nt) {
          var dt = [], vt = {};
          function Ct(jt) {
            if (Array.isArray(jt)) {
              var Rt;
              dt = (Rt = dt).concat.apply(Rt, jt);
            } else
              dt.push(jt);
          }
          for (var Pt = 0; Pt < nt.length; Pt++)
            Ct(nt[Pt]);
          dt.length ? (vt = p6t(dt), L(dt, vt)) : L(null, C);
        }
        if (D2.messages) {
          var j = this.messages();
          j === y6t && (j = v6t()), Cge(j, D2.messages), D2.messages = j;
        } else
          D2.messages = this.messages();
        var U3 = {}, Y3 = D2.keys || Object.keys(this.rules);
        Y3.forEach(function(nt) {
          var dt = x2.rules[nt], vt = C[nt];
          dt.forEach(function(Ct) {
            var Pt = Ct;
            typeof Pt.transform == "function" && (C === e2 && (C = PB({}, C)), vt = C[nt] = Pt.transform(vt)), typeof Pt == "function" ? Pt = { validator: Pt } : Pt = PB({}, Pt), Pt.validator = x2.getValidationMethod(Pt), Pt.validator && (Pt.field = nt, Pt.fullField = Pt.fullField || nt, Pt.type = x2.getType(Pt), U3[nt] = U3[nt] || [], U3[nt].push({ rule: Pt, value: vt, source: C, field: nt }));
          });
        });
        var Q = {};
        return hvn(U3, D2, function(nt, dt) {
          var vt = nt.rule, Ct = (vt.type === "object" || vt.type === "array") && (typeof vt.fields == "object" || typeof vt.defaultField == "object");
          Ct = Ct && (vt.required || !vt.required && nt.value), vt.field = nt.field;
          function Pt(le2, ne2) {
            return PB({}, ne2, { fullField: vt.fullField + "." + le2, fullFields: vt.fullFields ? [].concat(vt.fullFields, [le2]) : [le2] });
          }
          function jt(le2) {
            le2 === void 0 && (le2 = []);
            var ne2 = Array.isArray(le2) ? le2 : [le2];
            !D2.suppressWarning && ne2.length && l2.warning("async-validator:", ne2), ne2.length && vt.message !== void 0 && (ne2 = [].concat(vt.message));
            var he2 = ne2.map(Mge(vt, C));
            if (D2.first && he2.length)
              return Q[vt.field] = 1, dt(he2);
            if (!Ct)
              dt(he2);
            else {
              if (vt.required && !nt.value)
                return vt.message !== void 0 ? he2 = [].concat(vt.message).map(Mge(vt, C)) : D2.error && (he2 = [D2.error(vt, bC(D2.messages.required, vt.field))]), dt(he2);
              var _e = {};
              vt.defaultField && Object.keys(nt.value).map(function(Be2) {
                _e[Be2] = vt.defaultField;
              }), _e = PB({}, _e, nt.rule.fields);
              var Me2 = {};
              Object.keys(_e).forEach(function(Be2) {
                var Je2 = _e[Be2], Ze2 = Array.isArray(Je2) ? Je2 : [Je2];
                Me2[Be2] = Ze2.map(Pt.bind(null, Be2));
              });
              var Pe2 = new l2(Me2);
              Pe2.messages(D2.messages), nt.rule.options && (nt.rule.options.messages = D2.messages, nt.rule.options.error = D2.error), Pe2.validate(nt.value, nt.rule.options || D2, function(Be2) {
                var Je2 = [];
                he2 && he2.length && Je2.push.apply(Je2, he2), Be2 && Be2.length && Je2.push.apply(Je2, Be2), dt(Je2.length ? Je2 : null);
              });
            }
          }
          var Rt;
          vt.asyncValidator ? Rt = vt.asyncValidator(vt, nt.value, jt, nt.source, D2) : vt.validator && (Rt = vt.validator(vt, nt.value, jt, nt.source, D2), Rt === true ? jt() : Rt === false ? jt(typeof vt.message == "function" ? vt.message(vt.fullField || vt.field) : vt.message || (vt.fullField || vt.field) + " fails") : Rt instanceof Array ? jt(Rt) : Rt instanceof Error && jt(Rt.message)), Rt && Rt.then && Rt.then(function() {
            return jt();
          }, function(le2) {
            return jt(le2);
          });
        }, function(nt) {
          F3(nt);
        }, C);
      }, a.getType = function(e2) {
        if (e2.type === void 0 && e2.pattern instanceof RegExp && (e2.type = "pattern"), typeof e2.validator != "function" && e2.type && !Tit.hasOwnProperty(e2.type))
          throw new Error(bC("Unknown rule type %s", e2.type));
        return e2.type || "string";
      }, a.getValidationMethod = function(e2) {
        if (typeof e2.validator == "function")
          return e2.validator;
        var d2 = Object.keys(e2), y2 = d2.indexOf("message");
        return y2 !== -1 && d2.splice(y2, 1), d2.length === 1 && d2[0] === "required" ? Tit.required : Tit[this.getType(e2)] || void 0;
      }, l2;
    }();
    Ait.register = function(l2, a) {
      if (typeof a != "function")
        throw new Error("Cannot register a validator by type, validator is not a function");
      Tit[l2] = a;
    }, Ait.warning = lvn, Ait.messages = y6t, Ait.validators = Tit;
    var _C = "'${name}' is not a valid ${type}", Age = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: _C, method: _C, array: _C, object: _C, number: _C, date: _C, boolean: _C, integer: _C, float: _C, regexp: _C, email: _C, url: _C, hex: _C }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
    function Ige(l2, a) {
      for (var e2 = l2, d2 = 0; d2 < a.length; d2 += 1) {
        if (e2 == null)
          return;
        e2 = e2[a[d2]];
      }
      return e2;
    }
    function Rvn(l2) {
      return $de(l2) || bge(l2) || GRt(l2) || Yde();
    }
    function Dge(l2, a, e2, d2) {
      if (!a.length)
        return e2;
      var y2 = Rvn(a), x2 = y2[0], C = y2.slice(1), D2;
      return !l2 && typeof x2 == "number" ? D2 = [] : Array.isArray(l2) ? D2 = Rp(l2) : D2 = df2({}, l2), d2 && e2 === void 0 && C.length === 1 ? delete D2[x2][C[0]] : D2[x2] = Dge(D2[x2], C, e2, d2), D2;
    }
    function Nvn(l2, a, e2) {
      var d2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
      return a.length && d2 && e2 === void 0 && !Ige(l2, a.slice(0, -1)) ? l2 : Dge(l2, a, e2, d2);
    }
    function Pm(l2) {
      return c6t(l2);
    }
    function EZ(l2, a) {
      var e2 = Ige(l2, a);
      return e2;
    }
    function LB(l2, a, e2) {
      var d2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, y2 = Nvn(l2, a, e2, d2);
      return y2;
    }
    function Ege(l2, a) {
      var e2 = {};
      return a.forEach(function(d2) {
        var y2 = EZ(l2, d2);
        e2 = LB(e2, d2, y2);
      }), e2;
    }
    function Iit(l2, a) {
      return l2 && l2.some(function(e2) {
        return Lge(e2, a);
      });
    }
    function kge(l2) {
      return cw(l2) === "object" && l2 !== null && Object.getPrototypeOf(l2) === Object.prototype;
    }
    function Pge(l2, a) {
      var e2 = Array.isArray(l2) ? Rp(l2) : df2({}, l2);
      return a && Object.keys(a).forEach(function(d2) {
        var y2 = e2[d2], x2 = a[d2], C = kge(y2) && kge(x2);
        e2[d2] = C ? Pge(y2, x2 || {}) : x2;
      }), e2;
    }
    function v1t(l2) {
      for (var a = arguments.length, e2 = new Array(a > 1 ? a - 1 : 0), d2 = 1; d2 < a; d2++)
        e2[d2 - 1] = arguments[d2];
      return e2.reduce(function(y2, x2) {
        return Pge(y2, x2);
      }, l2);
    }
    function Lge(l2, a) {
      return !l2 || !a || l2.length !== a.length ? false : l2.every(function(e2, d2) {
        return a[d2] === e2;
      });
    }
    function Fvn(l2, a) {
      if (l2 === a)
        return true;
      if (!l2 && a || l2 && !a || !l2 || !a || cw(l2) !== "object" || cw(a) !== "object")
        return false;
      var e2 = Object.keys(l2), d2 = Object.keys(a), y2 = new Set([].concat(Rp(e2), Rp(d2)));
      return Rp(y2).every(function(x2) {
        var C = l2[x2], D2 = a[x2];
        return typeof C == "function" && typeof D2 == "function" ? true : C === D2;
      });
    }
    function Vvn(l2) {
      var a = arguments.length <= 1 ? void 0 : arguments[1];
      return a && a.target && cw(a.target) === "object" && l2 in a.target ? a.target[l2] : a;
    }
    function Oge(l2, a, e2) {
      var d2 = l2.length;
      if (a < 0 || a >= d2 || e2 < 0 || e2 >= d2)
        return l2;
      var y2 = l2[a], x2 = a - e2;
      return x2 > 0 ? [].concat(Rp(l2.slice(0, e2)), [y2], Rp(l2.slice(e2, a)), Rp(l2.slice(a + 1, d2))) : x2 < 0 ? [].concat(Rp(l2.slice(0, a)), Rp(l2.slice(a + 1, e2 + 1)), [y2], Rp(l2.slice(e2 + 1, d2))) : l2;
    }
    var Bvn = Ait;
    function zvn(l2, a) {
      return l2.replace(/\$\{\w+\}/g, function(e2) {
        var d2 = e2.slice(2, -1);
        return a[d2];
      });
    }
    function m6t(l2, a, e2, d2, y2) {
      return b6t.apply(this, arguments);
    }
    function b6t() {
      return b6t = d1t(gF.mark(function l2(a, e2, d2, y2, x2) {
        var C, D2, L, F3, j, U3, Y3, Q;
        return gF.wrap(function(nt) {
          for (; ; )
            switch (nt.prev = nt.next) {
              case 0:
                return C = df2({}, d2), delete C.ruleIndex, D2 = null, C && C.type === "array" && C.defaultField && (D2 = C.defaultField, delete C.defaultField), L = new Bvn(qd2({}, a, [C])), F3 = v1t({}, Age, y2.validateMessages), L.messages(F3), j = [], nt.prev = 8, nt.next = 11, Promise.resolve(L.validate(qd2({}, a, e2), df2({}, y2)));
              case 11:
                nt.next = 16;
                break;
              case 13:
                nt.prev = 13, nt.t0 = nt.catch(8), nt.t0.errors ? j = nt.t0.errors.map(function(dt, vt) {
                  var Ct = dt.message;
                  return $.isValidElement(Ct) ? $.cloneElement(Ct, { key: "error_".concat(vt) }) : Ct;
                }) : (console.error(nt.t0), j = [F3.default]);
              case 16:
                if (!(!j.length && D2)) {
                  nt.next = 21;
                  break;
                }
                return nt.next = 19, Promise.all(e2.map(function(dt, vt) {
                  return m6t("".concat(a, ".").concat(vt), dt, D2, y2, x2);
                }));
              case 19:
                return U3 = nt.sent, nt.abrupt("return", U3.reduce(function(dt, vt) {
                  return [].concat(Rp(dt), Rp(vt));
                }, []));
              case 21:
                return Y3 = df2(df2({}, d2), {}, { name: a, enum: (d2.enum || []).join(", ") }, x2), Q = j.map(function(dt) {
                  return typeof dt == "string" ? zvn(dt, Y3) : dt;
                }), nt.abrupt("return", Q);
              case 24:
              case "end":
                return nt.stop();
            }
        }, l2, null, [[8, 13]]);
      })), b6t.apply(this, arguments);
    }
    function jvn(l2, a, e2, d2, y2, x2) {
      var C = l2.join("."), D2 = e2.map(function(j, U3) {
        var Y3 = j.validator, Q = df2(df2({}, j), {}, { ruleIndex: U3 });
        return Y3 && (Q.validator = function(nt, dt, vt) {
          var Ct = false, Pt = function() {
            for (var Rt = arguments.length, le2 = new Array(Rt), ne2 = 0; ne2 < Rt; ne2++)
              le2[ne2] = arguments[ne2];
            Promise.resolve().then(function() {
              gP(!Ct, "Your validator function has already return a promise. `callback` will be ignored."), Ct || vt.apply(void 0, le2);
            });
          }, jt = Y3(nt, dt, Pt);
          Ct = jt && typeof jt.then == "function" && typeof jt.catch == "function", gP(Ct, "`callback` is deprecated. Please return a promise instead."), Ct && jt.then(function() {
            vt();
          }).catch(function(Rt) {
            vt(Rt || " ");
          });
        }), Q;
      }).sort(function(j, U3) {
        var Y3 = j.warningOnly, Q = j.ruleIndex, nt = U3.warningOnly, dt = U3.ruleIndex;
        return !!Y3 == !!nt ? Q - dt : Y3 ? 1 : -1;
      }), L;
      if (y2 === true)
        L = new Promise(function() {
          var j = d1t(gF.mark(function U3(Y3, Q) {
            var nt, dt, vt;
            return gF.wrap(function(Ct) {
              for (; ; )
                switch (Ct.prev = Ct.next) {
                  case 0:
                    nt = 0;
                  case 1:
                    if (!(nt < D2.length)) {
                      Ct.next = 12;
                      break;
                    }
                    return dt = D2[nt], Ct.next = 5, m6t(C, a, dt, d2, x2);
                  case 5:
                    if (vt = Ct.sent, !vt.length) {
                      Ct.next = 9;
                      break;
                    }
                    return Q([{ errors: vt, rule: dt }]), Ct.abrupt("return");
                  case 9:
                    nt += 1, Ct.next = 1;
                    break;
                  case 12:
                    Y3([]);
                  case 13:
                  case "end":
                    return Ct.stop();
                }
            }, U3);
          }));
          return function(U3, Y3) {
            return j.apply(this, arguments);
          };
        }());
      else {
        var F3 = D2.map(function(j) {
          return m6t(C, a, j, d2, x2).then(function(U3) {
            return { errors: U3, rule: j };
          });
        });
        L = (y2 ? Gvn(F3) : Wvn(F3)).then(function(j) {
          return Promise.reject(j);
        });
      }
      return L.catch(function(j) {
        return j;
      }), L;
    }
    function Wvn(l2) {
      return _6t.apply(this, arguments);
    }
    function _6t() {
      return _6t = d1t(gF.mark(function l2(a) {
        return gF.wrap(function(e2) {
          for (; ; )
            switch (e2.prev = e2.next) {
              case 0:
                return e2.abrupt("return", Promise.all(a).then(function(d2) {
                  var y2, x2 = (y2 = []).concat.apply(y2, Rp(d2));
                  return x2;
                }));
              case 1:
              case "end":
                return e2.stop();
            }
        }, l2);
      })), _6t.apply(this, arguments);
    }
    function Gvn(l2) {
      return x6t.apply(this, arguments);
    }
    function x6t() {
      return x6t = d1t(gF.mark(function l2(a) {
        var e2;
        return gF.wrap(function(d2) {
          for (; ; )
            switch (d2.prev = d2.next) {
              case 0:
                return e2 = 0, d2.abrupt("return", new Promise(function(y2) {
                  a.forEach(function(x2) {
                    x2.then(function(C) {
                      C.errors.length && y2([C]), e2 += 1, e2 === a.length && y2([]);
                    });
                  });
                }));
              case 2:
              case "end":
                return d2.stop();
            }
        }, l2);
      })), x6t.apply(this, arguments);
    }
    var Hvn = ["name"], FA = [];
    function Rge(l2, a, e2, d2, y2, x2) {
      return typeof l2 == "function" ? l2(a, e2, "source" in x2 ? { source: x2.source } : {}) : d2 !== y2;
    }
    var w6t = function(l2) {
      n6t(e2, l2);
      var a = i6t(e2);
      function e2(d2) {
        var y2;
        if (xit(this, e2), y2 = a.call(this, d2), y2.state = { resetCount: 0 }, y2.cancelRegisterFunc = null, y2.mounted = false, y2.touched = false, y2.dirty = false, y2.validatePromise = null, y2.prevValidating = void 0, y2.errors = FA, y2.warnings = FA, y2.cancelRegister = function() {
          var L = y2.props, F3 = L.preserve, j = L.isListField, U3 = L.name;
          y2.cancelRegisterFunc && y2.cancelRegisterFunc(j, F3, Pm(U3)), y2.cancelRegisterFunc = null;
        }, y2.getNamePath = function() {
          var L = y2.props, F3 = L.name, j = L.fieldContext, U3 = j.prefixName, Y3 = U3 === void 0 ? [] : U3;
          return F3 !== void 0 ? [].concat(Rp(Y3), Rp(F3)) : [];
        }, y2.getRules = function() {
          var L = y2.props, F3 = L.rules, j = F3 === void 0 ? [] : F3, U3 = L.fieldContext;
          return j.map(function(Y3) {
            return typeof Y3 == "function" ? Y3(U3) : Y3;
          });
        }, y2.refresh = function() {
          !y2.mounted || y2.setState(function(L) {
            var F3 = L.resetCount;
            return { resetCount: F3 + 1 };
          });
        }, y2.triggerMetaEvent = function(L) {
          var F3 = y2.props.onMetaChange;
          F3 == null || F3(df2(df2({}, y2.getMeta()), {}, { destroy: L }));
        }, y2.onStoreChange = function(L, F3, j) {
          var U3 = y2.props, Y3 = U3.shouldUpdate, Q = U3.dependencies, nt = Q === void 0 ? [] : Q, dt = U3.onReset, vt = j.store, Ct = y2.getNamePath(), Pt = y2.getValue(L), jt = y2.getValue(vt), Rt = F3 && Iit(F3, Ct);
          switch (j.type === "valueUpdate" && j.source === "external" && Pt !== jt && (y2.touched = true, y2.dirty = true, y2.validatePromise = null, y2.errors = FA, y2.warnings = FA, y2.triggerMetaEvent()), j.type) {
            case "reset":
              if (!F3 || Rt) {
                y2.touched = false, y2.dirty = false, y2.validatePromise = null, y2.errors = FA, y2.warnings = FA, y2.triggerMetaEvent(), dt == null || dt(), y2.refresh();
                return;
              }
              break;
            case "remove": {
              if (Y3) {
                y2.reRender();
                return;
              }
              break;
            }
            case "setField": {
              if (Rt) {
                var le2 = j.data;
                "touched" in le2 && (y2.touched = le2.touched), "validating" in le2 && !("originRCField" in le2) && (y2.validatePromise = le2.validating ? Promise.resolve([]) : null), "errors" in le2 && (y2.errors = le2.errors || FA), "warnings" in le2 && (y2.warnings = le2.warnings || FA), y2.dirty = true, y2.triggerMetaEvent(), y2.reRender();
                return;
              }
              if (Y3 && !Ct.length && Rge(Y3, L, vt, Pt, jt, j)) {
                y2.reRender();
                return;
              }
              break;
            }
            case "dependenciesUpdate": {
              var ne2 = nt.map(Pm);
              if (ne2.some(function(he2) {
                return Iit(j.relatedFields, he2);
              })) {
                y2.reRender();
                return;
              }
              break;
            }
            default:
              if (Rt || (!nt.length || Ct.length || Y3) && Rge(Y3, L, vt, Pt, jt, j)) {
                y2.reRender();
                return;
              }
              break;
          }
          Y3 === true && y2.reRender();
        }, y2.validateRules = function(L) {
          var F3 = y2.getNamePath(), j = y2.getValue(), U3 = Promise.resolve().then(function() {
            if (!y2.mounted)
              return [];
            var Y3 = y2.props, Q = Y3.validateFirst, nt = Q === void 0 ? false : Q, dt = Y3.messageVariables, vt = L || {}, Ct = vt.triggerName, Pt = y2.getRules();
            Ct && (Pt = Pt.filter(function(Rt) {
              var le2 = Rt.validateTrigger;
              if (!le2)
                return true;
              var ne2 = c6t(le2);
              return ne2.includes(Ct);
            }));
            var jt = jvn(F3, j, Pt, L, nt, dt);
            return jt.catch(function(Rt) {
              return Rt;
            }).then(function() {
              var Rt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : FA;
              if (y2.validatePromise === U3) {
                y2.validatePromise = null;
                var le2 = [], ne2 = [];
                Rt.forEach(function(he2) {
                  var _e = he2.rule.warningOnly, Me2 = he2.errors, Pe2 = Me2 === void 0 ? FA : Me2;
                  _e ? ne2.push.apply(ne2, Rp(Pe2)) : le2.push.apply(le2, Rp(Pe2));
                }), y2.errors = le2, y2.warnings = ne2, y2.triggerMetaEvent(), y2.reRender();
              }
            }), jt;
          });
          return y2.validatePromise = U3, y2.dirty = true, y2.errors = FA, y2.warnings = FA, y2.triggerMetaEvent(), y2.reRender(), U3;
        }, y2.isFieldValidating = function() {
          return !!y2.validatePromise;
        }, y2.isFieldTouched = function() {
          return y2.touched;
        }, y2.isFieldDirty = function() {
          if (y2.dirty || y2.props.initialValue !== void 0)
            return true;
          var L = y2.props.fieldContext, F3 = L.getInternalHooks(IZ), j = F3.getInitialValue;
          return j(y2.getNamePath()) !== void 0;
        }, y2.getErrors = function() {
          return y2.errors;
        }, y2.getWarnings = function() {
          return y2.warnings;
        }, y2.isListField = function() {
          return y2.props.isListField;
        }, y2.isList = function() {
          return y2.props.isList;
        }, y2.isPreserve = function() {
          return y2.props.preserve;
        }, y2.getMeta = function() {
          y2.prevValidating = y2.isFieldValidating();
          var L = { touched: y2.isFieldTouched(), validating: y2.prevValidating, errors: y2.errors, warnings: y2.warnings, name: y2.getNamePath() };
          return L;
        }, y2.getOnlyChild = function(L) {
          if (typeof L == "function") {
            var F3 = y2.getMeta();
            return df2(df2({}, y2.getOnlyChild(L(y2.getControlled(), F3, y2.props.fieldContext))), {}, { isFunction: true });
          }
          var j = u6t(L);
          return j.length !== 1 || !$.isValidElement(j[0]) ? { child: j, isFunction: false } : { child: j[0], isFunction: false };
        }, y2.getValue = function(L) {
          var F3 = y2.props.fieldContext.getFieldsValue, j = y2.getNamePath();
          return EZ(L || F3(true), j);
        }, y2.getControlled = function() {
          var L = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, F3 = y2.props, j = F3.trigger, U3 = F3.validateTrigger, Y3 = F3.getValueFromEvent, Q = F3.normalize, nt = F3.valuePropName, dt = F3.getValueProps, vt = F3.fieldContext, Ct = U3 !== void 0 ? U3 : vt.validateTrigger, Pt = y2.getNamePath(), jt = vt.getInternalHooks, Rt = vt.getFieldsValue, le2 = jt(IZ), ne2 = le2.dispatch, he2 = y2.getValue(), _e = dt || function(Je2) {
            return qd2({}, nt, Je2);
          }, Me2 = L[j], Pe2 = df2(df2({}, L), _e(he2));
          Pe2[j] = function() {
            y2.touched = true, y2.dirty = true, y2.triggerMetaEvent();
            for (var Je2, Ze2 = arguments.length, Cn = new Array(Ze2), Bn = 0; Bn < Ze2; Bn++)
              Cn[Bn] = arguments[Bn];
            Y3 ? Je2 = Y3.apply(void 0, Cn) : Je2 = Vvn.apply(void 0, [nt].concat(Cn)), Q && (Je2 = Q(Je2, he2, Rt(true))), ne2({ type: "updateValue", namePath: Pt, value: Je2 }), Me2 && Me2.apply(void 0, Cn);
          };
          var Be2 = c6t(Ct || []);
          return Be2.forEach(function(Je2) {
            var Ze2 = Pe2[Je2];
            Pe2[Je2] = function() {
              Ze2 && Ze2.apply(void 0, arguments);
              var Cn = y2.props.rules;
              Cn && Cn.length && ne2({ type: "validateField", namePath: Pt, triggerName: Je2 });
            };
          }), Pe2;
        }, d2.fieldContext) {
          var x2 = d2.fieldContext.getInternalHooks, C = x2(IZ), D2 = C.initEntityValue;
          D2(r6t(y2));
        }
        return y2;
      }
      return wit(e2, [{ key: "componentDidMount", value: function() {
        var d2 = this.props, y2 = d2.shouldUpdate, x2 = d2.fieldContext;
        if (this.mounted = true, x2) {
          var C = x2.getInternalHooks, D2 = C(IZ), L = D2.registerField;
          this.cancelRegisterFunc = L(this);
        }
        y2 === true && this.reRender();
      } }, { key: "componentWillUnmount", value: function() {
        this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
      } }, { key: "reRender", value: function() {
        !this.mounted || this.forceUpdate();
      } }, { key: "render", value: function() {
        var d2 = this.state.resetCount, y2 = this.props.children, x2 = this.getOnlyChild(y2), C = x2.child, D2 = x2.isFunction, L;
        return D2 ? L = C : $.isValidElement(C) ? L = $.cloneElement(C, this.getControlled(C.props)) : (gP(!C, "`children` of Field is not validate ReactElement."), L = C), $.createElement($.Fragment, { key: d2 }, L);
      } }]), e2;
    }($.Component);
    w6t.contextType = Sit, w6t.defaultProps = { trigger: "onChange", valuePropName: "value" };
    function Nge(l2) {
      var a = l2.name, e2 = TZ(l2, Hvn), d2 = $.useContext(Sit), y2 = a !== void 0 ? Pm(a) : void 0, x2 = "keep";
      return e2.isListField || (x2 = "_".concat((y2 || []).join("_"))), $.createElement(w6t, km({ key: x2, name: y2 }, e2, { fieldContext: d2 }));
    }
    var Uvn = $.createContext(null), qvn = function(l2) {
      var a = l2.name, e2 = l2.initialValue, d2 = l2.children, y2 = l2.rules, x2 = l2.validateTrigger, C = $.useContext(Sit), D2 = $.useRef({ keys: [], id: 0 }), L = D2.current, F3 = $.useMemo(function() {
        var Q = Pm(C.prefixName) || [];
        return [].concat(Rp(Q), Rp(Pm(a)));
      }, [C.prefixName, a]), j = $.useMemo(function() {
        return df2(df2({}, C), {}, { prefixName: F3 });
      }, [C, F3]), U3 = $.useMemo(function() {
        return { getKey: function(Q) {
          var nt = F3.length, dt = Q[nt];
          return [L.keys[dt], Q.slice(nt + 1)];
        } };
      }, [F3]);
      if (typeof d2 != "function")
        return gP(false, "Form.List only accepts function as children."), null;
      var Y3 = function(Q, nt, dt) {
        var vt = dt.source;
        return vt === "internal" ? false : Q !== nt;
      };
      return $.createElement(Uvn.Provider, { value: U3 }, $.createElement(Sit.Provider, { value: j }, $.createElement(Nge, { name: [], shouldUpdate: Y3, rules: y2, validateTrigger: x2, initialValue: e2, isList: true }, function(Q, nt) {
        var dt = Q.value, vt = dt === void 0 ? [] : dt, Ct = Q.onChange, Pt = C.getFieldValue, jt = function() {
          var ne2 = Pt(F3 || []);
          return ne2 || [];
        }, Rt = { add: function(ne2, he2) {
          var _e = jt();
          he2 >= 0 && he2 <= _e.length ? (L.keys = [].concat(Rp(L.keys.slice(0, he2)), [L.id], Rp(L.keys.slice(he2))), Ct([].concat(Rp(_e.slice(0, he2)), [ne2], Rp(_e.slice(he2))))) : (L.keys = [].concat(Rp(L.keys), [L.id]), Ct([].concat(Rp(_e), [ne2]))), L.id += 1;
        }, remove: function(ne2) {
          var he2 = jt(), _e = new Set(Array.isArray(ne2) ? ne2 : [ne2]);
          _e.size <= 0 || (L.keys = L.keys.filter(function(Me2, Pe2) {
            return !_e.has(Pe2);
          }), Ct(he2.filter(function(Me2, Pe2) {
            return !_e.has(Pe2);
          })));
        }, move: function(ne2, he2) {
          if (ne2 !== he2) {
            var _e = jt();
            ne2 < 0 || ne2 >= _e.length || he2 < 0 || he2 >= _e.length || (L.keys = Oge(L.keys, ne2, he2), Ct(Oge(_e, ne2, he2)));
          }
        } }, le2 = vt || [];
        return Array.isArray(le2) || (le2 = []), d2(le2.map(function(ne2, he2) {
          var _e = L.keys[he2];
          return _e === void 0 && (L.keys[he2] = L.id, _e = L.keys[he2], L.id += 1), { name: he2, key: _e, isListField: true };
        }), Rt, nt);
      })));
    };
    function Zvn(l2) {
      var a = false, e2 = l2.length, d2 = [];
      return l2.length ? new Promise(function(y2, x2) {
        l2.forEach(function(C, D2) {
          C.catch(function(L) {
            return a = true, L;
          }).then(function(L) {
            e2 -= 1, d2[D2] = L, !(e2 > 0) && (a && x2(d2), y2(d2));
          });
        });
      }) : Promise.resolve([]);
    }
    var Fge = "__@field_split__";
    function S6t(l2) {
      return l2.map(function(a) {
        return "".concat(cw(a), ":").concat(a);
      }).join(Fge);
    }
    var Dit = function() {
      function l2() {
        xit(this, l2), this.kvs = /* @__PURE__ */ new Map();
      }
      return wit(l2, [{ key: "set", value: function(a, e2) {
        this.kvs.set(S6t(a), e2);
      } }, { key: "get", value: function(a) {
        return this.kvs.get(S6t(a));
      } }, { key: "update", value: function(a, e2) {
        var d2 = this.get(a), y2 = e2(d2);
        y2 ? this.set(a, y2) : this.delete(a);
      } }, { key: "delete", value: function(a) {
        this.kvs.delete(S6t(a));
      } }, { key: "map", value: function(a) {
        return Rp(this.kvs.entries()).map(function(e2) {
          var d2 = RA(e2, 2), y2 = d2[0], x2 = d2[1], C = y2.split(Fge);
          return a({ key: C.map(function(D2) {
            var L = D2.match(/^([^:]*):(.*)$/), F3 = RA(L, 3), j = F3[1], U3 = F3[2];
            return j === "number" ? Number(U3) : U3;
          }), value: x2 });
        });
      } }, { key: "toJSON", value: function() {
        var a = {};
        return this.map(function(e2) {
          var d2 = e2.key, y2 = e2.value;
          return a[d2.join(".")] = y2, null;
        }), a;
      } }]), l2;
    }(), $vn = ["name", "errors"], Yvn = wit(function l2(a) {
      var e2 = this;
      xit(this, l2), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
        return { getFieldValue: e2.getFieldValue, getFieldsValue: e2.getFieldsValue, getFieldError: e2.getFieldError, getFieldWarning: e2.getFieldWarning, getFieldsError: e2.getFieldsError, isFieldsTouched: e2.isFieldsTouched, isFieldTouched: e2.isFieldTouched, isFieldValidating: e2.isFieldValidating, isFieldsValidating: e2.isFieldsValidating, resetFields: e2.resetFields, setFields: e2.setFields, setFieldsValue: e2.setFieldsValue, validateFields: e2.validateFields, submit: e2.submit, getInternalHooks: e2.getInternalHooks };
      }, this.getInternalHooks = function(d2) {
        return d2 === IZ ? (e2.formHooked = true, { dispatch: e2.dispatch, initEntityValue: e2.initEntityValue, registerField: e2.registerField, useSubscribe: e2.useSubscribe, setInitialValues: e2.setInitialValues, setCallbacks: e2.setCallbacks, setValidateMessages: e2.setValidateMessages, getFields: e2.getFields, setPreserve: e2.setPreserve, getInitialValue: e2.getInitialValue }) : (gP(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
      }, this.useSubscribe = function(d2) {
        e2.subscribable = d2;
      }, this.setInitialValues = function(d2, y2) {
        e2.initialValues = d2 || {}, y2 && (e2.store = v1t({}, d2, e2.store));
      }, this.getInitialValue = function(d2) {
        return EZ(e2.initialValues, d2);
      }, this.setCallbacks = function(d2) {
        e2.callbacks = d2;
      }, this.setValidateMessages = function(d2) {
        e2.validateMessages = d2;
      }, this.setPreserve = function(d2) {
        e2.preserve = d2;
      }, this.timeoutId = null, this.warningUnhooked = function() {
      }, this.getFieldEntities = function() {
        var d2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
        return d2 ? e2.fieldEntities.filter(function(y2) {
          return y2.getNamePath().length;
        }) : e2.fieldEntities;
      }, this.getFieldsMap = function() {
        var d2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, y2 = new Dit();
        return e2.getFieldEntities(d2).forEach(function(x2) {
          var C = x2.getNamePath();
          y2.set(C, x2);
        }), y2;
      }, this.getFieldEntitiesForNamePathList = function(d2) {
        if (!d2)
          return e2.getFieldEntities(true);
        var y2 = e2.getFieldsMap(true);
        return d2.map(function(x2) {
          var C = Pm(x2);
          return y2.get(C) || { INVALIDATE_NAME_PATH: Pm(x2) };
        });
      }, this.getFieldsValue = function(d2, y2) {
        if (e2.warningUnhooked(), d2 === true && !y2)
          return e2.store;
        var x2 = e2.getFieldEntitiesForNamePathList(Array.isArray(d2) ? d2 : null), C = [];
        return x2.forEach(function(D2) {
          var L, F3 = "INVALIDATE_NAME_PATH" in D2 ? D2.INVALIDATE_NAME_PATH : D2.getNamePath();
          if (!(!d2 && ((L = D2.isListField) === null || L === void 0 ? void 0 : L.call(D2))))
            if (!y2)
              C.push(F3);
            else {
              var j = "getMeta" in D2 ? D2.getMeta() : null;
              y2(j) && C.push(F3);
            }
        }), Ege(e2.store, C.map(Pm));
      }, this.getFieldValue = function(d2) {
        e2.warningUnhooked();
        var y2 = Pm(d2);
        return EZ(e2.store, y2);
      }, this.getFieldsError = function(d2) {
        e2.warningUnhooked();
        var y2 = e2.getFieldEntitiesForNamePathList(d2);
        return y2.map(function(x2, C) {
          return x2 && !("INVALIDATE_NAME_PATH" in x2) ? { name: x2.getNamePath(), errors: x2.getErrors(), warnings: x2.getWarnings() } : { name: Pm(d2[C]), errors: [], warnings: [] };
        });
      }, this.getFieldError = function(d2) {
        e2.warningUnhooked();
        var y2 = Pm(d2), x2 = e2.getFieldsError([y2])[0];
        return x2.errors;
      }, this.getFieldWarning = function(d2) {
        e2.warningUnhooked();
        var y2 = Pm(d2), x2 = e2.getFieldsError([y2])[0];
        return x2.warnings;
      }, this.isFieldsTouched = function() {
        e2.warningUnhooked();
        for (var d2 = arguments.length, y2 = new Array(d2), x2 = 0; x2 < d2; x2++)
          y2[x2] = arguments[x2];
        var C = y2[0], D2 = y2[1], L, F3 = false;
        y2.length === 0 ? L = null : y2.length === 1 ? Array.isArray(C) ? (L = C.map(Pm), F3 = false) : (L = null, F3 = C) : (L = C.map(Pm), F3 = D2);
        var j = e2.getFieldEntities(true), U3 = function(dt) {
          return dt.isFieldTouched();
        };
        if (!L)
          return F3 ? j.every(U3) : j.some(U3);
        var Y3 = new Dit();
        L.forEach(function(dt) {
          Y3.set(dt, []);
        }), j.forEach(function(dt) {
          var vt = dt.getNamePath();
          L.forEach(function(Ct) {
            Ct.every(function(Pt, jt) {
              return vt[jt] === Pt;
            }) && Y3.update(Ct, function(Pt) {
              return [].concat(Rp(Pt), [dt]);
            });
          });
        });
        var Q = function(dt) {
          return dt.some(U3);
        }, nt = Y3.map(function(dt) {
          var vt = dt.value;
          return vt;
        });
        return F3 ? nt.every(Q) : nt.some(Q);
      }, this.isFieldTouched = function(d2) {
        return e2.warningUnhooked(), e2.isFieldsTouched([d2]);
      }, this.isFieldsValidating = function(d2) {
        e2.warningUnhooked();
        var y2 = e2.getFieldEntities();
        if (!d2)
          return y2.some(function(C) {
            return C.isFieldValidating();
          });
        var x2 = d2.map(Pm);
        return y2.some(function(C) {
          var D2 = C.getNamePath();
          return Iit(x2, D2) && C.isFieldValidating();
        });
      }, this.isFieldValidating = function(d2) {
        return e2.warningUnhooked(), e2.isFieldsValidating([d2]);
      }, this.resetWithFieldInitialValue = function() {
        var d2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, y2 = new Dit(), x2 = e2.getFieldEntities(true);
        x2.forEach(function(L) {
          var F3 = L.props.initialValue, j = L.getNamePath();
          if (F3 !== void 0) {
            var U3 = y2.get(j) || /* @__PURE__ */ new Set();
            U3.add({ entity: L, value: F3 }), y2.set(j, U3);
          }
        });
        var C = function(L) {
          L.forEach(function(F3) {
            var j = F3.props.initialValue;
            if (j !== void 0) {
              var U3 = F3.getNamePath(), Y3 = e2.getInitialValue(U3);
              if (Y3 !== void 0)
                gP(false, "Form already set 'initialValues' with path '".concat(U3.join("."), "'. Field can not overwrite it."));
              else {
                var Q = y2.get(U3);
                if (Q && Q.size > 1)
                  gP(false, "Multiple Field with path '".concat(U3.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                else if (Q) {
                  var nt = e2.getFieldValue(U3);
                  (!d2.skipExist || nt === void 0) && (e2.store = LB(e2.store, U3, Rp(Q)[0].value));
                }
              }
            }
          });
        }, D2;
        d2.entities ? D2 = d2.entities : d2.namePathList ? (D2 = [], d2.namePathList.forEach(function(L) {
          var F3 = y2.get(L);
          if (F3) {
            var j;
            (j = D2).push.apply(j, Rp(Rp(F3).map(function(U3) {
              return U3.entity;
            })));
          }
        })) : D2 = x2, C(D2);
      }, this.resetFields = function(d2) {
        e2.warningUnhooked();
        var y2 = e2.store;
        if (!d2) {
          e2.store = v1t({}, e2.initialValues), e2.resetWithFieldInitialValue(), e2.notifyObservers(y2, null, { type: "reset" });
          return;
        }
        var x2 = d2.map(Pm);
        x2.forEach(function(C) {
          var D2 = e2.getInitialValue(C);
          e2.store = LB(e2.store, C, D2);
        }), e2.resetWithFieldInitialValue({ namePathList: x2 }), e2.notifyObservers(y2, x2, { type: "reset" });
      }, this.setFields = function(d2) {
        e2.warningUnhooked();
        var y2 = e2.store;
        d2.forEach(function(x2) {
          var C = x2.name;
          x2.errors;
          var D2 = TZ(x2, $vn), L = Pm(C);
          "value" in D2 && (e2.store = LB(e2.store, L, D2.value)), e2.notifyObservers(y2, [L], { type: "setField", data: x2 });
        });
      }, this.getFields = function() {
        var d2 = e2.getFieldEntities(true), y2 = d2.map(function(x2) {
          var C = x2.getNamePath(), D2 = x2.getMeta(), L = df2(df2({}, D2), {}, { name: C, value: e2.getFieldValue(C) });
          return Object.defineProperty(L, "originRCField", { value: true }), L;
        });
        return y2;
      }, this.initEntityValue = function(d2) {
        var y2 = d2.props.initialValue;
        if (y2 !== void 0) {
          var x2 = d2.getNamePath(), C = EZ(e2.store, x2);
          C === void 0 && (e2.store = LB(e2.store, x2, y2));
        }
      }, this.registerField = function(d2) {
        if (e2.fieldEntities.push(d2), d2.props.initialValue !== void 0) {
          var y2 = e2.store;
          e2.resetWithFieldInitialValue({ entities: [d2], skipExist: true }), e2.notifyObservers(y2, [d2.getNamePath()], { type: "valueUpdate", source: "internal" });
        }
        return function(x2, C) {
          var D2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
          e2.fieldEntities = e2.fieldEntities.filter(function(Y3) {
            return Y3 !== d2;
          });
          var L = C !== void 0 ? C : e2.preserve;
          if (L === false && (!x2 || D2.length > 1)) {
            var F3 = d2.getNamePath(), j = x2 ? void 0 : EZ(e2.initialValues, F3);
            if (F3.length && e2.getFieldValue(F3) !== j && e2.fieldEntities.every(function(Y3) {
              return !Lge(Y3.getNamePath(), F3);
            })) {
              var U3 = e2.store;
              e2.store = LB(U3, F3, j, true), e2.notifyObservers(U3, [F3], { type: "remove" }), e2.triggerDependenciesUpdate(U3, F3);
            }
          }
        };
      }, this.dispatch = function(d2) {
        switch (d2.type) {
          case "updateValue": {
            var y2 = d2.namePath, x2 = d2.value;
            e2.updateValue(y2, x2);
            break;
          }
          case "validateField": {
            var C = d2.namePath, D2 = d2.triggerName;
            e2.validateFields([C], { triggerName: D2 });
            break;
          }
        }
      }, this.notifyObservers = function(d2, y2, x2) {
        if (e2.subscribable) {
          var C = df2(df2({}, x2), {}, { store: e2.getFieldsValue(true) });
          e2.getFieldEntities().forEach(function(D2) {
            var L = D2.onStoreChange;
            L(d2, y2, C);
          });
        } else
          e2.forceRootUpdate();
      }, this.triggerDependenciesUpdate = function(d2, y2) {
        var x2 = e2.getDependencyChildrenFields(y2);
        return x2.length && e2.validateFields(x2), e2.notifyObservers(d2, x2, { type: "dependenciesUpdate", relatedFields: [y2].concat(Rp(x2)) }), x2;
      }, this.updateValue = function(d2, y2) {
        var x2 = Pm(d2), C = e2.store;
        e2.store = LB(e2.store, x2, y2), e2.notifyObservers(C, [x2], { type: "valueUpdate", source: "internal" });
        var D2 = e2.triggerDependenciesUpdate(C, x2), L = e2.callbacks.onValuesChange;
        if (L) {
          var F3 = Ege(e2.store, [x2]);
          L(F3, e2.getFieldsValue());
        }
        e2.triggerOnFieldsChange([x2].concat(Rp(D2)));
      }, this.setFieldsValue = function(d2) {
        e2.warningUnhooked();
        var y2 = e2.store;
        d2 && (e2.store = v1t(e2.store, d2)), e2.notifyObservers(y2, null, { type: "valueUpdate", source: "external" });
      }, this.getDependencyChildrenFields = function(d2) {
        var y2 = /* @__PURE__ */ new Set(), x2 = [], C = new Dit();
        e2.getFieldEntities().forEach(function(L) {
          var F3 = L.props.dependencies;
          (F3 || []).forEach(function(j) {
            var U3 = Pm(j);
            C.update(U3, function() {
              var Y3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
              return Y3.add(L), Y3;
            });
          });
        });
        var D2 = function L(F3) {
          var j = C.get(F3) || /* @__PURE__ */ new Set();
          j.forEach(function(U3) {
            if (!y2.has(U3)) {
              y2.add(U3);
              var Y3 = U3.getNamePath();
              U3.isFieldDirty() && Y3.length && (x2.push(Y3), L(Y3));
            }
          });
        };
        return D2(d2), x2;
      }, this.triggerOnFieldsChange = function(d2, y2) {
        var x2 = e2.callbacks.onFieldsChange;
        if (x2) {
          var C = e2.getFields();
          if (y2) {
            var D2 = new Dit();
            y2.forEach(function(F3) {
              var j = F3.name, U3 = F3.errors;
              D2.set(j, U3);
            }), C.forEach(function(F3) {
              F3.errors = D2.get(F3.name) || F3.errors;
            });
          }
          var L = C.filter(function(F3) {
            var j = F3.name;
            return Iit(d2, j);
          });
          x2(L, C);
        }
      }, this.validateFields = function(d2, y2) {
        e2.warningUnhooked();
        var x2 = !!d2, C = x2 ? d2.map(Pm) : [], D2 = [];
        e2.getFieldEntities(true).forEach(function(j) {
          if (x2 || C.push(j.getNamePath()), (y2 == null ? void 0 : y2.recursive) && x2) {
            var U3 = j.getNamePath();
            U3.every(function(nt, dt) {
              return d2[dt] === nt || d2[dt] === void 0;
            }) && C.push(U3);
          }
          if (!(!j.props.rules || !j.props.rules.length)) {
            var Y3 = j.getNamePath();
            if (!x2 || Iit(C, Y3)) {
              var Q = j.validateRules(df2({ validateMessages: df2(df2({}, Age), e2.validateMessages) }, y2));
              D2.push(Q.then(function() {
                return { name: Y3, errors: [], warnings: [] };
              }).catch(function(nt) {
                var dt = [], vt = [];
                return nt.forEach(function(Ct) {
                  var Pt = Ct.rule.warningOnly, jt = Ct.errors;
                  Pt ? vt.push.apply(vt, Rp(jt)) : dt.push.apply(dt, Rp(jt));
                }), dt.length ? Promise.reject({ name: Y3, errors: dt, warnings: vt }) : { name: Y3, errors: dt, warnings: vt };
              }));
            }
          }
        });
        var L = Zvn(D2);
        e2.lastValidatePromise = L, L.catch(function(j) {
          return j;
        }).then(function(j) {
          var U3 = j.map(function(Y3) {
            var Q = Y3.name;
            return Q;
          });
          e2.notifyObservers(e2.store, U3, { type: "validateFinish" }), e2.triggerOnFieldsChange(U3, j);
        });
        var F3 = L.then(function() {
          return e2.lastValidatePromise === L ? Promise.resolve(e2.getFieldsValue(C)) : Promise.reject([]);
        }).catch(function(j) {
          var U3 = j.filter(function(Y3) {
            return Y3 && Y3.errors.length;
          });
          return Promise.reject({ values: e2.getFieldsValue(C), errorFields: U3, outOfDate: e2.lastValidatePromise !== L });
        });
        return F3.catch(function(j) {
          return j;
        }), F3;
      }, this.submit = function() {
        e2.warningUnhooked(), e2.validateFields().then(function(d2) {
          var y2 = e2.callbacks.onFinish;
          if (y2)
            try {
              y2(d2);
            } catch (x2) {
              console.error(x2);
            }
        }).catch(function(d2) {
          var y2 = e2.callbacks.onFinishFailed;
          y2 && y2(d2);
        });
      }, this.forceRootUpdate = a;
    });
    function Vge(l2) {
      var a = $.useRef(), e2 = $.useState({}), d2 = RA(e2, 2), y2 = d2[1];
      if (!a.current)
        if (l2)
          a.current = l2;
        else {
          var x2 = function() {
            y2({});
          }, C = new Yvn(x2);
          a.current = C.getForm();
        }
      return [a.current];
    }
    var M6t = $.createContext({ triggerFormChange: function() {
    }, triggerFormFinish: function() {
    }, registerForm: function() {
    }, unregisterForm: function() {
    } }), Kvn = function(l2) {
      var a = l2.validateMessages, e2 = l2.onFormChange, d2 = l2.onFormFinish, y2 = l2.children, x2 = $.useContext(M6t), C = $.useRef({});
      return $.createElement(M6t.Provider, { value: df2(df2({}, x2), {}, { validateMessages: df2(df2({}, x2.validateMessages), a), triggerFormChange: function(D2, L) {
        e2 && e2(D2, { changedFields: L, forms: C.current }), x2.triggerFormChange(D2, L);
      }, triggerFormFinish: function(D2, L) {
        d2 && d2(D2, { values: L, forms: C.current }), x2.triggerFormFinish(D2, L);
      }, registerForm: function(D2, L) {
        D2 && (C.current = df2(df2({}, C.current), {}, qd2({}, D2, L))), x2.registerForm(D2, L);
      }, unregisterForm: function(D2) {
        var L = df2({}, C.current);
        delete L[D2], C.current = L, x2.unregisterForm(D2);
      } }) }, y2);
    }, Xvn = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], Qvn = function(l2, a) {
      var e2 = l2.name, d2 = l2.initialValues, y2 = l2.fields, x2 = l2.form, C = l2.preserve, D2 = l2.children, L = l2.component, F3 = L === void 0 ? "form" : L, j = l2.validateMessages, U3 = l2.validateTrigger, Y3 = U3 === void 0 ? "onChange" : U3, Q = l2.onValuesChange, nt = l2.onFieldsChange, dt = l2.onFinish, vt = l2.onFinishFailed, Ct = TZ(l2, Xvn), Pt = $.useContext(M6t), jt = Vge(x2), Rt = RA(jt, 1), le2 = Rt[0], ne2 = le2.getInternalHooks(IZ), he2 = ne2.useSubscribe, _e = ne2.setInitialValues, Me2 = ne2.setCallbacks, Pe2 = ne2.setValidateMessages, Be2 = ne2.setPreserve;
      $.useImperativeHandle(a, function() {
        return le2;
      }), $.useEffect(function() {
        return Pt.registerForm(e2, le2), function() {
          Pt.unregisterForm(e2);
        };
      }, [Pt, le2, e2]), Pe2(df2(df2({}, Pt.validateMessages), j)), Me2({ onValuesChange: Q, onFieldsChange: function(ar) {
        if (Pt.triggerFormChange(e2, ar), nt) {
          for (var Cr = arguments.length, ui2 = new Array(Cr > 1 ? Cr - 1 : 0), vi2 = 1; vi2 < Cr; vi2++)
            ui2[vi2 - 1] = arguments[vi2];
          nt.apply(void 0, [ar].concat(ui2));
        }
      }, onFinish: function(ar) {
        Pt.triggerFormFinish(e2, ar), dt && dt(ar);
      }, onFinishFailed: vt }), Be2(C);
      var Je2 = $.useRef(null);
      _e(d2, !Je2.current), Je2.current || (Je2.current = true);
      var Ze2 = D2, Cn = typeof D2 == "function";
      if (Cn) {
        var Bn = le2.getFieldsValue(true);
        Ze2 = D2(Bn, le2);
      }
      he2(!Cn);
      var mn = $.useRef();
      $.useEffect(function() {
        Fvn(mn.current || [], y2 || []) || le2.setFields(y2 || []), mn.current = y2;
      }, [y2, le2]);
      var Kr = $.useMemo(function() {
        return df2(df2({}, le2), {}, { validateTrigger: Y3 });
      }, [le2, Y3]), Kn = $.createElement(Sit.Provider, { value: Kr }, Ze2);
      return F3 === false ? Kn : $.createElement(F3, km({}, Ct, { onSubmit: function(ar) {
        ar.preventDefault(), ar.stopPropagation(), le2.submit();
      }, onReset: function(ar) {
        var Cr;
        ar.preventDefault(), le2.resetFields(), (Cr = Ct.onReset) === null || Cr === void 0 || Cr.call(Ct, ar);
      } }), Kn);
    }, Jvn = $.forwardRef(Qvn), y1t = Jvn;
    y1t.FormProvider = Kvn, y1t.Field = Nge, y1t.List = qvn, y1t.useForm = Vge;
    var t0n = function(l2, a, e2) {
      gP(l2, "[antd: ".concat(a, "] ").concat(e2));
    }, e0n = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, n0n = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, r0n = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, Bge = r0n, i0n = { lang: km({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, n0n), timePickerLocale: km({}, Bge) }, zge = i0n, xC = "${label} is not a valid ${type}", a0n = { locale: "en", Pagination: e0n, DatePicker: zge, TimePicker: Bge, Calendar: zge, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: xC, method: xC, array: xC, object: xC, number: xC, date: xC, boolean: xC, integer: xC, float: xC, regexp: xC, email: xC, url: xC, hex: xC }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, jge = a0n, o0n = P2.createContext(void 0), s0n = o0n, C6t = function(l2) {
      n6t(e2, l2);
      var a = i6t(e2);
      function e2() {
        return xit(this, e2), a.apply(this, arguments);
      }
      return wit(e2, [{ key: "getLocale", value: function() {
        var d2 = this.props, y2 = d2.componentName, x2 = d2.defaultLocale, C = x2 || jge[y2 != null ? y2 : "global"], D2 = this.context, L = y2 && D2 ? D2[y2] : {};
        return km(km({}, C instanceof Function ? C() : C), L || {});
      } }, { key: "getLocaleCode", value: function() {
        var d2 = this.context, y2 = d2 && d2.locale;
        return d2 && d2.exist && !y2 ? jge.locale : y2;
      } }, { key: "render", value: function() {
        return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
      } }]), e2;
    }($.Component);
    C6t.defaultProps = { componentName: "global" }, C6t.contextType = s0n;
    var l0n = function() {
      var l2 = $.useContext(vF), a = l2.getPrefixCls, e2 = a("empty-img-default");
      return $.createElement("svg", { className: e2, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, $.createElement("g", { fill: "none", fillRule: "evenodd" }, $.createElement("g", { transform: "translate(24 31.67)" }, $.createElement("ellipse", { className: "".concat(e2, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), $.createElement("path", { className: "".concat(e2, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), $.createElement("path", { className: "".concat(e2, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), $.createElement("path", { className: "".concat(e2, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), $.createElement("path", { className: "".concat(e2, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), $.createElement("path", { className: "".concat(e2, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), $.createElement("g", { className: "".concat(e2, "-g"), transform: "translate(149.65 15.383)" }, $.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), $.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
    }, u0n = l0n, c0n = function() {
      var l2 = $.useContext(vF), a = l2.getPrefixCls, e2 = a("empty-img-simple");
      return $.createElement("svg", { className: e2, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, $.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, $.createElement("ellipse", { className: "".concat(e2, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), $.createElement("g", { className: "".concat(e2, "-g"), fillRule: "nonzero" }, $.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), $.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(e2, "-path") }))));
    }, f0n = c0n, h0n = globalThis && globalThis.__rest || function(l2, a) {
      var e2 = {};
      for (var d2 in l2)
        Object.prototype.hasOwnProperty.call(l2, d2) && a.indexOf(d2) < 0 && (e2[d2] = l2[d2]);
      if (l2 != null && typeof Object.getOwnPropertySymbols == "function")
        for (var y2 = 0, d2 = Object.getOwnPropertySymbols(l2); y2 < d2.length; y2++)
          a.indexOf(d2[y2]) < 0 && Object.prototype.propertyIsEnumerable.call(l2, d2[y2]) && (e2[d2[y2]] = l2[d2[y2]]);
      return e2;
    }, Wge = $.createElement(u0n, null), Gge = $.createElement(f0n, null), T6t = function(l2) {
      var a = l2.className, e2 = l2.prefixCls, d2 = l2.image, y2 = d2 === void 0 ? Wge : d2, x2 = l2.description, C = l2.children, D2 = l2.imageStyle, L = h0n(l2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), F3 = $.useContext(vF), j = F3.getPrefixCls, U3 = F3.direction;
      return $.createElement(C6t, { componentName: "Empty" }, function(Y3) {
        var Q, nt = j("empty", e2), dt = typeof x2 != "undefined" ? x2 : Y3.description, vt = typeof dt == "string" ? dt : "empty", Ct = null;
        return typeof y2 == "string" ? Ct = $.createElement("img", { alt: vt, src: y2 }) : Ct = y2, $.createElement("div", km({ className: AZ(nt, (Q = {}, qd2(Q, "".concat(nt, "-normal"), y2 === Gge), qd2(Q, "".concat(nt, "-rtl"), U3 === "rtl"), Q), a) }, L), $.createElement("div", { className: "".concat(nt, "-image"), style: D2 }, Ct), dt && $.createElement("div", { className: "".concat(nt, "-description") }, dt), C && $.createElement("div", { className: "".concat(nt, "-footer") }, C));
      });
    };
    T6t.PRESENTED_IMAGE_DEFAULT = Wge, T6t.PRESENTED_IMAGE_SIMPLE = Gge;
    var Eit = T6t, p0n = function(l2) {
      return $.createElement(Hge, null, function(a) {
        var e2 = a.getPrefixCls, d2 = e2("empty");
        switch (l2) {
          case "Table":
          case "List":
            return $.createElement(Eit, { image: Eit.PRESENTED_IMAGE_SIMPLE });
          case "Select":
          case "TreeSelect":
          case "Cascader":
          case "Transfer":
          case "Mentions":
            return $.createElement(Eit, { image: Eit.PRESENTED_IMAGE_SIMPLE, className: "".concat(d2, "-small") });
          default:
            return $.createElement(Eit, null);
        }
      });
    }, d0n = p0n, g0n = function(l2, a) {
      return a || (l2 ? "ant-".concat(l2) : "ant");
    }, vF = $.createContext({ getPrefixCls: g0n, renderEmpty: d0n }), Hge = vF.Consumer, v0n = $.createContext(void 0), y0n = v0n, Uge = function(l2) {
      return +setTimeout(l2, 16);
    }, qge = function(l2) {
      return clearTimeout(l2);
    };
    typeof window != "undefined" && "requestAnimationFrame" in window && (Uge = function(l2) {
      return window.requestAnimationFrame(l2);
    }, qge = function(l2) {
      return window.cancelAnimationFrame(l2);
    });
    var Zge = 0, A6t = /* @__PURE__ */ new Map();
    function $ge(l2) {
      A6t.delete(l2);
    }
    function m1t(l2) {
      var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
      Zge += 1;
      var e2 = Zge;
      function d2(y2) {
        if (y2 === 0)
          $ge(e2), l2();
        else {
          var x2 = Uge(function() {
            d2(y2 - 1);
          });
          A6t.set(e2, x2);
        }
      }
      return d2(a), e2;
    }
    m1t.cancel = function(l2) {
      var a = A6t.get(l2);
      return $ge(a), qge(a);
    };
    function m0n(l2, a) {
      var e2 = a || {}, d2 = e2.defaultValue, y2 = e2.value, x2 = e2.onChange, C = e2.postState, D2 = $.useState(function() {
        return y2 !== void 0 ? y2 : d2 !== void 0 ? typeof d2 == "function" ? d2() : d2 : typeof l2 == "function" ? l2() : l2;
      }), L = RA(D2, 2), F3 = L[0], j = L[1], U3 = y2 !== void 0 ? y2 : F3;
      C && (U3 = C(U3));
      var Y3 = $.useRef(x2);
      Y3.current = x2;
      var Q = $.useCallback(function(dt) {
        j(dt), U3 !== dt && Y3.current && Y3.current(dt, U3);
      }, [U3, Y3]), nt = $.useRef(true);
      return $.useEffect(function() {
        if (nt.current) {
          nt.current = false;
          return;
        }
        y2 === void 0 && j(y2);
      }, [y2]), [U3, Q];
    }
    var Sc2 = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(l2) {
      var a = l2.keyCode;
      if (l2.altKey && !l2.ctrlKey || l2.metaKey || a >= Sc2.F1 && a <= Sc2.F12)
        return false;
      switch (a) {
        case Sc2.ALT:
        case Sc2.CAPS_LOCK:
        case Sc2.CONTEXT_MENU:
        case Sc2.CTRL:
        case Sc2.DOWN:
        case Sc2.END:
        case Sc2.ESC:
        case Sc2.HOME:
        case Sc2.INSERT:
        case Sc2.LEFT:
        case Sc2.MAC_FF_META:
        case Sc2.META:
        case Sc2.NUMLOCK:
        case Sc2.NUM_CENTER:
        case Sc2.PAGE_DOWN:
        case Sc2.PAGE_UP:
        case Sc2.PAUSE:
        case Sc2.PRINT_SCREEN:
        case Sc2.RIGHT:
        case Sc2.SHIFT:
        case Sc2.UP:
        case Sc2.WIN_KEY:
        case Sc2.WIN_KEY_RIGHT:
          return false;
        default:
          return true;
      }
    }, isCharacterKey: function(l2) {
      if (l2 >= Sc2.ZERO && l2 <= Sc2.NINE || l2 >= Sc2.NUM_ZERO && l2 <= Sc2.NUM_MULTIPLY || l2 >= Sc2.A && l2 <= Sc2.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && l2 === 0)
        return true;
      switch (l2) {
        case Sc2.SPACE:
        case Sc2.QUESTION_MARK:
        case Sc2.NUM_PLUS:
        case Sc2.NUM_MINUS:
        case Sc2.NUM_PERIOD:
        case Sc2.NUM_DIVISION:
        case Sc2.SEMICOLON:
        case Sc2.DASH:
        case Sc2.EQUALS:
        case Sc2.COMMA:
        case Sc2.PERIOD:
        case Sc2.SLASH:
        case Sc2.APOSTROPHE:
        case Sc2.SINGLE_QUOTE:
        case Sc2.OPEN_SQUARE_BRACKET:
        case Sc2.BACKSLASH:
        case Sc2.CLOSE_SQUARE_BRACKET:
          return true;
        default:
          return false;
      }
    } }, Yge = function() {
      for (var l2 = arguments.length, a = new Array(l2), e2 = 0; e2 < l2; e2++)
        a[e2] = arguments[e2];
      return a;
    }, b0n = $.isValidElement;
    function _0n(l2, a, e2) {
      return b0n(l2) ? $.cloneElement(l2, typeof e2 == "function" ? e2(l2.props || {}) : e2) : a;
    }
    function x0n(l2, a) {
      return _0n(l2, l2, a);
    }
    var Kge = ["xxl", "xl", "lg", "md", "sm", "xs"], b1t = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, OB = /* @__PURE__ */ new Map(), I6t = -1, _1t = {}, w0n = { matchHandlers: {}, dispatch: function(l2) {
      return _1t = l2, OB.forEach(function(a) {
        return a(_1t);
      }), OB.size >= 1;
    }, subscribe: function(l2) {
      return OB.size || this.register(), I6t += 1, OB.set(I6t, l2), l2(_1t), I6t;
    }, unsubscribe: function(l2) {
      OB.delete(l2), OB.size || this.unregister();
    }, unregister: function() {
      var l2 = this;
      Object.keys(b1t).forEach(function(a) {
        var e2 = b1t[a], d2 = l2.matchHandlers[e2];
        d2 == null || d2.mql.removeListener(d2 == null ? void 0 : d2.listener);
      }), OB.clear();
    }, register: function() {
      var l2 = this;
      Object.keys(b1t).forEach(function(a) {
        var e2 = b1t[a], d2 = function(x2) {
          var C = x2.matches;
          l2.dispatch(km(km({}, _1t), qd2({}, a, C)));
        }, y2 = window.matchMedia(e2);
        y2.addListener(d2), l2.matchHandlers[e2] = { mql: y2, listener: d2 }, d2(y2);
      });
    } }, Xge = w0n, S0n = 0, kZ = {};
    function x1t(l2) {
      var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, e2 = S0n++, d2 = a;
      function y2() {
        d2 -= 1, d2 <= 0 ? (l2(), delete kZ[e2]) : kZ[e2] = m1t(y2);
      }
      return kZ[e2] = m1t(y2), e2;
    }
    x1t.cancel = function(l2) {
      l2 !== void 0 && (m1t.cancel(kZ[l2]), delete kZ[l2]);
    }, x1t.ids = kZ;
    var D6t;
    function Qge(l2) {
      return !l2 || l2.offsetParent === null || l2.hidden;
    }
    function M0n(l2) {
      var a = (l2 || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
      return a && a[1] && a[2] && a[3] ? !(a[1] === a[2] && a[2] === a[3]) : true;
    }
    var Jge = function(l2) {
      n6t(e2, l2);
      var a = i6t(e2);
      function e2() {
        var d2;
        return xit(this, e2), d2 = a.apply(this, arguments), d2.containerRef = $.createRef(), d2.animationStart = false, d2.destroyed = false, d2.onClick = function(y2, x2) {
          var C, D2, L = d2.props, F3 = L.insertExtraNode, j = L.disabled;
          if (!(j || !y2 || Qge(y2) || y2.className.indexOf("-leave") >= 0)) {
            d2.extraNode = document.createElement("div");
            var U3 = r6t(d2), Y3 = U3.extraNode, Q = d2.context.getPrefixCls;
            Y3.className = "".concat(Q(""), "-click-animating-node");
            var nt = d2.getAttributeName();
            if (y2.setAttribute(nt, "true"), x2 && x2 !== "#ffffff" && x2 !== "rgb(255, 255, 255)" && M0n(x2) && !/rgba\((?:\d*, ){3}0\)/.test(x2) && x2 !== "transparent") {
              Y3.style.borderColor = x2;
              var dt = ((C = y2.getRootNode) === null || C === void 0 ? void 0 : C.call(y2)) || y2.ownerDocument, vt = dt instanceof Document ? dt.body : (D2 = dt.firstChild) !== null && D2 !== void 0 ? D2 : dt;
              D6t = cge(`
      [`.concat(Q(""), "-click-animating-without-extra-node='true']::after, .").concat(Q(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(x2, `;
      }`), "antd-wave", { csp: d2.csp, attachTo: vt });
            }
            F3 && y2.appendChild(Y3), ["transition", "animation"].forEach(function(Ct) {
              y2.addEventListener("".concat(Ct, "start"), d2.onTransitionStart), y2.addEventListener("".concat(Ct, "end"), d2.onTransitionEnd);
            });
          }
        }, d2.onTransitionStart = function(y2) {
          if (!d2.destroyed) {
            var x2 = d2.containerRef.current;
            !y2 || y2.target !== x2 || d2.animationStart || d2.resetEffect(x2);
          }
        }, d2.onTransitionEnd = function(y2) {
          !y2 || y2.animationName !== "fadeEffect" || d2.resetEffect(y2.target);
        }, d2.bindAnimationEvent = function(y2) {
          if (!(!y2 || !y2.getAttribute || y2.getAttribute("disabled") || y2.className.indexOf("disabled") >= 0)) {
            var x2 = function(C) {
              if (!(C.target.tagName === "INPUT" || Qge(C.target))) {
                d2.resetEffect(y2);
                var D2 = getComputedStyle(y2).getPropertyValue("border-top-color") || getComputedStyle(y2).getPropertyValue("border-color") || getComputedStyle(y2).getPropertyValue("background-color");
                d2.clickWaveTimeoutId = window.setTimeout(function() {
                  return d2.onClick(y2, D2);
                }, 0), x1t.cancel(d2.animationStartId), d2.animationStart = true, d2.animationStartId = x1t(function() {
                  d2.animationStart = false;
                }, 10);
              }
            };
            return y2.addEventListener("click", x2, true), { cancel: function() {
              y2.removeEventListener("click", x2, true);
            } };
          }
        }, d2.renderWave = function(y2) {
          var x2 = y2.csp, C = d2.props.children;
          if (d2.csp = x2, !$.isValidElement(C))
            return C;
          var D2 = d2.containerRef;
          return tvn(C) && (D2 = Jgn(C.ref, d2.containerRef)), x0n(C, { ref: D2 });
        }, d2;
      }
      return wit(e2, [{ key: "componentDidMount", value: function() {
        var d2 = this.containerRef.current;
        !d2 || d2.nodeType !== 1 || (this.instance = this.bindAnimationEvent(d2));
      } }, { key: "componentWillUnmount", value: function() {
        this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
      } }, { key: "getAttributeName", value: function() {
        var d2 = this.context.getPrefixCls, y2 = this.props.insertExtraNode;
        return y2 ? "".concat(d2(""), "-click-animating") : "".concat(d2(""), "-click-animating-without-extra-node");
      } }, { key: "resetEffect", value: function(d2) {
        var y2 = this;
        if (!(!d2 || d2 === this.extraNode || !(d2 instanceof Element))) {
          var x2 = this.props.insertExtraNode, C = this.getAttributeName();
          d2.setAttribute(C, "false"), D6t && (D6t.innerHTML = ""), x2 && this.extraNode && d2.contains(this.extraNode) && d2.removeChild(this.extraNode), ["transition", "animation"].forEach(function(D2) {
            d2.removeEventListener("".concat(D2, "start"), y2.onTransitionStart), d2.removeEventListener("".concat(D2, "end"), y2.onTransitionEnd);
          });
        }
      } }, { key: "render", value: function() {
        return $.createElement(Hge, null, this.renderWave);
      } }]), e2;
    }($.Component);
    Jge.contextType = vF;
    var E6t = { exports: {} }, kit = {};
    /** @license React v17.0.2
    * react-jsx-runtime.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var C0n = H2.default, tve = 60103;
    if (kit.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
      var eve = Symbol.for;
      tve = eve("react.element"), kit.Fragment = eve("react.fragment");
    }
    var T0n = C0n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, A0n = Object.prototype.hasOwnProperty, I0n = { key: true, ref: true, __self: true, __source: true };
    function nve(l2, a, e2) {
      var d2, y2 = {}, x2 = null, C = null;
      e2 !== void 0 && (x2 = "" + e2), a.key !== void 0 && (x2 = "" + a.key), a.ref !== void 0 && (C = a.ref);
      for (d2 in a)
        A0n.call(a, d2) && !I0n.hasOwnProperty(d2) && (y2[d2] = a[d2]);
      if (l2 && l2.defaultProps)
        for (d2 in a = l2.defaultProps, a)
          y2[d2] === void 0 && (y2[d2] = a[d2]);
      return { $$typeof: tve, type: l2, key: x2, ref: C, props: y2, _owner: T0n.current };
    }
    kit.jsx = nve, kit.jsxs = nve, E6t.exports = kit;
    const PZ = E6t.exports.jsx, D0n = E6t.exports.jsxs;
    var E0n = P2.createContext({}), rve = E0n, k0n = function() {
      return sge() && window.document.documentElement;
    }, w1t, P0n = function() {
      if (!k0n())
        return false;
      if (w1t !== void 0)
        return w1t;
      var l2 = document.createElement("div");
      return l2.style.display = "flex", l2.style.flexDirection = "column", l2.style.rowGap = "1px", l2.appendChild(document.createElement("div")), l2.appendChild(document.createElement("div")), document.body.appendChild(l2), w1t = l2.scrollHeight === 1, document.body.removeChild(l2), w1t;
    }, L0n = function() {
      var l2 = $.useState(false), a = RA(l2, 2), e2 = a[0], d2 = a[1];
      return $.useEffect(function() {
        d2(P0n());
      }, []), e2;
    }, O0n = globalThis && globalThis.__rest || function(l2, a) {
      var e2 = {};
      for (var d2 in l2)
        Object.prototype.hasOwnProperty.call(l2, d2) && a.indexOf(d2) < 0 && (e2[d2] = l2[d2]);
      if (l2 != null && typeof Object.getOwnPropertySymbols == "function")
        for (var y2 = 0, d2 = Object.getOwnPropertySymbols(l2); y2 < d2.length; y2++)
          a.indexOf(d2[y2]) < 0 && Object.prototype.propertyIsEnumerable.call(l2, d2[y2]) && (e2[d2[y2]] = l2[d2[y2]]);
      return e2;
    };
    Yge("top", "middle", "bottom", "stretch"), Yge("start", "end", "center", "space-around", "space-between");
    var ive = $.forwardRef(function(l2, a) {
      var e2, d2 = l2.prefixCls, y2 = l2.justify, x2 = l2.align, C = l2.className, D2 = l2.style, L = l2.children, F3 = l2.gutter, j = F3 === void 0 ? 0 : F3, U3 = l2.wrap, Y3 = O0n(l2, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Q = $.useContext(vF), nt = Q.getPrefixCls, dt = Q.direction, vt = $.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), Ct = RA(vt, 2), Pt = Ct[0], jt = Ct[1], Rt = L0n(), le2 = $.useRef(j);
      $.useEffect(function() {
        var Kn = Xge.subscribe(function(ar) {
          var Cr = le2.current || 0;
          (!Array.isArray(Cr) && cw(Cr) === "object" || Array.isArray(Cr) && (cw(Cr[0]) === "object" || cw(Cr[1]) === "object")) && jt(ar);
        });
        return function() {
          return Xge.unsubscribe(Kn);
        };
      }, []);
      var ne2 = function() {
        var Kn = [0, 0], ar = Array.isArray(j) ? j : [j, 0];
        return ar.forEach(function(Cr, ui2) {
          if (cw(Cr) === "object")
            for (var vi2 = 0; vi2 < Kge.length; vi2++) {
              var ko = Kge[vi2];
              if (Pt[ko] && Cr[ko] !== void 0) {
                Kn[ui2] = Cr[ko];
                break;
              }
            }
          else
            Kn[ui2] = Cr || 0;
        }), Kn;
      }, he2 = nt("row", d2), _e = ne2(), Me2 = AZ(he2, (e2 = {}, qd2(e2, "".concat(he2, "-no-wrap"), U3 === false), qd2(e2, "".concat(he2, "-").concat(y2), y2), qd2(e2, "".concat(he2, "-").concat(x2), x2), qd2(e2, "".concat(he2, "-rtl"), dt === "rtl"), e2), C), Pe2 = {}, Be2 = _e[0] > 0 ? _e[0] / -2 : void 0, Je2 = _e[1] > 0 ? _e[1] / -2 : void 0;
      if (Be2 && (Pe2.marginLeft = Be2, Pe2.marginRight = Be2), Rt) {
        var Ze2 = RA(_e, 2);
        Pe2.rowGap = Ze2[1];
      } else
        Je2 && (Pe2.marginTop = Je2, Pe2.marginBottom = Je2);
      var Cn = RA(_e, 2), Bn = Cn[0], mn = Cn[1], Kr = $.useMemo(function() {
        return { gutter: [Bn, mn], wrap: U3, supportFlexGap: Rt };
      }, [Bn, mn, U3, Rt]);
      return $.createElement(rve.Provider, { value: Kr }, $.createElement("div", km({}, Y3, { className: Me2, style: km(km({}, Pe2), D2), ref: a }), L));
    });
    ive.displayName = "Row";
    var R0n = ive, N0n = globalThis && globalThis.__rest || function(l2, a) {
      var e2 = {};
      for (var d2 in l2)
        Object.prototype.hasOwnProperty.call(l2, d2) && a.indexOf(d2) < 0 && (e2[d2] = l2[d2]);
      if (l2 != null && typeof Object.getOwnPropertySymbols == "function")
        for (var y2 = 0, d2 = Object.getOwnPropertySymbols(l2); y2 < d2.length; y2++)
          a.indexOf(d2[y2]) < 0 && Object.prototype.propertyIsEnumerable.call(l2, d2[y2]) && (e2[d2[y2]] = l2[d2[y2]]);
      return e2;
    };
    function F0n(l2) {
      return typeof l2 == "number" ? "".concat(l2, " ").concat(l2, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(l2) ? "0 0 ".concat(l2) : l2;
    }
    var V0n = ["xs", "sm", "md", "lg", "xl", "xxl"], ave = $.forwardRef(function(l2, a) {
      var e2, d2 = $.useContext(vF), y2 = d2.getPrefixCls, x2 = d2.direction, C = $.useContext(rve), D2 = C.gutter, L = C.wrap, F3 = C.supportFlexGap, j = l2.prefixCls, U3 = l2.span, Y3 = l2.order, Q = l2.offset, nt = l2.push, dt = l2.pull, vt = l2.className, Ct = l2.children, Pt = l2.flex, jt = l2.style, Rt = N0n(l2, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), le2 = y2("col", j), ne2 = {};
      V0n.forEach(function(Be2) {
        var Je2, Ze2 = {}, Cn = l2[Be2];
        typeof Cn == "number" ? Ze2.span = Cn : cw(Cn) === "object" && (Ze2 = Cn || {}), delete Rt[Be2], ne2 = km(km({}, ne2), (Je2 = {}, qd2(Je2, "".concat(le2, "-").concat(Be2, "-").concat(Ze2.span), Ze2.span !== void 0), qd2(Je2, "".concat(le2, "-").concat(Be2, "-order-").concat(Ze2.order), Ze2.order || Ze2.order === 0), qd2(Je2, "".concat(le2, "-").concat(Be2, "-offset-").concat(Ze2.offset), Ze2.offset || Ze2.offset === 0), qd2(Je2, "".concat(le2, "-").concat(Be2, "-push-").concat(Ze2.push), Ze2.push || Ze2.push === 0), qd2(Je2, "".concat(le2, "-").concat(Be2, "-pull-").concat(Ze2.pull), Ze2.pull || Ze2.pull === 0), qd2(Je2, "".concat(le2, "-rtl"), x2 === "rtl"), Je2));
      });
      var he2 = AZ(le2, (e2 = {}, qd2(e2, "".concat(le2, "-").concat(U3), U3 !== void 0), qd2(e2, "".concat(le2, "-order-").concat(Y3), Y3), qd2(e2, "".concat(le2, "-offset-").concat(Q), Q), qd2(e2, "".concat(le2, "-push-").concat(nt), nt), qd2(e2, "".concat(le2, "-pull-").concat(dt), dt), e2), vt, ne2), _e = {};
      if (D2 && D2[0] > 0) {
        var Me2 = D2[0] / 2;
        _e.paddingLeft = Me2, _e.paddingRight = Me2;
      }
      if (D2 && D2[1] > 0 && !F3) {
        var Pe2 = D2[1] / 2;
        _e.paddingTop = Pe2, _e.paddingBottom = Pe2;
      }
      return Pt && (_e.flex = F0n(Pt), L === false && !_e.minWidth && (_e.minWidth = 0)), $.createElement("div", km({}, Rt, { style: km(km({}, _e), jt), className: he2, ref: a }), Ct);
    });
    ave.displayName = "Col";
    var B0n = ave, ove = $.forwardRef(function(l2, a) {
      var e2, d2 = l2.prefixCls, y2 = d2 === void 0 ? "rc-switch" : d2, x2 = l2.className, C = l2.checked, D2 = l2.defaultChecked, L = l2.disabled, F3 = l2.loadingIcon, j = l2.checkedChildren, U3 = l2.unCheckedChildren, Y3 = l2.onClick, Q = l2.onChange, nt = l2.onKeyDown, dt = TZ(l2, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), vt = m0n(false, { value: C, defaultValue: D2 }), Ct = RA(vt, 2), Pt = Ct[0], jt = Ct[1];
      function Rt(_e, Me2) {
        var Pe2 = Pt;
        return L || (Pe2 = _e, jt(Pe2), Q == null || Q(Pe2, Me2)), Pe2;
      }
      function le2(_e) {
        _e.which === Sc2.LEFT ? Rt(false, _e) : _e.which === Sc2.RIGHT && Rt(true, _e), nt == null || nt(_e);
      }
      function ne2(_e) {
        var Me2 = Rt(!Pt, _e);
        Y3 == null || Y3(Me2, _e);
      }
      var he2 = AZ(y2, x2, (e2 = {}, qd2(e2, "".concat(y2, "-checked"), Pt), qd2(e2, "".concat(y2, "-disabled"), L), e2));
      return $.createElement("button", Object.assign({}, dt, { type: "button", role: "switch", "aria-checked": Pt, disabled: L, className: he2, ref: a, onKeyDown: le2, onClick: ne2 }), F3, $.createElement("span", { className: "".concat(y2, "-inner") }, Pt ? j : U3));
    });
    ove.displayName = "Switch";
    var z0n = globalThis && globalThis.__rest || function(l2, a) {
      var e2 = {};
      for (var d2 in l2)
        Object.prototype.hasOwnProperty.call(l2, d2) && a.indexOf(d2) < 0 && (e2[d2] = l2[d2]);
      if (l2 != null && typeof Object.getOwnPropertySymbols == "function")
        for (var y2 = 0, d2 = Object.getOwnPropertySymbols(l2); y2 < d2.length; y2++)
          a.indexOf(d2[y2]) < 0 && Object.prototype.propertyIsEnumerable.call(l2, d2[y2]) && (e2[d2[y2]] = l2[d2[y2]]);
      return e2;
    }, k6t = $.forwardRef(function(l2, a) {
      var e2, d2 = l2.prefixCls, y2 = l2.size, x2 = l2.loading, C = l2.className, D2 = C === void 0 ? "" : C, L = l2.disabled, F3 = z0n(l2, ["prefixCls", "size", "loading", "className", "disabled"]);
      t0n("checked" in F3 || !("value" in F3), "Switch", "`value` is not a valid prop, do you mean `checked`?");
      var j = $.useContext(vF), U3 = j.getPrefixCls, Y3 = j.direction, Q = $.useContext(y0n), nt = U3("switch", d2), dt = $.createElement("div", { className: "".concat(nt, "-handle") }, x2 && $.createElement(Hgn, { className: "".concat(nt, "-loading-icon") })), vt = AZ((e2 = {}, qd2(e2, "".concat(nt, "-small"), (y2 || Q) === "small"), qd2(e2, "".concat(nt, "-loading"), x2), qd2(e2, "".concat(nt, "-rtl"), Y3 === "rtl"), e2), D2);
      return $.createElement(Jge, { insertExtraNode: true }, $.createElement(ove, km({}, F3, { prefixCls: nt, className: vt, disabled: L || x2, ref: a, loadingIcon: dt })));
    });
    k6t.__ANT_SWITCH = true, k6t.displayName = "Switch";
    var j0n = k6t, W0n = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, S1t = {};
    (function(l2) {
      var a = Object.defineProperty, e2 = Object.getOwnPropertySymbols, d2 = Object.prototype.hasOwnProperty, y2 = Object.prototype.propertyIsEnumerable, x2 = (u, o, n3) => o in u ? a(u, o, { enumerable: true, configurable: true, writable: true, value: n3 }) : u[o] = n3, C = (u, o) => {
        for (var n3 in o || (o = {}))
          d2.call(o, n3) && x2(u, n3, o[n3]);
        if (e2)
          for (var n3 of e2(o))
            y2.call(o, n3) && x2(u, n3, o[n3]);
        return u;
      }, D2 = (u, o, n3) => (x2(u, typeof o != "symbol" ? o + "" : o, n3), n3);
      Object.defineProperties(l2, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
      var L = H2.default;
      function F3(u) {
        return u && typeof u == "object" && "default" in u ? u : { default: u };
      }
      function j(u) {
        if (u && u.__esModule)
          return u;
        var o = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
        return u && Object.keys(u).forEach(function(n3) {
          if (n3 !== "default") {
            var p2 = Object.getOwnPropertyDescriptor(u, n3);
            Object.defineProperty(o, n3, p2.get ? p2 : { enumerable: true, get: function() {
              return u[n3];
            } });
          }
        }), o.default = u, Object.freeze(o);
      }
      var U3 = F3(L), Y3 = j(L), Q = globalThis && globalThis.__read || function(u, o) {
        var n3 = typeof Symbol == "function" && u[Symbol.iterator];
        if (!n3)
          return u;
        var p2 = n3.call(u), m2, w2 = [], T2;
        try {
          for (; (o === void 0 || o-- > 0) && !(m2 = p2.next()).done; )
            w2.push(m2.value);
        } catch (E) {
          T2 = { error: E };
        } finally {
          try {
            m2 && !m2.done && (n3 = p2.return) && n3.call(p2);
          } finally {
            if (T2)
              throw T2.error;
          }
        }
        return w2;
      };
      function nt(u, o) {
        u === void 0 && (u = false);
        var n3 = Q(L.useState(u), 2), p2 = n3[0], m2 = n3[1], w2 = L.useMemo(function() {
          var T2 = o === void 0 ? !u : o, E = function() {
            return m2(function(q3) {
              return q3 === u ? T2 : u;
            });
          }, O2 = function(q3) {
            return m2(q3);
          }, V3 = function() {
            return m2(u);
          }, W3 = function() {
            return m2(T2);
          };
          return { toggle: E, set: O2, setLeft: V3, setRight: W3 };
        }, []);
        return [p2, w2];
      }
      var dt = globalThis && globalThis.__read || function(u, o) {
        var n3 = typeof Symbol == "function" && u[Symbol.iterator];
        if (!n3)
          return u;
        var p2 = n3.call(u), m2, w2 = [], T2;
        try {
          for (; (o === void 0 || o-- > 0) && !(m2 = p2.next()).done; )
            w2.push(m2.value);
        } catch (E) {
          T2 = { error: E };
        } finally {
          try {
            m2 && !m2.done && (n3 = p2.return) && n3.call(p2);
          } finally {
            if (T2)
              throw T2.error;
          }
        }
        return w2;
      };
      function vt(u) {
        u === void 0 && (u = false);
        var o = dt(nt(u), 2), n3 = o[0], p2 = o[1], m2 = p2.toggle, w2 = p2.set, T2 = L.useMemo(function() {
          var E = function() {
            return w2(true);
          }, O2 = function() {
            return w2(false);
          };
          return { toggle: m2, set: function(V3) {
            return w2(!!V3);
          }, setTrue: E, setFalse: O2 };
        }, []);
        return [n3, T2];
      }
      function Ct(u) {
        var o = L.useRef(u);
        return o.current = u, o;
      }
      var Pt = !!(typeof window != "undefined" && window.document && window.document.createElement), jt = Pt;
      function Rt(u, o) {
        if (jt) {
          if (!u)
            return o;
          var n3;
          return typeof u == "function" ? n3 = u() : "current" in u ? n3 = u.current : n3 = u, n3;
        }
      }
      var le2 = function(u) {
        var o = Ct(u);
        L.useEffect(function() {
          return function() {
            o.current();
          };
        }, []);
      }, ne2 = le2;
      function he2(u, o) {
        if (u === o)
          return true;
        for (var n3 = 0; n3 < u.length; n3++)
          if (!Object.is(u[n3], o[n3]))
            return false;
        return true;
      }
      var _e = function(u) {
        var o = function(n3, p2, m2) {
          var w2 = L.useRef(false), T2 = L.useRef([]), E = L.useRef([]), O2 = L.useRef();
          u(function() {
            var V3, W3 = Array.isArray(m2) ? m2 : [m2], q3 = W3.map(function(K) {
              return Rt(K);
            });
            if (!w2.current) {
              w2.current = true, T2.current = q3, E.current = p2, O2.current = n3();
              return;
            }
            (q3.length !== T2.current.length || !he2(q3, T2.current) || !he2(p2, E.current)) && ((V3 = O2.current) === null || V3 === void 0 || V3.call(O2), T2.current = q3, E.current = p2, O2.current = n3());
          }), ne2(function() {
            var V3;
            (V3 = O2.current) === null || V3 === void 0 || V3.call(O2), w2.current = false;
          });
        };
        return o;
      }, Me2 = _e, Pe2 = Me2(L.useEffect), Be2 = Pe2, Je2 = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof en != "undefined" ? en : typeof self != "undefined" ? self : {};
      function Ze2(u) {
        return u && u.__esModule && Object.prototype.hasOwnProperty.call(u, "default") ? u.default : u;
      }
      function Cn(u) {
        var o = typeof u;
        return u != null && (o == "object" || o == "function");
      }
      var Bn = Cn, mn = typeof Je2 == "object" && Je2 && Je2.Object === Object && Je2, Kr = mn, Kn = Kr, ar = typeof self == "object" && self && self.Object === Object && self, Cr = Kn || ar || Function("return this")(), ui2 = Cr, vi2 = ui2, ko = function() {
        return vi2.Date.now();
      }, Ss = ko, hl = /\s/;
      function Qs(u) {
        for (var o = u.length; o-- && hl.test(u.charAt(o)); )
          ;
        return o;
      }
      var Js = Qs, rs = Js, Gs = /^\s+/;
      function al(u) {
        return u && u.slice(0, rs(u) + 1).replace(Gs, "");
      }
      var _s = al, Fl = ui2, Ih2 = Fl.Symbol, lu = Ih2, ah2 = lu, Uh2 = Object.prototype, Np = Uh2.hasOwnProperty, Zy = Uh2.toString, Nd2 = ah2 ? ah2.toStringTag : void 0;
      function w1(u) {
        var o = Np.call(u, Nd2), n3 = u[Nd2];
        try {
          u[Nd2] = void 0;
          var p2 = true;
        } catch {
        }
        var m2 = Zy.call(u);
        return p2 && (o ? u[Nd2] = n3 : delete u[Nd2]), m2;
      }
      var Zd2 = w1, Lv = Object.prototype, hv = Lv.toString;
      function VA(u) {
        return hv.call(u);
      }
      var po = VA, ia2 = lu, Ji2 = Zd2, mo = po, zs = "[object Null]", Jl = "[object Undefined]", gf2 = ia2 ? ia2.toStringTag : void 0;
      function vf2(u) {
        return u == null ? u === void 0 ? Jl : zs : gf2 && gf2 in Object(u) ? Ji2(u) : mo(u);
      }
      var Xp = vf2;
      function pv(u) {
        return u != null && typeof u == "object";
      }
      var vg2 = pv, Z0 = Xp, yg2 = vg2, Cb2 = "[object Symbol]";
      function z_(u) {
        return typeof u == "symbol" || yg2(u) && Z0(u) == Cb2;
      }
      var tM = z_, j_ = _s, i0 = Bn, qh2 = tM, wy = 0 / 0, S1 = /^[-+]0x[0-9a-f]+$/i, eM = /^0b[01]+$/i, hw = /^0o[0-7]+$/i, W_ = parseInt;
      function GS(u) {
        if (typeof u == "number")
          return u;
        if (qh2(u))
          return wy;
        if (i0(u)) {
          var o = typeof u.valueOf == "function" ? u.valueOf() : u;
          u = i0(o) ? o + "" : o;
        }
        if (typeof u != "string")
          return u === 0 ? u : +u;
        u = j_(u);
        var n3 = eM.test(u);
        return n3 || hw.test(u) ? W_(u.slice(2), n3 ? 2 : 8) : S1.test(u) ? wy : +u;
      }
      var vP = GS, RE = Bn, RB = Ss, NE = vP, Pit = "Expected a function", Lit = Math.max, Oit = Math.min;
      function Rit(u, o, n3) {
        var p2, m2, w2, T2, E, O2, V3 = 0, W3 = false, q3 = false, K = true;
        if (typeof u != "function")
          throw new TypeError(Pit);
        o = NE(o) || 0, RE(n3) && (W3 = !!n3.leading, q3 = "maxWait" in n3, w2 = q3 ? Lit(NE(n3.maxWait) || 0, o) : w2, K = "trailing" in n3 ? !!n3.trailing : K);
        function J(ie2) {
          var pe2 = p2, xe = m2;
          return p2 = m2 = void 0, V3 = ie2, T2 = u.apply(xe, pe2), T2;
        }
        function rt2(ie2) {
          return V3 = ie2, E = setTimeout(At, o), W3 ? J(ie2) : T2;
        }
        function gt(ie2) {
          var pe2 = ie2 - O2, xe = ie2 - V3, Ce2 = o - pe2;
          return q3 ? Oit(Ce2, w2 - xe) : Ce2;
        }
        function yt(ie2) {
          var pe2 = ie2 - O2, xe = ie2 - V3;
          return O2 === void 0 || pe2 >= o || pe2 < 0 || q3 && xe >= w2;
        }
        function At() {
          var ie2 = RB();
          if (yt(ie2))
            return Lt(ie2);
          E = setTimeout(At, gt(ie2));
        }
        function Lt(ie2) {
          return E = void 0, K && p2 ? J(ie2) : (p2 = m2 = void 0, T2);
        }
        function Wt() {
          E !== void 0 && clearTimeout(E), V3 = 0, p2 = O2 = m2 = E = void 0;
        }
        function Nt() {
          return E === void 0 ? T2 : Lt(RB());
        }
        function ue2() {
          var ie2 = RB(), pe2 = yt(ie2);
          if (p2 = arguments, m2 = this, O2 = ie2, pe2) {
            if (E === void 0)
              return rt2(O2);
            if (q3)
              return clearTimeout(E), E = setTimeout(At, o), J(O2);
          }
          return E === void 0 && (E = setTimeout(At, o)), T2;
        }
        return ue2.cancel = Wt, ue2.flush = Nt, ue2;
      }
      var yF = Rit, xr = globalThis && globalThis.__read || function(u, o) {
        var n3 = typeof Symbol == "function" && u[Symbol.iterator];
        if (!n3)
          return u;
        var p2 = n3.call(u), m2, w2 = [], T2;
        try {
          for (; (o === void 0 || o-- > 0) && !(m2 = p2.next()).done; )
            w2.push(m2.value);
        } catch (E) {
          T2 = { error: E };
        } finally {
          try {
            m2 && !m2.done && (n3 = p2.return) && n3.call(p2);
          } finally {
            if (T2)
              throw T2.error;
          }
        }
        return w2;
      }, kr = globalThis && globalThis.__spread || function() {
        for (var u = [], o = 0; o < arguments.length; o++)
          u = u.concat(xr(arguments[o]));
        return u;
      };
      function Rn(u, o) {
        var n3, p2 = Ct(u), m2 = (n3 = o == null ? void 0 : o.wait) !== null && n3 !== void 0 ? n3 : 1e3, w2 = L.useMemo(function() {
          return yF(function() {
            for (var T2 = [], E = 0; E < arguments.length; E++)
              T2[E] = arguments[E];
            return p2.current.apply(p2, kr(T2));
          }, m2, o);
        }, []);
        return ne2(function() {
          w2.cancel();
        }), { run: w2, cancel: w2.cancel, flush: w2.flush };
      }
      var fr = function(u) {
        return function(o, n3) {
          var p2 = L.useRef(false);
          u(function() {
            return function() {
              p2.current = false;
            };
          }, []), u(function() {
            if (!p2.current)
              p2.current = true;
            else
              return o();
          }, n3);
        };
      }, mr = fr(L.useEffect), qi2 = globalThis && globalThis.__read || function(u, o) {
        var n3 = typeof Symbol == "function" && u[Symbol.iterator];
        if (!n3)
          return u;
        var p2 = n3.call(u), m2, w2 = [], T2;
        try {
          for (; (o === void 0 || o-- > 0) && !(m2 = p2.next()).done; )
            w2.push(m2.value);
        } catch (E) {
          T2 = { error: E };
        } finally {
          try {
            m2 && !m2.done && (n3 = p2.return) && n3.call(p2);
          } finally {
            if (T2)
              throw T2.error;
          }
        }
        return w2;
      };
      function to(u, o, n3) {
        var p2 = qi2(L.useState({}), 2), m2 = p2[0], w2 = p2[1], T2 = Rn(function() {
          w2({});
        }, n3), E = T2.run, O2 = T2.cancel;
        L.useEffect(function() {
          return E();
        }, o), ne2(O2), mr(u, [m2]);
      }
      function ka2(u, o, n3) {
        n3 === void 0 && (n3 = {});
        var p2 = Ct(o);
        Be2(function() {
          var m2 = Rt(n3.target, window);
          if (m2 != null && m2.addEventListener) {
            var w2 = function(T2) {
              return p2.current(T2);
            };
            return m2.addEventListener(u, w2, { capture: n3.capture, once: n3.once, passive: n3.passive }), function() {
              m2.removeEventListener(u, w2, { capture: n3.capture });
            };
          }
        }, [u, n3.capture, n3.once, n3.passive], n3.target);
      }
      /*! *****************************************************************************
      Copyright (c) Microsoft Corporation.
      
      Permission to use, copy, modify, and/or distribute this software for any
      purpose with or without fee is hereby granted.
      
      THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
      REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
      AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
      INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
      LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
      OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
      PERFORMANCE OF THIS SOFTWARE.
      ***************************************************************************** */
      var Ti2 = function(u, o) {
        return Ti2 = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(n3, p2) {
          n3.__proto__ = p2;
        } || function(n3, p2) {
          for (var m2 in p2)
            Object.prototype.hasOwnProperty.call(p2, m2) && (n3[m2] = p2[m2]);
        }, Ti2(u, o);
      };
      function tr(u, o) {
        if (typeof o != "function" && o !== null)
          throw new TypeError("Class extends value " + String(o) + " is not a constructor or null");
        Ti2(u, o);
        function n3() {
          this.constructor = u;
        }
        u.prototype = o === null ? Object.create(o) : (n3.prototype = o.prototype, new n3());
      }
      var tu = function() {
        function u() {
          this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
        }
        return u;
      }(), Kf2 = function() {
        function u() {
          this.browser = new tu(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
        }
        return u;
      }(), yf2 = new Kf2();
      typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (yf2.wxa = true, yf2.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? yf2.worker = true : typeof navigator == "undefined" ? (yf2.node = true, yf2.svgSupported = true) : wd2(navigator.userAgent, yf2);
      function wd2(u, o) {
        var n3 = o.browser, p2 = u.match(/Firefox\/([\d.]+)/), m2 = u.match(/MSIE\s([\d.]+)/) || u.match(/Trident\/.+?rv:(([\d.]+))/), w2 = u.match(/Edge?\/([\d.]+)/), T2 = /micromessenger/i.test(u);
        p2 && (n3.firefox = true, n3.version = p2[1]), m2 && (n3.ie = true, n3.version = m2[1]), w2 && (n3.edge = true, n3.version = w2[1], n3.newEdge = +w2[1].split(".")[0] > 18), T2 && (n3.weChat = true), o.svgSupported = typeof SVGRect != "undefined", o.touchEventsSupported = "ontouchstart" in window && !n3.ie && !n3.edge, o.pointerEventsSupported = "onpointerdown" in window && (n3.edge || n3.ie && +n3.version >= 11), o.domSupported = typeof document != "undefined";
        var E = document.documentElement.style;
        o.transform3dSupported = (n3.ie && "transition" in E || n3.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in E) && !("OTransition" in E), o.transformSupported = o.transform3dSupported || n3.ie && +n3.version >= 9;
      }
      var Ys = yf2, Qp = 12, dv = "sans-serif", Fu = Qp + "px " + dv, $0 = 20, G_ = 100, wC = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
      function mF(u) {
        var o = {};
        if (typeof JSON == "undefined")
          return o;
        for (var n3 = 0; n3 < u.length; n3++) {
          var p2 = String.fromCharCode(n3 + 32), m2 = (u.charCodeAt(n3) - $0) / G_;
          o[p2] = m2;
        }
        return o;
      }
      var SC = mF(wC), pw = { createCanvas: function() {
        return typeof document != "undefined" && document.createElement("canvas");
      }, measureText: function() {
        var u, o;
        return function(n3, p2) {
          if (!u) {
            var m2 = pw.createCanvas();
            u = m2 && m2.getContext("2d");
          }
          if (u)
            return o !== p2 && (o = u.font = p2 || Fu), u.measureText(n3);
          n3 = n3 || "", p2 = p2 || Fu;
          var w2 = /^([0-9]*?)px$/.exec(p2), T2 = +(w2 && w2[1]) || Qp, E = 0;
          if (p2.indexOf("mono") >= 0)
            E = T2 * n3.length;
          else
            for (var O2 = 0; O2 < n3.length; O2++) {
              var V3 = SC[n3[O2]];
              E += V3 == null ? T2 : V3 * T2;
            }
          return { width: E };
        };
      }(), loadImage: function(u, o, n3) {
        var p2 = new Image();
        return p2.onload = o, p2.onerror = n3, p2.src = u, p2;
      } }, BA = jA(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(u, o) {
        return u["[object " + o + "]"] = true, u;
      }, {}), Sy = jA(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(u, o) {
        return u["[object " + o + "Array]"] = true, u;
      }, {}), H_ = Object.prototype.toString, zA = Array.prototype, FE = zA.forEach, WO = zA.filter, VE = zA.slice, NB = zA.map, GO = function() {
      }.constructor, BE = GO ? GO.prototype : null, zE = "__proto__", yP = 2311;
      function bF() {
        return yP++;
      }
      function FB() {
        for (var u = [], o = 0; o < arguments.length; o++)
          u[o] = arguments[o];
        typeof console != "undefined" && console.error.apply(console, u);
      }
      function jl(u) {
        if (u == null || typeof u != "object")
          return u;
        var o = u, n3 = H_.call(u);
        if (n3 === "[object Array]") {
          if (!_F(u)) {
            o = [];
            for (var p2 = 0, m2 = u.length; p2 < m2; p2++)
              o[p2] = jl(u[p2]);
          }
        } else if (Sy[n3]) {
          if (!_F(u)) {
            var w2 = u.constructor;
            if (w2.from)
              o = w2.from(u);
            else {
              o = new w2(u.length);
              for (var p2 = 0, m2 = u.length; p2 < m2; p2++)
                o[p2] = u[p2];
            }
          }
        } else if (!BA[n3] && !_F(u) && !VB(u)) {
          o = {};
          for (var T2 in u)
            u.hasOwnProperty(T2) && T2 !== zE && (o[T2] = jl(u[T2]));
        }
        return o;
      }
      function Cu(u, o, n3) {
        if (!ys(o) || !ys(u))
          return n3 ? jl(o) : u;
        for (var p2 in o)
          if (o.hasOwnProperty(p2) && p2 !== zE) {
            var m2 = u[p2], w2 = o[p2];
            ys(w2) && ys(m2) && !za2(w2) && !za2(m2) && !VB(w2) && !VB(m2) && !mg2(w2) && !mg2(m2) && !_F(w2) && !_F(m2) ? Cu(m2, w2, n3) : (n3 || !(p2 in u)) && (u[p2] = jl(o[p2]));
          }
        return u;
      }
      function LZ(u, o) {
        for (var n3 = u[0], p2 = 1, m2 = u.length; p2 < m2; p2++)
          n3 = Cu(n3, u[p2], o);
        return n3;
      }
      function ua2(u, o) {
        if (Object.assign)
          Object.assign(u, o);
        else
          for (var n3 in o)
            o.hasOwnProperty(n3) && n3 !== zE && (u[n3] = o[n3]);
        return u;
      }
      function kl(u, o, n3) {
        for (var p2 = tf2(o), m2 = 0; m2 < p2.length; m2++) {
          var w2 = p2[m2];
          (n3 ? o[w2] != null : u[w2] == null) && (u[w2] = o[w2]);
        }
        return u;
      }
      function sc2(u, o) {
        if (u) {
          if (u.indexOf)
            return u.indexOf(o);
          for (var n3 = 0, p2 = u.length; n3 < p2; n3++)
            if (u[n3] === o)
              return n3;
        }
        return -1;
      }
      function M1t(u, o) {
        var n3 = u.prototype;
        function p2() {
        }
        p2.prototype = o.prototype, u.prototype = new p2();
        for (var m2 in n3)
          n3.hasOwnProperty(m2) && (u.prototype[m2] = n3[m2]);
        u.prototype.constructor = u, u.superClass = o;
      }
      function x0(u, o, n3) {
        if (u = "prototype" in u ? u.prototype : u, o = "prototype" in o ? o.prototype : o, Object.getOwnPropertyNames)
          for (var p2 = Object.getOwnPropertyNames(o), m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2];
            w2 !== "constructor" && (n3 ? o[w2] != null : u[w2] == null) && (u[w2] = o[w2]);
          }
        else
          kl(u, o, n3);
      }
      function M1(u) {
        return !u || typeof u == "string" ? false : typeof u.length == "number";
      }
      function Xe2(u, o, n3) {
        if (u && o)
          if (u.forEach && u.forEach === FE)
            u.forEach(o, n3);
          else if (u.length === +u.length)
            for (var p2 = 0, m2 = u.length; p2 < m2; p2++)
              o.call(n3, u[p2], p2, u);
          else
            for (var w2 in u)
              u.hasOwnProperty(w2) && o.call(n3, u[w2], w2, u);
      }
      function Ya2(u, o, n3) {
        if (!u)
          return [];
        if (!o)
          return zB(u);
        if (u.map && u.map === NB)
          return u.map(o, n3);
        for (var p2 = [], m2 = 0, w2 = u.length; m2 < w2; m2++)
          p2.push(o.call(n3, u[m2], m2, u));
        return p2;
      }
      function jA(u, o, n3, p2) {
        if (u && o) {
          for (var m2 = 0, w2 = u.length; m2 < w2; m2++)
            n3 = o.call(p2, n3, u[m2], m2, u);
          return n3;
        }
      }
      function Fp(u, o, n3) {
        if (!u)
          return [];
        if (!o)
          return zB(u);
        if (u.filter && u.filter === WO)
          return u.filter(o, n3);
        for (var p2 = [], m2 = 0, w2 = u.length; m2 < w2; m2++)
          o.call(n3, u[m2], m2, u) && p2.push(u[m2]);
        return p2;
      }
      function P6t(u, o, n3) {
        if (u && o) {
          for (var p2 = 0, m2 = u.length; p2 < m2; p2++)
            if (o.call(n3, u[p2], p2, u))
              return u[p2];
        }
      }
      function tf2(u) {
        if (!u)
          return [];
        if (Object.keys)
          return Object.keys(u);
        var o = [];
        for (var n3 in u)
          u.hasOwnProperty(n3) && o.push(n3);
        return o;
      }
      function L6t(u, o) {
        for (var n3 = [], p2 = 2; p2 < arguments.length; p2++)
          n3[p2 - 2] = arguments[p2];
        return function() {
          return u.apply(o, n3.concat(VE.call(arguments)));
        };
      }
      var Is = BE && Sl(BE.bind) ? BE.call.bind(BE.bind) : L6t;
      function wu(u) {
        for (var o = [], n3 = 1; n3 < arguments.length; n3++)
          o[n3 - 1] = arguments[n3];
        return function() {
          return u.apply(this, o.concat(VE.call(arguments)));
        };
      }
      function za2(u) {
        return Array.isArray ? Array.isArray(u) : H_.call(u) === "[object Array]";
      }
      function Sl(u) {
        return typeof u == "function";
      }
      function ds(u) {
        return typeof u == "string";
      }
      function Nit(u) {
        return H_.call(u) === "[object String]";
      }
      function Dh2(u) {
        return typeof u == "number";
      }
      function ys(u) {
        var o = typeof u;
        return o === "function" || !!u && o === "object";
      }
      function mg2(u) {
        return !!BA[H_.call(u)];
      }
      function HS(u) {
        return !!Sy[H_.call(u)];
      }
      function VB(u) {
        return typeof u == "object" && typeof u.nodeType == "number" && typeof u.ownerDocument == "object";
      }
      function OZ(u) {
        return u.colorStops != null;
      }
      function O6t(u) {
        return u.image != null;
      }
      function R6t(u) {
        return H_.call(u) === "[object RegExp]";
      }
      function BB(u) {
        return u !== u;
      }
      function $y() {
        for (var u = [], o = 0; o < arguments.length; o++)
          u[o] = arguments[o];
        for (var n3 = 0, p2 = u.length; n3 < p2; n3++)
          if (u[n3] != null)
            return u[n3];
      }
      function Xu(u, o) {
        return u != null ? u : o;
      }
      function gv(u, o, n3) {
        return u != null ? u : o != null ? o : n3;
      }
      function zB(u) {
        for (var o = [], n3 = 1; n3 < arguments.length; n3++)
          o[n3 - 1] = arguments[n3];
        return VE.apply(u, o);
      }
      function jE(u) {
        if (typeof u == "number")
          return [u, u, u, u];
        var o = u.length;
        return o === 2 ? [u[0], u[1], u[0], u[1]] : o === 3 ? [u[0], u[1], u[2], u[1]] : u;
      }
      function Tb2(u, o) {
        if (!u)
          throw new Error(o);
      }
      function US(u) {
        return u == null ? null : typeof u.trim == "function" ? u.trim() : u.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
      }
      var qS = "__ec_primitive__";
      function jB(u) {
        u[qS] = true;
      }
      function _F(u) {
        return u[qS];
      }
      var C1t = function() {
        function u(o) {
          this.data = {};
          var n3 = za2(o);
          this.data = {};
          var p2 = this;
          o instanceof u ? o.each(m2) : o && Xe2(o, m2);
          function m2(w2, T2) {
            n3 ? p2.set(w2, T2) : p2.set(T2, w2);
          }
        }
        return u.prototype.get = function(o) {
          return this.data.hasOwnProperty(o) ? this.data[o] : null;
        }, u.prototype.set = function(o, n3) {
          return this.data[o] = n3;
        }, u.prototype.each = function(o, n3) {
          for (var p2 in this.data)
            this.data.hasOwnProperty(p2) && o.call(n3, this.data[p2], p2);
        }, u.prototype.keys = function() {
          return tf2(this.data);
        }, u.prototype.removeKey = function(o) {
          delete this.data[o];
        }, u;
      }();
      function pl(u) {
        return new C1t(u);
      }
      function RZ(u, o) {
        for (var n3 = new u.constructor(u.length + o.length), p2 = 0; p2 < u.length; p2++)
          n3[p2] = u[p2];
        for (var m2 = u.length, p2 = 0; p2 < o.length; p2++)
          n3[p2 + m2] = o[p2];
        return n3;
      }
      function WB(u, o) {
        var n3;
        if (Object.create)
          n3 = Object.create(u);
        else {
          var p2 = function() {
          };
          p2.prototype = u, n3 = new p2();
        }
        return o && ua2(n3, o), n3;
      }
      function dw(u) {
        var o = u.style;
        o.webkitUserSelect = "none", o.userSelect = "none", o.webkitTapHighlightColor = "rgba(0,0,0,0)", o["-webkit-touch-callout"] = "none";
      }
      function Fs(u, o) {
        return u.hasOwnProperty(o);
      }
      function Jp() {
      }
      var NZ = 180 / Math.PI;
      function mP(u, o) {
        return u == null && (u = 0), o == null && (o = 0), [u, o];
      }
      function w0(u, o) {
        return u[0] = o[0], u[1] = o[1], u;
      }
      function nM(u) {
        return [u[0], u[1]];
      }
      function Fit(u, o, n3) {
        return u[0] = o, u[1] = n3, u;
      }
      function vv(u, o, n3) {
        return u[0] = o[0] + n3[0], u[1] = o[1] + n3[1], u;
      }
      function WA(u, o, n3, p2) {
        return u[0] = o[0] + n3[0] * p2, u[1] = o[1] + n3[1] * p2, u;
      }
      function WE(u, o, n3) {
        return u[0] = o[0] - n3[0], u[1] = o[1] - n3[1], u;
      }
      function Vit(u) {
        return Math.sqrt(Bit(u));
      }
      function Bit(u) {
        return u[0] * u[0] + u[1] * u[1];
      }
      function zit(u, o, n3) {
        return u[0] = o[0] * n3, u[1] = o[1] * n3, u;
      }
      function GB(u, o) {
        var n3 = Vit(o);
        return n3 === 0 ? (u[0] = 0, u[1] = 0) : (u[0] = o[0] / n3, u[1] = o[1] / n3), u;
      }
      function jit(u, o) {
        return Math.sqrt((u[0] - o[0]) * (u[0] - o[0]) + (u[1] - o[1]) * (u[1] - o[1]));
      }
      var GE = jit;
      function FZ(u, o) {
        return (u[0] - o[0]) * (u[0] - o[0]) + (u[1] - o[1]) * (u[1] - o[1]);
      }
      var rM = FZ;
      function VZ(u, o, n3, p2) {
        return u[0] = o[0] + p2 * (n3[0] - o[0]), u[1] = o[1] + p2 * (n3[1] - o[1]), u;
      }
      function Lm(u, o, n3) {
        var p2 = o[0], m2 = o[1];
        return u[0] = n3[0] * p2 + n3[2] * m2 + n3[4], u[1] = n3[1] * p2 + n3[3] * m2 + n3[5], u;
      }
      function HE(u, o, n3) {
        return u[0] = Math.min(o[0], n3[0]), u[1] = Math.min(o[1], n3[1]), u;
      }
      function GA(u, o, n3) {
        return u[0] = Math.max(o[0], n3[0]), u[1] = Math.max(o[1], n3[1]), u;
      }
      var bP = function() {
        function u(o, n3) {
          this.target = o, this.topTarget = n3 && n3.topTarget;
        }
        return u;
      }(), T1t = function() {
        function u(o) {
          this.handler = o, o.on("mousedown", this._dragStart, this), o.on("mousemove", this._drag, this), o.on("mouseup", this._dragEnd, this);
        }
        return u.prototype._dragStart = function(o) {
          for (var n3 = o.target; n3 && !n3.draggable; )
            n3 = n3.parent || n3.__hostTarget;
          n3 && (this._draggingTarget = n3, n3.dragging = true, this._x = o.offsetX, this._y = o.offsetY, this.handler.dispatchToElement(new bP(n3, o), "dragstart", o.event));
        }, u.prototype._drag = function(o) {
          var n3 = this._draggingTarget;
          if (n3) {
            var p2 = o.offsetX, m2 = o.offsetY, w2 = p2 - this._x, T2 = m2 - this._y;
            this._x = p2, this._y = m2, n3.drift(w2, T2, o), this.handler.dispatchToElement(new bP(n3, o), "drag", o.event);
            var E = this.handler.findHover(p2, m2, n3).target, O2 = this._dropTarget;
            this._dropTarget = E, n3 !== E && (O2 && E !== O2 && this.handler.dispatchToElement(new bP(O2, o), "dragleave", o.event), E && E !== O2 && this.handler.dispatchToElement(new bP(E, o), "dragenter", o.event));
          }
        }, u.prototype._dragEnd = function(o) {
          var n3 = this._draggingTarget;
          n3 && (n3.dragging = false), this.handler.dispatchToElement(new bP(n3, o), "dragend", o.event), this._dropTarget && this.handler.dispatchToElement(new bP(this._dropTarget, o), "drop", o.event), this._draggingTarget = null, this._dropTarget = null;
        }, u;
      }(), N6t = T1t, Wit = function() {
        function u(o) {
          o && (this._$eventProcessor = o);
        }
        return u.prototype.on = function(o, n3, p2, m2) {
          this._$handlers || (this._$handlers = {});
          var w2 = this._$handlers;
          if (typeof n3 == "function" && (m2 = p2, p2 = n3, n3 = null), !p2 || !o)
            return this;
          var T2 = this._$eventProcessor;
          n3 != null && T2 && T2.normalizeQuery && (n3 = T2.normalizeQuery(n3)), w2[o] || (w2[o] = []);
          for (var E = 0; E < w2[o].length; E++)
            if (w2[o][E].h === p2)
              return this;
          var O2 = { h: p2, query: n3, ctx: m2 || this, callAtLast: p2.zrEventfulCallAtLast }, V3 = w2[o].length - 1, W3 = w2[o][V3];
          return W3 && W3.callAtLast ? w2[o].splice(V3, 0, O2) : w2[o].push(O2), this;
        }, u.prototype.isSilent = function(o) {
          var n3 = this._$handlers;
          return !n3 || !n3[o] || !n3[o].length;
        }, u.prototype.off = function(o, n3) {
          var p2 = this._$handlers;
          if (!p2)
            return this;
          if (!o)
            return this._$handlers = {}, this;
          if (n3) {
            if (p2[o]) {
              for (var m2 = [], w2 = 0, T2 = p2[o].length; w2 < T2; w2++)
                p2[o][w2].h !== n3 && m2.push(p2[o][w2]);
              p2[o] = m2;
            }
            p2[o] && p2[o].length === 0 && delete p2[o];
          } else
            delete p2[o];
          return this;
        }, u.prototype.trigger = function(o) {
          for (var n3 = [], p2 = 1; p2 < arguments.length; p2++)
            n3[p2 - 1] = arguments[p2];
          if (!this._$handlers)
            return this;
          var m2 = this._$handlers[o], w2 = this._$eventProcessor;
          if (m2)
            for (var T2 = n3.length, E = m2.length, O2 = 0; O2 < E; O2++) {
              var V3 = m2[O2];
              if (!(w2 && w2.filter && V3.query != null && !w2.filter(o, V3.query)))
                switch (T2) {
                  case 0:
                    V3.h.call(V3.ctx);
                    break;
                  case 1:
                    V3.h.call(V3.ctx, n3[0]);
                    break;
                  case 2:
                    V3.h.call(V3.ctx, n3[0], n3[1]);
                    break;
                  default:
                    V3.h.apply(V3.ctx, n3);
                    break;
                }
            }
          return w2 && w2.afterTrigger && w2.afterTrigger(o), this;
        }, u.prototype.triggerWithContext = function(o) {
          for (var n3 = [], p2 = 1; p2 < arguments.length; p2++)
            n3[p2 - 1] = arguments[p2];
          if (!this._$handlers)
            return this;
          var m2 = this._$handlers[o], w2 = this._$eventProcessor;
          if (m2)
            for (var T2 = n3.length, E = n3[T2 - 1], O2 = m2.length, V3 = 0; V3 < O2; V3++) {
              var W3 = m2[V3];
              if (!(w2 && w2.filter && W3.query != null && !w2.filter(o, W3.query)))
                switch (T2) {
                  case 0:
                    W3.h.call(E);
                    break;
                  case 1:
                    W3.h.call(E, n3[0]);
                    break;
                  case 2:
                    W3.h.call(E, n3[0], n3[1]);
                    break;
                  default:
                    W3.h.apply(E, n3.slice(1, T2 - 1));
                    break;
                }
            }
          return w2 && w2.afterTrigger && w2.afterTrigger(o), this;
        }, u;
      }(), gw = Wit, F6t = Math.log(2);
      function BZ(u, o, n3, p2, m2, w2) {
        var T2 = p2 + "-" + m2, E = u.length;
        if (w2.hasOwnProperty(T2))
          return w2[T2];
        if (o === 1) {
          var O2 = Math.round(Math.log((1 << E) - 1 & ~m2) / F6t);
          return u[n3][O2];
        }
        for (var V3 = p2 | 1 << n3, W3 = n3 + 1; p2 & 1 << W3; )
          W3++;
        for (var q3 = 0, K = 0, J = 0; K < E; K++) {
          var rt2 = 1 << K;
          rt2 & m2 || (q3 += (J % 2 ? -1 : 1) * u[n3][K] * BZ(u, o - 1, W3, V3, m2 | rt2, w2), J++);
        }
        return w2[T2] = q3, q3;
      }
      function vw(u, o) {
        var n3 = [[u[0], u[1], 1, 0, 0, 0, -o[0] * u[0], -o[0] * u[1]], [0, 0, 0, u[0], u[1], 1, -o[1] * u[0], -o[1] * u[1]], [u[2], u[3], 1, 0, 0, 0, -o[2] * u[2], -o[2] * u[3]], [0, 0, 0, u[2], u[3], 1, -o[3] * u[2], -o[3] * u[3]], [u[4], u[5], 1, 0, 0, 0, -o[4] * u[4], -o[4] * u[5]], [0, 0, 0, u[4], u[5], 1, -o[5] * u[4], -o[5] * u[5]], [u[6], u[7], 1, 0, 0, 0, -o[6] * u[6], -o[6] * u[7]], [0, 0, 0, u[6], u[7], 1, -o[7] * u[6], -o[7] * u[7]]], p2 = {}, m2 = BZ(n3, 8, 0, 0, 0, p2);
        if (m2 !== 0) {
          for (var w2 = [], T2 = 0; T2 < 8; T2++)
            for (var E = 0; E < 8; E++)
              w2[E] == null && (w2[E] = 0), w2[E] += ((T2 + E) % 2 ? -1 : 1) * BZ(n3, 7, T2 === 0 ? 1 : 0, 1 << T2, 1 << E, p2) / m2 * o[T2];
          return function(O2, V3, W3) {
            var q3 = V3 * w2[6] + W3 * w2[7] + 1;
            O2[0] = (V3 * w2[0] + W3 * w2[1] + w2[2]) / q3, O2[1] = (V3 * w2[3] + W3 * w2[4] + w2[5]) / q3;
          };
        }
      }
      var zZ = "___zrEVENTSAVED", HO = [];
      function A1t(u, o, n3, p2, m2) {
        return jZ(HO, o, p2, m2, true) && jZ(u, n3, HO[0], HO[1]);
      }
      function jZ(u, o, n3, p2, m2) {
        if (o.getBoundingClientRect && Ys.domSupported && !I1t(o)) {
          var w2 = o[zZ] || (o[zZ] = {}), T2 = V6t(o, w2), E = B6t(T2, w2, m2);
          if (E)
            return E(u, n3, p2), true;
        }
        return false;
      }
      function V6t(u, o) {
        var n3 = o.markers;
        if (n3)
          return n3;
        n3 = o.markers = [];
        for (var p2 = ["left", "right"], m2 = ["top", "bottom"], w2 = 0; w2 < 4; w2++) {
          var T2 = document.createElement("div"), E = T2.style, O2 = w2 % 2, V3 = (w2 >> 1) % 2;
          E.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", p2[O2] + ":0", m2[V3] + ":0", p2[1 - O2] + ":auto", m2[1 - V3] + ":auto", ""].join("!important;"), u.appendChild(T2), n3.push(T2);
        }
        return n3;
      }
      function B6t(u, o, n3) {
        for (var p2 = n3 ? "invTrans" : "trans", m2 = o[p2], w2 = o.srcCoords, T2 = [], E = [], O2 = true, V3 = 0; V3 < 4; V3++) {
          var W3 = u[V3].getBoundingClientRect(), q3 = 2 * V3, K = W3.left, J = W3.top;
          T2.push(K, J), O2 = O2 && w2 && K === w2[q3] && J === w2[q3 + 1], E.push(u[V3].offsetLeft, u[V3].offsetTop);
        }
        return O2 && m2 ? m2 : (o.srcCoords = T2, o[p2] = n3 ? vw(E, T2) : vw(T2, E));
      }
      function I1t(u) {
        return u.nodeName.toUpperCase() === "CANVAS";
      }
      var z6t = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, Git = [], xF = Ys.browser.firefox && +Ys.browser.version.split(".")[0] < 39;
      function Hit(u, o, n3, p2) {
        return n3 = n3 || {}, p2 ? D1t(u, o, n3) : xF && o.layerX != null && o.layerX !== o.offsetX ? (n3.zrX = o.layerX, n3.zrY = o.layerY) : o.offsetX != null ? (n3.zrX = o.offsetX, n3.zrY = o.offsetY) : D1t(u, o, n3), n3;
      }
      function D1t(u, o, n3) {
        if (Ys.domSupported && u.getBoundingClientRect) {
          var p2 = o.clientX, m2 = o.clientY;
          if (I1t(u)) {
            var w2 = u.getBoundingClientRect();
            n3.zrX = p2 - w2.left, n3.zrY = m2 - w2.top;
            return;
          } else if (jZ(Git, u, p2, m2)) {
            n3.zrX = Git[0], n3.zrY = Git[1];
            return;
          }
        }
        n3.zrX = n3.zrY = 0;
      }
      function HB(u) {
        return u || window.event;
      }
      function ZS(u, o, n3) {
        if (o = HB(o), o.zrX != null)
          return o;
        var p2 = o.type, m2 = p2 && p2.indexOf("touch") >= 0;
        if (m2) {
          var w2 = p2 !== "touchend" ? o.targetTouches[0] : o.changedTouches[0];
          w2 && Hit(u, w2, o, n3);
        } else {
          Hit(u, o, o, n3);
          var T2 = _P(o);
          o.zrDelta = T2 ? T2 / 120 : -(o.detail || 0) / 3;
        }
        var E = o.button;
        return o.which == null && E !== void 0 && z6t.test(o.type) && (o.which = E & 1 ? 1 : E & 2 ? 3 : E & 4 ? 2 : 0), o;
      }
      function _P(u) {
        var o = u.wheelDelta;
        if (o)
          return o;
        var n3 = u.deltaX, p2 = u.deltaY;
        if (n3 == null || p2 == null)
          return o;
        var m2 = Math.abs(p2 !== 0 ? p2 : n3), w2 = p2 > 0 ? -1 : p2 < 0 ? 1 : n3 > 0 ? -1 : 1;
        return 3 * m2 * w2;
      }
      function wF(u, o, n3, p2) {
        u.addEventListener(o, n3, p2);
      }
      function j6t(u, o, n3, p2) {
        u.removeEventListener(o, n3, p2);
      }
      var UE = function(u) {
        u.preventDefault(), u.stopPropagation(), u.cancelBubble = true;
      };
      function E1t(u) {
        return u.which === 2 || u.which === 3;
      }
      var SF = function() {
        function u() {
          this._track = [];
        }
        return u.prototype.recognize = function(o, n3, p2) {
          return this._doTrack(o, n3, p2), this._recognize(o);
        }, u.prototype.clear = function() {
          return this._track.length = 0, this;
        }, u.prototype._doTrack = function(o, n3, p2) {
          var m2 = o.touches;
          if (m2) {
            for (var w2 = { points: [], touches: [], target: n3, event: o }, T2 = 0, E = m2.length; T2 < E; T2++) {
              var O2 = m2[T2], V3 = Hit(p2, O2, {});
              w2.points.push([V3.zrX, V3.zrY]), w2.touches.push(O2);
            }
            this._track.push(w2);
          }
        }, u.prototype._recognize = function(o) {
          for (var n3 in Uit)
            if (Uit.hasOwnProperty(n3)) {
              var p2 = Uit[n3](this._track, o);
              if (p2)
                return p2;
            }
        }, u;
      }();
      function iM(u) {
        var o = u[1][0] - u[0][0], n3 = u[1][1] - u[0][1];
        return Math.sqrt(o * o + n3 * n3);
      }
      function k1t(u) {
        return [(u[0][0] + u[1][0]) / 2, (u[0][1] + u[1][1]) / 2];
      }
      var Uit = { pinch: function(u, o) {
        var n3 = u.length;
        if (n3) {
          var p2 = (u[n3 - 1] || {}).points, m2 = (u[n3 - 2] || {}).points || p2;
          if (m2 && m2.length > 1 && p2 && p2.length > 1) {
            var w2 = iM(p2) / iM(m2);
            !isFinite(w2) && (w2 = 1), o.pinchScale = w2;
            var T2 = k1t(p2);
            return o.pinchX = T2[0], o.pinchY = T2[1], { type: "pinch", target: u[0].target, event: o };
          }
        }
      } }, P1t = "silent";
      function W6t(u, o, n3) {
        return { type: u, event: n3, target: o.target, topTarget: o.topTarget, cancelBubble: false, offsetX: n3.zrX, offsetY: n3.zrY, gestureEvent: n3.gestureEvent, pinchX: n3.pinchX, pinchY: n3.pinchY, pinchScale: n3.pinchScale, wheelDelta: n3.zrDelta, zrByTouch: n3.zrByTouch, which: n3.which, stop: G6t };
      }
      function G6t() {
        UE(this.event);
      }
      var H6t = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.handler = null, n3;
        }
        return o.prototype.dispose = function() {
        }, o.prototype.setCursor = function() {
        }, o;
      }(gw), HA = function() {
        function u(o, n3) {
          this.x = o, this.y = n3;
        }
        return u;
      }(), xi2 = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], ao = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2) {
          var T2 = u.call(this) || this;
          return T2._hovered = new HA(0, 0), T2.storage = n3, T2.painter = p2, T2.painterRoot = w2, m2 = m2 || new H6t(), T2.proxy = null, T2.setHandlerProxy(m2), T2._draggingMgr = new N6t(T2), T2;
        }
        return o.prototype.setHandlerProxy = function(n3) {
          this.proxy && this.proxy.dispose(), n3 && (Xe2(xi2, function(p2) {
            n3.on && n3.on(p2, this[p2], this);
          }, this), n3.handler = this), this.proxy = n3;
        }, o.prototype.mousemove = function(n3) {
          var p2 = n3.zrX, m2 = n3.zrY, w2 = Vl(this, p2, m2), T2 = this._hovered, E = T2.target;
          E && !E.__zr && (T2 = this.findHover(T2.x, T2.y), E = T2.target);
          var O2 = this._hovered = w2 ? new HA(p2, m2) : this.findHover(p2, m2), V3 = O2.target, W3 = this.proxy;
          W3.setCursor && W3.setCursor(V3 ? V3.cursor : "default"), E && V3 !== E && this.dispatchToElement(T2, "mouseout", n3), this.dispatchToElement(O2, "mousemove", n3), V3 && V3 !== E && this.dispatchToElement(O2, "mouseover", n3);
        }, o.prototype.mouseout = function(n3) {
          var p2 = n3.zrEventControl;
          p2 !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", n3), p2 !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: n3 });
        }, o.prototype.resize = function() {
          this._hovered = new HA(0, 0);
        }, o.prototype.dispatch = function(n3, p2) {
          var m2 = this[n3];
          m2 && m2.call(this, p2);
        }, o.prototype.dispose = function() {
          this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
        }, o.prototype.setCursorStyle = function(n3) {
          var p2 = this.proxy;
          p2.setCursor && p2.setCursor(n3);
        }, o.prototype.dispatchToElement = function(n3, p2, m2) {
          n3 = n3 || {};
          var w2 = n3.target;
          if (!(w2 && w2.silent)) {
            for (var T2 = "on" + p2, E = W6t(p2, n3, m2); w2 && (w2[T2] && (E.cancelBubble = !!w2[T2].call(w2, E)), w2.trigger(p2, E), w2 = w2.__hostTarget ? w2.__hostTarget : w2.parent, !E.cancelBubble); )
              ;
            E.cancelBubble || (this.trigger(p2, E), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(O2) {
              typeof O2[T2] == "function" && O2[T2].call(O2, E), O2.trigger && O2.trigger(p2, E);
            }));
          }
        }, o.prototype.findHover = function(n3, p2, m2) {
          for (var w2 = this.storage.getDisplayList(), T2 = new HA(n3, p2), E = w2.length - 1; E >= 0; E--) {
            var O2 = void 0;
            if (w2[E] !== m2 && !w2[E].ignore && (O2 = Ma2(w2[E], n3, p2)) && (!T2.topTarget && (T2.topTarget = w2[E]), O2 !== P1t)) {
              T2.target = w2[E];
              break;
            }
          }
          return T2;
        }, o.prototype.processGesture = function(n3, p2) {
          this._gestureMgr || (this._gestureMgr = new SF());
          var m2 = this._gestureMgr;
          p2 === "start" && m2.clear();
          var w2 = m2.recognize(n3, this.findHover(n3.zrX, n3.zrY, null).target, this.proxy.dom);
          if (p2 === "end" && m2.clear(), w2) {
            var T2 = w2.type;
            n3.gestureEvent = T2;
            var E = new HA();
            E.target = w2.target, this.dispatchToElement(E, T2, w2.event);
          }
        }, o;
      }(gw);
      Xe2(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(u) {
        ao.prototype[u] = function(o) {
          var n3 = o.zrX, p2 = o.zrY, m2 = Vl(this, n3, p2), w2, T2;
          if ((u !== "mouseup" || !m2) && (w2 = this.findHover(n3, p2), T2 = w2.target), u === "mousedown")
            this._downEl = T2, this._downPoint = [o.zrX, o.zrY], this._upEl = T2;
          else if (u === "mouseup")
            this._upEl = T2;
          else if (u === "click") {
            if (this._downEl !== this._upEl || !this._downPoint || GE(this._downPoint, [o.zrX, o.zrY]) > 4)
              return;
            this._downPoint = null;
          }
          this.dispatchToElement(w2, u, o);
        };
      });
      function Ma2(u, o, n3) {
        if (u[u.rectHover ? "rectContain" : "contain"](o, n3)) {
          for (var p2 = u, m2 = void 0, w2 = false; p2; ) {
            if (p2.ignoreClip && (w2 = true), !w2) {
              var T2 = p2.getClipPath();
              if (T2 && !T2.contain(o, n3))
                return false;
              p2.silent && (m2 = true);
            }
            var E = p2.__hostTarget;
            p2 = E || p2.parent;
          }
          return m2 ? P1t : true;
        }
        return false;
      }
      function Vl(u, o, n3) {
        var p2 = u.painter;
        return o < 0 || o > p2.getWidth() || n3 < 0 || n3 > p2.getHeight();
      }
      var ef2 = ao, td2 = 32, a0 = 7;
      function bg2(u) {
        for (var o = 0; u >= td2; )
          o |= u & 1, u >>= 1;
        return u + o;
      }
      function WZ(u, o, n3, p2) {
        var m2 = o + 1;
        if (m2 === n3)
          return 1;
        if (p2(u[m2++], u[o]) < 0) {
          for (; m2 < n3 && p2(u[m2], u[m2 - 1]) < 0; )
            m2++;
          U6t(u, o, m2);
        } else
          for (; m2 < n3 && p2(u[m2], u[m2 - 1]) >= 0; )
            m2++;
        return m2 - o;
      }
      function U6t(u, o, n3) {
        for (n3--; o < n3; ) {
          var p2 = u[o];
          u[o++] = u[n3], u[n3--] = p2;
        }
      }
      function $S(u, o, n3, p2, m2) {
        for (p2 === o && p2++; p2 < n3; p2++) {
          for (var w2 = u[p2], T2 = o, E = p2, O2; T2 < E; )
            O2 = T2 + E >>> 1, m2(w2, u[O2]) < 0 ? E = O2 : T2 = O2 + 1;
          var V3 = p2 - T2;
          switch (V3) {
            case 3:
              u[T2 + 3] = u[T2 + 2];
            case 2:
              u[T2 + 2] = u[T2 + 1];
            case 1:
              u[T2 + 1] = u[T2];
              break;
            default:
              for (; V3 > 0; )
                u[T2 + V3] = u[T2 + V3 - 1], V3--;
          }
          u[T2] = w2;
        }
      }
      function MF(u, o, n3, p2, m2, w2) {
        var T2 = 0, E = 0, O2 = 1;
        if (w2(u, o[n3 + m2]) > 0) {
          for (E = p2 - m2; O2 < E && w2(u, o[n3 + m2 + O2]) > 0; )
            T2 = O2, O2 = (O2 << 1) + 1, O2 <= 0 && (O2 = E);
          O2 > E && (O2 = E), T2 += m2, O2 += m2;
        } else {
          for (E = m2 + 1; O2 < E && w2(u, o[n3 + m2 - O2]) <= 0; )
            T2 = O2, O2 = (O2 << 1) + 1, O2 <= 0 && (O2 = E);
          O2 > E && (O2 = E);
          var V3 = T2;
          T2 = m2 - O2, O2 = m2 - V3;
        }
        for (T2++; T2 < O2; ) {
          var W3 = T2 + (O2 - T2 >>> 1);
          w2(u, o[n3 + W3]) > 0 ? T2 = W3 + 1 : O2 = W3;
        }
        return O2;
      }
      function qit(u, o, n3, p2, m2, w2) {
        var T2 = 0, E = 0, O2 = 1;
        if (w2(u, o[n3 + m2]) < 0) {
          for (E = m2 + 1; O2 < E && w2(u, o[n3 + m2 - O2]) < 0; )
            T2 = O2, O2 = (O2 << 1) + 1, O2 <= 0 && (O2 = E);
          O2 > E && (O2 = E);
          var V3 = T2;
          T2 = m2 - O2, O2 = m2 - V3;
        } else {
          for (E = p2 - m2; O2 < E && w2(u, o[n3 + m2 + O2]) >= 0; )
            T2 = O2, O2 = (O2 << 1) + 1, O2 <= 0 && (O2 = E);
          O2 > E && (O2 = E), T2 += m2, O2 += m2;
        }
        for (T2++; T2 < O2; ) {
          var W3 = T2 + (O2 - T2 >>> 1);
          w2(u, o[n3 + W3]) < 0 ? O2 = W3 : T2 = W3 + 1;
        }
        return O2;
      }
      function CF(u, o) {
        var n3 = a0, p2, m2, w2 = 0, T2 = [];
        p2 = [], m2 = [];
        function E(J, rt2) {
          p2[w2] = J, m2[w2] = rt2, w2 += 1;
        }
        function O2() {
          for (; w2 > 1; ) {
            var J = w2 - 2;
            if (J >= 1 && m2[J - 1] <= m2[J] + m2[J + 1] || J >= 2 && m2[J - 2] <= m2[J] + m2[J - 1])
              m2[J - 1] < m2[J + 1] && J--;
            else if (m2[J] > m2[J + 1])
              break;
            W3(J);
          }
        }
        function V3() {
          for (; w2 > 1; ) {
            var J = w2 - 2;
            J > 0 && m2[J - 1] < m2[J + 1] && J--, W3(J);
          }
        }
        function W3(J) {
          var rt2 = p2[J], gt = m2[J], yt = p2[J + 1], At = m2[J + 1];
          m2[J] = gt + At, J === w2 - 3 && (p2[J + 1] = p2[J + 2], m2[J + 1] = m2[J + 2]), w2--;
          var Lt = qit(u[yt], u, rt2, gt, 0, o);
          rt2 += Lt, gt -= Lt, gt !== 0 && (At = MF(u[rt2 + gt - 1], u, yt, At, At - 1, o), At !== 0 && (gt <= At ? q3(rt2, gt, yt, At) : K(rt2, gt, yt, At)));
        }
        function q3(J, rt2, gt, yt) {
          var At = 0;
          for (At = 0; At < rt2; At++)
            T2[At] = u[J + At];
          var Lt = 0, Wt = gt, Nt = J;
          if (u[Nt++] = u[Wt++], --yt === 0) {
            for (At = 0; At < rt2; At++)
              u[Nt + At] = T2[Lt + At];
            return;
          }
          if (rt2 === 1) {
            for (At = 0; At < yt; At++)
              u[Nt + At] = u[Wt + At];
            u[Nt + yt] = T2[Lt];
            return;
          }
          for (var ue2 = n3, ie2, pe2, xe; ; ) {
            ie2 = 0, pe2 = 0, xe = false;
            do
              if (o(u[Wt], T2[Lt]) < 0) {
                if (u[Nt++] = u[Wt++], pe2++, ie2 = 0, --yt === 0) {
                  xe = true;
                  break;
                }
              } else if (u[Nt++] = T2[Lt++], ie2++, pe2 = 0, --rt2 === 1) {
                xe = true;
                break;
              }
            while ((ie2 | pe2) < ue2);
            if (xe)
              break;
            do {
              if (ie2 = qit(u[Wt], T2, Lt, rt2, 0, o), ie2 !== 0) {
                for (At = 0; At < ie2; At++)
                  u[Nt + At] = T2[Lt + At];
                if (Nt += ie2, Lt += ie2, rt2 -= ie2, rt2 <= 1) {
                  xe = true;
                  break;
                }
              }
              if (u[Nt++] = u[Wt++], --yt === 0) {
                xe = true;
                break;
              }
              if (pe2 = MF(T2[Lt], u, Wt, yt, 0, o), pe2 !== 0) {
                for (At = 0; At < pe2; At++)
                  u[Nt + At] = u[Wt + At];
                if (Nt += pe2, Wt += pe2, yt -= pe2, yt === 0) {
                  xe = true;
                  break;
                }
              }
              if (u[Nt++] = T2[Lt++], --rt2 === 1) {
                xe = true;
                break;
              }
              ue2--;
            } while (ie2 >= a0 || pe2 >= a0);
            if (xe)
              break;
            ue2 < 0 && (ue2 = 0), ue2 += 2;
          }
          if (n3 = ue2, n3 < 1 && (n3 = 1), rt2 === 1) {
            for (At = 0; At < yt; At++)
              u[Nt + At] = u[Wt + At];
            u[Nt + yt] = T2[Lt];
          } else {
            if (rt2 === 0)
              throw new Error();
            for (At = 0; At < rt2; At++)
              u[Nt + At] = T2[Lt + At];
          }
        }
        function K(J, rt2, gt, yt) {
          var At = 0;
          for (At = 0; At < yt; At++)
            T2[At] = u[gt + At];
          var Lt = J + rt2 - 1, Wt = yt - 1, Nt = gt + yt - 1, ue2 = 0, ie2 = 0;
          if (u[Nt--] = u[Lt--], --rt2 === 0) {
            for (ue2 = Nt - (yt - 1), At = 0; At < yt; At++)
              u[ue2 + At] = T2[At];
            return;
          }
          if (yt === 1) {
            for (Nt -= rt2, Lt -= rt2, ie2 = Nt + 1, ue2 = Lt + 1, At = rt2 - 1; At >= 0; At--)
              u[ie2 + At] = u[ue2 + At];
            u[Nt] = T2[Wt];
            return;
          }
          for (var pe2 = n3; ; ) {
            var xe = 0, Ce2 = 0, Le2 = false;
            do
              if (o(T2[Wt], u[Lt]) < 0) {
                if (u[Nt--] = u[Lt--], xe++, Ce2 = 0, --rt2 === 0) {
                  Le2 = true;
                  break;
                }
              } else if (u[Nt--] = T2[Wt--], Ce2++, xe = 0, --yt === 1) {
                Le2 = true;
                break;
              }
            while ((xe | Ce2) < pe2);
            if (Le2)
              break;
            do {
              if (xe = rt2 - qit(T2[Wt], u, J, rt2, rt2 - 1, o), xe !== 0) {
                for (Nt -= xe, Lt -= xe, rt2 -= xe, ie2 = Nt + 1, ue2 = Lt + 1, At = xe - 1; At >= 0; At--)
                  u[ie2 + At] = u[ue2 + At];
                if (rt2 === 0) {
                  Le2 = true;
                  break;
                }
              }
              if (u[Nt--] = T2[Wt--], --yt === 1) {
                Le2 = true;
                break;
              }
              if (Ce2 = yt - MF(u[Lt], T2, 0, yt, yt - 1, o), Ce2 !== 0) {
                for (Nt -= Ce2, Wt -= Ce2, yt -= Ce2, ie2 = Nt + 1, ue2 = Wt + 1, At = 0; At < Ce2; At++)
                  u[ie2 + At] = T2[ue2 + At];
                if (yt <= 1) {
                  Le2 = true;
                  break;
                }
              }
              if (u[Nt--] = u[Lt--], --rt2 === 0) {
                Le2 = true;
                break;
              }
              pe2--;
            } while (xe >= a0 || Ce2 >= a0);
            if (Le2)
              break;
            pe2 < 0 && (pe2 = 0), pe2 += 2;
          }
          if (n3 = pe2, n3 < 1 && (n3 = 1), yt === 1) {
            for (Nt -= rt2, Lt -= rt2, ie2 = Nt + 1, ue2 = Lt + 1, At = rt2 - 1; At >= 0; At--)
              u[ie2 + At] = u[ue2 + At];
            u[Nt] = T2[Wt];
          } else {
            if (yt === 0)
              throw new Error();
            for (ue2 = Nt - (yt - 1), At = 0; At < yt; At++)
              u[ue2 + At] = T2[At];
          }
        }
        return { mergeRuns: O2, forceMergeRuns: V3, pushRun: E };
      }
      function UO(u, o, n3, p2) {
        n3 || (n3 = 0), p2 || (p2 = u.length);
        var m2 = p2 - n3;
        if (!(m2 < 2)) {
          var w2 = 0;
          if (m2 < td2) {
            w2 = WZ(u, n3, p2, o), $S(u, n3, p2, n3 + w2, o);
            return;
          }
          var T2 = CF(u, o), E = bg2(m2);
          do {
            if (w2 = WZ(u, n3, p2, o), w2 < E) {
              var O2 = m2;
              O2 > E && (O2 = E), $S(u, n3, n3 + O2, n3 + w2, o), w2 = O2;
            }
            T2.pushRun(n3, w2), T2.mergeRuns(), m2 -= w2, n3 += w2;
          } while (m2 !== 0);
          T2.forceMergeRuns();
        }
      }
      var Ab2 = 1, Vp = 2, TF = 4, Zit = false;
      function AF() {
        Zit || (Zit = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
      }
      function L1t(u, o) {
        return u.zlevel === o.zlevel ? u.z === o.z ? u.z2 - o.z2 : u.z - o.z : u.zlevel - o.zlevel;
      }
      var q6t = function() {
        function u() {
          this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = L1t;
        }
        return u.prototype.traverse = function(o, n3) {
          for (var p2 = 0; p2 < this._roots.length; p2++)
            this._roots[p2].traverse(o, n3);
        }, u.prototype.getDisplayList = function(o, n3) {
          n3 = n3 || false;
          var p2 = this._displayList;
          return (o || !p2.length) && this.updateDisplayList(n3), p2;
        }, u.prototype.updateDisplayList = function(o) {
          this._displayListLen = 0;
          for (var n3 = this._roots, p2 = this._displayList, m2 = 0, w2 = n3.length; m2 < w2; m2++)
            this._updateAndAddDisplayable(n3[m2], null, o);
          p2.length = this._displayListLen, UO(p2, L1t);
        }, u.prototype._updateAndAddDisplayable = function(o, n3, p2) {
          if (!(o.ignore && !p2)) {
            o.beforeUpdate(), o.update(), o.afterUpdate();
            var m2 = o.getClipPath();
            if (o.ignoreClip)
              n3 = null;
            else if (m2) {
              n3 ? n3 = n3.slice() : n3 = [];
              for (var w2 = m2, T2 = o; w2; )
                w2.parent = T2, w2.updateTransform(), n3.push(w2), T2 = w2, w2 = w2.getClipPath();
            }
            if (o.childrenRef) {
              for (var E = o.childrenRef(), O2 = 0; O2 < E.length; O2++) {
                var V3 = E[O2];
                o.__dirty && (V3.__dirty |= Ab2), this._updateAndAddDisplayable(V3, n3, p2);
              }
              o.__dirty = 0;
            } else {
              var W3 = o;
              n3 && n3.length ? W3.__clipPaths = n3 : W3.__clipPaths && W3.__clipPaths.length > 0 && (W3.__clipPaths = []), isNaN(W3.z) && (AF(), W3.z = 0), isNaN(W3.z2) && (AF(), W3.z2 = 0), isNaN(W3.zlevel) && (AF(), W3.zlevel = 0), this._displayList[this._displayListLen++] = W3;
            }
            var q3 = o.getDecalElement && o.getDecalElement();
            q3 && this._updateAndAddDisplayable(q3, n3, p2);
            var K = o.getTextGuideLine();
            K && this._updateAndAddDisplayable(K, n3, p2);
            var J = o.getTextContent();
            J && this._updateAndAddDisplayable(J, n3, p2);
          }
        }, u.prototype.addRoot = function(o) {
          o.__zr && o.__zr.storage === this || this._roots.push(o);
        }, u.prototype.delRoot = function(o) {
          if (o instanceof Array) {
            for (var n3 = 0, p2 = o.length; n3 < p2; n3++)
              this.delRoot(o[n3]);
            return;
          }
          var m2 = sc2(this._roots, o);
          m2 >= 0 && this._roots.splice(m2, 1);
        }, u.prototype.delAllRoots = function() {
          this._roots = [], this._displayList = [], this._displayListLen = 0;
        }, u.prototype.getRoots = function() {
          return this._roots;
        }, u.prototype.dispose = function() {
          this._displayList = null, this._roots = null;
        }, u;
      }(), Z6t = q6t, UB;
      UB = Ys.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(u) {
        return setTimeout(u, 16);
      };
      var UA = UB, qO = { linear: function(u) {
        return u;
      }, quadraticIn: function(u) {
        return u * u;
      }, quadraticOut: function(u) {
        return u * (2 - u);
      }, quadraticInOut: function(u) {
        return (u *= 2) < 1 ? 0.5 * u * u : -0.5 * (--u * (u - 2) - 1);
      }, cubicIn: function(u) {
        return u * u * u;
      }, cubicOut: function(u) {
        return --u * u * u + 1;
      }, cubicInOut: function(u) {
        return (u *= 2) < 1 ? 0.5 * u * u * u : 0.5 * ((u -= 2) * u * u + 2);
      }, quarticIn: function(u) {
        return u * u * u * u;
      }, quarticOut: function(u) {
        return 1 - --u * u * u * u;
      }, quarticInOut: function(u) {
        return (u *= 2) < 1 ? 0.5 * u * u * u * u : -0.5 * ((u -= 2) * u * u * u - 2);
      }, quinticIn: function(u) {
        return u * u * u * u * u;
      }, quinticOut: function(u) {
        return --u * u * u * u * u + 1;
      }, quinticInOut: function(u) {
        return (u *= 2) < 1 ? 0.5 * u * u * u * u * u : 0.5 * ((u -= 2) * u * u * u * u + 2);
      }, sinusoidalIn: function(u) {
        return 1 - Math.cos(u * Math.PI / 2);
      }, sinusoidalOut: function(u) {
        return Math.sin(u * Math.PI / 2);
      }, sinusoidalInOut: function(u) {
        return 0.5 * (1 - Math.cos(Math.PI * u));
      }, exponentialIn: function(u) {
        return u === 0 ? 0 : Math.pow(1024, u - 1);
      }, exponentialOut: function(u) {
        return u === 1 ? 1 : 1 - Math.pow(2, -10 * u);
      }, exponentialInOut: function(u) {
        return u === 0 ? 0 : u === 1 ? 1 : (u *= 2) < 1 ? 0.5 * Math.pow(1024, u - 1) : 0.5 * (-Math.pow(2, -10 * (u - 1)) + 2);
      }, circularIn: function(u) {
        return 1 - Math.sqrt(1 - u * u);
      }, circularOut: function(u) {
        return Math.sqrt(1 - --u * u);
      }, circularInOut: function(u) {
        return (u *= 2) < 1 ? -0.5 * (Math.sqrt(1 - u * u) - 1) : 0.5 * (Math.sqrt(1 - (u -= 2) * u) + 1);
      }, elasticIn: function(u) {
        var o, n3 = 0.1, p2 = 0.4;
        return u === 0 ? 0 : u === 1 ? 1 : (!n3 || n3 < 1 ? (n3 = 1, o = p2 / 4) : o = p2 * Math.asin(1 / n3) / (2 * Math.PI), -(n3 * Math.pow(2, 10 * (u -= 1)) * Math.sin((u - o) * (2 * Math.PI) / p2)));
      }, elasticOut: function(u) {
        var o, n3 = 0.1, p2 = 0.4;
        return u === 0 ? 0 : u === 1 ? 1 : (!n3 || n3 < 1 ? (n3 = 1, o = p2 / 4) : o = p2 * Math.asin(1 / n3) / (2 * Math.PI), n3 * Math.pow(2, -10 * u) * Math.sin((u - o) * (2 * Math.PI) / p2) + 1);
      }, elasticInOut: function(u) {
        var o, n3 = 0.1, p2 = 0.4;
        return u === 0 ? 0 : u === 1 ? 1 : (!n3 || n3 < 1 ? (n3 = 1, o = p2 / 4) : o = p2 * Math.asin(1 / n3) / (2 * Math.PI), (u *= 2) < 1 ? -0.5 * (n3 * Math.pow(2, 10 * (u -= 1)) * Math.sin((u - o) * (2 * Math.PI) / p2)) : n3 * Math.pow(2, -10 * (u -= 1)) * Math.sin((u - o) * (2 * Math.PI) / p2) * 0.5 + 1);
      }, backIn: function(u) {
        var o = 1.70158;
        return u * u * ((o + 1) * u - o);
      }, backOut: function(u) {
        var o = 1.70158;
        return --u * u * ((o + 1) * u + o) + 1;
      }, backInOut: function(u) {
        var o = 2.5949095;
        return (u *= 2) < 1 ? 0.5 * (u * u * ((o + 1) * u - o)) : 0.5 * ((u -= 2) * u * ((o + 1) * u + o) + 2);
      }, bounceIn: function(u) {
        return 1 - qO.bounceOut(1 - u);
      }, bounceOut: function(u) {
        return u < 1 / 2.75 ? 7.5625 * u * u : u < 2 / 2.75 ? 7.5625 * (u -= 1.5 / 2.75) * u + 0.75 : u < 2.5 / 2.75 ? 7.5625 * (u -= 2.25 / 2.75) * u + 0.9375 : 7.5625 * (u -= 2.625 / 2.75) * u + 0.984375;
      }, bounceInOut: function(u) {
        return u < 0.5 ? qO.bounceIn(u * 2) * 0.5 : qO.bounceOut(u * 2 - 1) * 0.5 + 0.5;
      } }, $it = qO, ZO = Math.pow, qE = Math.sqrt, qB = 1e-8, ZB = 1e-4, Yit = qE(3), xP = 1 / 3, Ib2 = mP(), U_ = mP(), IF = mP();
      function wP(u) {
        return u > -qB && u < qB;
      }
      function O1t(u) {
        return u > qB || u < -qB;
      }
      function S0(u, o, n3, p2, m2) {
        var w2 = 1 - m2;
        return w2 * w2 * (w2 * u + 3 * m2 * o) + m2 * m2 * (m2 * p2 + 3 * w2 * n3);
      }
      function $B(u, o, n3, p2, m2) {
        var w2 = 1 - m2;
        return 3 * (((o - u) * w2 + 2 * (n3 - o) * m2) * w2 + (p2 - n3) * m2 * m2);
      }
      function DF(u, o, n3, p2, m2, w2) {
        var T2 = p2 + 3 * (o - n3) - u, E = 3 * (n3 - o * 2 + u), O2 = 3 * (o - u), V3 = u - m2, W3 = E * E - 3 * T2 * O2, q3 = E * O2 - 9 * T2 * V3, K = O2 * O2 - 3 * E * V3, J = 0;
        if (wP(W3) && wP(q3))
          if (wP(E))
            w2[0] = 0;
          else {
            var rt2 = -O2 / E;
            rt2 >= 0 && rt2 <= 1 && (w2[J++] = rt2);
          }
        else {
          var gt = q3 * q3 - 4 * W3 * K;
          if (wP(gt)) {
            var yt = q3 / W3, rt2 = -E / T2 + yt, At = -yt / 2;
            rt2 >= 0 && rt2 <= 1 && (w2[J++] = rt2), At >= 0 && At <= 1 && (w2[J++] = At);
          } else if (gt > 0) {
            var Lt = qE(gt), Wt = W3 * E + 1.5 * T2 * (-q3 + Lt), Nt = W3 * E + 1.5 * T2 * (-q3 - Lt);
            Wt < 0 ? Wt = -ZO(-Wt, xP) : Wt = ZO(Wt, xP), Nt < 0 ? Nt = -ZO(-Nt, xP) : Nt = ZO(Nt, xP);
            var rt2 = (-E - (Wt + Nt)) / (3 * T2);
            rt2 >= 0 && rt2 <= 1 && (w2[J++] = rt2);
          } else {
            var ue2 = (2 * W3 * E - 3 * T2 * q3) / (2 * qE(W3 * W3 * W3)), ie2 = Math.acos(ue2) / 3, pe2 = qE(W3), xe = Math.cos(ie2), rt2 = (-E - 2 * pe2 * xe) / (3 * T2), At = (-E + pe2 * (xe + Yit * Math.sin(ie2))) / (3 * T2), Ce2 = (-E + pe2 * (xe - Yit * Math.sin(ie2))) / (3 * T2);
            rt2 >= 0 && rt2 <= 1 && (w2[J++] = rt2), At >= 0 && At <= 1 && (w2[J++] = At), Ce2 >= 0 && Ce2 <= 1 && (w2[J++] = Ce2);
          }
        }
        return J;
      }
      function R1t(u, o, n3, p2, m2) {
        var w2 = 6 * n3 - 12 * o + 6 * u, T2 = 9 * o + 3 * p2 - 3 * u - 9 * n3, E = 3 * o - 3 * u, O2 = 0;
        if (wP(T2)) {
          if (O1t(w2)) {
            var V3 = -E / w2;
            V3 >= 0 && V3 <= 1 && (m2[O2++] = V3);
          }
        } else {
          var W3 = w2 * w2 - 4 * T2 * E;
          if (wP(W3))
            m2[0] = -w2 / (2 * T2);
          else if (W3 > 0) {
            var q3 = qE(W3), V3 = (-w2 + q3) / (2 * T2), K = (-w2 - q3) / (2 * T2);
            V3 >= 0 && V3 <= 1 && (m2[O2++] = V3), K >= 0 && K <= 1 && (m2[O2++] = K);
          }
        }
        return O2;
      }
      function ZE(u, o, n3, p2, m2, w2) {
        var T2 = (o - u) * m2 + u, E = (n3 - o) * m2 + o, O2 = (p2 - n3) * m2 + n3, V3 = (E - T2) * m2 + T2, W3 = (O2 - E) * m2 + E, q3 = (W3 - V3) * m2 + V3;
        w2[0] = u, w2[1] = T2, w2[2] = V3, w2[3] = q3, w2[4] = q3, w2[5] = W3, w2[6] = O2, w2[7] = p2;
      }
      function N1t(u, o, n3, p2, m2, w2, T2, E, O2, V3, W3) {
        var q3, K = 5e-3, J = 1 / 0, rt2, gt, yt, At;
        Ib2[0] = O2, Ib2[1] = V3;
        for (var Lt = 0; Lt < 1; Lt += 0.05)
          U_[0] = S0(u, n3, m2, T2, Lt), U_[1] = S0(o, p2, w2, E, Lt), yt = rM(Ib2, U_), yt < J && (q3 = Lt, J = yt);
        J = 1 / 0;
        for (var Wt = 0; Wt < 32 && !(K < ZB); Wt++)
          rt2 = q3 - K, gt = q3 + K, U_[0] = S0(u, n3, m2, T2, rt2), U_[1] = S0(o, p2, w2, E, rt2), yt = rM(U_, Ib2), rt2 >= 0 && yt < J ? (q3 = rt2, J = yt) : (IF[0] = S0(u, n3, m2, T2, gt), IF[1] = S0(o, p2, w2, E, gt), At = rM(IF, Ib2), gt <= 1 && At < J ? (q3 = gt, J = At) : K *= 0.5);
        return W3 && (W3[0] = S0(u, n3, m2, T2, q3), W3[1] = S0(o, p2, w2, E, q3)), qE(J);
      }
      function $6t(u, o, n3, p2, m2, w2, T2, E, O2) {
        for (var V3 = u, W3 = o, q3 = 0, K = 1 / O2, J = 1; J <= O2; J++) {
          var rt2 = J * K, gt = S0(u, n3, m2, T2, rt2), yt = S0(o, p2, w2, E, rt2), At = gt - V3, Lt = yt - W3;
          q3 += Math.sqrt(At * At + Lt * Lt), V3 = gt, W3 = yt;
        }
        return q3;
      }
      function lp(u, o, n3, p2) {
        var m2 = 1 - p2;
        return m2 * (m2 * u + 2 * p2 * o) + p2 * p2 * n3;
      }
      function Om(u, o, n3, p2) {
        return 2 * ((1 - p2) * (o - u) + p2 * (n3 - o));
      }
      function Y6t(u, o, n3, p2, m2) {
        var w2 = u - 2 * o + n3, T2 = 2 * (o - u), E = u - p2, O2 = 0;
        if (wP(w2)) {
          if (O1t(T2)) {
            var V3 = -E / T2;
            V3 >= 0 && V3 <= 1 && (m2[O2++] = V3);
          }
        } else {
          var W3 = T2 * T2 - 4 * w2 * E;
          if (wP(W3)) {
            var V3 = -T2 / (2 * w2);
            V3 >= 0 && V3 <= 1 && (m2[O2++] = V3);
          } else if (W3 > 0) {
            var q3 = qE(W3), V3 = (-T2 + q3) / (2 * w2), K = (-T2 - q3) / (2 * w2);
            V3 >= 0 && V3 <= 1 && (m2[O2++] = V3), K >= 0 && K <= 1 && (m2[O2++] = K);
          }
        }
        return O2;
      }
      function F1t(u, o, n3) {
        var p2 = u + n3 - 2 * o;
        return p2 === 0 ? 0.5 : (u - o) / p2;
      }
      function EF(u, o, n3, p2, m2) {
        var w2 = (o - u) * p2 + u, T2 = (n3 - o) * p2 + o, E = (T2 - w2) * p2 + w2;
        m2[0] = u, m2[1] = w2, m2[2] = E, m2[3] = E, m2[4] = T2, m2[5] = n3;
      }
      function V1t(u, o, n3, p2, m2, w2, T2, E, O2) {
        var V3, W3 = 5e-3, q3 = 1 / 0;
        Ib2[0] = T2, Ib2[1] = E;
        for (var K = 0; K < 1; K += 0.05) {
          U_[0] = lp(u, n3, m2, K), U_[1] = lp(o, p2, w2, K);
          var J = rM(Ib2, U_);
          J < q3 && (V3 = K, q3 = J);
        }
        q3 = 1 / 0;
        for (var rt2 = 0; rt2 < 32 && !(W3 < ZB); rt2++) {
          var gt = V3 - W3, yt = V3 + W3;
          U_[0] = lp(u, n3, m2, gt), U_[1] = lp(o, p2, w2, gt);
          var J = rM(U_, Ib2);
          if (gt >= 0 && J < q3)
            V3 = gt, q3 = J;
          else {
            IF[0] = lp(u, n3, m2, yt), IF[1] = lp(o, p2, w2, yt);
            var At = rM(IF, Ib2);
            yt <= 1 && At < q3 ? (V3 = yt, q3 = At) : W3 *= 0.5;
          }
        }
        return O2 && (O2[0] = lp(u, n3, m2, V3), O2[1] = lp(o, p2, w2, V3)), qE(q3);
      }
      function Kit(u, o, n3, p2, m2, w2, T2) {
        for (var E = u, O2 = o, V3 = 0, W3 = 1 / T2, q3 = 1; q3 <= T2; q3++) {
          var K = q3 * W3, J = lp(u, n3, m2, K), rt2 = lp(o, p2, w2, K), gt = J - E, yt = rt2 - O2;
          V3 += Math.sqrt(gt * gt + yt * yt), E = J, O2 = rt2;
        }
        return V3;
      }
      var YB = /cubic-bezier\(([0-9,\.e ]+)\)/;
      function KB(u) {
        var o = u && YB.exec(u);
        if (o) {
          var n3 = o[1].split(","), p2 = +US(n3[0]), m2 = +US(n3[1]), w2 = +US(n3[2]), T2 = +US(n3[3]);
          if (isNaN(p2 + m2 + w2 + T2))
            return;
          var E = [];
          return function(O2) {
            return O2 <= 0 ? 0 : O2 >= 1 ? 1 : DF(0, p2, w2, 1, O2, E) && S0(0, m2, T2, 1, E[0]);
          };
        }
      }
      var kF = function() {
        function u(o) {
          this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = o.life || 1e3, this._delay = o.delay || 0, this.loop = o.loop || false, this.onframe = o.onframe || Jp, this.ondestroy = o.ondestroy || Jp, this.onrestart = o.onrestart || Jp, o.easing && this.setEasing(o.easing);
        }
        return u.prototype.step = function(o, n3) {
          if (this._inited || (this._startTime = o + this._delay, this._inited = true), this._paused) {
            this._pausedTime += n3;
            return;
          }
          var p2 = this._life, m2 = o - this._startTime - this._pausedTime, w2 = m2 / p2;
          w2 < 0 && (w2 = 0), w2 = Math.min(w2, 1);
          var T2 = this.easingFunc, E = T2 ? T2(w2) : w2;
          if (this.onframe(E), w2 === 1)
            if (this.loop) {
              var O2 = m2 % p2;
              this._startTime = o - O2, this._pausedTime = 0, this.onrestart();
            } else
              return true;
          return false;
        }, u.prototype.pause = function() {
          this._paused = true;
        }, u.prototype.resume = function() {
          this._paused = false;
        }, u.prototype.setEasing = function(o) {
          this.easing = o, this.easingFunc = Sl(o) ? o : $it[o] || KB(o);
        }, u;
      }(), XB = kF, PF = function() {
        function u(o) {
          this.value = o;
        }
        return u;
      }(), GZ = function() {
        function u() {
          this._len = 0;
        }
        return u.prototype.insert = function(o) {
          var n3 = new PF(o);
          return this.insertEntry(n3), n3;
        }, u.prototype.insertEntry = function(o) {
          this.head ? (this.tail.next = o, o.prev = this.tail, o.next = null, this.tail = o) : this.head = this.tail = o, this._len++;
        }, u.prototype.remove = function(o) {
          var n3 = o.prev, p2 = o.next;
          n3 ? n3.next = p2 : this.head = p2, p2 ? p2.prev = n3 : this.tail = n3, o.next = o.prev = null, this._len--;
        }, u.prototype.len = function() {
          return this._len;
        }, u.prototype.clear = function() {
          this.head = this.tail = null, this._len = 0;
        }, u;
      }(), LF = function() {
        function u(o) {
          this._list = new GZ(), this._maxSize = 10, this._map = {}, this._maxSize = o;
        }
        return u.prototype.put = function(o, n3) {
          var p2 = this._list, m2 = this._map, w2 = null;
          if (m2[o] == null) {
            var T2 = p2.len(), E = this._lastRemovedEntry;
            if (T2 >= this._maxSize && T2 > 0) {
              var O2 = p2.head;
              p2.remove(O2), delete m2[O2.key], w2 = O2.value, this._lastRemovedEntry = O2;
            }
            E ? E.value = n3 : E = new PF(n3), E.key = o, p2.insertEntry(E), m2[o] = E;
          }
          return w2;
        }, u.prototype.get = function(o) {
          var n3 = this._map[o], p2 = this._list;
          if (n3 != null)
            return n3 !== p2.tail && (p2.remove(n3), p2.insertEntry(n3)), n3.value;
        }, u.prototype.clear = function() {
          this._list.clear(), this._map = {};
        }, u.prototype.len = function() {
          return this._list.len();
        }, u;
      }(), QB = LF, B1t = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
      function MC(u) {
        return u = Math.round(u), u < 0 ? 0 : u > 255 ? 255 : u;
      }
      function K6t(u) {
        return u = Math.round(u), u < 0 ? 0 : u > 360 ? 360 : u;
      }
      function JB(u) {
        return u < 0 ? 0 : u > 1 ? 1 : u;
      }
      function OF(u) {
        var o = u;
        return o.length && o.charAt(o.length - 1) === "%" ? MC(parseFloat(o) / 100 * 255) : MC(parseInt(o, 10));
      }
      function qA(u) {
        var o = u;
        return o.length && o.charAt(o.length - 1) === "%" ? JB(parseFloat(o) / 100) : JB(parseFloat(o));
      }
      function HZ(u, o, n3) {
        return n3 < 0 ? n3 += 1 : n3 > 1 && (n3 -= 1), n3 * 6 < 1 ? u + (o - u) * n3 * 6 : n3 * 2 < 1 ? o : n3 * 3 < 2 ? u + (o - u) * (2 / 3 - n3) * 6 : u;
      }
      function Dn(u, o, n3) {
        return u + (o - u) * n3;
      }
      function C1(u, o, n3, p2, m2) {
        return u[0] = o, u[1] = n3, u[2] = p2, u[3] = m2, u;
      }
      function RF(u, o) {
        return u[0] = o[0], u[1] = o[1], u[2] = o[2], u[3] = o[3], u;
      }
      var YS = new QB(20), oh2 = null;
      function NF(u, o) {
        oh2 && RF(oh2, o), oh2 = YS.put(u, oh2 || o.slice());
      }
      function KS(u, o) {
        if (u) {
          o = o || [];
          var n3 = YS.get(u);
          if (n3)
            return RF(o, n3);
          u = u + "";
          var p2 = u.replace(/ /g, "").toLowerCase();
          if (p2 in B1t)
            return RF(o, B1t[p2]), NF(u, o), o;
          var m2 = p2.length;
          if (p2.charAt(0) === "#") {
            if (m2 === 4 || m2 === 5) {
              var w2 = parseInt(p2.slice(1, 4), 16);
              if (!(w2 >= 0 && w2 <= 4095)) {
                C1(o, 0, 0, 0, 1);
                return;
              }
              return C1(o, (w2 & 3840) >> 4 | (w2 & 3840) >> 8, w2 & 240 | (w2 & 240) >> 4, w2 & 15 | (w2 & 15) << 4, m2 === 5 ? parseInt(p2.slice(4), 16) / 15 : 1), NF(u, o), o;
            } else if (m2 === 7 || m2 === 9) {
              var w2 = parseInt(p2.slice(1, 7), 16);
              if (!(w2 >= 0 && w2 <= 16777215)) {
                C1(o, 0, 0, 0, 1);
                return;
              }
              return C1(o, (w2 & 16711680) >> 16, (w2 & 65280) >> 8, w2 & 255, m2 === 9 ? parseInt(p2.slice(7), 16) / 255 : 1), NF(u, o), o;
            }
            return;
          }
          var T2 = p2.indexOf("("), E = p2.indexOf(")");
          if (T2 !== -1 && E + 1 === m2) {
            var O2 = p2.substr(0, T2), V3 = p2.substr(T2 + 1, E - (T2 + 1)).split(","), W3 = 1;
            switch (O2) {
              case "rgba":
                if (V3.length !== 4)
                  return V3.length === 3 ? C1(o, +V3[0], +V3[1], +V3[2], 1) : C1(o, 0, 0, 0, 1);
                W3 = qA(V3.pop());
              case "rgb":
                if (V3.length !== 3) {
                  C1(o, 0, 0, 0, 1);
                  return;
                }
                return C1(o, OF(V3[0]), OF(V3[1]), OF(V3[2]), W3), NF(u, o), o;
              case "hsla":
                if (V3.length !== 4) {
                  C1(o, 0, 0, 0, 1);
                  return;
                }
                return V3[3] = qA(V3[3]), Xit(V3, o), NF(u, o), o;
              case "hsl":
                if (V3.length !== 3) {
                  C1(o, 0, 0, 0, 1);
                  return;
                }
                return Xit(V3, o), NF(u, o), o;
              default:
                return;
            }
          }
          C1(o, 0, 0, 0, 1);
        }
      }
      function Xit(u, o) {
        var n3 = (parseFloat(u[0]) % 360 + 360) % 360 / 360, p2 = qA(u[1]), m2 = qA(u[2]), w2 = m2 <= 0.5 ? m2 * (p2 + 1) : m2 + p2 - m2 * p2, T2 = m2 * 2 - w2;
        return o = o || [], C1(o, MC(HZ(T2, w2, n3 + 1 / 3) * 255), MC(HZ(T2, w2, n3) * 255), MC(HZ(T2, w2, n3 - 1 / 3) * 255), 1), u.length === 4 && (o[3] = u[3]), o;
      }
      function $O(u) {
        if (u) {
          var o = u[0] / 255, n3 = u[1] / 255, p2 = u[2] / 255, m2 = Math.min(o, n3, p2), w2 = Math.max(o, n3, p2), T2 = w2 - m2, E = (w2 + m2) / 2, O2, V3;
          if (T2 === 0)
            O2 = 0, V3 = 0;
          else {
            E < 0.5 ? V3 = T2 / (w2 + m2) : V3 = T2 / (2 - w2 - m2);
            var W3 = ((w2 - o) / 6 + T2 / 2) / T2, q3 = ((w2 - n3) / 6 + T2 / 2) / T2, K = ((w2 - p2) / 6 + T2 / 2) / T2;
            o === w2 ? O2 = K - q3 : n3 === w2 ? O2 = 1 / 3 + W3 - K : p2 === w2 && (O2 = 2 / 3 + q3 - W3), O2 < 0 && (O2 += 1), O2 > 1 && (O2 -= 1);
          }
          var J = [O2 * 360, V3, E];
          return u[3] != null && J.push(u[3]), J;
        }
      }
      function Qit(u, o) {
        var n3 = KS(u);
        if (n3) {
          for (var p2 = 0; p2 < 3; p2++)
            o < 0 ? n3[p2] = n3[p2] * (1 - o) | 0 : n3[p2] = (255 - n3[p2]) * o + n3[p2] | 0, n3[p2] > 255 ? n3[p2] = 255 : n3[p2] < 0 && (n3[p2] = 0);
          return T1(n3, n3.length === 4 ? "rgba" : "rgb");
        }
      }
      function Jit(u, o, n3) {
        if (!(!(o && o.length) || !(u >= 0 && u <= 1))) {
          n3 = n3 || [];
          var p2 = u * (o.length - 1), m2 = Math.floor(p2), w2 = Math.ceil(p2), T2 = o[m2], E = o[w2], O2 = p2 - m2;
          return n3[0] = MC(Dn(T2[0], E[0], O2)), n3[1] = MC(Dn(T2[1], E[1], O2)), n3[2] = MC(Dn(T2[2], E[2], O2)), n3[3] = JB(Dn(T2[3], E[3], O2)), n3;
        }
      }
      function X6t(u, o, n3) {
        if (!(!(o && o.length) || !(u >= 0 && u <= 1))) {
          var p2 = u * (o.length - 1), m2 = Math.floor(p2), w2 = Math.ceil(p2), T2 = KS(o[m2]), E = KS(o[w2]), O2 = p2 - m2, V3 = T1([MC(Dn(T2[0], E[0], O2)), MC(Dn(T2[1], E[1], O2)), MC(Dn(T2[2], E[2], O2)), JB(Dn(T2[3], E[3], O2))], "rgba");
          return n3 ? { color: V3, leftIndex: m2, rightIndex: w2, value: p2 } : V3;
        }
      }
      function tz(u, o, n3, p2) {
        var m2 = KS(u);
        if (u)
          return m2 = $O(m2), o != null && (m2[0] = K6t(o)), n3 != null && (m2[1] = qA(n3)), p2 != null && (m2[2] = qA(p2)), T1(Xit(m2), "rgba");
      }
      function UZ(u, o) {
        var n3 = KS(u);
        if (n3 && o != null)
          return n3[3] = JB(o), T1(n3, "rgba");
      }
      function T1(u, o) {
        if (!(!u || !u.length)) {
          var n3 = u[0] + "," + u[1] + "," + u[2];
          return (o === "rgba" || o === "hsva" || o === "hsla") && (n3 += "," + u[3]), o + "(" + n3 + ")";
        }
      }
      function qZ(u, o) {
        var n3 = KS(u);
        return n3 ? (0.299 * n3[0] + 0.587 * n3[1] + 0.114 * n3[2]) * n3[3] / 255 + (1 - n3[3]) * o : 0;
      }
      var ZZ = Math.round;
      function FF(u) {
        var o;
        if (!u || u === "transparent")
          u = "none";
        else if (typeof u == "string" && u.indexOf("rgba") > -1) {
          var n3 = KS(u);
          n3 && (u = "rgb(" + n3[0] + "," + n3[1] + "," + n3[2] + ")", o = n3[3]);
        }
        return { color: u, opacity: o == null ? 1 : o };
      }
      var z1t = 1e-4;
      function SP(u) {
        return u < z1t && u > -z1t;
      }
      function aM(u) {
        return ZZ(u * 1e3) / 1e3;
      }
      function tat(u) {
        return ZZ(u * 1e4) / 1e4;
      }
      function Q6t(u) {
        return "matrix(" + aM(u[0]) + "," + aM(u[1]) + "," + aM(u[2]) + "," + aM(u[3]) + "," + tat(u[4]) + "," + tat(u[5]) + ")";
      }
      var J6t = { left: "start", right: "end", center: "middle", middle: "middle" };
      function tNt(u, o, n3) {
        return n3 === "top" ? u += o / 2 : n3 === "bottom" && (u -= o / 2), u;
      }
      function eNt(u) {
        return u && (u.shadowBlur || u.shadowOffsetX || u.shadowOffsetY);
      }
      function YO(u) {
        var o = u.style, n3 = u.getGlobalScale();
        return [o.shadowColor, (o.shadowBlur || 0).toFixed(2), (o.shadowOffsetX || 0).toFixed(2), (o.shadowOffsetY || 0).toFixed(2), n3[0], n3[1]].join(",");
      }
      function j1t(u) {
        return u && !!u.image;
      }
      function nNt(u) {
        return u && !!u.svgElement;
      }
      function CC(u) {
        return j1t(u) || nNt(u);
      }
      function W1t(u) {
        return u.type === "linear";
      }
      function G1t(u) {
        return u.type === "radial";
      }
      function rNt(u) {
        return u && (u.type === "linear" || u.type === "radial");
      }
      function $Z(u) {
        return "url(#" + u + ")";
      }
      function H1t(u) {
        var o = u.getGlobalScale(), n3 = Math.max(o[0], o[1]);
        return Math.max(Math.ceil(Math.log(n3) / Math.log(10)), 1);
      }
      function eat(u) {
        var o = u.x || 0, n3 = u.y || 0, p2 = (u.rotation || 0) * NZ, m2 = Xu(u.scaleX, 1), w2 = Xu(u.scaleY, 1), T2 = u.skewX || 0, E = u.skewY || 0, O2 = [];
        return (o || n3) && O2.push("translate(" + o + "px," + n3 + "px)"), p2 && O2.push("rotate(" + p2 + ")"), (m2 !== 1 || w2 !== 1) && O2.push("scale(" + m2 + "," + w2 + ")"), (T2 || E) && O2.push("skew(" + ZZ(T2 * NZ) + "deg, " + ZZ(E * NZ) + "deg)"), O2.join(" ");
      }
      var U1t = function() {
        return Ys.hasGlobalWindow && Sl(window.btoa) ? function(u) {
          return window.btoa(unescape(u));
        } : typeof Buffer != "undefined" ? function(u) {
          return Buffer.from(u).toString("base64");
        } : function(u) {
          return null;
        };
      }(), nat = Array.prototype.slice;
      function $E(u, o, n3) {
        return (o - u) * n3 + u;
      }
      function ez(u, o, n3, p2) {
        for (var m2 = o.length, w2 = 0; w2 < m2; w2++)
          u[w2] = $E(o[w2], n3[w2], p2);
        return u;
      }
      function nz(u, o, n3, p2) {
        for (var m2 = o.length, w2 = m2 && o[0].length, T2 = 0; T2 < m2; T2++) {
          u[T2] || (u[T2] = []);
          for (var E = 0; E < w2; E++)
            u[T2][E] = $E(o[T2][E], n3[T2][E], p2);
        }
        return u;
      }
      function KO(u, o, n3, p2) {
        for (var m2 = o.length, w2 = 0; w2 < m2; w2++)
          u[w2] = o[w2] + n3[w2] * p2;
        return u;
      }
      function q1t(u, o, n3, p2) {
        for (var m2 = o.length, w2 = m2 && o[0].length, T2 = 0; T2 < m2; T2++) {
          u[T2] || (u[T2] = []);
          for (var E = 0; E < w2; E++)
            u[T2][E] = o[T2][E] + n3[T2][E] * p2;
        }
        return u;
      }
      function Z1t(u, o) {
        for (var n3 = u.length, p2 = o.length, m2 = n3 > p2 ? o : u, w2 = Math.min(n3, p2), T2 = m2[w2 - 1] || { color: [0, 0, 0, 0], offset: 0 }, E = w2; E < Math.max(n3, p2); E++)
          m2.push({ offset: T2.offset, color: T2.color.slice() });
      }
      function iNt(u, o, n3) {
        var p2 = u, m2 = o;
        if (!(!p2.push || !m2.push)) {
          var w2 = p2.length, T2 = m2.length;
          if (w2 !== T2) {
            var E = w2 > T2;
            if (E)
              p2.length = T2;
            else
              for (var O2 = w2; O2 < T2; O2++)
                p2.push(n3 === 1 ? m2[O2] : nat.call(m2[O2]));
          }
          for (var V3 = p2[0] && p2[0].length, O2 = 0; O2 < p2.length; O2++)
            if (n3 === 1)
              isNaN(p2[O2]) && (p2[O2] = m2[O2]);
            else
              for (var W3 = 0; W3 < V3; W3++)
                isNaN(p2[O2][W3]) && (p2[O2][W3] = m2[O2][W3]);
        }
      }
      function XS(u) {
        if (M1(u)) {
          var o = u.length;
          if (M1(u[0])) {
            for (var n3 = [], p2 = 0; p2 < o; p2++)
              n3.push(nat.call(u[p2]));
            return n3;
          }
          return nat.call(u);
        }
        return u;
      }
      function VF(u) {
        return u[0] = Math.floor(u[0]) || 0, u[1] = Math.floor(u[1]) || 0, u[2] = Math.floor(u[2]) || 0, u[3] = u[3] == null ? 1 : u[3], "rgba(" + u.join(",") + ")";
      }
      function XO(u) {
        return M1(u && u[0]) ? 2 : 1;
      }
      var q_ = 0, YZ = 1, rat = 2, BF = 3, QO = 4, ZA = 5, iat = 6;
      function $1t(u) {
        return u === QO || u === ZA;
      }
      function JO(u) {
        return u === YZ || u === rat;
      }
      var rz = [0, 0, 0, 0], Y1t = function() {
        function u(o) {
          this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = o;
        }
        return u.prototype.isFinished = function() {
          return this._finished;
        }, u.prototype.setFinished = function() {
          this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
        }, u.prototype.needsAnimate = function() {
          return this.keyframes.length >= 1;
        }, u.prototype.getAdditiveTrack = function() {
          return this._additiveTrack;
        }, u.prototype.addKeyframe = function(o, n3, p2) {
          this._needsSort = true;
          var m2 = this.keyframes, w2 = m2.length, T2 = false, E = iat, O2 = n3;
          if (M1(n3)) {
            var V3 = XO(n3);
            E = V3, (V3 === 1 && !Dh2(n3[0]) || V3 === 2 && !Dh2(n3[0][0])) && (T2 = true);
          } else if (Dh2(n3) && !BB(n3))
            E = q_;
          else if (ds(n3))
            if (!isNaN(+n3))
              E = q_;
            else {
              var W3 = KS(n3);
              W3 && (O2 = W3, E = BF);
            }
          else if (OZ(n3)) {
            var q3 = ua2({}, O2);
            q3.colorStops = Ya2(n3.colorStops, function(J) {
              return { offset: J.offset, color: KS(J.color) };
            }), W1t(n3) ? E = QO : G1t(n3) && (E = ZA), O2 = q3;
          }
          w2 === 0 ? this.valType = E : (E !== this.valType || E === iat) && (T2 = true), this.discrete = this.discrete || T2;
          var K = { time: o, value: O2, rawValue: n3, percent: 0 };
          return p2 && (K.easing = p2, K.easingFunc = Sl(p2) ? p2 : $it[p2] || KB(p2)), m2.push(K), K;
        }, u.prototype.prepare = function(o, n3) {
          var p2 = this.keyframes;
          this._needsSort && p2.sort(function(gt, yt) {
            return gt.time - yt.time;
          });
          for (var m2 = this.valType, w2 = p2.length, T2 = p2[w2 - 1], E = this.discrete, O2 = JO(m2), V3 = $1t(m2), W3 = 0; W3 < w2; W3++) {
            var q3 = p2[W3], K = q3.value, J = T2.value;
            q3.percent = q3.time / o, E || (O2 && W3 !== w2 - 1 ? iNt(K, J, m2) : V3 && Z1t(K.colorStops, J.colorStops));
          }
          if (!E && m2 !== ZA && n3 && this.needsAnimate() && n3.needsAnimate() && m2 === n3.valType && !n3._finished) {
            this._additiveTrack = n3;
            for (var rt2 = p2[0].value, W3 = 0; W3 < w2; W3++)
              m2 === q_ ? p2[W3].additiveValue = p2[W3].value - rt2 : m2 === BF ? p2[W3].additiveValue = KO([], p2[W3].value, rt2, -1) : JO(m2) && (p2[W3].additiveValue = m2 === YZ ? KO([], p2[W3].value, rt2, -1) : q1t([], p2[W3].value, rt2, -1));
          }
        }, u.prototype.step = function(o, n3) {
          if (!this._finished) {
            this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
            var p2 = this._additiveTrack != null, m2 = p2 ? "additiveValue" : "value", w2 = this.valType, T2 = this.keyframes, E = T2.length, O2 = this.propName, V3 = w2 === BF, W3, q3 = this._lastFr, K = Math.min, J, rt2;
            if (E === 1)
              J = rt2 = T2[0];
            else {
              if (n3 < 0)
                W3 = 0;
              else if (n3 < this._lastFrP) {
                var gt = K(q3 + 1, E - 1);
                for (W3 = gt; W3 >= 0 && !(T2[W3].percent <= n3); W3--)
                  ;
                W3 = K(W3, E - 2);
              } else {
                for (W3 = q3; W3 < E && !(T2[W3].percent > n3); W3++)
                  ;
                W3 = K(W3 - 1, E - 2);
              }
              rt2 = T2[W3 + 1], J = T2[W3];
            }
            if (J && rt2) {
              this._lastFr = W3, this._lastFrP = n3;
              var yt = rt2.percent - J.percent, At = yt === 0 ? 1 : K((n3 - J.percent) / yt, 1);
              rt2.easingFunc && (At = rt2.easingFunc(At));
              var Lt = p2 ? this._additiveValue : V3 ? rz : o[O2];
              if ((JO(w2) || V3) && !Lt && (Lt = this._additiveValue = []), this.discrete)
                o[O2] = At < 1 ? J.rawValue : rt2.rawValue;
              else if (JO(w2))
                w2 === YZ ? ez(Lt, J[m2], rt2[m2], At) : nz(Lt, J[m2], rt2[m2], At);
              else if ($1t(w2)) {
                var Wt = J[m2], Nt = rt2[m2], ue2 = w2 === QO;
                o[O2] = { type: ue2 ? "linear" : "radial", x: $E(Wt.x, Nt.x, At), y: $E(Wt.y, Nt.y, At), colorStops: Ya2(Wt.colorStops, function(pe2, xe) {
                  var Ce2 = Nt.colorStops[xe];
                  return { offset: $E(pe2.offset, Ce2.offset, At), color: VF(ez([], pe2.color, Ce2.color, At)) };
                }), global: Nt.global }, ue2 ? (o[O2].x2 = $E(Wt.x2, Nt.x2, At), o[O2].y2 = $E(Wt.y2, Nt.y2, At)) : o[O2].r = $E(Wt.r, Nt.r, At);
              } else if (V3)
                ez(Lt, J[m2], rt2[m2], At), p2 || (o[O2] = VF(Lt));
              else {
                var ie2 = $E(J[m2], rt2[m2], At);
                p2 ? this._additiveValue = ie2 : o[O2] = ie2;
              }
              p2 && this._addToTarget(o);
            }
          }
        }, u.prototype._addToTarget = function(o) {
          var n3 = this.valType, p2 = this.propName, m2 = this._additiveValue;
          n3 === q_ ? o[p2] = o[p2] + m2 : n3 === BF ? (KS(o[p2], rz), KO(rz, rz, m2, 1), o[p2] = VF(rz)) : n3 === YZ ? KO(o[p2], o[p2], m2, 1) : n3 === rat && q1t(o[p2], o[p2], m2, 1);
        }, u;
      }(), Yy = function() {
        function u(o, n3, p2, m2) {
          if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = o, this._loop = n3, n3 && m2) {
            FB("Can' use additive animation on looped animation.");
            return;
          }
          this._additiveAnimators = m2, this._allowDiscrete = p2;
        }
        return u.prototype.getMaxTime = function() {
          return this._maxTime;
        }, u.prototype.getDelay = function() {
          return this._delay;
        }, u.prototype.getLoop = function() {
          return this._loop;
        }, u.prototype.getTarget = function() {
          return this._target;
        }, u.prototype.changeTarget = function(o) {
          this._target = o;
        }, u.prototype.when = function(o, n3, p2) {
          return this.whenWithKeys(o, n3, tf2(n3), p2);
        }, u.prototype.whenWithKeys = function(o, n3, p2, m2) {
          for (var w2 = this._tracks, T2 = 0; T2 < p2.length; T2++) {
            var E = p2[T2], O2 = w2[E];
            if (!O2) {
              O2 = w2[E] = new Y1t(E);
              var V3 = void 0, W3 = this._getAdditiveTrack(E);
              if (W3) {
                var q3 = W3.keyframes, K = q3[q3.length - 1];
                V3 = K && K.value, W3.valType === BF && V3 && (V3 = VF(V3));
              } else
                V3 = this._target[E];
              if (V3 == null)
                continue;
              o > 0 && O2.addKeyframe(0, XS(V3), m2), this._trackKeys.push(E);
            }
            O2.addKeyframe(o, XS(n3[E]), m2);
          }
          return this._maxTime = Math.max(this._maxTime, o), this;
        }, u.prototype.pause = function() {
          this._clip.pause(), this._paused = true;
        }, u.prototype.resume = function() {
          this._clip.resume(), this._paused = false;
        }, u.prototype.isPaused = function() {
          return !!this._paused;
        }, u.prototype.duration = function(o) {
          return this._maxTime = o, this._force = true, this;
        }, u.prototype._doneCallback = function() {
          this._setTracksFinished(), this._clip = null;
          var o = this._doneCbs;
          if (o)
            for (var n3 = o.length, p2 = 0; p2 < n3; p2++)
              o[p2].call(this);
        }, u.prototype._abortedCallback = function() {
          this._setTracksFinished();
          var o = this.animation, n3 = this._abortedCbs;
          if (o && o.removeClip(this._clip), this._clip = null, n3)
            for (var p2 = 0; p2 < n3.length; p2++)
              n3[p2].call(this);
        }, u.prototype._setTracksFinished = function() {
          for (var o = this._tracks, n3 = this._trackKeys, p2 = 0; p2 < n3.length; p2++)
            o[n3[p2]].setFinished();
        }, u.prototype._getAdditiveTrack = function(o) {
          var n3, p2 = this._additiveAnimators;
          if (p2)
            for (var m2 = 0; m2 < p2.length; m2++) {
              var w2 = p2[m2].getTrack(o);
              w2 && (n3 = w2);
            }
          return n3;
        }, u.prototype.start = function(o) {
          if (!(this._started > 0)) {
            this._started = 1;
            for (var n3 = this, p2 = [], m2 = this._maxTime || 0, w2 = 0; w2 < this._trackKeys.length; w2++) {
              var T2 = this._trackKeys[w2], E = this._tracks[T2], O2 = this._getAdditiveTrack(T2), V3 = E.keyframes, W3 = V3.length;
              if (E.prepare(m2, O2), E.needsAnimate())
                if (!this._allowDiscrete && E.discrete) {
                  var q3 = V3[W3 - 1];
                  q3 && (n3._target[E.propName] = q3.rawValue), E.setFinished();
                } else
                  p2.push(E);
            }
            if (p2.length || this._force) {
              var K = new XB({ life: m2, loop: this._loop, delay: this._delay || 0, onframe: function(J) {
                n3._started = 2;
                var rt2 = n3._additiveAnimators;
                if (rt2) {
                  for (var gt = false, yt = 0; yt < rt2.length; yt++)
                    if (rt2[yt]._clip) {
                      gt = true;
                      break;
                    }
                  gt || (n3._additiveAnimators = null);
                }
                for (var yt = 0; yt < p2.length; yt++)
                  p2[yt].step(n3._target, J);
                var At = n3._onframeCbs;
                if (At)
                  for (var yt = 0; yt < At.length; yt++)
                    At[yt](n3._target, J);
              }, ondestroy: function() {
                n3._doneCallback();
              } });
              this._clip = K, this.animation && this.animation.addClip(K), o && K.setEasing(o);
            } else
              this._doneCallback();
            return this;
          }
        }, u.prototype.stop = function(o) {
          if (this._clip) {
            var n3 = this._clip;
            o && n3.onframe(1), this._abortedCallback();
          }
        }, u.prototype.delay = function(o) {
          return this._delay = o, this;
        }, u.prototype.during = function(o) {
          return o && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(o)), this;
        }, u.prototype.done = function(o) {
          return o && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(o)), this;
        }, u.prototype.aborted = function(o) {
          return o && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(o)), this;
        }, u.prototype.getClip = function() {
          return this._clip;
        }, u.prototype.getTrack = function(o) {
          return this._tracks[o];
        }, u.prototype.getTracks = function() {
          var o = this;
          return Ya2(this._trackKeys, function(n3) {
            return o._tracks[n3];
          });
        }, u.prototype.stopTracks = function(o, n3) {
          if (!o.length || !this._clip)
            return true;
          for (var p2 = this._tracks, m2 = this._trackKeys, w2 = 0; w2 < o.length; w2++) {
            var T2 = p2[o[w2]];
            T2 && !T2.isFinished() && (n3 ? T2.step(this._target, 1) : this._started === 1 && T2.step(this._target, 0), T2.setFinished());
          }
          for (var E = true, w2 = 0; w2 < m2.length; w2++)
            if (!p2[m2[w2]].isFinished()) {
              E = false;
              break;
            }
          return E && this._abortedCallback(), E;
        }, u.prototype.saveTo = function(o, n3, p2) {
          if (o) {
            n3 = n3 || this._trackKeys;
            for (var m2 = 0; m2 < n3.length; m2++) {
              var w2 = n3[m2], T2 = this._tracks[w2];
              if (!(!T2 || T2.isFinished())) {
                var E = T2.keyframes, O2 = E[p2 ? 0 : E.length - 1];
                O2 && (o[w2] = XS(O2.rawValue));
              }
            }
          }
        }, u.prototype.__changeFinalValue = function(o, n3) {
          n3 = n3 || tf2(o);
          for (var p2 = 0; p2 < n3.length; p2++) {
            var m2 = n3[p2], w2 = this._tracks[m2];
            if (w2) {
              var T2 = w2.keyframes;
              if (T2.length > 1) {
                var E = T2.pop();
                w2.addKeyframe(E.time, o[m2]), w2.prepare(this._maxTime, w2.getAdditiveTrack());
              }
            }
          }
        }, u;
      }();
      function MP() {
        return new Date().getTime();
      }
      var K1t = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this) || this;
          return p2._running = false, p2._time = 0, p2._pausedTime = 0, p2._pauseStart = 0, p2._paused = false, n3 = n3 || {}, p2.stage = n3.stage || {}, p2;
        }
        return o.prototype.addClip = function(n3) {
          n3.animation && this.removeClip(n3), this._head ? (this._tail.next = n3, n3.prev = this._tail, n3.next = null, this._tail = n3) : this._head = this._tail = n3, n3.animation = this;
        }, o.prototype.addAnimator = function(n3) {
          n3.animation = this;
          var p2 = n3.getClip();
          p2 && this.addClip(p2);
        }, o.prototype.removeClip = function(n3) {
          if (n3.animation) {
            var p2 = n3.prev, m2 = n3.next;
            p2 ? p2.next = m2 : this._head = m2, m2 ? m2.prev = p2 : this._tail = p2, n3.next = n3.prev = n3.animation = null;
          }
        }, o.prototype.removeAnimator = function(n3) {
          var p2 = n3.getClip();
          p2 && this.removeClip(p2), n3.animation = null;
        }, o.prototype.update = function(n3) {
          for (var p2 = MP() - this._pausedTime, m2 = p2 - this._time, w2 = this._head; w2; ) {
            var T2 = w2.next, E = w2.step(p2, m2);
            E && (w2.ondestroy(), this.removeClip(w2)), w2 = T2;
          }
          this._time = p2, n3 || (this.trigger("frame", m2), this.stage.update && this.stage.update());
        }, o.prototype._startLoop = function() {
          var n3 = this;
          this._running = true;
          function p2() {
            n3._running && (UA(p2), !n3._paused && n3.update());
          }
          UA(p2);
        }, o.prototype.start = function() {
          this._running || (this._time = MP(), this._pausedTime = 0, this._startLoop());
        }, o.prototype.stop = function() {
          this._running = false;
        }, o.prototype.pause = function() {
          this._paused || (this._pauseStart = MP(), this._paused = true);
        }, o.prototype.resume = function() {
          this._paused && (this._pausedTime += MP() - this._pauseStart, this._paused = false);
        }, o.prototype.clear = function() {
          for (var n3 = this._head; n3; ) {
            var p2 = n3.next;
            n3.prev = n3.next = n3.animation = null, n3 = p2;
          }
          this._head = this._tail = null;
        }, o.prototype.isFinished = function() {
          return this._head == null;
        }, o.prototype.animate = function(n3, p2) {
          p2 = p2 || {}, this.start();
          var m2 = new Yy(n3, p2.loop);
          return this.addAnimator(m2), m2;
        }, o;
      }(gw), $A = K1t, aat = 300, zF = Ys.domSupported, YE = function() {
        var u = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], o = ["touchstart", "touchend", "touchmove"], n3 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, p2 = Ya2(u, function(m2) {
          var w2 = m2.replace("mouse", "pointer");
          return n3.hasOwnProperty(w2) ? w2 : m2;
        });
        return { mouse: u, touch: o, pointer: p2 };
      }(), oat = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, Db2 = false;
      function iz(u) {
        var o = u.pointerType;
        return o === "pen" || o === "touch";
      }
      function aNt(u) {
        u.touching = true, u.touchTimer != null && (clearTimeout(u.touchTimer), u.touchTimer = null), u.touchTimer = setTimeout(function() {
          u.touching = false, u.touchTimer = null;
        }, 700);
      }
      function sat(u) {
        u && (u.zrByTouch = true);
      }
      function oNt(u, o) {
        return ZS(u.dom, new sNt(u, o), true);
      }
      function KZ(u, o) {
        for (var n3 = o, p2 = false; n3 && n3.nodeType !== 9 && !(p2 = n3.domBelongToZr || n3 !== o && n3 === u.painterRoot); )
          n3 = n3.parentNode;
        return p2;
      }
      var sNt = function() {
        function u(o, n3) {
          this.stopPropagation = Jp, this.stopImmediatePropagation = Jp, this.preventDefault = Jp, this.type = n3.type, this.target = this.currentTarget = o.dom, this.pointerType = n3.pointerType, this.clientX = n3.clientX, this.clientY = n3.clientY;
        }
        return u;
      }(), Z_ = { mousedown: function(u) {
        u = ZS(this.dom, u), this.__mayPointerCapture = [u.zrX, u.zrY], this.trigger("mousedown", u);
      }, mousemove: function(u) {
        u = ZS(this.dom, u);
        var o = this.__mayPointerCapture;
        o && (u.zrX !== o[0] || u.zrY !== o[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", u);
      }, mouseup: function(u) {
        u = ZS(this.dom, u), this.__togglePointerCapture(false), this.trigger("mouseup", u);
      }, mouseout: function(u) {
        u = ZS(this.dom, u);
        var o = u.toElement || u.relatedTarget;
        KZ(this, o) || (this.__pointerCapturing && (u.zrEventControl = "no_globalout"), this.trigger("mouseout", u));
      }, wheel: function(u) {
        Db2 = true, u = ZS(this.dom, u), this.trigger("mousewheel", u);
      }, mousewheel: function(u) {
        Db2 || (u = ZS(this.dom, u), this.trigger("mousewheel", u));
      }, touchstart: function(u) {
        u = ZS(this.dom, u), sat(u), this.__lastTouchMoment = new Date(), this.handler.processGesture(u, "start"), Z_.mousemove.call(this, u), Z_.mousedown.call(this, u);
      }, touchmove: function(u) {
        u = ZS(this.dom, u), sat(u), this.handler.processGesture(u, "change"), Z_.mousemove.call(this, u);
      }, touchend: function(u) {
        u = ZS(this.dom, u), sat(u), this.handler.processGesture(u, "end"), Z_.mouseup.call(this, u), +new Date() - +this.__lastTouchMoment < aat && Z_.click.call(this, u);
      }, pointerdown: function(u) {
        Z_.mousedown.call(this, u);
      }, pointermove: function(u) {
        iz(u) || Z_.mousemove.call(this, u);
      }, pointerup: function(u) {
        Z_.mouseup.call(this, u);
      }, pointerout: function(u) {
        iz(u) || Z_.mouseout.call(this, u);
      } };
      Xe2(["click", "dblclick", "contextmenu"], function(u) {
        Z_[u] = function(o) {
          o = ZS(this.dom, o), this.trigger(u, o);
        };
      });
      var XZ = { pointermove: function(u) {
        iz(u) || XZ.mousemove.call(this, u);
      }, pointerup: function(u) {
        XZ.mouseup.call(this, u);
      }, mousemove: function(u) {
        this.trigger("mousemove", u);
      }, mouseup: function(u) {
        var o = this.__pointerCapturing;
        this.__togglePointerCapture(false), this.trigger("mouseup", u), o && (u.zrEventControl = "only_globalout", this.trigger("mouseout", u));
      } };
      function lNt(u, o) {
        var n3 = o.domHandlers;
        Ys.pointerEventsSupported ? Xe2(YE.pointer, function(p2) {
          CP(o, p2, function(m2) {
            n3[p2].call(u, m2);
          });
        }) : (Ys.touchEventsSupported && Xe2(YE.touch, function(p2) {
          CP(o, p2, function(m2) {
            n3[p2].call(u, m2), aNt(o);
          });
        }), Xe2(YE.mouse, function(p2) {
          CP(o, p2, function(m2) {
            m2 = HB(m2), o.touching || n3[p2].call(u, m2);
          });
        }));
      }
      function uNt(u, o) {
        Ys.pointerEventsSupported ? Xe2(oat.pointer, n3) : Ys.touchEventsSupported || Xe2(oat.mouse, n3);
        function n3(p2) {
          function m2(w2) {
            w2 = HB(w2), KZ(u, w2.target) || (w2 = oNt(u, w2), o.domHandlers[p2].call(u, w2));
          }
          CP(o, p2, m2, { capture: true });
        }
      }
      function CP(u, o, n3, p2) {
        u.mounted[o] = n3, u.listenerOpts[o] = p2, wF(u.domTarget, o, n3, p2);
      }
      function lat(u) {
        var o = u.mounted;
        for (var n3 in o)
          o.hasOwnProperty(n3) && j6t(u.domTarget, n3, o[n3], u.listenerOpts[n3]);
        u.mounted = {};
      }
      var X1t = function() {
        function u(o, n3) {
          this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = o, this.domHandlers = n3;
        }
        return u;
      }(), uat = function(u) {
        tr(o, u);
        function o(n3, p2) {
          var m2 = u.call(this) || this;
          return m2.__pointerCapturing = false, m2.dom = n3, m2.painterRoot = p2, m2._localHandlerScope = new X1t(n3, Z_), zF && (m2._globalHandlerScope = new X1t(document, XZ)), lNt(m2, m2._localHandlerScope), m2;
        }
        return o.prototype.dispose = function() {
          lat(this._localHandlerScope), zF && lat(this._globalHandlerScope);
        }, o.prototype.setCursor = function(n3) {
          this.dom.style && (this.dom.style.cursor = n3 || "default");
        }, o.prototype.__togglePointerCapture = function(n3) {
          if (this.__mayPointerCapture = null, zF && +this.__pointerCapturing ^ +n3) {
            this.__pointerCapturing = n3;
            var p2 = this._globalHandlerScope;
            n3 ? uNt(this, p2) : lat(p2);
          }
        }, o;
      }(gw), Q1t = uat, J1t = 1;
      Ys.hasGlobalWindow && (J1t = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
      var QZ = J1t, cat = 0.4, JZ = "#333", az = "#ccc", cNt = "#eee";
      function yw() {
        return [1, 0, 0, 1, 0, 0];
      }
      function oz(u) {
        return u[0] = 1, u[1] = 0, u[2] = 0, u[3] = 1, u[4] = 0, u[5] = 0, u;
      }
      function t$(u, o) {
        return u[0] = o[0], u[1] = o[1], u[2] = o[2], u[3] = o[3], u[4] = o[4], u[5] = o[5], u;
      }
      function YA(u, o, n3) {
        var p2 = o[0] * n3[0] + o[2] * n3[1], m2 = o[1] * n3[0] + o[3] * n3[1], w2 = o[0] * n3[2] + o[2] * n3[3], T2 = o[1] * n3[2] + o[3] * n3[3], E = o[0] * n3[4] + o[2] * n3[5] + o[4], O2 = o[1] * n3[4] + o[3] * n3[5] + o[5];
        return u[0] = p2, u[1] = m2, u[2] = w2, u[3] = T2, u[4] = E, u[5] = O2, u;
      }
      function QS(u, o, n3) {
        return u[0] = o[0], u[1] = o[1], u[2] = o[2], u[3] = o[3], u[4] = o[4] + n3[0], u[5] = o[5] + n3[1], u;
      }
      function t4(u, o, n3) {
        var p2 = o[0], m2 = o[2], w2 = o[4], T2 = o[1], E = o[3], O2 = o[5], V3 = Math.sin(n3), W3 = Math.cos(n3);
        return u[0] = p2 * W3 + T2 * V3, u[1] = -p2 * V3 + T2 * W3, u[2] = m2 * W3 + E * V3, u[3] = -m2 * V3 + W3 * E, u[4] = W3 * w2 + V3 * O2, u[5] = W3 * O2 - V3 * w2, u;
      }
      function e$(u, o, n3) {
        var p2 = n3[0], m2 = n3[1];
        return u[0] = o[0] * p2, u[1] = o[1] * m2, u[2] = o[2] * p2, u[3] = o[3] * m2, u[4] = o[4] * p2, u[5] = o[5] * m2, u;
      }
      function e4(u, o) {
        var n3 = o[0], p2 = o[2], m2 = o[4], w2 = o[1], T2 = o[3], E = o[5], O2 = n3 * T2 - w2 * p2;
        return O2 ? (O2 = 1 / O2, u[0] = T2 * O2, u[1] = -w2 * O2, u[2] = -p2 * O2, u[3] = n3 * O2, u[4] = (p2 * E - T2 * m2) * O2, u[5] = (w2 * m2 - n3 * E) * O2, u) : null;
      }
      function fNt(u) {
        var o = yw();
        return t$(o, u), o;
      }
      var fat = oz, tbt = 5e-5;
      function KE(u) {
        return u > tbt || u < -tbt;
      }
      var TP = [], AP = [], hat = yw(), sz = Math.abs, sh2 = function() {
        function u() {
        }
        return u.prototype.getLocalTransform = function(o) {
          return u.getLocalTransform(this, o);
        }, u.prototype.setPosition = function(o) {
          this.x = o[0], this.y = o[1];
        }, u.prototype.setScale = function(o) {
          this.scaleX = o[0], this.scaleY = o[1];
        }, u.prototype.setSkew = function(o) {
          this.skewX = o[0], this.skewY = o[1];
        }, u.prototype.setOrigin = function(o) {
          this.originX = o[0], this.originY = o[1];
        }, u.prototype.needLocalTransform = function() {
          return KE(this.rotation) || KE(this.x) || KE(this.y) || KE(this.scaleX - 1) || KE(this.scaleY - 1) || KE(this.skewX) || KE(this.skewY);
        }, u.prototype.updateTransform = function() {
          var o = this.parent && this.parent.transform, n3 = this.needLocalTransform(), p2 = this.transform;
          if (!(n3 || o)) {
            p2 && fat(p2);
            return;
          }
          p2 = p2 || yw(), n3 ? this.getLocalTransform(p2) : fat(p2), o && (n3 ? YA(p2, o, p2) : t$(p2, o)), this.transform = p2, this._resolveGlobalScaleRatio(p2);
        }, u.prototype._resolveGlobalScaleRatio = function(o) {
          var n3 = this.globalScaleRatio;
          if (n3 != null && n3 !== 1) {
            this.getGlobalScale(TP);
            var p2 = TP[0] < 0 ? -1 : 1, m2 = TP[1] < 0 ? -1 : 1, w2 = ((TP[0] - p2) * n3 + p2) / TP[0] || 0, T2 = ((TP[1] - m2) * n3 + m2) / TP[1] || 0;
            o[0] *= w2, o[1] *= w2, o[2] *= T2, o[3] *= T2;
          }
          this.invTransform = this.invTransform || yw(), e4(this.invTransform, o);
        }, u.prototype.getComputedTransform = function() {
          for (var o = this, n3 = []; o; )
            n3.push(o), o = o.parent;
          for (; o = n3.pop(); )
            o.updateTransform();
          return this.transform;
        }, u.prototype.setLocalTransform = function(o) {
          if (o) {
            var n3 = o[0] * o[0] + o[1] * o[1], p2 = o[2] * o[2] + o[3] * o[3], m2 = Math.atan2(o[1], o[0]), w2 = Math.PI / 2 + m2 - Math.atan2(o[3], o[2]);
            p2 = Math.sqrt(p2) * Math.cos(w2), n3 = Math.sqrt(n3), this.skewX = w2, this.skewY = 0, this.rotation = -m2, this.x = +o[4], this.y = +o[5], this.scaleX = n3, this.scaleY = p2, this.originX = 0, this.originY = 0;
          }
        }, u.prototype.decomposeTransform = function() {
          if (this.transform) {
            var o = this.parent, n3 = this.transform;
            o && o.transform && (YA(AP, o.invTransform, n3), n3 = AP);
            var p2 = this.originX, m2 = this.originY;
            (p2 || m2) && (hat[4] = p2, hat[5] = m2, YA(AP, n3, hat), AP[4] -= p2, AP[5] -= m2, n3 = AP), this.setLocalTransform(n3);
          }
        }, u.prototype.getGlobalScale = function(o) {
          var n3 = this.transform;
          return o = o || [], n3 ? (o[0] = Math.sqrt(n3[0] * n3[0] + n3[1] * n3[1]), o[1] = Math.sqrt(n3[2] * n3[2] + n3[3] * n3[3]), n3[0] < 0 && (o[0] = -o[0]), n3[3] < 0 && (o[1] = -o[1]), o) : (o[0] = 1, o[1] = 1, o);
        }, u.prototype.transformCoordToLocal = function(o, n3) {
          var p2 = [o, n3], m2 = this.invTransform;
          return m2 && Lm(p2, p2, m2), p2;
        }, u.prototype.transformCoordToGlobal = function(o, n3) {
          var p2 = [o, n3], m2 = this.transform;
          return m2 && Lm(p2, p2, m2), p2;
        }, u.prototype.getLineScale = function() {
          var o = this.transform;
          return o && sz(o[0] - 1) > 1e-10 && sz(o[3] - 1) > 1e-10 ? Math.sqrt(sz(o[0] * o[3] - o[2] * o[1])) : 1;
        }, u.prototype.copyTransform = function(o) {
          ebt(this, o);
        }, u.getLocalTransform = function(o, n3) {
          n3 = n3 || [];
          var p2 = o.originX || 0, m2 = o.originY || 0, w2 = o.scaleX, T2 = o.scaleY, E = o.anchorX, O2 = o.anchorY, V3 = o.rotation || 0, W3 = o.x, q3 = o.y, K = o.skewX ? Math.tan(o.skewX) : 0, J = o.skewY ? Math.tan(-o.skewY) : 0;
          if (p2 || m2 || E || O2) {
            var rt2 = p2 + E, gt = m2 + O2;
            n3[4] = -rt2 * w2 - K * gt * T2, n3[5] = -gt * T2 - J * rt2 * w2;
          } else
            n3[4] = n3[5] = 0;
          return n3[0] = w2, n3[3] = T2, n3[1] = J * w2, n3[2] = K * T2, V3 && t4(n3, n3, V3), n3[4] += p2 + W3, n3[5] += m2 + q3, n3;
        }, u.initDefaultProps = function() {
          var o = u.prototype;
          o.scaleX = o.scaleY = o.globalScaleRatio = 1, o.x = o.y = o.originX = o.originY = o.skewX = o.skewY = o.rotation = o.anchorX = o.anchorY = 0;
        }(), u;
      }(), KA = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
      function ebt(u, o) {
        for (var n3 = 0; n3 < KA.length; n3++) {
          var p2 = KA[n3];
          u[p2] = o[p2];
        }
      }
      var JS = sh2, nbt = function() {
        function u(o, n3) {
          this.x = o || 0, this.y = n3 || 0;
        }
        return u.prototype.copy = function(o) {
          return this.x = o.x, this.y = o.y, this;
        }, u.prototype.clone = function() {
          return new u(this.x, this.y);
        }, u.prototype.set = function(o, n3) {
          return this.x = o, this.y = n3, this;
        }, u.prototype.equal = function(o) {
          return o.x === this.x && o.y === this.y;
        }, u.prototype.add = function(o) {
          return this.x += o.x, this.y += o.y, this;
        }, u.prototype.scale = function(o) {
          this.x *= o, this.y *= o;
        }, u.prototype.scaleAndAdd = function(o, n3) {
          this.x += o.x * n3, this.y += o.y * n3;
        }, u.prototype.sub = function(o) {
          return this.x -= o.x, this.y -= o.y, this;
        }, u.prototype.dot = function(o) {
          return this.x * o.x + this.y * o.y;
        }, u.prototype.len = function() {
          return Math.sqrt(this.x * this.x + this.y * this.y);
        }, u.prototype.lenSquare = function() {
          return this.x * this.x + this.y * this.y;
        }, u.prototype.normalize = function() {
          var o = this.len();
          return this.x /= o, this.y /= o, this;
        }, u.prototype.distance = function(o) {
          var n3 = this.x - o.x, p2 = this.y - o.y;
          return Math.sqrt(n3 * n3 + p2 * p2);
        }, u.prototype.distanceSquare = function(o) {
          var n3 = this.x - o.x, p2 = this.y - o.y;
          return n3 * n3 + p2 * p2;
        }, u.prototype.negate = function() {
          return this.x = -this.x, this.y = -this.y, this;
        }, u.prototype.transform = function(o) {
          if (o) {
            var n3 = this.x, p2 = this.y;
            return this.x = o[0] * n3 + o[2] * p2 + o[4], this.y = o[1] * n3 + o[3] * p2 + o[5], this;
          }
        }, u.prototype.toArray = function(o) {
          return o[0] = this.x, o[1] = this.y, o;
        }, u.prototype.fromArray = function(o) {
          this.x = o[0], this.y = o[1];
        }, u.set = function(o, n3, p2) {
          o.x = n3, o.y = p2;
        }, u.copy = function(o, n3) {
          o.x = n3.x, o.y = n3.y;
        }, u.len = function(o) {
          return Math.sqrt(o.x * o.x + o.y * o.y);
        }, u.lenSquare = function(o) {
          return o.x * o.x + o.y * o.y;
        }, u.dot = function(o, n3) {
          return o.x * n3.x + o.y * n3.y;
        }, u.add = function(o, n3, p2) {
          o.x = n3.x + p2.x, o.y = n3.y + p2.y;
        }, u.sub = function(o, n3, p2) {
          o.x = n3.x - p2.x, o.y = n3.y - p2.y;
        }, u.scale = function(o, n3, p2) {
          o.x = n3.x * p2, o.y = n3.y * p2;
        }, u.scaleAndAdd = function(o, n3, p2, m2) {
          o.x = n3.x + p2.x * m2, o.y = n3.y + p2.y * m2;
        }, u.lerp = function(o, n3, p2, m2) {
          var w2 = 1 - m2;
          o.x = w2 * n3.x + m2 * p2.x, o.y = w2 * n3.y + m2 * p2.y;
        }, u;
      }(), Vu = nbt, n$ = Math.min, $_ = Math.max, n4 = new Vu(), XA = new Vu(), XE = new Vu(), IP = new Vu(), jF = new Vu(), A1 = new Vu(), DP = function() {
        function u(o, n3, p2, m2) {
          p2 < 0 && (o = o + p2, p2 = -p2), m2 < 0 && (n3 = n3 + m2, m2 = -m2), this.x = o, this.y = n3, this.width = p2, this.height = m2;
        }
        return u.prototype.union = function(o) {
          var n3 = n$(o.x, this.x), p2 = n$(o.y, this.y);
          isFinite(this.x) && isFinite(this.width) ? this.width = $_(o.x + o.width, this.x + this.width) - n3 : this.width = o.width, isFinite(this.y) && isFinite(this.height) ? this.height = $_(o.y + o.height, this.y + this.height) - p2 : this.height = o.height, this.x = n3, this.y = p2;
        }, u.prototype.applyTransform = function(o) {
          u.applyTransform(this, this, o);
        }, u.prototype.calculateTransform = function(o) {
          var n3 = this, p2 = o.width / n3.width, m2 = o.height / n3.height, w2 = yw();
          return QS(w2, w2, [-n3.x, -n3.y]), e$(w2, w2, [p2, m2]), QS(w2, w2, [o.x, o.y]), w2;
        }, u.prototype.intersect = function(o, n3) {
          if (!o)
            return false;
          o instanceof u || (o = u.create(o));
          var p2 = this, m2 = p2.x, w2 = p2.x + p2.width, T2 = p2.y, E = p2.y + p2.height, O2 = o.x, V3 = o.x + o.width, W3 = o.y, q3 = o.y + o.height, K = !(w2 < O2 || V3 < m2 || E < W3 || q3 < T2);
          if (n3) {
            var J = 1 / 0, rt2 = 0, gt = Math.abs(w2 - O2), yt = Math.abs(V3 - m2), At = Math.abs(E - W3), Lt = Math.abs(q3 - T2), Wt = Math.min(gt, yt), Nt = Math.min(At, Lt);
            w2 < O2 || V3 < m2 ? Wt > rt2 && (rt2 = Wt, gt < yt ? Vu.set(A1, -gt, 0) : Vu.set(A1, yt, 0)) : Wt < J && (J = Wt, gt < yt ? Vu.set(jF, gt, 0) : Vu.set(jF, -yt, 0)), E < W3 || q3 < T2 ? Nt > rt2 && (rt2 = Nt, At < Lt ? Vu.set(A1, 0, -At) : Vu.set(A1, 0, Lt)) : Wt < J && (J = Wt, At < Lt ? Vu.set(jF, 0, At) : Vu.set(jF, 0, -Lt));
          }
          return n3 && Vu.copy(n3, K ? jF : A1), K;
        }, u.prototype.contain = function(o, n3) {
          var p2 = this;
          return o >= p2.x && o <= p2.x + p2.width && n3 >= p2.y && n3 <= p2.y + p2.height;
        }, u.prototype.clone = function() {
          return new u(this.x, this.y, this.width, this.height);
        }, u.prototype.copy = function(o) {
          u.copy(this, o);
        }, u.prototype.plain = function() {
          return { x: this.x, y: this.y, width: this.width, height: this.height };
        }, u.prototype.isFinite = function() {
          return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
        }, u.prototype.isZero = function() {
          return this.width === 0 || this.height === 0;
        }, u.create = function(o) {
          return new u(o.x, o.y, o.width, o.height);
        }, u.copy = function(o, n3) {
          o.x = n3.x, o.y = n3.y, o.width = n3.width, o.height = n3.height;
        }, u.applyTransform = function(o, n3, p2) {
          if (!p2) {
            o !== n3 && u.copy(o, n3);
            return;
          }
          if (p2[1] < 1e-5 && p2[1] > -1e-5 && p2[2] < 1e-5 && p2[2] > -1e-5) {
            var m2 = p2[0], w2 = p2[3], T2 = p2[4], E = p2[5];
            o.x = n3.x * m2 + T2, o.y = n3.y * w2 + E, o.width = n3.width * m2, o.height = n3.height * w2, o.width < 0 && (o.x += o.width, o.width = -o.width), o.height < 0 && (o.y += o.height, o.height = -o.height);
            return;
          }
          n4.x = XE.x = n3.x, n4.y = IP.y = n3.y, XA.x = IP.x = n3.x + n3.width, XA.y = XE.y = n3.y + n3.height, n4.transform(p2), IP.transform(p2), XA.transform(p2), XE.transform(p2), o.x = n$(n4.x, XA.x, XE.x, IP.x), o.y = n$(n4.y, XA.y, XE.y, IP.y);
          var O2 = $_(n4.x, XA.x, XE.x, IP.x), V3 = $_(n4.y, XA.y, XE.y, IP.y);
          o.width = O2 - o.x, o.height = V3 - o.y;
        }, u;
      }(), Qu = DP, pat = {};
      function Eb2(u, o) {
        o = o || Fu;
        var n3 = pat[o];
        n3 || (n3 = pat[o] = new QB(500));
        var p2 = n3.get(u);
        return p2 == null && (p2 = pw.measureText(u, o).width, n3.put(u, p2)), p2;
      }
      function dat(u, o, n3, p2) {
        var m2 = Eb2(u, o), w2 = GF(o), T2 = WF(0, m2, n3), E = EP(0, w2, p2), O2 = new Qu(T2, E, m2, w2);
        return O2;
      }
      function r4(u, o, n3, p2) {
        var m2 = ((u || "") + "").split(`
`), w2 = m2.length;
        if (w2 === 1)
          return dat(m2[0], o, n3, p2);
        for (var T2 = new Qu(0, 0, 0, 0), E = 0; E < m2.length; E++) {
          var O2 = dat(m2[E], o, n3, p2);
          E === 0 ? T2.copy(O2) : T2.union(O2);
        }
        return T2;
      }
      function WF(u, o, n3) {
        return n3 === "right" ? u -= o : n3 === "center" && (u -= o / 2), u;
      }
      function EP(u, o, n3) {
        return n3 === "middle" ? u -= o / 2 : n3 === "bottom" && (u -= o), u;
      }
      function GF(u) {
        return Eb2("\u56FD", u);
      }
      function Rm(u, o) {
        return typeof u == "string" ? u.lastIndexOf("%") >= 0 ? parseFloat(u) / 100 * o : parseFloat(u) : u;
      }
      function r$(u, o, n3) {
        var p2 = o.position || "inside", m2 = o.distance != null ? o.distance : 5, w2 = n3.height, T2 = n3.width, E = w2 / 2, O2 = n3.x, V3 = n3.y, W3 = "left", q3 = "top";
        if (p2 instanceof Array)
          O2 += Rm(p2[0], n3.width), V3 += Rm(p2[1], n3.height), W3 = null, q3 = null;
        else
          switch (p2) {
            case "left":
              O2 -= m2, V3 += E, W3 = "right", q3 = "middle";
              break;
            case "right":
              O2 += m2 + T2, V3 += E, q3 = "middle";
              break;
            case "top":
              O2 += T2 / 2, V3 -= m2, W3 = "center", q3 = "bottom";
              break;
            case "bottom":
              O2 += T2 / 2, V3 += w2 + m2, W3 = "center";
              break;
            case "inside":
              O2 += T2 / 2, V3 += E, W3 = "center", q3 = "middle";
              break;
            case "insideLeft":
              O2 += m2, V3 += E, q3 = "middle";
              break;
            case "insideRight":
              O2 += T2 - m2, V3 += E, W3 = "right", q3 = "middle";
              break;
            case "insideTop":
              O2 += T2 / 2, V3 += m2, W3 = "center";
              break;
            case "insideBottom":
              O2 += T2 / 2, V3 += w2 - m2, W3 = "center", q3 = "bottom";
              break;
            case "insideTopLeft":
              O2 += m2, V3 += m2;
              break;
            case "insideTopRight":
              O2 += T2 - m2, V3 += m2, W3 = "right";
              break;
            case "insideBottomLeft":
              O2 += m2, V3 += w2 - m2, q3 = "bottom";
              break;
            case "insideBottomRight":
              O2 += T2 - m2, V3 += w2 - m2, W3 = "right", q3 = "bottom";
              break;
          }
        return u = u || {}, u.x = O2, u.y = V3, u.align = W3, u.verticalAlign = q3, u;
      }
      var QA = "__zr_normal__", i$ = KA.concat(["ignore"]), rbt = jA(KA, function(u, o) {
        return u[o] = true, u;
      }, { ignore: false }), kP = {}, hNt = new Qu(0, 0, 0, 0), gat = function() {
        function u(o) {
          this.id = bF(), this.animators = [], this.currentStates = [], this.states = {}, this._init(o);
        }
        return u.prototype._init = function(o) {
          this.attr(o);
        }, u.prototype.drift = function(o, n3, p2) {
          switch (this.draggable) {
            case "horizontal":
              n3 = 0;
              break;
            case "vertical":
              o = 0;
              break;
          }
          var m2 = this.transform;
          m2 || (m2 = this.transform = [1, 0, 0, 1, 0, 0]), m2[4] += o, m2[5] += n3, this.decomposeTransform(), this.markRedraw();
        }, u.prototype.beforeUpdate = function() {
        }, u.prototype.afterUpdate = function() {
        }, u.prototype.update = function() {
          this.updateTransform(), this.__dirty && this.updateInnerText();
        }, u.prototype.updateInnerText = function(o) {
          var n3 = this._textContent;
          if (n3 && (!n3.ignore || o)) {
            this.textConfig || (this.textConfig = {});
            var p2 = this.textConfig, m2 = p2.local, w2 = n3.innerTransformable, T2 = void 0, E = void 0, O2 = false;
            w2.parent = m2 ? this : null;
            var V3 = false;
            if (w2.copyTransform(n3), p2.position != null) {
              var W3 = hNt;
              p2.layoutRect ? W3.copy(p2.layoutRect) : W3.copy(this.getBoundingRect()), m2 || W3.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(kP, p2, W3) : r$(kP, p2, W3), w2.x = kP.x, w2.y = kP.y, T2 = kP.align, E = kP.verticalAlign;
              var q3 = p2.origin;
              if (q3 && p2.rotation != null) {
                var K = void 0, J = void 0;
                q3 === "center" ? (K = W3.width * 0.5, J = W3.height * 0.5) : (K = Rm(q3[0], W3.width), J = Rm(q3[1], W3.height)), V3 = true, w2.originX = -w2.x + K + (m2 ? 0 : W3.x), w2.originY = -w2.y + J + (m2 ? 0 : W3.y);
              }
            }
            p2.rotation != null && (w2.rotation = p2.rotation);
            var rt2 = p2.offset;
            rt2 && (w2.x += rt2[0], w2.y += rt2[1], V3 || (w2.originX = -rt2[0], w2.originY = -rt2[1]));
            var gt = p2.inside == null ? typeof p2.position == "string" && p2.position.indexOf("inside") >= 0 : p2.inside, yt = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), At = void 0, Lt = void 0, Wt = void 0;
            gt && this.canBeInsideText() ? (At = p2.insideFill, Lt = p2.insideStroke, (At == null || At === "auto") && (At = this.getInsideTextFill()), (Lt == null || Lt === "auto") && (Lt = this.getInsideTextStroke(At), Wt = true)) : (At = p2.outsideFill, Lt = p2.outsideStroke, (At == null || At === "auto") && (At = this.getOutsideFill()), (Lt == null || Lt === "auto") && (Lt = this.getOutsideStroke(At), Wt = true)), At = At || "#000", (At !== yt.fill || Lt !== yt.stroke || Wt !== yt.autoStroke || T2 !== yt.align || E !== yt.verticalAlign) && (O2 = true, yt.fill = At, yt.stroke = Lt, yt.autoStroke = Wt, yt.align = T2, yt.verticalAlign = E, n3.setDefaultTextStyle(yt)), n3.__dirty |= Ab2, O2 && n3.dirtyStyle(true);
          }
        }, u.prototype.canBeInsideText = function() {
          return true;
        }, u.prototype.getInsideTextFill = function() {
          return "#fff";
        }, u.prototype.getInsideTextStroke = function(o) {
          return "#000";
        }, u.prototype.getOutsideFill = function() {
          return this.__zr && this.__zr.isDarkMode() ? az : JZ;
        }, u.prototype.getOutsideStroke = function(o) {
          var n3 = this.__zr && this.__zr.getBackgroundColor(), p2 = typeof n3 == "string" && KS(n3);
          p2 || (p2 = [255, 255, 255, 1]);
          for (var m2 = p2[3], w2 = this.__zr.isDarkMode(), T2 = 0; T2 < 3; T2++)
            p2[T2] = p2[T2] * m2 + (w2 ? 0 : 255) * (1 - m2);
          return p2[3] = 1, T1(p2, "rgba");
        }, u.prototype.traverse = function(o, n3) {
        }, u.prototype.attrKV = function(o, n3) {
          o === "textConfig" ? this.setTextConfig(n3) : o === "textContent" ? this.setTextContent(n3) : o === "clipPath" ? this.setClipPath(n3) : o === "extra" ? (this.extra = this.extra || {}, ua2(this.extra, n3)) : this[o] = n3;
        }, u.prototype.hide = function() {
          this.ignore = true, this.markRedraw();
        }, u.prototype.show = function() {
          this.ignore = false, this.markRedraw();
        }, u.prototype.attr = function(o, n3) {
          if (typeof o == "string")
            this.attrKV(o, n3);
          else if (ys(o))
            for (var p2 = o, m2 = tf2(p2), w2 = 0; w2 < m2.length; w2++) {
              var T2 = m2[w2];
              this.attrKV(T2, o[T2]);
            }
          return this.markRedraw(), this;
        }, u.prototype.saveCurrentToNormalState = function(o) {
          this._innerSaveToNormal(o);
          for (var n3 = this._normalState, p2 = 0; p2 < this.animators.length; p2++) {
            var m2 = this.animators[p2], w2 = m2.__fromStateTransition;
            if (!(m2.getLoop() || w2 && w2 !== QA)) {
              var T2 = m2.targetName, E = T2 ? n3[T2] : n3;
              m2.saveTo(E);
            }
          }
        }, u.prototype._innerSaveToNormal = function(o) {
          var n3 = this._normalState;
          n3 || (n3 = this._normalState = {}), o.textConfig && !n3.textConfig && (n3.textConfig = this.textConfig), this._savePrimaryToNormal(o, n3, i$);
        }, u.prototype._savePrimaryToNormal = function(o, n3, p2) {
          for (var m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2];
            o[w2] != null && !(w2 in n3) && (n3[w2] = this[w2]);
          }
        }, u.prototype.hasState = function() {
          return this.currentStates.length > 0;
        }, u.prototype.getState = function(o) {
          return this.states[o];
        }, u.prototype.ensureState = function(o) {
          var n3 = this.states;
          return n3[o] || (n3[o] = {}), n3[o];
        }, u.prototype.clearStates = function(o) {
          this.useState(QA, false, o);
        }, u.prototype.useState = function(o, n3, p2, m2) {
          var w2 = o === QA, T2 = this.hasState();
          if (!(!T2 && w2)) {
            var E = this.currentStates, O2 = this.stateTransition;
            if (!(sc2(E, o) >= 0 && (n3 || E.length === 1))) {
              var V3;
              if (this.stateProxy && !w2 && (V3 = this.stateProxy(o)), V3 || (V3 = this.states && this.states[o]), !V3 && !w2) {
                FB("State " + o + " not exists.");
                return;
              }
              w2 || this.saveCurrentToNormalState(V3);
              var W3 = !!(V3 && V3.hoverLayer || m2);
              W3 && this._toggleHoverLayerFlag(true), this._applyStateObj(o, V3, this._normalState, n3, !p2 && !this.__inHover && O2 && O2.duration > 0, O2);
              var q3 = this._textContent, K = this._textGuide;
              return q3 && q3.useState(o, n3, p2, W3), K && K.useState(o, n3, p2, W3), w2 ? (this.currentStates = [], this._normalState = {}) : n3 ? this.currentStates.push(o) : this.currentStates = [o], this._updateAnimationTargets(), this.markRedraw(), !W3 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Ab2), V3;
            }
          }
        }, u.prototype.useStates = function(o, n3, p2) {
          if (!o.length)
            this.clearStates();
          else {
            var m2 = [], w2 = this.currentStates, T2 = o.length, E = T2 === w2.length;
            if (E) {
              for (var O2 = 0; O2 < T2; O2++)
                if (o[O2] !== w2[O2]) {
                  E = false;
                  break;
                }
            }
            if (E)
              return;
            for (var O2 = 0; O2 < T2; O2++) {
              var V3 = o[O2], W3 = void 0;
              this.stateProxy && (W3 = this.stateProxy(V3, o)), W3 || (W3 = this.states[V3]), W3 && m2.push(W3);
            }
            var q3 = m2[T2 - 1], K = !!(q3 && q3.hoverLayer || p2);
            K && this._toggleHoverLayerFlag(true);
            var J = this._mergeStates(m2), rt2 = this.stateTransition;
            this.saveCurrentToNormalState(J), this._applyStateObj(o.join(","), J, this._normalState, false, !n3 && !this.__inHover && rt2 && rt2.duration > 0, rt2);
            var gt = this._textContent, yt = this._textGuide;
            gt && gt.useStates(o, n3, K), yt && yt.useStates(o, n3, K), this._updateAnimationTargets(), this.currentStates = o.slice(), this.markRedraw(), !K && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Ab2);
          }
        }, u.prototype._updateAnimationTargets = function() {
          for (var o = 0; o < this.animators.length; o++) {
            var n3 = this.animators[o];
            n3.targetName && n3.changeTarget(this[n3.targetName]);
          }
        }, u.prototype.removeState = function(o) {
          var n3 = sc2(this.currentStates, o);
          if (n3 >= 0) {
            var p2 = this.currentStates.slice();
            p2.splice(n3, 1), this.useStates(p2);
          }
        }, u.prototype.replaceState = function(o, n3, p2) {
          var m2 = this.currentStates.slice(), w2 = sc2(m2, o), T2 = sc2(m2, n3) >= 0;
          w2 >= 0 ? T2 ? m2.splice(w2, 1) : m2[w2] = n3 : p2 && !T2 && m2.push(n3), this.useStates(m2);
        }, u.prototype.toggleState = function(o, n3) {
          n3 ? this.useState(o, true) : this.removeState(o);
        }, u.prototype._mergeStates = function(o) {
          for (var n3 = {}, p2, m2 = 0; m2 < o.length; m2++) {
            var w2 = o[m2];
            ua2(n3, w2), w2.textConfig && (p2 = p2 || {}, ua2(p2, w2.textConfig));
          }
          return p2 && (n3.textConfig = p2), n3;
        }, u.prototype._applyStateObj = function(o, n3, p2, m2, w2, T2) {
          var E = !(n3 && m2);
          n3 && n3.textConfig ? (this.textConfig = ua2({}, m2 ? this.textConfig : p2.textConfig), ua2(this.textConfig, n3.textConfig)) : E && p2.textConfig && (this.textConfig = p2.textConfig);
          for (var O2 = {}, V3 = false, W3 = 0; W3 < i$.length; W3++) {
            var q3 = i$[W3], K = w2 && rbt[q3];
            n3 && n3[q3] != null ? K ? (V3 = true, O2[q3] = n3[q3]) : this[q3] = n3[q3] : E && p2[q3] != null && (K ? (V3 = true, O2[q3] = p2[q3]) : this[q3] = p2[q3]);
          }
          if (!w2)
            for (var W3 = 0; W3 < this.animators.length; W3++) {
              var J = this.animators[W3], rt2 = J.targetName;
              J.getLoop() || J.__changeFinalValue(rt2 ? (n3 || p2)[rt2] : n3 || p2);
            }
          V3 && this._transitionState(o, O2, T2);
        }, u.prototype._attachComponent = function(o) {
          if (!(o.__zr && !o.__hostTarget) && o !== this) {
            var n3 = this.__zr;
            n3 && o.addSelfToZr(n3), o.__zr = n3, o.__hostTarget = this;
          }
        }, u.prototype._detachComponent = function(o) {
          o.__zr && o.removeSelfFromZr(o.__zr), o.__zr = null, o.__hostTarget = null;
        }, u.prototype.getClipPath = function() {
          return this._clipPath;
        }, u.prototype.setClipPath = function(o) {
          this._clipPath && this._clipPath !== o && this.removeClipPath(), this._attachComponent(o), this._clipPath = o, this.markRedraw();
        }, u.prototype.removeClipPath = function() {
          var o = this._clipPath;
          o && (this._detachComponent(o), this._clipPath = null, this.markRedraw());
        }, u.prototype.getTextContent = function() {
          return this._textContent;
        }, u.prototype.setTextContent = function(o) {
          var n3 = this._textContent;
          n3 !== o && (n3 && n3 !== o && this.removeTextContent(), o.innerTransformable = new JS(), this._attachComponent(o), this._textContent = o, this.markRedraw());
        }, u.prototype.setTextConfig = function(o) {
          this.textConfig || (this.textConfig = {}), ua2(this.textConfig, o), this.markRedraw();
        }, u.prototype.removeTextConfig = function() {
          this.textConfig = null, this.markRedraw();
        }, u.prototype.removeTextContent = function() {
          var o = this._textContent;
          o && (o.innerTransformable = null, this._detachComponent(o), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
        }, u.prototype.getTextGuideLine = function() {
          return this._textGuide;
        }, u.prototype.setTextGuideLine = function(o) {
          this._textGuide && this._textGuide !== o && this.removeTextGuideLine(), this._attachComponent(o), this._textGuide = o, this.markRedraw();
        }, u.prototype.removeTextGuideLine = function() {
          var o = this._textGuide;
          o && (this._detachComponent(o), this._textGuide = null, this.markRedraw());
        }, u.prototype.markRedraw = function() {
          this.__dirty |= Ab2;
          var o = this.__zr;
          o && (this.__inHover ? o.refreshHover() : o.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
        }, u.prototype.dirty = function() {
          this.markRedraw();
        }, u.prototype._toggleHoverLayerFlag = function(o) {
          this.__inHover = o;
          var n3 = this._textContent, p2 = this._textGuide;
          n3 && (n3.__inHover = o), p2 && (p2.__inHover = o);
        }, u.prototype.addSelfToZr = function(o) {
          if (this.__zr !== o) {
            this.__zr = o;
            var n3 = this.animators;
            if (n3)
              for (var p2 = 0; p2 < n3.length; p2++)
                o.animation.addAnimator(n3[p2]);
            this._clipPath && this._clipPath.addSelfToZr(o), this._textContent && this._textContent.addSelfToZr(o), this._textGuide && this._textGuide.addSelfToZr(o);
          }
        }, u.prototype.removeSelfFromZr = function(o) {
          if (this.__zr) {
            this.__zr = null;
            var n3 = this.animators;
            if (n3)
              for (var p2 = 0; p2 < n3.length; p2++)
                o.animation.removeAnimator(n3[p2]);
            this._clipPath && this._clipPath.removeSelfFromZr(o), this._textContent && this._textContent.removeSelfFromZr(o), this._textGuide && this._textGuide.removeSelfFromZr(o);
          }
        }, u.prototype.animate = function(o, n3, p2) {
          var m2 = o ? this[o] : this, w2 = new Yy(m2, n3, p2);
          return o && (w2.targetName = o), this.addAnimator(w2, o), w2;
        }, u.prototype.addAnimator = function(o, n3) {
          var p2 = this.__zr, m2 = this;
          o.during(function() {
            m2.updateDuringAnimation(n3);
          }).done(function() {
            var w2 = m2.animators, T2 = sc2(w2, o);
            T2 >= 0 && w2.splice(T2, 1);
          }), this.animators.push(o), p2 && p2.animation.addAnimator(o), p2 && p2.wakeUp();
        }, u.prototype.updateDuringAnimation = function(o) {
          this.markRedraw();
        }, u.prototype.stopAnimation = function(o, n3) {
          for (var p2 = this.animators, m2 = p2.length, w2 = [], T2 = 0; T2 < m2; T2++) {
            var E = p2[T2];
            !o || o === E.scope ? E.stop(n3) : w2.push(E);
          }
          return this.animators = w2, this;
        }, u.prototype.animateTo = function(o, n3, p2) {
          vat(this, o, n3, p2);
        }, u.prototype.animateFrom = function(o, n3, p2) {
          vat(this, o, n3, p2, true);
        }, u.prototype._transitionState = function(o, n3, p2, m2) {
          for (var w2 = vat(this, n3, p2, m2), T2 = 0; T2 < w2.length; T2++)
            w2[T2].__fromStateTransition = o;
        }, u.prototype.getBoundingRect = function() {
          return null;
        }, u.prototype.getPaintRect = function() {
          return null;
        }, u.initDefaultProps = function() {
          var o = u.prototype;
          o.type = "element", o.name = "", o.ignore = o.silent = o.isGroup = o.draggable = o.dragging = o.ignoreClip = o.__inHover = false, o.__dirty = Ab2;
          function n3(p2, m2, w2, T2) {
            Object.defineProperty(o, p2, { get: function() {
              if (!this[m2]) {
                var O2 = this[m2] = [];
                E(this, O2);
              }
              return this[m2];
            }, set: function(O2) {
              this[w2] = O2[0], this[T2] = O2[1], this[m2] = O2, E(this, O2);
            } });
            function E(O2, V3) {
              Object.defineProperty(V3, 0, { get: function() {
                return O2[w2];
              }, set: function(W3) {
                O2[w2] = W3;
              } }), Object.defineProperty(V3, 1, { get: function() {
                return O2[T2];
              }, set: function(W3) {
                O2[T2] = W3;
              } });
            }
          }
          Object.defineProperty && (n3("position", "_legacyPos", "x", "y"), n3("scale", "_legacyScale", "scaleX", "scaleY"), n3("origin", "_legacyOrigin", "originX", "originY"));
        }(), u;
      }();
      x0(gat, gw), x0(gat, JS);
      function vat(u, o, n3, p2, m2) {
        n3 = n3 || {};
        var w2 = [];
        Y_(u, "", u, o, n3, p2, w2, m2);
        var T2 = w2.length, E = false, O2 = n3.done, V3 = n3.aborted, W3 = function() {
          E = true, T2--, T2 <= 0 && (E ? O2 && O2() : V3 && V3());
        }, q3 = function() {
          T2--, T2 <= 0 && (E ? O2 && O2() : V3 && V3());
        };
        T2 || O2 && O2(), w2.length > 0 && n3.during && w2[0].during(function(rt2, gt) {
          n3.during(gt);
        });
        for (var K = 0; K < w2.length; K++) {
          var J = w2[K];
          W3 && J.done(W3), q3 && J.aborted(q3), n3.force && J.duration(n3.duration), J.start(n3.easing);
        }
        return w2;
      }
      function a$(u, o, n3) {
        for (var p2 = 0; p2 < n3; p2++)
          u[p2] = o[p2];
      }
      function ibt(u) {
        return M1(u[0]);
      }
      function pNt(u, o, n3) {
        if (M1(o[n3]))
          if (M1(u[n3]) || (u[n3] = []), HS(o[n3])) {
            var p2 = o[n3].length;
            u[n3].length !== p2 && (u[n3] = new o[n3].constructor(p2), a$(u[n3], o[n3], p2));
          } else {
            var m2 = o[n3], w2 = u[n3], T2 = m2.length;
            if (ibt(m2))
              for (var E = m2[0].length, O2 = 0; O2 < T2; O2++)
                w2[O2] ? a$(w2[O2], m2[O2], E) : w2[O2] = Array.prototype.slice.call(m2[O2]);
            else
              a$(w2, m2, T2);
            w2.length = m2.length;
          }
        else
          u[n3] = o[n3];
      }
      function abt(u, o) {
        return u === o || M1(u) && M1(o) && obt(u, o);
      }
      function obt(u, o) {
        var n3 = u.length;
        if (n3 !== o.length)
          return false;
        for (var p2 = 0; p2 < n3; p2++)
          if (u[p2] !== o[p2])
            return false;
        return true;
      }
      function Y_(u, o, n3, p2, m2, w2, T2, E) {
        for (var O2 = tf2(p2), V3 = m2.duration, W3 = m2.delay, q3 = m2.additive, K = m2.setToFinal, J = !ys(w2), rt2 = u.animators, gt = [], yt = 0; yt < O2.length; yt++) {
          var At = O2[yt], Lt = p2[At];
          if (Lt != null && n3[At] != null && (J || w2[At]))
            if (ys(Lt) && !M1(Lt) && !OZ(Lt)) {
              if (o) {
                E || (n3[At] = Lt, u.updateDuringAnimation(o));
                continue;
              }
              Y_(u, At, n3[At], Lt, m2, w2 && w2[At], T2, E);
            } else
              gt.push(At);
          else
            E || (n3[At] = Lt, u.updateDuringAnimation(o), gt.push(At));
        }
        var Wt = gt.length;
        if (!q3 && Wt)
          for (var Nt = 0; Nt < rt2.length; Nt++) {
            var ue2 = rt2[Nt];
            if (ue2.targetName === o) {
              var ie2 = ue2.stopTracks(gt);
              if (ie2) {
                var pe2 = sc2(rt2, ue2);
                rt2.splice(pe2, 1);
              }
            }
          }
        if (m2.force || (gt = Fp(gt, function(ze) {
          return !abt(p2[ze], n3[ze]);
        }), Wt = gt.length), Wt > 0 || m2.force && !T2.length) {
          var xe = void 0, Ce2 = void 0, Le2 = void 0;
          if (E) {
            Ce2 = {}, K && (xe = {});
            for (var Nt = 0; Nt < Wt; Nt++) {
              var At = gt[Nt];
              Ce2[At] = n3[At], K ? xe[At] = p2[At] : n3[At] = p2[At];
            }
          } else if (K) {
            Le2 = {};
            for (var Nt = 0; Nt < Wt; Nt++) {
              var At = gt[Nt];
              Le2[At] = XS(n3[At]), pNt(n3, p2, At);
            }
          }
          var ue2 = new Yy(n3, false, false, q3 ? Fp(rt2, function(tn) {
            return tn.targetName === o;
          }) : null);
          ue2.targetName = o, m2.scope && (ue2.scope = m2.scope), K && xe && ue2.whenWithKeys(0, xe, gt), Le2 && ue2.whenWithKeys(0, Le2, gt), ue2.whenWithKeys(V3 == null ? 500 : V3, E ? Ce2 : p2, gt).delay(W3 || 0), u.addAnimator(ue2, o), T2.push(ue2);
        }
      }
      var TC = gat, sbt = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this) || this;
          return p2.isGroup = true, p2._children = [], p2.attr(n3), p2;
        }
        return o.prototype.childrenRef = function() {
          return this._children;
        }, o.prototype.children = function() {
          return this._children.slice();
        }, o.prototype.childAt = function(n3) {
          return this._children[n3];
        }, o.prototype.childOfName = function(n3) {
          for (var p2 = this._children, m2 = 0; m2 < p2.length; m2++)
            if (p2[m2].name === n3)
              return p2[m2];
        }, o.prototype.childCount = function() {
          return this._children.length;
        }, o.prototype.add = function(n3) {
          return n3 && n3 !== this && n3.parent !== this && (this._children.push(n3), this._doAdd(n3)), this;
        }, o.prototype.addBefore = function(n3, p2) {
          if (n3 && n3 !== this && n3.parent !== this && p2 && p2.parent === this) {
            var m2 = this._children, w2 = m2.indexOf(p2);
            w2 >= 0 && (m2.splice(w2, 0, n3), this._doAdd(n3));
          }
          return this;
        }, o.prototype.replace = function(n3, p2) {
          var m2 = sc2(this._children, n3);
          return m2 >= 0 && this.replaceAt(p2, m2), this;
        }, o.prototype.replaceAt = function(n3, p2) {
          var m2 = this._children, w2 = m2[p2];
          if (n3 && n3 !== this && n3.parent !== this && n3 !== w2) {
            m2[p2] = n3, w2.parent = null;
            var T2 = this.__zr;
            T2 && w2.removeSelfFromZr(T2), this._doAdd(n3);
          }
          return this;
        }, o.prototype._doAdd = function(n3) {
          n3.parent && n3.parent.remove(n3), n3.parent = this;
          var p2 = this.__zr;
          p2 && p2 !== n3.__zr && n3.addSelfToZr(p2), p2 && p2.refresh();
        }, o.prototype.remove = function(n3) {
          var p2 = this.__zr, m2 = this._children, w2 = sc2(m2, n3);
          return w2 < 0 ? this : (m2.splice(w2, 1), n3.parent = null, p2 && n3.removeSelfFromZr(p2), p2 && p2.refresh(), this);
        }, o.prototype.removeAll = function() {
          for (var n3 = this._children, p2 = this.__zr, m2 = 0; m2 < n3.length; m2++) {
            var w2 = n3[m2];
            p2 && w2.removeSelfFromZr(p2), w2.parent = null;
          }
          return n3.length = 0, this;
        }, o.prototype.eachChild = function(n3, p2) {
          for (var m2 = this._children, w2 = 0; w2 < m2.length; w2++) {
            var T2 = m2[w2];
            n3.call(p2, T2, w2);
          }
          return this;
        }, o.prototype.traverse = function(n3, p2) {
          for (var m2 = 0; m2 < this._children.length; m2++) {
            var w2 = this._children[m2], T2 = n3.call(p2, w2);
            w2.isGroup && !T2 && w2.traverse(n3, p2);
          }
          return this;
        }, o.prototype.addSelfToZr = function(n3) {
          u.prototype.addSelfToZr.call(this, n3);
          for (var p2 = 0; p2 < this._children.length; p2++) {
            var m2 = this._children[p2];
            m2.addSelfToZr(n3);
          }
        }, o.prototype.removeSelfFromZr = function(n3) {
          u.prototype.removeSelfFromZr.call(this, n3);
          for (var p2 = 0; p2 < this._children.length; p2++) {
            var m2 = this._children[p2];
            m2.removeSelfFromZr(n3);
          }
        }, o.prototype.getBoundingRect = function(n3) {
          for (var p2 = new Qu(0, 0, 0, 0), m2 = n3 || this._children, w2 = [], T2 = null, E = 0; E < m2.length; E++) {
            var O2 = m2[E];
            if (!(O2.ignore || O2.invisible)) {
              var V3 = O2.getBoundingRect(), W3 = O2.getLocalTransform(w2);
              W3 ? (Qu.applyTransform(p2, V3, W3), T2 = T2 || p2.clone(), T2.union(p2)) : (T2 = T2 || V3.clone(), T2.union(V3));
            }
          }
          return T2 || p2;
        }, o;
      }(TC);
      sbt.prototype.type = "group";
      var uu = sbt;
      /*!
      * ZRender, a high performance 2d drawing library.
      *
      * Copyright (c) 2013, Baidu Inc.
      * All rights reserved.
      *
      * LICENSE
      * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
      */
      var i4 = {}, a4 = {};
      function lbt(u) {
        delete a4[u];
      }
      function ubt(u) {
        if (!u)
          return false;
        if (typeof u == "string")
          return qZ(u, 1) < cat;
        if (u.colorStops) {
          for (var o = u.colorStops, n3 = 0, p2 = o.length, m2 = 0; m2 < p2; m2++)
            n3 += qZ(o[m2].color, 1);
          return n3 /= p2, n3 < cat;
        }
        return false;
      }
      var dNt = function() {
        function u(o, n3, p2) {
          var m2 = this;
          this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, p2 = p2 || {}, this.dom = n3, this.id = o;
          var w2 = new Z6t(), T2 = p2.renderer || "canvas";
          i4[T2] || (T2 = tf2(i4)[0]), p2.useDirtyRect = p2.useDirtyRect == null ? false : p2.useDirtyRect;
          var E = new i4[T2](n3, w2, p2, o), O2 = p2.ssr || E.ssrOnly;
          this.storage = w2, this.painter = E;
          var V3 = !Ys.node && !Ys.worker && !O2 ? new Q1t(E.getViewportRoot(), E.root) : null;
          this.handler = new ef2(w2, E, V3, E.root), this.animation = new $A({ stage: { update: O2 ? null : function() {
            return m2._flush(true);
          } } }), O2 || this.animation.start();
        }
        return u.prototype.add = function(o) {
          !o || (this.storage.addRoot(o), o.addSelfToZr(this), this.refresh());
        }, u.prototype.remove = function(o) {
          !o || (this.storage.delRoot(o), o.removeSelfFromZr(this), this.refresh());
        }, u.prototype.configLayer = function(o, n3) {
          this.painter.configLayer && this.painter.configLayer(o, n3), this.refresh();
        }, u.prototype.setBackgroundColor = function(o) {
          this.painter.setBackgroundColor && this.painter.setBackgroundColor(o), this.refresh(), this._backgroundColor = o, this._darkMode = ubt(o);
        }, u.prototype.getBackgroundColor = function() {
          return this._backgroundColor;
        }, u.prototype.setDarkMode = function(o) {
          this._darkMode = o;
        }, u.prototype.isDarkMode = function() {
          return this._darkMode;
        }, u.prototype.refreshImmediately = function(o) {
          o || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
        }, u.prototype.refresh = function() {
          this._needsRefresh = true, this.animation.start();
        }, u.prototype.flush = function() {
          this._flush(false);
        }, u.prototype._flush = function(o) {
          var n3, p2 = MP();
          this._needsRefresh && (n3 = true, this.refreshImmediately(o)), this._needsRefreshHover && (n3 = true, this.refreshHoverImmediately());
          var m2 = MP();
          n3 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: m2 - p2 })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
        }, u.prototype.setSleepAfterStill = function(o) {
          this._sleepAfterStill = o;
        }, u.prototype.wakeUp = function() {
          this.animation.start(), this._stillFrameAccum = 0;
        }, u.prototype.refreshHover = function() {
          this._needsRefreshHover = true;
        }, u.prototype.refreshHoverImmediately = function() {
          this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
        }, u.prototype.resize = function(o) {
          o = o || {}, this.painter.resize(o.width, o.height), this.handler.resize();
        }, u.prototype.clearAnimation = function() {
          this.animation.clear();
        }, u.prototype.getWidth = function() {
          return this.painter.getWidth();
        }, u.prototype.getHeight = function() {
          return this.painter.getHeight();
        }, u.prototype.setCursorStyle = function(o) {
          this.handler.setCursorStyle(o);
        }, u.prototype.findHover = function(o, n3) {
          return this.handler.findHover(o, n3);
        }, u.prototype.on = function(o, n3, p2) {
          return this.handler.on(o, n3, p2), this;
        }, u.prototype.off = function(o, n3) {
          this.handler.off(o, n3);
        }, u.prototype.trigger = function(o, n3) {
          this.handler.trigger(o, n3);
        }, u.prototype.clear = function() {
          for (var o = this.storage.getRoots(), n3 = 0; n3 < o.length; n3++)
            o[n3] instanceof uu && o[n3].removeSelfFromZr(this);
          this.storage.delAllRoots(), this.painter.clear();
        }, u.prototype.dispose = function() {
          this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, lbt(this.id);
        }, u;
      }();
      function yat(u, o) {
        var n3 = new dNt(bF(), u, o);
        return a4[n3.id] = n3, n3;
      }
      function HF(u, o) {
        i4[u] = o;
      }
      var UF = 1e-4, cbt = 20;
      function fbt(u) {
        return u.replace(/^\s+|\s+$/g, "");
      }
      function bp(u, o, n3, p2) {
        var m2 = o[0], w2 = o[1], T2 = n3[0], E = n3[1], O2 = w2 - m2, V3 = E - T2;
        if (O2 === 0)
          return V3 === 0 ? T2 : (T2 + E) / 2;
        if (p2)
          if (O2 > 0) {
            if (u <= m2)
              return T2;
            if (u >= w2)
              return E;
          } else {
            if (u >= m2)
              return T2;
            if (u <= w2)
              return E;
          }
        else {
          if (u === m2)
            return T2;
          if (u === w2)
            return E;
        }
        return (u - m2) / O2 * V3 + T2;
      }
      function Qo(u, o) {
        switch (u) {
          case "center":
          case "middle":
            u = "50%";
            break;
          case "left":
          case "top":
            u = "0%";
            break;
          case "right":
          case "bottom":
            u = "100%";
            break;
        }
        return ds(u) ? fbt(u).match(/%$/) ? parseFloat(u) / 100 * o : parseFloat(u) : u == null ? NaN : +u;
      }
      function Ov(u, o, n3) {
        return o == null && (o = 10), o = Math.min(Math.max(0, o), cbt), u = (+u).toFixed(o), n3 ? u : +u;
      }
      function K_(u) {
        return u.sort(function(o, n3) {
          return o - n3;
        }), u;
      }
      function oM(u) {
        if (u = +u, isNaN(u))
          return 0;
        if (u > 1e-14) {
          for (var o = 1, n3 = 0; n3 < 15; n3++, o *= 10)
            if (Math.round(u * o) / o === u)
              return n3;
        }
        return o$(u);
      }
      function o$(u) {
        var o = u.toString().toLowerCase(), n3 = o.indexOf("e"), p2 = n3 > 0 ? +o.slice(n3 + 1) : 0, m2 = n3 > 0 ? n3 : o.length, w2 = o.indexOf("."), T2 = w2 < 0 ? 0 : m2 - 1 - w2;
        return Math.max(0, T2 - p2);
      }
      function hbt(u, o) {
        var n3 = Math.log, p2 = Math.LN10, m2 = Math.floor(n3(u[1] - u[0]) / p2), w2 = Math.round(n3(Math.abs(o[1] - o[0])) / p2), T2 = Math.min(Math.max(-m2 + w2, 0), 20);
        return isFinite(T2) ? T2 : 20;
      }
      function pbt(u, o, n3) {
        if (!u[o])
          return 0;
        var p2 = jA(u, function(rt2, gt) {
          return rt2 + (isNaN(gt) ? 0 : gt);
        }, 0);
        if (p2 === 0)
          return 0;
        for (var m2 = Math.pow(10, n3), w2 = Ya2(u, function(rt2) {
          return (isNaN(rt2) ? 0 : rt2) / p2 * m2 * 100;
        }), T2 = m2 * 100, E = Ya2(w2, function(rt2) {
          return Math.floor(rt2);
        }), O2 = jA(E, function(rt2, gt) {
          return rt2 + gt;
        }, 0), V3 = Ya2(w2, function(rt2, gt) {
          return rt2 - E[gt];
        }); O2 < T2; ) {
          for (var W3 = Number.NEGATIVE_INFINITY, q3 = null, K = 0, J = V3.length; K < J; ++K)
            V3[K] > W3 && (W3 = V3[K], q3 = K);
          ++E[q3], V3[q3] = 0, ++O2;
        }
        return E[o] / m2;
      }
      function s$(u, o) {
        var n3 = Math.max(oM(u), oM(o)), p2 = u + o;
        return n3 > cbt ? p2 : Ov(p2, n3);
      }
      var mat = 9007199254740991;
      function l$(u) {
        var o = Math.PI * 2;
        return (u % o + o) % o;
      }
      function u$(u) {
        return u > -UF && u < UF;
      }
      var dbt = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
      function Nm(u) {
        if (u instanceof Date)
          return u;
        if (ds(u)) {
          var o = dbt.exec(u);
          if (!o)
            return new Date(NaN);
          if (o[8]) {
            var n3 = +o[4] || 0;
            return o[8].toUpperCase() !== "Z" && (n3 -= +o[8].slice(0, 3)), new Date(Date.UTC(+o[1], +(o[2] || 1) - 1, +o[3] || 1, n3, +(o[5] || 0), +o[6] || 0, o[7] ? +o[7].substring(0, 3) : 0));
          } else
            return new Date(+o[1], +(o[2] || 1) - 1, +o[3] || 1, +o[4] || 0, +(o[5] || 0), +o[6] || 0, o[7] ? +o[7].substring(0, 3) : 0);
        } else if (u == null)
          return new Date(NaN);
        return new Date(Math.round(u));
      }
      function gbt(u) {
        return Math.pow(10, c$(u));
      }
      function c$(u) {
        if (u === 0)
          return 0;
        var o = Math.floor(Math.log(u) / Math.LN10);
        return u / Math.pow(10, o) >= 10 && o++, o;
      }
      function vbt(u, o) {
        var n3 = c$(u), p2 = Math.pow(10, n3), m2 = u / p2, w2;
        return o ? m2 < 1.5 ? w2 = 1 : m2 < 2.5 ? w2 = 2 : m2 < 4 ? w2 = 3 : m2 < 7 ? w2 = 5 : w2 = 10 : m2 < 1 ? w2 = 1 : m2 < 2 ? w2 = 2 : m2 < 3 ? w2 = 3 : m2 < 5 ? w2 = 5 : w2 = 10, u = w2 * p2, n3 >= -20 ? +u.toFixed(n3 < 0 ? -n3 : 0) : u;
      }
      function f$(u, o) {
        var n3 = (u.length - 1) * o + 1, p2 = Math.floor(n3), m2 = +u[p2 - 1], w2 = n3 - p2;
        return w2 ? m2 + w2 * (u[p2] - m2) : m2;
      }
      function ybt(u) {
        u.sort(function(O2, V3) {
          return E(O2, V3, 0) ? -1 : 1;
        });
        for (var o = -1 / 0, n3 = 1, p2 = 0; p2 < u.length; ) {
          for (var m2 = u[p2].interval, w2 = u[p2].close, T2 = 0; T2 < 2; T2++)
            m2[T2] <= o && (m2[T2] = o, w2[T2] = T2 ? 1 : 1 - n3), o = m2[T2], n3 = w2[T2];
          m2[0] === m2[1] && w2[0] * w2[1] !== 1 ? u.splice(p2, 1) : p2++;
        }
        return u;
        function E(O2, V3, W3) {
          return O2.interval[W3] < V3.interval[W3] || O2.interval[W3] === V3.interval[W3] && (O2.close[W3] - V3.close[W3] === (W3 ? -1 : 1) || !W3 && E(O2, V3, 1));
        }
      }
      function QE(u) {
        var o = parseFloat(u);
        return o == u && (o !== 0 || !ds(u) || u.indexOf("x") <= 0) ? o : NaN;
      }
      function JA(u) {
        return !isNaN(QE(u));
      }
      function h$() {
        return Math.round(Math.random() * 9);
      }
      function p$(u, o) {
        return o === 0 ? u : p$(o, u % o);
      }
      function d$(u, o) {
        return u == null ? o : o == null ? u : u * o / p$(u, o);
      }
      function lh2(u) {
        throw new Error(u);
      }
      function o4(u, o, n3) {
        return (o - u) * n3 + u;
      }
      var Ju = "series\0", lz = "\0_ec_\0";
      function Tp(u) {
        return u instanceof Array ? u : u == null ? [] : [u];
      }
      function t22(u, o, n3) {
        if (u) {
          u[o] = u[o] || {}, u.emphasis = u.emphasis || {}, u.emphasis[o] = u.emphasis[o] || {};
          for (var p2 = 0, m2 = n3.length; p2 < m2; p2++) {
            var w2 = n3[p2];
            !u.emphasis[o].hasOwnProperty(w2) && u[o].hasOwnProperty(w2) && (u.emphasis[o][w2] = u[o][w2]);
          }
        }
      }
      var mbt = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
      function PP(u) {
        return ys(u) && !za2(u) && !(u instanceof Date) ? u.value : u;
      }
      function bbt(u) {
        return ys(u) && !(u instanceof Array);
      }
      function I1(u, o, n3) {
        var p2 = n3 === "normalMerge", m2 = n3 === "replaceMerge", w2 = n3 === "replaceAll";
        u = u || [], o = (o || []).slice();
        var T2 = pl();
        Xe2(o, function(O2, V3) {
          if (!ys(O2)) {
            o[V3] = null;
            return;
          }
        });
        var E = gNt(u, T2, n3);
        return (p2 || m2) && vNt(E, u, T2, o), p2 && _bt(E, o), p2 || m2 ? yNt(E, o, m2) : w2 && xbt(E, o), mNt(E), E;
      }
      function gNt(u, o, n3) {
        var p2 = [];
        if (n3 === "replaceAll")
          return p2;
        for (var m2 = 0; m2 < u.length; m2++) {
          var w2 = u[m2];
          w2 && w2.id != null && o.set(w2.id, m2), p2.push({ existing: n3 === "replaceMerge" || s4(w2) ? null : w2, newOption: null, keyInfo: null, brandNew: null });
        }
        return p2;
      }
      function vNt(u, o, n3, p2) {
        Xe2(p2, function(m2, w2) {
          if (!(!m2 || m2.id == null)) {
            var T2 = uz(m2.id), E = n3.get(T2);
            if (E != null) {
              var O2 = u[E];
              Tb2(!O2.newOption, 'Duplicated option on id "' + T2 + '".'), O2.newOption = m2, O2.existing = o[E], p2[w2] = null;
            }
          }
        });
      }
      function _bt(u, o) {
        Xe2(o, function(n3, p2) {
          if (!(!n3 || n3.name == null))
            for (var m2 = 0; m2 < u.length; m2++) {
              var w2 = u[m2].existing;
              if (!u[m2].newOption && w2 && (w2.id == null || n3.id == null) && !s4(n3) && !s4(w2) && wbt("name", w2, n3)) {
                u[m2].newOption = n3, o[p2] = null;
                return;
              }
            }
        });
      }
      function yNt(u, o, n3) {
        Xe2(o, function(p2) {
          if (p2) {
            for (var m2, w2 = 0; (m2 = u[w2]) && (m2.newOption || s4(m2.existing) || m2.existing && p2.id != null && !wbt("id", p2, m2.existing)); )
              w2++;
            m2 ? (m2.newOption = p2, m2.brandNew = n3) : u.push({ newOption: p2, brandNew: n3, existing: null, keyInfo: null }), w2++;
          }
        });
      }
      function xbt(u, o) {
        Xe2(o, function(n3) {
          u.push({ newOption: n3, brandNew: true, existing: null, keyInfo: null });
        });
      }
      function mNt(u) {
        var o = pl();
        Xe2(u, function(n3) {
          var p2 = n3.existing;
          p2 && o.set(p2.id, n3);
        }), Xe2(u, function(n3) {
          var p2 = n3.newOption;
          Tb2(!p2 || p2.id == null || !o.get(p2.id) || o.get(p2.id) === n3, "id duplicates: " + (p2 && p2.id)), p2 && p2.id != null && o.set(p2.id, n3), !n3.keyInfo && (n3.keyInfo = {});
        }), Xe2(u, function(n3, p2) {
          var m2 = n3.existing, w2 = n3.newOption, T2 = n3.keyInfo;
          if (ys(w2)) {
            if (T2.name = w2.name != null ? uz(w2.name) : m2 ? m2.name : Ju + p2, m2)
              T2.id = uz(m2.id);
            else if (w2.id != null)
              T2.id = uz(w2.id);
            else {
              var E = 0;
              do
                T2.id = "\0" + T2.name + "\0" + E++;
              while (o.get(T2.id));
            }
            o.set(T2.id, n3);
          }
        });
      }
      function wbt(u, o, n3) {
        var p2 = $d2(o[u], null), m2 = $d2(n3[u], null);
        return p2 != null && m2 != null && p2 === m2;
      }
      function uz(u) {
        return $d2(u, "");
      }
      function $d2(u, o) {
        return u == null ? o : ds(u) ? u : Dh2(u) || Nit(u) ? u + "" : o;
      }
      function D1(u) {
        var o = u.name;
        return !!(o && o.indexOf(Ju));
      }
      function s4(u) {
        return u && u.id != null && uz(u.id).indexOf(lz) === 0;
      }
      function bNt(u) {
        return lz + u;
      }
      function bat(u, o, n3) {
        Xe2(u, function(p2) {
          var m2 = p2.newOption;
          ys(m2) && (p2.keyInfo.mainType = o, p2.keyInfo.subType = _Nt(o, m2, p2.existing, n3));
        });
      }
      function _Nt(u, o, n3, p2) {
        var m2 = o.type ? o.type : n3 ? n3.subType : p2.determineSubType(u, o);
        return m2;
      }
      function xNt(u, o) {
        var n3 = {}, p2 = {};
        return m2(u || [], n3), m2(o || [], p2, n3), [w2(n3), w2(p2)];
        function m2(T2, E, O2) {
          for (var V3 = 0, W3 = T2.length; V3 < W3; V3++) {
            var q3 = $d2(T2[V3].seriesId, null);
            if (q3 == null)
              return;
            for (var K = Tp(T2[V3].dataIndex), J = O2 && O2[q3], rt2 = 0, gt = K.length; rt2 < gt; rt2++) {
              var yt = K[rt2];
              J && J[yt] ? J[yt] = null : (E[q3] || (E[q3] = {}))[yt] = 1;
            }
          }
        }
        function w2(T2, E) {
          var O2 = [];
          for (var V3 in T2)
            if (T2.hasOwnProperty(V3) && T2[V3] != null)
              if (E)
                O2.push(+V3);
              else {
                var W3 = w2(T2[V3], true);
                W3.length && O2.push({ seriesId: V3, dataIndex: W3 });
              }
          return O2;
        }
      }
      function AC(u, o) {
        if (o.dataIndexInside != null)
          return o.dataIndexInside;
        if (o.dataIndex != null)
          return za2(o.dataIndex) ? Ya2(o.dataIndex, function(n3) {
            return u.indexOfRawIndex(n3);
          }) : u.indexOfRawIndex(o.dataIndex);
        if (o.name != null)
          return za2(o.name) ? Ya2(o.name, function(n3) {
            return u.indexOfName(n3);
          }) : u.indexOfName(o.name);
      }
      function Ff2() {
        var u = "__ec_inner_" + Sbt++;
        return function(o) {
          return o[u] || (o[u] = {});
        };
      }
      var Sbt = h$();
      function cz(u, o, n3) {
        var p2 = _at(o, n3), m2 = p2.mainTypeSpecified, w2 = p2.queryOptionMap, T2 = p2.others, E = T2, O2 = n3 ? n3.defaultMainType : null;
        return !m2 && O2 && w2.set(O2, {}), w2.each(function(V3, W3) {
          var q3 = qF(u, W3, V3, { useDefault: O2 === W3, enableAll: n3 && n3.enableAll != null ? n3.enableAll : true, enableNone: n3 && n3.enableNone != null ? n3.enableNone : true });
          E[W3 + "Models"] = q3.models, E[W3 + "Model"] = q3.models[0];
        }), E;
      }
      function _at(u, o) {
        var n3;
        if (ds(u)) {
          var p2 = {};
          p2[u + "Index"] = 0, n3 = p2;
        } else
          n3 = u;
        var m2 = pl(), w2 = {}, T2 = false;
        return Xe2(n3, function(E, O2) {
          if (O2 === "dataIndex" || O2 === "dataIndexInside") {
            w2[O2] = E;
            return;
          }
          var V3 = O2.match(/^(\w+)(Index|Id|Name)$/) || [], W3 = V3[1], q3 = (V3[2] || "").toLowerCase();
          if (!(!W3 || !q3 || o && o.includeMainTypes && sc2(o.includeMainTypes, W3) < 0)) {
            T2 = T2 || !!W3;
            var K = m2.get(W3) || m2.set(W3, {});
            K[q3] = E;
          }
        }), { mainTypeSpecified: T2, queryOptionMap: m2, others: w2 };
      }
      var Y0 = { useDefault: true, enableAll: false, enableNone: false }, wNt = { useDefault: false, enableAll: true, enableNone: true };
      function qF(u, o, n3, p2) {
        p2 = p2 || Y0;
        var m2 = n3.index, w2 = n3.id, T2 = n3.name, E = { models: null, specified: m2 != null || w2 != null || T2 != null };
        if (!E.specified) {
          var O2 = void 0;
          return E.models = p2.useDefault && (O2 = u.getComponent(o)) ? [O2] : [], E;
        }
        return m2 === "none" || m2 === false ? (Tb2(p2.enableNone, '`"none"` or `false` is not a valid value on index option.'), E.models = [], E) : (m2 === "all" && (Tb2(p2.enableAll, '`"all"` is not a valid value on index option.'), m2 = w2 = T2 = null), E.models = u.queryComponents({ mainType: o, index: m2, id: w2, name: T2 }), E);
      }
      function xat(u, o, n3) {
        u.setAttribute ? u.setAttribute(o, n3) : u[o] = n3;
      }
      function SNt(u, o) {
        return u.getAttribute ? u.getAttribute(o) : u[o];
      }
      function wat(u) {
        return u === "auto" ? Ys.domSupported ? "html" : "richText" : u || "html";
      }
      function g$(u, o) {
        var n3 = pl(), p2 = [];
        return Xe2(u, function(m2) {
          var w2 = o(m2);
          (n3.get(w2) || (p2.push(w2), n3.set(w2, []))).push(m2);
        }), { keys: p2, buckets: n3 };
      }
      function ZF(u, o, n3, p2, m2) {
        var w2 = o == null || o === "auto";
        if (p2 == null)
          return p2;
        if (Dh2(p2)) {
          var T2 = o4(n3 || 0, p2, m2);
          return Ov(T2, w2 ? Math.max(oM(n3 || 0), oM(p2)) : o);
        } else {
          if (ds(p2))
            return m2 < 1 ? n3 : p2;
          for (var E = [], O2 = n3, V3 = p2, W3 = Math.max(O2 ? O2.length : 0, V3.length), q3 = 0; q3 < W3; ++q3) {
            var K = u.getDimensionInfo(q3);
            if (K && K.type === "ordinal")
              E[q3] = (m2 < 1 && O2 ? O2 : V3)[q3];
            else {
              var J = O2 && O2[q3] ? O2[q3] : 0, rt2 = V3[q3], T2 = o4(J, rt2, m2);
              E[q3] = Ov(T2, w2 ? Math.max(oM(J), oM(rt2)) : o);
            }
          }
          return E;
        }
      }
      var Sat = ".", LP = "___EC__COMPONENT__CONTAINER___", Mat = "___EC__EXTENDED_CLASS___";
      function e22(u) {
        var o = { main: "", sub: "" };
        if (u) {
          var n3 = u.split(Sat);
          o.main = n3[0] || "", o.sub = n3[1] || "";
        }
        return o;
      }
      function Mbt(u) {
        Tb2(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(u), 'componentType "' + u + '" illegal');
      }
      function tI(u) {
        return !!(u && u[Mat]);
      }
      function JE(u, o) {
        u.$constructor = u, u.extend = function(n3) {
          var p2 = this, m2;
          return MNt(p2) ? m2 = function(w2) {
            tr(T2, w2);
            function T2() {
              return w2.apply(this, arguments) || this;
            }
            return T2;
          }(p2) : (m2 = function() {
            (n3.$constructor || p2).apply(this, arguments);
          }, M1t(m2, this)), ua2(m2.prototype, n3), m2[Mat] = true, m2.extend = this.extend, m2.superCall = ANt, m2.superApply = INt, m2.superClass = p2, m2;
        };
      }
      function MNt(u) {
        return Sl(u) && /^class\s/.test(Function.prototype.toString.call(u));
      }
      function Cat(u, o) {
        u.extend = o.extend;
      }
      var CNt = Math.round(Math.random() * 10);
      function TNt(u) {
        var o = ["__\0is_clz", CNt++].join("_");
        u.prototype[o] = true, u.isInstance = function(n3) {
          return !!(n3 && n3[o]);
        };
      }
      function ANt(u, o) {
        for (var n3 = [], p2 = 2; p2 < arguments.length; p2++)
          n3[p2 - 2] = arguments[p2];
        return this.superClass.prototype[o].apply(u, n3);
      }
      function INt(u, o, n3) {
        return this.superClass.prototype[o].apply(u, n3);
      }
      function v$(u) {
        var o = {};
        u.registerClass = function(p2) {
          var m2 = p2.type || p2.prototype.type;
          if (m2) {
            Mbt(m2), p2.prototype.type = m2;
            var w2 = e22(m2);
            if (!w2.sub)
              o[w2.main] = p2;
            else if (w2.sub !== LP) {
              var T2 = n3(w2);
              T2[w2.sub] = p2;
            }
          }
          return p2;
        }, u.getClass = function(p2, m2, w2) {
          var T2 = o[p2];
          if (T2 && T2[LP] && (T2 = m2 ? T2[m2] : null), w2 && !T2)
            throw new Error(m2 ? "Component " + p2 + "." + (m2 || "") + " is used but not imported." : p2 + ".type should be specified.");
          return T2;
        }, u.getClassesByMainType = function(p2) {
          var m2 = e22(p2), w2 = [], T2 = o[m2.main];
          return T2 && T2[LP] ? Xe2(T2, function(E, O2) {
            O2 !== LP && w2.push(E);
          }) : w2.push(T2), w2;
        }, u.hasClass = function(p2) {
          var m2 = e22(p2);
          return !!o[m2.main];
        }, u.getAllClassMainTypes = function() {
          var p2 = [];
          return Xe2(o, function(m2, w2) {
            p2.push(w2);
          }), p2;
        }, u.hasSubTypes = function(p2) {
          var m2 = e22(p2), w2 = o[m2.main];
          return w2 && w2[LP];
        };
        function n3(p2) {
          var m2 = o[p2.main];
          return (!m2 || !m2[LP]) && (m2 = o[p2.main] = {}, m2[LP] = true), m2;
        }
      }
      function l4(u, o) {
        for (var n3 = 0; n3 < u.length; n3++)
          u[n3][1] || (u[n3][1] = u[n3][0]);
        return o = o || false, function(p2, m2, w2) {
          for (var T2 = {}, E = 0; E < u.length; E++) {
            var O2 = u[E][1];
            if (!(m2 && sc2(m2, O2) >= 0 || w2 && sc2(w2, O2) < 0)) {
              var V3 = p2.getShallow(O2, o);
              V3 != null && (T2[u[E][0]] = V3);
            }
          }
          return T2;
        };
      }
      var DNt = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], ENt = l4(DNt), kNt = function() {
        function u() {
        }
        return u.prototype.getAreaStyle = function(o, n3) {
          return ENt(this, o, n3);
        }, u;
      }(), Tat = new QB(50);
      function PNt(u) {
        if (typeof u == "string") {
          var o = Tat.get(u);
          return o && o.image;
        } else
          return u;
      }
      function y$(u, o, n3, p2, m2) {
        if (u)
          if (typeof u == "string") {
            if (o && o.__zrImageSrc === u || !n3)
              return o;
            var w2 = Tat.get(u), T2 = { hostEl: n3, cb: p2, cbPayload: m2 };
            if (w2)
              o = w2.image, !fz(o) && w2.pending.push(T2);
            else {
              var E = pw.loadImage(u, Aat, Aat);
              E.__zrImageSrc = u, Tat.put(u, E.__cachedImgObj = { image: E, pending: [T2] });
            }
            return o;
          } else
            return u;
        else
          return o;
      }
      function Aat() {
        var u = this.__cachedImgObj;
        this.onload = this.onerror = this.__cachedImgObj = null;
        for (var o = 0; o < u.pending.length; o++) {
          var n3 = u.pending[o], p2 = n3.cb;
          p2 && p2(this, n3.cbPayload), n3.hostEl.dirty();
        }
        u.pending.length = 0;
      }
      function fz(u) {
        return u && u.width && u.height;
      }
      var Iat = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
      function LNt(u, o, n3, p2, m2) {
        if (!o)
          return "";
        var w2 = (u + "").split(`
`);
        m2 = Cbt(o, n3, p2, m2);
        for (var T2 = 0, E = w2.length; T2 < E; T2++)
          w2[T2] = Dat(w2[T2], m2);
        return w2.join(`
`);
      }
      function Cbt(u, o, n3, p2) {
        p2 = p2 || {};
        var m2 = ua2({}, p2);
        m2.font = o, n3 = Xu(n3, "..."), m2.maxIterations = Xu(p2.maxIterations, 2);
        var w2 = m2.minChar = Xu(p2.minChar, 0);
        m2.cnCharWidth = Eb2("\u56FD", o);
        var T2 = m2.ascCharWidth = Eb2("a", o);
        m2.placeholder = Xu(p2.placeholder, "");
        for (var E = u = Math.max(0, u - 1), O2 = 0; O2 < w2 && E >= T2; O2++)
          E -= T2;
        var V3 = Eb2(n3, o);
        return V3 > E && (n3 = "", V3 = 0), E = u - V3, m2.ellipsis = n3, m2.ellipsisWidth = V3, m2.contentWidth = E, m2.containerWidth = u, m2;
      }
      function Dat(u, o) {
        var n3 = o.containerWidth, p2 = o.font, m2 = o.contentWidth;
        if (!n3)
          return "";
        var w2 = Eb2(u, p2);
        if (w2 <= n3)
          return u;
        for (var T2 = 0; ; T2++) {
          if (w2 <= m2 || T2 >= o.maxIterations) {
            u += o.ellipsis;
            break;
          }
          var E = T2 === 0 ? ONt(u, m2, o.ascCharWidth, o.cnCharWidth) : w2 > 0 ? Math.floor(u.length * m2 / w2) : 0;
          u = u.substr(0, E), w2 = Eb2(u, p2);
        }
        return u === "" && (u = o.placeholder), u;
      }
      function ONt(u, o, n3, p2) {
        for (var m2 = 0, w2 = 0, T2 = u.length; w2 < T2 && m2 < o; w2++) {
          var E = u.charCodeAt(w2);
          m2 += 0 <= E && E <= 127 ? n3 : p2;
        }
        return w2;
      }
      function RNt(u, o) {
        u != null && (u += "");
        var n3 = o.overflow, p2 = o.padding, m2 = o.font, w2 = n3 === "truncate", T2 = GF(m2), E = Xu(o.lineHeight, T2), O2 = !!o.backgroundColor, V3 = o.lineOverflow === "truncate", W3 = o.width, q3;
        W3 != null && (n3 === "break" || n3 === "breakAll") ? q3 = u ? Eat(u, o.font, W3, n3 === "breakAll", 0).lines : [] : q3 = u ? u.split(`
`) : [];
        var K = q3.length * E, J = Xu(o.height, K);
        if (K > J && V3) {
          var rt2 = Math.floor(J / E);
          q3 = q3.slice(0, rt2);
        }
        if (u && w2 && W3 != null)
          for (var gt = Cbt(W3, m2, o.ellipsis, { minChar: o.truncateMinChar, placeholder: o.placeholder }), yt = 0; yt < q3.length; yt++)
            q3[yt] = Dat(q3[yt], gt);
        for (var At = J, Lt = 0, yt = 0; yt < q3.length; yt++)
          Lt = Math.max(Eb2(q3[yt], m2), Lt);
        W3 == null && (W3 = Lt);
        var Wt = Lt;
        return p2 && (At += p2[0] + p2[2], Wt += p2[1] + p2[3], W3 += p2[1] + p2[3]), O2 && (Wt = W3), { lines: q3, height: J, outerWidth: Wt, outerHeight: At, lineHeight: E, calculatedLineHeight: T2, contentWidth: Lt, contentHeight: K, width: W3 };
      }
      var NNt = function() {
        function u() {
        }
        return u;
      }(), Tbt = function() {
        function u(o) {
          this.tokens = [], o && (this.tokens = o);
        }
        return u;
      }(), FNt = function() {
        function u() {
          this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
        }
        return u;
      }();
      function VNt(u, o) {
        var n3 = new FNt();
        if (u != null && (u += ""), !u)
          return n3;
        for (var p2 = o.width, m2 = o.height, w2 = o.overflow, T2 = (w2 === "break" || w2 === "breakAll") && p2 != null ? { width: p2, accumWidth: 0, breakAll: w2 === "breakAll" } : null, E = Iat.lastIndex = 0, O2; (O2 = Iat.exec(u)) != null; ) {
          var V3 = O2.index;
          V3 > E && mw(n3, u.substring(E, V3), o, T2), mw(n3, O2[2], o, T2, O2[1]), E = Iat.lastIndex;
        }
        E < u.length && mw(n3, u.substring(E, u.length), o, T2);
        var W3 = [], q3 = 0, K = 0, J = o.padding, rt2 = w2 === "truncate", gt = o.lineOverflow === "truncate";
        function yt(Xn, or, Tr) {
          Xn.width = or, Xn.lineHeight = Tr, q3 += Tr, K = Math.max(K, or);
        }
        t:
          for (var At = 0; At < n3.lines.length; At++) {
            for (var Lt = n3.lines[At], Wt = 0, Nt = 0, ue2 = 0; ue2 < Lt.tokens.length; ue2++) {
              var ie2 = Lt.tokens[ue2], pe2 = ie2.styleName && o.rich[ie2.styleName] || {}, xe = ie2.textPadding = pe2.padding, Ce2 = xe ? xe[1] + xe[3] : 0, Le2 = ie2.font = pe2.font || o.font;
              ie2.contentHeight = GF(Le2);
              var ze = Xu(pe2.height, ie2.contentHeight);
              if (ie2.innerHeight = ze, xe && (ze += xe[0] + xe[2]), ie2.height = ze, ie2.lineHeight = gv(pe2.lineHeight, o.lineHeight, ze), ie2.align = pe2 && pe2.align || o.align, ie2.verticalAlign = pe2 && pe2.verticalAlign || "middle", gt && m2 != null && q3 + ie2.lineHeight > m2) {
                ue2 > 0 ? (Lt.tokens = Lt.tokens.slice(0, ue2), yt(Lt, Nt, Wt), n3.lines = n3.lines.slice(0, At + 1)) : n3.lines = n3.lines.slice(0, At);
                break t;
              }
              var tn = pe2.width, $e2 = tn == null || tn === "auto";
              if (typeof tn == "string" && tn.charAt(tn.length - 1) === "%")
                ie2.percentWidth = tn, W3.push(ie2), ie2.contentWidth = Eb2(ie2.text, Le2);
              else {
                if ($e2) {
                  var Tn = pe2.backgroundColor, zn = Tn && Tn.image;
                  zn && (zn = PNt(zn), fz(zn) && (ie2.width = Math.max(ie2.width, zn.width * ze / zn.height)));
                }
                var bn = rt2 && p2 != null ? p2 - Nt : null;
                bn != null && bn < ie2.width ? !$e2 || bn < Ce2 ? (ie2.text = "", ie2.width = ie2.contentWidth = 0) : (ie2.text = LNt(ie2.text, bn - Ce2, Le2, o.ellipsis, { minChar: o.truncateMinChar }), ie2.width = ie2.contentWidth = Eb2(ie2.text, Le2)) : ie2.contentWidth = Eb2(ie2.text, Le2);
              }
              ie2.width += Ce2, Nt += ie2.width, pe2 && (Wt = Math.max(Wt, ie2.lineHeight));
            }
            yt(Lt, Nt, Wt);
          }
        n3.outerWidth = n3.width = Xu(p2, K), n3.outerHeight = n3.height = Xu(m2, q3), n3.contentHeight = q3, n3.contentWidth = K, J && (n3.outerWidth += J[1] + J[3], n3.outerHeight += J[0] + J[2]);
        for (var At = 0; At < W3.length; At++) {
          var ie2 = W3[At], Xr = ie2.percentWidth;
          ie2.width = parseInt(Xr, 10) / 100 * n3.width;
        }
        return n3;
      }
      function mw(u, o, n3, p2, m2) {
        var w2 = o === "", T2 = m2 && n3.rich[m2] || {}, E = u.lines, O2 = T2.font || n3.font, V3 = false, W3, q3;
        if (p2) {
          var K = T2.padding, J = K ? K[1] + K[3] : 0;
          if (T2.width != null && T2.width !== "auto") {
            var rt2 = Rm(T2.width, p2.width) + J;
            E.length > 0 && rt2 + p2.accumWidth > p2.width && (W3 = o.split(`
`), V3 = true), p2.accumWidth = rt2;
          } else {
            var gt = Eat(o, O2, p2.width, p2.breakAll, p2.accumWidth);
            p2.accumWidth = gt.accumWidth + J, q3 = gt.linesWidths, W3 = gt.lines;
          }
        } else
          W3 = o.split(`
`);
        for (var yt = 0; yt < W3.length; yt++) {
          var At = W3[yt], Lt = new NNt();
          if (Lt.styleName = m2, Lt.text = At, Lt.isLineHolder = !At && !w2, typeof T2.width == "number" ? Lt.width = T2.width : Lt.width = q3 ? q3[yt] : Eb2(At, O2), !yt && !V3) {
            var Wt = (E[E.length - 1] || (E[0] = new Tbt())).tokens, Nt = Wt.length;
            Nt === 1 && Wt[0].isLineHolder ? Wt[0] = Lt : (At || !Nt || w2) && Wt.push(Lt);
          } else
            E.push(new Tbt([Lt]));
        }
      }
      function BNt(u) {
        var o = u.charCodeAt(0);
        return o >= 33 && o <= 383;
      }
      var zNt = jA(",&?/;] ".split(""), function(u, o) {
        return u[o] = true, u;
      }, {});
      function jNt(u) {
        return BNt(u) ? !!zNt[u] : true;
      }
      function Eat(u, o, n3, p2, m2) {
        for (var w2 = [], T2 = [], E = "", O2 = "", V3 = 0, W3 = 0, q3 = 0; q3 < u.length; q3++) {
          var K = u.charAt(q3);
          if (K === `
`) {
            O2 && (E += O2, W3 += V3), w2.push(E), T2.push(W3), E = "", O2 = "", V3 = 0, W3 = 0;
            continue;
          }
          var J = Eb2(K, o), rt2 = p2 ? false : !jNt(K);
          if (w2.length ? W3 + J > n3 : m2 + W3 + J > n3) {
            W3 ? (E || O2) && (rt2 ? (E || (E = O2, O2 = "", V3 = 0, W3 = V3), w2.push(E), T2.push(W3 - V3), O2 += K, V3 += J, E = "", W3 = V3) : (O2 && (E += O2, O2 = "", V3 = 0), w2.push(E), T2.push(W3), E = K, W3 = J)) : rt2 ? (w2.push(O2), T2.push(V3), O2 = K, V3 = J) : (w2.push(K), T2.push(J));
            continue;
          }
          W3 += J, rt2 ? (O2 += K, V3 += J) : (O2 && (E += O2, O2 = "", V3 = 0), E += K);
        }
        return !w2.length && !E && (E = u, O2 = "", V3 = 0), O2 && (E += O2), E && (w2.push(E), T2.push(W3)), w2.length === 1 && (W3 += m2), { accumWidth: W3, lines: w2, linesWidths: T2 };
      }
      var kat = "__zr_style_" + Math.round(Math.random() * 10), u4 = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, m$ = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
      u4[kat] = true;
      var Abt = ["z", "z2", "invisible"], Pat = ["invisible"], WNt = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype._init = function(n3) {
          for (var p2 = tf2(n3), m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2];
            w2 === "style" ? this.useStyle(n3[w2]) : u.prototype.attrKV.call(this, w2, n3[w2]);
          }
          this.style || this.useStyle({});
        }, o.prototype.beforeBrush = function() {
        }, o.prototype.afterBrush = function() {
        }, o.prototype.innerBeforeBrush = function() {
        }, o.prototype.innerAfterBrush = function() {
        }, o.prototype.shouldBePainted = function(n3, p2, m2, w2) {
          var T2 = this.transform;
          if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && GNt(this, n3, p2) || T2 && !T2[0] && !T2[3])
            return false;
          if (m2 && this.__clipPaths) {
            for (var E = 0; E < this.__clipPaths.length; ++E)
              if (this.__clipPaths[E].isZeroArea())
                return false;
          }
          if (w2 && this.parent)
            for (var O2 = this.parent; O2; ) {
              if (O2.ignore)
                return false;
              O2 = O2.parent;
            }
          return true;
        }, o.prototype.contain = function(n3, p2) {
          return this.rectContain(n3, p2);
        }, o.prototype.traverse = function(n3, p2) {
          n3.call(p2, this);
        }, o.prototype.rectContain = function(n3, p2) {
          var m2 = this.transformCoordToLocal(n3, p2), w2 = this.getBoundingRect();
          return w2.contain(m2[0], m2[1]);
        }, o.prototype.getPaintRect = function() {
          var n3 = this._paintRect;
          if (!this._paintRect || this.__dirty) {
            var p2 = this.transform, m2 = this.getBoundingRect(), w2 = this.style, T2 = w2.shadowBlur || 0, E = w2.shadowOffsetX || 0, O2 = w2.shadowOffsetY || 0;
            n3 = this._paintRect || (this._paintRect = new Qu(0, 0, 0, 0)), p2 ? Qu.applyTransform(n3, m2, p2) : n3.copy(m2), (T2 || E || O2) && (n3.width += T2 * 2 + Math.abs(E), n3.height += T2 * 2 + Math.abs(O2), n3.x = Math.min(n3.x, n3.x + E - T2), n3.y = Math.min(n3.y, n3.y + O2 - T2));
            var V3 = this.dirtyRectTolerance;
            n3.isZero() || (n3.x = Math.floor(n3.x - V3), n3.y = Math.floor(n3.y - V3), n3.width = Math.ceil(n3.width + 1 + V3 * 2), n3.height = Math.ceil(n3.height + 1 + V3 * 2));
          }
          return n3;
        }, o.prototype.setPrevPaintRect = function(n3) {
          n3 ? (this._prevPaintRect = this._prevPaintRect || new Qu(0, 0, 0, 0), this._prevPaintRect.copy(n3)) : this._prevPaintRect = null;
        }, o.prototype.getPrevPaintRect = function() {
          return this._prevPaintRect;
        }, o.prototype.animateStyle = function(n3) {
          return this.animate("style", n3);
        }, o.prototype.updateDuringAnimation = function(n3) {
          n3 === "style" ? this.dirtyStyle() : this.markRedraw();
        }, o.prototype.attrKV = function(n3, p2) {
          n3 !== "style" ? u.prototype.attrKV.call(this, n3, p2) : this.style ? this.setStyle(p2) : this.useStyle(p2);
        }, o.prototype.setStyle = function(n3, p2) {
          return typeof n3 == "string" ? this.style[n3] = p2 : ua2(this.style, n3), this.dirtyStyle(), this;
        }, o.prototype.dirtyStyle = function(n3) {
          n3 || this.markRedraw(), this.__dirty |= Vp, this._rect && (this._rect = null);
        }, o.prototype.dirty = function() {
          this.dirtyStyle();
        }, o.prototype.styleChanged = function() {
          return !!(this.__dirty & Vp);
        }, o.prototype.styleUpdated = function() {
          this.__dirty &= ~Vp;
        }, o.prototype.createStyle = function(n3) {
          return WB(u4, n3);
        }, o.prototype.useStyle = function(n3) {
          n3[kat] || (n3 = this.createStyle(n3)), this.__inHover ? this.__hoverStyle = n3 : this.style = n3, this.dirtyStyle();
        }, o.prototype.isStyleObject = function(n3) {
          return n3[kat];
        }, o.prototype._innerSaveToNormal = function(n3) {
          u.prototype._innerSaveToNormal.call(this, n3);
          var p2 = this._normalState;
          n3.style && !p2.style && (p2.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(n3, p2, Abt);
        }, o.prototype._applyStateObj = function(n3, p2, m2, w2, T2, E) {
          u.prototype._applyStateObj.call(this, n3, p2, m2, w2, T2, E);
          var O2 = !(p2 && w2), V3;
          if (p2 && p2.style ? T2 ? w2 ? V3 = p2.style : (V3 = this._mergeStyle(this.createStyle(), m2.style), this._mergeStyle(V3, p2.style)) : (V3 = this._mergeStyle(this.createStyle(), w2 ? this.style : m2.style), this._mergeStyle(V3, p2.style)) : O2 && (V3 = m2.style), V3)
            if (T2) {
              var W3 = this.style;
              if (this.style = this.createStyle(O2 ? {} : W3), O2)
                for (var q3 = tf2(W3), K = 0; K < q3.length; K++) {
                  var J = q3[K];
                  J in V3 && (V3[J] = V3[J], this.style[J] = W3[J]);
                }
              for (var rt2 = tf2(V3), K = 0; K < rt2.length; K++) {
                var J = rt2[K];
                this.style[J] = this.style[J];
              }
              this._transitionState(n3, { style: V3 }, E, this.getAnimationStyleProps());
            } else
              this.useStyle(V3);
          for (var gt = this.__inHover ? Pat : Abt, K = 0; K < gt.length; K++) {
            var J = gt[K];
            p2 && p2[J] != null ? this[J] = p2[J] : O2 && m2[J] != null && (this[J] = m2[J]);
          }
        }, o.prototype._mergeStates = function(n3) {
          for (var p2 = u.prototype._mergeStates.call(this, n3), m2, w2 = 0; w2 < n3.length; w2++) {
            var T2 = n3[w2];
            T2.style && (m2 = m2 || {}, this._mergeStyle(m2, T2.style));
          }
          return m2 && (p2.style = m2), p2;
        }, o.prototype._mergeStyle = function(n3, p2) {
          return ua2(n3, p2), n3;
        }, o.prototype.getAnimationStyleProps = function() {
          return m$;
        }, o.initDefaultProps = function() {
          var n3 = o.prototype;
          n3.type = "displayable", n3.invisible = false, n3.z = 0, n3.z2 = 0, n3.zlevel = 0, n3.culling = false, n3.cursor = "pointer", n3.rectHover = false, n3.incremental = false, n3._rect = null, n3.dirtyRectTolerance = 0, n3.__dirty = Ab2 | Vp;
        }(), o;
      }(TC), Lat = new Qu(0, 0, 0, 0), Oat = new Qu(0, 0, 0, 0);
      function GNt(u, o, n3) {
        return Lat.copy(u.getBoundingRect()), u.transform && Lat.applyTransform(u.transform), Oat.width = o, Oat.height = n3, !Lat.intersect(Oat);
      }
      var sM = WNt, bw = Math.min, _w = Math.max, Rat = Math.sin, Nat = Math.cos, c4 = Math.PI * 2, b$ = mP(), _$ = mP(), x$ = mP();
      function w$(u, o, n3) {
        if (u.length !== 0) {
          for (var p2 = u[0], m2 = p2[0], w2 = p2[0], T2 = p2[1], E = p2[1], O2 = 1; O2 < u.length; O2++)
            p2 = u[O2], m2 = bw(m2, p2[0]), w2 = _w(w2, p2[0]), T2 = bw(T2, p2[1]), E = _w(E, p2[1]);
          o[0] = m2, o[1] = T2, n3[0] = w2, n3[1] = E;
        }
      }
      function Ibt(u, o, n3, p2, m2, w2) {
        m2[0] = bw(u, n3), m2[1] = bw(o, p2), w2[0] = _w(u, n3), w2[1] = _w(o, p2);
      }
      var Dbt = [], Ebt = [];
      function HNt(u, o, n3, p2, m2, w2, T2, E, O2, V3) {
        var W3 = R1t, q3 = S0, K = W3(u, n3, m2, T2, Dbt);
        O2[0] = 1 / 0, O2[1] = 1 / 0, V3[0] = -1 / 0, V3[1] = -1 / 0;
        for (var J = 0; J < K; J++) {
          var rt2 = q3(u, n3, m2, T2, Dbt[J]);
          O2[0] = bw(rt2, O2[0]), V3[0] = _w(rt2, V3[0]);
        }
        K = W3(o, p2, w2, E, Ebt);
        for (var J = 0; J < K; J++) {
          var gt = q3(o, p2, w2, E, Ebt[J]);
          O2[1] = bw(gt, O2[1]), V3[1] = _w(gt, V3[1]);
        }
        O2[0] = bw(u, O2[0]), V3[0] = _w(u, V3[0]), O2[0] = bw(T2, O2[0]), V3[0] = _w(T2, V3[0]), O2[1] = bw(o, O2[1]), V3[1] = _w(o, V3[1]), O2[1] = bw(E, O2[1]), V3[1] = _w(E, V3[1]);
      }
      function UNt(u, o, n3, p2, m2, w2, T2, E) {
        var O2 = F1t, V3 = lp, W3 = _w(bw(O2(u, n3, m2), 1), 0), q3 = _w(bw(O2(o, p2, w2), 1), 0), K = V3(u, n3, m2, W3), J = V3(o, p2, w2, q3);
        T2[0] = bw(u, m2, K), T2[1] = bw(o, w2, J), E[0] = _w(u, m2, K), E[1] = _w(o, w2, J);
      }
      function qNt(u, o, n3, p2, m2, w2, T2, E, O2) {
        var V3 = HE, W3 = GA, q3 = Math.abs(m2 - w2);
        if (q3 % c4 < 1e-4 && q3 > 1e-4) {
          E[0] = u - n3, E[1] = o - p2, O2[0] = u + n3, O2[1] = o + p2;
          return;
        }
        if (b$[0] = Nat(m2) * n3 + u, b$[1] = Rat(m2) * p2 + o, _$[0] = Nat(w2) * n3 + u, _$[1] = Rat(w2) * p2 + o, V3(E, b$, _$), W3(O2, b$, _$), m2 = m2 % c4, m2 < 0 && (m2 = m2 + c4), w2 = w2 % c4, w2 < 0 && (w2 = w2 + c4), m2 > w2 && !T2 ? w2 += c4 : m2 < w2 && T2 && (m2 += c4), T2) {
          var K = w2;
          w2 = m2, m2 = K;
        }
        for (var J = 0; J < w2; J += Math.PI / 2)
          J > m2 && (x$[0] = Nat(J) * n3 + u, x$[1] = Rat(J) * p2 + o, V3(E, x$, E), W3(O2, x$, O2));
      }
      var ed2 = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, OP = [], f4 = [], eI = [], RP = [], nI = [], rI = [], Fat = Math.min, Vat = Math.max, h4 = Math.cos, NP = Math.sin, tk2 = Math.abs, $F = Math.PI, FP = $F * 2, Bat = typeof Float32Array != "undefined", hz = [];
      function zat(u) {
        var o = Math.round(u / $F * 1e8) / 1e8;
        return o % 2 * $F;
      }
      function ZNt(u, o) {
        var n3 = zat(u[0]);
        n3 < 0 && (n3 += FP);
        var p2 = n3 - u[0], m2 = u[1];
        m2 += p2, !o && m2 - n3 >= FP ? m2 = n3 + FP : o && n3 - m2 >= FP ? m2 = n3 - FP : !o && n3 > m2 ? m2 = n3 + (FP - zat(n3 - m2)) : o && n3 < m2 && (m2 = n3 - (FP - zat(m2 - n3))), u[0] = n3, u[1] = m2;
      }
      var $Nt = function() {
        function u(o) {
          this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, o && (this._saveData = false), this._saveData && (this.data = []);
        }
        return u.prototype.increaseVersion = function() {
          this._version++;
        }, u.prototype.getVersion = function() {
          return this._version;
        }, u.prototype.setScale = function(o, n3, p2) {
          p2 = p2 || 0, p2 > 0 && (this._ux = tk2(p2 / QZ / o) || 0, this._uy = tk2(p2 / QZ / n3) || 0);
        }, u.prototype.setDPR = function(o) {
          this.dpr = o;
        }, u.prototype.setContext = function(o) {
          this._ctx = o;
        }, u.prototype.getContext = function() {
          return this._ctx;
        }, u.prototype.beginPath = function() {
          return this._ctx && this._ctx.beginPath(), this.reset(), this;
        }, u.prototype.reset = function() {
          this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
        }, u.prototype.moveTo = function(o, n3) {
          return this._drawPendingPt(), this.addData(ed2.M, o, n3), this._ctx && this._ctx.moveTo(o, n3), this._x0 = o, this._y0 = n3, this._xi = o, this._yi = n3, this;
        }, u.prototype.lineTo = function(o, n3) {
          var p2 = tk2(o - this._xi), m2 = tk2(n3 - this._yi), w2 = p2 > this._ux || m2 > this._uy;
          if (this.addData(ed2.L, o, n3), this._ctx && w2 && this._ctx.lineTo(o, n3), w2)
            this._xi = o, this._yi = n3, this._pendingPtDist = 0;
          else {
            var T2 = p2 * p2 + m2 * m2;
            T2 > this._pendingPtDist && (this._pendingPtX = o, this._pendingPtY = n3, this._pendingPtDist = T2);
          }
          return this;
        }, u.prototype.bezierCurveTo = function(o, n3, p2, m2, w2, T2) {
          return this._drawPendingPt(), this.addData(ed2.C, o, n3, p2, m2, w2, T2), this._ctx && this._ctx.bezierCurveTo(o, n3, p2, m2, w2, T2), this._xi = w2, this._yi = T2, this;
        }, u.prototype.quadraticCurveTo = function(o, n3, p2, m2) {
          return this._drawPendingPt(), this.addData(ed2.Q, o, n3, p2, m2), this._ctx && this._ctx.quadraticCurveTo(o, n3, p2, m2), this._xi = p2, this._yi = m2, this;
        }, u.prototype.arc = function(o, n3, p2, m2, w2, T2) {
          this._drawPendingPt(), hz[0] = m2, hz[1] = w2, ZNt(hz, T2), m2 = hz[0], w2 = hz[1];
          var E = w2 - m2;
          return this.addData(ed2.A, o, n3, p2, p2, m2, E, 0, T2 ? 0 : 1), this._ctx && this._ctx.arc(o, n3, p2, m2, w2, T2), this._xi = h4(w2) * p2 + o, this._yi = NP(w2) * p2 + n3, this;
        }, u.prototype.arcTo = function(o, n3, p2, m2, w2) {
          return this._drawPendingPt(), this._ctx && this._ctx.arcTo(o, n3, p2, m2, w2), this;
        }, u.prototype.rect = function(o, n3, p2, m2) {
          return this._drawPendingPt(), this._ctx && this._ctx.rect(o, n3, p2, m2), this.addData(ed2.R, o, n3, p2, m2), this;
        }, u.prototype.closePath = function() {
          this._drawPendingPt(), this.addData(ed2.Z);
          var o = this._ctx, n3 = this._x0, p2 = this._y0;
          return o && o.closePath(), this._xi = n3, this._yi = p2, this;
        }, u.prototype.fill = function(o) {
          o && o.fill(), this.toStatic();
        }, u.prototype.stroke = function(o) {
          o && o.stroke(), this.toStatic();
        }, u.prototype.len = function() {
          return this._len;
        }, u.prototype.setData = function(o) {
          var n3 = o.length;
          !(this.data && this.data.length === n3) && Bat && (this.data = new Float32Array(n3));
          for (var p2 = 0; p2 < n3; p2++)
            this.data[p2] = o[p2];
          this._len = n3;
        }, u.prototype.appendPath = function(o) {
          o instanceof Array || (o = [o]);
          for (var n3 = o.length, p2 = 0, m2 = this._len, w2 = 0; w2 < n3; w2++)
            p2 += o[w2].len();
          Bat && this.data instanceof Float32Array && (this.data = new Float32Array(m2 + p2));
          for (var w2 = 0; w2 < n3; w2++)
            for (var T2 = o[w2].data, E = 0; E < T2.length; E++)
              this.data[m2++] = T2[E];
          this._len = m2;
        }, u.prototype.addData = function(o, n3, p2, m2, w2, T2, E, O2, V3) {
          if (this._saveData) {
            var W3 = this.data;
            this._len + arguments.length > W3.length && (this._expandData(), W3 = this.data);
            for (var q3 = 0; q3 < arguments.length; q3++)
              W3[this._len++] = arguments[q3];
          }
        }, u.prototype._drawPendingPt = function() {
          this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
        }, u.prototype._expandData = function() {
          if (!(this.data instanceof Array)) {
            for (var o = [], n3 = 0; n3 < this._len; n3++)
              o[n3] = this.data[n3];
            this.data = o;
          }
        }, u.prototype.toStatic = function() {
          if (this._saveData) {
            this._drawPendingPt();
            var o = this.data;
            o instanceof Array && (o.length = this._len, Bat && this._len > 11 && (this.data = new Float32Array(o)));
          }
        }, u.prototype.getBoundingRect = function() {
          eI[0] = eI[1] = nI[0] = nI[1] = Number.MAX_VALUE, RP[0] = RP[1] = rI[0] = rI[1] = -Number.MAX_VALUE;
          var o = this.data, n3 = 0, p2 = 0, m2 = 0, w2 = 0, T2;
          for (T2 = 0; T2 < this._len; ) {
            var E = o[T2++], O2 = T2 === 1;
            switch (O2 && (n3 = o[T2], p2 = o[T2 + 1], m2 = n3, w2 = p2), E) {
              case ed2.M:
                n3 = m2 = o[T2++], p2 = w2 = o[T2++], nI[0] = m2, nI[1] = w2, rI[0] = m2, rI[1] = w2;
                break;
              case ed2.L:
                Ibt(n3, p2, o[T2], o[T2 + 1], nI, rI), n3 = o[T2++], p2 = o[T2++];
                break;
              case ed2.C:
                HNt(n3, p2, o[T2++], o[T2++], o[T2++], o[T2++], o[T2], o[T2 + 1], nI, rI), n3 = o[T2++], p2 = o[T2++];
                break;
              case ed2.Q:
                UNt(n3, p2, o[T2++], o[T2++], o[T2], o[T2 + 1], nI, rI), n3 = o[T2++], p2 = o[T2++];
                break;
              case ed2.A:
                var V3 = o[T2++], W3 = o[T2++], q3 = o[T2++], K = o[T2++], J = o[T2++], rt2 = o[T2++] + J;
                T2 += 1;
                var gt = !o[T2++];
                O2 && (m2 = h4(J) * q3 + V3, w2 = NP(J) * K + W3), qNt(V3, W3, q3, K, J, rt2, gt, nI, rI), n3 = h4(rt2) * q3 + V3, p2 = NP(rt2) * K + W3;
                break;
              case ed2.R:
                m2 = n3 = o[T2++], w2 = p2 = o[T2++];
                var yt = o[T2++], At = o[T2++];
                Ibt(m2, w2, m2 + yt, w2 + At, nI, rI);
                break;
              case ed2.Z:
                n3 = m2, p2 = w2;
                break;
            }
            HE(eI, eI, nI), GA(RP, RP, rI);
          }
          return T2 === 0 && (eI[0] = eI[1] = RP[0] = RP[1] = 0), new Qu(eI[0], eI[1], RP[0] - eI[0], RP[1] - eI[1]);
        }, u.prototype._calculateLength = function() {
          var o = this.data, n3 = this._len, p2 = this._ux, m2 = this._uy, w2 = 0, T2 = 0, E = 0, O2 = 0;
          this._pathSegLen || (this._pathSegLen = []);
          for (var V3 = this._pathSegLen, W3 = 0, q3 = 0, K = 0; K < n3; ) {
            var J = o[K++], rt2 = K === 1;
            rt2 && (w2 = o[K], T2 = o[K + 1], E = w2, O2 = T2);
            var gt = -1;
            switch (J) {
              case ed2.M:
                w2 = E = o[K++], T2 = O2 = o[K++];
                break;
              case ed2.L: {
                var yt = o[K++], At = o[K++], Lt = yt - w2, Wt = At - T2;
                (tk2(Lt) > p2 || tk2(Wt) > m2 || K === n3 - 1) && (gt = Math.sqrt(Lt * Lt + Wt * Wt), w2 = yt, T2 = At);
                break;
              }
              case ed2.C: {
                var Nt = o[K++], ue2 = o[K++], yt = o[K++], At = o[K++], ie2 = o[K++], pe2 = o[K++];
                gt = $6t(w2, T2, Nt, ue2, yt, At, ie2, pe2, 10), w2 = ie2, T2 = pe2;
                break;
              }
              case ed2.Q: {
                var Nt = o[K++], ue2 = o[K++], yt = o[K++], At = o[K++];
                gt = Kit(w2, T2, Nt, ue2, yt, At, 10), w2 = yt, T2 = At;
                break;
              }
              case ed2.A:
                var xe = o[K++], Ce2 = o[K++], Le2 = o[K++], ze = o[K++], tn = o[K++], $e2 = o[K++], Tn = $e2 + tn;
                K += 1, o[K++], rt2 && (E = h4(tn) * Le2 + xe, O2 = NP(tn) * ze + Ce2), gt = Vat(Le2, ze) * Fat(FP, Math.abs($e2)), w2 = h4(Tn) * Le2 + xe, T2 = NP(Tn) * ze + Ce2;
                break;
              case ed2.R: {
                E = w2 = o[K++], O2 = T2 = o[K++];
                var zn = o[K++], bn = o[K++];
                gt = zn * 2 + bn * 2;
                break;
              }
              case ed2.Z: {
                var Lt = E - w2, Wt = O2 - T2;
                gt = Math.sqrt(Lt * Lt + Wt * Wt), w2 = E, T2 = O2;
                break;
              }
            }
            gt >= 0 && (V3[q3++] = gt, W3 += gt);
          }
          return this._pathLen = W3, W3;
        }, u.prototype.rebuildPath = function(o, n3) {
          var p2 = this.data, m2 = this._ux, w2 = this._uy, T2 = this._len, E, O2, V3, W3, q3, K, J = n3 < 1, rt2, gt, yt = 0, At = 0, Lt, Wt = 0, Nt, ue2;
          if (J && (this._pathSegLen || this._calculateLength(), rt2 = this._pathSegLen, gt = this._pathLen, Lt = n3 * gt, !Lt))
            return;
          t:
            for (var ie2 = 0; ie2 < T2; ) {
              var pe2 = p2[ie2++], xe = ie2 === 1;
              switch (xe && (V3 = p2[ie2], W3 = p2[ie2 + 1], E = V3, O2 = W3), pe2 !== ed2.L && Wt > 0 && (o.lineTo(Nt, ue2), Wt = 0), pe2) {
                case ed2.M:
                  E = V3 = p2[ie2++], O2 = W3 = p2[ie2++], o.moveTo(V3, W3);
                  break;
                case ed2.L: {
                  q3 = p2[ie2++], K = p2[ie2++];
                  var Ce2 = tk2(q3 - V3), Le2 = tk2(K - W3);
                  if (Ce2 > m2 || Le2 > w2) {
                    if (J) {
                      var ze = rt2[At++];
                      if (yt + ze > Lt) {
                        var tn = (Lt - yt) / ze;
                        o.lineTo(V3 * (1 - tn) + q3 * tn, W3 * (1 - tn) + K * tn);
                        break t;
                      }
                      yt += ze;
                    }
                    o.lineTo(q3, K), V3 = q3, W3 = K, Wt = 0;
                  } else {
                    var $e2 = Ce2 * Ce2 + Le2 * Le2;
                    $e2 > Wt && (Nt = q3, ue2 = K, Wt = $e2);
                  }
                  break;
                }
                case ed2.C: {
                  var Tn = p2[ie2++], zn = p2[ie2++], bn = p2[ie2++], Xr = p2[ie2++], Xn = p2[ie2++], or = p2[ie2++];
                  if (J) {
                    var ze = rt2[At++];
                    if (yt + ze > Lt) {
                      var tn = (Lt - yt) / ze;
                      ZE(V3, Tn, bn, Xn, tn, OP), ZE(W3, zn, Xr, or, tn, f4), o.bezierCurveTo(OP[1], f4[1], OP[2], f4[2], OP[3], f4[3]);
                      break t;
                    }
                    yt += ze;
                  }
                  o.bezierCurveTo(Tn, zn, bn, Xr, Xn, or), V3 = Xn, W3 = or;
                  break;
                }
                case ed2.Q: {
                  var Tn = p2[ie2++], zn = p2[ie2++], bn = p2[ie2++], Xr = p2[ie2++];
                  if (J) {
                    var ze = rt2[At++];
                    if (yt + ze > Lt) {
                      var tn = (Lt - yt) / ze;
                      EF(V3, Tn, bn, tn, OP), EF(W3, zn, Xr, tn, f4), o.quadraticCurveTo(OP[1], f4[1], OP[2], f4[2]);
                      break t;
                    }
                    yt += ze;
                  }
                  o.quadraticCurveTo(Tn, zn, bn, Xr), V3 = bn, W3 = Xr;
                  break;
                }
                case ed2.A:
                  var Tr = p2[ie2++], ci2 = p2[ie2++], yi2 = p2[ie2++], Po = p2[ie2++], Ms = p2[ie2++], dl = p2[ie2++], tl = p2[ie2++], el = !p2[ie2++], as = yi2 > Po ? yi2 : Po, Hs = tk2(yi2 - Po) > 1e-3, ol = Ms + dl, xs = false;
                  if (J) {
                    var ze = rt2[At++];
                    yt + ze > Lt && (ol = Ms + dl * (Lt - yt) / ze, xs = true), yt += ze;
                  }
                  if (Hs && o.ellipse ? o.ellipse(Tr, ci2, yi2, Po, tl, Ms, ol, el) : o.arc(Tr, ci2, as, Ms, ol, el), xs)
                    break t;
                  xe && (E = h4(Ms) * yi2 + Tr, O2 = NP(Ms) * Po + ci2), V3 = h4(ol) * yi2 + Tr, W3 = NP(ol) * Po + ci2;
                  break;
                case ed2.R:
                  E = V3 = p2[ie2], O2 = W3 = p2[ie2 + 1], q3 = p2[ie2++], K = p2[ie2++];
                  var Bl = p2[ie2++], Ph2 = p2[ie2++];
                  if (J) {
                    var ze = rt2[At++];
                    if (yt + ze > Lt) {
                      var fu = Lt - yt;
                      o.moveTo(q3, K), o.lineTo(q3 + Fat(fu, Bl), K), fu -= Bl, fu > 0 && o.lineTo(q3 + Bl, K + Fat(fu, Ph2)), fu -= Ph2, fu > 0 && o.lineTo(q3 + Vat(Bl - fu, 0), K + Ph2), fu -= Bl, fu > 0 && o.lineTo(q3, K + Vat(Ph2 - fu, 0));
                      break t;
                    }
                    yt += ze;
                  }
                  o.rect(q3, K, Bl, Ph2);
                  break;
                case ed2.Z:
                  if (J) {
                    var ze = rt2[At++];
                    if (yt + ze > Lt) {
                      var tn = (Lt - yt) / ze;
                      o.lineTo(V3 * (1 - tn) + E * tn, W3 * (1 - tn) + O2 * tn);
                      break t;
                    }
                    yt += ze;
                  }
                  o.closePath(), V3 = E, W3 = O2;
              }
            }
        }, u.prototype.clone = function() {
          var o = new u(), n3 = this.data;
          return o.data = n3.slice ? n3.slice() : Array.prototype.slice.call(n3), o._len = this._len, o;
        }, u.CMD = ed2, u.initDefaultProps = function() {
          var o = u.prototype;
          o._saveData = true, o._ux = 0, o._uy = 0, o._pendingPtDist = 0, o._version = 0;
        }(), u;
      }(), iI = $Nt;
      function VP(u, o, n3, p2, m2, w2, T2) {
        if (m2 === 0)
          return false;
        var E = m2, O2 = 0, V3 = u;
        if (T2 > o + E && T2 > p2 + E || T2 < o - E && T2 < p2 - E || w2 > u + E && w2 > n3 + E || w2 < u - E && w2 < n3 - E)
          return false;
        if (u !== n3)
          O2 = (o - p2) / (u - n3), V3 = (u * p2 - n3 * o) / (u - n3);
        else
          return Math.abs(w2 - u) <= E / 2;
        var W3 = O2 * w2 - T2 + V3, q3 = W3 * W3 / (O2 * O2 + 1);
        return q3 <= E / 2 * E / 2;
      }
      function YNt(u, o, n3, p2, m2, w2, T2, E, O2, V3, W3) {
        if (O2 === 0)
          return false;
        var q3 = O2;
        if (W3 > o + q3 && W3 > p2 + q3 && W3 > w2 + q3 && W3 > E + q3 || W3 < o - q3 && W3 < p2 - q3 && W3 < w2 - q3 && W3 < E - q3 || V3 > u + q3 && V3 > n3 + q3 && V3 > m2 + q3 && V3 > T2 + q3 || V3 < u - q3 && V3 < n3 - q3 && V3 < m2 - q3 && V3 < T2 - q3)
          return false;
        var K = N1t(u, o, n3, p2, m2, w2, T2, E, V3, W3, null);
        return K <= q3 / 2;
      }
      function kbt(u, o, n3, p2, m2, w2, T2, E, O2) {
        if (T2 === 0)
          return false;
        var V3 = T2;
        if (O2 > o + V3 && O2 > p2 + V3 && O2 > w2 + V3 || O2 < o - V3 && O2 < p2 - V3 && O2 < w2 - V3 || E > u + V3 && E > n3 + V3 && E > m2 + V3 || E < u - V3 && E < n3 - V3 && E < m2 - V3)
          return false;
        var W3 = V1t(u, o, n3, p2, m2, w2, E, O2, null);
        return W3 <= V3 / 2;
      }
      var Pbt = Math.PI * 2;
      function BP(u) {
        return u %= Pbt, u < 0 && (u += Pbt), u;
      }
      var pz = Math.PI * 2;
      function KNt(u, o, n3, p2, m2, w2, T2, E, O2) {
        if (T2 === 0)
          return false;
        var V3 = T2;
        E -= u, O2 -= o;
        var W3 = Math.sqrt(E * E + O2 * O2);
        if (W3 - V3 > n3 || W3 + V3 < n3)
          return false;
        if (Math.abs(p2 - m2) % pz < 1e-4)
          return true;
        if (w2) {
          var q3 = p2;
          p2 = BP(m2), m2 = BP(q3);
        } else
          p2 = BP(p2), m2 = BP(m2);
        p2 > m2 && (m2 += pz);
        var K = Math.atan2(O2, E);
        return K < 0 && (K += pz), K >= p2 && K <= m2 || K + pz >= p2 && K + pz <= m2;
      }
      function ek2(u, o, n3, p2, m2, w2) {
        if (w2 > o && w2 > p2 || w2 < o && w2 < p2 || p2 === o)
          return 0;
        var T2 = (w2 - o) / (p2 - o), E = p2 < o ? 1 : -1;
        (T2 === 1 || T2 === 0) && (E = p2 < o ? 0.5 : -0.5);
        var O2 = T2 * (n3 - u) + u;
        return O2 === m2 ? 1 / 0 : O2 > m2 ? E : 0;
      }
      var zP = iI.CMD, jP = Math.PI * 2, Lbt = 1e-4;
      function XNt(u, o) {
        return Math.abs(u - o) < Lbt;
      }
      var X_ = [-1, -1, -1], lM = [-1, -1];
      function QNt() {
        var u = lM[0];
        lM[0] = lM[1], lM[1] = u;
      }
      function S$(u, o, n3, p2, m2, w2, T2, E, O2, V3) {
        if (V3 > o && V3 > p2 && V3 > w2 && V3 > E || V3 < o && V3 < p2 && V3 < w2 && V3 < E)
          return 0;
        var W3 = DF(o, p2, w2, E, V3, X_);
        if (W3 === 0)
          return 0;
        for (var q3 = 0, K = -1, J = void 0, rt2 = void 0, gt = 0; gt < W3; gt++) {
          var yt = X_[gt], At = yt === 0 || yt === 1 ? 0.5 : 1, Lt = S0(u, n3, m2, T2, yt);
          Lt < O2 || (K < 0 && (K = R1t(o, p2, w2, E, lM), lM[1] < lM[0] && K > 1 && QNt(), J = S0(o, p2, w2, E, lM[0]), K > 1 && (rt2 = S0(o, p2, w2, E, lM[1]))), K === 2 ? yt < lM[0] ? q3 += J < o ? At : -At : yt < lM[1] ? q3 += rt2 < J ? At : -At : q3 += E < rt2 ? At : -At : yt < lM[0] ? q3 += J < o ? At : -At : q3 += E < J ? At : -At);
        }
        return q3;
      }
      function JNt(u, o, n3, p2, m2, w2, T2, E) {
        if (E > o && E > p2 && E > w2 || E < o && E < p2 && E < w2)
          return 0;
        var O2 = Y6t(o, p2, w2, E, X_);
        if (O2 === 0)
          return 0;
        var V3 = F1t(o, p2, w2);
        if (V3 >= 0 && V3 <= 1) {
          for (var W3 = 0, q3 = lp(o, p2, w2, V3), K = 0; K < O2; K++) {
            var J = X_[K] === 0 || X_[K] === 1 ? 0.5 : 1, rt2 = lp(u, n3, m2, X_[K]);
            rt2 < T2 || (X_[K] < V3 ? W3 += q3 < o ? J : -J : W3 += w2 < q3 ? J : -J);
          }
          return W3;
        } else {
          var J = X_[0] === 0 || X_[0] === 1 ? 0.5 : 1, rt2 = lp(u, n3, m2, X_[0]);
          return rt2 < T2 ? 0 : w2 < o ? J : -J;
        }
      }
      function tFt(u, o, n3, p2, m2, w2, T2, E) {
        if (E -= o, E > n3 || E < -n3)
          return 0;
        var O2 = Math.sqrt(n3 * n3 - E * E);
        X_[0] = -O2, X_[1] = O2;
        var V3 = Math.abs(p2 - m2);
        if (V3 < 1e-4)
          return 0;
        if (V3 >= jP - 1e-4) {
          p2 = 0, m2 = jP;
          var W3 = w2 ? 1 : -1;
          return T2 >= X_[0] + u && T2 <= X_[1] + u ? W3 : 0;
        }
        if (p2 > m2) {
          var q3 = p2;
          p2 = m2, m2 = q3;
        }
        p2 < 0 && (p2 += jP, m2 += jP);
        for (var K = 0, J = 0; J < 2; J++) {
          var rt2 = X_[J];
          if (rt2 + u > T2) {
            var gt = Math.atan2(E, rt2), W3 = w2 ? 1 : -1;
            gt < 0 && (gt = jP + gt), (gt >= p2 && gt <= m2 || gt + jP >= p2 && gt + jP <= m2) && (gt > Math.PI / 2 && gt < Math.PI * 1.5 && (W3 = -W3), K += W3);
          }
        }
        return K;
      }
      function Obt(u, o, n3, p2, m2) {
        for (var w2 = u.data, T2 = u.len(), E = 0, O2 = 0, V3 = 0, W3 = 0, q3 = 0, K, J, rt2 = 0; rt2 < T2; ) {
          var gt = w2[rt2++], yt = rt2 === 1;
          switch (gt === zP.M && rt2 > 1 && (n3 || (E += ek2(O2, V3, W3, q3, p2, m2))), yt && (O2 = w2[rt2], V3 = w2[rt2 + 1], W3 = O2, q3 = V3), gt) {
            case zP.M:
              W3 = w2[rt2++], q3 = w2[rt2++], O2 = W3, V3 = q3;
              break;
            case zP.L:
              if (n3) {
                if (VP(O2, V3, w2[rt2], w2[rt2 + 1], o, p2, m2))
                  return true;
              } else
                E += ek2(O2, V3, w2[rt2], w2[rt2 + 1], p2, m2) || 0;
              O2 = w2[rt2++], V3 = w2[rt2++];
              break;
            case zP.C:
              if (n3) {
                if (YNt(O2, V3, w2[rt2++], w2[rt2++], w2[rt2++], w2[rt2++], w2[rt2], w2[rt2 + 1], o, p2, m2))
                  return true;
              } else
                E += S$(O2, V3, w2[rt2++], w2[rt2++], w2[rt2++], w2[rt2++], w2[rt2], w2[rt2 + 1], p2, m2) || 0;
              O2 = w2[rt2++], V3 = w2[rt2++];
              break;
            case zP.Q:
              if (n3) {
                if (kbt(O2, V3, w2[rt2++], w2[rt2++], w2[rt2], w2[rt2 + 1], o, p2, m2))
                  return true;
              } else
                E += JNt(O2, V3, w2[rt2++], w2[rt2++], w2[rt2], w2[rt2 + 1], p2, m2) || 0;
              O2 = w2[rt2++], V3 = w2[rt2++];
              break;
            case zP.A:
              var At = w2[rt2++], Lt = w2[rt2++], Wt = w2[rt2++], Nt = w2[rt2++], ue2 = w2[rt2++], ie2 = w2[rt2++];
              rt2 += 1;
              var pe2 = !!(1 - w2[rt2++]);
              K = Math.cos(ue2) * Wt + At, J = Math.sin(ue2) * Nt + Lt, yt ? (W3 = K, q3 = J) : E += ek2(O2, V3, K, J, p2, m2);
              var xe = (p2 - At) * Nt / Wt + At;
              if (n3) {
                if (KNt(At, Lt, Nt, ue2, ue2 + ie2, pe2, o, xe, m2))
                  return true;
              } else
                E += tFt(At, Lt, Nt, ue2, ue2 + ie2, pe2, xe, m2);
              O2 = Math.cos(ue2 + ie2) * Wt + At, V3 = Math.sin(ue2 + ie2) * Nt + Lt;
              break;
            case zP.R:
              W3 = O2 = w2[rt2++], q3 = V3 = w2[rt2++];
              var Ce2 = w2[rt2++], Le2 = w2[rt2++];
              if (K = W3 + Ce2, J = q3 + Le2, n3) {
                if (VP(W3, q3, K, q3, o, p2, m2) || VP(K, q3, K, J, o, p2, m2) || VP(K, J, W3, J, o, p2, m2) || VP(W3, J, W3, q3, o, p2, m2))
                  return true;
              } else
                E += ek2(K, q3, K, J, p2, m2), E += ek2(W3, J, W3, q3, p2, m2);
              break;
            case zP.Z:
              if (n3) {
                if (VP(O2, V3, W3, q3, o, p2, m2))
                  return true;
              } else
                E += ek2(O2, V3, W3, q3, p2, m2);
              O2 = W3, V3 = q3;
              break;
          }
        }
        return !n3 && !XNt(V3, q3) && (E += ek2(O2, V3, W3, q3, p2, m2) || 0), E !== 0;
      }
      function eFt(u, o, n3) {
        return Obt(u, 0, false, o, n3);
      }
      function nFt(u, o, n3, p2) {
        return Obt(u, o, true, n3, p2);
      }
      var M$ = kl({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, u4), rFt = { style: kl({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, m$.style) }, jat = KA.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), iFt = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.update = function() {
          var n3 = this;
          u.prototype.update.call(this);
          var p2 = this.style;
          if (p2.decal) {
            var m2 = this._decalEl = this._decalEl || new o();
            m2.buildPath === o.prototype.buildPath && (m2.buildPath = function(O2) {
              n3.buildPath(O2, n3.shape);
            }), m2.silent = true;
            var w2 = m2.style;
            for (var T2 in p2)
              w2[T2] !== p2[T2] && (w2[T2] = p2[T2]);
            w2.fill = p2.fill ? p2.decal : null, w2.decal = null, w2.shadowColor = null, p2.strokeFirst && (w2.stroke = null);
            for (var E = 0; E < jat.length; ++E)
              m2[jat[E]] = this[jat[E]];
            m2.__dirty |= Ab2;
          } else
            this._decalEl && (this._decalEl = null);
        }, o.prototype.getDecalElement = function() {
          return this._decalEl;
        }, o.prototype._init = function(n3) {
          var p2 = tf2(n3);
          this.shape = this.getDefaultShape();
          var m2 = this.getDefaultStyle();
          m2 && this.useStyle(m2);
          for (var w2 = 0; w2 < p2.length; w2++) {
            var T2 = p2[w2], E = n3[T2];
            T2 === "style" ? this.style ? ua2(this.style, E) : this.useStyle(E) : T2 === "shape" ? ua2(this.shape, E) : u.prototype.attrKV.call(this, T2, E);
          }
          this.style || this.useStyle({});
        }, o.prototype.getDefaultStyle = function() {
          return null;
        }, o.prototype.getDefaultShape = function() {
          return {};
        }, o.prototype.canBeInsideText = function() {
          return this.hasFill();
        }, o.prototype.getInsideTextFill = function() {
          var n3 = this.style.fill;
          if (n3 !== "none") {
            if (ds(n3)) {
              var p2 = qZ(n3, 0);
              return p2 > 0.5 ? JZ : p2 > 0.2 ? cNt : az;
            } else if (n3)
              return az;
          }
          return JZ;
        }, o.prototype.getInsideTextStroke = function(n3) {
          var p2 = this.style.fill;
          if (ds(p2)) {
            var m2 = this.__zr, w2 = !!(m2 && m2.isDarkMode()), T2 = qZ(n3, 0) < cat;
            if (w2 === T2)
              return p2;
          }
        }, o.prototype.buildPath = function(n3, p2, m2) {
        }, o.prototype.pathUpdated = function() {
          this.__dirty &= ~TF;
        }, o.prototype.getUpdatedPathProxy = function(n3) {
          return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, n3), this.path;
        }, o.prototype.createPathProxy = function() {
          this.path = new iI(false);
        }, o.prototype.hasStroke = function() {
          var n3 = this.style, p2 = n3.stroke;
          return !(p2 == null || p2 === "none" || !(n3.lineWidth > 0));
        }, o.prototype.hasFill = function() {
          var n3 = this.style, p2 = n3.fill;
          return p2 != null && p2 !== "none";
        }, o.prototype.getBoundingRect = function() {
          var n3 = this._rect, p2 = this.style, m2 = !n3;
          if (m2) {
            var w2 = false;
            this.path || (w2 = true, this.createPathProxy());
            var T2 = this.path;
            (w2 || this.__dirty & TF) && (T2.beginPath(), this.buildPath(T2, this.shape, false), this.pathUpdated()), n3 = T2.getBoundingRect();
          }
          if (this._rect = n3, this.hasStroke() && this.path && this.path.len() > 0) {
            var E = this._rectStroke || (this._rectStroke = n3.clone());
            if (this.__dirty || m2) {
              E.copy(n3);
              var O2 = p2.strokeNoScale ? this.getLineScale() : 1, V3 = p2.lineWidth;
              if (!this.hasFill()) {
                var W3 = this.strokeContainThreshold;
                V3 = Math.max(V3, W3 == null ? 4 : W3);
              }
              O2 > 1e-10 && (E.width += V3 / O2, E.height += V3 / O2, E.x -= V3 / O2 / 2, E.y -= V3 / O2 / 2);
            }
            return E;
          }
          return n3;
        }, o.prototype.contain = function(n3, p2) {
          var m2 = this.transformCoordToLocal(n3, p2), w2 = this.getBoundingRect(), T2 = this.style;
          if (n3 = m2[0], p2 = m2[1], w2.contain(n3, p2)) {
            var E = this.path;
            if (this.hasStroke()) {
              var O2 = T2.lineWidth, V3 = T2.strokeNoScale ? this.getLineScale() : 1;
              if (V3 > 1e-10 && (this.hasFill() || (O2 = Math.max(O2, this.strokeContainThreshold)), nFt(E, O2 / V3, n3, p2)))
                return true;
            }
            if (this.hasFill())
              return eFt(E, n3, p2);
          }
          return false;
        }, o.prototype.dirtyShape = function() {
          this.__dirty |= TF, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
        }, o.prototype.dirty = function() {
          this.dirtyStyle(), this.dirtyShape();
        }, o.prototype.animateShape = function(n3) {
          return this.animate("shape", n3);
        }, o.prototype.updateDuringAnimation = function(n3) {
          n3 === "style" ? this.dirtyStyle() : n3 === "shape" ? this.dirtyShape() : this.markRedraw();
        }, o.prototype.attrKV = function(n3, p2) {
          n3 === "shape" ? this.setShape(p2) : u.prototype.attrKV.call(this, n3, p2);
        }, o.prototype.setShape = function(n3, p2) {
          var m2 = this.shape;
          return m2 || (m2 = this.shape = {}), typeof n3 == "string" ? m2[n3] = p2 : ua2(m2, n3), this.dirtyShape(), this;
        }, o.prototype.shapeChanged = function() {
          return !!(this.__dirty & TF);
        }, o.prototype.createStyle = function(n3) {
          return WB(M$, n3);
        }, o.prototype._innerSaveToNormal = function(n3) {
          u.prototype._innerSaveToNormal.call(this, n3);
          var p2 = this._normalState;
          n3.shape && !p2.shape && (p2.shape = ua2({}, this.shape));
        }, o.prototype._applyStateObj = function(n3, p2, m2, w2, T2, E) {
          u.prototype._applyStateObj.call(this, n3, p2, m2, w2, T2, E);
          var O2 = !(p2 && w2), V3;
          if (p2 && p2.shape ? T2 ? w2 ? V3 = p2.shape : (V3 = ua2({}, m2.shape), ua2(V3, p2.shape)) : (V3 = ua2({}, w2 ? this.shape : m2.shape), ua2(V3, p2.shape)) : O2 && (V3 = m2.shape), V3)
            if (T2) {
              this.shape = ua2({}, this.shape);
              for (var W3 = {}, q3 = tf2(V3), K = 0; K < q3.length; K++) {
                var J = q3[K];
                typeof V3[J] == "object" ? this.shape[J] = V3[J] : W3[J] = V3[J];
              }
              this._transitionState(n3, { shape: W3 }, E);
            } else
              this.shape = V3, this.dirtyShape();
        }, o.prototype._mergeStates = function(n3) {
          for (var p2 = u.prototype._mergeStates.call(this, n3), m2, w2 = 0; w2 < n3.length; w2++) {
            var T2 = n3[w2];
            T2.shape && (m2 = m2 || {}, this._mergeStyle(m2, T2.shape));
          }
          return m2 && (p2.shape = m2), p2;
        }, o.prototype.getAnimationStyleProps = function() {
          return rFt;
        }, o.prototype.isZeroArea = function() {
          return false;
        }, o.extend = function(n3) {
          var p2 = function(w2) {
            tr(T2, w2);
            function T2(E) {
              var O2 = w2.call(this, E) || this;
              return n3.init && n3.init.call(O2, E), O2;
            }
            return T2.prototype.getDefaultStyle = function() {
              return jl(n3.style);
            }, T2.prototype.getDefaultShape = function() {
              return jl(n3.shape);
            }, T2;
          }(o);
          for (var m2 in n3)
            typeof n3[m2] == "function" && (p2.prototype[m2] = n3[m2]);
          return p2;
        }, o.initDefaultProps = function() {
          var n3 = o.prototype;
          n3.type = "path", n3.strokeContainThreshold = 5, n3.segmentIgnoreThreshold = 0, n3.subPixelOptimize = false, n3.autoBatch = false, n3.__dirty = Ab2 | Vp | TF;
        }(), o;
      }(sM), Mc2 = iFt, aFt = kl({ strokeFirst: true, font: Fu, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, M$), dz = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.hasStroke = function() {
          var n3 = this.style, p2 = n3.stroke;
          return p2 != null && p2 !== "none" && n3.lineWidth > 0;
        }, o.prototype.hasFill = function() {
          var n3 = this.style, p2 = n3.fill;
          return p2 != null && p2 !== "none";
        }, o.prototype.createStyle = function(n3) {
          return WB(aFt, n3);
        }, o.prototype.setBoundingRect = function(n3) {
          this._rect = n3;
        }, o.prototype.getBoundingRect = function() {
          var n3 = this.style;
          if (!this._rect) {
            var p2 = n3.text;
            p2 != null ? p2 += "" : p2 = "";
            var m2 = r4(p2, n3.font, n3.textAlign, n3.textBaseline);
            if (m2.x += n3.x || 0, m2.y += n3.y || 0, this.hasStroke()) {
              var w2 = n3.lineWidth;
              m2.x -= w2 / 2, m2.y -= w2 / 2, m2.width += w2, m2.height += w2;
            }
            this._rect = m2;
          }
          return this._rect;
        }, o.initDefaultProps = function() {
          var n3 = o.prototype;
          n3.dirtyRectTolerance = 10;
        }(), o;
      }(sM);
      dz.prototype.type = "tspan";
      var gz = dz, Rbt = kl({ x: 0, y: 0 }, u4), Nbt = { style: kl({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, m$.style) };
      function Wat(u) {
        return !!(u && typeof u != "string" && u.width && u.height);
      }
      var Gat = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.createStyle = function(n3) {
          return WB(Rbt, n3);
        }, o.prototype._getSize = function(n3) {
          var p2 = this.style, m2 = p2[n3];
          if (m2 != null)
            return m2;
          var w2 = Wat(p2.image) ? p2.image : this.__image;
          if (!w2)
            return 0;
          var T2 = n3 === "width" ? "height" : "width", E = p2[T2];
          return E == null ? w2[n3] : w2[n3] / w2[T2] * E;
        }, o.prototype.getWidth = function() {
          return this._getSize("width");
        }, o.prototype.getHeight = function() {
          return this._getSize("height");
        }, o.prototype.getAnimationStyleProps = function() {
          return Nbt;
        }, o.prototype.getBoundingRect = function() {
          var n3 = this.style;
          return this._rect || (this._rect = new Qu(n3.x || 0, n3.y || 0, this.getWidth(), this.getHeight())), this._rect;
        }, o;
      }(sM);
      Gat.prototype.type = "image";
      var Fm = Gat;
      function Fbt(u, o) {
        var n3 = o.x, p2 = o.y, m2 = o.width, w2 = o.height, T2 = o.r, E, O2, V3, W3;
        m2 < 0 && (n3 = n3 + m2, m2 = -m2), w2 < 0 && (p2 = p2 + w2, w2 = -w2), typeof T2 == "number" ? E = O2 = V3 = W3 = T2 : T2 instanceof Array ? T2.length === 1 ? E = O2 = V3 = W3 = T2[0] : T2.length === 2 ? (E = V3 = T2[0], O2 = W3 = T2[1]) : T2.length === 3 ? (E = T2[0], O2 = W3 = T2[1], V3 = T2[2]) : (E = T2[0], O2 = T2[1], V3 = T2[2], W3 = T2[3]) : E = O2 = V3 = W3 = 0;
        var q3;
        E + O2 > m2 && (q3 = E + O2, E *= m2 / q3, O2 *= m2 / q3), V3 + W3 > m2 && (q3 = V3 + W3, V3 *= m2 / q3, W3 *= m2 / q3), O2 + V3 > w2 && (q3 = O2 + V3, O2 *= w2 / q3, V3 *= w2 / q3), E + W3 > w2 && (q3 = E + W3, E *= w2 / q3, W3 *= w2 / q3), u.moveTo(n3 + E, p2), u.lineTo(n3 + m2 - O2, p2), O2 !== 0 && u.arc(n3 + m2 - O2, p2 + O2, O2, -Math.PI / 2, 0), u.lineTo(n3 + m2, p2 + w2 - V3), V3 !== 0 && u.arc(n3 + m2 - V3, p2 + w2 - V3, V3, 0, Math.PI / 2), u.lineTo(n3 + W3, p2 + w2), W3 !== 0 && u.arc(n3 + W3, p2 + w2 - W3, W3, Math.PI / 2, Math.PI), u.lineTo(n3, p2 + E), E !== 0 && u.arc(n3 + E, p2 + E, E, Math.PI, Math.PI * 1.5);
      }
      var p4 = Math.round;
      function Vbt(u, o, n3) {
        if (o) {
          var p2 = o.x1, m2 = o.x2, w2 = o.y1, T2 = o.y2;
          u.x1 = p2, u.x2 = m2, u.y1 = w2, u.y2 = T2;
          var E = n3 && n3.lineWidth;
          return E && (p4(p2 * 2) === p4(m2 * 2) && (u.x1 = u.x2 = d4(p2, E, true)), p4(w2 * 2) === p4(T2 * 2) && (u.y1 = u.y2 = d4(w2, E, true))), u;
        }
      }
      function Bbt(u, o, n3) {
        if (o) {
          var p2 = o.x, m2 = o.y, w2 = o.width, T2 = o.height;
          u.x = p2, u.y = m2, u.width = w2, u.height = T2;
          var E = n3 && n3.lineWidth;
          return E && (u.x = d4(p2, E, true), u.y = d4(m2, E, true), u.width = Math.max(d4(p2 + w2, E, false) - u.x, w2 === 0 ? 0 : 1), u.height = Math.max(d4(m2 + T2, E, false) - u.y, T2 === 0 ? 0 : 1)), u;
        }
      }
      function d4(u, o, n3) {
        if (!o)
          return u;
        var p2 = p4(u * 2);
        return (p2 + p4(o)) % 2 === 0 ? p2 / 2 : (p2 + (n3 ? 1 : -1)) / 2;
      }
      var C$ = function() {
        function u() {
          this.x = 0, this.y = 0, this.width = 0, this.height = 0;
        }
        return u;
      }(), T$ = {}, zbt = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultShape = function() {
          return new C$();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2, w2, T2, E;
          if (this.subPixelOptimize) {
            var O2 = Bbt(T$, p2, this.style);
            m2 = O2.x, w2 = O2.y, T2 = O2.width, E = O2.height, O2.r = p2.r, p2 = O2;
          } else
            m2 = p2.x, w2 = p2.y, T2 = p2.width, E = p2.height;
          p2.r ? Fbt(n3, p2) : n3.rect(m2, w2, T2, E);
        }, o.prototype.isZeroArea = function() {
          return !this.shape.width || !this.shape.height;
        }, o;
      }(Mc2);
      zbt.prototype.type = "rect";
      var Vf2 = zbt, A$ = { fill: "#000" }, Hat = 2, oFt = { style: kl({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, m$.style) }, jbt = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this) || this;
          return p2.type = "text", p2._children = [], p2._defaultStyle = A$, p2.attr(n3), p2;
        }
        return o.prototype.childrenRef = function() {
          return this._children;
        }, o.prototype.update = function() {
          u.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
          for (var n3 = 0; n3 < this._children.length; n3++) {
            var p2 = this._children[n3];
            p2.zlevel = this.zlevel, p2.z = this.z, p2.z2 = this.z2, p2.culling = this.culling, p2.cursor = this.cursor, p2.invisible = this.invisible;
          }
        }, o.prototype.updateTransform = function() {
          var n3 = this.innerTransformable;
          n3 ? (n3.updateTransform(), n3.transform && (this.transform = n3.transform)) : u.prototype.updateTransform.call(this);
        }, o.prototype.getLocalTransform = function(n3) {
          var p2 = this.innerTransformable;
          return p2 ? p2.getLocalTransform(n3) : u.prototype.getLocalTransform.call(this, n3);
        }, o.prototype.getComputedTransform = function() {
          return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), u.prototype.getComputedTransform.call(this);
        }, o.prototype._updateSubTexts = function() {
          this._childCursor = 0, uFt(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
        }, o.prototype.addSelfToZr = function(n3) {
          u.prototype.addSelfToZr.call(this, n3);
          for (var p2 = 0; p2 < this._children.length; p2++)
            this._children[p2].__zr = n3;
        }, o.prototype.removeSelfFromZr = function(n3) {
          u.prototype.removeSelfFromZr.call(this, n3);
          for (var p2 = 0; p2 < this._children.length; p2++)
            this._children[p2].__zr = null;
        }, o.prototype.getBoundingRect = function() {
          if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
            for (var n3 = new Qu(0, 0, 0, 0), p2 = this._children, m2 = [], w2 = null, T2 = 0; T2 < p2.length; T2++) {
              var E = p2[T2], O2 = E.getBoundingRect(), V3 = E.getLocalTransform(m2);
              V3 ? (n3.copy(O2), n3.applyTransform(V3), w2 = w2 || n3.clone(), w2.union(n3)) : (w2 = w2 || O2.clone(), w2.union(O2));
            }
            this._rect = w2 || n3;
          }
          return this._rect;
        }, o.prototype.setDefaultTextStyle = function(n3) {
          this._defaultStyle = n3 || A$;
        }, o.prototype.setTextContent = function(n3) {
        }, o.prototype._mergeStyle = function(n3, p2) {
          if (!p2)
            return n3;
          var m2 = p2.rich, w2 = n3.rich || m2 && {};
          return ua2(n3, p2), m2 && w2 ? (this._mergeRich(w2, m2), n3.rich = w2) : w2 && (n3.rich = w2), n3;
        }, o.prototype._mergeRich = function(n3, p2) {
          for (var m2 = tf2(p2), w2 = 0; w2 < m2.length; w2++) {
            var T2 = m2[w2];
            n3[T2] = n3[T2] || {}, ua2(n3[T2], p2[T2]);
          }
        }, o.prototype.getAnimationStyleProps = function() {
          return oFt;
        }, o.prototype._getOrCreateChild = function(n3) {
          var p2 = this._children[this._childCursor];
          return (!p2 || !(p2 instanceof n3)) && (p2 = new n3()), this._children[this._childCursor++] = p2, p2.__zr = this.__zr, p2.parent = this, p2;
        }, o.prototype._updatePlainTexts = function() {
          var n3 = this.style, p2 = n3.font || Fu, m2 = n3.padding, w2 = Ybt(n3), T2 = RNt(w2, n3), E = Uat(n3), O2 = !!n3.backgroundColor, V3 = T2.outerHeight, W3 = T2.outerWidth, q3 = T2.contentWidth, K = T2.lines, J = T2.lineHeight, rt2 = this._defaultStyle, gt = n3.x || 0, yt = n3.y || 0, At = n3.align || rt2.align || "left", Lt = n3.verticalAlign || rt2.verticalAlign || "top", Wt = gt, Nt = EP(yt, T2.contentHeight, Lt);
          if (E || m2) {
            var ue2 = WF(gt, W3, At), ie2 = EP(yt, V3, Lt);
            E && this._renderBackground(n3, n3, ue2, ie2, W3, V3);
          }
          Nt += J / 2, m2 && (Wt = uM(gt, At, m2), Lt === "top" ? Nt += m2[0] : Lt === "bottom" && (Nt -= m2[2]));
          for (var pe2 = 0, xe = false, Ce2 = $bt("fill" in n3 ? n3.fill : (xe = true, rt2.fill)), Le2 = Zbt("stroke" in n3 ? n3.stroke : !O2 && (!rt2.autoStroke || xe) ? (pe2 = Hat, rt2.stroke) : null), ze = n3.textShadowBlur > 0, tn = n3.width != null && (n3.overflow === "truncate" || n3.overflow === "break" || n3.overflow === "breakAll"), $e2 = T2.calculatedLineHeight, Tn = 0; Tn < K.length; Tn++) {
            var zn = this._getOrCreateChild(gz), bn = zn.createStyle();
            zn.useStyle(bn), bn.text = K[Tn], bn.x = Wt, bn.y = Nt, At && (bn.textAlign = At), bn.textBaseline = "middle", bn.opacity = n3.opacity, bn.strokeFirst = true, ze && (bn.shadowBlur = n3.textShadowBlur || 0, bn.shadowColor = n3.textShadowColor || "transparent", bn.shadowOffsetX = n3.textShadowOffsetX || 0, bn.shadowOffsetY = n3.textShadowOffsetY || 0), bn.stroke = Le2, bn.fill = Ce2, Le2 && (bn.lineWidth = n3.lineWidth || pe2, bn.lineDash = n3.lineDash, bn.lineDashOffset = n3.lineDashOffset || 0), bn.font = p2, Hbt(bn, n3), Nt += J, tn && zn.setBoundingRect(new Qu(WF(bn.x, n3.width, bn.textAlign), EP(bn.y, $e2, bn.textBaseline), q3, $e2));
          }
        }, o.prototype._updateRichTexts = function() {
          var n3 = this.style, p2 = Ybt(n3), m2 = VNt(p2, n3), w2 = m2.width, T2 = m2.outerWidth, E = m2.outerHeight, O2 = n3.padding, V3 = n3.x || 0, W3 = n3.y || 0, q3 = this._defaultStyle, K = n3.align || q3.align, J = n3.verticalAlign || q3.verticalAlign, rt2 = WF(V3, T2, K), gt = EP(W3, E, J), yt = rt2, At = gt;
          O2 && (yt += O2[3], At += O2[0]);
          var Lt = yt + w2;
          Uat(n3) && this._renderBackground(n3, n3, rt2, gt, T2, E);
          for (var Wt = !!n3.backgroundColor, Nt = 0; Nt < m2.lines.length; Nt++) {
            for (var ue2 = m2.lines[Nt], ie2 = ue2.tokens, pe2 = ie2.length, xe = ue2.lineHeight, Ce2 = ue2.width, Le2 = 0, ze = yt, tn = Lt, $e2 = pe2 - 1, Tn = void 0; Le2 < pe2 && (Tn = ie2[Le2], !Tn.align || Tn.align === "left"); )
              this._placeToken(Tn, n3, xe, At, ze, "left", Wt), Ce2 -= Tn.width, ze += Tn.width, Le2++;
            for (; $e2 >= 0 && (Tn = ie2[$e2], Tn.align === "right"); )
              this._placeToken(Tn, n3, xe, At, tn, "right", Wt), Ce2 -= Tn.width, tn -= Tn.width, $e2--;
            for (ze += (w2 - (ze - yt) - (Lt - tn) - Ce2) / 2; Le2 <= $e2; )
              Tn = ie2[Le2], this._placeToken(Tn, n3, xe, At, ze + Tn.width / 2, "center", Wt), ze += Tn.width, Le2++;
            At += xe;
          }
        }, o.prototype._placeToken = function(n3, p2, m2, w2, T2, E, O2) {
          var V3 = p2.rich[n3.styleName] || {};
          V3.text = n3.text;
          var W3 = n3.verticalAlign, q3 = w2 + m2 / 2;
          W3 === "top" ? q3 = w2 + n3.height / 2 : W3 === "bottom" && (q3 = w2 + m2 - n3.height / 2);
          var K = !n3.isLineHolder && Uat(V3);
          K && this._renderBackground(V3, p2, E === "right" ? T2 - n3.width : E === "center" ? T2 - n3.width / 2 : T2, q3 - n3.height / 2, n3.width, n3.height);
          var J = !!V3.backgroundColor, rt2 = n3.textPadding;
          rt2 && (T2 = uM(T2, E, rt2), q3 -= n3.height / 2 - rt2[0] - n3.innerHeight / 2);
          var gt = this._getOrCreateChild(gz), yt = gt.createStyle();
          gt.useStyle(yt);
          var At = this._defaultStyle, Lt = false, Wt = 0, Nt = $bt("fill" in V3 ? V3.fill : "fill" in p2 ? p2.fill : (Lt = true, At.fill)), ue2 = Zbt("stroke" in V3 ? V3.stroke : "stroke" in p2 ? p2.stroke : !J && !O2 && (!At.autoStroke || Lt) ? (Wt = Hat, At.stroke) : null), ie2 = V3.textShadowBlur > 0 || p2.textShadowBlur > 0;
          yt.text = n3.text, yt.x = T2, yt.y = q3, ie2 && (yt.shadowBlur = V3.textShadowBlur || p2.textShadowBlur || 0, yt.shadowColor = V3.textShadowColor || p2.textShadowColor || "transparent", yt.shadowOffsetX = V3.textShadowOffsetX || p2.textShadowOffsetX || 0, yt.shadowOffsetY = V3.textShadowOffsetY || p2.textShadowOffsetY || 0), yt.textAlign = E, yt.textBaseline = "middle", yt.font = n3.font || Fu, yt.opacity = gv(V3.opacity, p2.opacity, 1), Hbt(yt, V3), ue2 && (yt.lineWidth = gv(V3.lineWidth, p2.lineWidth, Wt), yt.lineDash = Xu(V3.lineDash, p2.lineDash), yt.lineDashOffset = p2.lineDashOffset || 0, yt.stroke = ue2), Nt && (yt.fill = Nt);
          var pe2 = n3.contentWidth, xe = n3.contentHeight;
          gt.setBoundingRect(new Qu(WF(yt.x, pe2, yt.textAlign), EP(yt.y, xe, yt.textBaseline), pe2, xe));
        }, o.prototype._renderBackground = function(n3, p2, m2, w2, T2, E) {
          var O2 = n3.backgroundColor, V3 = n3.borderWidth, W3 = n3.borderColor, q3 = O2 && O2.image, K = O2 && !q3, J = n3.borderRadius, rt2 = this, gt, yt;
          if (K || n3.lineHeight || V3 && W3) {
            gt = this._getOrCreateChild(Vf2), gt.useStyle(gt.createStyle()), gt.style.fill = null;
            var At = gt.shape;
            At.x = m2, At.y = w2, At.width = T2, At.height = E, At.r = J, gt.dirtyShape();
          }
          if (K) {
            var Lt = gt.style;
            Lt.fill = O2 || null, Lt.fillOpacity = Xu(n3.fillOpacity, 1);
          } else if (q3) {
            yt = this._getOrCreateChild(Fm), yt.onload = function() {
              rt2.dirtyStyle();
            };
            var Wt = yt.style;
            Wt.image = O2.image, Wt.x = m2, Wt.y = w2, Wt.width = T2, Wt.height = E;
          }
          if (V3 && W3) {
            var Lt = gt.style;
            Lt.lineWidth = V3, Lt.stroke = W3, Lt.strokeOpacity = Xu(n3.strokeOpacity, 1), Lt.lineDash = n3.borderDash, Lt.lineDashOffset = n3.borderDashOffset || 0, gt.strokeContainThreshold = 0, gt.hasFill() && gt.hasStroke() && (Lt.strokeFirst = true, Lt.lineWidth *= 2);
          }
          var Nt = (gt || yt).style;
          Nt.shadowBlur = n3.shadowBlur || 0, Nt.shadowColor = n3.shadowColor || "transparent", Nt.shadowOffsetX = n3.shadowOffsetX || 0, Nt.shadowOffsetY = n3.shadowOffsetY || 0, Nt.opacity = gv(n3.opacity, p2.opacity, 1);
        }, o.makeFont = function(n3) {
          var p2 = "";
          return Ubt(n3) && (p2 = [n3.fontStyle, n3.fontWeight, Gbt(n3.fontSize), n3.fontFamily || "sans-serif"].join(" ")), p2 && US(p2) || n3.textFont || n3.font;
        }, o;
      }(sM), sFt = { left: true, right: 1, center: 1 }, lFt = { top: 1, bottom: 1, middle: 1 }, Wbt = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
      function Gbt(u) {
        return typeof u == "string" && (u.indexOf("px") !== -1 || u.indexOf("rem") !== -1 || u.indexOf("em") !== -1) ? u : isNaN(+u) ? Qp + "px" : u + "px";
      }
      function Hbt(u, o) {
        for (var n3 = 0; n3 < Wbt.length; n3++) {
          var p2 = Wbt[n3], m2 = o[p2];
          m2 != null && (u[p2] = m2);
        }
      }
      function Ubt(u) {
        return u.fontSize != null || u.fontFamily || u.fontWeight;
      }
      function uFt(u) {
        return qbt(u), Xe2(u.rich, qbt), u;
      }
      function qbt(u) {
        if (u) {
          u.font = jbt.makeFont(u);
          var o = u.align;
          o === "middle" && (o = "center"), u.align = o == null || sFt[o] ? o : "left";
          var n3 = u.verticalAlign;
          n3 === "center" && (n3 = "middle"), u.verticalAlign = n3 == null || lFt[n3] ? n3 : "top";
          var p2 = u.padding;
          p2 && (u.padding = jE(u.padding));
        }
      }
      function Zbt(u, o) {
        return u == null || o <= 0 || u === "transparent" || u === "none" ? null : u.image || u.colorStops ? "#000" : u;
      }
      function $bt(u) {
        return u == null || u === "none" ? null : u.image || u.colorStops ? "#000" : u;
      }
      function uM(u, o, n3) {
        return o === "right" ? u - n3[1] : o === "center" ? u + n3[3] / 2 - n3[1] / 2 : u + n3[3];
      }
      function Ybt(u) {
        var o = u.text;
        return o != null && (o += ""), o;
      }
      function Uat(u) {
        return !!(u.backgroundColor || u.lineHeight || u.borderWidth && u.borderColor);
      }
      var Zc2 = jbt, is = Ff2(), qat = function(u, o, n3, p2) {
        if (p2) {
          var m2 = is(p2);
          m2.dataIndex = n3, m2.dataType = o, m2.seriesIndex = u, p2.type === "group" && p2.traverse(function(w2) {
            var T2 = is(w2);
            T2.seriesIndex = u, T2.dataIndex = n3, T2.dataType = o;
          });
        }
      }, Q_ = 1, M0 = {}, Kbt = Ff2(), aI = Ff2(), Zat = 0, vz = 1, I$ = 2, J_ = ["emphasis", "blur", "select"], yz = ["normal", "emphasis", "blur", "select"], WP = 10, cFt = 9, tx = "highlight", mz = "downplay", GP = "select", Kg2 = "unselect", Xg2 = "toggleSelect";
      function g4(u) {
        return u != null && u !== "none";
      }
      var Xbt = new QB(100);
      function Qbt(u) {
        if (ds(u)) {
          var o = Xbt.get(u);
          return o || (o = Qit(u, -0.1), Xbt.put(u, o)), o;
        } else if (OZ(u)) {
          var n3 = ua2({}, u);
          return n3.colorStops = Ya2(u.colorStops, function(p2) {
            return { offset: p2.offset, color: Qit(p2.color, -0.1) };
          }), n3;
        }
        return u;
      }
      function D$(u, o, n3) {
        u.onHoverStateChange && (u.hoverState || 0) !== n3 && u.onHoverStateChange(o), u.hoverState = n3;
      }
      function Jbt(u) {
        D$(u, "emphasis", I$);
      }
      function t_t(u) {
        u.hoverState === I$ && D$(u, "normal", Zat);
      }
      function $at(u) {
        D$(u, "blur", vz);
      }
      function Yat(u) {
        u.hoverState === vz && D$(u, "normal", Zat);
      }
      function bz(u) {
        u.selected = true;
      }
      function Kat(u) {
        u.selected = false;
      }
      function e_t(u, o, n3) {
        o(u, n3);
      }
      function oI(u, o, n3) {
        e_t(u, o, n3), u.isGroup && u.traverse(function(p2) {
          e_t(p2, o, n3);
        });
      }
      function v42(u, o) {
        switch (o) {
          case "emphasis":
            u.hoverState = I$;
            break;
          case "normal":
            u.hoverState = Zat;
            break;
          case "blur":
            u.hoverState = vz;
            break;
          case "select":
            u.selected = true;
        }
      }
      function n2(u, o, n3, p2) {
        for (var m2 = u.style, w2 = {}, T2 = 0; T2 < o.length; T2++) {
          var E = o[T2], O2 = m2[E];
          w2[E] = O2 == null ? p2 && p2[E] : O2;
        }
        for (var T2 = 0; T2 < u.animators.length; T2++) {
          var V3 = u.animators[T2];
          V3.__fromStateTransition && V3.__fromStateTransition.indexOf(n3) < 0 && V3.targetName === "style" && V3.saveTo(w2, o);
        }
        return w2;
      }
      function YF(u, o, n3, p2) {
        var m2 = n3 && sc2(n3, "select") >= 0, w2 = false;
        if (u instanceof Mc2) {
          var T2 = Kbt(u), E = m2 && T2.selectFill || T2.normalFill, O2 = m2 && T2.selectStroke || T2.normalStroke;
          if (g4(E) || g4(O2)) {
            p2 = p2 || {};
            var V3 = p2.style || {};
            V3.fill === "inherit" ? (w2 = true, p2 = ua2({}, p2), V3 = ua2({}, V3), V3.fill = E) : !g4(V3.fill) && g4(E) ? (w2 = true, p2 = ua2({}, p2), V3 = ua2({}, V3), V3.fill = Qbt(E)) : !g4(V3.stroke) && g4(O2) && (w2 || (p2 = ua2({}, p2), V3 = ua2({}, V3)), V3.stroke = Qbt(O2)), p2.style = V3;
          }
        }
        if (p2 && p2.z2 == null) {
          w2 || (p2 = ua2({}, p2));
          var W3 = u.z2EmphasisLift;
          p2.z2 = u.z2 + (W3 != null ? W3 : WP);
        }
        return p2;
      }
      function fFt(u, o, n3) {
        if (n3 && n3.z2 == null) {
          n3 = ua2({}, n3);
          var p2 = u.z2SelectLift;
          n3.z2 = u.z2 + (p2 != null ? p2 : cFt);
        }
        return n3;
      }
      function hFt(u, o, n3) {
        var p2 = sc2(u.currentStates, o) >= 0, m2 = u.style.opacity, w2 = p2 ? null : n2(u, ["opacity"], o, { opacity: 1 });
        n3 = n3 || {};
        var T2 = n3.style || {};
        return T2.opacity == null && (n3 = ua2({}, n3), T2 = ua2({ opacity: p2 ? m2 : w2.opacity * 0.1 }, T2), n3.style = T2), n3;
      }
      function Xat(u, o) {
        var n3 = this.states[u];
        if (this.style) {
          if (u === "emphasis")
            return YF(this, u, o, n3);
          if (u === "blur")
            return hFt(this, u, n3);
          if (u === "select")
            return fFt(this, u, n3);
        }
        return n3;
      }
      function y4(u) {
        u.stateProxy = Xat;
        var o = u.getTextContent(), n3 = u.getTextGuideLine();
        o && (o.stateProxy = Xat), n3 && (n3.stateProxy = Xat);
      }
      function n_t(u, o) {
        !hd2(u, o) && !u.__highByOuter && oI(u, Jbt);
      }
      function Qat(u, o) {
        !hd2(u, o) && !u.__highByOuter && oI(u, t_t);
      }
      function Vm(u, o) {
        u.__highByOuter |= 1 << (o || 0), oI(u, Jbt);
      }
      function pc2(u, o) {
        !(u.__highByOuter &= ~(1 << (o || 0))) && oI(u, t_t);
      }
      function Jat(u) {
        oI(u, $at);
      }
      function r2(u) {
        oI(u, Yat);
      }
      function tot(u) {
        oI(u, bz);
      }
      function r_t(u) {
        oI(u, Kat);
      }
      function hd2(u, o) {
        return u.__highDownSilentOnTouch && o.zrByTouch;
      }
      function i_t(u) {
        var o = u.getModel();
        o.eachComponent(function(n3, p2) {
          var m2 = aI(p2);
          if (m2.isBlured) {
            var w2 = n3 === "series" ? u.getViewOfSeriesModel(p2) : u.getViewOfComponentModel(p2);
            w2.group.traverse(function(T2) {
              Yat(T2);
            });
          }
          m2.isBlured = false;
        });
      }
      function E$(u, o, n3, p2) {
        var m2 = p2.getModel();
        n3 = n3 || "coordinateSystem";
        function w2(V3, W3) {
          for (var q3 = 0; q3 < W3.length; q3++) {
            var K = V3.getItemGraphicEl(W3[q3]);
            K && r2(K);
          }
        }
        if (u != null && !(!o || o === "none")) {
          var T2 = m2.getSeriesByIndex(u), E = T2.coordinateSystem;
          E && E.master && (E = E.master);
          var O2 = [];
          m2.eachSeries(function(V3) {
            var W3 = T2 === V3, q3 = V3.coordinateSystem;
            q3 && q3.master && (q3 = q3.master);
            var K = q3 && E ? q3 === E : W3;
            if (!(n3 === "series" && !W3 || n3 === "coordinateSystem" && !K || o === "series" && W3)) {
              var J = p2.getViewOfSeriesModel(V3);
              if (J.group.traverse(function(yt) {
                $at(yt);
              }), M1(o))
                w2(V3.getData(), o);
              else if (ys(o))
                for (var rt2 = tf2(o), gt = 0; gt < rt2.length; gt++)
                  w2(V3.getData(rt2[gt]), o[rt2[gt]]);
              O2.push(V3), aI(V3).isBlured = true;
            }
          }), m2.eachComponent(function(V3, W3) {
            if (V3 !== "series") {
              var q3 = p2.getViewOfComponentModel(W3);
              q3 && q3.blurSeries && q3.blurSeries(O2, m2);
            }
          });
        }
      }
      function KF(u, o, n3) {
        if (!(u == null || o == null)) {
          var p2 = n3.getModel().getComponent(u, o);
          if (p2) {
            aI(p2).isBlured = true;
            var m2 = n3.getViewOfComponentModel(p2);
            !m2 || !m2.focusBlurEnabled || m2.group.traverse(function(w2) {
              $at(w2);
            });
          }
        }
      }
      function pFt(u, o, n3) {
        var p2 = u.seriesIndex, m2 = u.getData(o.dataType);
        if (m2) {
          var w2 = AC(m2, o);
          w2 = (za2(w2) ? w2[0] : w2) || 0;
          var T2 = m2.getItemGraphicEl(w2);
          if (!T2)
            for (var E = m2.count(), O2 = 0; !T2 && O2 < E; )
              T2 = m2.getItemGraphicEl(O2++);
          if (T2) {
            var V3 = is(T2);
            E$(p2, V3.focus, V3.blurScope, n3);
          } else {
            var W3 = u.get(["emphasis", "focus"]), q3 = u.get(["emphasis", "blurScope"]);
            W3 != null && E$(p2, W3, q3, n3);
          }
        }
      }
      function eot(u, o, n3, p2) {
        var m2 = { focusSelf: false, dispatchers: null };
        if (u == null || u === "series" || o == null || n3 == null)
          return m2;
        var w2 = p2.getModel().getComponent(u, o);
        if (!w2)
          return m2;
        var T2 = p2.getViewOfComponentModel(w2);
        if (!T2 || !T2.findHighDownDispatchers)
          return m2;
        for (var E = T2.findHighDownDispatchers(n3), O2, V3 = 0; V3 < E.length; V3++)
          if (is(E[V3]).focus === "self") {
            O2 = true;
            break;
          }
        return { focusSelf: O2, dispatchers: E };
      }
      function dFt(u, o, n3) {
        var p2 = is(u), m2 = eot(p2.componentMainType, p2.componentIndex, p2.componentHighDownName, n3), w2 = m2.dispatchers, T2 = m2.focusSelf;
        w2 ? (T2 && KF(p2.componentMainType, p2.componentIndex, n3), Xe2(w2, function(E) {
          return n_t(E, o);
        })) : (E$(p2.seriesIndex, p2.focus, p2.blurScope, n3), p2.focus === "self" && KF(p2.componentMainType, p2.componentIndex, n3), n_t(u, o));
      }
      function gFt(u, o, n3) {
        i_t(n3);
        var p2 = is(u), m2 = eot(p2.componentMainType, p2.componentIndex, p2.componentHighDownName, n3).dispatchers;
        m2 ? Xe2(m2, function(w2) {
          return Qat(w2, o);
        }) : Qat(u, o);
      }
      function vFt(u, o, n3) {
        if (rot(o)) {
          var p2 = o.dataType, m2 = u.getData(p2), w2 = AC(m2, o);
          za2(w2) || (w2 = [w2]), u[o.type === Xg2 ? "toggleSelect" : o.type === GP ? "select" : "unselect"](w2, p2);
        }
      }
      function a_t(u) {
        var o = u.getAllData();
        Xe2(o, function(n3) {
          var p2 = n3.data, m2 = n3.type;
          p2.eachItemGraphicEl(function(w2, T2) {
            u.isSelected(T2, m2) ? tot(w2) : r_t(w2);
          });
        });
      }
      function yFt(u) {
        var o = [];
        return u.eachSeries(function(n3) {
          var p2 = n3.getAllData();
          Xe2(p2, function(m2) {
            m2.data;
            var w2 = m2.type, T2 = n3.getSelectedDataIndices();
            if (T2.length > 0) {
              var E = { dataIndex: T2, seriesIndex: n3.seriesIndex };
              w2 != null && (E.dataType = w2), o.push(E);
            }
          });
        }), o;
      }
      function m4(u, o, n3) {
        b4(u, true), oI(u, y4), not(u, o, n3);
      }
      function mFt(u) {
        b4(u, false);
      }
      function o0(u, o, n3, p2) {
        p2 ? mFt(u) : m4(u, o, n3);
      }
      function not(u, o, n3) {
        var p2 = is(u);
        o != null ? (p2.focus = o, p2.blurScope = n3) : p2.focus && (p2.focus = null);
      }
      var o_t = ["emphasis", "blur", "select"], bFt = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
      function Ky(u, o, n3, p2) {
        n3 = n3 || "itemStyle";
        for (var m2 = 0; m2 < o_t.length; m2++) {
          var w2 = o_t[m2], T2 = o.getModel([w2, n3]), E = u.ensureState(w2);
          E.style = p2 ? p2(T2) : T2[bFt[n3]]();
        }
      }
      function b4(u, o) {
        var n3 = o === false, p2 = u;
        u.highDownSilentOnTouch && (p2.__highDownSilentOnTouch = u.highDownSilentOnTouch), (!n3 || p2.__highDownDispatcher) && (p2.__highByOuter = p2.__highByOuter || 0, p2.__highDownDispatcher = !n3);
      }
      function _4(u) {
        return !!(u && u.__highDownDispatcher);
      }
      function _Ft(u, o, n3) {
        var p2 = is(u);
        p2.componentMainType = o.mainType, p2.componentIndex = o.componentIndex, p2.componentHighDownName = n3;
      }
      function xFt(u) {
        var o = M0[u];
        return o == null && Q_ <= 32 && (o = M0[u] = Q_++), o;
      }
      function rot(u) {
        var o = u.type;
        return o === GP || o === Kg2 || o === Xg2;
      }
      function Xy(u) {
        var o = u.type;
        return o === tx || o === mz;
      }
      function xw(u) {
        var o = Kbt(u);
        o.normalFill = u.style.fill, o.normalStroke = u.style.stroke;
        var n3 = u.states.select || {};
        o.selectFill = n3.style && n3.style.fill || null, o.selectStroke = n3.style && n3.style.stroke || null;
      }
      var XF = iI.CMD, wFt = [[], [], []], s_t = Math.sqrt, l_t = Math.atan2;
      function u_t(u, o) {
        if (o) {
          var n3 = u.data, p2 = u.len(), m2, w2, T2, E, O2, V3, W3 = XF.M, q3 = XF.C, K = XF.L, J = XF.R, rt2 = XF.A, gt = XF.Q;
          for (T2 = 0, E = 0; T2 < p2; ) {
            switch (m2 = n3[T2++], E = T2, w2 = 0, m2) {
              case W3:
                w2 = 1;
                break;
              case K:
                w2 = 1;
                break;
              case q3:
                w2 = 3;
                break;
              case gt:
                w2 = 2;
                break;
              case rt2:
                var yt = o[4], At = o[5], Lt = s_t(o[0] * o[0] + o[1] * o[1]), Wt = s_t(o[2] * o[2] + o[3] * o[3]), Nt = l_t(-o[1] / Wt, o[0] / Lt);
                n3[T2] *= Lt, n3[T2++] += yt, n3[T2] *= Wt, n3[T2++] += At, n3[T2++] *= Lt, n3[T2++] *= Wt, n3[T2++] += Nt, n3[T2++] += Nt, T2 += 2, E = T2;
                break;
              case J:
                V3[0] = n3[T2++], V3[1] = n3[T2++], Lm(V3, V3, o), n3[E++] = V3[0], n3[E++] = V3[1], V3[0] += n3[T2++], V3[1] += n3[T2++], Lm(V3, V3, o), n3[E++] = V3[0], n3[E++] = V3[1];
            }
            for (O2 = 0; O2 < w2; O2++) {
              var ue2 = wFt[O2];
              ue2[0] = n3[T2++], ue2[1] = n3[T2++], Lm(ue2, ue2, o), n3[E++] = ue2[0], n3[E++] = ue2[1];
            }
          }
          u.increaseVersion();
        }
      }
      var iot = Math.sqrt, k$ = Math.sin, _z = Math.cos, xz = Math.PI;
      function c_t(u) {
        return Math.sqrt(u[0] * u[0] + u[1] * u[1]);
      }
      function aot(u, o) {
        return (u[0] * o[0] + u[1] * o[1]) / (c_t(u) * c_t(o));
      }
      function oot(u, o) {
        return (u[0] * o[1] < u[1] * o[0] ? -1 : 1) * Math.acos(aot(u, o));
      }
      function sot(u, o, n3, p2, m2, w2, T2, E, O2, V3, W3) {
        var q3 = O2 * (xz / 180), K = _z(q3) * (u - n3) / 2 + k$(q3) * (o - p2) / 2, J = -1 * k$(q3) * (u - n3) / 2 + _z(q3) * (o - p2) / 2, rt2 = K * K / (T2 * T2) + J * J / (E * E);
        rt2 > 1 && (T2 *= iot(rt2), E *= iot(rt2));
        var gt = (m2 === w2 ? -1 : 1) * iot((T2 * T2 * (E * E) - T2 * T2 * (J * J) - E * E * (K * K)) / (T2 * T2 * (J * J) + E * E * (K * K))) || 0, yt = gt * T2 * J / E, At = gt * -E * K / T2, Lt = (u + n3) / 2 + _z(q3) * yt - k$(q3) * At, Wt = (o + p2) / 2 + k$(q3) * yt + _z(q3) * At, Nt = oot([1, 0], [(K - yt) / T2, (J - At) / E]), ue2 = [(K - yt) / T2, (J - At) / E], ie2 = [(-1 * K - yt) / T2, (-1 * J - At) / E], pe2 = oot(ue2, ie2);
        if (aot(ue2, ie2) <= -1 && (pe2 = xz), aot(ue2, ie2) >= 1 && (pe2 = 0), pe2 < 0) {
          var xe = Math.round(pe2 / xz * 1e6) / 1e6;
          pe2 = xz * 2 + xe % 2 * xz;
        }
        W3.addData(V3, Lt, Wt, T2, E, Nt, pe2, q3, w2);
      }
      var SFt = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, MFt = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
      function CFt(u) {
        var o = new iI();
        if (!u)
          return o;
        var n3 = 0, p2 = 0, m2 = n3, w2 = p2, T2, E = iI.CMD, O2 = u.match(SFt);
        if (!O2)
          return o;
        for (var V3 = 0; V3 < O2.length; V3++) {
          for (var W3 = O2[V3], q3 = W3.charAt(0), K = void 0, J = W3.match(MFt) || [], rt2 = J.length, gt = 0; gt < rt2; gt++)
            J[gt] = parseFloat(J[gt]);
          for (var yt = 0; yt < rt2; ) {
            var At = void 0, Lt = void 0, Wt = void 0, Nt = void 0, ue2 = void 0, ie2 = void 0, pe2 = void 0, xe = n3, Ce2 = p2, Le2 = void 0, ze = void 0;
            switch (q3) {
              case "l":
                n3 += J[yt++], p2 += J[yt++], K = E.L, o.addData(K, n3, p2);
                break;
              case "L":
                n3 = J[yt++], p2 = J[yt++], K = E.L, o.addData(K, n3, p2);
                break;
              case "m":
                n3 += J[yt++], p2 += J[yt++], K = E.M, o.addData(K, n3, p2), m2 = n3, w2 = p2, q3 = "l";
                break;
              case "M":
                n3 = J[yt++], p2 = J[yt++], K = E.M, o.addData(K, n3, p2), m2 = n3, w2 = p2, q3 = "L";
                break;
              case "h":
                n3 += J[yt++], K = E.L, o.addData(K, n3, p2);
                break;
              case "H":
                n3 = J[yt++], K = E.L, o.addData(K, n3, p2);
                break;
              case "v":
                p2 += J[yt++], K = E.L, o.addData(K, n3, p2);
                break;
              case "V":
                p2 = J[yt++], K = E.L, o.addData(K, n3, p2);
                break;
              case "C":
                K = E.C, o.addData(K, J[yt++], J[yt++], J[yt++], J[yt++], J[yt++], J[yt++]), n3 = J[yt - 2], p2 = J[yt - 1];
                break;
              case "c":
                K = E.C, o.addData(K, J[yt++] + n3, J[yt++] + p2, J[yt++] + n3, J[yt++] + p2, J[yt++] + n3, J[yt++] + p2), n3 += J[yt - 2], p2 += J[yt - 1];
                break;
              case "S":
                At = n3, Lt = p2, Le2 = o.len(), ze = o.data, T2 === E.C && (At += n3 - ze[Le2 - 4], Lt += p2 - ze[Le2 - 3]), K = E.C, xe = J[yt++], Ce2 = J[yt++], n3 = J[yt++], p2 = J[yt++], o.addData(K, At, Lt, xe, Ce2, n3, p2);
                break;
              case "s":
                At = n3, Lt = p2, Le2 = o.len(), ze = o.data, T2 === E.C && (At += n3 - ze[Le2 - 4], Lt += p2 - ze[Le2 - 3]), K = E.C, xe = n3 + J[yt++], Ce2 = p2 + J[yt++], n3 += J[yt++], p2 += J[yt++], o.addData(K, At, Lt, xe, Ce2, n3, p2);
                break;
              case "Q":
                xe = J[yt++], Ce2 = J[yt++], n3 = J[yt++], p2 = J[yt++], K = E.Q, o.addData(K, xe, Ce2, n3, p2);
                break;
              case "q":
                xe = J[yt++] + n3, Ce2 = J[yt++] + p2, n3 += J[yt++], p2 += J[yt++], K = E.Q, o.addData(K, xe, Ce2, n3, p2);
                break;
              case "T":
                At = n3, Lt = p2, Le2 = o.len(), ze = o.data, T2 === E.Q && (At += n3 - ze[Le2 - 4], Lt += p2 - ze[Le2 - 3]), n3 = J[yt++], p2 = J[yt++], K = E.Q, o.addData(K, At, Lt, n3, p2);
                break;
              case "t":
                At = n3, Lt = p2, Le2 = o.len(), ze = o.data, T2 === E.Q && (At += n3 - ze[Le2 - 4], Lt += p2 - ze[Le2 - 3]), n3 += J[yt++], p2 += J[yt++], K = E.Q, o.addData(K, At, Lt, n3, p2);
                break;
              case "A":
                Wt = J[yt++], Nt = J[yt++], ue2 = J[yt++], ie2 = J[yt++], pe2 = J[yt++], xe = n3, Ce2 = p2, n3 = J[yt++], p2 = J[yt++], K = E.A, sot(xe, Ce2, n3, p2, ie2, pe2, Wt, Nt, ue2, K, o);
                break;
              case "a":
                Wt = J[yt++], Nt = J[yt++], ue2 = J[yt++], ie2 = J[yt++], pe2 = J[yt++], xe = n3, Ce2 = p2, n3 += J[yt++], p2 += J[yt++], K = E.A, sot(xe, Ce2, n3, p2, ie2, pe2, Wt, Nt, ue2, K, o);
                break;
            }
          }
          (q3 === "z" || q3 === "Z") && (K = E.Z, o.addData(K), n3 = m2, p2 = w2), T2 = K;
        }
        return o.toStatic(), o;
      }
      var f_t = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.applyTransform = function(n3) {
        }, o;
      }(Mc2);
      function x4(u) {
        return u.setData != null;
      }
      function h_t(u, o) {
        var n3 = CFt(u), p2 = ua2({}, o);
        return p2.buildPath = function(m2) {
          if (x4(m2)) {
            m2.setData(n3.data);
            var w2 = m2.getContext();
            w2 && m2.rebuildPath(w2, 1);
          } else {
            var w2 = m2;
            n3.rebuildPath(w2, 1);
          }
        }, p2.applyTransform = function(m2) {
          u_t(n3, m2), this.dirtyShape();
        }, p2;
      }
      function p_t(u, o) {
        return new f_t(h_t(u, o));
      }
      function TFt(u, o) {
        var n3 = h_t(u, o), p2 = function(m2) {
          tr(w2, m2);
          function w2(T2) {
            var E = m2.call(this, T2) || this;
            return E.applyTransform = n3.applyTransform, E.buildPath = n3.buildPath, E;
          }
          return w2;
        }(f_t);
        return p2;
      }
      function AFt(u, o) {
        for (var n3 = [], p2 = u.length, m2 = 0; m2 < p2; m2++) {
          var w2 = u[m2];
          n3.push(w2.getUpdatedPathProxy(true));
        }
        var T2 = new Mc2(o);
        return T2.createPathProxy(), T2.buildPath = function(E) {
          if (x4(E)) {
            E.appendPath(n3);
            var O2 = E.getContext();
            O2 && E.rebuildPath(O2, 1);
          }
        }, T2;
      }
      function lot(u, o) {
        o = o || {};
        var n3 = new Mc2();
        return u.shape && n3.setShape(u.shape), n3.setStyle(u.style), o.bakeTransform ? u_t(n3.path, u.getComputedTransform()) : o.toLocal ? n3.setLocalTransform(u.getComputedTransform()) : n3.copyTransform(u), n3.buildPath = u.buildPath, n3.applyTransform = n3.applyTransform, n3.z = u.z, n3.z2 = u.z2, n3.zlevel = u.zlevel, n3;
      }
      var d_t = function() {
        function u() {
          this.cx = 0, this.cy = 0, this.r = 0;
        }
        return u;
      }(), uot = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultShape = function() {
          return new d_t();
        }, o.prototype.buildPath = function(n3, p2) {
          n3.moveTo(p2.cx + p2.r, p2.cy), n3.arc(p2.cx, p2.cy, p2.r, 0, Math.PI * 2);
        }, o;
      }(Mc2);
      uot.prototype.type = "circle";
      var sI = uot, IFt = function() {
        function u() {
          this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
        }
        return u;
      }(), g_t = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultShape = function() {
          return new IFt();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = 0.5522848, w2 = p2.cx, T2 = p2.cy, E = p2.rx, O2 = p2.ry, V3 = E * m2, W3 = O2 * m2;
          n3.moveTo(w2 - E, T2), n3.bezierCurveTo(w2 - E, T2 - W3, w2 - V3, T2 - O2, w2, T2 - O2), n3.bezierCurveTo(w2 + V3, T2 - O2, w2 + E, T2 - W3, w2 + E, T2), n3.bezierCurveTo(w2 + E, T2 + W3, w2 + V3, T2 + O2, w2, T2 + O2), n3.bezierCurveTo(w2 - V3, T2 + O2, w2 - E, T2 + W3, w2 - E, T2), n3.closePath();
        }, o;
      }(Mc2);
      g_t.prototype.type = "ellipse";
      var cot = g_t, v_t = Math.PI, fot = v_t * 2, w4 = Math.sin, QF = Math.cos, DFt = Math.acos, kb2 = Math.atan2, y_t = Math.abs, wz = Math.sqrt, Sz = Math.max, lI = Math.min, IC = 1e-4;
      function EFt(u, o, n3, p2, m2, w2, T2, E) {
        var O2 = n3 - u, V3 = p2 - o, W3 = T2 - m2, q3 = E - w2, K = q3 * O2 - W3 * V3;
        if (!(K * K < IC))
          return K = (W3 * (o - w2) - q3 * (u - m2)) / K, [u + K * O2, o + K * V3];
      }
      function P$(u, o, n3, p2, m2, w2, T2) {
        var E = u - n3, O2 = o - p2, V3 = (T2 ? w2 : -w2) / wz(E * E + O2 * O2), W3 = V3 * O2, q3 = -V3 * E, K = u + W3, J = o + q3, rt2 = n3 + W3, gt = p2 + q3, yt = (K + rt2) / 2, At = (J + gt) / 2, Lt = rt2 - K, Wt = gt - J, Nt = Lt * Lt + Wt * Wt, ue2 = m2 - w2, ie2 = K * gt - rt2 * J, pe2 = (Wt < 0 ? -1 : 1) * wz(Sz(0, ue2 * ue2 * Nt - ie2 * ie2)), xe = (ie2 * Wt - Lt * pe2) / Nt, Ce2 = (-ie2 * Lt - Wt * pe2) / Nt, Le2 = (ie2 * Wt + Lt * pe2) / Nt, ze = (-ie2 * Lt + Wt * pe2) / Nt, tn = xe - yt, $e2 = Ce2 - At, Tn = Le2 - yt, zn = ze - At;
        return tn * tn + $e2 * $e2 > Tn * Tn + zn * zn && (xe = Le2, Ce2 = ze), { cx: xe, cy: Ce2, x0: -W3, y0: -q3, x1: xe * (m2 / ue2 - 1), y1: Ce2 * (m2 / ue2 - 1) };
      }
      function kFt(u) {
        var o;
        if (za2(u)) {
          var n3 = u.length;
          if (!n3)
            return u;
          n3 === 1 ? o = [u[0], u[0], 0, 0] : n3 === 2 ? o = [u[0], u[0], u[1], u[1]] : n3 === 3 ? o = u.concat(u[2]) : o = u;
        } else
          o = [u, u, u, u];
        return o;
      }
      function PFt(u, o) {
        var n3, p2 = Sz(o.r, 0), m2 = Sz(o.r0 || 0, 0), w2 = p2 > 0, T2 = m2 > 0;
        if (!(!w2 && !T2)) {
          if (w2 || (p2 = m2, m2 = 0), m2 > p2) {
            var E = p2;
            p2 = m2, m2 = E;
          }
          var O2 = o.startAngle, V3 = o.endAngle;
          if (!(isNaN(O2) || isNaN(V3))) {
            var W3 = o.cx, q3 = o.cy, K = !!o.clockwise, J = y_t(V3 - O2), rt2 = J > fot && J % fot;
            if (rt2 > IC && (J = rt2), !(p2 > IC))
              u.moveTo(W3, q3);
            else if (J > fot - IC)
              u.moveTo(W3 + p2 * QF(O2), q3 + p2 * w4(O2)), u.arc(W3, q3, p2, O2, V3, !K), m2 > IC && (u.moveTo(W3 + m2 * QF(V3), q3 + m2 * w4(V3)), u.arc(W3, q3, m2, V3, O2, K));
            else {
              var gt = void 0, yt = void 0, At = void 0, Lt = void 0, Wt = void 0, Nt = void 0, ue2 = void 0, ie2 = void 0, pe2 = void 0, xe = void 0, Ce2 = void 0, Le2 = void 0, ze = void 0, tn = void 0, $e2 = void 0, Tn = void 0, zn = p2 * QF(O2), bn = p2 * w4(O2), Xr = m2 * QF(V3), Xn = m2 * w4(V3), or = J > IC;
              if (or) {
                var Tr = o.cornerRadius;
                Tr && (n3 = kFt(Tr), gt = n3[0], yt = n3[1], At = n3[2], Lt = n3[3]);
                var ci2 = y_t(p2 - m2) / 2;
                if (Wt = lI(ci2, At), Nt = lI(ci2, Lt), ue2 = lI(ci2, gt), ie2 = lI(ci2, yt), Ce2 = pe2 = Sz(Wt, Nt), Le2 = xe = Sz(ue2, ie2), (pe2 > IC || xe > IC) && (ze = p2 * QF(V3), tn = p2 * w4(V3), $e2 = m2 * QF(O2), Tn = m2 * w4(O2), J < v_t)) {
                  var yi2 = EFt(zn, bn, $e2, Tn, ze, tn, Xr, Xn);
                  if (yi2) {
                    var Po = zn - yi2[0], Ms = bn - yi2[1], dl = ze - yi2[0], tl = tn - yi2[1], el = 1 / w4(DFt((Po * dl + Ms * tl) / (wz(Po * Po + Ms * Ms) * wz(dl * dl + tl * tl))) / 2), as = wz(yi2[0] * yi2[0] + yi2[1] * yi2[1]);
                    Ce2 = lI(pe2, (p2 - as) / (el + 1)), Le2 = lI(xe, (m2 - as) / (el - 1));
                  }
                }
              }
              if (!or)
                u.moveTo(W3 + zn, q3 + bn);
              else if (Ce2 > IC) {
                var Hs = lI(At, Ce2), ol = lI(Lt, Ce2), xs = P$($e2, Tn, zn, bn, p2, Hs, K), Bl = P$(ze, tn, Xr, Xn, p2, ol, K);
                u.moveTo(W3 + xs.cx + xs.x0, q3 + xs.cy + xs.y0), Ce2 < pe2 && Hs === ol ? u.arc(W3 + xs.cx, q3 + xs.cy, Ce2, kb2(xs.y0, xs.x0), kb2(Bl.y0, Bl.x0), !K) : (Hs > 0 && u.arc(W3 + xs.cx, q3 + xs.cy, Hs, kb2(xs.y0, xs.x0), kb2(xs.y1, xs.x1), !K), u.arc(W3, q3, p2, kb2(xs.cy + xs.y1, xs.cx + xs.x1), kb2(Bl.cy + Bl.y1, Bl.cx + Bl.x1), !K), ol > 0 && u.arc(W3 + Bl.cx, q3 + Bl.cy, ol, kb2(Bl.y1, Bl.x1), kb2(Bl.y0, Bl.x0), !K));
              } else
                u.moveTo(W3 + zn, q3 + bn), u.arc(W3, q3, p2, O2, V3, !K);
              if (!(m2 > IC) || !or)
                u.lineTo(W3 + Xr, q3 + Xn);
              else if (Le2 > IC) {
                var Hs = lI(gt, Le2), ol = lI(yt, Le2), xs = P$(Xr, Xn, ze, tn, m2, -ol, K), Bl = P$(zn, bn, $e2, Tn, m2, -Hs, K);
                u.lineTo(W3 + xs.cx + xs.x0, q3 + xs.cy + xs.y0), Le2 < xe && Hs === ol ? u.arc(W3 + xs.cx, q3 + xs.cy, Le2, kb2(xs.y0, xs.x0), kb2(Bl.y0, Bl.x0), !K) : (ol > 0 && u.arc(W3 + xs.cx, q3 + xs.cy, ol, kb2(xs.y0, xs.x0), kb2(xs.y1, xs.x1), !K), u.arc(W3, q3, m2, kb2(xs.cy + xs.y1, xs.cx + xs.x1), kb2(Bl.cy + Bl.y1, Bl.cx + Bl.x1), K), Hs > 0 && u.arc(W3 + Bl.cx, q3 + Bl.cy, Hs, kb2(Bl.y1, Bl.x1), kb2(Bl.y0, Bl.x0), !K));
              } else
                u.lineTo(W3 + Xr, q3 + Xn), u.arc(W3, q3, m2, V3, O2, K);
            }
            u.closePath();
          }
        }
      }
      var LFt = function() {
        function u() {
          this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
        }
        return u;
      }(), m_t = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultShape = function() {
          return new LFt();
        }, o.prototype.buildPath = function(n3, p2) {
          PFt(n3, p2);
        }, o.prototype.isZeroArea = function() {
          return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
        }, o;
      }(Mc2);
      m_t.prototype.type = "sector";
      var ww = m_t, OFt = function() {
        function u() {
          this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
        }
        return u;
      }(), b_t = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultShape = function() {
          return new OFt();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.cx, w2 = p2.cy, T2 = Math.PI * 2;
          n3.moveTo(m2 + p2.r, w2), n3.arc(m2, w2, p2.r, 0, T2, false), n3.moveTo(m2 + p2.r0, w2), n3.arc(m2, w2, p2.r0, 0, T2, true);
        }, o;
      }(Mc2);
      b_t.prototype.type = "ring";
      var L$ = b_t;
      function hot(u, o, n3, p2) {
        var m2 = [], w2 = [], T2 = [], E = [], O2, V3, W3, q3;
        if (p2) {
          W3 = [1 / 0, 1 / 0], q3 = [-1 / 0, -1 / 0];
          for (var K = 0, J = u.length; K < J; K++)
            HE(W3, W3, u[K]), GA(q3, q3, u[K]);
          HE(W3, W3, p2[0]), GA(q3, q3, p2[1]);
        }
        for (var K = 0, J = u.length; K < J; K++) {
          var rt2 = u[K];
          if (n3)
            O2 = u[K ? K - 1 : J - 1], V3 = u[(K + 1) % J];
          else if (K === 0 || K === J - 1) {
            m2.push(nM(u[K]));
            continue;
          } else
            O2 = u[K - 1], V3 = u[K + 1];
          WE(w2, V3, O2), zit(w2, w2, o);
          var gt = jit(rt2, O2), yt = jit(rt2, V3), At = gt + yt;
          At !== 0 && (gt /= At, yt /= At), zit(T2, w2, -gt), zit(E, w2, yt);
          var Lt = vv([], rt2, T2), Wt = vv([], rt2, E);
          p2 && (GA(Lt, Lt, W3), HE(Lt, Lt, q3), GA(Wt, Wt, W3), HE(Wt, Wt, q3)), m2.push(Lt), m2.push(Wt);
        }
        return n3 && m2.push(m2.shift()), m2;
      }
      function pot(u, o, n3) {
        var p2 = o.smooth, m2 = o.points;
        if (m2 && m2.length >= 2) {
          if (p2) {
            var w2 = hot(m2, p2, n3, o.smoothConstraint);
            u.moveTo(m2[0][0], m2[0][1]);
            for (var T2 = m2.length, E = 0; E < (n3 ? T2 : T2 - 1); E++) {
              var O2 = w2[E * 2], V3 = w2[E * 2 + 1], W3 = m2[(E + 1) % T2];
              u.bezierCurveTo(O2[0], O2[1], V3[0], V3[1], W3[0], W3[1]);
            }
          } else {
            u.moveTo(m2[0][0], m2[0][1]);
            for (var E = 1, q3 = m2.length; E < q3; E++)
              u.lineTo(m2[E][0], m2[E][1]);
          }
          n3 && u.closePath();
        }
      }
      var __t = function() {
        function u() {
          this.points = null, this.smooth = 0, this.smoothConstraint = null;
        }
        return u;
      }(), x_t = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultShape = function() {
          return new __t();
        }, o.prototype.buildPath = function(n3, p2) {
          pot(n3, p2, true);
        }, o;
      }(Mc2);
      x_t.prototype.type = "polygon";
      var Sw = x_t, RFt = function() {
        function u() {
          this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
        }
        return u;
      }(), O$ = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new RFt();
        }, o.prototype.buildPath = function(n3, p2) {
          pot(n3, p2, false);
        }, o;
      }(Mc2);
      O$.prototype.type = "polyline";
      var Mw = O$, NFt = {}, FFt = function() {
        function u() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
        }
        return u;
      }(), ex = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new FFt();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2, w2, T2, E;
          if (this.subPixelOptimize) {
            var O2 = Vbt(NFt, p2, this.style);
            m2 = O2.x1, w2 = O2.y1, T2 = O2.x2, E = O2.y2;
          } else
            m2 = p2.x1, w2 = p2.y1, T2 = p2.x2, E = p2.y2;
          var V3 = p2.percent;
          V3 !== 0 && (n3.moveTo(m2, w2), V3 < 1 && (T2 = m2 * (1 - V3) + T2 * V3, E = w2 * (1 - V3) + E * V3), n3.lineTo(T2, E));
        }, o.prototype.pointAt = function(n3) {
          var p2 = this.shape;
          return [p2.x1 * (1 - n3) + p2.x2 * n3, p2.y1 * (1 - n3) + p2.y2 * n3];
        }, o;
      }(Mc2);
      ex.prototype.type = "line";
      var My = ex, Cw = [], VFt = function() {
        function u() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
        }
        return u;
      }();
      function w_t(u, o, n3) {
        var p2 = u.cpx2, m2 = u.cpy2;
        return p2 != null || m2 != null ? [(n3 ? $B : S0)(u.x1, u.cpx1, u.cpx2, u.x2, o), (n3 ? $B : S0)(u.y1, u.cpy1, u.cpy2, u.y2, o)] : [(n3 ? Om : lp)(u.x1, u.cpx1, u.x2, o), (n3 ? Om : lp)(u.y1, u.cpy1, u.y2, o)];
      }
      var S_t = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new VFt();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.x1, w2 = p2.y1, T2 = p2.x2, E = p2.y2, O2 = p2.cpx1, V3 = p2.cpy1, W3 = p2.cpx2, q3 = p2.cpy2, K = p2.percent;
          K !== 0 && (n3.moveTo(m2, w2), W3 == null || q3 == null ? (K < 1 && (EF(m2, O2, T2, K, Cw), O2 = Cw[1], T2 = Cw[2], EF(w2, V3, E, K, Cw), V3 = Cw[1], E = Cw[2]), n3.quadraticCurveTo(O2, V3, T2, E)) : (K < 1 && (ZE(m2, O2, W3, T2, K, Cw), O2 = Cw[1], W3 = Cw[2], T2 = Cw[3], ZE(w2, V3, q3, E, K, Cw), V3 = Cw[1], q3 = Cw[2], E = Cw[3]), n3.bezierCurveTo(O2, V3, W3, q3, T2, E)));
        }, o.prototype.pointAt = function(n3) {
          return w_t(this.shape, n3, false);
        }, o.prototype.tangentAt = function(n3) {
          var p2 = w_t(this.shape, n3, true);
          return GB(p2, p2);
        }, o;
      }(Mc2);
      S_t.prototype.type = "bezier-curve";
      var JF = S_t, BFt = function() {
        function u() {
          this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
        }
        return u;
      }(), R$ = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new BFt();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.cx, w2 = p2.cy, T2 = Math.max(p2.r, 0), E = p2.startAngle, O2 = p2.endAngle, V3 = p2.clockwise, W3 = Math.cos(E), q3 = Math.sin(E);
          n3.moveTo(W3 * T2 + m2, q3 * T2 + w2), n3.arc(m2, w2, T2, E, O2, !V3);
        }, o;
      }(Mc2);
      R$.prototype.type = "arc";
      var dot = R$, zFt = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "compound", n3;
        }
        return o.prototype._updatePathDirty = function() {
          for (var n3 = this.shape.paths, p2 = this.shapeChanged(), m2 = 0; m2 < n3.length; m2++)
            p2 = p2 || n3[m2].shapeChanged();
          p2 && this.dirtyShape();
        }, o.prototype.beforeBrush = function() {
          this._updatePathDirty();
          for (var n3 = this.shape.paths || [], p2 = this.getGlobalScale(), m2 = 0; m2 < n3.length; m2++)
            n3[m2].path || n3[m2].createPathProxy(), n3[m2].path.setScale(p2[0], p2[1], n3[m2].segmentIgnoreThreshold);
        }, o.prototype.buildPath = function(n3, p2) {
          for (var m2 = p2.paths || [], w2 = 0; w2 < m2.length; w2++)
            m2[w2].buildPath(n3, m2[w2].shape, true);
        }, o.prototype.afterBrush = function() {
          for (var n3 = this.shape.paths || [], p2 = 0; p2 < n3.length; p2++)
            n3[p2].pathUpdated();
        }, o.prototype.getBoundingRect = function() {
          return this._updatePathDirty.call(this), Mc2.prototype.getBoundingRect.call(this);
        }, o;
      }(Mc2), got = zFt, jFt = function() {
        function u(o) {
          this.colorStops = o || [];
        }
        return u.prototype.addColorStop = function(o, n3) {
          this.colorStops.push({ offset: o, color: n3 });
        }, u;
      }(), vot = jFt, WFt = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2, T2, E) {
          var O2 = u.call(this, T2) || this;
          return O2.x = n3 == null ? 0 : n3, O2.y = p2 == null ? 0 : p2, O2.x2 = m2 == null ? 1 : m2, O2.y2 = w2 == null ? 0 : w2, O2.type = "linear", O2.global = E || false, O2;
        }
        return o;
      }(vot), Mz = WFt, GFt = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2, T2) {
          var E = u.call(this, w2) || this;
          return E.x = n3 == null ? 0.5 : n3, E.y = p2 == null ? 0.5 : p2, E.r = m2 == null ? 0.5 : m2, E.type = "radial", E.global = T2 || false, E;
        }
        return o;
      }(vot), N$ = GFt, nk2 = [0, 0], S4 = [0, 0], F$ = new Vu(), V$ = new Vu(), HFt = function() {
        function u(o, n3) {
          this._corners = [], this._axes = [], this._origin = [0, 0];
          for (var p2 = 0; p2 < 4; p2++)
            this._corners[p2] = new Vu();
          for (var p2 = 0; p2 < 2; p2++)
            this._axes[p2] = new Vu();
          o && this.fromBoundingRect(o, n3);
        }
        return u.prototype.fromBoundingRect = function(o, n3) {
          var p2 = this._corners, m2 = this._axes, w2 = o.x, T2 = o.y, E = w2 + o.width, O2 = T2 + o.height;
          if (p2[0].set(w2, T2), p2[1].set(E, T2), p2[2].set(E, O2), p2[3].set(w2, O2), n3)
            for (var V3 = 0; V3 < 4; V3++)
              p2[V3].transform(n3);
          Vu.sub(m2[0], p2[1], p2[0]), Vu.sub(m2[1], p2[3], p2[0]), m2[0].normalize(), m2[1].normalize();
          for (var V3 = 0; V3 < 2; V3++)
            this._origin[V3] = m2[V3].dot(p2[0]);
        }, u.prototype.intersect = function(o, n3) {
          var p2 = true, m2 = !n3;
          return F$.set(1 / 0, 1 / 0), V$.set(0, 0), !this._intersectCheckOneSide(this, o, F$, V$, m2, 1) && (p2 = false, m2) || !this._intersectCheckOneSide(o, this, F$, V$, m2, -1) && (p2 = false, m2) || m2 || Vu.copy(n3, p2 ? F$ : V$), p2;
        }, u.prototype._intersectCheckOneSide = function(o, n3, p2, m2, w2, T2) {
          for (var E = true, O2 = 0; O2 < 2; O2++) {
            var V3 = this._axes[O2];
            if (this._getProjMinMaxOnAxis(O2, o._corners, nk2), this._getProjMinMaxOnAxis(O2, n3._corners, S4), nk2[1] < S4[0] || nk2[0] > S4[1]) {
              if (E = false, w2)
                return E;
              var W3 = Math.abs(S4[0] - nk2[1]), q3 = Math.abs(nk2[0] - S4[1]);
              Math.min(W3, q3) > m2.len() && (W3 < q3 ? Vu.scale(m2, V3, -W3 * T2) : Vu.scale(m2, V3, q3 * T2));
            } else if (p2) {
              var W3 = Math.abs(S4[0] - nk2[1]), q3 = Math.abs(nk2[0] - S4[1]);
              Math.min(W3, q3) < p2.len() && (W3 < q3 ? Vu.scale(p2, V3, W3 * T2) : Vu.scale(p2, V3, -q3 * T2));
            }
          }
          return E;
        }, u.prototype._getProjMinMaxOnAxis = function(o, n3, p2) {
          for (var m2 = this._axes[o], w2 = this._origin, T2 = n3[0].dot(m2) + w2[o], E = T2, O2 = T2, V3 = 1; V3 < n3.length; V3++) {
            var W3 = n3[V3].dot(m2) + w2[o];
            E = Math.min(W3, E), O2 = Math.max(W3, O2);
          }
          p2[0] = E, p2[1] = O2;
        }, u;
      }(), B$ = HFt, UFt = [], qFt = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.notClear = true, n3.incremental = true, n3._displayables = [], n3._temporaryDisplayables = [], n3._cursor = 0, n3;
        }
        return o.prototype.traverse = function(n3, p2) {
          n3.call(p2, this);
        }, o.prototype.useStyle = function() {
          this.style = {};
        }, o.prototype.getCursor = function() {
          return this._cursor;
        }, o.prototype.innerAfterBrush = function() {
          this._cursor = this._displayables.length;
        }, o.prototype.clearDisplaybles = function() {
          this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
        }, o.prototype.clearTemporalDisplayables = function() {
          this._temporaryDisplayables = [];
        }, o.prototype.addDisplayable = function(n3, p2) {
          p2 ? this._temporaryDisplayables.push(n3) : this._displayables.push(n3), this.markRedraw();
        }, o.prototype.addDisplayables = function(n3, p2) {
          p2 = p2 || false;
          for (var m2 = 0; m2 < n3.length; m2++)
            this.addDisplayable(n3[m2], p2);
        }, o.prototype.getDisplayables = function() {
          return this._displayables;
        }, o.prototype.getTemporalDisplayables = function() {
          return this._temporaryDisplayables;
        }, o.prototype.eachPendingDisplayable = function(n3) {
          for (var p2 = this._cursor; p2 < this._displayables.length; p2++)
            n3 && n3(this._displayables[p2]);
          for (var p2 = 0; p2 < this._temporaryDisplayables.length; p2++)
            n3 && n3(this._temporaryDisplayables[p2]);
        }, o.prototype.update = function() {
          this.updateTransform();
          for (var n3 = this._cursor; n3 < this._displayables.length; n3++) {
            var p2 = this._displayables[n3];
            p2.parent = this, p2.update(), p2.parent = null;
          }
          for (var n3 = 0; n3 < this._temporaryDisplayables.length; n3++) {
            var p2 = this._temporaryDisplayables[n3];
            p2.parent = this, p2.update(), p2.parent = null;
          }
        }, o.prototype.getBoundingRect = function() {
          if (!this._rect) {
            for (var n3 = new Qu(1 / 0, 1 / 0, -1 / 0, -1 / 0), p2 = 0; p2 < this._displayables.length; p2++) {
              var m2 = this._displayables[p2], w2 = m2.getBoundingRect().clone();
              m2.needLocalTransform() && w2.applyTransform(m2.getLocalTransform(UFt)), n3.union(w2);
            }
            this._rect = n3;
          }
          return this._rect;
        }, o.prototype.contain = function(n3, p2) {
          var m2 = this.transformCoordToLocal(n3, p2), w2 = this.getBoundingRect();
          if (w2.contain(m2[0], m2[1]))
            for (var T2 = 0; T2 < this._displayables.length; T2++) {
              var E = this._displayables[T2];
              if (E.contain(n3, p2))
                return true;
            }
          return false;
        }, o;
      }(sM), ZFt = qFt, M_t = Ff2();
      function t8(u, o, n3, p2, m2) {
        var w2;
        if (o && o.ecModel) {
          var T2 = o.ecModel.getUpdatePayload();
          w2 = T2 && T2.animation;
        }
        var E = o && o.isAnimationEnabled(), O2 = u === "update";
        if (E) {
          var V3 = void 0, W3 = void 0, q3 = void 0;
          p2 ? (V3 = Xu(p2.duration, 200), W3 = Xu(p2.easing, "cubicOut"), q3 = 0) : (V3 = o.getShallow(O2 ? "animationDurationUpdate" : "animationDuration"), W3 = o.getShallow(O2 ? "animationEasingUpdate" : "animationEasing"), q3 = o.getShallow(O2 ? "animationDelayUpdate" : "animationDelay")), w2 && (w2.duration != null && (V3 = w2.duration), w2.easing != null && (W3 = w2.easing), w2.delay != null && (q3 = w2.delay)), Sl(q3) && (q3 = q3(n3, m2)), Sl(V3) && (V3 = V3(n3));
          var K = { duration: V3 || 0, delay: q3, easing: W3 };
          return K;
        } else
          return null;
      }
      function yot(u, o, n3, p2, m2, w2, T2) {
        var E = false, O2;
        Sl(m2) ? (T2 = w2, w2 = m2, m2 = null) : ys(m2) && (w2 = m2.cb, T2 = m2.during, E = m2.isFrom, O2 = m2.removeOpt, m2 = m2.dataIndex);
        var V3 = u === "leave";
        V3 || o.stopAnimation("leave");
        var W3 = t8(u, p2, m2, V3 ? O2 || {} : null, p2 && p2.getAnimationDelayParams ? p2.getAnimationDelayParams(o, m2) : null);
        if (W3 && W3.duration > 0) {
          var q3 = W3.duration, K = W3.delay, J = W3.easing, rt2 = { duration: q3, delay: K || 0, easing: J, done: w2, force: !!w2 || !!T2, setToFinal: !V3, scope: u, during: T2 };
          E ? o.animateFrom(n3, rt2) : o.animateTo(n3, rt2);
        } else
          o.stopAnimation(), !E && o.attr(n3), T2 && T2(1), w2 && w2();
      }
      function Xf2(u, o, n3, p2, m2, w2) {
        yot("update", u, o, n3, p2, m2, w2);
      }
      function Qg2(u, o, n3, p2, m2, w2) {
        yot("enter", u, o, n3, p2, m2, w2);
      }
      function e8(u) {
        if (!u.__zr)
          return true;
        for (var o = 0; o < u.animators.length; o++) {
          var n3 = u.animators[o];
          if (n3.scope === "leave")
            return true;
        }
        return false;
      }
      function HP(u, o, n3, p2, m2, w2) {
        e8(u) || yot("leave", u, o, n3, p2, m2, w2);
      }
      function C_t(u, o, n3, p2) {
        u.removeTextContent(), u.removeTextGuideLine(), HP(u, { style: { opacity: 0 } }, o, n3, p2);
      }
      function Cz(u, o, n3) {
        function p2() {
          u.parent && u.parent.remove(u);
        }
        u.isGroup ? u.traverse(function(m2) {
          m2.isGroup || C_t(m2, o, n3, p2);
        }) : C_t(u, o, n3, p2);
      }
      function DC(u) {
        M_t(u).oldStyle = u.style;
      }
      function $Ft(u) {
        return M_t(u).oldStyle;
      }
      var z$ = Math.max, j$ = Math.min, ut = {};
      function Tt(u) {
        return Mc2.extend(u);
      }
      var te2 = TFt;
      function ke2(u, o) {
        return te2(u, o);
      }
      function ln(u, o) {
        ut[u] = o;
      }
      function qn(u) {
        if (ut.hasOwnProperty(u))
          return ut[u];
      }
      function Vr(u, o, n3, p2) {
        var m2 = p_t(u, o);
        return n3 && (p2 === "center" && (n3 = Pi2(n3, m2.getBoundingRect())), Do(m2, n3)), m2;
      }
      function Yr(u, o, n3) {
        var p2 = new Fm({ style: { image: u, x: o.x, y: o.y, width: o.width, height: o.height }, onload: function(m2) {
          if (n3 === "center") {
            var w2 = { width: m2.width, height: m2.height };
            p2.setStyle(Pi2(o, w2));
          }
        } });
        return p2;
      }
      function Pi2(u, o) {
        var n3 = o.width / o.height, p2 = u.height * n3, m2;
        p2 <= u.width ? m2 = u.height : (p2 = u.width, m2 = p2 / n3);
        var w2 = u.x + u.width / 2, T2 = u.y + u.height / 2;
        return { x: w2 - p2 / 2, y: T2 - m2 / 2, width: p2, height: m2 };
      }
      var eo = AFt;
      function Do(u, o) {
        if (u.applyTransform) {
          var n3 = u.getBoundingRect(), p2 = n3.calculateTransform(o);
          u.applyTransform(p2);
        }
      }
      function Jo(u) {
        return Vbt(u.shape, u.shape, u.style), u;
      }
      function cl(u) {
        return Bbt(u.shape, u.shape, u.style), u;
      }
      var cu = d4;
      function ku(u, o) {
        for (var n3 = oz([]); u && u !== o; )
          YA(n3, u.getLocalTransform(), n3), u = u.parent;
        return n3;
      }
      function dc2(u, o, n3) {
        return o && !M1(o) && (o = JS.getLocalTransform(o)), n3 && (o = e4([], o)), Lm([], u, o);
      }
      function Gu(u, o, n3) {
        var p2 = o[4] === 0 || o[5] === 0 || o[0] === 0 ? 1 : Math.abs(2 * o[4] / o[0]), m2 = o[4] === 0 || o[5] === 0 || o[2] === 0 ? 1 : Math.abs(2 * o[4] / o[2]), w2 = [u === "left" ? -p2 : u === "right" ? p2 : 0, u === "top" ? -m2 : u === "bottom" ? m2 : 0];
        return w2 = dc2(w2, o, n3), Math.abs(w2[0]) > Math.abs(w2[1]) ? w2[0] > 0 ? "right" : "left" : w2[1] > 0 ? "bottom" : "top";
      }
      function Eh2(u) {
        return !u.isGroup;
      }
      function _p(u) {
        return u.shape != null;
      }
      function E1(u, o, n3) {
        if (!u || !o)
          return;
        function p2(T2) {
          var E = {};
          return T2.traverse(function(O2) {
            Eh2(O2) && O2.anid && (E[O2.anid] = O2);
          }), E;
        }
        function m2(T2) {
          var E = { x: T2.x, y: T2.y, rotation: T2.rotation };
          return _p(T2) && (E.shape = ua2({}, T2.shape)), E;
        }
        var w2 = p2(u);
        o.traverse(function(T2) {
          if (Eh2(T2) && T2.anid) {
            var E = w2[T2.anid];
            if (E) {
              var O2 = m2(T2);
              T2.attr(m2(E)), Xf2(T2, O2, n3, is(T2).dataIndex);
            }
          }
        });
      }
      function Pb2(u, o) {
        return Ya2(u, function(n3) {
          var p2 = n3[0];
          p2 = z$(p2, o.x), p2 = j$(p2, o.x + o.width);
          var m2 = n3[1];
          return m2 = z$(m2, o.y), m2 = j$(m2, o.y + o.height), [p2, m2];
        });
      }
      function i2(u, o) {
        var n3 = z$(u.x, o.x), p2 = j$(u.x + u.width, o.x + o.width), m2 = z$(u.y, o.y), w2 = j$(u.y + u.height, o.y + o.height);
        if (p2 >= n3 && w2 >= m2)
          return { x: n3, y: m2, width: p2 - n3, height: w2 - m2 };
      }
      function yv(u, o, n3) {
        var p2 = ua2({ rectHover: true }, o), m2 = p2.style = { strokeNoScale: true };
        if (n3 = n3 || { x: -1, y: -1, width: 2, height: 2 }, u)
          return u.indexOf("image://") === 0 ? (m2.image = u.slice(8), kl(m2, n3), new Fm(p2)) : Vr(u.replace("path://", ""), p2, n3, "center");
      }
      function nx(u, o, n3, p2, m2) {
        for (var w2 = 0, T2 = m2[m2.length - 1]; w2 < m2.length; w2++) {
          var E = m2[w2];
          if (uI(u, o, n3, p2, E[0], E[1], T2[0], T2[1]))
            return true;
          T2 = E;
        }
      }
      function uI(u, o, n3, p2, m2, w2, T2, E) {
        var O2 = n3 - u, V3 = p2 - o, W3 = T2 - m2, q3 = E - w2, K = W$(W3, q3, O2, V3);
        if (q0n(K))
          return false;
        var J = u - m2, rt2 = o - w2, gt = W$(J, rt2, O2, V3) / K;
        if (gt < 0 || gt > 1)
          return false;
        var yt = W$(J, rt2, W3, q3) / K;
        return !(yt < 0 || yt > 1);
      }
      function W$(u, o, n3, p2) {
        return u * p2 - n3 * o;
      }
      function q0n(u) {
        return u <= 1e-6 && u >= -1e-6;
      }
      function G$(u) {
        var o = u.itemTooltipOption, n3 = u.componentModel, p2 = u.itemName, m2 = ds(o) ? { formatter: o } : o, w2 = n3.mainType, T2 = n3.componentIndex, E = { componentType: w2, name: p2, $vars: ["name"] };
        E[w2 + "Index"] = T2;
        var O2 = u.formatterParamsExtra;
        O2 && Xe2(tf2(O2), function(W3) {
          Fs(E, W3) || (E[W3] = O2[W3], E.$vars.push(W3));
        });
        var V3 = is(u.el);
        V3.componentMainType = w2, V3.componentIndex = T2, V3.tooltipConfig = { name: p2, option: kl({ content: p2, formatterParams: E }, m2) };
      }
      function lve(u, o) {
        var n3;
        u.isGroup && (n3 = o(u)), n3 || u.traverse(o);
      }
      function n8(u, o) {
        if (u)
          if (za2(u))
            for (var n3 = 0; n3 < u.length; n3++)
              lve(u[n3], o);
          else
            lve(u, o);
      }
      ln("circle", sI), ln("ellipse", cot), ln("sector", ww), ln("ring", L$), ln("polygon", Sw), ln("polyline", Mw), ln("rect", Vf2), ln("line", My), ln("bezierCurve", JF), ln("arc", dot);
      var mot = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: Xf2, initProps: Qg2, removeElement: HP, removeElementWithFadeOut: Cz, isElementRemoved: e8, extendShape: Tt, extendPath: ke2, registerShape: ln, getShapeClass: qn, makePath: Vr, makeImage: Yr, mergePath: eo, resizePath: Do, subPixelOptimizeLine: Jo, subPixelOptimizeRect: cl, subPixelOptimize: cu, getTransform: ku, applyTransform: dc2, transformDirection: Gu, groupTransition: E1, clipPointsByRect: Pb2, clipRectByRect: i2, createIcon: yv, linePolygonIntersect: nx, lineLineIntersect: uI, setTooltipConfig: G$, traverseElements: n8, Group: uu, Image: Fm, Text: Zc2, Circle: sI, Ellipse: cot, Sector: ww, Ring: L$, Polygon: Sw, Polyline: Mw, Rect: Vf2, Line: My, BezierCurve: JF, Arc: dot, IncrementalDisplayable: ZFt, CompoundPath: got, LinearGradient: Mz, RadialGradient: N$, BoundingRect: Qu, OrientedBoundingRect: B$, Point: Vu, Path: Mc2 }, Symbol.toStringTag, { value: "Module" })), T_t = {};
      function uve(u, o) {
        for (var n3 = 0; n3 < J_.length; n3++) {
          var p2 = J_[n3], m2 = o[p2], w2 = u.ensureState(p2);
          w2.style = w2.style || {}, w2.style.text = m2;
        }
        var T2 = u.currentStates.slice();
        u.clearStates(true), u.setStyle({ text: o.normal }), u.useStates(T2, true);
      }
      function YFt(u, o, n3) {
        var p2 = u.labelFetcher, m2 = u.labelDataIndex, w2 = u.labelDimIndex, T2 = o.normal, E;
        p2 && (E = p2.getFormattedLabel(m2, "normal", null, w2, T2 && T2.get("formatter"), n3 != null ? { interpolatedValue: n3 } : null)), E == null && (E = Sl(u.defaultText) ? u.defaultText(m2, u, n3) : u.defaultText);
        for (var O2 = { normal: E }, V3 = 0; V3 < J_.length; V3++) {
          var W3 = J_[V3], q3 = o[W3];
          O2[W3] = Xu(p2 ? p2.getFormattedLabel(m2, W3, null, w2, q3 && q3.get("formatter")) : null, E);
        }
        return O2;
      }
      function Tw(u, o, n3, p2) {
        n3 = n3 || T_t;
        for (var m2 = u instanceof Zc2, w2 = false, T2 = 0; T2 < yz.length; T2++) {
          var E = o[yz[T2]];
          if (E && E.getShallow("show")) {
            w2 = true;
            break;
          }
        }
        var O2 = m2 ? u : u.getTextContent();
        if (w2) {
          m2 || (O2 || (O2 = new Zc2(), u.setTextContent(O2)), u.stateProxy && (O2.stateProxy = u.stateProxy));
          var V3 = YFt(n3, o), W3 = o.normal, q3 = !!W3.getShallow("show"), K = Cy(W3, p2 && p2.normal, n3, false, !m2);
          K.text = V3.normal, m2 || u.setTextConfig(A_t(W3, n3, false));
          for (var T2 = 0; T2 < J_.length; T2++) {
            var J = J_[T2], E = o[J];
            if (E) {
              var rt2 = O2.ensureState(J), gt = !!Xu(E.getShallow("show"), q3);
              if (gt !== q3 && (rt2.ignore = !gt), rt2.style = Cy(E, p2 && p2[J], n3, true, !m2), rt2.style.text = V3[J], !m2) {
                var yt = u.ensureState(J);
                yt.textConfig = A_t(E, n3, true);
              }
            }
          }
          O2.silent = !!W3.getShallow("silent"), O2.style.x != null && (K.x = O2.style.x), O2.style.y != null && (K.y = O2.style.y), O2.ignore = !q3, O2.useStyle(K), O2.dirty(), n3.enableTextSetter && (H$(O2).setLabelText = function(At) {
            var Lt = YFt(n3, o, At);
            uve(O2, Lt);
          });
        } else
          O2 && (O2.ignore = true);
        u.dirty();
      }
      function Lb2(u, o) {
        o = o || "label";
        for (var n3 = { normal: u.getModel(o) }, p2 = 0; p2 < J_.length; p2++) {
          var m2 = J_[p2];
          n3[m2] = u.getModel([m2, o]);
        }
        return n3;
      }
      function Cy(u, o, n3, p2, m2) {
        var w2 = {};
        return Z0n(w2, u, n3, p2, m2), o && ua2(w2, o), w2;
      }
      function A_t(u, o, n3) {
        o = o || {};
        var p2 = {}, m2, w2 = u.getShallow("rotate"), T2 = Xu(u.getShallow("distance"), n3 ? null : 5), E = u.getShallow("offset");
        return m2 = u.getShallow("position") || (n3 ? null : "inside"), m2 === "outside" && (m2 = o.defaultOutsidePosition || "top"), m2 != null && (p2.position = m2), E != null && (p2.offset = E), w2 != null && (w2 *= Math.PI / 180, p2.rotation = w2), T2 != null && (p2.distance = T2), p2.outsideFill = u.get("color") === "inherit" ? o.inheritColor || null : "auto", p2;
      }
      function Z0n(u, o, n3, p2, m2) {
        n3 = n3 || T_t;
        var w2 = o.ecModel, T2 = w2 && w2.option.textStyle, E = $0n(o), O2;
        if (E) {
          O2 = {};
          for (var V3 in E)
            if (E.hasOwnProperty(V3)) {
              var W3 = o.getModel(["rich", V3]);
              pve(O2[V3] = {}, W3, T2, n3, p2, m2, false, true);
            }
        }
        O2 && (u.rich = O2);
        var q3 = o.get("overflow");
        q3 && (u.overflow = q3);
        var K = o.get("minMargin");
        K != null && (u.margin = K), pve(u, o, T2, n3, p2, m2, true, false);
      }
      function $0n(u) {
        for (var o; u && u !== u.ecModel; ) {
          var n3 = (u.option || T_t).rich;
          if (n3) {
            o = o || {};
            for (var p2 = tf2(n3), m2 = 0; m2 < p2.length; m2++) {
              var w2 = p2[m2];
              o[w2] = 1;
            }
          }
          u = u.parentModel;
        }
        return o;
      }
      var cve = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], fve = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], hve = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
      function pve(u, o, n3, p2, m2, w2, T2, E) {
        n3 = !m2 && n3 || T_t;
        var O2 = p2 && p2.inheritColor, V3 = o.getShallow("color"), W3 = o.getShallow("textBorderColor"), q3 = Xu(o.getShallow("opacity"), n3.opacity);
        (V3 === "inherit" || V3 === "auto") && (O2 ? V3 = O2 : V3 = null), (W3 === "inherit" || W3 === "auto") && (O2 ? W3 = O2 : W3 = null), w2 || (V3 = V3 || n3.color, W3 = W3 || n3.textBorderColor), V3 != null && (u.fill = V3), W3 != null && (u.stroke = W3);
        var K = Xu(o.getShallow("textBorderWidth"), n3.textBorderWidth);
        K != null && (u.lineWidth = K);
        var J = Xu(o.getShallow("textBorderType"), n3.textBorderType);
        J != null && (u.lineDash = J);
        var rt2 = Xu(o.getShallow("textBorderDashOffset"), n3.textBorderDashOffset);
        rt2 != null && (u.lineDashOffset = rt2), !m2 && q3 == null && !E && (q3 = p2 && p2.defaultOpacity), q3 != null && (u.opacity = q3), !m2 && !w2 && u.fill == null && p2.inheritColor && (u.fill = p2.inheritColor);
        for (var gt = 0; gt < cve.length; gt++) {
          var yt = cve[gt], At = Xu(o.getShallow(yt), n3[yt]);
          At != null && (u[yt] = At);
        }
        for (var gt = 0; gt < fve.length; gt++) {
          var yt = fve[gt], At = o.getShallow(yt);
          At != null && (u[yt] = At);
        }
        if (u.verticalAlign == null) {
          var Lt = o.getShallow("baseline");
          Lt != null && (u.verticalAlign = Lt);
        }
        if (!T2 || !p2.disableBox) {
          for (var gt = 0; gt < hve.length; gt++) {
            var yt = hve[gt], At = o.getShallow(yt);
            At != null && (u[yt] = At);
          }
          var Wt = o.getShallow("borderType");
          Wt != null && (u.borderDash = Wt), (u.backgroundColor === "auto" || u.backgroundColor === "inherit") && O2 && (u.backgroundColor = O2), (u.borderColor === "auto" || u.borderColor === "inherit") && O2 && (u.borderColor = O2);
        }
      }
      function dve(u, o) {
        var n3 = o && o.getModel("textStyle");
        return US([u.fontStyle || n3 && n3.getShallow("fontStyle") || "", u.fontWeight || n3 && n3.getShallow("fontWeight") || "", (u.fontSize || n3 && n3.getShallow("fontSize") || 12) + "px", u.fontFamily || n3 && n3.getShallow("fontFamily") || "sans-serif"].join(" "));
      }
      var H$ = Ff2();
      function gve(u, o, n3, p2) {
        if (u) {
          var m2 = H$(u);
          m2.prevValue = m2.value, m2.value = n3;
          var w2 = o.normal;
          m2.valueAnimation = w2.get("valueAnimation"), m2.valueAnimation && (m2.precision = w2.get("precision"), m2.defaultInterpolatedText = p2, m2.statesModels = o);
        }
      }
      function vve(u, o, n3, p2, m2) {
        var w2 = H$(u);
        if (!w2.valueAnimation || w2.prevValue === w2.value)
          return;
        var T2 = w2.defaultInterpolatedText, E = Xu(w2.interpolatedValue, w2.prevValue), O2 = w2.value;
        function V3(W3) {
          var q3 = ZF(n3, w2.precision, E, O2, W3);
          w2.interpolatedValue = W3 === 1 ? null : q3;
          var K = YFt({ labelDataIndex: o, labelFetcher: m2, defaultText: T2 ? T2(q3) : q3 + "" }, w2.statesModels, q3);
          uve(u, K);
        }
        u.percent = 0, (w2.prevValue == null ? Qg2 : Xf2)(u, { percent: 1 }, p2, o, null, V3);
      }
      var Y0n = ["textStyle", "color"], KFt = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], XFt = new Zc2(), K0n = function() {
        function u() {
        }
        return u.prototype.getTextColor = function(o) {
          var n3 = this.ecModel;
          return this.getShallow("color") || (!o && n3 ? n3.get(Y0n) : null);
        }, u.prototype.getFont = function() {
          return dve({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
        }, u.prototype.getTextRect = function(o) {
          for (var n3 = { text: o, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, p2 = 0; p2 < KFt.length; p2++)
            n3[KFt[p2]] = this.getShallow(KFt[p2]);
          return XFt.useStyle(n3), XFt.update(), XFt.getBoundingRect();
        }, u;
      }(), X0n = K0n, yve = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], Q0n = l4(yve), J0n = function() {
        function u() {
        }
        return u.prototype.getLineStyle = function(o) {
          return Q0n(this, o);
        }, u;
      }(), mve = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], tyn = l4(mve), eyn = function() {
        function u() {
        }
        return u.prototype.getItemStyle = function(o, n3) {
          return tyn(this, o, n3);
        }, u;
      }(), Tz = function() {
        function u(o, n3, p2) {
          this.parentModel = n3, this.ecModel = p2, this.option = o;
        }
        return u.prototype.init = function(o, n3, p2) {
          for (var m2 = [], w2 = 3; w2 < arguments.length; w2++)
            m2[w2 - 3] = arguments[w2];
        }, u.prototype.mergeOption = function(o, n3) {
          Cu(this.option, o, true);
        }, u.prototype.get = function(o, n3) {
          return o == null ? this.option : this._doGet(this.parsePath(o), !n3 && this.parentModel);
        }, u.prototype.getShallow = function(o, n3) {
          var p2 = this.option, m2 = p2 == null ? p2 : p2[o];
          if (m2 == null && !n3) {
            var w2 = this.parentModel;
            w2 && (m2 = w2.getShallow(o));
          }
          return m2;
        }, u.prototype.getModel = function(o, n3) {
          var p2 = o != null, m2 = p2 ? this.parsePath(o) : null, w2 = p2 ? this._doGet(m2) : this.option;
          return n3 = n3 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(m2)), new u(w2, n3, this.ecModel);
        }, u.prototype.isEmpty = function() {
          return this.option == null;
        }, u.prototype.restoreData = function() {
        }, u.prototype.clone = function() {
          var o = this.constructor;
          return new o(jl(this.option));
        }, u.prototype.parsePath = function(o) {
          return typeof o == "string" ? o.split(".") : o;
        }, u.prototype.resolveParentPath = function(o) {
          return o;
        }, u.prototype.isAnimationEnabled = function() {
          if (!Ys.node && this.option) {
            if (this.option.animation != null)
              return !!this.option.animation;
            if (this.parentModel)
              return this.parentModel.isAnimationEnabled();
          }
        }, u.prototype._doGet = function(o, n3) {
          var p2 = this.option;
          if (!o)
            return p2;
          for (var m2 = 0; m2 < o.length && !(!!o[m2] && (p2 = p2 && typeof p2 == "object" ? p2[o[m2]] : null, p2 == null)); m2++)
            ;
          return p2 == null && n3 && (p2 = n3._doGet(this.resolveParentPath(o), n3.parentModel)), p2;
        }, u;
      }();
      JE(Tz), TNt(Tz), x0(Tz, J0n), x0(Tz, eyn), x0(Tz, kNt), x0(Tz, X0n);
      var _g = Tz, nyn = Math.round(Math.random() * 10);
      function U$(u) {
        return [u || "", nyn++].join("_");
      }
      function ryn(u) {
        var o = {};
        u.registerSubTypeDefaulter = function(n3, p2) {
          var m2 = e22(n3);
          o[m2.main] = p2;
        }, u.determineSubType = function(n3, p2) {
          var m2 = p2.type;
          if (!m2) {
            var w2 = e22(n3).main;
            u.hasSubTypes(n3) && o[w2] && (m2 = o[w2](p2));
          }
          return m2;
        };
      }
      function iyn(u, o) {
        u.topologicalTravel = function(w2, T2, E, O2) {
          if (!w2.length)
            return;
          var V3 = n3(T2), W3 = V3.graph, q3 = V3.noEntryList, K = {};
          for (Xe2(w2, function(Lt) {
            K[Lt] = true;
          }); q3.length; ) {
            var J = q3.pop(), rt2 = W3[J], gt = !!K[J];
            gt && (E.call(O2, J, rt2.originalDeps.slice()), delete K[J]), Xe2(rt2.successor, gt ? At : yt);
          }
          Xe2(K, function() {
            var Lt = "";
            throw new Error(Lt);
          });
          function yt(Lt) {
            W3[Lt].entryCount--, W3[Lt].entryCount === 0 && q3.push(Lt);
          }
          function At(Lt) {
            K[Lt] = true, yt(Lt);
          }
        };
        function n3(w2) {
          var T2 = {}, E = [];
          return Xe2(w2, function(O2) {
            var V3 = p2(T2, O2), W3 = V3.originalDeps = o(O2), q3 = m2(W3, w2);
            V3.entryCount = q3.length, V3.entryCount === 0 && E.push(O2), Xe2(q3, function(K) {
              sc2(V3.predecessor, K) < 0 && V3.predecessor.push(K);
              var J = p2(T2, K);
              sc2(J.successor, K) < 0 && J.successor.push(O2);
            });
          }), { graph: T2, noEntryList: E };
        }
        function p2(w2, T2) {
          return w2[T2] || (w2[T2] = { predecessor: [], successor: [] }), w2[T2];
        }
        function m2(w2, T2) {
          var E = [];
          return Xe2(w2, function(O2) {
            sc2(T2, O2) >= 0 && E.push(O2);
          }), E;
        }
      }
      function r8(u, o) {
        return Cu(Cu({}, u, true), o, true);
      }
      var ayn = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, oyn = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, I_t = "ZH", QFt = "EN", bot = QFt, D_t = {}, JFt = {}, bve = Ys.domSupported ? function() {
        var u = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
        return u.indexOf(I_t) > -1 ? I_t : bot;
      }() : bot;
      function _ve(u, o) {
        u = u.toUpperCase(), JFt[u] = new _g(o), D_t[u] = o;
      }
      function syn(u) {
        if (ds(u)) {
          var o = D_t[u.toUpperCase()] || {};
          return u === I_t || u === QFt ? jl(o) : Cu(jl(o), jl(D_t[bot]), false);
        } else
          return Cu(jl(u), jl(D_t[bot]), false);
      }
      function t8t(u) {
        return JFt[u];
      }
      function lyn() {
        return JFt[bot];
      }
      _ve(QFt, ayn), _ve(I_t, oyn);
      var e8t = 1e3, n8t = e8t * 60, _ot = n8t * 60, cI = _ot * 24, xve = cI * 365, xot = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, E_t = "{yyyy}-{MM}-{dd}", wve = { year: "{yyyy}", month: "{yyyy}-{MM}", day: E_t, hour: E_t + " " + xot.hour, minute: E_t + " " + xot.minute, second: E_t + " " + xot.second, millisecond: xot.none }, r8t = ["year", "month", "day", "hour", "minute", "second", "millisecond"], Sve = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
      function Az(u, o) {
        return u += "", "0000".substr(0, o - u.length) + u;
      }
      function q$(u) {
        switch (u) {
          case "half-year":
          case "quarter":
            return "month";
          case "week":
          case "half-week":
            return "day";
          case "half-day":
          case "quarter-day":
            return "hour";
          default:
            return u;
        }
      }
      function uyn(u) {
        return u === q$(u);
      }
      function cyn(u) {
        switch (u) {
          case "year":
          case "month":
            return "day";
          case "millisecond":
            return "millisecond";
          default:
            return "second";
        }
      }
      function k_t(u, o, n3, p2) {
        var m2 = Nm(u), w2 = m2[i8t(n3)](), T2 = m2[Z$(n3)]() + 1, E = Math.floor((T2 - 1) / 4) + 1, O2 = m2[P_t(n3)](), V3 = m2["get" + (n3 ? "UTC" : "") + "Day"](), W3 = m2[wot(n3)](), q3 = (W3 - 1) % 12 + 1, K = m2[L_t(n3)](), J = m2[O_t(n3)](), rt2 = m2[R_t(n3)](), gt = p2 instanceof _g ? p2 : t8t(p2 || bve) || lyn(), yt = gt.getModel("time"), At = yt.get("month"), Lt = yt.get("monthAbbr"), Wt = yt.get("dayOfWeek"), Nt = yt.get("dayOfWeekAbbr");
        return (o || "").replace(/{yyyy}/g, w2 + "").replace(/{yy}/g, w2 % 100 + "").replace(/{Q}/g, E + "").replace(/{MMMM}/g, At[T2 - 1]).replace(/{MMM}/g, Lt[T2 - 1]).replace(/{MM}/g, Az(T2, 2)).replace(/{M}/g, T2 + "").replace(/{dd}/g, Az(O2, 2)).replace(/{d}/g, O2 + "").replace(/{eeee}/g, Wt[V3]).replace(/{ee}/g, Nt[V3]).replace(/{e}/g, V3 + "").replace(/{HH}/g, Az(W3, 2)).replace(/{H}/g, W3 + "").replace(/{hh}/g, Az(q3 + "", 2)).replace(/{h}/g, q3 + "").replace(/{mm}/g, Az(K, 2)).replace(/{m}/g, K + "").replace(/{ss}/g, Az(J, 2)).replace(/{s}/g, J + "").replace(/{SSS}/g, Az(rt2, 3)).replace(/{S}/g, rt2 + "");
      }
      function fyn(u, o, n3, p2, m2) {
        var w2 = null;
        if (ds(n3))
          w2 = n3;
        else if (Sl(n3))
          w2 = n3(u.value, o, { level: u.level });
        else {
          var T2 = ua2({}, xot);
          if (u.level > 0)
            for (var E = 0; E < r8t.length; ++E)
              T2[r8t[E]] = "{primary|" + T2[r8t[E]] + "}";
          var O2 = n3 ? n3.inherit === false ? n3 : kl(n3, T2) : T2, V3 = Mve(u.value, m2);
          if (O2[V3])
            w2 = O2[V3];
          else if (O2.inherit) {
            for (var W3 = Sve.indexOf(V3), E = W3 - 1; E >= 0; --E)
              if (O2[V3]) {
                w2 = O2[V3];
                break;
              }
            w2 = w2 || T2.none;
          }
          if (za2(w2)) {
            var q3 = u.level == null ? 0 : u.level >= 0 ? u.level : w2.length + u.level;
            q3 = Math.min(q3, w2.length - 1), w2 = w2[q3];
          }
        }
        return k_t(new Date(u.value), w2, m2, p2);
      }
      function Mve(u, o) {
        var n3 = Nm(u), p2 = n3[Z$(o)]() + 1, m2 = n3[P_t(o)](), w2 = n3[wot(o)](), T2 = n3[L_t(o)](), E = n3[O_t(o)](), O2 = n3[R_t(o)](), V3 = O2 === 0, W3 = V3 && E === 0, q3 = W3 && T2 === 0, K = q3 && w2 === 0, J = K && m2 === 1, rt2 = J && p2 === 1;
        return rt2 ? "year" : J ? "month" : K ? "day" : q3 ? "hour" : W3 ? "minute" : V3 ? "second" : "millisecond";
      }
      function Cve(u, o, n3) {
        var p2 = Dh2(u) ? Nm(u) : u;
        switch (o = o || Mve(u, n3), o) {
          case "year":
            return p2[i8t(n3)]();
          case "half-year":
            return p2[Z$(n3)]() >= 6 ? 1 : 0;
          case "quarter":
            return Math.floor((p2[Z$(n3)]() + 1) / 4);
          case "month":
            return p2[Z$(n3)]();
          case "day":
            return p2[P_t(n3)]();
          case "half-day":
            return p2[wot(n3)]() / 24;
          case "hour":
            return p2[wot(n3)]();
          case "minute":
            return p2[L_t(n3)]();
          case "second":
            return p2[O_t(n3)]();
          case "millisecond":
            return p2[R_t(n3)]();
        }
      }
      function i8t(u) {
        return u ? "getUTCFullYear" : "getFullYear";
      }
      function Z$(u) {
        return u ? "getUTCMonth" : "getMonth";
      }
      function P_t(u) {
        return u ? "getUTCDate" : "getDate";
      }
      function wot(u) {
        return u ? "getUTCHours" : "getHours";
      }
      function L_t(u) {
        return u ? "getUTCMinutes" : "getMinutes";
      }
      function O_t(u) {
        return u ? "getUTCSeconds" : "getSeconds";
      }
      function R_t(u) {
        return u ? "getUTCMilliseconds" : "getMilliseconds";
      }
      function hyn(u) {
        return u ? "setUTCFullYear" : "setFullYear";
      }
      function Tve(u) {
        return u ? "setUTCMonth" : "setMonth";
      }
      function Ave(u) {
        return u ? "setUTCDate" : "setDate";
      }
      function Ive(u) {
        return u ? "setUTCHours" : "setHours";
      }
      function Dve(u) {
        return u ? "setUTCMinutes" : "setMinutes";
      }
      function Eve(u) {
        return u ? "setUTCSeconds" : "setSeconds";
      }
      function kve(u) {
        return u ? "setUTCMilliseconds" : "setMilliseconds";
      }
      function Pve(u) {
        if (!JA(u))
          return ds(u) ? u : "-";
        var o = (u + "").split(".");
        return o[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (o.length > 1 ? "." + o[1] : "");
      }
      function Lve(u, o) {
        return u = (u || "").toLowerCase().replace(/-(.)/g, function(n3, p2) {
          return p2.toUpperCase();
        }), o && u && (u = u.charAt(0).toUpperCase() + u.slice(1)), u;
      }
      var $$ = jE, pyn = /([&<>"'])/g, dyn = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
      function EC(u) {
        return u == null ? "" : (u + "").replace(pyn, function(o, n3) {
          return dyn[n3];
        });
      }
      function a8t(u, o, n3) {
        var p2 = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
        function m2(W3) {
          return W3 && US(W3) ? W3 : "-";
        }
        function w2(W3) {
          return !!(W3 != null && !isNaN(W3) && isFinite(W3));
        }
        var T2 = o === "time", E = u instanceof Date;
        if (T2 || E) {
          var O2 = T2 ? Nm(u) : u;
          if (isNaN(+O2)) {
            if (E)
              return "-";
          } else
            return k_t(O2, p2, n3);
        }
        if (o === "ordinal")
          return Nit(u) ? m2(u) : Dh2(u) && w2(u) ? u + "" : "-";
        var V3 = QE(u);
        return w2(V3) ? Pve(V3) : Nit(u) ? m2(u) : typeof u == "boolean" ? u + "" : "-";
      }
      var Ove = ["a", "b", "c", "d", "e", "f", "g"], o8t = function(u, o) {
        return "{" + u + (o == null ? "" : o) + "}";
      };
      function Rve(u, o, n3) {
        za2(o) || (o = [o]);
        var p2 = o.length;
        if (!p2)
          return "";
        for (var m2 = o[0].$vars || [], w2 = 0; w2 < m2.length; w2++) {
          var T2 = Ove[w2];
          u = u.replace(o8t(T2), o8t(T2, 0));
        }
        for (var E = 0; E < p2; E++)
          for (var O2 = 0; O2 < m2.length; O2++) {
            var V3 = o[E][m2[O2]];
            u = u.replace(o8t(Ove[O2], E), n3 ? EC(V3) : V3);
          }
        return u;
      }
      function gyn(u, o, n3) {
        return Xe2(o, function(p2, m2) {
          u = u.replace("{" + m2 + "}", n3 ? EC(p2) : p2);
        }), u;
      }
      function vyn(u, o) {
        var n3 = ds(u) ? { color: u, extraCssText: o } : u || {}, p2 = n3.color, m2 = n3.type;
        o = n3.extraCssText;
        var w2 = n3.renderMode || "html";
        if (!p2)
          return "";
        if (w2 === "html")
          return m2 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + EC(p2) + ";" + (o || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + EC(p2) + ";" + (o || "") + '"></span>';
        var T2 = n3.markerId || "markerX";
        return { renderMode: w2, content: "{" + T2 + "|}  ", style: m2 === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: p2 } : { width: 10, height: 10, borderRadius: 5, backgroundColor: p2 } };
      }
      function Iz(u, o) {
        return o = o || "transparent", ds(u) ? u : ys(u) && u.colorStops && (u.colorStops[0] || {}).color || o;
      }
      function N_t(u, o) {
        if (o === "_blank" || o === "blank") {
          var n3 = window.open();
          n3.opener = null, n3.location.href = u;
        } else
          window.open(u, o);
      }
      var F_t = Xe2, Nve = ["left", "right", "top", "bottom", "width", "height"], Dz = [["width", "left", "right"], ["height", "top", "bottom"]];
      function s8t(u, o, n3, p2, m2) {
        var w2 = 0, T2 = 0;
        p2 == null && (p2 = 1 / 0), m2 == null && (m2 = 1 / 0);
        var E = 0;
        o.eachChild(function(O2, V3) {
          var W3 = O2.getBoundingRect(), q3 = o.childAt(V3 + 1), K = q3 && q3.getBoundingRect(), J, rt2;
          if (u === "horizontal") {
            var gt = W3.width + (K ? -K.x + W3.x : 0);
            J = w2 + gt, J > p2 || O2.newline ? (w2 = 0, J = gt, T2 += E + n3, E = W3.height) : E = Math.max(E, W3.height);
          } else {
            var yt = W3.height + (K ? -K.y + W3.y : 0);
            rt2 = T2 + yt, rt2 > m2 || O2.newline ? (w2 += E + n3, T2 = 0, rt2 = yt, E = W3.width) : E = Math.max(E, W3.width);
          }
          O2.newline || (O2.x = w2, O2.y = T2, O2.markRedraw(), u === "horizontal" ? w2 = J + n3 : T2 = rt2 + n3);
        });
      }
      var Ez = s8t;
      wu(s8t, "vertical"), wu(s8t, "horizontal");
      function yyn(u, o, n3) {
        var p2 = o.width, m2 = o.height, w2 = Qo(u.left, p2), T2 = Qo(u.top, m2), E = Qo(u.right, p2), O2 = Qo(u.bottom, m2);
        return (isNaN(w2) || isNaN(parseFloat(u.left))) && (w2 = 0), (isNaN(E) || isNaN(parseFloat(u.right))) && (E = p2), (isNaN(T2) || isNaN(parseFloat(u.top))) && (T2 = 0), (isNaN(O2) || isNaN(parseFloat(u.bottom))) && (O2 = m2), n3 = $$(n3 || 0), { width: Math.max(E - w2 - n3[1] - n3[3], 0), height: Math.max(O2 - T2 - n3[0] - n3[2], 0) };
      }
      function Bm(u, o, n3) {
        n3 = $$(n3 || 0);
        var p2 = o.width, m2 = o.height, w2 = Qo(u.left, p2), T2 = Qo(u.top, m2), E = Qo(u.right, p2), O2 = Qo(u.bottom, m2), V3 = Qo(u.width, p2), W3 = Qo(u.height, m2), q3 = n3[2] + n3[0], K = n3[1] + n3[3], J = u.aspect;
        switch (isNaN(V3) && (V3 = p2 - E - K - w2), isNaN(W3) && (W3 = m2 - O2 - q3 - T2), J != null && (isNaN(V3) && isNaN(W3) && (J > p2 / m2 ? V3 = p2 * 0.8 : W3 = m2 * 0.8), isNaN(V3) && (V3 = J * W3), isNaN(W3) && (W3 = V3 / J)), isNaN(w2) && (w2 = p2 - E - V3 - K), isNaN(T2) && (T2 = m2 - O2 - W3 - q3), u.left || u.right) {
          case "center":
            w2 = p2 / 2 - V3 / 2 - n3[3];
            break;
          case "right":
            w2 = p2 - V3 - K;
            break;
        }
        switch (u.top || u.bottom) {
          case "middle":
          case "center":
            T2 = m2 / 2 - W3 / 2 - n3[0];
            break;
          case "bottom":
            T2 = m2 - W3 - q3;
            break;
        }
        w2 = w2 || 0, T2 = T2 || 0, isNaN(V3) && (V3 = p2 - K - w2 - (E || 0)), isNaN(W3) && (W3 = m2 - q3 - T2 - (O2 || 0));
        var rt2 = new Qu(w2 + n3[3], T2 + n3[0], V3, W3);
        return rt2.margin = n3, rt2;
      }
      function V_t(u, o, n3, p2, m2, w2) {
        var T2 = !m2 || !m2.hv || m2.hv[0], E = !m2 || !m2.hv || m2.hv[1], O2 = m2 && m2.boundingMode || "all";
        if (w2 = w2 || u, w2.x = u.x, w2.y = u.y, !T2 && !E)
          return false;
        var V3;
        if (O2 === "raw")
          V3 = u.type === "group" ? new Qu(0, 0, +o.width || 0, +o.height || 0) : u.getBoundingRect();
        else if (V3 = u.getBoundingRect(), u.needLocalTransform()) {
          var W3 = u.getLocalTransform();
          V3 = V3.clone(), V3.applyTransform(W3);
        }
        var q3 = Bm(kl({ width: V3.width, height: V3.height }, o), n3, p2), K = T2 ? q3.x - V3.x : 0, J = E ? q3.y - V3.y : 0;
        return O2 === "raw" ? (w2.x = K, w2.y = J) : (w2.x += K, w2.y += J), w2 === u && u.markRedraw(), true;
      }
      function myn(u, o) {
        return u[Dz[o][0]] != null || u[Dz[o][1]] != null && u[Dz[o][2]] != null;
      }
      function Sot(u) {
        var o = u.layoutMode || u.constructor.layoutMode;
        return ys(o) ? o : o ? { type: o } : null;
      }
      function i8(u, o, n3) {
        var p2 = n3 && n3.ignoreSize;
        !za2(p2) && (p2 = [p2, p2]);
        var m2 = T2(Dz[0], 0), w2 = T2(Dz[1], 1);
        V3(Dz[0], u, m2), V3(Dz[1], u, w2);
        function T2(W3, q3) {
          var K = {}, J = 0, rt2 = {}, gt = 0, yt = 2;
          if (F_t(W3, function(Wt) {
            rt2[Wt] = u[Wt];
          }), F_t(W3, function(Wt) {
            E(o, Wt) && (K[Wt] = rt2[Wt] = o[Wt]), O2(K, Wt) && J++, O2(rt2, Wt) && gt++;
          }), p2[q3])
            return O2(o, W3[1]) ? rt2[W3[2]] = null : O2(o, W3[2]) && (rt2[W3[1]] = null), rt2;
          if (gt === yt || !J)
            return rt2;
          if (J >= yt)
            return K;
          for (var At = 0; At < W3.length; At++) {
            var Lt = W3[At];
            if (!E(K, Lt) && E(u, Lt)) {
              K[Lt] = u[Lt];
              break;
            }
          }
          return K;
        }
        function E(W3, q3) {
          return W3.hasOwnProperty(q3);
        }
        function O2(W3, q3) {
          return W3[q3] != null && W3[q3] !== "auto";
        }
        function V3(W3, q3, K) {
          F_t(W3, function(J) {
            q3[J] = K[J];
          });
        }
      }
      function Y$(u) {
        return Fve({}, u);
      }
      function Fve(u, o) {
        return o && u && F_t(Nve, function(n3) {
          o.hasOwnProperty(n3) && (u[n3] = o[n3]);
        }), u;
      }
      var byn = Ff2(), K$ = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this, n3, p2, m2) || this;
          return w2.uid = U$("ec_cpt_model"), w2;
        }
        return o.prototype.init = function(n3, p2, m2) {
          this.mergeDefaultAndTheme(n3, m2);
        }, o.prototype.mergeDefaultAndTheme = function(n3, p2) {
          var m2 = Sot(this), w2 = m2 ? Y$(n3) : {}, T2 = p2.getTheme();
          Cu(n3, T2.get(this.mainType)), Cu(n3, this.getDefaultOption()), m2 && i8(n3, w2, m2);
        }, o.prototype.mergeOption = function(n3, p2) {
          Cu(this.option, n3, true);
          var m2 = Sot(this);
          m2 && i8(this.option, n3, m2);
        }, o.prototype.optionUpdated = function(n3, p2) {
        }, o.prototype.getDefaultOption = function() {
          var n3 = this.constructor;
          if (!tI(n3))
            return n3.defaultOption;
          var p2 = byn(this);
          if (!p2.defaultOption) {
            for (var m2 = [], w2 = n3; w2; ) {
              var T2 = w2.prototype.defaultOption;
              T2 && m2.push(T2), w2 = w2.superClass;
            }
            for (var E = {}, O2 = m2.length - 1; O2 >= 0; O2--)
              E = Cu(E, m2[O2], true);
            p2.defaultOption = E;
          }
          return p2.defaultOption;
        }, o.prototype.getReferringComponents = function(n3, p2) {
          var m2 = n3 + "Index", w2 = n3 + "Id";
          return qF(this.ecModel, n3, { index: this.get(m2, true), id: this.get(w2, true) }, p2);
        }, o.prototype.getBoxLayoutParams = function() {
          var n3 = this;
          return { left: n3.get("left"), top: n3.get("top"), right: n3.get("right"), bottom: n3.get("bottom"), width: n3.get("width"), height: n3.get("height") };
        }, o.prototype.getZLevelKey = function() {
          return "";
        }, o.prototype.setZLevel = function(n3) {
          this.option.zlevel = n3;
        }, o.protoInitialize = function() {
          var n3 = o.prototype;
          n3.type = "component", n3.id = "", n3.name = "", n3.mainType = "", n3.subType = "", n3.componentIndex = 0;
        }(), o;
      }(_g);
      Cat(K$, _g), v$(K$), ryn(K$), iyn(K$, _yn);
      function _yn(u) {
        var o = [];
        return Xe2(K$.getClassesByMainType(u), function(n3) {
          o = o.concat(n3.dependencies || n3.prototype.dependencies || []);
        }), o = Ya2(o, function(n3) {
          return e22(n3).main;
        }), u !== "dataset" && sc2(o, "dataset") <= 0 && o.unshift("dataset"), o;
      }
      var kh2 = K$, Vve = "";
      typeof navigator != "undefined" && (Vve = navigator.platform || "");
      var X$ = "rgba(0, 0, 0, 0.2)", xyn = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: X$, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: X$, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: X$, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: X$, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: X$, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: X$, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: Vve.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, Bve = pl(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), fI = "original", Aw = "arrayRows", hI = "objectRows", UP2 = "keyedColumns", a8 = "typedArray", zve = "unknown", qP = "column", Q$ = "row", rx = { Must: 1, Might: 2, Not: 3 }, jve = Ff2();
      function wyn(u) {
        jve(u).datasetMap = pl();
      }
      function Wve(u, o, n3) {
        var p2 = {}, m2 = u8t(o);
        if (!m2 || !u)
          return p2;
        var w2 = [], T2 = [], E = o.ecModel, O2 = jve(E).datasetMap, V3 = m2.uid + "_" + n3.seriesLayoutBy, W3, q3;
        u = u.slice(), Xe2(u, function(gt, yt) {
          var At = ys(gt) ? gt : u[yt] = { name: gt };
          At.type === "ordinal" && W3 == null && (W3 = yt, q3 = rt2(At)), p2[At.name] = [];
        });
        var K = O2.get(V3) || O2.set(V3, { categoryWayDim: q3, valueWayDim: 0 });
        Xe2(u, function(gt, yt) {
          var At = gt.name, Lt = rt2(gt);
          if (W3 == null) {
            var Wt = K.valueWayDim;
            J(p2[At], Wt, Lt), J(T2, Wt, Lt), K.valueWayDim += Lt;
          } else if (W3 === yt)
            J(p2[At], 0, Lt), J(w2, 0, Lt);
          else {
            var Wt = K.categoryWayDim;
            J(p2[At], Wt, Lt), J(T2, Wt, Lt), K.categoryWayDim += Lt;
          }
        });
        function J(gt, yt, At) {
          for (var Lt = 0; Lt < At; Lt++)
            gt.push(yt + Lt);
        }
        function rt2(gt) {
          var yt = gt.dimsDef;
          return yt ? yt.length : 1;
        }
        return w2.length && (p2.itemName = w2), T2.length && (p2.seriesName = T2), p2;
      }
      function l8t(u, o, n3) {
        var p2 = {}, m2 = u8t(u);
        if (!m2)
          return p2;
        var w2 = o.sourceFormat, T2 = o.dimensionsDefine, E;
        (w2 === hI || w2 === UP2) && Xe2(T2, function(W3, q3) {
          (ys(W3) ? W3.name : W3) === "name" && (E = q3);
        });
        var O2 = function() {
          for (var W3 = {}, q3 = {}, K = [], J = 0, rt2 = Math.min(5, n3); J < rt2; J++) {
            var gt = Hve(o.data, w2, o.seriesLayoutBy, T2, o.startIndex, J);
            K.push(gt);
            var yt = gt === rx.Not;
            if (yt && W3.v == null && J !== E && (W3.v = J), (W3.n == null || W3.n === W3.v || !yt && K[W3.n] === rx.Not) && (W3.n = J), At(W3) && K[W3.n] !== rx.Not)
              return W3;
            yt || (gt === rx.Might && q3.v == null && J !== E && (q3.v = J), (q3.n == null || q3.n === q3.v) && (q3.n = J));
          }
          function At(Lt) {
            return Lt.v != null && Lt.n != null;
          }
          return At(W3) ? W3 : At(q3) ? q3 : null;
        }();
        if (O2) {
          p2.value = [O2.v];
          var V3 = E != null ? E : O2.n;
          p2.itemName = [V3], p2.seriesName = [V3];
        }
        return p2;
      }
      function u8t(u) {
        var o = u.get("data", true);
        if (!o)
          return qF(u.ecModel, "dataset", { index: u.get("datasetIndex", true), id: u.get("datasetId", true) }, Y0).models[0];
      }
      function Syn(u) {
        return !u.get("transform", true) && !u.get("fromTransformResult", true) ? [] : qF(u.ecModel, "dataset", { index: u.get("fromDatasetIndex", true), id: u.get("fromDatasetId", true) }, Y0).models;
      }
      function Gve(u, o) {
        return Hve(u.data, u.sourceFormat, u.seriesLayoutBy, u.dimensionsDefine, u.startIndex, o);
      }
      function Hve(u, o, n3, p2, m2, w2) {
        var T2, E = 5;
        if (HS(u))
          return rx.Not;
        var O2, V3;
        if (p2) {
          var W3 = p2[w2];
          ys(W3) ? (O2 = W3.name, V3 = W3.type) : ds(W3) && (O2 = W3);
        }
        if (V3 != null)
          return V3 === "ordinal" ? rx.Must : rx.Not;
        if (o === Aw) {
          var q3 = u;
          if (n3 === Q$) {
            for (var K = q3[w2], J = 0; J < (K || []).length && J < E; J++)
              if ((T2 = Nt(K[m2 + J])) != null)
                return T2;
          } else
            for (var J = 0; J < q3.length && J < E; J++) {
              var rt2 = q3[m2 + J];
              if (rt2 && (T2 = Nt(rt2[w2])) != null)
                return T2;
            }
        } else if (o === hI) {
          var gt = u;
          if (!O2)
            return rx.Not;
          for (var J = 0; J < gt.length && J < E; J++) {
            var yt = gt[J];
            if (yt && (T2 = Nt(yt[O2])) != null)
              return T2;
          }
        } else if (o === UP2) {
          var At = u;
          if (!O2)
            return rx.Not;
          var K = At[O2];
          if (!K || HS(K))
            return rx.Not;
          for (var J = 0; J < K.length && J < E; J++)
            if ((T2 = Nt(K[J])) != null)
              return T2;
        } else if (o === fI)
          for (var Lt = u, J = 0; J < Lt.length && J < E; J++) {
            var yt = Lt[J], Wt = PP(yt);
            if (!za2(Wt))
              return rx.Not;
            if ((T2 = Nt(Wt[w2])) != null)
              return T2;
          }
        function Nt(ue2) {
          var ie2 = ds(ue2);
          if (ue2 != null && isFinite(ue2) && ue2 !== "")
            return ie2 ? rx.Might : rx.Not;
          if (ie2 && ue2 !== "-")
            return rx.Must;
        }
        return rx.Not;
      }
      var c8t = pl();
      function Myn(u, o) {
        Tb2(c8t.get(u) == null && o), c8t.set(u, o);
      }
      function Cyn(u, o, n3) {
        var p2 = c8t.get(o);
        if (!p2)
          return n3;
        var m2 = p2(u);
        return m2 ? n3.concat(m2) : n3;
      }
      var Uve = Ff2(), Tyn = Ff2(), f8t = function() {
        function u() {
        }
        return u.prototype.getColorFromPalette = function(o, n3, p2) {
          var m2 = Tp(this.get("color", true)), w2 = this.get("colorLayer", true);
          return qve(this, Uve, m2, w2, o, n3, p2);
        }, u.prototype.clearColorPalette = function() {
          Iyn(this, Uve);
        }, u;
      }();
      function h8t(u, o, n3, p2) {
        var m2 = Tp(u.get(["aria", "decal", "decals"]));
        return qve(u, Tyn, m2, null, o, n3, p2);
      }
      function Ayn(u, o) {
        for (var n3 = u.length, p2 = 0; p2 < n3; p2++)
          if (u[p2].length > o)
            return u[p2];
        return u[n3 - 1];
      }
      function qve(u, o, n3, p2, m2, w2, T2) {
        w2 = w2 || u;
        var E = o(w2), O2 = E.paletteIdx || 0, V3 = E.paletteNameMap = E.paletteNameMap || {};
        if (V3.hasOwnProperty(m2))
          return V3[m2];
        var W3 = T2 == null || !p2 ? n3 : Ayn(p2, T2);
        if (W3 = W3 || n3, !(!W3 || !W3.length)) {
          var q3 = W3[O2];
          return m2 && (V3[m2] = q3), E.paletteIdx = (O2 + 1) % W3.length, q3;
        }
      }
      function Iyn(u, o) {
        o(u).paletteIdx = 0, o(u).paletteNameMap = {};
      }
      var B_t, Mot, Zve, $ve = "\0_ec_inner", Dyn = 1, Yve = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.init = function(n3, p2, m2, w2, T2, E) {
          w2 = w2 || {}, this.option = null, this._theme = new _g(w2), this._locale = new _g(T2), this._optionManager = E;
        }, o.prototype.setOption = function(n3, p2, m2) {
          var w2 = Qve(p2);
          this._optionManager.setOption(n3, m2, w2), this._resetOption(null, w2);
        }, o.prototype.resetOption = function(n3, p2) {
          return this._resetOption(n3, Qve(p2));
        }, o.prototype._resetOption = function(n3, p2) {
          var m2 = false, w2 = this._optionManager;
          if (!n3 || n3 === "recreate") {
            var T2 = w2.mountOption(n3 === "recreate");
            !this.option || n3 === "recreate" ? Zve(this, T2) : (this.restoreData(), this._mergeOption(T2, p2)), m2 = true;
          }
          if ((n3 === "timeline" || n3 === "media") && this.restoreData(), !n3 || n3 === "recreate" || n3 === "timeline") {
            var E = w2.getTimelineOption(this);
            E && (m2 = true, this._mergeOption(E, p2));
          }
          if (!n3 || n3 === "recreate" || n3 === "media") {
            var O2 = w2.getMediaOption(this);
            O2.length && Xe2(O2, function(V3) {
              m2 = true, this._mergeOption(V3, p2);
            }, this);
          }
          return m2;
        }, o.prototype.mergeOption = function(n3) {
          this._mergeOption(n3, null);
        }, o.prototype._mergeOption = function(n3, p2) {
          var m2 = this.option, w2 = this._componentsMap, T2 = this._componentsCount, E = [], O2 = pl(), V3 = p2 && p2.replaceMergeMainTypeMap;
          wyn(this), Xe2(n3, function(q3, K) {
            q3 != null && (kh2.hasClass(K) ? K && (E.push(K), O2.set(K, true)) : m2[K] = m2[K] == null ? jl(q3) : Cu(m2[K], q3, true));
          }), V3 && V3.each(function(q3, K) {
            kh2.hasClass(K) && !O2.get(K) && (E.push(K), O2.set(K, true));
          }), kh2.topologicalTravel(E, kh2.getAllClassMainTypes(), W3, this);
          function W3(q3) {
            var K = Cyn(this, q3, Tp(n3[q3])), J = w2.get(q3), rt2 = J ? V3 && V3.get(q3) ? "replaceMerge" : "normalMerge" : "replaceAll", gt = I1(J, K, rt2);
            bat(gt, q3, kh2), m2[q3] = null, w2.set(q3, null), T2.set(q3, 0);
            var yt = [], At = [], Lt = 0, Wt;
            Xe2(gt, function(Nt, ue2) {
              var ie2 = Nt.existing, pe2 = Nt.newOption;
              if (!pe2)
                ie2 && (ie2.mergeOption({}, this), ie2.optionUpdated({}, false));
              else {
                var xe = q3 === "series", Ce2 = kh2.getClass(q3, Nt.keyInfo.subType, !xe);
                if (!Ce2)
                  return;
                if (q3 === "tooltip") {
                  if (Wt)
                    return;
                  Wt = true;
                }
                if (ie2 && ie2.constructor === Ce2)
                  ie2.name = Nt.keyInfo.name, ie2.mergeOption(pe2, this), ie2.optionUpdated(pe2, false);
                else {
                  var Le2 = ua2({ componentIndex: ue2 }, Nt.keyInfo);
                  ie2 = new Ce2(pe2, this, this, Le2), ua2(ie2, Le2), Nt.brandNew && (ie2.__requireNewView = true), ie2.init(pe2, this, this), ie2.optionUpdated(null, true);
                }
              }
              ie2 ? (yt.push(ie2.option), At.push(ie2), Lt++) : (yt.push(void 0), At.push(void 0));
            }, this), m2[q3] = yt, w2.set(q3, At), T2.set(q3, Lt), q3 === "series" && B_t(this);
          }
          this._seriesIndices || B_t(this);
        }, o.prototype.getOption = function() {
          var n3 = jl(this.option);
          return Xe2(n3, function(p2, m2) {
            if (kh2.hasClass(m2)) {
              for (var w2 = Tp(p2), T2 = w2.length, E = false, O2 = T2 - 1; O2 >= 0; O2--)
                w2[O2] && !s4(w2[O2]) ? E = true : (w2[O2] = null, !E && T2--);
              w2.length = T2, n3[m2] = w2;
            }
          }), delete n3[$ve], n3;
        }, o.prototype.getTheme = function() {
          return this._theme;
        }, o.prototype.getLocaleModel = function() {
          return this._locale;
        }, o.prototype.setUpdatePayload = function(n3) {
          this._payload = n3;
        }, o.prototype.getUpdatePayload = function() {
          return this._payload;
        }, o.prototype.getComponent = function(n3, p2) {
          var m2 = this._componentsMap.get(n3);
          if (m2) {
            var w2 = m2[p2 || 0];
            if (w2)
              return w2;
            if (p2 == null) {
              for (var T2 = 0; T2 < m2.length; T2++)
                if (m2[T2])
                  return m2[T2];
            }
          }
        }, o.prototype.queryComponents = function(n3) {
          var p2 = n3.mainType;
          if (!p2)
            return [];
          var m2 = n3.index, w2 = n3.id, T2 = n3.name, E = this._componentsMap.get(p2);
          if (!E || !E.length)
            return [];
          var O2;
          return m2 != null ? (O2 = [], Xe2(Tp(m2), function(V3) {
            E[V3] && O2.push(E[V3]);
          })) : w2 != null ? O2 = Kve("id", w2, E) : T2 != null ? O2 = Kve("name", T2, E) : O2 = Fp(E, function(V3) {
            return !!V3;
          }), Xve(O2, n3);
        }, o.prototype.findComponents = function(n3) {
          var p2 = n3.query, m2 = n3.mainType, w2 = E(p2), T2 = w2 ? this.queryComponents(w2) : Fp(this._componentsMap.get(m2), function(V3) {
            return !!V3;
          });
          return O2(Xve(T2, n3));
          function E(V3) {
            var W3 = m2 + "Index", q3 = m2 + "Id", K = m2 + "Name";
            return V3 && (V3[W3] != null || V3[q3] != null || V3[K] != null) ? { mainType: m2, index: V3[W3], id: V3[q3], name: V3[K] } : null;
          }
          function O2(V3) {
            return n3.filter ? Fp(V3, n3.filter) : V3;
          }
        }, o.prototype.eachComponent = function(n3, p2, m2) {
          var w2 = this._componentsMap;
          if (Sl(n3)) {
            var T2 = p2, E = n3;
            w2.each(function(q3, K) {
              for (var J = 0; q3 && J < q3.length; J++) {
                var rt2 = q3[J];
                rt2 && E.call(T2, K, rt2, rt2.componentIndex);
              }
            });
          } else
            for (var O2 = ds(n3) ? w2.get(n3) : ys(n3) ? this.findComponents(n3) : null, V3 = 0; O2 && V3 < O2.length; V3++) {
              var W3 = O2[V3];
              W3 && p2.call(m2, W3, W3.componentIndex);
            }
        }, o.prototype.getSeriesByName = function(n3) {
          var p2 = $d2(n3, null);
          return Fp(this._componentsMap.get("series"), function(m2) {
            return !!m2 && p2 != null && m2.name === p2;
          });
        }, o.prototype.getSeriesByIndex = function(n3) {
          return this._componentsMap.get("series")[n3];
        }, o.prototype.getSeriesByType = function(n3) {
          return Fp(this._componentsMap.get("series"), function(p2) {
            return !!p2 && p2.subType === n3;
          });
        }, o.prototype.getSeries = function() {
          return Fp(this._componentsMap.get("series"), function(n3) {
            return !!n3;
          });
        }, o.prototype.getSeriesCount = function() {
          return this._componentsCount.get("series");
        }, o.prototype.eachSeries = function(n3, p2) {
          Mot(this), Xe2(this._seriesIndices, function(m2) {
            var w2 = this._componentsMap.get("series")[m2];
            n3.call(p2, w2, m2);
          }, this);
        }, o.prototype.eachRawSeries = function(n3, p2) {
          Xe2(this._componentsMap.get("series"), function(m2) {
            m2 && n3.call(p2, m2, m2.componentIndex);
          });
        }, o.prototype.eachSeriesByType = function(n3, p2, m2) {
          Mot(this), Xe2(this._seriesIndices, function(w2) {
            var T2 = this._componentsMap.get("series")[w2];
            T2.subType === n3 && p2.call(m2, T2, w2);
          }, this);
        }, o.prototype.eachRawSeriesByType = function(n3, p2, m2) {
          return Xe2(this.getSeriesByType(n3), p2, m2);
        }, o.prototype.isSeriesFiltered = function(n3) {
          return Mot(this), this._seriesIndicesMap.get(n3.componentIndex) == null;
        }, o.prototype.getCurrentSeriesIndices = function() {
          return (this._seriesIndices || []).slice();
        }, o.prototype.filterSeries = function(n3, p2) {
          Mot(this);
          var m2 = [];
          Xe2(this._seriesIndices, function(w2) {
            var T2 = this._componentsMap.get("series")[w2];
            n3.call(p2, T2, w2) && m2.push(w2);
          }, this), this._seriesIndices = m2, this._seriesIndicesMap = pl(m2);
        }, o.prototype.restoreData = function(n3) {
          B_t(this);
          var p2 = this._componentsMap, m2 = [];
          p2.each(function(w2, T2) {
            kh2.hasClass(T2) && m2.push(T2);
          }), kh2.topologicalTravel(m2, kh2.getAllClassMainTypes(), function(w2) {
            Xe2(p2.get(w2), function(T2) {
              T2 && (w2 !== "series" || !Eyn(T2, n3)) && T2.restoreData();
            });
          });
        }, o.internalField = function() {
          B_t = function(n3) {
            var p2 = n3._seriesIndices = [];
            Xe2(n3._componentsMap.get("series"), function(m2) {
              m2 && p2.push(m2.componentIndex);
            }), n3._seriesIndicesMap = pl(p2);
          }, Mot = function(n3) {
          }, Zve = function(n3, p2) {
            n3.option = {}, n3.option[$ve] = Dyn, n3._componentsMap = pl({ series: [] }), n3._componentsCount = pl();
            var m2 = p2.aria;
            ys(m2) && m2.enabled == null && (m2.enabled = true), kyn(p2, n3._theme.option), Cu(p2, xyn, false), n3._mergeOption(p2, null);
          };
        }(), o;
      }(_g);
      function Eyn(u, o) {
        if (o) {
          var n3 = o.seriesIndex, p2 = o.seriesId, m2 = o.seriesName;
          return n3 != null && u.componentIndex !== n3 || p2 != null && u.id !== p2 || m2 != null && u.name !== m2;
        }
      }
      function kyn(u, o) {
        var n3 = u.color && !u.colorLayer;
        Xe2(o, function(p2, m2) {
          m2 === "colorLayer" && n3 || kh2.hasClass(m2) || (typeof p2 == "object" ? u[m2] = u[m2] ? Cu(u[m2], p2, false) : jl(p2) : u[m2] == null && (u[m2] = p2));
        });
      }
      function Kve(u, o, n3) {
        if (za2(o)) {
          var p2 = pl();
          return Xe2(o, function(w2) {
            if (w2 != null) {
              var T2 = $d2(w2, null);
              T2 != null && p2.set(w2, true);
            }
          }), Fp(n3, function(w2) {
            return w2 && p2.get(w2[u]);
          });
        } else {
          var m2 = $d2(o, null);
          return Fp(n3, function(w2) {
            return w2 && m2 != null && w2[u] === m2;
          });
        }
      }
      function Xve(u, o) {
        return o.hasOwnProperty("subType") ? Fp(u, function(n3) {
          return n3 && n3.subType === o.subType;
        }) : u;
      }
      function Qve(u) {
        var o = pl();
        return u && Xe2(Tp(u.replaceMerge), function(n3) {
          o.set(n3, true);
        }), { replaceMergeMainTypeMap: o };
      }
      x0(Yve, f8t);
      var Jve = Yve, Pyn = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], Lyn = function() {
        function u(o) {
          Xe2(Pyn, function(n3) {
            this[n3] = Is(o[n3], o);
          }, this);
        }
        return u;
      }(), t0e = Lyn, p8t = {}, Oyn = function() {
        function u() {
          this._coordinateSystems = [];
        }
        return u.prototype.create = function(o, n3) {
          var p2 = [];
          Xe2(p8t, function(m2, w2) {
            var T2 = m2.create(o, n3);
            p2 = p2.concat(T2 || []);
          }), this._coordinateSystems = p2;
        }, u.prototype.update = function(o, n3) {
          Xe2(this._coordinateSystems, function(p2) {
            p2.update && p2.update(o, n3);
          });
        }, u.prototype.getCoordinateSystems = function() {
          return this._coordinateSystems.slice();
        }, u.register = function(o, n3) {
          p8t[o] = n3;
        }, u.get = function(o) {
          return p8t[o];
        }, u;
      }(), Cot = Oyn, Ryn = /^(min|max)?(.+)$/, Nyn = function() {
        function u(o) {
          this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = o;
        }
        return u.prototype.setOption = function(o, n3, p2) {
          o && (Xe2(Tp(o.series), function(T2) {
            T2 && T2.data && HS(T2.data) && jB(T2.data);
          }), Xe2(Tp(o.dataset), function(T2) {
            T2 && T2.source && HS(T2.source) && jB(T2.source);
          })), o = jl(o);
          var m2 = this._optionBackup, w2 = Fyn(o, n3, !m2);
          this._newBaseOption = w2.baseOption, m2 ? (w2.timelineOptions.length && (m2.timelineOptions = w2.timelineOptions), w2.mediaList.length && (m2.mediaList = w2.mediaList), w2.mediaDefault && (m2.mediaDefault = w2.mediaDefault)) : this._optionBackup = w2;
        }, u.prototype.mountOption = function(o) {
          var n3 = this._optionBackup;
          return this._timelineOptions = n3.timelineOptions, this._mediaList = n3.mediaList, this._mediaDefault = n3.mediaDefault, this._currentMediaIndices = [], jl(o ? n3.baseOption : this._newBaseOption);
        }, u.prototype.getTimelineOption = function(o) {
          var n3, p2 = this._timelineOptions;
          if (p2.length) {
            var m2 = o.getComponent("timeline");
            m2 && (n3 = jl(p2[m2.getCurrentIndex()]));
          }
          return n3;
        }, u.prototype.getMediaOption = function(o) {
          var n3 = this._api.getWidth(), p2 = this._api.getHeight(), m2 = this._mediaList, w2 = this._mediaDefault, T2 = [], E = [];
          if (!m2.length && !w2)
            return E;
          for (var O2 = 0, V3 = m2.length; O2 < V3; O2++)
            Vyn(m2[O2].query, n3, p2) && T2.push(O2);
          return !T2.length && w2 && (T2 = [-1]), T2.length && !zyn(T2, this._currentMediaIndices) && (E = Ya2(T2, function(W3) {
            return jl(W3 === -1 ? w2.option : m2[W3].option);
          })), this._currentMediaIndices = T2, E;
        }, u;
      }();
      function Fyn(u, o, n3) {
        var p2 = [], m2, w2, T2 = u.baseOption, E = u.timeline, O2 = u.options, V3 = u.media, W3 = !!u.media, q3 = !!(O2 || E || T2 && T2.timeline);
        T2 ? (w2 = T2, w2.timeline || (w2.timeline = E)) : ((q3 || W3) && (u.options = u.media = null), w2 = u), W3 && za2(V3) && Xe2(V3, function(J) {
          J && J.option && (J.query ? p2.push(J) : m2 || (m2 = J));
        }), K(w2), Xe2(O2, function(J) {
          return K(J);
        }), Xe2(p2, function(J) {
          return K(J.option);
        });
        function K(J) {
          Xe2(o, function(rt2) {
            rt2(J, n3);
          });
        }
        return { baseOption: w2, timelineOptions: O2 || [], mediaDefault: m2, mediaList: p2 };
      }
      function Vyn(u, o, n3) {
        var p2 = { width: o, height: n3, aspectratio: o / n3 }, m2 = true;
        return Xe2(u, function(w2, T2) {
          var E = T2.match(Ryn);
          if (!(!E || !E[1] || !E[2])) {
            var O2 = E[1], V3 = E[2].toLowerCase();
            Byn(p2[V3], w2, O2) || (m2 = false);
          }
        }), m2;
      }
      function Byn(u, o, n3) {
        return n3 === "min" ? u >= o : n3 === "max" ? u <= o : u === o;
      }
      function zyn(u, o) {
        return u.join(",") === o.join(",");
      }
      var jyn = Nyn, rk2 = Xe2, Tot = ys, e0e = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
      function d8t(u) {
        var o = u && u.itemStyle;
        if (o)
          for (var n3 = 0, p2 = e0e.length; n3 < p2; n3++) {
            var m2 = e0e[n3], w2 = o.normal, T2 = o.emphasis;
            w2 && w2[m2] && (u[m2] = u[m2] || {}, u[m2].normal ? Cu(u[m2].normal, w2[m2]) : u[m2].normal = w2[m2], w2[m2] = null), T2 && T2[m2] && (u[m2] = u[m2] || {}, u[m2].emphasis ? Cu(u[m2].emphasis, T2[m2]) : u[m2].emphasis = T2[m2], T2[m2] = null);
          }
      }
      function Iw(u, o, n3) {
        if (u && u[o] && (u[o].normal || u[o].emphasis)) {
          var p2 = u[o].normal, m2 = u[o].emphasis;
          p2 && (n3 ? (u[o].normal = u[o].emphasis = null, kl(u[o], p2)) : u[o] = p2), m2 && (u.emphasis = u.emphasis || {}, u.emphasis[o] = m2, m2.focus && (u.emphasis.focus = m2.focus), m2.blurScope && (u.emphasis.blurScope = m2.blurScope));
        }
      }
      function Aot(u) {
        Iw(u, "itemStyle"), Iw(u, "lineStyle"), Iw(u, "areaStyle"), Iw(u, "label"), Iw(u, "labelLine"), Iw(u, "upperLabel"), Iw(u, "edgeLabel");
      }
      function Qy(u, o) {
        var n3 = Tot(u) && u[o], p2 = Tot(n3) && n3.textStyle;
        if (p2)
          for (var m2 = 0, w2 = mbt.length; m2 < w2; m2++) {
            var T2 = mbt[m2];
            p2.hasOwnProperty(T2) && (n3[T2] = p2[T2]);
          }
      }
      function pI(u) {
        u && (Aot(u), Qy(u, "label"), u.emphasis && Qy(u.emphasis, "label"));
      }
      function Wyn(u) {
        if (Tot(u)) {
          d8t(u), Aot(u), Qy(u, "label"), Qy(u, "upperLabel"), Qy(u, "edgeLabel"), u.emphasis && (Qy(u.emphasis, "label"), Qy(u.emphasis, "upperLabel"), Qy(u.emphasis, "edgeLabel"));
          var o = u.markPoint;
          o && (d8t(o), pI(o));
          var n3 = u.markLine;
          n3 && (d8t(n3), pI(n3));
          var p2 = u.markArea;
          p2 && pI(p2);
          var m2 = u.data;
          if (u.type === "graph") {
            m2 = m2 || u.nodes;
            var w2 = u.links || u.edges;
            if (w2 && !HS(w2))
              for (var T2 = 0; T2 < w2.length; T2++)
                pI(w2[T2]);
            Xe2(u.categories, function(V3) {
              Aot(V3);
            });
          }
          if (m2 && !HS(m2))
            for (var T2 = 0; T2 < m2.length; T2++)
              pI(m2[T2]);
          if (o = u.markPoint, o && o.data)
            for (var E = o.data, T2 = 0; T2 < E.length; T2++)
              pI(E[T2]);
          if (n3 = u.markLine, n3 && n3.data)
            for (var O2 = n3.data, T2 = 0; T2 < O2.length; T2++)
              za2(O2[T2]) ? (pI(O2[T2][0]), pI(O2[T2][1])) : pI(O2[T2]);
          u.type === "gauge" ? (Qy(u, "axisLabel"), Qy(u, "title"), Qy(u, "detail")) : u.type === "treemap" ? (Iw(u.breadcrumb, "itemStyle"), Xe2(u.levels, function(V3) {
            Aot(V3);
          })) : u.type === "tree" && Aot(u.leaves);
        }
      }
      function M4(u) {
        return za2(u) ? u : u ? [u] : [];
      }
      function n0e(u) {
        return (za2(u) ? u[0] : u) || {};
      }
      function Gyn(u, o) {
        rk2(M4(u.series), function(p2) {
          Tot(p2) && Wyn(p2);
        });
        var n3 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
        o && n3.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), rk2(n3, function(p2) {
          rk2(M4(u[p2]), function(m2) {
            m2 && (Qy(m2, "axisLabel"), Qy(m2.axisPointer, "label"));
          });
        }), rk2(M4(u.parallel), function(p2) {
          var m2 = p2 && p2.parallelAxisDefault;
          Qy(m2, "axisLabel"), Qy(m2 && m2.axisPointer, "label");
        }), rk2(M4(u.calendar), function(p2) {
          Iw(p2, "itemStyle"), Qy(p2, "dayLabel"), Qy(p2, "monthLabel"), Qy(p2, "yearLabel");
        }), rk2(M4(u.radar), function(p2) {
          Qy(p2, "name"), p2.name && p2.axisName == null && (p2.axisName = p2.name, delete p2.name), p2.nameGap != null && p2.axisNameGap == null && (p2.axisNameGap = p2.nameGap, delete p2.nameGap);
        }), rk2(M4(u.geo), function(p2) {
          Tot(p2) && (pI(p2), rk2(M4(p2.regions), function(m2) {
            pI(m2);
          }));
        }), rk2(M4(u.timeline), function(p2) {
          pI(p2), Iw(p2, "label"), Iw(p2, "itemStyle"), Iw(p2, "controlStyle", true);
          var m2 = p2.data;
          za2(m2) && Xe2(m2, function(w2) {
            ys(w2) && (Iw(w2, "label"), Iw(w2, "itemStyle"));
          });
        }), rk2(M4(u.toolbox), function(p2) {
          Iw(p2, "iconStyle"), rk2(p2.feature, function(m2) {
            Iw(m2, "iconStyle");
          });
        }), Qy(n0e(u.axisPointer), "label"), Qy(n0e(u.tooltip).axisPointer, "label");
      }
      function Hyn(u, o) {
        for (var n3 = o.split(","), p2 = u, m2 = 0; m2 < n3.length && (p2 = p2 && p2[n3[m2]], p2 != null); m2++)
          ;
        return p2;
      }
      function Uyn(u, o, n3, p2) {
        for (var m2 = o.split(","), w2 = u, T2, E = 0; E < m2.length - 1; E++)
          T2 = m2[E], w2[T2] == null && (w2[T2] = {}), w2 = w2[T2];
        (p2 || w2[m2[E]] == null) && (w2[m2[E]] = n3);
      }
      function r0e(u) {
        u && Xe2(qyn, function(o) {
          o[0] in u && !(o[1] in u) && (u[o[1]] = u[o[0]]);
        });
      }
      var qyn = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], Zyn = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], g8t = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
      function Iot(u) {
        var o = u && u.itemStyle;
        if (o)
          for (var n3 = 0; n3 < g8t.length; n3++) {
            var p2 = g8t[n3][1], m2 = g8t[n3][0];
            o[p2] != null && (o[m2] = o[p2]);
          }
      }
      function i0e(u) {
        !u || u.alignTo === "edge" && u.margin != null && u.edgeDistance == null && (u.edgeDistance = u.margin);
      }
      function a0e(u) {
        !u || u.downplay && !u.blur && (u.blur = u.downplay);
      }
      function $yn(u) {
        !u || u.focusNodeAdjacency != null && (u.emphasis = u.emphasis || {}, u.emphasis.focus == null && (u.emphasis.focus = "adjacency"));
      }
      function o0e(u, o) {
        if (u)
          for (var n3 = 0; n3 < u.length; n3++)
            o(u[n3]), u[n3] && o0e(u[n3].children, o);
      }
      function s0e(u, o) {
        Gyn(u, o), u.series = Tp(u.series), Xe2(u.series, function(n3) {
          if (ys(n3)) {
            var p2 = n3.type;
            if (p2 === "line")
              n3.clipOverflow != null && (n3.clip = n3.clipOverflow);
            else if (p2 === "pie" || p2 === "gauge") {
              n3.clockWise != null && (n3.clockwise = n3.clockWise), i0e(n3.label);
              var m2 = n3.data;
              if (m2 && !HS(m2))
                for (var w2 = 0; w2 < m2.length; w2++)
                  i0e(m2[w2]);
              n3.hoverOffset != null && (n3.emphasis = n3.emphasis || {}, (n3.emphasis.scaleSize = null) && (n3.emphasis.scaleSize = n3.hoverOffset));
            } else if (p2 === "gauge") {
              var T2 = Hyn(n3, "pointer.color");
              T2 != null && Uyn(n3, "itemStyle.color", T2);
            } else if (p2 === "bar") {
              Iot(n3), Iot(n3.backgroundStyle), Iot(n3.emphasis);
              var m2 = n3.data;
              if (m2 && !HS(m2))
                for (var w2 = 0; w2 < m2.length; w2++)
                  typeof m2[w2] == "object" && (Iot(m2[w2]), Iot(m2[w2] && m2[w2].emphasis));
            } else if (p2 === "sunburst") {
              var E = n3.highlightPolicy;
              E && (n3.emphasis = n3.emphasis || {}, n3.emphasis.focus || (n3.emphasis.focus = E)), a0e(n3), o0e(n3.data, a0e);
            } else
              p2 === "graph" || p2 === "sankey" ? $yn(n3) : p2 === "map" && (n3.mapType && !n3.map && (n3.map = n3.mapType), n3.mapLocation && kl(n3, n3.mapLocation));
            n3.hoverAnimation != null && (n3.emphasis = n3.emphasis || {}, n3.emphasis && n3.emphasis.scale == null && (n3.emphasis.scale = n3.hoverAnimation)), r0e(n3);
          }
        }), u.dataRange && (u.visualMap = u.dataRange), Xe2(Zyn, function(n3) {
          var p2 = u[n3];
          p2 && (za2(p2) || (p2 = [p2]), Xe2(p2, function(m2) {
            r0e(m2);
          }));
        });
      }
      function Yyn(u) {
        var o = pl();
        u.eachSeries(function(n3) {
          var p2 = n3.get("stack");
          if (p2) {
            var m2 = o.get(p2) || o.set(p2, []), w2 = n3.getData(), T2 = { stackResultDimension: w2.getCalculationInfo("stackResultDimension"), stackedOverDimension: w2.getCalculationInfo("stackedOverDimension"), stackedDimension: w2.getCalculationInfo("stackedDimension"), stackedByDimension: w2.getCalculationInfo("stackedByDimension"), isStackedByIndex: w2.getCalculationInfo("isStackedByIndex"), data: w2, seriesModel: n3 };
            if (!T2.stackedDimension || !(T2.isStackedByIndex || T2.stackedByDimension))
              return;
            m2.length && w2.setCalculationInfo("stackedOnSeries", m2[m2.length - 1].seriesModel), m2.push(T2);
          }
        }), o.each(Kyn);
      }
      function Kyn(u) {
        Xe2(u, function(o, n3) {
          var p2 = [], m2 = [NaN, NaN], w2 = [o.stackResultDimension, o.stackedOverDimension], T2 = o.data, E = o.isStackedByIndex;
          T2.modify(w2, function(O2, V3, W3) {
            var q3 = T2.get(o.stackedDimension, W3);
            if (isNaN(q3))
              return m2;
            var K, J;
            E ? J = T2.getRawIndex(W3) : K = T2.get(o.stackedByDimension, W3);
            for (var rt2 = NaN, gt = n3 - 1; gt >= 0; gt--) {
              var yt = u[gt];
              if (E || (J = yt.data.rawIndexOf(yt.stackedByDimension, K)), J >= 0) {
                var At = yt.data.getByRawIndex(yt.stackResultDimension, J);
                if (q3 >= 0 && At > 0 || q3 <= 0 && At < 0) {
                  q3 = s$(q3, At), rt2 = At;
                  break;
                }
              }
            }
            return p2[0] = q3, p2[1] = rt2, p2;
          });
        });
      }
      var z_t = function() {
        function u(o) {
          this.data = o.data || (o.sourceFormat === UP2 ? {} : []), this.sourceFormat = o.sourceFormat || zve, this.seriesLayoutBy = o.seriesLayoutBy || qP, this.startIndex = o.startIndex || 0, this.dimensionsDetectedCount = o.dimensionsDetectedCount, this.metaRawOption = o.metaRawOption;
          var n3 = this.dimensionsDefine = o.dimensionsDefine;
          if (n3)
            for (var p2 = 0; p2 < n3.length; p2++) {
              var m2 = n3[p2];
              m2.type == null && Gve(this, p2) === rx.Must && (m2.type = "ordinal");
            }
        }
        return u;
      }();
      function v8t(u) {
        return u instanceof z_t;
      }
      function y8t(u, o, n3) {
        n3 = n3 || l0e(u);
        var p2 = o.seriesLayoutBy, m2 = Qyn(u, n3, p2, o.sourceHeader, o.dimensions), w2 = new z_t({ data: u, sourceFormat: n3, seriesLayoutBy: p2, dimensionsDefine: m2.dimensionsDefine, startIndex: m2.startIndex, dimensionsDetectedCount: m2.dimensionsDetectedCount, metaRawOption: jl(o) });
        return w2;
      }
      function m8t(u) {
        return new z_t({ data: u, sourceFormat: HS(u) ? a8 : fI });
      }
      function Xyn(u) {
        return new z_t({ data: u.data, sourceFormat: u.sourceFormat, seriesLayoutBy: u.seriesLayoutBy, dimensionsDefine: jl(u.dimensionsDefine), startIndex: u.startIndex, dimensionsDetectedCount: u.dimensionsDetectedCount });
      }
      function l0e(u) {
        var o = zve;
        if (HS(u))
          o = a8;
        else if (za2(u)) {
          u.length === 0 && (o = Aw);
          for (var n3 = 0, p2 = u.length; n3 < p2; n3++) {
            var m2 = u[n3];
            if (m2 != null) {
              if (za2(m2)) {
                o = Aw;
                break;
              } else if (ys(m2)) {
                o = hI;
                break;
              }
            }
          }
        } else if (ys(u)) {
          for (var w2 in u)
            if (Fs(u, w2) && M1(u[w2])) {
              o = UP2;
              break;
            }
        }
        return o;
      }
      function Qyn(u, o, n3, p2, m2) {
        var w2, T2;
        if (!u)
          return { dimensionsDefine: u0e(m2), startIndex: T2, dimensionsDetectedCount: w2 };
        if (o === Aw) {
          var E = u;
          p2 === "auto" || p2 == null ? c0e(function(V3) {
            V3 != null && V3 !== "-" && (ds(V3) ? T2 == null && (T2 = 1) : T2 = 0);
          }, n3, E, 10) : T2 = Dh2(p2) ? p2 : p2 ? 1 : 0, !m2 && T2 === 1 && (m2 = [], c0e(function(V3, W3) {
            m2[W3] = V3 != null ? V3 + "" : "";
          }, n3, E, 1 / 0)), w2 = m2 ? m2.length : n3 === Q$ ? E.length : E[0] ? E[0].length : null;
        } else if (o === hI)
          m2 || (m2 = Jyn(u));
        else if (o === UP2)
          m2 || (m2 = [], Xe2(u, function(V3, W3) {
            m2.push(W3);
          }));
        else if (o === fI) {
          var O2 = PP(u[0]);
          w2 = za2(O2) && O2.length || 1;
        }
        return { startIndex: T2, dimensionsDefine: u0e(m2), dimensionsDetectedCount: w2 };
      }
      function Jyn(u) {
        for (var o = 0, n3; o < u.length && !(n3 = u[o++]); )
          ;
        if (n3) {
          var p2 = [];
          return Xe2(n3, function(m2, w2) {
            p2.push(w2);
          }), p2;
        }
      }
      function u0e(u) {
        if (u) {
          var o = pl();
          return Ya2(u, function(n3, p2) {
            n3 = ys(n3) ? n3 : { name: n3 };
            var m2 = { name: n3.name, displayName: n3.displayName, type: n3.type };
            if (m2.name == null)
              return m2;
            m2.name += "", m2.displayName == null && (m2.displayName = m2.name);
            var w2 = o.get(m2.name);
            return w2 ? m2.name += "-" + w2.count++ : o.set(m2.name, { count: 1 }), m2;
          });
        }
      }
      function c0e(u, o, n3, p2) {
        if (o === Q$)
          for (var m2 = 0; m2 < n3.length && m2 < p2; m2++)
            u(n3[m2] ? n3[m2][0] : null, m2);
        else
          for (var w2 = n3[0] || [], m2 = 0; m2 < w2.length && m2 < p2; m2++)
            u(w2[m2], m2);
      }
      function f0e(u) {
        var o = u.sourceFormat;
        return o === hI || o === UP2;
      }
      var kz, Pz, Lz, h0e, p0e, d0e = function() {
        function u(o, n3) {
          var p2 = v8t(o) ? o : m8t(o);
          this._source = p2;
          var m2 = this._data = p2.data;
          p2.sourceFormat === a8 && (this._offset = 0, this._dimSize = n3, this._data = m2), p0e(this, m2, p2);
        }
        return u.prototype.getSource = function() {
          return this._source;
        }, u.prototype.count = function() {
          return 0;
        }, u.prototype.getItem = function(o, n3) {
        }, u.prototype.appendData = function(o) {
        }, u.prototype.clean = function() {
        }, u.protoInitialize = function() {
          var o = u.prototype;
          o.pure = false, o.persistent = true;
        }(), u.internalField = function() {
          var o;
          p0e = function(T2, E, O2) {
            var V3 = O2.sourceFormat, W3 = O2.seriesLayoutBy, q3 = O2.startIndex, K = O2.dimensionsDefine, J = h0e[_8t(V3, W3)];
            if (ua2(T2, J), V3 === a8)
              T2.getItem = n3, T2.count = m2, T2.fillStorage = p2;
            else {
              var rt2 = v0e(V3, W3);
              T2.getItem = Is(rt2, null, E, q3, K);
              var gt = m0e(V3, W3);
              T2.count = Is(gt, null, E, q3, K);
            }
          };
          var n3 = function(T2, E) {
            T2 = T2 - this._offset, E = E || [];
            for (var O2 = this._data, V3 = this._dimSize, W3 = V3 * T2, q3 = 0; q3 < V3; q3++)
              E[q3] = O2[W3 + q3];
            return E;
          }, p2 = function(T2, E, O2, V3) {
            for (var W3 = this._data, q3 = this._dimSize, K = 0; K < q3; K++) {
              for (var J = V3[K], rt2 = J[0] == null ? 1 / 0 : J[0], gt = J[1] == null ? -1 / 0 : J[1], yt = E - T2, At = O2[K], Lt = 0; Lt < yt; Lt++) {
                var Wt = W3[Lt * q3 + K];
                At[T2 + Lt] = Wt, Wt < rt2 && (rt2 = Wt), Wt > gt && (gt = Wt);
              }
              J[0] = rt2, J[1] = gt;
            }
          }, m2 = function() {
            return this._data ? this._data.length / this._dimSize : 0;
          };
          h0e = (o = {}, o[Aw + "_" + qP] = { pure: true, appendData: w2 }, o[Aw + "_" + Q$] = { pure: true, appendData: function() {
            throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
          } }, o[hI] = { pure: true, appendData: w2 }, o[UP2] = { pure: true, appendData: function(T2) {
            var E = this._data;
            Xe2(T2, function(O2, V3) {
              for (var W3 = E[V3] || (E[V3] = []), q3 = 0; q3 < (O2 || []).length; q3++)
                W3.push(O2[q3]);
            });
          } }, o[fI] = { appendData: w2 }, o[a8] = { persistent: false, pure: true, appendData: function(T2) {
            this._data = T2;
          }, clean: function() {
            this._offset += this.count(), this._data = null;
          } }, o);
          function w2(T2) {
            for (var E = 0; E < T2.length; E++)
              this._data.push(T2[E]);
          }
        }(), u;
      }(), g0e = function(u, o, n3, p2) {
        return u[p2];
      }, tmn = (kz = {}, kz[Aw + "_" + qP] = function(u, o, n3, p2) {
        return u[p2 + o];
      }, kz[Aw + "_" + Q$] = function(u, o, n3, p2, m2) {
        p2 += o;
        for (var w2 = m2 || [], T2 = u, E = 0; E < T2.length; E++) {
          var O2 = T2[E];
          w2[E] = O2 ? O2[p2] : null;
        }
        return w2;
      }, kz[hI] = g0e, kz[UP2] = function(u, o, n3, p2, m2) {
        for (var w2 = m2 || [], T2 = 0; T2 < n3.length; T2++) {
          var E = n3[T2].name, O2 = u[E];
          w2[T2] = O2 ? O2[p2] : null;
        }
        return w2;
      }, kz[fI] = g0e, kz);
      function v0e(u, o) {
        var n3 = tmn[_8t(u, o)];
        return n3;
      }
      var y0e = function(u, o, n3) {
        return u.length;
      }, emn = (Pz = {}, Pz[Aw + "_" + qP] = function(u, o, n3) {
        return Math.max(0, u.length - o);
      }, Pz[Aw + "_" + Q$] = function(u, o, n3) {
        var p2 = u[0];
        return p2 ? Math.max(0, p2.length - o) : 0;
      }, Pz[hI] = y0e, Pz[UP2] = function(u, o, n3) {
        var p2 = n3[0].name, m2 = u[p2];
        return m2 ? m2.length : 0;
      }, Pz[fI] = y0e, Pz);
      function m0e(u, o) {
        var n3 = emn[_8t(u, o)];
        return n3;
      }
      var b8t = function(u, o, n3) {
        return u[o];
      }, nmn = (Lz = {}, Lz[Aw] = b8t, Lz[hI] = function(u, o, n3) {
        return u[n3];
      }, Lz[UP2] = b8t, Lz[fI] = function(u, o, n3) {
        var p2 = PP(u);
        return p2 instanceof Array ? p2[o] : p2;
      }, Lz[a8] = b8t, Lz);
      function b0e(u) {
        var o = nmn[u];
        return o;
      }
      function _8t(u, o) {
        return u === Aw ? u + "_" + o : u;
      }
      function J$(u, o, n3) {
        if (u) {
          var p2 = u.getRawDataItem(o);
          if (p2 != null) {
            var m2 = u.getStore(), w2 = m2.getSource().sourceFormat;
            if (n3 != null) {
              var T2 = u.getDimensionIndex(n3), E = m2.getDimensionProperty(T2);
              return b0e(w2)(p2, T2, E);
            } else {
              var O2 = p2;
              return w2 === fI && (O2 = PP(p2)), O2;
            }
          }
        }
      }
      var rmn = /\{@(.+?)\}/g, x8t = function() {
        function u() {
        }
        return u.prototype.getDataParams = function(o, n3) {
          var p2 = this.getData(n3), m2 = this.getRawValue(o, n3), w2 = p2.getRawIndex(o), T2 = p2.getName(o), E = p2.getRawDataItem(o), O2 = p2.getItemVisual(o, "style"), V3 = O2 && O2[p2.getItemVisual(o, "drawType") || "fill"], W3 = O2 && O2.stroke, q3 = this.mainType, K = q3 === "series", J = p2.userOutput && p2.userOutput.get();
          return { componentType: q3, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: K ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: K ? this.id : null, seriesName: K ? this.name : null, name: T2, dataIndex: w2, data: E, dataType: n3, value: m2, color: V3, borderColor: W3, dimensionNames: J ? J.fullDimensions : null, encode: J ? J.encode : null, $vars: ["seriesName", "name", "value"] };
        }, u.prototype.getFormattedLabel = function(o, n3, p2, m2, w2, T2) {
          n3 = n3 || "normal";
          var E = this.getData(p2), O2 = this.getDataParams(o, p2);
          if (T2 && (O2.value = T2.interpolatedValue), m2 != null && za2(O2.value) && (O2.value = O2.value[m2]), !w2) {
            var V3 = E.getItemModel(o);
            w2 = V3.get(n3 === "normal" ? ["label", "formatter"] : [n3, "label", "formatter"]);
          }
          if (Sl(w2))
            return O2.status = n3, O2.dimensionIndex = m2, w2(O2);
          if (ds(w2)) {
            var W3 = Rve(w2, O2);
            return W3.replace(rmn, function(q3, K) {
              var J = K.length, rt2 = K;
              rt2.charAt(0) === "[" && rt2.charAt(J - 1) === "]" && (rt2 = +rt2.slice(1, J - 1));
              var gt = J$(E, o, rt2);
              if (T2 && za2(T2.interpolatedValue)) {
                var yt = E.getDimensionIndex(rt2);
                yt >= 0 && (gt = T2.interpolatedValue[yt]);
              }
              return gt != null ? gt + "" : "";
            });
          }
        }, u.prototype.getRawValue = function(o, n3) {
          return J$(this.getData(n3), o);
        }, u.prototype.formatTooltip = function(o, n3, p2) {
        }, u;
      }();
      function _0e(u) {
        var o, n3;
        return ys(u) ? u.type && (n3 = u) : o = u, { text: o, frag: n3 };
      }
      function Dot(u) {
        return new imn(u);
      }
      var imn = function() {
        function u(o) {
          o = o || {}, this._reset = o.reset, this._plan = o.plan, this._count = o.count, this._onDirty = o.onDirty, this._dirty = true;
        }
        return u.prototype.perform = function(o) {
          var n3 = this._upstream, p2 = o && o.skip;
          if (this._dirty && n3) {
            var m2 = this.context;
            m2.data = m2.outputData = n3.context.outputData;
          }
          this.__pipeline && (this.__pipeline.currentTask = this);
          var w2;
          this._plan && !p2 && (w2 = this._plan(this.context));
          var T2 = W3(this._modBy), E = this._modDataCount || 0, O2 = W3(o && o.modBy), V3 = o && o.modDataCount || 0;
          (T2 !== O2 || E !== V3) && (w2 = "reset");
          function W3(Lt) {
            return !(Lt >= 1) && (Lt = 1), Lt;
          }
          var q3;
          (this._dirty || w2 === "reset") && (this._dirty = false, q3 = this._doReset(p2)), this._modBy = O2, this._modDataCount = V3;
          var K = o && o.step;
          if (n3 ? this._dueEnd = n3._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
            var J = this._dueIndex, rt2 = Math.min(K != null ? this._dueIndex + K : 1 / 0, this._dueEnd);
            if (!p2 && (q3 || J < rt2)) {
              var gt = this._progress;
              if (za2(gt))
                for (var yt = 0; yt < gt.length; yt++)
                  this._doProgress(gt[yt], J, rt2, O2, V3);
              else
                this._doProgress(gt, J, rt2, O2, V3);
            }
            this._dueIndex = rt2;
            var At = this._settedOutputEnd != null ? this._settedOutputEnd : rt2;
            this._outputDueEnd = At;
          } else
            this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
          return this.unfinished();
        }, u.prototype.dirty = function() {
          this._dirty = true, this._onDirty && this._onDirty(this.context);
        }, u.prototype._doProgress = function(o, n3, p2, m2, w2) {
          x0e.reset(n3, p2, m2, w2), this._callingProgress = o, this._callingProgress({ start: n3, end: p2, count: p2 - n3, next: x0e.next }, this.context);
        }, u.prototype._doReset = function(o) {
          this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
          var n3, p2;
          !o && this._reset && (n3 = this._reset(this.context), n3 && n3.progress && (p2 = n3.forceFirstProgress, n3 = n3.progress), za2(n3) && !n3.length && (n3 = null)), this._progress = n3, this._modBy = this._modDataCount = null;
          var m2 = this._downstream;
          return m2 && m2.dirty(), p2;
        }, u.prototype.unfinished = function() {
          return this._progress && this._dueIndex < this._dueEnd;
        }, u.prototype.pipe = function(o) {
          (this._downstream !== o || this._dirty) && (this._downstream = o, o._upstream = this, o.dirty());
        }, u.prototype.dispose = function() {
          this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
        }, u.prototype.getUpstream = function() {
          return this._upstream;
        }, u.prototype.getDownstream = function() {
          return this._downstream;
        }, u.prototype.setOutputEnd = function(o) {
          this._outputDueEnd = this._settedOutputEnd = o;
        }, u;
      }(), x0e = function() {
        var u, o, n3, p2, m2, w2 = { reset: function(O2, V3, W3, q3) {
          o = O2, u = V3, n3 = W3, p2 = q3, m2 = Math.ceil(p2 / n3), w2.next = n3 > 1 && p2 > 0 ? E : T2;
        } };
        return w2;
        function T2() {
          return o < u ? o++ : null;
        }
        function E() {
          var O2 = o % m2 * n3 + Math.ceil(o / m2), V3 = o >= u ? null : O2 < p2 ? O2 : o;
          return o++, V3;
        }
      }();
      function o8(u, o) {
        var n3 = o && o.type;
        return n3 === "ordinal" ? u : (n3 === "time" && !Dh2(u) && u != null && u !== "-" && (u = +Nm(u)), u == null || u === "" ? NaN : +u);
      }
      var amn = pl({ number: function(u) {
        return parseFloat(u);
      }, time: function(u) {
        return +Nm(u);
      }, trim: function(u) {
        return ds(u) ? US(u) : u;
      } });
      function w0e(u) {
        return amn.get(u);
      }
      var S0e = { lt: function(u, o) {
        return u < o;
      }, lte: function(u, o) {
        return u <= o;
      }, gt: function(u, o) {
        return u > o;
      }, gte: function(u, o) {
        return u >= o;
      } }, omn = function() {
        function u(o, n3) {
          if (!Dh2(n3)) {
            var p2 = "";
            lh2(p2);
          }
          this._opFn = S0e[o], this._rvalFloat = QE(n3);
        }
        return u.prototype.evaluate = function(o) {
          return Dh2(o) ? this._opFn(o, this._rvalFloat) : this._opFn(QE(o), this._rvalFloat);
        }, u;
      }(), M0e = function() {
        function u(o, n3) {
          var p2 = o === "desc";
          this._resultLT = p2 ? 1 : -1, n3 == null && (n3 = p2 ? "min" : "max"), this._incomparable = n3 === "min" ? -1 / 0 : 1 / 0;
        }
        return u.prototype.evaluate = function(o, n3) {
          var p2 = Dh2(o) ? o : QE(o), m2 = Dh2(n3) ? n3 : QE(n3), w2 = isNaN(p2), T2 = isNaN(m2);
          if (w2 && (p2 = this._incomparable), T2 && (m2 = this._incomparable), w2 && T2) {
            var E = ds(o), O2 = ds(n3);
            E && (p2 = O2 ? o : 0), O2 && (m2 = E ? n3 : 0);
          }
          return p2 < m2 ? this._resultLT : p2 > m2 ? -this._resultLT : 0;
        }, u;
      }(), smn = function() {
        function u(o, n3) {
          this._rval = n3, this._isEQ = o, this._rvalTypeof = typeof n3, this._rvalFloat = QE(n3);
        }
        return u.prototype.evaluate = function(o) {
          var n3 = o === this._rval;
          if (!n3) {
            var p2 = typeof o;
            p2 !== this._rvalTypeof && (p2 === "number" || this._rvalTypeof === "number") && (n3 = QE(o) === this._rvalFloat);
          }
          return this._isEQ ? n3 : !n3;
        }, u;
      }();
      function lmn(u, o) {
        return u === "eq" || u === "ne" ? new smn(u === "eq", o) : Fs(S0e, u) ? new omn(u, o) : null;
      }
      var umn = function() {
        function u() {
        }
        return u.prototype.getRawData = function() {
          throw new Error("not supported");
        }, u.prototype.getRawDataItem = function(o) {
          throw new Error("not supported");
        }, u.prototype.cloneRawData = function() {
        }, u.prototype.getDimensionInfo = function(o) {
        }, u.prototype.cloneAllDimensionInfo = function() {
        }, u.prototype.count = function() {
        }, u.prototype.retrieveValue = function(o, n3) {
        }, u.prototype.retrieveValueFromItem = function(o, n3) {
        }, u.prototype.convertValue = function(o, n3) {
          return o8(o, n3);
        }, u;
      }();
      function cmn(u, o) {
        var n3 = new umn(), p2 = u.data, m2 = n3.sourceFormat = u.sourceFormat, w2 = u.startIndex, T2 = "";
        u.seriesLayoutBy !== qP && lh2(T2);
        var E = [], O2 = {}, V3 = u.dimensionsDefine;
        if (V3)
          Xe2(V3, function(gt, yt) {
            var At = gt.name, Lt = { index: yt, name: At, displayName: gt.displayName };
            if (E.push(Lt), At != null) {
              var Wt = "";
              Fs(O2, At) && lh2(Wt), O2[At] = Lt;
            }
          });
        else
          for (var W3 = 0; W3 < u.dimensionsDetectedCount; W3++)
            E.push({ index: W3 });
        var q3 = v0e(m2, qP);
        o.__isBuiltIn && (n3.getRawDataItem = function(gt) {
          return q3(p2, w2, E, gt);
        }, n3.getRawData = Is(fmn, null, u)), n3.cloneRawData = Is(hmn, null, u);
        var K = m0e(m2, qP);
        n3.count = Is(K, null, p2, w2, E);
        var J = b0e(m2);
        n3.retrieveValue = function(gt, yt) {
          var At = q3(p2, w2, E, gt);
          return rt2(At, yt);
        };
        var rt2 = n3.retrieveValueFromItem = function(gt, yt) {
          if (gt != null) {
            var At = E[yt];
            if (At)
              return J(gt, yt, At.name);
          }
        };
        return n3.getDimensionInfo = Is(pmn, null, E, O2), n3.cloneAllDimensionInfo = Is(dmn, null, E), n3;
      }
      function fmn(u) {
        var o = u.sourceFormat;
        if (!w8t(o)) {
          var n3 = "";
          lh2(n3);
        }
        return u.data;
      }
      function hmn(u) {
        var o = u.sourceFormat, n3 = u.data;
        if (!w8t(o)) {
          var p2 = "";
          lh2(p2);
        }
        if (o === Aw) {
          for (var m2 = [], w2 = 0, T2 = n3.length; w2 < T2; w2++)
            m2.push(n3[w2].slice());
          return m2;
        } else if (o === hI) {
          for (var m2 = [], w2 = 0, T2 = n3.length; w2 < T2; w2++)
            m2.push(ua2({}, n3[w2]));
          return m2;
        }
      }
      function pmn(u, o, n3) {
        if (n3 != null) {
          if (Dh2(n3) || !isNaN(n3) && !Fs(o, n3))
            return u[n3];
          if (Fs(o, n3))
            return o[n3];
        }
      }
      function dmn(u) {
        return jl(u);
      }
      var C0e = pl();
      function gmn(u) {
        u = jl(u);
        var o = u.type, n3 = "";
        o || lh2(n3);
        var p2 = o.split(":");
        p2.length !== 2 && lh2(n3);
        var m2 = false;
        p2[0] === "echarts" && (o = p2[1], m2 = true), u.__isBuiltIn = m2, C0e.set(o, u);
      }
      function vmn(u, o, n3) {
        var p2 = Tp(u), m2 = p2.length, w2 = "";
        m2 || lh2(w2);
        for (var T2 = 0, E = m2; T2 < E; T2++) {
          var O2 = p2[T2];
          o = ymn(O2, o), T2 !== E - 1 && (o.length = Math.max(o.length, 1));
        }
        return o;
      }
      function ymn(u, o, n3, p2) {
        var m2 = "";
        o.length || lh2(m2), ys(u) || lh2(m2);
        var w2 = u.type, T2 = C0e.get(w2);
        T2 || lh2(m2);
        var E = Ya2(o, function(V3) {
          return cmn(V3, T2);
        }), O2 = Tp(T2.transform({ upstream: E[0], upstreamList: E, config: jl(u.config) }));
        return Ya2(O2, function(V3, W3) {
          var q3 = "";
          ys(V3) || lh2(q3), V3.data || lh2(q3);
          var K = l0e(V3.data);
          w8t(K) || lh2(q3);
          var J, rt2 = o[0];
          if (rt2 && W3 === 0 && !V3.dimensions) {
            var gt = rt2.startIndex;
            gt && (V3.data = rt2.data.slice(0, gt).concat(V3.data)), J = { seriesLayoutBy: qP, sourceHeader: gt, dimensions: rt2.metaRawOption.dimensions };
          } else
            J = { seriesLayoutBy: qP, sourceHeader: 0, dimensions: V3.dimensions };
          return y8t(V3.data, J, null);
        });
      }
      function w8t(u) {
        return u === Aw || u === hI;
      }
      var j_t = "undefined", mmn = typeof Uint32Array === j_t ? Array : Uint32Array, bmn = typeof Uint16Array === j_t ? Array : Uint16Array, T0e = typeof Int32Array === j_t ? Array : Int32Array, A0e = typeof Float64Array === j_t ? Array : Float64Array, I0e = { float: A0e, int: T0e, ordinal: Array, number: Array, time: A0e }, S8t;
      function Eot(u) {
        return u > 65535 ? mmn : bmn;
      }
      function tY() {
        return [1 / 0, -1 / 0];
      }
      function _mn(u) {
        var o = u.constructor;
        return o === Array ? u.slice() : new o(u);
      }
      function D0e(u, o, n3, p2, m2) {
        var w2 = I0e[n3 || "float"];
        if (m2) {
          var T2 = u[o], E = T2 && T2.length;
          if (E !== p2) {
            for (var O2 = new w2(p2), V3 = 0; V3 < E; V3++)
              O2[V3] = T2[V3];
            u[o] = O2;
          }
        } else
          u[o] = new w2(p2);
      }
      var M8t = function() {
        function u() {
          this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = pl();
        }
        return u.prototype.initData = function(o, n3, p2) {
          this._provider = o, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
          var m2 = o.getSource(), w2 = this.defaultDimValueGetter = S8t[m2.sourceFormat];
          this._dimValueGetter = p2 || w2, this._rawExtent = [], f0e(m2), this._dimensions = Ya2(n3, function(T2) {
            return { type: T2.type, property: T2.property };
          }), this._initDataFromProvider(0, o.count());
        }, u.prototype.getProvider = function() {
          return this._provider;
        }, u.prototype.getSource = function() {
          return this._provider.getSource();
        }, u.prototype.ensureCalculationDimension = function(o, n3) {
          var p2 = this._calcDimNameToIdx, m2 = this._dimensions, w2 = p2.get(o);
          if (w2 != null) {
            if (m2[w2].type === n3)
              return w2;
          } else
            w2 = m2.length;
          return m2[w2] = { type: n3 }, p2.set(o, w2), this._chunks[w2] = new I0e[n3 || "float"](this._rawCount), this._rawExtent[w2] = tY(), w2;
        }, u.prototype.collectOrdinalMeta = function(o, n3) {
          var p2 = this._chunks[o], m2 = this._dimensions[o], w2 = this._rawExtent, T2 = m2.ordinalOffset || 0, E = p2.length;
          T2 === 0 && (w2[o] = tY());
          for (var O2 = w2[o], V3 = T2; V3 < E; V3++) {
            var W3 = p2[V3] = n3.parseAndCollect(p2[V3]);
            O2[0] = Math.min(W3, O2[0]), O2[1] = Math.max(W3, O2[1]);
          }
          m2.ordinalMeta = n3, m2.ordinalOffset = E, m2.type = "ordinal";
        }, u.prototype.getOrdinalMeta = function(o) {
          var n3 = this._dimensions[o], p2 = n3.ordinalMeta;
          return p2;
        }, u.prototype.getDimensionProperty = function(o) {
          var n3 = this._dimensions[o];
          return n3 && n3.property;
        }, u.prototype.appendData = function(o) {
          var n3 = this._provider, p2 = this.count();
          n3.appendData(o);
          var m2 = n3.count();
          return n3.persistent || (m2 += p2), p2 < m2 && this._initDataFromProvider(p2, m2, true), [p2, m2];
        }, u.prototype.appendValues = function(o, n3) {
          for (var p2 = this._chunks, m2 = this._dimensions, w2 = m2.length, T2 = this._rawExtent, E = this.count(), O2 = E + Math.max(o.length, n3 || 0), V3 = 0; V3 < w2; V3++) {
            var W3 = m2[V3];
            D0e(p2, V3, W3.type, O2, true);
          }
          for (var q3 = [], K = E; K < O2; K++)
            for (var J = K - E, rt2 = 0; rt2 < w2; rt2++) {
              var W3 = m2[rt2], gt = S8t.arrayRows.call(this, o[J] || q3, W3.property, J, rt2);
              p2[rt2][K] = gt;
              var yt = T2[rt2];
              gt < yt[0] && (yt[0] = gt), gt > yt[1] && (yt[1] = gt);
            }
          return this._rawCount = this._count = O2, { start: E, end: O2 };
        }, u.prototype._initDataFromProvider = function(o, n3, p2) {
          for (var m2 = this._provider, w2 = this._chunks, T2 = this._dimensions, E = T2.length, O2 = this._rawExtent, V3 = Ya2(T2, function(Lt) {
            return Lt.property;
          }), W3 = 0; W3 < E; W3++) {
            var q3 = T2[W3];
            O2[W3] || (O2[W3] = tY()), D0e(w2, W3, q3.type, n3, p2);
          }
          if (m2.fillStorage)
            m2.fillStorage(o, n3, w2, O2);
          else
            for (var K = [], J = o; J < n3; J++) {
              K = m2.getItem(J, K);
              for (var rt2 = 0; rt2 < E; rt2++) {
                var gt = w2[rt2], yt = this._dimValueGetter(K, V3[rt2], J, rt2);
                gt[J] = yt;
                var At = O2[rt2];
                yt < At[0] && (At[0] = yt), yt > At[1] && (At[1] = yt);
              }
            }
          !m2.persistent && m2.clean && m2.clean(), this._rawCount = this._count = n3, this._extent = [];
        }, u.prototype.count = function() {
          return this._count;
        }, u.prototype.get = function(o, n3) {
          if (!(n3 >= 0 && n3 < this._count))
            return NaN;
          var p2 = this._chunks[o];
          return p2 ? p2[this.getRawIndex(n3)] : NaN;
        }, u.prototype.getValues = function(o, n3) {
          var p2 = [], m2 = [];
          if (n3 == null) {
            n3 = o, o = [];
            for (var w2 = 0; w2 < this._dimensions.length; w2++)
              m2.push(w2);
          } else
            m2 = o;
          for (var w2 = 0, T2 = m2.length; w2 < T2; w2++)
            p2.push(this.get(m2[w2], n3));
          return p2;
        }, u.prototype.getByRawIndex = function(o, n3) {
          if (!(n3 >= 0 && n3 < this._rawCount))
            return NaN;
          var p2 = this._chunks[o];
          return p2 ? p2[n3] : NaN;
        }, u.prototype.getSum = function(o) {
          var n3 = this._chunks[o], p2 = 0;
          if (n3)
            for (var m2 = 0, w2 = this.count(); m2 < w2; m2++) {
              var T2 = this.get(o, m2);
              isNaN(T2) || (p2 += T2);
            }
          return p2;
        }, u.prototype.getMedian = function(o) {
          var n3 = [];
          this.each([o], function(w2) {
            isNaN(w2) || n3.push(w2);
          });
          var p2 = n3.sort(function(w2, T2) {
            return w2 - T2;
          }), m2 = this.count();
          return m2 === 0 ? 0 : m2 % 2 === 1 ? p2[(m2 - 1) / 2] : (p2[m2 / 2] + p2[m2 / 2 - 1]) / 2;
        }, u.prototype.indexOfRawIndex = function(o) {
          if (o >= this._rawCount || o < 0)
            return -1;
          if (!this._indices)
            return o;
          var n3 = this._indices, p2 = n3[o];
          if (p2 != null && p2 < this._count && p2 === o)
            return o;
          for (var m2 = 0, w2 = this._count - 1; m2 <= w2; ) {
            var T2 = (m2 + w2) / 2 | 0;
            if (n3[T2] < o)
              m2 = T2 + 1;
            else if (n3[T2] > o)
              w2 = T2 - 1;
            else
              return T2;
          }
          return -1;
        }, u.prototype.indicesOfNearest = function(o, n3, p2) {
          var m2 = this._chunks, w2 = m2[o], T2 = [];
          if (!w2)
            return T2;
          p2 == null && (p2 = 1 / 0);
          for (var E = 1 / 0, O2 = -1, V3 = 0, W3 = 0, q3 = this.count(); W3 < q3; W3++) {
            var K = this.getRawIndex(W3), J = n3 - w2[K], rt2 = Math.abs(J);
            rt2 <= p2 && ((rt2 < E || rt2 === E && J >= 0 && O2 < 0) && (E = rt2, O2 = J, V3 = 0), J === O2 && (T2[V3++] = W3));
          }
          return T2.length = V3, T2;
        }, u.prototype.getIndices = function() {
          var o, n3 = this._indices;
          if (n3) {
            var p2 = n3.constructor, m2 = this._count;
            if (p2 === Array) {
              o = new p2(m2);
              for (var w2 = 0; w2 < m2; w2++)
                o[w2] = n3[w2];
            } else
              o = new p2(n3.buffer, 0, m2);
          } else {
            var p2 = Eot(this._rawCount);
            o = new p2(this.count());
            for (var w2 = 0; w2 < o.length; w2++)
              o[w2] = w2;
          }
          return o;
        }, u.prototype.filter = function(o, n3) {
          if (!this._count)
            return this;
          for (var p2 = this.clone(), m2 = p2.count(), w2 = Eot(p2._rawCount), T2 = new w2(m2), E = [], O2 = o.length, V3 = 0, W3 = o[0], q3 = p2._chunks, K = 0; K < m2; K++) {
            var J = void 0, rt2 = p2.getRawIndex(K);
            if (O2 === 0)
              J = n3(K);
            else if (O2 === 1) {
              var gt = q3[W3][rt2];
              J = n3(gt, K);
            } else {
              for (var yt = 0; yt < O2; yt++)
                E[yt] = q3[o[yt]][rt2];
              E[yt] = K, J = n3.apply(null, E);
            }
            J && (T2[V3++] = rt2);
          }
          return V3 < m2 && (p2._indices = T2), p2._count = V3, p2._extent = [], p2._updateGetRawIdx(), p2;
        }, u.prototype.selectRange = function(o) {
          var n3 = this.clone(), p2 = n3._count;
          if (!p2)
            return this;
          var m2 = tf2(o), w2 = m2.length;
          if (!w2)
            return this;
          var T2 = n3.count(), E = Eot(n3._rawCount), O2 = new E(T2), V3 = 0, W3 = m2[0], q3 = o[W3][0], K = o[W3][1], J = n3._chunks, rt2 = false;
          if (!n3._indices) {
            var gt = 0;
            if (w2 === 1) {
              for (var yt = J[m2[0]], At = 0; At < p2; At++) {
                var Lt = yt[At];
                (Lt >= q3 && Lt <= K || isNaN(Lt)) && (O2[V3++] = gt), gt++;
              }
              rt2 = true;
            } else if (w2 === 2) {
              for (var yt = J[m2[0]], Wt = J[m2[1]], Nt = o[m2[1]][0], ue2 = o[m2[1]][1], At = 0; At < p2; At++) {
                var Lt = yt[At], ie2 = Wt[At];
                (Lt >= q3 && Lt <= K || isNaN(Lt)) && (ie2 >= Nt && ie2 <= ue2 || isNaN(ie2)) && (O2[V3++] = gt), gt++;
              }
              rt2 = true;
            }
          }
          if (!rt2)
            if (w2 === 1)
              for (var At = 0; At < T2; At++) {
                var pe2 = n3.getRawIndex(At), Lt = J[m2[0]][pe2];
                (Lt >= q3 && Lt <= K || isNaN(Lt)) && (O2[V3++] = pe2);
              }
            else
              for (var At = 0; At < T2; At++) {
                for (var xe = true, pe2 = n3.getRawIndex(At), Ce2 = 0; Ce2 < w2; Ce2++) {
                  var Le2 = m2[Ce2], Lt = J[Le2][pe2];
                  (Lt < o[Le2][0] || Lt > o[Le2][1]) && (xe = false);
                }
                xe && (O2[V3++] = n3.getRawIndex(At));
              }
          return V3 < T2 && (n3._indices = O2), n3._count = V3, n3._extent = [], n3._updateGetRawIdx(), n3;
        }, u.prototype.map = function(o, n3) {
          var p2 = this.clone(o);
          return this._updateDims(p2, o, n3), p2;
        }, u.prototype.modify = function(o, n3) {
          this._updateDims(this, o, n3);
        }, u.prototype._updateDims = function(o, n3, p2) {
          for (var m2 = o._chunks, w2 = [], T2 = n3.length, E = o.count(), O2 = [], V3 = o._rawExtent, W3 = 0; W3 < n3.length; W3++)
            V3[n3[W3]] = tY();
          for (var q3 = 0; q3 < E; q3++) {
            for (var K = o.getRawIndex(q3), J = 0; J < T2; J++)
              O2[J] = m2[n3[J]][K];
            O2[T2] = q3;
            var rt2 = p2 && p2.apply(null, O2);
            if (rt2 != null) {
              typeof rt2 != "object" && (w2[0] = rt2, rt2 = w2);
              for (var W3 = 0; W3 < rt2.length; W3++) {
                var gt = n3[W3], yt = rt2[W3], At = V3[gt], Lt = m2[gt];
                Lt && (Lt[K] = yt), yt < At[0] && (At[0] = yt), yt > At[1] && (At[1] = yt);
              }
            }
          }
        }, u.prototype.lttbDownSample = function(o, n3) {
          var p2 = this.clone([o], true), m2 = p2._chunks, w2 = m2[o], T2 = this.count(), E = 0, O2 = Math.floor(1 / n3), V3 = this.getRawIndex(0), W3, q3, K, J = new (Eot(this._rawCount))(Math.min((Math.ceil(T2 / O2) + 2) * 2, T2));
          J[E++] = V3;
          for (var rt2 = 1; rt2 < T2 - 1; rt2 += O2) {
            for (var gt = Math.min(rt2 + O2, T2 - 1), yt = Math.min(rt2 + O2 * 2, T2), At = (yt + gt) / 2, Lt = 0, Wt = gt; Wt < yt; Wt++) {
              var Nt = this.getRawIndex(Wt), ue2 = w2[Nt];
              isNaN(ue2) || (Lt += ue2);
            }
            Lt /= yt - gt;
            var ie2 = rt2, pe2 = Math.min(rt2 + O2, T2), xe = rt2 - 1, Ce2 = w2[V3];
            W3 = -1, K = ie2;
            for (var Le2 = -1, ze = 0, Wt = ie2; Wt < pe2; Wt++) {
              var Nt = this.getRawIndex(Wt), ue2 = w2[Nt];
              if (isNaN(ue2)) {
                ze++, Le2 < 0 && (Le2 = Nt);
                continue;
              }
              q3 = Math.abs((xe - At) * (ue2 - Ce2) - (xe - Wt) * (Lt - Ce2)), q3 > W3 && (W3 = q3, K = Nt);
            }
            ze > 0 && ze < pe2 - ie2 && (J[E++] = Math.min(Le2, K), K = Math.max(Le2, K)), J[E++] = K, V3 = K;
          }
          return J[E++] = this.getRawIndex(T2 - 1), p2._count = E, p2._indices = J, p2.getRawIndex = this._getRawIdx, p2;
        }, u.prototype.downSample = function(o, n3, p2, m2) {
          for (var w2 = this.clone([o], true), T2 = w2._chunks, E = [], O2 = Math.floor(1 / n3), V3 = T2[o], W3 = this.count(), q3 = w2._rawExtent[o] = tY(), K = new (Eot(this._rawCount))(Math.ceil(W3 / O2)), J = 0, rt2 = 0; rt2 < W3; rt2 += O2) {
            O2 > W3 - rt2 && (O2 = W3 - rt2, E.length = O2);
            for (var gt = 0; gt < O2; gt++) {
              var yt = this.getRawIndex(rt2 + gt);
              E[gt] = V3[yt];
            }
            var At = p2(E), Lt = this.getRawIndex(Math.min(rt2 + m2(E, At) || 0, W3 - 1));
            V3[Lt] = At, At < q3[0] && (q3[0] = At), At > q3[1] && (q3[1] = At), K[J++] = Lt;
          }
          return w2._count = J, w2._indices = K, w2._updateGetRawIdx(), w2;
        }, u.prototype.each = function(o, n3) {
          if (this._count)
            for (var p2 = o.length, m2 = this._chunks, w2 = 0, T2 = this.count(); w2 < T2; w2++) {
              var E = this.getRawIndex(w2);
              switch (p2) {
                case 0:
                  n3(w2);
                  break;
                case 1:
                  n3(m2[o[0]][E], w2);
                  break;
                case 2:
                  n3(m2[o[0]][E], m2[o[1]][E], w2);
                  break;
                default:
                  for (var O2 = 0, V3 = []; O2 < p2; O2++)
                    V3[O2] = m2[o[O2]][E];
                  V3[O2] = w2, n3.apply(null, V3);
              }
            }
        }, u.prototype.getDataExtent = function(o) {
          var n3 = this._chunks[o], p2 = tY();
          if (!n3)
            return p2;
          var m2 = this.count(), w2 = !this._indices, T2;
          if (w2)
            return this._rawExtent[o].slice();
          if (T2 = this._extent[o], T2)
            return T2.slice();
          T2 = p2;
          for (var E = T2[0], O2 = T2[1], V3 = 0; V3 < m2; V3++) {
            var W3 = this.getRawIndex(V3), q3 = n3[W3];
            q3 < E && (E = q3), q3 > O2 && (O2 = q3);
          }
          return T2 = [E, O2], this._extent[o] = T2, T2;
        }, u.prototype.getRawDataItem = function(o) {
          var n3 = this.getRawIndex(o);
          if (this._provider.persistent)
            return this._provider.getItem(n3);
          for (var p2 = [], m2 = this._chunks, w2 = 0; w2 < m2.length; w2++)
            p2.push(m2[w2][n3]);
          return p2;
        }, u.prototype.clone = function(o, n3) {
          var p2 = new u(), m2 = this._chunks, w2 = o && jA(o, function(E, O2) {
            return E[O2] = true, E;
          }, {});
          if (w2)
            for (var T2 = 0; T2 < m2.length; T2++)
              p2._chunks[T2] = w2[T2] ? _mn(m2[T2]) : m2[T2];
          else
            p2._chunks = m2;
          return this._copyCommonProps(p2), n3 || (p2._indices = this._cloneIndices()), p2._updateGetRawIdx(), p2;
        }, u.prototype._copyCommonProps = function(o) {
          o._count = this._count, o._rawCount = this._rawCount, o._provider = this._provider, o._dimensions = this._dimensions, o._extent = jl(this._extent), o._rawExtent = jl(this._rawExtent);
        }, u.prototype._cloneIndices = function() {
          if (this._indices) {
            var o = this._indices.constructor, n3 = void 0;
            if (o === Array) {
              var p2 = this._indices.length;
              n3 = new o(p2);
              for (var m2 = 0; m2 < p2; m2++)
                n3[m2] = this._indices[m2];
            } else
              n3 = new o(this._indices);
            return n3;
          }
          return null;
        }, u.prototype._getRawIdxIdentity = function(o) {
          return o;
        }, u.prototype._getRawIdx = function(o) {
          return o < this._count && o >= 0 ? this._indices[o] : -1;
        }, u.prototype._updateGetRawIdx = function() {
          this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
        }, u.internalField = function() {
          function o(n3, p2, m2, w2) {
            return o8(n3[w2], this._dimensions[w2]);
          }
          S8t = { arrayRows: o, objectRows: function(n3, p2, m2, w2) {
            return o8(n3[p2], this._dimensions[w2]);
          }, keyedColumns: o, original: function(n3, p2, m2, w2) {
            var T2 = n3 && (n3.value == null ? n3 : n3.value);
            return o8(T2 instanceof Array ? T2[w2] : T2, this._dimensions[w2]);
          }, typedArray: function(n3, p2, m2, w2) {
            return n3[w2];
          } };
        }(), u;
      }(), E0e = function() {
        function u(o) {
          this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = o;
        }
        return u.prototype.dirty = function() {
          this._setLocalSource([], []), this._storeList = [], this._dirty = true;
        }, u.prototype._setLocalSource = function(o, n3) {
          this._sourceList = o, this._upstreamSignList = n3, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
        }, u.prototype._getVersionSign = function() {
          return this._sourceHost.uid + "_" + this._versionSignBase;
        }, u.prototype.prepareSource = function() {
          this._isDirty() && (this._createSource(), this._dirty = false);
        }, u.prototype._createSource = function() {
          this._setLocalSource([], []);
          var o = this._sourceHost, n3 = this._getUpstreamSourceManagers(), p2 = !!n3.length, m2, w2;
          if (W_t(o)) {
            var T2 = o, E = void 0, O2 = void 0, V3 = void 0;
            if (p2) {
              var W3 = n3[0];
              W3.prepareSource(), V3 = W3.getSource(), E = V3.data, O2 = V3.sourceFormat, w2 = [W3._getVersionSign()];
            } else
              E = T2.get("data", true), O2 = HS(E) ? a8 : fI, w2 = [];
            var q3 = this._getSourceMetaRawOption() || {}, K = V3 && V3.metaRawOption || {}, J = Xu(q3.seriesLayoutBy, K.seriesLayoutBy) || null, rt2 = Xu(q3.sourceHeader, K.sourceHeader), gt = Xu(q3.dimensions, K.dimensions), yt = J !== K.seriesLayoutBy || !!rt2 != !!K.sourceHeader || gt;
            m2 = yt ? [y8t(E, { seriesLayoutBy: J, sourceHeader: rt2, dimensions: gt }, O2)] : [];
          } else {
            var At = o;
            if (p2) {
              var Lt = this._applyTransform(n3);
              m2 = Lt.sourceList, w2 = Lt.upstreamSignList;
            } else {
              var Wt = At.get("source", true);
              m2 = [y8t(Wt, this._getSourceMetaRawOption(), null)], w2 = [];
            }
          }
          this._setLocalSource(m2, w2);
        }, u.prototype._applyTransform = function(o) {
          var n3 = this._sourceHost, p2 = n3.get("transform", true), m2 = n3.get("fromTransformResult", true);
          if (m2 != null) {
            var w2 = "";
            o.length !== 1 && P0e(w2);
          }
          var T2, E = [], O2 = [];
          return Xe2(o, function(V3) {
            V3.prepareSource();
            var W3 = V3.getSource(m2 || 0), q3 = "";
            m2 != null && !W3 && P0e(q3), E.push(W3), O2.push(V3._getVersionSign());
          }), p2 ? T2 = vmn(p2, E, { datasetIndex: n3.componentIndex }) : m2 != null && (T2 = [Xyn(E[0])]), { sourceList: T2, upstreamSignList: O2 };
        }, u.prototype._isDirty = function() {
          if (this._dirty)
            return true;
          for (var o = this._getUpstreamSourceManagers(), n3 = 0; n3 < o.length; n3++) {
            var p2 = o[n3];
            if (p2._isDirty() || this._upstreamSignList[n3] !== p2._getVersionSign())
              return true;
          }
        }, u.prototype.getSource = function(o) {
          o = o || 0;
          var n3 = this._sourceList[o];
          if (!n3) {
            var p2 = this._getUpstreamSourceManagers();
            return p2[0] && p2[0].getSource(o);
          }
          return n3;
        }, u.prototype.getSharedDataStore = function(o) {
          var n3 = o.makeStoreSchema();
          return this._innerGetDataStore(n3.dimensions, o.source, n3.hash);
        }, u.prototype._innerGetDataStore = function(o, n3, p2) {
          var m2 = 0, w2 = this._storeList, T2 = w2[m2];
          T2 || (T2 = w2[m2] = {});
          var E = T2[p2];
          if (!E) {
            var O2 = this._getUpstreamSourceManagers()[0];
            W_t(this._sourceHost) && O2 ? E = O2._innerGetDataStore(o, n3, p2) : (E = new M8t(), E.initData(new d0e(n3, o.length), o)), T2[p2] = E;
          }
          return E;
        }, u.prototype._getUpstreamSourceManagers = function() {
          var o = this._sourceHost;
          if (W_t(o)) {
            var n3 = u8t(o);
            return n3 ? [n3.getSourceManager()] : [];
          } else
            return Ya2(Syn(o), function(p2) {
              return p2.getSourceManager();
            });
        }, u.prototype._getSourceMetaRawOption = function() {
          var o = this._sourceHost, n3, p2, m2;
          if (W_t(o))
            n3 = o.get("seriesLayoutBy", true), p2 = o.get("sourceHeader", true), m2 = o.get("dimensions", true);
          else if (!this._getUpstreamSourceManagers().length) {
            var w2 = o;
            n3 = w2.get("seriesLayoutBy", true), p2 = w2.get("sourceHeader", true), m2 = w2.get("dimensions", true);
          }
          return { seriesLayoutBy: n3, sourceHeader: p2, dimensions: m2 };
        }, u;
      }();
      function k0e(u) {
        var o = u.option.transform;
        o && jB(u.option.transform);
      }
      function W_t(u) {
        return u.mainType === "series";
      }
      function P0e(u) {
        throw new Error(u);
      }
      var L0e = "line-height:1";
      function O0e(u, o) {
        var n3 = u.color || "#6e7079", p2 = u.fontSize || 12, m2 = u.fontWeight || "400", w2 = u.color || "#464646", T2 = u.fontSize || 14, E = u.fontWeight || "900";
        return o === "html" ? { nameStyle: "font-size:" + EC(p2 + "") + "px;color:" + EC(n3) + ";font-weight:" + EC(m2 + ""), valueStyle: "font-size:" + EC(T2 + "") + "px;color:" + EC(w2) + ";font-weight:" + EC(E + "") } : { nameStyle: { fontSize: p2, fill: n3, fontWeight: m2 }, valueStyle: { fontSize: T2, fill: w2, fontWeight: E } };
      }
      var xmn = [0, 10, 20, 30], wmn = ["", `
`, `

`, `


`];
      function k1(u, o) {
        return o.type = u, o;
      }
      function C8t(u) {
        return u.type === "section";
      }
      function R0e(u) {
        return C8t(u) ? Smn : Mmn;
      }
      function N0e(u) {
        if (C8t(u)) {
          var o = 0, n3 = u.blocks.length, p2 = n3 > 1 || n3 > 0 && !u.noHeader;
          return Xe2(u.blocks, function(m2) {
            var w2 = N0e(m2);
            w2 >= o && (o = w2 + +(p2 && (!w2 || C8t(m2) && !m2.noHeader)));
          }), o;
        }
        return 0;
      }
      function Smn(u, o, n3, p2) {
        var m2 = o.noHeader, w2 = Cmn(N0e(o)), T2 = [], E = o.blocks || [];
        Tb2(!E || za2(E)), E = E || [];
        var O2 = u.orderMode;
        if (o.sortBlocks && O2) {
          E = E.slice();
          var V3 = { valueAsc: "asc", valueDesc: "desc" };
          if (Fs(V3, O2)) {
            var W3 = new M0e(V3[O2], null);
            E.sort(function(rt2, gt) {
              return W3.evaluate(rt2.sortParam, gt.sortParam);
            });
          } else
            O2 === "seriesDesc" && E.reverse();
        }
        Xe2(E, function(rt2, gt) {
          var yt = o.valueFormatter, At = R0e(rt2)(yt ? ua2(ua2({}, u), { valueFormatter: yt }) : u, rt2, gt > 0 ? w2.html : 0, p2);
          At != null && T2.push(At);
        });
        var q3 = u.renderMode === "richText" ? T2.join(w2.richText) : T8t(T2.join(""), m2 ? n3 : w2.html);
        if (m2)
          return q3;
        var K = a8t(o.header, "ordinal", u.useUTC), J = O0e(p2, u.renderMode).nameStyle;
        return u.renderMode === "richText" ? V0e(u, K, J) + w2.richText + q3 : T8t('<div style="' + J + ";" + L0e + ';">' + EC(K) + "</div>" + q3, n3);
      }
      function Mmn(u, o, n3, p2) {
        var m2 = u.renderMode, w2 = o.noName, T2 = o.noValue, E = !o.markerType, O2 = o.name, V3 = u.useUTC, W3 = o.valueFormatter || u.valueFormatter || function(Nt) {
          return Nt = za2(Nt) ? Nt : [Nt], Ya2(Nt, function(ue2, ie2) {
            return a8t(ue2, za2(J) ? J[ie2] : J, V3);
          });
        };
        if (!(w2 && T2)) {
          var q3 = E ? "" : u.markupStyleCreator.makeTooltipMarker(o.markerType, o.markerColor || "#333", m2), K = w2 ? "" : a8t(O2, "ordinal", V3), J = o.valueType, rt2 = T2 ? [] : W3(o.value), gt = !E || !w2, yt = !E && w2, At = O0e(p2, m2), Lt = At.nameStyle, Wt = At.valueStyle;
          return m2 === "richText" ? (E ? "" : q3) + (w2 ? "" : V0e(u, K, Lt)) + (T2 ? "" : Imn(u, rt2, gt, yt, Wt)) : T8t((E ? "" : q3) + (w2 ? "" : Tmn(K, !E, Lt)) + (T2 ? "" : Amn(rt2, gt, yt, Wt)), n3);
        }
      }
      function F0e(u, o, n3, p2, m2, w2) {
        if (u) {
          var T2 = R0e(u), E = { useUTC: m2, renderMode: n3, orderMode: p2, markupStyleCreator: o, valueFormatter: u.valueFormatter };
          return T2(E, u, 0, w2);
        }
      }
      function Cmn(u) {
        return { html: xmn[u], richText: wmn[u] };
      }
      function T8t(u, o) {
        var n3 = '<div style="clear:both"></div>', p2 = "margin: " + o + "px 0 0";
        return '<div style="' + p2 + ";" + L0e + ';">' + u + n3 + "</div>";
      }
      function Tmn(u, o, n3) {
        var p2 = o ? "margin-left:2px" : "";
        return '<span style="' + n3 + ";" + p2 + '">' + EC(u) + "</span>";
      }
      function Amn(u, o, n3, p2) {
        var m2 = n3 ? "10px" : "20px", w2 = o ? "float:right;margin-left:" + m2 : "";
        return u = za2(u) ? u : [u], '<span style="' + w2 + ";" + p2 + '">' + Ya2(u, function(T2) {
          return EC(T2);
        }).join("&nbsp;&nbsp;") + "</span>";
      }
      function V0e(u, o, n3) {
        return u.markupStyleCreator.wrapRichTextStyle(o, n3);
      }
      function Imn(u, o, n3, p2, m2) {
        var w2 = [m2], T2 = p2 ? 10 : 20;
        return n3 && w2.push({ padding: [0, 0, 0, T2], align: "right" }), u.markupStyleCreator.wrapRichTextStyle(za2(o) ? o.join("  ") : o, w2);
      }
      function B0e(u, o) {
        var n3 = u.getData().getItemVisual(o, "style"), p2 = n3[u.visualDrawType];
        return Iz(p2);
      }
      function z0e(u, o) {
        var n3 = u.get("padding");
        return n3 != null ? n3 : o === "richText" ? [8, 10] : 10;
      }
      var A8t = function() {
        function u() {
          this.richTextStyles = {}, this._nextStyleNameId = h$();
        }
        return u.prototype._generateStyleName = function() {
          return "__EC_aUTo_" + this._nextStyleNameId++;
        }, u.prototype.makeTooltipMarker = function(o, n3, p2) {
          var m2 = p2 === "richText" ? this._generateStyleName() : null, w2 = vyn({ color: n3, type: o, renderMode: p2, markerId: m2 });
          return ds(w2) ? w2 : (this.richTextStyles[m2] = w2.style, w2.content);
        }, u.prototype.wrapRichTextStyle = function(o, n3) {
          var p2 = {};
          za2(n3) ? Xe2(n3, function(w2) {
            return ua2(p2, w2);
          }) : ua2(p2, n3);
          var m2 = this._generateStyleName();
          return this.richTextStyles[m2] = p2, "{" + m2 + "|" + o + "}";
        }, u;
      }();
      function j0e(u) {
        var o = u.series, n3 = u.dataIndex, p2 = u.multipleSeries, m2 = o.getData(), w2 = m2.mapDimensionsAll("defaultedTooltip"), T2 = w2.length, E = o.getRawValue(n3), O2 = za2(E), V3 = B0e(o, n3), W3, q3, K, J;
        if (T2 > 1 || O2 && !T2) {
          var rt2 = Dmn(E, o, n3, w2, V3);
          W3 = rt2.inlineValues, q3 = rt2.inlineValueTypes, K = rt2.blocks, J = rt2.inlineValues[0];
        } else if (T2) {
          var gt = m2.getDimensionInfo(w2[0]);
          J = W3 = J$(m2, n3, w2[0]), q3 = gt.type;
        } else
          J = W3 = O2 ? E[0] : E;
        var yt = D1(o), At = yt && o.name || "", Lt = m2.getName(n3), Wt = p2 ? At : Lt;
        return k1("section", { header: At, noHeader: p2 || !yt, sortParam: J, blocks: [k1("nameValue", { markerType: "item", markerColor: V3, name: Wt, noName: !US(Wt), value: W3, valueType: q3 })].concat(K || []) });
      }
      function Dmn(u, o, n3, p2, m2) {
        var w2 = o.getData(), T2 = jA(u, function(q3, K, J) {
          var rt2 = w2.getDimensionInfo(J);
          return q3 = q3 || rt2 && rt2.tooltip !== false && rt2.displayName != null;
        }, false), E = [], O2 = [], V3 = [];
        p2.length ? Xe2(p2, function(q3) {
          W3(J$(w2, n3, q3), q3);
        }) : Xe2(u, W3);
        function W3(q3, K) {
          var J = w2.getDimensionInfo(K);
          !J || J.otherDims.tooltip === false || (T2 ? V3.push(k1("nameValue", { markerType: "subItem", markerColor: m2, name: J.displayName, value: q3, valueType: J.type })) : (E.push(q3), O2.push(J.type)));
        }
        return { inlineValues: E, inlineValueTypes: O2, blocks: V3 };
      }
      var s8 = Ff2();
      function G_t(u, o) {
        return u.getName(o) || u.getId(o);
      }
      var H_t = "__universalTransitionEnabled", U_t = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3._selectedDataIndicesMap = {}, n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          this.seriesIndex = this.componentIndex, this.dataTask = Dot({ count: kmn, reset: Pmn }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(n3, m2);
          var w2 = s8(this).sourceManager = new E0e(this);
          w2.prepareSource();
          var T2 = this.getInitialData(n3, m2);
          G0e(T2, this), this.dataTask.context.data = T2, s8(this).dataBeforeProcessed = T2, W0e(this), this._initSelectedMapFromData(T2);
        }, o.prototype.mergeDefaultAndTheme = function(n3, p2) {
          var m2 = Sot(this), w2 = m2 ? Y$(n3) : {}, T2 = this.subType;
          kh2.hasClass(T2) && (T2 += "Series"), Cu(n3, p2.getTheme().get(this.subType)), Cu(n3, this.getDefaultOption()), t22(n3, "label", ["show"]), this.fillDataTextStyle(n3.data), m2 && i8(n3, w2, m2);
        }, o.prototype.mergeOption = function(n3, p2) {
          n3 = Cu(this.option, n3, true), this.fillDataTextStyle(n3.data);
          var m2 = Sot(this);
          m2 && i8(this.option, n3, m2);
          var w2 = s8(this).sourceManager;
          w2.dirty(), w2.prepareSource();
          var T2 = this.getInitialData(n3, p2);
          G0e(T2, this), this.dataTask.dirty(), this.dataTask.context.data = T2, s8(this).dataBeforeProcessed = T2, W0e(this), this._initSelectedMapFromData(T2);
        }, o.prototype.fillDataTextStyle = function(n3) {
          if (n3 && !HS(n3))
            for (var p2 = ["show"], m2 = 0; m2 < n3.length; m2++)
              n3[m2] && n3[m2].label && t22(n3[m2], "label", p2);
        }, o.prototype.getInitialData = function(n3, p2) {
        }, o.prototype.appendData = function(n3) {
          var p2 = this.getRawData();
          p2.appendData(n3.data);
        }, o.prototype.getData = function(n3) {
          var p2 = I8t(this);
          if (p2) {
            var m2 = p2.context.data;
            return n3 == null ? m2 : m2.getLinkedData(n3);
          } else
            return s8(this).data;
        }, o.prototype.getAllData = function() {
          var n3 = this.getData();
          return n3 && n3.getLinkedDataAll ? n3.getLinkedDataAll() : [{ data: n3 }];
        }, o.prototype.setData = function(n3) {
          var p2 = I8t(this);
          if (p2) {
            var m2 = p2.context;
            m2.outputData = n3, p2 !== this.dataTask && (m2.data = n3);
          }
          s8(this).data = n3;
        }, o.prototype.getEncode = function() {
          var n3 = this.get("encode", true);
          if (n3)
            return pl(n3);
        }, o.prototype.getSourceManager = function() {
          return s8(this).sourceManager;
        }, o.prototype.getSource = function() {
          return this.getSourceManager().getSource();
        }, o.prototype.getRawData = function() {
          return s8(this).dataBeforeProcessed;
        }, o.prototype.getColorBy = function() {
          var n3 = this.get("colorBy");
          return n3 || "series";
        }, o.prototype.isColorBySeries = function() {
          return this.getColorBy() === "series";
        }, o.prototype.getBaseAxis = function() {
          var n3 = this.coordinateSystem;
          return n3 && n3.getBaseAxis && n3.getBaseAxis();
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          return j0e({ series: this, dataIndex: n3, multipleSeries: p2 });
        }, o.prototype.isAnimationEnabled = function() {
          var n3 = this.ecModel;
          if (Ys.node && !(n3 && n3.ssr))
            return false;
          var p2 = this.getShallow("animation");
          return p2 && this.getData().count() > this.getShallow("animationThreshold") && (p2 = false), !!p2;
        }, o.prototype.restoreData = function() {
          this.dataTask.dirty();
        }, o.prototype.getColorFromPalette = function(n3, p2, m2) {
          var w2 = this.ecModel, T2 = f8t.prototype.getColorFromPalette.call(this, n3, p2, m2);
          return T2 || (T2 = w2.getColorFromPalette(n3, p2, m2)), T2;
        }, o.prototype.coordDimToDataDim = function(n3) {
          return this.getRawData().mapDimensionsAll(n3);
        }, o.prototype.getProgressive = function() {
          return this.get("progressive");
        }, o.prototype.getProgressiveThreshold = function() {
          return this.get("progressiveThreshold");
        }, o.prototype.select = function(n3, p2) {
          this._innerSelect(this.getData(p2), n3);
        }, o.prototype.unselect = function(n3, p2) {
          var m2 = this.option.selectedMap;
          if (m2) {
            var w2 = this.option.selectedMode, T2 = this.getData(p2);
            if (w2 === "series" || m2 === "all") {
              this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
              return;
            }
            for (var E = 0; E < n3.length; E++) {
              var O2 = n3[E], V3 = G_t(T2, O2);
              m2[V3] = false, this._selectedDataIndicesMap[V3] = -1;
            }
          }
        }, o.prototype.toggleSelect = function(n3, p2) {
          for (var m2 = [], w2 = 0; w2 < n3.length; w2++)
            m2[0] = n3[w2], this.isSelected(n3[w2], p2) ? this.unselect(m2, p2) : this.select(m2, p2);
        }, o.prototype.getSelectedDataIndices = function() {
          if (this.option.selectedMap === "all")
            return [].slice.call(this.getData().getIndices());
          for (var n3 = this._selectedDataIndicesMap, p2 = tf2(n3), m2 = [], w2 = 0; w2 < p2.length; w2++) {
            var T2 = n3[p2[w2]];
            T2 >= 0 && m2.push(T2);
          }
          return m2;
        }, o.prototype.isSelected = function(n3, p2) {
          var m2 = this.option.selectedMap;
          if (!m2)
            return false;
          var w2 = this.getData(p2);
          return (m2 === "all" || m2[G_t(w2, n3)]) && !w2.getItemModel(n3).get(["select", "disabled"]);
        }, o.prototype.isUniversalTransitionEnabled = function() {
          if (this[H_t])
            return true;
          var n3 = this.option.universalTransition;
          return n3 ? n3 === true ? true : n3 && n3.enabled : false;
        }, o.prototype._innerSelect = function(n3, p2) {
          var m2, w2, T2 = this.option, E = T2.selectedMode, O2 = p2.length;
          if (!(!E || !O2)) {
            if (E === "series")
              T2.selectedMap = "all";
            else if (E === "multiple") {
              ys(T2.selectedMap) || (T2.selectedMap = {});
              for (var V3 = T2.selectedMap, W3 = 0; W3 < O2; W3++) {
                var q3 = p2[W3], K = G_t(n3, q3);
                V3[K] = true, this._selectedDataIndicesMap[K] = n3.getRawIndex(q3);
              }
            } else if (E === "single" || E === true) {
              var J = p2[O2 - 1], K = G_t(n3, J);
              T2.selectedMap = (m2 = {}, m2[K] = true, m2), this._selectedDataIndicesMap = (w2 = {}, w2[K] = n3.getRawIndex(J), w2);
            }
          }
        }, o.prototype._initSelectedMapFromData = function(n3) {
          if (!this.option.selectedMap) {
            var p2 = [];
            n3.hasItemOption && n3.each(function(m2) {
              var w2 = n3.getRawDataItem(m2);
              w2 && w2.selected && p2.push(m2);
            }), p2.length > 0 && this._innerSelect(n3, p2);
          }
        }, o.registerClass = function(n3) {
          return kh2.registerClass(n3);
        }, o.protoInitialize = function() {
          var n3 = o.prototype;
          n3.type = "series.__base__", n3.seriesIndex = 0, n3.ignoreStyleOnData = false, n3.hasSymbolVisual = false, n3.defaultSymbol = "circle", n3.visualStyleAccessPath = "itemStyle", n3.visualDrawType = "fill";
        }(), o;
      }(kh2);
      x0(U_t, x8t), x0(U_t, f8t), Cat(U_t, kh2);
      function W0e(u) {
        var o = u.name;
        D1(u) || (u.name = Emn(u) || o);
      }
      function Emn(u) {
        var o = u.getRawData(), n3 = o.mapDimensionsAll("seriesName"), p2 = [];
        return Xe2(n3, function(m2) {
          var w2 = o.getDimensionInfo(m2);
          w2.displayName && p2.push(w2.displayName);
        }), p2.join(" ");
      }
      function kmn(u) {
        return u.model.getRawData().count();
      }
      function Pmn(u) {
        var o = u.model;
        return o.setData(o.getRawData().cloneShallow()), Lmn;
      }
      function Lmn(u, o) {
        o.outputData && u.end > o.outputData.count() && o.model.getRawData().cloneShallow(o.outputData);
      }
      function G0e(u, o) {
        Xe2(RZ(u.CHANGABLE_METHODS, u.DOWNSAMPLE_METHODS), function(n3) {
          u.wrapMethod(n3, wu(Omn, o));
        });
      }
      function Omn(u, o) {
        var n3 = I8t(u);
        return n3 && n3.setOutputEnd((o || this).count()), o;
      }
      function I8t(u) {
        var o = (u.ecModel || {}).scheduler, n3 = o && o.getPipeline(u.uid);
        if (n3) {
          var p2 = n3.currentTask;
          if (p2) {
            var m2 = p2.agentStubMap;
            m2 && (p2 = m2.get(u.uid));
          }
          return p2;
        }
      }
      var Rv = U_t, D8t = function() {
        function u() {
          this.group = new uu(), this.uid = U$("viewComponent");
        }
        return u.prototype.init = function(o, n3) {
        }, u.prototype.render = function(o, n3, p2, m2) {
        }, u.prototype.dispose = function(o, n3) {
        }, u.prototype.updateView = function(o, n3, p2, m2) {
        }, u.prototype.updateLayout = function(o, n3, p2, m2) {
        }, u.prototype.updateVisual = function(o, n3, p2, m2) {
        }, u.prototype.blurSeries = function(o, n3) {
        }, u.prototype.eachRendered = function(o) {
          var n3 = this.group;
          n3 && n3.traverse(o);
        }, u;
      }();
      JE(D8t), v$(D8t);
      var C0 = D8t;
      function eY() {
        var u = Ff2();
        return function(o) {
          var n3 = u(o), p2 = o.pipelineContext, m2 = !!n3.large, w2 = !!n3.progressiveRender, T2 = n3.large = !!(p2 && p2.large), E = n3.progressiveRender = !!(p2 && p2.progressiveRender);
          return (m2 !== T2 || w2 !== E) && "reset";
        };
      }
      var H0e = Ff2(), Rmn = eY(), E8t = function() {
        function u() {
          this.group = new uu(), this.uid = U$("viewChart"), this.renderTask = Dot({ plan: Nmn, reset: Fmn }), this.renderTask.context = { view: this };
        }
        return u.prototype.init = function(o, n3) {
        }, u.prototype.render = function(o, n3, p2, m2) {
        }, u.prototype.highlight = function(o, n3, p2, m2) {
          var w2 = o.getData(m2 && m2.dataType);
          !w2 || q0e(w2, m2, "emphasis");
        }, u.prototype.downplay = function(o, n3, p2, m2) {
          var w2 = o.getData(m2 && m2.dataType);
          !w2 || q0e(w2, m2, "normal");
        }, u.prototype.remove = function(o, n3) {
          this.group.removeAll();
        }, u.prototype.dispose = function(o, n3) {
        }, u.prototype.updateView = function(o, n3, p2, m2) {
          this.render(o, n3, p2, m2);
        }, u.prototype.updateLayout = function(o, n3, p2, m2) {
          this.render(o, n3, p2, m2);
        }, u.prototype.updateVisual = function(o, n3, p2, m2) {
          this.render(o, n3, p2, m2);
        }, u.prototype.eachRendered = function(o) {
          n8(this.group, o);
        }, u.markUpdateMethod = function(o, n3) {
          H0e(o).updateMethod = n3;
        }, u.protoInitialize = function() {
          var o = u.prototype;
          o.type = "chart";
        }(), u;
      }();
      function U0e(u, o, n3) {
        u && _4(u) && (o === "emphasis" ? Vm : pc2)(u, n3);
      }
      function q0e(u, o, n3) {
        var p2 = AC(u, o), m2 = o && o.highlightKey != null ? xFt(o.highlightKey) : null;
        p2 != null ? Xe2(Tp(p2), function(w2) {
          U0e(u.getItemGraphicEl(w2), n3, m2);
        }) : u.eachItemGraphicEl(function(w2) {
          U0e(w2, n3, m2);
        });
      }
      JE(E8t), v$(E8t);
      function Nmn(u) {
        return Rmn(u.model);
      }
      function Fmn(u) {
        var o = u.model, n3 = u.ecModel, p2 = u.api, m2 = u.payload, w2 = o.pipelineContext.progressiveRender, T2 = u.view, E = m2 && H0e(m2).updateMethod, O2 = w2 ? "incrementalPrepareRender" : E && T2[E] ? E : "render";
        return O2 !== "render" && T2[O2](o, n3, p2, m2), Vmn[O2];
      }
      var Vmn = { incrementalPrepareRender: { progress: function(u, o) {
        o.view.incrementalRender(u, o.model, o.ecModel, o.api, o.payload);
      } }, render: { forceFirstProgress: true, progress: function(u, o) {
        o.view.render(o.model, o.ecModel, o.api, o.payload);
      } } }, xg2 = E8t, q_t = "\0__throttleOriginMethod", Z0e = "\0__throttleRate", $0e = "\0__throttleType";
      function k8t(u, o, n3) {
        var p2, m2 = 0, w2 = 0, T2 = null, E, O2, V3, W3;
        o = o || 0;
        function q3() {
          w2 = new Date().getTime(), T2 = null, u.apply(O2, V3 || []);
        }
        var K = function() {
          for (var J = [], rt2 = 0; rt2 < arguments.length; rt2++)
            J[rt2] = arguments[rt2];
          p2 = new Date().getTime(), O2 = this, V3 = J;
          var gt = W3 || o, yt = W3 || n3;
          W3 = null, E = p2 - (yt ? m2 : w2) - gt, clearTimeout(T2), yt ? T2 = setTimeout(q3, gt) : E >= 0 ? q3() : T2 = setTimeout(q3, -E), m2 = p2;
        };
        return K.clear = function() {
          T2 && (clearTimeout(T2), T2 = null);
        }, K.debounceNextCall = function(J) {
          W3 = J;
        }, K;
      }
      function nY(u, o, n3, p2) {
        var m2 = u[o];
        if (m2) {
          var w2 = m2[q_t] || m2, T2 = m2[$0e], E = m2[Z0e];
          if (E !== n3 || T2 !== p2) {
            if (n3 == null || !p2)
              return u[o] = w2;
            m2 = u[o] = k8t(w2, n3, p2 === "debounce"), m2[q_t] = w2, m2[$0e] = p2, m2[Z0e] = n3;
          }
          return m2;
        }
      }
      function kot(u, o) {
        var n3 = u[o];
        n3 && n3[q_t] && (n3.clear && n3.clear(), u[o] = n3[q_t]);
      }
      var Y0e = Ff2(), K0e = { itemStyle: l4(mve, true), lineStyle: l4(yve, true) }, Bmn = { lineStyle: "stroke", itemStyle: "fill" };
      function X0e(u, o) {
        var n3 = u.visualStyleMapper || K0e[o];
        return n3 || (console.warn("Unkown style type '" + o + "'."), K0e.itemStyle);
      }
      function Q0e(u, o) {
        var n3 = u.visualDrawType || Bmn[o];
        return n3 || (console.warn("Unkown style type '" + o + "'."), "fill");
      }
      var zmn = { createOnAllSeries: true, performRawSeries: true, reset: function(u, o) {
        var n3 = u.getData(), p2 = u.visualStyleAccessPath || "itemStyle", m2 = u.getModel(p2), w2 = X0e(u, p2), T2 = w2(m2), E = m2.getShallow("decal");
        E && (n3.setVisual("decal", E), E.dirty = true);
        var O2 = Q0e(u, p2), V3 = T2[O2], W3 = Sl(V3) ? V3 : null, q3 = T2.fill === "auto" || T2.stroke === "auto";
        if (!T2[O2] || W3 || q3) {
          var K = u.getColorFromPalette(u.name, null, o.getSeriesCount());
          T2[O2] || (T2[O2] = K, n3.setVisual("colorFromPalette", true)), T2.fill = T2.fill === "auto" || Sl(T2.fill) ? K : T2.fill, T2.stroke = T2.stroke === "auto" || Sl(T2.stroke) ? K : T2.stroke;
        }
        if (n3.setVisual("style", T2), n3.setVisual("drawType", O2), !o.isSeriesFiltered(u) && W3)
          return n3.setVisual("colorFromPalette", false), { dataEach: function(J, rt2) {
            var gt = u.getDataParams(rt2), yt = ua2({}, T2);
            yt[O2] = W3(gt), J.setItemVisual(rt2, "style", yt);
          } };
      } }, Pot = new _g(), jmn = { createOnAllSeries: true, performRawSeries: true, reset: function(u, o) {
        if (!(u.ignoreStyleOnData || o.isSeriesFiltered(u))) {
          var n3 = u.getData(), p2 = u.visualStyleAccessPath || "itemStyle", m2 = X0e(u, p2), w2 = n3.getVisual("drawType");
          return { dataEach: n3.hasItemOption ? function(T2, E) {
            var O2 = T2.getRawDataItem(E);
            if (O2 && O2[p2]) {
              Pot.option = O2[p2];
              var V3 = m2(Pot), W3 = T2.ensureUniqueItemVisual(E, "style");
              ua2(W3, V3), Pot.option.decal && (T2.setItemVisual(E, "decal", Pot.option.decal), Pot.option.decal.dirty = true), w2 in V3 && T2.setItemVisual(E, "colorFromPalette", false);
            }
          } : null };
        }
      } }, Wmn = { performRawSeries: true, overallReset: function(u) {
        var o = pl();
        u.eachSeries(function(n3) {
          var p2 = n3.getColorBy();
          if (!n3.isColorBySeries()) {
            var m2 = n3.type + "-" + p2, w2 = o.get(m2);
            w2 || (w2 = {}, o.set(m2, w2)), Y0e(n3).scope = w2;
          }
        }), u.eachSeries(function(n3) {
          if (!(n3.isColorBySeries() || u.isSeriesFiltered(n3))) {
            var p2 = n3.getRawData(), m2 = {}, w2 = n3.getData(), T2 = Y0e(n3).scope, E = n3.visualStyleAccessPath || "itemStyle", O2 = Q0e(n3, E);
            w2.each(function(V3) {
              var W3 = w2.getRawIndex(V3);
              m2[W3] = V3;
            }), p2.each(function(V3) {
              var W3 = m2[V3], q3 = w2.getItemVisual(W3, "colorFromPalette");
              if (q3) {
                var K = w2.ensureUniqueItemVisual(W3, "style"), J = p2.getName(V3) || V3 + "", rt2 = p2.count();
                K[O2] = n3.getColorFromPalette(J, T2, rt2);
              }
            });
          }
        });
      } }, Z_t = Math.PI;
      function Gmn(u, o) {
        o = o || {}, kl(o, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
        var n3 = new uu(), p2 = new Vf2({ style: { fill: o.maskColor }, zlevel: o.zlevel, z: 1e4 });
        n3.add(p2);
        var m2 = new Zc2({ style: { text: o.text, fill: o.textColor, fontSize: o.fontSize, fontWeight: o.fontWeight, fontStyle: o.fontStyle, fontFamily: o.fontFamily }, zlevel: o.zlevel, z: 10001 }), w2 = new Vf2({ style: { fill: "none" }, textContent: m2, textConfig: { position: "right", distance: 10 }, zlevel: o.zlevel, z: 10001 });
        n3.add(w2);
        var T2;
        return o.showSpinner && (T2 = new dot({ shape: { startAngle: -Z_t / 2, endAngle: -Z_t / 2 + 0.1, r: o.spinnerRadius }, style: { stroke: o.color, lineCap: "round", lineWidth: o.lineWidth }, zlevel: o.zlevel, z: 10001 }), T2.animateShape(true).when(1e3, { endAngle: Z_t * 3 / 2 }).start("circularInOut"), T2.animateShape(true).when(1e3, { startAngle: Z_t * 3 / 2 }).delay(300).start("circularInOut"), n3.add(T2)), n3.resize = function() {
          var E = m2.getBoundingRect().width, O2 = o.showSpinner ? o.spinnerRadius : 0, V3 = (u.getWidth() - O2 * 2 - (o.showSpinner && E ? 10 : 0) - E) / 2 - (o.showSpinner && E ? 0 : 5 + E / 2) + (o.showSpinner ? 0 : E / 2) + (E ? 0 : O2), W3 = u.getHeight() / 2;
          o.showSpinner && T2.setShape({ cx: V3, cy: W3 }), w2.setShape({ x: V3 - O2, y: W3 - O2, width: O2 * 2, height: O2 * 2 }), p2.setShape({ x: 0, y: 0, width: u.getWidth(), height: u.getHeight() });
        }, n3.resize(), n3;
      }
      var Hmn = function() {
        function u(o, n3, p2, m2) {
          this._stageTaskMap = pl(), this.ecInstance = o, this.api = n3, p2 = this._dataProcessorHandlers = p2.slice(), m2 = this._visualHandlers = m2.slice(), this._allHandlers = p2.concat(m2);
        }
        return u.prototype.restoreData = function(o, n3) {
          o.restoreData(n3), this._stageTaskMap.each(function(p2) {
            var m2 = p2.overallTask;
            m2 && m2.dirty();
          });
        }, u.prototype.getPerformArgs = function(o, n3) {
          if (o.__pipeline) {
            var p2 = this._pipelineMap.get(o.__pipeline.id), m2 = p2.context, w2 = !n3 && p2.progressiveEnabled && (!m2 || m2.progressiveRender) && o.__idxInPipeline > p2.blockIndex, T2 = w2 ? p2.step : null, E = m2 && m2.modDataCount, O2 = E != null ? Math.ceil(E / T2) : null;
            return { step: T2, modBy: O2, modDataCount: E };
          }
        }, u.prototype.getPipeline = function(o) {
          return this._pipelineMap.get(o);
        }, u.prototype.updateStreamModes = function(o, n3) {
          var p2 = this._pipelineMap.get(o.uid), m2 = o.getData(), w2 = m2.count(), T2 = p2.progressiveEnabled && n3.incrementalPrepareRender && w2 >= p2.threshold, E = o.get("large") && w2 >= o.get("largeThreshold"), O2 = o.get("progressiveChunkMode") === "mod" ? w2 : null;
          o.pipelineContext = p2.context = { progressiveRender: T2, modDataCount: O2, large: E };
        }, u.prototype.restorePipelines = function(o) {
          var n3 = this, p2 = n3._pipelineMap = pl();
          o.eachSeries(function(m2) {
            var w2 = m2.getProgressive(), T2 = m2.uid;
            p2.set(T2, { id: T2, head: null, tail: null, threshold: m2.getProgressiveThreshold(), progressiveEnabled: w2 && !(m2.preventIncremental && m2.preventIncremental()), blockIndex: -1, step: Math.round(w2 || 700), count: 0 }), n3._pipe(m2, m2.dataTask);
          });
        }, u.prototype.prepareStageTasks = function() {
          var o = this._stageTaskMap, n3 = this.api.getModel(), p2 = this.api;
          Xe2(this._allHandlers, function(m2) {
            var w2 = o.get(m2.uid) || o.set(m2.uid, {}), T2 = "";
            Tb2(!(m2.reset && m2.overallReset), T2), m2.reset && this._createSeriesStageTask(m2, w2, n3, p2), m2.overallReset && this._createOverallStageTask(m2, w2, n3, p2);
          }, this);
        }, u.prototype.prepareView = function(o, n3, p2, m2) {
          var w2 = o.renderTask, T2 = w2.context;
          T2.model = n3, T2.ecModel = p2, T2.api = m2, w2.__block = !o.incrementalPrepareRender, this._pipe(n3, w2);
        }, u.prototype.performDataProcessorTasks = function(o, n3) {
          this._performStageTasks(this._dataProcessorHandlers, o, n3, { block: true });
        }, u.prototype.performVisualTasks = function(o, n3, p2) {
          this._performStageTasks(this._visualHandlers, o, n3, p2);
        }, u.prototype._performStageTasks = function(o, n3, p2, m2) {
          m2 = m2 || {};
          var w2 = false, T2 = this;
          Xe2(o, function(O2, V3) {
            if (!(m2.visualType && m2.visualType !== O2.visualType)) {
              var W3 = T2._stageTaskMap.get(O2.uid), q3 = W3.seriesTaskMap, K = W3.overallTask;
              if (K) {
                var J, rt2 = K.agentStubMap;
                rt2.each(function(yt) {
                  E(m2, yt) && (yt.dirty(), J = true);
                }), J && K.dirty(), T2.updatePayload(K, p2);
                var gt = T2.getPerformArgs(K, m2.block);
                rt2.each(function(yt) {
                  yt.perform(gt);
                }), K.perform(gt) && (w2 = true);
              } else
                q3 && q3.each(function(yt, At) {
                  E(m2, yt) && yt.dirty();
                  var Lt = T2.getPerformArgs(yt, m2.block);
                  Lt.skip = !O2.performRawSeries && n3.isSeriesFiltered(yt.context.model), T2.updatePayload(yt, p2), yt.perform(Lt) && (w2 = true);
                });
            }
          });
          function E(O2, V3) {
            return O2.setDirty && (!O2.dirtyMap || O2.dirtyMap.get(V3.__pipeline.id));
          }
          this.unfinished = w2 || this.unfinished;
        }, u.prototype.performSeriesTasks = function(o) {
          var n3;
          o.eachSeries(function(p2) {
            n3 = p2.dataTask.perform() || n3;
          }), this.unfinished = n3 || this.unfinished;
        }, u.prototype.plan = function() {
          this._pipelineMap.each(function(o) {
            var n3 = o.tail;
            do {
              if (n3.__block) {
                o.blockIndex = n3.__idxInPipeline;
                break;
              }
              n3 = n3.getUpstream();
            } while (n3);
          });
        }, u.prototype.updatePayload = function(o, n3) {
          n3 !== "remain" && (o.context.payload = n3);
        }, u.prototype._createSeriesStageTask = function(o, n3, p2, m2) {
          var w2 = this, T2 = n3.seriesTaskMap, E = n3.seriesTaskMap = pl(), O2 = o.seriesType, V3 = o.getTargetSeries;
          o.createOnAllSeries ? p2.eachRawSeries(W3) : O2 ? p2.eachRawSeriesByType(O2, W3) : V3 && V3(p2, m2).each(W3);
          function W3(q3) {
            var K = q3.uid, J = E.set(K, T2 && T2.get(K) || Dot({ plan: Ymn, reset: Kmn, count: Qmn }));
            J.context = { model: q3, ecModel: p2, api: m2, useClearVisual: o.isVisual && !o.isLayout, plan: o.plan, reset: o.reset, scheduler: w2 }, w2._pipe(q3, J);
          }
        }, u.prototype._createOverallStageTask = function(o, n3, p2, m2) {
          var w2 = this, T2 = n3.overallTask = n3.overallTask || Dot({ reset: Umn });
          T2.context = { ecModel: p2, api: m2, overallReset: o.overallReset, scheduler: w2 };
          var E = T2.agentStubMap, O2 = T2.agentStubMap = pl(), V3 = o.seriesType, W3 = o.getTargetSeries, q3 = true, K = false, J = "";
          Tb2(!o.createOnAllSeries, J), V3 ? p2.eachRawSeriesByType(V3, rt2) : W3 ? W3(p2, m2).each(rt2) : (q3 = false, Xe2(p2.getSeries(), rt2));
          function rt2(gt) {
            var yt = gt.uid, At = O2.set(yt, E && E.get(yt) || (K = true, Dot({ reset: qmn, onDirty: $mn })));
            At.context = { model: gt, overallProgress: q3 }, At.agent = T2, At.__block = q3, w2._pipe(gt, At);
          }
          K && T2.dirty();
        }, u.prototype._pipe = function(o, n3) {
          var p2 = o.uid, m2 = this._pipelineMap.get(p2);
          !m2.head && (m2.head = n3), m2.tail && m2.tail.pipe(n3), m2.tail = n3, n3.__idxInPipeline = m2.count++, n3.__pipeline = m2;
        }, u.wrapStageHandler = function(o, n3) {
          return Sl(o) && (o = { overallReset: o, seriesType: Jmn(o) }), o.uid = U$("stageHandler"), n3 && (o.visualType = n3), o;
        }, u;
      }();
      function Umn(u) {
        u.overallReset(u.ecModel, u.api, u.payload);
      }
      function qmn(u) {
        return u.overallProgress && Zmn;
      }
      function Zmn() {
        this.agent.dirty(), this.getDownstream().dirty();
      }
      function $mn() {
        this.agent && this.agent.dirty();
      }
      function Ymn(u) {
        return u.plan ? u.plan(u.model, u.ecModel, u.api, u.payload) : null;
      }
      function Kmn(u) {
        u.useClearVisual && u.data.clearAllVisual();
        var o = u.resetDefines = Tp(u.reset(u.model, u.ecModel, u.api, u.payload));
        return o.length > 1 ? Ya2(o, function(n3, p2) {
          return J0e(p2);
        }) : Xmn;
      }
      var Xmn = J0e(0);
      function J0e(u) {
        return function(o, n3) {
          var p2 = n3.data, m2 = n3.resetDefines[u];
          if (m2 && m2.dataEach)
            for (var w2 = o.start; w2 < o.end; w2++)
              m2.dataEach(p2, w2);
          else
            m2 && m2.progress && m2.progress(o, p2);
        };
      }
      function Qmn(u) {
        return u.data.count();
      }
      function Jmn(u) {
        $_t = null;
        try {
          u(Lot, tye);
        } catch {
        }
        return $_t;
      }
      var Lot = {}, tye = {}, $_t;
      eye(Lot, Jve), eye(tye, t0e), Lot.eachSeriesByType = Lot.eachRawSeriesByType = function(u) {
        $_t = u;
      }, Lot.eachComponent = function(u) {
        u.mainType === "series" && u.subType && ($_t = u.subType);
      };
      function eye(u, o) {
        for (var n3 in o.prototype)
          u[n3] = Jp;
      }
      var nye = Hmn, rye = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], t1n = { color: rye, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], rye] }, a2 = "#B9B8CE", iye = "#100C2A", Y_t = function() {
        return { axisLine: { lineStyle: { color: a2 } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
      }, aye = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], oye = { darkMode: true, color: aye, backgroundColor: iye, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: a2 } }, textStyle: { color: a2 }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: a2 } }, dataZoom: { borderColor: "#71708A", textStyle: { color: a2 }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: a2 } }, timeline: { lineStyle: { color: a2 }, label: { color: a2 }, controlStyle: { color: a2, borderColor: a2 } }, calendar: { itemStyle: { color: iye }, dayLabel: { color: a2 }, monthLabel: { color: a2 }, yearLabel: { color: a2 } }, timeAxis: Y_t(), logAxis: Y_t(), valueAxis: Y_t(), categoryAxis: Y_t(), line: { symbol: "circle" }, graph: { color: aye }, gauge: { title: { color: a2 }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: a2 }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
      oye.categoryAxis.splitLine.show = false;
      var e1n = oye, n1n = function() {
        function u() {
        }
        return u.prototype.normalizeQuery = function(o) {
          var n3 = {}, p2 = {}, m2 = {};
          if (ds(o)) {
            var w2 = e22(o);
            n3.mainType = w2.main || null, n3.subType = w2.sub || null;
          } else {
            var T2 = ["Index", "Name", "Id"], E = { name: 1, dataIndex: 1, dataType: 1 };
            Xe2(o, function(O2, V3) {
              for (var W3 = false, q3 = 0; q3 < T2.length; q3++) {
                var K = T2[q3], J = V3.lastIndexOf(K);
                if (J > 0 && J === V3.length - K.length) {
                  var rt2 = V3.slice(0, J);
                  rt2 !== "data" && (n3.mainType = rt2, n3[K.toLowerCase()] = O2, W3 = true);
                }
              }
              E.hasOwnProperty(V3) && (p2[V3] = O2, W3 = true), W3 || (m2[V3] = O2);
            });
          }
          return { cptQuery: n3, dataQuery: p2, otherQuery: m2 };
        }, u.prototype.filter = function(o, n3) {
          var p2 = this.eventInfo;
          if (!p2)
            return true;
          var m2 = p2.targetEl, w2 = p2.packedEvent, T2 = p2.model, E = p2.view;
          if (!T2 || !E)
            return true;
          var O2 = n3.cptQuery, V3 = n3.dataQuery;
          return W3(O2, T2, "mainType") && W3(O2, T2, "subType") && W3(O2, T2, "index", "componentIndex") && W3(O2, T2, "name") && W3(O2, T2, "id") && W3(V3, w2, "name") && W3(V3, w2, "dataIndex") && W3(V3, w2, "dataType") && (!E.filterForExposedEvent || E.filterForExposedEvent(o, n3.otherQuery, m2, w2));
          function W3(q3, K, J, rt2) {
            return q3[J] == null || K[rt2 || J] === q3[J];
          }
        }, u.prototype.afterTrigger = function() {
          this.eventInfo = null;
        }, u;
      }(), P8t = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], sye = P8t.concat(["symbolKeepAspect"]), r1n = { createOnAllSeries: true, performRawSeries: true, reset: function(u, o) {
        var n3 = u.getData();
        if (u.legendIcon && n3.setVisual("legendIcon", u.legendIcon), !u.hasSymbolVisual)
          return;
        for (var p2 = {}, m2 = {}, w2 = false, T2 = 0; T2 < P8t.length; T2++) {
          var E = P8t[T2], O2 = u.get(E);
          Sl(O2) ? (w2 = true, m2[E] = O2) : p2[E] = O2;
        }
        if (p2.symbol = p2.symbol || u.defaultSymbol, n3.setVisual(ua2({ legendIcon: u.legendIcon || p2.symbol, symbolKeepAspect: u.get("symbolKeepAspect") }, p2)), o.isSeriesFiltered(u))
          return;
        var V3 = tf2(m2);
        function W3(q3, K) {
          for (var J = u.getRawValue(K), rt2 = u.getDataParams(K), gt = 0; gt < V3.length; gt++) {
            var yt = V3[gt];
            q3.setItemVisual(K, yt, m2[yt](J, rt2));
          }
        }
        return { dataEach: w2 ? W3 : null };
      } }, i1n = { createOnAllSeries: true, performRawSeries: true, reset: function(u, o) {
        if (!u.hasSymbolVisual || o.isSeriesFiltered(u))
          return;
        var n3 = u.getData();
        function p2(m2, w2) {
          for (var T2 = m2.getItemModel(w2), E = 0; E < sye.length; E++) {
            var O2 = sye[E], V3 = T2.getShallow(O2, true);
            V3 != null && m2.setItemVisual(w2, O2, V3);
          }
        }
        return { dataEach: n3.hasItemOption ? p2 : null };
      } };
      function L8t(u, o, n3) {
        switch (n3) {
          case "color":
            var p2 = u.getItemVisual(o, "style");
            return p2[u.getVisual("drawType")];
          case "opacity":
            return u.getItemVisual(o, "style").opacity;
          case "symbol":
          case "symbolSize":
          case "liftZ":
            return u.getItemVisual(o, n3);
        }
      }
      function Oot(u, o) {
        switch (o) {
          case "color":
            var n3 = u.getVisual("style");
            return n3[u.getVisual("drawType")];
          case "opacity":
            return u.getVisual("style").opacity;
          case "symbol":
          case "symbolSize":
          case "liftZ":
            return u.getVisual(o);
        }
      }
      function lye(u, o, n3, p2) {
        switch (n3) {
          case "color":
            var m2 = u.ensureUniqueItemVisual(o, "style");
            m2[u.getVisual("drawType")] = p2, u.setItemVisual(o, "colorFromPalette", false);
            break;
          case "opacity":
            u.ensureUniqueItemVisual(o, "style").opacity = p2;
            break;
          case "symbol":
          case "symbolSize":
          case "liftZ":
            u.setItemVisual(o, n3, p2);
            break;
        }
      }
      function uye(u, o) {
        function n3(p2, m2) {
          var w2 = [];
          return p2.eachComponent({ mainType: "series", subType: u, query: m2 }, function(T2) {
            w2.push(T2.seriesIndex);
          }), w2;
        }
        Xe2([[u + "ToggleSelect", "toggleSelect"], [u + "Select", "select"], [u + "UnSelect", "unselect"]], function(p2) {
          o(p2[0], function(m2, w2, T2) {
            m2 = ua2({}, m2), T2.dispatchAction(ua2(m2, { type: p2[1], seriesIndex: n3(w2, m2) }));
          });
        });
      }
      function rY(u, o, n3, p2, m2) {
        var w2 = u + o;
        n3.isSilent(w2) || p2.eachComponent({ mainType: "series", subType: "pie" }, function(T2) {
          for (var E = T2.seriesIndex, O2 = T2.option.selectedMap, V3 = m2.selected, W3 = 0; W3 < V3.length; W3++)
            if (V3[W3].seriesIndex === E) {
              var q3 = T2.getData(), K = AC(q3, m2.fromActionPayload);
              n3.trigger(w2, { type: w2, seriesId: T2.id, name: za2(K) ? q3.getName(K[0]) : q3.getName(K), selected: ds(O2) ? O2 : ua2({}, O2) });
            }
        });
      }
      function a1n(u, o, n3) {
        u.on("selectchanged", function(p2) {
          var m2 = n3.getModel();
          p2.isFromClick ? (rY("map", "selectchanged", o, m2, p2), rY("pie", "selectchanged", o, m2, p2)) : p2.fromAction === "select" ? (rY("map", "selected", o, m2, p2), rY("pie", "selected", o, m2, p2)) : p2.fromAction === "unselect" && (rY("map", "unselected", o, m2, p2), rY("pie", "unselected", o, m2, p2));
        });
      }
      function iY(u, o, n3) {
        for (var p2; u && !(o(u) && (p2 = u, n3)); )
          u = u.__hostTarget || u.parent;
        return p2;
      }
      var o1n = Math.round(Math.random() * 9), s1n = typeof Object.defineProperty == "function", l1n = function() {
        function u() {
          this._id = "__ec_inner_" + o1n++;
        }
        return u.prototype.get = function(o) {
          return this._guard(o)[this._id];
        }, u.prototype.set = function(o, n3) {
          var p2 = this._guard(o);
          return s1n ? Object.defineProperty(p2, this._id, { value: n3, enumerable: false, configurable: true }) : p2[this._id] = n3, this;
        }, u.prototype.delete = function(o) {
          return this.has(o) ? (delete this._guard(o)[this._id], true) : false;
        }, u.prototype.has = function(o) {
          return !!this._guard(o)[this._id];
        }, u.prototype._guard = function(o) {
          if (o !== Object(o))
            throw TypeError("Value of WeakMap is not a non-null object.");
          return o;
        }, u;
      }(), u1n = l1n, c1n = Mc2.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(u, o) {
        var n3 = o.cx, p2 = o.cy, m2 = o.width / 2, w2 = o.height / 2;
        u.moveTo(n3, p2 - w2), u.lineTo(n3 + m2, p2 + w2), u.lineTo(n3 - m2, p2 + w2), u.closePath();
      } }), f1n = Mc2.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(u, o) {
        var n3 = o.cx, p2 = o.cy, m2 = o.width / 2, w2 = o.height / 2;
        u.moveTo(n3, p2 - w2), u.lineTo(n3 + m2, p2), u.lineTo(n3, p2 + w2), u.lineTo(n3 - m2, p2), u.closePath();
      } }), h1n = Mc2.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(u, o) {
        var n3 = o.x, p2 = o.y, m2 = o.width / 5 * 3, w2 = Math.max(m2, o.height), T2 = m2 / 2, E = T2 * T2 / (w2 - T2), O2 = p2 - w2 + T2 + E, V3 = Math.asin(E / T2), W3 = Math.cos(V3) * T2, q3 = Math.sin(V3), K = Math.cos(V3), J = T2 * 0.6, rt2 = T2 * 0.7;
        u.moveTo(n3 - W3, O2 + E), u.arc(n3, O2, T2, Math.PI - V3, Math.PI * 2 + V3), u.bezierCurveTo(n3 + W3 - q3 * J, O2 + E + K * J, n3, p2 - rt2, n3, p2), u.bezierCurveTo(n3, p2 - rt2, n3 - W3 + q3 * J, O2 + E + K * J, n3 - W3, O2 + E), u.closePath();
      } }), p1n = Mc2.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(u, o) {
        var n3 = o.height, p2 = o.width, m2 = o.x, w2 = o.y, T2 = p2 / 3 * 2;
        u.moveTo(m2, w2), u.lineTo(m2 + T2, w2 + n3), u.lineTo(m2, w2 + n3 / 4 * 3), u.lineTo(m2 - T2, w2 + n3), u.lineTo(m2, w2), u.closePath();
      } }), d1n = { line: My, rect: Vf2, roundRect: Vf2, square: Vf2, circle: sI, diamond: f1n, pin: h1n, arrow: p1n, triangle: c1n }, g1n = { line: function(u, o, n3, p2, m2) {
        m2.x1 = u, m2.y1 = o + p2 / 2, m2.x2 = u + n3, m2.y2 = o + p2 / 2;
      }, rect: function(u, o, n3, p2, m2) {
        m2.x = u, m2.y = o, m2.width = n3, m2.height = p2;
      }, roundRect: function(u, o, n3, p2, m2) {
        m2.x = u, m2.y = o, m2.width = n3, m2.height = p2, m2.r = Math.min(n3, p2) / 4;
      }, square: function(u, o, n3, p2, m2) {
        var w2 = Math.min(n3, p2);
        m2.x = u, m2.y = o, m2.width = w2, m2.height = w2;
      }, circle: function(u, o, n3, p2, m2) {
        m2.cx = u + n3 / 2, m2.cy = o + p2 / 2, m2.r = Math.min(n3, p2) / 2;
      }, diamond: function(u, o, n3, p2, m2) {
        m2.cx = u + n3 / 2, m2.cy = o + p2 / 2, m2.width = n3, m2.height = p2;
      }, pin: function(u, o, n3, p2, m2) {
        m2.x = u + n3 / 2, m2.y = o + p2 / 2, m2.width = n3, m2.height = p2;
      }, arrow: function(u, o, n3, p2, m2) {
        m2.x = u + n3 / 2, m2.y = o + p2 / 2, m2.width = n3, m2.height = p2;
      }, triangle: function(u, o, n3, p2, m2) {
        m2.cx = u + n3 / 2, m2.cy = o + p2 / 2, m2.width = n3, m2.height = p2;
      } }, K_t = {};
      Xe2(d1n, function(u, o) {
        K_t[o] = new u();
      });
      var v1n = Mc2.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(u, o, n3) {
        var p2 = r$(u, o, n3), m2 = this.shape;
        return m2 && m2.symbolType === "pin" && o.position === "inside" && (p2.y = n3.y + n3.height * 0.4), p2;
      }, buildPath: function(u, o, n3) {
        var p2 = o.symbolType;
        if (p2 !== "none") {
          var m2 = K_t[p2];
          m2 || (p2 = "rect", m2 = K_t[p2]), g1n[p2](o.x, o.y, o.width, o.height, m2.shape), m2.buildPath(u, m2.shape, n3);
        }
      } });
      function y1n(u, o) {
        if (this.type !== "image") {
          var n3 = this.style;
          this.__isEmptyBrush ? (n3.stroke = u, n3.fill = o || "#fff", n3.lineWidth = 2) : this.shape.symbolType === "line" ? n3.stroke = u : n3.fill = u, this.markRedraw();
        }
      }
      function Jy(u, o, n3, p2, m2, w2, T2) {
        var E = u.indexOf("empty") === 0;
        E && (u = u.substr(5, 1).toLowerCase() + u.substr(6));
        var O2;
        return u.indexOf("image://") === 0 ? O2 = Yr(u.slice(8), new Qu(o, n3, p2, m2), T2 ? "center" : "cover") : u.indexOf("path://") === 0 ? O2 = Vr(u.slice(7), {}, new Qu(o, n3, p2, m2), T2 ? "center" : "cover") : O2 = new v1n({ shape: { symbolType: u, x: o, y: n3, width: p2, height: m2 } }), O2.__isEmptyBrush = E, O2.setColor = y1n, w2 && O2.setColor(w2), O2;
      }
      function Rot(u) {
        return za2(u) || (u = [+u, +u]), [u[0] || 0, u[1] || 0];
      }
      function aY(u, o) {
        if (u != null)
          return za2(u) || (u = [u, u]), [Qo(u[0], o[0]) || 0, Qo(Xu(u[1], u[0]), o[1]) || 0];
      }
      function m1n(u, o, n3) {
        var p2 = o.x == null ? 0 : o.x, m2 = o.x2 == null ? 1 : o.x2, w2 = o.y == null ? 0 : o.y, T2 = o.y2 == null ? 0 : o.y2;
        o.global || (p2 = p2 * n3.width + n3.x, m2 = m2 * n3.width + n3.x, w2 = w2 * n3.height + n3.y, T2 = T2 * n3.height + n3.y), p2 = isNaN(p2) ? 0 : p2, m2 = isNaN(m2) ? 1 : m2, w2 = isNaN(w2) ? 0 : w2, T2 = isNaN(T2) ? 0 : T2;
        var E = u.createLinearGradient(p2, w2, m2, T2);
        return E;
      }
      function b1n(u, o, n3) {
        var p2 = n3.width, m2 = n3.height, w2 = Math.min(p2, m2), T2 = o.x == null ? 0.5 : o.x, E = o.y == null ? 0.5 : o.y, O2 = o.r == null ? 0.5 : o.r;
        o.global || (T2 = T2 * p2 + n3.x, E = E * m2 + n3.y, O2 = O2 * w2);
        var V3 = u.createRadialGradient(T2, E, 0, T2, E, O2);
        return V3;
      }
      function O8t(u, o, n3) {
        for (var p2 = o.type === "radial" ? b1n(u, o, n3) : m1n(u, o, n3), m2 = o.colorStops, w2 = 0; w2 < m2.length; w2++)
          p2.addColorStop(m2[w2].offset, m2[w2].color);
        return p2;
      }
      function _1n(u, o) {
        if (u === o || !u && !o)
          return false;
        if (!u || !o || u.length !== o.length)
          return true;
        for (var n3 = 0; n3 < u.length; n3++)
          if (u[n3] !== o[n3])
            return true;
        return false;
      }
      function X_t(u) {
        return parseInt(u, 10);
      }
      function oY(u, o, n3) {
        var p2 = ["width", "height"][o], m2 = ["clientWidth", "clientHeight"][o], w2 = ["paddingLeft", "paddingTop"][o], T2 = ["paddingRight", "paddingBottom"][o];
        if (n3[p2] != null && n3[p2] !== "auto")
          return parseFloat(n3[p2]);
        var E = document.defaultView.getComputedStyle(u);
        return (u[m2] || X_t(E[p2]) || X_t(u.style[p2])) - (X_t(E[w2]) || 0) - (X_t(E[T2]) || 0) | 0;
      }
      function x1n(u, o) {
        return !u || u === "solid" || !(o > 0) ? null : u === "dashed" ? [4 * o, 2 * o] : u === "dotted" ? [o] : Dh2(u) ? [u] : za2(u) ? u : null;
      }
      function R8t(u) {
        var o = u.style, n3 = o.lineDash && o.lineWidth > 0 && x1n(o.lineDash, o.lineWidth), p2 = o.lineDashOffset;
        if (n3) {
          var m2 = o.strokeNoScale && u.getLineScale ? u.getLineScale() : 1;
          m2 && m2 !== 1 && (n3 = Ya2(n3, function(w2) {
            return w2 / m2;
          }), p2 /= m2);
        }
        return [n3, p2];
      }
      var w1n = new iI(true);
      function Q_t(u) {
        var o = u.stroke;
        return !(o == null || o === "none" || !(u.lineWidth > 0));
      }
      function cye(u) {
        return typeof u == "string" && u !== "none";
      }
      function J_t(u) {
        var o = u.fill;
        return o != null && o !== "none";
      }
      function fye(u, o) {
        if (o.fillOpacity != null && o.fillOpacity !== 1) {
          var n3 = u.globalAlpha;
          u.globalAlpha = o.fillOpacity * o.opacity, u.fill(), u.globalAlpha = n3;
        } else
          u.fill();
      }
      function hye(u, o) {
        if (o.strokeOpacity != null && o.strokeOpacity !== 1) {
          var n3 = u.globalAlpha;
          u.globalAlpha = o.strokeOpacity * o.opacity, u.stroke(), u.globalAlpha = n3;
        } else
          u.stroke();
      }
      function N8t(u, o, n3) {
        var p2 = y$(o.image, o.__image, n3);
        if (fz(p2)) {
          var m2 = u.createPattern(p2, o.repeat || "repeat");
          if (typeof DOMMatrix == "function" && m2 && m2.setTransform) {
            var w2 = new DOMMatrix();
            w2.translateSelf(o.x || 0, o.y || 0), w2.rotateSelf(0, 0, (o.rotation || 0) * NZ), w2.scaleSelf(o.scaleX || 1, o.scaleY || 1), m2.setTransform(w2);
          }
          return m2;
        }
      }
      function S1n(u, o, n3, p2) {
        var m2, w2 = Q_t(n3), T2 = J_t(n3), E = n3.strokePercent, O2 = E < 1, V3 = !o.path;
        (!o.silent || O2) && V3 && o.createPathProxy();
        var W3 = o.path || w1n, q3 = o.__dirty;
        if (!p2) {
          var K = n3.fill, J = n3.stroke, rt2 = T2 && !!K.colorStops, gt = w2 && !!J.colorStops, yt = T2 && !!K.image, At = w2 && !!J.image, Lt = void 0, Wt = void 0, Nt = void 0, ue2 = void 0, ie2 = void 0;
          (rt2 || gt) && (ie2 = o.getBoundingRect()), rt2 && (Lt = q3 ? O8t(u, K, ie2) : o.__canvasFillGradient, o.__canvasFillGradient = Lt), gt && (Wt = q3 ? O8t(u, J, ie2) : o.__canvasStrokeGradient, o.__canvasStrokeGradient = Wt), yt && (Nt = q3 || !o.__canvasFillPattern ? N8t(u, K, o) : o.__canvasFillPattern, o.__canvasFillPattern = Nt), At && (ue2 = q3 || !o.__canvasStrokePattern ? N8t(u, J, o) : o.__canvasStrokePattern, o.__canvasStrokePattern = Nt), rt2 ? u.fillStyle = Lt : yt && (Nt ? u.fillStyle = Nt : T2 = false), gt ? u.strokeStyle = Wt : At && (ue2 ? u.strokeStyle = ue2 : w2 = false);
        }
        var pe2 = o.getGlobalScale();
        W3.setScale(pe2[0], pe2[1], o.segmentIgnoreThreshold);
        var xe, Ce2;
        u.setLineDash && n3.lineDash && (m2 = R8t(o), xe = m2[0], Ce2 = m2[1]);
        var Le2 = true;
        (V3 || q3 & TF) && (W3.setDPR(u.dpr), O2 ? W3.setContext(null) : (W3.setContext(u), Le2 = false), W3.reset(), o.buildPath(W3, o.shape, p2), W3.toStatic(), o.pathUpdated()), Le2 && W3.rebuildPath(u, O2 ? E : 1), xe && (u.setLineDash(xe), u.lineDashOffset = Ce2), p2 || (n3.strokeFirst ? (w2 && hye(u, n3), T2 && fye(u, n3)) : (T2 && fye(u, n3), w2 && hye(u, n3))), xe && u.setLineDash([]);
      }
      function M1n(u, o, n3) {
        var p2 = o.__image = y$(n3.image, o.__image, o, o.onload);
        if (!(!p2 || !fz(p2))) {
          var m2 = n3.x || 0, w2 = n3.y || 0, T2 = o.getWidth(), E = o.getHeight(), O2 = p2.width / p2.height;
          if (T2 == null && E != null ? T2 = E * O2 : E == null && T2 != null ? E = T2 / O2 : T2 == null && E == null && (T2 = p2.width, E = p2.height), n3.sWidth && n3.sHeight) {
            var V3 = n3.sx || 0, W3 = n3.sy || 0;
            u.drawImage(p2, V3, W3, n3.sWidth, n3.sHeight, m2, w2, T2, E);
          } else if (n3.sx && n3.sy) {
            var V3 = n3.sx, W3 = n3.sy, q3 = T2 - V3, K = E - W3;
            u.drawImage(p2, V3, W3, q3, K, m2, w2, T2, E);
          } else
            u.drawImage(p2, m2, w2, T2, E);
        }
      }
      function C1n(u, o, n3) {
        var p2, m2 = n3.text;
        if (m2 != null && (m2 += ""), m2) {
          u.font = n3.font || Fu, u.textAlign = n3.textAlign, u.textBaseline = n3.textBaseline;
          var w2 = void 0, T2 = void 0;
          u.setLineDash && n3.lineDash && (p2 = R8t(o), w2 = p2[0], T2 = p2[1]), w2 && (u.setLineDash(w2), u.lineDashOffset = T2), n3.strokeFirst ? (Q_t(n3) && u.strokeText(m2, n3.x, n3.y), J_t(n3) && u.fillText(m2, n3.x, n3.y)) : (J_t(n3) && u.fillText(m2, n3.x, n3.y), Q_t(n3) && u.strokeText(m2, n3.x, n3.y)), w2 && u.setLineDash([]);
        }
      }
      var pye = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], dye = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
      function gye(u, o, n3, p2, m2) {
        var w2 = false;
        if (!p2 && (n3 = n3 || {}, o === n3))
          return false;
        if (p2 || o.opacity !== n3.opacity) {
          cM(u, m2), w2 = true;
          var T2 = Math.max(Math.min(o.opacity, 1), 0);
          u.globalAlpha = isNaN(T2) ? u4.opacity : T2;
        }
        (p2 || o.blend !== n3.blend) && (w2 || (cM(u, m2), w2 = true), u.globalCompositeOperation = o.blend || u4.blend);
        for (var E = 0; E < pye.length; E++) {
          var O2 = pye[E];
          (p2 || o[O2] !== n3[O2]) && (w2 || (cM(u, m2), w2 = true), u[O2] = u.dpr * (o[O2] || 0));
        }
        return (p2 || o.shadowColor !== n3.shadowColor) && (w2 || (cM(u, m2), w2 = true), u.shadowColor = o.shadowColor || u4.shadowColor), w2;
      }
      function vye(u, o, n3, p2, m2) {
        var w2 = Not(o, m2.inHover), T2 = p2 ? null : n3 && Not(n3, m2.inHover) || {};
        if (w2 === T2)
          return false;
        var E = gye(u, w2, T2, p2, m2);
        if ((p2 || w2.fill !== T2.fill) && (E || (cM(u, m2), E = true), cye(w2.fill) && (u.fillStyle = w2.fill)), (p2 || w2.stroke !== T2.stroke) && (E || (cM(u, m2), E = true), cye(w2.stroke) && (u.strokeStyle = w2.stroke)), (p2 || w2.opacity !== T2.opacity) && (E || (cM(u, m2), E = true), u.globalAlpha = w2.opacity == null ? 1 : w2.opacity), o.hasStroke()) {
          var O2 = w2.lineWidth, V3 = O2 / (w2.strokeNoScale && o.getLineScale ? o.getLineScale() : 1);
          u.lineWidth !== V3 && (E || (cM(u, m2), E = true), u.lineWidth = V3);
        }
        for (var W3 = 0; W3 < dye.length; W3++) {
          var q3 = dye[W3], K = q3[0];
          (p2 || w2[K] !== T2[K]) && (E || (cM(u, m2), E = true), u[K] = w2[K] || q3[1]);
        }
        return E;
      }
      function T1n(u, o, n3, p2, m2) {
        return gye(u, Not(o, m2.inHover), n3 && Not(n3, m2.inHover), p2, m2);
      }
      function yye(u, o) {
        var n3 = o.transform, p2 = u.dpr || 1;
        n3 ? u.setTransform(p2 * n3[0], p2 * n3[1], p2 * n3[2], p2 * n3[3], p2 * n3[4], p2 * n3[5]) : u.setTransform(p2, 0, 0, p2, 0, 0);
      }
      function A1n(u, o, n3) {
        for (var p2 = false, m2 = 0; m2 < u.length; m2++) {
          var w2 = u[m2];
          p2 = p2 || w2.isZeroArea(), yye(o, w2), o.beginPath(), w2.buildPath(o, w2.shape), o.clip();
        }
        n3.allClipped = p2;
      }
      function I1n(u, o) {
        return u && o ? u[0] !== o[0] || u[1] !== o[1] || u[2] !== o[2] || u[3] !== o[3] || u[4] !== o[4] || u[5] !== o[5] : !(!u && !o);
      }
      var mye = 1, bye = 2, _ye = 3, xye = 4;
      function D1n(u) {
        var o = J_t(u), n3 = Q_t(u);
        return !(u.lineDash || !(+o ^ +n3) || o && typeof u.fill != "string" || n3 && typeof u.stroke != "string" || u.strokePercent < 1 || u.strokeOpacity < 1 || u.fillOpacity < 1);
      }
      function cM(u, o) {
        o.batchFill && u.fill(), o.batchStroke && u.stroke(), o.batchFill = "", o.batchStroke = "";
      }
      function Not(u, o) {
        return o && u.__hoverStyle || u.style;
      }
      function wye(u, o) {
        Oz(u, o, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
      }
      function Oz(u, o, n3, p2) {
        var m2 = o.transform;
        if (!o.shouldBePainted(n3.viewWidth, n3.viewHeight, false, false)) {
          o.__dirty &= ~Ab2, o.__isRendered = false;
          return;
        }
        var w2 = o.__clipPaths, T2 = n3.prevElClipPaths, E = false, O2 = false;
        if ((!T2 || _1n(w2, T2)) && (T2 && T2.length && (cM(u, n3), u.restore(), O2 = E = true, n3.prevElClipPaths = null, n3.allClipped = false, n3.prevEl = null), w2 && w2.length && (cM(u, n3), u.save(), A1n(w2, u, n3), E = true), n3.prevElClipPaths = w2), n3.allClipped) {
          o.__isRendered = false;
          return;
        }
        o.beforeBrush && o.beforeBrush(), o.innerBeforeBrush();
        var V3 = n3.prevEl;
        V3 || (O2 = E = true);
        var W3 = o instanceof Mc2 && o.autoBatch && D1n(o.style);
        E || I1n(m2, V3.transform) ? (cM(u, n3), yye(u, o)) : W3 || cM(u, n3);
        var q3 = Not(o, n3.inHover);
        o instanceof Mc2 ? (n3.lastDrawType !== mye && (O2 = true, n3.lastDrawType = mye), vye(u, o, V3, O2, n3), (!W3 || !n3.batchFill && !n3.batchStroke) && u.beginPath(), S1n(u, o, q3, W3), W3 && (n3.batchFill = q3.fill || "", n3.batchStroke = q3.stroke || "")) : o instanceof gz ? (n3.lastDrawType !== _ye && (O2 = true, n3.lastDrawType = _ye), vye(u, o, V3, O2, n3), C1n(u, o, q3)) : o instanceof Fm ? (n3.lastDrawType !== bye && (O2 = true, n3.lastDrawType = bye), T1n(u, o, V3, O2, n3), M1n(u, o, q3)) : o.getTemporalDisplayables && (n3.lastDrawType !== xye && (O2 = true, n3.lastDrawType = xye), E1n(u, o, n3)), W3 && p2 && cM(u, n3), o.innerAfterBrush(), o.afterBrush && o.afterBrush(), n3.prevEl = o, o.__dirty = 0, o.__isRendered = true;
      }
      function E1n(u, o, n3) {
        var p2 = o.getDisplayables(), m2 = o.getTemporalDisplayables();
        u.save();
        var w2 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: n3.viewWidth, viewHeight: n3.viewHeight, inHover: n3.inHover }, T2, E;
        for (T2 = o.getCursor(), E = p2.length; T2 < E; T2++) {
          var O2 = p2[T2];
          O2.beforeBrush && O2.beforeBrush(), O2.innerBeforeBrush(), Oz(u, O2, w2, T2 === E - 1), O2.innerAfterBrush(), O2.afterBrush && O2.afterBrush(), w2.prevEl = O2;
        }
        for (var V3 = 0, W3 = m2.length; V3 < W3; V3++) {
          var O2 = m2[V3];
          O2.beforeBrush && O2.beforeBrush(), O2.innerBeforeBrush(), Oz(u, O2, w2, V3 === W3 - 1), O2.innerAfterBrush(), O2.afterBrush && O2.afterBrush(), w2.prevEl = O2;
        }
        o.clearTemporalDisplayables(), o.notClear = true, u.restore();
      }
      var F8t = new u1n(), Sye = new QB(100), Mye = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
      function Fot(u, o) {
        if (u === "none")
          return null;
        var n3 = o.getDevicePixelRatio(), p2 = o.getZr(), m2 = p2.painter.type === "svg";
        u.dirty && F8t.delete(u);
        var w2 = F8t.get(u);
        if (w2)
          return w2;
        var T2 = kl(u, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
        T2.backgroundColor === "none" && (T2.backgroundColor = null);
        var E = { repeat: "repeat" };
        return O2(E), E.rotation = T2.rotation, E.scaleX = E.scaleY = m2 ? 1 : 1 / n3, F8t.set(u, E), u.dirty = false, E;
        function O2(V3) {
          for (var W3 = [n3], q3 = true, K = 0; K < Mye.length; ++K) {
            var J = T2[Mye[K]];
            if (J != null && !za2(J) && !ds(J) && !Dh2(J) && typeof J != "boolean") {
              q3 = false;
              break;
            }
            W3.push(J);
          }
          var rt2;
          if (q3) {
            rt2 = W3.join(",") + (m2 ? "-svg" : "");
            var gt = Sye.get(rt2);
            gt && (m2 ? V3.svgElement = gt : V3.image = gt);
          }
          var yt = Tye(T2.dashArrayX), At = k1n(T2.dashArrayY), Lt = Cye(T2.symbol), Wt = P1n(yt), Nt = Aye(At), ue2 = !m2 && pw.createCanvas(), ie2 = m2 && { tag: "g", attrs: {}, key: "dcl", children: [] }, pe2 = Ce2(), xe;
          ue2 && (ue2.width = pe2.width * n3, ue2.height = pe2.height * n3, xe = ue2.getContext("2d")), Le2(), q3 && Sye.put(rt2, ue2 || ie2), V3.image = ue2, V3.svgElement = ie2, V3.svgWidth = pe2.width, V3.svgHeight = pe2.height;
          function Ce2() {
            for (var ze = 1, tn = 0, $e2 = Wt.length; tn < $e2; ++tn)
              ze = d$(ze, Wt[tn]);
            for (var Tn = 1, tn = 0, $e2 = Lt.length; tn < $e2; ++tn)
              Tn = d$(Tn, Lt[tn].length);
            ze *= Tn;
            var zn = Nt * Wt.length * Lt.length;
            return { width: Math.max(1, Math.min(ze, T2.maxTileWidth)), height: Math.max(1, Math.min(zn, T2.maxTileHeight)) };
          }
          function Le2() {
            xe && (xe.clearRect(0, 0, ue2.width, ue2.height), T2.backgroundColor && (xe.fillStyle = T2.backgroundColor, xe.fillRect(0, 0, ue2.width, ue2.height)));
            for (var ze = 0, tn = 0; tn < At.length; ++tn)
              ze += At[tn];
            if (ze <= 0)
              return;
            for (var $e2 = -Nt, Tn = 0, zn = 0, bn = 0; $e2 < pe2.height; ) {
              if (Tn % 2 === 0) {
                for (var Xr = zn / 2 % Lt.length, Xn = 0, or = 0, Tr = 0; Xn < pe2.width * 2; ) {
                  for (var ci2 = 0, tn = 0; tn < yt[bn].length; ++tn)
                    ci2 += yt[bn][tn];
                  if (ci2 <= 0)
                    break;
                  if (or % 2 === 0) {
                    var yi2 = (1 - T2.symbolSize) * 0.5, Po = Xn + yt[bn][or] * yi2, Ms = $e2 + At[Tn] * yi2, dl = yt[bn][or] * T2.symbolSize, tl = At[Tn] * T2.symbolSize, el = Tr / 2 % Lt[Xr].length;
                    as(Po, Ms, dl, tl, Lt[Xr][el]);
                  }
                  Xn += yt[bn][or], ++Tr, ++or, or === yt[bn].length && (or = 0);
                }
                ++bn, bn === yt.length && (bn = 0);
              }
              $e2 += At[Tn], ++zn, ++Tn, Tn === At.length && (Tn = 0);
            }
            function as(Hs, ol, xs, Bl, Ph2) {
              var fu = m2 ? 1 : n3, uh2 = Jy(Ph2, Hs * fu, ol * fu, xs * fu, Bl * fu, T2.color, T2.symbolKeepAspect);
              if (m2) {
                var Zh2 = p2.painter.renderOneToVNode(uh2);
                Zh2 && ie2.children.push(Zh2);
              } else
                wye(xe, uh2);
            }
          }
        }
      }
      function Cye(u) {
        if (!u || u.length === 0)
          return [["rect"]];
        if (ds(u))
          return [[u]];
        for (var o = true, n3 = 0; n3 < u.length; ++n3)
          if (!ds(u[n3])) {
            o = false;
            break;
          }
        if (o)
          return Cye([u]);
        for (var p2 = [], n3 = 0; n3 < u.length; ++n3)
          ds(u[n3]) ? p2.push([u[n3]]) : p2.push(u[n3]);
        return p2;
      }
      function Tye(u) {
        if (!u || u.length === 0)
          return [[0, 0]];
        if (Dh2(u)) {
          var o = Math.ceil(u);
          return [[o, o]];
        }
        for (var n3 = true, p2 = 0; p2 < u.length; ++p2)
          if (!Dh2(u[p2])) {
            n3 = false;
            break;
          }
        if (n3)
          return Tye([u]);
        for (var m2 = [], p2 = 0; p2 < u.length; ++p2)
          if (Dh2(u[p2])) {
            var o = Math.ceil(u[p2]);
            m2.push([o, o]);
          } else {
            var o = Ya2(u[p2], function(E) {
              return Math.ceil(E);
            });
            o.length % 2 === 1 ? m2.push(o.concat(o)) : m2.push(o);
          }
        return m2;
      }
      function k1n(u) {
        if (!u || typeof u == "object" && u.length === 0)
          return [0, 0];
        if (Dh2(u)) {
          var o = Math.ceil(u);
          return [o, o];
        }
        var n3 = Ya2(u, function(p2) {
          return Math.ceil(p2);
        });
        return u.length % 2 ? n3.concat(n3) : n3;
      }
      function P1n(u) {
        return Ya2(u, function(o) {
          return Aye(o);
        });
      }
      function Aye(u) {
        for (var o = 0, n3 = 0; n3 < u.length; ++n3)
          o += u[n3];
        return u.length % 2 === 1 ? o * 2 : o;
      }
      function L1n(u, o) {
        u.eachRawSeries(function(n3) {
          if (!u.isSeriesFiltered(n3)) {
            var p2 = n3.getData();
            p2.hasItemVisual() && p2.each(function(T2) {
              var E = p2.getItemVisual(T2, "decal");
              if (E) {
                var O2 = p2.ensureUniqueItemVisual(T2, "style");
                O2.decal = Fot(E, o);
              }
            });
            var m2 = p2.getVisual("decal");
            if (m2) {
              var w2 = p2.getVisual("style");
              w2.decal = Fot(m2, o);
            }
          }
        });
      }
      var O1n = new gw(), ik2 = O1n, Iye = {};
      function R1n(u, o) {
        Iye[u] = o;
      }
      function N1n(u) {
        return Iye[u];
      }
      var F1n = typeof window != "undefined", V1n = 1, B1n = 800, z1n = 900, j1n = 1e3, W1n = 2e3, G1n = 5e3, Dye = 1e3, H1n = 1100, V8t = 2e3, Eye = 3e3, U1n = 4e3, txt = 4500, q1n = 4600, Z1n = 5e3, $1n = 6e3, kye = 7e3, Y1n = { PROCESSOR: { FILTER: j1n, SERIES_FILTER: B1n, STATISTIC: G1n }, VISUAL: { LAYOUT: Dye, PROGRESSIVE_LAYOUT: H1n, GLOBAL: V8t, CHART: Eye, POST_CHART_LAYOUT: q1n, COMPONENT: U1n, BRUSH: Z1n, CHART_ITEM: txt, ARIA: $1n, DECAL: kye } }, Dw = "__flagInMainProcess", fM = "__pendingUpdate", B8t = "__needsUpdateStatus", Pye = /^[a-zA-Z0-9_]+$/, z8t = "__connectUpdateStatus", Lye = 0, K1n = 1, X1n = 2;
      function Oye(u) {
        return function() {
          for (var o = [], n3 = 0; n3 < arguments.length; n3++)
            o[n3] = arguments[n3];
          if (this.isDisposed()) {
            this.id;
            return;
          }
          return Nye(this, u, o);
        };
      }
      function Rye(u) {
        return function() {
          for (var o = [], n3 = 0; n3 < arguments.length; n3++)
            o[n3] = arguments[n3];
          return Nye(this, u, o);
        };
      }
      function Nye(u, o, n3) {
        return n3[0] = n3[0] && n3[0].toLowerCase(), gw.prototype[o].apply(u, n3);
      }
      var Fye = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o;
      }(gw), Vye = Fye.prototype;
      Vye.on = Rye("on"), Vye.off = Rye("off");
      var sY, j8t, ext, l8, W8t, G8t, H8t, Vot, Bot, Bye, zye, U8t, jye, nxt, Wye, Gye, dI, Hye, Uye = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this, new n1n()) || this;
          w2._chartsViews = [], w2._chartsMap = {}, w2._componentsViews = [], w2._componentsMap = {}, w2._pendingActions = [], m2 = m2 || {}, ds(p2) && (p2 = qye[p2]), w2._dom = n3;
          var T2 = "canvas", E = false, O2 = w2._zr = yat(n3, { renderer: m2.renderer || T2, devicePixelRatio: m2.devicePixelRatio, width: m2.width, height: m2.height, ssr: m2.ssr, useDirtyRect: m2.useDirtyRect == null ? E : m2.useDirtyRect });
          w2._ssr = m2.ssr, w2._throttledZrFlush = k8t(Is(O2.flush, O2), 17), p2 = jl(p2), p2 && s0e(p2, true), w2._theme = p2, w2._locale = syn(m2.locale || bve), w2._coordSysMgr = new Cot();
          var V3 = w2._api = Wye(w2);
          function W3(q3, K) {
            return q3.__prio - K.__prio;
          }
          return UO(ixt, W3), UO(Z8t, W3), w2._scheduler = new nye(w2, V3, Z8t, ixt), w2._messageCenter = new Fye(), w2._initEvents(), w2.resize = Is(w2.resize, w2), O2.animation.on("frame", w2._onframe, w2), Bye(O2, w2), zye(O2, w2), jB(w2), w2;
        }
        return o.prototype._onframe = function() {
          if (!this._disposed) {
            Hye(this);
            var n3 = this._scheduler;
            if (this[fM]) {
              var p2 = this[fM].silent;
              this[Dw] = true;
              try {
                sY(this), l8.update.call(this, null, this[fM].updateParams);
              } catch (O2) {
                throw this[Dw] = false, this[fM] = null, O2;
              }
              this._zr.flush(), this[Dw] = false, this[fM] = null, Vot.call(this, p2), Bot.call(this, p2);
            } else if (n3.unfinished) {
              var m2 = V1n, w2 = this._model, T2 = this._api;
              n3.unfinished = false;
              do {
                var E = +new Date();
                n3.performSeriesTasks(w2), n3.performDataProcessorTasks(w2), G8t(this, w2), n3.performVisualTasks(w2), nxt(this, this._model, T2, "remain", {}), m2 -= +new Date() - E;
              } while (m2 > 0 && n3.unfinished);
              n3.unfinished || this._zr.flush();
            }
          }
        }, o.prototype.getDom = function() {
          return this._dom;
        }, o.prototype.getId = function() {
          return this.id;
        }, o.prototype.getZr = function() {
          return this._zr;
        }, o.prototype.isSSR = function() {
          return this._ssr;
        }, o.prototype.setOption = function(n3, p2, m2) {
          if (!this[Dw]) {
            if (this._disposed) {
              this.id;
              return;
            }
            var w2, T2, E;
            if (ys(p2) && (m2 = p2.lazyUpdate, w2 = p2.silent, T2 = p2.replaceMerge, E = p2.transition, p2 = p2.notMerge), this[Dw] = true, !this._model || p2) {
              var O2 = new jyn(this._api), V3 = this._theme, W3 = this._model = new Jve();
              W3.scheduler = this._scheduler, W3.ssr = this._ssr, W3.init(null, null, null, V3, this._locale, O2);
            }
            this._model.setOption(n3, { replaceMerge: T2 }, $8t);
            var q3 = { seriesTransition: E, optionChanged: true };
            if (m2)
              this[fM] = { silent: w2, updateParams: q3 }, this[Dw] = false, this.getZr().wakeUp();
            else {
              try {
                sY(this), l8.update.call(this, null, q3);
              } catch (K) {
                throw this[fM] = null, this[Dw] = false, K;
              }
              this._ssr || this._zr.flush(), this[fM] = null, this[Dw] = false, Vot.call(this, w2), Bot.call(this, w2);
            }
          }
        }, o.prototype.setTheme = function() {
        }, o.prototype.getModel = function() {
          return this._model;
        }, o.prototype.getOption = function() {
          return this._model && this._model.getOption();
        }, o.prototype.getWidth = function() {
          return this._zr.getWidth();
        }, o.prototype.getHeight = function() {
          return this._zr.getHeight();
        }, o.prototype.getDevicePixelRatio = function() {
          return this._zr.painter.dpr || F1n && window.devicePixelRatio || 1;
        }, o.prototype.getRenderedCanvas = function(n3) {
          return this.renderToCanvas(n3);
        }, o.prototype.renderToCanvas = function(n3) {
          n3 = n3 || {};
          var p2 = this._zr.painter;
          return p2.getRenderedCanvas({ backgroundColor: n3.backgroundColor || this._model.get("backgroundColor"), pixelRatio: n3.pixelRatio || this.getDevicePixelRatio() });
        }, o.prototype.renderToSVGString = function(n3) {
          n3 = n3 || {};
          var p2 = this._zr.painter;
          return p2.renderToString({ useViewBox: n3.useViewBox });
        }, o.prototype.getSvgDataURL = function() {
          if (Ys.svgSupported) {
            var n3 = this._zr, p2 = n3.storage.getDisplayList();
            return Xe2(p2, function(m2) {
              m2.stopAnimation(null, true);
            }), n3.painter.toDataURL();
          }
        }, o.prototype.getDataURL = function(n3) {
          if (this._disposed) {
            this.id;
            return;
          }
          n3 = n3 || {};
          var p2 = n3.excludeComponents, m2 = this._model, w2 = [], T2 = this;
          Xe2(p2, function(O2) {
            m2.eachComponent({ mainType: O2 }, function(V3) {
              var W3 = T2._componentsMap[V3.__viewId];
              W3.group.ignore || (w2.push(W3), W3.group.ignore = true);
            });
          });
          var E = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(n3).toDataURL("image/" + (n3 && n3.type || "png"));
          return Xe2(w2, function(O2) {
            O2.group.ignore = false;
          }), E;
        }, o.prototype.getConnectedDataURL = function(n3) {
          if (this._disposed) {
            this.id;
            return;
          }
          var p2 = n3.type === "svg", m2 = this.group, w2 = Math.min, T2 = Math.max, E = 1 / 0;
          if (Zye[m2]) {
            var O2 = E, V3 = E, W3 = -E, q3 = -E, K = [], J = n3 && n3.pixelRatio || this.getDevicePixelRatio();
            Xe2(jot, function(Wt, Nt) {
              if (Wt.group === m2) {
                var ue2 = p2 ? Wt.getZr().painter.getSvgDom().innerHTML : Wt.renderToCanvas(jl(n3)), ie2 = Wt.getDom().getBoundingClientRect();
                O2 = w2(ie2.left, O2), V3 = w2(ie2.top, V3), W3 = T2(ie2.right, W3), q3 = T2(ie2.bottom, q3), K.push({ dom: ue2, left: ie2.left, top: ie2.top });
              }
            }), O2 *= J, V3 *= J, W3 *= J, q3 *= J;
            var rt2 = W3 - O2, gt = q3 - V3, yt = pw.createCanvas(), At = yat(yt, { renderer: p2 ? "svg" : "canvas" });
            if (At.resize({ width: rt2, height: gt }), p2) {
              var Lt = "";
              return Xe2(K, function(Wt) {
                var Nt = Wt.left - O2, ue2 = Wt.top - V3;
                Lt += '<g transform="translate(' + Nt + "," + ue2 + ')">' + Wt.dom + "</g>";
              }), At.painter.getSvgRoot().innerHTML = Lt, n3.connectedBackgroundColor && At.painter.setBackgroundColor(n3.connectedBackgroundColor), At.refreshImmediately(), At.painter.toDataURL();
            } else
              return n3.connectedBackgroundColor && At.add(new Vf2({ shape: { x: 0, y: 0, width: rt2, height: gt }, style: { fill: n3.connectedBackgroundColor } })), Xe2(K, function(Wt) {
                var Nt = new Fm({ style: { x: Wt.left * J - O2, y: Wt.top * J - V3, image: Wt.dom } });
                At.add(Nt);
              }), At.refreshImmediately(), yt.toDataURL("image/" + (n3 && n3.type || "png"));
          } else
            return this.getDataURL(n3);
        }, o.prototype.convertToPixel = function(n3, p2) {
          return W8t(this, "convertToPixel", n3, p2);
        }, o.prototype.convertFromPixel = function(n3, p2) {
          return W8t(this, "convertFromPixel", n3, p2);
        }, o.prototype.containPixel = function(n3, p2) {
          if (this._disposed) {
            this.id;
            return;
          }
          var m2 = this._model, w2, T2 = cz(m2, n3);
          return Xe2(T2, function(E, O2) {
            O2.indexOf("Models") >= 0 && Xe2(E, function(V3) {
              var W3 = V3.coordinateSystem;
              if (W3 && W3.containPoint)
                w2 = w2 || !!W3.containPoint(p2);
              else if (O2 === "seriesModels") {
                var q3 = this._chartsMap[V3.__viewId];
                q3 && q3.containPoint && (w2 = w2 || q3.containPoint(p2, V3));
              }
            }, this);
          }, this), !!w2;
        }, o.prototype.getVisual = function(n3, p2) {
          var m2 = this._model, w2 = cz(m2, n3, { defaultMainType: "series" }), T2 = w2.seriesModel, E = T2.getData(), O2 = w2.hasOwnProperty("dataIndexInside") ? w2.dataIndexInside : w2.hasOwnProperty("dataIndex") ? E.indexOfRawIndex(w2.dataIndex) : null;
          return O2 != null ? L8t(E, O2, p2) : Oot(E, p2);
        }, o.prototype.getViewOfComponentModel = function(n3) {
          return this._componentsMap[n3.__viewId];
        }, o.prototype.getViewOfSeriesModel = function(n3) {
          return this._chartsMap[n3.__viewId];
        }, o.prototype._initEvents = function() {
          var n3 = this;
          Xe2(Q1n, function(p2) {
            var m2 = function(w2) {
              var T2 = n3.getModel(), E = w2.target, O2, V3 = p2 === "globalout";
              if (V3 ? O2 = {} : E && iY(E, function(rt2) {
                var gt = is(rt2);
                if (gt && gt.dataIndex != null) {
                  var yt = gt.dataModel || T2.getSeriesByIndex(gt.seriesIndex);
                  return O2 = yt && yt.getDataParams(gt.dataIndex, gt.dataType) || {}, true;
                } else if (gt.eventData)
                  return O2 = ua2({}, gt.eventData), true;
              }, true), O2) {
                var W3 = O2.componentType, q3 = O2.componentIndex;
                (W3 === "markLine" || W3 === "markPoint" || W3 === "markArea") && (W3 = "series", q3 = O2.seriesIndex);
                var K = W3 && q3 != null && T2.getComponent(W3, q3), J = K && n3[K.mainType === "series" ? "_chartsMap" : "_componentsMap"][K.__viewId];
                O2.event = w2, O2.type = p2, n3._$eventProcessor.eventInfo = { targetEl: E, packedEvent: O2, model: K, view: J }, n3.trigger(p2, O2);
              }
            };
            m2.zrEventfulCallAtLast = true, n3._zr.on(p2, m2, n3);
          }), Xe2(zot, function(p2, m2) {
            n3._messageCenter.on(m2, function(w2) {
              this.trigger(m2, w2);
            }, n3);
          }), Xe2(["selectchanged"], function(p2) {
            n3._messageCenter.on(p2, function(m2) {
              this.trigger(p2, m2);
            }, n3);
          }), a1n(this._messageCenter, this, this._api);
        }, o.prototype.isDisposed = function() {
          return this._disposed;
        }, o.prototype.clear = function() {
          if (this._disposed) {
            this.id;
            return;
          }
          this.setOption({ series: [] }, true);
        }, o.prototype.dispose = function() {
          if (this._disposed) {
            this.id;
            return;
          }
          this._disposed = true;
          var n3 = this.getDom();
          n3 && xat(this.getDom(), K8t, "");
          var p2 = this, m2 = p2._api, w2 = p2._model;
          Xe2(p2._componentsViews, function(T2) {
            T2.dispose(w2, m2);
          }), Xe2(p2._chartsViews, function(T2) {
            T2.dispose(w2, m2);
          }), p2._zr.dispose(), p2._dom = p2._model = p2._chartsMap = p2._componentsMap = p2._chartsViews = p2._componentsViews = p2._scheduler = p2._api = p2._zr = p2._throttledZrFlush = p2._theme = p2._coordSysMgr = p2._messageCenter = null, delete jot[p2.id];
        }, o.prototype.resize = function(n3) {
          if (!this[Dw]) {
            if (this._disposed) {
              this.id;
              return;
            }
            this._zr.resize(n3);
            var p2 = this._model;
            if (this._loadingFX && this._loadingFX.resize(), !!p2) {
              var m2 = p2.resetOption("media"), w2 = n3 && n3.silent;
              this[fM] && (w2 == null && (w2 = this[fM].silent), m2 = true, this[fM] = null), this[Dw] = true;
              try {
                m2 && sY(this), l8.update.call(this, { type: "resize", animation: ua2({ duration: 0 }, n3 && n3.animation) });
              } catch (T2) {
                throw this[Dw] = false, T2;
              }
              this[Dw] = false, Vot.call(this, w2), Bot.call(this, w2);
            }
          }
        }, o.prototype.showLoading = function(n3, p2) {
          if (this._disposed) {
            this.id;
            return;
          }
          if (ys(n3) && (p2 = n3, n3 = ""), n3 = n3 || "default", this.hideLoading(), !!Y8t[n3]) {
            var m2 = Y8t[n3](this._api, p2), w2 = this._zr;
            this._loadingFX = m2, w2.add(m2);
          }
        }, o.prototype.hideLoading = function() {
          if (this._disposed) {
            this.id;
            return;
          }
          this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
        }, o.prototype.makeActionFromEvent = function(n3) {
          var p2 = ua2({}, n3);
          return p2.type = zot[n3.type], p2;
        }, o.prototype.dispatchAction = function(n3, p2) {
          if (this._disposed) {
            this.id;
            return;
          }
          if (ys(p2) || (p2 = { silent: !!p2 }), !!rxt[n3.type] && !!this._model) {
            if (this[Dw]) {
              this._pendingActions.push(n3);
              return;
            }
            var m2 = p2.silent;
            H8t.call(this, n3, m2);
            var w2 = p2.flush;
            w2 ? this._zr.flush() : w2 !== false && Ys.browser.weChat && this._throttledZrFlush(), Vot.call(this, m2), Bot.call(this, m2);
          }
        }, o.prototype.updateLabelLayout = function() {
          ik2.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
        }, o.prototype.appendData = function(n3) {
          if (this._disposed) {
            this.id;
            return;
          }
          var p2 = n3.seriesIndex, m2 = this.getModel(), w2 = m2.getSeriesByIndex(p2);
          w2.appendData(n3), this._scheduler.unfinished = true, this.getZr().wakeUp();
        }, o.internalField = function() {
          sY = function(q3) {
            var K = q3._scheduler;
            K.restorePipelines(q3._model), K.prepareStageTasks(), j8t(q3, true), j8t(q3, false), K.plan();
          }, j8t = function(q3, K) {
            for (var J = q3._model, rt2 = q3._scheduler, gt = K ? q3._componentsViews : q3._chartsViews, yt = K ? q3._componentsMap : q3._chartsMap, At = q3._zr, Lt = q3._api, Wt = 0; Wt < gt.length; Wt++)
              gt[Wt].__alive = false;
            K ? J.eachComponent(function(ie2, pe2) {
              ie2 !== "series" && Nt(pe2);
            }) : J.eachSeries(Nt);
            function Nt(ie2) {
              var pe2 = ie2.__requireNewView;
              ie2.__requireNewView = false;
              var xe = "_ec_" + ie2.id + "_" + ie2.type, Ce2 = !pe2 && yt[xe];
              if (!Ce2) {
                var Le2 = e22(ie2.type), ze = K ? C0.getClass(Le2.main, Le2.sub) : xg2.getClass(Le2.sub);
                Ce2 = new ze(), Ce2.init(J, Lt), yt[xe] = Ce2, gt.push(Ce2), At.add(Ce2.group);
              }
              ie2.__viewId = Ce2.__id = xe, Ce2.__alive = true, Ce2.__model = ie2, Ce2.group.__ecComponentInfo = { mainType: ie2.mainType, index: ie2.componentIndex }, !K && rt2.prepareView(Ce2, ie2, J, Lt);
            }
            for (var Wt = 0; Wt < gt.length; ) {
              var ue2 = gt[Wt];
              ue2.__alive ? Wt++ : (!K && ue2.renderTask.dispose(), At.remove(ue2.group), ue2.dispose(J, Lt), gt.splice(Wt, 1), yt[ue2.__id] === ue2 && delete yt[ue2.__id], ue2.__id = ue2.group.__ecComponentInfo = null);
            }
          }, ext = function(q3, K, J, rt2, gt) {
            var yt = q3._model;
            if (yt.setUpdatePayload(J), !rt2) {
              Xe2([].concat(q3._componentsViews).concat(q3._chartsViews), ue2);
              return;
            }
            var At = {};
            At[rt2 + "Id"] = J[rt2 + "Id"], At[rt2 + "Index"] = J[rt2 + "Index"], At[rt2 + "Name"] = J[rt2 + "Name"];
            var Lt = { mainType: rt2, query: At };
            gt && (Lt.subType = gt);
            var Wt = J.excludeSeriesId, Nt;
            Wt != null && (Nt = pl(), Xe2(Tp(Wt), function(ie2) {
              var pe2 = $d2(ie2, null);
              pe2 != null && Nt.set(pe2, true);
            })), yt && yt.eachComponent(Lt, function(ie2) {
              var pe2 = Nt && Nt.get(ie2.id) !== null;
              if (!pe2)
                if (Xy(J))
                  if (ie2 instanceof Rv)
                    J.type === tx && !J.notBlur && !ie2.get(["emphasis", "disabled"]) && pFt(ie2, J, q3._api);
                  else {
                    var xe = eot(ie2.mainType, ie2.componentIndex, J.name, q3._api), Ce2 = xe.focusSelf, Le2 = xe.dispatchers;
                    J.type === tx && Ce2 && !J.notBlur && KF(ie2.mainType, ie2.componentIndex, q3._api), Le2 && Xe2(Le2, function(ze) {
                      J.type === tx ? Vm(ze) : pc2(ze);
                    });
                  }
                else
                  rot(J) && ie2 instanceof Rv && (vFt(ie2, J, q3._api), a_t(ie2), dI(q3));
            }, q3), yt && yt.eachComponent(Lt, function(ie2) {
              var pe2 = Nt && Nt.get(ie2.id) !== null;
              pe2 || ue2(q3[rt2 === "series" ? "_chartsMap" : "_componentsMap"][ie2.__viewId]);
            }, q3);
            function ue2(ie2) {
              ie2 && ie2.__alive && ie2[K] && ie2[K](ie2.__model, yt, q3._api, J);
            }
          }, l8 = { prepareAndUpdate: function(q3) {
            sY(this), l8.update.call(this, q3, { optionChanged: q3.newOption != null });
          }, update: function(q3, K) {
            var J = this._model, rt2 = this._api, gt = this._zr, yt = this._coordSysMgr, At = this._scheduler;
            if (J) {
              J.setUpdatePayload(q3), At.restoreData(J, q3), At.performSeriesTasks(J), yt.create(J, rt2), At.performDataProcessorTasks(J, q3), G8t(this, J), yt.update(J, rt2), n3(J), At.performVisualTasks(J, q3), U8t(this, J, rt2, q3, K);
              var Lt = J.get("backgroundColor") || "transparent", Wt = J.get("darkMode");
              gt.setBackgroundColor(Lt), Wt != null && Wt !== "auto" && gt.setDarkMode(Wt), ik2.trigger("afterupdate", J, rt2);
            }
          }, updateTransform: function(q3) {
            var K = this, J = this._model, rt2 = this._api;
            if (J) {
              J.setUpdatePayload(q3);
              var gt = [];
              J.eachComponent(function(At, Lt) {
                if (At !== "series") {
                  var Wt = K.getViewOfComponentModel(Lt);
                  if (Wt && Wt.__alive)
                    if (Wt.updateTransform) {
                      var Nt = Wt.updateTransform(Lt, J, rt2, q3);
                      Nt && Nt.update && gt.push(Wt);
                    } else
                      gt.push(Wt);
                }
              });
              var yt = pl();
              J.eachSeries(function(At) {
                var Lt = K._chartsMap[At.__viewId];
                if (Lt.updateTransform) {
                  var Wt = Lt.updateTransform(At, J, rt2, q3);
                  Wt && Wt.update && yt.set(At.uid, 1);
                } else
                  yt.set(At.uid, 1);
              }), n3(J), this._scheduler.performVisualTasks(J, q3, { setDirty: true, dirtyMap: yt }), nxt(this, J, rt2, q3, {}, yt), ik2.trigger("afterupdate", J, rt2);
            }
          }, updateView: function(q3) {
            var K = this._model;
            !K || (K.setUpdatePayload(q3), xg2.markUpdateMethod(q3, "updateView"), n3(K), this._scheduler.performVisualTasks(K, q3, { setDirty: true }), U8t(this, K, this._api, q3, {}), ik2.trigger("afterupdate", K, this._api));
          }, updateVisual: function(q3) {
            var K = this, J = this._model;
            !J || (J.setUpdatePayload(q3), J.eachSeries(function(rt2) {
              rt2.getData().clearAllVisual();
            }), xg2.markUpdateMethod(q3, "updateVisual"), n3(J), this._scheduler.performVisualTasks(J, q3, { visualType: "visual", setDirty: true }), J.eachComponent(function(rt2, gt) {
              if (rt2 !== "series") {
                var yt = K.getViewOfComponentModel(gt);
                yt && yt.__alive && yt.updateVisual(gt, J, K._api, q3);
              }
            }), J.eachSeries(function(rt2) {
              var gt = K._chartsMap[rt2.__viewId];
              gt.updateVisual(rt2, J, K._api, q3);
            }), ik2.trigger("afterupdate", J, this._api));
          }, updateLayout: function(q3) {
            l8.update.call(this, q3);
          } }, W8t = function(q3, K, J, rt2) {
            if (q3._disposed) {
              q3.id;
              return;
            }
            for (var gt = q3._model, yt = q3._coordSysMgr.getCoordinateSystems(), At, Lt = cz(gt, J), Wt = 0; Wt < yt.length; Wt++) {
              var Nt = yt[Wt];
              if (Nt[K] && (At = Nt[K](gt, Lt, rt2)) != null)
                return At;
            }
          }, G8t = function(q3, K) {
            var J = q3._chartsMap, rt2 = q3._scheduler;
            K.eachSeries(function(gt) {
              rt2.updateStreamModes(gt, J[gt.__viewId]);
            });
          }, H8t = function(q3, K) {
            var J = this, rt2 = this.getModel(), gt = q3.type, yt = q3.escapeConnect, At = rxt[gt], Lt = At.actionInfo, Wt = (Lt.update || "update").split(":"), Nt = Wt.pop(), ue2 = Wt[0] != null && e22(Wt[0]);
            this[Dw] = true;
            var ie2 = [q3], pe2 = false;
            q3.batch && (pe2 = true, ie2 = Ya2(q3.batch, function(Tn) {
              return Tn = kl(ua2({}, Tn), q3), Tn.batch = null, Tn;
            }));
            var xe = [], Ce2, Le2 = rot(q3), ze = Xy(q3);
            if (ze && i_t(this._api), Xe2(ie2, function(Tn) {
              if (Ce2 = At.action(Tn, J._model, J._api), Ce2 = Ce2 || ua2({}, Tn), Ce2.type = Lt.event || Ce2.type, xe.push(Ce2), ze) {
                var zn = _at(q3), bn = zn.queryOptionMap, Xr = zn.mainTypeSpecified, Xn = Xr ? bn.keys()[0] : "series";
                ext(J, Nt, Tn, Xn), dI(J);
              } else
                Le2 ? (ext(J, Nt, Tn, "series"), dI(J)) : ue2 && ext(J, Nt, Tn, ue2.main, ue2.sub);
            }), Nt !== "none" && !ze && !Le2 && !ue2)
              try {
                this[fM] ? (sY(this), l8.update.call(this, q3), this[fM] = null) : l8[Nt].call(this, q3);
              } catch (Tn) {
                throw this[Dw] = false, Tn;
              }
            if (pe2 ? Ce2 = { type: Lt.event || gt, escapeConnect: yt, batch: xe } : Ce2 = xe[0], this[Dw] = false, !K) {
              var tn = this._messageCenter;
              if (tn.trigger(Ce2.type, Ce2), Le2) {
                var $e2 = { type: "selectchanged", escapeConnect: yt, selected: yFt(rt2), isFromClick: q3.isFromClick || false, fromAction: q3.type, fromActionPayload: q3 };
                tn.trigger($e2.type, $e2);
              }
            }
          }, Vot = function(q3) {
            for (var K = this._pendingActions; K.length; ) {
              var J = K.shift();
              H8t.call(this, J, q3);
            }
          }, Bot = function(q3) {
            !q3 && this.trigger("updated");
          }, Bye = function(q3, K) {
            q3.on("rendered", function(J) {
              K.trigger("rendered", J), q3.animation.isFinished() && !K[fM] && !K._scheduler.unfinished && !K._pendingActions.length && K.trigger("finished");
            });
          }, zye = function(q3, K) {
            q3.on("mouseover", function(J) {
              var rt2 = J.target, gt = iY(rt2, _4);
              gt && (dFt(gt, J, K._api), dI(K));
            }).on("mouseout", function(J) {
              var rt2 = J.target, gt = iY(rt2, _4);
              gt && (gFt(gt, J, K._api), dI(K));
            }).on("click", function(J) {
              var rt2 = J.target, gt = iY(rt2, function(Lt) {
                return is(Lt).dataIndex != null;
              }, true);
              if (gt) {
                var yt = gt.selected ? "unselect" : "select", At = is(gt);
                K._api.dispatchAction({ type: yt, dataType: At.dataType, dataIndexInside: At.dataIndex, seriesIndex: At.seriesIndex, isFromClick: true });
              }
            });
          };
          function n3(q3) {
            q3.clearColorPalette(), q3.eachSeries(function(K) {
              K.clearColorPalette();
            });
          }
          function p2(q3) {
            var K = [], J = [], rt2 = false;
            if (q3.eachComponent(function(Lt, Wt) {
              var Nt = Wt.get("zlevel") || 0, ue2 = Wt.get("z") || 0, ie2 = Wt.getZLevelKey();
              rt2 = rt2 || !!ie2, (Lt === "series" ? J : K).push({ zlevel: Nt, z: ue2, idx: Wt.componentIndex, type: Lt, key: ie2 });
            }), rt2) {
              var gt = K.concat(J), yt, At;
              UO(gt, function(Lt, Wt) {
                return Lt.zlevel === Wt.zlevel ? Lt.z - Wt.z : Lt.zlevel - Wt.zlevel;
              }), Xe2(gt, function(Lt) {
                var Wt = q3.getComponent(Lt.type, Lt.idx), Nt = Lt.zlevel, ue2 = Lt.key;
                yt != null && (Nt = Math.max(yt, Nt)), ue2 ? (Nt === yt && ue2 !== At && Nt++, At = ue2) : At && (Nt === yt && Nt++, At = ""), yt = Nt, Wt.setZLevel(Nt);
              });
            }
          }
          U8t = function(q3, K, J, rt2, gt) {
            p2(K), jye(q3, K, J, rt2, gt), Xe2(q3._chartsViews, function(yt) {
              yt.__alive = false;
            }), nxt(q3, K, J, rt2, gt), Xe2(q3._chartsViews, function(yt) {
              yt.__alive || yt.remove(K, J);
            });
          }, jye = function(q3, K, J, rt2, gt, yt) {
            Xe2(yt || q3._componentsViews, function(At) {
              var Lt = At.__model;
              V3(Lt, At), At.render(Lt, K, J, rt2), E(Lt, At), W3(Lt, At);
            });
          }, nxt = function(q3, K, J, rt2, gt, yt) {
            var At = q3._scheduler;
            gt = ua2(gt || {}, { updatedSeries: K.getSeries() }), ik2.trigger("series:beforeupdate", K, J, gt);
            var Lt = false;
            K.eachSeries(function(Wt) {
              var Nt = q3._chartsMap[Wt.__viewId];
              Nt.__alive = true;
              var ue2 = Nt.renderTask;
              At.updatePayload(ue2, rt2), V3(Wt, Nt), yt && yt.get(Wt.uid) && ue2.dirty(), ue2.perform(At.getPerformArgs(ue2)) && (Lt = true), Nt.group.silent = !!Wt.get("silent"), T2(Wt, Nt), a_t(Wt);
            }), At.unfinished = Lt || At.unfinished, ik2.trigger("series:layoutlabels", K, J, gt), ik2.trigger("series:transition", K, J, gt), K.eachSeries(function(Wt) {
              var Nt = q3._chartsMap[Wt.__viewId];
              E(Wt, Nt), W3(Wt, Nt);
            }), w2(q3, K), ik2.trigger("series:afterupdate", K, J, gt);
          }, dI = function(q3) {
            q3[B8t] = true, q3.getZr().wakeUp();
          }, Hye = function(q3) {
            !q3[B8t] || (q3.getZr().storage.traverse(function(K) {
              e8(K) || m2(K);
            }), q3[B8t] = false);
          };
          function m2(q3) {
            for (var K = [], J = q3.currentStates, rt2 = 0; rt2 < J.length; rt2++) {
              var gt = J[rt2];
              gt === "emphasis" || gt === "blur" || gt === "select" || K.push(gt);
            }
            q3.selected && q3.states.select && K.push("select"), q3.hoverState === I$ && q3.states.emphasis ? K.push("emphasis") : q3.hoverState === vz && q3.states.blur && K.push("blur"), q3.useStates(K);
          }
          function w2(q3, K) {
            var J = q3._zr, rt2 = J.storage, gt = 0;
            rt2.traverse(function(yt) {
              yt.isGroup || gt++;
            }), gt > K.get("hoverLayerThreshold") && !Ys.node && !Ys.worker && K.eachSeries(function(yt) {
              if (!yt.preventUsingHoverLayer) {
                var At = q3._chartsMap[yt.__viewId];
                At.__alive && At.eachRendered(function(Lt) {
                  Lt.states.emphasis && (Lt.states.emphasis.hoverLayer = true);
                });
              }
            });
          }
          function T2(q3, K) {
            var J = q3.get("blendMode") || null;
            K.eachRendered(function(rt2) {
              rt2.isGroup || (rt2.style.blend = J);
            });
          }
          function E(q3, K) {
            if (!q3.preventAutoZ) {
              var J = q3.get("z") || 0, rt2 = q3.get("zlevel") || 0;
              K.eachRendered(function(gt) {
                return O2(gt, J, rt2, -1 / 0), true;
              });
            }
          }
          function O2(q3, K, J, rt2) {
            var gt = q3.getTextContent(), yt = q3.getTextGuideLine(), At = q3.isGroup;
            if (At)
              for (var Lt = q3.childrenRef(), Wt = 0; Wt < Lt.length; Wt++)
                rt2 = Math.max(O2(Lt[Wt], K, J, rt2), rt2);
            else
              q3.z = K, q3.zlevel = J, rt2 = Math.max(q3.z2, rt2);
            if (gt && (gt.z = K, gt.zlevel = J, isFinite(rt2) && (gt.z2 = rt2 + 2)), yt) {
              var Nt = q3.textGuideLineConfig;
              yt.z = K, yt.zlevel = J, isFinite(rt2) && (yt.z2 = rt2 + (Nt && Nt.showAbove ? 1 : -1));
            }
            return rt2;
          }
          function V3(q3, K) {
            K.eachRendered(function(J) {
              if (!e8(J)) {
                var rt2 = J.getTextContent(), gt = J.getTextGuideLine();
                J.stateTransition && (J.stateTransition = null), rt2 && rt2.stateTransition && (rt2.stateTransition = null), gt && gt.stateTransition && (gt.stateTransition = null), J.hasState() ? (J.prevStates = J.currentStates, J.clearStates()) : J.prevStates && (J.prevStates = null);
              }
            });
          }
          function W3(q3, K) {
            var J = q3.getModel("stateAnimation"), rt2 = q3.isAnimationEnabled(), gt = J.get("duration"), yt = gt > 0 ? { duration: gt, delay: J.get("delay"), easing: J.get("easing") } : null;
            K.eachRendered(function(At) {
              if (At.states && At.states.emphasis) {
                if (e8(At))
                  return;
                if (At instanceof Mc2 && xw(At), At.__dirty) {
                  var Lt = At.prevStates;
                  Lt && At.useStates(Lt);
                }
                if (rt2) {
                  At.stateTransition = yt;
                  var Wt = At.getTextContent(), Nt = At.getTextGuideLine();
                  Wt && (Wt.stateTransition = yt), Nt && (Nt.stateTransition = yt);
                }
                At.__dirty && m2(At);
              }
            });
          }
          Wye = function(q3) {
            return new (function(K) {
              tr(J, K);
              function J() {
                return K !== null && K.apply(this, arguments) || this;
              }
              return J.prototype.getCoordinateSystems = function() {
                return q3._coordSysMgr.getCoordinateSystems();
              }, J.prototype.getComponentByElement = function(rt2) {
                for (; rt2; ) {
                  var gt = rt2.__ecComponentInfo;
                  if (gt != null)
                    return q3._model.getComponent(gt.mainType, gt.index);
                  rt2 = rt2.parent;
                }
              }, J.prototype.enterEmphasis = function(rt2, gt) {
                Vm(rt2, gt), dI(q3);
              }, J.prototype.leaveEmphasis = function(rt2, gt) {
                pc2(rt2, gt), dI(q3);
              }, J.prototype.enterBlur = function(rt2) {
                Jat(rt2), dI(q3);
              }, J.prototype.leaveBlur = function(rt2) {
                r2(rt2), dI(q3);
              }, J.prototype.enterSelect = function(rt2) {
                tot(rt2), dI(q3);
              }, J.prototype.leaveSelect = function(rt2) {
                r_t(rt2), dI(q3);
              }, J.prototype.getModel = function() {
                return q3.getModel();
              }, J.prototype.getViewOfComponentModel = function(rt2) {
                return q3.getViewOfComponentModel(rt2);
              }, J.prototype.getViewOfSeriesModel = function(rt2) {
                return q3.getViewOfSeriesModel(rt2);
              }, J;
            }(t0e))(q3);
          }, Gye = function(q3) {
            function K(J, rt2) {
              for (var gt = 0; gt < J.length; gt++) {
                var yt = J[gt];
                yt[z8t] = rt2;
              }
            }
            Xe2(zot, function(J, rt2) {
              q3._messageCenter.on(rt2, function(gt) {
                if (Zye[q3.group] && q3[z8t] !== Lye) {
                  if (gt && gt.escapeConnect)
                    return;
                  var yt = q3.makeActionFromEvent(gt), At = [];
                  Xe2(jot, function(Lt) {
                    Lt !== q3 && Lt.group === q3.group && At.push(Lt);
                  }), K(At, Lye), Xe2(At, function(Lt) {
                    Lt[z8t] !== K1n && Lt.dispatchAction(yt);
                  }), K(At, X1n);
                }
              });
            });
          };
        }(), o;
      }(gw), q8t = Uye.prototype;
      q8t.on = Oye("on"), q8t.off = Oye("off"), q8t.one = function(u, o, n3) {
        var p2 = this;
        function m2() {
          for (var w2 = [], T2 = 0; T2 < arguments.length; T2++)
            w2[T2] = arguments[T2];
          o && o.apply && o.apply(this, w2), p2.off(u, m2);
        }
        this.on.call(this, u, m2, n3);
      };
      var Q1n = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"], rxt = {}, zot = {}, Z8t = [], $8t = [], ixt = [], qye = {}, Y8t = {}, jot = {}, Zye = {}, J1n = +new Date() - 0, K8t = "_echarts_instance_";
      function tbn(u, o, n3) {
        var p2 = !(n3 && n3.ssr);
        if (p2) {
          var m2 = ebn(u);
          if (m2)
            return m2;
        }
        var w2 = new Uye(u, o, n3);
        return w2.id = "ec_" + J1n++, jot[w2.id] = w2, p2 && xat(u, K8t, w2.id), Gye(w2), ik2.trigger("afterinit", w2), w2;
      }
      function ebn(u) {
        return jot[SNt(u, K8t)];
      }
      function $ye(u, o) {
        qye[u] = o;
      }
      function Yye(u) {
        sc2($8t, u) < 0 && $8t.push(u);
      }
      function Kye(u, o) {
        Q8t(Z8t, u, o, W1n);
      }
      function nbn(u) {
        X8t("afterinit", u);
      }
      function rbn(u) {
        X8t("afterupdate", u);
      }
      function X8t(u, o) {
        ik2.on(u, o);
      }
      function ZP(u, o, n3) {
        Sl(o) && (n3 = o, o = "");
        var p2 = ys(u) ? u.type : [u, u = { event: o }][0];
        u.event = (u.event || p2).toLowerCase(), o = u.event, !zot[o] && (Tb2(Pye.test(p2) && Pye.test(o)), rxt[p2] || (rxt[p2] = { action: n3, actionInfo: u }), zot[o] = p2);
      }
      function ibn(u, o) {
        Cot.register(u, o);
      }
      function abn(u, o) {
        Q8t(ixt, u, o, Dye, "layout");
      }
      function Rz(u, o) {
        Q8t(ixt, u, o, Eye, "visual");
      }
      var Xye = [];
      function Q8t(u, o, n3, p2, m2) {
        if ((Sl(o) || ys(o)) && (n3 = o, o = p2), !(sc2(Xye, n3) >= 0)) {
          Xye.push(n3);
          var w2 = nye.wrapStageHandler(n3, m2);
          w2.__prio = o, w2.__raw = n3, u.push(w2);
        }
      }
      function Qye(u, o) {
        Y8t[u] = o;
      }
      function obn(u, o, n3) {
        var p2 = N1n("registerMap");
        p2 && p2(u, o, n3);
      }
      var sbn = gmn;
      Rz(V8t, zmn), Rz(txt, jmn), Rz(txt, Wmn), Rz(V8t, r1n), Rz(txt, i1n), Rz(kye, L1n), Yye(s0e), Kye(z1n, Yyn), Qye("default", Gmn), ZP({ type: tx, event: tx, update: tx }, Jp), ZP({ type: mz, event: mz, update: mz }, Jp), ZP({ type: GP, event: GP, update: GP }, Jp), ZP({ type: Kg2, event: Kg2, update: Kg2 }, Jp), ZP({ type: Xg2, event: Xg2, update: Xg2 }, Jp), $ye("light", t1n), $ye("dark", e1n);
      var Jye = [], lbn = { registerPreprocessor: Yye, registerProcessor: Kye, registerPostInit: nbn, registerPostUpdate: rbn, registerUpdateLifecycle: X8t, registerAction: ZP, registerCoordinateSystem: ibn, registerLayout: abn, registerVisual: Rz, registerTransform: sbn, registerLoading: Qye, registerMap: obn, registerImpl: R1n, PRIORITY: Y1n, ComponentModel: kh2, ComponentView: C0, SeriesModel: Rv, ChartView: xg2, registerComponentModel: function(u) {
        kh2.registerClass(u);
      }, registerComponentView: function(u) {
        C0.registerClass(u);
      }, registerSeriesModel: function(u) {
        Rv.registerClass(u);
      }, registerChartView: function(u) {
        xg2.registerClass(u);
      }, registerSubTypeDefaulter: function(u, o) {
        kh2.registerSubTypeDefaulter(u, o);
      }, registerPainter: function(u, o) {
        HF(u, o);
      } };
      function Rc2(u) {
        if (za2(u)) {
          Xe2(u, function(o) {
            Rc2(o);
          });
          return;
        }
        sc2(Jye, u) >= 0 || (Jye.push(u), Sl(u) && (u = { install: u }), u.install(lbn));
      }
      function Wot(u) {
        return u == null ? 0 : u.length || 1;
      }
      function tme(u) {
        return u;
      }
      var ubn = function() {
        function u(o, n3, p2, m2, w2, T2) {
          this._old = o, this._new = n3, this._oldKeyGetter = p2 || tme, this._newKeyGetter = m2 || tme, this.context = w2, this._diffModeMultiple = T2 === "multiple";
        }
        return u.prototype.add = function(o) {
          return this._add = o, this;
        }, u.prototype.update = function(o) {
          return this._update = o, this;
        }, u.prototype.updateManyToOne = function(o) {
          return this._updateManyToOne = o, this;
        }, u.prototype.updateOneToMany = function(o) {
          return this._updateOneToMany = o, this;
        }, u.prototype.updateManyToMany = function(o) {
          return this._updateManyToMany = o, this;
        }, u.prototype.remove = function(o) {
          return this._remove = o, this;
        }, u.prototype.execute = function() {
          this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
        }, u.prototype._executeOneToOne = function() {
          var o = this._old, n3 = this._new, p2 = {}, m2 = new Array(o.length), w2 = new Array(n3.length);
          this._initIndexMap(o, null, m2, "_oldKeyGetter"), this._initIndexMap(n3, p2, w2, "_newKeyGetter");
          for (var T2 = 0; T2 < o.length; T2++) {
            var E = m2[T2], O2 = p2[E], V3 = Wot(O2);
            if (V3 > 1) {
              var W3 = O2.shift();
              O2.length === 1 && (p2[E] = O2[0]), this._update && this._update(W3, T2);
            } else
              V3 === 1 ? (p2[E] = null, this._update && this._update(O2, T2)) : this._remove && this._remove(T2);
          }
          this._performRestAdd(w2, p2);
        }, u.prototype._executeMultiple = function() {
          var o = this._old, n3 = this._new, p2 = {}, m2 = {}, w2 = [], T2 = [];
          this._initIndexMap(o, p2, w2, "_oldKeyGetter"), this._initIndexMap(n3, m2, T2, "_newKeyGetter");
          for (var E = 0; E < w2.length; E++) {
            var O2 = w2[E], V3 = p2[O2], W3 = m2[O2], q3 = Wot(V3), K = Wot(W3);
            if (q3 > 1 && K === 1)
              this._updateManyToOne && this._updateManyToOne(W3, V3), m2[O2] = null;
            else if (q3 === 1 && K > 1)
              this._updateOneToMany && this._updateOneToMany(W3, V3), m2[O2] = null;
            else if (q3 === 1 && K === 1)
              this._update && this._update(W3, V3), m2[O2] = null;
            else if (q3 > 1 && K > 1)
              this._updateManyToMany && this._updateManyToMany(W3, V3), m2[O2] = null;
            else if (q3 > 1)
              for (var J = 0; J < q3; J++)
                this._remove && this._remove(V3[J]);
            else
              this._remove && this._remove(V3);
          }
          this._performRestAdd(T2, m2);
        }, u.prototype._performRestAdd = function(o, n3) {
          for (var p2 = 0; p2 < o.length; p2++) {
            var m2 = o[p2], w2 = n3[m2], T2 = Wot(w2);
            if (T2 > 1)
              for (var E = 0; E < T2; E++)
                this._add && this._add(w2[E]);
            else
              T2 === 1 && this._add && this._add(w2);
            n3[m2] = null;
          }
        }, u.prototype._initIndexMap = function(o, n3, p2, m2) {
          for (var w2 = this._diffModeMultiple, T2 = 0; T2 < o.length; T2++) {
            var E = "_ec_" + this[m2](o[T2], T2);
            if (w2 || (p2[T2] = E), !!n3) {
              var O2 = n3[E], V3 = Wot(O2);
              V3 === 0 ? (n3[E] = T2, w2 && p2.push(E)) : V3 === 1 ? n3[E] = [O2, T2] : O2.push(T2);
            }
          }
        }, u;
      }(), C4 = ubn, cbn = function() {
        function u(o, n3) {
          this._encode = o, this._schema = n3;
        }
        return u.prototype.get = function() {
          return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
        }, u.prototype._getFullDimensionNames = function() {
          return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
        }, u;
      }();
      function fbn(u, o) {
        var n3 = {}, p2 = n3.encode = {}, m2 = pl(), w2 = [], T2 = [], E = {};
        Xe2(u.dimensions, function(K) {
          var J = u.getDimensionInfo(K), rt2 = J.coordDim;
          if (rt2) {
            var gt = J.coordDimIndex;
            J8t(p2, rt2)[gt] = K, J.isExtraCoord || (m2.set(rt2, 1), hbn(J.type) && (w2[0] = K), J8t(E, rt2)[gt] = u.getDimensionIndex(J.name)), J.defaultTooltip && T2.push(K);
          }
          Bve.each(function(yt, At) {
            var Lt = J8t(p2, At), Wt = J.otherDims[At];
            Wt != null && Wt !== false && (Lt[Wt] = J.name);
          });
        });
        var O2 = [], V3 = {};
        m2.each(function(K, J) {
          var rt2 = p2[J];
          V3[J] = rt2[0], O2 = O2.concat(rt2);
        }), n3.dataDimsOnCoord = O2, n3.dataDimIndicesOnCoord = Ya2(O2, function(K) {
          return u.getDimensionInfo(K).storeDimIndex;
        }), n3.encodeFirstDimNotExtra = V3;
        var W3 = p2.label;
        W3 && W3.length && (w2 = W3.slice());
        var q3 = p2.tooltip;
        return q3 && q3.length ? T2 = q3.slice() : T2.length || (T2 = w2.slice()), p2.defaultedLabel = w2, p2.defaultedTooltip = T2, n3.userOutput = new cbn(E, o), n3;
      }
      function J8t(u, o) {
        return u.hasOwnProperty(o) || (u[o] = []), u[o];
      }
      function axt(u) {
        return u === "category" ? "ordinal" : u === "time" ? "time" : "float";
      }
      function hbn(u) {
        return !(u === "ordinal" || u === "time");
      }
      var pbn = function() {
        function u(o) {
          this.otherDims = {}, o != null && ua2(this, o);
        }
        return u;
      }(), oxt = pbn, dbn = Ff2(), gbn = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, eme = function() {
        function u(o) {
          this.dimensions = o.dimensions, this._dimOmitted = o.dimensionOmitted, this.source = o.source, this._fullDimCount = o.fullDimensionCount, this._updateDimOmitted(o.dimensionOmitted);
        }
        return u.prototype.isDimensionOmitted = function() {
          return this._dimOmitted;
        }, u.prototype._updateDimOmitted = function(o) {
          this._dimOmitted = o, o && (this._dimNameMap || (this._dimNameMap = ime(this.source)));
        }, u.prototype.getSourceDimensionIndex = function(o) {
          return Xu(this._dimNameMap.get(o), -1);
        }, u.prototype.getSourceDimension = function(o) {
          var n3 = this.source.dimensionsDefine;
          if (n3)
            return n3[o];
        }, u.prototype.makeStoreSchema = function() {
          for (var o = this._fullDimCount, n3 = f0e(this.source), p2 = !ame(o), m2 = "", w2 = [], T2 = 0, E = 0; T2 < o; T2++) {
            var O2 = void 0, V3 = void 0, W3 = void 0, q3 = this.dimensions[E];
            if (q3 && q3.storeDimIndex === T2)
              O2 = n3 ? q3.name : null, V3 = q3.type, W3 = q3.ordinalMeta, E++;
            else {
              var K = this.getSourceDimension(T2);
              K && (O2 = n3 ? K.name : null, V3 = K.type);
            }
            w2.push({ property: O2, type: V3, ordinalMeta: W3 }), n3 && O2 != null && (!q3 || !q3.isCalculationCoord) && (m2 += p2 ? O2.replace(/\`/g, "`1").replace(/\$/g, "`2") : O2), m2 += "$", m2 += gbn[V3] || "f", W3 && (m2 += W3.uid), m2 += "$";
          }
          var J = this.source, rt2 = [J.seriesLayoutBy, J.startIndex, m2].join("$$");
          return { dimensions: w2, hash: rt2 };
        }, u.prototype.makeOutputDimensionNames = function() {
          for (var o = [], n3 = 0, p2 = 0; n3 < this._fullDimCount; n3++) {
            var m2 = void 0, w2 = this.dimensions[p2];
            if (w2 && w2.storeDimIndex === n3)
              w2.isCalculationCoord || (m2 = w2.name), p2++;
            else {
              var T2 = this.getSourceDimension(n3);
              T2 && (m2 = T2.name);
            }
            o.push(m2);
          }
          return o;
        }, u.prototype.appendCalculationDimension = function(o) {
          this.dimensions.push(o), o.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
        }, u;
      }();
      function nme(u) {
        return u instanceof eme;
      }
      function rme(u) {
        for (var o = pl(), n3 = 0; n3 < (u || []).length; n3++) {
          var p2 = u[n3], m2 = ys(p2) ? p2.name : p2;
          m2 != null && o.get(m2) == null && o.set(m2, n3);
        }
        return o;
      }
      function ime(u) {
        var o = dbn(u);
        return o.dimNameMap || (o.dimNameMap = rme(u.dimensionsDefine));
      }
      function ame(u) {
        return u > 30;
      }
      var Got = ys, u8 = Ya2, vbn = typeof Int32Array == "undefined" ? Array : Int32Array, ybn = "e\0\0", ome = -1, mbn = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], bbn = ["_approximateExtent"], sme, sxt, Hot, Uot, t9t, lxt, e9t, _bn = function() {
        function u(o, n3) {
          this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
          var p2, m2 = false;
          nme(o) ? (p2 = o.dimensions, this._dimOmitted = o.isDimensionOmitted(), this._schema = o) : (m2 = true, p2 = o), p2 = p2 || ["x", "y"];
          for (var w2 = {}, T2 = [], E = {}, O2 = false, V3 = {}, W3 = 0; W3 < p2.length; W3++) {
            var q3 = p2[W3], K = ds(q3) ? new oxt({ name: q3 }) : q3 instanceof oxt ? q3 : new oxt(q3), J = K.name;
            K.type = K.type || "float", K.coordDim || (K.coordDim = J, K.coordDimIndex = 0);
            var rt2 = K.otherDims = K.otherDims || {};
            T2.push(J), w2[J] = K, V3[J] != null && (O2 = true), K.createInvertedIndices && (E[J] = []), rt2.itemName === 0 && (this._nameDimIdx = W3), rt2.itemId === 0 && (this._idDimIdx = W3), m2 && (K.storeDimIndex = W3);
          }
          if (this.dimensions = T2, this._dimInfos = w2, this._initGetDimensionInfo(O2), this.hostModel = n3, this._invertedIndicesMap = E, this._dimOmitted) {
            var gt = this._dimIdxToName = pl();
            Xe2(T2, function(yt) {
              gt.set(w2[yt].storeDimIndex, yt);
            });
          }
        }
        return u.prototype.getDimension = function(o) {
          var n3 = this._recognizeDimIndex(o);
          if (n3 == null)
            return o;
          if (n3 = o, !this._dimOmitted)
            return this.dimensions[n3];
          var p2 = this._dimIdxToName.get(n3);
          if (p2 != null)
            return p2;
          var m2 = this._schema.getSourceDimension(n3);
          if (m2)
            return m2.name;
        }, u.prototype.getDimensionIndex = function(o) {
          var n3 = this._recognizeDimIndex(o);
          if (n3 != null)
            return n3;
          if (o == null)
            return -1;
          var p2 = this._getDimInfo(o);
          return p2 ? p2.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(o) : -1;
        }, u.prototype._recognizeDimIndex = function(o) {
          if (Dh2(o) || o != null && !isNaN(o) && !this._getDimInfo(o) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(o) < 0))
            return +o;
        }, u.prototype._getStoreDimIndex = function(o) {
          var n3 = this.getDimensionIndex(o);
          return n3;
        }, u.prototype.getDimensionInfo = function(o) {
          return this._getDimInfo(this.getDimension(o));
        }, u.prototype._initGetDimensionInfo = function(o) {
          var n3 = this._dimInfos;
          this._getDimInfo = o ? function(p2) {
            return n3.hasOwnProperty(p2) ? n3[p2] : void 0;
          } : function(p2) {
            return n3[p2];
          };
        }, u.prototype.getDimensionsOnCoord = function() {
          return this._dimSummary.dataDimsOnCoord.slice();
        }, u.prototype.mapDimension = function(o, n3) {
          var p2 = this._dimSummary;
          if (n3 == null)
            return p2.encodeFirstDimNotExtra[o];
          var m2 = p2.encode[o];
          return m2 ? m2[n3] : null;
        }, u.prototype.mapDimensionsAll = function(o) {
          var n3 = this._dimSummary, p2 = n3.encode[o];
          return (p2 || []).slice();
        }, u.prototype.getStore = function() {
          return this._store;
        }, u.prototype.initData = function(o, n3, p2) {
          var m2 = this, w2;
          if (o instanceof M8t && (w2 = o), !w2) {
            var T2 = this.dimensions, E = v8t(o) || M1(o) ? new d0e(o, T2.length) : o;
            w2 = new M8t();
            var O2 = u8(T2, function(V3) {
              return { type: m2._dimInfos[V3].type, property: V3 };
            });
            w2.initData(E, O2, p2);
          }
          this._store = w2, this._nameList = (n3 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, w2.count()), this._dimSummary = fbn(this, this._schema), this.userOutput = this._dimSummary.userOutput;
        }, u.prototype.appendData = function(o) {
          var n3 = this._store.appendData(o);
          this._doInit(n3[0], n3[1]);
        }, u.prototype.appendValues = function(o, n3) {
          var p2 = this._store.appendValues(o, n3.length), m2 = p2.start, w2 = p2.end, T2 = this._shouldMakeIdFromName();
          if (this._updateOrdinalMeta(), n3)
            for (var E = m2; E < w2; E++) {
              var O2 = E - m2;
              this._nameList[E] = n3[O2], T2 && e9t(this, E);
            }
        }, u.prototype._updateOrdinalMeta = function() {
          for (var o = this._store, n3 = this.dimensions, p2 = 0; p2 < n3.length; p2++) {
            var m2 = this._dimInfos[n3[p2]];
            m2.ordinalMeta && o.collectOrdinalMeta(m2.storeDimIndex, m2.ordinalMeta);
          }
        }, u.prototype._shouldMakeIdFromName = function() {
          var o = this._store.getProvider();
          return this._idDimIdx == null && o.getSource().sourceFormat !== a8 && !o.fillStorage;
        }, u.prototype._doInit = function(o, n3) {
          if (!(o >= n3)) {
            var p2 = this._store, m2 = p2.getProvider();
            this._updateOrdinalMeta();
            var w2 = this._nameList, T2 = this._idList, E = m2.getSource().sourceFormat, O2 = E === fI;
            if (O2 && !m2.pure)
              for (var V3 = [], W3 = o; W3 < n3; W3++) {
                var q3 = m2.getItem(W3, V3);
                if (!this.hasItemOption && bbt(q3) && (this.hasItemOption = true), q3) {
                  var K = q3.name;
                  w2[W3] == null && K != null && (w2[W3] = $d2(K, null));
                  var J = q3.id;
                  T2[W3] == null && J != null && (T2[W3] = $d2(J, null));
                }
              }
            if (this._shouldMakeIdFromName())
              for (var W3 = o; W3 < n3; W3++)
                e9t(this, W3);
            sme(this);
          }
        }, u.prototype.getApproximateExtent = function(o) {
          return this._approximateExtent[o] || this._store.getDataExtent(this._getStoreDimIndex(o));
        }, u.prototype.setApproximateExtent = function(o, n3) {
          n3 = this.getDimension(n3), this._approximateExtent[n3] = o.slice();
        }, u.prototype.getCalculationInfo = function(o) {
          return this._calculationInfo[o];
        }, u.prototype.setCalculationInfo = function(o, n3) {
          Got(o) ? ua2(this._calculationInfo, o) : this._calculationInfo[o] = n3;
        }, u.prototype.getName = function(o) {
          var n3 = this.getRawIndex(o), p2 = this._nameList[n3];
          return p2 == null && this._nameDimIdx != null && (p2 = Hot(this, this._nameDimIdx, n3)), p2 == null && (p2 = ""), p2;
        }, u.prototype._getCategory = function(o, n3) {
          var p2 = this._store.get(o, n3), m2 = this._store.getOrdinalMeta(o);
          return m2 ? m2.categories[p2] : p2;
        }, u.prototype.getId = function(o) {
          return sxt(this, this.getRawIndex(o));
        }, u.prototype.count = function() {
          return this._store.count();
        }, u.prototype.get = function(o, n3) {
          var p2 = this._store, m2 = this._dimInfos[o];
          if (m2)
            return p2.get(m2.storeDimIndex, n3);
        }, u.prototype.getByRawIndex = function(o, n3) {
          var p2 = this._store, m2 = this._dimInfos[o];
          if (m2)
            return p2.getByRawIndex(m2.storeDimIndex, n3);
        }, u.prototype.getIndices = function() {
          return this._store.getIndices();
        }, u.prototype.getDataExtent = function(o) {
          return this._store.getDataExtent(this._getStoreDimIndex(o));
        }, u.prototype.getSum = function(o) {
          return this._store.getSum(this._getStoreDimIndex(o));
        }, u.prototype.getMedian = function(o) {
          return this._store.getMedian(this._getStoreDimIndex(o));
        }, u.prototype.getValues = function(o, n3) {
          var p2 = this, m2 = this._store;
          return za2(o) ? m2.getValues(u8(o, function(w2) {
            return p2._getStoreDimIndex(w2);
          }), n3) : m2.getValues(o);
        }, u.prototype.hasValue = function(o) {
          for (var n3 = this._dimSummary.dataDimIndicesOnCoord, p2 = 0, m2 = n3.length; p2 < m2; p2++)
            if (isNaN(this._store.get(n3[p2], o)))
              return false;
          return true;
        }, u.prototype.indexOfName = function(o) {
          for (var n3 = 0, p2 = this._store.count(); n3 < p2; n3++)
            if (this.getName(n3) === o)
              return n3;
          return -1;
        }, u.prototype.getRawIndex = function(o) {
          return this._store.getRawIndex(o);
        }, u.prototype.indexOfRawIndex = function(o) {
          return this._store.indexOfRawIndex(o);
        }, u.prototype.rawIndexOf = function(o, n3) {
          var p2 = o && this._invertedIndicesMap[o], m2 = p2[n3];
          return m2 == null || isNaN(m2) ? ome : m2;
        }, u.prototype.indicesOfNearest = function(o, n3, p2) {
          return this._store.indicesOfNearest(this._getStoreDimIndex(o), n3, p2);
        }, u.prototype.each = function(o, n3, p2) {
          Sl(o) && (p2 = n3, n3 = o, o = []);
          var m2 = p2 || this, w2 = u8(Uot(o), this._getStoreDimIndex, this);
          this._store.each(w2, m2 ? Is(n3, m2) : n3);
        }, u.prototype.filterSelf = function(o, n3, p2) {
          Sl(o) && (p2 = n3, n3 = o, o = []);
          var m2 = p2 || this, w2 = u8(Uot(o), this._getStoreDimIndex, this);
          return this._store = this._store.filter(w2, m2 ? Is(n3, m2) : n3), this;
        }, u.prototype.selectRange = function(o) {
          var n3 = this, p2 = {}, m2 = tf2(o);
          return Xe2(m2, function(w2) {
            var T2 = n3._getStoreDimIndex(w2);
            p2[T2] = o[w2];
          }), this._store = this._store.selectRange(p2), this;
        }, u.prototype.mapArray = function(o, n3, p2) {
          Sl(o) && (p2 = n3, n3 = o, o = []), p2 = p2 || this;
          var m2 = [];
          return this.each(o, function() {
            m2.push(n3 && n3.apply(this, arguments));
          }, p2), m2;
        }, u.prototype.map = function(o, n3, p2, m2) {
          var w2 = p2 || m2 || this, T2 = u8(Uot(o), this._getStoreDimIndex, this), E = lxt(this);
          return E._store = this._store.map(T2, w2 ? Is(n3, w2) : n3), E;
        }, u.prototype.modify = function(o, n3, p2, m2) {
          var w2 = p2 || m2 || this, T2 = u8(Uot(o), this._getStoreDimIndex, this);
          this._store.modify(T2, w2 ? Is(n3, w2) : n3);
        }, u.prototype.downSample = function(o, n3, p2, m2) {
          var w2 = lxt(this);
          return w2._store = this._store.downSample(this._getStoreDimIndex(o), n3, p2, m2), w2;
        }, u.prototype.lttbDownSample = function(o, n3) {
          var p2 = lxt(this);
          return p2._store = this._store.lttbDownSample(this._getStoreDimIndex(o), n3), p2;
        }, u.prototype.getRawDataItem = function(o) {
          return this._store.getRawDataItem(o);
        }, u.prototype.getItemModel = function(o) {
          var n3 = this.hostModel, p2 = this.getRawDataItem(o);
          return new _g(p2, n3, n3 && n3.ecModel);
        }, u.prototype.diff = function(o) {
          var n3 = this;
          return new C4(o ? o.getStore().getIndices() : [], this.getStore().getIndices(), function(p2) {
            return sxt(o, p2);
          }, function(p2) {
            return sxt(n3, p2);
          });
        }, u.prototype.getVisual = function(o) {
          var n3 = this._visual;
          return n3 && n3[o];
        }, u.prototype.setVisual = function(o, n3) {
          this._visual = this._visual || {}, Got(o) ? ua2(this._visual, o) : this._visual[o] = n3;
        }, u.prototype.getItemVisual = function(o, n3) {
          var p2 = this._itemVisuals[o], m2 = p2 && p2[n3];
          return m2 == null ? this.getVisual(n3) : m2;
        }, u.prototype.hasItemVisual = function() {
          return this._itemVisuals.length > 0;
        }, u.prototype.ensureUniqueItemVisual = function(o, n3) {
          var p2 = this._itemVisuals, m2 = p2[o];
          m2 || (m2 = p2[o] = {});
          var w2 = m2[n3];
          return w2 == null && (w2 = this.getVisual(n3), za2(w2) ? w2 = w2.slice() : Got(w2) && (w2 = ua2({}, w2)), m2[n3] = w2), w2;
        }, u.prototype.setItemVisual = function(o, n3, p2) {
          var m2 = this._itemVisuals[o] || {};
          this._itemVisuals[o] = m2, Got(n3) ? ua2(m2, n3) : m2[n3] = p2;
        }, u.prototype.clearAllVisual = function() {
          this._visual = {}, this._itemVisuals = [];
        }, u.prototype.setLayout = function(o, n3) {
          Got(o) ? ua2(this._layout, o) : this._layout[o] = n3;
        }, u.prototype.getLayout = function(o) {
          return this._layout[o];
        }, u.prototype.getItemLayout = function(o) {
          return this._itemLayouts[o];
        }, u.prototype.setItemLayout = function(o, n3, p2) {
          this._itemLayouts[o] = p2 ? ua2(this._itemLayouts[o] || {}, n3) : n3;
        }, u.prototype.clearItemLayouts = function() {
          this._itemLayouts.length = 0;
        }, u.prototype.setItemGraphicEl = function(o, n3) {
          var p2 = this.hostModel && this.hostModel.seriesIndex;
          qat(p2, this.dataType, o, n3), this._graphicEls[o] = n3;
        }, u.prototype.getItemGraphicEl = function(o) {
          return this._graphicEls[o];
        }, u.prototype.eachItemGraphicEl = function(o, n3) {
          Xe2(this._graphicEls, function(p2, m2) {
            p2 && o && o.call(n3, p2, m2);
          });
        }, u.prototype.cloneShallow = function(o) {
          return o || (o = new u(this._schema ? this._schema : u8(this.dimensions, this._getDimInfo, this), this.hostModel)), t9t(o, this), o._store = this._store, o;
        }, u.prototype.wrapMethod = function(o, n3) {
          var p2 = this[o];
          !Sl(p2) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(o), this[o] = function() {
            var m2 = p2.apply(this, arguments);
            return n3.apply(this, [m2].concat(zB(arguments)));
          });
        }, u.internalField = function() {
          sme = function(o) {
            var n3 = o._invertedIndicesMap;
            Xe2(n3, function(p2, m2) {
              var w2 = o._dimInfos[m2], T2 = w2.ordinalMeta, E = o._store;
              if (T2) {
                p2 = n3[m2] = new vbn(T2.categories.length);
                for (var O2 = 0; O2 < p2.length; O2++)
                  p2[O2] = ome;
                for (var O2 = 0; O2 < E.count(); O2++)
                  p2[E.get(w2.storeDimIndex, O2)] = O2;
              }
            });
          }, Hot = function(o, n3, p2) {
            return $d2(o._getCategory(n3, p2), null);
          }, sxt = function(o, n3) {
            var p2 = o._idList[n3];
            return p2 == null && o._idDimIdx != null && (p2 = Hot(o, o._idDimIdx, n3)), p2 == null && (p2 = ybn + n3), p2;
          }, Uot = function(o) {
            return za2(o) || (o = o != null ? [o] : []), o;
          }, lxt = function(o) {
            var n3 = new u(o._schema ? o._schema : u8(o.dimensions, o._getDimInfo, o), o.hostModel);
            return t9t(n3, o), n3;
          }, t9t = function(o, n3) {
            Xe2(mbn.concat(n3.__wrappedMethods || []), function(p2) {
              n3.hasOwnProperty(p2) && (o[p2] = n3[p2]);
            }), o.__wrappedMethods = n3.__wrappedMethods, Xe2(bbn, function(p2) {
              o[p2] = jl(n3[p2]);
            }), o._calculationInfo = ua2({}, n3._calculationInfo);
          }, e9t = function(o, n3) {
            var p2 = o._nameList, m2 = o._idList, w2 = o._nameDimIdx, T2 = o._idDimIdx, E = p2[n3], O2 = m2[n3];
            if (E == null && w2 != null && (p2[n3] = E = Hot(o, w2, n3)), O2 == null && T2 != null && (m2[n3] = O2 = Hot(o, T2, n3)), O2 == null && E != null) {
              var V3 = o._nameRepeatCount, W3 = V3[E] = (V3[E] || 0) + 1;
              O2 = E, W3 > 1 && (O2 += "__ec__" + W3), m2[n3] = O2;
            }
          };
        }(), u;
      }(), o2 = _bn;
      function qot(u, o) {
        v8t(u) || (u = m8t(u)), o = o || {};
        var n3 = o.coordDimensions || [], p2 = o.dimensionsDefine || u.dimensionsDefine || [], m2 = pl(), w2 = [], T2 = wbn(u, n3, p2, o.dimensionsCount), E = o.canOmitUnusedDimensions && ame(T2), O2 = p2 === u.dimensionsDefine, V3 = O2 ? ime(u) : rme(p2), W3 = o.encodeDefine;
        !W3 && o.encodeDefaulter && (W3 = o.encodeDefaulter(u, T2));
        for (var q3 = pl(W3), K = new T0e(T2), J = 0; J < K.length; J++)
          K[J] = -1;
        function rt2(Ce2) {
          var Le2 = K[Ce2];
          if (Le2 < 0) {
            var ze = p2[Ce2], tn = ys(ze) ? ze : { name: ze }, $e2 = new oxt(), Tn = tn.name;
            Tn != null && V3.get(Tn) != null && ($e2.name = $e2.displayName = Tn), tn.type != null && ($e2.type = tn.type), tn.displayName != null && ($e2.displayName = tn.displayName);
            var zn = w2.length;
            return K[Ce2] = zn, $e2.storeDimIndex = Ce2, w2.push($e2), $e2;
          }
          return w2[Le2];
        }
        if (!E)
          for (var J = 0; J < T2; J++)
            rt2(J);
        q3.each(function(Ce2, Le2) {
          var ze = Tp(Ce2).slice();
          if (ze.length === 1 && !ds(ze[0]) && ze[0] < 0) {
            q3.set(Le2, false);
            return;
          }
          var tn = q3.set(Le2, []);
          Xe2(ze, function($e2, Tn) {
            var zn = ds($e2) ? V3.get($e2) : $e2;
            zn != null && zn < T2 && (tn[Tn] = zn, yt(rt2(zn), Le2, Tn));
          });
        });
        var gt = 0;
        Xe2(n3, function(Ce2) {
          var Le2, ze, tn, $e2;
          if (ds(Ce2))
            Le2 = Ce2, $e2 = {};
          else {
            $e2 = Ce2, Le2 = $e2.name;
            var Tn = $e2.ordinalMeta;
            $e2.ordinalMeta = null, $e2 = ua2({}, $e2), $e2.ordinalMeta = Tn, ze = $e2.dimsDef, tn = $e2.otherDims, $e2.name = $e2.coordDim = $e2.coordDimIndex = $e2.dimsDef = $e2.otherDims = null;
          }
          var zn = q3.get(Le2);
          if (zn !== false) {
            if (zn = Tp(zn), !zn.length)
              for (var bn = 0; bn < (ze && ze.length || 1); bn++) {
                for (; gt < T2 && rt2(gt).coordDim != null; )
                  gt++;
                gt < T2 && zn.push(gt++);
              }
            Xe2(zn, function(Xr, Xn) {
              var or = rt2(Xr);
              if (O2 && $e2.type != null && (or.type = $e2.type), yt(kl(or, $e2), Le2, Xn), or.name == null && ze) {
                var Tr = ze[Xn];
                !ys(Tr) && (Tr = { name: Tr }), or.name = or.displayName = Tr.name, or.defaultTooltip = Tr.defaultTooltip;
              }
              tn && kl(or.otherDims, tn);
            });
          }
        });
        function yt(Ce2, Le2, ze) {
          Bve.get(Le2) != null ? Ce2.otherDims[Le2] = ze : (Ce2.coordDim = Le2, Ce2.coordDimIndex = ze, m2.set(Le2, true));
        }
        var At = o.generateCoord, Lt = o.generateCoordCount, Wt = Lt != null;
        Lt = At ? Lt || 1 : 0;
        var Nt = At || "value";
        function ue2(Ce2) {
          Ce2.name == null && (Ce2.name = Ce2.coordDim);
        }
        if (E)
          Xe2(w2, function(Ce2) {
            ue2(Ce2);
          }), w2.sort(function(Ce2, Le2) {
            return Ce2.storeDimIndex - Le2.storeDimIndex;
          });
        else
          for (var ie2 = 0; ie2 < T2; ie2++) {
            var pe2 = rt2(ie2), xe = pe2.coordDim;
            xe == null && (pe2.coordDim = Sbn(Nt, m2, Wt), pe2.coordDimIndex = 0, (!At || Lt <= 0) && (pe2.isExtraCoord = true), Lt--), ue2(pe2), pe2.type == null && (Gve(u, ie2) === rx.Must || pe2.isExtraCoord && (pe2.otherDims.itemName != null || pe2.otherDims.seriesName != null)) && (pe2.type = "ordinal");
          }
        return xbn(w2), new eme({ source: u, dimensions: w2, fullDimensionCount: T2, dimensionOmitted: E });
      }
      function xbn(u) {
        for (var o = pl(), n3 = 0; n3 < u.length; n3++) {
          var p2 = u[n3], m2 = p2.name, w2 = o.get(m2) || 0;
          w2 > 0 && (p2.name = m2 + (w2 - 1)), w2++, o.set(m2, w2);
        }
      }
      function wbn(u, o, n3, p2) {
        var m2 = Math.max(u.dimensionsDetectedCount || 1, o.length, n3.length, p2 || 0);
        return Xe2(o, function(w2) {
          var T2;
          ys(w2) && (T2 = w2.dimsDef) && (m2 = Math.max(m2, T2.length));
        }), m2;
      }
      function Sbn(u, o, n3) {
        var p2 = o.data;
        if (n3 || p2.hasOwnProperty(u)) {
          for (var m2 = 0; p2.hasOwnProperty(u + m2); )
            m2++;
          u += m2;
        }
        return o.set(u, true), u;
      }
      var Mbn = function() {
        function u(o) {
          this.coordSysDims = [], this.axisMap = pl(), this.categoryAxisMap = pl(), this.coordSysName = o;
        }
        return u;
      }();
      function Cbn(u) {
        var o = u.get("coordinateSystem"), n3 = new Mbn(o), p2 = Tbn[o];
        if (p2)
          return p2(u, n3, n3.axisMap, n3.categoryAxisMap), n3;
      }
      var Tbn = { cartesian2d: function(u, o, n3, p2) {
        var m2 = u.getReferringComponents("xAxis", Y0).models[0], w2 = u.getReferringComponents("yAxis", Y0).models[0];
        o.coordSysDims = ["x", "y"], n3.set("x", m2), n3.set("y", w2), lY(m2) && (p2.set("x", m2), o.firstCategoryDimIndex = 0), lY(w2) && (p2.set("y", w2), o.firstCategoryDimIndex == null && (o.firstCategoryDimIndex = 1));
      }, singleAxis: function(u, o, n3, p2) {
        var m2 = u.getReferringComponents("singleAxis", Y0).models[0];
        o.coordSysDims = ["single"], n3.set("single", m2), lY(m2) && (p2.set("single", m2), o.firstCategoryDimIndex = 0);
      }, polar: function(u, o, n3, p2) {
        var m2 = u.getReferringComponents("polar", Y0).models[0], w2 = m2.findAxisModel("radiusAxis"), T2 = m2.findAxisModel("angleAxis");
        o.coordSysDims = ["radius", "angle"], n3.set("radius", w2), n3.set("angle", T2), lY(w2) && (p2.set("radius", w2), o.firstCategoryDimIndex = 0), lY(T2) && (p2.set("angle", T2), o.firstCategoryDimIndex == null && (o.firstCategoryDimIndex = 1));
      }, geo: function(u, o, n3, p2) {
        o.coordSysDims = ["lng", "lat"];
      }, parallel: function(u, o, n3, p2) {
        var m2 = u.ecModel, w2 = m2.getComponent("parallel", u.get("parallelIndex")), T2 = o.coordSysDims = w2.dimensions.slice();
        Xe2(w2.parallelAxisIndex, function(E, O2) {
          var V3 = m2.getComponent("parallelAxis", E), W3 = T2[O2];
          n3.set(W3, V3), lY(V3) && (p2.set(W3, V3), o.firstCategoryDimIndex == null && (o.firstCategoryDimIndex = O2));
        });
      } };
      function lY(u) {
        return u.get("type") === "category";
      }
      function Abn(u, o, n3) {
        n3 = n3 || {};
        var p2 = n3.byIndex, m2 = n3.stackedCoordDimension, w2, T2, E;
        Ibn(o) ? w2 = o : (T2 = o.schema, w2 = T2.dimensions, E = o.store);
        var O2 = !!(u && u.get("stack")), V3, W3, q3, K;
        if (Xe2(w2, function(Lt, Wt) {
          ds(Lt) && (w2[Wt] = Lt = { name: Lt }), O2 && !Lt.isExtraCoord && (!p2 && !V3 && Lt.ordinalMeta && (V3 = Lt), !W3 && Lt.type !== "ordinal" && Lt.type !== "time" && (!m2 || m2 === Lt.coordDim) && (W3 = Lt));
        }), W3 && !p2 && !V3 && (p2 = true), W3) {
          q3 = "__\0ecstackresult_" + u.id, K = "__\0ecstackedover_" + u.id, V3 && (V3.createInvertedIndices = true);
          var J = W3.coordDim, rt2 = W3.type, gt = 0;
          Xe2(w2, function(Lt) {
            Lt.coordDim === J && gt++;
          });
          var yt = { name: q3, coordDim: J, coordDimIndex: gt, type: rt2, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: w2.length }, At = { name: K, coordDim: K, coordDimIndex: gt + 1, type: rt2, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: w2.length + 1 };
          T2 ? (E && (yt.storeDimIndex = E.ensureCalculationDimension(K, rt2), At.storeDimIndex = E.ensureCalculationDimension(q3, rt2)), T2.appendCalculationDimension(yt), T2.appendCalculationDimension(At)) : (w2.push(yt), w2.push(At));
        }
        return { stackedDimension: W3 && W3.name, stackedByDimension: V3 && V3.name, isStackedByIndex: p2, stackedOverDimension: K, stackResultDimension: q3 };
      }
      function Ibn(u) {
        return !nme(u.schema);
      }
      function c8(u, o) {
        return !!o && o === u.getCalculationInfo("stackedDimension");
      }
      function lme(u, o) {
        return c8(u, o) ? u.getCalculationInfo("stackResultDimension") : o;
      }
      function Dbn(u, o) {
        var n3 = u.get("coordinateSystem"), p2 = Cot.get(n3), m2;
        return o && o.coordSysDims && (m2 = Ya2(o.coordSysDims, function(w2) {
          var T2 = { name: w2 }, E = o.axisMap.get(w2);
          if (E) {
            var O2 = E.get("type");
            T2.type = axt(O2);
          }
          return T2;
        })), m2 || (m2 = p2 && (p2.getDimensionsInfo ? p2.getDimensionsInfo() : p2.dimensions.slice()) || ["x", "y"]), m2;
      }
      function Ebn(u, o, n3) {
        var p2, m2;
        return n3 && Xe2(u, function(w2, T2) {
          var E = w2.coordDim, O2 = n3.categoryAxisMap.get(E);
          O2 && (p2 == null && (p2 = T2), w2.ordinalMeta = O2.getOrdinalMeta(), o && (w2.createInvertedIndices = true)), w2.otherDims.itemName != null && (m2 = true);
        }), !m2 && p2 != null && (u[p2].otherDims.itemName = 0), p2;
      }
      function T4(u, o, n3) {
        n3 = n3 || {};
        var p2 = o.getSourceManager(), m2, w2 = false;
        u ? (w2 = true, m2 = m8t(u)) : (m2 = p2.getSource(), w2 = m2.sourceFormat === fI);
        var T2 = Cbn(o), E = Dbn(o, T2), O2 = n3.useEncodeDefaulter, V3 = Sl(O2) ? O2 : O2 ? wu(Wve, E, o) : null, W3 = { coordDimensions: E, generateCoord: n3.generateCoord, encodeDefine: o.getEncode(), encodeDefaulter: V3, canOmitUnusedDimensions: !w2 }, q3 = qot(m2, W3), K = Ebn(q3.dimensions, n3.createInvertedIndices, T2), J = w2 ? null : p2.getSharedDataStore(q3), rt2 = Abn(o, { schema: q3, store: J }), gt = new o2(q3, o);
        gt.setCalculationInfo(rt2);
        var yt = K != null && kbn(m2) ? function(At, Lt, Wt, Nt) {
          return Nt === K ? Wt : this.defaultDimValueGetter(At, Lt, Wt, Nt);
        } : null;
        return gt.hasItemOption = false, gt.initData(w2 ? m2 : J, null, yt), gt;
      }
      function kbn(u) {
        if (u.sourceFormat === fI) {
          var o = Pbn(u.data || []);
          return !za2(PP(o));
        }
      }
      function Pbn(u) {
        for (var o = 0; o < u.length && u[o] == null; )
          o++;
        return u[o];
      }
      var ume = function() {
        function u(o) {
          this._setting = o || {}, this._extent = [1 / 0, -1 / 0];
        }
        return u.prototype.getSetting = function(o) {
          return this._setting[o];
        }, u.prototype.unionExtent = function(o) {
          var n3 = this._extent;
          o[0] < n3[0] && (n3[0] = o[0]), o[1] > n3[1] && (n3[1] = o[1]);
        }, u.prototype.unionExtentFromData = function(o, n3) {
          this.unionExtent(o.getApproximateExtent(n3));
        }, u.prototype.getExtent = function() {
          return this._extent.slice();
        }, u.prototype.setExtent = function(o, n3) {
          var p2 = this._extent;
          isNaN(o) || (p2[0] = o), isNaN(n3) || (p2[1] = n3);
        }, u.prototype.isInExtentRange = function(o) {
          return this._extent[0] <= o && this._extent[1] >= o;
        }, u.prototype.isBlank = function() {
          return this._isBlank;
        }, u.prototype.setBlank = function(o) {
          this._isBlank = o;
        }, u;
      }();
      v$(ume);
      var A4 = ume, Lbn = 0, Obn = function() {
        function u(o) {
          this.categories = o.categories || [], this._needCollect = o.needCollect, this._deduplication = o.deduplication, this.uid = ++Lbn;
        }
        return u.createByAxisModel = function(o) {
          var n3 = o.option, p2 = n3.data, m2 = p2 && Ya2(p2, Rbn);
          return new u({ categories: m2, needCollect: !m2, deduplication: n3.dedplication !== false });
        }, u.prototype.getOrdinal = function(o) {
          return this._getOrCreateMap().get(o);
        }, u.prototype.parseAndCollect = function(o) {
          var n3, p2 = this._needCollect;
          if (!ds(o) && !p2)
            return o;
          if (p2 && !this._deduplication)
            return n3 = this.categories.length, this.categories[n3] = o, n3;
          var m2 = this._getOrCreateMap();
          return n3 = m2.get(o), n3 == null && (p2 ? (n3 = this.categories.length, this.categories[n3] = o, m2.set(o, n3)) : n3 = NaN), n3;
        }, u.prototype._getOrCreateMap = function() {
          return this._map || (this._map = pl(this.categories));
        }, u;
      }();
      function Rbn(u) {
        return ys(u) && u.value != null ? u.value : u + "";
      }
      var n9t = Obn;
      function r9t(u) {
        return u.type === "interval" || u.type === "log";
      }
      function Nbn(u, o, n3, p2) {
        var m2 = {}, w2 = u[1] - u[0], T2 = m2.interval = vbt(w2 / o, true);
        n3 != null && T2 < n3 && (T2 = m2.interval = n3), p2 != null && T2 > p2 && (T2 = m2.interval = p2);
        var E = m2.intervalPrecision = cme(T2), O2 = m2.niceTickExtent = [Ov(Math.ceil(u[0] / T2) * T2, E), Ov(Math.floor(u[1] / T2) * T2, E)];
        return Fbn(O2, u), m2;
      }
      function i9t(u) {
        var o = Math.pow(10, c$(u)), n3 = u / o;
        return n3 ? n3 === 2 ? n3 = 3 : n3 === 3 ? n3 = 5 : n3 *= 2 : n3 = 1, Ov(n3 * o);
      }
      function cme(u) {
        return oM(u) + 2;
      }
      function fme(u, o, n3) {
        u[o] = Math.max(Math.min(u[o], n3[1]), n3[0]);
      }
      function Fbn(u, o) {
        !isFinite(u[0]) && (u[0] = o[0]), !isFinite(u[1]) && (u[1] = o[1]), fme(u, 0, o), fme(u, 1, o), u[0] > u[1] && (u[0] = u[1]);
      }
      function uxt(u, o) {
        return u >= o[0] && u <= o[1];
      }
      function cxt(u, o) {
        return o[1] === o[0] ? 0.5 : (u - o[0]) / (o[1] - o[0]);
      }
      function fxt(u, o) {
        return u * (o[1] - o[0]) + o[0];
      }
      var hme = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          p2.type = "ordinal";
          var m2 = p2.getSetting("ordinalMeta");
          return m2 || (m2 = new n9t({})), za2(m2) && (m2 = new n9t({ categories: Ya2(m2, function(w2) {
            return ys(w2) ? w2.value : w2;
          }) })), p2._ordinalMeta = m2, p2._extent = p2.getSetting("extent") || [0, m2.categories.length - 1], p2;
        }
        return o.prototype.parse = function(n3) {
          return ds(n3) ? this._ordinalMeta.getOrdinal(n3) : Math.round(n3);
        }, o.prototype.contain = function(n3) {
          return n3 = this.parse(n3), uxt(n3, this._extent) && this._ordinalMeta.categories[n3] != null;
        }, o.prototype.normalize = function(n3) {
          return n3 = this._getTickNumber(this.parse(n3)), cxt(n3, this._extent);
        }, o.prototype.scale = function(n3) {
          return n3 = Math.round(fxt(n3, this._extent)), this.getRawOrdinalNumber(n3);
        }, o.prototype.getTicks = function() {
          for (var n3 = [], p2 = this._extent, m2 = p2[0]; m2 <= p2[1]; )
            n3.push({ value: m2 }), m2++;
          return n3;
        }, o.prototype.getMinorTicks = function(n3) {
        }, o.prototype.setSortInfo = function(n3) {
          if (n3 == null) {
            this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
            return;
          }
          for (var p2 = n3.ordinalNumbers, m2 = this._ordinalNumbersByTick = [], w2 = this._ticksByOrdinalNumber = [], T2 = 0, E = this._ordinalMeta.categories.length, O2 = Math.min(E, p2.length); T2 < O2; ++T2) {
            var V3 = p2[T2];
            m2[T2] = V3, w2[V3] = T2;
          }
          for (var W3 = 0; T2 < E; ++T2) {
            for (; w2[W3] != null; )
              W3++;
            m2.push(W3), w2[W3] = T2;
          }
        }, o.prototype._getTickNumber = function(n3) {
          var p2 = this._ticksByOrdinalNumber;
          return p2 && n3 >= 0 && n3 < p2.length ? p2[n3] : n3;
        }, o.prototype.getRawOrdinalNumber = function(n3) {
          var p2 = this._ordinalNumbersByTick;
          return p2 && n3 >= 0 && n3 < p2.length ? p2[n3] : n3;
        }, o.prototype.getLabel = function(n3) {
          if (!this.isBlank()) {
            var p2 = this.getRawOrdinalNumber(n3.value), m2 = this._ordinalMeta.categories[p2];
            return m2 == null ? "" : m2 + "";
          }
        }, o.prototype.count = function() {
          return this._extent[1] - this._extent[0] + 1;
        }, o.prototype.unionExtentFromData = function(n3, p2) {
          this.unionExtent(n3.getApproximateExtent(p2));
        }, o.prototype.isInExtentRange = function(n3) {
          return n3 = this._getTickNumber(n3), this._extent[0] <= n3 && this._extent[1] >= n3;
        }, o.prototype.getOrdinalMeta = function() {
          return this._ordinalMeta;
        }, o.prototype.calcNiceTicks = function() {
        }, o.prototype.calcNiceExtent = function() {
        }, o.type = "ordinal", o;
      }(A4);
      A4.registerClass(hme);
      var a9t = hme, Nz = Ov, pme = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "interval", n3._interval = 0, n3._intervalPrecision = 2, n3;
        }
        return o.prototype.parse = function(n3) {
          return n3;
        }, o.prototype.contain = function(n3) {
          return uxt(n3, this._extent);
        }, o.prototype.normalize = function(n3) {
          return cxt(n3, this._extent);
        }, o.prototype.scale = function(n3) {
          return fxt(n3, this._extent);
        }, o.prototype.setExtent = function(n3, p2) {
          var m2 = this._extent;
          isNaN(n3) || (m2[0] = parseFloat(n3)), isNaN(p2) || (m2[1] = parseFloat(p2));
        }, o.prototype.unionExtent = function(n3) {
          var p2 = this._extent;
          n3[0] < p2[0] && (p2[0] = n3[0]), n3[1] > p2[1] && (p2[1] = n3[1]), this.setExtent(p2[0], p2[1]);
        }, o.prototype.getInterval = function() {
          return this._interval;
        }, o.prototype.setInterval = function(n3) {
          this._interval = n3, this._niceExtent = this._extent.slice(), this._intervalPrecision = cme(n3);
        }, o.prototype.getTicks = function(n3) {
          var p2 = this._interval, m2 = this._extent, w2 = this._niceExtent, T2 = this._intervalPrecision, E = [];
          if (!p2)
            return E;
          var O2 = 1e4;
          m2[0] < w2[0] && (n3 ? E.push({ value: Nz(w2[0] - p2, T2) }) : E.push({ value: m2[0] }));
          for (var V3 = w2[0]; V3 <= w2[1] && (E.push({ value: V3 }), V3 = Nz(V3 + p2, T2), V3 !== E[E.length - 1].value); )
            if (E.length > O2)
              return [];
          var W3 = E.length ? E[E.length - 1].value : w2[1];
          return m2[1] > W3 && (n3 ? E.push({ value: Nz(W3 + p2, T2) }) : E.push({ value: m2[1] })), E;
        }, o.prototype.getMinorTicks = function(n3) {
          for (var p2 = this.getTicks(true), m2 = [], w2 = this.getExtent(), T2 = 1; T2 < p2.length; T2++) {
            for (var E = p2[T2], O2 = p2[T2 - 1], V3 = 0, W3 = [], q3 = E.value - O2.value, K = q3 / n3; V3 < n3 - 1; ) {
              var J = Nz(O2.value + (V3 + 1) * K);
              J > w2[0] && J < w2[1] && W3.push(J), V3++;
            }
            m2.push(W3);
          }
          return m2;
        }, o.prototype.getLabel = function(n3, p2) {
          if (n3 == null)
            return "";
          var m2 = p2 && p2.precision;
          m2 == null ? m2 = oM(n3.value) || 0 : m2 === "auto" && (m2 = this._intervalPrecision);
          var w2 = Nz(n3.value, m2, true);
          return Pve(w2);
        }, o.prototype.calcNiceTicks = function(n3, p2, m2) {
          n3 = n3 || 5;
          var w2 = this._extent, T2 = w2[1] - w2[0];
          if (isFinite(T2)) {
            T2 < 0 && (T2 = -T2, w2.reverse());
            var E = Nbn(w2, n3, p2, m2);
            this._intervalPrecision = E.intervalPrecision, this._interval = E.interval, this._niceExtent = E.niceTickExtent;
          }
        }, o.prototype.calcNiceExtent = function(n3) {
          var p2 = this._extent;
          if (p2[0] === p2[1])
            if (p2[0] !== 0) {
              var m2 = p2[0];
              n3.fixMax || (p2[1] += m2 / 2), p2[0] -= m2 / 2;
            } else
              p2[1] = 1;
          var w2 = p2[1] - p2[0];
          isFinite(w2) || (p2[0] = 0, p2[1] = 1), this.calcNiceTicks(n3.splitNumber, n3.minInterval, n3.maxInterval);
          var T2 = this._interval;
          n3.fixMin || (p2[0] = Nz(Math.floor(p2[0] / T2) * T2)), n3.fixMax || (p2[1] = Nz(Math.ceil(p2[1] / T2) * T2));
        }, o.prototype.setNiceExtent = function(n3, p2) {
          this._niceExtent = [n3, p2];
        }, o.type = "interval", o;
      }(A4);
      A4.registerClass(pme);
      var f8 = pme, dme = typeof Float32Array != "undefined", Vbn = dme ? Float32Array : Array;
      function $P(u) {
        return za2(u) ? dme ? new Float32Array(u) : u : new Vbn(u);
      }
      var o9t = "__ec_stack_";
      function s9t(u) {
        return u.get("stack") || o9t + u.seriesIndex;
      }
      function l9t(u) {
        return u.dim + u.index;
      }
      function Bbn(u) {
        var o = [], n3 = u.axis, p2 = "axis0";
        if (n3.type === "category") {
          for (var m2 = n3.getBandWidth(), w2 = 0; w2 < u.count; w2++)
            o.push(kl({ bandWidth: m2, axisKey: p2, stackId: o9t + w2 }, u));
          for (var T2 = yme(o), E = [], w2 = 0; w2 < u.count; w2++) {
            var O2 = T2[p2][o9t + w2];
            O2.offsetCenter = O2.offset + O2.width / 2, E.push(O2);
          }
          return E;
        }
      }
      function gme(u, o) {
        var n3 = [];
        return o.eachSeriesByType(u, function(p2) {
          _me(p2) && n3.push(p2);
        }), n3;
      }
      function zbn(u) {
        var o = {};
        Xe2(u, function(O2) {
          var V3 = O2.coordinateSystem, W3 = V3.getBaseAxis();
          if (!(W3.type !== "time" && W3.type !== "value"))
            for (var q3 = O2.getData(), K = W3.dim + "_" + W3.index, J = q3.getDimensionIndex(q3.mapDimension(W3.dim)), rt2 = q3.getStore(), gt = 0, yt = rt2.count(); gt < yt; ++gt) {
              var At = rt2.get(J, gt);
              o[K] ? o[K].push(At) : o[K] = [At];
            }
        });
        var n3 = {};
        for (var p2 in o)
          if (o.hasOwnProperty(p2)) {
            var m2 = o[p2];
            if (m2) {
              m2.sort(function(O2, V3) {
                return O2 - V3;
              });
              for (var w2 = null, T2 = 1; T2 < m2.length; ++T2) {
                var E = m2[T2] - m2[T2 - 1];
                E > 0 && (w2 = w2 === null ? E : Math.min(w2, E));
              }
              n3[p2] = w2;
            }
          }
        return n3;
      }
      function vme(u) {
        var o = zbn(u), n3 = [];
        return Xe2(u, function(p2) {
          var m2 = p2.coordinateSystem, w2 = m2.getBaseAxis(), T2 = w2.getExtent(), E;
          if (w2.type === "category")
            E = w2.getBandWidth();
          else if (w2.type === "value" || w2.type === "time") {
            var O2 = w2.dim + "_" + w2.index, V3 = o[O2], W3 = Math.abs(T2[1] - T2[0]), q3 = w2.scale.getExtent(), K = Math.abs(q3[1] - q3[0]);
            E = V3 ? W3 / K * V3 : W3;
          } else {
            var J = p2.getData();
            E = Math.abs(T2[1] - T2[0]) / J.count();
          }
          var rt2 = Qo(p2.get("barWidth"), E), gt = Qo(p2.get("barMaxWidth"), E), yt = Qo(p2.get("barMinWidth") || (xme(p2) ? 0.5 : 1), E), At = p2.get("barGap"), Lt = p2.get("barCategoryGap");
          n3.push({ bandWidth: E, barWidth: rt2, barMaxWidth: gt, barMinWidth: yt, barGap: At, barCategoryGap: Lt, axisKey: l9t(w2), stackId: s9t(p2) });
        }), yme(n3);
      }
      function yme(u) {
        var o = {};
        Xe2(u, function(p2, m2) {
          var w2 = p2.axisKey, T2 = p2.bandWidth, E = o[w2] || { bandWidth: T2, remainedWidth: T2, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, O2 = E.stacks;
          o[w2] = E;
          var V3 = p2.stackId;
          O2[V3] || E.autoWidthCount++, O2[V3] = O2[V3] || { width: 0, maxWidth: 0 };
          var W3 = p2.barWidth;
          W3 && !O2[V3].width && (O2[V3].width = W3, W3 = Math.min(E.remainedWidth, W3), E.remainedWidth -= W3);
          var q3 = p2.barMaxWidth;
          q3 && (O2[V3].maxWidth = q3);
          var K = p2.barMinWidth;
          K && (O2[V3].minWidth = K);
          var J = p2.barGap;
          J != null && (E.gap = J);
          var rt2 = p2.barCategoryGap;
          rt2 != null && (E.categoryGap = rt2);
        });
        var n3 = {};
        return Xe2(o, function(p2, m2) {
          n3[m2] = {};
          var w2 = p2.stacks, T2 = p2.bandWidth, E = p2.categoryGap;
          if (E == null) {
            var O2 = tf2(w2).length;
            E = Math.max(35 - O2 * 4, 15) + "%";
          }
          var V3 = Qo(E, T2), W3 = Qo(p2.gap, 1), q3 = p2.remainedWidth, K = p2.autoWidthCount, J = (q3 - V3) / (K + (K - 1) * W3);
          J = Math.max(J, 0), Xe2(w2, function(At) {
            var Lt = At.maxWidth, Wt = At.minWidth;
            if (At.width) {
              var Nt = At.width;
              Lt && (Nt = Math.min(Nt, Lt)), Wt && (Nt = Math.max(Nt, Wt)), At.width = Nt, q3 -= Nt + W3 * Nt, K--;
            } else {
              var Nt = J;
              Lt && Lt < Nt && (Nt = Math.min(Lt, q3)), Wt && Wt > Nt && (Nt = Wt), Nt !== J && (At.width = Nt, q3 -= Nt + W3 * Nt, K--);
            }
          }), J = (q3 - V3) / (K + (K - 1) * W3), J = Math.max(J, 0);
          var rt2 = 0, gt;
          Xe2(w2, function(At, Lt) {
            At.width || (At.width = J), gt = At, rt2 += At.width * (1 + W3);
          }), gt && (rt2 -= gt.width * W3);
          var yt = -rt2 / 2;
          Xe2(w2, function(At, Lt) {
            n3[m2][Lt] = n3[m2][Lt] || { bandWidth: T2, offset: yt, width: At.width }, yt += At.width * (1 + W3);
          });
        }), n3;
      }
      function jbn(u, o, n3) {
        if (u && o) {
          var p2 = u[l9t(o)];
          return p2 != null && n3 != null ? p2[s9t(n3)] : p2;
        }
      }
      function mme(u, o) {
        var n3 = gme(u, o), p2 = vme(n3);
        Xe2(n3, function(m2) {
          var w2 = m2.getData(), T2 = m2.coordinateSystem, E = T2.getBaseAxis(), O2 = s9t(m2), V3 = p2[l9t(E)][O2], W3 = V3.offset, q3 = V3.width;
          w2.setLayout({ bandWidth: V3.bandWidth, offset: W3, size: q3 });
        });
      }
      function bme(u) {
        return { seriesType: u, plan: eY(), reset: function(o) {
          if (_me(o)) {
            var n3 = o.getData(), p2 = o.coordinateSystem, m2 = p2.getBaseAxis(), w2 = p2.getOtherAxis(m2), T2 = n3.getDimensionIndex(n3.mapDimension(w2.dim)), E = n3.getDimensionIndex(n3.mapDimension(m2.dim)), O2 = o.get("showBackground", true), V3 = n3.mapDimension(w2.dim), W3 = n3.getCalculationInfo("stackResultDimension"), q3 = c8(n3, V3) && !!n3.getCalculationInfo("stackedOnSeries"), K = w2.isHorizontal(), J = Wbn(m2, w2), rt2 = xme(o), gt = o.get("barMinHeight") || 0, yt = W3 && n3.getDimensionIndex(W3), At = n3.getLayout("size"), Lt = n3.getLayout("offset");
            return { progress: function(Wt, Nt) {
              for (var ue2 = Wt.count, ie2 = rt2 && $P(ue2 * 3), pe2 = rt2 && O2 && $P(ue2 * 3), xe = rt2 && $P(ue2), Ce2 = p2.master.getRect(), Le2 = K ? Ce2.width : Ce2.height, ze, tn = Nt.getStore(), $e2 = 0; (ze = Wt.next()) != null; ) {
                var Tn = tn.get(q3 ? yt : T2, ze), zn = tn.get(E, ze), bn = J, Xr = void 0;
                q3 && (Xr = +Tn - tn.get(T2, ze));
                var Xn = void 0, or = void 0, Tr = void 0, ci2 = void 0;
                if (K) {
                  var yi2 = p2.dataToPoint([Tn, zn]);
                  if (q3) {
                    var Po = p2.dataToPoint([Xr, zn]);
                    bn = Po[0];
                  }
                  Xn = bn, or = yi2[1] + Lt, Tr = yi2[0] - bn, ci2 = At, Math.abs(Tr) < gt && (Tr = (Tr < 0 ? -1 : 1) * gt);
                } else {
                  var yi2 = p2.dataToPoint([zn, Tn]);
                  if (q3) {
                    var Po = p2.dataToPoint([zn, Xr]);
                    bn = Po[1];
                  }
                  Xn = yi2[0] + Lt, or = bn, Tr = At, ci2 = yi2[1] - bn, Math.abs(ci2) < gt && (ci2 = (ci2 <= 0 ? -1 : 1) * gt);
                }
                rt2 ? (ie2[$e2] = Xn, ie2[$e2 + 1] = or, ie2[$e2 + 2] = K ? Tr : ci2, pe2 && (pe2[$e2] = K ? Ce2.x : Xn, pe2[$e2 + 1] = K ? or : Ce2.y, pe2[$e2 + 2] = Le2), xe[ze] = ze) : Nt.setItemLayout(ze, { x: Xn, y: or, width: Tr, height: ci2 }), $e2 += 3;
              }
              rt2 && Nt.setLayout({ largePoints: ie2, largeDataIndices: xe, largeBackgroundPoints: pe2, valueAxisHorizontal: K });
            } };
          }
        } };
      }
      function _me(u) {
        return u.coordinateSystem && u.coordinateSystem.type === "cartesian2d";
      }
      function xme(u) {
        return u.pipelineContext && u.pipelineContext.large;
      }
      function Wbn(u, o) {
        return o.toGlobalCoord(o.dataToCoord(o.type === "log" ? 1 : 0));
      }
      var Gbn = function(u, o, n3, p2) {
        for (; n3 < p2; ) {
          var m2 = n3 + p2 >>> 1;
          u[m2][1] < o ? n3 = m2 + 1 : p2 = m2;
        }
        return n3;
      }, wme = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "time", p2;
        }
        return o.prototype.getLabel = function(n3) {
          var p2 = this.getSetting("useUTC");
          return k_t(n3.value, wve[cyn(q$(this._minLevelUnit))] || wve.second, p2, this.getSetting("locale"));
        }, o.prototype.getFormattedLabel = function(n3, p2, m2) {
          var w2 = this.getSetting("useUTC"), T2 = this.getSetting("locale");
          return fyn(n3, p2, m2, T2, w2);
        }, o.prototype.getTicks = function() {
          var n3 = this._interval, p2 = this._extent, m2 = [];
          if (!n3)
            return m2;
          m2.push({ value: p2[0], level: 0 });
          var w2 = this.getSetting("useUTC"), T2 = Kbn(this._minLevelUnit, this._approxInterval, w2, p2);
          return m2 = m2.concat(T2), m2.push({ value: p2[1], level: 0 }), m2;
        }, o.prototype.calcNiceExtent = function(n3) {
          var p2 = this._extent;
          if (p2[0] === p2[1] && (p2[0] -= cI, p2[1] += cI), p2[1] === -1 / 0 && p2[0] === 1 / 0) {
            var m2 = new Date();
            p2[1] = +new Date(m2.getFullYear(), m2.getMonth(), m2.getDate()), p2[0] = p2[1] - cI;
          }
          this.calcNiceTicks(n3.splitNumber, n3.minInterval, n3.maxInterval);
        }, o.prototype.calcNiceTicks = function(n3, p2, m2) {
          n3 = n3 || 10;
          var w2 = this._extent, T2 = w2[1] - w2[0];
          this._approxInterval = T2 / n3, p2 != null && this._approxInterval < p2 && (this._approxInterval = p2), m2 != null && this._approxInterval > m2 && (this._approxInterval = m2);
          var E = hxt.length, O2 = Math.min(Gbn(hxt, this._approxInterval, 0, E), E - 1);
          this._interval = hxt[O2][1], this._minLevelUnit = hxt[Math.max(O2 - 1, 0)][0];
        }, o.prototype.parse = function(n3) {
          return Dh2(n3) ? n3 : +Nm(n3);
        }, o.prototype.contain = function(n3) {
          return uxt(this.parse(n3), this._extent);
        }, o.prototype.normalize = function(n3) {
          return cxt(this.parse(n3), this._extent);
        }, o.prototype.scale = function(n3) {
          return fxt(n3, this._extent);
        }, o.type = "time", o;
      }(f8), hxt = [["second", e8t], ["minute", n8t], ["hour", _ot], ["quarter-day", _ot * 6], ["half-day", _ot * 12], ["day", cI * 1.2], ["half-week", cI * 3.5], ["week", cI * 7], ["month", cI * 31], ["quarter", cI * 95], ["half-year", xve / 2], ["year", xve]];
      function Hbn(u, o, n3, p2) {
        var m2 = Nm(o), w2 = Nm(n3), T2 = function(rt2) {
          return Cve(m2, rt2, p2) === Cve(w2, rt2, p2);
        }, E = function() {
          return T2("year");
        }, O2 = function() {
          return E() && T2("month");
        }, V3 = function() {
          return O2() && T2("day");
        }, W3 = function() {
          return V3() && T2("hour");
        }, q3 = function() {
          return W3() && T2("minute");
        }, K = function() {
          return q3() && T2("second");
        }, J = function() {
          return K() && T2("millisecond");
        };
        switch (u) {
          case "year":
            return E();
          case "month":
            return O2();
          case "day":
            return V3();
          case "hour":
            return W3();
          case "minute":
            return q3();
          case "second":
            return K();
          case "millisecond":
            return J();
        }
      }
      function Ubn(u, o) {
        return u /= cI, u > 16 ? 16 : u > 7.5 ? 7 : u > 3.5 ? 4 : u > 1.5 ? 2 : 1;
      }
      function qbn(u) {
        var o = 30 * cI;
        return u /= o, u > 6 ? 6 : u > 3 ? 3 : u > 2 ? 2 : 1;
      }
      function Zbn(u) {
        return u /= _ot, u > 12 ? 12 : u > 6 ? 6 : u > 3.5 ? 4 : u > 2 ? 2 : 1;
      }
      function Sme(u, o) {
        return u /= o ? n8t : e8t, u > 30 ? 30 : u > 20 ? 20 : u > 15 ? 15 : u > 10 ? 10 : u > 5 ? 5 : u > 2 ? 2 : 1;
      }
      function $bn(u) {
        return vbt(u, true);
      }
      function Ybn(u, o, n3) {
        var p2 = new Date(u);
        switch (q$(o)) {
          case "year":
          case "month":
            p2[Tve(n3)](0);
          case "day":
            p2[Ave(n3)](1);
          case "hour":
            p2[Ive(n3)](0);
          case "minute":
            p2[Dve(n3)](0);
          case "second":
            p2[Eve(n3)](0), p2[kve(n3)](0);
        }
        return p2.getTime();
      }
      function Kbn(u, o, n3, p2) {
        var m2 = 1e4, w2 = Sve, T2 = 0;
        function E(Le2, ze, tn, $e2, Tn, zn, bn) {
          for (var Xr = new Date(ze), Xn = ze, or = Xr[$e2](); Xn < tn && Xn <= p2[1]; )
            bn.push({ value: Xn }), or += Le2, Xr[Tn](or), Xn = Xr.getTime();
          bn.push({ value: Xn, notAdd: true });
        }
        function O2(Le2, ze, tn) {
          var $e2 = [], Tn = !ze.length;
          if (!Hbn(q$(Le2), p2[0], p2[1], n3)) {
            Tn && (ze = [{ value: Ybn(new Date(p2[0]), Le2, n3) }, { value: p2[1] }]);
            for (var zn = 0; zn < ze.length - 1; zn++) {
              var bn = ze[zn].value, Xr = ze[zn + 1].value;
              if (bn !== Xr) {
                var Xn = void 0, or = void 0, Tr = void 0, ci2 = false;
                switch (Le2) {
                  case "year":
                    Xn = Math.max(1, Math.round(o / cI / 365)), or = i8t(n3), Tr = hyn(n3);
                    break;
                  case "half-year":
                  case "quarter":
                  case "month":
                    Xn = qbn(o), or = Z$(n3), Tr = Tve(n3);
                    break;
                  case "week":
                  case "half-week":
                  case "day":
                    Xn = Ubn(o), or = P_t(n3), Tr = Ave(n3), ci2 = true;
                    break;
                  case "half-day":
                  case "quarter-day":
                  case "hour":
                    Xn = Zbn(o), or = wot(n3), Tr = Ive(n3);
                    break;
                  case "minute":
                    Xn = Sme(o, true), or = L_t(n3), Tr = Dve(n3);
                    break;
                  case "second":
                    Xn = Sme(o, false), or = O_t(n3), Tr = Eve(n3);
                    break;
                  case "millisecond":
                    Xn = $bn(o), or = R_t(n3), Tr = kve(n3);
                    break;
                }
                E(Xn, bn, Xr, or, Tr, ci2, $e2), Le2 === "year" && tn.length > 1 && zn === 0 && tn.unshift({ value: tn[0].value - Xn });
              }
            }
            for (var zn = 0; zn < $e2.length; zn++)
              tn.push($e2[zn]);
            return $e2;
          }
        }
        for (var V3 = [], W3 = [], q3 = 0, K = 0, J = 0; J < w2.length && T2++ < m2; ++J) {
          var rt2 = q$(w2[J]);
          if (uyn(w2[J])) {
            O2(w2[J], V3[V3.length - 1] || [], W3);
            var gt = w2[J + 1] ? q$(w2[J + 1]) : null;
            if (rt2 !== gt) {
              if (W3.length) {
                K = q3, W3.sort(function(Le2, ze) {
                  return Le2.value - ze.value;
                });
                for (var yt = [], At = 0; At < W3.length; ++At) {
                  var Lt = W3[At].value;
                  (At === 0 || W3[At - 1].value !== Lt) && (yt.push(W3[At]), Lt >= p2[0] && Lt <= p2[1] && q3++);
                }
                var Wt = (p2[1] - p2[0]) / o;
                if (q3 > Wt * 1.5 && K > Wt / 1.5 || (V3.push(yt), q3 > Wt || u === w2[J]))
                  break;
              }
              W3 = [];
            }
          }
        }
        for (var Nt = Fp(Ya2(V3, function(ze) {
          return Fp(ze, function(tn) {
            return tn.value >= p2[0] && tn.value <= p2[1] && !tn.notAdd;
          });
        }), function(ze) {
          return ze.length > 0;
        }), ue2 = [], ie2 = Nt.length - 1, J = 0; J < Nt.length; ++J)
          for (var pe2 = Nt[J], xe = 0; xe < pe2.length; ++xe)
            ue2.push({ value: pe2[xe].value, level: ie2 - J });
        ue2.sort(function(Le2, ze) {
          return Le2.value - ze.value;
        });
        for (var Ce2 = [], J = 0; J < ue2.length; ++J)
          (J === 0 || ue2[J].value !== ue2[J - 1].value) && Ce2.push(ue2[J]);
        return Ce2;
      }
      A4.registerClass(wme);
      var Mme = wme, Cme = A4.prototype, Zot = f8.prototype, Xbn = Ov, Qbn = Math.floor, Jbn = Math.ceil, pxt = Math.pow, gI = Math.log, u9t = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "log", n3.base = 10, n3._originalScale = new f8(), n3._interval = 0, n3;
        }
        return o.prototype.getTicks = function(n3) {
          var p2 = this._originalScale, m2 = this._extent, w2 = p2.getExtent(), T2 = Zot.getTicks.call(this, n3);
          return Ya2(T2, function(E) {
            var O2 = E.value, V3 = Ov(pxt(this.base, O2));
            return V3 = O2 === m2[0] && this._fixMin ? dxt(V3, w2[0]) : V3, V3 = O2 === m2[1] && this._fixMax ? dxt(V3, w2[1]) : V3, { value: V3 };
          }, this);
        }, o.prototype.setExtent = function(n3, p2) {
          var m2 = this.base;
          n3 = gI(n3) / gI(m2), p2 = gI(p2) / gI(m2), Zot.setExtent.call(this, n3, p2);
        }, o.prototype.getExtent = function() {
          var n3 = this.base, p2 = Cme.getExtent.call(this);
          p2[0] = pxt(n3, p2[0]), p2[1] = pxt(n3, p2[1]);
          var m2 = this._originalScale, w2 = m2.getExtent();
          return this._fixMin && (p2[0] = dxt(p2[0], w2[0])), this._fixMax && (p2[1] = dxt(p2[1], w2[1])), p2;
        }, o.prototype.unionExtent = function(n3) {
          this._originalScale.unionExtent(n3);
          var p2 = this.base;
          n3[0] = gI(n3[0]) / gI(p2), n3[1] = gI(n3[1]) / gI(p2), Cme.unionExtent.call(this, n3);
        }, o.prototype.unionExtentFromData = function(n3, p2) {
          this.unionExtent(n3.getApproximateExtent(p2));
        }, o.prototype.calcNiceTicks = function(n3) {
          n3 = n3 || 10;
          var p2 = this._extent, m2 = p2[1] - p2[0];
          if (!(m2 === 1 / 0 || m2 <= 0)) {
            var w2 = gbt(m2), T2 = n3 / m2 * w2;
            for (T2 <= 0.5 && (w2 *= 10); !isNaN(w2) && Math.abs(w2) < 1 && Math.abs(w2) > 0; )
              w2 *= 10;
            var E = [Ov(Jbn(p2[0] / w2) * w2), Ov(Qbn(p2[1] / w2) * w2)];
            this._interval = w2, this._niceExtent = E;
          }
        }, o.prototype.calcNiceExtent = function(n3) {
          Zot.calcNiceExtent.call(this, n3), this._fixMin = n3.fixMin, this._fixMax = n3.fixMax;
        }, o.prototype.parse = function(n3) {
          return n3;
        }, o.prototype.contain = function(n3) {
          return n3 = gI(n3) / gI(this.base), uxt(n3, this._extent);
        }, o.prototype.normalize = function(n3) {
          return n3 = gI(n3) / gI(this.base), cxt(n3, this._extent);
        }, o.prototype.scale = function(n3) {
          return n3 = fxt(n3, this._extent), pxt(this.base, n3);
        }, o.type = "log", o;
      }(A4), Tme = u9t.prototype;
      Tme.getMinorTicks = Zot.getMinorTicks, Tme.getLabel = Zot.getLabel;
      function dxt(u, o) {
        return Xbn(u, oM(o));
      }
      A4.registerClass(u9t);
      var t_n = u9t, e_n = function() {
        function u(o, n3, p2) {
          this._prepareParams(o, n3, p2);
        }
        return u.prototype._prepareParams = function(o, n3, p2) {
          p2[1] < p2[0] && (p2 = [NaN, NaN]), this._dataMin = p2[0], this._dataMax = p2[1];
          var m2 = this._isOrdinal = o.type === "ordinal";
          this._needCrossZero = o.type === "interval" && n3.getNeedCrossZero && n3.getNeedCrossZero();
          var w2 = this._modelMinRaw = n3.get("min", true);
          Sl(w2) ? this._modelMinNum = gxt(o, w2({ min: p2[0], max: p2[1] })) : w2 !== "dataMin" && (this._modelMinNum = gxt(o, w2));
          var T2 = this._modelMaxRaw = n3.get("max", true);
          if (Sl(T2) ? this._modelMaxNum = gxt(o, T2({ min: p2[0], max: p2[1] })) : T2 !== "dataMax" && (this._modelMaxNum = gxt(o, T2)), m2)
            this._axisDataLen = n3.getCategories().length;
          else {
            var E = n3.get("boundaryGap"), O2 = za2(E) ? E : [E || 0, E || 0];
            typeof O2[0] == "boolean" || typeof O2[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [Rm(O2[0], 1), Rm(O2[1], 1)];
          }
        }, u.prototype.calculate = function() {
          var o = this._isOrdinal, n3 = this._dataMin, p2 = this._dataMax, m2 = this._axisDataLen, w2 = this._boundaryGapInner, T2 = o ? null : p2 - n3 || Math.abs(n3), E = this._modelMinRaw === "dataMin" ? n3 : this._modelMinNum, O2 = this._modelMaxRaw === "dataMax" ? p2 : this._modelMaxNum, V3 = E != null, W3 = O2 != null;
          E == null && (E = o ? m2 ? 0 : NaN : n3 - w2[0] * T2), O2 == null && (O2 = o ? m2 ? m2 - 1 : NaN : p2 + w2[1] * T2), (E == null || !isFinite(E)) && (E = NaN), (O2 == null || !isFinite(O2)) && (O2 = NaN);
          var q3 = BB(E) || BB(O2) || o && !m2;
          this._needCrossZero && (E > 0 && O2 > 0 && !V3 && (E = 0), E < 0 && O2 < 0 && !W3 && (O2 = 0));
          var K = this._determinedMin, J = this._determinedMax;
          return K != null && (E = K, V3 = true), J != null && (O2 = J, W3 = true), { min: E, max: O2, minFixed: V3, maxFixed: W3, isBlank: q3 };
        }, u.prototype.modifyDataMinMax = function(o, n3) {
          this[r_n[o]] = n3;
        }, u.prototype.setDeterminedMinMax = function(o, n3) {
          var p2 = n_n[o];
          this[p2] = n3;
        }, u.prototype.freeze = function() {
          this.frozen = true;
        }, u;
      }(), n_n = { min: "_determinedMin", max: "_determinedMax" }, r_n = { min: "_dataMin", max: "_dataMax" };
      function Ame(u, o, n3) {
        var p2 = u.rawExtentInfo;
        return p2 || (p2 = new e_n(u, o, n3), u.rawExtentInfo = p2, p2);
      }
      function gxt(u, o) {
        return o == null ? null : BB(o) ? NaN : u.parse(o);
      }
      function Ime(u, o) {
        var n3 = u.type, p2 = Ame(u, o, u.getExtent()).calculate();
        u.setBlank(p2.isBlank);
        var m2 = p2.min, w2 = p2.max, T2 = o.ecModel;
        if (T2 && n3 === "time") {
          var E = gme("bar", T2), O2 = false;
          if (Xe2(E, function(q3) {
            O2 = O2 || q3.getBaseAxis() === o.axis;
          }), O2) {
            var V3 = vme(E), W3 = i_n(m2, w2, o, V3);
            m2 = W3.min, w2 = W3.max;
          }
        }
        return { extent: [m2, w2], fixMin: p2.minFixed, fixMax: p2.maxFixed };
      }
      function i_n(u, o, n3, p2) {
        var m2 = n3.axis.getExtent(), w2 = m2[1] - m2[0], T2 = jbn(p2, n3.axis);
        if (T2 === void 0)
          return { min: u, max: o };
        var E = 1 / 0;
        Xe2(T2, function(J) {
          E = Math.min(J.offset, E);
        });
        var O2 = -1 / 0;
        Xe2(T2, function(J) {
          O2 = Math.max(J.offset + J.width, O2);
        }), E = Math.abs(E), O2 = Math.abs(O2);
        var V3 = E + O2, W3 = o - u, q3 = 1 - (E + O2) / w2, K = W3 / q3 - W3;
        return o += K * (O2 / V3), u -= K * (E / V3), { min: u, max: o };
      }
      function uY(u, o) {
        var n3 = o, p2 = Ime(u, n3), m2 = p2.extent, w2 = n3.get("splitNumber");
        u instanceof t_n && (u.base = n3.get("logBase"));
        var T2 = u.type, E = n3.get("interval"), O2 = T2 === "interval" || T2 === "time";
        u.setExtent(m2[0], m2[1]), u.calcNiceExtent({ splitNumber: w2, fixMin: p2.fixMin, fixMax: p2.fixMax, minInterval: O2 ? n3.get("minInterval") : null, maxInterval: O2 ? n3.get("maxInterval") : null }), E != null && u.setInterval && u.setInterval(E);
      }
      function vxt(u, o) {
        if (o = o || u.get("type"), o)
          switch (o) {
            case "category":
              return new a9t({ ordinalMeta: u.getOrdinalMeta ? u.getOrdinalMeta() : u.getCategories(), extent: [1 / 0, -1 / 0] });
            case "time":
              return new Mme({ locale: u.ecModel.getLocaleModel(), useUTC: u.ecModel.get("useUTC") });
            default:
              return new (A4.getClass(o) || f8)();
          }
      }
      function a_n(u) {
        var o = u.scale.getExtent(), n3 = o[0], p2 = o[1];
        return !(n3 > 0 && p2 > 0 || n3 < 0 && p2 < 0);
      }
      function $ot(u) {
        var o = u.getLabelModel().get("formatter"), n3 = u.type === "category" ? u.scale.getExtent()[0] : null;
        return u.scale.type === "time" ? function(p2) {
          return function(m2, w2) {
            return u.scale.getFormattedLabel(m2, w2, p2);
          };
        }(o) : ds(o) ? function(p2) {
          return function(m2) {
            var w2 = u.scale.getLabel(m2), T2 = p2.replace("{value}", w2 != null ? w2 : "");
            return T2;
          };
        }(o) : Sl(o) ? function(p2) {
          return function(m2, w2) {
            return n3 != null && (w2 = m2.value - n3), p2(c9t(u, m2), w2, m2.level != null ? { level: m2.level } : null);
          };
        }(o) : function(p2) {
          return u.scale.getLabel(p2);
        };
      }
      function c9t(u, o) {
        return u.type === "category" ? u.scale.getLabel(o) : o.value;
      }
      function o_n(u) {
        var o = u.model, n3 = u.scale;
        if (!(!o.get(["axisLabel", "show"]) || n3.isBlank())) {
          var p2, m2, w2 = n3.getExtent();
          n3 instanceof a9t ? m2 = n3.count() : (p2 = n3.getTicks(), m2 = p2.length);
          var T2 = u.getLabelModel(), E = $ot(u), O2, V3 = 1;
          m2 > 40 && (V3 = Math.ceil(m2 / 40));
          for (var W3 = 0; W3 < m2; W3 += V3) {
            var q3 = p2 ? p2[W3] : { value: w2[0] + W3 }, K = E(q3, W3), J = T2.getTextRect(K), rt2 = s_n(J, T2.get("rotate") || 0);
            O2 ? O2.union(rt2) : O2 = rt2;
          }
          return O2;
        }
      }
      function s_n(u, o) {
        var n3 = o * Math.PI / 180, p2 = u.width, m2 = u.height, w2 = p2 * Math.abs(Math.cos(n3)) + Math.abs(m2 * Math.sin(n3)), T2 = p2 * Math.abs(Math.sin(n3)) + Math.abs(m2 * Math.cos(n3)), E = new Qu(u.x, u.y, w2, T2);
        return E;
      }
      function f9t(u) {
        var o = u.get("interval");
        return o == null ? "auto" : o;
      }
      function Dme(u) {
        return u.type === "category" && f9t(u.getLabelModel()) === 0;
      }
      function yxt(u, o) {
        var n3 = {};
        return Xe2(u.mapDimensionsAll(o), function(p2) {
          n3[lme(u, p2)] = true;
        }), tf2(n3);
      }
      function l_n(u, o, n3) {
        o && Xe2(yxt(o, n3), function(p2) {
          var m2 = o.getApproximateExtent(p2);
          m2[0] < u[0] && (u[0] = m2[0]), m2[1] > u[1] && (u[1] = m2[1]);
        });
      }
      var Yot = function() {
        function u() {
        }
        return u.prototype.getNeedCrossZero = function() {
          var o = this.option;
          return !o.scale;
        }, u.prototype.getCoordSysModel = function() {
        }, u;
      }(), u_n = 1e-8;
      function Eme(u, o) {
        return Math.abs(u - o) < u_n;
      }
      function Fz(u, o, n3) {
        var p2 = 0, m2 = u[0];
        if (!m2)
          return false;
        for (var w2 = 1; w2 < u.length; w2++) {
          var T2 = u[w2];
          p2 += ek2(m2[0], m2[1], T2[0], T2[1], o, n3), m2 = T2;
        }
        var E = u[0];
        return (!Eme(m2[0], E[0]) || !Eme(m2[1], E[1])) && (p2 += ek2(m2[0], m2[1], E[0], E[1], o, n3)), p2 !== 0;
      }
      var c_n = [];
      function h9t(u, o) {
        for (var n3 = 0; n3 < u.length; n3++)
          Lm(u[n3], u[n3], o);
      }
      function kme(u, o, n3, p2) {
        for (var m2 = 0; m2 < u.length; m2++) {
          var w2 = u[m2];
          p2 && (w2 = p2.project(w2)), w2 && isFinite(w2[0]) && isFinite(w2[1]) && (HE(o, o, w2), GA(n3, n3, w2));
        }
      }
      function f_n(u) {
        for (var o = 0, n3 = 0, p2 = 0, m2 = u.length, w2 = u[m2 - 1][0], T2 = u[m2 - 1][1], E = 0; E < m2; E++) {
          var O2 = u[E][0], V3 = u[E][1], W3 = w2 * V3 - O2 * T2;
          o += W3, n3 += (w2 + O2) * W3, p2 += (T2 + V3) * W3, w2 = O2, T2 = V3;
        }
        return o ? [n3 / o / 3, p2 / o / 3, o] : [u[0][0] || 0, u[0][1] || 0];
      }
      var Pme = function() {
        function u(o) {
          this.name = o;
        }
        return u.prototype.setCenter = function(o) {
          this._center = o;
        }, u.prototype.getCenter = function() {
          var o = this._center;
          return o || (o = this._center = this.calcCenter()), o;
        }, u;
      }(), Lme = function() {
        function u(o, n3) {
          this.type = "polygon", this.exterior = o, this.interiors = n3;
        }
        return u;
      }(), Ome = function() {
        function u(o) {
          this.type = "linestring", this.points = o;
        }
        return u;
      }(), Rme = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this, n3) || this;
          return w2.type = "geoJSON", w2.geometries = p2, w2._center = m2 && [m2[0], m2[1]], w2;
        }
        return o.prototype.calcCenter = function() {
          for (var n3 = this.geometries, p2, m2 = 0, w2 = 0; w2 < n3.length; w2++) {
            var T2 = n3[w2], E = T2.exterior, O2 = E && E.length;
            O2 > m2 && (p2 = T2, m2 = O2);
          }
          if (p2)
            return f_n(p2.exterior);
          var V3 = this.getBoundingRect();
          return [V3.x + V3.width / 2, V3.y + V3.height / 2];
        }, o.prototype.getBoundingRect = function(n3) {
          var p2 = this._rect;
          if (p2 && !n3)
            return p2;
          var m2 = [1 / 0, 1 / 0], w2 = [-1 / 0, -1 / 0], T2 = this.geometries;
          return Xe2(T2, function(E) {
            E.type === "polygon" ? kme(E.exterior, m2, w2, n3) : Xe2(E.points, function(O2) {
              kme(O2, m2, w2, n3);
            });
          }), isFinite(m2[0]) && isFinite(m2[1]) && isFinite(w2[0]) && isFinite(w2[1]) || (m2[0] = m2[1] = w2[0] = w2[1] = 0), p2 = new Qu(m2[0], m2[1], w2[0] - m2[0], w2[1] - m2[1]), n3 || (this._rect = p2), p2;
        }, o.prototype.contain = function(n3) {
          var p2 = this.getBoundingRect(), m2 = this.geometries;
          if (!p2.contain(n3[0], n3[1]))
            return false;
          t:
            for (var w2 = 0, T2 = m2.length; w2 < T2; w2++) {
              var E = m2[w2];
              if (E.type === "polygon") {
                var O2 = E.exterior, V3 = E.interiors;
                if (Fz(O2, n3[0], n3[1])) {
                  for (var W3 = 0; W3 < (V3 ? V3.length : 0); W3++)
                    if (Fz(V3[W3], n3[0], n3[1]))
                      continue t;
                  return true;
                }
              }
            }
          return false;
        }, o.prototype.transformTo = function(n3, p2, m2, w2) {
          var T2 = this.getBoundingRect(), E = T2.width / T2.height;
          m2 ? w2 || (w2 = m2 / E) : m2 = E * w2;
          for (var O2 = new Qu(n3, p2, m2, w2), V3 = T2.calculateTransform(O2), W3 = this.geometries, q3 = 0; q3 < W3.length; q3++) {
            var K = W3[q3];
            K.type === "polygon" ? (h9t(K.exterior, V3), Xe2(K.interiors, function(J) {
              h9t(J, V3);
            })) : Xe2(K.points, function(J) {
              h9t(J, V3);
            });
          }
          T2 = this._rect, T2.copy(O2), this._center = [T2.x + T2.width / 2, T2.y + T2.height / 2];
        }, o.prototype.cloneShallow = function(n3) {
          n3 == null && (n3 = this.name);
          var p2 = new o(n3, this.geometries, this._center);
          return p2._rect = this._rect, p2.transformTo = null, p2;
        }, o;
      }(Pme), h_n = function(u) {
        tr(o, u);
        function o(n3, p2) {
          var m2 = u.call(this, n3) || this;
          return m2.type = "geoSVG", m2._elOnlyForCalculate = p2, m2;
        }
        return o.prototype.calcCenter = function() {
          for (var n3 = this._elOnlyForCalculate, p2 = n3.getBoundingRect(), m2 = [p2.x + p2.width / 2, p2.y + p2.height / 2], w2 = oz(c_n), T2 = n3; T2 && !T2.isGeoSVGGraphicRoot; )
            YA(w2, T2.getLocalTransform(), w2), T2 = T2.parent;
          return e4(w2, w2), Lm(m2, m2, w2), m2;
        }, o;
      }(Pme);
      function p_n(u) {
        if (!u.UTF8Encoding)
          return u;
        var o = u, n3 = o.UTF8Scale;
        n3 == null && (n3 = 1024);
        var p2 = o.features;
        return Xe2(p2, function(m2) {
          var w2 = m2.geometry, T2 = w2.encodeOffsets, E = w2.coordinates;
          if (T2)
            switch (w2.type) {
              case "LineString":
                w2.coordinates = Nme(E, T2, n3);
                break;
              case "Polygon":
                p9t(E, T2, n3);
                break;
              case "MultiLineString":
                p9t(E, T2, n3);
                break;
              case "MultiPolygon":
                Xe2(E, function(O2, V3) {
                  return p9t(O2, T2[V3], n3);
                });
            }
        }), o.UTF8Encoding = false, o;
      }
      function p9t(u, o, n3) {
        for (var p2 = 0; p2 < u.length; p2++)
          u[p2] = Nme(u[p2], o[p2], n3);
      }
      function Nme(u, o, n3) {
        for (var p2 = [], m2 = o[0], w2 = o[1], T2 = 0; T2 < u.length; T2 += 2) {
          var E = u.charCodeAt(T2) - 64, O2 = u.charCodeAt(T2 + 1) - 64;
          E = E >> 1 ^ -(E & 1), O2 = O2 >> 1 ^ -(O2 & 1), E += m2, O2 += w2, m2 = E, w2 = O2, p2.push([E / n3, O2 / n3]);
        }
        return p2;
      }
      function d_n(u, o) {
        return u = p_n(u), Ya2(Fp(u.features, function(n3) {
          return n3.geometry && n3.properties && n3.geometry.coordinates.length > 0;
        }), function(n3) {
          var p2 = n3.properties, m2 = n3.geometry, w2 = [];
          switch (m2.type) {
            case "Polygon":
              var T2 = m2.coordinates;
              w2.push(new Lme(T2[0], T2.slice(1)));
              break;
            case "MultiPolygon":
              Xe2(m2.coordinates, function(O2) {
                O2[0] && w2.push(new Lme(O2[0], O2.slice(1)));
              });
              break;
            case "LineString":
              w2.push(new Ome([m2.coordinates]));
              break;
            case "MultiLineString":
              w2.push(new Ome(m2.coordinates));
          }
          var E = new Rme(p2[o || "name"], w2, p2.cp);
          return E.properties = p2, E;
        });
      }
      var Kot = Ff2();
      function g_n(u) {
        return u.type === "category" ? y_n(u) : b_n(u);
      }
      function v_n(u, o) {
        return u.type === "category" ? m_n(u, o) : { ticks: Ya2(u.scale.getTicks(), function(n3) {
          return n3.value;
        }) };
      }
      function y_n(u) {
        var o = u.getLabelModel(), n3 = Fme(u, o);
        return !o.get("show") || u.scale.isBlank() ? { labels: [], labelCategoryInterval: n3.labelCategoryInterval } : n3;
      }
      function Fme(u, o) {
        var n3 = Vme(u, "labels"), p2 = f9t(o), m2 = Bme(n3, p2);
        if (m2)
          return m2;
        var w2, T2;
        return Sl(p2) ? w2 = Wme(u, p2) : (T2 = p2 === "auto" ? __n(u) : p2, w2 = jme(u, T2)), zme(n3, p2, { labels: w2, labelCategoryInterval: T2 });
      }
      function m_n(u, o) {
        var n3 = Vme(u, "ticks"), p2 = f9t(o), m2 = Bme(n3, p2);
        if (m2)
          return m2;
        var w2, T2;
        if ((!o.get("show") || u.scale.isBlank()) && (w2 = []), Sl(p2))
          w2 = Wme(u, p2, true);
        else if (p2 === "auto") {
          var E = Fme(u, u.getLabelModel());
          T2 = E.labelCategoryInterval, w2 = Ya2(E.labels, function(O2) {
            return O2.tickValue;
          });
        } else
          T2 = p2, w2 = jme(u, T2, true);
        return zme(n3, p2, { ticks: w2, tickCategoryInterval: T2 });
      }
      function b_n(u) {
        var o = u.scale.getTicks(), n3 = $ot(u);
        return { labels: Ya2(o, function(p2, m2) {
          return { level: p2.level, formattedLabel: n3(p2, m2), rawLabel: u.scale.getLabel(p2), tickValue: p2.value };
        }) };
      }
      function Vme(u, o) {
        return Kot(u)[o] || (Kot(u)[o] = []);
      }
      function Bme(u, o) {
        for (var n3 = 0; n3 < u.length; n3++)
          if (u[n3].key === o)
            return u[n3].value;
      }
      function zme(u, o, n3) {
        return u.push({ key: o, value: n3 }), n3;
      }
      function __n(u) {
        var o = Kot(u).autoInterval;
        return o != null ? o : Kot(u).autoInterval = u.calculateCategoryInterval();
      }
      function x_n(u) {
        var o = w_n(u), n3 = $ot(u), p2 = (o.axisRotate - o.labelRotate) / 180 * Math.PI, m2 = u.scale, w2 = m2.getExtent(), T2 = m2.count();
        if (w2[1] - w2[0] < 1)
          return 0;
        var E = 1;
        T2 > 40 && (E = Math.max(1, Math.floor(T2 / 40)));
        for (var O2 = w2[0], V3 = u.dataToCoord(O2 + 1) - u.dataToCoord(O2), W3 = Math.abs(V3 * Math.cos(p2)), q3 = Math.abs(V3 * Math.sin(p2)), K = 0, J = 0; O2 <= w2[1]; O2 += E) {
          var rt2 = 0, gt = 0, yt = r4(n3({ value: O2 }), o.font, "center", "top");
          rt2 = yt.width * 1.3, gt = yt.height * 1.3, K = Math.max(K, rt2, 7), J = Math.max(J, gt, 7);
        }
        var At = K / W3, Lt = J / q3;
        isNaN(At) && (At = 1 / 0), isNaN(Lt) && (Lt = 1 / 0);
        var Wt = Math.max(0, Math.floor(Math.min(At, Lt))), Nt = Kot(u.model), ue2 = u.getExtent(), ie2 = Nt.lastAutoInterval, pe2 = Nt.lastTickCount;
        return ie2 != null && pe2 != null && Math.abs(ie2 - Wt) <= 1 && Math.abs(pe2 - T2) <= 1 && ie2 > Wt && Nt.axisExtent0 === ue2[0] && Nt.axisExtent1 === ue2[1] ? Wt = ie2 : (Nt.lastTickCount = T2, Nt.lastAutoInterval = Wt, Nt.axisExtent0 = ue2[0], Nt.axisExtent1 = ue2[1]), Wt;
      }
      function w_n(u) {
        var o = u.getLabelModel();
        return { axisRotate: u.getRotate ? u.getRotate() : u.isHorizontal && !u.isHorizontal() ? 90 : 0, labelRotate: o.get("rotate") || 0, font: o.getFont() };
      }
      function jme(u, o, n3) {
        var p2 = $ot(u), m2 = u.scale, w2 = m2.getExtent(), T2 = u.getLabelModel(), E = [], O2 = Math.max((o || 0) + 1, 1), V3 = w2[0], W3 = m2.count();
        V3 !== 0 && O2 > 1 && W3 / O2 > 2 && (V3 = Math.round(Math.ceil(V3 / O2) * O2));
        var q3 = Dme(u), K = T2.get("showMinLabel") || q3, J = T2.get("showMaxLabel") || q3;
        K && V3 !== w2[0] && gt(w2[0]);
        for (var rt2 = V3; rt2 <= w2[1]; rt2 += O2)
          gt(rt2);
        J && rt2 - O2 !== w2[1] && gt(w2[1]);
        function gt(yt) {
          var At = { value: yt };
          E.push(n3 ? yt : { formattedLabel: p2(At), rawLabel: m2.getLabel(At), tickValue: yt });
        }
        return E;
      }
      function Wme(u, o, n3) {
        var p2 = u.scale, m2 = $ot(u), w2 = [];
        return Xe2(p2.getTicks(), function(T2) {
          var E = p2.getLabel(T2), O2 = T2.value;
          o(T2.value, E) && w2.push(n3 ? O2 : { formattedLabel: m2(T2), rawLabel: E, tickValue: O2 });
        }), w2;
      }
      var Gme = [0, 1], S_n = function() {
        function u(o, n3, p2) {
          this.onBand = false, this.inverse = false, this.dim = o, this.scale = n3, this._extent = p2 || [0, 0];
        }
        return u.prototype.contain = function(o) {
          var n3 = this._extent, p2 = Math.min(n3[0], n3[1]), m2 = Math.max(n3[0], n3[1]);
          return o >= p2 && o <= m2;
        }, u.prototype.containData = function(o) {
          return this.scale.contain(o);
        }, u.prototype.getExtent = function() {
          return this._extent.slice();
        }, u.prototype.getPixelPrecision = function(o) {
          return hbt(o || this.scale.getExtent(), this._extent);
        }, u.prototype.setExtent = function(o, n3) {
          var p2 = this._extent;
          p2[0] = o, p2[1] = n3;
        }, u.prototype.dataToCoord = function(o, n3) {
          var p2 = this._extent, m2 = this.scale;
          return o = m2.normalize(o), this.onBand && m2.type === "ordinal" && (p2 = p2.slice(), Hme(p2, m2.count())), bp(o, Gme, p2, n3);
        }, u.prototype.coordToData = function(o, n3) {
          var p2 = this._extent, m2 = this.scale;
          this.onBand && m2.type === "ordinal" && (p2 = p2.slice(), Hme(p2, m2.count()));
          var w2 = bp(o, p2, Gme, n3);
          return this.scale.scale(w2);
        }, u.prototype.pointToData = function(o, n3) {
        }, u.prototype.getTicksCoords = function(o) {
          o = o || {};
          var n3 = o.tickModel || this.getTickModel(), p2 = v_n(this, n3), m2 = p2.ticks, w2 = Ya2(m2, function(E) {
            return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(E) : E), tickValue: E };
          }, this), T2 = n3.get("alignWithLabel");
          return M_n(this, w2, T2, o.clamp), w2;
        }, u.prototype.getMinorTicksCoords = function() {
          if (this.scale.type === "ordinal")
            return [];
          var o = this.model.getModel("minorTick"), n3 = o.get("splitNumber");
          n3 > 0 && n3 < 100 || (n3 = 5);
          var p2 = this.scale.getMinorTicks(n3), m2 = Ya2(p2, function(w2) {
            return Ya2(w2, function(T2) {
              return { coord: this.dataToCoord(T2), tickValue: T2 };
            }, this);
          }, this);
          return m2;
        }, u.prototype.getViewLabels = function() {
          return g_n(this).labels;
        }, u.prototype.getLabelModel = function() {
          return this.model.getModel("axisLabel");
        }, u.prototype.getTickModel = function() {
          return this.model.getModel("axisTick");
        }, u.prototype.getBandWidth = function() {
          var o = this._extent, n3 = this.scale.getExtent(), p2 = n3[1] - n3[0] + (this.onBand ? 1 : 0);
          p2 === 0 && (p2 = 1);
          var m2 = Math.abs(o[1] - o[0]);
          return Math.abs(m2) / p2;
        }, u.prototype.calculateCategoryInterval = function() {
          return x_n(this);
        }, u;
      }();
      function Hme(u, o) {
        var n3 = u[1] - u[0], p2 = o, m2 = n3 / p2 / 2;
        u[0] += m2, u[1] -= m2;
      }
      function M_n(u, o, n3, p2) {
        var m2 = o.length;
        if (!u.onBand || n3 || !m2)
          return;
        var w2 = u.getExtent(), T2, E;
        if (m2 === 1)
          o[0].coord = w2[0], T2 = o[1] = { coord: w2[0] };
        else {
          var O2 = o[m2 - 1].tickValue - o[0].tickValue, V3 = (o[m2 - 1].coord - o[0].coord) / O2;
          Xe2(o, function(J) {
            J.coord -= V3 / 2;
          });
          var W3 = u.scale.getExtent();
          E = 1 + W3[1] - o[m2 - 1].tickValue, T2 = { coord: o[m2 - 1].coord + V3 * E }, o.push(T2);
        }
        var q3 = w2[0] > w2[1];
        K(o[0].coord, w2[0]) && (p2 ? o[0].coord = w2[0] : o.shift()), p2 && K(w2[0], o[0].coord) && o.unshift({ coord: w2[0] }), K(w2[1], T2.coord) && (p2 ? T2.coord = w2[1] : o.pop()), p2 && K(T2.coord, w2[1]) && o.push({ coord: w2[1] });
        function K(J, rt2) {
          return J = Ov(J), rt2 = Ov(rt2), q3 ? J > rt2 : J < rt2;
        }
      }
      var ak2 = S_n, Xot = Math.PI * 2, Vz = iI.CMD, C_n = ["top", "right", "bottom", "left"];
      function T_n(u, o, n3, p2, m2) {
        var w2 = n3.width, T2 = n3.height;
        switch (u) {
          case "top":
            p2.set(n3.x + w2 / 2, n3.y - o), m2.set(0, -1);
            break;
          case "bottom":
            p2.set(n3.x + w2 / 2, n3.y + T2 + o), m2.set(0, 1);
            break;
          case "left":
            p2.set(n3.x - o, n3.y + T2 / 2), m2.set(-1, 0);
            break;
          case "right":
            p2.set(n3.x + w2 + o, n3.y + T2 / 2), m2.set(1, 0);
            break;
        }
      }
      function A_n(u, o, n3, p2, m2, w2, T2, E, O2) {
        T2 -= u, E -= o;
        var V3 = Math.sqrt(T2 * T2 + E * E);
        T2 /= V3, E /= V3;
        var W3 = T2 * n3 + u, q3 = E * n3 + o;
        if (Math.abs(p2 - m2) % Xot < 1e-4)
          return O2[0] = W3, O2[1] = q3, V3 - n3;
        if (w2) {
          var K = p2;
          p2 = BP(m2), m2 = BP(K);
        } else
          p2 = BP(p2), m2 = BP(m2);
        p2 > m2 && (m2 += Xot);
        var J = Math.atan2(E, T2);
        if (J < 0 && (J += Xot), J >= p2 && J <= m2 || J + Xot >= p2 && J + Xot <= m2)
          return O2[0] = W3, O2[1] = q3, V3 - n3;
        var rt2 = n3 * Math.cos(p2) + u, gt = n3 * Math.sin(p2) + o, yt = n3 * Math.cos(m2) + u, At = n3 * Math.sin(m2) + o, Lt = (rt2 - T2) * (rt2 - T2) + (gt - E) * (gt - E), Wt = (yt - T2) * (yt - T2) + (At - E) * (At - E);
        return Lt < Wt ? (O2[0] = rt2, O2[1] = gt, Math.sqrt(Lt)) : (O2[0] = yt, O2[1] = At, Math.sqrt(Wt));
      }
      function mxt(u, o, n3, p2, m2, w2, T2, E) {
        var O2 = m2 - u, V3 = w2 - o, W3 = n3 - u, q3 = p2 - o, K = Math.sqrt(W3 * W3 + q3 * q3);
        W3 /= K, q3 /= K;
        var J = O2 * W3 + V3 * q3, rt2 = J / K;
        E && (rt2 = Math.min(Math.max(rt2, 0), 1)), rt2 *= K;
        var gt = T2[0] = u + rt2 * W3, yt = T2[1] = o + rt2 * q3;
        return Math.sqrt((gt - m2) * (gt - m2) + (yt - w2) * (yt - w2));
      }
      function Ume(u, o, n3, p2, m2, w2, T2) {
        n3 < 0 && (u = u + n3, n3 = -n3), p2 < 0 && (o = o + p2, p2 = -p2);
        var E = u + n3, O2 = o + p2, V3 = T2[0] = Math.min(Math.max(m2, u), E), W3 = T2[1] = Math.min(Math.max(w2, o), O2);
        return Math.sqrt((V3 - m2) * (V3 - m2) + (W3 - w2) * (W3 - w2));
      }
      var ok2 = [];
      function I_n(u, o, n3) {
        var p2 = Ume(o.x, o.y, o.width, o.height, u.x, u.y, ok2);
        return n3.set(ok2[0], ok2[1]), p2;
      }
      function D_n(u, o, n3) {
        for (var p2 = 0, m2 = 0, w2 = 0, T2 = 0, E, O2, V3 = 1 / 0, W3 = o.data, q3 = u.x, K = u.y, J = 0; J < W3.length; ) {
          var rt2 = W3[J++];
          J === 1 && (p2 = W3[J], m2 = W3[J + 1], w2 = p2, T2 = m2);
          var gt = V3;
          switch (rt2) {
            case Vz.M:
              w2 = W3[J++], T2 = W3[J++], p2 = w2, m2 = T2;
              break;
            case Vz.L:
              gt = mxt(p2, m2, W3[J], W3[J + 1], q3, K, ok2, true), p2 = W3[J++], m2 = W3[J++];
              break;
            case Vz.C:
              gt = N1t(p2, m2, W3[J++], W3[J++], W3[J++], W3[J++], W3[J], W3[J + 1], q3, K, ok2), p2 = W3[J++], m2 = W3[J++];
              break;
            case Vz.Q:
              gt = V1t(p2, m2, W3[J++], W3[J++], W3[J], W3[J + 1], q3, K, ok2), p2 = W3[J++], m2 = W3[J++];
              break;
            case Vz.A:
              var yt = W3[J++], At = W3[J++], Lt = W3[J++], Wt = W3[J++], Nt = W3[J++], ue2 = W3[J++];
              J += 1;
              var ie2 = !!(1 - W3[J++]);
              E = Math.cos(Nt) * Lt + yt, O2 = Math.sin(Nt) * Wt + At, J <= 1 && (w2 = E, T2 = O2);
              var pe2 = (q3 - yt) * Wt / Lt + yt;
              gt = A_n(yt, At, Wt, Nt, Nt + ue2, ie2, pe2, K, ok2), p2 = Math.cos(Nt + ue2) * Lt + yt, m2 = Math.sin(Nt + ue2) * Wt + At;
              break;
            case Vz.R:
              w2 = p2 = W3[J++], T2 = m2 = W3[J++];
              var xe = W3[J++], Ce2 = W3[J++];
              gt = Ume(w2, T2, xe, Ce2, q3, K, ok2);
              break;
            case Vz.Z:
              gt = mxt(p2, m2, w2, T2, q3, K, ok2, true), p2 = w2, m2 = T2;
              break;
          }
          gt < V3 && (V3 = gt, n3.set(ok2[0], ok2[1]));
        }
        return V3;
      }
      var sk2 = new Vu(), wg2 = new Vu(), Ty = new Vu(), YP = new Vu(), KP = new Vu();
      function qme(u, o) {
        if (u) {
          var n3 = u.getTextGuideLine(), p2 = u.getTextContent();
          if (p2 && n3) {
            var m2 = u.textGuideLineConfig || {}, w2 = [[0, 0], [0, 0], [0, 0]], T2 = m2.candidates || C_n, E = p2.getBoundingRect().clone();
            E.applyTransform(p2.getComputedTransform());
            var O2 = 1 / 0, V3 = m2.anchor, W3 = u.getComputedTransform(), q3 = W3 && e4([], W3), K = o.get("length2") || 0;
            V3 && Ty.copy(V3);
            for (var J = 0; J < T2.length; J++) {
              var rt2 = T2[J];
              T_n(rt2, 0, E, sk2, YP), Vu.scaleAndAdd(wg2, sk2, YP, K), wg2.transform(q3);
              var gt = u.getBoundingRect(), yt = V3 ? V3.distance(wg2) : u instanceof Mc2 ? D_n(wg2, u.path, Ty) : I_n(wg2, gt, Ty);
              yt < O2 && (O2 = yt, wg2.transform(W3), Ty.transform(W3), Ty.toArray(w2[0]), wg2.toArray(w2[1]), sk2.toArray(w2[2]));
            }
            Zme(w2, o.get("minTurnAngle")), n3.setShape({ points: w2 });
          }
        }
      }
      var bxt = [], s2 = new Vu();
      function Zme(u, o) {
        if (o <= 180 && o > 0) {
          o = o / 180 * Math.PI, sk2.fromArray(u[0]), wg2.fromArray(u[1]), Ty.fromArray(u[2]), Vu.sub(YP, sk2, wg2), Vu.sub(KP, Ty, wg2);
          var n3 = YP.len(), p2 = KP.len();
          if (!(n3 < 1e-3 || p2 < 1e-3)) {
            YP.scale(1 / n3), KP.scale(1 / p2);
            var m2 = YP.dot(KP), w2 = Math.cos(o);
            if (w2 < m2) {
              var T2 = mxt(wg2.x, wg2.y, Ty.x, Ty.y, sk2.x, sk2.y, bxt, false);
              s2.fromArray(bxt), s2.scaleAndAdd(KP, T2 / Math.tan(Math.PI - o));
              var E = Ty.x !== wg2.x ? (s2.x - wg2.x) / (Ty.x - wg2.x) : (s2.y - wg2.y) / (Ty.y - wg2.y);
              if (isNaN(E))
                return;
              E < 0 ? Vu.copy(s2, wg2) : E > 1 && Vu.copy(s2, Ty), s2.toArray(u[1]);
            }
          }
        }
      }
      function E_n(u, o, n3) {
        if (n3 <= 180 && n3 > 0) {
          n3 = n3 / 180 * Math.PI, sk2.fromArray(u[0]), wg2.fromArray(u[1]), Ty.fromArray(u[2]), Vu.sub(YP, wg2, sk2), Vu.sub(KP, Ty, wg2);
          var p2 = YP.len(), m2 = KP.len();
          if (!(p2 < 1e-3 || m2 < 1e-3)) {
            YP.scale(1 / p2), KP.scale(1 / m2);
            var w2 = YP.dot(o), T2 = Math.cos(n3);
            if (w2 < T2) {
              var E = mxt(wg2.x, wg2.y, Ty.x, Ty.y, sk2.x, sk2.y, bxt, false);
              s2.fromArray(bxt);
              var O2 = Math.PI / 2, V3 = Math.acos(KP.dot(o)), W3 = O2 + V3 - n3;
              if (W3 >= O2)
                Vu.copy(s2, Ty);
              else {
                s2.scaleAndAdd(KP, E / Math.tan(Math.PI / 2 - W3));
                var q3 = Ty.x !== wg2.x ? (s2.x - wg2.x) / (Ty.x - wg2.x) : (s2.y - wg2.y) / (Ty.y - wg2.y);
                if (isNaN(q3))
                  return;
                q3 < 0 ? Vu.copy(s2, wg2) : q3 > 1 && Vu.copy(s2, Ty);
              }
              s2.toArray(u[1]);
            }
          }
        }
      }
      function $me(u, o, n3, p2) {
        var m2 = n3 === "normal", w2 = m2 ? u : u.ensureState(n3);
        w2.ignore = o;
        var T2 = p2.get("smooth");
        T2 && T2 === true && (T2 = 0.3), w2.shape = w2.shape || {}, T2 > 0 && (w2.shape.smooth = T2);
        var E = p2.getModel("lineStyle").getLineStyle();
        m2 ? u.useStyle(E) : w2.style = E;
      }
      function k_n(u, o) {
        var n3 = o.smooth, p2 = o.points;
        if (p2)
          if (u.moveTo(p2[0][0], p2[0][1]), n3 > 0 && p2.length >= 3) {
            var m2 = GE(p2[0], p2[1]), w2 = GE(p2[1], p2[2]);
            if (!m2 || !w2) {
              u.lineTo(p2[1][0], p2[1][1]), u.lineTo(p2[2][0], p2[2][1]);
              return;
            }
            var T2 = Math.min(m2, w2) * n3, E = VZ([], p2[1], p2[0], T2 / m2), O2 = VZ([], p2[1], p2[2], T2 / w2), V3 = VZ([], E, O2, 0.5);
            u.bezierCurveTo(E[0], E[1], E[0], E[1], V3[0], V3[1]), u.bezierCurveTo(O2[0], O2[1], O2[0], O2[1], p2[2][0], p2[2][1]);
          } else
            for (var W3 = 1; W3 < p2.length; W3++)
              u.lineTo(p2[W3][0], p2[W3][1]);
      }
      function d9t(u, o, n3) {
        var p2 = u.getTextGuideLine(), m2 = u.getTextContent();
        if (!m2) {
          p2 && u.removeTextGuideLine();
          return;
        }
        for (var w2 = o.normal, T2 = w2.get("show"), E = m2.ignore, O2 = 0; O2 < yz.length; O2++) {
          var V3 = yz[O2], W3 = o[V3], q3 = V3 === "normal";
          if (W3) {
            var K = W3.get("show"), J = q3 ? E : Xu(m2.states[V3] && m2.states[V3].ignore, E);
            if (J || !Xu(K, T2)) {
              var rt2 = q3 ? p2 : p2 && p2.states.normal;
              rt2 && (rt2.ignore = true);
              continue;
            }
            p2 || (p2 = new Mw(), u.setTextGuideLine(p2), !q3 && (E || !T2) && $me(p2, true, "normal", o.normal), u.stateProxy && (p2.stateProxy = u.stateProxy)), $me(p2, false, V3, W3);
          }
        }
        if (p2) {
          kl(p2.style, n3), p2.style.fill = null;
          var gt = w2.get("showAbove"), yt = u.textGuideLineConfig = u.textGuideLineConfig || {};
          yt.showAbove = gt || false, p2.buildPath = k_n;
        }
      }
      function g9t(u, o) {
        o = o || "labelLine";
        for (var n3 = { normal: u.getModel(o) }, p2 = 0; p2 < J_.length; p2++) {
          var m2 = J_[p2];
          n3[m2] = u.getModel([m2, o]);
        }
        return n3;
      }
      function Yme(u) {
        for (var o = [], n3 = 0; n3 < u.length; n3++) {
          var p2 = u[n3];
          if (!p2.defaultAttr.ignore) {
            var m2 = p2.label, w2 = m2.getComputedTransform(), T2 = m2.getBoundingRect(), E = !w2 || w2[1] < 1e-5 && w2[2] < 1e-5, O2 = m2.style.margin || 0, V3 = T2.clone();
            V3.applyTransform(w2), V3.x -= O2 / 2, V3.y -= O2 / 2, V3.width += O2, V3.height += O2;
            var W3 = E ? new B$(T2, w2) : null;
            o.push({ label: m2, labelLine: p2.labelLine, rect: V3, localRect: T2, obb: W3, priority: p2.priority, defaultAttr: p2.defaultAttr, layoutOption: p2.computedLayoutOption, axisAligned: E, transform: w2 });
          }
        }
        return o;
      }
      function Kme(u, o, n3, p2, m2, w2) {
        var T2 = u.length;
        if (T2 < 2)
          return;
        u.sort(function(xe, Ce2) {
          return xe.rect[o] - Ce2.rect[o];
        });
        for (var E = 0, O2, V3 = false, W3 = 0, q3 = 0; q3 < T2; q3++) {
          var K = u[q3], J = K.rect;
          O2 = J[o] - E, O2 < 0 && (J[o] -= O2, K.label[o] -= O2, V3 = true);
          var rt2 = Math.max(-O2, 0);
          W3 += rt2, E = J[o] + J[n3];
        }
        W3 > 0 && w2 && ue2(-W3 / T2, 0, T2);
        var gt = u[0], yt = u[T2 - 1], At, Lt;
        Wt(), At < 0 && ie2(-At, 0.8), Lt < 0 && ie2(Lt, 0.8), Wt(), Nt(At, Lt, 1), Nt(Lt, At, -1), Wt(), At < 0 && pe2(-At), Lt < 0 && pe2(Lt);
        function Wt() {
          At = gt.rect[o] - p2, Lt = m2 - yt.rect[o] - yt.rect[n3];
        }
        function Nt(xe, Ce2, Le2) {
          if (xe < 0) {
            var ze = Math.min(Ce2, -xe);
            if (ze > 0) {
              ue2(ze * Le2, 0, T2);
              var tn = ze + xe;
              tn < 0 && ie2(-tn * Le2, 1);
            } else
              ie2(-xe * Le2, 1);
          }
        }
        function ue2(xe, Ce2, Le2) {
          xe !== 0 && (V3 = true);
          for (var ze = Ce2; ze < Le2; ze++) {
            var tn = u[ze], $e2 = tn.rect;
            $e2[o] += xe, tn.label[o] += xe;
          }
        }
        function ie2(xe, Ce2) {
          for (var Le2 = [], ze = 0, tn = 1; tn < T2; tn++) {
            var $e2 = u[tn - 1].rect, Tn = Math.max(u[tn].rect[o] - $e2[o] - $e2[n3], 0);
            Le2.push(Tn), ze += Tn;
          }
          if (ze) {
            var zn = Math.min(Math.abs(xe) / ze, Ce2);
            if (xe > 0)
              for (var tn = 0; tn < T2 - 1; tn++) {
                var bn = Le2[tn] * zn;
                ue2(bn, 0, tn + 1);
              }
            else
              for (var tn = T2 - 1; tn > 0; tn--) {
                var bn = Le2[tn - 1] * zn;
                ue2(-bn, tn, T2);
              }
          }
        }
        function pe2(xe) {
          var Ce2 = xe < 0 ? -1 : 1;
          xe = Math.abs(xe);
          for (var Le2 = Math.ceil(xe / (T2 - 1)), ze = 0; ze < T2 - 1; ze++)
            if (Ce2 > 0 ? ue2(Le2, 0, ze + 1) : ue2(-Le2, T2 - ze - 1, T2), xe -= Le2, xe <= 0)
              return;
        }
        return V3;
      }
      function P_n(u, o, n3, p2) {
        return Kme(u, "x", "width", o, n3, p2);
      }
      function Xme(u, o, n3, p2) {
        return Kme(u, "y", "height", o, n3, p2);
      }
      function Qme(u) {
        var o = [];
        u.sort(function(gt, yt) {
          return yt.priority - gt.priority;
        });
        var n3 = new Qu(0, 0, 0, 0);
        function p2(gt) {
          if (!gt.ignore) {
            var yt = gt.ensureState("emphasis");
            yt.ignore == null && (yt.ignore = false);
          }
          gt.ignore = true;
        }
        for (var m2 = 0; m2 < u.length; m2++) {
          var w2 = u[m2], T2 = w2.axisAligned, E = w2.localRect, O2 = w2.transform, V3 = w2.label, W3 = w2.labelLine;
          n3.copy(w2.rect), n3.width -= 0.1, n3.height -= 0.1, n3.x += 0.05, n3.y += 0.05;
          for (var q3 = w2.obb, K = false, J = 0; J < o.length; J++) {
            var rt2 = o[J];
            if (n3.intersect(rt2.rect)) {
              if (T2 && rt2.axisAligned) {
                K = true;
                break;
              }
              if (rt2.obb || (rt2.obb = new B$(rt2.localRect, rt2.transform)), q3 || (q3 = new B$(E, O2)), q3.intersect(rt2.obb)) {
                K = true;
                break;
              }
            }
          }
          K ? (p2(V3), W3 && p2(W3)) : (V3.attr("ignore", w2.defaultAttr.ignore), W3 && W3.attr("ignore", w2.defaultAttr.labelGuideIgnore), o.push(w2));
        }
      }
      function L_n(u) {
        if (u) {
          for (var o = [], n3 = 0; n3 < u.length; n3++)
            o.push(u[n3].slice());
          return o;
        }
      }
      function O_n(u, o) {
        var n3 = u.label, p2 = o && o.getTextGuideLine();
        return { dataIndex: u.dataIndex, dataType: u.dataType, seriesIndex: u.seriesModel.seriesIndex, text: u.label.style.text, rect: u.hostRect, labelRect: u.rect, align: n3.style.align, verticalAlign: n3.style.verticalAlign, labelLinePoints: L_n(p2 && p2.shape.points) };
      }
      var Jme = ["align", "verticalAlign", "width", "height", "fontSize"], kC = new JS(), v9t = Ff2(), R_n = Ff2();
      function _xt(u, o, n3) {
        for (var p2 = 0; p2 < n3.length; p2++) {
          var m2 = n3[p2];
          o[m2] != null && (u[m2] = o[m2]);
        }
      }
      var xxt = ["x", "y", "rotation"], N_n = function() {
        function u() {
          this._labelList = [], this._chartViewList = [];
        }
        return u.prototype.clearLabels = function() {
          this._labelList = [], this._chartViewList = [];
        }, u.prototype._addLabel = function(o, n3, p2, m2, w2) {
          var T2 = m2.style, E = m2.__hostTarget, O2 = E.textConfig || {}, V3 = m2.getComputedTransform(), W3 = m2.getBoundingRect().plain();
          Qu.applyTransform(W3, W3, V3), V3 ? kC.setLocalTransform(V3) : (kC.x = kC.y = kC.rotation = kC.originX = kC.originY = 0, kC.scaleX = kC.scaleY = 1);
          var q3 = m2.__hostTarget, K;
          if (q3) {
            K = q3.getBoundingRect().plain();
            var J = q3.getComputedTransform();
            Qu.applyTransform(K, K, J);
          }
          var rt2 = K && q3.getTextGuideLine();
          this._labelList.push({ label: m2, labelLine: rt2, seriesModel: p2, dataIndex: o, dataType: n3, layoutOption: w2, computedLayoutOption: null, rect: W3, hostRect: K, priority: K ? K.width * K.height : 0, defaultAttr: { ignore: m2.ignore, labelGuideIgnore: rt2 && rt2.ignore, x: kC.x, y: kC.y, scaleX: kC.scaleX, scaleY: kC.scaleY, rotation: kC.rotation, style: { x: T2.x, y: T2.y, align: T2.align, verticalAlign: T2.verticalAlign, width: T2.width, height: T2.height, fontSize: T2.fontSize }, cursor: m2.cursor, attachedPos: O2.position, attachedRot: O2.rotation } });
        }, u.prototype.addLabelsOfSeries = function(o) {
          var n3 = this;
          this._chartViewList.push(o);
          var p2 = o.__model, m2 = p2.get("labelLayout");
          !(Sl(m2) || tf2(m2).length) || o.group.traverse(function(w2) {
            if (w2.ignore)
              return true;
            var T2 = w2.getTextContent(), E = is(w2);
            T2 && !T2.disableLabelLayout && n3._addLabel(E.dataIndex, E.dataType, p2, T2, m2);
          });
        }, u.prototype.updateLayoutConfig = function(o) {
          var n3 = o.getWidth(), p2 = o.getHeight();
          function m2(Wt, Nt) {
            return function() {
              qme(Wt, Nt);
            };
          }
          for (var w2 = 0; w2 < this._labelList.length; w2++) {
            var T2 = this._labelList[w2], E = T2.label, O2 = E.__hostTarget, V3 = T2.defaultAttr, W3 = void 0;
            Sl(T2.layoutOption) ? W3 = T2.layoutOption(O_n(T2, O2)) : W3 = T2.layoutOption, W3 = W3 || {}, T2.computedLayoutOption = W3;
            var q3 = Math.PI / 180;
            O2 && O2.setTextConfig({ local: false, position: W3.x != null || W3.y != null ? null : V3.attachedPos, rotation: W3.rotate != null ? W3.rotate * q3 : V3.attachedRot, offset: [W3.dx || 0, W3.dy || 0] });
            var K = false;
            if (W3.x != null ? (E.x = Qo(W3.x, n3), E.setStyle("x", 0), K = true) : (E.x = V3.x, E.setStyle("x", V3.style.x)), W3.y != null ? (E.y = Qo(W3.y, p2), E.setStyle("y", 0), K = true) : (E.y = V3.y, E.setStyle("y", V3.style.y)), W3.labelLinePoints) {
              var J = O2.getTextGuideLine();
              J && (J.setShape({ points: W3.labelLinePoints }), K = false);
            }
            var rt2 = v9t(E);
            rt2.needsUpdateLabelLine = K, E.rotation = W3.rotate != null ? W3.rotate * q3 : V3.rotation, E.scaleX = V3.scaleX, E.scaleY = V3.scaleY;
            for (var gt = 0; gt < Jme.length; gt++) {
              var yt = Jme[gt];
              E.setStyle(yt, W3[yt] != null ? W3[yt] : V3.style[yt]);
            }
            if (W3.draggable) {
              if (E.draggable = true, E.cursor = "move", O2) {
                var At = T2.seriesModel;
                if (T2.dataIndex != null) {
                  var Lt = T2.seriesModel.getData(T2.dataType);
                  At = Lt.getItemModel(T2.dataIndex);
                }
                E.on("drag", m2(O2, At.getModel("labelLine")));
              }
            } else
              E.off("drag"), E.cursor = V3.cursor;
          }
        }, u.prototype.layout = function(o) {
          var n3 = o.getWidth(), p2 = o.getHeight(), m2 = Yme(this._labelList), w2 = Fp(m2, function(O2) {
            return O2.layoutOption.moveOverlap === "shiftX";
          }), T2 = Fp(m2, function(O2) {
            return O2.layoutOption.moveOverlap === "shiftY";
          });
          P_n(w2, 0, n3), Xme(T2, 0, p2);
          var E = Fp(m2, function(O2) {
            return O2.layoutOption.hideOverlap;
          });
          Qme(E);
        }, u.prototype.processLabelsOverall = function() {
          var o = this;
          Xe2(this._chartViewList, function(n3) {
            var p2 = n3.__model, m2 = n3.ignoreLabelLineUpdate, w2 = p2.isAnimationEnabled();
            n3.group.traverse(function(T2) {
              if (T2.ignore && !T2.forceLabelAnimation)
                return true;
              var E = !m2, O2 = T2.getTextContent();
              !E && O2 && (E = v9t(O2).needsUpdateLabelLine), E && o._updateLabelLine(T2, p2), w2 && o._animateLabels(T2, p2);
            });
          });
        }, u.prototype._updateLabelLine = function(o, n3) {
          var p2 = o.getTextContent(), m2 = is(o), w2 = m2.dataIndex;
          if (p2 && w2 != null) {
            var T2 = n3.getData(m2.dataType), E = T2.getItemModel(w2), O2 = {}, V3 = T2.getItemVisual(w2, "style"), W3 = T2.getVisual("drawType");
            O2.stroke = V3[W3];
            var q3 = E.getModel("labelLine");
            d9t(o, g9t(E), O2), qme(o, q3);
          }
        }, u.prototype._animateLabels = function(o, n3) {
          var p2 = o.getTextContent(), m2 = o.getTextGuideLine();
          if (p2 && (o.forceLabelAnimation || !p2.ignore && !p2.invisible && !o.disableLabelAnimation && !e8(o))) {
            var w2 = v9t(p2), T2 = w2.oldLayout, E = is(o), O2 = E.dataIndex, V3 = { x: p2.x, y: p2.y, rotation: p2.rotation }, W3 = n3.getData(E.dataType);
            if (T2) {
              p2.attr(T2);
              var q3 = o.prevStates;
              q3 && (sc2(q3, "select") >= 0 && p2.attr(w2.oldLayoutSelect), sc2(q3, "emphasis") >= 0 && p2.attr(w2.oldLayoutEmphasis)), Xf2(p2, V3, n3, O2);
            } else if (p2.attr(V3), !H$(p2).valueAnimation) {
              var K = Xu(p2.style.opacity, 1);
              p2.style.opacity = 0, Qg2(p2, { style: { opacity: K } }, n3, O2);
            }
            if (w2.oldLayout = V3, p2.states.select) {
              var J = w2.oldLayoutSelect = {};
              _xt(J, V3, xxt), _xt(J, p2.states.select, xxt);
            }
            if (p2.states.emphasis) {
              var rt2 = w2.oldLayoutEmphasis = {};
              _xt(rt2, V3, xxt), _xt(rt2, p2.states.emphasis, xxt);
            }
            vve(p2, O2, W3, n3, n3);
          }
          if (m2 && !m2.ignore && !m2.invisible) {
            var w2 = R_n(m2), T2 = w2.oldLayout, gt = { points: m2.shape.points };
            T2 ? (m2.attr({ shape: T2 }), Xf2(m2, { shape: gt }, n3)) : (m2.setShape(gt), m2.style.strokePercent = 0, Qg2(m2, { style: { strokePercent: 1 } }, n3)), w2.oldLayout = gt;
          }
        }, u;
      }(), F_n = N_n, y9t = Ff2();
      function V_n(u) {
        u.registerUpdateLifecycle("series:beforeupdate", function(o, n3, p2) {
          var m2 = y9t(n3).labelManager;
          m2 || (m2 = y9t(n3).labelManager = new F_n()), m2.clearLabels();
        }), u.registerUpdateLifecycle("series:layoutlabels", function(o, n3, p2) {
          var m2 = y9t(n3).labelManager;
          p2.updatedSeries.forEach(function(w2) {
            m2.addLabelsOfSeries(n3.getViewOfSeriesModel(w2));
          }), m2.updateLayoutConfig(n3), m2.layout(n3), m2.processLabelsOverall();
        });
      }
      var m9t = Math.sin, b9t = Math.cos, t1e = Math.PI, Bz = Math.PI * 2, B_n = 180 / t1e, z_n = function() {
        function u() {
        }
        return u.prototype.reset = function(o) {
          this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, o || 4);
        }, u.prototype.moveTo = function(o, n3) {
          this._add("M", o, n3);
        }, u.prototype.lineTo = function(o, n3) {
          this._add("L", o, n3);
        }, u.prototype.bezierCurveTo = function(o, n3, p2, m2, w2, T2) {
          this._add("C", o, n3, p2, m2, w2, T2);
        }, u.prototype.quadraticCurveTo = function(o, n3, p2, m2) {
          this._add("Q", o, n3, p2, m2);
        }, u.prototype.arc = function(o, n3, p2, m2, w2, T2) {
          this.ellipse(o, n3, p2, p2, 0, m2, w2, T2);
        }, u.prototype.ellipse = function(o, n3, p2, m2, w2, T2, E, O2) {
          var V3 = E - T2, W3 = !O2, q3 = Math.abs(V3), K = SP(q3 - Bz) || (W3 ? V3 >= Bz : -V3 >= Bz), J = V3 > 0 ? V3 % Bz : V3 % Bz + Bz, rt2 = false;
          K ? rt2 = true : SP(q3) ? rt2 = false : rt2 = J >= t1e == !!W3;
          var gt = o + p2 * b9t(T2), yt = n3 + m2 * m9t(T2);
          this._start && this._add("M", gt, yt);
          var At = Math.round(w2 * B_n);
          if (K) {
            var Lt = 1 / this._p, Wt = (W3 ? 1 : -1) * (Bz - Lt);
            this._add("A", p2, m2, At, 1, +W3, o + p2 * b9t(T2 + Wt), n3 + m2 * m9t(T2 + Wt)), Lt > 0.01 && this._add("A", p2, m2, At, 0, +W3, gt, yt);
          } else {
            var Nt = o + p2 * b9t(E), ue2 = n3 + m2 * m9t(E);
            this._add("A", p2, m2, At, +rt2, +W3, Nt, ue2);
          }
        }, u.prototype.rect = function(o, n3, p2, m2) {
          this._add("M", o, n3), this._add("l", p2, 0), this._add("l", 0, m2), this._add("l", -p2, 0), this._add("Z");
        }, u.prototype.closePath = function() {
          this._d.length > 0 && this._add("Z");
        }, u.prototype._add = function(o, n3, p2, m2, w2, T2, E, O2, V3) {
          for (var W3 = [], q3 = this._p, K = 1; K < arguments.length; K++) {
            var J = arguments[K];
            if (isNaN(J)) {
              this._invalid = true;
              return;
            }
            W3.push(Math.round(J * q3) / q3);
          }
          this._d.push(o + W3.join(" ")), this._start = o === "Z";
        }, u.prototype.generateStr = function() {
          this._str = this._invalid ? "" : this._d.join(""), this._d = [];
        }, u.prototype.getStr = function() {
          return this._str;
        }, u;
      }(), e1e = z_n, Qot = "none", j_n = Math.round;
      function W_n(u) {
        var o = u.fill;
        return o != null && o !== Qot;
      }
      function G_n(u) {
        var o = u.stroke;
        return o != null && o !== Qot;
      }
      var _9t = ["lineCap", "miterLimit", "lineJoin"], H_n = Ya2(_9t, function(u) {
        return "stroke-" + u.toLowerCase();
      });
      function U_n(u, o, n3, p2) {
        var m2 = o.opacity == null ? 1 : o.opacity;
        if (n3 instanceof Fm) {
          u("opacity", m2);
          return;
        }
        if (W_n(o)) {
          var w2 = FF(o.fill);
          u("fill", w2.color);
          var T2 = o.fillOpacity != null ? o.fillOpacity * w2.opacity * m2 : w2.opacity * m2;
          (p2 || T2 < 1) && u("fill-opacity", T2);
        } else
          u("fill", Qot);
        if (G_n(o)) {
          var E = FF(o.stroke);
          u("stroke", E.color);
          var O2 = o.strokeNoScale ? n3.getLineScale() : 1, V3 = O2 ? (o.lineWidth || 0) / O2 : 0, W3 = o.strokeOpacity != null ? o.strokeOpacity * E.opacity * m2 : E.opacity * m2, q3 = o.strokeFirst;
          if ((p2 || V3 !== 1) && u("stroke-width", V3), (p2 || q3) && u("paint-order", q3 ? "stroke" : "fill"), (p2 || W3 < 1) && u("stroke-opacity", W3), o.lineDash) {
            var K = R8t(n3), J = K[0], rt2 = K[1];
            J && (rt2 = j_n(rt2 || 0), u("stroke-dasharray", J.join(",")), (rt2 || p2) && u("stroke-dashoffset", rt2));
          } else
            p2 && u("stroke-dasharray", Qot);
          for (var gt = 0; gt < _9t.length; gt++) {
            var yt = _9t[gt];
            if (p2 || o[yt] !== M$[yt]) {
              var At = o[yt] || M$[yt];
              At && u(H_n[gt], At);
            }
          }
        } else
          p2 && u("stroke", Qot);
      }
      var n1e = "http://www.w3.org/2000/svg", r1e = "http://www.w3.org/1999/xlink", q_n = "http://www.w3.org/2000/xmlns/", Z_n = "http://www.w3.org/XML/1998/namespace";
      function i1e(u) {
        return document.createElementNS(n1e, u);
      }
      function P1(u, o, n3, p2, m2) {
        return { tag: u, attrs: n3 || {}, children: p2, text: m2, key: o };
      }
      function $_n(u, o) {
        var n3 = [];
        if (o)
          for (var p2 in o) {
            var m2 = o[p2], w2 = p2;
            m2 !== false && (m2 !== true && m2 != null && (w2 += '="' + m2 + '"'), n3.push(w2));
          }
        return "<" + u + " " + n3.join(" ") + ">";
      }
      function Y_n(u) {
        return "</" + u + ">";
      }
      function x9t(u, o) {
        o = o || {};
        var n3 = o.newline ? `
` : "";
        function p2(m2) {
          var w2 = m2.children, T2 = m2.tag, E = m2.attrs;
          return $_n(T2, E) + (m2.text || "") + (w2 ? "" + n3 + Ya2(w2, function(O2) {
            return p2(O2);
          }).join(n3) + n3 : "") + Y_n(T2);
        }
        return p2(u);
      }
      function K_n(u, o, n3) {
        n3 = n3 || {};
        var p2 = n3.newline ? `
` : "", m2 = " {" + p2, w2 = p2 + "}", T2 = Ya2(tf2(u), function(O2) {
          return O2 + m2 + Ya2(tf2(u[O2]), function(V3) {
            return V3 + ":" + u[O2][V3] + ";";
          }).join(p2) + w2;
        }).join(p2), E = Ya2(tf2(o), function(O2) {
          return "@keyframes " + O2 + m2 + Ya2(tf2(o[O2]), function(V3) {
            return V3 + m2 + Ya2(tf2(o[O2][V3]), function(W3) {
              var q3 = o[O2][V3][W3];
              return W3 === "d" && (q3 = 'path("' + q3 + '")'), W3 + ":" + q3 + ";";
            }).join(p2) + w2;
          }).join(p2) + w2;
        }).join(p2);
        return !T2 && !E ? "" : ["<![CDATA[", T2, E, "]]>"].join(p2);
      }
      function w9t(u) {
        return { zrId: u, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
      }
      function a1e(u, o, n3, p2) {
        return P1("svg", "root", { width: u, height: o, xmlns: n1e, "xmlns:xlink": r1e, version: "1.1", baseProfile: "full", viewBox: p2 ? "0 0 " + u + " " + o : false }, n3);
      }
      var o1e = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, zz = "transform-origin";
      function X_n(u, o, n3) {
        var p2 = ua2({}, u.shape);
        ua2(p2, o), u.buildPath(n3, p2);
        var m2 = new e1e();
        return m2.reset(H1t(u)), n3.rebuildPath(m2, 1), m2.generateStr(), m2.getStr();
      }
      function Q_n(u, o) {
        var n3 = o.originX, p2 = o.originY;
        (n3 || p2) && (u[zz] = n3 + "px " + p2 + "px");
      }
      var J_n = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
      function s1e(u, o) {
        var n3 = o.zrId + "-ani-" + o.cssAnimIdx++;
        return o.cssAnims[n3] = u, n3;
      }
      function txn(u, o, n3) {
        var p2 = u.shape.paths, m2 = {}, w2, T2;
        if (Xe2(p2, function(O2) {
          var V3 = w9t(n3.zrId);
          V3.animation = true, wxt(O2, {}, V3, true);
          var W3 = V3.cssAnims, q3 = V3.cssNodes, K = tf2(W3), J = K.length;
          if (J) {
            T2 = K[J - 1];
            var rt2 = W3[T2];
            for (var gt in rt2) {
              var yt = rt2[gt];
              m2[gt] = m2[gt] || { d: "" }, m2[gt].d += yt.d || "";
            }
            for (var At in q3) {
              var Lt = q3[At].animation;
              Lt.indexOf(T2) >= 0 && (w2 = Lt);
            }
          }
        }), !!w2) {
          o.d = false;
          var E = s1e(m2, n3);
          return w2.replace(T2, E);
        }
      }
      function l1e(u) {
        return ds(u) ? o1e[u] ? "cubic-bezier(" + o1e[u] + ")" : KB(u) ? u : "" : "";
      }
      function wxt(u, o, n3, p2) {
        var m2 = u.animators, w2 = m2.length, T2 = [];
        if (u instanceof got) {
          var E = txn(u, o, n3);
          if (E)
            T2.push(E);
          else if (!w2)
            return;
        } else if (!w2)
          return;
        for (var O2 = {}, V3 = 0; V3 < w2; V3++) {
          var W3 = m2[V3], q3 = [W3.getMaxTime() / 1e3 + "s"], K = l1e(W3.getClip().easing), J = W3.getDelay();
          K ? q3.push(K) : q3.push("linear"), J && q3.push(J / 1e3 + "s"), W3.getLoop() && q3.push("infinite");
          var rt2 = q3.join(" ");
          O2[rt2] = O2[rt2] || [rt2, []], O2[rt2][1].push(W3);
        }
        function gt(Lt) {
          var Wt = Lt[1], Nt = Wt.length, ue2 = {}, ie2 = {}, pe2 = {}, xe = "animation-timing-function";
          function Ce2(as, Hs, ol) {
            for (var xs = as.getTracks(), Bl = as.getMaxTime(), Ph2 = 0; Ph2 < xs.length; Ph2++) {
              var fu = xs[Ph2];
              if (fu.needsAnimate()) {
                var uh2 = fu.keyframes, Zh2 = fu.propName;
                if (ol && (Zh2 = ol(Zh2)), Zh2)
                  for (var zp = 0; zp < uh2.length; zp++) {
                    var tm = uh2[zp], Fd2 = Math.round(tm.time / Bl * 100) + "%", O1 = l1e(tm.easing), Kd2 = tm.rawValue;
                    (ds(Kd2) || Dh2(Kd2)) && (Hs[Fd2] = Hs[Fd2] || {}, Hs[Fd2][Zh2] = tm.rawValue, O1 && (Hs[Fd2][xe] = O1));
                  }
              }
            }
          }
          for (var Le2 = 0; Le2 < Nt; Le2++) {
            var ze = Wt[Le2], tn = ze.targetName;
            tn ? tn === "shape" && Ce2(ze, ie2) : !p2 && Ce2(ze, ue2);
          }
          for (var $e2 in ue2) {
            var Tn = {};
            ebt(Tn, u), ua2(Tn, ue2[$e2]);
            var zn = eat(Tn), bn = ue2[$e2][xe];
            pe2[$e2] = zn ? { transform: zn } : {}, Q_n(pe2[$e2], Tn), bn && (pe2[$e2][xe] = bn);
          }
          var Xr, Xn = true;
          for (var $e2 in ie2) {
            pe2[$e2] = pe2[$e2] || {};
            var or = !Xr, bn = ie2[$e2][xe];
            or && (Xr = new iI());
            var Tr = Xr.len();
            Xr.reset(), pe2[$e2].d = X_n(u, ie2[$e2], Xr);
            var ci2 = Xr.len();
            if (!or && Tr !== ci2) {
              Xn = false;
              break;
            }
            bn && (pe2[$e2][xe] = bn);
          }
          if (!Xn)
            for (var $e2 in pe2)
              delete pe2[$e2].d;
          if (!p2)
            for (var Le2 = 0; Le2 < Nt; Le2++) {
              var ze = Wt[Le2], tn = ze.targetName;
              tn === "style" && Ce2(ze, pe2, function(xs) {
                return J_n[xs];
              });
            }
          for (var yi2 = tf2(pe2), Po = true, Ms, Le2 = 1; Le2 < yi2.length; Le2++) {
            var dl = yi2[Le2 - 1], tl = yi2[Le2];
            if (pe2[dl][zz] !== pe2[tl][zz]) {
              Po = false;
              break;
            }
            Ms = pe2[dl][zz];
          }
          if (Po && Ms) {
            for (var $e2 in pe2)
              pe2[$e2][zz] && delete pe2[$e2][zz];
            o[zz] = Ms;
          }
          if (Fp(yi2, function(as) {
            return tf2(pe2[as]).length > 0;
          }).length) {
            var el = s1e(pe2, n3);
            return el + " " + Lt[0] + " both";
          }
        }
        for (var yt in O2) {
          var E = gt(O2[yt]);
          E && T2.push(E);
        }
        if (T2.length) {
          var At = n3.zrId + "-cls-" + n3.cssClassIdx++;
          n3.cssNodes["." + At] = { animation: T2.join(",") }, o.class = At;
        }
      }
      var Jot = Math.round;
      function u1e(u) {
        return u && ds(u.src);
      }
      function c1e(u) {
        return u && Sl(u.toDataURL);
      }
      function S9t(u, o, n3, p2) {
        U_n(function(m2, w2) {
          var T2 = m2 === "fill" || m2 === "stroke";
          T2 && rNt(w2) ? lxn(o, u, m2, p2) : T2 && CC(w2) ? uxn(n3, u, m2, p2) : u[m2] = w2;
        }, o, n3, false), sxn(n3, u, p2);
      }
      function f1e(u) {
        return SP(u[0] - 1) && SP(u[1]) && SP(u[2]) && SP(u[3] - 1);
      }
      function exn(u) {
        return SP(u[4]) && SP(u[5]);
      }
      function M9t(u, o, n3) {
        if (o && !(exn(o) && f1e(o))) {
          var p2 = n3 ? 10 : 1e4;
          u.transform = f1e(o) ? "translate(" + Jot(o[4] * p2) / p2 + " " + Jot(o[5] * p2) / p2 + ")" : Q6t(o);
        }
      }
      function h1e(u, o, n3) {
        for (var p2 = u.points, m2 = [], w2 = 0; w2 < p2.length; w2++)
          m2.push(Jot(p2[w2][0] * n3) / n3), m2.push(Jot(p2[w2][1] * n3) / n3);
        o.points = m2.join(" ");
      }
      function p1e(u) {
        return !u.smooth;
      }
      function nxn(u) {
        var o = Ya2(u, function(n3) {
          return typeof n3 == "string" ? [n3, n3] : n3;
        });
        return function(n3, p2, m2) {
          for (var w2 = 0; w2 < o.length; w2++) {
            var T2 = o[w2], E = n3[T2[0]];
            E != null && (p2[T2[1]] = Jot(E * m2) / m2);
          }
        };
      }
      var rxn = { circle: [nxn(["cx", "cy", "r"])], polyline: [h1e, p1e], polygon: [h1e, p1e] };
      function ixn(u) {
        for (var o = u.animators, n3 = 0; n3 < o.length; n3++)
          if (o[n3].targetName === "shape")
            return true;
        return false;
      }
      function d1e(u, o) {
        var n3 = u.style, p2 = u.shape, m2 = rxn[u.type], w2 = {}, T2 = o.animation, E = "path", O2 = u.style.strokePercent, V3 = o.compress && H1t(u) || 4;
        if (m2 && !o.willUpdate && !(m2[1] && !m2[1](p2)) && !(T2 && ixn(u)) && !(O2 < 1)) {
          E = u.type;
          var W3 = Math.pow(10, V3);
          m2[0](p2, w2, W3);
        } else {
          u.path || u.createPathProxy();
          var q3 = u.path;
          u.shapeChanged() && (q3.beginPath(), u.buildPath(q3, u.shape), u.pathUpdated());
          var K = q3.getVersion(), J = u, rt2 = J.__svgPathBuilder;
          (J.__svgPathVersion !== K || !rt2 || O2 !== J.__svgPathStrokePercent) && (rt2 || (rt2 = J.__svgPathBuilder = new e1e()), rt2.reset(V3), q3.rebuildPath(rt2, O2), rt2.generateStr(), J.__svgPathVersion = K, J.__svgPathStrokePercent = O2), w2.d = rt2.getStr();
        }
        return M9t(w2, u.transform), S9t(w2, n3, u, o), o.animation && wxt(u, w2, o), P1(E, u.id + "", w2);
      }
      function axn(u, o) {
        var n3 = u.style, p2 = n3.image;
        if (p2 && !ds(p2) && (u1e(p2) ? p2 = p2.src : c1e(p2) && (p2 = p2.toDataURL())), !!p2) {
          var m2 = n3.x || 0, w2 = n3.y || 0, T2 = n3.width, E = n3.height, O2 = { href: p2, width: T2, height: E };
          return m2 && (O2.x = m2), w2 && (O2.y = w2), M9t(O2, u.transform), S9t(O2, n3, u, o), o.animation && wxt(u, O2, o), P1("image", u.id + "", O2);
        }
      }
      function oxn(u, o) {
        var n3 = u.style, p2 = n3.text;
        if (p2 != null && (p2 += ""), !(!p2 || isNaN(n3.x) || isNaN(n3.y))) {
          var m2 = n3.font || Fu, w2 = n3.x || 0, T2 = tNt(n3.y || 0, GF(m2), n3.textBaseline), E = J6t[n3.textAlign] || n3.textAlign, O2 = { "dominant-baseline": "central", "text-anchor": E };
          if (Ubt(n3)) {
            var V3 = "", W3 = n3.fontStyle, q3 = Gbt(n3.fontSize);
            if (!parseFloat(q3))
              return;
            var K = n3.fontFamily || dv, J = n3.fontWeight;
            V3 += "font-size:" + q3 + ";font-family:" + K + ";", W3 && W3 !== "normal" && (V3 += "font-style:" + W3 + ";"), J && J !== "normal" && (V3 += "font-weight:" + J + ";"), O2.style = V3;
          } else
            O2.style = "font: " + m2;
          return p2.match(/\s/) && (O2["xml:space"] = "preserve"), w2 && (O2.x = w2), T2 && (O2.y = T2), M9t(O2, u.transform), S9t(O2, n3, u, o), o.animation && wxt(u, O2, o), P1("text", u.id + "", O2, void 0, p2);
        }
      }
      function g1e(u, o) {
        if (u instanceof Mc2)
          return d1e(u, o);
        if (u instanceof Fm)
          return axn(u, o);
        if (u instanceof gz)
          return oxn(u, o);
      }
      function sxn(u, o, n3) {
        var p2 = u.style;
        if (eNt(p2)) {
          var m2 = YO(u), w2 = n3.shadowCache, T2 = w2[m2];
          if (!T2) {
            var E = u.getGlobalScale(), O2 = E[0], V3 = E[1];
            if (!O2 || !V3)
              return;
            var W3 = p2.shadowOffsetX || 0, q3 = p2.shadowOffsetY || 0, K = p2.shadowBlur, J = FF(p2.shadowColor), rt2 = J.opacity, gt = J.color, yt = K / 2 / O2, At = K / 2 / V3, Lt = yt + " " + At;
            T2 = n3.zrId + "-s" + n3.shadowIdx++, n3.defs[T2] = P1("filter", T2, { id: T2, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [P1("feDropShadow", "", { dx: W3 / O2, dy: q3 / V3, stdDeviation: Lt, "flood-color": gt, "flood-opacity": rt2 })]), w2[m2] = T2;
          }
          o.filter = $Z(T2);
        }
      }
      function lxn(u, o, n3, p2) {
        var m2 = u[n3], w2, T2 = { gradientUnits: m2.global ? "userSpaceOnUse" : "objectBoundingBox" };
        if (W1t(m2))
          w2 = "linearGradient", T2.x1 = m2.x, T2.y1 = m2.y, T2.x2 = m2.x2, T2.y2 = m2.y2;
        else if (G1t(m2))
          w2 = "radialGradient", T2.cx = Xu(m2.x, 0.5), T2.cy = Xu(m2.y, 0.5), T2.r = Xu(m2.r, 0.5);
        else
          return;
        for (var E = m2.colorStops, O2 = [], V3 = 0, W3 = E.length; V3 < W3; ++V3) {
          var q3 = tat(E[V3].offset) * 100 + "%", K = E[V3].color, J = FF(K), rt2 = J.color, gt = J.opacity, yt = { offset: q3 };
          yt["stop-color"] = rt2, gt < 1 && (yt["stop-opacity"] = gt), O2.push(P1("stop", V3 + "", yt));
        }
        var At = P1(w2, "", T2, O2), Lt = x9t(At), Wt = p2.gradientCache, Nt = Wt[Lt];
        Nt || (Nt = p2.zrId + "-g" + p2.gradientIdx++, Wt[Lt] = Nt, T2.id = Nt, p2.defs[Nt] = P1(w2, Nt, T2, O2)), o[n3] = $Z(Nt);
      }
      function uxn(u, o, n3, p2) {
        var m2 = u.style[n3], w2 = { patternUnits: "userSpaceOnUse" }, T2;
        if (j1t(m2)) {
          var E = m2.imageWidth, O2 = m2.imageHeight, V3 = void 0, W3 = m2.image;
          if (ds(W3) ? V3 = W3 : u1e(W3) ? V3 = W3.src : c1e(W3) && (V3 = W3.toDataURL()), typeof Image == "undefined") {
            var q3 = "Image width/height must been given explictly in svg-ssr renderer.";
            Tb2(E, q3), Tb2(O2, q3);
          } else if (E == null || O2 == null) {
            var K = function(Lt, Wt) {
              if (Lt) {
                var Nt = Lt.elm, ue2 = Lt.attrs.width = E || Wt.width, ie2 = Lt.attrs.height = O2 || Wt.height;
                Nt && (Nt.setAttribute("width", ue2), Nt.setAttribute("height", ie2));
              }
            }, J = y$(V3, null, u, function(Lt) {
              K(rt2, Lt), K(T2, Lt);
            });
            J && J.width && J.height && (E = E || J.width, O2 = O2 || J.height);
          }
          T2 = P1("image", "img", { href: V3, width: E, height: O2 }), w2.width = E, w2.height = O2;
        } else
          m2.svgElement && (T2 = jl(m2.svgElement), w2.width = m2.svgWidth, w2.height = m2.svgHeight);
        if (T2) {
          w2.patternTransform = eat(m2);
          var rt2 = P1("pattern", "", w2, [T2]), gt = x9t(rt2), yt = p2.patternCache, At = yt[gt];
          At || (At = p2.zrId + "-p" + p2.patternIdx++, yt[gt] = At, w2.id = At, rt2 = p2.defs[At] = P1("pattern", At, w2, [T2])), o[n3] = $Z(At);
        }
      }
      function cxn(u, o, n3) {
        var p2 = n3.clipPathCache, m2 = n3.defs, w2 = p2[u.id];
        if (!w2) {
          w2 = n3.zrId + "-c" + n3.clipPathIdx++;
          var T2 = { id: w2 };
          p2[u.id] = w2, m2[w2] = P1("clipPath", w2, T2, [d1e(u, n3)]);
        }
        o["clip-path"] = $Z(w2);
      }
      function v1e(u) {
        return document.createTextNode(u);
      }
      function jz(u, o, n3) {
        u.insertBefore(o, n3);
      }
      function y1e(u, o) {
        u.removeChild(o);
      }
      function m1e(u, o) {
        u.appendChild(o);
      }
      function b1e(u) {
        return u.parentNode;
      }
      function _1e(u) {
        return u.nextSibling;
      }
      function C9t(u, o) {
        u.textContent = o;
      }
      var x1e = 58, fxn = 120, hxn = P1("", "");
      function T9t(u) {
        return u === void 0;
      }
      function XP(u) {
        return u !== void 0;
      }
      function pxn(u, o, n3) {
        for (var p2 = {}, m2 = o; m2 <= n3; ++m2) {
          var w2 = u[m2].key;
          w2 !== void 0 && (p2[w2] = m2);
        }
        return p2;
      }
      function tst(u, o) {
        var n3 = u.key === o.key, p2 = u.tag === o.tag;
        return p2 && n3;
      }
      function est(u) {
        var o, n3 = u.children, p2 = u.tag;
        if (XP(p2)) {
          var m2 = u.elm = i1e(p2);
          if (A9t(hxn, u), za2(n3))
            for (o = 0; o < n3.length; ++o) {
              var w2 = n3[o];
              w2 != null && m1e(m2, est(w2));
            }
          else
            XP(u.text) && !ys(u.text) && m1e(m2, v1e(u.text));
        } else
          u.elm = v1e(u.text);
        return u.elm;
      }
      function w1e(u, o, n3, p2, m2) {
        for (; p2 <= m2; ++p2) {
          var w2 = n3[p2];
          w2 != null && jz(u, est(w2), o);
        }
      }
      function Sxt(u, o, n3, p2) {
        for (; n3 <= p2; ++n3) {
          var m2 = o[n3];
          if (m2 != null)
            if (XP(m2.tag)) {
              var w2 = b1e(m2.elm);
              y1e(w2, m2.elm);
            } else
              y1e(u, m2.elm);
        }
      }
      function A9t(u, o) {
        var n3, p2 = o.elm, m2 = u && u.attrs || {}, w2 = o.attrs || {};
        if (m2 !== w2) {
          for (n3 in w2) {
            var T2 = w2[n3], E = m2[n3];
            E !== T2 && (T2 === true ? p2.setAttribute(n3, "") : T2 === false ? p2.removeAttribute(n3) : n3.charCodeAt(0) !== fxn ? p2.setAttribute(n3, T2) : n3 === "xmlns:xlink" || n3 === "xmlns" ? p2.setAttributeNS(q_n, n3, T2) : n3.charCodeAt(3) === x1e ? p2.setAttributeNS(Z_n, n3, T2) : n3.charCodeAt(5) === x1e ? p2.setAttributeNS(r1e, n3, T2) : p2.setAttribute(n3, T2));
          }
          for (n3 in m2)
            n3 in w2 || p2.removeAttribute(n3);
        }
      }
      function dxn(u, o, n3) {
        for (var p2 = 0, m2 = 0, w2 = o.length - 1, T2 = o[0], E = o[w2], O2 = n3.length - 1, V3 = n3[0], W3 = n3[O2], q3, K, J, rt2; p2 <= w2 && m2 <= O2; )
          T2 == null ? T2 = o[++p2] : E == null ? E = o[--w2] : V3 == null ? V3 = n3[++m2] : W3 == null ? W3 = n3[--O2] : tst(T2, V3) ? (cY(T2, V3), T2 = o[++p2], V3 = n3[++m2]) : tst(E, W3) ? (cY(E, W3), E = o[--w2], W3 = n3[--O2]) : tst(T2, W3) ? (cY(T2, W3), jz(u, T2.elm, _1e(E.elm)), T2 = o[++p2], W3 = n3[--O2]) : tst(E, V3) ? (cY(E, V3), jz(u, E.elm, T2.elm), E = o[--w2], V3 = n3[++m2]) : (T9t(q3) && (q3 = pxn(o, p2, w2)), K = q3[V3.key], T9t(K) ? jz(u, est(V3), T2.elm) : (J = o[K], J.tag !== V3.tag ? jz(u, est(V3), T2.elm) : (cY(J, V3), o[K] = void 0, jz(u, J.elm, T2.elm))), V3 = n3[++m2]);
        (p2 <= w2 || m2 <= O2) && (p2 > w2 ? (rt2 = n3[O2 + 1] == null ? null : n3[O2 + 1].elm, w1e(u, rt2, n3, m2, O2)) : Sxt(u, o, p2, w2));
      }
      function cY(u, o) {
        var n3 = o.elm = u.elm, p2 = u.children, m2 = o.children;
        u !== o && (A9t(u, o), T9t(o.text) ? XP(p2) && XP(m2) ? p2 !== m2 && dxn(n3, p2, m2) : XP(m2) ? (XP(u.text) && C9t(n3, ""), w1e(n3, null, m2, 0, m2.length - 1)) : XP(p2) ? Sxt(n3, p2, 0, p2.length - 1) : XP(u.text) && C9t(n3, "") : u.text !== o.text && (XP(p2) && Sxt(n3, p2, 0, p2.length - 1), C9t(n3, o.text)));
      }
      function gxn(u, o) {
        if (tst(u, o))
          cY(u, o);
        else {
          var n3 = u.elm, p2 = b1e(n3);
          est(o), p2 !== null && (jz(p2, o.elm, _1e(n3)), Sxt(p2, [u], 0, 0));
        }
        return o;
      }
      var vxn = 0, yxn = function() {
        function u(o, n3, p2) {
          if (this.type = "svg", this.refreshHover = S1e(), this.configLayer = S1e(), this.storage = n3, this._opts = p2 = ua2({}, p2), this.root = o, this._id = "zr" + vxn++, this._oldVNode = a1e(p2.width, p2.height), o && !p2.ssr) {
            var m2 = this._viewport = document.createElement("div");
            m2.style.cssText = "position:relative;overflow:hidden";
            var w2 = this._svgDom = this._oldVNode.elm = i1e("svg");
            A9t(null, this._oldVNode), m2.appendChild(w2), o.appendChild(m2);
          }
          this.resize(p2.width, p2.height);
        }
        return u.prototype.getType = function() {
          return this.type;
        }, u.prototype.getViewportRoot = function() {
          return this._viewport;
        }, u.prototype.getViewportRootOffset = function() {
          var o = this.getViewportRoot();
          if (o)
            return { offsetLeft: o.offsetLeft || 0, offsetTop: o.offsetTop || 0 };
        }, u.prototype.getSvgDom = function() {
          return this._svgDom;
        }, u.prototype.refresh = function() {
          if (this.root) {
            var o = this.renderToVNode({ willUpdate: true });
            o.attrs.style = "position:absolute;left:0;top:0;user-select:none", gxn(this._oldVNode, o), this._oldVNode = o;
          }
        }, u.prototype.renderOneToVNode = function(o) {
          return g1e(o, w9t(this._id));
        }, u.prototype.renderToVNode = function(o) {
          o = o || {};
          var n3 = this.storage.getDisplayList(true), p2 = this._backgroundColor, m2 = this._width, w2 = this._height, T2 = w9t(this._id);
          T2.animation = o.animation, T2.willUpdate = o.willUpdate, T2.compress = o.compress;
          var E = [];
          if (p2 && p2 !== "none") {
            var O2 = FF(p2), V3 = O2.color, W3 = O2.opacity;
            this._bgVNode = P1("rect", "bg", { width: m2, height: w2, x: "0", y: "0", id: "0", fill: V3, "fill-opacity": W3 }), E.push(this._bgVNode);
          } else
            this._bgVNode = null;
          var q3 = o.compress ? null : this._mainVNode = P1("g", "main", {}, []);
          this._paintList(n3, T2, q3 ? q3.children : E), q3 && E.push(q3);
          var K = Ya2(tf2(T2.defs), function(gt) {
            return T2.defs[gt];
          });
          if (K.length && E.push(P1("defs", "defs", {}, K)), o.animation) {
            var J = K_n(T2.cssNodes, T2.cssAnims, { newline: true });
            if (J) {
              var rt2 = P1("style", "stl", {}, [], J);
              E.push(rt2);
            }
          }
          return a1e(m2, w2, E, o.useViewBox);
        }, u.prototype.renderToString = function(o) {
          return o = o || {}, x9t(this.renderToVNode({ animation: Xu(o.cssAnimation, true), willUpdate: false, compress: true, useViewBox: Xu(o.useViewBox, true) }), { newline: true });
        }, u.prototype.setBackgroundColor = function(o) {
          this._backgroundColor = o;
          var n3 = this._bgVNode;
          if (n3 && n3.elm) {
            var p2 = FF(o), m2 = p2.color, w2 = p2.opacity;
            n3.elm.setAttribute("fill", m2), w2 < 1 && n3.elm.setAttribute("fill-opacity", w2);
          }
        }, u.prototype.getSvgRoot = function() {
          return this._mainVNode && this._mainVNode.elm;
        }, u.prototype._paintList = function(o, n3, p2) {
          for (var m2 = o.length, w2 = [], T2 = 0, E, O2, V3 = 0, W3 = 0; W3 < m2; W3++) {
            var q3 = o[W3];
            if (!q3.invisible) {
              var K = q3.__clipPaths, J = K && K.length || 0, rt2 = O2 && O2.length || 0, gt = void 0;
              for (gt = Math.max(J - 1, rt2 - 1); gt >= 0 && !(K && O2 && K[gt] === O2[gt]); gt--)
                ;
              for (var yt = rt2 - 1; yt > gt; yt--)
                T2--, E = w2[T2 - 1];
              for (var At = gt + 1; At < J; At++) {
                var Lt = {};
                cxn(K[At], Lt, n3);
                var Wt = P1("g", "clip-g-" + V3++, Lt, []);
                (E ? E.children : p2).push(Wt), w2[T2++] = Wt, E = Wt;
              }
              O2 = K;
              var Nt = g1e(q3, n3);
              Nt && (E ? E.children : p2).push(Nt);
            }
          }
        }, u.prototype.resize = function(o, n3) {
          var p2 = this._opts, m2 = this.root, w2 = this._viewport;
          if (o != null && (p2.width = o), n3 != null && (p2.height = n3), m2 && w2 && (w2.style.display = "none", o = oY(m2, 0, p2), n3 = oY(m2, 1, p2), w2.style.display = ""), this._width !== o || this._height !== n3) {
            if (this._width = o, this._height = n3, w2) {
              var T2 = w2.style;
              T2.width = o + "px", T2.height = n3 + "px";
            }
            var E = this._svgDom;
            E && (E.setAttribute("width", o), E.setAttribute("height", n3));
          }
        }, u.prototype.getWidth = function() {
          return this._width;
        }, u.prototype.getHeight = function() {
          return this._height;
        }, u.prototype.dispose = function() {
          this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
        }, u.prototype.clear = function() {
          this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
        }, u.prototype.toDataURL = function(o) {
          var n3 = encodeURIComponent(this.renderToString()), p2 = "data:image/svg+xml;";
          return o ? (n3 = U1t(n3), n3 && p2 + "base64," + n3) : p2 + "charset=UTF-8," + n3;
        }, u;
      }();
      function S1e(u) {
        return function() {
        };
      }
      var mxn = yxn;
      function bxn(u) {
        u.registerPainter("svg", mxn);
      }
      function M1e(u, o, n3) {
        var p2 = pw.createCanvas(), m2 = o.getWidth(), w2 = o.getHeight(), T2 = p2.style;
        return T2 && (T2.position = "absolute", T2.left = "0", T2.top = "0", T2.width = m2 + "px", T2.height = w2 + "px", p2.setAttribute("data-zr-dom-id", u)), p2.width = m2 * n3, p2.height = w2 * n3, p2;
      }
      var _xn = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this) || this;
          w2.motionBlur = false, w2.lastFrameAlpha = 0.7, w2.dpr = 1, w2.virtual = false, w2.config = {}, w2.incremental = false, w2.zlevel = 0, w2.maxRepaintRectCount = 5, w2.__dirty = true, w2.__firstTimePaint = true, w2.__used = false, w2.__drawIndex = 0, w2.__startIndex = 0, w2.__endIndex = 0, w2.__prevStartIndex = null, w2.__prevEndIndex = null;
          var T2;
          m2 = m2 || QZ, typeof n3 == "string" ? T2 = M1e(n3, p2, m2) : ys(n3) && (T2 = n3, n3 = T2.id), w2.id = n3, w2.dom = T2;
          var E = T2.style;
          return E && (dw(T2), T2.onselectstart = function() {
            return false;
          }, E.padding = "0", E.margin = "0", E.borderWidth = "0"), w2.painter = p2, w2.dpr = m2, w2;
        }
        return o.prototype.getElementCount = function() {
          return this.__endIndex - this.__startIndex;
        }, o.prototype.afterBrush = function() {
          this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
        }, o.prototype.initContext = function() {
          this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
        }, o.prototype.setUnpainted = function() {
          this.__firstTimePaint = true;
        }, o.prototype.createBackBuffer = function() {
          var n3 = this.dpr;
          this.domBack = M1e("back-" + this.id, this.painter, n3), this.ctxBack = this.domBack.getContext("2d"), n3 !== 1 && this.ctxBack.scale(n3, n3);
        }, o.prototype.createRepaintRects = function(n3, p2, m2, w2) {
          if (this.__firstTimePaint)
            return this.__firstTimePaint = false, null;
          var T2 = [], E = this.maxRepaintRectCount, O2 = false, V3 = new Qu(0, 0, 0, 0);
          function W3(Lt) {
            if (!(!Lt.isFinite() || Lt.isZero()))
              if (T2.length === 0) {
                var Wt = new Qu(0, 0, 0, 0);
                Wt.copy(Lt), T2.push(Wt);
              } else {
                for (var Nt = false, ue2 = 1 / 0, ie2 = 0, pe2 = 0; pe2 < T2.length; ++pe2) {
                  var xe = T2[pe2];
                  if (xe.intersect(Lt)) {
                    var Ce2 = new Qu(0, 0, 0, 0);
                    Ce2.copy(xe), Ce2.union(Lt), T2[pe2] = Ce2, Nt = true;
                    break;
                  } else if (O2) {
                    V3.copy(Lt), V3.union(xe);
                    var Le2 = Lt.width * Lt.height, ze = xe.width * xe.height, tn = V3.width * V3.height, $e2 = tn - Le2 - ze;
                    $e2 < ue2 && (ue2 = $e2, ie2 = pe2);
                  }
                }
                if (O2 && (T2[ie2].union(Lt), Nt = true), !Nt) {
                  var Wt = new Qu(0, 0, 0, 0);
                  Wt.copy(Lt), T2.push(Wt);
                }
                O2 || (O2 = T2.length >= E);
              }
          }
          for (var q3 = this.__startIndex; q3 < this.__endIndex; ++q3) {
            var K = n3[q3];
            if (K) {
              var J = K.shouldBePainted(m2, w2, true, true), rt2 = K.__isRendered && (K.__dirty & Ab2 || !J) ? K.getPrevPaintRect() : null;
              rt2 && W3(rt2);
              var gt = J && (K.__dirty & Ab2 || !K.__isRendered) ? K.getPaintRect() : null;
              gt && W3(gt);
            }
          }
          for (var q3 = this.__prevStartIndex; q3 < this.__prevEndIndex; ++q3) {
            var K = p2[q3], J = K.shouldBePainted(m2, w2, true, true);
            if (K && (!J || !K.__zr) && K.__isRendered) {
              var rt2 = K.getPrevPaintRect();
              rt2 && W3(rt2);
            }
          }
          var yt;
          do {
            yt = false;
            for (var q3 = 0; q3 < T2.length; ) {
              if (T2[q3].isZero()) {
                T2.splice(q3, 1);
                continue;
              }
              for (var At = q3 + 1; At < T2.length; )
                T2[q3].intersect(T2[At]) ? (yt = true, T2[q3].union(T2[At]), T2.splice(At, 1)) : At++;
              q3++;
            }
          } while (yt);
          return this._paintRects = T2, T2;
        }, o.prototype.debugGetPaintRects = function() {
          return (this._paintRects || []).slice();
        }, o.prototype.resize = function(n3, p2) {
          var m2 = this.dpr, w2 = this.dom, T2 = w2.style, E = this.domBack;
          T2 && (T2.width = n3 + "px", T2.height = p2 + "px"), w2.width = n3 * m2, w2.height = p2 * m2, E && (E.width = n3 * m2, E.height = p2 * m2, m2 !== 1 && this.ctxBack.scale(m2, m2));
        }, o.prototype.clear = function(n3, p2, m2) {
          var w2 = this.dom, T2 = this.ctx, E = w2.width, O2 = w2.height;
          p2 = p2 || this.clearColor;
          var V3 = this.motionBlur && !n3, W3 = this.lastFrameAlpha, q3 = this.dpr, K = this;
          V3 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(w2, 0, 0, E / q3, O2 / q3));
          var J = this.domBack;
          function rt2(gt, yt, At, Lt) {
            if (T2.clearRect(gt, yt, At, Lt), p2 && p2 !== "transparent") {
              var Wt = void 0;
              OZ(p2) ? (Wt = p2.__canvasGradient || O8t(T2, p2, { x: 0, y: 0, width: At, height: Lt }), p2.__canvasGradient = Wt) : O6t(p2) && (Wt = N8t(T2, p2, { dirty: function() {
                K.setUnpainted(), K.__painter.refresh();
              } })), T2.save(), T2.fillStyle = Wt || p2, T2.fillRect(gt, yt, At, Lt), T2.restore();
            }
            V3 && (T2.save(), T2.globalAlpha = W3, T2.drawImage(J, gt, yt, At, Lt), T2.restore());
          }
          !m2 || V3 ? rt2(0, 0, E, O2) : m2.length && Xe2(m2, function(gt) {
            rt2(gt.x * q3, gt.y * q3, gt.width * q3, gt.height * q3);
          });
        }, o;
      }(gw), I9t = _xn, C1e = 1e5, Wz = 314159, Mxt = 0.01, xxn = 1e-3;
      function wxn(u) {
        return u ? u.__builtin__ ? true : !(typeof u.resize != "function" || typeof u.refresh != "function") : false;
      }
      function Sxn(u, o) {
        var n3 = document.createElement("div");
        return n3.style.cssText = ["position:relative", "width:" + u + "px", "height:" + o + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", n3;
      }
      var Mxn = function() {
        function u(o, n3, p2, m2) {
          this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
          var w2 = !o.nodeName || o.nodeName.toUpperCase() === "CANVAS";
          this._opts = p2 = ua2({}, p2 || {}), this.dpr = p2.devicePixelRatio || QZ, this._singleCanvas = w2, this.root = o;
          var T2 = o.style;
          T2 && (dw(o), o.innerHTML = ""), this.storage = n3;
          var E = this._zlevelList;
          this._prevDisplayList = [];
          var O2 = this._layers;
          if (w2) {
            var V3 = o, W3 = V3.width, q3 = V3.height;
            p2.width != null && (W3 = p2.width), p2.height != null && (q3 = p2.height), this.dpr = p2.devicePixelRatio || 1, V3.width = W3 * this.dpr, V3.height = q3 * this.dpr, this._width = W3, this._height = q3;
            var K = new I9t(V3, this, this.dpr);
            K.__builtin__ = true, K.initContext(), O2[Wz] = K, K.zlevel = Wz, E.push(Wz), this._domRoot = o;
          } else {
            this._width = oY(o, 0, p2), this._height = oY(o, 1, p2);
            var J = this._domRoot = Sxn(this._width, this._height);
            o.appendChild(J);
          }
        }
        return u.prototype.getType = function() {
          return "canvas";
        }, u.prototype.isSingleCanvas = function() {
          return this._singleCanvas;
        }, u.prototype.getViewportRoot = function() {
          return this._domRoot;
        }, u.prototype.getViewportRootOffset = function() {
          var o = this.getViewportRoot();
          if (o)
            return { offsetLeft: o.offsetLeft || 0, offsetTop: o.offsetTop || 0 };
        }, u.prototype.refresh = function(o) {
          var n3 = this.storage.getDisplayList(true), p2 = this._prevDisplayList, m2 = this._zlevelList;
          this._redrawId = Math.random(), this._paintList(n3, p2, o, this._redrawId);
          for (var w2 = 0; w2 < m2.length; w2++) {
            var T2 = m2[w2], E = this._layers[T2];
            if (!E.__builtin__ && E.refresh) {
              var O2 = w2 === 0 ? this._backgroundColor : null;
              E.refresh(O2);
            }
          }
          return this._opts.useDirtyRect && (this._prevDisplayList = n3.slice()), this;
        }, u.prototype.refreshHover = function() {
          this._paintHoverList(this.storage.getDisplayList(false));
        }, u.prototype._paintHoverList = function(o) {
          var n3 = o.length, p2 = this._hoverlayer;
          if (p2 && p2.clear(), !!n3) {
            for (var m2 = { inHover: true, viewWidth: this._width, viewHeight: this._height }, w2, T2 = 0; T2 < n3; T2++) {
              var E = o[T2];
              E.__inHover && (p2 || (p2 = this._hoverlayer = this.getLayer(C1e)), w2 || (w2 = p2.ctx, w2.save()), Oz(w2, E, m2, T2 === n3 - 1));
            }
            w2 && w2.restore();
          }
        }, u.prototype.getHoverLayer = function() {
          return this.getLayer(C1e);
        }, u.prototype.paintOne = function(o, n3) {
          wye(o, n3);
        }, u.prototype._paintList = function(o, n3, p2, m2) {
          if (this._redrawId === m2) {
            p2 = p2 || false, this._updateLayerStatus(o);
            var w2 = this._doPaintList(o, n3, p2), T2 = w2.finished, E = w2.needsRefreshHover;
            if (this._needsManuallyCompositing && this._compositeManually(), E && this._paintHoverList(o), T2)
              this.eachLayer(function(V3) {
                V3.afterBrush && V3.afterBrush();
              });
            else {
              var O2 = this;
              UA(function() {
                O2._paintList(o, n3, p2, m2);
              });
            }
          }
        }, u.prototype._compositeManually = function() {
          var o = this.getLayer(Wz).ctx, n3 = this._domRoot.width, p2 = this._domRoot.height;
          o.clearRect(0, 0, n3, p2), this.eachBuiltinLayer(function(m2) {
            m2.virtual && o.drawImage(m2.dom, 0, 0, n3, p2);
          });
        }, u.prototype._doPaintList = function(o, n3, p2) {
          for (var m2 = this, w2 = [], T2 = this._opts.useDirtyRect, E = 0; E < this._zlevelList.length; E++) {
            var O2 = this._zlevelList[E], V3 = this._layers[O2];
            V3.__builtin__ && V3 !== this._hoverlayer && (V3.__dirty || p2) && w2.push(V3);
          }
          for (var W3 = true, q3 = false, K = function(gt) {
            var yt = w2[gt], At = yt.ctx, Lt = T2 && yt.createRepaintRects(o, n3, J._width, J._height), Wt = p2 ? yt.__startIndex : yt.__drawIndex, Nt = !p2 && yt.incremental && Date.now, ue2 = Nt && Date.now(), ie2 = yt.zlevel === J._zlevelList[0] ? J._backgroundColor : null;
            if (yt.__startIndex === yt.__endIndex)
              yt.clear(false, ie2, Lt);
            else if (Wt === yt.__startIndex) {
              var pe2 = o[Wt];
              (!pe2.incremental || !pe2.notClear || p2) && yt.clear(false, ie2, Lt);
            }
            Wt === -1 && (console.error("For some unknown reason. drawIndex is -1"), Wt = yt.__startIndex);
            var xe, Ce2 = function($e2) {
              var Tn = { inHover: false, allClipped: false, prevEl: null, viewWidth: m2._width, viewHeight: m2._height };
              for (xe = Wt; xe < yt.__endIndex; xe++) {
                var zn = o[xe];
                if (zn.__inHover && (q3 = true), m2._doPaintEl(zn, yt, T2, $e2, Tn, xe === yt.__endIndex - 1), Nt) {
                  var bn = Date.now() - ue2;
                  if (bn > 15)
                    break;
                }
              }
              Tn.prevElClipPaths && At.restore();
            };
            if (Lt)
              if (Lt.length === 0)
                xe = yt.__endIndex;
              else
                for (var Le2 = J.dpr, ze = 0; ze < Lt.length; ++ze) {
                  var tn = Lt[ze];
                  At.save(), At.beginPath(), At.rect(tn.x * Le2, tn.y * Le2, tn.width * Le2, tn.height * Le2), At.clip(), Ce2(tn), At.restore();
                }
            else
              At.save(), Ce2(), At.restore();
            yt.__drawIndex = xe, yt.__drawIndex < yt.__endIndex && (W3 = false);
          }, J = this, rt2 = 0; rt2 < w2.length; rt2++)
            K(rt2);
          return Ys.wxa && Xe2(this._layers, function(gt) {
            gt && gt.ctx && gt.ctx.draw && gt.ctx.draw();
          }), { finished: W3, needsRefreshHover: q3 };
        }, u.prototype._doPaintEl = function(o, n3, p2, m2, w2, T2) {
          var E = n3.ctx;
          if (p2) {
            var O2 = o.getPaintRect();
            (!m2 || O2 && O2.intersect(m2)) && (Oz(E, o, w2, T2), o.setPrevPaintRect(O2));
          } else
            Oz(E, o, w2, T2);
        }, u.prototype.getLayer = function(o, n3) {
          this._singleCanvas && !this._needsManuallyCompositing && (o = Wz);
          var p2 = this._layers[o];
          return p2 || (p2 = new I9t("zr_" + o, this, this.dpr), p2.zlevel = o, p2.__builtin__ = true, this._layerConfig[o] ? Cu(p2, this._layerConfig[o], true) : this._layerConfig[o - Mxt] && Cu(p2, this._layerConfig[o - Mxt], true), n3 && (p2.virtual = n3), this.insertLayer(o, p2), p2.initContext()), p2;
        }, u.prototype.insertLayer = function(o, n3) {
          var p2 = this._layers, m2 = this._zlevelList, w2 = m2.length, T2 = this._domRoot, E = null, O2 = -1;
          if (!p2[o] && !!wxn(n3)) {
            if (w2 > 0 && o > m2[0]) {
              for (O2 = 0; O2 < w2 - 1 && !(m2[O2] < o && m2[O2 + 1] > o); O2++)
                ;
              E = p2[m2[O2]];
            }
            if (m2.splice(O2 + 1, 0, o), p2[o] = n3, !n3.virtual)
              if (E) {
                var V3 = E.dom;
                V3.nextSibling ? T2.insertBefore(n3.dom, V3.nextSibling) : T2.appendChild(n3.dom);
              } else
                T2.firstChild ? T2.insertBefore(n3.dom, T2.firstChild) : T2.appendChild(n3.dom);
            n3.__painter = this;
          }
        }, u.prototype.eachLayer = function(o, n3) {
          for (var p2 = this._zlevelList, m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2];
            o.call(n3, this._layers[w2], w2);
          }
        }, u.prototype.eachBuiltinLayer = function(o, n3) {
          for (var p2 = this._zlevelList, m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2], T2 = this._layers[w2];
            T2.__builtin__ && o.call(n3, T2, w2);
          }
        }, u.prototype.eachOtherLayer = function(o, n3) {
          for (var p2 = this._zlevelList, m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2], T2 = this._layers[w2];
            T2.__builtin__ || o.call(n3, T2, w2);
          }
        }, u.prototype.getLayers = function() {
          return this._layers;
        }, u.prototype._updateLayerStatus = function(o) {
          this.eachBuiltinLayer(function(q3, K) {
            q3.__dirty = q3.__used = false;
          });
          function n3(q3) {
            w2 && (w2.__endIndex !== q3 && (w2.__dirty = true), w2.__endIndex = q3);
          }
          if (this._singleCanvas)
            for (var p2 = 1; p2 < o.length; p2++) {
              var m2 = o[p2];
              if (m2.zlevel !== o[p2 - 1].zlevel || m2.incremental) {
                this._needsManuallyCompositing = true;
                break;
              }
            }
          var w2 = null, T2 = 0, E, O2;
          for (O2 = 0; O2 < o.length; O2++) {
            var m2 = o[O2], V3 = m2.zlevel, W3 = void 0;
            E !== V3 && (E = V3, T2 = 0), m2.incremental ? (W3 = this.getLayer(V3 + xxn, this._needsManuallyCompositing), W3.incremental = true, T2 = 1) : W3 = this.getLayer(V3 + (T2 > 0 ? Mxt : 0), this._needsManuallyCompositing), W3.__builtin__ || FB("ZLevel " + V3 + " has been used by unkown layer " + W3.id), W3 !== w2 && (W3.__used = true, W3.__startIndex !== O2 && (W3.__dirty = true), W3.__startIndex = O2, W3.incremental ? W3.__drawIndex = -1 : W3.__drawIndex = O2, n3(O2), w2 = W3), m2.__dirty & Ab2 && !m2.__inHover && (W3.__dirty = true, W3.incremental && W3.__drawIndex < 0 && (W3.__drawIndex = O2));
          }
          n3(O2), this.eachBuiltinLayer(function(q3, K) {
            !q3.__used && q3.getElementCount() > 0 && (q3.__dirty = true, q3.__startIndex = q3.__endIndex = q3.__drawIndex = 0), q3.__dirty && q3.__drawIndex < 0 && (q3.__drawIndex = q3.__startIndex);
          });
        }, u.prototype.clear = function() {
          return this.eachBuiltinLayer(this._clearLayer), this;
        }, u.prototype._clearLayer = function(o) {
          o.clear();
        }, u.prototype.setBackgroundColor = function(o) {
          this._backgroundColor = o, Xe2(this._layers, function(n3) {
            n3.setUnpainted();
          });
        }, u.prototype.configLayer = function(o, n3) {
          if (n3) {
            var p2 = this._layerConfig;
            p2[o] ? Cu(p2[o], n3, true) : p2[o] = n3;
            for (var m2 = 0; m2 < this._zlevelList.length; m2++) {
              var w2 = this._zlevelList[m2];
              if (w2 === o || w2 === o + Mxt) {
                var T2 = this._layers[w2];
                Cu(T2, p2[o], true);
              }
            }
          }
        }, u.prototype.delLayer = function(o) {
          var n3 = this._layers, p2 = this._zlevelList, m2 = n3[o];
          !m2 || (m2.dom.parentNode.removeChild(m2.dom), delete n3[o], p2.splice(sc2(p2, o), 1));
        }, u.prototype.resize = function(o, n3) {
          if (this._domRoot.style) {
            var p2 = this._domRoot;
            p2.style.display = "none";
            var m2 = this._opts, w2 = this.root;
            if (o != null && (m2.width = o), n3 != null && (m2.height = n3), o = oY(w2, 0, m2), n3 = oY(w2, 1, m2), p2.style.display = "", this._width !== o || n3 !== this._height) {
              p2.style.width = o + "px", p2.style.height = n3 + "px";
              for (var T2 in this._layers)
                this._layers.hasOwnProperty(T2) && this._layers[T2].resize(o, n3);
              this.refresh(true);
            }
            this._width = o, this._height = n3;
          } else {
            if (o == null || n3 == null)
              return;
            this._width = o, this._height = n3, this.getLayer(Wz).resize(o, n3);
          }
          return this;
        }, u.prototype.clearLayer = function(o) {
          var n3 = this._layers[o];
          n3 && n3.clear();
        }, u.prototype.dispose = function() {
          this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
        }, u.prototype.getRenderedCanvas = function(o) {
          if (o = o || {}, this._singleCanvas && !this._compositeManually)
            return this._layers[Wz].dom;
          var n3 = new I9t("image", this, o.pixelRatio || this.dpr);
          n3.initContext(), n3.clear(false, o.backgroundColor || this._backgroundColor);
          var p2 = n3.ctx;
          if (o.pixelRatio <= this.dpr) {
            this.refresh();
            var m2 = n3.dom.width, w2 = n3.dom.height;
            this.eachLayer(function(q3) {
              q3.__builtin__ ? p2.drawImage(q3.dom, 0, 0, m2, w2) : q3.renderToCanvas && (p2.save(), q3.renderToCanvas(p2), p2.restore());
            });
          } else
            for (var T2 = { inHover: false, viewWidth: this._width, viewHeight: this._height }, E = this.storage.getDisplayList(true), O2 = 0, V3 = E.length; O2 < V3; O2++) {
              var W3 = E[O2];
              Oz(p2, W3, T2, O2 === V3 - 1);
            }
          return n3.dom;
        }, u.prototype.getWidth = function() {
          return this._width;
        }, u.prototype.getHeight = function() {
          return this._height;
        }, u;
      }(), Cxn = Mxn;
      function Txn(u) {
        u.registerPainter("canvas", Cxn);
      }
      var Axn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.hasSymbolVisual = true, n3;
        }
        return o.prototype.getInitialData = function(n3) {
          return T4(null, this, { useEncodeDefaulter: true });
        }, o.prototype.getLegendIcon = function(n3) {
          var p2 = new uu(), m2 = Jy("line", 0, n3.itemHeight / 2, n3.itemWidth, 0, n3.lineStyle.stroke, false);
          p2.add(m2), m2.setStyle(n3.lineStyle);
          var w2 = this.getData().getVisual("symbol"), T2 = this.getData().getVisual("symbolRotate"), E = w2 === "none" ? "circle" : w2, O2 = n3.itemHeight * 0.8, V3 = Jy(E, (n3.itemWidth - O2) / 2, (n3.itemHeight - O2) / 2, O2, O2, n3.itemStyle.fill);
          p2.add(V3), V3.setStyle(n3.itemStyle);
          var W3 = n3.iconRotate === "inherit" ? T2 : n3.iconRotate || 0;
          return V3.rotation = W3 * Math.PI / 180, V3.setOrigin([n3.itemWidth / 2, n3.itemHeight / 2]), E.indexOf("empty") > -1 && (V3.style.stroke = V3.style.fill, V3.style.fill = "#fff", V3.style.lineWidth = 2), p2;
        }, o.type = "series.line", o.dependencies = ["grid", "polar"], o.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, o;
      }(Rv), Ixn = Axn;
      function fY(u, o) {
        var n3 = u.mapDimensionsAll("defaultedLabel"), p2 = n3.length;
        if (p2 === 1) {
          var m2 = J$(u, o, n3[0]);
          return m2 != null ? m2 + "" : null;
        } else if (p2) {
          for (var w2 = [], T2 = 0; T2 < n3.length; T2++)
            w2.push(J$(u, o, n3[T2]));
          return w2.join(" ");
        }
      }
      function T1e(u, o) {
        var n3 = u.mapDimensionsAll("defaultedLabel");
        if (!za2(o))
          return o + "";
        for (var p2 = [], m2 = 0; m2 < n3.length; m2++) {
          var w2 = u.getDimensionIndex(n3[m2]);
          w2 >= 0 && p2.push(o[w2]);
        }
        return p2.join(" ");
      }
      var Dxn = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2) {
          var T2 = u.call(this) || this;
          return T2.updateData(n3, p2, m2, w2), T2;
        }
        return o.prototype._createSymbol = function(n3, p2, m2, w2, T2) {
          this.removeAll();
          var E = Jy(n3, -1, -1, 2, 2, null, T2);
          E.attr({ z2: 100, culling: true, scaleX: w2[0] / 2, scaleY: w2[1] / 2 }), E.drift = Exn, this._symbolType = n3, this.add(E);
        }, o.prototype.stopSymbolAnimation = function(n3) {
          this.childAt(0).stopAnimation(null, n3);
        }, o.prototype.getSymbolType = function() {
          return this._symbolType;
        }, o.prototype.getSymbolPath = function() {
          return this.childAt(0);
        }, o.prototype.highlight = function() {
          Vm(this.childAt(0));
        }, o.prototype.downplay = function() {
          pc2(this.childAt(0));
        }, o.prototype.setZ = function(n3, p2) {
          var m2 = this.childAt(0);
          m2.zlevel = n3, m2.z = p2;
        }, o.prototype.setDraggable = function(n3) {
          var p2 = this.childAt(0);
          p2.draggable = n3, p2.cursor = n3 ? "move" : p2.cursor;
        }, o.prototype.updateData = function(n3, p2, m2, w2) {
          this.silent = false;
          var T2 = n3.getItemVisual(p2, "symbol") || "circle", E = n3.hostModel, O2 = o.getSymbolSize(n3, p2), V3 = T2 !== this._symbolType, W3 = w2 && w2.disableAnimation;
          if (V3) {
            var q3 = n3.getItemVisual(p2, "symbolKeepAspect");
            this._createSymbol(T2, n3, p2, O2, q3);
          } else {
            var K = this.childAt(0);
            K.silent = false;
            var J = { scaleX: O2[0] / 2, scaleY: O2[1] / 2 };
            W3 ? K.attr(J) : Xf2(K, J, E, p2), DC(K);
          }
          if (this._updateCommon(n3, p2, O2, m2, w2), V3) {
            var K = this.childAt(0);
            if (!W3) {
              var J = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: K.style.opacity } };
              K.scaleX = K.scaleY = 0, K.style.opacity = 0, Qg2(K, J, E, p2);
            }
          }
          W3 && this.childAt(0).stopAnimation("leave");
        }, o.prototype._updateCommon = function(n3, p2, m2, w2, T2) {
          var E = this.childAt(0), O2 = n3.hostModel, V3, W3, q3, K, J, rt2, gt, yt, At;
          if (w2 && (V3 = w2.emphasisItemStyle, W3 = w2.blurItemStyle, q3 = w2.selectItemStyle, K = w2.focus, J = w2.blurScope, gt = w2.labelStatesModels, yt = w2.hoverScale, At = w2.cursorStyle, rt2 = w2.emphasisDisabled), !w2 || n3.hasItemOption) {
            var Lt = w2 && w2.itemModel ? w2.itemModel : n3.getItemModel(p2), Wt = Lt.getModel("emphasis");
            V3 = Wt.getModel("itemStyle").getItemStyle(), q3 = Lt.getModel(["select", "itemStyle"]).getItemStyle(), W3 = Lt.getModel(["blur", "itemStyle"]).getItemStyle(), K = Wt.get("focus"), J = Wt.get("blurScope"), rt2 = Wt.get("disabled"), gt = Lb2(Lt), yt = Wt.getShallow("scale"), At = Lt.getShallow("cursor");
          }
          var Nt = n3.getItemVisual(p2, "symbolRotate");
          E.attr("rotation", (Nt || 0) * Math.PI / 180 || 0);
          var ue2 = aY(n3.getItemVisual(p2, "symbolOffset"), m2);
          ue2 && (E.x = ue2[0], E.y = ue2[1]), At && E.attr("cursor", At);
          var ie2 = n3.getItemVisual(p2, "style"), pe2 = ie2.fill;
          if (E instanceof Fm) {
            var xe = E.style;
            E.useStyle(ua2({ image: xe.image, x: xe.x, y: xe.y, width: xe.width, height: xe.height }, ie2));
          } else
            E.__isEmptyBrush ? E.useStyle(ua2({}, ie2)) : E.useStyle(ie2), E.style.decal = null, E.setColor(pe2, T2 && T2.symbolInnerColor), E.style.strokeNoScale = true;
          var Ce2 = n3.getItemVisual(p2, "liftZ"), Le2 = this._z2;
          Ce2 != null ? Le2 == null && (this._z2 = E.z2, E.z2 += Ce2) : Le2 != null && (E.z2 = Le2, this._z2 = null);
          var ze = T2 && T2.useNameLabel;
          Tw(E, gt, { labelFetcher: O2, labelDataIndex: p2, defaultText: tn, inheritColor: pe2, defaultOpacity: ie2.opacity });
          function tn(zn) {
            return ze ? n3.getName(zn) : fY(n3, zn);
          }
          this._sizeX = m2[0] / 2, this._sizeY = m2[1] / 2;
          var $e2 = E.ensureState("emphasis");
          if ($e2.style = V3, E.ensureState("select").style = q3, E.ensureState("blur").style = W3, yt) {
            var Tn = Math.max(1.1, 3 / this._sizeY);
            $e2.scaleX = this._sizeX * Tn, $e2.scaleY = this._sizeY * Tn;
          }
          this.setSymbolScale(1), o0(this, K, J, rt2);
        }, o.prototype.setSymbolScale = function(n3) {
          this.scaleX = this.scaleY = n3;
        }, o.prototype.fadeOut = function(n3, p2, m2) {
          var w2 = this.childAt(0), T2 = is(this).dataIndex, E = m2 && m2.animation;
          if (this.silent = w2.silent = true, m2 && m2.fadeLabel) {
            var O2 = w2.getTextContent();
            O2 && HP(O2, { style: { opacity: 0 } }, p2, { dataIndex: T2, removeOpt: E, cb: function() {
              w2.removeTextContent();
            } });
          } else
            w2.removeTextContent();
          HP(w2, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, p2, { dataIndex: T2, cb: n3, removeOpt: E });
        }, o.getSymbolSize = function(n3, p2) {
          return Rot(n3.getItemVisual(p2, "symbolSize"));
        }, o;
      }(uu);
      function Exn(u, o) {
        this.parent.drift(u, o);
      }
      var nst = Dxn;
      function D9t(u, o, n3, p2) {
        return o && !isNaN(o[0]) && !isNaN(o[1]) && !(p2.isIgnore && p2.isIgnore(n3)) && !(p2.clipShape && !p2.clipShape.contain(o[0], o[1])) && u.getItemVisual(n3, "symbol") !== "none";
      }
      function A1e(u) {
        return u != null && !ys(u) && (u = { isIgnore: u }), u || {};
      }
      function I1e(u) {
        var o = u.hostModel, n3 = o.getModel("emphasis");
        return { emphasisItemStyle: n3.getModel("itemStyle").getItemStyle(), blurItemStyle: o.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: o.getModel(["select", "itemStyle"]).getItemStyle(), focus: n3.get("focus"), blurScope: n3.get("blurScope"), emphasisDisabled: n3.get("disabled"), hoverScale: n3.get("scale"), labelStatesModels: Lb2(o), cursorStyle: o.get("cursor") };
      }
      var kxn = function() {
        function u(o) {
          this.group = new uu(), this._SymbolCtor = o || nst;
        }
        return u.prototype.updateData = function(o, n3) {
          this._progressiveEls = null, n3 = A1e(n3);
          var p2 = this.group, m2 = o.hostModel, w2 = this._data, T2 = this._SymbolCtor, E = n3.disableAnimation, O2 = I1e(o), V3 = { disableAnimation: E }, W3 = n3.getSymbolPoint || function(q3) {
            return o.getItemLayout(q3);
          };
          w2 || p2.removeAll(), o.diff(w2).add(function(q3) {
            var K = W3(q3);
            if (D9t(o, K, q3, n3)) {
              var J = new T2(o, q3, O2, V3);
              J.setPosition(K), o.setItemGraphicEl(q3, J), p2.add(J);
            }
          }).update(function(q3, K) {
            var J = w2.getItemGraphicEl(K), rt2 = W3(q3);
            if (!D9t(o, rt2, q3, n3)) {
              p2.remove(J);
              return;
            }
            var gt = o.getItemVisual(q3, "symbol") || "circle", yt = J && J.getSymbolType && J.getSymbolType();
            if (!J || yt && yt !== gt)
              p2.remove(J), J = new T2(o, q3, O2, V3), J.setPosition(rt2);
            else {
              J.updateData(o, q3, O2, V3);
              var At = { x: rt2[0], y: rt2[1] };
              E ? J.attr(At) : Xf2(J, At, m2);
            }
            p2.add(J), o.setItemGraphicEl(q3, J);
          }).remove(function(q3) {
            var K = w2.getItemGraphicEl(q3);
            K && K.fadeOut(function() {
              p2.remove(K);
            }, m2);
          }).execute(), this._getSymbolPoint = W3, this._data = o;
        }, u.prototype.updateLayout = function() {
          var o = this, n3 = this._data;
          n3 && n3.eachItemGraphicEl(function(p2, m2) {
            var w2 = o._getSymbolPoint(m2);
            p2.setPosition(w2), p2.markRedraw();
          });
        }, u.prototype.incrementalPrepareUpdate = function(o) {
          this._seriesScope = I1e(o), this._data = null, this.group.removeAll();
        }, u.prototype.incrementalUpdate = function(o, n3, p2) {
          this._progressiveEls = [], p2 = A1e(p2);
          function m2(O2) {
            O2.isGroup || (O2.incremental = true, O2.ensureState("emphasis").hoverLayer = true);
          }
          for (var w2 = o.start; w2 < o.end; w2++) {
            var T2 = n3.getItemLayout(w2);
            if (D9t(n3, T2, w2, p2)) {
              var E = new this._SymbolCtor(n3, w2, this._seriesScope);
              E.traverse(m2), E.setPosition(T2), this.group.add(E), n3.setItemGraphicEl(w2, E), this._progressiveEls.push(E);
            }
          }
        }, u.prototype.eachRendered = function(o) {
          n8(this._progressiveEls || this.group, o);
        }, u.prototype.remove = function(o) {
          var n3 = this.group, p2 = this._data;
          p2 && o ? p2.eachItemGraphicEl(function(m2) {
            m2.fadeOut(function() {
              n3.remove(m2);
            }, p2.hostModel);
          }) : n3.removeAll();
        }, u;
      }(), rst = kxn;
      function D1e(u, o, n3) {
        var p2 = u.getBaseAxis(), m2 = u.getOtherAxis(p2), w2 = Pxn(m2, n3), T2 = p2.dim, E = m2.dim, O2 = o.mapDimension(E), V3 = o.mapDimension(T2), W3 = E === "x" || E === "radius" ? 1 : 0, q3 = Ya2(u.dimensions, function(rt2) {
          return o.mapDimension(rt2);
        }), K = false, J = o.getCalculationInfo("stackResultDimension");
        return c8(o, q3[0]) && (K = true, q3[0] = J), c8(o, q3[1]) && (K = true, q3[1] = J), { dataDimsForPoint: q3, valueStart: w2, valueAxisDim: E, baseAxisDim: T2, stacked: !!K, valueDim: O2, baseDim: V3, baseDataOffset: W3, stackedOverDimension: o.getCalculationInfo("stackedOverDimension") };
      }
      function Pxn(u, o) {
        var n3 = 0, p2 = u.scale.getExtent();
        return o === "start" ? n3 = p2[0] : o === "end" ? n3 = p2[1] : p2[0] > 0 ? n3 = p2[0] : p2[1] < 0 && (n3 = p2[1]), n3;
      }
      function E1e(u, o, n3, p2) {
        var m2 = NaN;
        u.stacked && (m2 = n3.get(n3.getCalculationInfo("stackedOverDimension"), p2)), isNaN(m2) && (m2 = u.valueStart);
        var w2 = u.baseDataOffset, T2 = [];
        return T2[w2] = n3.get(u.baseDim, p2), T2[1 - w2] = m2, o.dataToPoint(T2);
      }
      function Lxn(u, o) {
        var n3 = [];
        return o.diff(u).add(function(p2) {
          n3.push({ cmd: "+", idx: p2 });
        }).update(function(p2, m2) {
          n3.push({ cmd: "=", idx: m2, idx1: p2 });
        }).remove(function(p2) {
          n3.push({ cmd: "-", idx: p2 });
        }).execute(), n3;
      }
      function Oxn(u, o, n3, p2, m2, w2, T2, E) {
        for (var O2 = Lxn(u, o), V3 = [], W3 = [], q3 = [], K = [], J = [], rt2 = [], gt = [], yt = D1e(m2, o, T2), At = u.getLayout("points") || [], Lt = o.getLayout("points") || [], Wt = 0; Wt < O2.length; Wt++) {
          var Nt = O2[Wt], ue2 = true, ie2 = void 0, pe2 = void 0;
          switch (Nt.cmd) {
            case "=":
              ie2 = Nt.idx * 2, pe2 = Nt.idx1 * 2;
              var xe = At[ie2], Ce2 = At[ie2 + 1], Le2 = Lt[pe2], ze = Lt[pe2 + 1];
              (isNaN(xe) || isNaN(Ce2)) && (xe = Le2, Ce2 = ze), V3.push(xe, Ce2), W3.push(Le2, ze), q3.push(n3[ie2], n3[ie2 + 1]), K.push(p2[pe2], p2[pe2 + 1]), gt.push(o.getRawIndex(Nt.idx1));
              break;
            case "+":
              var tn = Nt.idx, $e2 = yt.dataDimsForPoint, Tn = m2.dataToPoint([o.get($e2[0], tn), o.get($e2[1], tn)]);
              pe2 = tn * 2, V3.push(Tn[0], Tn[1]), W3.push(Lt[pe2], Lt[pe2 + 1]);
              var zn = E1e(yt, m2, o, tn);
              q3.push(zn[0], zn[1]), K.push(p2[pe2], p2[pe2 + 1]), gt.push(o.getRawIndex(tn));
              break;
            case "-":
              ue2 = false;
          }
          ue2 && (J.push(Nt), rt2.push(rt2.length));
        }
        rt2.sort(function(dl, tl) {
          return gt[dl] - gt[tl];
        });
        for (var bn = V3.length, Xr = $P(bn), Xn = $P(bn), or = $P(bn), Tr = $P(bn), ci2 = [], Wt = 0; Wt < rt2.length; Wt++) {
          var yi2 = rt2[Wt], Po = Wt * 2, Ms = yi2 * 2;
          Xr[Po] = V3[Ms], Xr[Po + 1] = V3[Ms + 1], Xn[Po] = W3[Ms], Xn[Po + 1] = W3[Ms + 1], or[Po] = q3[Ms], or[Po + 1] = q3[Ms + 1], Tr[Po] = K[Ms], Tr[Po + 1] = K[Ms + 1], ci2[Wt] = J[yi2];
        }
        return { current: Xr, next: Xn, stackedOnCurrent: or, stackedOnNext: Tr, status: ci2 };
      }
      var h8 = Math.min, p8 = Math.max;
      function Gz(u, o) {
        return isNaN(u) || isNaN(o);
      }
      function E9t(u, o, n3, p2, m2, w2, T2, E, O2) {
        for (var V3, W3, q3, K, J, rt2, gt = n3, yt = 0; yt < p2; yt++) {
          var At = o[gt * 2], Lt = o[gt * 2 + 1];
          if (gt >= m2 || gt < 0)
            break;
          if (Gz(At, Lt)) {
            if (O2) {
              gt += w2;
              continue;
            }
            break;
          }
          if (gt === n3)
            u[w2 > 0 ? "moveTo" : "lineTo"](At, Lt), q3 = At, K = Lt;
          else {
            var Wt = At - V3, Nt = Lt - W3;
            if (Wt * Wt + Nt * Nt < 0.5) {
              gt += w2;
              continue;
            }
            if (T2 > 0) {
              for (var ue2 = gt + w2, ie2 = o[ue2 * 2], pe2 = o[ue2 * 2 + 1]; ie2 === At && pe2 === Lt && yt < p2; )
                yt++, ue2 += w2, gt += w2, ie2 = o[ue2 * 2], pe2 = o[ue2 * 2 + 1], At = o[gt * 2], Lt = o[gt * 2 + 1], Wt = At - V3, Nt = Lt - W3;
              var xe = yt + 1;
              if (O2)
                for (; Gz(ie2, pe2) && xe < p2; )
                  xe++, ue2 += w2, ie2 = o[ue2 * 2], pe2 = o[ue2 * 2 + 1];
              var Ce2 = 0.5, Le2 = 0, ze = 0, tn = void 0, $e2 = void 0;
              if (xe >= p2 || Gz(ie2, pe2))
                J = At, rt2 = Lt;
              else {
                Le2 = ie2 - V3, ze = pe2 - W3;
                var Tn = At - V3, zn = ie2 - At, bn = Lt - W3, Xr = pe2 - Lt, Xn = void 0, or = void 0;
                if (E === "x") {
                  Xn = Math.abs(Tn), or = Math.abs(zn);
                  var Tr = Le2 > 0 ? 1 : -1;
                  J = At - Tr * Xn * T2, rt2 = Lt, tn = At + Tr * or * T2, $e2 = Lt;
                } else if (E === "y") {
                  Xn = Math.abs(bn), or = Math.abs(Xr);
                  var ci2 = ze > 0 ? 1 : -1;
                  J = At, rt2 = Lt - ci2 * Xn * T2, tn = At, $e2 = Lt + ci2 * or * T2;
                } else
                  Xn = Math.sqrt(Tn * Tn + bn * bn), or = Math.sqrt(zn * zn + Xr * Xr), Ce2 = or / (or + Xn), J = At - Le2 * T2 * (1 - Ce2), rt2 = Lt - ze * T2 * (1 - Ce2), tn = At + Le2 * T2 * Ce2, $e2 = Lt + ze * T2 * Ce2, tn = h8(tn, p8(ie2, At)), $e2 = h8($e2, p8(pe2, Lt)), tn = p8(tn, h8(ie2, At)), $e2 = p8($e2, h8(pe2, Lt)), Le2 = tn - At, ze = $e2 - Lt, J = At - Le2 * Xn / or, rt2 = Lt - ze * Xn / or, J = h8(J, p8(V3, At)), rt2 = h8(rt2, p8(W3, Lt)), J = p8(J, h8(V3, At)), rt2 = p8(rt2, h8(W3, Lt)), Le2 = At - J, ze = Lt - rt2, tn = At + Le2 * or / Xn, $e2 = Lt + ze * or / Xn;
              }
              u.bezierCurveTo(q3, K, J, rt2, At, Lt), q3 = tn, K = $e2;
            } else
              u.lineTo(At, Lt);
          }
          V3 = At, W3 = Lt, gt += w2;
        }
        return yt;
      }
      var k1e = function() {
        function u() {
          this.smooth = 0, this.smoothConstraint = true;
        }
        return u;
      }(), Rxn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "ec-polyline", p2;
        }
        return o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new k1e();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.points, w2 = 0, T2 = m2.length / 2;
          if (p2.connectNulls) {
            for (; T2 > 0 && Gz(m2[T2 * 2 - 2], m2[T2 * 2 - 1]); T2--)
              ;
            for (; w2 < T2 && Gz(m2[w2 * 2], m2[w2 * 2 + 1]); w2++)
              ;
          }
          for (; w2 < T2; )
            w2 += E9t(n3, m2, w2, T2, T2, 1, p2.smooth, p2.smoothMonotone, p2.connectNulls) + 1;
        }, o.prototype.getPointOn = function(n3, p2) {
          this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
          for (var m2 = this.path, w2 = m2.data, T2 = iI.CMD, E, O2, V3 = p2 === "x", W3 = [], q3 = 0; q3 < w2.length; ) {
            var K = w2[q3++], J = void 0, rt2 = void 0, gt = void 0, yt = void 0, At = void 0, Lt = void 0, Wt = void 0;
            switch (K) {
              case T2.M:
                E = w2[q3++], O2 = w2[q3++];
                break;
              case T2.L:
                if (J = w2[q3++], rt2 = w2[q3++], Wt = V3 ? (n3 - E) / (J - E) : (n3 - O2) / (rt2 - O2), Wt <= 1 && Wt >= 0) {
                  var Nt = V3 ? (rt2 - O2) * Wt + O2 : (J - E) * Wt + E;
                  return V3 ? [n3, Nt] : [Nt, n3];
                }
                E = J, O2 = rt2;
                break;
              case T2.C:
                J = w2[q3++], rt2 = w2[q3++], gt = w2[q3++], yt = w2[q3++], At = w2[q3++], Lt = w2[q3++];
                var ue2 = V3 ? DF(E, J, gt, At, n3, W3) : DF(O2, rt2, yt, Lt, n3, W3);
                if (ue2 > 0)
                  for (var ie2 = 0; ie2 < ue2; ie2++) {
                    var pe2 = W3[ie2];
                    if (pe2 <= 1 && pe2 >= 0) {
                      var Nt = V3 ? S0(O2, rt2, yt, Lt, pe2) : S0(E, J, gt, At, pe2);
                      return V3 ? [n3, Nt] : [Nt, n3];
                    }
                  }
                E = At, O2 = Lt;
                break;
            }
          }
        }, o;
      }(Mc2), Nxn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o;
      }(k1e), P1e = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "ec-polygon", p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new Nxn();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.points, w2 = p2.stackedOnPoints, T2 = 0, E = m2.length / 2, O2 = p2.smoothMonotone;
          if (p2.connectNulls) {
            for (; E > 0 && Gz(m2[E * 2 - 2], m2[E * 2 - 1]); E--)
              ;
            for (; T2 < E && Gz(m2[T2 * 2], m2[T2 * 2 + 1]); T2++)
              ;
          }
          for (; T2 < E; ) {
            var V3 = E9t(n3, m2, T2, E, E, 1, p2.smooth, O2, p2.connectNulls);
            E9t(n3, w2, T2 + V3 - 1, V3, E, -1, p2.stackedOnSmooth, O2, p2.connectNulls), T2 += V3 + 1, n3.closePath();
          }
        }, o;
      }(Mc2);
      function L1e(u, o, n3, p2, m2) {
        var w2 = u.getArea(), T2 = w2.x, E = w2.y, O2 = w2.width, V3 = w2.height, W3 = n3.get(["lineStyle", "width"]) || 2;
        T2 -= W3 / 2, E -= W3 / 2, O2 += W3, V3 += W3, T2 = Math.floor(T2), O2 = Math.round(O2);
        var q3 = new Vf2({ shape: { x: T2, y: E, width: O2, height: V3 } });
        if (o) {
          var K = u.getBaseAxis(), J = K.isHorizontal(), rt2 = K.inverse;
          J ? (rt2 && (q3.shape.x += O2), q3.shape.width = 0) : (rt2 || (q3.shape.y += V3), q3.shape.height = 0);
          var gt = Sl(m2) ? function(yt) {
            m2(yt, q3);
          } : null;
          Qg2(q3, { shape: { width: O2, height: V3, x: T2, y: E } }, n3, null, p2, gt);
        }
        return q3;
      }
      function O1e(u, o, n3) {
        var p2 = u.getArea(), m2 = Ov(p2.r0, 1), w2 = Ov(p2.r, 1), T2 = new ww({ shape: { cx: Ov(u.cx, 1), cy: Ov(u.cy, 1), r0: m2, r: w2, startAngle: p2.startAngle, endAngle: p2.endAngle, clockwise: p2.clockwise } });
        if (o) {
          var E = u.getBaseAxis().dim === "angle";
          E ? T2.shape.endAngle = p2.startAngle : T2.shape.r = m2, Qg2(T2, { shape: { endAngle: p2.endAngle, r: w2 } }, n3);
        }
        return T2;
      }
      function Cxt(u, o, n3, p2, m2) {
        if (u) {
          if (u.type === "polar")
            return O1e(u, o, n3);
          if (u.type === "cartesian2d")
            return L1e(u, o, n3, p2, m2);
        } else
          return null;
        return null;
      }
      function I4(u, o) {
        return u.type === o;
      }
      function R1e(u, o) {
        if (u.length === o.length) {
          for (var n3 = 0; n3 < u.length; n3++)
            if (u[n3] !== o[n3])
              return;
          return true;
        }
      }
      function N1e(u) {
        for (var o = 1 / 0, n3 = 1 / 0, p2 = -1 / 0, m2 = -1 / 0, w2 = 0; w2 < u.length; ) {
          var T2 = u[w2++], E = u[w2++];
          isNaN(T2) || (o = Math.min(T2, o), p2 = Math.max(T2, p2)), isNaN(E) || (n3 = Math.min(E, n3), m2 = Math.max(E, m2));
        }
        return [[o, n3], [p2, m2]];
      }
      function F1e(u, o) {
        var n3 = N1e(u), p2 = n3[0], m2 = n3[1], w2 = N1e(o), T2 = w2[0], E = w2[1];
        return Math.max(Math.abs(p2[0] - T2[0]), Math.abs(p2[1] - T2[1]), Math.abs(m2[0] - E[0]), Math.abs(m2[1] - E[1]));
      }
      function V1e(u) {
        return Dh2(u) ? u : u ? 0.5 : 0;
      }
      function Fxn(u, o, n3) {
        if (!n3.valueDim)
          return [];
        for (var p2 = o.count(), m2 = $P(p2 * 2), w2 = 0; w2 < p2; w2++) {
          var T2 = E1e(n3, u, o, w2);
          m2[w2 * 2] = T2[0], m2[w2 * 2 + 1] = T2[1];
        }
        return m2;
      }
      function d8(u, o, n3, p2) {
        var m2 = o.getBaseAxis(), w2 = m2.dim === "x" || m2.dim === "radius" ? 0 : 1, T2 = [], E = 0, O2 = [], V3 = [], W3 = [], q3 = [];
        if (p2) {
          for (E = 0; E < u.length; E += 2)
            !isNaN(u[E]) && !isNaN(u[E + 1]) && q3.push(u[E], u[E + 1]);
          u = q3;
        }
        for (E = 0; E < u.length - 2; E += 2)
          switch (W3[0] = u[E + 2], W3[1] = u[E + 3], V3[0] = u[E], V3[1] = u[E + 1], T2.push(V3[0], V3[1]), n3) {
            case "end":
              O2[w2] = W3[w2], O2[1 - w2] = V3[1 - w2], T2.push(O2[0], O2[1]);
              break;
            case "middle":
              var K = (V3[w2] + W3[w2]) / 2, J = [];
              O2[w2] = J[w2] = K, O2[1 - w2] = V3[1 - w2], J[1 - w2] = W3[1 - w2], T2.push(O2[0], O2[1]), T2.push(J[0], J[1]);
              break;
            default:
              O2[w2] = V3[w2], O2[1 - w2] = W3[1 - w2], T2.push(O2[0], O2[1]);
          }
        return T2.push(u[E++], u[E++]), T2;
      }
      function Vxn(u, o) {
        var n3 = [], p2 = u.length, m2, w2;
        function T2(W3, q3, K) {
          var J = W3.coord, rt2 = (K - J) / (q3.coord - J), gt = X6t(rt2, [W3.color, q3.color]);
          return { coord: K, color: gt };
        }
        for (var E = 0; E < p2; E++) {
          var O2 = u[E], V3 = O2.coord;
          if (V3 < 0)
            m2 = O2;
          else if (V3 > o) {
            w2 ? n3.push(T2(w2, O2, o)) : m2 && n3.push(T2(m2, O2, 0), T2(m2, O2, o));
            break;
          } else
            m2 && (n3.push(T2(m2, O2, 0)), m2 = null), n3.push(O2), w2 = O2;
        }
        return n3;
      }
      function Bxn(u, o, n3) {
        var p2 = u.getVisual("visualMeta");
        if (!(!p2 || !p2.length || !u.count()) && o.type === "cartesian2d") {
          for (var m2, w2, T2 = p2.length - 1; T2 >= 0; T2--) {
            var E = u.getDimensionInfo(p2[T2].dimension);
            if (m2 = E && E.coordDim, m2 === "x" || m2 === "y") {
              w2 = p2[T2];
              break;
            }
          }
          if (w2) {
            var O2 = o.getAxis(m2), V3 = Ya2(w2.stops, function(Wt) {
              return { coord: O2.toGlobalCoord(O2.dataToCoord(Wt.value)), color: Wt.color };
            }), W3 = V3.length, q3 = w2.outerColors.slice();
            W3 && V3[0].coord > V3[W3 - 1].coord && (V3.reverse(), q3.reverse());
            var K = Vxn(V3, m2 === "x" ? n3.getWidth() : n3.getHeight()), J = K.length;
            if (!J && W3)
              return V3[0].coord < 0 ? q3[1] ? q3[1] : V3[W3 - 1].color : q3[0] ? q3[0] : V3[0].color;
            var rt2 = 10, gt = K[0].coord - rt2, yt = K[J - 1].coord + rt2, At = yt - gt;
            if (At < 1e-3)
              return "transparent";
            Xe2(K, function(Wt) {
              Wt.offset = (Wt.coord - gt) / At;
            }), K.push({ offset: J ? K[J - 1].offset : 0.5, color: q3[1] || "transparent" }), K.unshift({ offset: J ? K[0].offset : 0.5, color: q3[0] || "transparent" });
            var Lt = new Mz(0, 0, 0, 0, K, true);
            return Lt[m2] = gt, Lt[m2 + "2"] = yt, Lt;
          }
        }
      }
      function zxn(u, o, n3) {
        var p2 = u.get("showAllSymbol"), m2 = p2 === "auto";
        if (!(p2 && !m2)) {
          var w2 = n3.getAxesByScale("ordinal")[0];
          if (!!w2 && !(m2 && jxn(w2, o))) {
            var T2 = o.mapDimension(w2.dim), E = {};
            return Xe2(w2.getViewLabels(), function(O2) {
              var V3 = w2.scale.getRawOrdinalNumber(O2.tickValue);
              E[V3] = 1;
            }), function(O2) {
              return !E.hasOwnProperty(o.get(T2, O2));
            };
          }
        }
      }
      function jxn(u, o) {
        var n3 = u.getExtent(), p2 = Math.abs(n3[1] - n3[0]) / u.scale.count();
        isNaN(p2) && (p2 = 0);
        for (var m2 = o.count(), w2 = Math.max(1, Math.round(m2 / 5)), T2 = 0; T2 < m2; T2 += w2)
          if (nst.getSymbolSize(o, T2)[u.isHorizontal() ? 1 : 0] * 1.5 > p2)
            return false;
        return true;
      }
      function Wxn(u, o) {
        return isNaN(u) || isNaN(o);
      }
      function Gxn(u) {
        for (var o = u.length / 2; o > 0 && Wxn(u[o * 2 - 2], u[o * 2 - 1]); o--)
          ;
        return o - 1;
      }
      function B1e(u, o) {
        return [u[o * 2], u[o * 2 + 1]];
      }
      function Hxn(u, o, n3) {
        for (var p2 = u.length / 2, m2 = n3 === "x" ? 0 : 1, w2, T2, E = 0, O2 = -1, V3 = 0; V3 < p2; V3++)
          if (T2 = u[V3 * 2 + m2], !(isNaN(T2) || isNaN(u[V3 * 2 + 1 - m2]))) {
            if (V3 === 0) {
              w2 = T2;
              continue;
            }
            if (w2 <= o && T2 >= o || w2 >= o && T2 <= o) {
              O2 = V3;
              break;
            }
            E = V3, w2 = T2;
          }
        return { range: [E, O2], t: (o - w2) / (T2 - w2) };
      }
      function z1e(u) {
        if (u.get(["endLabel", "show"]))
          return true;
        for (var o = 0; o < J_.length; o++)
          if (u.get([J_[o], "endLabel", "show"]))
            return true;
        return false;
      }
      function k9t(u, o, n3, p2) {
        if (I4(o, "cartesian2d")) {
          var m2 = p2.getModel("endLabel"), w2 = m2.get("valueAnimation"), T2 = p2.getData(), E = { lastFrameIndex: 0 }, O2 = z1e(p2) ? function(J, rt2) {
            u._endLabelOnDuring(J, rt2, T2, E, w2, m2, o);
          } : null, V3 = o.getBaseAxis().isHorizontal(), W3 = L1e(o, n3, p2, function() {
            var J = u._endLabel;
            J && n3 && E.originalX != null && J.attr({ x: E.originalX, y: E.originalY });
          }, O2);
          if (!p2.get("clip", true)) {
            var q3 = W3.shape, K = Math.max(q3.width, q3.height);
            V3 ? (q3.y -= K, q3.height += K * 2) : (q3.x -= K, q3.width += K * 2);
          }
          return O2 && O2(1, W3), W3;
        } else
          return O1e(o, n3, p2);
      }
      function Uxn(u, o) {
        var n3 = o.getBaseAxis(), p2 = n3.isHorizontal(), m2 = n3.inverse, w2 = p2 ? m2 ? "right" : "left" : "center", T2 = p2 ? "middle" : m2 ? "top" : "bottom";
        return { normal: { align: u.get("align") || w2, verticalAlign: u.get("verticalAlign") || T2 } };
      }
      var qxn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.init = function() {
          var n3 = new uu(), p2 = new rst();
          this.group.add(p2.group), this._symbolDraw = p2, this._lineGroup = n3;
        }, o.prototype.render = function(n3, p2, m2) {
          var w2 = this, T2 = n3.coordinateSystem, E = this.group, O2 = n3.getData(), V3 = n3.getModel("lineStyle"), W3 = n3.getModel("areaStyle"), q3 = O2.getLayout("points") || [], K = T2.type === "polar", J = this._coordSys, rt2 = this._symbolDraw, gt = this._polyline, yt = this._polygon, At = this._lineGroup, Lt = n3.get("animation"), Wt = !W3.isEmpty(), Nt = W3.get("origin"), ue2 = D1e(T2, O2, Nt), ie2 = Wt && Fxn(T2, O2, ue2), pe2 = n3.get("showSymbol"), xe = n3.get("connectNulls"), Ce2 = pe2 && !K && zxn(n3, O2, T2), Le2 = this._data;
          Le2 && Le2.eachItemGraphicEl(function(tl, el) {
            tl.__temp && (E.remove(tl), Le2.setItemGraphicEl(el, null));
          }), pe2 || rt2.remove(), E.add(At);
          var ze = K ? false : n3.get("step"), tn;
          T2 && T2.getArea && n3.get("clip", true) && (tn = T2.getArea(), tn.width != null ? (tn.x -= 0.1, tn.y -= 0.1, tn.width += 0.2, tn.height += 0.2) : tn.r0 && (tn.r0 -= 0.5, tn.r += 0.5)), this._clipShapeForSymbol = tn;
          var $e2 = Bxn(O2, T2, m2) || O2.getVisual("style")[O2.getVisual("drawType")];
          if (!(gt && J.type === T2.type && ze === this._step))
            pe2 && rt2.updateData(O2, { isIgnore: Ce2, clipShape: tn, disableAnimation: true, getSymbolPoint: function(tl) {
              return [q3[tl * 2], q3[tl * 2 + 1]];
            } }), Lt && this._initSymbolLabelAnimation(O2, T2, tn), ze && (q3 = d8(q3, T2, ze, xe), ie2 && (ie2 = d8(ie2, T2, ze, xe))), gt = this._newPolyline(q3), Wt && (yt = this._newPolygon(q3, ie2)), K || this._initOrUpdateEndLabel(n3, T2, Iz($e2)), At.setClipPath(k9t(this, T2, true, n3));
          else {
            Wt && !yt ? yt = this._newPolygon(q3, ie2) : yt && !Wt && (At.remove(yt), yt = this._polygon = null), K || this._initOrUpdateEndLabel(n3, T2, Iz($e2));
            var Tn = At.getClipPath();
            if (Tn) {
              var zn = k9t(this, T2, false, n3);
              Qg2(Tn, { shape: zn.shape }, n3);
            } else
              At.setClipPath(k9t(this, T2, true, n3));
            pe2 && rt2.updateData(O2, { isIgnore: Ce2, clipShape: tn, disableAnimation: true, getSymbolPoint: function(tl) {
              return [q3[tl * 2], q3[tl * 2 + 1]];
            } }), (!R1e(this._stackedOnPoints, ie2) || !R1e(this._points, q3)) && (Lt ? this._doUpdateAnimation(O2, ie2, T2, m2, ze, Nt, xe) : (ze && (q3 = d8(q3, T2, ze, xe), ie2 && (ie2 = d8(ie2, T2, ze, xe))), gt.setShape({ points: q3 }), yt && yt.setShape({ points: q3, stackedOnPoints: ie2 })));
          }
          var bn = n3.getModel("emphasis"), Xr = bn.get("focus"), Xn = bn.get("blurScope"), or = bn.get("disabled");
          if (gt.useStyle(kl(V3.getLineStyle(), { fill: "none", stroke: $e2, lineJoin: "bevel" })), Ky(gt, n3, "lineStyle"), gt.style.lineWidth > 0 && n3.get(["emphasis", "lineStyle", "width"]) === "bolder") {
            var Tr = gt.getState("emphasis").style;
            Tr.lineWidth = +gt.style.lineWidth + 1;
          }
          is(gt).seriesIndex = n3.seriesIndex, o0(gt, Xr, Xn, or);
          var ci2 = V1e(n3.get("smooth")), yi2 = n3.get("smoothMonotone");
          if (gt.setShape({ smooth: ci2, smoothMonotone: yi2, connectNulls: xe }), yt) {
            var Po = O2.getCalculationInfo("stackedOnSeries"), Ms = 0;
            yt.useStyle(kl(W3.getAreaStyle(), { fill: $e2, opacity: 0.7, lineJoin: "bevel", decal: O2.getVisual("style").decal })), Po && (Ms = V1e(Po.get("smooth"))), yt.setShape({ smooth: ci2, stackedOnSmooth: Ms, smoothMonotone: yi2, connectNulls: xe }), Ky(yt, n3, "areaStyle"), is(yt).seriesIndex = n3.seriesIndex, o0(yt, Xr, Xn, or);
          }
          var dl = function(tl) {
            w2._changePolyState(tl);
          };
          O2.eachItemGraphicEl(function(tl) {
            tl && (tl.onHoverStateChange = dl);
          }), this._polyline.onHoverStateChange = dl, this._data = O2, this._coordSys = T2, this._stackedOnPoints = ie2, this._points = q3, this._step = ze, this._valueOrigin = Nt, n3.get("triggerLineEvent") && (this.packEventData(n3, gt), yt && this.packEventData(n3, yt));
        }, o.prototype.packEventData = function(n3, p2) {
          is(p2).eventData = { componentType: "series", componentSubType: "line", componentIndex: n3.componentIndex, seriesIndex: n3.seriesIndex, seriesName: n3.name, seriesType: "line" };
        }, o.prototype.highlight = function(n3, p2, m2, w2) {
          var T2 = n3.getData(), E = AC(T2, w2);
          if (this._changePolyState("emphasis"), !(E instanceof Array) && E != null && E >= 0) {
            var O2 = T2.getLayout("points"), V3 = T2.getItemGraphicEl(E);
            if (!V3) {
              var W3 = O2[E * 2], q3 = O2[E * 2 + 1];
              if (isNaN(W3) || isNaN(q3) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(W3, q3))
                return;
              var K = n3.get("zlevel"), J = n3.get("z");
              V3 = new nst(T2, E), V3.x = W3, V3.y = q3, V3.setZ(K, J);
              var rt2 = V3.getSymbolPath().getTextContent();
              rt2 && (rt2.zlevel = K, rt2.z = J, rt2.z2 = this._polyline.z2 + 1), V3.__temp = true, T2.setItemGraphicEl(E, V3), V3.stopSymbolAnimation(true), this.group.add(V3);
            }
            V3.highlight();
          } else
            xg2.prototype.highlight.call(this, n3, p2, m2, w2);
        }, o.prototype.downplay = function(n3, p2, m2, w2) {
          var T2 = n3.getData(), E = AC(T2, w2);
          if (this._changePolyState("normal"), E != null && E >= 0) {
            var O2 = T2.getItemGraphicEl(E);
            O2 && (O2.__temp ? (T2.setItemGraphicEl(E, null), this.group.remove(O2)) : O2.downplay());
          } else
            xg2.prototype.downplay.call(this, n3, p2, m2, w2);
        }, o.prototype._changePolyState = function(n3) {
          var p2 = this._polygon;
          v42(this._polyline, n3), p2 && v42(p2, n3);
        }, o.prototype._newPolyline = function(n3) {
          var p2 = this._polyline;
          return p2 && this._lineGroup.remove(p2), p2 = new Rxn({ shape: { points: n3 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(p2), this._polyline = p2, p2;
        }, o.prototype._newPolygon = function(n3, p2) {
          var m2 = this._polygon;
          return m2 && this._lineGroup.remove(m2), m2 = new P1e({ shape: { points: n3, stackedOnPoints: p2 }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(m2), this._polygon = m2, m2;
        }, o.prototype._initSymbolLabelAnimation = function(n3, p2, m2) {
          var w2, T2, E = p2.getBaseAxis(), O2 = E.inverse;
          p2.type === "cartesian2d" ? (w2 = E.isHorizontal(), T2 = false) : p2.type === "polar" && (w2 = E.dim === "angle", T2 = true);
          var V3 = n3.hostModel, W3 = V3.get("animationDuration");
          Sl(W3) && (W3 = W3(null));
          var q3 = V3.get("animationDelay") || 0, K = Sl(q3) ? q3(null) : q3;
          n3.eachItemGraphicEl(function(J, rt2) {
            var gt = J;
            if (gt) {
              var yt = [J.x, J.y], At = void 0, Lt = void 0, Wt = void 0;
              if (m2)
                if (T2) {
                  var Nt = m2, ue2 = p2.pointToCoord(yt);
                  w2 ? (At = Nt.startAngle, Lt = Nt.endAngle, Wt = -ue2[1] / 180 * Math.PI) : (At = Nt.r0, Lt = Nt.r, Wt = ue2[0]);
                } else {
                  var ie2 = m2;
                  w2 ? (At = ie2.x, Lt = ie2.x + ie2.width, Wt = J.x) : (At = ie2.y + ie2.height, Lt = ie2.y, Wt = J.y);
                }
              var pe2 = Lt === At ? 0 : (Wt - At) / (Lt - At);
              O2 && (pe2 = 1 - pe2);
              var xe = Sl(q3) ? q3(rt2) : W3 * pe2 + K, Ce2 = gt.getSymbolPath(), Le2 = Ce2.getTextContent();
              gt.attr({ scaleX: 0, scaleY: 0 }), gt.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: xe }), Le2 && Le2.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: xe }), Ce2.disableLabelAnimation = true;
            }
          });
        }, o.prototype._initOrUpdateEndLabel = function(n3, p2, m2) {
          var w2 = n3.getModel("endLabel");
          if (z1e(n3)) {
            var T2 = n3.getData(), E = this._polyline, O2 = T2.getLayout("points");
            if (!O2) {
              E.removeTextContent(), this._endLabel = null;
              return;
            }
            var V3 = this._endLabel;
            V3 || (V3 = this._endLabel = new Zc2({ z2: 200 }), V3.ignoreClip = true, E.setTextContent(this._endLabel), E.disableLabelAnimation = true);
            var W3 = Gxn(O2);
            W3 >= 0 && (Tw(E, Lb2(n3, "endLabel"), { inheritColor: m2, labelFetcher: n3, labelDataIndex: W3, defaultText: function(q3, K, J) {
              return J != null ? T1e(T2, J) : fY(T2, q3);
            }, enableTextSetter: true }, Uxn(w2, p2)), E.textConfig.position = null);
          } else
            this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
        }, o.prototype._endLabelOnDuring = function(n3, p2, m2, w2, T2, E, O2) {
          var V3 = this._endLabel, W3 = this._polyline;
          if (V3) {
            n3 < 1 && w2.originalX == null && (w2.originalX = V3.x, w2.originalY = V3.y);
            var q3 = m2.getLayout("points"), K = m2.hostModel, J = K.get("connectNulls"), rt2 = E.get("precision"), gt = E.get("distance") || 0, yt = O2.getBaseAxis(), At = yt.isHorizontal(), Lt = yt.inverse, Wt = p2.shape, Nt = Lt ? At ? Wt.x : Wt.y + Wt.height : At ? Wt.x + Wt.width : Wt.y, ue2 = (At ? gt : 0) * (Lt ? -1 : 1), ie2 = (At ? 0 : -gt) * (Lt ? -1 : 1), pe2 = At ? "x" : "y", xe = Hxn(q3, Nt, pe2), Ce2 = xe.range, Le2 = Ce2[1] - Ce2[0], ze = void 0;
            if (Le2 >= 1) {
              if (Le2 > 1 && !J) {
                var tn = B1e(q3, Ce2[0]);
                V3.attr({ x: tn[0] + ue2, y: tn[1] + ie2 }), T2 && (ze = K.getRawValue(Ce2[0]));
              } else {
                var tn = W3.getPointOn(Nt, pe2);
                tn && V3.attr({ x: tn[0] + ue2, y: tn[1] + ie2 });
                var $e2 = K.getRawValue(Ce2[0]), Tn = K.getRawValue(Ce2[1]);
                T2 && (ze = ZF(m2, rt2, $e2, Tn, xe.t));
              }
              w2.lastFrameIndex = Ce2[0];
            } else {
              var zn = n3 === 1 || w2.lastFrameIndex > 0 ? Ce2[0] : 0, tn = B1e(q3, zn);
              T2 && (ze = K.getRawValue(zn)), V3.attr({ x: tn[0] + ue2, y: tn[1] + ie2 });
            }
            T2 && H$(V3).setLabelText(ze);
          }
        }, o.prototype._doUpdateAnimation = function(n3, p2, m2, w2, T2, E, O2) {
          var V3 = this._polyline, W3 = this._polygon, q3 = n3.hostModel, K = Oxn(this._data, n3, this._stackedOnPoints, p2, this._coordSys, m2, this._valueOrigin), J = K.current, rt2 = K.stackedOnCurrent, gt = K.next, yt = K.stackedOnNext;
          if (T2 && (J = d8(K.current, m2, T2, O2), rt2 = d8(K.stackedOnCurrent, m2, T2, O2), gt = d8(K.next, m2, T2, O2), yt = d8(K.stackedOnNext, m2, T2, O2)), F1e(J, gt) > 3e3 || W3 && F1e(rt2, yt) > 3e3) {
            V3.stopAnimation(), V3.setShape({ points: gt }), W3 && (W3.stopAnimation(), W3.setShape({ points: gt, stackedOnPoints: yt }));
            return;
          }
          V3.shape.__points = K.current, V3.shape.points = J;
          var At = { shape: { points: gt } };
          K.current !== J && (At.shape.__points = K.next), V3.stopAnimation(), Xf2(V3, At, q3), W3 && (W3.setShape({ points: J, stackedOnPoints: rt2 }), W3.stopAnimation(), Xf2(W3, { shape: { stackedOnPoints: yt } }, q3), V3.shape.points !== W3.shape.points && (W3.shape.points = V3.shape.points));
          for (var Lt = [], Wt = K.status, Nt = 0; Nt < Wt.length; Nt++) {
            var ue2 = Wt[Nt].cmd;
            if (ue2 === "=") {
              var ie2 = n3.getItemGraphicEl(Wt[Nt].idx1);
              ie2 && Lt.push({ el: ie2, ptIdx: Nt });
            }
          }
          V3.animators && V3.animators.length && V3.animators[0].during(function() {
            W3 && W3.dirtyShape();
            for (var pe2 = V3.shape.__points, xe = 0; xe < Lt.length; xe++) {
              var Ce2 = Lt[xe].el, Le2 = Lt[xe].ptIdx * 2;
              Ce2.x = pe2[Le2], Ce2.y = pe2[Le2 + 1], Ce2.markRedraw();
            }
          });
        }, o.prototype.remove = function(n3) {
          var p2 = this.group, m2 = this._data;
          this._lineGroup.removeAll(), this._symbolDraw.remove(true), m2 && m2.eachItemGraphicEl(function(w2, T2) {
            w2.__temp && (p2.remove(w2), m2.setItemGraphicEl(T2, null));
          }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
        }, o.type = "line", o;
      }(xg2), Zxn = qxn;
      function ist(u, o) {
        return { seriesType: u, plan: eY(), reset: function(n3) {
          var p2 = n3.getData(), m2 = n3.coordinateSystem, w2 = n3.pipelineContext, T2 = o || w2.large;
          if (m2) {
            var E = Ya2(m2.dimensions, function(J) {
              return p2.mapDimension(J);
            }).slice(0, 2), O2 = E.length, V3 = p2.getCalculationInfo("stackResultDimension");
            c8(p2, E[0]) && (E[0] = V3), c8(p2, E[1]) && (E[1] = V3);
            var W3 = p2.getStore(), q3 = p2.getDimensionIndex(E[0]), K = p2.getDimensionIndex(E[1]);
            return O2 && { progress: function(J, rt2) {
              for (var gt = J.end - J.start, yt = T2 && $P(gt * O2), At = [], Lt = [], Wt = J.start, Nt = 0; Wt < J.end; Wt++) {
                var ue2 = void 0;
                if (O2 === 1) {
                  var ie2 = W3.get(q3, Wt);
                  ue2 = m2.dataToPoint(ie2, null, Lt);
                } else
                  At[0] = W3.get(q3, Wt), At[1] = W3.get(K, Wt), ue2 = m2.dataToPoint(At, null, Lt);
                T2 ? (yt[Nt++] = ue2[0], yt[Nt++] = ue2[1]) : rt2.setItemLayout(Wt, ue2.slice());
              }
              T2 && rt2.setLayout("points", yt);
            } };
          }
        } };
      }
      var $xn = { average: function(u) {
        for (var o = 0, n3 = 0, p2 = 0; p2 < u.length; p2++)
          isNaN(u[p2]) || (o += u[p2], n3++);
        return n3 === 0 ? NaN : o / n3;
      }, sum: function(u) {
        for (var o = 0, n3 = 0; n3 < u.length; n3++)
          o += u[n3] || 0;
        return o;
      }, max: function(u) {
        for (var o = -1 / 0, n3 = 0; n3 < u.length; n3++)
          u[n3] > o && (o = u[n3]);
        return isFinite(o) ? o : NaN;
      }, min: function(u) {
        for (var o = 1 / 0, n3 = 0; n3 < u.length; n3++)
          u[n3] < o && (o = u[n3]);
        return isFinite(o) ? o : NaN;
      }, nearest: function(u) {
        return u[0];
      } }, Yxn = function(u) {
        return Math.round(u.length / 2);
      };
      function j1e(u) {
        return { seriesType: u, reset: function(o, n3, p2) {
          var m2 = o.getData(), w2 = o.get("sampling"), T2 = o.coordinateSystem, E = m2.count();
          if (E > 10 && T2.type === "cartesian2d" && w2) {
            var O2 = T2.getBaseAxis(), V3 = T2.getOtherAxis(O2), W3 = O2.getExtent(), q3 = p2.getDevicePixelRatio(), K = Math.abs(W3[1] - W3[0]) * (q3 || 1), J = Math.round(E / K);
            if (isFinite(J) && J > 1) {
              w2 === "lttb" && o.setData(m2.lttbDownSample(m2.mapDimension(V3.dim), 1 / J));
              var rt2 = void 0;
              ds(w2) ? rt2 = $xn[w2] : Sl(w2) && (rt2 = w2), rt2 && o.setData(m2.downSample(m2.mapDimension(V3.dim), 1 / J, rt2, Yxn));
            }
          }
        } };
      }
      function Kxn(u) {
        u.registerChartView(Zxn), u.registerSeriesModel(Ixn), u.registerLayout(ist("line", true)), u.registerVisual({ seriesType: "line", reset: function(o) {
          var n3 = o.getData(), p2 = o.getModel("lineStyle").getLineStyle();
          p2 && !p2.stroke && (p2.stroke = n3.getVisual("style").fill), n3.setVisual("legendLineStyle", p2);
        } }), u.registerProcessor(u.PRIORITY.PROCESSOR.STATISTIC, j1e("line"));
      }
      var W1e = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          return T4(null, this, { useEncodeDefaulter: true });
        }, o.prototype.getMarkerPosition = function(n3) {
          var p2 = this.coordinateSystem;
          if (p2 && p2.clampData) {
            var m2 = p2.dataToPoint(p2.clampData(n3)), w2 = this.getData(), T2 = w2.getLayout("offset"), E = w2.getLayout("size"), O2 = p2.getBaseAxis().isHorizontal() ? 0 : 1;
            return m2[O2] += T2 + E / 2, m2;
          }
          return [NaN, NaN];
        }, o.type = "series.__base_bar__", o.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, o;
      }(Rv);
      Rv.registerClass(W1e);
      var Txt = W1e, Xxn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.getInitialData = function() {
          return T4(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
        }, o.prototype.getProgressive = function() {
          return this.get("large") ? this.get("progressive") : false;
        }, o.prototype.getProgressiveThreshold = function() {
          var n3 = this.get("progressiveThreshold"), p2 = this.get("largeThreshold");
          return p2 > n3 && (n3 = p2), n3;
        }, o.prototype.brushSelector = function(n3, p2, m2) {
          return m2.rect(p2.getItemLayout(n3));
        }, o.type = "series.bar", o.dependencies = ["grid", "polar"], o.defaultOption = r8(Txt.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), o;
      }(Txt), Qxn = Xxn, Jxn = function() {
        function u() {
          this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
        }
        return u;
      }(), twn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "sausage", p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new Jxn();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.cx, w2 = p2.cy, T2 = Math.max(p2.r0 || 0, 0), E = Math.max(p2.r, 0), O2 = (E - T2) * 0.5, V3 = T2 + O2, W3 = p2.startAngle, q3 = p2.endAngle, K = p2.clockwise, J = Math.PI * 2, rt2 = K ? q3 - W3 < J : W3 - q3 < J;
          rt2 || (W3 = q3 - (K ? J : -J));
          var gt = Math.cos(W3), yt = Math.sin(W3), At = Math.cos(q3), Lt = Math.sin(q3);
          rt2 ? (n3.moveTo(gt * T2 + m2, yt * T2 + w2), n3.arc(gt * V3 + m2, yt * V3 + w2, O2, -Math.PI + W3, W3, !K)) : n3.moveTo(gt * E + m2, yt * E + w2), n3.arc(m2, w2, E, W3, q3, !K), n3.arc(At * V3 + m2, Lt * V3 + w2, O2, q3 - Math.PI * 2, q3 - Math.PI, !K), T2 !== 0 && n3.arc(m2, w2, T2, q3, W3, K);
        }, o;
      }(Mc2), Axt = twn;
      function ewn(u, o) {
        o = o || {};
        var n3 = o.isRoundCap;
        return function(p2, m2, w2) {
          var T2 = m2.position;
          if (!T2 || T2 instanceof Array)
            return r$(p2, m2, w2);
          var E = u(T2), O2 = m2.distance != null ? m2.distance : 5, V3 = this.shape, W3 = V3.cx, q3 = V3.cy, K = V3.r, J = V3.r0, rt2 = (K + J) / 2, gt = V3.startAngle, yt = V3.endAngle, At = (gt + yt) / 2, Lt = n3 ? Math.abs(K - J) / 2 : 0, Wt = Math.cos, Nt = Math.sin, ue2 = W3 + K * Wt(gt), ie2 = q3 + K * Nt(gt), pe2 = "left", xe = "top";
          switch (E) {
            case "startArc":
              ue2 = W3 + (J - O2) * Wt(At), ie2 = q3 + (J - O2) * Nt(At), pe2 = "center", xe = "top";
              break;
            case "insideStartArc":
              ue2 = W3 + (J + O2) * Wt(At), ie2 = q3 + (J + O2) * Nt(At), pe2 = "center", xe = "bottom";
              break;
            case "startAngle":
              ue2 = W3 + rt2 * Wt(gt) + Ixt(gt, O2 + Lt, false), ie2 = q3 + rt2 * Nt(gt) + Dxt(gt, O2 + Lt, false), pe2 = "right", xe = "middle";
              break;
            case "insideStartAngle":
              ue2 = W3 + rt2 * Wt(gt) + Ixt(gt, -O2 + Lt, false), ie2 = q3 + rt2 * Nt(gt) + Dxt(gt, -O2 + Lt, false), pe2 = "left", xe = "middle";
              break;
            case "middle":
              ue2 = W3 + rt2 * Wt(At), ie2 = q3 + rt2 * Nt(At), pe2 = "center", xe = "middle";
              break;
            case "endArc":
              ue2 = W3 + (K + O2) * Wt(At), ie2 = q3 + (K + O2) * Nt(At), pe2 = "center", xe = "bottom";
              break;
            case "insideEndArc":
              ue2 = W3 + (K - O2) * Wt(At), ie2 = q3 + (K - O2) * Nt(At), pe2 = "center", xe = "top";
              break;
            case "endAngle":
              ue2 = W3 + rt2 * Wt(yt) + Ixt(yt, O2 + Lt, true), ie2 = q3 + rt2 * Nt(yt) + Dxt(yt, O2 + Lt, true), pe2 = "left", xe = "middle";
              break;
            case "insideEndAngle":
              ue2 = W3 + rt2 * Wt(yt) + Ixt(yt, -O2 + Lt, true), ie2 = q3 + rt2 * Nt(yt) + Dxt(yt, -O2 + Lt, true), pe2 = "right", xe = "middle";
              break;
            default:
              return r$(p2, m2, w2);
          }
          return p2 = p2 || {}, p2.x = ue2, p2.y = ie2, p2.align = pe2, p2.verticalAlign = xe, p2;
        };
      }
      function nwn(u, o, n3, p2) {
        if (Dh2(p2)) {
          u.setTextConfig({ rotation: p2 });
          return;
        } else if (za2(o)) {
          u.setTextConfig({ rotation: 0 });
          return;
        }
        var m2 = u.shape, w2 = m2.clockwise ? m2.startAngle : m2.endAngle, T2 = m2.clockwise ? m2.endAngle : m2.startAngle, E = (w2 + T2) / 2, O2, V3 = n3(o);
        switch (V3) {
          case "startArc":
          case "insideStartArc":
          case "middle":
          case "insideEndArc":
          case "endArc":
            O2 = E;
            break;
          case "startAngle":
          case "insideStartAngle":
            O2 = w2;
            break;
          case "endAngle":
          case "insideEndAngle":
            O2 = T2;
            break;
          default:
            u.setTextConfig({ rotation: 0 });
            return;
        }
        var W3 = Math.PI * 1.5 - O2;
        V3 === "middle" && W3 > Math.PI / 2 && W3 < Math.PI * 1.5 && (W3 -= Math.PI), u.setTextConfig({ rotation: W3 });
      }
      function Ixt(u, o, n3) {
        return o * Math.sin(u) * (n3 ? -1 : 1);
      }
      function Dxt(u, o, n3) {
        return o * Math.cos(u) * (n3 ? 1 : -1);
      }
      var P9t = Math.max, L9t = Math.min;
      function rwn(u, o) {
        var n3 = u.getArea && u.getArea();
        if (I4(u, "cartesian2d")) {
          var p2 = u.getBaseAxis();
          if (p2.type !== "category" || !p2.onBand) {
            var m2 = o.getLayout("bandWidth");
            p2.isHorizontal() ? (n3.x -= m2, n3.width += m2 * 2) : (n3.y -= m2, n3.height += m2 * 2);
          }
        }
        return n3;
      }
      var iwn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u.call(this) || this;
          return n3.type = o.type, n3._isFirstFrame = true, n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          this._model = n3, this._removeOnRenderedListener(m2), this._updateDrawMode(n3);
          var T2 = n3.get("coordinateSystem");
          (T2 === "cartesian2d" || T2 === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(n3, p2, m2) : this._renderNormal(n3, p2, m2, w2));
        }, o.prototype.incrementalPrepareRender = function(n3) {
          this._clear(), this._updateDrawMode(n3), this._updateLargeClip(n3);
        }, o.prototype.incrementalRender = function(n3, p2) {
          this._progressiveEls = [], this._incrementalRenderLarge(n3, p2);
        }, o.prototype.eachRendered = function(n3) {
          n8(this._progressiveEls || this.group, n3);
        }, o.prototype._updateDrawMode = function(n3) {
          var p2 = n3.pipelineContext.large;
          (this._isLargeDraw == null || p2 !== this._isLargeDraw) && (this._isLargeDraw = p2, this._clear());
        }, o.prototype._renderNormal = function(n3, p2, m2, w2) {
          var T2 = this.group, E = n3.getData(), O2 = this._data, V3 = n3.coordinateSystem, W3 = V3.getBaseAxis(), q3;
          V3.type === "cartesian2d" ? q3 = W3.isHorizontal() : V3.type === "polar" && (q3 = W3.dim === "angle");
          var K = n3.isAnimationEnabled() ? n3 : null, J = awn(n3, V3);
          J && this._enableRealtimeSort(J, E, m2);
          var rt2 = n3.get("clip", true) || J, gt = rwn(V3, E);
          T2.removeClipPath();
          var yt = n3.get("roundCap", true), At = n3.get("showBackground", true), Lt = n3.getModel("backgroundStyle"), Wt = Lt.get("borderRadius") || 0, Nt = [], ue2 = this._backgroundEls, ie2 = w2 && w2.isInitSort, pe2 = w2 && w2.type === "changeAxisOrder";
          function xe(ze) {
            var tn = Ext[V3.type](E, ze), $e2 = hwn(V3, q3, tn);
            return $e2.useStyle(Lt.getItemStyle()), V3.type === "cartesian2d" && $e2.setShape("r", Wt), Nt[ze] = $e2, $e2;
          }
          E.diff(O2).add(function(ze) {
            var tn = E.getItemModel(ze), $e2 = Ext[V3.type](E, ze, tn);
            if (At && xe(ze), !(!E.hasValue(ze) || !Z1e[V3.type]($e2))) {
              var Tn = false;
              rt2 && (Tn = G1e[V3.type](gt, $e2));
              var zn = H1e[V3.type](n3, E, ze, $e2, q3, K, W3.model, false, yt);
              J && (zn.forceLabelAnimation = true), Y1e(zn, E, ze, tn, $e2, n3, q3, V3.type === "polar"), ie2 ? zn.attr({ shape: $e2 }) : J ? U1e(J, K, zn, $e2, ze, q3, false, false) : Qg2(zn, { shape: $e2 }, n3, ze), E.setItemGraphicEl(ze, zn), T2.add(zn), zn.ignore = Tn;
            }
          }).update(function(ze, tn) {
            var $e2 = E.getItemModel(ze), Tn = Ext[V3.type](E, ze, $e2);
            if (At) {
              var zn = void 0;
              ue2.length === 0 ? zn = xe(tn) : (zn = ue2[tn], zn.useStyle(Lt.getItemStyle()), V3.type === "cartesian2d" && zn.setShape("r", Wt), Nt[ze] = zn);
              var bn = Ext[V3.type](E, ze), Xr = J1e(q3, bn, V3);
              Xf2(zn, { shape: Xr }, K, ze);
            }
            var Xn = O2.getItemGraphicEl(tn);
            if (!E.hasValue(ze) || !Z1e[V3.type](Tn)) {
              T2.remove(Xn);
              return;
            }
            var or = false;
            if (rt2 && (or = G1e[V3.type](gt, Tn), or && T2.remove(Xn)), Xn ? DC(Xn) : Xn = H1e[V3.type](n3, E, ze, Tn, q3, K, W3.model, !!Xn, yt), J && (Xn.forceLabelAnimation = true), pe2) {
              var Tr = Xn.getTextContent();
              if (Tr) {
                var ci2 = H$(Tr);
                ci2.prevValue != null && (ci2.prevValue = ci2.value);
              }
            } else
              Y1e(Xn, E, ze, $e2, Tn, n3, q3, V3.type === "polar");
            ie2 ? Xn.attr({ shape: Tn }) : J ? U1e(J, K, Xn, Tn, ze, q3, true, pe2) : Xf2(Xn, { shape: Tn }, n3, ze, null), E.setItemGraphicEl(ze, Xn), Xn.ignore = or, T2.add(Xn);
          }).remove(function(ze) {
            var tn = O2.getItemGraphicEl(ze);
            tn && Cz(tn, n3, ze);
          }).execute();
          var Ce2 = this._backgroundGroup || (this._backgroundGroup = new uu());
          Ce2.removeAll();
          for (var Le2 = 0; Le2 < Nt.length; ++Le2)
            Ce2.add(Nt[Le2]);
          T2.add(Ce2), this._backgroundEls = Nt, this._data = E;
        }, o.prototype._renderLarge = function(n3, p2, m2) {
          this._clear(), X1e(n3, this.group), this._updateLargeClip(n3);
        }, o.prototype._incrementalRenderLarge = function(n3, p2) {
          this._removeBackground(), X1e(p2, this.group, this._progressiveEls, true);
        }, o.prototype._updateLargeClip = function(n3) {
          var p2 = n3.get("clip", true) && Cxt(n3.coordinateSystem, false, n3), m2 = this.group;
          p2 ? m2.setClipPath(p2) : m2.removeClipPath();
        }, o.prototype._enableRealtimeSort = function(n3, p2, m2) {
          var w2 = this;
          if (p2.count()) {
            var T2 = n3.baseAxis;
            if (this._isFirstFrame)
              this._dispatchInitSort(p2, n3, m2), this._isFirstFrame = false;
            else {
              var E = function(O2) {
                var V3 = p2.getItemGraphicEl(O2), W3 = V3 && V3.shape;
                return W3 && Math.abs(T2.isHorizontal() ? W3.height : W3.width) || 0;
              };
              this._onRendered = function() {
                w2._updateSortWithinSameData(p2, E, T2, m2);
              }, m2.getZr().on("rendered", this._onRendered);
            }
          }
        }, o.prototype._dataSort = function(n3, p2, m2) {
          var w2 = [];
          return n3.each(n3.mapDimension(p2.dim), function(T2, E) {
            var O2 = m2(E);
            O2 = O2 == null ? NaN : O2, w2.push({ dataIndex: E, mappedValue: O2, ordinalNumber: T2 });
          }), w2.sort(function(T2, E) {
            return E.mappedValue - T2.mappedValue;
          }), { ordinalNumbers: Ya2(w2, function(T2) {
            return T2.ordinalNumber;
          }) };
        }, o.prototype._isOrderChangedWithinSameData = function(n3, p2, m2) {
          for (var w2 = m2.scale, T2 = n3.mapDimension(m2.dim), E = Number.MAX_VALUE, O2 = 0, V3 = w2.getOrdinalMeta().categories.length; O2 < V3; ++O2) {
            var W3 = n3.rawIndexOf(T2, w2.getRawOrdinalNumber(O2)), q3 = W3 < 0 ? Number.MIN_VALUE : p2(n3.indexOfRawIndex(W3));
            if (q3 > E)
              return true;
            E = q3;
          }
          return false;
        }, o.prototype._isOrderDifferentInView = function(n3, p2) {
          for (var m2 = p2.scale, w2 = m2.getExtent(), T2 = Math.max(0, w2[0]), E = Math.min(w2[1], m2.getOrdinalMeta().categories.length - 1); T2 <= E; ++T2)
            if (n3.ordinalNumbers[T2] !== m2.getRawOrdinalNumber(T2))
              return true;
        }, o.prototype._updateSortWithinSameData = function(n3, p2, m2, w2) {
          if (this._isOrderChangedWithinSameData(n3, p2, m2)) {
            var T2 = this._dataSort(n3, m2, p2);
            this._isOrderDifferentInView(T2, m2) && (this._removeOnRenderedListener(w2), w2.dispatchAction({ type: "changeAxisOrder", componentType: m2.dim + "Axis", axisId: m2.index, sortInfo: T2 }));
          }
        }, o.prototype._dispatchInitSort = function(n3, p2, m2) {
          var w2 = p2.baseAxis, T2 = this._dataSort(n3, w2, function(E) {
            return n3.get(n3.mapDimension(p2.otherAxis.dim), E);
          });
          m2.dispatchAction({ type: "changeAxisOrder", componentType: w2.dim + "Axis", isInitSort: true, axisId: w2.index, sortInfo: T2 });
        }, o.prototype.remove = function(n3, p2) {
          this._clear(this._model), this._removeOnRenderedListener(p2);
        }, o.prototype.dispose = function(n3, p2) {
          this._removeOnRenderedListener(p2);
        }, o.prototype._removeOnRenderedListener = function(n3) {
          this._onRendered && (n3.getZr().off("rendered", this._onRendered), this._onRendered = null);
        }, o.prototype._clear = function(n3) {
          var p2 = this.group, m2 = this._data;
          n3 && n3.isAnimationEnabled() && m2 && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], m2.eachItemGraphicEl(function(w2) {
            Cz(w2, n3, is(w2).dataIndex);
          })) : p2.removeAll(), this._data = null, this._isFirstFrame = true;
        }, o.prototype._removeBackground = function() {
          this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
        }, o.type = "bar", o;
      }(xg2), G1e = { cartesian2d: function(u, o) {
        var n3 = o.width < 0 ? -1 : 1, p2 = o.height < 0 ? -1 : 1;
        n3 < 0 && (o.x += o.width, o.width = -o.width), p2 < 0 && (o.y += o.height, o.height = -o.height);
        var m2 = u.x + u.width, w2 = u.y + u.height, T2 = P9t(o.x, u.x), E = L9t(o.x + o.width, m2), O2 = P9t(o.y, u.y), V3 = L9t(o.y + o.height, w2), W3 = E < T2, q3 = V3 < O2;
        return o.x = W3 && T2 > m2 ? E : T2, o.y = q3 && O2 > w2 ? V3 : O2, o.width = W3 ? 0 : E - T2, o.height = q3 ? 0 : V3 - O2, n3 < 0 && (o.x += o.width, o.width = -o.width), p2 < 0 && (o.y += o.height, o.height = -o.height), W3 || q3;
      }, polar: function(u, o) {
        var n3 = o.r0 <= o.r ? 1 : -1;
        if (n3 < 0) {
          var p2 = o.r;
          o.r = o.r0, o.r0 = p2;
        }
        var m2 = L9t(o.r, u.r), w2 = P9t(o.r0, u.r0);
        o.r = m2, o.r0 = w2;
        var T2 = m2 - w2 < 0;
        if (n3 < 0) {
          var p2 = o.r;
          o.r = o.r0, o.r0 = p2;
        }
        return T2;
      } }, H1e = { cartesian2d: function(u, o, n3, p2, m2, w2, T2, E, O2) {
        var V3 = new Vf2({ shape: ua2({}, p2), z2: 1 });
        if (V3.__dataIndex = n3, V3.name = "item", w2) {
          var W3 = V3.shape, q3 = m2 ? "height" : "width";
          W3[q3] = 0;
        }
        return V3;
      }, polar: function(u, o, n3, p2, m2, w2, T2, E, O2) {
        var V3 = !m2 && O2 ? Axt : ww, W3 = new V3({ shape: p2, z2: 1 });
        W3.name = "item";
        var q3 = $1e(m2);
        if (W3.calculateTextPosition = ewn(q3, { isRoundCap: V3 === Axt }), w2) {
          var K = W3.shape, J = m2 ? "r" : "endAngle", rt2 = {};
          K[J] = m2 ? 0 : p2.startAngle, rt2[J] = p2[J], (E ? Xf2 : Qg2)(W3, { shape: rt2 }, w2);
        }
        return W3;
      } };
      function awn(u, o) {
        var n3 = u.get("realtimeSort", true), p2 = o.getBaseAxis();
        if (n3 && p2.type === "category" && o.type === "cartesian2d")
          return { baseAxis: p2, otherAxis: o.getOtherAxis(p2) };
      }
      function U1e(u, o, n3, p2, m2, w2, T2, E) {
        var O2, V3;
        w2 ? (V3 = { x: p2.x, width: p2.width }, O2 = { y: p2.y, height: p2.height }) : (V3 = { y: p2.y, height: p2.height }, O2 = { x: p2.x, width: p2.width }), E || (T2 ? Xf2 : Qg2)(n3, { shape: O2 }, o, m2, null);
        var W3 = o ? u.baseAxis.model : null;
        (T2 ? Xf2 : Qg2)(n3, { shape: V3 }, W3, m2);
      }
      function q1e(u, o) {
        for (var n3 = 0; n3 < o.length; n3++)
          if (!isFinite(u[o[n3]]))
            return true;
        return false;
      }
      var own = ["x", "y", "width", "height"], swn = ["cx", "cy", "r", "startAngle", "endAngle"], Z1e = { cartesian2d: function(u) {
        return !q1e(u, own);
      }, polar: function(u) {
        return !q1e(u, swn);
      } }, Ext = { cartesian2d: function(u, o, n3) {
        var p2 = u.getItemLayout(o), m2 = n3 ? uwn(n3, p2) : 0, w2 = p2.width > 0 ? 1 : -1, T2 = p2.height > 0 ? 1 : -1;
        return { x: p2.x + w2 * m2 / 2, y: p2.y + T2 * m2 / 2, width: p2.width - w2 * m2, height: p2.height - T2 * m2 };
      }, polar: function(u, o, n3) {
        var p2 = u.getItemLayout(o);
        return { cx: p2.cx, cy: p2.cy, r0: p2.r0, r: p2.r, startAngle: p2.startAngle, endAngle: p2.endAngle, clockwise: p2.clockwise };
      } };
      function lwn(u) {
        return u.startAngle != null && u.endAngle != null && u.startAngle === u.endAngle;
      }
      function $1e(u) {
        return function(o) {
          var n3 = o ? "Arc" : "Angle";
          return function(p2) {
            switch (p2) {
              case "start":
              case "insideStart":
              case "end":
              case "insideEnd":
                return p2 + n3;
              default:
                return p2;
            }
          };
        }(u);
      }
      function Y1e(u, o, n3, p2, m2, w2, T2, E) {
        var O2 = o.getItemVisual(n3, "style");
        E || u.setShape("r", p2.get(["itemStyle", "borderRadius"]) || 0), u.useStyle(O2);
        var V3 = p2.getShallow("cursor");
        V3 && u.attr("cursor", V3);
        var W3 = E ? T2 ? m2.r >= m2.r0 ? "endArc" : "startArc" : m2.endAngle >= m2.startAngle ? "endAngle" : "startAngle" : T2 ? m2.height >= 0 ? "bottom" : "top" : m2.width >= 0 ? "right" : "left", q3 = Lb2(p2);
        Tw(u, q3, { labelFetcher: w2, labelDataIndex: n3, defaultText: fY(w2.getData(), n3), inheritColor: O2.fill, defaultOpacity: O2.opacity, defaultOutsidePosition: W3 });
        var K = u.getTextContent();
        if (E && K) {
          var J = p2.get(["label", "position"]);
          u.textConfig.inside = J === "middle" ? true : null, nwn(u, J === "outside" ? W3 : J, $1e(T2), p2.get(["label", "rotate"]));
        }
        gve(K, q3, w2.getRawValue(n3), function(gt) {
          return T1e(o, gt);
        });
        var rt2 = p2.getModel(["emphasis"]);
        o0(u, rt2.get("focus"), rt2.get("blurScope"), rt2.get("disabled")), Ky(u, p2), lwn(m2) && (u.style.fill = "none", u.style.stroke = "none", Xe2(u.states, function(gt) {
          gt.style && (gt.style.fill = gt.style.stroke = "none");
        }));
      }
      function uwn(u, o) {
        var n3 = u.get(["itemStyle", "borderColor"]);
        if (!n3 || n3 === "none")
          return 0;
        var p2 = u.get(["itemStyle", "borderWidth"]) || 0, m2 = isNaN(o.width) ? Number.MAX_VALUE : Math.abs(o.width), w2 = isNaN(o.height) ? Number.MAX_VALUE : Math.abs(o.height);
        return Math.min(p2, m2, w2);
      }
      var cwn = function() {
        function u() {
        }
        return u;
      }(), K1e = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "largeBar", p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new cwn();
        }, o.prototype.buildPath = function(n3, p2) {
          for (var m2 = p2.points, w2 = this.baseDimIdx, T2 = 1 - this.baseDimIdx, E = [], O2 = [], V3 = this.barWidth, W3 = 0; W3 < m2.length; W3 += 3)
            O2[w2] = V3, O2[T2] = m2[W3 + 2], E[w2] = m2[W3 + w2], E[T2] = m2[W3 + T2], n3.rect(E[0], E[1], O2[0], O2[1]);
        }, o;
      }(Mc2);
      function X1e(u, o, n3, p2) {
        var m2 = u.getData(), w2 = m2.getLayout("valueAxisHorizontal") ? 1 : 0, T2 = m2.getLayout("largeDataIndices"), E = m2.getLayout("size"), O2 = u.getModel("backgroundStyle"), V3 = m2.getLayout("largeBackgroundPoints");
        if (V3) {
          var W3 = new K1e({ shape: { points: V3 }, incremental: !!p2, silent: true, z2: 0 });
          W3.baseDimIdx = w2, W3.largeDataIndices = T2, W3.barWidth = E, W3.useStyle(O2.getItemStyle()), o.add(W3), n3 && n3.push(W3);
        }
        var q3 = new K1e({ shape: { points: m2.getLayout("largePoints") }, incremental: !!p2, z2: 1 });
        q3.baseDimIdx = w2, q3.largeDataIndices = T2, q3.barWidth = E, o.add(q3), q3.useStyle(m2.getVisual("style")), is(q3).seriesIndex = u.seriesIndex, u.get("silent") || (q3.on("mousedown", Q1e), q3.on("mousemove", Q1e)), n3 && n3.push(q3);
      }
      var Q1e = k8t(function(u) {
        var o = this, n3 = fwn(o, u.offsetX, u.offsetY);
        is(o).dataIndex = n3 >= 0 ? n3 : null;
      }, 30, false);
      function fwn(u, o, n3) {
        for (var p2 = u.baseDimIdx, m2 = 1 - p2, w2 = u.shape.points, T2 = u.largeDataIndices, E = [], O2 = [], V3 = u.barWidth, W3 = 0, q3 = w2.length / 3; W3 < q3; W3++) {
          var K = W3 * 3;
          if (O2[p2] = V3, O2[m2] = w2[K + 2], E[p2] = w2[K + p2], E[m2] = w2[K + m2], O2[m2] < 0 && (E[m2] += O2[m2], O2[m2] = -O2[m2]), o >= E[0] && o <= E[0] + O2[0] && n3 >= E[1] && n3 <= E[1] + O2[1])
            return T2[W3];
        }
        return -1;
      }
      function J1e(u, o, n3) {
        if (I4(n3, "cartesian2d")) {
          var p2 = o, m2 = n3.getArea();
          return { x: u ? p2.x : m2.x, y: u ? m2.y : p2.y, width: u ? p2.width : m2.width, height: u ? m2.height : p2.height };
        } else {
          var m2 = n3.getArea(), w2 = o;
          return { cx: m2.cx, cy: m2.cy, r0: u ? m2.r0 : w2.r0, r: u ? m2.r : w2.r, startAngle: u ? w2.startAngle : 0, endAngle: u ? w2.endAngle : Math.PI * 2 };
        }
      }
      function hwn(u, o, n3) {
        var p2 = u.type === "polar" ? ww : Vf2;
        return new p2({ shape: J1e(o, n3, u), silent: true, z2: 0 });
      }
      var pwn = iwn;
      function dwn(u) {
        u.registerChartView(pwn), u.registerSeriesModel(Qxn), u.registerLayout(u.PRIORITY.VISUAL.LAYOUT, wu(mme, "bar")), u.registerLayout(u.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, bme("bar")), u.registerProcessor(u.PRIORITY.PROCESSOR.STATISTIC, j1e("bar")), u.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(o, n3) {
          var p2 = o.componentType || "series";
          n3.eachComponent({ mainType: p2, query: o }, function(m2) {
            o.sortInfo && m2.axis.setCategorySortInfo(o.sortInfo);
          });
        });
      }
      var kxt = Math.PI * 2, tbe = Math.PI / 180;
      function ebe(u, o) {
        return Bm(u.getBoxLayoutParams(), { width: o.getWidth(), height: o.getHeight() });
      }
      function nbe(u, o) {
        var n3 = ebe(u, o), p2 = u.get("center"), m2 = u.get("radius");
        za2(m2) || (m2 = [0, m2]), za2(p2) || (p2 = [p2, p2]);
        var w2 = Qo(n3.width, o.getWidth()), T2 = Qo(n3.height, o.getHeight()), E = Math.min(w2, T2), O2 = Qo(p2[0], w2) + n3.x, V3 = Qo(p2[1], T2) + n3.y, W3 = Qo(m2[0], E / 2), q3 = Qo(m2[1], E / 2);
        return { cx: O2, cy: V3, r0: W3, r: q3 };
      }
      function gwn(u, o, n3) {
        o.eachSeriesByType(u, function(p2) {
          var m2 = p2.getData(), w2 = m2.mapDimension("value"), T2 = ebe(p2, n3), E = nbe(p2, n3), O2 = E.cx, V3 = E.cy, W3 = E.r, q3 = E.r0, K = -p2.get("startAngle") * tbe, J = p2.get("minAngle") * tbe, rt2 = 0;
          m2.each(w2, function(Le2) {
            !isNaN(Le2) && rt2++;
          });
          var gt = m2.getSum(w2), yt = Math.PI / (gt || rt2) * 2, At = p2.get("clockwise"), Lt = p2.get("roseType"), Wt = p2.get("stillShowZeroSum"), Nt = m2.getDataExtent(w2);
          Nt[0] = 0;
          var ue2 = kxt, ie2 = 0, pe2 = K, xe = At ? 1 : -1;
          if (m2.setLayout({ viewRect: T2, r: W3 }), m2.each(w2, function(Le2, ze) {
            var tn;
            if (isNaN(Le2)) {
              m2.setItemLayout(ze, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: At, cx: O2, cy: V3, r0: q3, r: Lt ? NaN : W3 });
              return;
            }
            Lt !== "area" ? tn = gt === 0 && Wt ? yt : Le2 * yt : tn = kxt / rt2, tn < J ? (tn = J, ue2 -= J) : ie2 += Le2;
            var $e2 = pe2 + xe * tn;
            m2.setItemLayout(ze, { angle: tn, startAngle: pe2, endAngle: $e2, clockwise: At, cx: O2, cy: V3, r0: q3, r: Lt ? bp(Le2, Nt, [q3, W3]) : W3 }), pe2 = $e2;
          }), ue2 < kxt && rt2)
            if (ue2 <= 1e-3) {
              var Ce2 = kxt / rt2;
              m2.each(w2, function(Le2, ze) {
                if (!isNaN(Le2)) {
                  var tn = m2.getItemLayout(ze);
                  tn.angle = Ce2, tn.startAngle = K + xe * ze * Ce2, tn.endAngle = K + xe * (ze + 1) * Ce2;
                }
              });
            } else
              yt = ue2 / ie2, pe2 = K, m2.each(w2, function(Le2, ze) {
                if (!isNaN(Le2)) {
                  var tn = m2.getItemLayout(ze), $e2 = tn.angle === J ? J : Le2 * yt;
                  tn.startAngle = pe2, tn.endAngle = pe2 + xe * $e2, pe2 += xe * $e2;
                }
              });
        });
      }
      function ast(u) {
        return { seriesType: u, reset: function(o, n3) {
          var p2 = n3.findComponents({ mainType: "legend" });
          if (!(!p2 || !p2.length)) {
            var m2 = o.getData();
            m2.filterSelf(function(w2) {
              for (var T2 = m2.getName(w2), E = 0; E < p2.length; E++)
                if (!p2[E].isSelected(T2))
                  return false;
              return true;
            });
          }
        } };
      }
      var vwn = Math.PI / 180;
      function rbe(u, o, n3, p2, m2, w2, T2, E, O2, V3) {
        if (u.length < 2)
          return;
        function W3(gt) {
          for (var yt = gt.rB, At = yt * yt, Lt = 0; Lt < gt.list.length; Lt++) {
            var Wt = gt.list[Lt], Nt = Math.abs(Wt.label.y - n3), ue2 = p2 + Wt.len, ie2 = ue2 * ue2, pe2 = Math.sqrt((1 - Math.abs(Nt * Nt / At)) * ie2), xe = o + (pe2 + Wt.len2) * m2, Ce2 = xe - Wt.label.x, Le2 = Wt.targetTextWidth - Ce2 * m2;
            ibe(Wt, Le2, true), Wt.label.x = xe;
          }
        }
        function q3(gt) {
          for (var yt = { list: [], maxY: 0 }, At = { list: [], maxY: 0 }, Lt = 0; Lt < gt.length; Lt++)
            if (gt[Lt].labelAlignTo === "none") {
              var Wt = gt[Lt], Nt = Wt.label.y > n3 ? At : yt, ue2 = Math.abs(Wt.label.y - n3);
              if (ue2 >= Nt.maxY) {
                var ie2 = Wt.label.x - o - Wt.len2 * m2, pe2 = p2 + Wt.len, xe = Math.abs(ie2) < pe2 ? Math.sqrt(ue2 * ue2 / (1 - ie2 * ie2 / pe2 / pe2)) : pe2;
                Nt.rB = xe, Nt.maxY = ue2;
              }
              Nt.list.push(Wt);
            }
          W3(yt), W3(At);
        }
        for (var K = u.length, J = 0; J < K; J++)
          if (u[J].position === "outer" && u[J].labelAlignTo === "labelLine") {
            var rt2 = u[J].label.x - V3;
            u[J].linePoints[1][0] += rt2, u[J].label.x = V3;
          }
        Xme(u, O2, O2 + T2) && q3(u);
      }
      function ywn(u, o, n3, p2, m2, w2, T2, E) {
        for (var O2 = [], V3 = [], W3 = Number.MAX_VALUE, q3 = -Number.MAX_VALUE, K = 0; K < u.length; K++) {
          var J = u[K].label;
          O9t(u[K]) || (J.x < o ? (W3 = Math.min(W3, J.x), O2.push(u[K])) : (q3 = Math.max(q3, J.x), V3.push(u[K])));
        }
        for (var K = 0; K < u.length; K++) {
          var rt2 = u[K];
          if (!O9t(rt2) && rt2.linePoints) {
            if (rt2.labelStyleWidth != null)
              continue;
            var J = rt2.label, gt = rt2.linePoints, yt = void 0;
            rt2.labelAlignTo === "edge" ? J.x < o ? yt = gt[2][0] - rt2.labelDistance - T2 - rt2.edgeDistance : yt = T2 + m2 - rt2.edgeDistance - gt[2][0] - rt2.labelDistance : rt2.labelAlignTo === "labelLine" ? J.x < o ? yt = W3 - T2 - rt2.bleedMargin : yt = T2 + m2 - q3 - rt2.bleedMargin : J.x < o ? yt = J.x - T2 - rt2.bleedMargin : yt = T2 + m2 - J.x - rt2.bleedMargin, rt2.targetTextWidth = yt, ibe(rt2, yt);
          }
        }
        rbe(V3, o, n3, p2, 1, m2, w2, T2, E, q3), rbe(O2, o, n3, p2, -1, m2, w2, T2, E, W3);
        for (var K = 0; K < u.length; K++) {
          var rt2 = u[K];
          if (!O9t(rt2) && rt2.linePoints) {
            var J = rt2.label, gt = rt2.linePoints, At = rt2.labelAlignTo === "edge", Lt = J.style.padding, Wt = Lt ? Lt[1] + Lt[3] : 0, Nt = J.style.backgroundColor ? 0 : Wt, ue2 = rt2.rect.width + Nt, ie2 = gt[1][0] - gt[2][0];
            At ? J.x < o ? gt[2][0] = T2 + rt2.edgeDistance + ue2 + rt2.labelDistance : gt[2][0] = T2 + m2 - rt2.edgeDistance - ue2 - rt2.labelDistance : (J.x < o ? gt[2][0] = J.x + rt2.labelDistance : gt[2][0] = J.x - rt2.labelDistance, gt[1][0] = gt[2][0] + ie2), gt[1][1] = gt[2][1] = J.y;
          }
        }
      }
      function ibe(u, o, n3) {
        if (n3 === void 0 && (n3 = false), u.labelStyleWidth == null) {
          var p2 = u.label, m2 = p2.style, w2 = u.rect, T2 = m2.backgroundColor, E = m2.padding, O2 = E ? E[1] + E[3] : 0, V3 = m2.overflow, W3 = w2.width + (T2 ? 0 : O2);
          if (o < W3 || n3) {
            var q3 = w2.height;
            if (V3 && V3.match("break")) {
              p2.setStyle("backgroundColor", null), p2.setStyle("width", o - O2);
              var K = p2.getBoundingRect();
              p2.setStyle("width", Math.ceil(K.width)), p2.setStyle("backgroundColor", T2);
            } else {
              var J = o - O2, rt2 = o < W3 ? J : n3 ? J > u.unconstrainedWidth ? null : J : null;
              p2.setStyle("width", rt2);
            }
            var gt = p2.getBoundingRect();
            w2.width = gt.width;
            var yt = (p2.style.margin || 0) + 2.1;
            w2.height = gt.height + yt, w2.y -= (w2.height - q3) / 2;
          }
        }
      }
      function O9t(u) {
        return u.position === "center";
      }
      function mwn(u) {
        var o = u.getData(), n3 = [], p2, m2, w2 = false, T2 = (u.get("minShowLabelAngle") || 0) * vwn, E = o.getLayout("viewRect"), O2 = o.getLayout("r"), V3 = E.width, W3 = E.x, q3 = E.y, K = E.height;
        function J(ie2) {
          ie2.ignore = true;
        }
        function rt2(ie2) {
          if (!ie2.ignore)
            return true;
          for (var pe2 in ie2.states)
            if (ie2.states[pe2].ignore === false)
              return true;
          return false;
        }
        o.each(function(ie2) {
          var pe2 = o.getItemGraphicEl(ie2), xe = pe2.shape, Ce2 = pe2.getTextContent(), Le2 = pe2.getTextGuideLine(), ze = o.getItemModel(ie2), tn = ze.getModel("label"), $e2 = tn.get("position") || ze.get(["emphasis", "label", "position"]), Tn = tn.get("distanceToLabelLine"), zn = tn.get("alignTo"), bn = Qo(tn.get("edgeDistance"), V3), Xr = tn.get("bleedMargin"), Xn = ze.getModel("labelLine"), or = Xn.get("length");
          or = Qo(or, V3);
          var Tr = Xn.get("length2");
          if (Tr = Qo(Tr, V3), Math.abs(xe.endAngle - xe.startAngle) < T2) {
            Xe2(Ce2.states, J), Ce2.ignore = true;
            return;
          }
          if (rt2(Ce2)) {
            var ci2 = (xe.startAngle + xe.endAngle) / 2, yi2 = Math.cos(ci2), Po = Math.sin(ci2), Ms, dl, tl, el;
            p2 = xe.cx, m2 = xe.cy;
            var as = $e2 === "inside" || $e2 === "inner";
            if ($e2 === "center")
              Ms = xe.cx, dl = xe.cy, el = "center";
            else {
              var Hs = (as ? (xe.r + xe.r0) / 2 * yi2 : xe.r * yi2) + p2, ol = (as ? (xe.r + xe.r0) / 2 * Po : xe.r * Po) + m2;
              if (Ms = Hs + yi2 * 3, dl = ol + Po * 3, !as) {
                var xs = Hs + yi2 * (or + O2 - xe.r), Bl = ol + Po * (or + O2 - xe.r), Ph2 = xs + (yi2 < 0 ? -1 : 1) * Tr, fu = Bl;
                zn === "edge" ? Ms = yi2 < 0 ? W3 + bn : W3 + V3 - bn : Ms = Ph2 + (yi2 < 0 ? -Tn : Tn), dl = fu, tl = [[Hs, ol], [xs, Bl], [Ph2, fu]];
              }
              el = as ? "center" : zn === "edge" ? yi2 > 0 ? "right" : "left" : yi2 > 0 ? "left" : "right";
            }
            var uh2 = Math.PI, Zh2 = 0, zp = tn.get("rotate");
            if (Dh2(zp))
              Zh2 = zp * (uh2 / 180);
            else if ($e2 === "center")
              Zh2 = 0;
            else if (zp === "radial" || zp === true) {
              var tm = yi2 < 0 ? -ci2 + uh2 : -ci2;
              Zh2 = tm;
            } else if (zp === "tangential" && $e2 !== "outside" && $e2 !== "outer") {
              var Fd2 = Math.atan2(yi2, Po);
              Fd2 < 0 && (Fd2 = uh2 * 2 + Fd2);
              var O1 = Po > 0;
              O1 && (Fd2 = uh2 + Fd2), Zh2 = Fd2 - uh2;
            }
            if (w2 = !!Zh2, Ce2.x = Ms, Ce2.y = dl, Ce2.rotation = Zh2, Ce2.setStyle({ verticalAlign: "middle" }), as) {
              Ce2.setStyle({ align: el });
              var Kd2 = Ce2.states.select;
              Kd2 && (Kd2.x += Ce2.x, Kd2.y += Ce2.y);
            } else {
              var Nv = Ce2.getBoundingRect().clone();
              Nv.applyTransform(Ce2.getComputedTransform());
              var mv = (Ce2.style.margin || 0) + 2.1;
              Nv.y -= mv / 2, Nv.height += mv, n3.push({ label: Ce2, labelLine: Le2, position: $e2, len: or, len2: Tr, minTurnAngle: Xn.get("minTurnAngle"), maxSurfaceAngle: Xn.get("maxSurfaceAngle"), surfaceNormal: new Vu(yi2, Po), linePoints: tl, textAlign: el, labelDistance: Tn, labelAlignTo: zn, edgeDistance: bn, bleedMargin: Xr, rect: Nv, unconstrainedWidth: Nv.width, labelStyleWidth: Ce2.style.width });
            }
            pe2.setTextConfig({ inside: as });
          }
        }), !w2 && u.get("avoidLabelOverlap") && ywn(n3, p2, m2, O2, V3, K, W3, q3);
        for (var gt = 0; gt < n3.length; gt++) {
          var yt = n3[gt], At = yt.label, Lt = yt.labelLine, Wt = isNaN(At.x) || isNaN(At.y);
          if (At) {
            At.setStyle({ align: yt.textAlign }), Wt && (Xe2(At.states, J), At.ignore = true);
            var Nt = At.states.select;
            Nt && (Nt.x += At.x, Nt.y += At.y);
          }
          if (Lt) {
            var ue2 = yt.linePoints;
            Wt || !ue2 ? (Xe2(Lt.states, J), Lt.ignore = true) : (Zme(ue2, yt.minTurnAngle), E_n(ue2, yt.surfaceNormal, yt.maxSurfaceAngle), Lt.setShape({ points: ue2 }), At.__hostTarget.textGuideLineConfig = { anchor: new Vu(ue2[0][0], ue2[0][1]) });
          }
        }
      }
      function hY(u, o, n3) {
        var p2 = u.get("borderRadius");
        if (p2 == null)
          return n3 ? { cornerRadius: 0 } : null;
        za2(p2) || (p2 = [p2, p2, p2, p2]);
        var m2 = Math.abs(o.r || 0 - o.r0 || 0);
        return { cornerRadius: Ya2(p2, function(w2) {
          return Rm(w2, m2);
        }) };
      }
      var bwn = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this) || this;
          w2.z2 = 2;
          var T2 = new Zc2();
          return w2.setTextContent(T2), w2.updateData(n3, p2, m2, true), w2;
        }
        return o.prototype.updateData = function(n3, p2, m2, w2) {
          var T2 = this, E = n3.hostModel, O2 = n3.getItemModel(p2), V3 = O2.getModel("emphasis"), W3 = n3.getItemLayout(p2), q3 = ua2(hY(O2.getModel("itemStyle"), W3, true), W3);
          if (isNaN(q3.startAngle)) {
            T2.setShape(q3);
            return;
          }
          if (w2) {
            T2.setShape(q3);
            var K = E.getShallow("animationType");
            E.ecModel.ssr ? (Qg2(T2, { scaleX: 0, scaleY: 0 }, E, { dataIndex: p2, isFrom: true }), T2.originX = q3.cx, T2.originY = q3.cy) : K === "scale" ? (T2.shape.r = W3.r0, Qg2(T2, { shape: { r: W3.r } }, E, p2)) : m2 != null ? (T2.setShape({ startAngle: m2, endAngle: m2 }), Qg2(T2, { shape: { startAngle: W3.startAngle, endAngle: W3.endAngle } }, E, p2)) : (T2.shape.endAngle = W3.startAngle, Xf2(T2, { shape: { endAngle: W3.endAngle } }, E, p2));
          } else
            DC(T2), Xf2(T2, { shape: q3 }, E, p2);
          T2.useStyle(n3.getItemVisual(p2, "style")), Ky(T2, O2);
          var J = (W3.startAngle + W3.endAngle) / 2, rt2 = E.get("selectedOffset"), gt = Math.cos(J) * rt2, yt = Math.sin(J) * rt2, At = O2.getShallow("cursor");
          At && T2.attr("cursor", At), this._updateLabel(E, n3, p2), T2.ensureState("emphasis").shape = ua2({ r: W3.r + (V3.get("scale") && V3.get("scaleSize") || 0) }, hY(V3.getModel("itemStyle"), W3)), ua2(T2.ensureState("select"), { x: gt, y: yt, shape: hY(O2.getModel(["select", "itemStyle"]), W3) }), ua2(T2.ensureState("blur"), { shape: hY(O2.getModel(["blur", "itemStyle"]), W3) });
          var Lt = T2.getTextGuideLine(), Wt = T2.getTextContent();
          Lt && ua2(Lt.ensureState("select"), { x: gt, y: yt }), ua2(Wt.ensureState("select"), { x: gt, y: yt }), o0(this, V3.get("focus"), V3.get("blurScope"), V3.get("disabled"));
        }, o.prototype._updateLabel = function(n3, p2, m2) {
          var w2 = this, T2 = p2.getItemModel(m2), E = T2.getModel("labelLine"), O2 = p2.getItemVisual(m2, "style"), V3 = O2 && O2.fill, W3 = O2 && O2.opacity;
          Tw(w2, Lb2(T2), { labelFetcher: p2.hostModel, labelDataIndex: m2, inheritColor: V3, defaultOpacity: W3, defaultText: n3.getFormattedLabel(m2, "normal") || p2.getName(m2) });
          var q3 = w2.getTextContent();
          w2.setTextConfig({ position: null, rotation: null }), q3.attr({ z2: 10 });
          var K = n3.get(["label", "position"]);
          if (K !== "outside" && K !== "outer")
            w2.removeTextGuideLine();
          else {
            var J = this.getTextGuideLine();
            J || (J = new Mw(), this.setTextGuideLine(J)), d9t(this, g9t(T2), { stroke: V3, opacity: gv(E.get(["lineStyle", "opacity"]), W3, 1) });
          }
        }, o;
      }(ww), _wn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.ignoreLabelLineUpdate = true, n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          var T2 = n3.getData(), E = this._data, O2 = this.group, V3;
          if (!E && T2.count() > 0) {
            for (var W3 = T2.getItemLayout(0), q3 = 1; isNaN(W3 && W3.startAngle) && q3 < T2.count(); ++q3)
              W3 = T2.getItemLayout(q3);
            W3 && (V3 = W3.startAngle);
          }
          if (this._emptyCircleSector && O2.remove(this._emptyCircleSector), T2.count() === 0 && n3.get("showEmptyCircle")) {
            var K = new ww({ shape: nbe(n3, m2) });
            K.useStyle(n3.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = K, O2.add(K);
          }
          T2.diff(E).add(function(J) {
            var rt2 = new bwn(T2, J, V3);
            T2.setItemGraphicEl(J, rt2), O2.add(rt2);
          }).update(function(J, rt2) {
            var gt = E.getItemGraphicEl(rt2);
            gt.updateData(T2, J, V3), gt.off("click"), O2.add(gt), T2.setItemGraphicEl(J, gt);
          }).remove(function(J) {
            var rt2 = E.getItemGraphicEl(J);
            Cz(rt2, n3, J);
          }).execute(), mwn(n3), n3.get("animationTypeUpdate") !== "expansion" && (this._data = T2);
        }, o.prototype.dispose = function() {
        }, o.prototype.containPoint = function(n3, p2) {
          var m2 = p2.getData(), w2 = m2.getItemLayout(0);
          if (w2) {
            var T2 = n3[0] - w2.cx, E = n3[1] - w2.cy, O2 = Math.sqrt(T2 * T2 + E * E);
            return O2 <= w2.r && O2 >= w2.r0;
          }
        }, o.type = "pie", o;
      }(xg2), xwn = _wn;
      function pY(u, o, n3) {
        o = za2(o) && { coordDimensions: o } || ua2({ encodeDefine: u.getEncode() }, o);
        var p2 = u.getSource(), m2 = qot(p2, o).dimensions, w2 = new o2(m2, u);
        return w2.initData(p2, n3), w2;
      }
      var wwn = function() {
        function u(o, n3) {
          this._getDataWithEncodedVisual = o, this._getRawData = n3;
        }
        return u.prototype.getAllNames = function() {
          var o = this._getRawData();
          return o.mapArray(o.getName);
        }, u.prototype.containName = function(o) {
          var n3 = this._getRawData();
          return n3.indexOfName(o) >= 0;
        }, u.prototype.indexOfName = function(o) {
          var n3 = this._getDataWithEncodedVisual();
          return n3.indexOfName(o);
        }, u.prototype.getItemVisual = function(o, n3) {
          var p2 = this._getDataWithEncodedVisual();
          return p2.getItemVisual(o, n3);
        }, u;
      }(), ost = wwn, Swn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.init = function(n3) {
          u.prototype.init.apply(this, arguments), this.legendVisualProvider = new ost(Is(this.getData, this), Is(this.getRawData, this)), this._defaultLabelLine(n3);
        }, o.prototype.mergeOption = function() {
          u.prototype.mergeOption.apply(this, arguments);
        }, o.prototype.getInitialData = function() {
          return pY(this, { coordDimensions: ["value"], encodeDefaulter: wu(l8t, this) });
        }, o.prototype.getDataParams = function(n3) {
          var p2 = this.getData(), m2 = u.prototype.getDataParams.call(this, n3), w2 = [];
          return p2.each(p2.mapDimension("value"), function(T2) {
            w2.push(T2);
          }), m2.percent = pbt(w2, n3, p2.hostModel.get("percentPrecision")), m2.$vars.push("percent"), m2;
        }, o.prototype._defaultLabelLine = function(n3) {
          t22(n3, "labelLine", ["show"]);
          var p2 = n3.labelLine, m2 = n3.emphasis.labelLine;
          p2.show = p2.show && n3.label.show, m2.show = m2.show && n3.emphasis.label.show;
        }, o.type = "series.pie", o.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, o;
      }(Rv), Mwn = Swn;
      function Cwn(u) {
        return { seriesType: u, reset: function(o, n3) {
          var p2 = o.getData();
          p2.filterSelf(function(m2) {
            var w2 = p2.mapDimension("value"), T2 = p2.get(w2, m2);
            return !(Dh2(T2) && !isNaN(T2) && T2 < 0);
          });
        } };
      }
      function Twn(u) {
        u.registerChartView(xwn), u.registerSeriesModel(Mwn), uye("pie", u.registerAction), u.registerLayout(wu(gwn, "pie")), u.registerProcessor(ast("pie")), u.registerProcessor(Cwn("pie"));
      }
      var Awn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.hasSymbolVisual = true, n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          return T4(null, this, { useEncodeDefaulter: true });
        }, o.prototype.getProgressive = function() {
          var n3 = this.option.progressive;
          return n3 == null ? this.option.large ? 5e3 : this.get("progressive") : n3;
        }, o.prototype.getProgressiveThreshold = function() {
          var n3 = this.option.progressiveThreshold;
          return n3 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : n3;
        }, o.prototype.brushSelector = function(n3, p2, m2) {
          return m2.point(p2.getItemLayout(n3));
        }, o.prototype.getZLevelKey = function() {
          return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
        }, o.type = "series.scatter", o.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], o.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, o;
      }(Rv), Iwn = Awn, abe = 4, Dwn = function() {
        function u() {
        }
        return u;
      }(), Ewn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2._off = 0, p2.hoverDataIdx = -1, p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new Dwn();
        }, o.prototype.reset = function() {
          this.notClear = false, this._off = 0;
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.points, w2 = p2.size, T2 = this.symbolProxy, E = T2.shape, O2 = n3.getContext ? n3.getContext() : n3, V3 = O2 && w2[0] < abe, W3 = this.softClipShape, q3;
          if (V3) {
            this._ctx = O2;
            return;
          }
          for (this._ctx = null, q3 = this._off; q3 < m2.length; ) {
            var K = m2[q3++], J = m2[q3++];
            isNaN(K) || isNaN(J) || W3 && !W3.contain(K, J) || (E.x = K - w2[0] / 2, E.y = J - w2[1] / 2, E.width = w2[0], E.height = w2[1], T2.buildPath(n3, E, true));
          }
          this.incremental && (this._off = q3, this.notClear = true);
        }, o.prototype.afterBrush = function() {
          var n3 = this.shape, p2 = n3.points, m2 = n3.size, w2 = this._ctx, T2 = this.softClipShape, E;
          if (w2) {
            for (E = this._off; E < p2.length; ) {
              var O2 = p2[E++], V3 = p2[E++];
              isNaN(O2) || isNaN(V3) || T2 && !T2.contain(O2, V3) || w2.fillRect(O2 - m2[0] / 2, V3 - m2[1] / 2, m2[0], m2[1]);
            }
            this.incremental && (this._off = E, this.notClear = true);
          }
        }, o.prototype.findDataIndex = function(n3, p2) {
          for (var m2 = this.shape, w2 = m2.points, T2 = m2.size, E = Math.max(T2[0], 4), O2 = Math.max(T2[1], 4), V3 = w2.length / 2 - 1; V3 >= 0; V3--) {
            var W3 = V3 * 2, q3 = w2[W3] - E / 2, K = w2[W3 + 1] - O2 / 2;
            if (n3 >= q3 && p2 >= K && n3 <= q3 + E && p2 <= K + O2)
              return V3;
          }
          return -1;
        }, o.prototype.contain = function(n3, p2) {
          var m2 = this.transformCoordToLocal(n3, p2), w2 = this.getBoundingRect();
          if (n3 = m2[0], p2 = m2[1], w2.contain(n3, p2)) {
            var T2 = this.hoverDataIdx = this.findDataIndex(n3, p2);
            return T2 >= 0;
          }
          return this.hoverDataIdx = -1, false;
        }, o.prototype.getBoundingRect = function() {
          var n3 = this._rect;
          if (!n3) {
            for (var p2 = this.shape, m2 = p2.points, w2 = p2.size, T2 = w2[0], E = w2[1], O2 = 1 / 0, V3 = 1 / 0, W3 = -1 / 0, q3 = -1 / 0, K = 0; K < m2.length; ) {
              var J = m2[K++], rt2 = m2[K++];
              O2 = Math.min(J, O2), W3 = Math.max(J, W3), V3 = Math.min(rt2, V3), q3 = Math.max(rt2, q3);
            }
            n3 = this._rect = new Qu(O2 - T2 / 2, V3 - E / 2, W3 - O2 + T2, q3 - V3 + E);
          }
          return n3;
        }, o;
      }(Mc2), kwn = function() {
        function u() {
          this.group = new uu();
        }
        return u.prototype.updateData = function(o, n3) {
          this._clear();
          var p2 = this._create();
          p2.setShape({ points: o.getLayout("points") }), this._setCommon(p2, o, n3);
        }, u.prototype.updateLayout = function(o) {
          var n3 = o.getLayout("points");
          this.group.eachChild(function(p2) {
            if (p2.startIndex != null) {
              var m2 = (p2.endIndex - p2.startIndex) * 2, w2 = p2.startIndex * 4 * 2;
              n3 = new Float32Array(n3.buffer, w2, m2);
            }
            p2.setShape("points", n3), p2.reset();
          });
        }, u.prototype.incrementalPrepareUpdate = function(o) {
          this._clear();
        }, u.prototype.incrementalUpdate = function(o, n3, p2) {
          var m2 = this._newAdded[0], w2 = n3.getLayout("points"), T2 = m2 && m2.shape.points;
          if (T2 && T2.length < 2e4) {
            var E = T2.length, O2 = new Float32Array(E + w2.length);
            O2.set(T2), O2.set(w2, E), m2.endIndex = o.end, m2.setShape({ points: O2 });
          } else {
            this._newAdded = [];
            var V3 = this._create();
            V3.startIndex = o.start, V3.endIndex = o.end, V3.incremental = true, V3.setShape({ points: w2 }), this._setCommon(V3, n3, p2);
          }
        }, u.prototype.eachRendered = function(o) {
          this._newAdded[0] && o(this._newAdded[0]);
        }, u.prototype._create = function() {
          var o = new Ewn({ cursor: "default" });
          return this.group.add(o), this._newAdded.push(o), o;
        }, u.prototype._setCommon = function(o, n3, p2) {
          var m2 = n3.hostModel;
          p2 = p2 || {};
          var w2 = n3.getVisual("symbolSize");
          o.setShape("size", w2 instanceof Array ? w2 : [w2, w2]), o.softClipShape = p2.clipShape || null, o.symbolProxy = Jy(n3.getVisual("symbol"), 0, 0, 0, 0), o.setColor = o.symbolProxy.setColor;
          var T2 = o.shape.size[0] < abe;
          o.useStyle(m2.getModel("itemStyle").getItemStyle(T2 ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
          var E = n3.getVisual("style"), O2 = E && E.fill;
          O2 && o.setColor(O2);
          var V3 = is(o);
          V3.seriesIndex = m2.seriesIndex, o.on("mousemove", function(W3) {
            V3.dataIndex = null;
            var q3 = o.hoverDataIdx;
            q3 >= 0 && (V3.dataIndex = q3 + (o.startIndex || 0));
          });
        }, u.prototype.remove = function() {
          this._clear();
        }, u.prototype._clear = function() {
          this._newAdded = [], this.group.removeAll();
        }, u;
      }(), Pwn = kwn, Lwn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this._updateSymbolDraw(w2, n3);
          T2.updateData(w2, { clipShape: this._getClipShape(n3) }), this._finished = true;
        }, o.prototype.incrementalPrepareRender = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this._updateSymbolDraw(w2, n3);
          T2.incrementalPrepareUpdate(w2), this._finished = false;
        }, o.prototype.incrementalRender = function(n3, p2, m2) {
          this._symbolDraw.incrementalUpdate(n3, p2.getData(), { clipShape: this._getClipShape(p2) }), this._finished = n3.end === p2.getData().count();
        }, o.prototype.updateTransform = function(n3, p2, m2) {
          var w2 = n3.getData();
          if (this.group.dirty(), !this._finished || w2.count() > 1e4)
            return { update: true };
          var T2 = ist("").reset(n3, p2, m2);
          T2.progress && T2.progress({ start: 0, end: w2.count(), count: w2.count() }, w2), this._symbolDraw.updateLayout(w2);
        }, o.prototype.eachRendered = function(n3) {
          this._symbolDraw && this._symbolDraw.eachRendered(n3);
        }, o.prototype._getClipShape = function(n3) {
          var p2 = n3.coordinateSystem, m2 = p2 && p2.getArea && p2.getArea();
          return n3.get("clip", true) ? m2 : null;
        }, o.prototype._updateSymbolDraw = function(n3, p2) {
          var m2 = this._symbolDraw, w2 = p2.pipelineContext, T2 = w2.large;
          return (!m2 || T2 !== this._isLargeDraw) && (m2 && m2.remove(), m2 = this._symbolDraw = T2 ? new Pwn() : new rst(), this._isLargeDraw = T2, this.group.removeAll()), this.group.add(m2.group), m2;
        }, o.prototype.remove = function(n3, p2) {
          this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
        }, o.prototype.dispose = function() {
        }, o.type = "scatter", o;
      }(xg2), Own = Lwn, Rwn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.type = "grid", o.dependencies = ["xAxis", "yAxis"], o.layoutMode = "box", o.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, o;
      }(kh2), Nwn = Rwn, R9t = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.getCoordSysModel = function() {
          return this.getReferringComponents("grid", Y0).models[0];
        }, o.type = "cartesian2dAxis", o;
      }(kh2);
      x0(R9t, Yot);
      var obe = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, Fwn = Cu({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, obe), N9t = Cu({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, obe), Vwn = Cu({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, N9t), Bwn = kl({ logBase: 10 }, N9t), sbe = { category: Fwn, value: N9t, time: Vwn, log: Bwn }, zwn = { value: 1, category: 1, time: 1, log: 1 };
      function dY(u, o, n3, p2) {
        Xe2(zwn, function(m2, w2) {
          var T2 = Cu(Cu({}, sbe[w2], true), p2, true), E = function(O2) {
            tr(V3, O2);
            function V3() {
              var W3 = O2 !== null && O2.apply(this, arguments) || this;
              return W3.type = o + "Axis." + w2, W3;
            }
            return V3.prototype.mergeDefaultAndTheme = function(W3, q3) {
              var K = Sot(this), J = K ? Y$(W3) : {}, rt2 = q3.getTheme();
              Cu(W3, rt2.get(w2 + "Axis")), Cu(W3, this.getDefaultOption()), W3.type = lbe(W3), K && i8(W3, J, K);
            }, V3.prototype.optionUpdated = function() {
              var W3 = this.option;
              W3.type === "category" && (this.__ordinalMeta = n9t.createByAxisModel(this));
            }, V3.prototype.getCategories = function(W3) {
              var q3 = this.option;
              if (q3.type === "category")
                return W3 ? q3.data : this.__ordinalMeta.categories;
            }, V3.prototype.getOrdinalMeta = function() {
              return this.__ordinalMeta;
            }, V3.type = o + "Axis." + w2, V3.defaultOption = T2, V3;
          }(n3);
          u.registerComponentModel(E);
        }), u.registerSubTypeDefaulter(o + "Axis", lbe);
      }
      function lbe(u) {
        return u.type || (u.data ? "category" : "value");
      }
      var jwn = function() {
        function u(o) {
          this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = o || "";
        }
        return u.prototype.getAxis = function(o) {
          return this._axes[o];
        }, u.prototype.getAxes = function() {
          return Ya2(this._dimList, function(o) {
            return this._axes[o];
          }, this);
        }, u.prototype.getAxesByScale = function(o) {
          return o = o.toLowerCase(), Fp(this.getAxes(), function(n3) {
            return n3.scale.type === o;
          });
        }, u.prototype.addAxis = function(o) {
          var n3 = o.dim;
          this._axes[n3] = o, this._dimList.push(n3);
        }, u;
      }(), Wwn = jwn, F9t = ["x", "y"];
      function ube(u) {
        return u.type === "interval" || u.type === "time";
      }
      var Gwn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "cartesian2d", n3.dimensions = F9t, n3;
        }
        return o.prototype.calcAffineTransform = function() {
          this._transform = this._invTransform = null;
          var n3 = this.getAxis("x").scale, p2 = this.getAxis("y").scale;
          if (!(!ube(n3) || !ube(p2))) {
            var m2 = n3.getExtent(), w2 = p2.getExtent(), T2 = this.dataToPoint([m2[0], w2[0]]), E = this.dataToPoint([m2[1], w2[1]]), O2 = m2[1] - m2[0], V3 = w2[1] - w2[0];
            if (!(!O2 || !V3)) {
              var W3 = (E[0] - T2[0]) / O2, q3 = (E[1] - T2[1]) / V3, K = T2[0] - m2[0] * W3, J = T2[1] - w2[0] * q3, rt2 = this._transform = [W3, 0, 0, q3, K, J];
              this._invTransform = e4([], rt2);
            }
          }
        }, o.prototype.getBaseAxis = function() {
          return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
        }, o.prototype.containPoint = function(n3) {
          var p2 = this.getAxis("x"), m2 = this.getAxis("y");
          return p2.contain(p2.toLocalCoord(n3[0])) && m2.contain(m2.toLocalCoord(n3[1]));
        }, o.prototype.containData = function(n3) {
          return this.getAxis("x").containData(n3[0]) && this.getAxis("y").containData(n3[1]);
        }, o.prototype.dataToPoint = function(n3, p2, m2) {
          m2 = m2 || [];
          var w2 = n3[0], T2 = n3[1];
          if (this._transform && w2 != null && isFinite(w2) && T2 != null && isFinite(T2))
            return Lm(m2, n3, this._transform);
          var E = this.getAxis("x"), O2 = this.getAxis("y");
          return m2[0] = E.toGlobalCoord(E.dataToCoord(w2, p2)), m2[1] = O2.toGlobalCoord(O2.dataToCoord(T2, p2)), m2;
        }, o.prototype.clampData = function(n3, p2) {
          var m2 = this.getAxis("x").scale, w2 = this.getAxis("y").scale, T2 = m2.getExtent(), E = w2.getExtent(), O2 = m2.parse(n3[0]), V3 = w2.parse(n3[1]);
          return p2 = p2 || [], p2[0] = Math.min(Math.max(Math.min(T2[0], T2[1]), O2), Math.max(T2[0], T2[1])), p2[1] = Math.min(Math.max(Math.min(E[0], E[1]), V3), Math.max(E[0], E[1])), p2;
        }, o.prototype.pointToData = function(n3, p2) {
          var m2 = [];
          if (this._invTransform)
            return Lm(m2, n3, this._invTransform);
          var w2 = this.getAxis("x"), T2 = this.getAxis("y");
          return m2[0] = w2.coordToData(w2.toLocalCoord(n3[0]), p2), m2[1] = T2.coordToData(T2.toLocalCoord(n3[1]), p2), m2;
        }, o.prototype.getOtherAxis = function(n3) {
          return this.getAxis(n3.dim === "x" ? "y" : "x");
        }, o.prototype.getArea = function() {
          var n3 = this.getAxis("x").getGlobalExtent(), p2 = this.getAxis("y").getGlobalExtent(), m2 = Math.min(n3[0], n3[1]), w2 = Math.min(p2[0], p2[1]), T2 = Math.max(n3[0], n3[1]) - m2, E = Math.max(p2[0], p2[1]) - w2;
          return new Qu(m2, w2, T2, E);
        }, o;
      }(Wwn), Hwn = Gwn, Uwn = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2, T2) {
          var E = u.call(this, n3, p2, m2) || this;
          return E.index = 0, E.type = w2 || "value", E.position = T2 || "bottom", E;
        }
        return o.prototype.isHorizontal = function() {
          var n3 = this.position;
          return n3 === "top" || n3 === "bottom";
        }, o.prototype.getGlobalExtent = function(n3) {
          var p2 = this.getExtent();
          return p2[0] = this.toGlobalCoord(p2[0]), p2[1] = this.toGlobalCoord(p2[1]), n3 && p2[0] > p2[1] && p2.reverse(), p2;
        }, o.prototype.pointToData = function(n3, p2) {
          return this.coordToData(this.toLocalCoord(n3[this.dim === "x" ? 0 : 1]), p2);
        }, o.prototype.setCategorySortInfo = function(n3) {
          if (this.type !== "category")
            return false;
          this.model.option.categorySortInfo = n3, this.scale.setSortInfo(n3);
        }, o;
      }(ak2), qwn = Uwn;
      function V9t(u, o, n3) {
        n3 = n3 || {};
        var p2 = u.coordinateSystem, m2 = o.axis, w2 = {}, T2 = m2.getAxesOnZeroOf()[0], E = m2.position, O2 = T2 ? "onZero" : E, V3 = m2.dim, W3 = p2.getRect(), q3 = [W3.x, W3.x + W3.width, W3.y, W3.y + W3.height], K = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, J = o.get("offset") || 0, rt2 = V3 === "x" ? [q3[2] - J, q3[3] + J] : [q3[0] - J, q3[1] + J];
        if (T2) {
          var gt = T2.toGlobalCoord(T2.dataToCoord(0));
          rt2[K.onZero] = Math.max(Math.min(gt, rt2[1]), rt2[0]);
        }
        w2.position = [V3 === "y" ? rt2[K[O2]] : q3[0], V3 === "x" ? rt2[K[O2]] : q3[3]], w2.rotation = Math.PI / 2 * (V3 === "x" ? 0 : 1);
        var yt = { top: -1, bottom: 1, left: -1, right: 1 };
        w2.labelDirection = w2.tickDirection = w2.nameDirection = yt[E], w2.labelOffset = T2 ? rt2[K[E]] - rt2[K.onZero] : 0, o.get(["axisTick", "inside"]) && (w2.tickDirection = -w2.tickDirection), $y(n3.labelInside, o.get(["axisLabel", "inside"])) && (w2.labelDirection = -w2.labelDirection);
        var At = o.get(["axisLabel", "rotate"]);
        return w2.labelRotate = O2 === "top" ? -At : At, w2.z2 = 1, w2;
      }
      function cbe(u) {
        return u.get("coordinateSystem") === "cartesian2d";
      }
      function fbe(u) {
        var o = { xAxisModel: null, yAxisModel: null };
        return Xe2(o, function(n3, p2) {
          var m2 = p2.replace(/Model$/, ""), w2 = u.getReferringComponents(m2, Y0).models[0];
          o[p2] = w2;
        }), o;
      }
      var B9t = Math.log;
      function hbe(u, o, n3) {
        var p2 = f8.prototype, m2 = p2.getTicks.call(n3), w2 = p2.getTicks.call(n3, true), T2 = m2.length - 1, E = p2.getInterval.call(n3), O2 = Ime(u, o), V3 = O2.extent, W3 = O2.fixMin, q3 = O2.fixMax;
        if (u.type === "log") {
          var K = B9t(u.base);
          V3 = [B9t(V3[0]) / K, B9t(V3[1]) / K];
        }
        u.setExtent(V3[0], V3[1]), u.calcNiceExtent({ splitNumber: T2, fixMin: W3, fixMax: q3 });
        var J = p2.getExtent.call(u);
        W3 && (V3[0] = J[0]), q3 && (V3[1] = J[1]);
        var rt2 = p2.getInterval.call(u), gt = V3[0], yt = V3[1];
        if (W3 && q3)
          rt2 = (yt - gt) / T2;
        else if (W3)
          for (yt = V3[0] + rt2 * T2; yt < V3[1] && isFinite(yt) && isFinite(V3[1]); )
            rt2 = i9t(rt2), yt = V3[0] + rt2 * T2;
        else if (q3)
          for (gt = V3[1] - rt2 * T2; gt > V3[0] && isFinite(gt) && isFinite(V3[0]); )
            rt2 = i9t(rt2), gt = V3[1] - rt2 * T2;
        else {
          var At = u.getTicks().length - 1;
          At > T2 && (rt2 = i9t(rt2));
          var Lt = rt2 * T2;
          yt = Math.ceil(V3[1] / rt2) * rt2, gt = Ov(yt - Lt), gt < 0 && V3[0] >= 0 ? (gt = 0, yt = Ov(Lt)) : yt > 0 && V3[1] <= 0 && (yt = 0, gt = -Ov(Lt));
        }
        var Wt = (m2[0].value - w2[0].value) / E, Nt = (m2[T2].value - w2[T2].value) / E;
        p2.setExtent.call(u, gt + rt2 * Wt, yt + rt2 * Nt), p2.setInterval.call(u, rt2), (Wt || Nt) && p2.setNiceExtent.call(u, gt + rt2, yt - rt2);
      }
      var Zwn = function() {
        function u(o, n3, p2) {
          this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = F9t, this._initCartesian(o, n3, p2), this.model = o;
        }
        return u.prototype.getRect = function() {
          return this._rect;
        }, u.prototype.update = function(o, n3) {
          var p2 = this._axesMap;
          this._updateScale(o, this.model);
          function m2(T2) {
            var E, O2 = tf2(T2), V3 = O2.length;
            if (V3) {
              for (var W3 = [], q3 = V3 - 1; q3 >= 0; q3--) {
                var K = +O2[q3], J = T2[K], rt2 = J.model, gt = J.scale;
                r9t(gt) && rt2.get("alignTicks") && rt2.get("interval") == null ? W3.push(J) : (uY(gt, rt2), r9t(gt) && (E = J));
              }
              W3.length && (E || (E = W3.pop(), uY(E.scale, E.model)), Xe2(W3, function(yt) {
                hbe(yt.scale, yt.model, E.scale);
              }));
            }
          }
          m2(p2.x), m2(p2.y);
          var w2 = {};
          Xe2(p2.x, function(T2) {
            pbe(p2, "y", T2, w2);
          }), Xe2(p2.y, function(T2) {
            pbe(p2, "x", T2, w2);
          }), this.resize(this.model, n3);
        }, u.prototype.resize = function(o, n3, p2) {
          var m2 = o.getBoxLayoutParams(), w2 = !p2 && o.get("containLabel"), T2 = Bm(m2, { width: n3.getWidth(), height: n3.getHeight() });
          this._rect = T2;
          var E = this._axesList;
          O2(), w2 && (Xe2(E, function(V3) {
            if (!V3.model.get(["axisLabel", "inside"])) {
              var W3 = o_n(V3);
              if (W3) {
                var q3 = V3.isHorizontal() ? "height" : "width", K = V3.model.get(["axisLabel", "margin"]);
                T2[q3] -= W3[q3] + K, V3.position === "top" ? T2.y += W3.height + K : V3.position === "left" && (T2.x += W3.width + K);
              }
            }
          }), O2()), Xe2(this._coordsList, function(V3) {
            V3.calcAffineTransform();
          });
          function O2() {
            Xe2(E, function(V3) {
              var W3 = V3.isHorizontal(), q3 = W3 ? [0, T2.width] : [0, T2.height], K = V3.inverse ? 1 : 0;
              V3.setExtent(q3[K], q3[1 - K]), $wn(V3, W3 ? T2.x : T2.y);
            });
          }
        }, u.prototype.getAxis = function(o, n3) {
          var p2 = this._axesMap[o];
          if (p2 != null)
            return p2[n3 || 0];
        }, u.prototype.getAxes = function() {
          return this._axesList.slice();
        }, u.prototype.getCartesian = function(o, n3) {
          if (o != null && n3 != null) {
            var p2 = "x" + o + "y" + n3;
            return this._coordsMap[p2];
          }
          ys(o) && (n3 = o.yAxisIndex, o = o.xAxisIndex);
          for (var m2 = 0, w2 = this._coordsList; m2 < w2.length; m2++)
            if (w2[m2].getAxis("x").index === o || w2[m2].getAxis("y").index === n3)
              return w2[m2];
        }, u.prototype.getCartesians = function() {
          return this._coordsList.slice();
        }, u.prototype.convertToPixel = function(o, n3, p2) {
          var m2 = this._findConvertTarget(n3);
          return m2.cartesian ? m2.cartesian.dataToPoint(p2) : m2.axis ? m2.axis.toGlobalCoord(m2.axis.dataToCoord(p2)) : null;
        }, u.prototype.convertFromPixel = function(o, n3, p2) {
          var m2 = this._findConvertTarget(n3);
          return m2.cartesian ? m2.cartesian.pointToData(p2) : m2.axis ? m2.axis.coordToData(m2.axis.toLocalCoord(p2)) : null;
        }, u.prototype._findConvertTarget = function(o) {
          var n3 = o.seriesModel, p2 = o.xAxisModel || n3 && n3.getReferringComponents("xAxis", Y0).models[0], m2 = o.yAxisModel || n3 && n3.getReferringComponents("yAxis", Y0).models[0], w2 = o.gridModel, T2 = this._coordsList, E, O2;
          if (n3)
            E = n3.coordinateSystem, sc2(T2, E) < 0 && (E = null);
          else if (p2 && m2)
            E = this.getCartesian(p2.componentIndex, m2.componentIndex);
          else if (p2)
            O2 = this.getAxis("x", p2.componentIndex);
          else if (m2)
            O2 = this.getAxis("y", m2.componentIndex);
          else if (w2) {
            var V3 = w2.coordinateSystem;
            V3 === this && (E = this._coordsList[0]);
          }
          return { cartesian: E, axis: O2 };
        }, u.prototype.containPoint = function(o) {
          var n3 = this._coordsList[0];
          if (n3)
            return n3.containPoint(o);
        }, u.prototype._initCartesian = function(o, n3, p2) {
          var m2 = this, w2 = this, T2 = { left: false, right: false, top: false, bottom: false }, E = { x: {}, y: {} }, O2 = { x: 0, y: 0 };
          if (n3.eachComponent("xAxis", V3("x"), this), n3.eachComponent("yAxis", V3("y"), this), !O2.x || !O2.y) {
            this._axesMap = {}, this._axesList = [];
            return;
          }
          this._axesMap = E, Xe2(E.x, function(W3, q3) {
            Xe2(E.y, function(K, J) {
              var rt2 = "x" + q3 + "y" + J, gt = new Hwn(rt2);
              gt.master = m2, gt.model = o, m2._coordsMap[rt2] = gt, m2._coordsList.push(gt), gt.addAxis(W3), gt.addAxis(K);
            });
          });
          function V3(W3) {
            return function(q3, K) {
              if (z9t(q3, o)) {
                var J = q3.get("position");
                W3 === "x" ? J !== "top" && J !== "bottom" && (J = T2.bottom ? "top" : "bottom") : J !== "left" && J !== "right" && (J = T2.left ? "right" : "left"), T2[J] = true;
                var rt2 = new qwn(W3, vxt(q3), [0, 0], q3.get("type"), J), gt = rt2.type === "category";
                rt2.onBand = gt && q3.get("boundaryGap"), rt2.inverse = q3.get("inverse"), q3.axis = rt2, rt2.model = q3, rt2.grid = w2, rt2.index = K, w2._axesList.push(rt2), E[W3][K] = rt2, O2[W3]++;
              }
            };
          }
        }, u.prototype._updateScale = function(o, n3) {
          Xe2(this._axesList, function(m2) {
            if (m2.scale.setExtent(1 / 0, -1 / 0), m2.type === "category") {
              var w2 = m2.model.get("categorySortInfo");
              m2.scale.setSortInfo(w2);
            }
          }), o.eachSeries(function(m2) {
            if (cbe(m2)) {
              var w2 = fbe(m2), T2 = w2.xAxisModel, E = w2.yAxisModel;
              if (!z9t(T2, n3) || !z9t(E, n3))
                return;
              var O2 = this.getCartesian(T2.componentIndex, E.componentIndex), V3 = m2.getData(), W3 = O2.getAxis("x"), q3 = O2.getAxis("y");
              p2(V3, W3), p2(V3, q3);
            }
          }, this);
          function p2(m2, w2) {
            Xe2(yxt(m2, w2.dim), function(T2) {
              w2.scale.unionExtentFromData(m2, T2);
            });
          }
        }, u.prototype.getTooltipAxes = function(o) {
          var n3 = [], p2 = [];
          return Xe2(this.getCartesians(), function(m2) {
            var w2 = o != null && o !== "auto" ? m2.getAxis(o) : m2.getBaseAxis(), T2 = m2.getOtherAxis(w2);
            sc2(n3, w2) < 0 && n3.push(w2), sc2(p2, T2) < 0 && p2.push(T2);
          }), { baseAxes: n3, otherAxes: p2 };
        }, u.create = function(o, n3) {
          var p2 = [];
          return o.eachComponent("grid", function(m2, w2) {
            var T2 = new u(m2, o, n3);
            T2.name = "grid_" + w2, T2.resize(m2, n3, true), m2.coordinateSystem = T2, p2.push(T2);
          }), o.eachSeries(function(m2) {
            if (cbe(m2)) {
              var w2 = fbe(m2), T2 = w2.xAxisModel, E = w2.yAxisModel, O2 = T2.getCoordSysModel(), V3 = O2.coordinateSystem;
              m2.coordinateSystem = V3.getCartesian(T2.componentIndex, E.componentIndex);
            }
          }), p2;
        }, u.dimensions = F9t, u;
      }();
      function z9t(u, o) {
        return u.getCoordSysModel() === o;
      }
      function pbe(u, o, n3, p2) {
        n3.getAxesOnZeroOf = function() {
          return w2 ? [w2] : [];
        };
        var m2 = u[o], w2, T2 = n3.model, E = T2.get(["axisLine", "onZero"]), O2 = T2.get(["axisLine", "onZeroAxisIndex"]);
        if (!E)
          return;
        if (O2 != null)
          dbe(m2[O2]) && (w2 = m2[O2]);
        else
          for (var V3 in m2)
            if (m2.hasOwnProperty(V3) && dbe(m2[V3]) && !p2[W3(m2[V3])]) {
              w2 = m2[V3];
              break;
            }
        w2 && (p2[W3(w2)] = true);
        function W3(q3) {
          return q3.dim + "_" + q3.index;
        }
      }
      function dbe(u) {
        return u && u.type !== "category" && u.type !== "time" && a_n(u);
      }
      function $wn(u, o) {
        var n3 = u.getExtent(), p2 = n3[0] + n3[1];
        u.toGlobalCoord = u.dim === "x" ? function(m2) {
          return m2 + o;
        } : function(m2) {
          return p2 - m2 + o;
        }, u.toLocalCoord = u.dim === "x" ? function(m2) {
          return m2 - o;
        } : function(m2) {
          return p2 - m2 + o;
        };
      }
      var Ywn = Zwn, g8 = Math.PI, Hz = function() {
        function u(o, n3) {
          this.group = new uu(), this.opt = n3, this.axisModel = o, kl(n3, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
            return true;
          } });
          var p2 = new uu({ x: n3.position[0], y: n3.position[1], rotation: n3.rotation });
          p2.updateTransform(), this._transformGroup = p2;
        }
        return u.prototype.hasBuilder = function(o) {
          return !!gbe[o];
        }, u.prototype.add = function(o) {
          gbe[o](this.opt, this.axisModel, this.group, this._transformGroup);
        }, u.prototype.getGroup = function() {
          return this.group;
        }, u.innerTextLayout = function(o, n3, p2) {
          var m2 = l$(n3 - o), w2, T2;
          return u$(m2) ? (T2 = p2 > 0 ? "top" : "bottom", w2 = "center") : u$(m2 - g8) ? (T2 = p2 > 0 ? "bottom" : "top", w2 = "center") : (T2 = "middle", m2 > 0 && m2 < g8 ? w2 = p2 > 0 ? "right" : "left" : w2 = p2 > 0 ? "left" : "right"), { rotation: m2, textAlign: w2, textVerticalAlign: T2 };
        }, u.makeAxisEventDataBase = function(o) {
          var n3 = { componentType: o.mainType, componentIndex: o.componentIndex };
          return n3[o.mainType + "Index"] = o.componentIndex, n3;
        }, u.isLabelSilent = function(o) {
          var n3 = o.get("tooltip");
          return o.get("silent") || !(o.get("triggerEvent") || n3 && n3.show);
        }, u;
      }(), gbe = { axisLine: function(u, o, n3, p2) {
        var m2 = o.get(["axisLine", "show"]);
        if (m2 === "auto" && u.handleAutoShown && (m2 = u.handleAutoShown("axisLine")), !!m2) {
          var w2 = o.axis.getExtent(), T2 = p2.transform, E = [w2[0], 0], O2 = [w2[1], 0];
          T2 && (Lm(E, E, T2), Lm(O2, O2, T2));
          var V3 = ua2({ lineCap: "round" }, o.getModel(["axisLine", "lineStyle"]).getLineStyle()), W3 = new My({ subPixelOptimize: true, shape: { x1: E[0], y1: E[1], x2: O2[0], y2: O2[1] }, style: V3, strokeContainThreshold: u.strokeContainThreshold || 5, silent: true, z2: 1 });
          W3.anid = "line", n3.add(W3);
          var q3 = o.get(["axisLine", "symbol"]);
          if (q3 != null) {
            var K = o.get(["axisLine", "symbolSize"]);
            ds(q3) && (q3 = [q3, q3]), (ds(K) || Dh2(K)) && (K = [K, K]);
            var J = aY(o.get(["axisLine", "symbolOffset"]) || 0, K), rt2 = K[0], gt = K[1];
            Xe2([{ rotate: u.rotation + Math.PI / 2, offset: J[0], r: 0 }, { rotate: u.rotation - Math.PI / 2, offset: J[1], r: Math.sqrt((E[0] - O2[0]) * (E[0] - O2[0]) + (E[1] - O2[1]) * (E[1] - O2[1])) }], function(yt, At) {
              if (q3[At] !== "none" && q3[At] != null) {
                var Lt = Jy(q3[At], -rt2 / 2, -gt / 2, rt2, gt, V3.stroke, true), Wt = yt.r + yt.offset;
                Lt.attr({ rotation: yt.rotate, x: E[0] + Wt * Math.cos(u.rotation), y: E[1] - Wt * Math.sin(u.rotation), silent: true, z2: 11 }), n3.add(Lt);
              }
            });
          }
        }
      }, axisTickLabel: function(u, o, n3, p2) {
        var m2 = Qwn(n3, p2, o, u), w2 = tSn(n3, p2, o, u);
        if (Xwn(o, w2, m2), Jwn(n3, p2, o, u.tickDirection), o.get(["axisLabel", "hideOverlap"])) {
          var T2 = Yme(Ya2(w2, function(E) {
            return { label: E, priority: E.z2, defaultAttr: { ignore: E.ignore } };
          }));
          Qme(T2);
        }
      }, axisName: function(u, o, n3, p2) {
        var m2 = $y(u.axisName, o.get("name"));
        if (m2) {
          var w2 = o.get("nameLocation"), T2 = u.nameDirection, E = o.getModel("nameTextStyle"), O2 = o.get("nameGap") || 0, V3 = o.axis.getExtent(), W3 = V3[0] > V3[1] ? -1 : 1, q3 = [w2 === "start" ? V3[0] - W3 * O2 : w2 === "end" ? V3[1] + W3 * O2 : (V3[0] + V3[1]) / 2, ybe(w2) ? u.labelOffset + T2 * O2 : 0], K, J = o.get("nameRotate");
          J != null && (J = J * g8 / 180);
          var rt2;
          ybe(w2) ? K = Hz.innerTextLayout(u.rotation, J != null ? J : u.rotation, T2) : (K = Kwn(u.rotation, w2, J || 0, V3), rt2 = u.axisNameAvailableWidth, rt2 != null && (rt2 = Math.abs(rt2 / Math.sin(K.rotation)), !isFinite(rt2) && (rt2 = null)));
          var gt = E.getFont(), yt = o.get("nameTruncate", true) || {}, At = yt.ellipsis, Lt = $y(u.nameTruncateMaxWidth, yt.maxWidth, rt2), Wt = new Zc2({ x: q3[0], y: q3[1], rotation: K.rotation, silent: Hz.isLabelSilent(o), style: Cy(E, { text: m2, font: gt, overflow: "truncate", width: Lt, ellipsis: At, fill: E.getTextColor() || o.get(["axisLine", "lineStyle", "color"]), align: E.get("align") || K.textAlign, verticalAlign: E.get("verticalAlign") || K.textVerticalAlign }), z2: 1 });
          if (G$({ el: Wt, componentModel: o, itemName: m2 }), Wt.__fullText = m2, Wt.anid = "name", o.get("triggerEvent")) {
            var Nt = Hz.makeAxisEventDataBase(o);
            Nt.targetType = "axisName", Nt.name = m2, is(Wt).eventData = Nt;
          }
          p2.add(Wt), Wt.updateTransform(), n3.add(Wt), Wt.decomposeTransform();
        }
      } };
      function Kwn(u, o, n3, p2) {
        var m2 = l$(n3 - u), w2, T2, E = p2[0] > p2[1], O2 = o === "start" && !E || o !== "start" && E;
        return u$(m2 - g8 / 2) ? (T2 = O2 ? "bottom" : "top", w2 = "center") : u$(m2 - g8 * 1.5) ? (T2 = O2 ? "top" : "bottom", w2 = "center") : (T2 = "middle", m2 < g8 * 1.5 && m2 > g8 / 2 ? w2 = O2 ? "left" : "right" : w2 = O2 ? "right" : "left"), { rotation: m2, textAlign: w2, textVerticalAlign: T2 };
      }
      function Xwn(u, o, n3) {
        if (!Dme(u.axis)) {
          var p2 = u.get(["axisLabel", "showMinLabel"]), m2 = u.get(["axisLabel", "showMaxLabel"]);
          o = o || [], n3 = n3 || [];
          var w2 = o[0], T2 = o[1], E = o[o.length - 1], O2 = o[o.length - 2], V3 = n3[0], W3 = n3[1], q3 = n3[n3.length - 1], K = n3[n3.length - 2];
          p2 === false ? (vI(w2), vI(V3)) : vbe(w2, T2) && (p2 ? (vI(T2), vI(W3)) : (vI(w2), vI(V3))), m2 === false ? (vI(E), vI(q3)) : vbe(O2, E) && (m2 ? (vI(O2), vI(K)) : (vI(E), vI(q3)));
        }
      }
      function vI(u) {
        u && (u.ignore = true);
      }
      function vbe(u, o) {
        var n3 = u && u.getBoundingRect().clone(), p2 = o && o.getBoundingRect().clone();
        if (!(!n3 || !p2)) {
          var m2 = oz([]);
          return t4(m2, m2, -u.rotation), n3.applyTransform(YA([], m2, u.getLocalTransform())), p2.applyTransform(YA([], m2, o.getLocalTransform())), n3.intersect(p2);
        }
      }
      function ybe(u) {
        return u === "middle" || u === "center";
      }
      function mbe(u, o, n3, p2, m2) {
        for (var w2 = [], T2 = [], E = [], O2 = 0; O2 < u.length; O2++) {
          var V3 = u[O2].coord;
          T2[0] = V3, T2[1] = 0, E[0] = V3, E[1] = n3, o && (Lm(T2, T2, o), Lm(E, E, o));
          var W3 = new My({ subPixelOptimize: true, shape: { x1: T2[0], y1: T2[1], x2: E[0], y2: E[1] }, style: p2, z2: 2, autoBatch: true, silent: true });
          W3.anid = m2 + "_" + u[O2].tickValue, w2.push(W3);
        }
        return w2;
      }
      function Qwn(u, o, n3, p2) {
        var m2 = n3.axis, w2 = n3.getModel("axisTick"), T2 = w2.get("show");
        if (T2 === "auto" && p2.handleAutoShown && (T2 = p2.handleAutoShown("axisTick")), !(!T2 || m2.scale.isBlank())) {
          for (var E = w2.getModel("lineStyle"), O2 = p2.tickDirection * w2.get("length"), V3 = m2.getTicksCoords(), W3 = mbe(V3, o.transform, O2, kl(E.getLineStyle(), { stroke: n3.get(["axisLine", "lineStyle", "color"]) }), "ticks"), q3 = 0; q3 < W3.length; q3++)
            u.add(W3[q3]);
          return W3;
        }
      }
      function Jwn(u, o, n3, p2) {
        var m2 = n3.axis, w2 = n3.getModel("minorTick");
        if (!(!w2.get("show") || m2.scale.isBlank())) {
          var T2 = m2.getMinorTicksCoords();
          if (T2.length)
            for (var E = w2.getModel("lineStyle"), O2 = p2 * w2.get("length"), V3 = kl(E.getLineStyle(), kl(n3.getModel("axisTick").getLineStyle(), { stroke: n3.get(["axisLine", "lineStyle", "color"]) })), W3 = 0; W3 < T2.length; W3++)
              for (var q3 = mbe(T2[W3], o.transform, O2, V3, "minorticks_" + W3), K = 0; K < q3.length; K++)
                u.add(q3[K]);
        }
      }
      function tSn(u, o, n3, p2) {
        var m2 = n3.axis, w2 = $y(p2.axisLabelShow, n3.get(["axisLabel", "show"]));
        if (!(!w2 || m2.scale.isBlank())) {
          var T2 = n3.getModel("axisLabel"), E = T2.get("margin"), O2 = m2.getViewLabels(), V3 = ($y(p2.labelRotate, T2.get("rotate")) || 0) * g8 / 180, W3 = Hz.innerTextLayout(p2.rotation, V3, p2.labelDirection), q3 = n3.getCategories && n3.getCategories(true), K = [], J = Hz.isLabelSilent(n3), rt2 = n3.get("triggerEvent");
          return Xe2(O2, function(gt, yt) {
            var At = m2.scale.type === "ordinal" ? m2.scale.getRawOrdinalNumber(gt.tickValue) : gt.tickValue, Lt = gt.formattedLabel, Wt = gt.rawLabel, Nt = T2;
            if (q3 && q3[At]) {
              var ue2 = q3[At];
              ys(ue2) && ue2.textStyle && (Nt = new _g(ue2.textStyle, T2, n3.ecModel));
            }
            var ie2 = Nt.getTextColor() || n3.get(["axisLine", "lineStyle", "color"]), pe2 = m2.dataToCoord(At), xe = new Zc2({ x: pe2, y: p2.labelOffset + p2.labelDirection * E, rotation: W3.rotation, silent: J, z2: 10 + (gt.level || 0), style: Cy(Nt, { text: Lt, align: Nt.getShallow("align", true) || W3.textAlign, verticalAlign: Nt.getShallow("verticalAlign", true) || Nt.getShallow("baseline", true) || W3.textVerticalAlign, fill: Sl(ie2) ? ie2(m2.type === "category" ? Wt : m2.type === "value" ? At + "" : At, yt) : ie2 }) });
            if (xe.anid = "label_" + At, rt2) {
              var Ce2 = Hz.makeAxisEventDataBase(n3);
              Ce2.targetType = "axisLabel", Ce2.value = Wt, Ce2.tickIndex = yt, m2.type === "category" && (Ce2.dataIndex = At), is(xe).eventData = Ce2;
            }
            o.add(xe), xe.updateTransform(), K.push(xe), u.add(xe), xe.decomposeTransform();
          }), K;
        }
      }
      var D4 = Hz;
      function eSn(u, o) {
        var n3 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
        return nSn(n3, u, o), n3.seriesInvolved && iSn(n3, u), n3;
      }
      function nSn(u, o, n3) {
        var p2 = o.getComponent("tooltip"), m2 = o.getComponent("axisPointer"), w2 = m2.get("link", true) || [], T2 = [];
        Xe2(n3.getCoordinateSystems(), function(E) {
          if (!E.axisPointerEnabled)
            return;
          var O2 = sst(E.model), V3 = u.coordSysAxesInfo[O2] = {};
          u.coordSysMap[O2] = E;
          var W3 = E.model, q3 = W3.getModel("tooltip", p2);
          if (Xe2(E.getAxes(), wu(gt, false, null)), E.getTooltipAxes && p2 && q3.get("show")) {
            var K = q3.get("trigger") === "axis", J = q3.get(["axisPointer", "type"]) === "cross", rt2 = E.getTooltipAxes(q3.get(["axisPointer", "axis"]));
            (K || J) && Xe2(rt2.baseAxes, wu(gt, J ? "cross" : true, K)), J && Xe2(rt2.otherAxes, wu(gt, "cross", false));
          }
          function gt(yt, At, Lt) {
            var Wt = Lt.model.getModel("axisPointer", m2), Nt = Wt.get("show");
            if (!(!Nt || Nt === "auto" && !yt && !G9t(Wt))) {
              At == null && (At = Wt.get("triggerTooltip")), Wt = yt ? rSn(Lt, q3, m2, o, yt, At) : Wt;
              var ue2 = Wt.get("snap"), ie2 = sst(Lt.model), pe2 = At || ue2 || Lt.type === "category", xe = u.axesInfo[ie2] = { key: ie2, axis: Lt, coordSys: E, axisPointerModel: Wt, triggerTooltip: At, involveSeries: pe2, snap: ue2, useHandle: G9t(Wt), seriesModels: [], linkGroup: null };
              V3[ie2] = xe, u.seriesInvolved = u.seriesInvolved || pe2;
              var Ce2 = aSn(w2, Lt);
              if (Ce2 != null) {
                var Le2 = T2[Ce2] || (T2[Ce2] = { axesInfo: {} });
                Le2.axesInfo[ie2] = xe, Le2.mapper = w2[Ce2].mapper, xe.linkGroup = Le2;
              }
            }
          }
        });
      }
      function rSn(u, o, n3, p2, m2, w2) {
        var T2 = o.getModel("axisPointer"), E = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], O2 = {};
        Xe2(E, function(K) {
          O2[K] = jl(T2.get(K));
        }), O2.snap = u.type !== "category" && !!w2, T2.get("type") === "cross" && (O2.type = "line");
        var V3 = O2.label || (O2.label = {});
        if (V3.show == null && (V3.show = false), m2 === "cross") {
          var W3 = T2.get(["label", "show"]);
          if (V3.show = W3 != null ? W3 : true, !w2) {
            var q3 = O2.lineStyle = T2.get("crossStyle");
            q3 && kl(V3, q3.textStyle);
          }
        }
        return u.model.getModel("axisPointer", new _g(O2, n3, p2));
      }
      function iSn(u, o) {
        o.eachSeries(function(n3) {
          var p2 = n3.coordinateSystem, m2 = n3.get(["tooltip", "trigger"], true), w2 = n3.get(["tooltip", "show"], true);
          !p2 || m2 === "none" || m2 === false || m2 === "item" || w2 === false || n3.get(["axisPointer", "show"], true) === false || Xe2(u.coordSysAxesInfo[sst(p2.model)], function(T2) {
            var E = T2.axis;
            p2.getAxis(E.dim) === E && (T2.seriesModels.push(n3), T2.seriesDataCount == null && (T2.seriesDataCount = 0), T2.seriesDataCount += n3.getData().count());
          });
        });
      }
      function aSn(u, o) {
        for (var n3 = o.model, p2 = o.dim, m2 = 0; m2 < u.length; m2++) {
          var w2 = u[m2] || {};
          if (j9t(w2[p2 + "AxisId"], n3.id) || j9t(w2[p2 + "AxisIndex"], n3.componentIndex) || j9t(w2[p2 + "AxisName"], n3.name))
            return m2;
        }
      }
      function j9t(u, o) {
        return u === "all" || za2(u) && sc2(u, o) >= 0 || u === o;
      }
      function oSn(u) {
        var o = W9t(u);
        if (o) {
          var n3 = o.axisPointerModel, p2 = o.axis.scale, m2 = n3.option, w2 = n3.get("status"), T2 = n3.get("value");
          T2 != null && (T2 = p2.parse(T2));
          var E = G9t(n3);
          w2 == null && (m2.status = E ? "show" : "hide");
          var O2 = p2.getExtent().slice();
          O2[0] > O2[1] && O2.reverse(), (T2 == null || T2 > O2[1]) && (T2 = O2[1]), T2 < O2[0] && (T2 = O2[0]), m2.value = T2, E && (m2.status = o.axis.scale.isBlank() ? "hide" : "show");
        }
      }
      function W9t(u) {
        var o = (u.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
        return o && o.axesInfo[sst(u)];
      }
      function sSn(u) {
        var o = W9t(u);
        return o && o.axisPointerModel;
      }
      function G9t(u) {
        return !!u.get(["handle", "show"]);
      }
      function sst(u) {
        return u.type + "||" + u.id;
      }
      var bbe = {}, lSn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          this.axisPointerClass && oSn(n3), u.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(n3, m2, true);
        }, o.prototype.updateAxisPointer = function(n3, p2, m2, w2) {
          this._doUpdateAxisPointerClass(n3, m2, false);
        }, o.prototype.remove = function(n3, p2) {
          var m2 = this._axisPointer;
          m2 && m2.remove(p2);
        }, o.prototype.dispose = function(n3, p2) {
          this._disposeAxisPointer(p2), u.prototype.dispose.apply(this, arguments);
        }, o.prototype._doUpdateAxisPointerClass = function(n3, p2, m2) {
          var w2 = o.getAxisPointerClass(this.axisPointerClass);
          if (w2) {
            var T2 = sSn(n3);
            T2 ? (this._axisPointer || (this._axisPointer = new w2())).render(n3, T2, p2, m2) : this._disposeAxisPointer(p2);
          }
        }, o.prototype._disposeAxisPointer = function(n3) {
          this._axisPointer && this._axisPointer.dispose(n3), this._axisPointer = null;
        }, o.registerAxisPointerClass = function(n3, p2) {
          bbe[n3] = p2;
        }, o.getAxisPointerClass = function(n3) {
          return n3 && bbe[n3];
        }, o.type = "axis", o;
      }(C0), Uz = lSn, H9t = Ff2();
      function _be(u, o, n3, p2) {
        var m2 = n3.axis;
        if (!m2.scale.isBlank()) {
          var w2 = n3.getModel("splitArea"), T2 = w2.getModel("areaStyle"), E = T2.get("color"), O2 = p2.coordinateSystem.getRect(), V3 = m2.getTicksCoords({ tickModel: w2, clamp: true });
          if (V3.length) {
            var W3 = E.length, q3 = H9t(u).splitAreaColors, K = pl(), J = 0;
            if (q3)
              for (var rt2 = 0; rt2 < V3.length; rt2++) {
                var gt = q3.get(V3[rt2].tickValue);
                if (gt != null) {
                  J = (gt + (W3 - 1) * rt2) % W3;
                  break;
                }
              }
            var yt = m2.toGlobalCoord(V3[0].coord), At = T2.getAreaStyle();
            E = za2(E) ? E : [E];
            for (var rt2 = 1; rt2 < V3.length; rt2++) {
              var Lt = m2.toGlobalCoord(V3[rt2].coord), Wt = void 0, Nt = void 0, ue2 = void 0, ie2 = void 0;
              m2.isHorizontal() ? (Wt = yt, Nt = O2.y, ue2 = Lt - Wt, ie2 = O2.height, yt = Wt + ue2) : (Wt = O2.x, Nt = yt, ue2 = O2.width, ie2 = Lt - Nt, yt = Nt + ie2);
              var pe2 = V3[rt2 - 1].tickValue;
              pe2 != null && K.set(pe2, J), o.add(new Vf2({ anid: pe2 != null ? "area_" + pe2 : null, shape: { x: Wt, y: Nt, width: ue2, height: ie2 }, style: kl({ fill: E[J] }, At), autoBatch: true, silent: true })), J = (J + 1) % W3;
            }
            H9t(u).splitAreaColors = K;
          }
        }
      }
      function xbe(u) {
        H9t(u).splitAreaColors = null;
      }
      var uSn = ["axisLine", "axisTickLabel", "axisName"], cSn = ["splitArea", "splitLine", "minorSplitLine"], wbe = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.axisPointerClass = "CartesianAxisPointer", n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          this.group.removeAll();
          var T2 = this._axisGroup;
          if (this._axisGroup = new uu(), this.group.add(this._axisGroup), !!n3.get("show")) {
            var E = n3.getCoordSysModel(), O2 = V9t(E, n3), V3 = new D4(n3, ua2({ handleAutoShown: function(q3) {
              for (var K = E.coordinateSystem.getCartesians(), J = 0; J < K.length; J++)
                if (r9t(K[J].getOtherAxis(n3.axis).scale))
                  return true;
              return false;
            } }, O2));
            Xe2(uSn, V3.add, V3), this._axisGroup.add(V3.getGroup()), Xe2(cSn, function(q3) {
              n3.get([q3, "show"]) && fSn[q3](this, this._axisGroup, n3, E);
            }, this);
            var W3 = w2 && w2.type === "changeAxisOrder" && w2.isInitSort;
            W3 || E1(T2, this._axisGroup, n3), u.prototype.render.call(this, n3, p2, m2, w2);
          }
        }, o.prototype.remove = function() {
          xbe(this);
        }, o.type = "cartesianAxis", o;
      }(Uz), fSn = { splitLine: function(u, o, n3, p2) {
        var m2 = n3.axis;
        if (!m2.scale.isBlank()) {
          var w2 = n3.getModel("splitLine"), T2 = w2.getModel("lineStyle"), E = T2.get("color");
          E = za2(E) ? E : [E];
          for (var O2 = p2.coordinateSystem.getRect(), V3 = m2.isHorizontal(), W3 = 0, q3 = m2.getTicksCoords({ tickModel: w2 }), K = [], J = [], rt2 = T2.getLineStyle(), gt = 0; gt < q3.length; gt++) {
            var yt = m2.toGlobalCoord(q3[gt].coord);
            V3 ? (K[0] = yt, K[1] = O2.y, J[0] = yt, J[1] = O2.y + O2.height) : (K[0] = O2.x, K[1] = yt, J[0] = O2.x + O2.width, J[1] = yt);
            var At = W3++ % E.length, Lt = q3[gt].tickValue;
            o.add(new My({ anid: Lt != null ? "line_" + q3[gt].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: K[0], y1: K[1], x2: J[0], y2: J[1] }, style: kl({ stroke: E[At] }, rt2), silent: true }));
          }
        }
      }, minorSplitLine: function(u, o, n3, p2) {
        var m2 = n3.axis, w2 = n3.getModel("minorSplitLine"), T2 = w2.getModel("lineStyle"), E = p2.coordinateSystem.getRect(), O2 = m2.isHorizontal(), V3 = m2.getMinorTicksCoords();
        if (V3.length)
          for (var W3 = [], q3 = [], K = T2.getLineStyle(), J = 0; J < V3.length; J++)
            for (var rt2 = 0; rt2 < V3[J].length; rt2++) {
              var gt = m2.toGlobalCoord(V3[J][rt2].coord);
              O2 ? (W3[0] = gt, W3[1] = E.y, q3[0] = gt, q3[1] = E.y + E.height) : (W3[0] = E.x, W3[1] = gt, q3[0] = E.x + E.width, q3[1] = gt), o.add(new My({ anid: "minor_line_" + V3[J][rt2].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: W3[0], y1: W3[1], x2: q3[0], y2: q3[1] }, style: K, silent: true }));
            }
      }, splitArea: function(u, o, n3, p2) {
        _be(u, o, n3, p2);
      } }, Sbe = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "xAxis", o;
      }(wbe), hSn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = Sbe.type, n3;
        }
        return o.type = "yAxis", o;
      }(wbe), pSn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "grid", n3;
        }
        return o.prototype.render = function(n3, p2) {
          this.group.removeAll(), n3.get("show") && this.group.add(new Vf2({ shape: n3.coordinateSystem.getRect(), style: kl({ fill: n3.get("backgroundColor") }, n3.getItemStyle()), silent: true, z2: -1 }));
        }, o.type = "grid", o;
      }(C0), Mbe = { offset: 0 };
      function Cbe(u) {
        u.registerComponentView(pSn), u.registerComponentModel(Nwn), u.registerCoordinateSystem("cartesian2d", Ywn), dY(u, "x", R9t, Mbe), dY(u, "y", R9t, Mbe), u.registerComponentView(Sbe), u.registerComponentView(hSn), u.registerPreprocessor(function(o) {
          o.xAxis && o.yAxis && !o.grid && (o.grid = {});
        });
      }
      function dSn(u) {
        Rc2(Cbe), u.registerSeriesModel(Iwn), u.registerChartView(Own), u.registerLayout(ist("scatter"));
      }
      function gSn(u) {
        u.eachSeriesByType("radar", function(o) {
          var n3 = o.getData(), p2 = [], m2 = o.coordinateSystem;
          if (m2) {
            var w2 = m2.getIndicatorAxes();
            Xe2(w2, function(T2, E) {
              n3.each(n3.mapDimension(w2[E].dim), function(O2, V3) {
                p2[V3] = p2[V3] || [];
                var W3 = m2.dataToPoint(O2, E);
                p2[V3][E] = Tbe(W3) ? W3 : Abe(m2);
              });
            }), n3.each(function(T2) {
              var E = P6t(p2[T2], function(O2) {
                return Tbe(O2);
              }) || Abe(m2);
              p2[T2].push(E.slice()), n3.setItemLayout(T2, p2[T2]);
            });
          }
        });
      }
      function Tbe(u) {
        return !isNaN(u[0]) && !isNaN(u[1]);
      }
      function Abe(u) {
        return [u.cx, u.cy];
      }
      function vSn(u) {
        var o = u.polar;
        if (o) {
          za2(o) || (o = [o]);
          var n3 = [];
          Xe2(o, function(p2, m2) {
            p2.indicator ? (p2.type && !p2.shape && (p2.shape = p2.type), u.radar = u.radar || [], za2(u.radar) || (u.radar = [u.radar]), u.radar.push(p2)) : n3.push(p2);
          }), u.polar = n3;
        }
        Xe2(u.series, function(p2) {
          p2 && p2.type === "radar" && p2.polarIndex && (p2.radarIndex = p2.polarIndex);
        });
      }
      var ySn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.coordinateSystem, T2 = this.group, E = n3.getData(), O2 = this._data;
          function V3(K, J) {
            var rt2 = K.getItemVisual(J, "symbol") || "circle";
            if (rt2 !== "none") {
              var gt = Rot(K.getItemVisual(J, "symbolSize")), yt = Jy(rt2, -1, -1, 2, 2), At = K.getItemVisual(J, "symbolRotate") || 0;
              return yt.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: gt[0] / 2, scaleY: gt[1] / 2, rotation: At * Math.PI / 180 || 0 }), yt;
            }
          }
          function W3(K, J, rt2, gt, yt, At) {
            rt2.removeAll();
            for (var Lt = 0; Lt < J.length - 1; Lt++) {
              var Wt = V3(gt, yt);
              Wt && (Wt.__dimIdx = Lt, K[Lt] ? (Wt.setPosition(K[Lt]), mot[At ? "initProps" : "updateProps"](Wt, { x: J[Lt][0], y: J[Lt][1] }, n3, yt)) : Wt.setPosition(J[Lt]), rt2.add(Wt));
            }
          }
          function q3(K) {
            return Ya2(K, function(J) {
              return [w2.cx, w2.cy];
            });
          }
          E.diff(O2).add(function(K) {
            var J = E.getItemLayout(K);
            if (J) {
              var rt2 = new Sw(), gt = new Mw(), yt = { shape: { points: J } };
              rt2.shape.points = q3(J), gt.shape.points = q3(J), Qg2(rt2, yt, n3, K), Qg2(gt, yt, n3, K);
              var At = new uu(), Lt = new uu();
              At.add(gt), At.add(rt2), At.add(Lt), W3(gt.shape.points, J, Lt, E, K, true), E.setItemGraphicEl(K, At);
            }
          }).update(function(K, J) {
            var rt2 = O2.getItemGraphicEl(J), gt = rt2.childAt(0), yt = rt2.childAt(1), At = rt2.childAt(2), Lt = { shape: { points: E.getItemLayout(K) } };
            !Lt.shape.points || (W3(gt.shape.points, Lt.shape.points, At, E, K, false), DC(yt), DC(gt), Xf2(gt, Lt, n3), Xf2(yt, Lt, n3), E.setItemGraphicEl(K, rt2));
          }).remove(function(K) {
            T2.remove(O2.getItemGraphicEl(K));
          }).execute(), E.eachItemGraphicEl(function(K, J) {
            var rt2 = E.getItemModel(J), gt = K.childAt(0), yt = K.childAt(1), At = K.childAt(2), Lt = E.getItemVisual(J, "style"), Wt = Lt.fill;
            T2.add(K), gt.useStyle(kl(rt2.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: Wt })), Ky(gt, rt2, "lineStyle"), Ky(yt, rt2, "areaStyle");
            var Nt = rt2.getModel("areaStyle"), ue2 = Nt.isEmpty() && Nt.parentModel.isEmpty();
            yt.ignore = ue2, Xe2(["emphasis", "select", "blur"], function(xe) {
              var Ce2 = rt2.getModel([xe, "areaStyle"]), Le2 = Ce2.isEmpty() && Ce2.parentModel.isEmpty();
              yt.ensureState(xe).ignore = Le2 && ue2;
            }), yt.useStyle(kl(Nt.getAreaStyle(), { fill: Wt, opacity: 0.7, decal: Lt.decal }));
            var ie2 = rt2.getModel("emphasis"), pe2 = ie2.getModel("itemStyle").getItemStyle();
            At.eachChild(function(xe) {
              if (xe instanceof Fm) {
                var Ce2 = xe.style;
                xe.useStyle(ua2({ image: Ce2.image, x: Ce2.x, y: Ce2.y, width: Ce2.width, height: Ce2.height }, Lt));
              } else
                xe.useStyle(Lt), xe.setColor(Wt), xe.style.strokeNoScale = true;
              var Le2 = xe.ensureState("emphasis");
              Le2.style = jl(pe2);
              var ze = E.getStore().get(E.getDimensionIndex(xe.__dimIdx), J);
              (ze == null || isNaN(ze)) && (ze = ""), Tw(xe, Lb2(rt2), { labelFetcher: E.hostModel, labelDataIndex: J, labelDimIndex: xe.__dimIdx, defaultText: ze, inheritColor: Wt, defaultOpacity: Lt.opacity });
            }), o0(K, ie2.get("focus"), ie2.get("blurScope"), ie2.get("disabled"));
          }), this._data = E;
        }, o.prototype.remove = function() {
          this.group.removeAll(), this._data = null;
        }, o.type = "radar", o;
      }(xg2), mSn = ySn, bSn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.hasSymbolVisual = true, n3;
        }
        return o.prototype.init = function(n3) {
          u.prototype.init.apply(this, arguments), this.legendVisualProvider = new ost(Is(this.getData, this), Is(this.getRawData, this));
        }, o.prototype.getInitialData = function(n3, p2) {
          return pY(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          var w2 = this.getData(), T2 = this.coordinateSystem, E = T2.getIndicatorAxes(), O2 = this.getData().getName(n3), V3 = O2 === "" ? this.name : O2, W3 = B0e(this, n3);
          return k1("section", { header: V3, sortBlocks: true, blocks: Ya2(E, function(q3) {
            var K = w2.get(w2.mapDimension(q3.dim), n3);
            return k1("nameValue", { markerType: "subItem", markerColor: W3, name: q3.name, value: K, sortParam: K });
          }) });
        }, o.prototype.getTooltipPosition = function(n3) {
          if (n3 != null) {
            for (var p2 = this.getData(), m2 = this.coordinateSystem, w2 = p2.getValues(Ya2(m2.dimensions, function(V3) {
              return p2.mapDimension(V3);
            }), n3), T2 = 0, E = w2.length; T2 < E; T2++)
              if (!isNaN(w2[T2])) {
                var O2 = m2.getIndicatorAxes();
                return m2.coordToPoint(O2[T2].dataToCoord(w2[T2]), T2);
              }
          }
        }, o.type = "series.radar", o.dependencies = ["radar"], o.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, o;
      }(Rv), _Sn = bSn, lst = sbe.value;
      function Pxt(u, o) {
        return kl({ show: o }, u);
      }
      var xSn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.optionUpdated = function() {
          var n3 = this.get("boundaryGap"), p2 = this.get("splitNumber"), m2 = this.get("scale"), w2 = this.get("axisLine"), T2 = this.get("axisTick"), E = this.get("axisLabel"), O2 = this.get("axisName"), V3 = this.get(["axisName", "show"]), W3 = this.get(["axisName", "formatter"]), q3 = this.get("axisNameGap"), K = this.get("triggerEvent"), J = Ya2(this.get("indicator") || [], function(rt2) {
            rt2.max != null && rt2.max > 0 && !rt2.min ? rt2.min = 0 : rt2.min != null && rt2.min < 0 && !rt2.max && (rt2.max = 0);
            var gt = O2;
            rt2.color != null && (gt = kl({ color: rt2.color }, O2));
            var yt = Cu(jl(rt2), { boundaryGap: n3, splitNumber: p2, scale: m2, axisLine: w2, axisTick: T2, axisLabel: E, name: rt2.text, showName: V3, nameLocation: "end", nameGap: q3, nameTextStyle: gt, triggerEvent: K }, false);
            if (V3 || (yt.name = ""), ds(W3)) {
              var At = yt.name;
              yt.name = W3.replace("{value}", At != null ? At : "");
            } else
              Sl(W3) && (yt.name = W3(yt.name, yt));
            var Lt = new _g(yt, null, this.ecModel);
            return x0(Lt, Yot.prototype), Lt.mainType = "radar", Lt.componentIndex = this.componentIndex, Lt;
          }, this);
          this._indicatorModels = J;
        }, o.prototype.getIndicatorModels = function() {
          return this._indicatorModels;
        }, o.type = "radar", o.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: Cu({ lineStyle: { color: "#bbb" } }, lst.axisLine), axisLabel: Pxt(lst.axisLabel, false), axisTick: Pxt(lst.axisTick, false), splitLine: Pxt(lst.splitLine, true), splitArea: Pxt(lst.splitArea, true), indicator: [] }, o;
      }(kh2), wSn = xSn, SSn = ["axisLine", "axisTickLabel", "axisName"], MSn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = this.group;
          w2.removeAll(), this._buildAxes(n3), this._buildSplitLineAndArea(n3);
        }, o.prototype._buildAxes = function(n3) {
          var p2 = n3.coordinateSystem, m2 = p2.getIndicatorAxes(), w2 = Ya2(m2, function(T2) {
            var E = T2.model.get("showName") ? T2.name : "", O2 = new D4(T2.model, { axisName: E, position: [p2.cx, p2.cy], rotation: T2.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
            return O2;
          });
          Xe2(w2, function(T2) {
            Xe2(SSn, T2.add, T2), this.group.add(T2.getGroup());
          }, this);
        }, o.prototype._buildSplitLineAndArea = function(n3) {
          var p2 = n3.coordinateSystem, m2 = p2.getIndicatorAxes();
          if (!m2.length)
            return;
          var w2 = n3.get("shape"), T2 = n3.getModel("splitLine"), E = n3.getModel("splitArea"), O2 = T2.getModel("lineStyle"), V3 = E.getModel("areaStyle"), W3 = T2.get("show"), q3 = E.get("show"), K = O2.get("color"), J = V3.get("color"), rt2 = za2(K) ? K : [K], gt = za2(J) ? J : [J], yt = [], At = [];
          function Lt(zn, bn, Xr) {
            var Xn = Xr % bn.length;
            return zn[Xn] = zn[Xn] || [], Xn;
          }
          if (w2 === "circle")
            for (var Wt = m2[0].getTicksCoords(), Nt = p2.cx, ue2 = p2.cy, ie2 = 0; ie2 < Wt.length; ie2++) {
              if (W3) {
                var pe2 = Lt(yt, rt2, ie2);
                yt[pe2].push(new sI({ shape: { cx: Nt, cy: ue2, r: Wt[ie2].coord } }));
              }
              if (q3 && ie2 < Wt.length - 1) {
                var pe2 = Lt(At, gt, ie2);
                At[pe2].push(new L$({ shape: { cx: Nt, cy: ue2, r0: Wt[ie2].coord, r: Wt[ie2 + 1].coord } }));
              }
            }
          else
            for (var xe, Ce2 = Ya2(m2, function(bn, Xr) {
              var Xn = bn.getTicksCoords();
              return xe = xe == null ? Xn.length - 1 : Math.min(Xn.length - 1, xe), Ya2(Xn, function(or) {
                return p2.coordToPoint(or.coord, Xr);
              });
            }), Le2 = [], ie2 = 0; ie2 <= xe; ie2++) {
              for (var ze = [], tn = 0; tn < m2.length; tn++)
                ze.push(Ce2[tn][ie2]);
              if (ze[0] && ze.push(ze[0].slice()), W3) {
                var pe2 = Lt(yt, rt2, ie2);
                yt[pe2].push(new Mw({ shape: { points: ze } }));
              }
              if (q3 && Le2) {
                var pe2 = Lt(At, gt, ie2 - 1);
                At[pe2].push(new Sw({ shape: { points: ze.concat(Le2) } }));
              }
              Le2 = ze.slice().reverse();
            }
          var $e2 = O2.getLineStyle(), Tn = V3.getAreaStyle();
          Xe2(At, function(zn, bn) {
            this.group.add(eo(zn, { style: kl({ stroke: "none", fill: gt[bn % gt.length] }, Tn), silent: true }));
          }, this), Xe2(yt, function(zn, bn) {
            this.group.add(eo(zn, { style: kl({ fill: "none", stroke: rt2[bn % rt2.length] }, $e2), silent: true }));
          }, this);
        }, o.type = "radar", o;
      }(C0), CSn = MSn, TSn = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this, n3, p2, m2) || this;
          return w2.type = "value", w2.angle = 0, w2.name = "", w2;
        }
        return o;
      }(ak2), ASn = TSn, ISn = function() {
        function u(o, n3, p2) {
          this.dimensions = [], this._model = o, this._indicatorAxes = Ya2(o.getIndicatorModels(), function(m2, w2) {
            var T2 = "indicator_" + w2, E = new ASn(T2, new f8());
            return E.name = m2.get("name"), E.model = m2, m2.axis = E, this.dimensions.push(T2), E;
          }, this), this.resize(o, p2);
        }
        return u.prototype.getIndicatorAxes = function() {
          return this._indicatorAxes;
        }, u.prototype.dataToPoint = function(o, n3) {
          var p2 = this._indicatorAxes[n3];
          return this.coordToPoint(p2.dataToCoord(o), n3);
        }, u.prototype.coordToPoint = function(o, n3) {
          var p2 = this._indicatorAxes[n3], m2 = p2.angle, w2 = this.cx + o * Math.cos(m2), T2 = this.cy - o * Math.sin(m2);
          return [w2, T2];
        }, u.prototype.pointToData = function(o) {
          var n3 = o[0] - this.cx, p2 = o[1] - this.cy, m2 = Math.sqrt(n3 * n3 + p2 * p2);
          n3 /= m2, p2 /= m2;
          for (var w2 = Math.atan2(-p2, n3), T2 = 1 / 0, E, O2 = -1, V3 = 0; V3 < this._indicatorAxes.length; V3++) {
            var W3 = this._indicatorAxes[V3], q3 = Math.abs(w2 - W3.angle);
            q3 < T2 && (E = W3, O2 = V3, T2 = q3);
          }
          return [O2, +(E && E.coordToData(m2))];
        }, u.prototype.resize = function(o, n3) {
          var p2 = o.get("center"), m2 = n3.getWidth(), w2 = n3.getHeight(), T2 = Math.min(m2, w2) / 2;
          this.cx = Qo(p2[0], m2), this.cy = Qo(p2[1], w2), this.startAngle = o.get("startAngle") * Math.PI / 180;
          var E = o.get("radius");
          (ds(E) || Dh2(E)) && (E = [0, E]), this.r0 = Qo(E[0], T2), this.r = Qo(E[1], T2), Xe2(this._indicatorAxes, function(O2, V3) {
            O2.setExtent(this.r0, this.r);
            var W3 = this.startAngle + V3 * Math.PI * 2 / this._indicatorAxes.length;
            W3 = Math.atan2(Math.sin(W3), Math.cos(W3)), O2.angle = W3;
          }, this);
        }, u.prototype.update = function(o, n3) {
          var p2 = this._indicatorAxes, m2 = this._model;
          Xe2(p2, function(E) {
            E.scale.setExtent(1 / 0, -1 / 0);
          }), o.eachSeriesByType("radar", function(E, O2) {
            if (!(E.get("coordinateSystem") !== "radar" || o.getComponent("radar", E.get("radarIndex")) !== m2)) {
              var V3 = E.getData();
              Xe2(p2, function(W3) {
                W3.scale.unionExtentFromData(V3, V3.mapDimension(W3.dim));
              });
            }
          }, this);
          var w2 = m2.get("splitNumber"), T2 = new f8();
          T2.setExtent(0, w2), T2.setInterval(1), Xe2(p2, function(E, O2) {
            hbe(E.scale, E.model, T2);
          });
        }, u.prototype.convertToPixel = function(o, n3, p2) {
          return console.warn("Not implemented."), null;
        }, u.prototype.convertFromPixel = function(o, n3, p2) {
          return console.warn("Not implemented."), null;
        }, u.prototype.containPoint = function(o) {
          return console.warn("Not implemented."), false;
        }, u.create = function(o, n3) {
          var p2 = [];
          return o.eachComponent("radar", function(m2) {
            var w2 = new u(m2, o, n3);
            p2.push(w2), m2.coordinateSystem = w2;
          }), o.eachSeriesByType("radar", function(m2) {
            m2.get("coordinateSystem") === "radar" && (m2.coordinateSystem = p2[m2.get("radarIndex") || 0]);
          }), p2;
        }, u.dimensions = [], u;
      }(), DSn = ISn;
      function ESn(u) {
        u.registerCoordinateSystem("radar", DSn), u.registerComponentModel(wSn), u.registerComponentView(CSn), u.registerVisual({ seriesType: "radar", reset: function(o) {
          var n3 = o.getData();
          n3.each(function(p2) {
            n3.setItemVisual(p2, "legendIcon", "roundRect");
          }), n3.setVisual("legendIcon", "roundRect");
        } });
      }
      function kSn(u) {
        Rc2(ESn), u.registerChartView(mSn), u.registerSeriesModel(_Sn), u.registerLayout(gSn), u.registerProcessor(ast("radar")), u.registerPreprocessor(vSn);
      }
      var Ibe = "\0_ec_interaction_mutex";
      function PSn(u, o, n3) {
        var p2 = U9t(u);
        p2[o] = n3;
      }
      function LSn(u, o, n3) {
        var p2 = U9t(u), m2 = p2[o];
        m2 === n3 && (p2[o] = null);
      }
      function Dbe(u, o) {
        return !!U9t(u)[o];
      }
      function U9t(u) {
        return u[Ibe] || (u[Ibe] = {});
      }
      ZP({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, Jp);
      var OSn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this) || this;
          p2._zr = n3;
          var m2 = Is(p2._mousedownHandler, p2), w2 = Is(p2._mousemoveHandler, p2), T2 = Is(p2._mouseupHandler, p2), E = Is(p2._mousewheelHandler, p2), O2 = Is(p2._pinchHandler, p2);
          return p2.enable = function(V3, W3) {
            this.disable(), this._opt = kl(jl(W3) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), V3 == null && (V3 = true), (V3 === true || V3 === "move" || V3 === "pan") && (n3.on("mousedown", m2), n3.on("mousemove", w2), n3.on("mouseup", T2)), (V3 === true || V3 === "scale" || V3 === "zoom") && (n3.on("mousewheel", E), n3.on("pinch", O2));
          }, p2.disable = function() {
            n3.off("mousedown", m2), n3.off("mousemove", w2), n3.off("mouseup", T2), n3.off("mousewheel", E), n3.off("pinch", O2);
          }, p2;
        }
        return o.prototype.isDragging = function() {
          return this._dragging;
        }, o.prototype.isPinching = function() {
          return this._pinching;
        }, o.prototype.setPointerChecker = function(n3) {
          this.pointerChecker = n3;
        }, o.prototype.dispose = function() {
          this.disable();
        }, o.prototype._mousedownHandler = function(n3) {
          if (!(E1t(n3) || n3.target && n3.target.draggable)) {
            var p2 = n3.offsetX, m2 = n3.offsetY;
            this.pointerChecker && this.pointerChecker(n3, p2, m2) && (this._x = p2, this._y = m2, this._dragging = true);
          }
        }, o.prototype._mousemoveHandler = function(n3) {
          if (!(!this._dragging || !Lxt("moveOnMouseMove", n3, this._opt) || n3.gestureEvent === "pinch" || Dbe(this._zr, "globalPan"))) {
            var p2 = n3.offsetX, m2 = n3.offsetY, w2 = this._x, T2 = this._y, E = p2 - w2, O2 = m2 - T2;
            this._x = p2, this._y = m2, this._opt.preventDefaultMouseMove && UE(n3.event), Ebe(this, "pan", "moveOnMouseMove", n3, { dx: E, dy: O2, oldX: w2, oldY: T2, newX: p2, newY: m2, isAvailableBehavior: null });
          }
        }, o.prototype._mouseupHandler = function(n3) {
          E1t(n3) || (this._dragging = false);
        }, o.prototype._mousewheelHandler = function(n3) {
          var p2 = Lxt("zoomOnMouseWheel", n3, this._opt), m2 = Lxt("moveOnMouseWheel", n3, this._opt), w2 = n3.wheelDelta, T2 = Math.abs(w2), E = n3.offsetX, O2 = n3.offsetY;
          if (!(w2 === 0 || !p2 && !m2)) {
            if (p2) {
              var V3 = T2 > 3 ? 1.4 : T2 > 1 ? 1.2 : 1.1, W3 = w2 > 0 ? V3 : 1 / V3;
              q9t(this, "zoom", "zoomOnMouseWheel", n3, { scale: W3, originX: E, originY: O2, isAvailableBehavior: null });
            }
            if (m2) {
              var q3 = Math.abs(w2), K = (w2 > 0 ? 1 : -1) * (q3 > 3 ? 0.4 : q3 > 1 ? 0.15 : 0.05);
              q9t(this, "scrollMove", "moveOnMouseWheel", n3, { scrollDelta: K, originX: E, originY: O2, isAvailableBehavior: null });
            }
          }
        }, o.prototype._pinchHandler = function(n3) {
          if (!Dbe(this._zr, "globalPan")) {
            var p2 = n3.pinchScale > 1 ? 1.1 : 0.9090909090909091;
            q9t(this, "zoom", null, n3, { scale: p2, originX: n3.pinchX, originY: n3.pinchY, isAvailableBehavior: null });
          }
        }, o;
      }(gw);
      function q9t(u, o, n3, p2, m2) {
        u.pointerChecker && u.pointerChecker(p2, m2.originX, m2.originY) && (UE(p2.event), Ebe(u, o, n3, p2, m2));
      }
      function Ebe(u, o, n3, p2, m2) {
        m2.isAvailableBehavior = Is(Lxt, null, n3, p2), u.trigger(o, m2);
      }
      function Lxt(u, o, n3) {
        var p2 = n3[u];
        return !u || p2 && (!ds(p2) || o.event[p2 + "Key"]);
      }
      var ust = OSn;
      function Z9t(u, o, n3) {
        var p2 = u.target;
        p2.x += o, p2.y += n3, p2.dirty();
      }
      function $9t(u, o, n3, p2) {
        var m2 = u.target, w2 = u.zoomLimit, T2 = u.zoom = u.zoom || 1;
        if (T2 *= o, w2) {
          var E = w2.min || 0, O2 = w2.max || 1 / 0;
          T2 = Math.max(Math.min(O2, T2), E);
        }
        var V3 = T2 / u.zoom;
        u.zoom = T2, m2.x -= (n3 - m2.x) * (V3 - 1), m2.y -= (p2 - m2.y) * (V3 - 1), m2.scaleX *= V3, m2.scaleY *= V3, m2.dirty();
      }
      var RSn = { axisPointer: 1, tooltip: 1, brush: 1 };
      function Oxt(u, o, n3) {
        var p2 = o.getComponentByElement(u.topTarget), m2 = p2 && p2.coordinateSystem;
        return p2 && p2 !== n3 && !RSn.hasOwnProperty(p2.mainType) && m2 && m2.model !== n3;
      }
      function kbe(u) {
        if (ds(u)) {
          var o = new DOMParser();
          u = o.parseFromString(u, "text/xml");
        }
        var n3 = u;
        for (n3.nodeType === 9 && (n3 = n3.firstChild); n3.nodeName.toLowerCase() !== "svg" || n3.nodeType !== 1; )
          n3 = n3.nextSibling;
        return n3;
      }
      var Y9t, Rxt = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, Pbe = tf2(Rxt), Nxt = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, Lbe = tf2(Nxt), NSn = function() {
        function u() {
          this._defs = {}, this._root = null;
        }
        return u.prototype.parse = function(o, n3) {
          n3 = n3 || {};
          var p2 = kbe(o);
          this._defsUsePending = [];
          var m2 = new uu();
          this._root = m2;
          var w2 = [], T2 = p2.getAttribute("viewBox") || "", E = parseFloat(p2.getAttribute("width") || n3.width), O2 = parseFloat(p2.getAttribute("height") || n3.height);
          isNaN(E) && (E = null), isNaN(O2) && (O2 = null), PC(p2, m2, null, true, false);
          for (var V3 = p2.firstChild; V3; )
            this._parseNode(V3, m2, w2, null, false, false), V3 = V3.nextSibling;
          BSn(this._defs, this._defsUsePending), this._defsUsePending = [];
          var W3, q3;
          if (T2) {
            var K = Fxt(T2);
            K.length >= 4 && (W3 = { x: parseFloat(K[0] || 0), y: parseFloat(K[1] || 0), width: parseFloat(K[2]), height: parseFloat(K[3]) });
          }
          if (W3 && E != null && O2 != null && (q3 = jbe(W3, { x: 0, y: 0, width: E, height: O2 }), !n3.ignoreViewBox)) {
            var J = m2;
            m2 = new uu(), m2.add(J), J.scaleX = J.scaleY = q3.scale, J.x = q3.x, J.y = q3.y;
          }
          return !n3.ignoreRootClip && E != null && O2 != null && m2.setClipPath(new Vf2({ shape: { x: 0, y: 0, width: E, height: O2 } })), { root: m2, width: E, height: O2, viewBoxRect: W3, viewBoxTransform: q3, named: w2 };
        }, u.prototype._parseNode = function(o, n3, p2, m2, w2, T2) {
          var E = o.nodeName.toLowerCase(), O2, V3 = m2;
          if (E === "defs" && (w2 = true), E === "text" && (T2 = true), E === "defs" || E === "switch")
            O2 = n3;
          else {
            if (!w2) {
              var W3 = Y9t[E];
              if (W3 && Fs(Y9t, E)) {
                O2 = W3.call(this, o, n3);
                var q3 = o.getAttribute("name");
                if (q3) {
                  var K = { name: q3, namedFrom: null, svgNodeTagLower: E, el: O2 };
                  p2.push(K), E === "g" && (V3 = K);
                } else
                  m2 && p2.push({ name: m2.name, namedFrom: m2, svgNodeTagLower: E, el: O2 });
                n3.add(O2);
              }
            }
            var J = Obe[E];
            if (J && Fs(Obe, E)) {
              var rt2 = J.call(this, o), gt = o.getAttribute("id");
              gt && (this._defs[gt] = rt2);
            }
          }
          if (O2 && O2.isGroup)
            for (var yt = o.firstChild; yt; )
              yt.nodeType === 1 ? this._parseNode(yt, O2, p2, V3, w2, T2) : yt.nodeType === 3 && T2 && this._parseText(yt, O2), yt = yt.nextSibling;
        }, u.prototype._parseText = function(o, n3) {
          var p2 = new gz({ style: { text: o.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
          yI(n3, p2), PC(o, p2, this._defsUsePending, false, false), FSn(p2, n3);
          var m2 = p2.style, w2 = m2.fontSize;
          w2 && w2 < 9 && (m2.fontSize = 9, p2.scaleX *= w2 / 9, p2.scaleY *= w2 / 9);
          var T2 = (m2.fontSize || m2.fontFamily) && [m2.fontStyle, m2.fontWeight, (m2.fontSize || 12) + "px", m2.fontFamily || "sans-serif"].join(" ");
          m2.font = T2;
          var E = p2.getBoundingRect();
          return this._textX += E.width, n3.add(p2), p2;
        }, u.internalField = function() {
          Y9t = { g: function(o, n3) {
            var p2 = new uu();
            return yI(n3, p2), PC(o, p2, this._defsUsePending, false, false), p2;
          }, rect: function(o, n3) {
            var p2 = new Vf2();
            return yI(n3, p2), PC(o, p2, this._defsUsePending, false, false), p2.setShape({ x: parseFloat(o.getAttribute("x") || "0"), y: parseFloat(o.getAttribute("y") || "0"), width: parseFloat(o.getAttribute("width") || "0"), height: parseFloat(o.getAttribute("height") || "0") }), p2.silent = true, p2;
          }, circle: function(o, n3) {
            var p2 = new sI();
            return yI(n3, p2), PC(o, p2, this._defsUsePending, false, false), p2.setShape({ cx: parseFloat(o.getAttribute("cx") || "0"), cy: parseFloat(o.getAttribute("cy") || "0"), r: parseFloat(o.getAttribute("r") || "0") }), p2.silent = true, p2;
          }, line: function(o, n3) {
            var p2 = new My();
            return yI(n3, p2), PC(o, p2, this._defsUsePending, false, false), p2.setShape({ x1: parseFloat(o.getAttribute("x1") || "0"), y1: parseFloat(o.getAttribute("y1") || "0"), x2: parseFloat(o.getAttribute("x2") || "0"), y2: parseFloat(o.getAttribute("y2") || "0") }), p2.silent = true, p2;
          }, ellipse: function(o, n3) {
            var p2 = new cot();
            return yI(n3, p2), PC(o, p2, this._defsUsePending, false, false), p2.setShape({ cx: parseFloat(o.getAttribute("cx") || "0"), cy: parseFloat(o.getAttribute("cy") || "0"), rx: parseFloat(o.getAttribute("rx") || "0"), ry: parseFloat(o.getAttribute("ry") || "0") }), p2.silent = true, p2;
          }, polygon: function(o, n3) {
            var p2 = o.getAttribute("points"), m2;
            p2 && (m2 = Fbe(p2));
            var w2 = new Sw({ shape: { points: m2 || [] }, silent: true });
            return yI(n3, w2), PC(o, w2, this._defsUsePending, false, false), w2;
          }, polyline: function(o, n3) {
            var p2 = o.getAttribute("points"), m2;
            p2 && (m2 = Fbe(p2));
            var w2 = new Mw({ shape: { points: m2 || [] }, silent: true });
            return yI(n3, w2), PC(o, w2, this._defsUsePending, false, false), w2;
          }, image: function(o, n3) {
            var p2 = new Fm();
            return yI(n3, p2), PC(o, p2, this._defsUsePending, false, false), p2.setStyle({ image: o.getAttribute("xlink:href") || o.getAttribute("href"), x: +o.getAttribute("x"), y: +o.getAttribute("y"), width: +o.getAttribute("width"), height: +o.getAttribute("height") }), p2.silent = true, p2;
          }, text: function(o, n3) {
            var p2 = o.getAttribute("x") || "0", m2 = o.getAttribute("y") || "0", w2 = o.getAttribute("dx") || "0", T2 = o.getAttribute("dy") || "0";
            this._textX = parseFloat(p2) + parseFloat(w2), this._textY = parseFloat(m2) + parseFloat(T2);
            var E = new uu();
            return yI(n3, E), PC(o, E, this._defsUsePending, false, true), E;
          }, tspan: function(o, n3) {
            var p2 = o.getAttribute("x"), m2 = o.getAttribute("y");
            p2 != null && (this._textX = parseFloat(p2)), m2 != null && (this._textY = parseFloat(m2));
            var w2 = o.getAttribute("dx") || "0", T2 = o.getAttribute("dy") || "0", E = new uu();
            return yI(n3, E), PC(o, E, this._defsUsePending, false, true), this._textX += parseFloat(w2), this._textY += parseFloat(T2), E;
          }, path: function(o, n3) {
            var p2 = o.getAttribute("d") || "", m2 = p_t(p2);
            return yI(n3, m2), PC(o, m2, this._defsUsePending, false, false), m2.silent = true, m2;
          } };
        }(), u;
      }(), Obe = { lineargradient: function(u) {
        var o = parseInt(u.getAttribute("x1") || "0", 10), n3 = parseInt(u.getAttribute("y1") || "0", 10), p2 = parseInt(u.getAttribute("x2") || "10", 10), m2 = parseInt(u.getAttribute("y2") || "0", 10), w2 = new Mz(o, n3, p2, m2);
        return Rbe(u, w2), Nbe(u, w2), w2;
      }, radialgradient: function(u) {
        var o = parseInt(u.getAttribute("cx") || "0", 10), n3 = parseInt(u.getAttribute("cy") || "0", 10), p2 = parseInt(u.getAttribute("r") || "0", 10), m2 = new N$(o, n3, p2);
        return Rbe(u, m2), Nbe(u, m2), m2;
      } };
      function Rbe(u, o) {
        var n3 = u.getAttribute("gradientUnits");
        n3 === "userSpaceOnUse" && (o.global = true);
      }
      function Nbe(u, o) {
        for (var n3 = u.firstChild; n3; ) {
          if (n3.nodeType === 1 && n3.nodeName.toLocaleLowerCase() === "stop") {
            var p2 = n3.getAttribute("offset"), m2 = void 0;
            p2 && p2.indexOf("%") > 0 ? m2 = parseInt(p2, 10) / 100 : p2 ? m2 = parseFloat(p2) : m2 = 0;
            var w2 = {};
            zbe(n3, w2, w2);
            var T2 = w2.stopColor || n3.getAttribute("stop-color") || "#000000";
            o.colorStops.push({ offset: m2, color: T2 });
          }
          n3 = n3.nextSibling;
        }
      }
      function yI(u, o) {
        u && u.__inheritedStyle && (o.__inheritedStyle || (o.__inheritedStyle = {}), kl(o.__inheritedStyle, u.__inheritedStyle));
      }
      function Fbe(u) {
        for (var o = Fxt(u), n3 = [], p2 = 0; p2 < o.length; p2 += 2) {
          var m2 = parseFloat(o[p2]), w2 = parseFloat(o[p2 + 1]);
          n3.push([m2, w2]);
        }
        return n3;
      }
      function PC(u, o, n3, p2, m2) {
        var w2 = o, T2 = w2.__inheritedStyle = w2.__inheritedStyle || {}, E = {};
        u.nodeType === 1 && (WSn(u, o), zbe(u, T2, E), p2 || GSn(u, T2, E)), w2.style = w2.style || {}, T2.fill != null && (w2.style.fill = Vbe(w2, "fill", T2.fill, n3)), T2.stroke != null && (w2.style.stroke = Vbe(w2, "stroke", T2.stroke, n3)), Xe2(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(O2) {
          T2[O2] != null && (w2.style[O2] = parseFloat(T2[O2]));
        }), Xe2(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(O2) {
          T2[O2] != null && (w2.style[O2] = T2[O2]);
        }), m2 && (w2.__selfStyle = E), T2.lineDash && (w2.style.lineDash = Ya2(Fxt(T2.lineDash), function(O2) {
          return parseFloat(O2);
        })), (T2.visibility === "hidden" || T2.visibility === "collapse") && (w2.invisible = true), T2.display === "none" && (w2.ignore = true);
      }
      function FSn(u, o) {
        var n3 = o.__selfStyle;
        if (n3) {
          var p2 = n3.textBaseline, m2 = p2;
          !p2 || p2 === "auto" || p2 === "baseline" ? m2 = "alphabetic" : p2 === "before-edge" || p2 === "text-before-edge" ? m2 = "top" : p2 === "after-edge" || p2 === "text-after-edge" ? m2 = "bottom" : (p2 === "central" || p2 === "mathematical") && (m2 = "middle"), u.style.textBaseline = m2;
        }
        var w2 = o.__inheritedStyle;
        if (w2) {
          var T2 = w2.textAlign, E = T2;
          T2 && (T2 === "middle" && (E = "center"), u.style.textAlign = E);
        }
      }
      var VSn = /^url\(\s*#(.*?)\)/;
      function Vbe(u, o, n3, p2) {
        var m2 = n3 && n3.match(VSn);
        if (m2) {
          var w2 = US(m2[1]);
          p2.push([u, o, w2]);
          return;
        }
        return n3 === "none" && (n3 = null), n3;
      }
      function BSn(u, o) {
        for (var n3 = 0; n3 < o.length; n3++) {
          var p2 = o[n3];
          p2[0].style[p2[1]] = u[p2[2]];
        }
      }
      var zSn = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
      function Fxt(u) {
        return u.match(zSn) || [];
      }
      var jSn = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, K9t = Math.PI / 180;
      function WSn(u, o) {
        var n3 = u.getAttribute("transform");
        if (n3) {
          n3 = n3.replace(/,/g, " ");
          var p2 = [], m2 = null;
          n3.replace(jSn, function(q3, K, J) {
            return p2.push(K, J), "";
          });
          for (var w2 = p2.length - 1; w2 > 0; w2 -= 2) {
            var T2 = p2[w2], E = p2[w2 - 1], O2 = Fxt(T2);
            switch (m2 = m2 || yw(), E) {
              case "translate":
                QS(m2, m2, [parseFloat(O2[0]), parseFloat(O2[1] || "0")]);
                break;
              case "scale":
                e$(m2, m2, [parseFloat(O2[0]), parseFloat(O2[1] || O2[0])]);
                break;
              case "rotate":
                t4(m2, m2, -parseFloat(O2[0]) * K9t);
                break;
              case "skewX":
                var V3 = Math.tan(parseFloat(O2[0]) * K9t);
                YA(m2, [1, 0, V3, 1, 0, 0], m2);
                break;
              case "skewY":
                var W3 = Math.tan(parseFloat(O2[0]) * K9t);
                YA(m2, [1, W3, 0, 1, 0, 0], m2);
                break;
              case "matrix":
                m2[0] = parseFloat(O2[0]), m2[1] = parseFloat(O2[1]), m2[2] = parseFloat(O2[2]), m2[3] = parseFloat(O2[3]), m2[4] = parseFloat(O2[4]), m2[5] = parseFloat(O2[5]);
                break;
            }
          }
          o.setLocalTransform(m2);
        }
      }
      var Bbe = /([^\s:;]+)\s*:\s*([^:;]+)/g;
      function zbe(u, o, n3) {
        var p2 = u.getAttribute("style");
        if (p2) {
          Bbe.lastIndex = 0;
          for (var m2; (m2 = Bbe.exec(p2)) != null; ) {
            var w2 = m2[1], T2 = Fs(Rxt, w2) ? Rxt[w2] : null;
            T2 && (o[T2] = m2[2]);
            var E = Fs(Nxt, w2) ? Nxt[w2] : null;
            E && (n3[E] = m2[2]);
          }
        }
      }
      function GSn(u, o, n3) {
        for (var p2 = 0; p2 < Pbe.length; p2++) {
          var m2 = Pbe[p2], w2 = u.getAttribute(m2);
          w2 != null && (o[Rxt[m2]] = w2);
        }
        for (var p2 = 0; p2 < Lbe.length; p2++) {
          var m2 = Lbe[p2], w2 = u.getAttribute(m2);
          w2 != null && (n3[Nxt[m2]] = w2);
        }
      }
      function jbe(u, o) {
        var n3 = o.width / u.width, p2 = o.height / u.height, m2 = Math.min(n3, p2);
        return { scale: m2, x: -(u.x + u.width / 2) * m2 + (o.x + o.width / 2), y: -(u.y + u.height / 2) * m2 + (o.y + o.height / 2) };
      }
      function HSn(u, o) {
        var n3 = new NSn();
        return n3.parse(u, o);
      }
      var USn = pl(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), qSn = function() {
        function u(o, n3) {
          this.type = "geoSVG", this._usedGraphicMap = pl(), this._freedGraphics = [], this._mapName = o, this._parsedXML = kbe(n3);
        }
        return u.prototype.load = function() {
          var o = this._firstGraphic;
          if (!o) {
            o = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(o), this._boundingRect = this._firstGraphic.boundingRect.clone();
            var n3 = $Sn(o.named), p2 = n3.regions, m2 = n3.regionsMap;
            this._regions = p2, this._regionsMap = m2;
          }
          return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
        }, u.prototype._buildGraphic = function(o) {
          var n3, p2;
          try {
            n3 = o && HSn(o, { ignoreViewBox: true, ignoreRootClip: true }) || {}, p2 = n3.root, Tb2(p2 != null);
          } catch (yt) {
            throw new Error(`Invalid svg format
` + yt.message);
          }
          var m2 = new uu();
          m2.add(p2), m2.isGeoSVGGraphicRoot = true;
          var w2 = n3.width, T2 = n3.height, E = n3.viewBoxRect, O2 = this._boundingRect;
          if (!O2) {
            var V3 = void 0, W3 = void 0, q3 = void 0, K = void 0;
            if (w2 != null ? (V3 = 0, q3 = w2) : E && (V3 = E.x, q3 = E.width), T2 != null ? (W3 = 0, K = T2) : E && (W3 = E.y, K = E.height), V3 == null || W3 == null) {
              var J = p2.getBoundingRect();
              V3 == null && (V3 = J.x, q3 = J.width), W3 == null && (W3 = J.y, K = J.height);
            }
            O2 = this._boundingRect = new Qu(V3, W3, q3, K);
          }
          if (E) {
            var rt2 = jbe(E, O2);
            p2.scaleX = p2.scaleY = rt2.scale, p2.x = rt2.x, p2.y = rt2.y;
          }
          m2.setClipPath(new Vf2({ shape: O2.plain() }));
          var gt = [];
          return Xe2(n3.named, function(yt) {
            USn.get(yt.svgNodeTagLower) != null && (gt.push(yt), ZSn(yt.el));
          }), { root: m2, boundingRect: O2, named: gt };
        }, u.prototype.useGraphic = function(o) {
          var n3 = this._usedGraphicMap, p2 = n3.get(o);
          return p2 || (p2 = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), n3.set(o, p2), p2);
        }, u.prototype.freeGraphic = function(o) {
          var n3 = this._usedGraphicMap, p2 = n3.get(o);
          p2 && (n3.removeKey(o), this._freedGraphics.push(p2));
        }, u;
      }();
      function ZSn(u) {
        u.silent = false, u.isGroup && u.traverse(function(o) {
          o.silent = false;
        });
      }
      function $Sn(u) {
        var o = [], n3 = pl();
        return Xe2(u, function(p2) {
          if (p2.namedFrom == null) {
            var m2 = new h_n(p2.name, p2.el);
            o.push(m2), n3.set(p2.name, m2);
          }
        }), { regions: o, regionsMap: n3 };
      }
      for (var X9t = [126, 25], Wbe = "\u5357\u6D77\u8BF8\u5C9B", qz = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]], Zz = 0; Zz < qz.length; Zz++)
        for (var gY = 0; gY < qz[Zz].length; gY++)
          qz[Zz][gY][0] /= 10.5, qz[Zz][gY][1] /= -10.5 / 0.75, qz[Zz][gY][0] += X9t[0], qz[Zz][gY][1] += X9t[1];
      function YSn(u, o) {
        if (u === "china") {
          for (var n3 = 0; n3 < o.length; n3++)
            if (o[n3].name === Wbe)
              return;
          o.push(new Rme(Wbe, Ya2(qz, function(p2) {
            return { type: "polygon", exterior: p2 };
          }), X9t));
        }
      }
      var KSn = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
      function XSn(u, o) {
        if (u === "china") {
          var n3 = KSn[o.name];
          if (n3) {
            var p2 = o.getCenter();
            p2[0] += n3[0] / 10.5, p2[1] += -n3[1] / (10.5 / 0.75), o.setCenter(p2);
          }
        }
      }
      var QSn = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
      function JSn(u, o) {
        u === "china" && o.name === "\u53F0\u6E7E" && o.geometries.push({ type: "polygon", exterior: QSn[0] });
      }
      var t2n = "name", e2n = function() {
        function u(o, n3, p2) {
          this.type = "geoJSON", this._parsedMap = pl(), this._mapName = o, this._specialAreas = p2, this._geoJSON = r2n(n3);
        }
        return u.prototype.load = function(o, n3) {
          n3 = n3 || t2n;
          var p2 = this._parsedMap.get(n3);
          if (!p2) {
            var m2 = this._parseToRegions(n3);
            p2 = this._parsedMap.set(n3, { regions: m2, boundingRect: n2n(m2) });
          }
          var w2 = pl(), T2 = [];
          return Xe2(p2.regions, function(E) {
            var O2 = E.name;
            o && Fs(o, O2) && (E = E.cloneShallow(O2 = o[O2])), T2.push(E), w2.set(O2, E);
          }), { regions: T2, boundingRect: p2.boundingRect || new Qu(0, 0, 0, 0), regionsMap: w2 };
        }, u.prototype._parseToRegions = function(o) {
          var n3 = this._mapName, p2 = this._geoJSON, m2;
          try {
            m2 = p2 ? d_n(p2, o) : [];
          } catch (w2) {
            throw new Error(`Invalid geoJson format
` + w2.message);
          }
          return YSn(n3, m2), Xe2(m2, function(w2) {
            var T2 = w2.name;
            XSn(n3, w2), JSn(n3, w2);
            var E = this._specialAreas && this._specialAreas[T2];
            E && w2.transformTo(E.left, E.top, E.width, E.height);
          }, this), m2;
        }, u.prototype.getMapForUser = function() {
          return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
        }, u;
      }();
      function n2n(u) {
        for (var o, n3 = 0; n3 < u.length; n3++) {
          var p2 = u[n3].getBoundingRect();
          o = o || p2.clone(), o.union(p2);
        }
        return o;
      }
      function r2n(u) {
        return ds(u) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(u) : new Function("return (" + u + ");")() : u;
      }
      var cst = pl(), E4 = { registerMap: function(u, o, n3) {
        if (o.svg) {
          var p2 = new qSn(u, o.svg);
          cst.set(u, p2);
        } else {
          var m2 = o.geoJson || o.geoJSON;
          m2 && !o.features ? n3 = o.specialAreas : m2 = o;
          var p2 = new e2n(u, m2, n3);
          cst.set(u, p2);
        }
      }, getGeoResource: function(u) {
        return cst.get(u);
      }, getMapForUser: function(u) {
        var o = cst.get(u);
        return o && o.type === "geoJSON" && o.getMapForUser();
      }, load: function(u, o, n3) {
        var p2 = cst.get(u);
        if (p2)
          return p2.load(o, n3);
      } }, Q9t = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], i2n = pl(Q9t), a2n = pl(Q9t.concat(["g"])), o2n = pl(Q9t.concat(["g"])), Gbe = Ff2();
      function Vxt(u) {
        var o = u.getItemStyle(), n3 = u.get("areaColor");
        return n3 != null && (o.fill = n3), o;
      }
      function Hbe(u) {
        var o = u.style;
        o && (o.stroke = o.stroke || o.fill, o.fill = null);
      }
      var s2n = function() {
        function u(o) {
          var n3 = new uu();
          this.uid = U$("ec_map_draw"), this._controller = new ust(o.getZr()), this._controllerHost = { target: n3 }, this.group = n3, n3.add(this._regionsGroup = new uu()), n3.add(this._svgGroup = new uu());
        }
        return u.prototype.draw = function(o, n3, p2, m2, w2) {
          var T2 = o.mainType === "geo", E = o.getData && o.getData();
          T2 && n3.eachComponent({ mainType: "series", subType: "map" }, function(At) {
            !E && At.getHostGeoModel() === o && (E = At.getData());
          });
          var O2 = o.coordinateSystem, V3 = this._regionsGroup, W3 = this.group, q3 = O2.getTransformInfo(), K = q3.raw, J = q3.roam, rt2 = !V3.childAt(0) || w2;
          rt2 ? (W3.x = J.x, W3.y = J.y, W3.scaleX = J.scaleX, W3.scaleY = J.scaleY, W3.dirty()) : Xf2(W3, J, o);
          var gt = E && E.getVisual("visualMeta") && E.getVisual("visualMeta").length > 0, yt = { api: p2, geo: O2, mapOrGeoModel: o, data: E, isVisualEncodedByVisualMap: gt, isGeo: T2, transformInfoRaw: K };
          O2.resourceType === "geoJSON" ? this._buildGeoJSON(yt) : O2.resourceType === "geoSVG" && this._buildSVG(yt), this._updateController(o, n3, p2), this._updateMapSelectHandler(o, V3, p2, m2);
        }, u.prototype._buildGeoJSON = function(o) {
          var n3 = this._regionsGroupByName = pl(), p2 = pl(), m2 = this._regionsGroup, w2 = o.transformInfoRaw, T2 = o.mapOrGeoModel, E = o.data, O2 = o.geo.projection, V3 = O2 && O2.stream;
          function W3(J, rt2) {
            return rt2 && (J = rt2(J)), J && [J[0] * w2.scaleX + w2.x, J[1] * w2.scaleY + w2.y];
          }
          function q3(J) {
            for (var rt2 = [], gt = !V3 && O2 && O2.project, yt = 0; yt < J.length; ++yt) {
              var At = W3(J[yt], gt);
              At && rt2.push(At);
            }
            return rt2;
          }
          function K(J) {
            return { shape: { points: q3(J) } };
          }
          m2.removeAll(), Xe2(o.geo.regions, function(J) {
            var rt2 = J.name, gt = n3.get(rt2), yt = p2.get(rt2) || {}, At = yt.dataIdx, Lt = yt.regionModel;
            gt || (gt = n3.set(rt2, new uu()), m2.add(gt), At = E ? E.indexOfName(rt2) : null, Lt = o.isGeo ? T2.getRegionModel(rt2) : E ? E.getItemModel(At) : null, p2.set(rt2, { dataIdx: At, regionModel: Lt }));
            var Wt = [], Nt = [];
            Xe2(J.geometries, function(pe2) {
              if (pe2.type === "polygon") {
                var xe = [pe2.exterior].concat(pe2.interiors || []);
                V3 && (xe = Kbe(xe, V3)), Xe2(xe, function(Le2) {
                  Wt.push(new Sw(K(Le2)));
                });
              } else {
                var Ce2 = pe2.points;
                V3 && (Ce2 = Kbe(Ce2, V3, true)), Xe2(Ce2, function(Le2) {
                  Nt.push(new Mw(K(Le2)));
                });
              }
            });
            var ue2 = W3(J.getCenter(), O2 && O2.project);
            function ie2(pe2, xe) {
              if (pe2.length) {
                var Ce2 = new got({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: pe2 } });
                gt.add(Ce2), Ube(o, Ce2, At, Lt), qbe(o, Ce2, rt2, Lt, T2, At, ue2), xe && (Hbe(Ce2), Xe2(Ce2.states, Hbe));
              }
            }
            ie2(Wt), ie2(Nt, true);
          }), n3.each(function(J, rt2) {
            var gt = p2.get(rt2), yt = gt.dataIdx, At = gt.regionModel;
            Zbe(o, J, rt2, At, T2, yt), $be(o, J, rt2, At, T2), Ybe(o, J, rt2, At, T2);
          }, this);
        }, u.prototype._buildSVG = function(o) {
          var n3 = o.geo.map, p2 = o.transformInfoRaw;
          this._svgGroup.x = p2.x, this._svgGroup.y = p2.y, this._svgGroup.scaleX = p2.scaleX, this._svgGroup.scaleY = p2.scaleY, this._svgResourceChanged(n3) && (this._freeSVG(), this._useSVG(n3));
          var m2 = this._svgDispatcherMap = pl(), w2 = false;
          Xe2(this._svgGraphicRecord.named, function(T2) {
            var E = T2.name, O2 = o.mapOrGeoModel, V3 = o.data, W3 = T2.svgNodeTagLower, q3 = T2.el, K = V3 ? V3.indexOfName(E) : null, J = O2.getRegionModel(E);
            if (i2n.get(W3) != null && q3 instanceof sM && Ube(o, q3, K, J), q3 instanceof sM && (q3.culling = true), q3.z2EmphasisLift = 0, !T2.namedFrom && (o2n.get(W3) != null && qbe(o, q3, E, J, O2, K, null), Zbe(o, q3, E, J, O2, K), $be(o, q3, E, J, O2), a2n.get(W3) != null)) {
              var rt2 = Ybe(o, q3, E, J, O2);
              rt2 === "self" && (w2 = true);
              var gt = m2.get(E) || m2.set(E, []);
              gt.push(q3);
            }
          }, this), this._enableBlurEntireSVG(w2, o);
        }, u.prototype._enableBlurEntireSVG = function(o, n3) {
          if (o && n3.isGeo) {
            var p2 = n3.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), m2 = p2.opacity;
            this._svgGraphicRecord.root.traverse(function(w2) {
              if (!w2.isGroup) {
                y4(w2);
                var T2 = w2.ensureState("blur").style || {};
                T2.opacity == null && m2 != null && (T2.opacity = m2), w2.ensureState("emphasis");
              }
            });
          }
        }, u.prototype.remove = function() {
          this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
        }, u.prototype.findHighDownDispatchers = function(o, n3) {
          if (o == null)
            return [];
          var p2 = n3.coordinateSystem;
          if (p2.resourceType === "geoJSON") {
            var m2 = this._regionsGroupByName;
            if (m2) {
              var w2 = m2.get(o);
              return w2 ? [w2] : [];
            }
          } else if (p2.resourceType === "geoSVG")
            return this._svgDispatcherMap && this._svgDispatcherMap.get(o) || [];
        }, u.prototype._svgResourceChanged = function(o) {
          return this._svgMapName !== o;
        }, u.prototype._useSVG = function(o) {
          var n3 = E4.getGeoResource(o);
          if (n3 && n3.type === "geoSVG") {
            var p2 = n3.useGraphic(this.uid);
            this._svgGroup.add(p2.root), this._svgGraphicRecord = p2, this._svgMapName = o;
          }
        }, u.prototype._freeSVG = function() {
          var o = this._svgMapName;
          if (o != null) {
            var n3 = E4.getGeoResource(o);
            n3 && n3.type === "geoSVG" && n3.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
          }
        }, u.prototype._updateController = function(o, n3, p2) {
          var m2 = o.coordinateSystem, w2 = this._controller, T2 = this._controllerHost;
          T2.zoomLimit = o.get("scaleLimit"), T2.zoom = m2.getZoom(), w2.enable(o.get("roam") || false);
          var E = o.mainType;
          function O2() {
            var V3 = { type: "geoRoam", componentType: E };
            return V3[E + "Id"] = o.id, V3;
          }
          w2.off("pan").on("pan", function(V3) {
            this._mouseDownFlag = false, Z9t(T2, V3.dx, V3.dy), p2.dispatchAction(ua2(O2(), { dx: V3.dx, dy: V3.dy, animation: { duration: 0 } }));
          }, this), w2.off("zoom").on("zoom", function(V3) {
            this._mouseDownFlag = false, $9t(T2, V3.scale, V3.originX, V3.originY), p2.dispatchAction(ua2(O2(), { zoom: V3.scale, originX: V3.originX, originY: V3.originY, animation: { duration: 0 } }));
          }, this), w2.setPointerChecker(function(V3, W3, q3) {
            return m2.containPoint([W3, q3]) && !Oxt(V3, p2, o);
          });
        }, u.prototype.resetForLabelLayout = function() {
          this.group.traverse(function(o) {
            var n3 = o.getTextContent();
            n3 && (n3.ignore = Gbe(n3).ignore);
          });
        }, u.prototype._updateMapSelectHandler = function(o, n3, p2, m2) {
          var w2 = this;
          n3.off("mousedown"), n3.off("click"), o.get("selectedMode") && (n3.on("mousedown", function() {
            w2._mouseDownFlag = true;
          }), n3.on("click", function(T2) {
            !w2._mouseDownFlag || (w2._mouseDownFlag = false);
          }));
        }, u;
      }();
      function Ube(u, o, n3, p2) {
        var m2 = p2.getModel("itemStyle"), w2 = p2.getModel(["emphasis", "itemStyle"]), T2 = p2.getModel(["blur", "itemStyle"]), E = p2.getModel(["select", "itemStyle"]), O2 = Vxt(m2), V3 = Vxt(w2), W3 = Vxt(E), q3 = Vxt(T2), K = u.data;
        if (K) {
          var J = K.getItemVisual(n3, "style"), rt2 = K.getItemVisual(n3, "decal");
          u.isVisualEncodedByVisualMap && J.fill && (O2.fill = J.fill), rt2 && (O2.decal = Fot(rt2, u.api));
        }
        o.setStyle(O2), o.style.strokeNoScale = true, o.ensureState("emphasis").style = V3, o.ensureState("select").style = W3, o.ensureState("blur").style = q3, y4(o);
      }
      function qbe(u, o, n3, p2, m2, w2, T2) {
        var E = u.data, O2 = u.isGeo, V3 = E && isNaN(E.get(E.mapDimension("value"), w2)), W3 = E && E.getItemLayout(w2);
        if (O2 || V3 || W3 && W3.showLabel) {
          var q3 = O2 ? n3 : w2, K = void 0;
          (!E || w2 >= 0) && (K = m2);
          var J = T2 ? { normal: { align: "center", verticalAlign: "middle" } } : null;
          Tw(o, Lb2(p2), { labelFetcher: K, labelDataIndex: q3, defaultText: n3 }, J);
          var rt2 = o.getTextContent();
          if (rt2 && (Gbe(rt2).ignore = rt2.ignore, o.textConfig && T2)) {
            var gt = o.getBoundingRect().clone();
            o.textConfig.layoutRect = gt, o.textConfig.position = [(T2[0] - gt.x) / gt.width * 100 + "%", (T2[1] - gt.y) / gt.height * 100 + "%"];
          }
          o.disableLabelAnimation = true;
        } else
          o.removeTextContent(), o.removeTextConfig(), o.disableLabelAnimation = null;
      }
      function Zbe(u, o, n3, p2, m2, w2) {
        u.data ? u.data.setItemGraphicEl(w2, o) : is(o).eventData = { componentType: "geo", componentIndex: m2.componentIndex, geoIndex: m2.componentIndex, name: n3, region: p2 && p2.option || {} };
      }
      function $be(u, o, n3, p2, m2) {
        u.data || G$({ el: o, componentModel: m2, itemName: n3, itemTooltipOption: p2.get("tooltip") });
      }
      function Ybe(u, o, n3, p2, m2) {
        o.highDownSilentOnTouch = !!m2.get("selectedMode");
        var w2 = p2.getModel("emphasis"), T2 = w2.get("focus");
        return o0(o, T2, w2.get("blurScope"), w2.get("disabled")), u.isGeo && _Ft(o, m2, n3), T2;
      }
      function Kbe(u, o, n3) {
        var p2 = [], m2;
        function w2() {
          m2 = [];
        }
        function T2() {
          m2.length && (p2.push(m2), m2 = []);
        }
        var E = o({ polygonStart: w2, polygonEnd: T2, lineStart: w2, lineEnd: T2, point: function(O2, V3) {
          isFinite(O2) && isFinite(V3) && m2.push([O2, V3]);
        }, sphere: function() {
        } });
        return !n3 && E.polygonStart(), Xe2(u, function(O2) {
          E.lineStart();
          for (var V3 = 0; V3 < O2.length; V3++)
            E.point(O2[V3][0], O2[V3][1]);
          E.lineEnd();
        }), !n3 && E.polygonEnd(), p2;
      }
      var Xbe = s2n, l2n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          if (!(w2 && w2.type === "mapToggleSelect" && w2.from === this.uid)) {
            var T2 = this.group;
            if (T2.removeAll(), !n3.getHostGeoModel()) {
              if (this._mapDraw && w2 && w2.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), w2 && w2.type === "geoRoam" && w2.componentType === "series" && w2.seriesId === n3.id) {
                var E = this._mapDraw;
                E && T2.add(E.group);
              } else if (n3.needsDrawMap) {
                var E = this._mapDraw || new Xbe(m2);
                T2.add(E.group), E.draw(n3, p2, m2, this, w2), this._mapDraw = E;
              } else
                this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
              n3.get("showLegendSymbol") && p2.getComponent("legend") && this._renderSymbols(n3, p2, m2);
            }
          }
        }, o.prototype.remove = function() {
          this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
        }, o.prototype.dispose = function() {
          this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
        }, o.prototype._renderSymbols = function(n3, p2, m2) {
          var w2 = n3.originalData, T2 = this.group;
          w2.each(w2.mapDimension("value"), function(E, O2) {
            if (!isNaN(E)) {
              var V3 = w2.getItemLayout(O2);
              if (!(!V3 || !V3.point)) {
                var W3 = V3.point, q3 = V3.offset, K = new sI({ style: { fill: n3.getData().getVisual("style").fill }, shape: { cx: W3[0] + q3 * 9, cy: W3[1], r: 3 }, silent: true, z2: 8 + (q3 ? 0 : WP + 1) });
                if (!q3) {
                  var J = n3.mainSeries.getData(), rt2 = w2.getName(O2), gt = J.indexOfName(rt2), yt = w2.getItemModel(O2), At = yt.getModel("label"), Lt = J.getItemGraphicEl(gt);
                  Tw(K, Lb2(yt), { labelFetcher: { getFormattedLabel: function(Wt, Nt) {
                    return n3.getFormattedLabel(gt, Nt);
                  } }, defaultText: rt2 }), K.disableLabelAnimation = true, At.get("position") || K.setTextConfig({ position: "bottom" }), Lt.onHoverStateChange = function(Wt) {
                    v42(K, Wt);
                  };
                }
                T2.add(K);
              }
            }
          });
        }, o.type = "map", o;
      }(xg2), u2n = l2n, c2n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.needsDrawMap = false, n3.seriesGroup = [], n3.getTooltipPosition = function(p2) {
            if (p2 != null) {
              var m2 = this.getData().getName(p2), w2 = this.coordinateSystem, T2 = w2.getRegion(m2);
              return T2 && w2.dataToPoint(T2.getCenter());
            }
          }, n3;
        }
        return o.prototype.getInitialData = function(n3) {
          for (var p2 = pY(this, { coordDimensions: ["value"], encodeDefaulter: wu(l8t, this) }), m2 = pl(), w2 = [], T2 = 0, E = p2.count(); T2 < E; T2++) {
            var O2 = p2.getName(T2);
            m2.set(O2, true);
          }
          var V3 = E4.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
          return Xe2(V3.regions, function(W3) {
            var q3 = W3.name;
            m2.get(q3) || w2.push(q3);
          }), p2.appendValues([], w2), p2;
        }, o.prototype.getHostGeoModel = function() {
          var n3 = this.option.geoIndex;
          return n3 != null ? this.ecModel.getComponent("geo", n3) : null;
        }, o.prototype.getMapType = function() {
          return (this.getHostGeoModel() || this).option.map;
        }, o.prototype.getRawValue = function(n3) {
          var p2 = this.getData();
          return p2.get(p2.mapDimension("value"), n3);
        }, o.prototype.getRegionModel = function(n3) {
          var p2 = this.getData();
          return p2.getItemModel(p2.indexOfName(n3));
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          for (var w2 = this.getData(), T2 = this.getRawValue(n3), E = w2.getName(n3), O2 = this.seriesGroup, V3 = [], W3 = 0; W3 < O2.length; W3++) {
            var q3 = O2[W3].originalData.indexOfName(E), K = w2.mapDimension("value");
            isNaN(O2[W3].originalData.get(K, q3)) || V3.push(O2[W3].name);
          }
          return k1("section", { header: V3.join(", "), noHeader: !V3.length, blocks: [k1("nameValue", { name: E, value: T2 })] });
        }, o.prototype.setZoom = function(n3) {
          this.option.zoom = n3;
        }, o.prototype.setCenter = function(n3) {
          this.option.center = n3;
        }, o.prototype.getLegendIcon = function(n3) {
          var p2 = n3.icon || "roundRect", m2 = Jy(p2, 0, 0, n3.itemWidth, n3.itemHeight, n3.itemStyle.fill);
          return m2.setStyle(n3.itemStyle), m2.style.stroke = "none", p2.indexOf("empty") > -1 && (m2.style.stroke = m2.style.fill, m2.style.fill = "#fff", m2.style.lineWidth = 2), m2;
        }, o.type = "series.map", o.dependencies = ["geo"], o.layoutMode = "box", o.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, o;
      }(Rv), f2n = c2n;
      function h2n(u, o) {
        var n3 = {};
        return Xe2(u, function(p2) {
          p2.each(p2.mapDimension("value"), function(m2, w2) {
            var T2 = "ec-" + p2.getName(w2);
            n3[T2] = n3[T2] || [], isNaN(m2) || n3[T2].push(m2);
          });
        }), u[0].map(u[0].mapDimension("value"), function(p2, m2) {
          for (var w2 = "ec-" + u[0].getName(m2), T2 = 0, E = 1 / 0, O2 = -1 / 0, V3 = n3[w2].length, W3 = 0; W3 < V3; W3++)
            E = Math.min(E, n3[w2][W3]), O2 = Math.max(O2, n3[w2][W3]), T2 += n3[w2][W3];
          var q3;
          return o === "min" ? q3 = E : o === "max" ? q3 = O2 : o === "average" ? q3 = T2 / V3 : q3 = T2, V3 === 0 ? NaN : q3;
        });
      }
      function p2n(u) {
        var o = {};
        u.eachSeriesByType("map", function(n3) {
          var p2 = n3.getHostGeoModel(), m2 = p2 ? "o" + p2.id : "i" + n3.getMapType();
          (o[m2] = o[m2] || []).push(n3);
        }), Xe2(o, function(n3, p2) {
          for (var m2 = h2n(Ya2(n3, function(T2) {
            return T2.getData();
          }), n3[0].get("mapValueCalculation")), w2 = 0; w2 < n3.length; w2++)
            n3[w2].originalData = n3[w2].getData();
          for (var w2 = 0; w2 < n3.length; w2++)
            n3[w2].seriesGroup = n3, n3[w2].needsDrawMap = w2 === 0 && !n3[w2].getHostGeoModel(), n3[w2].setData(m2.cloneShallow()), n3[w2].mainSeries = n3[0];
        });
      }
      function d2n(u) {
        var o = {};
        u.eachSeriesByType("map", function(n3) {
          var p2 = n3.getMapType();
          if (!(n3.getHostGeoModel() || o[p2])) {
            var m2 = {};
            Xe2(n3.seriesGroup, function(T2) {
              var E = T2.coordinateSystem, O2 = T2.originalData;
              T2.get("showLegendSymbol") && u.getComponent("legend") && O2.each(O2.mapDimension("value"), function(V3, W3) {
                var q3 = O2.getName(W3), K = E.getRegion(q3);
                if (!(!K || isNaN(V3))) {
                  var J = m2[q3] || 0, rt2 = E.dataToPoint(K.getCenter());
                  m2[q3] = J + 1, O2.setItemLayout(W3, { point: rt2, offset: J });
                }
              });
            });
            var w2 = n3.getData();
            w2.each(function(T2) {
              var E = w2.getName(T2), O2 = w2.getItemLayout(T2) || {};
              O2.showLabel = !m2[E], w2.setItemLayout(T2, O2);
            }), o[p2] = true;
          }
        });
      }
      var Qbe = Lm, g2n = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this) || this;
          return p2.type = "view", p2.dimensions = ["x", "y"], p2._roamTransformable = new JS(), p2._rawTransformable = new JS(), p2.name = n3, p2;
        }
        return o.prototype.setBoundingRect = function(n3, p2, m2, w2) {
          return this._rect = new Qu(n3, p2, m2, w2), this._rect;
        }, o.prototype.getBoundingRect = function() {
          return this._rect;
        }, o.prototype.setViewRect = function(n3, p2, m2, w2) {
          this._transformTo(n3, p2, m2, w2), this._viewRect = new Qu(n3, p2, m2, w2);
        }, o.prototype._transformTo = function(n3, p2, m2, w2) {
          var T2 = this.getBoundingRect(), E = this._rawTransformable;
          E.transform = T2.calculateTransform(new Qu(n3, p2, m2, w2));
          var O2 = E.parent;
          E.parent = null, E.decomposeTransform(), E.parent = O2, this._updateTransform();
        }, o.prototype.setCenter = function(n3) {
          !n3 || (this._center = n3, this._updateCenterAndZoom());
        }, o.prototype.setZoom = function(n3) {
          n3 = n3 || 1;
          var p2 = this.zoomLimit;
          p2 && (p2.max != null && (n3 = Math.min(p2.max, n3)), p2.min != null && (n3 = Math.max(p2.min, n3))), this._zoom = n3, this._updateCenterAndZoom();
        }, o.prototype.getDefaultCenter = function() {
          var n3 = this.getBoundingRect(), p2 = n3.x + n3.width / 2, m2 = n3.y + n3.height / 2;
          return [p2, m2];
        }, o.prototype.getCenter = function() {
          return this._center || this.getDefaultCenter();
        }, o.prototype.getZoom = function() {
          return this._zoom || 1;
        }, o.prototype.getRoamTransform = function() {
          return this._roamTransformable.getLocalTransform();
        }, o.prototype._updateCenterAndZoom = function() {
          var n3 = this._rawTransformable.getLocalTransform(), p2 = this._roamTransformable, m2 = this.getDefaultCenter(), w2 = this.getCenter(), T2 = this.getZoom();
          w2 = Lm([], w2, n3), m2 = Lm([], m2, n3), p2.originX = w2[0], p2.originY = w2[1], p2.x = m2[0] - w2[0], p2.y = m2[1] - w2[1], p2.scaleX = p2.scaleY = T2, this._updateTransform();
        }, o.prototype._updateTransform = function() {
          var n3 = this._roamTransformable, p2 = this._rawTransformable;
          p2.parent = n3, n3.updateTransform(), p2.updateTransform(), t$(this.transform || (this.transform = []), p2.transform || yw()), this._rawTransform = p2.getLocalTransform(), this.invTransform = this.invTransform || [], e4(this.invTransform, this.transform), this.decomposeTransform();
        }, o.prototype.getTransformInfo = function() {
          var n3 = this._rawTransformable, p2 = this._roamTransformable, m2 = new JS();
          return m2.transform = p2.transform, m2.decomposeTransform(), { roam: { x: m2.x, y: m2.y, scaleX: m2.scaleX, scaleY: m2.scaleY }, raw: { x: n3.x, y: n3.y, scaleX: n3.scaleX, scaleY: n3.scaleY } };
        }, o.prototype.getViewRect = function() {
          return this._viewRect;
        }, o.prototype.getViewRectAfterRoam = function() {
          var n3 = this.getBoundingRect().clone();
          return n3.applyTransform(this.transform), n3;
        }, o.prototype.dataToPoint = function(n3, p2, m2) {
          var w2 = p2 ? this._rawTransform : this.transform;
          return m2 = m2 || [], w2 ? Qbe(m2, n3, w2) : w0(m2, n3);
        }, o.prototype.pointToData = function(n3) {
          var p2 = this.invTransform;
          return p2 ? Qbe([], n3, p2) : [n3[0], n3[1]];
        }, o.prototype.convertToPixel = function(n3, p2, m2) {
          var w2 = Jbe(p2);
          return w2 === this ? w2.dataToPoint(m2) : null;
        }, o.prototype.convertFromPixel = function(n3, p2, m2) {
          var w2 = Jbe(p2);
          return w2 === this ? w2.pointToData(m2) : null;
        }, o.prototype.containPoint = function(n3) {
          return this.getViewRectAfterRoam().contain(n3[0], n3[1]);
        }, o.dimensions = ["x", "y"], o;
      }(JS);
      function Jbe(u) {
        var o = u.seriesModel;
        return o ? o.coordinateSystem : null;
      }
      var fst = g2n, v2n = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, t_e = ["lng", "lat"], e_e = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this, n3) || this;
          w2.dimensions = t_e, w2.type = "geo", w2._nameCoordMap = pl(), w2.map = p2;
          var T2 = m2.projection, E = E4.load(p2, m2.nameMap, m2.nameProperty), O2 = E4.getGeoResource(p2);
          w2.resourceType = O2 ? O2.type : null;
          var V3 = w2.regions = E.regions, W3 = v2n[O2.type];
          w2._regionsMap = E.regionsMap, w2.regions = E.regions, w2.projection = T2;
          var q3;
          if (T2)
            for (var K = 0; K < V3.length; K++) {
              var J = V3[K].getBoundingRect(T2);
              q3 = q3 || J.clone(), q3.union(J);
            }
          else
            q3 = E.boundingRect;
          return w2.setBoundingRect(q3.x, q3.y, q3.width, q3.height), w2.aspectScale = T2 ? 1 : Xu(m2.aspectScale, W3.aspectScale), w2._invertLongitute = T2 ? false : W3.invertLongitute, w2;
        }
        return o.prototype._transformTo = function(n3, p2, m2, w2) {
          var T2 = this.getBoundingRect(), E = this._invertLongitute;
          T2 = T2.clone(), E && (T2.y = -T2.y - T2.height);
          var O2 = this._rawTransformable;
          O2.transform = T2.calculateTransform(new Qu(n3, p2, m2, w2));
          var V3 = O2.parent;
          O2.parent = null, O2.decomposeTransform(), O2.parent = V3, E && (O2.scaleY = -O2.scaleY), this._updateTransform();
        }, o.prototype.getRegion = function(n3) {
          return this._regionsMap.get(n3);
        }, o.prototype.getRegionByCoord = function(n3) {
          for (var p2 = this.regions, m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2];
            if (w2.type === "geoJSON" && w2.contain(n3))
              return p2[m2];
          }
        }, o.prototype.addGeoCoord = function(n3, p2) {
          this._nameCoordMap.set(n3, p2);
        }, o.prototype.getGeoCoord = function(n3) {
          var p2 = this._regionsMap.get(n3);
          return this._nameCoordMap.get(n3) || p2 && p2.getCenter();
        }, o.prototype.dataToPoint = function(n3, p2, m2) {
          if (ds(n3) && (n3 = this.getGeoCoord(n3)), n3) {
            var w2 = this.projection;
            return w2 && (n3 = w2.project(n3)), n3 && this.projectedToPoint(n3);
          }
        }, o.prototype.pointToData = function(n3) {
          var p2 = this.projection;
          return p2 && (n3 = p2.unproject(n3)), n3 && this.pointToProjected(n3);
        }, o.prototype.pointToProjected = function(n3) {
          return u.prototype.pointToData.call(this, n3);
        }, o.prototype.projectedToPoint = function(n3, p2, m2) {
          return u.prototype.dataToPoint.call(this, n3, p2, m2);
        }, o.prototype.convertToPixel = function(n3, p2, m2) {
          var w2 = n_e(p2);
          return w2 === this ? w2.dataToPoint(m2) : null;
        }, o.prototype.convertFromPixel = function(n3, p2, m2) {
          var w2 = n_e(p2);
          return w2 === this ? w2.pointToData(m2) : null;
        }, o;
      }(fst);
      x0(e_e, fst);
      function n_e(u) {
        var o = u.geoModel, n3 = u.seriesModel;
        return o ? o.coordinateSystem : n3 ? n3.coordinateSystem || (n3.getReferringComponents("geo", Y0).models[0] || {}).coordinateSystem : null;
      }
      var r_e = e_e;
      function i_e(u, o) {
        var n3 = u.get("boundingCoords");
        if (n3 != null) {
          var p2 = n3[0], m2 = n3[1];
          if (isFinite(p2[0]) && isFinite(p2[1]) && isFinite(m2[0]) && isFinite(m2[1])) {
            var w2 = this.projection;
            if (w2) {
              var T2 = p2[0], E = p2[1], O2 = m2[0], V3 = m2[1];
              p2 = [1 / 0, 1 / 0], m2 = [-1 / 0, -1 / 0];
              var W3 = function(ie2, pe2, xe, Ce2) {
                for (var Le2 = xe - ie2, ze = Ce2 - pe2, tn = 0; tn <= 100; tn++) {
                  var $e2 = tn / 100, Tn = w2.project([ie2 + Le2 * $e2, pe2 + ze * $e2]);
                  HE(p2, p2, Tn), GA(m2, m2, Tn);
                }
              };
              W3(T2, E, O2, E), W3(O2, E, O2, V3), W3(O2, V3, T2, V3), W3(T2, V3, O2, E);
            }
            this.setBoundingRect(p2[0], p2[1], m2[0] - p2[0], m2[1] - p2[1]);
          }
        }
        var q3 = this.getBoundingRect(), K = u.get("layoutCenter"), J = u.get("layoutSize"), rt2 = o.getWidth(), gt = o.getHeight(), yt = q3.width / q3.height * this.aspectScale, At = false, Lt, Wt;
        K && J && (Lt = [Qo(K[0], rt2), Qo(K[1], gt)], Wt = Qo(J, Math.min(rt2, gt)), !isNaN(Lt[0]) && !isNaN(Lt[1]) && !isNaN(Wt) && (At = true));
        var Nt;
        if (At)
          Nt = {}, yt > 1 ? (Nt.width = Wt, Nt.height = Wt / yt) : (Nt.height = Wt, Nt.width = Wt * yt), Nt.y = Lt[1] - Nt.height / 2, Nt.x = Lt[0] - Nt.width / 2;
        else {
          var ue2 = u.getBoxLayoutParams();
          ue2.aspect = yt, Nt = Bm(ue2, { width: rt2, height: gt });
        }
        this.setViewRect(Nt.x, Nt.y, Nt.width, Nt.height), this.setCenter(u.get("center")), this.setZoom(u.get("zoom"));
      }
      function y2n(u, o) {
        Xe2(o.get("geoCoord"), function(n3, p2) {
          u.addGeoCoord(p2, n3);
        });
      }
      var m2n = function() {
        function u() {
          this.dimensions = t_e;
        }
        return u.prototype.create = function(o, n3) {
          var p2 = [];
          function m2(T2) {
            return { nameProperty: T2.get("nameProperty"), aspectScale: T2.get("aspectScale"), projection: T2.get("projection") };
          }
          o.eachComponent("geo", function(T2, E) {
            var O2 = T2.get("map"), V3 = new r_e(O2 + E, O2, ua2({ nameMap: T2.get("nameMap") }, m2(T2)));
            V3.zoomLimit = T2.get("scaleLimit"), p2.push(V3), T2.coordinateSystem = V3, V3.model = T2, V3.resize = i_e, V3.resize(T2, n3);
          }), o.eachSeries(function(T2) {
            var E = T2.get("coordinateSystem");
            if (E === "geo") {
              var O2 = T2.get("geoIndex") || 0;
              T2.coordinateSystem = p2[O2];
            }
          });
          var w2 = {};
          return o.eachSeriesByType("map", function(T2) {
            if (!T2.getHostGeoModel()) {
              var E = T2.getMapType();
              w2[E] = w2[E] || [], w2[E].push(T2);
            }
          }), Xe2(w2, function(T2, E) {
            var O2 = Ya2(T2, function(W3) {
              return W3.get("nameMap");
            }), V3 = new r_e(E, E, ua2({ nameMap: LZ(O2) }, m2(T2[0])));
            V3.zoomLimit = $y.apply(null, Ya2(T2, function(W3) {
              return W3.get("scaleLimit");
            })), p2.push(V3), V3.resize = i_e, V3.resize(T2[0], n3), Xe2(T2, function(W3) {
              W3.coordinateSystem = V3, y2n(V3, W3);
            });
          }), p2;
        }, u.prototype.getFilledRegions = function(o, n3, p2, m2) {
          for (var w2 = (o || []).slice(), T2 = pl(), E = 0; E < w2.length; E++)
            T2.set(w2[E].name, w2[E]);
          var O2 = E4.load(n3, p2, m2);
          return Xe2(O2.regions, function(V3) {
            var W3 = V3.name;
            !T2.get(W3) && w2.push({ name: W3 });
          }), w2;
        }, u;
      }(), b2n = new m2n(), a_e = b2n, _2n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          var w2 = E4.getGeoResource(n3.map);
          if (w2 && w2.type === "geoJSON") {
            var T2 = n3.itemStyle = n3.itemStyle || {};
            "color" in T2 || (T2.color = "#eee");
          }
          this.mergeDefaultAndTheme(n3, m2), t22(n3, "label", ["show"]);
        }, o.prototype.optionUpdated = function() {
          var n3 = this, p2 = this.option;
          p2.regions = a_e.getFilledRegions(p2.regions, p2.map, p2.nameMap, p2.nameProperty);
          var m2 = {};
          this._optionModelMap = jA(p2.regions || [], function(w2, T2) {
            var E = T2.name;
            return E && (w2.set(E, new _g(T2, n3, n3.ecModel)), T2.selected && (m2[E] = true)), w2;
          }, pl()), p2.selectedMap || (p2.selectedMap = m2);
        }, o.prototype.getRegionModel = function(n3) {
          return this._optionModelMap.get(n3) || new _g(null, this, this.ecModel);
        }, o.prototype.getFormattedLabel = function(n3, p2) {
          var m2 = this.getRegionModel(n3), w2 = p2 === "normal" ? m2.get(["label", "formatter"]) : m2.get(["emphasis", "label", "formatter"]), T2 = { name: n3 };
          if (Sl(w2))
            return T2.status = p2, w2(T2);
          if (ds(w2))
            return w2.replace("{a}", n3 != null ? n3 : "");
        }, o.prototype.setZoom = function(n3) {
          this.option.zoom = n3;
        }, o.prototype.setCenter = function(n3) {
          this.option.center = n3;
        }, o.prototype.select = function(n3) {
          var p2 = this.option, m2 = p2.selectedMode;
          if (m2) {
            m2 !== "multiple" && (p2.selectedMap = null);
            var w2 = p2.selectedMap || (p2.selectedMap = {});
            w2[n3] = true;
          }
        }, o.prototype.unSelect = function(n3) {
          var p2 = this.option.selectedMap;
          p2 && (p2[n3] = false);
        }, o.prototype.toggleSelected = function(n3) {
          this[this.isSelected(n3) ? "unSelect" : "select"](n3);
        }, o.prototype.isSelected = function(n3) {
          var p2 = this.option.selectedMap;
          return !!(p2 && p2[n3]);
        }, o.type = "geo", o.layoutMode = "box", o.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, o;
      }(kh2), x2n = _2n;
      function o_e(u, o) {
        return u.pointToProjected ? u.pointToProjected(o) : u.pointToData(o);
      }
      function J9t(u, o, n3) {
        var p2 = u.getZoom(), m2 = u.getCenter(), w2 = o.zoom, T2 = u.projectedToPoint ? u.projectedToPoint(m2) : u.dataToPoint(m2);
        if (o.dx != null && o.dy != null && (T2[0] -= o.dx, T2[1] -= o.dy, u.setCenter(o_e(u, T2))), w2 != null) {
          if (n3) {
            var E = n3.min || 0, O2 = n3.max || 1 / 0;
            w2 = Math.max(Math.min(p2 * w2, O2), E) / p2;
          }
          u.scaleX *= w2, u.scaleY *= w2;
          var V3 = (o.originX - u.x) * (w2 - 1), W3 = (o.originY - u.y) * (w2 - 1);
          u.x -= V3, u.y -= W3, u.updateTransform(), u.setCenter(o_e(u, T2)), u.setZoom(w2 * p2);
        }
        return { center: u.getCenter(), zoom: u.getZoom() };
      }
      var w2n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.focusBlurEnabled = true, n3;
        }
        return o.prototype.init = function(n3, p2) {
          this._api = p2;
        }, o.prototype.render = function(n3, p2, m2, w2) {
          if (this._model = n3, !n3.get("show")) {
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
            return;
          }
          this._mapDraw || (this._mapDraw = new Xbe(m2));
          var T2 = this._mapDraw;
          T2.draw(n3, p2, m2, this, w2), T2.group.on("click", this._handleRegionClick, this), T2.group.silent = n3.get("silent"), this.group.add(T2.group), this.updateSelectStatus(n3, p2, m2);
        }, o.prototype._handleRegionClick = function(n3) {
          var p2;
          iY(n3.target, function(m2) {
            return (p2 = is(m2).eventData) != null;
          }, true), p2 && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: p2.name });
        }, o.prototype.updateSelectStatus = function(n3, p2, m2) {
          var w2 = this;
          this._mapDraw.group.traverse(function(T2) {
            var E = is(T2).eventData;
            if (E)
              return w2._model.isSelected(E.name) ? m2.enterSelect(T2) : m2.leaveSelect(T2), true;
          });
        }, o.prototype.findHighDownDispatchers = function(n3) {
          return this._mapDraw && this._mapDraw.findHighDownDispatchers(n3, this._model);
        }, o.prototype.dispose = function() {
          this._mapDraw && this._mapDraw.remove();
        }, o.type = "geo", o;
      }(C0), S2n = w2n;
      function M2n(u, o, n3) {
        E4.registerMap(u, o, n3);
      }
      function s_e(u) {
        u.registerCoordinateSystem("geo", a_e), u.registerComponentModel(x2n), u.registerComponentView(S2n), u.registerImpl("registerMap", M2n), u.registerImpl("getMap", function(n3) {
          return E4.getMapForUser(n3);
        });
        function o(n3, p2) {
          p2.update = "geo:updateSelectStatus", u.registerAction(p2, function(m2, w2) {
            var T2 = {}, E = [];
            return w2.eachComponent({ mainType: "geo", query: m2 }, function(O2) {
              O2[n3](m2.name);
              var V3 = O2.coordinateSystem;
              Xe2(V3.regions, function(q3) {
                T2[q3.name] = O2.isSelected(q3.name) || false;
              });
              var W3 = [];
              Xe2(T2, function(q3, K) {
                T2[K] && W3.push(K);
              }), E.push({ geoIndex: O2.componentIndex, name: W3 });
            }), { selected: T2, allSelected: E, name: m2.name };
          });
        }
        o("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), o("select", { type: "geoSelect", event: "geoselected" }), o("unSelect", { type: "geoUnSelect", event: "geounselected" }), u.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(n3, p2) {
          var m2 = n3.componentType || "series";
          p2.eachComponent({ mainType: m2, query: n3 }, function(w2) {
            var T2 = w2.coordinateSystem;
            if (T2.type === "geo") {
              var E = J9t(T2, n3, w2.get("scaleLimit"));
              w2.setCenter && w2.setCenter(E.center), w2.setZoom && w2.setZoom(E.zoom), m2 === "series" && Xe2(w2.seriesGroup, function(O2) {
                O2.setCenter(E.center), O2.setZoom(E.zoom);
              });
            }
          });
        });
      }
      function C2n(u) {
        Rc2(s_e), u.registerChartView(u2n), u.registerSeriesModel(f2n), u.registerLayout(d2n), u.registerProcessor(u.PRIORITY.PROCESSOR.STATISTIC, p2n), uye("map", u.registerAction);
      }
      function T2n(u) {
        var o = u;
        o.hierNode = { defaultAncestor: null, ancestor: o, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
        for (var n3 = [o], p2, m2; p2 = n3.pop(); )
          if (m2 = p2.children, p2.isExpand && m2.length)
            for (var w2 = m2.length, T2 = w2 - 1; T2 >= 0; T2--) {
              var E = m2[T2];
              E.hierNode = { defaultAncestor: null, ancestor: E, prelim: 0, modifier: 0, change: 0, shift: 0, i: T2, thread: null }, n3.push(E);
            }
      }
      function A2n(u, o) {
        var n3 = u.isExpand ? u.children : [], p2 = u.parentNode.children, m2 = u.hierNode.i ? p2[u.hierNode.i - 1] : null;
        if (n3.length) {
          E2n(u);
          var w2 = (n3[0].hierNode.prelim + n3[n3.length - 1].hierNode.prelim) / 2;
          m2 ? (u.hierNode.prelim = m2.hierNode.prelim + o(u, m2), u.hierNode.modifier = u.hierNode.prelim - w2) : u.hierNode.prelim = w2;
        } else
          m2 && (u.hierNode.prelim = m2.hierNode.prelim + o(u, m2));
        u.parentNode.hierNode.defaultAncestor = k2n(u, m2, u.parentNode.hierNode.defaultAncestor || p2[0], o);
      }
      function I2n(u) {
        var o = u.hierNode.prelim + u.parentNode.hierNode.modifier;
        u.setLayout({ x: o }, true), u.hierNode.modifier += u.parentNode.hierNode.modifier;
      }
      function l_e(u) {
        return arguments.length ? u : O2n;
      }
      function hst(u, o) {
        return u -= Math.PI / 2, { x: o * Math.cos(u), y: o * Math.sin(u) };
      }
      function D2n(u, o) {
        return Bm(u.getBoxLayoutParams(), { width: o.getWidth(), height: o.getHeight() });
      }
      function E2n(u) {
        for (var o = u.children, n3 = o.length, p2 = 0, m2 = 0; --n3 >= 0; ) {
          var w2 = o[n3];
          w2.hierNode.prelim += p2, w2.hierNode.modifier += p2, m2 += w2.hierNode.change, p2 += w2.hierNode.shift + m2;
        }
      }
      function k2n(u, o, n3, p2) {
        if (o) {
          for (var m2 = u, w2 = u, T2 = w2.parentNode.children[0], E = o, O2 = m2.hierNode.modifier, V3 = w2.hierNode.modifier, W3 = T2.hierNode.modifier, q3 = E.hierNode.modifier; E = t7t(E), w2 = e7t(w2), E && w2; ) {
            m2 = t7t(m2), T2 = e7t(T2), m2.hierNode.ancestor = u;
            var K = E.hierNode.prelim + q3 - w2.hierNode.prelim - V3 + p2(E, w2);
            K > 0 && (L2n(P2n(E, u, n3), u, K), V3 += K, O2 += K), q3 += E.hierNode.modifier, V3 += w2.hierNode.modifier, O2 += m2.hierNode.modifier, W3 += T2.hierNode.modifier;
          }
          E && !t7t(m2) && (m2.hierNode.thread = E, m2.hierNode.modifier += q3 - O2), w2 && !e7t(T2) && (T2.hierNode.thread = w2, T2.hierNode.modifier += V3 - W3, n3 = u);
        }
        return n3;
      }
      function t7t(u) {
        var o = u.children;
        return o.length && u.isExpand ? o[o.length - 1] : u.hierNode.thread;
      }
      function e7t(u) {
        var o = u.children;
        return o.length && u.isExpand ? o[0] : u.hierNode.thread;
      }
      function P2n(u, o, n3) {
        return u.hierNode.ancestor.parentNode === o.parentNode ? u.hierNode.ancestor : n3;
      }
      function L2n(u, o, n3) {
        var p2 = n3 / (o.hierNode.i - u.hierNode.i);
        o.hierNode.change -= p2, o.hierNode.shift += n3, o.hierNode.modifier += n3, o.hierNode.prelim += n3, u.hierNode.change += p2;
      }
      function O2n(u, o) {
        return u.parentNode === o.parentNode ? 1 : 2;
      }
      var R2n = function() {
        function u() {
          this.parentPoint = [], this.childPoints = [];
        }
        return u;
      }(), N2n = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new R2n();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.childPoints, w2 = m2.length, T2 = p2.parentPoint, E = m2[0], O2 = m2[w2 - 1];
          if (w2 === 1) {
            n3.moveTo(T2[0], T2[1]), n3.lineTo(E[0], E[1]);
            return;
          }
          var V3 = p2.orient, W3 = V3 === "TB" || V3 === "BT" ? 0 : 1, q3 = 1 - W3, K = Qo(p2.forkPosition, 1), J = [];
          J[W3] = T2[W3], J[q3] = T2[q3] + (O2[q3] - T2[q3]) * K, n3.moveTo(T2[0], T2[1]), n3.lineTo(J[0], J[1]), n3.moveTo(E[0], E[1]), J[W3] = E[W3], n3.lineTo(J[0], J[1]), J[W3] = O2[W3], n3.lineTo(J[0], J[1]), n3.lineTo(O2[0], O2[1]);
          for (var rt2 = 1; rt2 < w2 - 1; rt2++) {
            var gt = m2[rt2];
            n3.moveTo(gt[0], gt[1]), J[W3] = gt[W3], n3.lineTo(J[0], J[1]);
          }
        }, o;
      }(Mc2), F2n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._mainGroup = new uu(), n3;
        }
        return o.prototype.init = function(n3, p2) {
          this._controller = new ust(p2.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
        }, o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = n3.layoutInfo, E = this._mainGroup, O2 = n3.get("layout");
          O2 === "radial" ? (E.x = T2.x + T2.width / 2, E.y = T2.y + T2.height / 2) : (E.x = T2.x, E.y = T2.y), this._updateViewCoordSys(n3), this._updateController(n3, p2, m2);
          var V3 = this._data;
          w2.diff(V3).add(function(W3) {
            u_e(w2, W3) && c_e(w2, W3, null, E, n3);
          }).update(function(W3, q3) {
            var K = V3.getItemGraphicEl(q3);
            if (!u_e(w2, W3)) {
              K && p_e(V3, q3, K, E, n3);
              return;
            }
            c_e(w2, W3, K, E, n3);
          }).remove(function(W3) {
            var q3 = V3.getItemGraphicEl(W3);
            q3 && p_e(V3, W3, q3, E, n3);
          }).execute(), this._nodeScaleRatio = n3.get("nodeScaleRatio"), this._updateNodeAndLinkScale(n3), n3.get("expandAndCollapse") === true && w2.eachItemGraphicEl(function(W3, q3) {
            W3.off("click").on("click", function() {
              m2.dispatchAction({ type: "treeExpandAndCollapse", seriesId: n3.id, dataIndex: q3 });
            });
          }), this._data = w2;
        }, o.prototype._updateViewCoordSys = function(n3) {
          var p2 = n3.getData(), m2 = [];
          p2.each(function(W3) {
            var q3 = p2.getItemLayout(W3);
            q3 && !isNaN(q3.x) && !isNaN(q3.y) && m2.push([+q3.x, +q3.y]);
          });
          var w2 = [], T2 = [];
          w$(m2, w2, T2);
          var E = this._min, O2 = this._max;
          T2[0] - w2[0] === 0 && (w2[0] = E ? E[0] : w2[0] - 1, T2[0] = O2 ? O2[0] : T2[0] + 1), T2[1] - w2[1] === 0 && (w2[1] = E ? E[1] : w2[1] - 1, T2[1] = O2 ? O2[1] : T2[1] + 1);
          var V3 = n3.coordinateSystem = new fst();
          V3.zoomLimit = n3.get("scaleLimit"), V3.setBoundingRect(w2[0], w2[1], T2[0] - w2[0], T2[1] - w2[1]), V3.setCenter(n3.get("center")), V3.setZoom(n3.get("zoom")), this.group.attr({ x: V3.x, y: V3.y, scaleX: V3.scaleX, scaleY: V3.scaleY }), this._min = w2, this._max = T2;
        }, o.prototype._updateController = function(n3, p2, m2) {
          var w2 = this, T2 = this._controller, E = this._controllerHost, O2 = this.group;
          T2.setPointerChecker(function(V3, W3, q3) {
            var K = O2.getBoundingRect();
            return K.applyTransform(O2.transform), K.contain(W3, q3) && !Oxt(V3, m2, n3);
          }), T2.enable(n3.get("roam")), E.zoomLimit = n3.get("scaleLimit"), E.zoom = n3.coordinateSystem.getZoom(), T2.off("pan").off("zoom").on("pan", function(V3) {
            Z9t(E, V3.dx, V3.dy), m2.dispatchAction({ seriesId: n3.id, type: "treeRoam", dx: V3.dx, dy: V3.dy });
          }).on("zoom", function(V3) {
            $9t(E, V3.scale, V3.originX, V3.originY), m2.dispatchAction({ seriesId: n3.id, type: "treeRoam", zoom: V3.scale, originX: V3.originX, originY: V3.originY }), w2._updateNodeAndLinkScale(n3), m2.updateLabelLayout();
          });
        }, o.prototype._updateNodeAndLinkScale = function(n3) {
          var p2 = n3.getData(), m2 = this._getNodeGlobalScale(n3);
          p2.eachItemGraphicEl(function(w2, T2) {
            w2.setSymbolScale(m2);
          });
        }, o.prototype._getNodeGlobalScale = function(n3) {
          var p2 = n3.coordinateSystem;
          if (p2.type !== "view")
            return 1;
          var m2 = this._nodeScaleRatio, w2 = p2.scaleX || 1, T2 = p2.getZoom(), E = (T2 - 1) * m2 + 1;
          return E / w2;
        }, o.prototype.dispose = function() {
          this._controller && this._controller.dispose(), this._controllerHost = null;
        }, o.prototype.remove = function() {
          this._mainGroup.removeAll(), this._data = null;
        }, o.type = "tree", o;
      }(xg2);
      function u_e(u, o) {
        var n3 = u.getItemLayout(o);
        return n3 && !isNaN(n3.x) && !isNaN(n3.y);
      }
      function c_e(u, o, n3, p2, m2) {
        var w2 = !n3, T2 = u.tree.getNodeByDataIndex(o), E = T2.getModel(), O2 = T2.getVisual("style").fill, V3 = T2.isExpand === false && T2.children.length !== 0 ? O2 : "#fff", W3 = u.tree.root, q3 = T2.parentNode === W3 ? T2 : T2.parentNode || T2, K = u.getItemGraphicEl(q3.dataIndex), J = q3.getLayout(), rt2 = K ? { x: K.__oldX, y: K.__oldY, rawX: K.__radialOldRawX, rawY: K.__radialOldRawY } : J, gt = T2.getLayout();
        w2 ? (n3 = new nst(u, o, null, { symbolInnerColor: V3, useNameLabel: true }), n3.x = rt2.x, n3.y = rt2.y) : n3.updateData(u, o, null, { symbolInnerColor: V3, useNameLabel: true }), n3.__radialOldRawX = n3.__radialRawX, n3.__radialOldRawY = n3.__radialRawY, n3.__radialRawX = gt.rawX, n3.__radialRawY = gt.rawY, p2.add(n3), u.setItemGraphicEl(o, n3), n3.__oldX = n3.x, n3.__oldY = n3.y, Xf2(n3, { x: gt.x, y: gt.y }, m2);
        var yt = n3.getSymbolPath();
        if (m2.get("layout") === "radial") {
          var At = W3.children[0], Lt = At.getLayout(), Wt = At.children.length, Nt = void 0, ue2 = void 0;
          if (gt.x === Lt.x && T2.isExpand === true) {
            var ie2 = { x: (At.children[0].getLayout().x + At.children[Wt - 1].getLayout().x) / 2, y: (At.children[0].getLayout().y + At.children[Wt - 1].getLayout().y) / 2 };
            Nt = Math.atan2(ie2.y - Lt.y, ie2.x - Lt.x), Nt < 0 && (Nt = Math.PI * 2 + Nt), ue2 = ie2.x < Lt.x, ue2 && (Nt = Nt - Math.PI);
          } else
            Nt = Math.atan2(gt.y - Lt.y, gt.x - Lt.x), Nt < 0 && (Nt = Math.PI * 2 + Nt), T2.children.length === 0 || T2.children.length !== 0 && T2.isExpand === false ? (ue2 = gt.x < Lt.x, ue2 && (Nt = Nt - Math.PI)) : (ue2 = gt.x > Lt.x, ue2 || (Nt = Nt - Math.PI));
          var pe2 = ue2 ? "left" : "right", xe = E.getModel("label"), Ce2 = xe.get("rotate"), Le2 = Ce2 * (Math.PI / 180), ze = yt.getTextContent();
          ze && (yt.setTextConfig({ position: xe.get("position") || pe2, rotation: Ce2 == null ? -Nt : Le2, origin: "center" }), ze.setStyle("verticalAlign", "middle"));
        }
        var tn = E.get(["emphasis", "focus"]), $e2 = tn === "ancestor" ? T2.getAncestorsIndices() : tn === "descendant" ? T2.getDescendantIndices() : null;
        $e2 && (is(n3).focus = $e2), V2n(m2, T2, W3, n3, rt2, J, gt, p2), n3.__edge && (n3.onHoverStateChange = function(Tn) {
          if (Tn !== "blur") {
            var zn = T2.parentNode && u.getItemGraphicEl(T2.parentNode.dataIndex);
            zn && zn.hoverState === vz || v42(n3.__edge, Tn);
          }
        });
      }
      function V2n(u, o, n3, p2, m2, w2, T2, E) {
        var O2 = o.getModel(), V3 = u.get("edgeShape"), W3 = u.get("layout"), q3 = u.getOrient(), K = u.get(["lineStyle", "curveness"]), J = u.get("edgeForkPosition"), rt2 = O2.getModel("lineStyle").getLineStyle(), gt = p2.__edge;
        if (V3 === "curve")
          o.parentNode && o.parentNode !== n3 && (gt || (gt = p2.__edge = new JF({ shape: n7t(W3, q3, K, m2, m2) })), Xf2(gt, { shape: n7t(W3, q3, K, w2, T2) }, u));
        else if (V3 === "polyline" && W3 === "orthogonal" && o !== n3 && o.children && o.children.length !== 0 && o.isExpand === true) {
          for (var yt = o.children, At = [], Lt = 0; Lt < yt.length; Lt++) {
            var Wt = yt[Lt].getLayout();
            At.push([Wt.x, Wt.y]);
          }
          gt || (gt = p2.__edge = new N2n({ shape: { parentPoint: [T2.x, T2.y], childPoints: [[T2.x, T2.y]], orient: q3, forkPosition: J } })), Xf2(gt, { shape: { parentPoint: [T2.x, T2.y], childPoints: At } }, u);
        }
        gt && (gt.useStyle(kl({ strokeNoScale: true, fill: null }, rt2)), Ky(gt, O2, "lineStyle"), y4(gt), E.add(gt));
      }
      function f_e(u, o, n3, p2, m2) {
        var w2 = o.tree.root, T2 = h_e(w2, u), E = T2.source, O2 = T2.sourceLayout, V3 = o.getItemGraphicEl(u.dataIndex);
        if (V3) {
          var W3 = o.getItemGraphicEl(E.dataIndex), q3 = W3.__edge, K = V3.__edge || (E.isExpand === false || E.children.length === 1 ? q3 : void 0), J = p2.get("edgeShape"), rt2 = p2.get("layout"), gt = p2.get("orient"), yt = p2.get(["lineStyle", "curveness"]);
          K && (J === "curve" ? HP(K, { shape: n7t(rt2, gt, yt, O2, O2), style: { opacity: 0 } }, p2, { cb: function() {
            n3.remove(K);
          }, removeOpt: m2 }) : J === "polyline" && p2.get("layout") === "orthogonal" && HP(K, { shape: { parentPoint: [O2.x, O2.y], childPoints: [[O2.x, O2.y]] }, style: { opacity: 0 } }, p2, { cb: function() {
            n3.remove(K);
          }, removeOpt: m2 }));
        }
      }
      function h_e(u, o) {
        for (var n3 = o.parentNode === u ? o : o.parentNode || o, p2; p2 = n3.getLayout(), p2 == null; )
          n3 = n3.parentNode === u ? n3 : n3.parentNode || n3;
        return { source: n3, sourceLayout: p2 };
      }
      function p_e(u, o, n3, p2, m2) {
        var w2 = u.tree.getNodeByDataIndex(o), T2 = u.tree.root, E = h_e(T2, w2).sourceLayout, O2 = { duration: m2.get("animationDurationUpdate"), easing: m2.get("animationEasingUpdate") };
        HP(n3, { x: E.x + 1, y: E.y + 1 }, m2, { cb: function() {
          p2.remove(n3), u.setItemGraphicEl(o, null);
        }, removeOpt: O2 }), n3.fadeOut(null, u.hostModel, { fadeLabel: true, animation: O2 }), w2.children.forEach(function(V3) {
          f_e(V3, u, p2, m2, O2);
        }), f_e(w2, u, p2, m2, O2);
      }
      function n7t(u, o, n3, p2, m2) {
        var w2, T2, E, O2, V3, W3, q3, K;
        if (u === "radial") {
          V3 = p2.rawX, q3 = p2.rawY, W3 = m2.rawX, K = m2.rawY;
          var J = hst(V3, q3), rt2 = hst(V3, q3 + (K - q3) * n3), gt = hst(W3, K + (q3 - K) * n3), yt = hst(W3, K);
          return { x1: J.x || 0, y1: J.y || 0, x2: yt.x || 0, y2: yt.y || 0, cpx1: rt2.x || 0, cpy1: rt2.y || 0, cpx2: gt.x || 0, cpy2: gt.y || 0 };
        } else
          V3 = p2.x, q3 = p2.y, W3 = m2.x, K = m2.y, (o === "LR" || o === "RL") && (w2 = V3 + (W3 - V3) * n3, T2 = q3, E = W3 + (V3 - W3) * n3, O2 = K), (o === "TB" || o === "BT") && (w2 = V3, T2 = q3 + (K - q3) * n3, E = W3, O2 = K + (q3 - K) * n3);
        return { x1: V3, y1: q3, x2: W3, y2: K, cpx1: w2, cpy1: T2, cpx2: E, cpy2: O2 };
      }
      var B2n = F2n, mI = Ff2();
      function d_e(u) {
        var o = u.mainData, n3 = u.datas;
        n3 || (n3 = { main: o }, u.datasAttr = { main: "data" }), u.datas = u.mainData = null, g_e(o, n3, u), Xe2(n3, function(p2) {
          Xe2(o.TRANSFERABLE_METHODS, function(m2) {
            p2.wrapMethod(m2, wu(z2n, u));
          });
        }), o.wrapMethod("cloneShallow", wu(W2n, u)), Xe2(o.CHANGABLE_METHODS, function(p2) {
          o.wrapMethod(p2, wu(j2n, u));
        }), Tb2(n3[o.dataType] === o);
      }
      function z2n(u, o) {
        if (U2n(this)) {
          var n3 = ua2({}, mI(this).datas);
          n3[this.dataType] = o, g_e(o, n3, u);
        } else
          r7t(o, this.dataType, mI(this).mainData, u);
        return o;
      }
      function j2n(u, o) {
        return u.struct && u.struct.update(), o;
      }
      function W2n(u, o) {
        return Xe2(mI(o).datas, function(n3, p2) {
          n3 !== o && r7t(n3.cloneShallow(), p2, o, u);
        }), o;
      }
      function G2n(u) {
        var o = mI(this).mainData;
        return u == null || o == null ? o : mI(o).datas[u];
      }
      function H2n() {
        var u = mI(this).mainData;
        return u == null ? [{ data: u }] : Ya2(tf2(mI(u).datas), function(o) {
          return { type: o, data: mI(u).datas[o] };
        });
      }
      function U2n(u) {
        return mI(u).mainData === u;
      }
      function g_e(u, o, n3) {
        mI(u).datas = {}, Xe2(o, function(p2, m2) {
          r7t(p2, m2, u, n3);
        });
      }
      function r7t(u, o, n3, p2) {
        mI(n3).datas[o] = u, mI(u).mainData = n3, u.dataType = o, p2.struct && (u[p2.structAttr] = p2.struct, p2.struct[p2.datasAttr[o]] = u), u.getLinkedData = G2n, u.getLinkedDataAll = H2n;
      }
      var q2n = function() {
        function u(o, n3) {
          this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = o || "", this.hostTree = n3;
        }
        return u.prototype.isRemoved = function() {
          return this.dataIndex < 0;
        }, u.prototype.eachNode = function(o, n3, p2) {
          Sl(o) && (p2 = n3, n3 = o, o = null), o = o || {}, ds(o) && (o = { order: o });
          var m2 = o.order || "preorder", w2 = this[o.attr || "children"], T2;
          m2 === "preorder" && (T2 = n3.call(p2, this));
          for (var E = 0; !T2 && E < w2.length; E++)
            w2[E].eachNode(o, n3, p2);
          m2 === "postorder" && n3.call(p2, this);
        }, u.prototype.updateDepthAndHeight = function(o) {
          var n3 = 0;
          this.depth = o;
          for (var p2 = 0; p2 < this.children.length; p2++) {
            var m2 = this.children[p2];
            m2.updateDepthAndHeight(o + 1), m2.height > n3 && (n3 = m2.height);
          }
          this.height = n3 + 1;
        }, u.prototype.getNodeById = function(o) {
          if (this.getId() === o)
            return this;
          for (var n3 = 0, p2 = this.children, m2 = p2.length; n3 < m2; n3++) {
            var w2 = p2[n3].getNodeById(o);
            if (w2)
              return w2;
          }
        }, u.prototype.contains = function(o) {
          if (o === this)
            return true;
          for (var n3 = 0, p2 = this.children, m2 = p2.length; n3 < m2; n3++) {
            var w2 = p2[n3].contains(o);
            if (w2)
              return w2;
          }
        }, u.prototype.getAncestors = function(o) {
          for (var n3 = [], p2 = o ? this : this.parentNode; p2; )
            n3.push(p2), p2 = p2.parentNode;
          return n3.reverse(), n3;
        }, u.prototype.getAncestorsIndices = function() {
          for (var o = [], n3 = this; n3; )
            o.push(n3.dataIndex), n3 = n3.parentNode;
          return o.reverse(), o;
        }, u.prototype.getDescendantIndices = function() {
          var o = [];
          return this.eachNode(function(n3) {
            o.push(n3.dataIndex);
          }), o;
        }, u.prototype.getValue = function(o) {
          var n3 = this.hostTree.data;
          return n3.getStore().get(n3.getDimensionIndex(o || "value"), this.dataIndex);
        }, u.prototype.setLayout = function(o, n3) {
          this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, o, n3);
        }, u.prototype.getLayout = function() {
          return this.hostTree.data.getItemLayout(this.dataIndex);
        }, u.prototype.getModel = function(o) {
          if (!(this.dataIndex < 0)) {
            var n3 = this.hostTree, p2 = n3.data.getItemModel(this.dataIndex);
            return p2.getModel(o);
          }
        }, u.prototype.getLevelModel = function() {
          return (this.hostTree.levelModels || [])[this.depth];
        }, u.prototype.setVisual = function(o, n3) {
          this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, o, n3);
        }, u.prototype.getVisual = function(o) {
          return this.hostTree.data.getItemVisual(this.dataIndex, o);
        }, u.prototype.getRawIndex = function() {
          return this.hostTree.data.getRawIndex(this.dataIndex);
        }, u.prototype.getId = function() {
          return this.hostTree.data.getId(this.dataIndex);
        }, u.prototype.getChildIndex = function() {
          if (this.parentNode) {
            for (var o = this.parentNode.children, n3 = 0; n3 < o.length; ++n3)
              if (o[n3] === this)
                return n3;
            return -1;
          }
          return -1;
        }, u.prototype.isAncestorOf = function(o) {
          for (var n3 = o.parentNode; n3; ) {
            if (n3 === this)
              return true;
            n3 = n3.parentNode;
          }
          return false;
        }, u.prototype.isDescendantOf = function(o) {
          return o !== this && o.isAncestorOf(this);
        }, u;
      }(), Z2n = function() {
        function u(o) {
          this.type = "tree", this._nodes = [], this.hostModel = o;
        }
        return u.prototype.eachNode = function(o, n3, p2) {
          this.root.eachNode(o, n3, p2);
        }, u.prototype.getNodeByDataIndex = function(o) {
          var n3 = this.data.getRawIndex(o);
          return this._nodes[n3];
        }, u.prototype.getNodeById = function(o) {
          return this.root.getNodeById(o);
        }, u.prototype.update = function() {
          for (var o = this.data, n3 = this._nodes, p2 = 0, m2 = n3.length; p2 < m2; p2++)
            n3[p2].dataIndex = -1;
          for (var p2 = 0, m2 = o.count(); p2 < m2; p2++)
            n3[o.getRawIndex(p2)].dataIndex = p2;
        }, u.prototype.clearLayouts = function() {
          this.data.clearItemLayouts();
        }, u.createTree = function(o, n3, p2) {
          var m2 = new u(n3), w2 = [], T2 = 1;
          E(o);
          function E(W3, q3) {
            var K = W3.value;
            T2 = Math.max(T2, za2(K) ? K.length : 1), w2.push(W3);
            var J = new q2n($d2(W3.name, ""), m2);
            q3 ? $2n(J, q3) : m2.root = J, m2._nodes.push(J);
            var rt2 = W3.children;
            if (rt2)
              for (var gt = 0; gt < rt2.length; gt++)
                E(rt2[gt], J);
          }
          m2.root.updateDepthAndHeight(0);
          var O2 = qot(w2, { coordDimensions: ["value"], dimensionsCount: T2 }).dimensions, V3 = new o2(O2, n3);
          return V3.initData(w2), p2 && p2(V3), d_e({ mainData: V3, struct: m2, structAttr: "tree" }), m2.update(), m2;
        }, u;
      }();
      function $2n(u, o) {
        var n3 = o.children;
        u.parentNode !== o && (n3.push(u), u.parentNode = o);
      }
      var i7t = Z2n;
      function pst(u, o, n3) {
        if (u && sc2(o, u.type) >= 0) {
          var p2 = n3.getData().tree.root, m2 = u.targetNode;
          if (ds(m2) && (m2 = p2.getNodeById(m2)), m2 && p2.contains(m2))
            return { node: m2 };
          var w2 = u.targetNodeId;
          if (w2 != null && (m2 = p2.getNodeById(w2)))
            return { node: m2 };
        }
      }
      function v_e(u) {
        for (var o = []; u; )
          u = u.parentNode, u && o.push(u);
        return o.reverse();
      }
      function a7t(u, o) {
        var n3 = v_e(u);
        return sc2(n3, o) >= 0;
      }
      function Bxt(u, o) {
        for (var n3 = []; u; ) {
          var p2 = u.dataIndex;
          n3.push({ name: u.name, dataIndex: p2, value: o.getRawValue(p2) }), u = u.parentNode;
        }
        return n3.reverse(), n3;
      }
      var Y2n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.hasSymbolVisual = true, n3.ignoreStyleOnData = true, n3;
        }
        return o.prototype.getInitialData = function(n3) {
          var p2 = { name: n3.name, children: n3.data }, m2 = n3.leaves || {}, w2 = new _g(m2, this, this.ecModel), T2 = i7t.createTree(p2, this, E);
          function E(q3) {
            q3.wrapMethod("getItemModel", function(K, J) {
              var rt2 = T2.getNodeByDataIndex(J);
              return rt2 && rt2.children.length && rt2.isExpand || (K.parentModel = w2), K;
            });
          }
          var O2 = 0;
          T2.eachNode("preorder", function(q3) {
            q3.depth > O2 && (O2 = q3.depth);
          });
          var V3 = n3.expandAndCollapse, W3 = V3 && n3.initialTreeDepth >= 0 ? n3.initialTreeDepth : O2;
          return T2.root.eachNode("preorder", function(q3) {
            var K = q3.hostTree.data.getRawDataItem(q3.dataIndex);
            q3.isExpand = K && K.collapsed != null ? !K.collapsed : q3.depth <= W3;
          }), T2.data;
        }, o.prototype.getOrient = function() {
          var n3 = this.get("orient");
          return n3 === "horizontal" ? n3 = "LR" : n3 === "vertical" && (n3 = "TB"), n3;
        }, o.prototype.setZoom = function(n3) {
          this.option.zoom = n3;
        }, o.prototype.setCenter = function(n3) {
          this.option.center = n3;
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          for (var w2 = this.getData().tree, T2 = w2.root.children[0], E = w2.getNodeByDataIndex(n3), O2 = E.getValue(), V3 = E.name; E && E !== T2; )
            V3 = E.parentNode.name + "." + V3, E = E.parentNode;
          return k1("nameValue", { name: V3, value: O2, noValue: isNaN(O2) || O2 == null });
        }, o.prototype.getDataParams = function(n3) {
          var p2 = u.prototype.getDataParams.apply(this, arguments), m2 = this.getData().tree.getNodeByDataIndex(n3);
          return p2.treeAncestors = Bxt(m2, this), p2;
        }, o.type = "series.tree", o.layoutMode = "box", o.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, o;
      }(Rv), K2n = Y2n;
      function X2n(u, o, n3) {
        for (var p2 = [u], m2 = [], w2; w2 = p2.pop(); )
          if (m2.push(w2), w2.isExpand) {
            var T2 = w2.children;
            if (T2.length)
              for (var E = 0; E < T2.length; E++)
                p2.push(T2[E]);
          }
        for (; w2 = m2.pop(); )
          o(w2, n3);
      }
      function dst(u, o) {
        for (var n3 = [u], p2; p2 = n3.pop(); )
          if (o(p2), p2.isExpand) {
            var m2 = p2.children;
            if (m2.length)
              for (var w2 = m2.length - 1; w2 >= 0; w2--)
                n3.push(m2[w2]);
          }
      }
      function Q2n(u, o) {
        u.eachSeriesByType("tree", function(n3) {
          J2n(n3, o);
        });
      }
      function J2n(u, o) {
        var n3 = D2n(u, o);
        u.layoutInfo = n3;
        var p2 = u.get("layout"), m2 = 0, w2 = 0, T2 = null;
        p2 === "radial" ? (m2 = 2 * Math.PI, w2 = Math.min(n3.height, n3.width) / 2, T2 = l_e(function(Wt, Nt) {
          return (Wt.parentNode === Nt.parentNode ? 1 : 2) / Wt.depth;
        })) : (m2 = n3.width, w2 = n3.height, T2 = l_e());
        var E = u.getData().tree.root, O2 = E.children[0];
        if (O2) {
          T2n(E), X2n(O2, A2n, T2), E.hierNode.modifier = -O2.hierNode.prelim, dst(O2, I2n);
          var V3 = O2, W3 = O2, q3 = O2;
          dst(O2, function(Wt) {
            var Nt = Wt.getLayout().x;
            Nt < V3.getLayout().x && (V3 = Wt), Nt > W3.getLayout().x && (W3 = Wt), Wt.depth > q3.depth && (q3 = Wt);
          });
          var K = V3 === W3 ? 1 : T2(V3, W3) / 2, J = K - V3.getLayout().x, rt2 = 0, gt = 0, yt = 0, At = 0;
          if (p2 === "radial")
            rt2 = m2 / (W3.getLayout().x + K + J), gt = w2 / (q3.depth - 1 || 1), dst(O2, function(Wt) {
              yt = (Wt.getLayout().x + J) * rt2, At = (Wt.depth - 1) * gt;
              var Nt = hst(yt, At);
              Wt.setLayout({ x: Nt.x, y: Nt.y, rawX: yt, rawY: At }, true);
            });
          else {
            var Lt = u.getOrient();
            Lt === "RL" || Lt === "LR" ? (gt = w2 / (W3.getLayout().x + K + J), rt2 = m2 / (q3.depth - 1 || 1), dst(O2, function(Wt) {
              At = (Wt.getLayout().x + J) * gt, yt = Lt === "LR" ? (Wt.depth - 1) * rt2 : m2 - (Wt.depth - 1) * rt2, Wt.setLayout({ x: yt, y: At }, true);
            })) : (Lt === "TB" || Lt === "BT") && (rt2 = m2 / (W3.getLayout().x + K + J), gt = w2 / (q3.depth - 1 || 1), dst(O2, function(Wt) {
              yt = (Wt.getLayout().x + J) * rt2, At = Lt === "TB" ? (Wt.depth - 1) * gt : w2 - (Wt.depth - 1) * gt, Wt.setLayout({ x: yt, y: At }, true);
            }));
          }
        }
      }
      function tMn(u) {
        u.eachSeriesByType("tree", function(o) {
          var n3 = o.getData(), p2 = n3.tree;
          p2.eachNode(function(m2) {
            var w2 = m2.getModel(), T2 = w2.getModel("itemStyle").getItemStyle(), E = n3.ensureUniqueItemVisual(m2.dataIndex, "style");
            ua2(E, T2);
          });
        });
      }
      function eMn(u) {
        u.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(o, n3) {
          n3.eachComponent({ mainType: "series", subType: "tree", query: o }, function(p2) {
            var m2 = o.dataIndex, w2 = p2.getData().tree, T2 = w2.getNodeByDataIndex(m2);
            T2.isExpand = !T2.isExpand;
          });
        }), u.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(o, n3) {
          n3.eachComponent({ mainType: "series", subType: "tree", query: o }, function(p2) {
            var m2 = p2.coordinateSystem, w2 = J9t(m2, o);
            p2.setCenter && p2.setCenter(w2.center), p2.setZoom && p2.setZoom(w2.zoom);
          });
        });
      }
      function nMn(u) {
        u.registerChartView(B2n), u.registerSeriesModel(K2n), u.registerLayout(Q2n), u.registerVisual(tMn), eMn(u);
      }
      var y_e = ["treemapZoomToNode", "treemapRender", "treemapMove"];
      function rMn(u) {
        for (var o = 0; o < y_e.length; o++)
          u.registerAction({ type: y_e[o], update: "updateView" }, Jp);
        u.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(n3, p2) {
          p2.eachComponent({ mainType: "series", subType: "treemap", query: n3 }, m2);
          function m2(w2, T2) {
            var E = ["treemapZoomToNode", "treemapRootToNode"], O2 = pst(n3, E, w2);
            if (O2) {
              var V3 = w2.getViewRoot();
              V3 && (n3.direction = a7t(V3, O2.node) ? "rollUp" : "drillDown"), w2.resetViewRoot(O2.node);
            }
          }
        });
      }
      function m_e(u) {
        var o = u.getData(), n3 = o.tree, p2 = {};
        n3.eachNode(function(m2) {
          for (var w2 = m2; w2 && w2.depth > 1; )
            w2 = w2.parentNode;
          var T2 = h8t(u.ecModel, w2.name || w2.dataIndex + "", p2);
          m2.setVisual("decal", T2);
        });
      }
      var iMn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.preventUsingHoverLayer = true, n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          var m2 = { name: n3.name, children: n3.data };
          b_e(m2);
          var w2 = n3.levels || [], T2 = this.designatedVisualItemStyle = {}, E = new _g({ itemStyle: T2 }, this, p2);
          w2 = n3.levels = aMn(w2, p2);
          var O2 = Ya2(w2 || [], function(q3) {
            return new _g(q3, E, p2);
          }, this), V3 = i7t.createTree(m2, this, W3);
          function W3(q3) {
            q3.wrapMethod("getItemModel", function(K, J) {
              var rt2 = V3.getNodeByDataIndex(J), gt = rt2 ? O2[rt2.depth] : null;
              return K.parentModel = gt || E, K;
            });
          }
          return V3.data;
        }, o.prototype.optionUpdated = function() {
          this.resetViewRoot();
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          var w2 = this.getData(), T2 = this.getRawValue(n3), E = w2.getName(n3);
          return k1("nameValue", { name: E, value: T2 });
        }, o.prototype.getDataParams = function(n3) {
          var p2 = u.prototype.getDataParams.apply(this, arguments), m2 = this.getData().tree.getNodeByDataIndex(n3);
          return p2.treeAncestors = Bxt(m2, this), p2.treePathInfo = p2.treeAncestors, p2;
        }, o.prototype.setLayoutInfo = function(n3) {
          this.layoutInfo = this.layoutInfo || {}, ua2(this.layoutInfo, n3);
        }, o.prototype.mapIdToIndex = function(n3) {
          var p2 = this._idIndexMap;
          p2 || (p2 = this._idIndexMap = pl(), this._idIndexMapCount = 0);
          var m2 = p2.get(n3);
          return m2 == null && p2.set(n3, m2 = this._idIndexMapCount++), m2;
        }, o.prototype.getViewRoot = function() {
          return this._viewRoot;
        }, o.prototype.resetViewRoot = function(n3) {
          n3 ? this._viewRoot = n3 : n3 = this._viewRoot;
          var p2 = this.getRawData().tree.root;
          (!n3 || n3 !== p2 && !p2.contains(n3)) && (this._viewRoot = p2);
        }, o.prototype.enableAriaDecal = function() {
          m_e(this);
        }, o.type = "series.treemap", o.layoutMode = "box", o.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, o;
      }(Rv);
      function b_e(u) {
        var o = 0;
        Xe2(u.children, function(p2) {
          b_e(p2);
          var m2 = p2.value;
          za2(m2) && (m2 = m2[0]), o += m2;
        });
        var n3 = u.value;
        za2(n3) && (n3 = n3[0]), (n3 == null || isNaN(n3)) && (n3 = o), n3 < 0 && (n3 = 0), za2(u.value) ? u.value[0] = n3 : u.value = n3;
      }
      function aMn(u, o) {
        var n3 = Tp(o.get("color")), p2 = Tp(o.get(["aria", "decal", "decals"]));
        if (n3) {
          u = u || [];
          var m2, w2;
          Xe2(u, function(E) {
            var O2 = new _g(E), V3 = O2.get("color"), W3 = O2.get("decal");
            (O2.get(["itemStyle", "color"]) || V3 && V3 !== "none") && (m2 = true), (O2.get(["itemStyle", "decal"]) || W3 && W3 !== "none") && (w2 = true);
          });
          var T2 = u[0] || (u[0] = {});
          return m2 || (T2.color = n3.slice()), !w2 && p2 && (T2.decal = p2.slice()), u;
        }
      }
      var oMn = iMn, sMn = 8, x_e = 8, o7t = 5, lMn = function() {
        function u(o) {
          this.group = new uu(), o.add(this.group);
        }
        return u.prototype.render = function(o, n3, p2, m2) {
          var w2 = o.getModel("breadcrumb"), T2 = this.group;
          if (T2.removeAll(), !(!w2.get("show") || !p2)) {
            var E = w2.getModel("itemStyle"), O2 = E.getModel("textStyle"), V3 = { pos: { left: w2.get("left"), right: w2.get("right"), top: w2.get("top"), bottom: w2.get("bottom") }, box: { width: n3.getWidth(), height: n3.getHeight() }, emptyItemWidth: w2.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
            this._prepare(p2, V3, O2), this._renderContent(o, V3, E, O2, m2), V_t(T2, V3.pos, V3.box);
          }
        }, u.prototype._prepare = function(o, n3, p2) {
          for (var m2 = o; m2; m2 = m2.parentNode) {
            var w2 = $d2(m2.getModel().get("name"), ""), T2 = p2.getTextRect(w2), E = Math.max(T2.width + sMn * 2, n3.emptyItemWidth);
            n3.totalWidth += E + x_e, n3.renderList.push({ node: m2, text: w2, width: E });
          }
        }, u.prototype._renderContent = function(o, n3, p2, m2, w2) {
          for (var T2 = 0, E = n3.emptyItemWidth, O2 = o.get(["breadcrumb", "height"]), V3 = yyn(n3.pos, n3.box), W3 = n3.totalWidth, q3 = n3.renderList, K = q3.length - 1; K >= 0; K--) {
            var J = q3[K], rt2 = J.node, gt = J.width, yt = J.text;
            W3 > V3.width && (W3 -= gt - E, gt = E, yt = null);
            var At = new Sw({ shape: { points: uMn(T2, 0, gt, O2, K === q3.length - 1, K === 0) }, style: kl(p2.getItemStyle(), { lineJoin: "bevel" }), textContent: new Zc2({ style: { text: yt, fill: m2.getTextColor(), font: m2.getFont() } }), textConfig: { position: "inside" }, z2: WP * 1e4, onclick: wu(w2, rt2) });
            At.disableLabelAnimation = true, this.group.add(At), cMn(At, o, rt2), T2 += gt + x_e;
          }
        }, u.prototype.remove = function() {
          this.group.removeAll();
        }, u;
      }();
      function uMn(u, o, n3, p2, m2, w2) {
        var T2 = [[m2 ? u : u - o7t, o], [u + n3, o], [u + n3, o + p2], [m2 ? u : u - o7t, o + p2]];
        return !w2 && T2.splice(2, 0, [u + n3 + o7t, o + p2 / 2]), !m2 && T2.push([u, o + p2 / 2]), T2;
      }
      function cMn(u, o, n3) {
        is(u).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: o.componentIndex, seriesIndex: o.seriesIndex, seriesName: o.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: n3 && n3.dataIndex, name: n3 && n3.name }, treePathInfo: n3 && Bxt(n3, o) };
      }
      var fMn = lMn, hMn = function() {
        function u() {
          this._storage = [], this._elExistsMap = {};
        }
        return u.prototype.add = function(o, n3, p2, m2, w2) {
          return this._elExistsMap[o.id] ? false : (this._elExistsMap[o.id] = true, this._storage.push({ el: o, target: n3, duration: p2, delay: m2, easing: w2 }), true);
        }, u.prototype.finished = function(o) {
          return this._finishedCallback = o, this;
        }, u.prototype.start = function() {
          for (var o = this, n3 = this._storage.length, p2 = function() {
            n3--, n3 <= 0 && (o._storage.length = 0, o._elExistsMap = {}, o._finishedCallback && o._finishedCallback());
          }, m2 = 0, w2 = this._storage.length; m2 < w2; m2++) {
            var T2 = this._storage[m2];
            T2.el.animateTo(T2.target, { duration: T2.duration, delay: T2.delay, easing: T2.easing, setToFinal: true, done: p2, aborted: p2 });
          }
          return this;
        }, u;
      }();
      function pMn() {
        return new hMn();
      }
      var s7t = uu, w_e = Vf2, S_e = 3, M_e = "label", C_e = "upperLabel", dMn = WP * 10, gMn = WP * 2, vMn = WP * 3, $z = l4([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), T_e = function(u) {
        var o = $z(u);
        return o.stroke = o.fill = o.lineWidth = null, o;
      }, zxt = Ff2(), yMn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._state = "ready", n3._storage = gst(), n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          var T2 = p2.findComponents({ mainType: "series", subType: "treemap", query: w2 });
          if (!(sc2(T2, n3) < 0)) {
            this.seriesModel = n3, this.api = m2, this.ecModel = p2;
            var E = ["treemapZoomToNode", "treemapRootToNode"], O2 = pst(w2, E, n3), V3 = w2 && w2.type, W3 = n3.layoutInfo, q3 = !this._oldTree, K = this._storage, J = V3 === "treemapRootToNode" && O2 && K ? { rootNodeGroup: K.nodeGroup[O2.node.getRawIndex()], direction: w2.direction } : null, rt2 = this._giveContainerGroup(W3), gt = n3.get("animation"), yt = this._doRender(rt2, n3, J);
            gt && !q3 && (!V3 || V3 === "treemapZoomToNode" || V3 === "treemapRootToNode") ? this._doAnimation(rt2, yt, n3, J) : yt.renderFinally(), this._resetController(m2), this._renderBreadcrumb(n3, m2, O2);
          }
        }, o.prototype._giveContainerGroup = function(n3) {
          var p2 = this._containerGroup;
          return p2 || (p2 = this._containerGroup = new s7t(), this._initEvents(p2), this.group.add(p2)), p2.x = n3.x, p2.y = n3.y, p2;
        }, o.prototype._doRender = function(n3, p2, m2) {
          var w2 = p2.getData().tree, T2 = this._oldTree, E = gst(), O2 = gst(), V3 = this._storage, W3 = [];
          function q3(yt, At, Lt, Wt) {
            return mMn(p2, O2, V3, m2, E, W3, yt, At, Lt, Wt);
          }
          J(w2.root ? [w2.root] : [], T2 && T2.root ? [T2.root] : [], n3, w2 === T2 || !T2, 0);
          var K = rt2(V3);
          return this._oldTree = w2, this._storage = O2, { lastsForAnimation: E, willDeleteEls: K, renderFinally: gt };
          function J(yt, At, Lt, Wt, Nt) {
            Wt ? (At = yt, Xe2(yt, function(pe2, xe) {
              !pe2.isRemoved() && ie2(xe, xe);
            })) : new C4(At, yt, ue2, ue2).add(ie2).update(ie2).remove(wu(ie2, null)).execute();
            function ue2(pe2) {
              return pe2.getId();
            }
            function ie2(pe2, xe) {
              var Ce2 = pe2 != null ? yt[pe2] : null, Le2 = xe != null ? At[xe] : null, ze = q3(Ce2, Le2, Lt, Nt);
              ze && J(Ce2 && Ce2.viewChildren || [], Le2 && Le2.viewChildren || [], ze, Wt, Nt + 1);
            }
          }
          function rt2(yt) {
            var At = gst();
            return yt && Xe2(yt, function(Lt, Wt) {
              var Nt = At[Wt];
              Xe2(Lt, function(ue2) {
                ue2 && (Nt.push(ue2), zxt(ue2).willDelete = true);
              });
            }), At;
          }
          function gt() {
            Xe2(K, function(yt) {
              Xe2(yt, function(At) {
                At.parent && At.parent.remove(At);
              });
            }), Xe2(W3, function(yt) {
              yt.invisible = true, yt.dirty();
            });
          }
        }, o.prototype._doAnimation = function(n3, p2, m2, w2) {
          var T2 = m2.get("animationDurationUpdate"), E = m2.get("animationEasing"), O2 = (Sl(T2) ? 0 : T2) || 0, V3 = (Sl(E) ? null : E) || "cubicOut", W3 = pMn();
          Xe2(p2.willDeleteEls, function(q3, K) {
            Xe2(q3, function(J, rt2) {
              if (!J.invisible) {
                var gt = J.parent, yt, At = zxt(gt);
                if (w2 && w2.direction === "drillDown")
                  yt = gt === w2.rootNodeGroup ? { shape: { x: 0, y: 0, width: At.nodeWidth, height: At.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
                else {
                  var Lt = 0, Wt = 0;
                  At.willDelete || (Lt = At.nodeWidth / 2, Wt = At.nodeHeight / 2), yt = K === "nodeGroup" ? { x: Lt, y: Wt, style: { opacity: 0 } } : { shape: { x: Lt, y: Wt, width: 0, height: 0 }, style: { opacity: 0 } };
                }
                yt && W3.add(J, yt, O2, 0, V3);
              }
            });
          }), Xe2(this._storage, function(q3, K) {
            Xe2(q3, function(J, rt2) {
              var gt = p2.lastsForAnimation[K][rt2], yt = {};
              !gt || (J instanceof uu ? gt.oldX != null && (yt.x = J.x, yt.y = J.y, J.x = gt.oldX, J.y = gt.oldY) : (gt.oldShape && (yt.shape = ua2({}, J.shape), J.setShape(gt.oldShape)), gt.fadein ? (J.setStyle("opacity", 0), yt.style = { opacity: 1 }) : J.style.opacity !== 1 && (yt.style = { opacity: 1 })), W3.add(J, yt, O2, 0, V3));
            });
          }, this), this._state = "animating", W3.finished(Is(function() {
            this._state = "ready", p2.renderFinally();
          }, this)).start();
        }, o.prototype._resetController = function(n3) {
          var p2 = this._controller;
          p2 || (p2 = this._controller = new ust(n3.getZr()), p2.enable(this.seriesModel.get("roam")), p2.on("pan", Is(this._onPan, this)), p2.on("zoom", Is(this._onZoom, this)));
          var m2 = new Qu(0, 0, n3.getWidth(), n3.getHeight());
          p2.setPointerChecker(function(w2, T2, E) {
            return m2.contain(T2, E);
          });
        }, o.prototype._clearController = function() {
          var n3 = this._controller;
          n3 && (n3.dispose(), n3 = null);
        }, o.prototype._onPan = function(n3) {
          if (this._state !== "animating" && (Math.abs(n3.dx) > S_e || Math.abs(n3.dy) > S_e)) {
            var p2 = this.seriesModel.getData().tree.root;
            if (!p2)
              return;
            var m2 = p2.getLayout();
            if (!m2)
              return;
            this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: m2.x + n3.dx, y: m2.y + n3.dy, width: m2.width, height: m2.height } });
          }
        }, o.prototype._onZoom = function(n3) {
          var p2 = n3.originX, m2 = n3.originY;
          if (this._state !== "animating") {
            var w2 = this.seriesModel.getData().tree.root;
            if (!w2)
              return;
            var T2 = w2.getLayout();
            if (!T2)
              return;
            var E = new Qu(T2.x, T2.y, T2.width, T2.height), O2 = this.seriesModel.layoutInfo;
            p2 -= O2.x, m2 -= O2.y;
            var V3 = yw();
            QS(V3, V3, [-p2, -m2]), e$(V3, V3, [n3.scale, n3.scale]), QS(V3, V3, [p2, m2]), E.applyTransform(V3), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: E.x, y: E.y, width: E.width, height: E.height } });
          }
        }, o.prototype._initEvents = function(n3) {
          var p2 = this;
          n3.on("click", function(m2) {
            if (p2._state === "ready") {
              var w2 = p2.seriesModel.get("nodeClick", true);
              if (w2) {
                var T2 = p2.findTarget(m2.offsetX, m2.offsetY);
                if (T2) {
                  var E = T2.node;
                  if (E.getLayout().isLeafRoot)
                    p2._rootToNode(T2);
                  else if (w2 === "zoomToNode")
                    p2._zoomToNode(T2);
                  else if (w2 === "link") {
                    var O2 = E.hostTree.data.getItemModel(E.dataIndex), V3 = O2.get("link", true), W3 = O2.get("target", true) || "blank";
                    V3 && N_t(V3, W3);
                  }
                }
              }
            }
          }, this);
        }, o.prototype._renderBreadcrumb = function(n3, p2, m2) {
          var w2 = this;
          m2 || (m2 = n3.get("leafDepth", true) != null ? { node: n3.getViewRoot() } : this.findTarget(p2.getWidth() / 2, p2.getHeight() / 2), m2 || (m2 = { node: n3.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new fMn(this.group))).render(n3, p2, m2.node, function(T2) {
            w2._state !== "animating" && (a7t(n3.getViewRoot(), T2) ? w2._rootToNode({ node: T2 }) : w2._zoomToNode({ node: T2 }));
          });
        }, o.prototype.remove = function() {
          this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = gst(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
        }, o.prototype.dispose = function() {
          this._clearController();
        }, o.prototype._zoomToNode = function(n3) {
          this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: n3.node });
        }, o.prototype._rootToNode = function(n3) {
          this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: n3.node });
        }, o.prototype.findTarget = function(n3, p2) {
          var m2, w2 = this.seriesModel.getViewRoot();
          return w2.eachNode({ attr: "viewChildren", order: "preorder" }, function(T2) {
            var E = this._storage.background[T2.getRawIndex()];
            if (E) {
              var O2 = E.transformCoordToLocal(n3, p2), V3 = E.shape;
              if (V3.x <= O2[0] && O2[0] <= V3.x + V3.width && V3.y <= O2[1] && O2[1] <= V3.y + V3.height)
                m2 = { node: T2, offsetX: O2[0], offsetY: O2[1] };
              else
                return false;
            }
          }, this), m2;
        }, o.type = "treemap", o;
      }(xg2);
      function gst() {
        return { nodeGroup: [], background: [], content: [] };
      }
      function mMn(u, o, n3, p2, m2, w2, T2, E, O2, V3) {
        if (!T2)
          return;
        var W3 = T2.getLayout(), q3 = u.getData(), K = T2.getModel();
        if (q3.setItemGraphicEl(T2.dataIndex, null), !W3 || !W3.isInView)
          return;
        var J = W3.width, rt2 = W3.height, gt = W3.borderWidth, yt = W3.invisible, At = T2.getRawIndex(), Lt = E && E.getRawIndex(), Wt = T2.viewChildren, Nt = W3.upperHeight, ue2 = Wt && Wt.length, ie2 = K.getModel("itemStyle"), pe2 = K.getModel(["emphasis", "itemStyle"]), xe = K.getModel(["blur", "itemStyle"]), Ce2 = K.getModel(["select", "itemStyle"]), Le2 = ie2.get("borderRadius") || 0, ze = Ms("nodeGroup", s7t);
        if (!ze)
          return;
        if (O2.add(ze), ze.x = W3.x || 0, ze.y = W3.y || 0, ze.markRedraw(), zxt(ze).nodeWidth = J, zxt(ze).nodeHeight = rt2, W3.isAboveViewRoot)
          return ze;
        var tn = Ms("background", w_e, V3, gMn);
        tn && or(ze, tn, ue2 && W3.upperLabelHeight);
        var $e2 = K.getModel("emphasis"), Tn = $e2.get("focus"), zn = $e2.get("blurScope"), bn = $e2.get("disabled"), Xr = Tn === "ancestor" ? T2.getAncestorsIndices() : Tn === "descendant" ? T2.getDescendantIndices() : Tn;
        if (ue2)
          _4(ze) && b4(ze, false), tn && (b4(tn, !bn), q3.setItemGraphicEl(T2.dataIndex, tn), not(tn, Xr, zn));
        else {
          var Xn = Ms("content", w_e, V3, vMn);
          Xn && Tr(ze, Xn), tn.disableMorphing = true, tn && _4(tn) && b4(tn, false), b4(ze, !bn), q3.setItemGraphicEl(T2.dataIndex, ze), not(ze, Xr, zn);
        }
        return ze;
        function or(el, as, Hs) {
          var ol = is(as);
          if (ol.dataIndex = T2.dataIndex, ol.seriesIndex = u.seriesIndex, as.setShape({ x: 0, y: 0, width: J, height: rt2, r: Le2 }), yt)
            ci2(as);
          else {
            as.invisible = false;
            var xs = T2.getVisual("style"), Bl = xs.stroke, Ph2 = T_e(ie2);
            Ph2.fill = Bl;
            var fu = $z(pe2);
            fu.fill = pe2.get("borderColor");
            var uh2 = $z(xe);
            uh2.fill = xe.get("borderColor");
            var Zh2 = $z(Ce2);
            if (Zh2.fill = Ce2.get("borderColor"), Hs) {
              var zp = J - 2 * gt;
              yi2(as, Bl, xs.opacity, { x: gt, y: 0, width: zp, height: Nt });
            } else
              as.removeTextContent();
            as.setStyle(Ph2), as.ensureState("emphasis").style = fu, as.ensureState("blur").style = uh2, as.ensureState("select").style = Zh2, y4(as);
          }
          el.add(as);
        }
        function Tr(el, as) {
          var Hs = is(as);
          Hs.dataIndex = T2.dataIndex, Hs.seriesIndex = u.seriesIndex;
          var ol = Math.max(J - 2 * gt, 0), xs = Math.max(rt2 - 2 * gt, 0);
          if (as.culling = true, as.setShape({ x: gt, y: gt, width: ol, height: xs, r: Le2 }), yt)
            ci2(as);
          else {
            as.invisible = false;
            var Bl = T2.getVisual("style"), Ph2 = Bl.fill, fu = T_e(ie2);
            fu.fill = Ph2, fu.decal = Bl.decal;
            var uh2 = $z(pe2), Zh2 = $z(xe), zp = $z(Ce2);
            yi2(as, Ph2, Bl.opacity, null), as.setStyle(fu), as.ensureState("emphasis").style = uh2, as.ensureState("blur").style = Zh2, as.ensureState("select").style = zp, y4(as);
          }
          el.add(as);
        }
        function ci2(el) {
          !el.invisible && w2.push(el);
        }
        function yi2(el, as, Hs, ol) {
          var xs = K.getModel(ol ? C_e : M_e), Bl = $d2(K.get("name"), null), Ph2 = xs.getShallow("show");
          Tw(el, Lb2(K, ol ? C_e : M_e), { defaultText: Ph2 ? Bl : null, inheritColor: as, defaultOpacity: Hs, labelFetcher: u, labelDataIndex: T2.dataIndex });
          var fu = el.getTextContent();
          if (fu) {
            var uh2 = fu.style, Zh2 = jE(uh2.padding || 0);
            ol && (el.setTextConfig({ layoutRect: ol }), fu.disableLabelLayout = true), fu.beforeUpdate = function() {
              var tm = Math.max((ol ? ol.width : el.shape.width) - Zh2[1] - Zh2[3], 0), Fd2 = Math.max((ol ? ol.height : el.shape.height) - Zh2[0] - Zh2[2], 0);
              (uh2.width !== tm || uh2.height !== Fd2) && fu.setStyle({ width: tm, height: Fd2 });
            }, uh2.truncateMinChar = 2, uh2.lineOverflow = "truncate", Po(uh2, ol, W3);
            var zp = fu.getState("emphasis");
            Po(zp ? zp.style : null, ol, W3);
          }
        }
        function Po(el, as, Hs) {
          var ol = el ? el.text : null;
          if (!as && Hs.isLeafRoot && ol != null) {
            var xs = u.get("drillDownIcon", true);
            el.text = xs ? xs + " " + ol : ol;
          }
        }
        function Ms(el, as, Hs, ol) {
          var xs = Lt != null && n3[el][Lt], Bl = m2[el];
          return xs ? (n3[el][Lt] = null, dl(Bl, xs)) : yt || (xs = new as(), xs instanceof sM && (xs.z2 = bMn(Hs, ol)), tl(Bl, xs)), o[el][At] = xs;
        }
        function dl(el, as) {
          var Hs = el[At] = {};
          as instanceof s7t ? (Hs.oldX = as.x, Hs.oldY = as.y) : Hs.oldShape = ua2({}, as.shape);
        }
        function tl(el, as) {
          var Hs = el[At] = {}, ol = T2.parentNode, xs = as instanceof uu;
          if (ol && (!p2 || p2.direction === "drillDown")) {
            var Bl = 0, Ph2 = 0, fu = m2.background[ol.getRawIndex()];
            !p2 && fu && fu.oldShape && (Bl = fu.oldShape.width, Ph2 = fu.oldShape.height), xs ? (Hs.oldX = 0, Hs.oldY = Ph2) : Hs.oldShape = { x: Bl, y: Ph2, width: 0, height: 0 };
          }
          Hs.fadein = !xs;
        }
      }
      function bMn(u, o) {
        return u * dMn + o;
      }
      var _Mn = yMn, vst = Xe2, xMn = ys, jxt = -1, l7t = function() {
        function u(o) {
          var n3 = o.mappingMethod, p2 = o.type, m2 = this.option = jl(o);
          this.type = p2, this.mappingMethod = n3, this._normalizeData = MMn[n3];
          var w2 = u.visualHandlers[p2];
          this.applyVisual = w2.applyVisual, this.getColorMapper = w2.getColorMapper, this._normalizedToVisual = w2._normalizedToVisual[n3], n3 === "piecewise" ? (u7t(m2), wMn(m2)) : n3 === "category" ? m2.categories ? SMn(m2) : u7t(m2, true) : (Tb2(n3 !== "linear" || m2.dataExtent), u7t(m2));
        }
        return u.prototype.mapValueToVisual = function(o) {
          var n3 = this._normalizeData(o);
          return this._normalizedToVisual(n3, o);
        }, u.prototype.getNormalizer = function() {
          return Is(this._normalizeData, this);
        }, u.listVisualTypes = function() {
          return tf2(u.visualHandlers);
        }, u.isValidType = function(o) {
          return u.visualHandlers.hasOwnProperty(o);
        }, u.eachVisual = function(o, n3, p2) {
          ys(o) ? Xe2(o, n3, p2) : n3.call(p2, o);
        }, u.mapVisual = function(o, n3, p2) {
          var m2, w2 = za2(o) ? [] : ys(o) ? {} : (m2 = true, null);
          return u.eachVisual(o, function(T2, E) {
            var O2 = n3.call(p2, T2, E);
            m2 ? w2 = O2 : w2[E] = O2;
          }), w2;
        }, u.retrieveVisuals = function(o) {
          var n3 = {}, p2;
          return o && vst(u.visualHandlers, function(m2, w2) {
            o.hasOwnProperty(w2) && (n3[w2] = o[w2], p2 = true);
          }), p2 ? n3 : null;
        }, u.prepareVisualTypes = function(o) {
          if (za2(o))
            o = o.slice();
          else if (xMn(o)) {
            var n3 = [];
            vst(o, function(p2, m2) {
              n3.push(m2);
            }), o = n3;
          } else
            return [];
          return o.sort(function(p2, m2) {
            return m2 === "color" && p2 !== "color" && p2.indexOf("color") === 0 ? 1 : -1;
          }), o;
        }, u.dependsOn = function(o, n3) {
          return n3 === "color" ? !!(o && o.indexOf(n3) === 0) : o === n3;
        }, u.findPieceIndex = function(o, n3, p2) {
          for (var m2, w2 = 1 / 0, T2 = 0, E = n3.length; T2 < E; T2++) {
            var O2 = n3[T2].value;
            if (O2 != null) {
              if (O2 === o || ds(O2) && O2 === o + "")
                return T2;
              p2 && K(O2, T2);
            }
          }
          for (var T2 = 0, E = n3.length; T2 < E; T2++) {
            var V3 = n3[T2], W3 = V3.interval, q3 = V3.close;
            if (W3) {
              if (W3[0] === -1 / 0) {
                if (Gxt(q3[1], o, W3[1]))
                  return T2;
              } else if (W3[1] === 1 / 0) {
                if (Gxt(q3[0], W3[0], o))
                  return T2;
              } else if (Gxt(q3[0], W3[0], o) && Gxt(q3[1], o, W3[1]))
                return T2;
              p2 && K(W3[0], T2), p2 && K(W3[1], T2);
            }
          }
          if (p2)
            return o === 1 / 0 ? n3.length - 1 : o === -1 / 0 ? 0 : m2;
          function K(J, rt2) {
            var gt = Math.abs(J - o);
            gt < w2 && (w2 = gt, m2 = rt2);
          }
        }, u.visualHandlers = { color: { applyVisual: yst("color"), getColorMapper: function() {
          var o = this.option;
          return Is(o.mappingMethod === "category" ? function(n3, p2) {
            return !p2 && (n3 = this._normalizeData(n3)), mst.call(this, n3);
          } : function(n3, p2, m2) {
            var w2 = !!m2;
            return !p2 && (n3 = this._normalizeData(n3)), m2 = Jit(n3, o.parsedVisual, m2), w2 ? m2 : T1(m2, "rgba");
          }, this);
        }, _normalizedToVisual: { linear: function(o) {
          return T1(Jit(o, this.option.parsedVisual), "rgba");
        }, category: mst, piecewise: function(o, n3) {
          var p2 = f7t.call(this, n3);
          return p2 == null && (p2 = T1(Jit(o, this.option.parsedVisual), "rgba")), p2;
        }, fixed: Yz } }, colorHue: Wxt(function(o, n3) {
          return tz(o, n3);
        }), colorSaturation: Wxt(function(o, n3) {
          return tz(o, null, n3);
        }), colorLightness: Wxt(function(o, n3) {
          return tz(o, null, null, n3);
        }), colorAlpha: Wxt(function(o, n3) {
          return UZ(o, n3);
        }), decal: { applyVisual: yst("decal"), _normalizedToVisual: { linear: null, category: mst, piecewise: null, fixed: null } }, opacity: { applyVisual: yst("opacity"), _normalizedToVisual: c7t([0, 1]) }, liftZ: { applyVisual: yst("liftZ"), _normalizedToVisual: { linear: Yz, category: Yz, piecewise: Yz, fixed: Yz } }, symbol: { applyVisual: function(o, n3, p2) {
          var m2 = this.mapValueToVisual(o);
          p2("symbol", m2);
        }, _normalizedToVisual: { linear: A_e, category: mst, piecewise: function(o, n3) {
          var p2 = f7t.call(this, n3);
          return p2 == null && (p2 = A_e.call(this, o)), p2;
        }, fixed: Yz } }, symbolSize: { applyVisual: yst("symbolSize"), _normalizedToVisual: c7t([0, 1]) } }, u;
      }();
      function wMn(u) {
        var o = u.pieceList;
        u.hasSpecialVisual = false, Xe2(o, function(n3, p2) {
          n3.originIndex = p2, n3.visual != null && (u.hasSpecialVisual = true);
        });
      }
      function SMn(u) {
        var o = u.categories, n3 = u.categoryMap = {}, p2 = u.visual;
        if (vst(o, function(T2, E) {
          n3[T2] = E;
        }), !za2(p2)) {
          var m2 = [];
          ys(p2) ? vst(p2, function(T2, E) {
            var O2 = n3[E];
            m2[O2 != null ? O2 : jxt] = T2;
          }) : m2[jxt] = p2, p2 = I_e(u, m2);
        }
        for (var w2 = o.length - 1; w2 >= 0; w2--)
          p2[w2] == null && (delete n3[o[w2]], o.pop());
      }
      function u7t(u, o) {
        var n3 = u.visual, p2 = [];
        ys(n3) ? vst(n3, function(w2) {
          p2.push(w2);
        }) : n3 != null && p2.push(n3);
        var m2 = { color: 1, symbol: 1 };
        !o && p2.length === 1 && !m2.hasOwnProperty(u.type) && (p2[1] = p2[0]), I_e(u, p2);
      }
      function Wxt(u) {
        return { applyVisual: function(o, n3, p2) {
          var m2 = this.mapValueToVisual(o);
          p2("color", u(n3("color"), m2));
        }, _normalizedToVisual: c7t([0, 1]) };
      }
      function A_e(u) {
        var o = this.option.visual;
        return o[Math.round(bp(u, [0, 1], [0, o.length - 1], true))] || {};
      }
      function yst(u) {
        return function(o, n3, p2) {
          p2(u, this.mapValueToVisual(o));
        };
      }
      function mst(u) {
        var o = this.option.visual;
        return o[this.option.loop && u !== jxt ? u % o.length : u];
      }
      function Yz() {
        return this.option.visual[0];
      }
      function c7t(u) {
        return { linear: function(o) {
          return bp(o, u, this.option.visual, true);
        }, category: mst, piecewise: function(o, n3) {
          var p2 = f7t.call(this, n3);
          return p2 == null && (p2 = bp(o, u, this.option.visual, true)), p2;
        }, fixed: Yz };
      }
      function f7t(u) {
        var o = this.option, n3 = o.pieceList;
        if (o.hasSpecialVisual) {
          var p2 = l7t.findPieceIndex(u, n3), m2 = n3[p2];
          if (m2 && m2.visual)
            return m2.visual[this.type];
        }
      }
      function I_e(u, o) {
        return u.visual = o, u.type === "color" && (u.parsedVisual = Ya2(o, function(n3) {
          return KS(n3);
        })), o;
      }
      var MMn = { linear: function(u) {
        return bp(u, this.option.dataExtent, [0, 1], true);
      }, piecewise: function(u) {
        var o = this.option.pieceList, n3 = l7t.findPieceIndex(u, o, true);
        if (n3 != null)
          return bp(n3, [0, o.length - 1], [0, 1], true);
      }, category: function(u) {
        var o = this.option.categories ? this.option.categoryMap[u] : u;
        return o == null ? jxt : o;
      }, fixed: Jp };
      function Gxt(u, o, n3) {
        return u ? o <= n3 : o < n3;
      }
      var ix = l7t, CMn = "itemStyle", D_e = Ff2(), TMn = { seriesType: "treemap", reset: function(u) {
        var o = u.getData().tree, n3 = o.root;
        n3.isRemoved() || E_e(n3, {}, u.getViewRoot().getAncestors(), u);
      } };
      function E_e(u, o, n3, p2) {
        var m2 = u.getModel(), w2 = u.getLayout(), T2 = u.hostTree.data;
        if (!(!w2 || w2.invisible || !w2.isInView)) {
          var E = m2.getModel(CMn), O2 = AMn(E, o, p2), V3 = T2.ensureUniqueItemVisual(u.dataIndex, "style"), W3 = E.get("borderColor"), q3 = E.get("borderColorSaturation"), K;
          q3 != null && (K = k_e(O2), W3 = IMn(q3, K)), V3.stroke = W3;
          var J = u.viewChildren;
          if (!J || !J.length)
            K = k_e(O2), V3.fill = K;
          else {
            var rt2 = DMn(u, m2, w2, E, O2, J);
            Xe2(J, function(gt, yt) {
              if (gt.depth >= n3.length || gt === n3[gt.depth]) {
                var At = EMn(m2, O2, gt, yt, rt2, p2);
                E_e(gt, At, n3, p2);
              }
            });
          }
        }
      }
      function AMn(u, o, n3) {
        var p2 = ua2({}, o), m2 = n3.designatedVisualItemStyle;
        return Xe2(["color", "colorAlpha", "colorSaturation"], function(w2) {
          m2[w2] = o[w2];
          var T2 = u.get(w2);
          m2[w2] = null, T2 != null && (p2[w2] = T2);
        }), p2;
      }
      function k_e(u) {
        var o = h7t(u, "color");
        if (o) {
          var n3 = h7t(u, "colorAlpha"), p2 = h7t(u, "colorSaturation");
          return p2 && (o = tz(o, null, null, p2)), n3 && (o = UZ(o, n3)), o;
        }
      }
      function IMn(u, o) {
        return o != null ? tz(o, null, null, u) : null;
      }
      function h7t(u, o) {
        var n3 = u[o];
        if (n3 != null && n3 !== "none")
          return n3;
      }
      function DMn(u, o, n3, p2, m2, w2) {
        if (!(!w2 || !w2.length)) {
          var T2 = p7t(o, "color") || m2.color != null && m2.color !== "none" && (p7t(o, "colorAlpha") || p7t(o, "colorSaturation"));
          if (T2) {
            var E = o.get("visualMin"), O2 = o.get("visualMax"), V3 = n3.dataExtent.slice();
            E != null && E < V3[0] && (V3[0] = E), O2 != null && O2 > V3[1] && (V3[1] = O2);
            var W3 = o.get("colorMappingBy"), q3 = { type: T2.name, dataExtent: V3, visual: T2.range };
            q3.type === "color" && (W3 === "index" || W3 === "id") ? (q3.mappingMethod = "category", q3.loop = true) : q3.mappingMethod = "linear";
            var K = new ix(q3);
            return D_e(K).drColorMappingBy = W3, K;
          }
        }
      }
      function p7t(u, o) {
        var n3 = u.get(o);
        return za2(n3) && n3.length ? { name: o, range: n3 } : null;
      }
      function EMn(u, o, n3, p2, m2, w2) {
        var T2 = ua2({}, o);
        if (m2) {
          var E = m2.type, O2 = E === "color" && D_e(m2).drColorMappingBy, V3 = O2 === "index" ? p2 : O2 === "id" ? w2.mapIdToIndex(n3.getId()) : n3.getValue(u.get("visualDimension"));
          T2[E] = m2.mapValueToVisual(V3);
        }
        return T2;
      }
      var bst = Math.max, Hxt = Math.min, P_e = $y, d7t = Xe2, L_e = ["itemStyle", "borderWidth"], kMn = ["itemStyle", "gapWidth"], PMn = ["upperLabel", "show"], LMn = ["upperLabel", "height"], OMn = { seriesType: "treemap", reset: function(u, o, n3, p2) {
        var m2 = n3.getWidth(), w2 = n3.getHeight(), T2 = u.option, E = Bm(u.getBoxLayoutParams(), { width: n3.getWidth(), height: n3.getHeight() }), O2 = T2.size || [], V3 = Qo(P_e(E.width, O2[0]), m2), W3 = Qo(P_e(E.height, O2[1]), w2), q3 = p2 && p2.type, K = ["treemapZoomToNode", "treemapRootToNode"], J = pst(p2, K, u), rt2 = q3 === "treemapRender" || q3 === "treemapMove" ? p2.rootRect : null, gt = u.getViewRoot(), yt = v_e(gt);
        if (q3 !== "treemapMove") {
          var At = q3 === "treemapZoomToNode" ? zMn(u, J, gt, V3, W3) : rt2 ? [rt2.width, rt2.height] : [V3, W3], Lt = T2.sort;
          Lt && Lt !== "asc" && Lt !== "desc" && (Lt = "desc");
          var Wt = { squareRatio: T2.squareRatio, sort: Lt, leafDepth: T2.leafDepth };
          gt.hostTree.clearLayouts();
          var Nt = { x: 0, y: 0, width: At[0], height: At[1], area: At[0] * At[1] };
          gt.setLayout(Nt), O_e(gt, Wt, false, 0), Nt = gt.getLayout(), d7t(yt, function(ie2, pe2) {
            var xe = (yt[pe2 + 1] || gt).getValue();
            ie2.setLayout(ua2({ dataExtent: [xe, xe], borderWidth: 0, upperHeight: 0 }, Nt));
          });
        }
        var ue2 = u.getData().tree.root;
        ue2.setLayout(jMn(E, rt2, J), true), u.setLayoutInfo(E), N_e(ue2, new Qu(-E.x, -E.y, m2, w2), yt, gt, 0);
      } };
      function O_e(u, o, n3, p2) {
        var m2, w2;
        if (!u.isRemoved()) {
          var T2 = u.getLayout();
          m2 = T2.width, w2 = T2.height;
          var E = u.getModel(), O2 = E.get(L_e), V3 = E.get(kMn) / 2, W3 = F_e(E), q3 = Math.max(O2, W3), K = O2 - V3, J = q3 - V3;
          u.setLayout({ borderWidth: O2, upperHeight: q3, upperLabelHeight: W3 }, true), m2 = bst(m2 - 2 * K, 0), w2 = bst(w2 - K - J, 0);
          var rt2 = m2 * w2, gt = RMn(u, E, rt2, o, n3, p2);
          if (gt.length) {
            var yt = { x: K, y: J, width: m2, height: w2 }, At = Hxt(m2, w2), Lt = 1 / 0, Wt = [];
            Wt.area = 0;
            for (var Nt = 0, ue2 = gt.length; Nt < ue2; ) {
              var ie2 = gt[Nt];
              Wt.push(ie2), Wt.area += ie2.getLayout().area;
              var pe2 = BMn(Wt, At, o.squareRatio);
              pe2 <= Lt ? (Nt++, Lt = pe2) : (Wt.area -= Wt.pop().getLayout().area, R_e(Wt, At, yt, V3, false), At = Hxt(yt.width, yt.height), Wt.length = Wt.area = 0, Lt = 1 / 0);
            }
            if (Wt.length && R_e(Wt, At, yt, V3, true), !n3) {
              var xe = E.get("childrenVisibleMin");
              xe != null && rt2 < xe && (n3 = true);
            }
            for (var Nt = 0, ue2 = gt.length; Nt < ue2; Nt++)
              O_e(gt[Nt], o, n3, p2 + 1);
          }
        }
      }
      function RMn(u, o, n3, p2, m2, w2) {
        var T2 = u.children || [], E = p2.sort;
        E !== "asc" && E !== "desc" && (E = null);
        var O2 = p2.leafDepth != null && p2.leafDepth <= w2;
        if (m2 && !O2)
          return u.viewChildren = [];
        T2 = Fp(T2, function(J) {
          return !J.isRemoved();
        }), FMn(T2, E);
        var V3 = VMn(o, T2, E);
        if (V3.sum === 0)
          return u.viewChildren = [];
        if (V3.sum = NMn(o, n3, V3.sum, E, T2), V3.sum === 0)
          return u.viewChildren = [];
        for (var W3 = 0, q3 = T2.length; W3 < q3; W3++) {
          var K = T2[W3].getValue() / V3.sum * n3;
          T2[W3].setLayout({ area: K });
        }
        return O2 && (T2.length && u.setLayout({ isLeafRoot: true }, true), T2.length = 0), u.viewChildren = T2, u.setLayout({ dataExtent: V3.dataExtent }, true), T2;
      }
      function NMn(u, o, n3, p2, m2) {
        if (!p2)
          return n3;
        for (var w2 = u.get("visibleMin"), T2 = m2.length, E = T2, O2 = T2 - 1; O2 >= 0; O2--) {
          var V3 = m2[p2 === "asc" ? T2 - O2 - 1 : O2].getValue();
          V3 / n3 * o < w2 && (E = O2, n3 -= V3);
        }
        return p2 === "asc" ? m2.splice(0, T2 - E) : m2.splice(E, T2 - E), n3;
      }
      function FMn(u, o) {
        return o && u.sort(function(n3, p2) {
          var m2 = o === "asc" ? n3.getValue() - p2.getValue() : p2.getValue() - n3.getValue();
          return m2 === 0 ? o === "asc" ? n3.dataIndex - p2.dataIndex : p2.dataIndex - n3.dataIndex : m2;
        }), u;
      }
      function VMn(u, o, n3) {
        for (var p2 = 0, m2 = 0, w2 = o.length; m2 < w2; m2++)
          p2 += o[m2].getValue();
        var T2 = u.get("visualDimension"), E;
        return !o || !o.length ? E = [NaN, NaN] : T2 === "value" && n3 ? (E = [o[o.length - 1].getValue(), o[0].getValue()], n3 === "asc" && E.reverse()) : (E = [1 / 0, -1 / 0], d7t(o, function(O2) {
          var V3 = O2.getValue(T2);
          V3 < E[0] && (E[0] = V3), V3 > E[1] && (E[1] = V3);
        })), { sum: p2, dataExtent: E };
      }
      function BMn(u, o, n3) {
        for (var p2 = 0, m2 = 1 / 0, w2 = 0, T2 = void 0, E = u.length; w2 < E; w2++)
          T2 = u[w2].getLayout().area, T2 && (T2 < m2 && (m2 = T2), T2 > p2 && (p2 = T2));
        var O2 = u.area * u.area, V3 = o * o * n3;
        return O2 ? bst(V3 * p2 / O2, O2 / (V3 * m2)) : 1 / 0;
      }
      function R_e(u, o, n3, p2, m2) {
        var w2 = o === n3.width ? 0 : 1, T2 = 1 - w2, E = ["x", "y"], O2 = ["width", "height"], V3 = n3[E[w2]], W3 = o ? u.area / o : 0;
        (m2 || W3 > n3[O2[T2]]) && (W3 = n3[O2[T2]]);
        for (var q3 = 0, K = u.length; q3 < K; q3++) {
          var J = u[q3], rt2 = {}, gt = W3 ? J.getLayout().area / W3 : 0, yt = rt2[O2[T2]] = bst(W3 - 2 * p2, 0), At = n3[E[w2]] + n3[O2[w2]] - V3, Lt = q3 === K - 1 || At < gt ? At : gt, Wt = rt2[O2[w2]] = bst(Lt - 2 * p2, 0);
          rt2[E[T2]] = n3[E[T2]] + Hxt(p2, yt / 2), rt2[E[w2]] = V3 + Hxt(p2, Wt / 2), V3 += Lt, J.setLayout(rt2, true);
        }
        n3[E[T2]] += W3, n3[O2[T2]] -= W3;
      }
      function zMn(u, o, n3, p2, m2) {
        var w2 = (o || {}).node, T2 = [p2, m2];
        if (!w2 || w2 === n3)
          return T2;
        for (var E, O2 = p2 * m2, V3 = O2 * u.option.zoomToNodeRatio; E = w2.parentNode; ) {
          for (var W3 = 0, q3 = E.children, K = 0, J = q3.length; K < J; K++)
            W3 += q3[K].getValue();
          var rt2 = w2.getValue();
          if (rt2 === 0)
            return T2;
          V3 *= W3 / rt2;
          var gt = E.getModel(), yt = gt.get(L_e), At = Math.max(yt, F_e(gt));
          V3 += 4 * yt * yt + (3 * yt + At) * Math.pow(V3, 0.5), V3 > mat && (V3 = mat), w2 = E;
        }
        V3 < O2 && (V3 = O2);
        var Lt = Math.pow(V3 / O2, 0.5);
        return [p2 * Lt, m2 * Lt];
      }
      function jMn(u, o, n3) {
        if (o)
          return { x: o.x, y: o.y };
        var p2 = { x: 0, y: 0 };
        if (!n3)
          return p2;
        var m2 = n3.node, w2 = m2.getLayout();
        if (!w2)
          return p2;
        for (var T2 = [w2.width / 2, w2.height / 2], E = m2; E; ) {
          var O2 = E.getLayout();
          T2[0] += O2.x, T2[1] += O2.y, E = E.parentNode;
        }
        return { x: u.width / 2 - T2[0], y: u.height / 2 - T2[1] };
      }
      function N_e(u, o, n3, p2, m2) {
        var w2 = u.getLayout(), T2 = n3[m2], E = T2 && T2 === u;
        if (!(T2 && !E || m2 === n3.length && u !== p2)) {
          u.setLayout({ isInView: true, invisible: !E && !o.intersect(w2), isAboveViewRoot: E }, true);
          var O2 = new Qu(o.x - w2.x, o.y - w2.y, o.width, o.height);
          d7t(u.viewChildren || [], function(V3) {
            N_e(V3, O2, n3, p2, m2 + 1);
          });
        }
      }
      function F_e(u) {
        return u.get(PMn) ? u.get(LMn) : 0;
      }
      function WMn(u) {
        u.registerSeriesModel(oMn), u.registerChartView(_Mn), u.registerVisual(TMn), u.registerLayout(OMn), rMn(u);
      }
      function GMn(u) {
        var o = u.findComponents({ mainType: "legend" });
        !o || !o.length || u.eachSeriesByType("graph", function(n3) {
          var p2 = n3.getCategoriesData(), m2 = n3.getGraph(), w2 = m2.data, T2 = p2.mapArray(p2.getName);
          w2.filterSelf(function(E) {
            var O2 = w2.getItemModel(E), V3 = O2.getShallow("category");
            if (V3 != null) {
              Dh2(V3) && (V3 = T2[V3]);
              for (var W3 = 0; W3 < o.length; W3++)
                if (!o[W3].isSelected(V3))
                  return false;
            }
            return true;
          });
        });
      }
      function HMn(u) {
        var o = {};
        u.eachSeriesByType("graph", function(n3) {
          var p2 = n3.getCategoriesData(), m2 = n3.getData(), w2 = {};
          p2.each(function(T2) {
            var E = p2.getName(T2);
            w2["ec-" + E] = T2;
            var O2 = p2.getItemModel(T2), V3 = O2.getModel("itemStyle").getItemStyle();
            V3.fill || (V3.fill = n3.getColorFromPalette(E, o)), p2.setItemVisual(T2, "style", V3);
            for (var W3 = ["symbol", "symbolSize", "symbolKeepAspect"], q3 = 0; q3 < W3.length; q3++) {
              var K = O2.getShallow(W3[q3], true);
              K != null && p2.setItemVisual(T2, W3[q3], K);
            }
          }), p2.count() && m2.each(function(T2) {
            var E = m2.getItemModel(T2), O2 = E.getShallow("category");
            if (O2 != null) {
              ds(O2) && (O2 = w2["ec-" + O2]);
              var V3 = p2.getItemVisual(O2, "style"), W3 = m2.ensureUniqueItemVisual(T2, "style");
              ua2(W3, V3);
              for (var q3 = ["symbol", "symbolSize", "symbolKeepAspect"], K = 0; K < q3.length; K++)
                m2.setItemVisual(T2, q3[K], p2.getItemVisual(O2, q3[K]));
            }
          });
        });
      }
      function Uxt(u) {
        return u instanceof Array || (u = [u, u]), u;
      }
      function UMn(u) {
        u.eachSeriesByType("graph", function(o) {
          var n3 = o.getGraph(), p2 = o.getEdgeData(), m2 = Uxt(o.get("edgeSymbol")), w2 = Uxt(o.get("edgeSymbolSize"));
          p2.setVisual("fromSymbol", m2 && m2[0]), p2.setVisual("toSymbol", m2 && m2[1]), p2.setVisual("fromSymbolSize", w2 && w2[0]), p2.setVisual("toSymbolSize", w2 && w2[1]), p2.setVisual("style", o.getModel("lineStyle").getLineStyle()), p2.each(function(T2) {
            var E = p2.getItemModel(T2), O2 = n3.getEdgeByIndex(T2), V3 = Uxt(E.getShallow("symbol", true)), W3 = Uxt(E.getShallow("symbolSize", true)), q3 = E.getModel("lineStyle").getLineStyle(), K = p2.ensureUniqueItemVisual(T2, "style");
            switch (ua2(K, q3), K.stroke) {
              case "source": {
                var J = O2.node1.getVisual("style");
                K.stroke = J && J.fill;
                break;
              }
              case "target": {
                var J = O2.node2.getVisual("style");
                K.stroke = J && J.fill;
                break;
              }
            }
            V3[0] && O2.setVisual("fromSymbol", V3[0]), V3[1] && O2.setVisual("toSymbol", V3[1]), W3[0] && O2.setVisual("fromSymbolSize", W3[0]), W3[1] && O2.setVisual("toSymbolSize", W3[1]);
          });
        });
      }
      var g7t = "-->", qxt = function(u) {
        return u.get("autoCurveness") || null;
      }, V_e = function(u, o) {
        var n3 = qxt(u), p2 = 20, m2 = [];
        if (Dh2(n3))
          p2 = n3;
        else if (za2(n3)) {
          u.__curvenessList = n3;
          return;
        }
        o > p2 && (p2 = o);
        var w2 = p2 % 2 ? p2 + 2 : p2 + 3;
        m2 = [];
        for (var T2 = 0; T2 < w2; T2++)
          m2.push((T2 % 2 ? T2 + 1 : T2) / 10 * (T2 % 2 ? -1 : 1));
        u.__curvenessList = m2;
      }, _st = function(u, o, n3) {
        var p2 = [u.id, u.dataIndex].join("."), m2 = [o.id, o.dataIndex].join(".");
        return [n3.uid, p2, m2].join(g7t);
      }, B_e = function(u) {
        var o = u.split(g7t);
        return [o[0], o[2], o[1]].join(g7t);
      }, qMn = function(u, o) {
        var n3 = _st(u.node1, u.node2, o);
        return o.__edgeMap[n3];
      }, ZMn = function(u, o) {
        var n3 = v7t(_st(u.node1, u.node2, o), o), p2 = v7t(_st(u.node2, u.node1, o), o);
        return n3 + p2;
      }, v7t = function(u, o) {
        var n3 = o.__edgeMap;
        return n3[u] ? n3[u].length : 0;
      };
      function $Mn(u) {
        !qxt(u) || (u.__curvenessList = [], u.__edgeMap = {}, V_e(u));
      }
      function YMn(u, o, n3, p2) {
        if (qxt(n3)) {
          var m2 = _st(u, o, n3), w2 = n3.__edgeMap, T2 = w2[B_e(m2)];
          w2[m2] && !T2 ? w2[m2].isForward = true : T2 && w2[m2] && (T2.isForward = true, w2[m2].isForward = false), w2[m2] = w2[m2] || [], w2[m2].push(p2);
        }
      }
      function y7t(u, o, n3, p2) {
        var m2 = qxt(o), w2 = za2(m2);
        if (!m2)
          return null;
        var T2 = qMn(u, o);
        if (!T2)
          return null;
        for (var E = -1, O2 = 0; O2 < T2.length; O2++)
          if (T2[O2] === n3) {
            E = O2;
            break;
          }
        var V3 = ZMn(u, o);
        V_e(o, V3), u.lineStyle = u.lineStyle || {};
        var W3 = _st(u.node1, u.node2, o), q3 = o.__curvenessList, K = w2 || V3 % 2 ? 0 : 1;
        if (T2.isForward)
          return q3[K + E];
        var J = B_e(W3), rt2 = v7t(J, o), gt = q3[E + rt2 + K];
        return p2 ? w2 ? m2 && m2[0] === 0 ? (rt2 + K) % 2 ? gt : -gt : ((rt2 % 2 ? 0 : 1) + K) % 2 ? gt : -gt : (rt2 + K) % 2 ? gt : -gt : q3[E + rt2 + K];
      }
      function z_e(u) {
        var o = u.coordinateSystem;
        if (!(o && o.type !== "view")) {
          var n3 = u.getGraph();
          n3.eachNode(function(p2) {
            var m2 = p2.getModel();
            p2.setLayout([+m2.get("x"), +m2.get("y")]);
          }), j_e(n3, u);
        }
      }
      function j_e(u, o) {
        u.eachEdge(function(n3, p2) {
          var m2 = gv(n3.getModel().get(["lineStyle", "curveness"]), -y7t(n3, o, p2, true), 0), w2 = nM(n3.node1.getLayout()), T2 = nM(n3.node2.getLayout()), E = [w2, T2];
          +m2 && E.push([(w2[0] + T2[0]) / 2 - (w2[1] - T2[1]) * m2, (w2[1] + T2[1]) / 2 - (T2[0] - w2[0]) * m2]), n3.setLayout(E);
        });
      }
      function KMn(u, o) {
        u.eachSeriesByType("graph", function(n3) {
          var p2 = n3.get("layout"), m2 = n3.coordinateSystem;
          if (m2 && m2.type !== "view") {
            var w2 = n3.getData(), T2 = [];
            Xe2(m2.dimensions, function(K) {
              T2 = T2.concat(w2.mapDimensionsAll(K));
            });
            for (var E = 0; E < w2.count(); E++) {
              for (var O2 = [], V3 = false, W3 = 0; W3 < T2.length; W3++) {
                var q3 = w2.get(T2[W3], E);
                isNaN(q3) || (V3 = true), O2.push(q3);
              }
              V3 ? w2.setItemLayout(E, m2.dataToPoint(O2)) : w2.setItemLayout(E, [NaN, NaN]);
            }
            j_e(w2.graph, n3);
          } else
            (!p2 || p2 === "none") && z_e(n3);
        });
      }
      function xst(u) {
        var o = u.coordinateSystem;
        if (o.type !== "view")
          return 1;
        var n3 = u.option.nodeScaleRatio, p2 = o.scaleX, m2 = o.getZoom(), w2 = (m2 - 1) * n3 + 1;
        return w2 / p2;
      }
      function wst(u) {
        var o = u.getVisual("symbolSize");
        return o instanceof Array && (o = (o[0] + o[1]) / 2), +o;
      }
      var W_e = Math.PI, m7t = [];
      function G_e(u, o) {
        var n3 = u.coordinateSystem;
        if (!(n3 && n3.type !== "view")) {
          var p2 = n3.getBoundingRect(), m2 = u.getData(), w2 = m2.graph, T2 = p2.width / 2 + p2.x, E = p2.height / 2 + p2.y, O2 = Math.min(p2.width, p2.height) / 2, V3 = m2.count();
          m2.setLayout({ cx: T2, cy: E }), V3 && (XMn[o](u, w2, m2, O2, T2, E, V3), w2.eachEdge(function(W3, q3) {
            var K = gv(W3.getModel().get(["lineStyle", "curveness"]), y7t(W3, u, q3), 0), J = nM(W3.node1.getLayout()), rt2 = nM(W3.node2.getLayout()), gt, yt = (J[0] + rt2[0]) / 2, At = (J[1] + rt2[1]) / 2;
            +K && (K *= 3, gt = [T2 * K + yt * (1 - K), E * K + At * (1 - K)]), W3.setLayout([J, rt2, gt]);
          }));
        }
      }
      var XMn = { value: function(u, o, n3, p2, m2, w2, T2) {
        var E = 0, O2 = n3.getSum("value"), V3 = Math.PI * 2 / (O2 || T2);
        o.eachNode(function(W3) {
          var q3 = W3.getValue("value"), K = V3 * (O2 ? q3 : 1) / 2;
          E += K, W3.setLayout([p2 * Math.cos(E) + m2, p2 * Math.sin(E) + w2]), E += K;
        });
      }, symbolSize: function(u, o, n3, p2, m2, w2, T2) {
        var E = 0;
        m7t.length = T2;
        var O2 = xst(u);
        o.eachNode(function(q3) {
          var K = wst(q3);
          isNaN(K) && (K = 2), K < 0 && (K = 0), K *= O2;
          var J = Math.asin(K / 2 / p2);
          isNaN(J) && (J = W_e / 2), m7t[q3.dataIndex] = J, E += J * 2;
        });
        var V3 = (2 * W_e - E) / T2 / 2, W3 = 0;
        o.eachNode(function(q3) {
          var K = V3 + m7t[q3.dataIndex];
          W3 += K, q3.setLayout([p2 * Math.cos(W3) + m2, p2 * Math.sin(W3) + w2]), W3 += K;
        });
      } };
      function QMn(u) {
        u.eachSeriesByType("graph", function(o) {
          o.get("layout") === "circular" && G_e(o, "symbolSize");
        });
      }
      var vY = WA;
      function JMn(u, o, n3) {
        for (var p2 = u, m2 = o, w2 = n3.rect, T2 = w2.width, E = w2.height, O2 = [w2.x + T2 / 2, w2.y + E / 2], V3 = n3.gravity == null ? 0.1 : n3.gravity, W3 = 0; W3 < p2.length; W3++) {
          var q3 = p2[W3];
          q3.p || (q3.p = mP(T2 * (Math.random() - 0.5) + O2[0], E * (Math.random() - 0.5) + O2[1])), q3.pp = nM(q3.p), q3.edges = null;
        }
        var K = n3.friction == null ? 0.6 : n3.friction, J = K, rt2, gt;
        return { warmUp: function() {
          J = K * 0.8;
        }, setFixed: function(yt) {
          p2[yt].fixed = true;
        }, setUnfixed: function(yt) {
          p2[yt].fixed = false;
        }, beforeStep: function(yt) {
          rt2 = yt;
        }, afterStep: function(yt) {
          gt = yt;
        }, step: function(yt) {
          rt2 && rt2(p2, m2);
          for (var At = [], Lt = p2.length, Wt = 0; Wt < m2.length; Wt++) {
            var Nt = m2[Wt];
            if (!Nt.ignoreForceLayout) {
              var ue2 = Nt.n1, ie2 = Nt.n2;
              WE(At, ie2.p, ue2.p);
              var pe2 = Vit(At) - Nt.d, xe = ie2.w / (ue2.w + ie2.w);
              isNaN(xe) && (xe = 0), GB(At, At), !ue2.fixed && vY(ue2.p, ue2.p, At, xe * pe2 * J), !ie2.fixed && vY(ie2.p, ie2.p, At, -(1 - xe) * pe2 * J);
            }
          }
          for (var Wt = 0; Wt < Lt; Wt++) {
            var Ce2 = p2[Wt];
            Ce2.fixed || (WE(At, O2, Ce2.p), vY(Ce2.p, Ce2.p, At, V3 * J));
          }
          for (var Wt = 0; Wt < Lt; Wt++)
            for (var ue2 = p2[Wt], Le2 = Wt + 1; Le2 < Lt; Le2++) {
              var ie2 = p2[Le2];
              WE(At, ie2.p, ue2.p);
              var pe2 = Vit(At);
              pe2 === 0 && (Fit(At, Math.random() - 0.5, Math.random() - 0.5), pe2 = 1);
              var ze = (ue2.rep + ie2.rep) / pe2 / pe2;
              !ue2.fixed && vY(ue2.pp, ue2.pp, At, ze), !ie2.fixed && vY(ie2.pp, ie2.pp, At, -ze);
            }
          for (var tn = [], Wt = 0; Wt < Lt; Wt++) {
            var Ce2 = p2[Wt];
            Ce2.fixed || (WE(tn, Ce2.p, Ce2.pp), vY(Ce2.p, Ce2.p, tn, J), w0(Ce2.pp, Ce2.p));
          }
          J = J * 0.992;
          var $e2 = J < 0.01;
          gt && gt(p2, m2, $e2), yt && yt($e2);
        } };
      }
      function tCn(u) {
        u.eachSeriesByType("graph", function(o) {
          var n3 = o.coordinateSystem;
          if (!(n3 && n3.type !== "view"))
            if (o.get("layout") === "force") {
              var p2 = o.preservedPoints || {}, m2 = o.getGraph(), w2 = m2.data, T2 = m2.edgeData, E = o.getModel("force"), O2 = E.get("initLayout");
              o.preservedPoints ? w2.each(function(Wt) {
                var Nt = w2.getId(Wt);
                w2.setItemLayout(Wt, p2[Nt] || [NaN, NaN]);
              }) : !O2 || O2 === "none" ? z_e(o) : O2 === "circular" && G_e(o, "value");
              var V3 = w2.getDataExtent("value"), W3 = T2.getDataExtent("value"), q3 = E.get("repulsion"), K = E.get("edgeLength"), J = za2(q3) ? q3 : [q3, q3], rt2 = za2(K) ? K : [K, K];
              rt2 = [rt2[1], rt2[0]];
              var gt = w2.mapArray("value", function(Wt, Nt) {
                var ue2 = w2.getItemLayout(Nt), ie2 = bp(Wt, V3, J);
                return isNaN(ie2) && (ie2 = (J[0] + J[1]) / 2), { w: ie2, rep: ie2, fixed: w2.getItemModel(Nt).get("fixed"), p: !ue2 || isNaN(ue2[0]) || isNaN(ue2[1]) ? null : ue2 };
              }), yt = T2.mapArray("value", function(Wt, Nt) {
                var ue2 = m2.getEdgeByIndex(Nt), ie2 = bp(Wt, W3, rt2);
                isNaN(ie2) && (ie2 = (rt2[0] + rt2[1]) / 2);
                var pe2 = ue2.getModel(), xe = gv(ue2.getModel().get(["lineStyle", "curveness"]), -y7t(ue2, o, Nt, true), 0);
                return { n1: gt[ue2.node1.dataIndex], n2: gt[ue2.node2.dataIndex], d: ie2, curveness: xe, ignoreForceLayout: pe2.get("ignoreForceLayout") };
              }), At = n3.getBoundingRect(), Lt = JMn(gt, yt, { rect: At, gravity: E.get("gravity"), friction: E.get("friction") });
              Lt.beforeStep(function(Wt, Nt) {
                for (var ue2 = 0, ie2 = Wt.length; ue2 < ie2; ue2++)
                  Wt[ue2].fixed && w0(Wt[ue2].p, m2.getNodeByIndex(ue2).getLayout());
              }), Lt.afterStep(function(Wt, Nt, ue2) {
                for (var ie2 = 0, pe2 = Wt.length; ie2 < pe2; ie2++)
                  Wt[ie2].fixed || m2.getNodeByIndex(ie2).setLayout(Wt[ie2].p), p2[w2.getId(ie2)] = Wt[ie2].p;
                for (var ie2 = 0, pe2 = Nt.length; ie2 < pe2; ie2++) {
                  var xe = Nt[ie2], Ce2 = m2.getEdgeByIndex(ie2), Le2 = xe.n1.p, ze = xe.n2.p, tn = Ce2.getLayout();
                  tn = tn ? tn.slice() : [], tn[0] = tn[0] || [], tn[1] = tn[1] || [], w0(tn[0], Le2), w0(tn[1], ze), +xe.curveness && (tn[2] = [(Le2[0] + ze[0]) / 2 - (Le2[1] - ze[1]) * xe.curveness, (Le2[1] + ze[1]) / 2 - (ze[0] - Le2[0]) * xe.curveness]), Ce2.setLayout(tn);
                }
              }), o.forceLayout = Lt, o.preservedPoints = p2, Lt.step();
            } else
              o.forceLayout = null;
        });
      }
      function eCn(u, o, n3) {
        var p2 = ua2(u.getBoxLayoutParams(), { aspect: n3 });
        return Bm(p2, { width: o.getWidth(), height: o.getHeight() });
      }
      function nCn(u, o) {
        var n3 = [];
        return u.eachSeriesByType("graph", function(p2) {
          var m2 = p2.get("coordinateSystem");
          if (!m2 || m2 === "view") {
            var w2 = p2.getData(), T2 = w2.mapArray(function(yt) {
              var At = w2.getItemModel(yt);
              return [+At.get("x"), +At.get("y")];
            }), E = [], O2 = [];
            w$(T2, E, O2), O2[0] - E[0] === 0 && (O2[0] += 1, E[0] -= 1), O2[1] - E[1] === 0 && (O2[1] += 1, E[1] -= 1);
            var V3 = (O2[0] - E[0]) / (O2[1] - E[1]), W3 = eCn(p2, o, V3);
            isNaN(V3) && (E = [W3.x, W3.y], O2 = [W3.x + W3.width, W3.y + W3.height]);
            var q3 = O2[0] - E[0], K = O2[1] - E[1], J = W3.width, rt2 = W3.height, gt = p2.coordinateSystem = new fst();
            gt.zoomLimit = p2.get("scaleLimit"), gt.setBoundingRect(E[0], E[1], q3, K), gt.setViewRect(W3.x, W3.y, J, rt2), gt.setCenter(p2.get("center")), gt.setZoom(p2.get("zoom")), n3.push(gt);
          }
        }), n3;
      }
      var H_e = My.prototype, b7t = JF.prototype, U_e = function() {
        function u() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
        }
        return u;
      }();
      (function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o;
      })(U_e);
      function _7t(u) {
        return isNaN(+u.cpx1) || isNaN(+u.cpy1);
      }
      var rCn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "ec-line", p2;
        }
        return o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new U_e();
        }, o.prototype.buildPath = function(n3, p2) {
          _7t(p2) ? H_e.buildPath.call(this, n3, p2) : b7t.buildPath.call(this, n3, p2);
        }, o.prototype.pointAt = function(n3) {
          return _7t(this.shape) ? H_e.pointAt.call(this, n3) : b7t.pointAt.call(this, n3);
        }, o.prototype.tangentAt = function(n3) {
          var p2 = this.shape, m2 = _7t(p2) ? [p2.x2 - p2.x1, p2.y2 - p2.y1] : b7t.tangentAt.call(this, n3);
          return GB(m2, m2);
        }, o;
      }(Mc2), iCn = rCn, x7t = ["fromSymbol", "toSymbol"];
      function q_e(u) {
        return "_" + u + "Type";
      }
      function Z_e(u, o, n3) {
        var p2 = o.getItemVisual(n3, u);
        if (!(!p2 || p2 === "none")) {
          var m2 = o.getItemVisual(n3, u + "Size"), w2 = o.getItemVisual(n3, u + "Rotate"), T2 = o.getItemVisual(n3, u + "Offset"), E = o.getItemVisual(n3, u + "KeepAspect"), O2 = Rot(m2), V3 = aY(T2 || 0, O2), W3 = Jy(p2, -O2[0] / 2 + V3[0], -O2[1] / 2 + V3[1], O2[0], O2[1], null, E);
          return W3.__specifiedRotation = w2 == null || isNaN(w2) ? void 0 : +w2 * Math.PI / 180 || 0, W3.name = u, W3;
        }
      }
      function aCn(u) {
        var o = new iCn({ name: "line", subPixelOptimize: true });
        return w7t(o.shape, u), o;
      }
      function w7t(u, o) {
        u.x1 = o[0][0], u.y1 = o[0][1], u.x2 = o[1][0], u.y2 = o[1][1], u.percent = 1;
        var n3 = o[2];
        n3 ? (u.cpx1 = n3[0], u.cpy1 = n3[1]) : (u.cpx1 = NaN, u.cpy1 = NaN);
      }
      var oCn = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this) || this;
          return w2._createLine(n3, p2, m2), w2;
        }
        return o.prototype._createLine = function(n3, p2, m2) {
          var w2 = n3.hostModel, T2 = n3.getItemLayout(p2), E = aCn(T2);
          E.shape.percent = 0, Qg2(E, { shape: { percent: 1 } }, w2, p2), this.add(E), Xe2(x7t, function(O2) {
            var V3 = Z_e(O2, n3, p2);
            this.add(V3), this[q_e(O2)] = n3.getItemVisual(p2, O2);
          }, this), this._updateCommonStl(n3, p2, m2);
        }, o.prototype.updateData = function(n3, p2, m2) {
          var w2 = n3.hostModel, T2 = this.childOfName("line"), E = n3.getItemLayout(p2), O2 = { shape: {} };
          w7t(O2.shape, E), Xf2(T2, O2, w2, p2), Xe2(x7t, function(V3) {
            var W3 = n3.getItemVisual(p2, V3), q3 = q_e(V3);
            if (this[q3] !== W3) {
              this.remove(this.childOfName(V3));
              var K = Z_e(V3, n3, p2);
              this.add(K);
            }
            this[q3] = W3;
          }, this), this._updateCommonStl(n3, p2, m2);
        }, o.prototype.getLinePath = function() {
          return this.childAt(0);
        }, o.prototype._updateCommonStl = function(n3, p2, m2) {
          var w2 = n3.hostModel, T2 = this.childOfName("line"), E = m2 && m2.emphasisLineStyle, O2 = m2 && m2.blurLineStyle, V3 = m2 && m2.selectLineStyle, W3 = m2 && m2.labelStatesModels, q3 = m2 && m2.emphasisDisabled, K = m2 && m2.focus, J = m2 && m2.blurScope;
          if (!m2 || n3.hasItemOption) {
            var rt2 = n3.getItemModel(p2), gt = rt2.getModel("emphasis");
            E = gt.getModel("lineStyle").getLineStyle(), O2 = rt2.getModel(["blur", "lineStyle"]).getLineStyle(), V3 = rt2.getModel(["select", "lineStyle"]).getLineStyle(), q3 = gt.get("disabled"), K = gt.get("focus"), J = gt.get("blurScope"), W3 = Lb2(rt2);
          }
          var yt = n3.getItemVisual(p2, "style"), At = yt.stroke;
          T2.useStyle(yt), T2.style.fill = null, T2.style.strokeNoScale = true, T2.ensureState("emphasis").style = E, T2.ensureState("blur").style = O2, T2.ensureState("select").style = V3, Xe2(x7t, function(ie2) {
            var pe2 = this.childOfName(ie2);
            if (pe2) {
              pe2.setColor(At), pe2.style.opacity = yt.opacity;
              for (var xe = 0; xe < J_.length; xe++) {
                var Ce2 = J_[xe], Le2 = T2.getState(Ce2);
                if (Le2) {
                  var ze = Le2.style || {}, tn = pe2.ensureState(Ce2), $e2 = tn.style || (tn.style = {});
                  ze.stroke != null && ($e2[pe2.__isEmptyBrush ? "stroke" : "fill"] = ze.stroke), ze.opacity != null && ($e2.opacity = ze.opacity);
                }
              }
              pe2.markRedraw();
            }
          }, this);
          var Lt = w2.getRawValue(p2);
          Tw(this, W3, { labelDataIndex: p2, labelFetcher: { getFormattedLabel: function(ie2, pe2) {
            return w2.getFormattedLabel(ie2, pe2, n3.dataType);
          } }, inheritColor: At || "#000", defaultOpacity: yt.opacity, defaultText: (Lt == null ? n3.getName(p2) : isFinite(Lt) ? Ov(Lt) : Lt) + "" });
          var Wt = this.getTextContent();
          if (Wt) {
            var Nt = W3.normal;
            Wt.__align = Wt.style.align, Wt.__verticalAlign = Wt.style.verticalAlign, Wt.__position = Nt.get("position") || "middle";
            var ue2 = Nt.get("distance");
            za2(ue2) || (ue2 = [ue2, ue2]), Wt.__labelDistance = ue2;
          }
          this.setTextConfig({ position: null, local: true, inside: false }), o0(this, K, J, q3);
        }, o.prototype.highlight = function() {
          Vm(this);
        }, o.prototype.downplay = function() {
          pc2(this);
        }, o.prototype.updateLayout = function(n3, p2) {
          this.setLinePoints(n3.getItemLayout(p2));
        }, o.prototype.setLinePoints = function(n3) {
          var p2 = this.childOfName("line");
          w7t(p2.shape, n3), p2.dirty();
        }, o.prototype.beforeUpdate = function() {
          var n3 = this, p2 = n3.childOfName("fromSymbol"), m2 = n3.childOfName("toSymbol"), w2 = n3.getTextContent();
          if (!p2 && !m2 && (!w2 || w2.ignore))
            return;
          for (var T2 = 1, E = this.parent; E; )
            E.scaleX && (T2 /= E.scaleX), E = E.parent;
          var O2 = n3.childOfName("line");
          if (!this.__dirty && !O2.__dirty)
            return;
          var V3 = O2.shape.percent, W3 = O2.pointAt(0), q3 = O2.pointAt(V3), K = WE([], q3, W3);
          GB(K, K);
          function J(Le2, ze) {
            var tn = Le2.__specifiedRotation;
            if (tn == null) {
              var $e2 = O2.tangentAt(ze);
              Le2.attr("rotation", (ze === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2($e2[1], $e2[0]));
            } else
              Le2.attr("rotation", tn);
          }
          if (p2 && (p2.setPosition(W3), J(p2, 0), p2.scaleX = p2.scaleY = T2 * V3, p2.markRedraw()), m2 && (m2.setPosition(q3), J(m2, 1), m2.scaleX = m2.scaleY = T2 * V3, m2.markRedraw()), w2 && !w2.ignore) {
            w2.x = w2.y = 0, w2.originX = w2.originY = 0;
            var rt2 = void 0, gt = void 0, yt = w2.__labelDistance, At = yt[0] * T2, Lt = yt[1] * T2, Wt = V3 / 2, Nt = O2.tangentAt(Wt), ue2 = [Nt[1], -Nt[0]], ie2 = O2.pointAt(Wt);
            ue2[1] > 0 && (ue2[0] = -ue2[0], ue2[1] = -ue2[1]);
            var pe2 = Nt[0] < 0 ? -1 : 1;
            if (w2.__position !== "start" && w2.__position !== "end") {
              var xe = -Math.atan2(Nt[1], Nt[0]);
              q3[0] < W3[0] && (xe = Math.PI + xe), w2.rotation = xe;
            }
            var Ce2 = void 0;
            switch (w2.__position) {
              case "insideStartTop":
              case "insideMiddleTop":
              case "insideEndTop":
              case "middle":
                Ce2 = -Lt, gt = "bottom";
                break;
              case "insideStartBottom":
              case "insideMiddleBottom":
              case "insideEndBottom":
                Ce2 = Lt, gt = "top";
                break;
              default:
                Ce2 = 0, gt = "middle";
            }
            switch (w2.__position) {
              case "end":
                w2.x = K[0] * At + q3[0], w2.y = K[1] * Lt + q3[1], rt2 = K[0] > 0.8 ? "left" : K[0] < -0.8 ? "right" : "center", gt = K[1] > 0.8 ? "top" : K[1] < -0.8 ? "bottom" : "middle";
                break;
              case "start":
                w2.x = -K[0] * At + W3[0], w2.y = -K[1] * Lt + W3[1], rt2 = K[0] > 0.8 ? "right" : K[0] < -0.8 ? "left" : "center", gt = K[1] > 0.8 ? "bottom" : K[1] < -0.8 ? "top" : "middle";
                break;
              case "insideStartTop":
              case "insideStart":
              case "insideStartBottom":
                w2.x = At * pe2 + W3[0], w2.y = W3[1] + Ce2, rt2 = Nt[0] < 0 ? "right" : "left", w2.originX = -At * pe2, w2.originY = -Ce2;
                break;
              case "insideMiddleTop":
              case "insideMiddle":
              case "insideMiddleBottom":
              case "middle":
                w2.x = ie2[0], w2.y = ie2[1] + Ce2, rt2 = "center", w2.originY = -Ce2;
                break;
              case "insideEndTop":
              case "insideEnd":
              case "insideEndBottom":
                w2.x = -At * pe2 + q3[0], w2.y = q3[1] + Ce2, rt2 = Nt[0] >= 0 ? "right" : "left", w2.originX = At * pe2, w2.originY = -Ce2;
                break;
            }
            w2.scaleX = w2.scaleY = T2, w2.setStyle({ verticalAlign: w2.__verticalAlign || gt, align: w2.__align || rt2 });
          }
        }, o;
      }(uu), S7t = oCn, sCn = function() {
        function u(o) {
          this.group = new uu(), this._LineCtor = o || S7t;
        }
        return u.prototype.updateData = function(o) {
          var n3 = this;
          this._progressiveEls = null;
          var p2 = this, m2 = p2.group, w2 = p2._lineData;
          p2._lineData = o, w2 || m2.removeAll();
          var T2 = $_e(o);
          o.diff(w2).add(function(E) {
            n3._doAdd(o, E, T2);
          }).update(function(E, O2) {
            n3._doUpdate(w2, o, O2, E, T2);
          }).remove(function(E) {
            m2.remove(w2.getItemGraphicEl(E));
          }).execute();
        }, u.prototype.updateLayout = function() {
          var o = this._lineData;
          !o || o.eachItemGraphicEl(function(n3, p2) {
            n3.updateLayout(o, p2);
          }, this);
        }, u.prototype.incrementalPrepareUpdate = function(o) {
          this._seriesScope = $_e(o), this._lineData = null, this.group.removeAll();
        }, u.prototype.incrementalUpdate = function(o, n3) {
          this._progressiveEls = [];
          function p2(E) {
            !E.isGroup && !lCn(E) && (E.incremental = true, E.ensureState("emphasis").hoverLayer = true);
          }
          for (var m2 = o.start; m2 < o.end; m2++) {
            var w2 = n3.getItemLayout(m2);
            if (M7t(w2)) {
              var T2 = new this._LineCtor(n3, m2, this._seriesScope);
              T2.traverse(p2), this.group.add(T2), n3.setItemGraphicEl(m2, T2), this._progressiveEls.push(T2);
            }
          }
        }, u.prototype.remove = function() {
          this.group.removeAll();
        }, u.prototype.eachRendered = function(o) {
          n8(this._progressiveEls || this.group, o);
        }, u.prototype._doAdd = function(o, n3, p2) {
          var m2 = o.getItemLayout(n3);
          if (M7t(m2)) {
            var w2 = new this._LineCtor(o, n3, p2);
            o.setItemGraphicEl(n3, w2), this.group.add(w2);
          }
        }, u.prototype._doUpdate = function(o, n3, p2, m2, w2) {
          var T2 = o.getItemGraphicEl(p2);
          if (!M7t(n3.getItemLayout(m2))) {
            this.group.remove(T2);
            return;
          }
          T2 ? T2.updateData(n3, m2, w2) : T2 = new this._LineCtor(n3, m2, w2), n3.setItemGraphicEl(m2, T2), this.group.add(T2);
        }, u;
      }();
      function lCn(u) {
        return u.animators && u.animators.length > 0;
      }
      function $_e(u) {
        var o = u.hostModel, n3 = o.getModel("emphasis");
        return { lineStyle: o.getModel("lineStyle").getLineStyle(), emphasisLineStyle: n3.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: o.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: o.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: n3.get("disabled"), blurScope: n3.get("blurScope"), focus: n3.get("focus"), labelStatesModels: Lb2(o) };
      }
      function Y_e(u) {
        return isNaN(u[0]) || isNaN(u[1]);
      }
      function M7t(u) {
        return u && !Y_e(u[0]) && !Y_e(u[1]);
      }
      var C7t = sCn, T7t = [], A7t = [], I7t = [], yY = lp, D7t = rM, K_e = Math.abs;
      function X_e(u, o, n3) {
        for (var p2 = u[0], m2 = u[1], w2 = u[2], T2 = 1 / 0, E, O2 = n3 * n3, V3 = 0.1, W3 = 0.1; W3 <= 0.9; W3 += 0.1) {
          T7t[0] = yY(p2[0], m2[0], w2[0], W3), T7t[1] = yY(p2[1], m2[1], w2[1], W3);
          var q3 = K_e(D7t(T7t, o) - O2);
          q3 < T2 && (T2 = q3, E = W3);
        }
        for (var K = 0; K < 32; K++) {
          var J = E + V3;
          A7t[0] = yY(p2[0], m2[0], w2[0], E), A7t[1] = yY(p2[1], m2[1], w2[1], E), I7t[0] = yY(p2[0], m2[0], w2[0], J), I7t[1] = yY(p2[1], m2[1], w2[1], J);
          var q3 = D7t(A7t, o) - O2;
          if (K_e(q3) < 0.01)
            break;
          var rt2 = D7t(I7t, o) - O2;
          V3 /= 2, q3 < 0 ? rt2 >= 0 ? E = E + V3 : E = E - V3 : rt2 >= 0 ? E = E - V3 : E = E + V3;
        }
        return E;
      }
      function E7t(u, o) {
        var n3 = [], p2 = EF, m2 = [[], [], []], w2 = [[], []], T2 = [];
        o /= 2, u.eachEdge(function(E, O2) {
          var V3 = E.getLayout(), W3 = E.getVisual("fromSymbol"), q3 = E.getVisual("toSymbol");
          V3.__original || (V3.__original = [nM(V3[0]), nM(V3[1])], V3[2] && V3.__original.push(nM(V3[2])));
          var K = V3.__original;
          if (V3[2] != null) {
            if (w0(m2[0], K[0]), w0(m2[1], K[2]), w0(m2[2], K[1]), W3 && W3 !== "none") {
              var J = wst(E.node1), rt2 = X_e(m2, K[0], J * o);
              p2(m2[0][0], m2[1][0], m2[2][0], rt2, n3), m2[0][0] = n3[3], m2[1][0] = n3[4], p2(m2[0][1], m2[1][1], m2[2][1], rt2, n3), m2[0][1] = n3[3], m2[1][1] = n3[4];
            }
            if (q3 && q3 !== "none") {
              var J = wst(E.node2), rt2 = X_e(m2, K[1], J * o);
              p2(m2[0][0], m2[1][0], m2[2][0], rt2, n3), m2[1][0] = n3[1], m2[2][0] = n3[2], p2(m2[0][1], m2[1][1], m2[2][1], rt2, n3), m2[1][1] = n3[1], m2[2][1] = n3[2];
            }
            w0(V3[0], m2[0]), w0(V3[1], m2[2]), w0(V3[2], m2[1]);
          } else {
            if (w0(w2[0], K[0]), w0(w2[1], K[1]), WE(T2, w2[1], w2[0]), GB(T2, T2), W3 && W3 !== "none") {
              var J = wst(E.node1);
              WA(w2[0], w2[0], T2, J * o);
            }
            if (q3 && q3 !== "none") {
              var J = wst(E.node2);
              WA(w2[1], w2[1], T2, -J * o);
            }
            w0(V3[0], w2[0]), w0(V3[1], w2[1]);
          }
        });
      }
      function Q_e(u) {
        return u.type === "view";
      }
      var uCn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3, p2) {
          var m2 = new rst(), w2 = new C7t(), T2 = this.group;
          this._controller = new ust(p2.getZr()), this._controllerHost = { target: T2 }, T2.add(m2.group), T2.add(w2.group), this._symbolDraw = m2, this._lineDraw = w2, this._firstRender = true;
        }, o.prototype.render = function(n3, p2, m2) {
          var w2 = this, T2 = n3.coordinateSystem;
          this._model = n3;
          var E = this._symbolDraw, O2 = this._lineDraw, V3 = this.group;
          if (Q_e(T2)) {
            var W3 = { x: T2.x, y: T2.y, scaleX: T2.scaleX, scaleY: T2.scaleY };
            this._firstRender ? V3.attr(W3) : Xf2(V3, W3, n3);
          }
          E7t(n3.getGraph(), xst(n3));
          var q3 = n3.getData();
          E.updateData(q3);
          var K = n3.getEdgeData();
          O2.updateData(K), this._updateNodeAndLinkScale(), this._updateController(n3, p2, m2), clearTimeout(this._layoutTimeout);
          var J = n3.forceLayout, rt2 = n3.get(["force", "layoutAnimation"]);
          J && this._startForceLayoutIteration(J, rt2), q3.graph.eachNode(function(Lt) {
            var Wt = Lt.dataIndex, Nt = Lt.getGraphicEl(), ue2 = Lt.getModel();
            if (Nt) {
              Nt.off("drag").off("dragend");
              var ie2 = ue2.get("draggable");
              ie2 && Nt.on("drag", function() {
                J && (J.warmUp(), !w2._layouting && w2._startForceLayoutIteration(J, rt2), J.setFixed(Wt), q3.setItemLayout(Wt, [Nt.x, Nt.y]));
              }).on("dragend", function() {
                J && J.setUnfixed(Wt);
              }), Nt.setDraggable(ie2 && !!J);
              var pe2 = ue2.get(["emphasis", "focus"]);
              pe2 === "adjacency" && (is(Nt).focus = Lt.getAdjacentDataIndices());
            }
          }), q3.graph.eachEdge(function(Lt) {
            var Wt = Lt.getGraphicEl(), Nt = Lt.getModel().get(["emphasis", "focus"]);
            !Wt || Nt === "adjacency" && (is(Wt).focus = { edge: [Lt.dataIndex], node: [Lt.node1.dataIndex, Lt.node2.dataIndex] });
          });
          var gt = n3.get("layout") === "circular" && n3.get(["circular", "rotateLabel"]), yt = q3.getLayout("cx"), At = q3.getLayout("cy");
          q3.eachItemGraphicEl(function(Lt, Wt) {
            var Nt = q3.getItemModel(Wt), ue2 = Nt.get(["label", "rotate"]) || 0, ie2 = Lt.getSymbolPath();
            if (gt) {
              var pe2 = q3.getItemLayout(Wt), xe = Math.atan2(pe2[1] - At, pe2[0] - yt);
              xe < 0 && (xe = Math.PI * 2 + xe);
              var Ce2 = pe2[0] < yt;
              Ce2 && (xe = xe - Math.PI);
              var Le2 = Ce2 ? "left" : "right";
              ie2.setTextConfig({ rotation: -xe, position: Le2, origin: "center" });
              var ze = ie2.ensureState("emphasis");
              ua2(ze.textConfig || (ze.textConfig = {}), { position: Le2 });
            } else
              ie2.setTextConfig({ rotation: ue2 *= Math.PI / 180 });
          }), this._firstRender = false;
        }, o.prototype.dispose = function() {
          this._controller && this._controller.dispose(), this._controllerHost = null;
        }, o.prototype._startForceLayoutIteration = function(n3, p2) {
          var m2 = this;
          (function w2() {
            n3.step(function(T2) {
              m2.updateLayout(m2._model), (m2._layouting = !T2) && (p2 ? m2._layoutTimeout = setTimeout(w2, 16) : w2());
            });
          })();
        }, o.prototype._updateController = function(n3, p2, m2) {
          var w2 = this, T2 = this._controller, E = this._controllerHost, O2 = this.group;
          if (T2.setPointerChecker(function(V3, W3, q3) {
            var K = O2.getBoundingRect();
            return K.applyTransform(O2.transform), K.contain(W3, q3) && !Oxt(V3, m2, n3);
          }), !Q_e(n3.coordinateSystem)) {
            T2.disable();
            return;
          }
          T2.enable(n3.get("roam")), E.zoomLimit = n3.get("scaleLimit"), E.zoom = n3.coordinateSystem.getZoom(), T2.off("pan").off("zoom").on("pan", function(V3) {
            Z9t(E, V3.dx, V3.dy), m2.dispatchAction({ seriesId: n3.id, type: "graphRoam", dx: V3.dx, dy: V3.dy });
          }).on("zoom", function(V3) {
            $9t(E, V3.scale, V3.originX, V3.originY), m2.dispatchAction({ seriesId: n3.id, type: "graphRoam", zoom: V3.scale, originX: V3.originX, originY: V3.originY }), w2._updateNodeAndLinkScale(), E7t(n3.getGraph(), xst(n3)), w2._lineDraw.updateLayout(), m2.updateLabelLayout();
          });
        }, o.prototype._updateNodeAndLinkScale = function() {
          var n3 = this._model, p2 = n3.getData(), m2 = xst(n3);
          p2.eachItemGraphicEl(function(w2, T2) {
            w2 && w2.setSymbolScale(m2);
          });
        }, o.prototype.updateLayout = function(n3) {
          E7t(n3.getGraph(), xst(n3)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
        }, o.prototype.remove = function(n3, p2) {
          this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
        }, o.type = "graph", o;
      }(xg2), cCn = uCn;
      function mY(u) {
        return "_EC_" + u;
      }
      var fCn = function() {
        function u(o) {
          this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = o || false;
        }
        return u.prototype.isDirected = function() {
          return this._directed;
        }, u.prototype.addNode = function(o, n3) {
          o = o == null ? "" + n3 : "" + o;
          var p2 = this._nodesMap;
          if (!p2[mY(o)]) {
            var m2 = new Kz(o, n3);
            return m2.hostGraph = this, this.nodes.push(m2), p2[mY(o)] = m2, m2;
          }
        }, u.prototype.getNodeByIndex = function(o) {
          var n3 = this.data.getRawIndex(o);
          return this.nodes[n3];
        }, u.prototype.getNodeById = function(o) {
          return this._nodesMap[mY(o)];
        }, u.prototype.addEdge = function(o, n3, p2) {
          var m2 = this._nodesMap, w2 = this._edgesMap;
          if (Dh2(o) && (o = this.nodes[o]), Dh2(n3) && (n3 = this.nodes[n3]), o instanceof Kz || (o = m2[mY(o)]), n3 instanceof Kz || (n3 = m2[mY(n3)]), !(!o || !n3)) {
            var T2 = o.id + "-" + n3.id, E = new J_e(o, n3, p2);
            return E.hostGraph = this, this._directed && (o.outEdges.push(E), n3.inEdges.push(E)), o.edges.push(E), o !== n3 && n3.edges.push(E), this.edges.push(E), w2[T2] = E, E;
          }
        }, u.prototype.getEdgeByIndex = function(o) {
          var n3 = this.edgeData.getRawIndex(o);
          return this.edges[n3];
        }, u.prototype.getEdge = function(o, n3) {
          o instanceof Kz && (o = o.id), n3 instanceof Kz && (n3 = n3.id);
          var p2 = this._edgesMap;
          return this._directed ? p2[o + "-" + n3] : p2[o + "-" + n3] || p2[n3 + "-" + o];
        }, u.prototype.eachNode = function(o, n3) {
          for (var p2 = this.nodes, m2 = p2.length, w2 = 0; w2 < m2; w2++)
            p2[w2].dataIndex >= 0 && o.call(n3, p2[w2], w2);
        }, u.prototype.eachEdge = function(o, n3) {
          for (var p2 = this.edges, m2 = p2.length, w2 = 0; w2 < m2; w2++)
            p2[w2].dataIndex >= 0 && p2[w2].node1.dataIndex >= 0 && p2[w2].node2.dataIndex >= 0 && o.call(n3, p2[w2], w2);
        }, u.prototype.breadthFirstTraverse = function(o, n3, p2, m2) {
          if (n3 instanceof Kz || (n3 = this._nodesMap[mY(n3)]), !!n3) {
            for (var w2 = p2 === "out" ? "outEdges" : p2 === "in" ? "inEdges" : "edges", T2 = 0; T2 < this.nodes.length; T2++)
              this.nodes[T2].__visited = false;
            if (!o.call(m2, n3, null))
              for (var E = [n3]; E.length; )
                for (var O2 = E.shift(), V3 = O2[w2], T2 = 0; T2 < V3.length; T2++) {
                  var W3 = V3[T2], q3 = W3.node1 === O2 ? W3.node2 : W3.node1;
                  if (!q3.__visited) {
                    if (o.call(m2, q3, O2))
                      return;
                    E.push(q3), q3.__visited = true;
                  }
                }
          }
        }, u.prototype.update = function() {
          for (var o = this.data, n3 = this.edgeData, p2 = this.nodes, m2 = this.edges, w2 = 0, T2 = p2.length; w2 < T2; w2++)
            p2[w2].dataIndex = -1;
          for (var w2 = 0, T2 = o.count(); w2 < T2; w2++)
            p2[o.getRawIndex(w2)].dataIndex = w2;
          n3.filterSelf(function(E) {
            var O2 = m2[n3.getRawIndex(E)];
            return O2.node1.dataIndex >= 0 && O2.node2.dataIndex >= 0;
          });
          for (var w2 = 0, T2 = m2.length; w2 < T2; w2++)
            m2[w2].dataIndex = -1;
          for (var w2 = 0, T2 = n3.count(); w2 < T2; w2++)
            m2[n3.getRawIndex(w2)].dataIndex = w2;
        }, u.prototype.clone = function() {
          for (var o = new u(this._directed), n3 = this.nodes, p2 = this.edges, m2 = 0; m2 < n3.length; m2++)
            o.addNode(n3[m2].id, n3[m2].dataIndex);
          for (var m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2];
            o.addEdge(w2.node1.id, w2.node2.id, w2.dataIndex);
          }
          return o;
        }, u;
      }(), Kz = function() {
        function u(o, n3) {
          this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = o == null ? "" : o, this.dataIndex = n3 == null ? -1 : n3;
        }
        return u.prototype.degree = function() {
          return this.edges.length;
        }, u.prototype.inDegree = function() {
          return this.inEdges.length;
        }, u.prototype.outDegree = function() {
          return this.outEdges.length;
        }, u.prototype.getModel = function(o) {
          if (!(this.dataIndex < 0)) {
            var n3 = this.hostGraph, p2 = n3.data.getItemModel(this.dataIndex);
            return p2.getModel(o);
          }
        }, u.prototype.getAdjacentDataIndices = function() {
          for (var o = { edge: [], node: [] }, n3 = 0; n3 < this.edges.length; n3++) {
            var p2 = this.edges[n3];
            p2.dataIndex < 0 || (o.edge.push(p2.dataIndex), o.node.push(p2.node1.dataIndex, p2.node2.dataIndex));
          }
          return o;
        }, u;
      }(), J_e = function() {
        function u(o, n3, p2) {
          this.dataIndex = -1, this.node1 = o, this.node2 = n3, this.dataIndex = p2 == null ? -1 : p2;
        }
        return u.prototype.getModel = function(o) {
          if (!(this.dataIndex < 0)) {
            var n3 = this.hostGraph, p2 = n3.edgeData.getItemModel(this.dataIndex);
            return p2.getModel(o);
          }
        }, u.prototype.getAdjacentDataIndices = function() {
          return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
        }, u;
      }();
      function txe(u, o) {
        return { getValue: function(n3) {
          var p2 = this[u][o];
          return p2.getStore().get(p2.getDimensionIndex(n3 || "value"), this.dataIndex);
        }, setVisual: function(n3, p2) {
          this.dataIndex >= 0 && this[u][o].setItemVisual(this.dataIndex, n3, p2);
        }, getVisual: function(n3) {
          return this[u][o].getItemVisual(this.dataIndex, n3);
        }, setLayout: function(n3, p2) {
          this.dataIndex >= 0 && this[u][o].setItemLayout(this.dataIndex, n3, p2);
        }, getLayout: function() {
          return this[u][o].getItemLayout(this.dataIndex);
        }, getGraphicEl: function() {
          return this[u][o].getItemGraphicEl(this.dataIndex);
        }, getRawIndex: function() {
          return this[u][o].getRawIndex(this.dataIndex);
        } };
      }
      x0(Kz, txe("hostGraph", "data")), x0(J_e, txe("hostGraph", "edgeData"));
      var hCn = fCn;
      function exe(u, o, n3, p2, m2) {
        for (var w2 = new hCn(p2), T2 = 0; T2 < u.length; T2++)
          w2.addNode($y(u[T2].id, u[T2].name, T2), T2);
        for (var E = [], O2 = [], V3 = 0, T2 = 0; T2 < o.length; T2++) {
          var W3 = o[T2], q3 = W3.source, K = W3.target;
          w2.addEdge(q3, K, V3) && (O2.push(W3), E.push($y($d2(W3.id, null), q3 + " > " + K)), V3++);
        }
        var J = n3.get("coordinateSystem"), rt2;
        if (J === "cartesian2d" || J === "polar")
          rt2 = T4(u, n3);
        else {
          var gt = Cot.get(J), yt = gt ? gt.dimensions || [] : [];
          sc2(yt, "value") < 0 && yt.concat(["value"]);
          var At = qot(u, { coordDimensions: yt, encodeDefine: n3.getEncode() }).dimensions;
          rt2 = new o2(At, n3), rt2.initData(u);
        }
        var Lt = new o2(["value"], n3);
        return Lt.initData(O2, E), m2 && m2(rt2, Lt), d_e({ mainData: rt2, struct: w2, structAttr: "graph", datas: { node: rt2, edge: Lt }, datasAttr: { node: "data", edge: "edgeData" } }), w2.update(), w2;
      }
      var pCn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.hasSymbolVisual = true, n3;
        }
        return o.prototype.init = function(n3) {
          u.prototype.init.apply(this, arguments);
          var p2 = this;
          function m2() {
            return p2._categoriesData;
          }
          this.legendVisualProvider = new ost(m2, m2), this.fillDataTextStyle(n3.edges || n3.links), this._updateCategoriesData();
        }, o.prototype.mergeOption = function(n3) {
          u.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(n3.edges || n3.links), this._updateCategoriesData();
        }, o.prototype.mergeDefaultAndTheme = function(n3) {
          u.prototype.mergeDefaultAndTheme.apply(this, arguments), t22(n3, "edgeLabel", ["show"]);
        }, o.prototype.getInitialData = function(n3, p2) {
          var m2 = n3.edges || n3.links || [], w2 = n3.data || n3.nodes || [], T2 = this;
          if (w2 && m2) {
            $Mn(this);
            var E = exe(w2, m2, this, true, O2);
            return Xe2(E.edges, function(V3) {
              YMn(V3.node1, V3.node2, this, V3.dataIndex);
            }, this), E.data;
          }
          function O2(V3, W3) {
            V3.wrapMethod("getItemModel", function(rt2) {
              var gt = T2._categoriesModels, yt = rt2.getShallow("category"), At = gt[yt];
              return At && (At.parentModel = rt2.parentModel, rt2.parentModel = At), rt2;
            });
            var q3 = _g.prototype.getModel;
            function K(rt2, gt) {
              var yt = q3.call(this, rt2, gt);
              return yt.resolveParentPath = J, yt;
            }
            W3.wrapMethod("getItemModel", function(rt2) {
              return rt2.resolveParentPath = J, rt2.getModel = K, rt2;
            });
            function J(rt2) {
              if (rt2 && (rt2[0] === "label" || rt2[1] === "label")) {
                var gt = rt2.slice();
                return rt2[0] === "label" ? gt[0] = "edgeLabel" : rt2[1] === "label" && (gt[1] = "edgeLabel"), gt;
              }
              return rt2;
            }
          }
        }, o.prototype.getGraph = function() {
          return this.getData().graph;
        }, o.prototype.getEdgeData = function() {
          return this.getGraph().edgeData;
        }, o.prototype.getCategoriesData = function() {
          return this._categoriesData;
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          if (m2 === "edge") {
            var w2 = this.getData(), T2 = this.getDataParams(n3, m2), E = w2.graph.getEdgeByIndex(n3), O2 = w2.getName(E.node1.dataIndex), V3 = w2.getName(E.node2.dataIndex), W3 = [];
            return O2 != null && W3.push(O2), V3 != null && W3.push(V3), k1("nameValue", { name: W3.join(" > "), value: T2.value, noValue: T2.value == null });
          }
          var q3 = j0e({ series: this, dataIndex: n3, multipleSeries: p2 });
          return q3;
        }, o.prototype._updateCategoriesData = function() {
          var n3 = Ya2(this.option.categories || [], function(m2) {
            return m2.value != null ? m2 : ua2({ value: 0 }, m2);
          }), p2 = new o2(["value"], this);
          p2.initData(n3), this._categoriesData = p2, this._categoriesModels = p2.mapArray(function(m2) {
            return p2.getItemModel(m2);
          });
        }, o.prototype.setZoom = function(n3) {
          this.option.zoom = n3;
        }, o.prototype.setCenter = function(n3) {
          this.option.center = n3;
        }, o.prototype.isAnimationEnabled = function() {
          return u.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
        }, o.type = "series.graph", o.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], o.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, o;
      }(Rv), dCn = pCn, gCn = { type: "graphRoam", event: "graphRoam", update: "none" };
      function vCn(u) {
        u.registerChartView(cCn), u.registerSeriesModel(dCn), u.registerProcessor(GMn), u.registerVisual(HMn), u.registerVisual(UMn), u.registerLayout(KMn), u.registerLayout(u.PRIORITY.VISUAL.POST_CHART_LAYOUT, QMn), u.registerLayout(tCn), u.registerCoordinateSystem("graphView", { dimensions: fst.dimensions, create: nCn }), u.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, Jp), u.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, Jp), u.registerAction(gCn, function(o, n3) {
          n3.eachComponent({ mainType: "series", query: o }, function(p2) {
            var m2 = p2.coordinateSystem, w2 = J9t(m2, o);
            p2.setCenter && p2.setCenter(w2.center), p2.setZoom && p2.setZoom(w2.zoom);
          });
        });
      }
      var yCn = function() {
        function u() {
          this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
        }
        return u;
      }(), mCn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "pointer", p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new yCn();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = Math.cos, w2 = Math.sin, T2 = p2.r, E = p2.width, O2 = p2.angle, V3 = p2.x - m2(O2) * E * (E >= T2 / 3 ? 1 : 2), W3 = p2.y - w2(O2) * E * (E >= T2 / 3 ? 1 : 2);
          O2 = p2.angle - Math.PI / 2, n3.moveTo(V3, W3), n3.lineTo(p2.x + m2(O2) * E, p2.y + w2(O2) * E), n3.lineTo(p2.x + m2(p2.angle) * T2, p2.y + w2(p2.angle) * T2), n3.lineTo(p2.x - m2(O2) * E, p2.y - w2(O2) * E), n3.lineTo(V3, W3);
        }, o;
      }(Mc2), bCn = mCn;
      function _Cn(u, o) {
        var n3 = u.get("center"), p2 = o.getWidth(), m2 = o.getHeight(), w2 = Math.min(p2, m2), T2 = Qo(n3[0], o.getWidth()), E = Qo(n3[1], o.getHeight()), O2 = Qo(u.get("radius"), w2 / 2);
        return { cx: T2, cy: E, r: O2 };
      }
      function Zxt(u, o) {
        var n3 = u == null ? "" : u + "";
        return o && (ds(o) ? n3 = o.replace("{value}", n3) : Sl(o) && (n3 = o(u))), n3;
      }
      var k7t = Math.PI * 2, xCn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          this.group.removeAll();
          var w2 = n3.get(["axisLine", "lineStyle", "color"]), T2 = _Cn(n3, m2);
          this._renderMain(n3, p2, m2, w2, T2), this._data = n3.getData();
        }, o.prototype.dispose = function() {
        }, o.prototype._renderMain = function(n3, p2, m2, w2, T2) {
          for (var E = this.group, O2 = n3.get("clockwise"), V3 = -n3.get("startAngle") / 180 * Math.PI, W3 = -n3.get("endAngle") / 180 * Math.PI, q3 = n3.getModel("axisLine"), K = q3.get("roundCap"), J = K ? Axt : ww, rt2 = q3.get("show"), gt = q3.getModel("lineStyle"), yt = gt.get("width"), At = !((W3 - V3) % k7t) && W3 !== V3 ? k7t : (W3 - V3) % k7t, Lt = V3, Wt = 0; rt2 && Wt < w2.length; Wt++) {
            var Nt = Math.min(Math.max(w2[Wt][0], 0), 1);
            W3 = V3 + At * Nt;
            var ue2 = new J({ shape: { startAngle: Lt, endAngle: W3, cx: T2.cx, cy: T2.cy, clockwise: O2, r0: T2.r - yt, r: T2.r }, silent: true });
            ue2.setStyle({ fill: w2[Wt][1] }), ue2.setStyle(gt.getLineStyle(["color", "width"])), E.add(ue2), Lt = W3;
          }
          var ie2 = function(xe) {
            if (xe <= 0)
              return w2[0][1];
            var Ce2;
            for (Ce2 = 0; Ce2 < w2.length; Ce2++)
              if (w2[Ce2][0] >= xe && (Ce2 === 0 ? 0 : w2[Ce2 - 1][0]) < xe)
                return w2[Ce2][1];
            return w2[Ce2 - 1][1];
          };
          if (!O2) {
            var pe2 = V3;
            V3 = W3, W3 = pe2;
          }
          this._renderTicks(n3, p2, m2, ie2, T2, V3, W3, O2, yt), this._renderTitleAndDetail(n3, p2, m2, ie2, T2), this._renderAnchor(n3, T2), this._renderPointer(n3, p2, m2, ie2, T2, V3, W3, O2, yt);
        }, o.prototype._renderTicks = function(n3, p2, m2, w2, T2, E, O2, V3, W3) {
          for (var q3 = this.group, K = T2.cx, J = T2.cy, rt2 = T2.r, gt = +n3.get("min"), yt = +n3.get("max"), At = n3.getModel("splitLine"), Lt = n3.getModel("axisTick"), Wt = n3.getModel("axisLabel"), Nt = n3.get("splitNumber"), ue2 = Lt.get("splitNumber"), ie2 = Qo(At.get("length"), rt2), pe2 = Qo(Lt.get("length"), rt2), xe = E, Ce2 = (O2 - E) / Nt, Le2 = Ce2 / ue2, ze = At.getModel("lineStyle").getLineStyle(), tn = Lt.getModel("lineStyle").getLineStyle(), $e2 = At.get("distance"), Tn, zn, bn = 0; bn <= Nt; bn++) {
            if (Tn = Math.cos(xe), zn = Math.sin(xe), At.get("show")) {
              var Xr = $e2 ? $e2 + W3 : W3, Xn = new My({ shape: { x1: Tn * (rt2 - Xr) + K, y1: zn * (rt2 - Xr) + J, x2: Tn * (rt2 - ie2 - Xr) + K, y2: zn * (rt2 - ie2 - Xr) + J }, style: ze, silent: true });
              ze.stroke === "auto" && Xn.setStyle({ stroke: w2(bn / Nt) }), q3.add(Xn);
            }
            if (Wt.get("show")) {
              var Xr = Wt.get("distance") + $e2, or = Zxt(Ov(bn / Nt * (yt - gt) + gt), Wt.get("formatter")), Tr = w2(bn / Nt);
              q3.add(new Zc2({ style: Cy(Wt, { text: or, x: Tn * (rt2 - ie2 - Xr) + K, y: zn * (rt2 - ie2 - Xr) + J, verticalAlign: zn < -0.8 ? "top" : zn > 0.8 ? "bottom" : "middle", align: Tn < -0.4 ? "left" : Tn > 0.4 ? "right" : "center" }, { inheritColor: Tr }), silent: true }));
            }
            if (Lt.get("show") && bn !== Nt) {
              var Xr = Lt.get("distance");
              Xr = Xr ? Xr + W3 : W3;
              for (var ci2 = 0; ci2 <= ue2; ci2++) {
                Tn = Math.cos(xe), zn = Math.sin(xe);
                var yi2 = new My({ shape: { x1: Tn * (rt2 - Xr) + K, y1: zn * (rt2 - Xr) + J, x2: Tn * (rt2 - pe2 - Xr) + K, y2: zn * (rt2 - pe2 - Xr) + J }, silent: true, style: tn });
                tn.stroke === "auto" && yi2.setStyle({ stroke: w2((bn + ci2 / ue2) / Nt) }), q3.add(yi2), xe += Le2;
              }
              xe -= Le2;
            } else
              xe += Ce2;
          }
        }, o.prototype._renderPointer = function(n3, p2, m2, w2, T2, E, O2, V3, W3) {
          var q3 = this.group, K = this._data, J = this._progressEls, rt2 = [], gt = n3.get(["pointer", "show"]), yt = n3.getModel("progress"), At = yt.get("show"), Lt = n3.getData(), Wt = Lt.mapDimension("value"), Nt = +n3.get("min"), ue2 = +n3.get("max"), ie2 = [Nt, ue2], pe2 = [E, O2];
          function xe(Le2, ze) {
            var tn = Lt.getItemModel(Le2), $e2 = tn.getModel("pointer"), Tn = Qo($e2.get("width"), T2.r), zn = Qo($e2.get("length"), T2.r), bn = n3.get(["pointer", "icon"]), Xr = $e2.get("offsetCenter"), Xn = Qo(Xr[0], T2.r), or = Qo(Xr[1], T2.r), Tr = $e2.get("keepAspect"), ci2;
            return bn ? ci2 = Jy(bn, Xn - Tn / 2, or - zn, Tn, zn, null, Tr) : ci2 = new bCn({ shape: { angle: -Math.PI / 2, width: Tn, r: zn, x: Xn, y: or } }), ci2.rotation = -(ze + Math.PI / 2), ci2.x = T2.cx, ci2.y = T2.cy, ci2;
          }
          function Ce2(Le2, ze) {
            var tn = yt.get("roundCap"), $e2 = tn ? Axt : ww, Tn = yt.get("overlap"), zn = Tn ? yt.get("width") : W3 / Lt.count(), bn = Tn ? T2.r - zn : T2.r - (Le2 + 1) * zn, Xr = Tn ? T2.r : T2.r - Le2 * zn, Xn = new $e2({ shape: { startAngle: E, endAngle: ze, cx: T2.cx, cy: T2.cy, clockwise: V3, r0: bn, r: Xr } });
            return Tn && (Xn.z2 = ue2 - Lt.get(Wt, Le2) % ue2), Xn;
          }
          (At || gt) && (Lt.diff(K).add(function(Le2) {
            var ze = Lt.get(Wt, Le2);
            if (gt) {
              var tn = xe(Le2, E);
              Qg2(tn, { rotation: -((isNaN(+ze) ? pe2[0] : bp(ze, ie2, pe2, true)) + Math.PI / 2) }, n3), q3.add(tn), Lt.setItemGraphicEl(Le2, tn);
            }
            if (At) {
              var $e2 = Ce2(Le2, E), Tn = yt.get("clip");
              Qg2($e2, { shape: { endAngle: bp(ze, ie2, pe2, Tn) } }, n3), q3.add($e2), qat(n3.seriesIndex, Lt.dataType, Le2, $e2), rt2[Le2] = $e2;
            }
          }).update(function(Le2, ze) {
            var tn = Lt.get(Wt, Le2);
            if (gt) {
              var $e2 = K.getItemGraphicEl(ze), Tn = $e2 ? $e2.rotation : E, zn = xe(Le2, Tn);
              zn.rotation = Tn, Xf2(zn, { rotation: -((isNaN(+tn) ? pe2[0] : bp(tn, ie2, pe2, true)) + Math.PI / 2) }, n3), q3.add(zn), Lt.setItemGraphicEl(Le2, zn);
            }
            if (At) {
              var bn = J[ze], Xr = bn ? bn.shape.endAngle : E, Xn = Ce2(Le2, Xr), or = yt.get("clip");
              Xf2(Xn, { shape: { endAngle: bp(tn, ie2, pe2, or) } }, n3), q3.add(Xn), qat(n3.seriesIndex, Lt.dataType, Le2, Xn), rt2[Le2] = Xn;
            }
          }).execute(), Lt.each(function(Le2) {
            var ze = Lt.getItemModel(Le2), tn = ze.getModel("emphasis"), $e2 = tn.get("focus"), Tn = tn.get("blurScope"), zn = tn.get("disabled");
            if (gt) {
              var bn = Lt.getItemGraphicEl(Le2), Xr = Lt.getItemVisual(Le2, "style"), Xn = Xr.fill;
              if (bn instanceof Fm) {
                var or = bn.style;
                bn.useStyle(ua2({ image: or.image, x: or.x, y: or.y, width: or.width, height: or.height }, Xr));
              } else
                bn.useStyle(Xr), bn.type !== "pointer" && bn.setColor(Xn);
              bn.setStyle(ze.getModel(["pointer", "itemStyle"]).getItemStyle()), bn.style.fill === "auto" && bn.setStyle("fill", w2(bp(Lt.get(Wt, Le2), ie2, [0, 1], true))), bn.z2EmphasisLift = 0, Ky(bn, ze), o0(bn, $e2, Tn, zn);
            }
            if (At) {
              var Tr = rt2[Le2];
              Tr.useStyle(Lt.getItemVisual(Le2, "style")), Tr.setStyle(ze.getModel(["progress", "itemStyle"]).getItemStyle()), Tr.z2EmphasisLift = 0, Ky(Tr, ze), o0(Tr, $e2, Tn, zn);
            }
          }), this._progressEls = rt2);
        }, o.prototype._renderAnchor = function(n3, p2) {
          var m2 = n3.getModel("anchor"), w2 = m2.get("show");
          if (w2) {
            var T2 = m2.get("size"), E = m2.get("icon"), O2 = m2.get("offsetCenter"), V3 = m2.get("keepAspect"), W3 = Jy(E, p2.cx - T2 / 2 + Qo(O2[0], p2.r), p2.cy - T2 / 2 + Qo(O2[1], p2.r), T2, T2, null, V3);
            W3.z2 = m2.get("showAbove") ? 1 : 0, W3.setStyle(m2.getModel("itemStyle").getItemStyle()), this.group.add(W3);
          }
        }, o.prototype._renderTitleAndDetail = function(n3, p2, m2, w2, T2) {
          var E = this, O2 = n3.getData(), V3 = O2.mapDimension("value"), W3 = +n3.get("min"), q3 = +n3.get("max"), K = new uu(), J = [], rt2 = [], gt = n3.isAnimationEnabled(), yt = n3.get(["pointer", "showAbove"]);
          O2.diff(this._data).add(function(At) {
            J[At] = new Zc2({ silent: true }), rt2[At] = new Zc2({ silent: true });
          }).update(function(At, Lt) {
            J[At] = E._titleEls[Lt], rt2[At] = E._detailEls[Lt];
          }).execute(), O2.each(function(At) {
            var Lt = O2.getItemModel(At), Wt = O2.get(V3, At), Nt = new uu(), ue2 = w2(bp(Wt, [W3, q3], [0, 1], true)), ie2 = Lt.getModel("title");
            if (ie2.get("show")) {
              var pe2 = ie2.get("offsetCenter"), xe = T2.cx + Qo(pe2[0], T2.r), Ce2 = T2.cy + Qo(pe2[1], T2.r), Le2 = J[At];
              Le2.attr({ z2: yt ? 0 : 2, style: Cy(ie2, { x: xe, y: Ce2, text: O2.getName(At), align: "center", verticalAlign: "middle" }, { inheritColor: ue2 }) }), Nt.add(Le2);
            }
            var ze = Lt.getModel("detail");
            if (ze.get("show")) {
              var tn = ze.get("offsetCenter"), $e2 = T2.cx + Qo(tn[0], T2.r), Tn = T2.cy + Qo(tn[1], T2.r), zn = Qo(ze.get("width"), T2.r), bn = Qo(ze.get("height"), T2.r), Xr = n3.get(["progress", "show"]) ? O2.getItemVisual(At, "style").fill : ue2, Le2 = rt2[At], Xn = ze.get("formatter");
              Le2.attr({ z2: yt ? 0 : 2, style: Cy(ze, { x: $e2, y: Tn, text: Zxt(Wt, Xn), width: isNaN(zn) ? null : zn, height: isNaN(bn) ? null : bn, align: "center", verticalAlign: "middle" }, { inheritColor: Xr }) }), gve(Le2, { normal: ze }, Wt, function(Tr) {
                return Zxt(Tr, Xn);
              }), gt && vve(Le2, At, O2, n3, { getFormattedLabel: function(Tr, ci2, yi2, Po, Ms, dl) {
                return Zxt(dl ? dl.interpolatedValue : Wt, Xn);
              } }), Nt.add(Le2);
            }
            K.add(Nt);
          }), this.group.add(K), this._titleEls = J, this._detailEls = rt2;
        }, o.type = "gauge", o;
      }(xg2), wCn = xCn, SCn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.visualStyleAccessPath = "itemStyle", n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          return pY(this, ["value"]);
        }, o.type = "series.gauge", o.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, o;
      }(Rv), MCn = SCn;
      function CCn(u) {
        u.registerChartView(wCn), u.registerSeriesModel(MCn);
      }
      var TCn = ["itemStyle", "opacity"], ACn = function(u) {
        tr(o, u);
        function o(n3, p2) {
          var m2 = u.call(this) || this, w2 = m2, T2 = new Mw(), E = new Zc2();
          return w2.setTextContent(E), m2.setTextGuideLine(T2), m2.updateData(n3, p2, true), m2;
        }
        return o.prototype.updateData = function(n3, p2, m2) {
          var w2 = this, T2 = n3.hostModel, E = n3.getItemModel(p2), O2 = n3.getItemLayout(p2), V3 = E.getModel("emphasis"), W3 = E.get(TCn);
          W3 = W3 == null ? 1 : W3, m2 || DC(w2), w2.useStyle(n3.getItemVisual(p2, "style")), w2.style.lineJoin = "round", m2 ? (w2.setShape({ points: O2.points }), w2.style.opacity = 0, Qg2(w2, { style: { opacity: W3 } }, T2, p2)) : Xf2(w2, { style: { opacity: W3 }, shape: { points: O2.points } }, T2, p2), Ky(w2, E), this._updateLabel(n3, p2), o0(this, V3.get("focus"), V3.get("blurScope"), V3.get("disabled"));
        }, o.prototype._updateLabel = function(n3, p2) {
          var m2 = this, w2 = this.getTextGuideLine(), T2 = m2.getTextContent(), E = n3.hostModel, O2 = n3.getItemModel(p2), V3 = n3.getItemLayout(p2), W3 = V3.label, q3 = n3.getItemVisual(p2, "style"), K = q3.fill;
          Tw(T2, Lb2(O2), { labelFetcher: n3.hostModel, labelDataIndex: p2, defaultOpacity: q3.opacity, defaultText: n3.getName(p2) }, { normal: { align: W3.textAlign, verticalAlign: W3.verticalAlign } }), m2.setTextConfig({ local: true, inside: !!W3.inside, insideStroke: K, outsideFill: K });
          var J = W3.linePoints;
          w2.setShape({ points: J }), m2.textGuideLineConfig = { anchor: J ? new Vu(J[0][0], J[0][1]) : null }, Xf2(T2, { style: { x: W3.x, y: W3.y } }, E, p2), T2.attr({ rotation: W3.rotation, originX: W3.x, originY: W3.y, z2: 10 }), d9t(m2, g9t(O2), { stroke: K });
        }, o;
      }(Sw), ICn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.ignoreLabelLineUpdate = true, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this._data, E = this.group;
          w2.diff(T2).add(function(O2) {
            var V3 = new ACn(w2, O2);
            w2.setItemGraphicEl(O2, V3), E.add(V3);
          }).update(function(O2, V3) {
            var W3 = T2.getItemGraphicEl(V3);
            W3.updateData(w2, O2), E.add(W3), w2.setItemGraphicEl(O2, W3);
          }).remove(function(O2) {
            var V3 = T2.getItemGraphicEl(O2);
            Cz(V3, n3, O2);
          }).execute(), this._data = w2;
        }, o.prototype.remove = function() {
          this.group.removeAll(), this._data = null;
        }, o.prototype.dispose = function() {
        }, o.type = "funnel", o;
      }(xg2), DCn = ICn, ECn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3) {
          u.prototype.init.apply(this, arguments), this.legendVisualProvider = new ost(Is(this.getData, this), Is(this.getRawData, this)), this._defaultLabelLine(n3);
        }, o.prototype.getInitialData = function(n3, p2) {
          return pY(this, { coordDimensions: ["value"], encodeDefaulter: wu(l8t, this) });
        }, o.prototype._defaultLabelLine = function(n3) {
          t22(n3, "labelLine", ["show"]);
          var p2 = n3.labelLine, m2 = n3.emphasis.labelLine;
          p2.show = p2.show && n3.label.show, m2.show = m2.show && n3.emphasis.label.show;
        }, o.prototype.getDataParams = function(n3) {
          var p2 = this.getData(), m2 = u.prototype.getDataParams.call(this, n3), w2 = p2.mapDimension("value"), T2 = p2.getSum(w2);
          return m2.percent = T2 ? +(p2.get(w2, n3) / T2 * 100).toFixed(2) : 0, m2.$vars.push("percent"), m2;
        }, o.type = "series.funnel", o.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, o;
      }(Rv), kCn = ECn;
      function PCn(u, o) {
        return Bm(u.getBoxLayoutParams(), { width: o.getWidth(), height: o.getHeight() });
      }
      function LCn(u, o) {
        for (var n3 = u.mapDimension("value"), p2 = u.mapArray(n3, function(O2) {
          return O2;
        }), m2 = [], w2 = o === "ascending", T2 = 0, E = u.count(); T2 < E; T2++)
          m2[T2] = T2;
        return Sl(o) ? m2.sort(o) : o !== "none" && m2.sort(function(O2, V3) {
          return w2 ? p2[O2] - p2[V3] : p2[V3] - p2[O2];
        }), m2;
      }
      function OCn(u) {
        var o = u.hostModel, n3 = o.get("orient");
        u.each(function(p2) {
          var m2 = u.getItemModel(p2), w2 = m2.getModel("label"), T2 = w2.get("position"), E = m2.getModel("labelLine"), O2 = u.getItemLayout(p2), V3 = O2.points, W3 = T2 === "inner" || T2 === "inside" || T2 === "center" || T2 === "insideLeft" || T2 === "insideRight", q3, K, J, rt2;
          if (W3)
            T2 === "insideLeft" ? (K = (V3[0][0] + V3[3][0]) / 2 + 5, J = (V3[0][1] + V3[3][1]) / 2, q3 = "left") : T2 === "insideRight" ? (K = (V3[1][0] + V3[2][0]) / 2 - 5, J = (V3[1][1] + V3[2][1]) / 2, q3 = "right") : (K = (V3[0][0] + V3[1][0] + V3[2][0] + V3[3][0]) / 4, J = (V3[0][1] + V3[1][1] + V3[2][1] + V3[3][1]) / 4, q3 = "center"), rt2 = [[K, J], [K, J]];
          else {
            var gt = void 0, yt = void 0, At = void 0, Lt = void 0, Wt = E.get("length");
            T2 === "left" ? (gt = (V3[3][0] + V3[0][0]) / 2, yt = (V3[3][1] + V3[0][1]) / 2, At = gt - Wt, K = At - 5, q3 = "right") : T2 === "right" ? (gt = (V3[1][0] + V3[2][0]) / 2, yt = (V3[1][1] + V3[2][1]) / 2, At = gt + Wt, K = At + 5, q3 = "left") : T2 === "top" ? (gt = (V3[3][0] + V3[0][0]) / 2, yt = (V3[3][1] + V3[0][1]) / 2, Lt = yt - Wt, J = Lt - 5, q3 = "center") : T2 === "bottom" ? (gt = (V3[1][0] + V3[2][0]) / 2, yt = (V3[1][1] + V3[2][1]) / 2, Lt = yt + Wt, J = Lt + 5, q3 = "center") : T2 === "rightTop" ? (gt = n3 === "horizontal" ? V3[3][0] : V3[1][0], yt = n3 === "horizontal" ? V3[3][1] : V3[1][1], n3 === "horizontal" ? (Lt = yt - Wt, J = Lt - 5, q3 = "center") : (At = gt + Wt, K = At + 5, q3 = "top")) : T2 === "rightBottom" ? (gt = V3[2][0], yt = V3[2][1], n3 === "horizontal" ? (Lt = yt + Wt, J = Lt + 5, q3 = "center") : (At = gt + Wt, K = At + 5, q3 = "bottom")) : T2 === "leftTop" ? (gt = V3[0][0], yt = n3 === "horizontal" ? V3[0][1] : V3[1][1], n3 === "horizontal" ? (Lt = yt - Wt, J = Lt - 5, q3 = "center") : (At = gt - Wt, K = At - 5, q3 = "right")) : T2 === "leftBottom" ? (gt = n3 === "horizontal" ? V3[1][0] : V3[3][0], yt = n3 === "horizontal" ? V3[1][1] : V3[2][1], n3 === "horizontal" ? (Lt = yt + Wt, J = Lt + 5, q3 = "center") : (At = gt - Wt, K = At - 5, q3 = "right")) : (gt = (V3[1][0] + V3[2][0]) / 2, yt = (V3[1][1] + V3[2][1]) / 2, n3 === "horizontal" ? (Lt = yt + Wt, J = Lt + 5, q3 = "center") : (At = gt + Wt, K = At + 5, q3 = "left")), n3 === "horizontal" ? (At = gt, K = At) : (Lt = yt, J = Lt), rt2 = [[gt, yt], [At, Lt]];
          }
          O2.label = { linePoints: rt2, x: K, y: J, verticalAlign: "middle", textAlign: q3, inside: W3 };
        });
      }
      function RCn(u, o) {
        u.eachSeriesByType("funnel", function(n3) {
          var p2 = n3.getData(), m2 = p2.mapDimension("value"), w2 = n3.get("sort"), T2 = PCn(n3, o), E = n3.get("orient"), O2 = T2.width, V3 = T2.height, W3 = LCn(p2, w2), q3 = T2.x, K = T2.y, J = E === "horizontal" ? [Qo(n3.get("minSize"), V3), Qo(n3.get("maxSize"), V3)] : [Qo(n3.get("minSize"), O2), Qo(n3.get("maxSize"), O2)], rt2 = p2.getDataExtent(m2), gt = n3.get("min"), yt = n3.get("max");
          gt == null && (gt = Math.min(rt2[0], 0)), yt == null && (yt = rt2[1]);
          var At = n3.get("funnelAlign"), Lt = n3.get("gap"), Wt = E === "horizontal" ? O2 : V3, Nt = (Wt - Lt * (p2.count() - 1)) / p2.count(), ue2 = function(Tn, zn) {
            if (E === "horizontal") {
              var bn = p2.get(m2, Tn) || 0, Xr = bp(bn, [gt, yt], J, true), Xn = void 0;
              switch (At) {
                case "top":
                  Xn = K;
                  break;
                case "center":
                  Xn = K + (V3 - Xr) / 2;
                  break;
                case "bottom":
                  Xn = K + (V3 - Xr);
                  break;
              }
              return [[zn, Xn], [zn, Xn + Xr]];
            }
            var or = p2.get(m2, Tn) || 0, Tr = bp(or, [gt, yt], J, true), ci2;
            switch (At) {
              case "left":
                ci2 = q3;
                break;
              case "center":
                ci2 = q3 + (O2 - Tr) / 2;
                break;
              case "right":
                ci2 = q3 + O2 - Tr;
                break;
            }
            return [[ci2, zn], [ci2 + Tr, zn]];
          };
          w2 === "ascending" && (Nt = -Nt, Lt = -Lt, E === "horizontal" ? q3 += O2 : K += V3, W3 = W3.reverse());
          for (var ie2 = 0; ie2 < W3.length; ie2++) {
            var pe2 = W3[ie2], xe = W3[ie2 + 1], Ce2 = p2.getItemModel(pe2);
            if (E === "horizontal") {
              var Le2 = Ce2.get(["itemStyle", "width"]);
              Le2 == null ? Le2 = Nt : (Le2 = Qo(Le2, O2), w2 === "ascending" && (Le2 = -Le2));
              var ze = ue2(pe2, q3), tn = ue2(xe, q3 + Le2);
              q3 += Le2 + Lt, p2.setItemLayout(pe2, { points: ze.concat(tn.slice().reverse()) });
            } else {
              var $e2 = Ce2.get(["itemStyle", "height"]);
              $e2 == null ? $e2 = Nt : ($e2 = Qo($e2, V3), w2 === "ascending" && ($e2 = -$e2));
              var ze = ue2(pe2, K), tn = ue2(xe, K + $e2);
              K += $e2 + Lt, p2.setItemLayout(pe2, { points: ze.concat(tn.slice().reverse()) });
            }
          }
          OCn(p2);
        });
      }
      function NCn(u) {
        u.registerChartView(DCn), u.registerSeriesModel(kCn), u.registerLayout(RCn), u.registerProcessor(ast("funnel"));
      }
      var FCn = 0.3, VCn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._dataGroup = new uu(), n3._initialized = false, n3;
        }
        return o.prototype.init = function() {
          this.group.add(this._dataGroup);
        }, o.prototype.render = function(n3, p2, m2, w2) {
          this._progressiveEls = null;
          var T2 = this._dataGroup, E = n3.getData(), O2 = this._data, V3 = n3.coordinateSystem, W3 = V3.dimensions, q3 = ixe(n3);
          E.diff(O2).add(K).update(J).remove(rt2).execute();
          function K(yt) {
            var At = rxe(E, T2, yt, W3, V3);
            P7t(At, E, yt, q3);
          }
          function J(yt, At) {
            var Lt = O2.getItemGraphicEl(At), Wt = nxe(E, yt, W3, V3);
            E.setItemGraphicEl(yt, Lt), Xf2(Lt, { shape: { points: Wt } }, n3, yt), DC(Lt), P7t(Lt, E, yt, q3);
          }
          function rt2(yt) {
            var At = O2.getItemGraphicEl(yt);
            T2.remove(At);
          }
          if (!this._initialized) {
            this._initialized = true;
            var gt = BCn(V3, n3, function() {
              setTimeout(function() {
                T2.removeClipPath();
              });
            });
            T2.setClipPath(gt);
          }
          this._data = E;
        }, o.prototype.incrementalPrepareRender = function(n3, p2, m2) {
          this._initialized = true, this._data = null, this._dataGroup.removeAll();
        }, o.prototype.incrementalRender = function(n3, p2, m2) {
          for (var w2 = p2.getData(), T2 = p2.coordinateSystem, E = T2.dimensions, O2 = ixe(p2), V3 = this._progressiveEls = [], W3 = n3.start; W3 < n3.end; W3++) {
            var q3 = rxe(w2, this._dataGroup, W3, E, T2);
            q3.incremental = true, P7t(q3, w2, W3, O2), V3.push(q3);
          }
        }, o.prototype.remove = function() {
          this._dataGroup && this._dataGroup.removeAll(), this._data = null;
        }, o.type = "parallel", o;
      }(xg2);
      function BCn(u, o, n3) {
        var p2 = u.model, m2 = u.getRect(), w2 = new Vf2({ shape: { x: m2.x, y: m2.y, width: m2.width, height: m2.height } }), T2 = p2.get("layout") === "horizontal" ? "width" : "height";
        return w2.setShape(T2, 0), Qg2(w2, { shape: { width: m2.width, height: m2.height } }, o, n3), w2;
      }
      function nxe(u, o, n3, p2) {
        for (var m2 = [], w2 = 0; w2 < n3.length; w2++) {
          var T2 = n3[w2], E = u.get(u.mapDimension(T2), o);
          zCn(E, p2.getAxis(T2).type) || m2.push(p2.dataToPoint(E, T2));
        }
        return m2;
      }
      function rxe(u, o, n3, p2, m2) {
        var w2 = nxe(u, n3, p2, m2), T2 = new Mw({ shape: { points: w2 }, z2: 10 });
        return o.add(T2), u.setItemGraphicEl(n3, T2), T2;
      }
      function ixe(u) {
        var o = u.get("smooth", true);
        return o === true && (o = FCn), o = QE(o), BB(o) && (o = 0), { smooth: o };
      }
      function P7t(u, o, n3, p2) {
        u.useStyle(o.getItemVisual(n3, "style")), u.style.fill = null, u.setShape("smooth", p2.smooth);
        var m2 = o.getItemModel(n3), w2 = m2.getModel("emphasis");
        Ky(u, m2, "lineStyle"), o0(u, w2.get("focus"), w2.get("blurScope"), w2.get("disabled"));
      }
      function zCn(u, o) {
        return o === "category" ? u == null : u == null || isNaN(u);
      }
      var jCn = VCn, WCn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.visualStyleAccessPath = "lineStyle", n3.visualDrawType = "stroke", n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          return T4(null, this, { useEncodeDefaulter: Is(GCn, null, this) });
        }, o.prototype.getRawIndicesByActiveState = function(n3) {
          var p2 = this.coordinateSystem, m2 = this.getData(), w2 = [];
          return p2.eachActiveState(m2, function(T2, E) {
            n3 === T2 && w2.push(m2.getRawIndex(E));
          }), w2;
        }, o.type = "series.parallel", o.dependencies = ["parallel"], o.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, o;
      }(Rv);
      function GCn(u) {
        var o = u.ecModel.getComponent("parallel", u.get("parallelIndex"));
        if (o) {
          var n3 = {};
          return Xe2(o.dimensions, function(p2) {
            var m2 = HCn(p2);
            n3[p2] = m2;
          }), n3;
        }
      }
      function HCn(u) {
        return +u.replace("dim", "");
      }
      var UCn = WCn, qCn = ["lineStyle", "opacity"], ZCn = { seriesType: "parallel", reset: function(u, o) {
        var n3 = u.coordinateSystem, p2 = { normal: u.get(["lineStyle", "opacity"]), active: u.get("activeOpacity"), inactive: u.get("inactiveOpacity") };
        return { progress: function(m2, w2) {
          n3.eachActiveState(w2, function(T2, E) {
            var O2 = p2[T2];
            if (T2 === "normal" && w2.hasItemOption) {
              var V3 = w2.getItemModel(E).get(qCn, true);
              V3 != null && (O2 = V3);
            }
            var W3 = w2.ensureUniqueItemVisual(E, "style");
            W3.opacity = O2;
          }, m2.start, m2.end);
        } };
      } }, $Cn = ZCn;
      function YCn(u) {
        KCn(u), XCn(u);
      }
      function KCn(u) {
        if (!u.parallel) {
          var o = false;
          Xe2(u.series, function(n3) {
            n3 && n3.type === "parallel" && (o = true);
          }), o && (u.parallel = [{}]);
        }
      }
      function XCn(u) {
        var o = Tp(u.parallelAxis);
        Xe2(o, function(n3) {
          if (ys(n3)) {
            var p2 = n3.parallelIndex || 0, m2 = Tp(u.parallel)[p2];
            m2 && m2.parallelAxisDefault && Cu(n3, m2.parallelAxisDefault, false);
          }
        });
      }
      var QCn = 5, JCn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          this._model = n3, this._api = m2, this._handlers || (this._handlers = {}, Xe2(tTn, function(w2, T2) {
            m2.getZr().on(T2, this._handlers[T2] = Is(w2, this));
          }, this)), nY(this, "_throttledDispatchExpand", n3.get("axisExpandRate"), "fixRate");
        }, o.prototype.dispose = function(n3, p2) {
          kot(this, "_throttledDispatchExpand"), Xe2(this._handlers, function(m2, w2) {
            p2.getZr().off(w2, m2);
          }), this._handlers = null;
        }, o.prototype._throttledDispatchExpand = function(n3) {
          this._dispatchExpand(n3);
        }, o.prototype._dispatchExpand = function(n3) {
          n3 && this._api.dispatchAction(ua2({ type: "parallelAxisExpand" }, n3));
        }, o.type = "parallel", o;
      }(C0), tTn = { mousedown: function(u) {
        L7t(this, "click") && (this._mouseDownPoint = [u.offsetX, u.offsetY]);
      }, mouseup: function(u) {
        var o = this._mouseDownPoint;
        if (L7t(this, "click") && o) {
          var n3 = [u.offsetX, u.offsetY], p2 = Math.pow(o[0] - n3[0], 2) + Math.pow(o[1] - n3[1], 2);
          if (p2 > QCn)
            return;
          var m2 = this._model.coordinateSystem.getSlidedAxisExpandWindow([u.offsetX, u.offsetY]);
          m2.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: m2.axisExpandWindow });
        }
        this._mouseDownPoint = null;
      }, mousemove: function(u) {
        if (!(this._mouseDownPoint || !L7t(this, "mousemove"))) {
          var o = this._model, n3 = o.coordinateSystem.getSlidedAxisExpandWindow([u.offsetX, u.offsetY]), p2 = n3.behavior;
          p2 === "jump" && this._throttledDispatchExpand.debounceNextCall(o.get("axisExpandDebounce")), this._throttledDispatchExpand(p2 === "none" ? null : { axisExpandWindow: n3.axisExpandWindow, animation: p2 === "jump" ? null : { duration: 0 } });
        }
      } };
      function L7t(u, o) {
        var n3 = u._model;
        return n3.get("axisExpandable") && n3.get("axisExpandTriggerOn") === o;
      }
      var eTn = JCn, nTn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function() {
          u.prototype.init.apply(this, arguments), this.mergeOption({});
        }, o.prototype.mergeOption = function(n3) {
          var p2 = this.option;
          n3 && Cu(p2, n3, true), this._initDimensions();
        }, o.prototype.contains = function(n3, p2) {
          var m2 = n3.get("parallelIndex");
          return m2 != null && p2.getComponent("parallel", m2) === this;
        }, o.prototype.setAxisExpand = function(n3) {
          Xe2(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(p2) {
            n3.hasOwnProperty(p2) && (this.option[p2] = n3[p2]);
          }, this);
        }, o.prototype._initDimensions = function() {
          var n3 = this.dimensions = [], p2 = this.parallelAxisIndex = [], m2 = Fp(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(w2) {
            return (w2.get("parallelIndex") || 0) === this.componentIndex;
          }, this);
          Xe2(m2, function(w2) {
            n3.push("dim" + w2.get("dim")), p2.push(w2.componentIndex);
          });
        }, o.type = "parallel", o.dependencies = ["parallelAxis"], o.layoutMode = "box", o.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, o;
      }(kh2), rTn = nTn, iTn = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2, T2) {
          var E = u.call(this, n3, p2, m2) || this;
          return E.type = w2 || "value", E.axisIndex = T2, E;
        }
        return o.prototype.isHorizontal = function() {
          return this.coordinateSystem.getModel().get("layout") !== "horizontal";
        }, o;
      }(ak2), aTn = iTn;
      function Xz(u, o, n3, p2, m2, w2) {
        u = u || 0;
        var T2 = n3[1] - n3[0];
        if (m2 != null && (m2 = bY(m2, [0, T2])), w2 != null && (w2 = Math.max(w2, m2 != null ? m2 : 0)), p2 === "all") {
          var E = Math.abs(o[1] - o[0]);
          E = bY(E, [0, T2]), m2 = w2 = bY(E, [m2, w2]), p2 = 0;
        }
        o[0] = bY(o[0], n3), o[1] = bY(o[1], n3);
        var O2 = O7t(o, p2);
        o[p2] += u;
        var V3 = m2 || 0, W3 = n3.slice();
        O2.sign < 0 ? W3[0] += V3 : W3[1] -= V3, o[p2] = bY(o[p2], W3);
        var q3;
        return q3 = O7t(o, p2), m2 != null && (q3.sign !== O2.sign || q3.span < m2) && (o[1 - p2] = o[p2] + O2.sign * m2), q3 = O7t(o, p2), w2 != null && q3.span > w2 && (o[1 - p2] = o[p2] + q3.sign * w2), o;
      }
      function O7t(u, o) {
        var n3 = u[o] - u[1 - o];
        return { span: Math.abs(n3), sign: n3 > 0 ? -1 : n3 < 0 ? 1 : o ? -1 : 1 };
      }
      function bY(u, o) {
        return Math.min(o[1] != null ? o[1] : 1 / 0, Math.max(o[0] != null ? o[0] : -1 / 0, u));
      }
      var R7t = Xe2, axe = Math.min, oxe = Math.max, sxe = Math.floor, oTn = Math.ceil, lxe = Ov, sTn = Math.PI, lTn = function() {
        function u(o, n3, p2) {
          this.type = "parallel", this._axesMap = pl(), this._axesLayout = {}, this.dimensions = o.dimensions, this._model = o, this._init(o, n3, p2);
        }
        return u.prototype._init = function(o, n3, p2) {
          var m2 = o.dimensions, w2 = o.parallelAxisIndex;
          R7t(m2, function(T2, E) {
            var O2 = w2[E], V3 = n3.getComponent("parallelAxis", O2), W3 = this._axesMap.set(T2, new aTn(T2, vxt(V3), [0, 0], V3.get("type"), O2)), q3 = W3.type === "category";
            W3.onBand = q3 && V3.get("boundaryGap"), W3.inverse = V3.get("inverse"), V3.axis = W3, W3.model = V3, W3.coordinateSystem = V3.coordinateSystem = this;
          }, this);
        }, u.prototype.update = function(o, n3) {
          this._updateAxesFromSeries(this._model, o);
        }, u.prototype.containPoint = function(o) {
          var n3 = this._makeLayoutInfo(), p2 = n3.axisBase, m2 = n3.layoutBase, w2 = n3.pixelDimIndex, T2 = o[1 - w2], E = o[w2];
          return T2 >= p2 && T2 <= p2 + n3.axisLength && E >= m2 && E <= m2 + n3.layoutLength;
        }, u.prototype.getModel = function() {
          return this._model;
        }, u.prototype._updateAxesFromSeries = function(o, n3) {
          n3.eachSeries(function(p2) {
            if (o.contains(p2, n3)) {
              var m2 = p2.getData();
              R7t(this.dimensions, function(w2) {
                var T2 = this._axesMap.get(w2);
                T2.scale.unionExtentFromData(m2, m2.mapDimension(w2)), uY(T2.scale, T2.model);
              }, this);
            }
          }, this);
        }, u.prototype.resize = function(o, n3) {
          this._rect = Bm(o.getBoxLayoutParams(), { width: n3.getWidth(), height: n3.getHeight() }), this._layoutAxes();
        }, u.prototype.getRect = function() {
          return this._rect;
        }, u.prototype._makeLayoutInfo = function() {
          var o = this._model, n3 = this._rect, p2 = ["x", "y"], m2 = ["width", "height"], w2 = o.get("layout"), T2 = w2 === "horizontal" ? 0 : 1, E = n3[m2[T2]], O2 = [0, E], V3 = this.dimensions.length, W3 = $xt(o.get("axisExpandWidth"), O2), q3 = $xt(o.get("axisExpandCount") || 0, [0, V3]), K = o.get("axisExpandable") && V3 > 3 && V3 > q3 && q3 > 1 && W3 > 0 && E > 0, J = o.get("axisExpandWindow"), rt2;
          if (J)
            rt2 = $xt(J[1] - J[0], O2), J[1] = J[0] + rt2;
          else {
            rt2 = $xt(W3 * (q3 - 1), O2);
            var gt = o.get("axisExpandCenter") || sxe(V3 / 2);
            J = [W3 * gt - rt2 / 2], J[1] = J[0] + rt2;
          }
          var yt = (E - rt2) / (V3 - q3);
          yt < 3 && (yt = 0);
          var At = [sxe(lxe(J[0] / W3, 1)) + 1, oTn(lxe(J[1] / W3, 1)) - 1], Lt = yt / W3 * J[0];
          return { layout: w2, pixelDimIndex: T2, layoutBase: n3[p2[T2]], layoutLength: E, axisBase: n3[p2[1 - T2]], axisLength: n3[m2[1 - T2]], axisExpandable: K, axisExpandWidth: W3, axisCollapseWidth: yt, axisExpandWindow: J, axisCount: V3, winInnerIndices: At, axisExpandWindow0Pos: Lt };
        }, u.prototype._layoutAxes = function() {
          var o = this._rect, n3 = this._axesMap, p2 = this.dimensions, m2 = this._makeLayoutInfo(), w2 = m2.layout;
          n3.each(function(T2) {
            var E = [0, m2.axisLength], O2 = T2.inverse ? 1 : 0;
            T2.setExtent(E[O2], E[1 - O2]);
          }), R7t(p2, function(T2, E) {
            var O2 = (m2.axisExpandable ? cTn : uTn)(E, m2), V3 = { horizontal: { x: O2.position, y: m2.axisLength }, vertical: { x: 0, y: O2.position } }, W3 = { horizontal: sTn / 2, vertical: 0 }, q3 = [V3[w2].x + o.x, V3[w2].y + o.y], K = W3[w2], J = yw();
            t4(J, J, K), QS(J, J, q3), this._axesLayout[T2] = { position: q3, rotation: K, transform: J, axisNameAvailableWidth: O2.axisNameAvailableWidth, axisLabelShow: O2.axisLabelShow, nameTruncateMaxWidth: O2.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
          }, this);
        }, u.prototype.getAxis = function(o) {
          return this._axesMap.get(o);
        }, u.prototype.dataToPoint = function(o, n3) {
          return this.axisCoordToPoint(this._axesMap.get(n3).dataToCoord(o), n3);
        }, u.prototype.eachActiveState = function(o, n3, p2, m2) {
          p2 == null && (p2 = 0), m2 == null && (m2 = o.count());
          var w2 = this._axesMap, T2 = this.dimensions, E = [], O2 = [];
          Xe2(T2, function(yt) {
            E.push(o.mapDimension(yt)), O2.push(w2.get(yt).model);
          });
          for (var V3 = this.hasAxisBrushed(), W3 = p2; W3 < m2; W3++) {
            var q3 = void 0;
            if (!V3)
              q3 = "normal";
            else {
              q3 = "active";
              for (var K = o.getValues(E, W3), J = 0, rt2 = T2.length; J < rt2; J++) {
                var gt = O2[J].getActiveState(K[J]);
                if (gt === "inactive") {
                  q3 = "inactive";
                  break;
                }
              }
            }
            n3(q3, W3);
          }
        }, u.prototype.hasAxisBrushed = function() {
          for (var o = this.dimensions, n3 = this._axesMap, p2 = false, m2 = 0, w2 = o.length; m2 < w2; m2++)
            n3.get(o[m2]).model.getActiveState() !== "normal" && (p2 = true);
          return p2;
        }, u.prototype.axisCoordToPoint = function(o, n3) {
          var p2 = this._axesLayout[n3];
          return dc2([o, 0], p2.transform);
        }, u.prototype.getAxisLayout = function(o) {
          return jl(this._axesLayout[o]);
        }, u.prototype.getSlidedAxisExpandWindow = function(o) {
          var n3 = this._makeLayoutInfo(), p2 = n3.pixelDimIndex, m2 = n3.axisExpandWindow.slice(), w2 = m2[1] - m2[0], T2 = [0, n3.axisExpandWidth * (n3.axisCount - 1)];
          if (!this.containPoint(o))
            return { behavior: "none", axisExpandWindow: m2 };
          var E = o[p2] - n3.layoutBase - n3.axisExpandWindow0Pos, O2, V3 = "slide", W3 = n3.axisCollapseWidth, q3 = this._model.get("axisExpandSlideTriggerArea"), K = q3[0] != null;
          if (W3)
            K && W3 && E < w2 * q3[0] ? (V3 = "jump", O2 = E - w2 * q3[2]) : K && W3 && E > w2 * (1 - q3[0]) ? (V3 = "jump", O2 = E - w2 * (1 - q3[2])) : (O2 = E - w2 * q3[1]) >= 0 && (O2 = E - w2 * (1 - q3[1])) <= 0 && (O2 = 0), O2 *= n3.axisExpandWidth / W3, O2 ? Xz(O2, m2, T2, "all") : V3 = "none";
          else {
            var J = m2[1] - m2[0], rt2 = T2[1] * E / J;
            m2 = [oxe(0, rt2 - J / 2)], m2[1] = axe(T2[1], m2[0] + J), m2[0] = m2[1] - J;
          }
          return { axisExpandWindow: m2, behavior: V3 };
        }, u;
      }();
      function $xt(u, o) {
        return axe(oxe(u, o[0]), o[1]);
      }
      function uTn(u, o) {
        var n3 = o.layoutLength / (o.axisCount - 1);
        return { position: n3 * u, axisNameAvailableWidth: n3, axisLabelShow: true };
      }
      function cTn(u, o) {
        var n3 = o.layoutLength, p2 = o.axisExpandWidth, m2 = o.axisCount, w2 = o.axisCollapseWidth, T2 = o.winInnerIndices, E, O2 = w2, V3 = false, W3;
        return u < T2[0] ? (E = u * w2, W3 = w2) : u <= T2[1] ? (E = o.axisExpandWindow0Pos + u * p2 - o.axisExpandWindow[0], O2 = p2, V3 = true) : (E = n3 - (m2 - 1 - u) * w2, W3 = w2), { position: E, axisNameAvailableWidth: O2, axisLabelShow: V3, nameTruncateMaxWidth: W3 };
      }
      var fTn = lTn;
      function hTn(u, o) {
        var n3 = [];
        return u.eachComponent("parallel", function(p2, m2) {
          var w2 = new fTn(p2, u, o);
          w2.name = "parallel_" + m2, w2.resize(p2, o), p2.coordinateSystem = w2, w2.model = p2, n3.push(w2);
        }), u.eachSeries(function(p2) {
          if (p2.get("coordinateSystem") === "parallel") {
            var m2 = p2.getReferringComponents("parallel", Y0).models[0];
            p2.coordinateSystem = m2.coordinateSystem;
          }
        }), n3;
      }
      var pTn = { create: hTn }, dTn = pTn, uxe = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.activeIntervals = [], n3;
        }
        return o.prototype.getAreaSelectStyle = function() {
          return l4([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
        }, o.prototype.setActiveIntervals = function(n3) {
          var p2 = this.activeIntervals = jl(n3);
          if (p2)
            for (var m2 = p2.length - 1; m2 >= 0; m2--)
              K_(p2[m2]);
        }, o.prototype.getActiveState = function(n3) {
          var p2 = this.activeIntervals;
          if (!p2.length)
            return "normal";
          if (n3 == null || isNaN(+n3))
            return "inactive";
          if (p2.length === 1) {
            var m2 = p2[0];
            if (m2[0] <= n3 && n3 <= m2[1])
              return "active";
          } else
            for (var w2 = 0, T2 = p2.length; w2 < T2; w2++)
              if (p2[w2][0] <= n3 && n3 <= p2[w2][1])
                return "active";
          return "inactive";
        }, o;
      }(kh2);
      x0(uxe, Yot);
      var cxe = uxe, Qz = true, Sst = Math.min, _Y = Math.max, gTn = Math.pow, vTn = 1e4, yTn = 6, mTn = 6, fxe = "globalPan", bTn = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, _Tn = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, hxe = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, xTn = 0, wTn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this) || this;
          return p2._track = [], p2._covers = [], p2._handlers = {}, p2._zr = n3, p2.group = new uu(), p2._uid = "brushController_" + xTn++, Xe2(DTn, function(m2, w2) {
            this._handlers[w2] = Is(m2, this);
          }, p2), p2;
        }
        return o.prototype.enableBrush = function(n3) {
          return this._brushType && this._doDisableBrush(), n3.brushType && this._doEnableBrush(n3), this;
        }, o.prototype._doEnableBrush = function(n3) {
          var p2 = this._zr;
          this._enableGlobalPan || PSn(p2, fxe, this._uid), Xe2(this._handlers, function(m2, w2) {
            p2.on(w2, m2);
          }), this._brushType = n3.brushType, this._brushOption = Cu(jl(hxe), n3, true);
        }, o.prototype._doDisableBrush = function() {
          var n3 = this._zr;
          LSn(n3, fxe, this._uid), Xe2(this._handlers, function(p2, m2) {
            n3.off(m2, p2);
          }), this._brushType = this._brushOption = null;
        }, o.prototype.setPanels = function(n3) {
          if (n3 && n3.length) {
            var p2 = this._panels = {};
            Xe2(n3, function(m2) {
              p2[m2.panelId] = jl(m2);
            });
          } else
            this._panels = null;
          return this;
        }, o.prototype.mount = function(n3) {
          n3 = n3 || {}, this._enableGlobalPan = n3.enableGlobalPan;
          var p2 = this.group;
          return this._zr.add(p2), p2.attr({ x: n3.x || 0, y: n3.y || 0, rotation: n3.rotation || 0, scaleX: n3.scaleX || 1, scaleY: n3.scaleY || 1 }), this._transform = p2.getLocalTransform(), this;
        }, o.prototype.updateCovers = function(n3) {
          n3 = Ya2(n3, function(K) {
            return Cu(jl(hxe), K, true);
          });
          var p2 = "\0-brush-index-", m2 = this._covers, w2 = this._covers = [], T2 = this, E = this._creatingCover;
          return new C4(m2, n3, V3, O2).add(W3).update(W3).remove(q3).execute(), this;
          function O2(K, J) {
            return (K.id != null ? K.id : p2 + J) + "-" + K.brushType;
          }
          function V3(K, J) {
            return O2(K.__brushOption, J);
          }
          function W3(K, J) {
            var rt2 = n3[K];
            if (J != null && m2[J] === E)
              w2[K] = m2[J];
            else {
              var gt = w2[K] = J != null ? (m2[J].__brushOption = rt2, m2[J]) : dxe(T2, pxe(T2, rt2));
              N7t(T2, gt);
            }
          }
          function q3(K) {
            m2[K] !== E && T2.group.remove(m2[K]);
          }
        }, o.prototype.unmount = function() {
          return this.enableBrush(false), B7t(this), this._zr.remove(this.group), this;
        }, o.prototype.dispose = function() {
          this.unmount(), this.off();
        }, o;
      }(gw);
      function pxe(u, o) {
        var n3 = Yxt[o.brushType].createCover(u, o);
        return n3.__brushOption = o, vxe(n3, o), u.group.add(n3), n3;
      }
      function dxe(u, o) {
        var n3 = F7t(o);
        return n3.endCreating && (n3.endCreating(u, o), vxe(o, o.__brushOption)), o;
      }
      function gxe(u, o) {
        var n3 = o.__brushOption;
        F7t(o).updateCoverShape(u, o, n3.range, n3);
      }
      function vxe(u, o) {
        var n3 = o.z;
        n3 == null && (n3 = vTn), u.traverse(function(p2) {
          p2.z = n3, p2.z2 = n3;
        });
      }
      function N7t(u, o) {
        F7t(o).updateCommon(u, o), gxe(u, o);
      }
      function F7t(u) {
        return Yxt[u.__brushOption.brushType];
      }
      function V7t(u, o, n3) {
        var p2 = u._panels;
        if (!p2)
          return Qz;
        var m2, w2 = u._transform;
        return Xe2(p2, function(T2) {
          T2.isTargetByCursor(o, n3, w2) && (m2 = T2);
        }), m2;
      }
      function yxe(u, o) {
        var n3 = u._panels;
        if (!n3)
          return Qz;
        var p2 = o.__brushOption.panelId;
        return p2 != null ? n3[p2] : Qz;
      }
      function B7t(u) {
        var o = u._covers, n3 = o.length;
        return Xe2(o, function(p2) {
          u.group.remove(p2);
        }, u), o.length = 0, !!n3;
      }
      function Jz(u, o) {
        var n3 = Ya2(u._covers, function(p2) {
          var m2 = p2.__brushOption, w2 = jl(m2.range);
          return { brushType: m2.brushType, panelId: m2.panelId, range: w2 };
        });
        u.trigger("brush", { areas: n3, isEnd: !!o.isEnd, removeOnClick: !!o.removeOnClick });
      }
      function STn(u) {
        var o = u._track;
        if (!o.length)
          return false;
        var n3 = o[o.length - 1], p2 = o[0], m2 = n3[0] - p2[0], w2 = n3[1] - p2[1], T2 = gTn(m2 * m2 + w2 * w2, 0.5);
        return T2 > yTn;
      }
      function mxe(u) {
        var o = u.length - 1;
        return o < 0 && (o = 0), [u[0], u[o]];
      }
      function bxe(u, o, n3, p2) {
        var m2 = new uu();
        return m2.add(new Vf2({ name: "main", style: j7t(n3), silent: true, draggable: true, cursor: "move", drift: wu(wxe, u, o, m2, ["n", "s", "w", "e"]), ondragend: wu(Jz, o, { isEnd: true }) })), Xe2(p2, function(w2) {
          m2.add(new Vf2({ name: w2.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: wu(wxe, u, o, m2, w2), ondragend: wu(Jz, o, { isEnd: true }) }));
        }), m2;
      }
      function _xe(u, o, n3, p2) {
        var m2 = p2.brushStyle.lineWidth || 0, w2 = _Y(m2, mTn), T2 = n3[0][0], E = n3[1][0], O2 = T2 - m2 / 2, V3 = E - m2 / 2, W3 = n3[0][1], q3 = n3[1][1], K = W3 - w2 + m2 / 2, J = q3 - w2 + m2 / 2, rt2 = W3 - T2, gt = q3 - E, yt = rt2 + m2, At = gt + m2;
        k4(u, o, "main", T2, E, rt2, gt), p2.transformable && (k4(u, o, "w", O2, V3, w2, At), k4(u, o, "e", K, V3, w2, At), k4(u, o, "n", O2, V3, yt, w2), k4(u, o, "s", O2, J, yt, w2), k4(u, o, "nw", O2, V3, w2, w2), k4(u, o, "ne", K, V3, w2, w2), k4(u, o, "sw", O2, J, w2, w2), k4(u, o, "se", K, J, w2, w2));
      }
      function z7t(u, o) {
        var n3 = o.__brushOption, p2 = n3.transformable, m2 = o.childAt(0);
        m2.useStyle(j7t(n3)), m2.attr({ silent: !p2, cursor: p2 ? "move" : "default" }), Xe2([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(w2) {
          var T2 = o.childOfName(w2.join("")), E = w2.length === 1 ? W7t(u, w2[0]) : CTn(u, w2);
          T2 && T2.attr({ silent: !p2, invisible: !p2, cursor: p2 ? _Tn[E] + "-resize" : null });
        });
      }
      function k4(u, o, n3, p2, m2, w2, T2) {
        var E = o.childOfName(n3);
        E && E.setShape(ATn(G7t(u, o, [[p2, m2], [p2 + w2, m2 + T2]])));
      }
      function j7t(u) {
        return kl({ strokeNoScale: true }, u.brushStyle);
      }
      function xxe(u, o, n3, p2) {
        var m2 = [Sst(u, n3), Sst(o, p2)], w2 = [_Y(u, n3), _Y(o, p2)];
        return [[m2[0], w2[0]], [m2[1], w2[1]]];
      }
      function MTn(u) {
        return ku(u.group);
      }
      function W7t(u, o) {
        var n3 = { w: "left", e: "right", n: "top", s: "bottom" }, p2 = { left: "w", right: "e", top: "n", bottom: "s" }, m2 = Gu(n3[o], MTn(u));
        return p2[m2];
      }
      function CTn(u, o) {
        var n3 = [W7t(u, o[0]), W7t(u, o[1])];
        return (n3[0] === "e" || n3[0] === "w") && n3.reverse(), n3.join("");
      }
      function wxe(u, o, n3, p2, m2, w2) {
        var T2 = n3.__brushOption, E = u.toRectRange(T2.range), O2 = Sxe(o, m2, w2);
        Xe2(p2, function(V3) {
          var W3 = bTn[V3];
          E[W3[0]][W3[1]] += O2[W3[0]];
        }), T2.range = u.fromRectRange(xxe(E[0][0], E[1][0], E[0][1], E[1][1])), N7t(o, n3), Jz(o, { isEnd: false });
      }
      function TTn(u, o, n3, p2) {
        var m2 = o.__brushOption.range, w2 = Sxe(u, n3, p2);
        Xe2(m2, function(T2) {
          T2[0] += w2[0], T2[1] += w2[1];
        }), N7t(u, o), Jz(u, { isEnd: false });
      }
      function Sxe(u, o, n3) {
        var p2 = u.group, m2 = p2.transformCoordToLocal(o, n3), w2 = p2.transformCoordToLocal(0, 0);
        return [m2[0] - w2[0], m2[1] - w2[1]];
      }
      function G7t(u, o, n3) {
        var p2 = yxe(u, o);
        return p2 && p2 !== Qz ? p2.clipPath(n3, u._transform) : jl(n3);
      }
      function ATn(u) {
        var o = Sst(u[0][0], u[1][0]), n3 = Sst(u[0][1], u[1][1]), p2 = _Y(u[0][0], u[1][0]), m2 = _Y(u[0][1], u[1][1]);
        return { x: o, y: n3, width: p2 - o, height: m2 - n3 };
      }
      function ITn(u, o, n3) {
        if (!(!u._brushType || ETn(u, o.offsetX, o.offsetY))) {
          var p2 = u._zr, m2 = u._covers, w2 = V7t(u, o, n3);
          if (!u._dragging)
            for (var T2 = 0; T2 < m2.length; T2++) {
              var E = m2[T2].__brushOption;
              if (w2 && (w2 === Qz || E.panelId === w2.panelId) && Yxt[E.brushType].contain(m2[T2], n3[0], n3[1]))
                return;
            }
          w2 && p2.setCursorStyle("crosshair");
        }
      }
      function H7t(u) {
        var o = u.event;
        o.preventDefault && o.preventDefault();
      }
      function U7t(u, o, n3) {
        return u.childOfName("main").contain(o, n3);
      }
      function Mxe(u, o, n3, p2) {
        var m2 = u._creatingCover, w2 = u._creatingPanel, T2 = u._brushOption, E;
        if (u._track.push(n3.slice()), STn(u) || m2) {
          if (w2 && !m2) {
            T2.brushMode === "single" && B7t(u);
            var O2 = jl(T2);
            O2.brushType = Cxe(O2.brushType, w2), O2.panelId = w2 === Qz ? null : w2.panelId, m2 = u._creatingCover = pxe(u, O2), u._covers.push(m2);
          }
          if (m2) {
            var V3 = Yxt[Cxe(u._brushType, w2)], W3 = m2.__brushOption;
            W3.range = V3.getCreatingRange(G7t(u, m2, u._track)), p2 && (dxe(u, m2), V3.updateCommon(u, m2)), gxe(u, m2), E = { isEnd: p2 };
          }
        } else
          p2 && T2.brushMode === "single" && T2.removeOnClick && V7t(u, o, n3) && B7t(u) && (E = { isEnd: p2, removeOnClick: true });
        return E;
      }
      function Cxe(u, o) {
        return u === "auto" ? o.defaultBrushType : u;
      }
      var DTn = { mousedown: function(u) {
        if (this._dragging)
          Txe(this, u);
        else if (!u.target || !u.target.draggable) {
          H7t(u);
          var o = this.group.transformCoordToLocal(u.offsetX, u.offsetY);
          this._creatingCover = null;
          var n3 = this._creatingPanel = V7t(this, u, o);
          n3 && (this._dragging = true, this._track = [o.slice()]);
        }
      }, mousemove: function(u) {
        var o = u.offsetX, n3 = u.offsetY, p2 = this.group.transformCoordToLocal(o, n3);
        if (ITn(this, u, p2), this._dragging) {
          H7t(u);
          var m2 = Mxe(this, u, p2, false);
          m2 && Jz(this, m2);
        }
      }, mouseup: function(u) {
        Txe(this, u);
      } };
      function Txe(u, o) {
        if (u._dragging) {
          H7t(o);
          var n3 = o.offsetX, p2 = o.offsetY, m2 = u.group.transformCoordToLocal(n3, p2), w2 = Mxe(u, o, m2, true);
          u._dragging = false, u._track = [], u._creatingCover = null, w2 && Jz(u, w2);
        }
      }
      function ETn(u, o, n3) {
        var p2 = u._zr;
        return o < 0 || o > p2.getWidth() || n3 < 0 || n3 > p2.getHeight();
      }
      var Yxt = { lineX: Axe(0), lineY: Axe(1), rect: { createCover: function(u, o) {
        function n3(p2) {
          return p2;
        }
        return bxe({ toRectRange: n3, fromRectRange: n3 }, u, o, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
      }, getCreatingRange: function(u) {
        var o = mxe(u);
        return xxe(o[1][0], o[1][1], o[0][0], o[0][1]);
      }, updateCoverShape: function(u, o, n3, p2) {
        _xe(u, o, n3, p2);
      }, updateCommon: z7t, contain: U7t }, polygon: { createCover: function(u, o) {
        var n3 = new uu();
        return n3.add(new Mw({ name: "main", style: j7t(o), silent: true })), n3;
      }, getCreatingRange: function(u) {
        return u;
      }, endCreating: function(u, o) {
        o.remove(o.childAt(0)), o.add(new Sw({ name: "main", draggable: true, drift: wu(TTn, u, o), ondragend: wu(Jz, u, { isEnd: true }) }));
      }, updateCoverShape: function(u, o, n3, p2) {
        o.childAt(0).setShape({ points: G7t(u, o, n3) });
      }, updateCommon: z7t, contain: U7t } };
      function Axe(u) {
        return { createCover: function(o, n3) {
          return bxe({ toRectRange: function(p2) {
            var m2 = [p2, [0, 100]];
            return u && m2.reverse(), m2;
          }, fromRectRange: function(p2) {
            return p2[u];
          } }, o, n3, [[["w"], ["e"]], [["n"], ["s"]]][u]);
        }, getCreatingRange: function(o) {
          var n3 = mxe(o), p2 = Sst(n3[0][u], n3[1][u]), m2 = _Y(n3[0][u], n3[1][u]);
          return [p2, m2];
        }, updateCoverShape: function(o, n3, p2, m2) {
          var w2, T2 = yxe(o, n3);
          if (T2 !== Qz && T2.getLinearBrushOtherExtent)
            w2 = T2.getLinearBrushOtherExtent(u);
          else {
            var E = o._zr;
            w2 = [0, [E.getWidth(), E.getHeight()][1 - u]];
          }
          var O2 = [p2, w2];
          u && O2.reverse(), _xe(o, n3, O2, m2);
        }, updateCommon: z7t, contain: U7t };
      }
      var q7t = wTn;
      function Ixe(u) {
        return u = Z7t(u), function(o) {
          return Pb2(o, u);
        };
      }
      function Dxe(u, o) {
        return u = Z7t(u), function(n3) {
          var p2 = o != null ? o : n3, m2 = p2 ? u.width : u.height, w2 = p2 ? u.x : u.y;
          return [w2, w2 + (m2 || 0)];
        };
      }
      function Exe(u, o, n3) {
        var p2 = Z7t(u);
        return function(m2, w2) {
          return p2.contain(w2[0], w2[1]) && !Oxt(m2, o, n3);
        };
      }
      function Z7t(u) {
        return Qu.create(u);
      }
      var kTn = ["axisLine", "axisTickLabel", "axisName"], PTn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3, p2) {
          u.prototype.init.apply(this, arguments), (this._brushController = new q7t(p2.getZr())).on("brush", Is(this._onBrush, this));
        }, o.prototype.render = function(n3, p2, m2, w2) {
          if (!LTn(n3, p2, w2)) {
            this.axisModel = n3, this.api = m2, this.group.removeAll();
            var T2 = this._axisGroup;
            if (this._axisGroup = new uu(), this.group.add(this._axisGroup), !!n3.get("show")) {
              var E = RTn(n3, p2), O2 = E.coordinateSystem, V3 = n3.getAreaSelectStyle(), W3 = V3.width, q3 = n3.axis.dim, K = O2.getAxisLayout(q3), J = ua2({ strokeContainThreshold: W3 }, K), rt2 = new D4(n3, J);
              Xe2(kTn, rt2.add, rt2), this._axisGroup.add(rt2.getGroup()), this._refreshBrushController(J, V3, n3, E, W3, m2), E1(T2, this._axisGroup, n3);
            }
          }
        }, o.prototype._refreshBrushController = function(n3, p2, m2, w2, T2, E) {
          var O2 = m2.axis.getExtent(), V3 = O2[1] - O2[0], W3 = Math.min(30, Math.abs(V3) * 0.1), q3 = Qu.create({ x: O2[0], y: -T2 / 2, width: V3, height: T2 });
          q3.x -= W3, q3.width += 2 * W3, this._brushController.mount({ enableGlobalPan: true, rotation: n3.rotation, x: n3.position[0], y: n3.position[1] }).setPanels([{ panelId: "pl", clipPath: Ixe(q3), isTargetByCursor: Exe(q3, E, w2), getLinearBrushOtherExtent: Dxe(q3, 0) }]).enableBrush({ brushType: "lineX", brushStyle: p2, removeOnClick: true }).updateCovers(OTn(m2));
        }, o.prototype._onBrush = function(n3) {
          var p2 = n3.areas, m2 = this.axisModel, w2 = m2.axis, T2 = Ya2(p2, function(E) {
            return [w2.coordToData(E.range[0], true), w2.coordToData(E.range[1], true)];
          });
          (!m2.option.realtime === n3.isEnd || n3.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: m2.id, intervals: T2 });
        }, o.prototype.dispose = function() {
          this._brushController.dispose();
        }, o.type = "parallelAxis", o;
      }(C0);
      function LTn(u, o, n3) {
        return n3 && n3.type === "axisAreaSelect" && o.findComponents({ mainType: "parallelAxis", query: n3 })[0] === u;
      }
      function OTn(u) {
        var o = u.axis;
        return Ya2(u.activeIntervals, function(n3) {
          return { brushType: "lineX", panelId: "pl", range: [o.dataToCoord(n3[0], true), o.dataToCoord(n3[1], true)] };
        });
      }
      function RTn(u, o) {
        return o.getComponent("parallel", u.get("parallelIndex"));
      }
      var NTn = PTn, FTn = { type: "axisAreaSelect", event: "axisAreaSelected" };
      function VTn(u) {
        u.registerAction(FTn, function(o, n3) {
          n3.eachComponent({ mainType: "parallelAxis", query: o }, function(p2) {
            p2.axis.model.setActiveIntervals(o.intervals);
          });
        }), u.registerAction("parallelAxisExpand", function(o, n3) {
          n3.eachComponent({ mainType: "parallel", query: o }, function(p2) {
            p2.setAxisExpand(o);
          });
        });
      }
      var BTn = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
      function kxe(u) {
        u.registerComponentView(eTn), u.registerComponentModel(rTn), u.registerCoordinateSystem("parallel", dTn), u.registerPreprocessor(YCn), u.registerComponentModel(cxe), u.registerComponentView(NTn), dY(u, "parallel", cxe, BTn), VTn(u);
      }
      function zTn(u) {
        Rc2(kxe), u.registerChartView(jCn), u.registerSeriesModel(UCn), u.registerVisual(u.PRIORITY.VISUAL.BRUSH, $Cn);
      }
      var jTn = function() {
        function u() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
        }
        return u;
      }(), WTn = function(u) {
        tr(o, u);
        function o(n3) {
          return u.call(this, n3) || this;
        }
        return o.prototype.getDefaultShape = function() {
          return new jTn();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.extent;
          n3.moveTo(p2.x1, p2.y1), n3.bezierCurveTo(p2.cpx1, p2.cpy1, p2.cpx2, p2.cpy2, p2.x2, p2.y2), p2.orient === "vertical" ? (n3.lineTo(p2.x2 + m2, p2.y2), n3.bezierCurveTo(p2.cpx2 + m2, p2.cpy2, p2.cpx1 + m2, p2.cpy1, p2.x1 + m2, p2.y1)) : (n3.lineTo(p2.x2, p2.y2 + m2), n3.bezierCurveTo(p2.cpx2, p2.cpy2 + m2, p2.cpx1, p2.cpy1 + m2, p2.x1, p2.y1 + m2)), n3.closePath();
        }, o.prototype.highlight = function() {
          Vm(this);
        }, o.prototype.downplay = function() {
          pc2(this);
        }, o;
      }(Mc2), GTn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._focusAdjacencyDisabled = false, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = this, T2 = n3.getGraph(), E = this.group, O2 = n3.layoutInfo, V3 = O2.width, W3 = O2.height, q3 = n3.getData(), K = n3.getData("edge"), J = n3.get("orient");
          this._model = n3, E.removeAll(), E.x = O2.x, E.y = O2.y, T2.eachEdge(function(rt2) {
            var gt = new WTn(), yt = is(gt);
            yt.dataIndex = rt2.dataIndex, yt.seriesIndex = n3.seriesIndex, yt.dataType = "edge";
            var At = rt2.getModel(), Lt = At.getModel("lineStyle"), Wt = Lt.get("curveness"), Nt = rt2.node1.getLayout(), ue2 = rt2.node1.getModel(), ie2 = ue2.get("localX"), pe2 = ue2.get("localY"), xe = rt2.node2.getLayout(), Ce2 = rt2.node2.getModel(), Le2 = Ce2.get("localX"), ze = Ce2.get("localY"), tn = rt2.getLayout(), $e2, Tn, zn, bn, Xr, Xn, or, Tr;
            switch (gt.shape.extent = Math.max(1, tn.dy), gt.shape.orient = J, J === "vertical" ? ($e2 = (ie2 != null ? ie2 * V3 : Nt.x) + tn.sy, Tn = (pe2 != null ? pe2 * W3 : Nt.y) + Nt.dy, zn = (Le2 != null ? Le2 * V3 : xe.x) + tn.ty, bn = ze != null ? ze * W3 : xe.y, Xr = $e2, Xn = Tn * (1 - Wt) + bn * Wt, or = zn, Tr = Tn * Wt + bn * (1 - Wt)) : ($e2 = (ie2 != null ? ie2 * V3 : Nt.x) + Nt.dx, Tn = (pe2 != null ? pe2 * W3 : Nt.y) + tn.sy, zn = Le2 != null ? Le2 * V3 : xe.x, bn = (ze != null ? ze * W3 : xe.y) + tn.ty, Xr = $e2 * (1 - Wt) + zn * Wt, Xn = Tn, or = $e2 * Wt + zn * (1 - Wt), Tr = bn), gt.setShape({ x1: $e2, y1: Tn, x2: zn, y2: bn, cpx1: Xr, cpy1: Xn, cpx2: or, cpy2: Tr }), gt.useStyle(Lt.getItemStyle()), gt.style.fill) {
              case "source":
                gt.style.fill = rt2.node1.getVisual("color"), gt.style.decal = rt2.node1.getVisual("style").decal;
                break;
              case "target":
                gt.style.fill = rt2.node2.getVisual("color"), gt.style.decal = rt2.node2.getVisual("style").decal;
                break;
              case "gradient":
                var ci2 = rt2.node1.getVisual("color"), yi2 = rt2.node2.getVisual("color");
                ds(ci2) && ds(yi2) && (gt.style.fill = new Mz(0, 0, +(J === "horizontal"), +(J === "vertical"), [{ color: ci2, offset: 0 }, { color: yi2, offset: 1 }]));
            }
            var Po = At.getModel("emphasis");
            Ky(gt, At, "lineStyle", function(dl) {
              return dl.getItemStyle();
            }), E.add(gt), K.setItemGraphicEl(rt2.dataIndex, gt);
            var Ms = Po.get("focus");
            o0(gt, Ms === "adjacency" ? rt2.getAdjacentDataIndices() : Ms, Po.get("blurScope"), Po.get("disabled")), is(gt).dataType = "edge";
          }), T2.eachNode(function(rt2) {
            var gt = rt2.getLayout(), yt = rt2.getModel(), At = yt.get("localX"), Lt = yt.get("localY"), Wt = yt.getModel("emphasis"), Nt = new Vf2({ shape: { x: At != null ? At * V3 : gt.x, y: Lt != null ? Lt * W3 : gt.y, width: gt.dx, height: gt.dy }, style: yt.getModel("itemStyle").getItemStyle(), z2: 10 });
            Tw(Nt, Lb2(yt), { labelFetcher: n3, labelDataIndex: rt2.dataIndex, defaultText: rt2.id }), Nt.disableLabelAnimation = true, Nt.setStyle("fill", rt2.getVisual("color")), Nt.setStyle("decal", rt2.getVisual("style").decal), Ky(Nt, yt), E.add(Nt), q3.setItemGraphicEl(rt2.dataIndex, Nt), is(Nt).dataType = "node";
            var ue2 = Wt.get("focus");
            o0(Nt, ue2 === "adjacency" ? rt2.getAdjacentDataIndices() : ue2, Wt.get("blurScope"), Wt.get("disabled"));
          }), q3.eachItemGraphicEl(function(rt2, gt) {
            var yt = q3.getItemModel(gt);
            yt.get("draggable") && (rt2.drift = function(At, Lt) {
              w2._focusAdjacencyDisabled = true, this.shape.x += At, this.shape.y += Lt, this.dirty(), m2.dispatchAction({ type: "dragNode", seriesId: n3.id, dataIndex: q3.getRawIndex(gt), localX: this.shape.x / V3, localY: this.shape.y / W3 });
            }, rt2.ondragend = function() {
              w2._focusAdjacencyDisabled = false;
            }, rt2.draggable = true, rt2.cursor = "move");
          }), !this._data && n3.isAnimationEnabled() && E.setClipPath(HTn(E.getBoundingRect(), n3, function() {
            E.removeClipPath();
          })), this._data = n3.getData();
        }, o.prototype.dispose = function() {
        }, o.type = "sankey", o;
      }(xg2);
      function HTn(u, o, n3) {
        var p2 = new Vf2({ shape: { x: u.x - 10, y: u.y - 10, width: 0, height: u.height + 20 } });
        return Qg2(p2, { shape: { width: u.width + 20 } }, o, n3), p2;
      }
      var UTn = GTn, qTn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          var m2 = n3.edges || n3.links, w2 = n3.data || n3.nodes, T2 = n3.levels;
          this.levelModels = [];
          for (var E = this.levelModels, O2 = 0; O2 < T2.length; O2++)
            T2[O2].depth != null && T2[O2].depth >= 0 && (E[T2[O2].depth] = new _g(T2[O2], this, p2));
          if (w2 && m2) {
            var V3 = exe(w2, m2, this, true, W3);
            return V3.data;
          }
          function W3(q3, K) {
            q3.wrapMethod("getItemModel", function(J, rt2) {
              var gt = J.parentModel, yt = gt.getData().getItemLayout(rt2);
              if (yt) {
                var At = yt.depth, Lt = gt.levelModels[At];
                Lt && (J.parentModel = Lt);
              }
              return J;
            }), K.wrapMethod("getItemModel", function(J, rt2) {
              var gt = J.parentModel, yt = gt.getGraph().getEdgeByIndex(rt2), At = yt.node1.getLayout();
              if (At) {
                var Lt = At.depth, Wt = gt.levelModels[Lt];
                Wt && (J.parentModel = Wt);
              }
              return J;
            });
          }
        }, o.prototype.setNodePosition = function(n3, p2) {
          var m2 = this.option.data || this.option.nodes, w2 = m2[n3];
          w2.localX = p2[0], w2.localY = p2[1];
        }, o.prototype.getGraph = function() {
          return this.getData().graph;
        }, o.prototype.getEdgeData = function() {
          return this.getGraph().edgeData;
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          function w2(J) {
            return isNaN(J) || J == null;
          }
          if (m2 === "edge") {
            var T2 = this.getDataParams(n3, m2), E = T2.data, O2 = T2.value, V3 = E.source + " -- " + E.target;
            return k1("nameValue", { name: V3, value: O2, noValue: w2(O2) });
          } else {
            var W3 = this.getGraph().getNodeByIndex(n3), q3 = W3.getLayout().value, K = this.getDataParams(n3, m2).data.name;
            return k1("nameValue", { name: K != null ? K + "" : null, value: q3, noValue: w2(q3) });
          }
        }, o.prototype.optionUpdated = function() {
        }, o.prototype.getDataParams = function(n3, p2) {
          var m2 = u.prototype.getDataParams.call(this, n3, p2);
          if (m2.value == null && p2 === "node") {
            var w2 = this.getGraph().getNodeByIndex(n3), T2 = w2.getLayout().value;
            m2.value = T2;
          }
          return m2;
        }, o.type = "series.sankey", o.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, o;
      }(Rv), ZTn = qTn;
      function $Tn(u, o) {
        u.eachSeriesByType("sankey", function(n3) {
          var p2 = n3.get("nodeWidth"), m2 = n3.get("nodeGap"), w2 = YTn(n3, o);
          n3.layoutInfo = w2;
          var T2 = w2.width, E = w2.height, O2 = n3.getGraph(), V3 = O2.nodes, W3 = O2.edges;
          XTn(V3);
          var q3 = Fp(V3, function(gt) {
            return gt.getLayout().value === 0;
          }), K = q3.length !== 0 ? 0 : n3.get("layoutIterations"), J = n3.get("orient"), rt2 = n3.get("nodeAlign");
          KTn(V3, W3, p2, m2, T2, E, K, J, rt2);
        });
      }
      function YTn(u, o) {
        return Bm(u.getBoxLayoutParams(), { width: o.getWidth(), height: o.getHeight() });
      }
      function KTn(u, o, n3, p2, m2, w2, T2, E, O2) {
        QTn(u, o, n3, m2, w2, E, O2), nAn(u, o, w2, m2, p2, T2, E), fAn(u, E);
      }
      function XTn(u) {
        Xe2(u, function(o) {
          var n3 = y8(o.outEdges, Kxt), p2 = y8(o.inEdges, Kxt), m2 = o.getValue() || 0, w2 = Math.max(n3, p2, m2);
          o.setLayout({ value: w2 }, true);
        });
      }
      function QTn(u, o, n3, p2, m2, w2, T2) {
        for (var E = [], O2 = [], V3 = [], W3 = [], q3 = 0, K = 0; K < o.length; K++)
          E[K] = 1;
        for (var K = 0; K < u.length; K++)
          O2[K] = u[K].inEdges.length, O2[K] === 0 && V3.push(u[K]);
        for (var J = -1; V3.length; ) {
          for (var rt2 = 0; rt2 < V3.length; rt2++) {
            var gt = V3[rt2], yt = gt.hostGraph.data.getRawDataItem(gt.dataIndex), At = yt.depth != null && yt.depth >= 0;
            At && yt.depth > J && (J = yt.depth), gt.setLayout({ depth: At ? yt.depth : q3 }, true), w2 === "vertical" ? gt.setLayout({ dy: n3 }, true) : gt.setLayout({ dx: n3 }, true);
            for (var Lt = 0; Lt < gt.outEdges.length; Lt++) {
              var Wt = gt.outEdges[Lt], Nt = o.indexOf(Wt);
              E[Nt] = 0;
              var ue2 = Wt.node2, ie2 = u.indexOf(ue2);
              --O2[ie2] === 0 && W3.indexOf(ue2) < 0 && W3.push(ue2);
            }
          }
          ++q3, V3 = W3, W3 = [];
        }
        for (var K = 0; K < E.length; K++)
          if (E[K] === 1)
            throw new Error("Sankey is a DAG, the original data has cycle!");
        var pe2 = J > q3 - 1 ? J : q3 - 1;
        T2 && T2 !== "left" && JTn(u, T2, w2, pe2);
        var xe = w2 === "vertical" ? (m2 - n3) / pe2 : (p2 - n3) / pe2;
        eAn(u, xe, w2);
      }
      function Pxe(u) {
        var o = u.hostGraph.data.getRawDataItem(u.dataIndex);
        return o.depth != null && o.depth >= 0;
      }
      function JTn(u, o, n3, p2) {
        if (o === "right") {
          for (var m2 = [], w2 = u, T2 = 0; w2.length; ) {
            for (var E = 0; E < w2.length; E++) {
              var O2 = w2[E];
              O2.setLayout({ skNodeHeight: T2 }, true);
              for (var V3 = 0; V3 < O2.inEdges.length; V3++) {
                var W3 = O2.inEdges[V3];
                m2.indexOf(W3.node1) < 0 && m2.push(W3.node1);
              }
            }
            w2 = m2, m2 = [], ++T2;
          }
          Xe2(u, function(q3) {
            Pxe(q3) || q3.setLayout({ depth: Math.max(0, p2 - q3.getLayout().skNodeHeight) }, true);
          });
        } else
          o === "justify" && tAn(u, p2);
      }
      function tAn(u, o) {
        Xe2(u, function(n3) {
          !Pxe(n3) && !n3.outEdges.length && n3.setLayout({ depth: o }, true);
        });
      }
      function eAn(u, o, n3) {
        Xe2(u, function(p2) {
          var m2 = p2.getLayout().depth * o;
          n3 === "vertical" ? p2.setLayout({ y: m2 }, true) : p2.setLayout({ x: m2 }, true);
        });
      }
      function nAn(u, o, n3, p2, m2, w2, T2) {
        var E = rAn(u, T2);
        iAn(E, o, n3, p2, m2, T2), $7t(E, m2, n3, p2, T2);
        for (var O2 = 1; w2 > 0; w2--)
          O2 *= 0.99, aAn(E, O2, T2), $7t(E, m2, n3, p2, T2), cAn(E, O2, T2), $7t(E, m2, n3, p2, T2);
      }
      function rAn(u, o) {
        var n3 = [], p2 = o === "vertical" ? "y" : "x", m2 = g$(u, function(w2) {
          return w2.getLayout()[p2];
        });
        return m2.keys.sort(function(w2, T2) {
          return w2 - T2;
        }), Xe2(m2.keys, function(w2) {
          n3.push(m2.buckets.get(w2));
        }), n3;
      }
      function iAn(u, o, n3, p2, m2, w2) {
        var T2 = 1 / 0;
        Xe2(u, function(E) {
          var O2 = E.length, V3 = 0;
          Xe2(E, function(q3) {
            V3 += q3.getLayout().value;
          });
          var W3 = w2 === "vertical" ? (p2 - (O2 - 1) * m2) / V3 : (n3 - (O2 - 1) * m2) / V3;
          W3 < T2 && (T2 = W3);
        }), Xe2(u, function(E) {
          Xe2(E, function(O2, V3) {
            var W3 = O2.getLayout().value * T2;
            w2 === "vertical" ? (O2.setLayout({ x: V3 }, true), O2.setLayout({ dx: W3 }, true)) : (O2.setLayout({ y: V3 }, true), O2.setLayout({ dy: W3 }, true));
          });
        }), Xe2(o, function(E) {
          var O2 = +E.getValue() * T2;
          E.setLayout({ dy: O2 }, true);
        });
      }
      function $7t(u, o, n3, p2, m2) {
        var w2 = m2 === "vertical" ? "x" : "y";
        Xe2(u, function(T2) {
          T2.sort(function(gt, yt) {
            return gt.getLayout()[w2] - yt.getLayout()[w2];
          });
          for (var E, O2, V3, W3 = 0, q3 = T2.length, K = m2 === "vertical" ? "dx" : "dy", J = 0; J < q3; J++)
            O2 = T2[J], V3 = W3 - O2.getLayout()[w2], V3 > 0 && (E = O2.getLayout()[w2] + V3, m2 === "vertical" ? O2.setLayout({ x: E }, true) : O2.setLayout({ y: E }, true)), W3 = O2.getLayout()[w2] + O2.getLayout()[K] + o;
          var rt2 = m2 === "vertical" ? p2 : n3;
          if (V3 = W3 - o - rt2, V3 > 0) {
            E = O2.getLayout()[w2] - V3, m2 === "vertical" ? O2.setLayout({ x: E }, true) : O2.setLayout({ y: E }, true), W3 = E;
            for (var J = q3 - 2; J >= 0; --J)
              O2 = T2[J], V3 = O2.getLayout()[w2] + O2.getLayout()[K] + o - W3, V3 > 0 && (E = O2.getLayout()[w2] - V3, m2 === "vertical" ? O2.setLayout({ x: E }, true) : O2.setLayout({ y: E }, true)), W3 = O2.getLayout()[w2];
          }
        });
      }
      function aAn(u, o, n3) {
        Xe2(u.slice().reverse(), function(p2) {
          Xe2(p2, function(m2) {
            if (m2.outEdges.length) {
              var w2 = y8(m2.outEdges, oAn, n3) / y8(m2.outEdges, Kxt);
              if (isNaN(w2)) {
                var T2 = m2.outEdges.length;
                w2 = T2 ? y8(m2.outEdges, sAn, n3) / T2 : 0;
              }
              if (n3 === "vertical") {
                var E = m2.getLayout().x + (w2 - v8(m2, n3)) * o;
                m2.setLayout({ x: E }, true);
              } else {
                var O2 = m2.getLayout().y + (w2 - v8(m2, n3)) * o;
                m2.setLayout({ y: O2 }, true);
              }
            }
          });
        });
      }
      function oAn(u, o) {
        return v8(u.node2, o) * u.getValue();
      }
      function sAn(u, o) {
        return v8(u.node2, o);
      }
      function lAn(u, o) {
        return v8(u.node1, o) * u.getValue();
      }
      function uAn(u, o) {
        return v8(u.node1, o);
      }
      function v8(u, o) {
        return o === "vertical" ? u.getLayout().x + u.getLayout().dx / 2 : u.getLayout().y + u.getLayout().dy / 2;
      }
      function Kxt(u) {
        return u.getValue();
      }
      function y8(u, o, n3) {
        for (var p2 = 0, m2 = u.length, w2 = -1; ++w2 < m2; ) {
          var T2 = +o(u[w2], n3);
          isNaN(T2) || (p2 += T2);
        }
        return p2;
      }
      function cAn(u, o, n3) {
        Xe2(u, function(p2) {
          Xe2(p2, function(m2) {
            if (m2.inEdges.length) {
              var w2 = y8(m2.inEdges, lAn, n3) / y8(m2.inEdges, Kxt);
              if (isNaN(w2)) {
                var T2 = m2.inEdges.length;
                w2 = T2 ? y8(m2.inEdges, uAn, n3) / T2 : 0;
              }
              if (n3 === "vertical") {
                var E = m2.getLayout().x + (w2 - v8(m2, n3)) * o;
                m2.setLayout({ x: E }, true);
              } else {
                var O2 = m2.getLayout().y + (w2 - v8(m2, n3)) * o;
                m2.setLayout({ y: O2 }, true);
              }
            }
          });
        });
      }
      function fAn(u, o) {
        var n3 = o === "vertical" ? "x" : "y";
        Xe2(u, function(p2) {
          p2.outEdges.sort(function(m2, w2) {
            return m2.node2.getLayout()[n3] - w2.node2.getLayout()[n3];
          }), p2.inEdges.sort(function(m2, w2) {
            return m2.node1.getLayout()[n3] - w2.node1.getLayout()[n3];
          });
        }), Xe2(u, function(p2) {
          var m2 = 0, w2 = 0;
          Xe2(p2.outEdges, function(T2) {
            T2.setLayout({ sy: m2 }, true), m2 += T2.getLayout().dy;
          }), Xe2(p2.inEdges, function(T2) {
            T2.setLayout({ ty: w2 }, true), w2 += T2.getLayout().dy;
          });
        });
      }
      function hAn(u) {
        u.eachSeriesByType("sankey", function(o) {
          var n3 = o.getGraph(), p2 = n3.nodes;
          if (p2.length) {
            var m2 = 1 / 0, w2 = -1 / 0;
            Xe2(p2, function(T2) {
              var E = T2.getLayout().value;
              E < m2 && (m2 = E), E > w2 && (w2 = E);
            }), Xe2(p2, function(T2) {
              var E = new ix({ type: "color", mappingMethod: "linear", dataExtent: [m2, w2], visual: o.get("color") }), O2 = E.mapValueToVisual(T2.getLayout().value), V3 = T2.getModel().get(["itemStyle", "color"]);
              V3 != null ? (T2.setVisual("color", V3), T2.setVisual("style", { fill: V3 })) : (T2.setVisual("color", O2), T2.setVisual("style", { fill: O2 }));
            });
          }
        });
      }
      function pAn(u) {
        u.registerChartView(UTn), u.registerSeriesModel(ZTn), u.registerLayout($Tn), u.registerVisual(hAn), u.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(o, n3) {
          n3.eachComponent({ mainType: "series", subType: "sankey", query: o }, function(p2) {
            p2.setNodePosition(o.dataIndex, [o.localX, o.localY]);
          });
        });
      }
      var Lxe = function() {
        function u() {
        }
        return u.prototype.getInitialData = function(o, n3) {
          var p2, m2 = n3.getComponent("xAxis", this.get("xAxisIndex")), w2 = n3.getComponent("yAxis", this.get("yAxisIndex")), T2 = m2.get("type"), E = w2.get("type"), O2;
          T2 === "category" ? (o.layout = "horizontal", p2 = m2.getOrdinalMeta(), O2 = true) : E === "category" ? (o.layout = "vertical", p2 = w2.getOrdinalMeta(), O2 = true) : o.layout = o.layout || "horizontal";
          var V3 = ["x", "y"], W3 = o.layout === "horizontal" ? 0 : 1, q3 = this._baseAxisDim = V3[W3], K = V3[1 - W3], J = [m2, w2], rt2 = J[W3].get("type"), gt = J[1 - W3].get("type"), yt = o.data;
          if (yt && O2) {
            var At = [];
            Xe2(yt, function(Nt, ue2) {
              var ie2;
              za2(Nt) ? (ie2 = Nt.slice(), Nt.unshift(ue2)) : za2(Nt.value) ? (ie2 = ua2({}, Nt), ie2.value = ie2.value.slice(), Nt.value.unshift(ue2)) : ie2 = Nt, At.push(ie2);
            }), o.data = At;
          }
          var Lt = this.defaultValueDimensions, Wt = [{ name: q3, type: axt(rt2), ordinalMeta: p2, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: K, type: axt(gt), dimsDef: Lt.slice() }];
          return pY(this, { coordDimensions: Wt, dimensionsCount: Lt.length + 1, encodeDefaulter: wu(Wve, Wt, this) });
        }, u.prototype.getBaseAxis = function() {
          var o = this._baseAxisDim;
          return this.ecModel.getComponent(o + "Axis", this.get(o + "AxisIndex")).axis;
        }, u;
      }(), Oxe = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], n3.visualDrawType = "stroke", n3;
        }
        return o.type = "series.boxplot", o.dependencies = ["xAxis", "yAxis", "grid"], o.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, o;
      }(Rv);
      x0(Oxe, Lxe, true);
      var dAn = Oxe, gAn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this.group, E = this._data;
          this._data || T2.removeAll();
          var O2 = n3.get("layout") === "horizontal" ? 1 : 0;
          w2.diff(E).add(function(V3) {
            if (w2.hasValue(V3)) {
              var W3 = w2.getItemLayout(V3), q3 = Rxe(W3, w2, V3, O2, true);
              w2.setItemGraphicEl(V3, q3), T2.add(q3);
            }
          }).update(function(V3, W3) {
            var q3 = E.getItemGraphicEl(W3);
            if (!w2.hasValue(V3)) {
              T2.remove(q3);
              return;
            }
            var K = w2.getItemLayout(V3);
            q3 ? (DC(q3), Nxe(K, q3, w2, V3)) : q3 = Rxe(K, w2, V3, O2), T2.add(q3), w2.setItemGraphicEl(V3, q3);
          }).remove(function(V3) {
            var W3 = E.getItemGraphicEl(V3);
            W3 && T2.remove(W3);
          }).execute(), this._data = w2;
        }, o.prototype.remove = function(n3) {
          var p2 = this.group, m2 = this._data;
          this._data = null, m2 && m2.eachItemGraphicEl(function(w2) {
            w2 && p2.remove(w2);
          });
        }, o.type = "boxplot", o;
      }(xg2), vAn = function() {
        function u() {
        }
        return u;
      }(), yAn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "boxplotBoxPath", p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new vAn();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.points, w2 = 0;
          for (n3.moveTo(m2[w2][0], m2[w2][1]), w2++; w2 < 4; w2++)
            n3.lineTo(m2[w2][0], m2[w2][1]);
          for (n3.closePath(); w2 < m2.length; w2++)
            n3.moveTo(m2[w2][0], m2[w2][1]), w2++, n3.lineTo(m2[w2][0], m2[w2][1]);
        }, o;
      }(Mc2);
      function Rxe(u, o, n3, p2, m2) {
        var w2 = u.ends, T2 = new yAn({ shape: { points: m2 ? mAn(w2, p2, u) : w2 } });
        return Nxe(u, T2, o, n3, m2), T2;
      }
      function Nxe(u, o, n3, p2, m2) {
        var w2 = n3.hostModel, T2 = mot[m2 ? "initProps" : "updateProps"];
        T2(o, { shape: { points: u.ends } }, w2, p2), o.useStyle(n3.getItemVisual(p2, "style")), o.style.strokeNoScale = true, o.z2 = 100;
        var E = n3.getItemModel(p2), O2 = E.getModel("emphasis");
        Ky(o, E), o0(o, O2.get("focus"), O2.get("blurScope"), O2.get("disabled"));
      }
      function mAn(u, o, n3) {
        return Ya2(u, function(p2) {
          return p2 = p2.slice(), p2[o] = n3.initBaseline, p2;
        });
      }
      var bAn = gAn;
      function _An(u, o) {
      }
      var Mst = Xe2;
      function xAn(u) {
        var o = wAn(u);
        Mst(o, function(n3) {
          var p2 = n3.seriesModels;
          !p2.length || (SAn(n3), Mst(p2, function(m2, w2) {
            MAn(m2, n3.boxOffsetList[w2], n3.boxWidthList[w2]);
          }));
        });
      }
      function wAn(u) {
        var o = [], n3 = [];
        return u.eachSeriesByType("boxplot", function(p2) {
          var m2 = p2.getBaseAxis(), w2 = sc2(n3, m2);
          w2 < 0 && (w2 = n3.length, n3[w2] = m2, o[w2] = { axis: m2, seriesModels: [] }), o[w2].seriesModels.push(p2);
        }), o;
      }
      function SAn(u) {
        var o = u.axis, n3 = u.seriesModels, p2 = n3.length, m2 = u.boxWidthList = [], w2 = u.boxOffsetList = [], T2 = [], E;
        if (o.type === "category")
          E = o.getBandWidth();
        else {
          var O2 = 0;
          Mst(n3, function(rt2) {
            O2 = Math.max(O2, rt2.getData().count());
          });
          var V3 = o.getExtent();
          E = Math.abs(V3[1] - V3[0]) / O2;
        }
        Mst(n3, function(rt2) {
          var gt = rt2.get("boxWidth");
          za2(gt) || (gt = [gt, gt]), T2.push([Qo(gt[0], E) || 0, Qo(gt[1], E) || 0]);
        });
        var W3 = E * 0.8 - 2, q3 = W3 / p2 * 0.3, K = (W3 - q3 * (p2 - 1)) / p2, J = K / 2 - W3 / 2;
        Mst(n3, function(rt2, gt) {
          w2.push(J), J += q3 + K, m2.push(Math.min(Math.max(K, T2[gt][0]), T2[gt][1]));
        });
      }
      function MAn(u, o, n3) {
        var p2 = u.coordinateSystem, m2 = u.getData(), w2 = n3 / 2, T2 = u.get("layout") === "horizontal" ? 0 : 1, E = 1 - T2, O2 = ["x", "y"], V3 = m2.mapDimension(O2[T2]), W3 = m2.mapDimensionsAll(O2[E]);
        if (V3 == null || W3.length < 5)
          return;
        for (var q3 = 0; q3 < m2.count(); q3++) {
          var K = m2.get(V3, q3), J = Wt(K, W3[2], q3), rt2 = Wt(K, W3[0], q3), gt = Wt(K, W3[1], q3), yt = Wt(K, W3[3], q3), At = Wt(K, W3[4], q3), Lt = [];
          Nt(Lt, gt, false), Nt(Lt, yt, true), Lt.push(rt2, gt, At, yt), ue2(Lt, rt2), ue2(Lt, At), ue2(Lt, J), m2.setItemLayout(q3, { initBaseline: J[E], ends: Lt });
        }
        function Wt(ie2, pe2, xe) {
          var Ce2 = m2.get(pe2, xe), Le2 = [];
          Le2[T2] = ie2, Le2[E] = Ce2;
          var ze;
          return isNaN(ie2) || isNaN(Ce2) ? ze = [NaN, NaN] : (ze = p2.dataToPoint(Le2), ze[T2] += o), ze;
        }
        function Nt(ie2, pe2, xe) {
          var Ce2 = pe2.slice(), Le2 = pe2.slice();
          Ce2[T2] += w2, Le2[T2] -= w2, xe ? ie2.push(Ce2, Le2) : ie2.push(Le2, Ce2);
        }
        function ue2(ie2, pe2) {
          var xe = pe2.slice(), Ce2 = pe2.slice();
          xe[T2] -= w2, Ce2[T2] += w2, ie2.push(xe, Ce2);
        }
      }
      function CAn(u, o) {
        o = o || {};
        for (var n3 = [], p2 = [], m2 = o.boundIQR, w2 = m2 === "none" || m2 === 0, T2 = 0; T2 < u.length; T2++) {
          var E = K_(u[T2].slice()), O2 = f$(E, 0.25), V3 = f$(E, 0.5), W3 = f$(E, 0.75), q3 = E[0], K = E[E.length - 1], J = (m2 == null ? 1.5 : m2) * (W3 - O2), rt2 = w2 ? q3 : Math.max(q3, O2 - J), gt = w2 ? K : Math.min(K, W3 + J), yt = o.itemNameFormatter, At = Sl(yt) ? yt({ value: T2 }) : ds(yt) ? yt.replace("{value}", T2 + "") : T2 + "";
          n3.push([At, rt2, O2, V3, W3, gt]);
          for (var Lt = 0; Lt < E.length; Lt++) {
            var Wt = E[Lt];
            if (Wt < rt2 || Wt > gt) {
              var Nt = [At, Wt];
              p2.push(Nt);
            }
          }
        }
        return { boxData: n3, outliers: p2 };
      }
      var TAn = { type: "echarts:boxplot", transform: function(u) {
        var o = u.upstream;
        if (o.sourceFormat !== Aw) {
          var n3 = "";
          lh2(n3);
        }
        var p2 = CAn(o.getRawData(), u.config);
        return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: p2.boxData }, { data: p2.outliers }];
      } };
      function AAn(u) {
        u.registerSeriesModel(dAn), u.registerChartView(bAn), u.registerVisual(_An), u.registerLayout(xAn), u.registerTransform(TAn);
      }
      var IAn = ["color", "borderColor"], DAn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(n3), this._isLargeDraw ? this._renderLarge(n3) : this._renderNormal(n3);
        }, o.prototype.incrementalPrepareRender = function(n3, p2, m2) {
          this._clear(), this._updateDrawMode(n3);
        }, o.prototype.incrementalRender = function(n3, p2, m2, w2) {
          this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(n3, p2) : this._incrementalRenderNormal(n3, p2);
        }, o.prototype.eachRendered = function(n3) {
          n8(this._progressiveEls || this.group, n3);
        }, o.prototype._updateDrawMode = function(n3) {
          var p2 = n3.pipelineContext.large;
          (this._isLargeDraw == null || p2 !== this._isLargeDraw) && (this._isLargeDraw = p2, this._clear());
        }, o.prototype._renderNormal = function(n3) {
          var p2 = n3.getData(), m2 = this._data, w2 = this.group, T2 = p2.getLayout("isSimpleBox"), E = n3.get("clip", true), O2 = n3.coordinateSystem, V3 = O2.getArea && O2.getArea();
          this._data || w2.removeAll(), p2.diff(m2).add(function(W3) {
            if (p2.hasValue(W3)) {
              var q3 = p2.getItemLayout(W3);
              if (E && Fxe(V3, q3))
                return;
              var K = Y7t(q3, W3, true);
              Qg2(K, { shape: { points: q3.ends } }, n3, W3), K7t(K, p2, W3, T2), w2.add(K), p2.setItemGraphicEl(W3, K);
            }
          }).update(function(W3, q3) {
            var K = m2.getItemGraphicEl(q3);
            if (!p2.hasValue(W3)) {
              w2.remove(K);
              return;
            }
            var J = p2.getItemLayout(W3);
            if (E && Fxe(V3, J)) {
              w2.remove(K);
              return;
            }
            K ? (Xf2(K, { shape: { points: J.ends } }, n3, W3), DC(K)) : K = Y7t(J), K7t(K, p2, W3, T2), w2.add(K), p2.setItemGraphicEl(W3, K);
          }).remove(function(W3) {
            var q3 = m2.getItemGraphicEl(W3);
            q3 && w2.remove(q3);
          }).execute(), this._data = p2;
        }, o.prototype._renderLarge = function(n3) {
          this._clear(), Bxe(n3, this.group);
          var p2 = n3.get("clip", true) ? Cxt(n3.coordinateSystem, false, n3) : null;
          p2 ? this.group.setClipPath(p2) : this.group.removeClipPath();
        }, o.prototype._incrementalRenderNormal = function(n3, p2) {
          for (var m2 = p2.getData(), w2 = m2.getLayout("isSimpleBox"), T2; (T2 = n3.next()) != null; ) {
            var E = m2.getItemLayout(T2), O2 = Y7t(E);
            K7t(O2, m2, T2, w2), O2.incremental = true, this.group.add(O2), this._progressiveEls.push(O2);
          }
        }, o.prototype._incrementalRenderLarge = function(n3, p2) {
          Bxe(p2, this.group, this._progressiveEls, true);
        }, o.prototype.remove = function(n3) {
          this._clear();
        }, o.prototype._clear = function() {
          this.group.removeAll(), this._data = null;
        }, o.type = "candlestick", o;
      }(xg2), EAn = function() {
        function u() {
        }
        return u;
      }(), kAn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "normalCandlestickBox", p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new EAn();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.points;
          this.__simpleBox ? (n3.moveTo(m2[4][0], m2[4][1]), n3.lineTo(m2[6][0], m2[6][1])) : (n3.moveTo(m2[0][0], m2[0][1]), n3.lineTo(m2[1][0], m2[1][1]), n3.lineTo(m2[2][0], m2[2][1]), n3.lineTo(m2[3][0], m2[3][1]), n3.closePath(), n3.moveTo(m2[4][0], m2[4][1]), n3.lineTo(m2[5][0], m2[5][1]), n3.moveTo(m2[6][0], m2[6][1]), n3.lineTo(m2[7][0], m2[7][1]));
        }, o;
      }(Mc2);
      function Y7t(u, o, n3) {
        var p2 = u.ends;
        return new kAn({ shape: { points: n3 ? PAn(p2, u) : p2 }, z2: 100 });
      }
      function Fxe(u, o) {
        for (var n3 = true, p2 = 0; p2 < o.ends.length; p2++)
          if (u.contain(o.ends[p2][0], o.ends[p2][1])) {
            n3 = false;
            break;
          }
        return n3;
      }
      function K7t(u, o, n3, p2) {
        var m2 = o.getItemModel(n3);
        u.useStyle(o.getItemVisual(n3, "style")), u.style.strokeNoScale = true, u.__simpleBox = p2, Ky(u, m2);
      }
      function PAn(u, o) {
        return Ya2(u, function(n3) {
          return n3 = n3.slice(), n3[1] = o.initBaseline, n3;
        });
      }
      var LAn = function() {
        function u() {
        }
        return u;
      }(), Vxe = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2.type = "largeCandlestickBox", p2;
        }
        return o.prototype.getDefaultShape = function() {
          return new LAn();
        }, o.prototype.buildPath = function(n3, p2) {
          for (var m2 = p2.points, w2 = 0; w2 < m2.length; )
            if (this.__sign === m2[w2++]) {
              var T2 = m2[w2++];
              n3.moveTo(T2, m2[w2++]), n3.lineTo(T2, m2[w2++]);
            } else
              w2 += 3;
        }, o;
      }(Mc2);
      function Bxe(u, o, n3, p2) {
        var m2 = u.getData(), w2 = m2.getLayout("largePoints"), T2 = new Vxe({ shape: { points: w2 }, __sign: 1 });
        o.add(T2);
        var E = new Vxe({ shape: { points: w2 }, __sign: -1 });
        o.add(E), zxe(1, T2, u), zxe(-1, E, u), p2 && (T2.incremental = true, E.incremental = true), n3 && n3.push(T2, E);
      }
      function zxe(u, o, n3, p2) {
        var m2 = n3.get(["itemStyle", u > 0 ? "borderColor" : "borderColor0"]) || n3.get(["itemStyle", u > 0 ? "color" : "color0"]), w2 = n3.getModel("itemStyle").getItemStyle(IAn);
        o.useStyle(w2), o.style.fill = null, o.style.stroke = m2;
      }
      var OAn = DAn, jxe = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], n3;
        }
        return o.prototype.getShadowDim = function() {
          return "open";
        }, o.prototype.brushSelector = function(n3, p2, m2) {
          var w2 = p2.getItemLayout(n3);
          return w2 && m2.rect(w2.brushRect);
        }, o.type = "series.candlestick", o.dependencies = ["xAxis", "yAxis", "grid"], o.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, o;
      }(Rv);
      x0(jxe, Lxe, true);
      var RAn = jxe;
      function NAn(u) {
        !u || !za2(u.series) || Xe2(u.series, function(o) {
          ys(o) && o.type === "k" && (o.type = "candlestick");
        });
      }
      var FAn = ["itemStyle", "borderColor"], VAn = ["itemStyle", "borderColor0"], BAn = ["itemStyle", "color"], zAn = ["itemStyle", "color0"], jAn = { seriesType: "candlestick", plan: eY(), performRawSeries: true, reset: function(u, o) {
        function n3(w2, T2) {
          return T2.get(w2 > 0 ? BAn : zAn);
        }
        function p2(w2, T2) {
          return T2.get(w2 > 0 ? FAn : VAn);
        }
        if (!o.isSeriesFiltered(u)) {
          var m2 = u.pipelineContext.large;
          return !m2 && { progress: function(w2, T2) {
            for (var E; (E = w2.next()) != null; ) {
              var O2 = T2.getItemModel(E), V3 = T2.getItemLayout(E).sign, W3 = O2.getItemStyle();
              W3.fill = n3(V3, O2), W3.stroke = p2(V3, O2) || W3.fill;
              var q3 = T2.ensureUniqueItemVisual(E, "style");
              ua2(q3, W3);
            }
          } };
        }
      } }, WAn = jAn, GAn = { seriesType: "candlestick", plan: eY(), reset: function(u) {
        var o = u.coordinateSystem, n3 = u.getData(), p2 = HAn(u, n3), m2 = 0, w2 = 1, T2 = ["x", "y"], E = n3.getDimensionIndex(n3.mapDimension(T2[m2])), O2 = Ya2(n3.mapDimensionsAll(T2[w2]), n3.getDimensionIndex, n3), V3 = O2[0], W3 = O2[1], q3 = O2[2], K = O2[3];
        if (n3.setLayout({ candleWidth: p2, isSimpleBox: p2 <= 1.3 }), E < 0 || O2.length < 4)
          return;
        return { progress: u.pipelineContext.large ? rt2 : J };
        function J(gt, yt) {
          for (var At, Lt = yt.getStore(); (At = gt.next()) != null; ) {
            var Wt = Lt.get(E, At), Nt = Lt.get(V3, At), ue2 = Lt.get(W3, At), ie2 = Lt.get(q3, At), pe2 = Lt.get(K, At), xe = Math.min(Nt, ue2), Ce2 = Math.max(Nt, ue2), Le2 = zn(xe, Wt), ze = zn(Ce2, Wt), tn = zn(ie2, Wt), $e2 = zn(pe2, Wt), Tn = [];
            bn(Tn, ze, 0), bn(Tn, Le2, 1), Tn.push(Xn($e2), Xn(ze), Xn(tn), Xn(Le2)), yt.setItemLayout(At, { sign: Wxe(Lt, At, Nt, ue2, W3), initBaseline: Nt > ue2 ? ze[w2] : Le2[w2], ends: Tn, brushRect: Xr(ie2, pe2, Wt) });
          }
          function zn(or, Tr) {
            var ci2 = [];
            return ci2[m2] = Tr, ci2[w2] = or, isNaN(Tr) || isNaN(or) ? [NaN, NaN] : o.dataToPoint(ci2);
          }
          function bn(or, Tr, ci2) {
            var yi2 = Tr.slice(), Po = Tr.slice();
            yi2[m2] = cu(yi2[m2] + p2 / 2, 1, false), Po[m2] = cu(Po[m2] - p2 / 2, 1, true), ci2 ? or.push(yi2, Po) : or.push(Po, yi2);
          }
          function Xr(or, Tr, ci2) {
            var yi2 = zn(or, ci2), Po = zn(Tr, ci2);
            return yi2[m2] -= p2 / 2, Po[m2] -= p2 / 2, { x: yi2[0], y: yi2[1], width: p2, height: Po[1] - yi2[1] };
          }
          function Xn(or) {
            return or[m2] = cu(or[m2], 1), or;
          }
        }
        function rt2(gt, yt) {
          for (var At = $P(gt.count * 4), Lt = 0, Wt, Nt = [], ue2 = [], ie2, pe2 = yt.getStore(); (ie2 = gt.next()) != null; ) {
            var xe = pe2.get(E, ie2), Ce2 = pe2.get(V3, ie2), Le2 = pe2.get(W3, ie2), ze = pe2.get(q3, ie2), tn = pe2.get(K, ie2);
            if (isNaN(xe) || isNaN(ze) || isNaN(tn)) {
              At[Lt++] = NaN, Lt += 3;
              continue;
            }
            At[Lt++] = Wxe(pe2, ie2, Ce2, Le2, W3), Nt[m2] = xe, Nt[w2] = ze, Wt = o.dataToPoint(Nt, null, ue2), At[Lt++] = Wt ? Wt[0] : NaN, At[Lt++] = Wt ? Wt[1] : NaN, Nt[w2] = tn, Wt = o.dataToPoint(Nt, null, ue2), At[Lt++] = Wt ? Wt[1] : NaN;
          }
          yt.setLayout("largePoints", At);
        }
      } };
      function Wxe(u, o, n3, p2, m2) {
        var w2;
        return n3 > p2 ? w2 = -1 : n3 < p2 ? w2 = 1 : w2 = o > 0 ? u.get(m2, o - 1) <= p2 ? 1 : -1 : 1, w2;
      }
      function HAn(u, o) {
        var n3 = u.getBaseAxis(), p2, m2 = n3.type === "category" ? n3.getBandWidth() : (p2 = n3.getExtent(), Math.abs(p2[1] - p2[0]) / o.count()), w2 = Qo(Xu(u.get("barMaxWidth"), m2), m2), T2 = Qo(Xu(u.get("barMinWidth"), 1), m2), E = u.get("barWidth");
        return E != null ? Qo(E, m2) : Math.max(Math.min(m2 / 2, w2), T2);
      }
      var UAn = GAn;
      function qAn(u) {
        u.registerChartView(OAn), u.registerSeriesModel(RAn), u.registerPreprocessor(NAn), u.registerVisual(WAn), u.registerLayout(UAn);
      }
      function Gxe(u, o) {
        var n3 = o.rippleEffectColor || o.color;
        u.eachChild(function(p2) {
          p2.attr({ z: o.z, zlevel: o.zlevel, style: { stroke: o.brushType === "stroke" ? n3 : null, fill: o.brushType === "fill" ? n3 : null } });
        });
      }
      var ZAn = function(u) {
        tr(o, u);
        function o(n3, p2) {
          var m2 = u.call(this) || this, w2 = new nst(n3, p2), T2 = new uu();
          return m2.add(w2), m2.add(T2), m2.updateData(n3, p2), m2;
        }
        return o.prototype.stopEffectAnimation = function() {
          this.childAt(1).removeAll();
        }, o.prototype.startEffectAnimation = function(n3) {
          for (var p2 = n3.symbolType, m2 = n3.color, w2 = n3.rippleNumber, T2 = this.childAt(1), E = 0; E < w2; E++) {
            var O2 = Jy(p2, -1, -1, 2, 2, m2);
            O2.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
            var V3 = -E / w2 * n3.period + n3.effectOffset;
            O2.animate("", true).when(n3.period, { scaleX: n3.rippleScale / 2, scaleY: n3.rippleScale / 2 }).delay(V3).start(), O2.animateStyle(true).when(n3.period, { opacity: 0 }).delay(V3).start(), T2.add(O2);
          }
          Gxe(T2, n3);
        }, o.prototype.updateEffectAnimation = function(n3) {
          for (var p2 = this._effectCfg, m2 = this.childAt(1), w2 = ["symbolType", "period", "rippleScale", "rippleNumber"], T2 = 0; T2 < w2.length; T2++) {
            var E = w2[T2];
            if (p2[E] !== n3[E]) {
              this.stopEffectAnimation(), this.startEffectAnimation(n3);
              return;
            }
          }
          Gxe(m2, n3);
        }, o.prototype.highlight = function() {
          Vm(this);
        }, o.prototype.downplay = function() {
          pc2(this);
        }, o.prototype.getSymbolType = function() {
          var n3 = this.childAt(0);
          return n3 && n3.getSymbolType();
        }, o.prototype.updateData = function(n3, p2) {
          var m2 = this, w2 = n3.hostModel;
          this.childAt(0).updateData(n3, p2);
          var T2 = this.childAt(1), E = n3.getItemModel(p2), O2 = n3.getItemVisual(p2, "symbol"), V3 = Rot(n3.getItemVisual(p2, "symbolSize")), W3 = n3.getItemVisual(p2, "style"), q3 = W3 && W3.fill, K = E.getModel("emphasis");
          T2.setScale(V3), T2.traverse(function(yt) {
            yt.setStyle("fill", q3);
          });
          var J = aY(n3.getItemVisual(p2, "symbolOffset"), V3);
          J && (T2.x = J[0], T2.y = J[1]);
          var rt2 = n3.getItemVisual(p2, "symbolRotate");
          T2.rotation = (rt2 || 0) * Math.PI / 180 || 0;
          var gt = {};
          gt.showEffectOn = w2.get("showEffectOn"), gt.rippleScale = E.get(["rippleEffect", "scale"]), gt.brushType = E.get(["rippleEffect", "brushType"]), gt.period = E.get(["rippleEffect", "period"]) * 1e3, gt.effectOffset = p2 / n3.count(), gt.z = w2.getShallow("z") || 0, gt.zlevel = w2.getShallow("zlevel") || 0, gt.symbolType = O2, gt.color = q3, gt.rippleEffectColor = E.get(["rippleEffect", "color"]), gt.rippleNumber = E.get(["rippleEffect", "number"]), gt.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(gt) : this.startEffectAnimation(gt), this._effectCfg = gt) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(yt) {
            yt === "emphasis" ? gt.showEffectOn !== "render" && m2.startEffectAnimation(gt) : yt === "normal" && gt.showEffectOn !== "render" && m2.stopEffectAnimation();
          }), this._effectCfg = gt, o0(this, K.get("focus"), K.get("blurScope"), K.get("disabled"));
        }, o.prototype.fadeOut = function(n3) {
          n3 && n3();
        }, o;
      }(uu), $An = ZAn, YAn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function() {
          this._symbolDraw = new rst($An);
        }, o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this._symbolDraw;
          T2.updateData(w2, { clipShape: this._getClipShape(n3) }), this.group.add(T2.group);
        }, o.prototype._getClipShape = function(n3) {
          var p2 = n3.coordinateSystem, m2 = p2 && p2.getArea && p2.getArea();
          return n3.get("clip", true) ? m2 : null;
        }, o.prototype.updateTransform = function(n3, p2, m2) {
          var w2 = n3.getData();
          this.group.dirty();
          var T2 = ist("").reset(n3, p2, m2);
          T2.progress && T2.progress({ start: 0, end: w2.count(), count: w2.count() }, w2), this._symbolDraw.updateLayout();
        }, o.prototype._updateGroupTransform = function(n3) {
          var p2 = n3.coordinateSystem;
          p2 && p2.getRoamTransform && (this.group.transform = fNt(p2.getRoamTransform()), this.group.decomposeTransform());
        }, o.prototype.remove = function(n3, p2) {
          this._symbolDraw && this._symbolDraw.remove(true);
        }, o.type = "effectScatter", o;
      }(xg2), KAn = YAn, XAn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.hasSymbolVisual = true, n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          return T4(null, this, { useEncodeDefaulter: true });
        }, o.prototype.brushSelector = function(n3, p2, m2) {
          return m2.point(p2.getItemLayout(n3));
        }, o.type = "series.effectScatter", o.dependencies = ["grid", "polar"], o.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, o;
      }(Rv), QAn = XAn;
      function JAn(u) {
        u.registerChartView(KAn), u.registerSeriesModel(QAn), u.registerLayout(ist("effectScatter"));
      }
      var tIn = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this) || this;
          return w2.add(w2.createLine(n3, p2, m2)), w2._updateEffectSymbol(n3, p2), w2;
        }
        return o.prototype.createLine = function(n3, p2, m2) {
          return new S7t(n3, p2, m2);
        }, o.prototype._updateEffectSymbol = function(n3, p2) {
          var m2 = n3.getItemModel(p2), w2 = m2.getModel("effect"), T2 = w2.get("symbolSize"), E = w2.get("symbol");
          za2(T2) || (T2 = [T2, T2]);
          var O2 = n3.getItemVisual(p2, "style"), V3 = w2.get("color") || O2 && O2.stroke, W3 = this.childAt(1);
          this._symbolType !== E && (this.remove(W3), W3 = Jy(E, -0.5, -0.5, 1, 1, V3), W3.z2 = 100, W3.culling = true, this.add(W3)), W3 && (W3.setStyle("shadowColor", V3), W3.setStyle(w2.getItemStyle(["color"])), W3.scaleX = T2[0], W3.scaleY = T2[1], W3.setColor(V3), this._symbolType = E, this._symbolScale = T2, this._updateEffectAnimation(n3, w2, p2));
        }, o.prototype._updateEffectAnimation = function(n3, p2, m2) {
          var w2 = this.childAt(1);
          if (w2) {
            var T2 = n3.getItemLayout(m2), E = p2.get("period") * 1e3, O2 = p2.get("loop"), V3 = p2.get("constantSpeed"), W3 = $y(p2.get("delay"), function(K) {
              return K / n3.count() * E / 3;
            });
            if (w2.ignore = true, this._updateAnimationPoints(w2, T2), V3 > 0 && (E = this._getLineLength(w2) / V3 * 1e3), E !== this._period || O2 !== this._loop) {
              w2.stopAnimation();
              var q3 = void 0;
              Sl(W3) ? q3 = W3(m2) : q3 = W3, w2.__t > 0 && (q3 = -E * w2.__t), this._animateSymbol(w2, E, q3, O2);
            }
            this._period = E, this._loop = O2;
          }
        }, o.prototype._animateSymbol = function(n3, p2, m2, w2) {
          if (p2 > 0) {
            n3.__t = 0;
            var T2 = this, E = n3.animate("", w2).when(p2, { __t: 1 }).delay(m2).during(function() {
              T2._updateSymbolPosition(n3);
            });
            w2 || E.done(function() {
              T2.remove(n3);
            }), E.start();
          }
        }, o.prototype._getLineLength = function(n3) {
          return GE(n3.__p1, n3.__cp1) + GE(n3.__cp1, n3.__p2);
        }, o.prototype._updateAnimationPoints = function(n3, p2) {
          n3.__p1 = p2[0], n3.__p2 = p2[1], n3.__cp1 = p2[2] || [(p2[0][0] + p2[1][0]) / 2, (p2[0][1] + p2[1][1]) / 2];
        }, o.prototype.updateData = function(n3, p2, m2) {
          this.childAt(0).updateData(n3, p2, m2), this._updateEffectSymbol(n3, p2);
        }, o.prototype._updateSymbolPosition = function(n3) {
          var p2 = n3.__p1, m2 = n3.__p2, w2 = n3.__cp1, T2 = n3.__t, E = [n3.x, n3.y], O2 = E.slice(), V3 = lp, W3 = Om;
          E[0] = V3(p2[0], w2[0], m2[0], T2), E[1] = V3(p2[1], w2[1], m2[1], T2);
          var q3 = W3(p2[0], w2[0], m2[0], T2), K = W3(p2[1], w2[1], m2[1], T2);
          n3.rotation = -Math.atan2(K, q3) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (n3.__lastT !== void 0 && n3.__lastT < n3.__t ? (n3.scaleY = GE(O2, E) * 1.05, T2 === 1 && (E[0] = O2[0] + (E[0] - O2[0]) / 2, E[1] = O2[1] + (E[1] - O2[1]) / 2)) : n3.__lastT === 1 ? n3.scaleY = 2 * GE(p2, E) : n3.scaleY = this._symbolScale[1]), n3.__lastT = n3.__t, n3.ignore = false, n3.x = E[0], n3.y = E[1];
        }, o.prototype.updateLayout = function(n3, p2) {
          this.childAt(0).updateLayout(n3, p2);
          var m2 = n3.getItemModel(p2).getModel("effect");
          this._updateEffectAnimation(n3, m2, p2);
        }, o;
      }(uu), Hxe = tIn, eIn = function(u) {
        tr(o, u);
        function o(n3, p2, m2) {
          var w2 = u.call(this) || this;
          return w2._createPolyline(n3, p2, m2), w2;
        }
        return o.prototype._createPolyline = function(n3, p2, m2) {
          var w2 = n3.getItemLayout(p2), T2 = new Mw({ shape: { points: w2 } });
          this.add(T2), this._updateCommonStl(n3, p2, m2);
        }, o.prototype.updateData = function(n3, p2, m2) {
          var w2 = n3.hostModel, T2 = this.childAt(0), E = { shape: { points: n3.getItemLayout(p2) } };
          Xf2(T2, E, w2, p2), this._updateCommonStl(n3, p2, m2);
        }, o.prototype._updateCommonStl = function(n3, p2, m2) {
          var w2 = this.childAt(0), T2 = n3.getItemModel(p2), E = m2 && m2.emphasisLineStyle, O2 = m2 && m2.focus, V3 = m2 && m2.blurScope, W3 = m2 && m2.emphasisDisabled;
          if (!m2 || n3.hasItemOption) {
            var q3 = T2.getModel("emphasis");
            E = q3.getModel("lineStyle").getLineStyle(), W3 = q3.get("disabled"), O2 = q3.get("focus"), V3 = q3.get("blurScope");
          }
          w2.useStyle(n3.getItemVisual(p2, "style")), w2.style.fill = null, w2.style.strokeNoScale = true;
          var K = w2.ensureState("emphasis");
          K.style = E, o0(this, O2, V3, W3);
        }, o.prototype.updateLayout = function(n3, p2) {
          var m2 = this.childAt(0);
          m2.setShape("points", n3.getItemLayout(p2));
        }, o;
      }(uu), Uxe = eIn, nIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3._lastFrame = 0, n3._lastFramePercent = 0, n3;
        }
        return o.prototype.createLine = function(n3, p2, m2) {
          return new Uxe(n3, p2, m2);
        }, o.prototype._updateAnimationPoints = function(n3, p2) {
          this._points = p2;
          for (var m2 = [0], w2 = 0, T2 = 1; T2 < p2.length; T2++) {
            var E = p2[T2 - 1], O2 = p2[T2];
            w2 += GE(E, O2), m2.push(w2);
          }
          if (w2 === 0) {
            this._length = 0;
            return;
          }
          for (var T2 = 0; T2 < m2.length; T2++)
            m2[T2] /= w2;
          this._offsets = m2, this._length = w2;
        }, o.prototype._getLineLength = function() {
          return this._length;
        }, o.prototype._updateSymbolPosition = function(n3) {
          var p2 = n3.__t, m2 = this._points, w2 = this._offsets, T2 = m2.length;
          if (w2) {
            var E = this._lastFrame, O2;
            if (p2 < this._lastFramePercent) {
              var V3 = Math.min(E + 1, T2 - 1);
              for (O2 = V3; O2 >= 0 && !(w2[O2] <= p2); O2--)
                ;
              O2 = Math.min(O2, T2 - 2);
            } else {
              for (O2 = E; O2 < T2 && !(w2[O2] > p2); O2++)
                ;
              O2 = Math.min(O2 - 1, T2 - 2);
            }
            var W3 = (p2 - w2[O2]) / (w2[O2 + 1] - w2[O2]), q3 = m2[O2], K = m2[O2 + 1];
            n3.x = q3[0] * (1 - W3) + W3 * K[0], n3.y = q3[1] * (1 - W3) + W3 * K[1];
            var J = K[0] - q3[0], rt2 = K[1] - q3[1];
            n3.rotation = -Math.atan2(rt2, J) - Math.PI / 2, this._lastFrame = O2, this._lastFramePercent = p2, n3.ignore = false;
          }
        }, o;
      }(Hxe), rIn = nIn, iIn = function() {
        function u() {
          this.polyline = false, this.curveness = 0, this.segs = [];
        }
        return u;
      }(), aIn = function(u) {
        tr(o, u);
        function o(n3) {
          var p2 = u.call(this, n3) || this;
          return p2._off = 0, p2.hoverDataIdx = -1, p2;
        }
        return o.prototype.reset = function() {
          this.notClear = false, this._off = 0;
        }, o.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, o.prototype.getDefaultShape = function() {
          return new iIn();
        }, o.prototype.buildPath = function(n3, p2) {
          var m2 = p2.segs, w2 = p2.curveness, T2;
          if (p2.polyline)
            for (T2 = this._off; T2 < m2.length; ) {
              var E = m2[T2++];
              if (E > 0) {
                n3.moveTo(m2[T2++], m2[T2++]);
                for (var O2 = 1; O2 < E; O2++)
                  n3.lineTo(m2[T2++], m2[T2++]);
              }
            }
          else
            for (T2 = this._off; T2 < m2.length; ) {
              var V3 = m2[T2++], W3 = m2[T2++], q3 = m2[T2++], K = m2[T2++];
              if (n3.moveTo(V3, W3), w2 > 0) {
                var J = (V3 + q3) / 2 - (W3 - K) * w2, rt2 = (W3 + K) / 2 - (q3 - V3) * w2;
                n3.quadraticCurveTo(J, rt2, q3, K);
              } else
                n3.lineTo(q3, K);
            }
          this.incremental && (this._off = T2, this.notClear = true);
        }, o.prototype.findDataIndex = function(n3, p2) {
          var m2 = this.shape, w2 = m2.segs, T2 = m2.curveness, E = this.style.lineWidth;
          if (m2.polyline)
            for (var O2 = 0, V3 = 0; V3 < w2.length; ) {
              var W3 = w2[V3++];
              if (W3 > 0)
                for (var q3 = w2[V3++], K = w2[V3++], J = 1; J < W3; J++) {
                  var rt2 = w2[V3++], gt = w2[V3++];
                  if (VP(q3, K, rt2, gt, E, n3, p2))
                    return O2;
                }
              O2++;
            }
          else
            for (var O2 = 0, V3 = 0; V3 < w2.length; ) {
              var q3 = w2[V3++], K = w2[V3++], rt2 = w2[V3++], gt = w2[V3++];
              if (T2 > 0) {
                var yt = (q3 + rt2) / 2 - (K - gt) * T2, At = (K + gt) / 2 - (rt2 - q3) * T2;
                if (kbt(q3, K, yt, At, rt2, gt, E, n3, p2))
                  return O2;
              } else if (VP(q3, K, rt2, gt, E, n3, p2))
                return O2;
              O2++;
            }
          return -1;
        }, o.prototype.contain = function(n3, p2) {
          var m2 = this.transformCoordToLocal(n3, p2), w2 = this.getBoundingRect();
          if (n3 = m2[0], p2 = m2[1], w2.contain(n3, p2)) {
            var T2 = this.hoverDataIdx = this.findDataIndex(n3, p2);
            return T2 >= 0;
          }
          return this.hoverDataIdx = -1, false;
        }, o.prototype.getBoundingRect = function() {
          var n3 = this._rect;
          if (!n3) {
            for (var p2 = this.shape, m2 = p2.segs, w2 = 1 / 0, T2 = 1 / 0, E = -1 / 0, O2 = -1 / 0, V3 = 0; V3 < m2.length; ) {
              var W3 = m2[V3++], q3 = m2[V3++];
              w2 = Math.min(W3, w2), E = Math.max(W3, E), T2 = Math.min(q3, T2), O2 = Math.max(q3, O2);
            }
            n3 = this._rect = new Qu(w2, T2, E, O2);
          }
          return n3;
        }, o;
      }(Mc2), oIn = function() {
        function u() {
          this.group = new uu();
        }
        return u.prototype.updateData = function(o) {
          this._clear();
          var n3 = this._create();
          n3.setShape({ segs: o.getLayout("linesPoints") }), this._setCommon(n3, o);
        }, u.prototype.incrementalPrepareUpdate = function(o) {
          this.group.removeAll(), this._clear();
        }, u.prototype.incrementalUpdate = function(o, n3) {
          var p2 = this._newAdded[0], m2 = n3.getLayout("linesPoints"), w2 = p2 && p2.shape.segs;
          if (w2 && w2.length < 2e4) {
            var T2 = w2.length, E = new Float32Array(T2 + m2.length);
            E.set(w2), E.set(m2, T2), p2.setShape({ segs: E });
          } else {
            this._newAdded = [];
            var O2 = this._create();
            O2.incremental = true, O2.setShape({ segs: m2 }), this._setCommon(O2, n3), O2.__startIndex = o.start;
          }
        }, u.prototype.remove = function() {
          this._clear();
        }, u.prototype.eachRendered = function(o) {
          this._newAdded[0] && o(this._newAdded[0]);
        }, u.prototype._create = function() {
          var o = new aIn({ cursor: "default" });
          return this._newAdded.push(o), this.group.add(o), o;
        }, u.prototype._setCommon = function(o, n3, p2) {
          var m2 = n3.hostModel;
          o.setShape({ polyline: m2.get("polyline"), curveness: m2.get(["lineStyle", "curveness"]) }), o.useStyle(m2.getModel("lineStyle").getLineStyle()), o.style.strokeNoScale = true;
          var w2 = n3.getVisual("style");
          w2 && w2.stroke && o.setStyle("stroke", w2.stroke), o.setStyle("fill", null);
          var T2 = is(o);
          T2.seriesIndex = m2.seriesIndex, o.on("mousemove", function(E) {
            T2.dataIndex = null;
            var O2 = o.hoverDataIdx;
            O2 > 0 && (T2.dataIndex = O2 + o.__startIndex);
          });
        }, u.prototype._clear = function() {
          this._newAdded = [], this.group.removeAll();
        }, u;
      }(), sIn = oIn, lIn = { seriesType: "lines", plan: eY(), reset: function(u) {
        var o = u.coordinateSystem;
        if (o) {
          var n3 = u.get("polyline"), p2 = u.pipelineContext.large;
          return { progress: function(m2, w2) {
            var T2 = [];
            if (p2) {
              var E = void 0, O2 = m2.end - m2.start;
              if (n3) {
                for (var V3 = 0, W3 = m2.start; W3 < m2.end; W3++)
                  V3 += u.getLineCoordsCount(W3);
                E = new Float32Array(O2 + V3 * 2);
              } else
                E = new Float32Array(O2 * 4);
              for (var q3 = 0, K = [], W3 = m2.start; W3 < m2.end; W3++) {
                var J = u.getLineCoords(W3, T2);
                n3 && (E[q3++] = J);
                for (var rt2 = 0; rt2 < J; rt2++)
                  K = o.dataToPoint(T2[rt2], false, K), E[q3++] = K[0], E[q3++] = K[1];
              }
              w2.setLayout("linesPoints", E);
            } else
              for (var W3 = m2.start; W3 < m2.end; W3++) {
                var gt = w2.getItemModel(W3), J = u.getLineCoords(W3, T2), yt = [];
                if (n3)
                  for (var At = 0; At < J; At++)
                    yt.push(o.dataToPoint(T2[At]));
                else {
                  yt[0] = o.dataToPoint(T2[0]), yt[1] = o.dataToPoint(T2[1]);
                  var Lt = gt.get(["lineStyle", "curveness"]);
                  +Lt && (yt[2] = [(yt[0][0] + yt[1][0]) / 2 - (yt[0][1] - yt[1][1]) * Lt, (yt[0][1] + yt[1][1]) / 2 - (yt[1][0] - yt[0][0]) * Lt]);
                }
                w2.setItemLayout(W3, yt);
              }
          } };
        }
      } }, qxe = lIn, uIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this._updateLineDraw(w2, n3), E = n3.get("zlevel"), O2 = n3.get(["effect", "trailLength"]), V3 = m2.getZr(), W3 = V3.painter.getType() === "svg";
          W3 || V3.painter.getLayer(E).clear(true), this._lastZlevel != null && !W3 && V3.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(n3) && O2 > 0 && (W3 || V3.configLayer(E, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(O2 / 10 + 0.9, 1), 0) })), T2.updateData(w2);
          var q3 = n3.get("clip", true) && Cxt(n3.coordinateSystem, false, n3);
          q3 ? this.group.setClipPath(q3) : this.group.removeClipPath(), this._lastZlevel = E, this._finished = true;
        }, o.prototype.incrementalPrepareRender = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this._updateLineDraw(w2, n3);
          T2.incrementalPrepareUpdate(w2), this._clearLayer(m2), this._finished = false;
        }, o.prototype.incrementalRender = function(n3, p2, m2) {
          this._lineDraw.incrementalUpdate(n3, p2.getData()), this._finished = n3.end === p2.getData().count();
        }, o.prototype.eachRendered = function(n3) {
          this._lineDraw && this._lineDraw.eachRendered(n3);
        }, o.prototype.updateTransform = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = n3.pipelineContext;
          if (!this._finished || T2.large || T2.progressiveRender)
            return { update: true };
          var E = qxe.reset(n3, p2, m2);
          E.progress && E.progress({ start: 0, end: w2.count(), count: w2.count() }, w2), this._lineDraw.updateLayout(), this._clearLayer(m2);
        }, o.prototype._updateLineDraw = function(n3, p2) {
          var m2 = this._lineDraw, w2 = this._showEffect(p2), T2 = !!p2.get("polyline"), E = p2.pipelineContext, O2 = E.large;
          return (!m2 || w2 !== this._hasEffet || T2 !== this._isPolyline || O2 !== this._isLargeDraw) && (m2 && m2.remove(), m2 = this._lineDraw = O2 ? new sIn() : new C7t(T2 ? w2 ? rIn : Uxe : w2 ? Hxe : S7t), this._hasEffet = w2, this._isPolyline = T2, this._isLargeDraw = O2), this.group.add(m2.group), m2;
        }, o.prototype._showEffect = function(n3) {
          return !!n3.get(["effect", "show"]);
        }, o.prototype._clearLayer = function(n3) {
          var p2 = n3.getZr(), m2 = p2.painter.getType() === "svg";
          !m2 && this._lastZlevel != null && p2.painter.getLayer(this._lastZlevel).clear(true);
        }, o.prototype.remove = function(n3, p2) {
          this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(p2);
        }, o.prototype.dispose = function(n3, p2) {
          this.remove(n3, p2);
        }, o.type = "lines", o;
      }(xg2), cIn = uIn, fIn = typeof Uint32Array == "undefined" ? Array : Uint32Array, hIn = typeof Float64Array == "undefined" ? Array : Float64Array;
      function Zxe(u) {
        var o = u.data;
        o && o[0] && o[0][0] && o[0][0].coord && (u.data = Ya2(o, function(n3) {
          var p2 = [n3[0].coord, n3[1].coord], m2 = { coords: p2 };
          return n3[0].name && (m2.fromName = n3[0].name), n3[1].name && (m2.toName = n3[1].name), LZ([m2, n3[0], n3[1]]);
        }));
      }
      var pIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.visualStyleAccessPath = "lineStyle", n3.visualDrawType = "stroke", n3;
        }
        return o.prototype.init = function(n3) {
          n3.data = n3.data || [], Zxe(n3);
          var p2 = this._processFlatCoordsArray(n3.data);
          this._flatCoords = p2.flatCoords, this._flatCoordsOffset = p2.flatCoordsOffset, p2.flatCoords && (n3.data = new Float32Array(p2.count)), u.prototype.init.apply(this, arguments);
        }, o.prototype.mergeOption = function(n3) {
          if (Zxe(n3), n3.data) {
            var p2 = this._processFlatCoordsArray(n3.data);
            this._flatCoords = p2.flatCoords, this._flatCoordsOffset = p2.flatCoordsOffset, p2.flatCoords && (n3.data = new Float32Array(p2.count));
          }
          u.prototype.mergeOption.apply(this, arguments);
        }, o.prototype.appendData = function(n3) {
          var p2 = this._processFlatCoordsArray(n3.data);
          p2.flatCoords && (this._flatCoords ? (this._flatCoords = RZ(this._flatCoords, p2.flatCoords), this._flatCoordsOffset = RZ(this._flatCoordsOffset, p2.flatCoordsOffset)) : (this._flatCoords = p2.flatCoords, this._flatCoordsOffset = p2.flatCoordsOffset), n3.data = new Float32Array(p2.count)), this.getRawData().appendData(n3.data);
        }, o.prototype._getCoordsFromItemModel = function(n3) {
          var p2 = this.getData().getItemModel(n3), m2 = p2.option instanceof Array ? p2.option : p2.getShallow("coords");
          return m2;
        }, o.prototype.getLineCoordsCount = function(n3) {
          return this._flatCoordsOffset ? this._flatCoordsOffset[n3 * 2 + 1] : this._getCoordsFromItemModel(n3).length;
        }, o.prototype.getLineCoords = function(n3, p2) {
          if (this._flatCoordsOffset) {
            for (var m2 = this._flatCoordsOffset[n3 * 2], w2 = this._flatCoordsOffset[n3 * 2 + 1], T2 = 0; T2 < w2; T2++)
              p2[T2] = p2[T2] || [], p2[T2][0] = this._flatCoords[m2 + T2 * 2], p2[T2][1] = this._flatCoords[m2 + T2 * 2 + 1];
            return w2;
          } else {
            for (var E = this._getCoordsFromItemModel(n3), T2 = 0; T2 < E.length; T2++)
              p2[T2] = p2[T2] || [], p2[T2][0] = E[T2][0], p2[T2][1] = E[T2][1];
            return E.length;
          }
        }, o.prototype._processFlatCoordsArray = function(n3) {
          var p2 = 0;
          if (this._flatCoords && (p2 = this._flatCoords.length), Dh2(n3[0])) {
            for (var m2 = n3.length, w2 = new fIn(m2), T2 = new hIn(m2), E = 0, O2 = 0, V3 = 0, W3 = 0; W3 < m2; ) {
              V3++;
              var q3 = n3[W3++];
              w2[O2++] = E + p2, w2[O2++] = q3;
              for (var K = 0; K < q3; K++) {
                var J = n3[W3++], rt2 = n3[W3++];
                T2[E++] = J, T2[E++] = rt2;
              }
            }
            return { flatCoordsOffset: new Uint32Array(w2.buffer, 0, O2), flatCoords: T2, count: V3 };
          }
          return { flatCoordsOffset: null, flatCoords: null, count: n3.length };
        }, o.prototype.getInitialData = function(n3, p2) {
          var m2 = new o2(["value"], this);
          return m2.hasItemOption = false, m2.initData(n3.data, [], function(w2, T2, E, O2) {
            if (w2 instanceof Array)
              return NaN;
            m2.hasItemOption = true;
            var V3 = w2.value;
            if (V3 != null)
              return V3 instanceof Array ? V3[O2] : V3;
          }), m2;
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          var w2 = this.getData(), T2 = w2.getItemModel(n3), E = T2.get("name");
          if (E)
            return E;
          var O2 = T2.get("fromName"), V3 = T2.get("toName"), W3 = [];
          return O2 != null && W3.push(O2), V3 != null && W3.push(V3), k1("nameValue", { name: W3.join(" > ") });
        }, o.prototype.preventIncremental = function() {
          return !!this.get(["effect", "show"]);
        }, o.prototype.getProgressive = function() {
          var n3 = this.option.progressive;
          return n3 == null ? this.option.large ? 1e4 : this.get("progressive") : n3;
        }, o.prototype.getProgressiveThreshold = function() {
          var n3 = this.option.progressiveThreshold;
          return n3 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : n3;
        }, o.prototype.getZLevelKey = function() {
          var n3 = this.getModel("effect"), p2 = n3.get("trailLength");
          return this.getData().count() > this.getProgressiveThreshold() ? this.id : n3.get("show") && p2 > 0 ? p2 + "" : "";
        }, o.type = "series.lines", o.dependencies = ["grid", "polar", "geo", "calendar"], o.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, o;
      }(Rv), dIn = pIn;
      function Xxt(u) {
        return u instanceof Array || (u = [u, u]), u;
      }
      var gIn = { seriesType: "lines", reset: function(u) {
        var o = Xxt(u.get("symbol")), n3 = Xxt(u.get("symbolSize")), p2 = u.getData();
        p2.setVisual("fromSymbol", o && o[0]), p2.setVisual("toSymbol", o && o[1]), p2.setVisual("fromSymbolSize", n3 && n3[0]), p2.setVisual("toSymbolSize", n3 && n3[1]);
        function m2(w2, T2) {
          var E = w2.getItemModel(T2), O2 = Xxt(E.getShallow("symbol", true)), V3 = Xxt(E.getShallow("symbolSize", true));
          O2[0] && w2.setItemVisual(T2, "fromSymbol", O2[0]), O2[1] && w2.setItemVisual(T2, "toSymbol", O2[1]), V3[0] && w2.setItemVisual(T2, "fromSymbolSize", V3[0]), V3[1] && w2.setItemVisual(T2, "toSymbolSize", V3[1]);
        }
        return { dataEach: p2.hasItemOption ? m2 : null };
      } }, vIn = gIn;
      function yIn(u) {
        u.registerChartView(cIn), u.registerSeriesModel(dIn), u.registerLayout(qxe), u.registerVisual(vIn);
      }
      var mIn = 256, bIn = function() {
        function u() {
          this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
          var o = pw.createCanvas();
          this.canvas = o;
        }
        return u.prototype.update = function(o, n3, p2, m2, w2, T2) {
          var E = this._getBrush(), O2 = this._getGradient(w2, "inRange"), V3 = this._getGradient(w2, "outOfRange"), W3 = this.pointSize + this.blurSize, q3 = this.canvas, K = q3.getContext("2d"), J = o.length;
          q3.width = n3, q3.height = p2;
          for (var rt2 = 0; rt2 < J; ++rt2) {
            var gt = o[rt2], yt = gt[0], At = gt[1], Lt = gt[2], Wt = m2(Lt);
            K.globalAlpha = Wt, K.drawImage(E, yt - W3, At - W3);
          }
          if (!q3.width || !q3.height)
            return q3;
          for (var Nt = K.getImageData(0, 0, q3.width, q3.height), ue2 = Nt.data, ie2 = 0, pe2 = ue2.length, xe = this.minOpacity, Ce2 = this.maxOpacity, Le2 = Ce2 - xe; ie2 < pe2; ) {
            var Wt = ue2[ie2 + 3] / 256, ze = Math.floor(Wt * (mIn - 1)) * 4;
            if (Wt > 0) {
              var tn = T2(Wt) ? O2 : V3;
              Wt > 0 && (Wt = Wt * Le2 + xe), ue2[ie2++] = tn[ze], ue2[ie2++] = tn[ze + 1], ue2[ie2++] = tn[ze + 2], ue2[ie2++] = tn[ze + 3] * Wt * 256;
            } else
              ie2 += 4;
          }
          return K.putImageData(Nt, 0, 0), q3;
        }, u.prototype._getBrush = function() {
          var o = this._brushCanvas || (this._brushCanvas = pw.createCanvas()), n3 = this.pointSize + this.blurSize, p2 = n3 * 2;
          o.width = p2, o.height = p2;
          var m2 = o.getContext("2d");
          return m2.clearRect(0, 0, p2, p2), m2.shadowOffsetX = p2, m2.shadowBlur = this.blurSize, m2.shadowColor = "#000", m2.beginPath(), m2.arc(-n3, n3, this.pointSize, 0, Math.PI * 2, true), m2.closePath(), m2.fill(), o;
        }, u.prototype._getGradient = function(o, n3) {
          for (var p2 = this._gradientPixels, m2 = p2[n3] || (p2[n3] = new Uint8ClampedArray(256 * 4)), w2 = [0, 0, 0, 0], T2 = 0, E = 0; E < 256; E++)
            o[n3](E / 255, true, w2), m2[T2++] = w2[0], m2[T2++] = w2[1], m2[T2++] = w2[2], m2[T2++] = w2[3];
          return m2;
        }, u;
      }(), _In = bIn;
      function xIn(u, o, n3) {
        var p2 = u[1] - u[0];
        o = Ya2(o, function(T2) {
          return { interval: [(T2.interval[0] - u[0]) / p2, (T2.interval[1] - u[0]) / p2] };
        });
        var m2 = o.length, w2 = 0;
        return function(T2) {
          var E;
          for (E = w2; E < m2; E++) {
            var O2 = o[E].interval;
            if (O2[0] <= T2 && T2 <= O2[1]) {
              w2 = E;
              break;
            }
          }
          if (E === m2)
            for (E = w2 - 1; E >= 0; E--) {
              var O2 = o[E].interval;
              if (O2[0] <= T2 && T2 <= O2[1]) {
                w2 = E;
                break;
              }
            }
          return E >= 0 && E < m2 && n3[E];
        };
      }
      function wIn(u, o) {
        var n3 = u[1] - u[0];
        return o = [(o[0] - u[0]) / n3, (o[1] - u[0]) / n3], function(p2) {
          return p2 >= o[0] && p2 <= o[1];
        };
      }
      function $xe(u) {
        var o = u.dimensions;
        return o[0] === "lng" && o[1] === "lat";
      }
      var SIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2;
          p2.eachComponent("visualMap", function(E) {
            E.eachTargetSeries(function(O2) {
              O2 === n3 && (w2 = E);
            });
          }), this._progressiveEls = null, this.group.removeAll();
          var T2 = n3.coordinateSystem;
          T2.type === "cartesian2d" || T2.type === "calendar" ? this._renderOnCartesianAndCalendar(n3, m2, 0, n3.getData().count()) : $xe(T2) && this._renderOnGeo(T2, n3, w2, m2);
        }, o.prototype.incrementalPrepareRender = function(n3, p2, m2) {
          this.group.removeAll();
        }, o.prototype.incrementalRender = function(n3, p2, m2, w2) {
          var T2 = p2.coordinateSystem;
          T2 && ($xe(T2) ? this.render(p2, m2, w2) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(p2, w2, n3.start, n3.end, true)));
        }, o.prototype.eachRendered = function(n3) {
          n8(this._progressiveEls || this.group, n3);
        }, o.prototype._renderOnCartesianAndCalendar = function(n3, p2, m2, w2, T2) {
          var E = n3.coordinateSystem, O2, V3, W3, q3;
          if (I4(E, "cartesian2d")) {
            var K = E.getAxis("x"), J = E.getAxis("y");
            O2 = K.getBandWidth(), V3 = J.getBandWidth(), W3 = K.scale.getExtent(), q3 = J.scale.getExtent();
          }
          for (var rt2 = this.group, gt = n3.getData(), yt = n3.getModel(["emphasis", "itemStyle"]).getItemStyle(), At = n3.getModel(["blur", "itemStyle"]).getItemStyle(), Lt = n3.getModel(["select", "itemStyle"]).getItemStyle(), Wt = n3.get(["itemStyle", "borderRadius"]), Nt = Lb2(n3), ue2 = n3.getModel("emphasis"), ie2 = ue2.get("focus"), pe2 = ue2.get("blurScope"), xe = ue2.get("disabled"), Ce2 = I4(E, "cartesian2d") ? [gt.mapDimension("x"), gt.mapDimension("y"), gt.mapDimension("value")] : [gt.mapDimension("time"), gt.mapDimension("value")], Le2 = m2; Le2 < w2; Le2++) {
            var ze = void 0, tn = gt.getItemVisual(Le2, "style");
            if (I4(E, "cartesian2d")) {
              var $e2 = gt.get(Ce2[0], Le2), Tn = gt.get(Ce2[1], Le2);
              if (isNaN(gt.get(Ce2[2], Le2)) || $e2 < W3[0] || $e2 > W3[1] || Tn < q3[0] || Tn > q3[1])
                continue;
              var zn = E.dataToPoint([$e2, Tn]);
              ze = new Vf2({ shape: { x: Math.floor(Math.round(zn[0]) - O2 / 2), y: Math.floor(Math.round(zn[1]) - V3 / 2), width: Math.ceil(O2), height: Math.ceil(V3) }, style: tn });
            } else {
              if (isNaN(gt.get(Ce2[1], Le2)))
                continue;
              ze = new Vf2({ z2: 1, shape: E.dataToRect([gt.get(Ce2[0], Le2)]).contentShape, style: tn });
            }
            if (gt.hasItemOption) {
              var bn = gt.getItemModel(Le2), Xr = bn.getModel("emphasis");
              yt = Xr.getModel("itemStyle").getItemStyle(), At = bn.getModel(["blur", "itemStyle"]).getItemStyle(), Lt = bn.getModel(["select", "itemStyle"]).getItemStyle(), Wt = bn.get(["itemStyle", "borderRadius"]), ie2 = Xr.get("focus"), pe2 = Xr.get("blurScope"), xe = Xr.get("disabled"), Nt = Lb2(bn);
            }
            ze.shape.r = Wt;
            var Xn = n3.getRawValue(Le2), or = "-";
            Xn && Xn[2] != null && (or = Xn[2] + ""), Tw(ze, Nt, { labelFetcher: n3, labelDataIndex: Le2, defaultOpacity: tn.opacity, defaultText: or }), ze.ensureState("emphasis").style = yt, ze.ensureState("blur").style = At, ze.ensureState("select").style = Lt, o0(ze, ie2, pe2, xe), ze.incremental = T2, T2 && (ze.states.emphasis.hoverLayer = true), rt2.add(ze), gt.setItemGraphicEl(Le2, ze), this._progressiveEls && this._progressiveEls.push(ze);
          }
        }, o.prototype._renderOnGeo = function(n3, p2, m2, w2) {
          var T2 = m2.targetVisuals.inRange, E = m2.targetVisuals.outOfRange, O2 = p2.getData(), V3 = this._hmLayer || this._hmLayer || new _In();
          V3.blurSize = p2.get("blurSize"), V3.pointSize = p2.get("pointSize"), V3.minOpacity = p2.get("minOpacity"), V3.maxOpacity = p2.get("maxOpacity");
          var W3 = n3.getViewRect().clone(), q3 = n3.getRoamTransform();
          W3.applyTransform(q3);
          var K = Math.max(W3.x, 0), J = Math.max(W3.y, 0), rt2 = Math.min(W3.width + W3.x, w2.getWidth()), gt = Math.min(W3.height + W3.y, w2.getHeight()), yt = rt2 - K, At = gt - J, Lt = [O2.mapDimension("lng"), O2.mapDimension("lat"), O2.mapDimension("value")], Wt = O2.mapArray(Lt, function(pe2, xe, Ce2) {
            var Le2 = n3.dataToPoint([pe2, xe]);
            return Le2[0] -= K, Le2[1] -= J, Le2.push(Ce2), Le2;
          }), Nt = m2.getExtent(), ue2 = m2.type === "visualMap.continuous" ? wIn(Nt, m2.option.range) : xIn(Nt, m2.getPieceList(), m2.option.selected);
          V3.update(Wt, yt, At, T2.color.getNormalizer(), { inRange: T2.color.getColorMapper(), outOfRange: E.color.getColorMapper() }, ue2);
          var ie2 = new Fm({ style: { width: yt, height: At, x: K, y: J, image: V3.canvas }, silent: true });
          this.group.add(ie2);
        }, o.type = "heatmap", o;
      }(xg2), MIn = SIn, CIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          return T4(null, this, { generateCoord: "value" });
        }, o.prototype.preventIncremental = function() {
          var n3 = Cot.get(this.get("coordinateSystem"));
          if (n3 && n3.dimensions)
            return n3.dimensions[0] === "lng" && n3.dimensions[1] === "lat";
        }, o.type = "series.heatmap", o.dependencies = ["grid", "geo", "calendar"], o.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, o;
      }(Rv), TIn = CIn;
      function AIn(u) {
        u.registerChartView(MIn), u.registerSeriesModel(TIn);
      }
      var IIn = ["itemStyle", "borderWidth"], Yxe = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], X7t = new sI(), DIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = this.group, T2 = n3.getData(), E = this._data, O2 = n3.coordinateSystem, V3 = O2.getBaseAxis(), W3 = V3.isHorizontal(), q3 = O2.master.getRect(), K = { ecSize: { width: m2.getWidth(), height: m2.getHeight() }, seriesModel: n3, coordSys: O2, coordSysExtent: [[q3.x, q3.x + q3.width], [q3.y, q3.y + q3.height]], isHorizontal: W3, valueDim: Yxe[+W3], categoryDim: Yxe[1 - +W3] };
          return T2.diff(E).add(function(J) {
            if (T2.hasValue(J)) {
              var rt2 = nwe(T2, J), gt = Kxe(T2, J, rt2, K), yt = rwe(T2, K, gt);
              T2.setItemGraphicEl(J, yt), w2.add(yt), owe(yt, K, gt);
            }
          }).update(function(J, rt2) {
            var gt = E.getItemGraphicEl(rt2);
            if (!T2.hasValue(J)) {
              w2.remove(gt);
              return;
            }
            var yt = nwe(T2, J), At = Kxe(T2, J, yt, K), Lt = awe(T2, At);
            gt && Lt !== gt.__pictorialShapeStr && (w2.remove(gt), T2.setItemGraphicEl(J, null), gt = null), gt ? NIn(gt, K, At) : gt = rwe(T2, K, At, true), T2.setItemGraphicEl(J, gt), gt.__pictorialSymbolMeta = At, w2.add(gt), owe(gt, K, At);
          }).remove(function(J) {
            var rt2 = E.getItemGraphicEl(J);
            rt2 && iwe(E, J, rt2.__pictorialSymbolMeta.animationModel, rt2);
          }).execute(), this._data = T2, this.group;
        }, o.prototype.remove = function(n3, p2) {
          var m2 = this.group, w2 = this._data;
          n3.get("animation") ? w2 && w2.eachItemGraphicEl(function(T2) {
            iwe(w2, is(T2).dataIndex, n3, T2);
          }) : m2.removeAll();
        }, o.type = "pictorialBar", o;
      }(xg2);
      function Kxe(u, o, n3, p2) {
        var m2 = u.getItemLayout(o), w2 = n3.get("symbolRepeat"), T2 = n3.get("symbolClip"), E = n3.get("symbolPosition") || "start", O2 = n3.get("symbolRotate"), V3 = (O2 || 0) * Math.PI / 180 || 0, W3 = n3.get("symbolPatternSize") || 2, q3 = n3.isAnimationEnabled(), K = { dataIndex: o, layout: m2, itemModel: n3, symbolType: u.getItemVisual(o, "symbol") || "circle", style: u.getItemVisual(o, "style"), symbolClip: T2, symbolRepeat: w2, symbolRepeatDirection: n3.get("symbolRepeatDirection"), symbolPatternSize: W3, rotation: V3, animationModel: q3 ? n3 : null, hoverScale: q3 && n3.get(["emphasis", "scale"]), z2: n3.getShallow("z", true) || 0 };
        EIn(n3, w2, m2, p2, K), kIn(u, o, m2, w2, T2, K.boundingLength, K.pxSign, W3, p2, K), PIn(n3, K.symbolScale, V3, p2, K);
        var J = K.symbolSize, rt2 = aY(n3.get("symbolOffset"), J);
        return LIn(n3, J, m2, w2, T2, rt2, E, K.valueLineWidth, K.boundingLength, K.repeatCutLength, p2, K), K;
      }
      function EIn(u, o, n3, p2, m2) {
        var w2 = p2.valueDim, T2 = u.get("symbolBoundingData"), E = p2.coordSys.getOtherAxis(p2.coordSys.getBaseAxis()), O2 = E.toGlobalCoord(E.dataToCoord(0)), V3 = 1 - +(n3[w2.wh] <= 0), W3;
        if (za2(T2)) {
          var q3 = [Q7t(E, T2[0]) - O2, Q7t(E, T2[1]) - O2];
          q3[1] < q3[0] && q3.reverse(), W3 = q3[V3];
        } else
          T2 != null ? W3 = Q7t(E, T2) - O2 : o ? W3 = p2.coordSysExtent[w2.index][V3] - O2 : W3 = n3[w2.wh];
        m2.boundingLength = W3, o && (m2.repeatCutLength = n3[w2.wh]), m2.pxSign = W3 > 0 ? 1 : -1;
      }
      function Q7t(u, o) {
        return u.toGlobalCoord(u.dataToCoord(u.scale.parse(o)));
      }
      function kIn(u, o, n3, p2, m2, w2, T2, E, O2, V3) {
        var W3 = O2.valueDim, q3 = O2.categoryDim, K = Math.abs(n3[q3.wh]), J = u.getItemVisual(o, "symbolSize"), rt2;
        za2(J) ? rt2 = J.slice() : J == null ? rt2 = ["100%", "100%"] : rt2 = [J, J], rt2[q3.index] = Qo(rt2[q3.index], K), rt2[W3.index] = Qo(rt2[W3.index], p2 ? K : Math.abs(w2)), V3.symbolSize = rt2;
        var gt = V3.symbolScale = [rt2[0] / E, rt2[1] / E];
        gt[W3.index] *= (O2.isHorizontal ? -1 : 1) * T2;
      }
      function PIn(u, o, n3, p2, m2) {
        var w2 = u.get(IIn) || 0;
        w2 && (X7t.attr({ scaleX: o[0], scaleY: o[1], rotation: n3 }), X7t.updateTransform(), w2 /= X7t.getLineScale(), w2 *= o[p2.valueDim.index]), m2.valueLineWidth = w2 || 0;
      }
      function LIn(u, o, n3, p2, m2, w2, T2, E, O2, V3, W3, q3) {
        var K = W3.categoryDim, J = W3.valueDim, rt2 = q3.pxSign, gt = Math.max(o[J.index] + E, 0), yt = gt;
        if (p2) {
          var At = Math.abs(O2), Lt = $y(u.get("symbolMargin"), "15%") + "", Wt = false;
          Lt.lastIndexOf("!") === Lt.length - 1 && (Wt = true, Lt = Lt.slice(0, Lt.length - 1));
          var Nt = Qo(Lt, o[J.index]), ue2 = Math.max(gt + Nt * 2, 0), ie2 = Wt ? 0 : Nt * 2, pe2 = JA(p2), xe = pe2 ? p2 : swe((At + ie2) / ue2), Ce2 = At - xe * gt;
          Nt = Ce2 / 2 / (Wt ? xe : Math.max(xe - 1, 1)), ue2 = gt + Nt * 2, ie2 = Wt ? 0 : Nt * 2, !pe2 && p2 !== "fixed" && (xe = V3 ? swe((Math.abs(V3) + ie2) / ue2) : 0), yt = xe * ue2 - ie2, q3.repeatTimes = xe, q3.symbolMargin = Nt;
        }
        var Le2 = rt2 * (yt / 2), ze = q3.pathPosition = [];
        ze[K.index] = n3[K.wh] / 2, ze[J.index] = T2 === "start" ? Le2 : T2 === "end" ? O2 - Le2 : O2 / 2, w2 && (ze[0] += w2[0], ze[1] += w2[1]);
        var tn = q3.bundlePosition = [];
        tn[K.index] = n3[K.xy], tn[J.index] = n3[J.xy];
        var $e2 = q3.barRectShape = ua2({}, n3);
        $e2[J.wh] = rt2 * Math.max(Math.abs(n3[J.wh]), Math.abs(ze[J.index] + Le2)), $e2[K.wh] = n3[K.wh];
        var Tn = q3.clipShape = {};
        Tn[K.xy] = -n3[K.xy], Tn[K.wh] = W3.ecSize[K.wh], Tn[J.xy] = 0, Tn[J.wh] = n3[J.wh];
      }
      function Xxe(u) {
        var o = u.symbolPatternSize, n3 = Jy(u.symbolType, -o / 2, -o / 2, o, o);
        return n3.attr({ culling: true }), n3.type !== "image" && n3.setStyle({ strokeNoScale: true }), n3;
      }
      function Qxe(u, o, n3, p2) {
        var m2 = u.__pictorialBundle, w2 = n3.symbolSize, T2 = n3.valueLineWidth, E = n3.pathPosition, O2 = o.valueDim, V3 = n3.repeatTimes || 0, W3 = 0, q3 = w2[o.valueDim.index] + T2 + n3.symbolMargin * 2;
        for (J7t(u, function(gt) {
          gt.__pictorialAnimationIndex = W3, gt.__pictorialRepeatTimes = V3, W3 < V3 ? xY(gt, null, rt2(W3), n3, p2) : xY(gt, null, { scaleX: 0, scaleY: 0 }, n3, p2, function() {
            m2.remove(gt);
          }), W3++;
        }); W3 < V3; W3++) {
          var K = Xxe(n3);
          K.__pictorialAnimationIndex = W3, K.__pictorialRepeatTimes = V3, m2.add(K);
          var J = rt2(W3);
          xY(K, { x: J.x, y: J.y, scaleX: 0, scaleY: 0 }, { scaleX: J.scaleX, scaleY: J.scaleY, rotation: J.rotation }, n3, p2);
        }
        function rt2(gt) {
          var yt = E.slice(), At = n3.pxSign, Lt = gt;
          return (n3.symbolRepeatDirection === "start" ? At > 0 : At < 0) && (Lt = V3 - 1 - gt), yt[O2.index] = q3 * (Lt - V3 / 2 + 0.5) + E[O2.index], { x: yt[0], y: yt[1], scaleX: n3.symbolScale[0], scaleY: n3.symbolScale[1], rotation: n3.rotation };
        }
      }
      function Jxe(u, o, n3, p2) {
        var m2 = u.__pictorialBundle, w2 = u.__pictorialMainPath;
        w2 ? xY(w2, null, { x: n3.pathPosition[0], y: n3.pathPosition[1], scaleX: n3.symbolScale[0], scaleY: n3.symbolScale[1], rotation: n3.rotation }, n3, p2) : (w2 = u.__pictorialMainPath = Xxe(n3), m2.add(w2), xY(w2, { x: n3.pathPosition[0], y: n3.pathPosition[1], scaleX: 0, scaleY: 0, rotation: n3.rotation }, { scaleX: n3.symbolScale[0], scaleY: n3.symbolScale[1] }, n3, p2));
      }
      function twe(u, o, n3) {
        var p2 = ua2({}, o.barRectShape), m2 = u.__pictorialBarRect;
        m2 ? xY(m2, null, { shape: p2 }, o, n3) : (m2 = u.__pictorialBarRect = new Vf2({ z2: 2, shape: p2, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), m2.disableMorphing = true, u.add(m2));
      }
      function ewe(u, o, n3, p2) {
        if (n3.symbolClip) {
          var m2 = u.__pictorialClipPath, w2 = ua2({}, n3.clipShape), T2 = o.valueDim, E = n3.animationModel, O2 = n3.dataIndex;
          if (m2)
            Xf2(m2, { shape: w2 }, E, O2);
          else {
            w2[T2.wh] = 0, m2 = new Vf2({ shape: w2 }), u.__pictorialBundle.setClipPath(m2), u.__pictorialClipPath = m2;
            var V3 = {};
            V3[T2.wh] = n3.clipShape[T2.wh], mot[p2 ? "updateProps" : "initProps"](m2, { shape: V3 }, E, O2);
          }
        }
      }
      function nwe(u, o) {
        var n3 = u.getItemModel(o);
        return n3.getAnimationDelayParams = OIn, n3.isAnimationEnabled = RIn, n3;
      }
      function OIn(u) {
        return { index: u.__pictorialAnimationIndex, count: u.__pictorialRepeatTimes };
      }
      function RIn() {
        return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
      }
      function rwe(u, o, n3, p2) {
        var m2 = new uu(), w2 = new uu();
        return m2.add(w2), m2.__pictorialBundle = w2, w2.x = n3.bundlePosition[0], w2.y = n3.bundlePosition[1], n3.symbolRepeat ? Qxe(m2, o, n3) : Jxe(m2, o, n3), twe(m2, n3, p2), ewe(m2, o, n3, p2), m2.__pictorialShapeStr = awe(u, n3), m2.__pictorialSymbolMeta = n3, m2;
      }
      function NIn(u, o, n3) {
        var p2 = n3.animationModel, m2 = n3.dataIndex, w2 = u.__pictorialBundle;
        Xf2(w2, { x: n3.bundlePosition[0], y: n3.bundlePosition[1] }, p2, m2), n3.symbolRepeat ? Qxe(u, o, n3, true) : Jxe(u, o, n3, true), twe(u, n3, true), ewe(u, o, n3, true);
      }
      function iwe(u, o, n3, p2) {
        var m2 = p2.__pictorialBarRect;
        m2 && m2.removeTextContent();
        var w2 = [];
        J7t(p2, function(T2) {
          w2.push(T2);
        }), p2.__pictorialMainPath && w2.push(p2.__pictorialMainPath), p2.__pictorialClipPath && (n3 = null), Xe2(w2, function(T2) {
          HP(T2, { scaleX: 0, scaleY: 0 }, n3, o, function() {
            p2.parent && p2.parent.remove(p2);
          });
        }), u.setItemGraphicEl(o, null);
      }
      function awe(u, o) {
        return [u.getItemVisual(o.dataIndex, "symbol") || "none", !!o.symbolRepeat, !!o.symbolClip].join(":");
      }
      function J7t(u, o, n3) {
        Xe2(u.__pictorialBundle.children(), function(p2) {
          p2 !== u.__pictorialBarRect && o.call(n3, p2);
        });
      }
      function xY(u, o, n3, p2, m2, w2) {
        o && u.attr(o), p2.symbolClip && !m2 ? n3 && u.attr(n3) : n3 && mot[m2 ? "updateProps" : "initProps"](u, n3, p2.animationModel, p2.dataIndex, w2);
      }
      function owe(u, o, n3) {
        var p2 = n3.dataIndex, m2 = n3.itemModel, w2 = m2.getModel("emphasis"), T2 = w2.getModel("itemStyle").getItemStyle(), E = m2.getModel(["blur", "itemStyle"]).getItemStyle(), O2 = m2.getModel(["select", "itemStyle"]).getItemStyle(), V3 = m2.getShallow("cursor"), W3 = w2.get("focus"), q3 = w2.get("blurScope"), K = w2.get("scale");
        J7t(u, function(gt) {
          if (gt instanceof Fm) {
            var yt = gt.style;
            gt.useStyle(ua2({ image: yt.image, x: yt.x, y: yt.y, width: yt.width, height: yt.height }, n3.style));
          } else
            gt.useStyle(n3.style);
          var At = gt.ensureState("emphasis");
          At.style = T2, K && (At.scaleX = gt.scaleX * 1.1, At.scaleY = gt.scaleY * 1.1), gt.ensureState("blur").style = E, gt.ensureState("select").style = O2, V3 && (gt.cursor = V3), gt.z2 = n3.z2;
        });
        var J = o.valueDim.posDesc[+(n3.boundingLength > 0)], rt2 = u.__pictorialBarRect;
        Tw(rt2, Lb2(m2), { labelFetcher: o.seriesModel, labelDataIndex: p2, defaultText: fY(o.seriesModel.getData(), p2), inheritColor: n3.style.fill, defaultOpacity: n3.style.opacity, defaultOutsidePosition: J }), o0(u, W3, q3, w2.get("disabled"));
      }
      function swe(u) {
        var o = Math.round(u);
        return Math.abs(u - o) < 1e-4 ? o : Math.ceil(u);
      }
      var FIn = DIn, VIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.hasSymbolVisual = true, n3.defaultSymbol = "roundRect", n3;
        }
        return o.prototype.getInitialData = function(n3) {
          return n3.stack = null, u.prototype.getInitialData.apply(this, arguments);
        }, o.type = "series.pictorialBar", o.dependencies = ["grid"], o.defaultOption = r8(Txt.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), o;
      }(Txt), BIn = VIn;
      function zIn(u) {
        u.registerChartView(FIn), u.registerSeriesModel(BIn), u.registerLayout(u.PRIORITY.VISUAL.LAYOUT, wu(mme, "pictorialBar")), u.registerLayout(u.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, bme("pictorialBar"));
      }
      var jIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._layers = [], n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = n3.getData(), T2 = this, E = this.group, O2 = n3.getLayerSeries(), V3 = w2.getLayout("layoutInfo"), W3 = V3.rect, q3 = V3.boundaryGap;
          E.x = 0, E.y = W3.y + q3[0];
          function K(yt) {
            return yt.name;
          }
          var J = new C4(this._layersSeries || [], O2, K, K), rt2 = [];
          J.add(Is(gt, this, "add")).update(Is(gt, this, "update")).remove(Is(gt, this, "remove")).execute();
          function gt(yt, At, Lt) {
            var Wt = T2._layers;
            if (yt === "remove") {
              E.remove(Wt[At]);
              return;
            }
            for (var Nt = [], ue2 = [], ie2, pe2 = O2[At].indices, xe = 0; xe < pe2.length; xe++) {
              var Ce2 = w2.getItemLayout(pe2[xe]), Le2 = Ce2.x, ze = Ce2.y0, tn = Ce2.y;
              Nt.push(Le2, ze), ue2.push(Le2, ze + tn), ie2 = w2.getItemVisual(pe2[xe], "style");
            }
            var $e2, Tn = w2.getItemLayout(pe2[0]), zn = n3.getModel("label"), bn = zn.get("margin"), Xr = n3.getModel("emphasis");
            if (yt === "add") {
              var Xn = rt2[At] = new uu();
              $e2 = new P1e({ shape: { points: Nt, stackedOnPoints: ue2, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), Xn.add($e2), E.add(Xn), n3.isAnimationEnabled() && $e2.setClipPath(WIn($e2.getBoundingRect(), n3, function() {
                $e2.removeClipPath();
              }));
            } else {
              var Xn = Wt[Lt];
              $e2 = Xn.childAt(0), E.add(Xn), rt2[At] = Xn, Xf2($e2, { shape: { points: Nt, stackedOnPoints: ue2 } }, n3), DC($e2);
            }
            Tw($e2, Lb2(n3), { labelDataIndex: pe2[xe - 1], defaultText: w2.getName(pe2[xe - 1]), inheritColor: ie2.fill }, { normal: { verticalAlign: "middle" } }), $e2.setTextConfig({ position: null, local: true });
            var or = $e2.getTextContent();
            or && (or.x = Tn.x - bn, or.y = Tn.y0 + Tn.y / 2), $e2.useStyle(ie2), w2.setItemGraphicEl(At, $e2), Ky($e2, n3), o0($e2, Xr.get("focus"), Xr.get("blurScope"), Xr.get("disabled"));
          }
          this._layersSeries = O2, this._layers = rt2;
        }, o.type = "themeRiver", o;
      }(xg2);
      function WIn(u, o, n3) {
        var p2 = new Vf2({ shape: { x: u.x - 10, y: u.y - 10, width: 0, height: u.height + 20 } });
        return Qg2(p2, { shape: { x: u.x - 50, width: u.width + 100, height: u.height + 20 } }, o, n3), p2;
      }
      var GIn = jIn, tVt = 2, HIn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3) {
          u.prototype.init.apply(this, arguments), this.legendVisualProvider = new ost(Is(this.getData, this), Is(this.getRawData, this));
        }, o.prototype.fixData = function(n3) {
          var p2 = n3.length, m2 = {}, w2 = g$(n3, function(K) {
            return m2.hasOwnProperty(K[0] + "") || (m2[K[0] + ""] = -1), K[2];
          }), T2 = [];
          w2.buckets.each(function(K, J) {
            T2.push({ name: J, dataList: K });
          });
          for (var E = T2.length, O2 = 0; O2 < E; ++O2) {
            for (var V3 = T2[O2].name, W3 = 0; W3 < T2[O2].dataList.length; ++W3) {
              var q3 = T2[O2].dataList[W3][0] + "";
              m2[q3] = O2;
            }
            for (var q3 in m2)
              m2.hasOwnProperty(q3) && m2[q3] !== O2 && (m2[q3] = O2, n3[p2] = [q3, 0, V3], p2++);
          }
          return n3;
        }, o.prototype.getInitialData = function(n3, p2) {
          for (var m2 = this.getReferringComponents("singleAxis", Y0).models[0], w2 = m2.get("type"), T2 = Fp(n3.data, function(rt2) {
            return rt2[2] !== void 0;
          }), E = this.fixData(T2 || []), O2 = [], V3 = this.nameMap = pl(), W3 = 0, q3 = 0; q3 < E.length; ++q3)
            O2.push(E[q3][tVt]), V3.get(E[q3][tVt]) || (V3.set(E[q3][tVt], W3), W3++);
          var K = qot(E, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: axt(w2) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, J = new o2(K, this);
          return J.initData(E), J;
        }, o.prototype.getLayerSeries = function() {
          for (var n3 = this.getData(), p2 = n3.count(), m2 = [], w2 = 0; w2 < p2; ++w2)
            m2[w2] = w2;
          var T2 = n3.mapDimension("single"), E = g$(m2, function(V3) {
            return n3.get("name", V3);
          }), O2 = [];
          return E.buckets.each(function(V3, W3) {
            V3.sort(function(q3, K) {
              return n3.get(T2, q3) - n3.get(T2, K);
            }), O2.push({ name: W3, indices: V3 });
          }), O2;
        }, o.prototype.getAxisTooltipData = function(n3, p2, m2) {
          za2(n3) || (n3 = n3 ? [n3] : []);
          for (var w2 = this.getData(), T2 = this.getLayerSeries(), E = [], O2 = T2.length, V3, W3 = 0; W3 < O2; ++W3) {
            for (var q3 = Number.MAX_VALUE, K = -1, J = T2[W3].indices.length, rt2 = 0; rt2 < J; ++rt2) {
              var gt = w2.get(n3[0], T2[W3].indices[rt2]), yt = Math.abs(gt - p2);
              yt <= q3 && (V3 = gt, q3 = yt, K = T2[W3].indices[rt2]);
            }
            E.push(K);
          }
          return { dataIndices: E, nestestValue: V3 };
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          var w2 = this.getData(), T2 = w2.getName(n3), E = w2.get(w2.mapDimension("value"), n3);
          return k1("nameValue", { name: T2, value: E });
        }, o.type = "series.themeRiver", o.dependencies = ["singleAxis"], o.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, o;
      }(Rv), UIn = HIn;
      function qIn(u, o) {
        u.eachSeriesByType("themeRiver", function(n3) {
          var p2 = n3.getData(), m2 = n3.coordinateSystem, w2 = {}, T2 = m2.getRect();
          w2.rect = T2;
          var E = n3.get("boundaryGap"), O2 = m2.getAxis();
          if (w2.boundaryGap = E, O2.orient === "horizontal") {
            E[0] = Qo(E[0], T2.height), E[1] = Qo(E[1], T2.height);
            var V3 = T2.height - E[0] - E[1];
            lwe(p2, n3, V3);
          } else {
            E[0] = Qo(E[0], T2.width), E[1] = Qo(E[1], T2.width);
            var W3 = T2.width - E[0] - E[1];
            lwe(p2, n3, W3);
          }
          p2.setLayout("layoutInfo", w2);
        });
      }
      function lwe(u, o, n3) {
        if (u.count())
          for (var p2 = o.coordinateSystem, m2 = o.getLayerSeries(), w2 = u.mapDimension("single"), T2 = u.mapDimension("value"), E = Ya2(m2, function(yt) {
            return Ya2(yt.indices, function(At) {
              var Lt = p2.dataToPoint(u.get(w2, At));
              return Lt[1] = u.get(T2, At), Lt;
            });
          }), O2 = ZIn(E), V3 = O2.y0, W3 = n3 / O2.max, q3 = m2.length, K = m2[0].indices.length, J, rt2 = 0; rt2 < K; ++rt2) {
            J = V3[rt2] * W3, u.setItemLayout(m2[0].indices[rt2], { layerIndex: 0, x: E[0][rt2][0], y0: J, y: E[0][rt2][1] * W3 });
            for (var gt = 1; gt < q3; ++gt)
              J += E[gt - 1][rt2][1] * W3, u.setItemLayout(m2[gt].indices[rt2], { layerIndex: gt, x: E[gt][rt2][0], y0: J, y: E[gt][rt2][1] * W3 });
          }
      }
      function ZIn(u) {
        for (var o = u.length, n3 = u[0].length, p2 = [], m2 = [], w2 = 0, T2 = 0; T2 < n3; ++T2) {
          for (var E = 0, O2 = 0; O2 < o; ++O2)
            E += u[O2][T2][1];
          E > w2 && (w2 = E), p2.push(E);
        }
        for (var V3 = 0; V3 < n3; ++V3)
          m2[V3] = (w2 - p2[V3]) / 2;
        w2 = 0;
        for (var W3 = 0; W3 < n3; ++W3) {
          var q3 = p2[W3] + m2[W3];
          q3 > w2 && (w2 = q3);
        }
        return { y0: m2, max: w2 };
      }
      function $In(u) {
        u.registerChartView(GIn), u.registerSeriesModel(UIn), u.registerLayout(qIn), u.registerProcessor(ast("themeRiver"));
      }
      var YIn = 2, KIn = 4, XIn = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2) {
          var T2 = u.call(this) || this;
          T2.z2 = YIn, T2.textConfig = { inside: true }, is(T2).seriesIndex = p2.seriesIndex;
          var E = new Zc2({ z2: KIn, silent: n3.getModel().get(["label", "silent"]) });
          return T2.setTextContent(E), T2.updateData(true, n3, p2, m2, w2), T2;
        }
        return o.prototype.updateData = function(n3, p2, m2, w2, T2) {
          this.node = p2, p2.piece = this, m2 = m2 || this._seriesModel, w2 = w2 || this._ecModel;
          var E = this;
          is(E).dataIndex = p2.dataIndex;
          var O2 = p2.getModel(), V3 = O2.getModel("emphasis"), W3 = p2.getLayout(), q3 = ua2({}, W3);
          q3.label = null;
          var K = p2.getVisual("style");
          K.lineJoin = "bevel";
          var J = p2.getVisual("decal");
          J && (K.decal = Fot(J, T2));
          var rt2 = hY(O2.getModel("itemStyle"), q3, true);
          ua2(q3, rt2), Xe2(J_, function(Lt) {
            var Wt = E.ensureState(Lt), Nt = O2.getModel([Lt, "itemStyle"]);
            Wt.style = Nt.getItemStyle();
            var ue2 = hY(Nt, q3);
            ue2 && (Wt.shape = ue2);
          }), n3 ? (E.setShape(q3), E.shape.r = W3.r0, Xf2(E, { shape: { r: W3.r } }, m2, p2.dataIndex)) : (Xf2(E, { shape: q3 }, m2), DC(E)), E.useStyle(K), this._updateLabel(m2);
          var gt = O2.getShallow("cursor");
          gt && E.attr("cursor", gt), this._seriesModel = m2 || this._seriesModel, this._ecModel = w2 || this._ecModel;
          var yt = V3.get("focus"), At = yt === "ancestor" ? p2.getAncestorsIndices() : yt === "descendant" ? p2.getDescendantIndices() : yt;
          o0(this, At, V3.get("blurScope"), V3.get("disabled"));
        }, o.prototype._updateLabel = function(n3) {
          var p2 = this, m2 = this.node.getModel(), w2 = m2.getModel("label"), T2 = this.node.getLayout(), E = T2.endAngle - T2.startAngle, O2 = (T2.startAngle + T2.endAngle) / 2, V3 = Math.cos(O2), W3 = Math.sin(O2), q3 = this, K = q3.getTextContent(), J = this.node.dataIndex, rt2 = w2.get("minAngle") / 180 * Math.PI, gt = w2.get("show") && !(rt2 != null && Math.abs(E) < rt2);
          K.ignore = !gt, Xe2(yz, function(At) {
            var Lt = At === "normal" ? m2.getModel("label") : m2.getModel([At, "label"]), Wt = At === "normal", Nt = Wt ? K : K.ensureState(At), ue2 = n3.getFormattedLabel(J, At);
            Wt && (ue2 = ue2 || p2.node.name), Nt.style = Cy(Lt, {}, null, At !== "normal", true), ue2 && (Nt.style.text = ue2);
            var ie2 = Lt.get("show");
            ie2 != null && !Wt && (Nt.ignore = !ie2);
            var pe2 = yt(Lt, "position"), xe = Wt ? q3 : q3.states[At], Ce2 = xe.style.fill;
            xe.textConfig = { outsideFill: Lt.get("color") === "inherit" ? Ce2 : null, inside: pe2 !== "outside" };
            var Le2, ze = yt(Lt, "distance") || 0, tn = yt(Lt, "align");
            pe2 === "outside" ? (Le2 = T2.r + ze, tn = O2 > Math.PI / 2 ? "right" : "left") : !tn || tn === "center" ? (E === 2 * Math.PI && T2.r0 === 0 ? Le2 = 0 : Le2 = (T2.r + T2.r0) / 2, tn = "center") : tn === "left" ? (Le2 = T2.r0 + ze, O2 > Math.PI / 2 && (tn = "right")) : tn === "right" && (Le2 = T2.r - ze, O2 > Math.PI / 2 && (tn = "left")), Nt.style.align = tn, Nt.style.verticalAlign = yt(Lt, "verticalAlign") || "middle", Nt.x = Le2 * V3 + T2.cx, Nt.y = Le2 * W3 + T2.cy;
            var $e2 = yt(Lt, "rotate"), Tn = 0;
            $e2 === "radial" ? (Tn = -O2, Tn < -Math.PI / 2 && (Tn += Math.PI)) : $e2 === "tangential" ? (Tn = Math.PI / 2 - O2, Tn > Math.PI / 2 ? Tn -= Math.PI : Tn < -Math.PI / 2 && (Tn += Math.PI)) : Dh2($e2) && (Tn = $e2 * Math.PI / 180), Nt.rotation = Tn;
          });
          function yt(At, Lt) {
            var Wt = At.get(Lt);
            return Wt == null ? w2.get(Lt) : Wt;
          }
          K.dirtyStyle();
        }, o;
      }(ww), uwe = XIn, eVt = "sunburstRootToNode", cwe = "sunburstHighlight", QIn = "sunburstUnhighlight";
      function JIn(u) {
        u.registerAction({ type: eVt, update: "updateView" }, function(o, n3) {
          n3.eachComponent({ mainType: "series", subType: "sunburst", query: o }, p2);
          function p2(m2, w2) {
            var T2 = pst(o, [eVt], m2);
            if (T2) {
              var E = m2.getViewRoot();
              E && (o.direction = a7t(E, T2.node) ? "rollUp" : "drillDown"), m2.resetViewRoot(T2.node);
            }
          }
        }), u.registerAction({ type: cwe, update: "none" }, function(o, n3, p2) {
          o = ua2({}, o), n3.eachComponent({ mainType: "series", subType: "sunburst", query: o }, m2);
          function m2(w2) {
            var T2 = pst(o, [cwe], w2);
            T2 && (o.dataIndex = T2.node.dataIndex);
          }
          p2.dispatchAction(ua2(o, { type: "highlight" }));
        }), u.registerAction({ type: QIn, update: "updateView" }, function(o, n3, p2) {
          o = ua2({}, o), p2.dispatchAction(ua2(o, { type: "downplay" }));
        });
      }
      var tDn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          var T2 = this;
          this.seriesModel = n3, this.api = m2, this.ecModel = p2;
          var E = n3.getData(), O2 = E.tree.root, V3 = n3.getViewRoot(), W3 = this.group, q3 = n3.get("renderLabelForZeroData"), K = [];
          V3.eachNode(function(Lt) {
            K.push(Lt);
          });
          var J = this._oldChildren || [];
          rt2(K, J), At(O2, V3), this._initEvents(), this._oldChildren = K;
          function rt2(Lt, Wt) {
            if (Lt.length === 0 && Wt.length === 0)
              return;
            new C4(Wt, Lt, Nt, Nt).add(ue2).update(ue2).remove(wu(ue2, null)).execute();
            function Nt(ie2) {
              return ie2.getId();
            }
            function ue2(ie2, pe2) {
              var xe = ie2 == null ? null : Lt[ie2], Ce2 = pe2 == null ? null : Wt[pe2];
              gt(xe, Ce2);
            }
          }
          function gt(Lt, Wt) {
            if (!q3 && Lt && !Lt.getValue() && (Lt = null), Lt !== O2 && Wt !== O2) {
              if (Wt && Wt.piece)
                Lt ? (Wt.piece.updateData(false, Lt, n3, p2, m2), E.setItemGraphicEl(Lt.dataIndex, Wt.piece)) : yt(Wt);
              else if (Lt) {
                var Nt = new uwe(Lt, n3, p2, m2);
                W3.add(Nt), E.setItemGraphicEl(Lt.dataIndex, Nt);
              }
            }
          }
          function yt(Lt) {
            !Lt || Lt.piece && (W3.remove(Lt.piece), Lt.piece = null);
          }
          function At(Lt, Wt) {
            Wt.depth > 0 ? (T2.virtualPiece ? T2.virtualPiece.updateData(false, Lt, n3, p2, m2) : (T2.virtualPiece = new uwe(Lt, n3, p2, m2), W3.add(T2.virtualPiece)), Wt.piece.off("click"), T2.virtualPiece.on("click", function(Nt) {
              T2._rootToNode(Wt.parentNode);
            })) : T2.virtualPiece && (W3.remove(T2.virtualPiece), T2.virtualPiece = null);
          }
        }, o.prototype._initEvents = function() {
          var n3 = this;
          this.group.off("click"), this.group.on("click", function(p2) {
            var m2 = false, w2 = n3.seriesModel.getViewRoot();
            w2.eachNode(function(T2) {
              if (!m2 && T2.piece && T2.piece === p2.target) {
                var E = T2.getModel().get("nodeClick");
                if (E === "rootToNode")
                  n3._rootToNode(T2);
                else if (E === "link") {
                  var O2 = T2.getModel(), V3 = O2.get("link");
                  if (V3) {
                    var W3 = O2.get("target", true) || "_blank";
                    N_t(V3, W3);
                  }
                }
                m2 = true;
              }
            });
          });
        }, o.prototype._rootToNode = function(n3) {
          n3 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: eVt, from: this.uid, seriesId: this.seriesModel.id, targetNode: n3 });
        }, o.prototype.containPoint = function(n3, p2) {
          var m2 = p2.getData(), w2 = m2.getItemLayout(0);
          if (w2) {
            var T2 = n3[0] - w2.cx, E = n3[1] - w2.cy, O2 = Math.sqrt(T2 * T2 + E * E);
            return O2 <= w2.r && O2 >= w2.r0;
          }
        }, o.type = "sunburst", o;
      }(xg2), eDn = tDn, nDn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.ignoreStyleOnData = true, n3;
        }
        return o.prototype.getInitialData = function(n3, p2) {
          var m2 = { name: n3.name, children: n3.data };
          fwe(m2);
          var w2 = this._levelModels = Ya2(n3.levels || [], function(O2) {
            return new _g(O2, this, p2);
          }, this), T2 = i7t.createTree(m2, this, E);
          function E(O2) {
            O2.wrapMethod("getItemModel", function(V3, W3) {
              var q3 = T2.getNodeByDataIndex(W3), K = w2[q3.depth];
              return K && (V3.parentModel = K), V3;
            });
          }
          return T2.data;
        }, o.prototype.optionUpdated = function() {
          this.resetViewRoot();
        }, o.prototype.getDataParams = function(n3) {
          var p2 = u.prototype.getDataParams.apply(this, arguments), m2 = this.getData().tree.getNodeByDataIndex(n3);
          return p2.treePathInfo = Bxt(m2, this), p2;
        }, o.prototype.getLevelModel = function(n3) {
          return this._levelModels && this._levelModels[n3.depth];
        }, o.prototype.getViewRoot = function() {
          return this._viewRoot;
        }, o.prototype.resetViewRoot = function(n3) {
          n3 ? this._viewRoot = n3 : n3 = this._viewRoot;
          var p2 = this.getRawData().tree.root;
          (!n3 || n3 !== p2 && !p2.contains(n3)) && (this._viewRoot = p2);
        }, o.prototype.enableAriaDecal = function() {
          m_e(this);
        }, o.type = "series.sunburst", o.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, o;
      }(Rv);
      function fwe(u) {
        var o = 0;
        Xe2(u.children, function(p2) {
          fwe(p2);
          var m2 = p2.value;
          za2(m2) && (m2 = m2[0]), o += m2;
        });
        var n3 = u.value;
        za2(n3) && (n3 = n3[0]), (n3 == null || isNaN(n3)) && (n3 = o), n3 < 0 && (n3 = 0), za2(u.value) ? u.value[0] = n3 : u.value = n3;
      }
      var rDn = nDn, hwe = Math.PI / 180;
      function iDn(u, o, n3) {
        o.eachSeriesByType(u, function(p2) {
          var m2 = p2.get("center"), w2 = p2.get("radius");
          za2(w2) || (w2 = [0, w2]), za2(m2) || (m2 = [m2, m2]);
          var T2 = n3.getWidth(), E = n3.getHeight(), O2 = Math.min(T2, E), V3 = Qo(m2[0], T2), W3 = Qo(m2[1], E), q3 = Qo(w2[0], O2 / 2), K = Qo(w2[1], O2 / 2), J = -p2.get("startAngle") * hwe, rt2 = p2.get("minAngle") * hwe, gt = p2.getData().tree.root, yt = p2.getViewRoot(), At = yt.depth, Lt = p2.get("sort");
          Lt != null && pwe(yt, Lt);
          var Wt = 0;
          Xe2(yt.children, function(bn) {
            !isNaN(bn.getValue()) && Wt++;
          });
          var Nt = yt.getValue(), ue2 = Math.PI / (Nt || Wt) * 2, ie2 = yt.depth > 0, pe2 = yt.height - (ie2 ? -1 : 1), xe = (K - q3) / (pe2 || 1), Ce2 = p2.get("clockwise"), Le2 = p2.get("stillShowZeroSum"), ze = Ce2 ? 1 : -1, tn = function(bn, Xr) {
            if (bn) {
              var Xn = Xr;
              if (bn !== gt) {
                var or = bn.getValue(), Tr = Nt === 0 && Le2 ? ue2 : or * ue2;
                Tr < rt2 && (Tr = rt2), Xn = Xr + ze * Tr;
                var ci2 = bn.depth - At - (ie2 ? -1 : 1), yi2 = q3 + xe * ci2, Po = q3 + xe * (ci2 + 1), Ms = p2.getLevelModel(bn);
                if (Ms) {
                  var dl = Ms.get("r0", true), tl = Ms.get("r", true), el = Ms.get("radius", true);
                  el != null && (dl = el[0], tl = el[1]), dl != null && (yi2 = Qo(dl, O2 / 2)), tl != null && (Po = Qo(tl, O2 / 2));
                }
                bn.setLayout({ angle: Tr, startAngle: Xr, endAngle: Xn, clockwise: Ce2, cx: V3, cy: W3, r0: yi2, r: Po });
              }
              if (bn.children && bn.children.length) {
                var as = 0;
                Xe2(bn.children, function(Hs) {
                  as += tn(Hs, Xr + as);
                });
              }
              return Xn - Xr;
            }
          };
          if (ie2) {
            var $e2 = q3, Tn = q3 + xe, zn = Math.PI * 2;
            gt.setLayout({ angle: zn, startAngle: J, endAngle: J + zn, clockwise: Ce2, cx: V3, cy: W3, r0: $e2, r: Tn });
          }
          tn(yt, J);
        });
      }
      function pwe(u, o) {
        var n3 = u.children || [];
        u.children = aDn(n3, o), n3.length && Xe2(u.children, function(p2) {
          pwe(p2, o);
        });
      }
      function aDn(u, o) {
        if (Sl(o)) {
          var n3 = Ya2(u, function(m2, w2) {
            var T2 = m2.getValue();
            return { params: { depth: m2.depth, height: m2.height, dataIndex: m2.dataIndex, getValue: function() {
              return T2;
            } }, index: w2 };
          });
          return n3.sort(function(m2, w2) {
            return o(m2.params, w2.params);
          }), Ya2(n3, function(m2) {
            return u[m2.index];
          });
        } else {
          var p2 = o === "asc";
          return u.sort(function(m2, w2) {
            var T2 = (m2.getValue() - w2.getValue()) * (p2 ? 1 : -1);
            return T2 === 0 ? (m2.dataIndex - w2.dataIndex) * (p2 ? -1 : 1) : T2;
          });
        }
      }
      function oDn(u) {
        var o = {};
        function n3(p2, m2, w2) {
          for (var T2 = p2; T2 && T2.depth > 1; )
            T2 = T2.parentNode;
          var E = m2.getColorFromPalette(T2.name || T2.dataIndex + "", o);
          return p2.depth > 1 && ds(E) && (E = Qit(E, (p2.depth - 1) / (w2 - 1) * 0.5)), E;
        }
        u.eachSeriesByType("sunburst", function(p2) {
          var m2 = p2.getData(), w2 = m2.tree;
          w2.eachNode(function(T2) {
            var E = T2.getModel(), O2 = E.getModel("itemStyle").getItemStyle();
            O2.fill || (O2.fill = n3(T2, p2, w2.root.height));
            var V3 = m2.ensureUniqueItemVisual(T2.dataIndex, "style");
            ua2(V3, O2);
          });
        });
      }
      function sDn(u) {
        u.registerChartView(eDn), u.registerSeriesModel(rDn), u.registerLayout(wu(iDn, "sunburst")), u.registerProcessor(wu(ast, "sunburst")), u.registerVisual(oDn), JIn(u);
      }
      var dwe = { color: "fill", borderColor: "stroke" }, lDn = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, P4 = Ff2(), uDn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.optionUpdated = function() {
          this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
        }, o.prototype.getInitialData = function(n3, p2) {
          return T4(null, this);
        }, o.prototype.getDataParams = function(n3, p2, m2) {
          var w2 = u.prototype.getDataParams.call(this, n3, p2);
          return m2 && (w2.info = P4(m2).info), w2;
        }, o.type = "series.custom", o.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], o.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, o;
      }(Rv), cDn = uDn;
      function fDn(u, o) {
        return o = o || [0, 0], Ya2(["x", "y"], function(n3, p2) {
          var m2 = this.getAxis(n3), w2 = o[p2], T2 = u[p2] / 2;
          return m2.type === "category" ? m2.getBandWidth() : Math.abs(m2.dataToCoord(w2 - T2) - m2.dataToCoord(w2 + T2));
        }, this);
      }
      function hDn(u) {
        var o = u.master.getRect();
        return { coordSys: { type: "cartesian2d", x: o.x, y: o.y, width: o.width, height: o.height }, api: { coord: function(n3) {
          return u.dataToPoint(n3);
        }, size: Is(fDn, u) } };
      }
      function pDn(u, o) {
        return o = o || [0, 0], Ya2([0, 1], function(n3) {
          var p2 = o[n3], m2 = u[n3] / 2, w2 = [], T2 = [];
          return w2[n3] = p2 - m2, T2[n3] = p2 + m2, w2[1 - n3] = T2[1 - n3] = o[1 - n3], Math.abs(this.dataToPoint(w2)[n3] - this.dataToPoint(T2)[n3]);
        }, this);
      }
      function dDn(u) {
        var o = u.getBoundingRect();
        return { coordSys: { type: "geo", x: o.x, y: o.y, width: o.width, height: o.height, zoom: u.getZoom() }, api: { coord: function(n3) {
          return u.dataToPoint(n3);
        }, size: Is(pDn, u) } };
      }
      function gDn(u, o) {
        var n3 = this.getAxis(), p2 = o instanceof Array ? o[0] : o, m2 = (u instanceof Array ? u[0] : u) / 2;
        return n3.type === "category" ? n3.getBandWidth() : Math.abs(n3.dataToCoord(p2 - m2) - n3.dataToCoord(p2 + m2));
      }
      function vDn(u) {
        var o = u.getRect();
        return { coordSys: { type: "singleAxis", x: o.x, y: o.y, width: o.width, height: o.height }, api: { coord: function(n3) {
          return u.dataToPoint(n3);
        }, size: Is(gDn, u) } };
      }
      function yDn(u, o) {
        return o = o || [0, 0], Ya2(["Radius", "Angle"], function(n3, p2) {
          var m2 = "get" + n3 + "Axis", w2 = this[m2](), T2 = o[p2], E = u[p2] / 2, O2 = w2.type === "category" ? w2.getBandWidth() : Math.abs(w2.dataToCoord(T2 - E) - w2.dataToCoord(T2 + E));
          return n3 === "Angle" && (O2 = O2 * Math.PI / 180), O2;
        }, this);
      }
      function mDn(u) {
        var o = u.getRadiusAxis(), n3 = u.getAngleAxis(), p2 = o.getExtent();
        return p2[0] > p2[1] && p2.reverse(), { coordSys: { type: "polar", cx: u.cx, cy: u.cy, r: p2[1], r0: p2[0] }, api: { coord: function(m2) {
          var w2 = o.dataToRadius(m2[0]), T2 = n3.dataToAngle(m2[1]), E = u.coordToPoint([w2, T2]);
          return E.push(w2, T2 * Math.PI / 180), E;
        }, size: Is(yDn, u) } };
      }
      function bDn(u) {
        var o = u.getRect(), n3 = u.getRangeInfo();
        return { coordSys: { type: "calendar", x: o.x, y: o.y, width: o.width, height: o.height, cellWidth: u.getCellWidth(), cellHeight: u.getCellHeight(), rangeInfo: { start: n3.start, end: n3.end, weeks: n3.weeks, dayCount: n3.allDay } }, api: { coord: function(p2, m2) {
          return u.dataToPoint(p2, m2);
        } } };
      }
      function gwe(u, o, n3, p2) {
        return u && (u.legacy || u.legacy !== false && !n3 && !p2 && o !== "tspan" && (o === "text" || Fs(u, "text")));
      }
      function vwe(u, o, n3) {
        var p2 = u, m2, w2, T2;
        if (o === "text")
          T2 = p2;
        else {
          T2 = {}, Fs(p2, "text") && (T2.text = p2.text), Fs(p2, "rich") && (T2.rich = p2.rich), Fs(p2, "textFill") && (T2.fill = p2.textFill), Fs(p2, "textStroke") && (T2.stroke = p2.textStroke), Fs(p2, "fontFamily") && (T2.fontFamily = p2.fontFamily), Fs(p2, "fontSize") && (T2.fontSize = p2.fontSize), Fs(p2, "fontStyle") && (T2.fontStyle = p2.fontStyle), Fs(p2, "fontWeight") && (T2.fontWeight = p2.fontWeight), w2 = { type: "text", style: T2, silent: true }, m2 = {};
          var E = Fs(p2, "textPosition");
          n3 ? m2.position = E ? p2.textPosition : "inside" : E && (m2.position = p2.textPosition), Fs(p2, "textPosition") && (m2.position = p2.textPosition), Fs(p2, "textOffset") && (m2.offset = p2.textOffset), Fs(p2, "textRotation") && (m2.rotation = p2.textRotation), Fs(p2, "textDistance") && (m2.distance = p2.textDistance);
        }
        return ywe(T2, u), Xe2(T2.rich, function(O2) {
          ywe(O2, O2);
        }), { textConfig: m2, textContent: w2 };
      }
      function ywe(u, o) {
        !o || (o.font = o.textFont || o.font, Fs(o, "textStrokeWidth") && (u.lineWidth = o.textStrokeWidth), Fs(o, "textAlign") && (u.align = o.textAlign), Fs(o, "textVerticalAlign") && (u.verticalAlign = o.textVerticalAlign), Fs(o, "textLineHeight") && (u.lineHeight = o.textLineHeight), Fs(o, "textWidth") && (u.width = o.textWidth), Fs(o, "textHeight") && (u.height = o.textHeight), Fs(o, "textBackgroundColor") && (u.backgroundColor = o.textBackgroundColor), Fs(o, "textPadding") && (u.padding = o.textPadding), Fs(o, "textBorderColor") && (u.borderColor = o.textBorderColor), Fs(o, "textBorderWidth") && (u.borderWidth = o.textBorderWidth), Fs(o, "textBorderRadius") && (u.borderRadius = o.textBorderRadius), Fs(o, "textBoxShadowColor") && (u.shadowColor = o.textBoxShadowColor), Fs(o, "textBoxShadowBlur") && (u.shadowBlur = o.textBoxShadowBlur), Fs(o, "textBoxShadowOffsetX") && (u.shadowOffsetX = o.textBoxShadowOffsetX), Fs(o, "textBoxShadowOffsetY") && (u.shadowOffsetY = o.textBoxShadowOffsetY));
      }
      function mwe(u, o, n3) {
        var p2 = u;
        p2.textPosition = p2.textPosition || n3.position || "inside", n3.offset != null && (p2.textOffset = n3.offset), n3.rotation != null && (p2.textRotation = n3.rotation), n3.distance != null && (p2.textDistance = n3.distance);
        var m2 = p2.textPosition.indexOf("inside") >= 0, w2 = u.fill || "#000";
        bwe(p2, o);
        var T2 = p2.textFill == null;
        return m2 ? T2 && (p2.textFill = n3.insideFill || "#fff", !p2.textStroke && n3.insideStroke && (p2.textStroke = n3.insideStroke), !p2.textStroke && (p2.textStroke = w2), p2.textStrokeWidth == null && (p2.textStrokeWidth = 2)) : (T2 && (p2.textFill = u.fill || n3.outsideFill || "#000"), !p2.textStroke && n3.outsideStroke && (p2.textStroke = n3.outsideStroke)), p2.text = o.text, p2.rich = o.rich, Xe2(o.rich, function(E) {
          bwe(E, E);
        }), p2;
      }
      function bwe(u, o) {
        !o || (Fs(o, "fill") && (u.textFill = o.fill), Fs(o, "stroke") && (u.textStroke = o.fill), Fs(o, "lineWidth") && (u.textStrokeWidth = o.lineWidth), Fs(o, "font") && (u.font = o.font), Fs(o, "fontStyle") && (u.fontStyle = o.fontStyle), Fs(o, "fontWeight") && (u.fontWeight = o.fontWeight), Fs(o, "fontSize") && (u.fontSize = o.fontSize), Fs(o, "fontFamily") && (u.fontFamily = o.fontFamily), Fs(o, "align") && (u.textAlign = o.align), Fs(o, "verticalAlign") && (u.textVerticalAlign = o.verticalAlign), Fs(o, "lineHeight") && (u.textLineHeight = o.lineHeight), Fs(o, "width") && (u.textWidth = o.width), Fs(o, "height") && (u.textHeight = o.height), Fs(o, "backgroundColor") && (u.textBackgroundColor = o.backgroundColor), Fs(o, "padding") && (u.textPadding = o.padding), Fs(o, "borderColor") && (u.textBorderColor = o.borderColor), Fs(o, "borderWidth") && (u.textBorderWidth = o.borderWidth), Fs(o, "borderRadius") && (u.textBorderRadius = o.borderRadius), Fs(o, "shadowColor") && (u.textBoxShadowColor = o.shadowColor), Fs(o, "shadowBlur") && (u.textBoxShadowBlur = o.shadowBlur), Fs(o, "shadowOffsetX") && (u.textBoxShadowOffsetX = o.shadowOffsetX), Fs(o, "shadowOffsetY") && (u.textBoxShadowOffsetY = o.shadowOffsetY), Fs(o, "textShadowColor") && (u.textShadowColor = o.textShadowColor), Fs(o, "textShadowBlur") && (u.textShadowBlur = o.textShadowBlur), Fs(o, "textShadowOffsetX") && (u.textShadowOffsetX = o.textShadowOffsetX), Fs(o, "textShadowOffsetY") && (u.textShadowOffsetY = o.textShadowOffsetY));
      }
      var _we = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, xwe = tf2(_we);
      jA(KA, function(u, o) {
        return u[o] = 1, u;
      }, {}), KA.join(", ");
      var Qxt = ["", "style", "shape", "extra"], wY = Ff2();
      function nVt(u, o, n3, p2, m2) {
        var w2 = u + "Animation", T2 = t8(u, p2, m2) || {}, E = wY(o).userDuring;
        return T2.duration > 0 && (T2.during = E ? Is(MDn, { el: o, userDuring: E }) : null, T2.setToFinal = true, T2.scope = u), ua2(T2, n3[w2]), T2;
      }
      function Jxt(u, o, n3, p2) {
        p2 = p2 || {};
        var m2 = p2.dataIndex, w2 = p2.isInit, T2 = p2.clearStyle, E = n3.isAnimationEnabled(), O2 = wY(u), V3 = o.style;
        O2.userDuring = o.during;
        var W3 = {}, q3 = {};
        if (TDn(u, o, q3), Mwe("shape", o, q3), Mwe("extra", o, q3), !w2 && E && (CDn(u, o, W3), Swe("shape", u, o, W3), Swe("extra", u, o, W3), ADn(u, o, V3, W3)), q3.style = V3, _Dn(u, q3, T2), wDn(u, o), E)
          if (w2) {
            var K = {};
            Xe2(Qxt, function(rt2) {
              var gt = rt2 ? o[rt2] : o;
              gt && gt.enterFrom && (rt2 && (K[rt2] = K[rt2] || {}), ua2(rt2 ? K[rt2] : K, gt.enterFrom));
            });
            var J = nVt("enter", u, o, n3, m2);
            J.duration > 0 && u.animateFrom(K, J);
          } else
            xDn(u, o, m2 || 0, n3, W3);
        wwe(u, o), V3 ? u.dirty() : u.markRedraw();
      }
      function wwe(u, o) {
        for (var n3 = wY(u).leaveToProps, p2 = 0; p2 < Qxt.length; p2++) {
          var m2 = Qxt[p2], w2 = m2 ? o[m2] : o;
          w2 && w2.leaveTo && (n3 || (n3 = wY(u).leaveToProps = {}), m2 && (n3[m2] = n3[m2] || {}), ua2(m2 ? n3[m2] : n3, w2.leaveTo));
        }
      }
      function twt(u, o, n3, p2) {
        if (u) {
          var m2 = u.parent, w2 = wY(u).leaveToProps;
          if (w2) {
            var T2 = nVt("update", u, o, n3, 0);
            T2.done = function() {
              m2.remove(u), p2 && p2();
            }, u.animateTo(w2, T2);
          } else
            m2.remove(u), p2 && p2();
        }
      }
      function tj2(u) {
        return u === "all";
      }
      function _Dn(u, o, n3) {
        var p2 = o.style;
        if (!u.isGroup && p2) {
          if (n3) {
            u.useStyle({});
            for (var m2 = u.animators, w2 = 0; w2 < m2.length; w2++) {
              var T2 = m2[w2];
              T2.targetName === "style" && T2.changeTarget(u.style);
            }
          }
          u.setStyle(p2);
        }
        o && (o.style = null, o && u.attr(o), o.style = p2);
      }
      function xDn(u, o, n3, p2, m2) {
        if (m2) {
          var w2 = nVt("update", u, o, p2, n3);
          w2.duration > 0 && u.animateFrom(m2, w2);
        }
      }
      function wDn(u, o) {
        Fs(o, "silent") && (u.silent = o.silent), Fs(o, "ignore") && (u.ignore = o.ignore), u instanceof sM && Fs(o, "invisible") && (u.invisible = o.invisible), u instanceof Mc2 && Fs(o, "autoBatch") && (u.autoBatch = o.autoBatch);
      }
      var QP = {}, SDn = { setTransform: function(u, o) {
        return QP.el[u] = o, this;
      }, getTransform: function(u) {
        return QP.el[u];
      }, setShape: function(u, o) {
        var n3 = QP.el, p2 = n3.shape || (n3.shape = {});
        return p2[u] = o, n3.dirtyShape && n3.dirtyShape(), this;
      }, getShape: function(u) {
        var o = QP.el.shape;
        if (o)
          return o[u];
      }, setStyle: function(u, o) {
        var n3 = QP.el, p2 = n3.style;
        return p2 && (p2[u] = o, n3.dirtyStyle && n3.dirtyStyle()), this;
      }, getStyle: function(u) {
        var o = QP.el.style;
        if (o)
          return o[u];
      }, setExtra: function(u, o) {
        var n3 = QP.el.extra || (QP.el.extra = {});
        return n3[u] = o, this;
      }, getExtra: function(u) {
        var o = QP.el.extra;
        if (o)
          return o[u];
      } };
      function MDn() {
        var u = this, o = u.el;
        if (o) {
          var n3 = wY(o).userDuring, p2 = u.userDuring;
          if (n3 !== p2) {
            u.el = u.userDuring = null;
            return;
          }
          QP.el = o, p2(SDn);
        }
      }
      function Swe(u, o, n3, p2) {
        var m2 = n3[u];
        if (m2) {
          var w2 = o[u], T2;
          if (w2) {
            var E = n3.transition, O2 = m2.transition;
            if (O2)
              if (!T2 && (T2 = p2[u] = {}), tj2(O2))
                ua2(T2, w2);
              else
                for (var V3 = Tp(O2), W3 = 0; W3 < V3.length; W3++) {
                  var q3 = V3[W3], K = w2[q3];
                  T2[q3] = K;
                }
            else if (tj2(E) || sc2(E, u) >= 0) {
              !T2 && (T2 = p2[u] = {});
              for (var J = tf2(w2), W3 = 0; W3 < J.length; W3++) {
                var q3 = J[W3], K = w2[q3];
                IDn(m2[q3], K) && (T2[q3] = K);
              }
            }
          }
        }
      }
      function Mwe(u, o, n3) {
        var p2 = o[u];
        if (p2)
          for (var m2 = n3[u] = {}, w2 = tf2(p2), T2 = 0; T2 < w2.length; T2++) {
            var E = w2[T2];
            m2[E] = XS(p2[E]);
          }
      }
      function CDn(u, o, n3) {
        for (var p2 = o.transition, m2 = tj2(p2) ? KA : Tp(p2 || []), w2 = 0; w2 < m2.length; w2++) {
          var T2 = m2[w2];
          if (!(T2 === "style" || T2 === "shape" || T2 === "extra")) {
            var E = u[T2];
            n3[T2] = E;
          }
        }
      }
      function TDn(u, o, n3) {
        for (var p2 = 0; p2 < xwe.length; p2++) {
          var m2 = xwe[p2], w2 = _we[m2], T2 = o[m2];
          T2 && (n3[w2[0]] = T2[0], n3[w2[1]] = T2[1]);
        }
        for (var p2 = 0; p2 < KA.length; p2++) {
          var E = KA[p2];
          o[E] != null && (n3[E] = o[E]);
        }
      }
      function ADn(u, o, n3, p2) {
        if (n3) {
          var m2 = u.style, w2;
          if (m2) {
            var T2 = n3.transition, E = o.transition;
            if (T2 && !tj2(T2)) {
              var O2 = Tp(T2);
              !w2 && (w2 = p2.style = {});
              for (var V3 = 0; V3 < O2.length; V3++) {
                var W3 = O2[V3], q3 = m2[W3];
                w2[W3] = q3;
              }
            } else if (u.getAnimationStyleProps && (tj2(E) || tj2(T2) || sc2(E, "style") >= 0)) {
              var K = u.getAnimationStyleProps(), J = K ? K.style : null;
              if (J) {
                !w2 && (w2 = p2.style = {});
                for (var rt2 = tf2(n3), V3 = 0; V3 < rt2.length; V3++) {
                  var W3 = rt2[V3];
                  if (J[W3]) {
                    var q3 = m2[W3];
                    w2[W3] = q3;
                  }
                }
              }
            }
          }
        }
      }
      function IDn(u, o) {
        return M1(u) ? u !== o : u != null && isFinite(u);
      }
      var Cwe = Ff2(), DDn = ["percent", "easing", "shape", "style", "extra"];
      function Twe(u) {
        u.stopAnimation("keyframe"), u.attr(Cwe(u));
      }
      function ewt(u, o, n3) {
        if (!(!n3.isAnimationEnabled() || !o)) {
          if (za2(o)) {
            Xe2(o, function(E) {
              ewt(u, E, n3);
            });
            return;
          }
          var p2 = o.keyframes, m2 = o.duration;
          if (n3 && m2 == null) {
            var w2 = t8("enter", n3, 0);
            m2 = w2 && w2.duration;
          }
          if (!(!p2 || !m2)) {
            var T2 = Cwe(u);
            Xe2(Qxt, function(E) {
              if (!(E && !u[E])) {
                var O2;
                p2.sort(function(V3, W3) {
                  return V3.percent - W3.percent;
                }), Xe2(p2, function(V3) {
                  var W3 = u.animators, q3 = E ? V3[E] : V3;
                  if (q3) {
                    var K = tf2(q3);
                    if (E || (K = Fp(K, function(gt) {
                      return sc2(DDn, gt) < 0;
                    })), !!K.length) {
                      O2 || (O2 = u.animate(E, o.loop, true), O2.scope = "keyframe");
                      for (var J = 0; J < W3.length; J++)
                        W3[J] !== O2 && W3[J].targetName === O2.targetName && W3[J].stopTracks(K);
                      E && (T2[E] = T2[E] || {});
                      var rt2 = E ? T2[E] : T2;
                      Xe2(K, function(gt) {
                        rt2[gt] = ((E ? u[E] : u) || {})[gt];
                      }), O2.whenWithKeys(m2 * V3.percent, q3, K, V3.easing);
                    }
                  }
                }), O2 && O2.delay(o.delay || 0).duration(m2).start(o.easing);
              }
            });
          }
        }
      }
      var L4 = "emphasis", m8 = "normal", rVt = "blur", iVt = "select", b8 = [m8, L4, rVt, iVt], aVt = { normal: ["itemStyle"], emphasis: [L4, "itemStyle"], blur: [rVt, "itemStyle"], select: [iVt, "itemStyle"] }, oVt = { normal: ["label"], emphasis: [L4, "label"], blur: [rVt, "label"], select: [iVt, "label"] }, EDn = ["x", "y"], kDn = "e\0\0", bI = { normal: {}, emphasis: {}, blur: {}, select: {} }, PDn = { cartesian2d: hDn, geo: dDn, singleAxis: vDn, polar: mDn, calendar: bDn };
      function sVt(u) {
        return u instanceof Mc2;
      }
      function lVt(u) {
        return u instanceof sM;
      }
      function LDn(u, o) {
        o.copyTransform(u), lVt(o) && lVt(u) && (o.setStyle(u.style), o.z = u.z, o.z2 = u.z2, o.zlevel = u.zlevel, o.invisible = u.invisible, o.ignore = u.ignore, sVt(o) && sVt(u) && o.setShape(u.shape));
      }
      var ODn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          this._progressiveEls = null;
          var T2 = this._data, E = n3.getData(), O2 = this.group, V3 = Iwe(n3, E, p2, m2);
          T2 || O2.removeAll(), E.diff(T2).add(function(q3) {
            fVt(m2, null, q3, V3(q3, w2), n3, O2, E);
          }).remove(function(q3) {
            var K = T2.getItemGraphicEl(q3);
            twt(K, P4(K).option, n3);
          }).update(function(q3, K) {
            var J = T2.getItemGraphicEl(K);
            fVt(m2, J, q3, V3(q3, w2), n3, O2, E);
          }).execute();
          var W3 = n3.get("clip", true) ? Cxt(n3.coordinateSystem, false, n3) : null;
          W3 ? O2.setClipPath(W3) : O2.removeClipPath(), this._data = E;
        }, o.prototype.incrementalPrepareRender = function(n3, p2, m2) {
          this.group.removeAll(), this._data = null;
        }, o.prototype.incrementalRender = function(n3, p2, m2, w2, T2) {
          var E = p2.getData(), O2 = Iwe(p2, E, m2, w2), V3 = this._progressiveEls = [];
          function W3(J) {
            J.isGroup || (J.incremental = true, J.ensureState("emphasis").hoverLayer = true);
          }
          for (var q3 = n3.start; q3 < n3.end; q3++) {
            var K = fVt(null, null, q3, O2(q3, T2), p2, this.group, E);
            K && (K.traverse(W3), V3.push(K));
          }
        }, o.prototype.eachRendered = function(n3) {
          n8(this._progressiveEls || this.group, n3);
        }, o.prototype.filterForExposedEvent = function(n3, p2, m2, w2) {
          var T2 = p2.element;
          if (T2 == null || m2.name === T2)
            return true;
          for (; (m2 = m2.__hostTarget || m2.parent) && m2 !== this.group; )
            if (m2.name === T2)
              return true;
          return false;
        }, o.type = "custom", o;
      }(xg2), RDn = ODn;
      function uVt(u) {
        var o = u.type, n3;
        if (o === "path") {
          var p2 = u.shape, m2 = p2.width != null && p2.height != null ? { x: p2.x || 0, y: p2.y || 0, width: p2.width, height: p2.height } : null, w2 = Lwe(p2);
          n3 = Vr(w2, null, m2, p2.layout || "center"), P4(n3).customPathData = w2;
        } else if (o === "image")
          n3 = new Fm({}), P4(n3).customImagePath = u.style.image;
        else if (o === "text")
          n3 = new Zc2({});
        else if (o === "group")
          n3 = new uu();
        else {
          if (o === "compoundPath")
            throw new Error('"compoundPath" is not supported yet.');
          var T2 = qn(o);
          if (!T2) {
            var E = "";
            lh2(E);
          }
          n3 = new T2();
        }
        return P4(n3).customGraphicType = o, n3.name = u.name, n3.z2EmphasisLift = 1, n3.z2SelectLift = 1, n3;
      }
      function cVt(u, o, n3, p2, m2, w2, T2) {
        Twe(o);
        var E = m2 && m2.normal.cfg;
        E && o.setTextConfig(E), p2 && p2.transition == null && (p2.transition = EDn);
        var O2 = p2 && p2.style;
        if (O2) {
          if (o.type === "text") {
            var V3 = O2;
            Fs(V3, "textFill") && (V3.fill = V3.textFill), Fs(V3, "textStroke") && (V3.stroke = V3.textStroke);
          }
          var W3 = void 0, q3 = sVt(o) ? O2.decal : null;
          u && q3 && (q3.dirty = true, W3 = Fot(q3, u)), O2.__decalPattern = W3;
        }
        if (lVt(o) && O2) {
          var W3 = O2.__decalPattern;
          W3 && (O2.decal = W3);
        }
        Jxt(o, p2, w2, { dataIndex: n3, isInit: T2, clearStyle: true }), ewt(o, p2.keyframeAnimation, w2);
      }
      function Awe(u, o, n3, p2, m2) {
        var w2 = o.isGroup ? null : o, T2 = m2 && m2[u].cfg;
        if (w2) {
          var E = w2.ensureState(u);
          if (p2 === false) {
            var O2 = w2.getState(u);
            O2 && (O2.style = null);
          } else
            E.style = p2 || null;
          T2 && (E.textConfig = T2), y4(w2);
        }
      }
      function NDn(u, o, n3) {
        if (!u.isGroup) {
          var p2 = u, m2 = n3.currentZ, w2 = n3.currentZLevel;
          p2.z = m2, p2.zlevel = w2;
          var T2 = o.z2;
          T2 != null && (p2.z2 = T2 || 0);
          for (var E = 0; E < b8.length; E++)
            FDn(p2, o, b8[E]);
        }
      }
      function FDn(u, o, n3) {
        var p2 = n3 === m8, m2 = p2 ? o : nwt(o, n3), w2 = m2 ? m2.z2 : null, T2;
        w2 != null && (T2 = p2 ? u : u.ensureState(n3), T2.z2 = w2 || 0);
      }
      function Iwe(u, o, n3, p2) {
        var m2 = u.get("renderItem"), w2 = u.coordinateSystem, T2 = {};
        w2 && (T2 = w2.prepareCustoms ? w2.prepareCustoms(w2) : PDn[w2.type](w2));
        for (var E = kl({ getWidth: p2.getWidth, getHeight: p2.getHeight, getZr: p2.getZr, getDevicePixelRatio: p2.getDevicePixelRatio, value: Nt, style: ie2, ordinalRawValue: ue2, styleEmphasis: pe2, visual: Le2, barLayout: ze, currentSeriesIndices: tn, font: $e2 }, T2.api || {}), O2 = { context: {}, seriesId: u.id, seriesName: u.name, seriesIndex: u.seriesIndex, coordSys: T2.coordSys, dataInsideLength: o.count(), encode: VDn(u.getData()) }, V3, W3, q3 = {}, K = {}, J = {}, rt2 = {}, gt = 0; gt < b8.length; gt++) {
          var yt = b8[gt];
          J[yt] = u.getModel(aVt[yt]), rt2[yt] = u.getModel(oVt[yt]);
        }
        function At(Tn) {
          return Tn === V3 ? W3 || (W3 = o.getItemModel(Tn)) : o.getItemModel(Tn);
        }
        function Lt(Tn, zn) {
          return o.hasItemOption ? Tn === V3 ? q3[zn] || (q3[zn] = At(Tn).getModel(aVt[zn])) : At(Tn).getModel(aVt[zn]) : J[zn];
        }
        function Wt(Tn, zn) {
          return o.hasItemOption ? Tn === V3 ? K[zn] || (K[zn] = At(Tn).getModel(oVt[zn])) : At(Tn).getModel(oVt[zn]) : rt2[zn];
        }
        return function(Tn, zn) {
          return V3 = Tn, W3 = null, q3 = {}, K = {}, m2 && m2(kl({ dataIndexInside: Tn, dataIndex: o.getRawIndex(Tn), actionType: zn ? zn.type : null }, O2), E);
        };
        function Nt(Tn, zn) {
          return zn == null && (zn = V3), o.getStore().get(o.getDimensionIndex(Tn || 0), zn);
        }
        function ue2(Tn, zn) {
          zn == null && (zn = V3), Tn = Tn || 0;
          var bn = o.getDimensionInfo(Tn);
          if (!bn) {
            var Xr = o.getDimensionIndex(Tn);
            return Xr >= 0 ? o.getStore().get(Xr, zn) : void 0;
          }
          var Xn = o.get(bn.name, zn), or = bn && bn.ordinalMeta;
          return or ? or.categories[Xn] : Xn;
        }
        function ie2(Tn, zn) {
          zn == null && (zn = V3);
          var bn = o.getItemVisual(zn, "style"), Xr = bn && bn.fill, Xn = bn && bn.opacity, or = Lt(zn, m8).getItemStyle();
          Xr != null && (or.fill = Xr), Xn != null && (or.opacity = Xn);
          var Tr = { inheritColor: ds(Xr) ? Xr : "#000" }, ci2 = Wt(zn, m8), yi2 = Cy(ci2, null, Tr, false, true);
          yi2.text = ci2.getShallow("show") ? Xu(u.getFormattedLabel(zn, m8), fY(o, zn)) : null;
          var Po = A_t(ci2, Tr, false);
          return Ce2(Tn, or), or = mwe(or, yi2, Po), Tn && xe(or, Tn), or.legacy = true, or;
        }
        function pe2(Tn, zn) {
          zn == null && (zn = V3);
          var bn = Lt(zn, L4).getItemStyle(), Xr = Wt(zn, L4), Xn = Cy(Xr, null, null, true, true);
          Xn.text = Xr.getShallow("show") ? gv(u.getFormattedLabel(zn, L4), u.getFormattedLabel(zn, m8), fY(o, zn)) : null;
          var or = A_t(Xr, null, true);
          return Ce2(Tn, bn), bn = mwe(bn, Xn, or), Tn && xe(bn, Tn), bn.legacy = true, bn;
        }
        function xe(Tn, zn) {
          for (var bn in zn)
            Fs(zn, bn) && (Tn[bn] = zn[bn]);
        }
        function Ce2(Tn, zn) {
          Tn && (Tn.textFill && (zn.textFill = Tn.textFill), Tn.textPosition && (zn.textPosition = Tn.textPosition));
        }
        function Le2(Tn, zn) {
          if (zn == null && (zn = V3), Fs(dwe, Tn)) {
            var bn = o.getItemVisual(zn, "style");
            return bn ? bn[dwe[Tn]] : null;
          }
          if (Fs(lDn, Tn))
            return o.getItemVisual(zn, Tn);
        }
        function ze(Tn) {
          if (w2.type === "cartesian2d") {
            var zn = w2.getBaseAxis();
            return Bbn(kl({ axis: zn }, Tn));
          }
        }
        function tn() {
          return n3.getCurrentSeriesIndices();
        }
        function $e2(Tn) {
          return dve(Tn, n3);
        }
      }
      function VDn(u) {
        var o = {};
        return Xe2(u.dimensions, function(n3) {
          var p2 = u.getDimensionInfo(n3);
          if (!p2.isExtraCoord) {
            var m2 = p2.coordDim, w2 = o[m2] = o[m2] || [];
            w2[p2.coordDimIndex] = u.getDimensionIndex(n3);
          }
        }), o;
      }
      function fVt(u, o, n3, p2, m2, w2, T2) {
        if (!p2) {
          w2.remove(o);
          return;
        }
        var E = hVt(u, o, n3, p2, m2, w2);
        return E && T2.setItemGraphicEl(n3, E), E && o0(E, p2.focus, p2.blurScope, p2.emphasisDisabled), E;
      }
      function hVt(u, o, n3, p2, m2, w2) {
        var T2 = -1, E = o;
        o && Dwe(o, p2, m2) && (T2 = sc2(w2.childrenRef(), o), o = null);
        var O2 = !o, V3 = o;
        V3 ? V3.clearStates() : (V3 = uVt(p2), E && LDn(E, V3)), p2.morph === false ? V3.disableMorphing = true : V3.disableMorphing && (V3.disableMorphing = false), bI.normal.cfg = bI.normal.conOpt = bI.emphasis.cfg = bI.emphasis.conOpt = bI.blur.cfg = bI.blur.conOpt = bI.select.cfg = bI.select.conOpt = null, bI.isLegacy = false, zDn(V3, n3, p2, m2, O2, bI), BDn(V3, n3, p2, m2, O2), cVt(u, V3, n3, p2, bI, m2, O2), Fs(p2, "info") && (P4(V3).info = p2.info);
        for (var W3 = 0; W3 < b8.length; W3++) {
          var q3 = b8[W3];
          if (q3 !== m8) {
            var K = nwt(p2, q3), J = pVt(p2, K, q3);
            Awe(q3, V3, K, J, bI);
          }
        }
        return NDn(V3, p2, m2), p2.type === "group" && jDn(u, V3, n3, p2, m2), T2 >= 0 ? w2.replaceAt(V3, T2) : w2.add(V3), V3;
      }
      function Dwe(u, o, n3) {
        var p2 = P4(u), m2 = o.type, w2 = o.shape, T2 = o.style;
        return n3.isUniversalTransitionEnabled() || m2 != null && m2 !== p2.customGraphicType || m2 === "path" && HDn(w2) && Lwe(w2) !== p2.customPathData || m2 === "image" && Fs(T2, "image") && T2.image !== p2.customImagePath;
      }
      function BDn(u, o, n3, p2, m2) {
        var w2 = n3.clipPath;
        if (w2 === false)
          u && u.getClipPath() && u.removeClipPath();
        else if (w2) {
          var T2 = u.getClipPath();
          T2 && Dwe(T2, w2, p2) && (T2 = null), T2 || (T2 = uVt(w2), u.setClipPath(T2)), cVt(null, T2, o, w2, null, p2, m2);
        }
      }
      function zDn(u, o, n3, p2, m2, w2) {
        if (!u.isGroup) {
          Ewe(n3, null, w2), Ewe(n3, L4, w2);
          var T2 = w2.normal.conOpt, E = w2.emphasis.conOpt, O2 = w2.blur.conOpt, V3 = w2.select.conOpt;
          if (T2 != null || E != null || V3 != null || O2 != null) {
            var W3 = u.getTextContent();
            if (T2 === false)
              W3 && u.removeTextContent();
            else {
              T2 = w2.normal.conOpt = T2 || { type: "text" }, W3 ? W3.clearStates() : (W3 = uVt(T2), u.setTextContent(W3)), cVt(null, W3, o, T2, null, p2, m2);
              for (var q3 = T2 && T2.style, K = 0; K < b8.length; K++) {
                var J = b8[K];
                if (J !== m8) {
                  var rt2 = w2[J].conOpt;
                  Awe(J, W3, rt2, pVt(T2, rt2, J), null);
                }
              }
              q3 ? W3.dirty() : W3.markRedraw();
            }
          }
        }
      }
      function Ewe(u, o, n3) {
        var p2 = o ? nwt(u, o) : u, m2 = o ? pVt(u, p2, L4) : u.style, w2 = u.type, T2 = p2 ? p2.textConfig : null, E = u.textContent, O2 = E ? o ? nwt(E, o) : E : null;
        if (m2 && (n3.isLegacy || gwe(m2, w2, !!T2, !!O2))) {
          n3.isLegacy = true;
          var V3 = vwe(m2, w2, !o);
          !T2 && V3.textConfig && (T2 = V3.textConfig), !O2 && V3.textContent && (O2 = V3.textContent);
        }
        if (!o && O2) {
          var W3 = O2;
          !W3.type && (W3.type = "text");
        }
        var q3 = o ? n3[o] : n3.normal;
        q3.cfg = T2, q3.conOpt = O2;
      }
      function nwt(u, o) {
        return o ? u ? u[o] : null : u;
      }
      function pVt(u, o, n3) {
        var p2 = o && o.style;
        return p2 == null && n3 === L4 && u && (p2 = u.styleEmphasis), p2;
      }
      function jDn(u, o, n3, p2, m2) {
        var w2 = p2.children, T2 = w2 ? w2.length : 0, E = p2.$mergeChildren, O2 = E === "byName" || p2.diffChildrenByName, V3 = E === false;
        if (!(!T2 && !O2 && !V3)) {
          if (O2) {
            WDn({ api: u, oldChildren: o.children() || [], newChildren: w2 || [], dataIndex: n3, seriesModel: m2, group: o });
            return;
          }
          V3 && o.removeAll();
          for (var W3 = 0; W3 < T2; W3++)
            w2[W3] && hVt(u, o.childAt(W3), n3, w2[W3], m2, o);
          for (var q3 = o.childCount() - 1; q3 >= W3; q3--) {
            var K = o.childAt(q3);
            twt(K, P4(o).option, m2);
          }
        }
      }
      function WDn(u) {
        new C4(u.oldChildren, u.newChildren, kwe, kwe, u).add(Pwe).update(Pwe).remove(GDn).execute();
      }
      function kwe(u, o) {
        var n3 = u && u.name;
        return n3 != null ? n3 : kDn + o;
      }
      function Pwe(u, o) {
        var n3 = this.context, p2 = u != null ? n3.newChildren[u] : null, m2 = o != null ? n3.oldChildren[o] : null;
        hVt(n3.api, m2, n3.dataIndex, p2, n3.seriesModel, n3.group);
      }
      function GDn(u) {
        var o = this.context, n3 = o.oldChildren[u];
        twt(n3, P4(n3).option, o.seriesModel);
      }
      function Lwe(u) {
        return u && (u.pathData || u.d);
      }
      function HDn(u) {
        return u && (Fs(u, "pathData") || Fs(u, "d"));
      }
      function UDn(u) {
        u.registerChartView(RDn), u.registerSeriesModel(cDn);
      }
      var ej2 = Ff2(), Owe = jl, dVt = Is, qDn = function() {
        function u() {
          this._dragging = false, this.animationThreshold = 15;
        }
        return u.prototype.render = function(o, n3, p2, m2) {
          var w2 = n3.get("value"), T2 = n3.get("status");
          if (this._axisModel = o, this._axisPointerModel = n3, this._api = p2, !(!m2 && this._lastValue === w2 && this._lastStatus === T2)) {
            this._lastValue = w2, this._lastStatus = T2;
            var E = this._group, O2 = this._handle;
            if (!T2 || T2 === "hide") {
              E && E.hide(), O2 && O2.hide();
              return;
            }
            E && E.show(), O2 && O2.show();
            var V3 = {};
            this.makeElOption(V3, w2, o, n3, p2);
            var W3 = V3.graphicKey;
            W3 !== this._lastGraphicKey && this.clear(p2), this._lastGraphicKey = W3;
            var q3 = this._moveAnimation = this.determineAnimation(o, n3);
            if (!E)
              E = this._group = new uu(), this.createPointerEl(E, V3, o, n3), this.createLabelEl(E, V3, o, n3), p2.getZr().add(E);
            else {
              var K = wu(Rwe, n3, q3);
              this.updatePointerEl(E, V3, K), this.updateLabelEl(E, V3, K, n3);
            }
            Vwe(E, n3, true), this._renderHandle(w2);
          }
        }, u.prototype.remove = function(o) {
          this.clear(o);
        }, u.prototype.dispose = function(o) {
          this.clear(o);
        }, u.prototype.determineAnimation = function(o, n3) {
          var p2 = n3.get("animation"), m2 = o.axis, w2 = m2.type === "category", T2 = n3.get("snap");
          if (!T2 && !w2)
            return false;
          if (p2 === "auto" || p2 == null) {
            var E = this.animationThreshold;
            if (w2 && m2.getBandWidth() > E)
              return true;
            if (T2) {
              var O2 = W9t(o).seriesDataCount, V3 = m2.getExtent();
              return Math.abs(V3[0] - V3[1]) / O2 > E;
            }
            return false;
          }
          return p2 === true;
        }, u.prototype.makeElOption = function(o, n3, p2, m2, w2) {
        }, u.prototype.createPointerEl = function(o, n3, p2, m2) {
          var w2 = n3.pointer;
          if (w2) {
            var T2 = ej2(o).pointerEl = new mot[w2.type](Owe(n3.pointer));
            o.add(T2);
          }
        }, u.prototype.createLabelEl = function(o, n3, p2, m2) {
          if (n3.label) {
            var w2 = ej2(o).labelEl = new Zc2(Owe(n3.label));
            o.add(w2), Fwe(w2, m2);
          }
        }, u.prototype.updatePointerEl = function(o, n3, p2) {
          var m2 = ej2(o).pointerEl;
          m2 && n3.pointer && (m2.setStyle(n3.pointer.style), p2(m2, { shape: n3.pointer.shape }));
        }, u.prototype.updateLabelEl = function(o, n3, p2, m2) {
          var w2 = ej2(o).labelEl;
          w2 && (w2.setStyle(n3.label.style), p2(w2, { x: n3.label.x, y: n3.label.y }), Fwe(w2, m2));
        }, u.prototype._renderHandle = function(o) {
          if (!(this._dragging || !this.updateHandleTransform)) {
            var n3 = this._axisPointerModel, p2 = this._api.getZr(), m2 = this._handle, w2 = n3.getModel("handle"), T2 = n3.get("status");
            if (!w2.get("show") || !T2 || T2 === "hide") {
              m2 && p2.remove(m2), this._handle = null;
              return;
            }
            var E;
            this._handle || (E = true, m2 = this._handle = yv(w2.get("icon"), { cursor: "move", draggable: true, onmousemove: function(V3) {
              UE(V3.event);
            }, onmousedown: dVt(this._onHandleDragMove, this, 0, 0), drift: dVt(this._onHandleDragMove, this), ondragend: dVt(this._onHandleDragEnd, this) }), p2.add(m2)), Vwe(m2, n3, false), m2.setStyle(w2.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
            var O2 = w2.get("size");
            za2(O2) || (O2 = [O2, O2]), m2.scaleX = O2[0] / 2, m2.scaleY = O2[1] / 2, nY(this, "_doDispatchAxisPointer", w2.get("throttle") || 0, "fixRate"), this._moveHandleToValue(o, E);
          }
        }, u.prototype._moveHandleToValue = function(o, n3) {
          Rwe(this._axisPointerModel, !n3 && this._moveAnimation, this._handle, gVt(this.getHandleTransform(o, this._axisModel, this._axisPointerModel)));
        }, u.prototype._onHandleDragMove = function(o, n3) {
          var p2 = this._handle;
          if (p2) {
            this._dragging = true;
            var m2 = this.updateHandleTransform(gVt(p2), [o, n3], this._axisModel, this._axisPointerModel);
            this._payloadInfo = m2, p2.stopAnimation(), p2.attr(gVt(m2)), ej2(p2).lastProp = null, this._doDispatchAxisPointer();
          }
        }, u.prototype._doDispatchAxisPointer = function() {
          var o = this._handle;
          if (o) {
            var n3 = this._payloadInfo, p2 = this._axisModel;
            this._api.dispatchAction({ type: "updateAxisPointer", x: n3.cursorPoint[0], y: n3.cursorPoint[1], tooltipOption: n3.tooltipOption, axesInfo: [{ axisDim: p2.axis.dim, axisIndex: p2.componentIndex }] });
          }
        }, u.prototype._onHandleDragEnd = function() {
          this._dragging = false;
          var o = this._handle;
          if (o) {
            var n3 = this._axisPointerModel.get("value");
            this._moveHandleToValue(n3), this._api.dispatchAction({ type: "hideTip" });
          }
        }, u.prototype.clear = function(o) {
          this._lastValue = null, this._lastStatus = null;
          var n3 = o.getZr(), p2 = this._group, m2 = this._handle;
          n3 && p2 && (this._lastGraphicKey = null, p2 && n3.remove(p2), m2 && n3.remove(m2), this._group = null, this._handle = null, this._payloadInfo = null), kot(this, "_doDispatchAxisPointer");
        }, u.prototype.doClear = function() {
        }, u.prototype.buildLabel = function(o, n3, p2) {
          return p2 = p2 || 0, { x: o[p2], y: o[1 - p2], width: n3[p2], height: n3[1 - p2] };
        }, u;
      }();
      function Rwe(u, o, n3, p2) {
        Nwe(ej2(n3).lastProp, p2) || (ej2(n3).lastProp = p2, o ? Xf2(n3, p2, u) : (n3.stopAnimation(), n3.attr(p2)));
      }
      function Nwe(u, o) {
        if (ys(u) && ys(o)) {
          var n3 = true;
          return Xe2(o, function(p2, m2) {
            n3 = n3 && Nwe(u[m2], p2);
          }), !!n3;
        } else
          return u === o;
      }
      function Fwe(u, o) {
        u[o.get(["label", "show"]) ? "show" : "hide"]();
      }
      function gVt(u) {
        return { x: u.x || 0, y: u.y || 0, rotation: u.rotation || 0 };
      }
      function Vwe(u, o, n3) {
        var p2 = o.get("z"), m2 = o.get("zlevel");
        u && u.traverse(function(w2) {
          w2.type !== "group" && (p2 != null && (w2.z = p2), m2 != null && (w2.zlevel = m2), w2.silent = n3);
        });
      }
      var vVt = qDn;
      function yVt(u) {
        var o = u.get("type"), n3 = u.getModel(o + "Style"), p2;
        return o === "line" ? (p2 = n3.getLineStyle(), p2.fill = null) : o === "shadow" && (p2 = n3.getAreaStyle(), p2.stroke = null), p2;
      }
      function Bwe(u, o, n3, p2, m2) {
        var w2 = n3.get("value"), T2 = zwe(w2, o.axis, o.ecModel, n3.get("seriesDataIndices"), { precision: n3.get(["label", "precision"]), formatter: n3.get(["label", "formatter"]) }), E = n3.getModel("label"), O2 = $$(E.get("padding") || 0), V3 = E.getFont(), W3 = r4(T2, V3), q3 = m2.position, K = W3.width + O2[1] + O2[3], J = W3.height + O2[0] + O2[2], rt2 = m2.align;
        rt2 === "right" && (q3[0] -= K), rt2 === "center" && (q3[0] -= K / 2);
        var gt = m2.verticalAlign;
        gt === "bottom" && (q3[1] -= J), gt === "middle" && (q3[1] -= J / 2), ZDn(q3, K, J, p2);
        var yt = E.get("backgroundColor");
        (!yt || yt === "auto") && (yt = o.get(["axisLine", "lineStyle", "color"])), u.label = { x: q3[0], y: q3[1], style: Cy(E, { text: T2, font: V3, fill: E.getTextColor(), padding: O2, backgroundColor: yt }), z2: 10 };
      }
      function ZDn(u, o, n3, p2) {
        var m2 = p2.getWidth(), w2 = p2.getHeight();
        u[0] = Math.min(u[0] + o, m2) - o, u[1] = Math.min(u[1] + n3, w2) - n3, u[0] = Math.max(u[0], 0), u[1] = Math.max(u[1], 0);
      }
      function zwe(u, o, n3, p2, m2) {
        u = o.scale.parse(u);
        var w2 = o.scale.getLabel({ value: u }, { precision: m2.precision }), T2 = m2.formatter;
        if (T2) {
          var E = { value: c9t(o, { value: u }), axisDimension: o.dim, axisIndex: o.index, seriesData: [] };
          Xe2(p2, function(O2) {
            var V3 = n3.getSeriesByIndex(O2.seriesIndex), W3 = O2.dataIndexInside, q3 = V3 && V3.getDataParams(W3);
            q3 && E.seriesData.push(q3);
          }), ds(T2) ? w2 = T2.replace("{value}", w2) : Sl(T2) && (w2 = T2(E));
        }
        return w2;
      }
      function mVt(u, o, n3) {
        var p2 = yw();
        return t4(p2, p2, n3.rotation), QS(p2, p2, n3.position), dc2([u.dataToCoord(o), (n3.labelOffset || 0) + (n3.labelDirection || 1) * (n3.labelMargin || 0)], p2);
      }
      function jwe(u, o, n3, p2, m2, w2) {
        var T2 = D4.innerTextLayout(n3.rotation, 0, n3.labelDirection);
        n3.labelMargin = m2.get(["label", "margin"]), Bwe(o, p2, m2, w2, { position: mVt(p2.axis, u, n3), align: T2.textAlign, verticalAlign: T2.textVerticalAlign });
      }
      function bVt(u, o, n3) {
        return n3 = n3 || 0, { x1: u[n3], y1: u[1 - n3], x2: o[n3], y2: o[1 - n3] };
      }
      function Wwe(u, o, n3) {
        return n3 = n3 || 0, { x: u[n3], y: u[1 - n3], width: o[n3], height: o[1 - n3] };
      }
      function Gwe(u, o, n3, p2, m2, w2) {
        return { cx: u, cy: o, r0: n3, r: p2, startAngle: m2, endAngle: w2, clockwise: true };
      }
      var $Dn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.makeElOption = function(n3, p2, m2, w2, T2) {
          var E = m2.axis, O2 = E.grid, V3 = w2.get("type"), W3 = Hwe(O2, E).getOtherAxis(E).getGlobalExtent(), q3 = E.toGlobalCoord(E.dataToCoord(p2, true));
          if (V3 && V3 !== "none") {
            var K = yVt(w2), J = YDn[V3](E, q3, W3);
            J.style = K, n3.graphicKey = J.type, n3.pointer = J;
          }
          var rt2 = V9t(O2.model, m2);
          jwe(p2, n3, rt2, m2, w2, T2);
        }, o.prototype.getHandleTransform = function(n3, p2, m2) {
          var w2 = V9t(p2.axis.grid.model, p2, { labelInside: false });
          w2.labelMargin = m2.get(["handle", "margin"]);
          var T2 = mVt(p2.axis, n3, w2);
          return { x: T2[0], y: T2[1], rotation: w2.rotation + (w2.labelDirection < 0 ? Math.PI : 0) };
        }, o.prototype.updateHandleTransform = function(n3, p2, m2, w2) {
          var T2 = m2.axis, E = T2.grid, O2 = T2.getGlobalExtent(true), V3 = Hwe(E, T2).getOtherAxis(T2).getGlobalExtent(), W3 = T2.dim === "x" ? 0 : 1, q3 = [n3.x, n3.y];
          q3[W3] += p2[W3], q3[W3] = Math.min(O2[1], q3[W3]), q3[W3] = Math.max(O2[0], q3[W3]);
          var K = (V3[1] + V3[0]) / 2, J = [K, K];
          J[W3] = q3[W3];
          var rt2 = [{ verticalAlign: "middle" }, { align: "center" }];
          return { x: q3[0], y: q3[1], rotation: n3.rotation, cursorPoint: J, tooltipOption: rt2[W3] };
        }, o;
      }(vVt);
      function Hwe(u, o) {
        var n3 = {};
        return n3[o.dim + "AxisIndex"] = o.index, u.getCartesian(n3);
      }
      var YDn = { line: function(u, o, n3) {
        var p2 = bVt([o, n3[0]], [o, n3[1]], Uwe(u));
        return { type: "Line", subPixelOptimize: true, shape: p2 };
      }, shadow: function(u, o, n3) {
        var p2 = Math.max(1, u.getBandWidth()), m2 = n3[1] - n3[0];
        return { type: "Rect", shape: Wwe([o - p2 / 2, n3[0]], [p2, m2], Uwe(u)) };
      } };
      function Uwe(u) {
        return u.dim === "x" ? 0 : 1;
      }
      var KDn = $Dn, XDn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "axisPointer", o.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, o;
      }(kh2), QDn = XDn, O4 = Ff2(), JDn = Xe2;
      function qwe(u, o, n3) {
        if (!Ys.node) {
          var p2 = o.getZr();
          O4(p2).records || (O4(p2).records = {}), tEn(p2, o);
          var m2 = O4(p2).records[u] || (O4(p2).records[u] = {});
          m2.handler = n3;
        }
      }
      function tEn(u, o) {
        if (O4(u).initialized)
          return;
        O4(u).initialized = true, n3("click", wu(Zwe, "click")), n3("mousemove", wu(Zwe, "mousemove")), n3("globalout", nEn);
        function n3(p2, m2) {
          u.on(p2, function(w2) {
            var T2 = rEn(o);
            JDn(O4(u).records, function(E) {
              E && m2(E, w2, T2.dispatchAction);
            }), eEn(T2.pendings, o);
          });
        }
      }
      function eEn(u, o) {
        var n3 = u.showTip.length, p2 = u.hideTip.length, m2;
        n3 ? m2 = u.showTip[n3 - 1] : p2 && (m2 = u.hideTip[p2 - 1]), m2 && (m2.dispatchAction = null, o.dispatchAction(m2));
      }
      function nEn(u, o, n3) {
        u.handler("leave", null, n3);
      }
      function Zwe(u, o, n3, p2) {
        o.handler(u, n3, p2);
      }
      function rEn(u) {
        var o = { showTip: [], hideTip: [] }, n3 = function(p2) {
          var m2 = o[p2.type];
          m2 ? m2.push(p2) : (p2.dispatchAction = n3, u.dispatchAction(p2));
        };
        return { dispatchAction: n3, pendings: o };
      }
      function _Vt(u, o) {
        if (!Ys.node) {
          var n3 = o.getZr(), p2 = (O4(n3).records || {})[u];
          p2 && (O4(n3).records[u] = null);
        }
      }
      var iEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = p2.getComponent("tooltip"), T2 = n3.get("triggerOn") || w2 && w2.get("triggerOn") || "mousemove|click";
          qwe("axisPointer", m2, function(E, O2, V3) {
            T2 !== "none" && (E === "leave" || T2.indexOf(E) >= 0) && V3({ type: "updateAxisPointer", currTrigger: E, x: O2 && O2.offsetX, y: O2 && O2.offsetY });
          });
        }, o.prototype.remove = function(n3, p2) {
          _Vt("axisPointer", p2);
        }, o.prototype.dispose = function(n3, p2) {
          _Vt("axisPointer", p2);
        }, o.type = "axisPointer", o;
      }(C0), aEn = iEn;
      function $we(u, o) {
        var n3 = [], p2 = u.seriesIndex, m2;
        if (p2 == null || !(m2 = o.getSeriesByIndex(p2)))
          return { point: [] };
        var w2 = m2.getData(), T2 = AC(w2, u);
        if (T2 == null || T2 < 0 || za2(T2))
          return { point: [] };
        var E = w2.getItemGraphicEl(T2), O2 = m2.coordinateSystem;
        if (m2.getTooltipPosition)
          n3 = m2.getTooltipPosition(T2) || [];
        else if (O2 && O2.dataToPoint)
          if (u.isStacked) {
            var V3 = O2.getBaseAxis(), W3 = O2.getOtherAxis(V3), q3 = W3.dim, K = V3.dim, J = q3 === "x" || q3 === "radius" ? 1 : 0, rt2 = w2.mapDimension(K), gt = [];
            gt[J] = w2.get(rt2, T2), gt[1 - J] = w2.get(w2.getCalculationInfo("stackResultDimension"), T2), n3 = O2.dataToPoint(gt) || [];
          } else
            n3 = O2.dataToPoint(w2.getValues(Ya2(O2.dimensions, function(At) {
              return w2.mapDimension(At);
            }), T2)) || [];
        else if (E) {
          var yt = E.getBoundingRect().clone();
          yt.applyTransform(E.transform), n3 = [yt.x + yt.width / 2, yt.y + yt.height / 2];
        }
        return { point: n3, el: E };
      }
      var Ywe = Ff2();
      function oEn(u, o, n3) {
        var p2 = u.currTrigger, m2 = [u.x, u.y], w2 = u, T2 = u.dispatchAction || Is(n3.dispatchAction, n3), E = o.getComponent("axisPointer").coordSysAxesInfo;
        if (E) {
          rwt(m2) && (m2 = $we({ seriesIndex: w2.seriesIndex, dataIndex: w2.dataIndex }, o).point);
          var O2 = rwt(m2), V3 = w2.axesInfo, W3 = E.axesInfo, q3 = p2 === "leave" || rwt(m2), K = {}, J = {}, rt2 = { list: [], map: {} }, gt = { showPointer: wu(lEn, J), showTooltip: wu(uEn, rt2) };
          Xe2(E.coordSysMap, function(At, Lt) {
            var Wt = O2 || At.containPoint(m2);
            Xe2(E.coordSysAxesInfo[Lt], function(Nt, ue2) {
              var ie2 = Nt.axis, pe2 = pEn(V3, Nt);
              if (!q3 && Wt && (!V3 || pe2)) {
                var xe = pe2 && pe2.value;
                xe == null && !O2 && (xe = ie2.pointToData(m2)), xe != null && Kwe(Nt, xe, gt, false, K);
              }
            });
          });
          var yt = {};
          return Xe2(W3, function(At, Lt) {
            var Wt = At.linkGroup;
            Wt && !J[Lt] && Xe2(Wt.axesInfo, function(Nt, ue2) {
              var ie2 = J[ue2];
              if (Nt !== At && ie2) {
                var pe2 = ie2.value;
                Wt.mapper && (pe2 = At.axis.scale.parse(Wt.mapper(pe2, Xwe(Nt), Xwe(At)))), yt[At.key] = pe2;
              }
            });
          }), Xe2(yt, function(At, Lt) {
            Kwe(W3[Lt], At, gt, true, K);
          }), cEn(J, W3, K), fEn(rt2, m2, u, T2), hEn(W3, T2, n3), K;
        }
      }
      function Kwe(u, o, n3, p2, m2) {
        var w2 = u.axis;
        if (!(w2.scale.isBlank() || !w2.containData(o))) {
          if (!u.involveSeries) {
            n3.showPointer(u, o);
            return;
          }
          var T2 = sEn(o, u), E = T2.payloadBatch, O2 = T2.snapToValue;
          E[0] && m2.seriesIndex == null && ua2(m2, E[0]), !p2 && u.snap && w2.containData(O2) && O2 != null && (o = O2), n3.showPointer(u, o, E), n3.showTooltip(u, T2, O2);
        }
      }
      function sEn(u, o) {
        var n3 = o.axis, p2 = n3.dim, m2 = u, w2 = [], T2 = Number.MAX_VALUE, E = -1;
        return Xe2(o.seriesModels, function(O2, V3) {
          var W3 = O2.getData().mapDimensionsAll(p2), q3, K;
          if (O2.getAxisTooltipData) {
            var J = O2.getAxisTooltipData(W3, u, n3);
            K = J.dataIndices, q3 = J.nestestValue;
          } else {
            if (K = O2.getData().indicesOfNearest(W3[0], u, n3.type === "category" ? 0.5 : null), !K.length)
              return;
            q3 = O2.getData().get(W3[0], K[0]);
          }
          if (!(q3 == null || !isFinite(q3))) {
            var rt2 = u - q3, gt = Math.abs(rt2);
            gt <= T2 && ((gt < T2 || rt2 >= 0 && E < 0) && (T2 = gt, E = rt2, m2 = q3, w2.length = 0), Xe2(K, function(yt) {
              w2.push({ seriesIndex: O2.seriesIndex, dataIndexInside: yt, dataIndex: O2.getData().getRawIndex(yt) });
            }));
          }
        }), { payloadBatch: w2, snapToValue: m2 };
      }
      function lEn(u, o, n3, p2) {
        u[o.key] = { value: n3, payloadBatch: p2 };
      }
      function uEn(u, o, n3, p2) {
        var m2 = n3.payloadBatch, w2 = o.axis, T2 = w2.model, E = o.axisPointerModel;
        if (!(!o.triggerTooltip || !m2.length)) {
          var O2 = o.coordSys.model, V3 = sst(O2), W3 = u.map[V3];
          W3 || (W3 = u.map[V3] = { coordSysId: O2.id, coordSysIndex: O2.componentIndex, coordSysType: O2.type, coordSysMainType: O2.mainType, dataByAxis: [] }, u.list.push(W3)), W3.dataByAxis.push({ axisDim: w2.dim, axisIndex: T2.componentIndex, axisType: T2.type, axisId: T2.id, value: p2, valueLabelOpt: { precision: E.get(["label", "precision"]), formatter: E.get(["label", "formatter"]) }, seriesDataIndices: m2.slice() });
        }
      }
      function cEn(u, o, n3) {
        var p2 = n3.axesInfo = [];
        Xe2(o, function(m2, w2) {
          var T2 = m2.axisPointerModel.option, E = u[w2];
          E ? (!m2.useHandle && (T2.status = "show"), T2.value = E.value, T2.seriesDataIndices = (E.payloadBatch || []).slice()) : !m2.useHandle && (T2.status = "hide"), T2.status === "show" && p2.push({ axisDim: m2.axis.dim, axisIndex: m2.axis.model.componentIndex, value: T2.value });
        });
      }
      function fEn(u, o, n3, p2) {
        if (rwt(o) || !u.list.length) {
          p2({ type: "hideTip" });
          return;
        }
        var m2 = ((u.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
        p2({ type: "showTip", escapeConnect: true, x: o[0], y: o[1], tooltipOption: n3.tooltipOption, position: n3.position, dataIndexInside: m2.dataIndexInside, dataIndex: m2.dataIndex, seriesIndex: m2.seriesIndex, dataByCoordSys: u.list });
      }
      function hEn(u, o, n3) {
        var p2 = n3.getZr(), m2 = "axisPointerLastHighlights", w2 = Ywe(p2)[m2] || {}, T2 = Ywe(p2)[m2] = {};
        Xe2(u, function(V3, W3) {
          var q3 = V3.axisPointerModel.option;
          q3.status === "show" && Xe2(q3.seriesDataIndices, function(K) {
            var J = K.seriesIndex + " | " + K.dataIndex;
            T2[J] = K;
          });
        });
        var E = [], O2 = [];
        Xe2(w2, function(V3, W3) {
          !T2[W3] && O2.push(V3);
        }), Xe2(T2, function(V3, W3) {
          !w2[W3] && E.push(V3);
        }), O2.length && n3.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: O2 }), E.length && n3.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: E });
      }
      function pEn(u, o) {
        for (var n3 = 0; n3 < (u || []).length; n3++) {
          var p2 = u[n3];
          if (o.axis.dim === p2.axisDim && o.axis.model.componentIndex === p2.axisIndex)
            return p2;
        }
      }
      function Xwe(u) {
        var o = u.axis.model, n3 = {}, p2 = n3.axisDim = u.axis.dim;
        return n3.axisIndex = n3[p2 + "AxisIndex"] = o.componentIndex, n3.axisName = n3[p2 + "AxisName"] = o.name, n3.axisId = n3[p2 + "AxisId"] = o.id, n3;
      }
      function rwt(u) {
        return !u || u[0] == null || isNaN(u[0]) || u[1] == null || isNaN(u[1]);
      }
      function Cst(u) {
        Uz.registerAxisPointerClass("CartesianAxisPointer", KDn), u.registerComponentModel(QDn), u.registerComponentView(aEn), u.registerPreprocessor(function(o) {
          if (o) {
            (!o.axisPointer || o.axisPointer.length === 0) && (o.axisPointer = {});
            var n3 = o.axisPointer.link;
            n3 && !za2(n3) && (o.axisPointer.link = [n3]);
          }
        }), u.registerProcessor(u.PRIORITY.PROCESSOR.STATISTIC, function(o, n3) {
          o.getComponent("axisPointer").coordSysAxesInfo = eSn(o, n3);
        }), u.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, oEn);
      }
      function dEn(u) {
        Rc2(Cbe), Rc2(Cst);
      }
      var gEn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.makeElOption = function(n3, p2, m2, w2, T2) {
          var E = m2.axis;
          E.dim === "angle" && (this.animationThreshold = Math.PI / 18);
          var O2 = E.polar, V3 = O2.getOtherAxis(E), W3 = V3.getExtent(), q3 = E.dataToCoord(p2), K = w2.get("type");
          if (K && K !== "none") {
            var J = yVt(w2), rt2 = yEn[K](E, O2, q3, W3);
            rt2.style = J, n3.graphicKey = rt2.type, n3.pointer = rt2;
          }
          var gt = w2.get(["label", "margin"]), yt = vEn(p2, m2, w2, O2, gt);
          Bwe(n3, m2, w2, T2, yt);
        }, o;
      }(vVt);
      function vEn(u, o, n3, p2, m2) {
        var w2 = o.axis, T2 = w2.dataToCoord(u), E = p2.getAngleAxis().getExtent()[0];
        E = E / 180 * Math.PI;
        var O2 = p2.getRadiusAxis().getExtent(), V3, W3, q3;
        if (w2.dim === "radius") {
          var K = yw();
          t4(K, K, E), QS(K, K, [p2.cx, p2.cy]), V3 = dc2([T2, -m2], K);
          var J = o.getModel("axisLabel").get("rotate") || 0, rt2 = D4.innerTextLayout(E, J * Math.PI / 180, -1);
          W3 = rt2.textAlign, q3 = rt2.textVerticalAlign;
        } else {
          var gt = O2[1];
          V3 = p2.coordToPoint([gt + m2, T2]);
          var yt = p2.cx, At = p2.cy;
          W3 = Math.abs(V3[0] - yt) / gt < 0.3 ? "center" : V3[0] > yt ? "left" : "right", q3 = Math.abs(V3[1] - At) / gt < 0.3 ? "middle" : V3[1] > At ? "top" : "bottom";
        }
        return { position: V3, align: W3, verticalAlign: q3 };
      }
      var yEn = { line: function(u, o, n3, p2) {
        return u.dim === "angle" ? { type: "Line", shape: bVt(o.coordToPoint([p2[0], n3]), o.coordToPoint([p2[1], n3])) } : { type: "Circle", shape: { cx: o.cx, cy: o.cy, r: n3 } };
      }, shadow: function(u, o, n3, p2) {
        var m2 = Math.max(1, u.getBandWidth()), w2 = Math.PI / 180;
        return u.dim === "angle" ? { type: "Sector", shape: Gwe(o.cx, o.cy, p2[0], p2[1], (-n3 - m2 / 2) * w2, (-n3 + m2 / 2) * w2) } : { type: "Sector", shape: Gwe(o.cx, o.cy, n3 - m2 / 2, n3 + m2 / 2, 0, Math.PI * 2) };
      } }, mEn = gEn, bEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.findAxisModel = function(n3) {
          var p2, m2 = this.ecModel;
          return m2.eachComponent(n3, function(w2) {
            w2.getCoordSysModel() === this && (p2 = w2);
          }, this), p2;
        }, o.type = "polar", o.dependencies = ["radiusAxis", "angleAxis"], o.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, o;
      }(kh2), _En = bEn, xVt = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.getCoordSysModel = function() {
          return this.getReferringComponents("polar", Y0).models[0];
        }, o.type = "polarAxis", o;
      }(kh2);
      x0(xVt, Yot);
      var xEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "angleAxis", o;
      }(xVt), wEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "radiusAxis", o;
      }(xVt), wVt = function(u) {
        tr(o, u);
        function o(n3, p2) {
          return u.call(this, "radius", n3, p2) || this;
        }
        return o.prototype.pointToData = function(n3, p2) {
          return this.polar.pointToData(n3, p2)[this.dim === "radius" ? 0 : 1];
        }, o;
      }(ak2);
      wVt.prototype.dataToRadius = ak2.prototype.dataToCoord, wVt.prototype.radiusToData = ak2.prototype.coordToData;
      var SEn = wVt, MEn = Ff2(), SVt = function(u) {
        tr(o, u);
        function o(n3, p2) {
          return u.call(this, "angle", n3, p2 || [0, 360]) || this;
        }
        return o.prototype.pointToData = function(n3, p2) {
          return this.polar.pointToData(n3, p2)[this.dim === "radius" ? 0 : 1];
        }, o.prototype.calculateCategoryInterval = function() {
          var n3 = this, p2 = n3.getLabelModel(), m2 = n3.scale, w2 = m2.getExtent(), T2 = m2.count();
          if (w2[1] - w2[0] < 1)
            return 0;
          var E = w2[0], O2 = n3.dataToCoord(E + 1) - n3.dataToCoord(E), V3 = Math.abs(O2), W3 = r4(E == null ? "" : E + "", p2.getFont(), "center", "top"), q3 = Math.max(W3.height, 7), K = q3 / V3;
          isNaN(K) && (K = 1 / 0);
          var J = Math.max(0, Math.floor(K)), rt2 = MEn(n3.model), gt = rt2.lastAutoInterval, yt = rt2.lastTickCount;
          return gt != null && yt != null && Math.abs(gt - J) <= 1 && Math.abs(yt - T2) <= 1 && gt > J ? J = gt : (rt2.lastTickCount = T2, rt2.lastAutoInterval = J), J;
        }, o;
      }(ak2);
      SVt.prototype.dataToAngle = ak2.prototype.dataToCoord, SVt.prototype.angleToData = ak2.prototype.coordToData;
      var CEn = SVt, Qwe = ["radius", "angle"], TEn = function() {
        function u(o) {
          this.dimensions = Qwe, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new SEn(), this._angleAxis = new CEn(), this.axisPointerEnabled = true, this.name = o || "", this._radiusAxis.polar = this._angleAxis.polar = this;
        }
        return u.prototype.containPoint = function(o) {
          var n3 = this.pointToCoord(o);
          return this._radiusAxis.contain(n3[0]) && this._angleAxis.contain(n3[1]);
        }, u.prototype.containData = function(o) {
          return this._radiusAxis.containData(o[0]) && this._angleAxis.containData(o[1]);
        }, u.prototype.getAxis = function(o) {
          var n3 = "_" + o + "Axis";
          return this[n3];
        }, u.prototype.getAxes = function() {
          return [this._radiusAxis, this._angleAxis];
        }, u.prototype.getAxesByScale = function(o) {
          var n3 = [], p2 = this._angleAxis, m2 = this._radiusAxis;
          return p2.scale.type === o && n3.push(p2), m2.scale.type === o && n3.push(m2), n3;
        }, u.prototype.getAngleAxis = function() {
          return this._angleAxis;
        }, u.prototype.getRadiusAxis = function() {
          return this._radiusAxis;
        }, u.prototype.getOtherAxis = function(o) {
          var n3 = this._angleAxis;
          return o === n3 ? this._radiusAxis : n3;
        }, u.prototype.getBaseAxis = function() {
          return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
        }, u.prototype.getTooltipAxes = function(o) {
          var n3 = o != null && o !== "auto" ? this.getAxis(o) : this.getBaseAxis();
          return { baseAxes: [n3], otherAxes: [this.getOtherAxis(n3)] };
        }, u.prototype.dataToPoint = function(o, n3) {
          return this.coordToPoint([this._radiusAxis.dataToRadius(o[0], n3), this._angleAxis.dataToAngle(o[1], n3)]);
        }, u.prototype.pointToData = function(o, n3) {
          var p2 = this.pointToCoord(o);
          return [this._radiusAxis.radiusToData(p2[0], n3), this._angleAxis.angleToData(p2[1], n3)];
        }, u.prototype.pointToCoord = function(o) {
          var n3 = o[0] - this.cx, p2 = o[1] - this.cy, m2 = this.getAngleAxis(), w2 = m2.getExtent(), T2 = Math.min(w2[0], w2[1]), E = Math.max(w2[0], w2[1]);
          m2.inverse ? T2 = E - 360 : E = T2 + 360;
          var O2 = Math.sqrt(n3 * n3 + p2 * p2);
          n3 /= O2, p2 /= O2;
          for (var V3 = Math.atan2(-p2, n3) / Math.PI * 180, W3 = V3 < T2 ? 1 : -1; V3 < T2 || V3 > E; )
            V3 += W3 * 360;
          return [O2, V3];
        }, u.prototype.coordToPoint = function(o) {
          var n3 = o[0], p2 = o[1] / 180 * Math.PI, m2 = Math.cos(p2) * n3 + this.cx, w2 = -Math.sin(p2) * n3 + this.cy;
          return [m2, w2];
        }, u.prototype.getArea = function() {
          var o = this.getAngleAxis(), n3 = this.getRadiusAxis(), p2 = n3.getExtent().slice();
          p2[0] > p2[1] && p2.reverse();
          var m2 = o.getExtent(), w2 = Math.PI / 180;
          return { cx: this.cx, cy: this.cy, r0: p2[0], r: p2[1], startAngle: -m2[0] * w2, endAngle: -m2[1] * w2, clockwise: o.inverse, contain: function(T2, E) {
            var O2 = T2 - this.cx, V3 = E - this.cy, W3 = O2 * O2 + V3 * V3 - 1e-4, q3 = this.r, K = this.r0;
            return W3 <= q3 * q3 && W3 >= K * K;
          } };
        }, u.prototype.convertToPixel = function(o, n3, p2) {
          var m2 = Jwe(n3);
          return m2 === this ? this.dataToPoint(p2) : null;
        }, u.prototype.convertFromPixel = function(o, n3, p2) {
          var m2 = Jwe(n3);
          return m2 === this ? this.pointToData(p2) : null;
        }, u;
      }();
      function Jwe(u) {
        var o = u.seriesModel, n3 = u.polarModel;
        return n3 && n3.coordinateSystem || o && o.coordinateSystem;
      }
      var AEn = TEn;
      function IEn(u, o, n3) {
        var p2 = o.get("center"), m2 = n3.getWidth(), w2 = n3.getHeight();
        u.cx = Qo(p2[0], m2), u.cy = Qo(p2[1], w2);
        var T2 = u.getRadiusAxis(), E = Math.min(m2, w2) / 2, O2 = o.get("radius");
        O2 == null ? O2 = [0, "100%"] : za2(O2) || (O2 = [0, O2]);
        var V3 = [Qo(O2[0], E), Qo(O2[1], E)];
        T2.inverse ? T2.setExtent(V3[1], V3[0]) : T2.setExtent(V3[0], V3[1]);
      }
      function DEn(u, o) {
        var n3 = this, p2 = n3.getAngleAxis(), m2 = n3.getRadiusAxis();
        if (p2.scale.setExtent(1 / 0, -1 / 0), m2.scale.setExtent(1 / 0, -1 / 0), u.eachSeries(function(E) {
          if (E.coordinateSystem === n3) {
            var O2 = E.getData();
            Xe2(yxt(O2, "radius"), function(V3) {
              m2.scale.unionExtentFromData(O2, V3);
            }), Xe2(yxt(O2, "angle"), function(V3) {
              p2.scale.unionExtentFromData(O2, V3);
            });
          }
        }), uY(p2.scale, p2.model), uY(m2.scale, m2.model), p2.type === "category" && !p2.onBand) {
          var w2 = p2.getExtent(), T2 = 360 / p2.scale.count();
          p2.inverse ? w2[1] += T2 : w2[1] -= T2, p2.setExtent(w2[0], w2[1]);
        }
      }
      function EEn(u) {
        return u.mainType === "angleAxis";
      }
      function tSe(u, o) {
        if (u.type = o.get("type"), u.scale = vxt(o), u.onBand = o.get("boundaryGap") && u.type === "category", u.inverse = o.get("inverse"), EEn(o)) {
          u.inverse = u.inverse !== o.get("clockwise");
          var n3 = o.get("startAngle");
          u.setExtent(n3, n3 + (u.inverse ? -360 : 360));
        }
        o.axis = u, u.model = o;
      }
      var kEn = { dimensions: Qwe, create: function(u, o) {
        var n3 = [];
        return u.eachComponent("polar", function(p2, m2) {
          var w2 = new AEn(m2 + "");
          w2.update = DEn;
          var T2 = w2.getRadiusAxis(), E = w2.getAngleAxis(), O2 = p2.findAxisModel("radiusAxis"), V3 = p2.findAxisModel("angleAxis");
          tSe(T2, O2), tSe(E, V3), IEn(w2, p2, o), n3.push(w2), p2.coordinateSystem = w2, w2.model = p2;
        }), u.eachSeries(function(p2) {
          if (p2.get("coordinateSystem") === "polar") {
            var m2 = p2.getReferringComponents("polar", Y0).models[0];
            p2.coordinateSystem = m2.coordinateSystem;
          }
        }), n3;
      } }, PEn = kEn, LEn = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
      function iwt(u, o, n3) {
        o[1] > o[0] && (o = o.slice().reverse());
        var p2 = u.coordToPoint([o[0], n3]), m2 = u.coordToPoint([o[1], n3]);
        return { x1: p2[0], y1: p2[1], x2: m2[0], y2: m2[1] };
      }
      function awt(u) {
        var o = u.getRadiusAxis();
        return o.inverse ? 0 : 1;
      }
      function eSe(u) {
        var o = u[0], n3 = u[u.length - 1];
        o && n3 && Math.abs(Math.abs(o.coord - n3.coord) - 360) < 1e-4 && u.pop();
      }
      var OEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.axisPointerClass = "PolarAxisPointer", n3;
        }
        return o.prototype.render = function(n3, p2) {
          if (this.group.removeAll(), !!n3.get("show")) {
            var m2 = n3.axis, w2 = m2.polar, T2 = w2.getRadiusAxis().getExtent(), E = m2.getTicksCoords(), O2 = m2.getMinorTicksCoords(), V3 = Ya2(m2.getViewLabels(), function(W3) {
              W3 = jl(W3);
              var q3 = m2.scale, K = q3.type === "ordinal" ? q3.getRawOrdinalNumber(W3.tickValue) : W3.tickValue;
              return W3.coord = m2.dataToCoord(K), W3;
            });
            eSe(V3), eSe(E), Xe2(LEn, function(W3) {
              n3.get([W3, "show"]) && (!m2.scale.isBlank() || W3 === "axisLine") && REn[W3](this.group, n3, w2, E, O2, T2, V3);
            }, this);
          }
        }, o.type = "angleAxis", o;
      }(Uz), REn = { axisLine: function(u, o, n3, p2, m2, w2) {
        var T2 = o.getModel(["axisLine", "lineStyle"]), E = awt(n3), O2 = E ? 0 : 1, V3;
        w2[O2] === 0 ? V3 = new sI({ shape: { cx: n3.cx, cy: n3.cy, r: w2[E] }, style: T2.getLineStyle(), z2: 1, silent: true }) : V3 = new L$({ shape: { cx: n3.cx, cy: n3.cy, r: w2[E], r0: w2[O2] }, style: T2.getLineStyle(), z2: 1, silent: true }), V3.style.fill = null, u.add(V3);
      }, axisTick: function(u, o, n3, p2, m2, w2) {
        var T2 = o.getModel("axisTick"), E = (T2.get("inside") ? -1 : 1) * T2.get("length"), O2 = w2[awt(n3)], V3 = Ya2(p2, function(W3) {
          return new My({ shape: iwt(n3, [O2, O2 + E], W3.coord) });
        });
        u.add(eo(V3, { style: kl(T2.getModel("lineStyle").getLineStyle(), { stroke: o.get(["axisLine", "lineStyle", "color"]) }) }));
      }, minorTick: function(u, o, n3, p2, m2, w2) {
        if (m2.length) {
          for (var T2 = o.getModel("axisTick"), E = o.getModel("minorTick"), O2 = (T2.get("inside") ? -1 : 1) * E.get("length"), V3 = w2[awt(n3)], W3 = [], q3 = 0; q3 < m2.length; q3++)
            for (var K = 0; K < m2[q3].length; K++)
              W3.push(new My({ shape: iwt(n3, [V3, V3 + O2], m2[q3][K].coord) }));
          u.add(eo(W3, { style: kl(E.getModel("lineStyle").getLineStyle(), kl(T2.getLineStyle(), { stroke: o.get(["axisLine", "lineStyle", "color"]) })) }));
        }
      }, axisLabel: function(u, o, n3, p2, m2, w2, T2) {
        var E = o.getCategories(true), O2 = o.getModel("axisLabel"), V3 = O2.get("margin"), W3 = o.get("triggerEvent");
        Xe2(T2, function(q3, K) {
          var J = O2, rt2 = q3.tickValue, gt = w2[awt(n3)], yt = n3.coordToPoint([gt + V3, q3.coord]), At = n3.cx, Lt = n3.cy, Wt = Math.abs(yt[0] - At) / gt < 0.3 ? "center" : yt[0] > At ? "left" : "right", Nt = Math.abs(yt[1] - Lt) / gt < 0.3 ? "middle" : yt[1] > Lt ? "top" : "bottom";
          if (E && E[rt2]) {
            var ue2 = E[rt2];
            ys(ue2) && ue2.textStyle && (J = new _g(ue2.textStyle, O2, O2.ecModel));
          }
          var ie2 = new Zc2({ silent: D4.isLabelSilent(o), style: Cy(J, { x: yt[0], y: yt[1], fill: J.getTextColor() || o.get(["axisLine", "lineStyle", "color"]), text: q3.formattedLabel, align: Wt, verticalAlign: Nt }) });
          if (u.add(ie2), W3) {
            var pe2 = D4.makeAxisEventDataBase(o);
            pe2.targetType = "axisLabel", pe2.value = q3.rawLabel, is(ie2).eventData = pe2;
          }
        }, this);
      }, splitLine: function(u, o, n3, p2, m2, w2) {
        var T2 = o.getModel("splitLine"), E = T2.getModel("lineStyle"), O2 = E.get("color"), V3 = 0;
        O2 = O2 instanceof Array ? O2 : [O2];
        for (var W3 = [], q3 = 0; q3 < p2.length; q3++) {
          var K = V3++ % O2.length;
          W3[K] = W3[K] || [], W3[K].push(new My({ shape: iwt(n3, w2, p2[q3].coord) }));
        }
        for (var q3 = 0; q3 < W3.length; q3++)
          u.add(eo(W3[q3], { style: kl({ stroke: O2[q3 % O2.length] }, E.getLineStyle()), silent: true, z: o.get("z") }));
      }, minorSplitLine: function(u, o, n3, p2, m2, w2) {
        if (m2.length) {
          for (var T2 = o.getModel("minorSplitLine"), E = T2.getModel("lineStyle"), O2 = [], V3 = 0; V3 < m2.length; V3++)
            for (var W3 = 0; W3 < m2[V3].length; W3++)
              O2.push(new My({ shape: iwt(n3, w2, m2[V3][W3].coord) }));
          u.add(eo(O2, { style: E.getLineStyle(), silent: true, z: o.get("z") }));
        }
      }, splitArea: function(u, o, n3, p2, m2, w2) {
        if (p2.length) {
          var T2 = o.getModel("splitArea"), E = T2.getModel("areaStyle"), O2 = E.get("color"), V3 = 0;
          O2 = O2 instanceof Array ? O2 : [O2];
          for (var W3 = [], q3 = Math.PI / 180, K = -p2[0].coord * q3, J = Math.min(w2[0], w2[1]), rt2 = Math.max(w2[0], w2[1]), gt = o.get("clockwise"), yt = 1, At = p2.length; yt <= At; yt++) {
            var Lt = yt === At ? p2[0].coord : p2[yt].coord, Wt = V3++ % O2.length;
            W3[Wt] = W3[Wt] || [], W3[Wt].push(new ww({ shape: { cx: n3.cx, cy: n3.cy, r0: J, r: rt2, startAngle: K, endAngle: -Lt * q3, clockwise: gt }, silent: true })), K = -Lt * q3;
          }
          for (var yt = 0; yt < W3.length; yt++)
            u.add(eo(W3[yt], { style: kl({ fill: O2[yt % O2.length] }, E.getAreaStyle()), silent: true }));
        }
      } }, NEn = OEn, FEn = ["axisLine", "axisTickLabel", "axisName"], VEn = ["splitLine", "splitArea", "minorSplitLine"], BEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.axisPointerClass = "PolarAxisPointer", n3;
        }
        return o.prototype.render = function(n3, p2) {
          if (this.group.removeAll(), !!n3.get("show")) {
            var m2 = this._axisGroup, w2 = this._axisGroup = new uu();
            this.group.add(w2);
            var T2 = n3.axis, E = T2.polar, O2 = E.getAngleAxis(), V3 = T2.getTicksCoords(), W3 = T2.getMinorTicksCoords(), q3 = O2.getExtent()[0], K = T2.getExtent(), J = jEn(E, n3, q3), rt2 = new D4(n3, J);
            Xe2(FEn, rt2.add, rt2), w2.add(rt2.getGroup()), E1(m2, w2, n3), Xe2(VEn, function(gt) {
              n3.get([gt, "show"]) && !T2.scale.isBlank() && zEn[gt](this.group, n3, E, q3, K, V3, W3);
            }, this);
          }
        }, o.type = "radiusAxis", o;
      }(Uz), zEn = { splitLine: function(u, o, n3, p2, m2, w2) {
        var T2 = o.getModel("splitLine"), E = T2.getModel("lineStyle"), O2 = E.get("color"), V3 = 0;
        O2 = O2 instanceof Array ? O2 : [O2];
        for (var W3 = [], q3 = 0; q3 < w2.length; q3++) {
          var K = V3++ % O2.length;
          W3[K] = W3[K] || [], W3[K].push(new sI({ shape: { cx: n3.cx, cy: n3.cy, r: w2[q3].coord } }));
        }
        for (var q3 = 0; q3 < W3.length; q3++)
          u.add(eo(W3[q3], { style: kl({ stroke: O2[q3 % O2.length], fill: null }, E.getLineStyle()), silent: true }));
      }, minorSplitLine: function(u, o, n3, p2, m2, w2, T2) {
        if (T2.length) {
          for (var E = o.getModel("minorSplitLine"), O2 = E.getModel("lineStyle"), V3 = [], W3 = 0; W3 < T2.length; W3++)
            for (var q3 = 0; q3 < T2[W3].length; q3++)
              V3.push(new sI({ shape: { cx: n3.cx, cy: n3.cy, r: T2[W3][q3].coord } }));
          u.add(eo(V3, { style: kl({ fill: null }, O2.getLineStyle()), silent: true }));
        }
      }, splitArea: function(u, o, n3, p2, m2, w2) {
        if (w2.length) {
          var T2 = o.getModel("splitArea"), E = T2.getModel("areaStyle"), O2 = E.get("color"), V3 = 0;
          O2 = O2 instanceof Array ? O2 : [O2];
          for (var W3 = [], q3 = w2[0].coord, K = 1; K < w2.length; K++) {
            var J = V3++ % O2.length;
            W3[J] = W3[J] || [], W3[J].push(new ww({ shape: { cx: n3.cx, cy: n3.cy, r0: q3, r: w2[K].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), q3 = w2[K].coord;
          }
          for (var K = 0; K < W3.length; K++)
            u.add(eo(W3[K], { style: kl({ fill: O2[K % O2.length] }, E.getAreaStyle()), silent: true }));
        }
      } };
      function jEn(u, o, n3) {
        return { position: [u.cx, u.cy], rotation: n3 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: o.getModel("axisLabel").get("rotate"), z2: 1 };
      }
      var WEn = BEn;
      function nSe(u) {
        return u.get("stack") || "__ec_stack_" + u.seriesIndex;
      }
      function rSe(u, o) {
        return o.dim + u.model.componentIndex;
      }
      function GEn(u, o, n3) {
        var p2 = {}, m2 = HEn(Fp(o.getSeriesByType(u), function(w2) {
          return !o.isSeriesFiltered(w2) && w2.coordinateSystem && w2.coordinateSystem.type === "polar";
        }));
        o.eachSeriesByType(u, function(w2) {
          if (w2.coordinateSystem.type === "polar") {
            var T2 = w2.getData(), E = w2.coordinateSystem, O2 = E.getBaseAxis(), V3 = rSe(E, O2), W3 = nSe(w2), q3 = m2[V3][W3], K = q3.offset, J = q3.width, rt2 = E.getOtherAxis(O2), gt = w2.coordinateSystem.cx, yt = w2.coordinateSystem.cy, At = w2.get("barMinHeight") || 0, Lt = w2.get("barMinAngle") || 0;
            p2[W3] = p2[W3] || [];
            for (var Wt = T2.mapDimension(rt2.dim), Nt = T2.mapDimension(O2.dim), ue2 = c8(T2, Wt), ie2 = O2.dim !== "radius" || !w2.get("roundCap", true), pe2 = rt2.dataToCoord(0), xe = 0, Ce2 = T2.count(); xe < Ce2; xe++) {
              var Le2 = T2.get(Wt, xe), ze = T2.get(Nt, xe), tn = Le2 >= 0 ? "p" : "n", $e2 = pe2;
              ue2 && (p2[W3][ze] || (p2[W3][ze] = { p: pe2, n: pe2 }), $e2 = p2[W3][ze][tn]);
              var Tn = void 0, zn = void 0, bn = void 0, Xr = void 0;
              if (rt2.dim === "radius") {
                var Xn = rt2.dataToCoord(Le2) - pe2, or = O2.dataToCoord(ze);
                Math.abs(Xn) < At && (Xn = (Xn < 0 ? -1 : 1) * At), Tn = $e2, zn = $e2 + Xn, bn = or - K, Xr = bn - J, ue2 && (p2[W3][ze][tn] = zn);
              } else {
                var Tr = rt2.dataToCoord(Le2, ie2) - pe2, ci2 = O2.dataToCoord(ze);
                Math.abs(Tr) < Lt && (Tr = (Tr < 0 ? -1 : 1) * Lt), Tn = ci2 + K, zn = Tn + J, bn = $e2, Xr = $e2 + Tr, ue2 && (p2[W3][ze][tn] = Xr);
              }
              T2.setItemLayout(xe, { cx: gt, cy: yt, r0: Tn, r: zn, startAngle: -bn * Math.PI / 180, endAngle: -Xr * Math.PI / 180, clockwise: bn >= Xr });
            }
          }
        });
      }
      function HEn(u) {
        var o = {};
        Xe2(u, function(p2, m2) {
          var w2 = p2.getData(), T2 = p2.coordinateSystem, E = T2.getBaseAxis(), O2 = rSe(T2, E), V3 = E.getExtent(), W3 = E.type === "category" ? E.getBandWidth() : Math.abs(V3[1] - V3[0]) / w2.count(), q3 = o[O2] || { bandWidth: W3, remainedWidth: W3, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, K = q3.stacks;
          o[O2] = q3;
          var J = nSe(p2);
          K[J] || q3.autoWidthCount++, K[J] = K[J] || { width: 0, maxWidth: 0 };
          var rt2 = Qo(p2.get("barWidth"), W3), gt = Qo(p2.get("barMaxWidth"), W3), yt = p2.get("barGap"), At = p2.get("barCategoryGap");
          rt2 && !K[J].width && (rt2 = Math.min(q3.remainedWidth, rt2), K[J].width = rt2, q3.remainedWidth -= rt2), gt && (K[J].maxWidth = gt), yt != null && (q3.gap = yt), At != null && (q3.categoryGap = At);
        });
        var n3 = {};
        return Xe2(o, function(p2, m2) {
          n3[m2] = {};
          var w2 = p2.stacks, T2 = p2.bandWidth, E = Qo(p2.categoryGap, T2), O2 = Qo(p2.gap, 1), V3 = p2.remainedWidth, W3 = p2.autoWidthCount, q3 = (V3 - E) / (W3 + (W3 - 1) * O2);
          q3 = Math.max(q3, 0), Xe2(w2, function(gt, yt) {
            var At = gt.maxWidth;
            At && At < q3 && (At = Math.min(At, V3), gt.width && (At = Math.min(At, gt.width)), V3 -= At, gt.width = At, W3--);
          }), q3 = (V3 - E) / (W3 + (W3 - 1) * O2), q3 = Math.max(q3, 0);
          var K = 0, J;
          Xe2(w2, function(gt, yt) {
            gt.width || (gt.width = q3), J = gt, K += gt.width * (1 + O2);
          }), J && (K -= J.width * O2);
          var rt2 = -K / 2;
          Xe2(w2, function(gt, yt) {
            n3[m2][yt] = n3[m2][yt] || { offset: rt2, width: gt.width }, rt2 += gt.width * (1 + O2);
          });
        }), n3;
      }
      var UEn = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, qEn = { splitNumber: 5 }, ZEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "polar", o;
      }(C0);
      function $En(u) {
        Rc2(Cst), Uz.registerAxisPointerClass("PolarAxisPointer", mEn), u.registerCoordinateSystem("polar", PEn), u.registerComponentModel(_En), u.registerComponentView(ZEn), dY(u, "angle", xEn, UEn), dY(u, "radius", wEn, qEn), u.registerComponentView(NEn), u.registerComponentView(WEn), u.registerLayout(wu(GEn, "bar"));
      }
      function MVt(u, o) {
        o = o || {};
        var n3 = u.coordinateSystem, p2 = u.axis, m2 = {}, w2 = p2.position, T2 = p2.orient, E = n3.getRect(), O2 = [E.x, E.x + E.width, E.y, E.y + E.height], V3 = { horizontal: { top: O2[2], bottom: O2[3] }, vertical: { left: O2[0], right: O2[1] } };
        m2.position = [T2 === "vertical" ? V3.vertical[w2] : O2[0], T2 === "horizontal" ? V3.horizontal[w2] : O2[3]];
        var W3 = { horizontal: 0, vertical: 1 };
        m2.rotation = Math.PI / 2 * W3[T2];
        var q3 = { top: -1, bottom: 1, right: 1, left: -1 };
        m2.labelDirection = m2.tickDirection = m2.nameDirection = q3[w2], u.get(["axisTick", "inside"]) && (m2.tickDirection = -m2.tickDirection), $y(o.labelInside, u.get(["axisLabel", "inside"])) && (m2.labelDirection = -m2.labelDirection);
        var K = o.rotate;
        return K == null && (K = u.get(["axisLabel", "rotate"])), m2.labelRotation = w2 === "top" ? -K : K, m2.z2 = 1, m2;
      }
      var YEn = ["axisLine", "axisTickLabel", "axisName"], KEn = ["splitArea", "splitLine"], XEn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.axisPointerClass = "SingleAxisPointer", n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          var T2 = this.group;
          T2.removeAll();
          var E = this._axisGroup;
          this._axisGroup = new uu();
          var O2 = MVt(n3), V3 = new D4(n3, O2);
          Xe2(YEn, V3.add, V3), T2.add(this._axisGroup), T2.add(V3.getGroup()), Xe2(KEn, function(W3) {
            n3.get([W3, "show"]) && QEn[W3](this, this.group, this._axisGroup, n3);
          }, this), E1(E, this._axisGroup, n3), u.prototype.render.call(this, n3, p2, m2, w2);
        }, o.prototype.remove = function() {
          xbe(this);
        }, o.type = "singleAxis", o;
      }(Uz), QEn = { splitLine: function(u, o, n3, p2) {
        var m2 = p2.axis;
        if (!m2.scale.isBlank()) {
          var w2 = p2.getModel("splitLine"), T2 = w2.getModel("lineStyle"), E = T2.get("color");
          E = E instanceof Array ? E : [E];
          for (var O2 = p2.coordinateSystem.getRect(), V3 = m2.isHorizontal(), W3 = [], q3 = 0, K = m2.getTicksCoords({ tickModel: w2 }), J = [], rt2 = [], gt = 0; gt < K.length; ++gt) {
            var yt = m2.toGlobalCoord(K[gt].coord);
            V3 ? (J[0] = yt, J[1] = O2.y, rt2[0] = yt, rt2[1] = O2.y + O2.height) : (J[0] = O2.x, J[1] = yt, rt2[0] = O2.x + O2.width, rt2[1] = yt);
            var At = q3++ % E.length;
            W3[At] = W3[At] || [], W3[At].push(new My({ subPixelOptimize: true, shape: { x1: J[0], y1: J[1], x2: rt2[0], y2: rt2[1] }, silent: true }));
          }
          for (var Lt = T2.getLineStyle(["color"]), gt = 0; gt < W3.length; ++gt)
            o.add(eo(W3[gt], { style: kl({ stroke: E[gt % E.length] }, Lt), silent: true }));
        }
      }, splitArea: function(u, o, n3, p2) {
        _be(u, n3, p2, p2);
      } }, JEn = XEn, iSe = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.getCoordSysModel = function() {
          return this;
        }, o.type = "singleAxis", o.layoutMode = "box", o.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, o;
      }(kh2);
      x0(iSe, Yot.prototype);
      var CVt = iSe, tkn = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2, T2) {
          var E = u.call(this, n3, p2, m2) || this;
          return E.type = w2 || "value", E.position = T2 || "bottom", E;
        }
        return o.prototype.isHorizontal = function() {
          var n3 = this.position;
          return n3 === "top" || n3 === "bottom";
        }, o.prototype.pointToData = function(n3, p2) {
          return this.coordinateSystem.pointToData(n3)[0];
        }, o;
      }(ak2), ekn = tkn, aSe = ["single"], nkn = function() {
        function u(o, n3, p2) {
          this.type = "single", this.dimension = "single", this.dimensions = aSe, this.axisPointerEnabled = true, this.model = o, this._init(o, n3, p2);
        }
        return u.prototype._init = function(o, n3, p2) {
          var m2 = this.dimension, w2 = new ekn(m2, vxt(o), [0, 0], o.get("type"), o.get("position")), T2 = w2.type === "category";
          w2.onBand = T2 && o.get("boundaryGap"), w2.inverse = o.get("inverse"), w2.orient = o.get("orient"), o.axis = w2, w2.model = o, w2.coordinateSystem = this, this._axis = w2;
        }, u.prototype.update = function(o, n3) {
          o.eachSeries(function(p2) {
            if (p2.coordinateSystem === this) {
              var m2 = p2.getData();
              Xe2(m2.mapDimensionsAll(this.dimension), function(w2) {
                this._axis.scale.unionExtentFromData(m2, w2);
              }, this), uY(this._axis.scale, this._axis.model);
            }
          }, this);
        }, u.prototype.resize = function(o, n3) {
          this._rect = Bm({ left: o.get("left"), top: o.get("top"), right: o.get("right"), bottom: o.get("bottom"), width: o.get("width"), height: o.get("height") }, { width: n3.getWidth(), height: n3.getHeight() }), this._adjustAxis();
        }, u.prototype.getRect = function() {
          return this._rect;
        }, u.prototype._adjustAxis = function() {
          var o = this._rect, n3 = this._axis, p2 = n3.isHorizontal(), m2 = p2 ? [0, o.width] : [0, o.height], w2 = n3.reverse ? 1 : 0;
          n3.setExtent(m2[w2], m2[1 - w2]), this._updateAxisTransform(n3, p2 ? o.x : o.y);
        }, u.prototype._updateAxisTransform = function(o, n3) {
          var p2 = o.getExtent(), m2 = p2[0] + p2[1], w2 = o.isHorizontal();
          o.toGlobalCoord = w2 ? function(T2) {
            return T2 + n3;
          } : function(T2) {
            return m2 - T2 + n3;
          }, o.toLocalCoord = w2 ? function(T2) {
            return T2 - n3;
          } : function(T2) {
            return m2 - T2 + n3;
          };
        }, u.prototype.getAxis = function() {
          return this._axis;
        }, u.prototype.getBaseAxis = function() {
          return this._axis;
        }, u.prototype.getAxes = function() {
          return [this._axis];
        }, u.prototype.getTooltipAxes = function() {
          return { baseAxes: [this.getAxis()], otherAxes: [] };
        }, u.prototype.containPoint = function(o) {
          var n3 = this.getRect(), p2 = this.getAxis(), m2 = p2.orient;
          return m2 === "horizontal" ? p2.contain(p2.toLocalCoord(o[0])) && o[1] >= n3.y && o[1] <= n3.y + n3.height : p2.contain(p2.toLocalCoord(o[1])) && o[0] >= n3.y && o[0] <= n3.y + n3.height;
        }, u.prototype.pointToData = function(o) {
          var n3 = this.getAxis();
          return [n3.coordToData(n3.toLocalCoord(o[n3.orient === "horizontal" ? 0 : 1]))];
        }, u.prototype.dataToPoint = function(o) {
          var n3 = this.getAxis(), p2 = this.getRect(), m2 = [], w2 = n3.orient === "horizontal" ? 0 : 1;
          return o instanceof Array && (o = o[0]), m2[w2] = n3.toGlobalCoord(n3.dataToCoord(+o)), m2[1 - w2] = w2 === 0 ? p2.y + p2.height / 2 : p2.x + p2.width / 2, m2;
        }, u.prototype.convertToPixel = function(o, n3, p2) {
          var m2 = oSe(n3);
          return m2 === this ? this.dataToPoint(p2) : null;
        }, u.prototype.convertFromPixel = function(o, n3, p2) {
          var m2 = oSe(n3);
          return m2 === this ? this.pointToData(p2) : null;
        }, u;
      }();
      function oSe(u) {
        var o = u.seriesModel, n3 = u.singleAxisModel;
        return n3 && n3.coordinateSystem || o && o.coordinateSystem;
      }
      function rkn(u, o) {
        var n3 = [];
        return u.eachComponent("singleAxis", function(p2, m2) {
          var w2 = new nkn(p2, u, o);
          w2.name = "single_" + m2, w2.resize(p2, o), p2.coordinateSystem = w2, n3.push(w2);
        }), u.eachSeries(function(p2) {
          if (p2.get("coordinateSystem") === "singleAxis") {
            var m2 = p2.getReferringComponents("singleAxis", Y0).models[0];
            p2.coordinateSystem = m2 && m2.coordinateSystem;
          }
        }), n3;
      }
      var ikn = { create: rkn, dimensions: aSe }, akn = ikn, sSe = ["x", "y"], okn = ["width", "height"], skn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.makeElOption = function(n3, p2, m2, w2, T2) {
          var E = m2.axis, O2 = E.coordinateSystem, V3 = TVt(O2, 1 - owt(E)), W3 = O2.dataToPoint(p2)[0], q3 = w2.get("type");
          if (q3 && q3 !== "none") {
            var K = yVt(w2), J = lkn[q3](E, W3, V3);
            J.style = K, n3.graphicKey = J.type, n3.pointer = J;
          }
          var rt2 = MVt(m2);
          jwe(p2, n3, rt2, m2, w2, T2);
        }, o.prototype.getHandleTransform = function(n3, p2, m2) {
          var w2 = MVt(p2, { labelInside: false });
          w2.labelMargin = m2.get(["handle", "margin"]);
          var T2 = mVt(p2.axis, n3, w2);
          return { x: T2[0], y: T2[1], rotation: w2.rotation + (w2.labelDirection < 0 ? Math.PI : 0) };
        }, o.prototype.updateHandleTransform = function(n3, p2, m2, w2) {
          var T2 = m2.axis, E = T2.coordinateSystem, O2 = owt(T2), V3 = TVt(E, O2), W3 = [n3.x, n3.y];
          W3[O2] += p2[O2], W3[O2] = Math.min(V3[1], W3[O2]), W3[O2] = Math.max(V3[0], W3[O2]);
          var q3 = TVt(E, 1 - O2), K = (q3[1] + q3[0]) / 2, J = [K, K];
          return J[O2] = W3[O2], { x: W3[0], y: W3[1], rotation: n3.rotation, cursorPoint: J, tooltipOption: { verticalAlign: "middle" } };
        }, o;
      }(vVt), lkn = { line: function(u, o, n3) {
        var p2 = bVt([o, n3[0]], [o, n3[1]], owt(u));
        return { type: "Line", subPixelOptimize: true, shape: p2 };
      }, shadow: function(u, o, n3) {
        var p2 = u.getBandWidth(), m2 = n3[1] - n3[0];
        return { type: "Rect", shape: Wwe([o - p2 / 2, n3[0]], [p2, m2], owt(u)) };
      } };
      function owt(u) {
        return u.isHorizontal() ? 0 : 1;
      }
      function TVt(u, o) {
        var n3 = u.getRect();
        return [n3[sSe[o]], n3[sSe[o]] + n3[okn[o]]];
      }
      var ukn = skn, ckn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "single", o;
      }(C0);
      function fkn(u) {
        Rc2(Cst), Uz.registerAxisPointerClass("SingleAxisPointer", ukn), u.registerComponentView(ckn), u.registerComponentView(JEn), u.registerComponentModel(CVt), dY(u, "single", CVt, CVt.defaultOption), u.registerCoordinateSystem("single", akn);
      }
      var hkn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          var w2 = Y$(n3);
          u.prototype.init.apply(this, arguments), lSe(n3, w2);
        }, o.prototype.mergeOption = function(n3) {
          u.prototype.mergeOption.apply(this, arguments), lSe(this.option, n3);
        }, o.prototype.getCellSize = function() {
          return this.option.cellSize;
        }, o.type = "calendar", o.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, o;
      }(kh2);
      function lSe(u, o) {
        var n3 = u.cellSize, p2;
        za2(n3) ? p2 = n3 : p2 = u.cellSize = [n3, n3], p2.length === 1 && (p2[1] = p2[0]);
        var m2 = Ya2([0, 1], function(w2) {
          return myn(o, w2) && (p2[w2] = "auto"), p2[w2] != null && p2[w2] !== "auto";
        });
        i8(u, o, { type: "box", ignoreSize: m2 });
      }
      var pkn = hkn, dkn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2 = this.group;
          w2.removeAll();
          var T2 = n3.coordinateSystem, E = T2.getRangeInfo(), O2 = T2.getOrient(), V3 = p2.getLocaleModel();
          this._renderDayRect(n3, E, w2), this._renderLines(n3, E, O2, w2), this._renderYearText(n3, E, O2, w2), this._renderMonthText(n3, V3, O2, w2), this._renderWeekText(n3, V3, E, O2, w2);
        }, o.prototype._renderDayRect = function(n3, p2, m2) {
          for (var w2 = n3.coordinateSystem, T2 = n3.getModel("itemStyle").getItemStyle(), E = w2.getCellWidth(), O2 = w2.getCellHeight(), V3 = p2.start.time; V3 <= p2.end.time; V3 = w2.getNextNDay(V3, 1).time) {
            var W3 = w2.dataToRect([V3], false).tl, q3 = new Vf2({ shape: { x: W3[0], y: W3[1], width: E, height: O2 }, cursor: "default", style: T2 });
            m2.add(q3);
          }
        }, o.prototype._renderLines = function(n3, p2, m2, w2) {
          var T2 = this, E = n3.coordinateSystem, O2 = n3.getModel(["splitLine", "lineStyle"]).getLineStyle(), V3 = n3.get(["splitLine", "show"]), W3 = O2.lineWidth;
          this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
          for (var q3 = p2.start, K = 0; q3.time <= p2.end.time; K++) {
            rt2(q3.formatedDate), K === 0 && (q3 = E.getDateInfo(p2.start.y + "-" + p2.start.m));
            var J = q3.date;
            J.setMonth(J.getMonth() + 1), q3 = E.getDateInfo(J);
          }
          rt2(E.getNextNDay(p2.end.time, 1).formatedDate);
          function rt2(gt) {
            T2._firstDayOfMonth.push(E.getDateInfo(gt)), T2._firstDayPoints.push(E.dataToRect([gt], false).tl);
            var yt = T2._getLinePointsOfOneWeek(n3, gt, m2);
            T2._tlpoints.push(yt[0]), T2._blpoints.push(yt[yt.length - 1]), V3 && T2._drawSplitline(yt, O2, w2);
          }
          V3 && this._drawSplitline(T2._getEdgesPoints(T2._tlpoints, W3, m2), O2, w2), V3 && this._drawSplitline(T2._getEdgesPoints(T2._blpoints, W3, m2), O2, w2);
        }, o.prototype._getEdgesPoints = function(n3, p2, m2) {
          var w2 = [n3[0].slice(), n3[n3.length - 1].slice()], T2 = m2 === "horizontal" ? 0 : 1;
          return w2[0][T2] = w2[0][T2] - p2 / 2, w2[1][T2] = w2[1][T2] + p2 / 2, w2;
        }, o.prototype._drawSplitline = function(n3, p2, m2) {
          var w2 = new Mw({ z2: 20, shape: { points: n3 }, style: p2 });
          m2.add(w2);
        }, o.prototype._getLinePointsOfOneWeek = function(n3, p2, m2) {
          for (var w2 = n3.coordinateSystem, T2 = w2.getDateInfo(p2), E = [], O2 = 0; O2 < 7; O2++) {
            var V3 = w2.getNextNDay(T2.time, O2), W3 = w2.dataToRect([V3.time], false);
            E[2 * V3.day] = W3.tl, E[2 * V3.day + 1] = W3[m2 === "horizontal" ? "bl" : "tr"];
          }
          return E;
        }, o.prototype._formatterLabel = function(n3, p2) {
          return ds(n3) && n3 ? gyn(n3, p2) : Sl(n3) ? n3(p2) : p2.nameMap;
        }, o.prototype._yearTextPositionControl = function(n3, p2, m2, w2, T2) {
          var E = p2[0], O2 = p2[1], V3 = ["center", "bottom"];
          w2 === "bottom" ? (O2 += T2, V3 = ["center", "top"]) : w2 === "left" ? E -= T2 : w2 === "right" ? (E += T2, V3 = ["center", "top"]) : O2 -= T2;
          var W3 = 0;
          return (w2 === "left" || w2 === "right") && (W3 = Math.PI / 2), { rotation: W3, x: E, y: O2, style: { align: V3[0], verticalAlign: V3[1] } };
        }, o.prototype._renderYearText = function(n3, p2, m2, w2) {
          var T2 = n3.getModel("yearLabel");
          if (T2.get("show")) {
            var E = T2.get("margin"), O2 = T2.get("position");
            O2 || (O2 = m2 !== "horizontal" ? "top" : "left");
            var V3 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], W3 = (V3[0][0] + V3[1][0]) / 2, q3 = (V3[0][1] + V3[1][1]) / 2, K = m2 === "horizontal" ? 0 : 1, J = { top: [W3, V3[K][1]], bottom: [W3, V3[1 - K][1]], left: [V3[1 - K][0], q3], right: [V3[K][0], q3] }, rt2 = p2.start.y;
            +p2.end.y > +p2.start.y && (rt2 = rt2 + "-" + p2.end.y);
            var gt = T2.get("formatter"), yt = { start: p2.start.y, end: p2.end.y, nameMap: rt2 }, At = this._formatterLabel(gt, yt), Lt = new Zc2({ z2: 30, style: Cy(T2, { text: At }) });
            Lt.attr(this._yearTextPositionControl(Lt, J[O2], m2, O2, E)), w2.add(Lt);
          }
        }, o.prototype._monthTextPositionControl = function(n3, p2, m2, w2, T2) {
          var E = "left", O2 = "top", V3 = n3[0], W3 = n3[1];
          return m2 === "horizontal" ? (W3 = W3 + T2, p2 && (E = "center"), w2 === "start" && (O2 = "bottom")) : (V3 = V3 + T2, p2 && (O2 = "middle"), w2 === "start" && (E = "right")), { x: V3, y: W3, align: E, verticalAlign: O2 };
        }, o.prototype._renderMonthText = function(n3, p2, m2, w2) {
          var T2 = n3.getModel("monthLabel");
          if (T2.get("show")) {
            var E = T2.get("nameMap"), O2 = T2.get("margin"), V3 = T2.get("position"), W3 = T2.get("align"), q3 = [this._tlpoints, this._blpoints];
            (!E || ds(E)) && (E && (p2 = t8t(E) || p2), E = p2.get(["time", "monthAbbr"]) || []);
            var K = V3 === "start" ? 0 : 1, J = m2 === "horizontal" ? 0 : 1;
            O2 = V3 === "start" ? -O2 : O2;
            for (var rt2 = W3 === "center", gt = 0; gt < q3[K].length - 1; gt++) {
              var yt = q3[K][gt].slice(), At = this._firstDayOfMonth[gt];
              if (rt2) {
                var Lt = this._firstDayPoints[gt];
                yt[J] = (Lt[J] + q3[0][gt + 1][J]) / 2;
              }
              var Wt = T2.get("formatter"), Nt = E[+At.m - 1], ue2 = { yyyy: At.y, yy: (At.y + "").slice(2), MM: At.m, M: +At.m, nameMap: Nt }, ie2 = this._formatterLabel(Wt, ue2), pe2 = new Zc2({ z2: 30, style: ua2(Cy(T2, { text: ie2 }), this._monthTextPositionControl(yt, rt2, m2, V3, O2)) });
              w2.add(pe2);
            }
          }
        }, o.prototype._weekTextPositionControl = function(n3, p2, m2, w2, T2) {
          var E = "center", O2 = "middle", V3 = n3[0], W3 = n3[1], q3 = m2 === "start";
          return p2 === "horizontal" ? (V3 = V3 + w2 + (q3 ? 1 : -1) * T2[0] / 2, E = q3 ? "right" : "left") : (W3 = W3 + w2 + (q3 ? 1 : -1) * T2[1] / 2, O2 = q3 ? "bottom" : "top"), { x: V3, y: W3, align: E, verticalAlign: O2 };
        }, o.prototype._renderWeekText = function(n3, p2, m2, w2, T2) {
          var E = n3.getModel("dayLabel");
          if (E.get("show")) {
            var O2 = n3.coordinateSystem, V3 = E.get("position"), W3 = E.get("nameMap"), q3 = E.get("margin"), K = O2.getFirstDayOfWeek();
            if (!W3 || ds(W3)) {
              W3 && (p2 = t8t(W3) || p2);
              var J = p2.get(["time", "dayOfWeekShort"]);
              W3 = J || Ya2(p2.get(["time", "dayOfWeekAbbr"]), function(ue2) {
                return ue2[0];
              });
            }
            var rt2 = O2.getNextNDay(m2.end.time, 7 - m2.lweek).time, gt = [O2.getCellWidth(), O2.getCellHeight()];
            q3 = Qo(q3, Math.min(gt[1], gt[0])), V3 === "start" && (rt2 = O2.getNextNDay(m2.start.time, -(7 + m2.fweek)).time, q3 = -q3);
            for (var yt = 0; yt < 7; yt++) {
              var At = O2.getNextNDay(rt2, yt), Lt = O2.dataToRect([At.time], false).center, Wt = yt;
              Wt = Math.abs((yt + K) % 7);
              var Nt = new Zc2({ z2: 30, style: ua2(Cy(E, { text: W3[Wt] }), this._weekTextPositionControl(Lt, w2, V3, q3, gt)) });
              T2.add(Nt);
            }
          }
        }, o.type = "calendar", o;
      }(C0), gkn = dkn, AVt = 864e5, vkn = function() {
        function u(o, n3, p2) {
          this.type = "calendar", this.dimensions = u.dimensions, this.getDimensionsInfo = u.getDimensionsInfo, this._model = o;
        }
        return u.getDimensionsInfo = function() {
          return [{ name: "time", type: "time" }, "value"];
        }, u.prototype.getRangeInfo = function() {
          return this._rangeInfo;
        }, u.prototype.getModel = function() {
          return this._model;
        }, u.prototype.getRect = function() {
          return this._rect;
        }, u.prototype.getCellWidth = function() {
          return this._sw;
        }, u.prototype.getCellHeight = function() {
          return this._sh;
        }, u.prototype.getOrient = function() {
          return this._orient;
        }, u.prototype.getFirstDayOfWeek = function() {
          return this._firstDayOfWeek;
        }, u.prototype.getDateInfo = function(o) {
          o = Nm(o);
          var n3 = o.getFullYear(), p2 = o.getMonth() + 1, m2 = p2 < 10 ? "0" + p2 : "" + p2, w2 = o.getDate(), T2 = w2 < 10 ? "0" + w2 : "" + w2, E = o.getDay();
          return E = Math.abs((E + 7 - this.getFirstDayOfWeek()) % 7), { y: n3 + "", m: m2, d: T2, day: E, time: o.getTime(), formatedDate: n3 + "-" + m2 + "-" + T2, date: o };
        }, u.prototype.getNextNDay = function(o, n3) {
          return n3 = n3 || 0, n3 === 0 ? this.getDateInfo(o) : (o = new Date(this.getDateInfo(o).time), o.setDate(o.getDate() + n3), this.getDateInfo(o));
        }, u.prototype.update = function(o, n3) {
          this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
          var p2 = this._rangeInfo.weeks || 1, m2 = ["width", "height"], w2 = this._model.getCellSize().slice(), T2 = this._model.getBoxLayoutParams(), E = this._orient === "horizontal" ? [p2, 7] : [7, p2];
          Xe2([0, 1], function(q3) {
            W3(w2, q3) && (T2[m2[q3]] = w2[q3] * E[q3]);
          });
          var O2 = { width: n3.getWidth(), height: n3.getHeight() }, V3 = this._rect = Bm(T2, O2);
          Xe2([0, 1], function(q3) {
            W3(w2, q3) || (w2[q3] = V3[m2[q3]] / E[q3]);
          });
          function W3(q3, K) {
            return q3[K] != null && q3[K] !== "auto";
          }
          this._sw = w2[0], this._sh = w2[1];
        }, u.prototype.dataToPoint = function(o, n3) {
          za2(o) && (o = o[0]), n3 == null && (n3 = true);
          var p2 = this.getDateInfo(o), m2 = this._rangeInfo, w2 = p2.formatedDate;
          if (n3 && !(p2.time >= m2.start.time && p2.time < m2.end.time + AVt))
            return [NaN, NaN];
          var T2 = p2.day, E = this._getRangeInfo([m2.start.time, w2]).nthWeek;
          return this._orient === "vertical" ? [this._rect.x + T2 * this._sw + this._sw / 2, this._rect.y + E * this._sh + this._sh / 2] : [this._rect.x + E * this._sw + this._sw / 2, this._rect.y + T2 * this._sh + this._sh / 2];
        }, u.prototype.pointToData = function(o) {
          var n3 = this.pointToDate(o);
          return n3 && n3.time;
        }, u.prototype.dataToRect = function(o, n3) {
          var p2 = this.dataToPoint(o, n3);
          return { contentShape: { x: p2[0] - (this._sw - this._lineWidth) / 2, y: p2[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: p2, tl: [p2[0] - this._sw / 2, p2[1] - this._sh / 2], tr: [p2[0] + this._sw / 2, p2[1] - this._sh / 2], br: [p2[0] + this._sw / 2, p2[1] + this._sh / 2], bl: [p2[0] - this._sw / 2, p2[1] + this._sh / 2] };
        }, u.prototype.pointToDate = function(o) {
          var n3 = Math.floor((o[0] - this._rect.x) / this._sw) + 1, p2 = Math.floor((o[1] - this._rect.y) / this._sh) + 1, m2 = this._rangeInfo.range;
          return this._orient === "vertical" ? this._getDateByWeeksAndDay(p2, n3 - 1, m2) : this._getDateByWeeksAndDay(n3, p2 - 1, m2);
        }, u.prototype.convertToPixel = function(o, n3, p2) {
          var m2 = uSe(n3);
          return m2 === this ? m2.dataToPoint(p2) : null;
        }, u.prototype.convertFromPixel = function(o, n3, p2) {
          var m2 = uSe(n3);
          return m2 === this ? m2.pointToData(p2) : null;
        }, u.prototype.containPoint = function(o) {
          return console.warn("Not implemented."), false;
        }, u.prototype._initRangeOption = function() {
          var o = this._model.get("range"), n3;
          if (za2(o) && o.length === 1 && (o = o[0]), za2(o))
            n3 = o;
          else {
            var p2 = o.toString();
            if (/^\d{4}$/.test(p2) && (n3 = [p2 + "-01-01", p2 + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(p2)) {
              var m2 = this.getDateInfo(p2), w2 = m2.date;
              w2.setMonth(w2.getMonth() + 1);
              var T2 = this.getNextNDay(w2, -1);
              n3 = [m2.formatedDate, T2.formatedDate];
            }
            /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(p2) && (n3 = [p2, p2]);
          }
          if (!n3)
            return o;
          var E = this._getRangeInfo(n3);
          return E.start.time > E.end.time && n3.reverse(), n3;
        }, u.prototype._getRangeInfo = function(o) {
          var n3 = [this.getDateInfo(o[0]), this.getDateInfo(o[1])], p2;
          n3[0].time > n3[1].time && (p2 = true, n3.reverse());
          var m2 = Math.floor(n3[1].time / AVt) - Math.floor(n3[0].time / AVt) + 1, w2 = new Date(n3[0].time), T2 = w2.getDate(), E = n3[1].date.getDate();
          w2.setDate(T2 + m2 - 1);
          var O2 = w2.getDate();
          if (O2 !== E)
            for (var V3 = w2.getTime() - n3[1].time > 0 ? 1 : -1; (O2 = w2.getDate()) !== E && (w2.getTime() - n3[1].time) * V3 > 0; )
              m2 -= V3, w2.setDate(O2 - V3);
          var W3 = Math.floor((m2 + n3[0].day + 6) / 7), q3 = p2 ? -W3 + 1 : W3 - 1;
          return p2 && n3.reverse(), { range: [n3[0].formatedDate, n3[1].formatedDate], start: n3[0], end: n3[1], allDay: m2, weeks: W3, nthWeek: q3, fweek: n3[0].day, lweek: n3[1].day };
        }, u.prototype._getDateByWeeksAndDay = function(o, n3, p2) {
          var m2 = this._getRangeInfo(p2);
          if (o > m2.weeks || o === 0 && n3 < m2.fweek || o === m2.weeks && n3 > m2.lweek)
            return null;
          var w2 = (o - 1) * 7 - m2.fweek + n3, T2 = new Date(m2.start.time);
          return T2.setDate(+m2.start.d + w2), this.getDateInfo(T2);
        }, u.create = function(o, n3) {
          var p2 = [];
          return o.eachComponent("calendar", function(m2) {
            var w2 = new u(m2, o, n3);
            p2.push(w2), m2.coordinateSystem = w2;
          }), o.eachSeries(function(m2) {
            m2.get("coordinateSystem") === "calendar" && (m2.coordinateSystem = p2[m2.get("calendarIndex") || 0]);
          }), p2;
        }, u.dimensions = ["time", "value"], u;
      }();
      function uSe(u) {
        var o = u.calendarModel, n3 = u.seriesModel, p2 = o ? o.coordinateSystem : n3 ? n3.coordinateSystem : null;
        return p2;
      }
      var ykn = vkn;
      function mkn(u) {
        u.registerComponentModel(pkn), u.registerComponentView(gkn), u.registerCoordinateSystem("calendar", ykn);
      }
      function bkn(u, o) {
        var n3 = u.existing;
        if (o.id = u.keyInfo.id, !o.type && n3 && (o.type = n3.type), o.parentId == null) {
          var p2 = o.parentOption;
          p2 ? o.parentId = p2.id : n3 && (o.parentId = n3.parentId);
        }
        o.parentOption = null;
      }
      function cSe(u, o) {
        var n3;
        return Xe2(o, function(p2) {
          u[p2] != null && u[p2] !== "auto" && (n3 = true);
        }), n3;
      }
      function _kn(u, o, n3) {
        var p2 = ua2({}, n3), m2 = u[o], w2 = n3.$action || "merge";
        w2 === "merge" ? m2 ? (Cu(m2, p2, true), i8(m2, p2, { ignoreSize: true }), Fve(n3, m2), swt(n3, m2), swt(n3, m2, "shape"), swt(n3, m2, "style"), swt(n3, m2, "extra"), n3.clipPath = m2.clipPath) : u[o] = p2 : w2 === "replace" ? u[o] = p2 : w2 === "remove" && m2 && (u[o] = null);
      }
      var fSe = ["transition", "enterFrom", "leaveTo"], xkn = fSe.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
      function swt(u, o, n3) {
        if (n3 && (!u[n3] && o[n3] && (u[n3] = {}), u = u[n3], o = o[n3]), !(!u || !o))
          for (var p2 = n3 ? fSe : xkn, m2 = 0; m2 < p2.length; m2++) {
            var w2 = p2[m2];
            u[w2] == null && o[w2] != null && (u[w2] = o[w2]);
          }
      }
      function wkn(u, o) {
        if (!!u && (u.hv = o.hv = [cSe(o, ["left", "right"]), cSe(o, ["top", "bottom"])], u.type === "group")) {
          var n3 = u, p2 = o;
          n3.width == null && (n3.width = p2.width = 0), n3.height == null && (n3.height = p2.height = 0);
        }
      }
      var Skn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.preventAutoZ = true, n3;
        }
        return o.prototype.mergeOption = function(n3, p2) {
          var m2 = this.option.elements;
          this.option.elements = null, u.prototype.mergeOption.call(this, n3, p2), this.option.elements = m2;
        }, o.prototype.optionUpdated = function(n3, p2) {
          var m2 = this.option, w2 = (p2 ? m2 : n3).elements, T2 = m2.elements = p2 ? [] : m2.elements, E = [];
          this._flatten(w2, E, null);
          var O2 = I1(T2, E, "normalMerge"), V3 = this._elOptionsToUpdate = [];
          Xe2(O2, function(W3, q3) {
            var K = W3.newOption;
            !K || (V3.push(K), bkn(W3, K), _kn(T2, q3, K), wkn(T2[q3], K));
          }, this), m2.elements = Fp(T2, function(W3) {
            return W3 && delete W3.$action, W3 != null;
          });
        }, o.prototype._flatten = function(n3, p2, m2) {
          Xe2(n3, function(w2) {
            if (w2) {
              m2 && (w2.parentOption = m2), p2.push(w2);
              var T2 = w2.children;
              w2.type === "group" && T2 && this._flatten(T2, p2, w2), delete w2.children;
            }
          }, this);
        }, o.prototype.useElOptionsToUpdate = function() {
          var n3 = this._elOptionsToUpdate;
          return this._elOptionsToUpdate = null, n3;
        }, o.type = "graphic", o.defaultOption = { elements: [] }, o;
      }(kh2), hSe = { path: null, compoundPath: null, group: uu, image: Fm, text: Zc2 }, _I = Ff2(), Mkn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function() {
          this._elMap = pl();
        }, o.prototype.render = function(n3, p2, m2) {
          n3 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = n3, this._updateElements(n3), this._relocate(n3, m2);
        }, o.prototype._updateElements = function(n3) {
          var p2 = n3.useElOptionsToUpdate();
          if (p2) {
            var m2 = this._elMap, w2 = this.group, T2 = n3.get("z"), E = n3.get("zlevel");
            Xe2(p2, function(O2) {
              var V3 = $d2(O2.id, null), W3 = V3 != null ? m2.get(V3) : null, q3 = $d2(O2.parentId, null), K = q3 != null ? m2.get(q3) : w2, J = O2.type, rt2 = O2.style;
              J === "text" && rt2 && O2.hv && O2.hv[1] && (rt2.textVerticalAlign = rt2.textBaseline = rt2.verticalAlign = rt2.align = null);
              var gt = O2.textContent, yt = O2.textConfig;
              if (rt2 && gwe(rt2, J, !!yt, !!gt)) {
                var At = vwe(rt2, J, true);
                !yt && At.textConfig && (yt = O2.textConfig = At.textConfig), !gt && At.textContent && (gt = At.textContent);
              }
              var Lt = Ckn(O2), Wt = O2.$action || "merge", Nt = Wt === "merge", ue2 = Wt === "replace";
              if (Nt) {
                var ie2 = !W3, pe2 = W3;
                ie2 ? pe2 = pSe(V3, K, O2.type, m2) : (pe2 && (_I(pe2).isNew = false), Twe(pe2)), pe2 && (Jxt(pe2, Lt, n3, { isInit: ie2 }), dSe(pe2, O2, T2, E));
              } else if (ue2) {
                lwt(W3, O2, m2, n3);
                var xe = pSe(V3, K, O2.type, m2);
                xe && (Jxt(xe, Lt, n3, { isInit: true }), dSe(xe, O2, T2, E));
              } else
                Wt === "remove" && (wwe(W3, O2), lwt(W3, O2, m2, n3));
              var Ce2 = m2.get(V3);
              if (Ce2 && gt)
                if (Nt) {
                  var Le2 = Ce2.getTextContent();
                  Le2 ? Le2.attr(gt) : Ce2.setTextContent(new Zc2(gt));
                } else
                  ue2 && Ce2.setTextContent(new Zc2(gt));
              if (Ce2) {
                var ze = O2.clipPath;
                if (ze) {
                  var tn = ze.type, $e2 = void 0, ie2 = false;
                  if (Nt) {
                    var Tn = Ce2.getClipPath();
                    ie2 = !Tn || _I(Tn).type !== tn, $e2 = ie2 ? IVt(tn) : Tn;
                  } else
                    ue2 && (ie2 = true, $e2 = IVt(tn));
                  Ce2.setClipPath($e2), Jxt($e2, ze, n3, { isInit: ie2 }), ewt($e2, ze.keyframeAnimation, n3);
                }
                var zn = _I(Ce2);
                Ce2.setTextConfig(yt), zn.option = O2, Tkn(Ce2, n3, O2), G$({ el: Ce2, componentModel: n3, itemName: Ce2.name, itemTooltipOption: O2.tooltip }), ewt(Ce2, O2.keyframeAnimation, n3);
              }
            });
          }
        }, o.prototype._relocate = function(n3, p2) {
          for (var m2 = n3.option.elements, w2 = this.group, T2 = this._elMap, E = p2.getWidth(), O2 = p2.getHeight(), V3 = ["x", "y"], W3 = 0; W3 < m2.length; W3++) {
            var q3 = m2[W3], K = $d2(q3.id, null), J = K != null ? T2.get(K) : null;
            if (!(!J || !J.isGroup)) {
              var rt2 = J.parent, gt = rt2 === w2, yt = _I(J), At = _I(rt2);
              yt.width = Qo(yt.option.width, gt ? E : At.width) || 0, yt.height = Qo(yt.option.height, gt ? O2 : At.height) || 0;
            }
          }
          for (var W3 = m2.length - 1; W3 >= 0; W3--) {
            var q3 = m2[W3], K = $d2(q3.id, null), J = K != null ? T2.get(K) : null;
            if (J) {
              var rt2 = J.parent, At = _I(rt2), Lt = rt2 === w2 ? { width: E, height: O2 } : { width: At.width, height: At.height }, Wt = {}, Nt = V_t(J, q3, Lt, null, { hv: q3.hv, boundingMode: q3.bounding }, Wt);
              if (!_I(J).isNew && Nt) {
                for (var ue2 = q3.transition, ie2 = {}, pe2 = 0; pe2 < V3.length; pe2++) {
                  var xe = V3[pe2], Ce2 = Wt[xe];
                  ue2 && (tj2(ue2) || sc2(ue2, xe) >= 0) ? ie2[xe] = Ce2 : J[xe] = Ce2;
                }
                Xf2(J, ie2, n3, 0);
              } else
                J.attr(Wt);
            }
          }
        }, o.prototype._clear = function() {
          var n3 = this, p2 = this._elMap;
          p2.each(function(m2) {
            lwt(m2, _I(m2).option, p2, n3._lastGraphicModel);
          }), this._elMap = pl();
        }, o.prototype.dispose = function() {
          this._clear();
        }, o.type = "graphic", o;
      }(C0);
      function IVt(u) {
        var o = Fs(hSe, u) ? hSe[u] : qn(u), n3 = new o({});
        return _I(n3).type = u, n3;
      }
      function pSe(u, o, n3, p2) {
        var m2 = IVt(n3);
        return o.add(m2), p2.set(u, m2), _I(m2).id = u, _I(m2).isNew = true, m2;
      }
      function lwt(u, o, n3, p2) {
        var m2 = u && u.parent;
        m2 && (u.type === "group" && u.traverse(function(w2) {
          lwt(w2, o, n3, p2);
        }), twt(u, o, p2), n3.removeKey(_I(u).id));
      }
      function dSe(u, o, n3, p2) {
        if (!u.isGroup) {
          var m2 = u;
          m2.cursor = Xu(o.cursor, sM.prototype.cursor), m2.z = Xu(o.z, n3 || 0), m2.zlevel = Xu(o.zlevel, p2 || 0);
          var w2 = o.z2;
          w2 != null && (m2.z2 = w2 || 0);
        }
        Xe2(tf2(o), function(T2) {
          var E = o[T2];
          T2.indexOf("on") === 0 && Sl(E) && (u[T2] = E);
        }), u.draggable = o.draggable, o.name != null && (u.name = o.name), o.id != null && (u.id = o.id);
      }
      function Ckn(u) {
        return u = ua2({}, u), Xe2(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(Nve), function(o) {
          delete u[o];
        }), u;
      }
      function Tkn(u, o, n3) {
        var p2 = is(u).eventData;
        !u.silent && !u.ignore && !p2 && (p2 = is(u).eventData = { componentType: "graphic", componentIndex: o.componentIndex, name: u.name }), p2 && (p2.info = n3.info);
      }
      function Akn(u) {
        u.registerComponentModel(Skn), u.registerComponentView(Mkn), u.registerPreprocessor(function(o) {
          var n3 = o.graphic;
          za2(n3) ? !n3[0] || !n3[0].elements ? o.graphic = [{ elements: n3 }] : o.graphic = [o.graphic[0]] : n3 && !n3.elements && (o.graphic = [{ elements: [n3] }]);
        });
      }
      var gSe = ["x", "y", "radius", "angle", "single"], Ikn = ["cartesian2d", "polar", "singleAxis"];
      function Dkn(u) {
        var o = u.get("coordinateSystem");
        return sc2(Ikn, o) >= 0;
      }
      function _8(u) {
        return u + "Axis";
      }
      function Ekn(u, o) {
        var n3 = pl(), p2 = [], m2 = pl();
        u.eachComponent({ mainType: "dataZoom", query: o }, function(W3) {
          m2.get(W3.uid) || E(W3);
        });
        var w2;
        do
          w2 = false, u.eachComponent("dataZoom", T2);
        while (w2);
        function T2(W3) {
          !m2.get(W3.uid) && O2(W3) && (E(W3), w2 = true);
        }
        function E(W3) {
          m2.set(W3.uid, true), p2.push(W3), V3(W3);
        }
        function O2(W3) {
          var q3 = false;
          return W3.eachTargetAxis(function(K, J) {
            var rt2 = n3.get(K);
            rt2 && rt2[J] && (q3 = true);
          }), q3;
        }
        function V3(W3) {
          W3.eachTargetAxis(function(q3, K) {
            (n3.get(q3) || n3.set(q3, []))[K] = true;
          });
        }
        return p2;
      }
      function vSe(u) {
        var o = u.ecModel, n3 = { infoList: [], infoMap: pl() };
        return u.eachTargetAxis(function(p2, m2) {
          var w2 = o.getComponent(_8(p2), m2);
          if (w2) {
            var T2 = w2.getCoordSysModel();
            if (T2) {
              var E = T2.uid, O2 = n3.infoMap.get(E);
              O2 || (O2 = { model: T2, axisModels: [] }, n3.infoList.push(O2), n3.infoMap.set(E, O2)), O2.axisModels.push(w2);
            }
          }
        }), n3;
      }
      var DVt = function() {
        function u() {
          this.indexList = [], this.indexMap = [];
        }
        return u.prototype.add = function(o) {
          this.indexMap[o] || (this.indexList.push(o), this.indexMap[o] = true);
        }, u;
      }(), kkn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._autoThrottle = true, n3._noTarget = true, n3._rangePropMode = ["percent", "percent"], n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          var w2 = ySe(n3);
          this.settledOption = w2, this.mergeDefaultAndTheme(n3, m2), this._doInit(w2);
        }, o.prototype.mergeOption = function(n3) {
          var p2 = ySe(n3);
          Cu(this.option, n3, true), Cu(this.settledOption, p2, true), this._doInit(p2);
        }, o.prototype._doInit = function(n3) {
          var p2 = this.option;
          this._setDefaultThrottle(n3), this._updateRangeUse(n3);
          var m2 = this.settledOption;
          Xe2([["start", "startValue"], ["end", "endValue"]], function(w2, T2) {
            this._rangePropMode[T2] === "value" && (p2[w2[0]] = m2[w2[0]] = null);
          }, this), this._resetTarget();
        }, o.prototype._resetTarget = function() {
          var n3 = this.get("orient", true), p2 = this._targetAxisInfoMap = pl(), m2 = this._fillSpecifiedTargetAxis(p2);
          m2 ? this._orient = n3 || this._makeAutoOrientByTargetAxis() : (this._orient = n3 || "horizontal", this._fillAutoTargetAxisByOrient(p2, this._orient)), this._noTarget = true, p2.each(function(w2) {
            w2.indexList.length && (this._noTarget = false);
          }, this);
        }, o.prototype._fillSpecifiedTargetAxis = function(n3) {
          var p2 = false;
          return Xe2(gSe, function(m2) {
            var w2 = this.getReferringComponents(_8(m2), wNt);
            if (w2.specified) {
              p2 = true;
              var T2 = new DVt();
              Xe2(w2.models, function(E) {
                T2.add(E.componentIndex);
              }), n3.set(m2, T2);
            }
          }, this), p2;
        }, o.prototype._fillAutoTargetAxisByOrient = function(n3, p2) {
          var m2 = this.ecModel, w2 = true;
          if (w2) {
            var T2 = p2 === "vertical" ? "y" : "x", E = m2.findComponents({ mainType: T2 + "Axis" });
            O2(E, T2);
          }
          if (w2) {
            var E = m2.findComponents({ mainType: "singleAxis", filter: function(W3) {
              return W3.get("orient", true) === p2;
            } });
            O2(E, "single");
          }
          function O2(V3, W3) {
            var q3 = V3[0];
            if (q3) {
              var K = new DVt();
              if (K.add(q3.componentIndex), n3.set(W3, K), w2 = false, W3 === "x" || W3 === "y") {
                var J = q3.getReferringComponents("grid", Y0).models[0];
                J && Xe2(V3, function(rt2) {
                  q3.componentIndex !== rt2.componentIndex && J === rt2.getReferringComponents("grid", Y0).models[0] && K.add(rt2.componentIndex);
                });
              }
            }
          }
          w2 && Xe2(gSe, function(V3) {
            if (w2) {
              var W3 = m2.findComponents({ mainType: _8(V3), filter: function(K) {
                return K.get("type", true) === "category";
              } });
              if (W3[0]) {
                var q3 = new DVt();
                q3.add(W3[0].componentIndex), n3.set(V3, q3), w2 = false;
              }
            }
          }, this);
        }, o.prototype._makeAutoOrientByTargetAxis = function() {
          var n3;
          return this.eachTargetAxis(function(p2) {
            !n3 && (n3 = p2);
          }, this), n3 === "y" ? "vertical" : "horizontal";
        }, o.prototype._setDefaultThrottle = function(n3) {
          if (n3.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
            var p2 = this.ecModel.option;
            this.option.throttle = p2.animation && p2.animationDurationUpdate > 0 ? 100 : 20;
          }
        }, o.prototype._updateRangeUse = function(n3) {
          var p2 = this._rangePropMode, m2 = this.get("rangeMode");
          Xe2([["start", "startValue"], ["end", "endValue"]], function(w2, T2) {
            var E = n3[w2[0]] != null, O2 = n3[w2[1]] != null;
            E && !O2 ? p2[T2] = "percent" : !E && O2 ? p2[T2] = "value" : m2 ? p2[T2] = m2[T2] : E && (p2[T2] = "percent");
          });
        }, o.prototype.noTarget = function() {
          return this._noTarget;
        }, o.prototype.getFirstTargetAxisModel = function() {
          var n3;
          return this.eachTargetAxis(function(p2, m2) {
            n3 == null && (n3 = this.ecModel.getComponent(_8(p2), m2));
          }, this), n3;
        }, o.prototype.eachTargetAxis = function(n3, p2) {
          this._targetAxisInfoMap.each(function(m2, w2) {
            Xe2(m2.indexList, function(T2) {
              n3.call(p2, w2, T2);
            });
          });
        }, o.prototype.getAxisProxy = function(n3, p2) {
          var m2 = this.getAxisModel(n3, p2);
          if (m2)
            return m2.__dzAxisProxy;
        }, o.prototype.getAxisModel = function(n3, p2) {
          var m2 = this._targetAxisInfoMap.get(n3);
          if (m2 && m2.indexMap[p2])
            return this.ecModel.getComponent(_8(n3), p2);
        }, o.prototype.setRawRange = function(n3) {
          var p2 = this.option, m2 = this.settledOption;
          Xe2([["start", "startValue"], ["end", "endValue"]], function(w2) {
            (n3[w2[0]] != null || n3[w2[1]] != null) && (p2[w2[0]] = m2[w2[0]] = n3[w2[0]], p2[w2[1]] = m2[w2[1]] = n3[w2[1]]);
          }, this), this._updateRangeUse(n3);
        }, o.prototype.setCalculatedRange = function(n3) {
          var p2 = this.option;
          Xe2(["start", "startValue", "end", "endValue"], function(m2) {
            p2[m2] = n3[m2];
          });
        }, o.prototype.getPercentRange = function() {
          var n3 = this.findRepresentativeAxisProxy();
          if (n3)
            return n3.getDataPercentWindow();
        }, o.prototype.getValueRange = function(n3, p2) {
          if (n3 == null && p2 == null) {
            var m2 = this.findRepresentativeAxisProxy();
            if (m2)
              return m2.getDataValueWindow();
          } else
            return this.getAxisProxy(n3, p2).getDataValueWindow();
        }, o.prototype.findRepresentativeAxisProxy = function(n3) {
          if (n3)
            return n3.__dzAxisProxy;
          for (var p2, m2 = this._targetAxisInfoMap.keys(), w2 = 0; w2 < m2.length; w2++)
            for (var T2 = m2[w2], E = this._targetAxisInfoMap.get(T2), O2 = 0; O2 < E.indexList.length; O2++) {
              var V3 = this.getAxisProxy(T2, E.indexList[O2]);
              if (V3.hostedBy(this))
                return V3;
              p2 || (p2 = V3);
            }
          return p2;
        }, o.prototype.getRangePropMode = function() {
          return this._rangePropMode.slice();
        }, o.prototype.getOrient = function() {
          return this._orient;
        }, o.type = "dataZoom", o.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], o.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, o;
      }(kh2);
      function ySe(u) {
        var o = {};
        return Xe2(["start", "end", "startValue", "endValue", "throttle"], function(n3) {
          u.hasOwnProperty(n3) && (o[n3] = u[n3]);
        }), o;
      }
      var Tst = kkn, Pkn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "dataZoom.select", o;
      }(Tst), Lkn = Pkn, Okn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          this.dataZoomModel = n3, this.ecModel = p2, this.api = m2;
        }, o.type = "dataZoom", o;
      }(C0), EVt = Okn, Rkn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "dataZoom.select", o;
      }(EVt), Nkn = Rkn, SY = Xe2, mSe = K_, Fkn = function() {
        function u(o, n3, p2, m2) {
          this._dimName = o, this._axisIndex = n3, this.ecModel = m2, this._dataZoomModel = p2;
        }
        return u.prototype.hostedBy = function(o) {
          return this._dataZoomModel === o;
        }, u.prototype.getDataValueWindow = function() {
          return this._valueWindow.slice();
        }, u.prototype.getDataPercentWindow = function() {
          return this._percentWindow.slice();
        }, u.prototype.getTargetSeriesModels = function() {
          var o = [];
          return this.ecModel.eachSeries(function(n3) {
            if (Dkn(n3)) {
              var p2 = _8(this._dimName), m2 = n3.getReferringComponents(p2, Y0).models[0];
              m2 && this._axisIndex === m2.componentIndex && o.push(n3);
            }
          }, this), o;
        }, u.prototype.getAxisModel = function() {
          return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
        }, u.prototype.getMinMaxSpan = function() {
          return jl(this._minMaxSpan);
        }, u.prototype.calculateDataWindow = function(o) {
          var n3 = this._dataExtent, p2 = this.getAxisModel(), m2 = p2.axis.scale, w2 = this._dataZoomModel.getRangePropMode(), T2 = [0, 100], E = [], O2 = [], V3;
          SY(["start", "end"], function(K, J) {
            var rt2 = o[K], gt = o[K + "Value"];
            w2[J] === "percent" ? (rt2 == null && (rt2 = T2[J]), gt = m2.parse(bp(rt2, T2, n3))) : (V3 = true, gt = gt == null ? n3[J] : m2.parse(gt), rt2 = bp(gt, n3, T2)), O2[J] = gt, E[J] = rt2;
          }), mSe(O2), mSe(E);
          var W3 = this._minMaxSpan;
          V3 ? q3(O2, E, n3, T2, false) : q3(E, O2, T2, n3, true);
          function q3(K, J, rt2, gt, yt) {
            var At = yt ? "Span" : "ValueSpan";
            Xz(0, K, rt2, "all", W3["min" + At], W3["max" + At]);
            for (var Lt = 0; Lt < 2; Lt++)
              J[Lt] = bp(K[Lt], rt2, gt, true), yt && (J[Lt] = m2.parse(J[Lt]));
          }
          return { valueWindow: O2, percentWindow: E };
        }, u.prototype.reset = function(o) {
          if (o === this._dataZoomModel) {
            var n3 = this.getTargetSeriesModels();
            this._dataExtent = Vkn(this, this._dimName, n3), this._updateMinMaxSpan();
            var p2 = this.calculateDataWindow(o.settledOption);
            this._valueWindow = p2.valueWindow, this._percentWindow = p2.percentWindow, this._setAxisModel();
          }
        }, u.prototype.filterData = function(o, n3) {
          if (o !== this._dataZoomModel)
            return;
          var p2 = this._dimName, m2 = this.getTargetSeriesModels(), w2 = o.get("filterMode"), T2 = this._valueWindow;
          if (w2 === "none")
            return;
          SY(m2, function(O2) {
            var V3 = O2.getData(), W3 = V3.mapDimensionsAll(p2);
            if (W3.length) {
              if (w2 === "weakFilter") {
                var q3 = V3.getStore(), K = Ya2(W3, function(J) {
                  return V3.getDimensionIndex(J);
                }, V3);
                V3.filterSelf(function(J) {
                  for (var rt2, gt, yt, At = 0; At < W3.length; At++) {
                    var Lt = q3.get(K[At], J), Wt = !isNaN(Lt), Nt = Lt < T2[0], ue2 = Lt > T2[1];
                    if (Wt && !Nt && !ue2)
                      return true;
                    Wt && (yt = true), Nt && (rt2 = true), ue2 && (gt = true);
                  }
                  return yt && rt2 && gt;
                });
              } else
                SY(W3, function(J) {
                  if (w2 === "empty")
                    O2.setData(V3 = V3.map(J, function(gt) {
                      return E(gt) ? gt : NaN;
                    }));
                  else {
                    var rt2 = {};
                    rt2[J] = T2, V3.selectRange(rt2);
                  }
                });
              SY(W3, function(J) {
                V3.setApproximateExtent(T2, J);
              });
            }
          });
          function E(O2) {
            return O2 >= T2[0] && O2 <= T2[1];
          }
        }, u.prototype._updateMinMaxSpan = function() {
          var o = this._minMaxSpan = {}, n3 = this._dataZoomModel, p2 = this._dataExtent;
          SY(["min", "max"], function(m2) {
            var w2 = n3.get(m2 + "Span"), T2 = n3.get(m2 + "ValueSpan");
            T2 != null && (T2 = this.getAxisModel().axis.scale.parse(T2)), T2 != null ? w2 = bp(p2[0] + T2, p2, [0, 100], true) : w2 != null && (T2 = bp(w2, [0, 100], p2, true) - p2[0]), o[m2 + "Span"] = w2, o[m2 + "ValueSpan"] = T2;
          }, this);
        }, u.prototype._setAxisModel = function() {
          var o = this.getAxisModel(), n3 = this._percentWindow, p2 = this._valueWindow;
          if (n3) {
            var m2 = hbt(p2, [0, 500]);
            m2 = Math.min(m2, 20);
            var w2 = o.axis.scale.rawExtentInfo;
            n3[0] !== 0 && w2.setDeterminedMinMax("min", +p2[0].toFixed(m2)), n3[1] !== 100 && w2.setDeterminedMinMax("max", +p2[1].toFixed(m2)), w2.freeze();
          }
        }, u;
      }();
      function Vkn(u, o, n3) {
        var p2 = [1 / 0, -1 / 0];
        SY(n3, function(T2) {
          l_n(p2, T2.getData(), o);
        });
        var m2 = u.getAxisModel(), w2 = Ame(m2.axis.scale, m2, p2).calculate();
        return [w2.min, w2.max];
      }
      var Bkn = Fkn, zkn = { getTargetSeries: function(u) {
        function o(m2) {
          u.eachComponent("dataZoom", function(w2) {
            w2.eachTargetAxis(function(T2, E) {
              var O2 = u.getComponent(_8(T2), E);
              m2(T2, E, O2, w2);
            });
          });
        }
        o(function(m2, w2, T2, E) {
          T2.__dzAxisProxy = null;
        });
        var n3 = [];
        o(function(m2, w2, T2, E) {
          T2.__dzAxisProxy || (T2.__dzAxisProxy = new Bkn(m2, w2, E, u), n3.push(T2.__dzAxisProxy));
        });
        var p2 = pl();
        return Xe2(n3, function(m2) {
          Xe2(m2.getTargetSeriesModels(), function(w2) {
            p2.set(w2.uid, w2);
          });
        }), p2;
      }, overallReset: function(u, o) {
        u.eachComponent("dataZoom", function(n3) {
          n3.eachTargetAxis(function(p2, m2) {
            n3.getAxisProxy(p2, m2).reset(n3);
          }), n3.eachTargetAxis(function(p2, m2) {
            n3.getAxisProxy(p2, m2).filterData(n3, o);
          });
        }), u.eachComponent("dataZoom", function(n3) {
          var p2 = n3.findRepresentativeAxisProxy();
          if (p2) {
            var m2 = p2.getDataPercentWindow(), w2 = p2.getDataValueWindow();
            n3.setCalculatedRange({ start: m2[0], end: m2[1], startValue: w2[0], endValue: w2[1] });
          }
        });
      } }, jkn = zkn;
      function Wkn(u) {
        u.registerAction("dataZoom", function(o, n3) {
          var p2 = Ekn(n3, o);
          Xe2(p2, function(m2) {
            m2.setRawRange({ start: o.start, end: o.end, startValue: o.startValue, endValue: o.endValue });
          });
        });
      }
      var bSe = false;
      function kVt(u) {
        bSe || (bSe = true, u.registerProcessor(u.PRIORITY.PROCESSOR.FILTER, jkn), Wkn(u), u.registerSubTypeDefaulter("dataZoom", function() {
          return "slider";
        }));
      }
      function Gkn(u) {
        u.registerComponentModel(Lkn), u.registerComponentView(Nkn), kVt(u);
      }
      var xI = function() {
        function u() {
        }
        return u;
      }(), _Se = {};
      function MY(u, o) {
        _Se[u] = o;
      }
      function xSe(u) {
        return _Se[u];
      }
      var Hkn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.optionUpdated = function() {
          u.prototype.optionUpdated.apply(this, arguments);
          var n3 = this.ecModel;
          Xe2(this.option.feature, function(p2, m2) {
            var w2 = xSe(m2);
            w2 && (w2.getDefaultOption && (w2.defaultOption = w2.getDefaultOption(n3)), Cu(p2, w2.defaultOption));
          });
        }, o.type = "toolbox", o.layoutMode = { type: "box", ignoreSize: true }, o.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, o;
      }(kh2), Ukn = Hkn;
      function qkn(u, o, n3) {
        var p2 = o.getBoxLayoutParams(), m2 = o.get("padding"), w2 = { width: n3.getWidth(), height: n3.getHeight() }, T2 = Bm(p2, w2, m2);
        Ez(o.get("orient"), u, o.get("itemGap"), T2.width, T2.height), V_t(u, p2, w2, m2);
      }
      function wSe(u, o) {
        var n3 = $$(o.get("padding")), p2 = o.getItemStyle(["color", "opacity"]);
        return p2.fill = o.get("backgroundColor"), u = new Vf2({ shape: { x: u.x - n3[3], y: u.y - n3[0], width: u.width + n3[1] + n3[3], height: u.height + n3[0] + n3[2], r: o.get("borderRadius") }, style: p2, silent: true, z2: -1 }), u;
      }
      var Zkn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          var T2 = this.group;
          if (T2.removeAll(), !n3.get("show"))
            return;
          var E = +n3.get("itemSize"), O2 = n3.get("feature") || {}, V3 = this._features || (this._features = {}), W3 = [];
          Xe2(O2, function(J, rt2) {
            W3.push(rt2);
          }), new C4(this._featureNames || [], W3).add(q3).update(q3).remove(wu(q3, null)).execute(), this._featureNames = W3;
          function q3(J, rt2) {
            var gt = W3[J], yt = W3[rt2], At = O2[gt], Lt = new _g(At, n3, n3.ecModel), Wt;
            if (w2 && w2.newTitle != null && w2.featureName === gt && (At.title = w2.newTitle), gt && !yt) {
              if ($kn(gt))
                Wt = { onclick: Lt.option.onclick, featureName: gt };
              else {
                var Nt = xSe(gt);
                if (!Nt)
                  return;
                Wt = new Nt();
              }
              V3[gt] = Wt;
            } else if (Wt = V3[yt], !Wt)
              return;
            Wt.uid = U$("toolbox-feature"), Wt.model = Lt, Wt.ecModel = p2, Wt.api = m2;
            var ue2 = Wt instanceof xI;
            if (!gt && yt) {
              ue2 && Wt.dispose && Wt.dispose(p2, m2);
              return;
            }
            if (!Lt.get("show") || ue2 && Wt.unusable) {
              ue2 && Wt.remove && Wt.remove(p2, m2);
              return;
            }
            K(Lt, Wt, gt), Lt.setIconStatus = function(ie2, pe2) {
              var xe = this.option, Ce2 = this.iconPaths;
              xe.iconStatus = xe.iconStatus || {}, xe.iconStatus[ie2] = pe2, Ce2[ie2] && (pe2 === "emphasis" ? Vm : pc2)(Ce2[ie2]);
            }, Wt instanceof xI && Wt.render && Wt.render(Lt, p2, m2, w2);
          }
          function K(J, rt2, gt) {
            var yt = J.getModel("iconStyle"), At = J.getModel(["emphasis", "iconStyle"]), Lt = rt2 instanceof xI && rt2.getIcons ? rt2.getIcons() : J.get("icon"), Wt = J.get("title") || {}, Nt, ue2;
            ds(Lt) ? (Nt = {}, Nt[gt] = Lt) : Nt = Lt, ds(Wt) ? (ue2 = {}, ue2[gt] = Wt) : ue2 = Wt;
            var ie2 = J.iconPaths = {};
            Xe2(Nt, function(pe2, xe) {
              var Ce2 = yv(pe2, {}, { x: -E / 2, y: -E / 2, width: E, height: E });
              Ce2.setStyle(yt.getItemStyle());
              var Le2 = Ce2.ensureState("emphasis");
              Le2.style = At.getItemStyle();
              var ze = new Zc2({ style: { text: ue2[xe], align: At.get("textAlign"), borderRadius: At.get("textBorderRadius"), padding: At.get("textPadding"), fill: null }, ignore: true });
              Ce2.setTextContent(ze), G$({ el: Ce2, componentModel: n3, itemName: xe, formatterParamsExtra: { title: ue2[xe] } }), Ce2.__title = ue2[xe], Ce2.on("mouseover", function() {
                var tn = At.getItemStyle(), $e2 = n3.get("orient") === "vertical" ? n3.get("right") == null ? "right" : "left" : n3.get("bottom") == null ? "bottom" : "top";
                ze.setStyle({ fill: At.get("textFill") || tn.fill || tn.stroke || "#000", backgroundColor: At.get("textBackgroundColor") }), Ce2.setTextConfig({ position: At.get("textPosition") || $e2 }), ze.ignore = !n3.get("showTitle"), Vm(this);
              }).on("mouseout", function() {
                J.get(["iconStatus", xe]) !== "emphasis" && pc2(this), ze.hide();
              }), (J.get(["iconStatus", xe]) === "emphasis" ? Vm : pc2)(Ce2), T2.add(Ce2), Ce2.on("click", Is(rt2.onclick, rt2, p2, m2, xe)), ie2[xe] = Ce2;
            });
          }
          qkn(T2, n3, m2), T2.add(wSe(T2.getBoundingRect(), n3)), T2.eachChild(function(J) {
            var rt2 = J.__title, gt = J.ensureState("emphasis"), yt = gt.textConfig || (gt.textConfig = {}), At = J.getTextContent(), Lt = At && At.states.emphasis;
            if (Lt && !Sl(Lt) && rt2) {
              var Wt = Lt.style || (Lt.style = {}), Nt = r4(rt2, Zc2.makeFont(Wt)), ue2 = J.x + T2.x, ie2 = J.y + T2.y + E, pe2 = false;
              ie2 + Nt.height > m2.getHeight() && (yt.position = "top", pe2 = true);
              var xe = pe2 ? -5 - Nt.height : E + 8;
              ue2 + Nt.width / 2 > m2.getWidth() ? (yt.position = ["100%", xe], Wt.align = "right") : ue2 - Nt.width / 2 < 0 && (yt.position = [0, xe], Wt.align = "left");
            }
          });
        }, o.prototype.updateView = function(n3, p2, m2, w2) {
          Xe2(this._features, function(T2) {
            T2 instanceof xI && T2.updateView && T2.updateView(T2.model, p2, m2, w2);
          });
        }, o.prototype.remove = function(n3, p2) {
          Xe2(this._features, function(m2) {
            m2 instanceof xI && m2.remove && m2.remove(n3, p2);
          }), this.group.removeAll();
        }, o.prototype.dispose = function(n3, p2) {
          Xe2(this._features, function(m2) {
            m2 instanceof xI && m2.dispose && m2.dispose(n3, p2);
          });
        }, o.type = "toolbox", o;
      }(C0);
      function $kn(u) {
        return u.indexOf("my") === 0;
      }
      var Ykn = Zkn, Kkn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.onclick = function(n3, p2) {
          var m2 = this.model, w2 = m2.get("name") || n3.get("title.0.text") || "echarts", T2 = p2.getZr().painter.getType() === "svg", E = T2 ? "svg" : m2.get("type", true) || "png", O2 = p2.getConnectedDataURL({ type: E, backgroundColor: m2.get("backgroundColor", true) || n3.get("backgroundColor") || "#fff", connectedBackgroundColor: m2.get("connectedBackgroundColor"), excludeComponents: m2.get("excludeComponents"), pixelRatio: m2.get("pixelRatio") }), V3 = Ys.browser;
          if (Sl(MouseEvent) && (V3.newEdge || !V3.ie && !V3.edge)) {
            var W3 = document.createElement("a");
            W3.download = w2 + "." + E, W3.target = "_blank", W3.href = O2;
            var q3 = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
            W3.dispatchEvent(q3);
          } else if (window.navigator.msSaveOrOpenBlob || T2) {
            var K = O2.split(","), J = K[0].indexOf("base64") > -1, rt2 = T2 ? decodeURIComponent(K[1]) : K[1];
            J && (rt2 = window.atob(rt2));
            var gt = w2 + "." + E;
            if (window.navigator.msSaveOrOpenBlob) {
              for (var yt = rt2.length, At = new Uint8Array(yt); yt--; )
                At[yt] = rt2.charCodeAt(yt);
              var Lt = new Blob([At]);
              window.navigator.msSaveOrOpenBlob(Lt, gt);
            } else {
              var Wt = document.createElement("iframe");
              document.body.appendChild(Wt);
              var Nt = Wt.contentWindow, ue2 = Nt.document;
              ue2.open("image/svg+xml", "replace"), ue2.write(rt2), ue2.close(), Nt.focus(), ue2.execCommand("SaveAs", true, gt), document.body.removeChild(Wt);
            }
          } else {
            var ie2 = m2.get("lang"), pe2 = '<body style="margin:0;"><img src="' + O2 + '" style="max-width:100%;" title="' + (ie2 && ie2[0] || "") + '" /></body>', xe = window.open();
            xe.document.write(pe2), xe.document.title = w2;
          }
        }, o.getDefaultOption = function(n3) {
          var p2 = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: n3.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: n3.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
          return p2;
        }, o;
      }(xI), Xkn = Kkn, SSe = "__ec_magicType_stack__", Qkn = [["line", "bar"], ["stack"]], Jkn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.getIcons = function() {
          var n3 = this.model, p2 = n3.get("icon"), m2 = {};
          return Xe2(n3.get("type"), function(w2) {
            p2[w2] && (m2[w2] = p2[w2]);
          }), m2;
        }, o.getDefaultOption = function(n3) {
          var p2 = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: n3.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
          return p2;
        }, o.prototype.onclick = function(n3, p2, m2) {
          var w2 = this.model, T2 = w2.get(["seriesIndex", m2]);
          if (MSe[m2]) {
            var E = { series: [] }, O2 = function(q3) {
              var K = q3.subType, J = q3.id, rt2 = MSe[m2](K, J, q3, w2);
              rt2 && (kl(rt2, q3.option), E.series.push(rt2));
              var gt = q3.coordinateSystem;
              if (gt && gt.type === "cartesian2d" && (m2 === "line" || m2 === "bar")) {
                var yt = gt.getAxesByScale("ordinal")[0];
                if (yt) {
                  var At = yt.dim, Lt = At + "Axis", Wt = q3.getReferringComponents(Lt, Y0).models[0], Nt = Wt.componentIndex;
                  E[Lt] = E[Lt] || [];
                  for (var ue2 = 0; ue2 <= Nt; ue2++)
                    E[Lt][Nt] = E[Lt][Nt] || {};
                  E[Lt][Nt].boundaryGap = m2 === "bar";
                }
              }
            };
            Xe2(Qkn, function(q3) {
              sc2(q3, m2) >= 0 && Xe2(q3, function(K) {
                w2.setIconStatus(K, "normal");
              });
            }), w2.setIconStatus(m2, "emphasis"), n3.eachComponent({ mainType: "series", query: T2 == null ? null : { seriesIndex: T2 } }, O2);
            var V3, W3 = m2;
            m2 === "stack" && (V3 = Cu({ stack: w2.option.title.tiled, tiled: w2.option.title.stack }, w2.option.title), w2.get(["iconStatus", m2]) !== "emphasis" && (W3 = "tiled")), p2.dispatchAction({ type: "changeMagicType", currentType: W3, newOption: E, newTitle: V3, featureName: "magicType" });
          }
        }, o;
      }(xI), MSe = { line: function(u, o, n3, p2) {
        if (u === "bar")
          return Cu({ id: o, type: "line", data: n3.get("data"), stack: n3.get("stack"), markPoint: n3.get("markPoint"), markLine: n3.get("markLine") }, p2.get(["option", "line"]) || {}, true);
      }, bar: function(u, o, n3, p2) {
        if (u === "line")
          return Cu({ id: o, type: "bar", data: n3.get("data"), stack: n3.get("stack"), markPoint: n3.get("markPoint"), markLine: n3.get("markLine") }, p2.get(["option", "bar"]) || {}, true);
      }, stack: function(u, o, n3, p2) {
        var m2 = n3.get("stack") === SSe;
        if (u === "line" || u === "bar")
          return p2.setIconStatus("stack", m2 ? "normal" : "emphasis"), Cu({ id: o, stack: m2 ? "" : SSe }, p2.get(["option", "stack"]) || {}, true);
      } };
      ZP({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(u, o) {
        o.mergeOption(u.newOption);
      });
      var t5n = Jkn, uwt = new Array(60).join("-"), CY = "	";
      function e5n(u) {
        var o = {}, n3 = [], p2 = [];
        return u.eachRawSeries(function(m2) {
          var w2 = m2.coordinateSystem;
          if (w2 && (w2.type === "cartesian2d" || w2.type === "polar")) {
            var T2 = w2.getBaseAxis();
            if (T2.type === "category") {
              var E = T2.dim + "_" + T2.index;
              o[E] || (o[E] = { categoryAxis: T2, valueAxis: w2.getOtherAxis(T2), series: [] }, p2.push({ axisDim: T2.dim, axisIndex: T2.index })), o[E].series.push(m2);
            } else
              n3.push(m2);
          } else
            n3.push(m2);
        }), { seriesGroupByCategoryAxis: o, other: n3, meta: p2 };
      }
      function n5n(u) {
        var o = [];
        return Xe2(u, function(n3, p2) {
          var m2 = n3.categoryAxis, w2 = n3.valueAxis, T2 = w2.dim, E = [" "].concat(Ya2(n3.series, function(J) {
            return J.name;
          })), O2 = [m2.model.getCategories()];
          Xe2(n3.series, function(J) {
            var rt2 = J.getRawData();
            O2.push(J.getRawData().mapArray(rt2.mapDimension(T2), function(gt) {
              return gt;
            }));
          });
          for (var V3 = [E.join(CY)], W3 = 0; W3 < O2[0].length; W3++) {
            for (var q3 = [], K = 0; K < O2.length; K++)
              q3.push(O2[K][W3]);
            V3.push(q3.join(CY));
          }
          o.push(V3.join(`
`));
        }), o.join(`

` + uwt + `

`);
      }
      function r5n(u) {
        return Ya2(u, function(o) {
          var n3 = o.getRawData(), p2 = [o.name], m2 = [];
          return n3.each(n3.dimensions, function() {
            for (var w2 = arguments.length, T2 = arguments[w2 - 1], E = n3.getName(T2), O2 = 0; O2 < w2 - 1; O2++)
              m2[O2] = arguments[O2];
            p2.push((E ? E + CY : "") + m2.join(CY));
          }), p2.join(`
`);
        }).join(`

` + uwt + `

`);
      }
      function i5n(u) {
        var o = e5n(u);
        return { value: Fp([n5n(o.seriesGroupByCategoryAxis), r5n(o.other)], function(n3) {
          return !!n3.replace(/[\n\t\s]/g, "");
        }).join(`

` + uwt + `

`), meta: o.meta };
      }
      function cwt(u) {
        return u.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
      }
      function a5n(u) {
        var o = u.slice(0, u.indexOf(`
`));
        if (o.indexOf(CY) >= 0)
          return true;
      }
      var PVt = new RegExp("[" + CY + "]+", "g");
      function o5n(u) {
        for (var o = u.split(/\n+/g), n3 = cwt(o.shift()).split(PVt), p2 = [], m2 = Ya2(n3, function(O2) {
          return { name: O2, data: [] };
        }), w2 = 0; w2 < o.length; w2++) {
          var T2 = cwt(o[w2]).split(PVt);
          p2.push(T2.shift());
          for (var E = 0; E < T2.length; E++)
            m2[E] && (m2[E].data[w2] = T2[E]);
        }
        return { series: m2, categories: p2 };
      }
      function s5n(u) {
        for (var o = u.split(/\n+/g), n3 = cwt(o.shift()), p2 = [], m2 = 0; m2 < o.length; m2++) {
          var w2 = cwt(o[m2]);
          if (w2) {
            var T2 = w2.split(PVt), E = "", O2 = void 0, V3 = false;
            isNaN(T2[0]) ? (V3 = true, E = T2[0], T2 = T2.slice(1), p2[m2] = { name: E, value: [] }, O2 = p2[m2].value) : O2 = p2[m2] = [];
            for (var W3 = 0; W3 < T2.length; W3++)
              O2.push(+T2[W3]);
            O2.length === 1 && (V3 ? p2[m2].value = O2[0] : p2[m2] = O2[0]);
          }
        }
        return { name: n3, data: p2 };
      }
      function l5n(u, o) {
        var n3 = u.split(new RegExp(`
*` + uwt + `
*`, "g")), p2 = { series: [] };
        return Xe2(n3, function(m2, w2) {
          if (a5n(m2)) {
            var T2 = o5n(m2), E = o[w2], O2 = E.axisDim + "Axis";
            E && (p2[O2] = p2[O2] || [], p2[O2][E.axisIndex] = { data: T2.categories }, p2.series = p2.series.concat(T2.series));
          } else {
            var T2 = s5n(m2);
            p2.series.push(T2);
          }
        }), p2;
      }
      var u5n = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.onclick = function(n3, p2) {
          setTimeout(function() {
            p2.dispatchAction({ type: "hideTip" });
          });
          var m2 = p2.getDom(), w2 = this.model;
          this._dom && m2.removeChild(this._dom);
          var T2 = document.createElement("div");
          T2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", T2.style.backgroundColor = w2.get("backgroundColor") || "#fff";
          var E = document.createElement("h4"), O2 = w2.get("lang") || [];
          E.innerHTML = O2[0] || w2.get("title"), E.style.cssText = "margin:10px 20px", E.style.color = w2.get("textColor");
          var V3 = document.createElement("div"), W3 = document.createElement("textarea");
          V3.style.cssText = "overflow:auto";
          var q3 = w2.get("optionToContent"), K = w2.get("contentToOption"), J = i5n(n3);
          if (Sl(q3)) {
            var rt2 = q3(p2.getOption());
            ds(rt2) ? V3.innerHTML = rt2 : VB(rt2) && V3.appendChild(rt2);
          } else {
            W3.readOnly = w2.get("readOnly");
            var gt = W3.style;
            gt.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", gt.color = w2.get("textColor"), gt.borderColor = w2.get("textareaBorderColor"), gt.backgroundColor = w2.get("textareaColor"), W3.value = J.value, V3.appendChild(W3);
          }
          var yt = J.meta, At = document.createElement("div");
          At.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
          var Lt = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", Wt = document.createElement("div"), Nt = document.createElement("div");
          Lt += ";background-color:" + w2.get("buttonColor"), Lt += ";color:" + w2.get("buttonTextColor");
          var ue2 = this;
          function ie2() {
            m2.removeChild(T2), ue2._dom = null;
          }
          wF(Wt, "click", ie2), wF(Nt, "click", function() {
            if (K == null && q3 != null || K != null && q3 == null) {
              ie2();
              return;
            }
            var pe2;
            try {
              Sl(K) ? pe2 = K(V3, p2.getOption()) : pe2 = l5n(W3.value, yt);
            } catch (xe) {
              throw ie2(), new Error("Data view format error " + xe);
            }
            pe2 && p2.dispatchAction({ type: "changeDataView", newOption: pe2 }), ie2();
          }), Wt.innerHTML = O2[1], Nt.innerHTML = O2[2], Nt.style.cssText = Wt.style.cssText = Lt, !w2.get("readOnly") && At.appendChild(Nt), At.appendChild(Wt), T2.appendChild(E), T2.appendChild(V3), T2.appendChild(At), V3.style.height = m2.clientHeight - 80 + "px", m2.appendChild(T2), this._dom = T2;
        }, o.prototype.remove = function(n3, p2) {
          this._dom && p2.getDom().removeChild(this._dom);
        }, o.prototype.dispose = function(n3, p2) {
          this.remove(n3, p2);
        }, o.getDefaultOption = function(n3) {
          var p2 = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: n3.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: n3.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
          return p2;
        }, o;
      }(xI);
      function c5n(u, o) {
        return Ya2(u, function(n3, p2) {
          var m2 = o && o[p2];
          if (ys(m2) && !za2(m2)) {
            var w2 = ys(n3) && !za2(n3);
            w2 || (n3 = { value: n3 });
            var T2 = m2.name != null && n3.name == null;
            return n3 = kl(n3, m2), T2 && delete n3.name, n3;
          } else
            return n3;
        });
      }
      ZP({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(u, o) {
        var n3 = [];
        Xe2(u.newOption.series, function(p2) {
          var m2 = o.getSeriesByName(p2.name)[0];
          if (!m2)
            n3.push(ua2({ type: "scatter" }, p2));
          else {
            var w2 = m2.get("data");
            n3.push({ name: p2.name, data: c5n(p2.data, w2) });
          }
        }), o.mergeOption(kl({ series: n3 }, u.newOption));
      });
      var f5n = u5n, CSe = Xe2, TSe = Ff2();
      function h5n(u, o) {
        var n3 = LVt(u);
        CSe(o, function(p2, m2) {
          for (var w2 = n3.length - 1; w2 >= 0; w2--) {
            var T2 = n3[w2];
            if (T2[m2])
              break;
          }
          if (w2 < 0) {
            var E = u.queryComponents({ mainType: "dataZoom", subType: "select", id: m2 })[0];
            if (E) {
              var O2 = E.getPercentRange();
              n3[0][m2] = { dataZoomId: m2, start: O2[0], end: O2[1] };
            }
          }
        }), n3.push(o);
      }
      function p5n(u) {
        var o = LVt(u), n3 = o[o.length - 1];
        o.length > 1 && o.pop();
        var p2 = {};
        return CSe(n3, function(m2, w2) {
          for (var T2 = o.length - 1; T2 >= 0; T2--)
            if (m2 = o[T2][w2], m2) {
              p2[w2] = m2;
              break;
            }
        }), p2;
      }
      function d5n(u) {
        TSe(u).snapshots = null;
      }
      function g5n(u) {
        return LVt(u).length;
      }
      function LVt(u) {
        var o = TSe(u);
        return o.snapshots || (o.snapshots = [{}]), o.snapshots;
      }
      var v5n = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.onclick = function(n3, p2) {
          d5n(n3), p2.dispatchAction({ type: "restore", from: this.uid });
        }, o.getDefaultOption = function(n3) {
          var p2 = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: n3.getLocaleModel().get(["toolbox", "restore", "title"]) };
          return p2;
        }, o;
      }(xI);
      ZP({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(u, o) {
        o.resetOption("recreate");
      });
      var y5n = v5n, m5n = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], b5n = function() {
        function u(o, n3, p2) {
          var m2 = this;
          this._targetInfoList = [];
          var w2 = ASe(n3, o);
          Xe2(_5n, function(T2, E) {
            (!p2 || !p2.include || sc2(p2.include, E) >= 0) && T2(w2, m2._targetInfoList);
          });
        }
        return u.prototype.setOutputRanges = function(o, n3) {
          return this.matchOutputRanges(o, n3, function(p2, m2, w2) {
            if ((p2.coordRanges || (p2.coordRanges = [])).push(m2), !p2.coordRange) {
              p2.coordRange = m2;
              var T2 = RVt[p2.brushType](0, w2, m2);
              p2.__rangeOffset = { offset: kSe[p2.brushType](T2.values, p2.range, [1, 1]), xyMinMax: T2.xyMinMax };
            }
          }), o;
        }, u.prototype.matchOutputRanges = function(o, n3, p2) {
          Xe2(o, function(m2) {
            var w2 = this.findTargetInfo(m2, n3);
            w2 && w2 !== true && Xe2(w2.coordSyses, function(T2) {
              var E = RVt[m2.brushType](1, T2, m2.range, true);
              p2(m2, E.values, T2, n3);
            });
          }, this);
        }, u.prototype.setInputRanges = function(o, n3) {
          Xe2(o, function(p2) {
            var m2 = this.findTargetInfo(p2, n3);
            if (p2.range = p2.range || [], m2 && m2 !== true) {
              p2.panelId = m2.panelId;
              var w2 = RVt[p2.brushType](0, m2.coordSys, p2.coordRange), T2 = p2.__rangeOffset;
              p2.range = T2 ? kSe[p2.brushType](w2.values, T2.offset, x5n(w2.xyMinMax, T2.xyMinMax)) : w2.values;
            }
          }, this);
        }, u.prototype.makePanelOpts = function(o, n3) {
          return Ya2(this._targetInfoList, function(p2) {
            var m2 = p2.getPanelRect();
            return { panelId: p2.panelId, defaultBrushType: n3 ? n3(p2) : null, clipPath: Ixe(m2), isTargetByCursor: Exe(m2, o, p2.coordSysModel), getLinearBrushOtherExtent: Dxe(m2) };
          });
        }, u.prototype.controlSeries = function(o, n3, p2) {
          var m2 = this.findTargetInfo(o, p2);
          return m2 === true || m2 && sc2(m2.coordSyses, n3.coordinateSystem) >= 0;
        }, u.prototype.findTargetInfo = function(o, n3) {
          for (var p2 = this._targetInfoList, m2 = ASe(n3, o), w2 = 0; w2 < p2.length; w2++) {
            var T2 = p2[w2], E = o.panelId;
            if (E) {
              if (T2.panelId === E)
                return T2;
            } else
              for (var O2 = 0; O2 < ISe.length; O2++)
                if (ISe[O2](m2, T2))
                  return T2;
          }
          return true;
        }, u;
      }();
      function OVt(u) {
        return u[0] > u[1] && u.reverse(), u;
      }
      function ASe(u, o) {
        return cz(u, o, { includeMainTypes: m5n });
      }
      var _5n = { grid: function(u, o) {
        var n3 = u.xAxisModels, p2 = u.yAxisModels, m2 = u.gridModels, w2 = pl(), T2 = {}, E = {};
        !n3 && !p2 && !m2 || (Xe2(n3, function(O2) {
          var V3 = O2.axis.grid.model;
          w2.set(V3.id, V3), T2[V3.id] = true;
        }), Xe2(p2, function(O2) {
          var V3 = O2.axis.grid.model;
          w2.set(V3.id, V3), E[V3.id] = true;
        }), Xe2(m2, function(O2) {
          w2.set(O2.id, O2), T2[O2.id] = true, E[O2.id] = true;
        }), w2.each(function(O2) {
          var V3 = O2.coordinateSystem, W3 = [];
          Xe2(V3.getCartesians(), function(q3, K) {
            (sc2(n3, q3.getAxis("x").model) >= 0 || sc2(p2, q3.getAxis("y").model) >= 0) && W3.push(q3);
          }), o.push({ panelId: "grid--" + O2.id, gridModel: O2, coordSysModel: O2, coordSys: W3[0], coordSyses: W3, getPanelRect: DSe.grid, xAxisDeclared: T2[O2.id], yAxisDeclared: E[O2.id] });
        }));
      }, geo: function(u, o) {
        Xe2(u.geoModels, function(n3) {
          var p2 = n3.coordinateSystem;
          o.push({ panelId: "geo--" + n3.id, geoModel: n3, coordSysModel: n3, coordSys: p2, coordSyses: [p2], getPanelRect: DSe.geo });
        });
      } }, ISe = [function(u, o) {
        var n3 = u.xAxisModel, p2 = u.yAxisModel, m2 = u.gridModel;
        return !m2 && n3 && (m2 = n3.axis.grid.model), !m2 && p2 && (m2 = p2.axis.grid.model), m2 && m2 === o.gridModel;
      }, function(u, o) {
        var n3 = u.geoModel;
        return n3 && n3 === o.geoModel;
      }], DSe = { grid: function() {
        return this.coordSys.master.getRect().clone();
      }, geo: function() {
        var u = this.coordSys, o = u.getBoundingRect().clone();
        return o.applyTransform(ku(u)), o;
      } }, RVt = { lineX: wu(ESe, 0), lineY: wu(ESe, 1), rect: function(u, o, n3, p2) {
        var m2 = u ? o.pointToData([n3[0][0], n3[1][0]], p2) : o.dataToPoint([n3[0][0], n3[1][0]], p2), w2 = u ? o.pointToData([n3[0][1], n3[1][1]], p2) : o.dataToPoint([n3[0][1], n3[1][1]], p2), T2 = [OVt([m2[0], w2[0]]), OVt([m2[1], w2[1]])];
        return { values: T2, xyMinMax: T2 };
      }, polygon: function(u, o, n3, p2) {
        var m2 = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], w2 = Ya2(n3, function(T2) {
          var E = u ? o.pointToData(T2, p2) : o.dataToPoint(T2, p2);
          return m2[0][0] = Math.min(m2[0][0], E[0]), m2[1][0] = Math.min(m2[1][0], E[1]), m2[0][1] = Math.max(m2[0][1], E[0]), m2[1][1] = Math.max(m2[1][1], E[1]), E;
        });
        return { values: w2, xyMinMax: m2 };
      } };
      function ESe(u, o, n3, p2) {
        var m2 = n3.getAxis(["x", "y"][u]), w2 = OVt(Ya2([0, 1], function(E) {
          return o ? m2.coordToData(m2.toLocalCoord(p2[E]), true) : m2.toGlobalCoord(m2.dataToCoord(p2[E]));
        })), T2 = [];
        return T2[u] = w2, T2[1 - u] = [NaN, NaN], { values: w2, xyMinMax: T2 };
      }
      var kSe = { lineX: wu(PSe, 0), lineY: wu(PSe, 1), rect: function(u, o, n3) {
        return [[u[0][0] - n3[0] * o[0][0], u[0][1] - n3[0] * o[0][1]], [u[1][0] - n3[1] * o[1][0], u[1][1] - n3[1] * o[1][1]]];
      }, polygon: function(u, o, n3) {
        return Ya2(u, function(p2, m2) {
          return [p2[0] - n3[0] * o[m2][0], p2[1] - n3[1] * o[m2][1]];
        });
      } };
      function PSe(u, o, n3, p2) {
        return [o[0] - p2[u] * n3[0], o[1] - p2[u] * n3[1]];
      }
      function x5n(u, o) {
        var n3 = LSe(u), p2 = LSe(o), m2 = [n3[0] / p2[0], n3[1] / p2[1]];
        return isNaN(m2[0]) && (m2[0] = 1), isNaN(m2[1]) && (m2[1] = 1), m2;
      }
      function LSe(u) {
        return u ? [u[0][1] - u[0][0], u[1][1] - u[1][0]] : [NaN, NaN];
      }
      var NVt = b5n, FVt = Xe2, w5n = bNt("toolbox-dataZoom_"), S5n = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.render = function(n3, p2, m2, w2) {
          this._brushController || (this._brushController = new q7t(m2.getZr()), this._brushController.on("brush", Is(this._onBrush, this)).mount()), T5n(n3, p2, this, w2, m2), C5n(n3, p2);
        }, o.prototype.onclick = function(n3, p2, m2) {
          M5n[m2].call(this);
        }, o.prototype.remove = function(n3, p2) {
          this._brushController && this._brushController.unmount();
        }, o.prototype.dispose = function(n3, p2) {
          this._brushController && this._brushController.dispose();
        }, o.prototype._onBrush = function(n3) {
          var p2 = n3.areas;
          if (!n3.isEnd || !p2.length)
            return;
          var m2 = {}, w2 = this.ecModel;
          this._brushController.updateCovers([]);
          var T2 = new NVt(VVt(this.model), w2, { include: ["grid"] });
          T2.matchOutputRanges(p2, w2, function(V3, W3, q3) {
            if (q3.type === "cartesian2d") {
              var K = V3.brushType;
              K === "rect" ? (E("x", q3, W3[0]), E("y", q3, W3[1])) : E({ lineX: "x", lineY: "y" }[K], q3, W3);
            }
          }), h5n(w2, m2), this._dispatchZoomAction(m2);
          function E(V3, W3, q3) {
            var K = W3.getAxis(V3), J = K.model, rt2 = O2(V3, J, w2), gt = rt2.findRepresentativeAxisProxy(J).getMinMaxSpan();
            (gt.minValueSpan != null || gt.maxValueSpan != null) && (q3 = Xz(0, q3.slice(), K.scale.getExtent(), 0, gt.minValueSpan, gt.maxValueSpan)), rt2 && (m2[rt2.id] = { dataZoomId: rt2.id, startValue: q3[0], endValue: q3[1] });
          }
          function O2(V3, W3, q3) {
            var K;
            return q3.eachComponent({ mainType: "dataZoom", subType: "select" }, function(J) {
              var rt2 = J.getAxisModel(V3, W3.componentIndex);
              rt2 && (K = J);
            }), K;
          }
        }, o.prototype._dispatchZoomAction = function(n3) {
          var p2 = [];
          FVt(n3, function(m2, w2) {
            p2.push(jl(m2));
          }), p2.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: p2 });
        }, o.getDefaultOption = function(n3) {
          var p2 = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: n3.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
          return p2;
        }, o;
      }(xI), M5n = { zoom: function() {
        var u = !this._isZoomActive;
        this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: u });
      }, back: function() {
        this._dispatchZoomAction(p5n(this.ecModel));
      } };
      function VVt(u) {
        var o = { xAxisIndex: u.get("xAxisIndex", true), yAxisIndex: u.get("yAxisIndex", true), xAxisId: u.get("xAxisId", true), yAxisId: u.get("yAxisId", true) };
        return o.xAxisIndex == null && o.xAxisId == null && (o.xAxisIndex = "all"), o.yAxisIndex == null && o.yAxisId == null && (o.yAxisIndex = "all"), o;
      }
      function C5n(u, o) {
        u.setIconStatus("back", g5n(o) > 1 ? "emphasis" : "normal");
      }
      function T5n(u, o, n3, p2, m2) {
        var w2 = n3._isZoomActive;
        p2 && p2.type === "takeGlobalCursor" && (w2 = p2.key === "dataZoomSelect" ? p2.dataZoomSelectActive : false), n3._isZoomActive = w2, u.setIconStatus("zoom", w2 ? "emphasis" : "normal");
        var T2 = new NVt(VVt(u), o, { include: ["grid"] }), E = T2.makePanelOpts(m2, function(O2) {
          return O2.xAxisDeclared && !O2.yAxisDeclared ? "lineX" : !O2.xAxisDeclared && O2.yAxisDeclared ? "lineY" : "rect";
        });
        n3._brushController.setPanels(E).enableBrush(w2 && E.length ? { brushType: "auto", brushStyle: u.getModel("brushStyle").getItemStyle() } : false);
      }
      Myn("dataZoom", function(u) {
        var o = u.getComponent("toolbox", 0), n3 = ["feature", "dataZoom"];
        if (!o || o.get(n3) == null)
          return;
        var p2 = o.getModel(n3), m2 = [], w2 = VVt(p2), T2 = cz(u, w2);
        FVt(T2.xAxisModels, function(O2) {
          return E(O2, "xAxis", "xAxisIndex");
        }), FVt(T2.yAxisModels, function(O2) {
          return E(O2, "yAxis", "yAxisIndex");
        });
        function E(O2, V3, W3) {
          var q3 = O2.componentIndex, K = { type: "select", $fromToolbox: true, filterMode: p2.get("filterMode", true) || "filter", id: w5n + V3 + q3 };
          K[W3] = q3, m2.push(K);
        }
        return m2;
      });
      var A5n = S5n;
      function I5n(u) {
        u.registerComponentModel(Ukn), u.registerComponentView(Ykn), MY("saveAsImage", Xkn), MY("magicType", t5n), MY("dataView", f5n), MY("dataZoom", A5n), MY("restore", y5n), Rc2(Gkn);
      }
      var D5n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "tooltip", o.dependencies = ["axisPointer"], o.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, o;
      }(kh2), E5n = D5n;
      function OSe(u) {
        var o = u.get("confine");
        return o != null ? !!o : u.get("renderMode") === "richText";
      }
      function RSe(u) {
        if (Ys.domSupported) {
          for (var o = document.documentElement.style, n3 = 0, p2 = u.length; n3 < p2; n3++)
            if (u[n3] in o)
              return u[n3];
        }
      }
      var NSe = RSe(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), k5n = RSe(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
      function FSe(u, o) {
        if (!u)
          return o;
        o = Lve(o, true);
        var n3 = u.indexOf(o);
        return u = n3 === -1 ? o : "-" + u.slice(0, n3) + "-" + o, u.toLowerCase();
      }
      function P5n(u, o) {
        var n3 = u.currentStyle || document.defaultView && document.defaultView.getComputedStyle(u);
        return n3 ? o ? n3[o] : n3 : null;
      }
      var L5n = FSe(k5n, "transition"), BVt = FSe(NSe, "transform"), O5n = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (Ys.transform3dSupported ? "will-change:transform;" : "");
      function R5n(u) {
        return u = u === "left" ? "right" : u === "right" ? "left" : u === "top" ? "bottom" : "top", u;
      }
      function N5n(u, o, n3) {
        if (!ds(n3) || n3 === "inside")
          return "";
        var p2 = u.get("backgroundColor"), m2 = u.get("borderWidth");
        o = Iz(o);
        var w2 = R5n(n3), T2 = Math.max(Math.round(m2) * 1.5, 6), E = "", O2 = BVt + ":", V3;
        sc2(["left", "right"], w2) > -1 ? (E += "top:50%", O2 += "translateY(-50%) rotate(" + (V3 = w2 === "left" ? -225 : -45) + "deg)") : (E += "left:50%", O2 += "translateX(-50%) rotate(" + (V3 = w2 === "top" ? 225 : 45) + "deg)");
        var W3 = V3 * Math.PI / 180, q3 = T2 + m2, K = q3 * Math.abs(Math.cos(W3)) + q3 * Math.abs(Math.sin(W3)), J = Math.round(((K - Math.SQRT2 * m2) / 2 + Math.SQRT2 * m2 - (K - q3) / 2) * 100) / 100;
        E += ";" + w2 + ":-" + J + "px";
        var rt2 = o + " solid " + m2 + "px;", gt = ["position:absolute;width:" + T2 + "px;height:" + T2 + "px;", E + ";" + O2 + ";", "border-bottom:" + rt2, "border-right:" + rt2, "background-color:" + p2 + ";"];
        return '<div style="' + gt.join("") + '"></div>';
      }
      function F5n(u, o) {
        var n3 = "cubic-bezier(0.23,1,0.32,1)", p2 = " " + u / 2 + "s " + n3, m2 = "opacity" + p2 + ",visibility" + p2;
        return o || (p2 = " " + u + "s " + n3, m2 += Ys.transformSupported ? "," + BVt + p2 : ",left" + p2 + ",top" + p2), L5n + ":" + m2;
      }
      function VSe(u, o, n3) {
        var p2 = u.toFixed(0) + "px", m2 = o.toFixed(0) + "px";
        if (!Ys.transformSupported)
          return n3 ? "top:" + m2 + ";left:" + p2 + ";" : [["top", m2], ["left", p2]];
        var w2 = Ys.transform3dSupported, T2 = "translate" + (w2 ? "3d" : "") + "(" + p2 + "," + m2 + (w2 ? ",0" : "") + ")";
        return n3 ? "top:0;left:0;" + BVt + ":" + T2 + ";" : [["top", 0], ["left", 0], [NSe, T2]];
      }
      function V5n(u) {
        var o = [], n3 = u.get("fontSize"), p2 = u.getTextColor();
        p2 && o.push("color:" + p2), o.push("font:" + u.getFont()), n3 && o.push("line-height:" + Math.round(n3 * 3 / 2) + "px");
        var m2 = u.get("textShadowColor"), w2 = u.get("textShadowBlur") || 0, T2 = u.get("textShadowOffsetX") || 0, E = u.get("textShadowOffsetY") || 0;
        return m2 && w2 && o.push("text-shadow:" + T2 + "px " + E + "px " + w2 + "px " + m2), Xe2(["decoration", "align"], function(O2) {
          var V3 = u.get(O2);
          V3 && o.push("text-" + O2 + ":" + V3);
        }), o.join(";");
      }
      function B5n(u, o, n3) {
        var p2 = [], m2 = u.get("transitionDuration"), w2 = u.get("backgroundColor"), T2 = u.get("shadowBlur"), E = u.get("shadowColor"), O2 = u.get("shadowOffsetX"), V3 = u.get("shadowOffsetY"), W3 = u.getModel("textStyle"), q3 = z0e(u, "html"), K = O2 + "px " + V3 + "px " + T2 + "px " + E;
        return p2.push("box-shadow:" + K), o && m2 && p2.push(F5n(m2, n3)), w2 && p2.push("background-color:" + w2), Xe2(["width", "color", "radius"], function(J) {
          var rt2 = "border-" + J, gt = Lve(rt2), yt = u.get(gt);
          yt != null && p2.push(rt2 + ":" + yt + (J === "color" ? "" : "px"));
        }), p2.push(V5n(W3)), q3 != null && p2.push("padding:" + $$(q3).join("px ") + "px"), p2.join(";") + ";";
      }
      function BSe(u, o, n3, p2, m2) {
        var w2 = o && o.painter;
        if (n3) {
          var T2 = w2 && w2.getViewportRoot();
          T2 && A1t(u, T2, document.body, p2, m2);
        } else {
          u[0] = p2, u[1] = m2;
          var E = w2 && w2.getViewportRootOffset();
          E && (u[0] += E.offsetLeft, u[1] += E.offsetTop);
        }
        u[2] = u[0] / o.getWidth(), u[3] = u[1] / o.getHeight();
      }
      var z5n = function() {
        function u(o, n3, p2) {
          if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, Ys.wxa)
            return null;
          var m2 = document.createElement("div");
          m2.domBelongToZr = true, this.el = m2;
          var w2 = this._zr = n3.getZr(), T2 = this._appendToBody = p2 && p2.appendToBody;
          BSe(this._styleCoord, w2, T2, n3.getWidth() / 2, n3.getHeight() / 2), T2 ? document.body.appendChild(m2) : o.appendChild(m2), this._container = o;
          var E = this;
          m2.onmouseenter = function() {
            E._enterable && (clearTimeout(E._hideTimeout), E._show = true), E._inContent = true;
          }, m2.onmousemove = function(O2) {
            if (O2 = O2 || window.event, !E._enterable) {
              var V3 = w2.handler, W3 = w2.painter.getViewportRoot();
              ZS(W3, O2, true), V3.dispatch("mousemove", O2);
            }
          }, m2.onmouseleave = function() {
            E._inContent = false, E._enterable && E._show && E.hideLater(E._hideDelay);
          };
        }
        return u.prototype.update = function(o) {
          var n3 = this._container, p2 = P5n(n3, "position"), m2 = n3.style;
          m2.position !== "absolute" && p2 !== "absolute" && (m2.position = "relative");
          var w2 = o.get("alwaysShowContent");
          w2 && this._moveIfResized(), this.el.className = o.get("className") || "";
        }, u.prototype.show = function(o, n3) {
          clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
          var p2 = this.el, m2 = p2.style, w2 = this._styleCoord;
          p2.innerHTML ? m2.cssText = O5n + B5n(o, !this._firstShow, this._longHide) + VSe(w2[0], w2[1], true) + ("border-color:" + Iz(n3) + ";") + (o.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : m2.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
        }, u.prototype.setContent = function(o, n3, p2, m2, w2) {
          var T2 = this.el;
          if (o == null) {
            T2.innerHTML = "";
            return;
          }
          var E = "";
          if (ds(w2) && p2.get("trigger") === "item" && !OSe(p2) && (E = N5n(p2, m2, w2)), ds(o))
            T2.innerHTML = o + E;
          else if (o) {
            T2.innerHTML = "", za2(o) || (o = [o]);
            for (var O2 = 0; O2 < o.length; O2++)
              VB(o[O2]) && o[O2].parentNode !== T2 && T2.appendChild(o[O2]);
            if (E && T2.childNodes.length) {
              var V3 = document.createElement("div");
              V3.innerHTML = E, T2.appendChild(V3);
            }
          }
        }, u.prototype.setEnterable = function(o) {
          this._enterable = o;
        }, u.prototype.getSize = function() {
          var o = this.el;
          return [o.offsetWidth, o.offsetHeight];
        }, u.prototype.moveTo = function(o, n3) {
          var p2 = this._styleCoord;
          if (BSe(p2, this._zr, this._appendToBody, o, n3), p2[0] != null && p2[1] != null) {
            var m2 = this.el.style, w2 = VSe(p2[0], p2[1]);
            Xe2(w2, function(T2) {
              m2[T2[0]] = T2[1];
            });
          }
        }, u.prototype._moveIfResized = function() {
          var o = this._styleCoord[2], n3 = this._styleCoord[3];
          this.moveTo(o * this._zr.getWidth(), n3 * this._zr.getHeight());
        }, u.prototype.hide = function() {
          var o = this, n3 = this.el.style;
          n3.visibility = "hidden", n3.opacity = "0", Ys.transform3dSupported && (n3.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
            return o._longHide = true;
          }, 500);
        }, u.prototype.hideLater = function(o) {
          this._show && !(this._inContent && this._enterable) && (o ? (this._hideDelay = o, this._show = false, this._hideTimeout = setTimeout(Is(this.hide, this), o)) : this.hide());
        }, u.prototype.isShow = function() {
          return this._show;
        }, u.prototype.dispose = function() {
          this.el.parentNode.removeChild(this.el);
        }, u;
      }(), j5n = z5n, W5n = function() {
        function u(o) {
          this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = o.getZr(), jSe(this._styleCoord, this._zr, o.getWidth() / 2, o.getHeight() / 2);
        }
        return u.prototype.update = function(o) {
          var n3 = o.get("alwaysShowContent");
          n3 && this._moveIfResized();
        }, u.prototype.show = function() {
          this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
        }, u.prototype.setContent = function(o, n3, p2, m2, w2) {
          var T2 = this;
          ys(o) && lh2(""), this.el && this._zr.remove(this.el);
          var E = p2.getModel("textStyle");
          this.el = new Zc2({ style: { rich: n3.richTextStyles, text: o, lineHeight: 22, borderWidth: 1, borderColor: m2, textShadowColor: E.get("textShadowColor"), fill: p2.get(["textStyle", "color"]), padding: z0e(p2, "richText"), verticalAlign: "top", align: "left" }, z: p2.get("z") }), Xe2(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(V3) {
            T2.el.style[V3] = p2.get(V3);
          }), Xe2(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(V3) {
            T2.el.style[V3] = E.get(V3) || 0;
          }), this._zr.add(this.el);
          var O2 = this;
          this.el.on("mouseover", function() {
            O2._enterable && (clearTimeout(O2._hideTimeout), O2._show = true), O2._inContent = true;
          }), this.el.on("mouseout", function() {
            O2._enterable && O2._show && O2.hideLater(O2._hideDelay), O2._inContent = false;
          });
        }, u.prototype.setEnterable = function(o) {
          this._enterable = o;
        }, u.prototype.getSize = function() {
          var o = this.el, n3 = this.el.getBoundingRect(), p2 = zSe(o.style);
          return [n3.width + p2.left + p2.right, n3.height + p2.top + p2.bottom];
        }, u.prototype.moveTo = function(o, n3) {
          var p2 = this.el;
          if (p2) {
            var m2 = this._styleCoord;
            jSe(m2, this._zr, o, n3), o = m2[0], n3 = m2[1];
            var w2 = p2.style, T2 = x8(w2.borderWidth || 0), E = zSe(w2);
            p2.x = o + T2 + E.left, p2.y = n3 + T2 + E.top, p2.markRedraw();
          }
        }, u.prototype._moveIfResized = function() {
          var o = this._styleCoord[2], n3 = this._styleCoord[3];
          this.moveTo(o * this._zr.getWidth(), n3 * this._zr.getHeight());
        }, u.prototype.hide = function() {
          this.el && this.el.hide(), this._show = false;
        }, u.prototype.hideLater = function(o) {
          this._show && !(this._inContent && this._enterable) && (o ? (this._hideDelay = o, this._show = false, this._hideTimeout = setTimeout(Is(this.hide, this), o)) : this.hide());
        }, u.prototype.isShow = function() {
          return this._show;
        }, u.prototype.dispose = function() {
          this._zr.remove(this.el);
        }, u;
      }();
      function x8(u) {
        return Math.max(0, u);
      }
      function zSe(u) {
        var o = x8(u.shadowBlur || 0), n3 = x8(u.shadowOffsetX || 0), p2 = x8(u.shadowOffsetY || 0);
        return { left: x8(o - n3), right: x8(o + n3), top: x8(o - p2), bottom: x8(o + p2) };
      }
      function jSe(u, o, n3, p2) {
        u[0] = n3, u[1] = p2, u[2] = u[0] / o.getWidth(), u[3] = u[1] / o.getHeight();
      }
      var G5n = W5n, H5n = new Vf2({ shape: { x: -1, y: -1, width: 2, height: 2 } }), U5n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3, p2) {
          if (!(Ys.node || !p2.getDom())) {
            var m2 = n3.getComponent("tooltip"), w2 = this._renderMode = wat(m2.get("renderMode"));
            this._tooltipContent = w2 === "richText" ? new G5n(p2) : new j5n(p2.getDom(), p2, { appendToBody: m2.get("appendToBody", true) });
          }
        }, o.prototype.render = function(n3, p2, m2) {
          if (!(Ys.node || !m2.getDom())) {
            this.group.removeAll(), this._tooltipModel = n3, this._ecModel = p2, this._api = m2, this._alwaysShowContent = n3.get("alwaysShowContent");
            var w2 = this._tooltipContent;
            w2.update(n3), w2.setEnterable(n3.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && n3.get("transitionDuration") ? nY(this, "_updatePosition", 50, "fixRate") : kot(this, "_updatePosition");
          }
        }, o.prototype._initGlobalListener = function() {
          var n3 = this._tooltipModel, p2 = n3.get("triggerOn");
          qwe("itemTooltip", this._api, Is(function(m2, w2, T2) {
            p2 !== "none" && (p2.indexOf(m2) >= 0 ? this._tryShow(w2, T2) : m2 === "leave" && this._hide(T2));
          }, this));
        }, o.prototype._keepShow = function() {
          var n3 = this._tooltipModel, p2 = this._ecModel, m2 = this._api;
          if (this._lastX != null && this._lastY != null && n3.get("triggerOn") !== "none") {
            var w2 = this;
            clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
              !m2.isDisposed() && w2.manuallyShowTip(n3, p2, m2, { x: w2._lastX, y: w2._lastY, dataByCoordSys: w2._lastDataByCoordSys });
            });
          }
        }, o.prototype.manuallyShowTip = function(n3, p2, m2, w2) {
          if (!(w2.from === this.uid || Ys.node || !m2.getDom())) {
            var T2 = WSe(w2, m2);
            this._ticket = "";
            var E = w2.dataByCoordSys, O2 = Y5n(w2, p2, m2);
            if (O2) {
              var V3 = O2.el.getBoundingRect().clone();
              V3.applyTransform(O2.el.transform), this._tryShow({ offsetX: V3.x + V3.width / 2, offsetY: V3.y + V3.height / 2, target: O2.el, position: w2.position, positionDefault: "bottom" }, T2);
            } else if (w2.tooltip && w2.x != null && w2.y != null) {
              var W3 = H5n;
              W3.x = w2.x, W3.y = w2.y, W3.update(), is(W3).tooltipConfig = { name: null, option: w2.tooltip }, this._tryShow({ offsetX: w2.x, offsetY: w2.y, target: W3 }, T2);
            } else if (E)
              this._tryShow({ offsetX: w2.x, offsetY: w2.y, position: w2.position, dataByCoordSys: E, tooltipOption: w2.tooltipOption }, T2);
            else if (w2.seriesIndex != null) {
              if (this._manuallyAxisShowTip(n3, p2, m2, w2))
                return;
              var q3 = $we(w2, p2), K = q3.point[0], J = q3.point[1];
              K != null && J != null && this._tryShow({ offsetX: K, offsetY: J, target: q3.el, position: w2.position, positionDefault: "bottom" }, T2);
            } else
              w2.x != null && w2.y != null && (m2.dispatchAction({ type: "updateAxisPointer", x: w2.x, y: w2.y }), this._tryShow({ offsetX: w2.x, offsetY: w2.y, position: w2.position, target: m2.getZr().findHover(w2.x, w2.y).target }, T2));
          }
        }, o.prototype.manuallyHideTip = function(n3, p2, m2, w2) {
          var T2 = this._tooltipContent;
          !this._alwaysShowContent && this._tooltipModel && T2.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, w2.from !== this.uid && this._hide(WSe(w2, m2));
        }, o.prototype._manuallyAxisShowTip = function(n3, p2, m2, w2) {
          var T2 = w2.seriesIndex, E = w2.dataIndex, O2 = p2.getComponent("axisPointer").coordSysAxesInfo;
          if (!(T2 == null || E == null || O2 == null)) {
            var V3 = p2.getSeriesByIndex(T2);
            if (V3) {
              var W3 = V3.getData(), q3 = Ast([W3.getItemModel(E), V3, (V3.coordinateSystem || {}).model], this._tooltipModel);
              if (q3.get("trigger") === "axis")
                return m2.dispatchAction({ type: "updateAxisPointer", seriesIndex: T2, dataIndex: E, position: w2.position }), true;
            }
          }
        }, o.prototype._tryShow = function(n3, p2) {
          var m2 = n3.target, w2 = this._tooltipModel;
          if (w2) {
            this._lastX = n3.offsetX, this._lastY = n3.offsetY;
            var T2 = n3.dataByCoordSys;
            if (T2 && T2.length)
              this._showAxisTooltip(T2, n3);
            else if (m2) {
              this._lastDataByCoordSys = null;
              var E, O2;
              iY(m2, function(V3) {
                if (is(V3).dataIndex != null)
                  return E = V3, true;
                if (is(V3).tooltipConfig != null)
                  return O2 = V3, true;
              }, true), E ? this._showSeriesItemTooltip(n3, E, p2) : O2 ? this._showComponentItemTooltip(n3, O2, p2) : this._hide(p2);
            } else
              this._lastDataByCoordSys = null, this._hide(p2);
          }
        }, o.prototype._showOrMove = function(n3, p2) {
          var m2 = n3.get("showDelay");
          p2 = Is(p2, this), clearTimeout(this._showTimout), m2 > 0 ? this._showTimout = setTimeout(p2, m2) : p2();
        }, o.prototype._showAxisTooltip = function(n3, p2) {
          var m2 = this._ecModel, w2 = this._tooltipModel, T2 = [p2.offsetX, p2.offsetY], E = Ast([p2.tooltipOption], w2), O2 = this._renderMode, V3 = [], W3 = k1("section", { blocks: [], noHeader: true }), q3 = [], K = new A8t();
          Xe2(n3, function(Lt) {
            Xe2(Lt.dataByAxis, function(Wt) {
              var Nt = m2.getComponent(Wt.axisDim + "Axis", Wt.axisIndex), ue2 = Wt.value;
              if (!(!Nt || ue2 == null)) {
                var ie2 = zwe(ue2, Nt.axis, m2, Wt.seriesDataIndices, Wt.valueLabelOpt), pe2 = k1("section", { header: ie2, noHeader: !US(ie2), sortBlocks: true, blocks: [] });
                W3.blocks.push(pe2), Xe2(Wt.seriesDataIndices, function(xe) {
                  var Ce2 = m2.getSeriesByIndex(xe.seriesIndex), Le2 = xe.dataIndexInside, ze = Ce2.getDataParams(Le2);
                  if (!(ze.dataIndex < 0)) {
                    ze.axisDim = Wt.axisDim, ze.axisIndex = Wt.axisIndex, ze.axisType = Wt.axisType, ze.axisId = Wt.axisId, ze.axisValue = c9t(Nt.axis, { value: ue2 }), ze.axisValueLabel = ie2, ze.marker = K.makeTooltipMarker("item", Iz(ze.color), O2);
                    var tn = _0e(Ce2.formatTooltip(Le2, true, null)), $e2 = tn.frag;
                    if ($e2) {
                      var Tn = Ast([Ce2], w2).get("valueFormatter");
                      pe2.blocks.push(Tn ? ua2({ valueFormatter: Tn }, $e2) : $e2);
                    }
                    tn.text && q3.push(tn.text), V3.push(ze);
                  }
                });
              }
            });
          }), W3.blocks.reverse(), q3.reverse();
          var J = p2.position, rt2 = E.get("order"), gt = F0e(W3, K, O2, rt2, m2.get("useUTC"), E.get("textStyle"));
          gt && q3.unshift(gt);
          var yt = O2 === "richText" ? `

` : "<br/>", At = q3.join(yt);
          this._showOrMove(E, function() {
            this._updateContentNotChangedOnAxis(n3, V3) ? this._updatePosition(E, J, T2[0], T2[1], this._tooltipContent, V3) : this._showTooltipContent(E, At, V3, Math.random() + "", T2[0], T2[1], J, null, K);
          });
        }, o.prototype._showSeriesItemTooltip = function(n3, p2, m2) {
          var w2 = this._ecModel, T2 = is(p2), E = T2.seriesIndex, O2 = w2.getSeriesByIndex(E), V3 = T2.dataModel || O2, W3 = T2.dataIndex, q3 = T2.dataType, K = V3.getData(q3), J = this._renderMode, rt2 = n3.positionDefault, gt = Ast([K.getItemModel(W3), V3, O2 && (O2.coordinateSystem || {}).model], this._tooltipModel, rt2 ? { position: rt2 } : null), yt = gt.get("trigger");
          if (!(yt != null && yt !== "item")) {
            var At = V3.getDataParams(W3, q3), Lt = new A8t();
            At.marker = Lt.makeTooltipMarker("item", Iz(At.color), J);
            var Wt = _0e(V3.formatTooltip(W3, false, q3)), Nt = gt.get("order"), ue2 = gt.get("valueFormatter"), ie2 = Wt.frag, pe2 = ie2 ? F0e(ue2 ? ua2({ valueFormatter: ue2 }, ie2) : ie2, Lt, J, Nt, w2.get("useUTC"), gt.get("textStyle")) : Wt.text, xe = "item_" + V3.name + "_" + W3;
            this._showOrMove(gt, function() {
              this._showTooltipContent(gt, pe2, At, xe, n3.offsetX, n3.offsetY, n3.position, n3.target, Lt);
            }), m2({ type: "showTip", dataIndexInside: W3, dataIndex: K.getRawIndex(W3), seriesIndex: E, from: this.uid });
          }
        }, o.prototype._showComponentItemTooltip = function(n3, p2, m2) {
          var w2 = is(p2), T2 = w2.tooltipConfig, E = T2.option || {};
          if (ds(E)) {
            var O2 = E;
            E = { content: O2, formatter: O2 };
          }
          var V3 = [E], W3 = this._ecModel.getComponent(w2.componentMainType, w2.componentIndex);
          W3 && V3.push(W3), V3.push({ formatter: E.content });
          var q3 = n3.positionDefault, K = Ast(V3, this._tooltipModel, q3 ? { position: q3 } : null), J = K.get("content"), rt2 = Math.random() + "", gt = new A8t();
          this._showOrMove(K, function() {
            var yt = jl(K.get("formatterParams") || {});
            this._showTooltipContent(K, J, yt, rt2, n3.offsetX, n3.offsetY, n3.position, p2, gt);
          }), m2({ type: "showTip", from: this.uid });
        }, o.prototype._showTooltipContent = function(n3, p2, m2, w2, T2, E, O2, V3, W3) {
          if (this._ticket = "", !(!n3.get("showContent") || !n3.get("show"))) {
            var q3 = this._tooltipContent;
            q3.setEnterable(n3.get("enterable"));
            var K = n3.get("formatter");
            O2 = O2 || n3.get("position");
            var J = p2, rt2 = this._getNearestPoint([T2, E], m2, n3.get("trigger"), n3.get("borderColor")), gt = rt2.color;
            if (K)
              if (ds(K)) {
                var yt = n3.ecModel.get("useUTC"), At = za2(m2) ? m2[0] : m2, Lt = At && At.axisType && At.axisType.indexOf("time") >= 0;
                J = K, Lt && (J = k_t(At.axisValue, J, yt)), J = Rve(J, m2, true);
              } else if (Sl(K)) {
                var Wt = Is(function(Nt, ue2) {
                  Nt === this._ticket && (q3.setContent(ue2, W3, n3, gt, O2), this._updatePosition(n3, O2, T2, E, q3, m2, V3));
                }, this);
                this._ticket = w2, J = K(m2, w2, Wt);
              } else
                J = K;
            q3.setContent(J, W3, n3, gt, O2), q3.show(n3, gt), this._updatePosition(n3, O2, T2, E, q3, m2, V3);
          }
        }, o.prototype._getNearestPoint = function(n3, p2, m2, w2) {
          if (m2 === "axis" || za2(p2))
            return { color: w2 || (this._renderMode === "html" ? "#fff" : "none") };
          if (!za2(p2))
            return { color: w2 || p2.color || p2.borderColor };
        }, o.prototype._updatePosition = function(n3, p2, m2, w2, T2, E, O2) {
          var V3 = this._api.getWidth(), W3 = this._api.getHeight();
          p2 = p2 || n3.get("position");
          var q3 = T2.getSize(), K = n3.get("align"), J = n3.get("verticalAlign"), rt2 = O2 && O2.getBoundingRect().clone();
          if (O2 && rt2.applyTransform(O2.transform), Sl(p2) && (p2 = p2([m2, w2], E, T2.el, rt2, { viewSize: [V3, W3], contentSize: q3.slice() })), za2(p2))
            m2 = Qo(p2[0], V3), w2 = Qo(p2[1], W3);
          else if (ys(p2)) {
            var gt = p2;
            gt.width = q3[0], gt.height = q3[1];
            var yt = Bm(gt, { width: V3, height: W3 });
            m2 = yt.x, w2 = yt.y, K = null, J = null;
          } else if (ds(p2) && O2) {
            var At = $5n(p2, rt2, q3, n3.get("borderWidth"));
            m2 = At[0], w2 = At[1];
          } else {
            var At = q5n(m2, w2, T2, V3, W3, K ? null : 20, J ? null : 20);
            m2 = At[0], w2 = At[1];
          }
          if (K && (m2 -= GSe(K) ? q3[0] / 2 : K === "right" ? q3[0] : 0), J && (w2 -= GSe(J) ? q3[1] / 2 : J === "bottom" ? q3[1] : 0), OSe(n3)) {
            var At = Z5n(m2, w2, T2, V3, W3);
            m2 = At[0], w2 = At[1];
          }
          T2.moveTo(m2, w2);
        }, o.prototype._updateContentNotChangedOnAxis = function(n3, p2) {
          var m2 = this._lastDataByCoordSys, w2 = this._cbParamsList, T2 = !!m2 && m2.length === n3.length;
          return T2 && Xe2(m2, function(E, O2) {
            var V3 = E.dataByAxis || [], W3 = n3[O2] || {}, q3 = W3.dataByAxis || [];
            T2 = T2 && V3.length === q3.length, T2 && Xe2(V3, function(K, J) {
              var rt2 = q3[J] || {}, gt = K.seriesDataIndices || [], yt = rt2.seriesDataIndices || [];
              T2 = T2 && K.value === rt2.value && K.axisType === rt2.axisType && K.axisId === rt2.axisId && gt.length === yt.length, T2 && Xe2(gt, function(At, Lt) {
                var Wt = yt[Lt];
                T2 = T2 && At.seriesIndex === Wt.seriesIndex && At.dataIndex === Wt.dataIndex;
              }), w2 && Xe2(K.seriesDataIndices, function(At) {
                var Lt = At.seriesIndex, Wt = p2[Lt], Nt = w2[Lt];
                Wt && Nt && Nt.data !== Wt.data && (T2 = false);
              });
            });
          }), this._lastDataByCoordSys = n3, this._cbParamsList = p2, !!T2;
        }, o.prototype._hide = function(n3) {
          this._lastDataByCoordSys = null, n3({ type: "hideTip", from: this.uid });
        }, o.prototype.dispose = function(n3, p2) {
          Ys.node || !p2.getDom() || (kot(this, "_updatePosition"), this._tooltipContent.dispose(), _Vt("itemTooltip", p2));
        }, o.type = "tooltip", o;
      }(C0);
      function Ast(u, o, n3) {
        var p2 = o.ecModel, m2;
        n3 ? (m2 = new _g(n3, p2, p2), m2 = new _g(o.option, m2, p2)) : m2 = o;
        for (var w2 = u.length - 1; w2 >= 0; w2--) {
          var T2 = u[w2];
          T2 && (T2 instanceof _g && (T2 = T2.get("tooltip", true)), ds(T2) && (T2 = { formatter: T2 }), T2 && (m2 = new _g(T2, m2, p2)));
        }
        return m2;
      }
      function WSe(u, o) {
        return u.dispatchAction || Is(o.dispatchAction, o);
      }
      function q5n(u, o, n3, p2, m2, w2, T2) {
        var E = n3.getSize(), O2 = E[0], V3 = E[1];
        return w2 != null && (u + O2 + w2 + 2 > p2 ? u -= O2 + w2 : u += w2), T2 != null && (o + V3 + T2 > m2 ? o -= V3 + T2 : o += T2), [u, o];
      }
      function Z5n(u, o, n3, p2, m2) {
        var w2 = n3.getSize(), T2 = w2[0], E = w2[1];
        return u = Math.min(u + T2, p2) - T2, o = Math.min(o + E, m2) - E, u = Math.max(u, 0), o = Math.max(o, 0), [u, o];
      }
      function $5n(u, o, n3, p2) {
        var m2 = n3[0], w2 = n3[1], T2 = Math.ceil(Math.SQRT2 * p2) + 8, E = 0, O2 = 0, V3 = o.width, W3 = o.height;
        switch (u) {
          case "inside":
            E = o.x + V3 / 2 - m2 / 2, O2 = o.y + W3 / 2 - w2 / 2;
            break;
          case "top":
            E = o.x + V3 / 2 - m2 / 2, O2 = o.y - w2 - T2;
            break;
          case "bottom":
            E = o.x + V3 / 2 - m2 / 2, O2 = o.y + W3 + T2;
            break;
          case "left":
            E = o.x - m2 - T2, O2 = o.y + W3 / 2 - w2 / 2;
            break;
          case "right":
            E = o.x + V3 + T2, O2 = o.y + W3 / 2 - w2 / 2;
        }
        return [E, O2];
      }
      function GSe(u) {
        return u === "center" || u === "middle";
      }
      function Y5n(u, o, n3) {
        var p2 = _at(u).queryOptionMap, m2 = p2.keys()[0];
        if (!(!m2 || m2 === "series")) {
          var w2 = qF(o, m2, p2.get(m2), { useDefault: false, enableAll: false, enableNone: false }), T2 = w2.models[0];
          if (T2) {
            var E = n3.getViewOfComponentModel(T2), O2;
            if (E.group.traverse(function(V3) {
              var W3 = is(V3).tooltipConfig;
              if (W3 && W3.name === u.name)
                return O2 = V3, true;
            }), O2)
              return { componentMainType: m2, componentIndex: T2.componentIndex, el: O2 };
          }
        }
      }
      var K5n = U5n;
      function X5n(u) {
        Rc2(Cst), u.registerComponentModel(E5n), u.registerComponentView(K5n), u.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, Jp), u.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, Jp);
      }
      var Q5n = ["rect", "polygon", "keep", "clear"];
      function J5n(u, o) {
        var n3 = Tp(u ? u.brush : []);
        if (n3.length) {
          var p2 = [];
          Xe2(n3, function(O2) {
            var V3 = O2.hasOwnProperty("toolbox") ? O2.toolbox : [];
            V3 instanceof Array && (p2 = p2.concat(V3));
          });
          var m2 = u && u.toolbox;
          za2(m2) && (m2 = m2[0]), m2 || (m2 = { feature: {} }, u.toolbox = [m2]);
          var w2 = m2.feature || (m2.feature = {}), T2 = w2.brush || (w2.brush = {}), E = T2.type || (T2.type = []);
          E.push.apply(E, p2), tPn(E), o && !E.length && E.push.apply(E, Q5n);
        }
      }
      function tPn(u) {
        var o = {};
        Xe2(u, function(n3) {
          o[n3] = 1;
        }), u.length = 0, Xe2(o, function(n3, p2) {
          u.push(p2);
        });
      }
      var HSe = Xe2;
      function USe(u) {
        if (u) {
          for (var o in u)
            if (u.hasOwnProperty(o))
              return true;
        }
      }
      function zVt(u, o, n3) {
        var p2 = {};
        return HSe(o, function(w2) {
          var T2 = p2[w2] = m2();
          HSe(u[w2], function(E, O2) {
            if (ix.isValidType(O2)) {
              var V3 = { type: O2, visual: E };
              n3 && n3(V3, w2), T2[O2] = new ix(V3), O2 === "opacity" && (V3 = jl(V3), V3.type = "colorAlpha", T2.__hidden.__alphaForOpacity = new ix(V3));
            }
          });
        }), p2;
        function m2() {
          var w2 = function() {
          };
          w2.prototype.__hidden = w2.prototype;
          var T2 = new w2();
          return T2;
        }
      }
      function qSe(u, o, n3) {
        var p2;
        Xe2(n3, function(m2) {
          o.hasOwnProperty(m2) && USe(o[m2]) && (p2 = true);
        }), p2 && Xe2(n3, function(m2) {
          o.hasOwnProperty(m2) && USe(o[m2]) ? u[m2] = jl(o[m2]) : delete u[m2];
        });
      }
      function ePn(u, o, n3, p2, m2, w2) {
        var T2 = {};
        Xe2(u, function(q3) {
          var K = ix.prepareVisualTypes(o[q3]);
          T2[q3] = K;
        });
        var E;
        function O2(q3) {
          return L8t(n3, E, q3);
        }
        function V3(q3, K) {
          lye(n3, E, q3, K);
        }
        w2 == null ? n3.each(W3) : n3.each([w2], W3);
        function W3(q3, K) {
          E = w2 == null ? q3 : K;
          var J = n3.getRawDataItem(E);
          if (!(J && J.visualMap === false))
            for (var rt2 = p2.call(m2, q3), gt = o[rt2], yt = T2[rt2], At = 0, Lt = yt.length; At < Lt; At++) {
              var Wt = yt[At];
              gt[Wt] && gt[Wt].applyVisual(q3, O2, V3);
            }
        }
      }
      function nPn(u, o, n3, p2) {
        var m2 = {};
        return Xe2(u, function(w2) {
          var T2 = ix.prepareVisualTypes(o[w2]);
          m2[w2] = T2;
        }), { progress: function(w2, T2) {
          var E;
          p2 != null && (E = T2.getDimensionIndex(p2));
          function O2(Nt) {
            return L8t(T2, W3, Nt);
          }
          function V3(Nt, ue2) {
            lye(T2, W3, Nt, ue2);
          }
          for (var W3, q3 = T2.getStore(); (W3 = w2.next()) != null; ) {
            var K = T2.getRawDataItem(W3);
            if (!(K && K.visualMap === false))
              for (var J = p2 != null ? q3.get(E, W3) : W3, rt2 = n3(J), gt = o[rt2], yt = m2[rt2], At = 0, Lt = yt.length; At < Lt; At++) {
                var Wt = yt[At];
                gt[Wt] && gt[Wt].applyVisual(J, O2, V3);
              }
          }
        } };
      }
      function rPn(u) {
        var o = u.brushType, n3 = { point: function(p2) {
          return ZSe[o].point(p2, n3, u);
        }, rect: function(p2) {
          return ZSe[o].rect(p2, n3, u);
        } };
        return n3;
      }
      var ZSe = { lineX: $Se(0), lineY: $Se(1), rect: { point: function(u, o, n3) {
        return u && n3.boundingRect.contain(u[0], u[1]);
      }, rect: function(u, o, n3) {
        return u && n3.boundingRect.intersect(u);
      } }, polygon: { point: function(u, o, n3) {
        return u && n3.boundingRect.contain(u[0], u[1]) && Fz(n3.range, u[0], u[1]);
      }, rect: function(u, o, n3) {
        var p2 = n3.range;
        if (!u || p2.length <= 1)
          return false;
        var m2 = u.x, w2 = u.y, T2 = u.width, E = u.height, O2 = p2[0];
        if (Fz(p2, m2, w2) || Fz(p2, m2 + T2, w2) || Fz(p2, m2, w2 + E) || Fz(p2, m2 + T2, w2 + E) || Qu.create(u).contain(O2[0], O2[1]) || nx(m2, w2, m2 + T2, w2, p2) || nx(m2, w2, m2, w2 + E, p2) || nx(m2 + T2, w2, m2 + T2, w2 + E, p2) || nx(m2, w2 + E, m2 + T2, w2 + E, p2))
          return true;
      } } };
      function $Se(u) {
        var o = ["x", "y"], n3 = ["width", "height"];
        return { point: function(p2, m2, w2) {
          if (p2) {
            var T2 = w2.range, E = p2[u];
            return Ist(E, T2);
          }
        }, rect: function(p2, m2, w2) {
          if (p2) {
            var T2 = w2.range, E = [p2[o[u]], p2[o[u]] + p2[n3[u]]];
            return E[1] < E[0] && E.reverse(), Ist(E[0], T2) || Ist(E[1], T2) || Ist(T2[0], E) || Ist(T2[1], E);
          }
        } };
      }
      function Ist(u, o) {
        return o[0] <= u && u <= o[1];
      }
      var YSe = ["inBrush", "outOfBrush"], jVt = "__ecBrushSelect", WVt = "__ecInBrushSelectEvent";
      function KSe(u) {
        u.eachComponent({ mainType: "brush" }, function(o) {
          var n3 = o.brushTargetManager = new NVt(o.option, u);
          n3.setInputRanges(o.areas, u);
        });
      }
      function iPn(u, o, n3) {
        var p2 = [], m2, w2;
        u.eachComponent({ mainType: "brush" }, function(T2) {
          n3 && n3.type === "takeGlobalCursor" && T2.setBrushOption(n3.key === "brush" ? n3.brushOption : { brushType: false });
        }), KSe(u), u.eachComponent({ mainType: "brush" }, function(T2, E) {
          var O2 = { brushId: T2.id, brushIndex: E, brushName: T2.name, areas: jl(T2.areas), selected: [] };
          p2.push(O2);
          var V3 = T2.option, W3 = V3.brushLink, q3 = [], K = [], J = [], rt2 = false;
          E || (m2 = V3.throttleType, w2 = V3.throttleDelay);
          var gt = Ya2(T2.areas, function(ue2) {
            var ie2 = lPn[ue2.brushType], pe2 = kl({ boundingRect: ie2 ? ie2(ue2) : void 0 }, ue2);
            return pe2.selectors = rPn(pe2), pe2;
          }), yt = zVt(T2.option, YSe, function(ue2) {
            ue2.mappingMethod = "fixed";
          });
          za2(W3) && Xe2(W3, function(ue2) {
            q3[ue2] = 1;
          });
          function At(ue2) {
            return W3 === "all" || !!q3[ue2];
          }
          function Lt(ue2) {
            return !!ue2.length;
          }
          u.eachSeries(function(ue2, ie2) {
            var pe2 = J[ie2] = [];
            ue2.subType === "parallel" ? Wt(ue2, ie2) : Nt(ue2, ie2, pe2);
          });
          function Wt(ue2, ie2) {
            var pe2 = ue2.coordinateSystem;
            rt2 = rt2 || pe2.hasAxisBrushed(), At(ie2) && pe2.eachActiveState(ue2.getData(), function(xe, Ce2) {
              xe === "active" && (K[Ce2] = 1);
            });
          }
          function Nt(ue2, ie2, pe2) {
            if (!(!ue2.brushSelector || sPn(T2, ie2)) && (Xe2(gt, function(Ce2) {
              T2.brushTargetManager.controlSeries(Ce2, ue2, u) && pe2.push(Ce2), rt2 = rt2 || Lt(pe2);
            }), At(ie2) && Lt(pe2))) {
              var xe = ue2.getData();
              xe.each(function(Ce2) {
                XSe(ue2, pe2, xe, Ce2) && (K[Ce2] = 1);
              });
            }
          }
          u.eachSeries(function(ue2, ie2) {
            var pe2 = { seriesId: ue2.id, seriesIndex: ie2, seriesName: ue2.name, dataIndex: [] };
            O2.selected.push(pe2);
            var xe = J[ie2], Ce2 = ue2.getData(), Le2 = At(ie2) ? function(ze) {
              return K[ze] ? (pe2.dataIndex.push(Ce2.getRawIndex(ze)), "inBrush") : "outOfBrush";
            } : function(ze) {
              return XSe(ue2, xe, Ce2, ze) ? (pe2.dataIndex.push(Ce2.getRawIndex(ze)), "inBrush") : "outOfBrush";
            };
            (At(ie2) ? rt2 : Lt(xe)) && ePn(YSe, yt, Ce2, Le2);
          });
        }), aPn(o, m2, w2, p2, n3);
      }
      function aPn(u, o, n3, p2, m2) {
        if (m2) {
          var w2 = u.getZr();
          if (!w2[WVt]) {
            w2[jVt] || (w2[jVt] = oPn);
            var T2 = nY(w2, jVt, n3, o);
            T2(u, p2);
          }
        }
      }
      function oPn(u, o) {
        if (!u.isDisposed()) {
          var n3 = u.getZr();
          n3[WVt] = true, u.dispatchAction({ type: "brushSelect", batch: o }), n3[WVt] = false;
        }
      }
      function XSe(u, o, n3, p2) {
        for (var m2 = 0, w2 = o.length; m2 < w2; m2++) {
          var T2 = o[m2];
          if (u.brushSelector(p2, n3, T2.selectors, T2))
            return true;
        }
      }
      function sPn(u, o) {
        var n3 = u.option.seriesIndex;
        return n3 != null && n3 !== "all" && (za2(n3) ? sc2(n3, o) < 0 : o !== n3);
      }
      var lPn = { rect: function(u) {
        return QSe(u.range);
      }, polygon: function(u) {
        for (var o, n3 = u.range, p2 = 0, m2 = n3.length; p2 < m2; p2++) {
          o = o || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
          var w2 = n3[p2];
          w2[0] < o[0][0] && (o[0][0] = w2[0]), w2[0] > o[0][1] && (o[0][1] = w2[0]), w2[1] < o[1][0] && (o[1][0] = w2[1]), w2[1] > o[1][1] && (o[1][1] = w2[1]);
        }
        return o && QSe(o);
      } };
      function QSe(u) {
        return new Qu(u[0][0], u[1][0], u[0][1] - u[0][0], u[1][1] - u[1][0]);
      }
      var uPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3, p2) {
          this.ecModel = n3, this.api = p2, this.model, (this._brushController = new q7t(p2.getZr())).on("brush", Is(this._onBrush, this)).mount();
        }, o.prototype.render = function(n3, p2, m2, w2) {
          this.model = n3, this._updateController(n3, p2, m2, w2);
        }, o.prototype.updateTransform = function(n3, p2, m2, w2) {
          KSe(p2), this._updateController(n3, p2, m2, w2);
        }, o.prototype.updateVisual = function(n3, p2, m2, w2) {
          this.updateTransform(n3, p2, m2, w2);
        }, o.prototype.updateView = function(n3, p2, m2, w2) {
          this._updateController(n3, p2, m2, w2);
        }, o.prototype._updateController = function(n3, p2, m2, w2) {
          (!w2 || w2.$from !== n3.id) && this._brushController.setPanels(n3.brushTargetManager.makePanelOpts(m2)).enableBrush(n3.brushOption).updateCovers(n3.areas.slice());
        }, o.prototype.dispose = function() {
          this._brushController.dispose();
        }, o.prototype._onBrush = function(n3) {
          var p2 = this.model.id, m2 = this.model.brushTargetManager.setOutputRanges(n3.areas, this.ecModel);
          (!n3.isEnd || n3.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: p2, areas: jl(m2), $from: p2 }), n3.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: p2, areas: jl(m2), $from: p2 });
        }, o.type = "brush", o;
      }(C0), cPn = uPn, fPn = "#ddd", hPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.areas = [], n3.brushOption = {}, n3;
        }
        return o.prototype.optionUpdated = function(n3, p2) {
          var m2 = this.option;
          !p2 && qSe(m2, n3, ["inBrush", "outOfBrush"]);
          var w2 = m2.inBrush = m2.inBrush || {};
          m2.outOfBrush = m2.outOfBrush || { color: fPn }, w2.hasOwnProperty("liftZ") || (w2.liftZ = 5);
        }, o.prototype.setAreas = function(n3) {
          !n3 || (this.areas = Ya2(n3, function(p2) {
            return JSe(this.option, p2);
          }, this));
        }, o.prototype.setBrushOption = function(n3) {
          this.brushOption = JSe(this.option, n3), this.brushType = this.brushOption.brushType;
        }, o.type = "brush", o.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], o.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, o;
      }(kh2);
      function JSe(u, o) {
        return Cu({ brushType: u.brushType, brushMode: u.brushMode, transformable: u.transformable, brushStyle: new _g(u.brushStyle).getItemStyle(), removeOnClick: u.removeOnClick, z: u.z }, o, true);
      }
      var pPn = hPn, dPn = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], gPn = function(u) {
        tr(o, u);
        function o() {
          return u !== null && u.apply(this, arguments) || this;
        }
        return o.prototype.render = function(n3, p2, m2) {
          var w2, T2, E;
          p2.eachComponent({ mainType: "brush" }, function(O2) {
            w2 = O2.brushType, T2 = O2.brushOption.brushMode || "single", E = E || !!O2.areas.length;
          }), this._brushType = w2, this._brushMode = T2, Xe2(n3.get("type", true), function(O2) {
            n3.setIconStatus(O2, (O2 === "keep" ? T2 === "multiple" : O2 === "clear" ? E : O2 === w2) ? "emphasis" : "normal");
          });
        }, o.prototype.updateView = function(n3, p2, m2) {
          this.render(n3, p2, m2);
        }, o.prototype.getIcons = function() {
          var n3 = this.model, p2 = n3.get("icon", true), m2 = {};
          return Xe2(n3.get("type", true), function(w2) {
            p2[w2] && (m2[w2] = p2[w2]);
          }), m2;
        }, o.prototype.onclick = function(n3, p2, m2) {
          var w2 = this._brushType, T2 = this._brushMode;
          m2 === "clear" ? (p2.dispatchAction({ type: "axisAreaSelect", intervals: [] }), p2.dispatchAction({ type: "brush", command: "clear", areas: [] })) : p2.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: m2 === "keep" ? w2 : w2 === m2 ? false : m2, brushMode: m2 === "keep" ? T2 === "multiple" ? "single" : "multiple" : T2 } });
        }, o.getDefaultOption = function(n3) {
          var p2 = { show: true, type: dPn.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: n3.getLocaleModel().get(["toolbox", "brush", "title"]) };
          return p2;
        }, o;
      }(xI), vPn = gPn;
      function yPn(u) {
        u.registerComponentView(cPn), u.registerComponentModel(pPn), u.registerPreprocessor(J5n), u.registerVisual(u.PRIORITY.VISUAL.BRUSH, iPn), u.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(o, n3) {
          n3.eachComponent({ mainType: "brush", query: o }, function(p2) {
            p2.setAreas(o.areas);
          });
        }), u.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, Jp), u.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, Jp), MY("brush", vPn);
      }
      var mPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.layoutMode = { type: "box", ignoreSize: true }, n3;
        }
        return o.type = "title", o.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, o;
      }(kh2), bPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          if (this.group.removeAll(), !!n3.get("show")) {
            var w2 = this.group, T2 = n3.getModel("textStyle"), E = n3.getModel("subtextStyle"), O2 = n3.get("textAlign"), V3 = Xu(n3.get("textBaseline"), n3.get("textVerticalAlign")), W3 = new Zc2({ style: Cy(T2, { text: n3.get("text"), fill: T2.getTextColor() }, { disableBox: true }), z2: 10 }), q3 = W3.getBoundingRect(), K = n3.get("subtext"), J = new Zc2({ style: Cy(E, { text: K, fill: E.getTextColor(), y: q3.height + n3.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), rt2 = n3.get("link"), gt = n3.get("sublink"), yt = n3.get("triggerEvent", true);
            W3.silent = !rt2 && !yt, J.silent = !gt && !yt, rt2 && W3.on("click", function() {
              N_t(rt2, "_" + n3.get("target"));
            }), gt && J.on("click", function() {
              N_t(gt, "_" + n3.get("subtarget"));
            }), is(W3).eventData = is(J).eventData = yt ? { componentType: "title", componentIndex: n3.componentIndex } : null, w2.add(W3), K && w2.add(J);
            var At = w2.getBoundingRect(), Lt = n3.getBoxLayoutParams();
            Lt.width = At.width, Lt.height = At.height;
            var Wt = Bm(Lt, { width: m2.getWidth(), height: m2.getHeight() }, n3.get("padding"));
            O2 || (O2 = n3.get("left") || n3.get("right"), O2 === "middle" && (O2 = "center"), O2 === "right" ? Wt.x += Wt.width : O2 === "center" && (Wt.x += Wt.width / 2)), V3 || (V3 = n3.get("top") || n3.get("bottom"), V3 === "center" && (V3 = "middle"), V3 === "bottom" ? Wt.y += Wt.height : V3 === "middle" && (Wt.y += Wt.height / 2), V3 = V3 || "top"), w2.x = Wt.x, w2.y = Wt.y, w2.markRedraw();
            var Nt = { align: O2, verticalAlign: V3 };
            W3.setStyle(Nt), J.setStyle(Nt), At = w2.getBoundingRect();
            var ue2 = Wt.margin, ie2 = n3.getItemStyle(["color", "opacity"]);
            ie2.fill = n3.get("backgroundColor");
            var pe2 = new Vf2({ shape: { x: At.x - ue2[3], y: At.y - ue2[0], width: At.width + ue2[1] + ue2[3], height: At.height + ue2[0] + ue2[2], r: n3.get("borderRadius") }, style: ie2, subPixelOptimize: true, silent: true });
            w2.add(pe2);
          }
        }, o.type = "title", o;
      }(C0);
      function _Pn(u) {
        u.registerComponentModel(mPn), u.registerComponentView(bPn);
      }
      var xPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.layoutMode = "box", n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          this.mergeDefaultAndTheme(n3, m2), this._initData();
        }, o.prototype.mergeOption = function(n3) {
          u.prototype.mergeOption.apply(this, arguments), this._initData();
        }, o.prototype.setCurrentIndex = function(n3) {
          n3 == null && (n3 = this.option.currentIndex);
          var p2 = this._data.count();
          this.option.loop ? n3 = (n3 % p2 + p2) % p2 : (n3 >= p2 && (n3 = p2 - 1), n3 < 0 && (n3 = 0)), this.option.currentIndex = n3;
        }, o.prototype.getCurrentIndex = function() {
          return this.option.currentIndex;
        }, o.prototype.isIndexMax = function() {
          return this.getCurrentIndex() >= this._data.count() - 1;
        }, o.prototype.setPlayState = function(n3) {
          this.option.autoPlay = !!n3;
        }, o.prototype.getPlayState = function() {
          return !!this.option.autoPlay;
        }, o.prototype._initData = function() {
          var n3 = this.option, p2 = n3.data || [], m2 = n3.axisType, w2 = this._names = [], T2;
          m2 === "category" ? (T2 = [], Xe2(p2, function(V3, W3) {
            var q3 = $d2(PP(V3), ""), K;
            ys(V3) ? (K = jl(V3), K.value = W3) : K = W3, T2.push(K), w2.push(q3);
          })) : T2 = p2;
          var E = { category: "ordinal", time: "time", value: "number" }[m2] || "number", O2 = this._data = new o2([{ name: "value", type: E }], this);
          O2.initData(T2, w2);
        }, o.prototype.getData = function() {
          return this._data;
        }, o.prototype.getCategories = function() {
          if (this.get("axisType") === "category")
            return this._names.slice();
        }, o.type = "timeline", o.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, o;
      }(kh2), t2e = xPn, e2e = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "timeline.slider", o.defaultOption = r8(t2e.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), o;
      }(t2e);
      x0(e2e, x8t.prototype);
      var wPn = e2e, SPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "timeline", o;
      }(C0), MPn = SPn, CPn = function(u) {
        tr(o, u);
        function o(n3, p2, m2, w2) {
          var T2 = u.call(this, n3, p2, m2) || this;
          return T2.type = w2 || "value", T2;
        }
        return o.prototype.getLabelModel = function() {
          return this.model.getModel("label");
        }, o.prototype.isHorizontal = function() {
          return this.model.get("orient") === "horizontal";
        }, o;
      }(ak2), TPn = CPn, GVt = Math.PI, n2e = Ff2(), APn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function(n3, p2) {
          this.api = p2;
        }, o.prototype.render = function(n3, p2, m2) {
          if (this.model = n3, this.api = m2, this.ecModel = p2, this.group.removeAll(), n3.get("show", true)) {
            var w2 = this._layout(n3, m2), T2 = this._createGroup("_mainGroup"), E = this._createGroup("_labelGroup"), O2 = this._axis = this._createAxis(w2, n3);
            n3.formatTooltip = function(V3) {
              var W3 = O2.scale.getLabel({ value: V3 });
              return k1("nameValue", { noName: true, value: W3 });
            }, Xe2(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(V3) {
              this["_render" + V3](w2, T2, O2, n3);
            }, this), this._renderAxisLabel(w2, E, O2, n3), this._position(w2, n3);
          }
          this._doPlayStop(), this._updateTicksStatus();
        }, o.prototype.remove = function() {
          this._clearTimer(), this.group.removeAll();
        }, o.prototype.dispose = function() {
          this._clearTimer();
        }, o.prototype._layout = function(n3, p2) {
          var m2 = n3.get(["label", "position"]), w2 = n3.get("orient"), T2 = DPn(n3, p2), E;
          m2 == null || m2 === "auto" ? E = w2 === "horizontal" ? T2.y + T2.height / 2 < p2.getHeight() / 2 ? "-" : "+" : T2.x + T2.width / 2 < p2.getWidth() / 2 ? "+" : "-" : ds(m2) ? E = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[w2][m2] : E = m2;
          var O2 = { horizontal: "center", vertical: E >= 0 || E === "+" ? "left" : "right" }, V3 = { horizontal: E >= 0 || E === "+" ? "top" : "bottom", vertical: "middle" }, W3 = { horizontal: 0, vertical: GVt / 2 }, q3 = w2 === "vertical" ? T2.height : T2.width, K = n3.getModel("controlStyle"), J = K.get("show", true), rt2 = J ? K.get("itemSize") : 0, gt = J ? K.get("itemGap") : 0, yt = rt2 + gt, At = n3.get(["label", "rotate"]) || 0;
          At = At * GVt / 180;
          var Lt, Wt, Nt, ue2 = K.get("position", true), ie2 = J && K.get("showPlayBtn", true), pe2 = J && K.get("showPrevBtn", true), xe = J && K.get("showNextBtn", true), Ce2 = 0, Le2 = q3;
          ue2 === "left" || ue2 === "bottom" ? (ie2 && (Lt = [0, 0], Ce2 += yt), pe2 && (Wt = [Ce2, 0], Ce2 += yt), xe && (Nt = [Le2 - rt2, 0], Le2 -= yt)) : (ie2 && (Lt = [Le2 - rt2, 0], Le2 -= yt), pe2 && (Wt = [0, 0], Ce2 += yt), xe && (Nt = [Le2 - rt2, 0], Le2 -= yt));
          var ze = [Ce2, Le2];
          return n3.get("inverse") && ze.reverse(), { viewRect: T2, mainLength: q3, orient: w2, rotation: W3[w2], labelRotation: At, labelPosOpt: E, labelAlign: n3.get(["label", "align"]) || O2[w2], labelBaseline: n3.get(["label", "verticalAlign"]) || n3.get(["label", "baseline"]) || V3[w2], playPosition: Lt, prevBtnPosition: Wt, nextBtnPosition: Nt, axisExtent: ze, controlSize: rt2, controlGap: gt };
        }, o.prototype._position = function(n3, p2) {
          var m2 = this._mainGroup, w2 = this._labelGroup, T2 = n3.viewRect;
          if (n3.orient === "vertical") {
            var E = yw(), O2 = T2.x, V3 = T2.y + T2.height;
            QS(E, E, [-O2, -V3]), t4(E, E, -GVt / 2), QS(E, E, [O2, V3]), T2 = T2.clone(), T2.applyTransform(E);
          }
          var W3 = Lt(T2), q3 = Lt(m2.getBoundingRect()), K = Lt(w2.getBoundingRect()), J = [m2.x, m2.y], rt2 = [w2.x, w2.y];
          rt2[0] = J[0] = W3[0][0];
          var gt = n3.labelPosOpt;
          if (gt == null || ds(gt)) {
            var yt = gt === "+" ? 0 : 1;
            Wt(J, q3, W3, 1, yt), Wt(rt2, K, W3, 1, 1 - yt);
          } else {
            var yt = gt >= 0 ? 0 : 1;
            Wt(J, q3, W3, 1, yt), rt2[1] = J[1] + gt;
          }
          m2.setPosition(J), w2.setPosition(rt2), m2.rotation = w2.rotation = n3.rotation, At(m2), At(w2);
          function At(Nt) {
            Nt.originX = W3[0][0] - Nt.x, Nt.originY = W3[1][0] - Nt.y;
          }
          function Lt(Nt) {
            return [[Nt.x, Nt.x + Nt.width], [Nt.y, Nt.y + Nt.height]];
          }
          function Wt(Nt, ue2, ie2, pe2, xe) {
            Nt[pe2] += ie2[pe2][xe] - ue2[pe2][xe];
          }
        }, o.prototype._createAxis = function(n3, p2) {
          var m2 = p2.getData(), w2 = p2.get("axisType"), T2 = IPn(p2, w2);
          T2.getTicks = function() {
            return m2.mapArray(["value"], function(V3) {
              return { value: V3 };
            });
          };
          var E = m2.getDataExtent("value");
          T2.setExtent(E[0], E[1]), T2.calcNiceTicks();
          var O2 = new TPn("value", T2, n3.axisExtent, w2);
          return O2.model = p2, O2;
        }, o.prototype._createGroup = function(n3) {
          var p2 = this[n3] = new uu();
          return this.group.add(p2), p2;
        }, o.prototype._renderAxisLine = function(n3, p2, m2, w2) {
          var T2 = m2.getExtent();
          if (w2.get(["lineStyle", "show"])) {
            var E = new My({ shape: { x1: T2[0], y1: 0, x2: T2[1], y2: 0 }, style: ua2({ lineCap: "round" }, w2.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
            p2.add(E);
            var O2 = this._progressLine = new My({ shape: { x1: T2[0], x2: this._currentPointer ? this._currentPointer.x : T2[0], y1: 0, y2: 0 }, style: kl({ lineCap: "round", lineWidth: E.style.lineWidth }, w2.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
            p2.add(O2);
          }
        }, o.prototype._renderAxisTick = function(n3, p2, m2, w2) {
          var T2 = this, E = w2.getData(), O2 = m2.scale.getTicks();
          this._tickSymbols = [], Xe2(O2, function(V3) {
            var W3 = m2.dataToCoord(V3.value), q3 = E.getItemModel(V3.value), K = q3.getModel("itemStyle"), J = q3.getModel(["emphasis", "itemStyle"]), rt2 = q3.getModel(["progress", "itemStyle"]), gt = { x: W3, y: 0, onclick: Is(T2._changeTimeline, T2, V3.value) }, yt = r2e(q3, K, p2, gt);
            yt.ensureState("emphasis").style = J.getItemStyle(), yt.ensureState("progress").style = rt2.getItemStyle(), m4(yt);
            var At = is(yt);
            q3.get("tooltip") ? (At.dataIndex = V3.value, At.dataModel = w2) : At.dataIndex = At.dataModel = null, T2._tickSymbols.push(yt);
          });
        }, o.prototype._renderAxisLabel = function(n3, p2, m2, w2) {
          var T2 = this, E = m2.getLabelModel();
          if (E.get("show")) {
            var O2 = w2.getData(), V3 = m2.getViewLabels();
            this._tickLabels = [], Xe2(V3, function(W3) {
              var q3 = W3.tickValue, K = O2.getItemModel(q3), J = K.getModel("label"), rt2 = K.getModel(["emphasis", "label"]), gt = K.getModel(["progress", "label"]), yt = m2.dataToCoord(W3.tickValue), At = new Zc2({ x: yt, y: 0, rotation: n3.labelRotation - n3.rotation, onclick: Is(T2._changeTimeline, T2, q3), silent: false, style: Cy(J, { text: W3.formattedLabel, align: n3.labelAlign, verticalAlign: n3.labelBaseline }) });
              At.ensureState("emphasis").style = Cy(rt2), At.ensureState("progress").style = Cy(gt), p2.add(At), m4(At), n2e(At).dataIndex = q3, T2._tickLabels.push(At);
            });
          }
        }, o.prototype._renderControl = function(n3, p2, m2, w2) {
          var T2 = n3.controlSize, E = n3.rotation, O2 = w2.getModel("controlStyle").getItemStyle(), V3 = w2.getModel(["emphasis", "controlStyle"]).getItemStyle(), W3 = w2.getPlayState(), q3 = w2.get("inverse", true);
          K(n3.nextBtnPosition, "next", Is(this._changeTimeline, this, q3 ? "-" : "+")), K(n3.prevBtnPosition, "prev", Is(this._changeTimeline, this, q3 ? "+" : "-")), K(n3.playPosition, W3 ? "stop" : "play", Is(this._handlePlayClick, this, !W3), true);
          function K(J, rt2, gt, yt) {
            if (J) {
              var At = Rm(Xu(w2.get(["controlStyle", rt2 + "BtnSize"]), T2), T2), Lt = [0, -At / 2, At, At], Wt = EPn(w2, rt2 + "Icon", Lt, { x: J[0], y: J[1], originX: T2 / 2, originY: 0, rotation: yt ? -E : 0, rectHover: true, style: O2, onclick: gt });
              Wt.ensureState("emphasis").style = V3, p2.add(Wt), m4(Wt);
            }
          }
        }, o.prototype._renderCurrentPointer = function(n3, p2, m2, w2) {
          var T2 = w2.getData(), E = w2.getCurrentIndex(), O2 = T2.getItemModel(E).getModel("checkpointStyle"), V3 = this, W3 = { onCreate: function(q3) {
            q3.draggable = true, q3.drift = Is(V3._handlePointerDrag, V3), q3.ondragend = Is(V3._handlePointerDragend, V3), i2e(q3, V3._progressLine, E, m2, w2, true);
          }, onUpdate: function(q3) {
            i2e(q3, V3._progressLine, E, m2, w2);
          } };
          this._currentPointer = r2e(O2, O2, this._mainGroup, {}, this._currentPointer, W3);
        }, o.prototype._handlePlayClick = function(n3) {
          this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: n3, from: this.uid });
        }, o.prototype._handlePointerDrag = function(n3, p2, m2) {
          this._clearTimer(), this._pointerChangeTimeline([m2.offsetX, m2.offsetY]);
        }, o.prototype._handlePointerDragend = function(n3) {
          this._pointerChangeTimeline([n3.offsetX, n3.offsetY], true);
        }, o.prototype._pointerChangeTimeline = function(n3, p2) {
          var m2 = this._toAxisCoord(n3)[0], w2 = this._axis, T2 = K_(w2.getExtent().slice());
          m2 > T2[1] && (m2 = T2[1]), m2 < T2[0] && (m2 = T2[0]), this._currentPointer.x = m2, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = m2, this._progressLine.dirty();
          var E = this._findNearestTick(m2), O2 = this.model;
          (p2 || E !== O2.getCurrentIndex() && O2.get("realtime")) && this._changeTimeline(E);
        }, o.prototype._doPlayStop = function() {
          var n3 = this;
          this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
            var p2 = n3.model;
            n3._changeTimeline(p2.getCurrentIndex() + (p2.get("rewind", true) ? -1 : 1));
          }, this.model.get("playInterval")));
        }, o.prototype._toAxisCoord = function(n3) {
          var p2 = this._mainGroup.getLocalTransform();
          return dc2(n3, p2, true);
        }, o.prototype._findNearestTick = function(n3) {
          var p2 = this.model.getData(), m2 = 1 / 0, w2, T2 = this._axis;
          return p2.each(["value"], function(E, O2) {
            var V3 = T2.dataToCoord(E), W3 = Math.abs(V3 - n3);
            W3 < m2 && (m2 = W3, w2 = O2);
          }), w2;
        }, o.prototype._clearTimer = function() {
          this._timer && (clearTimeout(this._timer), this._timer = null);
        }, o.prototype._changeTimeline = function(n3) {
          var p2 = this.model.getCurrentIndex();
          n3 === "+" ? n3 = p2 + 1 : n3 === "-" && (n3 = p2 - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: n3, from: this.uid });
        }, o.prototype._updateTicksStatus = function() {
          var n3 = this.model.getCurrentIndex(), p2 = this._tickSymbols, m2 = this._tickLabels;
          if (p2)
            for (var w2 = 0; w2 < p2.length; w2++)
              p2 && p2[w2] && p2[w2].toggleState("progress", w2 < n3);
          if (m2)
            for (var w2 = 0; w2 < m2.length; w2++)
              m2 && m2[w2] && m2[w2].toggleState("progress", n2e(m2[w2]).dataIndex <= n3);
        }, o.type = "timeline.slider", o;
      }(MPn);
      function IPn(u, o) {
        if (o = o || u.get("type"), o)
          switch (o) {
            case "category":
              return new a9t({ ordinalMeta: u.getCategories(), extent: [1 / 0, -1 / 0] });
            case "time":
              return new Mme({ locale: u.ecModel.getLocaleModel(), useUTC: u.ecModel.get("useUTC") });
            default:
              return new f8();
          }
      }
      function DPn(u, o) {
        return Bm(u.getBoxLayoutParams(), { width: o.getWidth(), height: o.getHeight() }, u.get("padding"));
      }
      function EPn(u, o, n3, p2) {
        var m2 = p2.style, w2 = yv(u.get(["controlStyle", o]), p2 || {}, new Qu(n3[0], n3[1], n3[2], n3[3]));
        return m2 && w2.setStyle(m2), w2;
      }
      function r2e(u, o, n3, p2, m2, w2) {
        var T2 = o.get("color");
        if (m2)
          m2.setColor(T2), n3.add(m2), w2 && w2.onUpdate(m2);
        else {
          var E = u.get("symbol");
          m2 = Jy(E, -1, -1, 2, 2, T2), m2.setStyle("strokeNoScale", true), n3.add(m2), w2 && w2.onCreate(m2);
        }
        var O2 = o.getItemStyle(["color"]);
        m2.setStyle(O2), p2 = Cu({ rectHover: true, z2: 100 }, p2, true);
        var V3 = Rot(u.get("symbolSize"));
        p2.scaleX = V3[0] / 2, p2.scaleY = V3[1] / 2;
        var W3 = aY(u.get("symbolOffset"), V3);
        W3 && (p2.x = (p2.x || 0) + W3[0], p2.y = (p2.y || 0) + W3[1]);
        var q3 = u.get("symbolRotate");
        return p2.rotation = (q3 || 0) * Math.PI / 180 || 0, m2.attr(p2), m2.updateTransform(), m2;
      }
      function i2e(u, o, n3, p2, m2, w2) {
        if (!u.dragging) {
          var T2 = m2.getModel("checkpointStyle"), E = p2.dataToCoord(m2.getData().get("value", n3));
          if (w2 || !T2.get("animation", true))
            u.attr({ x: E, y: 0 }), o && o.attr({ shape: { x2: E } });
          else {
            var O2 = { duration: T2.get("animationDuration", true), easing: T2.get("animationEasing", true) };
            u.stopAnimation(null, true), u.animateTo({ x: E, y: 0 }, O2), o && o.animateTo({ shape: { x2: E } }, O2);
          }
        }
      }
      var kPn = APn;
      function PPn(u) {
        u.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(o, n3, p2) {
          var m2 = n3.getComponent("timeline");
          return m2 && o.currentIndex != null && (m2.setCurrentIndex(o.currentIndex), !m2.get("loop", true) && m2.isIndexMax() && m2.getPlayState() && (m2.setPlayState(false), p2.dispatchAction({ type: "timelinePlayChange", playState: false, from: o.from }))), n3.resetOption("timeline", { replaceMerge: m2.get("replaceMerge", true) }), kl({ currentIndex: m2.option.currentIndex }, o);
        }), u.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(o, n3) {
          var p2 = n3.getComponent("timeline");
          p2 && o.playState != null && p2.setPlayState(o.playState);
        });
      }
      function LPn(u) {
        var o = u && u.timeline;
        za2(o) || (o = o ? [o] : []), Xe2(o, function(n3) {
          !n3 || OPn(n3);
        });
      }
      function OPn(u) {
        var o = u.type, n3 = { number: "value", time: "time" };
        if (n3[o] && (u.axisType = n3[o], delete u.type), a2e(u), nj2(u, "controlPosition")) {
          var p2 = u.controlStyle || (u.controlStyle = {});
          nj2(p2, "position") || (p2.position = u.controlPosition), p2.position === "none" && !nj2(p2, "show") && (p2.show = false, delete p2.position), delete u.controlPosition;
        }
        Xe2(u.data || [], function(m2) {
          ys(m2) && !za2(m2) && (!nj2(m2, "value") && nj2(m2, "name") && (m2.value = m2.name), a2e(m2));
        });
      }
      function a2e(u) {
        var o = u.itemStyle || (u.itemStyle = {}), n3 = o.emphasis || (o.emphasis = {}), p2 = u.label || u.label || {}, m2 = p2.normal || (p2.normal = {}), w2 = { normal: 1, emphasis: 1 };
        Xe2(p2, function(T2, E) {
          !w2[E] && !nj2(m2, E) && (m2[E] = T2);
        }), n3.label && !nj2(p2, "emphasis") && (p2.emphasis = n3.label, delete n3.label);
      }
      function nj2(u, o) {
        return u.hasOwnProperty(o);
      }
      function RPn(u) {
        u.registerComponentModel(wPn), u.registerComponentView(kPn), u.registerSubTypeDefaulter("timeline", function() {
          return "slider";
        }), PPn(u), u.registerPreprocessor(LPn);
      }
      function HVt(u, o) {
        if (!u)
          return false;
        for (var n3 = za2(u) ? u : [u], p2 = 0; p2 < n3.length; p2++)
          if (n3[p2] && n3[p2][o])
            return true;
        return false;
      }
      function fwt(u) {
        t22(u, "label", ["show"]);
      }
      var hwt = Ff2(), o2e = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.createdBySelf = false, n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          this.mergeDefaultAndTheme(n3, m2), this._mergeOption(n3, m2, false, true);
        }, o.prototype.isAnimationEnabled = function() {
          if (Ys.node)
            return false;
          var n3 = this.__hostSeries;
          return this.getShallow("animation") && n3 && n3.isAnimationEnabled();
        }, o.prototype.mergeOption = function(n3, p2) {
          this._mergeOption(n3, p2, false, false);
        }, o.prototype._mergeOption = function(n3, p2, m2, w2) {
          var T2 = this.mainType;
          m2 || p2.eachSeries(function(E) {
            var O2 = E.get(this.mainType, true), V3 = hwt(E)[T2];
            if (!O2 || !O2.data) {
              hwt(E)[T2] = null;
              return;
            }
            V3 ? V3._mergeOption(O2, p2, true) : (w2 && fwt(O2), Xe2(O2.data, function(W3) {
              W3 instanceof Array ? (fwt(W3[0]), fwt(W3[1])) : fwt(W3);
            }), V3 = this.createMarkerModelFromSeries(O2, this, p2), ua2(V3, { mainType: this.mainType, seriesIndex: E.seriesIndex, name: E.name, createdBySelf: true }), V3.__hostSeries = E), hwt(E)[T2] = V3;
          }, this);
        }, o.prototype.formatTooltip = function(n3, p2, m2) {
          var w2 = this.getData(), T2 = this.getRawValue(n3), E = w2.getName(n3);
          return k1("section", { header: this.name, blocks: [k1("nameValue", { name: E, value: T2, noName: !E, noValue: T2 == null })] });
        }, o.prototype.getData = function() {
          return this._data;
        }, o.prototype.setData = function(n3) {
          this._data = n3;
        }, o.getMarkerModelFromSeries = function(n3, p2) {
          return hwt(n3)[p2];
        }, o.type = "marker", o.dependencies = ["series", "grid", "polar", "geo"], o;
      }(kh2);
      x0(o2e, x8t.prototype);
      var w8 = o2e, NPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.createMarkerModelFromSeries = function(n3, p2, m2) {
          return new o(n3, p2, m2);
        }, o.type = "markPoint", o.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, o;
      }(w8), FPn = NPn;
      function VPn(u) {
        return !(isNaN(parseFloat(u.x)) && isNaN(parseFloat(u.y)));
      }
      function BPn(u) {
        return !isNaN(parseFloat(u.x)) && !isNaN(parseFloat(u.y));
      }
      function pwt(u, o, n3, p2, m2, w2) {
        var T2 = [], E = c8(o, p2), O2 = E ? o.getCalculationInfo("stackResultDimension") : p2, V3 = qVt(o, O2, u), W3 = o.indicesOfNearest(O2, V3)[0];
        T2[m2] = o.get(n3, W3), T2[w2] = o.get(O2, W3);
        var q3 = o.get(p2, W3), K = oM(o.get(p2, W3));
        return K = Math.min(K, 20), K >= 0 && (T2[w2] = +T2[w2].toFixed(K)), [T2, q3];
      }
      var UVt = { min: wu(pwt, "min"), max: wu(pwt, "max"), average: wu(pwt, "average"), median: wu(pwt, "median") };
      function Dst(u, o) {
        var n3 = u.getData(), p2 = u.coordinateSystem;
        if (o && !BPn(o) && !za2(o.coord) && p2) {
          var m2 = p2.dimensions, w2 = s2e(o, n3, p2, u);
          if (o = jl(o), o.type && UVt[o.type] && w2.baseAxis && w2.valueAxis) {
            var T2 = sc2(m2, w2.baseAxis.dim), E = sc2(m2, w2.valueAxis.dim), O2 = UVt[o.type](n3, w2.baseDataDim, w2.valueDataDim, T2, E);
            o.coord = O2[0], o.value = O2[1];
          } else {
            for (var V3 = [o.xAxis != null ? o.xAxis : o.radiusAxis, o.yAxis != null ? o.yAxis : o.angleAxis], W3 = 0; W3 < 2; W3++)
              UVt[V3[W3]] && (V3[W3] = qVt(n3, n3.mapDimension(m2[W3]), V3[W3]));
            o.coord = V3;
          }
        }
        return o;
      }
      function s2e(u, o, n3, p2) {
        var m2 = {};
        return u.valueIndex != null || u.valueDim != null ? (m2.valueDataDim = u.valueIndex != null ? o.getDimension(u.valueIndex) : u.valueDim, m2.valueAxis = n3.getAxis(zPn(p2, m2.valueDataDim)), m2.baseAxis = n3.getOtherAxis(m2.valueAxis), m2.baseDataDim = o.mapDimension(m2.baseAxis.dim)) : (m2.baseAxis = p2.getBaseAxis(), m2.valueAxis = n3.getOtherAxis(m2.baseAxis), m2.baseDataDim = o.mapDimension(m2.baseAxis.dim), m2.valueDataDim = o.mapDimension(m2.valueAxis.dim)), m2;
      }
      function zPn(u, o) {
        var n3 = u.getData().getDimensionInfo(o);
        return n3 && n3.coordDim;
      }
      function Est(u, o) {
        return u && u.containData && o.coord && !VPn(o) ? u.containData(o.coord) : true;
      }
      function l2e(u, o) {
        return u ? function(n3, p2, m2, w2) {
          var T2 = w2 < 2 ? n3.coord && n3.coord[w2] : n3.value;
          return o8(T2, o[w2]);
        } : function(n3, p2, m2, w2) {
          return o8(n3.value, o[w2]);
        };
      }
      function qVt(u, o, n3) {
        if (n3 === "average") {
          var p2 = 0, m2 = 0;
          return u.each(o, function(w2, T2) {
            isNaN(w2) || (p2 += w2, m2++);
          }), p2 / m2;
        } else
          return n3 === "median" ? u.getMedian(o) : u.getDataExtent(o)[n3 === "max" ? 1 : 0];
      }
      var ZVt = Ff2(), jPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.init = function() {
          this.markerGroupMap = pl();
        }, o.prototype.render = function(n3, p2, m2) {
          var w2 = this, T2 = this.markerGroupMap;
          T2.each(function(E) {
            ZVt(E).keep = false;
          }), p2.eachSeries(function(E) {
            var O2 = w8.getMarkerModelFromSeries(E, w2.type);
            O2 && w2.renderSeries(E, O2, p2, m2);
          }), T2.each(function(E) {
            !ZVt(E).keep && w2.group.remove(E.group);
          });
        }, o.prototype.markKeep = function(n3) {
          ZVt(n3).keep = true;
        }, o.prototype.blurSeries = function(n3) {
          var p2 = this;
          Xe2(n3, function(m2) {
            var w2 = w8.getMarkerModelFromSeries(m2, p2.type);
            if (w2) {
              var T2 = w2.getData();
              T2.eachItemGraphicEl(function(E) {
                E && Jat(E);
              });
            }
          });
        }, o.type = "marker", o;
      }(C0), $Vt = jPn;
      function u2e(u, o, n3) {
        var p2 = o.coordinateSystem;
        u.each(function(m2) {
          var w2 = u.getItemModel(m2), T2, E = Qo(w2.get("x"), n3.getWidth()), O2 = Qo(w2.get("y"), n3.getHeight());
          if (!isNaN(E) && !isNaN(O2))
            T2 = [E, O2];
          else if (o.getMarkerPosition)
            T2 = o.getMarkerPosition(u.getValues(u.dimensions, m2));
          else if (p2) {
            var V3 = u.get(p2.dimensions[0], m2), W3 = u.get(p2.dimensions[1], m2);
            T2 = p2.dataToPoint([V3, W3]);
          }
          isNaN(E) || (T2[0] = E), isNaN(O2) || (T2[1] = O2), u.setItemLayout(m2, T2);
        });
      }
      var WPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.updateTransform = function(n3, p2, m2) {
          p2.eachSeries(function(w2) {
            var T2 = w8.getMarkerModelFromSeries(w2, "markPoint");
            T2 && (u2e(T2.getData(), w2, m2), this.markerGroupMap.get(w2.id).updateLayout());
          }, this);
        }, o.prototype.renderSeries = function(n3, p2, m2, w2) {
          var T2 = n3.coordinateSystem, E = n3.id, O2 = n3.getData(), V3 = this.markerGroupMap, W3 = V3.get(E) || V3.set(E, new rst()), q3 = GPn(T2, n3, p2);
          p2.setData(q3), u2e(p2.getData(), n3, w2), q3.each(function(K) {
            var J = q3.getItemModel(K), rt2 = J.getShallow("symbol"), gt = J.getShallow("symbolSize"), yt = J.getShallow("symbolRotate"), At = J.getShallow("symbolOffset"), Lt = J.getShallow("symbolKeepAspect");
            if (Sl(rt2) || Sl(gt) || Sl(yt) || Sl(At)) {
              var Wt = p2.getRawValue(K), Nt = p2.getDataParams(K);
              Sl(rt2) && (rt2 = rt2(Wt, Nt)), Sl(gt) && (gt = gt(Wt, Nt)), Sl(yt) && (yt = yt(Wt, Nt)), Sl(At) && (At = At(Wt, Nt));
            }
            var ue2 = J.getModel("itemStyle").getItemStyle(), ie2 = Oot(O2, "color");
            ue2.fill || (ue2.fill = ie2), q3.setItemVisual(K, { symbol: rt2, symbolSize: gt, symbolRotate: yt, symbolOffset: At, symbolKeepAspect: Lt, style: ue2 });
          }), W3.updateData(q3), this.group.add(W3.group), q3.eachItemGraphicEl(function(K) {
            K.traverse(function(J) {
              is(J).dataModel = p2;
            });
          }), this.markKeep(W3), W3.group.silent = p2.get("silent") || n3.get("silent");
        }, o.type = "markPoint", o;
      }($Vt);
      function GPn(u, o, n3) {
        var p2;
        u ? p2 = Ya2(u && u.dimensions, function(E) {
          var O2 = o.getData().getDimensionInfo(o.getData().mapDimension(E)) || {};
          return ua2(ua2({}, O2), { name: E, ordinalMeta: null });
        }) : p2 = [{ name: "value", type: "float" }];
        var m2 = new o2(p2, n3), w2 = Ya2(n3.get("data"), wu(Dst, o));
        u && (w2 = Fp(w2, wu(Est, u)));
        var T2 = l2e(!!u, p2);
        return m2.initData(w2, null, T2), m2;
      }
      var HPn = WPn;
      function UPn(u) {
        u.registerComponentModel(FPn), u.registerComponentView(HPn), u.registerPreprocessor(function(o) {
          HVt(o.series, "markPoint") && (o.markPoint = o.markPoint || {});
        });
      }
      var qPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.createMarkerModelFromSeries = function(n3, p2, m2) {
          return new o(n3, p2, m2);
        }, o.type = "markLine", o.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, o;
      }(w8), ZPn = qPn, dwt = Ff2(), $Pn = function(u, o, n3, p2) {
        var m2 = u.getData(), w2;
        if (za2(p2))
          w2 = p2;
        else {
          var T2 = p2.type;
          if (T2 === "min" || T2 === "max" || T2 === "average" || T2 === "median" || p2.xAxis != null || p2.yAxis != null) {
            var E = void 0, O2 = void 0;
            if (p2.yAxis != null || p2.xAxis != null)
              E = o.getAxis(p2.yAxis != null ? "y" : "x"), O2 = $y(p2.yAxis, p2.xAxis);
            else {
              var V3 = s2e(p2, m2, o, u);
              E = V3.valueAxis;
              var W3 = lme(m2, V3.valueDataDim);
              O2 = qVt(m2, W3, T2);
            }
            var q3 = E.dim === "x" ? 0 : 1, K = 1 - q3, J = jl(p2), rt2 = { coord: [] };
            J.type = null, J.coord = [], J.coord[K] = -1 / 0, rt2.coord[K] = 1 / 0;
            var gt = n3.get("precision");
            gt >= 0 && Dh2(O2) && (O2 = +O2.toFixed(Math.min(gt, 20))), J.coord[q3] = rt2.coord[q3] = O2, w2 = [J, rt2, { type: T2, valueIndex: p2.valueIndex, value: O2 }];
          } else
            w2 = [];
        }
        var yt = [Dst(u, w2[0]), Dst(u, w2[1]), ua2({}, w2[2])];
        return yt[2].type = yt[2].type || null, Cu(yt[2], yt[0]), Cu(yt[2], yt[1]), yt;
      };
      function gwt(u) {
        return !isNaN(u) && !isFinite(u);
      }
      function c2e(u, o, n3, p2) {
        var m2 = 1 - u, w2 = p2.dimensions[u];
        return gwt(o[m2]) && gwt(n3[m2]) && o[u] === n3[u] && p2.getAxis(w2).containData(o[u]);
      }
      function YPn(u, o) {
        if (u.type === "cartesian2d") {
          var n3 = o[0].coord, p2 = o[1].coord;
          if (n3 && p2 && (c2e(1, n3, p2, u) || c2e(0, n3, p2, u)))
            return true;
        }
        return Est(u, o[0]) && Est(u, o[1]);
      }
      function YVt(u, o, n3, p2, m2) {
        var w2 = p2.coordinateSystem, T2 = u.getItemModel(o), E, O2 = Qo(T2.get("x"), m2.getWidth()), V3 = Qo(T2.get("y"), m2.getHeight());
        if (!isNaN(O2) && !isNaN(V3))
          E = [O2, V3];
        else {
          if (p2.getMarkerPosition)
            E = p2.getMarkerPosition(u.getValues(u.dimensions, o));
          else {
            var W3 = w2.dimensions, q3 = u.get(W3[0], o), K = u.get(W3[1], o);
            E = w2.dataToPoint([q3, K]);
          }
          if (I4(w2, "cartesian2d")) {
            var J = w2.getAxis("x"), rt2 = w2.getAxis("y"), W3 = w2.dimensions;
            gwt(u.get(W3[0], o)) ? E[0] = J.toGlobalCoord(J.getExtent()[n3 ? 0 : 1]) : gwt(u.get(W3[1], o)) && (E[1] = rt2.toGlobalCoord(rt2.getExtent()[n3 ? 0 : 1]));
          }
          isNaN(O2) || (E[0] = O2), isNaN(V3) || (E[1] = V3);
        }
        u.setItemLayout(o, E);
      }
      var KPn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.updateTransform = function(n3, p2, m2) {
          p2.eachSeries(function(w2) {
            var T2 = w8.getMarkerModelFromSeries(w2, "markLine");
            if (T2) {
              var E = T2.getData(), O2 = dwt(T2).from, V3 = dwt(T2).to;
              O2.each(function(W3) {
                YVt(O2, W3, true, w2, m2), YVt(V3, W3, false, w2, m2);
              }), E.each(function(W3) {
                E.setItemLayout(W3, [O2.getItemLayout(W3), V3.getItemLayout(W3)]);
              }), this.markerGroupMap.get(w2.id).updateLayout();
            }
          }, this);
        }, o.prototype.renderSeries = function(n3, p2, m2, w2) {
          var T2 = n3.coordinateSystem, E = n3.id, O2 = n3.getData(), V3 = this.markerGroupMap, W3 = V3.get(E) || V3.set(E, new C7t());
          this.group.add(W3.group);
          var q3 = XPn(T2, n3, p2), K = q3.from, J = q3.to, rt2 = q3.line;
          dwt(p2).from = K, dwt(p2).to = J, p2.setData(rt2);
          var gt = p2.get("symbol"), yt = p2.get("symbolSize"), At = p2.get("symbolRotate"), Lt = p2.get("symbolOffset");
          za2(gt) || (gt = [gt, gt]), za2(yt) || (yt = [yt, yt]), za2(At) || (At = [At, At]), za2(Lt) || (Lt = [Lt, Lt]), q3.from.each(function(Nt) {
            Wt(K, Nt, true), Wt(J, Nt, false);
          }), rt2.each(function(Nt) {
            var ue2 = rt2.getItemModel(Nt).getModel("lineStyle").getLineStyle();
            rt2.setItemLayout(Nt, [K.getItemLayout(Nt), J.getItemLayout(Nt)]), ue2.stroke == null && (ue2.stroke = K.getItemVisual(Nt, "style").fill), rt2.setItemVisual(Nt, { fromSymbolKeepAspect: K.getItemVisual(Nt, "symbolKeepAspect"), fromSymbolOffset: K.getItemVisual(Nt, "symbolOffset"), fromSymbolRotate: K.getItemVisual(Nt, "symbolRotate"), fromSymbolSize: K.getItemVisual(Nt, "symbolSize"), fromSymbol: K.getItemVisual(Nt, "symbol"), toSymbolKeepAspect: J.getItemVisual(Nt, "symbolKeepAspect"), toSymbolOffset: J.getItemVisual(Nt, "symbolOffset"), toSymbolRotate: J.getItemVisual(Nt, "symbolRotate"), toSymbolSize: J.getItemVisual(Nt, "symbolSize"), toSymbol: J.getItemVisual(Nt, "symbol"), style: ue2 });
          }), W3.updateData(rt2), q3.line.eachItemGraphicEl(function(Nt, ue2) {
            Nt.traverse(function(ie2) {
              is(ie2).dataModel = p2;
            });
          });
          function Wt(Nt, ue2, ie2) {
            var pe2 = Nt.getItemModel(ue2);
            YVt(Nt, ue2, ie2, n3, w2);
            var xe = pe2.getModel("itemStyle").getItemStyle();
            xe.fill == null && (xe.fill = Oot(O2, "color")), Nt.setItemVisual(ue2, { symbolKeepAspect: pe2.get("symbolKeepAspect"), symbolOffset: Xu(pe2.get("symbolOffset", true), Lt[ie2 ? 0 : 1]), symbolRotate: Xu(pe2.get("symbolRotate", true), At[ie2 ? 0 : 1]), symbolSize: Xu(pe2.get("symbolSize"), yt[ie2 ? 0 : 1]), symbol: Xu(pe2.get("symbol", true), gt[ie2 ? 0 : 1]), style: xe });
          }
          this.markKeep(W3), W3.group.silent = p2.get("silent") || n3.get("silent");
        }, o.type = "markLine", o;
      }($Vt);
      function XPn(u, o, n3) {
        var p2;
        u ? p2 = Ya2(u && u.dimensions, function(V3) {
          var W3 = o.getData().getDimensionInfo(o.getData().mapDimension(V3)) || {};
          return ua2(ua2({}, W3), { name: V3, ordinalMeta: null });
        }) : p2 = [{ name: "value", type: "float" }];
        var m2 = new o2(p2, n3), w2 = new o2(p2, n3), T2 = new o2([], n3), E = Ya2(n3.get("data"), wu($Pn, o, u, n3));
        u && (E = Fp(E, wu(YPn, u)));
        var O2 = l2e(!!u, p2);
        return m2.initData(Ya2(E, function(V3) {
          return V3[0];
        }), null, O2), w2.initData(Ya2(E, function(V3) {
          return V3[1];
        }), null, O2), T2.initData(Ya2(E, function(V3) {
          return V3[2];
        })), T2.hasItemOption = true, { from: m2, to: w2, line: T2 };
      }
      var QPn = KPn;
      function JPn(u) {
        u.registerComponentModel(ZPn), u.registerComponentView(QPn), u.registerPreprocessor(function(o) {
          HVt(o.series, "markLine") && (o.markLine = o.markLine || {});
        });
      }
      var t3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.createMarkerModelFromSeries = function(n3, p2, m2) {
          return new o(n3, p2, m2);
        }, o.type = "markArea", o.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, o;
      }(w8), e3n = t3n, vwt = Ff2(), n3n = function(u, o, n3, p2) {
        var m2 = Dst(u, p2[0]), w2 = Dst(u, p2[1]), T2 = m2.coord, E = w2.coord;
        T2[0] = $y(T2[0], -1 / 0), T2[1] = $y(T2[1], -1 / 0), E[0] = $y(E[0], 1 / 0), E[1] = $y(E[1], 1 / 0);
        var O2 = LZ([{}, m2, w2]);
        return O2.coord = [m2.coord, w2.coord], O2.x0 = m2.x, O2.y0 = m2.y, O2.x1 = w2.x, O2.y1 = w2.y, O2;
      };
      function ywt(u) {
        return !isNaN(u) && !isFinite(u);
      }
      function f2e(u, o, n3, p2) {
        var m2 = 1 - u;
        return ywt(o[m2]) && ywt(n3[m2]);
      }
      function r3n(u, o) {
        var n3 = o.coord[0], p2 = o.coord[1];
        return I4(u, "cartesian2d") && n3 && p2 && (f2e(1, n3, p2) || f2e(0, n3, p2)) ? true : Est(u, { coord: n3, x: o.x0, y: o.y0 }) || Est(u, { coord: p2, x: o.x1, y: o.y1 });
      }
      function h2e(u, o, n3, p2, m2) {
        var w2 = p2.coordinateSystem, T2 = u.getItemModel(o), E, O2 = Qo(T2.get(n3[0]), m2.getWidth()), V3 = Qo(T2.get(n3[1]), m2.getHeight());
        if (!isNaN(O2) && !isNaN(V3))
          E = [O2, V3];
        else {
          if (p2.getMarkerPosition)
            E = p2.getMarkerPosition(u.getValues(n3, o));
          else {
            var W3 = u.get(n3[0], o), q3 = u.get(n3[1], o), K = [W3, q3];
            w2.clampData && w2.clampData(K, K), E = w2.dataToPoint(K, true);
          }
          if (I4(w2, "cartesian2d")) {
            var J = w2.getAxis("x"), rt2 = w2.getAxis("y"), W3 = u.get(n3[0], o), q3 = u.get(n3[1], o);
            ywt(W3) ? E[0] = J.toGlobalCoord(J.getExtent()[n3[0] === "x0" ? 0 : 1]) : ywt(q3) && (E[1] = rt2.toGlobalCoord(rt2.getExtent()[n3[1] === "y0" ? 0 : 1]));
          }
          isNaN(O2) || (E[0] = O2), isNaN(V3) || (E[1] = V3);
        }
        return E;
      }
      var p2e = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], i3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.updateTransform = function(n3, p2, m2) {
          p2.eachSeries(function(w2) {
            var T2 = w8.getMarkerModelFromSeries(w2, "markArea");
            if (T2) {
              var E = T2.getData();
              E.each(function(O2) {
                var V3 = Ya2(p2e, function(q3) {
                  return h2e(E, O2, q3, w2, m2);
                });
                E.setItemLayout(O2, V3);
                var W3 = E.getItemGraphicEl(O2);
                W3.setShape("points", V3);
              });
            }
          }, this);
        }, o.prototype.renderSeries = function(n3, p2, m2, w2) {
          var T2 = n3.coordinateSystem, E = n3.id, O2 = n3.getData(), V3 = this.markerGroupMap, W3 = V3.get(E) || V3.set(E, { group: new uu() });
          this.group.add(W3.group), this.markKeep(W3);
          var q3 = a3n(T2, n3, p2);
          p2.setData(q3), q3.each(function(K) {
            var J = Ya2(p2e, function(xe) {
              return h2e(q3, K, xe, n3, w2);
            }), rt2 = T2.getAxis("x").scale, gt = T2.getAxis("y").scale, yt = rt2.getExtent(), At = gt.getExtent(), Lt = [rt2.parse(q3.get("x0", K)), rt2.parse(q3.get("x1", K))], Wt = [gt.parse(q3.get("y0", K)), gt.parse(q3.get("y1", K))];
            K_(Lt), K_(Wt);
            var Nt = !(yt[0] > Lt[1] || yt[1] < Lt[0] || At[0] > Wt[1] || At[1] < Wt[0]), ue2 = !Nt;
            q3.setItemLayout(K, { points: J, allClipped: ue2 });
            var ie2 = q3.getItemModel(K).getModel("itemStyle").getItemStyle(), pe2 = Oot(O2, "color");
            ie2.fill || (ie2.fill = pe2, ds(ie2.fill) && (ie2.fill = UZ(ie2.fill, 0.4))), ie2.stroke || (ie2.stroke = pe2), q3.setItemVisual(K, "style", ie2);
          }), q3.diff(vwt(W3).data).add(function(K) {
            var J = q3.getItemLayout(K);
            if (!J.allClipped) {
              var rt2 = new Sw({ shape: { points: J.points } });
              q3.setItemGraphicEl(K, rt2), W3.group.add(rt2);
            }
          }).update(function(K, J) {
            var rt2 = vwt(W3).data.getItemGraphicEl(J), gt = q3.getItemLayout(K);
            gt.allClipped ? rt2 && W3.group.remove(rt2) : (rt2 ? Xf2(rt2, { shape: { points: gt.points } }, p2, K) : rt2 = new Sw({ shape: { points: gt.points } }), q3.setItemGraphicEl(K, rt2), W3.group.add(rt2));
          }).remove(function(K) {
            var J = vwt(W3).data.getItemGraphicEl(K);
            W3.group.remove(J);
          }).execute(), q3.eachItemGraphicEl(function(K, J) {
            var rt2 = q3.getItemModel(J), gt = q3.getItemVisual(J, "style");
            K.useStyle(q3.getItemVisual(J, "style")), Tw(K, Lb2(rt2), { labelFetcher: p2, labelDataIndex: J, defaultText: q3.getName(J) || "", inheritColor: ds(gt.fill) ? UZ(gt.fill, 1) : "#000" }), Ky(K, rt2), o0(K, null, null, rt2.get(["emphasis", "disabled"])), is(K).dataModel = p2;
          }), vwt(W3).data = q3, W3.group.silent = p2.get("silent") || n3.get("silent");
        }, o.type = "markArea", o;
      }($Vt);
      function a3n(u, o, n3) {
        var p2, m2, w2 = ["x0", "y0", "x1", "y1"];
        if (u) {
          var T2 = Ya2(u && u.dimensions, function(V3) {
            var W3 = o.getData(), q3 = W3.getDimensionInfo(W3.mapDimension(V3)) || {};
            return ua2(ua2({}, q3), { name: V3, ordinalMeta: null });
          });
          m2 = Ya2(w2, function(V3, W3) {
            return { name: V3, type: T2[W3 % 2].type };
          }), p2 = new o2(m2, n3);
        } else
          m2 = [{ name: "value", type: "float" }], p2 = new o2(m2, n3);
        var E = Ya2(n3.get("data"), wu(n3n, o, u, n3));
        u && (E = Fp(E, wu(r3n, u)));
        var O2 = u ? function(V3, W3, q3, K) {
          var J = V3.coord[Math.floor(K / 2)][K % 2];
          return o8(J, m2[K]);
        } : function(V3, W3, q3, K) {
          return o8(V3.value, m2[K]);
        };
        return p2.initData(E, null, O2), p2.hasItemOption = true, p2;
      }
      var o3n = i3n;
      function s3n(u) {
        u.registerComponentModel(e3n), u.registerComponentView(o3n), u.registerPreprocessor(function(o) {
          HVt(o.series, "markArea") && (o.markArea = o.markArea || {});
        });
      }
      var l3n = function(u, o) {
        if (o === "all")
          return { type: "all", title: u.getLocaleModel().get(["legend", "selector", "all"]) };
        if (o === "inverse")
          return { type: "inverse", title: u.getLocaleModel().get(["legend", "selector", "inverse"]) };
      }, u3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.layoutMode = { type: "box", ignoreSize: true }, n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          this.mergeDefaultAndTheme(n3, m2), n3.selected = n3.selected || {}, this._updateSelector(n3);
        }, o.prototype.mergeOption = function(n3, p2) {
          u.prototype.mergeOption.call(this, n3, p2), this._updateSelector(n3);
        }, o.prototype._updateSelector = function(n3) {
          var p2 = n3.selector, m2 = this.ecModel;
          p2 === true && (p2 = n3.selector = ["all", "inverse"]), za2(p2) && Xe2(p2, function(w2, T2) {
            ds(w2) && (w2 = { type: w2 }), p2[T2] = Cu(w2, l3n(m2, w2.type));
          });
        }, o.prototype.optionUpdated = function() {
          this._updateData(this.ecModel);
          var n3 = this._data;
          if (n3[0] && this.get("selectedMode") === "single") {
            for (var p2 = false, m2 = 0; m2 < n3.length; m2++) {
              var w2 = n3[m2].get("name");
              if (this.isSelected(w2)) {
                this.select(w2), p2 = true;
                break;
              }
            }
            !p2 && this.select(n3[0].get("name"));
          }
        }, o.prototype._updateData = function(n3) {
          var p2 = [], m2 = [];
          n3.eachRawSeries(function(E) {
            var O2 = E.name;
            m2.push(O2);
            var V3;
            if (E.legendVisualProvider) {
              var W3 = E.legendVisualProvider, q3 = W3.getAllNames();
              n3.isSeriesFiltered(E) || (m2 = m2.concat(q3)), q3.length ? p2 = p2.concat(q3) : V3 = true;
            } else
              V3 = true;
            V3 && D1(E) && p2.push(E.name);
          }), this._availableNames = m2;
          var w2 = this.get("data") || p2, T2 = Ya2(w2, function(E) {
            return (ds(E) || Dh2(E)) && (E = { name: E }), new _g(E, this, this.ecModel);
          }, this);
          this._data = T2;
        }, o.prototype.getData = function() {
          return this._data;
        }, o.prototype.select = function(n3) {
          var p2 = this.option.selected, m2 = this.get("selectedMode");
          if (m2 === "single") {
            var w2 = this._data;
            Xe2(w2, function(T2) {
              p2[T2.get("name")] = false;
            });
          }
          p2[n3] = true;
        }, o.prototype.unSelect = function(n3) {
          this.get("selectedMode") !== "single" && (this.option.selected[n3] = false);
        }, o.prototype.toggleSelected = function(n3) {
          var p2 = this.option.selected;
          p2.hasOwnProperty(n3) || (p2[n3] = true), this[p2[n3] ? "unSelect" : "select"](n3);
        }, o.prototype.allSelect = function() {
          var n3 = this._data, p2 = this.option.selected;
          Xe2(n3, function(m2) {
            p2[m2.get("name", true)] = true;
          });
        }, o.prototype.inverseSelect = function() {
          var n3 = this._data, p2 = this.option.selected;
          Xe2(n3, function(m2) {
            var w2 = m2.get("name", true);
            p2.hasOwnProperty(w2) || (p2[w2] = true), p2[w2] = !p2[w2];
          });
        }, o.prototype.isSelected = function(n3) {
          var p2 = this.option.selected;
          return !(p2.hasOwnProperty(n3) && !p2[n3]) && sc2(this._availableNames, n3) >= 0;
        }, o.prototype.getOrient = function() {
          return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
        }, o.type = "legend.plain", o.dependencies = ["series"], o.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, o;
      }(kh2), KVt = u3n, TY = wu, XVt = Xe2, mwt = uu, c3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.newlineDisabled = false, n3;
        }
        return o.prototype.init = function() {
          this.group.add(this._contentGroup = new mwt()), this.group.add(this._selectorGroup = new mwt()), this._isFirstRender = true;
        }, o.prototype.getContentGroup = function() {
          return this._contentGroup;
        }, o.prototype.getSelectorGroup = function() {
          return this._selectorGroup;
        }, o.prototype.render = function(n3, p2, m2) {
          var w2 = this._isFirstRender;
          if (this._isFirstRender = false, this.resetInner(), !!n3.get("show", true)) {
            var T2 = n3.get("align"), E = n3.get("orient");
            (!T2 || T2 === "auto") && (T2 = n3.get("left") === "right" && E === "vertical" ? "right" : "left");
            var O2 = n3.get("selector", true), V3 = n3.get("selectorPosition", true);
            O2 && (!V3 || V3 === "auto") && (V3 = E === "horizontal" ? "end" : "start"), this.renderInner(T2, n3, p2, m2, O2, E, V3);
            var W3 = n3.getBoxLayoutParams(), q3 = { width: m2.getWidth(), height: m2.getHeight() }, K = n3.get("padding"), J = Bm(W3, q3, K), rt2 = this.layoutInner(n3, T2, J, w2, O2, V3), gt = Bm(kl({ width: rt2.width, height: rt2.height }, W3), q3, K);
            this.group.x = gt.x - rt2.x, this.group.y = gt.y - rt2.y, this.group.markRedraw(), this.group.add(this._backgroundEl = wSe(rt2, n3));
          }
        }, o.prototype.resetInner = function() {
          this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
        }, o.prototype.renderInner = function(n3, p2, m2, w2, T2, E, O2) {
          var V3 = this.getContentGroup(), W3 = pl(), q3 = p2.get("selectedMode"), K = [];
          m2.eachRawSeries(function(J) {
            !J.get("legendHoverLink") && K.push(J.id);
          }), XVt(p2.getData(), function(J, rt2) {
            var gt = J.get("name");
            if (!this.newlineDisabled && (gt === "" || gt === `
`)) {
              var yt = new mwt();
              yt.newline = true, V3.add(yt);
              return;
            }
            var At = m2.getSeriesByName(gt)[0];
            if (!W3.get(gt))
              if (At) {
                var Lt = At.getData(), Wt = Lt.getVisual("legendLineStyle") || {}, Nt = Lt.getVisual("legendIcon"), ue2 = Lt.getVisual("style"), ie2 = this._createItem(At, gt, rt2, J, p2, n3, Wt, ue2, Nt, q3);
                ie2.on("click", TY(d2e, gt, null, w2, K)).on("mouseover", TY(QVt, At.name, null, w2, K)).on("mouseout", TY(JVt, At.name, null, w2, K)), W3.set(gt, true);
              } else
                m2.eachRawSeries(function(pe2) {
                  if (!W3.get(gt) && pe2.legendVisualProvider) {
                    var xe = pe2.legendVisualProvider;
                    if (!xe.containName(gt))
                      return;
                    var Ce2 = xe.indexOfName(gt), Le2 = xe.getItemVisual(Ce2, "style"), ze = xe.getItemVisual(Ce2, "legendIcon"), tn = KS(Le2.fill);
                    tn && tn[3] === 0 && (tn[3] = 0.2, Le2 = ua2(ua2({}, Le2), { fill: T1(tn, "rgba") }));
                    var $e2 = this._createItem(pe2, gt, rt2, J, p2, n3, {}, Le2, ze, q3);
                    $e2.on("click", TY(d2e, null, gt, w2, K)).on("mouseover", TY(QVt, null, gt, w2, K)).on("mouseout", TY(JVt, null, gt, w2, K)), W3.set(gt, true);
                  }
                }, this);
          }, this), T2 && this._createSelector(T2, p2, w2, E, O2);
        }, o.prototype._createSelector = function(n3, p2, m2, w2, T2) {
          var E = this.getSelectorGroup();
          XVt(n3, function(O2) {
            var V3 = O2.type, W3 = new Zc2({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
              m2.dispatchAction({ type: V3 === "all" ? "legendAllSelect" : "legendInverseSelect" });
            } });
            E.add(W3);
            var q3 = p2.getModel("selectorLabel"), K = p2.getModel(["emphasis", "selectorLabel"]);
            Tw(W3, { normal: q3, emphasis: K }, { defaultText: O2.title }), m4(W3);
          });
        }, o.prototype._createItem = function(n3, p2, m2, w2, T2, E, O2, V3, W3, q3) {
          var K = n3.visualDrawType, J = T2.get("itemWidth"), rt2 = T2.get("itemHeight"), gt = T2.isSelected(p2), yt = w2.get("symbolRotate"), At = w2.get("symbolKeepAspect"), Lt = w2.get("icon");
          W3 = Lt || W3 || "roundRect";
          var Wt = f3n(W3, w2, O2, V3, K, gt), Nt = new mwt(), ue2 = w2.getModel("textStyle");
          if (Sl(n3.getLegendIcon) && (!Lt || Lt === "inherit"))
            Nt.add(n3.getLegendIcon({ itemWidth: J, itemHeight: rt2, icon: W3, iconRotate: yt, itemStyle: Wt.itemStyle, lineStyle: Wt.lineStyle, symbolKeepAspect: At }));
          else {
            var ie2 = Lt === "inherit" && n3.getData().getVisual("symbol") ? yt === "inherit" ? n3.getData().getVisual("symbolRotate") : yt : 0;
            Nt.add(h3n({ itemWidth: J, itemHeight: rt2, icon: W3, iconRotate: ie2, itemStyle: Wt.itemStyle, lineStyle: Wt.lineStyle, symbolKeepAspect: At }));
          }
          var pe2 = E === "left" ? J + 5 : -5, xe = E, Ce2 = T2.get("formatter"), Le2 = p2;
          ds(Ce2) && Ce2 ? Le2 = Ce2.replace("{name}", p2 != null ? p2 : "") : Sl(Ce2) && (Le2 = Ce2(p2));
          var ze = w2.get("inactiveColor");
          Nt.add(new Zc2({ style: Cy(ue2, { text: Le2, x: pe2, y: rt2 / 2, fill: gt ? ue2.getTextColor() : ze, align: xe, verticalAlign: "middle" }) }));
          var tn = new Vf2({ shape: Nt.getBoundingRect(), invisible: true }), $e2 = w2.getModel("tooltip");
          return $e2.get("show") && G$({ el: tn, componentModel: T2, itemName: p2, itemTooltipOption: $e2.option }), Nt.add(tn), Nt.eachChild(function(Tn) {
            Tn.silent = true;
          }), tn.silent = !q3, this.getContentGroup().add(Nt), m4(Nt), Nt.__legendDataIndex = m2, Nt;
        }, o.prototype.layoutInner = function(n3, p2, m2, w2, T2, E) {
          var O2 = this.getContentGroup(), V3 = this.getSelectorGroup();
          Ez(n3.get("orient"), O2, n3.get("itemGap"), m2.width, m2.height);
          var W3 = O2.getBoundingRect(), q3 = [-W3.x, -W3.y];
          if (V3.markRedraw(), O2.markRedraw(), T2) {
            Ez("horizontal", V3, n3.get("selectorItemGap", true));
            var K = V3.getBoundingRect(), J = [-K.x, -K.y], rt2 = n3.get("selectorButtonGap", true), gt = n3.getOrient().index, yt = gt === 0 ? "width" : "height", At = gt === 0 ? "height" : "width", Lt = gt === 0 ? "y" : "x";
            E === "end" ? J[gt] += W3[yt] + rt2 : q3[gt] += K[yt] + rt2, J[1 - gt] += W3[At] / 2 - K[At] / 2, V3.x = J[0], V3.y = J[1], O2.x = q3[0], O2.y = q3[1];
            var Wt = { x: 0, y: 0 };
            return Wt[yt] = W3[yt] + rt2 + K[yt], Wt[At] = Math.max(W3[At], K[At]), Wt[Lt] = Math.min(0, K[Lt] + J[1 - gt]), Wt;
          } else
            return O2.x = q3[0], O2.y = q3[1], this.group.getBoundingRect();
        }, o.prototype.remove = function() {
          this.getContentGroup().removeAll(), this._isFirstRender = true;
        }, o.type = "legend.plain", o;
      }(C0);
      function f3n(u, o, n3, p2, m2, w2) {
        function T2(rt2, gt) {
          rt2.lineWidth === "auto" && (rt2.lineWidth = gt.lineWidth > 0 ? 2 : 0), XVt(rt2, function(yt, At) {
            rt2[At] === "inherit" && (rt2[At] = gt[At]);
          });
        }
        var E = o.getModel("itemStyle"), O2 = E.getItemStyle(), V3 = u.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
        O2.decal = p2.decal, O2.fill === "inherit" && (O2.fill = p2[m2]), O2.stroke === "inherit" && (O2.stroke = p2[V3]), O2.opacity === "inherit" && (O2.opacity = (m2 === "fill" ? p2 : n3).opacity), T2(O2, p2);
        var W3 = o.getModel("lineStyle"), q3 = W3.getLineStyle();
        if (T2(q3, n3), O2.fill === "auto" && (O2.fill = p2.fill), O2.stroke === "auto" && (O2.stroke = p2.fill), q3.stroke === "auto" && (q3.stroke = p2.fill), !w2) {
          var K = o.get("inactiveBorderWidth"), J = O2[V3];
          O2.lineWidth = K === "auto" ? p2.lineWidth > 0 && J ? 2 : 0 : O2.lineWidth, O2.fill = o.get("inactiveColor"), O2.stroke = o.get("inactiveBorderColor"), q3.stroke = W3.get("inactiveColor"), q3.lineWidth = W3.get("inactiveWidth");
        }
        return { itemStyle: O2, lineStyle: q3 };
      }
      function h3n(u) {
        var o = u.icon || "roundRect", n3 = Jy(o, 0, 0, u.itemWidth, u.itemHeight, u.itemStyle.fill, u.symbolKeepAspect);
        return n3.setStyle(u.itemStyle), n3.rotation = (u.iconRotate || 0) * Math.PI / 180, n3.setOrigin([u.itemWidth / 2, u.itemHeight / 2]), o.indexOf("empty") > -1 && (n3.style.stroke = n3.style.fill, n3.style.fill = "#fff", n3.style.lineWidth = 2), n3;
      }
      function d2e(u, o, n3, p2) {
        JVt(u, o, n3, p2), n3.dispatchAction({ type: "legendToggleSelect", name: u != null ? u : o }), QVt(u, o, n3, p2);
      }
      function g2e(u) {
        for (var o = u.getZr().storage.getDisplayList(), n3, p2 = 0, m2 = o.length; p2 < m2 && !(n3 = o[p2].states.emphasis); )
          p2++;
        return n3 && n3.hoverLayer;
      }
      function QVt(u, o, n3, p2) {
        g2e(n3) || n3.dispatchAction({ type: "highlight", seriesName: u, name: o, excludeSeriesId: p2 });
      }
      function JVt(u, o, n3, p2) {
        g2e(n3) || n3.dispatchAction({ type: "downplay", seriesName: u, name: o, excludeSeriesId: p2 });
      }
      var v2e = c3n;
      function p3n(u) {
        var o = u.findComponents({ mainType: "legend" });
        o && o.length && u.filterSeries(function(n3) {
          for (var p2 = 0; p2 < o.length; p2++)
            if (!o[p2].isSelected(n3.name))
              return false;
          return true;
        });
      }
      function kst(u, o, n3) {
        var p2 = {}, m2 = u === "toggleSelected", w2;
        return n3.eachComponent("legend", function(T2) {
          m2 && w2 != null ? T2[w2 ? "select" : "unSelect"](o.name) : u === "allSelect" || u === "inverseSelect" ? T2[u]() : (T2[u](o.name), w2 = T2.isSelected(o.name));
          var E = T2.getData();
          Xe2(E, function(O2) {
            var V3 = O2.get("name");
            if (!(V3 === `
` || V3 === "")) {
              var W3 = T2.isSelected(V3);
              p2.hasOwnProperty(V3) ? p2[V3] = p2[V3] && W3 : p2[V3] = W3;
            }
          });
        }), u === "allSelect" || u === "inverseSelect" ? { selected: p2 } : { name: o.name, selected: p2 };
      }
      function d3n(u) {
        u.registerAction("legendToggleSelect", "legendselectchanged", wu(kst, "toggleSelected")), u.registerAction("legendAllSelect", "legendselectall", wu(kst, "allSelect")), u.registerAction("legendInverseSelect", "legendinverseselect", wu(kst, "inverseSelect")), u.registerAction("legendSelect", "legendselected", wu(kst, "select")), u.registerAction("legendUnSelect", "legendunselected", wu(kst, "unSelect"));
      }
      function y2e(u) {
        u.registerComponentModel(KVt), u.registerComponentView(v2e), u.registerProcessor(u.PRIORITY.PROCESSOR.SERIES_FILTER, p3n), u.registerSubTypeDefaulter("legend", function() {
          return "plain";
        }), d3n(u);
      }
      var g3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.setScrollDataIndex = function(n3) {
          this.option.scrollDataIndex = n3;
        }, o.prototype.init = function(n3, p2, m2) {
          var w2 = Y$(n3);
          u.prototype.init.call(this, n3, p2, m2), m2e(this, n3, w2);
        }, o.prototype.mergeOption = function(n3, p2) {
          u.prototype.mergeOption.call(this, n3, p2), m2e(this, this.option, n3);
        }, o.type = "legend.scroll", o.defaultOption = r8(KVt.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), o;
      }(KVt);
      function m2e(u, o, n3) {
        var p2 = u.getOrient(), m2 = [1, 1];
        m2[p2.index] = 0, i8(o, n3, { type: "box", ignoreSize: !!m2 });
      }
      var v3n = g3n, b2e = uu, tBt = ["width", "height"], eBt = ["x", "y"], y3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.newlineDisabled = true, n3._currentIndex = 0, n3;
        }
        return o.prototype.init = function() {
          u.prototype.init.call(this), this.group.add(this._containerGroup = new b2e()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new b2e());
        }, o.prototype.resetInner = function() {
          u.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
        }, o.prototype.renderInner = function(n3, p2, m2, w2, T2, E, O2) {
          var V3 = this;
          u.prototype.renderInner.call(this, n3, p2, m2, w2, T2, E, O2);
          var W3 = this._controllerGroup, q3 = p2.get("pageIconSize", true), K = za2(q3) ? q3 : [q3, q3];
          rt2("pagePrev", 0);
          var J = p2.getModel("pageTextStyle");
          W3.add(new Zc2({ name: "pageText", style: { text: "xx/xx", fill: J.getTextColor(), font: J.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), rt2("pageNext", 1);
          function rt2(gt, yt) {
            var At = gt + "DataIndex", Lt = yv(p2.get("pageIcons", true)[p2.getOrient().name][yt], { onclick: Is(V3._pageGo, V3, At, p2, w2) }, { x: -K[0] / 2, y: -K[1] / 2, width: K[0], height: K[1] });
            Lt.name = gt, W3.add(Lt);
          }
        }, o.prototype.layoutInner = function(n3, p2, m2, w2, T2, E) {
          var O2 = this.getSelectorGroup(), V3 = n3.getOrient().index, W3 = tBt[V3], q3 = eBt[V3], K = tBt[1 - V3], J = eBt[1 - V3];
          T2 && Ez("horizontal", O2, n3.get("selectorItemGap", true));
          var rt2 = n3.get("selectorButtonGap", true), gt = O2.getBoundingRect(), yt = [-gt.x, -gt.y], At = jl(m2);
          T2 && (At[W3] = m2[W3] - gt[W3] - rt2);
          var Lt = this._layoutContentAndController(n3, w2, At, V3, W3, K, J, q3);
          if (T2) {
            if (E === "end")
              yt[V3] += Lt[W3] + rt2;
            else {
              var Wt = gt[W3] + rt2;
              yt[V3] -= Wt, Lt[q3] -= Wt;
            }
            Lt[W3] += gt[W3] + rt2, yt[1 - V3] += Lt[J] + Lt[K] / 2 - gt[K] / 2, Lt[K] = Math.max(Lt[K], gt[K]), Lt[J] = Math.min(Lt[J], gt[J] + yt[1 - V3]), O2.x = yt[0], O2.y = yt[1], O2.markRedraw();
          }
          return Lt;
        }, o.prototype._layoutContentAndController = function(n3, p2, m2, w2, T2, E, O2, V3) {
          var W3 = this.getContentGroup(), q3 = this._containerGroup, K = this._controllerGroup;
          Ez(n3.get("orient"), W3, n3.get("itemGap"), w2 ? m2.width : null, w2 ? null : m2.height), Ez("horizontal", K, n3.get("pageButtonItemGap", true));
          var J = W3.getBoundingRect(), rt2 = K.getBoundingRect(), gt = this._showController = J[T2] > m2[T2], yt = [-J.x, -J.y];
          p2 || (yt[w2] = W3[V3]);
          var At = [0, 0], Lt = [-rt2.x, -rt2.y], Wt = Xu(n3.get("pageButtonGap", true), n3.get("itemGap", true));
          if (gt) {
            var Nt = n3.get("pageButtonPosition", true);
            Nt === "end" ? Lt[w2] += m2[T2] - rt2[T2] : At[w2] += rt2[T2] + Wt;
          }
          Lt[1 - w2] += J[E] / 2 - rt2[E] / 2, W3.setPosition(yt), q3.setPosition(At), K.setPosition(Lt);
          var ue2 = { x: 0, y: 0 };
          if (ue2[T2] = gt ? m2[T2] : J[T2], ue2[E] = Math.max(J[E], rt2[E]), ue2[O2] = Math.min(0, rt2[O2] + Lt[1 - w2]), q3.__rectSize = m2[T2], gt) {
            var ie2 = { x: 0, y: 0 };
            ie2[T2] = Math.max(m2[T2] - rt2[T2] - Wt, 0), ie2[E] = ue2[E], q3.setClipPath(new Vf2({ shape: ie2 })), q3.__rectSize = ie2[T2];
          } else
            K.eachChild(function(xe) {
              xe.attr({ invisible: true, silent: true });
            });
          var pe2 = this._getPageInfo(n3);
          return pe2.pageIndex != null && Xf2(W3, { x: pe2.contentPosition[0], y: pe2.contentPosition[1] }, gt ? n3 : null), this._updatePageInfoView(n3, pe2), ue2;
        }, o.prototype._pageGo = function(n3, p2, m2) {
          var w2 = this._getPageInfo(p2)[n3];
          w2 != null && m2.dispatchAction({ type: "legendScroll", scrollDataIndex: w2, legendId: p2.id });
        }, o.prototype._updatePageInfoView = function(n3, p2) {
          var m2 = this._controllerGroup;
          Xe2(["pagePrev", "pageNext"], function(W3) {
            var q3 = W3 + "DataIndex", K = p2[q3] != null, J = m2.childOfName(W3);
            J && (J.setStyle("fill", K ? n3.get("pageIconColor", true) : n3.get("pageIconInactiveColor", true)), J.cursor = K ? "pointer" : "default");
          });
          var w2 = m2.childOfName("pageText"), T2 = n3.get("pageFormatter"), E = p2.pageIndex, O2 = E != null ? E + 1 : 0, V3 = p2.pageCount;
          w2 && T2 && w2.setStyle("text", ds(T2) ? T2.replace("{current}", O2 == null ? "" : O2 + "").replace("{total}", V3 == null ? "" : V3 + "") : T2({ current: O2, total: V3 }));
        }, o.prototype._getPageInfo = function(n3) {
          var p2 = n3.get("scrollDataIndex", true), m2 = this.getContentGroup(), w2 = this._containerGroup.__rectSize, T2 = n3.getOrient().index, E = tBt[T2], O2 = eBt[T2], V3 = this._findTargetItemIndex(p2), W3 = m2.children(), q3 = W3[V3], K = W3.length, J = K ? 1 : 0, rt2 = { contentPosition: [m2.x, m2.y], pageCount: J, pageIndex: J - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
          if (!q3)
            return rt2;
          var gt = Nt(q3);
          rt2.contentPosition[T2] = -gt.s;
          for (var yt = V3 + 1, At = gt, Lt = gt, Wt = null; yt <= K; ++yt)
            Wt = Nt(W3[yt]), (!Wt && Lt.e > At.s + w2 || Wt && !ue2(Wt, At.s)) && (Lt.i > At.i ? At = Lt : At = Wt, At && (rt2.pageNextDataIndex == null && (rt2.pageNextDataIndex = At.i), ++rt2.pageCount)), Lt = Wt;
          for (var yt = V3 - 1, At = gt, Lt = gt, Wt = null; yt >= -1; --yt)
            Wt = Nt(W3[yt]), (!Wt || !ue2(Lt, Wt.s)) && At.i < Lt.i && (Lt = At, rt2.pagePrevDataIndex == null && (rt2.pagePrevDataIndex = At.i), ++rt2.pageCount, ++rt2.pageIndex), At = Wt;
          return rt2;
          function Nt(ie2) {
            if (ie2) {
              var pe2 = ie2.getBoundingRect(), xe = pe2[O2] + ie2[O2];
              return { s: xe, e: xe + pe2[E], i: ie2.__legendDataIndex };
            }
          }
          function ue2(ie2, pe2) {
            return ie2.e >= pe2 && ie2.s <= pe2 + w2;
          }
        }, o.prototype._findTargetItemIndex = function(n3) {
          if (!this._showController)
            return 0;
          var p2, m2 = this.getContentGroup(), w2;
          return m2.eachChild(function(T2, E) {
            var O2 = T2.__legendDataIndex;
            w2 == null && O2 != null && (w2 = E), O2 === n3 && (p2 = E);
          }), p2 != null ? p2 : w2;
        }, o.type = "legend.scroll", o;
      }(v2e), m3n = y3n;
      function b3n(u) {
        u.registerAction("legendScroll", "legendscroll", function(o, n3) {
          var p2 = o.scrollDataIndex;
          p2 != null && n3.eachComponent({ mainType: "legend", subType: "scroll", query: o }, function(m2) {
            m2.setScrollDataIndex(p2);
          });
        });
      }
      function _3n(u) {
        Rc2(y2e), u.registerComponentModel(v3n), u.registerComponentView(m3n), b3n(u);
      }
      function x3n(u) {
        Rc2(y2e), Rc2(_3n);
      }
      var w3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "dataZoom.inside", o.defaultOption = r8(Tst.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), o;
      }(Tst), S3n = w3n, nBt = Ff2();
      function M3n(u, o, n3) {
        nBt(u).coordSysRecordMap.each(function(p2) {
          var m2 = p2.dataZoomInfoMap.get(o.uid);
          m2 && (m2.getRange = n3);
        });
      }
      function C3n(u, o) {
        for (var n3 = nBt(u).coordSysRecordMap, p2 = n3.keys(), m2 = 0; m2 < p2.length; m2++) {
          var w2 = p2[m2], T2 = n3.get(w2), E = T2.dataZoomInfoMap;
          if (E) {
            var O2 = o.uid, V3 = E.get(O2);
            V3 && (E.removeKey(O2), E.keys().length || _2e(n3, T2));
          }
        }
      }
      function _2e(u, o) {
        if (o) {
          u.removeKey(o.model.uid);
          var n3 = o.controller;
          n3 && n3.dispose();
        }
      }
      function T3n(u, o) {
        var n3 = { model: o, containsPoint: wu(I3n, o), dispatchAction: wu(A3n, u), dataZoomInfoMap: null, controller: null }, p2 = n3.controller = new ust(u.getZr());
        return Xe2(["pan", "zoom", "scrollMove"], function(m2) {
          p2.on(m2, function(w2) {
            var T2 = [];
            n3.dataZoomInfoMap.each(function(E) {
              if (w2.isAvailableBehavior(E.model.option)) {
                var O2 = (E.getRange || {})[m2], V3 = O2 && O2(E.dzReferCoordSysInfo, n3.model.mainType, n3.controller, w2);
                !E.model.get("disabled", true) && V3 && T2.push({ dataZoomId: E.model.id, start: V3[0], end: V3[1] });
              }
            }), T2.length && n3.dispatchAction(T2);
          });
        }), n3;
      }
      function A3n(u, o) {
        u.isDisposed() || u.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: o });
      }
      function I3n(u, o, n3, p2) {
        return u.coordinateSystem.containPoint([n3, p2]);
      }
      function D3n(u) {
        var o, n3 = "type_", p2 = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, m2 = true;
        return u.each(function(w2) {
          var T2 = w2.model, E = T2.get("disabled", true) ? false : T2.get("zoomLock", true) ? "move" : true;
          p2[n3 + E] > p2[n3 + o] && (o = E), m2 = m2 && T2.get("preventDefaultMouseMove", true);
        }), { controlType: o, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!m2 } };
      }
      function E3n(u) {
        u.registerProcessor(u.PRIORITY.PROCESSOR.FILTER, function(o, n3) {
          var p2 = nBt(n3), m2 = p2.coordSysRecordMap || (p2.coordSysRecordMap = pl());
          m2.each(function(w2) {
            w2.dataZoomInfoMap = null;
          }), o.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(w2) {
            var T2 = vSe(w2);
            Xe2(T2.infoList, function(E) {
              var O2 = E.model.uid, V3 = m2.get(O2) || m2.set(O2, T3n(n3, E.model)), W3 = V3.dataZoomInfoMap || (V3.dataZoomInfoMap = pl());
              W3.set(w2.uid, { dzReferCoordSysInfo: E, model: w2, getRange: null });
            });
          }), m2.each(function(w2) {
            var T2 = w2.controller, E, O2 = w2.dataZoomInfoMap;
            if (O2) {
              var V3 = O2.keys()[0];
              V3 != null && (E = O2.get(V3));
            }
            if (!E) {
              _2e(m2, w2);
              return;
            }
            var W3 = D3n(O2);
            T2.enable(W3.controlType, W3.opt), T2.setPointerChecker(w2.containsPoint), nY(w2, "dispatchAction", E.model.get("throttle", true), "fixRate");
          });
        });
      }
      var k3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "dataZoom.inside", n3;
        }
        return o.prototype.render = function(n3, p2, m2) {
          if (u.prototype.render.apply(this, arguments), n3.noTarget()) {
            this._clear();
            return;
          }
          this.range = n3.getPercentRange(), M3n(m2, n3, { pan: Is(rBt.pan, this), zoom: Is(rBt.zoom, this), scrollMove: Is(rBt.scrollMove, this) });
        }, o.prototype.dispose = function() {
          this._clear(), u.prototype.dispose.apply(this, arguments);
        }, o.prototype._clear = function() {
          C3n(this.api, this.dataZoomModel), this.range = null;
        }, o.type = "dataZoom.inside", o;
      }(EVt), rBt = { zoom: function(u, o, n3, p2) {
        var m2 = this.range, w2 = m2.slice(), T2 = u.axisModels[0];
        if (T2) {
          var E = iBt[o](null, [p2.originX, p2.originY], T2, n3, u), O2 = (E.signal > 0 ? E.pixelStart + E.pixelLength - E.pixel : E.pixel - E.pixelStart) / E.pixelLength * (w2[1] - w2[0]) + w2[0], V3 = Math.max(1 / p2.scale, 0);
          w2[0] = (w2[0] - O2) * V3 + O2, w2[1] = (w2[1] - O2) * V3 + O2;
          var W3 = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
          if (Xz(0, w2, [0, 100], 0, W3.minSpan, W3.maxSpan), this.range = w2, m2[0] !== w2[0] || m2[1] !== w2[1])
            return w2;
        }
      }, pan: x2e(function(u, o, n3, p2, m2, w2) {
        var T2 = iBt[p2]([w2.oldX, w2.oldY], [w2.newX, w2.newY], o, m2, n3);
        return T2.signal * (u[1] - u[0]) * T2.pixel / T2.pixelLength;
      }), scrollMove: x2e(function(u, o, n3, p2, m2, w2) {
        var T2 = iBt[p2]([0, 0], [w2.scrollDelta, w2.scrollDelta], o, m2, n3);
        return T2.signal * (u[1] - u[0]) * w2.scrollDelta;
      }) };
      function x2e(u) {
        return function(o, n3, p2, m2) {
          var w2 = this.range, T2 = w2.slice(), E = o.axisModels[0];
          if (E) {
            var O2 = u(T2, E, o, n3, p2, m2);
            if (Xz(O2, T2, [0, 100], "all"), this.range = T2, w2[0] !== T2[0] || w2[1] !== T2[1])
              return T2;
          }
        };
      }
      var iBt = { grid: function(u, o, n3, p2, m2) {
        var w2 = n3.axis, T2 = {}, E = m2.model.coordinateSystem.getRect();
        return u = u || [0, 0], w2.dim === "x" ? (T2.pixel = o[0] - u[0], T2.pixelLength = E.width, T2.pixelStart = E.x, T2.signal = w2.inverse ? 1 : -1) : (T2.pixel = o[1] - u[1], T2.pixelLength = E.height, T2.pixelStart = E.y, T2.signal = w2.inverse ? -1 : 1), T2;
      }, polar: function(u, o, n3, p2, m2) {
        var w2 = n3.axis, T2 = {}, E = m2.model.coordinateSystem, O2 = E.getRadiusAxis().getExtent(), V3 = E.getAngleAxis().getExtent();
        return u = u ? E.pointToCoord(u) : [0, 0], o = E.pointToCoord(o), n3.mainType === "radiusAxis" ? (T2.pixel = o[0] - u[0], T2.pixelLength = O2[1] - O2[0], T2.pixelStart = O2[0], T2.signal = w2.inverse ? 1 : -1) : (T2.pixel = o[1] - u[1], T2.pixelLength = V3[1] - V3[0], T2.pixelStart = V3[0], T2.signal = w2.inverse ? -1 : 1), T2;
      }, singleAxis: function(u, o, n3, p2, m2) {
        var w2 = n3.axis, T2 = m2.model.coordinateSystem.getRect(), E = {};
        return u = u || [0, 0], w2.orient === "horizontal" ? (E.pixel = o[0] - u[0], E.pixelLength = T2.width, E.pixelStart = T2.x, E.signal = w2.inverse ? 1 : -1) : (E.pixel = o[1] - u[1], E.pixelLength = T2.height, E.pixelStart = T2.y, E.signal = w2.inverse ? -1 : 1), E;
      } }, P3n = k3n;
      function w2e(u) {
        kVt(u), u.registerComponentModel(S3n), u.registerComponentView(P3n), E3n(u);
      }
      var L3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.type = "dataZoom.slider", o.layoutMode = "box", o.defaultOption = r8(Tst.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), o;
      }(Tst), O3n = L3n, Pst = Vf2, S2e = 7, R3n = 1, aBt = 30, N3n = 7, Lst = "horizontal", M2e = "vertical", F3n = 5, V3n = ["line", "bar", "candlestick", "scatter"], B3n = { easing: "cubicOut", duration: 100, delay: 0 }, z3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._displayables = {}, n3;
        }
        return o.prototype.init = function(n3, p2) {
          this.api = p2, this._onBrush = Is(this._onBrush, this), this._onBrushEnd = Is(this._onBrushEnd, this);
        }, o.prototype.render = function(n3, p2, m2, w2) {
          if (u.prototype.render.apply(this, arguments), nY(this, "_dispatchZoomAction", n3.get("throttle"), "fixRate"), this._orient = n3.getOrient(), n3.get("show") === false) {
            this.group.removeAll();
            return;
          }
          if (n3.noTarget()) {
            this._clear(), this.group.removeAll();
            return;
          }
          (!w2 || w2.type !== "dataZoom" || w2.from !== this.uid) && this._buildView(), this._updateView();
        }, o.prototype.dispose = function() {
          this._clear(), u.prototype.dispose.apply(this, arguments);
        }, o.prototype._clear = function() {
          kot(this, "_dispatchZoomAction");
          var n3 = this.api.getZr();
          n3.off("mousemove", this._onBrush), n3.off("mouseup", this._onBrushEnd);
        }, o.prototype._buildView = function() {
          var n3 = this.group;
          n3.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
          var p2 = this._displayables.sliderGroup = new uu();
          this._renderBackground(), this._renderHandle(), this._renderDataShadow(), n3.add(p2), this._positionGroup();
        }, o.prototype._resetLocation = function() {
          var n3 = this.dataZoomModel, p2 = this.api, m2 = n3.get("brushSelect"), w2 = m2 ? N3n : 0, T2 = this._findCoordRect(), E = { width: p2.getWidth(), height: p2.getHeight() }, O2 = this._orient === Lst ? { right: E.width - T2.x - T2.width, top: E.height - aBt - S2e - w2, width: T2.width, height: aBt } : { right: S2e, top: T2.y, width: aBt, height: T2.height }, V3 = Y$(n3.option);
          Xe2(["right", "top", "width", "height"], function(q3) {
            V3[q3] === "ph" && (V3[q3] = O2[q3]);
          });
          var W3 = Bm(V3, E);
          this._location = { x: W3.x, y: W3.y }, this._size = [W3.width, W3.height], this._orient === M2e && this._size.reverse();
        }, o.prototype._positionGroup = function() {
          var n3 = this.group, p2 = this._location, m2 = this._orient, w2 = this.dataZoomModel.getFirstTargetAxisModel(), T2 = w2 && w2.get("inverse"), E = this._displayables.sliderGroup, O2 = (this._dataShadowInfo || {}).otherAxisInverse;
          E.attr(m2 === Lst && !T2 ? { scaleY: O2 ? 1 : -1, scaleX: 1 } : m2 === Lst && T2 ? { scaleY: O2 ? 1 : -1, scaleX: -1 } : m2 === M2e && !T2 ? { scaleY: O2 ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: O2 ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
          var V3 = n3.getBoundingRect([E]);
          n3.x = p2.x - V3.x, n3.y = p2.y - V3.y, n3.markRedraw();
        }, o.prototype._getViewExtent = function() {
          return [0, this._size[0]];
        }, o.prototype._renderBackground = function() {
          var n3 = this.dataZoomModel, p2 = this._size, m2 = this._displayables.sliderGroup, w2 = n3.get("brushSelect");
          m2.add(new Pst({ silent: true, shape: { x: 0, y: 0, width: p2[0], height: p2[1] }, style: { fill: n3.get("backgroundColor") }, z2: -40 }));
          var T2 = new Pst({ shape: { x: 0, y: 0, width: p2[0], height: p2[1] }, style: { fill: "transparent" }, z2: 0, onclick: Is(this._onClickPanel, this) }), E = this.api.getZr();
          w2 ? (T2.on("mousedown", this._onBrushStart, this), T2.cursor = "crosshair", E.on("mousemove", this._onBrush), E.on("mouseup", this._onBrushEnd)) : (E.off("mousemove", this._onBrush), E.off("mouseup", this._onBrushEnd)), m2.add(T2);
        }, o.prototype._renderDataShadow = function() {
          var n3 = this._dataShadowInfo = this._prepareDataShadowInfo();
          if (this._displayables.dataShadowSegs = [], !n3)
            return;
          var p2 = this._size, m2 = this._shadowSize || [], w2 = n3.series, T2 = w2.getRawData(), E = w2.getShadowDim ? w2.getShadowDim() : n3.otherDim;
          if (E == null)
            return;
          var O2 = this._shadowPolygonPts, V3 = this._shadowPolylinePts;
          if (T2 !== this._shadowData || E !== this._shadowDim || p2[0] !== m2[0] || p2[1] !== m2[1]) {
            var W3 = T2.getDataExtent(E), q3 = (W3[1] - W3[0]) * 0.3;
            W3 = [W3[0] - q3, W3[1] + q3];
            var K = [0, p2[1]], J = [0, p2[0]], rt2 = [[p2[0], 0], [0, 0]], gt = [], yt = J[1] / (T2.count() - 1), At = 0, Lt = Math.round(T2.count() / p2[0]), Wt;
            T2.each([E], function(xe, Ce2) {
              if (Lt > 0 && Ce2 % Lt) {
                At += yt;
                return;
              }
              var Le2 = xe == null || isNaN(xe) || xe === "", ze = Le2 ? 0 : bp(xe, W3, K, true);
              Le2 && !Wt && Ce2 ? (rt2.push([rt2[rt2.length - 1][0], 0]), gt.push([gt[gt.length - 1][0], 0])) : !Le2 && Wt && (rt2.push([At, 0]), gt.push([At, 0])), rt2.push([At, ze]), gt.push([At, ze]), At += yt, Wt = Le2;
            }), O2 = this._shadowPolygonPts = rt2, V3 = this._shadowPolylinePts = gt;
          }
          this._shadowData = T2, this._shadowDim = E, this._shadowSize = [p2[0], p2[1]];
          var Nt = this.dataZoomModel;
          function ue2(xe) {
            var Ce2 = Nt.getModel(xe ? "selectedDataBackground" : "dataBackground"), Le2 = new uu(), ze = new Sw({ shape: { points: O2 }, segmentIgnoreThreshold: 1, style: Ce2.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), tn = new Mw({ shape: { points: V3 }, segmentIgnoreThreshold: 1, style: Ce2.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
            return Le2.add(ze), Le2.add(tn), Le2;
          }
          for (var ie2 = 0; ie2 < 3; ie2++) {
            var pe2 = ue2(ie2 === 1);
            this._displayables.sliderGroup.add(pe2), this._displayables.dataShadowSegs.push(pe2);
          }
        }, o.prototype._prepareDataShadowInfo = function() {
          var n3 = this.dataZoomModel, p2 = n3.get("showDataShadow");
          if (p2 !== false) {
            var m2, w2 = this.ecModel;
            return n3.eachTargetAxis(function(T2, E) {
              var O2 = n3.getAxisProxy(T2, E).getTargetSeriesModels();
              Xe2(O2, function(V3) {
                if (!m2 && !(p2 !== true && sc2(V3n, V3.get("type")) < 0)) {
                  var W3 = w2.getComponent(_8(T2), E).axis, q3 = j3n(T2), K, J = V3.coordinateSystem;
                  q3 != null && J.getOtherAxis && (K = J.getOtherAxis(W3).inverse), q3 = V3.getData().mapDimension(q3), m2 = { thisAxis: W3, series: V3, thisDim: T2, otherDim: q3, otherAxisInverse: K };
                }
              }, this);
            }, this), m2;
          }
        }, o.prototype._renderHandle = function() {
          var n3 = this.group, p2 = this._displayables, m2 = p2.handles = [null, null], w2 = p2.handleLabels = [null, null], T2 = this._displayables.sliderGroup, E = this._size, O2 = this.dataZoomModel, V3 = this.api, W3 = O2.get("borderRadius") || 0, q3 = O2.get("brushSelect"), K = p2.filler = new Pst({ silent: q3, style: { fill: O2.get("fillerColor") }, textConfig: { position: "inside" } });
          T2.add(K), T2.add(new Pst({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: E[0], height: E[1], r: W3 }, style: { stroke: O2.get("dataBackgroundColor") || O2.get("borderColor"), lineWidth: R3n, fill: "rgba(0,0,0,0)" } })), Xe2([0, 1], function(Wt) {
            var Nt = O2.get("handleIcon");
            !K_t[Nt] && Nt.indexOf("path://") < 0 && Nt.indexOf("image://") < 0 && (Nt = "path://" + Nt);
            var ue2 = Jy(Nt, -1, 0, 2, 2, null, true);
            ue2.attr({ cursor: C2e(this._orient), draggable: true, drift: Is(this._onDragMove, this, Wt), ondragend: Is(this._onDragEnd, this), onmouseover: Is(this._showDataInfo, this, true), onmouseout: Is(this._showDataInfo, this, false), z2: 5 });
            var ie2 = ue2.getBoundingRect(), pe2 = O2.get("handleSize");
            this._handleHeight = Qo(pe2, this._size[1]), this._handleWidth = ie2.width / ie2.height * this._handleHeight, ue2.setStyle(O2.getModel("handleStyle").getItemStyle()), ue2.style.strokeNoScale = true, ue2.rectHover = true, ue2.ensureState("emphasis").style = O2.getModel(["emphasis", "handleStyle"]).getItemStyle(), m4(ue2);
            var xe = O2.get("handleColor");
            xe != null && (ue2.style.fill = xe), T2.add(m2[Wt] = ue2);
            var Ce2 = O2.getModel("textStyle");
            n3.add(w2[Wt] = new Zc2({ silent: true, invisible: true, style: Cy(Ce2, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: Ce2.getTextColor(), font: Ce2.getFont() }), z2: 10 }));
          }, this);
          var J = K;
          if (q3) {
            var rt2 = Qo(O2.get("moveHandleSize"), E[1]), gt = p2.moveHandle = new Vf2({ style: O2.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: E[1] - 0.5, height: rt2 } }), yt = rt2 * 0.8, At = p2.moveHandleIcon = Jy(O2.get("moveHandleIcon"), -yt / 2, -yt / 2, yt, yt, "#fff", true);
            At.silent = true, At.y = E[1] + rt2 / 2 - 0.5, gt.ensureState("emphasis").style = O2.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
            var Lt = Math.min(E[1] / 2, Math.max(rt2, 10));
            J = p2.moveZone = new Vf2({ invisible: true, shape: { y: E[1] - Lt, height: rt2 + Lt } }), J.on("mouseover", function() {
              V3.enterEmphasis(gt);
            }).on("mouseout", function() {
              V3.leaveEmphasis(gt);
            }), T2.add(gt), T2.add(At), T2.add(J);
          }
          J.attr({ draggable: true, cursor: C2e(this._orient), drift: Is(this._onDragMove, this, "all"), ondragstart: Is(this._showDataInfo, this, true), ondragend: Is(this._onDragEnd, this), onmouseover: Is(this._showDataInfo, this, true), onmouseout: Is(this._showDataInfo, this, false) });
        }, o.prototype._resetInterval = function() {
          var n3 = this._range = this.dataZoomModel.getPercentRange(), p2 = this._getViewExtent();
          this._handleEnds = [bp(n3[0], [0, 100], p2, true), bp(n3[1], [0, 100], p2, true)];
        }, o.prototype._updateInterval = function(n3, p2) {
          var m2 = this.dataZoomModel, w2 = this._handleEnds, T2 = this._getViewExtent(), E = m2.findRepresentativeAxisProxy().getMinMaxSpan(), O2 = [0, 100];
          Xz(p2, w2, T2, m2.get("zoomLock") ? "all" : n3, E.minSpan != null ? bp(E.minSpan, O2, T2, true) : null, E.maxSpan != null ? bp(E.maxSpan, O2, T2, true) : null);
          var V3 = this._range, W3 = this._range = K_([bp(w2[0], T2, O2, true), bp(w2[1], T2, O2, true)]);
          return !V3 || V3[0] !== W3[0] || V3[1] !== W3[1];
        }, o.prototype._updateView = function(n3) {
          var p2 = this._displayables, m2 = this._handleEnds, w2 = K_(m2.slice()), T2 = this._size;
          Xe2([0, 1], function(J) {
            var rt2 = p2.handles[J], gt = this._handleHeight;
            rt2.attr({ scaleX: gt / 2, scaleY: gt / 2, x: m2[J] + (J ? -1 : 1), y: T2[1] / 2 - gt / 2 });
          }, this), p2.filler.setShape({ x: w2[0], y: 0, width: w2[1] - w2[0], height: T2[1] });
          var E = { x: w2[0], width: w2[1] - w2[0] };
          p2.moveHandle && (p2.moveHandle.setShape(E), p2.moveZone.setShape(E), p2.moveZone.getBoundingRect(), p2.moveHandleIcon && p2.moveHandleIcon.attr("x", E.x + E.width / 2));
          for (var O2 = p2.dataShadowSegs, V3 = [0, w2[0], w2[1], T2[0]], W3 = 0; W3 < O2.length; W3++) {
            var q3 = O2[W3], K = q3.getClipPath();
            K || (K = new Vf2(), q3.setClipPath(K)), K.setShape({ x: V3[W3], y: 0, width: V3[W3 + 1] - V3[W3], height: T2[1] });
          }
          this._updateDataInfo(n3);
        }, o.prototype._updateDataInfo = function(n3) {
          var p2 = this.dataZoomModel, m2 = this._displayables, w2 = m2.handleLabels, T2 = this._orient, E = ["", ""];
          if (p2.get("showDetail")) {
            var O2 = p2.findRepresentativeAxisProxy();
            if (O2) {
              var V3 = O2.getAxisModel().axis, W3 = this._range, q3 = n3 ? O2.calculateDataWindow({ start: W3[0], end: W3[1] }).valueWindow : O2.getDataValueWindow();
              E = [this._formatLabel(q3[0], V3), this._formatLabel(q3[1], V3)];
            }
          }
          var K = K_(this._handleEnds.slice());
          J.call(this, 0), J.call(this, 1);
          function J(rt2) {
            var gt = ku(m2.handles[rt2].parent, this.group), yt = Gu(rt2 === 0 ? "right" : "left", gt), At = this._handleWidth / 2 + F3n, Lt = dc2([K[rt2] + (rt2 === 0 ? -At : At), this._size[1] / 2], gt);
            w2[rt2].setStyle({ x: Lt[0], y: Lt[1], verticalAlign: T2 === Lst ? "middle" : yt, align: T2 === Lst ? yt : "center", text: E[rt2] });
          }
        }, o.prototype._formatLabel = function(n3, p2) {
          var m2 = this.dataZoomModel, w2 = m2.get("labelFormatter"), T2 = m2.get("labelPrecision");
          (T2 == null || T2 === "auto") && (T2 = p2.getPixelPrecision());
          var E = n3 == null || isNaN(n3) ? "" : p2.type === "category" || p2.type === "time" ? p2.scale.getLabel({ value: Math.round(n3) }) : n3.toFixed(Math.min(T2, 20));
          return Sl(w2) ? w2(n3, E) : ds(w2) ? w2.replace("{value}", E) : E;
        }, o.prototype._showDataInfo = function(n3) {
          n3 = this._dragging || n3;
          var p2 = this._displayables, m2 = p2.handleLabels;
          m2[0].attr("invisible", !n3), m2[1].attr("invisible", !n3), p2.moveHandle && this.api[n3 ? "enterEmphasis" : "leaveEmphasis"](p2.moveHandle, 1);
        }, o.prototype._onDragMove = function(n3, p2, m2, w2) {
          this._dragging = true, UE(w2.event);
          var T2 = this._displayables.sliderGroup.getLocalTransform(), E = dc2([p2, m2], T2, true), O2 = this._updateInterval(n3, E[0]), V3 = this.dataZoomModel.get("realtime");
          this._updateView(!V3), O2 && V3 && this._dispatchZoomAction(true);
        }, o.prototype._onDragEnd = function() {
          this._dragging = false, this._showDataInfo(false);
          var n3 = this.dataZoomModel.get("realtime");
          !n3 && this._dispatchZoomAction(false);
        }, o.prototype._onClickPanel = function(n3) {
          var p2 = this._size, m2 = this._displayables.sliderGroup.transformCoordToLocal(n3.offsetX, n3.offsetY);
          if (!(m2[0] < 0 || m2[0] > p2[0] || m2[1] < 0 || m2[1] > p2[1])) {
            var w2 = this._handleEnds, T2 = (w2[0] + w2[1]) / 2, E = this._updateInterval("all", m2[0] - T2);
            this._updateView(), E && this._dispatchZoomAction(false);
          }
        }, o.prototype._onBrushStart = function(n3) {
          var p2 = n3.offsetX, m2 = n3.offsetY;
          this._brushStart = new Vu(p2, m2), this._brushing = true, this._brushStartTime = +new Date();
        }, o.prototype._onBrushEnd = function(n3) {
          if (this._brushing) {
            var p2 = this._displayables.brushRect;
            if (this._brushing = false, !!p2) {
              p2.attr("ignore", true);
              var m2 = p2.shape, w2 = +new Date();
              if (!(w2 - this._brushStartTime < 200 && Math.abs(m2.width) < 5)) {
                var T2 = this._getViewExtent(), E = [0, 100];
                this._range = K_([bp(m2.x, T2, E, true), bp(m2.x + m2.width, T2, E, true)]), this._handleEnds = [m2.x, m2.x + m2.width], this._updateView(), this._dispatchZoomAction(false);
              }
            }
          }
        }, o.prototype._onBrush = function(n3) {
          this._brushing && (UE(n3.event), this._updateBrushRect(n3.offsetX, n3.offsetY));
        }, o.prototype._updateBrushRect = function(n3, p2) {
          var m2 = this._displayables, w2 = this.dataZoomModel, T2 = m2.brushRect;
          T2 || (T2 = m2.brushRect = new Pst({ silent: true, style: w2.getModel("brushStyle").getItemStyle() }), m2.sliderGroup.add(T2)), T2.attr("ignore", false);
          var E = this._brushStart, O2 = this._displayables.sliderGroup, V3 = O2.transformCoordToLocal(n3, p2), W3 = O2.transformCoordToLocal(E.x, E.y), q3 = this._size;
          V3[0] = Math.max(Math.min(q3[0], V3[0]), 0), T2.setShape({ x: W3[0], y: 0, width: V3[0] - W3[0], height: q3[1] });
        }, o.prototype._dispatchZoomAction = function(n3) {
          var p2 = this._range;
          this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: n3 ? B3n : null, start: p2[0], end: p2[1] });
        }, o.prototype._findCoordRect = function() {
          var n3, p2 = vSe(this.dataZoomModel).infoList;
          if (!n3 && p2.length) {
            var m2 = p2[0].model.coordinateSystem;
            n3 = m2.getRect && m2.getRect();
          }
          if (!n3) {
            var w2 = this.api.getWidth(), T2 = this.api.getHeight();
            n3 = { x: w2 * 0.2, y: T2 * 0.2, width: w2 * 0.6, height: T2 * 0.6 };
          }
          return n3;
        }, o.type = "dataZoom.slider", o;
      }(EVt);
      function j3n(u) {
        var o = { x: "y", y: "x", radius: "angle", angle: "radius" };
        return o[u];
      }
      function C2e(u) {
        return u === "vertical" ? "ns-resize" : "ew-resize";
      }
      var W3n = z3n;
      function T2e(u) {
        u.registerComponentModel(O3n), u.registerComponentView(W3n), kVt(u);
      }
      function G3n(u) {
        Rc2(w2e), Rc2(T2e);
      }
      var H3n = { get: function(u, o, n3) {
        var p2 = jl((U3n[u] || {})[o]);
        return n3 && za2(p2) ? p2[p2.length - 1] : p2;
      } }, U3n = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, A2e = H3n, I2e = ix.mapVisual, q3n = ix.eachVisual, Z3n = za2, D2e = Xe2, $3n = K_, Y3n = bp, K3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.stateList = ["inRange", "outOfRange"], n3.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], n3.layoutMode = { type: "box", ignoreSize: true }, n3.dataBound = [-1 / 0, 1 / 0], n3.targetVisuals = {}, n3.controllerVisuals = {}, n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          this.mergeDefaultAndTheme(n3, m2);
        }, o.prototype.optionUpdated = function(n3, p2) {
          var m2 = this.option;
          !p2 && qSe(m2, n3, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
        }, o.prototype.resetVisual = function(n3) {
          var p2 = this.stateList;
          n3 = Is(n3, this), this.controllerVisuals = zVt(this.option.controller, p2, n3), this.targetVisuals = zVt(this.option.target, p2, n3);
        }, o.prototype.getItemSymbol = function() {
          return null;
        }, o.prototype.getTargetSeriesIndices = function() {
          var n3 = this.option.seriesIndex, p2 = [];
          return n3 == null || n3 === "all" ? this.ecModel.eachSeries(function(m2, w2) {
            p2.push(w2);
          }) : p2 = Tp(n3), p2;
        }, o.prototype.eachTargetSeries = function(n3, p2) {
          Xe2(this.getTargetSeriesIndices(), function(m2) {
            var w2 = this.ecModel.getSeriesByIndex(m2);
            w2 && n3.call(p2, w2);
          }, this);
        }, o.prototype.isTargetSeries = function(n3) {
          var p2 = false;
          return this.eachTargetSeries(function(m2) {
            m2 === n3 && (p2 = true);
          }), p2;
        }, o.prototype.formatValueText = function(n3, p2, m2) {
          var w2 = this.option, T2 = w2.precision, E = this.dataBound, O2 = w2.formatter, V3;
          m2 = m2 || ["<", ">"], za2(n3) && (n3 = n3.slice(), V3 = true);
          var W3 = p2 ? n3 : V3 ? [q3(n3[0]), q3(n3[1])] : q3(n3);
          if (ds(O2))
            return O2.replace("{value}", V3 ? W3[0] : W3).replace("{value2}", V3 ? W3[1] : W3);
          if (Sl(O2))
            return V3 ? O2(n3[0], n3[1]) : O2(n3);
          if (V3)
            return n3[0] === E[0] ? m2[0] + " " + W3[1] : n3[1] === E[1] ? m2[1] + " " + W3[0] : W3[0] + " - " + W3[1];
          return W3;
          function q3(K) {
            return K === E[0] ? "min" : K === E[1] ? "max" : (+K).toFixed(Math.min(T2, 20));
          }
        }, o.prototype.resetExtent = function() {
          var n3 = this.option, p2 = $3n([n3.min, n3.max]);
          this._dataExtent = p2;
        }, o.prototype.getDataDimensionIndex = function(n3) {
          var p2 = this.option.dimension;
          if (p2 != null)
            return n3.getDimensionIndex(p2);
          for (var m2 = n3.dimensions, w2 = m2.length - 1; w2 >= 0; w2--) {
            var T2 = m2[w2], E = n3.getDimensionInfo(T2);
            if (!E.isCalculationCoord)
              return E.storeDimIndex;
          }
        }, o.prototype.getExtent = function() {
          return this._dataExtent.slice();
        }, o.prototype.completeVisualOption = function() {
          var n3 = this.ecModel, p2 = this.option, m2 = { inRange: p2.inRange, outOfRange: p2.outOfRange }, w2 = p2.target || (p2.target = {}), T2 = p2.controller || (p2.controller = {});
          Cu(w2, m2), Cu(T2, m2);
          var E = this.isCategory();
          O2.call(this, w2), O2.call(this, T2), V3.call(this, w2, "inRange", "outOfRange"), W3.call(this, T2);
          function O2(q3) {
            Z3n(p2.color) && !q3.inRange && (q3.inRange = { color: p2.color.slice().reverse() }), q3.inRange = q3.inRange || { color: n3.get("gradientColor") };
          }
          function V3(q3, K, J) {
            var rt2 = q3[K], gt = q3[J];
            rt2 && !gt && (gt = q3[J] = {}, D2e(rt2, function(yt, At) {
              if (ix.isValidType(At)) {
                var Lt = A2e.get(At, "inactive", E);
                Lt != null && (gt[At] = Lt, At === "color" && !gt.hasOwnProperty("opacity") && !gt.hasOwnProperty("colorAlpha") && (gt.opacity = [0, 0]));
              }
            }));
          }
          function W3(q3) {
            var K = (q3.inRange || {}).symbol || (q3.outOfRange || {}).symbol, J = (q3.inRange || {}).symbolSize || (q3.outOfRange || {}).symbolSize, rt2 = this.get("inactiveColor"), gt = this.getItemSymbol(), yt = gt || "roundRect";
            D2e(this.stateList, function(At) {
              var Lt = this.itemSize, Wt = q3[At];
              Wt || (Wt = q3[At] = { color: E ? rt2 : [rt2] }), Wt.symbol == null && (Wt.symbol = K && jl(K) || (E ? yt : [yt])), Wt.symbolSize == null && (Wt.symbolSize = J && jl(J) || (E ? Lt[0] : [Lt[0], Lt[0]])), Wt.symbol = I2e(Wt.symbol, function(ie2) {
                return ie2 === "none" ? yt : ie2;
              });
              var Nt = Wt.symbolSize;
              if (Nt != null) {
                var ue2 = -1 / 0;
                q3n(Nt, function(ie2) {
                  ie2 > ue2 && (ue2 = ie2);
                }), Wt.symbolSize = I2e(Nt, function(ie2) {
                  return Y3n(ie2, [0, ue2], [0, Lt[0]], true);
                });
              }
            }, this);
          }
        }, o.prototype.resetItemSize = function() {
          this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
        }, o.prototype.isCategory = function() {
          return !!this.option.categories;
        }, o.prototype.setSelected = function(n3) {
        }, o.prototype.getSelected = function() {
          return null;
        }, o.prototype.getValueState = function(n3) {
          return null;
        }, o.prototype.getVisualMeta = function(n3) {
          return null;
        }, o.type = "visualMap", o.dependencies = ["series"], o.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, o;
      }(kh2), bwt = K3n, E2e = [20, 140], X3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.optionUpdated = function(n3, p2) {
          u.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(m2) {
            m2.mappingMethod = "linear", m2.dataExtent = this.getExtent();
          }), this._resetRange();
        }, o.prototype.resetItemSize = function() {
          u.prototype.resetItemSize.apply(this, arguments);
          var n3 = this.itemSize;
          (n3[0] == null || isNaN(n3[0])) && (n3[0] = E2e[0]), (n3[1] == null || isNaN(n3[1])) && (n3[1] = E2e[1]);
        }, o.prototype._resetRange = function() {
          var n3 = this.getExtent(), p2 = this.option.range;
          !p2 || p2.auto ? (n3.auto = 1, this.option.range = n3) : za2(p2) && (p2[0] > p2[1] && p2.reverse(), p2[0] = Math.max(p2[0], n3[0]), p2[1] = Math.min(p2[1], n3[1]));
        }, o.prototype.completeVisualOption = function() {
          u.prototype.completeVisualOption.apply(this, arguments), Xe2(this.stateList, function(n3) {
            var p2 = this.option.controller[n3].symbolSize;
            p2 && p2[0] !== p2[1] && (p2[0] = p2[1] / 3);
          }, this);
        }, o.prototype.setSelected = function(n3) {
          this.option.range = n3.slice(), this._resetRange();
        }, o.prototype.getSelected = function() {
          var n3 = this.getExtent(), p2 = K_((this.get("range") || []).slice());
          return p2[0] > n3[1] && (p2[0] = n3[1]), p2[1] > n3[1] && (p2[1] = n3[1]), p2[0] < n3[0] && (p2[0] = n3[0]), p2[1] < n3[0] && (p2[1] = n3[0]), p2;
        }, o.prototype.getValueState = function(n3) {
          var p2 = this.option.range, m2 = this.getExtent();
          return (p2[0] <= m2[0] || p2[0] <= n3) && (p2[1] >= m2[1] || n3 <= p2[1]) ? "inRange" : "outOfRange";
        }, o.prototype.findTargetDataIndices = function(n3) {
          var p2 = [];
          return this.eachTargetSeries(function(m2) {
            var w2 = [], T2 = m2.getData();
            T2.each(this.getDataDimensionIndex(T2), function(E, O2) {
              n3[0] <= E && E <= n3[1] && w2.push(O2);
            }, this), p2.push({ seriesId: m2.id, dataIndex: w2 });
          }, this), p2;
        }, o.prototype.getVisualMeta = function(n3) {
          var p2 = k2e(this, "outOfRange", this.getExtent()), m2 = k2e(this, "inRange", this.option.range.slice()), w2 = [];
          function T2(J, rt2) {
            w2.push({ value: J, color: n3(J, rt2) });
          }
          for (var E = 0, O2 = 0, V3 = m2.length, W3 = p2.length; O2 < W3 && (!m2.length || p2[O2] <= m2[0]); O2++)
            p2[O2] < m2[E] && T2(p2[O2], "outOfRange");
          for (var q3 = 1; E < V3; E++, q3 = 0)
            q3 && w2.length && T2(m2[E], "outOfRange"), T2(m2[E], "inRange");
          for (var q3 = 1; O2 < W3; O2++)
            (!m2.length || m2[m2.length - 1] < p2[O2]) && (q3 && (w2.length && T2(w2[w2.length - 1].value, "outOfRange"), q3 = 0), T2(p2[O2], "outOfRange"));
          var K = w2.length;
          return { stops: w2, outerColors: [K ? w2[0].color : "transparent", K ? w2[K - 1].color : "transparent"] };
        }, o.type = "visualMap.continuous", o.defaultOption = r8(bwt.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), o;
      }(bwt);
      function k2e(u, o, n3) {
        if (n3[0] === n3[1])
          return n3.slice();
        for (var p2 = 200, m2 = (n3[1] - n3[0]) / p2, w2 = n3[0], T2 = [], E = 0; E <= p2 && w2 < n3[1]; E++)
          T2.push(w2), w2 += m2;
        return T2.push(n3[1]), T2;
      }
      var Q3n = X3n, J3n = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, n3;
        }
        return o.prototype.init = function(n3, p2) {
          this.ecModel = n3, this.api = p2;
        }, o.prototype.render = function(n3, p2, m2, w2) {
          if (this.visualMapModel = n3, n3.get("show") === false) {
            this.group.removeAll();
            return;
          }
          this.doRender(n3, p2, m2, w2);
        }, o.prototype.renderBackground = function(n3) {
          var p2 = this.visualMapModel, m2 = $$(p2.get("padding") || 0), w2 = n3.getBoundingRect();
          n3.add(new Vf2({ z2: -1, silent: true, shape: { x: w2.x - m2[3], y: w2.y - m2[0], width: w2.width + m2[3] + m2[1], height: w2.height + m2[0] + m2[2] }, style: { fill: p2.get("backgroundColor"), stroke: p2.get("borderColor"), lineWidth: p2.get("borderWidth") } }));
        }, o.prototype.getControllerVisual = function(n3, p2, m2) {
          m2 = m2 || {};
          var w2 = m2.forceState, T2 = this.visualMapModel, E = {};
          if (p2 === "color") {
            var O2 = T2.get("contentColor");
            E.color = O2;
          }
          function V3(J) {
            return E[J];
          }
          function W3(J, rt2) {
            E[J] = rt2;
          }
          var q3 = T2.controllerVisuals[w2 || T2.getValueState(n3)], K = ix.prepareVisualTypes(q3);
          return Xe2(K, function(J) {
            var rt2 = q3[J];
            m2.convertOpacityToAlpha && J === "opacity" && (J = "colorAlpha", rt2 = q3.__alphaForOpacity), ix.dependsOn(J, p2) && rt2 && rt2.applyVisual(n3, V3, W3);
          }), E[p2];
        }, o.prototype.positionGroup = function(n3) {
          var p2 = this.visualMapModel, m2 = this.api;
          V_t(n3, p2.getBoxLayoutParams(), { width: m2.getWidth(), height: m2.getHeight() });
        }, o.prototype.doRender = function(n3, p2, m2, w2) {
        }, o.type = "visualMap", o;
      }(C0), P2e = J3n, L2e = [["left", "right", "width"], ["top", "bottom", "height"]];
      function O2e(u, o, n3) {
        var p2 = u.option, m2 = p2.align;
        if (m2 != null && m2 !== "auto")
          return m2;
        for (var w2 = { width: o.getWidth(), height: o.getHeight() }, T2 = p2.orient === "horizontal" ? 1 : 0, E = L2e[T2], O2 = [0, null, 10], V3 = {}, W3 = 0; W3 < 3; W3++)
          V3[L2e[1 - T2][W3]] = O2[W3], V3[E[W3]] = W3 === 2 ? n3[0] : p2[E[W3]];
        var q3 = [["x", "width", 3], ["y", "height", 0]][T2], K = Bm(V3, w2, p2.padding);
        return E[(K.margin[q3[2]] || 0) + K[q3[0]] + K[q3[1]] * 0.5 < w2[q3[1]] * 0.5 ? 0 : 1];
      }
      function _wt(u, o) {
        return Xe2(u || [], function(n3) {
          n3.dataIndex != null && (n3.dataIndexInside = n3.dataIndex, n3.dataIndex = null), n3.highlightKey = "visualMap" + (o ? o.componentIndex : "");
        }), u;
      }
      var JP = bp, tLn = Xe2, R2e = Math.min, oBt = Math.max, eLn = 12, nLn = 6, rLn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._shapes = {}, n3._dataInterval = [], n3._handleEnds = [], n3._hoverLinkDataIndices = [], n3;
        }
        return o.prototype.doRender = function(n3, p2, m2, w2) {
          this._api = m2, (!w2 || w2.type !== "selectDataRange" || w2.from !== this.uid) && this._buildView();
        }, o.prototype._buildView = function() {
          this.group.removeAll();
          var n3 = this.visualMapModel, p2 = this.group;
          this._orient = n3.get("orient"), this._useHandle = n3.get("calculable"), this._resetInterval(), this._renderBar(p2);
          var m2 = n3.get("text");
          this._renderEndsText(p2, m2, 0), this._renderEndsText(p2, m2, 1), this._updateView(true), this.renderBackground(p2), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(p2);
        }, o.prototype._renderEndsText = function(n3, p2, m2) {
          if (p2) {
            var w2 = p2[1 - m2];
            w2 = w2 != null ? w2 + "" : "";
            var T2 = this.visualMapModel, E = T2.get("textGap"), O2 = T2.itemSize, V3 = this._shapes.mainGroup, W3 = this._applyTransform([O2[0] / 2, m2 === 0 ? -E : O2[1] + E], V3), q3 = this._applyTransform(m2 === 0 ? "bottom" : "top", V3), K = this._orient, J = this.visualMapModel.textStyleModel;
            this.group.add(new Zc2({ style: { x: W3[0], y: W3[1], verticalAlign: K === "horizontal" ? "middle" : q3, align: K === "horizontal" ? q3 : "center", text: w2, font: J.getFont(), fill: J.getTextColor() } }));
          }
        }, o.prototype._renderBar = function(n3) {
          var p2 = this.visualMapModel, m2 = this._shapes, w2 = p2.itemSize, T2 = this._orient, E = this._useHandle, O2 = O2e(p2, this.api, w2), V3 = m2.mainGroup = this._createBarGroup(O2), W3 = new uu();
          V3.add(W3), W3.add(m2.outOfRange = N2e()), W3.add(m2.inRange = N2e(null, E ? V2e(this._orient) : null, Is(this._dragHandle, this, "all", false), Is(this._dragHandle, this, "all", true))), W3.setClipPath(new Vf2({ shape: { x: 0, y: 0, width: w2[0], height: w2[1], r: 3 } }));
          var q3 = p2.textStyleModel.getTextRect("\u56FD"), K = oBt(q3.width, q3.height);
          E && (m2.handleThumbs = [], m2.handleLabels = [], m2.handleLabelPoints = [], this._createHandle(p2, V3, 0, w2, K, T2), this._createHandle(p2, V3, 1, w2, K, T2)), this._createIndicator(p2, V3, w2, K, T2), n3.add(V3);
        }, o.prototype._createHandle = function(n3, p2, m2, w2, T2, E) {
          var O2 = Is(this._dragHandle, this, m2, false), V3 = Is(this._dragHandle, this, m2, true), W3 = Rm(n3.get("handleSize"), w2[0]), q3 = Jy(n3.get("handleIcon"), -W3 / 2, -W3 / 2, W3, W3, null, true), K = V2e(this._orient);
          q3.attr({ cursor: K, draggable: true, drift: O2, ondragend: V3, onmousemove: function(At) {
            UE(At.event);
          } }), q3.x = w2[0] / 2, q3.useStyle(n3.getModel("handleStyle").getItemStyle()), q3.setStyle({ strokeNoScale: true, strokeFirst: true }), q3.style.lineWidth *= 2, q3.ensureState("emphasis").style = n3.getModel(["emphasis", "handleStyle"]).getItemStyle(), b4(q3, true), p2.add(q3);
          var J = this.visualMapModel.textStyleModel, rt2 = new Zc2({ cursor: K, draggable: true, drift: O2, onmousemove: function(At) {
            UE(At.event);
          }, ondragend: V3, style: { x: 0, y: 0, text: "", font: J.getFont(), fill: J.getTextColor() } });
          rt2.ensureState("blur").style = { opacity: 0.1 }, rt2.stateTransition = { duration: 200 }, this.group.add(rt2);
          var gt = [W3, 0], yt = this._shapes;
          yt.handleThumbs[m2] = q3, yt.handleLabelPoints[m2] = gt, yt.handleLabels[m2] = rt2;
        }, o.prototype._createIndicator = function(n3, p2, m2, w2, T2) {
          var E = Rm(n3.get("indicatorSize"), m2[0]), O2 = Jy(n3.get("indicatorIcon"), -E / 2, -E / 2, E, E, null, true);
          O2.attr({ cursor: "move", invisible: true, silent: true, x: m2[0] / 2 });
          var V3 = n3.getModel("indicatorStyle").getItemStyle();
          if (O2 instanceof Fm) {
            var W3 = O2.style;
            O2.useStyle(ua2({ image: W3.image, x: W3.x, y: W3.y, width: W3.width, height: W3.height }, V3));
          } else
            O2.useStyle(V3);
          p2.add(O2);
          var q3 = this.visualMapModel.textStyleModel, K = new Zc2({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: q3.getFont(), fill: q3.getTextColor() } });
          this.group.add(K);
          var J = [(T2 === "horizontal" ? w2 / 2 : nLn) + m2[0] / 2, 0], rt2 = this._shapes;
          rt2.indicator = O2, rt2.indicatorLabel = K, rt2.indicatorLabelPoint = J, this._firstShowIndicator = true;
        }, o.prototype._dragHandle = function(n3, p2, m2, w2) {
          if (this._useHandle) {
            if (this._dragging = !p2, !p2) {
              var T2 = this._applyTransform([m2, w2], this._shapes.mainGroup, true);
              this._updateInterval(n3, T2[1]), this._hideIndicator(), this._updateView();
            }
            p2 === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), p2 ? !this._hovering && this._clearHoverLinkToSeries() : F2e(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[n3], false);
          }
        }, o.prototype._resetInterval = function() {
          var n3 = this.visualMapModel, p2 = this._dataInterval = n3.getSelected(), m2 = n3.getExtent(), w2 = [0, n3.itemSize[1]];
          this._handleEnds = [JP(p2[0], m2, w2, true), JP(p2[1], m2, w2, true)];
        }, o.prototype._updateInterval = function(n3, p2) {
          p2 = p2 || 0;
          var m2 = this.visualMapModel, w2 = this._handleEnds, T2 = [0, m2.itemSize[1]];
          Xz(p2, w2, T2, n3, 0);
          var E = m2.getExtent();
          this._dataInterval = [JP(w2[0], T2, E, true), JP(w2[1], T2, E, true)];
        }, o.prototype._updateView = function(n3) {
          var p2 = this.visualMapModel, m2 = p2.getExtent(), w2 = this._shapes, T2 = [0, p2.itemSize[1]], E = n3 ? T2 : this._handleEnds, O2 = this._createBarVisual(this._dataInterval, m2, E, "inRange"), V3 = this._createBarVisual(m2, m2, T2, "outOfRange");
          w2.inRange.setStyle({ fill: O2.barColor }).setShape("points", O2.barPoints), w2.outOfRange.setStyle({ fill: V3.barColor }).setShape("points", V3.barPoints), this._updateHandle(E, O2);
        }, o.prototype._createBarVisual = function(n3, p2, m2, w2) {
          var T2 = { forceState: w2, convertOpacityToAlpha: true }, E = this._makeColorGradient(n3, T2), O2 = [this.getControllerVisual(n3[0], "symbolSize", T2), this.getControllerVisual(n3[1], "symbolSize", T2)], V3 = this._createBarPoints(m2, O2);
          return { barColor: new Mz(0, 0, 0, 1, E), barPoints: V3, handlesColor: [E[0].color, E[E.length - 1].color] };
        }, o.prototype._makeColorGradient = function(n3, p2) {
          var m2 = 100, w2 = [], T2 = (n3[1] - n3[0]) / m2;
          w2.push({ color: this.getControllerVisual(n3[0], "color", p2), offset: 0 });
          for (var E = 1; E < m2; E++) {
            var O2 = n3[0] + T2 * E;
            if (O2 > n3[1])
              break;
            w2.push({ color: this.getControllerVisual(O2, "color", p2), offset: E / m2 });
          }
          return w2.push({ color: this.getControllerVisual(n3[1], "color", p2), offset: 1 }), w2;
        }, o.prototype._createBarPoints = function(n3, p2) {
          var m2 = this.visualMapModel.itemSize;
          return [[m2[0] - p2[0], n3[0]], [m2[0], n3[0]], [m2[0], n3[1]], [m2[0] - p2[1], n3[1]]];
        }, o.prototype._createBarGroup = function(n3) {
          var p2 = this._orient, m2 = this.visualMapModel.get("inverse");
          return new uu(p2 === "horizontal" && !m2 ? { scaleX: n3 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : p2 === "horizontal" && m2 ? { scaleX: n3 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : p2 === "vertical" && !m2 ? { scaleX: n3 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: n3 === "left" ? 1 : -1 });
        }, o.prototype._updateHandle = function(n3, p2) {
          if (this._useHandle) {
            var m2 = this._shapes, w2 = this.visualMapModel, T2 = m2.handleThumbs, E = m2.handleLabels, O2 = w2.itemSize, V3 = w2.getExtent();
            tLn([0, 1], function(W3) {
              var q3 = T2[W3];
              q3.setStyle("fill", p2.handlesColor[W3]), q3.y = n3[W3];
              var K = JP(n3[W3], [0, O2[1]], V3, true), J = this.getControllerVisual(K, "symbolSize");
              q3.scaleX = q3.scaleY = J / O2[0], q3.x = O2[0] - J / 2;
              var rt2 = dc2(m2.handleLabelPoints[W3], ku(q3, this.group));
              E[W3].setStyle({ x: rt2[0], y: rt2[1], text: w2.formatValueText(this._dataInterval[W3]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", m2.mainGroup) : "center" });
            }, this);
          }
        }, o.prototype._showIndicator = function(n3, p2, m2, w2) {
          var T2 = this.visualMapModel, E = T2.getExtent(), O2 = T2.itemSize, V3 = [0, O2[1]], W3 = this._shapes, q3 = W3.indicator;
          if (q3) {
            q3.attr("invisible", false);
            var K = { convertOpacityToAlpha: true }, J = this.getControllerVisual(n3, "color", K), rt2 = this.getControllerVisual(n3, "symbolSize"), gt = JP(n3, E, V3, true), yt = O2[0] - rt2 / 2, At = { x: q3.x, y: q3.y };
            q3.y = gt, q3.x = yt;
            var Lt = dc2(W3.indicatorLabelPoint, ku(q3, this.group)), Wt = W3.indicatorLabel;
            Wt.attr("invisible", false);
            var Nt = this._applyTransform("left", W3.mainGroup), ue2 = this._orient, ie2 = ue2 === "horizontal";
            Wt.setStyle({ text: (m2 || "") + T2.formatValueText(p2), verticalAlign: ie2 ? Nt : "middle", align: ie2 ? "center" : Nt });
            var pe2 = { x: yt, y: gt, style: { fill: J } }, xe = { style: { x: Lt[0], y: Lt[1] } };
            if (T2.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
              var Ce2 = { duration: 100, easing: "cubicInOut", additive: true };
              q3.x = At.x, q3.y = At.y, q3.animateTo(pe2, Ce2), Wt.animateTo(xe, Ce2);
            } else
              q3.attr(pe2), Wt.attr(xe);
            this._firstShowIndicator = false;
            var Le2 = this._shapes.handleLabels;
            if (Le2)
              for (var ze = 0; ze < Le2.length; ze++)
                this._api.enterBlur(Le2[ze]);
          }
        }, o.prototype._enableHoverLinkToSeries = function() {
          var n3 = this;
          this._shapes.mainGroup.on("mousemove", function(p2) {
            if (n3._hovering = true, !n3._dragging) {
              var m2 = n3.visualMapModel.itemSize, w2 = n3._applyTransform([p2.offsetX, p2.offsetY], n3._shapes.mainGroup, true, true);
              w2[1] = R2e(oBt(0, w2[1]), m2[1]), n3._doHoverLinkToSeries(w2[1], 0 <= w2[0] && w2[0] <= m2[0]);
            }
          }).on("mouseout", function() {
            n3._hovering = false, !n3._dragging && n3._clearHoverLinkToSeries();
          });
        }, o.prototype._enableHoverLinkFromSeries = function() {
          var n3 = this.api.getZr();
          this.visualMapModel.option.hoverLink ? (n3.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), n3.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
        }, o.prototype._doHoverLinkToSeries = function(n3, p2) {
          var m2 = this.visualMapModel, w2 = m2.itemSize;
          if (m2.option.hoverLink) {
            var T2 = [0, w2[1]], E = m2.getExtent();
            n3 = R2e(oBt(T2[0], n3), T2[1]);
            var O2 = iLn(m2, E, T2), V3 = [n3 - O2, n3 + O2], W3 = JP(n3, T2, E, true), q3 = [JP(V3[0], T2, E, true), JP(V3[1], T2, E, true)];
            V3[0] < T2[0] && (q3[0] = -1 / 0), V3[1] > T2[1] && (q3[1] = 1 / 0), p2 && (q3[0] === -1 / 0 ? this._showIndicator(W3, q3[1], "< ", O2) : q3[1] === 1 / 0 ? this._showIndicator(W3, q3[0], "> ", O2) : this._showIndicator(W3, W3, "\u2248 ", O2));
            var K = this._hoverLinkDataIndices, J = [];
            (p2 || F2e(m2)) && (J = this._hoverLinkDataIndices = m2.findTargetDataIndices(q3));
            var rt2 = xNt(K, J);
            this._dispatchHighDown("downplay", _wt(rt2[0], m2)), this._dispatchHighDown("highlight", _wt(rt2[1], m2));
          }
        }, o.prototype._hoverLinkFromSeriesMouseOver = function(n3) {
          var p2 = n3.target, m2 = this.visualMapModel;
          if (!(!p2 || is(p2).dataIndex == null)) {
            var w2 = is(p2), T2 = this.ecModel.getSeriesByIndex(w2.seriesIndex);
            if (m2.isTargetSeries(T2)) {
              var E = T2.getData(w2.dataType), O2 = E.getStore().get(m2.getDataDimensionIndex(E), w2.dataIndex);
              isNaN(O2) || this._showIndicator(O2, O2);
            }
          }
        }, o.prototype._hideIndicator = function() {
          var n3 = this._shapes;
          n3.indicator && n3.indicator.attr("invisible", true), n3.indicatorLabel && n3.indicatorLabel.attr("invisible", true);
          var p2 = this._shapes.handleLabels;
          if (p2)
            for (var m2 = 0; m2 < p2.length; m2++)
              this._api.leaveBlur(p2[m2]);
        }, o.prototype._clearHoverLinkToSeries = function() {
          this._hideIndicator();
          var n3 = this._hoverLinkDataIndices;
          this._dispatchHighDown("downplay", _wt(n3, this.visualMapModel)), n3.length = 0;
        }, o.prototype._clearHoverLinkFromSeries = function() {
          this._hideIndicator();
          var n3 = this.api.getZr();
          n3.off("mouseover", this._hoverLinkFromSeriesMouseOver), n3.off("mouseout", this._hideIndicator);
        }, o.prototype._applyTransform = function(n3, p2, m2, w2) {
          var T2 = ku(p2, w2 ? null : this.group);
          return za2(n3) ? dc2(n3, T2, m2) : Gu(n3, T2, m2);
        }, o.prototype._dispatchHighDown = function(n3, p2) {
          p2 && p2.length && this.api.dispatchAction({ type: n3, batch: p2 });
        }, o.prototype.dispose = function() {
          this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
        }, o.prototype.remove = function() {
          this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
        }, o.type = "visualMap.continuous", o;
      }(P2e);
      function N2e(u, o, n3, p2) {
        return new Sw({ shape: { points: u }, draggable: !!n3, cursor: o, drift: n3, onmousemove: function(m2) {
          UE(m2.event);
        }, ondragend: p2 });
      }
      function iLn(u, o, n3) {
        var p2 = eLn / 2, m2 = u.get("hoverLinkDataSize");
        return m2 && (p2 = JP(m2, o, n3, true) / 2), p2;
      }
      function F2e(u) {
        var o = u.get("hoverLinkOnHandle");
        return !!(o == null ? u.get("realtime") : o);
      }
      function V2e(u) {
        return u === "vertical" ? "ns-resize" : "ew-resize";
      }
      var aLn = rLn, oLn = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, sLn = function(u, o) {
        o.eachComponent({ mainType: "visualMap", query: u }, function(n3) {
          n3.setSelected(u.selected);
        });
      }, lLn = [{ createOnAllSeries: true, reset: function(u, o) {
        var n3 = [];
        return o.eachComponent("visualMap", function(p2) {
          var m2 = u.pipelineContext;
          !p2.isTargetSeries(u) || m2 && m2.large || n3.push(nPn(p2.stateList, p2.targetVisuals, Is(p2.getValueState, p2), p2.getDataDimensionIndex(u.getData())));
        }), n3;
      } }, { createOnAllSeries: true, reset: function(u, o) {
        var n3 = u.getData(), p2 = [];
        o.eachComponent("visualMap", function(m2) {
          if (m2.isTargetSeries(u)) {
            var w2 = m2.getVisualMeta(Is(uLn, null, u, m2)) || { stops: [], outerColors: [] }, T2 = m2.getDataDimensionIndex(n3);
            T2 >= 0 && (w2.dimension = T2, p2.push(w2));
          }
        }), u.getData().setVisual("visualMeta", p2);
      } }];
      function uLn(u, o, n3, p2) {
        for (var m2 = o.targetVisuals[p2], w2 = ix.prepareVisualTypes(m2), T2 = { color: Oot(u.getData(), "color") }, E = 0, O2 = w2.length; E < O2; E++) {
          var V3 = w2[E], W3 = m2[V3 === "opacity" ? "__alphaForOpacity" : V3];
          W3 && W3.applyVisual(n3, q3, K);
        }
        return T2.color;
        function q3(J) {
          return T2[J];
        }
        function K(J, rt2) {
          T2[J] = rt2;
        }
      }
      var B2e = Xe2;
      function cLn(u) {
        var o = u && u.visualMap;
        za2(o) || (o = o ? [o] : []), B2e(o, function(n3) {
          if (n3) {
            AY(n3, "splitList") && !AY(n3, "pieces") && (n3.pieces = n3.splitList, delete n3.splitList);
            var p2 = n3.pieces;
            p2 && za2(p2) && B2e(p2, function(m2) {
              ys(m2) && (AY(m2, "start") && !AY(m2, "min") && (m2.min = m2.start), AY(m2, "end") && !AY(m2, "max") && (m2.max = m2.end));
            });
          }
        });
      }
      function AY(u, o) {
        return u && u.hasOwnProperty && u.hasOwnProperty(o);
      }
      var z2e = false;
      function j2e(u) {
        z2e || (z2e = true, u.registerSubTypeDefaulter("visualMap", function(o) {
          return !o.categories && (!(o.pieces ? o.pieces.length > 0 : o.splitNumber > 0) || o.calculable) ? "continuous" : "piecewise";
        }), u.registerAction(oLn, sLn), Xe2(lLn, function(o) {
          u.registerVisual(u.PRIORITY.VISUAL.COMPONENT, o);
        }), u.registerPreprocessor(cLn));
      }
      function W2e(u) {
        u.registerComponentModel(Q3n), u.registerComponentView(aLn), j2e(u);
      }
      var fLn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3._pieceList = [], n3;
        }
        return o.prototype.optionUpdated = function(n3, p2) {
          u.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
          var m2 = this._mode = this._determineMode();
          this._pieceList = [], hLn[this._mode].call(this, this._pieceList), this._resetSelected(n3, p2);
          var w2 = this.option.categories;
          this.resetVisual(function(T2, E) {
            m2 === "categories" ? (T2.mappingMethod = "category", T2.categories = jl(w2)) : (T2.dataExtent = this.getExtent(), T2.mappingMethod = "piecewise", T2.pieceList = Ya2(this._pieceList, function(O2) {
              return O2 = jl(O2), E !== "inRange" && (O2.visual = null), O2;
            }));
          });
        }, o.prototype.completeVisualOption = function() {
          var n3 = this.option, p2 = {}, m2 = ix.listVisualTypes(), w2 = this.isCategory();
          Xe2(n3.pieces, function(E) {
            Xe2(m2, function(O2) {
              E.hasOwnProperty(O2) && (p2[O2] = 1);
            });
          }), Xe2(p2, function(E, O2) {
            var V3 = false;
            Xe2(this.stateList, function(W3) {
              V3 = V3 || T2(n3, W3, O2) || T2(n3.target, W3, O2);
            }, this), !V3 && Xe2(this.stateList, function(W3) {
              (n3[W3] || (n3[W3] = {}))[O2] = A2e.get(O2, W3 === "inRange" ? "active" : "inactive", w2);
            });
          }, this);
          function T2(E, O2, V3) {
            return E && E[O2] && E[O2].hasOwnProperty(V3);
          }
          u.prototype.completeVisualOption.apply(this, arguments);
        }, o.prototype._resetSelected = function(n3, p2) {
          var m2 = this.option, w2 = this._pieceList, T2 = (p2 ? m2 : n3).selected || {};
          if (m2.selected = T2, Xe2(w2, function(O2, V3) {
            var W3 = this.getSelectedMapKey(O2);
            T2.hasOwnProperty(W3) || (T2[W3] = true);
          }, this), m2.selectedMode === "single") {
            var E = false;
            Xe2(w2, function(O2, V3) {
              var W3 = this.getSelectedMapKey(O2);
              T2[W3] && (E ? T2[W3] = false : E = true);
            }, this);
          }
        }, o.prototype.getItemSymbol = function() {
          return this.get("itemSymbol");
        }, o.prototype.getSelectedMapKey = function(n3) {
          return this._mode === "categories" ? n3.value + "" : n3.index + "";
        }, o.prototype.getPieceList = function() {
          return this._pieceList;
        }, o.prototype._determineMode = function() {
          var n3 = this.option;
          return n3.pieces && n3.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
        }, o.prototype.setSelected = function(n3) {
          this.option.selected = jl(n3);
        }, o.prototype.getValueState = function(n3) {
          var p2 = ix.findPieceIndex(n3, this._pieceList);
          return p2 != null && this.option.selected[this.getSelectedMapKey(this._pieceList[p2])] ? "inRange" : "outOfRange";
        }, o.prototype.findTargetDataIndices = function(n3) {
          var p2 = [], m2 = this._pieceList;
          return this.eachTargetSeries(function(w2) {
            var T2 = [], E = w2.getData();
            E.each(this.getDataDimensionIndex(E), function(O2, V3) {
              var W3 = ix.findPieceIndex(O2, m2);
              W3 === n3 && T2.push(V3);
            }, this), p2.push({ seriesId: w2.id, dataIndex: T2 });
          }, this), p2;
        }, o.prototype.getRepresentValue = function(n3) {
          var p2;
          if (this.isCategory())
            p2 = n3.value;
          else if (n3.value != null)
            p2 = n3.value;
          else {
            var m2 = n3.interval || [];
            p2 = m2[0] === -1 / 0 && m2[1] === 1 / 0 ? 0 : (m2[0] + m2[1]) / 2;
          }
          return p2;
        }, o.prototype.getVisualMeta = function(n3) {
          if (this.isCategory())
            return;
          var p2 = [], m2 = ["", ""], w2 = this;
          function T2(W3, q3) {
            var K = w2.getRepresentValue({ interval: W3 });
            q3 || (q3 = w2.getValueState(K));
            var J = n3(K, q3);
            W3[0] === -1 / 0 ? m2[0] = J : W3[1] === 1 / 0 ? m2[1] = J : p2.push({ value: W3[0], color: J }, { value: W3[1], color: J });
          }
          var E = this._pieceList.slice();
          if (!E.length)
            E.push({ interval: [-1 / 0, 1 / 0] });
          else {
            var O2 = E[0].interval[0];
            O2 !== -1 / 0 && E.unshift({ interval: [-1 / 0, O2] }), O2 = E[E.length - 1].interval[1], O2 !== 1 / 0 && E.push({ interval: [O2, 1 / 0] });
          }
          var V3 = -1 / 0;
          return Xe2(E, function(W3) {
            var q3 = W3.interval;
            q3 && (q3[0] > V3 && T2([V3, q3[0]], "outOfRange"), T2(q3.slice()), V3 = q3[1]);
          }, this), { stops: p2, outerColors: m2 };
        }, o.type = "visualMap.piecewise", o.defaultOption = r8(bwt.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), o;
      }(bwt), hLn = { splitNumber: function(u) {
        var o = this.option, n3 = Math.min(o.precision, 20), p2 = this.getExtent(), m2 = o.splitNumber;
        m2 = Math.max(parseInt(m2, 10), 1), o.splitNumber = m2;
        for (var w2 = (p2[1] - p2[0]) / m2; +w2.toFixed(n3) !== w2 && n3 < 5; )
          n3++;
        o.precision = n3, w2 = +w2.toFixed(n3), o.minOpen && u.push({ interval: [-1 / 0, p2[0]], close: [0, 0] });
        for (var T2 = 0, E = p2[0]; T2 < m2; E += w2, T2++) {
          var O2 = T2 === m2 - 1 ? p2[1] : E + w2;
          u.push({ interval: [E, O2], close: [1, 1] });
        }
        o.maxOpen && u.push({ interval: [p2[1], 1 / 0], close: [0, 0] }), ybt(u), Xe2(u, function(V3, W3) {
          V3.index = W3, V3.text = this.formatValueText(V3.interval);
        }, this);
      }, categories: function(u) {
        var o = this.option;
        Xe2(o.categories, function(n3) {
          u.push({ text: this.formatValueText(n3, true), value: n3 });
        }, this), G2e(o, u);
      }, pieces: function(u) {
        var o = this.option;
        Xe2(o.pieces, function(n3, p2) {
          ys(n3) || (n3 = { value: n3 });
          var m2 = { text: "", index: p2 };
          if (n3.label != null && (m2.text = n3.label), n3.hasOwnProperty("value")) {
            var w2 = m2.value = n3.value;
            m2.interval = [w2, w2], m2.close = [1, 1];
          } else {
            for (var T2 = m2.interval = [], E = m2.close = [0, 0], O2 = [1, 0, 1], V3 = [-1 / 0, 1 / 0], W3 = [], q3 = 0; q3 < 2; q3++) {
              for (var K = [["gte", "gt", "min"], ["lte", "lt", "max"]][q3], J = 0; J < 3 && T2[q3] == null; J++)
                T2[q3] = n3[K[J]], E[q3] = O2[J], W3[q3] = J === 2;
              T2[q3] == null && (T2[q3] = V3[q3]);
            }
            W3[0] && T2[1] === 1 / 0 && (E[0] = 0), W3[1] && T2[0] === -1 / 0 && (E[1] = 0), T2[0] === T2[1] && E[0] && E[1] && (m2.value = T2[0]);
          }
          m2.visual = ix.retrieveVisuals(n3), u.push(m2);
        }, this), G2e(o, u), ybt(u), Xe2(u, function(n3) {
          var p2 = n3.close, m2 = [["<", "\u2264"][p2[1]], [">", "\u2265"][p2[0]]];
          n3.text = n3.text || this.formatValueText(n3.value != null ? n3.value : n3.interval, false, m2);
        }, this);
      } };
      function G2e(u, o) {
        var n3 = u.inverse;
        (u.orient === "vertical" ? !n3 : n3) && o.reverse();
      }
      var pLn = fLn, dLn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = o.type, n3;
        }
        return o.prototype.doRender = function() {
          var n3 = this.group;
          n3.removeAll();
          var p2 = this.visualMapModel, m2 = p2.get("textGap"), w2 = p2.textStyleModel, T2 = w2.getFont(), E = w2.getTextColor(), O2 = this._getItemAlign(), V3 = p2.itemSize, W3 = this._getViewData(), q3 = W3.endsText, K = $y(p2.get("showLabel", true), !q3);
          q3 && this._renderEndsText(n3, q3[0], V3, K, O2), Xe2(W3.viewPieceList, function(J) {
            var rt2 = J.piece, gt = new uu();
            gt.onclick = Is(this._onItemClick, this, rt2), this._enableHoverLink(gt, J.indexInModelPieceList);
            var yt = p2.getRepresentValue(rt2);
            if (this._createItemSymbol(gt, yt, [0, 0, V3[0], V3[1]]), K) {
              var At = this.visualMapModel.getValueState(yt);
              gt.add(new Zc2({ style: { x: O2 === "right" ? -m2 : V3[0] + m2, y: V3[1] / 2, text: rt2.text, verticalAlign: "middle", align: O2, font: T2, fill: E, opacity: At === "outOfRange" ? 0.5 : 1 } }));
            }
            n3.add(gt);
          }, this), q3 && this._renderEndsText(n3, q3[1], V3, K, O2), Ez(p2.get("orient"), n3, p2.get("itemGap")), this.renderBackground(n3), this.positionGroup(n3);
        }, o.prototype._enableHoverLink = function(n3, p2) {
          var m2 = this;
          n3.on("mouseover", function() {
            return w2("highlight");
          }).on("mouseout", function() {
            return w2("downplay");
          });
          var w2 = function(T2) {
            var E = m2.visualMapModel;
            E.option.hoverLink && m2.api.dispatchAction({ type: T2, batch: _wt(E.findTargetDataIndices(p2), E) });
          };
        }, o.prototype._getItemAlign = function() {
          var n3 = this.visualMapModel, p2 = n3.option;
          if (p2.orient === "vertical")
            return O2e(n3, this.api, n3.itemSize);
          var m2 = p2.align;
          return (!m2 || m2 === "auto") && (m2 = "left"), m2;
        }, o.prototype._renderEndsText = function(n3, p2, m2, w2, T2) {
          if (p2) {
            var E = new uu(), O2 = this.visualMapModel.textStyleModel;
            E.add(new Zc2({ style: { x: w2 ? T2 === "right" ? m2[0] : 0 : m2[0] / 2, y: m2[1] / 2, verticalAlign: "middle", align: w2 ? T2 : "center", text: p2, font: O2.getFont(), fill: O2.getTextColor() } })), n3.add(E);
          }
        }, o.prototype._getViewData = function() {
          var n3 = this.visualMapModel, p2 = Ya2(n3.getPieceList(), function(E, O2) {
            return { piece: E, indexInModelPieceList: O2 };
          }), m2 = n3.get("text"), w2 = n3.get("orient"), T2 = n3.get("inverse");
          return (w2 === "horizontal" ? T2 : !T2) ? p2.reverse() : m2 && (m2 = m2.slice().reverse()), { viewPieceList: p2, endsText: m2 };
        }, o.prototype._createItemSymbol = function(n3, p2, m2) {
          n3.add(Jy(this.getControllerVisual(p2, "symbol"), m2[0], m2[1], m2[2], m2[3], this.getControllerVisual(p2, "color")));
        }, o.prototype._onItemClick = function(n3) {
          var p2 = this.visualMapModel, m2 = p2.option, w2 = jl(m2.selected), T2 = p2.getSelectedMapKey(n3);
          m2.selectedMode === "single" ? (w2[T2] = true, Xe2(w2, function(E, O2) {
            w2[O2] = O2 === T2;
          })) : w2[T2] = !w2[T2], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: w2 });
        }, o.type = "visualMap.piecewise", o;
      }(P2e), gLn = dLn;
      function H2e(u) {
        u.registerComponentModel(pLn), u.registerComponentView(gLn), j2e(u);
      }
      function vLn(u) {
        Rc2(W2e), Rc2(H2e);
      }
      var yLn = { label: { enabled: true }, decal: { show: false } }, U2e = Ff2(), mLn = {};
      function bLn(u, o) {
        var n3 = u.getModel("aria");
        if (!n3.get("enabled"))
          return;
        var p2 = jl(yLn);
        Cu(p2.label, u.getLocaleModel().get("aria"), false), Cu(n3.option, p2, false), m2(), w2();
        function m2() {
          var V3 = n3.getModel("decal"), W3 = V3.get("show");
          if (W3) {
            var q3 = pl();
            u.eachSeries(function(K) {
              if (!K.isColorBySeries()) {
                var J = q3.get(K.type);
                J || (J = {}, q3.set(K.type, J)), U2e(K).scope = J;
              }
            }), u.eachRawSeries(function(K) {
              if (u.isSeriesFiltered(K))
                return;
              if (Sl(K.enableAriaDecal)) {
                K.enableAriaDecal();
                return;
              }
              var J = K.getData();
              if (K.isColorBySeries()) {
                var rt2 = h8t(K.ecModel, K.name, mLn, u.getSeriesCount()), gt = J.getVisual("decal");
                J.setVisual("decal", Nt(gt, rt2));
              } else {
                var yt = K.getRawData(), At = {}, Lt = U2e(K).scope;
                J.each(function(ue2) {
                  var ie2 = J.getRawIndex(ue2);
                  At[ie2] = ue2;
                });
                var Wt = yt.count();
                yt.each(function(ue2) {
                  var ie2 = At[ue2], pe2 = yt.getName(ue2) || ue2 + "", xe = h8t(K.ecModel, pe2, Lt, Wt), Ce2 = J.getItemVisual(ie2, "decal");
                  J.setItemVisual(ie2, "decal", Nt(Ce2, xe));
                });
              }
              function Nt(ue2, ie2) {
                var pe2 = ue2 ? ua2(ua2({}, ie2), ue2) : ie2;
                return pe2.dirty = true, pe2;
              }
            });
          }
        }
        function w2() {
          var V3 = u.getLocaleModel().get("aria"), W3 = n3.getModel("label");
          if (W3.option = kl(W3.option, V3), !!W3.get("enabled")) {
            var q3 = o.getZr().dom;
            if (W3.get("description")) {
              q3.setAttribute("aria-label", W3.get("description"));
              return;
            }
            var K = u.getSeriesCount(), J = W3.get(["data", "maxCount"]) || 10, rt2 = W3.get(["series", "maxCount"]) || 10, gt = Math.min(K, rt2), yt;
            if (!(K < 1)) {
              var At = E();
              if (At) {
                var Lt = W3.get(["general", "withTitle"]);
                yt = T2(Lt, { title: At });
              } else
                yt = W3.get(["general", "withoutTitle"]);
              var Wt = [], Nt = K > 1 ? W3.get(["series", "multiple", "prefix"]) : W3.get(["series", "single", "prefix"]);
              yt += T2(Nt, { seriesCount: K }), u.eachSeries(function(xe, Ce2) {
                if (Ce2 < gt) {
                  var Le2 = void 0, ze = xe.get("name"), tn = ze ? "withName" : "withoutName";
                  Le2 = K > 1 ? W3.get(["series", "multiple", tn]) : W3.get(["series", "single", tn]), Le2 = T2(Le2, { seriesId: xe.seriesIndex, seriesName: xe.get("name"), seriesType: O2(xe.subType) });
                  var $e2 = xe.getData();
                  if ($e2.count() > J) {
                    var Tn = W3.get(["data", "partialData"]);
                    Le2 += T2(Tn, { displayCnt: J });
                  } else
                    Le2 += W3.get(["data", "allData"]);
                  for (var zn = W3.get(["data", "separator", "middle"]), bn = W3.get(["data", "separator", "end"]), Xr = [], Xn = 0; Xn < $e2.count(); Xn++)
                    if (Xn < J) {
                      var or = $e2.getName(Xn), Tr = $e2.getValues(Xn), ci2 = W3.get(["data", or ? "withName" : "withoutName"]);
                      Xr.push(T2(ci2, { name: or, value: Tr.join(zn) }));
                    }
                  Le2 += Xr.join(zn) + bn, Wt.push(Le2);
                }
              });
              var ue2 = W3.getModel(["series", "multiple", "separator"]), ie2 = ue2.get("middle"), pe2 = ue2.get("end");
              yt += Wt.join(ie2) + pe2, q3.setAttribute("aria-label", yt);
            }
          }
        }
        function T2(V3, W3) {
          if (!ds(V3))
            return V3;
          var q3 = V3;
          return Xe2(W3, function(K, J) {
            q3 = q3.replace(new RegExp("\\{\\s*" + J + "\\s*\\}", "g"), K);
          }), q3;
        }
        function E() {
          var V3 = u.get("title");
          return V3 && V3.length && (V3 = V3[0]), V3 && V3.text;
        }
        function O2(V3) {
          return u.getLocaleModel().get(["series", "typeNames"])[V3] || "\u81EA\u5B9A\u4E49\u56FE";
        }
      }
      function _Ln(u) {
        if (!(!u || !u.aria)) {
          var o = u.aria;
          o.show != null && (o.enabled = o.show), o.label = o.label || {}, Xe2(["description", "general", "series", "data"], function(n3) {
            o[n3] != null && (o.label[n3] = o[n3]);
          });
        }
      }
      function xLn(u) {
        u.registerPreprocessor(_Ln), u.registerVisual(u.PRIORITY.VISUAL.ARIA, bLn);
      }
      var q2e = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, wLn = function() {
        function u(o) {
          var n3 = this._condVal = ds(o) ? new RegExp(o) : R6t(o) ? o : null;
          if (n3 == null) {
            var p2 = "";
            lh2(p2);
          }
        }
        return u.prototype.evaluate = function(o) {
          var n3 = typeof o;
          return ds(n3) ? this._condVal.test(o) : Dh2(n3) ? this._condVal.test(o + "") : false;
        }, u;
      }(), SLn = function() {
        function u() {
        }
        return u.prototype.evaluate = function() {
          return this.value;
        }, u;
      }(), MLn = function() {
        function u() {
        }
        return u.prototype.evaluate = function() {
          for (var o = this.children, n3 = 0; n3 < o.length; n3++)
            if (!o[n3].evaluate())
              return false;
          return true;
        }, u;
      }(), CLn = function() {
        function u() {
        }
        return u.prototype.evaluate = function() {
          for (var o = this.children, n3 = 0; n3 < o.length; n3++)
            if (o[n3].evaluate())
              return true;
          return false;
        }, u;
      }(), TLn = function() {
        function u() {
        }
        return u.prototype.evaluate = function() {
          return !this.child.evaluate();
        }, u;
      }(), ALn = function() {
        function u() {
        }
        return u.prototype.evaluate = function() {
          for (var o = !!this.valueParser, n3 = this.getValue, p2 = n3(this.valueGetterParam), m2 = o ? this.valueParser(p2) : null, w2 = 0; w2 < this.subCondList.length; w2++)
            if (!this.subCondList[w2].evaluate(o ? m2 : p2))
              return false;
          return true;
        }, u;
      }();
      function sBt(u, o) {
        if (u === true || u === false) {
          var n3 = new SLn();
          return n3.value = u, n3;
        }
        var p2 = "";
        return $2e(u) || lh2(p2), u.and ? Z2e("and", u, o) : u.or ? Z2e("or", u, o) : u.not ? ILn(u, o) : DLn(u, o);
      }
      function Z2e(u, o, n3) {
        var p2 = o[u], m2 = "";
        za2(p2) || lh2(m2), p2.length || lh2(m2);
        var w2 = u === "and" ? new MLn() : new CLn();
        return w2.children = Ya2(p2, function(T2) {
          return sBt(T2, n3);
        }), w2.children.length || lh2(m2), w2;
      }
      function ILn(u, o) {
        var n3 = u.not, p2 = "";
        $2e(n3) || lh2(p2);
        var m2 = new TLn();
        return m2.child = sBt(n3, o), m2.child || lh2(p2), m2;
      }
      function DLn(u, o) {
        for (var n3 = "", p2 = o.prepareGetValue(u), m2 = [], w2 = tf2(u), T2 = u.parser, E = T2 ? w0e(T2) : null, O2 = 0; O2 < w2.length; O2++) {
          var V3 = w2[O2];
          if (!(V3 === "parser" || o.valueGetterAttrMap.get(V3))) {
            var W3 = Fs(q2e, V3) ? q2e[V3] : V3, q3 = u[V3], K = E ? E(q3) : q3, J = lmn(W3, K) || W3 === "reg" && new wLn(K);
            J || lh2(n3), m2.push(J);
          }
        }
        m2.length || lh2(n3);
        var rt2 = new ALn();
        return rt2.valueGetterParam = p2, rt2.valueParser = E, rt2.getValue = o.getValue, rt2.subCondList = m2, rt2;
      }
      function $2e(u) {
        return ys(u) && !M1(u);
      }
      var ELn = function() {
        function u(o, n3) {
          this._cond = sBt(o, n3);
        }
        return u.prototype.evaluate = function() {
          return this._cond.evaluate();
        }, u;
      }();
      function kLn(u, o) {
        return new ELn(u, o);
      }
      var PLn = { type: "echarts:filter", transform: function(u) {
        for (var o = u.upstream, n3, p2 = kLn(u.config, { valueGetterAttrMap: pl({ dimension: true }), prepareGetValue: function(E) {
          var O2 = "", V3 = E.dimension;
          Fs(E, "dimension") || lh2(O2);
          var W3 = o.getDimensionInfo(V3);
          return W3 || lh2(O2), { dimIdx: W3.index };
        }, getValue: function(E) {
          return o.retrieveValueFromItem(n3, E.dimIdx);
        } }), m2 = [], w2 = 0, T2 = o.count(); w2 < T2; w2++)
          n3 = o.getRawDataItem(w2), p2.evaluate() && m2.push(n3);
        return { data: m2 };
      } }, LLn = { type: "echarts:sort", transform: function(u) {
        var o = u.upstream, n3 = u.config, p2 = "", m2 = Tp(n3);
        m2.length || lh2(p2);
        var w2 = [];
        Xe2(m2, function(W3) {
          var q3 = W3.dimension, K = W3.order, J = W3.parser, rt2 = W3.incomparable;
          if (q3 == null && lh2(p2), K !== "asc" && K !== "desc" && lh2(p2), rt2 && rt2 !== "min" && rt2 !== "max") {
            var gt = "";
            lh2(gt);
          }
          if (K !== "asc" && K !== "desc") {
            var yt = "";
            lh2(yt);
          }
          var At = o.getDimensionInfo(q3);
          At || lh2(p2);
          var Lt = J ? w0e(J) : null;
          J && !Lt && lh2(p2), w2.push({ dimIdx: At.index, parser: Lt, comparator: new M0e(K, rt2) });
        });
        var T2 = o.sourceFormat;
        T2 !== Aw && T2 !== hI && lh2(p2);
        for (var E = [], O2 = 0, V3 = o.count(); O2 < V3; O2++)
          E.push(o.getRawDataItem(O2));
        return E.sort(function(W3, q3) {
          for (var K = 0; K < w2.length; K++) {
            var J = w2[K], rt2 = o.retrieveValueFromItem(W3, J.dimIdx), gt = o.retrieveValueFromItem(q3, J.dimIdx);
            J.parser && (rt2 = J.parser(rt2), gt = J.parser(gt));
            var yt = J.comparator.evaluate(rt2, gt);
            if (yt !== 0)
              return yt;
          }
          return 0;
        }), { data: E };
      } };
      function OLn(u) {
        u.registerTransform(PLn), u.registerTransform(LLn);
      }
      var RLn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "dataset", n3;
        }
        return o.prototype.init = function(n3, p2, m2) {
          u.prototype.init.call(this, n3, p2, m2), this._sourceManager = new E0e(this), k0e(this);
        }, o.prototype.mergeOption = function(n3, p2) {
          u.prototype.mergeOption.call(this, n3, p2), k0e(this);
        }, o.prototype.optionUpdated = function() {
          this._sourceManager.dirty();
        }, o.prototype.getSourceManager = function() {
          return this._sourceManager;
        }, o.type = "dataset", o.defaultOption = { seriesLayoutBy: qP }, o;
      }(kh2), NLn = function(u) {
        tr(o, u);
        function o() {
          var n3 = u !== null && u.apply(this, arguments) || this;
          return n3.type = "dataset", n3;
        }
        return o.type = "dataset", o;
      }(C0);
      function FLn(u) {
        u.registerComponentModel(RLn), u.registerComponentView(NLn);
      }
      var t3 = iI.CMD;
      function IY(u, o) {
        return Math.abs(u - o) < 1e-5;
      }
      function lBt(u) {
        var o = u.data, n3 = u.len(), p2 = [], m2, w2 = 0, T2 = 0, E = 0, O2 = 0;
        function V3($e2, Tn) {
          m2 && m2.length > 2 && p2.push(m2), m2 = [$e2, Tn];
        }
        function W3($e2, Tn, zn, bn) {
          IY($e2, zn) && IY(Tn, bn) || m2.push($e2, Tn, zn, bn, zn, bn);
        }
        function q3($e2, Tn, zn, bn, Xr, Xn) {
          var or = Math.abs(Tn - $e2), Tr = Math.tan(or / 4) * 4 / 3, ci2 = Tn < $e2 ? -1 : 1, yi2 = Math.cos($e2), Po = Math.sin($e2), Ms = Math.cos(Tn), dl = Math.sin(Tn), tl = yi2 * Xr + zn, el = Po * Xn + bn, as = Ms * Xr + zn, Hs = dl * Xn + bn, ol = Xr * Tr * ci2, xs = Xn * Tr * ci2;
          m2.push(tl - ol * Po, el + xs * yi2, as + ol * dl, Hs - xs * Ms, as, Hs);
        }
        for (var K, J, rt2, gt, yt = 0; yt < n3; ) {
          var At = o[yt++], Lt = yt === 1;
          switch (Lt && (w2 = o[yt], T2 = o[yt + 1], E = w2, O2 = T2, (At === t3.L || At === t3.C || At === t3.Q) && (m2 = [E, O2])), At) {
            case t3.M:
              w2 = E = o[yt++], T2 = O2 = o[yt++], V3(E, O2);
              break;
            case t3.L:
              K = o[yt++], J = o[yt++], W3(w2, T2, K, J), w2 = K, T2 = J;
              break;
            case t3.C:
              m2.push(o[yt++], o[yt++], o[yt++], o[yt++], w2 = o[yt++], T2 = o[yt++]);
              break;
            case t3.Q:
              K = o[yt++], J = o[yt++], rt2 = o[yt++], gt = o[yt++], m2.push(w2 + 2 / 3 * (K - w2), T2 + 2 / 3 * (J - T2), rt2 + 2 / 3 * (K - rt2), gt + 2 / 3 * (J - gt), rt2, gt), w2 = rt2, T2 = gt;
              break;
            case t3.A:
              var Wt = o[yt++], Nt = o[yt++], ue2 = o[yt++], ie2 = o[yt++], pe2 = o[yt++], xe = o[yt++] + pe2;
              yt += 1;
              var Ce2 = !o[yt++];
              K = Math.cos(pe2) * ue2 + Wt, J = Math.sin(pe2) * ie2 + Nt, Lt ? (E = K, O2 = J, V3(E, O2)) : W3(w2, T2, K, J), w2 = Math.cos(xe) * ue2 + Wt, T2 = Math.sin(xe) * ie2 + Nt;
              for (var Le2 = (Ce2 ? -1 : 1) * Math.PI / 2, ze = pe2; Ce2 ? ze > xe : ze < xe; ze += Le2) {
                var tn = Ce2 ? Math.max(ze + Le2, xe) : Math.min(ze + Le2, xe);
                q3(ze, tn, Wt, Nt, ue2, ie2);
              }
              break;
            case t3.R:
              E = w2 = o[yt++], O2 = T2 = o[yt++], K = E + o[yt++], J = O2 + o[yt++], V3(K, O2), W3(K, O2, K, J), W3(K, J, E, J), W3(E, J, E, O2), W3(E, O2, K, O2);
              break;
            case t3.Z:
              m2 && W3(w2, T2, E, O2), w2 = E, T2 = O2;
              break;
          }
        }
        return m2 && m2.length > 2 && p2.push(m2), p2;
      }
      function uBt(u, o, n3, p2, m2, w2, T2, E, O2, V3) {
        if (IY(u, n3) && IY(o, p2) && IY(m2, T2) && IY(w2, E)) {
          O2.push(T2, E);
          return;
        }
        var W3 = 2 / V3, q3 = W3 * W3, K = T2 - u, J = E - o, rt2 = Math.sqrt(K * K + J * J);
        K /= rt2, J /= rt2;
        var gt = n3 - u, yt = p2 - o, At = m2 - T2, Lt = w2 - E, Wt = gt * gt + yt * yt, Nt = At * At + Lt * Lt;
        if (Wt < q3 && Nt < q3) {
          O2.push(T2, E);
          return;
        }
        var ue2 = K * gt + J * yt, ie2 = -K * At - J * Lt, pe2 = Wt - ue2 * ue2, xe = Nt - ie2 * ie2;
        if (pe2 < q3 && ue2 >= 0 && xe < q3 && ie2 >= 0) {
          O2.push(T2, E);
          return;
        }
        var Ce2 = [], Le2 = [];
        ZE(u, n3, m2, T2, 0.5, Ce2), ZE(o, p2, w2, E, 0.5, Le2), uBt(Ce2[0], Le2[0], Ce2[1], Le2[1], Ce2[2], Le2[2], Ce2[3], Le2[3], O2, V3), uBt(Ce2[4], Le2[4], Ce2[5], Le2[5], Ce2[6], Le2[6], Ce2[7], Le2[7], O2, V3);
      }
      function VLn(u, o) {
        var n3 = lBt(u), p2 = [];
        o = o || 1;
        for (var m2 = 0; m2 < n3.length; m2++) {
          var w2 = n3[m2], T2 = [], E = w2[0], O2 = w2[1];
          T2.push(E, O2);
          for (var V3 = 2; V3 < w2.length; ) {
            var W3 = w2[V3++], q3 = w2[V3++], K = w2[V3++], J = w2[V3++], rt2 = w2[V3++], gt = w2[V3++];
            uBt(E, O2, W3, q3, K, J, rt2, gt, T2, o), E = rt2, O2 = gt;
          }
          p2.push(T2);
        }
        return p2;
      }
      function Y2e(u, o, n3) {
        var p2 = u[o], m2 = u[1 - o], w2 = Math.abs(p2 / m2), T2 = Math.ceil(Math.sqrt(w2 * n3)), E = Math.floor(n3 / T2);
        E === 0 && (E = 1, T2 = n3);
        for (var O2 = [], V3 = 0; V3 < T2; V3++)
          O2.push(E);
        var W3 = T2 * E, q3 = n3 - W3;
        if (q3 > 0)
          for (var V3 = 0; V3 < q3; V3++)
            O2[V3 % T2] += 1;
        return O2;
      }
      function K2e(u, o, n3) {
        for (var p2 = u.r0, m2 = u.r, w2 = u.startAngle, T2 = u.endAngle, E = Math.abs(T2 - w2), O2 = E * m2, V3 = m2 - p2, W3 = O2 > Math.abs(V3), q3 = Y2e([O2, V3], W3 ? 0 : 1, o), K = (W3 ? E : V3) / q3.length, J = 0; J < q3.length; J++)
          for (var rt2 = (W3 ? V3 : E) / q3[J], gt = 0; gt < q3[J]; gt++) {
            var yt = {};
            W3 ? (yt.startAngle = w2 + K * J, yt.endAngle = w2 + K * (J + 1), yt.r0 = p2 + rt2 * gt, yt.r = p2 + rt2 * (gt + 1)) : (yt.startAngle = w2 + rt2 * gt, yt.endAngle = w2 + rt2 * (gt + 1), yt.r0 = p2 + K * J, yt.r = p2 + K * (J + 1)), yt.clockwise = u.clockwise, yt.cx = u.cx, yt.cy = u.cy, n3.push(yt);
          }
      }
      function BLn(u, o, n3) {
        for (var p2 = u.width, m2 = u.height, w2 = p2 > m2, T2 = Y2e([p2, m2], w2 ? 0 : 1, o), E = w2 ? "width" : "height", O2 = w2 ? "height" : "width", V3 = w2 ? "x" : "y", W3 = w2 ? "y" : "x", q3 = u[E] / T2.length, K = 0; K < T2.length; K++)
          for (var J = u[O2] / T2[K], rt2 = 0; rt2 < T2[K]; rt2++) {
            var gt = {};
            gt[V3] = K * q3, gt[W3] = rt2 * J, gt[E] = q3, gt[O2] = J, gt.x += u.x, gt.y += u.y, n3.push(gt);
          }
      }
      function X2e(u, o, n3, p2) {
        return u * p2 - n3 * o;
      }
      function zLn(u, o, n3, p2, m2, w2, T2, E) {
        var O2 = n3 - u, V3 = p2 - o, W3 = T2 - m2, q3 = E - w2, K = X2e(W3, q3, O2, V3);
        if (Math.abs(K) < 1e-6)
          return null;
        var J = u - m2, rt2 = o - w2, gt = X2e(J, rt2, W3, q3) / K;
        return gt < 0 || gt > 1 ? null : new Vu(gt * O2 + u, gt * V3 + o);
      }
      function jLn(u, o, n3) {
        var p2 = new Vu();
        Vu.sub(p2, n3, o), p2.normalize();
        var m2 = new Vu();
        Vu.sub(m2, u, o);
        var w2 = m2.dot(p2);
        return w2;
      }
      function DY(u, o) {
        var n3 = u[u.length - 1];
        n3 && n3[0] === o[0] && n3[1] === o[1] || u.push(o);
      }
      function WLn(u, o, n3) {
        for (var p2 = u.length, m2 = [], w2 = 0; w2 < p2; w2++) {
          var T2 = u[w2], E = u[(w2 + 1) % p2], O2 = zLn(T2[0], T2[1], E[0], E[1], o.x, o.y, n3.x, n3.y);
          O2 && m2.push({ projPt: jLn(O2, o, n3), pt: O2, idx: w2 });
        }
        if (m2.length < 2)
          return [{ points: u }, { points: u }];
        m2.sort(function(yt, At) {
          return yt.projPt - At.projPt;
        });
        var V3 = m2[0], W3 = m2[m2.length - 1];
        if (W3.idx < V3.idx) {
          var q3 = V3;
          V3 = W3, W3 = q3;
        }
        for (var K = [V3.pt.x, V3.pt.y], J = [W3.pt.x, W3.pt.y], rt2 = [K], gt = [J], w2 = V3.idx + 1; w2 <= W3.idx; w2++)
          DY(rt2, u[w2].slice());
        DY(rt2, J), DY(rt2, K);
        for (var w2 = W3.idx + 1; w2 <= V3.idx + p2; w2++)
          DY(gt, u[w2 % p2].slice());
        return DY(gt, K), DY(gt, J), [{ points: rt2 }, { points: gt }];
      }
      function Q2e(u) {
        var o = u.points, n3 = [], p2 = [];
        w$(o, n3, p2);
        var m2 = new Qu(n3[0], n3[1], p2[0] - n3[0], p2[1] - n3[1]), w2 = m2.width, T2 = m2.height, E = m2.x, O2 = m2.y, V3 = new Vu(), W3 = new Vu();
        return w2 > T2 ? (V3.x = W3.x = E + w2 / 2, V3.y = O2, W3.y = O2 + T2) : (V3.y = W3.y = O2 + T2 / 2, V3.x = E, W3.x = E + w2), WLn(o, V3, W3);
      }
      function xwt(u, o, n3, p2) {
        if (n3 === 1)
          p2.push(o);
        else {
          var m2 = Math.floor(n3 / 2), w2 = u(o);
          xwt(u, w2[0], m2, p2), xwt(u, w2[1], n3 - m2, p2);
        }
        return p2;
      }
      function GLn(u, o) {
        for (var n3 = [], p2 = 0; p2 < o; p2++)
          n3.push(lot(u));
        return n3;
      }
      function HLn(u, o) {
        o.setStyle(u.style), o.z = u.z, o.z2 = u.z2, o.zlevel = u.zlevel;
      }
      function ULn(u) {
        for (var o = [], n3 = 0; n3 < u.length; )
          o.push([u[n3++], u[n3++]]);
        return o;
      }
      function qLn(u, o) {
        var n3 = [], p2 = u.shape, m2;
        switch (u.type) {
          case "rect":
            BLn(p2, o, n3), m2 = Vf2;
            break;
          case "sector":
            K2e(p2, o, n3), m2 = ww;
            break;
          case "circle":
            K2e({ r0: 0, r: p2.r, startAngle: 0, endAngle: Math.PI * 2, cx: p2.cx, cy: p2.cy }, o, n3), m2 = ww;
            break;
          default:
            var w2 = u.getComputedTransform(), T2 = w2 ? Math.sqrt(Math.max(w2[0] * w2[0] + w2[1] * w2[1], w2[2] * w2[2] + w2[3] * w2[3])) : 1, E = Ya2(VLn(u.getUpdatedPathProxy(), T2), function(At) {
              return ULn(At);
            }), O2 = E.length;
            if (O2 === 0)
              xwt(Q2e, { points: E[0] }, o, n3);
            else if (O2 === o)
              for (var V3 = 0; V3 < O2; V3++)
                n3.push({ points: E[V3] });
            else {
              var W3 = 0, q3 = Ya2(E, function(At) {
                var Lt = [], Wt = [];
                w$(At, Lt, Wt);
                var Nt = (Wt[1] - Lt[1]) * (Wt[0] - Lt[0]);
                return W3 += Nt, { poly: At, area: Nt };
              });
              q3.sort(function(At, Lt) {
                return Lt.area - At.area;
              });
              for (var K = o, V3 = 0; V3 < O2; V3++) {
                var J = q3[V3];
                if (K <= 0)
                  break;
                var rt2 = V3 === O2 - 1 ? K : Math.ceil(J.area / W3 * o);
                rt2 < 0 || (xwt(Q2e, { points: J.poly }, rt2, n3), K -= rt2);
              }
            }
            m2 = Sw;
            break;
        }
        if (!m2)
          return GLn(u, o);
        for (var gt = [], V3 = 0; V3 < n3.length; V3++) {
          var yt = new m2();
          yt.setShape(n3[V3]), HLn(u, yt), gt.push(yt);
        }
        return gt;
      }
      function ZLn(u, o) {
        var n3 = u.length, p2 = o.length;
        if (n3 === p2)
          return [u, o];
        for (var m2 = [], w2 = [], T2 = n3 < p2 ? u : o, E = Math.min(n3, p2), O2 = Math.abs(p2 - n3) / 6, V3 = (E - 2) / 6, W3 = Math.ceil(O2 / V3) + 1, q3 = [T2[0], T2[1]], K = O2, J = 2; J < E; ) {
          var rt2 = T2[J - 2], gt = T2[J - 1], yt = T2[J++], At = T2[J++], Lt = T2[J++], Wt = T2[J++], Nt = T2[J++], ue2 = T2[J++];
          if (K <= 0) {
            q3.push(yt, At, Lt, Wt, Nt, ue2);
            continue;
          }
          for (var ie2 = Math.min(K, W3 - 1) + 1, pe2 = 1; pe2 <= ie2; pe2++) {
            var xe = pe2 / ie2;
            ZE(rt2, yt, Lt, Nt, xe, m2), ZE(gt, At, Wt, ue2, xe, w2), rt2 = m2[3], gt = w2[3], q3.push(m2[1], w2[1], m2[2], w2[2], rt2, gt), yt = m2[5], At = w2[5], Lt = m2[6], Wt = w2[6];
          }
          K -= ie2 - 1;
        }
        return T2 === u ? [q3, o] : [u, q3];
      }
      function J2e(u, o) {
        for (var n3 = u.length, p2 = u[n3 - 2], m2 = u[n3 - 1], w2 = [], T2 = 0; T2 < o.length; )
          w2[T2++] = p2, w2[T2++] = m2;
        return w2;
      }
      function $Ln(u, o) {
        for (var n3, p2, m2, w2 = [], T2 = [], E = 0; E < Math.max(u.length, o.length); E++) {
          var O2 = u[E], V3 = o[E], W3 = void 0, q3 = void 0;
          O2 ? V3 ? (n3 = ZLn(O2, V3), W3 = n3[0], q3 = n3[1], p2 = W3, m2 = q3) : (q3 = J2e(m2 || O2, O2), W3 = O2) : (W3 = J2e(p2 || V3, V3), q3 = V3), w2.push(W3), T2.push(q3);
        }
        return [w2, T2];
      }
      function tMe(u) {
        for (var o = 0, n3 = 0, p2 = 0, m2 = u.length, w2 = 0, T2 = m2 - 2; w2 < m2; T2 = w2, w2 += 2) {
          var E = u[T2], O2 = u[T2 + 1], V3 = u[w2], W3 = u[w2 + 1], q3 = E * W3 - V3 * O2;
          o += q3, n3 += (E + V3) * q3, p2 += (O2 + W3) * q3;
        }
        return o === 0 ? [u[0] || 0, u[1] || 0] : [n3 / o / 3, p2 / o / 3, o];
      }
      function YLn(u, o, n3, p2) {
        for (var m2 = (u.length - 2) / 6, w2 = 1 / 0, T2 = 0, E = u.length, O2 = E - 2, V3 = 0; V3 < m2; V3++) {
          for (var W3 = V3 * 6, q3 = 0, K = 0; K < E; K += 2) {
            var J = K === 0 ? W3 : (W3 + K - 2) % O2 + 2, rt2 = u[J] - n3[0], gt = u[J + 1] - n3[1], yt = o[K] - p2[0], At = o[K + 1] - p2[1], Lt = yt - rt2, Wt = At - gt;
            q3 += Lt * Lt + Wt * Wt;
          }
          q3 < w2 && (w2 = q3, T2 = V3);
        }
        return T2;
      }
      function KLn(u) {
        for (var o = [], n3 = u.length, p2 = 0; p2 < n3; p2 += 2)
          o[p2] = u[n3 - p2 - 2], o[p2 + 1] = u[n3 - p2 - 1];
        return o;
      }
      function XLn(u, o, n3, p2) {
        for (var m2 = [], w2, T2 = 0; T2 < u.length; T2++) {
          var E = u[T2], O2 = o[T2], V3 = tMe(E), W3 = tMe(O2);
          w2 == null && (w2 = V3[2] < 0 != W3[2] < 0);
          var q3 = [], K = [], J = 0, rt2 = 1 / 0, gt = [], yt = E.length;
          w2 && (E = KLn(E));
          for (var At = YLn(E, O2, V3, W3) * 6, Lt = yt - 2, Wt = 0; Wt < Lt; Wt += 2) {
            var Nt = (At + Wt) % Lt + 2;
            q3[Wt + 2] = E[Nt] - V3[0], q3[Wt + 3] = E[Nt + 1] - V3[1];
          }
          if (q3[0] = E[At] - V3[0], q3[1] = E[At + 1] - V3[1], n3 > 0)
            for (var ue2 = p2 / n3, ie2 = -p2 / 2; ie2 <= p2 / 2; ie2 += ue2) {
              for (var pe2 = Math.sin(ie2), xe = Math.cos(ie2), Ce2 = 0, Wt = 0; Wt < E.length; Wt += 2) {
                var Le2 = q3[Wt], ze = q3[Wt + 1], tn = O2[Wt] - W3[0], $e2 = O2[Wt + 1] - W3[1], Tn = tn * xe - $e2 * pe2, zn = tn * pe2 + $e2 * xe;
                gt[Wt] = Tn, gt[Wt + 1] = zn;
                var bn = Tn - Le2, Xr = zn - ze;
                Ce2 += bn * bn + Xr * Xr;
              }
              if (Ce2 < rt2) {
                rt2 = Ce2, J = ie2;
                for (var Xn = 0; Xn < gt.length; Xn++)
                  K[Xn] = gt[Xn];
              }
            }
          else
            for (var or = 0; or < yt; or += 2)
              K[or] = O2[or] - W3[0], K[or + 1] = O2[or + 1] - W3[1];
          m2.push({ from: q3, to: K, fromCp: V3, toCp: W3, rotation: -J });
        }
        return m2;
      }
      function wwt(u) {
        return u.__isCombineMorphing;
      }
      var eMe = "__mOriginal_";
      function Swt(u, o, n3) {
        var p2 = eMe + o, m2 = u[p2] || u[o];
        u[p2] || (u[p2] = u[o]);
        var w2 = n3.replace, T2 = n3.after, E = n3.before;
        u[o] = function() {
          var O2 = arguments, V3;
          return E && E.apply(this, O2), w2 ? V3 = w2.apply(this, O2) : V3 = m2.apply(this, O2), T2 && T2.apply(this, O2), V3;
        };
      }
      function Ost(u, o) {
        var n3 = eMe + o;
        u[n3] && (u[o] = u[n3], u[n3] = null);
      }
      function nMe(u, o) {
        for (var n3 = 0; n3 < u.length; n3++)
          for (var p2 = u[n3], m2 = 0; m2 < p2.length; ) {
            var w2 = p2[m2], T2 = p2[m2 + 1];
            p2[m2++] = o[0] * w2 + o[2] * T2 + o[4], p2[m2++] = o[1] * w2 + o[3] * T2 + o[5];
          }
      }
      function rMe(u, o) {
        var n3 = u.getUpdatedPathProxy(), p2 = o.getUpdatedPathProxy(), m2 = $Ln(lBt(n3), lBt(p2)), w2 = m2[0], T2 = m2[1], E = u.getComputedTransform(), O2 = o.getComputedTransform();
        function V3() {
          this.transform = null;
        }
        E && nMe(w2, E), O2 && nMe(T2, O2), Swt(o, "updateTransform", { replace: V3 }), o.transform = null;
        var W3 = XLn(w2, T2, 10, Math.PI), q3 = [];
        Swt(o, "buildPath", { replace: function(K) {
          for (var J = o.__morphT, rt2 = 1 - J, gt = [], yt = 0; yt < W3.length; yt++) {
            var At = W3[yt], Lt = At.from, Wt = At.to, Nt = At.rotation * J, ue2 = At.fromCp, ie2 = At.toCp, pe2 = Math.sin(Nt), xe = Math.cos(Nt);
            VZ(gt, ue2, ie2, J);
            for (var Ce2 = 0; Ce2 < Lt.length; Ce2 += 2) {
              var Le2 = Lt[Ce2], ze = Lt[Ce2 + 1], tn = Wt[Ce2], $e2 = Wt[Ce2 + 1], Tn = Le2 * rt2 + tn * J, zn = ze * rt2 + $e2 * J;
              q3[Ce2] = Tn * xe - zn * pe2 + gt[0], q3[Ce2 + 1] = Tn * pe2 + zn * xe + gt[1];
            }
            var bn = q3[0], Xr = q3[1];
            K.moveTo(bn, Xr);
            for (var Ce2 = 2; Ce2 < Lt.length; ) {
              var tn = q3[Ce2++], $e2 = q3[Ce2++], Xn = q3[Ce2++], or = q3[Ce2++], Tr = q3[Ce2++], ci2 = q3[Ce2++];
              bn === tn && Xr === $e2 && Xn === Tr && or === ci2 ? K.lineTo(Tr, ci2) : K.bezierCurveTo(tn, $e2, Xn, or, Tr, ci2), bn = Tr, Xr = ci2;
            }
          }
        } });
      }
      function cBt(u, o, n3) {
        if (!u || !o)
          return o;
        var p2 = n3.done, m2 = n3.during;
        rMe(u, o), o.__morphT = 0;
        function w2() {
          Ost(o, "buildPath"), Ost(o, "updateTransform"), o.__morphT = -1, o.createPathProxy(), o.dirtyShape();
        }
        return o.animateTo({ __morphT: 1 }, kl({ during: function(T2) {
          o.dirtyShape(), m2 && m2(T2);
        }, done: function() {
          w2(), p2 && p2();
        } }, n3)), o;
      }
      function QLn(u, o, n3, p2, m2, w2) {
        var T2 = 16;
        u = m2 === n3 ? 0 : Math.round(32767 * (u - n3) / (m2 - n3)), o = w2 === p2 ? 0 : Math.round(32767 * (o - p2) / (w2 - p2));
        for (var E = 0, O2, V3 = (1 << T2) / 2; V3 > 0; V3 /= 2) {
          var W3 = 0, q3 = 0;
          (u & V3) > 0 && (W3 = 1), (o & V3) > 0 && (q3 = 1), E += V3 * V3 * (3 * W3 ^ q3), q3 === 0 && (W3 === 1 && (u = V3 - 1 - u, o = V3 - 1 - o), O2 = u, u = o, o = O2);
        }
        return E;
      }
      function Mwt(u) {
        var o = 1 / 0, n3 = 1 / 0, p2 = -1 / 0, m2 = -1 / 0, w2 = Ya2(u, function(E) {
          var O2 = E.getBoundingRect(), V3 = E.getComputedTransform(), W3 = O2.x + O2.width / 2 + (V3 ? V3[4] : 0), q3 = O2.y + O2.height / 2 + (V3 ? V3[5] : 0);
          return o = Math.min(W3, o), n3 = Math.min(q3, n3), p2 = Math.max(W3, p2), m2 = Math.max(q3, m2), [W3, q3];
        }), T2 = Ya2(w2, function(E, O2) {
          return { cp: E, z: QLn(E[0], E[1], o, n3, p2, m2), path: u[O2] };
        });
        return T2.sort(function(E, O2) {
          return E.z - O2.z;
        }).map(function(E) {
          return E.path;
        });
      }
      function iMe(u) {
        return qLn(u.path, u.count);
      }
      function fBt() {
        return { fromIndividuals: [], toIndividuals: [], count: 0 };
      }
      function JLn(u, o, n3) {
        var p2 = [];
        function m2(ue2) {
          for (var ie2 = 0; ie2 < ue2.length; ie2++) {
            var pe2 = ue2[ie2];
            wwt(pe2) ? m2(pe2.childrenRef()) : pe2 instanceof Mc2 && p2.push(pe2);
          }
        }
        m2(u);
        var w2 = p2.length;
        if (!w2)
          return fBt();
        var T2 = n3.dividePath || iMe, E = T2({ path: o, count: w2 });
        if (E.length !== w2)
          return console.error("Invalid morphing: unmatched splitted path"), fBt();
        p2 = Mwt(p2), E = Mwt(E);
        for (var O2 = n3.done, V3 = n3.during, W3 = n3.individualDelay, q3 = new JS(), K = 0; K < w2; K++) {
          var J = p2[K], rt2 = E[K];
          rt2.parent = o, rt2.copyTransform(q3), W3 || rMe(J, rt2);
        }
        o.__isCombineMorphing = true, o.childrenRef = function() {
          return E;
        };
        function gt(ue2) {
          for (var ie2 = 0; ie2 < E.length; ie2++)
            E[ie2].addSelfToZr(ue2);
        }
        Swt(o, "addSelfToZr", { after: function(ue2) {
          gt(ue2);
        } }), Swt(o, "removeSelfFromZr", { after: function(ue2) {
          for (var ie2 = 0; ie2 < E.length; ie2++)
            E[ie2].removeSelfFromZr(ue2);
        } });
        function yt() {
          o.__isCombineMorphing = false, o.__morphT = -1, o.childrenRef = null, Ost(o, "addSelfToZr"), Ost(o, "removeSelfFromZr");
        }
        var At = E.length;
        if (W3)
          for (var Lt = At, Wt = function() {
            Lt--, Lt === 0 && (yt(), O2 && O2());
          }, K = 0; K < At; K++) {
            var Nt = W3 ? kl({ delay: (n3.delay || 0) + W3(K, At, p2[K], E[K]), done: Wt }, n3) : n3;
            cBt(p2[K], E[K], Nt);
          }
        else
          o.__morphT = 0, o.animateTo({ __morphT: 1 }, kl({ during: function(ue2) {
            for (var ie2 = 0; ie2 < At; ie2++) {
              var pe2 = E[ie2];
              pe2.__morphT = o.__morphT, pe2.dirtyShape();
            }
            V3 && V3(ue2);
          }, done: function() {
            yt();
            for (var ue2 = 0; ue2 < u.length; ue2++)
              Ost(u[ue2], "updateTransform");
            O2 && O2();
          } }, n3));
        return o.__zr && gt(o.__zr), { fromIndividuals: p2, toIndividuals: E, count: At };
      }
      function tOn(u, o, n3) {
        var p2 = o.length, m2 = [], w2 = n3.dividePath || iMe;
        function T2(J) {
          for (var rt2 = 0; rt2 < J.length; rt2++) {
            var gt = J[rt2];
            wwt(gt) ? T2(gt.childrenRef()) : gt instanceof Mc2 && m2.push(gt);
          }
        }
        if (wwt(u)) {
          T2(u.childrenRef());
          var E = m2.length;
          if (E < p2)
            for (var O2 = 0, V3 = E; V3 < p2; V3++)
              m2.push(lot(m2[O2++ % E]));
          m2.length = p2;
        } else {
          m2 = w2({ path: u, count: p2 });
          for (var W3 = u.getComputedTransform(), V3 = 0; V3 < m2.length; V3++)
            m2[V3].setLocalTransform(W3);
          if (m2.length !== p2)
            return console.error("Invalid morphing: unmatched splitted path"), fBt();
        }
        m2 = Mwt(m2), o = Mwt(o);
        for (var q3 = n3.individualDelay, V3 = 0; V3 < p2; V3++) {
          var K = q3 ? kl({ delay: (n3.delay || 0) + q3(V3, p2, m2[V3], o[V3]) }, n3) : n3;
          cBt(m2[V3], o[V3], K);
        }
        return { fromIndividuals: m2, toIndividuals: o, count: o.length };
      }
      function aMe(u) {
        return za2(u[0]);
      }
      function oMe(u, o) {
        for (var n3 = [], p2 = u.length, m2 = 0; m2 < p2; m2++)
          n3.push({ one: u[m2], many: [] });
        for (var m2 = 0; m2 < o.length; m2++) {
          var w2 = o[m2].length, T2 = void 0;
          for (T2 = 0; T2 < w2; T2++)
            n3[T2 % p2].many.push(o[m2][T2]);
        }
        for (var E = 0, m2 = p2 - 1; m2 >= 0; m2--)
          if (!n3[m2].many.length) {
            var O2 = n3[E].many;
            if (O2.length <= 1)
              if (E)
                E = 0;
              else
                return n3;
            var w2 = O2.length, V3 = Math.ceil(w2 / 2);
            n3[m2].many = O2.slice(V3, w2), n3[E].many = O2.slice(0, V3), E++;
          }
        return n3;
      }
      var eOn = { clone: function(u) {
        for (var o = [], n3 = 1 - Math.pow(1 - u.path.style.opacity, 1 / u.count), p2 = 0; p2 < u.count; p2++) {
          var m2 = lot(u.path);
          m2.setStyle("opacity", n3), o.push(m2);
        }
        return o;
      }, split: null };
      function hBt(u, o, n3, p2, m2, w2) {
        if (!u.length || !o.length)
          return;
        var T2 = t8("update", p2, m2);
        if (!(T2 && T2.duration > 0))
          return;
        var E = p2.getModel("universalTransition").get("delay"), O2 = Object.assign({ setToFinal: true }, T2), V3, W3;
        aMe(u) && (V3 = u, W3 = o), aMe(o) && (V3 = o, W3 = u);
        function q3(At, Lt, Wt, Nt, ue2) {
          var ie2 = At.many, pe2 = At.one;
          if (ie2.length === 1 && !ue2) {
            var xe = Lt ? ie2[0] : pe2, Ce2 = Lt ? pe2 : ie2[0];
            if (wwt(xe))
              q3({ many: [xe], one: Ce2 }, true, Wt, Nt, true);
            else {
              var Le2 = E ? kl({ delay: E(Wt, Nt) }, O2) : O2;
              cBt(xe, Ce2, Le2), w2(xe, Ce2, xe, Ce2, Le2);
            }
          } else
            for (var ze = kl({ dividePath: eOn[n3], individualDelay: E && function(Xr, Xn, or, Tr) {
              return E(Xr + Wt, Nt);
            } }, O2), tn = Lt ? JLn(ie2, pe2, ze) : tOn(pe2, ie2, ze), $e2 = tn.fromIndividuals, Tn = tn.toIndividuals, zn = $e2.length, bn = 0; bn < zn; bn++) {
              var Le2 = E ? kl({ delay: E(bn, zn) }, O2) : O2;
              w2($e2[bn], Tn[bn], Lt ? ie2[bn] : At.one, Lt ? At.one : ie2[bn], Le2);
            }
        }
        for (var K = V3 ? V3 === u : u.length > o.length, J = V3 ? oMe(W3, V3) : oMe(K ? o : u, [K ? u : o]), rt2 = 0, gt = 0; gt < J.length; gt++)
          rt2 += J[gt].many.length;
        for (var yt = 0, gt = 0; gt < J.length; gt++)
          q3(J[gt], K, yt, rt2), yt += J[gt].many.length;
      }
      function rj2(u) {
        if (!u)
          return [];
        if (za2(u)) {
          for (var o = [], n3 = 0; n3 < u.length; n3++)
            o.push(rj2(u[n3]));
          return o;
        }
        var p2 = [];
        return u.traverse(function(m2) {
          m2 instanceof Mc2 && !m2.disableMorphing && !m2.invisible && !m2.ignore && p2.push(m2);
        }), p2;
      }
      var sMe = 1e4, nOn = Ff2();
      function rOn(u) {
        for (var o = u.dimensions, n3 = 0; n3 < o.length; n3++) {
          var p2 = u.getDimensionInfo(o[n3]);
          if (p2 && p2.otherDims.itemGroupId === 0)
            return o[n3];
        }
      }
      function lMe(u) {
        var o = [];
        return Xe2(u, function(n3) {
          var p2 = n3.data;
          if (!(p2.count() > sMe))
            for (var m2 = p2.getIndices(), w2 = rOn(p2), T2 = 0; T2 < m2.length; T2++)
              o.push({ data: p2, dim: n3.dim || w2, divide: n3.divide, dataIndex: T2 });
        }), o;
      }
      function pBt(u, o, n3) {
        u.traverse(function(p2) {
          p2 instanceof Mc2 && Qg2(p2, { style: { opacity: 0 } }, o, { dataIndex: n3, isFrom: true });
        });
      }
      function dBt(u) {
        if (u.parent) {
          var o = u.getComputedTransform();
          u.setLocalTransform(o), u.parent.remove(u);
        }
      }
      function EY(u) {
        u.stopAnimation(), u.isGroup && u.traverse(function(o) {
          o.stopAnimation();
        });
      }
      function iOn(u, o, n3) {
        var p2 = t8("update", n3, o);
        p2 && u.traverse(function(m2) {
          if (m2 instanceof sM) {
            var w2 = $Ft(m2);
            w2 && m2.animateFrom({ style: w2 }, p2);
          }
        });
      }
      function aOn(u, o) {
        var n3 = u.length;
        if (n3 !== o.length)
          return false;
        for (var p2 = 0; p2 < n3; p2++) {
          var m2 = u[p2], w2 = o[p2];
          if (m2.data.getId(m2.dataIndex) !== w2.data.getId(w2.dataIndex))
            return false;
        }
        return true;
      }
      function uMe(u, o, n3) {
        var p2 = lMe(u), m2 = lMe(o);
        function w2(At, Lt, Wt, Nt, ue2) {
          (Wt || At) && Lt.animateFrom({ style: Wt && Wt !== At ? ua2(ua2({}, Wt.style), At.style) : At.style }, ue2);
        }
        function T2(At) {
          for (var Lt = 0; Lt < At.length; Lt++)
            if (At[Lt].dim)
              return At[Lt].dim;
        }
        var E = T2(p2), O2 = T2(m2), V3 = false;
        function W3(At, Lt) {
          return function(Wt) {
            var Nt = Wt.data, ue2 = Wt.dataIndex;
            if (Lt)
              return Nt.getId(ue2);
            var ie2 = Nt.hostModel && Nt.hostModel.get("dataGroupId"), pe2 = At ? E || O2 : O2 || E, xe = pe2 && Nt.getDimensionInfo(pe2), Ce2 = xe && xe.ordinalMeta;
            if (xe) {
              var Le2 = Nt.get(xe.name, ue2);
              return Ce2 && Ce2.categories[Le2] || Le2 + "";
            }
            var ze = Nt.getRawDataItem(ue2);
            return ze && ze.groupId ? ze.groupId + "" : ie2 || Nt.getId(ue2);
          };
        }
        var q3 = aOn(p2, m2), K = {};
        if (!q3)
          for (var J = 0; J < m2.length; J++) {
            var rt2 = m2[J], gt = rt2.data.getItemGraphicEl(rt2.dataIndex);
            gt && (K[gt.id] = true);
          }
        function yt(At, Lt) {
          var Wt = p2[Lt], Nt = m2[At], ue2 = Nt.data.hostModel, ie2 = Wt.data.getItemGraphicEl(Wt.dataIndex), pe2 = Nt.data.getItemGraphicEl(Nt.dataIndex);
          if (ie2 === pe2) {
            pe2 && iOn(pe2, Nt.dataIndex, ue2);
            return;
          }
          ie2 && K[ie2.id] || pe2 && (EY(pe2), ie2 ? (EY(ie2), dBt(ie2), V3 = true, hBt(rj2(ie2), rj2(pe2), Nt.divide, ue2, At, w2)) : pBt(pe2, ue2, At));
        }
        new C4(p2, m2, W3(true, q3), W3(false, q3), null, "multiple").update(yt).updateManyToOne(function(At, Lt) {
          var Wt = m2[At], Nt = Wt.data, ue2 = Nt.hostModel, ie2 = Nt.getItemGraphicEl(Wt.dataIndex), pe2 = Fp(Ya2(Lt, function(xe) {
            return p2[xe].data.getItemGraphicEl(p2[xe].dataIndex);
          }), function(xe) {
            return xe && xe !== ie2 && !K[xe.id];
          });
          ie2 && (EY(ie2), pe2.length ? (Xe2(pe2, function(xe) {
            EY(xe), dBt(xe);
          }), V3 = true, hBt(rj2(pe2), rj2(ie2), Wt.divide, ue2, At, w2)) : pBt(ie2, ue2, Wt.dataIndex));
        }).updateOneToMany(function(At, Lt) {
          var Wt = p2[Lt], Nt = Wt.data.getItemGraphicEl(Wt.dataIndex);
          if (!(Nt && K[Nt.id])) {
            var ue2 = Fp(Ya2(At, function(pe2) {
              return m2[pe2].data.getItemGraphicEl(m2[pe2].dataIndex);
            }), function(pe2) {
              return pe2 && pe2 !== Nt;
            }), ie2 = m2[At[0]].data.hostModel;
            ue2.length && (Xe2(ue2, function(pe2) {
              return EY(pe2);
            }), Nt ? (EY(Nt), dBt(Nt), V3 = true, hBt(rj2(Nt), rj2(ue2), Wt.divide, ie2, At[0], w2)) : Xe2(ue2, function(pe2) {
              return pBt(pe2, ie2, At[0]);
            }));
          }
        }).updateManyToMany(function(At, Lt) {
          new C4(Lt, At, function(Wt) {
            return p2[Wt].data.getId(p2[Wt].dataIndex);
          }, function(Wt) {
            return m2[Wt].data.getId(m2[Wt].dataIndex);
          }).update(function(Wt, Nt) {
            yt(At[Wt], Lt[Nt]);
          }).execute();
        }).execute(), V3 && Xe2(o, function(At) {
          var Lt = At.data, Wt = Lt.hostModel, Nt = Wt && n3.getViewOfSeriesModel(Wt), ue2 = t8("update", Wt, 0);
          Nt && Wt.isAnimationEnabled() && ue2 && ue2.duration > 0 && Nt.group.traverse(function(ie2) {
            ie2 instanceof Mc2 && !ie2.animators.length && ie2.animateFrom({ style: { opacity: 0 } }, ue2);
          });
        });
      }
      function cMe(u) {
        var o = u.getModel("universalTransition").get("seriesKey");
        return o || u.id;
      }
      function fMe(u) {
        return za2(u) ? u.sort().join(",") : u;
      }
      function S8(u) {
        if (u.hostModel)
          return u.hostModel.getModel("universalTransition").get("divideShape");
      }
      function oOn(u, o) {
        var n3 = pl(), p2 = pl(), m2 = pl();
        return Xe2(u.oldSeries, function(w2, T2) {
          var E = u.oldData[T2], O2 = cMe(w2), V3 = fMe(O2);
          p2.set(V3, E), za2(O2) && Xe2(O2, function(W3) {
            m2.set(W3, { data: E, key: V3 });
          });
        }), Xe2(o.updatedSeries, function(w2) {
          if (w2.isUniversalTransitionEnabled() && w2.isAnimationEnabled()) {
            var T2 = w2.getData(), E = cMe(w2), O2 = fMe(E), V3 = p2.get(O2);
            if (V3)
              n3.set(O2, { oldSeries: [{ divide: S8(V3), data: V3 }], newSeries: [{ divide: S8(T2), data: T2 }] });
            else if (za2(E)) {
              var W3 = [];
              Xe2(E, function(J) {
                var rt2 = p2.get(J);
                rt2 && W3.push({ divide: S8(rt2), data: rt2 });
              }), W3.length && n3.set(O2, { oldSeries: W3, newSeries: [{ data: T2, divide: S8(T2) }] });
            } else {
              var q3 = m2.get(E);
              if (q3) {
                var K = n3.get(q3.key);
                K || (K = { oldSeries: [{ data: q3.data, divide: S8(q3.data) }], newSeries: [] }, n3.set(q3.key, K)), K.newSeries.push({ data: T2, divide: S8(T2) });
              }
            }
          }
        }), n3;
      }
      function hMe(u, o) {
        for (var n3 = 0; n3 < u.length; n3++) {
          var p2 = o.seriesIndex != null && o.seriesIndex === u[n3].seriesIndex || o.seriesId != null && o.seriesId === u[n3].id;
          if (p2)
            return n3;
        }
      }
      function sOn(u, o, n3, p2) {
        var m2 = [], w2 = [];
        Xe2(Tp(u.from), function(T2) {
          var E = hMe(o.oldSeries, T2);
          E >= 0 && m2.push({ data: o.oldData[E], divide: S8(o.oldData[E]), dim: T2.dimension });
        }), Xe2(Tp(u.to), function(T2) {
          var E = hMe(n3.updatedSeries, T2);
          if (E >= 0) {
            var O2 = n3.updatedSeries[E].getData();
            w2.push({ data: O2, divide: S8(O2), dim: T2.dimension });
          }
        }), m2.length > 0 && w2.length > 0 && uMe(m2, w2, p2);
      }
      function lOn(u) {
        u.registerUpdateLifecycle("series:beforeupdate", function(o, n3, p2) {
          Xe2(Tp(p2.seriesTransition), function(m2) {
            Xe2(Tp(m2.to), function(w2) {
              for (var T2 = p2.updatedSeries, E = 0; E < T2.length; E++)
                (w2.seriesIndex != null && w2.seriesIndex === T2[E].seriesIndex || w2.seriesId != null && w2.seriesId === T2[E].id) && (T2[E][H_t] = true);
            });
          });
        }), u.registerUpdateLifecycle("series:transition", function(o, n3, p2) {
          var m2 = nOn(n3);
          if (m2.oldSeries && p2.updatedSeries && p2.optionChanged) {
            var w2 = p2.seriesTransition;
            if (w2)
              Xe2(Tp(w2), function(K) {
                sOn(K, m2, p2, n3);
              });
            else {
              var T2 = oOn(m2, p2);
              Xe2(T2.keys(), function(K) {
                var J = T2.get(K);
                uMe(J.oldSeries, J.newSeries, n3);
              });
            }
            Xe2(p2.updatedSeries, function(K) {
              K[H_t] && (K[H_t] = false);
            });
          }
          for (var E = o.getSeries(), O2 = m2.oldSeries = [], V3 = m2.oldData = [], W3 = 0; W3 < E.length; W3++) {
            var q3 = E[W3].getData();
            q3.count() < sMe && (O2.push(E[W3]), V3.push(q3));
          }
        });
      }
      Rc2([Txn]), Rc2([bxn]), Rc2([Kxn, dwn, Twn, dSn, kSn, C2n, nMn, WMn, vCn, CCn, NCn, zTn, pAn, AAn, qAn, JAn, yIn, AIn, zIn, $In, sDn, UDn]), Rc2(dEn), Rc2($En), Rc2(s_e), Rc2(fkn), Rc2(kxe), Rc2(mkn), Rc2(Akn), Rc2(I5n), Rc2(X5n), Rc2(Cst), Rc2(yPn), Rc2(_Pn), Rc2(RPn), Rc2(UPn), Rc2(JPn), Rc2(s3n), Rc2(x3n), Rc2(G3n), Rc2(w2e), Rc2(T2e), Rc2(vLn), Rc2(W2e), Rc2(H2e), Rc2(xLn), Rc2(OLn), Rc2(FLn), Rc2(lOn), Rc2(V_n);
      function uOn(u) {
        const { defaultOptions: o } = u != null ? u : {}, n3 = L.useRef(null), p2 = L.useRef(), m2 = L.useRef(o);
        return L.useEffect(() => {
          if (!n3.current)
            return;
          const w2 = tbn(n3.current);
          p2.current = w2, m2.current && w2.setOption(m2.current);
        }, []), L.useEffect(() => () => {
          var w2, T2, E, O2;
          (T2 = (w2 = p2.current) == null ? void 0 : w2.dispose) == null || T2.call(w2), (O2 = (E = p2.current) == null ? void 0 : E.off) == null || O2.call(E, "*"), p2.current = void 0;
        }, []), ka2("resize", () => {
          requestAnimationFrame(() => {
            var w2, T2;
            (T2 = (w2 = p2 == null ? void 0 : p2.current) == null ? void 0 : w2.resize) == null || T2.call(w2);
          });
        }), { chart: p2, container: n3 };
      }
      class cOn {
        constructor() {
          D2(this, "chartsEmitters", /* @__PURE__ */ new Map()), D2(this, "add", (o, n3, p2, m2) => {
            n3 && p2 ? this.chartsEmitters.set(o, { chart: n3, option: p2, title: m2 }) : console.log("\u6DFB\u52A0\u5931\u8D25");
          }), D2(this, "get", (o) => this.chartsEmitters.get(o)), D2(this, "clear", () => {
            this.chartsEmitters.clear();
          }), D2(this, "delete", (o) => {
            this.chartsEmitters.delete(o);
          }), D2(this, "list", () => {
            var o, n3, p2;
            const m2 = [];
            for (const w2 of this.chartsEmitters.keys())
              m2.push({ id: w2, chart: (o = this.chartsEmitters.get(w2)) == null ? void 0 : o.chart, option: (n3 = this.chartsEmitters.get(w2)) == null ? void 0 : n3.option, title: (p2 = this.chartsEmitters.get(w2)) == null ? void 0 : p2.title });
            return m2;
          });
        }
      }
      const fOn = new cOn();
      var Cwt = { exports: {} };
      /**
      * @license
      * Lodash <https://lodash.com/>
      * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
      * Released under MIT license <https://lodash.com/license>
      * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
      * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
      */
      (function(u, o) {
        (function() {
          var n3, p2 = "4.17.21", m2 = 200, w2 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", T2 = "Expected a function", E = "Invalid `variable` option passed into `_.template`", O2 = "__lodash_hash_undefined__", V3 = 500, W3 = "__lodash_placeholder__", q3 = 1, K = 2, J = 4, rt2 = 1, gt = 2, yt = 1, At = 2, Lt = 4, Wt = 8, Nt = 16, ue2 = 32, ie2 = 64, pe2 = 128, xe = 256, Ce2 = 512, Le2 = 30, ze = "...", tn = 800, $e2 = 16, Tn = 1, zn = 2, bn = 3, Xr = 1 / 0, Xn = 9007199254740991, or = 17976931348623157e292, Tr = 0 / 0, ci2 = 4294967295, yi2 = ci2 - 1, Po = ci2 >>> 1, Ms = [["ary", pe2], ["bind", yt], ["bindKey", At], ["curry", Wt], ["curryRight", Nt], ["flip", Ce2], ["partial", ue2], ["partialRight", ie2], ["rearg", xe]], dl = "[object Arguments]", tl = "[object Array]", el = "[object AsyncFunction]", as = "[object Boolean]", Hs = "[object Date]", ol = "[object DOMException]", xs = "[object Error]", Bl = "[object Function]", Ph2 = "[object GeneratorFunction]", fu = "[object Map]", uh2 = "[object Number]", Zh2 = "[object Null]", zp = "[object Object]", tm = "[object Promise]", Fd2 = "[object Proxy]", O1 = "[object RegExp]", Kd2 = "[object Set]", Nv = "[object String]", mv = "[object Symbol]", CI = "[object Undefined]", go = "[object WeakMap]", aa2 = "[object WeakSet]", ta2 = "[object ArrayBuffer]", bo = "[object DataView]", js = "[object Float32Array]", eu = "[object Float64Array]", bf2 = "[object Int8Array]", _f = "[object Int16Array]", nd2 = "[object Int32Array]", bv = "[object Uint8Array]", Mg2 = "[object Uint8ClampedArray]", K0 = "[object Uint16Array]", Cg2 = "[object Uint32Array]", Rb2 = /\b__p \+= '';/g, ax = /\b(__p \+=) '' \+/g, hM = /(__e\(.*?\)|\b__t\)) \+\n'';/g, ox = /&(?:amp|lt|gt|quot|#39);/g, l0 = /[&<>"']/g, $h2 = RegExp(ox.source), Ay = RegExp(l0.source), R1 = /<%-([\s\S]+?)%>/g, pM = /<%([\s\S]+?)%>/g, Pw = /<%=([\s\S]+?)%>/g, sx = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, l22 = /^\w*$/, n32 = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, uk2 = /[\\^$.*+?()[\]{}|]/g, sj2 = RegExp(uk2.source), ck2 = /^\s+/, $st = /\s/, Yst = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Kst = /\{\n\/\* \[wrapped with (.+)\] \*/, Xst = /,? & /, A8 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, wr = /[()=,{}\[\]\/\s]/, Pr = /\\(\\)?/g, Nn = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, hr = /\w*$/, vr = /^[-+]0x[0-9a-f]+$/i, wn = /^0b[01]+$/i, no = /^\[object .+?Constructor\]$/, Pa2 = /^0o[0-7]+$/i, pi2 = /^(?:0|[1-9]\d*)$/, Uo = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, os = /($^)/, If2 = /['\n\r\u2028\u2029\\]/g, Lh2 = "\\ud800-\\udfff", Yh2 = "\\u0300-\\u036f", Bf2 = "\\ufe20-\\ufe2f", Sd2 = "\\u20d0-\\u20ff", Fv = Yh2 + Bf2 + Sd2, Nc2 = "\\u2700-\\u27bf", X0 = "a-z\\xdf-\\xf6\\xf8-\\xff", T0 = "\\xac\\xb1\\xd7\\xf7", dM = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", N4 = "\\u2000-\\u206f", Nb2 = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", TI = "A-Z\\xc0-\\xd6\\xd8-\\xde", fk2 = "\\ufe0e\\ufe0f", em = T0 + dM + N4 + Nb2, gM = "['\u2019]", F4 = "[" + Lh2 + "]", AI = "[" + em + "]", II = "[" + Fv + "]", hk2 = "\\d+", lj2 = "[" + Nc2 + "]", V4 = "[" + X0 + "]", r3 = "[^" + Lh2 + em + hk2 + Nc2 + X0 + TI + "]", Ml = "\\ud83c[\\udffb-\\udfff]", bu = "(?:" + II + "|" + Ml + ")", B4 = "[^" + Lh2 + "]", sa2 = "(?:\\ud83c[\\udde6-\\uddff]){2}", Cl = "[\\ud800-\\udbff][\\udc00-\\udfff]", Lu = "[" + TI + "]", Qwt = "\\u200d", A0 = "(?:" + V4 + "|" + r3 + ")", Fb2 = "(?:" + Lu + "|" + r3 + ")", Ye2 = "(?:" + gM + "(?:d|ll|m|re|s|t|ve))?", Ha2 = "(?:" + gM + "(?:D|LL|M|RE|S|T|VE))?", VC = bu + "?", jp = "[" + fk2 + "]?", ozt = "(?:" + Qwt + "(?:" + [B4, sa2, Cl].join("|") + ")" + jp + VC + ")*", nf2 = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", szt = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Cs = jp + VC + ozt, Au = "(?:" + [lj2, sa2, Cl].join("|") + ")" + Cs, ja2 = "(?:" + [B4 + II + "?", II, sa2, Cl, F4].join("|") + ")", Tl = RegExp(gM, "g"), gs = RegExp(II, "g"), uj2 = RegExp(Ml + "(?=" + Ml + ")|" + ja2 + Cs, "g"), Oh2 = RegExp([Lu + "?" + V4 + "+" + Ye2 + "(?=" + [AI, Lu, "$"].join("|") + ")", Fb2 + "+" + Ha2 + "(?=" + [AI, Lu + A0, "$"].join("|") + ")", Lu + "?" + A0 + "+" + Ye2, Lu + "+" + Ha2, szt, nf2, hk2, Au].join("|"), "g"), Wl = RegExp("[" + Qwt + Lh2 + Fv + fk2 + "]"), Jwt = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, u2 = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], cj2 = -1, Xd2 = {};
          Xd2[js] = Xd2[eu] = Xd2[bf2] = Xd2[_f] = Xd2[nd2] = Xd2[bv] = Xd2[Mg2] = Xd2[K0] = Xd2[Cg2] = true, Xd2[dl] = Xd2[tl] = Xd2[ta2] = Xd2[as] = Xd2[bo] = Xd2[Hs] = Xd2[xs] = Xd2[Bl] = Xd2[fu] = Xd2[uh2] = Xd2[zp] = Xd2[O1] = Xd2[Kd2] = Xd2[Nv] = Xd2[go] = false;
          var Jg2 = {};
          Jg2[dl] = Jg2[tl] = Jg2[ta2] = Jg2[bo] = Jg2[as] = Jg2[Hs] = Jg2[js] = Jg2[eu] = Jg2[bf2] = Jg2[_f] = Jg2[nd2] = Jg2[fu] = Jg2[uh2] = Jg2[zp] = Jg2[O1] = Jg2[Kd2] = Jg2[Nv] = Jg2[mv] = Jg2[bv] = Jg2[Mg2] = Jg2[K0] = Jg2[Cg2] = true, Jg2[xs] = Jg2[Bl] = Jg2[go] = false;
          var lzt = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, fj2 = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, Wm = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, tc2 = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, pk2 = parseFloat, Qst = parseInt, VY = typeof Je2 == "object" && Je2 && Je2.Object === Object && Je2, lx = typeof self == "object" && self && self.Object === Object && self, Tg2 = VY || lx || Function("return this")(), BY = o && !o.nodeType && o, DI = BY && true && u && !u.nodeType && u, I8 = DI && DI.exports === BY, Jst = I8 && VY.process, Ps = function() {
            try {
              var wi2 = DI && DI.require && DI.require("util").types;
              return wi2 || Jst && Jst.binding && Jst.binding("util");
            } catch {
            }
          }(), zY = Ps && Ps.isArrayBuffer, hj2 = Ps && Ps.isDate, tlt = Ps && Ps.isMap, Ls = Ps && Ps.isRegExp, I0 = Ps && Ps.isSet, pj2 = Ps && Ps.isTypedArray;
          function nm(wi2, oo, da2) {
            switch (da2.length) {
              case 0:
                return wi2.call(oo);
              case 1:
                return wi2.call(oo, da2[0]);
              case 2:
                return wi2.call(oo, da2[0], da2[1]);
              case 3:
                return wi2.call(oo, da2[0], da2[1], da2[2]);
            }
            return wi2.apply(oo, da2);
          }
          function ux(wi2, oo, da2, Gl) {
            for (var $c2 = -1, pd2 = wi2 == null ? 0 : wi2.length; ++$c2 < pd2; ) {
              var Dy = wi2[$c2];
              oo(Gl, Dy, da2(Dy), wi2);
            }
            return Gl;
          }
          function Iy(wi2, oo) {
            for (var da2 = -1, Gl = wi2 == null ? 0 : wi2.length; ++da2 < Gl && oo(wi2[da2], da2, wi2) !== false; )
              ;
            return wi2;
          }
          function uzt(wi2, oo) {
            for (var da2 = wi2 == null ? 0 : wi2.length; da2-- && oo(wi2[da2], da2, wi2) !== false; )
              ;
            return wi2;
          }
          function elt(wi2, oo) {
            for (var da2 = -1, Gl = wi2 == null ? 0 : wi2.length; ++da2 < Gl; )
              if (!oo(wi2[da2], da2, wi2))
                return false;
            return true;
          }
          function EI(wi2, oo) {
            for (var da2 = -1, Gl = wi2 == null ? 0 : wi2.length, $c2 = 0, pd2 = []; ++da2 < Gl; ) {
              var Dy = wi2[da2];
              oo(Dy, da2, wi2) && (pd2[$c2++] = Dy);
            }
            return pd2;
          }
          function kI(wi2, oo) {
            var da2 = wi2 == null ? 0 : wi2.length;
            return !!da2 && c2(wi2, oo, 0) > -1;
          }
          function dj2(wi2, oo, da2) {
            for (var Gl = -1, $c2 = wi2 == null ? 0 : wi2.length; ++Gl < $c2; )
              if (da2(oo, wi2[Gl]))
                return true;
            return false;
          }
          function Vv(wi2, oo) {
            for (var da2 = -1, Gl = wi2 == null ? 0 : wi2.length, $c2 = Array(Gl); ++da2 < Gl; )
              $c2[da2] = oo(wi2[da2], da2, wi2);
            return $c2;
          }
          function PI3(wi2, oo) {
            for (var da2 = -1, Gl = oo.length, $c2 = wi2.length; ++da2 < Gl; )
              wi2[$c2 + da2] = oo[da2];
            return wi2;
          }
          function z4(wi2, oo, da2, Gl) {
            var $c2 = -1, pd2 = wi2 == null ? 0 : wi2.length;
            for (Gl && pd2 && (da2 = wi2[++$c2]); ++$c2 < pd2; )
              da2 = oo(da2, wi2[$c2], $c2, wi2);
            return da2;
          }
          function nlt(wi2, oo, da2, Gl) {
            var $c2 = wi2 == null ? 0 : wi2.length;
            for (Gl && $c2 && (da2 = wi2[--$c2]); $c2--; )
              da2 = oo(da2, wi2[$c2], $c2, wi2);
            return da2;
          }
          function LI(wi2, oo) {
            for (var da2 = -1, Gl = wi2 == null ? 0 : wi2.length; ++da2 < Gl; )
              if (oo(wi2[da2], da2, wi2))
                return true;
            return false;
          }
          var czt = rlt("length");
          function j4(wi2) {
            return wi2.split("");
          }
          function jY(wi2) {
            return wi2.match(A8) || [];
          }
          function Gm(wi2, oo, da2) {
            var Gl;
            return da2(wi2, function($c2, pd2, Dy) {
              if (oo($c2, pd2, Dy))
                return Gl = pd2, false;
            }), Gl;
          }
          function BC(wi2, oo, da2, Gl) {
            for (var $c2 = wi2.length, pd2 = da2 + (Gl ? 1 : -1); Gl ? pd2-- : ++pd2 < $c2; )
              if (oo(wi2[pd2], pd2, wi2))
                return pd2;
            return -1;
          }
          function c2(wi2, oo, da2) {
            return oo === oo ? pzt(wi2, oo, da2) : BC(wi2, tSt, da2);
          }
          function D8(wi2, oo, da2, Gl) {
            for (var $c2 = da2 - 1, pd2 = wi2.length; ++$c2 < pd2; )
              if (Gl(wi2[$c2], oo))
                return $c2;
            return -1;
          }
          function tSt(wi2) {
            return wi2 !== wi2;
          }
          function eSt(wi2, oo) {
            var da2 = wi2 == null ? 0 : wi2.length;
            return da2 ? WY(wi2, oo) / da2 : Tr;
          }
          function rlt(wi2) {
            return function(oo) {
              return oo == null ? n3 : oo[wi2];
            };
          }
          function Lw(wi2) {
            return function(oo) {
              return wi2 == null ? n3 : wi2[oo];
            };
          }
          function nSt(wi2, oo, da2, Gl, $c2) {
            return $c2(wi2, function(pd2, Dy, Vd2) {
              da2 = Gl ? (Gl = false, pd2) : oo(da2, pd2, Dy, Vd2);
            }), da2;
          }
          function ilt(wi2, oo) {
            var da2 = wi2.length;
            for (wi2.sort(oo); da2--; )
              wi2[da2] = wi2[da2].value;
            return wi2;
          }
          function WY(wi2, oo) {
            for (var da2, Gl = -1, $c2 = wi2.length; ++Gl < $c2; ) {
              var pd2 = oo(wi2[Gl]);
              pd2 !== n3 && (da2 = da2 === n3 ? pd2 : da2 + pd2);
            }
            return da2;
          }
          function GY(wi2, oo) {
            for (var da2 = -1, Gl = Array(wi2); ++da2 < wi2; )
              Gl[da2] = oo(da2);
            return Gl;
          }
          function alt(wi2, oo) {
            return Vv(oo, function(da2) {
              return [da2, wi2[da2]];
            });
          }
          function rSt(wi2) {
            return wi2 && wi2.slice(0, sSt(wi2) + 1).replace(ck2, "");
          }
          function cx(wi2) {
            return function(oo) {
              return wi2(oo);
            };
          }
          function olt(wi2, oo) {
            return Vv(oo, function(da2) {
              return wi2[da2];
            });
          }
          function gj2(wi2, oo) {
            return wi2.has(oo);
          }
          function slt(wi2, oo) {
            for (var da2 = -1, Gl = wi2.length; ++da2 < Gl && c2(oo, wi2[da2], 0) > -1; )
              ;
            return da2;
          }
          function iSt(wi2, oo) {
            for (var da2 = wi2.length; da2-- && c2(oo, wi2[da2], 0) > -1; )
              ;
            return da2;
          }
          function llt(wi2, oo) {
            for (var da2 = wi2.length, Gl = 0; da2--; )
              wi2[da2] === oo && ++Gl;
            return Gl;
          }
          var fzt = Lw(lzt), ult = Lw(fj2);
          function aSt(wi2) {
            return "\\" + tc2[wi2];
          }
          function clt(wi2, oo) {
            return wi2 == null ? n3 : wi2[oo];
          }
          function N1(wi2) {
            return Wl.test(wi2);
          }
          function hzt(wi2) {
            return Jwt.test(wi2);
          }
          function flt(wi2) {
            for (var oo, da2 = []; !(oo = wi2.next()).done; )
              da2.push(oo.value);
            return da2;
          }
          function hlt(wi2) {
            var oo = -1, da2 = Array(wi2.size);
            return wi2.forEach(function(Gl, $c2) {
              da2[++oo] = [$c2, Gl];
            }), da2;
          }
          function OI(wi2, oo) {
            return function(da2) {
              return wi2(oo(da2));
            };
          }
          function dk2(wi2, oo) {
            for (var da2 = -1, Gl = wi2.length, $c2 = 0, pd2 = []; ++da2 < Gl; ) {
              var Dy = wi2[da2];
              (Dy === oo || Dy === W3) && (wi2[da2] = W3, pd2[$c2++] = da2);
            }
            return pd2;
          }
          function HY(wi2) {
            var oo = -1, da2 = Array(wi2.size);
            return wi2.forEach(function(Gl) {
              da2[++oo] = Gl;
            }), da2;
          }
          function oSt(wi2) {
            var oo = -1, da2 = Array(wi2.size);
            return wi2.forEach(function(Gl) {
              da2[++oo] = [Gl, Gl];
            }), da2;
          }
          function pzt(wi2, oo, da2) {
            for (var Gl = da2 - 1, $c2 = wi2.length; ++Gl < $c2; )
              if (wi2[Gl] === oo)
                return Gl;
            return -1;
          }
          function plt(wi2, oo, da2) {
            for (var Gl = da2 + 1; Gl--; )
              if (wi2[Gl] === oo)
                return Gl;
            return Gl;
          }
          function W4(wi2) {
            return N1(wi2) ? vj2(wi2) : czt(wi2);
          }
          function zC(wi2) {
            return N1(wi2) ? gzt(wi2) : j4(wi2);
          }
          function sSt(wi2) {
            for (var oo = wi2.length; oo-- && $st.test(wi2.charAt(oo)); )
              ;
            return oo;
          }
          var dzt = Lw(Wm);
          function vj2(wi2) {
            for (var oo = uj2.lastIndex = 0; uj2.test(wi2); )
              ++oo;
            return oo;
          }
          function gzt(wi2) {
            return wi2.match(uj2) || [];
          }
          function lSt(wi2) {
            return wi2.match(Oh2) || [];
          }
          var vzt = function wi2(oo) {
            oo = oo == null ? Tg2 : G4.defaults(Tg2.Object(), oo, G4.pick(Tg2, u2));
            var da2 = oo.Array, Gl = oo.Date, $c2 = oo.Error, pd2 = oo.Function, Dy = oo.Math, Vd2 = oo.Object, yj2 = oo.RegExp, yzt = oo.String, fx = oo.TypeError, Vb2 = da2.prototype, mj2 = pd2.prototype, jC = Vd2.prototype, bj2 = oo["__core-js_shared__"], E8 = mj2.toString, Md2 = jC.hasOwnProperty, mzt = 0, uSt = function() {
              var ot = /[^.]+$/.exec(bj2 && bj2.keys && bj2.keys.IE_PROTO || "");
              return ot ? "Symbol(src)_1." + ot : "";
            }(), _j = jC.toString, dlt = E8.call(Vd2), UY = Tg2._, cSt = yj2("^" + E8.call(Md2).replace(uk2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), H4 = I8 ? oo.Buffer : n3, hx = oo.Symbol, U4 = oo.Uint8Array, glt = H4 ? H4.allocUnsafe : n3, xj2 = OI(Vd2.getPrototypeOf, Vd2), wj2 = Vd2.create, WC = jC.propertyIsEnumerable, px = Vb2.splice, q4 = hx ? hx.isConcatSpreadable : n3, vM = hx ? hx.iterator : n3, i3 = hx ? hx.toStringTag : n3, D0 = function() {
              try {
                var ot = m3(Vd2, "defineProperty");
                return ot({}, "", {}), ot;
              } catch {
              }
            }(), fSt = oo.clearTimeout !== Tg2.clearTimeout && oo.clearTimeout, qY = Gl && Gl.now !== Tg2.Date.now && Gl.now, hSt = oo.setTimeout !== Tg2.setTimeout && oo.setTimeout, GC = Dy.ceil, Sj2 = Dy.floor, vlt = Vd2.getOwnPropertySymbols, Hm = H4 ? H4.isBuffer : n3, ZY = oo.isFinite, bzt = Vb2.join, pSt = OI(Vd2.keys, Vd2), u0 = Dy.max, F1 = Dy.min, _zt = Gl.now, xzt = oo.parseInt, $Y = Dy.random, wzt = Vb2.reverse, ylt = m3(oo, "DataView"), k8 = m3(oo, "Map"), mlt = m3(oo, "Promise"), P8 = m3(oo, "Set"), gk2 = m3(oo, "WeakMap"), L8 = m3(Vd2, "create"), Ow = gk2 && new gk2(), O8 = {}, Mj2 = iR(ylt), blt = iR(k8), R8 = iR(mlt), _lt = iR(P8), a3 = iR(gk2), dx = hx ? hx.prototype : n3, Z4 = dx ? dx.valueOf : n3, xlt = dx ? dx.toString : n3;
            function kn(ot) {
              if (wv(ot) && !af2(ot) && !(ot instanceof up)) {
                if (ot instanceof Rw)
                  return ot;
                if (Md2.call(ot, "__wrapped__"))
                  return jSt(ot);
              }
              return new Rw(ot);
            }
            var HC = function() {
              function ot() {
              }
              return function(St) {
                if (!Bv(St))
                  return {};
                if (wj2)
                  return wj2(St);
                ot.prototype = St;
                var Xt = new ot();
                return ot.prototype = n3, Xt;
              };
            }();
            function Bb2() {
            }
            function Rw(ot, St) {
              this.__wrapped__ = ot, this.__actions__ = [], this.__chain__ = !!St, this.__index__ = 0, this.__values__ = n3;
            }
            kn.templateSettings = { escape: R1, evaluate: pM, interpolate: Pw, variable: "", imports: { _: kn } }, kn.prototype = Bb2.prototype, kn.prototype.constructor = kn, Rw.prototype = HC(Bb2.prototype), Rw.prototype.constructor = Rw;
            function up(ot) {
              this.__wrapped__ = ot, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = ci2, this.__views__ = [];
            }
            function wlt() {
              var ot = new up(this.__wrapped__);
              return ot.__actions__ = B1(this.__actions__), ot.__dir__ = this.__dir__, ot.__filtered__ = this.__filtered__, ot.__iteratees__ = B1(this.__iteratees__), ot.__takeCount__ = this.__takeCount__, ot.__views__ = B1(this.__views__), ot;
            }
            function Slt() {
              if (this.__filtered__) {
                var ot = new up(this);
                ot.__dir__ = -1, ot.__filtered__ = true;
              } else
                ot = this.clone(), ot.__dir__ *= -1;
              return ot;
            }
            function Szt() {
              var ot = this.__wrapped__.value(), St = this.__dir__, Xt = af2(ot), Ie2 = St < 0, cn = Xt ? ot.length : 0, Wn = Gzt(0, cn, this.__views__), zr = Wn.start, Qr = Wn.end, Ni2 = Qr - zr, wo = Ie2 ? Qr : zr - 1, vo = this.__iteratees__, Lo = vo.length, Ks = 0, yu = F1(Ni2, this.__takeCount__);
              if (!Xt || !Ie2 && cn == Ni2 && yu == Ni2)
                return Lj2(ot, this.__actions__);
              var gc2 = [];
              t:
                for (; Ni2-- && Ks < yu; ) {
                  wo += St;
                  for (var of2 = -1, uc2 = ot[wo]; ++of2 < Lo; ) {
                    var Kh2 = vo[of2], ph2 = Kh2.iteratee, j1 = Kh2.type, Hb2 = ph2(uc2);
                    if (j1 == zn)
                      uc2 = Hb2;
                    else if (!Hb2) {
                      if (j1 == Tn)
                        continue t;
                      break t;
                    }
                  }
                  gc2[Ks++] = uc2;
                }
              return gc2;
            }
            up.prototype = HC(Bb2.prototype), up.prototype.constructor = up;
            function UC(ot) {
              var St = -1, Xt = ot == null ? 0 : ot.length;
              for (this.clear(); ++St < Xt; ) {
                var Ie2 = ot[St];
                this.set(Ie2[0], Ie2[1]);
              }
            }
            function YY() {
              this.__data__ = L8 ? L8(null) : {}, this.size = 0;
            }
            function vk2(ot) {
              var St = this.has(ot) && delete this.__data__[ot];
              return this.size -= St ? 1 : 0, St;
            }
            function KY(ot) {
              var St = this.__data__;
              if (L8) {
                var Xt = St[ot];
                return Xt === O2 ? n3 : Xt;
              }
              return Md2.call(St, ot) ? St[ot] : n3;
            }
            function XY2(ot) {
              var St = this.__data__;
              return L8 ? St[ot] !== n3 : Md2.call(St, ot);
            }
            function N8(ot, St) {
              var Xt = this.__data__;
              return this.size += this.has(ot) ? 0 : 1, Xt[ot] = L8 && St === n3 ? O2 : St, this;
            }
            UC.prototype.clear = YY, UC.prototype.delete = vk2, UC.prototype.get = KY, UC.prototype.has = XY2, UC.prototype.set = N8;
            function RI(ot) {
              var St = -1, Xt = ot == null ? 0 : ot.length;
              for (this.clear(); ++St < Xt; ) {
                var Ie2 = ot[St];
                this.set(Ie2[0], Ie2[1]);
              }
            }
            function o3() {
              this.__data__ = [], this.size = 0;
            }
            function QY(ot) {
              var St = this.__data__, Xt = l3(St, ot);
              if (Xt < 0)
                return false;
              var Ie2 = St.length - 1;
              return Xt == Ie2 ? St.pop() : px.call(St, Xt, 1), --this.size, true;
            }
            function Mlt(ot) {
              var St = this.__data__, Xt = l3(St, ot);
              return Xt < 0 ? n3 : St[Xt][1];
            }
            function Mzt(ot) {
              return l3(this.__data__, ot) > -1;
            }
            function Czt(ot, St) {
              var Xt = this.__data__, Ie2 = l3(Xt, ot);
              return Ie2 < 0 ? (++this.size, Xt.push([ot, St])) : Xt[Ie2][1] = St, this;
            }
            RI.prototype.clear = o3, RI.prototype.delete = QY, RI.prototype.get = Mlt, RI.prototype.has = Mzt, RI.prototype.set = Czt;
            function yk(ot) {
              var St = -1, Xt = ot == null ? 0 : ot.length;
              for (this.clear(); ++St < Xt; ) {
                var Ie2 = ot[St];
                this.set(Ie2[0], Ie2[1]);
              }
            }
            function Tzt() {
              this.size = 0, this.__data__ = { hash: new UC(), map: new (k8 || RI)(), string: new UC() };
            }
            function Azt(ot) {
              var St = Sk(this, ot).delete(ot);
              return this.size -= St ? 1 : 0, St;
            }
            function dSt(ot) {
              return Sk(this, ot).get(ot);
            }
            function Izt(ot) {
              return Sk(this, ot).has(ot);
            }
            function Dzt(ot, St) {
              var Xt = Sk(this, ot), Ie2 = Xt.size;
              return Xt.set(ot, St), this.size += Xt.size == Ie2 ? 0 : 1, this;
            }
            yk.prototype.clear = Tzt, yk.prototype.delete = Azt, yk.prototype.get = dSt, yk.prototype.has = Izt, yk.prototype.set = Dzt;
            function s3(ot) {
              var St = -1, Xt = ot == null ? 0 : ot.length;
              for (this.__data__ = new yk(); ++St < Xt; )
                this.add(ot[St]);
            }
            function gSt(ot) {
              return this.__data__.set(ot, O2), this;
            }
            function Ezt(ot) {
              return this.__data__.has(ot);
            }
            s3.prototype.add = s3.prototype.push = gSt, s3.prototype.has = Ezt;
            function Nw(ot) {
              var St = this.__data__ = new RI(ot);
              this.size = St.size;
            }
            function vSt() {
              this.__data__ = new RI(), this.size = 0;
            }
            function ySt(ot) {
              var St = this.__data__, Xt = St.delete(ot);
              return this.size = St.size, Xt;
            }
            function kzt(ot) {
              return this.__data__.get(ot);
            }
            function Clt(ot) {
              return this.__data__.has(ot);
            }
            function mk2(ot, St) {
              var Xt = this.__data__;
              if (Xt instanceof RI) {
                var Ie2 = Xt.__data__;
                if (!k8 || Ie2.length < m2 - 1)
                  return Ie2.push([ot, St]), this.size = ++Xt.size, this;
                Xt = this.__data__ = new yk(Ie2);
              }
              return Xt.set(ot, St), this.size = Xt.size, this;
            }
            Nw.prototype.clear = vSt, Nw.prototype.delete = ySt, Nw.prototype.get = kzt, Nw.prototype.has = Clt, Nw.prototype.set = mk2;
            function JY(ot, St) {
              var Xt = af2(ot), Ie2 = !Xt && C3(ot), cn = !Xt && !Ie2 && k0(ot), Wn = !Xt && !Ie2 && !cn && MM(ot), zr = Xt || Ie2 || cn || Wn, Qr = zr ? GY(ot.length, yzt) : [], Ni2 = Qr.length;
              for (var wo in ot)
                (St || Md2.call(ot, wo)) && !(zr && (wo == "length" || cn && (wo == "offset" || wo == "parent") || Wn && (wo == "buffer" || wo == "byteLength" || wo == "byteOffset") || Mk(wo, Ni2))) && Qr.push(wo);
              return Qr;
            }
            function mSt(ot) {
              var St = ot.length;
              return St ? ot[xM(0, St - 1)] : n3;
            }
            function tK(ot, St) {
              return CK(B1(ot), qC(St, 0, ot.length));
            }
            function bSt(ot) {
              return CK(B1(ot));
            }
            function Tlt(ot, St, Xt) {
              (Xt !== n3 && !Pl(ot[St], Xt) || Xt === n3 && !(St in ot)) && yM(ot, St, Xt);
            }
            function Cj2(ot, St, Xt) {
              var Ie2 = ot[St];
              (!(Md2.call(ot, St) && Pl(Ie2, Xt)) || Xt === n3 && !(St in ot)) && yM(ot, St, Xt);
            }
            function l3(ot, St) {
              for (var Xt = ot.length; Xt--; )
                if (Pl(ot[Xt][0], St))
                  return Xt;
              return -1;
            }
            function eK(ot, St, Xt, Ie2) {
              return mM(ot, function(cn, Wn, zr) {
                St(Ie2, cn, Xt(cn), zr);
              }), Ie2;
            }
            function _St(ot, St) {
              return ot && KC(St, rm(St), ot);
            }
            function nK(ot, St) {
              return ot && KC(St, jw(St), ot);
            }
            function yM(ot, St, Xt) {
              St == "__proto__" && D0 ? D0(ot, St, { configurable: true, enumerable: true, value: Xt, writable: true }) : ot[St] = Xt;
            }
            function rK(ot, St) {
              for (var Xt = -1, Ie2 = St.length, cn = da2(Ie2), Wn = ot == null; ++Xt < Ie2; )
                cn[Xt] = Wn ? n3 : Rut(ot, St[Xt]);
              return cn;
            }
            function qC(ot, St, Xt) {
              return ot === ot && (Xt !== n3 && (ot = ot <= Xt ? ot : Xt), St !== n3 && (ot = ot >= St ? ot : St)), ot;
            }
            function Fw(ot, St, Xt, Ie2, cn, Wn) {
              var zr, Qr = St & q3, Ni2 = St & K, wo = St & J;
              if (Xt && (zr = cn ? Xt(ot, Ie2, cn, Wn) : Xt(ot)), zr !== n3)
                return zr;
              if (!Bv(ot))
                return ot;
              var vo = af2(ot);
              if (vo) {
                if (zr = zj2(ot), !Qr)
                  return B1(ot, zr);
              } else {
                var Lo = zb2(ot), Ks = Lo == Bl || Lo == Ph2;
                if (k0(ot))
                  return gK(ot, Qr);
                if (Lo == zp || Lo == dl || Ks && !cn) {
                  if (zr = Ni2 || Ks ? {} : Q0(ot), !Qr)
                    return Ni2 ? jzt(ot, nK(zr, ot)) : zzt(ot, _St(zr, ot));
                } else {
                  if (!Jg2[Lo])
                    return cn ? ot : {};
                  zr = Xlt(ot, Lo, Qr);
                }
              }
              Wn || (Wn = new Nw());
              var yu = Wn.get(ot);
              if (yu)
                return yu;
              Wn.set(ot, zr), y2t(ot) ? ot.forEach(function(uc2) {
                zr.add(Fw(uc2, St, Xt, uc2, ot, Wn));
              }) : Aut(ot) && ot.forEach(function(uc2, Kh2) {
                zr.set(Kh2, Fw(uc2, St, Xt, Kh2, ot, Wn));
              });
              var gc2 = wo ? Ni2 ? xK : _K : Ni2 ? jw : rm, of2 = vo ? n3 : gc2(ot);
              return Iy(of2 || ot, function(uc2, Kh2) {
                of2 && (Kh2 = uc2, uc2 = ot[Kh2]), Cj2(zr, Kh2, Fw(uc2, St, Xt, Kh2, ot, Wn));
              }), zr;
            }
            function Alt(ot) {
              var St = rm(ot);
              return function(Xt) {
                return Ilt(Xt, ot, St);
              };
            }
            function Ilt(ot, St, Xt) {
              var Ie2 = Xt.length;
              if (ot == null)
                return !Ie2;
              for (ot = Vd2(ot); Ie2--; ) {
                var cn = Xt[Ie2], Wn = St[cn], zr = ot[cn];
                if (zr === n3 && !(cn in ot) || !Wn(zr))
                  return false;
              }
              return true;
            }
            function Dlt(ot, St, Xt) {
              if (typeof ot != "function")
                throw new fx(T2);
              return Vw(function() {
                ot.apply(n3, Xt);
              }, St);
            }
            function u3(ot, St, Xt, Ie2) {
              var cn = -1, Wn = kI, zr = true, Qr = ot.length, Ni2 = [], wo = St.length;
              if (!Qr)
                return Ni2;
              Xt && (St = Vv(St, cx(Xt))), Ie2 ? (Wn = dj2, zr = false) : St.length >= m2 && (Wn = gj2, zr = false, St = new s3(St));
              t:
                for (; ++cn < Qr; ) {
                  var vo = ot[cn], Lo = Xt == null ? vo : Xt(vo);
                  if (vo = Ie2 || vo !== 0 ? vo : 0, zr && Lo === Lo) {
                    for (var Ks = wo; Ks--; )
                      if (St[Ks] === Lo)
                        continue t;
                    Ni2.push(vo);
                  } else
                    Wn(St, Lo, Ie2) || Ni2.push(vo);
                }
              return Ni2;
            }
            var mM = ESt(ZC), xSt = ESt(aK, true);
            function Elt(ot, St) {
              var Xt = true;
              return mM(ot, function(Ie2, cn, Wn) {
                return Xt = !!St(Ie2, cn, Wn), Xt;
              }), Xt;
            }
            function bk2(ot, St, Xt) {
              for (var Ie2 = -1, cn = ot.length; ++Ie2 < cn; ) {
                var Wn = ot[Ie2], zr = St(Wn);
                if (zr != null && (Qr === n3 ? zr === zr && !mx(zr) : Xt(zr, Qr)))
                  var Qr = zr, Ni2 = Wn;
              }
              return Ni2;
            }
            function Pzt(ot, St, Xt, Ie2) {
              var cn = ot.length;
              for (Xt = Ef2(Xt), Xt < 0 && (Xt = -Xt > cn ? 0 : cn + Xt), Ie2 = Ie2 === n3 || Ie2 > cn ? cn : Ef2(Ie2), Ie2 < 0 && (Ie2 += cn), Ie2 = Xt > Ie2 ? 0 : kut(Ie2); Xt < Ie2; )
                ot[Xt++] = St;
              return ot;
            }
            function wSt(ot, St) {
              var Xt = [];
              return mM(ot, function(Ie2, cn, Wn) {
                St(Ie2, cn, Wn) && Xt.push(Ie2);
              }), Xt;
            }
            function V1(ot, St, Xt, Ie2, cn) {
              var Wn = -1, zr = ot.length;
              for (Xt || (Xt = Uzt), cn || (cn = []); ++Wn < zr; ) {
                var Qr = ot[Wn];
                St > 0 && Xt(Qr) ? St > 1 ? V1(Qr, St - 1, Xt, Ie2, cn) : PI3(cn, Qr) : Ie2 || (cn[cn.length] = Qr);
              }
              return cn;
            }
            var Tj2 = zlt(), iK = zlt(true);
            function ZC(ot, St) {
              return ot && Tj2(ot, St, rm);
            }
            function aK(ot, St) {
              return ot && iK(ot, St, rm);
            }
            function F8(ot, St) {
              return EI(St, function(Xt) {
                return g2(ot[Xt]);
              });
            }
            function $4(ot, St) {
              St = v32(St, ot);
              for (var Xt = 0, Ie2 = St.length; ot != null && Xt < Ie2; )
                ot = ot[FI(St[Xt++])];
              return Xt && Xt == Ie2 ? ot : n3;
            }
            function oK(ot, St, Xt) {
              var Ie2 = St(ot);
              return af2(ot) ? Ie2 : PI3(Ie2, Xt(ot));
            }
            function gx(ot) {
              return ot == null ? ot === n3 ? CI : Zh2 : i3 && i3 in Vd2(ot) ? Wzt(ot) : $zt(ot);
            }
            function sK(ot, St) {
              return ot > St;
            }
            function Lzt(ot, St) {
              return ot != null && Md2.call(ot, St);
            }
            function $C(ot, St) {
              return ot != null && St in Vd2(ot);
            }
            function klt(ot, St, Xt) {
              return ot >= F1(St, Xt) && ot < u0(St, Xt);
            }
            function Plt(ot, St, Xt) {
              for (var Ie2 = Xt ? dj2 : kI, cn = ot[0].length, Wn = ot.length, zr = Wn, Qr = da2(Wn), Ni2 = 1 / 0, wo = []; zr--; ) {
                var vo = ot[zr];
                zr && St && (vo = Vv(vo, cx(St))), Ni2 = F1(vo.length, Ni2), Qr[zr] = !Xt && (St || cn >= 120 && vo.length >= 120) ? new s3(zr && vo) : n3;
              }
              vo = ot[0];
              var Lo = -1, Ks = Qr[0];
              t:
                for (; ++Lo < cn && wo.length < Ni2; ) {
                  var yu = vo[Lo], gc2 = St ? St(yu) : yu;
                  if (yu = Xt || yu !== 0 ? yu : 0, !(Ks ? gj2(Ks, gc2) : Ie2(wo, gc2, Xt))) {
                    for (zr = Wn; --zr; ) {
                      var of2 = Qr[zr];
                      if (!(of2 ? gj2(of2, gc2) : Ie2(ot[zr], gc2, Xt)))
                        continue t;
                    }
                    Ks && Ks.push(gc2), wo.push(yu);
                  }
                }
              return wo;
            }
            function Ozt(ot, St, Xt, Ie2) {
              return ZC(ot, function(cn, Wn, zr) {
                St(Ie2, Xt(cn), Wn, zr);
              }), Ie2;
            }
            function c3(ot, St, Xt) {
              St = v32(St, ot), ot = Jlt(ot, St);
              var Ie2 = ot == null ? ot : ot[FI(p22(St))];
              return Ie2 == null ? n3 : nm(Ie2, ot, Xt);
            }
            function lK(ot) {
              return wv(ot) && gx(ot) == dl;
            }
            function SSt(ot) {
              return wv(ot) && gx(ot) == ta2;
            }
            function Rzt(ot) {
              return wv(ot) && gx(ot) == Hs;
            }
            function Aj2(ot, St, Xt, Ie2, cn) {
              return ot === St ? true : ot == null || St == null || !wv(ot) && !wv(St) ? ot !== ot && St !== St : MSt(ot, St, Xt, Ie2, Aj2, cn);
            }
            function MSt(ot, St, Xt, Ie2, cn, Wn) {
              var zr = af2(ot), Qr = af2(St), Ni2 = zr ? tl : zb2(ot), wo = Qr ? tl : zb2(St);
              Ni2 = Ni2 == dl ? zp : Ni2, wo = wo == dl ? zp : wo;
              var vo = Ni2 == zp, Lo = wo == zp, Ks = Ni2 == wo;
              if (Ks && k0(ot)) {
                if (!k0(St))
                  return false;
                zr = true, vo = false;
              }
              if (Ks && !vo)
                return Wn || (Wn = new Nw()), zr || MM(ot) ? Zlt(ot, St, Xt, Ie2, cn, Wn) : RSt(ot, St, Ni2, Xt, Ie2, cn, Wn);
              if (!(Xt & rt2)) {
                var yu = vo && Md2.call(ot, "__wrapped__"), gc2 = Lo && Md2.call(St, "__wrapped__");
                if (yu || gc2) {
                  var of2 = yu ? ot.value() : ot, uc2 = gc2 ? St.value() : St;
                  return Wn || (Wn = new Nw()), cn(of2, uc2, Xt, Ie2, Wn);
                }
              }
              return Ks ? (Wn || (Wn = new Nw()), NSt(ot, St, Xt, Ie2, cn, Wn)) : false;
            }
            function uK(ot) {
              return wv(ot) && zb2(ot) == fu;
            }
            function Ij2(ot, St, Xt, Ie2) {
              var cn = Xt.length, Wn = cn, zr = !Ie2;
              if (ot == null)
                return !Wn;
              for (ot = Vd2(ot); cn--; ) {
                var Qr = Xt[cn];
                if (zr && Qr[2] ? Qr[1] !== ot[Qr[0]] : !(Qr[0] in ot))
                  return false;
              }
              for (; ++cn < Wn; ) {
                Qr = Xt[cn];
                var Ni2 = Qr[0], wo = ot[Ni2], vo = Qr[1];
                if (zr && Qr[2]) {
                  if (wo === n3 && !(Ni2 in ot))
                    return false;
                } else {
                  var Lo = new Nw();
                  if (Ie2)
                    var Ks = Ie2(wo, vo, Ni2, ot, St, Lo);
                  if (!(Ks === n3 ? Aj2(vo, wo, rt2 | gt, Ie2, Lo) : Ks))
                    return false;
                }
              }
              return true;
            }
            function cK(ot) {
              if (!Bv(ot) || qzt(ot))
                return false;
              var St = g2(ot) ? cSt : no;
              return St.test(iR(ot));
            }
            function Llt(ot) {
              return wv(ot) && gx(ot) == O1;
            }
            function Nzt(ot) {
              return wv(ot) && zb2(ot) == Kd2;
            }
            function bM(ot) {
              return wv(ot) && Kj2(ot.length) && !!Xd2[gx(ot)];
            }
            function Dj2(ot) {
              return typeof ot == "function" ? ot : ot == null ? bx : typeof ot == "object" ? af2(ot) ? Y4(ot[0], ot[1]) : fK(ot) : Yut(ot);
            }
            function Ej2(ot) {
              if (!rR(ot))
                return pSt(ot);
              var St = [];
              for (var Xt in Vd2(ot))
                Md2.call(ot, Xt) && Xt != "constructor" && St.push(Xt);
              return St;
            }
            function _k(ot) {
              if (!Bv(ot))
                return Zzt(ot);
              var St = rR(ot), Xt = [];
              for (var Ie2 in ot)
                Ie2 == "constructor" && (St || !Md2.call(ot, Ie2)) || Xt.push(Ie2);
              return Xt;
            }
            function _M(ot, St) {
              return ot < St;
            }
            function f3(ot, St) {
              var Xt = -1, Ie2 = jb2(ot) ? da2(ot.length) : [];
              return mM(ot, function(cn, Wn, zr) {
                Ie2[++Xt] = St(cn, Wn, zr);
              }), Ie2;
            }
            function fK(ot) {
              var St = $lt(ot);
              return St.length == 1 && St[0][2] ? VSt(St[0][0], St[0][1]) : function(Xt) {
                return Xt === ot || Ij2(Xt, ot, St);
              };
            }
            function Y4(ot, St) {
              return Qlt(ot) && E0(St) ? VSt(FI(ot), St) : function(Xt) {
                var Ie2 = Rut(Xt, ot);
                return Ie2 === n3 && Ie2 === St ? GK(Xt, ot) : Aj2(St, Ie2, rt2 | gt);
              };
            }
            function hK(ot, St, Xt, Ie2, cn) {
              ot !== St && Tj2(St, function(Wn, zr) {
                if (cn || (cn = new Nw()), Bv(Wn))
                  CSt(ot, St, zr, Xt, hK, Ie2, cn);
                else {
                  var Qr = Ie2 ? Ie2(Ck(ot, zr), Wn, zr + "", ot, St, cn) : n3;
                  Qr === n3 && (Qr = Wn), Tlt(ot, zr, Qr);
                }
              }, jw);
            }
            function CSt(ot, St, Xt, Ie2, cn, Wn, zr) {
              var Qr = Ck(ot, Xt), Ni2 = Ck(St, Xt), wo = zr.get(Ni2);
              if (wo) {
                Tlt(ot, Xt, wo);
                return;
              }
              var vo = Wn ? Wn(Qr, Ni2, Xt + "", ot, St, zr) : n3, Lo = vo === n3;
              if (Lo) {
                var Ks = af2(Ni2), yu = !Ks && k0(Ni2), gc2 = !Ks && !yu && MM(Ni2);
                vo = Ni2, Ks || yu || gc2 ? af2(Qr) ? vo = Qr : xv(Qr) ? vo = B1(Qr) : yu ? (Lo = false, vo = gK(Ni2, true)) : gc2 ? (Lo = false, vo = ISt(Ni2, true)) : vo = [] : T3(Ni2) || C3(Ni2) ? (vo = Qr, C3(Qr) ? vo = jK(Qr) : (!Bv(Qr) || g2(Qr)) && (vo = Q0(Ni2))) : Lo = false;
              }
              Lo && (zr.set(Ni2, vo), cn(vo, Ni2, Ie2, Wn, zr), zr.delete(Ni2)), Tlt(ot, Xt, vo);
            }
            function Olt(ot, St) {
              var Xt = ot.length;
              if (Xt)
                return St += St < 0 ? Xt : 0, Mk(St, Xt) ? ot[St] : n3;
            }
            function h3(ot, St, Xt) {
              St.length ? St = Vv(St, function(Wn) {
                return af2(Wn) ? function(zr) {
                  return $4(zr, Wn.length === 1 ? Wn[0] : Wn);
                } : Wn;
              }) : St = [bx];
              var Ie2 = -1;
              St = Vv(St, cx(ec2()));
              var cn = f3(ot, function(Wn, zr, Qr) {
                var Ni2 = Vv(St, function(wo) {
                  return wo(Wn);
                });
                return { criteria: Ni2, index: ++Ie2, value: Wn };
              });
              return ilt(cn, function(Wn, zr) {
                return DSt(Wn, zr, Xt);
              });
            }
            function K4(ot, St) {
              return X4(ot, St, function(Xt, Ie2) {
                return GK(ot, Ie2);
              });
            }
            function X4(ot, St, Xt) {
              for (var Ie2 = -1, cn = St.length, Wn = {}; ++Ie2 < cn; ) {
                var zr = St[Ie2], Qr = $4(ot, zr);
                Xt(Qr, zr) && p3(Wn, v32(zr, ot), Qr);
              }
              return Wn;
            }
            function Rlt(ot) {
              return function(St) {
                return $4(St, ot);
              };
            }
            function kj2(ot, St, Xt, Ie2) {
              var cn = Ie2 ? D8 : c2, Wn = -1, zr = St.length, Qr = ot;
              for (ot === St && (St = B1(St)), Xt && (Qr = Vv(ot, cx(Xt))); ++Wn < zr; )
                for (var Ni2 = 0, wo = St[Wn], vo = Xt ? Xt(wo) : wo; (Ni2 = cn(Qr, vo, Ni2, Ie2)) > -1; )
                  Qr !== ot && px.call(Qr, Ni2, 1), px.call(ot, Ni2, 1);
              return ot;
            }
            function TSt(ot, St) {
              for (var Xt = ot ? St.length : 0, Ie2 = Xt - 1; Xt--; ) {
                var cn = St[Xt];
                if (Xt == Ie2 || cn !== Wn) {
                  var Wn = cn;
                  Mk(cn) ? px.call(ot, cn, 1) : tR(ot, cn);
                }
              }
              return ot;
            }
            function xM(ot, St) {
              return ot + Sj2($Y() * (St - ot + 1));
            }
            function ASt(ot, St, Xt, Ie2) {
              for (var cn = -1, Wn = u0(GC((St - ot) / (Xt || 1)), 0), zr = da2(Wn); Wn--; )
                zr[Ie2 ? Wn : ++cn] = ot, ot += Xt;
              return zr;
            }
            function YC(ot, St) {
              var Xt = "";
              if (!ot || St < 1 || St > Xn)
                return Xt;
              do
                St % 2 && (Xt += ot), St = Sj2(St / 2), St && (ot += ot);
              while (St);
              return Xt;
            }
            function ch2(ot, St) {
              return eut(SK(ot, St, bx), ot + "");
            }
            function Bu(ot) {
              return mSt(G8(ot));
            }
            function pK(ot, St) {
              var Xt = G8(ot);
              return CK(Xt, qC(St, 0, Xt.length));
            }
            function p3(ot, St, Xt, Ie2) {
              if (!Bv(ot))
                return ot;
              St = v32(St, ot);
              for (var cn = -1, Wn = St.length, zr = Wn - 1, Qr = ot; Qr != null && ++cn < Wn; ) {
                var Ni2 = FI(St[cn]), wo = Xt;
                if (Ni2 === "__proto__" || Ni2 === "constructor" || Ni2 === "prototype")
                  return ot;
                if (cn != zr) {
                  var vo = Qr[Ni2];
                  wo = Ie2 ? Ie2(vo, Ni2, Qr) : n3, wo === n3 && (wo = Bv(vo) ? vo : Mk(St[cn + 1]) ? [] : {});
                }
                Cj2(Qr, Ni2, wo), Qr = Qr[Ni2];
              }
              return ot;
            }
            var d3 = Ow ? function(ot, St) {
              return Ow.set(ot, St), ot;
            } : bx, Q4 = D0 ? function(ot, St) {
              return D0(ot, "toString", { configurable: true, enumerable: false, value: $K(St), writable: true });
            } : bx;
            function J4(ot) {
              return CK(G8(ot));
            }
            function Um(ot, St, Xt) {
              var Ie2 = -1, cn = ot.length;
              St < 0 && (St = -St > cn ? 0 : cn + St), Xt = Xt > cn ? cn : Xt, Xt < 0 && (Xt += cn), cn = St > Xt ? 0 : Xt - St >>> 0, St >>>= 0;
              for (var Wn = da2(cn); ++Ie2 < cn; )
                Wn[Ie2] = ot[Ie2 + St];
              return Wn;
            }
            function Pj2(ot, St) {
              var Xt;
              return mM(ot, function(Ie2, cn, Wn) {
                return Xt = St(Ie2, cn, Wn), !Xt;
              }), !!Xt;
            }
            function g3(ot, St, Xt) {
              var Ie2 = 0, cn = ot == null ? Ie2 : ot.length;
              if (typeof St == "number" && St === St && cn <= Po) {
                for (; Ie2 < cn; ) {
                  var Wn = Ie2 + cn >>> 1, zr = ot[Wn];
                  zr !== null && !mx(zr) && (Xt ? zr <= St : zr < St) ? Ie2 = Wn + 1 : cn = Wn;
                }
                return cn;
              }
              return Nlt(ot, St, bx, Xt);
            }
            function Nlt(ot, St, Xt, Ie2) {
              var cn = 0, Wn = ot == null ? 0 : ot.length;
              if (Wn === 0)
                return 0;
              St = Xt(St);
              for (var zr = St !== St, Qr = St === null, Ni2 = mx(St), wo = St === n3; cn < Wn; ) {
                var vo = Sj2((cn + Wn) / 2), Lo = Xt(ot[vo]), Ks = Lo !== n3, yu = Lo === null, gc2 = Lo === Lo, of2 = mx(Lo);
                if (zr)
                  var uc2 = Ie2 || gc2;
                else
                  wo ? uc2 = gc2 && (Ie2 || Ks) : Qr ? uc2 = gc2 && Ks && (Ie2 || !yu) : Ni2 ? uc2 = gc2 && Ks && !yu && (Ie2 || !of2) : yu || of2 ? uc2 = false : uc2 = Ie2 ? Lo <= St : Lo < St;
                uc2 ? cn = vo + 1 : Wn = vo;
              }
              return F1(Wn, yi2);
            }
            function lc2(ot, St) {
              for (var Xt = -1, Ie2 = ot.length, cn = 0, Wn = []; ++Xt < Ie2; ) {
                var zr = ot[Xt], Qr = St ? St(zr) : zr;
                if (!Xt || !Pl(Qr, Ni2)) {
                  var Ni2 = Qr;
                  Wn[cn++] = zr === 0 ? 0 : zr;
                }
              }
              return Wn;
            }
            function Flt(ot) {
              return typeof ot == "number" ? ot : mx(ot) ? Tr : +ot;
            }
            function _v(ot) {
              if (typeof ot == "string")
                return ot;
              if (af2(ot))
                return Vv(ot, _v) + "";
              if (mx(ot))
                return xlt ? xlt.call(ot) : "";
              var St = ot + "";
              return St == "0" && 1 / ot == -Xr ? "-0" : St;
            }
            function xk2(ot, St, Xt) {
              var Ie2 = -1, cn = kI, Wn = ot.length, zr = true, Qr = [], Ni2 = Qr;
              if (Xt)
                zr = false, cn = dj2;
              else if (Wn >= m2) {
                var wo = St ? null : Hlt(ot);
                if (wo)
                  return HY(wo);
                zr = false, cn = gj2, Ni2 = new s3();
              } else
                Ni2 = St ? [] : Qr;
              t:
                for (; ++Ie2 < Wn; ) {
                  var vo = ot[Ie2], Lo = St ? St(vo) : vo;
                  if (vo = Xt || vo !== 0 ? vo : 0, zr && Lo === Lo) {
                    for (var Ks = Ni2.length; Ks--; )
                      if (Ni2[Ks] === Lo)
                        continue t;
                    St && Ni2.push(Lo), Qr.push(vo);
                  } else
                    cn(Ni2, Lo, Xt) || (Ni2 !== Qr && Ni2.push(Lo), Qr.push(vo));
                }
              return Qr;
            }
            function tR(ot, St) {
              return St = v32(St, ot), ot = Jlt(ot, St), ot == null || delete ot[FI(p22(St))];
            }
            function V8(ot, St, Xt, Ie2) {
              return p3(ot, St, Xt($4(ot, St)), Ie2);
            }
            function wk2(ot, St, Xt, Ie2) {
              for (var cn = ot.length, Wn = Ie2 ? cn : -1; (Ie2 ? Wn-- : ++Wn < cn) && St(ot[Wn], Wn, ot); )
                ;
              return Xt ? Um(ot, Ie2 ? 0 : Wn, Ie2 ? Wn + 1 : cn) : Um(ot, Ie2 ? Wn + 1 : 0, Ie2 ? cn : Wn);
            }
            function Lj2(ot, St) {
              var Xt = ot;
              return Xt instanceof up && (Xt = Xt.value()), z4(St, function(Ie2, cn) {
                return cn.func.apply(cn.thisArg, PI3([Ie2], cn.args));
              }, Xt);
            }
            function f22(ot, St, Xt) {
              var Ie2 = ot.length;
              if (Ie2 < 2)
                return Ie2 ? xk2(ot[0]) : [];
              for (var cn = -1, Wn = da2(Ie2); ++cn < Ie2; )
                for (var zr = ot[cn], Qr = -1; ++Qr < Ie2; )
                  Qr != cn && (Wn[cn] = u3(Wn[cn] || zr, ot[Qr], St, Xt));
              return xk2(V1(Wn, 1), St, Xt);
            }
            function Oj2(ot, St, Xt) {
              for (var Ie2 = -1, cn = ot.length, Wn = St.length, zr = {}; ++Ie2 < cn; ) {
                var Qr = Ie2 < Wn ? St[Ie2] : n3;
                Xt(zr, ot[Ie2], Qr);
              }
              return zr;
            }
            function Rj2(ot) {
              return xv(ot) ? ot : [];
            }
            function Nj2(ot) {
              return typeof ot == "function" ? ot : bx;
            }
            function v32(ot, St) {
              return af2(ot) ? ot : Qlt(ot, St) ? [ot] : nut(Td2(ot));
            }
            var B8 = ch2;
            function y3(ot, St, Xt) {
              var Ie2 = ot.length;
              return Xt = Xt === n3 ? Ie2 : Xt, !St && Xt >= Ie2 ? ot : Um(ot, St, Xt);
            }
            var dK = fSt || function(ot) {
              return Tg2.clearTimeout(ot);
            };
            function gK(ot, St) {
              if (St)
                return ot.slice();
              var Xt = ot.length, Ie2 = glt ? glt(Xt) : new ot.constructor(Xt);
              return ot.copy(Ie2), Ie2;
            }
            function Fj2(ot) {
              var St = new ot.constructor(ot.byteLength);
              return new U4(St).set(new U4(ot)), St;
            }
            function Fzt(ot, St) {
              var Xt = St ? Fj2(ot.buffer) : ot.buffer;
              return new ot.constructor(Xt, ot.byteOffset, ot.byteLength);
            }
            function Vzt(ot) {
              var St = new ot.constructor(ot.source, hr.exec(ot));
              return St.lastIndex = ot.lastIndex, St;
            }
            function Bzt(ot) {
              return Z4 ? Vd2(Z4.call(ot)) : {};
            }
            function ISt(ot, St) {
              var Xt = St ? Fj2(ot.buffer) : ot.buffer;
              return new ot.constructor(Xt, ot.byteOffset, ot.length);
            }
            function Vlt(ot, St) {
              if (ot !== St) {
                var Xt = ot !== n3, Ie2 = ot === null, cn = ot === ot, Wn = mx(ot), zr = St !== n3, Qr = St === null, Ni2 = St === St, wo = mx(St);
                if (!Qr && !wo && !Wn && ot > St || Wn && zr && Ni2 && !Qr && !wo || Ie2 && zr && Ni2 || !Xt && Ni2 || !cn)
                  return 1;
                if (!Ie2 && !Wn && !wo && ot < St || wo && Xt && cn && !Ie2 && !Wn || Qr && Xt && cn || !zr && cn || !Ni2)
                  return -1;
              }
              return 0;
            }
            function DSt(ot, St, Xt) {
              for (var Ie2 = -1, cn = ot.criteria, Wn = St.criteria, zr = cn.length, Qr = Xt.length; ++Ie2 < zr; ) {
                var Ni2 = Vlt(cn[Ie2], Wn[Ie2]);
                if (Ni2) {
                  if (Ie2 >= Qr)
                    return Ni2;
                  var wo = Xt[Ie2];
                  return Ni2 * (wo == "desc" ? -1 : 1);
                }
              }
              return ot.index - St.index;
            }
            function Blt(ot, St, Xt, Ie2) {
              for (var cn = -1, Wn = ot.length, zr = Xt.length, Qr = -1, Ni2 = St.length, wo = u0(Wn - zr, 0), vo = da2(Ni2 + wo), Lo = !Ie2; ++Qr < Ni2; )
                vo[Qr] = St[Qr];
              for (; ++cn < zr; )
                (Lo || cn < Wn) && (vo[Xt[cn]] = ot[cn]);
              for (; wo--; )
                vo[Qr++] = ot[cn++];
              return vo;
            }
            function nu(ot, St, Xt, Ie2) {
              for (var cn = -1, Wn = ot.length, zr = -1, Qr = Xt.length, Ni2 = -1, wo = St.length, vo = u0(Wn - Qr, 0), Lo = da2(vo + wo), Ks = !Ie2; ++cn < vo; )
                Lo[cn] = ot[cn];
              for (var yu = cn; ++Ni2 < wo; )
                Lo[yu + Ni2] = St[Ni2];
              for (; ++zr < Qr; )
                (Ks || cn < Wn) && (Lo[yu + Xt[zr]] = ot[cn++]);
              return Lo;
            }
            function B1(ot, St) {
              var Xt = -1, Ie2 = ot.length;
              for (St || (St = da2(Ie2)); ++Xt < Ie2; )
                St[Xt] = ot[Xt];
              return St;
            }
            function KC(ot, St, Xt, Ie2) {
              var cn = !Xt;
              Xt || (Xt = {});
              for (var Wn = -1, zr = St.length; ++Wn < zr; ) {
                var Qr = St[Wn], Ni2 = Ie2 ? Ie2(Xt[Qr], ot[Qr], Qr, Xt, ot) : n3;
                Ni2 === n3 && (Ni2 = ot[Qr]), cn ? yM(Xt, Qr, Ni2) : Cj2(Xt, Qr, Ni2);
              }
              return Xt;
            }
            function zzt(ot, St) {
              return KC(ot, Ylt(ot), St);
            }
            function jzt(ot, St) {
              return KC(ot, FSt(ot), St);
            }
            function vK(ot, St) {
              return function(Xt, Ie2) {
                var cn = af2(Xt) ? ux : eK, Wn = St ? St() : {};
                return cn(Xt, ot, ec2(Ie2, 2), Wn);
              };
            }
            function eR(ot) {
              return ch2(function(St, Xt) {
                var Ie2 = -1, cn = Xt.length, Wn = cn > 1 ? Xt[cn - 1] : n3, zr = cn > 2 ? Xt[2] : n3;
                for (Wn = ot.length > 3 && typeof Wn == "function" ? (cn--, Wn) : n3, zr && vx(Xt[0], Xt[1], zr) && (Wn = cn < 3 ? n3 : Wn, cn = 1), St = Vd2(St); ++Ie2 < cn; ) {
                  var Qr = Xt[Ie2];
                  Qr && ot(St, Qr, Ie2, Wn);
                }
                return St;
              });
            }
            function ESt(ot, St) {
              return function(Xt, Ie2) {
                if (Xt == null)
                  return Xt;
                if (!jb2(Xt))
                  return ot(Xt, Ie2);
                for (var cn = Xt.length, Wn = St ? cn : -1, zr = Vd2(Xt); (St ? Wn-- : ++Wn < cn) && Ie2(zr[Wn], Wn, zr) !== false; )
                  ;
                return Xt;
              };
            }
            function zlt(ot) {
              return function(St, Xt, Ie2) {
                for (var cn = -1, Wn = Vd2(St), zr = Ie2(St), Qr = zr.length; Qr--; ) {
                  var Ni2 = zr[ot ? Qr : ++cn];
                  if (Xt(Wn[Ni2], Ni2, Wn) === false)
                    break;
                }
                return St;
              };
            }
            function kSt(ot, St, Xt) {
              var Ie2 = St & yt, cn = $o(ot);
              function Wn() {
                var zr = this && this !== Tg2 && this instanceof Wn ? cn : ot;
                return zr.apply(Ie2 ? Xt : this, arguments);
              }
              return Wn;
            }
            function PSt(ot) {
              return function(St) {
                St = Td2(St);
                var Xt = N1(St) ? zC(St) : n3, Ie2 = Xt ? Xt[0] : St.charAt(0), cn = Xt ? y3(Xt, 1).join("") : St.slice(1);
                return Ie2[ot]() + cn;
              };
            }
            function fh2(ot) {
              return function(St) {
                return z4(V2t(UK(St).replace(Tl, "")), ot, "");
              };
            }
            function $o(ot) {
              return function() {
                var St = arguments;
                switch (St.length) {
                  case 0:
                    return new ot();
                  case 1:
                    return new ot(St[0]);
                  case 2:
                    return new ot(St[0], St[1]);
                  case 3:
                    return new ot(St[0], St[1], St[2]);
                  case 4:
                    return new ot(St[0], St[1], St[2], St[3]);
                  case 5:
                    return new ot(St[0], St[1], St[2], St[3], St[4]);
                  case 6:
                    return new ot(St[0], St[1], St[2], St[3], St[4], St[5]);
                  case 7:
                    return new ot(St[0], St[1], St[2], St[3], St[4], St[5], St[6]);
                }
                var Xt = HC(ot.prototype), Ie2 = ot.apply(Xt, St);
                return Bv(Ie2) ? Ie2 : Xt;
              };
            }
            function c0(ot, St, Xt) {
              var Ie2 = $o(ot);
              function cn() {
                for (var Wn = arguments.length, zr = da2(Wn), Qr = Wn, Ni2 = wM(cn); Qr--; )
                  zr[Qr] = arguments[Qr];
                var wo = Wn < 3 && zr[0] !== Ni2 && zr[Wn - 1] !== Ni2 ? [] : dk2(zr, Ni2);
                if (Wn -= wo.length, Wn < Xt)
                  return QC(ot, St, yK, cn.placeholder, n3, zr, wo, n3, n3, Xt - Wn);
                var vo = this && this !== Tg2 && this instanceof cn ? Ie2 : ot;
                return nm(vo, this, zr);
              }
              return cn;
            }
            function h2(ot) {
              return function(St, Xt, Ie2) {
                var cn = Vd2(St);
                if (!jb2(St)) {
                  var Wn = ec2(Xt, 3);
                  St = rm(St), Xt = function(Qr) {
                    return Wn(cn[Qr], Qr, cn);
                  };
                }
                var zr = ot(St, Xt, Ie2);
                return zr > -1 ? cn[Wn ? St[zr] : zr] : n3;
              };
            }
            function XC(ot) {
              return rf2(function(St) {
                var Xt = St.length, Ie2 = Xt, cn = Rw.prototype.thru;
                for (ot && St.reverse(); Ie2--; ) {
                  var Wn = St[Ie2];
                  if (typeof Wn != "function")
                    throw new fx(T2);
                  if (cn && !zr && xp(Wn) == "wrapper")
                    var zr = new Rw([], true);
                }
                for (Ie2 = zr ? Ie2 : Xt; ++Ie2 < Xt; ) {
                  Wn = St[Ie2];
                  var Qr = xp(Wn), Ni2 = Qr == "wrapper" ? wK(Wn) : n3;
                  Ni2 && Df2(Ni2[0]) && Ni2[1] == (pe2 | Wt | ue2 | xe) && !Ni2[4].length && Ni2[9] == 1 ? zr = zr[xp(Ni2[0])].apply(zr, Ni2[3]) : zr = Wn.length == 1 && Df2(Wn) ? zr[Qr]() : zr.thru(Wn);
                }
                return function() {
                  var wo = arguments, vo = wo[0];
                  if (zr && wo.length == 1 && af2(vo))
                    return zr.plant(vo).value();
                  for (var Lo = 0, Ks = Xt ? St[Lo].apply(this, wo) : vo; ++Lo < Xt; )
                    Ks = St[Lo].call(this, Ks);
                  return Ks;
                };
              });
            }
            function yK(ot, St, Xt, Ie2, cn, Wn, zr, Qr, Ni2, wo) {
              var vo = St & pe2, Lo = St & yt, Ks = St & At, yu = St & (Wt | Nt), gc2 = St & Ce2, of2 = Ks ? n3 : $o(ot);
              function uc2() {
                for (var Kh2 = arguments.length, ph2 = da2(Kh2), j1 = Kh2; j1--; )
                  ph2[j1] = arguments[j1];
                if (yu)
                  var Hb2 = wM(uc2), _x = llt(ph2, Hb2);
                if (Ie2 && (ph2 = Blt(ph2, Ie2, cn, yu)), Wn && (ph2 = nu(ph2, Wn, zr, yu)), Kh2 -= _x, yu && Kh2 < wo) {
                  var J0 = dk2(ph2, Hb2);
                  return QC(ot, St, yK, uc2.placeholder, Xt, ph2, J0, Qr, Ni2, wo - Kh2);
                }
                var Ub2 = Lo ? Xt : this, $I = Ks ? Ub2[ot] : ot;
                return Kh2 = ph2.length, Qr ? ph2 = Yzt(ph2, Qr) : gc2 && Kh2 > 1 && ph2.reverse(), vo && Ni2 < Kh2 && (ph2.length = Ni2), this && this !== Tg2 && this instanceof uc2 && ($I = of2 || $o($I)), $I.apply(Ub2, ph2);
              }
              return uc2;
            }
            function jlt(ot, St) {
              return function(Xt, Ie2) {
                return Ozt(Xt, ot, St(Ie2), {});
              };
            }
            function mK(ot, St) {
              return function(Xt, Ie2) {
                var cn;
                if (Xt === n3 && Ie2 === n3)
                  return St;
                if (Xt !== n3 && (cn = Xt), Ie2 !== n3) {
                  if (cn === n3)
                    return Ie2;
                  typeof Xt == "string" || typeof Ie2 == "string" ? (Xt = _v(Xt), Ie2 = _v(Ie2)) : (Xt = Flt(Xt), Ie2 = Flt(Ie2)), cn = ot(Xt, Ie2);
                }
                return cn;
              };
            }
            function Wlt(ot) {
              return rf2(function(St) {
                return St = Vv(St, cx(ec2())), ch2(function(Xt) {
                  var Ie2 = this;
                  return ot(St, function(cn) {
                    return nm(cn, Ie2, Xt);
                  });
                });
              });
            }
            function Vj2(ot, St) {
              St = St === n3 ? " " : _v(St);
              var Xt = St.length;
              if (Xt < 2)
                return Xt ? YC(St, ot) : St;
              var Ie2 = YC(St, GC(ot / W4(St)));
              return N1(St) ? y3(zC(Ie2), 0, ot).join("") : Ie2.slice(0, ot);
            }
            function LSt(ot, St, Xt, Ie2) {
              var cn = St & yt, Wn = $o(ot);
              function zr() {
                for (var Qr = -1, Ni2 = arguments.length, wo = -1, vo = Ie2.length, Lo = da2(vo + Ni2), Ks = this && this !== Tg2 && this instanceof zr ? Wn : ot; ++wo < vo; )
                  Lo[wo] = Ie2[wo];
                for (; Ni2--; )
                  Lo[wo++] = arguments[++Qr];
                return nm(Ks, cn ? Xt : this, Lo);
              }
              return zr;
            }
            function Bj2(ot) {
              return function(St, Xt, Ie2) {
                return Ie2 && typeof Ie2 != "number" && vx(St, Xt, Ie2) && (Xt = Ie2 = n3), St = UI(St), Xt === n3 ? (Xt = St, St = 0) : Xt = UI(Xt), Ie2 = Ie2 === n3 ? St < Xt ? 1 : -1 : UI(Ie2), ASt(St, Xt, Ie2, ot);
              };
            }
            function bK(ot) {
              return function(St, Xt) {
                return typeof St == "string" && typeof Xt == "string" || (St = v22(St), Xt = v22(Xt)), ot(St, Xt);
              };
            }
            function QC(ot, St, Xt, Ie2, cn, Wn, zr, Qr, Ni2, wo) {
              var vo = St & Wt, Lo = vo ? zr : n3, Ks = vo ? n3 : zr, yu = vo ? Wn : n3, gc2 = vo ? n3 : Wn;
              St |= vo ? ue2 : ie2, St &= ~(vo ? ie2 : ue2), St & Lt || (St &= ~(yt | At));
              var of2 = [ot, St, cn, yu, Lo, gc2, Ks, Qr, Ni2, wo], uc2 = Xt.apply(n3, of2);
              return Df2(ot) && tut(uc2, of2), uc2.placeholder = Ie2, zSt(uc2, ot, St);
            }
            function Glt(ot) {
              var St = Dy[ot];
              return function(Xt, Ie2) {
                if (Xt = v22(Xt), Ie2 = Ie2 == null ? 0 : F1(Ef2(Ie2), 292), Ie2 && ZY(Xt)) {
                  var cn = (Td2(Xt) + "e").split("e"), Wn = St(cn[0] + "e" + (+cn[1] + Ie2));
                  return cn = (Td2(Wn) + "e").split("e"), +(cn[0] + "e" + (+cn[1] - Ie2));
                }
                return St(Xt);
              };
            }
            var Hlt = P8 && 1 / HY(new P8([, -0]))[1] == Xr ? function(ot) {
              return new P8(ot);
            } : $ut;
            function Ult(ot) {
              return function(St) {
                var Xt = zb2(St);
                return Xt == fu ? hlt(St) : Xt == Kd2 ? oSt(St) : alt(St, ot(St));
              };
            }
            function JC(ot, St, Xt, Ie2, cn, Wn, zr, Qr) {
              var Ni2 = St & At;
              if (!Ni2 && typeof ot != "function")
                throw new fx(T2);
              var wo = Ie2 ? Ie2.length : 0;
              if (wo || (St &= ~(ue2 | ie2), Ie2 = cn = n3), zr = zr === n3 ? zr : u0(Ef2(zr), 0), Qr = Qr === n3 ? Qr : Ef2(Qr), wo -= cn ? cn.length : 0, St & ie2) {
                var vo = Ie2, Lo = cn;
                Ie2 = cn = n3;
              }
              var Ks = Ni2 ? n3 : wK(ot), yu = [ot, St, Xt, Ie2, cn, vo, Lo, Wn, zr, Qr];
              if (Ks && BSt(yu, Ks), ot = yu[0], St = yu[1], Xt = yu[2], Ie2 = yu[3], cn = yu[4], Qr = yu[9] = yu[9] === n3 ? Ni2 ? 0 : ot.length : u0(yu[9] - wo, 0), !Qr && St & (Wt | Nt) && (St &= ~(Wt | Nt)), !St || St == yt)
                var gc2 = kSt(ot, St, Xt);
              else
                St == Wt || St == Nt ? gc2 = c0(ot, St, Qr) : (St == ue2 || St == (yt | ue2)) && !cn.length ? gc2 = LSt(ot, St, Xt, Ie2) : gc2 = yK.apply(n3, yu);
              var of2 = Ks ? d3 : tut;
              return zSt(of2(gc2, yu), ot, St);
            }
            function qlt(ot, St, Xt, Ie2) {
              return ot === n3 || Pl(ot, jC[Xt]) && !Md2.call(Ie2, Xt) ? St : ot;
            }
            function NI(ot, St, Xt, Ie2, cn, Wn) {
              return Bv(ot) && Bv(St) && (Wn.set(St, ot), hK(ot, St, n3, NI, Wn), Wn.delete(St)), ot;
            }
            function OSt(ot) {
              return T3(ot) ? n3 : ot;
            }
            function Zlt(ot, St, Xt, Ie2, cn, Wn) {
              var zr = Xt & rt2, Qr = ot.length, Ni2 = St.length;
              if (Qr != Ni2 && !(zr && Ni2 > Qr))
                return false;
              var wo = Wn.get(ot), vo = Wn.get(St);
              if (wo && vo)
                return wo == St && vo == ot;
              var Lo = -1, Ks = true, yu = Xt & gt ? new s3() : n3;
              for (Wn.set(ot, St), Wn.set(St, ot); ++Lo < Qr; ) {
                var gc2 = ot[Lo], of2 = St[Lo];
                if (Ie2)
                  var uc2 = zr ? Ie2(of2, gc2, Lo, St, ot, Wn) : Ie2(gc2, of2, Lo, ot, St, Wn);
                if (uc2 !== n3) {
                  if (uc2)
                    continue;
                  Ks = false;
                  break;
                }
                if (yu) {
                  if (!LI(St, function(Kh2, ph2) {
                    if (!gj2(yu, ph2) && (gc2 === Kh2 || cn(gc2, Kh2, Xt, Ie2, Wn)))
                      return yu.push(ph2);
                  })) {
                    Ks = false;
                    break;
                  }
                } else if (!(gc2 === of2 || cn(gc2, of2, Xt, Ie2, Wn))) {
                  Ks = false;
                  break;
                }
              }
              return Wn.delete(ot), Wn.delete(St), Ks;
            }
            function RSt(ot, St, Xt, Ie2, cn, Wn, zr) {
              switch (Xt) {
                case bo:
                  if (ot.byteLength != St.byteLength || ot.byteOffset != St.byteOffset)
                    return false;
                  ot = ot.buffer, St = St.buffer;
                case ta2:
                  return !(ot.byteLength != St.byteLength || !Wn(new U4(ot), new U4(St)));
                case as:
                case Hs:
                case uh2:
                  return Pl(+ot, +St);
                case xs:
                  return ot.name == St.name && ot.message == St.message;
                case O1:
                case Nv:
                  return ot == St + "";
                case fu:
                  var Qr = hlt;
                case Kd2:
                  var Ni2 = Ie2 & rt2;
                  if (Qr || (Qr = HY), ot.size != St.size && !Ni2)
                    return false;
                  var wo = zr.get(ot);
                  if (wo)
                    return wo == St;
                  Ie2 |= gt, zr.set(ot, St);
                  var vo = Zlt(Qr(ot), Qr(St), Ie2, cn, Wn, zr);
                  return zr.delete(ot), vo;
                case mv:
                  if (Z4)
                    return Z4.call(ot) == Z4.call(St);
              }
              return false;
            }
            function NSt(ot, St, Xt, Ie2, cn, Wn) {
              var zr = Xt & rt2, Qr = _K(ot), Ni2 = Qr.length, wo = _K(St), vo = wo.length;
              if (Ni2 != vo && !zr)
                return false;
              for (var Lo = Ni2; Lo--; ) {
                var Ks = Qr[Lo];
                if (!(zr ? Ks in St : Md2.call(St, Ks)))
                  return false;
              }
              var yu = Wn.get(ot), gc2 = Wn.get(St);
              if (yu && gc2)
                return yu == St && gc2 == ot;
              var of2 = true;
              Wn.set(ot, St), Wn.set(St, ot);
              for (var uc2 = zr; ++Lo < Ni2; ) {
                Ks = Qr[Lo];
                var Kh2 = ot[Ks], ph2 = St[Ks];
                if (Ie2)
                  var j1 = zr ? Ie2(ph2, Kh2, Ks, St, ot, Wn) : Ie2(Kh2, ph2, Ks, ot, St, Wn);
                if (!(j1 === n3 ? Kh2 === ph2 || cn(Kh2, ph2, Xt, Ie2, Wn) : j1)) {
                  of2 = false;
                  break;
                }
                uc2 || (uc2 = Ks == "constructor");
              }
              if (of2 && !uc2) {
                var Hb2 = ot.constructor, _x = St.constructor;
                Hb2 != _x && "constructor" in ot && "constructor" in St && !(typeof Hb2 == "function" && Hb2 instanceof Hb2 && typeof _x == "function" && _x instanceof _x) && (of2 = false);
              }
              return Wn.delete(ot), Wn.delete(St), of2;
            }
            function rf2(ot) {
              return eut(SK(ot, n3, sut), ot + "");
            }
            function _K(ot) {
              return oK(ot, rm, Ylt);
            }
            function xK(ot) {
              return oK(ot, jw, FSt);
            }
            var wK = Ow ? function(ot) {
              return Ow.get(ot);
            } : $ut;
            function xp(ot) {
              for (var St = ot.name + "", Xt = O8[St], Ie2 = Md2.call(O8, St) ? Xt.length : 0; Ie2--; ) {
                var cn = Xt[Ie2], Wn = cn.func;
                if (Wn == null || Wn == ot)
                  return cn.name;
              }
              return St;
            }
            function wM(ot) {
              var St = Md2.call(kn, "placeholder") ? kn : ot;
              return St.placeholder;
            }
            function ec2() {
              var ot = kn.iteratee || YK;
              return ot = ot === YK ? Dj2 : ot, arguments.length ? ot(arguments[0], arguments[1]) : ot;
            }
            function Sk(ot, St) {
              var Xt = ot.__data__;
              return nR(St) ? Xt[typeof St == "string" ? "string" : "hash"] : Xt.map;
            }
            function $lt(ot) {
              for (var St = rm(ot), Xt = St.length; Xt--; ) {
                var Ie2 = St[Xt], cn = ot[Ie2];
                St[Xt] = [Ie2, cn, E0(cn)];
              }
              return St;
            }
            function m3(ot, St) {
              var Xt = clt(ot, St);
              return cK(Xt) ? Xt : n3;
            }
            function Wzt(ot) {
              var St = Md2.call(ot, i3), Xt = ot[i3];
              try {
                ot[i3] = n3;
                var Ie2 = true;
              } catch {
              }
              var cn = _j.call(ot);
              return Ie2 && (St ? ot[i3] = Xt : delete ot[i3]), cn;
            }
            var Ylt = vlt ? function(ot) {
              return ot == null ? [] : (ot = Vd2(ot), EI(vlt(ot), function(St) {
                return WC.call(ot, St);
              }));
            } : U8, FSt = vlt ? function(ot) {
              for (var St = []; ot; )
                PI3(St, Ylt(ot)), ot = xj2(ot);
              return St;
            } : U8, zb2 = gx;
            (ylt && zb2(new ylt(new ArrayBuffer(1))) != bo || k8 && zb2(new k8()) != fu || mlt && zb2(mlt.resolve()) != tm || P8 && zb2(new P8()) != Kd2 || gk2 && zb2(new gk2()) != go) && (zb2 = function(ot) {
              var St = gx(ot), Xt = St == zp ? ot.constructor : n3, Ie2 = Xt ? iR(Xt) : "";
              if (Ie2)
                switch (Ie2) {
                  case Mj2:
                    return bo;
                  case blt:
                    return fu;
                  case R8:
                    return tm;
                  case _lt:
                    return Kd2;
                  case a3:
                    return go;
                }
              return St;
            });
            function Gzt(ot, St, Xt) {
              for (var Ie2 = -1, cn = Xt.length; ++Ie2 < cn; ) {
                var Wn = Xt[Ie2], zr = Wn.size;
                switch (Wn.type) {
                  case "drop":
                    ot += zr;
                    break;
                  case "dropRight":
                    St -= zr;
                    break;
                  case "take":
                    St = F1(St, ot + zr);
                    break;
                  case "takeRight":
                    ot = u0(ot, St - zr);
                    break;
                }
              }
              return { start: ot, end: St };
            }
            function Hzt(ot) {
              var St = ot.match(Kst);
              return St ? St[1].split(Xst) : [];
            }
            function Klt(ot, St, Xt) {
              St = v32(St, ot);
              for (var Ie2 = -1, cn = St.length, Wn = false; ++Ie2 < cn; ) {
                var zr = FI(St[Ie2]);
                if (!(Wn = ot != null && Xt(ot, zr)))
                  break;
                ot = ot[zr];
              }
              return Wn || ++Ie2 != cn ? Wn : (cn = ot == null ? 0 : ot.length, !!cn && Kj2(cn) && Mk(zr, cn) && (af2(ot) || C3(ot)));
            }
            function zj2(ot) {
              var St = ot.length, Xt = new ot.constructor(St);
              return St && typeof ot[0] == "string" && Md2.call(ot, "index") && (Xt.index = ot.index, Xt.input = ot.input), Xt;
            }
            function Q0(ot) {
              return typeof ot.constructor == "function" && !rR(ot) ? HC(xj2(ot)) : {};
            }
            function Xlt(ot, St, Xt) {
              var Ie2 = ot.constructor;
              switch (St) {
                case ta2:
                  return Fj2(ot);
                case as:
                case Hs:
                  return new Ie2(+ot);
                case bo:
                  return Fzt(ot, Xt);
                case js:
                case eu:
                case bf2:
                case _f:
                case nd2:
                case bv:
                case Mg2:
                case K0:
                case Cg2:
                  return ISt(ot, Xt);
                case fu:
                  return new Ie2();
                case uh2:
                case Nv:
                  return new Ie2(ot);
                case O1:
                  return Vzt(ot);
                case Kd2:
                  return new Ie2();
                case mv:
                  return Bzt(ot);
              }
            }
            function jj2(ot, St) {
              var Xt = St.length;
              if (!Xt)
                return ot;
              var Ie2 = Xt - 1;
              return St[Ie2] = (Xt > 1 ? "& " : "") + St[Ie2], St = St.join(Xt > 2 ? ", " : " "), ot.replace(Yst, `{
/* [wrapped with ` + St + `] */
`);
            }
            function Uzt(ot) {
              return af2(ot) || C3(ot) || !!(q4 && ot && ot[q4]);
            }
            function Mk(ot, St) {
              var Xt = typeof ot;
              return St = St == null ? Xn : St, !!St && (Xt == "number" || Xt != "symbol" && pi2.test(ot)) && ot > -1 && ot % 1 == 0 && ot < St;
            }
            function vx(ot, St, Xt) {
              if (!Bv(Xt))
                return false;
              var Ie2 = typeof St;
              return (Ie2 == "number" ? jb2(Xt) && Mk(St, Xt.length) : Ie2 == "string" && St in Xt) ? Pl(Xt[St], ot) : false;
            }
            function Qlt(ot, St) {
              if (af2(ot))
                return false;
              var Xt = typeof ot;
              return Xt == "number" || Xt == "symbol" || Xt == "boolean" || ot == null || mx(ot) ? true : l22.test(ot) || !sx.test(ot) || St != null && ot in Vd2(St);
            }
            function nR(ot) {
              var St = typeof ot;
              return St == "string" || St == "number" || St == "symbol" || St == "boolean" ? ot !== "__proto__" : ot === null;
            }
            function Df2(ot) {
              var St = xp(ot), Xt = kn[St];
              if (typeof Xt != "function" || !(St in up.prototype))
                return false;
              if (ot === Xt)
                return true;
              var Ie2 = wK(Xt);
              return !!Ie2 && ot === Ie2[0];
            }
            function qzt(ot) {
              return !!uSt && uSt in ot;
            }
            var Wj2 = bj2 ? g2 : Kut;
            function rR(ot) {
              var St = ot && ot.constructor, Xt = typeof St == "function" && St.prototype || jC;
              return ot === Xt;
            }
            function E0(ot) {
              return ot === ot && !Bv(ot);
            }
            function VSt(ot, St) {
              return function(Xt) {
                return Xt == null ? false : Xt[ot] === St && (St !== n3 || ot in Vd2(Xt));
              };
            }
            function Gj2(ot) {
              var St = Zj2(ot, function(Ie2) {
                return Xt.size === V3 && Xt.clear(), Ie2;
              }), Xt = St.cache;
              return St;
            }
            function BSt(ot, St) {
              var Xt = ot[1], Ie2 = St[1], cn = Xt | Ie2, Wn = cn < (yt | At | pe2), zr = Ie2 == pe2 && Xt == Wt || Ie2 == pe2 && Xt == xe && ot[7].length <= St[8] || Ie2 == (pe2 | xe) && St[7].length <= St[8] && Xt == Wt;
              if (!(Wn || zr))
                return ot;
              Ie2 & yt && (ot[2] = St[2], cn |= Xt & yt ? 0 : Lt);
              var Qr = St[3];
              if (Qr) {
                var Ni2 = ot[3];
                ot[3] = Ni2 ? Blt(Ni2, Qr, St[4]) : Qr, ot[4] = Ni2 ? dk2(ot[3], W3) : St[4];
              }
              return Qr = St[5], Qr && (Ni2 = ot[5], ot[5] = Ni2 ? nu(Ni2, Qr, St[6]) : Qr, ot[6] = Ni2 ? dk2(ot[5], W3) : St[6]), Qr = St[7], Qr && (ot[7] = Qr), Ie2 & pe2 && (ot[8] = ot[8] == null ? St[8] : F1(ot[8], St[8])), ot[9] == null && (ot[9] = St[9]), ot[0] = St[0], ot[1] = cn, ot;
            }
            function Zzt(ot) {
              var St = [];
              if (ot != null)
                for (var Xt in Vd2(ot))
                  St.push(Xt);
              return St;
            }
            function $zt(ot) {
              return _j.call(ot);
            }
            function SK(ot, St, Xt) {
              return St = u0(St === n3 ? ot.length - 1 : St, 0), function() {
                for (var Ie2 = arguments, cn = -1, Wn = u0(Ie2.length - St, 0), zr = da2(Wn); ++cn < Wn; )
                  zr[cn] = Ie2[St + cn];
                cn = -1;
                for (var Qr = da2(St + 1); ++cn < St; )
                  Qr[cn] = Ie2[cn];
                return Qr[St] = Xt(zr), nm(ot, this, Qr);
              };
            }
            function Jlt(ot, St) {
              return St.length < 2 ? ot : $4(ot, Um(St, 0, -1));
            }
            function Yzt(ot, St) {
              for (var Xt = ot.length, Ie2 = F1(St.length, Xt), cn = B1(ot); Ie2--; ) {
                var Wn = St[Ie2];
                ot[Ie2] = Mk(Wn, Xt) ? cn[Wn] : n3;
              }
              return ot;
            }
            function Ck(ot, St) {
              if (!(St === "constructor" && typeof ot[St] == "function") && St != "__proto__")
                return ot[St];
            }
            var tut = MK(d3), Vw = hSt || function(ot, St) {
              return Tg2.setTimeout(ot, St);
            }, eut = MK(Q4);
            function zSt(ot, St, Xt) {
              var Ie2 = St + "";
              return eut(ot, jj2(Ie2, Kzt(Hzt(Ie2), Xt)));
            }
            function MK(ot) {
              var St = 0, Xt = 0;
              return function() {
                var Ie2 = _zt(), cn = $e2 - (Ie2 - Xt);
                if (Xt = Ie2, cn > 0) {
                  if (++St >= tn)
                    return arguments[0];
                } else
                  St = 0;
                return ot.apply(n3, arguments);
              };
            }
            function CK(ot, St) {
              var Xt = -1, Ie2 = ot.length, cn = Ie2 - 1;
              for (St = St === n3 ? Ie2 : St; ++Xt < St; ) {
                var Wn = xM(Xt, cn), zr = ot[Wn];
                ot[Wn] = ot[Xt], ot[Xt] = zr;
              }
              return ot.length = St, ot;
            }
            var nut = Gj2(function(ot) {
              var St = [];
              return ot.charCodeAt(0) === 46 && St.push(""), ot.replace(n32, function(Xt, Ie2, cn, Wn) {
                St.push(cn ? Wn.replace(Pr, "$1") : Ie2 || Xt);
              }), St;
            });
            function FI(ot) {
              if (typeof ot == "string" || mx(ot))
                return ot;
              var St = ot + "";
              return St == "0" && 1 / ot == -Xr ? "-0" : St;
            }
            function iR(ot) {
              if (ot != null) {
                try {
                  return E8.call(ot);
                } catch {
                }
                try {
                  return ot + "";
                } catch {
                }
              }
              return "";
            }
            function Kzt(ot, St) {
              return Iy(Ms, function(Xt) {
                var Ie2 = "_." + Xt[0];
                St & Xt[1] && !kI(ot, Ie2) && ot.push(Ie2);
              }), ot.sort();
            }
            function jSt(ot) {
              if (ot instanceof up)
                return ot.clone();
              var St = new Rw(ot.__wrapped__, ot.__chain__);
              return St.__actions__ = B1(ot.__actions__), St.__index__ = ot.__index__, St.__values__ = ot.__values__, St;
            }
            function TK(ot, St, Xt) {
              (Xt ? vx(ot, St, Xt) : St === n3) ? St = 1 : St = u0(Ef2(St), 0);
              var Ie2 = ot == null ? 0 : ot.length;
              if (!Ie2 || St < 1)
                return [];
              for (var cn = 0, Wn = 0, zr = da2(GC(Ie2 / St)); cn < Ie2; )
                zr[Wn++] = Um(ot, cn, cn += St);
              return zr;
            }
            function aR(ot) {
              for (var St = -1, Xt = ot == null ? 0 : ot.length, Ie2 = 0, cn = []; ++St < Xt; ) {
                var Wn = ot[St];
                Wn && (cn[Ie2++] = Wn);
              }
              return cn;
            }
            function Xzt() {
              var ot = arguments.length;
              if (!ot)
                return [];
              for (var St = da2(ot - 1), Xt = arguments[0], Ie2 = ot; Ie2--; )
                St[Ie2 - 1] = arguments[Ie2];
              return PI3(af2(Xt) ? B1(Xt) : [Xt], V1(St, 1));
            }
            var Qzt = ch2(function(ot, St) {
              return xv(ot) ? u3(ot, V1(St, 1, xv, true)) : [];
            }), Jzt = ch2(function(ot, St) {
              var Xt = p22(St);
              return xv(Xt) && (Xt = n3), xv(ot) ? u3(ot, V1(St, 1, xv, true), ec2(Xt, 2)) : [];
            }), rut = ch2(function(ot, St) {
              var Xt = p22(St);
              return xv(Xt) && (Xt = n3), xv(ot) ? u3(ot, V1(St, 1, xv, true), n3, Xt) : [];
            });
            function tjt(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              return Ie2 ? (St = Xt || St === n3 ? 1 : Ef2(St), Um(ot, St < 0 ? 0 : St, Ie2)) : [];
            }
            function iut(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              return Ie2 ? (St = Xt || St === n3 ? 1 : Ef2(St), St = Ie2 - St, Um(ot, 0, St < 0 ? 0 : St)) : [];
            }
            function WSt(ot, St) {
              return ot && ot.length ? wk2(ot, ec2(St, 3), true, true) : [];
            }
            function AK(ot, St) {
              return ot && ot.length ? wk2(ot, ec2(St, 3), true) : [];
            }
            function aut(ot, St, Xt, Ie2) {
              var cn = ot == null ? 0 : ot.length;
              return cn ? (Xt && typeof Xt != "number" && vx(ot, St, Xt) && (Xt = 0, Ie2 = cn), Pzt(ot, St, Xt, Ie2)) : [];
            }
            function GSt(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              if (!Ie2)
                return -1;
              var cn = Xt == null ? 0 : Ef2(Xt);
              return cn < 0 && (cn = u0(Ie2 + cn, 0)), BC(ot, ec2(St, 3), cn);
            }
            function out2(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              if (!Ie2)
                return -1;
              var cn = Ie2 - 1;
              return Xt !== n3 && (cn = Ef2(Xt), cn = Xt < 0 ? u0(Ie2 + cn, 0) : F1(cn, Ie2 - 1)), BC(ot, ec2(St, 3), cn, true);
            }
            function sut(ot) {
              var St = ot == null ? 0 : ot.length;
              return St ? V1(ot, 1) : [];
            }
            function ejt(ot) {
              var St = ot == null ? 0 : ot.length;
              return St ? V1(ot, Xr) : [];
            }
            function njt(ot, St) {
              var Xt = ot == null ? 0 : ot.length;
              return Xt ? (St = St === n3 ? 1 : Ef2(St), V1(ot, St)) : [];
            }
            function rjt(ot) {
              for (var St = -1, Xt = ot == null ? 0 : ot.length, Ie2 = {}; ++St < Xt; ) {
                var cn = ot[St];
                Ie2[cn[0]] = cn[1];
              }
              return Ie2;
            }
            function lut(ot) {
              return ot && ot.length ? ot[0] : n3;
            }
            function ijt(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              if (!Ie2)
                return -1;
              var cn = Xt == null ? 0 : Ef2(Xt);
              return cn < 0 && (cn = u0(Ie2 + cn, 0)), c2(ot, St, cn);
            }
            function ajt(ot) {
              var St = ot == null ? 0 : ot.length;
              return St ? Um(ot, 0, -1) : [];
            }
            var uut = ch2(function(ot) {
              var St = Vv(ot, Rj2);
              return St.length && St[0] === ot[0] ? Plt(St) : [];
            }), ojt = ch2(function(ot) {
              var St = p22(ot), Xt = Vv(ot, Rj2);
              return St === p22(Xt) ? St = n3 : Xt.pop(), Xt.length && Xt[0] === ot[0] ? Plt(Xt, ec2(St, 2)) : [];
            }), sjt = ch2(function(ot) {
              var St = p22(ot), Xt = Vv(ot, Rj2);
              return St = typeof St == "function" ? St : n3, St && Xt.pop(), Xt.length && Xt[0] === ot[0] ? Plt(Xt, n3, St) : [];
            });
            function ljt(ot, St) {
              return ot == null ? "" : bzt.call(ot, St);
            }
            function p22(ot) {
              var St = ot == null ? 0 : ot.length;
              return St ? ot[St - 1] : n3;
            }
            function cut(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              if (!Ie2)
                return -1;
              var cn = Ie2;
              return Xt !== n3 && (cn = Ef2(Xt), cn = cn < 0 ? u0(Ie2 + cn, 0) : F1(cn, Ie2 - 1)), St === St ? plt(ot, St, cn) : BC(ot, tSt, cn, true);
            }
            function oR(ot, St) {
              return ot && ot.length ? Olt(ot, Ef2(St)) : n3;
            }
            var IK = ch2(fut);
            function fut(ot, St) {
              return ot && ot.length && St && St.length ? kj2(ot, St) : ot;
            }
            function ujt(ot, St, Xt) {
              return ot && ot.length && St && St.length ? kj2(ot, St, ec2(Xt, 2)) : ot;
            }
            function cjt(ot, St, Xt) {
              return ot && ot.length && St && St.length ? kj2(ot, St, n3, Xt) : ot;
            }
            var hut = rf2(function(ot, St) {
              var Xt = ot == null ? 0 : ot.length, Ie2 = rK(ot, St);
              return TSt(ot, Vv(St, function(cn) {
                return Mk(cn, Xt) ? +cn : cn;
              }).sort(Vlt)), Ie2;
            });
            function put(ot, St) {
              var Xt = [];
              if (!(ot && ot.length))
                return Xt;
              var Ie2 = -1, cn = [], Wn = ot.length;
              for (St = ec2(St, 3); ++Ie2 < Wn; ) {
                var zr = ot[Ie2];
                St(zr, Ie2, ot) && (Xt.push(zr), cn.push(Ie2));
              }
              return TSt(ot, cn), Xt;
            }
            function dut(ot) {
              return ot == null ? ot : wzt.call(ot);
            }
            function SM(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              return Ie2 ? (Xt && typeof Xt != "number" && vx(ot, St, Xt) ? (St = 0, Xt = Ie2) : (St = St == null ? 0 : Ef2(St), Xt = Xt === n3 ? Ie2 : Ef2(Xt)), Um(ot, St, Xt)) : [];
            }
            function Bw(ot, St) {
              return g3(ot, St);
            }
            function zw(ot, St, Xt) {
              return Nlt(ot, St, ec2(Xt, 2));
            }
            function gut(ot, St) {
              var Xt = ot == null ? 0 : ot.length;
              if (Xt) {
                var Ie2 = g3(ot, St);
                if (Ie2 < Xt && Pl(ot[Ie2], St))
                  return Ie2;
              }
              return -1;
            }
            function vut(ot, St) {
              return g3(ot, St, true);
            }
            function sR(ot, St, Xt) {
              return Nlt(ot, St, ec2(Xt, 2), true);
            }
            function DK(ot, St) {
              var Xt = ot == null ? 0 : ot.length;
              if (Xt) {
                var Ie2 = g3(ot, St, true) - 1;
                if (Pl(ot[Ie2], St))
                  return Ie2;
              }
              return -1;
            }
            function EK(ot) {
              return ot && ot.length ? lc2(ot) : [];
            }
            function kK(ot, St) {
              return ot && ot.length ? lc2(ot, ec2(St, 2)) : [];
            }
            function PK(ot) {
              var St = ot == null ? 0 : ot.length;
              return St ? Um(ot, 1, St) : [];
            }
            function HSt(ot, St, Xt) {
              return ot && ot.length ? (St = Xt || St === n3 ? 1 : Ef2(St), Um(ot, 0, St < 0 ? 0 : St)) : [];
            }
            function USt(ot, St, Xt) {
              var Ie2 = ot == null ? 0 : ot.length;
              return Ie2 ? (St = Xt || St === n3 ? 1 : Ef2(St), St = Ie2 - St, Um(ot, St < 0 ? 0 : St, Ie2)) : [];
            }
            function qSt(ot, St) {
              return ot && ot.length ? wk2(ot, ec2(St, 3), false, true) : [];
            }
            function fjt(ot, St) {
              return ot && ot.length ? wk2(ot, ec2(St, 3)) : [];
            }
            var hjt = ch2(function(ot) {
              return xk2(V1(ot, 1, xv, true));
            }), pjt = ch2(function(ot) {
              var St = p22(ot);
              return xv(St) && (St = n3), xk2(V1(ot, 1, xv, true), ec2(St, 2));
            }), Cd2 = ch2(function(ot) {
              var St = p22(ot);
              return St = typeof St == "function" ? St : n3, xk2(V1(ot, 1, xv, true), n3, St);
            });
            function lR(ot) {
              return ot && ot.length ? xk2(ot) : [];
            }
            function uR(ot, St) {
              return ot && ot.length ? xk2(ot, ec2(St, 2)) : [];
            }
            function VI(ot, St) {
              return St = typeof St == "function" ? St : n3, ot && ot.length ? xk2(ot, n3, St) : [];
            }
            function BI(ot) {
              if (!(ot && ot.length))
                return [];
              var St = 0;
              return ot = EI(ot, function(Xt) {
                if (xv(Xt))
                  return St = u0(Xt.length, St), true;
              }), GY(St, function(Xt) {
                return Vv(ot, rlt(Xt));
              });
            }
            function tT(ot, St) {
              if (!(ot && ot.length))
                return [];
              var Xt = BI(ot);
              return St == null ? Xt : Vv(Xt, function(Ie2) {
                return nm(St, n3, Ie2);
              });
            }
            var zI = ch2(function(ot, St) {
              return xv(ot) ? u3(ot, St) : [];
            }), yut = ch2(function(ot) {
              return f22(EI(ot, xv));
            }), mut = ch2(function(ot) {
              var St = p22(ot);
              return xv(St) && (St = n3), f22(EI(ot, xv), ec2(St, 2));
            }), cR = ch2(function(ot) {
              var St = p22(ot);
              return St = typeof St == "function" ? St : n3, f22(EI(ot, xv), n3, St);
            }), fR = ch2(BI);
            function Tk(ot, St) {
              return Oj2(ot || [], St || [], Cj2);
            }
            function but(ot, St) {
              return Oj2(ot || [], St || [], p3);
            }
            var b3 = ch2(function(ot) {
              var St = ot.length, Xt = St > 1 ? ot[St - 1] : n3;
              return Xt = typeof Xt == "function" ? (ot.pop(), Xt) : n3, tT(ot, Xt);
            });
            function LK(ot) {
              var St = kn(ot);
              return St.__chain__ = true, St;
            }
            function Hj2(ot, St) {
              return St(ot), ot;
            }
            function z8(ot, St) {
              return St(ot);
            }
            var djt = rf2(function(ot) {
              var St = ot.length, Xt = St ? ot[0] : 0, Ie2 = this.__wrapped__, cn = function(Wn) {
                return rK(Wn, ot);
              };
              return St > 1 || this.__actions__.length || !(Ie2 instanceof up) || !Mk(Xt) ? this.thru(cn) : (Ie2 = Ie2.slice(Xt, +Xt + (St ? 1 : 0)), Ie2.__actions__.push({ func: z8, args: [cn], thisArg: n3 }), new Rw(Ie2, this.__chain__).thru(function(Wn) {
                return St && !Wn.length && Wn.push(n3), Wn;
              }));
            });
            function gjt() {
              return LK(this);
            }
            function jI() {
              return new Rw(this.value(), this.__chain__);
            }
            function _3() {
              this.__values__ === n3 && (this.__values__ = Eut(this.value()));
              var ot = this.__index__ >= this.__values__.length, St = ot ? n3 : this.__values__[this.__index__++];
              return { done: ot, value: St };
            }
            function vjt() {
              return this;
            }
            function ZSt(ot) {
              for (var St, Xt = this; Xt instanceof Bb2; ) {
                var Ie2 = jSt(Xt);
                Ie2.__index__ = 0, Ie2.__values__ = n3, St ? cn.__wrapped__ = Ie2 : St = Ie2;
                var cn = Ie2;
                Xt = Xt.__wrapped__;
              }
              return cn.__wrapped__ = ot, St;
            }
            function $St() {
              var ot = this.__wrapped__;
              if (ot instanceof up) {
                var St = ot;
                return this.__actions__.length && (St = new up(this)), St = St.reverse(), St.__actions__.push({ func: z8, args: [dut], thisArg: n3 }), new Rw(St, this.__chain__);
              }
              return this.thru(dut);
            }
            function x3() {
              return Lj2(this.__wrapped__, this.__actions__);
            }
            var Uj2 = vK(function(ot, St, Xt) {
              Md2.call(ot, Xt) ? ++ot[Xt] : yM(ot, Xt, 1);
            });
            function yjt(ot, St, Xt) {
              var Ie2 = af2(ot) ? elt : Elt;
              return Xt && vx(ot, St, Xt) && (St = n3), Ie2(ot, ec2(St, 3));
            }
            function Ak(ot, St) {
              var Xt = af2(ot) ? EI : wSt;
              return Xt(ot, ec2(St, 3));
            }
            var w3 = h2(GSt), hR = h2(out2);
            function mjt(ot, St) {
              return V1(OK(ot, St), 1);
            }
            function bjt(ot, St) {
              return V1(OK(ot, St), Xr);
            }
            function yx(ot, St, Xt) {
              return Xt = Xt === n3 ? 1 : Ef2(Xt), V1(OK(ot, St), Xt);
            }
            function d22(ot, St) {
              var Xt = af2(ot) ? Iy : mM;
              return Xt(ot, ec2(St, 3));
            }
            function YSt(ot, St) {
              var Xt = af2(ot) ? uzt : xSt;
              return Xt(ot, ec2(St, 3));
            }
            var _jt = vK(function(ot, St, Xt) {
              Md2.call(ot, Xt) ? ot[Xt].push(St) : yM(ot, Xt, [St]);
            });
            function xjt(ot, St, Xt, Ie2) {
              ot = jb2(ot) ? ot : G8(ot), Xt = Xt && !Ie2 ? Ef2(Xt) : 0;
              var cn = ot.length;
              return Xt < 0 && (Xt = u0(cn + Xt, 0)), zK(ot) ? Xt <= cn && ot.indexOf(St, Xt) > -1 : !!cn && c2(ot, St, Xt) > -1;
            }
            var wjt = ch2(function(ot, St, Xt) {
              var Ie2 = -1, cn = typeof St == "function", Wn = jb2(ot) ? da2(ot.length) : [];
              return mM(ot, function(zr) {
                Wn[++Ie2] = cn ? nm(St, zr, Xt) : c3(zr, St, Xt);
              }), Wn;
            }), KSt = vK(function(ot, St, Xt) {
              yM(ot, Xt, St);
            });
            function OK(ot, St) {
              var Xt = af2(ot) ? Vv : f3;
              return Xt(ot, ec2(St, 3));
            }
            function Sjt(ot, St, Xt, Ie2) {
              return ot == null ? [] : (af2(St) || (St = St == null ? [] : [St]), Xt = Ie2 ? n3 : Xt, af2(Xt) || (Xt = Xt == null ? [] : [Xt]), h3(ot, St, Xt));
            }
            var RK = vK(function(ot, St, Xt) {
              ot[Xt ? 0 : 1].push(St);
            }, function() {
              return [[], []];
            });
            function Mjt(ot, St, Xt) {
              var Ie2 = af2(ot) ? z4 : nSt, cn = arguments.length < 3;
              return Ie2(ot, ec2(St, 4), Xt, cn, mM);
            }
            function _ut(ot, St, Xt) {
              var Ie2 = af2(ot) ? nlt : nSt, cn = arguments.length < 3;
              return Ie2(ot, ec2(St, 4), Xt, cn, xSt);
            }
            function Cjt(ot, St) {
              var Xt = af2(ot) ? EI : wSt;
              return Xt(ot, $j(ec2(St, 3)));
            }
            function Tc2(ot) {
              var St = af2(ot) ? mSt : Bu;
              return St(ot);
            }
            function Tjt(ot, St, Xt) {
              (Xt ? vx(ot, St, Xt) : St === n3) ? St = 1 : St = Ef2(St);
              var Ie2 = af2(ot) ? tK : pK;
              return Ie2(ot, St);
            }
            function XSt(ot) {
              var St = af2(ot) ? bSt : J4;
              return St(ot);
            }
            function qj2(ot) {
              if (ot == null)
                return 0;
              if (jb2(ot))
                return zK(ot) ? W4(ot) : ot.length;
              var St = zb2(ot);
              return St == fu || St == Kd2 ? ot.size : Ej2(ot).length;
            }
            function Ajt(ot, St, Xt) {
              var Ie2 = af2(ot) ? LI : Pj2;
              return Xt && vx(ot, St, Xt) && (St = n3), Ie2(ot, ec2(St, 3));
            }
            var Ijt = ch2(function(ot, St) {
              if (ot == null)
                return [];
              var Xt = St.length;
              return Xt > 1 && vx(ot, St[0], St[1]) ? St = [] : Xt > 2 && vx(St[0], St[1], St[2]) && (St = [St[0]]), h3(ot, V1(St, 1), []);
            }), NK = qY || function() {
              return Tg2.Date.now();
            };
            function QSt(ot, St) {
              if (typeof St != "function")
                throw new fx(T2);
              return ot = Ef2(ot), function() {
                if (--ot < 1)
                  return St.apply(this, arguments);
              };
            }
            function qm(ot, St, Xt) {
              return St = Xt ? n3 : St, St = ot && St == null ? ot.length : St, JC(ot, pe2, n3, n3, n3, n3, St);
            }
            function JSt(ot, St) {
              var Xt;
              if (typeof St != "function")
                throw new fx(T2);
              return ot = Ef2(ot), function() {
                return --ot > 0 && (Xt = St.apply(this, arguments)), ot <= 1 && (St = n3), Xt;
              };
            }
            var S3 = ch2(function(ot, St, Xt) {
              var Ie2 = yt;
              if (Xt.length) {
                var cn = dk2(Xt, wM(S3));
                Ie2 |= ue2;
              }
              return JC(ot, Ie2, St, Xt, cn);
            }), xut = ch2(function(ot, St, Xt) {
              var Ie2 = yt | At;
              if (Xt.length) {
                var cn = dk2(Xt, wM(xut));
                Ie2 |= ue2;
              }
              return JC(St, Ie2, ot, Xt, cn);
            });
            function wut(ot, St, Xt) {
              St = Xt ? n3 : St;
              var Ie2 = JC(ot, Wt, n3, n3, n3, n3, n3, St);
              return Ie2.placeholder = wut.placeholder, Ie2;
            }
            function M3(ot, St, Xt) {
              St = Xt ? n3 : St;
              var Ie2 = JC(ot, Nt, n3, n3, n3, n3, n3, St);
              return Ie2.placeholder = M3.placeholder, Ie2;
            }
            function t2t(ot, St, Xt) {
              var Ie2, cn, Wn, zr, Qr, Ni2, wo = 0, vo = false, Lo = false, Ks = true;
              if (typeof ot != "function")
                throw new fx(T2);
              St = v22(St) || 0, Bv(Xt) && (vo = !!Xt.leading, Lo = "maxWait" in Xt, Wn = Lo ? u0(v22(Xt.maxWait) || 0, St) : Wn, Ks = "trailing" in Xt ? !!Xt.trailing : Ks);
              function yu(J0) {
                var Ub2 = Ie2, $I = cn;
                return Ie2 = cn = n3, wo = J0, zr = ot.apply($I, Ub2), zr;
              }
              function gc2(J0) {
                return wo = J0, Qr = Vw(Kh2, St), vo ? yu(J0) : zr;
              }
              function of2(J0) {
                var Ub2 = J0 - Ni2, $I = J0 - wo, Ik = St - Ub2;
                return Lo ? F1(Ik, Wn - $I) : Ik;
              }
              function uc2(J0) {
                var Ub2 = J0 - Ni2, $I = J0 - wo;
                return Ni2 === n3 || Ub2 >= St || Ub2 < 0 || Lo && $I >= Wn;
              }
              function Kh2() {
                var J0 = NK();
                if (uc2(J0))
                  return ph2(J0);
                Qr = Vw(Kh2, of2(J0));
              }
              function ph2(J0) {
                return Qr = n3, Ks && Ie2 ? yu(J0) : (Ie2 = cn = n3, zr);
              }
              function j1() {
                Qr !== n3 && dK(Qr), wo = 0, Ie2 = Ni2 = cn = Qr = n3;
              }
              function Hb2() {
                return Qr === n3 ? zr : ph2(NK());
              }
              function _x() {
                var J0 = NK(), Ub2 = uc2(J0);
                if (Ie2 = arguments, cn = this, Ni2 = J0, Ub2) {
                  if (Qr === n3)
                    return gc2(Ni2);
                  if (Lo)
                    return dK(Qr), Qr = Vw(Kh2, St), yu(Ni2);
                }
                return Qr === n3 && (Qr = Vw(Kh2, St)), zr;
              }
              return _x.cancel = j1, _x.flush = Hb2, _x;
            }
            var Djt = ch2(function(ot, St) {
              return Dlt(ot, 1, St);
            }), e2t = ch2(function(ot, St, Xt) {
              return Dlt(ot, v22(St) || 0, Xt);
            });
            function zf2(ot) {
              return JC(ot, Ce2);
            }
            function Zj2(ot, St) {
              if (typeof ot != "function" || St != null && typeof St != "function")
                throw new fx(T2);
              var Xt = function() {
                var Ie2 = arguments, cn = St ? St.apply(this, Ie2) : Ie2[0], Wn = Xt.cache;
                if (Wn.has(cn))
                  return Wn.get(cn);
                var zr = ot.apply(this, Ie2);
                return Xt.cache = Wn.set(cn, zr) || Wn, zr;
              };
              return Xt.cache = new (Zj2.Cache || yk)(), Xt;
            }
            Zj2.Cache = yk;
            function $j(ot) {
              if (typeof ot != "function")
                throw new fx(T2);
              return function() {
                var St = arguments;
                switch (St.length) {
                  case 0:
                    return !ot.call(this);
                  case 1:
                    return !ot.call(this, St[0]);
                  case 2:
                    return !ot.call(this, St[0], St[1]);
                  case 3:
                    return !ot.call(this, St[0], St[1], St[2]);
                }
                return !ot.apply(this, St);
              };
            }
            function Ejt(ot) {
              return JSt(2, ot);
            }
            var n2t = B8(function(ot, St) {
              St = St.length == 1 && af2(St[0]) ? Vv(St[0], cx(ec2())) : Vv(V1(St, 1), cx(ec2()));
              var Xt = St.length;
              return ch2(function(Ie2) {
                for (var cn = -1, Wn = F1(Ie2.length, Xt); ++cn < Wn; )
                  Ie2[cn] = St[cn].call(this, Ie2[cn]);
                return nm(ot, this, Ie2);
              });
            }), Sut = ch2(function(ot, St) {
              var Xt = dk2(St, wM(Sut));
              return JC(ot, ue2, n3, St, Xt);
            }), r2t = ch2(function(ot, St) {
              var Xt = dk2(St, wM(r2t));
              return JC(ot, ie2, n3, St, Xt);
            }), i2t = rf2(function(ot, St) {
              return JC(ot, xe, n3, n3, n3, St);
            });
            function a2t(ot, St) {
              if (typeof ot != "function")
                throw new fx(T2);
              return St = St === n3 ? St : Ef2(St), ch2(ot, St);
            }
            function o2t(ot, St) {
              if (typeof ot != "function")
                throw new fx(T2);
              return St = St == null ? 0 : u0(Ef2(St), 0), ch2(function(Xt) {
                var Ie2 = Xt[St], cn = y3(Xt, 0, St);
                return Ie2 && PI3(cn, Ie2), nm(ot, this, cn);
              });
            }
            function s2t(ot, St, Xt) {
              var Ie2 = true, cn = true;
              if (typeof ot != "function")
                throw new fx(T2);
              return Bv(Xt) && (Ie2 = "leading" in Xt ? !!Xt.leading : Ie2, cn = "trailing" in Xt ? !!Xt.trailing : cn), t2t(ot, St, { leading: Ie2, maxWait: St, trailing: cn });
            }
            function kjt(ot) {
              return qm(ot, 1);
            }
            function l2t(ot, St) {
              return Sut(Nj2(St), ot);
            }
            function u2t() {
              if (!arguments.length)
                return [];
              var ot = arguments[0];
              return af2(ot) ? ot : [ot];
            }
            function c2t(ot) {
              return Fw(ot, J);
            }
            function f2t(ot, St) {
              return St = typeof St == "function" ? St : n3, Fw(ot, J, St);
            }
            function h2t(ot) {
              return Fw(ot, q3 | J);
            }
            function Mut(ot, St) {
              return St = typeof St == "function" ? St : n3, Fw(ot, q3 | J, St);
            }
            function hh2(ot, St) {
              return St == null || Ilt(ot, St, rm(St));
            }
            function Pl(ot, St) {
              return ot === St || ot !== ot && St !== St;
            }
            var Cut = bK(sK), p2t = bK(function(ot, St) {
              return ot >= St;
            }), C3 = lK(function() {
              return arguments;
            }()) ? lK : function(ot) {
              return wv(ot) && Md2.call(ot, "callee") && !WC.call(ot, "callee");
            }, af2 = da2.isArray, Tut = zY ? cx(zY) : SSt;
            function jb2(ot) {
              return ot != null && Kj2(ot.length) && !g2(ot);
            }
            function xv(ot) {
              return wv(ot) && jb2(ot);
            }
            function FK(ot) {
              return ot === true || ot === false || wv(ot) && gx(ot) == as;
            }
            var k0 = Hm || Kut, Yj2 = hj2 ? cx(hj2) : Rzt;
            function j8(ot) {
              return wv(ot) && ot.nodeType === 1 && !T3(ot);
            }
            function Pjt(ot) {
              if (ot == null)
                return true;
              if (jb2(ot) && (af2(ot) || typeof ot == "string" || typeof ot.splice == "function" || k0(ot) || MM(ot) || C3(ot)))
                return !ot.length;
              var St = zb2(ot);
              if (St == fu || St == Kd2)
                return !ot.size;
              if (rR(ot))
                return !Ej2(ot).length;
              for (var Xt in ot)
                if (Md2.call(ot, Xt))
                  return false;
              return true;
            }
            function pR(ot, St) {
              return Aj2(ot, St);
            }
            function VK(ot, St, Xt) {
              Xt = typeof Xt == "function" ? Xt : n3;
              var Ie2 = Xt ? Xt(ot, St) : n3;
              return Ie2 === n3 ? Aj2(ot, St, n3, Xt) : !!Ie2;
            }
            function dR(ot) {
              if (!wv(ot))
                return false;
              var St = gx(ot);
              return St == xs || St == ol || typeof ot.message == "string" && typeof ot.name == "string" && !T3(ot);
            }
            function BK(ot) {
              return typeof ot == "number" && ZY(ot);
            }
            function g2(ot) {
              if (!Bv(ot))
                return false;
              var St = gx(ot);
              return St == Bl || St == Ph2 || St == el || St == Fd2;
            }
            function gR(ot) {
              return typeof ot == "number" && ot == Ef2(ot);
            }
            function Kj2(ot) {
              return typeof ot == "number" && ot > -1 && ot % 1 == 0 && ot <= Xn;
            }
            function Bv(ot) {
              var St = typeof ot;
              return ot != null && (St == "object" || St == "function");
            }
            function wv(ot) {
              return ot != null && typeof ot == "object";
            }
            var Aut = tlt ? cx(tlt) : uK;
            function d2t(ot, St) {
              return ot === St || Ij2(ot, St, $lt(St));
            }
            function Iut(ot, St, Xt) {
              return Xt = typeof Xt == "function" ? Xt : n3, Ij2(ot, St, $lt(St), Xt);
            }
            function g2t(ot) {
              return WI(ot) && ot != +ot;
            }
            function Ljt(ot) {
              if (Wj2(ot))
                throw new $c2(w2);
              return cK(ot);
            }
            function Ojt(ot) {
              return ot === null;
            }
            function v2t(ot) {
              return ot == null;
            }
            function WI(ot) {
              return typeof ot == "number" || wv(ot) && gx(ot) == uh2;
            }
            function T3(ot) {
              if (!wv(ot) || gx(ot) != zp)
                return false;
              var St = xj2(ot);
              if (St === null)
                return true;
              var Xt = Md2.call(St, "constructor") && St.constructor;
              return typeof Xt == "function" && Xt instanceof Xt && E8.call(Xt) == dlt;
            }
            var Dut = Ls ? cx(Ls) : Llt;
            function Rjt(ot) {
              return gR(ot) && ot >= -Xn && ot <= Xn;
            }
            var y2t = I0 ? cx(I0) : Nzt;
            function zK(ot) {
              return typeof ot == "string" || !af2(ot) && wv(ot) && gx(ot) == Nv;
            }
            function mx(ot) {
              return typeof ot == "symbol" || wv(ot) && gx(ot) == mv;
            }
            var MM = pj2 ? cx(pj2) : bM;
            function m2t(ot) {
              return ot === n3;
            }
            function b2t(ot) {
              return wv(ot) && zb2(ot) == go;
            }
            function GI(ot) {
              return wv(ot) && gx(ot) == aa2;
            }
            var HI = bK(_M), _2t = bK(function(ot, St) {
              return ot <= St;
            });
            function Eut(ot) {
              if (!ot)
                return [];
              if (jb2(ot))
                return zK(ot) ? zC(ot) : B1(ot);
              if (vM && ot[vM])
                return flt(ot[vM]());
              var St = zb2(ot), Xt = St == fu ? hlt : St == Kd2 ? HY : G8;
              return Xt(ot);
            }
            function UI(ot) {
              if (!ot)
                return ot === 0 ? ot : 0;
              if (ot = v22(ot), ot === Xr || ot === -Xr) {
                var St = ot < 0 ? -1 : 1;
                return St * or;
              }
              return ot === ot ? ot : 0;
            }
            function Ef2(ot) {
              var St = UI(ot), Xt = St % 1;
              return St === St ? Xt ? St - Xt : St : 0;
            }
            function kut(ot) {
              return ot ? qC(Ef2(ot), 0, ci2) : 0;
            }
            function v22(ot) {
              if (typeof ot == "number")
                return ot;
              if (mx(ot))
                return Tr;
              if (Bv(ot)) {
                var St = typeof ot.valueOf == "function" ? ot.valueOf() : ot;
                ot = Bv(St) ? St + "" : St;
              }
              if (typeof ot != "string")
                return ot === 0 ? ot : +ot;
              ot = rSt(ot);
              var Xt = wn.test(ot);
              return Xt || Pa2.test(ot) ? Qst(ot.slice(2), Xt ? 2 : 8) : vr.test(ot) ? Tr : +ot;
            }
            function jK(ot) {
              return KC(ot, jw(ot));
            }
            function Put(ot) {
              return ot ? qC(Ef2(ot), -Xn, Xn) : ot === 0 ? ot : 0;
            }
            function Td2(ot) {
              return ot == null ? "" : _v(ot);
            }
            var Lut = eR(function(ot, St) {
              if (rR(St) || jb2(St)) {
                KC(St, rm(St), ot);
                return;
              }
              for (var Xt in St)
                Md2.call(St, Xt) && Cj2(ot, Xt, St[Xt]);
            }), x2t = eR(function(ot, St) {
              KC(St, jw(St), ot);
            }), WK = eR(function(ot, St, Xt, Ie2) {
              KC(St, jw(St), ot, Ie2);
            }), Njt = eR(function(ot, St, Xt, Ie2) {
              KC(St, rm(St), ot, Ie2);
            }), w2t = rf2(rK);
            function Fjt(ot, St) {
              var Xt = HC(ot);
              return St == null ? Xt : _St(Xt, St);
            }
            var vR = ch2(function(ot, St) {
              ot = Vd2(ot);
              var Xt = -1, Ie2 = St.length, cn = Ie2 > 2 ? St[2] : n3;
              for (cn && vx(St[0], St[1], cn) && (Ie2 = 1); ++Xt < Ie2; )
                for (var Wn = St[Xt], zr = jw(Wn), Qr = -1, Ni2 = zr.length; ++Qr < Ni2; ) {
                  var wo = zr[Qr], vo = ot[wo];
                  (vo === n3 || Pl(vo, jC[wo]) && !Md2.call(ot, wo)) && (ot[wo] = Wn[wo]);
                }
              return ot;
            }), Vjt = ch2(function(ot) {
              return ot.push(n3, NI), nm(Qj2, n3, ot);
            });
            function f0(ot, St) {
              return Gm(ot, ec2(St, 3), ZC);
            }
            function Out(ot, St) {
              return Gm(ot, ec2(St, 3), aK);
            }
            function S2t(ot, St) {
              return ot == null ? ot : Tj2(ot, ec2(St, 3), jw);
            }
            function Bjt(ot, St) {
              return ot == null ? ot : iK(ot, ec2(St, 3), jw);
            }
            function z1(ot, St) {
              return ot && ZC(ot, ec2(St, 3));
            }
            function yR(ot, St) {
              return ot && aK(ot, ec2(St, 3));
            }
            function Xj2(ot) {
              return ot == null ? [] : F8(ot, rm(ot));
            }
            function zjt(ot) {
              return ot == null ? [] : F8(ot, jw(ot));
            }
            function Rut(ot, St, Xt) {
              var Ie2 = ot == null ? n3 : $4(ot, St);
              return Ie2 === n3 ? Xt : Ie2;
            }
            function Nut(ot, St) {
              return ot != null && Klt(ot, St, Lzt);
            }
            function GK(ot, St) {
              return ot != null && Klt(ot, St, $C);
            }
            var jjt = jlt(function(ot, St, Xt) {
              St != null && typeof St.toString != "function" && (St = _j.call(St)), ot[St] = Xt;
            }, $K(bx)), W8 = jlt(function(ot, St, Xt) {
              St != null && typeof St.toString != "function" && (St = _j.call(St)), Md2.call(ot, St) ? ot[St].push(Xt) : ot[St] = [Xt];
            }, ec2), Wjt = ch2(c3);
            function rm(ot) {
              return jb2(ot) ? JY(ot) : Ej2(ot);
            }
            function jw(ot) {
              return jb2(ot) ? JY(ot, true) : _k(ot);
            }
            function M2t(ot, St) {
              var Xt = {};
              return St = ec2(St, 3), ZC(ot, function(Ie2, cn, Wn) {
                yM(Xt, St(Ie2, cn, Wn), Ie2);
              }), Xt;
            }
            function Fut(ot, St) {
              var Xt = {};
              return St = ec2(St, 3), ZC(ot, function(Ie2, cn, Wn) {
                yM(Xt, cn, St(Ie2, cn, Wn));
              }), Xt;
            }
            var HK = eR(function(ot, St, Xt) {
              hK(ot, St, Xt);
            }), Qj2 = eR(function(ot, St, Xt, Ie2) {
              hK(ot, St, Xt, Ie2);
            }), Jj2 = rf2(function(ot, St) {
              var Xt = {};
              if (ot == null)
                return Xt;
              var Ie2 = false;
              St = Vv(St, function(Wn) {
                return Wn = v32(Wn, ot), Ie2 || (Ie2 = Wn.length > 1), Wn;
              }), KC(ot, xK(ot), Xt), Ie2 && (Xt = Fw(Xt, q3 | K | J, OSt));
              for (var cn = St.length; cn--; )
                tR(Xt, St[cn]);
              return Xt;
            });
            function C2t(ot, St) {
              return But(ot, $j(ec2(St)));
            }
            var Vut = rf2(function(ot, St) {
              return ot == null ? {} : K4(ot, St);
            });
            function But(ot, St) {
              if (ot == null)
                return {};
              var Xt = Vv(xK(ot), function(Ie2) {
                return [Ie2];
              });
              return St = ec2(St), X4(ot, Xt, function(Ie2, cn) {
                return St(Ie2, cn[0]);
              });
            }
            function T2t(ot, St, Xt) {
              St = v32(St, ot);
              var Ie2 = -1, cn = St.length;
              for (cn || (cn = 1, ot = n3); ++Ie2 < cn; ) {
                var Wn = ot == null ? n3 : ot[FI(St[Ie2])];
                Wn === n3 && (Ie2 = cn, Wn = Xt), ot = g2(Wn) ? Wn.call(ot) : Wn;
              }
              return ot;
            }
            function Gjt(ot, St, Xt) {
              return ot == null ? ot : p3(ot, St, Xt);
            }
            function Hjt(ot, St, Xt, Ie2) {
              return Ie2 = typeof Ie2 == "function" ? Ie2 : n3, ot == null ? ot : p3(ot, St, Xt, Ie2);
            }
            var A2t = Ult(rm), zut = Ult(jw);
            function I2t(ot, St, Xt) {
              var Ie2 = af2(ot), cn = Ie2 || k0(ot) || MM(ot);
              if (St = ec2(St, 4), Xt == null) {
                var Wn = ot && ot.constructor;
                cn ? Xt = Ie2 ? new Wn() : [] : Bv(ot) ? Xt = g2(Wn) ? HC(xj2(ot)) : {} : Xt = {};
              }
              return (cn ? Iy : ZC)(ot, function(zr, Qr, Ni2) {
                return St(Xt, zr, Qr, Ni2);
              }), Xt;
            }
            function D2t(ot, St) {
              return ot == null ? true : tR(ot, St);
            }
            function E2t(ot, St, Xt) {
              return ot == null ? ot : V8(ot, St, Nj2(Xt));
            }
            function Ujt(ot, St, Xt, Ie2) {
              return Ie2 = typeof Ie2 == "function" ? Ie2 : n3, ot == null ? ot : V8(ot, St, Nj2(Xt), Ie2);
            }
            function G8(ot) {
              return ot == null ? [] : olt(ot, rm(ot));
            }
            function jut(ot) {
              return ot == null ? [] : olt(ot, jw(ot));
            }
            function qjt(ot, St, Xt) {
              return Xt === n3 && (Xt = St, St = n3), Xt !== n3 && (Xt = v22(Xt), Xt = Xt === Xt ? Xt : 0), St !== n3 && (St = v22(St), St = St === St ? St : 0), qC(v22(ot), St, Xt);
            }
            function k2t(ot, St, Xt) {
              return St = UI(St), Xt === n3 ? (Xt = St, St = 0) : Xt = UI(Xt), ot = v22(ot), klt(ot, St, Xt);
            }
            function qI(ot, St, Xt) {
              if (Xt && typeof Xt != "boolean" && vx(ot, St, Xt) && (St = Xt = n3), Xt === n3 && (typeof St == "boolean" ? (Xt = St, St = n3) : typeof ot == "boolean" && (Xt = ot, ot = n3)), ot === n3 && St === n3 ? (ot = 0, St = 1) : (ot = UI(ot), St === n3 ? (St = ot, ot = 0) : St = UI(St)), ot > St) {
                var Ie2 = ot;
                ot = St, St = Ie2;
              }
              if (Xt || ot % 1 || St % 1) {
                var cn = $Y();
                return F1(ot + cn * (St - ot + pk2("1e-" + ((cn + "").length - 1))), St);
              }
              return xM(ot, St);
            }
            var Zjt = fh2(function(ot, St, Xt) {
              return St = St.toLowerCase(), ot + (Xt ? Wut(St) : St);
            });
            function Wut(ot) {
              return Gb2(Td2(ot).toLowerCase());
            }
            function UK(ot) {
              return ot = Td2(ot), ot && ot.replace(Uo, fzt).replace(gs, "");
            }
            function P2t(ot, St, Xt) {
              ot = Td2(ot), St = _v(St);
              var Ie2 = ot.length;
              Xt = Xt === n3 ? Ie2 : qC(Ef2(Xt), 0, Ie2);
              var cn = Xt;
              return Xt -= St.length, Xt >= 0 && ot.slice(Xt, cn) == St;
            }
            function Gut(ot) {
              return ot = Td2(ot), ot && Ay.test(ot) ? ot.replace(l0, ult) : ot;
            }
            function mR(ot) {
              return ot = Td2(ot), ot && sj2.test(ot) ? ot.replace(uk2, "\\$&") : ot;
            }
            var H8 = fh2(function(ot, St, Xt) {
              return ot + (Xt ? "-" : "") + St.toLowerCase();
            }), $jt = fh2(function(ot, St, Xt) {
              return ot + (Xt ? " " : "") + St.toLowerCase();
            }), Wb2 = PSt("toLowerCase");
            function L2t(ot, St, Xt) {
              ot = Td2(ot), St = Ef2(St);
              var Ie2 = St ? W4(ot) : 0;
              if (!St || Ie2 >= St)
                return ot;
              var cn = (St - Ie2) / 2;
              return Vj2(Sj2(cn), Xt) + ot + Vj2(GC(cn), Xt);
            }
            function tW(ot, St, Xt) {
              ot = Td2(ot), St = Ef2(St);
              var Ie2 = St ? W4(ot) : 0;
              return St && Ie2 < St ? ot + Vj2(St - Ie2, Xt) : ot;
            }
            function eW(ot, St, Xt) {
              ot = Td2(ot), St = Ef2(St);
              var Ie2 = St ? W4(ot) : 0;
              return St && Ie2 < St ? Vj2(St - Ie2, Xt) + ot : ot;
            }
            function ZI(ot, St, Xt) {
              return Xt || St == null ? St = 0 : St && (St = +St), xzt(Td2(ot).replace(ck2, ""), St || 0);
            }
            function eT(ot, St, Xt) {
              return (Xt ? vx(ot, St, Xt) : St === n3) ? St = 1 : St = Ef2(St), YC(Td2(ot), St);
            }
            function Yjt() {
              var ot = arguments, St = Td2(ot[0]);
              return ot.length < 3 ? St : St.replace(ot[1], ot[2]);
            }
            var qK = fh2(function(ot, St, Xt) {
              return ot + (Xt ? "_" : "") + St.toLowerCase();
            });
            function Kjt(ot, St, Xt) {
              return Xt && typeof Xt != "number" && vx(ot, St, Xt) && (St = Xt = n3), Xt = Xt === n3 ? ci2 : Xt >>> 0, Xt ? (ot = Td2(ot), ot && (typeof St == "string" || St != null && !Dut(St)) && (St = _v(St), !St && N1(ot)) ? y3(zC(ot), 0, Xt) : ot.split(St, Xt)) : [];
            }
            var Xjt = fh2(function(ot, St, Xt) {
              return ot + (Xt ? " " : "") + Gb2(St);
            });
            function Qjt(ot, St, Xt) {
              return ot = Td2(ot), Xt = Xt == null ? 0 : qC(Ef2(Xt), 0, ot.length), St = _v(St), ot.slice(Xt, Xt + St.length) == St;
            }
            function O2t(ot, St, Xt) {
              var Ie2 = kn.templateSettings;
              Xt && vx(ot, St, Xt) && (St = n3), ot = Td2(ot), St = WK({}, St, Ie2, qlt);
              var cn = WK({}, St.imports, Ie2.imports, qlt), Wn = rm(cn), zr = olt(cn, Wn), Qr, Ni2, wo = 0, vo = St.interpolate || os, Lo = "__p += '", Ks = yj2((St.escape || os).source + "|" + vo.source + "|" + (vo === Pw ? Nn : os).source + "|" + (St.evaluate || os).source + "|$", "g"), yu = "//# sourceURL=" + (Md2.call(St, "sourceURL") ? (St.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++cj2 + "]") + `
`;
              ot.replace(Ks, function(uc2, Kh2, ph2, j1, Hb2, _x) {
                return ph2 || (ph2 = j1), Lo += ot.slice(wo, _x).replace(If2, aSt), Kh2 && (Qr = true, Lo += `' +
__e(` + Kh2 + `) +
'`), Hb2 && (Ni2 = true, Lo += `';
` + Hb2 + `;
__p += '`), ph2 && (Lo += `' +
((__t = (` + ph2 + `)) == null ? '' : __t) +
'`), wo = _x + uc2.length, uc2;
              }), Lo += `';
`;
              var gc2 = Md2.call(St, "variable") && St.variable;
              if (!gc2)
                Lo = `with (obj) {
` + Lo + `
}
`;
              else if (wr.test(gc2))
                throw new $c2(E);
              Lo = (Ni2 ? Lo.replace(Rb2, "") : Lo).replace(ax, "$1").replace(hM, "$1;"), Lo = "function(" + (gc2 || "obj") + `) {
` + (gc2 ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (Qr ? ", __e = _.escape" : "") + (Ni2 ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Lo + `return __p
}`;
              var of2 = Hut(function() {
                return pd2(Wn, yu + "return " + Lo).apply(n3, zr);
              });
              if (of2.source = Lo, dR(of2))
                throw of2;
              return of2;
            }
            function Ww(ot) {
              return Td2(ot).toLowerCase();
            }
            function Jjt(ot) {
              return Td2(ot).toUpperCase();
            }
            function R2t(ot, St, Xt) {
              if (ot = Td2(ot), ot && (Xt || St === n3))
                return rSt(ot);
              if (!ot || !(St = _v(St)))
                return ot;
              var Ie2 = zC(ot), cn = zC(St), Wn = slt(Ie2, cn), zr = iSt(Ie2, cn) + 1;
              return y3(Ie2, Wn, zr).join("");
            }
            function ZK(ot, St, Xt) {
              if (ot = Td2(ot), ot && (Xt || St === n3))
                return ot.slice(0, sSt(ot) + 1);
              if (!ot || !(St = _v(St)))
                return ot;
              var Ie2 = zC(ot), cn = iSt(Ie2, zC(St)) + 1;
              return y3(Ie2, 0, cn).join("");
            }
            function tWt(ot, St, Xt) {
              if (ot = Td2(ot), ot && (Xt || St === n3))
                return ot.replace(ck2, "");
              if (!ot || !(St = _v(St)))
                return ot;
              var Ie2 = zC(ot), cn = slt(Ie2, zC(St));
              return y3(Ie2, cn).join("");
            }
            function N2t(ot, St) {
              var Xt = Le2, Ie2 = ze;
              if (Bv(St)) {
                var cn = "separator" in St ? St.separator : cn;
                Xt = "length" in St ? Ef2(St.length) : Xt, Ie2 = "omission" in St ? _v(St.omission) : Ie2;
              }
              ot = Td2(ot);
              var Wn = ot.length;
              if (N1(ot)) {
                var zr = zC(ot);
                Wn = zr.length;
              }
              if (Xt >= Wn)
                return ot;
              var Qr = Xt - W4(Ie2);
              if (Qr < 1)
                return Ie2;
              var Ni2 = zr ? y3(zr, 0, Qr).join("") : ot.slice(0, Qr);
              if (cn === n3)
                return Ni2 + Ie2;
              if (zr && (Qr += Ni2.length - Qr), Dut(cn)) {
                if (ot.slice(Qr).search(cn)) {
                  var wo, vo = Ni2;
                  for (cn.global || (cn = yj2(cn.source, Td2(hr.exec(cn)) + "g")), cn.lastIndex = 0; wo = cn.exec(vo); )
                    var Lo = wo.index;
                  Ni2 = Ni2.slice(0, Lo === n3 ? Qr : Lo);
                }
              } else if (ot.indexOf(_v(cn), Qr) != Qr) {
                var Ks = Ni2.lastIndexOf(cn);
                Ks > -1 && (Ni2 = Ni2.slice(0, Ks));
              }
              return Ni2 + Ie2;
            }
            function eWt(ot) {
              return ot = Td2(ot), ot && $h2.test(ot) ? ot.replace(ox, dzt) : ot;
            }
            var F2t = fh2(function(ot, St, Xt) {
              return ot + (Xt ? " " : "") + St.toUpperCase();
            }), Gb2 = PSt("toUpperCase");
            function V2t(ot, St, Xt) {
              return ot = Td2(ot), St = Xt ? n3 : St, St === n3 ? hzt(ot) ? lSt(ot) : jY(ot) : ot.match(St) || [];
            }
            var Hut = ch2(function(ot, St) {
              try {
                return nm(ot, n3, St);
              } catch (Xt) {
                return dR(Xt) ? Xt : new $c2(Xt);
              }
            }), Gw = rf2(function(ot, St) {
              return Iy(St, function(Xt) {
                Xt = FI(Xt), yM(ot, Xt, S3(ot[Xt], ot));
              }), ot;
            });
            function nWt(ot) {
              var St = ot == null ? 0 : ot.length, Xt = ec2();
              return ot = St ? Vv(ot, function(Ie2) {
                if (typeof Ie2[1] != "function")
                  throw new fx(T2);
                return [Xt(Ie2[0]), Ie2[1]];
              }) : [], ch2(function(Ie2) {
                for (var cn = -1; ++cn < St; ) {
                  var Wn = ot[cn];
                  if (nm(Wn[0], this, Ie2))
                    return nm(Wn[1], this, Ie2);
                }
              });
            }
            function rWt(ot) {
              return Alt(Fw(ot, q3));
            }
            function $K(ot) {
              return function() {
                return ot;
              };
            }
            function Zm(ot, St) {
              return ot == null || ot !== ot ? St : ot;
            }
            var Hw = XC(), iWt = XC(true);
            function bx(ot) {
              return ot;
            }
            function YK(ot) {
              return Dj2(typeof ot == "function" ? ot : Fw(ot, q3));
            }
            function KK(ot) {
              return fK(Fw(ot, q3));
            }
            function aWt(ot, St) {
              return Y4(ot, Fw(St, q3));
            }
            var B2t = ch2(function(ot, St) {
              return function(Xt) {
                return c3(Xt, ot, St);
              };
            }), Uut = ch2(function(ot, St) {
              return function(Xt) {
                return c3(ot, Xt, St);
              };
            });
            function qut(ot, St, Xt) {
              var Ie2 = rm(St), cn = F8(St, Ie2);
              Xt == null && !(Bv(St) && (cn.length || !Ie2.length)) && (Xt = St, St = ot, ot = this, cn = F8(St, rm(St)));
              var Wn = !(Bv(Xt) && "chain" in Xt) || !!Xt.chain, zr = g2(ot);
              return Iy(cn, function(Qr) {
                var Ni2 = St[Qr];
                ot[Qr] = Ni2, zr && (ot.prototype[Qr] = function() {
                  var wo = this.__chain__;
                  if (Wn || wo) {
                    var vo = ot(this.__wrapped__), Lo = vo.__actions__ = B1(this.__actions__);
                    return Lo.push({ func: Ni2, args: arguments, thisArg: ot }), vo.__chain__ = wo, vo;
                  }
                  return Ni2.apply(ot, PI3([this.value()], arguments));
                });
              }), ot;
            }
            function Zut() {
              return Tg2._ === this && (Tg2._ = UY), this;
            }
            function $ut() {
            }
            function z2t(ot) {
              return ot = Ef2(ot), ch2(function(St) {
                return Olt(St, ot);
              });
            }
            var oWt = Wlt(Vv), nW = Wlt(elt), sWt = Wlt(LI);
            function Yut(ot) {
              return Qlt(ot) ? rlt(FI(ot)) : Rlt(ot);
            }
            function bR(ot) {
              return function(St) {
                return ot == null ? n3 : $4(ot, St);
              };
            }
            var _R = Bj2(), XK = Bj2(true);
            function U8() {
              return [];
            }
            function Kut() {
              return false;
            }
            function QK() {
              return {};
            }
            function lWt() {
              return "";
            }
            function uWt() {
              return true;
            }
            function cWt(ot, St) {
              if (ot = Ef2(ot), ot < 1 || ot > Xn)
                return [];
              var Xt = ci2, Ie2 = F1(ot, ci2);
              St = ec2(St), ot -= ci2;
              for (var cn = GY(Ie2, St); ++Xt < ot; )
                St(Xt);
              return cn;
            }
            function j2t(ot) {
              return af2(ot) ? Vv(ot, FI) : mx(ot) ? [ot] : B1(nut(Td2(ot)));
            }
            function q8(ot) {
              var St = ++mzt;
              return Td2(ot) + St;
            }
            var Xut = mK(function(ot, St) {
              return ot + St;
            }, 0), Qf2 = Glt("ceil"), tv = mK(function(ot, St) {
              return ot / St;
            }, 1), Z8 = Glt("floor");
            function A3(ot) {
              return ot && ot.length ? bk2(ot, bx, sK) : n3;
            }
            function W2t(ot, St) {
              return ot && ot.length ? bk2(ot, ec2(St, 2), sK) : n3;
            }
            function rW(ot) {
              return eSt(ot, bx);
            }
            function nT(ot, St) {
              return eSt(ot, ec2(St, 2));
            }
            function fWt(ot) {
              return ot && ot.length ? bk2(ot, bx, _M) : n3;
            }
            function JK(ot, St) {
              return ot && ot.length ? bk2(ot, ec2(St, 2), _M) : n3;
            }
            var tX = mK(function(ot, St) {
              return ot * St;
            }, 1), Qut = Glt("round"), hWt = mK(function(ot, St) {
              return ot - St;
            }, 0);
            function pWt(ot) {
              return ot && ot.length ? WY(ot, bx) : 0;
            }
            function dWt(ot, St) {
              return ot && ot.length ? WY(ot, ec2(St, 2)) : 0;
            }
            return kn.after = QSt, kn.ary = qm, kn.assign = Lut, kn.assignIn = x2t, kn.assignInWith = WK, kn.assignWith = Njt, kn.at = w2t, kn.before = JSt, kn.bind = S3, kn.bindAll = Gw, kn.bindKey = xut, kn.castArray = u2t, kn.chain = LK, kn.chunk = TK, kn.compact = aR, kn.concat = Xzt, kn.cond = nWt, kn.conforms = rWt, kn.constant = $K, kn.countBy = Uj2, kn.create = Fjt, kn.curry = wut, kn.curryRight = M3, kn.debounce = t2t, kn.defaults = vR, kn.defaultsDeep = Vjt, kn.defer = Djt, kn.delay = e2t, kn.difference = Qzt, kn.differenceBy = Jzt, kn.differenceWith = rut, kn.drop = tjt, kn.dropRight = iut, kn.dropRightWhile = WSt, kn.dropWhile = AK, kn.fill = aut, kn.filter = Ak, kn.flatMap = mjt, kn.flatMapDeep = bjt, kn.flatMapDepth = yx, kn.flatten = sut, kn.flattenDeep = ejt, kn.flattenDepth = njt, kn.flip = zf2, kn.flow = Hw, kn.flowRight = iWt, kn.fromPairs = rjt, kn.functions = Xj2, kn.functionsIn = zjt, kn.groupBy = _jt, kn.initial = ajt, kn.intersection = uut, kn.intersectionBy = ojt, kn.intersectionWith = sjt, kn.invert = jjt, kn.invertBy = W8, kn.invokeMap = wjt, kn.iteratee = YK, kn.keyBy = KSt, kn.keys = rm, kn.keysIn = jw, kn.map = OK, kn.mapKeys = M2t, kn.mapValues = Fut, kn.matches = KK, kn.matchesProperty = aWt, kn.memoize = Zj2, kn.merge = HK, kn.mergeWith = Qj2, kn.method = B2t, kn.methodOf = Uut, kn.mixin = qut, kn.negate = $j, kn.nthArg = z2t, kn.omit = Jj2, kn.omitBy = C2t, kn.once = Ejt, kn.orderBy = Sjt, kn.over = oWt, kn.overArgs = n2t, kn.overEvery = nW, kn.overSome = sWt, kn.partial = Sut, kn.partialRight = r2t, kn.partition = RK, kn.pick = Vut, kn.pickBy = But, kn.property = Yut, kn.propertyOf = bR, kn.pull = IK, kn.pullAll = fut, kn.pullAllBy = ujt, kn.pullAllWith = cjt, kn.pullAt = hut, kn.range = _R, kn.rangeRight = XK, kn.rearg = i2t, kn.reject = Cjt, kn.remove = put, kn.rest = a2t, kn.reverse = dut, kn.sampleSize = Tjt, kn.set = Gjt, kn.setWith = Hjt, kn.shuffle = XSt, kn.slice = SM, kn.sortBy = Ijt, kn.sortedUniq = EK, kn.sortedUniqBy = kK, kn.split = Kjt, kn.spread = o2t, kn.tail = PK, kn.take = HSt, kn.takeRight = USt, kn.takeRightWhile = qSt, kn.takeWhile = fjt, kn.tap = Hj2, kn.throttle = s2t, kn.thru = z8, kn.toArray = Eut, kn.toPairs = A2t, kn.toPairsIn = zut, kn.toPath = j2t, kn.toPlainObject = jK, kn.transform = I2t, kn.unary = kjt, kn.union = hjt, kn.unionBy = pjt, kn.unionWith = Cd2, kn.uniq = lR, kn.uniqBy = uR, kn.uniqWith = VI, kn.unset = D2t, kn.unzip = BI, kn.unzipWith = tT, kn.update = E2t, kn.updateWith = Ujt, kn.values = G8, kn.valuesIn = jut, kn.without = zI, kn.words = V2t, kn.wrap = l2t, kn.xor = yut, kn.xorBy = mut, kn.xorWith = cR, kn.zip = fR, kn.zipObject = Tk, kn.zipObjectDeep = but, kn.zipWith = b3, kn.entries = A2t, kn.entriesIn = zut, kn.extend = x2t, kn.extendWith = WK, qut(kn, kn), kn.add = Xut, kn.attempt = Hut, kn.camelCase = Zjt, kn.capitalize = Wut, kn.ceil = Qf2, kn.clamp = qjt, kn.clone = c2t, kn.cloneDeep = h2t, kn.cloneDeepWith = Mut, kn.cloneWith = f2t, kn.conformsTo = hh2, kn.deburr = UK, kn.defaultTo = Zm, kn.divide = tv, kn.endsWith = P2t, kn.eq = Pl, kn.escape = Gut, kn.escapeRegExp = mR, kn.every = yjt, kn.find = w3, kn.findIndex = GSt, kn.findKey = f0, kn.findLast = hR, kn.findLastIndex = out2, kn.findLastKey = Out, kn.floor = Z8, kn.forEach = d22, kn.forEachRight = YSt, kn.forIn = S2t, kn.forInRight = Bjt, kn.forOwn = z1, kn.forOwnRight = yR, kn.get = Rut, kn.gt = Cut, kn.gte = p2t, kn.has = Nut, kn.hasIn = GK, kn.head = lut, kn.identity = bx, kn.includes = xjt, kn.indexOf = ijt, kn.inRange = k2t, kn.invoke = Wjt, kn.isArguments = C3, kn.isArray = af2, kn.isArrayBuffer = Tut, kn.isArrayLike = jb2, kn.isArrayLikeObject = xv, kn.isBoolean = FK, kn.isBuffer = k0, kn.isDate = Yj2, kn.isElement = j8, kn.isEmpty = Pjt, kn.isEqual = pR, kn.isEqualWith = VK, kn.isError = dR, kn.isFinite = BK, kn.isFunction = g2, kn.isInteger = gR, kn.isLength = Kj2, kn.isMap = Aut, kn.isMatch = d2t, kn.isMatchWith = Iut, kn.isNaN = g2t, kn.isNative = Ljt, kn.isNil = v2t, kn.isNull = Ojt, kn.isNumber = WI, kn.isObject = Bv, kn.isObjectLike = wv, kn.isPlainObject = T3, kn.isRegExp = Dut, kn.isSafeInteger = Rjt, kn.isSet = y2t, kn.isString = zK, kn.isSymbol = mx, kn.isTypedArray = MM, kn.isUndefined = m2t, kn.isWeakMap = b2t, kn.isWeakSet = GI, kn.join = ljt, kn.kebabCase = H8, kn.last = p22, kn.lastIndexOf = cut, kn.lowerCase = $jt, kn.lowerFirst = Wb2, kn.lt = HI, kn.lte = _2t, kn.max = A3, kn.maxBy = W2t, kn.mean = rW, kn.meanBy = nT, kn.min = fWt, kn.minBy = JK, kn.stubArray = U8, kn.stubFalse = Kut, kn.stubObject = QK, kn.stubString = lWt, kn.stubTrue = uWt, kn.multiply = tX, kn.nth = oR, kn.noConflict = Zut, kn.noop = $ut, kn.now = NK, kn.pad = L2t, kn.padEnd = tW, kn.padStart = eW, kn.parseInt = ZI, kn.random = qI, kn.reduce = Mjt, kn.reduceRight = _ut, kn.repeat = eT, kn.replace = Yjt, kn.result = T2t, kn.round = Qut, kn.runInContext = wi2, kn.sample = Tc2, kn.size = qj2, kn.snakeCase = qK, kn.some = Ajt, kn.sortedIndex = Bw, kn.sortedIndexBy = zw, kn.sortedIndexOf = gut, kn.sortedLastIndex = vut, kn.sortedLastIndexBy = sR, kn.sortedLastIndexOf = DK, kn.startCase = Xjt, kn.startsWith = Qjt, kn.subtract = hWt, kn.sum = pWt, kn.sumBy = dWt, kn.template = O2t, kn.times = cWt, kn.toFinite = UI, kn.toInteger = Ef2, kn.toLength = kut, kn.toLower = Ww, kn.toNumber = v22, kn.toSafeInteger = Put, kn.toString = Td2, kn.toUpper = Jjt, kn.trim = R2t, kn.trimEnd = ZK, kn.trimStart = tWt, kn.truncate = N2t, kn.unescape = eWt, kn.uniqueId = q8, kn.upperCase = F2t, kn.upperFirst = Gb2, kn.each = d22, kn.eachRight = YSt, kn.first = lut, qut(kn, function() {
              var ot = {};
              return ZC(kn, function(St, Xt) {
                Md2.call(kn.prototype, Xt) || (ot[Xt] = St);
              }), ot;
            }(), { chain: false }), kn.VERSION = p2, Iy(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(ot) {
              kn[ot].placeholder = kn;
            }), Iy(["drop", "take"], function(ot, St) {
              up.prototype[ot] = function(Xt) {
                Xt = Xt === n3 ? 1 : u0(Ef2(Xt), 0);
                var Ie2 = this.__filtered__ && !St ? new up(this) : this.clone();
                return Ie2.__filtered__ ? Ie2.__takeCount__ = F1(Xt, Ie2.__takeCount__) : Ie2.__views__.push({ size: F1(Xt, ci2), type: ot + (Ie2.__dir__ < 0 ? "Right" : "") }), Ie2;
              }, up.prototype[ot + "Right"] = function(Xt) {
                return this.reverse()[ot](Xt).reverse();
              };
            }), Iy(["filter", "map", "takeWhile"], function(ot, St) {
              var Xt = St + 1, Ie2 = Xt == Tn || Xt == bn;
              up.prototype[ot] = function(cn) {
                var Wn = this.clone();
                return Wn.__iteratees__.push({ iteratee: ec2(cn, 3), type: Xt }), Wn.__filtered__ = Wn.__filtered__ || Ie2, Wn;
              };
            }), Iy(["head", "last"], function(ot, St) {
              var Xt = "take" + (St ? "Right" : "");
              up.prototype[ot] = function() {
                return this[Xt](1).value()[0];
              };
            }), Iy(["initial", "tail"], function(ot, St) {
              var Xt = "drop" + (St ? "" : "Right");
              up.prototype[ot] = function() {
                return this.__filtered__ ? new up(this) : this[Xt](1);
              };
            }), up.prototype.compact = function() {
              return this.filter(bx);
            }, up.prototype.find = function(ot) {
              return this.filter(ot).head();
            }, up.prototype.findLast = function(ot) {
              return this.reverse().find(ot);
            }, up.prototype.invokeMap = ch2(function(ot, St) {
              return typeof ot == "function" ? new up(this) : this.map(function(Xt) {
                return c3(Xt, ot, St);
              });
            }), up.prototype.reject = function(ot) {
              return this.filter($j(ec2(ot)));
            }, up.prototype.slice = function(ot, St) {
              ot = Ef2(ot);
              var Xt = this;
              return Xt.__filtered__ && (ot > 0 || St < 0) ? new up(Xt) : (ot < 0 ? Xt = Xt.takeRight(-ot) : ot && (Xt = Xt.drop(ot)), St !== n3 && (St = Ef2(St), Xt = St < 0 ? Xt.dropRight(-St) : Xt.take(St - ot)), Xt);
            }, up.prototype.takeRightWhile = function(ot) {
              return this.reverse().takeWhile(ot).reverse();
            }, up.prototype.toArray = function() {
              return this.take(ci2);
            }, ZC(up.prototype, function(ot, St) {
              var Xt = /^(?:filter|find|map|reject)|While$/.test(St), Ie2 = /^(?:head|last)$/.test(St), cn = kn[Ie2 ? "take" + (St == "last" ? "Right" : "") : St], Wn = Ie2 || /^find/.test(St);
              !cn || (kn.prototype[St] = function() {
                var zr = this.__wrapped__, Qr = Ie2 ? [1] : arguments, Ni2 = zr instanceof up, wo = Qr[0], vo = Ni2 || af2(zr), Lo = function(Kh2) {
                  var ph2 = cn.apply(kn, PI3([Kh2], Qr));
                  return Ie2 && Ks ? ph2[0] : ph2;
                };
                vo && Xt && typeof wo == "function" && wo.length != 1 && (Ni2 = vo = false);
                var Ks = this.__chain__, yu = !!this.__actions__.length, gc2 = Wn && !Ks, of2 = Ni2 && !yu;
                if (!Wn && vo) {
                  zr = of2 ? zr : new up(this);
                  var uc2 = ot.apply(zr, Qr);
                  return uc2.__actions__.push({ func: z8, args: [Lo], thisArg: n3 }), new Rw(uc2, Ks);
                }
                return gc2 && of2 ? ot.apply(this, Qr) : (uc2 = this.thru(Lo), gc2 ? Ie2 ? uc2.value()[0] : uc2.value() : uc2);
              });
            }), Iy(["pop", "push", "shift", "sort", "splice", "unshift"], function(ot) {
              var St = Vb2[ot], Xt = /^(?:push|sort|unshift)$/.test(ot) ? "tap" : "thru", Ie2 = /^(?:pop|shift)$/.test(ot);
              kn.prototype[ot] = function() {
                var cn = arguments;
                if (Ie2 && !this.__chain__) {
                  var Wn = this.value();
                  return St.apply(af2(Wn) ? Wn : [], cn);
                }
                return this[Xt](function(zr) {
                  return St.apply(af2(zr) ? zr : [], cn);
                });
              };
            }), ZC(up.prototype, function(ot, St) {
              var Xt = kn[St];
              if (Xt) {
                var Ie2 = Xt.name + "";
                Md2.call(O8, Ie2) || (O8[Ie2] = []), O8[Ie2].push({ name: St, func: Xt });
              }
            }), O8[yK(n3, At).name] = [{ name: "wrapper", func: n3 }], up.prototype.clone = wlt, up.prototype.reverse = Slt, up.prototype.value = Szt, kn.prototype.at = djt, kn.prototype.chain = gjt, kn.prototype.commit = jI, kn.prototype.next = _3, kn.prototype.plant = ZSt, kn.prototype.reverse = $St, kn.prototype.toJSON = kn.prototype.valueOf = kn.prototype.value = x3, kn.prototype.first = kn.prototype.head, vM && (kn.prototype[vM] = vjt), kn;
          }, G4 = vzt();
          DI ? ((DI.exports = G4)._ = G4, BY._ = G4) : Tg2._ = G4;
        }).call(Je2);
      })(Cwt, Cwt.exports);
      class pMe {
        constructor() {
          D2(this, "subscriptions", /* @__PURE__ */ new Map()), D2(this, "emitEffectCache", /* @__PURE__ */ new Map()), D2(this, "useSubscription", (o, n3) => {
            const p2 = L.useRef();
            L.useEffect(() => {
              var m2, w2;
              p2.current = n3;
              function T2(O2) {
                p2.current && p2.current(O2);
              }
              const E = (w2 = (m2 = this.subscriptions) == null ? void 0 : m2.get(o)) != null ? w2 : [];
              return E.push(T2), this.subscriptions.set(o, E), this.emitEffect(o), () => {
                this.subscriptions.delete(o);
              };
            });
          }), D2(this, "emit", (o, ...n3) => {
            if (typeof o == "string" || typeof o == "number") {
              const p2 = this.subscriptions.get(o);
              p2 == null || p2.forEach((m2) => {
                m2 == null || m2({ params: Cwt.exports.cloneDeep(n3), event: o });
              }), this.emitEffectCache.set(o, { params: Cwt.exports.cloneDeep(n3), event: o });
            } else
              throw new TypeError("event must be string or number !");
          }), D2(this, "emitEffect", (o) => {
            const n3 = this.emitEffectCache.get(o), p2 = this.subscriptions.get(o);
            n3 && (p2 == null || p2.forEach((m2) => {
              m2 == null || m2(C({}, n3));
            }));
          }), D2(this, "removeListener", (o) => {
            this.subscriptions.delete(o);
          }), D2(this, "clear", () => {
            this.subscriptions.clear();
          }), this.clear();
        }
      }
      const hOn = new pMe();
      function Twt(u) {
        const o = L.useRef(), n3 = L.useMemo(() => u != null ? u : { global: false }, [u]);
        return o.current || (o.current = n3.global ? o.current = hOn : o.current = new pMe()), L.useEffect(() => () => {
          var p2;
          return (p2 = o.current) == null ? void 0 : p2.clear();
        }, []), o.current;
      }
      const gBt = ({ id: u, title: o, chart: n3, option: p2 }, m2) => {
        const w2 = L.useRef(fOn), T2 = Twt({ global: true });
        return to(() => {
          console.log("id", u), console.log("chart", n3 == null ? void 0 : n3.current), w2.current && (n3 == null ? void 0 : n3.current) && u && p2 && (w2.current.add(u, n3 == null ? void 0 : n3.current, p2, o), T2.emit("list"));
        }, m2 != null ? m2 : [], { wait: 100 }), { tool: w2.current };
      };
      var pOn = L.createContext({}), dMe = pOn;
      function Yd2(u, o, n3) {
        return o in u ? Object.defineProperty(u, o, { value: n3, enumerable: true, configurable: true, writable: true }) : u[o] = n3, u;
      }
      function gMe(u, o) {
        var n3 = Object.keys(u);
        if (Object.getOwnPropertySymbols) {
          var p2 = Object.getOwnPropertySymbols(u);
          o && (p2 = p2.filter(function(m2) {
            return Object.getOwnPropertyDescriptor(u, m2).enumerable;
          })), n3.push.apply(n3, p2);
        }
        return n3;
      }
      function mf2(u) {
        for (var o = 1; o < arguments.length; o++) {
          var n3 = arguments[o] != null ? arguments[o] : {};
          o % 2 ? gMe(Object(n3), true).forEach(function(p2) {
            Yd2(u, p2, n3[p2]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(u, Object.getOwnPropertyDescriptors(n3)) : gMe(Object(n3)).forEach(function(p2) {
            Object.defineProperty(u, p2, Object.getOwnPropertyDescriptor(n3, p2));
          });
        }
        return u;
      }
      function vMe(u) {
        if (Array.isArray(u))
          return u;
      }
      function dOn(u, o) {
        var n3 = u == null ? null : typeof Symbol != "undefined" && u[Symbol.iterator] || u["@@iterator"];
        if (n3 != null) {
          var p2 = [], m2 = true, w2 = false, T2, E;
          try {
            for (n3 = n3.call(u); !(m2 = (T2 = n3.next()).done) && (p2.push(T2.value), !(o && p2.length === o)); m2 = true)
              ;
          } catch (O2) {
            w2 = true, E = O2;
          } finally {
            try {
              !m2 && n3.return != null && n3.return();
            } finally {
              if (w2)
                throw E;
            }
          }
          return p2;
        }
      }
      function vBt(u, o) {
        (o == null || o > u.length) && (o = u.length);
        for (var n3 = 0, p2 = new Array(o); n3 < o; n3++)
          p2[n3] = u[n3];
        return p2;
      }
      function yBt(u, o) {
        if (u) {
          if (typeof u == "string")
            return vBt(u, o);
          var n3 = Object.prototype.toString.call(u).slice(8, -1);
          if (n3 === "Object" && u.constructor && (n3 = u.constructor.name), n3 === "Map" || n3 === "Set")
            return Array.from(u);
          if (n3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n3))
            return vBt(u, o);
        }
      }
      function yMe() {
        throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function wI(u, o) {
        return vMe(u) || dOn(u, o) || yBt(u, o) || yMe();
      }
      function gOn(u, o) {
        if (u == null)
          return {};
        var n3 = {}, p2 = Object.keys(u), m2, w2;
        for (w2 = 0; w2 < p2.length; w2++)
          m2 = p2[w2], !(o.indexOf(m2) >= 0) && (n3[m2] = u[m2]);
        return n3;
      }
      function kY(u, o) {
        if (u == null)
          return {};
        var n3 = gOn(u, o), p2, m2;
        if (Object.getOwnPropertySymbols) {
          var w2 = Object.getOwnPropertySymbols(u);
          for (m2 = 0; m2 < w2.length; m2++)
            p2 = w2[m2], !(o.indexOf(p2) >= 0) && (!Object.prototype.propertyIsEnumerable.call(u, p2) || (n3[p2] = u[p2]));
        }
        return n3;
      }
      var mMe = { exports: {} };
      /*!
        Copyright (c) 2018 Jed Watson.
        Licensed under the MIT License (MIT), see
        http://jedwatson.github.io/classnames
      */
      (function(u) {
        (function() {
          var o = {}.hasOwnProperty;
          function n3() {
            for (var p2 = [], m2 = 0; m2 < arguments.length; m2++) {
              var w2 = arguments[m2];
              if (w2) {
                var T2 = typeof w2;
                if (T2 === "string" || T2 === "number")
                  p2.push(w2);
                else if (Array.isArray(w2)) {
                  if (w2.length) {
                    var E = n3.apply(null, w2);
                    E && p2.push(E);
                  }
                } else if (T2 === "object")
                  if (w2.toString === Object.prototype.toString)
                    for (var O2 in w2)
                      o.call(w2, O2) && w2[O2] && p2.push(O2);
                  else
                    p2.push(w2.toString());
              }
            }
            return p2.join(" ");
          }
          u.exports ? (n3.default = n3, u.exports = n3) : window.classNames = n3;
        })();
      })(mMe);
      var PY = mMe.exports;
      function Ew(u) {
        return Ew = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o) {
          return typeof o;
        } : function(o) {
          return o && typeof Symbol == "function" && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
        }, Ew(u);
      }
      function SI(u, o) {
        vOn(u) && (u = "100%");
        var n3 = yOn(u);
        return u = o === 360 ? u : Math.min(o, Math.max(0, parseFloat(u))), n3 && (u = parseInt(String(u * o), 10) / 100), Math.abs(u - o) < 1e-6 ? 1 : (o === 360 ? u = (u < 0 ? u % o + o : u % o) / parseFloat(String(o)) : u = u % o / parseFloat(String(o)), u);
      }
      function vOn(u) {
        return typeof u == "string" && u.indexOf(".") !== -1 && parseFloat(u) === 1;
      }
      function yOn(u) {
        return typeof u == "string" && u.indexOf("%") !== -1;
      }
      function mOn(u) {
        return u = parseFloat(u), (isNaN(u) || u < 0 || u > 1) && (u = 1), u;
      }
      function Awt(u) {
        return u <= 1 ? Number(u) * 100 + "%" : u;
      }
      function mBt(u) {
        return u.length === 1 ? "0" + u : String(u);
      }
      function bOn(u, o, n3) {
        return { r: SI(u, 255) * 255, g: SI(o, 255) * 255, b: SI(n3, 255) * 255 };
      }
      function bBt(u, o, n3) {
        return n3 < 0 && (n3 += 1), n3 > 1 && (n3 -= 1), n3 < 1 / 6 ? u + (o - u) * (6 * n3) : n3 < 1 / 2 ? o : n3 < 2 / 3 ? u + (o - u) * (2 / 3 - n3) * 6 : u;
      }
      function _On(u, o, n3) {
        var p2, m2, w2;
        if (u = SI(u, 360), o = SI(o, 100), n3 = SI(n3, 100), o === 0)
          m2 = n3, w2 = n3, p2 = n3;
        else {
          var T2 = n3 < 0.5 ? n3 * (1 + o) : n3 + o - n3 * o, E = 2 * n3 - T2;
          p2 = bBt(E, T2, u + 1 / 3), m2 = bBt(E, T2, u), w2 = bBt(E, T2, u - 1 / 3);
        }
        return { r: p2 * 255, g: m2 * 255, b: w2 * 255 };
      }
      function xOn(u, o, n3) {
        u = SI(u, 255), o = SI(o, 255), n3 = SI(n3, 255);
        var p2 = Math.max(u, o, n3), m2 = Math.min(u, o, n3), w2 = 0, T2 = p2, E = p2 - m2, O2 = p2 === 0 ? 0 : E / p2;
        if (p2 === m2)
          w2 = 0;
        else {
          switch (p2) {
            case u:
              w2 = (o - n3) / E + (o < n3 ? 6 : 0);
              break;
            case o:
              w2 = (n3 - u) / E + 2;
              break;
            case n3:
              w2 = (u - o) / E + 4;
              break;
          }
          w2 /= 6;
        }
        return { h: w2, s: O2, v: T2 };
      }
      function wOn(u, o, n3) {
        u = SI(u, 360) * 6, o = SI(o, 100), n3 = SI(n3, 100);
        var p2 = Math.floor(u), m2 = u - p2, w2 = n3 * (1 - o), T2 = n3 * (1 - m2 * o), E = n3 * (1 - (1 - m2) * o), O2 = p2 % 6, V3 = [n3, T2, w2, w2, E, n3][O2], W3 = [E, n3, n3, T2, w2, w2][O2], q3 = [w2, w2, E, n3, n3, T2][O2];
        return { r: V3 * 255, g: W3 * 255, b: q3 * 255 };
      }
      function SOn(u, o, n3, p2) {
        var m2 = [mBt(Math.round(u).toString(16)), mBt(Math.round(o).toString(16)), mBt(Math.round(n3).toString(16))];
        return p2 && m2[0].startsWith(m2[0].charAt(1)) && m2[1].startsWith(m2[1].charAt(1)) && m2[2].startsWith(m2[2].charAt(1)) ? m2[0].charAt(0) + m2[1].charAt(0) + m2[2].charAt(0) : m2.join("");
      }
      function bMe(u) {
        return LC(u) / 255;
      }
      function LC(u) {
        return parseInt(u, 16);
      }
      var _Me = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
      function Rst(u) {
        var o = { r: 0, g: 0, b: 0 }, n3 = 1, p2 = null, m2 = null, w2 = null, T2 = false, E = false;
        return typeof u == "string" && (u = TOn(u)), typeof u == "object" && (R4(u.r) && R4(u.g) && R4(u.b) ? (o = bOn(u.r, u.g, u.b), T2 = true, E = String(u.r).substr(-1) === "%" ? "prgb" : "rgb") : R4(u.h) && R4(u.s) && R4(u.v) ? (p2 = Awt(u.s), m2 = Awt(u.v), o = wOn(u.h, p2, m2), T2 = true, E = "hsv") : R4(u.h) && R4(u.s) && R4(u.l) && (p2 = Awt(u.s), w2 = Awt(u.l), o = _On(u.h, p2, w2), T2 = true, E = "hsl"), Object.prototype.hasOwnProperty.call(u, "a") && (n3 = u.a)), n3 = mOn(n3), { ok: T2, format: u.format || E, r: Math.min(255, Math.max(o.r, 0)), g: Math.min(255, Math.max(o.g, 0)), b: Math.min(255, Math.max(o.b, 0)), a: n3 };
      }
      var MOn = "[-\\+]?\\d+%?", COn = "[-\\+]?\\d*\\.\\d+%?", M8 = "(?:" + COn + ")|(?:" + MOn + ")", _Bt = "[\\s|\\(]+(" + M8 + ")[,|\\s]+(" + M8 + ")[,|\\s]+(" + M8 + ")\\s*\\)?", xBt = "[\\s|\\(]+(" + M8 + ")[,|\\s]+(" + M8 + ")[,|\\s]+(" + M8 + ")[,|\\s]+(" + M8 + ")\\s*\\)?", lk2 = { CSS_UNIT: new RegExp(M8), rgb: new RegExp("rgb" + _Bt), rgba: new RegExp("rgba" + xBt), hsl: new RegExp("hsl" + _Bt), hsla: new RegExp("hsla" + xBt), hsv: new RegExp("hsv" + _Bt), hsva: new RegExp("hsva" + xBt), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
      function TOn(u) {
        if (u = u.trim().toLowerCase(), u.length === 0)
          return false;
        var o = false;
        if (_Me[u])
          u = _Me[u], o = true;
        else if (u === "transparent")
          return { r: 0, g: 0, b: 0, a: 0, format: "name" };
        var n3 = lk2.rgb.exec(u);
        return n3 ? { r: n3[1], g: n3[2], b: n3[3] } : (n3 = lk2.rgba.exec(u), n3 ? { r: n3[1], g: n3[2], b: n3[3], a: n3[4] } : (n3 = lk2.hsl.exec(u), n3 ? { h: n3[1], s: n3[2], l: n3[3] } : (n3 = lk2.hsla.exec(u), n3 ? { h: n3[1], s: n3[2], l: n3[3], a: n3[4] } : (n3 = lk2.hsv.exec(u), n3 ? { h: n3[1], s: n3[2], v: n3[3] } : (n3 = lk2.hsva.exec(u), n3 ? { h: n3[1], s: n3[2], v: n3[3], a: n3[4] } : (n3 = lk2.hex8.exec(u), n3 ? { r: LC(n3[1]), g: LC(n3[2]), b: LC(n3[3]), a: bMe(n3[4]), format: o ? "name" : "hex8" } : (n3 = lk2.hex6.exec(u), n3 ? { r: LC(n3[1]), g: LC(n3[2]), b: LC(n3[3]), format: o ? "name" : "hex" } : (n3 = lk2.hex4.exec(u), n3 ? { r: LC(n3[1] + n3[1]), g: LC(n3[2] + n3[2]), b: LC(n3[3] + n3[3]), a: bMe(n3[4] + n3[4]), format: o ? "name" : "hex8" } : (n3 = lk2.hex3.exec(u), n3 ? { r: LC(n3[1] + n3[1]), g: LC(n3[2] + n3[2]), b: LC(n3[3] + n3[3]), format: o ? "name" : "hex" } : false)))))))));
      }
      function R4(u) {
        return Boolean(lk2.CSS_UNIT.exec(String(u)));
      }
      var Iwt = 2, xMe = 0.16, AOn = 0.05, IOn = 0.05, DOn = 0.15, wMe = 5, SMe = 4, EOn = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
      function MMe(u) {
        var o = u.r, n3 = u.g, p2 = u.b, m2 = xOn(o, n3, p2);
        return { h: m2.h * 360, s: m2.s, v: m2.v };
      }
      function Dwt(u) {
        var o = u.r, n3 = u.g, p2 = u.b;
        return "#".concat(SOn(o, n3, p2, false));
      }
      function kOn(u, o, n3) {
        var p2 = n3 / 100, m2 = { r: (o.r - u.r) * p2 + u.r, g: (o.g - u.g) * p2 + u.g, b: (o.b - u.b) * p2 + u.b };
        return m2;
      }
      function CMe(u, o, n3) {
        var p2;
        return Math.round(u.h) >= 60 && Math.round(u.h) <= 240 ? p2 = n3 ? Math.round(u.h) - Iwt * o : Math.round(u.h) + Iwt * o : p2 = n3 ? Math.round(u.h) + Iwt * o : Math.round(u.h) - Iwt * o, p2 < 0 ? p2 += 360 : p2 >= 360 && (p2 -= 360), p2;
      }
      function TMe(u, o, n3) {
        if (u.h === 0 && u.s === 0)
          return u.s;
        var p2;
        return n3 ? p2 = u.s - xMe * o : o === SMe ? p2 = u.s + xMe : p2 = u.s + AOn * o, p2 > 1 && (p2 = 1), n3 && o === wMe && p2 > 0.1 && (p2 = 0.1), p2 < 0.06 && (p2 = 0.06), Number(p2.toFixed(2));
      }
      function AMe(u, o, n3) {
        var p2;
        return n3 ? p2 = u.v + IOn * o : p2 = u.v - DOn * o, p2 > 1 && (p2 = 1), Number(p2.toFixed(2));
      }
      function wBt(u) {
        for (var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n3 = [], p2 = Rst(u), m2 = wMe; m2 > 0; m2 -= 1) {
          var w2 = MMe(p2), T2 = Dwt(Rst({ h: CMe(w2, m2, true), s: TMe(w2, m2, true), v: AMe(w2, m2, true) }));
          n3.push(T2);
        }
        n3.push(Dwt(p2));
        for (var E = 1; E <= SMe; E += 1) {
          var O2 = MMe(p2), V3 = Dwt(Rst({ h: CMe(O2, E), s: TMe(O2, E), v: AMe(O2, E) }));
          n3.push(V3);
        }
        return o.theme === "dark" ? EOn.map(function(W3) {
          var q3 = W3.index, K = W3.opacity, J = Dwt(kOn(Rst(o.backgroundColor || "#141414"), Rst(n3[q3]), K * 100));
          return J;
        }) : n3;
      }
      var SBt = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, kw = {}, MBt = {};
      Object.keys(SBt).forEach(function(u) {
        kw[u] = wBt(SBt[u]), kw[u].primary = kw[u][5], MBt[u] = wBt(SBt[u], { theme: "dark", backgroundColor: "#141414" }), MBt[u].primary = MBt[u][5];
      }), kw.red, kw.volcano, kw.gold, kw.orange, kw.yellow, kw.lime, kw.green, kw.cyan, kw.blue, kw.geekblue, kw.purple, kw.magenta, kw.grey;
      var IMe = {};
      function POn(u, o) {
      }
      function LOn(u, o, n3) {
        !o && !IMe[n3] && (u(false, n3), IMe[n3] = true);
      }
      function e3(u, o) {
        LOn(POn, u, o);
      }
      function DMe() {
        return !!(typeof window != "undefined" && window.document && window.document.createElement);
      }
      var OOn = "rc-util-key";
      function EMe() {
        var u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, o = u.mark;
        return o ? o.startsWith("data-") ? o : "data-".concat(o) : OOn;
      }
      function CBt(u) {
        if (u.attachTo)
          return u.attachTo;
        var o = document.querySelector("head");
        return o || document.body;
      }
      function kMe(u) {
        var o, n3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        if (!DMe())
          return null;
        var p2 = document.createElement("style");
        if (!((o = n3.csp) === null || o === void 0) && o.nonce) {
          var m2;
          p2.nonce = (m2 = n3.csp) === null || m2 === void 0 ? void 0 : m2.nonce;
        }
        p2.innerHTML = u;
        var w2 = CBt(n3), T2 = w2.firstChild;
        return n3.prepend && w2.prepend ? w2.prepend(p2) : n3.prepend && T2 ? w2.insertBefore(p2, T2) : w2.appendChild(p2), p2;
      }
      var TBt = /* @__PURE__ */ new Map();
      function ROn(u) {
        var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n3 = CBt(o);
        return Array.from(TBt.get(n3).children).find(function(p2) {
          return p2.tagName === "STYLE" && p2.getAttribute(EMe(o)) === u;
        });
      }
      function PMe(u, o) {
        var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, p2 = CBt(n3);
        if (!TBt.has(p2)) {
          var m2 = kMe("", n3), w2 = m2.parentNode;
          TBt.set(p2, w2), w2.removeChild(m2);
        }
        var T2 = ROn(o, n3);
        if (T2) {
          var E, O2;
          if (((E = n3.csp) === null || E === void 0 ? void 0 : E.nonce) && T2.nonce !== ((O2 = n3.csp) === null || O2 === void 0 ? void 0 : O2.nonce)) {
            var V3;
            T2.nonce = (V3 = n3.csp) === null || V3 === void 0 ? void 0 : V3.nonce;
          }
          return T2.innerHTML !== u && (T2.innerHTML = u), T2;
        }
        var W3 = kMe(u, n3);
        return W3.setAttribute(EMe(n3), o), W3;
      }
      function NOn(u, o) {
        e3(u, "[@ant-design/icons] ".concat(o));
      }
      function LMe(u) {
        return Ew(u) === "object" && typeof u.name == "string" && typeof u.theme == "string" && (Ew(u.icon) === "object" || typeof u.icon == "function");
      }
      function OMe() {
        var u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
        return Object.keys(u).reduce(function(o, n3) {
          var p2 = u[n3];
          switch (n3) {
            case "class":
              o.className = p2, delete o.class;
              break;
            default:
              o[n3] = p2;
          }
          return o;
        }, {});
      }
      function ABt(u, o, n3) {
        return n3 ? U3.default.createElement(u.tag, mf2(mf2({ key: o }, OMe(u.attrs)), n3), (u.children || []).map(function(p2, m2) {
          return ABt(p2, "".concat(o, "-").concat(u.tag, "-").concat(m2));
        })) : U3.default.createElement(u.tag, mf2({ key: o }, OMe(u.attrs)), (u.children || []).map(function(p2, m2) {
          return ABt(p2, "".concat(o, "-").concat(u.tag, "-").concat(m2));
        }));
      }
      function RMe(u) {
        return wBt(u)[0];
      }
      function NMe(u) {
        return u ? Array.isArray(u) ? u : [u] : [];
      }
      var FOn = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, VOn = function() {
        var u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : FOn, o = L.useContext(dMe), n3 = o.csp;
        L.useEffect(function() {
          PMe(u, "@ant-design-icons", { prepend: true, csp: n3 });
        }, []);
      }, BOn = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], Nst = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
      function zOn(u) {
        var o = u.primaryColor, n3 = u.secondaryColor;
        Nst.primaryColor = o, Nst.secondaryColor = n3 || RMe(o), Nst.calculated = !!n3;
      }
      function jOn() {
        return mf2({}, Nst);
      }
      var Ewt = function(u) {
        var o = u.icon, n3 = u.className, p2 = u.onClick, m2 = u.style, w2 = u.primaryColor, T2 = u.secondaryColor, E = kY(u, BOn), O2 = Nst;
        if (w2 && (O2 = { primaryColor: w2, secondaryColor: T2 || RMe(w2) }), VOn(), NOn(LMe(o), "icon should be icon definiton, but got ".concat(o)), !LMe(o))
          return null;
        var V3 = o;
        return V3 && typeof V3.icon == "function" && (V3 = mf2(mf2({}, V3), {}, { icon: V3.icon(O2.primaryColor, O2.secondaryColor) })), ABt(V3.icon, "svg-".concat(V3.name), mf2({ className: n3, onClick: p2, style: m2, "data-icon": V3.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, E));
      };
      Ewt.displayName = "IconReact", Ewt.getTwoToneColors = jOn, Ewt.setTwoToneColors = zOn;
      var IBt = Ewt;
      function FMe(u) {
        var o = NMe(u), n3 = wI(o, 2), p2 = n3[0], m2 = n3[1];
        return IBt.setTwoToneColors({ primaryColor: p2, secondaryColor: m2 });
      }
      function WOn() {
        var u = IBt.getTwoToneColors();
        return u.calculated ? [u.primaryColor, u.secondaryColor] : u.primaryColor;
      }
      var GOn = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
      FMe("#1890ff");
      var kwt = Y3.forwardRef(function(u, o) {
        var n3, p2 = u.className, m2 = u.icon, w2 = u.spin, T2 = u.rotate, E = u.tabIndex, O2 = u.onClick, V3 = u.twoToneColor, W3 = kY(u, GOn), q3 = Y3.useContext(dMe), K = q3.prefixCls, J = K === void 0 ? "anticon" : K, rt2 = PY(J, (n3 = {}, Yd2(n3, "".concat(J, "-").concat(m2.name), !!m2.name), Yd2(n3, "".concat(J, "-spin"), !!w2 || m2.name === "loading"), n3), p2), gt = E;
        gt === void 0 && O2 && (gt = -1);
        var yt = T2 ? { msTransform: "rotate(".concat(T2, "deg)"), transform: "rotate(".concat(T2, "deg)") } : void 0, At = NMe(V3), Lt = wI(At, 2), Wt = Lt[0], Nt = Lt[1];
        return Y3.createElement("span", mf2(mf2({ role: "img", "aria-label": m2.name }, W3), {}, { ref: o, tabIndex: gt, onClick: O2, className: rt2 }), Y3.createElement(IBt, { icon: m2, primaryColor: Wt, secondaryColor: Nt, style: yt }));
      });
      kwt.displayName = "AntdIcon", kwt.getTwoToneColor = WOn, kwt.setTwoToneColor = FMe;
      var HOn = kwt, UOn = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, qOn = UOn, VMe = function(u, o) {
        return Y3.createElement(HOn, mf2(mf2({}, u), {}, { ref: o, icon: qOn }));
      };
      VMe.displayName = "LoadingOutlined";
      var ZOn = Y3.forwardRef(VMe);
      function zm() {
        return zm = Object.assign || function(u) {
          for (var o = 1; o < arguments.length; o++) {
            var n3 = arguments[o];
            for (var p2 in n3)
              Object.prototype.hasOwnProperty.call(n3, p2) && (u[p2] = n3[p2]);
          }
          return u;
        }, zm.apply(this, arguments);
      }
      function Fst(u, o) {
        if (!(u instanceof o))
          throw new TypeError("Cannot call a class as a function");
      }
      function BMe(u, o) {
        for (var n3 = 0; n3 < o.length; n3++) {
          var p2 = o[n3];
          p2.enumerable = p2.enumerable || false, p2.configurable = true, "value" in p2 && (p2.writable = true), Object.defineProperty(u, p2.key, p2);
        }
      }
      function Vst(u, o, n3) {
        return o && BMe(u.prototype, o), n3 && BMe(u, n3), Object.defineProperty(u, "prototype", { writable: false }), u;
      }
      function DBt(u, o) {
        return DBt = Object.setPrototypeOf || function(n3, p2) {
          return n3.__proto__ = p2, n3;
        }, DBt(u, o);
      }
      function EBt(u, o) {
        if (typeof o != "function" && o !== null)
          throw new TypeError("Super expression must either be null or a function");
        u.prototype = Object.create(o && o.prototype, { constructor: { value: u, writable: true, configurable: true } }), Object.defineProperty(u, "prototype", { writable: false }), o && DBt(u, o);
      }
      function Pwt(u) {
        return Pwt = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
          return o.__proto__ || Object.getPrototypeOf(o);
        }, Pwt(u);
      }
      function $On() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function kBt(u) {
        if (u === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return u;
      }
      function YOn(u, o) {
        if (o && (Ew(o) === "object" || typeof o == "function"))
          return o;
        if (o !== void 0)
          throw new TypeError("Derived constructors may only return object or undefined");
        return kBt(u);
      }
      function PBt(u) {
        var o = $On();
        return function() {
          var n3 = Pwt(u), p2;
          if (o) {
            var m2 = Pwt(this).constructor;
            p2 = Reflect.construct(n3, arguments, m2);
          } else
            p2 = n3.apply(this, arguments);
          return YOn(this, p2);
        };
      }
      var LBt = { exports: {} }, Sg2 = {};
      /** @license React v16.13.1
      * react-is.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var Ob2 = typeof Symbol == "function" && Symbol.for, OBt = Ob2 ? Symbol.for("react.element") : 60103, RBt = Ob2 ? Symbol.for("react.portal") : 60106, Lwt = Ob2 ? Symbol.for("react.fragment") : 60107, Owt = Ob2 ? Symbol.for("react.strict_mode") : 60108, Rwt = Ob2 ? Symbol.for("react.profiler") : 60114, Nwt = Ob2 ? Symbol.for("react.provider") : 60109, Fwt = Ob2 ? Symbol.for("react.context") : 60110, NBt = Ob2 ? Symbol.for("react.async_mode") : 60111, Vwt = Ob2 ? Symbol.for("react.concurrent_mode") : 60111, Bwt = Ob2 ? Symbol.for("react.forward_ref") : 60112, zwt = Ob2 ? Symbol.for("react.suspense") : 60113, KOn = Ob2 ? Symbol.for("react.suspense_list") : 60120, jwt = Ob2 ? Symbol.for("react.memo") : 60115, Wwt = Ob2 ? Symbol.for("react.lazy") : 60116, XOn = Ob2 ? Symbol.for("react.block") : 60121, QOn = Ob2 ? Symbol.for("react.fundamental") : 60117, JOn = Ob2 ? Symbol.for("react.responder") : 60118, t4n = Ob2 ? Symbol.for("react.scope") : 60119;
      function OC(u) {
        if (typeof u == "object" && u !== null) {
          var o = u.$$typeof;
          switch (o) {
            case OBt:
              switch (u = u.type, u) {
                case NBt:
                case Vwt:
                case Lwt:
                case Rwt:
                case Owt:
                case zwt:
                  return u;
                default:
                  switch (u = u && u.$$typeof, u) {
                    case Fwt:
                    case Bwt:
                    case Wwt:
                    case jwt:
                    case Nwt:
                      return u;
                    default:
                      return o;
                  }
              }
            case RBt:
              return o;
          }
        }
      }
      function zMe(u) {
        return OC(u) === Vwt;
      }
      Sg2.AsyncMode = NBt, Sg2.ConcurrentMode = Vwt, Sg2.ContextConsumer = Fwt, Sg2.ContextProvider = Nwt, Sg2.Element = OBt, Sg2.ForwardRef = Bwt, Sg2.Fragment = Lwt, Sg2.Lazy = Wwt, Sg2.Memo = jwt, Sg2.Portal = RBt, Sg2.Profiler = Rwt, Sg2.StrictMode = Owt, Sg2.Suspense = zwt, Sg2.isAsyncMode = function(u) {
        return zMe(u) || OC(u) === NBt;
      }, Sg2.isConcurrentMode = zMe, Sg2.isContextConsumer = function(u) {
        return OC(u) === Fwt;
      }, Sg2.isContextProvider = function(u) {
        return OC(u) === Nwt;
      }, Sg2.isElement = function(u) {
        return typeof u == "object" && u !== null && u.$$typeof === OBt;
      }, Sg2.isForwardRef = function(u) {
        return OC(u) === Bwt;
      }, Sg2.isFragment = function(u) {
        return OC(u) === Lwt;
      }, Sg2.isLazy = function(u) {
        return OC(u) === Wwt;
      }, Sg2.isMemo = function(u) {
        return OC(u) === jwt;
      }, Sg2.isPortal = function(u) {
        return OC(u) === RBt;
      }, Sg2.isProfiler = function(u) {
        return OC(u) === Rwt;
      }, Sg2.isStrictMode = function(u) {
        return OC(u) === Owt;
      }, Sg2.isSuspense = function(u) {
        return OC(u) === zwt;
      }, Sg2.isValidElementType = function(u) {
        return typeof u == "string" || typeof u == "function" || u === Lwt || u === Vwt || u === Rwt || u === Owt || u === zwt || u === KOn || typeof u == "object" && u !== null && (u.$$typeof === Wwt || u.$$typeof === jwt || u.$$typeof === Nwt || u.$$typeof === Fwt || u.$$typeof === Bwt || u.$$typeof === QOn || u.$$typeof === JOn || u.$$typeof === t4n || u.$$typeof === XOn);
      }, Sg2.typeOf = OC, LBt.exports = Sg2;
      function FBt(u) {
        var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n3 = [];
        return U3.default.Children.forEach(u, function(p2) {
          p2 == null && !o.keepEmpty || (Array.isArray(p2) ? n3 = n3.concat(FBt(p2)) : LBt.exports.isFragment(p2) && p2.props ? n3 = n3.concat(FBt(p2.props.children, o)) : n3.push(p2));
        }), n3;
      }
      function e4n(u, o) {
        typeof u == "function" ? u(o) : Ew(u) === "object" && u && "current" in u && (u.current = o);
      }
      function n4n() {
        for (var u = arguments.length, o = new Array(u), n3 = 0; n3 < u; n3++)
          o[n3] = arguments[n3];
        var p2 = o.filter(function(m2) {
          return m2;
        });
        return p2.length <= 1 ? p2[0] : function(m2) {
          o.forEach(function(w2) {
            e4n(w2, m2);
          });
        };
      }
      function r4n(u) {
        var o, n3, p2 = LBt.exports.isMemo(u) ? u.type.type : u.type;
        return !(typeof p2 == "function" && !(!((o = p2.prototype) === null || o === void 0) && o.render) || typeof u == "function" && !(!((n3 = u.prototype) === null || n3 === void 0) && n3.render));
      }
      function i4n() {
        try {
          if (!Object.assign)
            return false;
          var u = new String("abc");
          if (u[5] = "de", Object.getOwnPropertyNames(u)[0] === "5")
            return false;
          for (var o = {}, n3 = 0; n3 < 10; n3++)
            o["_" + String.fromCharCode(n3)] = n3;
          var p2 = Object.getOwnPropertyNames(o).map(function(w2) {
            return o[w2];
          });
          if (p2.join("") !== "0123456789")
            return false;
          var m2 = {};
          return "abcdefghijklmnopqrst".split("").forEach(function(w2) {
            m2[w2] = w2;
          }), Object.keys(Object.assign({}, m2)).join("") === "abcdefghijklmnopqrst";
        } catch {
          return false;
        }
      }
      i4n();
      function a4n(u) {
        if (Array.isArray(u))
          return vBt(u);
      }
      function jMe(u) {
        if (typeof Symbol != "undefined" && u[Symbol.iterator] != null || u["@@iterator"] != null)
          return Array.from(u);
      }
      function o4n() {
        throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function Bp(u) {
        return a4n(u) || jMe(u) || yBt(u) || o4n();
      }
      var LY = "RC_FORM_INTERNAL_HOOKS", s0 = function() {
        e3(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
      }, Bst = Y3.createContext({ getFieldValue: s0, getFieldsValue: s0, getFieldError: s0, getFieldWarning: s0, getFieldsError: s0, isFieldsTouched: s0, isFieldTouched: s0, isFieldValidating: s0, isFieldsValidating: s0, resetFields: s0, setFields: s0, setFieldsValue: s0, validateFields: s0, submit: s0, getInternalHooks: function() {
        return s0(), { dispatch: s0, initEntityValue: s0, registerField: s0, useSubscribe: s0, setInitialValues: s0, setCallbacks: s0, getFields: s0, setValidateMessages: s0, setPreserve: s0, getInitialValue: s0 };
      } });
      function VBt(u) {
        return u == null ? [] : Array.isArray(u) ? u : [u];
      }
      var WMe = { exports: {} };
      (function(u) {
        var o = function(n3) {
          var p2 = Object.prototype, m2 = p2.hasOwnProperty, w2, T2 = typeof Symbol == "function" ? Symbol : {}, E = T2.iterator || "@@iterator", O2 = T2.asyncIterator || "@@asyncIterator", V3 = T2.toStringTag || "@@toStringTag";
          function W3(Xn, or, Tr) {
            return Object.defineProperty(Xn, or, { value: Tr, enumerable: true, configurable: true, writable: true }), Xn[or];
          }
          try {
            W3({}, "");
          } catch {
            W3 = function(Xn, or, Tr) {
              return Xn[or] = Tr;
            };
          }
          function q3(Xn, or, Tr, ci2) {
            var yi2 = or && or.prototype instanceof Lt ? or : Lt, Po = Object.create(yi2.prototype), Ms = new zn(ci2 || []);
            return Po._invoke = ze(Xn, Tr, Ms), Po;
          }
          n3.wrap = q3;
          function K(Xn, or, Tr) {
            try {
              return { type: "normal", arg: Xn.call(or, Tr) };
            } catch (ci2) {
              return { type: "throw", arg: ci2 };
            }
          }
          var J = "suspendedStart", rt2 = "suspendedYield", gt = "executing", yt = "completed", At = {};
          function Lt() {
          }
          function Wt() {
          }
          function Nt() {
          }
          var ue2 = {};
          W3(ue2, E, function() {
            return this;
          });
          var ie2 = Object.getPrototypeOf, pe2 = ie2 && ie2(ie2(bn([])));
          pe2 && pe2 !== p2 && m2.call(pe2, E) && (ue2 = pe2);
          var xe = Nt.prototype = Lt.prototype = Object.create(ue2);
          Wt.prototype = Nt, W3(xe, "constructor", Nt), W3(Nt, "constructor", Wt), Wt.displayName = W3(Nt, V3, "GeneratorFunction");
          function Ce2(Xn) {
            ["next", "throw", "return"].forEach(function(or) {
              W3(Xn, or, function(Tr) {
                return this._invoke(or, Tr);
              });
            });
          }
          n3.isGeneratorFunction = function(Xn) {
            var or = typeof Xn == "function" && Xn.constructor;
            return or ? or === Wt || (or.displayName || or.name) === "GeneratorFunction" : false;
          }, n3.mark = function(Xn) {
            return Object.setPrototypeOf ? Object.setPrototypeOf(Xn, Nt) : (Xn.__proto__ = Nt, W3(Xn, V3, "GeneratorFunction")), Xn.prototype = Object.create(xe), Xn;
          }, n3.awrap = function(Xn) {
            return { __await: Xn };
          };
          function Le2(Xn, or) {
            function Tr(Po, Ms, dl, tl) {
              var el = K(Xn[Po], Xn, Ms);
              if (el.type === "throw")
                tl(el.arg);
              else {
                var as = el.arg, Hs = as.value;
                return Hs && typeof Hs == "object" && m2.call(Hs, "__await") ? or.resolve(Hs.__await).then(function(ol) {
                  Tr("next", ol, dl, tl);
                }, function(ol) {
                  Tr("throw", ol, dl, tl);
                }) : or.resolve(Hs).then(function(ol) {
                  as.value = ol, dl(as);
                }, function(ol) {
                  return Tr("throw", ol, dl, tl);
                });
              }
            }
            var ci2;
            function yi2(Po, Ms) {
              function dl() {
                return new or(function(tl, el) {
                  Tr(Po, Ms, tl, el);
                });
              }
              return ci2 = ci2 ? ci2.then(dl, dl) : dl();
            }
            this._invoke = yi2;
          }
          Ce2(Le2.prototype), W3(Le2.prototype, O2, function() {
            return this;
          }), n3.AsyncIterator = Le2, n3.async = function(Xn, or, Tr, ci2, yi2) {
            yi2 === void 0 && (yi2 = Promise);
            var Po = new Le2(q3(Xn, or, Tr, ci2), yi2);
            return n3.isGeneratorFunction(or) ? Po : Po.next().then(function(Ms) {
              return Ms.done ? Ms.value : Po.next();
            });
          };
          function ze(Xn, or, Tr) {
            var ci2 = J;
            return function(yi2, Po) {
              if (ci2 === gt)
                throw new Error("Generator is already running");
              if (ci2 === yt) {
                if (yi2 === "throw")
                  throw Po;
                return Xr();
              }
              for (Tr.method = yi2, Tr.arg = Po; ; ) {
                var Ms = Tr.delegate;
                if (Ms) {
                  var dl = tn(Ms, Tr);
                  if (dl) {
                    if (dl === At)
                      continue;
                    return dl;
                  }
                }
                if (Tr.method === "next")
                  Tr.sent = Tr._sent = Tr.arg;
                else if (Tr.method === "throw") {
                  if (ci2 === J)
                    throw ci2 = yt, Tr.arg;
                  Tr.dispatchException(Tr.arg);
                } else
                  Tr.method === "return" && Tr.abrupt("return", Tr.arg);
                ci2 = gt;
                var tl = K(Xn, or, Tr);
                if (tl.type === "normal") {
                  if (ci2 = Tr.done ? yt : rt2, tl.arg === At)
                    continue;
                  return { value: tl.arg, done: Tr.done };
                } else
                  tl.type === "throw" && (ci2 = yt, Tr.method = "throw", Tr.arg = tl.arg);
              }
            };
          }
          function tn(Xn, or) {
            var Tr = Xn.iterator[or.method];
            if (Tr === w2) {
              if (or.delegate = null, or.method === "throw") {
                if (Xn.iterator.return && (or.method = "return", or.arg = w2, tn(Xn, or), or.method === "throw"))
                  return At;
                or.method = "throw", or.arg = new TypeError("The iterator does not provide a 'throw' method");
              }
              return At;
            }
            var ci2 = K(Tr, Xn.iterator, or.arg);
            if (ci2.type === "throw")
              return or.method = "throw", or.arg = ci2.arg, or.delegate = null, At;
            var yi2 = ci2.arg;
            if (!yi2)
              return or.method = "throw", or.arg = new TypeError("iterator result is not an object"), or.delegate = null, At;
            if (yi2.done)
              or[Xn.resultName] = yi2.value, or.next = Xn.nextLoc, or.method !== "return" && (or.method = "next", or.arg = w2);
            else
              return yi2;
            return or.delegate = null, At;
          }
          Ce2(xe), W3(xe, V3, "Generator"), W3(xe, E, function() {
            return this;
          }), W3(xe, "toString", function() {
            return "[object Generator]";
          });
          function $e2(Xn) {
            var or = { tryLoc: Xn[0] };
            1 in Xn && (or.catchLoc = Xn[1]), 2 in Xn && (or.finallyLoc = Xn[2], or.afterLoc = Xn[3]), this.tryEntries.push(or);
          }
          function Tn(Xn) {
            var or = Xn.completion || {};
            or.type = "normal", delete or.arg, Xn.completion = or;
          }
          function zn(Xn) {
            this.tryEntries = [{ tryLoc: "root" }], Xn.forEach($e2, this), this.reset(true);
          }
          n3.keys = function(Xn) {
            var or = [];
            for (var Tr in Xn)
              or.push(Tr);
            return or.reverse(), function ci2() {
              for (; or.length; ) {
                var yi2 = or.pop();
                if (yi2 in Xn)
                  return ci2.value = yi2, ci2.done = false, ci2;
              }
              return ci2.done = true, ci2;
            };
          };
          function bn(Xn) {
            if (Xn) {
              var or = Xn[E];
              if (or)
                return or.call(Xn);
              if (typeof Xn.next == "function")
                return Xn;
              if (!isNaN(Xn.length)) {
                var Tr = -1, ci2 = function yi2() {
                  for (; ++Tr < Xn.length; )
                    if (m2.call(Xn, Tr))
                      return yi2.value = Xn[Tr], yi2.done = false, yi2;
                  return yi2.value = w2, yi2.done = true, yi2;
                };
                return ci2.next = ci2;
              }
            }
            return { next: Xr };
          }
          n3.values = bn;
          function Xr() {
            return { value: w2, done: true };
          }
          return zn.prototype = { constructor: zn, reset: function(Xn) {
            if (this.prev = 0, this.next = 0, this.sent = this._sent = w2, this.done = false, this.delegate = null, this.method = "next", this.arg = w2, this.tryEntries.forEach(Tn), !Xn)
              for (var or in this)
                or.charAt(0) === "t" && m2.call(this, or) && !isNaN(+or.slice(1)) && (this[or] = w2);
          }, stop: function() {
            this.done = true;
            var Xn = this.tryEntries[0], or = Xn.completion;
            if (or.type === "throw")
              throw or.arg;
            return this.rval;
          }, dispatchException: function(Xn) {
            if (this.done)
              throw Xn;
            var or = this;
            function Tr(tl, el) {
              return Po.type = "throw", Po.arg = Xn, or.next = tl, el && (or.method = "next", or.arg = w2), !!el;
            }
            for (var ci2 = this.tryEntries.length - 1; ci2 >= 0; --ci2) {
              var yi2 = this.tryEntries[ci2], Po = yi2.completion;
              if (yi2.tryLoc === "root")
                return Tr("end");
              if (yi2.tryLoc <= this.prev) {
                var Ms = m2.call(yi2, "catchLoc"), dl = m2.call(yi2, "finallyLoc");
                if (Ms && dl) {
                  if (this.prev < yi2.catchLoc)
                    return Tr(yi2.catchLoc, true);
                  if (this.prev < yi2.finallyLoc)
                    return Tr(yi2.finallyLoc);
                } else if (Ms) {
                  if (this.prev < yi2.catchLoc)
                    return Tr(yi2.catchLoc, true);
                } else if (dl) {
                  if (this.prev < yi2.finallyLoc)
                    return Tr(yi2.finallyLoc);
                } else
                  throw new Error("try statement without catch or finally");
              }
            }
          }, abrupt: function(Xn, or) {
            for (var Tr = this.tryEntries.length - 1; Tr >= 0; --Tr) {
              var ci2 = this.tryEntries[Tr];
              if (ci2.tryLoc <= this.prev && m2.call(ci2, "finallyLoc") && this.prev < ci2.finallyLoc) {
                var yi2 = ci2;
                break;
              }
            }
            yi2 && (Xn === "break" || Xn === "continue") && yi2.tryLoc <= or && or <= yi2.finallyLoc && (yi2 = null);
            var Po = yi2 ? yi2.completion : {};
            return Po.type = Xn, Po.arg = or, yi2 ? (this.method = "next", this.next = yi2.finallyLoc, At) : this.complete(Po);
          }, complete: function(Xn, or) {
            if (Xn.type === "throw")
              throw Xn.arg;
            return Xn.type === "break" || Xn.type === "continue" ? this.next = Xn.arg : Xn.type === "return" ? (this.rval = this.arg = Xn.arg, this.method = "return", this.next = "end") : Xn.type === "normal" && or && (this.next = or), At;
          }, finish: function(Xn) {
            for (var or = this.tryEntries.length - 1; or >= 0; --or) {
              var Tr = this.tryEntries[or];
              if (Tr.finallyLoc === Xn)
                return this.complete(Tr.completion, Tr.afterLoc), Tn(Tr), At;
            }
          }, catch: function(Xn) {
            for (var or = this.tryEntries.length - 1; or >= 0; --or) {
              var Tr = this.tryEntries[or];
              if (Tr.tryLoc === Xn) {
                var ci2 = Tr.completion;
                if (ci2.type === "throw") {
                  var yi2 = ci2.arg;
                  Tn(Tr);
                }
                return yi2;
              }
            }
            throw new Error("illegal catch attempt");
          }, delegateYield: function(Xn, or, Tr) {
            return this.delegate = { iterator: bn(Xn), resultName: or, nextLoc: Tr }, this.method === "next" && (this.arg = w2), At;
          } }, n3;
        }(u.exports);
        try {
          regeneratorRuntime = o;
        } catch {
          typeof globalThis == "object" ? globalThis.regeneratorRuntime = o : Function("r", "regeneratorRuntime = r")(o);
        }
      })(WMe);
      var C8 = WMe.exports;
      function GMe(u, o, n3, p2, m2, w2, T2) {
        try {
          var E = u[w2](T2), O2 = E.value;
        } catch (V3) {
          n3(V3);
          return;
        }
        E.done ? o(O2) : Promise.resolve(O2).then(p2, m2);
      }
      function Gwt(u) {
        return function() {
          var o = this, n3 = arguments;
          return new Promise(function(p2, m2) {
            var w2 = u.apply(o, n3);
            function T2(O2) {
              GMe(w2, p2, m2, T2, E, "next", O2);
            }
            function E(O2) {
              GMe(w2, p2, m2, T2, E, "throw", O2);
            }
            T2(void 0);
          });
        };
      }
      function ij2() {
        return ij2 = Object.assign || function(u) {
          for (var o = 1; o < arguments.length; o++) {
            var n3 = arguments[o];
            for (var p2 in n3)
              Object.prototype.hasOwnProperty.call(n3, p2) && (u[p2] = n3[p2]);
          }
          return u;
        }, ij2.apply(this, arguments);
      }
      function s4n(u, o) {
        u.prototype = Object.create(o.prototype), u.prototype.constructor = u, zst(u, o);
      }
      function BBt(u) {
        return BBt = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
          return o.__proto__ || Object.getPrototypeOf(o);
        }, BBt(u);
      }
      function zst(u, o) {
        return zst = Object.setPrototypeOf || function(n3, p2) {
          return n3.__proto__ = p2, n3;
        }, zst(u, o);
      }
      function l4n() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function Hwt(u, o, n3) {
        return l4n() ? Hwt = Reflect.construct : Hwt = function(p2, m2, w2) {
          var T2 = [null];
          T2.push.apply(T2, m2);
          var E = Function.bind.apply(p2, T2), O2 = new E();
          return w2 && zst(O2, w2.prototype), O2;
        }, Hwt.apply(null, arguments);
      }
      function u4n(u) {
        return Function.toString.call(u).indexOf("[native code]") !== -1;
      }
      function zBt(u) {
        var o = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
        return zBt = function(n3) {
          if (n3 === null || !u4n(n3))
            return n3;
          if (typeof n3 != "function")
            throw new TypeError("Super expression must either be null or a function");
          if (typeof o != "undefined") {
            if (o.has(n3))
              return o.get(n3);
            o.set(n3, p2);
          }
          function p2() {
            return Hwt(n3, arguments, BBt(this).constructor);
          }
          return p2.prototype = Object.create(n3.prototype, { constructor: { value: p2, enumerable: false, writable: true, configurable: true } }), zst(p2, n3);
        }, zBt(u);
      }
      var c4n = /%[sdj%]/g, f4n = function() {
      };
      typeof process != "undefined" && process.env;
      function jBt(u) {
        if (!u || !u.length)
          return null;
        var o = {};
        return u.forEach(function(n3) {
          var p2 = n3.field;
          o[p2] = o[p2] || [], o[p2].push(n3);
        }), o;
      }
      function RC(u) {
        for (var o = arguments.length, n3 = new Array(o > 1 ? o - 1 : 0), p2 = 1; p2 < o; p2++)
          n3[p2 - 1] = arguments[p2];
        var m2 = 0, w2 = n3.length;
        if (typeof u == "function")
          return u.apply(null, n3);
        if (typeof u == "string") {
          var T2 = u.replace(c4n, function(E) {
            if (E === "%%")
              return "%";
            if (m2 >= w2)
              return E;
            switch (E) {
              case "%s":
                return String(n3[m2++]);
              case "%d":
                return Number(n3[m2++]);
              case "%j":
                try {
                  return JSON.stringify(n3[m2++]);
                } catch {
                  return "[Circular]";
                }
                break;
              default:
                return E;
            }
          });
          return T2;
        }
        return u;
      }
      function h4n(u) {
        return u === "string" || u === "url" || u === "hex" || u === "email" || u === "date" || u === "pattern";
      }
      function L1(u, o) {
        return !!(u == null || o === "array" && Array.isArray(u) && !u.length || h4n(o) && typeof u == "string" && !u);
      }
      function p4n(u, o, n3) {
        var p2 = [], m2 = 0, w2 = u.length;
        function T2(E) {
          p2.push.apply(p2, E || []), m2++, m2 === w2 && n3(p2);
        }
        u.forEach(function(E) {
          o(E, T2);
        });
      }
      function HMe(u, o, n3) {
        var p2 = 0, m2 = u.length;
        function w2(T2) {
          if (T2 && T2.length) {
            n3(T2);
            return;
          }
          var E = p2;
          p2 = p2 + 1, E < m2 ? o(u[E], w2) : n3([]);
        }
        w2([]);
      }
      function d4n(u) {
        var o = [];
        return Object.keys(u).forEach(function(n3) {
          o.push.apply(o, u[n3] || []);
        }), o;
      }
      var UMe = function(u) {
        s4n(o, u);
        function o(n3, p2) {
          var m2;
          return m2 = u.call(this, "Async Validation Error") || this, m2.errors = n3, m2.fields = p2, m2;
        }
        return o;
      }(zBt(Error));
      function g4n(u, o, n3, p2, m2) {
        if (o.first) {
          var w2 = new Promise(function(K, J) {
            var rt2 = function(yt) {
              return p2(yt), yt.length ? J(new UMe(yt, jBt(yt))) : K(m2);
            }, gt = d4n(u);
            HMe(gt, n3, rt2);
          });
          return w2.catch(function(K) {
            return K;
          }), w2;
        }
        var T2 = o.firstFields === true ? Object.keys(u) : o.firstFields || [], E = Object.keys(u), O2 = E.length, V3 = 0, W3 = [], q3 = new Promise(function(K, J) {
          var rt2 = function(gt) {
            if (W3.push.apply(W3, gt), V3++, V3 === O2)
              return p2(W3), W3.length ? J(new UMe(W3, jBt(W3))) : K(m2);
          };
          E.length || (p2(W3), K(m2)), E.forEach(function(gt) {
            var yt = u[gt];
            T2.indexOf(gt) !== -1 ? HMe(yt, n3, rt2) : p4n(yt, n3, rt2);
          });
        });
        return q3.catch(function(K) {
          return K;
        }), q3;
      }
      function v4n(u) {
        return !!(u && u.message !== void 0);
      }
      function y4n(u, o) {
        for (var n3 = u, p2 = 0; p2 < o.length; p2++) {
          if (n3 == null)
            return n3;
          n3 = n3[o[p2]];
        }
        return n3;
      }
      function qMe(u, o) {
        return function(n3) {
          var p2;
          return u.fullFields ? p2 = y4n(o, u.fullFields) : p2 = o[n3.field || u.fullField], v4n(n3) ? (n3.field = n3.field || u.fullField, n3.fieldValue = p2, n3) : { message: typeof n3 == "function" ? n3() : n3, fieldValue: p2, field: n3.field || u.fullField };
        };
      }
      function ZMe(u, o) {
        if (o) {
          for (var n3 in o)
            if (o.hasOwnProperty(n3)) {
              var p2 = o[n3];
              typeof p2 == "object" && typeof u[n3] == "object" ? u[n3] = ij2({}, u[n3], p2) : u[n3] = p2;
            }
        }
        return u;
      }
      var $Me = function(u, o, n3, p2, m2, w2) {
        u.required && (!n3.hasOwnProperty(u.field) || L1(o, w2 || u.type)) && p2.push(RC(m2.messages.required, u.fullField));
      }, m4n = function(u, o, n3, p2, m2) {
        (/^\s+$/.test(o) || o === "") && p2.push(RC(m2.messages.whitespace, u.fullField));
      }, WBt = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, jst = { integer: function(u) {
        return jst.number(u) && parseInt(u, 10) === u;
      }, float: function(u) {
        return jst.number(u) && !jst.integer(u);
      }, array: function(u) {
        return Array.isArray(u);
      }, regexp: function(u) {
        if (u instanceof RegExp)
          return true;
        try {
          return !!new RegExp(u);
        } catch {
          return false;
        }
      }, date: function(u) {
        return typeof u.getTime == "function" && typeof u.getMonth == "function" && typeof u.getYear == "function" && !isNaN(u.getTime());
      }, number: function(u) {
        return isNaN(u) ? false : typeof u == "number";
      }, object: function(u) {
        return typeof u == "object" && !jst.array(u);
      }, method: function(u) {
        return typeof u == "function";
      }, email: function(u) {
        return typeof u == "string" && u.length <= 320 && !!u.match(WBt.email);
      }, url: function(u) {
        return typeof u == "string" && u.length <= 2048 && !!u.match(WBt.url);
      }, hex: function(u) {
        return typeof u == "string" && !!u.match(WBt.hex);
      } }, b4n = function(u, o, n3, p2, m2) {
        if (u.required && o === void 0) {
          $Me(u, o, n3, p2, m2);
          return;
        }
        var w2 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], T2 = u.type;
        w2.indexOf(T2) > -1 ? jst[T2](o) || p2.push(RC(m2.messages.types[T2], u.fullField, u.type)) : T2 && typeof o !== u.type && p2.push(RC(m2.messages.types[T2], u.fullField, u.type));
      }, _4n = function(u, o, n3, p2, m2) {
        var w2 = typeof u.len == "number", T2 = typeof u.min == "number", E = typeof u.max == "number", O2 = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, V3 = o, W3 = null, q3 = typeof o == "number", K = typeof o == "string", J = Array.isArray(o);
        if (q3 ? W3 = "number" : K ? W3 = "string" : J && (W3 = "array"), !W3)
          return false;
        J && (V3 = o.length), K && (V3 = o.replace(O2, "_").length), w2 ? V3 !== u.len && p2.push(RC(m2.messages[W3].len, u.fullField, u.len)) : T2 && !E && V3 < u.min ? p2.push(RC(m2.messages[W3].min, u.fullField, u.min)) : E && !T2 && V3 > u.max ? p2.push(RC(m2.messages[W3].max, u.fullField, u.max)) : T2 && E && (V3 < u.min || V3 > u.max) && p2.push(RC(m2.messages[W3].range, u.fullField, u.min, u.max));
      }, OY = "enum", x4n = function(u, o, n3, p2, m2) {
        u[OY] = Array.isArray(u[OY]) ? u[OY] : [], u[OY].indexOf(o) === -1 && p2.push(RC(m2.messages[OY], u.fullField, u[OY].join(", ")));
      }, w4n = function(u, o, n3, p2, m2) {
        if (u.pattern) {
          if (u.pattern instanceof RegExp)
            u.pattern.lastIndex = 0, u.pattern.test(o) || p2.push(RC(m2.messages.pattern.mismatch, u.fullField, o, u.pattern));
          else if (typeof u.pattern == "string") {
            var w2 = new RegExp(u.pattern);
            w2.test(o) || p2.push(RC(m2.messages.pattern.mismatch, u.fullField, o, u.pattern));
          }
        }
      }, Ap = { required: $Me, whitespace: m4n, type: b4n, range: _4n, enum: x4n, pattern: w4n }, S4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o, "string") && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2, "string"), L1(o, "string") || (Ap.type(u, o, p2, w2, m2), Ap.range(u, o, p2, w2, m2), Ap.pattern(u, o, p2, w2, m2), u.whitespace === true && Ap.whitespace(u, o, p2, w2, m2));
        }
        n3(w2);
      }, M4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), o !== void 0 && Ap.type(u, o, p2, w2, m2);
        }
        n3(w2);
      }, C4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (o === "" && (o = void 0), L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), o !== void 0 && (Ap.type(u, o, p2, w2, m2), Ap.range(u, o, p2, w2, m2));
        }
        n3(w2);
      }, T4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), o !== void 0 && Ap.type(u, o, p2, w2, m2);
        }
        n3(w2);
      }, A4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), L1(o) || Ap.type(u, o, p2, w2, m2);
        }
        n3(w2);
      }, I4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), o !== void 0 && (Ap.type(u, o, p2, w2, m2), Ap.range(u, o, p2, w2, m2));
        }
        n3(w2);
      }, D4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), o !== void 0 && (Ap.type(u, o, p2, w2, m2), Ap.range(u, o, p2, w2, m2));
        }
        n3(w2);
      }, E4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (o == null && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2, "array"), o != null && (Ap.type(u, o, p2, w2, m2), Ap.range(u, o, p2, w2, m2));
        }
        n3(w2);
      }, k4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), o !== void 0 && Ap.type(u, o, p2, w2, m2);
        }
        n3(w2);
      }, P4n = "enum", L4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), o !== void 0 && Ap[P4n](u, o, p2, w2, m2);
        }
        n3(w2);
      }, O4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o, "string") && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2), L1(o, "string") || Ap.pattern(u, o, p2, w2, m2);
        }
        n3(w2);
      }, R4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o, "date") && !u.required)
            return n3();
          if (Ap.required(u, o, p2, w2, m2), !L1(o, "date")) {
            var E;
            o instanceof Date ? E = o : E = new Date(o), Ap.type(u, E, p2, w2, m2), E && Ap.range(u, E.getTime(), p2, w2, m2);
          }
        }
        n3(w2);
      }, N4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = Array.isArray(o) ? "array" : typeof o;
        Ap.required(u, o, p2, w2, m2, T2), n3(w2);
      }, GBt = function(u, o, n3, p2, m2) {
        var w2 = u.type, T2 = [], E = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (E) {
          if (L1(o, w2) && !u.required)
            return n3();
          Ap.required(u, o, p2, T2, m2, w2), L1(o, w2) || Ap.type(u, o, p2, T2, m2);
        }
        n3(T2);
      }, F4n = function(u, o, n3, p2, m2) {
        var w2 = [], T2 = u.required || !u.required && p2.hasOwnProperty(u.field);
        if (T2) {
          if (L1(o) && !u.required)
            return n3();
          Ap.required(u, o, p2, w2, m2);
        }
        n3(w2);
      }, Wst = { string: S4n, method: M4n, number: C4n, boolean: T4n, regexp: A4n, integer: I4n, float: D4n, array: E4n, object: k4n, enum: L4n, pattern: O4n, date: R4n, url: GBt, hex: GBt, email: GBt, required: N4n, any: F4n };
      function HBt() {
        return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
          var u = JSON.parse(JSON.stringify(this));
          return u.clone = this.clone, u;
        } };
      }
      var UBt = HBt(), Gst = function() {
        function u(n3) {
          this.rules = null, this._messages = UBt, this.define(n3);
        }
        var o = u.prototype;
        return o.define = function(n3) {
          var p2 = this;
          if (!n3)
            throw new Error("Cannot configure a schema with no rules");
          if (typeof n3 != "object" || Array.isArray(n3))
            throw new Error("Rules must be an object");
          this.rules = {}, Object.keys(n3).forEach(function(m2) {
            var w2 = n3[m2];
            p2.rules[m2] = Array.isArray(w2) ? w2 : [w2];
          });
        }, o.messages = function(n3) {
          return n3 && (this._messages = ZMe(HBt(), n3)), this._messages;
        }, o.validate = function(n3, p2, m2) {
          var w2 = this;
          p2 === void 0 && (p2 = {}), m2 === void 0 && (m2 = function() {
          });
          var T2 = n3, E = p2, O2 = m2;
          if (typeof E == "function" && (O2 = E, E = {}), !this.rules || Object.keys(this.rules).length === 0)
            return O2 && O2(null, T2), Promise.resolve(T2);
          function V3(rt2) {
            var gt = [], yt = {};
            function At(Wt) {
              if (Array.isArray(Wt)) {
                var Nt;
                gt = (Nt = gt).concat.apply(Nt, Wt);
              } else
                gt.push(Wt);
            }
            for (var Lt = 0; Lt < rt2.length; Lt++)
              At(rt2[Lt]);
            gt.length ? (yt = jBt(gt), O2(gt, yt)) : O2(null, T2);
          }
          if (E.messages) {
            var W3 = this.messages();
            W3 === UBt && (W3 = HBt()), ZMe(W3, E.messages), E.messages = W3;
          } else
            E.messages = this.messages();
          var q3 = {}, K = E.keys || Object.keys(this.rules);
          K.forEach(function(rt2) {
            var gt = w2.rules[rt2], yt = T2[rt2];
            gt.forEach(function(At) {
              var Lt = At;
              typeof Lt.transform == "function" && (T2 === n3 && (T2 = ij2({}, T2)), yt = T2[rt2] = Lt.transform(yt)), typeof Lt == "function" ? Lt = { validator: Lt } : Lt = ij2({}, Lt), Lt.validator = w2.getValidationMethod(Lt), Lt.validator && (Lt.field = rt2, Lt.fullField = Lt.fullField || rt2, Lt.type = w2.getType(Lt), q3[rt2] = q3[rt2] || [], q3[rt2].push({ rule: Lt, value: yt, source: T2, field: rt2 }));
            });
          });
          var J = {};
          return g4n(q3, E, function(rt2, gt) {
            var yt = rt2.rule, At = (yt.type === "object" || yt.type === "array") && (typeof yt.fields == "object" || typeof yt.defaultField == "object");
            At = At && (yt.required || !yt.required && rt2.value), yt.field = rt2.field;
            function Lt(ue2, ie2) {
              return ij2({}, ie2, { fullField: yt.fullField + "." + ue2, fullFields: yt.fullFields ? [].concat(yt.fullFields, [ue2]) : [ue2] });
            }
            function Wt(ue2) {
              ue2 === void 0 && (ue2 = []);
              var ie2 = Array.isArray(ue2) ? ue2 : [ue2];
              !E.suppressWarning && ie2.length && u.warning("async-validator:", ie2), ie2.length && yt.message !== void 0 && (ie2 = [].concat(yt.message));
              var pe2 = ie2.map(qMe(yt, T2));
              if (E.first && pe2.length)
                return J[yt.field] = 1, gt(pe2);
              if (!At)
                gt(pe2);
              else {
                if (yt.required && !rt2.value)
                  return yt.message !== void 0 ? pe2 = [].concat(yt.message).map(qMe(yt, T2)) : E.error && (pe2 = [E.error(yt, RC(E.messages.required, yt.field))]), gt(pe2);
                var xe = {};
                yt.defaultField && Object.keys(rt2.value).map(function(ze) {
                  xe[ze] = yt.defaultField;
                }), xe = ij2({}, xe, rt2.rule.fields);
                var Ce2 = {};
                Object.keys(xe).forEach(function(ze) {
                  var tn = xe[ze], $e2 = Array.isArray(tn) ? tn : [tn];
                  Ce2[ze] = $e2.map(Lt.bind(null, ze));
                });
                var Le2 = new u(Ce2);
                Le2.messages(E.messages), rt2.rule.options && (rt2.rule.options.messages = E.messages, rt2.rule.options.error = E.error), Le2.validate(rt2.value, rt2.rule.options || E, function(ze) {
                  var tn = [];
                  pe2 && pe2.length && tn.push.apply(tn, pe2), ze && ze.length && tn.push.apply(tn, ze), gt(tn.length ? tn : null);
                });
              }
            }
            var Nt;
            yt.asyncValidator ? Nt = yt.asyncValidator(yt, rt2.value, Wt, rt2.source, E) : yt.validator && (Nt = yt.validator(yt, rt2.value, Wt, rt2.source, E), Nt === true ? Wt() : Nt === false ? Wt(typeof yt.message == "function" ? yt.message(yt.fullField || yt.field) : yt.message || (yt.fullField || yt.field) + " fails") : Nt instanceof Array ? Wt(Nt) : Nt instanceof Error && Wt(Nt.message)), Nt && Nt.then && Nt.then(function() {
              return Wt();
            }, function(ue2) {
              return Wt(ue2);
            });
          }, function(rt2) {
            V3(rt2);
          }, T2);
        }, o.getType = function(n3) {
          if (n3.type === void 0 && n3.pattern instanceof RegExp && (n3.type = "pattern"), typeof n3.validator != "function" && n3.type && !Wst.hasOwnProperty(n3.type))
            throw new Error(RC("Unknown rule type %s", n3.type));
          return n3.type || "string";
        }, o.getValidationMethod = function(n3) {
          if (typeof n3.validator == "function")
            return n3.validator;
          var p2 = Object.keys(n3), m2 = p2.indexOf("message");
          return m2 !== -1 && p2.splice(m2, 1), p2.length === 1 && p2[0] === "required" ? Wst.required : Wst[this.getType(n3)] || void 0;
        }, u;
      }();
      Gst.register = function(u, o) {
        if (typeof o != "function")
          throw new Error("Cannot register a validator by type, validator is not a function");
        Wst[u] = o;
      }, Gst.warning = f4n, Gst.messages = UBt, Gst.validators = Wst;
      var NC = "'${name}' is not a valid ${type}", YMe = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: NC, method: NC, array: NC, object: NC, number: NC, date: NC, boolean: NC, integer: NC, float: NC, regexp: NC, email: NC, url: NC, hex: NC }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
      function KMe(u, o) {
        for (var n3 = u, p2 = 0; p2 < o.length; p2 += 1) {
          if (n3 == null)
            return;
          n3 = n3[o[p2]];
        }
        return n3;
      }
      function V4n(u) {
        return vMe(u) || jMe(u) || yBt(u) || yMe();
      }
      function XMe(u, o, n3, p2) {
        if (!o.length)
          return n3;
        var m2 = V4n(o), w2 = m2[0], T2 = m2.slice(1), E;
        return !u && typeof w2 == "number" ? E = [] : Array.isArray(u) ? E = Bp(u) : E = mf2({}, u), p2 && n3 === void 0 && T2.length === 1 ? delete E[w2][T2[0]] : E[w2] = XMe(E[w2], T2, n3, p2), E;
      }
      function B4n(u, o, n3) {
        var p2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
        return o.length && p2 && n3 === void 0 && !KMe(u, o.slice(0, -1)) ? u : XMe(u, o, n3, p2);
      }
      function jm(u) {
        return VBt(u);
      }
      function RY(u, o) {
        var n3 = KMe(u, o);
        return n3;
      }
      function aj2(u, o, n3) {
        var p2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, m2 = B4n(u, o, n3, p2);
        return m2;
      }
      function QMe(u, o) {
        var n3 = {};
        return o.forEach(function(p2) {
          var m2 = RY(u, p2);
          n3 = aj2(n3, p2, m2);
        }), n3;
      }
      function Hst(u, o) {
        return u && u.some(function(n3) {
          return eCe(n3, o);
        });
      }
      function JMe(u) {
        return Ew(u) === "object" && u !== null && Object.getPrototypeOf(u) === Object.prototype;
      }
      function tCe(u, o) {
        var n3 = Array.isArray(u) ? Bp(u) : mf2({}, u);
        return o && Object.keys(o).forEach(function(p2) {
          var m2 = n3[p2], w2 = o[p2], T2 = JMe(m2) && JMe(w2);
          n3[p2] = T2 ? tCe(m2, w2 || {}) : w2;
        }), n3;
      }
      function Uwt(u) {
        for (var o = arguments.length, n3 = new Array(o > 1 ? o - 1 : 0), p2 = 1; p2 < o; p2++)
          n3[p2 - 1] = arguments[p2];
        return n3.reduce(function(m2, w2) {
          return tCe(m2, w2);
        }, u);
      }
      function eCe(u, o) {
        return !u || !o || u.length !== o.length ? false : u.every(function(n3, p2) {
          return o[p2] === n3;
        });
      }
      function z4n(u, o) {
        if (u === o)
          return true;
        if (!u && o || u && !o || !u || !o || Ew(u) !== "object" || Ew(o) !== "object")
          return false;
        var n3 = Object.keys(u), p2 = Object.keys(o), m2 = new Set([].concat(Bp(n3), Bp(p2)));
        return Bp(m2).every(function(w2) {
          var T2 = u[w2], E = o[w2];
          return typeof T2 == "function" && typeof E == "function" ? true : T2 === E;
        });
      }
      function j4n(u) {
        var o = arguments.length <= 1 ? void 0 : arguments[1];
        return o && o.target && Ew(o.target) === "object" && u in o.target ? o.target[u] : o;
      }
      function nCe(u, o, n3) {
        var p2 = u.length;
        if (o < 0 || o >= p2 || n3 < 0 || n3 >= p2)
          return u;
        var m2 = u[o], w2 = o - n3;
        return w2 > 0 ? [].concat(Bp(u.slice(0, n3)), [m2], Bp(u.slice(n3, o)), Bp(u.slice(o + 1, p2))) : w2 < 0 ? [].concat(Bp(u.slice(0, o)), Bp(u.slice(o + 1, n3 + 1)), [m2], Bp(u.slice(n3 + 1, p2))) : u;
      }
      var W4n = Gst;
      function G4n(u, o) {
        return u.replace(/\$\{\w+\}/g, function(n3) {
          var p2 = n3.slice(2, -1);
          return o[p2];
        });
      }
      function qBt(u, o, n3, p2, m2) {
        return ZBt.apply(this, arguments);
      }
      function ZBt() {
        return ZBt = Gwt(C8.mark(function u(o, n3, p2, m2, w2) {
          var T2, E, O2, V3, W3, q3, K, J;
          return C8.wrap(function(rt2) {
            for (; ; )
              switch (rt2.prev = rt2.next) {
                case 0:
                  return T2 = mf2({}, p2), delete T2.ruleIndex, E = null, T2 && T2.type === "array" && T2.defaultField && (E = T2.defaultField, delete T2.defaultField), O2 = new W4n(Yd2({}, o, [T2])), V3 = Uwt({}, YMe, m2.validateMessages), O2.messages(V3), W3 = [], rt2.prev = 8, rt2.next = 11, Promise.resolve(O2.validate(Yd2({}, o, n3), mf2({}, m2)));
                case 11:
                  rt2.next = 16;
                  break;
                case 13:
                  rt2.prev = 13, rt2.t0 = rt2.catch(8), rt2.t0.errors ? W3 = rt2.t0.errors.map(function(gt, yt) {
                    var At = gt.message;
                    return Y3.isValidElement(At) ? Y3.cloneElement(At, { key: "error_".concat(yt) }) : At;
                  }) : (console.error(rt2.t0), W3 = [V3.default]);
                case 16:
                  if (!(!W3.length && E)) {
                    rt2.next = 21;
                    break;
                  }
                  return rt2.next = 19, Promise.all(n3.map(function(gt, yt) {
                    return qBt("".concat(o, ".").concat(yt), gt, E, m2, w2);
                  }));
                case 19:
                  return q3 = rt2.sent, rt2.abrupt("return", q3.reduce(function(gt, yt) {
                    return [].concat(Bp(gt), Bp(yt));
                  }, []));
                case 21:
                  return K = mf2(mf2({}, p2), {}, { name: o, enum: (p2.enum || []).join(", ") }, w2), J = W3.map(function(gt) {
                    return typeof gt == "string" ? G4n(gt, K) : gt;
                  }), rt2.abrupt("return", J);
                case 24:
                case "end":
                  return rt2.stop();
              }
          }, u, null, [[8, 13]]);
        })), ZBt.apply(this, arguments);
      }
      function H4n(u, o, n3, p2, m2, w2) {
        var T2 = u.join("."), E = n3.map(function(W3, q3) {
          var K = W3.validator, J = mf2(mf2({}, W3), {}, { ruleIndex: q3 });
          return K && (J.validator = function(rt2, gt, yt) {
            var At = false, Lt = function() {
              for (var Nt = arguments.length, ue2 = new Array(Nt), ie2 = 0; ie2 < Nt; ie2++)
                ue2[ie2] = arguments[ie2];
              Promise.resolve().then(function() {
                e3(!At, "Your validator function has already return a promise. `callback` will be ignored."), At || yt.apply(void 0, ue2);
              });
            }, Wt = K(rt2, gt, Lt);
            At = Wt && typeof Wt.then == "function" && typeof Wt.catch == "function", e3(At, "`callback` is deprecated. Please return a promise instead."), At && Wt.then(function() {
              yt();
            }).catch(function(Nt) {
              yt(Nt || " ");
            });
          }), J;
        }).sort(function(W3, q3) {
          var K = W3.warningOnly, J = W3.ruleIndex, rt2 = q3.warningOnly, gt = q3.ruleIndex;
          return !!K == !!rt2 ? J - gt : K ? 1 : -1;
        }), O2;
        if (m2 === true)
          O2 = new Promise(function() {
            var W3 = Gwt(C8.mark(function q3(K, J) {
              var rt2, gt, yt;
              return C8.wrap(function(At) {
                for (; ; )
                  switch (At.prev = At.next) {
                    case 0:
                      rt2 = 0;
                    case 1:
                      if (!(rt2 < E.length)) {
                        At.next = 12;
                        break;
                      }
                      return gt = E[rt2], At.next = 5, qBt(T2, o, gt, p2, w2);
                    case 5:
                      if (yt = At.sent, !yt.length) {
                        At.next = 9;
                        break;
                      }
                      return J([{ errors: yt, rule: gt }]), At.abrupt("return");
                    case 9:
                      rt2 += 1, At.next = 1;
                      break;
                    case 12:
                      K([]);
                    case 13:
                    case "end":
                      return At.stop();
                  }
              }, q3);
            }));
            return function(q3, K) {
              return W3.apply(this, arguments);
            };
          }());
        else {
          var V3 = E.map(function(W3) {
            return qBt(T2, o, W3, p2, w2).then(function(q3) {
              return { errors: q3, rule: W3 };
            });
          });
          O2 = (m2 ? q4n(V3) : U4n(V3)).then(function(W3) {
            return Promise.reject(W3);
          });
        }
        return O2.catch(function(W3) {
          return W3;
        }), O2;
      }
      function U4n(u) {
        return $Bt.apply(this, arguments);
      }
      function $Bt() {
        return $Bt = Gwt(C8.mark(function u(o) {
          return C8.wrap(function(n3) {
            for (; ; )
              switch (n3.prev = n3.next) {
                case 0:
                  return n3.abrupt("return", Promise.all(o).then(function(p2) {
                    var m2, w2 = (m2 = []).concat.apply(m2, Bp(p2));
                    return w2;
                  }));
                case 1:
                case "end":
                  return n3.stop();
              }
          }, u);
        })), $Bt.apply(this, arguments);
      }
      function q4n(u) {
        return YBt.apply(this, arguments);
      }
      function YBt() {
        return YBt = Gwt(C8.mark(function u(o) {
          var n3;
          return C8.wrap(function(p2) {
            for (; ; )
              switch (p2.prev = p2.next) {
                case 0:
                  return n3 = 0, p2.abrupt("return", new Promise(function(m2) {
                    o.forEach(function(w2) {
                      w2.then(function(T2) {
                        T2.errors.length && m2([T2]), n3 += 1, n3 === o.length && m2([]);
                      });
                    });
                  }));
                case 2:
                case "end":
                  return p2.stop();
              }
          }, u);
        })), YBt.apply(this, arguments);
      }
      var Z4n = ["name"], MI = [];
      function rCe(u, o, n3, p2, m2, w2) {
        return typeof u == "function" ? u(o, n3, "source" in w2 ? { source: w2.source } : {}) : p2 !== m2;
      }
      var KBt = function(u) {
        EBt(n3, u);
        var o = PBt(n3);
        function n3(p2) {
          var m2;
          if (Fst(this, n3), m2 = o.call(this, p2), m2.state = { resetCount: 0 }, m2.cancelRegisterFunc = null, m2.mounted = false, m2.touched = false, m2.dirty = false, m2.validatePromise = null, m2.prevValidating = void 0, m2.errors = MI, m2.warnings = MI, m2.cancelRegister = function() {
            var O2 = m2.props, V3 = O2.preserve, W3 = O2.isListField, q3 = O2.name;
            m2.cancelRegisterFunc && m2.cancelRegisterFunc(W3, V3, jm(q3)), m2.cancelRegisterFunc = null;
          }, m2.getNamePath = function() {
            var O2 = m2.props, V3 = O2.name, W3 = O2.fieldContext, q3 = W3.prefixName, K = q3 === void 0 ? [] : q3;
            return V3 !== void 0 ? [].concat(Bp(K), Bp(V3)) : [];
          }, m2.getRules = function() {
            var O2 = m2.props, V3 = O2.rules, W3 = V3 === void 0 ? [] : V3, q3 = O2.fieldContext;
            return W3.map(function(K) {
              return typeof K == "function" ? K(q3) : K;
            });
          }, m2.refresh = function() {
            !m2.mounted || m2.setState(function(O2) {
              var V3 = O2.resetCount;
              return { resetCount: V3 + 1 };
            });
          }, m2.triggerMetaEvent = function(O2) {
            var V3 = m2.props.onMetaChange;
            V3 == null || V3(mf2(mf2({}, m2.getMeta()), {}, { destroy: O2 }));
          }, m2.onStoreChange = function(O2, V3, W3) {
            var q3 = m2.props, K = q3.shouldUpdate, J = q3.dependencies, rt2 = J === void 0 ? [] : J, gt = q3.onReset, yt = W3.store, At = m2.getNamePath(), Lt = m2.getValue(O2), Wt = m2.getValue(yt), Nt = V3 && Hst(V3, At);
            switch (W3.type === "valueUpdate" && W3.source === "external" && Lt !== Wt && (m2.touched = true, m2.dirty = true, m2.validatePromise = null, m2.errors = MI, m2.warnings = MI, m2.triggerMetaEvent()), W3.type) {
              case "reset":
                if (!V3 || Nt) {
                  m2.touched = false, m2.dirty = false, m2.validatePromise = null, m2.errors = MI, m2.warnings = MI, m2.triggerMetaEvent(), gt == null || gt(), m2.refresh();
                  return;
                }
                break;
              case "remove": {
                if (K) {
                  m2.reRender();
                  return;
                }
                break;
              }
              case "setField": {
                if (Nt) {
                  var ue2 = W3.data;
                  "touched" in ue2 && (m2.touched = ue2.touched), "validating" in ue2 && !("originRCField" in ue2) && (m2.validatePromise = ue2.validating ? Promise.resolve([]) : null), "errors" in ue2 && (m2.errors = ue2.errors || MI), "warnings" in ue2 && (m2.warnings = ue2.warnings || MI), m2.dirty = true, m2.triggerMetaEvent(), m2.reRender();
                  return;
                }
                if (K && !At.length && rCe(K, O2, yt, Lt, Wt, W3)) {
                  m2.reRender();
                  return;
                }
                break;
              }
              case "dependenciesUpdate": {
                var ie2 = rt2.map(jm);
                if (ie2.some(function(pe2) {
                  return Hst(W3.relatedFields, pe2);
                })) {
                  m2.reRender();
                  return;
                }
                break;
              }
              default:
                if (Nt || (!rt2.length || At.length || K) && rCe(K, O2, yt, Lt, Wt, W3)) {
                  m2.reRender();
                  return;
                }
                break;
            }
            K === true && m2.reRender();
          }, m2.validateRules = function(O2) {
            var V3 = m2.getNamePath(), W3 = m2.getValue(), q3 = Promise.resolve().then(function() {
              if (!m2.mounted)
                return [];
              var K = m2.props, J = K.validateFirst, rt2 = J === void 0 ? false : J, gt = K.messageVariables, yt = O2 || {}, At = yt.triggerName, Lt = m2.getRules();
              At && (Lt = Lt.filter(function(Nt) {
                var ue2 = Nt.validateTrigger;
                if (!ue2)
                  return true;
                var ie2 = VBt(ue2);
                return ie2.includes(At);
              }));
              var Wt = H4n(V3, W3, Lt, O2, rt2, gt);
              return Wt.catch(function(Nt) {
                return Nt;
              }).then(function() {
                var Nt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : MI;
                if (m2.validatePromise === q3) {
                  m2.validatePromise = null;
                  var ue2 = [], ie2 = [];
                  Nt.forEach(function(pe2) {
                    var xe = pe2.rule.warningOnly, Ce2 = pe2.errors, Le2 = Ce2 === void 0 ? MI : Ce2;
                    xe ? ie2.push.apply(ie2, Bp(Le2)) : ue2.push.apply(ue2, Bp(Le2));
                  }), m2.errors = ue2, m2.warnings = ie2, m2.triggerMetaEvent(), m2.reRender();
                }
              }), Wt;
            });
            return m2.validatePromise = q3, m2.dirty = true, m2.errors = MI, m2.warnings = MI, m2.triggerMetaEvent(), m2.reRender(), q3;
          }, m2.isFieldValidating = function() {
            return !!m2.validatePromise;
          }, m2.isFieldTouched = function() {
            return m2.touched;
          }, m2.isFieldDirty = function() {
            if (m2.dirty || m2.props.initialValue !== void 0)
              return true;
            var O2 = m2.props.fieldContext, V3 = O2.getInternalHooks(LY), W3 = V3.getInitialValue;
            return W3(m2.getNamePath()) !== void 0;
          }, m2.getErrors = function() {
            return m2.errors;
          }, m2.getWarnings = function() {
            return m2.warnings;
          }, m2.isListField = function() {
            return m2.props.isListField;
          }, m2.isList = function() {
            return m2.props.isList;
          }, m2.isPreserve = function() {
            return m2.props.preserve;
          }, m2.getMeta = function() {
            m2.prevValidating = m2.isFieldValidating();
            var O2 = { touched: m2.isFieldTouched(), validating: m2.prevValidating, errors: m2.errors, warnings: m2.warnings, name: m2.getNamePath() };
            return O2;
          }, m2.getOnlyChild = function(O2) {
            if (typeof O2 == "function") {
              var V3 = m2.getMeta();
              return mf2(mf2({}, m2.getOnlyChild(O2(m2.getControlled(), V3, m2.props.fieldContext))), {}, { isFunction: true });
            }
            var W3 = FBt(O2);
            return W3.length !== 1 || !Y3.isValidElement(W3[0]) ? { child: W3, isFunction: false } : { child: W3[0], isFunction: false };
          }, m2.getValue = function(O2) {
            var V3 = m2.props.fieldContext.getFieldsValue, W3 = m2.getNamePath();
            return RY(O2 || V3(true), W3);
          }, m2.getControlled = function() {
            var O2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, V3 = m2.props, W3 = V3.trigger, q3 = V3.validateTrigger, K = V3.getValueFromEvent, J = V3.normalize, rt2 = V3.valuePropName, gt = V3.getValueProps, yt = V3.fieldContext, At = q3 !== void 0 ? q3 : yt.validateTrigger, Lt = m2.getNamePath(), Wt = yt.getInternalHooks, Nt = yt.getFieldsValue, ue2 = Wt(LY), ie2 = ue2.dispatch, pe2 = m2.getValue(), xe = gt || function(tn) {
              return Yd2({}, rt2, tn);
            }, Ce2 = O2[W3], Le2 = mf2(mf2({}, O2), xe(pe2));
            Le2[W3] = function() {
              m2.touched = true, m2.dirty = true, m2.triggerMetaEvent();
              for (var tn, $e2 = arguments.length, Tn = new Array($e2), zn = 0; zn < $e2; zn++)
                Tn[zn] = arguments[zn];
              K ? tn = K.apply(void 0, Tn) : tn = j4n.apply(void 0, [rt2].concat(Tn)), J && (tn = J(tn, pe2, Nt(true))), ie2({ type: "updateValue", namePath: Lt, value: tn }), Ce2 && Ce2.apply(void 0, Tn);
            };
            var ze = VBt(At || []);
            return ze.forEach(function(tn) {
              var $e2 = Le2[tn];
              Le2[tn] = function() {
                $e2 && $e2.apply(void 0, arguments);
                var Tn = m2.props.rules;
                Tn && Tn.length && ie2({ type: "validateField", namePath: Lt, triggerName: tn });
              };
            }), Le2;
          }, p2.fieldContext) {
            var w2 = p2.fieldContext.getInternalHooks, T2 = w2(LY), E = T2.initEntityValue;
            E(kBt(m2));
          }
          return m2;
        }
        return Vst(n3, [{ key: "componentDidMount", value: function() {
          var p2 = this.props, m2 = p2.shouldUpdate, w2 = p2.fieldContext;
          if (this.mounted = true, w2) {
            var T2 = w2.getInternalHooks, E = T2(LY), O2 = E.registerField;
            this.cancelRegisterFunc = O2(this);
          }
          m2 === true && this.reRender();
        } }, { key: "componentWillUnmount", value: function() {
          this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
        } }, { key: "reRender", value: function() {
          !this.mounted || this.forceUpdate();
        } }, { key: "render", value: function() {
          var p2 = this.state.resetCount, m2 = this.props.children, w2 = this.getOnlyChild(m2), T2 = w2.child, E = w2.isFunction, O2;
          return E ? O2 = T2 : Y3.isValidElement(T2) ? O2 = Y3.cloneElement(T2, this.getControlled(T2.props)) : (e3(!T2, "`children` of Field is not validate ReactElement."), O2 = T2), Y3.createElement(Y3.Fragment, { key: p2 }, O2);
        } }]), n3;
      }(Y3.Component);
      KBt.contextType = Bst, KBt.defaultProps = { trigger: "onChange", valuePropName: "value" };
      function iCe(u) {
        var o = u.name, n3 = kY(u, Z4n), p2 = Y3.useContext(Bst), m2 = o !== void 0 ? jm(o) : void 0, w2 = "keep";
        return n3.isListField || (w2 = "_".concat((m2 || []).join("_"))), Y3.createElement(KBt, zm({ key: w2, name: m2 }, n3, { fieldContext: p2 }));
      }
      var $4n = Y3.createContext(null), Y4n = function(u) {
        var o = u.name, n3 = u.initialValue, p2 = u.children, m2 = u.rules, w2 = u.validateTrigger, T2 = Y3.useContext(Bst), E = Y3.useRef({ keys: [], id: 0 }), O2 = E.current, V3 = Y3.useMemo(function() {
          var J = jm(T2.prefixName) || [];
          return [].concat(Bp(J), Bp(jm(o)));
        }, [T2.prefixName, o]), W3 = Y3.useMemo(function() {
          return mf2(mf2({}, T2), {}, { prefixName: V3 });
        }, [T2, V3]), q3 = Y3.useMemo(function() {
          return { getKey: function(J) {
            var rt2 = V3.length, gt = J[rt2];
            return [O2.keys[gt], J.slice(rt2 + 1)];
          } };
        }, [V3]);
        if (typeof p2 != "function")
          return e3(false, "Form.List only accepts function as children."), null;
        var K = function(J, rt2, gt) {
          var yt = gt.source;
          return yt === "internal" ? false : J !== rt2;
        };
        return Y3.createElement($4n.Provider, { value: q3 }, Y3.createElement(Bst.Provider, { value: W3 }, Y3.createElement(iCe, { name: [], shouldUpdate: K, rules: m2, validateTrigger: w2, initialValue: n3, isList: true }, function(J, rt2) {
          var gt = J.value, yt = gt === void 0 ? [] : gt, At = J.onChange, Lt = T2.getFieldValue, Wt = function() {
            var ie2 = Lt(V3 || []);
            return ie2 || [];
          }, Nt = { add: function(ie2, pe2) {
            var xe = Wt();
            pe2 >= 0 && pe2 <= xe.length ? (O2.keys = [].concat(Bp(O2.keys.slice(0, pe2)), [O2.id], Bp(O2.keys.slice(pe2))), At([].concat(Bp(xe.slice(0, pe2)), [ie2], Bp(xe.slice(pe2))))) : (O2.keys = [].concat(Bp(O2.keys), [O2.id]), At([].concat(Bp(xe), [ie2]))), O2.id += 1;
          }, remove: function(ie2) {
            var pe2 = Wt(), xe = new Set(Array.isArray(ie2) ? ie2 : [ie2]);
            xe.size <= 0 || (O2.keys = O2.keys.filter(function(Ce2, Le2) {
              return !xe.has(Le2);
            }), At(pe2.filter(function(Ce2, Le2) {
              return !xe.has(Le2);
            })));
          }, move: function(ie2, pe2) {
            if (ie2 !== pe2) {
              var xe = Wt();
              ie2 < 0 || ie2 >= xe.length || pe2 < 0 || pe2 >= xe.length || (O2.keys = nCe(O2.keys, ie2, pe2), At(nCe(xe, ie2, pe2)));
            }
          } }, ue2 = yt || [];
          return Array.isArray(ue2) || (ue2 = []), p2(ue2.map(function(ie2, pe2) {
            var xe = O2.keys[pe2];
            return xe === void 0 && (O2.keys[pe2] = O2.id, xe = O2.keys[pe2], O2.id += 1), { name: pe2, key: xe, isListField: true };
          }), Nt, rt2);
        })));
      };
      function K4n(u) {
        var o = false, n3 = u.length, p2 = [];
        return u.length ? new Promise(function(m2, w2) {
          u.forEach(function(T2, E) {
            T2.catch(function(O2) {
              return o = true, O2;
            }).then(function(O2) {
              n3 -= 1, p2[E] = O2, !(n3 > 0) && (o && w2(p2), m2(p2));
            });
          });
        }) : Promise.resolve([]);
      }
      var aCe = "__@field_split__";
      function XBt(u) {
        return u.map(function(o) {
          return "".concat(Ew(o), ":").concat(o);
        }).join(aCe);
      }
      var Ust = function() {
        function u() {
          Fst(this, u), this.kvs = /* @__PURE__ */ new Map();
        }
        return Vst(u, [{ key: "set", value: function(o, n3) {
          this.kvs.set(XBt(o), n3);
        } }, { key: "get", value: function(o) {
          return this.kvs.get(XBt(o));
        } }, { key: "update", value: function(o, n3) {
          var p2 = this.get(o), m2 = n3(p2);
          m2 ? this.set(o, m2) : this.delete(o);
        } }, { key: "delete", value: function(o) {
          this.kvs.delete(XBt(o));
        } }, { key: "map", value: function(o) {
          return Bp(this.kvs.entries()).map(function(n3) {
            var p2 = wI(n3, 2), m2 = p2[0], w2 = p2[1], T2 = m2.split(aCe);
            return o({ key: T2.map(function(E) {
              var O2 = E.match(/^([^:]*):(.*)$/), V3 = wI(O2, 3), W3 = V3[1], q3 = V3[2];
              return W3 === "number" ? Number(q3) : q3;
            }), value: w2 });
          });
        } }, { key: "toJSON", value: function() {
          var o = {};
          return this.map(function(n3) {
            var p2 = n3.key, m2 = n3.value;
            return o[p2.join(".")] = m2, null;
          }), o;
        } }]), u;
      }(), X4n = ["name", "errors"], Q4n = Vst(function u(o) {
        var n3 = this;
        Fst(this, u), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
          return { getFieldValue: n3.getFieldValue, getFieldsValue: n3.getFieldsValue, getFieldError: n3.getFieldError, getFieldWarning: n3.getFieldWarning, getFieldsError: n3.getFieldsError, isFieldsTouched: n3.isFieldsTouched, isFieldTouched: n3.isFieldTouched, isFieldValidating: n3.isFieldValidating, isFieldsValidating: n3.isFieldsValidating, resetFields: n3.resetFields, setFields: n3.setFields, setFieldsValue: n3.setFieldsValue, validateFields: n3.validateFields, submit: n3.submit, getInternalHooks: n3.getInternalHooks };
        }, this.getInternalHooks = function(p2) {
          return p2 === LY ? (n3.formHooked = true, { dispatch: n3.dispatch, initEntityValue: n3.initEntityValue, registerField: n3.registerField, useSubscribe: n3.useSubscribe, setInitialValues: n3.setInitialValues, setCallbacks: n3.setCallbacks, setValidateMessages: n3.setValidateMessages, getFields: n3.getFields, setPreserve: n3.setPreserve, getInitialValue: n3.getInitialValue }) : (e3(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
        }, this.useSubscribe = function(p2) {
          n3.subscribable = p2;
        }, this.setInitialValues = function(p2, m2) {
          n3.initialValues = p2 || {}, m2 && (n3.store = Uwt({}, p2, n3.store));
        }, this.getInitialValue = function(p2) {
          return RY(n3.initialValues, p2);
        }, this.setCallbacks = function(p2) {
          n3.callbacks = p2;
        }, this.setValidateMessages = function(p2) {
          n3.validateMessages = p2;
        }, this.setPreserve = function(p2) {
          n3.preserve = p2;
        }, this.timeoutId = null, this.warningUnhooked = function() {
        }, this.getFieldEntities = function() {
          var p2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
          return p2 ? n3.fieldEntities.filter(function(m2) {
            return m2.getNamePath().length;
          }) : n3.fieldEntities;
        }, this.getFieldsMap = function() {
          var p2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, m2 = new Ust();
          return n3.getFieldEntities(p2).forEach(function(w2) {
            var T2 = w2.getNamePath();
            m2.set(T2, w2);
          }), m2;
        }, this.getFieldEntitiesForNamePathList = function(p2) {
          if (!p2)
            return n3.getFieldEntities(true);
          var m2 = n3.getFieldsMap(true);
          return p2.map(function(w2) {
            var T2 = jm(w2);
            return m2.get(T2) || { INVALIDATE_NAME_PATH: jm(w2) };
          });
        }, this.getFieldsValue = function(p2, m2) {
          if (n3.warningUnhooked(), p2 === true && !m2)
            return n3.store;
          var w2 = n3.getFieldEntitiesForNamePathList(Array.isArray(p2) ? p2 : null), T2 = [];
          return w2.forEach(function(E) {
            var O2, V3 = "INVALIDATE_NAME_PATH" in E ? E.INVALIDATE_NAME_PATH : E.getNamePath();
            if (!(!p2 && ((O2 = E.isListField) === null || O2 === void 0 ? void 0 : O2.call(E))))
              if (!m2)
                T2.push(V3);
              else {
                var W3 = "getMeta" in E ? E.getMeta() : null;
                m2(W3) && T2.push(V3);
              }
          }), QMe(n3.store, T2.map(jm));
        }, this.getFieldValue = function(p2) {
          n3.warningUnhooked();
          var m2 = jm(p2);
          return RY(n3.store, m2);
        }, this.getFieldsError = function(p2) {
          n3.warningUnhooked();
          var m2 = n3.getFieldEntitiesForNamePathList(p2);
          return m2.map(function(w2, T2) {
            return w2 && !("INVALIDATE_NAME_PATH" in w2) ? { name: w2.getNamePath(), errors: w2.getErrors(), warnings: w2.getWarnings() } : { name: jm(p2[T2]), errors: [], warnings: [] };
          });
        }, this.getFieldError = function(p2) {
          n3.warningUnhooked();
          var m2 = jm(p2), w2 = n3.getFieldsError([m2])[0];
          return w2.errors;
        }, this.getFieldWarning = function(p2) {
          n3.warningUnhooked();
          var m2 = jm(p2), w2 = n3.getFieldsError([m2])[0];
          return w2.warnings;
        }, this.isFieldsTouched = function() {
          n3.warningUnhooked();
          for (var p2 = arguments.length, m2 = new Array(p2), w2 = 0; w2 < p2; w2++)
            m2[w2] = arguments[w2];
          var T2 = m2[0], E = m2[1], O2, V3 = false;
          m2.length === 0 ? O2 = null : m2.length === 1 ? Array.isArray(T2) ? (O2 = T2.map(jm), V3 = false) : (O2 = null, V3 = T2) : (O2 = T2.map(jm), V3 = E);
          var W3 = n3.getFieldEntities(true), q3 = function(gt) {
            return gt.isFieldTouched();
          };
          if (!O2)
            return V3 ? W3.every(q3) : W3.some(q3);
          var K = new Ust();
          O2.forEach(function(gt) {
            K.set(gt, []);
          }), W3.forEach(function(gt) {
            var yt = gt.getNamePath();
            O2.forEach(function(At) {
              At.every(function(Lt, Wt) {
                return yt[Wt] === Lt;
              }) && K.update(At, function(Lt) {
                return [].concat(Bp(Lt), [gt]);
              });
            });
          });
          var J = function(gt) {
            return gt.some(q3);
          }, rt2 = K.map(function(gt) {
            var yt = gt.value;
            return yt;
          });
          return V3 ? rt2.every(J) : rt2.some(J);
        }, this.isFieldTouched = function(p2) {
          return n3.warningUnhooked(), n3.isFieldsTouched([p2]);
        }, this.isFieldsValidating = function(p2) {
          n3.warningUnhooked();
          var m2 = n3.getFieldEntities();
          if (!p2)
            return m2.some(function(T2) {
              return T2.isFieldValidating();
            });
          var w2 = p2.map(jm);
          return m2.some(function(T2) {
            var E = T2.getNamePath();
            return Hst(w2, E) && T2.isFieldValidating();
          });
        }, this.isFieldValidating = function(p2) {
          return n3.warningUnhooked(), n3.isFieldsValidating([p2]);
        }, this.resetWithFieldInitialValue = function() {
          var p2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, m2 = new Ust(), w2 = n3.getFieldEntities(true);
          w2.forEach(function(O2) {
            var V3 = O2.props.initialValue, W3 = O2.getNamePath();
            if (V3 !== void 0) {
              var q3 = m2.get(W3) || /* @__PURE__ */ new Set();
              q3.add({ entity: O2, value: V3 }), m2.set(W3, q3);
            }
          });
          var T2 = function(O2) {
            O2.forEach(function(V3) {
              var W3 = V3.props.initialValue;
              if (W3 !== void 0) {
                var q3 = V3.getNamePath(), K = n3.getInitialValue(q3);
                if (K !== void 0)
                  e3(false, "Form already set 'initialValues' with path '".concat(q3.join("."), "'. Field can not overwrite it."));
                else {
                  var J = m2.get(q3);
                  if (J && J.size > 1)
                    e3(false, "Multiple Field with path '".concat(q3.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                  else if (J) {
                    var rt2 = n3.getFieldValue(q3);
                    (!p2.skipExist || rt2 === void 0) && (n3.store = aj2(n3.store, q3, Bp(J)[0].value));
                  }
                }
              }
            });
          }, E;
          p2.entities ? E = p2.entities : p2.namePathList ? (E = [], p2.namePathList.forEach(function(O2) {
            var V3 = m2.get(O2);
            if (V3) {
              var W3;
              (W3 = E).push.apply(W3, Bp(Bp(V3).map(function(q3) {
                return q3.entity;
              })));
            }
          })) : E = w2, T2(E);
        }, this.resetFields = function(p2) {
          n3.warningUnhooked();
          var m2 = n3.store;
          if (!p2) {
            n3.store = Uwt({}, n3.initialValues), n3.resetWithFieldInitialValue(), n3.notifyObservers(m2, null, { type: "reset" });
            return;
          }
          var w2 = p2.map(jm);
          w2.forEach(function(T2) {
            var E = n3.getInitialValue(T2);
            n3.store = aj2(n3.store, T2, E);
          }), n3.resetWithFieldInitialValue({ namePathList: w2 }), n3.notifyObservers(m2, w2, { type: "reset" });
        }, this.setFields = function(p2) {
          n3.warningUnhooked();
          var m2 = n3.store;
          p2.forEach(function(w2) {
            var T2 = w2.name;
            w2.errors;
            var E = kY(w2, X4n), O2 = jm(T2);
            "value" in E && (n3.store = aj2(n3.store, O2, E.value)), n3.notifyObservers(m2, [O2], { type: "setField", data: w2 });
          });
        }, this.getFields = function() {
          var p2 = n3.getFieldEntities(true), m2 = p2.map(function(w2) {
            var T2 = w2.getNamePath(), E = w2.getMeta(), O2 = mf2(mf2({}, E), {}, { name: T2, value: n3.getFieldValue(T2) });
            return Object.defineProperty(O2, "originRCField", { value: true }), O2;
          });
          return m2;
        }, this.initEntityValue = function(p2) {
          var m2 = p2.props.initialValue;
          if (m2 !== void 0) {
            var w2 = p2.getNamePath(), T2 = RY(n3.store, w2);
            T2 === void 0 && (n3.store = aj2(n3.store, w2, m2));
          }
        }, this.registerField = function(p2) {
          if (n3.fieldEntities.push(p2), p2.props.initialValue !== void 0) {
            var m2 = n3.store;
            n3.resetWithFieldInitialValue({ entities: [p2], skipExist: true }), n3.notifyObservers(m2, [p2.getNamePath()], { type: "valueUpdate", source: "internal" });
          }
          return function(w2, T2) {
            var E = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
            n3.fieldEntities = n3.fieldEntities.filter(function(K) {
              return K !== p2;
            });
            var O2 = T2 !== void 0 ? T2 : n3.preserve;
            if (O2 === false && (!w2 || E.length > 1)) {
              var V3 = p2.getNamePath(), W3 = w2 ? void 0 : RY(n3.initialValues, V3);
              if (V3.length && n3.getFieldValue(V3) !== W3 && n3.fieldEntities.every(function(K) {
                return !eCe(K.getNamePath(), V3);
              })) {
                var q3 = n3.store;
                n3.store = aj2(q3, V3, W3, true), n3.notifyObservers(q3, [V3], { type: "remove" }), n3.triggerDependenciesUpdate(q3, V3);
              }
            }
          };
        }, this.dispatch = function(p2) {
          switch (p2.type) {
            case "updateValue": {
              var m2 = p2.namePath, w2 = p2.value;
              n3.updateValue(m2, w2);
              break;
            }
            case "validateField": {
              var T2 = p2.namePath, E = p2.triggerName;
              n3.validateFields([T2], { triggerName: E });
              break;
            }
          }
        }, this.notifyObservers = function(p2, m2, w2) {
          if (n3.subscribable) {
            var T2 = mf2(mf2({}, w2), {}, { store: n3.getFieldsValue(true) });
            n3.getFieldEntities().forEach(function(E) {
              var O2 = E.onStoreChange;
              O2(p2, m2, T2);
            });
          } else
            n3.forceRootUpdate();
        }, this.triggerDependenciesUpdate = function(p2, m2) {
          var w2 = n3.getDependencyChildrenFields(m2);
          return w2.length && n3.validateFields(w2), n3.notifyObservers(p2, w2, { type: "dependenciesUpdate", relatedFields: [m2].concat(Bp(w2)) }), w2;
        }, this.updateValue = function(p2, m2) {
          var w2 = jm(p2), T2 = n3.store;
          n3.store = aj2(n3.store, w2, m2), n3.notifyObservers(T2, [w2], { type: "valueUpdate", source: "internal" });
          var E = n3.triggerDependenciesUpdate(T2, w2), O2 = n3.callbacks.onValuesChange;
          if (O2) {
            var V3 = QMe(n3.store, [w2]);
            O2(V3, n3.getFieldsValue());
          }
          n3.triggerOnFieldsChange([w2].concat(Bp(E)));
        }, this.setFieldsValue = function(p2) {
          n3.warningUnhooked();
          var m2 = n3.store;
          p2 && (n3.store = Uwt(n3.store, p2)), n3.notifyObservers(m2, null, { type: "valueUpdate", source: "external" });
        }, this.getDependencyChildrenFields = function(p2) {
          var m2 = /* @__PURE__ */ new Set(), w2 = [], T2 = new Ust();
          n3.getFieldEntities().forEach(function(O2) {
            var V3 = O2.props.dependencies;
            (V3 || []).forEach(function(W3) {
              var q3 = jm(W3);
              T2.update(q3, function() {
                var K = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                return K.add(O2), K;
              });
            });
          });
          var E = function O2(V3) {
            var W3 = T2.get(V3) || /* @__PURE__ */ new Set();
            W3.forEach(function(q3) {
              if (!m2.has(q3)) {
                m2.add(q3);
                var K = q3.getNamePath();
                q3.isFieldDirty() && K.length && (w2.push(K), O2(K));
              }
            });
          };
          return E(p2), w2;
        }, this.triggerOnFieldsChange = function(p2, m2) {
          var w2 = n3.callbacks.onFieldsChange;
          if (w2) {
            var T2 = n3.getFields();
            if (m2) {
              var E = new Ust();
              m2.forEach(function(V3) {
                var W3 = V3.name, q3 = V3.errors;
                E.set(W3, q3);
              }), T2.forEach(function(V3) {
                V3.errors = E.get(V3.name) || V3.errors;
              });
            }
            var O2 = T2.filter(function(V3) {
              var W3 = V3.name;
              return Hst(p2, W3);
            });
            w2(O2, T2);
          }
        }, this.validateFields = function(p2, m2) {
          n3.warningUnhooked();
          var w2 = !!p2, T2 = w2 ? p2.map(jm) : [], E = [];
          n3.getFieldEntities(true).forEach(function(W3) {
            if (w2 || T2.push(W3.getNamePath()), (m2 == null ? void 0 : m2.recursive) && w2) {
              var q3 = W3.getNamePath();
              q3.every(function(rt2, gt) {
                return p2[gt] === rt2 || p2[gt] === void 0;
              }) && T2.push(q3);
            }
            if (!(!W3.props.rules || !W3.props.rules.length)) {
              var K = W3.getNamePath();
              if (!w2 || Hst(T2, K)) {
                var J = W3.validateRules(mf2({ validateMessages: mf2(mf2({}, YMe), n3.validateMessages) }, m2));
                E.push(J.then(function() {
                  return { name: K, errors: [], warnings: [] };
                }).catch(function(rt2) {
                  var gt = [], yt = [];
                  return rt2.forEach(function(At) {
                    var Lt = At.rule.warningOnly, Wt = At.errors;
                    Lt ? yt.push.apply(yt, Bp(Wt)) : gt.push.apply(gt, Bp(Wt));
                  }), gt.length ? Promise.reject({ name: K, errors: gt, warnings: yt }) : { name: K, errors: gt, warnings: yt };
                }));
              }
            }
          });
          var O2 = K4n(E);
          n3.lastValidatePromise = O2, O2.catch(function(W3) {
            return W3;
          }).then(function(W3) {
            var q3 = W3.map(function(K) {
              var J = K.name;
              return J;
            });
            n3.notifyObservers(n3.store, q3, { type: "validateFinish" }), n3.triggerOnFieldsChange(q3, W3);
          });
          var V3 = O2.then(function() {
            return n3.lastValidatePromise === O2 ? Promise.resolve(n3.getFieldsValue(T2)) : Promise.reject([]);
          }).catch(function(W3) {
            var q3 = W3.filter(function(K) {
              return K && K.errors.length;
            });
            return Promise.reject({ values: n3.getFieldsValue(T2), errorFields: q3, outOfDate: n3.lastValidatePromise !== O2 });
          });
          return V3.catch(function(W3) {
            return W3;
          }), V3;
        }, this.submit = function() {
          n3.warningUnhooked(), n3.validateFields().then(function(p2) {
            var m2 = n3.callbacks.onFinish;
            if (m2)
              try {
                m2(p2);
              } catch (w2) {
                console.error(w2);
              }
          }).catch(function(p2) {
            var m2 = n3.callbacks.onFinishFailed;
            m2 && m2(p2);
          });
        }, this.forceRootUpdate = o;
      });
      function oCe(u) {
        var o = Y3.useRef(), n3 = Y3.useState({}), p2 = wI(n3, 2), m2 = p2[1];
        if (!o.current)
          if (u)
            o.current = u;
          else {
            var w2 = function() {
              m2({});
            }, T2 = new Q4n(w2);
            o.current = T2.getForm();
          }
        return [o.current];
      }
      var QBt = Y3.createContext({ triggerFormChange: function() {
      }, triggerFormFinish: function() {
      }, registerForm: function() {
      }, unregisterForm: function() {
      } }), J4n = function(u) {
        var o = u.validateMessages, n3 = u.onFormChange, p2 = u.onFormFinish, m2 = u.children, w2 = Y3.useContext(QBt), T2 = Y3.useRef({});
        return Y3.createElement(QBt.Provider, { value: mf2(mf2({}, w2), {}, { validateMessages: mf2(mf2({}, w2.validateMessages), o), triggerFormChange: function(E, O2) {
          n3 && n3(E, { changedFields: O2, forms: T2.current }), w2.triggerFormChange(E, O2);
        }, triggerFormFinish: function(E, O2) {
          p2 && p2(E, { values: O2, forms: T2.current }), w2.triggerFormFinish(E, O2);
        }, registerForm: function(E, O2) {
          E && (T2.current = mf2(mf2({}, T2.current), {}, Yd2({}, E, O2))), w2.registerForm(E, O2);
        }, unregisterForm: function(E) {
          var O2 = mf2({}, T2.current);
          delete O2[E], T2.current = O2, w2.unregisterForm(E);
        } }) }, m2);
      }, tRn = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], eRn = function(u, o) {
        var n3 = u.name, p2 = u.initialValues, m2 = u.fields, w2 = u.form, T2 = u.preserve, E = u.children, O2 = u.component, V3 = O2 === void 0 ? "form" : O2, W3 = u.validateMessages, q3 = u.validateTrigger, K = q3 === void 0 ? "onChange" : q3, J = u.onValuesChange, rt2 = u.onFieldsChange, gt = u.onFinish, yt = u.onFinishFailed, At = kY(u, tRn), Lt = Y3.useContext(QBt), Wt = oCe(w2), Nt = wI(Wt, 1), ue2 = Nt[0], ie2 = ue2.getInternalHooks(LY), pe2 = ie2.useSubscribe, xe = ie2.setInitialValues, Ce2 = ie2.setCallbacks, Le2 = ie2.setValidateMessages, ze = ie2.setPreserve;
        Y3.useImperativeHandle(o, function() {
          return ue2;
        }), Y3.useEffect(function() {
          return Lt.registerForm(n3, ue2), function() {
            Lt.unregisterForm(n3);
          };
        }, [Lt, ue2, n3]), Le2(mf2(mf2({}, Lt.validateMessages), W3)), Ce2({ onValuesChange: J, onFieldsChange: function(or) {
          if (Lt.triggerFormChange(n3, or), rt2) {
            for (var Tr = arguments.length, ci2 = new Array(Tr > 1 ? Tr - 1 : 0), yi2 = 1; yi2 < Tr; yi2++)
              ci2[yi2 - 1] = arguments[yi2];
            rt2.apply(void 0, [or].concat(ci2));
          }
        }, onFinish: function(or) {
          Lt.triggerFormFinish(n3, or), gt && gt(or);
        }, onFinishFailed: yt }), ze(T2);
        var tn = Y3.useRef(null);
        xe(p2, !tn.current), tn.current || (tn.current = true);
        var $e2 = E, Tn = typeof E == "function";
        if (Tn) {
          var zn = ue2.getFieldsValue(true);
          $e2 = E(zn, ue2);
        }
        pe2(!Tn);
        var bn = Y3.useRef();
        Y3.useEffect(function() {
          z4n(bn.current || [], m2 || []) || ue2.setFields(m2 || []), bn.current = m2;
        }, [m2, ue2]);
        var Xr = Y3.useMemo(function() {
          return mf2(mf2({}, ue2), {}, { validateTrigger: K });
        }, [ue2, K]), Xn = Y3.createElement(Bst.Provider, { value: Xr }, $e2);
        return V3 === false ? Xn : Y3.createElement(V3, zm({}, At, { onSubmit: function(or) {
          or.preventDefault(), or.stopPropagation(), ue2.submit();
        }, onReset: function(or) {
          var Tr;
          or.preventDefault(), ue2.resetFields(), (Tr = At.onReset) === null || Tr === void 0 || Tr.call(At, or);
        } }), Xn);
      }, nRn = Y3.forwardRef(eRn), qwt = nRn;
      qwt.FormProvider = J4n, qwt.Field = iCe, qwt.List = Y4n, qwt.useForm = oCe;
      var rRn = function(u, o, n3) {
        e3(u, "[antd: ".concat(o, "] ").concat(n3));
      }, iRn = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, aRn = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, oRn = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, sCe = oRn, sRn = { lang: zm({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, aRn), timePickerLocale: zm({}, sCe) }, lCe = sRn, FC = "${label} is not a valid ${type}", lRn = { locale: "en", Pagination: iRn, DatePicker: lCe, TimePicker: sCe, Calendar: lCe, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: FC, method: FC, array: FC, object: FC, number: FC, date: FC, boolean: FC, integer: FC, float: FC, regexp: FC, email: FC, url: FC, hex: FC }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, uCe = lRn, uRn = L.createContext(void 0), cRn = uRn, JBt = function(u) {
        EBt(n3, u);
        var o = PBt(n3);
        function n3() {
          return Fst(this, n3), o.apply(this, arguments);
        }
        return Vst(n3, [{ key: "getLocale", value: function() {
          var p2 = this.props, m2 = p2.componentName, w2 = p2.defaultLocale, T2 = w2 || uCe[m2 != null ? m2 : "global"], E = this.context, O2 = m2 && E ? E[m2] : {};
          return zm(zm({}, T2 instanceof Function ? T2() : T2), O2 || {});
        } }, { key: "getLocaleCode", value: function() {
          var p2 = this.context, m2 = p2 && p2.locale;
          return p2 && p2.exist && !m2 ? uCe.locale : m2;
        } }, { key: "render", value: function() {
          return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
        } }]), n3;
      }(Y3.Component);
      JBt.defaultProps = { componentName: "global" }, JBt.contextType = cRn;
      var fRn = function() {
        var u = Y3.useContext(T8), o = u.getPrefixCls, n3 = o("empty-img-default");
        return Y3.createElement("svg", { className: n3, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, Y3.createElement("g", { fill: "none", fillRule: "evenodd" }, Y3.createElement("g", { transform: "translate(24 31.67)" }, Y3.createElement("ellipse", { className: "".concat(n3, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), Y3.createElement("path", { className: "".concat(n3, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), Y3.createElement("path", { className: "".concat(n3, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), Y3.createElement("path", { className: "".concat(n3, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), Y3.createElement("path", { className: "".concat(n3, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), Y3.createElement("path", { className: "".concat(n3, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), Y3.createElement("g", { className: "".concat(n3, "-g"), transform: "translate(149.65 15.383)" }, Y3.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), Y3.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
      }, hRn = fRn, pRn = function() {
        var u = Y3.useContext(T8), o = u.getPrefixCls, n3 = o("empty-img-simple");
        return Y3.createElement("svg", { className: n3, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, Y3.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, Y3.createElement("ellipse", { className: "".concat(n3, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), Y3.createElement("g", { className: "".concat(n3, "-g"), fillRule: "nonzero" }, Y3.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), Y3.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(n3, "-path") }))));
      }, dRn = pRn, gRn = globalThis && globalThis.__rest || function(u, o) {
        var n3 = {};
        for (var p2 in u)
          Object.prototype.hasOwnProperty.call(u, p2) && o.indexOf(p2) < 0 && (n3[p2] = u[p2]);
        if (u != null && typeof Object.getOwnPropertySymbols == "function")
          for (var m2 = 0, p2 = Object.getOwnPropertySymbols(u); m2 < p2.length; m2++)
            o.indexOf(p2[m2]) < 0 && Object.prototype.propertyIsEnumerable.call(u, p2[m2]) && (n3[p2[m2]] = u[p2[m2]]);
        return n3;
      }, cCe = Y3.createElement(hRn, null), fCe = Y3.createElement(dRn, null), tzt = function(u) {
        var o = u.className, n3 = u.prefixCls, p2 = u.image, m2 = p2 === void 0 ? cCe : p2, w2 = u.description, T2 = u.children, E = u.imageStyle, O2 = gRn(u, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), V3 = Y3.useContext(T8), W3 = V3.getPrefixCls, q3 = V3.direction;
        return Y3.createElement(JBt, { componentName: "Empty" }, function(K) {
          var J, rt2 = W3("empty", n3), gt = typeof w2 != "undefined" ? w2 : K.description, yt = typeof gt == "string" ? gt : "empty", At = null;
          return typeof m2 == "string" ? At = Y3.createElement("img", { alt: yt, src: m2 }) : At = m2, Y3.createElement("div", zm({ className: PY(rt2, (J = {}, Yd2(J, "".concat(rt2, "-normal"), m2 === fCe), Yd2(J, "".concat(rt2, "-rtl"), q3 === "rtl"), J), o) }, O2), Y3.createElement("div", { className: "".concat(rt2, "-image"), style: E }, At), gt && Y3.createElement("div", { className: "".concat(rt2, "-description") }, gt), T2 && Y3.createElement("div", { className: "".concat(rt2, "-footer") }, T2));
        });
      };
      tzt.PRESENTED_IMAGE_DEFAULT = cCe, tzt.PRESENTED_IMAGE_SIMPLE = fCe;
      var qst = tzt, vRn = function(u) {
        return Y3.createElement(hCe, null, function(o) {
          var n3 = o.getPrefixCls, p2 = n3("empty");
          switch (u) {
            case "Table":
            case "List":
              return Y3.createElement(qst, { image: qst.PRESENTED_IMAGE_SIMPLE });
            case "Select":
            case "TreeSelect":
            case "Cascader":
            case "Transfer":
            case "Mentions":
              return Y3.createElement(qst, { image: qst.PRESENTED_IMAGE_SIMPLE, className: "".concat(p2, "-small") });
            default:
              return Y3.createElement(qst, null);
          }
        });
      }, yRn = vRn, mRn = function(u, o) {
        return o || (u ? "ant-".concat(u) : "ant");
      }, T8 = Y3.createContext({ getPrefixCls: mRn, renderEmpty: yRn }), hCe = T8.Consumer, bRn = Y3.createContext(void 0), _Rn = bRn, pCe = function(u) {
        return +setTimeout(u, 16);
      }, dCe = function(u) {
        return clearTimeout(u);
      };
      typeof window != "undefined" && "requestAnimationFrame" in window && (pCe = function(u) {
        return window.requestAnimationFrame(u);
      }, dCe = function(u) {
        return window.cancelAnimationFrame(u);
      });
      var gCe = 0, ezt = /* @__PURE__ */ new Map();
      function vCe(u) {
        ezt.delete(u);
      }
      function Zwt(u) {
        var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
        gCe += 1;
        var n3 = gCe;
        function p2(m2) {
          if (m2 === 0)
            vCe(n3), u();
          else {
            var w2 = pCe(function() {
              p2(m2 - 1);
            });
            ezt.set(n3, w2);
          }
        }
        return p2(o), n3;
      }
      Zwt.cancel = function(u) {
        var o = ezt.get(u);
        return vCe(o), dCe(o);
      };
      function xRn(u, o) {
        var n3 = o || {}, p2 = n3.defaultValue, m2 = n3.value, w2 = n3.onChange, T2 = n3.postState, E = Y3.useState(function() {
          return m2 !== void 0 ? m2 : p2 !== void 0 ? typeof p2 == "function" ? p2() : p2 : typeof u == "function" ? u() : u;
        }), O2 = wI(E, 2), V3 = O2[0], W3 = O2[1], q3 = m2 !== void 0 ? m2 : V3;
        T2 && (q3 = T2(q3));
        var K = Y3.useRef(w2);
        K.current = w2;
        var J = Y3.useCallback(function(gt) {
          W3(gt), q3 !== gt && K.current && K.current(gt, q3);
        }, [q3, K]), rt2 = Y3.useRef(true);
        return Y3.useEffect(function() {
          if (rt2.current) {
            rt2.current = false;
            return;
          }
          m2 === void 0 && W3(m2);
        }, [m2]), [q3, J];
      }
      var Cc2 = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(u) {
        var o = u.keyCode;
        if (u.altKey && !u.ctrlKey || u.metaKey || o >= Cc2.F1 && o <= Cc2.F12)
          return false;
        switch (o) {
          case Cc2.ALT:
          case Cc2.CAPS_LOCK:
          case Cc2.CONTEXT_MENU:
          case Cc2.CTRL:
          case Cc2.DOWN:
          case Cc2.END:
          case Cc2.ESC:
          case Cc2.HOME:
          case Cc2.INSERT:
          case Cc2.LEFT:
          case Cc2.MAC_FF_META:
          case Cc2.META:
          case Cc2.NUMLOCK:
          case Cc2.NUM_CENTER:
          case Cc2.PAGE_DOWN:
          case Cc2.PAGE_UP:
          case Cc2.PAUSE:
          case Cc2.PRINT_SCREEN:
          case Cc2.RIGHT:
          case Cc2.SHIFT:
          case Cc2.UP:
          case Cc2.WIN_KEY:
          case Cc2.WIN_KEY_RIGHT:
            return false;
          default:
            return true;
        }
      }, isCharacterKey: function(u) {
        if (u >= Cc2.ZERO && u <= Cc2.NINE || u >= Cc2.NUM_ZERO && u <= Cc2.NUM_MULTIPLY || u >= Cc2.A && u <= Cc2.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && u === 0)
          return true;
        switch (u) {
          case Cc2.SPACE:
          case Cc2.QUESTION_MARK:
          case Cc2.NUM_PLUS:
          case Cc2.NUM_MINUS:
          case Cc2.NUM_PERIOD:
          case Cc2.NUM_DIVISION:
          case Cc2.SEMICOLON:
          case Cc2.DASH:
          case Cc2.EQUALS:
          case Cc2.COMMA:
          case Cc2.PERIOD:
          case Cc2.SLASH:
          case Cc2.APOSTROPHE:
          case Cc2.SINGLE_QUOTE:
          case Cc2.OPEN_SQUARE_BRACKET:
          case Cc2.BACKSLASH:
          case Cc2.CLOSE_SQUARE_BRACKET:
            return true;
          default:
            return false;
        }
      } }, yCe = function() {
        for (var u = arguments.length, o = new Array(u), n3 = 0; n3 < u; n3++)
          o[n3] = arguments[n3];
        return o;
      }, wRn = Y3.isValidElement;
      function SRn(u, o, n3) {
        return wRn(u) ? Y3.cloneElement(u, typeof n3 == "function" ? n3(u.props || {}) : n3) : o;
      }
      function MRn(u, o) {
        return SRn(u, u, o);
      }
      var mCe = ["xxl", "xl", "lg", "md", "sm", "xs"], $wt = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, oj2 = /* @__PURE__ */ new Map(), nzt = -1, Ywt = {}, CRn = { matchHandlers: {}, dispatch: function(u) {
        return Ywt = u, oj2.forEach(function(o) {
          return o(Ywt);
        }), oj2.size >= 1;
      }, subscribe: function(u) {
        return oj2.size || this.register(), nzt += 1, oj2.set(nzt, u), u(Ywt), nzt;
      }, unsubscribe: function(u) {
        oj2.delete(u), oj2.size || this.unregister();
      }, unregister: function() {
        var u = this;
        Object.keys($wt).forEach(function(o) {
          var n3 = $wt[o], p2 = u.matchHandlers[n3];
          p2 == null || p2.mql.removeListener(p2 == null ? void 0 : p2.listener);
        }), oj2.clear();
      }, register: function() {
        var u = this;
        Object.keys($wt).forEach(function(o) {
          var n3 = $wt[o], p2 = function(w2) {
            var T2 = w2.matches;
            u.dispatch(zm(zm({}, Ywt), Yd2({}, o, T2)));
          }, m2 = window.matchMedia(n3);
          m2.addListener(p2), u.matchHandlers[n3] = { mql: m2, listener: p2 }, p2(m2);
        });
      } }, bCe = CRn, TRn = 0, NY = {};
      function Kwt(u) {
        var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, n3 = TRn++, p2 = o;
        function m2() {
          p2 -= 1, p2 <= 0 ? (u(), delete NY[n3]) : NY[n3] = Zwt(m2);
        }
        return NY[n3] = Zwt(m2), n3;
      }
      Kwt.cancel = function(u) {
        u !== void 0 && (Zwt.cancel(NY[u]), delete NY[u]);
      }, Kwt.ids = NY;
      var rzt;
      function _Ce(u) {
        return !u || u.offsetParent === null || u.hidden;
      }
      function ARn(u) {
        var o = (u || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
        return o && o[1] && o[2] && o[3] ? !(o[1] === o[2] && o[2] === o[3]) : true;
      }
      var xCe = function(u) {
        EBt(n3, u);
        var o = PBt(n3);
        function n3() {
          var p2;
          return Fst(this, n3), p2 = o.apply(this, arguments), p2.containerRef = Y3.createRef(), p2.animationStart = false, p2.destroyed = false, p2.onClick = function(m2, w2) {
            var T2, E, O2 = p2.props, V3 = O2.insertExtraNode, W3 = O2.disabled;
            if (!(W3 || !m2 || _Ce(m2) || m2.className.indexOf("-leave") >= 0)) {
              p2.extraNode = document.createElement("div");
              var q3 = kBt(p2), K = q3.extraNode, J = p2.context.getPrefixCls;
              K.className = "".concat(J(""), "-click-animating-node");
              var rt2 = p2.getAttributeName();
              if (m2.setAttribute(rt2, "true"), w2 && w2 !== "#ffffff" && w2 !== "rgb(255, 255, 255)" && ARn(w2) && !/rgba\((?:\d*, ){3}0\)/.test(w2) && w2 !== "transparent") {
                K.style.borderColor = w2;
                var gt = ((T2 = m2.getRootNode) === null || T2 === void 0 ? void 0 : T2.call(m2)) || m2.ownerDocument, yt = gt instanceof Document ? gt.body : (E = gt.firstChild) !== null && E !== void 0 ? E : gt;
                rzt = PMe(`
      [`.concat(J(""), "-click-animating-without-extra-node='true']::after, .").concat(J(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(w2, `;
      }`), "antd-wave", { csp: p2.csp, attachTo: yt });
              }
              V3 && m2.appendChild(K), ["transition", "animation"].forEach(function(At) {
                m2.addEventListener("".concat(At, "start"), p2.onTransitionStart), m2.addEventListener("".concat(At, "end"), p2.onTransitionEnd);
              });
            }
          }, p2.onTransitionStart = function(m2) {
            if (!p2.destroyed) {
              var w2 = p2.containerRef.current;
              !m2 || m2.target !== w2 || p2.animationStart || p2.resetEffect(w2);
            }
          }, p2.onTransitionEnd = function(m2) {
            !m2 || m2.animationName !== "fadeEffect" || p2.resetEffect(m2.target);
          }, p2.bindAnimationEvent = function(m2) {
            if (!(!m2 || !m2.getAttribute || m2.getAttribute("disabled") || m2.className.indexOf("disabled") >= 0)) {
              var w2 = function(T2) {
                if (!(T2.target.tagName === "INPUT" || _Ce(T2.target))) {
                  p2.resetEffect(m2);
                  var E = getComputedStyle(m2).getPropertyValue("border-top-color") || getComputedStyle(m2).getPropertyValue("border-color") || getComputedStyle(m2).getPropertyValue("background-color");
                  p2.clickWaveTimeoutId = window.setTimeout(function() {
                    return p2.onClick(m2, E);
                  }, 0), Kwt.cancel(p2.animationStartId), p2.animationStart = true, p2.animationStartId = Kwt(function() {
                    p2.animationStart = false;
                  }, 10);
                }
              };
              return m2.addEventListener("click", w2, true), { cancel: function() {
                m2.removeEventListener("click", w2, true);
              } };
            }
          }, p2.renderWave = function(m2) {
            var w2 = m2.csp, T2 = p2.props.children;
            if (p2.csp = w2, !Y3.isValidElement(T2))
              return T2;
            var E = p2.containerRef;
            return r4n(T2) && (E = n4n(T2.ref, p2.containerRef)), MRn(T2, { ref: E });
          }, p2;
        }
        return Vst(n3, [{ key: "componentDidMount", value: function() {
          var p2 = this.containerRef.current;
          !p2 || p2.nodeType !== 1 || (this.instance = this.bindAnimationEvent(p2));
        } }, { key: "componentWillUnmount", value: function() {
          this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
        } }, { key: "getAttributeName", value: function() {
          var p2 = this.context.getPrefixCls, m2 = this.props.insertExtraNode;
          return m2 ? "".concat(p2(""), "-click-animating") : "".concat(p2(""), "-click-animating-without-extra-node");
        } }, { key: "resetEffect", value: function(p2) {
          var m2 = this;
          if (!(!p2 || p2 === this.extraNode || !(p2 instanceof Element))) {
            var w2 = this.props.insertExtraNode, T2 = this.getAttributeName();
            p2.setAttribute(T2, "false"), rzt && (rzt.innerHTML = ""), w2 && this.extraNode && p2.contains(this.extraNode) && p2.removeChild(this.extraNode), ["transition", "animation"].forEach(function(E) {
              p2.removeEventListener("".concat(E, "start"), m2.onTransitionStart), p2.removeEventListener("".concat(E, "end"), m2.onTransitionEnd);
            });
          }
        } }, { key: "render", value: function() {
          return Y3.createElement(hCe, null, this.renderWave);
        } }]), n3;
      }(Y3.Component);
      xCe.contextType = T8;
      var izt = { exports: {} }, Zst = {};
      /** @license React v17.0.2
      * react-jsx-runtime.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var IRn = U3.default, wCe = 60103;
      if (Zst.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
        var SCe = Symbol.for;
        wCe = SCe("react.element"), Zst.Fragment = SCe("react.fragment");
      }
      var DRn = IRn.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, ERn = Object.prototype.hasOwnProperty, kRn = { key: true, ref: true, __self: true, __source: true };
      function MCe(u, o, n3) {
        var p2, m2 = {}, w2 = null, T2 = null;
        n3 !== void 0 && (w2 = "" + n3), o.key !== void 0 && (w2 = "" + o.key), o.ref !== void 0 && (T2 = o.ref);
        for (p2 in o)
          ERn.call(o, p2) && !kRn.hasOwnProperty(p2) && (m2[p2] = o[p2]);
        if (u && u.defaultProps)
          for (p2 in o = u.defaultProps, o)
            m2[p2] === void 0 && (m2[p2] = o[p2]);
        return { $$typeof: wCe, type: u, key: w2, ref: T2, props: m2, _owner: DRn.current };
      }
      Zst.jsx = MCe, Zst.jsxs = MCe, izt.exports = Zst;
      const FY = izt.exports.jsx, PRn = izt.exports.jsxs;
      var LRn = L.createContext({}), CCe = LRn, ORn = function() {
        return DMe() && window.document.documentElement;
      }, Xwt, RRn = function() {
        if (!ORn())
          return false;
        if (Xwt !== void 0)
          return Xwt;
        var u = document.createElement("div");
        return u.style.display = "flex", u.style.flexDirection = "column", u.style.rowGap = "1px", u.appendChild(document.createElement("div")), u.appendChild(document.createElement("div")), document.body.appendChild(u), Xwt = u.scrollHeight === 1, document.body.removeChild(u), Xwt;
      }, NRn = function() {
        var u = Y3.useState(false), o = wI(u, 2), n3 = o[0], p2 = o[1];
        return Y3.useEffect(function() {
          p2(RRn());
        }, []), n3;
      }, FRn = globalThis && globalThis.__rest || function(u, o) {
        var n3 = {};
        for (var p2 in u)
          Object.prototype.hasOwnProperty.call(u, p2) && o.indexOf(p2) < 0 && (n3[p2] = u[p2]);
        if (u != null && typeof Object.getOwnPropertySymbols == "function")
          for (var m2 = 0, p2 = Object.getOwnPropertySymbols(u); m2 < p2.length; m2++)
            o.indexOf(p2[m2]) < 0 && Object.prototype.propertyIsEnumerable.call(u, p2[m2]) && (n3[p2[m2]] = u[p2[m2]]);
        return n3;
      };
      yCe("top", "middle", "bottom", "stretch"), yCe("start", "end", "center", "space-around", "space-between");
      var TCe = Y3.forwardRef(function(u, o) {
        var n3, p2 = u.prefixCls, m2 = u.justify, w2 = u.align, T2 = u.className, E = u.style, O2 = u.children, V3 = u.gutter, W3 = V3 === void 0 ? 0 : V3, q3 = u.wrap, K = FRn(u, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), J = Y3.useContext(T8), rt2 = J.getPrefixCls, gt = J.direction, yt = Y3.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), At = wI(yt, 2), Lt = At[0], Wt = At[1], Nt = NRn(), ue2 = Y3.useRef(W3);
        Y3.useEffect(function() {
          var Xn = bCe.subscribe(function(or) {
            var Tr = ue2.current || 0;
            (!Array.isArray(Tr) && Ew(Tr) === "object" || Array.isArray(Tr) && (Ew(Tr[0]) === "object" || Ew(Tr[1]) === "object")) && Wt(or);
          });
          return function() {
            return bCe.unsubscribe(Xn);
          };
        }, []);
        var ie2 = function() {
          var Xn = [0, 0], or = Array.isArray(W3) ? W3 : [W3, 0];
          return or.forEach(function(Tr, ci2) {
            if (Ew(Tr) === "object")
              for (var yi2 = 0; yi2 < mCe.length; yi2++) {
                var Po = mCe[yi2];
                if (Lt[Po] && Tr[Po] !== void 0) {
                  Xn[ci2] = Tr[Po];
                  break;
                }
              }
            else
              Xn[ci2] = Tr || 0;
          }), Xn;
        }, pe2 = rt2("row", p2), xe = ie2(), Ce2 = PY(pe2, (n3 = {}, Yd2(n3, "".concat(pe2, "-no-wrap"), q3 === false), Yd2(n3, "".concat(pe2, "-").concat(m2), m2), Yd2(n3, "".concat(pe2, "-").concat(w2), w2), Yd2(n3, "".concat(pe2, "-rtl"), gt === "rtl"), n3), T2), Le2 = {}, ze = xe[0] > 0 ? xe[0] / -2 : void 0, tn = xe[1] > 0 ? xe[1] / -2 : void 0;
        if (ze && (Le2.marginLeft = ze, Le2.marginRight = ze), Nt) {
          var $e2 = wI(xe, 2);
          Le2.rowGap = $e2[1];
        } else
          tn && (Le2.marginTop = tn, Le2.marginBottom = tn);
        var Tn = wI(xe, 2), zn = Tn[0], bn = Tn[1], Xr = Y3.useMemo(function() {
          return { gutter: [zn, bn], wrap: q3, supportFlexGap: Nt };
        }, [zn, bn, q3, Nt]);
        return Y3.createElement(CCe.Provider, { value: Xr }, Y3.createElement("div", zm({}, K, { className: Ce2, style: zm(zm({}, Le2), E), ref: o }), O2));
      });
      TCe.displayName = "Row";
      var VRn = TCe, BRn = globalThis && globalThis.__rest || function(u, o) {
        var n3 = {};
        for (var p2 in u)
          Object.prototype.hasOwnProperty.call(u, p2) && o.indexOf(p2) < 0 && (n3[p2] = u[p2]);
        if (u != null && typeof Object.getOwnPropertySymbols == "function")
          for (var m2 = 0, p2 = Object.getOwnPropertySymbols(u); m2 < p2.length; m2++)
            o.indexOf(p2[m2]) < 0 && Object.prototype.propertyIsEnumerable.call(u, p2[m2]) && (n3[p2[m2]] = u[p2[m2]]);
        return n3;
      };
      function zRn(u) {
        return typeof u == "number" ? "".concat(u, " ").concat(u, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(u) ? "0 0 ".concat(u) : u;
      }
      var jRn = ["xs", "sm", "md", "lg", "xl", "xxl"], ACe = Y3.forwardRef(function(u, o) {
        var n3, p2 = Y3.useContext(T8), m2 = p2.getPrefixCls, w2 = p2.direction, T2 = Y3.useContext(CCe), E = T2.gutter, O2 = T2.wrap, V3 = T2.supportFlexGap, W3 = u.prefixCls, q3 = u.span, K = u.order, J = u.offset, rt2 = u.push, gt = u.pull, yt = u.className, At = u.children, Lt = u.flex, Wt = u.style, Nt = BRn(u, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), ue2 = m2("col", W3), ie2 = {};
        jRn.forEach(function(ze) {
          var tn, $e2 = {}, Tn = u[ze];
          typeof Tn == "number" ? $e2.span = Tn : Ew(Tn) === "object" && ($e2 = Tn || {}), delete Nt[ze], ie2 = zm(zm({}, ie2), (tn = {}, Yd2(tn, "".concat(ue2, "-").concat(ze, "-").concat($e2.span), $e2.span !== void 0), Yd2(tn, "".concat(ue2, "-").concat(ze, "-order-").concat($e2.order), $e2.order || $e2.order === 0), Yd2(tn, "".concat(ue2, "-").concat(ze, "-offset-").concat($e2.offset), $e2.offset || $e2.offset === 0), Yd2(tn, "".concat(ue2, "-").concat(ze, "-push-").concat($e2.push), $e2.push || $e2.push === 0), Yd2(tn, "".concat(ue2, "-").concat(ze, "-pull-").concat($e2.pull), $e2.pull || $e2.pull === 0), Yd2(tn, "".concat(ue2, "-rtl"), w2 === "rtl"), tn));
        });
        var pe2 = PY(ue2, (n3 = {}, Yd2(n3, "".concat(ue2, "-").concat(q3), q3 !== void 0), Yd2(n3, "".concat(ue2, "-order-").concat(K), K), Yd2(n3, "".concat(ue2, "-offset-").concat(J), J), Yd2(n3, "".concat(ue2, "-push-").concat(rt2), rt2), Yd2(n3, "".concat(ue2, "-pull-").concat(gt), gt), n3), yt, ie2), xe = {};
        if (E && E[0] > 0) {
          var Ce2 = E[0] / 2;
          xe.paddingLeft = Ce2, xe.paddingRight = Ce2;
        }
        if (E && E[1] > 0 && !V3) {
          var Le2 = E[1] / 2;
          xe.paddingTop = Le2, xe.paddingBottom = Le2;
        }
        return Lt && (xe.flex = zRn(Lt), O2 === false && !xe.minWidth && (xe.minWidth = 0)), Y3.createElement("div", zm({}, Nt, { style: zm(zm({}, xe), Wt), className: pe2, ref: o }), At);
      });
      ACe.displayName = "Col";
      var WRn = ACe, ICe = Y3.forwardRef(function(u, o) {
        var n3, p2 = u.prefixCls, m2 = p2 === void 0 ? "rc-switch" : p2, w2 = u.className, T2 = u.checked, E = u.defaultChecked, O2 = u.disabled, V3 = u.loadingIcon, W3 = u.checkedChildren, q3 = u.unCheckedChildren, K = u.onClick, J = u.onChange, rt2 = u.onKeyDown, gt = kY(u, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), yt = xRn(false, { value: T2, defaultValue: E }), At = wI(yt, 2), Lt = At[0], Wt = At[1];
        function Nt(xe, Ce2) {
          var Le2 = Lt;
          return O2 || (Le2 = xe, Wt(Le2), J == null || J(Le2, Ce2)), Le2;
        }
        function ue2(xe) {
          xe.which === Cc2.LEFT ? Nt(false, xe) : xe.which === Cc2.RIGHT && Nt(true, xe), rt2 == null || rt2(xe);
        }
        function ie2(xe) {
          var Ce2 = Nt(!Lt, xe);
          K == null || K(Ce2, xe);
        }
        var pe2 = PY(m2, w2, (n3 = {}, Yd2(n3, "".concat(m2, "-checked"), Lt), Yd2(n3, "".concat(m2, "-disabled"), O2), n3));
        return Y3.createElement("button", Object.assign({}, gt, { type: "button", role: "switch", "aria-checked": Lt, disabled: O2, className: pe2, ref: o, onKeyDown: ue2, onClick: ie2 }), V3, Y3.createElement("span", { className: "".concat(m2, "-inner") }, Lt ? W3 : q3));
      });
      ICe.displayName = "Switch";
      var GRn = globalThis && globalThis.__rest || function(u, o) {
        var n3 = {};
        for (var p2 in u)
          Object.prototype.hasOwnProperty.call(u, p2) && o.indexOf(p2) < 0 && (n3[p2] = u[p2]);
        if (u != null && typeof Object.getOwnPropertySymbols == "function")
          for (var m2 = 0, p2 = Object.getOwnPropertySymbols(u); m2 < p2.length; m2++)
            o.indexOf(p2[m2]) < 0 && Object.prototype.propertyIsEnumerable.call(u, p2[m2]) && (n3[p2[m2]] = u[p2[m2]]);
        return n3;
      }, azt = Y3.forwardRef(function(u, o) {
        var n3, p2 = u.prefixCls, m2 = u.size, w2 = u.loading, T2 = u.className, E = T2 === void 0 ? "" : T2, O2 = u.disabled, V3 = GRn(u, ["prefixCls", "size", "loading", "className", "disabled"]);
        rRn("checked" in V3 || !("value" in V3), "Switch", "`value` is not a valid prop, do you mean `checked`?");
        var W3 = Y3.useContext(T8), q3 = W3.getPrefixCls, K = W3.direction, J = Y3.useContext(_Rn), rt2 = q3("switch", p2), gt = Y3.createElement("div", { className: "".concat(rt2, "-handle") }, w2 && Y3.createElement(ZOn, { className: "".concat(rt2, "-loading-icon") })), yt = PY((n3 = {}, Yd2(n3, "".concat(rt2, "-small"), (m2 || J) === "small"), Yd2(n3, "".concat(rt2, "-loading"), w2), Yd2(n3, "".concat(rt2, "-rtl"), K === "rtl"), n3), E);
        return Y3.createElement(xCe, { insertExtraNode: true }, Y3.createElement(ICe, zm({}, V3, { prefixCls: rt2, className: yt, disabled: O2 || w2, ref: o, loadingIcon: gt })));
      });
      azt.__ANT_SWITCH = true, azt.displayName = "Switch";
      var HRn = azt, URn = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, qRn = {};
      (function(u) {
        var o = Object.defineProperty, n3 = Object.getOwnPropertySymbols, p2 = Object.prototype.hasOwnProperty, m2 = Object.prototype.propertyIsEnumerable, w2 = (c5, s, r5) => s in c5 ? o(c5, s, { enumerable: true, configurable: true, writable: true, value: r5 }) : c5[s] = r5, T2 = (c5, s) => {
          for (var r5 in s || (s = {}))
            p2.call(s, r5) && w2(c5, r5, s[r5]);
          if (n3)
            for (var r5 of n3(s))
              m2.call(s, r5) && w2(c5, r5, s[r5]);
          return c5;
        }, E = (c5, s, r5) => (w2(c5, typeof s != "symbol" ? s + "" : s, r5), r5);
        Object.defineProperties(u, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
        var O2 = U3.default;
        function V3(c5) {
          return c5 && typeof c5 == "object" && "default" in c5 ? c5 : { default: c5 };
        }
        function W3(c5) {
          if (c5 && c5.__esModule)
            return c5;
          var s = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
          return c5 && Object.keys(c5).forEach(function(r5) {
            if (r5 !== "default") {
              var g5 = Object.getOwnPropertyDescriptor(c5, r5);
              Object.defineProperty(s, r5, g5.get ? g5 : { enumerable: true, get: function() {
                return c5[r5];
              } });
            }
          }), s.default = c5, Object.freeze(s);
        }
        var q3 = V3(O2), K = W3(O2), J = globalThis && globalThis.__read || function(c5, s) {
          var r5 = typeof Symbol == "function" && c5[Symbol.iterator];
          if (!r5)
            return c5;
          var g5 = r5.call(c5), b6, S2 = [], A2;
          try {
            for (; (s === void 0 || s-- > 0) && !(b6 = g5.next()).done; )
              S2.push(b6.value);
          } catch (k2) {
            A2 = { error: k2 };
          } finally {
            try {
              b6 && !b6.done && (r5 = g5.return) && r5.call(g5);
            } finally {
              if (A2)
                throw A2.error;
            }
          }
          return S2;
        };
        function rt2(c5, s) {
          c5 === void 0 && (c5 = false);
          var r5 = J(O2.useState(c5), 2), g5 = r5[0], b6 = r5[1], S2 = O2.useMemo(function() {
            var A2 = s === void 0 ? !c5 : s, k2 = function() {
              return b6(function(Z3) {
                return Z3 === c5 ? A2 : c5;
              });
            }, R6 = function(Z3) {
              return b6(Z3);
            }, B3 = function() {
              return b6(c5);
            }, G3 = function() {
              return b6(A2);
            };
            return { toggle: k2, set: R6, setLeft: B3, setRight: G3 };
          }, []);
          return [g5, S2];
        }
        var gt = globalThis && globalThis.__read || function(c5, s) {
          var r5 = typeof Symbol == "function" && c5[Symbol.iterator];
          if (!r5)
            return c5;
          var g5 = r5.call(c5), b6, S2 = [], A2;
          try {
            for (; (s === void 0 || s-- > 0) && !(b6 = g5.next()).done; )
              S2.push(b6.value);
          } catch (k2) {
            A2 = { error: k2 };
          } finally {
            try {
              b6 && !b6.done && (r5 = g5.return) && r5.call(g5);
            } finally {
              if (A2)
                throw A2.error;
            }
          }
          return S2;
        };
        function yt(c5) {
          c5 === void 0 && (c5 = false);
          var s = gt(rt2(c5), 2), r5 = s[0], g5 = s[1], b6 = g5.toggle, S2 = g5.set, A2 = O2.useMemo(function() {
            var k2 = function() {
              return S2(true);
            }, R6 = function() {
              return S2(false);
            };
            return { toggle: b6, set: function(B3) {
              return S2(!!B3);
            }, setTrue: k2, setFalse: R6 };
          }, []);
          return [r5, A2];
        }
        function At(c5) {
          var s = O2.useRef(c5);
          return s.current = c5, s;
        }
        var Lt = !!(typeof window != "undefined" && window.document && window.document.createElement), Wt = Lt;
        function Nt(c5, s) {
          if (Wt) {
            if (!c5)
              return s;
            var r5;
            return typeof c5 == "function" ? r5 = c5() : "current" in c5 ? r5 = c5.current : r5 = c5, r5;
          }
        }
        var ue2 = function(c5) {
          var s = At(c5);
          O2.useEffect(function() {
            return function() {
              s.current();
            };
          }, []);
        }, ie2 = ue2;
        function pe2(c5, s) {
          if (c5 === s)
            return true;
          for (var r5 = 0; r5 < c5.length; r5++)
            if (!Object.is(c5[r5], s[r5]))
              return false;
          return true;
        }
        var xe = function(c5) {
          var s = function(r5, g5, b6) {
            var S2 = O2.useRef(false), A2 = O2.useRef([]), k2 = O2.useRef([]), R6 = O2.useRef();
            c5(function() {
              var B3, G3 = Array.isArray(b6) ? b6 : [b6], Z3 = G3.map(function(X3) {
                return Nt(X3);
              });
              if (!S2.current) {
                S2.current = true, A2.current = Z3, k2.current = g5, R6.current = r5();
                return;
              }
              (Z3.length !== A2.current.length || !pe2(Z3, A2.current) || !pe2(g5, k2.current)) && ((B3 = R6.current) === null || B3 === void 0 || B3.call(R6), A2.current = Z3, k2.current = g5, R6.current = r5());
            }), ie2(function() {
              var B3;
              (B3 = R6.current) === null || B3 === void 0 || B3.call(R6), S2.current = false;
            });
          };
          return s;
        }, Ce2 = xe, Le2 = Ce2(O2.useEffect), ze = Le2, tn = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof Je2 != "undefined" ? Je2 : typeof self != "undefined" ? self : {};
        function $e2(c5) {
          return c5 && c5.__esModule && Object.prototype.hasOwnProperty.call(c5, "default") ? c5.default : c5;
        }
        function Tn(c5) {
          var s = typeof c5;
          return c5 != null && (s == "object" || s == "function");
        }
        var zn = Tn, bn = typeof tn == "object" && tn && tn.Object === Object && tn, Xr = bn, Xn = Xr, or = typeof self == "object" && self && self.Object === Object && self, Tr = Xn || or || Function("return this")(), ci2 = Tr, yi2 = ci2, Po = function() {
          return yi2.Date.now();
        }, Ms = Po, dl = /\s/;
        function tl(c5) {
          for (var s = c5.length; s-- && dl.test(c5.charAt(s)); )
            ;
          return s;
        }
        var el = tl, as = el, Hs = /^\s+/;
        function ol(c5) {
          return c5 && c5.slice(0, as(c5) + 1).replace(Hs, "");
        }
        var xs = ol, Bl = ci2, Ph2 = Bl.Symbol, fu = Ph2, uh2 = fu, Zh2 = Object.prototype, zp = Zh2.hasOwnProperty, tm = Zh2.toString, Fd2 = uh2 ? uh2.toStringTag : void 0;
        function O1(c5) {
          var s = zp.call(c5, Fd2), r5 = c5[Fd2];
          try {
            c5[Fd2] = void 0;
            var g5 = true;
          } catch {
          }
          var b6 = tm.call(c5);
          return g5 && (s ? c5[Fd2] = r5 : delete c5[Fd2]), b6;
        }
        var Kd2 = O1, Nv = Object.prototype, mv = Nv.toString;
        function CI(c5) {
          return mv.call(c5);
        }
        var go = CI, aa2 = fu, ta2 = Kd2, bo = go, js = "[object Null]", eu = "[object Undefined]", bf2 = aa2 ? aa2.toStringTag : void 0;
        function _f(c5) {
          return c5 == null ? c5 === void 0 ? eu : js : bf2 && bf2 in Object(c5) ? ta2(c5) : bo(c5);
        }
        var nd2 = _f;
        function bv(c5) {
          return c5 != null && typeof c5 == "object";
        }
        var Mg2 = bv, K0 = nd2, Cg2 = Mg2, Rb2 = "[object Symbol]";
        function ax(c5) {
          return typeof c5 == "symbol" || Cg2(c5) && K0(c5) == Rb2;
        }
        var hM = ax, ox = xs, l0 = zn, $h2 = hM, Ay = 0 / 0, R1 = /^[-+]0x[0-9a-f]+$/i, pM = /^0b[01]+$/i, Pw = /^0o[0-7]+$/i, sx = parseInt;
        function l22(c5) {
          if (typeof c5 == "number")
            return c5;
          if ($h2(c5))
            return Ay;
          if (l0(c5)) {
            var s = typeof c5.valueOf == "function" ? c5.valueOf() : c5;
            c5 = l0(s) ? s + "" : s;
          }
          if (typeof c5 != "string")
            return c5 === 0 ? c5 : +c5;
          c5 = ox(c5);
          var r5 = pM.test(c5);
          return r5 || Pw.test(c5) ? sx(c5.slice(2), r5 ? 2 : 8) : R1.test(c5) ? Ay : +c5;
        }
        var n32 = l22, uk2 = zn, sj2 = Ms, ck2 = n32, $st = "Expected a function", Yst = Math.max, Kst = Math.min;
        function Xst(c5, s, r5) {
          var g5, b6, S2, A2, k2, R6, B3 = 0, G3 = false, Z3 = false, X3 = true;
          if (typeof c5 != "function")
            throw new TypeError($st);
          s = ck2(s) || 0, uk2(r5) && (G3 = !!r5.leading, Z3 = "maxWait" in r5, S2 = Z3 ? Yst(ck2(r5.maxWait) || 0, s) : S2, X3 = "trailing" in r5 ? !!r5.trailing : X3);
          function tt(ae2) {
            var de2 = g5, we2 = b6;
            return g5 = b6 = void 0, B3 = ae2, A2 = c5.apply(we2, de2), A2;
          }
          function it(ae2) {
            return B3 = ae2, k2 = setTimeout(Mt, s), G3 ? tt(ae2) : A2;
          }
          function pt(ae2) {
            var de2 = ae2 - R6, we2 = ae2 - B3, Se2 = s - de2;
            return Z3 ? Kst(Se2, S2 - we2) : Se2;
          }
          function mt(ae2) {
            var de2 = ae2 - R6, we2 = ae2 - B3;
            return R6 === void 0 || de2 >= s || de2 < 0 || Z3 && we2 >= S2;
          }
          function Mt() {
            var ae2 = sj2();
            if (mt(ae2))
              return kt(ae2);
            k2 = setTimeout(Mt, pt(ae2));
          }
          function kt(ae2) {
            return k2 = void 0, X3 && g5 ? tt(ae2) : (g5 = b6 = void 0, A2);
          }
          function Gt() {
            k2 !== void 0 && clearTimeout(k2), B3 = 0, g5 = R6 = b6 = k2 = void 0;
          }
          function Ot() {
            return k2 === void 0 ? A2 : kt(sj2());
          }
          function ce2() {
            var ae2 = sj2(), de2 = mt(ae2);
            if (g5 = arguments, b6 = this, R6 = ae2, de2) {
              if (k2 === void 0)
                return it(R6);
              if (Z3)
                return clearTimeout(k2), k2 = setTimeout(Mt, s), tt(R6);
            }
            return k2 === void 0 && (k2 = setTimeout(Mt, s)), A2;
          }
          return ce2.cancel = Gt, ce2.flush = Ot, ce2;
        }
        var A8 = Xst, wr = globalThis && globalThis.__read || function(c5, s) {
          var r5 = typeof Symbol == "function" && c5[Symbol.iterator];
          if (!r5)
            return c5;
          var g5 = r5.call(c5), b6, S2 = [], A2;
          try {
            for (; (s === void 0 || s-- > 0) && !(b6 = g5.next()).done; )
              S2.push(b6.value);
          } catch (k2) {
            A2 = { error: k2 };
          } finally {
            try {
              b6 && !b6.done && (r5 = g5.return) && r5.call(g5);
            } finally {
              if (A2)
                throw A2.error;
            }
          }
          return S2;
        }, Pr = globalThis && globalThis.__spread || function() {
          for (var c5 = [], s = 0; s < arguments.length; s++)
            c5 = c5.concat(wr(arguments[s]));
          return c5;
        };
        function Nn(c5, s) {
          var r5, g5 = At(c5), b6 = (r5 = s == null ? void 0 : s.wait) !== null && r5 !== void 0 ? r5 : 1e3, S2 = O2.useMemo(function() {
            return A8(function() {
              for (var A2 = [], k2 = 0; k2 < arguments.length; k2++)
                A2[k2] = arguments[k2];
              return g5.current.apply(g5, Pr(A2));
            }, b6, s);
          }, []);
          return ie2(function() {
            S2.cancel();
          }), { run: S2, cancel: S2.cancel, flush: S2.flush };
        }
        function hr(c5, s, r5) {
          r5 === void 0 && (r5 = {});
          var g5 = At(s);
          ze(function() {
            var b6 = Nt(r5.target, window);
            if (b6 != null && b6.addEventListener) {
              var S2 = function(A2) {
                return g5.current(A2);
              };
              return b6.addEventListener(c5, S2, { capture: r5.capture, once: r5.once, passive: r5.passive }), function() {
                b6.removeEventListener(c5, S2, { capture: r5.capture });
              };
            }
          }, [c5, r5.capture, r5.once, r5.passive], r5.target);
        }
        /*! *****************************************************************************
        Copyright (c) Microsoft Corporation.
        
        Permission to use, copy, modify, and/or distribute this software for any
        purpose with or without fee is hereby granted.
        
        THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
        REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
        AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
        INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
        LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
        OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
        PERFORMANCE OF THIS SOFTWARE.
        ***************************************************************************** */
        var vr = function(c5, s) {
          return vr = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(r5, g5) {
            r5.__proto__ = g5;
          } || function(r5, g5) {
            for (var b6 in g5)
              Object.prototype.hasOwnProperty.call(g5, b6) && (r5[b6] = g5[b6]);
          }, vr(c5, s);
        };
        function wn(c5, s) {
          if (typeof s != "function" && s !== null)
            throw new TypeError("Class extends value " + String(s) + " is not a constructor or null");
          vr(c5, s);
          function r5() {
            this.constructor = c5;
          }
          c5.prototype = s === null ? Object.create(s) : (r5.prototype = s.prototype, new r5());
        }
        var no = function() {
          function c5() {
            this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
          }
          return c5;
        }(), Pa2 = function() {
          function c5() {
            this.browser = new no(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
          }
          return c5;
        }(), pi2 = new Pa2();
        typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (pi2.wxa = true, pi2.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? pi2.worker = true : typeof navigator == "undefined" ? (pi2.node = true, pi2.svgSupported = true) : Uo(navigator.userAgent, pi2);
        function Uo(c5, s) {
          var r5 = s.browser, g5 = c5.match(/Firefox\/([\d.]+)/), b6 = c5.match(/MSIE\s([\d.]+)/) || c5.match(/Trident\/.+?rv:(([\d.]+))/), S2 = c5.match(/Edge?\/([\d.]+)/), A2 = /micromessenger/i.test(c5);
          g5 && (r5.firefox = true, r5.version = g5[1]), b6 && (r5.ie = true, r5.version = b6[1]), S2 && (r5.edge = true, r5.version = S2[1], r5.newEdge = +S2[1].split(".")[0] > 18), A2 && (r5.weChat = true), s.svgSupported = typeof SVGRect != "undefined", s.touchEventsSupported = "ontouchstart" in window && !r5.ie && !r5.edge, s.pointerEventsSupported = "onpointerdown" in window && (r5.edge || r5.ie && +r5.version >= 11), s.domSupported = typeof document != "undefined";
          var k2 = document.documentElement.style;
          s.transform3dSupported = (r5.ie && "transition" in k2 || r5.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in k2) && !("OTransition" in k2), s.transformSupported = s.transform3dSupported || r5.ie && +r5.version >= 9;
        }
        var os = pi2, If2 = 12, Lh2 = "sans-serif", Yh2 = If2 + "px " + Lh2, Bf2 = 20, Sd2 = 100, Fv = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
        function Nc2(c5) {
          var s = {};
          if (typeof JSON == "undefined")
            return s;
          for (var r5 = 0; r5 < c5.length; r5++) {
            var g5 = String.fromCharCode(r5 + 32), b6 = (c5.charCodeAt(r5) - Bf2) / Sd2;
            s[g5] = b6;
          }
          return s;
        }
        var X0 = Nc2(Fv), T0 = { createCanvas: function() {
          return typeof document != "undefined" && document.createElement("canvas");
        }, measureText: function() {
          var c5, s;
          return function(r5, g5) {
            if (!c5) {
              var b6 = T0.createCanvas();
              c5 = b6 && b6.getContext("2d");
            }
            if (c5)
              return s !== g5 && (s = c5.font = g5 || Yh2), c5.measureText(r5);
            r5 = r5 || "", g5 = g5 || Yh2;
            var S2 = /^([0-9]*?)px$/.exec(g5), A2 = +(S2 && S2[1]) || If2, k2 = 0;
            if (g5.indexOf("mono") >= 0)
              k2 = A2 * r5.length;
            else
              for (var R6 = 0; R6 < r5.length; R6++) {
                var B3 = X0[r5[R6]];
                k2 += B3 == null ? A2 : B3 * A2;
              }
            return { width: k2 };
          };
        }(), loadImage: function(c5, s, r5) {
          var g5 = new Image();
          return g5.onload = s, g5.onerror = r5, g5.src = c5, g5;
        } }, dM = VC(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(c5, s) {
          return c5["[object " + s + "]"] = true, c5;
        }, {}), N4 = VC(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(c5, s) {
          return c5["[object " + s + "Array]"] = true, c5;
        }, {}), Nb2 = Object.prototype.toString, TI = Array.prototype, fk2 = TI.forEach, em = TI.filter, gM = TI.slice, F4 = TI.map, AI = function() {
        }.constructor, II = AI ? AI.prototype : null, hk2 = "__proto__", lj2 = 2311;
        function V4() {
          return lj2++;
        }
        function r3() {
          for (var c5 = [], s = 0; s < arguments.length; s++)
            c5[s] = arguments[s];
          typeof console != "undefined" && console.error.apply(console, c5);
        }
        function Ml(c5) {
          if (c5 == null || typeof c5 != "object")
            return c5;
          var s = c5, r5 = Nb2.call(c5);
          if (r5 === "[object Array]") {
            if (!I8(c5)) {
              s = [];
              for (var g5 = 0, b6 = c5.length; g5 < b6; g5++)
                s[g5] = Ml(c5[g5]);
            }
          } else if (N4[r5]) {
            if (!I8(c5)) {
              var S2 = c5.constructor;
              if (S2.from)
                s = S2.from(c5);
              else {
                s = new S2(c5.length);
                for (var g5 = 0, b6 = c5.length; g5 < b6; g5++)
                  s[g5] = c5[g5];
              }
            }
          } else if (!dM[r5] && !I8(c5) && !cj2(c5)) {
            s = {};
            for (var A2 in c5)
              c5.hasOwnProperty(A2) && A2 !== hk2 && (s[A2] = Ml(c5[A2]));
          }
          return s;
        }
        function bu(c5, s, r5) {
          if (!Wl(s) || !Wl(c5))
            return r5 ? Ml(s) : c5;
          for (var g5 in s)
            if (s.hasOwnProperty(g5) && g5 !== hk2) {
              var b6 = c5[g5], S2 = s[g5];
              Wl(S2) && Wl(b6) && !ja2(S2) && !ja2(b6) && !cj2(S2) && !cj2(b6) && !Jwt(S2) && !Jwt(b6) && !I8(S2) && !I8(b6) ? bu(b6, S2, r5) : (r5 || !(g5 in c5)) && (c5[g5] = Ml(s[g5]));
            }
          return c5;
        }
        function B4(c5, s) {
          for (var r5 = c5[0], g5 = 1, b6 = c5.length; g5 < b6; g5++)
            r5 = bu(r5, c5[g5], s);
          return r5;
        }
        function sa2(c5, s) {
          if (Object.assign)
            Object.assign(c5, s);
          else
            for (var r5 in s)
              s.hasOwnProperty(r5) && r5 !== hk2 && (c5[r5] = s[r5]);
          return c5;
        }
        function Cl(c5, s, r5) {
          for (var g5 = nf2(s), b6 = 0; b6 < g5.length; b6++) {
            var S2 = g5[b6];
            (r5 ? s[S2] != null : c5[S2] == null) && (c5[S2] = s[S2]);
          }
          return c5;
        }
        function Lu(c5, s) {
          if (c5) {
            if (c5.indexOf)
              return c5.indexOf(s);
            for (var r5 = 0, g5 = c5.length; r5 < g5; r5++)
              if (c5[r5] === s)
                return r5;
          }
          return -1;
        }
        function Qwt(c5, s) {
          var r5 = c5.prototype;
          function g5() {
          }
          g5.prototype = s.prototype, c5.prototype = new g5();
          for (var b6 in r5)
            r5.hasOwnProperty(b6) && (c5.prototype[b6] = r5[b6]);
          c5.prototype.constructor = c5, c5.superClass = s;
        }
        function A0(c5, s, r5) {
          if (c5 = "prototype" in c5 ? c5.prototype : c5, s = "prototype" in s ? s.prototype : s, Object.getOwnPropertyNames)
            for (var g5 = Object.getOwnPropertyNames(s), b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6];
              S2 !== "constructor" && (r5 ? s[S2] != null : c5[S2] == null) && (c5[S2] = s[S2]);
            }
          else
            Cl(c5, s, r5);
        }
        function Fb2(c5) {
          return !c5 || typeof c5 == "string" ? false : typeof c5.length == "number";
        }
        function Ye2(c5, s, r5) {
          if (c5 && s)
            if (c5.forEach && c5.forEach === fk2)
              c5.forEach(s, r5);
            else if (c5.length === +c5.length)
              for (var g5 = 0, b6 = c5.length; g5 < b6; g5++)
                s.call(r5, c5[g5], g5, c5);
            else
              for (var S2 in c5)
                c5.hasOwnProperty(S2) && s.call(r5, c5[S2], S2, c5);
        }
        function Ha2(c5, s, r5) {
          if (!c5)
            return [];
          if (!s)
            return Qst(c5);
          if (c5.map && c5.map === F4)
            return c5.map(s, r5);
          for (var g5 = [], b6 = 0, S2 = c5.length; b6 < S2; b6++)
            g5.push(s.call(r5, c5[b6], b6, c5));
          return g5;
        }
        function VC(c5, s, r5, g5) {
          if (c5 && s) {
            for (var b6 = 0, S2 = c5.length; b6 < S2; b6++)
              r5 = s.call(g5, r5, c5[b6], b6, c5);
            return r5;
          }
        }
        function jp(c5, s, r5) {
          if (!c5)
            return [];
          if (!s)
            return Qst(c5);
          if (c5.filter && c5.filter === em)
            return c5.filter(s, r5);
          for (var g5 = [], b6 = 0, S2 = c5.length; b6 < S2; b6++)
            s.call(r5, c5[b6], b6, c5) && g5.push(c5[b6]);
          return g5;
        }
        function ozt(c5, s, r5) {
          if (c5 && s) {
            for (var g5 = 0, b6 = c5.length; g5 < b6; g5++)
              if (s.call(r5, c5[g5], g5, c5))
                return c5[g5];
          }
        }
        function nf2(c5) {
          if (!c5)
            return [];
          if (Object.keys)
            return Object.keys(c5);
          var s = [];
          for (var r5 in c5)
            c5.hasOwnProperty(r5) && s.push(r5);
          return s;
        }
        function szt(c5, s) {
          for (var r5 = [], g5 = 2; g5 < arguments.length; g5++)
            r5[g5 - 2] = arguments[g5];
          return function() {
            return c5.apply(s, r5.concat(gM.call(arguments)));
          };
        }
        var Cs = II && Tl(II.bind) ? II.call.bind(II.bind) : szt;
        function Au(c5) {
          for (var s = [], r5 = 1; r5 < arguments.length; r5++)
            s[r5 - 1] = arguments[r5];
          return function() {
            return c5.apply(this, s.concat(gM.call(arguments)));
          };
        }
        function ja2(c5) {
          return Array.isArray ? Array.isArray(c5) : Nb2.call(c5) === "[object Array]";
        }
        function Tl(c5) {
          return typeof c5 == "function";
        }
        function gs(c5) {
          return typeof c5 == "string";
        }
        function uj2(c5) {
          return Nb2.call(c5) === "[object String]";
        }
        function Oh2(c5) {
          return typeof c5 == "number";
        }
        function Wl(c5) {
          var s = typeof c5;
          return s === "function" || !!c5 && s === "object";
        }
        function Jwt(c5) {
          return !!dM[Nb2.call(c5)];
        }
        function u2(c5) {
          return !!N4[Nb2.call(c5)];
        }
        function cj2(c5) {
          return typeof c5 == "object" && typeof c5.nodeType == "number" && typeof c5.ownerDocument == "object";
        }
        function Xd2(c5) {
          return c5.colorStops != null;
        }
        function Jg2(c5) {
          return c5.image != null;
        }
        function lzt(c5) {
          return Nb2.call(c5) === "[object RegExp]";
        }
        function fj2(c5) {
          return c5 !== c5;
        }
        function Wm() {
          for (var c5 = [], s = 0; s < arguments.length; s++)
            c5[s] = arguments[s];
          for (var r5 = 0, g5 = c5.length; r5 < g5; r5++)
            if (c5[r5] != null)
              return c5[r5];
        }
        function tc2(c5, s) {
          return c5 != null ? c5 : s;
        }
        function pk2(c5, s, r5) {
          return c5 != null ? c5 : s != null ? s : r5;
        }
        function Qst(c5) {
          for (var s = [], r5 = 1; r5 < arguments.length; r5++)
            s[r5 - 1] = arguments[r5];
          return gM.apply(c5, s);
        }
        function VY(c5) {
          if (typeof c5 == "number")
            return [c5, c5, c5, c5];
          var s = c5.length;
          return s === 2 ? [c5[0], c5[1], c5[0], c5[1]] : s === 3 ? [c5[0], c5[1], c5[2], c5[1]] : c5;
        }
        function lx(c5, s) {
          if (!c5)
            throw new Error(s);
        }
        function Tg2(c5) {
          return c5 == null ? null : typeof c5.trim == "function" ? c5.trim() : c5.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
        }
        var BY = "__ec_primitive__";
        function DI(c5) {
          c5[BY] = true;
        }
        function I8(c5) {
          return c5[BY];
        }
        var Jst = function() {
          function c5(s) {
            this.data = {};
            var r5 = ja2(s);
            this.data = {};
            var g5 = this;
            s instanceof c5 ? s.each(b6) : s && Ye2(s, b6);
            function b6(S2, A2) {
              r5 ? g5.set(S2, A2) : g5.set(A2, S2);
            }
          }
          return c5.prototype.get = function(s) {
            return this.data.hasOwnProperty(s) ? this.data[s] : null;
          }, c5.prototype.set = function(s, r5) {
            return this.data[s] = r5;
          }, c5.prototype.each = function(s, r5) {
            for (var g5 in this.data)
              this.data.hasOwnProperty(g5) && s.call(r5, this.data[g5], g5);
          }, c5.prototype.keys = function() {
            return nf2(this.data);
          }, c5.prototype.removeKey = function(s) {
            delete this.data[s];
          }, c5;
        }();
        function Ps(c5) {
          return new Jst(c5);
        }
        function zY(c5, s) {
          for (var r5 = new c5.constructor(c5.length + s.length), g5 = 0; g5 < c5.length; g5++)
            r5[g5] = c5[g5];
          for (var b6 = c5.length, g5 = 0; g5 < s.length; g5++)
            r5[g5 + b6] = s[g5];
          return r5;
        }
        function hj2(c5, s) {
          var r5;
          if (Object.create)
            r5 = Object.create(c5);
          else {
            var g5 = function() {
            };
            g5.prototype = c5, r5 = new g5();
          }
          return s && sa2(r5, s), r5;
        }
        function tlt(c5) {
          var s = c5.style;
          s.webkitUserSelect = "none", s.userSelect = "none", s.webkitTapHighlightColor = "rgba(0,0,0,0)", s["-webkit-touch-callout"] = "none";
        }
        function Ls(c5, s) {
          return c5.hasOwnProperty(s);
        }
        function I0() {
        }
        var pj2 = 180 / Math.PI;
        function nm(c5, s) {
          return c5 == null && (c5 = 0), s == null && (s = 0), [c5, s];
        }
        function ux(c5, s) {
          return c5[0] = s[0], c5[1] = s[1], c5;
        }
        function Iy(c5) {
          return [c5[0], c5[1]];
        }
        function uzt(c5, s, r5) {
          return c5[0] = s, c5[1] = r5, c5;
        }
        function elt(c5, s, r5) {
          return c5[0] = s[0] + r5[0], c5[1] = s[1] + r5[1], c5;
        }
        function EI(c5, s, r5, g5) {
          return c5[0] = s[0] + r5[0] * g5, c5[1] = s[1] + r5[1] * g5, c5;
        }
        function kI(c5, s, r5) {
          return c5[0] = s[0] - r5[0], c5[1] = s[1] - r5[1], c5;
        }
        function dj2(c5) {
          return Math.sqrt(Vv(c5));
        }
        function Vv(c5) {
          return c5[0] * c5[0] + c5[1] * c5[1];
        }
        function PI3(c5, s, r5) {
          return c5[0] = s[0] * r5, c5[1] = s[1] * r5, c5;
        }
        function z4(c5, s) {
          var r5 = dj2(s);
          return r5 === 0 ? (c5[0] = 0, c5[1] = 0) : (c5[0] = s[0] / r5, c5[1] = s[1] / r5), c5;
        }
        function nlt(c5, s) {
          return Math.sqrt((c5[0] - s[0]) * (c5[0] - s[0]) + (c5[1] - s[1]) * (c5[1] - s[1]));
        }
        var LI = nlt;
        function czt(c5, s) {
          return (c5[0] - s[0]) * (c5[0] - s[0]) + (c5[1] - s[1]) * (c5[1] - s[1]);
        }
        var j4 = czt;
        function jY(c5, s, r5, g5) {
          return c5[0] = s[0] + g5 * (r5[0] - s[0]), c5[1] = s[1] + g5 * (r5[1] - s[1]), c5;
        }
        function Gm(c5, s, r5) {
          var g5 = s[0], b6 = s[1];
          return c5[0] = r5[0] * g5 + r5[2] * b6 + r5[4], c5[1] = r5[1] * g5 + r5[3] * b6 + r5[5], c5;
        }
        function BC(c5, s, r5) {
          return c5[0] = Math.min(s[0], r5[0]), c5[1] = Math.min(s[1], r5[1]), c5;
        }
        function c2(c5, s, r5) {
          return c5[0] = Math.max(s[0], r5[0]), c5[1] = Math.max(s[1], r5[1]), c5;
        }
        var D8 = function() {
          function c5(s, r5) {
            this.target = s, this.topTarget = r5 && r5.topTarget;
          }
          return c5;
        }(), tSt = function() {
          function c5(s) {
            this.handler = s, s.on("mousedown", this._dragStart, this), s.on("mousemove", this._drag, this), s.on("mouseup", this._dragEnd, this);
          }
          return c5.prototype._dragStart = function(s) {
            for (var r5 = s.target; r5 && !r5.draggable; )
              r5 = r5.parent || r5.__hostTarget;
            r5 && (this._draggingTarget = r5, r5.dragging = true, this._x = s.offsetX, this._y = s.offsetY, this.handler.dispatchToElement(new D8(r5, s), "dragstart", s.event));
          }, c5.prototype._drag = function(s) {
            var r5 = this._draggingTarget;
            if (r5) {
              var g5 = s.offsetX, b6 = s.offsetY, S2 = g5 - this._x, A2 = b6 - this._y;
              this._x = g5, this._y = b6, r5.drift(S2, A2, s), this.handler.dispatchToElement(new D8(r5, s), "drag", s.event);
              var k2 = this.handler.findHover(g5, b6, r5).target, R6 = this._dropTarget;
              this._dropTarget = k2, r5 !== k2 && (R6 && k2 !== R6 && this.handler.dispatchToElement(new D8(R6, s), "dragleave", s.event), k2 && k2 !== R6 && this.handler.dispatchToElement(new D8(k2, s), "dragenter", s.event));
            }
          }, c5.prototype._dragEnd = function(s) {
            var r5 = this._draggingTarget;
            r5 && (r5.dragging = false), this.handler.dispatchToElement(new D8(r5, s), "dragend", s.event), this._dropTarget && this.handler.dispatchToElement(new D8(this._dropTarget, s), "drop", s.event), this._draggingTarget = null, this._dropTarget = null;
          }, c5;
        }(), eSt = tSt, rlt = function() {
          function c5(s) {
            s && (this._$eventProcessor = s);
          }
          return c5.prototype.on = function(s, r5, g5, b6) {
            this._$handlers || (this._$handlers = {});
            var S2 = this._$handlers;
            if (typeof r5 == "function" && (b6 = g5, g5 = r5, r5 = null), !g5 || !s)
              return this;
            var A2 = this._$eventProcessor;
            r5 != null && A2 && A2.normalizeQuery && (r5 = A2.normalizeQuery(r5)), S2[s] || (S2[s] = []);
            for (var k2 = 0; k2 < S2[s].length; k2++)
              if (S2[s][k2].h === g5)
                return this;
            var R6 = { h: g5, query: r5, ctx: b6 || this, callAtLast: g5.zrEventfulCallAtLast }, B3 = S2[s].length - 1, G3 = S2[s][B3];
            return G3 && G3.callAtLast ? S2[s].splice(B3, 0, R6) : S2[s].push(R6), this;
          }, c5.prototype.isSilent = function(s) {
            var r5 = this._$handlers;
            return !r5 || !r5[s] || !r5[s].length;
          }, c5.prototype.off = function(s, r5) {
            var g5 = this._$handlers;
            if (!g5)
              return this;
            if (!s)
              return this._$handlers = {}, this;
            if (r5) {
              if (g5[s]) {
                for (var b6 = [], S2 = 0, A2 = g5[s].length; S2 < A2; S2++)
                  g5[s][S2].h !== r5 && b6.push(g5[s][S2]);
                g5[s] = b6;
              }
              g5[s] && g5[s].length === 0 && delete g5[s];
            } else
              delete g5[s];
            return this;
          }, c5.prototype.trigger = function(s) {
            for (var r5 = [], g5 = 1; g5 < arguments.length; g5++)
              r5[g5 - 1] = arguments[g5];
            if (!this._$handlers)
              return this;
            var b6 = this._$handlers[s], S2 = this._$eventProcessor;
            if (b6)
              for (var A2 = r5.length, k2 = b6.length, R6 = 0; R6 < k2; R6++) {
                var B3 = b6[R6];
                if (!(S2 && S2.filter && B3.query != null && !S2.filter(s, B3.query)))
                  switch (A2) {
                    case 0:
                      B3.h.call(B3.ctx);
                      break;
                    case 1:
                      B3.h.call(B3.ctx, r5[0]);
                      break;
                    case 2:
                      B3.h.call(B3.ctx, r5[0], r5[1]);
                      break;
                    default:
                      B3.h.apply(B3.ctx, r5);
                      break;
                  }
              }
            return S2 && S2.afterTrigger && S2.afterTrigger(s), this;
          }, c5.prototype.triggerWithContext = function(s) {
            for (var r5 = [], g5 = 1; g5 < arguments.length; g5++)
              r5[g5 - 1] = arguments[g5];
            if (!this._$handlers)
              return this;
            var b6 = this._$handlers[s], S2 = this._$eventProcessor;
            if (b6)
              for (var A2 = r5.length, k2 = r5[A2 - 1], R6 = b6.length, B3 = 0; B3 < R6; B3++) {
                var G3 = b6[B3];
                if (!(S2 && S2.filter && G3.query != null && !S2.filter(s, G3.query)))
                  switch (A2) {
                    case 0:
                      G3.h.call(k2);
                      break;
                    case 1:
                      G3.h.call(k2, r5[0]);
                      break;
                    case 2:
                      G3.h.call(k2, r5[0], r5[1]);
                      break;
                    default:
                      G3.h.apply(k2, r5.slice(1, A2 - 1));
                      break;
                  }
              }
            return S2 && S2.afterTrigger && S2.afterTrigger(s), this;
          }, c5;
        }(), Lw = rlt, nSt = Math.log(2);
        function ilt(c5, s, r5, g5, b6, S2) {
          var A2 = g5 + "-" + b6, k2 = c5.length;
          if (S2.hasOwnProperty(A2))
            return S2[A2];
          if (s === 1) {
            var R6 = Math.round(Math.log((1 << k2) - 1 & ~b6) / nSt);
            return c5[r5][R6];
          }
          for (var B3 = g5 | 1 << r5, G3 = r5 + 1; g5 & 1 << G3; )
            G3++;
          for (var Z3 = 0, X3 = 0, tt = 0; X3 < k2; X3++) {
            var it = 1 << X3;
            it & b6 || (Z3 += (tt % 2 ? -1 : 1) * c5[r5][X3] * ilt(c5, s - 1, G3, B3, b6 | it, S2), tt++);
          }
          return S2[A2] = Z3, Z3;
        }
        function WY(c5, s) {
          var r5 = [[c5[0], c5[1], 1, 0, 0, 0, -s[0] * c5[0], -s[0] * c5[1]], [0, 0, 0, c5[0], c5[1], 1, -s[1] * c5[0], -s[1] * c5[1]], [c5[2], c5[3], 1, 0, 0, 0, -s[2] * c5[2], -s[2] * c5[3]], [0, 0, 0, c5[2], c5[3], 1, -s[3] * c5[2], -s[3] * c5[3]], [c5[4], c5[5], 1, 0, 0, 0, -s[4] * c5[4], -s[4] * c5[5]], [0, 0, 0, c5[4], c5[5], 1, -s[5] * c5[4], -s[5] * c5[5]], [c5[6], c5[7], 1, 0, 0, 0, -s[6] * c5[6], -s[6] * c5[7]], [0, 0, 0, c5[6], c5[7], 1, -s[7] * c5[6], -s[7] * c5[7]]], g5 = {}, b6 = ilt(r5, 8, 0, 0, 0, g5);
          if (b6 !== 0) {
            for (var S2 = [], A2 = 0; A2 < 8; A2++)
              for (var k2 = 0; k2 < 8; k2++)
                S2[k2] == null && (S2[k2] = 0), S2[k2] += ((A2 + k2) % 2 ? -1 : 1) * ilt(r5, 7, A2 === 0 ? 1 : 0, 1 << A2, 1 << k2, g5) / b6 * s[A2];
            return function(R6, B3, G3) {
              var Z3 = B3 * S2[6] + G3 * S2[7] + 1;
              R6[0] = (B3 * S2[0] + G3 * S2[1] + S2[2]) / Z3, R6[1] = (B3 * S2[3] + G3 * S2[4] + S2[5]) / Z3;
            };
          }
        }
        var GY = "___zrEVENTSAVED", alt = [];
        function rSt(c5, s, r5, g5, b6) {
          return cx(alt, s, g5, b6, true) && cx(c5, r5, alt[0], alt[1]);
        }
        function cx(c5, s, r5, g5, b6) {
          if (s.getBoundingClientRect && os.domSupported && !slt(s)) {
            var S2 = s[GY] || (s[GY] = {}), A2 = olt(s, S2), k2 = gj2(A2, S2, b6);
            if (k2)
              return k2(c5, r5, g5), true;
          }
          return false;
        }
        function olt(c5, s) {
          var r5 = s.markers;
          if (r5)
            return r5;
          r5 = s.markers = [];
          for (var g5 = ["left", "right"], b6 = ["top", "bottom"], S2 = 0; S2 < 4; S2++) {
            var A2 = document.createElement("div"), k2 = A2.style, R6 = S2 % 2, B3 = (S2 >> 1) % 2;
            k2.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", g5[R6] + ":0", b6[B3] + ":0", g5[1 - R6] + ":auto", b6[1 - B3] + ":auto", ""].join("!important;"), c5.appendChild(A2), r5.push(A2);
          }
          return r5;
        }
        function gj2(c5, s, r5) {
          for (var g5 = r5 ? "invTrans" : "trans", b6 = s[g5], S2 = s.srcCoords, A2 = [], k2 = [], R6 = true, B3 = 0; B3 < 4; B3++) {
            var G3 = c5[B3].getBoundingClientRect(), Z3 = 2 * B3, X3 = G3.left, tt = G3.top;
            A2.push(X3, tt), R6 = R6 && S2 && X3 === S2[Z3] && tt === S2[Z3 + 1], k2.push(c5[B3].offsetLeft, c5[B3].offsetTop);
          }
          return R6 && b6 ? b6 : (s.srcCoords = A2, s[g5] = r5 ? WY(k2, A2) : WY(A2, k2));
        }
        function slt(c5) {
          return c5.nodeName.toUpperCase() === "CANVAS";
        }
        var iSt = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, llt = [], fzt = os.browser.firefox && +os.browser.version.split(".")[0] < 39;
        function ult(c5, s, r5, g5) {
          return r5 = r5 || {}, g5 ? aSt(c5, s, r5) : fzt && s.layerX != null && s.layerX !== s.offsetX ? (r5.zrX = s.layerX, r5.zrY = s.layerY) : s.offsetX != null ? (r5.zrX = s.offsetX, r5.zrY = s.offsetY) : aSt(c5, s, r5), r5;
        }
        function aSt(c5, s, r5) {
          if (os.domSupported && c5.getBoundingClientRect) {
            var g5 = s.clientX, b6 = s.clientY;
            if (slt(c5)) {
              var S2 = c5.getBoundingClientRect();
              r5.zrX = g5 - S2.left, r5.zrY = b6 - S2.top;
              return;
            } else if (cx(llt, c5, g5, b6)) {
              r5.zrX = llt[0], r5.zrY = llt[1];
              return;
            }
          }
          r5.zrX = r5.zrY = 0;
        }
        function clt(c5) {
          return c5 || window.event;
        }
        function N1(c5, s, r5) {
          if (s = clt(s), s.zrX != null)
            return s;
          var g5 = s.type, b6 = g5 && g5.indexOf("touch") >= 0;
          if (b6) {
            var S2 = g5 !== "touchend" ? s.targetTouches[0] : s.changedTouches[0];
            S2 && ult(c5, S2, s, r5);
          } else {
            ult(c5, s, s, r5);
            var A2 = hzt(s);
            s.zrDelta = A2 ? A2 / 120 : -(s.detail || 0) / 3;
          }
          var k2 = s.button;
          return s.which == null && k2 !== void 0 && iSt.test(s.type) && (s.which = k2 & 1 ? 1 : k2 & 2 ? 3 : k2 & 4 ? 2 : 0), s;
        }
        function hzt(c5) {
          var s = c5.wheelDelta;
          if (s)
            return s;
          var r5 = c5.deltaX, g5 = c5.deltaY;
          if (r5 == null || g5 == null)
            return s;
          var b6 = Math.abs(g5 !== 0 ? g5 : r5), S2 = g5 > 0 ? -1 : g5 < 0 ? 1 : r5 > 0 ? -1 : 1;
          return 3 * b6 * S2;
        }
        function flt(c5, s, r5, g5) {
          c5.addEventListener(s, r5, g5);
        }
        function hlt(c5, s, r5, g5) {
          c5.removeEventListener(s, r5, g5);
        }
        var OI = function(c5) {
          c5.preventDefault(), c5.stopPropagation(), c5.cancelBubble = true;
        };
        function dk2(c5) {
          return c5.which === 2 || c5.which === 3;
        }
        var HY = function() {
          function c5() {
            this._track = [];
          }
          return c5.prototype.recognize = function(s, r5, g5) {
            return this._doTrack(s, r5, g5), this._recognize(s);
          }, c5.prototype.clear = function() {
            return this._track.length = 0, this;
          }, c5.prototype._doTrack = function(s, r5, g5) {
            var b6 = s.touches;
            if (b6) {
              for (var S2 = { points: [], touches: [], target: r5, event: s }, A2 = 0, k2 = b6.length; A2 < k2; A2++) {
                var R6 = b6[A2], B3 = ult(g5, R6, {});
                S2.points.push([B3.zrX, B3.zrY]), S2.touches.push(R6);
              }
              this._track.push(S2);
            }
          }, c5.prototype._recognize = function(s) {
            for (var r5 in plt)
              if (plt.hasOwnProperty(r5)) {
                var g5 = plt[r5](this._track, s);
                if (g5)
                  return g5;
              }
          }, c5;
        }();
        function oSt(c5) {
          var s = c5[1][0] - c5[0][0], r5 = c5[1][1] - c5[0][1];
          return Math.sqrt(s * s + r5 * r5);
        }
        function pzt(c5) {
          return [(c5[0][0] + c5[1][0]) / 2, (c5[0][1] + c5[1][1]) / 2];
        }
        var plt = { pinch: function(c5, s) {
          var r5 = c5.length;
          if (r5) {
            var g5 = (c5[r5 - 1] || {}).points, b6 = (c5[r5 - 2] || {}).points || g5;
            if (b6 && b6.length > 1 && g5 && g5.length > 1) {
              var S2 = oSt(g5) / oSt(b6);
              !isFinite(S2) && (S2 = 1), s.pinchScale = S2;
              var A2 = pzt(g5);
              return s.pinchX = A2[0], s.pinchY = A2[1], { type: "pinch", target: c5[0].target, event: s };
            }
          }
        } }, W4 = "silent";
        function zC(c5, s, r5) {
          return { type: c5, event: r5, target: s.target, topTarget: s.topTarget, cancelBubble: false, offsetX: r5.zrX, offsetY: r5.zrY, gestureEvent: r5.gestureEvent, pinchX: r5.pinchX, pinchY: r5.pinchY, pinchScale: r5.pinchScale, wheelDelta: r5.zrDelta, zrByTouch: r5.zrByTouch, which: r5.which, stop: sSt };
        }
        function sSt() {
          OI(this.event);
        }
        var dzt = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.handler = null, r5;
          }
          return s.prototype.dispose = function() {
          }, s.prototype.setCursor = function() {
          }, s;
        }(Lw), vj2 = function() {
          function c5(s, r5) {
            this.x = s, this.y = r5;
          }
          return c5;
        }(), gzt = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], lSt = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2) {
            var A2 = c5.call(this) || this;
            return A2._hovered = new vj2(0, 0), A2.storage = r5, A2.painter = g5, A2.painterRoot = S2, b6 = b6 || new dzt(), A2.proxy = null, A2.setHandlerProxy(b6), A2._draggingMgr = new eSt(A2), A2;
          }
          return s.prototype.setHandlerProxy = function(r5) {
            this.proxy && this.proxy.dispose(), r5 && (Ye2(gzt, function(g5) {
              r5.on && r5.on(g5, this[g5], this);
            }, this), r5.handler = this), this.proxy = r5;
          }, s.prototype.mousemove = function(r5) {
            var g5 = r5.zrX, b6 = r5.zrY, S2 = G4(this, g5, b6), A2 = this._hovered, k2 = A2.target;
            k2 && !k2.__zr && (A2 = this.findHover(A2.x, A2.y), k2 = A2.target);
            var R6 = this._hovered = S2 ? new vj2(g5, b6) : this.findHover(g5, b6), B3 = R6.target, G3 = this.proxy;
            G3.setCursor && G3.setCursor(B3 ? B3.cursor : "default"), k2 && B3 !== k2 && this.dispatchToElement(A2, "mouseout", r5), this.dispatchToElement(R6, "mousemove", r5), B3 && B3 !== k2 && this.dispatchToElement(R6, "mouseover", r5);
          }, s.prototype.mouseout = function(r5) {
            var g5 = r5.zrEventControl;
            g5 !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", r5), g5 !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: r5 });
          }, s.prototype.resize = function() {
            this._hovered = new vj2(0, 0);
          }, s.prototype.dispatch = function(r5, g5) {
            var b6 = this[r5];
            b6 && b6.call(this, g5);
          }, s.prototype.dispose = function() {
            this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
          }, s.prototype.setCursorStyle = function(r5) {
            var g5 = this.proxy;
            g5.setCursor && g5.setCursor(r5);
          }, s.prototype.dispatchToElement = function(r5, g5, b6) {
            r5 = r5 || {};
            var S2 = r5.target;
            if (!(S2 && S2.silent)) {
              for (var A2 = "on" + g5, k2 = zC(g5, r5, b6); S2 && (S2[A2] && (k2.cancelBubble = !!S2[A2].call(S2, k2)), S2.trigger(g5, k2), S2 = S2.__hostTarget ? S2.__hostTarget : S2.parent, !k2.cancelBubble); )
                ;
              k2.cancelBubble || (this.trigger(g5, k2), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(R6) {
                typeof R6[A2] == "function" && R6[A2].call(R6, k2), R6.trigger && R6.trigger(g5, k2);
              }));
            }
          }, s.prototype.findHover = function(r5, g5, b6) {
            for (var S2 = this.storage.getDisplayList(), A2 = new vj2(r5, g5), k2 = S2.length - 1; k2 >= 0; k2--) {
              var R6 = void 0;
              if (S2[k2] !== b6 && !S2[k2].ignore && (R6 = vzt(S2[k2], r5, g5)) && (!A2.topTarget && (A2.topTarget = S2[k2]), R6 !== W4)) {
                A2.target = S2[k2];
                break;
              }
            }
            return A2;
          }, s.prototype.processGesture = function(r5, g5) {
            this._gestureMgr || (this._gestureMgr = new HY());
            var b6 = this._gestureMgr;
            g5 === "start" && b6.clear();
            var S2 = b6.recognize(r5, this.findHover(r5.zrX, r5.zrY, null).target, this.proxy.dom);
            if (g5 === "end" && b6.clear(), S2) {
              var A2 = S2.type;
              r5.gestureEvent = A2;
              var k2 = new vj2();
              k2.target = S2.target, this.dispatchToElement(k2, A2, S2.event);
            }
          }, s;
        }(Lw);
        Ye2(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(c5) {
          lSt.prototype[c5] = function(s) {
            var r5 = s.zrX, g5 = s.zrY, b6 = G4(this, r5, g5), S2, A2;
            if ((c5 !== "mouseup" || !b6) && (S2 = this.findHover(r5, g5), A2 = S2.target), c5 === "mousedown")
              this._downEl = A2, this._downPoint = [s.zrX, s.zrY], this._upEl = A2;
            else if (c5 === "mouseup")
              this._upEl = A2;
            else if (c5 === "click") {
              if (this._downEl !== this._upEl || !this._downPoint || LI(this._downPoint, [s.zrX, s.zrY]) > 4)
                return;
              this._downPoint = null;
            }
            this.dispatchToElement(S2, c5, s);
          };
        });
        function vzt(c5, s, r5) {
          if (c5[c5.rectHover ? "rectContain" : "contain"](s, r5)) {
            for (var g5 = c5, b6 = void 0, S2 = false; g5; ) {
              if (g5.ignoreClip && (S2 = true), !S2) {
                var A2 = g5.getClipPath();
                if (A2 && !A2.contain(s, r5))
                  return false;
                g5.silent && (b6 = true);
              }
              var k2 = g5.__hostTarget;
              g5 = k2 || g5.parent;
            }
            return b6 ? W4 : true;
          }
          return false;
        }
        function G4(c5, s, r5) {
          var g5 = c5.painter;
          return s < 0 || s > g5.getWidth() || r5 < 0 || r5 > g5.getHeight();
        }
        var wi2 = lSt, oo = 32, da2 = 7;
        function Gl(c5) {
          for (var s = 0; c5 >= oo; )
            s |= c5 & 1, c5 >>= 1;
          return c5 + s;
        }
        function $c2(c5, s, r5, g5) {
          var b6 = s + 1;
          if (b6 === r5)
            return 1;
          if (g5(c5[b6++], c5[s]) < 0) {
            for (; b6 < r5 && g5(c5[b6], c5[b6 - 1]) < 0; )
              b6++;
            pd2(c5, s, b6);
          } else
            for (; b6 < r5 && g5(c5[b6], c5[b6 - 1]) >= 0; )
              b6++;
          return b6 - s;
        }
        function pd2(c5, s, r5) {
          for (r5--; s < r5; ) {
            var g5 = c5[s];
            c5[s++] = c5[r5], c5[r5--] = g5;
          }
        }
        function Dy(c5, s, r5, g5, b6) {
          for (g5 === s && g5++; g5 < r5; g5++) {
            for (var S2 = c5[g5], A2 = s, k2 = g5, R6; A2 < k2; )
              R6 = A2 + k2 >>> 1, b6(S2, c5[R6]) < 0 ? k2 = R6 : A2 = R6 + 1;
            var B3 = g5 - A2;
            switch (B3) {
              case 3:
                c5[A2 + 3] = c5[A2 + 2];
              case 2:
                c5[A2 + 2] = c5[A2 + 1];
              case 1:
                c5[A2 + 1] = c5[A2];
                break;
              default:
                for (; B3 > 0; )
                  c5[A2 + B3] = c5[A2 + B3 - 1], B3--;
            }
            c5[A2] = S2;
          }
        }
        function Vd2(c5, s, r5, g5, b6, S2) {
          var A2 = 0, k2 = 0, R6 = 1;
          if (S2(c5, s[r5 + b6]) > 0) {
            for (k2 = g5 - b6; R6 < k2 && S2(c5, s[r5 + b6 + R6]) > 0; )
              A2 = R6, R6 = (R6 << 1) + 1, R6 <= 0 && (R6 = k2);
            R6 > k2 && (R6 = k2), A2 += b6, R6 += b6;
          } else {
            for (k2 = b6 + 1; R6 < k2 && S2(c5, s[r5 + b6 - R6]) <= 0; )
              A2 = R6, R6 = (R6 << 1) + 1, R6 <= 0 && (R6 = k2);
            R6 > k2 && (R6 = k2);
            var B3 = A2;
            A2 = b6 - R6, R6 = b6 - B3;
          }
          for (A2++; A2 < R6; ) {
            var G3 = A2 + (R6 - A2 >>> 1);
            S2(c5, s[r5 + G3]) > 0 ? A2 = G3 + 1 : R6 = G3;
          }
          return R6;
        }
        function yj2(c5, s, r5, g5, b6, S2) {
          var A2 = 0, k2 = 0, R6 = 1;
          if (S2(c5, s[r5 + b6]) < 0) {
            for (k2 = b6 + 1; R6 < k2 && S2(c5, s[r5 + b6 - R6]) < 0; )
              A2 = R6, R6 = (R6 << 1) + 1, R6 <= 0 && (R6 = k2);
            R6 > k2 && (R6 = k2);
            var B3 = A2;
            A2 = b6 - R6, R6 = b6 - B3;
          } else {
            for (k2 = g5 - b6; R6 < k2 && S2(c5, s[r5 + b6 + R6]) >= 0; )
              A2 = R6, R6 = (R6 << 1) + 1, R6 <= 0 && (R6 = k2);
            R6 > k2 && (R6 = k2), A2 += b6, R6 += b6;
          }
          for (A2++; A2 < R6; ) {
            var G3 = A2 + (R6 - A2 >>> 1);
            S2(c5, s[r5 + G3]) < 0 ? R6 = G3 : A2 = G3 + 1;
          }
          return R6;
        }
        function yzt(c5, s) {
          var r5 = da2, g5, b6, S2 = 0, A2 = [];
          g5 = [], b6 = [];
          function k2(tt, it) {
            g5[S2] = tt, b6[S2] = it, S2 += 1;
          }
          function R6() {
            for (; S2 > 1; ) {
              var tt = S2 - 2;
              if (tt >= 1 && b6[tt - 1] <= b6[tt] + b6[tt + 1] || tt >= 2 && b6[tt - 2] <= b6[tt] + b6[tt - 1])
                b6[tt - 1] < b6[tt + 1] && tt--;
              else if (b6[tt] > b6[tt + 1])
                break;
              G3(tt);
            }
          }
          function B3() {
            for (; S2 > 1; ) {
              var tt = S2 - 2;
              tt > 0 && b6[tt - 1] < b6[tt + 1] && tt--, G3(tt);
            }
          }
          function G3(tt) {
            var it = g5[tt], pt = b6[tt], mt = g5[tt + 1], Mt = b6[tt + 1];
            b6[tt] = pt + Mt, tt === S2 - 3 && (g5[tt + 1] = g5[tt + 2], b6[tt + 1] = b6[tt + 2]), S2--;
            var kt = yj2(c5[mt], c5, it, pt, 0, s);
            it += kt, pt -= kt, pt !== 0 && (Mt = Vd2(c5[it + pt - 1], c5, mt, Mt, Mt - 1, s), Mt !== 0 && (pt <= Mt ? Z3(it, pt, mt, Mt) : X3(it, pt, mt, Mt)));
          }
          function Z3(tt, it, pt, mt) {
            var Mt = 0;
            for (Mt = 0; Mt < it; Mt++)
              A2[Mt] = c5[tt + Mt];
            var kt = 0, Gt = pt, Ot = tt;
            if (c5[Ot++] = c5[Gt++], --mt === 0) {
              for (Mt = 0; Mt < it; Mt++)
                c5[Ot + Mt] = A2[kt + Mt];
              return;
            }
            if (it === 1) {
              for (Mt = 0; Mt < mt; Mt++)
                c5[Ot + Mt] = c5[Gt + Mt];
              c5[Ot + mt] = A2[kt];
              return;
            }
            for (var ce2 = r5, ae2, de2, we2; ; ) {
              ae2 = 0, de2 = 0, we2 = false;
              do
                if (s(c5[Gt], A2[kt]) < 0) {
                  if (c5[Ot++] = c5[Gt++], de2++, ae2 = 0, --mt === 0) {
                    we2 = true;
                    break;
                  }
                } else if (c5[Ot++] = A2[kt++], ae2++, de2 = 0, --it === 1) {
                  we2 = true;
                  break;
                }
              while ((ae2 | de2) < ce2);
              if (we2)
                break;
              do {
                if (ae2 = yj2(c5[Gt], A2, kt, it, 0, s), ae2 !== 0) {
                  for (Mt = 0; Mt < ae2; Mt++)
                    c5[Ot + Mt] = A2[kt + Mt];
                  if (Ot += ae2, kt += ae2, it -= ae2, it <= 1) {
                    we2 = true;
                    break;
                  }
                }
                if (c5[Ot++] = c5[Gt++], --mt === 0) {
                  we2 = true;
                  break;
                }
                if (de2 = Vd2(A2[kt], c5, Gt, mt, 0, s), de2 !== 0) {
                  for (Mt = 0; Mt < de2; Mt++)
                    c5[Ot + Mt] = c5[Gt + Mt];
                  if (Ot += de2, Gt += de2, mt -= de2, mt === 0) {
                    we2 = true;
                    break;
                  }
                }
                if (c5[Ot++] = A2[kt++], --it === 1) {
                  we2 = true;
                  break;
                }
                ce2--;
              } while (ae2 >= da2 || de2 >= da2);
              if (we2)
                break;
              ce2 < 0 && (ce2 = 0), ce2 += 2;
            }
            if (r5 = ce2, r5 < 1 && (r5 = 1), it === 1) {
              for (Mt = 0; Mt < mt; Mt++)
                c5[Ot + Mt] = c5[Gt + Mt];
              c5[Ot + mt] = A2[kt];
            } else {
              if (it === 0)
                throw new Error();
              for (Mt = 0; Mt < it; Mt++)
                c5[Ot + Mt] = A2[kt + Mt];
            }
          }
          function X3(tt, it, pt, mt) {
            var Mt = 0;
            for (Mt = 0; Mt < mt; Mt++)
              A2[Mt] = c5[pt + Mt];
            var kt = tt + it - 1, Gt = mt - 1, Ot = pt + mt - 1, ce2 = 0, ae2 = 0;
            if (c5[Ot--] = c5[kt--], --it === 0) {
              for (ce2 = Ot - (mt - 1), Mt = 0; Mt < mt; Mt++)
                c5[ce2 + Mt] = A2[Mt];
              return;
            }
            if (mt === 1) {
              for (Ot -= it, kt -= it, ae2 = Ot + 1, ce2 = kt + 1, Mt = it - 1; Mt >= 0; Mt--)
                c5[ae2 + Mt] = c5[ce2 + Mt];
              c5[Ot] = A2[Gt];
              return;
            }
            for (var de2 = r5; ; ) {
              var we2 = 0, Se2 = 0, Oe2 = false;
              do
                if (s(A2[Gt], c5[kt]) < 0) {
                  if (c5[Ot--] = c5[kt--], we2++, Se2 = 0, --it === 0) {
                    Oe2 = true;
                    break;
                  }
                } else if (c5[Ot--] = A2[Gt--], Se2++, we2 = 0, --mt === 1) {
                  Oe2 = true;
                  break;
                }
              while ((we2 | Se2) < de2);
              if (Oe2)
                break;
              do {
                if (we2 = it - yj2(A2[Gt], c5, tt, it, it - 1, s), we2 !== 0) {
                  for (Ot -= we2, kt -= we2, it -= we2, ae2 = Ot + 1, ce2 = kt + 1, Mt = we2 - 1; Mt >= 0; Mt--)
                    c5[ae2 + Mt] = c5[ce2 + Mt];
                  if (it === 0) {
                    Oe2 = true;
                    break;
                  }
                }
                if (c5[Ot--] = A2[Gt--], --mt === 1) {
                  Oe2 = true;
                  break;
                }
                if (Se2 = mt - Vd2(c5[kt], A2, 0, mt, mt - 1, s), Se2 !== 0) {
                  for (Ot -= Se2, Gt -= Se2, mt -= Se2, ae2 = Ot + 1, ce2 = Gt + 1, Mt = 0; Mt < Se2; Mt++)
                    c5[ae2 + Mt] = A2[ce2 + Mt];
                  if (mt <= 1) {
                    Oe2 = true;
                    break;
                  }
                }
                if (c5[Ot--] = c5[kt--], --it === 0) {
                  Oe2 = true;
                  break;
                }
                de2--;
              } while (we2 >= da2 || Se2 >= da2);
              if (Oe2)
                break;
              de2 < 0 && (de2 = 0), de2 += 2;
            }
            if (r5 = de2, r5 < 1 && (r5 = 1), mt === 1) {
              for (Ot -= it, kt -= it, ae2 = Ot + 1, ce2 = kt + 1, Mt = it - 1; Mt >= 0; Mt--)
                c5[ae2 + Mt] = c5[ce2 + Mt];
              c5[Ot] = A2[Gt];
            } else {
              if (mt === 0)
                throw new Error();
              for (ce2 = Ot - (mt - 1), Mt = 0; Mt < mt; Mt++)
                c5[ce2 + Mt] = A2[Mt];
            }
          }
          return { mergeRuns: R6, forceMergeRuns: B3, pushRun: k2 };
        }
        function fx(c5, s, r5, g5) {
          r5 || (r5 = 0), g5 || (g5 = c5.length);
          var b6 = g5 - r5;
          if (!(b6 < 2)) {
            var S2 = 0;
            if (b6 < oo) {
              S2 = $c2(c5, r5, g5, s), Dy(c5, r5, g5, r5 + S2, s);
              return;
            }
            var A2 = yzt(c5, s), k2 = Gl(b6);
            do {
              if (S2 = $c2(c5, r5, g5, s), S2 < k2) {
                var R6 = b6;
                R6 > k2 && (R6 = k2), Dy(c5, r5, r5 + R6, r5 + S2, s), S2 = R6;
              }
              A2.pushRun(r5, S2), A2.mergeRuns(), b6 -= S2, r5 += S2;
            } while (b6 !== 0);
            A2.forceMergeRuns();
          }
        }
        var Vb2 = 1, mj2 = 2, jC = 4, bj2 = false;
        function E8() {
          bj2 || (bj2 = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
        }
        function Md2(c5, s) {
          return c5.zlevel === s.zlevel ? c5.z === s.z ? c5.z2 - s.z2 : c5.z - s.z : c5.zlevel - s.zlevel;
        }
        var mzt = function() {
          function c5() {
            this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = Md2;
          }
          return c5.prototype.traverse = function(s, r5) {
            for (var g5 = 0; g5 < this._roots.length; g5++)
              this._roots[g5].traverse(s, r5);
          }, c5.prototype.getDisplayList = function(s, r5) {
            r5 = r5 || false;
            var g5 = this._displayList;
            return (s || !g5.length) && this.updateDisplayList(r5), g5;
          }, c5.prototype.updateDisplayList = function(s) {
            this._displayListLen = 0;
            for (var r5 = this._roots, g5 = this._displayList, b6 = 0, S2 = r5.length; b6 < S2; b6++)
              this._updateAndAddDisplayable(r5[b6], null, s);
            g5.length = this._displayListLen, fx(g5, Md2);
          }, c5.prototype._updateAndAddDisplayable = function(s, r5, g5) {
            if (!(s.ignore && !g5)) {
              s.beforeUpdate(), s.update(), s.afterUpdate();
              var b6 = s.getClipPath();
              if (s.ignoreClip)
                r5 = null;
              else if (b6) {
                r5 ? r5 = r5.slice() : r5 = [];
                for (var S2 = b6, A2 = s; S2; )
                  S2.parent = A2, S2.updateTransform(), r5.push(S2), A2 = S2, S2 = S2.getClipPath();
              }
              if (s.childrenRef) {
                for (var k2 = s.childrenRef(), R6 = 0; R6 < k2.length; R6++) {
                  var B3 = k2[R6];
                  s.__dirty && (B3.__dirty |= Vb2), this._updateAndAddDisplayable(B3, r5, g5);
                }
                s.__dirty = 0;
              } else {
                var G3 = s;
                r5 && r5.length ? G3.__clipPaths = r5 : G3.__clipPaths && G3.__clipPaths.length > 0 && (G3.__clipPaths = []), isNaN(G3.z) && (E8(), G3.z = 0), isNaN(G3.z2) && (E8(), G3.z2 = 0), isNaN(G3.zlevel) && (E8(), G3.zlevel = 0), this._displayList[this._displayListLen++] = G3;
              }
              var Z3 = s.getDecalElement && s.getDecalElement();
              Z3 && this._updateAndAddDisplayable(Z3, r5, g5);
              var X3 = s.getTextGuideLine();
              X3 && this._updateAndAddDisplayable(X3, r5, g5);
              var tt = s.getTextContent();
              tt && this._updateAndAddDisplayable(tt, r5, g5);
            }
          }, c5.prototype.addRoot = function(s) {
            s.__zr && s.__zr.storage === this || this._roots.push(s);
          }, c5.prototype.delRoot = function(s) {
            if (s instanceof Array) {
              for (var r5 = 0, g5 = s.length; r5 < g5; r5++)
                this.delRoot(s[r5]);
              return;
            }
            var b6 = Lu(this._roots, s);
            b6 >= 0 && this._roots.splice(b6, 1);
          }, c5.prototype.delAllRoots = function() {
            this._roots = [], this._displayList = [], this._displayListLen = 0;
          }, c5.prototype.getRoots = function() {
            return this._roots;
          }, c5.prototype.dispose = function() {
            this._displayList = null, this._roots = null;
          }, c5;
        }(), uSt = mzt, _j;
        _j = os.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(c5) {
          return setTimeout(c5, 16);
        };
        var dlt = _j, UY = { linear: function(c5) {
          return c5;
        }, quadraticIn: function(c5) {
          return c5 * c5;
        }, quadraticOut: function(c5) {
          return c5 * (2 - c5);
        }, quadraticInOut: function(c5) {
          return (c5 *= 2) < 1 ? 0.5 * c5 * c5 : -0.5 * (--c5 * (c5 - 2) - 1);
        }, cubicIn: function(c5) {
          return c5 * c5 * c5;
        }, cubicOut: function(c5) {
          return --c5 * c5 * c5 + 1;
        }, cubicInOut: function(c5) {
          return (c5 *= 2) < 1 ? 0.5 * c5 * c5 * c5 : 0.5 * ((c5 -= 2) * c5 * c5 + 2);
        }, quarticIn: function(c5) {
          return c5 * c5 * c5 * c5;
        }, quarticOut: function(c5) {
          return 1 - --c5 * c5 * c5 * c5;
        }, quarticInOut: function(c5) {
          return (c5 *= 2) < 1 ? 0.5 * c5 * c5 * c5 * c5 : -0.5 * ((c5 -= 2) * c5 * c5 * c5 - 2);
        }, quinticIn: function(c5) {
          return c5 * c5 * c5 * c5 * c5;
        }, quinticOut: function(c5) {
          return --c5 * c5 * c5 * c5 * c5 + 1;
        }, quinticInOut: function(c5) {
          return (c5 *= 2) < 1 ? 0.5 * c5 * c5 * c5 * c5 * c5 : 0.5 * ((c5 -= 2) * c5 * c5 * c5 * c5 + 2);
        }, sinusoidalIn: function(c5) {
          return 1 - Math.cos(c5 * Math.PI / 2);
        }, sinusoidalOut: function(c5) {
          return Math.sin(c5 * Math.PI / 2);
        }, sinusoidalInOut: function(c5) {
          return 0.5 * (1 - Math.cos(Math.PI * c5));
        }, exponentialIn: function(c5) {
          return c5 === 0 ? 0 : Math.pow(1024, c5 - 1);
        }, exponentialOut: function(c5) {
          return c5 === 1 ? 1 : 1 - Math.pow(2, -10 * c5);
        }, exponentialInOut: function(c5) {
          return c5 === 0 ? 0 : c5 === 1 ? 1 : (c5 *= 2) < 1 ? 0.5 * Math.pow(1024, c5 - 1) : 0.5 * (-Math.pow(2, -10 * (c5 - 1)) + 2);
        }, circularIn: function(c5) {
          return 1 - Math.sqrt(1 - c5 * c5);
        }, circularOut: function(c5) {
          return Math.sqrt(1 - --c5 * c5);
        }, circularInOut: function(c5) {
          return (c5 *= 2) < 1 ? -0.5 * (Math.sqrt(1 - c5 * c5) - 1) : 0.5 * (Math.sqrt(1 - (c5 -= 2) * c5) + 1);
        }, elasticIn: function(c5) {
          var s, r5 = 0.1, g5 = 0.4;
          return c5 === 0 ? 0 : c5 === 1 ? 1 : (!r5 || r5 < 1 ? (r5 = 1, s = g5 / 4) : s = g5 * Math.asin(1 / r5) / (2 * Math.PI), -(r5 * Math.pow(2, 10 * (c5 -= 1)) * Math.sin((c5 - s) * (2 * Math.PI) / g5)));
        }, elasticOut: function(c5) {
          var s, r5 = 0.1, g5 = 0.4;
          return c5 === 0 ? 0 : c5 === 1 ? 1 : (!r5 || r5 < 1 ? (r5 = 1, s = g5 / 4) : s = g5 * Math.asin(1 / r5) / (2 * Math.PI), r5 * Math.pow(2, -10 * c5) * Math.sin((c5 - s) * (2 * Math.PI) / g5) + 1);
        }, elasticInOut: function(c5) {
          var s, r5 = 0.1, g5 = 0.4;
          return c5 === 0 ? 0 : c5 === 1 ? 1 : (!r5 || r5 < 1 ? (r5 = 1, s = g5 / 4) : s = g5 * Math.asin(1 / r5) / (2 * Math.PI), (c5 *= 2) < 1 ? -0.5 * (r5 * Math.pow(2, 10 * (c5 -= 1)) * Math.sin((c5 - s) * (2 * Math.PI) / g5)) : r5 * Math.pow(2, -10 * (c5 -= 1)) * Math.sin((c5 - s) * (2 * Math.PI) / g5) * 0.5 + 1);
        }, backIn: function(c5) {
          var s = 1.70158;
          return c5 * c5 * ((s + 1) * c5 - s);
        }, backOut: function(c5) {
          var s = 1.70158;
          return --c5 * c5 * ((s + 1) * c5 + s) + 1;
        }, backInOut: function(c5) {
          var s = 2.5949095;
          return (c5 *= 2) < 1 ? 0.5 * (c5 * c5 * ((s + 1) * c5 - s)) : 0.5 * ((c5 -= 2) * c5 * ((s + 1) * c5 + s) + 2);
        }, bounceIn: function(c5) {
          return 1 - UY.bounceOut(1 - c5);
        }, bounceOut: function(c5) {
          return c5 < 1 / 2.75 ? 7.5625 * c5 * c5 : c5 < 2 / 2.75 ? 7.5625 * (c5 -= 1.5 / 2.75) * c5 + 0.75 : c5 < 2.5 / 2.75 ? 7.5625 * (c5 -= 2.25 / 2.75) * c5 + 0.9375 : 7.5625 * (c5 -= 2.625 / 2.75) * c5 + 0.984375;
        }, bounceInOut: function(c5) {
          return c5 < 0.5 ? UY.bounceIn(c5 * 2) * 0.5 : UY.bounceOut(c5 * 2 - 1) * 0.5 + 0.5;
        } }, cSt = UY, H4 = Math.pow, hx = Math.sqrt, U4 = 1e-8, glt = 1e-4, xj2 = hx(3), wj2 = 1 / 3, WC = nm(), px = nm(), q4 = nm();
        function vM(c5) {
          return c5 > -U4 && c5 < U4;
        }
        function i3(c5) {
          return c5 > U4 || c5 < -U4;
        }
        function D0(c5, s, r5, g5, b6) {
          var S2 = 1 - b6;
          return S2 * S2 * (S2 * c5 + 3 * b6 * s) + b6 * b6 * (b6 * g5 + 3 * S2 * r5);
        }
        function fSt(c5, s, r5, g5, b6) {
          var S2 = 1 - b6;
          return 3 * (((s - c5) * S2 + 2 * (r5 - s) * b6) * S2 + (g5 - r5) * b6 * b6);
        }
        function qY(c5, s, r5, g5, b6, S2) {
          var A2 = g5 + 3 * (s - r5) - c5, k2 = 3 * (r5 - s * 2 + c5), R6 = 3 * (s - c5), B3 = c5 - b6, G3 = k2 * k2 - 3 * A2 * R6, Z3 = k2 * R6 - 9 * A2 * B3, X3 = R6 * R6 - 3 * k2 * B3, tt = 0;
          if (vM(G3) && vM(Z3))
            if (vM(k2))
              S2[0] = 0;
            else {
              var it = -R6 / k2;
              it >= 0 && it <= 1 && (S2[tt++] = it);
            }
          else {
            var pt = Z3 * Z3 - 4 * G3 * X3;
            if (vM(pt)) {
              var mt = Z3 / G3, it = -k2 / A2 + mt, Mt = -mt / 2;
              it >= 0 && it <= 1 && (S2[tt++] = it), Mt >= 0 && Mt <= 1 && (S2[tt++] = Mt);
            } else if (pt > 0) {
              var kt = hx(pt), Gt = G3 * k2 + 1.5 * A2 * (-Z3 + kt), Ot = G3 * k2 + 1.5 * A2 * (-Z3 - kt);
              Gt < 0 ? Gt = -H4(-Gt, wj2) : Gt = H4(Gt, wj2), Ot < 0 ? Ot = -H4(-Ot, wj2) : Ot = H4(Ot, wj2);
              var it = (-k2 - (Gt + Ot)) / (3 * A2);
              it >= 0 && it <= 1 && (S2[tt++] = it);
            } else {
              var ce2 = (2 * G3 * k2 - 3 * A2 * Z3) / (2 * hx(G3 * G3 * G3)), ae2 = Math.acos(ce2) / 3, de2 = hx(G3), we2 = Math.cos(ae2), it = (-k2 - 2 * de2 * we2) / (3 * A2), Mt = (-k2 + de2 * (we2 + xj2 * Math.sin(ae2))) / (3 * A2), Se2 = (-k2 + de2 * (we2 - xj2 * Math.sin(ae2))) / (3 * A2);
              it >= 0 && it <= 1 && (S2[tt++] = it), Mt >= 0 && Mt <= 1 && (S2[tt++] = Mt), Se2 >= 0 && Se2 <= 1 && (S2[tt++] = Se2);
            }
          }
          return tt;
        }
        function hSt(c5, s, r5, g5, b6) {
          var S2 = 6 * r5 - 12 * s + 6 * c5, A2 = 9 * s + 3 * g5 - 3 * c5 - 9 * r5, k2 = 3 * s - 3 * c5, R6 = 0;
          if (vM(A2)) {
            if (i3(S2)) {
              var B3 = -k2 / S2;
              B3 >= 0 && B3 <= 1 && (b6[R6++] = B3);
            }
          } else {
            var G3 = S2 * S2 - 4 * A2 * k2;
            if (vM(G3))
              b6[0] = -S2 / (2 * A2);
            else if (G3 > 0) {
              var Z3 = hx(G3), B3 = (-S2 + Z3) / (2 * A2), X3 = (-S2 - Z3) / (2 * A2);
              B3 >= 0 && B3 <= 1 && (b6[R6++] = B3), X3 >= 0 && X3 <= 1 && (b6[R6++] = X3);
            }
          }
          return R6;
        }
        function GC(c5, s, r5, g5, b6, S2) {
          var A2 = (s - c5) * b6 + c5, k2 = (r5 - s) * b6 + s, R6 = (g5 - r5) * b6 + r5, B3 = (k2 - A2) * b6 + A2, G3 = (R6 - k2) * b6 + k2, Z3 = (G3 - B3) * b6 + B3;
          S2[0] = c5, S2[1] = A2, S2[2] = B3, S2[3] = Z3, S2[4] = Z3, S2[5] = G3, S2[6] = R6, S2[7] = g5;
        }
        function Sj2(c5, s, r5, g5, b6, S2, A2, k2, R6, B3, G3) {
          var Z3, X3 = 5e-3, tt = 1 / 0, it, pt, mt, Mt;
          WC[0] = R6, WC[1] = B3;
          for (var kt = 0; kt < 1; kt += 0.05)
            px[0] = D0(c5, r5, b6, A2, kt), px[1] = D0(s, g5, S2, k2, kt), mt = j4(WC, px), mt < tt && (Z3 = kt, tt = mt);
          tt = 1 / 0;
          for (var Gt = 0; Gt < 32 && !(X3 < glt); Gt++)
            it = Z3 - X3, pt = Z3 + X3, px[0] = D0(c5, r5, b6, A2, it), px[1] = D0(s, g5, S2, k2, it), mt = j4(px, WC), it >= 0 && mt < tt ? (Z3 = it, tt = mt) : (q4[0] = D0(c5, r5, b6, A2, pt), q4[1] = D0(s, g5, S2, k2, pt), Mt = j4(q4, WC), pt <= 1 && Mt < tt ? (Z3 = pt, tt = Mt) : X3 *= 0.5);
          return G3 && (G3[0] = D0(c5, r5, b6, A2, Z3), G3[1] = D0(s, g5, S2, k2, Z3)), hx(tt);
        }
        function vlt(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          for (var B3 = c5, G3 = s, Z3 = 0, X3 = 1 / R6, tt = 1; tt <= R6; tt++) {
            var it = tt * X3, pt = D0(c5, r5, b6, A2, it), mt = D0(s, g5, S2, k2, it), Mt = pt - B3, kt = mt - G3;
            Z3 += Math.sqrt(Mt * Mt + kt * kt), B3 = pt, G3 = mt;
          }
          return Z3;
        }
        function Hm(c5, s, r5, g5) {
          var b6 = 1 - g5;
          return b6 * (b6 * c5 + 2 * g5 * s) + g5 * g5 * r5;
        }
        function ZY(c5, s, r5, g5) {
          return 2 * ((1 - g5) * (s - c5) + g5 * (r5 - s));
        }
        function bzt(c5, s, r5, g5, b6) {
          var S2 = c5 - 2 * s + r5, A2 = 2 * (s - c5), k2 = c5 - g5, R6 = 0;
          if (vM(S2)) {
            if (i3(A2)) {
              var B3 = -k2 / A2;
              B3 >= 0 && B3 <= 1 && (b6[R6++] = B3);
            }
          } else {
            var G3 = A2 * A2 - 4 * S2 * k2;
            if (vM(G3)) {
              var B3 = -A2 / (2 * S2);
              B3 >= 0 && B3 <= 1 && (b6[R6++] = B3);
            } else if (G3 > 0) {
              var Z3 = hx(G3), B3 = (-A2 + Z3) / (2 * S2), X3 = (-A2 - Z3) / (2 * S2);
              B3 >= 0 && B3 <= 1 && (b6[R6++] = B3), X3 >= 0 && X3 <= 1 && (b6[R6++] = X3);
            }
          }
          return R6;
        }
        function pSt(c5, s, r5) {
          var g5 = c5 + r5 - 2 * s;
          return g5 === 0 ? 0.5 : (c5 - s) / g5;
        }
        function u0(c5, s, r5, g5, b6) {
          var S2 = (s - c5) * g5 + c5, A2 = (r5 - s) * g5 + s, k2 = (A2 - S2) * g5 + S2;
          b6[0] = c5, b6[1] = S2, b6[2] = k2, b6[3] = k2, b6[4] = A2, b6[5] = r5;
        }
        function F1(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          var B3, G3 = 5e-3, Z3 = 1 / 0;
          WC[0] = A2, WC[1] = k2;
          for (var X3 = 0; X3 < 1; X3 += 0.05) {
            px[0] = Hm(c5, r5, b6, X3), px[1] = Hm(s, g5, S2, X3);
            var tt = j4(WC, px);
            tt < Z3 && (B3 = X3, Z3 = tt);
          }
          Z3 = 1 / 0;
          for (var it = 0; it < 32 && !(G3 < glt); it++) {
            var pt = B3 - G3, mt = B3 + G3;
            px[0] = Hm(c5, r5, b6, pt), px[1] = Hm(s, g5, S2, pt);
            var tt = j4(px, WC);
            if (pt >= 0 && tt < Z3)
              B3 = pt, Z3 = tt;
            else {
              q4[0] = Hm(c5, r5, b6, mt), q4[1] = Hm(s, g5, S2, mt);
              var Mt = j4(q4, WC);
              mt <= 1 && Mt < Z3 ? (B3 = mt, Z3 = Mt) : G3 *= 0.5;
            }
          }
          return R6 && (R6[0] = Hm(c5, r5, b6, B3), R6[1] = Hm(s, g5, S2, B3)), hx(Z3);
        }
        function _zt(c5, s, r5, g5, b6, S2, A2) {
          for (var k2 = c5, R6 = s, B3 = 0, G3 = 1 / A2, Z3 = 1; Z3 <= A2; Z3++) {
            var X3 = Z3 * G3, tt = Hm(c5, r5, b6, X3), it = Hm(s, g5, S2, X3), pt = tt - k2, mt = it - R6;
            B3 += Math.sqrt(pt * pt + mt * mt), k2 = tt, R6 = it;
          }
          return B3;
        }
        var xzt = /cubic-bezier\(([0-9,\.e ]+)\)/;
        function $Y(c5) {
          var s = c5 && xzt.exec(c5);
          if (s) {
            var r5 = s[1].split(","), g5 = +Tg2(r5[0]), b6 = +Tg2(r5[1]), S2 = +Tg2(r5[2]), A2 = +Tg2(r5[3]);
            if (isNaN(g5 + b6 + S2 + A2))
              return;
            var k2 = [];
            return function(R6) {
              return R6 <= 0 ? 0 : R6 >= 1 ? 1 : qY(0, g5, S2, 1, R6, k2) && D0(0, b6, A2, 1, k2[0]);
            };
          }
        }
        var wzt = function() {
          function c5(s) {
            this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = s.life || 1e3, this._delay = s.delay || 0, this.loop = s.loop || false, this.onframe = s.onframe || I0, this.ondestroy = s.ondestroy || I0, this.onrestart = s.onrestart || I0, s.easing && this.setEasing(s.easing);
          }
          return c5.prototype.step = function(s, r5) {
            if (this._inited || (this._startTime = s + this._delay, this._inited = true), this._paused) {
              this._pausedTime += r5;
              return;
            }
            var g5 = this._life, b6 = s - this._startTime - this._pausedTime, S2 = b6 / g5;
            S2 < 0 && (S2 = 0), S2 = Math.min(S2, 1);
            var A2 = this.easingFunc, k2 = A2 ? A2(S2) : S2;
            if (this.onframe(k2), S2 === 1)
              if (this.loop) {
                var R6 = b6 % g5;
                this._startTime = s - R6, this._pausedTime = 0, this.onrestart();
              } else
                return true;
            return false;
          }, c5.prototype.pause = function() {
            this._paused = true;
          }, c5.prototype.resume = function() {
            this._paused = false;
          }, c5.prototype.setEasing = function(s) {
            this.easing = s, this.easingFunc = Tl(s) ? s : cSt[s] || $Y(s);
          }, c5;
        }(), ylt = wzt, k8 = function() {
          function c5(s) {
            this.value = s;
          }
          return c5;
        }(), mlt = function() {
          function c5() {
            this._len = 0;
          }
          return c5.prototype.insert = function(s) {
            var r5 = new k8(s);
            return this.insertEntry(r5), r5;
          }, c5.prototype.insertEntry = function(s) {
            this.head ? (this.tail.next = s, s.prev = this.tail, s.next = null, this.tail = s) : this.head = this.tail = s, this._len++;
          }, c5.prototype.remove = function(s) {
            var r5 = s.prev, g5 = s.next;
            r5 ? r5.next = g5 : this.head = g5, g5 ? g5.prev = r5 : this.tail = r5, s.next = s.prev = null, this._len--;
          }, c5.prototype.len = function() {
            return this._len;
          }, c5.prototype.clear = function() {
            this.head = this.tail = null, this._len = 0;
          }, c5;
        }(), P8 = function() {
          function c5(s) {
            this._list = new mlt(), this._maxSize = 10, this._map = {}, this._maxSize = s;
          }
          return c5.prototype.put = function(s, r5) {
            var g5 = this._list, b6 = this._map, S2 = null;
            if (b6[s] == null) {
              var A2 = g5.len(), k2 = this._lastRemovedEntry;
              if (A2 >= this._maxSize && A2 > 0) {
                var R6 = g5.head;
                g5.remove(R6), delete b6[R6.key], S2 = R6.value, this._lastRemovedEntry = R6;
              }
              k2 ? k2.value = r5 : k2 = new k8(r5), k2.key = s, g5.insertEntry(k2), b6[s] = k2;
            }
            return S2;
          }, c5.prototype.get = function(s) {
            var r5 = this._map[s], g5 = this._list;
            if (r5 != null)
              return r5 !== g5.tail && (g5.remove(r5), g5.insertEntry(r5)), r5.value;
          }, c5.prototype.clear = function() {
            this._list.clear(), this._map = {};
          }, c5.prototype.len = function() {
            return this._list.len();
          }, c5;
        }(), gk2 = P8, L8 = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
        function Ow(c5) {
          return c5 = Math.round(c5), c5 < 0 ? 0 : c5 > 255 ? 255 : c5;
        }
        function O8(c5) {
          return c5 = Math.round(c5), c5 < 0 ? 0 : c5 > 360 ? 360 : c5;
        }
        function Mj2(c5) {
          return c5 < 0 ? 0 : c5 > 1 ? 1 : c5;
        }
        function blt(c5) {
          var s = c5;
          return s.length && s.charAt(s.length - 1) === "%" ? Ow(parseFloat(s) / 100 * 255) : Ow(parseInt(s, 10));
        }
        function R8(c5) {
          var s = c5;
          return s.length && s.charAt(s.length - 1) === "%" ? Mj2(parseFloat(s) / 100) : Mj2(parseFloat(s));
        }
        function _lt(c5, s, r5) {
          return r5 < 0 ? r5 += 1 : r5 > 1 && (r5 -= 1), r5 * 6 < 1 ? c5 + (s - c5) * r5 * 6 : r5 * 2 < 1 ? s : r5 * 3 < 2 ? c5 + (s - c5) * (2 / 3 - r5) * 6 : c5;
        }
        function a3(c5, s, r5) {
          return c5 + (s - c5) * r5;
        }
        function dx(c5, s, r5, g5, b6) {
          return c5[0] = s, c5[1] = r5, c5[2] = g5, c5[3] = b6, c5;
        }
        function Z4(c5, s) {
          return c5[0] = s[0], c5[1] = s[1], c5[2] = s[2], c5[3] = s[3], c5;
        }
        var xlt = new gk2(20), kn = null;
        function HC(c5, s) {
          kn && Z4(kn, s), kn = xlt.put(c5, kn || s.slice());
        }
        function Bb2(c5, s) {
          if (c5) {
            s = s || [];
            var r5 = xlt.get(c5);
            if (r5)
              return Z4(s, r5);
            c5 = c5 + "";
            var g5 = c5.replace(/ /g, "").toLowerCase();
            if (g5 in L8)
              return Z4(s, L8[g5]), HC(c5, s), s;
            var b6 = g5.length;
            if (g5.charAt(0) === "#") {
              if (b6 === 4 || b6 === 5) {
                var S2 = parseInt(g5.slice(1, 4), 16);
                if (!(S2 >= 0 && S2 <= 4095)) {
                  dx(s, 0, 0, 0, 1);
                  return;
                }
                return dx(s, (S2 & 3840) >> 4 | (S2 & 3840) >> 8, S2 & 240 | (S2 & 240) >> 4, S2 & 15 | (S2 & 15) << 4, b6 === 5 ? parseInt(g5.slice(4), 16) / 15 : 1), HC(c5, s), s;
              } else if (b6 === 7 || b6 === 9) {
                var S2 = parseInt(g5.slice(1, 7), 16);
                if (!(S2 >= 0 && S2 <= 16777215)) {
                  dx(s, 0, 0, 0, 1);
                  return;
                }
                return dx(s, (S2 & 16711680) >> 16, (S2 & 65280) >> 8, S2 & 255, b6 === 9 ? parseInt(g5.slice(7), 16) / 255 : 1), HC(c5, s), s;
              }
              return;
            }
            var A2 = g5.indexOf("("), k2 = g5.indexOf(")");
            if (A2 !== -1 && k2 + 1 === b6) {
              var R6 = g5.substr(0, A2), B3 = g5.substr(A2 + 1, k2 - (A2 + 1)).split(","), G3 = 1;
              switch (R6) {
                case "rgba":
                  if (B3.length !== 4)
                    return B3.length === 3 ? dx(s, +B3[0], +B3[1], +B3[2], 1) : dx(s, 0, 0, 0, 1);
                  G3 = R8(B3.pop());
                case "rgb":
                  if (B3.length !== 3) {
                    dx(s, 0, 0, 0, 1);
                    return;
                  }
                  return dx(s, blt(B3[0]), blt(B3[1]), blt(B3[2]), G3), HC(c5, s), s;
                case "hsla":
                  if (B3.length !== 4) {
                    dx(s, 0, 0, 0, 1);
                    return;
                  }
                  return B3[3] = R8(B3[3]), Rw(B3, s), HC(c5, s), s;
                case "hsl":
                  if (B3.length !== 3) {
                    dx(s, 0, 0, 0, 1);
                    return;
                  }
                  return Rw(B3, s), HC(c5, s), s;
                default:
                  return;
              }
            }
            dx(s, 0, 0, 0, 1);
          }
        }
        function Rw(c5, s) {
          var r5 = (parseFloat(c5[0]) % 360 + 360) % 360 / 360, g5 = R8(c5[1]), b6 = R8(c5[2]), S2 = b6 <= 0.5 ? b6 * (g5 + 1) : b6 + g5 - b6 * g5, A2 = b6 * 2 - S2;
          return s = s || [], dx(s, Ow(_lt(A2, S2, r5 + 1 / 3) * 255), Ow(_lt(A2, S2, r5) * 255), Ow(_lt(A2, S2, r5 - 1 / 3) * 255), 1), c5.length === 4 && (s[3] = c5[3]), s;
        }
        function up(c5) {
          if (c5) {
            var s = c5[0] / 255, r5 = c5[1] / 255, g5 = c5[2] / 255, b6 = Math.min(s, r5, g5), S2 = Math.max(s, r5, g5), A2 = S2 - b6, k2 = (S2 + b6) / 2, R6, B3;
            if (A2 === 0)
              R6 = 0, B3 = 0;
            else {
              k2 < 0.5 ? B3 = A2 / (S2 + b6) : B3 = A2 / (2 - S2 - b6);
              var G3 = ((S2 - s) / 6 + A2 / 2) / A2, Z3 = ((S2 - r5) / 6 + A2 / 2) / A2, X3 = ((S2 - g5) / 6 + A2 / 2) / A2;
              s === S2 ? R6 = X3 - Z3 : r5 === S2 ? R6 = 1 / 3 + G3 - X3 : g5 === S2 && (R6 = 2 / 3 + Z3 - G3), R6 < 0 && (R6 += 1), R6 > 1 && (R6 -= 1);
            }
            var tt = [R6 * 360, B3, k2];
            return c5[3] != null && tt.push(c5[3]), tt;
          }
        }
        function wlt(c5, s) {
          var r5 = Bb2(c5);
          if (r5) {
            for (var g5 = 0; g5 < 3; g5++)
              s < 0 ? r5[g5] = r5[g5] * (1 - s) | 0 : r5[g5] = (255 - r5[g5]) * s + r5[g5] | 0, r5[g5] > 255 ? r5[g5] = 255 : r5[g5] < 0 && (r5[g5] = 0);
            return vk2(r5, r5.length === 4 ? "rgba" : "rgb");
          }
        }
        function Slt(c5, s, r5) {
          if (!(!(s && s.length) || !(c5 >= 0 && c5 <= 1))) {
            r5 = r5 || [];
            var g5 = c5 * (s.length - 1), b6 = Math.floor(g5), S2 = Math.ceil(g5), A2 = s[b6], k2 = s[S2], R6 = g5 - b6;
            return r5[0] = Ow(a3(A2[0], k2[0], R6)), r5[1] = Ow(a3(A2[1], k2[1], R6)), r5[2] = Ow(a3(A2[2], k2[2], R6)), r5[3] = Mj2(a3(A2[3], k2[3], R6)), r5;
          }
        }
        function Szt(c5, s, r5) {
          if (!(!(s && s.length) || !(c5 >= 0 && c5 <= 1))) {
            var g5 = c5 * (s.length - 1), b6 = Math.floor(g5), S2 = Math.ceil(g5), A2 = Bb2(s[b6]), k2 = Bb2(s[S2]), R6 = g5 - b6, B3 = vk2([Ow(a3(A2[0], k2[0], R6)), Ow(a3(A2[1], k2[1], R6)), Ow(a3(A2[2], k2[2], R6)), Mj2(a3(A2[3], k2[3], R6))], "rgba");
            return r5 ? { color: B3, leftIndex: b6, rightIndex: S2, value: g5 } : B3;
          }
        }
        function UC(c5, s, r5, g5) {
          var b6 = Bb2(c5);
          if (c5)
            return b6 = up(b6), s != null && (b6[0] = O8(s)), r5 != null && (b6[1] = R8(r5)), g5 != null && (b6[2] = R8(g5)), vk2(Rw(b6), "rgba");
        }
        function YY(c5, s) {
          var r5 = Bb2(c5);
          if (r5 && s != null)
            return r5[3] = Mj2(s), vk2(r5, "rgba");
        }
        function vk2(c5, s) {
          if (!(!c5 || !c5.length)) {
            var r5 = c5[0] + "," + c5[1] + "," + c5[2];
            return (s === "rgba" || s === "hsva" || s === "hsla") && (r5 += "," + c5[3]), s + "(" + r5 + ")";
          }
        }
        function KY(c5, s) {
          var r5 = Bb2(c5);
          return r5 ? (0.299 * r5[0] + 0.587 * r5[1] + 0.114 * r5[2]) * r5[3] / 255 + (1 - r5[3]) * s : 0;
        }
        var XY2 = Math.round;
        function N8(c5) {
          var s;
          if (!c5 || c5 === "transparent")
            c5 = "none";
          else if (typeof c5 == "string" && c5.indexOf("rgba") > -1) {
            var r5 = Bb2(c5);
            r5 && (c5 = "rgb(" + r5[0] + "," + r5[1] + "," + r5[2] + ")", s = r5[3]);
          }
          return { color: c5, opacity: s == null ? 1 : s };
        }
        var RI = 1e-4;
        function o3(c5) {
          return c5 < RI && c5 > -RI;
        }
        function QY(c5) {
          return XY2(c5 * 1e3) / 1e3;
        }
        function Mlt(c5) {
          return XY2(c5 * 1e4) / 1e4;
        }
        function Mzt(c5) {
          return "matrix(" + QY(c5[0]) + "," + QY(c5[1]) + "," + QY(c5[2]) + "," + QY(c5[3]) + "," + Mlt(c5[4]) + "," + Mlt(c5[5]) + ")";
        }
        var Czt = { left: "start", right: "end", center: "middle", middle: "middle" };
        function yk(c5, s, r5) {
          return r5 === "top" ? c5 += s / 2 : r5 === "bottom" && (c5 -= s / 2), c5;
        }
        function Tzt(c5) {
          return c5 && (c5.shadowBlur || c5.shadowOffsetX || c5.shadowOffsetY);
        }
        function Azt(c5) {
          var s = c5.style, r5 = c5.getGlobalScale();
          return [s.shadowColor, (s.shadowBlur || 0).toFixed(2), (s.shadowOffsetX || 0).toFixed(2), (s.shadowOffsetY || 0).toFixed(2), r5[0], r5[1]].join(",");
        }
        function dSt(c5) {
          return c5 && !!c5.image;
        }
        function Izt(c5) {
          return c5 && !!c5.svgElement;
        }
        function Dzt(c5) {
          return dSt(c5) || Izt(c5);
        }
        function s3(c5) {
          return c5.type === "linear";
        }
        function gSt(c5) {
          return c5.type === "radial";
        }
        function Ezt(c5) {
          return c5 && (c5.type === "linear" || c5.type === "radial");
        }
        function Nw(c5) {
          return "url(#" + c5 + ")";
        }
        function vSt(c5) {
          var s = c5.getGlobalScale(), r5 = Math.max(s[0], s[1]);
          return Math.max(Math.ceil(Math.log(r5) / Math.log(10)), 1);
        }
        function ySt(c5) {
          var s = c5.x || 0, r5 = c5.y || 0, g5 = (c5.rotation || 0) * pj2, b6 = tc2(c5.scaleX, 1), S2 = tc2(c5.scaleY, 1), A2 = c5.skewX || 0, k2 = c5.skewY || 0, R6 = [];
          return (s || r5) && R6.push("translate(" + s + "px," + r5 + "px)"), g5 && R6.push("rotate(" + g5 + ")"), (b6 !== 1 || S2 !== 1) && R6.push("scale(" + b6 + "," + S2 + ")"), (A2 || k2) && R6.push("skew(" + XY2(A2 * pj2) + "deg, " + XY2(k2 * pj2) + "deg)"), R6.join(" ");
        }
        var kzt = function() {
          return os.hasGlobalWindow && Tl(window.btoa) ? function(c5) {
            return window.btoa(unescape(c5));
          } : typeof Buffer != "undefined" ? function(c5) {
            return Buffer.from(c5).toString("base64");
          } : function(c5) {
            return null;
          };
        }(), Clt = Array.prototype.slice;
        function mk2(c5, s, r5) {
          return (s - c5) * r5 + c5;
        }
        function JY(c5, s, r5, g5) {
          for (var b6 = s.length, S2 = 0; S2 < b6; S2++)
            c5[S2] = mk2(s[S2], r5[S2], g5);
          return c5;
        }
        function mSt(c5, s, r5, g5) {
          for (var b6 = s.length, S2 = b6 && s[0].length, A2 = 0; A2 < b6; A2++) {
            c5[A2] || (c5[A2] = []);
            for (var k2 = 0; k2 < S2; k2++)
              c5[A2][k2] = mk2(s[A2][k2], r5[A2][k2], g5);
          }
          return c5;
        }
        function tK(c5, s, r5, g5) {
          for (var b6 = s.length, S2 = 0; S2 < b6; S2++)
            c5[S2] = s[S2] + r5[S2] * g5;
          return c5;
        }
        function bSt(c5, s, r5, g5) {
          for (var b6 = s.length, S2 = b6 && s[0].length, A2 = 0; A2 < b6; A2++) {
            c5[A2] || (c5[A2] = []);
            for (var k2 = 0; k2 < S2; k2++)
              c5[A2][k2] = s[A2][k2] + r5[A2][k2] * g5;
          }
          return c5;
        }
        function Tlt(c5, s) {
          for (var r5 = c5.length, g5 = s.length, b6 = r5 > g5 ? s : c5, S2 = Math.min(r5, g5), A2 = b6[S2 - 1] || { color: [0, 0, 0, 0], offset: 0 }, k2 = S2; k2 < Math.max(r5, g5); k2++)
            b6.push({ offset: A2.offset, color: A2.color.slice() });
        }
        function Cj2(c5, s, r5) {
          var g5 = c5, b6 = s;
          if (!(!g5.push || !b6.push)) {
            var S2 = g5.length, A2 = b6.length;
            if (S2 !== A2) {
              var k2 = S2 > A2;
              if (k2)
                g5.length = A2;
              else
                for (var R6 = S2; R6 < A2; R6++)
                  g5.push(r5 === 1 ? b6[R6] : Clt.call(b6[R6]));
            }
            for (var B3 = g5[0] && g5[0].length, R6 = 0; R6 < g5.length; R6++)
              if (r5 === 1)
                isNaN(g5[R6]) && (g5[R6] = b6[R6]);
              else
                for (var G3 = 0; G3 < B3; G3++)
                  isNaN(g5[R6][G3]) && (g5[R6][G3] = b6[R6][G3]);
          }
        }
        function l3(c5) {
          if (Fb2(c5)) {
            var s = c5.length;
            if (Fb2(c5[0])) {
              for (var r5 = [], g5 = 0; g5 < s; g5++)
                r5.push(Clt.call(c5[g5]));
              return r5;
            }
            return Clt.call(c5);
          }
          return c5;
        }
        function eK(c5) {
          return c5[0] = Math.floor(c5[0]) || 0, c5[1] = Math.floor(c5[1]) || 0, c5[2] = Math.floor(c5[2]) || 0, c5[3] = c5[3] == null ? 1 : c5[3], "rgba(" + c5.join(",") + ")";
        }
        function _St(c5) {
          return Fb2(c5 && c5[0]) ? 2 : 1;
        }
        var nK = 0, yM = 1, rK = 2, qC = 3, Fw = 4, Alt = 5, Ilt = 6;
        function Dlt(c5) {
          return c5 === Fw || c5 === Alt;
        }
        function u3(c5) {
          return c5 === yM || c5 === rK;
        }
        var mM = [0, 0, 0, 0], xSt = function() {
          function c5(s) {
            this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = s;
          }
          return c5.prototype.isFinished = function() {
            return this._finished;
          }, c5.prototype.setFinished = function() {
            this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
          }, c5.prototype.needsAnimate = function() {
            return this.keyframes.length >= 1;
          }, c5.prototype.getAdditiveTrack = function() {
            return this._additiveTrack;
          }, c5.prototype.addKeyframe = function(s, r5, g5) {
            this._needsSort = true;
            var b6 = this.keyframes, S2 = b6.length, A2 = false, k2 = Ilt, R6 = r5;
            if (Fb2(r5)) {
              var B3 = _St(r5);
              k2 = B3, (B3 === 1 && !Oh2(r5[0]) || B3 === 2 && !Oh2(r5[0][0])) && (A2 = true);
            } else if (Oh2(r5) && !fj2(r5))
              k2 = nK;
            else if (gs(r5))
              if (!isNaN(+r5))
                k2 = nK;
              else {
                var G3 = Bb2(r5);
                G3 && (R6 = G3, k2 = qC);
              }
            else if (Xd2(r5)) {
              var Z3 = sa2({}, R6);
              Z3.colorStops = Ha2(r5.colorStops, function(tt) {
                return { offset: tt.offset, color: Bb2(tt.color) };
              }), s3(r5) ? k2 = Fw : gSt(r5) && (k2 = Alt), R6 = Z3;
            }
            S2 === 0 ? this.valType = k2 : (k2 !== this.valType || k2 === Ilt) && (A2 = true), this.discrete = this.discrete || A2;
            var X3 = { time: s, value: R6, rawValue: r5, percent: 0 };
            return g5 && (X3.easing = g5, X3.easingFunc = Tl(g5) ? g5 : cSt[g5] || $Y(g5)), b6.push(X3), X3;
          }, c5.prototype.prepare = function(s, r5) {
            var g5 = this.keyframes;
            this._needsSort && g5.sort(function(pt, mt) {
              return pt.time - mt.time;
            });
            for (var b6 = this.valType, S2 = g5.length, A2 = g5[S2 - 1], k2 = this.discrete, R6 = u3(b6), B3 = Dlt(b6), G3 = 0; G3 < S2; G3++) {
              var Z3 = g5[G3], X3 = Z3.value, tt = A2.value;
              Z3.percent = Z3.time / s, k2 || (R6 && G3 !== S2 - 1 ? Cj2(X3, tt, b6) : B3 && Tlt(X3.colorStops, tt.colorStops));
            }
            if (!k2 && b6 !== Alt && r5 && this.needsAnimate() && r5.needsAnimate() && b6 === r5.valType && !r5._finished) {
              this._additiveTrack = r5;
              for (var it = g5[0].value, G3 = 0; G3 < S2; G3++)
                b6 === nK ? g5[G3].additiveValue = g5[G3].value - it : b6 === qC ? g5[G3].additiveValue = tK([], g5[G3].value, it, -1) : u3(b6) && (g5[G3].additiveValue = b6 === yM ? tK([], g5[G3].value, it, -1) : bSt([], g5[G3].value, it, -1));
            }
          }, c5.prototype.step = function(s, r5) {
            if (!this._finished) {
              this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
              var g5 = this._additiveTrack != null, b6 = g5 ? "additiveValue" : "value", S2 = this.valType, A2 = this.keyframes, k2 = A2.length, R6 = this.propName, B3 = S2 === qC, G3, Z3 = this._lastFr, X3 = Math.min, tt, it;
              if (k2 === 1)
                tt = it = A2[0];
              else {
                if (r5 < 0)
                  G3 = 0;
                else if (r5 < this._lastFrP) {
                  var pt = X3(Z3 + 1, k2 - 1);
                  for (G3 = pt; G3 >= 0 && !(A2[G3].percent <= r5); G3--)
                    ;
                  G3 = X3(G3, k2 - 2);
                } else {
                  for (G3 = Z3; G3 < k2 && !(A2[G3].percent > r5); G3++)
                    ;
                  G3 = X3(G3 - 1, k2 - 2);
                }
                it = A2[G3 + 1], tt = A2[G3];
              }
              if (tt && it) {
                this._lastFr = G3, this._lastFrP = r5;
                var mt = it.percent - tt.percent, Mt = mt === 0 ? 1 : X3((r5 - tt.percent) / mt, 1);
                it.easingFunc && (Mt = it.easingFunc(Mt));
                var kt = g5 ? this._additiveValue : B3 ? mM : s[R6];
                if ((u3(S2) || B3) && !kt && (kt = this._additiveValue = []), this.discrete)
                  s[R6] = Mt < 1 ? tt.rawValue : it.rawValue;
                else if (u3(S2))
                  S2 === yM ? JY(kt, tt[b6], it[b6], Mt) : mSt(kt, tt[b6], it[b6], Mt);
                else if (Dlt(S2)) {
                  var Gt = tt[b6], Ot = it[b6], ce2 = S2 === Fw;
                  s[R6] = { type: ce2 ? "linear" : "radial", x: mk2(Gt.x, Ot.x, Mt), y: mk2(Gt.y, Ot.y, Mt), colorStops: Ha2(Gt.colorStops, function(de2, we2) {
                    var Se2 = Ot.colorStops[we2];
                    return { offset: mk2(de2.offset, Se2.offset, Mt), color: eK(JY([], de2.color, Se2.color, Mt)) };
                  }), global: Ot.global }, ce2 ? (s[R6].x2 = mk2(Gt.x2, Ot.x2, Mt), s[R6].y2 = mk2(Gt.y2, Ot.y2, Mt)) : s[R6].r = mk2(Gt.r, Ot.r, Mt);
                } else if (B3)
                  JY(kt, tt[b6], it[b6], Mt), g5 || (s[R6] = eK(kt));
                else {
                  var ae2 = mk2(tt[b6], it[b6], Mt);
                  g5 ? this._additiveValue = ae2 : s[R6] = ae2;
                }
                g5 && this._addToTarget(s);
              }
            }
          }, c5.prototype._addToTarget = function(s) {
            var r5 = this.valType, g5 = this.propName, b6 = this._additiveValue;
            r5 === nK ? s[g5] = s[g5] + b6 : r5 === qC ? (Bb2(s[g5], mM), tK(mM, mM, b6, 1), s[g5] = eK(mM)) : r5 === yM ? tK(s[g5], s[g5], b6, 1) : r5 === rK && bSt(s[g5], s[g5], b6, 1);
          }, c5;
        }(), Elt = function() {
          function c5(s, r5, g5, b6) {
            if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = s, this._loop = r5, r5 && b6) {
              r3("Can' use additive animation on looped animation.");
              return;
            }
            this._additiveAnimators = b6, this._allowDiscrete = g5;
          }
          return c5.prototype.getMaxTime = function() {
            return this._maxTime;
          }, c5.prototype.getDelay = function() {
            return this._delay;
          }, c5.prototype.getLoop = function() {
            return this._loop;
          }, c5.prototype.getTarget = function() {
            return this._target;
          }, c5.prototype.changeTarget = function(s) {
            this._target = s;
          }, c5.prototype.when = function(s, r5, g5) {
            return this.whenWithKeys(s, r5, nf2(r5), g5);
          }, c5.prototype.whenWithKeys = function(s, r5, g5, b6) {
            for (var S2 = this._tracks, A2 = 0; A2 < g5.length; A2++) {
              var k2 = g5[A2], R6 = S2[k2];
              if (!R6) {
                R6 = S2[k2] = new xSt(k2);
                var B3 = void 0, G3 = this._getAdditiveTrack(k2);
                if (G3) {
                  var Z3 = G3.keyframes, X3 = Z3[Z3.length - 1];
                  B3 = X3 && X3.value, G3.valType === qC && B3 && (B3 = eK(B3));
                } else
                  B3 = this._target[k2];
                if (B3 == null)
                  continue;
                s > 0 && R6.addKeyframe(0, l3(B3), b6), this._trackKeys.push(k2);
              }
              R6.addKeyframe(s, l3(r5[k2]), b6);
            }
            return this._maxTime = Math.max(this._maxTime, s), this;
          }, c5.prototype.pause = function() {
            this._clip.pause(), this._paused = true;
          }, c5.prototype.resume = function() {
            this._clip.resume(), this._paused = false;
          }, c5.prototype.isPaused = function() {
            return !!this._paused;
          }, c5.prototype.duration = function(s) {
            return this._maxTime = s, this._force = true, this;
          }, c5.prototype._doneCallback = function() {
            this._setTracksFinished(), this._clip = null;
            var s = this._doneCbs;
            if (s)
              for (var r5 = s.length, g5 = 0; g5 < r5; g5++)
                s[g5].call(this);
          }, c5.prototype._abortedCallback = function() {
            this._setTracksFinished();
            var s = this.animation, r5 = this._abortedCbs;
            if (s && s.removeClip(this._clip), this._clip = null, r5)
              for (var g5 = 0; g5 < r5.length; g5++)
                r5[g5].call(this);
          }, c5.prototype._setTracksFinished = function() {
            for (var s = this._tracks, r5 = this._trackKeys, g5 = 0; g5 < r5.length; g5++)
              s[r5[g5]].setFinished();
          }, c5.prototype._getAdditiveTrack = function(s) {
            var r5, g5 = this._additiveAnimators;
            if (g5)
              for (var b6 = 0; b6 < g5.length; b6++) {
                var S2 = g5[b6].getTrack(s);
                S2 && (r5 = S2);
              }
            return r5;
          }, c5.prototype.start = function(s) {
            if (!(this._started > 0)) {
              this._started = 1;
              for (var r5 = this, g5 = [], b6 = this._maxTime || 0, S2 = 0; S2 < this._trackKeys.length; S2++) {
                var A2 = this._trackKeys[S2], k2 = this._tracks[A2], R6 = this._getAdditiveTrack(A2), B3 = k2.keyframes, G3 = B3.length;
                if (k2.prepare(b6, R6), k2.needsAnimate())
                  if (!this._allowDiscrete && k2.discrete) {
                    var Z3 = B3[G3 - 1];
                    Z3 && (r5._target[k2.propName] = Z3.rawValue), k2.setFinished();
                  } else
                    g5.push(k2);
              }
              if (g5.length || this._force) {
                var X3 = new ylt({ life: b6, loop: this._loop, delay: this._delay || 0, onframe: function(tt) {
                  r5._started = 2;
                  var it = r5._additiveAnimators;
                  if (it) {
                    for (var pt = false, mt = 0; mt < it.length; mt++)
                      if (it[mt]._clip) {
                        pt = true;
                        break;
                      }
                    pt || (r5._additiveAnimators = null);
                  }
                  for (var mt = 0; mt < g5.length; mt++)
                    g5[mt].step(r5._target, tt);
                  var Mt = r5._onframeCbs;
                  if (Mt)
                    for (var mt = 0; mt < Mt.length; mt++)
                      Mt[mt](r5._target, tt);
                }, ondestroy: function() {
                  r5._doneCallback();
                } });
                this._clip = X3, this.animation && this.animation.addClip(X3), s && X3.setEasing(s);
              } else
                this._doneCallback();
              return this;
            }
          }, c5.prototype.stop = function(s) {
            if (this._clip) {
              var r5 = this._clip;
              s && r5.onframe(1), this._abortedCallback();
            }
          }, c5.prototype.delay = function(s) {
            return this._delay = s, this;
          }, c5.prototype.during = function(s) {
            return s && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(s)), this;
          }, c5.prototype.done = function(s) {
            return s && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(s)), this;
          }, c5.prototype.aborted = function(s) {
            return s && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(s)), this;
          }, c5.prototype.getClip = function() {
            return this._clip;
          }, c5.prototype.getTrack = function(s) {
            return this._tracks[s];
          }, c5.prototype.getTracks = function() {
            var s = this;
            return Ha2(this._trackKeys, function(r5) {
              return s._tracks[r5];
            });
          }, c5.prototype.stopTracks = function(s, r5) {
            if (!s.length || !this._clip)
              return true;
            for (var g5 = this._tracks, b6 = this._trackKeys, S2 = 0; S2 < s.length; S2++) {
              var A2 = g5[s[S2]];
              A2 && !A2.isFinished() && (r5 ? A2.step(this._target, 1) : this._started === 1 && A2.step(this._target, 0), A2.setFinished());
            }
            for (var k2 = true, S2 = 0; S2 < b6.length; S2++)
              if (!g5[b6[S2]].isFinished()) {
                k2 = false;
                break;
              }
            return k2 && this._abortedCallback(), k2;
          }, c5.prototype.saveTo = function(s, r5, g5) {
            if (s) {
              r5 = r5 || this._trackKeys;
              for (var b6 = 0; b6 < r5.length; b6++) {
                var S2 = r5[b6], A2 = this._tracks[S2];
                if (!(!A2 || A2.isFinished())) {
                  var k2 = A2.keyframes, R6 = k2[g5 ? 0 : k2.length - 1];
                  R6 && (s[S2] = l3(R6.rawValue));
                }
              }
            }
          }, c5.prototype.__changeFinalValue = function(s, r5) {
            r5 = r5 || nf2(s);
            for (var g5 = 0; g5 < r5.length; g5++) {
              var b6 = r5[g5], S2 = this._tracks[b6];
              if (S2) {
                var A2 = S2.keyframes;
                if (A2.length > 1) {
                  var k2 = A2.pop();
                  S2.addKeyframe(k2.time, s[b6]), S2.prepare(this._maxTime, S2.getAdditiveTrack());
                }
              }
            }
          }, c5;
        }();
        function bk2() {
          return new Date().getTime();
        }
        var Pzt = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this) || this;
            return g5._running = false, g5._time = 0, g5._pausedTime = 0, g5._pauseStart = 0, g5._paused = false, r5 = r5 || {}, g5.stage = r5.stage || {}, g5;
          }
          return s.prototype.addClip = function(r5) {
            r5.animation && this.removeClip(r5), this._head ? (this._tail.next = r5, r5.prev = this._tail, r5.next = null, this._tail = r5) : this._head = this._tail = r5, r5.animation = this;
          }, s.prototype.addAnimator = function(r5) {
            r5.animation = this;
            var g5 = r5.getClip();
            g5 && this.addClip(g5);
          }, s.prototype.removeClip = function(r5) {
            if (r5.animation) {
              var g5 = r5.prev, b6 = r5.next;
              g5 ? g5.next = b6 : this._head = b6, b6 ? b6.prev = g5 : this._tail = g5, r5.next = r5.prev = r5.animation = null;
            }
          }, s.prototype.removeAnimator = function(r5) {
            var g5 = r5.getClip();
            g5 && this.removeClip(g5), r5.animation = null;
          }, s.prototype.update = function(r5) {
            for (var g5 = bk2() - this._pausedTime, b6 = g5 - this._time, S2 = this._head; S2; ) {
              var A2 = S2.next, k2 = S2.step(g5, b6);
              k2 && (S2.ondestroy(), this.removeClip(S2)), S2 = A2;
            }
            this._time = g5, r5 || (this.trigger("frame", b6), this.stage.update && this.stage.update());
          }, s.prototype._startLoop = function() {
            var r5 = this;
            this._running = true;
            function g5() {
              r5._running && (dlt(g5), !r5._paused && r5.update());
            }
            dlt(g5);
          }, s.prototype.start = function() {
            this._running || (this._time = bk2(), this._pausedTime = 0, this._startLoop());
          }, s.prototype.stop = function() {
            this._running = false;
          }, s.prototype.pause = function() {
            this._paused || (this._pauseStart = bk2(), this._paused = true);
          }, s.prototype.resume = function() {
            this._paused && (this._pausedTime += bk2() - this._pauseStart, this._paused = false);
          }, s.prototype.clear = function() {
            for (var r5 = this._head; r5; ) {
              var g5 = r5.next;
              r5.prev = r5.next = r5.animation = null, r5 = g5;
            }
            this._head = this._tail = null;
          }, s.prototype.isFinished = function() {
            return this._head == null;
          }, s.prototype.animate = function(r5, g5) {
            g5 = g5 || {}, this.start();
            var b6 = new Elt(r5, g5.loop);
            return this.addAnimator(b6), b6;
          }, s;
        }(Lw), wSt = Pzt, V1 = 300, Tj2 = os.domSupported, iK = function() {
          var c5 = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], s = ["touchstart", "touchend", "touchmove"], r5 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, g5 = Ha2(c5, function(b6) {
            var S2 = b6.replace("mouse", "pointer");
            return r5.hasOwnProperty(S2) ? S2 : b6;
          });
          return { mouse: c5, touch: s, pointer: g5 };
        }(), ZC = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, aK = false;
        function F8(c5) {
          var s = c5.pointerType;
          return s === "pen" || s === "touch";
        }
        function $4(c5) {
          c5.touching = true, c5.touchTimer != null && (clearTimeout(c5.touchTimer), c5.touchTimer = null), c5.touchTimer = setTimeout(function() {
            c5.touching = false, c5.touchTimer = null;
          }, 700);
        }
        function oK(c5) {
          c5 && (c5.zrByTouch = true);
        }
        function gx(c5, s) {
          return N1(c5.dom, new Lzt(c5, s), true);
        }
        function sK(c5, s) {
          for (var r5 = s, g5 = false; r5 && r5.nodeType !== 9 && !(g5 = r5.domBelongToZr || r5 !== s && r5 === c5.painterRoot); )
            r5 = r5.parentNode;
          return g5;
        }
        var Lzt = function() {
          function c5(s, r5) {
            this.stopPropagation = I0, this.stopImmediatePropagation = I0, this.preventDefault = I0, this.type = r5.type, this.target = this.currentTarget = s.dom, this.pointerType = r5.pointerType, this.clientX = r5.clientX, this.clientY = r5.clientY;
          }
          return c5;
        }(), $C = { mousedown: function(c5) {
          c5 = N1(this.dom, c5), this.__mayPointerCapture = [c5.zrX, c5.zrY], this.trigger("mousedown", c5);
        }, mousemove: function(c5) {
          c5 = N1(this.dom, c5);
          var s = this.__mayPointerCapture;
          s && (c5.zrX !== s[0] || c5.zrY !== s[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", c5);
        }, mouseup: function(c5) {
          c5 = N1(this.dom, c5), this.__togglePointerCapture(false), this.trigger("mouseup", c5);
        }, mouseout: function(c5) {
          c5 = N1(this.dom, c5);
          var s = c5.toElement || c5.relatedTarget;
          sK(this, s) || (this.__pointerCapturing && (c5.zrEventControl = "no_globalout"), this.trigger("mouseout", c5));
        }, wheel: function(c5) {
          aK = true, c5 = N1(this.dom, c5), this.trigger("mousewheel", c5);
        }, mousewheel: function(c5) {
          aK || (c5 = N1(this.dom, c5), this.trigger("mousewheel", c5));
        }, touchstart: function(c5) {
          c5 = N1(this.dom, c5), oK(c5), this.__lastTouchMoment = new Date(), this.handler.processGesture(c5, "start"), $C.mousemove.call(this, c5), $C.mousedown.call(this, c5);
        }, touchmove: function(c5) {
          c5 = N1(this.dom, c5), oK(c5), this.handler.processGesture(c5, "change"), $C.mousemove.call(this, c5);
        }, touchend: function(c5) {
          c5 = N1(this.dom, c5), oK(c5), this.handler.processGesture(c5, "end"), $C.mouseup.call(this, c5), +new Date() - +this.__lastTouchMoment < V1 && $C.click.call(this, c5);
        }, pointerdown: function(c5) {
          $C.mousedown.call(this, c5);
        }, pointermove: function(c5) {
          F8(c5) || $C.mousemove.call(this, c5);
        }, pointerup: function(c5) {
          $C.mouseup.call(this, c5);
        }, pointerout: function(c5) {
          F8(c5) || $C.mouseout.call(this, c5);
        } };
        Ye2(["click", "dblclick", "contextmenu"], function(c5) {
          $C[c5] = function(s) {
            s = N1(this.dom, s), this.trigger(c5, s);
          };
        });
        var klt = { pointermove: function(c5) {
          F8(c5) || klt.mousemove.call(this, c5);
        }, pointerup: function(c5) {
          klt.mouseup.call(this, c5);
        }, mousemove: function(c5) {
          this.trigger("mousemove", c5);
        }, mouseup: function(c5) {
          var s = this.__pointerCapturing;
          this.__togglePointerCapture(false), this.trigger("mouseup", c5), s && (c5.zrEventControl = "only_globalout", this.trigger("mouseout", c5));
        } };
        function Plt(c5, s) {
          var r5 = s.domHandlers;
          os.pointerEventsSupported ? Ye2(iK.pointer, function(g5) {
            c3(s, g5, function(b6) {
              r5[g5].call(c5, b6);
            });
          }) : (os.touchEventsSupported && Ye2(iK.touch, function(g5) {
            c3(s, g5, function(b6) {
              r5[g5].call(c5, b6), $4(s);
            });
          }), Ye2(iK.mouse, function(g5) {
            c3(s, g5, function(b6) {
              b6 = clt(b6), s.touching || r5[g5].call(c5, b6);
            });
          }));
        }
        function Ozt(c5, s) {
          os.pointerEventsSupported ? Ye2(ZC.pointer, r5) : os.touchEventsSupported || Ye2(ZC.mouse, r5);
          function r5(g5) {
            function b6(S2) {
              S2 = clt(S2), sK(c5, S2.target) || (S2 = gx(c5, S2), s.domHandlers[g5].call(c5, S2));
            }
            c3(s, g5, b6, { capture: true });
          }
        }
        function c3(c5, s, r5, g5) {
          c5.mounted[s] = r5, c5.listenerOpts[s] = g5, flt(c5.domTarget, s, r5, g5);
        }
        function lK(c5) {
          var s = c5.mounted;
          for (var r5 in s)
            s.hasOwnProperty(r5) && hlt(c5.domTarget, r5, s[r5], c5.listenerOpts[r5]);
          c5.mounted = {};
        }
        var SSt = function() {
          function c5(s, r5) {
            this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = s, this.domHandlers = r5;
          }
          return c5;
        }(), Rzt = function(c5) {
          wn(s, c5);
          function s(r5, g5) {
            var b6 = c5.call(this) || this;
            return b6.__pointerCapturing = false, b6.dom = r5, b6.painterRoot = g5, b6._localHandlerScope = new SSt(r5, $C), Tj2 && (b6._globalHandlerScope = new SSt(document, klt)), Plt(b6, b6._localHandlerScope), b6;
          }
          return s.prototype.dispose = function() {
            lK(this._localHandlerScope), Tj2 && lK(this._globalHandlerScope);
          }, s.prototype.setCursor = function(r5) {
            this.dom.style && (this.dom.style.cursor = r5 || "default");
          }, s.prototype.__togglePointerCapture = function(r5) {
            if (this.__mayPointerCapture = null, Tj2 && +this.__pointerCapturing ^ +r5) {
              this.__pointerCapturing = r5;
              var g5 = this._globalHandlerScope;
              r5 ? Ozt(this, g5) : lK(g5);
            }
          }, s;
        }(Lw), Aj2 = Rzt, MSt = 1;
        os.hasGlobalWindow && (MSt = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
        var uK = MSt, Ij2 = 0.4, cK = "#333", Llt = "#ccc", Nzt = "#eee";
        function bM() {
          return [1, 0, 0, 1, 0, 0];
        }
        function Dj2(c5) {
          return c5[0] = 1, c5[1] = 0, c5[2] = 0, c5[3] = 1, c5[4] = 0, c5[5] = 0, c5;
        }
        function Ej2(c5, s) {
          return c5[0] = s[0], c5[1] = s[1], c5[2] = s[2], c5[3] = s[3], c5[4] = s[4], c5[5] = s[5], c5;
        }
        function _k(c5, s, r5) {
          var g5 = s[0] * r5[0] + s[2] * r5[1], b6 = s[1] * r5[0] + s[3] * r5[1], S2 = s[0] * r5[2] + s[2] * r5[3], A2 = s[1] * r5[2] + s[3] * r5[3], k2 = s[0] * r5[4] + s[2] * r5[5] + s[4], R6 = s[1] * r5[4] + s[3] * r5[5] + s[5];
          return c5[0] = g5, c5[1] = b6, c5[2] = S2, c5[3] = A2, c5[4] = k2, c5[5] = R6, c5;
        }
        function _M(c5, s, r5) {
          return c5[0] = s[0], c5[1] = s[1], c5[2] = s[2], c5[3] = s[3], c5[4] = s[4] + r5[0], c5[5] = s[5] + r5[1], c5;
        }
        function f3(c5, s, r5) {
          var g5 = s[0], b6 = s[2], S2 = s[4], A2 = s[1], k2 = s[3], R6 = s[5], B3 = Math.sin(r5), G3 = Math.cos(r5);
          return c5[0] = g5 * G3 + A2 * B3, c5[1] = -g5 * B3 + A2 * G3, c5[2] = b6 * G3 + k2 * B3, c5[3] = -b6 * B3 + G3 * k2, c5[4] = G3 * S2 + B3 * R6, c5[5] = G3 * R6 - B3 * S2, c5;
        }
        function fK(c5, s, r5) {
          var g5 = r5[0], b6 = r5[1];
          return c5[0] = s[0] * g5, c5[1] = s[1] * b6, c5[2] = s[2] * g5, c5[3] = s[3] * b6, c5[4] = s[4] * g5, c5[5] = s[5] * b6, c5;
        }
        function Y4(c5, s) {
          var r5 = s[0], g5 = s[2], b6 = s[4], S2 = s[1], A2 = s[3], k2 = s[5], R6 = r5 * A2 - S2 * g5;
          return R6 ? (R6 = 1 / R6, c5[0] = A2 * R6, c5[1] = -S2 * R6, c5[2] = -g5 * R6, c5[3] = r5 * R6, c5[4] = (g5 * k2 - A2 * b6) * R6, c5[5] = (S2 * b6 - r5 * k2) * R6, c5) : null;
        }
        function hK(c5) {
          var s = bM();
          return Ej2(s, c5), s;
        }
        var CSt = Dj2, Olt = 5e-5;
        function h3(c5) {
          return c5 > Olt || c5 < -Olt;
        }
        var K4 = [], X4 = [], Rlt = bM(), kj2 = Math.abs, TSt = function() {
          function c5() {
          }
          return c5.prototype.getLocalTransform = function(s) {
            return c5.getLocalTransform(this, s);
          }, c5.prototype.setPosition = function(s) {
            this.x = s[0], this.y = s[1];
          }, c5.prototype.setScale = function(s) {
            this.scaleX = s[0], this.scaleY = s[1];
          }, c5.prototype.setSkew = function(s) {
            this.skewX = s[0], this.skewY = s[1];
          }, c5.prototype.setOrigin = function(s) {
            this.originX = s[0], this.originY = s[1];
          }, c5.prototype.needLocalTransform = function() {
            return h3(this.rotation) || h3(this.x) || h3(this.y) || h3(this.scaleX - 1) || h3(this.scaleY - 1) || h3(this.skewX) || h3(this.skewY);
          }, c5.prototype.updateTransform = function() {
            var s = this.parent && this.parent.transform, r5 = this.needLocalTransform(), g5 = this.transform;
            if (!(r5 || s)) {
              g5 && CSt(g5);
              return;
            }
            g5 = g5 || bM(), r5 ? this.getLocalTransform(g5) : CSt(g5), s && (r5 ? _k(g5, s, g5) : Ej2(g5, s)), this.transform = g5, this._resolveGlobalScaleRatio(g5);
          }, c5.prototype._resolveGlobalScaleRatio = function(s) {
            var r5 = this.globalScaleRatio;
            if (r5 != null && r5 !== 1) {
              this.getGlobalScale(K4);
              var g5 = K4[0] < 0 ? -1 : 1, b6 = K4[1] < 0 ? -1 : 1, S2 = ((K4[0] - g5) * r5 + g5) / K4[0] || 0, A2 = ((K4[1] - b6) * r5 + b6) / K4[1] || 0;
              s[0] *= S2, s[1] *= S2, s[2] *= A2, s[3] *= A2;
            }
            this.invTransform = this.invTransform || bM(), Y4(this.invTransform, s);
          }, c5.prototype.getComputedTransform = function() {
            for (var s = this, r5 = []; s; )
              r5.push(s), s = s.parent;
            for (; s = r5.pop(); )
              s.updateTransform();
            return this.transform;
          }, c5.prototype.setLocalTransform = function(s) {
            if (s) {
              var r5 = s[0] * s[0] + s[1] * s[1], g5 = s[2] * s[2] + s[3] * s[3], b6 = Math.atan2(s[1], s[0]), S2 = Math.PI / 2 + b6 - Math.atan2(s[3], s[2]);
              g5 = Math.sqrt(g5) * Math.cos(S2), r5 = Math.sqrt(r5), this.skewX = S2, this.skewY = 0, this.rotation = -b6, this.x = +s[4], this.y = +s[5], this.scaleX = r5, this.scaleY = g5, this.originX = 0, this.originY = 0;
            }
          }, c5.prototype.decomposeTransform = function() {
            if (this.transform) {
              var s = this.parent, r5 = this.transform;
              s && s.transform && (_k(X4, s.invTransform, r5), r5 = X4);
              var g5 = this.originX, b6 = this.originY;
              (g5 || b6) && (Rlt[4] = g5, Rlt[5] = b6, _k(X4, r5, Rlt), X4[4] -= g5, X4[5] -= b6, r5 = X4), this.setLocalTransform(r5);
            }
          }, c5.prototype.getGlobalScale = function(s) {
            var r5 = this.transform;
            return s = s || [], r5 ? (s[0] = Math.sqrt(r5[0] * r5[0] + r5[1] * r5[1]), s[1] = Math.sqrt(r5[2] * r5[2] + r5[3] * r5[3]), r5[0] < 0 && (s[0] = -s[0]), r5[3] < 0 && (s[1] = -s[1]), s) : (s[0] = 1, s[1] = 1, s);
          }, c5.prototype.transformCoordToLocal = function(s, r5) {
            var g5 = [s, r5], b6 = this.invTransform;
            return b6 && Gm(g5, g5, b6), g5;
          }, c5.prototype.transformCoordToGlobal = function(s, r5) {
            var g5 = [s, r5], b6 = this.transform;
            return b6 && Gm(g5, g5, b6), g5;
          }, c5.prototype.getLineScale = function() {
            var s = this.transform;
            return s && kj2(s[0] - 1) > 1e-10 && kj2(s[3] - 1) > 1e-10 ? Math.sqrt(kj2(s[0] * s[3] - s[2] * s[1])) : 1;
          }, c5.prototype.copyTransform = function(s) {
            ASt(this, s);
          }, c5.getLocalTransform = function(s, r5) {
            r5 = r5 || [];
            var g5 = s.originX || 0, b6 = s.originY || 0, S2 = s.scaleX, A2 = s.scaleY, k2 = s.anchorX, R6 = s.anchorY, B3 = s.rotation || 0, G3 = s.x, Z3 = s.y, X3 = s.skewX ? Math.tan(s.skewX) : 0, tt = s.skewY ? Math.tan(-s.skewY) : 0;
            if (g5 || b6 || k2 || R6) {
              var it = g5 + k2, pt = b6 + R6;
              r5[4] = -it * S2 - X3 * pt * A2, r5[5] = -pt * A2 - tt * it * S2;
            } else
              r5[4] = r5[5] = 0;
            return r5[0] = S2, r5[3] = A2, r5[1] = tt * S2, r5[2] = X3 * A2, B3 && f3(r5, r5, B3), r5[4] += g5 + G3, r5[5] += b6 + Z3, r5;
          }, c5.initDefaultProps = function() {
            var s = c5.prototype;
            s.scaleX = s.scaleY = s.globalScaleRatio = 1, s.x = s.y = s.originX = s.originY = s.skewX = s.skewY = s.rotation = s.anchorX = s.anchorY = 0;
          }(), c5;
        }(), xM = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
        function ASt(c5, s) {
          for (var r5 = 0; r5 < xM.length; r5++) {
            var g5 = xM[r5];
            c5[g5] = s[g5];
          }
        }
        var YC = TSt, ch2 = function() {
          function c5(s, r5) {
            this.x = s || 0, this.y = r5 || 0;
          }
          return c5.prototype.copy = function(s) {
            return this.x = s.x, this.y = s.y, this;
          }, c5.prototype.clone = function() {
            return new c5(this.x, this.y);
          }, c5.prototype.set = function(s, r5) {
            return this.x = s, this.y = r5, this;
          }, c5.prototype.equal = function(s) {
            return s.x === this.x && s.y === this.y;
          }, c5.prototype.add = function(s) {
            return this.x += s.x, this.y += s.y, this;
          }, c5.prototype.scale = function(s) {
            this.x *= s, this.y *= s;
          }, c5.prototype.scaleAndAdd = function(s, r5) {
            this.x += s.x * r5, this.y += s.y * r5;
          }, c5.prototype.sub = function(s) {
            return this.x -= s.x, this.y -= s.y, this;
          }, c5.prototype.dot = function(s) {
            return this.x * s.x + this.y * s.y;
          }, c5.prototype.len = function() {
            return Math.sqrt(this.x * this.x + this.y * this.y);
          }, c5.prototype.lenSquare = function() {
            return this.x * this.x + this.y * this.y;
          }, c5.prototype.normalize = function() {
            var s = this.len();
            return this.x /= s, this.y /= s, this;
          }, c5.prototype.distance = function(s) {
            var r5 = this.x - s.x, g5 = this.y - s.y;
            return Math.sqrt(r5 * r5 + g5 * g5);
          }, c5.prototype.distanceSquare = function(s) {
            var r5 = this.x - s.x, g5 = this.y - s.y;
            return r5 * r5 + g5 * g5;
          }, c5.prototype.negate = function() {
            return this.x = -this.x, this.y = -this.y, this;
          }, c5.prototype.transform = function(s) {
            if (s) {
              var r5 = this.x, g5 = this.y;
              return this.x = s[0] * r5 + s[2] * g5 + s[4], this.y = s[1] * r5 + s[3] * g5 + s[5], this;
            }
          }, c5.prototype.toArray = function(s) {
            return s[0] = this.x, s[1] = this.y, s;
          }, c5.prototype.fromArray = function(s) {
            this.x = s[0], this.y = s[1];
          }, c5.set = function(s, r5, g5) {
            s.x = r5, s.y = g5;
          }, c5.copy = function(s, r5) {
            s.x = r5.x, s.y = r5.y;
          }, c5.len = function(s) {
            return Math.sqrt(s.x * s.x + s.y * s.y);
          }, c5.lenSquare = function(s) {
            return s.x * s.x + s.y * s.y;
          }, c5.dot = function(s, r5) {
            return s.x * r5.x + s.y * r5.y;
          }, c5.add = function(s, r5, g5) {
            s.x = r5.x + g5.x, s.y = r5.y + g5.y;
          }, c5.sub = function(s, r5, g5) {
            s.x = r5.x - g5.x, s.y = r5.y - g5.y;
          }, c5.scale = function(s, r5, g5) {
            s.x = r5.x * g5, s.y = r5.y * g5;
          }, c5.scaleAndAdd = function(s, r5, g5, b6) {
            s.x = r5.x + g5.x * b6, s.y = r5.y + g5.y * b6;
          }, c5.lerp = function(s, r5, g5, b6) {
            var S2 = 1 - b6;
            s.x = S2 * r5.x + b6 * g5.x, s.y = S2 * r5.y + b6 * g5.y;
          }, c5;
        }(), Bu = ch2, pK = Math.min, p3 = Math.max, d3 = new Bu(), Q4 = new Bu(), J4 = new Bu(), Um = new Bu(), Pj2 = new Bu(), g3 = new Bu(), Nlt = function() {
          function c5(s, r5, g5, b6) {
            g5 < 0 && (s = s + g5, g5 = -g5), b6 < 0 && (r5 = r5 + b6, b6 = -b6), this.x = s, this.y = r5, this.width = g5, this.height = b6;
          }
          return c5.prototype.union = function(s) {
            var r5 = pK(s.x, this.x), g5 = pK(s.y, this.y);
            isFinite(this.x) && isFinite(this.width) ? this.width = p3(s.x + s.width, this.x + this.width) - r5 : this.width = s.width, isFinite(this.y) && isFinite(this.height) ? this.height = p3(s.y + s.height, this.y + this.height) - g5 : this.height = s.height, this.x = r5, this.y = g5;
          }, c5.prototype.applyTransform = function(s) {
            c5.applyTransform(this, this, s);
          }, c5.prototype.calculateTransform = function(s) {
            var r5 = this, g5 = s.width / r5.width, b6 = s.height / r5.height, S2 = bM();
            return _M(S2, S2, [-r5.x, -r5.y]), fK(S2, S2, [g5, b6]), _M(S2, S2, [s.x, s.y]), S2;
          }, c5.prototype.intersect = function(s, r5) {
            if (!s)
              return false;
            s instanceof c5 || (s = c5.create(s));
            var g5 = this, b6 = g5.x, S2 = g5.x + g5.width, A2 = g5.y, k2 = g5.y + g5.height, R6 = s.x, B3 = s.x + s.width, G3 = s.y, Z3 = s.y + s.height, X3 = !(S2 < R6 || B3 < b6 || k2 < G3 || Z3 < A2);
            if (r5) {
              var tt = 1 / 0, it = 0, pt = Math.abs(S2 - R6), mt = Math.abs(B3 - b6), Mt = Math.abs(k2 - G3), kt = Math.abs(Z3 - A2), Gt = Math.min(pt, mt), Ot = Math.min(Mt, kt);
              S2 < R6 || B3 < b6 ? Gt > it && (it = Gt, pt < mt ? Bu.set(g3, -pt, 0) : Bu.set(g3, mt, 0)) : Gt < tt && (tt = Gt, pt < mt ? Bu.set(Pj2, pt, 0) : Bu.set(Pj2, -mt, 0)), k2 < G3 || Z3 < A2 ? Ot > it && (it = Ot, Mt < kt ? Bu.set(g3, 0, -Mt) : Bu.set(g3, 0, kt)) : Gt < tt && (tt = Gt, Mt < kt ? Bu.set(Pj2, 0, Mt) : Bu.set(Pj2, 0, -kt));
            }
            return r5 && Bu.copy(r5, X3 ? Pj2 : g3), X3;
          }, c5.prototype.contain = function(s, r5) {
            var g5 = this;
            return s >= g5.x && s <= g5.x + g5.width && r5 >= g5.y && r5 <= g5.y + g5.height;
          }, c5.prototype.clone = function() {
            return new c5(this.x, this.y, this.width, this.height);
          }, c5.prototype.copy = function(s) {
            c5.copy(this, s);
          }, c5.prototype.plain = function() {
            return { x: this.x, y: this.y, width: this.width, height: this.height };
          }, c5.prototype.isFinite = function() {
            return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
          }, c5.prototype.isZero = function() {
            return this.width === 0 || this.height === 0;
          }, c5.create = function(s) {
            return new c5(s.x, s.y, s.width, s.height);
          }, c5.copy = function(s, r5) {
            s.x = r5.x, s.y = r5.y, s.width = r5.width, s.height = r5.height;
          }, c5.applyTransform = function(s, r5, g5) {
            if (!g5) {
              s !== r5 && c5.copy(s, r5);
              return;
            }
            if (g5[1] < 1e-5 && g5[1] > -1e-5 && g5[2] < 1e-5 && g5[2] > -1e-5) {
              var b6 = g5[0], S2 = g5[3], A2 = g5[4], k2 = g5[5];
              s.x = r5.x * b6 + A2, s.y = r5.y * S2 + k2, s.width = r5.width * b6, s.height = r5.height * S2, s.width < 0 && (s.x += s.width, s.width = -s.width), s.height < 0 && (s.y += s.height, s.height = -s.height);
              return;
            }
            d3.x = J4.x = r5.x, d3.y = Um.y = r5.y, Q4.x = Um.x = r5.x + r5.width, Q4.y = J4.y = r5.y + r5.height, d3.transform(g5), Um.transform(g5), Q4.transform(g5), J4.transform(g5), s.x = pK(d3.x, Q4.x, J4.x, Um.x), s.y = pK(d3.y, Q4.y, J4.y, Um.y);
            var R6 = p3(d3.x, Q4.x, J4.x, Um.x), B3 = p3(d3.y, Q4.y, J4.y, Um.y);
            s.width = R6 - s.x, s.height = B3 - s.y;
          }, c5;
        }(), lc2 = Nlt, Flt = {};
        function _v(c5, s) {
          s = s || Yh2;
          var r5 = Flt[s];
          r5 || (r5 = Flt[s] = new gk2(500));
          var g5 = r5.get(c5);
          return g5 == null && (g5 = T0.measureText(c5, s).width, r5.put(c5, g5)), g5;
        }
        function xk2(c5, s, r5, g5) {
          var b6 = _v(c5, s), S2 = Lj2(s), A2 = V8(0, b6, r5), k2 = wk2(0, S2, g5), R6 = new lc2(A2, k2, b6, S2);
          return R6;
        }
        function tR(c5, s, r5, g5) {
          var b6 = ((c5 || "") + "").split(`
`), S2 = b6.length;
          if (S2 === 1)
            return xk2(b6[0], s, r5, g5);
          for (var A2 = new lc2(0, 0, 0, 0), k2 = 0; k2 < b6.length; k2++) {
            var R6 = xk2(b6[k2], s, r5, g5);
            k2 === 0 ? A2.copy(R6) : A2.union(R6);
          }
          return A2;
        }
        function V8(c5, s, r5) {
          return r5 === "right" ? c5 -= s : r5 === "center" && (c5 -= s / 2), c5;
        }
        function wk2(c5, s, r5) {
          return r5 === "middle" ? c5 -= s / 2 : r5 === "bottom" && (c5 -= s), c5;
        }
        function Lj2(c5) {
          return _v("\u56FD", c5);
        }
        function f22(c5, s) {
          return typeof c5 == "string" ? c5.lastIndexOf("%") >= 0 ? parseFloat(c5) / 100 * s : parseFloat(c5) : c5;
        }
        function Oj2(c5, s, r5) {
          var g5 = s.position || "inside", b6 = s.distance != null ? s.distance : 5, S2 = r5.height, A2 = r5.width, k2 = S2 / 2, R6 = r5.x, B3 = r5.y, G3 = "left", Z3 = "top";
          if (g5 instanceof Array)
            R6 += f22(g5[0], r5.width), B3 += f22(g5[1], r5.height), G3 = null, Z3 = null;
          else
            switch (g5) {
              case "left":
                R6 -= b6, B3 += k2, G3 = "right", Z3 = "middle";
                break;
              case "right":
                R6 += b6 + A2, B3 += k2, Z3 = "middle";
                break;
              case "top":
                R6 += A2 / 2, B3 -= b6, G3 = "center", Z3 = "bottom";
                break;
              case "bottom":
                R6 += A2 / 2, B3 += S2 + b6, G3 = "center";
                break;
              case "inside":
                R6 += A2 / 2, B3 += k2, G3 = "center", Z3 = "middle";
                break;
              case "insideLeft":
                R6 += b6, B3 += k2, Z3 = "middle";
                break;
              case "insideRight":
                R6 += A2 - b6, B3 += k2, G3 = "right", Z3 = "middle";
                break;
              case "insideTop":
                R6 += A2 / 2, B3 += b6, G3 = "center";
                break;
              case "insideBottom":
                R6 += A2 / 2, B3 += S2 - b6, G3 = "center", Z3 = "bottom";
                break;
              case "insideTopLeft":
                R6 += b6, B3 += b6;
                break;
              case "insideTopRight":
                R6 += A2 - b6, B3 += b6, G3 = "right";
                break;
              case "insideBottomLeft":
                R6 += b6, B3 += S2 - b6, Z3 = "bottom";
                break;
              case "insideBottomRight":
                R6 += A2 - b6, B3 += S2 - b6, G3 = "right", Z3 = "bottom";
                break;
            }
          return c5 = c5 || {}, c5.x = R6, c5.y = B3, c5.align = G3, c5.verticalAlign = Z3, c5;
        }
        var Rj2 = "__zr_normal__", Nj2 = xM.concat(["ignore"]), v32 = VC(xM, function(c5, s) {
          return c5[s] = true, c5;
        }, { ignore: false }), B8 = {}, y3 = new lc2(0, 0, 0, 0), dK = function() {
          function c5(s) {
            this.id = V4(), this.animators = [], this.currentStates = [], this.states = {}, this._init(s);
          }
          return c5.prototype._init = function(s) {
            this.attr(s);
          }, c5.prototype.drift = function(s, r5, g5) {
            switch (this.draggable) {
              case "horizontal":
                r5 = 0;
                break;
              case "vertical":
                s = 0;
                break;
            }
            var b6 = this.transform;
            b6 || (b6 = this.transform = [1, 0, 0, 1, 0, 0]), b6[4] += s, b6[5] += r5, this.decomposeTransform(), this.markRedraw();
          }, c5.prototype.beforeUpdate = function() {
          }, c5.prototype.afterUpdate = function() {
          }, c5.prototype.update = function() {
            this.updateTransform(), this.__dirty && this.updateInnerText();
          }, c5.prototype.updateInnerText = function(s) {
            var r5 = this._textContent;
            if (r5 && (!r5.ignore || s)) {
              this.textConfig || (this.textConfig = {});
              var g5 = this.textConfig, b6 = g5.local, S2 = r5.innerTransformable, A2 = void 0, k2 = void 0, R6 = false;
              S2.parent = b6 ? this : null;
              var B3 = false;
              if (S2.copyTransform(r5), g5.position != null) {
                var G3 = y3;
                g5.layoutRect ? G3.copy(g5.layoutRect) : G3.copy(this.getBoundingRect()), b6 || G3.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(B8, g5, G3) : Oj2(B8, g5, G3), S2.x = B8.x, S2.y = B8.y, A2 = B8.align, k2 = B8.verticalAlign;
                var Z3 = g5.origin;
                if (Z3 && g5.rotation != null) {
                  var X3 = void 0, tt = void 0;
                  Z3 === "center" ? (X3 = G3.width * 0.5, tt = G3.height * 0.5) : (X3 = f22(Z3[0], G3.width), tt = f22(Z3[1], G3.height)), B3 = true, S2.originX = -S2.x + X3 + (b6 ? 0 : G3.x), S2.originY = -S2.y + tt + (b6 ? 0 : G3.y);
                }
              }
              g5.rotation != null && (S2.rotation = g5.rotation);
              var it = g5.offset;
              it && (S2.x += it[0], S2.y += it[1], B3 || (S2.originX = -it[0], S2.originY = -it[1]));
              var pt = g5.inside == null ? typeof g5.position == "string" && g5.position.indexOf("inside") >= 0 : g5.inside, mt = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), Mt = void 0, kt = void 0, Gt = void 0;
              pt && this.canBeInsideText() ? (Mt = g5.insideFill, kt = g5.insideStroke, (Mt == null || Mt === "auto") && (Mt = this.getInsideTextFill()), (kt == null || kt === "auto") && (kt = this.getInsideTextStroke(Mt), Gt = true)) : (Mt = g5.outsideFill, kt = g5.outsideStroke, (Mt == null || Mt === "auto") && (Mt = this.getOutsideFill()), (kt == null || kt === "auto") && (kt = this.getOutsideStroke(Mt), Gt = true)), Mt = Mt || "#000", (Mt !== mt.fill || kt !== mt.stroke || Gt !== mt.autoStroke || A2 !== mt.align || k2 !== mt.verticalAlign) && (R6 = true, mt.fill = Mt, mt.stroke = kt, mt.autoStroke = Gt, mt.align = A2, mt.verticalAlign = k2, r5.setDefaultTextStyle(mt)), r5.__dirty |= Vb2, R6 && r5.dirtyStyle(true);
            }
          }, c5.prototype.canBeInsideText = function() {
            return true;
          }, c5.prototype.getInsideTextFill = function() {
            return "#fff";
          }, c5.prototype.getInsideTextStroke = function(s) {
            return "#000";
          }, c5.prototype.getOutsideFill = function() {
            return this.__zr && this.__zr.isDarkMode() ? Llt : cK;
          }, c5.prototype.getOutsideStroke = function(s) {
            var r5 = this.__zr && this.__zr.getBackgroundColor(), g5 = typeof r5 == "string" && Bb2(r5);
            g5 || (g5 = [255, 255, 255, 1]);
            for (var b6 = g5[3], S2 = this.__zr.isDarkMode(), A2 = 0; A2 < 3; A2++)
              g5[A2] = g5[A2] * b6 + (S2 ? 0 : 255) * (1 - b6);
            return g5[3] = 1, vk2(g5, "rgba");
          }, c5.prototype.traverse = function(s, r5) {
          }, c5.prototype.attrKV = function(s, r5) {
            s === "textConfig" ? this.setTextConfig(r5) : s === "textContent" ? this.setTextContent(r5) : s === "clipPath" ? this.setClipPath(r5) : s === "extra" ? (this.extra = this.extra || {}, sa2(this.extra, r5)) : this[s] = r5;
          }, c5.prototype.hide = function() {
            this.ignore = true, this.markRedraw();
          }, c5.prototype.show = function() {
            this.ignore = false, this.markRedraw();
          }, c5.prototype.attr = function(s, r5) {
            if (typeof s == "string")
              this.attrKV(s, r5);
            else if (Wl(s))
              for (var g5 = s, b6 = nf2(g5), S2 = 0; S2 < b6.length; S2++) {
                var A2 = b6[S2];
                this.attrKV(A2, s[A2]);
              }
            return this.markRedraw(), this;
          }, c5.prototype.saveCurrentToNormalState = function(s) {
            this._innerSaveToNormal(s);
            for (var r5 = this._normalState, g5 = 0; g5 < this.animators.length; g5++) {
              var b6 = this.animators[g5], S2 = b6.__fromStateTransition;
              if (!(b6.getLoop() || S2 && S2 !== Rj2)) {
                var A2 = b6.targetName, k2 = A2 ? r5[A2] : r5;
                b6.saveTo(k2);
              }
            }
          }, c5.prototype._innerSaveToNormal = function(s) {
            var r5 = this._normalState;
            r5 || (r5 = this._normalState = {}), s.textConfig && !r5.textConfig && (r5.textConfig = this.textConfig), this._savePrimaryToNormal(s, r5, Nj2);
          }, c5.prototype._savePrimaryToNormal = function(s, r5, g5) {
            for (var b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6];
              s[S2] != null && !(S2 in r5) && (r5[S2] = this[S2]);
            }
          }, c5.prototype.hasState = function() {
            return this.currentStates.length > 0;
          }, c5.prototype.getState = function(s) {
            return this.states[s];
          }, c5.prototype.ensureState = function(s) {
            var r5 = this.states;
            return r5[s] || (r5[s] = {}), r5[s];
          }, c5.prototype.clearStates = function(s) {
            this.useState(Rj2, false, s);
          }, c5.prototype.useState = function(s, r5, g5, b6) {
            var S2 = s === Rj2, A2 = this.hasState();
            if (!(!A2 && S2)) {
              var k2 = this.currentStates, R6 = this.stateTransition;
              if (!(Lu(k2, s) >= 0 && (r5 || k2.length === 1))) {
                var B3;
                if (this.stateProxy && !S2 && (B3 = this.stateProxy(s)), B3 || (B3 = this.states && this.states[s]), !B3 && !S2) {
                  r3("State " + s + " not exists.");
                  return;
                }
                S2 || this.saveCurrentToNormalState(B3);
                var G3 = !!(B3 && B3.hoverLayer || b6);
                G3 && this._toggleHoverLayerFlag(true), this._applyStateObj(s, B3, this._normalState, r5, !g5 && !this.__inHover && R6 && R6.duration > 0, R6);
                var Z3 = this._textContent, X3 = this._textGuide;
                return Z3 && Z3.useState(s, r5, g5, G3), X3 && X3.useState(s, r5, g5, G3), S2 ? (this.currentStates = [], this._normalState = {}) : r5 ? this.currentStates.push(s) : this.currentStates = [s], this._updateAnimationTargets(), this.markRedraw(), !G3 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Vb2), B3;
              }
            }
          }, c5.prototype.useStates = function(s, r5, g5) {
            if (!s.length)
              this.clearStates();
            else {
              var b6 = [], S2 = this.currentStates, A2 = s.length, k2 = A2 === S2.length;
              if (k2) {
                for (var R6 = 0; R6 < A2; R6++)
                  if (s[R6] !== S2[R6]) {
                    k2 = false;
                    break;
                  }
              }
              if (k2)
                return;
              for (var R6 = 0; R6 < A2; R6++) {
                var B3 = s[R6], G3 = void 0;
                this.stateProxy && (G3 = this.stateProxy(B3, s)), G3 || (G3 = this.states[B3]), G3 && b6.push(G3);
              }
              var Z3 = b6[A2 - 1], X3 = !!(Z3 && Z3.hoverLayer || g5);
              X3 && this._toggleHoverLayerFlag(true);
              var tt = this._mergeStates(b6), it = this.stateTransition;
              this.saveCurrentToNormalState(tt), this._applyStateObj(s.join(","), tt, this._normalState, false, !r5 && !this.__inHover && it && it.duration > 0, it);
              var pt = this._textContent, mt = this._textGuide;
              pt && pt.useStates(s, r5, X3), mt && mt.useStates(s, r5, X3), this._updateAnimationTargets(), this.currentStates = s.slice(), this.markRedraw(), !X3 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Vb2);
            }
          }, c5.prototype._updateAnimationTargets = function() {
            for (var s = 0; s < this.animators.length; s++) {
              var r5 = this.animators[s];
              r5.targetName && r5.changeTarget(this[r5.targetName]);
            }
          }, c5.prototype.removeState = function(s) {
            var r5 = Lu(this.currentStates, s);
            if (r5 >= 0) {
              var g5 = this.currentStates.slice();
              g5.splice(r5, 1), this.useStates(g5);
            }
          }, c5.prototype.replaceState = function(s, r5, g5) {
            var b6 = this.currentStates.slice(), S2 = Lu(b6, s), A2 = Lu(b6, r5) >= 0;
            S2 >= 0 ? A2 ? b6.splice(S2, 1) : b6[S2] = r5 : g5 && !A2 && b6.push(r5), this.useStates(b6);
          }, c5.prototype.toggleState = function(s, r5) {
            r5 ? this.useState(s, true) : this.removeState(s);
          }, c5.prototype._mergeStates = function(s) {
            for (var r5 = {}, g5, b6 = 0; b6 < s.length; b6++) {
              var S2 = s[b6];
              sa2(r5, S2), S2.textConfig && (g5 = g5 || {}, sa2(g5, S2.textConfig));
            }
            return g5 && (r5.textConfig = g5), r5;
          }, c5.prototype._applyStateObj = function(s, r5, g5, b6, S2, A2) {
            var k2 = !(r5 && b6);
            r5 && r5.textConfig ? (this.textConfig = sa2({}, b6 ? this.textConfig : g5.textConfig), sa2(this.textConfig, r5.textConfig)) : k2 && g5.textConfig && (this.textConfig = g5.textConfig);
            for (var R6 = {}, B3 = false, G3 = 0; G3 < Nj2.length; G3++) {
              var Z3 = Nj2[G3], X3 = S2 && v32[Z3];
              r5 && r5[Z3] != null ? X3 ? (B3 = true, R6[Z3] = r5[Z3]) : this[Z3] = r5[Z3] : k2 && g5[Z3] != null && (X3 ? (B3 = true, R6[Z3] = g5[Z3]) : this[Z3] = g5[Z3]);
            }
            if (!S2)
              for (var G3 = 0; G3 < this.animators.length; G3++) {
                var tt = this.animators[G3], it = tt.targetName;
                tt.getLoop() || tt.__changeFinalValue(it ? (r5 || g5)[it] : r5 || g5);
              }
            B3 && this._transitionState(s, R6, A2);
          }, c5.prototype._attachComponent = function(s) {
            if (!(s.__zr && !s.__hostTarget) && s !== this) {
              var r5 = this.__zr;
              r5 && s.addSelfToZr(r5), s.__zr = r5, s.__hostTarget = this;
            }
          }, c5.prototype._detachComponent = function(s) {
            s.__zr && s.removeSelfFromZr(s.__zr), s.__zr = null, s.__hostTarget = null;
          }, c5.prototype.getClipPath = function() {
            return this._clipPath;
          }, c5.prototype.setClipPath = function(s) {
            this._clipPath && this._clipPath !== s && this.removeClipPath(), this._attachComponent(s), this._clipPath = s, this.markRedraw();
          }, c5.prototype.removeClipPath = function() {
            var s = this._clipPath;
            s && (this._detachComponent(s), this._clipPath = null, this.markRedraw());
          }, c5.prototype.getTextContent = function() {
            return this._textContent;
          }, c5.prototype.setTextContent = function(s) {
            var r5 = this._textContent;
            r5 !== s && (r5 && r5 !== s && this.removeTextContent(), s.innerTransformable = new YC(), this._attachComponent(s), this._textContent = s, this.markRedraw());
          }, c5.prototype.setTextConfig = function(s) {
            this.textConfig || (this.textConfig = {}), sa2(this.textConfig, s), this.markRedraw();
          }, c5.prototype.removeTextConfig = function() {
            this.textConfig = null, this.markRedraw();
          }, c5.prototype.removeTextContent = function() {
            var s = this._textContent;
            s && (s.innerTransformable = null, this._detachComponent(s), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
          }, c5.prototype.getTextGuideLine = function() {
            return this._textGuide;
          }, c5.prototype.setTextGuideLine = function(s) {
            this._textGuide && this._textGuide !== s && this.removeTextGuideLine(), this._attachComponent(s), this._textGuide = s, this.markRedraw();
          }, c5.prototype.removeTextGuideLine = function() {
            var s = this._textGuide;
            s && (this._detachComponent(s), this._textGuide = null, this.markRedraw());
          }, c5.prototype.markRedraw = function() {
            this.__dirty |= Vb2;
            var s = this.__zr;
            s && (this.__inHover ? s.refreshHover() : s.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
          }, c5.prototype.dirty = function() {
            this.markRedraw();
          }, c5.prototype._toggleHoverLayerFlag = function(s) {
            this.__inHover = s;
            var r5 = this._textContent, g5 = this._textGuide;
            r5 && (r5.__inHover = s), g5 && (g5.__inHover = s);
          }, c5.prototype.addSelfToZr = function(s) {
            if (this.__zr !== s) {
              this.__zr = s;
              var r5 = this.animators;
              if (r5)
                for (var g5 = 0; g5 < r5.length; g5++)
                  s.animation.addAnimator(r5[g5]);
              this._clipPath && this._clipPath.addSelfToZr(s), this._textContent && this._textContent.addSelfToZr(s), this._textGuide && this._textGuide.addSelfToZr(s);
            }
          }, c5.prototype.removeSelfFromZr = function(s) {
            if (this.__zr) {
              this.__zr = null;
              var r5 = this.animators;
              if (r5)
                for (var g5 = 0; g5 < r5.length; g5++)
                  s.animation.removeAnimator(r5[g5]);
              this._clipPath && this._clipPath.removeSelfFromZr(s), this._textContent && this._textContent.removeSelfFromZr(s), this._textGuide && this._textGuide.removeSelfFromZr(s);
            }
          }, c5.prototype.animate = function(s, r5, g5) {
            var b6 = s ? this[s] : this, S2 = new Elt(b6, r5, g5);
            return s && (S2.targetName = s), this.addAnimator(S2, s), S2;
          }, c5.prototype.addAnimator = function(s, r5) {
            var g5 = this.__zr, b6 = this;
            s.during(function() {
              b6.updateDuringAnimation(r5);
            }).done(function() {
              var S2 = b6.animators, A2 = Lu(S2, s);
              A2 >= 0 && S2.splice(A2, 1);
            }), this.animators.push(s), g5 && g5.animation.addAnimator(s), g5 && g5.wakeUp();
          }, c5.prototype.updateDuringAnimation = function(s) {
            this.markRedraw();
          }, c5.prototype.stopAnimation = function(s, r5) {
            for (var g5 = this.animators, b6 = g5.length, S2 = [], A2 = 0; A2 < b6; A2++) {
              var k2 = g5[A2];
              !s || s === k2.scope ? k2.stop(r5) : S2.push(k2);
            }
            return this.animators = S2, this;
          }, c5.prototype.animateTo = function(s, r5, g5) {
            gK(this, s, r5, g5);
          }, c5.prototype.animateFrom = function(s, r5, g5) {
            gK(this, s, r5, g5, true);
          }, c5.prototype._transitionState = function(s, r5, g5, b6) {
            for (var S2 = gK(this, r5, g5, b6), A2 = 0; A2 < S2.length; A2++)
              S2[A2].__fromStateTransition = s;
          }, c5.prototype.getBoundingRect = function() {
            return null;
          }, c5.prototype.getPaintRect = function() {
            return null;
          }, c5.initDefaultProps = function() {
            var s = c5.prototype;
            s.type = "element", s.name = "", s.ignore = s.silent = s.isGroup = s.draggable = s.dragging = s.ignoreClip = s.__inHover = false, s.__dirty = Vb2;
            function r5(g5, b6, S2, A2) {
              Object.defineProperty(s, g5, { get: function() {
                if (!this[b6]) {
                  var R6 = this[b6] = [];
                  k2(this, R6);
                }
                return this[b6];
              }, set: function(R6) {
                this[S2] = R6[0], this[A2] = R6[1], this[b6] = R6, k2(this, R6);
              } });
              function k2(R6, B3) {
                Object.defineProperty(B3, 0, { get: function() {
                  return R6[S2];
                }, set: function(G3) {
                  R6[S2] = G3;
                } }), Object.defineProperty(B3, 1, { get: function() {
                  return R6[A2];
                }, set: function(G3) {
                  R6[A2] = G3;
                } });
              }
            }
            Object.defineProperty && (r5("position", "_legacyPos", "x", "y"), r5("scale", "_legacyScale", "scaleX", "scaleY"), r5("origin", "_legacyOrigin", "originX", "originY"));
          }(), c5;
        }();
        A0(dK, Lw), A0(dK, YC);
        function gK(c5, s, r5, g5, b6) {
          r5 = r5 || {};
          var S2 = [];
          Vlt(c5, "", c5, s, r5, g5, S2, b6);
          var A2 = S2.length, k2 = false, R6 = r5.done, B3 = r5.aborted, G3 = function() {
            k2 = true, A2--, A2 <= 0 && (k2 ? R6 && R6() : B3 && B3());
          }, Z3 = function() {
            A2--, A2 <= 0 && (k2 ? R6 && R6() : B3 && B3());
          };
          A2 || R6 && R6(), S2.length > 0 && r5.during && S2[0].during(function(it, pt) {
            r5.during(pt);
          });
          for (var X3 = 0; X3 < S2.length; X3++) {
            var tt = S2[X3];
            G3 && tt.done(G3), Z3 && tt.aborted(Z3), r5.force && tt.duration(r5.duration), tt.start(r5.easing);
          }
          return S2;
        }
        function Fj2(c5, s, r5) {
          for (var g5 = 0; g5 < r5; g5++)
            c5[g5] = s[g5];
        }
        function Fzt(c5) {
          return Fb2(c5[0]);
        }
        function Vzt(c5, s, r5) {
          if (Fb2(s[r5]))
            if (Fb2(c5[r5]) || (c5[r5] = []), u2(s[r5])) {
              var g5 = s[r5].length;
              c5[r5].length !== g5 && (c5[r5] = new s[r5].constructor(g5), Fj2(c5[r5], s[r5], g5));
            } else {
              var b6 = s[r5], S2 = c5[r5], A2 = b6.length;
              if (Fzt(b6))
                for (var k2 = b6[0].length, R6 = 0; R6 < A2; R6++)
                  S2[R6] ? Fj2(S2[R6], b6[R6], k2) : S2[R6] = Array.prototype.slice.call(b6[R6]);
              else
                Fj2(S2, b6, A2);
              S2.length = b6.length;
            }
          else
            c5[r5] = s[r5];
        }
        function Bzt(c5, s) {
          return c5 === s || Fb2(c5) && Fb2(s) && ISt(c5, s);
        }
        function ISt(c5, s) {
          var r5 = c5.length;
          if (r5 !== s.length)
            return false;
          for (var g5 = 0; g5 < r5; g5++)
            if (c5[g5] !== s[g5])
              return false;
          return true;
        }
        function Vlt(c5, s, r5, g5, b6, S2, A2, k2) {
          for (var R6 = nf2(g5), B3 = b6.duration, G3 = b6.delay, Z3 = b6.additive, X3 = b6.setToFinal, tt = !Wl(S2), it = c5.animators, pt = [], mt = 0; mt < R6.length; mt++) {
            var Mt = R6[mt], kt = g5[Mt];
            if (kt != null && r5[Mt] != null && (tt || S2[Mt]))
              if (Wl(kt) && !Fb2(kt) && !Xd2(kt)) {
                if (s) {
                  k2 || (r5[Mt] = kt, c5.updateDuringAnimation(s));
                  continue;
                }
                Vlt(c5, Mt, r5[Mt], kt, b6, S2 && S2[Mt], A2, k2);
              } else
                pt.push(Mt);
            else
              k2 || (r5[Mt] = kt, c5.updateDuringAnimation(s), pt.push(Mt));
          }
          var Gt = pt.length;
          if (!Z3 && Gt)
            for (var Ot = 0; Ot < it.length; Ot++) {
              var ce2 = it[Ot];
              if (ce2.targetName === s) {
                var ae2 = ce2.stopTracks(pt);
                if (ae2) {
                  var de2 = Lu(it, ce2);
                  it.splice(de2, 1);
                }
              }
            }
          if (b6.force || (pt = jp(pt, function(je2) {
            return !Bzt(g5[je2], r5[je2]);
          }), Gt = pt.length), Gt > 0 || b6.force && !A2.length) {
            var we2 = void 0, Se2 = void 0, Oe2 = void 0;
            if (k2) {
              Se2 = {}, X3 && (we2 = {});
              for (var Ot = 0; Ot < Gt; Ot++) {
                var Mt = pt[Ot];
                Se2[Mt] = r5[Mt], X3 ? we2[Mt] = g5[Mt] : r5[Mt] = g5[Mt];
              }
            } else if (X3) {
              Oe2 = {};
              for (var Ot = 0; Ot < Gt; Ot++) {
                var Mt = pt[Ot];
                Oe2[Mt] = l3(r5[Mt]), Vzt(r5, g5, Mt);
              }
            }
            var ce2 = new Elt(r5, false, false, Z3 ? jp(it, function(rn) {
              return rn.targetName === s;
            }) : null);
            ce2.targetName = s, b6.scope && (ce2.scope = b6.scope), X3 && we2 && ce2.whenWithKeys(0, we2, pt), Oe2 && ce2.whenWithKeys(0, Oe2, pt), ce2.whenWithKeys(B3 == null ? 500 : B3, k2 ? Se2 : g5, pt).delay(G3 || 0), c5.addAnimator(ce2, s), A2.push(ce2);
          }
        }
        var DSt = dK, Blt = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this) || this;
            return g5.isGroup = true, g5._children = [], g5.attr(r5), g5;
          }
          return s.prototype.childrenRef = function() {
            return this._children;
          }, s.prototype.children = function() {
            return this._children.slice();
          }, s.prototype.childAt = function(r5) {
            return this._children[r5];
          }, s.prototype.childOfName = function(r5) {
            for (var g5 = this._children, b6 = 0; b6 < g5.length; b6++)
              if (g5[b6].name === r5)
                return g5[b6];
          }, s.prototype.childCount = function() {
            return this._children.length;
          }, s.prototype.add = function(r5) {
            return r5 && r5 !== this && r5.parent !== this && (this._children.push(r5), this._doAdd(r5)), this;
          }, s.prototype.addBefore = function(r5, g5) {
            if (r5 && r5 !== this && r5.parent !== this && g5 && g5.parent === this) {
              var b6 = this._children, S2 = b6.indexOf(g5);
              S2 >= 0 && (b6.splice(S2, 0, r5), this._doAdd(r5));
            }
            return this;
          }, s.prototype.replace = function(r5, g5) {
            var b6 = Lu(this._children, r5);
            return b6 >= 0 && this.replaceAt(g5, b6), this;
          }, s.prototype.replaceAt = function(r5, g5) {
            var b6 = this._children, S2 = b6[g5];
            if (r5 && r5 !== this && r5.parent !== this && r5 !== S2) {
              b6[g5] = r5, S2.parent = null;
              var A2 = this.__zr;
              A2 && S2.removeSelfFromZr(A2), this._doAdd(r5);
            }
            return this;
          }, s.prototype._doAdd = function(r5) {
            r5.parent && r5.parent.remove(r5), r5.parent = this;
            var g5 = this.__zr;
            g5 && g5 !== r5.__zr && r5.addSelfToZr(g5), g5 && g5.refresh();
          }, s.prototype.remove = function(r5) {
            var g5 = this.__zr, b6 = this._children, S2 = Lu(b6, r5);
            return S2 < 0 ? this : (b6.splice(S2, 1), r5.parent = null, g5 && r5.removeSelfFromZr(g5), g5 && g5.refresh(), this);
          }, s.prototype.removeAll = function() {
            for (var r5 = this._children, g5 = this.__zr, b6 = 0; b6 < r5.length; b6++) {
              var S2 = r5[b6];
              g5 && S2.removeSelfFromZr(g5), S2.parent = null;
            }
            return r5.length = 0, this;
          }, s.prototype.eachChild = function(r5, g5) {
            for (var b6 = this._children, S2 = 0; S2 < b6.length; S2++) {
              var A2 = b6[S2];
              r5.call(g5, A2, S2);
            }
            return this;
          }, s.prototype.traverse = function(r5, g5) {
            for (var b6 = 0; b6 < this._children.length; b6++) {
              var S2 = this._children[b6], A2 = r5.call(g5, S2);
              S2.isGroup && !A2 && S2.traverse(r5, g5);
            }
            return this;
          }, s.prototype.addSelfToZr = function(r5) {
            c5.prototype.addSelfToZr.call(this, r5);
            for (var g5 = 0; g5 < this._children.length; g5++) {
              var b6 = this._children[g5];
              b6.addSelfToZr(r5);
            }
          }, s.prototype.removeSelfFromZr = function(r5) {
            c5.prototype.removeSelfFromZr.call(this, r5);
            for (var g5 = 0; g5 < this._children.length; g5++) {
              var b6 = this._children[g5];
              b6.removeSelfFromZr(r5);
            }
          }, s.prototype.getBoundingRect = function(r5) {
            for (var g5 = new lc2(0, 0, 0, 0), b6 = r5 || this._children, S2 = [], A2 = null, k2 = 0; k2 < b6.length; k2++) {
              var R6 = b6[k2];
              if (!(R6.ignore || R6.invisible)) {
                var B3 = R6.getBoundingRect(), G3 = R6.getLocalTransform(S2);
                G3 ? (lc2.applyTransform(g5, B3, G3), A2 = A2 || g5.clone(), A2.union(g5)) : (A2 = A2 || B3.clone(), A2.union(B3));
              }
            }
            return A2 || g5;
          }, s;
        }(DSt);
        Blt.prototype.type = "group";
        var nu = Blt;
        /*!
        * ZRender, a high performance 2d drawing library.
        *
        * Copyright (c) 2013, Baidu Inc.
        * All rights reserved.
        *
        * LICENSE
        * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
        */
        var B1 = {}, KC = {};
        function zzt(c5) {
          delete KC[c5];
        }
        function jzt(c5) {
          if (!c5)
            return false;
          if (typeof c5 == "string")
            return KY(c5, 1) < Ij2;
          if (c5.colorStops) {
            for (var s = c5.colorStops, r5 = 0, g5 = s.length, b6 = 0; b6 < g5; b6++)
              r5 += KY(s[b6].color, 1);
            return r5 /= g5, r5 < Ij2;
          }
          return false;
        }
        var vK = function() {
          function c5(s, r5, g5) {
            var b6 = this;
            this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, g5 = g5 || {}, this.dom = r5, this.id = s;
            var S2 = new uSt(), A2 = g5.renderer || "canvas";
            B1[A2] || (A2 = nf2(B1)[0]), g5.useDirtyRect = g5.useDirtyRect == null ? false : g5.useDirtyRect;
            var k2 = new B1[A2](r5, S2, g5, s), R6 = g5.ssr || k2.ssrOnly;
            this.storage = S2, this.painter = k2;
            var B3 = !os.node && !os.worker && !R6 ? new Aj2(k2.getViewportRoot(), k2.root) : null;
            this.handler = new wi2(S2, k2, B3, k2.root), this.animation = new wSt({ stage: { update: R6 ? null : function() {
              return b6._flush(true);
            } } }), R6 || this.animation.start();
          }
          return c5.prototype.add = function(s) {
            !s || (this.storage.addRoot(s), s.addSelfToZr(this), this.refresh());
          }, c5.prototype.remove = function(s) {
            !s || (this.storage.delRoot(s), s.removeSelfFromZr(this), this.refresh());
          }, c5.prototype.configLayer = function(s, r5) {
            this.painter.configLayer && this.painter.configLayer(s, r5), this.refresh();
          }, c5.prototype.setBackgroundColor = function(s) {
            this.painter.setBackgroundColor && this.painter.setBackgroundColor(s), this.refresh(), this._backgroundColor = s, this._darkMode = jzt(s);
          }, c5.prototype.getBackgroundColor = function() {
            return this._backgroundColor;
          }, c5.prototype.setDarkMode = function(s) {
            this._darkMode = s;
          }, c5.prototype.isDarkMode = function() {
            return this._darkMode;
          }, c5.prototype.refreshImmediately = function(s) {
            s || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
          }, c5.prototype.refresh = function() {
            this._needsRefresh = true, this.animation.start();
          }, c5.prototype.flush = function() {
            this._flush(false);
          }, c5.prototype._flush = function(s) {
            var r5, g5 = bk2();
            this._needsRefresh && (r5 = true, this.refreshImmediately(s)), this._needsRefreshHover && (r5 = true, this.refreshHoverImmediately());
            var b6 = bk2();
            r5 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: b6 - g5 })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
          }, c5.prototype.setSleepAfterStill = function(s) {
            this._sleepAfterStill = s;
          }, c5.prototype.wakeUp = function() {
            this.animation.start(), this._stillFrameAccum = 0;
          }, c5.prototype.refreshHover = function() {
            this._needsRefreshHover = true;
          }, c5.prototype.refreshHoverImmediately = function() {
            this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
          }, c5.prototype.resize = function(s) {
            s = s || {}, this.painter.resize(s.width, s.height), this.handler.resize();
          }, c5.prototype.clearAnimation = function() {
            this.animation.clear();
          }, c5.prototype.getWidth = function() {
            return this.painter.getWidth();
          }, c5.prototype.getHeight = function() {
            return this.painter.getHeight();
          }, c5.prototype.setCursorStyle = function(s) {
            this.handler.setCursorStyle(s);
          }, c5.prototype.findHover = function(s, r5) {
            return this.handler.findHover(s, r5);
          }, c5.prototype.on = function(s, r5, g5) {
            return this.handler.on(s, r5, g5), this;
          }, c5.prototype.off = function(s, r5) {
            this.handler.off(s, r5);
          }, c5.prototype.trigger = function(s, r5) {
            this.handler.trigger(s, r5);
          }, c5.prototype.clear = function() {
            for (var s = this.storage.getRoots(), r5 = 0; r5 < s.length; r5++)
              s[r5] instanceof nu && s[r5].removeSelfFromZr(this);
            this.storage.delAllRoots(), this.painter.clear();
          }, c5.prototype.dispose = function() {
            this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, zzt(this.id);
          }, c5;
        }();
        function eR(c5, s) {
          var r5 = new vK(V4(), c5, s);
          return KC[r5.id] = r5, r5;
        }
        function ESt(c5, s) {
          B1[c5] = s;
        }
        var zlt = 1e-4, kSt = 20;
        function PSt(c5) {
          return c5.replace(/^\s+|\s+$/g, "");
        }
        function fh2(c5, s, r5, g5) {
          var b6 = s[0], S2 = s[1], A2 = r5[0], k2 = r5[1], R6 = S2 - b6, B3 = k2 - A2;
          if (R6 === 0)
            return B3 === 0 ? A2 : (A2 + k2) / 2;
          if (g5)
            if (R6 > 0) {
              if (c5 <= b6)
                return A2;
              if (c5 >= S2)
                return k2;
            } else {
              if (c5 >= b6)
                return A2;
              if (c5 <= S2)
                return k2;
            }
          else {
            if (c5 === b6)
              return A2;
            if (c5 === S2)
              return k2;
          }
          return (c5 - b6) / R6 * B3 + A2;
        }
        function $o(c5, s) {
          switch (c5) {
            case "center":
            case "middle":
              c5 = "50%";
              break;
            case "left":
            case "top":
              c5 = "0%";
              break;
            case "right":
            case "bottom":
              c5 = "100%";
              break;
          }
          return gs(c5) ? PSt(c5).match(/%$/) ? parseFloat(c5) / 100 * s : parseFloat(c5) : c5 == null ? NaN : +c5;
        }
        function c0(c5, s, r5) {
          return s == null && (s = 10), s = Math.min(Math.max(0, s), kSt), c5 = (+c5).toFixed(s), r5 ? c5 : +c5;
        }
        function h2(c5) {
          return c5.sort(function(s, r5) {
            return s - r5;
          }), c5;
        }
        function XC(c5) {
          if (c5 = +c5, isNaN(c5))
            return 0;
          if (c5 > 1e-14) {
            for (var s = 1, r5 = 0; r5 < 15; r5++, s *= 10)
              if (Math.round(c5 * s) / s === c5)
                return r5;
          }
          return yK(c5);
        }
        function yK(c5) {
          var s = c5.toString().toLowerCase(), r5 = s.indexOf("e"), g5 = r5 > 0 ? +s.slice(r5 + 1) : 0, b6 = r5 > 0 ? r5 : s.length, S2 = s.indexOf("."), A2 = S2 < 0 ? 0 : b6 - 1 - S2;
          return Math.max(0, A2 - g5);
        }
        function jlt(c5, s) {
          var r5 = Math.log, g5 = Math.LN10, b6 = Math.floor(r5(c5[1] - c5[0]) / g5), S2 = Math.round(r5(Math.abs(s[1] - s[0])) / g5), A2 = Math.min(Math.max(-b6 + S2, 0), 20);
          return isFinite(A2) ? A2 : 20;
        }
        function mK(c5, s, r5) {
          if (!c5[s])
            return 0;
          var g5 = VC(c5, function(it, pt) {
            return it + (isNaN(pt) ? 0 : pt);
          }, 0);
          if (g5 === 0)
            return 0;
          for (var b6 = Math.pow(10, r5), S2 = Ha2(c5, function(it) {
            return (isNaN(it) ? 0 : it) / g5 * b6 * 100;
          }), A2 = b6 * 100, k2 = Ha2(S2, function(it) {
            return Math.floor(it);
          }), R6 = VC(k2, function(it, pt) {
            return it + pt;
          }, 0), B3 = Ha2(S2, function(it, pt) {
            return it - k2[pt];
          }); R6 < A2; ) {
            for (var G3 = Number.NEGATIVE_INFINITY, Z3 = null, X3 = 0, tt = B3.length; X3 < tt; ++X3)
              B3[X3] > G3 && (G3 = B3[X3], Z3 = X3);
            ++k2[Z3], B3[Z3] = 0, ++R6;
          }
          return k2[s] / b6;
        }
        function Wlt(c5, s) {
          var r5 = Math.max(XC(c5), XC(s)), g5 = c5 + s;
          return r5 > kSt ? g5 : c0(g5, r5);
        }
        var Vj2 = 9007199254740991;
        function LSt(c5) {
          var s = Math.PI * 2;
          return (c5 % s + s) % s;
        }
        function Bj2(c5) {
          return c5 > -zlt && c5 < zlt;
        }
        var bK = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
        function QC(c5) {
          if (c5 instanceof Date)
            return c5;
          if (gs(c5)) {
            var s = bK.exec(c5);
            if (!s)
              return new Date(NaN);
            if (s[8]) {
              var r5 = +s[4] || 0;
              return s[8].toUpperCase() !== "Z" && (r5 -= +s[8].slice(0, 3)), new Date(Date.UTC(+s[1], +(s[2] || 1) - 1, +s[3] || 1, r5, +(s[5] || 0), +s[6] || 0, s[7] ? +s[7].substring(0, 3) : 0));
            } else
              return new Date(+s[1], +(s[2] || 1) - 1, +s[3] || 1, +s[4] || 0, +(s[5] || 0), +s[6] || 0, s[7] ? +s[7].substring(0, 3) : 0);
          } else if (c5 == null)
            return new Date(NaN);
          return new Date(Math.round(c5));
        }
        function Glt(c5) {
          return Math.pow(10, Hlt(c5));
        }
        function Hlt(c5) {
          if (c5 === 0)
            return 0;
          var s = Math.floor(Math.log(c5) / Math.LN10);
          return c5 / Math.pow(10, s) >= 10 && s++, s;
        }
        function Ult(c5, s) {
          var r5 = Hlt(c5), g5 = Math.pow(10, r5), b6 = c5 / g5, S2;
          return s ? b6 < 1.5 ? S2 = 1 : b6 < 2.5 ? S2 = 2 : b6 < 4 ? S2 = 3 : b6 < 7 ? S2 = 5 : S2 = 10 : b6 < 1 ? S2 = 1 : b6 < 2 ? S2 = 2 : b6 < 3 ? S2 = 3 : b6 < 5 ? S2 = 5 : S2 = 10, c5 = S2 * g5, r5 >= -20 ? +c5.toFixed(r5 < 0 ? -r5 : 0) : c5;
        }
        function JC(c5, s) {
          var r5 = (c5.length - 1) * s + 1, g5 = Math.floor(r5), b6 = +c5[g5 - 1], S2 = r5 - g5;
          return S2 ? b6 + S2 * (c5[g5] - b6) : b6;
        }
        function qlt(c5) {
          c5.sort(function(R6, B3) {
            return k2(R6, B3, 0) ? -1 : 1;
          });
          for (var s = -1 / 0, r5 = 1, g5 = 0; g5 < c5.length; ) {
            for (var b6 = c5[g5].interval, S2 = c5[g5].close, A2 = 0; A2 < 2; A2++)
              b6[A2] <= s && (b6[A2] = s, S2[A2] = A2 ? 1 : 1 - r5), s = b6[A2], r5 = S2[A2];
            b6[0] === b6[1] && S2[0] * S2[1] !== 1 ? c5.splice(g5, 1) : g5++;
          }
          return c5;
          function k2(R6, B3, G3) {
            return R6.interval[G3] < B3.interval[G3] || R6.interval[G3] === B3.interval[G3] && (R6.close[G3] - B3.close[G3] === (G3 ? -1 : 1) || !G3 && k2(R6, B3, 1));
          }
        }
        function NI(c5) {
          var s = parseFloat(c5);
          return s == c5 && (s !== 0 || !gs(c5) || c5.indexOf("x") <= 0) ? s : NaN;
        }
        function OSt(c5) {
          return !isNaN(NI(c5));
        }
        function Zlt() {
          return Math.round(Math.random() * 9);
        }
        function RSt(c5, s) {
          return s === 0 ? c5 : RSt(s, c5 % s);
        }
        function NSt(c5, s) {
          return c5 == null ? s : s == null ? c5 : c5 * s / RSt(c5, s);
        }
        function rf2(c5) {
          throw new Error(c5);
        }
        function _K(c5, s, r5) {
          return (s - c5) * r5 + c5;
        }
        var xK = "series\0", wK = "\0_ec_\0";
        function xp(c5) {
          return c5 instanceof Array ? c5 : c5 == null ? [] : [c5];
        }
        function wM(c5, s, r5) {
          if (c5) {
            c5[s] = c5[s] || {}, c5.emphasis = c5.emphasis || {}, c5.emphasis[s] = c5.emphasis[s] || {};
            for (var g5 = 0, b6 = r5.length; g5 < b6; g5++) {
              var S2 = r5[g5];
              !c5.emphasis[s].hasOwnProperty(S2) && c5[s].hasOwnProperty(S2) && (c5.emphasis[s][S2] = c5[s][S2]);
            }
          }
        }
        var ec2 = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
        function Sk(c5) {
          return Wl(c5) && !ja2(c5) && !(c5 instanceof Date) ? c5.value : c5;
        }
        function $lt(c5) {
          return Wl(c5) && !(c5 instanceof Array);
        }
        function m3(c5, s, r5) {
          var g5 = r5 === "normalMerge", b6 = r5 === "replaceMerge", S2 = r5 === "replaceAll";
          c5 = c5 || [], s = (s || []).slice();
          var A2 = Ps();
          Ye2(s, function(R6, B3) {
            if (!Wl(R6)) {
              s[B3] = null;
              return;
            }
          });
          var k2 = Wzt(c5, A2, r5);
          return (g5 || b6) && Ylt(k2, c5, A2, s), g5 && FSt(k2, s), g5 || b6 ? zb2(k2, s, b6) : S2 && Gzt(k2, s), Hzt(k2), k2;
        }
        function Wzt(c5, s, r5) {
          var g5 = [];
          if (r5 === "replaceAll")
            return g5;
          for (var b6 = 0; b6 < c5.length; b6++) {
            var S2 = c5[b6];
            S2 && S2.id != null && s.set(S2.id, b6), g5.push({ existing: r5 === "replaceMerge" || jj2(S2) ? null : S2, newOption: null, keyInfo: null, brandNew: null });
          }
          return g5;
        }
        function Ylt(c5, s, r5, g5) {
          Ye2(g5, function(b6, S2) {
            if (!(!b6 || b6.id == null)) {
              var A2 = zj2(b6.id), k2 = r5.get(A2);
              if (k2 != null) {
                var R6 = c5[k2];
                lx(!R6.newOption, 'Duplicated option on id "' + A2 + '".'), R6.newOption = b6, R6.existing = s[k2], g5[S2] = null;
              }
            }
          });
        }
        function FSt(c5, s) {
          Ye2(s, function(r5, g5) {
            if (!(!r5 || r5.name == null))
              for (var b6 = 0; b6 < c5.length; b6++) {
                var S2 = c5[b6].existing;
                if (!c5[b6].newOption && S2 && (S2.id == null || r5.id == null) && !jj2(r5) && !jj2(S2) && Klt("name", S2, r5)) {
                  c5[b6].newOption = r5, s[g5] = null;
                  return;
                }
              }
          });
        }
        function zb2(c5, s, r5) {
          Ye2(s, function(g5) {
            if (g5) {
              for (var b6, S2 = 0; (b6 = c5[S2]) && (b6.newOption || jj2(b6.existing) || b6.existing && g5.id != null && !Klt("id", g5, b6.existing)); )
                S2++;
              b6 ? (b6.newOption = g5, b6.brandNew = r5) : c5.push({ newOption: g5, brandNew: r5, existing: null, keyInfo: null }), S2++;
            }
          });
        }
        function Gzt(c5, s) {
          Ye2(s, function(r5) {
            c5.push({ newOption: r5, brandNew: true, existing: null, keyInfo: null });
          });
        }
        function Hzt(c5) {
          var s = Ps();
          Ye2(c5, function(r5) {
            var g5 = r5.existing;
            g5 && s.set(g5.id, r5);
          }), Ye2(c5, function(r5) {
            var g5 = r5.newOption;
            lx(!g5 || g5.id == null || !s.get(g5.id) || s.get(g5.id) === r5, "id duplicates: " + (g5 && g5.id)), g5 && g5.id != null && s.set(g5.id, r5), !r5.keyInfo && (r5.keyInfo = {});
          }), Ye2(c5, function(r5, g5) {
            var b6 = r5.existing, S2 = r5.newOption, A2 = r5.keyInfo;
            if (Wl(S2)) {
              if (A2.name = S2.name != null ? zj2(S2.name) : b6 ? b6.name : xK + g5, b6)
                A2.id = zj2(b6.id);
              else if (S2.id != null)
                A2.id = zj2(S2.id);
              else {
                var k2 = 0;
                do
                  A2.id = "\0" + A2.name + "\0" + k2++;
                while (s.get(A2.id));
              }
              s.set(A2.id, r5);
            }
          });
        }
        function Klt(c5, s, r5) {
          var g5 = Q0(s[c5], null), b6 = Q0(r5[c5], null);
          return g5 != null && b6 != null && g5 === b6;
        }
        function zj2(c5) {
          return Q0(c5, "");
        }
        function Q0(c5, s) {
          return c5 == null ? s : gs(c5) ? c5 : Oh2(c5) || uj2(c5) ? c5 + "" : s;
        }
        function Xlt(c5) {
          var s = c5.name;
          return !!(s && s.indexOf(xK));
        }
        function jj2(c5) {
          return c5 && c5.id != null && zj2(c5.id).indexOf(wK) === 0;
        }
        function Uzt(c5) {
          return wK + c5;
        }
        function Mk(c5, s, r5) {
          Ye2(c5, function(g5) {
            var b6 = g5.newOption;
            Wl(b6) && (g5.keyInfo.mainType = s, g5.keyInfo.subType = vx(s, b6, g5.existing, r5));
          });
        }
        function vx(c5, s, r5, g5) {
          var b6 = s.type ? s.type : r5 ? r5.subType : g5.determineSubType(c5, s);
          return b6;
        }
        function Qlt(c5, s) {
          var r5 = {}, g5 = {};
          return b6(c5 || [], r5), b6(s || [], g5, r5), [S2(r5), S2(g5)];
          function b6(A2, k2, R6) {
            for (var B3 = 0, G3 = A2.length; B3 < G3; B3++) {
              var Z3 = Q0(A2[B3].seriesId, null);
              if (Z3 == null)
                return;
              for (var X3 = xp(A2[B3].dataIndex), tt = R6 && R6[Z3], it = 0, pt = X3.length; it < pt; it++) {
                var mt = X3[it];
                tt && tt[mt] ? tt[mt] = null : (k2[Z3] || (k2[Z3] = {}))[mt] = 1;
              }
            }
          }
          function S2(A2, k2) {
            var R6 = [];
            for (var B3 in A2)
              if (A2.hasOwnProperty(B3) && A2[B3] != null)
                if (k2)
                  R6.push(+B3);
                else {
                  var G3 = S2(A2[B3], true);
                  G3.length && R6.push({ seriesId: B3, dataIndex: G3 });
                }
            return R6;
          }
        }
        function nR(c5, s) {
          if (s.dataIndexInside != null)
            return s.dataIndexInside;
          if (s.dataIndex != null)
            return ja2(s.dataIndex) ? Ha2(s.dataIndex, function(r5) {
              return c5.indexOfRawIndex(r5);
            }) : c5.indexOfRawIndex(s.dataIndex);
          if (s.name != null)
            return ja2(s.name) ? Ha2(s.name, function(r5) {
              return c5.indexOfName(r5);
            }) : c5.indexOfName(s.name);
        }
        function Df2() {
          var c5 = "__ec_inner_" + qzt++;
          return function(s) {
            return s[c5] || (s[c5] = {});
          };
        }
        var qzt = Zlt();
        function Wj2(c5, s, r5) {
          var g5 = rR(s, r5), b6 = g5.mainTypeSpecified, S2 = g5.queryOptionMap, A2 = g5.others, k2 = A2, R6 = r5 ? r5.defaultMainType : null;
          return !b6 && R6 && S2.set(R6, {}), S2.each(function(B3, G3) {
            var Z3 = Gj2(c5, G3, B3, { useDefault: R6 === G3, enableAll: r5 && r5.enableAll != null ? r5.enableAll : true, enableNone: r5 && r5.enableNone != null ? r5.enableNone : true });
            k2[G3 + "Models"] = Z3.models, k2[G3 + "Model"] = Z3.models[0];
          }), k2;
        }
        function rR(c5, s) {
          var r5;
          if (gs(c5)) {
            var g5 = {};
            g5[c5 + "Index"] = 0, r5 = g5;
          } else
            r5 = c5;
          var b6 = Ps(), S2 = {}, A2 = false;
          return Ye2(r5, function(k2, R6) {
            if (R6 === "dataIndex" || R6 === "dataIndexInside") {
              S2[R6] = k2;
              return;
            }
            var B3 = R6.match(/^(\w+)(Index|Id|Name)$/) || [], G3 = B3[1], Z3 = (B3[2] || "").toLowerCase();
            if (!(!G3 || !Z3 || s && s.includeMainTypes && Lu(s.includeMainTypes, G3) < 0)) {
              A2 = A2 || !!G3;
              var X3 = b6.get(G3) || b6.set(G3, {});
              X3[Z3] = k2;
            }
          }), { mainTypeSpecified: A2, queryOptionMap: b6, others: S2 };
        }
        var E0 = { useDefault: true, enableAll: false, enableNone: false }, VSt = { useDefault: false, enableAll: true, enableNone: true };
        function Gj2(c5, s, r5, g5) {
          g5 = g5 || E0;
          var b6 = r5.index, S2 = r5.id, A2 = r5.name, k2 = { models: null, specified: b6 != null || S2 != null || A2 != null };
          if (!k2.specified) {
            var R6 = void 0;
            return k2.models = g5.useDefault && (R6 = c5.getComponent(s)) ? [R6] : [], k2;
          }
          return b6 === "none" || b6 === false ? (lx(g5.enableNone, '`"none"` or `false` is not a valid value on index option.'), k2.models = [], k2) : (b6 === "all" && (lx(g5.enableAll, '`"all"` is not a valid value on index option.'), b6 = S2 = A2 = null), k2.models = c5.queryComponents({ mainType: s, index: b6, id: S2, name: A2 }), k2);
        }
        function BSt(c5, s, r5) {
          c5.setAttribute ? c5.setAttribute(s, r5) : c5[s] = r5;
        }
        function Zzt(c5, s) {
          return c5.getAttribute ? c5.getAttribute(s) : c5[s];
        }
        function $zt(c5) {
          return c5 === "auto" ? os.domSupported ? "html" : "richText" : c5 || "html";
        }
        function SK(c5, s) {
          var r5 = Ps(), g5 = [];
          return Ye2(c5, function(b6) {
            var S2 = s(b6);
            (r5.get(S2) || (g5.push(S2), r5.set(S2, []))).push(b6);
          }), { keys: g5, buckets: r5 };
        }
        function Jlt(c5, s, r5, g5, b6) {
          var S2 = s == null || s === "auto";
          if (g5 == null)
            return g5;
          if (Oh2(g5)) {
            var A2 = _K(r5 || 0, g5, b6);
            return c0(A2, S2 ? Math.max(XC(r5 || 0), XC(g5)) : s);
          } else {
            if (gs(g5))
              return b6 < 1 ? r5 : g5;
            for (var k2 = [], R6 = r5, B3 = g5, G3 = Math.max(R6 ? R6.length : 0, B3.length), Z3 = 0; Z3 < G3; ++Z3) {
              var X3 = c5.getDimensionInfo(Z3);
              if (X3 && X3.type === "ordinal")
                k2[Z3] = (b6 < 1 && R6 ? R6 : B3)[Z3];
              else {
                var tt = R6 && R6[Z3] ? R6[Z3] : 0, it = B3[Z3], A2 = _K(tt, it, b6);
                k2[Z3] = c0(A2, S2 ? Math.max(XC(tt), XC(it)) : s);
              }
            }
            return k2;
          }
        }
        var Yzt = ".", Ck = "___EC__COMPONENT__CONTAINER___", tut = "___EC__EXTENDED_CLASS___";
        function Vw(c5) {
          var s = { main: "", sub: "" };
          if (c5) {
            var r5 = c5.split(Yzt);
            s.main = r5[0] || "", s.sub = r5[1] || "";
          }
          return s;
        }
        function eut(c5) {
          lx(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(c5), 'componentType "' + c5 + '" illegal');
        }
        function zSt(c5) {
          return !!(c5 && c5[tut]);
        }
        function MK(c5, s) {
          c5.$constructor = c5, c5.extend = function(r5) {
            var g5 = this, b6;
            return CK(g5) ? b6 = function(S2) {
              wn(A2, S2);
              function A2() {
                return S2.apply(this, arguments) || this;
              }
              return A2;
            }(g5) : (b6 = function() {
              (r5.$constructor || g5).apply(this, arguments);
            }, Qwt(b6, this)), sa2(b6.prototype, r5), b6[tut] = true, b6.extend = this.extend, b6.superCall = Kzt, b6.superApply = jSt, b6.superClass = g5, b6;
          };
        }
        function CK(c5) {
          return Tl(c5) && /^class\s/.test(Function.prototype.toString.call(c5));
        }
        function nut(c5, s) {
          c5.extend = s.extend;
        }
        var FI = Math.round(Math.random() * 10);
        function iR(c5) {
          var s = ["__\0is_clz", FI++].join("_");
          c5.prototype[s] = true, c5.isInstance = function(r5) {
            return !!(r5 && r5[s]);
          };
        }
        function Kzt(c5, s) {
          for (var r5 = [], g5 = 2; g5 < arguments.length; g5++)
            r5[g5 - 2] = arguments[g5];
          return this.superClass.prototype[s].apply(c5, r5);
        }
        function jSt(c5, s, r5) {
          return this.superClass.prototype[s].apply(c5, r5);
        }
        function TK(c5) {
          var s = {};
          c5.registerClass = function(g5) {
            var b6 = g5.type || g5.prototype.type;
            if (b6) {
              eut(b6), g5.prototype.type = b6;
              var S2 = Vw(b6);
              if (!S2.sub)
                s[S2.main] = g5;
              else if (S2.sub !== Ck) {
                var A2 = r5(S2);
                A2[S2.sub] = g5;
              }
            }
            return g5;
          }, c5.getClass = function(g5, b6, S2) {
            var A2 = s[g5];
            if (A2 && A2[Ck] && (A2 = b6 ? A2[b6] : null), S2 && !A2)
              throw new Error(b6 ? "Component " + g5 + "." + (b6 || "") + " is used but not imported." : g5 + ".type should be specified.");
            return A2;
          }, c5.getClassesByMainType = function(g5) {
            var b6 = Vw(g5), S2 = [], A2 = s[b6.main];
            return A2 && A2[Ck] ? Ye2(A2, function(k2, R6) {
              R6 !== Ck && S2.push(k2);
            }) : S2.push(A2), S2;
          }, c5.hasClass = function(g5) {
            var b6 = Vw(g5);
            return !!s[b6.main];
          }, c5.getAllClassMainTypes = function() {
            var g5 = [];
            return Ye2(s, function(b6, S2) {
              g5.push(S2);
            }), g5;
          }, c5.hasSubTypes = function(g5) {
            var b6 = Vw(g5), S2 = s[b6.main];
            return S2 && S2[Ck];
          };
          function r5(g5) {
            var b6 = s[g5.main];
            return (!b6 || !b6[Ck]) && (b6 = s[g5.main] = {}, b6[Ck] = true), b6;
          }
        }
        function aR(c5, s) {
          for (var r5 = 0; r5 < c5.length; r5++)
            c5[r5][1] || (c5[r5][1] = c5[r5][0]);
          return s = s || false, function(g5, b6, S2) {
            for (var A2 = {}, k2 = 0; k2 < c5.length; k2++) {
              var R6 = c5[k2][1];
              if (!(b6 && Lu(b6, R6) >= 0 || S2 && Lu(S2, R6) < 0)) {
                var B3 = g5.getShallow(R6, s);
                B3 != null && (A2[c5[k2][0]] = B3);
              }
            }
            return A2;
          };
        }
        var Xzt = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], Qzt = aR(Xzt), Jzt = function() {
          function c5() {
          }
          return c5.prototype.getAreaStyle = function(s, r5) {
            return Qzt(this, s, r5);
          }, c5;
        }(), rut = new gk2(50);
        function tjt(c5) {
          if (typeof c5 == "string") {
            var s = rut.get(c5);
            return s && s.image;
          } else
            return c5;
        }
        function iut(c5, s, r5, g5, b6) {
          if (c5)
            if (typeof c5 == "string") {
              if (s && s.__zrImageSrc === c5 || !r5)
                return s;
              var S2 = rut.get(c5), A2 = { hostEl: r5, cb: g5, cbPayload: b6 };
              if (S2)
                s = S2.image, !AK(s) && S2.pending.push(A2);
              else {
                var k2 = T0.loadImage(c5, WSt, WSt);
                k2.__zrImageSrc = c5, rut.put(c5, k2.__cachedImgObj = { image: k2, pending: [A2] });
              }
              return s;
            } else
              return c5;
          else
            return s;
        }
        function WSt() {
          var c5 = this.__cachedImgObj;
          this.onload = this.onerror = this.__cachedImgObj = null;
          for (var s = 0; s < c5.pending.length; s++) {
            var r5 = c5.pending[s], g5 = r5.cb;
            g5 && g5(this, r5.cbPayload), r5.hostEl.dirty();
          }
          c5.pending.length = 0;
        }
        function AK(c5) {
          return c5 && c5.width && c5.height;
        }
        var aut = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
        function GSt(c5, s, r5, g5, b6) {
          if (!s)
            return "";
          var S2 = (c5 + "").split(`
`);
          b6 = out2(s, r5, g5, b6);
          for (var A2 = 0, k2 = S2.length; A2 < k2; A2++)
            S2[A2] = sut(S2[A2], b6);
          return S2.join(`
`);
        }
        function out2(c5, s, r5, g5) {
          g5 = g5 || {};
          var b6 = sa2({}, g5);
          b6.font = s, r5 = tc2(r5, "..."), b6.maxIterations = tc2(g5.maxIterations, 2);
          var S2 = b6.minChar = tc2(g5.minChar, 0);
          b6.cnCharWidth = _v("\u56FD", s);
          var A2 = b6.ascCharWidth = _v("a", s);
          b6.placeholder = tc2(g5.placeholder, "");
          for (var k2 = c5 = Math.max(0, c5 - 1), R6 = 0; R6 < S2 && k2 >= A2; R6++)
            k2 -= A2;
          var B3 = _v(r5, s);
          return B3 > k2 && (r5 = "", B3 = 0), k2 = c5 - B3, b6.ellipsis = r5, b6.ellipsisWidth = B3, b6.contentWidth = k2, b6.containerWidth = c5, b6;
        }
        function sut(c5, s) {
          var r5 = s.containerWidth, g5 = s.font, b6 = s.contentWidth;
          if (!r5)
            return "";
          var S2 = _v(c5, g5);
          if (S2 <= r5)
            return c5;
          for (var A2 = 0; ; A2++) {
            if (S2 <= b6 || A2 >= s.maxIterations) {
              c5 += s.ellipsis;
              break;
            }
            var k2 = A2 === 0 ? ejt(c5, b6, s.ascCharWidth, s.cnCharWidth) : S2 > 0 ? Math.floor(c5.length * b6 / S2) : 0;
            c5 = c5.substr(0, k2), S2 = _v(c5, g5);
          }
          return c5 === "" && (c5 = s.placeholder), c5;
        }
        function ejt(c5, s, r5, g5) {
          for (var b6 = 0, S2 = 0, A2 = c5.length; S2 < A2 && b6 < s; S2++) {
            var k2 = c5.charCodeAt(S2);
            b6 += 0 <= k2 && k2 <= 127 ? r5 : g5;
          }
          return S2;
        }
        function njt(c5, s) {
          c5 != null && (c5 += "");
          var r5 = s.overflow, g5 = s.padding, b6 = s.font, S2 = r5 === "truncate", A2 = Lj2(b6), k2 = tc2(s.lineHeight, A2), R6 = !!s.backgroundColor, B3 = s.lineOverflow === "truncate", G3 = s.width, Z3;
          G3 != null && (r5 === "break" || r5 === "breakAll") ? Z3 = c5 ? p22(c5, s.font, G3, r5 === "breakAll", 0).lines : [] : Z3 = c5 ? c5.split(`
`) : [];
          var X3 = Z3.length * k2, tt = tc2(s.height, X3);
          if (X3 > tt && B3) {
            var it = Math.floor(tt / k2);
            Z3 = Z3.slice(0, it);
          }
          if (c5 && S2 && G3 != null)
            for (var pt = out2(G3, b6, s.ellipsis, { minChar: s.truncateMinChar, placeholder: s.placeholder }), mt = 0; mt < Z3.length; mt++)
              Z3[mt] = sut(Z3[mt], pt);
          for (var Mt = tt, kt = 0, mt = 0; mt < Z3.length; mt++)
            kt = Math.max(_v(Z3[mt], b6), kt);
          G3 == null && (G3 = kt);
          var Gt = kt;
          return g5 && (Mt += g5[0] + g5[2], Gt += g5[1] + g5[3], G3 += g5[1] + g5[3]), R6 && (Gt = G3), { lines: Z3, height: tt, outerWidth: Gt, outerHeight: Mt, lineHeight: k2, calculatedLineHeight: A2, contentWidth: kt, contentHeight: X3, width: G3 };
        }
        var rjt = function() {
          function c5() {
          }
          return c5;
        }(), lut = function() {
          function c5(s) {
            this.tokens = [], s && (this.tokens = s);
          }
          return c5;
        }(), ijt = function() {
          function c5() {
            this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
          }
          return c5;
        }();
        function ajt(c5, s) {
          var r5 = new ijt();
          if (c5 != null && (c5 += ""), !c5)
            return r5;
          for (var g5 = s.width, b6 = s.height, S2 = s.overflow, A2 = (S2 === "break" || S2 === "breakAll") && g5 != null ? { width: g5, accumWidth: 0, breakAll: S2 === "breakAll" } : null, k2 = aut.lastIndex = 0, R6; (R6 = aut.exec(c5)) != null; ) {
            var B3 = R6.index;
            B3 > k2 && uut(r5, c5.substring(k2, B3), s, A2), uut(r5, R6[2], s, A2, R6[1]), k2 = aut.lastIndex;
          }
          k2 < c5.length && uut(r5, c5.substring(k2, c5.length), s, A2);
          var G3 = [], Z3 = 0, X3 = 0, tt = s.padding, it = S2 === "truncate", pt = s.lineOverflow === "truncate";
          function mt(Qn, rr, Ar) {
            Qn.width = rr, Qn.lineHeight = Ar, Z3 += Ar, X3 = Math.max(X3, rr);
          }
          t:
            for (var Mt = 0; Mt < r5.lines.length; Mt++) {
              for (var kt = r5.lines[Mt], Gt = 0, Ot = 0, ce2 = 0; ce2 < kt.tokens.length; ce2++) {
                var ae2 = kt.tokens[ce2], de2 = ae2.styleName && s.rich[ae2.styleName] || {}, we2 = ae2.textPadding = de2.padding, Se2 = we2 ? we2[1] + we2[3] : 0, Oe2 = ae2.font = de2.font || s.font;
                ae2.contentHeight = Lj2(Oe2);
                var je2 = tc2(de2.height, ae2.contentHeight);
                if (ae2.innerHeight = je2, we2 && (je2 += we2[0] + we2[2]), ae2.height = je2, ae2.lineHeight = pk2(de2.lineHeight, s.lineHeight, je2), ae2.align = de2 && de2.align || s.align, ae2.verticalAlign = de2 && de2.verticalAlign || "middle", pt && b6 != null && Z3 + ae2.lineHeight > b6) {
                  ce2 > 0 ? (kt.tokens = kt.tokens.slice(0, ce2), mt(kt, Ot, Gt), r5.lines = r5.lines.slice(0, Mt + 1)) : r5.lines = r5.lines.slice(0, Mt);
                  break t;
                }
                var rn = de2.width, qe2 = rn == null || rn === "auto";
                if (typeof rn == "string" && rn.charAt(rn.length - 1) === "%")
                  ae2.percentWidth = rn, G3.push(ae2), ae2.contentWidth = _v(ae2.text, Oe2);
                else {
                  if (qe2) {
                    var An = de2.backgroundColor, jn = An && An.image;
                    jn && (jn = tjt(jn), AK(jn) && (ae2.width = Math.max(ae2.width, jn.width * je2 / jn.height)));
                  }
                  var _n = it && g5 != null ? g5 - Ot : null;
                  _n != null && _n < ae2.width ? !qe2 || _n < Se2 ? (ae2.text = "", ae2.width = ae2.contentWidth = 0) : (ae2.text = GSt(ae2.text, _n - Se2, Oe2, s.ellipsis, { minChar: s.truncateMinChar }), ae2.width = ae2.contentWidth = _v(ae2.text, Oe2)) : ae2.contentWidth = _v(ae2.text, Oe2);
                }
                ae2.width += Se2, Ot += ae2.width, de2 && (Gt = Math.max(Gt, ae2.lineHeight));
              }
              mt(kt, Ot, Gt);
            }
          r5.outerWidth = r5.width = tc2(g5, X3), r5.outerHeight = r5.height = tc2(b6, Z3), r5.contentHeight = Z3, r5.contentWidth = X3, tt && (r5.outerWidth += tt[1] + tt[3], r5.outerHeight += tt[0] + tt[2]);
          for (var Mt = 0; Mt < G3.length; Mt++) {
            var ae2 = G3[Mt], Jr = ae2.percentWidth;
            ae2.width = parseInt(Jr, 10) / 100 * r5.width;
          }
          return r5;
        }
        function uut(c5, s, r5, g5, b6) {
          var S2 = s === "", A2 = b6 && r5.rich[b6] || {}, k2 = c5.lines, R6 = A2.font || r5.font, B3 = false, G3, Z3;
          if (g5) {
            var X3 = A2.padding, tt = X3 ? X3[1] + X3[3] : 0;
            if (A2.width != null && A2.width !== "auto") {
              var it = f22(A2.width, g5.width) + tt;
              k2.length > 0 && it + g5.accumWidth > g5.width && (G3 = s.split(`
`), B3 = true), g5.accumWidth = it;
            } else {
              var pt = p22(s, R6, g5.width, g5.breakAll, g5.accumWidth);
              g5.accumWidth = pt.accumWidth + tt, Z3 = pt.linesWidths, G3 = pt.lines;
            }
          } else
            G3 = s.split(`
`);
          for (var mt = 0; mt < G3.length; mt++) {
            var Mt = G3[mt], kt = new rjt();
            if (kt.styleName = b6, kt.text = Mt, kt.isLineHolder = !Mt && !S2, typeof A2.width == "number" ? kt.width = A2.width : kt.width = Z3 ? Z3[mt] : _v(Mt, R6), !mt && !B3) {
              var Gt = (k2[k2.length - 1] || (k2[0] = new lut())).tokens, Ot = Gt.length;
              Ot === 1 && Gt[0].isLineHolder ? Gt[0] = kt : (Mt || !Ot || S2) && Gt.push(kt);
            } else
              k2.push(new lut([kt]));
          }
        }
        function ojt(c5) {
          var s = c5.charCodeAt(0);
          return s >= 33 && s <= 383;
        }
        var sjt = VC(",&?/;] ".split(""), function(c5, s) {
          return c5[s] = true, c5;
        }, {});
        function ljt(c5) {
          return ojt(c5) ? !!sjt[c5] : true;
        }
        function p22(c5, s, r5, g5, b6) {
          for (var S2 = [], A2 = [], k2 = "", R6 = "", B3 = 0, G3 = 0, Z3 = 0; Z3 < c5.length; Z3++) {
            var X3 = c5.charAt(Z3);
            if (X3 === `
`) {
              R6 && (k2 += R6, G3 += B3), S2.push(k2), A2.push(G3), k2 = "", R6 = "", B3 = 0, G3 = 0;
              continue;
            }
            var tt = _v(X3, s), it = g5 ? false : !ljt(X3);
            if (S2.length ? G3 + tt > r5 : b6 + G3 + tt > r5) {
              G3 ? (k2 || R6) && (it ? (k2 || (k2 = R6, R6 = "", B3 = 0, G3 = B3), S2.push(k2), A2.push(G3 - B3), R6 += X3, B3 += tt, k2 = "", G3 = B3) : (R6 && (k2 += R6, R6 = "", B3 = 0), S2.push(k2), A2.push(G3), k2 = X3, G3 = tt)) : it ? (S2.push(R6), A2.push(B3), R6 = X3, B3 = tt) : (S2.push(X3), A2.push(tt));
              continue;
            }
            G3 += tt, it ? (R6 += X3, B3 += tt) : (R6 && (k2 += R6, R6 = "", B3 = 0), k2 += X3);
          }
          return !S2.length && !k2 && (k2 = c5, R6 = "", B3 = 0), R6 && (k2 += R6), k2 && (S2.push(k2), A2.push(G3)), S2.length === 1 && (G3 += b6), { accumWidth: G3, lines: S2, linesWidths: A2 };
        }
        var cut = "__zr_style_" + Math.round(Math.random() * 10), oR = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, IK = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
        oR[cut] = true;
        var fut = ["z", "z2", "invisible"], ujt = ["invisible"], cjt = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype._init = function(r5) {
            for (var g5 = nf2(r5), b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6];
              S2 === "style" ? this.useStyle(r5[S2]) : c5.prototype.attrKV.call(this, S2, r5[S2]);
            }
            this.style || this.useStyle({});
          }, s.prototype.beforeBrush = function() {
          }, s.prototype.afterBrush = function() {
          }, s.prototype.innerBeforeBrush = function() {
          }, s.prototype.innerAfterBrush = function() {
          }, s.prototype.shouldBePainted = function(r5, g5, b6, S2) {
            var A2 = this.transform;
            if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && dut(this, r5, g5) || A2 && !A2[0] && !A2[3])
              return false;
            if (b6 && this.__clipPaths) {
              for (var k2 = 0; k2 < this.__clipPaths.length; ++k2)
                if (this.__clipPaths[k2].isZeroArea())
                  return false;
            }
            if (S2 && this.parent)
              for (var R6 = this.parent; R6; ) {
                if (R6.ignore)
                  return false;
                R6 = R6.parent;
              }
            return true;
          }, s.prototype.contain = function(r5, g5) {
            return this.rectContain(r5, g5);
          }, s.prototype.traverse = function(r5, g5) {
            r5.call(g5, this);
          }, s.prototype.rectContain = function(r5, g5) {
            var b6 = this.transformCoordToLocal(r5, g5), S2 = this.getBoundingRect();
            return S2.contain(b6[0], b6[1]);
          }, s.prototype.getPaintRect = function() {
            var r5 = this._paintRect;
            if (!this._paintRect || this.__dirty) {
              var g5 = this.transform, b6 = this.getBoundingRect(), S2 = this.style, A2 = S2.shadowBlur || 0, k2 = S2.shadowOffsetX || 0, R6 = S2.shadowOffsetY || 0;
              r5 = this._paintRect || (this._paintRect = new lc2(0, 0, 0, 0)), g5 ? lc2.applyTransform(r5, b6, g5) : r5.copy(b6), (A2 || k2 || R6) && (r5.width += A2 * 2 + Math.abs(k2), r5.height += A2 * 2 + Math.abs(R6), r5.x = Math.min(r5.x, r5.x + k2 - A2), r5.y = Math.min(r5.y, r5.y + R6 - A2));
              var B3 = this.dirtyRectTolerance;
              r5.isZero() || (r5.x = Math.floor(r5.x - B3), r5.y = Math.floor(r5.y - B3), r5.width = Math.ceil(r5.width + 1 + B3 * 2), r5.height = Math.ceil(r5.height + 1 + B3 * 2));
            }
            return r5;
          }, s.prototype.setPrevPaintRect = function(r5) {
            r5 ? (this._prevPaintRect = this._prevPaintRect || new lc2(0, 0, 0, 0), this._prevPaintRect.copy(r5)) : this._prevPaintRect = null;
          }, s.prototype.getPrevPaintRect = function() {
            return this._prevPaintRect;
          }, s.prototype.animateStyle = function(r5) {
            return this.animate("style", r5);
          }, s.prototype.updateDuringAnimation = function(r5) {
            r5 === "style" ? this.dirtyStyle() : this.markRedraw();
          }, s.prototype.attrKV = function(r5, g5) {
            r5 !== "style" ? c5.prototype.attrKV.call(this, r5, g5) : this.style ? this.setStyle(g5) : this.useStyle(g5);
          }, s.prototype.setStyle = function(r5, g5) {
            return typeof r5 == "string" ? this.style[r5] = g5 : sa2(this.style, r5), this.dirtyStyle(), this;
          }, s.prototype.dirtyStyle = function(r5) {
            r5 || this.markRedraw(), this.__dirty |= mj2, this._rect && (this._rect = null);
          }, s.prototype.dirty = function() {
            this.dirtyStyle();
          }, s.prototype.styleChanged = function() {
            return !!(this.__dirty & mj2);
          }, s.prototype.styleUpdated = function() {
            this.__dirty &= ~mj2;
          }, s.prototype.createStyle = function(r5) {
            return hj2(oR, r5);
          }, s.prototype.useStyle = function(r5) {
            r5[cut] || (r5 = this.createStyle(r5)), this.__inHover ? this.__hoverStyle = r5 : this.style = r5, this.dirtyStyle();
          }, s.prototype.isStyleObject = function(r5) {
            return r5[cut];
          }, s.prototype._innerSaveToNormal = function(r5) {
            c5.prototype._innerSaveToNormal.call(this, r5);
            var g5 = this._normalState;
            r5.style && !g5.style && (g5.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(r5, g5, fut);
          }, s.prototype._applyStateObj = function(r5, g5, b6, S2, A2, k2) {
            c5.prototype._applyStateObj.call(this, r5, g5, b6, S2, A2, k2);
            var R6 = !(g5 && S2), B3;
            if (g5 && g5.style ? A2 ? S2 ? B3 = g5.style : (B3 = this._mergeStyle(this.createStyle(), b6.style), this._mergeStyle(B3, g5.style)) : (B3 = this._mergeStyle(this.createStyle(), S2 ? this.style : b6.style), this._mergeStyle(B3, g5.style)) : R6 && (B3 = b6.style), B3)
              if (A2) {
                var G3 = this.style;
                if (this.style = this.createStyle(R6 ? {} : G3), R6)
                  for (var Z3 = nf2(G3), X3 = 0; X3 < Z3.length; X3++) {
                    var tt = Z3[X3];
                    tt in B3 && (B3[tt] = B3[tt], this.style[tt] = G3[tt]);
                  }
                for (var it = nf2(B3), X3 = 0; X3 < it.length; X3++) {
                  var tt = it[X3];
                  this.style[tt] = this.style[tt];
                }
                this._transitionState(r5, { style: B3 }, k2, this.getAnimationStyleProps());
              } else
                this.useStyle(B3);
            for (var pt = this.__inHover ? ujt : fut, X3 = 0; X3 < pt.length; X3++) {
              var tt = pt[X3];
              g5 && g5[tt] != null ? this[tt] = g5[tt] : R6 && b6[tt] != null && (this[tt] = b6[tt]);
            }
          }, s.prototype._mergeStates = function(r5) {
            for (var g5 = c5.prototype._mergeStates.call(this, r5), b6, S2 = 0; S2 < r5.length; S2++) {
              var A2 = r5[S2];
              A2.style && (b6 = b6 || {}, this._mergeStyle(b6, A2.style));
            }
            return b6 && (g5.style = b6), g5;
          }, s.prototype._mergeStyle = function(r5, g5) {
            return sa2(r5, g5), r5;
          }, s.prototype.getAnimationStyleProps = function() {
            return IK;
          }, s.initDefaultProps = function() {
            var r5 = s.prototype;
            r5.type = "displayable", r5.invisible = false, r5.z = 0, r5.z2 = 0, r5.zlevel = 0, r5.culling = false, r5.cursor = "pointer", r5.rectHover = false, r5.incremental = false, r5._rect = null, r5.dirtyRectTolerance = 0, r5.__dirty = Vb2 | mj2;
          }(), s;
        }(DSt), hut = new lc2(0, 0, 0, 0), put = new lc2(0, 0, 0, 0);
        function dut(c5, s, r5) {
          return hut.copy(c5.getBoundingRect()), c5.transform && hut.applyTransform(c5.transform), put.width = s, put.height = r5, !hut.intersect(put);
        }
        var SM = cjt, Bw = Math.min, zw = Math.max, gut = Math.sin, vut = Math.cos, sR = Math.PI * 2, DK = nm(), EK = nm(), kK = nm();
        function PK(c5, s, r5) {
          if (c5.length !== 0) {
            for (var g5 = c5[0], b6 = g5[0], S2 = g5[0], A2 = g5[1], k2 = g5[1], R6 = 1; R6 < c5.length; R6++)
              g5 = c5[R6], b6 = Bw(b6, g5[0]), S2 = zw(S2, g5[0]), A2 = Bw(A2, g5[1]), k2 = zw(k2, g5[1]);
            s[0] = b6, s[1] = A2, r5[0] = S2, r5[1] = k2;
          }
        }
        function HSt(c5, s, r5, g5, b6, S2) {
          b6[0] = Bw(c5, r5), b6[1] = Bw(s, g5), S2[0] = zw(c5, r5), S2[1] = zw(s, g5);
        }
        var USt = [], qSt = [];
        function fjt(c5, s, r5, g5, b6, S2, A2, k2, R6, B3) {
          var G3 = hSt, Z3 = D0, X3 = G3(c5, r5, b6, A2, USt);
          R6[0] = 1 / 0, R6[1] = 1 / 0, B3[0] = -1 / 0, B3[1] = -1 / 0;
          for (var tt = 0; tt < X3; tt++) {
            var it = Z3(c5, r5, b6, A2, USt[tt]);
            R6[0] = Bw(it, R6[0]), B3[0] = zw(it, B3[0]);
          }
          X3 = G3(s, g5, S2, k2, qSt);
          for (var tt = 0; tt < X3; tt++) {
            var pt = Z3(s, g5, S2, k2, qSt[tt]);
            R6[1] = Bw(pt, R6[1]), B3[1] = zw(pt, B3[1]);
          }
          R6[0] = Bw(c5, R6[0]), B3[0] = zw(c5, B3[0]), R6[0] = Bw(A2, R6[0]), B3[0] = zw(A2, B3[0]), R6[1] = Bw(s, R6[1]), B3[1] = zw(s, B3[1]), R6[1] = Bw(k2, R6[1]), B3[1] = zw(k2, B3[1]);
        }
        function hjt(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6 = pSt, B3 = Hm, G3 = zw(Bw(R6(c5, r5, b6), 1), 0), Z3 = zw(Bw(R6(s, g5, S2), 1), 0), X3 = B3(c5, r5, b6, G3), tt = B3(s, g5, S2, Z3);
          A2[0] = Bw(c5, b6, X3), A2[1] = Bw(s, S2, tt), k2[0] = zw(c5, b6, X3), k2[1] = zw(s, S2, tt);
        }
        function pjt(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          var B3 = BC, G3 = c2, Z3 = Math.abs(b6 - S2);
          if (Z3 % sR < 1e-4 && Z3 > 1e-4) {
            k2[0] = c5 - r5, k2[1] = s - g5, R6[0] = c5 + r5, R6[1] = s + g5;
            return;
          }
          if (DK[0] = vut(b6) * r5 + c5, DK[1] = gut(b6) * g5 + s, EK[0] = vut(S2) * r5 + c5, EK[1] = gut(S2) * g5 + s, B3(k2, DK, EK), G3(R6, DK, EK), b6 = b6 % sR, b6 < 0 && (b6 = b6 + sR), S2 = S2 % sR, S2 < 0 && (S2 = S2 + sR), b6 > S2 && !A2 ? S2 += sR : b6 < S2 && A2 && (b6 += sR), A2) {
            var X3 = S2;
            S2 = b6, b6 = X3;
          }
          for (var tt = 0; tt < S2; tt += Math.PI / 2)
            tt > b6 && (kK[0] = vut(tt) * r5 + c5, kK[1] = gut(tt) * g5 + s, B3(k2, kK, k2), G3(R6, kK, R6));
        }
        var Cd2 = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, lR = [], uR = [], VI = [], BI = [], tT = [], zI = [], yut = Math.min, mut = Math.max, cR = Math.cos, fR = Math.sin, Tk = Math.abs, but = Math.PI, b3 = but * 2, LK = typeof Float32Array != "undefined", Hj2 = [];
        function z8(c5) {
          var s = Math.round(c5 / but * 1e8) / 1e8;
          return s % 2 * but;
        }
        function djt(c5, s) {
          var r5 = z8(c5[0]);
          r5 < 0 && (r5 += b3);
          var g5 = r5 - c5[0], b6 = c5[1];
          b6 += g5, !s && b6 - r5 >= b3 ? b6 = r5 + b3 : s && r5 - b6 >= b3 ? b6 = r5 - b3 : !s && r5 > b6 ? b6 = r5 + (b3 - z8(r5 - b6)) : s && r5 < b6 && (b6 = r5 - (b3 - z8(b6 - r5))), c5[0] = r5, c5[1] = b6;
        }
        var gjt = function() {
          function c5(s) {
            this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, s && (this._saveData = false), this._saveData && (this.data = []);
          }
          return c5.prototype.increaseVersion = function() {
            this._version++;
          }, c5.prototype.getVersion = function() {
            return this._version;
          }, c5.prototype.setScale = function(s, r5, g5) {
            g5 = g5 || 0, g5 > 0 && (this._ux = Tk(g5 / uK / s) || 0, this._uy = Tk(g5 / uK / r5) || 0);
          }, c5.prototype.setDPR = function(s) {
            this.dpr = s;
          }, c5.prototype.setContext = function(s) {
            this._ctx = s;
          }, c5.prototype.getContext = function() {
            return this._ctx;
          }, c5.prototype.beginPath = function() {
            return this._ctx && this._ctx.beginPath(), this.reset(), this;
          }, c5.prototype.reset = function() {
            this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
          }, c5.prototype.moveTo = function(s, r5) {
            return this._drawPendingPt(), this.addData(Cd2.M, s, r5), this._ctx && this._ctx.moveTo(s, r5), this._x0 = s, this._y0 = r5, this._xi = s, this._yi = r5, this;
          }, c5.prototype.lineTo = function(s, r5) {
            var g5 = Tk(s - this._xi), b6 = Tk(r5 - this._yi), S2 = g5 > this._ux || b6 > this._uy;
            if (this.addData(Cd2.L, s, r5), this._ctx && S2 && this._ctx.lineTo(s, r5), S2)
              this._xi = s, this._yi = r5, this._pendingPtDist = 0;
            else {
              var A2 = g5 * g5 + b6 * b6;
              A2 > this._pendingPtDist && (this._pendingPtX = s, this._pendingPtY = r5, this._pendingPtDist = A2);
            }
            return this;
          }, c5.prototype.bezierCurveTo = function(s, r5, g5, b6, S2, A2) {
            return this._drawPendingPt(), this.addData(Cd2.C, s, r5, g5, b6, S2, A2), this._ctx && this._ctx.bezierCurveTo(s, r5, g5, b6, S2, A2), this._xi = S2, this._yi = A2, this;
          }, c5.prototype.quadraticCurveTo = function(s, r5, g5, b6) {
            return this._drawPendingPt(), this.addData(Cd2.Q, s, r5, g5, b6), this._ctx && this._ctx.quadraticCurveTo(s, r5, g5, b6), this._xi = g5, this._yi = b6, this;
          }, c5.prototype.arc = function(s, r5, g5, b6, S2, A2) {
            this._drawPendingPt(), Hj2[0] = b6, Hj2[1] = S2, djt(Hj2, A2), b6 = Hj2[0], S2 = Hj2[1];
            var k2 = S2 - b6;
            return this.addData(Cd2.A, s, r5, g5, g5, b6, k2, 0, A2 ? 0 : 1), this._ctx && this._ctx.arc(s, r5, g5, b6, S2, A2), this._xi = cR(S2) * g5 + s, this._yi = fR(S2) * g5 + r5, this;
          }, c5.prototype.arcTo = function(s, r5, g5, b6, S2) {
            return this._drawPendingPt(), this._ctx && this._ctx.arcTo(s, r5, g5, b6, S2), this;
          }, c5.prototype.rect = function(s, r5, g5, b6) {
            return this._drawPendingPt(), this._ctx && this._ctx.rect(s, r5, g5, b6), this.addData(Cd2.R, s, r5, g5, b6), this;
          }, c5.prototype.closePath = function() {
            this._drawPendingPt(), this.addData(Cd2.Z);
            var s = this._ctx, r5 = this._x0, g5 = this._y0;
            return s && s.closePath(), this._xi = r5, this._yi = g5, this;
          }, c5.prototype.fill = function(s) {
            s && s.fill(), this.toStatic();
          }, c5.prototype.stroke = function(s) {
            s && s.stroke(), this.toStatic();
          }, c5.prototype.len = function() {
            return this._len;
          }, c5.prototype.setData = function(s) {
            var r5 = s.length;
            !(this.data && this.data.length === r5) && LK && (this.data = new Float32Array(r5));
            for (var g5 = 0; g5 < r5; g5++)
              this.data[g5] = s[g5];
            this._len = r5;
          }, c5.prototype.appendPath = function(s) {
            s instanceof Array || (s = [s]);
            for (var r5 = s.length, g5 = 0, b6 = this._len, S2 = 0; S2 < r5; S2++)
              g5 += s[S2].len();
            LK && this.data instanceof Float32Array && (this.data = new Float32Array(b6 + g5));
            for (var S2 = 0; S2 < r5; S2++)
              for (var A2 = s[S2].data, k2 = 0; k2 < A2.length; k2++)
                this.data[b6++] = A2[k2];
            this._len = b6;
          }, c5.prototype.addData = function(s, r5, g5, b6, S2, A2, k2, R6, B3) {
            if (this._saveData) {
              var G3 = this.data;
              this._len + arguments.length > G3.length && (this._expandData(), G3 = this.data);
              for (var Z3 = 0; Z3 < arguments.length; Z3++)
                G3[this._len++] = arguments[Z3];
            }
          }, c5.prototype._drawPendingPt = function() {
            this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
          }, c5.prototype._expandData = function() {
            if (!(this.data instanceof Array)) {
              for (var s = [], r5 = 0; r5 < this._len; r5++)
                s[r5] = this.data[r5];
              this.data = s;
            }
          }, c5.prototype.toStatic = function() {
            if (this._saveData) {
              this._drawPendingPt();
              var s = this.data;
              s instanceof Array && (s.length = this._len, LK && this._len > 11 && (this.data = new Float32Array(s)));
            }
          }, c5.prototype.getBoundingRect = function() {
            VI[0] = VI[1] = tT[0] = tT[1] = Number.MAX_VALUE, BI[0] = BI[1] = zI[0] = zI[1] = -Number.MAX_VALUE;
            var s = this.data, r5 = 0, g5 = 0, b6 = 0, S2 = 0, A2;
            for (A2 = 0; A2 < this._len; ) {
              var k2 = s[A2++], R6 = A2 === 1;
              switch (R6 && (r5 = s[A2], g5 = s[A2 + 1], b6 = r5, S2 = g5), k2) {
                case Cd2.M:
                  r5 = b6 = s[A2++], g5 = S2 = s[A2++], tT[0] = b6, tT[1] = S2, zI[0] = b6, zI[1] = S2;
                  break;
                case Cd2.L:
                  HSt(r5, g5, s[A2], s[A2 + 1], tT, zI), r5 = s[A2++], g5 = s[A2++];
                  break;
                case Cd2.C:
                  fjt(r5, g5, s[A2++], s[A2++], s[A2++], s[A2++], s[A2], s[A2 + 1], tT, zI), r5 = s[A2++], g5 = s[A2++];
                  break;
                case Cd2.Q:
                  hjt(r5, g5, s[A2++], s[A2++], s[A2], s[A2 + 1], tT, zI), r5 = s[A2++], g5 = s[A2++];
                  break;
                case Cd2.A:
                  var B3 = s[A2++], G3 = s[A2++], Z3 = s[A2++], X3 = s[A2++], tt = s[A2++], it = s[A2++] + tt;
                  A2 += 1;
                  var pt = !s[A2++];
                  R6 && (b6 = cR(tt) * Z3 + B3, S2 = fR(tt) * X3 + G3), pjt(B3, G3, Z3, X3, tt, it, pt, tT, zI), r5 = cR(it) * Z3 + B3, g5 = fR(it) * X3 + G3;
                  break;
                case Cd2.R:
                  b6 = r5 = s[A2++], S2 = g5 = s[A2++];
                  var mt = s[A2++], Mt = s[A2++];
                  HSt(b6, S2, b6 + mt, S2 + Mt, tT, zI);
                  break;
                case Cd2.Z:
                  r5 = b6, g5 = S2;
                  break;
              }
              BC(VI, VI, tT), c2(BI, BI, zI);
            }
            return A2 === 0 && (VI[0] = VI[1] = BI[0] = BI[1] = 0), new lc2(VI[0], VI[1], BI[0] - VI[0], BI[1] - VI[1]);
          }, c5.prototype._calculateLength = function() {
            var s = this.data, r5 = this._len, g5 = this._ux, b6 = this._uy, S2 = 0, A2 = 0, k2 = 0, R6 = 0;
            this._pathSegLen || (this._pathSegLen = []);
            for (var B3 = this._pathSegLen, G3 = 0, Z3 = 0, X3 = 0; X3 < r5; ) {
              var tt = s[X3++], it = X3 === 1;
              it && (S2 = s[X3], A2 = s[X3 + 1], k2 = S2, R6 = A2);
              var pt = -1;
              switch (tt) {
                case Cd2.M:
                  S2 = k2 = s[X3++], A2 = R6 = s[X3++];
                  break;
                case Cd2.L: {
                  var mt = s[X3++], Mt = s[X3++], kt = mt - S2, Gt = Mt - A2;
                  (Tk(kt) > g5 || Tk(Gt) > b6 || X3 === r5 - 1) && (pt = Math.sqrt(kt * kt + Gt * Gt), S2 = mt, A2 = Mt);
                  break;
                }
                case Cd2.C: {
                  var Ot = s[X3++], ce2 = s[X3++], mt = s[X3++], Mt = s[X3++], ae2 = s[X3++], de2 = s[X3++];
                  pt = vlt(S2, A2, Ot, ce2, mt, Mt, ae2, de2, 10), S2 = ae2, A2 = de2;
                  break;
                }
                case Cd2.Q: {
                  var Ot = s[X3++], ce2 = s[X3++], mt = s[X3++], Mt = s[X3++];
                  pt = _zt(S2, A2, Ot, ce2, mt, Mt, 10), S2 = mt, A2 = Mt;
                  break;
                }
                case Cd2.A:
                  var we2 = s[X3++], Se2 = s[X3++], Oe2 = s[X3++], je2 = s[X3++], rn = s[X3++], qe2 = s[X3++], An = qe2 + rn;
                  X3 += 1, s[X3++], it && (k2 = cR(rn) * Oe2 + we2, R6 = fR(rn) * je2 + Se2), pt = mut(Oe2, je2) * yut(b3, Math.abs(qe2)), S2 = cR(An) * Oe2 + we2, A2 = fR(An) * je2 + Se2;
                  break;
                case Cd2.R: {
                  k2 = S2 = s[X3++], R6 = A2 = s[X3++];
                  var jn = s[X3++], _n = s[X3++];
                  pt = jn * 2 + _n * 2;
                  break;
                }
                case Cd2.Z: {
                  var kt = k2 - S2, Gt = R6 - A2;
                  pt = Math.sqrt(kt * kt + Gt * Gt), S2 = k2, A2 = R6;
                  break;
                }
              }
              pt >= 0 && (B3[Z3++] = pt, G3 += pt);
            }
            return this._pathLen = G3, G3;
          }, c5.prototype.rebuildPath = function(s, r5) {
            var g5 = this.data, b6 = this._ux, S2 = this._uy, A2 = this._len, k2, R6, B3, G3, Z3, X3, tt = r5 < 1, it, pt, mt = 0, Mt = 0, kt, Gt = 0, Ot, ce2;
            if (tt && (this._pathSegLen || this._calculateLength(), it = this._pathSegLen, pt = this._pathLen, kt = r5 * pt, !kt))
              return;
            t:
              for (var ae2 = 0; ae2 < A2; ) {
                var de2 = g5[ae2++], we2 = ae2 === 1;
                switch (we2 && (B3 = g5[ae2], G3 = g5[ae2 + 1], k2 = B3, R6 = G3), de2 !== Cd2.L && Gt > 0 && (s.lineTo(Ot, ce2), Gt = 0), de2) {
                  case Cd2.M:
                    k2 = B3 = g5[ae2++], R6 = G3 = g5[ae2++], s.moveTo(B3, G3);
                    break;
                  case Cd2.L: {
                    Z3 = g5[ae2++], X3 = g5[ae2++];
                    var Se2 = Tk(Z3 - B3), Oe2 = Tk(X3 - G3);
                    if (Se2 > b6 || Oe2 > S2) {
                      if (tt) {
                        var je2 = it[Mt++];
                        if (mt + je2 > kt) {
                          var rn = (kt - mt) / je2;
                          s.lineTo(B3 * (1 - rn) + Z3 * rn, G3 * (1 - rn) + X3 * rn);
                          break t;
                        }
                        mt += je2;
                      }
                      s.lineTo(Z3, X3), B3 = Z3, G3 = X3, Gt = 0;
                    } else {
                      var qe2 = Se2 * Se2 + Oe2 * Oe2;
                      qe2 > Gt && (Ot = Z3, ce2 = X3, Gt = qe2);
                    }
                    break;
                  }
                  case Cd2.C: {
                    var An = g5[ae2++], jn = g5[ae2++], _n = g5[ae2++], Jr = g5[ae2++], Qn = g5[ae2++], rr = g5[ae2++];
                    if (tt) {
                      var je2 = it[Mt++];
                      if (mt + je2 > kt) {
                        var rn = (kt - mt) / je2;
                        GC(B3, An, _n, Qn, rn, lR), GC(G3, jn, Jr, rr, rn, uR), s.bezierCurveTo(lR[1], uR[1], lR[2], uR[2], lR[3], uR[3]);
                        break t;
                      }
                      mt += je2;
                    }
                    s.bezierCurveTo(An, jn, _n, Jr, Qn, rr), B3 = Qn, G3 = rr;
                    break;
                  }
                  case Cd2.Q: {
                    var An = g5[ae2++], jn = g5[ae2++], _n = g5[ae2++], Jr = g5[ae2++];
                    if (tt) {
                      var je2 = it[Mt++];
                      if (mt + je2 > kt) {
                        var rn = (kt - mt) / je2;
                        u0(B3, An, _n, rn, lR), u0(G3, jn, Jr, rn, uR), s.quadraticCurveTo(lR[1], uR[1], lR[2], uR[2]);
                        break t;
                      }
                      mt += je2;
                    }
                    s.quadraticCurveTo(An, jn, _n, Jr), B3 = _n, G3 = Jr;
                    break;
                  }
                  case Cd2.A:
                    var Ar = g5[ae2++], fi2 = g5[ae2++], mi2 = g5[ae2++], Oo = g5[ae2++], Ts = g5[ae2++], gl = g5[ae2++], nl = g5[ae2++], rl = !g5[ae2++], ss = mi2 > Oo ? mi2 : Oo, Us = Tk(mi2 - Oo) > 1e-3, sl = Ts + gl, ws = false;
                    if (tt) {
                      var je2 = it[Mt++];
                      mt + je2 > kt && (sl = Ts + gl * (kt - mt) / je2, ws = true), mt += je2;
                    }
                    if (Us && s.ellipse ? s.ellipse(Ar, fi2, mi2, Oo, nl, Ts, sl, rl) : s.arc(Ar, fi2, ss, Ts, sl, rl), ws)
                      break t;
                    we2 && (k2 = cR(Ts) * mi2 + Ar, R6 = fR(Ts) * Oo + fi2), B3 = cR(sl) * mi2 + Ar, G3 = fR(sl) * Oo + fi2;
                    break;
                  case Cd2.R:
                    k2 = B3 = g5[ae2], R6 = G3 = g5[ae2 + 1], Z3 = g5[ae2++], X3 = g5[ae2++];
                    var Ll = g5[ae2++], dh2 = g5[ae2++];
                    if (tt) {
                      var je2 = it[Mt++];
                      if (mt + je2 > kt) {
                        var hu = kt - mt;
                        s.moveTo(Z3, X3), s.lineTo(Z3 + yut(hu, Ll), X3), hu -= Ll, hu > 0 && s.lineTo(Z3 + Ll, X3 + yut(hu, dh2)), hu -= dh2, hu > 0 && s.lineTo(Z3 + mut(Ll - hu, 0), X3 + dh2), hu -= Ll, hu > 0 && s.lineTo(Z3, X3 + mut(dh2 - hu, 0));
                        break t;
                      }
                      mt += je2;
                    }
                    s.rect(Z3, X3, Ll, dh2);
                    break;
                  case Cd2.Z:
                    if (tt) {
                      var je2 = it[Mt++];
                      if (mt + je2 > kt) {
                        var rn = (kt - mt) / je2;
                        s.lineTo(B3 * (1 - rn) + k2 * rn, G3 * (1 - rn) + R6 * rn);
                        break t;
                      }
                      mt += je2;
                    }
                    s.closePath(), B3 = k2, G3 = R6;
                }
              }
          }, c5.prototype.clone = function() {
            var s = new c5(), r5 = this.data;
            return s.data = r5.slice ? r5.slice() : Array.prototype.slice.call(r5), s._len = this._len, s;
          }, c5.CMD = Cd2, c5.initDefaultProps = function() {
            var s = c5.prototype;
            s._saveData = true, s._ux = 0, s._uy = 0, s._pendingPtDist = 0, s._version = 0;
          }(), c5;
        }(), jI = gjt;
        function _3(c5, s, r5, g5, b6, S2, A2) {
          if (b6 === 0)
            return false;
          var k2 = b6, R6 = 0, B3 = c5;
          if (A2 > s + k2 && A2 > g5 + k2 || A2 < s - k2 && A2 < g5 - k2 || S2 > c5 + k2 && S2 > r5 + k2 || S2 < c5 - k2 && S2 < r5 - k2)
            return false;
          if (c5 !== r5)
            R6 = (s - g5) / (c5 - r5), B3 = (c5 * g5 - r5 * s) / (c5 - r5);
          else
            return Math.abs(S2 - c5) <= k2 / 2;
          var G3 = R6 * S2 - A2 + B3, Z3 = G3 * G3 / (R6 * R6 + 1);
          return Z3 <= k2 / 2 * k2 / 2;
        }
        function vjt(c5, s, r5, g5, b6, S2, A2, k2, R6, B3, G3) {
          if (R6 === 0)
            return false;
          var Z3 = R6;
          if (G3 > s + Z3 && G3 > g5 + Z3 && G3 > S2 + Z3 && G3 > k2 + Z3 || G3 < s - Z3 && G3 < g5 - Z3 && G3 < S2 - Z3 && G3 < k2 - Z3 || B3 > c5 + Z3 && B3 > r5 + Z3 && B3 > b6 + Z3 && B3 > A2 + Z3 || B3 < c5 - Z3 && B3 < r5 - Z3 && B3 < b6 - Z3 && B3 < A2 - Z3)
            return false;
          var X3 = Sj2(c5, s, r5, g5, b6, S2, A2, k2, B3, G3, null);
          return X3 <= Z3 / 2;
        }
        function ZSt(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          if (A2 === 0)
            return false;
          var B3 = A2;
          if (R6 > s + B3 && R6 > g5 + B3 && R6 > S2 + B3 || R6 < s - B3 && R6 < g5 - B3 && R6 < S2 - B3 || k2 > c5 + B3 && k2 > r5 + B3 && k2 > b6 + B3 || k2 < c5 - B3 && k2 < r5 - B3 && k2 < b6 - B3)
            return false;
          var G3 = F1(c5, s, r5, g5, b6, S2, k2, R6, null);
          return G3 <= B3 / 2;
        }
        var $St = Math.PI * 2;
        function x3(c5) {
          return c5 %= $St, c5 < 0 && (c5 += $St), c5;
        }
        var Uj2 = Math.PI * 2;
        function yjt(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          if (A2 === 0)
            return false;
          var B3 = A2;
          k2 -= c5, R6 -= s;
          var G3 = Math.sqrt(k2 * k2 + R6 * R6);
          if (G3 - B3 > r5 || G3 + B3 < r5)
            return false;
          if (Math.abs(g5 - b6) % Uj2 < 1e-4)
            return true;
          if (S2) {
            var Z3 = g5;
            g5 = x3(b6), b6 = x3(Z3);
          } else
            g5 = x3(g5), b6 = x3(b6);
          g5 > b6 && (b6 += Uj2);
          var X3 = Math.atan2(R6, k2);
          return X3 < 0 && (X3 += Uj2), X3 >= g5 && X3 <= b6 || X3 + Uj2 >= g5 && X3 + Uj2 <= b6;
        }
        function Ak(c5, s, r5, g5, b6, S2) {
          if (S2 > s && S2 > g5 || S2 < s && S2 < g5 || g5 === s)
            return 0;
          var A2 = (S2 - s) / (g5 - s), k2 = g5 < s ? 1 : -1;
          (A2 === 1 || A2 === 0) && (k2 = g5 < s ? 0.5 : -0.5);
          var R6 = A2 * (r5 - c5) + c5;
          return R6 === b6 ? 1 / 0 : R6 > b6 ? k2 : 0;
        }
        var w3 = jI.CMD, hR = Math.PI * 2, mjt = 1e-4;
        function bjt(c5, s) {
          return Math.abs(c5 - s) < mjt;
        }
        var yx = [-1, -1, -1], d22 = [-1, -1];
        function YSt() {
          var c5 = d22[0];
          d22[0] = d22[1], d22[1] = c5;
        }
        function _jt(c5, s, r5, g5, b6, S2, A2, k2, R6, B3) {
          if (B3 > s && B3 > g5 && B3 > S2 && B3 > k2 || B3 < s && B3 < g5 && B3 < S2 && B3 < k2)
            return 0;
          var G3 = qY(s, g5, S2, k2, B3, yx);
          if (G3 === 0)
            return 0;
          for (var Z3 = 0, X3 = -1, tt = void 0, it = void 0, pt = 0; pt < G3; pt++) {
            var mt = yx[pt], Mt = mt === 0 || mt === 1 ? 0.5 : 1, kt = D0(c5, r5, b6, A2, mt);
            kt < R6 || (X3 < 0 && (X3 = hSt(s, g5, S2, k2, d22), d22[1] < d22[0] && X3 > 1 && YSt(), tt = D0(s, g5, S2, k2, d22[0]), X3 > 1 && (it = D0(s, g5, S2, k2, d22[1]))), X3 === 2 ? mt < d22[0] ? Z3 += tt < s ? Mt : -Mt : mt < d22[1] ? Z3 += it < tt ? Mt : -Mt : Z3 += k2 < it ? Mt : -Mt : mt < d22[0] ? Z3 += tt < s ? Mt : -Mt : Z3 += k2 < tt ? Mt : -Mt);
          }
          return Z3;
        }
        function xjt(c5, s, r5, g5, b6, S2, A2, k2) {
          if (k2 > s && k2 > g5 && k2 > S2 || k2 < s && k2 < g5 && k2 < S2)
            return 0;
          var R6 = bzt(s, g5, S2, k2, yx);
          if (R6 === 0)
            return 0;
          var B3 = pSt(s, g5, S2);
          if (B3 >= 0 && B3 <= 1) {
            for (var G3 = 0, Z3 = Hm(s, g5, S2, B3), X3 = 0; X3 < R6; X3++) {
              var tt = yx[X3] === 0 || yx[X3] === 1 ? 0.5 : 1, it = Hm(c5, r5, b6, yx[X3]);
              it < A2 || (yx[X3] < B3 ? G3 += Z3 < s ? tt : -tt : G3 += S2 < Z3 ? tt : -tt);
            }
            return G3;
          } else {
            var tt = yx[0] === 0 || yx[0] === 1 ? 0.5 : 1, it = Hm(c5, r5, b6, yx[0]);
            return it < A2 ? 0 : S2 < s ? tt : -tt;
          }
        }
        function wjt(c5, s, r5, g5, b6, S2, A2, k2) {
          if (k2 -= s, k2 > r5 || k2 < -r5)
            return 0;
          var R6 = Math.sqrt(r5 * r5 - k2 * k2);
          yx[0] = -R6, yx[1] = R6;
          var B3 = Math.abs(g5 - b6);
          if (B3 < 1e-4)
            return 0;
          if (B3 >= hR - 1e-4) {
            g5 = 0, b6 = hR;
            var G3 = S2 ? 1 : -1;
            return A2 >= yx[0] + c5 && A2 <= yx[1] + c5 ? G3 : 0;
          }
          if (g5 > b6) {
            var Z3 = g5;
            g5 = b6, b6 = Z3;
          }
          g5 < 0 && (g5 += hR, b6 += hR);
          for (var X3 = 0, tt = 0; tt < 2; tt++) {
            var it = yx[tt];
            if (it + c5 > A2) {
              var pt = Math.atan2(k2, it), G3 = S2 ? 1 : -1;
              pt < 0 && (pt = hR + pt), (pt >= g5 && pt <= b6 || pt + hR >= g5 && pt + hR <= b6) && (pt > Math.PI / 2 && pt < Math.PI * 1.5 && (G3 = -G3), X3 += G3);
            }
          }
          return X3;
        }
        function KSt(c5, s, r5, g5, b6) {
          for (var S2 = c5.data, A2 = c5.len(), k2 = 0, R6 = 0, B3 = 0, G3 = 0, Z3 = 0, X3, tt, it = 0; it < A2; ) {
            var pt = S2[it++], mt = it === 1;
            switch (pt === w3.M && it > 1 && (r5 || (k2 += Ak(R6, B3, G3, Z3, g5, b6))), mt && (R6 = S2[it], B3 = S2[it + 1], G3 = R6, Z3 = B3), pt) {
              case w3.M:
                G3 = S2[it++], Z3 = S2[it++], R6 = G3, B3 = Z3;
                break;
              case w3.L:
                if (r5) {
                  if (_3(R6, B3, S2[it], S2[it + 1], s, g5, b6))
                    return true;
                } else
                  k2 += Ak(R6, B3, S2[it], S2[it + 1], g5, b6) || 0;
                R6 = S2[it++], B3 = S2[it++];
                break;
              case w3.C:
                if (r5) {
                  if (vjt(R6, B3, S2[it++], S2[it++], S2[it++], S2[it++], S2[it], S2[it + 1], s, g5, b6))
                    return true;
                } else
                  k2 += _jt(R6, B3, S2[it++], S2[it++], S2[it++], S2[it++], S2[it], S2[it + 1], g5, b6) || 0;
                R6 = S2[it++], B3 = S2[it++];
                break;
              case w3.Q:
                if (r5) {
                  if (ZSt(R6, B3, S2[it++], S2[it++], S2[it], S2[it + 1], s, g5, b6))
                    return true;
                } else
                  k2 += xjt(R6, B3, S2[it++], S2[it++], S2[it], S2[it + 1], g5, b6) || 0;
                R6 = S2[it++], B3 = S2[it++];
                break;
              case w3.A:
                var Mt = S2[it++], kt = S2[it++], Gt = S2[it++], Ot = S2[it++], ce2 = S2[it++], ae2 = S2[it++];
                it += 1;
                var de2 = !!(1 - S2[it++]);
                X3 = Math.cos(ce2) * Gt + Mt, tt = Math.sin(ce2) * Ot + kt, mt ? (G3 = X3, Z3 = tt) : k2 += Ak(R6, B3, X3, tt, g5, b6);
                var we2 = (g5 - Mt) * Ot / Gt + Mt;
                if (r5) {
                  if (yjt(Mt, kt, Ot, ce2, ce2 + ae2, de2, s, we2, b6))
                    return true;
                } else
                  k2 += wjt(Mt, kt, Ot, ce2, ce2 + ae2, de2, we2, b6);
                R6 = Math.cos(ce2 + ae2) * Gt + Mt, B3 = Math.sin(ce2 + ae2) * Ot + kt;
                break;
              case w3.R:
                G3 = R6 = S2[it++], Z3 = B3 = S2[it++];
                var Se2 = S2[it++], Oe2 = S2[it++];
                if (X3 = G3 + Se2, tt = Z3 + Oe2, r5) {
                  if (_3(G3, Z3, X3, Z3, s, g5, b6) || _3(X3, Z3, X3, tt, s, g5, b6) || _3(X3, tt, G3, tt, s, g5, b6) || _3(G3, tt, G3, Z3, s, g5, b6))
                    return true;
                } else
                  k2 += Ak(X3, Z3, X3, tt, g5, b6), k2 += Ak(G3, tt, G3, Z3, g5, b6);
                break;
              case w3.Z:
                if (r5) {
                  if (_3(R6, B3, G3, Z3, s, g5, b6))
                    return true;
                } else
                  k2 += Ak(R6, B3, G3, Z3, g5, b6);
                R6 = G3, B3 = Z3;
                break;
            }
          }
          return !r5 && !bjt(B3, Z3) && (k2 += Ak(R6, B3, G3, Z3, g5, b6) || 0), k2 !== 0;
        }
        function OK(c5, s, r5) {
          return KSt(c5, 0, false, s, r5);
        }
        function Sjt(c5, s, r5, g5) {
          return KSt(c5, s, true, r5, g5);
        }
        var RK = Cl({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, oR), Mjt = { style: Cl({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, IK.style) }, _ut = xM.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), Cjt = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.update = function() {
            var r5 = this;
            c5.prototype.update.call(this);
            var g5 = this.style;
            if (g5.decal) {
              var b6 = this._decalEl = this._decalEl || new s();
              b6.buildPath === s.prototype.buildPath && (b6.buildPath = function(R6) {
                r5.buildPath(R6, r5.shape);
              }), b6.silent = true;
              var S2 = b6.style;
              for (var A2 in g5)
                S2[A2] !== g5[A2] && (S2[A2] = g5[A2]);
              S2.fill = g5.fill ? g5.decal : null, S2.decal = null, S2.shadowColor = null, g5.strokeFirst && (S2.stroke = null);
              for (var k2 = 0; k2 < _ut.length; ++k2)
                b6[_ut[k2]] = this[_ut[k2]];
              b6.__dirty |= Vb2;
            } else
              this._decalEl && (this._decalEl = null);
          }, s.prototype.getDecalElement = function() {
            return this._decalEl;
          }, s.prototype._init = function(r5) {
            var g5 = nf2(r5);
            this.shape = this.getDefaultShape();
            var b6 = this.getDefaultStyle();
            b6 && this.useStyle(b6);
            for (var S2 = 0; S2 < g5.length; S2++) {
              var A2 = g5[S2], k2 = r5[A2];
              A2 === "style" ? this.style ? sa2(this.style, k2) : this.useStyle(k2) : A2 === "shape" ? sa2(this.shape, k2) : c5.prototype.attrKV.call(this, A2, k2);
            }
            this.style || this.useStyle({});
          }, s.prototype.getDefaultStyle = function() {
            return null;
          }, s.prototype.getDefaultShape = function() {
            return {};
          }, s.prototype.canBeInsideText = function() {
            return this.hasFill();
          }, s.prototype.getInsideTextFill = function() {
            var r5 = this.style.fill;
            if (r5 !== "none") {
              if (gs(r5)) {
                var g5 = KY(r5, 0);
                return g5 > 0.5 ? cK : g5 > 0.2 ? Nzt : Llt;
              } else if (r5)
                return Llt;
            }
            return cK;
          }, s.prototype.getInsideTextStroke = function(r5) {
            var g5 = this.style.fill;
            if (gs(g5)) {
              var b6 = this.__zr, S2 = !!(b6 && b6.isDarkMode()), A2 = KY(r5, 0) < Ij2;
              if (S2 === A2)
                return g5;
            }
          }, s.prototype.buildPath = function(r5, g5, b6) {
          }, s.prototype.pathUpdated = function() {
            this.__dirty &= ~jC;
          }, s.prototype.getUpdatedPathProxy = function(r5) {
            return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, r5), this.path;
          }, s.prototype.createPathProxy = function() {
            this.path = new jI(false);
          }, s.prototype.hasStroke = function() {
            var r5 = this.style, g5 = r5.stroke;
            return !(g5 == null || g5 === "none" || !(r5.lineWidth > 0));
          }, s.prototype.hasFill = function() {
            var r5 = this.style, g5 = r5.fill;
            return g5 != null && g5 !== "none";
          }, s.prototype.getBoundingRect = function() {
            var r5 = this._rect, g5 = this.style, b6 = !r5;
            if (b6) {
              var S2 = false;
              this.path || (S2 = true, this.createPathProxy());
              var A2 = this.path;
              (S2 || this.__dirty & jC) && (A2.beginPath(), this.buildPath(A2, this.shape, false), this.pathUpdated()), r5 = A2.getBoundingRect();
            }
            if (this._rect = r5, this.hasStroke() && this.path && this.path.len() > 0) {
              var k2 = this._rectStroke || (this._rectStroke = r5.clone());
              if (this.__dirty || b6) {
                k2.copy(r5);
                var R6 = g5.strokeNoScale ? this.getLineScale() : 1, B3 = g5.lineWidth;
                if (!this.hasFill()) {
                  var G3 = this.strokeContainThreshold;
                  B3 = Math.max(B3, G3 == null ? 4 : G3);
                }
                R6 > 1e-10 && (k2.width += B3 / R6, k2.height += B3 / R6, k2.x -= B3 / R6 / 2, k2.y -= B3 / R6 / 2);
              }
              return k2;
            }
            return r5;
          }, s.prototype.contain = function(r5, g5) {
            var b6 = this.transformCoordToLocal(r5, g5), S2 = this.getBoundingRect(), A2 = this.style;
            if (r5 = b6[0], g5 = b6[1], S2.contain(r5, g5)) {
              var k2 = this.path;
              if (this.hasStroke()) {
                var R6 = A2.lineWidth, B3 = A2.strokeNoScale ? this.getLineScale() : 1;
                if (B3 > 1e-10 && (this.hasFill() || (R6 = Math.max(R6, this.strokeContainThreshold)), Sjt(k2, R6 / B3, r5, g5)))
                  return true;
              }
              if (this.hasFill())
                return OK(k2, r5, g5);
            }
            return false;
          }, s.prototype.dirtyShape = function() {
            this.__dirty |= jC, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
          }, s.prototype.dirty = function() {
            this.dirtyStyle(), this.dirtyShape();
          }, s.prototype.animateShape = function(r5) {
            return this.animate("shape", r5);
          }, s.prototype.updateDuringAnimation = function(r5) {
            r5 === "style" ? this.dirtyStyle() : r5 === "shape" ? this.dirtyShape() : this.markRedraw();
          }, s.prototype.attrKV = function(r5, g5) {
            r5 === "shape" ? this.setShape(g5) : c5.prototype.attrKV.call(this, r5, g5);
          }, s.prototype.setShape = function(r5, g5) {
            var b6 = this.shape;
            return b6 || (b6 = this.shape = {}), typeof r5 == "string" ? b6[r5] = g5 : sa2(b6, r5), this.dirtyShape(), this;
          }, s.prototype.shapeChanged = function() {
            return !!(this.__dirty & jC);
          }, s.prototype.createStyle = function(r5) {
            return hj2(RK, r5);
          }, s.prototype._innerSaveToNormal = function(r5) {
            c5.prototype._innerSaveToNormal.call(this, r5);
            var g5 = this._normalState;
            r5.shape && !g5.shape && (g5.shape = sa2({}, this.shape));
          }, s.prototype._applyStateObj = function(r5, g5, b6, S2, A2, k2) {
            c5.prototype._applyStateObj.call(this, r5, g5, b6, S2, A2, k2);
            var R6 = !(g5 && S2), B3;
            if (g5 && g5.shape ? A2 ? S2 ? B3 = g5.shape : (B3 = sa2({}, b6.shape), sa2(B3, g5.shape)) : (B3 = sa2({}, S2 ? this.shape : b6.shape), sa2(B3, g5.shape)) : R6 && (B3 = b6.shape), B3)
              if (A2) {
                this.shape = sa2({}, this.shape);
                for (var G3 = {}, Z3 = nf2(B3), X3 = 0; X3 < Z3.length; X3++) {
                  var tt = Z3[X3];
                  typeof B3[tt] == "object" ? this.shape[tt] = B3[tt] : G3[tt] = B3[tt];
                }
                this._transitionState(r5, { shape: G3 }, k2);
              } else
                this.shape = B3, this.dirtyShape();
          }, s.prototype._mergeStates = function(r5) {
            for (var g5 = c5.prototype._mergeStates.call(this, r5), b6, S2 = 0; S2 < r5.length; S2++) {
              var A2 = r5[S2];
              A2.shape && (b6 = b6 || {}, this._mergeStyle(b6, A2.shape));
            }
            return b6 && (g5.shape = b6), g5;
          }, s.prototype.getAnimationStyleProps = function() {
            return Mjt;
          }, s.prototype.isZeroArea = function() {
            return false;
          }, s.extend = function(r5) {
            var g5 = function(S2) {
              wn(A2, S2);
              function A2(k2) {
                var R6 = S2.call(this, k2) || this;
                return r5.init && r5.init.call(R6, k2), R6;
              }
              return A2.prototype.getDefaultStyle = function() {
                return Ml(r5.style);
              }, A2.prototype.getDefaultShape = function() {
                return Ml(r5.shape);
              }, A2;
            }(s);
            for (var b6 in r5)
              typeof r5[b6] == "function" && (g5.prototype[b6] = r5[b6]);
            return g5;
          }, s.initDefaultProps = function() {
            var r5 = s.prototype;
            r5.type = "path", r5.strokeContainThreshold = 5, r5.segmentIgnoreThreshold = 0, r5.subPixelOptimize = false, r5.autoBatch = false, r5.__dirty = Vb2 | mj2 | jC;
          }(), s;
        }(SM), Tc2 = Cjt, Tjt = Cl({ strokeFirst: true, font: Yh2, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, RK), XSt = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.hasStroke = function() {
            var r5 = this.style, g5 = r5.stroke;
            return g5 != null && g5 !== "none" && r5.lineWidth > 0;
          }, s.prototype.hasFill = function() {
            var r5 = this.style, g5 = r5.fill;
            return g5 != null && g5 !== "none";
          }, s.prototype.createStyle = function(r5) {
            return hj2(Tjt, r5);
          }, s.prototype.setBoundingRect = function(r5) {
            this._rect = r5;
          }, s.prototype.getBoundingRect = function() {
            var r5 = this.style;
            if (!this._rect) {
              var g5 = r5.text;
              g5 != null ? g5 += "" : g5 = "";
              var b6 = tR(g5, r5.font, r5.textAlign, r5.textBaseline);
              if (b6.x += r5.x || 0, b6.y += r5.y || 0, this.hasStroke()) {
                var S2 = r5.lineWidth;
                b6.x -= S2 / 2, b6.y -= S2 / 2, b6.width += S2, b6.height += S2;
              }
              this._rect = b6;
            }
            return this._rect;
          }, s.initDefaultProps = function() {
            var r5 = s.prototype;
            r5.dirtyRectTolerance = 10;
          }(), s;
        }(SM);
        XSt.prototype.type = "tspan";
        var qj2 = XSt, Ajt = Cl({ x: 0, y: 0 }, oR), Ijt = { style: Cl({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, IK.style) };
        function NK(c5) {
          return !!(c5 && typeof c5 != "string" && c5.width && c5.height);
        }
        var QSt = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.createStyle = function(r5) {
            return hj2(Ajt, r5);
          }, s.prototype._getSize = function(r5) {
            var g5 = this.style, b6 = g5[r5];
            if (b6 != null)
              return b6;
            var S2 = NK(g5.image) ? g5.image : this.__image;
            if (!S2)
              return 0;
            var A2 = r5 === "width" ? "height" : "width", k2 = g5[A2];
            return k2 == null ? S2[r5] : S2[r5] / S2[A2] * k2;
          }, s.prototype.getWidth = function() {
            return this._getSize("width");
          }, s.prototype.getHeight = function() {
            return this._getSize("height");
          }, s.prototype.getAnimationStyleProps = function() {
            return Ijt;
          }, s.prototype.getBoundingRect = function() {
            var r5 = this.style;
            return this._rect || (this._rect = new lc2(r5.x || 0, r5.y || 0, this.getWidth(), this.getHeight())), this._rect;
          }, s;
        }(SM);
        QSt.prototype.type = "image";
        var qm = QSt;
        function JSt(c5, s) {
          var r5 = s.x, g5 = s.y, b6 = s.width, S2 = s.height, A2 = s.r, k2, R6, B3, G3;
          b6 < 0 && (r5 = r5 + b6, b6 = -b6), S2 < 0 && (g5 = g5 + S2, S2 = -S2), typeof A2 == "number" ? k2 = R6 = B3 = G3 = A2 : A2 instanceof Array ? A2.length === 1 ? k2 = R6 = B3 = G3 = A2[0] : A2.length === 2 ? (k2 = B3 = A2[0], R6 = G3 = A2[1]) : A2.length === 3 ? (k2 = A2[0], R6 = G3 = A2[1], B3 = A2[2]) : (k2 = A2[0], R6 = A2[1], B3 = A2[2], G3 = A2[3]) : k2 = R6 = B3 = G3 = 0;
          var Z3;
          k2 + R6 > b6 && (Z3 = k2 + R6, k2 *= b6 / Z3, R6 *= b6 / Z3), B3 + G3 > b6 && (Z3 = B3 + G3, B3 *= b6 / Z3, G3 *= b6 / Z3), R6 + B3 > S2 && (Z3 = R6 + B3, R6 *= S2 / Z3, B3 *= S2 / Z3), k2 + G3 > S2 && (Z3 = k2 + G3, k2 *= S2 / Z3, G3 *= S2 / Z3), c5.moveTo(r5 + k2, g5), c5.lineTo(r5 + b6 - R6, g5), R6 !== 0 && c5.arc(r5 + b6 - R6, g5 + R6, R6, -Math.PI / 2, 0), c5.lineTo(r5 + b6, g5 + S2 - B3), B3 !== 0 && c5.arc(r5 + b6 - B3, g5 + S2 - B3, B3, 0, Math.PI / 2), c5.lineTo(r5 + G3, g5 + S2), G3 !== 0 && c5.arc(r5 + G3, g5 + S2 - G3, G3, Math.PI / 2, Math.PI), c5.lineTo(r5, g5 + k2), k2 !== 0 && c5.arc(r5 + k2, g5 + k2, k2, Math.PI, Math.PI * 1.5);
        }
        var S3 = Math.round;
        function xut(c5, s, r5) {
          if (s) {
            var g5 = s.x1, b6 = s.x2, S2 = s.y1, A2 = s.y2;
            c5.x1 = g5, c5.x2 = b6, c5.y1 = S2, c5.y2 = A2;
            var k2 = r5 && r5.lineWidth;
            return k2 && (S3(g5 * 2) === S3(b6 * 2) && (c5.x1 = c5.x2 = M3(g5, k2, true)), S3(S2 * 2) === S3(A2 * 2) && (c5.y1 = c5.y2 = M3(S2, k2, true))), c5;
          }
        }
        function wut(c5, s, r5) {
          if (s) {
            var g5 = s.x, b6 = s.y, S2 = s.width, A2 = s.height;
            c5.x = g5, c5.y = b6, c5.width = S2, c5.height = A2;
            var k2 = r5 && r5.lineWidth;
            return k2 && (c5.x = M3(g5, k2, true), c5.y = M3(b6, k2, true), c5.width = Math.max(M3(g5 + S2, k2, false) - c5.x, S2 === 0 ? 0 : 1), c5.height = Math.max(M3(b6 + A2, k2, false) - c5.y, A2 === 0 ? 0 : 1)), c5;
          }
        }
        function M3(c5, s, r5) {
          if (!s)
            return c5;
          var g5 = S3(c5 * 2);
          return (g5 + S3(s)) % 2 === 0 ? g5 / 2 : (g5 + (r5 ? 1 : -1)) / 2;
        }
        var t2t = function() {
          function c5() {
            this.x = 0, this.y = 0, this.width = 0, this.height = 0;
          }
          return c5;
        }(), Djt = {}, e2t = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultShape = function() {
            return new t2t();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6, S2, A2, k2;
            if (this.subPixelOptimize) {
              var R6 = wut(Djt, g5, this.style);
              b6 = R6.x, S2 = R6.y, A2 = R6.width, k2 = R6.height, R6.r = g5.r, g5 = R6;
            } else
              b6 = g5.x, S2 = g5.y, A2 = g5.width, k2 = g5.height;
            g5.r ? JSt(r5, g5) : r5.rect(b6, S2, A2, k2);
          }, s.prototype.isZeroArea = function() {
            return !this.shape.width || !this.shape.height;
          }, s;
        }(Tc2);
        e2t.prototype.type = "rect";
        var zf2 = e2t, Zj2 = { fill: "#000" }, $j = 2, Ejt = { style: Cl({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, IK.style) }, n2t = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this) || this;
            return g5.type = "text", g5._children = [], g5._defaultStyle = Zj2, g5.attr(r5), g5;
          }
          return s.prototype.childrenRef = function() {
            return this._children;
          }, s.prototype.update = function() {
            c5.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
            for (var r5 = 0; r5 < this._children.length; r5++) {
              var g5 = this._children[r5];
              g5.zlevel = this.zlevel, g5.z = this.z, g5.z2 = this.z2, g5.culling = this.culling, g5.cursor = this.cursor, g5.invisible = this.invisible;
            }
          }, s.prototype.updateTransform = function() {
            var r5 = this.innerTransformable;
            r5 ? (r5.updateTransform(), r5.transform && (this.transform = r5.transform)) : c5.prototype.updateTransform.call(this);
          }, s.prototype.getLocalTransform = function(r5) {
            var g5 = this.innerTransformable;
            return g5 ? g5.getLocalTransform(r5) : c5.prototype.getLocalTransform.call(this, r5);
          }, s.prototype.getComputedTransform = function() {
            return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), c5.prototype.getComputedTransform.call(this);
          }, s.prototype._updateSubTexts = function() {
            this._childCursor = 0, kjt(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
          }, s.prototype.addSelfToZr = function(r5) {
            c5.prototype.addSelfToZr.call(this, r5);
            for (var g5 = 0; g5 < this._children.length; g5++)
              this._children[g5].__zr = r5;
          }, s.prototype.removeSelfFromZr = function(r5) {
            c5.prototype.removeSelfFromZr.call(this, r5);
            for (var g5 = 0; g5 < this._children.length; g5++)
              this._children[g5].__zr = null;
          }, s.prototype.getBoundingRect = function() {
            if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
              for (var r5 = new lc2(0, 0, 0, 0), g5 = this._children, b6 = [], S2 = null, A2 = 0; A2 < g5.length; A2++) {
                var k2 = g5[A2], R6 = k2.getBoundingRect(), B3 = k2.getLocalTransform(b6);
                B3 ? (r5.copy(R6), r5.applyTransform(B3), S2 = S2 || r5.clone(), S2.union(r5)) : (S2 = S2 || R6.clone(), S2.union(R6));
              }
              this._rect = S2 || r5;
            }
            return this._rect;
          }, s.prototype.setDefaultTextStyle = function(r5) {
            this._defaultStyle = r5 || Zj2;
          }, s.prototype.setTextContent = function(r5) {
          }, s.prototype._mergeStyle = function(r5, g5) {
            if (!g5)
              return r5;
            var b6 = g5.rich, S2 = r5.rich || b6 && {};
            return sa2(r5, g5), b6 && S2 ? (this._mergeRich(S2, b6), r5.rich = S2) : S2 && (r5.rich = S2), r5;
          }, s.prototype._mergeRich = function(r5, g5) {
            for (var b6 = nf2(g5), S2 = 0; S2 < b6.length; S2++) {
              var A2 = b6[S2];
              r5[A2] = r5[A2] || {}, sa2(r5[A2], g5[A2]);
            }
          }, s.prototype.getAnimationStyleProps = function() {
            return Ejt;
          }, s.prototype._getOrCreateChild = function(r5) {
            var g5 = this._children[this._childCursor];
            return (!g5 || !(g5 instanceof r5)) && (g5 = new r5()), this._children[this._childCursor++] = g5, g5.__zr = this.__zr, g5.parent = this, g5;
          }, s.prototype._updatePlainTexts = function() {
            var r5 = this.style, g5 = r5.font || Yh2, b6 = r5.padding, S2 = h2t(r5), A2 = njt(S2, r5), k2 = Mut(r5), R6 = !!r5.backgroundColor, B3 = A2.outerHeight, G3 = A2.outerWidth, Z3 = A2.contentWidth, X3 = A2.lines, tt = A2.lineHeight, it = this._defaultStyle, pt = r5.x || 0, mt = r5.y || 0, Mt = r5.align || it.align || "left", kt = r5.verticalAlign || it.verticalAlign || "top", Gt = pt, Ot = wk2(mt, A2.contentHeight, kt);
            if (k2 || b6) {
              var ce2 = V8(pt, G3, Mt), ae2 = wk2(mt, B3, kt);
              k2 && this._renderBackground(r5, r5, ce2, ae2, G3, B3);
            }
            Ot += tt / 2, b6 && (Gt = f2t(pt, Mt, b6), kt === "top" ? Ot += b6[0] : kt === "bottom" && (Ot -= b6[2]));
            for (var de2 = 0, we2 = false, Se2 = c2t("fill" in r5 ? r5.fill : (we2 = true, it.fill)), Oe2 = u2t("stroke" in r5 ? r5.stroke : !R6 && (!it.autoStroke || we2) ? (de2 = $j, it.stroke) : null), je2 = r5.textShadowBlur > 0, rn = r5.width != null && (r5.overflow === "truncate" || r5.overflow === "break" || r5.overflow === "breakAll"), qe2 = A2.calculatedLineHeight, An = 0; An < X3.length; An++) {
              var jn = this._getOrCreateChild(qj2), _n = jn.createStyle();
              jn.useStyle(_n), _n.text = X3[An], _n.x = Gt, _n.y = Ot, Mt && (_n.textAlign = Mt), _n.textBaseline = "middle", _n.opacity = r5.opacity, _n.strokeFirst = true, je2 && (_n.shadowBlur = r5.textShadowBlur || 0, _n.shadowColor = r5.textShadowColor || "transparent", _n.shadowOffsetX = r5.textShadowOffsetX || 0, _n.shadowOffsetY = r5.textShadowOffsetY || 0), _n.stroke = Oe2, _n.fill = Se2, Oe2 && (_n.lineWidth = r5.lineWidth || de2, _n.lineDash = r5.lineDash, _n.lineDashOffset = r5.lineDashOffset || 0), _n.font = g5, o2t(_n, r5), Ot += tt, rn && jn.setBoundingRect(new lc2(V8(_n.x, r5.width, _n.textAlign), wk2(_n.y, qe2, _n.textBaseline), Z3, qe2));
            }
          }, s.prototype._updateRichTexts = function() {
            var r5 = this.style, g5 = h2t(r5), b6 = ajt(g5, r5), S2 = b6.width, A2 = b6.outerWidth, k2 = b6.outerHeight, R6 = r5.padding, B3 = r5.x || 0, G3 = r5.y || 0, Z3 = this._defaultStyle, X3 = r5.align || Z3.align, tt = r5.verticalAlign || Z3.verticalAlign, it = V8(B3, A2, X3), pt = wk2(G3, k2, tt), mt = it, Mt = pt;
            R6 && (mt += R6[3], Mt += R6[0]);
            var kt = mt + S2;
            Mut(r5) && this._renderBackground(r5, r5, it, pt, A2, k2);
            for (var Gt = !!r5.backgroundColor, Ot = 0; Ot < b6.lines.length; Ot++) {
              for (var ce2 = b6.lines[Ot], ae2 = ce2.tokens, de2 = ae2.length, we2 = ce2.lineHeight, Se2 = ce2.width, Oe2 = 0, je2 = mt, rn = kt, qe2 = de2 - 1, An = void 0; Oe2 < de2 && (An = ae2[Oe2], !An.align || An.align === "left"); )
                this._placeToken(An, r5, we2, Mt, je2, "left", Gt), Se2 -= An.width, je2 += An.width, Oe2++;
              for (; qe2 >= 0 && (An = ae2[qe2], An.align === "right"); )
                this._placeToken(An, r5, we2, Mt, rn, "right", Gt), Se2 -= An.width, rn -= An.width, qe2--;
              for (je2 += (S2 - (je2 - mt) - (kt - rn) - Se2) / 2; Oe2 <= qe2; )
                An = ae2[Oe2], this._placeToken(An, r5, we2, Mt, je2 + An.width / 2, "center", Gt), je2 += An.width, Oe2++;
              Mt += we2;
            }
          }, s.prototype._placeToken = function(r5, g5, b6, S2, A2, k2, R6) {
            var B3 = g5.rich[r5.styleName] || {};
            B3.text = r5.text;
            var G3 = r5.verticalAlign, Z3 = S2 + b6 / 2;
            G3 === "top" ? Z3 = S2 + r5.height / 2 : G3 === "bottom" && (Z3 = S2 + b6 - r5.height / 2);
            var X3 = !r5.isLineHolder && Mut(B3);
            X3 && this._renderBackground(B3, g5, k2 === "right" ? A2 - r5.width : k2 === "center" ? A2 - r5.width / 2 : A2, Z3 - r5.height / 2, r5.width, r5.height);
            var tt = !!B3.backgroundColor, it = r5.textPadding;
            it && (A2 = f2t(A2, k2, it), Z3 -= r5.height / 2 - it[0] - r5.innerHeight / 2);
            var pt = this._getOrCreateChild(qj2), mt = pt.createStyle();
            pt.useStyle(mt);
            var Mt = this._defaultStyle, kt = false, Gt = 0, Ot = c2t("fill" in B3 ? B3.fill : "fill" in g5 ? g5.fill : (kt = true, Mt.fill)), ce2 = u2t("stroke" in B3 ? B3.stroke : "stroke" in g5 ? g5.stroke : !tt && !R6 && (!Mt.autoStroke || kt) ? (Gt = $j, Mt.stroke) : null), ae2 = B3.textShadowBlur > 0 || g5.textShadowBlur > 0;
            mt.text = r5.text, mt.x = A2, mt.y = Z3, ae2 && (mt.shadowBlur = B3.textShadowBlur || g5.textShadowBlur || 0, mt.shadowColor = B3.textShadowColor || g5.textShadowColor || "transparent", mt.shadowOffsetX = B3.textShadowOffsetX || g5.textShadowOffsetX || 0, mt.shadowOffsetY = B3.textShadowOffsetY || g5.textShadowOffsetY || 0), mt.textAlign = k2, mt.textBaseline = "middle", mt.font = r5.font || Yh2, mt.opacity = pk2(B3.opacity, g5.opacity, 1), o2t(mt, B3), ce2 && (mt.lineWidth = pk2(B3.lineWidth, g5.lineWidth, Gt), mt.lineDash = tc2(B3.lineDash, g5.lineDash), mt.lineDashOffset = g5.lineDashOffset || 0, mt.stroke = ce2), Ot && (mt.fill = Ot);
            var de2 = r5.contentWidth, we2 = r5.contentHeight;
            pt.setBoundingRect(new lc2(V8(mt.x, de2, mt.textAlign), wk2(mt.y, we2, mt.textBaseline), de2, we2));
          }, s.prototype._renderBackground = function(r5, g5, b6, S2, A2, k2) {
            var R6 = r5.backgroundColor, B3 = r5.borderWidth, G3 = r5.borderColor, Z3 = R6 && R6.image, X3 = R6 && !Z3, tt = r5.borderRadius, it = this, pt, mt;
            if (X3 || r5.lineHeight || B3 && G3) {
              pt = this._getOrCreateChild(zf2), pt.useStyle(pt.createStyle()), pt.style.fill = null;
              var Mt = pt.shape;
              Mt.x = b6, Mt.y = S2, Mt.width = A2, Mt.height = k2, Mt.r = tt, pt.dirtyShape();
            }
            if (X3) {
              var kt = pt.style;
              kt.fill = R6 || null, kt.fillOpacity = tc2(r5.fillOpacity, 1);
            } else if (Z3) {
              mt = this._getOrCreateChild(qm), mt.onload = function() {
                it.dirtyStyle();
              };
              var Gt = mt.style;
              Gt.image = R6.image, Gt.x = b6, Gt.y = S2, Gt.width = A2, Gt.height = k2;
            }
            if (B3 && G3) {
              var kt = pt.style;
              kt.lineWidth = B3, kt.stroke = G3, kt.strokeOpacity = tc2(r5.strokeOpacity, 1), kt.lineDash = r5.borderDash, kt.lineDashOffset = r5.borderDashOffset || 0, pt.strokeContainThreshold = 0, pt.hasFill() && pt.hasStroke() && (kt.strokeFirst = true, kt.lineWidth *= 2);
            }
            var Ot = (pt || mt).style;
            Ot.shadowBlur = r5.shadowBlur || 0, Ot.shadowColor = r5.shadowColor || "transparent", Ot.shadowOffsetX = r5.shadowOffsetX || 0, Ot.shadowOffsetY = r5.shadowOffsetY || 0, Ot.opacity = pk2(r5.opacity, g5.opacity, 1);
          }, s.makeFont = function(r5) {
            var g5 = "";
            return s2t(r5) && (g5 = [r5.fontStyle, r5.fontWeight, a2t(r5.fontSize), r5.fontFamily || "sans-serif"].join(" ")), g5 && Tg2(g5) || r5.textFont || r5.font;
          }, s;
        }(SM), Sut = { left: true, right: 1, center: 1 }, r2t = { top: 1, bottom: 1, middle: 1 }, i2t = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
        function a2t(c5) {
          return typeof c5 == "string" && (c5.indexOf("px") !== -1 || c5.indexOf("rem") !== -1 || c5.indexOf("em") !== -1) ? c5 : isNaN(+c5) ? If2 + "px" : c5 + "px";
        }
        function o2t(c5, s) {
          for (var r5 = 0; r5 < i2t.length; r5++) {
            var g5 = i2t[r5], b6 = s[g5];
            b6 != null && (c5[g5] = b6);
          }
        }
        function s2t(c5) {
          return c5.fontSize != null || c5.fontFamily || c5.fontWeight;
        }
        function kjt(c5) {
          return l2t(c5), Ye2(c5.rich, l2t), c5;
        }
        function l2t(c5) {
          if (c5) {
            c5.font = n2t.makeFont(c5);
            var s = c5.align;
            s === "middle" && (s = "center"), c5.align = s == null || Sut[s] ? s : "left";
            var r5 = c5.verticalAlign;
            r5 === "center" && (r5 = "middle"), c5.verticalAlign = r5 == null || r2t[r5] ? r5 : "top";
            var g5 = c5.padding;
            g5 && (c5.padding = VY(c5.padding));
          }
        }
        function u2t(c5, s) {
          return c5 == null || s <= 0 || c5 === "transparent" || c5 === "none" ? null : c5.image || c5.colorStops ? "#000" : c5;
        }
        function c2t(c5) {
          return c5 == null || c5 === "none" ? null : c5.image || c5.colorStops ? "#000" : c5;
        }
        function f2t(c5, s, r5) {
          return s === "right" ? c5 - r5[1] : s === "center" ? c5 + r5[3] / 2 - r5[1] / 2 : c5 + r5[3];
        }
        function h2t(c5) {
          var s = c5.text;
          return s != null && (s += ""), s;
        }
        function Mut(c5) {
          return !!(c5.backgroundColor || c5.lineHeight || c5.borderWidth && c5.borderColor);
        }
        var hh2 = n2t, Pl = Df2(), Cut = function(c5, s, r5, g5) {
          if (g5) {
            var b6 = Pl(g5);
            b6.dataIndex = r5, b6.dataType = s, b6.seriesIndex = c5, g5.type === "group" && g5.traverse(function(S2) {
              var A2 = Pl(S2);
              A2.seriesIndex = c5, A2.dataIndex = r5, A2.dataType = s;
            });
          }
        }, p2t = 1, C3 = {}, af2 = Df2(), Tut = Df2(), jb2 = 0, xv = 1, FK = 2, k0 = ["emphasis", "blur", "select"], Yj2 = ["normal", "emphasis", "blur", "select"], j8 = 10, Pjt = 9, pR = "highlight", VK = "downplay", dR = "select", BK = "unselect", g2 = "toggleSelect";
        function gR(c5) {
          return c5 != null && c5 !== "none";
        }
        var Kj2 = new gk2(100);
        function Bv(c5) {
          if (gs(c5)) {
            var s = Kj2.get(c5);
            return s || (s = wlt(c5, -0.1), Kj2.put(c5, s)), s;
          } else if (Xd2(c5)) {
            var r5 = sa2({}, c5);
            return r5.colorStops = Ha2(c5.colorStops, function(g5) {
              return { offset: g5.offset, color: wlt(g5.color, -0.1) };
            }), r5;
          }
          return c5;
        }
        function wv(c5, s, r5) {
          c5.onHoverStateChange && (c5.hoverState || 0) !== r5 && c5.onHoverStateChange(s), c5.hoverState = r5;
        }
        function Aut(c5) {
          wv(c5, "emphasis", FK);
        }
        function d2t(c5) {
          c5.hoverState === FK && wv(c5, "normal", jb2);
        }
        function Iut(c5) {
          wv(c5, "blur", xv);
        }
        function g2t(c5) {
          c5.hoverState === xv && wv(c5, "normal", jb2);
        }
        function Ljt(c5) {
          c5.selected = true;
        }
        function Ojt(c5) {
          c5.selected = false;
        }
        function v2t(c5, s, r5) {
          s(c5, r5);
        }
        function WI(c5, s, r5) {
          v2t(c5, s, r5), c5.isGroup && c5.traverse(function(g5) {
            v2t(g5, s, r5);
          });
        }
        function T3(c5, s) {
          switch (s) {
            case "emphasis":
              c5.hoverState = FK;
              break;
            case "normal":
              c5.hoverState = jb2;
              break;
            case "blur":
              c5.hoverState = xv;
              break;
            case "select":
              c5.selected = true;
          }
        }
        function Dut(c5, s, r5, g5) {
          for (var b6 = c5.style, S2 = {}, A2 = 0; A2 < s.length; A2++) {
            var k2 = s[A2], R6 = b6[k2];
            S2[k2] = R6 == null ? g5 && g5[k2] : R6;
          }
          for (var A2 = 0; A2 < c5.animators.length; A2++) {
            var B3 = c5.animators[A2];
            B3.__fromStateTransition && B3.__fromStateTransition.indexOf(r5) < 0 && B3.targetName === "style" && B3.saveTo(S2, s);
          }
          return S2;
        }
        function Rjt(c5, s, r5, g5) {
          var b6 = r5 && Lu(r5, "select") >= 0, S2 = false;
          if (c5 instanceof Tc2) {
            var A2 = af2(c5), k2 = b6 && A2.selectFill || A2.normalFill, R6 = b6 && A2.selectStroke || A2.normalStroke;
            if (gR(k2) || gR(R6)) {
              g5 = g5 || {};
              var B3 = g5.style || {};
              B3.fill === "inherit" ? (S2 = true, g5 = sa2({}, g5), B3 = sa2({}, B3), B3.fill = k2) : !gR(B3.fill) && gR(k2) ? (S2 = true, g5 = sa2({}, g5), B3 = sa2({}, B3), B3.fill = Bv(k2)) : !gR(B3.stroke) && gR(R6) && (S2 || (g5 = sa2({}, g5), B3 = sa2({}, B3)), B3.stroke = Bv(R6)), g5.style = B3;
            }
          }
          if (g5 && g5.z2 == null) {
            S2 || (g5 = sa2({}, g5));
            var G3 = c5.z2EmphasisLift;
            g5.z2 = c5.z2 + (G3 != null ? G3 : j8);
          }
          return g5;
        }
        function y2t(c5, s, r5) {
          if (r5 && r5.z2 == null) {
            r5 = sa2({}, r5);
            var g5 = c5.z2SelectLift;
            r5.z2 = c5.z2 + (g5 != null ? g5 : Pjt);
          }
          return r5;
        }
        function zK(c5, s, r5) {
          var g5 = Lu(c5.currentStates, s) >= 0, b6 = c5.style.opacity, S2 = g5 ? null : Dut(c5, ["opacity"], s, { opacity: 1 });
          r5 = r5 || {};
          var A2 = r5.style || {};
          return A2.opacity == null && (r5 = sa2({}, r5), A2 = sa2({ opacity: g5 ? b6 : S2.opacity * 0.1 }, A2), r5.style = A2), r5;
        }
        function mx(c5, s) {
          var r5 = this.states[c5];
          if (this.style) {
            if (c5 === "emphasis")
              return Rjt(this, c5, s, r5);
            if (c5 === "blur")
              return zK(this, c5, r5);
            if (c5 === "select")
              return y2t(this, c5, r5);
          }
          return r5;
        }
        function MM(c5) {
          c5.stateProxy = mx;
          var s = c5.getTextContent(), r5 = c5.getTextGuideLine();
          s && (s.stateProxy = mx), r5 && (r5.stateProxy = mx);
        }
        function m2t(c5, s) {
          !kut(c5, s) && !c5.__highByOuter && WI(c5, Aut);
        }
        function b2t(c5, s) {
          !kut(c5, s) && !c5.__highByOuter && WI(c5, d2t);
        }
        function GI(c5, s) {
          c5.__highByOuter |= 1 << (s || 0), WI(c5, Aut);
        }
        function HI(c5, s) {
          !(c5.__highByOuter &= ~(1 << (s || 0))) && WI(c5, d2t);
        }
        function _2t(c5) {
          WI(c5, Iut);
        }
        function Eut(c5) {
          WI(c5, g2t);
        }
        function UI(c5) {
          WI(c5, Ljt);
        }
        function Ef2(c5) {
          WI(c5, Ojt);
        }
        function kut(c5, s) {
          return c5.__highDownSilentOnTouch && s.zrByTouch;
        }
        function v22(c5) {
          var s = c5.getModel();
          s.eachComponent(function(r5, g5) {
            var b6 = Tut(g5);
            if (b6.isBlured) {
              var S2 = r5 === "series" ? c5.getViewOfSeriesModel(g5) : c5.getViewOfComponentModel(g5);
              S2.group.traverse(function(A2) {
                g2t(A2);
              });
            }
            b6.isBlured = false;
          });
        }
        function jK(c5, s, r5, g5) {
          var b6 = g5.getModel();
          r5 = r5 || "coordinateSystem";
          function S2(B3, G3) {
            for (var Z3 = 0; Z3 < G3.length; Z3++) {
              var X3 = B3.getItemGraphicEl(G3[Z3]);
              X3 && Eut(X3);
            }
          }
          if (c5 != null && !(!s || s === "none")) {
            var A2 = b6.getSeriesByIndex(c5), k2 = A2.coordinateSystem;
            k2 && k2.master && (k2 = k2.master);
            var R6 = [];
            b6.eachSeries(function(B3) {
              var G3 = A2 === B3, Z3 = B3.coordinateSystem;
              Z3 && Z3.master && (Z3 = Z3.master);
              var X3 = Z3 && k2 ? Z3 === k2 : G3;
              if (!(r5 === "series" && !G3 || r5 === "coordinateSystem" && !X3 || s === "series" && G3)) {
                var tt = g5.getViewOfSeriesModel(B3);
                if (tt.group.traverse(function(mt) {
                  Iut(mt);
                }), Fb2(s))
                  S2(B3.getData(), s);
                else if (Wl(s))
                  for (var it = nf2(s), pt = 0; pt < it.length; pt++)
                    S2(B3.getData(it[pt]), s[it[pt]]);
                R6.push(B3), Tut(B3).isBlured = true;
              }
            }), b6.eachComponent(function(B3, G3) {
              if (B3 !== "series") {
                var Z3 = g5.getViewOfComponentModel(G3);
                Z3 && Z3.blurSeries && Z3.blurSeries(R6, b6);
              }
            });
          }
        }
        function Put(c5, s, r5) {
          if (!(c5 == null || s == null)) {
            var g5 = r5.getModel().getComponent(c5, s);
            if (g5) {
              Tut(g5).isBlured = true;
              var b6 = r5.getViewOfComponentModel(g5);
              !b6 || !b6.focusBlurEnabled || b6.group.traverse(function(S2) {
                Iut(S2);
              });
            }
          }
        }
        function Td2(c5, s, r5) {
          var g5 = c5.seriesIndex, b6 = c5.getData(s.dataType);
          if (b6) {
            var S2 = nR(b6, s);
            S2 = (ja2(S2) ? S2[0] : S2) || 0;
            var A2 = b6.getItemGraphicEl(S2);
            if (!A2)
              for (var k2 = b6.count(), R6 = 0; !A2 && R6 < k2; )
                A2 = b6.getItemGraphicEl(R6++);
            if (A2) {
              var B3 = Pl(A2);
              jK(g5, B3.focus, B3.blurScope, r5);
            } else {
              var G3 = c5.get(["emphasis", "focus"]), Z3 = c5.get(["emphasis", "blurScope"]);
              G3 != null && jK(g5, G3, Z3, r5);
            }
          }
        }
        function Lut(c5, s, r5, g5) {
          var b6 = { focusSelf: false, dispatchers: null };
          if (c5 == null || c5 === "series" || s == null || r5 == null)
            return b6;
          var S2 = g5.getModel().getComponent(c5, s);
          if (!S2)
            return b6;
          var A2 = g5.getViewOfComponentModel(S2);
          if (!A2 || !A2.findHighDownDispatchers)
            return b6;
          for (var k2 = A2.findHighDownDispatchers(r5), R6, B3 = 0; B3 < k2.length; B3++)
            if (Pl(k2[B3]).focus === "self") {
              R6 = true;
              break;
            }
          return { focusSelf: R6, dispatchers: k2 };
        }
        function x2t(c5, s, r5) {
          var g5 = Pl(c5), b6 = Lut(g5.componentMainType, g5.componentIndex, g5.componentHighDownName, r5), S2 = b6.dispatchers, A2 = b6.focusSelf;
          S2 ? (A2 && Put(g5.componentMainType, g5.componentIndex, r5), Ye2(S2, function(k2) {
            return m2t(k2, s);
          })) : (jK(g5.seriesIndex, g5.focus, g5.blurScope, r5), g5.focus === "self" && Put(g5.componentMainType, g5.componentIndex, r5), m2t(c5, s));
        }
        function WK(c5, s, r5) {
          v22(r5);
          var g5 = Pl(c5), b6 = Lut(g5.componentMainType, g5.componentIndex, g5.componentHighDownName, r5).dispatchers;
          b6 ? Ye2(b6, function(S2) {
            return b2t(S2, s);
          }) : b2t(c5, s);
        }
        function Njt(c5, s, r5) {
          if (Nut(s)) {
            var g5 = s.dataType, b6 = c5.getData(g5), S2 = nR(b6, s);
            ja2(S2) || (S2 = [S2]), c5[s.type === g2 ? "toggleSelect" : s.type === dR ? "select" : "unselect"](S2, g5);
          }
        }
        function w2t(c5) {
          var s = c5.getAllData();
          Ye2(s, function(r5) {
            var g5 = r5.data, b6 = r5.type;
            g5.eachItemGraphicEl(function(S2, A2) {
              c5.isSelected(A2, b6) ? UI(S2) : Ef2(S2);
            });
          });
        }
        function Fjt(c5) {
          var s = [];
          return c5.eachSeries(function(r5) {
            var g5 = r5.getAllData();
            Ye2(g5, function(b6) {
              b6.data;
              var S2 = b6.type, A2 = r5.getSelectedDataIndices();
              if (A2.length > 0) {
                var k2 = { dataIndex: A2, seriesIndex: r5.seriesIndex };
                S2 != null && (k2.dataType = S2), s.push(k2);
              }
            });
          }), s;
        }
        function vR(c5, s, r5) {
          yR(c5, true), WI(c5, MM), Out(c5, s, r5);
        }
        function Vjt(c5) {
          yR(c5, false);
        }
        function f0(c5, s, r5, g5) {
          g5 ? Vjt(c5) : vR(c5, s, r5);
        }
        function Out(c5, s, r5) {
          var g5 = Pl(c5);
          s != null ? (g5.focus = s, g5.blurScope = r5) : g5.focus && (g5.focus = null);
        }
        var S2t = ["emphasis", "blur", "select"], Bjt = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
        function z1(c5, s, r5, g5) {
          r5 = r5 || "itemStyle";
          for (var b6 = 0; b6 < S2t.length; b6++) {
            var S2 = S2t[b6], A2 = s.getModel([S2, r5]), k2 = c5.ensureState(S2);
            k2.style = g5 ? g5(A2) : A2[Bjt[r5]]();
          }
        }
        function yR(c5, s) {
          var r5 = s === false, g5 = c5;
          c5.highDownSilentOnTouch && (g5.__highDownSilentOnTouch = c5.highDownSilentOnTouch), (!r5 || g5.__highDownDispatcher) && (g5.__highByOuter = g5.__highByOuter || 0, g5.__highDownDispatcher = !r5);
        }
        function Xj2(c5) {
          return !!(c5 && c5.__highDownDispatcher);
        }
        function zjt(c5, s, r5) {
          var g5 = Pl(c5);
          g5.componentMainType = s.mainType, g5.componentIndex = s.componentIndex, g5.componentHighDownName = r5;
        }
        function Rut(c5) {
          var s = C3[c5];
          return s == null && p2t <= 32 && (s = C3[c5] = p2t++), s;
        }
        function Nut(c5) {
          var s = c5.type;
          return s === dR || s === BK || s === g2;
        }
        function GK(c5) {
          var s = c5.type;
          return s === pR || s === VK;
        }
        function jjt(c5) {
          var s = af2(c5);
          s.normalFill = c5.style.fill, s.normalStroke = c5.style.stroke;
          var r5 = c5.states.select || {};
          s.selectFill = r5.style && r5.style.fill || null, s.selectStroke = r5.style && r5.style.stroke || null;
        }
        var W8 = jI.CMD, Wjt = [[], [], []], rm = Math.sqrt, jw = Math.atan2;
        function M2t(c5, s) {
          if (s) {
            var r5 = c5.data, g5 = c5.len(), b6, S2, A2, k2, R6, B3, G3 = W8.M, Z3 = W8.C, X3 = W8.L, tt = W8.R, it = W8.A, pt = W8.Q;
            for (A2 = 0, k2 = 0; A2 < g5; ) {
              switch (b6 = r5[A2++], k2 = A2, S2 = 0, b6) {
                case G3:
                  S2 = 1;
                  break;
                case X3:
                  S2 = 1;
                  break;
                case Z3:
                  S2 = 3;
                  break;
                case pt:
                  S2 = 2;
                  break;
                case it:
                  var mt = s[4], Mt = s[5], kt = rm(s[0] * s[0] + s[1] * s[1]), Gt = rm(s[2] * s[2] + s[3] * s[3]), Ot = jw(-s[1] / Gt, s[0] / kt);
                  r5[A2] *= kt, r5[A2++] += mt, r5[A2] *= Gt, r5[A2++] += Mt, r5[A2++] *= kt, r5[A2++] *= Gt, r5[A2++] += Ot, r5[A2++] += Ot, A2 += 2, k2 = A2;
                  break;
                case tt:
                  B3[0] = r5[A2++], B3[1] = r5[A2++], Gm(B3, B3, s), r5[k2++] = B3[0], r5[k2++] = B3[1], B3[0] += r5[A2++], B3[1] += r5[A2++], Gm(B3, B3, s), r5[k2++] = B3[0], r5[k2++] = B3[1];
              }
              for (R6 = 0; R6 < S2; R6++) {
                var ce2 = Wjt[R6];
                ce2[0] = r5[A2++], ce2[1] = r5[A2++], Gm(ce2, ce2, s), r5[k2++] = ce2[0], r5[k2++] = ce2[1];
              }
            }
            c5.increaseVersion();
          }
        }
        var Fut = Math.sqrt, HK = Math.sin, Qj2 = Math.cos, Jj2 = Math.PI;
        function C2t(c5) {
          return Math.sqrt(c5[0] * c5[0] + c5[1] * c5[1]);
        }
        function Vut(c5, s) {
          return (c5[0] * s[0] + c5[1] * s[1]) / (C2t(c5) * C2t(s));
        }
        function But(c5, s) {
          return (c5[0] * s[1] < c5[1] * s[0] ? -1 : 1) * Math.acos(Vut(c5, s));
        }
        function T2t(c5, s, r5, g5, b6, S2, A2, k2, R6, B3, G3) {
          var Z3 = R6 * (Jj2 / 180), X3 = Qj2(Z3) * (c5 - r5) / 2 + HK(Z3) * (s - g5) / 2, tt = -1 * HK(Z3) * (c5 - r5) / 2 + Qj2(Z3) * (s - g5) / 2, it = X3 * X3 / (A2 * A2) + tt * tt / (k2 * k2);
          it > 1 && (A2 *= Fut(it), k2 *= Fut(it));
          var pt = (b6 === S2 ? -1 : 1) * Fut((A2 * A2 * (k2 * k2) - A2 * A2 * (tt * tt) - k2 * k2 * (X3 * X3)) / (A2 * A2 * (tt * tt) + k2 * k2 * (X3 * X3))) || 0, mt = pt * A2 * tt / k2, Mt = pt * -k2 * X3 / A2, kt = (c5 + r5) / 2 + Qj2(Z3) * mt - HK(Z3) * Mt, Gt = (s + g5) / 2 + HK(Z3) * mt + Qj2(Z3) * Mt, Ot = But([1, 0], [(X3 - mt) / A2, (tt - Mt) / k2]), ce2 = [(X3 - mt) / A2, (tt - Mt) / k2], ae2 = [(-1 * X3 - mt) / A2, (-1 * tt - Mt) / k2], de2 = But(ce2, ae2);
          if (Vut(ce2, ae2) <= -1 && (de2 = Jj2), Vut(ce2, ae2) >= 1 && (de2 = 0), de2 < 0) {
            var we2 = Math.round(de2 / Jj2 * 1e6) / 1e6;
            de2 = Jj2 * 2 + we2 % 2 * Jj2;
          }
          G3.addData(B3, kt, Gt, A2, k2, Ot, de2, Z3, S2);
        }
        var Gjt = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, Hjt = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
        function A2t(c5) {
          var s = new jI();
          if (!c5)
            return s;
          var r5 = 0, g5 = 0, b6 = r5, S2 = g5, A2, k2 = jI.CMD, R6 = c5.match(Gjt);
          if (!R6)
            return s;
          for (var B3 = 0; B3 < R6.length; B3++) {
            for (var G3 = R6[B3], Z3 = G3.charAt(0), X3 = void 0, tt = G3.match(Hjt) || [], it = tt.length, pt = 0; pt < it; pt++)
              tt[pt] = parseFloat(tt[pt]);
            for (var mt = 0; mt < it; ) {
              var Mt = void 0, kt = void 0, Gt = void 0, Ot = void 0, ce2 = void 0, ae2 = void 0, de2 = void 0, we2 = r5, Se2 = g5, Oe2 = void 0, je2 = void 0;
              switch (Z3) {
                case "l":
                  r5 += tt[mt++], g5 += tt[mt++], X3 = k2.L, s.addData(X3, r5, g5);
                  break;
                case "L":
                  r5 = tt[mt++], g5 = tt[mt++], X3 = k2.L, s.addData(X3, r5, g5);
                  break;
                case "m":
                  r5 += tt[mt++], g5 += tt[mt++], X3 = k2.M, s.addData(X3, r5, g5), b6 = r5, S2 = g5, Z3 = "l";
                  break;
                case "M":
                  r5 = tt[mt++], g5 = tt[mt++], X3 = k2.M, s.addData(X3, r5, g5), b6 = r5, S2 = g5, Z3 = "L";
                  break;
                case "h":
                  r5 += tt[mt++], X3 = k2.L, s.addData(X3, r5, g5);
                  break;
                case "H":
                  r5 = tt[mt++], X3 = k2.L, s.addData(X3, r5, g5);
                  break;
                case "v":
                  g5 += tt[mt++], X3 = k2.L, s.addData(X3, r5, g5);
                  break;
                case "V":
                  g5 = tt[mt++], X3 = k2.L, s.addData(X3, r5, g5);
                  break;
                case "C":
                  X3 = k2.C, s.addData(X3, tt[mt++], tt[mt++], tt[mt++], tt[mt++], tt[mt++], tt[mt++]), r5 = tt[mt - 2], g5 = tt[mt - 1];
                  break;
                case "c":
                  X3 = k2.C, s.addData(X3, tt[mt++] + r5, tt[mt++] + g5, tt[mt++] + r5, tt[mt++] + g5, tt[mt++] + r5, tt[mt++] + g5), r5 += tt[mt - 2], g5 += tt[mt - 1];
                  break;
                case "S":
                  Mt = r5, kt = g5, Oe2 = s.len(), je2 = s.data, A2 === k2.C && (Mt += r5 - je2[Oe2 - 4], kt += g5 - je2[Oe2 - 3]), X3 = k2.C, we2 = tt[mt++], Se2 = tt[mt++], r5 = tt[mt++], g5 = tt[mt++], s.addData(X3, Mt, kt, we2, Se2, r5, g5);
                  break;
                case "s":
                  Mt = r5, kt = g5, Oe2 = s.len(), je2 = s.data, A2 === k2.C && (Mt += r5 - je2[Oe2 - 4], kt += g5 - je2[Oe2 - 3]), X3 = k2.C, we2 = r5 + tt[mt++], Se2 = g5 + tt[mt++], r5 += tt[mt++], g5 += tt[mt++], s.addData(X3, Mt, kt, we2, Se2, r5, g5);
                  break;
                case "Q":
                  we2 = tt[mt++], Se2 = tt[mt++], r5 = tt[mt++], g5 = tt[mt++], X3 = k2.Q, s.addData(X3, we2, Se2, r5, g5);
                  break;
                case "q":
                  we2 = tt[mt++] + r5, Se2 = tt[mt++] + g5, r5 += tt[mt++], g5 += tt[mt++], X3 = k2.Q, s.addData(X3, we2, Se2, r5, g5);
                  break;
                case "T":
                  Mt = r5, kt = g5, Oe2 = s.len(), je2 = s.data, A2 === k2.Q && (Mt += r5 - je2[Oe2 - 4], kt += g5 - je2[Oe2 - 3]), r5 = tt[mt++], g5 = tt[mt++], X3 = k2.Q, s.addData(X3, Mt, kt, r5, g5);
                  break;
                case "t":
                  Mt = r5, kt = g5, Oe2 = s.len(), je2 = s.data, A2 === k2.Q && (Mt += r5 - je2[Oe2 - 4], kt += g5 - je2[Oe2 - 3]), r5 += tt[mt++], g5 += tt[mt++], X3 = k2.Q, s.addData(X3, Mt, kt, r5, g5);
                  break;
                case "A":
                  Gt = tt[mt++], Ot = tt[mt++], ce2 = tt[mt++], ae2 = tt[mt++], de2 = tt[mt++], we2 = r5, Se2 = g5, r5 = tt[mt++], g5 = tt[mt++], X3 = k2.A, T2t(we2, Se2, r5, g5, ae2, de2, Gt, Ot, ce2, X3, s);
                  break;
                case "a":
                  Gt = tt[mt++], Ot = tt[mt++], ce2 = tt[mt++], ae2 = tt[mt++], de2 = tt[mt++], we2 = r5, Se2 = g5, r5 += tt[mt++], g5 += tt[mt++], X3 = k2.A, T2t(we2, Se2, r5, g5, ae2, de2, Gt, Ot, ce2, X3, s);
                  break;
              }
            }
            (Z3 === "z" || Z3 === "Z") && (X3 = k2.Z, s.addData(X3), r5 = b6, g5 = S2), A2 = X3;
          }
          return s.toStatic(), s;
        }
        var zut = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.applyTransform = function(r5) {
          }, s;
        }(Tc2);
        function I2t(c5) {
          return c5.setData != null;
        }
        function D2t(c5, s) {
          var r5 = A2t(c5), g5 = sa2({}, s);
          return g5.buildPath = function(b6) {
            if (I2t(b6)) {
              b6.setData(r5.data);
              var S2 = b6.getContext();
              S2 && b6.rebuildPath(S2, 1);
            } else {
              var S2 = b6;
              r5.rebuildPath(S2, 1);
            }
          }, g5.applyTransform = function(b6) {
            M2t(r5, b6), this.dirtyShape();
          }, g5;
        }
        function E2t(c5, s) {
          return new zut(D2t(c5, s));
        }
        function Ujt(c5, s) {
          var r5 = D2t(c5, s), g5 = function(b6) {
            wn(S2, b6);
            function S2(A2) {
              var k2 = b6.call(this, A2) || this;
              return k2.applyTransform = r5.applyTransform, k2.buildPath = r5.buildPath, k2;
            }
            return S2;
          }(zut);
          return g5;
        }
        function G8(c5, s) {
          for (var r5 = [], g5 = c5.length, b6 = 0; b6 < g5; b6++) {
            var S2 = c5[b6];
            r5.push(S2.getUpdatedPathProxy(true));
          }
          var A2 = new Tc2(s);
          return A2.createPathProxy(), A2.buildPath = function(k2) {
            if (I2t(k2)) {
              k2.appendPath(r5);
              var R6 = k2.getContext();
              R6 && k2.rebuildPath(R6, 1);
            }
          }, A2;
        }
        function jut(c5, s) {
          s = s || {};
          var r5 = new Tc2();
          return c5.shape && r5.setShape(c5.shape), r5.setStyle(c5.style), s.bakeTransform ? M2t(r5.path, c5.getComputedTransform()) : s.toLocal ? r5.setLocalTransform(c5.getComputedTransform()) : r5.copyTransform(c5), r5.buildPath = c5.buildPath, r5.applyTransform = r5.applyTransform, r5.z = c5.z, r5.z2 = c5.z2, r5.zlevel = c5.zlevel, r5;
        }
        var qjt = function() {
          function c5() {
            this.cx = 0, this.cy = 0, this.r = 0;
          }
          return c5;
        }(), k2t = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultShape = function() {
            return new qjt();
          }, s.prototype.buildPath = function(r5, g5) {
            r5.moveTo(g5.cx + g5.r, g5.cy), r5.arc(g5.cx, g5.cy, g5.r, 0, Math.PI * 2);
          }, s;
        }(Tc2);
        k2t.prototype.type = "circle";
        var qI = k2t, Zjt = function() {
          function c5() {
            this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
          }
          return c5;
        }(), Wut = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultShape = function() {
            return new Zjt();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = 0.5522848, S2 = g5.cx, A2 = g5.cy, k2 = g5.rx, R6 = g5.ry, B3 = k2 * b6, G3 = R6 * b6;
            r5.moveTo(S2 - k2, A2), r5.bezierCurveTo(S2 - k2, A2 - G3, S2 - B3, A2 - R6, S2, A2 - R6), r5.bezierCurveTo(S2 + B3, A2 - R6, S2 + k2, A2 - G3, S2 + k2, A2), r5.bezierCurveTo(S2 + k2, A2 + G3, S2 + B3, A2 + R6, S2, A2 + R6), r5.bezierCurveTo(S2 - B3, A2 + R6, S2 - k2, A2 + G3, S2 - k2, A2), r5.closePath();
          }, s;
        }(Tc2);
        Wut.prototype.type = "ellipse";
        var UK = Wut, P2t = Math.PI, Gut = P2t * 2, mR = Math.sin, H8 = Math.cos, $jt = Math.acos, Wb2 = Math.atan2, L2t = Math.abs, tW = Math.sqrt, eW = Math.max, ZI = Math.min, eT = 1e-4;
        function Yjt(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6 = r5 - c5, B3 = g5 - s, G3 = A2 - b6, Z3 = k2 - S2, X3 = Z3 * R6 - G3 * B3;
          if (!(X3 * X3 < eT))
            return X3 = (G3 * (s - S2) - Z3 * (c5 - b6)) / X3, [c5 + X3 * R6, s + X3 * B3];
        }
        function qK(c5, s, r5, g5, b6, S2, A2) {
          var k2 = c5 - r5, R6 = s - g5, B3 = (A2 ? S2 : -S2) / tW(k2 * k2 + R6 * R6), G3 = B3 * R6, Z3 = -B3 * k2, X3 = c5 + G3, tt = s + Z3, it = r5 + G3, pt = g5 + Z3, mt = (X3 + it) / 2, Mt = (tt + pt) / 2, kt = it - X3, Gt = pt - tt, Ot = kt * kt + Gt * Gt, ce2 = b6 - S2, ae2 = X3 * pt - it * tt, de2 = (Gt < 0 ? -1 : 1) * tW(eW(0, ce2 * ce2 * Ot - ae2 * ae2)), we2 = (ae2 * Gt - kt * de2) / Ot, Se2 = (-ae2 * kt - Gt * de2) / Ot, Oe2 = (ae2 * Gt + kt * de2) / Ot, je2 = (-ae2 * kt + Gt * de2) / Ot, rn = we2 - mt, qe2 = Se2 - Mt, An = Oe2 - mt, jn = je2 - Mt;
          return rn * rn + qe2 * qe2 > An * An + jn * jn && (we2 = Oe2, Se2 = je2), { cx: we2, cy: Se2, x0: -G3, y0: -Z3, x1: we2 * (b6 / ce2 - 1), y1: Se2 * (b6 / ce2 - 1) };
        }
        function Kjt(c5) {
          var s;
          if (ja2(c5)) {
            var r5 = c5.length;
            if (!r5)
              return c5;
            r5 === 1 ? s = [c5[0], c5[0], 0, 0] : r5 === 2 ? s = [c5[0], c5[0], c5[1], c5[1]] : r5 === 3 ? s = c5.concat(c5[2]) : s = c5;
          } else
            s = [c5, c5, c5, c5];
          return s;
        }
        function Xjt(c5, s) {
          var r5, g5 = eW(s.r, 0), b6 = eW(s.r0 || 0, 0), S2 = g5 > 0, A2 = b6 > 0;
          if (!(!S2 && !A2)) {
            if (S2 || (g5 = b6, b6 = 0), b6 > g5) {
              var k2 = g5;
              g5 = b6, b6 = k2;
            }
            var R6 = s.startAngle, B3 = s.endAngle;
            if (!(isNaN(R6) || isNaN(B3))) {
              var G3 = s.cx, Z3 = s.cy, X3 = !!s.clockwise, tt = L2t(B3 - R6), it = tt > Gut && tt % Gut;
              if (it > eT && (tt = it), !(g5 > eT))
                c5.moveTo(G3, Z3);
              else if (tt > Gut - eT)
                c5.moveTo(G3 + g5 * H8(R6), Z3 + g5 * mR(R6)), c5.arc(G3, Z3, g5, R6, B3, !X3), b6 > eT && (c5.moveTo(G3 + b6 * H8(B3), Z3 + b6 * mR(B3)), c5.arc(G3, Z3, b6, B3, R6, X3));
              else {
                var pt = void 0, mt = void 0, Mt = void 0, kt = void 0, Gt = void 0, Ot = void 0, ce2 = void 0, ae2 = void 0, de2 = void 0, we2 = void 0, Se2 = void 0, Oe2 = void 0, je2 = void 0, rn = void 0, qe2 = void 0, An = void 0, jn = g5 * H8(R6), _n = g5 * mR(R6), Jr = b6 * H8(B3), Qn = b6 * mR(B3), rr = tt > eT;
                if (rr) {
                  var Ar = s.cornerRadius;
                  Ar && (r5 = Kjt(Ar), pt = r5[0], mt = r5[1], Mt = r5[2], kt = r5[3]);
                  var fi2 = L2t(g5 - b6) / 2;
                  if (Gt = ZI(fi2, Mt), Ot = ZI(fi2, kt), ce2 = ZI(fi2, pt), ae2 = ZI(fi2, mt), Se2 = de2 = eW(Gt, Ot), Oe2 = we2 = eW(ce2, ae2), (de2 > eT || we2 > eT) && (je2 = g5 * H8(B3), rn = g5 * mR(B3), qe2 = b6 * H8(R6), An = b6 * mR(R6), tt < P2t)) {
                    var mi2 = Yjt(jn, _n, qe2, An, je2, rn, Jr, Qn);
                    if (mi2) {
                      var Oo = jn - mi2[0], Ts = _n - mi2[1], gl = je2 - mi2[0], nl = rn - mi2[1], rl = 1 / mR($jt((Oo * gl + Ts * nl) / (tW(Oo * Oo + Ts * Ts) * tW(gl * gl + nl * nl))) / 2), ss = tW(mi2[0] * mi2[0] + mi2[1] * mi2[1]);
                      Se2 = ZI(de2, (g5 - ss) / (rl + 1)), Oe2 = ZI(we2, (b6 - ss) / (rl - 1));
                    }
                  }
                }
                if (!rr)
                  c5.moveTo(G3 + jn, Z3 + _n);
                else if (Se2 > eT) {
                  var Us = ZI(Mt, Se2), sl = ZI(kt, Se2), ws = qK(qe2, An, jn, _n, g5, Us, X3), Ll = qK(je2, rn, Jr, Qn, g5, sl, X3);
                  c5.moveTo(G3 + ws.cx + ws.x0, Z3 + ws.cy + ws.y0), Se2 < de2 && Us === sl ? c5.arc(G3 + ws.cx, Z3 + ws.cy, Se2, Wb2(ws.y0, ws.x0), Wb2(Ll.y0, Ll.x0), !X3) : (Us > 0 && c5.arc(G3 + ws.cx, Z3 + ws.cy, Us, Wb2(ws.y0, ws.x0), Wb2(ws.y1, ws.x1), !X3), c5.arc(G3, Z3, g5, Wb2(ws.cy + ws.y1, ws.cx + ws.x1), Wb2(Ll.cy + Ll.y1, Ll.cx + Ll.x1), !X3), sl > 0 && c5.arc(G3 + Ll.cx, Z3 + Ll.cy, sl, Wb2(Ll.y1, Ll.x1), Wb2(Ll.y0, Ll.x0), !X3));
                } else
                  c5.moveTo(G3 + jn, Z3 + _n), c5.arc(G3, Z3, g5, R6, B3, !X3);
                if (!(b6 > eT) || !rr)
                  c5.lineTo(G3 + Jr, Z3 + Qn);
                else if (Oe2 > eT) {
                  var Us = ZI(pt, Oe2), sl = ZI(mt, Oe2), ws = qK(Jr, Qn, je2, rn, b6, -sl, X3), Ll = qK(jn, _n, qe2, An, b6, -Us, X3);
                  c5.lineTo(G3 + ws.cx + ws.x0, Z3 + ws.cy + ws.y0), Oe2 < we2 && Us === sl ? c5.arc(G3 + ws.cx, Z3 + ws.cy, Oe2, Wb2(ws.y0, ws.x0), Wb2(Ll.y0, Ll.x0), !X3) : (sl > 0 && c5.arc(G3 + ws.cx, Z3 + ws.cy, sl, Wb2(ws.y0, ws.x0), Wb2(ws.y1, ws.x1), !X3), c5.arc(G3, Z3, b6, Wb2(ws.cy + ws.y1, ws.cx + ws.x1), Wb2(Ll.cy + Ll.y1, Ll.cx + Ll.x1), X3), Us > 0 && c5.arc(G3 + Ll.cx, Z3 + Ll.cy, Us, Wb2(Ll.y1, Ll.x1), Wb2(Ll.y0, Ll.x0), !X3));
                } else
                  c5.lineTo(G3 + Jr, Z3 + Qn), c5.arc(G3, Z3, b6, B3, R6, X3);
              }
              c5.closePath();
            }
          }
        }
        var Qjt = function() {
          function c5() {
            this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
          }
          return c5;
        }(), O2t = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultShape = function() {
            return new Qjt();
          }, s.prototype.buildPath = function(r5, g5) {
            Xjt(r5, g5);
          }, s.prototype.isZeroArea = function() {
            return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
          }, s;
        }(Tc2);
        O2t.prototype.type = "sector";
        var Ww = O2t, Jjt = function() {
          function c5() {
            this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
          }
          return c5;
        }(), R2t = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultShape = function() {
            return new Jjt();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.cx, S2 = g5.cy, A2 = Math.PI * 2;
            r5.moveTo(b6 + g5.r, S2), r5.arc(b6, S2, g5.r, 0, A2, false), r5.moveTo(b6 + g5.r0, S2), r5.arc(b6, S2, g5.r0, 0, A2, true);
          }, s;
        }(Tc2);
        R2t.prototype.type = "ring";
        var ZK = R2t;
        function tWt(c5, s, r5, g5) {
          var b6 = [], S2 = [], A2 = [], k2 = [], R6, B3, G3, Z3;
          if (g5) {
            G3 = [1 / 0, 1 / 0], Z3 = [-1 / 0, -1 / 0];
            for (var X3 = 0, tt = c5.length; X3 < tt; X3++)
              BC(G3, G3, c5[X3]), c2(Z3, Z3, c5[X3]);
            BC(G3, G3, g5[0]), c2(Z3, Z3, g5[1]);
          }
          for (var X3 = 0, tt = c5.length; X3 < tt; X3++) {
            var it = c5[X3];
            if (r5)
              R6 = c5[X3 ? X3 - 1 : tt - 1], B3 = c5[(X3 + 1) % tt];
            else if (X3 === 0 || X3 === tt - 1) {
              b6.push(Iy(c5[X3]));
              continue;
            } else
              R6 = c5[X3 - 1], B3 = c5[X3 + 1];
            kI(S2, B3, R6), PI3(S2, S2, s);
            var pt = nlt(it, R6), mt = nlt(it, B3), Mt = pt + mt;
            Mt !== 0 && (pt /= Mt, mt /= Mt), PI3(A2, S2, -pt), PI3(k2, S2, mt);
            var kt = elt([], it, A2), Gt = elt([], it, k2);
            g5 && (c2(kt, kt, G3), BC(kt, kt, Z3), c2(Gt, Gt, G3), BC(Gt, Gt, Z3)), b6.push(kt), b6.push(Gt);
          }
          return r5 && b6.push(b6.shift()), b6;
        }
        function N2t(c5, s, r5) {
          var g5 = s.smooth, b6 = s.points;
          if (b6 && b6.length >= 2) {
            if (g5) {
              var S2 = tWt(b6, g5, r5, s.smoothConstraint);
              c5.moveTo(b6[0][0], b6[0][1]);
              for (var A2 = b6.length, k2 = 0; k2 < (r5 ? A2 : A2 - 1); k2++) {
                var R6 = S2[k2 * 2], B3 = S2[k2 * 2 + 1], G3 = b6[(k2 + 1) % A2];
                c5.bezierCurveTo(R6[0], R6[1], B3[0], B3[1], G3[0], G3[1]);
              }
            } else {
              c5.moveTo(b6[0][0], b6[0][1]);
              for (var k2 = 1, Z3 = b6.length; k2 < Z3; k2++)
                c5.lineTo(b6[k2][0], b6[k2][1]);
            }
            r5 && c5.closePath();
          }
        }
        var eWt = function() {
          function c5() {
            this.points = null, this.smooth = 0, this.smoothConstraint = null;
          }
          return c5;
        }(), F2t = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultShape = function() {
            return new eWt();
          }, s.prototype.buildPath = function(r5, g5) {
            N2t(r5, g5, true);
          }, s;
        }(Tc2);
        F2t.prototype.type = "polygon";
        var Gb2 = F2t, V2t = function() {
          function c5() {
            this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
          }
          return c5;
        }(), Hut = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new V2t();
          }, s.prototype.buildPath = function(r5, g5) {
            N2t(r5, g5, false);
          }, s;
        }(Tc2);
        Hut.prototype.type = "polyline";
        var Gw = Hut, nWt = {}, rWt = function() {
          function c5() {
            this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
          }
          return c5;
        }(), $K = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new rWt();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6, S2, A2, k2;
            if (this.subPixelOptimize) {
              var R6 = xut(nWt, g5, this.style);
              b6 = R6.x1, S2 = R6.y1, A2 = R6.x2, k2 = R6.y2;
            } else
              b6 = g5.x1, S2 = g5.y1, A2 = g5.x2, k2 = g5.y2;
            var B3 = g5.percent;
            B3 !== 0 && (r5.moveTo(b6, S2), B3 < 1 && (A2 = b6 * (1 - B3) + A2 * B3, k2 = S2 * (1 - B3) + k2 * B3), r5.lineTo(A2, k2));
          }, s.prototype.pointAt = function(r5) {
            var g5 = this.shape;
            return [g5.x1 * (1 - r5) + g5.x2 * r5, g5.y1 * (1 - r5) + g5.y2 * r5];
          }, s;
        }(Tc2);
        $K.prototype.type = "line";
        var Zm = $K, Hw = [], iWt = function() {
          function c5() {
            this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
          }
          return c5;
        }();
        function bx(c5, s, r5) {
          var g5 = c5.cpx2, b6 = c5.cpy2;
          return g5 != null || b6 != null ? [(r5 ? fSt : D0)(c5.x1, c5.cpx1, c5.cpx2, c5.x2, s), (r5 ? fSt : D0)(c5.y1, c5.cpy1, c5.cpy2, c5.y2, s)] : [(r5 ? ZY : Hm)(c5.x1, c5.cpx1, c5.x2, s), (r5 ? ZY : Hm)(c5.y1, c5.cpy1, c5.y2, s)];
        }
        var YK = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new iWt();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.x1, S2 = g5.y1, A2 = g5.x2, k2 = g5.y2, R6 = g5.cpx1, B3 = g5.cpy1, G3 = g5.cpx2, Z3 = g5.cpy2, X3 = g5.percent;
            X3 !== 0 && (r5.moveTo(b6, S2), G3 == null || Z3 == null ? (X3 < 1 && (u0(b6, R6, A2, X3, Hw), R6 = Hw[1], A2 = Hw[2], u0(S2, B3, k2, X3, Hw), B3 = Hw[1], k2 = Hw[2]), r5.quadraticCurveTo(R6, B3, A2, k2)) : (X3 < 1 && (GC(b6, R6, G3, A2, X3, Hw), R6 = Hw[1], G3 = Hw[2], A2 = Hw[3], GC(S2, B3, Z3, k2, X3, Hw), B3 = Hw[1], Z3 = Hw[2], k2 = Hw[3]), r5.bezierCurveTo(R6, B3, G3, Z3, A2, k2)));
          }, s.prototype.pointAt = function(r5) {
            return bx(this.shape, r5, false);
          }, s.prototype.tangentAt = function(r5) {
            var g5 = bx(this.shape, r5, true);
            return z4(g5, g5);
          }, s;
        }(Tc2);
        YK.prototype.type = "bezier-curve";
        var KK = YK, aWt = function() {
          function c5() {
            this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
          }
          return c5;
        }(), B2t = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new aWt();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.cx, S2 = g5.cy, A2 = Math.max(g5.r, 0), k2 = g5.startAngle, R6 = g5.endAngle, B3 = g5.clockwise, G3 = Math.cos(k2), Z3 = Math.sin(k2);
            r5.moveTo(G3 * A2 + b6, Z3 * A2 + S2), r5.arc(b6, S2, A2, k2, R6, !B3);
          }, s;
        }(Tc2);
        B2t.prototype.type = "arc";
        var Uut = B2t, qut = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "compound", r5;
          }
          return s.prototype._updatePathDirty = function() {
            for (var r5 = this.shape.paths, g5 = this.shapeChanged(), b6 = 0; b6 < r5.length; b6++)
              g5 = g5 || r5[b6].shapeChanged();
            g5 && this.dirtyShape();
          }, s.prototype.beforeBrush = function() {
            this._updatePathDirty();
            for (var r5 = this.shape.paths || [], g5 = this.getGlobalScale(), b6 = 0; b6 < r5.length; b6++)
              r5[b6].path || r5[b6].createPathProxy(), r5[b6].path.setScale(g5[0], g5[1], r5[b6].segmentIgnoreThreshold);
          }, s.prototype.buildPath = function(r5, g5) {
            for (var b6 = g5.paths || [], S2 = 0; S2 < b6.length; S2++)
              b6[S2].buildPath(r5, b6[S2].shape, true);
          }, s.prototype.afterBrush = function() {
            for (var r5 = this.shape.paths || [], g5 = 0; g5 < r5.length; g5++)
              r5[g5].pathUpdated();
          }, s.prototype.getBoundingRect = function() {
            return this._updatePathDirty.call(this), Tc2.prototype.getBoundingRect.call(this);
          }, s;
        }(Tc2), Zut = qut, $ut = function() {
          function c5(s) {
            this.colorStops = s || [];
          }
          return c5.prototype.addColorStop = function(s, r5) {
            this.colorStops.push({ offset: s, color: r5 });
          }, c5;
        }(), z2t = $ut, oWt = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2, A2, k2) {
            var R6 = c5.call(this, A2) || this;
            return R6.x = r5 == null ? 0 : r5, R6.y = g5 == null ? 0 : g5, R6.x2 = b6 == null ? 1 : b6, R6.y2 = S2 == null ? 0 : S2, R6.type = "linear", R6.global = k2 || false, R6;
          }
          return s;
        }(z2t), nW = oWt, sWt = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2, A2) {
            var k2 = c5.call(this, S2) || this;
            return k2.x = r5 == null ? 0.5 : r5, k2.y = g5 == null ? 0.5 : g5, k2.r = b6 == null ? 0.5 : b6, k2.type = "radial", k2.global = A2 || false, k2;
          }
          return s;
        }(z2t), Yut = sWt, bR = [0, 0], _R = [0, 0], XK = new Bu(), U8 = new Bu(), Kut = function() {
          function c5(s, r5) {
            this._corners = [], this._axes = [], this._origin = [0, 0];
            for (var g5 = 0; g5 < 4; g5++)
              this._corners[g5] = new Bu();
            for (var g5 = 0; g5 < 2; g5++)
              this._axes[g5] = new Bu();
            s && this.fromBoundingRect(s, r5);
          }
          return c5.prototype.fromBoundingRect = function(s, r5) {
            var g5 = this._corners, b6 = this._axes, S2 = s.x, A2 = s.y, k2 = S2 + s.width, R6 = A2 + s.height;
            if (g5[0].set(S2, A2), g5[1].set(k2, A2), g5[2].set(k2, R6), g5[3].set(S2, R6), r5)
              for (var B3 = 0; B3 < 4; B3++)
                g5[B3].transform(r5);
            Bu.sub(b6[0], g5[1], g5[0]), Bu.sub(b6[1], g5[3], g5[0]), b6[0].normalize(), b6[1].normalize();
            for (var B3 = 0; B3 < 2; B3++)
              this._origin[B3] = b6[B3].dot(g5[0]);
          }, c5.prototype.intersect = function(s, r5) {
            var g5 = true, b6 = !r5;
            return XK.set(1 / 0, 1 / 0), U8.set(0, 0), !this._intersectCheckOneSide(this, s, XK, U8, b6, 1) && (g5 = false, b6) || !this._intersectCheckOneSide(s, this, XK, U8, b6, -1) && (g5 = false, b6) || b6 || Bu.copy(r5, g5 ? XK : U8), g5;
          }, c5.prototype._intersectCheckOneSide = function(s, r5, g5, b6, S2, A2) {
            for (var k2 = true, R6 = 0; R6 < 2; R6++) {
              var B3 = this._axes[R6];
              if (this._getProjMinMaxOnAxis(R6, s._corners, bR), this._getProjMinMaxOnAxis(R6, r5._corners, _R), bR[1] < _R[0] || bR[0] > _R[1]) {
                if (k2 = false, S2)
                  return k2;
                var G3 = Math.abs(_R[0] - bR[1]), Z3 = Math.abs(bR[0] - _R[1]);
                Math.min(G3, Z3) > b6.len() && (G3 < Z3 ? Bu.scale(b6, B3, -G3 * A2) : Bu.scale(b6, B3, Z3 * A2));
              } else if (g5) {
                var G3 = Math.abs(_R[0] - bR[1]), Z3 = Math.abs(bR[0] - _R[1]);
                Math.min(G3, Z3) < g5.len() && (G3 < Z3 ? Bu.scale(g5, B3, G3 * A2) : Bu.scale(g5, B3, -Z3 * A2));
              }
            }
            return k2;
          }, c5.prototype._getProjMinMaxOnAxis = function(s, r5, g5) {
            for (var b6 = this._axes[s], S2 = this._origin, A2 = r5[0].dot(b6) + S2[s], k2 = A2, R6 = A2, B3 = 1; B3 < r5.length; B3++) {
              var G3 = r5[B3].dot(b6) + S2[s];
              k2 = Math.min(G3, k2), R6 = Math.max(G3, R6);
            }
            g5[0] = k2, g5[1] = R6;
          }, c5;
        }(), QK = Kut, lWt = [], uWt = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.notClear = true, r5.incremental = true, r5._displayables = [], r5._temporaryDisplayables = [], r5._cursor = 0, r5;
          }
          return s.prototype.traverse = function(r5, g5) {
            r5.call(g5, this);
          }, s.prototype.useStyle = function() {
            this.style = {};
          }, s.prototype.getCursor = function() {
            return this._cursor;
          }, s.prototype.innerAfterBrush = function() {
            this._cursor = this._displayables.length;
          }, s.prototype.clearDisplaybles = function() {
            this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
          }, s.prototype.clearTemporalDisplayables = function() {
            this._temporaryDisplayables = [];
          }, s.prototype.addDisplayable = function(r5, g5) {
            g5 ? this._temporaryDisplayables.push(r5) : this._displayables.push(r5), this.markRedraw();
          }, s.prototype.addDisplayables = function(r5, g5) {
            g5 = g5 || false;
            for (var b6 = 0; b6 < r5.length; b6++)
              this.addDisplayable(r5[b6], g5);
          }, s.prototype.getDisplayables = function() {
            return this._displayables;
          }, s.prototype.getTemporalDisplayables = function() {
            return this._temporaryDisplayables;
          }, s.prototype.eachPendingDisplayable = function(r5) {
            for (var g5 = this._cursor; g5 < this._displayables.length; g5++)
              r5 && r5(this._displayables[g5]);
            for (var g5 = 0; g5 < this._temporaryDisplayables.length; g5++)
              r5 && r5(this._temporaryDisplayables[g5]);
          }, s.prototype.update = function() {
            this.updateTransform();
            for (var r5 = this._cursor; r5 < this._displayables.length; r5++) {
              var g5 = this._displayables[r5];
              g5.parent = this, g5.update(), g5.parent = null;
            }
            for (var r5 = 0; r5 < this._temporaryDisplayables.length; r5++) {
              var g5 = this._temporaryDisplayables[r5];
              g5.parent = this, g5.update(), g5.parent = null;
            }
          }, s.prototype.getBoundingRect = function() {
            if (!this._rect) {
              for (var r5 = new lc2(1 / 0, 1 / 0, -1 / 0, -1 / 0), g5 = 0; g5 < this._displayables.length; g5++) {
                var b6 = this._displayables[g5], S2 = b6.getBoundingRect().clone();
                b6.needLocalTransform() && S2.applyTransform(b6.getLocalTransform(lWt)), r5.union(S2);
              }
              this._rect = r5;
            }
            return this._rect;
          }, s.prototype.contain = function(r5, g5) {
            var b6 = this.transformCoordToLocal(r5, g5), S2 = this.getBoundingRect();
            if (S2.contain(b6[0], b6[1]))
              for (var A2 = 0; A2 < this._displayables.length; A2++) {
                var k2 = this._displayables[A2];
                if (k2.contain(r5, g5))
                  return true;
              }
            return false;
          }, s;
        }(SM), cWt = uWt, j2t = Df2();
        function q8(c5, s, r5, g5, b6) {
          var S2;
          if (s && s.ecModel) {
            var A2 = s.ecModel.getUpdatePayload();
            S2 = A2 && A2.animation;
          }
          var k2 = s && s.isAnimationEnabled(), R6 = c5 === "update";
          if (k2) {
            var B3 = void 0, G3 = void 0, Z3 = void 0;
            g5 ? (B3 = tc2(g5.duration, 200), G3 = tc2(g5.easing, "cubicOut"), Z3 = 0) : (B3 = s.getShallow(R6 ? "animationDurationUpdate" : "animationDuration"), G3 = s.getShallow(R6 ? "animationEasingUpdate" : "animationEasing"), Z3 = s.getShallow(R6 ? "animationDelayUpdate" : "animationDelay")), S2 && (S2.duration != null && (B3 = S2.duration), S2.easing != null && (G3 = S2.easing), S2.delay != null && (Z3 = S2.delay)), Tl(Z3) && (Z3 = Z3(r5, b6)), Tl(B3) && (B3 = B3(r5));
            var X3 = { duration: B3 || 0, delay: Z3, easing: G3 };
            return X3;
          } else
            return null;
        }
        function Xut(c5, s, r5, g5, b6, S2, A2) {
          var k2 = false, R6;
          Tl(b6) ? (A2 = S2, S2 = b6, b6 = null) : Wl(b6) && (S2 = b6.cb, A2 = b6.during, k2 = b6.isFrom, R6 = b6.removeOpt, b6 = b6.dataIndex);
          var B3 = c5 === "leave";
          B3 || s.stopAnimation("leave");
          var G3 = q8(c5, g5, b6, B3 ? R6 || {} : null, g5 && g5.getAnimationDelayParams ? g5.getAnimationDelayParams(s, b6) : null);
          if (G3 && G3.duration > 0) {
            var Z3 = G3.duration, X3 = G3.delay, tt = G3.easing, it = { duration: Z3, delay: X3 || 0, easing: tt, done: S2, force: !!S2 || !!A2, setToFinal: !B3, scope: c5, during: A2 };
            k2 ? s.animateFrom(r5, it) : s.animateTo(r5, it);
          } else
            s.stopAnimation(), !k2 && s.attr(r5), A2 && A2(1), S2 && S2();
        }
        function Qf2(c5, s, r5, g5, b6, S2) {
          Xut("update", c5, s, r5, g5, b6, S2);
        }
        function tv(c5, s, r5, g5, b6, S2) {
          Xut("enter", c5, s, r5, g5, b6, S2);
        }
        function Z8(c5) {
          if (!c5.__zr)
            return true;
          for (var s = 0; s < c5.animators.length; s++) {
            var r5 = c5.animators[s];
            if (r5.scope === "leave")
              return true;
          }
          return false;
        }
        function A3(c5, s, r5, g5, b6, S2) {
          Z8(c5) || Xut("leave", c5, s, r5, g5, b6, S2);
        }
        function W2t(c5, s, r5, g5) {
          c5.removeTextContent(), c5.removeTextGuideLine(), A3(c5, { style: { opacity: 0 } }, s, r5, g5);
        }
        function rW(c5, s, r5) {
          function g5() {
            c5.parent && c5.parent.remove(c5);
          }
          c5.isGroup ? c5.traverse(function(b6) {
            b6.isGroup || W2t(b6, s, r5, g5);
          }) : W2t(c5, s, r5, g5);
        }
        function nT(c5) {
          j2t(c5).oldStyle = c5.style;
        }
        function fWt(c5) {
          return j2t(c5).oldStyle;
        }
        var JK = Math.max, tX = Math.min, Qut = {};
        function hWt(c5) {
          return Tc2.extend(c5);
        }
        var pWt = Ujt;
        function dWt(c5, s) {
          return pWt(c5, s);
        }
        function ot(c5, s) {
          Qut[c5] = s;
        }
        function St(c5) {
          if (Qut.hasOwnProperty(c5))
            return Qut[c5];
        }
        function Xt(c5, s, r5, g5) {
          var b6 = E2t(c5, s);
          return r5 && (g5 === "center" && (r5 = cn(r5, b6.getBoundingRect())), zr(b6, r5)), b6;
        }
        function Ie2(c5, s, r5) {
          var g5 = new qm({ style: { image: c5, x: s.x, y: s.y, width: s.width, height: s.height }, onload: function(b6) {
            if (r5 === "center") {
              var S2 = { width: b6.width, height: b6.height };
              g5.setStyle(cn(s, S2));
            }
          } });
          return g5;
        }
        function cn(c5, s) {
          var r5 = s.width / s.height, g5 = c5.height * r5, b6;
          g5 <= c5.width ? b6 = c5.height : (g5 = c5.width, b6 = g5 / r5);
          var S2 = c5.x + c5.width / 2, A2 = c5.y + c5.height / 2;
          return { x: S2 - g5 / 2, y: A2 - b6 / 2, width: g5, height: b6 };
        }
        var Wn = G8;
        function zr(c5, s) {
          if (c5.applyTransform) {
            var r5 = c5.getBoundingRect(), g5 = r5.calculateTransform(s);
            c5.applyTransform(g5);
          }
        }
        function Qr(c5) {
          return xut(c5.shape, c5.shape, c5.style), c5;
        }
        function Ni2(c5) {
          return wut(c5.shape, c5.shape, c5.style), c5;
        }
        var wo = M3;
        function vo(c5, s) {
          for (var r5 = Dj2([]); c5 && c5 !== s; )
            _k(r5, c5.getLocalTransform(), r5), c5 = c5.parent;
          return r5;
        }
        function Lo(c5, s, r5) {
          return s && !Fb2(s) && (s = YC.getLocalTransform(s)), r5 && (s = Y4([], s)), Gm([], c5, s);
        }
        function Ks(c5, s, r5) {
          var g5 = s[4] === 0 || s[5] === 0 || s[0] === 0 ? 1 : Math.abs(2 * s[4] / s[0]), b6 = s[4] === 0 || s[5] === 0 || s[2] === 0 ? 1 : Math.abs(2 * s[4] / s[2]), S2 = [c5 === "left" ? -g5 : c5 === "right" ? g5 : 0, c5 === "top" ? -b6 : c5 === "bottom" ? b6 : 0];
          return S2 = Lo(S2, s, r5), Math.abs(S2[0]) > Math.abs(S2[1]) ? S2[0] > 0 ? "right" : "left" : S2[1] > 0 ? "bottom" : "top";
        }
        function yu(c5) {
          return !c5.isGroup;
        }
        function gc2(c5) {
          return c5.shape != null;
        }
        function of2(c5, s, r5) {
          if (!c5 || !s)
            return;
          function g5(A2) {
            var k2 = {};
            return A2.traverse(function(R6) {
              yu(R6) && R6.anid && (k2[R6.anid] = R6);
            }), k2;
          }
          function b6(A2) {
            var k2 = { x: A2.x, y: A2.y, rotation: A2.rotation };
            return gc2(A2) && (k2.shape = sa2({}, A2.shape)), k2;
          }
          var S2 = g5(c5);
          s.traverse(function(A2) {
            if (yu(A2) && A2.anid) {
              var k2 = S2[A2.anid];
              if (k2) {
                var R6 = b6(A2);
                A2.attr(b6(k2)), Qf2(A2, R6, r5, Pl(A2).dataIndex);
              }
            }
          });
        }
        function uc2(c5, s) {
          return Ha2(c5, function(r5) {
            var g5 = r5[0];
            g5 = JK(g5, s.x), g5 = tX(g5, s.x + s.width);
            var b6 = r5[1];
            return b6 = JK(b6, s.y), b6 = tX(b6, s.y + s.height), [g5, b6];
          });
        }
        function Kh2(c5, s) {
          var r5 = JK(c5.x, s.x), g5 = tX(c5.x + c5.width, s.x + s.width), b6 = JK(c5.y, s.y), S2 = tX(c5.y + c5.height, s.y + s.height);
          if (g5 >= r5 && S2 >= b6)
            return { x: r5, y: b6, width: g5 - r5, height: S2 - b6 };
        }
        function ph2(c5, s, r5) {
          var g5 = sa2({ rectHover: true }, s), b6 = g5.style = { strokeNoScale: true };
          if (r5 = r5 || { x: -1, y: -1, width: 2, height: 2 }, c5)
            return c5.indexOf("image://") === 0 ? (b6.image = c5.slice(8), Cl(b6, r5), new qm(g5)) : Xt(c5.replace("path://", ""), g5, r5, "center");
        }
        function j1(c5, s, r5, g5, b6) {
          for (var S2 = 0, A2 = b6[b6.length - 1]; S2 < b6.length; S2++) {
            var k2 = b6[S2];
            if (Hb2(c5, s, r5, g5, k2[0], k2[1], A2[0], A2[1]))
              return true;
            A2 = k2;
          }
        }
        function Hb2(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6 = r5 - c5, B3 = g5 - s, G3 = A2 - b6, Z3 = k2 - S2, X3 = _x(G3, Z3, R6, B3);
          if (J0(X3))
            return false;
          var tt = c5 - b6, it = s - S2, pt = _x(tt, it, R6, B3) / X3;
          if (pt < 0 || pt > 1)
            return false;
          var mt = _x(tt, it, G3, Z3) / X3;
          return !(mt < 0 || mt > 1);
        }
        function _x(c5, s, r5, g5) {
          return c5 * g5 - r5 * s;
        }
        function J0(c5) {
          return c5 <= 1e-6 && c5 >= -1e-6;
        }
        function Ub2(c5) {
          var s = c5.itemTooltipOption, r5 = c5.componentModel, g5 = c5.itemName, b6 = gs(s) ? { formatter: s } : s, S2 = r5.mainType, A2 = r5.componentIndex, k2 = { componentType: S2, name: g5, $vars: ["name"] };
          k2[S2 + "Index"] = A2;
          var R6 = c5.formatterParamsExtra;
          R6 && Ye2(nf2(R6), function(G3) {
            Ls(k2, G3) || (k2[G3] = R6[G3], k2.$vars.push(G3));
          });
          var B3 = Pl(c5.el);
          B3.componentMainType = S2, B3.componentIndex = A2, B3.tooltipConfig = { name: g5, option: Cl({ content: g5, formatterParams: k2 }, b6) };
        }
        function $I(c5, s) {
          var r5;
          c5.isGroup && (r5 = s(c5)), r5 || c5.traverse(s);
        }
        function Ik(c5, s) {
          if (c5)
            if (ja2(c5))
              for (var r5 = 0; r5 < c5.length; r5++)
                $I(c5[r5], s);
            else
              $I(c5, s);
        }
        ot("circle", qI), ot("ellipse", UK), ot("sector", Ww), ot("ring", ZK), ot("polygon", Gb2), ot("polyline", Gw), ot("rect", zf2), ot("line", Zm), ot("bezierCurve", KK), ot("arc", Uut);
        var Jut = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: Qf2, initProps: tv, removeElement: A3, removeElementWithFadeOut: rW, isElementRemoved: Z8, extendShape: hWt, extendPath: dWt, registerShape: ot, getShapeClass: St, makePath: Xt, makeImage: Ie2, mergePath: Wn, resizePath: zr, subPixelOptimizeLine: Qr, subPixelOptimizeRect: Ni2, subPixelOptimize: wo, getTransform: vo, applyTransform: Lo, transformDirection: Ks, groupTransition: of2, clipPointsByRect: uc2, clipRectByRect: Kh2, createIcon: ph2, linePolygonIntersect: j1, lineLineIntersect: Hb2, setTooltipConfig: Ub2, traverseElements: Ik, Group: nu, Image: qm, Text: hh2, Circle: qI, Ellipse: UK, Sector: Ww, Ring: ZK, Polygon: Gb2, Polyline: Gw, Rect: zf2, Line: Zm, BezierCurve: KK, Arc: Uut, IncrementalDisplayable: cWt, CompoundPath: Zut, LinearGradient: nW, RadialGradient: Yut, BoundingRect: lc2, OrientedBoundingRect: QK, Point: Bu, Path: Tc2 }, Symbol.toStringTag, { value: "Module" })), G2t = {};
        function ECe(c5, s) {
          for (var r5 = 0; r5 < k0.length; r5++) {
            var g5 = k0[r5], b6 = s[g5], S2 = c5.ensureState(g5);
            S2.style = S2.style || {}, S2.style.text = b6;
          }
          var A2 = c5.currentStates.slice();
          c5.clearStates(true), c5.setStyle({ text: s.normal }), c5.useStates(A2, true);
        }
        function gWt(c5, s, r5) {
          var g5 = c5.labelFetcher, b6 = c5.labelDataIndex, S2 = c5.labelDimIndex, A2 = s.normal, k2;
          g5 && (k2 = g5.getFormattedLabel(b6, "normal", null, S2, A2 && A2.get("formatter"), r5 != null ? { interpolatedValue: r5 } : null)), k2 == null && (k2 = Tl(c5.defaultText) ? c5.defaultText(b6, c5, r5) : c5.defaultText);
          for (var R6 = { normal: k2 }, B3 = 0; B3 < k0.length; B3++) {
            var G3 = k0[B3], Z3 = s[G3];
            R6[G3] = tc2(g5 ? g5.getFormattedLabel(b6, G3, null, S2, Z3 && Z3.get("formatter")) : null, k2);
          }
          return R6;
        }
        function Uw(c5, s, r5, g5) {
          r5 = r5 || G2t;
          for (var b6 = c5 instanceof hh2, S2 = false, A2 = 0; A2 < Yj2.length; A2++) {
            var k2 = s[Yj2[A2]];
            if (k2 && k2.getShallow("show")) {
              S2 = true;
              break;
            }
          }
          var R6 = b6 ? c5 : c5.getTextContent();
          if (S2) {
            b6 || (R6 || (R6 = new hh2(), c5.setTextContent(R6)), c5.stateProxy && (R6.stateProxy = c5.stateProxy));
            var B3 = gWt(r5, s), G3 = s.normal, Z3 = !!G3.getShallow("show"), X3 = Ey(G3, g5 && g5.normal, r5, false, !b6);
            X3.text = B3.normal, b6 || c5.setTextConfig(H2t(G3, r5, false));
            for (var A2 = 0; A2 < k0.length; A2++) {
              var tt = k0[A2], k2 = s[tt];
              if (k2) {
                var it = R6.ensureState(tt), pt = !!tc2(k2.getShallow("show"), Z3);
                if (pt !== Z3 && (it.ignore = !pt), it.style = Ey(k2, g5 && g5[tt], r5, true, !b6), it.style.text = B3[tt], !b6) {
                  var mt = c5.ensureState(tt);
                  mt.textConfig = H2t(k2, r5, true);
                }
              }
            }
            R6.silent = !!G3.getShallow("silent"), R6.style.x != null && (X3.x = R6.style.x), R6.style.y != null && (X3.y = R6.style.y), R6.ignore = !Z3, R6.useStyle(X3), R6.dirty(), r5.enableTextSetter && (eX(R6).setLabelText = function(Mt) {
              var kt = gWt(r5, s, Mt);
              ECe(R6, kt);
            });
          } else
            R6 && (R6.ignore = true);
          c5.dirty();
        }
        function qb2(c5, s) {
          s = s || "label";
          for (var r5 = { normal: c5.getModel(s) }, g5 = 0; g5 < k0.length; g5++) {
            var b6 = k0[g5];
            r5[b6] = c5.getModel([b6, s]);
          }
          return r5;
        }
        function Ey(c5, s, r5, g5, b6) {
          var S2 = {};
          return KRn(S2, c5, r5, g5, b6), s && sa2(S2, s), S2;
        }
        function H2t(c5, s, r5) {
          s = s || {};
          var g5 = {}, b6, S2 = c5.getShallow("rotate"), A2 = tc2(c5.getShallow("distance"), r5 ? null : 5), k2 = c5.getShallow("offset");
          return b6 = c5.getShallow("position") || (r5 ? null : "inside"), b6 === "outside" && (b6 = s.defaultOutsidePosition || "top"), b6 != null && (g5.position = b6), k2 != null && (g5.offset = k2), S2 != null && (S2 *= Math.PI / 180, g5.rotation = S2), A2 != null && (g5.distance = A2), g5.outsideFill = c5.get("color") === "inherit" ? s.inheritColor || null : "auto", g5;
        }
        function KRn(c5, s, r5, g5, b6) {
          r5 = r5 || G2t;
          var S2 = s.ecModel, A2 = S2 && S2.option.textStyle, k2 = XRn(s), R6;
          if (k2) {
            R6 = {};
            for (var B3 in k2)
              if (k2.hasOwnProperty(B3)) {
                var G3 = s.getModel(["rich", B3]);
                OCe(R6[B3] = {}, G3, A2, r5, g5, b6, false, true);
              }
          }
          R6 && (c5.rich = R6);
          var Z3 = s.get("overflow");
          Z3 && (c5.overflow = Z3);
          var X3 = s.get("minMargin");
          X3 != null && (c5.margin = X3), OCe(c5, s, A2, r5, g5, b6, true, false);
        }
        function XRn(c5) {
          for (var s; c5 && c5 !== c5.ecModel; ) {
            var r5 = (c5.option || G2t).rich;
            if (r5) {
              s = s || {};
              for (var g5 = nf2(r5), b6 = 0; b6 < g5.length; b6++) {
                var S2 = g5[b6];
                s[S2] = 1;
              }
            }
            c5 = c5.parentModel;
          }
          return s;
        }
        var kCe = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], PCe = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], LCe = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
        function OCe(c5, s, r5, g5, b6, S2, A2, k2) {
          r5 = !b6 && r5 || G2t;
          var R6 = g5 && g5.inheritColor, B3 = s.getShallow("color"), G3 = s.getShallow("textBorderColor"), Z3 = tc2(s.getShallow("opacity"), r5.opacity);
          (B3 === "inherit" || B3 === "auto") && (R6 ? B3 = R6 : B3 = null), (G3 === "inherit" || G3 === "auto") && (R6 ? G3 = R6 : G3 = null), S2 || (B3 = B3 || r5.color, G3 = G3 || r5.textBorderColor), B3 != null && (c5.fill = B3), G3 != null && (c5.stroke = G3);
          var X3 = tc2(s.getShallow("textBorderWidth"), r5.textBorderWidth);
          X3 != null && (c5.lineWidth = X3);
          var tt = tc2(s.getShallow("textBorderType"), r5.textBorderType);
          tt != null && (c5.lineDash = tt);
          var it = tc2(s.getShallow("textBorderDashOffset"), r5.textBorderDashOffset);
          it != null && (c5.lineDashOffset = it), !b6 && Z3 == null && !k2 && (Z3 = g5 && g5.defaultOpacity), Z3 != null && (c5.opacity = Z3), !b6 && !S2 && c5.fill == null && g5.inheritColor && (c5.fill = g5.inheritColor);
          for (var pt = 0; pt < kCe.length; pt++) {
            var mt = kCe[pt], Mt = tc2(s.getShallow(mt), r5[mt]);
            Mt != null && (c5[mt] = Mt);
          }
          for (var pt = 0; pt < PCe.length; pt++) {
            var mt = PCe[pt], Mt = s.getShallow(mt);
            Mt != null && (c5[mt] = Mt);
          }
          if (c5.verticalAlign == null) {
            var kt = s.getShallow("baseline");
            kt != null && (c5.verticalAlign = kt);
          }
          if (!A2 || !g5.disableBox) {
            for (var pt = 0; pt < LCe.length; pt++) {
              var mt = LCe[pt], Mt = s.getShallow(mt);
              Mt != null && (c5[mt] = Mt);
            }
            var Gt = s.getShallow("borderType");
            Gt != null && (c5.borderDash = Gt), (c5.backgroundColor === "auto" || c5.backgroundColor === "inherit") && R6 && (c5.backgroundColor = R6), (c5.borderColor === "auto" || c5.borderColor === "inherit") && R6 && (c5.borderColor = R6);
          }
        }
        function RCe(c5, s) {
          var r5 = s && s.getModel("textStyle");
          return Tg2([c5.fontStyle || r5 && r5.getShallow("fontStyle") || "", c5.fontWeight || r5 && r5.getShallow("fontWeight") || "", (c5.fontSize || r5 && r5.getShallow("fontSize") || 12) + "px", c5.fontFamily || r5 && r5.getShallow("fontFamily") || "sans-serif"].join(" "));
        }
        var eX = Df2();
        function NCe(c5, s, r5, g5) {
          if (c5) {
            var b6 = eX(c5);
            b6.prevValue = b6.value, b6.value = r5;
            var S2 = s.normal;
            b6.valueAnimation = S2.get("valueAnimation"), b6.valueAnimation && (b6.precision = S2.get("precision"), b6.defaultInterpolatedText = g5, b6.statesModels = s);
          }
        }
        function FCe(c5, s, r5, g5, b6) {
          var S2 = eX(c5);
          if (!S2.valueAnimation || S2.prevValue === S2.value)
            return;
          var A2 = S2.defaultInterpolatedText, k2 = tc2(S2.interpolatedValue, S2.prevValue), R6 = S2.value;
          function B3(G3) {
            var Z3 = Jlt(r5, S2.precision, k2, R6, G3);
            S2.interpolatedValue = G3 === 1 ? null : Z3;
            var X3 = gWt({ labelDataIndex: s, labelFetcher: b6, defaultText: A2 ? A2(Z3) : Z3 + "" }, S2.statesModels, Z3);
            ECe(c5, X3);
          }
          c5.percent = 0, (S2.prevValue == null ? tv : Qf2)(c5, { percent: 1 }, g5, s, null, B3);
        }
        var QRn = ["textStyle", "color"], vWt = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], yWt = new hh2(), JRn = function() {
          function c5() {
          }
          return c5.prototype.getTextColor = function(s) {
            var r5 = this.ecModel;
            return this.getShallow("color") || (!s && r5 ? r5.get(QRn) : null);
          }, c5.prototype.getFont = function() {
            return RCe({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
          }, c5.prototype.getTextRect = function(s) {
            for (var r5 = { text: s, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, g5 = 0; g5 < vWt.length; g5++)
              r5[vWt[g5]] = this.getShallow(vWt[g5]);
            return yWt.useStyle(r5), yWt.update(), yWt.getBoundingRect();
          }, c5;
        }(), t6n = JRn, VCe = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], e6n = aR(VCe), n6n = function() {
          function c5() {
          }
          return c5.prototype.getLineStyle = function(s) {
            return e6n(this, s);
          }, c5;
        }(), BCe = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], r6n = aR(BCe), i6n = function() {
          function c5() {
          }
          return c5.prototype.getItemStyle = function(s, r5) {
            return r6n(this, s, r5);
          }, c5;
        }(), iW = function() {
          function c5(s, r5, g5) {
            this.parentModel = r5, this.ecModel = g5, this.option = s;
          }
          return c5.prototype.init = function(s, r5, g5) {
            for (var b6 = [], S2 = 3; S2 < arguments.length; S2++)
              b6[S2 - 3] = arguments[S2];
          }, c5.prototype.mergeOption = function(s, r5) {
            bu(this.option, s, true);
          }, c5.prototype.get = function(s, r5) {
            return s == null ? this.option : this._doGet(this.parsePath(s), !r5 && this.parentModel);
          }, c5.prototype.getShallow = function(s, r5) {
            var g5 = this.option, b6 = g5 == null ? g5 : g5[s];
            if (b6 == null && !r5) {
              var S2 = this.parentModel;
              S2 && (b6 = S2.getShallow(s));
            }
            return b6;
          }, c5.prototype.getModel = function(s, r5) {
            var g5 = s != null, b6 = g5 ? this.parsePath(s) : null, S2 = g5 ? this._doGet(b6) : this.option;
            return r5 = r5 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(b6)), new c5(S2, r5, this.ecModel);
          }, c5.prototype.isEmpty = function() {
            return this.option == null;
          }, c5.prototype.restoreData = function() {
          }, c5.prototype.clone = function() {
            var s = this.constructor;
            return new s(Ml(this.option));
          }, c5.prototype.parsePath = function(s) {
            return typeof s == "string" ? s.split(".") : s;
          }, c5.prototype.resolveParentPath = function(s) {
            return s;
          }, c5.prototype.isAnimationEnabled = function() {
            if (!os.node && this.option) {
              if (this.option.animation != null)
                return !!this.option.animation;
              if (this.parentModel)
                return this.parentModel.isAnimationEnabled();
            }
          }, c5.prototype._doGet = function(s, r5) {
            var g5 = this.option;
            if (!s)
              return g5;
            for (var b6 = 0; b6 < s.length && !(!!s[b6] && (g5 = g5 && typeof g5 == "object" ? g5[s[b6]] : null, g5 == null)); b6++)
              ;
            return g5 == null && r5 && (g5 = r5._doGet(this.resolveParentPath(s), r5.parentModel)), g5;
          }, c5;
        }();
        MK(iW), iR(iW), A0(iW, n6n), A0(iW, i6n), A0(iW, Jzt), A0(iW, t6n);
        var Ag2 = iW, a6n = Math.round(Math.random() * 10);
        function nX(c5) {
          return [c5 || "", a6n++].join("_");
        }
        function o6n(c5) {
          var s = {};
          c5.registerSubTypeDefaulter = function(r5, g5) {
            var b6 = Vw(r5);
            s[b6.main] = g5;
          }, c5.determineSubType = function(r5, g5) {
            var b6 = g5.type;
            if (!b6) {
              var S2 = Vw(r5).main;
              c5.hasSubTypes(r5) && s[S2] && (b6 = s[S2](g5));
            }
            return b6;
          };
        }
        function s6n(c5, s) {
          c5.topologicalTravel = function(S2, A2, k2, R6) {
            if (!S2.length)
              return;
            var B3 = r5(A2), G3 = B3.graph, Z3 = B3.noEntryList, X3 = {};
            for (Ye2(S2, function(kt) {
              X3[kt] = true;
            }); Z3.length; ) {
              var tt = Z3.pop(), it = G3[tt], pt = !!X3[tt];
              pt && (k2.call(R6, tt, it.originalDeps.slice()), delete X3[tt]), Ye2(it.successor, pt ? Mt : mt);
            }
            Ye2(X3, function() {
              var kt = "";
              throw new Error(kt);
            });
            function mt(kt) {
              G3[kt].entryCount--, G3[kt].entryCount === 0 && Z3.push(kt);
            }
            function Mt(kt) {
              X3[kt] = true, mt(kt);
            }
          };
          function r5(S2) {
            var A2 = {}, k2 = [];
            return Ye2(S2, function(R6) {
              var B3 = g5(A2, R6), G3 = B3.originalDeps = s(R6), Z3 = b6(G3, S2);
              B3.entryCount = Z3.length, B3.entryCount === 0 && k2.push(R6), Ye2(Z3, function(X3) {
                Lu(B3.predecessor, X3) < 0 && B3.predecessor.push(X3);
                var tt = g5(A2, X3);
                Lu(tt.successor, X3) < 0 && tt.successor.push(R6);
              });
            }), { graph: A2, noEntryList: k2 };
          }
          function g5(S2, A2) {
            return S2[A2] || (S2[A2] = { predecessor: [], successor: [] }), S2[A2];
          }
          function b6(S2, A2) {
            var k2 = [];
            return Ye2(S2, function(R6) {
              Lu(A2, R6) >= 0 && k2.push(R6);
            }), k2;
          }
        }
        function $8(c5, s) {
          return bu(bu({}, c5, true), s, true);
        }
        var l6n = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, u6n = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, U2t = "ZH", mWt = "EN", tct = mWt, q2t = {}, bWt = {}, zCe = os.domSupported ? function() {
          var c5 = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
          return c5.indexOf(U2t) > -1 ? U2t : tct;
        }() : tct;
        function jCe(c5, s) {
          c5 = c5.toUpperCase(), bWt[c5] = new Ag2(s), q2t[c5] = s;
        }
        function c6n(c5) {
          if (gs(c5)) {
            var s = q2t[c5.toUpperCase()] || {};
            return c5 === U2t || c5 === mWt ? Ml(s) : bu(Ml(s), Ml(q2t[tct]), false);
          } else
            return bu(Ml(c5), Ml(q2t[tct]), false);
        }
        function _Wt(c5) {
          return bWt[c5];
        }
        function f6n() {
          return bWt[tct];
        }
        jCe(mWt, l6n), jCe(U2t, u6n);
        var xWt = 1e3, wWt = xWt * 60, ect = wWt * 60, YI = ect * 24, WCe = YI * 365, nct = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, Z2t = "{yyyy}-{MM}-{dd}", GCe = { year: "{yyyy}", month: "{yyyy}-{MM}", day: Z2t, hour: Z2t + " " + nct.hour, minute: Z2t + " " + nct.minute, second: Z2t + " " + nct.second, millisecond: nct.none }, SWt = ["year", "month", "day", "hour", "minute", "second", "millisecond"], HCe = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
        function aW(c5, s) {
          return c5 += "", "0000".substr(0, s - c5.length) + c5;
        }
        function rX(c5) {
          switch (c5) {
            case "half-year":
            case "quarter":
              return "month";
            case "week":
            case "half-week":
              return "day";
            case "half-day":
            case "quarter-day":
              return "hour";
            default:
              return c5;
          }
        }
        function h6n(c5) {
          return c5 === rX(c5);
        }
        function p6n(c5) {
          switch (c5) {
            case "year":
            case "month":
              return "day";
            case "millisecond":
              return "millisecond";
            default:
              return "second";
          }
        }
        function $2t(c5, s, r5, g5) {
          var b6 = QC(c5), S2 = b6[MWt(r5)](), A2 = b6[iX(r5)]() + 1, k2 = Math.floor((A2 - 1) / 4) + 1, R6 = b6[Y2t(r5)](), B3 = b6["get" + (r5 ? "UTC" : "") + "Day"](), G3 = b6[rct(r5)](), Z3 = (G3 - 1) % 12 + 1, X3 = b6[K2t(r5)](), tt = b6[X2t(r5)](), it = b6[Q2t(r5)](), pt = g5 instanceof Ag2 ? g5 : _Wt(g5 || zCe) || f6n(), mt = pt.getModel("time"), Mt = mt.get("month"), kt = mt.get("monthAbbr"), Gt = mt.get("dayOfWeek"), Ot = mt.get("dayOfWeekAbbr");
          return (s || "").replace(/{yyyy}/g, S2 + "").replace(/{yy}/g, S2 % 100 + "").replace(/{Q}/g, k2 + "").replace(/{MMMM}/g, Mt[A2 - 1]).replace(/{MMM}/g, kt[A2 - 1]).replace(/{MM}/g, aW(A2, 2)).replace(/{M}/g, A2 + "").replace(/{dd}/g, aW(R6, 2)).replace(/{d}/g, R6 + "").replace(/{eeee}/g, Gt[B3]).replace(/{ee}/g, Ot[B3]).replace(/{e}/g, B3 + "").replace(/{HH}/g, aW(G3, 2)).replace(/{H}/g, G3 + "").replace(/{hh}/g, aW(Z3 + "", 2)).replace(/{h}/g, Z3 + "").replace(/{mm}/g, aW(X3, 2)).replace(/{m}/g, X3 + "").replace(/{ss}/g, aW(tt, 2)).replace(/{s}/g, tt + "").replace(/{SSS}/g, aW(it, 3)).replace(/{S}/g, it + "");
        }
        function d6n(c5, s, r5, g5, b6) {
          var S2 = null;
          if (gs(r5))
            S2 = r5;
          else if (Tl(r5))
            S2 = r5(c5.value, s, { level: c5.level });
          else {
            var A2 = sa2({}, nct);
            if (c5.level > 0)
              for (var k2 = 0; k2 < SWt.length; ++k2)
                A2[SWt[k2]] = "{primary|" + A2[SWt[k2]] + "}";
            var R6 = r5 ? r5.inherit === false ? r5 : Cl(r5, A2) : A2, B3 = UCe(c5.value, b6);
            if (R6[B3])
              S2 = R6[B3];
            else if (R6.inherit) {
              for (var G3 = HCe.indexOf(B3), k2 = G3 - 1; k2 >= 0; --k2)
                if (R6[B3]) {
                  S2 = R6[B3];
                  break;
                }
              S2 = S2 || A2.none;
            }
            if (ja2(S2)) {
              var Z3 = c5.level == null ? 0 : c5.level >= 0 ? c5.level : S2.length + c5.level;
              Z3 = Math.min(Z3, S2.length - 1), S2 = S2[Z3];
            }
          }
          return $2t(new Date(c5.value), S2, b6, g5);
        }
        function UCe(c5, s) {
          var r5 = QC(c5), g5 = r5[iX(s)]() + 1, b6 = r5[Y2t(s)](), S2 = r5[rct(s)](), A2 = r5[K2t(s)](), k2 = r5[X2t(s)](), R6 = r5[Q2t(s)](), B3 = R6 === 0, G3 = B3 && k2 === 0, Z3 = G3 && A2 === 0, X3 = Z3 && S2 === 0, tt = X3 && b6 === 1, it = tt && g5 === 1;
          return it ? "year" : tt ? "month" : X3 ? "day" : Z3 ? "hour" : G3 ? "minute" : B3 ? "second" : "millisecond";
        }
        function qCe(c5, s, r5) {
          var g5 = Oh2(c5) ? QC(c5) : c5;
          switch (s = s || UCe(c5, r5), s) {
            case "year":
              return g5[MWt(r5)]();
            case "half-year":
              return g5[iX(r5)]() >= 6 ? 1 : 0;
            case "quarter":
              return Math.floor((g5[iX(r5)]() + 1) / 4);
            case "month":
              return g5[iX(r5)]();
            case "day":
              return g5[Y2t(r5)]();
            case "half-day":
              return g5[rct(r5)]() / 24;
            case "hour":
              return g5[rct(r5)]();
            case "minute":
              return g5[K2t(r5)]();
            case "second":
              return g5[X2t(r5)]();
            case "millisecond":
              return g5[Q2t(r5)]();
          }
        }
        function MWt(c5) {
          return c5 ? "getUTCFullYear" : "getFullYear";
        }
        function iX(c5) {
          return c5 ? "getUTCMonth" : "getMonth";
        }
        function Y2t(c5) {
          return c5 ? "getUTCDate" : "getDate";
        }
        function rct(c5) {
          return c5 ? "getUTCHours" : "getHours";
        }
        function K2t(c5) {
          return c5 ? "getUTCMinutes" : "getMinutes";
        }
        function X2t(c5) {
          return c5 ? "getUTCSeconds" : "getSeconds";
        }
        function Q2t(c5) {
          return c5 ? "getUTCMilliseconds" : "getMilliseconds";
        }
        function g6n(c5) {
          return c5 ? "setUTCFullYear" : "setFullYear";
        }
        function ZCe(c5) {
          return c5 ? "setUTCMonth" : "setMonth";
        }
        function $Ce(c5) {
          return c5 ? "setUTCDate" : "setDate";
        }
        function YCe(c5) {
          return c5 ? "setUTCHours" : "setHours";
        }
        function KCe(c5) {
          return c5 ? "setUTCMinutes" : "setMinutes";
        }
        function XCe(c5) {
          return c5 ? "setUTCSeconds" : "setSeconds";
        }
        function QCe(c5) {
          return c5 ? "setUTCMilliseconds" : "setMilliseconds";
        }
        function JCe(c5) {
          if (!OSt(c5))
            return gs(c5) ? c5 : "-";
          var s = (c5 + "").split(".");
          return s[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (s.length > 1 ? "." + s[1] : "");
        }
        function tTe(c5, s) {
          return c5 = (c5 || "").toLowerCase().replace(/-(.)/g, function(r5, g5) {
            return g5.toUpperCase();
          }), s && c5 && (c5 = c5.charAt(0).toUpperCase() + c5.slice(1)), c5;
        }
        var aX = VY, v6n = /([&<>"'])/g, y6n = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
        function rT(c5) {
          return c5 == null ? "" : (c5 + "").replace(v6n, function(s, r5) {
            return y6n[r5];
          });
        }
        function CWt(c5, s, r5) {
          var g5 = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
          function b6(G3) {
            return G3 && Tg2(G3) ? G3 : "-";
          }
          function S2(G3) {
            return !!(G3 != null && !isNaN(G3) && isFinite(G3));
          }
          var A2 = s === "time", k2 = c5 instanceof Date;
          if (A2 || k2) {
            var R6 = A2 ? QC(c5) : c5;
            if (isNaN(+R6)) {
              if (k2)
                return "-";
            } else
              return $2t(R6, g5, r5);
          }
          if (s === "ordinal")
            return uj2(c5) ? b6(c5) : Oh2(c5) && S2(c5) ? c5 + "" : "-";
          var B3 = NI(c5);
          return S2(B3) ? JCe(B3) : uj2(c5) ? b6(c5) : typeof c5 == "boolean" ? c5 + "" : "-";
        }
        var eTe = ["a", "b", "c", "d", "e", "f", "g"], TWt = function(c5, s) {
          return "{" + c5 + (s == null ? "" : s) + "}";
        };
        function nTe(c5, s, r5) {
          ja2(s) || (s = [s]);
          var g5 = s.length;
          if (!g5)
            return "";
          for (var b6 = s[0].$vars || [], S2 = 0; S2 < b6.length; S2++) {
            var A2 = eTe[S2];
            c5 = c5.replace(TWt(A2), TWt(A2, 0));
          }
          for (var k2 = 0; k2 < g5; k2++)
            for (var R6 = 0; R6 < b6.length; R6++) {
              var B3 = s[k2][b6[R6]];
              c5 = c5.replace(TWt(eTe[R6], k2), r5 ? rT(B3) : B3);
            }
          return c5;
        }
        function m6n(c5, s, r5) {
          return Ye2(s, function(g5, b6) {
            c5 = c5.replace("{" + b6 + "}", r5 ? rT(g5) : g5);
          }), c5;
        }
        function b6n(c5, s) {
          var r5 = gs(c5) ? { color: c5, extraCssText: s } : c5 || {}, g5 = r5.color, b6 = r5.type;
          s = r5.extraCssText;
          var S2 = r5.renderMode || "html";
          if (!g5)
            return "";
          if (S2 === "html")
            return b6 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + rT(g5) + ";" + (s || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + rT(g5) + ";" + (s || "") + '"></span>';
          var A2 = r5.markerId || "markerX";
          return { renderMode: S2, content: "{" + A2 + "|}  ", style: b6 === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: g5 } : { width: 10, height: 10, borderRadius: 5, backgroundColor: g5 } };
        }
        function oW(c5, s) {
          return s = s || "transparent", gs(c5) ? c5 : Wl(c5) && c5.colorStops && (c5.colorStops[0] || {}).color || s;
        }
        function J2t(c5, s) {
          if (s === "_blank" || s === "blank") {
            var r5 = window.open();
            r5.opener = null, r5.location.href = c5;
          } else
            window.open(c5, s);
        }
        var tMt = Ye2, rTe = ["left", "right", "top", "bottom", "width", "height"], sW = [["width", "left", "right"], ["height", "top", "bottom"]];
        function AWt(c5, s, r5, g5, b6) {
          var S2 = 0, A2 = 0;
          g5 == null && (g5 = 1 / 0), b6 == null && (b6 = 1 / 0);
          var k2 = 0;
          s.eachChild(function(R6, B3) {
            var G3 = R6.getBoundingRect(), Z3 = s.childAt(B3 + 1), X3 = Z3 && Z3.getBoundingRect(), tt, it;
            if (c5 === "horizontal") {
              var pt = G3.width + (X3 ? -X3.x + G3.x : 0);
              tt = S2 + pt, tt > g5 || R6.newline ? (S2 = 0, tt = pt, A2 += k2 + r5, k2 = G3.height) : k2 = Math.max(k2, G3.height);
            } else {
              var mt = G3.height + (X3 ? -X3.y + G3.y : 0);
              it = A2 + mt, it > b6 || R6.newline ? (S2 += k2 + r5, A2 = 0, it = mt, k2 = G3.width) : k2 = Math.max(k2, G3.width);
            }
            R6.newline || (R6.x = S2, R6.y = A2, R6.markRedraw(), c5 === "horizontal" ? S2 = tt + r5 : A2 = it + r5);
          });
        }
        var lW = AWt;
        Au(AWt, "vertical"), Au(AWt, "horizontal");
        function _6n(c5, s, r5) {
          var g5 = s.width, b6 = s.height, S2 = $o(c5.left, g5), A2 = $o(c5.top, b6), k2 = $o(c5.right, g5), R6 = $o(c5.bottom, b6);
          return (isNaN(S2) || isNaN(parseFloat(c5.left))) && (S2 = 0), (isNaN(k2) || isNaN(parseFloat(c5.right))) && (k2 = g5), (isNaN(A2) || isNaN(parseFloat(c5.top))) && (A2 = 0), (isNaN(R6) || isNaN(parseFloat(c5.bottom))) && (R6 = b6), r5 = aX(r5 || 0), { width: Math.max(k2 - S2 - r5[1] - r5[3], 0), height: Math.max(R6 - A2 - r5[0] - r5[2], 0) };
        }
        function $m(c5, s, r5) {
          r5 = aX(r5 || 0);
          var g5 = s.width, b6 = s.height, S2 = $o(c5.left, g5), A2 = $o(c5.top, b6), k2 = $o(c5.right, g5), R6 = $o(c5.bottom, b6), B3 = $o(c5.width, g5), G3 = $o(c5.height, b6), Z3 = r5[2] + r5[0], X3 = r5[1] + r5[3], tt = c5.aspect;
          switch (isNaN(B3) && (B3 = g5 - k2 - X3 - S2), isNaN(G3) && (G3 = b6 - R6 - Z3 - A2), tt != null && (isNaN(B3) && isNaN(G3) && (tt > g5 / b6 ? B3 = g5 * 0.8 : G3 = b6 * 0.8), isNaN(B3) && (B3 = tt * G3), isNaN(G3) && (G3 = B3 / tt)), isNaN(S2) && (S2 = g5 - k2 - B3 - X3), isNaN(A2) && (A2 = b6 - R6 - G3 - Z3), c5.left || c5.right) {
            case "center":
              S2 = g5 / 2 - B3 / 2 - r5[3];
              break;
            case "right":
              S2 = g5 - B3 - X3;
              break;
          }
          switch (c5.top || c5.bottom) {
            case "middle":
            case "center":
              A2 = b6 / 2 - G3 / 2 - r5[0];
              break;
            case "bottom":
              A2 = b6 - G3 - Z3;
              break;
          }
          S2 = S2 || 0, A2 = A2 || 0, isNaN(B3) && (B3 = g5 - X3 - S2 - (k2 || 0)), isNaN(G3) && (G3 = b6 - Z3 - A2 - (R6 || 0));
          var it = new lc2(S2 + r5[3], A2 + r5[0], B3, G3);
          return it.margin = r5, it;
        }
        function eMt(c5, s, r5, g5, b6, S2) {
          var A2 = !b6 || !b6.hv || b6.hv[0], k2 = !b6 || !b6.hv || b6.hv[1], R6 = b6 && b6.boundingMode || "all";
          if (S2 = S2 || c5, S2.x = c5.x, S2.y = c5.y, !A2 && !k2)
            return false;
          var B3;
          if (R6 === "raw")
            B3 = c5.type === "group" ? new lc2(0, 0, +s.width || 0, +s.height || 0) : c5.getBoundingRect();
          else if (B3 = c5.getBoundingRect(), c5.needLocalTransform()) {
            var G3 = c5.getLocalTransform();
            B3 = B3.clone(), B3.applyTransform(G3);
          }
          var Z3 = $m(Cl({ width: B3.width, height: B3.height }, s), r5, g5), X3 = A2 ? Z3.x - B3.x : 0, tt = k2 ? Z3.y - B3.y : 0;
          return R6 === "raw" ? (S2.x = X3, S2.y = tt) : (S2.x += X3, S2.y += tt), S2 === c5 && c5.markRedraw(), true;
        }
        function x6n(c5, s) {
          return c5[sW[s][0]] != null || c5[sW[s][1]] != null && c5[sW[s][2]] != null;
        }
        function ict(c5) {
          var s = c5.layoutMode || c5.constructor.layoutMode;
          return Wl(s) ? s : s ? { type: s } : null;
        }
        function Y8(c5, s, r5) {
          var g5 = r5 && r5.ignoreSize;
          !ja2(g5) && (g5 = [g5, g5]);
          var b6 = A2(sW[0], 0), S2 = A2(sW[1], 1);
          B3(sW[0], c5, b6), B3(sW[1], c5, S2);
          function A2(G3, Z3) {
            var X3 = {}, tt = 0, it = {}, pt = 0, mt = 2;
            if (tMt(G3, function(Gt) {
              it[Gt] = c5[Gt];
            }), tMt(G3, function(Gt) {
              k2(s, Gt) && (X3[Gt] = it[Gt] = s[Gt]), R6(X3, Gt) && tt++, R6(it, Gt) && pt++;
            }), g5[Z3])
              return R6(s, G3[1]) ? it[G3[2]] = null : R6(s, G3[2]) && (it[G3[1]] = null), it;
            if (pt === mt || !tt)
              return it;
            if (tt >= mt)
              return X3;
            for (var Mt = 0; Mt < G3.length; Mt++) {
              var kt = G3[Mt];
              if (!k2(X3, kt) && k2(c5, kt)) {
                X3[kt] = c5[kt];
                break;
              }
            }
            return X3;
          }
          function k2(G3, Z3) {
            return G3.hasOwnProperty(Z3);
          }
          function R6(G3, Z3) {
            return G3[Z3] != null && G3[Z3] !== "auto";
          }
          function B3(G3, Z3, X3) {
            tMt(G3, function(tt) {
              Z3[tt] = X3[tt];
            });
          }
        }
        function oX(c5) {
          return iTe({}, c5);
        }
        function iTe(c5, s) {
          return s && c5 && tMt(rTe, function(r5) {
            s.hasOwnProperty(r5) && (c5[r5] = s[r5]);
          }), c5;
        }
        var w6n = Df2(), sX = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this, r5, g5, b6) || this;
            return S2.uid = nX("ec_cpt_model"), S2;
          }
          return s.prototype.init = function(r5, g5, b6) {
            this.mergeDefaultAndTheme(r5, b6);
          }, s.prototype.mergeDefaultAndTheme = function(r5, g5) {
            var b6 = ict(this), S2 = b6 ? oX(r5) : {}, A2 = g5.getTheme();
            bu(r5, A2.get(this.mainType)), bu(r5, this.getDefaultOption()), b6 && Y8(r5, S2, b6);
          }, s.prototype.mergeOption = function(r5, g5) {
            bu(this.option, r5, true);
            var b6 = ict(this);
            b6 && Y8(this.option, r5, b6);
          }, s.prototype.optionUpdated = function(r5, g5) {
          }, s.prototype.getDefaultOption = function() {
            var r5 = this.constructor;
            if (!zSt(r5))
              return r5.defaultOption;
            var g5 = w6n(this);
            if (!g5.defaultOption) {
              for (var b6 = [], S2 = r5; S2; ) {
                var A2 = S2.prototype.defaultOption;
                A2 && b6.push(A2), S2 = S2.superClass;
              }
              for (var k2 = {}, R6 = b6.length - 1; R6 >= 0; R6--)
                k2 = bu(k2, b6[R6], true);
              g5.defaultOption = k2;
            }
            return g5.defaultOption;
          }, s.prototype.getReferringComponents = function(r5, g5) {
            var b6 = r5 + "Index", S2 = r5 + "Id";
            return Gj2(this.ecModel, r5, { index: this.get(b6, true), id: this.get(S2, true) }, g5);
          }, s.prototype.getBoxLayoutParams = function() {
            var r5 = this;
            return { left: r5.get("left"), top: r5.get("top"), right: r5.get("right"), bottom: r5.get("bottom"), width: r5.get("width"), height: r5.get("height") };
          }, s.prototype.getZLevelKey = function() {
            return "";
          }, s.prototype.setZLevel = function(r5) {
            this.option.zlevel = r5;
          }, s.protoInitialize = function() {
            var r5 = s.prototype;
            r5.type = "component", r5.id = "", r5.name = "", r5.mainType = "", r5.subType = "", r5.componentIndex = 0;
          }(), s;
        }(Ag2);
        nut(sX, Ag2), TK(sX), o6n(sX), s6n(sX, S6n);
        function S6n(c5) {
          var s = [];
          return Ye2(sX.getClassesByMainType(c5), function(r5) {
            s = s.concat(r5.dependencies || r5.prototype.dependencies || []);
          }), s = Ha2(s, function(r5) {
            return Vw(r5).main;
          }), c5 !== "dataset" && Lu(s, "dataset") <= 0 && s.unshift("dataset"), s;
        }
        var Rh2 = sX, aTe = "";
        typeof navigator != "undefined" && (aTe = navigator.platform || "");
        var lX = "rgba(0, 0, 0, 0.2)", M6n = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: lX, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: lX, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: lX, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: lX, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: lX, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: lX, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: aTe.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, oTe = Ps(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), KI = "original", qw = "arrayRows", XI = "objectRows", I3 = "keyedColumns", K8 = "typedArray", sTe = "unknown", D3 = "column", uX = "row", xx = { Must: 1, Might: 2, Not: 3 }, lTe = Df2();
        function C6n(c5) {
          lTe(c5).datasetMap = Ps();
        }
        function uTe(c5, s, r5) {
          var g5 = {}, b6 = DWt(s);
          if (!b6 || !c5)
            return g5;
          var S2 = [], A2 = [], k2 = s.ecModel, R6 = lTe(k2).datasetMap, B3 = b6.uid + "_" + r5.seriesLayoutBy, G3, Z3;
          c5 = c5.slice(), Ye2(c5, function(pt, mt) {
            var Mt = Wl(pt) ? pt : c5[mt] = { name: pt };
            Mt.type === "ordinal" && G3 == null && (G3 = mt, Z3 = it(Mt)), g5[Mt.name] = [];
          });
          var X3 = R6.get(B3) || R6.set(B3, { categoryWayDim: Z3, valueWayDim: 0 });
          Ye2(c5, function(pt, mt) {
            var Mt = pt.name, kt = it(pt);
            if (G3 == null) {
              var Gt = X3.valueWayDim;
              tt(g5[Mt], Gt, kt), tt(A2, Gt, kt), X3.valueWayDim += kt;
            } else if (G3 === mt)
              tt(g5[Mt], 0, kt), tt(S2, 0, kt);
            else {
              var Gt = X3.categoryWayDim;
              tt(g5[Mt], Gt, kt), tt(A2, Gt, kt), X3.categoryWayDim += kt;
            }
          });
          function tt(pt, mt, Mt) {
            for (var kt = 0; kt < Mt; kt++)
              pt.push(mt + kt);
          }
          function it(pt) {
            var mt = pt.dimsDef;
            return mt ? mt.length : 1;
          }
          return S2.length && (g5.itemName = S2), A2.length && (g5.seriesName = A2), g5;
        }
        function IWt(c5, s, r5) {
          var g5 = {}, b6 = DWt(c5);
          if (!b6)
            return g5;
          var S2 = s.sourceFormat, A2 = s.dimensionsDefine, k2;
          (S2 === XI || S2 === I3) && Ye2(A2, function(G3, Z3) {
            (Wl(G3) ? G3.name : G3) === "name" && (k2 = Z3);
          });
          var R6 = function() {
            for (var G3 = {}, Z3 = {}, X3 = [], tt = 0, it = Math.min(5, r5); tt < it; tt++) {
              var pt = fTe(s.data, S2, s.seriesLayoutBy, A2, s.startIndex, tt);
              X3.push(pt);
              var mt = pt === xx.Not;
              if (mt && G3.v == null && tt !== k2 && (G3.v = tt), (G3.n == null || G3.n === G3.v || !mt && X3[G3.n] === xx.Not) && (G3.n = tt), Mt(G3) && X3[G3.n] !== xx.Not)
                return G3;
              mt || (pt === xx.Might && Z3.v == null && tt !== k2 && (Z3.v = tt), (Z3.n == null || Z3.n === Z3.v) && (Z3.n = tt));
            }
            function Mt(kt) {
              return kt.v != null && kt.n != null;
            }
            return Mt(G3) ? G3 : Mt(Z3) ? Z3 : null;
          }();
          if (R6) {
            g5.value = [R6.v];
            var B3 = k2 != null ? k2 : R6.n;
            g5.itemName = [B3], g5.seriesName = [B3];
          }
          return g5;
        }
        function DWt(c5) {
          var s = c5.get("data", true);
          if (!s)
            return Gj2(c5.ecModel, "dataset", { index: c5.get("datasetIndex", true), id: c5.get("datasetId", true) }, E0).models[0];
        }
        function T6n(c5) {
          return !c5.get("transform", true) && !c5.get("fromTransformResult", true) ? [] : Gj2(c5.ecModel, "dataset", { index: c5.get("fromDatasetIndex", true), id: c5.get("fromDatasetId", true) }, E0).models;
        }
        function cTe(c5, s) {
          return fTe(c5.data, c5.sourceFormat, c5.seriesLayoutBy, c5.dimensionsDefine, c5.startIndex, s);
        }
        function fTe(c5, s, r5, g5, b6, S2) {
          var A2, k2 = 5;
          if (u2(c5))
            return xx.Not;
          var R6, B3;
          if (g5) {
            var G3 = g5[S2];
            Wl(G3) ? (R6 = G3.name, B3 = G3.type) : gs(G3) && (R6 = G3);
          }
          if (B3 != null)
            return B3 === "ordinal" ? xx.Must : xx.Not;
          if (s === qw) {
            var Z3 = c5;
            if (r5 === uX) {
              for (var X3 = Z3[S2], tt = 0; tt < (X3 || []).length && tt < k2; tt++)
                if ((A2 = Ot(X3[b6 + tt])) != null)
                  return A2;
            } else
              for (var tt = 0; tt < Z3.length && tt < k2; tt++) {
                var it = Z3[b6 + tt];
                if (it && (A2 = Ot(it[S2])) != null)
                  return A2;
              }
          } else if (s === XI) {
            var pt = c5;
            if (!R6)
              return xx.Not;
            for (var tt = 0; tt < pt.length && tt < k2; tt++) {
              var mt = pt[tt];
              if (mt && (A2 = Ot(mt[R6])) != null)
                return A2;
            }
          } else if (s === I3) {
            var Mt = c5;
            if (!R6)
              return xx.Not;
            var X3 = Mt[R6];
            if (!X3 || u2(X3))
              return xx.Not;
            for (var tt = 0; tt < X3.length && tt < k2; tt++)
              if ((A2 = Ot(X3[tt])) != null)
                return A2;
          } else if (s === KI)
            for (var kt = c5, tt = 0; tt < kt.length && tt < k2; tt++) {
              var mt = kt[tt], Gt = Sk(mt);
              if (!ja2(Gt))
                return xx.Not;
              if ((A2 = Ot(Gt[S2])) != null)
                return A2;
            }
          function Ot(ce2) {
            var ae2 = gs(ce2);
            if (ce2 != null && isFinite(ce2) && ce2 !== "")
              return ae2 ? xx.Might : xx.Not;
            if (ae2 && ce2 !== "-")
              return xx.Must;
          }
          return xx.Not;
        }
        var EWt = Ps();
        function A6n(c5, s) {
          lx(EWt.get(c5) == null && s), EWt.set(c5, s);
        }
        function I6n(c5, s, r5) {
          var g5 = EWt.get(s);
          if (!g5)
            return r5;
          var b6 = g5(c5);
          return b6 ? r5.concat(b6) : r5;
        }
        var hTe = Df2(), D6n = Df2(), kWt = function() {
          function c5() {
          }
          return c5.prototype.getColorFromPalette = function(s, r5, g5) {
            var b6 = xp(this.get("color", true)), S2 = this.get("colorLayer", true);
            return pTe(this, hTe, b6, S2, s, r5, g5);
          }, c5.prototype.clearColorPalette = function() {
            k6n(this, hTe);
          }, c5;
        }();
        function PWt(c5, s, r5, g5) {
          var b6 = xp(c5.get(["aria", "decal", "decals"]));
          return pTe(c5, D6n, b6, null, s, r5, g5);
        }
        function E6n(c5, s) {
          for (var r5 = c5.length, g5 = 0; g5 < r5; g5++)
            if (c5[g5].length > s)
              return c5[g5];
          return c5[r5 - 1];
        }
        function pTe(c5, s, r5, g5, b6, S2, A2) {
          S2 = S2 || c5;
          var k2 = s(S2), R6 = k2.paletteIdx || 0, B3 = k2.paletteNameMap = k2.paletteNameMap || {};
          if (B3.hasOwnProperty(b6))
            return B3[b6];
          var G3 = A2 == null || !g5 ? r5 : E6n(g5, A2);
          if (G3 = G3 || r5, !(!G3 || !G3.length)) {
            var Z3 = G3[R6];
            return b6 && (B3[b6] = Z3), k2.paletteIdx = (R6 + 1) % G3.length, Z3;
          }
        }
        function k6n(c5, s) {
          s(c5).paletteIdx = 0, s(c5).paletteNameMap = {};
        }
        var nMt, act, dTe, gTe = "\0_ec_inner", P6n = 1, vTe = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.init = function(r5, g5, b6, S2, A2, k2) {
            S2 = S2 || {}, this.option = null, this._theme = new Ag2(S2), this._locale = new Ag2(A2), this._optionManager = k2;
          }, s.prototype.setOption = function(r5, g5, b6) {
            var S2 = bTe(g5);
            this._optionManager.setOption(r5, b6, S2), this._resetOption(null, S2);
          }, s.prototype.resetOption = function(r5, g5) {
            return this._resetOption(r5, bTe(g5));
          }, s.prototype._resetOption = function(r5, g5) {
            var b6 = false, S2 = this._optionManager;
            if (!r5 || r5 === "recreate") {
              var A2 = S2.mountOption(r5 === "recreate");
              !this.option || r5 === "recreate" ? dTe(this, A2) : (this.restoreData(), this._mergeOption(A2, g5)), b6 = true;
            }
            if ((r5 === "timeline" || r5 === "media") && this.restoreData(), !r5 || r5 === "recreate" || r5 === "timeline") {
              var k2 = S2.getTimelineOption(this);
              k2 && (b6 = true, this._mergeOption(k2, g5));
            }
            if (!r5 || r5 === "recreate" || r5 === "media") {
              var R6 = S2.getMediaOption(this);
              R6.length && Ye2(R6, function(B3) {
                b6 = true, this._mergeOption(B3, g5);
              }, this);
            }
            return b6;
          }, s.prototype.mergeOption = function(r5) {
            this._mergeOption(r5, null);
          }, s.prototype._mergeOption = function(r5, g5) {
            var b6 = this.option, S2 = this._componentsMap, A2 = this._componentsCount, k2 = [], R6 = Ps(), B3 = g5 && g5.replaceMergeMainTypeMap;
            C6n(this), Ye2(r5, function(Z3, X3) {
              Z3 != null && (Rh2.hasClass(X3) ? X3 && (k2.push(X3), R6.set(X3, true)) : b6[X3] = b6[X3] == null ? Ml(Z3) : bu(b6[X3], Z3, true));
            }), B3 && B3.each(function(Z3, X3) {
              Rh2.hasClass(X3) && !R6.get(X3) && (k2.push(X3), R6.set(X3, true));
            }), Rh2.topologicalTravel(k2, Rh2.getAllClassMainTypes(), G3, this);
            function G3(Z3) {
              var X3 = I6n(this, Z3, xp(r5[Z3])), tt = S2.get(Z3), it = tt ? B3 && B3.get(Z3) ? "replaceMerge" : "normalMerge" : "replaceAll", pt = m3(tt, X3, it);
              Mk(pt, Z3, Rh2), b6[Z3] = null, S2.set(Z3, null), A2.set(Z3, 0);
              var mt = [], Mt = [], kt = 0, Gt;
              Ye2(pt, function(Ot, ce2) {
                var ae2 = Ot.existing, de2 = Ot.newOption;
                if (!de2)
                  ae2 && (ae2.mergeOption({}, this), ae2.optionUpdated({}, false));
                else {
                  var we2 = Z3 === "series", Se2 = Rh2.getClass(Z3, Ot.keyInfo.subType, !we2);
                  if (!Se2)
                    return;
                  if (Z3 === "tooltip") {
                    if (Gt)
                      return;
                    Gt = true;
                  }
                  if (ae2 && ae2.constructor === Se2)
                    ae2.name = Ot.keyInfo.name, ae2.mergeOption(de2, this), ae2.optionUpdated(de2, false);
                  else {
                    var Oe2 = sa2({ componentIndex: ce2 }, Ot.keyInfo);
                    ae2 = new Se2(de2, this, this, Oe2), sa2(ae2, Oe2), Ot.brandNew && (ae2.__requireNewView = true), ae2.init(de2, this, this), ae2.optionUpdated(null, true);
                  }
                }
                ae2 ? (mt.push(ae2.option), Mt.push(ae2), kt++) : (mt.push(void 0), Mt.push(void 0));
              }, this), b6[Z3] = mt, S2.set(Z3, Mt), A2.set(Z3, kt), Z3 === "series" && nMt(this);
            }
            this._seriesIndices || nMt(this);
          }, s.prototype.getOption = function() {
            var r5 = Ml(this.option);
            return Ye2(r5, function(g5, b6) {
              if (Rh2.hasClass(b6)) {
                for (var S2 = xp(g5), A2 = S2.length, k2 = false, R6 = A2 - 1; R6 >= 0; R6--)
                  S2[R6] && !jj2(S2[R6]) ? k2 = true : (S2[R6] = null, !k2 && A2--);
                S2.length = A2, r5[b6] = S2;
              }
            }), delete r5[gTe], r5;
          }, s.prototype.getTheme = function() {
            return this._theme;
          }, s.prototype.getLocaleModel = function() {
            return this._locale;
          }, s.prototype.setUpdatePayload = function(r5) {
            this._payload = r5;
          }, s.prototype.getUpdatePayload = function() {
            return this._payload;
          }, s.prototype.getComponent = function(r5, g5) {
            var b6 = this._componentsMap.get(r5);
            if (b6) {
              var S2 = b6[g5 || 0];
              if (S2)
                return S2;
              if (g5 == null) {
                for (var A2 = 0; A2 < b6.length; A2++)
                  if (b6[A2])
                    return b6[A2];
              }
            }
          }, s.prototype.queryComponents = function(r5) {
            var g5 = r5.mainType;
            if (!g5)
              return [];
            var b6 = r5.index, S2 = r5.id, A2 = r5.name, k2 = this._componentsMap.get(g5);
            if (!k2 || !k2.length)
              return [];
            var R6;
            return b6 != null ? (R6 = [], Ye2(xp(b6), function(B3) {
              k2[B3] && R6.push(k2[B3]);
            })) : S2 != null ? R6 = yTe("id", S2, k2) : A2 != null ? R6 = yTe("name", A2, k2) : R6 = jp(k2, function(B3) {
              return !!B3;
            }), mTe(R6, r5);
          }, s.prototype.findComponents = function(r5) {
            var g5 = r5.query, b6 = r5.mainType, S2 = k2(g5), A2 = S2 ? this.queryComponents(S2) : jp(this._componentsMap.get(b6), function(B3) {
              return !!B3;
            });
            return R6(mTe(A2, r5));
            function k2(B3) {
              var G3 = b6 + "Index", Z3 = b6 + "Id", X3 = b6 + "Name";
              return B3 && (B3[G3] != null || B3[Z3] != null || B3[X3] != null) ? { mainType: b6, index: B3[G3], id: B3[Z3], name: B3[X3] } : null;
            }
            function R6(B3) {
              return r5.filter ? jp(B3, r5.filter) : B3;
            }
          }, s.prototype.eachComponent = function(r5, g5, b6) {
            var S2 = this._componentsMap;
            if (Tl(r5)) {
              var A2 = g5, k2 = r5;
              S2.each(function(Z3, X3) {
                for (var tt = 0; Z3 && tt < Z3.length; tt++) {
                  var it = Z3[tt];
                  it && k2.call(A2, X3, it, it.componentIndex);
                }
              });
            } else
              for (var R6 = gs(r5) ? S2.get(r5) : Wl(r5) ? this.findComponents(r5) : null, B3 = 0; R6 && B3 < R6.length; B3++) {
                var G3 = R6[B3];
                G3 && g5.call(b6, G3, G3.componentIndex);
              }
          }, s.prototype.getSeriesByName = function(r5) {
            var g5 = Q0(r5, null);
            return jp(this._componentsMap.get("series"), function(b6) {
              return !!b6 && g5 != null && b6.name === g5;
            });
          }, s.prototype.getSeriesByIndex = function(r5) {
            return this._componentsMap.get("series")[r5];
          }, s.prototype.getSeriesByType = function(r5) {
            return jp(this._componentsMap.get("series"), function(g5) {
              return !!g5 && g5.subType === r5;
            });
          }, s.prototype.getSeries = function() {
            return jp(this._componentsMap.get("series"), function(r5) {
              return !!r5;
            });
          }, s.prototype.getSeriesCount = function() {
            return this._componentsCount.get("series");
          }, s.prototype.eachSeries = function(r5, g5) {
            act(this), Ye2(this._seriesIndices, function(b6) {
              var S2 = this._componentsMap.get("series")[b6];
              r5.call(g5, S2, b6);
            }, this);
          }, s.prototype.eachRawSeries = function(r5, g5) {
            Ye2(this._componentsMap.get("series"), function(b6) {
              b6 && r5.call(g5, b6, b6.componentIndex);
            });
          }, s.prototype.eachSeriesByType = function(r5, g5, b6) {
            act(this), Ye2(this._seriesIndices, function(S2) {
              var A2 = this._componentsMap.get("series")[S2];
              A2.subType === r5 && g5.call(b6, A2, S2);
            }, this);
          }, s.prototype.eachRawSeriesByType = function(r5, g5, b6) {
            return Ye2(this.getSeriesByType(r5), g5, b6);
          }, s.prototype.isSeriesFiltered = function(r5) {
            return act(this), this._seriesIndicesMap.get(r5.componentIndex) == null;
          }, s.prototype.getCurrentSeriesIndices = function() {
            return (this._seriesIndices || []).slice();
          }, s.prototype.filterSeries = function(r5, g5) {
            act(this);
            var b6 = [];
            Ye2(this._seriesIndices, function(S2) {
              var A2 = this._componentsMap.get("series")[S2];
              r5.call(g5, A2, S2) && b6.push(S2);
            }, this), this._seriesIndices = b6, this._seriesIndicesMap = Ps(b6);
          }, s.prototype.restoreData = function(r5) {
            nMt(this);
            var g5 = this._componentsMap, b6 = [];
            g5.each(function(S2, A2) {
              Rh2.hasClass(A2) && b6.push(A2);
            }), Rh2.topologicalTravel(b6, Rh2.getAllClassMainTypes(), function(S2) {
              Ye2(g5.get(S2), function(A2) {
                A2 && (S2 !== "series" || !L6n(A2, r5)) && A2.restoreData();
              });
            });
          }, s.internalField = function() {
            nMt = function(r5) {
              var g5 = r5._seriesIndices = [];
              Ye2(r5._componentsMap.get("series"), function(b6) {
                b6 && g5.push(b6.componentIndex);
              }), r5._seriesIndicesMap = Ps(g5);
            }, act = function(r5) {
            }, dTe = function(r5, g5) {
              r5.option = {}, r5.option[gTe] = P6n, r5._componentsMap = Ps({ series: [] }), r5._componentsCount = Ps();
              var b6 = g5.aria;
              Wl(b6) && b6.enabled == null && (b6.enabled = true), O6n(g5, r5._theme.option), bu(g5, M6n, false), r5._mergeOption(g5, null);
            };
          }(), s;
        }(Ag2);
        function L6n(c5, s) {
          if (s) {
            var r5 = s.seriesIndex, g5 = s.seriesId, b6 = s.seriesName;
            return r5 != null && c5.componentIndex !== r5 || g5 != null && c5.id !== g5 || b6 != null && c5.name !== b6;
          }
        }
        function O6n(c5, s) {
          var r5 = c5.color && !c5.colorLayer;
          Ye2(s, function(g5, b6) {
            b6 === "colorLayer" && r5 || Rh2.hasClass(b6) || (typeof g5 == "object" ? c5[b6] = c5[b6] ? bu(c5[b6], g5, false) : Ml(g5) : c5[b6] == null && (c5[b6] = g5));
          });
        }
        function yTe(c5, s, r5) {
          if (ja2(s)) {
            var g5 = Ps();
            return Ye2(s, function(S2) {
              if (S2 != null) {
                var A2 = Q0(S2, null);
                A2 != null && g5.set(S2, true);
              }
            }), jp(r5, function(S2) {
              return S2 && g5.get(S2[c5]);
            });
          } else {
            var b6 = Q0(s, null);
            return jp(r5, function(S2) {
              return S2 && b6 != null && S2[c5] === b6;
            });
          }
        }
        function mTe(c5, s) {
          return s.hasOwnProperty("subType") ? jp(c5, function(r5) {
            return r5 && r5.subType === s.subType;
          }) : c5;
        }
        function bTe(c5) {
          var s = Ps();
          return c5 && Ye2(xp(c5.replaceMerge), function(r5) {
            s.set(r5, true);
          }), { replaceMergeMainTypeMap: s };
        }
        A0(vTe, kWt);
        var _Te = vTe, R6n = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], N6n = function() {
          function c5(s) {
            Ye2(R6n, function(r5) {
              this[r5] = Cs(s[r5], s);
            }, this);
          }
          return c5;
        }(), xTe = N6n, LWt = {}, F6n = function() {
          function c5() {
            this._coordinateSystems = [];
          }
          return c5.prototype.create = function(s, r5) {
            var g5 = [];
            Ye2(LWt, function(b6, S2) {
              var A2 = b6.create(s, r5);
              g5 = g5.concat(A2 || []);
            }), this._coordinateSystems = g5;
          }, c5.prototype.update = function(s, r5) {
            Ye2(this._coordinateSystems, function(g5) {
              g5.update && g5.update(s, r5);
            });
          }, c5.prototype.getCoordinateSystems = function() {
            return this._coordinateSystems.slice();
          }, c5.register = function(s, r5) {
            LWt[s] = r5;
          }, c5.get = function(s) {
            return LWt[s];
          }, c5;
        }(), oct = F6n, V6n = /^(min|max)?(.+)$/, B6n = function() {
          function c5(s) {
            this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = s;
          }
          return c5.prototype.setOption = function(s, r5, g5) {
            s && (Ye2(xp(s.series), function(A2) {
              A2 && A2.data && u2(A2.data) && DI(A2.data);
            }), Ye2(xp(s.dataset), function(A2) {
              A2 && A2.source && u2(A2.source) && DI(A2.source);
            })), s = Ml(s);
            var b6 = this._optionBackup, S2 = z6n(s, r5, !b6);
            this._newBaseOption = S2.baseOption, b6 ? (S2.timelineOptions.length && (b6.timelineOptions = S2.timelineOptions), S2.mediaList.length && (b6.mediaList = S2.mediaList), S2.mediaDefault && (b6.mediaDefault = S2.mediaDefault)) : this._optionBackup = S2;
          }, c5.prototype.mountOption = function(s) {
            var r5 = this._optionBackup;
            return this._timelineOptions = r5.timelineOptions, this._mediaList = r5.mediaList, this._mediaDefault = r5.mediaDefault, this._currentMediaIndices = [], Ml(s ? r5.baseOption : this._newBaseOption);
          }, c5.prototype.getTimelineOption = function(s) {
            var r5, g5 = this._timelineOptions;
            if (g5.length) {
              var b6 = s.getComponent("timeline");
              b6 && (r5 = Ml(g5[b6.getCurrentIndex()]));
            }
            return r5;
          }, c5.prototype.getMediaOption = function(s) {
            var r5 = this._api.getWidth(), g5 = this._api.getHeight(), b6 = this._mediaList, S2 = this._mediaDefault, A2 = [], k2 = [];
            if (!b6.length && !S2)
              return k2;
            for (var R6 = 0, B3 = b6.length; R6 < B3; R6++)
              j6n(b6[R6].query, r5, g5) && A2.push(R6);
            return !A2.length && S2 && (A2 = [-1]), A2.length && !G6n(A2, this._currentMediaIndices) && (k2 = Ha2(A2, function(G3) {
              return Ml(G3 === -1 ? S2.option : b6[G3].option);
            })), this._currentMediaIndices = A2, k2;
          }, c5;
        }();
        function z6n(c5, s, r5) {
          var g5 = [], b6, S2, A2 = c5.baseOption, k2 = c5.timeline, R6 = c5.options, B3 = c5.media, G3 = !!c5.media, Z3 = !!(R6 || k2 || A2 && A2.timeline);
          A2 ? (S2 = A2, S2.timeline || (S2.timeline = k2)) : ((Z3 || G3) && (c5.options = c5.media = null), S2 = c5), G3 && ja2(B3) && Ye2(B3, function(tt) {
            tt && tt.option && (tt.query ? g5.push(tt) : b6 || (b6 = tt));
          }), X3(S2), Ye2(R6, function(tt) {
            return X3(tt);
          }), Ye2(g5, function(tt) {
            return X3(tt.option);
          });
          function X3(tt) {
            Ye2(s, function(it) {
              it(tt, r5);
            });
          }
          return { baseOption: S2, timelineOptions: R6 || [], mediaDefault: b6, mediaList: g5 };
        }
        function j6n(c5, s, r5) {
          var g5 = { width: s, height: r5, aspectratio: s / r5 }, b6 = true;
          return Ye2(c5, function(S2, A2) {
            var k2 = A2.match(V6n);
            if (!(!k2 || !k2[1] || !k2[2])) {
              var R6 = k2[1], B3 = k2[2].toLowerCase();
              W6n(g5[B3], S2, R6) || (b6 = false);
            }
          }), b6;
        }
        function W6n(c5, s, r5) {
          return r5 === "min" ? c5 >= s : r5 === "max" ? c5 <= s : c5 === s;
        }
        function G6n(c5, s) {
          return c5.join(",") === s.join(",");
        }
        var H6n = B6n, Dk = Ye2, sct = Wl, wTe = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
        function OWt(c5) {
          var s = c5 && c5.itemStyle;
          if (s)
            for (var r5 = 0, g5 = wTe.length; r5 < g5; r5++) {
              var b6 = wTe[r5], S2 = s.normal, A2 = s.emphasis;
              S2 && S2[b6] && (c5[b6] = c5[b6] || {}, c5[b6].normal ? bu(c5[b6].normal, S2[b6]) : c5[b6].normal = S2[b6], S2[b6] = null), A2 && A2[b6] && (c5[b6] = c5[b6] || {}, c5[b6].emphasis ? bu(c5[b6].emphasis, A2[b6]) : c5[b6].emphasis = A2[b6], A2[b6] = null);
            }
        }
        function Zw(c5, s, r5) {
          if (c5 && c5[s] && (c5[s].normal || c5[s].emphasis)) {
            var g5 = c5[s].normal, b6 = c5[s].emphasis;
            g5 && (r5 ? (c5[s].normal = c5[s].emphasis = null, Cl(c5[s], g5)) : c5[s] = g5), b6 && (c5.emphasis = c5.emphasis || {}, c5.emphasis[s] = b6, b6.focus && (c5.emphasis.focus = b6.focus), b6.blurScope && (c5.emphasis.blurScope = b6.blurScope));
          }
        }
        function lct(c5) {
          Zw(c5, "itemStyle"), Zw(c5, "lineStyle"), Zw(c5, "areaStyle"), Zw(c5, "label"), Zw(c5, "labelLine"), Zw(c5, "upperLabel"), Zw(c5, "edgeLabel");
        }
        function im(c5, s) {
          var r5 = sct(c5) && c5[s], g5 = sct(r5) && r5.textStyle;
          if (g5)
            for (var b6 = 0, S2 = ec2.length; b6 < S2; b6++) {
              var A2 = ec2[b6];
              g5.hasOwnProperty(A2) && (r5[A2] = g5[A2]);
            }
        }
        function QI(c5) {
          c5 && (lct(c5), im(c5, "label"), c5.emphasis && im(c5.emphasis, "label"));
        }
        function U6n(c5) {
          if (sct(c5)) {
            OWt(c5), lct(c5), im(c5, "label"), im(c5, "upperLabel"), im(c5, "edgeLabel"), c5.emphasis && (im(c5.emphasis, "label"), im(c5.emphasis, "upperLabel"), im(c5.emphasis, "edgeLabel"));
            var s = c5.markPoint;
            s && (OWt(s), QI(s));
            var r5 = c5.markLine;
            r5 && (OWt(r5), QI(r5));
            var g5 = c5.markArea;
            g5 && QI(g5);
            var b6 = c5.data;
            if (c5.type === "graph") {
              b6 = b6 || c5.nodes;
              var S2 = c5.links || c5.edges;
              if (S2 && !u2(S2))
                for (var A2 = 0; A2 < S2.length; A2++)
                  QI(S2[A2]);
              Ye2(c5.categories, function(B3) {
                lct(B3);
              });
            }
            if (b6 && !u2(b6))
              for (var A2 = 0; A2 < b6.length; A2++)
                QI(b6[A2]);
            if (s = c5.markPoint, s && s.data)
              for (var k2 = s.data, A2 = 0; A2 < k2.length; A2++)
                QI(k2[A2]);
            if (r5 = c5.markLine, r5 && r5.data)
              for (var R6 = r5.data, A2 = 0; A2 < R6.length; A2++)
                ja2(R6[A2]) ? (QI(R6[A2][0]), QI(R6[A2][1])) : QI(R6[A2]);
            c5.type === "gauge" ? (im(c5, "axisLabel"), im(c5, "title"), im(c5, "detail")) : c5.type === "treemap" ? (Zw(c5.breadcrumb, "itemStyle"), Ye2(c5.levels, function(B3) {
              lct(B3);
            })) : c5.type === "tree" && lct(c5.leaves);
          }
        }
        function xR(c5) {
          return ja2(c5) ? c5 : c5 ? [c5] : [];
        }
        function STe(c5) {
          return (ja2(c5) ? c5[0] : c5) || {};
        }
        function q6n(c5, s) {
          Dk(xR(c5.series), function(g5) {
            sct(g5) && U6n(g5);
          });
          var r5 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
          s && r5.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), Dk(r5, function(g5) {
            Dk(xR(c5[g5]), function(b6) {
              b6 && (im(b6, "axisLabel"), im(b6.axisPointer, "label"));
            });
          }), Dk(xR(c5.parallel), function(g5) {
            var b6 = g5 && g5.parallelAxisDefault;
            im(b6, "axisLabel"), im(b6 && b6.axisPointer, "label");
          }), Dk(xR(c5.calendar), function(g5) {
            Zw(g5, "itemStyle"), im(g5, "dayLabel"), im(g5, "monthLabel"), im(g5, "yearLabel");
          }), Dk(xR(c5.radar), function(g5) {
            im(g5, "name"), g5.name && g5.axisName == null && (g5.axisName = g5.name, delete g5.name), g5.nameGap != null && g5.axisNameGap == null && (g5.axisNameGap = g5.nameGap, delete g5.nameGap);
          }), Dk(xR(c5.geo), function(g5) {
            sct(g5) && (QI(g5), Dk(xR(g5.regions), function(b6) {
              QI(b6);
            }));
          }), Dk(xR(c5.timeline), function(g5) {
            QI(g5), Zw(g5, "label"), Zw(g5, "itemStyle"), Zw(g5, "controlStyle", true);
            var b6 = g5.data;
            ja2(b6) && Ye2(b6, function(S2) {
              Wl(S2) && (Zw(S2, "label"), Zw(S2, "itemStyle"));
            });
          }), Dk(xR(c5.toolbox), function(g5) {
            Zw(g5, "iconStyle"), Dk(g5.feature, function(b6) {
              Zw(b6, "iconStyle");
            });
          }), im(STe(c5.axisPointer), "label"), im(STe(c5.tooltip).axisPointer, "label");
        }
        function Z6n(c5, s) {
          for (var r5 = s.split(","), g5 = c5, b6 = 0; b6 < r5.length && (g5 = g5 && g5[r5[b6]], g5 != null); b6++)
            ;
          return g5;
        }
        function $6n(c5, s, r5, g5) {
          for (var b6 = s.split(","), S2 = c5, A2, k2 = 0; k2 < b6.length - 1; k2++)
            A2 = b6[k2], S2[A2] == null && (S2[A2] = {}), S2 = S2[A2];
          (g5 || S2[b6[k2]] == null) && (S2[b6[k2]] = r5);
        }
        function MTe(c5) {
          c5 && Ye2(Y6n, function(s) {
            s[0] in c5 && !(s[1] in c5) && (c5[s[1]] = c5[s[0]]);
          });
        }
        var Y6n = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], K6n = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], RWt = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
        function uct(c5) {
          var s = c5 && c5.itemStyle;
          if (s)
            for (var r5 = 0; r5 < RWt.length; r5++) {
              var g5 = RWt[r5][1], b6 = RWt[r5][0];
              s[g5] != null && (s[b6] = s[g5]);
            }
        }
        function CTe(c5) {
          !c5 || c5.alignTo === "edge" && c5.margin != null && c5.edgeDistance == null && (c5.edgeDistance = c5.margin);
        }
        function TTe(c5) {
          !c5 || c5.downplay && !c5.blur && (c5.blur = c5.downplay);
        }
        function X6n(c5) {
          !c5 || c5.focusNodeAdjacency != null && (c5.emphasis = c5.emphasis || {}, c5.emphasis.focus == null && (c5.emphasis.focus = "adjacency"));
        }
        function ATe(c5, s) {
          if (c5)
            for (var r5 = 0; r5 < c5.length; r5++)
              s(c5[r5]), c5[r5] && ATe(c5[r5].children, s);
        }
        function ITe(c5, s) {
          q6n(c5, s), c5.series = xp(c5.series), Ye2(c5.series, function(r5) {
            if (Wl(r5)) {
              var g5 = r5.type;
              if (g5 === "line")
                r5.clipOverflow != null && (r5.clip = r5.clipOverflow);
              else if (g5 === "pie" || g5 === "gauge") {
                r5.clockWise != null && (r5.clockwise = r5.clockWise), CTe(r5.label);
                var b6 = r5.data;
                if (b6 && !u2(b6))
                  for (var S2 = 0; S2 < b6.length; S2++)
                    CTe(b6[S2]);
                r5.hoverOffset != null && (r5.emphasis = r5.emphasis || {}, (r5.emphasis.scaleSize = null) && (r5.emphasis.scaleSize = r5.hoverOffset));
              } else if (g5 === "gauge") {
                var A2 = Z6n(r5, "pointer.color");
                A2 != null && $6n(r5, "itemStyle.color", A2);
              } else if (g5 === "bar") {
                uct(r5), uct(r5.backgroundStyle), uct(r5.emphasis);
                var b6 = r5.data;
                if (b6 && !u2(b6))
                  for (var S2 = 0; S2 < b6.length; S2++)
                    typeof b6[S2] == "object" && (uct(b6[S2]), uct(b6[S2] && b6[S2].emphasis));
              } else if (g5 === "sunburst") {
                var k2 = r5.highlightPolicy;
                k2 && (r5.emphasis = r5.emphasis || {}, r5.emphasis.focus || (r5.emphasis.focus = k2)), TTe(r5), ATe(r5.data, TTe);
              } else
                g5 === "graph" || g5 === "sankey" ? X6n(r5) : g5 === "map" && (r5.mapType && !r5.map && (r5.map = r5.mapType), r5.mapLocation && Cl(r5, r5.mapLocation));
              r5.hoverAnimation != null && (r5.emphasis = r5.emphasis || {}, r5.emphasis && r5.emphasis.scale == null && (r5.emphasis.scale = r5.hoverAnimation)), MTe(r5);
            }
          }), c5.dataRange && (c5.visualMap = c5.dataRange), Ye2(K6n, function(r5) {
            var g5 = c5[r5];
            g5 && (ja2(g5) || (g5 = [g5]), Ye2(g5, function(b6) {
              MTe(b6);
            }));
          });
        }
        function Q6n(c5) {
          var s = Ps();
          c5.eachSeries(function(r5) {
            var g5 = r5.get("stack");
            if (g5) {
              var b6 = s.get(g5) || s.set(g5, []), S2 = r5.getData(), A2 = { stackResultDimension: S2.getCalculationInfo("stackResultDimension"), stackedOverDimension: S2.getCalculationInfo("stackedOverDimension"), stackedDimension: S2.getCalculationInfo("stackedDimension"), stackedByDimension: S2.getCalculationInfo("stackedByDimension"), isStackedByIndex: S2.getCalculationInfo("isStackedByIndex"), data: S2, seriesModel: r5 };
              if (!A2.stackedDimension || !(A2.isStackedByIndex || A2.stackedByDimension))
                return;
              b6.length && S2.setCalculationInfo("stackedOnSeries", b6[b6.length - 1].seriesModel), b6.push(A2);
            }
          }), s.each(J6n);
        }
        function J6n(c5) {
          Ye2(c5, function(s, r5) {
            var g5 = [], b6 = [NaN, NaN], S2 = [s.stackResultDimension, s.stackedOverDimension], A2 = s.data, k2 = s.isStackedByIndex;
            A2.modify(S2, function(R6, B3, G3) {
              var Z3 = A2.get(s.stackedDimension, G3);
              if (isNaN(Z3))
                return b6;
              var X3, tt;
              k2 ? tt = A2.getRawIndex(G3) : X3 = A2.get(s.stackedByDimension, G3);
              for (var it = NaN, pt = r5 - 1; pt >= 0; pt--) {
                var mt = c5[pt];
                if (k2 || (tt = mt.data.rawIndexOf(mt.stackedByDimension, X3)), tt >= 0) {
                  var Mt = mt.data.getByRawIndex(mt.stackResultDimension, tt);
                  if (Z3 >= 0 && Mt > 0 || Z3 <= 0 && Mt < 0) {
                    Z3 = Wlt(Z3, Mt), it = Mt;
                    break;
                  }
                }
              }
              return g5[0] = Z3, g5[1] = it, g5;
            });
          });
        }
        var rMt = function() {
          function c5(s) {
            this.data = s.data || (s.sourceFormat === I3 ? {} : []), this.sourceFormat = s.sourceFormat || sTe, this.seriesLayoutBy = s.seriesLayoutBy || D3, this.startIndex = s.startIndex || 0, this.dimensionsDetectedCount = s.dimensionsDetectedCount, this.metaRawOption = s.metaRawOption;
            var r5 = this.dimensionsDefine = s.dimensionsDefine;
            if (r5)
              for (var g5 = 0; g5 < r5.length; g5++) {
                var b6 = r5[g5];
                b6.type == null && cTe(this, g5) === xx.Must && (b6.type = "ordinal");
              }
          }
          return c5;
        }();
        function NWt(c5) {
          return c5 instanceof rMt;
        }
        function FWt(c5, s, r5) {
          r5 = r5 || DTe(c5);
          var g5 = s.seriesLayoutBy, b6 = eNn(c5, r5, g5, s.sourceHeader, s.dimensions), S2 = new rMt({ data: c5, sourceFormat: r5, seriesLayoutBy: g5, dimensionsDefine: b6.dimensionsDefine, startIndex: b6.startIndex, dimensionsDetectedCount: b6.dimensionsDetectedCount, metaRawOption: Ml(s) });
          return S2;
        }
        function VWt(c5) {
          return new rMt({ data: c5, sourceFormat: u2(c5) ? K8 : KI });
        }
        function tNn(c5) {
          return new rMt({ data: c5.data, sourceFormat: c5.sourceFormat, seriesLayoutBy: c5.seriesLayoutBy, dimensionsDefine: Ml(c5.dimensionsDefine), startIndex: c5.startIndex, dimensionsDetectedCount: c5.dimensionsDetectedCount });
        }
        function DTe(c5) {
          var s = sTe;
          if (u2(c5))
            s = K8;
          else if (ja2(c5)) {
            c5.length === 0 && (s = qw);
            for (var r5 = 0, g5 = c5.length; r5 < g5; r5++) {
              var b6 = c5[r5];
              if (b6 != null) {
                if (ja2(b6)) {
                  s = qw;
                  break;
                } else if (Wl(b6)) {
                  s = XI;
                  break;
                }
              }
            }
          } else if (Wl(c5)) {
            for (var S2 in c5)
              if (Ls(c5, S2) && Fb2(c5[S2])) {
                s = I3;
                break;
              }
          }
          return s;
        }
        function eNn(c5, s, r5, g5, b6) {
          var S2, A2;
          if (!c5)
            return { dimensionsDefine: ETe(b6), startIndex: A2, dimensionsDetectedCount: S2 };
          if (s === qw) {
            var k2 = c5;
            g5 === "auto" || g5 == null ? kTe(function(B3) {
              B3 != null && B3 !== "-" && (gs(B3) ? A2 == null && (A2 = 1) : A2 = 0);
            }, r5, k2, 10) : A2 = Oh2(g5) ? g5 : g5 ? 1 : 0, !b6 && A2 === 1 && (b6 = [], kTe(function(B3, G3) {
              b6[G3] = B3 != null ? B3 + "" : "";
            }, r5, k2, 1 / 0)), S2 = b6 ? b6.length : r5 === uX ? k2.length : k2[0] ? k2[0].length : null;
          } else if (s === XI)
            b6 || (b6 = nNn(c5));
          else if (s === I3)
            b6 || (b6 = [], Ye2(c5, function(B3, G3) {
              b6.push(G3);
            }));
          else if (s === KI) {
            var R6 = Sk(c5[0]);
            S2 = ja2(R6) && R6.length || 1;
          }
          return { startIndex: A2, dimensionsDefine: ETe(b6), dimensionsDetectedCount: S2 };
        }
        function nNn(c5) {
          for (var s = 0, r5; s < c5.length && !(r5 = c5[s++]); )
            ;
          if (r5) {
            var g5 = [];
            return Ye2(r5, function(b6, S2) {
              g5.push(S2);
            }), g5;
          }
        }
        function ETe(c5) {
          if (c5) {
            var s = Ps();
            return Ha2(c5, function(r5, g5) {
              r5 = Wl(r5) ? r5 : { name: r5 };
              var b6 = { name: r5.name, displayName: r5.displayName, type: r5.type };
              if (b6.name == null)
                return b6;
              b6.name += "", b6.displayName == null && (b6.displayName = b6.name);
              var S2 = s.get(b6.name);
              return S2 ? b6.name += "-" + S2.count++ : s.set(b6.name, { count: 1 }), b6;
            });
          }
        }
        function kTe(c5, s, r5, g5) {
          if (s === uX)
            for (var b6 = 0; b6 < r5.length && b6 < g5; b6++)
              c5(r5[b6] ? r5[b6][0] : null, b6);
          else
            for (var S2 = r5[0] || [], b6 = 0; b6 < S2.length && b6 < g5; b6++)
              c5(S2[b6], b6);
        }
        function PTe(c5) {
          var s = c5.sourceFormat;
          return s === XI || s === I3;
        }
        var uW, cW, fW, LTe, OTe, RTe = function() {
          function c5(s, r5) {
            var g5 = NWt(s) ? s : VWt(s);
            this._source = g5;
            var b6 = this._data = g5.data;
            g5.sourceFormat === K8 && (this._offset = 0, this._dimSize = r5, this._data = b6), OTe(this, b6, g5);
          }
          return c5.prototype.getSource = function() {
            return this._source;
          }, c5.prototype.count = function() {
            return 0;
          }, c5.prototype.getItem = function(s, r5) {
          }, c5.prototype.appendData = function(s) {
          }, c5.prototype.clean = function() {
          }, c5.protoInitialize = function() {
            var s = c5.prototype;
            s.pure = false, s.persistent = true;
          }(), c5.internalField = function() {
            var s;
            OTe = function(A2, k2, R6) {
              var B3 = R6.sourceFormat, G3 = R6.seriesLayoutBy, Z3 = R6.startIndex, X3 = R6.dimensionsDefine, tt = LTe[zWt(B3, G3)];
              if (sa2(A2, tt), B3 === K8)
                A2.getItem = r5, A2.count = b6, A2.fillStorage = g5;
              else {
                var it = FTe(B3, G3);
                A2.getItem = Cs(it, null, k2, Z3, X3);
                var pt = BTe(B3, G3);
                A2.count = Cs(pt, null, k2, Z3, X3);
              }
            };
            var r5 = function(A2, k2) {
              A2 = A2 - this._offset, k2 = k2 || [];
              for (var R6 = this._data, B3 = this._dimSize, G3 = B3 * A2, Z3 = 0; Z3 < B3; Z3++)
                k2[Z3] = R6[G3 + Z3];
              return k2;
            }, g5 = function(A2, k2, R6, B3) {
              for (var G3 = this._data, Z3 = this._dimSize, X3 = 0; X3 < Z3; X3++) {
                for (var tt = B3[X3], it = tt[0] == null ? 1 / 0 : tt[0], pt = tt[1] == null ? -1 / 0 : tt[1], mt = k2 - A2, Mt = R6[X3], kt = 0; kt < mt; kt++) {
                  var Gt = G3[kt * Z3 + X3];
                  Mt[A2 + kt] = Gt, Gt < it && (it = Gt), Gt > pt && (pt = Gt);
                }
                tt[0] = it, tt[1] = pt;
              }
            }, b6 = function() {
              return this._data ? this._data.length / this._dimSize : 0;
            };
            LTe = (s = {}, s[qw + "_" + D3] = { pure: true, appendData: S2 }, s[qw + "_" + uX] = { pure: true, appendData: function() {
              throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
            } }, s[XI] = { pure: true, appendData: S2 }, s[I3] = { pure: true, appendData: function(A2) {
              var k2 = this._data;
              Ye2(A2, function(R6, B3) {
                for (var G3 = k2[B3] || (k2[B3] = []), Z3 = 0; Z3 < (R6 || []).length; Z3++)
                  G3.push(R6[Z3]);
              });
            } }, s[KI] = { appendData: S2 }, s[K8] = { persistent: false, pure: true, appendData: function(A2) {
              this._data = A2;
            }, clean: function() {
              this._offset += this.count(), this._data = null;
            } }, s);
            function S2(A2) {
              for (var k2 = 0; k2 < A2.length; k2++)
                this._data.push(A2[k2]);
            }
          }(), c5;
        }(), NTe = function(c5, s, r5, g5) {
          return c5[g5];
        }, rNn = (uW = {}, uW[qw + "_" + D3] = function(c5, s, r5, g5) {
          return c5[g5 + s];
        }, uW[qw + "_" + uX] = function(c5, s, r5, g5, b6) {
          g5 += s;
          for (var S2 = b6 || [], A2 = c5, k2 = 0; k2 < A2.length; k2++) {
            var R6 = A2[k2];
            S2[k2] = R6 ? R6[g5] : null;
          }
          return S2;
        }, uW[XI] = NTe, uW[I3] = function(c5, s, r5, g5, b6) {
          for (var S2 = b6 || [], A2 = 0; A2 < r5.length; A2++) {
            var k2 = r5[A2].name, R6 = c5[k2];
            S2[A2] = R6 ? R6[g5] : null;
          }
          return S2;
        }, uW[KI] = NTe, uW);
        function FTe(c5, s) {
          var r5 = rNn[zWt(c5, s)];
          return r5;
        }
        var VTe = function(c5, s, r5) {
          return c5.length;
        }, iNn = (cW = {}, cW[qw + "_" + D3] = function(c5, s, r5) {
          return Math.max(0, c5.length - s);
        }, cW[qw + "_" + uX] = function(c5, s, r5) {
          var g5 = c5[0];
          return g5 ? Math.max(0, g5.length - s) : 0;
        }, cW[XI] = VTe, cW[I3] = function(c5, s, r5) {
          var g5 = r5[0].name, b6 = c5[g5];
          return b6 ? b6.length : 0;
        }, cW[KI] = VTe, cW);
        function BTe(c5, s) {
          var r5 = iNn[zWt(c5, s)];
          return r5;
        }
        var BWt = function(c5, s, r5) {
          return c5[s];
        }, aNn = (fW = {}, fW[qw] = BWt, fW[XI] = function(c5, s, r5) {
          return c5[r5];
        }, fW[I3] = BWt, fW[KI] = function(c5, s, r5) {
          var g5 = Sk(c5);
          return g5 instanceof Array ? g5[s] : g5;
        }, fW[K8] = BWt, fW);
        function zTe(c5) {
          var s = aNn[c5];
          return s;
        }
        function zWt(c5, s) {
          return c5 === qw ? c5 + "_" + s : c5;
        }
        function cX(c5, s, r5) {
          if (c5) {
            var g5 = c5.getRawDataItem(s);
            if (g5 != null) {
              var b6 = c5.getStore(), S2 = b6.getSource().sourceFormat;
              if (r5 != null) {
                var A2 = c5.getDimensionIndex(r5), k2 = b6.getDimensionProperty(A2);
                return zTe(S2)(g5, A2, k2);
              } else {
                var R6 = g5;
                return S2 === KI && (R6 = Sk(g5)), R6;
              }
            }
          }
        }
        var oNn = /\{@(.+?)\}/g, jWt = function() {
          function c5() {
          }
          return c5.prototype.getDataParams = function(s, r5) {
            var g5 = this.getData(r5), b6 = this.getRawValue(s, r5), S2 = g5.getRawIndex(s), A2 = g5.getName(s), k2 = g5.getRawDataItem(s), R6 = g5.getItemVisual(s, "style"), B3 = R6 && R6[g5.getItemVisual(s, "drawType") || "fill"], G3 = R6 && R6.stroke, Z3 = this.mainType, X3 = Z3 === "series", tt = g5.userOutput && g5.userOutput.get();
            return { componentType: Z3, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: X3 ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: X3 ? this.id : null, seriesName: X3 ? this.name : null, name: A2, dataIndex: S2, data: k2, dataType: r5, value: b6, color: B3, borderColor: G3, dimensionNames: tt ? tt.fullDimensions : null, encode: tt ? tt.encode : null, $vars: ["seriesName", "name", "value"] };
          }, c5.prototype.getFormattedLabel = function(s, r5, g5, b6, S2, A2) {
            r5 = r5 || "normal";
            var k2 = this.getData(g5), R6 = this.getDataParams(s, g5);
            if (A2 && (R6.value = A2.interpolatedValue), b6 != null && ja2(R6.value) && (R6.value = R6.value[b6]), !S2) {
              var B3 = k2.getItemModel(s);
              S2 = B3.get(r5 === "normal" ? ["label", "formatter"] : [r5, "label", "formatter"]);
            }
            if (Tl(S2))
              return R6.status = r5, R6.dimensionIndex = b6, S2(R6);
            if (gs(S2)) {
              var G3 = nTe(S2, R6);
              return G3.replace(oNn, function(Z3, X3) {
                var tt = X3.length, it = X3;
                it.charAt(0) === "[" && it.charAt(tt - 1) === "]" && (it = +it.slice(1, tt - 1));
                var pt = cX(k2, s, it);
                if (A2 && ja2(A2.interpolatedValue)) {
                  var mt = k2.getDimensionIndex(it);
                  mt >= 0 && (pt = A2.interpolatedValue[mt]);
                }
                return pt != null ? pt + "" : "";
              });
            }
          }, c5.prototype.getRawValue = function(s, r5) {
            return cX(this.getData(r5), s);
          }, c5.prototype.formatTooltip = function(s, r5, g5) {
          }, c5;
        }();
        function jTe(c5) {
          var s, r5;
          return Wl(c5) ? c5.type && (r5 = c5) : s = c5, { text: s, frag: r5 };
        }
        function cct(c5) {
          return new sNn(c5);
        }
        var sNn = function() {
          function c5(s) {
            s = s || {}, this._reset = s.reset, this._plan = s.plan, this._count = s.count, this._onDirty = s.onDirty, this._dirty = true;
          }
          return c5.prototype.perform = function(s) {
            var r5 = this._upstream, g5 = s && s.skip;
            if (this._dirty && r5) {
              var b6 = this.context;
              b6.data = b6.outputData = r5.context.outputData;
            }
            this.__pipeline && (this.__pipeline.currentTask = this);
            var S2;
            this._plan && !g5 && (S2 = this._plan(this.context));
            var A2 = G3(this._modBy), k2 = this._modDataCount || 0, R6 = G3(s && s.modBy), B3 = s && s.modDataCount || 0;
            (A2 !== R6 || k2 !== B3) && (S2 = "reset");
            function G3(kt) {
              return !(kt >= 1) && (kt = 1), kt;
            }
            var Z3;
            (this._dirty || S2 === "reset") && (this._dirty = false, Z3 = this._doReset(g5)), this._modBy = R6, this._modDataCount = B3;
            var X3 = s && s.step;
            if (r5 ? this._dueEnd = r5._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
              var tt = this._dueIndex, it = Math.min(X3 != null ? this._dueIndex + X3 : 1 / 0, this._dueEnd);
              if (!g5 && (Z3 || tt < it)) {
                var pt = this._progress;
                if (ja2(pt))
                  for (var mt = 0; mt < pt.length; mt++)
                    this._doProgress(pt[mt], tt, it, R6, B3);
                else
                  this._doProgress(pt, tt, it, R6, B3);
              }
              this._dueIndex = it;
              var Mt = this._settedOutputEnd != null ? this._settedOutputEnd : it;
              this._outputDueEnd = Mt;
            } else
              this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
            return this.unfinished();
          }, c5.prototype.dirty = function() {
            this._dirty = true, this._onDirty && this._onDirty(this.context);
          }, c5.prototype._doProgress = function(s, r5, g5, b6, S2) {
            WTe.reset(r5, g5, b6, S2), this._callingProgress = s, this._callingProgress({ start: r5, end: g5, count: g5 - r5, next: WTe.next }, this.context);
          }, c5.prototype._doReset = function(s) {
            this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
            var r5, g5;
            !s && this._reset && (r5 = this._reset(this.context), r5 && r5.progress && (g5 = r5.forceFirstProgress, r5 = r5.progress), ja2(r5) && !r5.length && (r5 = null)), this._progress = r5, this._modBy = this._modDataCount = null;
            var b6 = this._downstream;
            return b6 && b6.dirty(), g5;
          }, c5.prototype.unfinished = function() {
            return this._progress && this._dueIndex < this._dueEnd;
          }, c5.prototype.pipe = function(s) {
            (this._downstream !== s || this._dirty) && (this._downstream = s, s._upstream = this, s.dirty());
          }, c5.prototype.dispose = function() {
            this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
          }, c5.prototype.getUpstream = function() {
            return this._upstream;
          }, c5.prototype.getDownstream = function() {
            return this._downstream;
          }, c5.prototype.setOutputEnd = function(s) {
            this._outputDueEnd = this._settedOutputEnd = s;
          }, c5;
        }(), WTe = function() {
          var c5, s, r5, g5, b6, S2 = { reset: function(R6, B3, G3, Z3) {
            s = R6, c5 = B3, r5 = G3, g5 = Z3, b6 = Math.ceil(g5 / r5), S2.next = r5 > 1 && g5 > 0 ? k2 : A2;
          } };
          return S2;
          function A2() {
            return s < c5 ? s++ : null;
          }
          function k2() {
            var R6 = s % b6 * r5 + Math.ceil(s / b6), B3 = s >= c5 ? null : R6 < g5 ? R6 : s;
            return s++, B3;
          }
        }();
        function X8(c5, s) {
          var r5 = s && s.type;
          return r5 === "ordinal" ? c5 : (r5 === "time" && !Oh2(c5) && c5 != null && c5 !== "-" && (c5 = +QC(c5)), c5 == null || c5 === "" ? NaN : +c5);
        }
        var lNn = Ps({ number: function(c5) {
          return parseFloat(c5);
        }, time: function(c5) {
          return +QC(c5);
        }, trim: function(c5) {
          return gs(c5) ? Tg2(c5) : c5;
        } });
        function GTe(c5) {
          return lNn.get(c5);
        }
        var HTe = { lt: function(c5, s) {
          return c5 < s;
        }, lte: function(c5, s) {
          return c5 <= s;
        }, gt: function(c5, s) {
          return c5 > s;
        }, gte: function(c5, s) {
          return c5 >= s;
        } }, uNn = function() {
          function c5(s, r5) {
            if (!Oh2(r5)) {
              var g5 = "";
              rf2(g5);
            }
            this._opFn = HTe[s], this._rvalFloat = NI(r5);
          }
          return c5.prototype.evaluate = function(s) {
            return Oh2(s) ? this._opFn(s, this._rvalFloat) : this._opFn(NI(s), this._rvalFloat);
          }, c5;
        }(), UTe = function() {
          function c5(s, r5) {
            var g5 = s === "desc";
            this._resultLT = g5 ? 1 : -1, r5 == null && (r5 = g5 ? "min" : "max"), this._incomparable = r5 === "min" ? -1 / 0 : 1 / 0;
          }
          return c5.prototype.evaluate = function(s, r5) {
            var g5 = Oh2(s) ? s : NI(s), b6 = Oh2(r5) ? r5 : NI(r5), S2 = isNaN(g5), A2 = isNaN(b6);
            if (S2 && (g5 = this._incomparable), A2 && (b6 = this._incomparable), S2 && A2) {
              var k2 = gs(s), R6 = gs(r5);
              k2 && (g5 = R6 ? s : 0), R6 && (b6 = k2 ? r5 : 0);
            }
            return g5 < b6 ? this._resultLT : g5 > b6 ? -this._resultLT : 0;
          }, c5;
        }(), cNn = function() {
          function c5(s, r5) {
            this._rval = r5, this._isEQ = s, this._rvalTypeof = typeof r5, this._rvalFloat = NI(r5);
          }
          return c5.prototype.evaluate = function(s) {
            var r5 = s === this._rval;
            if (!r5) {
              var g5 = typeof s;
              g5 !== this._rvalTypeof && (g5 === "number" || this._rvalTypeof === "number") && (r5 = NI(s) === this._rvalFloat);
            }
            return this._isEQ ? r5 : !r5;
          }, c5;
        }();
        function fNn(c5, s) {
          return c5 === "eq" || c5 === "ne" ? new cNn(c5 === "eq", s) : Ls(HTe, c5) ? new uNn(c5, s) : null;
        }
        var hNn = function() {
          function c5() {
          }
          return c5.prototype.getRawData = function() {
            throw new Error("not supported");
          }, c5.prototype.getRawDataItem = function(s) {
            throw new Error("not supported");
          }, c5.prototype.cloneRawData = function() {
          }, c5.prototype.getDimensionInfo = function(s) {
          }, c5.prototype.cloneAllDimensionInfo = function() {
          }, c5.prototype.count = function() {
          }, c5.prototype.retrieveValue = function(s, r5) {
          }, c5.prototype.retrieveValueFromItem = function(s, r5) {
          }, c5.prototype.convertValue = function(s, r5) {
            return X8(s, r5);
          }, c5;
        }();
        function pNn(c5, s) {
          var r5 = new hNn(), g5 = c5.data, b6 = r5.sourceFormat = c5.sourceFormat, S2 = c5.startIndex, A2 = "";
          c5.seriesLayoutBy !== D3 && rf2(A2);
          var k2 = [], R6 = {}, B3 = c5.dimensionsDefine;
          if (B3)
            Ye2(B3, function(pt, mt) {
              var Mt = pt.name, kt = { index: mt, name: Mt, displayName: pt.displayName };
              if (k2.push(kt), Mt != null) {
                var Gt = "";
                Ls(R6, Mt) && rf2(Gt), R6[Mt] = kt;
              }
            });
          else
            for (var G3 = 0; G3 < c5.dimensionsDetectedCount; G3++)
              k2.push({ index: G3 });
          var Z3 = FTe(b6, D3);
          s.__isBuiltIn && (r5.getRawDataItem = function(pt) {
            return Z3(g5, S2, k2, pt);
          }, r5.getRawData = Cs(dNn, null, c5)), r5.cloneRawData = Cs(gNn, null, c5);
          var X3 = BTe(b6, D3);
          r5.count = Cs(X3, null, g5, S2, k2);
          var tt = zTe(b6);
          r5.retrieveValue = function(pt, mt) {
            var Mt = Z3(g5, S2, k2, pt);
            return it(Mt, mt);
          };
          var it = r5.retrieveValueFromItem = function(pt, mt) {
            if (pt != null) {
              var Mt = k2[mt];
              if (Mt)
                return tt(pt, mt, Mt.name);
            }
          };
          return r5.getDimensionInfo = Cs(vNn, null, k2, R6), r5.cloneAllDimensionInfo = Cs(yNn, null, k2), r5;
        }
        function dNn(c5) {
          var s = c5.sourceFormat;
          if (!WWt(s)) {
            var r5 = "";
            rf2(r5);
          }
          return c5.data;
        }
        function gNn(c5) {
          var s = c5.sourceFormat, r5 = c5.data;
          if (!WWt(s)) {
            var g5 = "";
            rf2(g5);
          }
          if (s === qw) {
            for (var b6 = [], S2 = 0, A2 = r5.length; S2 < A2; S2++)
              b6.push(r5[S2].slice());
            return b6;
          } else if (s === XI) {
            for (var b6 = [], S2 = 0, A2 = r5.length; S2 < A2; S2++)
              b6.push(sa2({}, r5[S2]));
            return b6;
          }
        }
        function vNn(c5, s, r5) {
          if (r5 != null) {
            if (Oh2(r5) || !isNaN(r5) && !Ls(s, r5))
              return c5[r5];
            if (Ls(s, r5))
              return s[r5];
          }
        }
        function yNn(c5) {
          return Ml(c5);
        }
        var qTe = Ps();
        function mNn(c5) {
          c5 = Ml(c5);
          var s = c5.type, r5 = "";
          s || rf2(r5);
          var g5 = s.split(":");
          g5.length !== 2 && rf2(r5);
          var b6 = false;
          g5[0] === "echarts" && (s = g5[1], b6 = true), c5.__isBuiltIn = b6, qTe.set(s, c5);
        }
        function bNn(c5, s, r5) {
          var g5 = xp(c5), b6 = g5.length, S2 = "";
          b6 || rf2(S2);
          for (var A2 = 0, k2 = b6; A2 < k2; A2++) {
            var R6 = g5[A2];
            s = _Nn(R6, s), A2 !== k2 - 1 && (s.length = Math.max(s.length, 1));
          }
          return s;
        }
        function _Nn(c5, s, r5, g5) {
          var b6 = "";
          s.length || rf2(b6), Wl(c5) || rf2(b6);
          var S2 = c5.type, A2 = qTe.get(S2);
          A2 || rf2(b6);
          var k2 = Ha2(s, function(B3) {
            return pNn(B3, A2);
          }), R6 = xp(A2.transform({ upstream: k2[0], upstreamList: k2, config: Ml(c5.config) }));
          return Ha2(R6, function(B3, G3) {
            var Z3 = "";
            Wl(B3) || rf2(Z3), B3.data || rf2(Z3);
            var X3 = DTe(B3.data);
            WWt(X3) || rf2(Z3);
            var tt, it = s[0];
            if (it && G3 === 0 && !B3.dimensions) {
              var pt = it.startIndex;
              pt && (B3.data = it.data.slice(0, pt).concat(B3.data)), tt = { seriesLayoutBy: D3, sourceHeader: pt, dimensions: it.metaRawOption.dimensions };
            } else
              tt = { seriesLayoutBy: D3, sourceHeader: 0, dimensions: B3.dimensions };
            return FWt(B3.data, tt, null);
          });
        }
        function WWt(c5) {
          return c5 === qw || c5 === XI;
        }
        var iMt = "undefined", xNn = typeof Uint32Array === iMt ? Array : Uint32Array, wNn = typeof Uint16Array === iMt ? Array : Uint16Array, ZTe = typeof Int32Array === iMt ? Array : Int32Array, $Te = typeof Float64Array === iMt ? Array : Float64Array, YTe = { float: $Te, int: ZTe, ordinal: Array, number: Array, time: $Te }, GWt;
        function fct(c5) {
          return c5 > 65535 ? xNn : wNn;
        }
        function fX() {
          return [1 / 0, -1 / 0];
        }
        function SNn(c5) {
          var s = c5.constructor;
          return s === Array ? c5.slice() : new s(c5);
        }
        function KTe(c5, s, r5, g5, b6) {
          var S2 = YTe[r5 || "float"];
          if (b6) {
            var A2 = c5[s], k2 = A2 && A2.length;
            if (k2 !== g5) {
              for (var R6 = new S2(g5), B3 = 0; B3 < k2; B3++)
                R6[B3] = A2[B3];
              c5[s] = R6;
            }
          } else
            c5[s] = new S2(g5);
        }
        var HWt = function() {
          function c5() {
            this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = Ps();
          }
          return c5.prototype.initData = function(s, r5, g5) {
            this._provider = s, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
            var b6 = s.getSource(), S2 = this.defaultDimValueGetter = GWt[b6.sourceFormat];
            this._dimValueGetter = g5 || S2, this._rawExtent = [], PTe(b6), this._dimensions = Ha2(r5, function(A2) {
              return { type: A2.type, property: A2.property };
            }), this._initDataFromProvider(0, s.count());
          }, c5.prototype.getProvider = function() {
            return this._provider;
          }, c5.prototype.getSource = function() {
            return this._provider.getSource();
          }, c5.prototype.ensureCalculationDimension = function(s, r5) {
            var g5 = this._calcDimNameToIdx, b6 = this._dimensions, S2 = g5.get(s);
            if (S2 != null) {
              if (b6[S2].type === r5)
                return S2;
            } else
              S2 = b6.length;
            return b6[S2] = { type: r5 }, g5.set(s, S2), this._chunks[S2] = new YTe[r5 || "float"](this._rawCount), this._rawExtent[S2] = fX(), S2;
          }, c5.prototype.collectOrdinalMeta = function(s, r5) {
            var g5 = this._chunks[s], b6 = this._dimensions[s], S2 = this._rawExtent, A2 = b6.ordinalOffset || 0, k2 = g5.length;
            A2 === 0 && (S2[s] = fX());
            for (var R6 = S2[s], B3 = A2; B3 < k2; B3++) {
              var G3 = g5[B3] = r5.parseAndCollect(g5[B3]);
              R6[0] = Math.min(G3, R6[0]), R6[1] = Math.max(G3, R6[1]);
            }
            b6.ordinalMeta = r5, b6.ordinalOffset = k2, b6.type = "ordinal";
          }, c5.prototype.getOrdinalMeta = function(s) {
            var r5 = this._dimensions[s], g5 = r5.ordinalMeta;
            return g5;
          }, c5.prototype.getDimensionProperty = function(s) {
            var r5 = this._dimensions[s];
            return r5 && r5.property;
          }, c5.prototype.appendData = function(s) {
            var r5 = this._provider, g5 = this.count();
            r5.appendData(s);
            var b6 = r5.count();
            return r5.persistent || (b6 += g5), g5 < b6 && this._initDataFromProvider(g5, b6, true), [g5, b6];
          }, c5.prototype.appendValues = function(s, r5) {
            for (var g5 = this._chunks, b6 = this._dimensions, S2 = b6.length, A2 = this._rawExtent, k2 = this.count(), R6 = k2 + Math.max(s.length, r5 || 0), B3 = 0; B3 < S2; B3++) {
              var G3 = b6[B3];
              KTe(g5, B3, G3.type, R6, true);
            }
            for (var Z3 = [], X3 = k2; X3 < R6; X3++)
              for (var tt = X3 - k2, it = 0; it < S2; it++) {
                var G3 = b6[it], pt = GWt.arrayRows.call(this, s[tt] || Z3, G3.property, tt, it);
                g5[it][X3] = pt;
                var mt = A2[it];
                pt < mt[0] && (mt[0] = pt), pt > mt[1] && (mt[1] = pt);
              }
            return this._rawCount = this._count = R6, { start: k2, end: R6 };
          }, c5.prototype._initDataFromProvider = function(s, r5, g5) {
            for (var b6 = this._provider, S2 = this._chunks, A2 = this._dimensions, k2 = A2.length, R6 = this._rawExtent, B3 = Ha2(A2, function(kt) {
              return kt.property;
            }), G3 = 0; G3 < k2; G3++) {
              var Z3 = A2[G3];
              R6[G3] || (R6[G3] = fX()), KTe(S2, G3, Z3.type, r5, g5);
            }
            if (b6.fillStorage)
              b6.fillStorage(s, r5, S2, R6);
            else
              for (var X3 = [], tt = s; tt < r5; tt++) {
                X3 = b6.getItem(tt, X3);
                for (var it = 0; it < k2; it++) {
                  var pt = S2[it], mt = this._dimValueGetter(X3, B3[it], tt, it);
                  pt[tt] = mt;
                  var Mt = R6[it];
                  mt < Mt[0] && (Mt[0] = mt), mt > Mt[1] && (Mt[1] = mt);
                }
              }
            !b6.persistent && b6.clean && b6.clean(), this._rawCount = this._count = r5, this._extent = [];
          }, c5.prototype.count = function() {
            return this._count;
          }, c5.prototype.get = function(s, r5) {
            if (!(r5 >= 0 && r5 < this._count))
              return NaN;
            var g5 = this._chunks[s];
            return g5 ? g5[this.getRawIndex(r5)] : NaN;
          }, c5.prototype.getValues = function(s, r5) {
            var g5 = [], b6 = [];
            if (r5 == null) {
              r5 = s, s = [];
              for (var S2 = 0; S2 < this._dimensions.length; S2++)
                b6.push(S2);
            } else
              b6 = s;
            for (var S2 = 0, A2 = b6.length; S2 < A2; S2++)
              g5.push(this.get(b6[S2], r5));
            return g5;
          }, c5.prototype.getByRawIndex = function(s, r5) {
            if (!(r5 >= 0 && r5 < this._rawCount))
              return NaN;
            var g5 = this._chunks[s];
            return g5 ? g5[r5] : NaN;
          }, c5.prototype.getSum = function(s) {
            var r5 = this._chunks[s], g5 = 0;
            if (r5)
              for (var b6 = 0, S2 = this.count(); b6 < S2; b6++) {
                var A2 = this.get(s, b6);
                isNaN(A2) || (g5 += A2);
              }
            return g5;
          }, c5.prototype.getMedian = function(s) {
            var r5 = [];
            this.each([s], function(S2) {
              isNaN(S2) || r5.push(S2);
            });
            var g5 = r5.sort(function(S2, A2) {
              return S2 - A2;
            }), b6 = this.count();
            return b6 === 0 ? 0 : b6 % 2 === 1 ? g5[(b6 - 1) / 2] : (g5[b6 / 2] + g5[b6 / 2 - 1]) / 2;
          }, c5.prototype.indexOfRawIndex = function(s) {
            if (s >= this._rawCount || s < 0)
              return -1;
            if (!this._indices)
              return s;
            var r5 = this._indices, g5 = r5[s];
            if (g5 != null && g5 < this._count && g5 === s)
              return s;
            for (var b6 = 0, S2 = this._count - 1; b6 <= S2; ) {
              var A2 = (b6 + S2) / 2 | 0;
              if (r5[A2] < s)
                b6 = A2 + 1;
              else if (r5[A2] > s)
                S2 = A2 - 1;
              else
                return A2;
            }
            return -1;
          }, c5.prototype.indicesOfNearest = function(s, r5, g5) {
            var b6 = this._chunks, S2 = b6[s], A2 = [];
            if (!S2)
              return A2;
            g5 == null && (g5 = 1 / 0);
            for (var k2 = 1 / 0, R6 = -1, B3 = 0, G3 = 0, Z3 = this.count(); G3 < Z3; G3++) {
              var X3 = this.getRawIndex(G3), tt = r5 - S2[X3], it = Math.abs(tt);
              it <= g5 && ((it < k2 || it === k2 && tt >= 0 && R6 < 0) && (k2 = it, R6 = tt, B3 = 0), tt === R6 && (A2[B3++] = G3));
            }
            return A2.length = B3, A2;
          }, c5.prototype.getIndices = function() {
            var s, r5 = this._indices;
            if (r5) {
              var g5 = r5.constructor, b6 = this._count;
              if (g5 === Array) {
                s = new g5(b6);
                for (var S2 = 0; S2 < b6; S2++)
                  s[S2] = r5[S2];
              } else
                s = new g5(r5.buffer, 0, b6);
            } else {
              var g5 = fct(this._rawCount);
              s = new g5(this.count());
              for (var S2 = 0; S2 < s.length; S2++)
                s[S2] = S2;
            }
            return s;
          }, c5.prototype.filter = function(s, r5) {
            if (!this._count)
              return this;
            for (var g5 = this.clone(), b6 = g5.count(), S2 = fct(g5._rawCount), A2 = new S2(b6), k2 = [], R6 = s.length, B3 = 0, G3 = s[0], Z3 = g5._chunks, X3 = 0; X3 < b6; X3++) {
              var tt = void 0, it = g5.getRawIndex(X3);
              if (R6 === 0)
                tt = r5(X3);
              else if (R6 === 1) {
                var pt = Z3[G3][it];
                tt = r5(pt, X3);
              } else {
                for (var mt = 0; mt < R6; mt++)
                  k2[mt] = Z3[s[mt]][it];
                k2[mt] = X3, tt = r5.apply(null, k2);
              }
              tt && (A2[B3++] = it);
            }
            return B3 < b6 && (g5._indices = A2), g5._count = B3, g5._extent = [], g5._updateGetRawIdx(), g5;
          }, c5.prototype.selectRange = function(s) {
            var r5 = this.clone(), g5 = r5._count;
            if (!g5)
              return this;
            var b6 = nf2(s), S2 = b6.length;
            if (!S2)
              return this;
            var A2 = r5.count(), k2 = fct(r5._rawCount), R6 = new k2(A2), B3 = 0, G3 = b6[0], Z3 = s[G3][0], X3 = s[G3][1], tt = r5._chunks, it = false;
            if (!r5._indices) {
              var pt = 0;
              if (S2 === 1) {
                for (var mt = tt[b6[0]], Mt = 0; Mt < g5; Mt++) {
                  var kt = mt[Mt];
                  (kt >= Z3 && kt <= X3 || isNaN(kt)) && (R6[B3++] = pt), pt++;
                }
                it = true;
              } else if (S2 === 2) {
                for (var mt = tt[b6[0]], Gt = tt[b6[1]], Ot = s[b6[1]][0], ce2 = s[b6[1]][1], Mt = 0; Mt < g5; Mt++) {
                  var kt = mt[Mt], ae2 = Gt[Mt];
                  (kt >= Z3 && kt <= X3 || isNaN(kt)) && (ae2 >= Ot && ae2 <= ce2 || isNaN(ae2)) && (R6[B3++] = pt), pt++;
                }
                it = true;
              }
            }
            if (!it)
              if (S2 === 1)
                for (var Mt = 0; Mt < A2; Mt++) {
                  var de2 = r5.getRawIndex(Mt), kt = tt[b6[0]][de2];
                  (kt >= Z3 && kt <= X3 || isNaN(kt)) && (R6[B3++] = de2);
                }
              else
                for (var Mt = 0; Mt < A2; Mt++) {
                  for (var we2 = true, de2 = r5.getRawIndex(Mt), Se2 = 0; Se2 < S2; Se2++) {
                    var Oe2 = b6[Se2], kt = tt[Oe2][de2];
                    (kt < s[Oe2][0] || kt > s[Oe2][1]) && (we2 = false);
                  }
                  we2 && (R6[B3++] = r5.getRawIndex(Mt));
                }
            return B3 < A2 && (r5._indices = R6), r5._count = B3, r5._extent = [], r5._updateGetRawIdx(), r5;
          }, c5.prototype.map = function(s, r5) {
            var g5 = this.clone(s);
            return this._updateDims(g5, s, r5), g5;
          }, c5.prototype.modify = function(s, r5) {
            this._updateDims(this, s, r5);
          }, c5.prototype._updateDims = function(s, r5, g5) {
            for (var b6 = s._chunks, S2 = [], A2 = r5.length, k2 = s.count(), R6 = [], B3 = s._rawExtent, G3 = 0; G3 < r5.length; G3++)
              B3[r5[G3]] = fX();
            for (var Z3 = 0; Z3 < k2; Z3++) {
              for (var X3 = s.getRawIndex(Z3), tt = 0; tt < A2; tt++)
                R6[tt] = b6[r5[tt]][X3];
              R6[A2] = Z3;
              var it = g5 && g5.apply(null, R6);
              if (it != null) {
                typeof it != "object" && (S2[0] = it, it = S2);
                for (var G3 = 0; G3 < it.length; G3++) {
                  var pt = r5[G3], mt = it[G3], Mt = B3[pt], kt = b6[pt];
                  kt && (kt[X3] = mt), mt < Mt[0] && (Mt[0] = mt), mt > Mt[1] && (Mt[1] = mt);
                }
              }
            }
          }, c5.prototype.lttbDownSample = function(s, r5) {
            var g5 = this.clone([s], true), b6 = g5._chunks, S2 = b6[s], A2 = this.count(), k2 = 0, R6 = Math.floor(1 / r5), B3 = this.getRawIndex(0), G3, Z3, X3, tt = new (fct(this._rawCount))(Math.min((Math.ceil(A2 / R6) + 2) * 2, A2));
            tt[k2++] = B3;
            for (var it = 1; it < A2 - 1; it += R6) {
              for (var pt = Math.min(it + R6, A2 - 1), mt = Math.min(it + R6 * 2, A2), Mt = (mt + pt) / 2, kt = 0, Gt = pt; Gt < mt; Gt++) {
                var Ot = this.getRawIndex(Gt), ce2 = S2[Ot];
                isNaN(ce2) || (kt += ce2);
              }
              kt /= mt - pt;
              var ae2 = it, de2 = Math.min(it + R6, A2), we2 = it - 1, Se2 = S2[B3];
              G3 = -1, X3 = ae2;
              for (var Oe2 = -1, je2 = 0, Gt = ae2; Gt < de2; Gt++) {
                var Ot = this.getRawIndex(Gt), ce2 = S2[Ot];
                if (isNaN(ce2)) {
                  je2++, Oe2 < 0 && (Oe2 = Ot);
                  continue;
                }
                Z3 = Math.abs((we2 - Mt) * (ce2 - Se2) - (we2 - Gt) * (kt - Se2)), Z3 > G3 && (G3 = Z3, X3 = Ot);
              }
              je2 > 0 && je2 < de2 - ae2 && (tt[k2++] = Math.min(Oe2, X3), X3 = Math.max(Oe2, X3)), tt[k2++] = X3, B3 = X3;
            }
            return tt[k2++] = this.getRawIndex(A2 - 1), g5._count = k2, g5._indices = tt, g5.getRawIndex = this._getRawIdx, g5;
          }, c5.prototype.downSample = function(s, r5, g5, b6) {
            for (var S2 = this.clone([s], true), A2 = S2._chunks, k2 = [], R6 = Math.floor(1 / r5), B3 = A2[s], G3 = this.count(), Z3 = S2._rawExtent[s] = fX(), X3 = new (fct(this._rawCount))(Math.ceil(G3 / R6)), tt = 0, it = 0; it < G3; it += R6) {
              R6 > G3 - it && (R6 = G3 - it, k2.length = R6);
              for (var pt = 0; pt < R6; pt++) {
                var mt = this.getRawIndex(it + pt);
                k2[pt] = B3[mt];
              }
              var Mt = g5(k2), kt = this.getRawIndex(Math.min(it + b6(k2, Mt) || 0, G3 - 1));
              B3[kt] = Mt, Mt < Z3[0] && (Z3[0] = Mt), Mt > Z3[1] && (Z3[1] = Mt), X3[tt++] = kt;
            }
            return S2._count = tt, S2._indices = X3, S2._updateGetRawIdx(), S2;
          }, c5.prototype.each = function(s, r5) {
            if (this._count)
              for (var g5 = s.length, b6 = this._chunks, S2 = 0, A2 = this.count(); S2 < A2; S2++) {
                var k2 = this.getRawIndex(S2);
                switch (g5) {
                  case 0:
                    r5(S2);
                    break;
                  case 1:
                    r5(b6[s[0]][k2], S2);
                    break;
                  case 2:
                    r5(b6[s[0]][k2], b6[s[1]][k2], S2);
                    break;
                  default:
                    for (var R6 = 0, B3 = []; R6 < g5; R6++)
                      B3[R6] = b6[s[R6]][k2];
                    B3[R6] = S2, r5.apply(null, B3);
                }
              }
          }, c5.prototype.getDataExtent = function(s) {
            var r5 = this._chunks[s], g5 = fX();
            if (!r5)
              return g5;
            var b6 = this.count(), S2 = !this._indices, A2;
            if (S2)
              return this._rawExtent[s].slice();
            if (A2 = this._extent[s], A2)
              return A2.slice();
            A2 = g5;
            for (var k2 = A2[0], R6 = A2[1], B3 = 0; B3 < b6; B3++) {
              var G3 = this.getRawIndex(B3), Z3 = r5[G3];
              Z3 < k2 && (k2 = Z3), Z3 > R6 && (R6 = Z3);
            }
            return A2 = [k2, R6], this._extent[s] = A2, A2;
          }, c5.prototype.getRawDataItem = function(s) {
            var r5 = this.getRawIndex(s);
            if (this._provider.persistent)
              return this._provider.getItem(r5);
            for (var g5 = [], b6 = this._chunks, S2 = 0; S2 < b6.length; S2++)
              g5.push(b6[S2][r5]);
            return g5;
          }, c5.prototype.clone = function(s, r5) {
            var g5 = new c5(), b6 = this._chunks, S2 = s && VC(s, function(k2, R6) {
              return k2[R6] = true, k2;
            }, {});
            if (S2)
              for (var A2 = 0; A2 < b6.length; A2++)
                g5._chunks[A2] = S2[A2] ? SNn(b6[A2]) : b6[A2];
            else
              g5._chunks = b6;
            return this._copyCommonProps(g5), r5 || (g5._indices = this._cloneIndices()), g5._updateGetRawIdx(), g5;
          }, c5.prototype._copyCommonProps = function(s) {
            s._count = this._count, s._rawCount = this._rawCount, s._provider = this._provider, s._dimensions = this._dimensions, s._extent = Ml(this._extent), s._rawExtent = Ml(this._rawExtent);
          }, c5.prototype._cloneIndices = function() {
            if (this._indices) {
              var s = this._indices.constructor, r5 = void 0;
              if (s === Array) {
                var g5 = this._indices.length;
                r5 = new s(g5);
                for (var b6 = 0; b6 < g5; b6++)
                  r5[b6] = this._indices[b6];
              } else
                r5 = new s(this._indices);
              return r5;
            }
            return null;
          }, c5.prototype._getRawIdxIdentity = function(s) {
            return s;
          }, c5.prototype._getRawIdx = function(s) {
            return s < this._count && s >= 0 ? this._indices[s] : -1;
          }, c5.prototype._updateGetRawIdx = function() {
            this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
          }, c5.internalField = function() {
            function s(r5, g5, b6, S2) {
              return X8(r5[S2], this._dimensions[S2]);
            }
            GWt = { arrayRows: s, objectRows: function(r5, g5, b6, S2) {
              return X8(r5[g5], this._dimensions[S2]);
            }, keyedColumns: s, original: function(r5, g5, b6, S2) {
              var A2 = r5 && (r5.value == null ? r5 : r5.value);
              return X8(A2 instanceof Array ? A2[S2] : A2, this._dimensions[S2]);
            }, typedArray: function(r5, g5, b6, S2) {
              return r5[S2];
            } };
          }(), c5;
        }(), XTe = function() {
          function c5(s) {
            this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = s;
          }
          return c5.prototype.dirty = function() {
            this._setLocalSource([], []), this._storeList = [], this._dirty = true;
          }, c5.prototype._setLocalSource = function(s, r5) {
            this._sourceList = s, this._upstreamSignList = r5, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
          }, c5.prototype._getVersionSign = function() {
            return this._sourceHost.uid + "_" + this._versionSignBase;
          }, c5.prototype.prepareSource = function() {
            this._isDirty() && (this._createSource(), this._dirty = false);
          }, c5.prototype._createSource = function() {
            this._setLocalSource([], []);
            var s = this._sourceHost, r5 = this._getUpstreamSourceManagers(), g5 = !!r5.length, b6, S2;
            if (aMt(s)) {
              var A2 = s, k2 = void 0, R6 = void 0, B3 = void 0;
              if (g5) {
                var G3 = r5[0];
                G3.prepareSource(), B3 = G3.getSource(), k2 = B3.data, R6 = B3.sourceFormat, S2 = [G3._getVersionSign()];
              } else
                k2 = A2.get("data", true), R6 = u2(k2) ? K8 : KI, S2 = [];
              var Z3 = this._getSourceMetaRawOption() || {}, X3 = B3 && B3.metaRawOption || {}, tt = tc2(Z3.seriesLayoutBy, X3.seriesLayoutBy) || null, it = tc2(Z3.sourceHeader, X3.sourceHeader), pt = tc2(Z3.dimensions, X3.dimensions), mt = tt !== X3.seriesLayoutBy || !!it != !!X3.sourceHeader || pt;
              b6 = mt ? [FWt(k2, { seriesLayoutBy: tt, sourceHeader: it, dimensions: pt }, R6)] : [];
            } else {
              var Mt = s;
              if (g5) {
                var kt = this._applyTransform(r5);
                b6 = kt.sourceList, S2 = kt.upstreamSignList;
              } else {
                var Gt = Mt.get("source", true);
                b6 = [FWt(Gt, this._getSourceMetaRawOption(), null)], S2 = [];
              }
            }
            this._setLocalSource(b6, S2);
          }, c5.prototype._applyTransform = function(s) {
            var r5 = this._sourceHost, g5 = r5.get("transform", true), b6 = r5.get("fromTransformResult", true);
            if (b6 != null) {
              var S2 = "";
              s.length !== 1 && JTe(S2);
            }
            var A2, k2 = [], R6 = [];
            return Ye2(s, function(B3) {
              B3.prepareSource();
              var G3 = B3.getSource(b6 || 0), Z3 = "";
              b6 != null && !G3 && JTe(Z3), k2.push(G3), R6.push(B3._getVersionSign());
            }), g5 ? A2 = bNn(g5, k2, { datasetIndex: r5.componentIndex }) : b6 != null && (A2 = [tNn(k2[0])]), { sourceList: A2, upstreamSignList: R6 };
          }, c5.prototype._isDirty = function() {
            if (this._dirty)
              return true;
            for (var s = this._getUpstreamSourceManagers(), r5 = 0; r5 < s.length; r5++) {
              var g5 = s[r5];
              if (g5._isDirty() || this._upstreamSignList[r5] !== g5._getVersionSign())
                return true;
            }
          }, c5.prototype.getSource = function(s) {
            s = s || 0;
            var r5 = this._sourceList[s];
            if (!r5) {
              var g5 = this._getUpstreamSourceManagers();
              return g5[0] && g5[0].getSource(s);
            }
            return r5;
          }, c5.prototype.getSharedDataStore = function(s) {
            var r5 = s.makeStoreSchema();
            return this._innerGetDataStore(r5.dimensions, s.source, r5.hash);
          }, c5.prototype._innerGetDataStore = function(s, r5, g5) {
            var b6 = 0, S2 = this._storeList, A2 = S2[b6];
            A2 || (A2 = S2[b6] = {});
            var k2 = A2[g5];
            if (!k2) {
              var R6 = this._getUpstreamSourceManagers()[0];
              aMt(this._sourceHost) && R6 ? k2 = R6._innerGetDataStore(s, r5, g5) : (k2 = new HWt(), k2.initData(new RTe(r5, s.length), s)), A2[g5] = k2;
            }
            return k2;
          }, c5.prototype._getUpstreamSourceManagers = function() {
            var s = this._sourceHost;
            if (aMt(s)) {
              var r5 = DWt(s);
              return r5 ? [r5.getSourceManager()] : [];
            } else
              return Ha2(T6n(s), function(g5) {
                return g5.getSourceManager();
              });
          }, c5.prototype._getSourceMetaRawOption = function() {
            var s = this._sourceHost, r5, g5, b6;
            if (aMt(s))
              r5 = s.get("seriesLayoutBy", true), g5 = s.get("sourceHeader", true), b6 = s.get("dimensions", true);
            else if (!this._getUpstreamSourceManagers().length) {
              var S2 = s;
              r5 = S2.get("seriesLayoutBy", true), g5 = S2.get("sourceHeader", true), b6 = S2.get("dimensions", true);
            }
            return { seriesLayoutBy: r5, sourceHeader: g5, dimensions: b6 };
          }, c5;
        }();
        function QTe(c5) {
          var s = c5.option.transform;
          s && DI(c5.option.transform);
        }
        function aMt(c5) {
          return c5.mainType === "series";
        }
        function JTe(c5) {
          throw new Error(c5);
        }
        var tAe = "line-height:1";
        function eAe(c5, s) {
          var r5 = c5.color || "#6e7079", g5 = c5.fontSize || 12, b6 = c5.fontWeight || "400", S2 = c5.color || "#464646", A2 = c5.fontSize || 14, k2 = c5.fontWeight || "900";
          return s === "html" ? { nameStyle: "font-size:" + rT(g5 + "") + "px;color:" + rT(r5) + ";font-weight:" + rT(b6 + ""), valueStyle: "font-size:" + rT(A2 + "") + "px;color:" + rT(S2) + ";font-weight:" + rT(k2 + "") } : { nameStyle: { fontSize: g5, fill: r5, fontWeight: b6 }, valueStyle: { fontSize: A2, fill: S2, fontWeight: k2 } };
        }
        var MNn = [0, 10, 20, 30], CNn = ["", `
`, `

`, `


`];
        function W1(c5, s) {
          return s.type = c5, s;
        }
        function UWt(c5) {
          return c5.type === "section";
        }
        function nAe(c5) {
          return UWt(c5) ? TNn : ANn;
        }
        function rAe(c5) {
          if (UWt(c5)) {
            var s = 0, r5 = c5.blocks.length, g5 = r5 > 1 || r5 > 0 && !c5.noHeader;
            return Ye2(c5.blocks, function(b6) {
              var S2 = rAe(b6);
              S2 >= s && (s = S2 + +(g5 && (!S2 || UWt(b6) && !b6.noHeader)));
            }), s;
          }
          return 0;
        }
        function TNn(c5, s, r5, g5) {
          var b6 = s.noHeader, S2 = INn(rAe(s)), A2 = [], k2 = s.blocks || [];
          lx(!k2 || ja2(k2)), k2 = k2 || [];
          var R6 = c5.orderMode;
          if (s.sortBlocks && R6) {
            k2 = k2.slice();
            var B3 = { valueAsc: "asc", valueDesc: "desc" };
            if (Ls(B3, R6)) {
              var G3 = new UTe(B3[R6], null);
              k2.sort(function(it, pt) {
                return G3.evaluate(it.sortParam, pt.sortParam);
              });
            } else
              R6 === "seriesDesc" && k2.reverse();
          }
          Ye2(k2, function(it, pt) {
            var mt = s.valueFormatter, Mt = nAe(it)(mt ? sa2(sa2({}, c5), { valueFormatter: mt }) : c5, it, pt > 0 ? S2.html : 0, g5);
            Mt != null && A2.push(Mt);
          });
          var Z3 = c5.renderMode === "richText" ? A2.join(S2.richText) : qWt(A2.join(""), b6 ? r5 : S2.html);
          if (b6)
            return Z3;
          var X3 = CWt(s.header, "ordinal", c5.useUTC), tt = eAe(g5, c5.renderMode).nameStyle;
          return c5.renderMode === "richText" ? aAe(c5, X3, tt) + S2.richText + Z3 : qWt('<div style="' + tt + ";" + tAe + ';">' + rT(X3) + "</div>" + Z3, r5);
        }
        function ANn(c5, s, r5, g5) {
          var b6 = c5.renderMode, S2 = s.noName, A2 = s.noValue, k2 = !s.markerType, R6 = s.name, B3 = c5.useUTC, G3 = s.valueFormatter || c5.valueFormatter || function(Ot) {
            return Ot = ja2(Ot) ? Ot : [Ot], Ha2(Ot, function(ce2, ae2) {
              return CWt(ce2, ja2(tt) ? tt[ae2] : tt, B3);
            });
          };
          if (!(S2 && A2)) {
            var Z3 = k2 ? "" : c5.markupStyleCreator.makeTooltipMarker(s.markerType, s.markerColor || "#333", b6), X3 = S2 ? "" : CWt(R6, "ordinal", B3), tt = s.valueType, it = A2 ? [] : G3(s.value), pt = !k2 || !S2, mt = !k2 && S2, Mt = eAe(g5, b6), kt = Mt.nameStyle, Gt = Mt.valueStyle;
            return b6 === "richText" ? (k2 ? "" : Z3) + (S2 ? "" : aAe(c5, X3, kt)) + (A2 ? "" : kNn(c5, it, pt, mt, Gt)) : qWt((k2 ? "" : Z3) + (S2 ? "" : DNn(X3, !k2, kt)) + (A2 ? "" : ENn(it, pt, mt, Gt)), r5);
          }
        }
        function iAe(c5, s, r5, g5, b6, S2) {
          if (c5) {
            var A2 = nAe(c5), k2 = { useUTC: b6, renderMode: r5, orderMode: g5, markupStyleCreator: s, valueFormatter: c5.valueFormatter };
            return A2(k2, c5, 0, S2);
          }
        }
        function INn(c5) {
          return { html: MNn[c5], richText: CNn[c5] };
        }
        function qWt(c5, s) {
          var r5 = '<div style="clear:both"></div>', g5 = "margin: " + s + "px 0 0";
          return '<div style="' + g5 + ";" + tAe + ';">' + c5 + r5 + "</div>";
        }
        function DNn(c5, s, r5) {
          var g5 = s ? "margin-left:2px" : "";
          return '<span style="' + r5 + ";" + g5 + '">' + rT(c5) + "</span>";
        }
        function ENn(c5, s, r5, g5) {
          var b6 = r5 ? "10px" : "20px", S2 = s ? "float:right;margin-left:" + b6 : "";
          return c5 = ja2(c5) ? c5 : [c5], '<span style="' + S2 + ";" + g5 + '">' + Ha2(c5, function(A2) {
            return rT(A2);
          }).join("&nbsp;&nbsp;") + "</span>";
        }
        function aAe(c5, s, r5) {
          return c5.markupStyleCreator.wrapRichTextStyle(s, r5);
        }
        function kNn(c5, s, r5, g5, b6) {
          var S2 = [b6], A2 = g5 ? 10 : 20;
          return r5 && S2.push({ padding: [0, 0, 0, A2], align: "right" }), c5.markupStyleCreator.wrapRichTextStyle(ja2(s) ? s.join("  ") : s, S2);
        }
        function oAe(c5, s) {
          var r5 = c5.getData().getItemVisual(s, "style"), g5 = r5[c5.visualDrawType];
          return oW(g5);
        }
        function sAe(c5, s) {
          var r5 = c5.get("padding");
          return r5 != null ? r5 : s === "richText" ? [8, 10] : 10;
        }
        var ZWt = function() {
          function c5() {
            this.richTextStyles = {}, this._nextStyleNameId = Zlt();
          }
          return c5.prototype._generateStyleName = function() {
            return "__EC_aUTo_" + this._nextStyleNameId++;
          }, c5.prototype.makeTooltipMarker = function(s, r5, g5) {
            var b6 = g5 === "richText" ? this._generateStyleName() : null, S2 = b6n({ color: r5, type: s, renderMode: g5, markerId: b6 });
            return gs(S2) ? S2 : (this.richTextStyles[b6] = S2.style, S2.content);
          }, c5.prototype.wrapRichTextStyle = function(s, r5) {
            var g5 = {};
            ja2(r5) ? Ye2(r5, function(S2) {
              return sa2(g5, S2);
            }) : sa2(g5, r5);
            var b6 = this._generateStyleName();
            return this.richTextStyles[b6] = g5, "{" + b6 + "|" + s + "}";
          }, c5;
        }();
        function lAe(c5) {
          var s = c5.series, r5 = c5.dataIndex, g5 = c5.multipleSeries, b6 = s.getData(), S2 = b6.mapDimensionsAll("defaultedTooltip"), A2 = S2.length, k2 = s.getRawValue(r5), R6 = ja2(k2), B3 = oAe(s, r5), G3, Z3, X3, tt;
          if (A2 > 1 || R6 && !A2) {
            var it = PNn(k2, s, r5, S2, B3);
            G3 = it.inlineValues, Z3 = it.inlineValueTypes, X3 = it.blocks, tt = it.inlineValues[0];
          } else if (A2) {
            var pt = b6.getDimensionInfo(S2[0]);
            tt = G3 = cX(b6, r5, S2[0]), Z3 = pt.type;
          } else
            tt = G3 = R6 ? k2[0] : k2;
          var mt = Xlt(s), Mt = mt && s.name || "", kt = b6.getName(r5), Gt = g5 ? Mt : kt;
          return W1("section", { header: Mt, noHeader: g5 || !mt, sortParam: tt, blocks: [W1("nameValue", { markerType: "item", markerColor: B3, name: Gt, noName: !Tg2(Gt), value: G3, valueType: Z3 })].concat(X3 || []) });
        }
        function PNn(c5, s, r5, g5, b6) {
          var S2 = s.getData(), A2 = VC(c5, function(Z3, X3, tt) {
            var it = S2.getDimensionInfo(tt);
            return Z3 = Z3 || it && it.tooltip !== false && it.displayName != null;
          }, false), k2 = [], R6 = [], B3 = [];
          g5.length ? Ye2(g5, function(Z3) {
            G3(cX(S2, r5, Z3), Z3);
          }) : Ye2(c5, G3);
          function G3(Z3, X3) {
            var tt = S2.getDimensionInfo(X3);
            !tt || tt.otherDims.tooltip === false || (A2 ? B3.push(W1("nameValue", { markerType: "subItem", markerColor: b6, name: tt.displayName, value: Z3, valueType: tt.type })) : (k2.push(Z3), R6.push(tt.type)));
          }
          return { inlineValues: k2, inlineValueTypes: R6, blocks: B3 };
        }
        var Q8 = Df2();
        function oMt(c5, s) {
          return c5.getName(s) || c5.getId(s);
        }
        var sMt = "__universalTransitionEnabled", lMt = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5._selectedDataIndicesMap = {}, r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            this.seriesIndex = this.componentIndex, this.dataTask = cct({ count: ONn, reset: RNn }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(r5, b6);
            var S2 = Q8(this).sourceManager = new XTe(this);
            S2.prepareSource();
            var A2 = this.getInitialData(r5, b6);
            cAe(A2, this), this.dataTask.context.data = A2, Q8(this).dataBeforeProcessed = A2, uAe(this), this._initSelectedMapFromData(A2);
          }, s.prototype.mergeDefaultAndTheme = function(r5, g5) {
            var b6 = ict(this), S2 = b6 ? oX(r5) : {}, A2 = this.subType;
            Rh2.hasClass(A2) && (A2 += "Series"), bu(r5, g5.getTheme().get(this.subType)), bu(r5, this.getDefaultOption()), wM(r5, "label", ["show"]), this.fillDataTextStyle(r5.data), b6 && Y8(r5, S2, b6);
          }, s.prototype.mergeOption = function(r5, g5) {
            r5 = bu(this.option, r5, true), this.fillDataTextStyle(r5.data);
            var b6 = ict(this);
            b6 && Y8(this.option, r5, b6);
            var S2 = Q8(this).sourceManager;
            S2.dirty(), S2.prepareSource();
            var A2 = this.getInitialData(r5, g5);
            cAe(A2, this), this.dataTask.dirty(), this.dataTask.context.data = A2, Q8(this).dataBeforeProcessed = A2, uAe(this), this._initSelectedMapFromData(A2);
          }, s.prototype.fillDataTextStyle = function(r5) {
            if (r5 && !u2(r5))
              for (var g5 = ["show"], b6 = 0; b6 < r5.length; b6++)
                r5[b6] && r5[b6].label && wM(r5[b6], "label", g5);
          }, s.prototype.getInitialData = function(r5, g5) {
          }, s.prototype.appendData = function(r5) {
            var g5 = this.getRawData();
            g5.appendData(r5.data);
          }, s.prototype.getData = function(r5) {
            var g5 = $Wt(this);
            if (g5) {
              var b6 = g5.context.data;
              return r5 == null ? b6 : b6.getLinkedData(r5);
            } else
              return Q8(this).data;
          }, s.prototype.getAllData = function() {
            var r5 = this.getData();
            return r5 && r5.getLinkedDataAll ? r5.getLinkedDataAll() : [{ data: r5 }];
          }, s.prototype.setData = function(r5) {
            var g5 = $Wt(this);
            if (g5) {
              var b6 = g5.context;
              b6.outputData = r5, g5 !== this.dataTask && (b6.data = r5);
            }
            Q8(this).data = r5;
          }, s.prototype.getEncode = function() {
            var r5 = this.get("encode", true);
            if (r5)
              return Ps(r5);
          }, s.prototype.getSourceManager = function() {
            return Q8(this).sourceManager;
          }, s.prototype.getSource = function() {
            return this.getSourceManager().getSource();
          }, s.prototype.getRawData = function() {
            return Q8(this).dataBeforeProcessed;
          }, s.prototype.getColorBy = function() {
            var r5 = this.get("colorBy");
            return r5 || "series";
          }, s.prototype.isColorBySeries = function() {
            return this.getColorBy() === "series";
          }, s.prototype.getBaseAxis = function() {
            var r5 = this.coordinateSystem;
            return r5 && r5.getBaseAxis && r5.getBaseAxis();
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            return lAe({ series: this, dataIndex: r5, multipleSeries: g5 });
          }, s.prototype.isAnimationEnabled = function() {
            var r5 = this.ecModel;
            if (os.node && !(r5 && r5.ssr))
              return false;
            var g5 = this.getShallow("animation");
            return g5 && this.getData().count() > this.getShallow("animationThreshold") && (g5 = false), !!g5;
          }, s.prototype.restoreData = function() {
            this.dataTask.dirty();
          }, s.prototype.getColorFromPalette = function(r5, g5, b6) {
            var S2 = this.ecModel, A2 = kWt.prototype.getColorFromPalette.call(this, r5, g5, b6);
            return A2 || (A2 = S2.getColorFromPalette(r5, g5, b6)), A2;
          }, s.prototype.coordDimToDataDim = function(r5) {
            return this.getRawData().mapDimensionsAll(r5);
          }, s.prototype.getProgressive = function() {
            return this.get("progressive");
          }, s.prototype.getProgressiveThreshold = function() {
            return this.get("progressiveThreshold");
          }, s.prototype.select = function(r5, g5) {
            this._innerSelect(this.getData(g5), r5);
          }, s.prototype.unselect = function(r5, g5) {
            var b6 = this.option.selectedMap;
            if (b6) {
              var S2 = this.option.selectedMode, A2 = this.getData(g5);
              if (S2 === "series" || b6 === "all") {
                this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
                return;
              }
              for (var k2 = 0; k2 < r5.length; k2++) {
                var R6 = r5[k2], B3 = oMt(A2, R6);
                b6[B3] = false, this._selectedDataIndicesMap[B3] = -1;
              }
            }
          }, s.prototype.toggleSelect = function(r5, g5) {
            for (var b6 = [], S2 = 0; S2 < r5.length; S2++)
              b6[0] = r5[S2], this.isSelected(r5[S2], g5) ? this.unselect(b6, g5) : this.select(b6, g5);
          }, s.prototype.getSelectedDataIndices = function() {
            if (this.option.selectedMap === "all")
              return [].slice.call(this.getData().getIndices());
            for (var r5 = this._selectedDataIndicesMap, g5 = nf2(r5), b6 = [], S2 = 0; S2 < g5.length; S2++) {
              var A2 = r5[g5[S2]];
              A2 >= 0 && b6.push(A2);
            }
            return b6;
          }, s.prototype.isSelected = function(r5, g5) {
            var b6 = this.option.selectedMap;
            if (!b6)
              return false;
            var S2 = this.getData(g5);
            return (b6 === "all" || b6[oMt(S2, r5)]) && !S2.getItemModel(r5).get(["select", "disabled"]);
          }, s.prototype.isUniversalTransitionEnabled = function() {
            if (this[sMt])
              return true;
            var r5 = this.option.universalTransition;
            return r5 ? r5 === true ? true : r5 && r5.enabled : false;
          }, s.prototype._innerSelect = function(r5, g5) {
            var b6, S2, A2 = this.option, k2 = A2.selectedMode, R6 = g5.length;
            if (!(!k2 || !R6)) {
              if (k2 === "series")
                A2.selectedMap = "all";
              else if (k2 === "multiple") {
                Wl(A2.selectedMap) || (A2.selectedMap = {});
                for (var B3 = A2.selectedMap, G3 = 0; G3 < R6; G3++) {
                  var Z3 = g5[G3], X3 = oMt(r5, Z3);
                  B3[X3] = true, this._selectedDataIndicesMap[X3] = r5.getRawIndex(Z3);
                }
              } else if (k2 === "single" || k2 === true) {
                var tt = g5[R6 - 1], X3 = oMt(r5, tt);
                A2.selectedMap = (b6 = {}, b6[X3] = true, b6), this._selectedDataIndicesMap = (S2 = {}, S2[X3] = r5.getRawIndex(tt), S2);
              }
            }
          }, s.prototype._initSelectedMapFromData = function(r5) {
            if (!this.option.selectedMap) {
              var g5 = [];
              r5.hasItemOption && r5.each(function(b6) {
                var S2 = r5.getRawDataItem(b6);
                S2 && S2.selected && g5.push(b6);
              }), g5.length > 0 && this._innerSelect(r5, g5);
            }
          }, s.registerClass = function(r5) {
            return Rh2.registerClass(r5);
          }, s.protoInitialize = function() {
            var r5 = s.prototype;
            r5.type = "series.__base__", r5.seriesIndex = 0, r5.ignoreStyleOnData = false, r5.hasSymbolVisual = false, r5.defaultSymbol = "circle", r5.visualStyleAccessPath = "itemStyle", r5.visualDrawType = "fill";
          }(), s;
        }(Rh2);
        A0(lMt, jWt), A0(lMt, kWt), nut(lMt, Rh2);
        function uAe(c5) {
          var s = c5.name;
          Xlt(c5) || (c5.name = LNn(c5) || s);
        }
        function LNn(c5) {
          var s = c5.getRawData(), r5 = s.mapDimensionsAll("seriesName"), g5 = [];
          return Ye2(r5, function(b6) {
            var S2 = s.getDimensionInfo(b6);
            S2.displayName && g5.push(S2.displayName);
          }), g5.join(" ");
        }
        function ONn(c5) {
          return c5.model.getRawData().count();
        }
        function RNn(c5) {
          var s = c5.model;
          return s.setData(s.getRawData().cloneShallow()), NNn;
        }
        function NNn(c5, s) {
          s.outputData && c5.end > s.outputData.count() && s.model.getRawData().cloneShallow(s.outputData);
        }
        function cAe(c5, s) {
          Ye2(zY(c5.CHANGABLE_METHODS, c5.DOWNSAMPLE_METHODS), function(r5) {
            c5.wrapMethod(r5, Au(FNn, s));
          });
        }
        function FNn(c5, s) {
          var r5 = $Wt(c5);
          return r5 && r5.setOutputEnd((s || this).count()), s;
        }
        function $Wt(c5) {
          var s = (c5.ecModel || {}).scheduler, r5 = s && s.getPipeline(c5.uid);
          if (r5) {
            var g5 = r5.currentTask;
            if (g5) {
              var b6 = g5.agentStubMap;
              b6 && (g5 = b6.get(c5.uid));
            }
            return g5;
          }
        }
        var zv = lMt, YWt = function() {
          function c5() {
            this.group = new nu(), this.uid = nX("viewComponent");
          }
          return c5.prototype.init = function(s, r5) {
          }, c5.prototype.render = function(s, r5, g5, b6) {
          }, c5.prototype.dispose = function(s, r5) {
          }, c5.prototype.updateView = function(s, r5, g5, b6) {
          }, c5.prototype.updateLayout = function(s, r5, g5, b6) {
          }, c5.prototype.updateVisual = function(s, r5, g5, b6) {
          }, c5.prototype.blurSeries = function(s, r5) {
          }, c5.prototype.eachRendered = function(s) {
            var r5 = this.group;
            r5 && r5.traverse(s);
          }, c5;
        }();
        MK(YWt), TK(YWt);
        var P0 = YWt;
        function hX() {
          var c5 = Df2();
          return function(s) {
            var r5 = c5(s), g5 = s.pipelineContext, b6 = !!r5.large, S2 = !!r5.progressiveRender, A2 = r5.large = !!(g5 && g5.large), k2 = r5.progressiveRender = !!(g5 && g5.progressiveRender);
            return (b6 !== A2 || S2 !== k2) && "reset";
          };
        }
        var fAe = Df2(), VNn = hX(), KWt = function() {
          function c5() {
            this.group = new nu(), this.uid = nX("viewChart"), this.renderTask = cct({ plan: BNn, reset: zNn }), this.renderTask.context = { view: this };
          }
          return c5.prototype.init = function(s, r5) {
          }, c5.prototype.render = function(s, r5, g5, b6) {
          }, c5.prototype.highlight = function(s, r5, g5, b6) {
            var S2 = s.getData(b6 && b6.dataType);
            !S2 || pAe(S2, b6, "emphasis");
          }, c5.prototype.downplay = function(s, r5, g5, b6) {
            var S2 = s.getData(b6 && b6.dataType);
            !S2 || pAe(S2, b6, "normal");
          }, c5.prototype.remove = function(s, r5) {
            this.group.removeAll();
          }, c5.prototype.dispose = function(s, r5) {
          }, c5.prototype.updateView = function(s, r5, g5, b6) {
            this.render(s, r5, g5, b6);
          }, c5.prototype.updateLayout = function(s, r5, g5, b6) {
            this.render(s, r5, g5, b6);
          }, c5.prototype.updateVisual = function(s, r5, g5, b6) {
            this.render(s, r5, g5, b6);
          }, c5.prototype.eachRendered = function(s) {
            Ik(this.group, s);
          }, c5.markUpdateMethod = function(s, r5) {
            fAe(s).updateMethod = r5;
          }, c5.protoInitialize = function() {
            var s = c5.prototype;
            s.type = "chart";
          }(), c5;
        }();
        function hAe(c5, s, r5) {
          c5 && Xj2(c5) && (s === "emphasis" ? GI : HI)(c5, r5);
        }
        function pAe(c5, s, r5) {
          var g5 = nR(c5, s), b6 = s && s.highlightKey != null ? Rut(s.highlightKey) : null;
          g5 != null ? Ye2(xp(g5), function(S2) {
            hAe(c5.getItemGraphicEl(S2), r5, b6);
          }) : c5.eachItemGraphicEl(function(S2) {
            hAe(S2, r5, b6);
          });
        }
        MK(KWt), TK(KWt);
        function BNn(c5) {
          return VNn(c5.model);
        }
        function zNn(c5) {
          var s = c5.model, r5 = c5.ecModel, g5 = c5.api, b6 = c5.payload, S2 = s.pipelineContext.progressiveRender, A2 = c5.view, k2 = b6 && fAe(b6).updateMethod, R6 = S2 ? "incrementalPrepareRender" : k2 && A2[k2] ? k2 : "render";
          return R6 !== "render" && A2[R6](s, r5, g5, b6), jNn[R6];
        }
        var jNn = { incrementalPrepareRender: { progress: function(c5, s) {
          s.view.incrementalRender(c5, s.model, s.ecModel, s.api, s.payload);
        } }, render: { forceFirstProgress: true, progress: function(c5, s) {
          s.view.render(s.model, s.ecModel, s.api, s.payload);
        } } }, Ig2 = KWt, uMt = "\0__throttleOriginMethod", dAe = "\0__throttleRate", gAe = "\0__throttleType";
        function XWt(c5, s, r5) {
          var g5, b6 = 0, S2 = 0, A2 = null, k2, R6, B3, G3;
          s = s || 0;
          function Z3() {
            S2 = new Date().getTime(), A2 = null, c5.apply(R6, B3 || []);
          }
          var X3 = function() {
            for (var tt = [], it = 0; it < arguments.length; it++)
              tt[it] = arguments[it];
            g5 = new Date().getTime(), R6 = this, B3 = tt;
            var pt = G3 || s, mt = G3 || r5;
            G3 = null, k2 = g5 - (mt ? b6 : S2) - pt, clearTimeout(A2), mt ? A2 = setTimeout(Z3, pt) : k2 >= 0 ? Z3() : A2 = setTimeout(Z3, -k2), b6 = g5;
          };
          return X3.clear = function() {
            A2 && (clearTimeout(A2), A2 = null);
          }, X3.debounceNextCall = function(tt) {
            G3 = tt;
          }, X3;
        }
        function pX(c5, s, r5, g5) {
          var b6 = c5[s];
          if (b6) {
            var S2 = b6[uMt] || b6, A2 = b6[gAe], k2 = b6[dAe];
            if (k2 !== r5 || A2 !== g5) {
              if (r5 == null || !g5)
                return c5[s] = S2;
              b6 = c5[s] = XWt(S2, r5, g5 === "debounce"), b6[uMt] = S2, b6[gAe] = g5, b6[dAe] = r5;
            }
            return b6;
          }
        }
        function hct(c5, s) {
          var r5 = c5[s];
          r5 && r5[uMt] && (r5.clear && r5.clear(), c5[s] = r5[uMt]);
        }
        var vAe = Df2(), yAe = { itemStyle: aR(BCe, true), lineStyle: aR(VCe, true) }, WNn = { lineStyle: "stroke", itemStyle: "fill" };
        function mAe(c5, s) {
          var r5 = c5.visualStyleMapper || yAe[s];
          return r5 || (console.warn("Unkown style type '" + s + "'."), yAe.itemStyle);
        }
        function bAe(c5, s) {
          var r5 = c5.visualDrawType || WNn[s];
          return r5 || (console.warn("Unkown style type '" + s + "'."), "fill");
        }
        var GNn = { createOnAllSeries: true, performRawSeries: true, reset: function(c5, s) {
          var r5 = c5.getData(), g5 = c5.visualStyleAccessPath || "itemStyle", b6 = c5.getModel(g5), S2 = mAe(c5, g5), A2 = S2(b6), k2 = b6.getShallow("decal");
          k2 && (r5.setVisual("decal", k2), k2.dirty = true);
          var R6 = bAe(c5, g5), B3 = A2[R6], G3 = Tl(B3) ? B3 : null, Z3 = A2.fill === "auto" || A2.stroke === "auto";
          if (!A2[R6] || G3 || Z3) {
            var X3 = c5.getColorFromPalette(c5.name, null, s.getSeriesCount());
            A2[R6] || (A2[R6] = X3, r5.setVisual("colorFromPalette", true)), A2.fill = A2.fill === "auto" || Tl(A2.fill) ? X3 : A2.fill, A2.stroke = A2.stroke === "auto" || Tl(A2.stroke) ? X3 : A2.stroke;
          }
          if (r5.setVisual("style", A2), r5.setVisual("drawType", R6), !s.isSeriesFiltered(c5) && G3)
            return r5.setVisual("colorFromPalette", false), { dataEach: function(tt, it) {
              var pt = c5.getDataParams(it), mt = sa2({}, A2);
              mt[R6] = G3(pt), tt.setItemVisual(it, "style", mt);
            } };
        } }, pct = new Ag2(), HNn = { createOnAllSeries: true, performRawSeries: true, reset: function(c5, s) {
          if (!(c5.ignoreStyleOnData || s.isSeriesFiltered(c5))) {
            var r5 = c5.getData(), g5 = c5.visualStyleAccessPath || "itemStyle", b6 = mAe(c5, g5), S2 = r5.getVisual("drawType");
            return { dataEach: r5.hasItemOption ? function(A2, k2) {
              var R6 = A2.getRawDataItem(k2);
              if (R6 && R6[g5]) {
                pct.option = R6[g5];
                var B3 = b6(pct), G3 = A2.ensureUniqueItemVisual(k2, "style");
                sa2(G3, B3), pct.option.decal && (A2.setItemVisual(k2, "decal", pct.option.decal), pct.option.decal.dirty = true), S2 in B3 && A2.setItemVisual(k2, "colorFromPalette", false);
              }
            } : null };
          }
        } }, UNn = { performRawSeries: true, overallReset: function(c5) {
          var s = Ps();
          c5.eachSeries(function(r5) {
            var g5 = r5.getColorBy();
            if (!r5.isColorBySeries()) {
              var b6 = r5.type + "-" + g5, S2 = s.get(b6);
              S2 || (S2 = {}, s.set(b6, S2)), vAe(r5).scope = S2;
            }
          }), c5.eachSeries(function(r5) {
            if (!(r5.isColorBySeries() || c5.isSeriesFiltered(r5))) {
              var g5 = r5.getRawData(), b6 = {}, S2 = r5.getData(), A2 = vAe(r5).scope, k2 = r5.visualStyleAccessPath || "itemStyle", R6 = bAe(r5, k2);
              S2.each(function(B3) {
                var G3 = S2.getRawIndex(B3);
                b6[G3] = B3;
              }), g5.each(function(B3) {
                var G3 = b6[B3], Z3 = S2.getItemVisual(G3, "colorFromPalette");
                if (Z3) {
                  var X3 = S2.ensureUniqueItemVisual(G3, "style"), tt = g5.getName(B3) || B3 + "", it = g5.count();
                  X3[R6] = r5.getColorFromPalette(tt, A2, it);
                }
              });
            }
          });
        } }, cMt = Math.PI;
        function qNn(c5, s) {
          s = s || {}, Cl(s, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
          var r5 = new nu(), g5 = new zf2({ style: { fill: s.maskColor }, zlevel: s.zlevel, z: 1e4 });
          r5.add(g5);
          var b6 = new hh2({ style: { text: s.text, fill: s.textColor, fontSize: s.fontSize, fontWeight: s.fontWeight, fontStyle: s.fontStyle, fontFamily: s.fontFamily }, zlevel: s.zlevel, z: 10001 }), S2 = new zf2({ style: { fill: "none" }, textContent: b6, textConfig: { position: "right", distance: 10 }, zlevel: s.zlevel, z: 10001 });
          r5.add(S2);
          var A2;
          return s.showSpinner && (A2 = new Uut({ shape: { startAngle: -cMt / 2, endAngle: -cMt / 2 + 0.1, r: s.spinnerRadius }, style: { stroke: s.color, lineCap: "round", lineWidth: s.lineWidth }, zlevel: s.zlevel, z: 10001 }), A2.animateShape(true).when(1e3, { endAngle: cMt * 3 / 2 }).start("circularInOut"), A2.animateShape(true).when(1e3, { startAngle: cMt * 3 / 2 }).delay(300).start("circularInOut"), r5.add(A2)), r5.resize = function() {
            var k2 = b6.getBoundingRect().width, R6 = s.showSpinner ? s.spinnerRadius : 0, B3 = (c5.getWidth() - R6 * 2 - (s.showSpinner && k2 ? 10 : 0) - k2) / 2 - (s.showSpinner && k2 ? 0 : 5 + k2 / 2) + (s.showSpinner ? 0 : k2 / 2) + (k2 ? 0 : R6), G3 = c5.getHeight() / 2;
            s.showSpinner && A2.setShape({ cx: B3, cy: G3 }), S2.setShape({ x: B3 - R6, y: G3 - R6, width: R6 * 2, height: R6 * 2 }), g5.setShape({ x: 0, y: 0, width: c5.getWidth(), height: c5.getHeight() });
          }, r5.resize(), r5;
        }
        var ZNn = function() {
          function c5(s, r5, g5, b6) {
            this._stageTaskMap = Ps(), this.ecInstance = s, this.api = r5, g5 = this._dataProcessorHandlers = g5.slice(), b6 = this._visualHandlers = b6.slice(), this._allHandlers = g5.concat(b6);
          }
          return c5.prototype.restoreData = function(s, r5) {
            s.restoreData(r5), this._stageTaskMap.each(function(g5) {
              var b6 = g5.overallTask;
              b6 && b6.dirty();
            });
          }, c5.prototype.getPerformArgs = function(s, r5) {
            if (s.__pipeline) {
              var g5 = this._pipelineMap.get(s.__pipeline.id), b6 = g5.context, S2 = !r5 && g5.progressiveEnabled && (!b6 || b6.progressiveRender) && s.__idxInPipeline > g5.blockIndex, A2 = S2 ? g5.step : null, k2 = b6 && b6.modDataCount, R6 = k2 != null ? Math.ceil(k2 / A2) : null;
              return { step: A2, modBy: R6, modDataCount: k2 };
            }
          }, c5.prototype.getPipeline = function(s) {
            return this._pipelineMap.get(s);
          }, c5.prototype.updateStreamModes = function(s, r5) {
            var g5 = this._pipelineMap.get(s.uid), b6 = s.getData(), S2 = b6.count(), A2 = g5.progressiveEnabled && r5.incrementalPrepareRender && S2 >= g5.threshold, k2 = s.get("large") && S2 >= s.get("largeThreshold"), R6 = s.get("progressiveChunkMode") === "mod" ? S2 : null;
            s.pipelineContext = g5.context = { progressiveRender: A2, modDataCount: R6, large: k2 };
          }, c5.prototype.restorePipelines = function(s) {
            var r5 = this, g5 = r5._pipelineMap = Ps();
            s.eachSeries(function(b6) {
              var S2 = b6.getProgressive(), A2 = b6.uid;
              g5.set(A2, { id: A2, head: null, tail: null, threshold: b6.getProgressiveThreshold(), progressiveEnabled: S2 && !(b6.preventIncremental && b6.preventIncremental()), blockIndex: -1, step: Math.round(S2 || 700), count: 0 }), r5._pipe(b6, b6.dataTask);
            });
          }, c5.prototype.prepareStageTasks = function() {
            var s = this._stageTaskMap, r5 = this.api.getModel(), g5 = this.api;
            Ye2(this._allHandlers, function(b6) {
              var S2 = s.get(b6.uid) || s.set(b6.uid, {}), A2 = "";
              lx(!(b6.reset && b6.overallReset), A2), b6.reset && this._createSeriesStageTask(b6, S2, r5, g5), b6.overallReset && this._createOverallStageTask(b6, S2, r5, g5);
            }, this);
          }, c5.prototype.prepareView = function(s, r5, g5, b6) {
            var S2 = s.renderTask, A2 = S2.context;
            A2.model = r5, A2.ecModel = g5, A2.api = b6, S2.__block = !s.incrementalPrepareRender, this._pipe(r5, S2);
          }, c5.prototype.performDataProcessorTasks = function(s, r5) {
            this._performStageTasks(this._dataProcessorHandlers, s, r5, { block: true });
          }, c5.prototype.performVisualTasks = function(s, r5, g5) {
            this._performStageTasks(this._visualHandlers, s, r5, g5);
          }, c5.prototype._performStageTasks = function(s, r5, g5, b6) {
            b6 = b6 || {};
            var S2 = false, A2 = this;
            Ye2(s, function(R6, B3) {
              if (!(b6.visualType && b6.visualType !== R6.visualType)) {
                var G3 = A2._stageTaskMap.get(R6.uid), Z3 = G3.seriesTaskMap, X3 = G3.overallTask;
                if (X3) {
                  var tt, it = X3.agentStubMap;
                  it.each(function(mt) {
                    k2(b6, mt) && (mt.dirty(), tt = true);
                  }), tt && X3.dirty(), A2.updatePayload(X3, g5);
                  var pt = A2.getPerformArgs(X3, b6.block);
                  it.each(function(mt) {
                    mt.perform(pt);
                  }), X3.perform(pt) && (S2 = true);
                } else
                  Z3 && Z3.each(function(mt, Mt) {
                    k2(b6, mt) && mt.dirty();
                    var kt = A2.getPerformArgs(mt, b6.block);
                    kt.skip = !R6.performRawSeries && r5.isSeriesFiltered(mt.context.model), A2.updatePayload(mt, g5), mt.perform(kt) && (S2 = true);
                  });
              }
            });
            function k2(R6, B3) {
              return R6.setDirty && (!R6.dirtyMap || R6.dirtyMap.get(B3.__pipeline.id));
            }
            this.unfinished = S2 || this.unfinished;
          }, c5.prototype.performSeriesTasks = function(s) {
            var r5;
            s.eachSeries(function(g5) {
              r5 = g5.dataTask.perform() || r5;
            }), this.unfinished = r5 || this.unfinished;
          }, c5.prototype.plan = function() {
            this._pipelineMap.each(function(s) {
              var r5 = s.tail;
              do {
                if (r5.__block) {
                  s.blockIndex = r5.__idxInPipeline;
                  break;
                }
                r5 = r5.getUpstream();
              } while (r5);
            });
          }, c5.prototype.updatePayload = function(s, r5) {
            r5 !== "remain" && (s.context.payload = r5);
          }, c5.prototype._createSeriesStageTask = function(s, r5, g5, b6) {
            var S2 = this, A2 = r5.seriesTaskMap, k2 = r5.seriesTaskMap = Ps(), R6 = s.seriesType, B3 = s.getTargetSeries;
            s.createOnAllSeries ? g5.eachRawSeries(G3) : R6 ? g5.eachRawSeriesByType(R6, G3) : B3 && B3(g5, b6).each(G3);
            function G3(Z3) {
              var X3 = Z3.uid, tt = k2.set(X3, A2 && A2.get(X3) || cct({ plan: QNn, reset: JNn, count: eFn }));
              tt.context = { model: Z3, ecModel: g5, api: b6, useClearVisual: s.isVisual && !s.isLayout, plan: s.plan, reset: s.reset, scheduler: S2 }, S2._pipe(Z3, tt);
            }
          }, c5.prototype._createOverallStageTask = function(s, r5, g5, b6) {
            var S2 = this, A2 = r5.overallTask = r5.overallTask || cct({ reset: $Nn });
            A2.context = { ecModel: g5, api: b6, overallReset: s.overallReset, scheduler: S2 };
            var k2 = A2.agentStubMap, R6 = A2.agentStubMap = Ps(), B3 = s.seriesType, G3 = s.getTargetSeries, Z3 = true, X3 = false, tt = "";
            lx(!s.createOnAllSeries, tt), B3 ? g5.eachRawSeriesByType(B3, it) : G3 ? G3(g5, b6).each(it) : (Z3 = false, Ye2(g5.getSeries(), it));
            function it(pt) {
              var mt = pt.uid, Mt = R6.set(mt, k2 && k2.get(mt) || (X3 = true, cct({ reset: YNn, onDirty: XNn })));
              Mt.context = { model: pt, overallProgress: Z3 }, Mt.agent = A2, Mt.__block = Z3, S2._pipe(pt, Mt);
            }
            X3 && A2.dirty();
          }, c5.prototype._pipe = function(s, r5) {
            var g5 = s.uid, b6 = this._pipelineMap.get(g5);
            !b6.head && (b6.head = r5), b6.tail && b6.tail.pipe(r5), b6.tail = r5, r5.__idxInPipeline = b6.count++, r5.__pipeline = b6;
          }, c5.wrapStageHandler = function(s, r5) {
            return Tl(s) && (s = { overallReset: s, seriesType: nFn(s) }), s.uid = nX("stageHandler"), r5 && (s.visualType = r5), s;
          }, c5;
        }();
        function $Nn(c5) {
          c5.overallReset(c5.ecModel, c5.api, c5.payload);
        }
        function YNn(c5) {
          return c5.overallProgress && KNn;
        }
        function KNn() {
          this.agent.dirty(), this.getDownstream().dirty();
        }
        function XNn() {
          this.agent && this.agent.dirty();
        }
        function QNn(c5) {
          return c5.plan ? c5.plan(c5.model, c5.ecModel, c5.api, c5.payload) : null;
        }
        function JNn(c5) {
          c5.useClearVisual && c5.data.clearAllVisual();
          var s = c5.resetDefines = xp(c5.reset(c5.model, c5.ecModel, c5.api, c5.payload));
          return s.length > 1 ? Ha2(s, function(r5, g5) {
            return _Ae(g5);
          }) : tFn;
        }
        var tFn = _Ae(0);
        function _Ae(c5) {
          return function(s, r5) {
            var g5 = r5.data, b6 = r5.resetDefines[c5];
            if (b6 && b6.dataEach)
              for (var S2 = s.start; S2 < s.end; S2++)
                b6.dataEach(g5, S2);
            else
              b6 && b6.progress && b6.progress(s, g5);
          };
        }
        function eFn(c5) {
          return c5.data.count();
        }
        function nFn(c5) {
          fMt = null;
          try {
            c5(dct, xAe);
          } catch {
          }
          return fMt;
        }
        var dct = {}, xAe = {}, fMt;
        wAe(dct, _Te), wAe(xAe, xTe), dct.eachSeriesByType = dct.eachRawSeriesByType = function(c5) {
          fMt = c5;
        }, dct.eachComponent = function(c5) {
          c5.mainType === "series" && c5.subType && (fMt = c5.subType);
        };
        function wAe(c5, s) {
          for (var r5 in s.prototype)
            c5[r5] = I0;
        }
        var SAe = ZNn, MAe = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], rFn = { color: MAe, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], MAe] }, y22 = "#B9B8CE", CAe = "#100C2A", hMt = function() {
          return { axisLine: { lineStyle: { color: y22 } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
        }, TAe = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], AAe = { darkMode: true, color: TAe, backgroundColor: CAe, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: y22 } }, textStyle: { color: y22 }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: y22 } }, dataZoom: { borderColor: "#71708A", textStyle: { color: y22 }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: y22 } }, timeline: { lineStyle: { color: y22 }, label: { color: y22 }, controlStyle: { color: y22, borderColor: y22 } }, calendar: { itemStyle: { color: CAe }, dayLabel: { color: y22 }, monthLabel: { color: y22 }, yearLabel: { color: y22 } }, timeAxis: hMt(), logAxis: hMt(), valueAxis: hMt(), categoryAxis: hMt(), line: { symbol: "circle" }, graph: { color: TAe }, gauge: { title: { color: y22 }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: y22 }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
        AAe.categoryAxis.splitLine.show = false;
        var iFn = AAe, aFn = function() {
          function c5() {
          }
          return c5.prototype.normalizeQuery = function(s) {
            var r5 = {}, g5 = {}, b6 = {};
            if (gs(s)) {
              var S2 = Vw(s);
              r5.mainType = S2.main || null, r5.subType = S2.sub || null;
            } else {
              var A2 = ["Index", "Name", "Id"], k2 = { name: 1, dataIndex: 1, dataType: 1 };
              Ye2(s, function(R6, B3) {
                for (var G3 = false, Z3 = 0; Z3 < A2.length; Z3++) {
                  var X3 = A2[Z3], tt = B3.lastIndexOf(X3);
                  if (tt > 0 && tt === B3.length - X3.length) {
                    var it = B3.slice(0, tt);
                    it !== "data" && (r5.mainType = it, r5[X3.toLowerCase()] = R6, G3 = true);
                  }
                }
                k2.hasOwnProperty(B3) && (g5[B3] = R6, G3 = true), G3 || (b6[B3] = R6);
              });
            }
            return { cptQuery: r5, dataQuery: g5, otherQuery: b6 };
          }, c5.prototype.filter = function(s, r5) {
            var g5 = this.eventInfo;
            if (!g5)
              return true;
            var b6 = g5.targetEl, S2 = g5.packedEvent, A2 = g5.model, k2 = g5.view;
            if (!A2 || !k2)
              return true;
            var R6 = r5.cptQuery, B3 = r5.dataQuery;
            return G3(R6, A2, "mainType") && G3(R6, A2, "subType") && G3(R6, A2, "index", "componentIndex") && G3(R6, A2, "name") && G3(R6, A2, "id") && G3(B3, S2, "name") && G3(B3, S2, "dataIndex") && G3(B3, S2, "dataType") && (!k2.filterForExposedEvent || k2.filterForExposedEvent(s, r5.otherQuery, b6, S2));
            function G3(Z3, X3, tt, it) {
              return Z3[tt] == null || X3[it || tt] === Z3[tt];
            }
          }, c5.prototype.afterTrigger = function() {
            this.eventInfo = null;
          }, c5;
        }(), QWt = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], IAe = QWt.concat(["symbolKeepAspect"]), oFn = { createOnAllSeries: true, performRawSeries: true, reset: function(c5, s) {
          var r5 = c5.getData();
          if (c5.legendIcon && r5.setVisual("legendIcon", c5.legendIcon), !c5.hasSymbolVisual)
            return;
          for (var g5 = {}, b6 = {}, S2 = false, A2 = 0; A2 < QWt.length; A2++) {
            var k2 = QWt[A2], R6 = c5.get(k2);
            Tl(R6) ? (S2 = true, b6[k2] = R6) : g5[k2] = R6;
          }
          if (g5.symbol = g5.symbol || c5.defaultSymbol, r5.setVisual(sa2({ legendIcon: c5.legendIcon || g5.symbol, symbolKeepAspect: c5.get("symbolKeepAspect") }, g5)), s.isSeriesFiltered(c5))
            return;
          var B3 = nf2(b6);
          function G3(Z3, X3) {
            for (var tt = c5.getRawValue(X3), it = c5.getDataParams(X3), pt = 0; pt < B3.length; pt++) {
              var mt = B3[pt];
              Z3.setItemVisual(X3, mt, b6[mt](tt, it));
            }
          }
          return { dataEach: S2 ? G3 : null };
        } }, sFn = { createOnAllSeries: true, performRawSeries: true, reset: function(c5, s) {
          if (!c5.hasSymbolVisual || s.isSeriesFiltered(c5))
            return;
          var r5 = c5.getData();
          function g5(b6, S2) {
            for (var A2 = b6.getItemModel(S2), k2 = 0; k2 < IAe.length; k2++) {
              var R6 = IAe[k2], B3 = A2.getShallow(R6, true);
              B3 != null && b6.setItemVisual(S2, R6, B3);
            }
          }
          return { dataEach: r5.hasItemOption ? g5 : null };
        } };
        function JWt(c5, s, r5) {
          switch (r5) {
            case "color":
              var g5 = c5.getItemVisual(s, "style");
              return g5[c5.getVisual("drawType")];
            case "opacity":
              return c5.getItemVisual(s, "style").opacity;
            case "symbol":
            case "symbolSize":
            case "liftZ":
              return c5.getItemVisual(s, r5);
          }
        }
        function gct(c5, s) {
          switch (s) {
            case "color":
              var r5 = c5.getVisual("style");
              return r5[c5.getVisual("drawType")];
            case "opacity":
              return c5.getVisual("style").opacity;
            case "symbol":
            case "symbolSize":
            case "liftZ":
              return c5.getVisual(s);
          }
        }
        function DAe(c5, s, r5, g5) {
          switch (r5) {
            case "color":
              var b6 = c5.ensureUniqueItemVisual(s, "style");
              b6[c5.getVisual("drawType")] = g5, c5.setItemVisual(s, "colorFromPalette", false);
              break;
            case "opacity":
              c5.ensureUniqueItemVisual(s, "style").opacity = g5;
              break;
            case "symbol":
            case "symbolSize":
            case "liftZ":
              c5.setItemVisual(s, r5, g5);
              break;
          }
        }
        function EAe(c5, s) {
          function r5(g5, b6) {
            var S2 = [];
            return g5.eachComponent({ mainType: "series", subType: c5, query: b6 }, function(A2) {
              S2.push(A2.seriesIndex);
            }), S2;
          }
          Ye2([[c5 + "ToggleSelect", "toggleSelect"], [c5 + "Select", "select"], [c5 + "UnSelect", "unselect"]], function(g5) {
            s(g5[0], function(b6, S2, A2) {
              b6 = sa2({}, b6), A2.dispatchAction(sa2(b6, { type: g5[1], seriesIndex: r5(S2, b6) }));
            });
          });
        }
        function dX(c5, s, r5, g5, b6) {
          var S2 = c5 + s;
          r5.isSilent(S2) || g5.eachComponent({ mainType: "series", subType: "pie" }, function(A2) {
            for (var k2 = A2.seriesIndex, R6 = A2.option.selectedMap, B3 = b6.selected, G3 = 0; G3 < B3.length; G3++)
              if (B3[G3].seriesIndex === k2) {
                var Z3 = A2.getData(), X3 = nR(Z3, b6.fromActionPayload);
                r5.trigger(S2, { type: S2, seriesId: A2.id, name: ja2(X3) ? Z3.getName(X3[0]) : Z3.getName(X3), selected: gs(R6) ? R6 : sa2({}, R6) });
              }
          });
        }
        function lFn(c5, s, r5) {
          c5.on("selectchanged", function(g5) {
            var b6 = r5.getModel();
            g5.isFromClick ? (dX("map", "selectchanged", s, b6, g5), dX("pie", "selectchanged", s, b6, g5)) : g5.fromAction === "select" ? (dX("map", "selected", s, b6, g5), dX("pie", "selected", s, b6, g5)) : g5.fromAction === "unselect" && (dX("map", "unselected", s, b6, g5), dX("pie", "unselected", s, b6, g5));
          });
        }
        function gX(c5, s, r5) {
          for (var g5; c5 && !(s(c5) && (g5 = c5, r5)); )
            c5 = c5.__hostTarget || c5.parent;
          return g5;
        }
        var uFn = Math.round(Math.random() * 9), cFn = typeof Object.defineProperty == "function", fFn = function() {
          function c5() {
            this._id = "__ec_inner_" + uFn++;
          }
          return c5.prototype.get = function(s) {
            return this._guard(s)[this._id];
          }, c5.prototype.set = function(s, r5) {
            var g5 = this._guard(s);
            return cFn ? Object.defineProperty(g5, this._id, { value: r5, enumerable: false, configurable: true }) : g5[this._id] = r5, this;
          }, c5.prototype.delete = function(s) {
            return this.has(s) ? (delete this._guard(s)[this._id], true) : false;
          }, c5.prototype.has = function(s) {
            return !!this._guard(s)[this._id];
          }, c5.prototype._guard = function(s) {
            if (s !== Object(s))
              throw TypeError("Value of WeakMap is not a non-null object.");
            return s;
          }, c5;
        }(), hFn = fFn, pFn = Tc2.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(c5, s) {
          var r5 = s.cx, g5 = s.cy, b6 = s.width / 2, S2 = s.height / 2;
          c5.moveTo(r5, g5 - S2), c5.lineTo(r5 + b6, g5 + S2), c5.lineTo(r5 - b6, g5 + S2), c5.closePath();
        } }), dFn = Tc2.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(c5, s) {
          var r5 = s.cx, g5 = s.cy, b6 = s.width / 2, S2 = s.height / 2;
          c5.moveTo(r5, g5 - S2), c5.lineTo(r5 + b6, g5), c5.lineTo(r5, g5 + S2), c5.lineTo(r5 - b6, g5), c5.closePath();
        } }), gFn = Tc2.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(c5, s) {
          var r5 = s.x, g5 = s.y, b6 = s.width / 5 * 3, S2 = Math.max(b6, s.height), A2 = b6 / 2, k2 = A2 * A2 / (S2 - A2), R6 = g5 - S2 + A2 + k2, B3 = Math.asin(k2 / A2), G3 = Math.cos(B3) * A2, Z3 = Math.sin(B3), X3 = Math.cos(B3), tt = A2 * 0.6, it = A2 * 0.7;
          c5.moveTo(r5 - G3, R6 + k2), c5.arc(r5, R6, A2, Math.PI - B3, Math.PI * 2 + B3), c5.bezierCurveTo(r5 + G3 - Z3 * tt, R6 + k2 + X3 * tt, r5, g5 - it, r5, g5), c5.bezierCurveTo(r5, g5 - it, r5 - G3 + Z3 * tt, R6 + k2 + X3 * tt, r5 - G3, R6 + k2), c5.closePath();
        } }), vFn = Tc2.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(c5, s) {
          var r5 = s.height, g5 = s.width, b6 = s.x, S2 = s.y, A2 = g5 / 3 * 2;
          c5.moveTo(b6, S2), c5.lineTo(b6 + A2, S2 + r5), c5.lineTo(b6, S2 + r5 / 4 * 3), c5.lineTo(b6 - A2, S2 + r5), c5.lineTo(b6, S2), c5.closePath();
        } }), yFn = { line: Zm, rect: zf2, roundRect: zf2, square: zf2, circle: qI, diamond: dFn, pin: gFn, arrow: vFn, triangle: pFn }, mFn = { line: function(c5, s, r5, g5, b6) {
          b6.x1 = c5, b6.y1 = s + g5 / 2, b6.x2 = c5 + r5, b6.y2 = s + g5 / 2;
        }, rect: function(c5, s, r5, g5, b6) {
          b6.x = c5, b6.y = s, b6.width = r5, b6.height = g5;
        }, roundRect: function(c5, s, r5, g5, b6) {
          b6.x = c5, b6.y = s, b6.width = r5, b6.height = g5, b6.r = Math.min(r5, g5) / 4;
        }, square: function(c5, s, r5, g5, b6) {
          var S2 = Math.min(r5, g5);
          b6.x = c5, b6.y = s, b6.width = S2, b6.height = S2;
        }, circle: function(c5, s, r5, g5, b6) {
          b6.cx = c5 + r5 / 2, b6.cy = s + g5 / 2, b6.r = Math.min(r5, g5) / 2;
        }, diamond: function(c5, s, r5, g5, b6) {
          b6.cx = c5 + r5 / 2, b6.cy = s + g5 / 2, b6.width = r5, b6.height = g5;
        }, pin: function(c5, s, r5, g5, b6) {
          b6.x = c5 + r5 / 2, b6.y = s + g5 / 2, b6.width = r5, b6.height = g5;
        }, arrow: function(c5, s, r5, g5, b6) {
          b6.x = c5 + r5 / 2, b6.y = s + g5 / 2, b6.width = r5, b6.height = g5;
        }, triangle: function(c5, s, r5, g5, b6) {
          b6.cx = c5 + r5 / 2, b6.cy = s + g5 / 2, b6.width = r5, b6.height = g5;
        } }, pMt = {};
        Ye2(yFn, function(c5, s) {
          pMt[s] = new c5();
        });
        var bFn = Tc2.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(c5, s, r5) {
          var g5 = Oj2(c5, s, r5), b6 = this.shape;
          return b6 && b6.symbolType === "pin" && s.position === "inside" && (g5.y = r5.y + r5.height * 0.4), g5;
        }, buildPath: function(c5, s, r5) {
          var g5 = s.symbolType;
          if (g5 !== "none") {
            var b6 = pMt[g5];
            b6 || (g5 = "rect", b6 = pMt[g5]), mFn[g5](s.x, s.y, s.width, s.height, b6.shape), b6.buildPath(c5, b6.shape, r5);
          }
        } });
        function _Fn(c5, s) {
          if (this.type !== "image") {
            var r5 = this.style;
            this.__isEmptyBrush ? (r5.stroke = c5, r5.fill = s || "#fff", r5.lineWidth = 2) : this.shape.symbolType === "line" ? r5.stroke = c5 : r5.fill = c5, this.markRedraw();
          }
        }
        function am(c5, s, r5, g5, b6, S2, A2) {
          var k2 = c5.indexOf("empty") === 0;
          k2 && (c5 = c5.substr(5, 1).toLowerCase() + c5.substr(6));
          var R6;
          return c5.indexOf("image://") === 0 ? R6 = Ie2(c5.slice(8), new lc2(s, r5, g5, b6), A2 ? "center" : "cover") : c5.indexOf("path://") === 0 ? R6 = Xt(c5.slice(7), {}, new lc2(s, r5, g5, b6), A2 ? "center" : "cover") : R6 = new bFn({ shape: { symbolType: c5, x: s, y: r5, width: g5, height: b6 } }), R6.__isEmptyBrush = k2, R6.setColor = _Fn, S2 && R6.setColor(S2), R6;
        }
        function vct(c5) {
          return ja2(c5) || (c5 = [+c5, +c5]), [c5[0] || 0, c5[1] || 0];
        }
        function vX(c5, s) {
          if (c5 != null)
            return ja2(c5) || (c5 = [c5, c5]), [$o(c5[0], s[0]) || 0, $o(tc2(c5[1], c5[0]), s[1]) || 0];
        }
        function xFn(c5, s, r5) {
          var g5 = s.x == null ? 0 : s.x, b6 = s.x2 == null ? 1 : s.x2, S2 = s.y == null ? 0 : s.y, A2 = s.y2 == null ? 0 : s.y2;
          s.global || (g5 = g5 * r5.width + r5.x, b6 = b6 * r5.width + r5.x, S2 = S2 * r5.height + r5.y, A2 = A2 * r5.height + r5.y), g5 = isNaN(g5) ? 0 : g5, b6 = isNaN(b6) ? 1 : b6, S2 = isNaN(S2) ? 0 : S2, A2 = isNaN(A2) ? 0 : A2;
          var k2 = c5.createLinearGradient(g5, S2, b6, A2);
          return k2;
        }
        function wFn(c5, s, r5) {
          var g5 = r5.width, b6 = r5.height, S2 = Math.min(g5, b6), A2 = s.x == null ? 0.5 : s.x, k2 = s.y == null ? 0.5 : s.y, R6 = s.r == null ? 0.5 : s.r;
          s.global || (A2 = A2 * g5 + r5.x, k2 = k2 * b6 + r5.y, R6 = R6 * S2);
          var B3 = c5.createRadialGradient(A2, k2, 0, A2, k2, R6);
          return B3;
        }
        function tGt(c5, s, r5) {
          for (var g5 = s.type === "radial" ? wFn(c5, s, r5) : xFn(c5, s, r5), b6 = s.colorStops, S2 = 0; S2 < b6.length; S2++)
            g5.addColorStop(b6[S2].offset, b6[S2].color);
          return g5;
        }
        function SFn(c5, s) {
          if (c5 === s || !c5 && !s)
            return false;
          if (!c5 || !s || c5.length !== s.length)
            return true;
          for (var r5 = 0; r5 < c5.length; r5++)
            if (c5[r5] !== s[r5])
              return true;
          return false;
        }
        function dMt(c5) {
          return parseInt(c5, 10);
        }
        function yX(c5, s, r5) {
          var g5 = ["width", "height"][s], b6 = ["clientWidth", "clientHeight"][s], S2 = ["paddingLeft", "paddingTop"][s], A2 = ["paddingRight", "paddingBottom"][s];
          if (r5[g5] != null && r5[g5] !== "auto")
            return parseFloat(r5[g5]);
          var k2 = document.defaultView.getComputedStyle(c5);
          return (c5[b6] || dMt(k2[g5]) || dMt(c5.style[g5])) - (dMt(k2[S2]) || 0) - (dMt(k2[A2]) || 0) | 0;
        }
        function MFn(c5, s) {
          return !c5 || c5 === "solid" || !(s > 0) ? null : c5 === "dashed" ? [4 * s, 2 * s] : c5 === "dotted" ? [s] : Oh2(c5) ? [c5] : ja2(c5) ? c5 : null;
        }
        function eGt(c5) {
          var s = c5.style, r5 = s.lineDash && s.lineWidth > 0 && MFn(s.lineDash, s.lineWidth), g5 = s.lineDashOffset;
          if (r5) {
            var b6 = s.strokeNoScale && c5.getLineScale ? c5.getLineScale() : 1;
            b6 && b6 !== 1 && (r5 = Ha2(r5, function(S2) {
              return S2 / b6;
            }), g5 /= b6);
          }
          return [r5, g5];
        }
        var CFn = new jI(true);
        function gMt(c5) {
          var s = c5.stroke;
          return !(s == null || s === "none" || !(c5.lineWidth > 0));
        }
        function kAe(c5) {
          return typeof c5 == "string" && c5 !== "none";
        }
        function vMt(c5) {
          var s = c5.fill;
          return s != null && s !== "none";
        }
        function PAe(c5, s) {
          if (s.fillOpacity != null && s.fillOpacity !== 1) {
            var r5 = c5.globalAlpha;
            c5.globalAlpha = s.fillOpacity * s.opacity, c5.fill(), c5.globalAlpha = r5;
          } else
            c5.fill();
        }
        function LAe(c5, s) {
          if (s.strokeOpacity != null && s.strokeOpacity !== 1) {
            var r5 = c5.globalAlpha;
            c5.globalAlpha = s.strokeOpacity * s.opacity, c5.stroke(), c5.globalAlpha = r5;
          } else
            c5.stroke();
        }
        function nGt(c5, s, r5) {
          var g5 = iut(s.image, s.__image, r5);
          if (AK(g5)) {
            var b6 = c5.createPattern(g5, s.repeat || "repeat");
            if (typeof DOMMatrix == "function" && b6 && b6.setTransform) {
              var S2 = new DOMMatrix();
              S2.translateSelf(s.x || 0, s.y || 0), S2.rotateSelf(0, 0, (s.rotation || 0) * pj2), S2.scaleSelf(s.scaleX || 1, s.scaleY || 1), b6.setTransform(S2);
            }
            return b6;
          }
        }
        function TFn(c5, s, r5, g5) {
          var b6, S2 = gMt(r5), A2 = vMt(r5), k2 = r5.strokePercent, R6 = k2 < 1, B3 = !s.path;
          (!s.silent || R6) && B3 && s.createPathProxy();
          var G3 = s.path || CFn, Z3 = s.__dirty;
          if (!g5) {
            var X3 = r5.fill, tt = r5.stroke, it = A2 && !!X3.colorStops, pt = S2 && !!tt.colorStops, mt = A2 && !!X3.image, Mt = S2 && !!tt.image, kt = void 0, Gt = void 0, Ot = void 0, ce2 = void 0, ae2 = void 0;
            (it || pt) && (ae2 = s.getBoundingRect()), it && (kt = Z3 ? tGt(c5, X3, ae2) : s.__canvasFillGradient, s.__canvasFillGradient = kt), pt && (Gt = Z3 ? tGt(c5, tt, ae2) : s.__canvasStrokeGradient, s.__canvasStrokeGradient = Gt), mt && (Ot = Z3 || !s.__canvasFillPattern ? nGt(c5, X3, s) : s.__canvasFillPattern, s.__canvasFillPattern = Ot), Mt && (ce2 = Z3 || !s.__canvasStrokePattern ? nGt(c5, tt, s) : s.__canvasStrokePattern, s.__canvasStrokePattern = Ot), it ? c5.fillStyle = kt : mt && (Ot ? c5.fillStyle = Ot : A2 = false), pt ? c5.strokeStyle = Gt : Mt && (ce2 ? c5.strokeStyle = ce2 : S2 = false);
          }
          var de2 = s.getGlobalScale();
          G3.setScale(de2[0], de2[1], s.segmentIgnoreThreshold);
          var we2, Se2;
          c5.setLineDash && r5.lineDash && (b6 = eGt(s), we2 = b6[0], Se2 = b6[1]);
          var Oe2 = true;
          (B3 || Z3 & jC) && (G3.setDPR(c5.dpr), R6 ? G3.setContext(null) : (G3.setContext(c5), Oe2 = false), G3.reset(), s.buildPath(G3, s.shape, g5), G3.toStatic(), s.pathUpdated()), Oe2 && G3.rebuildPath(c5, R6 ? k2 : 1), we2 && (c5.setLineDash(we2), c5.lineDashOffset = Se2), g5 || (r5.strokeFirst ? (S2 && LAe(c5, r5), A2 && PAe(c5, r5)) : (A2 && PAe(c5, r5), S2 && LAe(c5, r5))), we2 && c5.setLineDash([]);
        }
        function AFn(c5, s, r5) {
          var g5 = s.__image = iut(r5.image, s.__image, s, s.onload);
          if (!(!g5 || !AK(g5))) {
            var b6 = r5.x || 0, S2 = r5.y || 0, A2 = s.getWidth(), k2 = s.getHeight(), R6 = g5.width / g5.height;
            if (A2 == null && k2 != null ? A2 = k2 * R6 : k2 == null && A2 != null ? k2 = A2 / R6 : A2 == null && k2 == null && (A2 = g5.width, k2 = g5.height), r5.sWidth && r5.sHeight) {
              var B3 = r5.sx || 0, G3 = r5.sy || 0;
              c5.drawImage(g5, B3, G3, r5.sWidth, r5.sHeight, b6, S2, A2, k2);
            } else if (r5.sx && r5.sy) {
              var B3 = r5.sx, G3 = r5.sy, Z3 = A2 - B3, X3 = k2 - G3;
              c5.drawImage(g5, B3, G3, Z3, X3, b6, S2, A2, k2);
            } else
              c5.drawImage(g5, b6, S2, A2, k2);
          }
        }
        function IFn(c5, s, r5) {
          var g5, b6 = r5.text;
          if (b6 != null && (b6 += ""), b6) {
            c5.font = r5.font || Yh2, c5.textAlign = r5.textAlign, c5.textBaseline = r5.textBaseline;
            var S2 = void 0, A2 = void 0;
            c5.setLineDash && r5.lineDash && (g5 = eGt(s), S2 = g5[0], A2 = g5[1]), S2 && (c5.setLineDash(S2), c5.lineDashOffset = A2), r5.strokeFirst ? (gMt(r5) && c5.strokeText(b6, r5.x, r5.y), vMt(r5) && c5.fillText(b6, r5.x, r5.y)) : (vMt(r5) && c5.fillText(b6, r5.x, r5.y), gMt(r5) && c5.strokeText(b6, r5.x, r5.y)), S2 && c5.setLineDash([]);
          }
        }
        var OAe = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], RAe = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
        function NAe(c5, s, r5, g5, b6) {
          var S2 = false;
          if (!g5 && (r5 = r5 || {}, s === r5))
            return false;
          if (g5 || s.opacity !== r5.opacity) {
            CM(c5, b6), S2 = true;
            var A2 = Math.max(Math.min(s.opacity, 1), 0);
            c5.globalAlpha = isNaN(A2) ? oR.opacity : A2;
          }
          (g5 || s.blend !== r5.blend) && (S2 || (CM(c5, b6), S2 = true), c5.globalCompositeOperation = s.blend || oR.blend);
          for (var k2 = 0; k2 < OAe.length; k2++) {
            var R6 = OAe[k2];
            (g5 || s[R6] !== r5[R6]) && (S2 || (CM(c5, b6), S2 = true), c5[R6] = c5.dpr * (s[R6] || 0));
          }
          return (g5 || s.shadowColor !== r5.shadowColor) && (S2 || (CM(c5, b6), S2 = true), c5.shadowColor = s.shadowColor || oR.shadowColor), S2;
        }
        function FAe(c5, s, r5, g5, b6) {
          var S2 = yct(s, b6.inHover), A2 = g5 ? null : r5 && yct(r5, b6.inHover) || {};
          if (S2 === A2)
            return false;
          var k2 = NAe(c5, S2, A2, g5, b6);
          if ((g5 || S2.fill !== A2.fill) && (k2 || (CM(c5, b6), k2 = true), kAe(S2.fill) && (c5.fillStyle = S2.fill)), (g5 || S2.stroke !== A2.stroke) && (k2 || (CM(c5, b6), k2 = true), kAe(S2.stroke) && (c5.strokeStyle = S2.stroke)), (g5 || S2.opacity !== A2.opacity) && (k2 || (CM(c5, b6), k2 = true), c5.globalAlpha = S2.opacity == null ? 1 : S2.opacity), s.hasStroke()) {
            var R6 = S2.lineWidth, B3 = R6 / (S2.strokeNoScale && s.getLineScale ? s.getLineScale() : 1);
            c5.lineWidth !== B3 && (k2 || (CM(c5, b6), k2 = true), c5.lineWidth = B3);
          }
          for (var G3 = 0; G3 < RAe.length; G3++) {
            var Z3 = RAe[G3], X3 = Z3[0];
            (g5 || S2[X3] !== A2[X3]) && (k2 || (CM(c5, b6), k2 = true), c5[X3] = S2[X3] || Z3[1]);
          }
          return k2;
        }
        function DFn(c5, s, r5, g5, b6) {
          return NAe(c5, yct(s, b6.inHover), r5 && yct(r5, b6.inHover), g5, b6);
        }
        function VAe(c5, s) {
          var r5 = s.transform, g5 = c5.dpr || 1;
          r5 ? c5.setTransform(g5 * r5[0], g5 * r5[1], g5 * r5[2], g5 * r5[3], g5 * r5[4], g5 * r5[5]) : c5.setTransform(g5, 0, 0, g5, 0, 0);
        }
        function EFn(c5, s, r5) {
          for (var g5 = false, b6 = 0; b6 < c5.length; b6++) {
            var S2 = c5[b6];
            g5 = g5 || S2.isZeroArea(), VAe(s, S2), s.beginPath(), S2.buildPath(s, S2.shape), s.clip();
          }
          r5.allClipped = g5;
        }
        function kFn(c5, s) {
          return c5 && s ? c5[0] !== s[0] || c5[1] !== s[1] || c5[2] !== s[2] || c5[3] !== s[3] || c5[4] !== s[4] || c5[5] !== s[5] : !(!c5 && !s);
        }
        var BAe = 1, zAe = 2, jAe = 3, WAe = 4;
        function PFn(c5) {
          var s = vMt(c5), r5 = gMt(c5);
          return !(c5.lineDash || !(+s ^ +r5) || s && typeof c5.fill != "string" || r5 && typeof c5.stroke != "string" || c5.strokePercent < 1 || c5.strokeOpacity < 1 || c5.fillOpacity < 1);
        }
        function CM(c5, s) {
          s.batchFill && c5.fill(), s.batchStroke && c5.stroke(), s.batchFill = "", s.batchStroke = "";
        }
        function yct(c5, s) {
          return s && c5.__hoverStyle || c5.style;
        }
        function GAe(c5, s) {
          hW(c5, s, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
        }
        function hW(c5, s, r5, g5) {
          var b6 = s.transform;
          if (!s.shouldBePainted(r5.viewWidth, r5.viewHeight, false, false)) {
            s.__dirty &= ~Vb2, s.__isRendered = false;
            return;
          }
          var S2 = s.__clipPaths, A2 = r5.prevElClipPaths, k2 = false, R6 = false;
          if ((!A2 || SFn(S2, A2)) && (A2 && A2.length && (CM(c5, r5), c5.restore(), R6 = k2 = true, r5.prevElClipPaths = null, r5.allClipped = false, r5.prevEl = null), S2 && S2.length && (CM(c5, r5), c5.save(), EFn(S2, c5, r5), k2 = true), r5.prevElClipPaths = S2), r5.allClipped) {
            s.__isRendered = false;
            return;
          }
          s.beforeBrush && s.beforeBrush(), s.innerBeforeBrush();
          var B3 = r5.prevEl;
          B3 || (R6 = k2 = true);
          var G3 = s instanceof Tc2 && s.autoBatch && PFn(s.style);
          k2 || kFn(b6, B3.transform) ? (CM(c5, r5), VAe(c5, s)) : G3 || CM(c5, r5);
          var Z3 = yct(s, r5.inHover);
          s instanceof Tc2 ? (r5.lastDrawType !== BAe && (R6 = true, r5.lastDrawType = BAe), FAe(c5, s, B3, R6, r5), (!G3 || !r5.batchFill && !r5.batchStroke) && c5.beginPath(), TFn(c5, s, Z3, G3), G3 && (r5.batchFill = Z3.fill || "", r5.batchStroke = Z3.stroke || "")) : s instanceof qj2 ? (r5.lastDrawType !== jAe && (R6 = true, r5.lastDrawType = jAe), FAe(c5, s, B3, R6, r5), IFn(c5, s, Z3)) : s instanceof qm ? (r5.lastDrawType !== zAe && (R6 = true, r5.lastDrawType = zAe), DFn(c5, s, B3, R6, r5), AFn(c5, s, Z3)) : s.getTemporalDisplayables && (r5.lastDrawType !== WAe && (R6 = true, r5.lastDrawType = WAe), LFn(c5, s, r5)), G3 && g5 && CM(c5, r5), s.innerAfterBrush(), s.afterBrush && s.afterBrush(), r5.prevEl = s, s.__dirty = 0, s.__isRendered = true;
        }
        function LFn(c5, s, r5) {
          var g5 = s.getDisplayables(), b6 = s.getTemporalDisplayables();
          c5.save();
          var S2 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: r5.viewWidth, viewHeight: r5.viewHeight, inHover: r5.inHover }, A2, k2;
          for (A2 = s.getCursor(), k2 = g5.length; A2 < k2; A2++) {
            var R6 = g5[A2];
            R6.beforeBrush && R6.beforeBrush(), R6.innerBeforeBrush(), hW(c5, R6, S2, A2 === k2 - 1), R6.innerAfterBrush(), R6.afterBrush && R6.afterBrush(), S2.prevEl = R6;
          }
          for (var B3 = 0, G3 = b6.length; B3 < G3; B3++) {
            var R6 = b6[B3];
            R6.beforeBrush && R6.beforeBrush(), R6.innerBeforeBrush(), hW(c5, R6, S2, B3 === G3 - 1), R6.innerAfterBrush(), R6.afterBrush && R6.afterBrush(), S2.prevEl = R6;
          }
          s.clearTemporalDisplayables(), s.notClear = true, c5.restore();
        }
        var rGt = new hFn(), HAe = new gk2(100), UAe = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
        function mct(c5, s) {
          if (c5 === "none")
            return null;
          var r5 = s.getDevicePixelRatio(), g5 = s.getZr(), b6 = g5.painter.type === "svg";
          c5.dirty && rGt.delete(c5);
          var S2 = rGt.get(c5);
          if (S2)
            return S2;
          var A2 = Cl(c5, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
          A2.backgroundColor === "none" && (A2.backgroundColor = null);
          var k2 = { repeat: "repeat" };
          return R6(k2), k2.rotation = A2.rotation, k2.scaleX = k2.scaleY = b6 ? 1 : 1 / r5, rGt.set(c5, k2), c5.dirty = false, k2;
          function R6(B3) {
            for (var G3 = [r5], Z3 = true, X3 = 0; X3 < UAe.length; ++X3) {
              var tt = A2[UAe[X3]];
              if (tt != null && !ja2(tt) && !gs(tt) && !Oh2(tt) && typeof tt != "boolean") {
                Z3 = false;
                break;
              }
              G3.push(tt);
            }
            var it;
            if (Z3) {
              it = G3.join(",") + (b6 ? "-svg" : "");
              var pt = HAe.get(it);
              pt && (b6 ? B3.svgElement = pt : B3.image = pt);
            }
            var mt = ZAe(A2.dashArrayX), Mt = OFn(A2.dashArrayY), kt = qAe(A2.symbol), Gt = RFn(mt), Ot = $Ae(Mt), ce2 = !b6 && T0.createCanvas(), ae2 = b6 && { tag: "g", attrs: {}, key: "dcl", children: [] }, de2 = Se2(), we2;
            ce2 && (ce2.width = de2.width * r5, ce2.height = de2.height * r5, we2 = ce2.getContext("2d")), Oe2(), Z3 && HAe.put(it, ce2 || ae2), B3.image = ce2, B3.svgElement = ae2, B3.svgWidth = de2.width, B3.svgHeight = de2.height;
            function Se2() {
              for (var je2 = 1, rn = 0, qe2 = Gt.length; rn < qe2; ++rn)
                je2 = NSt(je2, Gt[rn]);
              for (var An = 1, rn = 0, qe2 = kt.length; rn < qe2; ++rn)
                An = NSt(An, kt[rn].length);
              je2 *= An;
              var jn = Ot * Gt.length * kt.length;
              return { width: Math.max(1, Math.min(je2, A2.maxTileWidth)), height: Math.max(1, Math.min(jn, A2.maxTileHeight)) };
            }
            function Oe2() {
              we2 && (we2.clearRect(0, 0, ce2.width, ce2.height), A2.backgroundColor && (we2.fillStyle = A2.backgroundColor, we2.fillRect(0, 0, ce2.width, ce2.height)));
              for (var je2 = 0, rn = 0; rn < Mt.length; ++rn)
                je2 += Mt[rn];
              if (je2 <= 0)
                return;
              for (var qe2 = -Ot, An = 0, jn = 0, _n = 0; qe2 < de2.height; ) {
                if (An % 2 === 0) {
                  for (var Jr = jn / 2 % kt.length, Qn = 0, rr = 0, Ar = 0; Qn < de2.width * 2; ) {
                    for (var fi2 = 0, rn = 0; rn < mt[_n].length; ++rn)
                      fi2 += mt[_n][rn];
                    if (fi2 <= 0)
                      break;
                    if (rr % 2 === 0) {
                      var mi2 = (1 - A2.symbolSize) * 0.5, Oo = Qn + mt[_n][rr] * mi2, Ts = qe2 + Mt[An] * mi2, gl = mt[_n][rr] * A2.symbolSize, nl = Mt[An] * A2.symbolSize, rl = Ar / 2 % kt[Jr].length;
                      ss(Oo, Ts, gl, nl, kt[Jr][rl]);
                    }
                    Qn += mt[_n][rr], ++Ar, ++rr, rr === mt[_n].length && (rr = 0);
                  }
                  ++_n, _n === mt.length && (_n = 0);
                }
                qe2 += Mt[An], ++jn, ++An, An === Mt.length && (An = 0);
              }
              function ss(Us, sl, ws, Ll, dh2) {
                var hu = b6 ? 1 : r5, Nh2 = am(dh2, Us * hu, sl * hu, ws * hu, Ll * hu, A2.color, A2.symbolKeepAspect);
                if (b6) {
                  var cp = g5.painter.renderOneToVNode(Nh2);
                  cp && ae2.children.push(cp);
                } else
                  GAe(we2, Nh2);
              }
            }
          }
        }
        function qAe(c5) {
          if (!c5 || c5.length === 0)
            return [["rect"]];
          if (gs(c5))
            return [[c5]];
          for (var s = true, r5 = 0; r5 < c5.length; ++r5)
            if (!gs(c5[r5])) {
              s = false;
              break;
            }
          if (s)
            return qAe([c5]);
          for (var g5 = [], r5 = 0; r5 < c5.length; ++r5)
            gs(c5[r5]) ? g5.push([c5[r5]]) : g5.push(c5[r5]);
          return g5;
        }
        function ZAe(c5) {
          if (!c5 || c5.length === 0)
            return [[0, 0]];
          if (Oh2(c5)) {
            var s = Math.ceil(c5);
            return [[s, s]];
          }
          for (var r5 = true, g5 = 0; g5 < c5.length; ++g5)
            if (!Oh2(c5[g5])) {
              r5 = false;
              break;
            }
          if (r5)
            return ZAe([c5]);
          for (var b6 = [], g5 = 0; g5 < c5.length; ++g5)
            if (Oh2(c5[g5])) {
              var s = Math.ceil(c5[g5]);
              b6.push([s, s]);
            } else {
              var s = Ha2(c5[g5], function(k2) {
                return Math.ceil(k2);
              });
              s.length % 2 === 1 ? b6.push(s.concat(s)) : b6.push(s);
            }
          return b6;
        }
        function OFn(c5) {
          if (!c5 || typeof c5 == "object" && c5.length === 0)
            return [0, 0];
          if (Oh2(c5)) {
            var s = Math.ceil(c5);
            return [s, s];
          }
          var r5 = Ha2(c5, function(g5) {
            return Math.ceil(g5);
          });
          return c5.length % 2 ? r5.concat(r5) : r5;
        }
        function RFn(c5) {
          return Ha2(c5, function(s) {
            return $Ae(s);
          });
        }
        function $Ae(c5) {
          for (var s = 0, r5 = 0; r5 < c5.length; ++r5)
            s += c5[r5];
          return c5.length % 2 === 1 ? s * 2 : s;
        }
        function NFn(c5, s) {
          c5.eachRawSeries(function(r5) {
            if (!c5.isSeriesFiltered(r5)) {
              var g5 = r5.getData();
              g5.hasItemVisual() && g5.each(function(A2) {
                var k2 = g5.getItemVisual(A2, "decal");
                if (k2) {
                  var R6 = g5.ensureUniqueItemVisual(A2, "style");
                  R6.decal = mct(k2, s);
                }
              });
              var b6 = g5.getVisual("decal");
              if (b6) {
                var S2 = g5.getVisual("style");
                S2.decal = mct(b6, s);
              }
            }
          });
        }
        var FFn = new Lw(), Ek = FFn, YAe = {};
        function VFn(c5, s) {
          YAe[c5] = s;
        }
        function BFn(c5) {
          return YAe[c5];
        }
        var zFn = typeof window != "undefined", jFn = 1, WFn = 800, GFn = 900, HFn = 1e3, UFn = 2e3, qFn = 5e3, KAe = 1e3, ZFn = 1100, iGt = 2e3, XAe = 3e3, $Fn = 4e3, yMt = 4500, YFn = 4600, KFn = 5e3, XFn = 6e3, QAe = 7e3, QFn = { PROCESSOR: { FILTER: HFn, SERIES_FILTER: WFn, STATISTIC: qFn }, VISUAL: { LAYOUT: KAe, PROGRESSIVE_LAYOUT: ZFn, GLOBAL: iGt, CHART: XAe, POST_CHART_LAYOUT: YFn, COMPONENT: $Fn, BRUSH: KFn, CHART_ITEM: yMt, ARIA: XFn, DECAL: QAe } }, $w = "__flagInMainProcess", TM = "__pendingUpdate", aGt = "__needsUpdateStatus", JAe = /^[a-zA-Z0-9_]+$/, oGt = "__connectUpdateStatus", tIe = 0, JFn = 1, t8n = 2;
        function eIe(c5) {
          return function() {
            for (var s = [], r5 = 0; r5 < arguments.length; r5++)
              s[r5] = arguments[r5];
            if (this.isDisposed()) {
              this.id;
              return;
            }
            return rIe(this, c5, s);
          };
        }
        function nIe(c5) {
          return function() {
            for (var s = [], r5 = 0; r5 < arguments.length; r5++)
              s[r5] = arguments[r5];
            return rIe(this, c5, s);
          };
        }
        function rIe(c5, s, r5) {
          return r5[0] = r5[0] && r5[0].toLowerCase(), Lw.prototype[s].apply(c5, r5);
        }
        var iIe = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s;
        }(Lw), aIe = iIe.prototype;
        aIe.on = nIe("on"), aIe.off = nIe("off");
        var mX, sGt, mMt, J8, lGt, uGt, cGt, bct, _ct, oIe, sIe, fGt, lIe, bMt, uIe, cIe, JI, fIe, hIe = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this, new aFn()) || this;
            S2._chartsViews = [], S2._chartsMap = {}, S2._componentsViews = [], S2._componentsMap = {}, S2._pendingActions = [], b6 = b6 || {}, gs(g5) && (g5 = pIe[g5]), S2._dom = r5;
            var A2 = "canvas", k2 = false, R6 = S2._zr = eR(r5, { renderer: b6.renderer || A2, devicePixelRatio: b6.devicePixelRatio, width: b6.width, height: b6.height, ssr: b6.ssr, useDirtyRect: b6.useDirtyRect == null ? k2 : b6.useDirtyRect });
            S2._ssr = b6.ssr, S2._throttledZrFlush = XWt(Cs(R6.flush, R6), 17), g5 = Ml(g5), g5 && ITe(g5, true), S2._theme = g5, S2._locale = c6n(b6.locale || zCe), S2._coordSysMgr = new oct();
            var B3 = S2._api = uIe(S2);
            function G3(Z3, X3) {
              return Z3.__prio - X3.__prio;
            }
            return fx(xMt, G3), fx(pGt, G3), S2._scheduler = new SAe(S2, B3, pGt, xMt), S2._messageCenter = new iIe(), S2._initEvents(), S2.resize = Cs(S2.resize, S2), R6.animation.on("frame", S2._onframe, S2), oIe(R6, S2), sIe(R6, S2), DI(S2), S2;
          }
          return s.prototype._onframe = function() {
            if (!this._disposed) {
              fIe(this);
              var r5 = this._scheduler;
              if (this[TM]) {
                var g5 = this[TM].silent;
                this[$w] = true;
                try {
                  mX(this), J8.update.call(this, null, this[TM].updateParams);
                } catch (R6) {
                  throw this[$w] = false, this[TM] = null, R6;
                }
                this._zr.flush(), this[$w] = false, this[TM] = null, bct.call(this, g5), _ct.call(this, g5);
              } else if (r5.unfinished) {
                var b6 = jFn, S2 = this._model, A2 = this._api;
                r5.unfinished = false;
                do {
                  var k2 = +new Date();
                  r5.performSeriesTasks(S2), r5.performDataProcessorTasks(S2), uGt(this, S2), r5.performVisualTasks(S2), bMt(this, this._model, A2, "remain", {}), b6 -= +new Date() - k2;
                } while (b6 > 0 && r5.unfinished);
                r5.unfinished || this._zr.flush();
              }
            }
          }, s.prototype.getDom = function() {
            return this._dom;
          }, s.prototype.getId = function() {
            return this.id;
          }, s.prototype.getZr = function() {
            return this._zr;
          }, s.prototype.isSSR = function() {
            return this._ssr;
          }, s.prototype.setOption = function(r5, g5, b6) {
            if (!this[$w]) {
              if (this._disposed) {
                this.id;
                return;
              }
              var S2, A2, k2;
              if (Wl(g5) && (b6 = g5.lazyUpdate, S2 = g5.silent, A2 = g5.replaceMerge, k2 = g5.transition, g5 = g5.notMerge), this[$w] = true, !this._model || g5) {
                var R6 = new H6n(this._api), B3 = this._theme, G3 = this._model = new _Te();
                G3.scheduler = this._scheduler, G3.ssr = this._ssr, G3.init(null, null, null, B3, this._locale, R6);
              }
              this._model.setOption(r5, { replaceMerge: A2 }, dGt);
              var Z3 = { seriesTransition: k2, optionChanged: true };
              if (b6)
                this[TM] = { silent: S2, updateParams: Z3 }, this[$w] = false, this.getZr().wakeUp();
              else {
                try {
                  mX(this), J8.update.call(this, null, Z3);
                } catch (X3) {
                  throw this[TM] = null, this[$w] = false, X3;
                }
                this._ssr || this._zr.flush(), this[TM] = null, this[$w] = false, bct.call(this, S2), _ct.call(this, S2);
              }
            }
          }, s.prototype.setTheme = function() {
          }, s.prototype.getModel = function() {
            return this._model;
          }, s.prototype.getOption = function() {
            return this._model && this._model.getOption();
          }, s.prototype.getWidth = function() {
            return this._zr.getWidth();
          }, s.prototype.getHeight = function() {
            return this._zr.getHeight();
          }, s.prototype.getDevicePixelRatio = function() {
            return this._zr.painter.dpr || zFn && window.devicePixelRatio || 1;
          }, s.prototype.getRenderedCanvas = function(r5) {
            return this.renderToCanvas(r5);
          }, s.prototype.renderToCanvas = function(r5) {
            r5 = r5 || {};
            var g5 = this._zr.painter;
            return g5.getRenderedCanvas({ backgroundColor: r5.backgroundColor || this._model.get("backgroundColor"), pixelRatio: r5.pixelRatio || this.getDevicePixelRatio() });
          }, s.prototype.renderToSVGString = function(r5) {
            r5 = r5 || {};
            var g5 = this._zr.painter;
            return g5.renderToString({ useViewBox: r5.useViewBox });
          }, s.prototype.getSvgDataURL = function() {
            if (os.svgSupported) {
              var r5 = this._zr, g5 = r5.storage.getDisplayList();
              return Ye2(g5, function(b6) {
                b6.stopAnimation(null, true);
              }), r5.painter.toDataURL();
            }
          }, s.prototype.getDataURL = function(r5) {
            if (this._disposed) {
              this.id;
              return;
            }
            r5 = r5 || {};
            var g5 = r5.excludeComponents, b6 = this._model, S2 = [], A2 = this;
            Ye2(g5, function(R6) {
              b6.eachComponent({ mainType: R6 }, function(B3) {
                var G3 = A2._componentsMap[B3.__viewId];
                G3.group.ignore || (S2.push(G3), G3.group.ignore = true);
              });
            });
            var k2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(r5).toDataURL("image/" + (r5 && r5.type || "png"));
            return Ye2(S2, function(R6) {
              R6.group.ignore = false;
            }), k2;
          }, s.prototype.getConnectedDataURL = function(r5) {
            if (this._disposed) {
              this.id;
              return;
            }
            var g5 = r5.type === "svg", b6 = this.group, S2 = Math.min, A2 = Math.max, k2 = 1 / 0;
            if (dIe[b6]) {
              var R6 = k2, B3 = k2, G3 = -k2, Z3 = -k2, X3 = [], tt = r5 && r5.pixelRatio || this.getDevicePixelRatio();
              Ye2(wct, function(Gt, Ot) {
                if (Gt.group === b6) {
                  var ce2 = g5 ? Gt.getZr().painter.getSvgDom().innerHTML : Gt.renderToCanvas(Ml(r5)), ae2 = Gt.getDom().getBoundingClientRect();
                  R6 = S2(ae2.left, R6), B3 = S2(ae2.top, B3), G3 = A2(ae2.right, G3), Z3 = A2(ae2.bottom, Z3), X3.push({ dom: ce2, left: ae2.left, top: ae2.top });
                }
              }), R6 *= tt, B3 *= tt, G3 *= tt, Z3 *= tt;
              var it = G3 - R6, pt = Z3 - B3, mt = T0.createCanvas(), Mt = eR(mt, { renderer: g5 ? "svg" : "canvas" });
              if (Mt.resize({ width: it, height: pt }), g5) {
                var kt = "";
                return Ye2(X3, function(Gt) {
                  var Ot = Gt.left - R6, ce2 = Gt.top - B3;
                  kt += '<g transform="translate(' + Ot + "," + ce2 + ')">' + Gt.dom + "</g>";
                }), Mt.painter.getSvgRoot().innerHTML = kt, r5.connectedBackgroundColor && Mt.painter.setBackgroundColor(r5.connectedBackgroundColor), Mt.refreshImmediately(), Mt.painter.toDataURL();
              } else
                return r5.connectedBackgroundColor && Mt.add(new zf2({ shape: { x: 0, y: 0, width: it, height: pt }, style: { fill: r5.connectedBackgroundColor } })), Ye2(X3, function(Gt) {
                  var Ot = new qm({ style: { x: Gt.left * tt - R6, y: Gt.top * tt - B3, image: Gt.dom } });
                  Mt.add(Ot);
                }), Mt.refreshImmediately(), mt.toDataURL("image/" + (r5 && r5.type || "png"));
            } else
              return this.getDataURL(r5);
          }, s.prototype.convertToPixel = function(r5, g5) {
            return lGt(this, "convertToPixel", r5, g5);
          }, s.prototype.convertFromPixel = function(r5, g5) {
            return lGt(this, "convertFromPixel", r5, g5);
          }, s.prototype.containPixel = function(r5, g5) {
            if (this._disposed) {
              this.id;
              return;
            }
            var b6 = this._model, S2, A2 = Wj2(b6, r5);
            return Ye2(A2, function(k2, R6) {
              R6.indexOf("Models") >= 0 && Ye2(k2, function(B3) {
                var G3 = B3.coordinateSystem;
                if (G3 && G3.containPoint)
                  S2 = S2 || !!G3.containPoint(g5);
                else if (R6 === "seriesModels") {
                  var Z3 = this._chartsMap[B3.__viewId];
                  Z3 && Z3.containPoint && (S2 = S2 || Z3.containPoint(g5, B3));
                }
              }, this);
            }, this), !!S2;
          }, s.prototype.getVisual = function(r5, g5) {
            var b6 = this._model, S2 = Wj2(b6, r5, { defaultMainType: "series" }), A2 = S2.seriesModel, k2 = A2.getData(), R6 = S2.hasOwnProperty("dataIndexInside") ? S2.dataIndexInside : S2.hasOwnProperty("dataIndex") ? k2.indexOfRawIndex(S2.dataIndex) : null;
            return R6 != null ? JWt(k2, R6, g5) : gct(k2, g5);
          }, s.prototype.getViewOfComponentModel = function(r5) {
            return this._componentsMap[r5.__viewId];
          }, s.prototype.getViewOfSeriesModel = function(r5) {
            return this._chartsMap[r5.__viewId];
          }, s.prototype._initEvents = function() {
            var r5 = this;
            Ye2(e8n, function(g5) {
              var b6 = function(S2) {
                var A2 = r5.getModel(), k2 = S2.target, R6, B3 = g5 === "globalout";
                if (B3 ? R6 = {} : k2 && gX(k2, function(it) {
                  var pt = Pl(it);
                  if (pt && pt.dataIndex != null) {
                    var mt = pt.dataModel || A2.getSeriesByIndex(pt.seriesIndex);
                    return R6 = mt && mt.getDataParams(pt.dataIndex, pt.dataType) || {}, true;
                  } else if (pt.eventData)
                    return R6 = sa2({}, pt.eventData), true;
                }, true), R6) {
                  var G3 = R6.componentType, Z3 = R6.componentIndex;
                  (G3 === "markLine" || G3 === "markPoint" || G3 === "markArea") && (G3 = "series", Z3 = R6.seriesIndex);
                  var X3 = G3 && Z3 != null && A2.getComponent(G3, Z3), tt = X3 && r5[X3.mainType === "series" ? "_chartsMap" : "_componentsMap"][X3.__viewId];
                  R6.event = S2, R6.type = g5, r5._$eventProcessor.eventInfo = { targetEl: k2, packedEvent: R6, model: X3, view: tt }, r5.trigger(g5, R6);
                }
              };
              b6.zrEventfulCallAtLast = true, r5._zr.on(g5, b6, r5);
            }), Ye2(xct, function(g5, b6) {
              r5._messageCenter.on(b6, function(S2) {
                this.trigger(b6, S2);
              }, r5);
            }), Ye2(["selectchanged"], function(g5) {
              r5._messageCenter.on(g5, function(b6) {
                this.trigger(g5, b6);
              }, r5);
            }), lFn(this._messageCenter, this, this._api);
          }, s.prototype.isDisposed = function() {
            return this._disposed;
          }, s.prototype.clear = function() {
            if (this._disposed) {
              this.id;
              return;
            }
            this.setOption({ series: [] }, true);
          }, s.prototype.dispose = function() {
            if (this._disposed) {
              this.id;
              return;
            }
            this._disposed = true;
            var r5 = this.getDom();
            r5 && BSt(this.getDom(), vGt, "");
            var g5 = this, b6 = g5._api, S2 = g5._model;
            Ye2(g5._componentsViews, function(A2) {
              A2.dispose(S2, b6);
            }), Ye2(g5._chartsViews, function(A2) {
              A2.dispose(S2, b6);
            }), g5._zr.dispose(), g5._dom = g5._model = g5._chartsMap = g5._componentsMap = g5._chartsViews = g5._componentsViews = g5._scheduler = g5._api = g5._zr = g5._throttledZrFlush = g5._theme = g5._coordSysMgr = g5._messageCenter = null, delete wct[g5.id];
          }, s.prototype.resize = function(r5) {
            if (!this[$w]) {
              if (this._disposed) {
                this.id;
                return;
              }
              this._zr.resize(r5);
              var g5 = this._model;
              if (this._loadingFX && this._loadingFX.resize(), !!g5) {
                var b6 = g5.resetOption("media"), S2 = r5 && r5.silent;
                this[TM] && (S2 == null && (S2 = this[TM].silent), b6 = true, this[TM] = null), this[$w] = true;
                try {
                  b6 && mX(this), J8.update.call(this, { type: "resize", animation: sa2({ duration: 0 }, r5 && r5.animation) });
                } catch (A2) {
                  throw this[$w] = false, A2;
                }
                this[$w] = false, bct.call(this, S2), _ct.call(this, S2);
              }
            }
          }, s.prototype.showLoading = function(r5, g5) {
            if (this._disposed) {
              this.id;
              return;
            }
            if (Wl(r5) && (g5 = r5, r5 = ""), r5 = r5 || "default", this.hideLoading(), !!gGt[r5]) {
              var b6 = gGt[r5](this._api, g5), S2 = this._zr;
              this._loadingFX = b6, S2.add(b6);
            }
          }, s.prototype.hideLoading = function() {
            if (this._disposed) {
              this.id;
              return;
            }
            this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
          }, s.prototype.makeActionFromEvent = function(r5) {
            var g5 = sa2({}, r5);
            return g5.type = xct[r5.type], g5;
          }, s.prototype.dispatchAction = function(r5, g5) {
            if (this._disposed) {
              this.id;
              return;
            }
            if (Wl(g5) || (g5 = { silent: !!g5 }), !!_Mt[r5.type] && !!this._model) {
              if (this[$w]) {
                this._pendingActions.push(r5);
                return;
              }
              var b6 = g5.silent;
              cGt.call(this, r5, b6);
              var S2 = g5.flush;
              S2 ? this._zr.flush() : S2 !== false && os.browser.weChat && this._throttledZrFlush(), bct.call(this, b6), _ct.call(this, b6);
            }
          }, s.prototype.updateLabelLayout = function() {
            Ek.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
          }, s.prototype.appendData = function(r5) {
            if (this._disposed) {
              this.id;
              return;
            }
            var g5 = r5.seriesIndex, b6 = this.getModel(), S2 = b6.getSeriesByIndex(g5);
            S2.appendData(r5), this._scheduler.unfinished = true, this.getZr().wakeUp();
          }, s.internalField = function() {
            mX = function(Z3) {
              var X3 = Z3._scheduler;
              X3.restorePipelines(Z3._model), X3.prepareStageTasks(), sGt(Z3, true), sGt(Z3, false), X3.plan();
            }, sGt = function(Z3, X3) {
              for (var tt = Z3._model, it = Z3._scheduler, pt = X3 ? Z3._componentsViews : Z3._chartsViews, mt = X3 ? Z3._componentsMap : Z3._chartsMap, Mt = Z3._zr, kt = Z3._api, Gt = 0; Gt < pt.length; Gt++)
                pt[Gt].__alive = false;
              X3 ? tt.eachComponent(function(ae2, de2) {
                ae2 !== "series" && Ot(de2);
              }) : tt.eachSeries(Ot);
              function Ot(ae2) {
                var de2 = ae2.__requireNewView;
                ae2.__requireNewView = false;
                var we2 = "_ec_" + ae2.id + "_" + ae2.type, Se2 = !de2 && mt[we2];
                if (!Se2) {
                  var Oe2 = Vw(ae2.type), je2 = X3 ? P0.getClass(Oe2.main, Oe2.sub) : Ig2.getClass(Oe2.sub);
                  Se2 = new je2(), Se2.init(tt, kt), mt[we2] = Se2, pt.push(Se2), Mt.add(Se2.group);
                }
                ae2.__viewId = Se2.__id = we2, Se2.__alive = true, Se2.__model = ae2, Se2.group.__ecComponentInfo = { mainType: ae2.mainType, index: ae2.componentIndex }, !X3 && it.prepareView(Se2, ae2, tt, kt);
              }
              for (var Gt = 0; Gt < pt.length; ) {
                var ce2 = pt[Gt];
                ce2.__alive ? Gt++ : (!X3 && ce2.renderTask.dispose(), Mt.remove(ce2.group), ce2.dispose(tt, kt), pt.splice(Gt, 1), mt[ce2.__id] === ce2 && delete mt[ce2.__id], ce2.__id = ce2.group.__ecComponentInfo = null);
              }
            }, mMt = function(Z3, X3, tt, it, pt) {
              var mt = Z3._model;
              if (mt.setUpdatePayload(tt), !it) {
                Ye2([].concat(Z3._componentsViews).concat(Z3._chartsViews), ce2);
                return;
              }
              var Mt = {};
              Mt[it + "Id"] = tt[it + "Id"], Mt[it + "Index"] = tt[it + "Index"], Mt[it + "Name"] = tt[it + "Name"];
              var kt = { mainType: it, query: Mt };
              pt && (kt.subType = pt);
              var Gt = tt.excludeSeriesId, Ot;
              Gt != null && (Ot = Ps(), Ye2(xp(Gt), function(ae2) {
                var de2 = Q0(ae2, null);
                de2 != null && Ot.set(de2, true);
              })), mt && mt.eachComponent(kt, function(ae2) {
                var de2 = Ot && Ot.get(ae2.id) !== null;
                if (!de2)
                  if (GK(tt))
                    if (ae2 instanceof zv)
                      tt.type === pR && !tt.notBlur && !ae2.get(["emphasis", "disabled"]) && Td2(ae2, tt, Z3._api);
                    else {
                      var we2 = Lut(ae2.mainType, ae2.componentIndex, tt.name, Z3._api), Se2 = we2.focusSelf, Oe2 = we2.dispatchers;
                      tt.type === pR && Se2 && !tt.notBlur && Put(ae2.mainType, ae2.componentIndex, Z3._api), Oe2 && Ye2(Oe2, function(je2) {
                        tt.type === pR ? GI(je2) : HI(je2);
                      });
                    }
                  else
                    Nut(tt) && ae2 instanceof zv && (Njt(ae2, tt, Z3._api), w2t(ae2), JI(Z3));
              }, Z3), mt && mt.eachComponent(kt, function(ae2) {
                var de2 = Ot && Ot.get(ae2.id) !== null;
                de2 || ce2(Z3[it === "series" ? "_chartsMap" : "_componentsMap"][ae2.__viewId]);
              }, Z3);
              function ce2(ae2) {
                ae2 && ae2.__alive && ae2[X3] && ae2[X3](ae2.__model, mt, Z3._api, tt);
              }
            }, J8 = { prepareAndUpdate: function(Z3) {
              mX(this), J8.update.call(this, Z3, { optionChanged: Z3.newOption != null });
            }, update: function(Z3, X3) {
              var tt = this._model, it = this._api, pt = this._zr, mt = this._coordSysMgr, Mt = this._scheduler;
              if (tt) {
                tt.setUpdatePayload(Z3), Mt.restoreData(tt, Z3), Mt.performSeriesTasks(tt), mt.create(tt, it), Mt.performDataProcessorTasks(tt, Z3), uGt(this, tt), mt.update(tt, it), r5(tt), Mt.performVisualTasks(tt, Z3), fGt(this, tt, it, Z3, X3);
                var kt = tt.get("backgroundColor") || "transparent", Gt = tt.get("darkMode");
                pt.setBackgroundColor(kt), Gt != null && Gt !== "auto" && pt.setDarkMode(Gt), Ek.trigger("afterupdate", tt, it);
              }
            }, updateTransform: function(Z3) {
              var X3 = this, tt = this._model, it = this._api;
              if (tt) {
                tt.setUpdatePayload(Z3);
                var pt = [];
                tt.eachComponent(function(Mt, kt) {
                  if (Mt !== "series") {
                    var Gt = X3.getViewOfComponentModel(kt);
                    if (Gt && Gt.__alive)
                      if (Gt.updateTransform) {
                        var Ot = Gt.updateTransform(kt, tt, it, Z3);
                        Ot && Ot.update && pt.push(Gt);
                      } else
                        pt.push(Gt);
                  }
                });
                var mt = Ps();
                tt.eachSeries(function(Mt) {
                  var kt = X3._chartsMap[Mt.__viewId];
                  if (kt.updateTransform) {
                    var Gt = kt.updateTransform(Mt, tt, it, Z3);
                    Gt && Gt.update && mt.set(Mt.uid, 1);
                  } else
                    mt.set(Mt.uid, 1);
                }), r5(tt), this._scheduler.performVisualTasks(tt, Z3, { setDirty: true, dirtyMap: mt }), bMt(this, tt, it, Z3, {}, mt), Ek.trigger("afterupdate", tt, it);
              }
            }, updateView: function(Z3) {
              var X3 = this._model;
              !X3 || (X3.setUpdatePayload(Z3), Ig2.markUpdateMethod(Z3, "updateView"), r5(X3), this._scheduler.performVisualTasks(X3, Z3, { setDirty: true }), fGt(this, X3, this._api, Z3, {}), Ek.trigger("afterupdate", X3, this._api));
            }, updateVisual: function(Z3) {
              var X3 = this, tt = this._model;
              !tt || (tt.setUpdatePayload(Z3), tt.eachSeries(function(it) {
                it.getData().clearAllVisual();
              }), Ig2.markUpdateMethod(Z3, "updateVisual"), r5(tt), this._scheduler.performVisualTasks(tt, Z3, { visualType: "visual", setDirty: true }), tt.eachComponent(function(it, pt) {
                if (it !== "series") {
                  var mt = X3.getViewOfComponentModel(pt);
                  mt && mt.__alive && mt.updateVisual(pt, tt, X3._api, Z3);
                }
              }), tt.eachSeries(function(it) {
                var pt = X3._chartsMap[it.__viewId];
                pt.updateVisual(it, tt, X3._api, Z3);
              }), Ek.trigger("afterupdate", tt, this._api));
            }, updateLayout: function(Z3) {
              J8.update.call(this, Z3);
            } }, lGt = function(Z3, X3, tt, it) {
              if (Z3._disposed) {
                Z3.id;
                return;
              }
              for (var pt = Z3._model, mt = Z3._coordSysMgr.getCoordinateSystems(), Mt, kt = Wj2(pt, tt), Gt = 0; Gt < mt.length; Gt++) {
                var Ot = mt[Gt];
                if (Ot[X3] && (Mt = Ot[X3](pt, kt, it)) != null)
                  return Mt;
              }
            }, uGt = function(Z3, X3) {
              var tt = Z3._chartsMap, it = Z3._scheduler;
              X3.eachSeries(function(pt) {
                it.updateStreamModes(pt, tt[pt.__viewId]);
              });
            }, cGt = function(Z3, X3) {
              var tt = this, it = this.getModel(), pt = Z3.type, mt = Z3.escapeConnect, Mt = _Mt[pt], kt = Mt.actionInfo, Gt = (kt.update || "update").split(":"), Ot = Gt.pop(), ce2 = Gt[0] != null && Vw(Gt[0]);
              this[$w] = true;
              var ae2 = [Z3], de2 = false;
              Z3.batch && (de2 = true, ae2 = Ha2(Z3.batch, function(An) {
                return An = Cl(sa2({}, An), Z3), An.batch = null, An;
              }));
              var we2 = [], Se2, Oe2 = Nut(Z3), je2 = GK(Z3);
              if (je2 && v22(this._api), Ye2(ae2, function(An) {
                if (Se2 = Mt.action(An, tt._model, tt._api), Se2 = Se2 || sa2({}, An), Se2.type = kt.event || Se2.type, we2.push(Se2), je2) {
                  var jn = rR(Z3), _n = jn.queryOptionMap, Jr = jn.mainTypeSpecified, Qn = Jr ? _n.keys()[0] : "series";
                  mMt(tt, Ot, An, Qn), JI(tt);
                } else
                  Oe2 ? (mMt(tt, Ot, An, "series"), JI(tt)) : ce2 && mMt(tt, Ot, An, ce2.main, ce2.sub);
              }), Ot !== "none" && !je2 && !Oe2 && !ce2)
                try {
                  this[TM] ? (mX(this), J8.update.call(this, Z3), this[TM] = null) : J8[Ot].call(this, Z3);
                } catch (An) {
                  throw this[$w] = false, An;
                }
              if (de2 ? Se2 = { type: kt.event || pt, escapeConnect: mt, batch: we2 } : Se2 = we2[0], this[$w] = false, !X3) {
                var rn = this._messageCenter;
                if (rn.trigger(Se2.type, Se2), Oe2) {
                  var qe2 = { type: "selectchanged", escapeConnect: mt, selected: Fjt(it), isFromClick: Z3.isFromClick || false, fromAction: Z3.type, fromActionPayload: Z3 };
                  rn.trigger(qe2.type, qe2);
                }
              }
            }, bct = function(Z3) {
              for (var X3 = this._pendingActions; X3.length; ) {
                var tt = X3.shift();
                cGt.call(this, tt, Z3);
              }
            }, _ct = function(Z3) {
              !Z3 && this.trigger("updated");
            }, oIe = function(Z3, X3) {
              Z3.on("rendered", function(tt) {
                X3.trigger("rendered", tt), Z3.animation.isFinished() && !X3[TM] && !X3._scheduler.unfinished && !X3._pendingActions.length && X3.trigger("finished");
              });
            }, sIe = function(Z3, X3) {
              Z3.on("mouseover", function(tt) {
                var it = tt.target, pt = gX(it, Xj2);
                pt && (x2t(pt, tt, X3._api), JI(X3));
              }).on("mouseout", function(tt) {
                var it = tt.target, pt = gX(it, Xj2);
                pt && (WK(pt, tt, X3._api), JI(X3));
              }).on("click", function(tt) {
                var it = tt.target, pt = gX(it, function(kt) {
                  return Pl(kt).dataIndex != null;
                }, true);
                if (pt) {
                  var mt = pt.selected ? "unselect" : "select", Mt = Pl(pt);
                  X3._api.dispatchAction({ type: mt, dataType: Mt.dataType, dataIndexInside: Mt.dataIndex, seriesIndex: Mt.seriesIndex, isFromClick: true });
                }
              });
            };
            function r5(Z3) {
              Z3.clearColorPalette(), Z3.eachSeries(function(X3) {
                X3.clearColorPalette();
              });
            }
            function g5(Z3) {
              var X3 = [], tt = [], it = false;
              if (Z3.eachComponent(function(kt, Gt) {
                var Ot = Gt.get("zlevel") || 0, ce2 = Gt.get("z") || 0, ae2 = Gt.getZLevelKey();
                it = it || !!ae2, (kt === "series" ? tt : X3).push({ zlevel: Ot, z: ce2, idx: Gt.componentIndex, type: kt, key: ae2 });
              }), it) {
                var pt = X3.concat(tt), mt, Mt;
                fx(pt, function(kt, Gt) {
                  return kt.zlevel === Gt.zlevel ? kt.z - Gt.z : kt.zlevel - Gt.zlevel;
                }), Ye2(pt, function(kt) {
                  var Gt = Z3.getComponent(kt.type, kt.idx), Ot = kt.zlevel, ce2 = kt.key;
                  mt != null && (Ot = Math.max(mt, Ot)), ce2 ? (Ot === mt && ce2 !== Mt && Ot++, Mt = ce2) : Mt && (Ot === mt && Ot++, Mt = ""), mt = Ot, Gt.setZLevel(Ot);
                });
              }
            }
            fGt = function(Z3, X3, tt, it, pt) {
              g5(X3), lIe(Z3, X3, tt, it, pt), Ye2(Z3._chartsViews, function(mt) {
                mt.__alive = false;
              }), bMt(Z3, X3, tt, it, pt), Ye2(Z3._chartsViews, function(mt) {
                mt.__alive || mt.remove(X3, tt);
              });
            }, lIe = function(Z3, X3, tt, it, pt, mt) {
              Ye2(mt || Z3._componentsViews, function(Mt) {
                var kt = Mt.__model;
                B3(kt, Mt), Mt.render(kt, X3, tt, it), k2(kt, Mt), G3(kt, Mt);
              });
            }, bMt = function(Z3, X3, tt, it, pt, mt) {
              var Mt = Z3._scheduler;
              pt = sa2(pt || {}, { updatedSeries: X3.getSeries() }), Ek.trigger("series:beforeupdate", X3, tt, pt);
              var kt = false;
              X3.eachSeries(function(Gt) {
                var Ot = Z3._chartsMap[Gt.__viewId];
                Ot.__alive = true;
                var ce2 = Ot.renderTask;
                Mt.updatePayload(ce2, it), B3(Gt, Ot), mt && mt.get(Gt.uid) && ce2.dirty(), ce2.perform(Mt.getPerformArgs(ce2)) && (kt = true), Ot.group.silent = !!Gt.get("silent"), A2(Gt, Ot), w2t(Gt);
              }), Mt.unfinished = kt || Mt.unfinished, Ek.trigger("series:layoutlabels", X3, tt, pt), Ek.trigger("series:transition", X3, tt, pt), X3.eachSeries(function(Gt) {
                var Ot = Z3._chartsMap[Gt.__viewId];
                k2(Gt, Ot), G3(Gt, Ot);
              }), S2(Z3, X3), Ek.trigger("series:afterupdate", X3, tt, pt);
            }, JI = function(Z3) {
              Z3[aGt] = true, Z3.getZr().wakeUp();
            }, fIe = function(Z3) {
              !Z3[aGt] || (Z3.getZr().storage.traverse(function(X3) {
                Z8(X3) || b6(X3);
              }), Z3[aGt] = false);
            };
            function b6(Z3) {
              for (var X3 = [], tt = Z3.currentStates, it = 0; it < tt.length; it++) {
                var pt = tt[it];
                pt === "emphasis" || pt === "blur" || pt === "select" || X3.push(pt);
              }
              Z3.selected && Z3.states.select && X3.push("select"), Z3.hoverState === FK && Z3.states.emphasis ? X3.push("emphasis") : Z3.hoverState === xv && Z3.states.blur && X3.push("blur"), Z3.useStates(X3);
            }
            function S2(Z3, X3) {
              var tt = Z3._zr, it = tt.storage, pt = 0;
              it.traverse(function(mt) {
                mt.isGroup || pt++;
              }), pt > X3.get("hoverLayerThreshold") && !os.node && !os.worker && X3.eachSeries(function(mt) {
                if (!mt.preventUsingHoverLayer) {
                  var Mt = Z3._chartsMap[mt.__viewId];
                  Mt.__alive && Mt.eachRendered(function(kt) {
                    kt.states.emphasis && (kt.states.emphasis.hoverLayer = true);
                  });
                }
              });
            }
            function A2(Z3, X3) {
              var tt = Z3.get("blendMode") || null;
              X3.eachRendered(function(it) {
                it.isGroup || (it.style.blend = tt);
              });
            }
            function k2(Z3, X3) {
              if (!Z3.preventAutoZ) {
                var tt = Z3.get("z") || 0, it = Z3.get("zlevel") || 0;
                X3.eachRendered(function(pt) {
                  return R6(pt, tt, it, -1 / 0), true;
                });
              }
            }
            function R6(Z3, X3, tt, it) {
              var pt = Z3.getTextContent(), mt = Z3.getTextGuideLine(), Mt = Z3.isGroup;
              if (Mt)
                for (var kt = Z3.childrenRef(), Gt = 0; Gt < kt.length; Gt++)
                  it = Math.max(R6(kt[Gt], X3, tt, it), it);
              else
                Z3.z = X3, Z3.zlevel = tt, it = Math.max(Z3.z2, it);
              if (pt && (pt.z = X3, pt.zlevel = tt, isFinite(it) && (pt.z2 = it + 2)), mt) {
                var Ot = Z3.textGuideLineConfig;
                mt.z = X3, mt.zlevel = tt, isFinite(it) && (mt.z2 = it + (Ot && Ot.showAbove ? 1 : -1));
              }
              return it;
            }
            function B3(Z3, X3) {
              X3.eachRendered(function(tt) {
                if (!Z8(tt)) {
                  var it = tt.getTextContent(), pt = tt.getTextGuideLine();
                  tt.stateTransition && (tt.stateTransition = null), it && it.stateTransition && (it.stateTransition = null), pt && pt.stateTransition && (pt.stateTransition = null), tt.hasState() ? (tt.prevStates = tt.currentStates, tt.clearStates()) : tt.prevStates && (tt.prevStates = null);
                }
              });
            }
            function G3(Z3, X3) {
              var tt = Z3.getModel("stateAnimation"), it = Z3.isAnimationEnabled(), pt = tt.get("duration"), mt = pt > 0 ? { duration: pt, delay: tt.get("delay"), easing: tt.get("easing") } : null;
              X3.eachRendered(function(Mt) {
                if (Mt.states && Mt.states.emphasis) {
                  if (Z8(Mt))
                    return;
                  if (Mt instanceof Tc2 && jjt(Mt), Mt.__dirty) {
                    var kt = Mt.prevStates;
                    kt && Mt.useStates(kt);
                  }
                  if (it) {
                    Mt.stateTransition = mt;
                    var Gt = Mt.getTextContent(), Ot = Mt.getTextGuideLine();
                    Gt && (Gt.stateTransition = mt), Ot && (Ot.stateTransition = mt);
                  }
                  Mt.__dirty && b6(Mt);
                }
              });
            }
            uIe = function(Z3) {
              return new (function(X3) {
                wn(tt, X3);
                function tt() {
                  return X3 !== null && X3.apply(this, arguments) || this;
                }
                return tt.prototype.getCoordinateSystems = function() {
                  return Z3._coordSysMgr.getCoordinateSystems();
                }, tt.prototype.getComponentByElement = function(it) {
                  for (; it; ) {
                    var pt = it.__ecComponentInfo;
                    if (pt != null)
                      return Z3._model.getComponent(pt.mainType, pt.index);
                    it = it.parent;
                  }
                }, tt.prototype.enterEmphasis = function(it, pt) {
                  GI(it, pt), JI(Z3);
                }, tt.prototype.leaveEmphasis = function(it, pt) {
                  HI(it, pt), JI(Z3);
                }, tt.prototype.enterBlur = function(it) {
                  _2t(it), JI(Z3);
                }, tt.prototype.leaveBlur = function(it) {
                  Eut(it), JI(Z3);
                }, tt.prototype.enterSelect = function(it) {
                  UI(it), JI(Z3);
                }, tt.prototype.leaveSelect = function(it) {
                  Ef2(it), JI(Z3);
                }, tt.prototype.getModel = function() {
                  return Z3.getModel();
                }, tt.prototype.getViewOfComponentModel = function(it) {
                  return Z3.getViewOfComponentModel(it);
                }, tt.prototype.getViewOfSeriesModel = function(it) {
                  return Z3.getViewOfSeriesModel(it);
                }, tt;
              }(xTe))(Z3);
            }, cIe = function(Z3) {
              function X3(tt, it) {
                for (var pt = 0; pt < tt.length; pt++) {
                  var mt = tt[pt];
                  mt[oGt] = it;
                }
              }
              Ye2(xct, function(tt, it) {
                Z3._messageCenter.on(it, function(pt) {
                  if (dIe[Z3.group] && Z3[oGt] !== tIe) {
                    if (pt && pt.escapeConnect)
                      return;
                    var mt = Z3.makeActionFromEvent(pt), Mt = [];
                    Ye2(wct, function(kt) {
                      kt !== Z3 && kt.group === Z3.group && Mt.push(kt);
                    }), X3(Mt, tIe), Ye2(Mt, function(kt) {
                      kt[oGt] !== JFn && kt.dispatchAction(mt);
                    }), X3(Mt, t8n);
                  }
                });
              });
            };
          }(), s;
        }(Lw), hGt = hIe.prototype;
        hGt.on = eIe("on"), hGt.off = eIe("off"), hGt.one = function(c5, s, r5) {
          var g5 = this;
          function b6() {
            for (var S2 = [], A2 = 0; A2 < arguments.length; A2++)
              S2[A2] = arguments[A2];
            s && s.apply && s.apply(this, S2), g5.off(c5, b6);
          }
          this.on.call(this, c5, b6, r5);
        };
        var e8n = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"], _Mt = {}, xct = {}, pGt = [], dGt = [], xMt = [], pIe = {}, gGt = {}, wct = {}, dIe = {}, n8n = +new Date() - 0, vGt = "_echarts_instance_";
        function r8n(c5, s, r5) {
          var g5 = !(r5 && r5.ssr);
          if (g5) {
            var b6 = i8n(c5);
            if (b6)
              return b6;
          }
          var S2 = new hIe(c5, s, r5);
          return S2.id = "ec_" + n8n++, wct[S2.id] = S2, g5 && BSt(c5, vGt, S2.id), cIe(S2), Ek.trigger("afterinit", S2), S2;
        }
        function i8n(c5) {
          return wct[Zzt(c5, vGt)];
        }
        function gIe(c5, s) {
          pIe[c5] = s;
        }
        function vIe(c5) {
          Lu(dGt, c5) < 0 && dGt.push(c5);
        }
        function yIe(c5, s) {
          mGt(pGt, c5, s, UFn);
        }
        function a8n(c5) {
          yGt("afterinit", c5);
        }
        function o8n(c5) {
          yGt("afterupdate", c5);
        }
        function yGt(c5, s) {
          Ek.on(c5, s);
        }
        function E3(c5, s, r5) {
          Tl(s) && (r5 = s, s = "");
          var g5 = Wl(c5) ? c5.type : [c5, c5 = { event: s }][0];
          c5.event = (c5.event || g5).toLowerCase(), s = c5.event, !xct[s] && (lx(JAe.test(g5) && JAe.test(s)), _Mt[g5] || (_Mt[g5] = { action: r5, actionInfo: c5 }), xct[s] = g5);
        }
        function s8n(c5, s) {
          oct.register(c5, s);
        }
        function l8n(c5, s) {
          mGt(xMt, c5, s, KAe, "layout");
        }
        function pW(c5, s) {
          mGt(xMt, c5, s, XAe, "visual");
        }
        var mIe = [];
        function mGt(c5, s, r5, g5, b6) {
          if ((Tl(s) || Wl(s)) && (r5 = s, s = g5), !(Lu(mIe, r5) >= 0)) {
            mIe.push(r5);
            var S2 = SAe.wrapStageHandler(r5, b6);
            S2.__prio = s, S2.__raw = r5, c5.push(S2);
          }
        }
        function bIe(c5, s) {
          gGt[c5] = s;
        }
        function u8n(c5, s, r5) {
          var g5 = BFn("registerMap");
          g5 && g5(c5, s, r5);
        }
        var c8n = mNn;
        pW(iGt, GNn), pW(yMt, HNn), pW(yMt, UNn), pW(iGt, oFn), pW(yMt, sFn), pW(QAe, NFn), vIe(ITe), yIe(GFn, Q6n), bIe("default", qNn), E3({ type: pR, event: pR, update: pR }, I0), E3({ type: VK, event: VK, update: VK }, I0), E3({ type: dR, event: dR, update: dR }, I0), E3({ type: BK, event: BK, update: BK }, I0), E3({ type: g2, event: g2, update: g2 }, I0), gIe("light", rFn), gIe("dark", iFn);
        var _Ie = [], f8n = { registerPreprocessor: vIe, registerProcessor: yIe, registerPostInit: a8n, registerPostUpdate: o8n, registerUpdateLifecycle: yGt, registerAction: E3, registerCoordinateSystem: s8n, registerLayout: l8n, registerVisual: pW, registerTransform: c8n, registerLoading: bIe, registerMap: u8n, registerImpl: VFn, PRIORITY: QFn, ComponentModel: Rh2, ComponentView: P0, SeriesModel: zv, ChartView: Ig2, registerComponentModel: function(c5) {
          Rh2.registerClass(c5);
        }, registerComponentView: function(c5) {
          P0.registerClass(c5);
        }, registerSeriesModel: function(c5) {
          zv.registerClass(c5);
        }, registerChartView: function(c5) {
          Ig2.registerClass(c5);
        }, registerSubTypeDefaulter: function(c5, s) {
          Rh2.registerSubTypeDefaulter(c5, s);
        }, registerPainter: function(c5, s) {
          ESt(c5, s);
        } };
        function Fc2(c5) {
          if (ja2(c5)) {
            Ye2(c5, function(s) {
              Fc2(s);
            });
            return;
          }
          Lu(_Ie, c5) >= 0 || (_Ie.push(c5), Tl(c5) && (c5 = { install: c5 }), c5.install(f8n));
        }
        function Sct(c5) {
          return c5 == null ? 0 : c5.length || 1;
        }
        function xIe(c5) {
          return c5;
        }
        var h8n = function() {
          function c5(s, r5, g5, b6, S2, A2) {
            this._old = s, this._new = r5, this._oldKeyGetter = g5 || xIe, this._newKeyGetter = b6 || xIe, this.context = S2, this._diffModeMultiple = A2 === "multiple";
          }
          return c5.prototype.add = function(s) {
            return this._add = s, this;
          }, c5.prototype.update = function(s) {
            return this._update = s, this;
          }, c5.prototype.updateManyToOne = function(s) {
            return this._updateManyToOne = s, this;
          }, c5.prototype.updateOneToMany = function(s) {
            return this._updateOneToMany = s, this;
          }, c5.prototype.updateManyToMany = function(s) {
            return this._updateManyToMany = s, this;
          }, c5.prototype.remove = function(s) {
            return this._remove = s, this;
          }, c5.prototype.execute = function() {
            this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
          }, c5.prototype._executeOneToOne = function() {
            var s = this._old, r5 = this._new, g5 = {}, b6 = new Array(s.length), S2 = new Array(r5.length);
            this._initIndexMap(s, null, b6, "_oldKeyGetter"), this._initIndexMap(r5, g5, S2, "_newKeyGetter");
            for (var A2 = 0; A2 < s.length; A2++) {
              var k2 = b6[A2], R6 = g5[k2], B3 = Sct(R6);
              if (B3 > 1) {
                var G3 = R6.shift();
                R6.length === 1 && (g5[k2] = R6[0]), this._update && this._update(G3, A2);
              } else
                B3 === 1 ? (g5[k2] = null, this._update && this._update(R6, A2)) : this._remove && this._remove(A2);
            }
            this._performRestAdd(S2, g5);
          }, c5.prototype._executeMultiple = function() {
            var s = this._old, r5 = this._new, g5 = {}, b6 = {}, S2 = [], A2 = [];
            this._initIndexMap(s, g5, S2, "_oldKeyGetter"), this._initIndexMap(r5, b6, A2, "_newKeyGetter");
            for (var k2 = 0; k2 < S2.length; k2++) {
              var R6 = S2[k2], B3 = g5[R6], G3 = b6[R6], Z3 = Sct(B3), X3 = Sct(G3);
              if (Z3 > 1 && X3 === 1)
                this._updateManyToOne && this._updateManyToOne(G3, B3), b6[R6] = null;
              else if (Z3 === 1 && X3 > 1)
                this._updateOneToMany && this._updateOneToMany(G3, B3), b6[R6] = null;
              else if (Z3 === 1 && X3 === 1)
                this._update && this._update(G3, B3), b6[R6] = null;
              else if (Z3 > 1 && X3 > 1)
                this._updateManyToMany && this._updateManyToMany(G3, B3), b6[R6] = null;
              else if (Z3 > 1)
                for (var tt = 0; tt < Z3; tt++)
                  this._remove && this._remove(B3[tt]);
              else
                this._remove && this._remove(B3);
            }
            this._performRestAdd(A2, b6);
          }, c5.prototype._performRestAdd = function(s, r5) {
            for (var g5 = 0; g5 < s.length; g5++) {
              var b6 = s[g5], S2 = r5[b6], A2 = Sct(S2);
              if (A2 > 1)
                for (var k2 = 0; k2 < A2; k2++)
                  this._add && this._add(S2[k2]);
              else
                A2 === 1 && this._add && this._add(S2);
              r5[b6] = null;
            }
          }, c5.prototype._initIndexMap = function(s, r5, g5, b6) {
            for (var S2 = this._diffModeMultiple, A2 = 0; A2 < s.length; A2++) {
              var k2 = "_ec_" + this[b6](s[A2], A2);
              if (S2 || (g5[A2] = k2), !!r5) {
                var R6 = r5[k2], B3 = Sct(R6);
                B3 === 0 ? (r5[k2] = A2, S2 && g5.push(k2)) : B3 === 1 ? r5[k2] = [R6, A2] : R6.push(A2);
              }
            }
          }, c5;
        }(), wR = h8n, p8n = function() {
          function c5(s, r5) {
            this._encode = s, this._schema = r5;
          }
          return c5.prototype.get = function() {
            return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
          }, c5.prototype._getFullDimensionNames = function() {
            return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
          }, c5;
        }();
        function d8n(c5, s) {
          var r5 = {}, g5 = r5.encode = {}, b6 = Ps(), S2 = [], A2 = [], k2 = {};
          Ye2(c5.dimensions, function(X3) {
            var tt = c5.getDimensionInfo(X3), it = tt.coordDim;
            if (it) {
              var pt = tt.coordDimIndex;
              bGt(g5, it)[pt] = X3, tt.isExtraCoord || (b6.set(it, 1), g8n(tt.type) && (S2[0] = X3), bGt(k2, it)[pt] = c5.getDimensionIndex(tt.name)), tt.defaultTooltip && A2.push(X3);
            }
            oTe.each(function(mt, Mt) {
              var kt = bGt(g5, Mt), Gt = tt.otherDims[Mt];
              Gt != null && Gt !== false && (kt[Gt] = tt.name);
            });
          });
          var R6 = [], B3 = {};
          b6.each(function(X3, tt) {
            var it = g5[tt];
            B3[tt] = it[0], R6 = R6.concat(it);
          }), r5.dataDimsOnCoord = R6, r5.dataDimIndicesOnCoord = Ha2(R6, function(X3) {
            return c5.getDimensionInfo(X3).storeDimIndex;
          }), r5.encodeFirstDimNotExtra = B3;
          var G3 = g5.label;
          G3 && G3.length && (S2 = G3.slice());
          var Z3 = g5.tooltip;
          return Z3 && Z3.length ? A2 = Z3.slice() : A2.length || (A2 = S2.slice()), g5.defaultedLabel = S2, g5.defaultedTooltip = A2, r5.userOutput = new p8n(k2, s), r5;
        }
        function bGt(c5, s) {
          return c5.hasOwnProperty(s) || (c5[s] = []), c5[s];
        }
        function wMt(c5) {
          return c5 === "category" ? "ordinal" : c5 === "time" ? "time" : "float";
        }
        function g8n(c5) {
          return !(c5 === "ordinal" || c5 === "time");
        }
        var v8n = function() {
          function c5(s) {
            this.otherDims = {}, s != null && sa2(this, s);
          }
          return c5;
        }(), SMt = v8n, y8n = Df2(), m8n = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, wIe = function() {
          function c5(s) {
            this.dimensions = s.dimensions, this._dimOmitted = s.dimensionOmitted, this.source = s.source, this._fullDimCount = s.fullDimensionCount, this._updateDimOmitted(s.dimensionOmitted);
          }
          return c5.prototype.isDimensionOmitted = function() {
            return this._dimOmitted;
          }, c5.prototype._updateDimOmitted = function(s) {
            this._dimOmitted = s, s && (this._dimNameMap || (this._dimNameMap = CIe(this.source)));
          }, c5.prototype.getSourceDimensionIndex = function(s) {
            return tc2(this._dimNameMap.get(s), -1);
          }, c5.prototype.getSourceDimension = function(s) {
            var r5 = this.source.dimensionsDefine;
            if (r5)
              return r5[s];
          }, c5.prototype.makeStoreSchema = function() {
            for (var s = this._fullDimCount, r5 = PTe(this.source), g5 = !TIe(s), b6 = "", S2 = [], A2 = 0, k2 = 0; A2 < s; A2++) {
              var R6 = void 0, B3 = void 0, G3 = void 0, Z3 = this.dimensions[k2];
              if (Z3 && Z3.storeDimIndex === A2)
                R6 = r5 ? Z3.name : null, B3 = Z3.type, G3 = Z3.ordinalMeta, k2++;
              else {
                var X3 = this.getSourceDimension(A2);
                X3 && (R6 = r5 ? X3.name : null, B3 = X3.type);
              }
              S2.push({ property: R6, type: B3, ordinalMeta: G3 }), r5 && R6 != null && (!Z3 || !Z3.isCalculationCoord) && (b6 += g5 ? R6.replace(/\`/g, "`1").replace(/\$/g, "`2") : R6), b6 += "$", b6 += m8n[B3] || "f", G3 && (b6 += G3.uid), b6 += "$";
            }
            var tt = this.source, it = [tt.seriesLayoutBy, tt.startIndex, b6].join("$$");
            return { dimensions: S2, hash: it };
          }, c5.prototype.makeOutputDimensionNames = function() {
            for (var s = [], r5 = 0, g5 = 0; r5 < this._fullDimCount; r5++) {
              var b6 = void 0, S2 = this.dimensions[g5];
              if (S2 && S2.storeDimIndex === r5)
                S2.isCalculationCoord || (b6 = S2.name), g5++;
              else {
                var A2 = this.getSourceDimension(r5);
                A2 && (b6 = A2.name);
              }
              s.push(b6);
            }
            return s;
          }, c5.prototype.appendCalculationDimension = function(s) {
            this.dimensions.push(s), s.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
          }, c5;
        }();
        function SIe(c5) {
          return c5 instanceof wIe;
        }
        function MIe(c5) {
          for (var s = Ps(), r5 = 0; r5 < (c5 || []).length; r5++) {
            var g5 = c5[r5], b6 = Wl(g5) ? g5.name : g5;
            b6 != null && s.get(b6) == null && s.set(b6, r5);
          }
          return s;
        }
        function CIe(c5) {
          var s = y8n(c5);
          return s.dimNameMap || (s.dimNameMap = MIe(c5.dimensionsDefine));
        }
        function TIe(c5) {
          return c5 > 30;
        }
        var Mct = Wl, t9 = Ha2, b8n = typeof Int32Array == "undefined" ? Array : Int32Array, _8n = "e\0\0", AIe = -1, x8n = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], w8n = ["_approximateExtent"], IIe, MMt, Cct, Tct, _Gt, CMt, xGt, S8n = function() {
          function c5(s, r5) {
            this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
            var g5, b6 = false;
            SIe(s) ? (g5 = s.dimensions, this._dimOmitted = s.isDimensionOmitted(), this._schema = s) : (b6 = true, g5 = s), g5 = g5 || ["x", "y"];
            for (var S2 = {}, A2 = [], k2 = {}, R6 = false, B3 = {}, G3 = 0; G3 < g5.length; G3++) {
              var Z3 = g5[G3], X3 = gs(Z3) ? new SMt({ name: Z3 }) : Z3 instanceof SMt ? Z3 : new SMt(Z3), tt = X3.name;
              X3.type = X3.type || "float", X3.coordDim || (X3.coordDim = tt, X3.coordDimIndex = 0);
              var it = X3.otherDims = X3.otherDims || {};
              A2.push(tt), S2[tt] = X3, B3[tt] != null && (R6 = true), X3.createInvertedIndices && (k2[tt] = []), it.itemName === 0 && (this._nameDimIdx = G3), it.itemId === 0 && (this._idDimIdx = G3), b6 && (X3.storeDimIndex = G3);
            }
            if (this.dimensions = A2, this._dimInfos = S2, this._initGetDimensionInfo(R6), this.hostModel = r5, this._invertedIndicesMap = k2, this._dimOmitted) {
              var pt = this._dimIdxToName = Ps();
              Ye2(A2, function(mt) {
                pt.set(S2[mt].storeDimIndex, mt);
              });
            }
          }
          return c5.prototype.getDimension = function(s) {
            var r5 = this._recognizeDimIndex(s);
            if (r5 == null)
              return s;
            if (r5 = s, !this._dimOmitted)
              return this.dimensions[r5];
            var g5 = this._dimIdxToName.get(r5);
            if (g5 != null)
              return g5;
            var b6 = this._schema.getSourceDimension(r5);
            if (b6)
              return b6.name;
          }, c5.prototype.getDimensionIndex = function(s) {
            var r5 = this._recognizeDimIndex(s);
            if (r5 != null)
              return r5;
            if (s == null)
              return -1;
            var g5 = this._getDimInfo(s);
            return g5 ? g5.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(s) : -1;
          }, c5.prototype._recognizeDimIndex = function(s) {
            if (Oh2(s) || s != null && !isNaN(s) && !this._getDimInfo(s) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(s) < 0))
              return +s;
          }, c5.prototype._getStoreDimIndex = function(s) {
            var r5 = this.getDimensionIndex(s);
            return r5;
          }, c5.prototype.getDimensionInfo = function(s) {
            return this._getDimInfo(this.getDimension(s));
          }, c5.prototype._initGetDimensionInfo = function(s) {
            var r5 = this._dimInfos;
            this._getDimInfo = s ? function(g5) {
              return r5.hasOwnProperty(g5) ? r5[g5] : void 0;
            } : function(g5) {
              return r5[g5];
            };
          }, c5.prototype.getDimensionsOnCoord = function() {
            return this._dimSummary.dataDimsOnCoord.slice();
          }, c5.prototype.mapDimension = function(s, r5) {
            var g5 = this._dimSummary;
            if (r5 == null)
              return g5.encodeFirstDimNotExtra[s];
            var b6 = g5.encode[s];
            return b6 ? b6[r5] : null;
          }, c5.prototype.mapDimensionsAll = function(s) {
            var r5 = this._dimSummary, g5 = r5.encode[s];
            return (g5 || []).slice();
          }, c5.prototype.getStore = function() {
            return this._store;
          }, c5.prototype.initData = function(s, r5, g5) {
            var b6 = this, S2;
            if (s instanceof HWt && (S2 = s), !S2) {
              var A2 = this.dimensions, k2 = NWt(s) || Fb2(s) ? new RTe(s, A2.length) : s;
              S2 = new HWt();
              var R6 = t9(A2, function(B3) {
                return { type: b6._dimInfos[B3].type, property: B3 };
              });
              S2.initData(k2, R6, g5);
            }
            this._store = S2, this._nameList = (r5 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, S2.count()), this._dimSummary = d8n(this, this._schema), this.userOutput = this._dimSummary.userOutput;
          }, c5.prototype.appendData = function(s) {
            var r5 = this._store.appendData(s);
            this._doInit(r5[0], r5[1]);
          }, c5.prototype.appendValues = function(s, r5) {
            var g5 = this._store.appendValues(s, r5.length), b6 = g5.start, S2 = g5.end, A2 = this._shouldMakeIdFromName();
            if (this._updateOrdinalMeta(), r5)
              for (var k2 = b6; k2 < S2; k2++) {
                var R6 = k2 - b6;
                this._nameList[k2] = r5[R6], A2 && xGt(this, k2);
              }
          }, c5.prototype._updateOrdinalMeta = function() {
            for (var s = this._store, r5 = this.dimensions, g5 = 0; g5 < r5.length; g5++) {
              var b6 = this._dimInfos[r5[g5]];
              b6.ordinalMeta && s.collectOrdinalMeta(b6.storeDimIndex, b6.ordinalMeta);
            }
          }, c5.prototype._shouldMakeIdFromName = function() {
            var s = this._store.getProvider();
            return this._idDimIdx == null && s.getSource().sourceFormat !== K8 && !s.fillStorage;
          }, c5.prototype._doInit = function(s, r5) {
            if (!(s >= r5)) {
              var g5 = this._store, b6 = g5.getProvider();
              this._updateOrdinalMeta();
              var S2 = this._nameList, A2 = this._idList, k2 = b6.getSource().sourceFormat, R6 = k2 === KI;
              if (R6 && !b6.pure)
                for (var B3 = [], G3 = s; G3 < r5; G3++) {
                  var Z3 = b6.getItem(G3, B3);
                  if (!this.hasItemOption && $lt(Z3) && (this.hasItemOption = true), Z3) {
                    var X3 = Z3.name;
                    S2[G3] == null && X3 != null && (S2[G3] = Q0(X3, null));
                    var tt = Z3.id;
                    A2[G3] == null && tt != null && (A2[G3] = Q0(tt, null));
                  }
                }
              if (this._shouldMakeIdFromName())
                for (var G3 = s; G3 < r5; G3++)
                  xGt(this, G3);
              IIe(this);
            }
          }, c5.prototype.getApproximateExtent = function(s) {
            return this._approximateExtent[s] || this._store.getDataExtent(this._getStoreDimIndex(s));
          }, c5.prototype.setApproximateExtent = function(s, r5) {
            r5 = this.getDimension(r5), this._approximateExtent[r5] = s.slice();
          }, c5.prototype.getCalculationInfo = function(s) {
            return this._calculationInfo[s];
          }, c5.prototype.setCalculationInfo = function(s, r5) {
            Mct(s) ? sa2(this._calculationInfo, s) : this._calculationInfo[s] = r5;
          }, c5.prototype.getName = function(s) {
            var r5 = this.getRawIndex(s), g5 = this._nameList[r5];
            return g5 == null && this._nameDimIdx != null && (g5 = Cct(this, this._nameDimIdx, r5)), g5 == null && (g5 = ""), g5;
          }, c5.prototype._getCategory = function(s, r5) {
            var g5 = this._store.get(s, r5), b6 = this._store.getOrdinalMeta(s);
            return b6 ? b6.categories[g5] : g5;
          }, c5.prototype.getId = function(s) {
            return MMt(this, this.getRawIndex(s));
          }, c5.prototype.count = function() {
            return this._store.count();
          }, c5.prototype.get = function(s, r5) {
            var g5 = this._store, b6 = this._dimInfos[s];
            if (b6)
              return g5.get(b6.storeDimIndex, r5);
          }, c5.prototype.getByRawIndex = function(s, r5) {
            var g5 = this._store, b6 = this._dimInfos[s];
            if (b6)
              return g5.getByRawIndex(b6.storeDimIndex, r5);
          }, c5.prototype.getIndices = function() {
            return this._store.getIndices();
          }, c5.prototype.getDataExtent = function(s) {
            return this._store.getDataExtent(this._getStoreDimIndex(s));
          }, c5.prototype.getSum = function(s) {
            return this._store.getSum(this._getStoreDimIndex(s));
          }, c5.prototype.getMedian = function(s) {
            return this._store.getMedian(this._getStoreDimIndex(s));
          }, c5.prototype.getValues = function(s, r5) {
            var g5 = this, b6 = this._store;
            return ja2(s) ? b6.getValues(t9(s, function(S2) {
              return g5._getStoreDimIndex(S2);
            }), r5) : b6.getValues(s);
          }, c5.prototype.hasValue = function(s) {
            for (var r5 = this._dimSummary.dataDimIndicesOnCoord, g5 = 0, b6 = r5.length; g5 < b6; g5++)
              if (isNaN(this._store.get(r5[g5], s)))
                return false;
            return true;
          }, c5.prototype.indexOfName = function(s) {
            for (var r5 = 0, g5 = this._store.count(); r5 < g5; r5++)
              if (this.getName(r5) === s)
                return r5;
            return -1;
          }, c5.prototype.getRawIndex = function(s) {
            return this._store.getRawIndex(s);
          }, c5.prototype.indexOfRawIndex = function(s) {
            return this._store.indexOfRawIndex(s);
          }, c5.prototype.rawIndexOf = function(s, r5) {
            var g5 = s && this._invertedIndicesMap[s], b6 = g5[r5];
            return b6 == null || isNaN(b6) ? AIe : b6;
          }, c5.prototype.indicesOfNearest = function(s, r5, g5) {
            return this._store.indicesOfNearest(this._getStoreDimIndex(s), r5, g5);
          }, c5.prototype.each = function(s, r5, g5) {
            Tl(s) && (g5 = r5, r5 = s, s = []);
            var b6 = g5 || this, S2 = t9(Tct(s), this._getStoreDimIndex, this);
            this._store.each(S2, b6 ? Cs(r5, b6) : r5);
          }, c5.prototype.filterSelf = function(s, r5, g5) {
            Tl(s) && (g5 = r5, r5 = s, s = []);
            var b6 = g5 || this, S2 = t9(Tct(s), this._getStoreDimIndex, this);
            return this._store = this._store.filter(S2, b6 ? Cs(r5, b6) : r5), this;
          }, c5.prototype.selectRange = function(s) {
            var r5 = this, g5 = {}, b6 = nf2(s);
            return Ye2(b6, function(S2) {
              var A2 = r5._getStoreDimIndex(S2);
              g5[A2] = s[S2];
            }), this._store = this._store.selectRange(g5), this;
          }, c5.prototype.mapArray = function(s, r5, g5) {
            Tl(s) && (g5 = r5, r5 = s, s = []), g5 = g5 || this;
            var b6 = [];
            return this.each(s, function() {
              b6.push(r5 && r5.apply(this, arguments));
            }, g5), b6;
          }, c5.prototype.map = function(s, r5, g5, b6) {
            var S2 = g5 || b6 || this, A2 = t9(Tct(s), this._getStoreDimIndex, this), k2 = CMt(this);
            return k2._store = this._store.map(A2, S2 ? Cs(r5, S2) : r5), k2;
          }, c5.prototype.modify = function(s, r5, g5, b6) {
            var S2 = g5 || b6 || this, A2 = t9(Tct(s), this._getStoreDimIndex, this);
            this._store.modify(A2, S2 ? Cs(r5, S2) : r5);
          }, c5.prototype.downSample = function(s, r5, g5, b6) {
            var S2 = CMt(this);
            return S2._store = this._store.downSample(this._getStoreDimIndex(s), r5, g5, b6), S2;
          }, c5.prototype.lttbDownSample = function(s, r5) {
            var g5 = CMt(this);
            return g5._store = this._store.lttbDownSample(this._getStoreDimIndex(s), r5), g5;
          }, c5.prototype.getRawDataItem = function(s) {
            return this._store.getRawDataItem(s);
          }, c5.prototype.getItemModel = function(s) {
            var r5 = this.hostModel, g5 = this.getRawDataItem(s);
            return new Ag2(g5, r5, r5 && r5.ecModel);
          }, c5.prototype.diff = function(s) {
            var r5 = this;
            return new wR(s ? s.getStore().getIndices() : [], this.getStore().getIndices(), function(g5) {
              return MMt(s, g5);
            }, function(g5) {
              return MMt(r5, g5);
            });
          }, c5.prototype.getVisual = function(s) {
            var r5 = this._visual;
            return r5 && r5[s];
          }, c5.prototype.setVisual = function(s, r5) {
            this._visual = this._visual || {}, Mct(s) ? sa2(this._visual, s) : this._visual[s] = r5;
          }, c5.prototype.getItemVisual = function(s, r5) {
            var g5 = this._itemVisuals[s], b6 = g5 && g5[r5];
            return b6 == null ? this.getVisual(r5) : b6;
          }, c5.prototype.hasItemVisual = function() {
            return this._itemVisuals.length > 0;
          }, c5.prototype.ensureUniqueItemVisual = function(s, r5) {
            var g5 = this._itemVisuals, b6 = g5[s];
            b6 || (b6 = g5[s] = {});
            var S2 = b6[r5];
            return S2 == null && (S2 = this.getVisual(r5), ja2(S2) ? S2 = S2.slice() : Mct(S2) && (S2 = sa2({}, S2)), b6[r5] = S2), S2;
          }, c5.prototype.setItemVisual = function(s, r5, g5) {
            var b6 = this._itemVisuals[s] || {};
            this._itemVisuals[s] = b6, Mct(r5) ? sa2(b6, r5) : b6[r5] = g5;
          }, c5.prototype.clearAllVisual = function() {
            this._visual = {}, this._itemVisuals = [];
          }, c5.prototype.setLayout = function(s, r5) {
            Mct(s) ? sa2(this._layout, s) : this._layout[s] = r5;
          }, c5.prototype.getLayout = function(s) {
            return this._layout[s];
          }, c5.prototype.getItemLayout = function(s) {
            return this._itemLayouts[s];
          }, c5.prototype.setItemLayout = function(s, r5, g5) {
            this._itemLayouts[s] = g5 ? sa2(this._itemLayouts[s] || {}, r5) : r5;
          }, c5.prototype.clearItemLayouts = function() {
            this._itemLayouts.length = 0;
          }, c5.prototype.setItemGraphicEl = function(s, r5) {
            var g5 = this.hostModel && this.hostModel.seriesIndex;
            Cut(g5, this.dataType, s, r5), this._graphicEls[s] = r5;
          }, c5.prototype.getItemGraphicEl = function(s) {
            return this._graphicEls[s];
          }, c5.prototype.eachItemGraphicEl = function(s, r5) {
            Ye2(this._graphicEls, function(g5, b6) {
              g5 && s && s.call(r5, g5, b6);
            });
          }, c5.prototype.cloneShallow = function(s) {
            return s || (s = new c5(this._schema ? this._schema : t9(this.dimensions, this._getDimInfo, this), this.hostModel)), _Gt(s, this), s._store = this._store, s;
          }, c5.prototype.wrapMethod = function(s, r5) {
            var g5 = this[s];
            !Tl(g5) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(s), this[s] = function() {
              var b6 = g5.apply(this, arguments);
              return r5.apply(this, [b6].concat(Qst(arguments)));
            });
          }, c5.internalField = function() {
            IIe = function(s) {
              var r5 = s._invertedIndicesMap;
              Ye2(r5, function(g5, b6) {
                var S2 = s._dimInfos[b6], A2 = S2.ordinalMeta, k2 = s._store;
                if (A2) {
                  g5 = r5[b6] = new b8n(A2.categories.length);
                  for (var R6 = 0; R6 < g5.length; R6++)
                    g5[R6] = AIe;
                  for (var R6 = 0; R6 < k2.count(); R6++)
                    g5[k2.get(S2.storeDimIndex, R6)] = R6;
                }
              });
            }, Cct = function(s, r5, g5) {
              return Q0(s._getCategory(r5, g5), null);
            }, MMt = function(s, r5) {
              var g5 = s._idList[r5];
              return g5 == null && s._idDimIdx != null && (g5 = Cct(s, s._idDimIdx, r5)), g5 == null && (g5 = _8n + r5), g5;
            }, Tct = function(s) {
              return ja2(s) || (s = s != null ? [s] : []), s;
            }, CMt = function(s) {
              var r5 = new c5(s._schema ? s._schema : t9(s.dimensions, s._getDimInfo, s), s.hostModel);
              return _Gt(r5, s), r5;
            }, _Gt = function(s, r5) {
              Ye2(x8n.concat(r5.__wrappedMethods || []), function(g5) {
                r5.hasOwnProperty(g5) && (s[g5] = r5[g5]);
              }), s.__wrappedMethods = r5.__wrappedMethods, Ye2(w8n, function(g5) {
                s[g5] = Ml(r5[g5]);
              }), s._calculationInfo = sa2({}, r5._calculationInfo);
            }, xGt = function(s, r5) {
              var g5 = s._nameList, b6 = s._idList, S2 = s._nameDimIdx, A2 = s._idDimIdx, k2 = g5[r5], R6 = b6[r5];
              if (k2 == null && S2 != null && (g5[r5] = k2 = Cct(s, S2, r5)), R6 == null && A2 != null && (b6[r5] = R6 = Cct(s, A2, r5)), R6 == null && k2 != null) {
                var B3 = s._nameRepeatCount, G3 = B3[k2] = (B3[k2] || 0) + 1;
                R6 = k2, G3 > 1 && (R6 += "__ec__" + G3), b6[r5] = R6;
              }
            };
          }(), c5;
        }(), m22 = S8n;
        function Act(c5, s) {
          NWt(c5) || (c5 = VWt(c5)), s = s || {};
          var r5 = s.coordDimensions || [], g5 = s.dimensionsDefine || c5.dimensionsDefine || [], b6 = Ps(), S2 = [], A2 = C8n(c5, r5, g5, s.dimensionsCount), k2 = s.canOmitUnusedDimensions && TIe(A2), R6 = g5 === c5.dimensionsDefine, B3 = R6 ? CIe(c5) : MIe(g5), G3 = s.encodeDefine;
          !G3 && s.encodeDefaulter && (G3 = s.encodeDefaulter(c5, A2));
          for (var Z3 = Ps(G3), X3 = new ZTe(A2), tt = 0; tt < X3.length; tt++)
            X3[tt] = -1;
          function it(Se2) {
            var Oe2 = X3[Se2];
            if (Oe2 < 0) {
              var je2 = g5[Se2], rn = Wl(je2) ? je2 : { name: je2 }, qe2 = new SMt(), An = rn.name;
              An != null && B3.get(An) != null && (qe2.name = qe2.displayName = An), rn.type != null && (qe2.type = rn.type), rn.displayName != null && (qe2.displayName = rn.displayName);
              var jn = S2.length;
              return X3[Se2] = jn, qe2.storeDimIndex = Se2, S2.push(qe2), qe2;
            }
            return S2[Oe2];
          }
          if (!k2)
            for (var tt = 0; tt < A2; tt++)
              it(tt);
          Z3.each(function(Se2, Oe2) {
            var je2 = xp(Se2).slice();
            if (je2.length === 1 && !gs(je2[0]) && je2[0] < 0) {
              Z3.set(Oe2, false);
              return;
            }
            var rn = Z3.set(Oe2, []);
            Ye2(je2, function(qe2, An) {
              var jn = gs(qe2) ? B3.get(qe2) : qe2;
              jn != null && jn < A2 && (rn[An] = jn, mt(it(jn), Oe2, An));
            });
          });
          var pt = 0;
          Ye2(r5, function(Se2) {
            var Oe2, je2, rn, qe2;
            if (gs(Se2))
              Oe2 = Se2, qe2 = {};
            else {
              qe2 = Se2, Oe2 = qe2.name;
              var An = qe2.ordinalMeta;
              qe2.ordinalMeta = null, qe2 = sa2({}, qe2), qe2.ordinalMeta = An, je2 = qe2.dimsDef, rn = qe2.otherDims, qe2.name = qe2.coordDim = qe2.coordDimIndex = qe2.dimsDef = qe2.otherDims = null;
            }
            var jn = Z3.get(Oe2);
            if (jn !== false) {
              if (jn = xp(jn), !jn.length)
                for (var _n = 0; _n < (je2 && je2.length || 1); _n++) {
                  for (; pt < A2 && it(pt).coordDim != null; )
                    pt++;
                  pt < A2 && jn.push(pt++);
                }
              Ye2(jn, function(Jr, Qn) {
                var rr = it(Jr);
                if (R6 && qe2.type != null && (rr.type = qe2.type), mt(Cl(rr, qe2), Oe2, Qn), rr.name == null && je2) {
                  var Ar = je2[Qn];
                  !Wl(Ar) && (Ar = { name: Ar }), rr.name = rr.displayName = Ar.name, rr.defaultTooltip = Ar.defaultTooltip;
                }
                rn && Cl(rr.otherDims, rn);
              });
            }
          });
          function mt(Se2, Oe2, je2) {
            oTe.get(Oe2) != null ? Se2.otherDims[Oe2] = je2 : (Se2.coordDim = Oe2, Se2.coordDimIndex = je2, b6.set(Oe2, true));
          }
          var Mt = s.generateCoord, kt = s.generateCoordCount, Gt = kt != null;
          kt = Mt ? kt || 1 : 0;
          var Ot = Mt || "value";
          function ce2(Se2) {
            Se2.name == null && (Se2.name = Se2.coordDim);
          }
          if (k2)
            Ye2(S2, function(Se2) {
              ce2(Se2);
            }), S2.sort(function(Se2, Oe2) {
              return Se2.storeDimIndex - Oe2.storeDimIndex;
            });
          else
            for (var ae2 = 0; ae2 < A2; ae2++) {
              var de2 = it(ae2), we2 = de2.coordDim;
              we2 == null && (de2.coordDim = T8n(Ot, b6, Gt), de2.coordDimIndex = 0, (!Mt || kt <= 0) && (de2.isExtraCoord = true), kt--), ce2(de2), de2.type == null && (cTe(c5, ae2) === xx.Must || de2.isExtraCoord && (de2.otherDims.itemName != null || de2.otherDims.seriesName != null)) && (de2.type = "ordinal");
            }
          return M8n(S2), new wIe({ source: c5, dimensions: S2, fullDimensionCount: A2, dimensionOmitted: k2 });
        }
        function M8n(c5) {
          for (var s = Ps(), r5 = 0; r5 < c5.length; r5++) {
            var g5 = c5[r5], b6 = g5.name, S2 = s.get(b6) || 0;
            S2 > 0 && (g5.name = b6 + (S2 - 1)), S2++, s.set(b6, S2);
          }
        }
        function C8n(c5, s, r5, g5) {
          var b6 = Math.max(c5.dimensionsDetectedCount || 1, s.length, r5.length, g5 || 0);
          return Ye2(s, function(S2) {
            var A2;
            Wl(S2) && (A2 = S2.dimsDef) && (b6 = Math.max(b6, A2.length));
          }), b6;
        }
        function T8n(c5, s, r5) {
          var g5 = s.data;
          if (r5 || g5.hasOwnProperty(c5)) {
            for (var b6 = 0; g5.hasOwnProperty(c5 + b6); )
              b6++;
            c5 += b6;
          }
          return s.set(c5, true), c5;
        }
        var A8n = function() {
          function c5(s) {
            this.coordSysDims = [], this.axisMap = Ps(), this.categoryAxisMap = Ps(), this.coordSysName = s;
          }
          return c5;
        }();
        function I8n(c5) {
          var s = c5.get("coordinateSystem"), r5 = new A8n(s), g5 = D8n[s];
          if (g5)
            return g5(c5, r5, r5.axisMap, r5.categoryAxisMap), r5;
        }
        var D8n = { cartesian2d: function(c5, s, r5, g5) {
          var b6 = c5.getReferringComponents("xAxis", E0).models[0], S2 = c5.getReferringComponents("yAxis", E0).models[0];
          s.coordSysDims = ["x", "y"], r5.set("x", b6), r5.set("y", S2), bX(b6) && (g5.set("x", b6), s.firstCategoryDimIndex = 0), bX(S2) && (g5.set("y", S2), s.firstCategoryDimIndex == null && (s.firstCategoryDimIndex = 1));
        }, singleAxis: function(c5, s, r5, g5) {
          var b6 = c5.getReferringComponents("singleAxis", E0).models[0];
          s.coordSysDims = ["single"], r5.set("single", b6), bX(b6) && (g5.set("single", b6), s.firstCategoryDimIndex = 0);
        }, polar: function(c5, s, r5, g5) {
          var b6 = c5.getReferringComponents("polar", E0).models[0], S2 = b6.findAxisModel("radiusAxis"), A2 = b6.findAxisModel("angleAxis");
          s.coordSysDims = ["radius", "angle"], r5.set("radius", S2), r5.set("angle", A2), bX(S2) && (g5.set("radius", S2), s.firstCategoryDimIndex = 0), bX(A2) && (g5.set("angle", A2), s.firstCategoryDimIndex == null && (s.firstCategoryDimIndex = 1));
        }, geo: function(c5, s, r5, g5) {
          s.coordSysDims = ["lng", "lat"];
        }, parallel: function(c5, s, r5, g5) {
          var b6 = c5.ecModel, S2 = b6.getComponent("parallel", c5.get("parallelIndex")), A2 = s.coordSysDims = S2.dimensions.slice();
          Ye2(S2.parallelAxisIndex, function(k2, R6) {
            var B3 = b6.getComponent("parallelAxis", k2), G3 = A2[R6];
            r5.set(G3, B3), bX(B3) && (g5.set(G3, B3), s.firstCategoryDimIndex == null && (s.firstCategoryDimIndex = R6));
          });
        } };
        function bX(c5) {
          return c5.get("type") === "category";
        }
        function E8n(c5, s, r5) {
          r5 = r5 || {};
          var g5 = r5.byIndex, b6 = r5.stackedCoordDimension, S2, A2, k2;
          k8n(s) ? S2 = s : (A2 = s.schema, S2 = A2.dimensions, k2 = s.store);
          var R6 = !!(c5 && c5.get("stack")), B3, G3, Z3, X3;
          if (Ye2(S2, function(kt, Gt) {
            gs(kt) && (S2[Gt] = kt = { name: kt }), R6 && !kt.isExtraCoord && (!g5 && !B3 && kt.ordinalMeta && (B3 = kt), !G3 && kt.type !== "ordinal" && kt.type !== "time" && (!b6 || b6 === kt.coordDim) && (G3 = kt));
          }), G3 && !g5 && !B3 && (g5 = true), G3) {
            Z3 = "__\0ecstackresult_" + c5.id, X3 = "__\0ecstackedover_" + c5.id, B3 && (B3.createInvertedIndices = true);
            var tt = G3.coordDim, it = G3.type, pt = 0;
            Ye2(S2, function(kt) {
              kt.coordDim === tt && pt++;
            });
            var mt = { name: Z3, coordDim: tt, coordDimIndex: pt, type: it, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: S2.length }, Mt = { name: X3, coordDim: X3, coordDimIndex: pt + 1, type: it, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: S2.length + 1 };
            A2 ? (k2 && (mt.storeDimIndex = k2.ensureCalculationDimension(X3, it), Mt.storeDimIndex = k2.ensureCalculationDimension(Z3, it)), A2.appendCalculationDimension(mt), A2.appendCalculationDimension(Mt)) : (S2.push(mt), S2.push(Mt));
          }
          return { stackedDimension: G3 && G3.name, stackedByDimension: B3 && B3.name, isStackedByIndex: g5, stackedOverDimension: X3, stackResultDimension: Z3 };
        }
        function k8n(c5) {
          return !SIe(c5.schema);
        }
        function e9(c5, s) {
          return !!s && s === c5.getCalculationInfo("stackedDimension");
        }
        function DIe(c5, s) {
          return e9(c5, s) ? c5.getCalculationInfo("stackResultDimension") : s;
        }
        function P8n(c5, s) {
          var r5 = c5.get("coordinateSystem"), g5 = oct.get(r5), b6;
          return s && s.coordSysDims && (b6 = Ha2(s.coordSysDims, function(S2) {
            var A2 = { name: S2 }, k2 = s.axisMap.get(S2);
            if (k2) {
              var R6 = k2.get("type");
              A2.type = wMt(R6);
            }
            return A2;
          })), b6 || (b6 = g5 && (g5.getDimensionsInfo ? g5.getDimensionsInfo() : g5.dimensions.slice()) || ["x", "y"]), b6;
        }
        function L8n(c5, s, r5) {
          var g5, b6;
          return r5 && Ye2(c5, function(S2, A2) {
            var k2 = S2.coordDim, R6 = r5.categoryAxisMap.get(k2);
            R6 && (g5 == null && (g5 = A2), S2.ordinalMeta = R6.getOrdinalMeta(), s && (S2.createInvertedIndices = true)), S2.otherDims.itemName != null && (b6 = true);
          }), !b6 && g5 != null && (c5[g5].otherDims.itemName = 0), g5;
        }
        function SR(c5, s, r5) {
          r5 = r5 || {};
          var g5 = s.getSourceManager(), b6, S2 = false;
          c5 ? (S2 = true, b6 = VWt(c5)) : (b6 = g5.getSource(), S2 = b6.sourceFormat === KI);
          var A2 = I8n(s), k2 = P8n(s, A2), R6 = r5.useEncodeDefaulter, B3 = Tl(R6) ? R6 : R6 ? Au(uTe, k2, s) : null, G3 = { coordDimensions: k2, generateCoord: r5.generateCoord, encodeDefine: s.getEncode(), encodeDefaulter: B3, canOmitUnusedDimensions: !S2 }, Z3 = Act(b6, G3), X3 = L8n(Z3.dimensions, r5.createInvertedIndices, A2), tt = S2 ? null : g5.getSharedDataStore(Z3), it = E8n(s, { schema: Z3, store: tt }), pt = new m22(Z3, s);
          pt.setCalculationInfo(it);
          var mt = X3 != null && O8n(b6) ? function(Mt, kt, Gt, Ot) {
            return Ot === X3 ? Gt : this.defaultDimValueGetter(Mt, kt, Gt, Ot);
          } : null;
          return pt.hasItemOption = false, pt.initData(S2 ? b6 : tt, null, mt), pt;
        }
        function O8n(c5) {
          if (c5.sourceFormat === KI) {
            var s = R8n(c5.data || []);
            return !ja2(Sk(s));
          }
        }
        function R8n(c5) {
          for (var s = 0; s < c5.length && c5[s] == null; )
            s++;
          return c5[s];
        }
        var EIe = function() {
          function c5(s) {
            this._setting = s || {}, this._extent = [1 / 0, -1 / 0];
          }
          return c5.prototype.getSetting = function(s) {
            return this._setting[s];
          }, c5.prototype.unionExtent = function(s) {
            var r5 = this._extent;
            s[0] < r5[0] && (r5[0] = s[0]), s[1] > r5[1] && (r5[1] = s[1]);
          }, c5.prototype.unionExtentFromData = function(s, r5) {
            this.unionExtent(s.getApproximateExtent(r5));
          }, c5.prototype.getExtent = function() {
            return this._extent.slice();
          }, c5.prototype.setExtent = function(s, r5) {
            var g5 = this._extent;
            isNaN(s) || (g5[0] = s), isNaN(r5) || (g5[1] = r5);
          }, c5.prototype.isInExtentRange = function(s) {
            return this._extent[0] <= s && this._extent[1] >= s;
          }, c5.prototype.isBlank = function() {
            return this._isBlank;
          }, c5.prototype.setBlank = function(s) {
            this._isBlank = s;
          }, c5;
        }();
        TK(EIe);
        var MR = EIe, N8n = 0, F8n = function() {
          function c5(s) {
            this.categories = s.categories || [], this._needCollect = s.needCollect, this._deduplication = s.deduplication, this.uid = ++N8n;
          }
          return c5.createByAxisModel = function(s) {
            var r5 = s.option, g5 = r5.data, b6 = g5 && Ha2(g5, V8n);
            return new c5({ categories: b6, needCollect: !b6, deduplication: r5.dedplication !== false });
          }, c5.prototype.getOrdinal = function(s) {
            return this._getOrCreateMap().get(s);
          }, c5.prototype.parseAndCollect = function(s) {
            var r5, g5 = this._needCollect;
            if (!gs(s) && !g5)
              return s;
            if (g5 && !this._deduplication)
              return r5 = this.categories.length, this.categories[r5] = s, r5;
            var b6 = this._getOrCreateMap();
            return r5 = b6.get(s), r5 == null && (g5 ? (r5 = this.categories.length, this.categories[r5] = s, b6.set(s, r5)) : r5 = NaN), r5;
          }, c5.prototype._getOrCreateMap = function() {
            return this._map || (this._map = Ps(this.categories));
          }, c5;
        }();
        function V8n(c5) {
          return Wl(c5) && c5.value != null ? c5.value : c5 + "";
        }
        var wGt = F8n;
        function SGt(c5) {
          return c5.type === "interval" || c5.type === "log";
        }
        function B8n(c5, s, r5, g5) {
          var b6 = {}, S2 = c5[1] - c5[0], A2 = b6.interval = Ult(S2 / s, true);
          r5 != null && A2 < r5 && (A2 = b6.interval = r5), g5 != null && A2 > g5 && (A2 = b6.interval = g5);
          var k2 = b6.intervalPrecision = kIe(A2), R6 = b6.niceTickExtent = [c0(Math.ceil(c5[0] / A2) * A2, k2), c0(Math.floor(c5[1] / A2) * A2, k2)];
          return z8n(R6, c5), b6;
        }
        function MGt(c5) {
          var s = Math.pow(10, Hlt(c5)), r5 = c5 / s;
          return r5 ? r5 === 2 ? r5 = 3 : r5 === 3 ? r5 = 5 : r5 *= 2 : r5 = 1, c0(r5 * s);
        }
        function kIe(c5) {
          return XC(c5) + 2;
        }
        function PIe(c5, s, r5) {
          c5[s] = Math.max(Math.min(c5[s], r5[1]), r5[0]);
        }
        function z8n(c5, s) {
          !isFinite(c5[0]) && (c5[0] = s[0]), !isFinite(c5[1]) && (c5[1] = s[1]), PIe(c5, 0, s), PIe(c5, 1, s), c5[0] > c5[1] && (c5[0] = c5[1]);
        }
        function TMt(c5, s) {
          return c5 >= s[0] && c5 <= s[1];
        }
        function AMt(c5, s) {
          return s[1] === s[0] ? 0.5 : (c5 - s[0]) / (s[1] - s[0]);
        }
        function IMt(c5, s) {
          return c5 * (s[1] - s[0]) + s[0];
        }
        var LIe = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            g5.type = "ordinal";
            var b6 = g5.getSetting("ordinalMeta");
            return b6 || (b6 = new wGt({})), ja2(b6) && (b6 = new wGt({ categories: Ha2(b6, function(S2) {
              return Wl(S2) ? S2.value : S2;
            }) })), g5._ordinalMeta = b6, g5._extent = g5.getSetting("extent") || [0, b6.categories.length - 1], g5;
          }
          return s.prototype.parse = function(r5) {
            return gs(r5) ? this._ordinalMeta.getOrdinal(r5) : Math.round(r5);
          }, s.prototype.contain = function(r5) {
            return r5 = this.parse(r5), TMt(r5, this._extent) && this._ordinalMeta.categories[r5] != null;
          }, s.prototype.normalize = function(r5) {
            return r5 = this._getTickNumber(this.parse(r5)), AMt(r5, this._extent);
          }, s.prototype.scale = function(r5) {
            return r5 = Math.round(IMt(r5, this._extent)), this.getRawOrdinalNumber(r5);
          }, s.prototype.getTicks = function() {
            for (var r5 = [], g5 = this._extent, b6 = g5[0]; b6 <= g5[1]; )
              r5.push({ value: b6 }), b6++;
            return r5;
          }, s.prototype.getMinorTicks = function(r5) {
          }, s.prototype.setSortInfo = function(r5) {
            if (r5 == null) {
              this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
              return;
            }
            for (var g5 = r5.ordinalNumbers, b6 = this._ordinalNumbersByTick = [], S2 = this._ticksByOrdinalNumber = [], A2 = 0, k2 = this._ordinalMeta.categories.length, R6 = Math.min(k2, g5.length); A2 < R6; ++A2) {
              var B3 = g5[A2];
              b6[A2] = B3, S2[B3] = A2;
            }
            for (var G3 = 0; A2 < k2; ++A2) {
              for (; S2[G3] != null; )
                G3++;
              b6.push(G3), S2[G3] = A2;
            }
          }, s.prototype._getTickNumber = function(r5) {
            var g5 = this._ticksByOrdinalNumber;
            return g5 && r5 >= 0 && r5 < g5.length ? g5[r5] : r5;
          }, s.prototype.getRawOrdinalNumber = function(r5) {
            var g5 = this._ordinalNumbersByTick;
            return g5 && r5 >= 0 && r5 < g5.length ? g5[r5] : r5;
          }, s.prototype.getLabel = function(r5) {
            if (!this.isBlank()) {
              var g5 = this.getRawOrdinalNumber(r5.value), b6 = this._ordinalMeta.categories[g5];
              return b6 == null ? "" : b6 + "";
            }
          }, s.prototype.count = function() {
            return this._extent[1] - this._extent[0] + 1;
          }, s.prototype.unionExtentFromData = function(r5, g5) {
            this.unionExtent(r5.getApproximateExtent(g5));
          }, s.prototype.isInExtentRange = function(r5) {
            return r5 = this._getTickNumber(r5), this._extent[0] <= r5 && this._extent[1] >= r5;
          }, s.prototype.getOrdinalMeta = function() {
            return this._ordinalMeta;
          }, s.prototype.calcNiceTicks = function() {
          }, s.prototype.calcNiceExtent = function() {
          }, s.type = "ordinal", s;
        }(MR);
        MR.registerClass(LIe);
        var CGt = LIe, dW = c0, OIe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "interval", r5._interval = 0, r5._intervalPrecision = 2, r5;
          }
          return s.prototype.parse = function(r5) {
            return r5;
          }, s.prototype.contain = function(r5) {
            return TMt(r5, this._extent);
          }, s.prototype.normalize = function(r5) {
            return AMt(r5, this._extent);
          }, s.prototype.scale = function(r5) {
            return IMt(r5, this._extent);
          }, s.prototype.setExtent = function(r5, g5) {
            var b6 = this._extent;
            isNaN(r5) || (b6[0] = parseFloat(r5)), isNaN(g5) || (b6[1] = parseFloat(g5));
          }, s.prototype.unionExtent = function(r5) {
            var g5 = this._extent;
            r5[0] < g5[0] && (g5[0] = r5[0]), r5[1] > g5[1] && (g5[1] = r5[1]), this.setExtent(g5[0], g5[1]);
          }, s.prototype.getInterval = function() {
            return this._interval;
          }, s.prototype.setInterval = function(r5) {
            this._interval = r5, this._niceExtent = this._extent.slice(), this._intervalPrecision = kIe(r5);
          }, s.prototype.getTicks = function(r5) {
            var g5 = this._interval, b6 = this._extent, S2 = this._niceExtent, A2 = this._intervalPrecision, k2 = [];
            if (!g5)
              return k2;
            var R6 = 1e4;
            b6[0] < S2[0] && (r5 ? k2.push({ value: dW(S2[0] - g5, A2) }) : k2.push({ value: b6[0] }));
            for (var B3 = S2[0]; B3 <= S2[1] && (k2.push({ value: B3 }), B3 = dW(B3 + g5, A2), B3 !== k2[k2.length - 1].value); )
              if (k2.length > R6)
                return [];
            var G3 = k2.length ? k2[k2.length - 1].value : S2[1];
            return b6[1] > G3 && (r5 ? k2.push({ value: dW(G3 + g5, A2) }) : k2.push({ value: b6[1] })), k2;
          }, s.prototype.getMinorTicks = function(r5) {
            for (var g5 = this.getTicks(true), b6 = [], S2 = this.getExtent(), A2 = 1; A2 < g5.length; A2++) {
              for (var k2 = g5[A2], R6 = g5[A2 - 1], B3 = 0, G3 = [], Z3 = k2.value - R6.value, X3 = Z3 / r5; B3 < r5 - 1; ) {
                var tt = dW(R6.value + (B3 + 1) * X3);
                tt > S2[0] && tt < S2[1] && G3.push(tt), B3++;
              }
              b6.push(G3);
            }
            return b6;
          }, s.prototype.getLabel = function(r5, g5) {
            if (r5 == null)
              return "";
            var b6 = g5 && g5.precision;
            b6 == null ? b6 = XC(r5.value) || 0 : b6 === "auto" && (b6 = this._intervalPrecision);
            var S2 = dW(r5.value, b6, true);
            return JCe(S2);
          }, s.prototype.calcNiceTicks = function(r5, g5, b6) {
            r5 = r5 || 5;
            var S2 = this._extent, A2 = S2[1] - S2[0];
            if (isFinite(A2)) {
              A2 < 0 && (A2 = -A2, S2.reverse());
              var k2 = B8n(S2, r5, g5, b6);
              this._intervalPrecision = k2.intervalPrecision, this._interval = k2.interval, this._niceExtent = k2.niceTickExtent;
            }
          }, s.prototype.calcNiceExtent = function(r5) {
            var g5 = this._extent;
            if (g5[0] === g5[1])
              if (g5[0] !== 0) {
                var b6 = g5[0];
                r5.fixMax || (g5[1] += b6 / 2), g5[0] -= b6 / 2;
              } else
                g5[1] = 1;
            var S2 = g5[1] - g5[0];
            isFinite(S2) || (g5[0] = 0, g5[1] = 1), this.calcNiceTicks(r5.splitNumber, r5.minInterval, r5.maxInterval);
            var A2 = this._interval;
            r5.fixMin || (g5[0] = dW(Math.floor(g5[0] / A2) * A2)), r5.fixMax || (g5[1] = dW(Math.ceil(g5[1] / A2) * A2));
          }, s.prototype.setNiceExtent = function(r5, g5) {
            this._niceExtent = [r5, g5];
          }, s.type = "interval", s;
        }(MR);
        MR.registerClass(OIe);
        var n9 = OIe, RIe = typeof Float32Array != "undefined", j8n = RIe ? Float32Array : Array;
        function k3(c5) {
          return ja2(c5) ? RIe ? new Float32Array(c5) : c5 : new j8n(c5);
        }
        var TGt = "__ec_stack_";
        function AGt(c5) {
          return c5.get("stack") || TGt + c5.seriesIndex;
        }
        function IGt(c5) {
          return c5.dim + c5.index;
        }
        function W8n(c5) {
          var s = [], r5 = c5.axis, g5 = "axis0";
          if (r5.type === "category") {
            for (var b6 = r5.getBandWidth(), S2 = 0; S2 < c5.count; S2++)
              s.push(Cl({ bandWidth: b6, axisKey: g5, stackId: TGt + S2 }, c5));
            for (var A2 = VIe(s), k2 = [], S2 = 0; S2 < c5.count; S2++) {
              var R6 = A2[g5][TGt + S2];
              R6.offsetCenter = R6.offset + R6.width / 2, k2.push(R6);
            }
            return k2;
          }
        }
        function NIe(c5, s) {
          var r5 = [];
          return s.eachSeriesByType(c5, function(g5) {
            jIe(g5) && r5.push(g5);
          }), r5;
        }
        function G8n(c5) {
          var s = {};
          Ye2(c5, function(R6) {
            var B3 = R6.coordinateSystem, G3 = B3.getBaseAxis();
            if (!(G3.type !== "time" && G3.type !== "value"))
              for (var Z3 = R6.getData(), X3 = G3.dim + "_" + G3.index, tt = Z3.getDimensionIndex(Z3.mapDimension(G3.dim)), it = Z3.getStore(), pt = 0, mt = it.count(); pt < mt; ++pt) {
                var Mt = it.get(tt, pt);
                s[X3] ? s[X3].push(Mt) : s[X3] = [Mt];
              }
          });
          var r5 = {};
          for (var g5 in s)
            if (s.hasOwnProperty(g5)) {
              var b6 = s[g5];
              if (b6) {
                b6.sort(function(R6, B3) {
                  return R6 - B3;
                });
                for (var S2 = null, A2 = 1; A2 < b6.length; ++A2) {
                  var k2 = b6[A2] - b6[A2 - 1];
                  k2 > 0 && (S2 = S2 === null ? k2 : Math.min(S2, k2));
                }
                r5[g5] = S2;
              }
            }
          return r5;
        }
        function FIe(c5) {
          var s = G8n(c5), r5 = [];
          return Ye2(c5, function(g5) {
            var b6 = g5.coordinateSystem, S2 = b6.getBaseAxis(), A2 = S2.getExtent(), k2;
            if (S2.type === "category")
              k2 = S2.getBandWidth();
            else if (S2.type === "value" || S2.type === "time") {
              var R6 = S2.dim + "_" + S2.index, B3 = s[R6], G3 = Math.abs(A2[1] - A2[0]), Z3 = S2.scale.getExtent(), X3 = Math.abs(Z3[1] - Z3[0]);
              k2 = B3 ? G3 / X3 * B3 : G3;
            } else {
              var tt = g5.getData();
              k2 = Math.abs(A2[1] - A2[0]) / tt.count();
            }
            var it = $o(g5.get("barWidth"), k2), pt = $o(g5.get("barMaxWidth"), k2), mt = $o(g5.get("barMinWidth") || (WIe(g5) ? 0.5 : 1), k2), Mt = g5.get("barGap"), kt = g5.get("barCategoryGap");
            r5.push({ bandWidth: k2, barWidth: it, barMaxWidth: pt, barMinWidth: mt, barGap: Mt, barCategoryGap: kt, axisKey: IGt(S2), stackId: AGt(g5) });
          }), VIe(r5);
        }
        function VIe(c5) {
          var s = {};
          Ye2(c5, function(g5, b6) {
            var S2 = g5.axisKey, A2 = g5.bandWidth, k2 = s[S2] || { bandWidth: A2, remainedWidth: A2, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, R6 = k2.stacks;
            s[S2] = k2;
            var B3 = g5.stackId;
            R6[B3] || k2.autoWidthCount++, R6[B3] = R6[B3] || { width: 0, maxWidth: 0 };
            var G3 = g5.barWidth;
            G3 && !R6[B3].width && (R6[B3].width = G3, G3 = Math.min(k2.remainedWidth, G3), k2.remainedWidth -= G3);
            var Z3 = g5.barMaxWidth;
            Z3 && (R6[B3].maxWidth = Z3);
            var X3 = g5.barMinWidth;
            X3 && (R6[B3].minWidth = X3);
            var tt = g5.barGap;
            tt != null && (k2.gap = tt);
            var it = g5.barCategoryGap;
            it != null && (k2.categoryGap = it);
          });
          var r5 = {};
          return Ye2(s, function(g5, b6) {
            r5[b6] = {};
            var S2 = g5.stacks, A2 = g5.bandWidth, k2 = g5.categoryGap;
            if (k2 == null) {
              var R6 = nf2(S2).length;
              k2 = Math.max(35 - R6 * 4, 15) + "%";
            }
            var B3 = $o(k2, A2), G3 = $o(g5.gap, 1), Z3 = g5.remainedWidth, X3 = g5.autoWidthCount, tt = (Z3 - B3) / (X3 + (X3 - 1) * G3);
            tt = Math.max(tt, 0), Ye2(S2, function(Mt) {
              var kt = Mt.maxWidth, Gt = Mt.minWidth;
              if (Mt.width) {
                var Ot = Mt.width;
                kt && (Ot = Math.min(Ot, kt)), Gt && (Ot = Math.max(Ot, Gt)), Mt.width = Ot, Z3 -= Ot + G3 * Ot, X3--;
              } else {
                var Ot = tt;
                kt && kt < Ot && (Ot = Math.min(kt, Z3)), Gt && Gt > Ot && (Ot = Gt), Ot !== tt && (Mt.width = Ot, Z3 -= Ot + G3 * Ot, X3--);
              }
            }), tt = (Z3 - B3) / (X3 + (X3 - 1) * G3), tt = Math.max(tt, 0);
            var it = 0, pt;
            Ye2(S2, function(Mt, kt) {
              Mt.width || (Mt.width = tt), pt = Mt, it += Mt.width * (1 + G3);
            }), pt && (it -= pt.width * G3);
            var mt = -it / 2;
            Ye2(S2, function(Mt, kt) {
              r5[b6][kt] = r5[b6][kt] || { bandWidth: A2, offset: mt, width: Mt.width }, mt += Mt.width * (1 + G3);
            });
          }), r5;
        }
        function H8n(c5, s, r5) {
          if (c5 && s) {
            var g5 = c5[IGt(s)];
            return g5 != null && r5 != null ? g5[AGt(r5)] : g5;
          }
        }
        function BIe(c5, s) {
          var r5 = NIe(c5, s), g5 = FIe(r5);
          Ye2(r5, function(b6) {
            var S2 = b6.getData(), A2 = b6.coordinateSystem, k2 = A2.getBaseAxis(), R6 = AGt(b6), B3 = g5[IGt(k2)][R6], G3 = B3.offset, Z3 = B3.width;
            S2.setLayout({ bandWidth: B3.bandWidth, offset: G3, size: Z3 });
          });
        }
        function zIe(c5) {
          return { seriesType: c5, plan: hX(), reset: function(s) {
            if (jIe(s)) {
              var r5 = s.getData(), g5 = s.coordinateSystem, b6 = g5.getBaseAxis(), S2 = g5.getOtherAxis(b6), A2 = r5.getDimensionIndex(r5.mapDimension(S2.dim)), k2 = r5.getDimensionIndex(r5.mapDimension(b6.dim)), R6 = s.get("showBackground", true), B3 = r5.mapDimension(S2.dim), G3 = r5.getCalculationInfo("stackResultDimension"), Z3 = e9(r5, B3) && !!r5.getCalculationInfo("stackedOnSeries"), X3 = S2.isHorizontal(), tt = U8n(b6, S2), it = WIe(s), pt = s.get("barMinHeight") || 0, mt = G3 && r5.getDimensionIndex(G3), Mt = r5.getLayout("size"), kt = r5.getLayout("offset");
              return { progress: function(Gt, Ot) {
                for (var ce2 = Gt.count, ae2 = it && k3(ce2 * 3), de2 = it && R6 && k3(ce2 * 3), we2 = it && k3(ce2), Se2 = g5.master.getRect(), Oe2 = X3 ? Se2.width : Se2.height, je2, rn = Ot.getStore(), qe2 = 0; (je2 = Gt.next()) != null; ) {
                  var An = rn.get(Z3 ? mt : A2, je2), jn = rn.get(k2, je2), _n = tt, Jr = void 0;
                  Z3 && (Jr = +An - rn.get(A2, je2));
                  var Qn = void 0, rr = void 0, Ar = void 0, fi2 = void 0;
                  if (X3) {
                    var mi2 = g5.dataToPoint([An, jn]);
                    if (Z3) {
                      var Oo = g5.dataToPoint([Jr, jn]);
                      _n = Oo[0];
                    }
                    Qn = _n, rr = mi2[1] + kt, Ar = mi2[0] - _n, fi2 = Mt, Math.abs(Ar) < pt && (Ar = (Ar < 0 ? -1 : 1) * pt);
                  } else {
                    var mi2 = g5.dataToPoint([jn, An]);
                    if (Z3) {
                      var Oo = g5.dataToPoint([jn, Jr]);
                      _n = Oo[1];
                    }
                    Qn = mi2[0] + kt, rr = _n, Ar = Mt, fi2 = mi2[1] - _n, Math.abs(fi2) < pt && (fi2 = (fi2 <= 0 ? -1 : 1) * pt);
                  }
                  it ? (ae2[qe2] = Qn, ae2[qe2 + 1] = rr, ae2[qe2 + 2] = X3 ? Ar : fi2, de2 && (de2[qe2] = X3 ? Se2.x : Qn, de2[qe2 + 1] = X3 ? rr : Se2.y, de2[qe2 + 2] = Oe2), we2[je2] = je2) : Ot.setItemLayout(je2, { x: Qn, y: rr, width: Ar, height: fi2 }), qe2 += 3;
                }
                it && Ot.setLayout({ largePoints: ae2, largeDataIndices: we2, largeBackgroundPoints: de2, valueAxisHorizontal: X3 });
              } };
            }
          } };
        }
        function jIe(c5) {
          return c5.coordinateSystem && c5.coordinateSystem.type === "cartesian2d";
        }
        function WIe(c5) {
          return c5.pipelineContext && c5.pipelineContext.large;
        }
        function U8n(c5, s) {
          return s.toGlobalCoord(s.dataToCoord(s.type === "log" ? 1 : 0));
        }
        var q8n = function(c5, s, r5, g5) {
          for (; r5 < g5; ) {
            var b6 = r5 + g5 >>> 1;
            c5[b6][1] < s ? r5 = b6 + 1 : g5 = b6;
          }
          return r5;
        }, GIe = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "time", g5;
          }
          return s.prototype.getLabel = function(r5) {
            var g5 = this.getSetting("useUTC");
            return $2t(r5.value, GCe[p6n(rX(this._minLevelUnit))] || GCe.second, g5, this.getSetting("locale"));
          }, s.prototype.getFormattedLabel = function(r5, g5, b6) {
            var S2 = this.getSetting("useUTC"), A2 = this.getSetting("locale");
            return d6n(r5, g5, b6, A2, S2);
          }, s.prototype.getTicks = function() {
            var r5 = this._interval, g5 = this._extent, b6 = [];
            if (!r5)
              return b6;
            b6.push({ value: g5[0], level: 0 });
            var S2 = this.getSetting("useUTC"), A2 = J8n(this._minLevelUnit, this._approxInterval, S2, g5);
            return b6 = b6.concat(A2), b6.push({ value: g5[1], level: 0 }), b6;
          }, s.prototype.calcNiceExtent = function(r5) {
            var g5 = this._extent;
            if (g5[0] === g5[1] && (g5[0] -= YI, g5[1] += YI), g5[1] === -1 / 0 && g5[0] === 1 / 0) {
              var b6 = new Date();
              g5[1] = +new Date(b6.getFullYear(), b6.getMonth(), b6.getDate()), g5[0] = g5[1] - YI;
            }
            this.calcNiceTicks(r5.splitNumber, r5.minInterval, r5.maxInterval);
          }, s.prototype.calcNiceTicks = function(r5, g5, b6) {
            r5 = r5 || 10;
            var S2 = this._extent, A2 = S2[1] - S2[0];
            this._approxInterval = A2 / r5, g5 != null && this._approxInterval < g5 && (this._approxInterval = g5), b6 != null && this._approxInterval > b6 && (this._approxInterval = b6);
            var k2 = DMt.length, R6 = Math.min(q8n(DMt, this._approxInterval, 0, k2), k2 - 1);
            this._interval = DMt[R6][1], this._minLevelUnit = DMt[Math.max(R6 - 1, 0)][0];
          }, s.prototype.parse = function(r5) {
            return Oh2(r5) ? r5 : +QC(r5);
          }, s.prototype.contain = function(r5) {
            return TMt(this.parse(r5), this._extent);
          }, s.prototype.normalize = function(r5) {
            return AMt(this.parse(r5), this._extent);
          }, s.prototype.scale = function(r5) {
            return IMt(r5, this._extent);
          }, s.type = "time", s;
        }(n9), DMt = [["second", xWt], ["minute", wWt], ["hour", ect], ["quarter-day", ect * 6], ["half-day", ect * 12], ["day", YI * 1.2], ["half-week", YI * 3.5], ["week", YI * 7], ["month", YI * 31], ["quarter", YI * 95], ["half-year", WCe / 2], ["year", WCe]];
        function Z8n(c5, s, r5, g5) {
          var b6 = QC(s), S2 = QC(r5), A2 = function(it) {
            return qCe(b6, it, g5) === qCe(S2, it, g5);
          }, k2 = function() {
            return A2("year");
          }, R6 = function() {
            return k2() && A2("month");
          }, B3 = function() {
            return R6() && A2("day");
          }, G3 = function() {
            return B3() && A2("hour");
          }, Z3 = function() {
            return G3() && A2("minute");
          }, X3 = function() {
            return Z3() && A2("second");
          }, tt = function() {
            return X3() && A2("millisecond");
          };
          switch (c5) {
            case "year":
              return k2();
            case "month":
              return R6();
            case "day":
              return B3();
            case "hour":
              return G3();
            case "minute":
              return Z3();
            case "second":
              return X3();
            case "millisecond":
              return tt();
          }
        }
        function $8n(c5, s) {
          return c5 /= YI, c5 > 16 ? 16 : c5 > 7.5 ? 7 : c5 > 3.5 ? 4 : c5 > 1.5 ? 2 : 1;
        }
        function Y8n(c5) {
          var s = 30 * YI;
          return c5 /= s, c5 > 6 ? 6 : c5 > 3 ? 3 : c5 > 2 ? 2 : 1;
        }
        function K8n(c5) {
          return c5 /= ect, c5 > 12 ? 12 : c5 > 6 ? 6 : c5 > 3.5 ? 4 : c5 > 2 ? 2 : 1;
        }
        function HIe(c5, s) {
          return c5 /= s ? wWt : xWt, c5 > 30 ? 30 : c5 > 20 ? 20 : c5 > 15 ? 15 : c5 > 10 ? 10 : c5 > 5 ? 5 : c5 > 2 ? 2 : 1;
        }
        function X8n(c5) {
          return Ult(c5, true);
        }
        function Q8n(c5, s, r5) {
          var g5 = new Date(c5);
          switch (rX(s)) {
            case "year":
            case "month":
              g5[ZCe(r5)](0);
            case "day":
              g5[$Ce(r5)](1);
            case "hour":
              g5[YCe(r5)](0);
            case "minute":
              g5[KCe(r5)](0);
            case "second":
              g5[XCe(r5)](0), g5[QCe(r5)](0);
          }
          return g5.getTime();
        }
        function J8n(c5, s, r5, g5) {
          var b6 = 1e4, S2 = HCe, A2 = 0;
          function k2(Oe2, je2, rn, qe2, An, jn, _n) {
            for (var Jr = new Date(je2), Qn = je2, rr = Jr[qe2](); Qn < rn && Qn <= g5[1]; )
              _n.push({ value: Qn }), rr += Oe2, Jr[An](rr), Qn = Jr.getTime();
            _n.push({ value: Qn, notAdd: true });
          }
          function R6(Oe2, je2, rn) {
            var qe2 = [], An = !je2.length;
            if (!Z8n(rX(Oe2), g5[0], g5[1], r5)) {
              An && (je2 = [{ value: Q8n(new Date(g5[0]), Oe2, r5) }, { value: g5[1] }]);
              for (var jn = 0; jn < je2.length - 1; jn++) {
                var _n = je2[jn].value, Jr = je2[jn + 1].value;
                if (_n !== Jr) {
                  var Qn = void 0, rr = void 0, Ar = void 0, fi2 = false;
                  switch (Oe2) {
                    case "year":
                      Qn = Math.max(1, Math.round(s / YI / 365)), rr = MWt(r5), Ar = g6n(r5);
                      break;
                    case "half-year":
                    case "quarter":
                    case "month":
                      Qn = Y8n(s), rr = iX(r5), Ar = ZCe(r5);
                      break;
                    case "week":
                    case "half-week":
                    case "day":
                      Qn = $8n(s), rr = Y2t(r5), Ar = $Ce(r5), fi2 = true;
                      break;
                    case "half-day":
                    case "quarter-day":
                    case "hour":
                      Qn = K8n(s), rr = rct(r5), Ar = YCe(r5);
                      break;
                    case "minute":
                      Qn = HIe(s, true), rr = K2t(r5), Ar = KCe(r5);
                      break;
                    case "second":
                      Qn = HIe(s, false), rr = X2t(r5), Ar = XCe(r5);
                      break;
                    case "millisecond":
                      Qn = X8n(s), rr = Q2t(r5), Ar = QCe(r5);
                      break;
                  }
                  k2(Qn, _n, Jr, rr, Ar, fi2, qe2), Oe2 === "year" && rn.length > 1 && jn === 0 && rn.unshift({ value: rn[0].value - Qn });
                }
              }
              for (var jn = 0; jn < qe2.length; jn++)
                rn.push(qe2[jn]);
              return qe2;
            }
          }
          for (var B3 = [], G3 = [], Z3 = 0, X3 = 0, tt = 0; tt < S2.length && A2++ < b6; ++tt) {
            var it = rX(S2[tt]);
            if (h6n(S2[tt])) {
              R6(S2[tt], B3[B3.length - 1] || [], G3);
              var pt = S2[tt + 1] ? rX(S2[tt + 1]) : null;
              if (it !== pt) {
                if (G3.length) {
                  X3 = Z3, G3.sort(function(Oe2, je2) {
                    return Oe2.value - je2.value;
                  });
                  for (var mt = [], Mt = 0; Mt < G3.length; ++Mt) {
                    var kt = G3[Mt].value;
                    (Mt === 0 || G3[Mt - 1].value !== kt) && (mt.push(G3[Mt]), kt >= g5[0] && kt <= g5[1] && Z3++);
                  }
                  var Gt = (g5[1] - g5[0]) / s;
                  if (Z3 > Gt * 1.5 && X3 > Gt / 1.5 || (B3.push(mt), Z3 > Gt || c5 === S2[tt]))
                    break;
                }
                G3 = [];
              }
            }
          }
          for (var Ot = jp(Ha2(B3, function(je2) {
            return jp(je2, function(rn) {
              return rn.value >= g5[0] && rn.value <= g5[1] && !rn.notAdd;
            });
          }), function(je2) {
            return je2.length > 0;
          }), ce2 = [], ae2 = Ot.length - 1, tt = 0; tt < Ot.length; ++tt)
            for (var de2 = Ot[tt], we2 = 0; we2 < de2.length; ++we2)
              ce2.push({ value: de2[we2].value, level: ae2 - tt });
          ce2.sort(function(Oe2, je2) {
            return Oe2.value - je2.value;
          });
          for (var Se2 = [], tt = 0; tt < ce2.length; ++tt)
            (tt === 0 || ce2[tt].value !== ce2[tt - 1].value) && Se2.push(ce2[tt]);
          return Se2;
        }
        MR.registerClass(GIe);
        var UIe = GIe, qIe = MR.prototype, Ict = n9.prototype, t9n = c0, e9n = Math.floor, n9n = Math.ceil, EMt = Math.pow, tD = Math.log, DGt = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "log", r5.base = 10, r5._originalScale = new n9(), r5._interval = 0, r5;
          }
          return s.prototype.getTicks = function(r5) {
            var g5 = this._originalScale, b6 = this._extent, S2 = g5.getExtent(), A2 = Ict.getTicks.call(this, r5);
            return Ha2(A2, function(k2) {
              var R6 = k2.value, B3 = c0(EMt(this.base, R6));
              return B3 = R6 === b6[0] && this._fixMin ? kMt(B3, S2[0]) : B3, B3 = R6 === b6[1] && this._fixMax ? kMt(B3, S2[1]) : B3, { value: B3 };
            }, this);
          }, s.prototype.setExtent = function(r5, g5) {
            var b6 = this.base;
            r5 = tD(r5) / tD(b6), g5 = tD(g5) / tD(b6), Ict.setExtent.call(this, r5, g5);
          }, s.prototype.getExtent = function() {
            var r5 = this.base, g5 = qIe.getExtent.call(this);
            g5[0] = EMt(r5, g5[0]), g5[1] = EMt(r5, g5[1]);
            var b6 = this._originalScale, S2 = b6.getExtent();
            return this._fixMin && (g5[0] = kMt(g5[0], S2[0])), this._fixMax && (g5[1] = kMt(g5[1], S2[1])), g5;
          }, s.prototype.unionExtent = function(r5) {
            this._originalScale.unionExtent(r5);
            var g5 = this.base;
            r5[0] = tD(r5[0]) / tD(g5), r5[1] = tD(r5[1]) / tD(g5), qIe.unionExtent.call(this, r5);
          }, s.prototype.unionExtentFromData = function(r5, g5) {
            this.unionExtent(r5.getApproximateExtent(g5));
          }, s.prototype.calcNiceTicks = function(r5) {
            r5 = r5 || 10;
            var g5 = this._extent, b6 = g5[1] - g5[0];
            if (!(b6 === 1 / 0 || b6 <= 0)) {
              var S2 = Glt(b6), A2 = r5 / b6 * S2;
              for (A2 <= 0.5 && (S2 *= 10); !isNaN(S2) && Math.abs(S2) < 1 && Math.abs(S2) > 0; )
                S2 *= 10;
              var k2 = [c0(n9n(g5[0] / S2) * S2), c0(e9n(g5[1] / S2) * S2)];
              this._interval = S2, this._niceExtent = k2;
            }
          }, s.prototype.calcNiceExtent = function(r5) {
            Ict.calcNiceExtent.call(this, r5), this._fixMin = r5.fixMin, this._fixMax = r5.fixMax;
          }, s.prototype.parse = function(r5) {
            return r5;
          }, s.prototype.contain = function(r5) {
            return r5 = tD(r5) / tD(this.base), TMt(r5, this._extent);
          }, s.prototype.normalize = function(r5) {
            return r5 = tD(r5) / tD(this.base), AMt(r5, this._extent);
          }, s.prototype.scale = function(r5) {
            return r5 = IMt(r5, this._extent), EMt(this.base, r5);
          }, s.type = "log", s;
        }(MR), ZIe = DGt.prototype;
        ZIe.getMinorTicks = Ict.getMinorTicks, ZIe.getLabel = Ict.getLabel;
        function kMt(c5, s) {
          return t9n(c5, XC(s));
        }
        MR.registerClass(DGt);
        var r9n = DGt, i9n = function() {
          function c5(s, r5, g5) {
            this._prepareParams(s, r5, g5);
          }
          return c5.prototype._prepareParams = function(s, r5, g5) {
            g5[1] < g5[0] && (g5 = [NaN, NaN]), this._dataMin = g5[0], this._dataMax = g5[1];
            var b6 = this._isOrdinal = s.type === "ordinal";
            this._needCrossZero = s.type === "interval" && r5.getNeedCrossZero && r5.getNeedCrossZero();
            var S2 = this._modelMinRaw = r5.get("min", true);
            Tl(S2) ? this._modelMinNum = PMt(s, S2({ min: g5[0], max: g5[1] })) : S2 !== "dataMin" && (this._modelMinNum = PMt(s, S2));
            var A2 = this._modelMaxRaw = r5.get("max", true);
            if (Tl(A2) ? this._modelMaxNum = PMt(s, A2({ min: g5[0], max: g5[1] })) : A2 !== "dataMax" && (this._modelMaxNum = PMt(s, A2)), b6)
              this._axisDataLen = r5.getCategories().length;
            else {
              var k2 = r5.get("boundaryGap"), R6 = ja2(k2) ? k2 : [k2 || 0, k2 || 0];
              typeof R6[0] == "boolean" || typeof R6[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [f22(R6[0], 1), f22(R6[1], 1)];
            }
          }, c5.prototype.calculate = function() {
            var s = this._isOrdinal, r5 = this._dataMin, g5 = this._dataMax, b6 = this._axisDataLen, S2 = this._boundaryGapInner, A2 = s ? null : g5 - r5 || Math.abs(r5), k2 = this._modelMinRaw === "dataMin" ? r5 : this._modelMinNum, R6 = this._modelMaxRaw === "dataMax" ? g5 : this._modelMaxNum, B3 = k2 != null, G3 = R6 != null;
            k2 == null && (k2 = s ? b6 ? 0 : NaN : r5 - S2[0] * A2), R6 == null && (R6 = s ? b6 ? b6 - 1 : NaN : g5 + S2[1] * A2), (k2 == null || !isFinite(k2)) && (k2 = NaN), (R6 == null || !isFinite(R6)) && (R6 = NaN);
            var Z3 = fj2(k2) || fj2(R6) || s && !b6;
            this._needCrossZero && (k2 > 0 && R6 > 0 && !B3 && (k2 = 0), k2 < 0 && R6 < 0 && !G3 && (R6 = 0));
            var X3 = this._determinedMin, tt = this._determinedMax;
            return X3 != null && (k2 = X3, B3 = true), tt != null && (R6 = tt, G3 = true), { min: k2, max: R6, minFixed: B3, maxFixed: G3, isBlank: Z3 };
          }, c5.prototype.modifyDataMinMax = function(s, r5) {
            this[o9n[s]] = r5;
          }, c5.prototype.setDeterminedMinMax = function(s, r5) {
            var g5 = a9n[s];
            this[g5] = r5;
          }, c5.prototype.freeze = function() {
            this.frozen = true;
          }, c5;
        }(), a9n = { min: "_determinedMin", max: "_determinedMax" }, o9n = { min: "_dataMin", max: "_dataMax" };
        function $Ie(c5, s, r5) {
          var g5 = c5.rawExtentInfo;
          return g5 || (g5 = new i9n(c5, s, r5), c5.rawExtentInfo = g5, g5);
        }
        function PMt(c5, s) {
          return s == null ? null : fj2(s) ? NaN : c5.parse(s);
        }
        function YIe(c5, s) {
          var r5 = c5.type, g5 = $Ie(c5, s, c5.getExtent()).calculate();
          c5.setBlank(g5.isBlank);
          var b6 = g5.min, S2 = g5.max, A2 = s.ecModel;
          if (A2 && r5 === "time") {
            var k2 = NIe("bar", A2), R6 = false;
            if (Ye2(k2, function(Z3) {
              R6 = R6 || Z3.getBaseAxis() === s.axis;
            }), R6) {
              var B3 = FIe(k2), G3 = s9n(b6, S2, s, B3);
              b6 = G3.min, S2 = G3.max;
            }
          }
          return { extent: [b6, S2], fixMin: g5.minFixed, fixMax: g5.maxFixed };
        }
        function s9n(c5, s, r5, g5) {
          var b6 = r5.axis.getExtent(), S2 = b6[1] - b6[0], A2 = H8n(g5, r5.axis);
          if (A2 === void 0)
            return { min: c5, max: s };
          var k2 = 1 / 0;
          Ye2(A2, function(tt) {
            k2 = Math.min(tt.offset, k2);
          });
          var R6 = -1 / 0;
          Ye2(A2, function(tt) {
            R6 = Math.max(tt.offset + tt.width, R6);
          }), k2 = Math.abs(k2), R6 = Math.abs(R6);
          var B3 = k2 + R6, G3 = s - c5, Z3 = 1 - (k2 + R6) / S2, X3 = G3 / Z3 - G3;
          return s += X3 * (R6 / B3), c5 -= X3 * (k2 / B3), { min: c5, max: s };
        }
        function _X(c5, s) {
          var r5 = s, g5 = YIe(c5, r5), b6 = g5.extent, S2 = r5.get("splitNumber");
          c5 instanceof r9n && (c5.base = r5.get("logBase"));
          var A2 = c5.type, k2 = r5.get("interval"), R6 = A2 === "interval" || A2 === "time";
          c5.setExtent(b6[0], b6[1]), c5.calcNiceExtent({ splitNumber: S2, fixMin: g5.fixMin, fixMax: g5.fixMax, minInterval: R6 ? r5.get("minInterval") : null, maxInterval: R6 ? r5.get("maxInterval") : null }), k2 != null && c5.setInterval && c5.setInterval(k2);
        }
        function LMt(c5, s) {
          if (s = s || c5.get("type"), s)
            switch (s) {
              case "category":
                return new CGt({ ordinalMeta: c5.getOrdinalMeta ? c5.getOrdinalMeta() : c5.getCategories(), extent: [1 / 0, -1 / 0] });
              case "time":
                return new UIe({ locale: c5.ecModel.getLocaleModel(), useUTC: c5.ecModel.get("useUTC") });
              default:
                return new (MR.getClass(s) || n9)();
            }
        }
        function l9n(c5) {
          var s = c5.scale.getExtent(), r5 = s[0], g5 = s[1];
          return !(r5 > 0 && g5 > 0 || r5 < 0 && g5 < 0);
        }
        function Dct(c5) {
          var s = c5.getLabelModel().get("formatter"), r5 = c5.type === "category" ? c5.scale.getExtent()[0] : null;
          return c5.scale.type === "time" ? function(g5) {
            return function(b6, S2) {
              return c5.scale.getFormattedLabel(b6, S2, g5);
            };
          }(s) : gs(s) ? function(g5) {
            return function(b6) {
              var S2 = c5.scale.getLabel(b6), A2 = g5.replace("{value}", S2 != null ? S2 : "");
              return A2;
            };
          }(s) : Tl(s) ? function(g5) {
            return function(b6, S2) {
              return r5 != null && (S2 = b6.value - r5), g5(EGt(c5, b6), S2, b6.level != null ? { level: b6.level } : null);
            };
          }(s) : function(g5) {
            return c5.scale.getLabel(g5);
          };
        }
        function EGt(c5, s) {
          return c5.type === "category" ? c5.scale.getLabel(s) : s.value;
        }
        function u9n(c5) {
          var s = c5.model, r5 = c5.scale;
          if (!(!s.get(["axisLabel", "show"]) || r5.isBlank())) {
            var g5, b6, S2 = r5.getExtent();
            r5 instanceof CGt ? b6 = r5.count() : (g5 = r5.getTicks(), b6 = g5.length);
            var A2 = c5.getLabelModel(), k2 = Dct(c5), R6, B3 = 1;
            b6 > 40 && (B3 = Math.ceil(b6 / 40));
            for (var G3 = 0; G3 < b6; G3 += B3) {
              var Z3 = g5 ? g5[G3] : { value: S2[0] + G3 }, X3 = k2(Z3, G3), tt = A2.getTextRect(X3), it = c9n(tt, A2.get("rotate") || 0);
              R6 ? R6.union(it) : R6 = it;
            }
            return R6;
          }
        }
        function c9n(c5, s) {
          var r5 = s * Math.PI / 180, g5 = c5.width, b6 = c5.height, S2 = g5 * Math.abs(Math.cos(r5)) + Math.abs(b6 * Math.sin(r5)), A2 = g5 * Math.abs(Math.sin(r5)) + Math.abs(b6 * Math.cos(r5)), k2 = new lc2(c5.x, c5.y, S2, A2);
          return k2;
        }
        function kGt(c5) {
          var s = c5.get("interval");
          return s == null ? "auto" : s;
        }
        function KIe(c5) {
          return c5.type === "category" && kGt(c5.getLabelModel()) === 0;
        }
        function OMt(c5, s) {
          var r5 = {};
          return Ye2(c5.mapDimensionsAll(s), function(g5) {
            r5[DIe(c5, g5)] = true;
          }), nf2(r5);
        }
        function f9n(c5, s, r5) {
          s && Ye2(OMt(s, r5), function(g5) {
            var b6 = s.getApproximateExtent(g5);
            b6[0] < c5[0] && (c5[0] = b6[0]), b6[1] > c5[1] && (c5[1] = b6[1]);
          });
        }
        var Ect = function() {
          function c5() {
          }
          return c5.prototype.getNeedCrossZero = function() {
            var s = this.option;
            return !s.scale;
          }, c5.prototype.getCoordSysModel = function() {
          }, c5;
        }(), h9n = 1e-8;
        function XIe(c5, s) {
          return Math.abs(c5 - s) < h9n;
        }
        function gW(c5, s, r5) {
          var g5 = 0, b6 = c5[0];
          if (!b6)
            return false;
          for (var S2 = 1; S2 < c5.length; S2++) {
            var A2 = c5[S2];
            g5 += Ak(b6[0], b6[1], A2[0], A2[1], s, r5), b6 = A2;
          }
          var k2 = c5[0];
          return (!XIe(b6[0], k2[0]) || !XIe(b6[1], k2[1])) && (g5 += Ak(b6[0], b6[1], k2[0], k2[1], s, r5)), g5 !== 0;
        }
        var p9n = [];
        function PGt(c5, s) {
          for (var r5 = 0; r5 < c5.length; r5++)
            Gm(c5[r5], c5[r5], s);
        }
        function QIe(c5, s, r5, g5) {
          for (var b6 = 0; b6 < c5.length; b6++) {
            var S2 = c5[b6];
            g5 && (S2 = g5.project(S2)), S2 && isFinite(S2[0]) && isFinite(S2[1]) && (BC(s, s, S2), c2(r5, r5, S2));
          }
        }
        function d9n(c5) {
          for (var s = 0, r5 = 0, g5 = 0, b6 = c5.length, S2 = c5[b6 - 1][0], A2 = c5[b6 - 1][1], k2 = 0; k2 < b6; k2++) {
            var R6 = c5[k2][0], B3 = c5[k2][1], G3 = S2 * B3 - R6 * A2;
            s += G3, r5 += (S2 + R6) * G3, g5 += (A2 + B3) * G3, S2 = R6, A2 = B3;
          }
          return s ? [r5 / s / 3, g5 / s / 3, s] : [c5[0][0] || 0, c5[0][1] || 0];
        }
        var JIe = function() {
          function c5(s) {
            this.name = s;
          }
          return c5.prototype.setCenter = function(s) {
            this._center = s;
          }, c5.prototype.getCenter = function() {
            var s = this._center;
            return s || (s = this._center = this.calcCenter()), s;
          }, c5;
        }(), tDe = function() {
          function c5(s, r5) {
            this.type = "polygon", this.exterior = s, this.interiors = r5;
          }
          return c5;
        }(), eDe = function() {
          function c5(s) {
            this.type = "linestring", this.points = s;
          }
          return c5;
        }(), nDe = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this, r5) || this;
            return S2.type = "geoJSON", S2.geometries = g5, S2._center = b6 && [b6[0], b6[1]], S2;
          }
          return s.prototype.calcCenter = function() {
            for (var r5 = this.geometries, g5, b6 = 0, S2 = 0; S2 < r5.length; S2++) {
              var A2 = r5[S2], k2 = A2.exterior, R6 = k2 && k2.length;
              R6 > b6 && (g5 = A2, b6 = R6);
            }
            if (g5)
              return d9n(g5.exterior);
            var B3 = this.getBoundingRect();
            return [B3.x + B3.width / 2, B3.y + B3.height / 2];
          }, s.prototype.getBoundingRect = function(r5) {
            var g5 = this._rect;
            if (g5 && !r5)
              return g5;
            var b6 = [1 / 0, 1 / 0], S2 = [-1 / 0, -1 / 0], A2 = this.geometries;
            return Ye2(A2, function(k2) {
              k2.type === "polygon" ? QIe(k2.exterior, b6, S2, r5) : Ye2(k2.points, function(R6) {
                QIe(R6, b6, S2, r5);
              });
            }), isFinite(b6[0]) && isFinite(b6[1]) && isFinite(S2[0]) && isFinite(S2[1]) || (b6[0] = b6[1] = S2[0] = S2[1] = 0), g5 = new lc2(b6[0], b6[1], S2[0] - b6[0], S2[1] - b6[1]), r5 || (this._rect = g5), g5;
          }, s.prototype.contain = function(r5) {
            var g5 = this.getBoundingRect(), b6 = this.geometries;
            if (!g5.contain(r5[0], r5[1]))
              return false;
            t:
              for (var S2 = 0, A2 = b6.length; S2 < A2; S2++) {
                var k2 = b6[S2];
                if (k2.type === "polygon") {
                  var R6 = k2.exterior, B3 = k2.interiors;
                  if (gW(R6, r5[0], r5[1])) {
                    for (var G3 = 0; G3 < (B3 ? B3.length : 0); G3++)
                      if (gW(B3[G3], r5[0], r5[1]))
                        continue t;
                    return true;
                  }
                }
              }
            return false;
          }, s.prototype.transformTo = function(r5, g5, b6, S2) {
            var A2 = this.getBoundingRect(), k2 = A2.width / A2.height;
            b6 ? S2 || (S2 = b6 / k2) : b6 = k2 * S2;
            for (var R6 = new lc2(r5, g5, b6, S2), B3 = A2.calculateTransform(R6), G3 = this.geometries, Z3 = 0; Z3 < G3.length; Z3++) {
              var X3 = G3[Z3];
              X3.type === "polygon" ? (PGt(X3.exterior, B3), Ye2(X3.interiors, function(tt) {
                PGt(tt, B3);
              })) : Ye2(X3.points, function(tt) {
                PGt(tt, B3);
              });
            }
            A2 = this._rect, A2.copy(R6), this._center = [A2.x + A2.width / 2, A2.y + A2.height / 2];
          }, s.prototype.cloneShallow = function(r5) {
            r5 == null && (r5 = this.name);
            var g5 = new s(r5, this.geometries, this._center);
            return g5._rect = this._rect, g5.transformTo = null, g5;
          }, s;
        }(JIe), g9n = function(c5) {
          wn(s, c5);
          function s(r5, g5) {
            var b6 = c5.call(this, r5) || this;
            return b6.type = "geoSVG", b6._elOnlyForCalculate = g5, b6;
          }
          return s.prototype.calcCenter = function() {
            for (var r5 = this._elOnlyForCalculate, g5 = r5.getBoundingRect(), b6 = [g5.x + g5.width / 2, g5.y + g5.height / 2], S2 = Dj2(p9n), A2 = r5; A2 && !A2.isGeoSVGGraphicRoot; )
              _k(S2, A2.getLocalTransform(), S2), A2 = A2.parent;
            return Y4(S2, S2), Gm(b6, b6, S2), b6;
          }, s;
        }(JIe);
        function v9n(c5) {
          if (!c5.UTF8Encoding)
            return c5;
          var s = c5, r5 = s.UTF8Scale;
          r5 == null && (r5 = 1024);
          var g5 = s.features;
          return Ye2(g5, function(b6) {
            var S2 = b6.geometry, A2 = S2.encodeOffsets, k2 = S2.coordinates;
            if (A2)
              switch (S2.type) {
                case "LineString":
                  S2.coordinates = rDe(k2, A2, r5);
                  break;
                case "Polygon":
                  LGt(k2, A2, r5);
                  break;
                case "MultiLineString":
                  LGt(k2, A2, r5);
                  break;
                case "MultiPolygon":
                  Ye2(k2, function(R6, B3) {
                    return LGt(R6, A2[B3], r5);
                  });
              }
          }), s.UTF8Encoding = false, s;
        }
        function LGt(c5, s, r5) {
          for (var g5 = 0; g5 < c5.length; g5++)
            c5[g5] = rDe(c5[g5], s[g5], r5);
        }
        function rDe(c5, s, r5) {
          for (var g5 = [], b6 = s[0], S2 = s[1], A2 = 0; A2 < c5.length; A2 += 2) {
            var k2 = c5.charCodeAt(A2) - 64, R6 = c5.charCodeAt(A2 + 1) - 64;
            k2 = k2 >> 1 ^ -(k2 & 1), R6 = R6 >> 1 ^ -(R6 & 1), k2 += b6, R6 += S2, b6 = k2, S2 = R6, g5.push([k2 / r5, R6 / r5]);
          }
          return g5;
        }
        function y9n(c5, s) {
          return c5 = v9n(c5), Ha2(jp(c5.features, function(r5) {
            return r5.geometry && r5.properties && r5.geometry.coordinates.length > 0;
          }), function(r5) {
            var g5 = r5.properties, b6 = r5.geometry, S2 = [];
            switch (b6.type) {
              case "Polygon":
                var A2 = b6.coordinates;
                S2.push(new tDe(A2[0], A2.slice(1)));
                break;
              case "MultiPolygon":
                Ye2(b6.coordinates, function(R6) {
                  R6[0] && S2.push(new tDe(R6[0], R6.slice(1)));
                });
                break;
              case "LineString":
                S2.push(new eDe([b6.coordinates]));
                break;
              case "MultiLineString":
                S2.push(new eDe(b6.coordinates));
            }
            var k2 = new nDe(g5[s || "name"], S2, g5.cp);
            return k2.properties = g5, k2;
          });
        }
        var kct = Df2();
        function m9n(c5) {
          return c5.type === "category" ? _9n(c5) : w9n(c5);
        }
        function b9n(c5, s) {
          return c5.type === "category" ? x9n(c5, s) : { ticks: Ha2(c5.scale.getTicks(), function(r5) {
            return r5.value;
          }) };
        }
        function _9n(c5) {
          var s = c5.getLabelModel(), r5 = iDe(c5, s);
          return !s.get("show") || c5.scale.isBlank() ? { labels: [], labelCategoryInterval: r5.labelCategoryInterval } : r5;
        }
        function iDe(c5, s) {
          var r5 = aDe(c5, "labels"), g5 = kGt(s), b6 = oDe(r5, g5);
          if (b6)
            return b6;
          var S2, A2;
          return Tl(g5) ? S2 = uDe(c5, g5) : (A2 = g5 === "auto" ? S9n(c5) : g5, S2 = lDe(c5, A2)), sDe(r5, g5, { labels: S2, labelCategoryInterval: A2 });
        }
        function x9n(c5, s) {
          var r5 = aDe(c5, "ticks"), g5 = kGt(s), b6 = oDe(r5, g5);
          if (b6)
            return b6;
          var S2, A2;
          if ((!s.get("show") || c5.scale.isBlank()) && (S2 = []), Tl(g5))
            S2 = uDe(c5, g5, true);
          else if (g5 === "auto") {
            var k2 = iDe(c5, c5.getLabelModel());
            A2 = k2.labelCategoryInterval, S2 = Ha2(k2.labels, function(R6) {
              return R6.tickValue;
            });
          } else
            A2 = g5, S2 = lDe(c5, A2, true);
          return sDe(r5, g5, { ticks: S2, tickCategoryInterval: A2 });
        }
        function w9n(c5) {
          var s = c5.scale.getTicks(), r5 = Dct(c5);
          return { labels: Ha2(s, function(g5, b6) {
            return { level: g5.level, formattedLabel: r5(g5, b6), rawLabel: c5.scale.getLabel(g5), tickValue: g5.value };
          }) };
        }
        function aDe(c5, s) {
          return kct(c5)[s] || (kct(c5)[s] = []);
        }
        function oDe(c5, s) {
          for (var r5 = 0; r5 < c5.length; r5++)
            if (c5[r5].key === s)
              return c5[r5].value;
        }
        function sDe(c5, s, r5) {
          return c5.push({ key: s, value: r5 }), r5;
        }
        function S9n(c5) {
          var s = kct(c5).autoInterval;
          return s != null ? s : kct(c5).autoInterval = c5.calculateCategoryInterval();
        }
        function M9n(c5) {
          var s = C9n(c5), r5 = Dct(c5), g5 = (s.axisRotate - s.labelRotate) / 180 * Math.PI, b6 = c5.scale, S2 = b6.getExtent(), A2 = b6.count();
          if (S2[1] - S2[0] < 1)
            return 0;
          var k2 = 1;
          A2 > 40 && (k2 = Math.max(1, Math.floor(A2 / 40)));
          for (var R6 = S2[0], B3 = c5.dataToCoord(R6 + 1) - c5.dataToCoord(R6), G3 = Math.abs(B3 * Math.cos(g5)), Z3 = Math.abs(B3 * Math.sin(g5)), X3 = 0, tt = 0; R6 <= S2[1]; R6 += k2) {
            var it = 0, pt = 0, mt = tR(r5({ value: R6 }), s.font, "center", "top");
            it = mt.width * 1.3, pt = mt.height * 1.3, X3 = Math.max(X3, it, 7), tt = Math.max(tt, pt, 7);
          }
          var Mt = X3 / G3, kt = tt / Z3;
          isNaN(Mt) && (Mt = 1 / 0), isNaN(kt) && (kt = 1 / 0);
          var Gt = Math.max(0, Math.floor(Math.min(Mt, kt))), Ot = kct(c5.model), ce2 = c5.getExtent(), ae2 = Ot.lastAutoInterval, de2 = Ot.lastTickCount;
          return ae2 != null && de2 != null && Math.abs(ae2 - Gt) <= 1 && Math.abs(de2 - A2) <= 1 && ae2 > Gt && Ot.axisExtent0 === ce2[0] && Ot.axisExtent1 === ce2[1] ? Gt = ae2 : (Ot.lastTickCount = A2, Ot.lastAutoInterval = Gt, Ot.axisExtent0 = ce2[0], Ot.axisExtent1 = ce2[1]), Gt;
        }
        function C9n(c5) {
          var s = c5.getLabelModel();
          return { axisRotate: c5.getRotate ? c5.getRotate() : c5.isHorizontal && !c5.isHorizontal() ? 90 : 0, labelRotate: s.get("rotate") || 0, font: s.getFont() };
        }
        function lDe(c5, s, r5) {
          var g5 = Dct(c5), b6 = c5.scale, S2 = b6.getExtent(), A2 = c5.getLabelModel(), k2 = [], R6 = Math.max((s || 0) + 1, 1), B3 = S2[0], G3 = b6.count();
          B3 !== 0 && R6 > 1 && G3 / R6 > 2 && (B3 = Math.round(Math.ceil(B3 / R6) * R6));
          var Z3 = KIe(c5), X3 = A2.get("showMinLabel") || Z3, tt = A2.get("showMaxLabel") || Z3;
          X3 && B3 !== S2[0] && pt(S2[0]);
          for (var it = B3; it <= S2[1]; it += R6)
            pt(it);
          tt && it - R6 !== S2[1] && pt(S2[1]);
          function pt(mt) {
            var Mt = { value: mt };
            k2.push(r5 ? mt : { formattedLabel: g5(Mt), rawLabel: b6.getLabel(Mt), tickValue: mt });
          }
          return k2;
        }
        function uDe(c5, s, r5) {
          var g5 = c5.scale, b6 = Dct(c5), S2 = [];
          return Ye2(g5.getTicks(), function(A2) {
            var k2 = g5.getLabel(A2), R6 = A2.value;
            s(A2.value, k2) && S2.push(r5 ? R6 : { formattedLabel: b6(A2), rawLabel: k2, tickValue: R6 });
          }), S2;
        }
        var cDe = [0, 1], T9n = function() {
          function c5(s, r5, g5) {
            this.onBand = false, this.inverse = false, this.dim = s, this.scale = r5, this._extent = g5 || [0, 0];
          }
          return c5.prototype.contain = function(s) {
            var r5 = this._extent, g5 = Math.min(r5[0], r5[1]), b6 = Math.max(r5[0], r5[1]);
            return s >= g5 && s <= b6;
          }, c5.prototype.containData = function(s) {
            return this.scale.contain(s);
          }, c5.prototype.getExtent = function() {
            return this._extent.slice();
          }, c5.prototype.getPixelPrecision = function(s) {
            return jlt(s || this.scale.getExtent(), this._extent);
          }, c5.prototype.setExtent = function(s, r5) {
            var g5 = this._extent;
            g5[0] = s, g5[1] = r5;
          }, c5.prototype.dataToCoord = function(s, r5) {
            var g5 = this._extent, b6 = this.scale;
            return s = b6.normalize(s), this.onBand && b6.type === "ordinal" && (g5 = g5.slice(), fDe(g5, b6.count())), fh2(s, cDe, g5, r5);
          }, c5.prototype.coordToData = function(s, r5) {
            var g5 = this._extent, b6 = this.scale;
            this.onBand && b6.type === "ordinal" && (g5 = g5.slice(), fDe(g5, b6.count()));
            var S2 = fh2(s, g5, cDe, r5);
            return this.scale.scale(S2);
          }, c5.prototype.pointToData = function(s, r5) {
          }, c5.prototype.getTicksCoords = function(s) {
            s = s || {};
            var r5 = s.tickModel || this.getTickModel(), g5 = b9n(this, r5), b6 = g5.ticks, S2 = Ha2(b6, function(k2) {
              return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(k2) : k2), tickValue: k2 };
            }, this), A2 = r5.get("alignWithLabel");
            return A9n(this, S2, A2, s.clamp), S2;
          }, c5.prototype.getMinorTicksCoords = function() {
            if (this.scale.type === "ordinal")
              return [];
            var s = this.model.getModel("minorTick"), r5 = s.get("splitNumber");
            r5 > 0 && r5 < 100 || (r5 = 5);
            var g5 = this.scale.getMinorTicks(r5), b6 = Ha2(g5, function(S2) {
              return Ha2(S2, function(A2) {
                return { coord: this.dataToCoord(A2), tickValue: A2 };
              }, this);
            }, this);
            return b6;
          }, c5.prototype.getViewLabels = function() {
            return m9n(this).labels;
          }, c5.prototype.getLabelModel = function() {
            return this.model.getModel("axisLabel");
          }, c5.prototype.getTickModel = function() {
            return this.model.getModel("axisTick");
          }, c5.prototype.getBandWidth = function() {
            var s = this._extent, r5 = this.scale.getExtent(), g5 = r5[1] - r5[0] + (this.onBand ? 1 : 0);
            g5 === 0 && (g5 = 1);
            var b6 = Math.abs(s[1] - s[0]);
            return Math.abs(b6) / g5;
          }, c5.prototype.calculateCategoryInterval = function() {
            return M9n(this);
          }, c5;
        }();
        function fDe(c5, s) {
          var r5 = c5[1] - c5[0], g5 = s, b6 = r5 / g5 / 2;
          c5[0] += b6, c5[1] -= b6;
        }
        function A9n(c5, s, r5, g5) {
          var b6 = s.length;
          if (!c5.onBand || r5 || !b6)
            return;
          var S2 = c5.getExtent(), A2, k2;
          if (b6 === 1)
            s[0].coord = S2[0], A2 = s[1] = { coord: S2[0] };
          else {
            var R6 = s[b6 - 1].tickValue - s[0].tickValue, B3 = (s[b6 - 1].coord - s[0].coord) / R6;
            Ye2(s, function(tt) {
              tt.coord -= B3 / 2;
            });
            var G3 = c5.scale.getExtent();
            k2 = 1 + G3[1] - s[b6 - 1].tickValue, A2 = { coord: s[b6 - 1].coord + B3 * k2 }, s.push(A2);
          }
          var Z3 = S2[0] > S2[1];
          X3(s[0].coord, S2[0]) && (g5 ? s[0].coord = S2[0] : s.shift()), g5 && X3(S2[0], s[0].coord) && s.unshift({ coord: S2[0] }), X3(S2[1], A2.coord) && (g5 ? A2.coord = S2[1] : s.pop()), g5 && X3(A2.coord, S2[1]) && s.push({ coord: S2[1] });
          function X3(tt, it) {
            return tt = c0(tt), it = c0(it), Z3 ? tt > it : tt < it;
          }
        }
        var kk2 = T9n, Pct = Math.PI * 2, vW = jI.CMD, I9n = ["top", "right", "bottom", "left"];
        function D9n(c5, s, r5, g5, b6) {
          var S2 = r5.width, A2 = r5.height;
          switch (c5) {
            case "top":
              g5.set(r5.x + S2 / 2, r5.y - s), b6.set(0, -1);
              break;
            case "bottom":
              g5.set(r5.x + S2 / 2, r5.y + A2 + s), b6.set(0, 1);
              break;
            case "left":
              g5.set(r5.x - s, r5.y + A2 / 2), b6.set(-1, 0);
              break;
            case "right":
              g5.set(r5.x + S2 + s, r5.y + A2 / 2), b6.set(1, 0);
              break;
          }
        }
        function E9n(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          A2 -= c5, k2 -= s;
          var B3 = Math.sqrt(A2 * A2 + k2 * k2);
          A2 /= B3, k2 /= B3;
          var G3 = A2 * r5 + c5, Z3 = k2 * r5 + s;
          if (Math.abs(g5 - b6) % Pct < 1e-4)
            return R6[0] = G3, R6[1] = Z3, B3 - r5;
          if (S2) {
            var X3 = g5;
            g5 = x3(b6), b6 = x3(X3);
          } else
            g5 = x3(g5), b6 = x3(b6);
          g5 > b6 && (b6 += Pct);
          var tt = Math.atan2(k2, A2);
          if (tt < 0 && (tt += Pct), tt >= g5 && tt <= b6 || tt + Pct >= g5 && tt + Pct <= b6)
            return R6[0] = G3, R6[1] = Z3, B3 - r5;
          var it = r5 * Math.cos(g5) + c5, pt = r5 * Math.sin(g5) + s, mt = r5 * Math.cos(b6) + c5, Mt = r5 * Math.sin(b6) + s, kt = (it - A2) * (it - A2) + (pt - k2) * (pt - k2), Gt = (mt - A2) * (mt - A2) + (Mt - k2) * (Mt - k2);
          return kt < Gt ? (R6[0] = it, R6[1] = pt, Math.sqrt(kt)) : (R6[0] = mt, R6[1] = Mt, Math.sqrt(Gt));
        }
        function RMt(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6 = b6 - c5, B3 = S2 - s, G3 = r5 - c5, Z3 = g5 - s, X3 = Math.sqrt(G3 * G3 + Z3 * Z3);
          G3 /= X3, Z3 /= X3;
          var tt = R6 * G3 + B3 * Z3, it = tt / X3;
          k2 && (it = Math.min(Math.max(it, 0), 1)), it *= X3;
          var pt = A2[0] = c5 + it * G3, mt = A2[1] = s + it * Z3;
          return Math.sqrt((pt - b6) * (pt - b6) + (mt - S2) * (mt - S2));
        }
        function hDe(c5, s, r5, g5, b6, S2, A2) {
          r5 < 0 && (c5 = c5 + r5, r5 = -r5), g5 < 0 && (s = s + g5, g5 = -g5);
          var k2 = c5 + r5, R6 = s + g5, B3 = A2[0] = Math.min(Math.max(b6, c5), k2), G3 = A2[1] = Math.min(Math.max(S2, s), R6);
          return Math.sqrt((B3 - b6) * (B3 - b6) + (G3 - S2) * (G3 - S2));
        }
        var Pk = [];
        function k9n(c5, s, r5) {
          var g5 = hDe(s.x, s.y, s.width, s.height, c5.x, c5.y, Pk);
          return r5.set(Pk[0], Pk[1]), g5;
        }
        function P9n(c5, s, r5) {
          for (var g5 = 0, b6 = 0, S2 = 0, A2 = 0, k2, R6, B3 = 1 / 0, G3 = s.data, Z3 = c5.x, X3 = c5.y, tt = 0; tt < G3.length; ) {
            var it = G3[tt++];
            tt === 1 && (g5 = G3[tt], b6 = G3[tt + 1], S2 = g5, A2 = b6);
            var pt = B3;
            switch (it) {
              case vW.M:
                S2 = G3[tt++], A2 = G3[tt++], g5 = S2, b6 = A2;
                break;
              case vW.L:
                pt = RMt(g5, b6, G3[tt], G3[tt + 1], Z3, X3, Pk, true), g5 = G3[tt++], b6 = G3[tt++];
                break;
              case vW.C:
                pt = Sj2(g5, b6, G3[tt++], G3[tt++], G3[tt++], G3[tt++], G3[tt], G3[tt + 1], Z3, X3, Pk), g5 = G3[tt++], b6 = G3[tt++];
                break;
              case vW.Q:
                pt = F1(g5, b6, G3[tt++], G3[tt++], G3[tt], G3[tt + 1], Z3, X3, Pk), g5 = G3[tt++], b6 = G3[tt++];
                break;
              case vW.A:
                var mt = G3[tt++], Mt = G3[tt++], kt = G3[tt++], Gt = G3[tt++], Ot = G3[tt++], ce2 = G3[tt++];
                tt += 1;
                var ae2 = !!(1 - G3[tt++]);
                k2 = Math.cos(Ot) * kt + mt, R6 = Math.sin(Ot) * Gt + Mt, tt <= 1 && (S2 = k2, A2 = R6);
                var de2 = (Z3 - mt) * Gt / kt + mt;
                pt = E9n(mt, Mt, Gt, Ot, Ot + ce2, ae2, de2, X3, Pk), g5 = Math.cos(Ot + ce2) * kt + mt, b6 = Math.sin(Ot + ce2) * Gt + Mt;
                break;
              case vW.R:
                S2 = g5 = G3[tt++], A2 = b6 = G3[tt++];
                var we2 = G3[tt++], Se2 = G3[tt++];
                pt = hDe(S2, A2, we2, Se2, Z3, X3, Pk);
                break;
              case vW.Z:
                pt = RMt(g5, b6, S2, A2, Z3, X3, Pk, true), g5 = S2, b6 = A2;
                break;
            }
            pt < B3 && (B3 = pt, r5.set(Pk[0], Pk[1]));
          }
          return B3;
        }
        var Lk = new Bu(), Dg2 = new Bu(), ky = new Bu(), P3 = new Bu(), L3 = new Bu();
        function pDe(c5, s) {
          if (c5) {
            var r5 = c5.getTextGuideLine(), g5 = c5.getTextContent();
            if (g5 && r5) {
              var b6 = c5.textGuideLineConfig || {}, S2 = [[0, 0], [0, 0], [0, 0]], A2 = b6.candidates || I9n, k2 = g5.getBoundingRect().clone();
              k2.applyTransform(g5.getComputedTransform());
              var R6 = 1 / 0, B3 = b6.anchor, G3 = c5.getComputedTransform(), Z3 = G3 && Y4([], G3), X3 = s.get("length2") || 0;
              B3 && ky.copy(B3);
              for (var tt = 0; tt < A2.length; tt++) {
                var it = A2[tt];
                D9n(it, 0, k2, Lk, P3), Bu.scaleAndAdd(Dg2, Lk, P3, X3), Dg2.transform(Z3);
                var pt = c5.getBoundingRect(), mt = B3 ? B3.distance(Dg2) : c5 instanceof Tc2 ? P9n(Dg2, c5.path, ky) : k9n(Dg2, pt, ky);
                mt < R6 && (R6 = mt, Dg2.transform(G3), ky.transform(G3), ky.toArray(S2[0]), Dg2.toArray(S2[1]), Lk.toArray(S2[2]));
              }
              dDe(S2, s.get("minTurnAngle")), r5.setShape({ points: S2 });
            }
          }
        }
        var NMt = [], b2 = new Bu();
        function dDe(c5, s) {
          if (s <= 180 && s > 0) {
            s = s / 180 * Math.PI, Lk.fromArray(c5[0]), Dg2.fromArray(c5[1]), ky.fromArray(c5[2]), Bu.sub(P3, Lk, Dg2), Bu.sub(L3, ky, Dg2);
            var r5 = P3.len(), g5 = L3.len();
            if (!(r5 < 1e-3 || g5 < 1e-3)) {
              P3.scale(1 / r5), L3.scale(1 / g5);
              var b6 = P3.dot(L3), S2 = Math.cos(s);
              if (S2 < b6) {
                var A2 = RMt(Dg2.x, Dg2.y, ky.x, ky.y, Lk.x, Lk.y, NMt, false);
                b2.fromArray(NMt), b2.scaleAndAdd(L3, A2 / Math.tan(Math.PI - s));
                var k2 = ky.x !== Dg2.x ? (b2.x - Dg2.x) / (ky.x - Dg2.x) : (b2.y - Dg2.y) / (ky.y - Dg2.y);
                if (isNaN(k2))
                  return;
                k2 < 0 ? Bu.copy(b2, Dg2) : k2 > 1 && Bu.copy(b2, ky), b2.toArray(c5[1]);
              }
            }
          }
        }
        function L9n(c5, s, r5) {
          if (r5 <= 180 && r5 > 0) {
            r5 = r5 / 180 * Math.PI, Lk.fromArray(c5[0]), Dg2.fromArray(c5[1]), ky.fromArray(c5[2]), Bu.sub(P3, Dg2, Lk), Bu.sub(L3, ky, Dg2);
            var g5 = P3.len(), b6 = L3.len();
            if (!(g5 < 1e-3 || b6 < 1e-3)) {
              P3.scale(1 / g5), L3.scale(1 / b6);
              var S2 = P3.dot(s), A2 = Math.cos(r5);
              if (S2 < A2) {
                var k2 = RMt(Dg2.x, Dg2.y, ky.x, ky.y, Lk.x, Lk.y, NMt, false);
                b2.fromArray(NMt);
                var R6 = Math.PI / 2, B3 = Math.acos(L3.dot(s)), G3 = R6 + B3 - r5;
                if (G3 >= R6)
                  Bu.copy(b2, ky);
                else {
                  b2.scaleAndAdd(L3, k2 / Math.tan(Math.PI / 2 - G3));
                  var Z3 = ky.x !== Dg2.x ? (b2.x - Dg2.x) / (ky.x - Dg2.x) : (b2.y - Dg2.y) / (ky.y - Dg2.y);
                  if (isNaN(Z3))
                    return;
                  Z3 < 0 ? Bu.copy(b2, Dg2) : Z3 > 1 && Bu.copy(b2, ky);
                }
                b2.toArray(c5[1]);
              }
            }
          }
        }
        function gDe(c5, s, r5, g5) {
          var b6 = r5 === "normal", S2 = b6 ? c5 : c5.ensureState(r5);
          S2.ignore = s;
          var A2 = g5.get("smooth");
          A2 && A2 === true && (A2 = 0.3), S2.shape = S2.shape || {}, A2 > 0 && (S2.shape.smooth = A2);
          var k2 = g5.getModel("lineStyle").getLineStyle();
          b6 ? c5.useStyle(k2) : S2.style = k2;
        }
        function O9n(c5, s) {
          var r5 = s.smooth, g5 = s.points;
          if (g5)
            if (c5.moveTo(g5[0][0], g5[0][1]), r5 > 0 && g5.length >= 3) {
              var b6 = LI(g5[0], g5[1]), S2 = LI(g5[1], g5[2]);
              if (!b6 || !S2) {
                c5.lineTo(g5[1][0], g5[1][1]), c5.lineTo(g5[2][0], g5[2][1]);
                return;
              }
              var A2 = Math.min(b6, S2) * r5, k2 = jY([], g5[1], g5[0], A2 / b6), R6 = jY([], g5[1], g5[2], A2 / S2), B3 = jY([], k2, R6, 0.5);
              c5.bezierCurveTo(k2[0], k2[1], k2[0], k2[1], B3[0], B3[1]), c5.bezierCurveTo(R6[0], R6[1], R6[0], R6[1], g5[2][0], g5[2][1]);
            } else
              for (var G3 = 1; G3 < g5.length; G3++)
                c5.lineTo(g5[G3][0], g5[G3][1]);
        }
        function OGt(c5, s, r5) {
          var g5 = c5.getTextGuideLine(), b6 = c5.getTextContent();
          if (!b6) {
            g5 && c5.removeTextGuideLine();
            return;
          }
          for (var S2 = s.normal, A2 = S2.get("show"), k2 = b6.ignore, R6 = 0; R6 < Yj2.length; R6++) {
            var B3 = Yj2[R6], G3 = s[B3], Z3 = B3 === "normal";
            if (G3) {
              var X3 = G3.get("show"), tt = Z3 ? k2 : tc2(b6.states[B3] && b6.states[B3].ignore, k2);
              if (tt || !tc2(X3, A2)) {
                var it = Z3 ? g5 : g5 && g5.states.normal;
                it && (it.ignore = true);
                continue;
              }
              g5 || (g5 = new Gw(), c5.setTextGuideLine(g5), !Z3 && (k2 || !A2) && gDe(g5, true, "normal", s.normal), c5.stateProxy && (g5.stateProxy = c5.stateProxy)), gDe(g5, false, B3, G3);
            }
          }
          if (g5) {
            Cl(g5.style, r5), g5.style.fill = null;
            var pt = S2.get("showAbove"), mt = c5.textGuideLineConfig = c5.textGuideLineConfig || {};
            mt.showAbove = pt || false, g5.buildPath = O9n;
          }
        }
        function RGt(c5, s) {
          s = s || "labelLine";
          for (var r5 = { normal: c5.getModel(s) }, g5 = 0; g5 < k0.length; g5++) {
            var b6 = k0[g5];
            r5[b6] = c5.getModel([b6, s]);
          }
          return r5;
        }
        function vDe(c5) {
          for (var s = [], r5 = 0; r5 < c5.length; r5++) {
            var g5 = c5[r5];
            if (!g5.defaultAttr.ignore) {
              var b6 = g5.label, S2 = b6.getComputedTransform(), A2 = b6.getBoundingRect(), k2 = !S2 || S2[1] < 1e-5 && S2[2] < 1e-5, R6 = b6.style.margin || 0, B3 = A2.clone();
              B3.applyTransform(S2), B3.x -= R6 / 2, B3.y -= R6 / 2, B3.width += R6, B3.height += R6;
              var G3 = k2 ? new QK(A2, S2) : null;
              s.push({ label: b6, labelLine: g5.labelLine, rect: B3, localRect: A2, obb: G3, priority: g5.priority, defaultAttr: g5.defaultAttr, layoutOption: g5.computedLayoutOption, axisAligned: k2, transform: S2 });
            }
          }
          return s;
        }
        function yDe(c5, s, r5, g5, b6, S2) {
          var A2 = c5.length;
          if (A2 < 2)
            return;
          c5.sort(function(we2, Se2) {
            return we2.rect[s] - Se2.rect[s];
          });
          for (var k2 = 0, R6, B3 = false, G3 = 0, Z3 = 0; Z3 < A2; Z3++) {
            var X3 = c5[Z3], tt = X3.rect;
            R6 = tt[s] - k2, R6 < 0 && (tt[s] -= R6, X3.label[s] -= R6, B3 = true);
            var it = Math.max(-R6, 0);
            G3 += it, k2 = tt[s] + tt[r5];
          }
          G3 > 0 && S2 && ce2(-G3 / A2, 0, A2);
          var pt = c5[0], mt = c5[A2 - 1], Mt, kt;
          Gt(), Mt < 0 && ae2(-Mt, 0.8), kt < 0 && ae2(kt, 0.8), Gt(), Ot(Mt, kt, 1), Ot(kt, Mt, -1), Gt(), Mt < 0 && de2(-Mt), kt < 0 && de2(kt);
          function Gt() {
            Mt = pt.rect[s] - g5, kt = b6 - mt.rect[s] - mt.rect[r5];
          }
          function Ot(we2, Se2, Oe2) {
            if (we2 < 0) {
              var je2 = Math.min(Se2, -we2);
              if (je2 > 0) {
                ce2(je2 * Oe2, 0, A2);
                var rn = je2 + we2;
                rn < 0 && ae2(-rn * Oe2, 1);
              } else
                ae2(-we2 * Oe2, 1);
            }
          }
          function ce2(we2, Se2, Oe2) {
            we2 !== 0 && (B3 = true);
            for (var je2 = Se2; je2 < Oe2; je2++) {
              var rn = c5[je2], qe2 = rn.rect;
              qe2[s] += we2, rn.label[s] += we2;
            }
          }
          function ae2(we2, Se2) {
            for (var Oe2 = [], je2 = 0, rn = 1; rn < A2; rn++) {
              var qe2 = c5[rn - 1].rect, An = Math.max(c5[rn].rect[s] - qe2[s] - qe2[r5], 0);
              Oe2.push(An), je2 += An;
            }
            if (je2) {
              var jn = Math.min(Math.abs(we2) / je2, Se2);
              if (we2 > 0)
                for (var rn = 0; rn < A2 - 1; rn++) {
                  var _n = Oe2[rn] * jn;
                  ce2(_n, 0, rn + 1);
                }
              else
                for (var rn = A2 - 1; rn > 0; rn--) {
                  var _n = Oe2[rn - 1] * jn;
                  ce2(-_n, rn, A2);
                }
            }
          }
          function de2(we2) {
            var Se2 = we2 < 0 ? -1 : 1;
            we2 = Math.abs(we2);
            for (var Oe2 = Math.ceil(we2 / (A2 - 1)), je2 = 0; je2 < A2 - 1; je2++)
              if (Se2 > 0 ? ce2(Oe2, 0, je2 + 1) : ce2(-Oe2, A2 - je2 - 1, A2), we2 -= Oe2, we2 <= 0)
                return;
          }
          return B3;
        }
        function R9n(c5, s, r5, g5) {
          return yDe(c5, "x", "width", s, r5, g5);
        }
        function mDe(c5, s, r5, g5) {
          return yDe(c5, "y", "height", s, r5, g5);
        }
        function bDe(c5) {
          var s = [];
          c5.sort(function(pt, mt) {
            return mt.priority - pt.priority;
          });
          var r5 = new lc2(0, 0, 0, 0);
          function g5(pt) {
            if (!pt.ignore) {
              var mt = pt.ensureState("emphasis");
              mt.ignore == null && (mt.ignore = false);
            }
            pt.ignore = true;
          }
          for (var b6 = 0; b6 < c5.length; b6++) {
            var S2 = c5[b6], A2 = S2.axisAligned, k2 = S2.localRect, R6 = S2.transform, B3 = S2.label, G3 = S2.labelLine;
            r5.copy(S2.rect), r5.width -= 0.1, r5.height -= 0.1, r5.x += 0.05, r5.y += 0.05;
            for (var Z3 = S2.obb, X3 = false, tt = 0; tt < s.length; tt++) {
              var it = s[tt];
              if (r5.intersect(it.rect)) {
                if (A2 && it.axisAligned) {
                  X3 = true;
                  break;
                }
                if (it.obb || (it.obb = new QK(it.localRect, it.transform)), Z3 || (Z3 = new QK(k2, R6)), Z3.intersect(it.obb)) {
                  X3 = true;
                  break;
                }
              }
            }
            X3 ? (g5(B3), G3 && g5(G3)) : (B3.attr("ignore", S2.defaultAttr.ignore), G3 && G3.attr("ignore", S2.defaultAttr.labelGuideIgnore), s.push(S2));
          }
        }
        function N9n(c5) {
          if (c5) {
            for (var s = [], r5 = 0; r5 < c5.length; r5++)
              s.push(c5[r5].slice());
            return s;
          }
        }
        function F9n(c5, s) {
          var r5 = c5.label, g5 = s && s.getTextGuideLine();
          return { dataIndex: c5.dataIndex, dataType: c5.dataType, seriesIndex: c5.seriesModel.seriesIndex, text: c5.label.style.text, rect: c5.hostRect, labelRect: c5.rect, align: r5.style.align, verticalAlign: r5.style.verticalAlign, labelLinePoints: N9n(g5 && g5.shape.points) };
        }
        var _De = ["align", "verticalAlign", "width", "height", "fontSize"], iT = new YC(), NGt = Df2(), V9n = Df2();
        function FMt(c5, s, r5) {
          for (var g5 = 0; g5 < r5.length; g5++) {
            var b6 = r5[g5];
            s[b6] != null && (c5[b6] = s[b6]);
          }
        }
        var VMt = ["x", "y", "rotation"], B9n = function() {
          function c5() {
            this._labelList = [], this._chartViewList = [];
          }
          return c5.prototype.clearLabels = function() {
            this._labelList = [], this._chartViewList = [];
          }, c5.prototype._addLabel = function(s, r5, g5, b6, S2) {
            var A2 = b6.style, k2 = b6.__hostTarget, R6 = k2.textConfig || {}, B3 = b6.getComputedTransform(), G3 = b6.getBoundingRect().plain();
            lc2.applyTransform(G3, G3, B3), B3 ? iT.setLocalTransform(B3) : (iT.x = iT.y = iT.rotation = iT.originX = iT.originY = 0, iT.scaleX = iT.scaleY = 1);
            var Z3 = b6.__hostTarget, X3;
            if (Z3) {
              X3 = Z3.getBoundingRect().plain();
              var tt = Z3.getComputedTransform();
              lc2.applyTransform(X3, X3, tt);
            }
            var it = X3 && Z3.getTextGuideLine();
            this._labelList.push({ label: b6, labelLine: it, seriesModel: g5, dataIndex: s, dataType: r5, layoutOption: S2, computedLayoutOption: null, rect: G3, hostRect: X3, priority: X3 ? X3.width * X3.height : 0, defaultAttr: { ignore: b6.ignore, labelGuideIgnore: it && it.ignore, x: iT.x, y: iT.y, scaleX: iT.scaleX, scaleY: iT.scaleY, rotation: iT.rotation, style: { x: A2.x, y: A2.y, align: A2.align, verticalAlign: A2.verticalAlign, width: A2.width, height: A2.height, fontSize: A2.fontSize }, cursor: b6.cursor, attachedPos: R6.position, attachedRot: R6.rotation } });
          }, c5.prototype.addLabelsOfSeries = function(s) {
            var r5 = this;
            this._chartViewList.push(s);
            var g5 = s.__model, b6 = g5.get("labelLayout");
            !(Tl(b6) || nf2(b6).length) || s.group.traverse(function(S2) {
              if (S2.ignore)
                return true;
              var A2 = S2.getTextContent(), k2 = Pl(S2);
              A2 && !A2.disableLabelLayout && r5._addLabel(k2.dataIndex, k2.dataType, g5, A2, b6);
            });
          }, c5.prototype.updateLayoutConfig = function(s) {
            var r5 = s.getWidth(), g5 = s.getHeight();
            function b6(Gt, Ot) {
              return function() {
                pDe(Gt, Ot);
              };
            }
            for (var S2 = 0; S2 < this._labelList.length; S2++) {
              var A2 = this._labelList[S2], k2 = A2.label, R6 = k2.__hostTarget, B3 = A2.defaultAttr, G3 = void 0;
              Tl(A2.layoutOption) ? G3 = A2.layoutOption(F9n(A2, R6)) : G3 = A2.layoutOption, G3 = G3 || {}, A2.computedLayoutOption = G3;
              var Z3 = Math.PI / 180;
              R6 && R6.setTextConfig({ local: false, position: G3.x != null || G3.y != null ? null : B3.attachedPos, rotation: G3.rotate != null ? G3.rotate * Z3 : B3.attachedRot, offset: [G3.dx || 0, G3.dy || 0] });
              var X3 = false;
              if (G3.x != null ? (k2.x = $o(G3.x, r5), k2.setStyle("x", 0), X3 = true) : (k2.x = B3.x, k2.setStyle("x", B3.style.x)), G3.y != null ? (k2.y = $o(G3.y, g5), k2.setStyle("y", 0), X3 = true) : (k2.y = B3.y, k2.setStyle("y", B3.style.y)), G3.labelLinePoints) {
                var tt = R6.getTextGuideLine();
                tt && (tt.setShape({ points: G3.labelLinePoints }), X3 = false);
              }
              var it = NGt(k2);
              it.needsUpdateLabelLine = X3, k2.rotation = G3.rotate != null ? G3.rotate * Z3 : B3.rotation, k2.scaleX = B3.scaleX, k2.scaleY = B3.scaleY;
              for (var pt = 0; pt < _De.length; pt++) {
                var mt = _De[pt];
                k2.setStyle(mt, G3[mt] != null ? G3[mt] : B3.style[mt]);
              }
              if (G3.draggable) {
                if (k2.draggable = true, k2.cursor = "move", R6) {
                  var Mt = A2.seriesModel;
                  if (A2.dataIndex != null) {
                    var kt = A2.seriesModel.getData(A2.dataType);
                    Mt = kt.getItemModel(A2.dataIndex);
                  }
                  k2.on("drag", b6(R6, Mt.getModel("labelLine")));
                }
              } else
                k2.off("drag"), k2.cursor = B3.cursor;
            }
          }, c5.prototype.layout = function(s) {
            var r5 = s.getWidth(), g5 = s.getHeight(), b6 = vDe(this._labelList), S2 = jp(b6, function(R6) {
              return R6.layoutOption.moveOverlap === "shiftX";
            }), A2 = jp(b6, function(R6) {
              return R6.layoutOption.moveOverlap === "shiftY";
            });
            R9n(S2, 0, r5), mDe(A2, 0, g5);
            var k2 = jp(b6, function(R6) {
              return R6.layoutOption.hideOverlap;
            });
            bDe(k2);
          }, c5.prototype.processLabelsOverall = function() {
            var s = this;
            Ye2(this._chartViewList, function(r5) {
              var g5 = r5.__model, b6 = r5.ignoreLabelLineUpdate, S2 = g5.isAnimationEnabled();
              r5.group.traverse(function(A2) {
                if (A2.ignore && !A2.forceLabelAnimation)
                  return true;
                var k2 = !b6, R6 = A2.getTextContent();
                !k2 && R6 && (k2 = NGt(R6).needsUpdateLabelLine), k2 && s._updateLabelLine(A2, g5), S2 && s._animateLabels(A2, g5);
              });
            });
          }, c5.prototype._updateLabelLine = function(s, r5) {
            var g5 = s.getTextContent(), b6 = Pl(s), S2 = b6.dataIndex;
            if (g5 && S2 != null) {
              var A2 = r5.getData(b6.dataType), k2 = A2.getItemModel(S2), R6 = {}, B3 = A2.getItemVisual(S2, "style"), G3 = A2.getVisual("drawType");
              R6.stroke = B3[G3];
              var Z3 = k2.getModel("labelLine");
              OGt(s, RGt(k2), R6), pDe(s, Z3);
            }
          }, c5.prototype._animateLabels = function(s, r5) {
            var g5 = s.getTextContent(), b6 = s.getTextGuideLine();
            if (g5 && (s.forceLabelAnimation || !g5.ignore && !g5.invisible && !s.disableLabelAnimation && !Z8(s))) {
              var S2 = NGt(g5), A2 = S2.oldLayout, k2 = Pl(s), R6 = k2.dataIndex, B3 = { x: g5.x, y: g5.y, rotation: g5.rotation }, G3 = r5.getData(k2.dataType);
              if (A2) {
                g5.attr(A2);
                var Z3 = s.prevStates;
                Z3 && (Lu(Z3, "select") >= 0 && g5.attr(S2.oldLayoutSelect), Lu(Z3, "emphasis") >= 0 && g5.attr(S2.oldLayoutEmphasis)), Qf2(g5, B3, r5, R6);
              } else if (g5.attr(B3), !eX(g5).valueAnimation) {
                var X3 = tc2(g5.style.opacity, 1);
                g5.style.opacity = 0, tv(g5, { style: { opacity: X3 } }, r5, R6);
              }
              if (S2.oldLayout = B3, g5.states.select) {
                var tt = S2.oldLayoutSelect = {};
                FMt(tt, B3, VMt), FMt(tt, g5.states.select, VMt);
              }
              if (g5.states.emphasis) {
                var it = S2.oldLayoutEmphasis = {};
                FMt(it, B3, VMt), FMt(it, g5.states.emphasis, VMt);
              }
              FCe(g5, R6, G3, r5, r5);
            }
            if (b6 && !b6.ignore && !b6.invisible) {
              var S2 = V9n(b6), A2 = S2.oldLayout, pt = { points: b6.shape.points };
              A2 ? (b6.attr({ shape: A2 }), Qf2(b6, { shape: pt }, r5)) : (b6.setShape(pt), b6.style.strokePercent = 0, tv(b6, { style: { strokePercent: 1 } }, r5)), S2.oldLayout = pt;
            }
          }, c5;
        }(), z9n = B9n, FGt = Df2();
        function j9n(c5) {
          c5.registerUpdateLifecycle("series:beforeupdate", function(s, r5, g5) {
            var b6 = FGt(r5).labelManager;
            b6 || (b6 = FGt(r5).labelManager = new z9n()), b6.clearLabels();
          }), c5.registerUpdateLifecycle("series:layoutlabels", function(s, r5, g5) {
            var b6 = FGt(r5).labelManager;
            g5.updatedSeries.forEach(function(S2) {
              b6.addLabelsOfSeries(r5.getViewOfSeriesModel(S2));
            }), b6.updateLayoutConfig(r5), b6.layout(r5), b6.processLabelsOverall();
          });
        }
        var VGt = Math.sin, BGt = Math.cos, xDe = Math.PI, yW = Math.PI * 2, W9n = 180 / xDe, G9n = function() {
          function c5() {
          }
          return c5.prototype.reset = function(s) {
            this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, s || 4);
          }, c5.prototype.moveTo = function(s, r5) {
            this._add("M", s, r5);
          }, c5.prototype.lineTo = function(s, r5) {
            this._add("L", s, r5);
          }, c5.prototype.bezierCurveTo = function(s, r5, g5, b6, S2, A2) {
            this._add("C", s, r5, g5, b6, S2, A2);
          }, c5.prototype.quadraticCurveTo = function(s, r5, g5, b6) {
            this._add("Q", s, r5, g5, b6);
          }, c5.prototype.arc = function(s, r5, g5, b6, S2, A2) {
            this.ellipse(s, r5, g5, g5, 0, b6, S2, A2);
          }, c5.prototype.ellipse = function(s, r5, g5, b6, S2, A2, k2, R6) {
            var B3 = k2 - A2, G3 = !R6, Z3 = Math.abs(B3), X3 = o3(Z3 - yW) || (G3 ? B3 >= yW : -B3 >= yW), tt = B3 > 0 ? B3 % yW : B3 % yW + yW, it = false;
            X3 ? it = true : o3(Z3) ? it = false : it = tt >= xDe == !!G3;
            var pt = s + g5 * BGt(A2), mt = r5 + b6 * VGt(A2);
            this._start && this._add("M", pt, mt);
            var Mt = Math.round(S2 * W9n);
            if (X3) {
              var kt = 1 / this._p, Gt = (G3 ? 1 : -1) * (yW - kt);
              this._add("A", g5, b6, Mt, 1, +G3, s + g5 * BGt(A2 + Gt), r5 + b6 * VGt(A2 + Gt)), kt > 0.01 && this._add("A", g5, b6, Mt, 0, +G3, pt, mt);
            } else {
              var Ot = s + g5 * BGt(k2), ce2 = r5 + b6 * VGt(k2);
              this._add("A", g5, b6, Mt, +it, +G3, Ot, ce2);
            }
          }, c5.prototype.rect = function(s, r5, g5, b6) {
            this._add("M", s, r5), this._add("l", g5, 0), this._add("l", 0, b6), this._add("l", -g5, 0), this._add("Z");
          }, c5.prototype.closePath = function() {
            this._d.length > 0 && this._add("Z");
          }, c5.prototype._add = function(s, r5, g5, b6, S2, A2, k2, R6, B3) {
            for (var G3 = [], Z3 = this._p, X3 = 1; X3 < arguments.length; X3++) {
              var tt = arguments[X3];
              if (isNaN(tt)) {
                this._invalid = true;
                return;
              }
              G3.push(Math.round(tt * Z3) / Z3);
            }
            this._d.push(s + G3.join(" ")), this._start = s === "Z";
          }, c5.prototype.generateStr = function() {
            this._str = this._invalid ? "" : this._d.join(""), this._d = [];
          }, c5.prototype.getStr = function() {
            return this._str;
          }, c5;
        }(), wDe = G9n, Lct = "none", H9n = Math.round;
        function U9n(c5) {
          var s = c5.fill;
          return s != null && s !== Lct;
        }
        function q9n(c5) {
          var s = c5.stroke;
          return s != null && s !== Lct;
        }
        var zGt = ["lineCap", "miterLimit", "lineJoin"], Z9n = Ha2(zGt, function(c5) {
          return "stroke-" + c5.toLowerCase();
        });
        function $9n(c5, s, r5, g5) {
          var b6 = s.opacity == null ? 1 : s.opacity;
          if (r5 instanceof qm) {
            c5("opacity", b6);
            return;
          }
          if (U9n(s)) {
            var S2 = N8(s.fill);
            c5("fill", S2.color);
            var A2 = s.fillOpacity != null ? s.fillOpacity * S2.opacity * b6 : S2.opacity * b6;
            (g5 || A2 < 1) && c5("fill-opacity", A2);
          } else
            c5("fill", Lct);
          if (q9n(s)) {
            var k2 = N8(s.stroke);
            c5("stroke", k2.color);
            var R6 = s.strokeNoScale ? r5.getLineScale() : 1, B3 = R6 ? (s.lineWidth || 0) / R6 : 0, G3 = s.strokeOpacity != null ? s.strokeOpacity * k2.opacity * b6 : k2.opacity * b6, Z3 = s.strokeFirst;
            if ((g5 || B3 !== 1) && c5("stroke-width", B3), (g5 || Z3) && c5("paint-order", Z3 ? "stroke" : "fill"), (g5 || G3 < 1) && c5("stroke-opacity", G3), s.lineDash) {
              var X3 = eGt(r5), tt = X3[0], it = X3[1];
              tt && (it = H9n(it || 0), c5("stroke-dasharray", tt.join(",")), (it || g5) && c5("stroke-dashoffset", it));
            } else
              g5 && c5("stroke-dasharray", Lct);
            for (var pt = 0; pt < zGt.length; pt++) {
              var mt = zGt[pt];
              if (g5 || s[mt] !== RK[mt]) {
                var Mt = s[mt] || RK[mt];
                Mt && c5(Z9n[pt], Mt);
              }
            }
          } else
            g5 && c5("stroke", Lct);
        }
        var SDe = "http://www.w3.org/2000/svg", MDe = "http://www.w3.org/1999/xlink", Y9n = "http://www.w3.org/2000/xmlns/", K9n = "http://www.w3.org/XML/1998/namespace";
        function CDe(c5) {
          return document.createElementNS(SDe, c5);
        }
        function G1(c5, s, r5, g5, b6) {
          return { tag: c5, attrs: r5 || {}, children: g5, text: b6, key: s };
        }
        function X9n(c5, s) {
          var r5 = [];
          if (s)
            for (var g5 in s) {
              var b6 = s[g5], S2 = g5;
              b6 !== false && (b6 !== true && b6 != null && (S2 += '="' + b6 + '"'), r5.push(S2));
            }
          return "<" + c5 + " " + r5.join(" ") + ">";
        }
        function Q9n(c5) {
          return "</" + c5 + ">";
        }
        function jGt(c5, s) {
          s = s || {};
          var r5 = s.newline ? `
` : "";
          function g5(b6) {
            var S2 = b6.children, A2 = b6.tag, k2 = b6.attrs;
            return X9n(A2, k2) + (b6.text || "") + (S2 ? "" + r5 + Ha2(S2, function(R6) {
              return g5(R6);
            }).join(r5) + r5 : "") + Q9n(A2);
          }
          return g5(c5);
        }
        function J9n(c5, s, r5) {
          r5 = r5 || {};
          var g5 = r5.newline ? `
` : "", b6 = " {" + g5, S2 = g5 + "}", A2 = Ha2(nf2(c5), function(R6) {
            return R6 + b6 + Ha2(nf2(c5[R6]), function(B3) {
              return B3 + ":" + c5[R6][B3] + ";";
            }).join(g5) + S2;
          }).join(g5), k2 = Ha2(nf2(s), function(R6) {
            return "@keyframes " + R6 + b6 + Ha2(nf2(s[R6]), function(B3) {
              return B3 + b6 + Ha2(nf2(s[R6][B3]), function(G3) {
                var Z3 = s[R6][B3][G3];
                return G3 === "d" && (Z3 = 'path("' + Z3 + '")'), G3 + ":" + Z3 + ";";
              }).join(g5) + S2;
            }).join(g5) + S2;
          }).join(g5);
          return !A2 && !k2 ? "" : ["<![CDATA[", A2, k2, "]]>"].join(g5);
        }
        function WGt(c5) {
          return { zrId: c5, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
        }
        function TDe(c5, s, r5, g5) {
          return G1("svg", "root", { width: c5, height: s, xmlns: SDe, "xmlns:xlink": MDe, version: "1.1", baseProfile: "full", viewBox: g5 ? "0 0 " + c5 + " " + s : false }, r5);
        }
        var ADe = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, mW = "transform-origin";
        function t7n(c5, s, r5) {
          var g5 = sa2({}, c5.shape);
          sa2(g5, s), c5.buildPath(r5, g5);
          var b6 = new wDe();
          return b6.reset(vSt(c5)), r5.rebuildPath(b6, 1), b6.generateStr(), b6.getStr();
        }
        function e7n(c5, s) {
          var r5 = s.originX, g5 = s.originY;
          (r5 || g5) && (c5[mW] = r5 + "px " + g5 + "px");
        }
        var n7n = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
        function IDe(c5, s) {
          var r5 = s.zrId + "-ani-" + s.cssAnimIdx++;
          return s.cssAnims[r5] = c5, r5;
        }
        function r7n(c5, s, r5) {
          var g5 = c5.shape.paths, b6 = {}, S2, A2;
          if (Ye2(g5, function(R6) {
            var B3 = WGt(r5.zrId);
            B3.animation = true, BMt(R6, {}, B3, true);
            var G3 = B3.cssAnims, Z3 = B3.cssNodes, X3 = nf2(G3), tt = X3.length;
            if (tt) {
              A2 = X3[tt - 1];
              var it = G3[A2];
              for (var pt in it) {
                var mt = it[pt];
                b6[pt] = b6[pt] || { d: "" }, b6[pt].d += mt.d || "";
              }
              for (var Mt in Z3) {
                var kt = Z3[Mt].animation;
                kt.indexOf(A2) >= 0 && (S2 = kt);
              }
            }
          }), !!S2) {
            s.d = false;
            var k2 = IDe(b6, r5);
            return S2.replace(A2, k2);
          }
        }
        function DDe(c5) {
          return gs(c5) ? ADe[c5] ? "cubic-bezier(" + ADe[c5] + ")" : $Y(c5) ? c5 : "" : "";
        }
        function BMt(c5, s, r5, g5) {
          var b6 = c5.animators, S2 = b6.length, A2 = [];
          if (c5 instanceof Zut) {
            var k2 = r7n(c5, s, r5);
            if (k2)
              A2.push(k2);
            else if (!S2)
              return;
          } else if (!S2)
            return;
          for (var R6 = {}, B3 = 0; B3 < S2; B3++) {
            var G3 = b6[B3], Z3 = [G3.getMaxTime() / 1e3 + "s"], X3 = DDe(G3.getClip().easing), tt = G3.getDelay();
            X3 ? Z3.push(X3) : Z3.push("linear"), tt && Z3.push(tt / 1e3 + "s"), G3.getLoop() && Z3.push("infinite");
            var it = Z3.join(" ");
            R6[it] = R6[it] || [it, []], R6[it][1].push(G3);
          }
          function pt(kt) {
            var Gt = kt[1], Ot = Gt.length, ce2 = {}, ae2 = {}, de2 = {}, we2 = "animation-timing-function";
            function Se2(ss, Us, sl) {
              for (var ws = ss.getTracks(), Ll = ss.getMaxTime(), dh2 = 0; dh2 < ws.length; dh2++) {
                var hu = ws[dh2];
                if (hu.needsAnimate()) {
                  var Nh2 = hu.keyframes, cp = hu.propName;
                  if (sl && (cp = sl(cp)), cp)
                    for (var Xh2 = 0; Xh2 < Nh2.length; Xh2++) {
                      var om = Nh2[Xh2], Sv = Math.round(om.time / Ll * 100) + "%", U1 = DDe(om.easing), Jd2 = om.rawValue;
                      (gs(Jd2) || Oh2(Jd2)) && (Us[Sv] = Us[Sv] || {}, Us[Sv][cp] = om.rawValue, U1 && (Us[Sv][we2] = U1));
                    }
                }
              }
            }
            for (var Oe2 = 0; Oe2 < Ot; Oe2++) {
              var je2 = Gt[Oe2], rn = je2.targetName;
              rn ? rn === "shape" && Se2(je2, ae2) : !g5 && Se2(je2, ce2);
            }
            for (var qe2 in ce2) {
              var An = {};
              ASt(An, c5), sa2(An, ce2[qe2]);
              var jn = ySt(An), _n = ce2[qe2][we2];
              de2[qe2] = jn ? { transform: jn } : {}, e7n(de2[qe2], An), _n && (de2[qe2][we2] = _n);
            }
            var Jr, Qn = true;
            for (var qe2 in ae2) {
              de2[qe2] = de2[qe2] || {};
              var rr = !Jr, _n = ae2[qe2][we2];
              rr && (Jr = new jI());
              var Ar = Jr.len();
              Jr.reset(), de2[qe2].d = t7n(c5, ae2[qe2], Jr);
              var fi2 = Jr.len();
              if (!rr && Ar !== fi2) {
                Qn = false;
                break;
              }
              _n && (de2[qe2][we2] = _n);
            }
            if (!Qn)
              for (var qe2 in de2)
                delete de2[qe2].d;
            if (!g5)
              for (var Oe2 = 0; Oe2 < Ot; Oe2++) {
                var je2 = Gt[Oe2], rn = je2.targetName;
                rn === "style" && Se2(je2, de2, function(ws) {
                  return n7n[ws];
                });
              }
            for (var mi2 = nf2(de2), Oo = true, Ts, Oe2 = 1; Oe2 < mi2.length; Oe2++) {
              var gl = mi2[Oe2 - 1], nl = mi2[Oe2];
              if (de2[gl][mW] !== de2[nl][mW]) {
                Oo = false;
                break;
              }
              Ts = de2[gl][mW];
            }
            if (Oo && Ts) {
              for (var qe2 in de2)
                de2[qe2][mW] && delete de2[qe2][mW];
              s[mW] = Ts;
            }
            if (jp(mi2, function(ss) {
              return nf2(de2[ss]).length > 0;
            }).length) {
              var rl = IDe(de2, r5);
              return rl + " " + kt[0] + " both";
            }
          }
          for (var mt in R6) {
            var k2 = pt(R6[mt]);
            k2 && A2.push(k2);
          }
          if (A2.length) {
            var Mt = r5.zrId + "-cls-" + r5.cssClassIdx++;
            r5.cssNodes["." + Mt] = { animation: A2.join(",") }, s.class = Mt;
          }
        }
        var Oct = Math.round;
        function EDe(c5) {
          return c5 && gs(c5.src);
        }
        function kDe(c5) {
          return c5 && Tl(c5.toDataURL);
        }
        function GGt(c5, s, r5, g5) {
          $9n(function(b6, S2) {
            var A2 = b6 === "fill" || b6 === "stroke";
            A2 && Ezt(S2) ? f7n(s, c5, b6, g5) : A2 && Dzt(S2) ? h7n(r5, c5, b6, g5) : c5[b6] = S2;
          }, s, r5, false), c7n(r5, c5, g5);
        }
        function PDe(c5) {
          return o3(c5[0] - 1) && o3(c5[1]) && o3(c5[2]) && o3(c5[3] - 1);
        }
        function i7n(c5) {
          return o3(c5[4]) && o3(c5[5]);
        }
        function HGt(c5, s, r5) {
          if (s && !(i7n(s) && PDe(s))) {
            var g5 = r5 ? 10 : 1e4;
            c5.transform = PDe(s) ? "translate(" + Oct(s[4] * g5) / g5 + " " + Oct(s[5] * g5) / g5 + ")" : Mzt(s);
          }
        }
        function LDe(c5, s, r5) {
          for (var g5 = c5.points, b6 = [], S2 = 0; S2 < g5.length; S2++)
            b6.push(Oct(g5[S2][0] * r5) / r5), b6.push(Oct(g5[S2][1] * r5) / r5);
          s.points = b6.join(" ");
        }
        function ODe(c5) {
          return !c5.smooth;
        }
        function a7n(c5) {
          var s = Ha2(c5, function(r5) {
            return typeof r5 == "string" ? [r5, r5] : r5;
          });
          return function(r5, g5, b6) {
            for (var S2 = 0; S2 < s.length; S2++) {
              var A2 = s[S2], k2 = r5[A2[0]];
              k2 != null && (g5[A2[1]] = Oct(k2 * b6) / b6);
            }
          };
        }
        var o7n = { circle: [a7n(["cx", "cy", "r"])], polyline: [LDe, ODe], polygon: [LDe, ODe] };
        function s7n(c5) {
          for (var s = c5.animators, r5 = 0; r5 < s.length; r5++)
            if (s[r5].targetName === "shape")
              return true;
          return false;
        }
        function RDe(c5, s) {
          var r5 = c5.style, g5 = c5.shape, b6 = o7n[c5.type], S2 = {}, A2 = s.animation, k2 = "path", R6 = c5.style.strokePercent, B3 = s.compress && vSt(c5) || 4;
          if (b6 && !s.willUpdate && !(b6[1] && !b6[1](g5)) && !(A2 && s7n(c5)) && !(R6 < 1)) {
            k2 = c5.type;
            var G3 = Math.pow(10, B3);
            b6[0](g5, S2, G3);
          } else {
            c5.path || c5.createPathProxy();
            var Z3 = c5.path;
            c5.shapeChanged() && (Z3.beginPath(), c5.buildPath(Z3, c5.shape), c5.pathUpdated());
            var X3 = Z3.getVersion(), tt = c5, it = tt.__svgPathBuilder;
            (tt.__svgPathVersion !== X3 || !it || R6 !== tt.__svgPathStrokePercent) && (it || (it = tt.__svgPathBuilder = new wDe()), it.reset(B3), Z3.rebuildPath(it, R6), it.generateStr(), tt.__svgPathVersion = X3, tt.__svgPathStrokePercent = R6), S2.d = it.getStr();
          }
          return HGt(S2, c5.transform), GGt(S2, r5, c5, s), s.animation && BMt(c5, S2, s), G1(k2, c5.id + "", S2);
        }
        function l7n(c5, s) {
          var r5 = c5.style, g5 = r5.image;
          if (g5 && !gs(g5) && (EDe(g5) ? g5 = g5.src : kDe(g5) && (g5 = g5.toDataURL())), !!g5) {
            var b6 = r5.x || 0, S2 = r5.y || 0, A2 = r5.width, k2 = r5.height, R6 = { href: g5, width: A2, height: k2 };
            return b6 && (R6.x = b6), S2 && (R6.y = S2), HGt(R6, c5.transform), GGt(R6, r5, c5, s), s.animation && BMt(c5, R6, s), G1("image", c5.id + "", R6);
          }
        }
        function u7n(c5, s) {
          var r5 = c5.style, g5 = r5.text;
          if (g5 != null && (g5 += ""), !(!g5 || isNaN(r5.x) || isNaN(r5.y))) {
            var b6 = r5.font || Yh2, S2 = r5.x || 0, A2 = yk(r5.y || 0, Lj2(b6), r5.textBaseline), k2 = Czt[r5.textAlign] || r5.textAlign, R6 = { "dominant-baseline": "central", "text-anchor": k2 };
            if (s2t(r5)) {
              var B3 = "", G3 = r5.fontStyle, Z3 = a2t(r5.fontSize);
              if (!parseFloat(Z3))
                return;
              var X3 = r5.fontFamily || Lh2, tt = r5.fontWeight;
              B3 += "font-size:" + Z3 + ";font-family:" + X3 + ";", G3 && G3 !== "normal" && (B3 += "font-style:" + G3 + ";"), tt && tt !== "normal" && (B3 += "font-weight:" + tt + ";"), R6.style = B3;
            } else
              R6.style = "font: " + b6;
            return g5.match(/\s/) && (R6["xml:space"] = "preserve"), S2 && (R6.x = S2), A2 && (R6.y = A2), HGt(R6, c5.transform), GGt(R6, r5, c5, s), s.animation && BMt(c5, R6, s), G1("text", c5.id + "", R6, void 0, g5);
          }
        }
        function NDe(c5, s) {
          if (c5 instanceof Tc2)
            return RDe(c5, s);
          if (c5 instanceof qm)
            return l7n(c5, s);
          if (c5 instanceof qj2)
            return u7n(c5, s);
        }
        function c7n(c5, s, r5) {
          var g5 = c5.style;
          if (Tzt(g5)) {
            var b6 = Azt(c5), S2 = r5.shadowCache, A2 = S2[b6];
            if (!A2) {
              var k2 = c5.getGlobalScale(), R6 = k2[0], B3 = k2[1];
              if (!R6 || !B3)
                return;
              var G3 = g5.shadowOffsetX || 0, Z3 = g5.shadowOffsetY || 0, X3 = g5.shadowBlur, tt = N8(g5.shadowColor), it = tt.opacity, pt = tt.color, mt = X3 / 2 / R6, Mt = X3 / 2 / B3, kt = mt + " " + Mt;
              A2 = r5.zrId + "-s" + r5.shadowIdx++, r5.defs[A2] = G1("filter", A2, { id: A2, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [G1("feDropShadow", "", { dx: G3 / R6, dy: Z3 / B3, stdDeviation: kt, "flood-color": pt, "flood-opacity": it })]), S2[b6] = A2;
            }
            s.filter = Nw(A2);
          }
        }
        function f7n(c5, s, r5, g5) {
          var b6 = c5[r5], S2, A2 = { gradientUnits: b6.global ? "userSpaceOnUse" : "objectBoundingBox" };
          if (s3(b6))
            S2 = "linearGradient", A2.x1 = b6.x, A2.y1 = b6.y, A2.x2 = b6.x2, A2.y2 = b6.y2;
          else if (gSt(b6))
            S2 = "radialGradient", A2.cx = tc2(b6.x, 0.5), A2.cy = tc2(b6.y, 0.5), A2.r = tc2(b6.r, 0.5);
          else
            return;
          for (var k2 = b6.colorStops, R6 = [], B3 = 0, G3 = k2.length; B3 < G3; ++B3) {
            var Z3 = Mlt(k2[B3].offset) * 100 + "%", X3 = k2[B3].color, tt = N8(X3), it = tt.color, pt = tt.opacity, mt = { offset: Z3 };
            mt["stop-color"] = it, pt < 1 && (mt["stop-opacity"] = pt), R6.push(G1("stop", B3 + "", mt));
          }
          var Mt = G1(S2, "", A2, R6), kt = jGt(Mt), Gt = g5.gradientCache, Ot = Gt[kt];
          Ot || (Ot = g5.zrId + "-g" + g5.gradientIdx++, Gt[kt] = Ot, A2.id = Ot, g5.defs[Ot] = G1(S2, Ot, A2, R6)), s[r5] = Nw(Ot);
        }
        function h7n(c5, s, r5, g5) {
          var b6 = c5.style[r5], S2 = { patternUnits: "userSpaceOnUse" }, A2;
          if (dSt(b6)) {
            var k2 = b6.imageWidth, R6 = b6.imageHeight, B3 = void 0, G3 = b6.image;
            if (gs(G3) ? B3 = G3 : EDe(G3) ? B3 = G3.src : kDe(G3) && (B3 = G3.toDataURL()), typeof Image == "undefined") {
              var Z3 = "Image width/height must been given explictly in svg-ssr renderer.";
              lx(k2, Z3), lx(R6, Z3);
            } else if (k2 == null || R6 == null) {
              var X3 = function(kt, Gt) {
                if (kt) {
                  var Ot = kt.elm, ce2 = kt.attrs.width = k2 || Gt.width, ae2 = kt.attrs.height = R6 || Gt.height;
                  Ot && (Ot.setAttribute("width", ce2), Ot.setAttribute("height", ae2));
                }
              }, tt = iut(B3, null, c5, function(kt) {
                X3(it, kt), X3(A2, kt);
              });
              tt && tt.width && tt.height && (k2 = k2 || tt.width, R6 = R6 || tt.height);
            }
            A2 = G1("image", "img", { href: B3, width: k2, height: R6 }), S2.width = k2, S2.height = R6;
          } else
            b6.svgElement && (A2 = Ml(b6.svgElement), S2.width = b6.svgWidth, S2.height = b6.svgHeight);
          if (A2) {
            S2.patternTransform = ySt(b6);
            var it = G1("pattern", "", S2, [A2]), pt = jGt(it), mt = g5.patternCache, Mt = mt[pt];
            Mt || (Mt = g5.zrId + "-p" + g5.patternIdx++, mt[pt] = Mt, S2.id = Mt, it = g5.defs[Mt] = G1("pattern", Mt, S2, [A2])), s[r5] = Nw(Mt);
          }
        }
        function p7n(c5, s, r5) {
          var g5 = r5.clipPathCache, b6 = r5.defs, S2 = g5[c5.id];
          if (!S2) {
            S2 = r5.zrId + "-c" + r5.clipPathIdx++;
            var A2 = { id: S2 };
            g5[c5.id] = S2, b6[S2] = G1("clipPath", S2, A2, [RDe(c5, r5)]);
          }
          s["clip-path"] = Nw(S2);
        }
        function FDe(c5) {
          return document.createTextNode(c5);
        }
        function bW(c5, s, r5) {
          c5.insertBefore(s, r5);
        }
        function VDe(c5, s) {
          c5.removeChild(s);
        }
        function BDe(c5, s) {
          c5.appendChild(s);
        }
        function zDe(c5) {
          return c5.parentNode;
        }
        function jDe(c5) {
          return c5.nextSibling;
        }
        function UGt(c5, s) {
          c5.textContent = s;
        }
        var WDe = 58, d7n = 120, g7n = G1("", "");
        function qGt(c5) {
          return c5 === void 0;
        }
        function O3(c5) {
          return c5 !== void 0;
        }
        function v7n(c5, s, r5) {
          for (var g5 = {}, b6 = s; b6 <= r5; ++b6) {
            var S2 = c5[b6].key;
            S2 !== void 0 && (g5[S2] = b6);
          }
          return g5;
        }
        function Rct(c5, s) {
          var r5 = c5.key === s.key, g5 = c5.tag === s.tag;
          return g5 && r5;
        }
        function Nct(c5) {
          var s, r5 = c5.children, g5 = c5.tag;
          if (O3(g5)) {
            var b6 = c5.elm = CDe(g5);
            if (ZGt(g7n, c5), ja2(r5))
              for (s = 0; s < r5.length; ++s) {
                var S2 = r5[s];
                S2 != null && BDe(b6, Nct(S2));
              }
            else
              O3(c5.text) && !Wl(c5.text) && BDe(b6, FDe(c5.text));
          } else
            c5.elm = FDe(c5.text);
          return c5.elm;
        }
        function GDe(c5, s, r5, g5, b6) {
          for (; g5 <= b6; ++g5) {
            var S2 = r5[g5];
            S2 != null && bW(c5, Nct(S2), s);
          }
        }
        function zMt(c5, s, r5, g5) {
          for (; r5 <= g5; ++r5) {
            var b6 = s[r5];
            if (b6 != null)
              if (O3(b6.tag)) {
                var S2 = zDe(b6.elm);
                VDe(S2, b6.elm);
              } else
                VDe(c5, b6.elm);
          }
        }
        function ZGt(c5, s) {
          var r5, g5 = s.elm, b6 = c5 && c5.attrs || {}, S2 = s.attrs || {};
          if (b6 !== S2) {
            for (r5 in S2) {
              var A2 = S2[r5], k2 = b6[r5];
              k2 !== A2 && (A2 === true ? g5.setAttribute(r5, "") : A2 === false ? g5.removeAttribute(r5) : r5.charCodeAt(0) !== d7n ? g5.setAttribute(r5, A2) : r5 === "xmlns:xlink" || r5 === "xmlns" ? g5.setAttributeNS(Y9n, r5, A2) : r5.charCodeAt(3) === WDe ? g5.setAttributeNS(K9n, r5, A2) : r5.charCodeAt(5) === WDe ? g5.setAttributeNS(MDe, r5, A2) : g5.setAttribute(r5, A2));
            }
            for (r5 in b6)
              r5 in S2 || g5.removeAttribute(r5);
          }
        }
        function y7n(c5, s, r5) {
          for (var g5 = 0, b6 = 0, S2 = s.length - 1, A2 = s[0], k2 = s[S2], R6 = r5.length - 1, B3 = r5[0], G3 = r5[R6], Z3, X3, tt, it; g5 <= S2 && b6 <= R6; )
            A2 == null ? A2 = s[++g5] : k2 == null ? k2 = s[--S2] : B3 == null ? B3 = r5[++b6] : G3 == null ? G3 = r5[--R6] : Rct(A2, B3) ? (xX(A2, B3), A2 = s[++g5], B3 = r5[++b6]) : Rct(k2, G3) ? (xX(k2, G3), k2 = s[--S2], G3 = r5[--R6]) : Rct(A2, G3) ? (xX(A2, G3), bW(c5, A2.elm, jDe(k2.elm)), A2 = s[++g5], G3 = r5[--R6]) : Rct(k2, B3) ? (xX(k2, B3), bW(c5, k2.elm, A2.elm), k2 = s[--S2], B3 = r5[++b6]) : (qGt(Z3) && (Z3 = v7n(s, g5, S2)), X3 = Z3[B3.key], qGt(X3) ? bW(c5, Nct(B3), A2.elm) : (tt = s[X3], tt.tag !== B3.tag ? bW(c5, Nct(B3), A2.elm) : (xX(tt, B3), s[X3] = void 0, bW(c5, tt.elm, A2.elm))), B3 = r5[++b6]);
          (g5 <= S2 || b6 <= R6) && (g5 > S2 ? (it = r5[R6 + 1] == null ? null : r5[R6 + 1].elm, GDe(c5, it, r5, b6, R6)) : zMt(c5, s, g5, S2));
        }
        function xX(c5, s) {
          var r5 = s.elm = c5.elm, g5 = c5.children, b6 = s.children;
          c5 !== s && (ZGt(c5, s), qGt(s.text) ? O3(g5) && O3(b6) ? g5 !== b6 && y7n(r5, g5, b6) : O3(b6) ? (O3(c5.text) && UGt(r5, ""), GDe(r5, null, b6, 0, b6.length - 1)) : O3(g5) ? zMt(r5, g5, 0, g5.length - 1) : O3(c5.text) && UGt(r5, "") : c5.text !== s.text && (O3(g5) && zMt(r5, g5, 0, g5.length - 1), UGt(r5, s.text)));
        }
        function m7n(c5, s) {
          if (Rct(c5, s))
            xX(c5, s);
          else {
            var r5 = c5.elm, g5 = zDe(r5);
            Nct(s), g5 !== null && (bW(g5, s.elm, jDe(r5)), zMt(g5, [c5], 0, 0));
          }
          return s;
        }
        var b7n = 0, _7n = function() {
          function c5(s, r5, g5) {
            if (this.type = "svg", this.refreshHover = HDe(), this.configLayer = HDe(), this.storage = r5, this._opts = g5 = sa2({}, g5), this.root = s, this._id = "zr" + b7n++, this._oldVNode = TDe(g5.width, g5.height), s && !g5.ssr) {
              var b6 = this._viewport = document.createElement("div");
              b6.style.cssText = "position:relative;overflow:hidden";
              var S2 = this._svgDom = this._oldVNode.elm = CDe("svg");
              ZGt(null, this._oldVNode), b6.appendChild(S2), s.appendChild(b6);
            }
            this.resize(g5.width, g5.height);
          }
          return c5.prototype.getType = function() {
            return this.type;
          }, c5.prototype.getViewportRoot = function() {
            return this._viewport;
          }, c5.prototype.getViewportRootOffset = function() {
            var s = this.getViewportRoot();
            if (s)
              return { offsetLeft: s.offsetLeft || 0, offsetTop: s.offsetTop || 0 };
          }, c5.prototype.getSvgDom = function() {
            return this._svgDom;
          }, c5.prototype.refresh = function() {
            if (this.root) {
              var s = this.renderToVNode({ willUpdate: true });
              s.attrs.style = "position:absolute;left:0;top:0;user-select:none", m7n(this._oldVNode, s), this._oldVNode = s;
            }
          }, c5.prototype.renderOneToVNode = function(s) {
            return NDe(s, WGt(this._id));
          }, c5.prototype.renderToVNode = function(s) {
            s = s || {};
            var r5 = this.storage.getDisplayList(true), g5 = this._backgroundColor, b6 = this._width, S2 = this._height, A2 = WGt(this._id);
            A2.animation = s.animation, A2.willUpdate = s.willUpdate, A2.compress = s.compress;
            var k2 = [];
            if (g5 && g5 !== "none") {
              var R6 = N8(g5), B3 = R6.color, G3 = R6.opacity;
              this._bgVNode = G1("rect", "bg", { width: b6, height: S2, x: "0", y: "0", id: "0", fill: B3, "fill-opacity": G3 }), k2.push(this._bgVNode);
            } else
              this._bgVNode = null;
            var Z3 = s.compress ? null : this._mainVNode = G1("g", "main", {}, []);
            this._paintList(r5, A2, Z3 ? Z3.children : k2), Z3 && k2.push(Z3);
            var X3 = Ha2(nf2(A2.defs), function(pt) {
              return A2.defs[pt];
            });
            if (X3.length && k2.push(G1("defs", "defs", {}, X3)), s.animation) {
              var tt = J9n(A2.cssNodes, A2.cssAnims, { newline: true });
              if (tt) {
                var it = G1("style", "stl", {}, [], tt);
                k2.push(it);
              }
            }
            return TDe(b6, S2, k2, s.useViewBox);
          }, c5.prototype.renderToString = function(s) {
            return s = s || {}, jGt(this.renderToVNode({ animation: tc2(s.cssAnimation, true), willUpdate: false, compress: true, useViewBox: tc2(s.useViewBox, true) }), { newline: true });
          }, c5.prototype.setBackgroundColor = function(s) {
            this._backgroundColor = s;
            var r5 = this._bgVNode;
            if (r5 && r5.elm) {
              var g5 = N8(s), b6 = g5.color, S2 = g5.opacity;
              r5.elm.setAttribute("fill", b6), S2 < 1 && r5.elm.setAttribute("fill-opacity", S2);
            }
          }, c5.prototype.getSvgRoot = function() {
            return this._mainVNode && this._mainVNode.elm;
          }, c5.prototype._paintList = function(s, r5, g5) {
            for (var b6 = s.length, S2 = [], A2 = 0, k2, R6, B3 = 0, G3 = 0; G3 < b6; G3++) {
              var Z3 = s[G3];
              if (!Z3.invisible) {
                var X3 = Z3.__clipPaths, tt = X3 && X3.length || 0, it = R6 && R6.length || 0, pt = void 0;
                for (pt = Math.max(tt - 1, it - 1); pt >= 0 && !(X3 && R6 && X3[pt] === R6[pt]); pt--)
                  ;
                for (var mt = it - 1; mt > pt; mt--)
                  A2--, k2 = S2[A2 - 1];
                for (var Mt = pt + 1; Mt < tt; Mt++) {
                  var kt = {};
                  p7n(X3[Mt], kt, r5);
                  var Gt = G1("g", "clip-g-" + B3++, kt, []);
                  (k2 ? k2.children : g5).push(Gt), S2[A2++] = Gt, k2 = Gt;
                }
                R6 = X3;
                var Ot = NDe(Z3, r5);
                Ot && (k2 ? k2.children : g5).push(Ot);
              }
            }
          }, c5.prototype.resize = function(s, r5) {
            var g5 = this._opts, b6 = this.root, S2 = this._viewport;
            if (s != null && (g5.width = s), r5 != null && (g5.height = r5), b6 && S2 && (S2.style.display = "none", s = yX(b6, 0, g5), r5 = yX(b6, 1, g5), S2.style.display = ""), this._width !== s || this._height !== r5) {
              if (this._width = s, this._height = r5, S2) {
                var A2 = S2.style;
                A2.width = s + "px", A2.height = r5 + "px";
              }
              var k2 = this._svgDom;
              k2 && (k2.setAttribute("width", s), k2.setAttribute("height", r5));
            }
          }, c5.prototype.getWidth = function() {
            return this._width;
          }, c5.prototype.getHeight = function() {
            return this._height;
          }, c5.prototype.dispose = function() {
            this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
          }, c5.prototype.clear = function() {
            this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
          }, c5.prototype.toDataURL = function(s) {
            var r5 = encodeURIComponent(this.renderToString()), g5 = "data:image/svg+xml;";
            return s ? (r5 = kzt(r5), r5 && g5 + "base64," + r5) : g5 + "charset=UTF-8," + r5;
          }, c5;
        }();
        function HDe(c5) {
          return function() {
          };
        }
        var x7n = _7n;
        function w7n(c5) {
          c5.registerPainter("svg", x7n);
        }
        function UDe(c5, s, r5) {
          var g5 = T0.createCanvas(), b6 = s.getWidth(), S2 = s.getHeight(), A2 = g5.style;
          return A2 && (A2.position = "absolute", A2.left = "0", A2.top = "0", A2.width = b6 + "px", A2.height = S2 + "px", g5.setAttribute("data-zr-dom-id", c5)), g5.width = b6 * r5, g5.height = S2 * r5, g5;
        }
        var S7n = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this) || this;
            S2.motionBlur = false, S2.lastFrameAlpha = 0.7, S2.dpr = 1, S2.virtual = false, S2.config = {}, S2.incremental = false, S2.zlevel = 0, S2.maxRepaintRectCount = 5, S2.__dirty = true, S2.__firstTimePaint = true, S2.__used = false, S2.__drawIndex = 0, S2.__startIndex = 0, S2.__endIndex = 0, S2.__prevStartIndex = null, S2.__prevEndIndex = null;
            var A2;
            b6 = b6 || uK, typeof r5 == "string" ? A2 = UDe(r5, g5, b6) : Wl(r5) && (A2 = r5, r5 = A2.id), S2.id = r5, S2.dom = A2;
            var k2 = A2.style;
            return k2 && (tlt(A2), A2.onselectstart = function() {
              return false;
            }, k2.padding = "0", k2.margin = "0", k2.borderWidth = "0"), S2.painter = g5, S2.dpr = b6, S2;
          }
          return s.prototype.getElementCount = function() {
            return this.__endIndex - this.__startIndex;
          }, s.prototype.afterBrush = function() {
            this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
          }, s.prototype.initContext = function() {
            this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
          }, s.prototype.setUnpainted = function() {
            this.__firstTimePaint = true;
          }, s.prototype.createBackBuffer = function() {
            var r5 = this.dpr;
            this.domBack = UDe("back-" + this.id, this.painter, r5), this.ctxBack = this.domBack.getContext("2d"), r5 !== 1 && this.ctxBack.scale(r5, r5);
          }, s.prototype.createRepaintRects = function(r5, g5, b6, S2) {
            if (this.__firstTimePaint)
              return this.__firstTimePaint = false, null;
            var A2 = [], k2 = this.maxRepaintRectCount, R6 = false, B3 = new lc2(0, 0, 0, 0);
            function G3(kt) {
              if (!(!kt.isFinite() || kt.isZero()))
                if (A2.length === 0) {
                  var Gt = new lc2(0, 0, 0, 0);
                  Gt.copy(kt), A2.push(Gt);
                } else {
                  for (var Ot = false, ce2 = 1 / 0, ae2 = 0, de2 = 0; de2 < A2.length; ++de2) {
                    var we2 = A2[de2];
                    if (we2.intersect(kt)) {
                      var Se2 = new lc2(0, 0, 0, 0);
                      Se2.copy(we2), Se2.union(kt), A2[de2] = Se2, Ot = true;
                      break;
                    } else if (R6) {
                      B3.copy(kt), B3.union(we2);
                      var Oe2 = kt.width * kt.height, je2 = we2.width * we2.height, rn = B3.width * B3.height, qe2 = rn - Oe2 - je2;
                      qe2 < ce2 && (ce2 = qe2, ae2 = de2);
                    }
                  }
                  if (R6 && (A2[ae2].union(kt), Ot = true), !Ot) {
                    var Gt = new lc2(0, 0, 0, 0);
                    Gt.copy(kt), A2.push(Gt);
                  }
                  R6 || (R6 = A2.length >= k2);
                }
            }
            for (var Z3 = this.__startIndex; Z3 < this.__endIndex; ++Z3) {
              var X3 = r5[Z3];
              if (X3) {
                var tt = X3.shouldBePainted(b6, S2, true, true), it = X3.__isRendered && (X3.__dirty & Vb2 || !tt) ? X3.getPrevPaintRect() : null;
                it && G3(it);
                var pt = tt && (X3.__dirty & Vb2 || !X3.__isRendered) ? X3.getPaintRect() : null;
                pt && G3(pt);
              }
            }
            for (var Z3 = this.__prevStartIndex; Z3 < this.__prevEndIndex; ++Z3) {
              var X3 = g5[Z3], tt = X3.shouldBePainted(b6, S2, true, true);
              if (X3 && (!tt || !X3.__zr) && X3.__isRendered) {
                var it = X3.getPrevPaintRect();
                it && G3(it);
              }
            }
            var mt;
            do {
              mt = false;
              for (var Z3 = 0; Z3 < A2.length; ) {
                if (A2[Z3].isZero()) {
                  A2.splice(Z3, 1);
                  continue;
                }
                for (var Mt = Z3 + 1; Mt < A2.length; )
                  A2[Z3].intersect(A2[Mt]) ? (mt = true, A2[Z3].union(A2[Mt]), A2.splice(Mt, 1)) : Mt++;
                Z3++;
              }
            } while (mt);
            return this._paintRects = A2, A2;
          }, s.prototype.debugGetPaintRects = function() {
            return (this._paintRects || []).slice();
          }, s.prototype.resize = function(r5, g5) {
            var b6 = this.dpr, S2 = this.dom, A2 = S2.style, k2 = this.domBack;
            A2 && (A2.width = r5 + "px", A2.height = g5 + "px"), S2.width = r5 * b6, S2.height = g5 * b6, k2 && (k2.width = r5 * b6, k2.height = g5 * b6, b6 !== 1 && this.ctxBack.scale(b6, b6));
          }, s.prototype.clear = function(r5, g5, b6) {
            var S2 = this.dom, A2 = this.ctx, k2 = S2.width, R6 = S2.height;
            g5 = g5 || this.clearColor;
            var B3 = this.motionBlur && !r5, G3 = this.lastFrameAlpha, Z3 = this.dpr, X3 = this;
            B3 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(S2, 0, 0, k2 / Z3, R6 / Z3));
            var tt = this.domBack;
            function it(pt, mt, Mt, kt) {
              if (A2.clearRect(pt, mt, Mt, kt), g5 && g5 !== "transparent") {
                var Gt = void 0;
                Xd2(g5) ? (Gt = g5.__canvasGradient || tGt(A2, g5, { x: 0, y: 0, width: Mt, height: kt }), g5.__canvasGradient = Gt) : Jg2(g5) && (Gt = nGt(A2, g5, { dirty: function() {
                  X3.setUnpainted(), X3.__painter.refresh();
                } })), A2.save(), A2.fillStyle = Gt || g5, A2.fillRect(pt, mt, Mt, kt), A2.restore();
              }
              B3 && (A2.save(), A2.globalAlpha = G3, A2.drawImage(tt, pt, mt, Mt, kt), A2.restore());
            }
            !b6 || B3 ? it(0, 0, k2, R6) : b6.length && Ye2(b6, function(pt) {
              it(pt.x * Z3, pt.y * Z3, pt.width * Z3, pt.height * Z3);
            });
          }, s;
        }(Lw), $Gt = S7n, qDe = 1e5, _W = 314159, jMt = 0.01, M7n = 1e-3;
        function C7n(c5) {
          return c5 ? c5.__builtin__ ? true : !(typeof c5.resize != "function" || typeof c5.refresh != "function") : false;
        }
        function T7n(c5, s) {
          var r5 = document.createElement("div");
          return r5.style.cssText = ["position:relative", "width:" + c5 + "px", "height:" + s + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", r5;
        }
        var A7n = function() {
          function c5(s, r5, g5, b6) {
            this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
            var S2 = !s.nodeName || s.nodeName.toUpperCase() === "CANVAS";
            this._opts = g5 = sa2({}, g5 || {}), this.dpr = g5.devicePixelRatio || uK, this._singleCanvas = S2, this.root = s;
            var A2 = s.style;
            A2 && (tlt(s), s.innerHTML = ""), this.storage = r5;
            var k2 = this._zlevelList;
            this._prevDisplayList = [];
            var R6 = this._layers;
            if (S2) {
              var B3 = s, G3 = B3.width, Z3 = B3.height;
              g5.width != null && (G3 = g5.width), g5.height != null && (Z3 = g5.height), this.dpr = g5.devicePixelRatio || 1, B3.width = G3 * this.dpr, B3.height = Z3 * this.dpr, this._width = G3, this._height = Z3;
              var X3 = new $Gt(B3, this, this.dpr);
              X3.__builtin__ = true, X3.initContext(), R6[_W] = X3, X3.zlevel = _W, k2.push(_W), this._domRoot = s;
            } else {
              this._width = yX(s, 0, g5), this._height = yX(s, 1, g5);
              var tt = this._domRoot = T7n(this._width, this._height);
              s.appendChild(tt);
            }
          }
          return c5.prototype.getType = function() {
            return "canvas";
          }, c5.prototype.isSingleCanvas = function() {
            return this._singleCanvas;
          }, c5.prototype.getViewportRoot = function() {
            return this._domRoot;
          }, c5.prototype.getViewportRootOffset = function() {
            var s = this.getViewportRoot();
            if (s)
              return { offsetLeft: s.offsetLeft || 0, offsetTop: s.offsetTop || 0 };
          }, c5.prototype.refresh = function(s) {
            var r5 = this.storage.getDisplayList(true), g5 = this._prevDisplayList, b6 = this._zlevelList;
            this._redrawId = Math.random(), this._paintList(r5, g5, s, this._redrawId);
            for (var S2 = 0; S2 < b6.length; S2++) {
              var A2 = b6[S2], k2 = this._layers[A2];
              if (!k2.__builtin__ && k2.refresh) {
                var R6 = S2 === 0 ? this._backgroundColor : null;
                k2.refresh(R6);
              }
            }
            return this._opts.useDirtyRect && (this._prevDisplayList = r5.slice()), this;
          }, c5.prototype.refreshHover = function() {
            this._paintHoverList(this.storage.getDisplayList(false));
          }, c5.prototype._paintHoverList = function(s) {
            var r5 = s.length, g5 = this._hoverlayer;
            if (g5 && g5.clear(), !!r5) {
              for (var b6 = { inHover: true, viewWidth: this._width, viewHeight: this._height }, S2, A2 = 0; A2 < r5; A2++) {
                var k2 = s[A2];
                k2.__inHover && (g5 || (g5 = this._hoverlayer = this.getLayer(qDe)), S2 || (S2 = g5.ctx, S2.save()), hW(S2, k2, b6, A2 === r5 - 1));
              }
              S2 && S2.restore();
            }
          }, c5.prototype.getHoverLayer = function() {
            return this.getLayer(qDe);
          }, c5.prototype.paintOne = function(s, r5) {
            GAe(s, r5);
          }, c5.prototype._paintList = function(s, r5, g5, b6) {
            if (this._redrawId === b6) {
              g5 = g5 || false, this._updateLayerStatus(s);
              var S2 = this._doPaintList(s, r5, g5), A2 = S2.finished, k2 = S2.needsRefreshHover;
              if (this._needsManuallyCompositing && this._compositeManually(), k2 && this._paintHoverList(s), A2)
                this.eachLayer(function(B3) {
                  B3.afterBrush && B3.afterBrush();
                });
              else {
                var R6 = this;
                dlt(function() {
                  R6._paintList(s, r5, g5, b6);
                });
              }
            }
          }, c5.prototype._compositeManually = function() {
            var s = this.getLayer(_W).ctx, r5 = this._domRoot.width, g5 = this._domRoot.height;
            s.clearRect(0, 0, r5, g5), this.eachBuiltinLayer(function(b6) {
              b6.virtual && s.drawImage(b6.dom, 0, 0, r5, g5);
            });
          }, c5.prototype._doPaintList = function(s, r5, g5) {
            for (var b6 = this, S2 = [], A2 = this._opts.useDirtyRect, k2 = 0; k2 < this._zlevelList.length; k2++) {
              var R6 = this._zlevelList[k2], B3 = this._layers[R6];
              B3.__builtin__ && B3 !== this._hoverlayer && (B3.__dirty || g5) && S2.push(B3);
            }
            for (var G3 = true, Z3 = false, X3 = function(pt) {
              var mt = S2[pt], Mt = mt.ctx, kt = A2 && mt.createRepaintRects(s, r5, tt._width, tt._height), Gt = g5 ? mt.__startIndex : mt.__drawIndex, Ot = !g5 && mt.incremental && Date.now, ce2 = Ot && Date.now(), ae2 = mt.zlevel === tt._zlevelList[0] ? tt._backgroundColor : null;
              if (mt.__startIndex === mt.__endIndex)
                mt.clear(false, ae2, kt);
              else if (Gt === mt.__startIndex) {
                var de2 = s[Gt];
                (!de2.incremental || !de2.notClear || g5) && mt.clear(false, ae2, kt);
              }
              Gt === -1 && (console.error("For some unknown reason. drawIndex is -1"), Gt = mt.__startIndex);
              var we2, Se2 = function(qe2) {
                var An = { inHover: false, allClipped: false, prevEl: null, viewWidth: b6._width, viewHeight: b6._height };
                for (we2 = Gt; we2 < mt.__endIndex; we2++) {
                  var jn = s[we2];
                  if (jn.__inHover && (Z3 = true), b6._doPaintEl(jn, mt, A2, qe2, An, we2 === mt.__endIndex - 1), Ot) {
                    var _n = Date.now() - ce2;
                    if (_n > 15)
                      break;
                  }
                }
                An.prevElClipPaths && Mt.restore();
              };
              if (kt)
                if (kt.length === 0)
                  we2 = mt.__endIndex;
                else
                  for (var Oe2 = tt.dpr, je2 = 0; je2 < kt.length; ++je2) {
                    var rn = kt[je2];
                    Mt.save(), Mt.beginPath(), Mt.rect(rn.x * Oe2, rn.y * Oe2, rn.width * Oe2, rn.height * Oe2), Mt.clip(), Se2(rn), Mt.restore();
                  }
              else
                Mt.save(), Se2(), Mt.restore();
              mt.__drawIndex = we2, mt.__drawIndex < mt.__endIndex && (G3 = false);
            }, tt = this, it = 0; it < S2.length; it++)
              X3(it);
            return os.wxa && Ye2(this._layers, function(pt) {
              pt && pt.ctx && pt.ctx.draw && pt.ctx.draw();
            }), { finished: G3, needsRefreshHover: Z3 };
          }, c5.prototype._doPaintEl = function(s, r5, g5, b6, S2, A2) {
            var k2 = r5.ctx;
            if (g5) {
              var R6 = s.getPaintRect();
              (!b6 || R6 && R6.intersect(b6)) && (hW(k2, s, S2, A2), s.setPrevPaintRect(R6));
            } else
              hW(k2, s, S2, A2);
          }, c5.prototype.getLayer = function(s, r5) {
            this._singleCanvas && !this._needsManuallyCompositing && (s = _W);
            var g5 = this._layers[s];
            return g5 || (g5 = new $Gt("zr_" + s, this, this.dpr), g5.zlevel = s, g5.__builtin__ = true, this._layerConfig[s] ? bu(g5, this._layerConfig[s], true) : this._layerConfig[s - jMt] && bu(g5, this._layerConfig[s - jMt], true), r5 && (g5.virtual = r5), this.insertLayer(s, g5), g5.initContext()), g5;
          }, c5.prototype.insertLayer = function(s, r5) {
            var g5 = this._layers, b6 = this._zlevelList, S2 = b6.length, A2 = this._domRoot, k2 = null, R6 = -1;
            if (!g5[s] && !!C7n(r5)) {
              if (S2 > 0 && s > b6[0]) {
                for (R6 = 0; R6 < S2 - 1 && !(b6[R6] < s && b6[R6 + 1] > s); R6++)
                  ;
                k2 = g5[b6[R6]];
              }
              if (b6.splice(R6 + 1, 0, s), g5[s] = r5, !r5.virtual)
                if (k2) {
                  var B3 = k2.dom;
                  B3.nextSibling ? A2.insertBefore(r5.dom, B3.nextSibling) : A2.appendChild(r5.dom);
                } else
                  A2.firstChild ? A2.insertBefore(r5.dom, A2.firstChild) : A2.appendChild(r5.dom);
              r5.__painter = this;
            }
          }, c5.prototype.eachLayer = function(s, r5) {
            for (var g5 = this._zlevelList, b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6];
              s.call(r5, this._layers[S2], S2);
            }
          }, c5.prototype.eachBuiltinLayer = function(s, r5) {
            for (var g5 = this._zlevelList, b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6], A2 = this._layers[S2];
              A2.__builtin__ && s.call(r5, A2, S2);
            }
          }, c5.prototype.eachOtherLayer = function(s, r5) {
            for (var g5 = this._zlevelList, b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6], A2 = this._layers[S2];
              A2.__builtin__ || s.call(r5, A2, S2);
            }
          }, c5.prototype.getLayers = function() {
            return this._layers;
          }, c5.prototype._updateLayerStatus = function(s) {
            this.eachBuiltinLayer(function(Z3, X3) {
              Z3.__dirty = Z3.__used = false;
            });
            function r5(Z3) {
              S2 && (S2.__endIndex !== Z3 && (S2.__dirty = true), S2.__endIndex = Z3);
            }
            if (this._singleCanvas)
              for (var g5 = 1; g5 < s.length; g5++) {
                var b6 = s[g5];
                if (b6.zlevel !== s[g5 - 1].zlevel || b6.incremental) {
                  this._needsManuallyCompositing = true;
                  break;
                }
              }
            var S2 = null, A2 = 0, k2, R6;
            for (R6 = 0; R6 < s.length; R6++) {
              var b6 = s[R6], B3 = b6.zlevel, G3 = void 0;
              k2 !== B3 && (k2 = B3, A2 = 0), b6.incremental ? (G3 = this.getLayer(B3 + M7n, this._needsManuallyCompositing), G3.incremental = true, A2 = 1) : G3 = this.getLayer(B3 + (A2 > 0 ? jMt : 0), this._needsManuallyCompositing), G3.__builtin__ || r3("ZLevel " + B3 + " has been used by unkown layer " + G3.id), G3 !== S2 && (G3.__used = true, G3.__startIndex !== R6 && (G3.__dirty = true), G3.__startIndex = R6, G3.incremental ? G3.__drawIndex = -1 : G3.__drawIndex = R6, r5(R6), S2 = G3), b6.__dirty & Vb2 && !b6.__inHover && (G3.__dirty = true, G3.incremental && G3.__drawIndex < 0 && (G3.__drawIndex = R6));
            }
            r5(R6), this.eachBuiltinLayer(function(Z3, X3) {
              !Z3.__used && Z3.getElementCount() > 0 && (Z3.__dirty = true, Z3.__startIndex = Z3.__endIndex = Z3.__drawIndex = 0), Z3.__dirty && Z3.__drawIndex < 0 && (Z3.__drawIndex = Z3.__startIndex);
            });
          }, c5.prototype.clear = function() {
            return this.eachBuiltinLayer(this._clearLayer), this;
          }, c5.prototype._clearLayer = function(s) {
            s.clear();
          }, c5.prototype.setBackgroundColor = function(s) {
            this._backgroundColor = s, Ye2(this._layers, function(r5) {
              r5.setUnpainted();
            });
          }, c5.prototype.configLayer = function(s, r5) {
            if (r5) {
              var g5 = this._layerConfig;
              g5[s] ? bu(g5[s], r5, true) : g5[s] = r5;
              for (var b6 = 0; b6 < this._zlevelList.length; b6++) {
                var S2 = this._zlevelList[b6];
                if (S2 === s || S2 === s + jMt) {
                  var A2 = this._layers[S2];
                  bu(A2, g5[s], true);
                }
              }
            }
          }, c5.prototype.delLayer = function(s) {
            var r5 = this._layers, g5 = this._zlevelList, b6 = r5[s];
            !b6 || (b6.dom.parentNode.removeChild(b6.dom), delete r5[s], g5.splice(Lu(g5, s), 1));
          }, c5.prototype.resize = function(s, r5) {
            if (this._domRoot.style) {
              var g5 = this._domRoot;
              g5.style.display = "none";
              var b6 = this._opts, S2 = this.root;
              if (s != null && (b6.width = s), r5 != null && (b6.height = r5), s = yX(S2, 0, b6), r5 = yX(S2, 1, b6), g5.style.display = "", this._width !== s || r5 !== this._height) {
                g5.style.width = s + "px", g5.style.height = r5 + "px";
                for (var A2 in this._layers)
                  this._layers.hasOwnProperty(A2) && this._layers[A2].resize(s, r5);
                this.refresh(true);
              }
              this._width = s, this._height = r5;
            } else {
              if (s == null || r5 == null)
                return;
              this._width = s, this._height = r5, this.getLayer(_W).resize(s, r5);
            }
            return this;
          }, c5.prototype.clearLayer = function(s) {
            var r5 = this._layers[s];
            r5 && r5.clear();
          }, c5.prototype.dispose = function() {
            this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
          }, c5.prototype.getRenderedCanvas = function(s) {
            if (s = s || {}, this._singleCanvas && !this._compositeManually)
              return this._layers[_W].dom;
            var r5 = new $Gt("image", this, s.pixelRatio || this.dpr);
            r5.initContext(), r5.clear(false, s.backgroundColor || this._backgroundColor);
            var g5 = r5.ctx;
            if (s.pixelRatio <= this.dpr) {
              this.refresh();
              var b6 = r5.dom.width, S2 = r5.dom.height;
              this.eachLayer(function(Z3) {
                Z3.__builtin__ ? g5.drawImage(Z3.dom, 0, 0, b6, S2) : Z3.renderToCanvas && (g5.save(), Z3.renderToCanvas(g5), g5.restore());
              });
            } else
              for (var A2 = { inHover: false, viewWidth: this._width, viewHeight: this._height }, k2 = this.storage.getDisplayList(true), R6 = 0, B3 = k2.length; R6 < B3; R6++) {
                var G3 = k2[R6];
                hW(g5, G3, A2, R6 === B3 - 1);
              }
            return r5.dom;
          }, c5.prototype.getWidth = function() {
            return this._width;
          }, c5.prototype.getHeight = function() {
            return this._height;
          }, c5;
        }(), I7n = A7n;
        function D7n(c5) {
          c5.registerPainter("canvas", I7n);
        }
        var E7n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.hasSymbolVisual = true, r5;
          }
          return s.prototype.getInitialData = function(r5) {
            return SR(null, this, { useEncodeDefaulter: true });
          }, s.prototype.getLegendIcon = function(r5) {
            var g5 = new nu(), b6 = am("line", 0, r5.itemHeight / 2, r5.itemWidth, 0, r5.lineStyle.stroke, false);
            g5.add(b6), b6.setStyle(r5.lineStyle);
            var S2 = this.getData().getVisual("symbol"), A2 = this.getData().getVisual("symbolRotate"), k2 = S2 === "none" ? "circle" : S2, R6 = r5.itemHeight * 0.8, B3 = am(k2, (r5.itemWidth - R6) / 2, (r5.itemHeight - R6) / 2, R6, R6, r5.itemStyle.fill);
            g5.add(B3), B3.setStyle(r5.itemStyle);
            var G3 = r5.iconRotate === "inherit" ? A2 : r5.iconRotate || 0;
            return B3.rotation = G3 * Math.PI / 180, B3.setOrigin([r5.itemWidth / 2, r5.itemHeight / 2]), k2.indexOf("empty") > -1 && (B3.style.stroke = B3.style.fill, B3.style.fill = "#fff", B3.style.lineWidth = 2), g5;
          }, s.type = "series.line", s.dependencies = ["grid", "polar"], s.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, s;
        }(zv), k7n = E7n;
        function wX(c5, s) {
          var r5 = c5.mapDimensionsAll("defaultedLabel"), g5 = r5.length;
          if (g5 === 1) {
            var b6 = cX(c5, s, r5[0]);
            return b6 != null ? b6 + "" : null;
          } else if (g5) {
            for (var S2 = [], A2 = 0; A2 < r5.length; A2++)
              S2.push(cX(c5, s, r5[A2]));
            return S2.join(" ");
          }
        }
        function ZDe(c5, s) {
          var r5 = c5.mapDimensionsAll("defaultedLabel");
          if (!ja2(s))
            return s + "";
          for (var g5 = [], b6 = 0; b6 < r5.length; b6++) {
            var S2 = c5.getDimensionIndex(r5[b6]);
            S2 >= 0 && g5.push(s[S2]);
          }
          return g5.join(" ");
        }
        var P7n = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2) {
            var A2 = c5.call(this) || this;
            return A2.updateData(r5, g5, b6, S2), A2;
          }
          return s.prototype._createSymbol = function(r5, g5, b6, S2, A2) {
            this.removeAll();
            var k2 = am(r5, -1, -1, 2, 2, null, A2);
            k2.attr({ z2: 100, culling: true, scaleX: S2[0] / 2, scaleY: S2[1] / 2 }), k2.drift = L7n, this._symbolType = r5, this.add(k2);
          }, s.prototype.stopSymbolAnimation = function(r5) {
            this.childAt(0).stopAnimation(null, r5);
          }, s.prototype.getSymbolType = function() {
            return this._symbolType;
          }, s.prototype.getSymbolPath = function() {
            return this.childAt(0);
          }, s.prototype.highlight = function() {
            GI(this.childAt(0));
          }, s.prototype.downplay = function() {
            HI(this.childAt(0));
          }, s.prototype.setZ = function(r5, g5) {
            var b6 = this.childAt(0);
            b6.zlevel = r5, b6.z = g5;
          }, s.prototype.setDraggable = function(r5) {
            var g5 = this.childAt(0);
            g5.draggable = r5, g5.cursor = r5 ? "move" : g5.cursor;
          }, s.prototype.updateData = function(r5, g5, b6, S2) {
            this.silent = false;
            var A2 = r5.getItemVisual(g5, "symbol") || "circle", k2 = r5.hostModel, R6 = s.getSymbolSize(r5, g5), B3 = A2 !== this._symbolType, G3 = S2 && S2.disableAnimation;
            if (B3) {
              var Z3 = r5.getItemVisual(g5, "symbolKeepAspect");
              this._createSymbol(A2, r5, g5, R6, Z3);
            } else {
              var X3 = this.childAt(0);
              X3.silent = false;
              var tt = { scaleX: R6[0] / 2, scaleY: R6[1] / 2 };
              G3 ? X3.attr(tt) : Qf2(X3, tt, k2, g5), nT(X3);
            }
            if (this._updateCommon(r5, g5, R6, b6, S2), B3) {
              var X3 = this.childAt(0);
              if (!G3) {
                var tt = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: X3.style.opacity } };
                X3.scaleX = X3.scaleY = 0, X3.style.opacity = 0, tv(X3, tt, k2, g5);
              }
            }
            G3 && this.childAt(0).stopAnimation("leave");
          }, s.prototype._updateCommon = function(r5, g5, b6, S2, A2) {
            var k2 = this.childAt(0), R6 = r5.hostModel, B3, G3, Z3, X3, tt, it, pt, mt, Mt;
            if (S2 && (B3 = S2.emphasisItemStyle, G3 = S2.blurItemStyle, Z3 = S2.selectItemStyle, X3 = S2.focus, tt = S2.blurScope, pt = S2.labelStatesModels, mt = S2.hoverScale, Mt = S2.cursorStyle, it = S2.emphasisDisabled), !S2 || r5.hasItemOption) {
              var kt = S2 && S2.itemModel ? S2.itemModel : r5.getItemModel(g5), Gt = kt.getModel("emphasis");
              B3 = Gt.getModel("itemStyle").getItemStyle(), Z3 = kt.getModel(["select", "itemStyle"]).getItemStyle(), G3 = kt.getModel(["blur", "itemStyle"]).getItemStyle(), X3 = Gt.get("focus"), tt = Gt.get("blurScope"), it = Gt.get("disabled"), pt = qb2(kt), mt = Gt.getShallow("scale"), Mt = kt.getShallow("cursor");
            }
            var Ot = r5.getItemVisual(g5, "symbolRotate");
            k2.attr("rotation", (Ot || 0) * Math.PI / 180 || 0);
            var ce2 = vX(r5.getItemVisual(g5, "symbolOffset"), b6);
            ce2 && (k2.x = ce2[0], k2.y = ce2[1]), Mt && k2.attr("cursor", Mt);
            var ae2 = r5.getItemVisual(g5, "style"), de2 = ae2.fill;
            if (k2 instanceof qm) {
              var we2 = k2.style;
              k2.useStyle(sa2({ image: we2.image, x: we2.x, y: we2.y, width: we2.width, height: we2.height }, ae2));
            } else
              k2.__isEmptyBrush ? k2.useStyle(sa2({}, ae2)) : k2.useStyle(ae2), k2.style.decal = null, k2.setColor(de2, A2 && A2.symbolInnerColor), k2.style.strokeNoScale = true;
            var Se2 = r5.getItemVisual(g5, "liftZ"), Oe2 = this._z2;
            Se2 != null ? Oe2 == null && (this._z2 = k2.z2, k2.z2 += Se2) : Oe2 != null && (k2.z2 = Oe2, this._z2 = null);
            var je2 = A2 && A2.useNameLabel;
            Uw(k2, pt, { labelFetcher: R6, labelDataIndex: g5, defaultText: rn, inheritColor: de2, defaultOpacity: ae2.opacity });
            function rn(jn) {
              return je2 ? r5.getName(jn) : wX(r5, jn);
            }
            this._sizeX = b6[0] / 2, this._sizeY = b6[1] / 2;
            var qe2 = k2.ensureState("emphasis");
            if (qe2.style = B3, k2.ensureState("select").style = Z3, k2.ensureState("blur").style = G3, mt) {
              var An = Math.max(1.1, 3 / this._sizeY);
              qe2.scaleX = this._sizeX * An, qe2.scaleY = this._sizeY * An;
            }
            this.setSymbolScale(1), f0(this, X3, tt, it);
          }, s.prototype.setSymbolScale = function(r5) {
            this.scaleX = this.scaleY = r5;
          }, s.prototype.fadeOut = function(r5, g5, b6) {
            var S2 = this.childAt(0), A2 = Pl(this).dataIndex, k2 = b6 && b6.animation;
            if (this.silent = S2.silent = true, b6 && b6.fadeLabel) {
              var R6 = S2.getTextContent();
              R6 && A3(R6, { style: { opacity: 0 } }, g5, { dataIndex: A2, removeOpt: k2, cb: function() {
                S2.removeTextContent();
              } });
            } else
              S2.removeTextContent();
            A3(S2, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, g5, { dataIndex: A2, cb: r5, removeOpt: k2 });
          }, s.getSymbolSize = function(r5, g5) {
            return vct(r5.getItemVisual(g5, "symbolSize"));
          }, s;
        }(nu);
        function L7n(c5, s) {
          this.parent.drift(c5, s);
        }
        var Fct = P7n;
        function YGt(c5, s, r5, g5) {
          return s && !isNaN(s[0]) && !isNaN(s[1]) && !(g5.isIgnore && g5.isIgnore(r5)) && !(g5.clipShape && !g5.clipShape.contain(s[0], s[1])) && c5.getItemVisual(r5, "symbol") !== "none";
        }
        function $De(c5) {
          return c5 != null && !Wl(c5) && (c5 = { isIgnore: c5 }), c5 || {};
        }
        function YDe(c5) {
          var s = c5.hostModel, r5 = s.getModel("emphasis");
          return { emphasisItemStyle: r5.getModel("itemStyle").getItemStyle(), blurItemStyle: s.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: s.getModel(["select", "itemStyle"]).getItemStyle(), focus: r5.get("focus"), blurScope: r5.get("blurScope"), emphasisDisabled: r5.get("disabled"), hoverScale: r5.get("scale"), labelStatesModels: qb2(s), cursorStyle: s.get("cursor") };
        }
        var O7n = function() {
          function c5(s) {
            this.group = new nu(), this._SymbolCtor = s || Fct;
          }
          return c5.prototype.updateData = function(s, r5) {
            this._progressiveEls = null, r5 = $De(r5);
            var g5 = this.group, b6 = s.hostModel, S2 = this._data, A2 = this._SymbolCtor, k2 = r5.disableAnimation, R6 = YDe(s), B3 = { disableAnimation: k2 }, G3 = r5.getSymbolPoint || function(Z3) {
              return s.getItemLayout(Z3);
            };
            S2 || g5.removeAll(), s.diff(S2).add(function(Z3) {
              var X3 = G3(Z3);
              if (YGt(s, X3, Z3, r5)) {
                var tt = new A2(s, Z3, R6, B3);
                tt.setPosition(X3), s.setItemGraphicEl(Z3, tt), g5.add(tt);
              }
            }).update(function(Z3, X3) {
              var tt = S2.getItemGraphicEl(X3), it = G3(Z3);
              if (!YGt(s, it, Z3, r5)) {
                g5.remove(tt);
                return;
              }
              var pt = s.getItemVisual(Z3, "symbol") || "circle", mt = tt && tt.getSymbolType && tt.getSymbolType();
              if (!tt || mt && mt !== pt)
                g5.remove(tt), tt = new A2(s, Z3, R6, B3), tt.setPosition(it);
              else {
                tt.updateData(s, Z3, R6, B3);
                var Mt = { x: it[0], y: it[1] };
                k2 ? tt.attr(Mt) : Qf2(tt, Mt, b6);
              }
              g5.add(tt), s.setItemGraphicEl(Z3, tt);
            }).remove(function(Z3) {
              var X3 = S2.getItemGraphicEl(Z3);
              X3 && X3.fadeOut(function() {
                g5.remove(X3);
              }, b6);
            }).execute(), this._getSymbolPoint = G3, this._data = s;
          }, c5.prototype.updateLayout = function() {
            var s = this, r5 = this._data;
            r5 && r5.eachItemGraphicEl(function(g5, b6) {
              var S2 = s._getSymbolPoint(b6);
              g5.setPosition(S2), g5.markRedraw();
            });
          }, c5.prototype.incrementalPrepareUpdate = function(s) {
            this._seriesScope = YDe(s), this._data = null, this.group.removeAll();
          }, c5.prototype.incrementalUpdate = function(s, r5, g5) {
            this._progressiveEls = [], g5 = $De(g5);
            function b6(R6) {
              R6.isGroup || (R6.incremental = true, R6.ensureState("emphasis").hoverLayer = true);
            }
            for (var S2 = s.start; S2 < s.end; S2++) {
              var A2 = r5.getItemLayout(S2);
              if (YGt(r5, A2, S2, g5)) {
                var k2 = new this._SymbolCtor(r5, S2, this._seriesScope);
                k2.traverse(b6), k2.setPosition(A2), this.group.add(k2), r5.setItemGraphicEl(S2, k2), this._progressiveEls.push(k2);
              }
            }
          }, c5.prototype.eachRendered = function(s) {
            Ik(this._progressiveEls || this.group, s);
          }, c5.prototype.remove = function(s) {
            var r5 = this.group, g5 = this._data;
            g5 && s ? g5.eachItemGraphicEl(function(b6) {
              b6.fadeOut(function() {
                r5.remove(b6);
              }, g5.hostModel);
            }) : r5.removeAll();
          }, c5;
        }(), Vct = O7n;
        function KDe(c5, s, r5) {
          var g5 = c5.getBaseAxis(), b6 = c5.getOtherAxis(g5), S2 = R7n(b6, r5), A2 = g5.dim, k2 = b6.dim, R6 = s.mapDimension(k2), B3 = s.mapDimension(A2), G3 = k2 === "x" || k2 === "radius" ? 1 : 0, Z3 = Ha2(c5.dimensions, function(it) {
            return s.mapDimension(it);
          }), X3 = false, tt = s.getCalculationInfo("stackResultDimension");
          return e9(s, Z3[0]) && (X3 = true, Z3[0] = tt), e9(s, Z3[1]) && (X3 = true, Z3[1] = tt), { dataDimsForPoint: Z3, valueStart: S2, valueAxisDim: k2, baseAxisDim: A2, stacked: !!X3, valueDim: R6, baseDim: B3, baseDataOffset: G3, stackedOverDimension: s.getCalculationInfo("stackedOverDimension") };
        }
        function R7n(c5, s) {
          var r5 = 0, g5 = c5.scale.getExtent();
          return s === "start" ? r5 = g5[0] : s === "end" ? r5 = g5[1] : g5[0] > 0 ? r5 = g5[0] : g5[1] < 0 && (r5 = g5[1]), r5;
        }
        function XDe(c5, s, r5, g5) {
          var b6 = NaN;
          c5.stacked && (b6 = r5.get(r5.getCalculationInfo("stackedOverDimension"), g5)), isNaN(b6) && (b6 = c5.valueStart);
          var S2 = c5.baseDataOffset, A2 = [];
          return A2[S2] = r5.get(c5.baseDim, g5), A2[1 - S2] = b6, s.dataToPoint(A2);
        }
        function N7n(c5, s) {
          var r5 = [];
          return s.diff(c5).add(function(g5) {
            r5.push({ cmd: "+", idx: g5 });
          }).update(function(g5, b6) {
            r5.push({ cmd: "=", idx: b6, idx1: g5 });
          }).remove(function(g5) {
            r5.push({ cmd: "-", idx: g5 });
          }).execute(), r5;
        }
        function F7n(c5, s, r5, g5, b6, S2, A2, k2) {
          for (var R6 = N7n(c5, s), B3 = [], G3 = [], Z3 = [], X3 = [], tt = [], it = [], pt = [], mt = KDe(b6, s, A2), Mt = c5.getLayout("points") || [], kt = s.getLayout("points") || [], Gt = 0; Gt < R6.length; Gt++) {
            var Ot = R6[Gt], ce2 = true, ae2 = void 0, de2 = void 0;
            switch (Ot.cmd) {
              case "=":
                ae2 = Ot.idx * 2, de2 = Ot.idx1 * 2;
                var we2 = Mt[ae2], Se2 = Mt[ae2 + 1], Oe2 = kt[de2], je2 = kt[de2 + 1];
                (isNaN(we2) || isNaN(Se2)) && (we2 = Oe2, Se2 = je2), B3.push(we2, Se2), G3.push(Oe2, je2), Z3.push(r5[ae2], r5[ae2 + 1]), X3.push(g5[de2], g5[de2 + 1]), pt.push(s.getRawIndex(Ot.idx1));
                break;
              case "+":
                var rn = Ot.idx, qe2 = mt.dataDimsForPoint, An = b6.dataToPoint([s.get(qe2[0], rn), s.get(qe2[1], rn)]);
                de2 = rn * 2, B3.push(An[0], An[1]), G3.push(kt[de2], kt[de2 + 1]);
                var jn = XDe(mt, b6, s, rn);
                Z3.push(jn[0], jn[1]), X3.push(g5[de2], g5[de2 + 1]), pt.push(s.getRawIndex(rn));
                break;
              case "-":
                ce2 = false;
            }
            ce2 && (tt.push(Ot), it.push(it.length));
          }
          it.sort(function(gl, nl) {
            return pt[gl] - pt[nl];
          });
          for (var _n = B3.length, Jr = k3(_n), Qn = k3(_n), rr = k3(_n), Ar = k3(_n), fi2 = [], Gt = 0; Gt < it.length; Gt++) {
            var mi2 = it[Gt], Oo = Gt * 2, Ts = mi2 * 2;
            Jr[Oo] = B3[Ts], Jr[Oo + 1] = B3[Ts + 1], Qn[Oo] = G3[Ts], Qn[Oo + 1] = G3[Ts + 1], rr[Oo] = Z3[Ts], rr[Oo + 1] = Z3[Ts + 1], Ar[Oo] = X3[Ts], Ar[Oo + 1] = X3[Ts + 1], fi2[Gt] = tt[mi2];
          }
          return { current: Jr, next: Qn, stackedOnCurrent: rr, stackedOnNext: Ar, status: fi2 };
        }
        var r9 = Math.min, i9 = Math.max;
        function xW(c5, s) {
          return isNaN(c5) || isNaN(s);
        }
        function KGt(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          for (var B3, G3, Z3, X3, tt, it, pt = r5, mt = 0; mt < g5; mt++) {
            var Mt = s[pt * 2], kt = s[pt * 2 + 1];
            if (pt >= b6 || pt < 0)
              break;
            if (xW(Mt, kt)) {
              if (R6) {
                pt += S2;
                continue;
              }
              break;
            }
            if (pt === r5)
              c5[S2 > 0 ? "moveTo" : "lineTo"](Mt, kt), Z3 = Mt, X3 = kt;
            else {
              var Gt = Mt - B3, Ot = kt - G3;
              if (Gt * Gt + Ot * Ot < 0.5) {
                pt += S2;
                continue;
              }
              if (A2 > 0) {
                for (var ce2 = pt + S2, ae2 = s[ce2 * 2], de2 = s[ce2 * 2 + 1]; ae2 === Mt && de2 === kt && mt < g5; )
                  mt++, ce2 += S2, pt += S2, ae2 = s[ce2 * 2], de2 = s[ce2 * 2 + 1], Mt = s[pt * 2], kt = s[pt * 2 + 1], Gt = Mt - B3, Ot = kt - G3;
                var we2 = mt + 1;
                if (R6)
                  for (; xW(ae2, de2) && we2 < g5; )
                    we2++, ce2 += S2, ae2 = s[ce2 * 2], de2 = s[ce2 * 2 + 1];
                var Se2 = 0.5, Oe2 = 0, je2 = 0, rn = void 0, qe2 = void 0;
                if (we2 >= g5 || xW(ae2, de2))
                  tt = Mt, it = kt;
                else {
                  Oe2 = ae2 - B3, je2 = de2 - G3;
                  var An = Mt - B3, jn = ae2 - Mt, _n = kt - G3, Jr = de2 - kt, Qn = void 0, rr = void 0;
                  if (k2 === "x") {
                    Qn = Math.abs(An), rr = Math.abs(jn);
                    var Ar = Oe2 > 0 ? 1 : -1;
                    tt = Mt - Ar * Qn * A2, it = kt, rn = Mt + Ar * rr * A2, qe2 = kt;
                  } else if (k2 === "y") {
                    Qn = Math.abs(_n), rr = Math.abs(Jr);
                    var fi2 = je2 > 0 ? 1 : -1;
                    tt = Mt, it = kt - fi2 * Qn * A2, rn = Mt, qe2 = kt + fi2 * rr * A2;
                  } else
                    Qn = Math.sqrt(An * An + _n * _n), rr = Math.sqrt(jn * jn + Jr * Jr), Se2 = rr / (rr + Qn), tt = Mt - Oe2 * A2 * (1 - Se2), it = kt - je2 * A2 * (1 - Se2), rn = Mt + Oe2 * A2 * Se2, qe2 = kt + je2 * A2 * Se2, rn = r9(rn, i9(ae2, Mt)), qe2 = r9(qe2, i9(de2, kt)), rn = i9(rn, r9(ae2, Mt)), qe2 = i9(qe2, r9(de2, kt)), Oe2 = rn - Mt, je2 = qe2 - kt, tt = Mt - Oe2 * Qn / rr, it = kt - je2 * Qn / rr, tt = r9(tt, i9(B3, Mt)), it = r9(it, i9(G3, kt)), tt = i9(tt, r9(B3, Mt)), it = i9(it, r9(G3, kt)), Oe2 = Mt - tt, je2 = kt - it, rn = Mt + Oe2 * rr / Qn, qe2 = kt + je2 * rr / Qn;
                }
                c5.bezierCurveTo(Z3, X3, tt, it, Mt, kt), Z3 = rn, X3 = qe2;
              } else
                c5.lineTo(Mt, kt);
            }
            B3 = Mt, G3 = kt, pt += S2;
          }
          return mt;
        }
        var QDe = function() {
          function c5() {
            this.smooth = 0, this.smoothConstraint = true;
          }
          return c5;
        }(), V7n = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "ec-polyline", g5;
          }
          return s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new QDe();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.points, S2 = 0, A2 = b6.length / 2;
            if (g5.connectNulls) {
              for (; A2 > 0 && xW(b6[A2 * 2 - 2], b6[A2 * 2 - 1]); A2--)
                ;
              for (; S2 < A2 && xW(b6[S2 * 2], b6[S2 * 2 + 1]); S2++)
                ;
            }
            for (; S2 < A2; )
              S2 += KGt(r5, b6, S2, A2, A2, 1, g5.smooth, g5.smoothMonotone, g5.connectNulls) + 1;
          }, s.prototype.getPointOn = function(r5, g5) {
            this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
            for (var b6 = this.path, S2 = b6.data, A2 = jI.CMD, k2, R6, B3 = g5 === "x", G3 = [], Z3 = 0; Z3 < S2.length; ) {
              var X3 = S2[Z3++], tt = void 0, it = void 0, pt = void 0, mt = void 0, Mt = void 0, kt = void 0, Gt = void 0;
              switch (X3) {
                case A2.M:
                  k2 = S2[Z3++], R6 = S2[Z3++];
                  break;
                case A2.L:
                  if (tt = S2[Z3++], it = S2[Z3++], Gt = B3 ? (r5 - k2) / (tt - k2) : (r5 - R6) / (it - R6), Gt <= 1 && Gt >= 0) {
                    var Ot = B3 ? (it - R6) * Gt + R6 : (tt - k2) * Gt + k2;
                    return B3 ? [r5, Ot] : [Ot, r5];
                  }
                  k2 = tt, R6 = it;
                  break;
                case A2.C:
                  tt = S2[Z3++], it = S2[Z3++], pt = S2[Z3++], mt = S2[Z3++], Mt = S2[Z3++], kt = S2[Z3++];
                  var ce2 = B3 ? qY(k2, tt, pt, Mt, r5, G3) : qY(R6, it, mt, kt, r5, G3);
                  if (ce2 > 0)
                    for (var ae2 = 0; ae2 < ce2; ae2++) {
                      var de2 = G3[ae2];
                      if (de2 <= 1 && de2 >= 0) {
                        var Ot = B3 ? D0(R6, it, mt, kt, de2) : D0(k2, tt, pt, Mt, de2);
                        return B3 ? [r5, Ot] : [Ot, r5];
                      }
                    }
                  k2 = Mt, R6 = kt;
                  break;
              }
            }
          }, s;
        }(Tc2), B7n = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s;
        }(QDe), JDe = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "ec-polygon", g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new B7n();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.points, S2 = g5.stackedOnPoints, A2 = 0, k2 = b6.length / 2, R6 = g5.smoothMonotone;
            if (g5.connectNulls) {
              for (; k2 > 0 && xW(b6[k2 * 2 - 2], b6[k2 * 2 - 1]); k2--)
                ;
              for (; A2 < k2 && xW(b6[A2 * 2], b6[A2 * 2 + 1]); A2++)
                ;
            }
            for (; A2 < k2; ) {
              var B3 = KGt(r5, b6, A2, k2, k2, 1, g5.smooth, R6, g5.connectNulls);
              KGt(r5, S2, A2 + B3 - 1, B3, k2, -1, g5.stackedOnSmooth, R6, g5.connectNulls), A2 += B3 + 1, r5.closePath();
            }
          }, s;
        }(Tc2);
        function tEe(c5, s, r5, g5, b6) {
          var S2 = c5.getArea(), A2 = S2.x, k2 = S2.y, R6 = S2.width, B3 = S2.height, G3 = r5.get(["lineStyle", "width"]) || 2;
          A2 -= G3 / 2, k2 -= G3 / 2, R6 += G3, B3 += G3, A2 = Math.floor(A2), R6 = Math.round(R6);
          var Z3 = new zf2({ shape: { x: A2, y: k2, width: R6, height: B3 } });
          if (s) {
            var X3 = c5.getBaseAxis(), tt = X3.isHorizontal(), it = X3.inverse;
            tt ? (it && (Z3.shape.x += R6), Z3.shape.width = 0) : (it || (Z3.shape.y += B3), Z3.shape.height = 0);
            var pt = Tl(b6) ? function(mt) {
              b6(mt, Z3);
            } : null;
            tv(Z3, { shape: { width: R6, height: B3, x: A2, y: k2 } }, r5, null, g5, pt);
          }
          return Z3;
        }
        function eEe(c5, s, r5) {
          var g5 = c5.getArea(), b6 = c0(g5.r0, 1), S2 = c0(g5.r, 1), A2 = new Ww({ shape: { cx: c0(c5.cx, 1), cy: c0(c5.cy, 1), r0: b6, r: S2, startAngle: g5.startAngle, endAngle: g5.endAngle, clockwise: g5.clockwise } });
          if (s) {
            var k2 = c5.getBaseAxis().dim === "angle";
            k2 ? A2.shape.endAngle = g5.startAngle : A2.shape.r = b6, tv(A2, { shape: { endAngle: g5.endAngle, r: S2 } }, r5);
          }
          return A2;
        }
        function WMt(c5, s, r5, g5, b6) {
          if (c5) {
            if (c5.type === "polar")
              return eEe(c5, s, r5);
            if (c5.type === "cartesian2d")
              return tEe(c5, s, r5, g5, b6);
          } else
            return null;
          return null;
        }
        function CR(c5, s) {
          return c5.type === s;
        }
        function nEe(c5, s) {
          if (c5.length === s.length) {
            for (var r5 = 0; r5 < c5.length; r5++)
              if (c5[r5] !== s[r5])
                return;
            return true;
          }
        }
        function rEe(c5) {
          for (var s = 1 / 0, r5 = 1 / 0, g5 = -1 / 0, b6 = -1 / 0, S2 = 0; S2 < c5.length; ) {
            var A2 = c5[S2++], k2 = c5[S2++];
            isNaN(A2) || (s = Math.min(A2, s), g5 = Math.max(A2, g5)), isNaN(k2) || (r5 = Math.min(k2, r5), b6 = Math.max(k2, b6));
          }
          return [[s, r5], [g5, b6]];
        }
        function iEe(c5, s) {
          var r5 = rEe(c5), g5 = r5[0], b6 = r5[1], S2 = rEe(s), A2 = S2[0], k2 = S2[1];
          return Math.max(Math.abs(g5[0] - A2[0]), Math.abs(g5[1] - A2[1]), Math.abs(b6[0] - k2[0]), Math.abs(b6[1] - k2[1]));
        }
        function aEe(c5) {
          return Oh2(c5) ? c5 : c5 ? 0.5 : 0;
        }
        function z7n(c5, s, r5) {
          if (!r5.valueDim)
            return [];
          for (var g5 = s.count(), b6 = k3(g5 * 2), S2 = 0; S2 < g5; S2++) {
            var A2 = XDe(r5, c5, s, S2);
            b6[S2 * 2] = A2[0], b6[S2 * 2 + 1] = A2[1];
          }
          return b6;
        }
        function a9(c5, s, r5, g5) {
          var b6 = s.getBaseAxis(), S2 = b6.dim === "x" || b6.dim === "radius" ? 0 : 1, A2 = [], k2 = 0, R6 = [], B3 = [], G3 = [], Z3 = [];
          if (g5) {
            for (k2 = 0; k2 < c5.length; k2 += 2)
              !isNaN(c5[k2]) && !isNaN(c5[k2 + 1]) && Z3.push(c5[k2], c5[k2 + 1]);
            c5 = Z3;
          }
          for (k2 = 0; k2 < c5.length - 2; k2 += 2)
            switch (G3[0] = c5[k2 + 2], G3[1] = c5[k2 + 3], B3[0] = c5[k2], B3[1] = c5[k2 + 1], A2.push(B3[0], B3[1]), r5) {
              case "end":
                R6[S2] = G3[S2], R6[1 - S2] = B3[1 - S2], A2.push(R6[0], R6[1]);
                break;
              case "middle":
                var X3 = (B3[S2] + G3[S2]) / 2, tt = [];
                R6[S2] = tt[S2] = X3, R6[1 - S2] = B3[1 - S2], tt[1 - S2] = G3[1 - S2], A2.push(R6[0], R6[1]), A2.push(tt[0], tt[1]);
                break;
              default:
                R6[S2] = B3[S2], R6[1 - S2] = G3[1 - S2], A2.push(R6[0], R6[1]);
            }
          return A2.push(c5[k2++], c5[k2++]), A2;
        }
        function j7n(c5, s) {
          var r5 = [], g5 = c5.length, b6, S2;
          function A2(G3, Z3, X3) {
            var tt = G3.coord, it = (X3 - tt) / (Z3.coord - tt), pt = Szt(it, [G3.color, Z3.color]);
            return { coord: X3, color: pt };
          }
          for (var k2 = 0; k2 < g5; k2++) {
            var R6 = c5[k2], B3 = R6.coord;
            if (B3 < 0)
              b6 = R6;
            else if (B3 > s) {
              S2 ? r5.push(A2(S2, R6, s)) : b6 && r5.push(A2(b6, R6, 0), A2(b6, R6, s));
              break;
            } else
              b6 && (r5.push(A2(b6, R6, 0)), b6 = null), r5.push(R6), S2 = R6;
          }
          return r5;
        }
        function W7n(c5, s, r5) {
          var g5 = c5.getVisual("visualMeta");
          if (!(!g5 || !g5.length || !c5.count()) && s.type === "cartesian2d") {
            for (var b6, S2, A2 = g5.length - 1; A2 >= 0; A2--) {
              var k2 = c5.getDimensionInfo(g5[A2].dimension);
              if (b6 = k2 && k2.coordDim, b6 === "x" || b6 === "y") {
                S2 = g5[A2];
                break;
              }
            }
            if (S2) {
              var R6 = s.getAxis(b6), B3 = Ha2(S2.stops, function(Gt) {
                return { coord: R6.toGlobalCoord(R6.dataToCoord(Gt.value)), color: Gt.color };
              }), G3 = B3.length, Z3 = S2.outerColors.slice();
              G3 && B3[0].coord > B3[G3 - 1].coord && (B3.reverse(), Z3.reverse());
              var X3 = j7n(B3, b6 === "x" ? r5.getWidth() : r5.getHeight()), tt = X3.length;
              if (!tt && G3)
                return B3[0].coord < 0 ? Z3[1] ? Z3[1] : B3[G3 - 1].color : Z3[0] ? Z3[0] : B3[0].color;
              var it = 10, pt = X3[0].coord - it, mt = X3[tt - 1].coord + it, Mt = mt - pt;
              if (Mt < 1e-3)
                return "transparent";
              Ye2(X3, function(Gt) {
                Gt.offset = (Gt.coord - pt) / Mt;
              }), X3.push({ offset: tt ? X3[tt - 1].offset : 0.5, color: Z3[1] || "transparent" }), X3.unshift({ offset: tt ? X3[0].offset : 0.5, color: Z3[0] || "transparent" });
              var kt = new nW(0, 0, 0, 0, X3, true);
              return kt[b6] = pt, kt[b6 + "2"] = mt, kt;
            }
          }
        }
        function G7n(c5, s, r5) {
          var g5 = c5.get("showAllSymbol"), b6 = g5 === "auto";
          if (!(g5 && !b6)) {
            var S2 = r5.getAxesByScale("ordinal")[0];
            if (!!S2 && !(b6 && H7n(S2, s))) {
              var A2 = s.mapDimension(S2.dim), k2 = {};
              return Ye2(S2.getViewLabels(), function(R6) {
                var B3 = S2.scale.getRawOrdinalNumber(R6.tickValue);
                k2[B3] = 1;
              }), function(R6) {
                return !k2.hasOwnProperty(s.get(A2, R6));
              };
            }
          }
        }
        function H7n(c5, s) {
          var r5 = c5.getExtent(), g5 = Math.abs(r5[1] - r5[0]) / c5.scale.count();
          isNaN(g5) && (g5 = 0);
          for (var b6 = s.count(), S2 = Math.max(1, Math.round(b6 / 5)), A2 = 0; A2 < b6; A2 += S2)
            if (Fct.getSymbolSize(s, A2)[c5.isHorizontal() ? 1 : 0] * 1.5 > g5)
              return false;
          return true;
        }
        function U7n(c5, s) {
          return isNaN(c5) || isNaN(s);
        }
        function q7n(c5) {
          for (var s = c5.length / 2; s > 0 && U7n(c5[s * 2 - 2], c5[s * 2 - 1]); s--)
            ;
          return s - 1;
        }
        function oEe(c5, s) {
          return [c5[s * 2], c5[s * 2 + 1]];
        }
        function Z7n(c5, s, r5) {
          for (var g5 = c5.length / 2, b6 = r5 === "x" ? 0 : 1, S2, A2, k2 = 0, R6 = -1, B3 = 0; B3 < g5; B3++)
            if (A2 = c5[B3 * 2 + b6], !(isNaN(A2) || isNaN(c5[B3 * 2 + 1 - b6]))) {
              if (B3 === 0) {
                S2 = A2;
                continue;
              }
              if (S2 <= s && A2 >= s || S2 >= s && A2 <= s) {
                R6 = B3;
                break;
              }
              k2 = B3, S2 = A2;
            }
          return { range: [k2, R6], t: (s - S2) / (A2 - S2) };
        }
        function sEe(c5) {
          if (c5.get(["endLabel", "show"]))
            return true;
          for (var s = 0; s < k0.length; s++)
            if (c5.get([k0[s], "endLabel", "show"]))
              return true;
          return false;
        }
        function XGt(c5, s, r5, g5) {
          if (CR(s, "cartesian2d")) {
            var b6 = g5.getModel("endLabel"), S2 = b6.get("valueAnimation"), A2 = g5.getData(), k2 = { lastFrameIndex: 0 }, R6 = sEe(g5) ? function(tt, it) {
              c5._endLabelOnDuring(tt, it, A2, k2, S2, b6, s);
            } : null, B3 = s.getBaseAxis().isHorizontal(), G3 = tEe(s, r5, g5, function() {
              var tt = c5._endLabel;
              tt && r5 && k2.originalX != null && tt.attr({ x: k2.originalX, y: k2.originalY });
            }, R6);
            if (!g5.get("clip", true)) {
              var Z3 = G3.shape, X3 = Math.max(Z3.width, Z3.height);
              B3 ? (Z3.y -= X3, Z3.height += X3 * 2) : (Z3.x -= X3, Z3.width += X3 * 2);
            }
            return R6 && R6(1, G3), G3;
          } else
            return eEe(s, r5, g5);
        }
        function $7n(c5, s) {
          var r5 = s.getBaseAxis(), g5 = r5.isHorizontal(), b6 = r5.inverse, S2 = g5 ? b6 ? "right" : "left" : "center", A2 = g5 ? "middle" : b6 ? "top" : "bottom";
          return { normal: { align: c5.get("align") || S2, verticalAlign: c5.get("verticalAlign") || A2 } };
        }
        var Y7n = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.init = function() {
            var r5 = new nu(), g5 = new Vct();
            this.group.add(g5.group), this._symbolDraw = g5, this._lineGroup = r5;
          }, s.prototype.render = function(r5, g5, b6) {
            var S2 = this, A2 = r5.coordinateSystem, k2 = this.group, R6 = r5.getData(), B3 = r5.getModel("lineStyle"), G3 = r5.getModel("areaStyle"), Z3 = R6.getLayout("points") || [], X3 = A2.type === "polar", tt = this._coordSys, it = this._symbolDraw, pt = this._polyline, mt = this._polygon, Mt = this._lineGroup, kt = r5.get("animation"), Gt = !G3.isEmpty(), Ot = G3.get("origin"), ce2 = KDe(A2, R6, Ot), ae2 = Gt && z7n(A2, R6, ce2), de2 = r5.get("showSymbol"), we2 = r5.get("connectNulls"), Se2 = de2 && !X3 && G7n(r5, R6, A2), Oe2 = this._data;
            Oe2 && Oe2.eachItemGraphicEl(function(nl, rl) {
              nl.__temp && (k2.remove(nl), Oe2.setItemGraphicEl(rl, null));
            }), de2 || it.remove(), k2.add(Mt);
            var je2 = X3 ? false : r5.get("step"), rn;
            A2 && A2.getArea && r5.get("clip", true) && (rn = A2.getArea(), rn.width != null ? (rn.x -= 0.1, rn.y -= 0.1, rn.width += 0.2, rn.height += 0.2) : rn.r0 && (rn.r0 -= 0.5, rn.r += 0.5)), this._clipShapeForSymbol = rn;
            var qe2 = W7n(R6, A2, b6) || R6.getVisual("style")[R6.getVisual("drawType")];
            if (!(pt && tt.type === A2.type && je2 === this._step))
              de2 && it.updateData(R6, { isIgnore: Se2, clipShape: rn, disableAnimation: true, getSymbolPoint: function(nl) {
                return [Z3[nl * 2], Z3[nl * 2 + 1]];
              } }), kt && this._initSymbolLabelAnimation(R6, A2, rn), je2 && (Z3 = a9(Z3, A2, je2, we2), ae2 && (ae2 = a9(ae2, A2, je2, we2))), pt = this._newPolyline(Z3), Gt && (mt = this._newPolygon(Z3, ae2)), X3 || this._initOrUpdateEndLabel(r5, A2, oW(qe2)), Mt.setClipPath(XGt(this, A2, true, r5));
            else {
              Gt && !mt ? mt = this._newPolygon(Z3, ae2) : mt && !Gt && (Mt.remove(mt), mt = this._polygon = null), X3 || this._initOrUpdateEndLabel(r5, A2, oW(qe2));
              var An = Mt.getClipPath();
              if (An) {
                var jn = XGt(this, A2, false, r5);
                tv(An, { shape: jn.shape }, r5);
              } else
                Mt.setClipPath(XGt(this, A2, true, r5));
              de2 && it.updateData(R6, { isIgnore: Se2, clipShape: rn, disableAnimation: true, getSymbolPoint: function(nl) {
                return [Z3[nl * 2], Z3[nl * 2 + 1]];
              } }), (!nEe(this._stackedOnPoints, ae2) || !nEe(this._points, Z3)) && (kt ? this._doUpdateAnimation(R6, ae2, A2, b6, je2, Ot, we2) : (je2 && (Z3 = a9(Z3, A2, je2, we2), ae2 && (ae2 = a9(ae2, A2, je2, we2))), pt.setShape({ points: Z3 }), mt && mt.setShape({ points: Z3, stackedOnPoints: ae2 })));
            }
            var _n = r5.getModel("emphasis"), Jr = _n.get("focus"), Qn = _n.get("blurScope"), rr = _n.get("disabled");
            if (pt.useStyle(Cl(B3.getLineStyle(), { fill: "none", stroke: qe2, lineJoin: "bevel" })), z1(pt, r5, "lineStyle"), pt.style.lineWidth > 0 && r5.get(["emphasis", "lineStyle", "width"]) === "bolder") {
              var Ar = pt.getState("emphasis").style;
              Ar.lineWidth = +pt.style.lineWidth + 1;
            }
            Pl(pt).seriesIndex = r5.seriesIndex, f0(pt, Jr, Qn, rr);
            var fi2 = aEe(r5.get("smooth")), mi2 = r5.get("smoothMonotone");
            if (pt.setShape({ smooth: fi2, smoothMonotone: mi2, connectNulls: we2 }), mt) {
              var Oo = R6.getCalculationInfo("stackedOnSeries"), Ts = 0;
              mt.useStyle(Cl(G3.getAreaStyle(), { fill: qe2, opacity: 0.7, lineJoin: "bevel", decal: R6.getVisual("style").decal })), Oo && (Ts = aEe(Oo.get("smooth"))), mt.setShape({ smooth: fi2, stackedOnSmooth: Ts, smoothMonotone: mi2, connectNulls: we2 }), z1(mt, r5, "areaStyle"), Pl(mt).seriesIndex = r5.seriesIndex, f0(mt, Jr, Qn, rr);
            }
            var gl = function(nl) {
              S2._changePolyState(nl);
            };
            R6.eachItemGraphicEl(function(nl) {
              nl && (nl.onHoverStateChange = gl);
            }), this._polyline.onHoverStateChange = gl, this._data = R6, this._coordSys = A2, this._stackedOnPoints = ae2, this._points = Z3, this._step = je2, this._valueOrigin = Ot, r5.get("triggerLineEvent") && (this.packEventData(r5, pt), mt && this.packEventData(r5, mt));
          }, s.prototype.packEventData = function(r5, g5) {
            Pl(g5).eventData = { componentType: "series", componentSubType: "line", componentIndex: r5.componentIndex, seriesIndex: r5.seriesIndex, seriesName: r5.name, seriesType: "line" };
          }, s.prototype.highlight = function(r5, g5, b6, S2) {
            var A2 = r5.getData(), k2 = nR(A2, S2);
            if (this._changePolyState("emphasis"), !(k2 instanceof Array) && k2 != null && k2 >= 0) {
              var R6 = A2.getLayout("points"), B3 = A2.getItemGraphicEl(k2);
              if (!B3) {
                var G3 = R6[k2 * 2], Z3 = R6[k2 * 2 + 1];
                if (isNaN(G3) || isNaN(Z3) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(G3, Z3))
                  return;
                var X3 = r5.get("zlevel"), tt = r5.get("z");
                B3 = new Fct(A2, k2), B3.x = G3, B3.y = Z3, B3.setZ(X3, tt);
                var it = B3.getSymbolPath().getTextContent();
                it && (it.zlevel = X3, it.z = tt, it.z2 = this._polyline.z2 + 1), B3.__temp = true, A2.setItemGraphicEl(k2, B3), B3.stopSymbolAnimation(true), this.group.add(B3);
              }
              B3.highlight();
            } else
              Ig2.prototype.highlight.call(this, r5, g5, b6, S2);
          }, s.prototype.downplay = function(r5, g5, b6, S2) {
            var A2 = r5.getData(), k2 = nR(A2, S2);
            if (this._changePolyState("normal"), k2 != null && k2 >= 0) {
              var R6 = A2.getItemGraphicEl(k2);
              R6 && (R6.__temp ? (A2.setItemGraphicEl(k2, null), this.group.remove(R6)) : R6.downplay());
            } else
              Ig2.prototype.downplay.call(this, r5, g5, b6, S2);
          }, s.prototype._changePolyState = function(r5) {
            var g5 = this._polygon;
            T3(this._polyline, r5), g5 && T3(g5, r5);
          }, s.prototype._newPolyline = function(r5) {
            var g5 = this._polyline;
            return g5 && this._lineGroup.remove(g5), g5 = new V7n({ shape: { points: r5 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(g5), this._polyline = g5, g5;
          }, s.prototype._newPolygon = function(r5, g5) {
            var b6 = this._polygon;
            return b6 && this._lineGroup.remove(b6), b6 = new JDe({ shape: { points: r5, stackedOnPoints: g5 }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(b6), this._polygon = b6, b6;
          }, s.prototype._initSymbolLabelAnimation = function(r5, g5, b6) {
            var S2, A2, k2 = g5.getBaseAxis(), R6 = k2.inverse;
            g5.type === "cartesian2d" ? (S2 = k2.isHorizontal(), A2 = false) : g5.type === "polar" && (S2 = k2.dim === "angle", A2 = true);
            var B3 = r5.hostModel, G3 = B3.get("animationDuration");
            Tl(G3) && (G3 = G3(null));
            var Z3 = B3.get("animationDelay") || 0, X3 = Tl(Z3) ? Z3(null) : Z3;
            r5.eachItemGraphicEl(function(tt, it) {
              var pt = tt;
              if (pt) {
                var mt = [tt.x, tt.y], Mt = void 0, kt = void 0, Gt = void 0;
                if (b6)
                  if (A2) {
                    var Ot = b6, ce2 = g5.pointToCoord(mt);
                    S2 ? (Mt = Ot.startAngle, kt = Ot.endAngle, Gt = -ce2[1] / 180 * Math.PI) : (Mt = Ot.r0, kt = Ot.r, Gt = ce2[0]);
                  } else {
                    var ae2 = b6;
                    S2 ? (Mt = ae2.x, kt = ae2.x + ae2.width, Gt = tt.x) : (Mt = ae2.y + ae2.height, kt = ae2.y, Gt = tt.y);
                  }
                var de2 = kt === Mt ? 0 : (Gt - Mt) / (kt - Mt);
                R6 && (de2 = 1 - de2);
                var we2 = Tl(Z3) ? Z3(it) : G3 * de2 + X3, Se2 = pt.getSymbolPath(), Oe2 = Se2.getTextContent();
                pt.attr({ scaleX: 0, scaleY: 0 }), pt.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: we2 }), Oe2 && Oe2.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: we2 }), Se2.disableLabelAnimation = true;
              }
            });
          }, s.prototype._initOrUpdateEndLabel = function(r5, g5, b6) {
            var S2 = r5.getModel("endLabel");
            if (sEe(r5)) {
              var A2 = r5.getData(), k2 = this._polyline, R6 = A2.getLayout("points");
              if (!R6) {
                k2.removeTextContent(), this._endLabel = null;
                return;
              }
              var B3 = this._endLabel;
              B3 || (B3 = this._endLabel = new hh2({ z2: 200 }), B3.ignoreClip = true, k2.setTextContent(this._endLabel), k2.disableLabelAnimation = true);
              var G3 = q7n(R6);
              G3 >= 0 && (Uw(k2, qb2(r5, "endLabel"), { inheritColor: b6, labelFetcher: r5, labelDataIndex: G3, defaultText: function(Z3, X3, tt) {
                return tt != null ? ZDe(A2, tt) : wX(A2, Z3);
              }, enableTextSetter: true }, $7n(S2, g5)), k2.textConfig.position = null);
            } else
              this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
          }, s.prototype._endLabelOnDuring = function(r5, g5, b6, S2, A2, k2, R6) {
            var B3 = this._endLabel, G3 = this._polyline;
            if (B3) {
              r5 < 1 && S2.originalX == null && (S2.originalX = B3.x, S2.originalY = B3.y);
              var Z3 = b6.getLayout("points"), X3 = b6.hostModel, tt = X3.get("connectNulls"), it = k2.get("precision"), pt = k2.get("distance") || 0, mt = R6.getBaseAxis(), Mt = mt.isHorizontal(), kt = mt.inverse, Gt = g5.shape, Ot = kt ? Mt ? Gt.x : Gt.y + Gt.height : Mt ? Gt.x + Gt.width : Gt.y, ce2 = (Mt ? pt : 0) * (kt ? -1 : 1), ae2 = (Mt ? 0 : -pt) * (kt ? -1 : 1), de2 = Mt ? "x" : "y", we2 = Z7n(Z3, Ot, de2), Se2 = we2.range, Oe2 = Se2[1] - Se2[0], je2 = void 0;
              if (Oe2 >= 1) {
                if (Oe2 > 1 && !tt) {
                  var rn = oEe(Z3, Se2[0]);
                  B3.attr({ x: rn[0] + ce2, y: rn[1] + ae2 }), A2 && (je2 = X3.getRawValue(Se2[0]));
                } else {
                  var rn = G3.getPointOn(Ot, de2);
                  rn && B3.attr({ x: rn[0] + ce2, y: rn[1] + ae2 });
                  var qe2 = X3.getRawValue(Se2[0]), An = X3.getRawValue(Se2[1]);
                  A2 && (je2 = Jlt(b6, it, qe2, An, we2.t));
                }
                S2.lastFrameIndex = Se2[0];
              } else {
                var jn = r5 === 1 || S2.lastFrameIndex > 0 ? Se2[0] : 0, rn = oEe(Z3, jn);
                A2 && (je2 = X3.getRawValue(jn)), B3.attr({ x: rn[0] + ce2, y: rn[1] + ae2 });
              }
              A2 && eX(B3).setLabelText(je2);
            }
          }, s.prototype._doUpdateAnimation = function(r5, g5, b6, S2, A2, k2, R6) {
            var B3 = this._polyline, G3 = this._polygon, Z3 = r5.hostModel, X3 = F7n(this._data, r5, this._stackedOnPoints, g5, this._coordSys, b6, this._valueOrigin), tt = X3.current, it = X3.stackedOnCurrent, pt = X3.next, mt = X3.stackedOnNext;
            if (A2 && (tt = a9(X3.current, b6, A2, R6), it = a9(X3.stackedOnCurrent, b6, A2, R6), pt = a9(X3.next, b6, A2, R6), mt = a9(X3.stackedOnNext, b6, A2, R6)), iEe(tt, pt) > 3e3 || G3 && iEe(it, mt) > 3e3) {
              B3.stopAnimation(), B3.setShape({ points: pt }), G3 && (G3.stopAnimation(), G3.setShape({ points: pt, stackedOnPoints: mt }));
              return;
            }
            B3.shape.__points = X3.current, B3.shape.points = tt;
            var Mt = { shape: { points: pt } };
            X3.current !== tt && (Mt.shape.__points = X3.next), B3.stopAnimation(), Qf2(B3, Mt, Z3), G3 && (G3.setShape({ points: tt, stackedOnPoints: it }), G3.stopAnimation(), Qf2(G3, { shape: { stackedOnPoints: mt } }, Z3), B3.shape.points !== G3.shape.points && (G3.shape.points = B3.shape.points));
            for (var kt = [], Gt = X3.status, Ot = 0; Ot < Gt.length; Ot++) {
              var ce2 = Gt[Ot].cmd;
              if (ce2 === "=") {
                var ae2 = r5.getItemGraphicEl(Gt[Ot].idx1);
                ae2 && kt.push({ el: ae2, ptIdx: Ot });
              }
            }
            B3.animators && B3.animators.length && B3.animators[0].during(function() {
              G3 && G3.dirtyShape();
              for (var de2 = B3.shape.__points, we2 = 0; we2 < kt.length; we2++) {
                var Se2 = kt[we2].el, Oe2 = kt[we2].ptIdx * 2;
                Se2.x = de2[Oe2], Se2.y = de2[Oe2 + 1], Se2.markRedraw();
              }
            });
          }, s.prototype.remove = function(r5) {
            var g5 = this.group, b6 = this._data;
            this._lineGroup.removeAll(), this._symbolDraw.remove(true), b6 && b6.eachItemGraphicEl(function(S2, A2) {
              S2.__temp && (g5.remove(S2), b6.setItemGraphicEl(A2, null));
            }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
          }, s.type = "line", s;
        }(Ig2), K7n = Y7n;
        function Bct(c5, s) {
          return { seriesType: c5, plan: hX(), reset: function(r5) {
            var g5 = r5.getData(), b6 = r5.coordinateSystem, S2 = r5.pipelineContext, A2 = s || S2.large;
            if (b6) {
              var k2 = Ha2(b6.dimensions, function(tt) {
                return g5.mapDimension(tt);
              }).slice(0, 2), R6 = k2.length, B3 = g5.getCalculationInfo("stackResultDimension");
              e9(g5, k2[0]) && (k2[0] = B3), e9(g5, k2[1]) && (k2[1] = B3);
              var G3 = g5.getStore(), Z3 = g5.getDimensionIndex(k2[0]), X3 = g5.getDimensionIndex(k2[1]);
              return R6 && { progress: function(tt, it) {
                for (var pt = tt.end - tt.start, mt = A2 && k3(pt * R6), Mt = [], kt = [], Gt = tt.start, Ot = 0; Gt < tt.end; Gt++) {
                  var ce2 = void 0;
                  if (R6 === 1) {
                    var ae2 = G3.get(Z3, Gt);
                    ce2 = b6.dataToPoint(ae2, null, kt);
                  } else
                    Mt[0] = G3.get(Z3, Gt), Mt[1] = G3.get(X3, Gt), ce2 = b6.dataToPoint(Mt, null, kt);
                  A2 ? (mt[Ot++] = ce2[0], mt[Ot++] = ce2[1]) : it.setItemLayout(Gt, ce2.slice());
                }
                A2 && it.setLayout("points", mt);
              } };
            }
          } };
        }
        var X7n = { average: function(c5) {
          for (var s = 0, r5 = 0, g5 = 0; g5 < c5.length; g5++)
            isNaN(c5[g5]) || (s += c5[g5], r5++);
          return r5 === 0 ? NaN : s / r5;
        }, sum: function(c5) {
          for (var s = 0, r5 = 0; r5 < c5.length; r5++)
            s += c5[r5] || 0;
          return s;
        }, max: function(c5) {
          for (var s = -1 / 0, r5 = 0; r5 < c5.length; r5++)
            c5[r5] > s && (s = c5[r5]);
          return isFinite(s) ? s : NaN;
        }, min: function(c5) {
          for (var s = 1 / 0, r5 = 0; r5 < c5.length; r5++)
            c5[r5] < s && (s = c5[r5]);
          return isFinite(s) ? s : NaN;
        }, nearest: function(c5) {
          return c5[0];
        } }, Q7n = function(c5) {
          return Math.round(c5.length / 2);
        };
        function lEe(c5) {
          return { seriesType: c5, reset: function(s, r5, g5) {
            var b6 = s.getData(), S2 = s.get("sampling"), A2 = s.coordinateSystem, k2 = b6.count();
            if (k2 > 10 && A2.type === "cartesian2d" && S2) {
              var R6 = A2.getBaseAxis(), B3 = A2.getOtherAxis(R6), G3 = R6.getExtent(), Z3 = g5.getDevicePixelRatio(), X3 = Math.abs(G3[1] - G3[0]) * (Z3 || 1), tt = Math.round(k2 / X3);
              if (isFinite(tt) && tt > 1) {
                S2 === "lttb" && s.setData(b6.lttbDownSample(b6.mapDimension(B3.dim), 1 / tt));
                var it = void 0;
                gs(S2) ? it = X7n[S2] : Tl(S2) && (it = S2), it && s.setData(b6.downSample(b6.mapDimension(B3.dim), 1 / tt, it, Q7n));
              }
            }
          } };
        }
        function J7n(c5) {
          c5.registerChartView(K7n), c5.registerSeriesModel(k7n), c5.registerLayout(Bct("line", true)), c5.registerVisual({ seriesType: "line", reset: function(s) {
            var r5 = s.getData(), g5 = s.getModel("lineStyle").getLineStyle();
            g5 && !g5.stroke && (g5.stroke = r5.getVisual("style").fill), r5.setVisual("legendLineStyle", g5);
          } }), c5.registerProcessor(c5.PRIORITY.PROCESSOR.STATISTIC, lEe("line"));
        }
        var uEe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            return SR(null, this, { useEncodeDefaulter: true });
          }, s.prototype.getMarkerPosition = function(r5) {
            var g5 = this.coordinateSystem;
            if (g5 && g5.clampData) {
              var b6 = g5.dataToPoint(g5.clampData(r5)), S2 = this.getData(), A2 = S2.getLayout("offset"), k2 = S2.getLayout("size"), R6 = g5.getBaseAxis().isHorizontal() ? 0 : 1;
              return b6[R6] += A2 + k2 / 2, b6;
            }
            return [NaN, NaN];
          }, s.type = "series.__base_bar__", s.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, s;
        }(zv);
        zv.registerClass(uEe);
        var GMt = uEe, tVn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.getInitialData = function() {
            return SR(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
          }, s.prototype.getProgressive = function() {
            return this.get("large") ? this.get("progressive") : false;
          }, s.prototype.getProgressiveThreshold = function() {
            var r5 = this.get("progressiveThreshold"), g5 = this.get("largeThreshold");
            return g5 > r5 && (r5 = g5), r5;
          }, s.prototype.brushSelector = function(r5, g5, b6) {
            return b6.rect(g5.getItemLayout(r5));
          }, s.type = "series.bar", s.dependencies = ["grid", "polar"], s.defaultOption = $8(GMt.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), s;
        }(GMt), eVn = tVn, nVn = function() {
          function c5() {
            this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
          }
          return c5;
        }(), rVn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "sausage", g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new nVn();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.cx, S2 = g5.cy, A2 = Math.max(g5.r0 || 0, 0), k2 = Math.max(g5.r, 0), R6 = (k2 - A2) * 0.5, B3 = A2 + R6, G3 = g5.startAngle, Z3 = g5.endAngle, X3 = g5.clockwise, tt = Math.PI * 2, it = X3 ? Z3 - G3 < tt : G3 - Z3 < tt;
            it || (G3 = Z3 - (X3 ? tt : -tt));
            var pt = Math.cos(G3), mt = Math.sin(G3), Mt = Math.cos(Z3), kt = Math.sin(Z3);
            it ? (r5.moveTo(pt * A2 + b6, mt * A2 + S2), r5.arc(pt * B3 + b6, mt * B3 + S2, R6, -Math.PI + G3, G3, !X3)) : r5.moveTo(pt * k2 + b6, mt * k2 + S2), r5.arc(b6, S2, k2, G3, Z3, !X3), r5.arc(Mt * B3 + b6, kt * B3 + S2, R6, Z3 - Math.PI * 2, Z3 - Math.PI, !X3), A2 !== 0 && r5.arc(b6, S2, A2, Z3, G3, X3);
          }, s;
        }(Tc2), HMt = rVn;
        function iVn(c5, s) {
          s = s || {};
          var r5 = s.isRoundCap;
          return function(g5, b6, S2) {
            var A2 = b6.position;
            if (!A2 || A2 instanceof Array)
              return Oj2(g5, b6, S2);
            var k2 = c5(A2), R6 = b6.distance != null ? b6.distance : 5, B3 = this.shape, G3 = B3.cx, Z3 = B3.cy, X3 = B3.r, tt = B3.r0, it = (X3 + tt) / 2, pt = B3.startAngle, mt = B3.endAngle, Mt = (pt + mt) / 2, kt = r5 ? Math.abs(X3 - tt) / 2 : 0, Gt = Math.cos, Ot = Math.sin, ce2 = G3 + X3 * Gt(pt), ae2 = Z3 + X3 * Ot(pt), de2 = "left", we2 = "top";
            switch (k2) {
              case "startArc":
                ce2 = G3 + (tt - R6) * Gt(Mt), ae2 = Z3 + (tt - R6) * Ot(Mt), de2 = "center", we2 = "top";
                break;
              case "insideStartArc":
                ce2 = G3 + (tt + R6) * Gt(Mt), ae2 = Z3 + (tt + R6) * Ot(Mt), de2 = "center", we2 = "bottom";
                break;
              case "startAngle":
                ce2 = G3 + it * Gt(pt) + UMt(pt, R6 + kt, false), ae2 = Z3 + it * Ot(pt) + qMt(pt, R6 + kt, false), de2 = "right", we2 = "middle";
                break;
              case "insideStartAngle":
                ce2 = G3 + it * Gt(pt) + UMt(pt, -R6 + kt, false), ae2 = Z3 + it * Ot(pt) + qMt(pt, -R6 + kt, false), de2 = "left", we2 = "middle";
                break;
              case "middle":
                ce2 = G3 + it * Gt(Mt), ae2 = Z3 + it * Ot(Mt), de2 = "center", we2 = "middle";
                break;
              case "endArc":
                ce2 = G3 + (X3 + R6) * Gt(Mt), ae2 = Z3 + (X3 + R6) * Ot(Mt), de2 = "center", we2 = "bottom";
                break;
              case "insideEndArc":
                ce2 = G3 + (X3 - R6) * Gt(Mt), ae2 = Z3 + (X3 - R6) * Ot(Mt), de2 = "center", we2 = "top";
                break;
              case "endAngle":
                ce2 = G3 + it * Gt(mt) + UMt(mt, R6 + kt, true), ae2 = Z3 + it * Ot(mt) + qMt(mt, R6 + kt, true), de2 = "left", we2 = "middle";
                break;
              case "insideEndAngle":
                ce2 = G3 + it * Gt(mt) + UMt(mt, -R6 + kt, true), ae2 = Z3 + it * Ot(mt) + qMt(mt, -R6 + kt, true), de2 = "right", we2 = "middle";
                break;
              default:
                return Oj2(g5, b6, S2);
            }
            return g5 = g5 || {}, g5.x = ce2, g5.y = ae2, g5.align = de2, g5.verticalAlign = we2, g5;
          };
        }
        function aVn(c5, s, r5, g5) {
          if (Oh2(g5)) {
            c5.setTextConfig({ rotation: g5 });
            return;
          } else if (ja2(s)) {
            c5.setTextConfig({ rotation: 0 });
            return;
          }
          var b6 = c5.shape, S2 = b6.clockwise ? b6.startAngle : b6.endAngle, A2 = b6.clockwise ? b6.endAngle : b6.startAngle, k2 = (S2 + A2) / 2, R6, B3 = r5(s);
          switch (B3) {
            case "startArc":
            case "insideStartArc":
            case "middle":
            case "insideEndArc":
            case "endArc":
              R6 = k2;
              break;
            case "startAngle":
            case "insideStartAngle":
              R6 = S2;
              break;
            case "endAngle":
            case "insideEndAngle":
              R6 = A2;
              break;
            default:
              c5.setTextConfig({ rotation: 0 });
              return;
          }
          var G3 = Math.PI * 1.5 - R6;
          B3 === "middle" && G3 > Math.PI / 2 && G3 < Math.PI * 1.5 && (G3 -= Math.PI), c5.setTextConfig({ rotation: G3 });
        }
        function UMt(c5, s, r5) {
          return s * Math.sin(c5) * (r5 ? -1 : 1);
        }
        function qMt(c5, s, r5) {
          return s * Math.cos(c5) * (r5 ? 1 : -1);
        }
        var QGt = Math.max, JGt = Math.min;
        function oVn(c5, s) {
          var r5 = c5.getArea && c5.getArea();
          if (CR(c5, "cartesian2d")) {
            var g5 = c5.getBaseAxis();
            if (g5.type !== "category" || !g5.onBand) {
              var b6 = s.getLayout("bandWidth");
              g5.isHorizontal() ? (r5.x -= b6, r5.width += b6 * 2) : (r5.y -= b6, r5.height += b6 * 2);
            }
          }
          return r5;
        }
        var sVn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5.call(this) || this;
            return r5.type = s.type, r5._isFirstFrame = true, r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            this._model = r5, this._removeOnRenderedListener(b6), this._updateDrawMode(r5);
            var A2 = r5.get("coordinateSystem");
            (A2 === "cartesian2d" || A2 === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(r5, g5, b6) : this._renderNormal(r5, g5, b6, S2));
          }, s.prototype.incrementalPrepareRender = function(r5) {
            this._clear(), this._updateDrawMode(r5), this._updateLargeClip(r5);
          }, s.prototype.incrementalRender = function(r5, g5) {
            this._progressiveEls = [], this._incrementalRenderLarge(r5, g5);
          }, s.prototype.eachRendered = function(r5) {
            Ik(this._progressiveEls || this.group, r5);
          }, s.prototype._updateDrawMode = function(r5) {
            var g5 = r5.pipelineContext.large;
            (this._isLargeDraw == null || g5 !== this._isLargeDraw) && (this._isLargeDraw = g5, this._clear());
          }, s.prototype._renderNormal = function(r5, g5, b6, S2) {
            var A2 = this.group, k2 = r5.getData(), R6 = this._data, B3 = r5.coordinateSystem, G3 = B3.getBaseAxis(), Z3;
            B3.type === "cartesian2d" ? Z3 = G3.isHorizontal() : B3.type === "polar" && (Z3 = G3.dim === "angle");
            var X3 = r5.isAnimationEnabled() ? r5 : null, tt = lVn(r5, B3);
            tt && this._enableRealtimeSort(tt, k2, b6);
            var it = r5.get("clip", true) || tt, pt = oVn(B3, k2);
            A2.removeClipPath();
            var mt = r5.get("roundCap", true), Mt = r5.get("showBackground", true), kt = r5.getModel("backgroundStyle"), Gt = kt.get("borderRadius") || 0, Ot = [], ce2 = this._backgroundEls, ae2 = S2 && S2.isInitSort, de2 = S2 && S2.type === "changeAxisOrder";
            function we2(je2) {
              var rn = ZMt[B3.type](k2, je2), qe2 = gVn(B3, Z3, rn);
              return qe2.useStyle(kt.getItemStyle()), B3.type === "cartesian2d" && qe2.setShape("r", Gt), Ot[je2] = qe2, qe2;
            }
            k2.diff(R6).add(function(je2) {
              var rn = k2.getItemModel(je2), qe2 = ZMt[B3.type](k2, je2, rn);
              if (Mt && we2(je2), !(!k2.hasValue(je2) || !dEe[B3.type](qe2))) {
                var An = false;
                it && (An = cEe[B3.type](pt, qe2));
                var jn = fEe[B3.type](r5, k2, je2, qe2, Z3, X3, G3.model, false, mt);
                tt && (jn.forceLabelAnimation = true), vEe(jn, k2, je2, rn, qe2, r5, Z3, B3.type === "polar"), ae2 ? jn.attr({ shape: qe2 }) : tt ? hEe(tt, X3, jn, qe2, je2, Z3, false, false) : tv(jn, { shape: qe2 }, r5, je2), k2.setItemGraphicEl(je2, jn), A2.add(jn), jn.ignore = An;
              }
            }).update(function(je2, rn) {
              var qe2 = k2.getItemModel(je2), An = ZMt[B3.type](k2, je2, qe2);
              if (Mt) {
                var jn = void 0;
                ce2.length === 0 ? jn = we2(rn) : (jn = ce2[rn], jn.useStyle(kt.getItemStyle()), B3.type === "cartesian2d" && jn.setShape("r", Gt), Ot[je2] = jn);
                var _n = ZMt[B3.type](k2, je2), Jr = _Ee(Z3, _n, B3);
                Qf2(jn, { shape: Jr }, X3, je2);
              }
              var Qn = R6.getItemGraphicEl(rn);
              if (!k2.hasValue(je2) || !dEe[B3.type](An)) {
                A2.remove(Qn);
                return;
              }
              var rr = false;
              if (it && (rr = cEe[B3.type](pt, An), rr && A2.remove(Qn)), Qn ? nT(Qn) : Qn = fEe[B3.type](r5, k2, je2, An, Z3, X3, G3.model, !!Qn, mt), tt && (Qn.forceLabelAnimation = true), de2) {
                var Ar = Qn.getTextContent();
                if (Ar) {
                  var fi2 = eX(Ar);
                  fi2.prevValue != null && (fi2.prevValue = fi2.value);
                }
              } else
                vEe(Qn, k2, je2, qe2, An, r5, Z3, B3.type === "polar");
              ae2 ? Qn.attr({ shape: An }) : tt ? hEe(tt, X3, Qn, An, je2, Z3, true, de2) : Qf2(Qn, { shape: An }, r5, je2, null), k2.setItemGraphicEl(je2, Qn), Qn.ignore = rr, A2.add(Qn);
            }).remove(function(je2) {
              var rn = R6.getItemGraphicEl(je2);
              rn && rW(rn, r5, je2);
            }).execute();
            var Se2 = this._backgroundGroup || (this._backgroundGroup = new nu());
            Se2.removeAll();
            for (var Oe2 = 0; Oe2 < Ot.length; ++Oe2)
              Se2.add(Ot[Oe2]);
            A2.add(Se2), this._backgroundEls = Ot, this._data = k2;
          }, s.prototype._renderLarge = function(r5, g5, b6) {
            this._clear(), mEe(r5, this.group), this._updateLargeClip(r5);
          }, s.prototype._incrementalRenderLarge = function(r5, g5) {
            this._removeBackground(), mEe(g5, this.group, this._progressiveEls, true);
          }, s.prototype._updateLargeClip = function(r5) {
            var g5 = r5.get("clip", true) && WMt(r5.coordinateSystem, false, r5), b6 = this.group;
            g5 ? b6.setClipPath(g5) : b6.removeClipPath();
          }, s.prototype._enableRealtimeSort = function(r5, g5, b6) {
            var S2 = this;
            if (g5.count()) {
              var A2 = r5.baseAxis;
              if (this._isFirstFrame)
                this._dispatchInitSort(g5, r5, b6), this._isFirstFrame = false;
              else {
                var k2 = function(R6) {
                  var B3 = g5.getItemGraphicEl(R6), G3 = B3 && B3.shape;
                  return G3 && Math.abs(A2.isHorizontal() ? G3.height : G3.width) || 0;
                };
                this._onRendered = function() {
                  S2._updateSortWithinSameData(g5, k2, A2, b6);
                }, b6.getZr().on("rendered", this._onRendered);
              }
            }
          }, s.prototype._dataSort = function(r5, g5, b6) {
            var S2 = [];
            return r5.each(r5.mapDimension(g5.dim), function(A2, k2) {
              var R6 = b6(k2);
              R6 = R6 == null ? NaN : R6, S2.push({ dataIndex: k2, mappedValue: R6, ordinalNumber: A2 });
            }), S2.sort(function(A2, k2) {
              return k2.mappedValue - A2.mappedValue;
            }), { ordinalNumbers: Ha2(S2, function(A2) {
              return A2.ordinalNumber;
            }) };
          }, s.prototype._isOrderChangedWithinSameData = function(r5, g5, b6) {
            for (var S2 = b6.scale, A2 = r5.mapDimension(b6.dim), k2 = Number.MAX_VALUE, R6 = 0, B3 = S2.getOrdinalMeta().categories.length; R6 < B3; ++R6) {
              var G3 = r5.rawIndexOf(A2, S2.getRawOrdinalNumber(R6)), Z3 = G3 < 0 ? Number.MIN_VALUE : g5(r5.indexOfRawIndex(G3));
              if (Z3 > k2)
                return true;
              k2 = Z3;
            }
            return false;
          }, s.prototype._isOrderDifferentInView = function(r5, g5) {
            for (var b6 = g5.scale, S2 = b6.getExtent(), A2 = Math.max(0, S2[0]), k2 = Math.min(S2[1], b6.getOrdinalMeta().categories.length - 1); A2 <= k2; ++A2)
              if (r5.ordinalNumbers[A2] !== b6.getRawOrdinalNumber(A2))
                return true;
          }, s.prototype._updateSortWithinSameData = function(r5, g5, b6, S2) {
            if (this._isOrderChangedWithinSameData(r5, g5, b6)) {
              var A2 = this._dataSort(r5, b6, g5);
              this._isOrderDifferentInView(A2, b6) && (this._removeOnRenderedListener(S2), S2.dispatchAction({ type: "changeAxisOrder", componentType: b6.dim + "Axis", axisId: b6.index, sortInfo: A2 }));
            }
          }, s.prototype._dispatchInitSort = function(r5, g5, b6) {
            var S2 = g5.baseAxis, A2 = this._dataSort(r5, S2, function(k2) {
              return r5.get(r5.mapDimension(g5.otherAxis.dim), k2);
            });
            b6.dispatchAction({ type: "changeAxisOrder", componentType: S2.dim + "Axis", isInitSort: true, axisId: S2.index, sortInfo: A2 });
          }, s.prototype.remove = function(r5, g5) {
            this._clear(this._model), this._removeOnRenderedListener(g5);
          }, s.prototype.dispose = function(r5, g5) {
            this._removeOnRenderedListener(g5);
          }, s.prototype._removeOnRenderedListener = function(r5) {
            this._onRendered && (r5.getZr().off("rendered", this._onRendered), this._onRendered = null);
          }, s.prototype._clear = function(r5) {
            var g5 = this.group, b6 = this._data;
            r5 && r5.isAnimationEnabled() && b6 && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], b6.eachItemGraphicEl(function(S2) {
              rW(S2, r5, Pl(S2).dataIndex);
            })) : g5.removeAll(), this._data = null, this._isFirstFrame = true;
          }, s.prototype._removeBackground = function() {
            this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
          }, s.type = "bar", s;
        }(Ig2), cEe = { cartesian2d: function(c5, s) {
          var r5 = s.width < 0 ? -1 : 1, g5 = s.height < 0 ? -1 : 1;
          r5 < 0 && (s.x += s.width, s.width = -s.width), g5 < 0 && (s.y += s.height, s.height = -s.height);
          var b6 = c5.x + c5.width, S2 = c5.y + c5.height, A2 = QGt(s.x, c5.x), k2 = JGt(s.x + s.width, b6), R6 = QGt(s.y, c5.y), B3 = JGt(s.y + s.height, S2), G3 = k2 < A2, Z3 = B3 < R6;
          return s.x = G3 && A2 > b6 ? k2 : A2, s.y = Z3 && R6 > S2 ? B3 : R6, s.width = G3 ? 0 : k2 - A2, s.height = Z3 ? 0 : B3 - R6, r5 < 0 && (s.x += s.width, s.width = -s.width), g5 < 0 && (s.y += s.height, s.height = -s.height), G3 || Z3;
        }, polar: function(c5, s) {
          var r5 = s.r0 <= s.r ? 1 : -1;
          if (r5 < 0) {
            var g5 = s.r;
            s.r = s.r0, s.r0 = g5;
          }
          var b6 = JGt(s.r, c5.r), S2 = QGt(s.r0, c5.r0);
          s.r = b6, s.r0 = S2;
          var A2 = b6 - S2 < 0;
          if (r5 < 0) {
            var g5 = s.r;
            s.r = s.r0, s.r0 = g5;
          }
          return A2;
        } }, fEe = { cartesian2d: function(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          var B3 = new zf2({ shape: sa2({}, g5), z2: 1 });
          if (B3.__dataIndex = r5, B3.name = "item", S2) {
            var G3 = B3.shape, Z3 = b6 ? "height" : "width";
            G3[Z3] = 0;
          }
          return B3;
        }, polar: function(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          var B3 = !b6 && R6 ? HMt : Ww, G3 = new B3({ shape: g5, z2: 1 });
          G3.name = "item";
          var Z3 = gEe(b6);
          if (G3.calculateTextPosition = iVn(Z3, { isRoundCap: B3 === HMt }), S2) {
            var X3 = G3.shape, tt = b6 ? "r" : "endAngle", it = {};
            X3[tt] = b6 ? 0 : g5.startAngle, it[tt] = g5[tt], (k2 ? Qf2 : tv)(G3, { shape: it }, S2);
          }
          return G3;
        } };
        function lVn(c5, s) {
          var r5 = c5.get("realtimeSort", true), g5 = s.getBaseAxis();
          if (r5 && g5.type === "category" && s.type === "cartesian2d")
            return { baseAxis: g5, otherAxis: s.getOtherAxis(g5) };
        }
        function hEe(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6, B3;
          S2 ? (B3 = { x: g5.x, width: g5.width }, R6 = { y: g5.y, height: g5.height }) : (B3 = { y: g5.y, height: g5.height }, R6 = { x: g5.x, width: g5.width }), k2 || (A2 ? Qf2 : tv)(r5, { shape: R6 }, s, b6, null);
          var G3 = s ? c5.baseAxis.model : null;
          (A2 ? Qf2 : tv)(r5, { shape: B3 }, G3, b6);
        }
        function pEe(c5, s) {
          for (var r5 = 0; r5 < s.length; r5++)
            if (!isFinite(c5[s[r5]]))
              return true;
          return false;
        }
        var uVn = ["x", "y", "width", "height"], cVn = ["cx", "cy", "r", "startAngle", "endAngle"], dEe = { cartesian2d: function(c5) {
          return !pEe(c5, uVn);
        }, polar: function(c5) {
          return !pEe(c5, cVn);
        } }, ZMt = { cartesian2d: function(c5, s, r5) {
          var g5 = c5.getItemLayout(s), b6 = r5 ? hVn(r5, g5) : 0, S2 = g5.width > 0 ? 1 : -1, A2 = g5.height > 0 ? 1 : -1;
          return { x: g5.x + S2 * b6 / 2, y: g5.y + A2 * b6 / 2, width: g5.width - S2 * b6, height: g5.height - A2 * b6 };
        }, polar: function(c5, s, r5) {
          var g5 = c5.getItemLayout(s);
          return { cx: g5.cx, cy: g5.cy, r0: g5.r0, r: g5.r, startAngle: g5.startAngle, endAngle: g5.endAngle, clockwise: g5.clockwise };
        } };
        function fVn(c5) {
          return c5.startAngle != null && c5.endAngle != null && c5.startAngle === c5.endAngle;
        }
        function gEe(c5) {
          return function(s) {
            var r5 = s ? "Arc" : "Angle";
            return function(g5) {
              switch (g5) {
                case "start":
                case "insideStart":
                case "end":
                case "insideEnd":
                  return g5 + r5;
                default:
                  return g5;
              }
            };
          }(c5);
        }
        function vEe(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6 = s.getItemVisual(r5, "style");
          k2 || c5.setShape("r", g5.get(["itemStyle", "borderRadius"]) || 0), c5.useStyle(R6);
          var B3 = g5.getShallow("cursor");
          B3 && c5.attr("cursor", B3);
          var G3 = k2 ? A2 ? b6.r >= b6.r0 ? "endArc" : "startArc" : b6.endAngle >= b6.startAngle ? "endAngle" : "startAngle" : A2 ? b6.height >= 0 ? "bottom" : "top" : b6.width >= 0 ? "right" : "left", Z3 = qb2(g5);
          Uw(c5, Z3, { labelFetcher: S2, labelDataIndex: r5, defaultText: wX(S2.getData(), r5), inheritColor: R6.fill, defaultOpacity: R6.opacity, defaultOutsidePosition: G3 });
          var X3 = c5.getTextContent();
          if (k2 && X3) {
            var tt = g5.get(["label", "position"]);
            c5.textConfig.inside = tt === "middle" ? true : null, aVn(c5, tt === "outside" ? G3 : tt, gEe(A2), g5.get(["label", "rotate"]));
          }
          NCe(X3, Z3, S2.getRawValue(r5), function(pt) {
            return ZDe(s, pt);
          });
          var it = g5.getModel(["emphasis"]);
          f0(c5, it.get("focus"), it.get("blurScope"), it.get("disabled")), z1(c5, g5), fVn(b6) && (c5.style.fill = "none", c5.style.stroke = "none", Ye2(c5.states, function(pt) {
            pt.style && (pt.style.fill = pt.style.stroke = "none");
          }));
        }
        function hVn(c5, s) {
          var r5 = c5.get(["itemStyle", "borderColor"]);
          if (!r5 || r5 === "none")
            return 0;
          var g5 = c5.get(["itemStyle", "borderWidth"]) || 0, b6 = isNaN(s.width) ? Number.MAX_VALUE : Math.abs(s.width), S2 = isNaN(s.height) ? Number.MAX_VALUE : Math.abs(s.height);
          return Math.min(g5, b6, S2);
        }
        var pVn = function() {
          function c5() {
          }
          return c5;
        }(), yEe = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "largeBar", g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new pVn();
          }, s.prototype.buildPath = function(r5, g5) {
            for (var b6 = g5.points, S2 = this.baseDimIdx, A2 = 1 - this.baseDimIdx, k2 = [], R6 = [], B3 = this.barWidth, G3 = 0; G3 < b6.length; G3 += 3)
              R6[S2] = B3, R6[A2] = b6[G3 + 2], k2[S2] = b6[G3 + S2], k2[A2] = b6[G3 + A2], r5.rect(k2[0], k2[1], R6[0], R6[1]);
          }, s;
        }(Tc2);
        function mEe(c5, s, r5, g5) {
          var b6 = c5.getData(), S2 = b6.getLayout("valueAxisHorizontal") ? 1 : 0, A2 = b6.getLayout("largeDataIndices"), k2 = b6.getLayout("size"), R6 = c5.getModel("backgroundStyle"), B3 = b6.getLayout("largeBackgroundPoints");
          if (B3) {
            var G3 = new yEe({ shape: { points: B3 }, incremental: !!g5, silent: true, z2: 0 });
            G3.baseDimIdx = S2, G3.largeDataIndices = A2, G3.barWidth = k2, G3.useStyle(R6.getItemStyle()), s.add(G3), r5 && r5.push(G3);
          }
          var Z3 = new yEe({ shape: { points: b6.getLayout("largePoints") }, incremental: !!g5, z2: 1 });
          Z3.baseDimIdx = S2, Z3.largeDataIndices = A2, Z3.barWidth = k2, s.add(Z3), Z3.useStyle(b6.getVisual("style")), Pl(Z3).seriesIndex = c5.seriesIndex, c5.get("silent") || (Z3.on("mousedown", bEe), Z3.on("mousemove", bEe)), r5 && r5.push(Z3);
        }
        var bEe = XWt(function(c5) {
          var s = this, r5 = dVn(s, c5.offsetX, c5.offsetY);
          Pl(s).dataIndex = r5 >= 0 ? r5 : null;
        }, 30, false);
        function dVn(c5, s, r5) {
          for (var g5 = c5.baseDimIdx, b6 = 1 - g5, S2 = c5.shape.points, A2 = c5.largeDataIndices, k2 = [], R6 = [], B3 = c5.barWidth, G3 = 0, Z3 = S2.length / 3; G3 < Z3; G3++) {
            var X3 = G3 * 3;
            if (R6[g5] = B3, R6[b6] = S2[X3 + 2], k2[g5] = S2[X3 + g5], k2[b6] = S2[X3 + b6], R6[b6] < 0 && (k2[b6] += R6[b6], R6[b6] = -R6[b6]), s >= k2[0] && s <= k2[0] + R6[0] && r5 >= k2[1] && r5 <= k2[1] + R6[1])
              return A2[G3];
          }
          return -1;
        }
        function _Ee(c5, s, r5) {
          if (CR(r5, "cartesian2d")) {
            var g5 = s, b6 = r5.getArea();
            return { x: c5 ? g5.x : b6.x, y: c5 ? b6.y : g5.y, width: c5 ? g5.width : b6.width, height: c5 ? b6.height : g5.height };
          } else {
            var b6 = r5.getArea(), S2 = s;
            return { cx: b6.cx, cy: b6.cy, r0: c5 ? b6.r0 : S2.r0, r: c5 ? b6.r : S2.r, startAngle: c5 ? S2.startAngle : 0, endAngle: c5 ? S2.endAngle : Math.PI * 2 };
          }
        }
        function gVn(c5, s, r5) {
          var g5 = c5.type === "polar" ? Ww : zf2;
          return new g5({ shape: _Ee(s, r5, c5), silent: true, z2: 0 });
        }
        var vVn = sVn;
        function yVn(c5) {
          c5.registerChartView(vVn), c5.registerSeriesModel(eVn), c5.registerLayout(c5.PRIORITY.VISUAL.LAYOUT, Au(BIe, "bar")), c5.registerLayout(c5.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, zIe("bar")), c5.registerProcessor(c5.PRIORITY.PROCESSOR.STATISTIC, lEe("bar")), c5.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(s, r5) {
            var g5 = s.componentType || "series";
            r5.eachComponent({ mainType: g5, query: s }, function(b6) {
              s.sortInfo && b6.axis.setCategorySortInfo(s.sortInfo);
            });
          });
        }
        var $Mt = Math.PI * 2, xEe = Math.PI / 180;
        function wEe(c5, s) {
          return $m(c5.getBoxLayoutParams(), { width: s.getWidth(), height: s.getHeight() });
        }
        function SEe(c5, s) {
          var r5 = wEe(c5, s), g5 = c5.get("center"), b6 = c5.get("radius");
          ja2(b6) || (b6 = [0, b6]), ja2(g5) || (g5 = [g5, g5]);
          var S2 = $o(r5.width, s.getWidth()), A2 = $o(r5.height, s.getHeight()), k2 = Math.min(S2, A2), R6 = $o(g5[0], S2) + r5.x, B3 = $o(g5[1], A2) + r5.y, G3 = $o(b6[0], k2 / 2), Z3 = $o(b6[1], k2 / 2);
          return { cx: R6, cy: B3, r0: G3, r: Z3 };
        }
        function mVn(c5, s, r5) {
          s.eachSeriesByType(c5, function(g5) {
            var b6 = g5.getData(), S2 = b6.mapDimension("value"), A2 = wEe(g5, r5), k2 = SEe(g5, r5), R6 = k2.cx, B3 = k2.cy, G3 = k2.r, Z3 = k2.r0, X3 = -g5.get("startAngle") * xEe, tt = g5.get("minAngle") * xEe, it = 0;
            b6.each(S2, function(Oe2) {
              !isNaN(Oe2) && it++;
            });
            var pt = b6.getSum(S2), mt = Math.PI / (pt || it) * 2, Mt = g5.get("clockwise"), kt = g5.get("roseType"), Gt = g5.get("stillShowZeroSum"), Ot = b6.getDataExtent(S2);
            Ot[0] = 0;
            var ce2 = $Mt, ae2 = 0, de2 = X3, we2 = Mt ? 1 : -1;
            if (b6.setLayout({ viewRect: A2, r: G3 }), b6.each(S2, function(Oe2, je2) {
              var rn;
              if (isNaN(Oe2)) {
                b6.setItemLayout(je2, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: Mt, cx: R6, cy: B3, r0: Z3, r: kt ? NaN : G3 });
                return;
              }
              kt !== "area" ? rn = pt === 0 && Gt ? mt : Oe2 * mt : rn = $Mt / it, rn < tt ? (rn = tt, ce2 -= tt) : ae2 += Oe2;
              var qe2 = de2 + we2 * rn;
              b6.setItemLayout(je2, { angle: rn, startAngle: de2, endAngle: qe2, clockwise: Mt, cx: R6, cy: B3, r0: Z3, r: kt ? fh2(Oe2, Ot, [Z3, G3]) : G3 }), de2 = qe2;
            }), ce2 < $Mt && it)
              if (ce2 <= 1e-3) {
                var Se2 = $Mt / it;
                b6.each(S2, function(Oe2, je2) {
                  if (!isNaN(Oe2)) {
                    var rn = b6.getItemLayout(je2);
                    rn.angle = Se2, rn.startAngle = X3 + we2 * je2 * Se2, rn.endAngle = X3 + we2 * (je2 + 1) * Se2;
                  }
                });
              } else
                mt = ce2 / ae2, de2 = X3, b6.each(S2, function(Oe2, je2) {
                  if (!isNaN(Oe2)) {
                    var rn = b6.getItemLayout(je2), qe2 = rn.angle === tt ? tt : Oe2 * mt;
                    rn.startAngle = de2, rn.endAngle = de2 + we2 * qe2, de2 += we2 * qe2;
                  }
                });
          });
        }
        function zct(c5) {
          return { seriesType: c5, reset: function(s, r5) {
            var g5 = r5.findComponents({ mainType: "legend" });
            if (!(!g5 || !g5.length)) {
              var b6 = s.getData();
              b6.filterSelf(function(S2) {
                for (var A2 = b6.getName(S2), k2 = 0; k2 < g5.length; k2++)
                  if (!g5[k2].isSelected(A2))
                    return false;
                return true;
              });
            }
          } };
        }
        var bVn = Math.PI / 180;
        function MEe(c5, s, r5, g5, b6, S2, A2, k2, R6, B3) {
          if (c5.length < 2)
            return;
          function G3(pt) {
            for (var mt = pt.rB, Mt = mt * mt, kt = 0; kt < pt.list.length; kt++) {
              var Gt = pt.list[kt], Ot = Math.abs(Gt.label.y - r5), ce2 = g5 + Gt.len, ae2 = ce2 * ce2, de2 = Math.sqrt((1 - Math.abs(Ot * Ot / Mt)) * ae2), we2 = s + (de2 + Gt.len2) * b6, Se2 = we2 - Gt.label.x, Oe2 = Gt.targetTextWidth - Se2 * b6;
              CEe(Gt, Oe2, true), Gt.label.x = we2;
            }
          }
          function Z3(pt) {
            for (var mt = { list: [], maxY: 0 }, Mt = { list: [], maxY: 0 }, kt = 0; kt < pt.length; kt++)
              if (pt[kt].labelAlignTo === "none") {
                var Gt = pt[kt], Ot = Gt.label.y > r5 ? Mt : mt, ce2 = Math.abs(Gt.label.y - r5);
                if (ce2 >= Ot.maxY) {
                  var ae2 = Gt.label.x - s - Gt.len2 * b6, de2 = g5 + Gt.len, we2 = Math.abs(ae2) < de2 ? Math.sqrt(ce2 * ce2 / (1 - ae2 * ae2 / de2 / de2)) : de2;
                  Ot.rB = we2, Ot.maxY = ce2;
                }
                Ot.list.push(Gt);
              }
            G3(mt), G3(Mt);
          }
          for (var X3 = c5.length, tt = 0; tt < X3; tt++)
            if (c5[tt].position === "outer" && c5[tt].labelAlignTo === "labelLine") {
              var it = c5[tt].label.x - B3;
              c5[tt].linePoints[1][0] += it, c5[tt].label.x = B3;
            }
          mDe(c5, R6, R6 + A2) && Z3(c5);
        }
        function _Vn(c5, s, r5, g5, b6, S2, A2, k2) {
          for (var R6 = [], B3 = [], G3 = Number.MAX_VALUE, Z3 = -Number.MAX_VALUE, X3 = 0; X3 < c5.length; X3++) {
            var tt = c5[X3].label;
            tHt(c5[X3]) || (tt.x < s ? (G3 = Math.min(G3, tt.x), R6.push(c5[X3])) : (Z3 = Math.max(Z3, tt.x), B3.push(c5[X3])));
          }
          for (var X3 = 0; X3 < c5.length; X3++) {
            var it = c5[X3];
            if (!tHt(it) && it.linePoints) {
              if (it.labelStyleWidth != null)
                continue;
              var tt = it.label, pt = it.linePoints, mt = void 0;
              it.labelAlignTo === "edge" ? tt.x < s ? mt = pt[2][0] - it.labelDistance - A2 - it.edgeDistance : mt = A2 + b6 - it.edgeDistance - pt[2][0] - it.labelDistance : it.labelAlignTo === "labelLine" ? tt.x < s ? mt = G3 - A2 - it.bleedMargin : mt = A2 + b6 - Z3 - it.bleedMargin : tt.x < s ? mt = tt.x - A2 - it.bleedMargin : mt = A2 + b6 - tt.x - it.bleedMargin, it.targetTextWidth = mt, CEe(it, mt);
            }
          }
          MEe(B3, s, r5, g5, 1, b6, S2, A2, k2, Z3), MEe(R6, s, r5, g5, -1, b6, S2, A2, k2, G3);
          for (var X3 = 0; X3 < c5.length; X3++) {
            var it = c5[X3];
            if (!tHt(it) && it.linePoints) {
              var tt = it.label, pt = it.linePoints, Mt = it.labelAlignTo === "edge", kt = tt.style.padding, Gt = kt ? kt[1] + kt[3] : 0, Ot = tt.style.backgroundColor ? 0 : Gt, ce2 = it.rect.width + Ot, ae2 = pt[1][0] - pt[2][0];
              Mt ? tt.x < s ? pt[2][0] = A2 + it.edgeDistance + ce2 + it.labelDistance : pt[2][0] = A2 + b6 - it.edgeDistance - ce2 - it.labelDistance : (tt.x < s ? pt[2][0] = tt.x + it.labelDistance : pt[2][0] = tt.x - it.labelDistance, pt[1][0] = pt[2][0] + ae2), pt[1][1] = pt[2][1] = tt.y;
            }
          }
        }
        function CEe(c5, s, r5) {
          if (r5 === void 0 && (r5 = false), c5.labelStyleWidth == null) {
            var g5 = c5.label, b6 = g5.style, S2 = c5.rect, A2 = b6.backgroundColor, k2 = b6.padding, R6 = k2 ? k2[1] + k2[3] : 0, B3 = b6.overflow, G3 = S2.width + (A2 ? 0 : R6);
            if (s < G3 || r5) {
              var Z3 = S2.height;
              if (B3 && B3.match("break")) {
                g5.setStyle("backgroundColor", null), g5.setStyle("width", s - R6);
                var X3 = g5.getBoundingRect();
                g5.setStyle("width", Math.ceil(X3.width)), g5.setStyle("backgroundColor", A2);
              } else {
                var tt = s - R6, it = s < G3 ? tt : r5 ? tt > c5.unconstrainedWidth ? null : tt : null;
                g5.setStyle("width", it);
              }
              var pt = g5.getBoundingRect();
              S2.width = pt.width;
              var mt = (g5.style.margin || 0) + 2.1;
              S2.height = pt.height + mt, S2.y -= (S2.height - Z3) / 2;
            }
          }
        }
        function tHt(c5) {
          return c5.position === "center";
        }
        function xVn(c5) {
          var s = c5.getData(), r5 = [], g5, b6, S2 = false, A2 = (c5.get("minShowLabelAngle") || 0) * bVn, k2 = s.getLayout("viewRect"), R6 = s.getLayout("r"), B3 = k2.width, G3 = k2.x, Z3 = k2.y, X3 = k2.height;
          function tt(ae2) {
            ae2.ignore = true;
          }
          function it(ae2) {
            if (!ae2.ignore)
              return true;
            for (var de2 in ae2.states)
              if (ae2.states[de2].ignore === false)
                return true;
            return false;
          }
          s.each(function(ae2) {
            var de2 = s.getItemGraphicEl(ae2), we2 = de2.shape, Se2 = de2.getTextContent(), Oe2 = de2.getTextGuideLine(), je2 = s.getItemModel(ae2), rn = je2.getModel("label"), qe2 = rn.get("position") || je2.get(["emphasis", "label", "position"]), An = rn.get("distanceToLabelLine"), jn = rn.get("alignTo"), _n = $o(rn.get("edgeDistance"), B3), Jr = rn.get("bleedMargin"), Qn = je2.getModel("labelLine"), rr = Qn.get("length");
            rr = $o(rr, B3);
            var Ar = Qn.get("length2");
            if (Ar = $o(Ar, B3), Math.abs(we2.endAngle - we2.startAngle) < A2) {
              Ye2(Se2.states, tt), Se2.ignore = true;
              return;
            }
            if (it(Se2)) {
              var fi2 = (we2.startAngle + we2.endAngle) / 2, mi2 = Math.cos(fi2), Oo = Math.sin(fi2), Ts, gl, nl, rl;
              g5 = we2.cx, b6 = we2.cy;
              var ss = qe2 === "inside" || qe2 === "inner";
              if (qe2 === "center")
                Ts = we2.cx, gl = we2.cy, rl = "center";
              else {
                var Us = (ss ? (we2.r + we2.r0) / 2 * mi2 : we2.r * mi2) + g5, sl = (ss ? (we2.r + we2.r0) / 2 * Oo : we2.r * Oo) + b6;
                if (Ts = Us + mi2 * 3, gl = sl + Oo * 3, !ss) {
                  var ws = Us + mi2 * (rr + R6 - we2.r), Ll = sl + Oo * (rr + R6 - we2.r), dh2 = ws + (mi2 < 0 ? -1 : 1) * Ar, hu = Ll;
                  jn === "edge" ? Ts = mi2 < 0 ? G3 + _n : G3 + B3 - _n : Ts = dh2 + (mi2 < 0 ? -An : An), gl = hu, nl = [[Us, sl], [ws, Ll], [dh2, hu]];
                }
                rl = ss ? "center" : jn === "edge" ? mi2 > 0 ? "right" : "left" : mi2 > 0 ? "left" : "right";
              }
              var Nh2 = Math.PI, cp = 0, Xh2 = rn.get("rotate");
              if (Oh2(Xh2))
                cp = Xh2 * (Nh2 / 180);
              else if (qe2 === "center")
                cp = 0;
              else if (Xh2 === "radial" || Xh2 === true) {
                var om = mi2 < 0 ? -fi2 + Nh2 : -fi2;
                cp = om;
              } else if (Xh2 === "tangential" && qe2 !== "outside" && qe2 !== "outer") {
                var Sv = Math.atan2(mi2, Oo);
                Sv < 0 && (Sv = Nh2 * 2 + Sv);
                var U1 = Oo > 0;
                U1 && (Sv = Nh2 + Sv), cp = Sv - Nh2;
              }
              if (S2 = !!cp, Se2.x = Ts, Se2.y = gl, Se2.rotation = cp, Se2.setStyle({ verticalAlign: "middle" }), ss) {
                Se2.setStyle({ align: rl });
                var Jd2 = Se2.states.select;
                Jd2 && (Jd2.x += Se2.x, Jd2.y += Se2.y);
              } else {
                var jv = Se2.getBoundingRect().clone();
                jv.applyTransform(Se2.getComputedTransform());
                var Mv = (Se2.style.margin || 0) + 2.1;
                jv.y -= Mv / 2, jv.height += Mv, r5.push({ label: Se2, labelLine: Oe2, position: qe2, len: rr, len2: Ar, minTurnAngle: Qn.get("minTurnAngle"), maxSurfaceAngle: Qn.get("maxSurfaceAngle"), surfaceNormal: new Bu(mi2, Oo), linePoints: nl, textAlign: rl, labelDistance: An, labelAlignTo: jn, edgeDistance: _n, bleedMargin: Jr, rect: jv, unconstrainedWidth: jv.width, labelStyleWidth: Se2.style.width });
              }
              de2.setTextConfig({ inside: ss });
            }
          }), !S2 && c5.get("avoidLabelOverlap") && _Vn(r5, g5, b6, R6, B3, X3, G3, Z3);
          for (var pt = 0; pt < r5.length; pt++) {
            var mt = r5[pt], Mt = mt.label, kt = mt.labelLine, Gt = isNaN(Mt.x) || isNaN(Mt.y);
            if (Mt) {
              Mt.setStyle({ align: mt.textAlign }), Gt && (Ye2(Mt.states, tt), Mt.ignore = true);
              var Ot = Mt.states.select;
              Ot && (Ot.x += Mt.x, Ot.y += Mt.y);
            }
            if (kt) {
              var ce2 = mt.linePoints;
              Gt || !ce2 ? (Ye2(kt.states, tt), kt.ignore = true) : (dDe(ce2, mt.minTurnAngle), L9n(ce2, mt.surfaceNormal, mt.maxSurfaceAngle), kt.setShape({ points: ce2 }), Mt.__hostTarget.textGuideLineConfig = { anchor: new Bu(ce2[0][0], ce2[0][1]) });
            }
          }
        }
        function SX(c5, s, r5) {
          var g5 = c5.get("borderRadius");
          if (g5 == null)
            return r5 ? { cornerRadius: 0 } : null;
          ja2(g5) || (g5 = [g5, g5, g5, g5]);
          var b6 = Math.abs(s.r || 0 - s.r0 || 0);
          return { cornerRadius: Ha2(g5, function(S2) {
            return f22(S2, b6);
          }) };
        }
        var wVn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this) || this;
            S2.z2 = 2;
            var A2 = new hh2();
            return S2.setTextContent(A2), S2.updateData(r5, g5, b6, true), S2;
          }
          return s.prototype.updateData = function(r5, g5, b6, S2) {
            var A2 = this, k2 = r5.hostModel, R6 = r5.getItemModel(g5), B3 = R6.getModel("emphasis"), G3 = r5.getItemLayout(g5), Z3 = sa2(SX(R6.getModel("itemStyle"), G3, true), G3);
            if (isNaN(Z3.startAngle)) {
              A2.setShape(Z3);
              return;
            }
            if (S2) {
              A2.setShape(Z3);
              var X3 = k2.getShallow("animationType");
              k2.ecModel.ssr ? (tv(A2, { scaleX: 0, scaleY: 0 }, k2, { dataIndex: g5, isFrom: true }), A2.originX = Z3.cx, A2.originY = Z3.cy) : X3 === "scale" ? (A2.shape.r = G3.r0, tv(A2, { shape: { r: G3.r } }, k2, g5)) : b6 != null ? (A2.setShape({ startAngle: b6, endAngle: b6 }), tv(A2, { shape: { startAngle: G3.startAngle, endAngle: G3.endAngle } }, k2, g5)) : (A2.shape.endAngle = G3.startAngle, Qf2(A2, { shape: { endAngle: G3.endAngle } }, k2, g5));
            } else
              nT(A2), Qf2(A2, { shape: Z3 }, k2, g5);
            A2.useStyle(r5.getItemVisual(g5, "style")), z1(A2, R6);
            var tt = (G3.startAngle + G3.endAngle) / 2, it = k2.get("selectedOffset"), pt = Math.cos(tt) * it, mt = Math.sin(tt) * it, Mt = R6.getShallow("cursor");
            Mt && A2.attr("cursor", Mt), this._updateLabel(k2, r5, g5), A2.ensureState("emphasis").shape = sa2({ r: G3.r + (B3.get("scale") && B3.get("scaleSize") || 0) }, SX(B3.getModel("itemStyle"), G3)), sa2(A2.ensureState("select"), { x: pt, y: mt, shape: SX(R6.getModel(["select", "itemStyle"]), G3) }), sa2(A2.ensureState("blur"), { shape: SX(R6.getModel(["blur", "itemStyle"]), G3) });
            var kt = A2.getTextGuideLine(), Gt = A2.getTextContent();
            kt && sa2(kt.ensureState("select"), { x: pt, y: mt }), sa2(Gt.ensureState("select"), { x: pt, y: mt }), f0(this, B3.get("focus"), B3.get("blurScope"), B3.get("disabled"));
          }, s.prototype._updateLabel = function(r5, g5, b6) {
            var S2 = this, A2 = g5.getItemModel(b6), k2 = A2.getModel("labelLine"), R6 = g5.getItemVisual(b6, "style"), B3 = R6 && R6.fill, G3 = R6 && R6.opacity;
            Uw(S2, qb2(A2), { labelFetcher: g5.hostModel, labelDataIndex: b6, inheritColor: B3, defaultOpacity: G3, defaultText: r5.getFormattedLabel(b6, "normal") || g5.getName(b6) });
            var Z3 = S2.getTextContent();
            S2.setTextConfig({ position: null, rotation: null }), Z3.attr({ z2: 10 });
            var X3 = r5.get(["label", "position"]);
            if (X3 !== "outside" && X3 !== "outer")
              S2.removeTextGuideLine();
            else {
              var tt = this.getTextGuideLine();
              tt || (tt = new Gw(), this.setTextGuideLine(tt)), OGt(this, RGt(A2), { stroke: B3, opacity: pk2(k2.get(["lineStyle", "opacity"]), G3, 1) });
            }
          }, s;
        }(Ww), SVn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.ignoreLabelLineUpdate = true, r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            var A2 = r5.getData(), k2 = this._data, R6 = this.group, B3;
            if (!k2 && A2.count() > 0) {
              for (var G3 = A2.getItemLayout(0), Z3 = 1; isNaN(G3 && G3.startAngle) && Z3 < A2.count(); ++Z3)
                G3 = A2.getItemLayout(Z3);
              G3 && (B3 = G3.startAngle);
            }
            if (this._emptyCircleSector && R6.remove(this._emptyCircleSector), A2.count() === 0 && r5.get("showEmptyCircle")) {
              var X3 = new Ww({ shape: SEe(r5, b6) });
              X3.useStyle(r5.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = X3, R6.add(X3);
            }
            A2.diff(k2).add(function(tt) {
              var it = new wVn(A2, tt, B3);
              A2.setItemGraphicEl(tt, it), R6.add(it);
            }).update(function(tt, it) {
              var pt = k2.getItemGraphicEl(it);
              pt.updateData(A2, tt, B3), pt.off("click"), R6.add(pt), A2.setItemGraphicEl(tt, pt);
            }).remove(function(tt) {
              var it = k2.getItemGraphicEl(tt);
              rW(it, r5, tt);
            }).execute(), xVn(r5), r5.get("animationTypeUpdate") !== "expansion" && (this._data = A2);
          }, s.prototype.dispose = function() {
          }, s.prototype.containPoint = function(r5, g5) {
            var b6 = g5.getData(), S2 = b6.getItemLayout(0);
            if (S2) {
              var A2 = r5[0] - S2.cx, k2 = r5[1] - S2.cy, R6 = Math.sqrt(A2 * A2 + k2 * k2);
              return R6 <= S2.r && R6 >= S2.r0;
            }
          }, s.type = "pie", s;
        }(Ig2), MVn = SVn;
        function MX(c5, s, r5) {
          s = ja2(s) && { coordDimensions: s } || sa2({ encodeDefine: c5.getEncode() }, s);
          var g5 = c5.getSource(), b6 = Act(g5, s).dimensions, S2 = new m22(b6, c5);
          return S2.initData(g5, r5), S2;
        }
        var CVn = function() {
          function c5(s, r5) {
            this._getDataWithEncodedVisual = s, this._getRawData = r5;
          }
          return c5.prototype.getAllNames = function() {
            var s = this._getRawData();
            return s.mapArray(s.getName);
          }, c5.prototype.containName = function(s) {
            var r5 = this._getRawData();
            return r5.indexOfName(s) >= 0;
          }, c5.prototype.indexOfName = function(s) {
            var r5 = this._getDataWithEncodedVisual();
            return r5.indexOfName(s);
          }, c5.prototype.getItemVisual = function(s, r5) {
            var g5 = this._getDataWithEncodedVisual();
            return g5.getItemVisual(s, r5);
          }, c5;
        }(), jct = CVn, TVn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.init = function(r5) {
            c5.prototype.init.apply(this, arguments), this.legendVisualProvider = new jct(Cs(this.getData, this), Cs(this.getRawData, this)), this._defaultLabelLine(r5);
          }, s.prototype.mergeOption = function() {
            c5.prototype.mergeOption.apply(this, arguments);
          }, s.prototype.getInitialData = function() {
            return MX(this, { coordDimensions: ["value"], encodeDefaulter: Au(IWt, this) });
          }, s.prototype.getDataParams = function(r5) {
            var g5 = this.getData(), b6 = c5.prototype.getDataParams.call(this, r5), S2 = [];
            return g5.each(g5.mapDimension("value"), function(A2) {
              S2.push(A2);
            }), b6.percent = mK(S2, r5, g5.hostModel.get("percentPrecision")), b6.$vars.push("percent"), b6;
          }, s.prototype._defaultLabelLine = function(r5) {
            wM(r5, "labelLine", ["show"]);
            var g5 = r5.labelLine, b6 = r5.emphasis.labelLine;
            g5.show = g5.show && r5.label.show, b6.show = b6.show && r5.emphasis.label.show;
          }, s.type = "series.pie", s.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, s;
        }(zv), AVn = TVn;
        function IVn(c5) {
          return { seriesType: c5, reset: function(s, r5) {
            var g5 = s.getData();
            g5.filterSelf(function(b6) {
              var S2 = g5.mapDimension("value"), A2 = g5.get(S2, b6);
              return !(Oh2(A2) && !isNaN(A2) && A2 < 0);
            });
          } };
        }
        function DVn(c5) {
          c5.registerChartView(MVn), c5.registerSeriesModel(AVn), EAe("pie", c5.registerAction), c5.registerLayout(Au(mVn, "pie")), c5.registerProcessor(zct("pie")), c5.registerProcessor(IVn("pie"));
        }
        var EVn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.hasSymbolVisual = true, r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            return SR(null, this, { useEncodeDefaulter: true });
          }, s.prototype.getProgressive = function() {
            var r5 = this.option.progressive;
            return r5 == null ? this.option.large ? 5e3 : this.get("progressive") : r5;
          }, s.prototype.getProgressiveThreshold = function() {
            var r5 = this.option.progressiveThreshold;
            return r5 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : r5;
          }, s.prototype.brushSelector = function(r5, g5, b6) {
            return b6.point(g5.getItemLayout(r5));
          }, s.prototype.getZLevelKey = function() {
            return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
          }, s.type = "series.scatter", s.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], s.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, s;
        }(zv), kVn = EVn, TEe = 4, PVn = function() {
          function c5() {
          }
          return c5;
        }(), LVn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5._off = 0, g5.hoverDataIdx = -1, g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new PVn();
          }, s.prototype.reset = function() {
            this.notClear = false, this._off = 0;
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.points, S2 = g5.size, A2 = this.symbolProxy, k2 = A2.shape, R6 = r5.getContext ? r5.getContext() : r5, B3 = R6 && S2[0] < TEe, G3 = this.softClipShape, Z3;
            if (B3) {
              this._ctx = R6;
              return;
            }
            for (this._ctx = null, Z3 = this._off; Z3 < b6.length; ) {
              var X3 = b6[Z3++], tt = b6[Z3++];
              isNaN(X3) || isNaN(tt) || G3 && !G3.contain(X3, tt) || (k2.x = X3 - S2[0] / 2, k2.y = tt - S2[1] / 2, k2.width = S2[0], k2.height = S2[1], A2.buildPath(r5, k2, true));
            }
            this.incremental && (this._off = Z3, this.notClear = true);
          }, s.prototype.afterBrush = function() {
            var r5 = this.shape, g5 = r5.points, b6 = r5.size, S2 = this._ctx, A2 = this.softClipShape, k2;
            if (S2) {
              for (k2 = this._off; k2 < g5.length; ) {
                var R6 = g5[k2++], B3 = g5[k2++];
                isNaN(R6) || isNaN(B3) || A2 && !A2.contain(R6, B3) || S2.fillRect(R6 - b6[0] / 2, B3 - b6[1] / 2, b6[0], b6[1]);
              }
              this.incremental && (this._off = k2, this.notClear = true);
            }
          }, s.prototype.findDataIndex = function(r5, g5) {
            for (var b6 = this.shape, S2 = b6.points, A2 = b6.size, k2 = Math.max(A2[0], 4), R6 = Math.max(A2[1], 4), B3 = S2.length / 2 - 1; B3 >= 0; B3--) {
              var G3 = B3 * 2, Z3 = S2[G3] - k2 / 2, X3 = S2[G3 + 1] - R6 / 2;
              if (r5 >= Z3 && g5 >= X3 && r5 <= Z3 + k2 && g5 <= X3 + R6)
                return B3;
            }
            return -1;
          }, s.prototype.contain = function(r5, g5) {
            var b6 = this.transformCoordToLocal(r5, g5), S2 = this.getBoundingRect();
            if (r5 = b6[0], g5 = b6[1], S2.contain(r5, g5)) {
              var A2 = this.hoverDataIdx = this.findDataIndex(r5, g5);
              return A2 >= 0;
            }
            return this.hoverDataIdx = -1, false;
          }, s.prototype.getBoundingRect = function() {
            var r5 = this._rect;
            if (!r5) {
              for (var g5 = this.shape, b6 = g5.points, S2 = g5.size, A2 = S2[0], k2 = S2[1], R6 = 1 / 0, B3 = 1 / 0, G3 = -1 / 0, Z3 = -1 / 0, X3 = 0; X3 < b6.length; ) {
                var tt = b6[X3++], it = b6[X3++];
                R6 = Math.min(tt, R6), G3 = Math.max(tt, G3), B3 = Math.min(it, B3), Z3 = Math.max(it, Z3);
              }
              r5 = this._rect = new lc2(R6 - A2 / 2, B3 - k2 / 2, G3 - R6 + A2, Z3 - B3 + k2);
            }
            return r5;
          }, s;
        }(Tc2), OVn = function() {
          function c5() {
            this.group = new nu();
          }
          return c5.prototype.updateData = function(s, r5) {
            this._clear();
            var g5 = this._create();
            g5.setShape({ points: s.getLayout("points") }), this._setCommon(g5, s, r5);
          }, c5.prototype.updateLayout = function(s) {
            var r5 = s.getLayout("points");
            this.group.eachChild(function(g5) {
              if (g5.startIndex != null) {
                var b6 = (g5.endIndex - g5.startIndex) * 2, S2 = g5.startIndex * 4 * 2;
                r5 = new Float32Array(r5.buffer, S2, b6);
              }
              g5.setShape("points", r5), g5.reset();
            });
          }, c5.prototype.incrementalPrepareUpdate = function(s) {
            this._clear();
          }, c5.prototype.incrementalUpdate = function(s, r5, g5) {
            var b6 = this._newAdded[0], S2 = r5.getLayout("points"), A2 = b6 && b6.shape.points;
            if (A2 && A2.length < 2e4) {
              var k2 = A2.length, R6 = new Float32Array(k2 + S2.length);
              R6.set(A2), R6.set(S2, k2), b6.endIndex = s.end, b6.setShape({ points: R6 });
            } else {
              this._newAdded = [];
              var B3 = this._create();
              B3.startIndex = s.start, B3.endIndex = s.end, B3.incremental = true, B3.setShape({ points: S2 }), this._setCommon(B3, r5, g5);
            }
          }, c5.prototype.eachRendered = function(s) {
            this._newAdded[0] && s(this._newAdded[0]);
          }, c5.prototype._create = function() {
            var s = new LVn({ cursor: "default" });
            return this.group.add(s), this._newAdded.push(s), s;
          }, c5.prototype._setCommon = function(s, r5, g5) {
            var b6 = r5.hostModel;
            g5 = g5 || {};
            var S2 = r5.getVisual("symbolSize");
            s.setShape("size", S2 instanceof Array ? S2 : [S2, S2]), s.softClipShape = g5.clipShape || null, s.symbolProxy = am(r5.getVisual("symbol"), 0, 0, 0, 0), s.setColor = s.symbolProxy.setColor;
            var A2 = s.shape.size[0] < TEe;
            s.useStyle(b6.getModel("itemStyle").getItemStyle(A2 ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
            var k2 = r5.getVisual("style"), R6 = k2 && k2.fill;
            R6 && s.setColor(R6);
            var B3 = Pl(s);
            B3.seriesIndex = b6.seriesIndex, s.on("mousemove", function(G3) {
              B3.dataIndex = null;
              var Z3 = s.hoverDataIdx;
              Z3 >= 0 && (B3.dataIndex = Z3 + (s.startIndex || 0));
            });
          }, c5.prototype.remove = function() {
            this._clear();
          }, c5.prototype._clear = function() {
            this._newAdded = [], this.group.removeAll();
          }, c5;
        }(), RVn = OVn, NVn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this._updateSymbolDraw(S2, r5);
            A2.updateData(S2, { clipShape: this._getClipShape(r5) }), this._finished = true;
          }, s.prototype.incrementalPrepareRender = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this._updateSymbolDraw(S2, r5);
            A2.incrementalPrepareUpdate(S2), this._finished = false;
          }, s.prototype.incrementalRender = function(r5, g5, b6) {
            this._symbolDraw.incrementalUpdate(r5, g5.getData(), { clipShape: this._getClipShape(g5) }), this._finished = r5.end === g5.getData().count();
          }, s.prototype.updateTransform = function(r5, g5, b6) {
            var S2 = r5.getData();
            if (this.group.dirty(), !this._finished || S2.count() > 1e4)
              return { update: true };
            var A2 = Bct("").reset(r5, g5, b6);
            A2.progress && A2.progress({ start: 0, end: S2.count(), count: S2.count() }, S2), this._symbolDraw.updateLayout(S2);
          }, s.prototype.eachRendered = function(r5) {
            this._symbolDraw && this._symbolDraw.eachRendered(r5);
          }, s.prototype._getClipShape = function(r5) {
            var g5 = r5.coordinateSystem, b6 = g5 && g5.getArea && g5.getArea();
            return r5.get("clip", true) ? b6 : null;
          }, s.prototype._updateSymbolDraw = function(r5, g5) {
            var b6 = this._symbolDraw, S2 = g5.pipelineContext, A2 = S2.large;
            return (!b6 || A2 !== this._isLargeDraw) && (b6 && b6.remove(), b6 = this._symbolDraw = A2 ? new RVn() : new Vct(), this._isLargeDraw = A2, this.group.removeAll()), this.group.add(b6.group), b6;
          }, s.prototype.remove = function(r5, g5) {
            this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
          }, s.prototype.dispose = function() {
          }, s.type = "scatter", s;
        }(Ig2), FVn = NVn, VVn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.type = "grid", s.dependencies = ["xAxis", "yAxis"], s.layoutMode = "box", s.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, s;
        }(Rh2), BVn = VVn, eHt = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.getCoordSysModel = function() {
            return this.getReferringComponents("grid", E0).models[0];
          }, s.type = "cartesian2dAxis", s;
        }(Rh2);
        A0(eHt, Ect);
        var AEe = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, zVn = bu({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, AEe), nHt = bu({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, AEe), jVn = bu({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, nHt), WVn = Cl({ logBase: 10 }, nHt), IEe = { category: zVn, value: nHt, time: jVn, log: WVn }, GVn = { value: 1, category: 1, time: 1, log: 1 };
        function CX(c5, s, r5, g5) {
          Ye2(GVn, function(b6, S2) {
            var A2 = bu(bu({}, IEe[S2], true), g5, true), k2 = function(R6) {
              wn(B3, R6);
              function B3() {
                var G3 = R6 !== null && R6.apply(this, arguments) || this;
                return G3.type = s + "Axis." + S2, G3;
              }
              return B3.prototype.mergeDefaultAndTheme = function(G3, Z3) {
                var X3 = ict(this), tt = X3 ? oX(G3) : {}, it = Z3.getTheme();
                bu(G3, it.get(S2 + "Axis")), bu(G3, this.getDefaultOption()), G3.type = DEe(G3), X3 && Y8(G3, tt, X3);
              }, B3.prototype.optionUpdated = function() {
                var G3 = this.option;
                G3.type === "category" && (this.__ordinalMeta = wGt.createByAxisModel(this));
              }, B3.prototype.getCategories = function(G3) {
                var Z3 = this.option;
                if (Z3.type === "category")
                  return G3 ? Z3.data : this.__ordinalMeta.categories;
              }, B3.prototype.getOrdinalMeta = function() {
                return this.__ordinalMeta;
              }, B3.type = s + "Axis." + S2, B3.defaultOption = A2, B3;
            }(r5);
            c5.registerComponentModel(k2);
          }), c5.registerSubTypeDefaulter(s + "Axis", DEe);
        }
        function DEe(c5) {
          return c5.type || (c5.data ? "category" : "value");
        }
        var HVn = function() {
          function c5(s) {
            this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = s || "";
          }
          return c5.prototype.getAxis = function(s) {
            return this._axes[s];
          }, c5.prototype.getAxes = function() {
            return Ha2(this._dimList, function(s) {
              return this._axes[s];
            }, this);
          }, c5.prototype.getAxesByScale = function(s) {
            return s = s.toLowerCase(), jp(this.getAxes(), function(r5) {
              return r5.scale.type === s;
            });
          }, c5.prototype.addAxis = function(s) {
            var r5 = s.dim;
            this._axes[r5] = s, this._dimList.push(r5);
          }, c5;
        }(), UVn = HVn, rHt = ["x", "y"];
        function EEe(c5) {
          return c5.type === "interval" || c5.type === "time";
        }
        var qVn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "cartesian2d", r5.dimensions = rHt, r5;
          }
          return s.prototype.calcAffineTransform = function() {
            this._transform = this._invTransform = null;
            var r5 = this.getAxis("x").scale, g5 = this.getAxis("y").scale;
            if (!(!EEe(r5) || !EEe(g5))) {
              var b6 = r5.getExtent(), S2 = g5.getExtent(), A2 = this.dataToPoint([b6[0], S2[0]]), k2 = this.dataToPoint([b6[1], S2[1]]), R6 = b6[1] - b6[0], B3 = S2[1] - S2[0];
              if (!(!R6 || !B3)) {
                var G3 = (k2[0] - A2[0]) / R6, Z3 = (k2[1] - A2[1]) / B3, X3 = A2[0] - b6[0] * G3, tt = A2[1] - S2[0] * Z3, it = this._transform = [G3, 0, 0, Z3, X3, tt];
                this._invTransform = Y4([], it);
              }
            }
          }, s.prototype.getBaseAxis = function() {
            return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
          }, s.prototype.containPoint = function(r5) {
            var g5 = this.getAxis("x"), b6 = this.getAxis("y");
            return g5.contain(g5.toLocalCoord(r5[0])) && b6.contain(b6.toLocalCoord(r5[1]));
          }, s.prototype.containData = function(r5) {
            return this.getAxis("x").containData(r5[0]) && this.getAxis("y").containData(r5[1]);
          }, s.prototype.dataToPoint = function(r5, g5, b6) {
            b6 = b6 || [];
            var S2 = r5[0], A2 = r5[1];
            if (this._transform && S2 != null && isFinite(S2) && A2 != null && isFinite(A2))
              return Gm(b6, r5, this._transform);
            var k2 = this.getAxis("x"), R6 = this.getAxis("y");
            return b6[0] = k2.toGlobalCoord(k2.dataToCoord(S2, g5)), b6[1] = R6.toGlobalCoord(R6.dataToCoord(A2, g5)), b6;
          }, s.prototype.clampData = function(r5, g5) {
            var b6 = this.getAxis("x").scale, S2 = this.getAxis("y").scale, A2 = b6.getExtent(), k2 = S2.getExtent(), R6 = b6.parse(r5[0]), B3 = S2.parse(r5[1]);
            return g5 = g5 || [], g5[0] = Math.min(Math.max(Math.min(A2[0], A2[1]), R6), Math.max(A2[0], A2[1])), g5[1] = Math.min(Math.max(Math.min(k2[0], k2[1]), B3), Math.max(k2[0], k2[1])), g5;
          }, s.prototype.pointToData = function(r5, g5) {
            var b6 = [];
            if (this._invTransform)
              return Gm(b6, r5, this._invTransform);
            var S2 = this.getAxis("x"), A2 = this.getAxis("y");
            return b6[0] = S2.coordToData(S2.toLocalCoord(r5[0]), g5), b6[1] = A2.coordToData(A2.toLocalCoord(r5[1]), g5), b6;
          }, s.prototype.getOtherAxis = function(r5) {
            return this.getAxis(r5.dim === "x" ? "y" : "x");
          }, s.prototype.getArea = function() {
            var r5 = this.getAxis("x").getGlobalExtent(), g5 = this.getAxis("y").getGlobalExtent(), b6 = Math.min(r5[0], r5[1]), S2 = Math.min(g5[0], g5[1]), A2 = Math.max(r5[0], r5[1]) - b6, k2 = Math.max(g5[0], g5[1]) - S2;
            return new lc2(b6, S2, A2, k2);
          }, s;
        }(UVn), ZVn = qVn, $Vn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2, A2) {
            var k2 = c5.call(this, r5, g5, b6) || this;
            return k2.index = 0, k2.type = S2 || "value", k2.position = A2 || "bottom", k2;
          }
          return s.prototype.isHorizontal = function() {
            var r5 = this.position;
            return r5 === "top" || r5 === "bottom";
          }, s.prototype.getGlobalExtent = function(r5) {
            var g5 = this.getExtent();
            return g5[0] = this.toGlobalCoord(g5[0]), g5[1] = this.toGlobalCoord(g5[1]), r5 && g5[0] > g5[1] && g5.reverse(), g5;
          }, s.prototype.pointToData = function(r5, g5) {
            return this.coordToData(this.toLocalCoord(r5[this.dim === "x" ? 0 : 1]), g5);
          }, s.prototype.setCategorySortInfo = function(r5) {
            if (this.type !== "category")
              return false;
            this.model.option.categorySortInfo = r5, this.scale.setSortInfo(r5);
          }, s;
        }(kk2), YVn = $Vn;
        function iHt(c5, s, r5) {
          r5 = r5 || {};
          var g5 = c5.coordinateSystem, b6 = s.axis, S2 = {}, A2 = b6.getAxesOnZeroOf()[0], k2 = b6.position, R6 = A2 ? "onZero" : k2, B3 = b6.dim, G3 = g5.getRect(), Z3 = [G3.x, G3.x + G3.width, G3.y, G3.y + G3.height], X3 = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, tt = s.get("offset") || 0, it = B3 === "x" ? [Z3[2] - tt, Z3[3] + tt] : [Z3[0] - tt, Z3[1] + tt];
          if (A2) {
            var pt = A2.toGlobalCoord(A2.dataToCoord(0));
            it[X3.onZero] = Math.max(Math.min(pt, it[1]), it[0]);
          }
          S2.position = [B3 === "y" ? it[X3[R6]] : Z3[0], B3 === "x" ? it[X3[R6]] : Z3[3]], S2.rotation = Math.PI / 2 * (B3 === "x" ? 0 : 1);
          var mt = { top: -1, bottom: 1, left: -1, right: 1 };
          S2.labelDirection = S2.tickDirection = S2.nameDirection = mt[k2], S2.labelOffset = A2 ? it[X3[k2]] - it[X3.onZero] : 0, s.get(["axisTick", "inside"]) && (S2.tickDirection = -S2.tickDirection), Wm(r5.labelInside, s.get(["axisLabel", "inside"])) && (S2.labelDirection = -S2.labelDirection);
          var Mt = s.get(["axisLabel", "rotate"]);
          return S2.labelRotate = R6 === "top" ? -Mt : Mt, S2.z2 = 1, S2;
        }
        function kEe(c5) {
          return c5.get("coordinateSystem") === "cartesian2d";
        }
        function PEe(c5) {
          var s = { xAxisModel: null, yAxisModel: null };
          return Ye2(s, function(r5, g5) {
            var b6 = g5.replace(/Model$/, ""), S2 = c5.getReferringComponents(b6, E0).models[0];
            s[g5] = S2;
          }), s;
        }
        var aHt = Math.log;
        function LEe(c5, s, r5) {
          var g5 = n9.prototype, b6 = g5.getTicks.call(r5), S2 = g5.getTicks.call(r5, true), A2 = b6.length - 1, k2 = g5.getInterval.call(r5), R6 = YIe(c5, s), B3 = R6.extent, G3 = R6.fixMin, Z3 = R6.fixMax;
          if (c5.type === "log") {
            var X3 = aHt(c5.base);
            B3 = [aHt(B3[0]) / X3, aHt(B3[1]) / X3];
          }
          c5.setExtent(B3[0], B3[1]), c5.calcNiceExtent({ splitNumber: A2, fixMin: G3, fixMax: Z3 });
          var tt = g5.getExtent.call(c5);
          G3 && (B3[0] = tt[0]), Z3 && (B3[1] = tt[1]);
          var it = g5.getInterval.call(c5), pt = B3[0], mt = B3[1];
          if (G3 && Z3)
            it = (mt - pt) / A2;
          else if (G3)
            for (mt = B3[0] + it * A2; mt < B3[1] && isFinite(mt) && isFinite(B3[1]); )
              it = MGt(it), mt = B3[0] + it * A2;
          else if (Z3)
            for (pt = B3[1] - it * A2; pt > B3[0] && isFinite(pt) && isFinite(B3[0]); )
              it = MGt(it), pt = B3[1] - it * A2;
          else {
            var Mt = c5.getTicks().length - 1;
            Mt > A2 && (it = MGt(it));
            var kt = it * A2;
            mt = Math.ceil(B3[1] / it) * it, pt = c0(mt - kt), pt < 0 && B3[0] >= 0 ? (pt = 0, mt = c0(kt)) : mt > 0 && B3[1] <= 0 && (mt = 0, pt = -c0(kt));
          }
          var Gt = (b6[0].value - S2[0].value) / k2, Ot = (b6[A2].value - S2[A2].value) / k2;
          g5.setExtent.call(c5, pt + it * Gt, mt + it * Ot), g5.setInterval.call(c5, it), (Gt || Ot) && g5.setNiceExtent.call(c5, pt + it, mt - it);
        }
        var KVn = function() {
          function c5(s, r5, g5) {
            this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = rHt, this._initCartesian(s, r5, g5), this.model = s;
          }
          return c5.prototype.getRect = function() {
            return this._rect;
          }, c5.prototype.update = function(s, r5) {
            var g5 = this._axesMap;
            this._updateScale(s, this.model);
            function b6(A2) {
              var k2, R6 = nf2(A2), B3 = R6.length;
              if (B3) {
                for (var G3 = [], Z3 = B3 - 1; Z3 >= 0; Z3--) {
                  var X3 = +R6[Z3], tt = A2[X3], it = tt.model, pt = tt.scale;
                  SGt(pt) && it.get("alignTicks") && it.get("interval") == null ? G3.push(tt) : (_X(pt, it), SGt(pt) && (k2 = tt));
                }
                G3.length && (k2 || (k2 = G3.pop(), _X(k2.scale, k2.model)), Ye2(G3, function(mt) {
                  LEe(mt.scale, mt.model, k2.scale);
                }));
              }
            }
            b6(g5.x), b6(g5.y);
            var S2 = {};
            Ye2(g5.x, function(A2) {
              OEe(g5, "y", A2, S2);
            }), Ye2(g5.y, function(A2) {
              OEe(g5, "x", A2, S2);
            }), this.resize(this.model, r5);
          }, c5.prototype.resize = function(s, r5, g5) {
            var b6 = s.getBoxLayoutParams(), S2 = !g5 && s.get("containLabel"), A2 = $m(b6, { width: r5.getWidth(), height: r5.getHeight() });
            this._rect = A2;
            var k2 = this._axesList;
            R6(), S2 && (Ye2(k2, function(B3) {
              if (!B3.model.get(["axisLabel", "inside"])) {
                var G3 = u9n(B3);
                if (G3) {
                  var Z3 = B3.isHorizontal() ? "height" : "width", X3 = B3.model.get(["axisLabel", "margin"]);
                  A2[Z3] -= G3[Z3] + X3, B3.position === "top" ? A2.y += G3.height + X3 : B3.position === "left" && (A2.x += G3.width + X3);
                }
              }
            }), R6()), Ye2(this._coordsList, function(B3) {
              B3.calcAffineTransform();
            });
            function R6() {
              Ye2(k2, function(B3) {
                var G3 = B3.isHorizontal(), Z3 = G3 ? [0, A2.width] : [0, A2.height], X3 = B3.inverse ? 1 : 0;
                B3.setExtent(Z3[X3], Z3[1 - X3]), XVn(B3, G3 ? A2.x : A2.y);
              });
            }
          }, c5.prototype.getAxis = function(s, r5) {
            var g5 = this._axesMap[s];
            if (g5 != null)
              return g5[r5 || 0];
          }, c5.prototype.getAxes = function() {
            return this._axesList.slice();
          }, c5.prototype.getCartesian = function(s, r5) {
            if (s != null && r5 != null) {
              var g5 = "x" + s + "y" + r5;
              return this._coordsMap[g5];
            }
            Wl(s) && (r5 = s.yAxisIndex, s = s.xAxisIndex);
            for (var b6 = 0, S2 = this._coordsList; b6 < S2.length; b6++)
              if (S2[b6].getAxis("x").index === s || S2[b6].getAxis("y").index === r5)
                return S2[b6];
          }, c5.prototype.getCartesians = function() {
            return this._coordsList.slice();
          }, c5.prototype.convertToPixel = function(s, r5, g5) {
            var b6 = this._findConvertTarget(r5);
            return b6.cartesian ? b6.cartesian.dataToPoint(g5) : b6.axis ? b6.axis.toGlobalCoord(b6.axis.dataToCoord(g5)) : null;
          }, c5.prototype.convertFromPixel = function(s, r5, g5) {
            var b6 = this._findConvertTarget(r5);
            return b6.cartesian ? b6.cartesian.pointToData(g5) : b6.axis ? b6.axis.coordToData(b6.axis.toLocalCoord(g5)) : null;
          }, c5.prototype._findConvertTarget = function(s) {
            var r5 = s.seriesModel, g5 = s.xAxisModel || r5 && r5.getReferringComponents("xAxis", E0).models[0], b6 = s.yAxisModel || r5 && r5.getReferringComponents("yAxis", E0).models[0], S2 = s.gridModel, A2 = this._coordsList, k2, R6;
            if (r5)
              k2 = r5.coordinateSystem, Lu(A2, k2) < 0 && (k2 = null);
            else if (g5 && b6)
              k2 = this.getCartesian(g5.componentIndex, b6.componentIndex);
            else if (g5)
              R6 = this.getAxis("x", g5.componentIndex);
            else if (b6)
              R6 = this.getAxis("y", b6.componentIndex);
            else if (S2) {
              var B3 = S2.coordinateSystem;
              B3 === this && (k2 = this._coordsList[0]);
            }
            return { cartesian: k2, axis: R6 };
          }, c5.prototype.containPoint = function(s) {
            var r5 = this._coordsList[0];
            if (r5)
              return r5.containPoint(s);
          }, c5.prototype._initCartesian = function(s, r5, g5) {
            var b6 = this, S2 = this, A2 = { left: false, right: false, top: false, bottom: false }, k2 = { x: {}, y: {} }, R6 = { x: 0, y: 0 };
            if (r5.eachComponent("xAxis", B3("x"), this), r5.eachComponent("yAxis", B3("y"), this), !R6.x || !R6.y) {
              this._axesMap = {}, this._axesList = [];
              return;
            }
            this._axesMap = k2, Ye2(k2.x, function(G3, Z3) {
              Ye2(k2.y, function(X3, tt) {
                var it = "x" + Z3 + "y" + tt, pt = new ZVn(it);
                pt.master = b6, pt.model = s, b6._coordsMap[it] = pt, b6._coordsList.push(pt), pt.addAxis(G3), pt.addAxis(X3);
              });
            });
            function B3(G3) {
              return function(Z3, X3) {
                if (oHt(Z3, s)) {
                  var tt = Z3.get("position");
                  G3 === "x" ? tt !== "top" && tt !== "bottom" && (tt = A2.bottom ? "top" : "bottom") : tt !== "left" && tt !== "right" && (tt = A2.left ? "right" : "left"), A2[tt] = true;
                  var it = new YVn(G3, LMt(Z3), [0, 0], Z3.get("type"), tt), pt = it.type === "category";
                  it.onBand = pt && Z3.get("boundaryGap"), it.inverse = Z3.get("inverse"), Z3.axis = it, it.model = Z3, it.grid = S2, it.index = X3, S2._axesList.push(it), k2[G3][X3] = it, R6[G3]++;
                }
              };
            }
          }, c5.prototype._updateScale = function(s, r5) {
            Ye2(this._axesList, function(b6) {
              if (b6.scale.setExtent(1 / 0, -1 / 0), b6.type === "category") {
                var S2 = b6.model.get("categorySortInfo");
                b6.scale.setSortInfo(S2);
              }
            }), s.eachSeries(function(b6) {
              if (kEe(b6)) {
                var S2 = PEe(b6), A2 = S2.xAxisModel, k2 = S2.yAxisModel;
                if (!oHt(A2, r5) || !oHt(k2, r5))
                  return;
                var R6 = this.getCartesian(A2.componentIndex, k2.componentIndex), B3 = b6.getData(), G3 = R6.getAxis("x"), Z3 = R6.getAxis("y");
                g5(B3, G3), g5(B3, Z3);
              }
            }, this);
            function g5(b6, S2) {
              Ye2(OMt(b6, S2.dim), function(A2) {
                S2.scale.unionExtentFromData(b6, A2);
              });
            }
          }, c5.prototype.getTooltipAxes = function(s) {
            var r5 = [], g5 = [];
            return Ye2(this.getCartesians(), function(b6) {
              var S2 = s != null && s !== "auto" ? b6.getAxis(s) : b6.getBaseAxis(), A2 = b6.getOtherAxis(S2);
              Lu(r5, S2) < 0 && r5.push(S2), Lu(g5, A2) < 0 && g5.push(A2);
            }), { baseAxes: r5, otherAxes: g5 };
          }, c5.create = function(s, r5) {
            var g5 = [];
            return s.eachComponent("grid", function(b6, S2) {
              var A2 = new c5(b6, s, r5);
              A2.name = "grid_" + S2, A2.resize(b6, r5, true), b6.coordinateSystem = A2, g5.push(A2);
            }), s.eachSeries(function(b6) {
              if (kEe(b6)) {
                var S2 = PEe(b6), A2 = S2.xAxisModel, k2 = S2.yAxisModel, R6 = A2.getCoordSysModel(), B3 = R6.coordinateSystem;
                b6.coordinateSystem = B3.getCartesian(A2.componentIndex, k2.componentIndex);
              }
            }), g5;
          }, c5.dimensions = rHt, c5;
        }();
        function oHt(c5, s) {
          return c5.getCoordSysModel() === s;
        }
        function OEe(c5, s, r5, g5) {
          r5.getAxesOnZeroOf = function() {
            return S2 ? [S2] : [];
          };
          var b6 = c5[s], S2, A2 = r5.model, k2 = A2.get(["axisLine", "onZero"]), R6 = A2.get(["axisLine", "onZeroAxisIndex"]);
          if (!k2)
            return;
          if (R6 != null)
            REe(b6[R6]) && (S2 = b6[R6]);
          else
            for (var B3 in b6)
              if (b6.hasOwnProperty(B3) && REe(b6[B3]) && !g5[G3(b6[B3])]) {
                S2 = b6[B3];
                break;
              }
          S2 && (g5[G3(S2)] = true);
          function G3(Z3) {
            return Z3.dim + "_" + Z3.index;
          }
        }
        function REe(c5) {
          return c5 && c5.type !== "category" && c5.type !== "time" && l9n(c5);
        }
        function XVn(c5, s) {
          var r5 = c5.getExtent(), g5 = r5[0] + r5[1];
          c5.toGlobalCoord = c5.dim === "x" ? function(b6) {
            return b6 + s;
          } : function(b6) {
            return g5 - b6 + s;
          }, c5.toLocalCoord = c5.dim === "x" ? function(b6) {
            return b6 - s;
          } : function(b6) {
            return g5 - b6 + s;
          };
        }
        var QVn = KVn, o9 = Math.PI, wW = function() {
          function c5(s, r5) {
            this.group = new nu(), this.opt = r5, this.axisModel = s, Cl(r5, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
              return true;
            } });
            var g5 = new nu({ x: r5.position[0], y: r5.position[1], rotation: r5.rotation });
            g5.updateTransform(), this._transformGroup = g5;
          }
          return c5.prototype.hasBuilder = function(s) {
            return !!NEe[s];
          }, c5.prototype.add = function(s) {
            NEe[s](this.opt, this.axisModel, this.group, this._transformGroup);
          }, c5.prototype.getGroup = function() {
            return this.group;
          }, c5.innerTextLayout = function(s, r5, g5) {
            var b6 = LSt(r5 - s), S2, A2;
            return Bj2(b6) ? (A2 = g5 > 0 ? "top" : "bottom", S2 = "center") : Bj2(b6 - o9) ? (A2 = g5 > 0 ? "bottom" : "top", S2 = "center") : (A2 = "middle", b6 > 0 && b6 < o9 ? S2 = g5 > 0 ? "right" : "left" : S2 = g5 > 0 ? "left" : "right"), { rotation: b6, textAlign: S2, textVerticalAlign: A2 };
          }, c5.makeAxisEventDataBase = function(s) {
            var r5 = { componentType: s.mainType, componentIndex: s.componentIndex };
            return r5[s.mainType + "Index"] = s.componentIndex, r5;
          }, c5.isLabelSilent = function(s) {
            var r5 = s.get("tooltip");
            return s.get("silent") || !(s.get("triggerEvent") || r5 && r5.show);
          }, c5;
        }(), NEe = { axisLine: function(c5, s, r5, g5) {
          var b6 = s.get(["axisLine", "show"]);
          if (b6 === "auto" && c5.handleAutoShown && (b6 = c5.handleAutoShown("axisLine")), !!b6) {
            var S2 = s.axis.getExtent(), A2 = g5.transform, k2 = [S2[0], 0], R6 = [S2[1], 0];
            A2 && (Gm(k2, k2, A2), Gm(R6, R6, A2));
            var B3 = sa2({ lineCap: "round" }, s.getModel(["axisLine", "lineStyle"]).getLineStyle()), G3 = new Zm({ subPixelOptimize: true, shape: { x1: k2[0], y1: k2[1], x2: R6[0], y2: R6[1] }, style: B3, strokeContainThreshold: c5.strokeContainThreshold || 5, silent: true, z2: 1 });
            G3.anid = "line", r5.add(G3);
            var Z3 = s.get(["axisLine", "symbol"]);
            if (Z3 != null) {
              var X3 = s.get(["axisLine", "symbolSize"]);
              gs(Z3) && (Z3 = [Z3, Z3]), (gs(X3) || Oh2(X3)) && (X3 = [X3, X3]);
              var tt = vX(s.get(["axisLine", "symbolOffset"]) || 0, X3), it = X3[0], pt = X3[1];
              Ye2([{ rotate: c5.rotation + Math.PI / 2, offset: tt[0], r: 0 }, { rotate: c5.rotation - Math.PI / 2, offset: tt[1], r: Math.sqrt((k2[0] - R6[0]) * (k2[0] - R6[0]) + (k2[1] - R6[1]) * (k2[1] - R6[1])) }], function(mt, Mt) {
                if (Z3[Mt] !== "none" && Z3[Mt] != null) {
                  var kt = am(Z3[Mt], -it / 2, -pt / 2, it, pt, B3.stroke, true), Gt = mt.r + mt.offset;
                  kt.attr({ rotation: mt.rotate, x: k2[0] + Gt * Math.cos(c5.rotation), y: k2[1] - Gt * Math.sin(c5.rotation), silent: true, z2: 11 }), r5.add(kt);
                }
              });
            }
          }
        }, axisTickLabel: function(c5, s, r5, g5) {
          var b6 = eBn(r5, g5, s, c5), S2 = rBn(r5, g5, s, c5);
          if (tBn(s, S2, b6), nBn(r5, g5, s, c5.tickDirection), s.get(["axisLabel", "hideOverlap"])) {
            var A2 = vDe(Ha2(S2, function(k2) {
              return { label: k2, priority: k2.z2, defaultAttr: { ignore: k2.ignore } };
            }));
            bDe(A2);
          }
        }, axisName: function(c5, s, r5, g5) {
          var b6 = Wm(c5.axisName, s.get("name"));
          if (b6) {
            var S2 = s.get("nameLocation"), A2 = c5.nameDirection, k2 = s.getModel("nameTextStyle"), R6 = s.get("nameGap") || 0, B3 = s.axis.getExtent(), G3 = B3[0] > B3[1] ? -1 : 1, Z3 = [S2 === "start" ? B3[0] - G3 * R6 : S2 === "end" ? B3[1] + G3 * R6 : (B3[0] + B3[1]) / 2, VEe(S2) ? c5.labelOffset + A2 * R6 : 0], X3, tt = s.get("nameRotate");
            tt != null && (tt = tt * o9 / 180);
            var it;
            VEe(S2) ? X3 = wW.innerTextLayout(c5.rotation, tt != null ? tt : c5.rotation, A2) : (X3 = JVn(c5.rotation, S2, tt || 0, B3), it = c5.axisNameAvailableWidth, it != null && (it = Math.abs(it / Math.sin(X3.rotation)), !isFinite(it) && (it = null)));
            var pt = k2.getFont(), mt = s.get("nameTruncate", true) || {}, Mt = mt.ellipsis, kt = Wm(c5.nameTruncateMaxWidth, mt.maxWidth, it), Gt = new hh2({ x: Z3[0], y: Z3[1], rotation: X3.rotation, silent: wW.isLabelSilent(s), style: Ey(k2, { text: b6, font: pt, overflow: "truncate", width: kt, ellipsis: Mt, fill: k2.getTextColor() || s.get(["axisLine", "lineStyle", "color"]), align: k2.get("align") || X3.textAlign, verticalAlign: k2.get("verticalAlign") || X3.textVerticalAlign }), z2: 1 });
            if (Ub2({ el: Gt, componentModel: s, itemName: b6 }), Gt.__fullText = b6, Gt.anid = "name", s.get("triggerEvent")) {
              var Ot = wW.makeAxisEventDataBase(s);
              Ot.targetType = "axisName", Ot.name = b6, Pl(Gt).eventData = Ot;
            }
            g5.add(Gt), Gt.updateTransform(), r5.add(Gt), Gt.decomposeTransform();
          }
        } };
        function JVn(c5, s, r5, g5) {
          var b6 = LSt(r5 - c5), S2, A2, k2 = g5[0] > g5[1], R6 = s === "start" && !k2 || s !== "start" && k2;
          return Bj2(b6 - o9 / 2) ? (A2 = R6 ? "bottom" : "top", S2 = "center") : Bj2(b6 - o9 * 1.5) ? (A2 = R6 ? "top" : "bottom", S2 = "center") : (A2 = "middle", b6 < o9 * 1.5 && b6 > o9 / 2 ? S2 = R6 ? "left" : "right" : S2 = R6 ? "right" : "left"), { rotation: b6, textAlign: S2, textVerticalAlign: A2 };
        }
        function tBn(c5, s, r5) {
          if (!KIe(c5.axis)) {
            var g5 = c5.get(["axisLabel", "showMinLabel"]), b6 = c5.get(["axisLabel", "showMaxLabel"]);
            s = s || [], r5 = r5 || [];
            var S2 = s[0], A2 = s[1], k2 = s[s.length - 1], R6 = s[s.length - 2], B3 = r5[0], G3 = r5[1], Z3 = r5[r5.length - 1], X3 = r5[r5.length - 2];
            g5 === false ? (eD(S2), eD(B3)) : FEe(S2, A2) && (g5 ? (eD(A2), eD(G3)) : (eD(S2), eD(B3))), b6 === false ? (eD(k2), eD(Z3)) : FEe(R6, k2) && (b6 ? (eD(R6), eD(X3)) : (eD(k2), eD(Z3)));
          }
        }
        function eD(c5) {
          c5 && (c5.ignore = true);
        }
        function FEe(c5, s) {
          var r5 = c5 && c5.getBoundingRect().clone(), g5 = s && s.getBoundingRect().clone();
          if (!(!r5 || !g5)) {
            var b6 = Dj2([]);
            return f3(b6, b6, -c5.rotation), r5.applyTransform(_k([], b6, c5.getLocalTransform())), g5.applyTransform(_k([], b6, s.getLocalTransform())), r5.intersect(g5);
          }
        }
        function VEe(c5) {
          return c5 === "middle" || c5 === "center";
        }
        function BEe(c5, s, r5, g5, b6) {
          for (var S2 = [], A2 = [], k2 = [], R6 = 0; R6 < c5.length; R6++) {
            var B3 = c5[R6].coord;
            A2[0] = B3, A2[1] = 0, k2[0] = B3, k2[1] = r5, s && (Gm(A2, A2, s), Gm(k2, k2, s));
            var G3 = new Zm({ subPixelOptimize: true, shape: { x1: A2[0], y1: A2[1], x2: k2[0], y2: k2[1] }, style: g5, z2: 2, autoBatch: true, silent: true });
            G3.anid = b6 + "_" + c5[R6].tickValue, S2.push(G3);
          }
          return S2;
        }
        function eBn(c5, s, r5, g5) {
          var b6 = r5.axis, S2 = r5.getModel("axisTick"), A2 = S2.get("show");
          if (A2 === "auto" && g5.handleAutoShown && (A2 = g5.handleAutoShown("axisTick")), !(!A2 || b6.scale.isBlank())) {
            for (var k2 = S2.getModel("lineStyle"), R6 = g5.tickDirection * S2.get("length"), B3 = b6.getTicksCoords(), G3 = BEe(B3, s.transform, R6, Cl(k2.getLineStyle(), { stroke: r5.get(["axisLine", "lineStyle", "color"]) }), "ticks"), Z3 = 0; Z3 < G3.length; Z3++)
              c5.add(G3[Z3]);
            return G3;
          }
        }
        function nBn(c5, s, r5, g5) {
          var b6 = r5.axis, S2 = r5.getModel("minorTick");
          if (!(!S2.get("show") || b6.scale.isBlank())) {
            var A2 = b6.getMinorTicksCoords();
            if (A2.length)
              for (var k2 = S2.getModel("lineStyle"), R6 = g5 * S2.get("length"), B3 = Cl(k2.getLineStyle(), Cl(r5.getModel("axisTick").getLineStyle(), { stroke: r5.get(["axisLine", "lineStyle", "color"]) })), G3 = 0; G3 < A2.length; G3++)
                for (var Z3 = BEe(A2[G3], s.transform, R6, B3, "minorticks_" + G3), X3 = 0; X3 < Z3.length; X3++)
                  c5.add(Z3[X3]);
          }
        }
        function rBn(c5, s, r5, g5) {
          var b6 = r5.axis, S2 = Wm(g5.axisLabelShow, r5.get(["axisLabel", "show"]));
          if (!(!S2 || b6.scale.isBlank())) {
            var A2 = r5.getModel("axisLabel"), k2 = A2.get("margin"), R6 = b6.getViewLabels(), B3 = (Wm(g5.labelRotate, A2.get("rotate")) || 0) * o9 / 180, G3 = wW.innerTextLayout(g5.rotation, B3, g5.labelDirection), Z3 = r5.getCategories && r5.getCategories(true), X3 = [], tt = wW.isLabelSilent(r5), it = r5.get("triggerEvent");
            return Ye2(R6, function(pt, mt) {
              var Mt = b6.scale.type === "ordinal" ? b6.scale.getRawOrdinalNumber(pt.tickValue) : pt.tickValue, kt = pt.formattedLabel, Gt = pt.rawLabel, Ot = A2;
              if (Z3 && Z3[Mt]) {
                var ce2 = Z3[Mt];
                Wl(ce2) && ce2.textStyle && (Ot = new Ag2(ce2.textStyle, A2, r5.ecModel));
              }
              var ae2 = Ot.getTextColor() || r5.get(["axisLine", "lineStyle", "color"]), de2 = b6.dataToCoord(Mt), we2 = new hh2({ x: de2, y: g5.labelOffset + g5.labelDirection * k2, rotation: G3.rotation, silent: tt, z2: 10 + (pt.level || 0), style: Ey(Ot, { text: kt, align: Ot.getShallow("align", true) || G3.textAlign, verticalAlign: Ot.getShallow("verticalAlign", true) || Ot.getShallow("baseline", true) || G3.textVerticalAlign, fill: Tl(ae2) ? ae2(b6.type === "category" ? Gt : b6.type === "value" ? Mt + "" : Mt, mt) : ae2 }) });
              if (we2.anid = "label_" + Mt, it) {
                var Se2 = wW.makeAxisEventDataBase(r5);
                Se2.targetType = "axisLabel", Se2.value = Gt, Se2.tickIndex = mt, b6.type === "category" && (Se2.dataIndex = Mt), Pl(we2).eventData = Se2;
              }
              s.add(we2), we2.updateTransform(), X3.push(we2), c5.add(we2), we2.decomposeTransform();
            }), X3;
          }
        }
        var TR = wW;
        function iBn(c5, s) {
          var r5 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
          return aBn(r5, c5, s), r5.seriesInvolved && sBn(r5, c5), r5;
        }
        function aBn(c5, s, r5) {
          var g5 = s.getComponent("tooltip"), b6 = s.getComponent("axisPointer"), S2 = b6.get("link", true) || [], A2 = [];
          Ye2(r5.getCoordinateSystems(), function(k2) {
            if (!k2.axisPointerEnabled)
              return;
            var R6 = Wct(k2.model), B3 = c5.coordSysAxesInfo[R6] = {};
            c5.coordSysMap[R6] = k2;
            var G3 = k2.model, Z3 = G3.getModel("tooltip", g5);
            if (Ye2(k2.getAxes(), Au(pt, false, null)), k2.getTooltipAxes && g5 && Z3.get("show")) {
              var X3 = Z3.get("trigger") === "axis", tt = Z3.get(["axisPointer", "type"]) === "cross", it = k2.getTooltipAxes(Z3.get(["axisPointer", "axis"]));
              (X3 || tt) && Ye2(it.baseAxes, Au(pt, tt ? "cross" : true, X3)), tt && Ye2(it.otherAxes, Au(pt, "cross", false));
            }
            function pt(mt, Mt, kt) {
              var Gt = kt.model.getModel("axisPointer", b6), Ot = Gt.get("show");
              if (!(!Ot || Ot === "auto" && !mt && !uHt(Gt))) {
                Mt == null && (Mt = Gt.get("triggerTooltip")), Gt = mt ? oBn(kt, Z3, b6, s, mt, Mt) : Gt;
                var ce2 = Gt.get("snap"), ae2 = Wct(kt.model), de2 = Mt || ce2 || kt.type === "category", we2 = c5.axesInfo[ae2] = { key: ae2, axis: kt, coordSys: k2, axisPointerModel: Gt, triggerTooltip: Mt, involveSeries: de2, snap: ce2, useHandle: uHt(Gt), seriesModels: [], linkGroup: null };
                B3[ae2] = we2, c5.seriesInvolved = c5.seriesInvolved || de2;
                var Se2 = lBn(S2, kt);
                if (Se2 != null) {
                  var Oe2 = A2[Se2] || (A2[Se2] = { axesInfo: {} });
                  Oe2.axesInfo[ae2] = we2, Oe2.mapper = S2[Se2].mapper, we2.linkGroup = Oe2;
                }
              }
            }
          });
        }
        function oBn(c5, s, r5, g5, b6, S2) {
          var A2 = s.getModel("axisPointer"), k2 = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], R6 = {};
          Ye2(k2, function(X3) {
            R6[X3] = Ml(A2.get(X3));
          }), R6.snap = c5.type !== "category" && !!S2, A2.get("type") === "cross" && (R6.type = "line");
          var B3 = R6.label || (R6.label = {});
          if (B3.show == null && (B3.show = false), b6 === "cross") {
            var G3 = A2.get(["label", "show"]);
            if (B3.show = G3 != null ? G3 : true, !S2) {
              var Z3 = R6.lineStyle = A2.get("crossStyle");
              Z3 && Cl(B3, Z3.textStyle);
            }
          }
          return c5.model.getModel("axisPointer", new Ag2(R6, r5, g5));
        }
        function sBn(c5, s) {
          s.eachSeries(function(r5) {
            var g5 = r5.coordinateSystem, b6 = r5.get(["tooltip", "trigger"], true), S2 = r5.get(["tooltip", "show"], true);
            !g5 || b6 === "none" || b6 === false || b6 === "item" || S2 === false || r5.get(["axisPointer", "show"], true) === false || Ye2(c5.coordSysAxesInfo[Wct(g5.model)], function(A2) {
              var k2 = A2.axis;
              g5.getAxis(k2.dim) === k2 && (A2.seriesModels.push(r5), A2.seriesDataCount == null && (A2.seriesDataCount = 0), A2.seriesDataCount += r5.getData().count());
            });
          });
        }
        function lBn(c5, s) {
          for (var r5 = s.model, g5 = s.dim, b6 = 0; b6 < c5.length; b6++) {
            var S2 = c5[b6] || {};
            if (sHt(S2[g5 + "AxisId"], r5.id) || sHt(S2[g5 + "AxisIndex"], r5.componentIndex) || sHt(S2[g5 + "AxisName"], r5.name))
              return b6;
          }
        }
        function sHt(c5, s) {
          return c5 === "all" || ja2(c5) && Lu(c5, s) >= 0 || c5 === s;
        }
        function uBn(c5) {
          var s = lHt(c5);
          if (s) {
            var r5 = s.axisPointerModel, g5 = s.axis.scale, b6 = r5.option, S2 = r5.get("status"), A2 = r5.get("value");
            A2 != null && (A2 = g5.parse(A2));
            var k2 = uHt(r5);
            S2 == null && (b6.status = k2 ? "show" : "hide");
            var R6 = g5.getExtent().slice();
            R6[0] > R6[1] && R6.reverse(), (A2 == null || A2 > R6[1]) && (A2 = R6[1]), A2 < R6[0] && (A2 = R6[0]), b6.value = A2, k2 && (b6.status = s.axis.scale.isBlank() ? "hide" : "show");
          }
        }
        function lHt(c5) {
          var s = (c5.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
          return s && s.axesInfo[Wct(c5)];
        }
        function cBn(c5) {
          var s = lHt(c5);
          return s && s.axisPointerModel;
        }
        function uHt(c5) {
          return !!c5.get(["handle", "show"]);
        }
        function Wct(c5) {
          return c5.type + "||" + c5.id;
        }
        var zEe = {}, fBn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            this.axisPointerClass && uBn(r5), c5.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(r5, b6, true);
          }, s.prototype.updateAxisPointer = function(r5, g5, b6, S2) {
            this._doUpdateAxisPointerClass(r5, b6, false);
          }, s.prototype.remove = function(r5, g5) {
            var b6 = this._axisPointer;
            b6 && b6.remove(g5);
          }, s.prototype.dispose = function(r5, g5) {
            this._disposeAxisPointer(g5), c5.prototype.dispose.apply(this, arguments);
          }, s.prototype._doUpdateAxisPointerClass = function(r5, g5, b6) {
            var S2 = s.getAxisPointerClass(this.axisPointerClass);
            if (S2) {
              var A2 = cBn(r5);
              A2 ? (this._axisPointer || (this._axisPointer = new S2())).render(r5, A2, g5, b6) : this._disposeAxisPointer(g5);
            }
          }, s.prototype._disposeAxisPointer = function(r5) {
            this._axisPointer && this._axisPointer.dispose(r5), this._axisPointer = null;
          }, s.registerAxisPointerClass = function(r5, g5) {
            zEe[r5] = g5;
          }, s.getAxisPointerClass = function(r5) {
            return r5 && zEe[r5];
          }, s.type = "axis", s;
        }(P0), SW = fBn, cHt = Df2();
        function jEe(c5, s, r5, g5) {
          var b6 = r5.axis;
          if (!b6.scale.isBlank()) {
            var S2 = r5.getModel("splitArea"), A2 = S2.getModel("areaStyle"), k2 = A2.get("color"), R6 = g5.coordinateSystem.getRect(), B3 = b6.getTicksCoords({ tickModel: S2, clamp: true });
            if (B3.length) {
              var G3 = k2.length, Z3 = cHt(c5).splitAreaColors, X3 = Ps(), tt = 0;
              if (Z3)
                for (var it = 0; it < B3.length; it++) {
                  var pt = Z3.get(B3[it].tickValue);
                  if (pt != null) {
                    tt = (pt + (G3 - 1) * it) % G3;
                    break;
                  }
                }
              var mt = b6.toGlobalCoord(B3[0].coord), Mt = A2.getAreaStyle();
              k2 = ja2(k2) ? k2 : [k2];
              for (var it = 1; it < B3.length; it++) {
                var kt = b6.toGlobalCoord(B3[it].coord), Gt = void 0, Ot = void 0, ce2 = void 0, ae2 = void 0;
                b6.isHorizontal() ? (Gt = mt, Ot = R6.y, ce2 = kt - Gt, ae2 = R6.height, mt = Gt + ce2) : (Gt = R6.x, Ot = mt, ce2 = R6.width, ae2 = kt - Ot, mt = Ot + ae2);
                var de2 = B3[it - 1].tickValue;
                de2 != null && X3.set(de2, tt), s.add(new zf2({ anid: de2 != null ? "area_" + de2 : null, shape: { x: Gt, y: Ot, width: ce2, height: ae2 }, style: Cl({ fill: k2[tt] }, Mt), autoBatch: true, silent: true })), tt = (tt + 1) % G3;
              }
              cHt(c5).splitAreaColors = X3;
            }
          }
        }
        function WEe(c5) {
          cHt(c5).splitAreaColors = null;
        }
        var hBn = ["axisLine", "axisTickLabel", "axisName"], pBn = ["splitArea", "splitLine", "minorSplitLine"], GEe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.axisPointerClass = "CartesianAxisPointer", r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            this.group.removeAll();
            var A2 = this._axisGroup;
            if (this._axisGroup = new nu(), this.group.add(this._axisGroup), !!r5.get("show")) {
              var k2 = r5.getCoordSysModel(), R6 = iHt(k2, r5), B3 = new TR(r5, sa2({ handleAutoShown: function(Z3) {
                for (var X3 = k2.coordinateSystem.getCartesians(), tt = 0; tt < X3.length; tt++)
                  if (SGt(X3[tt].getOtherAxis(r5.axis).scale))
                    return true;
                return false;
              } }, R6));
              Ye2(hBn, B3.add, B3), this._axisGroup.add(B3.getGroup()), Ye2(pBn, function(Z3) {
                r5.get([Z3, "show"]) && dBn[Z3](this, this._axisGroup, r5, k2);
              }, this);
              var G3 = S2 && S2.type === "changeAxisOrder" && S2.isInitSort;
              G3 || of2(A2, this._axisGroup, r5), c5.prototype.render.call(this, r5, g5, b6, S2);
            }
          }, s.prototype.remove = function() {
            WEe(this);
          }, s.type = "cartesianAxis", s;
        }(SW), dBn = { splitLine: function(c5, s, r5, g5) {
          var b6 = r5.axis;
          if (!b6.scale.isBlank()) {
            var S2 = r5.getModel("splitLine"), A2 = S2.getModel("lineStyle"), k2 = A2.get("color");
            k2 = ja2(k2) ? k2 : [k2];
            for (var R6 = g5.coordinateSystem.getRect(), B3 = b6.isHorizontal(), G3 = 0, Z3 = b6.getTicksCoords({ tickModel: S2 }), X3 = [], tt = [], it = A2.getLineStyle(), pt = 0; pt < Z3.length; pt++) {
              var mt = b6.toGlobalCoord(Z3[pt].coord);
              B3 ? (X3[0] = mt, X3[1] = R6.y, tt[0] = mt, tt[1] = R6.y + R6.height) : (X3[0] = R6.x, X3[1] = mt, tt[0] = R6.x + R6.width, tt[1] = mt);
              var Mt = G3++ % k2.length, kt = Z3[pt].tickValue;
              s.add(new Zm({ anid: kt != null ? "line_" + Z3[pt].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: X3[0], y1: X3[1], x2: tt[0], y2: tt[1] }, style: Cl({ stroke: k2[Mt] }, it), silent: true }));
            }
          }
        }, minorSplitLine: function(c5, s, r5, g5) {
          var b6 = r5.axis, S2 = r5.getModel("minorSplitLine"), A2 = S2.getModel("lineStyle"), k2 = g5.coordinateSystem.getRect(), R6 = b6.isHorizontal(), B3 = b6.getMinorTicksCoords();
          if (B3.length)
            for (var G3 = [], Z3 = [], X3 = A2.getLineStyle(), tt = 0; tt < B3.length; tt++)
              for (var it = 0; it < B3[tt].length; it++) {
                var pt = b6.toGlobalCoord(B3[tt][it].coord);
                R6 ? (G3[0] = pt, G3[1] = k2.y, Z3[0] = pt, Z3[1] = k2.y + k2.height) : (G3[0] = k2.x, G3[1] = pt, Z3[0] = k2.x + k2.width, Z3[1] = pt), s.add(new Zm({ anid: "minor_line_" + B3[tt][it].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: G3[0], y1: G3[1], x2: Z3[0], y2: Z3[1] }, style: X3, silent: true }));
              }
        }, splitArea: function(c5, s, r5, g5) {
          jEe(c5, s, r5, g5);
        } }, HEe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "xAxis", s;
        }(GEe), gBn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = HEe.type, r5;
          }
          return s.type = "yAxis", s;
        }(GEe), vBn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "grid", r5;
          }
          return s.prototype.render = function(r5, g5) {
            this.group.removeAll(), r5.get("show") && this.group.add(new zf2({ shape: r5.coordinateSystem.getRect(), style: Cl({ fill: r5.get("backgroundColor") }, r5.getItemStyle()), silent: true, z2: -1 }));
          }, s.type = "grid", s;
        }(P0), UEe = { offset: 0 };
        function qEe(c5) {
          c5.registerComponentView(vBn), c5.registerComponentModel(BVn), c5.registerCoordinateSystem("cartesian2d", QVn), CX(c5, "x", eHt, UEe), CX(c5, "y", eHt, UEe), c5.registerComponentView(HEe), c5.registerComponentView(gBn), c5.registerPreprocessor(function(s) {
            s.xAxis && s.yAxis && !s.grid && (s.grid = {});
          });
        }
        function yBn(c5) {
          Fc2(qEe), c5.registerSeriesModel(kVn), c5.registerChartView(FVn), c5.registerLayout(Bct("scatter"));
        }
        function mBn(c5) {
          c5.eachSeriesByType("radar", function(s) {
            var r5 = s.getData(), g5 = [], b6 = s.coordinateSystem;
            if (b6) {
              var S2 = b6.getIndicatorAxes();
              Ye2(S2, function(A2, k2) {
                r5.each(r5.mapDimension(S2[k2].dim), function(R6, B3) {
                  g5[B3] = g5[B3] || [];
                  var G3 = b6.dataToPoint(R6, k2);
                  g5[B3][k2] = ZEe(G3) ? G3 : $Ee(b6);
                });
              }), r5.each(function(A2) {
                var k2 = ozt(g5[A2], function(R6) {
                  return ZEe(R6);
                }) || $Ee(b6);
                g5[A2].push(k2.slice()), r5.setItemLayout(A2, g5[A2]);
              });
            }
          });
        }
        function ZEe(c5) {
          return !isNaN(c5[0]) && !isNaN(c5[1]);
        }
        function $Ee(c5) {
          return [c5.cx, c5.cy];
        }
        function bBn(c5) {
          var s = c5.polar;
          if (s) {
            ja2(s) || (s = [s]);
            var r5 = [];
            Ye2(s, function(g5, b6) {
              g5.indicator ? (g5.type && !g5.shape && (g5.shape = g5.type), c5.radar = c5.radar || [], ja2(c5.radar) || (c5.radar = [c5.radar]), c5.radar.push(g5)) : r5.push(g5);
            }), c5.polar = r5;
          }
          Ye2(c5.series, function(g5) {
            g5 && g5.type === "radar" && g5.polarIndex && (g5.radarIndex = g5.polarIndex);
          });
        }
        var _Bn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.coordinateSystem, A2 = this.group, k2 = r5.getData(), R6 = this._data;
            function B3(X3, tt) {
              var it = X3.getItemVisual(tt, "symbol") || "circle";
              if (it !== "none") {
                var pt = vct(X3.getItemVisual(tt, "symbolSize")), mt = am(it, -1, -1, 2, 2), Mt = X3.getItemVisual(tt, "symbolRotate") || 0;
                return mt.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: pt[0] / 2, scaleY: pt[1] / 2, rotation: Mt * Math.PI / 180 || 0 }), mt;
              }
            }
            function G3(X3, tt, it, pt, mt, Mt) {
              it.removeAll();
              for (var kt = 0; kt < tt.length - 1; kt++) {
                var Gt = B3(pt, mt);
                Gt && (Gt.__dimIdx = kt, X3[kt] ? (Gt.setPosition(X3[kt]), Jut[Mt ? "initProps" : "updateProps"](Gt, { x: tt[kt][0], y: tt[kt][1] }, r5, mt)) : Gt.setPosition(tt[kt]), it.add(Gt));
              }
            }
            function Z3(X3) {
              return Ha2(X3, function(tt) {
                return [S2.cx, S2.cy];
              });
            }
            k2.diff(R6).add(function(X3) {
              var tt = k2.getItemLayout(X3);
              if (tt) {
                var it = new Gb2(), pt = new Gw(), mt = { shape: { points: tt } };
                it.shape.points = Z3(tt), pt.shape.points = Z3(tt), tv(it, mt, r5, X3), tv(pt, mt, r5, X3);
                var Mt = new nu(), kt = new nu();
                Mt.add(pt), Mt.add(it), Mt.add(kt), G3(pt.shape.points, tt, kt, k2, X3, true), k2.setItemGraphicEl(X3, Mt);
              }
            }).update(function(X3, tt) {
              var it = R6.getItemGraphicEl(tt), pt = it.childAt(0), mt = it.childAt(1), Mt = it.childAt(2), kt = { shape: { points: k2.getItemLayout(X3) } };
              !kt.shape.points || (G3(pt.shape.points, kt.shape.points, Mt, k2, X3, false), nT(mt), nT(pt), Qf2(pt, kt, r5), Qf2(mt, kt, r5), k2.setItemGraphicEl(X3, it));
            }).remove(function(X3) {
              A2.remove(R6.getItemGraphicEl(X3));
            }).execute(), k2.eachItemGraphicEl(function(X3, tt) {
              var it = k2.getItemModel(tt), pt = X3.childAt(0), mt = X3.childAt(1), Mt = X3.childAt(2), kt = k2.getItemVisual(tt, "style"), Gt = kt.fill;
              A2.add(X3), pt.useStyle(Cl(it.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: Gt })), z1(pt, it, "lineStyle"), z1(mt, it, "areaStyle");
              var Ot = it.getModel("areaStyle"), ce2 = Ot.isEmpty() && Ot.parentModel.isEmpty();
              mt.ignore = ce2, Ye2(["emphasis", "select", "blur"], function(we2) {
                var Se2 = it.getModel([we2, "areaStyle"]), Oe2 = Se2.isEmpty() && Se2.parentModel.isEmpty();
                mt.ensureState(we2).ignore = Oe2 && ce2;
              }), mt.useStyle(Cl(Ot.getAreaStyle(), { fill: Gt, opacity: 0.7, decal: kt.decal }));
              var ae2 = it.getModel("emphasis"), de2 = ae2.getModel("itemStyle").getItemStyle();
              Mt.eachChild(function(we2) {
                if (we2 instanceof qm) {
                  var Se2 = we2.style;
                  we2.useStyle(sa2({ image: Se2.image, x: Se2.x, y: Se2.y, width: Se2.width, height: Se2.height }, kt));
                } else
                  we2.useStyle(kt), we2.setColor(Gt), we2.style.strokeNoScale = true;
                var Oe2 = we2.ensureState("emphasis");
                Oe2.style = Ml(de2);
                var je2 = k2.getStore().get(k2.getDimensionIndex(we2.__dimIdx), tt);
                (je2 == null || isNaN(je2)) && (je2 = ""), Uw(we2, qb2(it), { labelFetcher: k2.hostModel, labelDataIndex: tt, labelDimIndex: we2.__dimIdx, defaultText: je2, inheritColor: Gt, defaultOpacity: kt.opacity });
              }), f0(X3, ae2.get("focus"), ae2.get("blurScope"), ae2.get("disabled"));
            }), this._data = k2;
          }, s.prototype.remove = function() {
            this.group.removeAll(), this._data = null;
          }, s.type = "radar", s;
        }(Ig2), xBn = _Bn, wBn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.hasSymbolVisual = true, r5;
          }
          return s.prototype.init = function(r5) {
            c5.prototype.init.apply(this, arguments), this.legendVisualProvider = new jct(Cs(this.getData, this), Cs(this.getRawData, this));
          }, s.prototype.getInitialData = function(r5, g5) {
            return MX(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            var S2 = this.getData(), A2 = this.coordinateSystem, k2 = A2.getIndicatorAxes(), R6 = this.getData().getName(r5), B3 = R6 === "" ? this.name : R6, G3 = oAe(this, r5);
            return W1("section", { header: B3, sortBlocks: true, blocks: Ha2(k2, function(Z3) {
              var X3 = S2.get(S2.mapDimension(Z3.dim), r5);
              return W1("nameValue", { markerType: "subItem", markerColor: G3, name: Z3.name, value: X3, sortParam: X3 });
            }) });
          }, s.prototype.getTooltipPosition = function(r5) {
            if (r5 != null) {
              for (var g5 = this.getData(), b6 = this.coordinateSystem, S2 = g5.getValues(Ha2(b6.dimensions, function(B3) {
                return g5.mapDimension(B3);
              }), r5), A2 = 0, k2 = S2.length; A2 < k2; A2++)
                if (!isNaN(S2[A2])) {
                  var R6 = b6.getIndicatorAxes();
                  return b6.coordToPoint(R6[A2].dataToCoord(S2[A2]), A2);
                }
            }
          }, s.type = "series.radar", s.dependencies = ["radar"], s.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, s;
        }(zv), SBn = wBn, Gct = IEe.value;
        function YMt(c5, s) {
          return Cl({ show: s }, c5);
        }
        var MBn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.optionUpdated = function() {
            var r5 = this.get("boundaryGap"), g5 = this.get("splitNumber"), b6 = this.get("scale"), S2 = this.get("axisLine"), A2 = this.get("axisTick"), k2 = this.get("axisLabel"), R6 = this.get("axisName"), B3 = this.get(["axisName", "show"]), G3 = this.get(["axisName", "formatter"]), Z3 = this.get("axisNameGap"), X3 = this.get("triggerEvent"), tt = Ha2(this.get("indicator") || [], function(it) {
              it.max != null && it.max > 0 && !it.min ? it.min = 0 : it.min != null && it.min < 0 && !it.max && (it.max = 0);
              var pt = R6;
              it.color != null && (pt = Cl({ color: it.color }, R6));
              var mt = bu(Ml(it), { boundaryGap: r5, splitNumber: g5, scale: b6, axisLine: S2, axisTick: A2, axisLabel: k2, name: it.text, showName: B3, nameLocation: "end", nameGap: Z3, nameTextStyle: pt, triggerEvent: X3 }, false);
              if (B3 || (mt.name = ""), gs(G3)) {
                var Mt = mt.name;
                mt.name = G3.replace("{value}", Mt != null ? Mt : "");
              } else
                Tl(G3) && (mt.name = G3(mt.name, mt));
              var kt = new Ag2(mt, null, this.ecModel);
              return A0(kt, Ect.prototype), kt.mainType = "radar", kt.componentIndex = this.componentIndex, kt;
            }, this);
            this._indicatorModels = tt;
          }, s.prototype.getIndicatorModels = function() {
            return this._indicatorModels;
          }, s.type = "radar", s.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: bu({ lineStyle: { color: "#bbb" } }, Gct.axisLine), axisLabel: YMt(Gct.axisLabel, false), axisTick: YMt(Gct.axisTick, false), splitLine: YMt(Gct.splitLine, true), splitArea: YMt(Gct.splitArea, true), indicator: [] }, s;
        }(Rh2), CBn = MBn, TBn = ["axisLine", "axisTickLabel", "axisName"], ABn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = this.group;
            S2.removeAll(), this._buildAxes(r5), this._buildSplitLineAndArea(r5);
          }, s.prototype._buildAxes = function(r5) {
            var g5 = r5.coordinateSystem, b6 = g5.getIndicatorAxes(), S2 = Ha2(b6, function(A2) {
              var k2 = A2.model.get("showName") ? A2.name : "", R6 = new TR(A2.model, { axisName: k2, position: [g5.cx, g5.cy], rotation: A2.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
              return R6;
            });
            Ye2(S2, function(A2) {
              Ye2(TBn, A2.add, A2), this.group.add(A2.getGroup());
            }, this);
          }, s.prototype._buildSplitLineAndArea = function(r5) {
            var g5 = r5.coordinateSystem, b6 = g5.getIndicatorAxes();
            if (!b6.length)
              return;
            var S2 = r5.get("shape"), A2 = r5.getModel("splitLine"), k2 = r5.getModel("splitArea"), R6 = A2.getModel("lineStyle"), B3 = k2.getModel("areaStyle"), G3 = A2.get("show"), Z3 = k2.get("show"), X3 = R6.get("color"), tt = B3.get("color"), it = ja2(X3) ? X3 : [X3], pt = ja2(tt) ? tt : [tt], mt = [], Mt = [];
            function kt(jn, _n, Jr) {
              var Qn = Jr % _n.length;
              return jn[Qn] = jn[Qn] || [], Qn;
            }
            if (S2 === "circle")
              for (var Gt = b6[0].getTicksCoords(), Ot = g5.cx, ce2 = g5.cy, ae2 = 0; ae2 < Gt.length; ae2++) {
                if (G3) {
                  var de2 = kt(mt, it, ae2);
                  mt[de2].push(new qI({ shape: { cx: Ot, cy: ce2, r: Gt[ae2].coord } }));
                }
                if (Z3 && ae2 < Gt.length - 1) {
                  var de2 = kt(Mt, pt, ae2);
                  Mt[de2].push(new ZK({ shape: { cx: Ot, cy: ce2, r0: Gt[ae2].coord, r: Gt[ae2 + 1].coord } }));
                }
              }
            else
              for (var we2, Se2 = Ha2(b6, function(_n, Jr) {
                var Qn = _n.getTicksCoords();
                return we2 = we2 == null ? Qn.length - 1 : Math.min(Qn.length - 1, we2), Ha2(Qn, function(rr) {
                  return g5.coordToPoint(rr.coord, Jr);
                });
              }), Oe2 = [], ae2 = 0; ae2 <= we2; ae2++) {
                for (var je2 = [], rn = 0; rn < b6.length; rn++)
                  je2.push(Se2[rn][ae2]);
                if (je2[0] && je2.push(je2[0].slice()), G3) {
                  var de2 = kt(mt, it, ae2);
                  mt[de2].push(new Gw({ shape: { points: je2 } }));
                }
                if (Z3 && Oe2) {
                  var de2 = kt(Mt, pt, ae2 - 1);
                  Mt[de2].push(new Gb2({ shape: { points: je2.concat(Oe2) } }));
                }
                Oe2 = je2.slice().reverse();
              }
            var qe2 = R6.getLineStyle(), An = B3.getAreaStyle();
            Ye2(Mt, function(jn, _n) {
              this.group.add(Wn(jn, { style: Cl({ stroke: "none", fill: pt[_n % pt.length] }, An), silent: true }));
            }, this), Ye2(mt, function(jn, _n) {
              this.group.add(Wn(jn, { style: Cl({ fill: "none", stroke: it[_n % it.length] }, qe2), silent: true }));
            }, this);
          }, s.type = "radar", s;
        }(P0), IBn = ABn, DBn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this, r5, g5, b6) || this;
            return S2.type = "value", S2.angle = 0, S2.name = "", S2;
          }
          return s;
        }(kk2), EBn = DBn, kBn = function() {
          function c5(s, r5, g5) {
            this.dimensions = [], this._model = s, this._indicatorAxes = Ha2(s.getIndicatorModels(), function(b6, S2) {
              var A2 = "indicator_" + S2, k2 = new EBn(A2, new n9());
              return k2.name = b6.get("name"), k2.model = b6, b6.axis = k2, this.dimensions.push(A2), k2;
            }, this), this.resize(s, g5);
          }
          return c5.prototype.getIndicatorAxes = function() {
            return this._indicatorAxes;
          }, c5.prototype.dataToPoint = function(s, r5) {
            var g5 = this._indicatorAxes[r5];
            return this.coordToPoint(g5.dataToCoord(s), r5);
          }, c5.prototype.coordToPoint = function(s, r5) {
            var g5 = this._indicatorAxes[r5], b6 = g5.angle, S2 = this.cx + s * Math.cos(b6), A2 = this.cy - s * Math.sin(b6);
            return [S2, A2];
          }, c5.prototype.pointToData = function(s) {
            var r5 = s[0] - this.cx, g5 = s[1] - this.cy, b6 = Math.sqrt(r5 * r5 + g5 * g5);
            r5 /= b6, g5 /= b6;
            for (var S2 = Math.atan2(-g5, r5), A2 = 1 / 0, k2, R6 = -1, B3 = 0; B3 < this._indicatorAxes.length; B3++) {
              var G3 = this._indicatorAxes[B3], Z3 = Math.abs(S2 - G3.angle);
              Z3 < A2 && (k2 = G3, R6 = B3, A2 = Z3);
            }
            return [R6, +(k2 && k2.coordToData(b6))];
          }, c5.prototype.resize = function(s, r5) {
            var g5 = s.get("center"), b6 = r5.getWidth(), S2 = r5.getHeight(), A2 = Math.min(b6, S2) / 2;
            this.cx = $o(g5[0], b6), this.cy = $o(g5[1], S2), this.startAngle = s.get("startAngle") * Math.PI / 180;
            var k2 = s.get("radius");
            (gs(k2) || Oh2(k2)) && (k2 = [0, k2]), this.r0 = $o(k2[0], A2), this.r = $o(k2[1], A2), Ye2(this._indicatorAxes, function(R6, B3) {
              R6.setExtent(this.r0, this.r);
              var G3 = this.startAngle + B3 * Math.PI * 2 / this._indicatorAxes.length;
              G3 = Math.atan2(Math.sin(G3), Math.cos(G3)), R6.angle = G3;
            }, this);
          }, c5.prototype.update = function(s, r5) {
            var g5 = this._indicatorAxes, b6 = this._model;
            Ye2(g5, function(k2) {
              k2.scale.setExtent(1 / 0, -1 / 0);
            }), s.eachSeriesByType("radar", function(k2, R6) {
              if (!(k2.get("coordinateSystem") !== "radar" || s.getComponent("radar", k2.get("radarIndex")) !== b6)) {
                var B3 = k2.getData();
                Ye2(g5, function(G3) {
                  G3.scale.unionExtentFromData(B3, B3.mapDimension(G3.dim));
                });
              }
            }, this);
            var S2 = b6.get("splitNumber"), A2 = new n9();
            A2.setExtent(0, S2), A2.setInterval(1), Ye2(g5, function(k2, R6) {
              LEe(k2.scale, k2.model, A2);
            });
          }, c5.prototype.convertToPixel = function(s, r5, g5) {
            return console.warn("Not implemented."), null;
          }, c5.prototype.convertFromPixel = function(s, r5, g5) {
            return console.warn("Not implemented."), null;
          }, c5.prototype.containPoint = function(s) {
            return console.warn("Not implemented."), false;
          }, c5.create = function(s, r5) {
            var g5 = [];
            return s.eachComponent("radar", function(b6) {
              var S2 = new c5(b6, s, r5);
              g5.push(S2), b6.coordinateSystem = S2;
            }), s.eachSeriesByType("radar", function(b6) {
              b6.get("coordinateSystem") === "radar" && (b6.coordinateSystem = g5[b6.get("radarIndex") || 0]);
            }), g5;
          }, c5.dimensions = [], c5;
        }(), PBn = kBn;
        function LBn(c5) {
          c5.registerCoordinateSystem("radar", PBn), c5.registerComponentModel(CBn), c5.registerComponentView(IBn), c5.registerVisual({ seriesType: "radar", reset: function(s) {
            var r5 = s.getData();
            r5.each(function(g5) {
              r5.setItemVisual(g5, "legendIcon", "roundRect");
            }), r5.setVisual("legendIcon", "roundRect");
          } });
        }
        function OBn(c5) {
          Fc2(LBn), c5.registerChartView(xBn), c5.registerSeriesModel(SBn), c5.registerLayout(mBn), c5.registerProcessor(zct("radar")), c5.registerPreprocessor(bBn);
        }
        var YEe = "\0_ec_interaction_mutex";
        function RBn(c5, s, r5) {
          var g5 = fHt(c5);
          g5[s] = r5;
        }
        function NBn(c5, s, r5) {
          var g5 = fHt(c5), b6 = g5[s];
          b6 === r5 && (g5[s] = null);
        }
        function KEe(c5, s) {
          return !!fHt(c5)[s];
        }
        function fHt(c5) {
          return c5[YEe] || (c5[YEe] = {});
        }
        E3({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, I0);
        var FBn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this) || this;
            g5._zr = r5;
            var b6 = Cs(g5._mousedownHandler, g5), S2 = Cs(g5._mousemoveHandler, g5), A2 = Cs(g5._mouseupHandler, g5), k2 = Cs(g5._mousewheelHandler, g5), R6 = Cs(g5._pinchHandler, g5);
            return g5.enable = function(B3, G3) {
              this.disable(), this._opt = Cl(Ml(G3) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), B3 == null && (B3 = true), (B3 === true || B3 === "move" || B3 === "pan") && (r5.on("mousedown", b6), r5.on("mousemove", S2), r5.on("mouseup", A2)), (B3 === true || B3 === "scale" || B3 === "zoom") && (r5.on("mousewheel", k2), r5.on("pinch", R6));
            }, g5.disable = function() {
              r5.off("mousedown", b6), r5.off("mousemove", S2), r5.off("mouseup", A2), r5.off("mousewheel", k2), r5.off("pinch", R6);
            }, g5;
          }
          return s.prototype.isDragging = function() {
            return this._dragging;
          }, s.prototype.isPinching = function() {
            return this._pinching;
          }, s.prototype.setPointerChecker = function(r5) {
            this.pointerChecker = r5;
          }, s.prototype.dispose = function() {
            this.disable();
          }, s.prototype._mousedownHandler = function(r5) {
            if (!(dk2(r5) || r5.target && r5.target.draggable)) {
              var g5 = r5.offsetX, b6 = r5.offsetY;
              this.pointerChecker && this.pointerChecker(r5, g5, b6) && (this._x = g5, this._y = b6, this._dragging = true);
            }
          }, s.prototype._mousemoveHandler = function(r5) {
            if (!(!this._dragging || !KMt("moveOnMouseMove", r5, this._opt) || r5.gestureEvent === "pinch" || KEe(this._zr, "globalPan"))) {
              var g5 = r5.offsetX, b6 = r5.offsetY, S2 = this._x, A2 = this._y, k2 = g5 - S2, R6 = b6 - A2;
              this._x = g5, this._y = b6, this._opt.preventDefaultMouseMove && OI(r5.event), XEe(this, "pan", "moveOnMouseMove", r5, { dx: k2, dy: R6, oldX: S2, oldY: A2, newX: g5, newY: b6, isAvailableBehavior: null });
            }
          }, s.prototype._mouseupHandler = function(r5) {
            dk2(r5) || (this._dragging = false);
          }, s.prototype._mousewheelHandler = function(r5) {
            var g5 = KMt("zoomOnMouseWheel", r5, this._opt), b6 = KMt("moveOnMouseWheel", r5, this._opt), S2 = r5.wheelDelta, A2 = Math.abs(S2), k2 = r5.offsetX, R6 = r5.offsetY;
            if (!(S2 === 0 || !g5 && !b6)) {
              if (g5) {
                var B3 = A2 > 3 ? 1.4 : A2 > 1 ? 1.2 : 1.1, G3 = S2 > 0 ? B3 : 1 / B3;
                hHt(this, "zoom", "zoomOnMouseWheel", r5, { scale: G3, originX: k2, originY: R6, isAvailableBehavior: null });
              }
              if (b6) {
                var Z3 = Math.abs(S2), X3 = (S2 > 0 ? 1 : -1) * (Z3 > 3 ? 0.4 : Z3 > 1 ? 0.15 : 0.05);
                hHt(this, "scrollMove", "moveOnMouseWheel", r5, { scrollDelta: X3, originX: k2, originY: R6, isAvailableBehavior: null });
              }
            }
          }, s.prototype._pinchHandler = function(r5) {
            if (!KEe(this._zr, "globalPan")) {
              var g5 = r5.pinchScale > 1 ? 1.1 : 0.9090909090909091;
              hHt(this, "zoom", null, r5, { scale: g5, originX: r5.pinchX, originY: r5.pinchY, isAvailableBehavior: null });
            }
          }, s;
        }(Lw);
        function hHt(c5, s, r5, g5, b6) {
          c5.pointerChecker && c5.pointerChecker(g5, b6.originX, b6.originY) && (OI(g5.event), XEe(c5, s, r5, g5, b6));
        }
        function XEe(c5, s, r5, g5, b6) {
          b6.isAvailableBehavior = Cs(KMt, null, r5, g5), c5.trigger(s, b6);
        }
        function KMt(c5, s, r5) {
          var g5 = r5[c5];
          return !c5 || g5 && (!gs(g5) || s.event[g5 + "Key"]);
        }
        var Hct = FBn;
        function pHt(c5, s, r5) {
          var g5 = c5.target;
          g5.x += s, g5.y += r5, g5.dirty();
        }
        function dHt(c5, s, r5, g5) {
          var b6 = c5.target, S2 = c5.zoomLimit, A2 = c5.zoom = c5.zoom || 1;
          if (A2 *= s, S2) {
            var k2 = S2.min || 0, R6 = S2.max || 1 / 0;
            A2 = Math.max(Math.min(R6, A2), k2);
          }
          var B3 = A2 / c5.zoom;
          c5.zoom = A2, b6.x -= (r5 - b6.x) * (B3 - 1), b6.y -= (g5 - b6.y) * (B3 - 1), b6.scaleX *= B3, b6.scaleY *= B3, b6.dirty();
        }
        var VBn = { axisPointer: 1, tooltip: 1, brush: 1 };
        function XMt(c5, s, r5) {
          var g5 = s.getComponentByElement(c5.topTarget), b6 = g5 && g5.coordinateSystem;
          return g5 && g5 !== r5 && !VBn.hasOwnProperty(g5.mainType) && b6 && b6.model !== r5;
        }
        function QEe(c5) {
          if (gs(c5)) {
            var s = new DOMParser();
            c5 = s.parseFromString(c5, "text/xml");
          }
          var r5 = c5;
          for (r5.nodeType === 9 && (r5 = r5.firstChild); r5.nodeName.toLowerCase() !== "svg" || r5.nodeType !== 1; )
            r5 = r5.nextSibling;
          return r5;
        }
        var gHt, QMt = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, JEe = nf2(QMt), JMt = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, tke = nf2(JMt), BBn = function() {
          function c5() {
            this._defs = {}, this._root = null;
          }
          return c5.prototype.parse = function(s, r5) {
            r5 = r5 || {};
            var g5 = QEe(s);
            this._defsUsePending = [];
            var b6 = new nu();
            this._root = b6;
            var S2 = [], A2 = g5.getAttribute("viewBox") || "", k2 = parseFloat(g5.getAttribute("width") || r5.width), R6 = parseFloat(g5.getAttribute("height") || r5.height);
            isNaN(k2) && (k2 = null), isNaN(R6) && (R6 = null), aT(g5, b6, null, true, false);
            for (var B3 = g5.firstChild; B3; )
              this._parseNode(B3, b6, S2, null, false, false), B3 = B3.nextSibling;
            WBn(this._defs, this._defsUsePending), this._defsUsePending = [];
            var G3, Z3;
            if (A2) {
              var X3 = tCt(A2);
              X3.length >= 4 && (G3 = { x: parseFloat(X3[0] || 0), y: parseFloat(X3[1] || 0), width: parseFloat(X3[2]), height: parseFloat(X3[3]) });
            }
            if (G3 && k2 != null && R6 != null && (Z3 = lke(G3, { x: 0, y: 0, width: k2, height: R6 }), !r5.ignoreViewBox)) {
              var tt = b6;
              b6 = new nu(), b6.add(tt), tt.scaleX = tt.scaleY = Z3.scale, tt.x = Z3.x, tt.y = Z3.y;
            }
            return !r5.ignoreRootClip && k2 != null && R6 != null && b6.setClipPath(new zf2({ shape: { x: 0, y: 0, width: k2, height: R6 } })), { root: b6, width: k2, height: R6, viewBoxRect: G3, viewBoxTransform: Z3, named: S2 };
          }, c5.prototype._parseNode = function(s, r5, g5, b6, S2, A2) {
            var k2 = s.nodeName.toLowerCase(), R6, B3 = b6;
            if (k2 === "defs" && (S2 = true), k2 === "text" && (A2 = true), k2 === "defs" || k2 === "switch")
              R6 = r5;
            else {
              if (!S2) {
                var G3 = gHt[k2];
                if (G3 && Ls(gHt, k2)) {
                  R6 = G3.call(this, s, r5);
                  var Z3 = s.getAttribute("name");
                  if (Z3) {
                    var X3 = { name: Z3, namedFrom: null, svgNodeTagLower: k2, el: R6 };
                    g5.push(X3), k2 === "g" && (B3 = X3);
                  } else
                    b6 && g5.push({ name: b6.name, namedFrom: b6, svgNodeTagLower: k2, el: R6 });
                  r5.add(R6);
                }
              }
              var tt = eke[k2];
              if (tt && Ls(eke, k2)) {
                var it = tt.call(this, s), pt = s.getAttribute("id");
                pt && (this._defs[pt] = it);
              }
            }
            if (R6 && R6.isGroup)
              for (var mt = s.firstChild; mt; )
                mt.nodeType === 1 ? this._parseNode(mt, R6, g5, B3, S2, A2) : mt.nodeType === 3 && A2 && this._parseText(mt, R6), mt = mt.nextSibling;
          }, c5.prototype._parseText = function(s, r5) {
            var g5 = new qj2({ style: { text: s.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
            nD(r5, g5), aT(s, g5, this._defsUsePending, false, false), zBn(g5, r5);
            var b6 = g5.style, S2 = b6.fontSize;
            S2 && S2 < 9 && (b6.fontSize = 9, g5.scaleX *= S2 / 9, g5.scaleY *= S2 / 9);
            var A2 = (b6.fontSize || b6.fontFamily) && [b6.fontStyle, b6.fontWeight, (b6.fontSize || 12) + "px", b6.fontFamily || "sans-serif"].join(" ");
            b6.font = A2;
            var k2 = g5.getBoundingRect();
            return this._textX += k2.width, r5.add(g5), g5;
          }, c5.internalField = function() {
            gHt = { g: function(s, r5) {
              var g5 = new nu();
              return nD(r5, g5), aT(s, g5, this._defsUsePending, false, false), g5;
            }, rect: function(s, r5) {
              var g5 = new zf2();
              return nD(r5, g5), aT(s, g5, this._defsUsePending, false, false), g5.setShape({ x: parseFloat(s.getAttribute("x") || "0"), y: parseFloat(s.getAttribute("y") || "0"), width: parseFloat(s.getAttribute("width") || "0"), height: parseFloat(s.getAttribute("height") || "0") }), g5.silent = true, g5;
            }, circle: function(s, r5) {
              var g5 = new qI();
              return nD(r5, g5), aT(s, g5, this._defsUsePending, false, false), g5.setShape({ cx: parseFloat(s.getAttribute("cx") || "0"), cy: parseFloat(s.getAttribute("cy") || "0"), r: parseFloat(s.getAttribute("r") || "0") }), g5.silent = true, g5;
            }, line: function(s, r5) {
              var g5 = new Zm();
              return nD(r5, g5), aT(s, g5, this._defsUsePending, false, false), g5.setShape({ x1: parseFloat(s.getAttribute("x1") || "0"), y1: parseFloat(s.getAttribute("y1") || "0"), x2: parseFloat(s.getAttribute("x2") || "0"), y2: parseFloat(s.getAttribute("y2") || "0") }), g5.silent = true, g5;
            }, ellipse: function(s, r5) {
              var g5 = new UK();
              return nD(r5, g5), aT(s, g5, this._defsUsePending, false, false), g5.setShape({ cx: parseFloat(s.getAttribute("cx") || "0"), cy: parseFloat(s.getAttribute("cy") || "0"), rx: parseFloat(s.getAttribute("rx") || "0"), ry: parseFloat(s.getAttribute("ry") || "0") }), g5.silent = true, g5;
            }, polygon: function(s, r5) {
              var g5 = s.getAttribute("points"), b6;
              g5 && (b6 = ike(g5));
              var S2 = new Gb2({ shape: { points: b6 || [] }, silent: true });
              return nD(r5, S2), aT(s, S2, this._defsUsePending, false, false), S2;
            }, polyline: function(s, r5) {
              var g5 = s.getAttribute("points"), b6;
              g5 && (b6 = ike(g5));
              var S2 = new Gw({ shape: { points: b6 || [] }, silent: true });
              return nD(r5, S2), aT(s, S2, this._defsUsePending, false, false), S2;
            }, image: function(s, r5) {
              var g5 = new qm();
              return nD(r5, g5), aT(s, g5, this._defsUsePending, false, false), g5.setStyle({ image: s.getAttribute("xlink:href") || s.getAttribute("href"), x: +s.getAttribute("x"), y: +s.getAttribute("y"), width: +s.getAttribute("width"), height: +s.getAttribute("height") }), g5.silent = true, g5;
            }, text: function(s, r5) {
              var g5 = s.getAttribute("x") || "0", b6 = s.getAttribute("y") || "0", S2 = s.getAttribute("dx") || "0", A2 = s.getAttribute("dy") || "0";
              this._textX = parseFloat(g5) + parseFloat(S2), this._textY = parseFloat(b6) + parseFloat(A2);
              var k2 = new nu();
              return nD(r5, k2), aT(s, k2, this._defsUsePending, false, true), k2;
            }, tspan: function(s, r5) {
              var g5 = s.getAttribute("x"), b6 = s.getAttribute("y");
              g5 != null && (this._textX = parseFloat(g5)), b6 != null && (this._textY = parseFloat(b6));
              var S2 = s.getAttribute("dx") || "0", A2 = s.getAttribute("dy") || "0", k2 = new nu();
              return nD(r5, k2), aT(s, k2, this._defsUsePending, false, true), this._textX += parseFloat(S2), this._textY += parseFloat(A2), k2;
            }, path: function(s, r5) {
              var g5 = s.getAttribute("d") || "", b6 = E2t(g5);
              return nD(r5, b6), aT(s, b6, this._defsUsePending, false, false), b6.silent = true, b6;
            } };
          }(), c5;
        }(), eke = { lineargradient: function(c5) {
          var s = parseInt(c5.getAttribute("x1") || "0", 10), r5 = parseInt(c5.getAttribute("y1") || "0", 10), g5 = parseInt(c5.getAttribute("x2") || "10", 10), b6 = parseInt(c5.getAttribute("y2") || "0", 10), S2 = new nW(s, r5, g5, b6);
          return nke(c5, S2), rke(c5, S2), S2;
        }, radialgradient: function(c5) {
          var s = parseInt(c5.getAttribute("cx") || "0", 10), r5 = parseInt(c5.getAttribute("cy") || "0", 10), g5 = parseInt(c5.getAttribute("r") || "0", 10), b6 = new Yut(s, r5, g5);
          return nke(c5, b6), rke(c5, b6), b6;
        } };
        function nke(c5, s) {
          var r5 = c5.getAttribute("gradientUnits");
          r5 === "userSpaceOnUse" && (s.global = true);
        }
        function rke(c5, s) {
          for (var r5 = c5.firstChild; r5; ) {
            if (r5.nodeType === 1 && r5.nodeName.toLocaleLowerCase() === "stop") {
              var g5 = r5.getAttribute("offset"), b6 = void 0;
              g5 && g5.indexOf("%") > 0 ? b6 = parseInt(g5, 10) / 100 : g5 ? b6 = parseFloat(g5) : b6 = 0;
              var S2 = {};
              ske(r5, S2, S2);
              var A2 = S2.stopColor || r5.getAttribute("stop-color") || "#000000";
              s.colorStops.push({ offset: b6, color: A2 });
            }
            r5 = r5.nextSibling;
          }
        }
        function nD(c5, s) {
          c5 && c5.__inheritedStyle && (s.__inheritedStyle || (s.__inheritedStyle = {}), Cl(s.__inheritedStyle, c5.__inheritedStyle));
        }
        function ike(c5) {
          for (var s = tCt(c5), r5 = [], g5 = 0; g5 < s.length; g5 += 2) {
            var b6 = parseFloat(s[g5]), S2 = parseFloat(s[g5 + 1]);
            r5.push([b6, S2]);
          }
          return r5;
        }
        function aT(c5, s, r5, g5, b6) {
          var S2 = s, A2 = S2.__inheritedStyle = S2.__inheritedStyle || {}, k2 = {};
          c5.nodeType === 1 && (UBn(c5, s), ske(c5, A2, k2), g5 || qBn(c5, A2, k2)), S2.style = S2.style || {}, A2.fill != null && (S2.style.fill = ake(S2, "fill", A2.fill, r5)), A2.stroke != null && (S2.style.stroke = ake(S2, "stroke", A2.stroke, r5)), Ye2(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(R6) {
            A2[R6] != null && (S2.style[R6] = parseFloat(A2[R6]));
          }), Ye2(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(R6) {
            A2[R6] != null && (S2.style[R6] = A2[R6]);
          }), b6 && (S2.__selfStyle = k2), A2.lineDash && (S2.style.lineDash = Ha2(tCt(A2.lineDash), function(R6) {
            return parseFloat(R6);
          })), (A2.visibility === "hidden" || A2.visibility === "collapse") && (S2.invisible = true), A2.display === "none" && (S2.ignore = true);
        }
        function zBn(c5, s) {
          var r5 = s.__selfStyle;
          if (r5) {
            var g5 = r5.textBaseline, b6 = g5;
            !g5 || g5 === "auto" || g5 === "baseline" ? b6 = "alphabetic" : g5 === "before-edge" || g5 === "text-before-edge" ? b6 = "top" : g5 === "after-edge" || g5 === "text-after-edge" ? b6 = "bottom" : (g5 === "central" || g5 === "mathematical") && (b6 = "middle"), c5.style.textBaseline = b6;
          }
          var S2 = s.__inheritedStyle;
          if (S2) {
            var A2 = S2.textAlign, k2 = A2;
            A2 && (A2 === "middle" && (k2 = "center"), c5.style.textAlign = k2);
          }
        }
        var jBn = /^url\(\s*#(.*?)\)/;
        function ake(c5, s, r5, g5) {
          var b6 = r5 && r5.match(jBn);
          if (b6) {
            var S2 = Tg2(b6[1]);
            g5.push([c5, s, S2]);
            return;
          }
          return r5 === "none" && (r5 = null), r5;
        }
        function WBn(c5, s) {
          for (var r5 = 0; r5 < s.length; r5++) {
            var g5 = s[r5];
            g5[0].style[g5[1]] = c5[g5[2]];
          }
        }
        var GBn = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
        function tCt(c5) {
          return c5.match(GBn) || [];
        }
        var HBn = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, vHt = Math.PI / 180;
        function UBn(c5, s) {
          var r5 = c5.getAttribute("transform");
          if (r5) {
            r5 = r5.replace(/,/g, " ");
            var g5 = [], b6 = null;
            r5.replace(HBn, function(Z3, X3, tt) {
              return g5.push(X3, tt), "";
            });
            for (var S2 = g5.length - 1; S2 > 0; S2 -= 2) {
              var A2 = g5[S2], k2 = g5[S2 - 1], R6 = tCt(A2);
              switch (b6 = b6 || bM(), k2) {
                case "translate":
                  _M(b6, b6, [parseFloat(R6[0]), parseFloat(R6[1] || "0")]);
                  break;
                case "scale":
                  fK(b6, b6, [parseFloat(R6[0]), parseFloat(R6[1] || R6[0])]);
                  break;
                case "rotate":
                  f3(b6, b6, -parseFloat(R6[0]) * vHt);
                  break;
                case "skewX":
                  var B3 = Math.tan(parseFloat(R6[0]) * vHt);
                  _k(b6, [1, 0, B3, 1, 0, 0], b6);
                  break;
                case "skewY":
                  var G3 = Math.tan(parseFloat(R6[0]) * vHt);
                  _k(b6, [1, G3, 0, 1, 0, 0], b6);
                  break;
                case "matrix":
                  b6[0] = parseFloat(R6[0]), b6[1] = parseFloat(R6[1]), b6[2] = parseFloat(R6[2]), b6[3] = parseFloat(R6[3]), b6[4] = parseFloat(R6[4]), b6[5] = parseFloat(R6[5]);
                  break;
              }
            }
            s.setLocalTransform(b6);
          }
        }
        var oke = /([^\s:;]+)\s*:\s*([^:;]+)/g;
        function ske(c5, s, r5) {
          var g5 = c5.getAttribute("style");
          if (g5) {
            oke.lastIndex = 0;
            for (var b6; (b6 = oke.exec(g5)) != null; ) {
              var S2 = b6[1], A2 = Ls(QMt, S2) ? QMt[S2] : null;
              A2 && (s[A2] = b6[2]);
              var k2 = Ls(JMt, S2) ? JMt[S2] : null;
              k2 && (r5[k2] = b6[2]);
            }
          }
        }
        function qBn(c5, s, r5) {
          for (var g5 = 0; g5 < JEe.length; g5++) {
            var b6 = JEe[g5], S2 = c5.getAttribute(b6);
            S2 != null && (s[QMt[b6]] = S2);
          }
          for (var g5 = 0; g5 < tke.length; g5++) {
            var b6 = tke[g5], S2 = c5.getAttribute(b6);
            S2 != null && (r5[JMt[b6]] = S2);
          }
        }
        function lke(c5, s) {
          var r5 = s.width / c5.width, g5 = s.height / c5.height, b6 = Math.min(r5, g5);
          return { scale: b6, x: -(c5.x + c5.width / 2) * b6 + (s.x + s.width / 2), y: -(c5.y + c5.height / 2) * b6 + (s.y + s.height / 2) };
        }
        function ZBn(c5, s) {
          var r5 = new BBn();
          return r5.parse(c5, s);
        }
        var $Bn = Ps(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), YBn = function() {
          function c5(s, r5) {
            this.type = "geoSVG", this._usedGraphicMap = Ps(), this._freedGraphics = [], this._mapName = s, this._parsedXML = QEe(r5);
          }
          return c5.prototype.load = function() {
            var s = this._firstGraphic;
            if (!s) {
              s = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(s), this._boundingRect = this._firstGraphic.boundingRect.clone();
              var r5 = XBn(s.named), g5 = r5.regions, b6 = r5.regionsMap;
              this._regions = g5, this._regionsMap = b6;
            }
            return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
          }, c5.prototype._buildGraphic = function(s) {
            var r5, g5;
            try {
              r5 = s && ZBn(s, { ignoreViewBox: true, ignoreRootClip: true }) || {}, g5 = r5.root, lx(g5 != null);
            } catch (mt) {
              throw new Error(`Invalid svg format
` + mt.message);
            }
            var b6 = new nu();
            b6.add(g5), b6.isGeoSVGGraphicRoot = true;
            var S2 = r5.width, A2 = r5.height, k2 = r5.viewBoxRect, R6 = this._boundingRect;
            if (!R6) {
              var B3 = void 0, G3 = void 0, Z3 = void 0, X3 = void 0;
              if (S2 != null ? (B3 = 0, Z3 = S2) : k2 && (B3 = k2.x, Z3 = k2.width), A2 != null ? (G3 = 0, X3 = A2) : k2 && (G3 = k2.y, X3 = k2.height), B3 == null || G3 == null) {
                var tt = g5.getBoundingRect();
                B3 == null && (B3 = tt.x, Z3 = tt.width), G3 == null && (G3 = tt.y, X3 = tt.height);
              }
              R6 = this._boundingRect = new lc2(B3, G3, Z3, X3);
            }
            if (k2) {
              var it = lke(k2, R6);
              g5.scaleX = g5.scaleY = it.scale, g5.x = it.x, g5.y = it.y;
            }
            b6.setClipPath(new zf2({ shape: R6.plain() }));
            var pt = [];
            return Ye2(r5.named, function(mt) {
              $Bn.get(mt.svgNodeTagLower) != null && (pt.push(mt), KBn(mt.el));
            }), { root: b6, boundingRect: R6, named: pt };
          }, c5.prototype.useGraphic = function(s) {
            var r5 = this._usedGraphicMap, g5 = r5.get(s);
            return g5 || (g5 = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), r5.set(s, g5), g5);
          }, c5.prototype.freeGraphic = function(s) {
            var r5 = this._usedGraphicMap, g5 = r5.get(s);
            g5 && (r5.removeKey(s), this._freedGraphics.push(g5));
          }, c5;
        }();
        function KBn(c5) {
          c5.silent = false, c5.isGroup && c5.traverse(function(s) {
            s.silent = false;
          });
        }
        function XBn(c5) {
          var s = [], r5 = Ps();
          return Ye2(c5, function(g5) {
            if (g5.namedFrom == null) {
              var b6 = new g9n(g5.name, g5.el);
              s.push(b6), r5.set(g5.name, b6);
            }
          }), { regions: s, regionsMap: r5 };
        }
        for (var yHt = [126, 25], uke = "\u5357\u6D77\u8BF8\u5C9B", MW = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]], CW = 0; CW < MW.length; CW++)
          for (var TX = 0; TX < MW[CW].length; TX++)
            MW[CW][TX][0] /= 10.5, MW[CW][TX][1] /= -10.5 / 0.75, MW[CW][TX][0] += yHt[0], MW[CW][TX][1] += yHt[1];
        function QBn(c5, s) {
          if (c5 === "china") {
            for (var r5 = 0; r5 < s.length; r5++)
              if (s[r5].name === uke)
                return;
            s.push(new nDe(uke, Ha2(MW, function(g5) {
              return { type: "polygon", exterior: g5 };
            }), yHt));
          }
        }
        var JBn = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
        function tzn(c5, s) {
          if (c5 === "china") {
            var r5 = JBn[s.name];
            if (r5) {
              var g5 = s.getCenter();
              g5[0] += r5[0] / 10.5, g5[1] += -r5[1] / (10.5 / 0.75), s.setCenter(g5);
            }
          }
        }
        var ezn = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
        function nzn(c5, s) {
          c5 === "china" && s.name === "\u53F0\u6E7E" && s.geometries.push({ type: "polygon", exterior: ezn[0] });
        }
        var rzn = "name", izn = function() {
          function c5(s, r5, g5) {
            this.type = "geoJSON", this._parsedMap = Ps(), this._mapName = s, this._specialAreas = g5, this._geoJSON = ozn(r5);
          }
          return c5.prototype.load = function(s, r5) {
            r5 = r5 || rzn;
            var g5 = this._parsedMap.get(r5);
            if (!g5) {
              var b6 = this._parseToRegions(r5);
              g5 = this._parsedMap.set(r5, { regions: b6, boundingRect: azn(b6) });
            }
            var S2 = Ps(), A2 = [];
            return Ye2(g5.regions, function(k2) {
              var R6 = k2.name;
              s && Ls(s, R6) && (k2 = k2.cloneShallow(R6 = s[R6])), A2.push(k2), S2.set(R6, k2);
            }), { regions: A2, boundingRect: g5.boundingRect || new lc2(0, 0, 0, 0), regionsMap: S2 };
          }, c5.prototype._parseToRegions = function(s) {
            var r5 = this._mapName, g5 = this._geoJSON, b6;
            try {
              b6 = g5 ? y9n(g5, s) : [];
            } catch (S2) {
              throw new Error(`Invalid geoJson format
` + S2.message);
            }
            return QBn(r5, b6), Ye2(b6, function(S2) {
              var A2 = S2.name;
              tzn(r5, S2), nzn(r5, S2);
              var k2 = this._specialAreas && this._specialAreas[A2];
              k2 && S2.transformTo(k2.left, k2.top, k2.width, k2.height);
            }, this), b6;
          }, c5.prototype.getMapForUser = function() {
            return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
          }, c5;
        }();
        function azn(c5) {
          for (var s, r5 = 0; r5 < c5.length; r5++) {
            var g5 = c5[r5].getBoundingRect();
            s = s || g5.clone(), s.union(g5);
          }
          return s;
        }
        function ozn(c5) {
          return gs(c5) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(c5) : new Function("return (" + c5 + ");")() : c5;
        }
        var Uct = Ps(), AR = { registerMap: function(c5, s, r5) {
          if (s.svg) {
            var g5 = new YBn(c5, s.svg);
            Uct.set(c5, g5);
          } else {
            var b6 = s.geoJson || s.geoJSON;
            b6 && !s.features ? r5 = s.specialAreas : b6 = s;
            var g5 = new izn(c5, b6, r5);
            Uct.set(c5, g5);
          }
        }, getGeoResource: function(c5) {
          return Uct.get(c5);
        }, getMapForUser: function(c5) {
          var s = Uct.get(c5);
          return s && s.type === "geoJSON" && s.getMapForUser();
        }, load: function(c5, s, r5) {
          var g5 = Uct.get(c5);
          if (g5)
            return g5.load(s, r5);
        } }, mHt = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], szn = Ps(mHt), lzn = Ps(mHt.concat(["g"])), uzn = Ps(mHt.concat(["g"])), cke = Df2();
        function eCt(c5) {
          var s = c5.getItemStyle(), r5 = c5.get("areaColor");
          return r5 != null && (s.fill = r5), s;
        }
        function fke(c5) {
          var s = c5.style;
          s && (s.stroke = s.stroke || s.fill, s.fill = null);
        }
        var czn = function() {
          function c5(s) {
            var r5 = new nu();
            this.uid = nX("ec_map_draw"), this._controller = new Hct(s.getZr()), this._controllerHost = { target: r5 }, this.group = r5, r5.add(this._regionsGroup = new nu()), r5.add(this._svgGroup = new nu());
          }
          return c5.prototype.draw = function(s, r5, g5, b6, S2) {
            var A2 = s.mainType === "geo", k2 = s.getData && s.getData();
            A2 && r5.eachComponent({ mainType: "series", subType: "map" }, function(Mt) {
              !k2 && Mt.getHostGeoModel() === s && (k2 = Mt.getData());
            });
            var R6 = s.coordinateSystem, B3 = this._regionsGroup, G3 = this.group, Z3 = R6.getTransformInfo(), X3 = Z3.raw, tt = Z3.roam, it = !B3.childAt(0) || S2;
            it ? (G3.x = tt.x, G3.y = tt.y, G3.scaleX = tt.scaleX, G3.scaleY = tt.scaleY, G3.dirty()) : Qf2(G3, tt, s);
            var pt = k2 && k2.getVisual("visualMeta") && k2.getVisual("visualMeta").length > 0, mt = { api: g5, geo: R6, mapOrGeoModel: s, data: k2, isVisualEncodedByVisualMap: pt, isGeo: A2, transformInfoRaw: X3 };
            R6.resourceType === "geoJSON" ? this._buildGeoJSON(mt) : R6.resourceType === "geoSVG" && this._buildSVG(mt), this._updateController(s, r5, g5), this._updateMapSelectHandler(s, B3, g5, b6);
          }, c5.prototype._buildGeoJSON = function(s) {
            var r5 = this._regionsGroupByName = Ps(), g5 = Ps(), b6 = this._regionsGroup, S2 = s.transformInfoRaw, A2 = s.mapOrGeoModel, k2 = s.data, R6 = s.geo.projection, B3 = R6 && R6.stream;
            function G3(tt, it) {
              return it && (tt = it(tt)), tt && [tt[0] * S2.scaleX + S2.x, tt[1] * S2.scaleY + S2.y];
            }
            function Z3(tt) {
              for (var it = [], pt = !B3 && R6 && R6.project, mt = 0; mt < tt.length; ++mt) {
                var Mt = G3(tt[mt], pt);
                Mt && it.push(Mt);
              }
              return it;
            }
            function X3(tt) {
              return { shape: { points: Z3(tt) } };
            }
            b6.removeAll(), Ye2(s.geo.regions, function(tt) {
              var it = tt.name, pt = r5.get(it), mt = g5.get(it) || {}, Mt = mt.dataIdx, kt = mt.regionModel;
              pt || (pt = r5.set(it, new nu()), b6.add(pt), Mt = k2 ? k2.indexOfName(it) : null, kt = s.isGeo ? A2.getRegionModel(it) : k2 ? k2.getItemModel(Mt) : null, g5.set(it, { dataIdx: Mt, regionModel: kt }));
              var Gt = [], Ot = [];
              Ye2(tt.geometries, function(de2) {
                if (de2.type === "polygon") {
                  var we2 = [de2.exterior].concat(de2.interiors || []);
                  B3 && (we2 = yke(we2, B3)), Ye2(we2, function(Oe2) {
                    Gt.push(new Gb2(X3(Oe2)));
                  });
                } else {
                  var Se2 = de2.points;
                  B3 && (Se2 = yke(Se2, B3, true)), Ye2(Se2, function(Oe2) {
                    Ot.push(new Gw(X3(Oe2)));
                  });
                }
              });
              var ce2 = G3(tt.getCenter(), R6 && R6.project);
              function ae2(de2, we2) {
                if (de2.length) {
                  var Se2 = new Zut({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: de2 } });
                  pt.add(Se2), hke(s, Se2, Mt, kt), pke(s, Se2, it, kt, A2, Mt, ce2), we2 && (fke(Se2), Ye2(Se2.states, fke));
                }
              }
              ae2(Gt), ae2(Ot, true);
            }), r5.each(function(tt, it) {
              var pt = g5.get(it), mt = pt.dataIdx, Mt = pt.regionModel;
              dke(s, tt, it, Mt, A2, mt), gke(s, tt, it, Mt, A2), vke(s, tt, it, Mt, A2);
            }, this);
          }, c5.prototype._buildSVG = function(s) {
            var r5 = s.geo.map, g5 = s.transformInfoRaw;
            this._svgGroup.x = g5.x, this._svgGroup.y = g5.y, this._svgGroup.scaleX = g5.scaleX, this._svgGroup.scaleY = g5.scaleY, this._svgResourceChanged(r5) && (this._freeSVG(), this._useSVG(r5));
            var b6 = this._svgDispatcherMap = Ps(), S2 = false;
            Ye2(this._svgGraphicRecord.named, function(A2) {
              var k2 = A2.name, R6 = s.mapOrGeoModel, B3 = s.data, G3 = A2.svgNodeTagLower, Z3 = A2.el, X3 = B3 ? B3.indexOfName(k2) : null, tt = R6.getRegionModel(k2);
              if (szn.get(G3) != null && Z3 instanceof SM && hke(s, Z3, X3, tt), Z3 instanceof SM && (Z3.culling = true), Z3.z2EmphasisLift = 0, !A2.namedFrom && (uzn.get(G3) != null && pke(s, Z3, k2, tt, R6, X3, null), dke(s, Z3, k2, tt, R6, X3), gke(s, Z3, k2, tt, R6), lzn.get(G3) != null)) {
                var it = vke(s, Z3, k2, tt, R6);
                it === "self" && (S2 = true);
                var pt = b6.get(k2) || b6.set(k2, []);
                pt.push(Z3);
              }
            }, this), this._enableBlurEntireSVG(S2, s);
          }, c5.prototype._enableBlurEntireSVG = function(s, r5) {
            if (s && r5.isGeo) {
              var g5 = r5.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), b6 = g5.opacity;
              this._svgGraphicRecord.root.traverse(function(S2) {
                if (!S2.isGroup) {
                  MM(S2);
                  var A2 = S2.ensureState("blur").style || {};
                  A2.opacity == null && b6 != null && (A2.opacity = b6), S2.ensureState("emphasis");
                }
              });
            }
          }, c5.prototype.remove = function() {
            this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
          }, c5.prototype.findHighDownDispatchers = function(s, r5) {
            if (s == null)
              return [];
            var g5 = r5.coordinateSystem;
            if (g5.resourceType === "geoJSON") {
              var b6 = this._regionsGroupByName;
              if (b6) {
                var S2 = b6.get(s);
                return S2 ? [S2] : [];
              }
            } else if (g5.resourceType === "geoSVG")
              return this._svgDispatcherMap && this._svgDispatcherMap.get(s) || [];
          }, c5.prototype._svgResourceChanged = function(s) {
            return this._svgMapName !== s;
          }, c5.prototype._useSVG = function(s) {
            var r5 = AR.getGeoResource(s);
            if (r5 && r5.type === "geoSVG") {
              var g5 = r5.useGraphic(this.uid);
              this._svgGroup.add(g5.root), this._svgGraphicRecord = g5, this._svgMapName = s;
            }
          }, c5.prototype._freeSVG = function() {
            var s = this._svgMapName;
            if (s != null) {
              var r5 = AR.getGeoResource(s);
              r5 && r5.type === "geoSVG" && r5.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
            }
          }, c5.prototype._updateController = function(s, r5, g5) {
            var b6 = s.coordinateSystem, S2 = this._controller, A2 = this._controllerHost;
            A2.zoomLimit = s.get("scaleLimit"), A2.zoom = b6.getZoom(), S2.enable(s.get("roam") || false);
            var k2 = s.mainType;
            function R6() {
              var B3 = { type: "geoRoam", componentType: k2 };
              return B3[k2 + "Id"] = s.id, B3;
            }
            S2.off("pan").on("pan", function(B3) {
              this._mouseDownFlag = false, pHt(A2, B3.dx, B3.dy), g5.dispatchAction(sa2(R6(), { dx: B3.dx, dy: B3.dy, animation: { duration: 0 } }));
            }, this), S2.off("zoom").on("zoom", function(B3) {
              this._mouseDownFlag = false, dHt(A2, B3.scale, B3.originX, B3.originY), g5.dispatchAction(sa2(R6(), { zoom: B3.scale, originX: B3.originX, originY: B3.originY, animation: { duration: 0 } }));
            }, this), S2.setPointerChecker(function(B3, G3, Z3) {
              return b6.containPoint([G3, Z3]) && !XMt(B3, g5, s);
            });
          }, c5.prototype.resetForLabelLayout = function() {
            this.group.traverse(function(s) {
              var r5 = s.getTextContent();
              r5 && (r5.ignore = cke(r5).ignore);
            });
          }, c5.prototype._updateMapSelectHandler = function(s, r5, g5, b6) {
            var S2 = this;
            r5.off("mousedown"), r5.off("click"), s.get("selectedMode") && (r5.on("mousedown", function() {
              S2._mouseDownFlag = true;
            }), r5.on("click", function(A2) {
              !S2._mouseDownFlag || (S2._mouseDownFlag = false);
            }));
          }, c5;
        }();
        function hke(c5, s, r5, g5) {
          var b6 = g5.getModel("itemStyle"), S2 = g5.getModel(["emphasis", "itemStyle"]), A2 = g5.getModel(["blur", "itemStyle"]), k2 = g5.getModel(["select", "itemStyle"]), R6 = eCt(b6), B3 = eCt(S2), G3 = eCt(k2), Z3 = eCt(A2), X3 = c5.data;
          if (X3) {
            var tt = X3.getItemVisual(r5, "style"), it = X3.getItemVisual(r5, "decal");
            c5.isVisualEncodedByVisualMap && tt.fill && (R6.fill = tt.fill), it && (R6.decal = mct(it, c5.api));
          }
          s.setStyle(R6), s.style.strokeNoScale = true, s.ensureState("emphasis").style = B3, s.ensureState("select").style = G3, s.ensureState("blur").style = Z3, MM(s);
        }
        function pke(c5, s, r5, g5, b6, S2, A2) {
          var k2 = c5.data, R6 = c5.isGeo, B3 = k2 && isNaN(k2.get(k2.mapDimension("value"), S2)), G3 = k2 && k2.getItemLayout(S2);
          if (R6 || B3 || G3 && G3.showLabel) {
            var Z3 = R6 ? r5 : S2, X3 = void 0;
            (!k2 || S2 >= 0) && (X3 = b6);
            var tt = A2 ? { normal: { align: "center", verticalAlign: "middle" } } : null;
            Uw(s, qb2(g5), { labelFetcher: X3, labelDataIndex: Z3, defaultText: r5 }, tt);
            var it = s.getTextContent();
            if (it && (cke(it).ignore = it.ignore, s.textConfig && A2)) {
              var pt = s.getBoundingRect().clone();
              s.textConfig.layoutRect = pt, s.textConfig.position = [(A2[0] - pt.x) / pt.width * 100 + "%", (A2[1] - pt.y) / pt.height * 100 + "%"];
            }
            s.disableLabelAnimation = true;
          } else
            s.removeTextContent(), s.removeTextConfig(), s.disableLabelAnimation = null;
        }
        function dke(c5, s, r5, g5, b6, S2) {
          c5.data ? c5.data.setItemGraphicEl(S2, s) : Pl(s).eventData = { componentType: "geo", componentIndex: b6.componentIndex, geoIndex: b6.componentIndex, name: r5, region: g5 && g5.option || {} };
        }
        function gke(c5, s, r5, g5, b6) {
          c5.data || Ub2({ el: s, componentModel: b6, itemName: r5, itemTooltipOption: g5.get("tooltip") });
        }
        function vke(c5, s, r5, g5, b6) {
          s.highDownSilentOnTouch = !!b6.get("selectedMode");
          var S2 = g5.getModel("emphasis"), A2 = S2.get("focus");
          return f0(s, A2, S2.get("blurScope"), S2.get("disabled")), c5.isGeo && zjt(s, b6, r5), A2;
        }
        function yke(c5, s, r5) {
          var g5 = [], b6;
          function S2() {
            b6 = [];
          }
          function A2() {
            b6.length && (g5.push(b6), b6 = []);
          }
          var k2 = s({ polygonStart: S2, polygonEnd: A2, lineStart: S2, lineEnd: A2, point: function(R6, B3) {
            isFinite(R6) && isFinite(B3) && b6.push([R6, B3]);
          }, sphere: function() {
          } });
          return !r5 && k2.polygonStart(), Ye2(c5, function(R6) {
            k2.lineStart();
            for (var B3 = 0; B3 < R6.length; B3++)
              k2.point(R6[B3][0], R6[B3][1]);
            k2.lineEnd();
          }), !r5 && k2.polygonEnd(), g5;
        }
        var mke = czn, fzn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            if (!(S2 && S2.type === "mapToggleSelect" && S2.from === this.uid)) {
              var A2 = this.group;
              if (A2.removeAll(), !r5.getHostGeoModel()) {
                if (this._mapDraw && S2 && S2.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), S2 && S2.type === "geoRoam" && S2.componentType === "series" && S2.seriesId === r5.id) {
                  var k2 = this._mapDraw;
                  k2 && A2.add(k2.group);
                } else if (r5.needsDrawMap) {
                  var k2 = this._mapDraw || new mke(b6);
                  A2.add(k2.group), k2.draw(r5, g5, b6, this, S2), this._mapDraw = k2;
                } else
                  this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
                r5.get("showLegendSymbol") && g5.getComponent("legend") && this._renderSymbols(r5, g5, b6);
              }
            }
          }, s.prototype.remove = function() {
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
          }, s.prototype.dispose = function() {
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          }, s.prototype._renderSymbols = function(r5, g5, b6) {
            var S2 = r5.originalData, A2 = this.group;
            S2.each(S2.mapDimension("value"), function(k2, R6) {
              if (!isNaN(k2)) {
                var B3 = S2.getItemLayout(R6);
                if (!(!B3 || !B3.point)) {
                  var G3 = B3.point, Z3 = B3.offset, X3 = new qI({ style: { fill: r5.getData().getVisual("style").fill }, shape: { cx: G3[0] + Z3 * 9, cy: G3[1], r: 3 }, silent: true, z2: 8 + (Z3 ? 0 : j8 + 1) });
                  if (!Z3) {
                    var tt = r5.mainSeries.getData(), it = S2.getName(R6), pt = tt.indexOfName(it), mt = S2.getItemModel(R6), Mt = mt.getModel("label"), kt = tt.getItemGraphicEl(pt);
                    Uw(X3, qb2(mt), { labelFetcher: { getFormattedLabel: function(Gt, Ot) {
                      return r5.getFormattedLabel(pt, Ot);
                    } }, defaultText: it }), X3.disableLabelAnimation = true, Mt.get("position") || X3.setTextConfig({ position: "bottom" }), kt.onHoverStateChange = function(Gt) {
                      T3(X3, Gt);
                    };
                  }
                  A2.add(X3);
                }
              }
            });
          }, s.type = "map", s;
        }(Ig2), hzn = fzn, pzn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.needsDrawMap = false, r5.seriesGroup = [], r5.getTooltipPosition = function(g5) {
              if (g5 != null) {
                var b6 = this.getData().getName(g5), S2 = this.coordinateSystem, A2 = S2.getRegion(b6);
                return A2 && S2.dataToPoint(A2.getCenter());
              }
            }, r5;
          }
          return s.prototype.getInitialData = function(r5) {
            for (var g5 = MX(this, { coordDimensions: ["value"], encodeDefaulter: Au(IWt, this) }), b6 = Ps(), S2 = [], A2 = 0, k2 = g5.count(); A2 < k2; A2++) {
              var R6 = g5.getName(A2);
              b6.set(R6, true);
            }
            var B3 = AR.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
            return Ye2(B3.regions, function(G3) {
              var Z3 = G3.name;
              b6.get(Z3) || S2.push(Z3);
            }), g5.appendValues([], S2), g5;
          }, s.prototype.getHostGeoModel = function() {
            var r5 = this.option.geoIndex;
            return r5 != null ? this.ecModel.getComponent("geo", r5) : null;
          }, s.prototype.getMapType = function() {
            return (this.getHostGeoModel() || this).option.map;
          }, s.prototype.getRawValue = function(r5) {
            var g5 = this.getData();
            return g5.get(g5.mapDimension("value"), r5);
          }, s.prototype.getRegionModel = function(r5) {
            var g5 = this.getData();
            return g5.getItemModel(g5.indexOfName(r5));
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            for (var S2 = this.getData(), A2 = this.getRawValue(r5), k2 = S2.getName(r5), R6 = this.seriesGroup, B3 = [], G3 = 0; G3 < R6.length; G3++) {
              var Z3 = R6[G3].originalData.indexOfName(k2), X3 = S2.mapDimension("value");
              isNaN(R6[G3].originalData.get(X3, Z3)) || B3.push(R6[G3].name);
            }
            return W1("section", { header: B3.join(", "), noHeader: !B3.length, blocks: [W1("nameValue", { name: k2, value: A2 })] });
          }, s.prototype.setZoom = function(r5) {
            this.option.zoom = r5;
          }, s.prototype.setCenter = function(r5) {
            this.option.center = r5;
          }, s.prototype.getLegendIcon = function(r5) {
            var g5 = r5.icon || "roundRect", b6 = am(g5, 0, 0, r5.itemWidth, r5.itemHeight, r5.itemStyle.fill);
            return b6.setStyle(r5.itemStyle), b6.style.stroke = "none", g5.indexOf("empty") > -1 && (b6.style.stroke = b6.style.fill, b6.style.fill = "#fff", b6.style.lineWidth = 2), b6;
          }, s.type = "series.map", s.dependencies = ["geo"], s.layoutMode = "box", s.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, s;
        }(zv), dzn = pzn;
        function gzn(c5, s) {
          var r5 = {};
          return Ye2(c5, function(g5) {
            g5.each(g5.mapDimension("value"), function(b6, S2) {
              var A2 = "ec-" + g5.getName(S2);
              r5[A2] = r5[A2] || [], isNaN(b6) || r5[A2].push(b6);
            });
          }), c5[0].map(c5[0].mapDimension("value"), function(g5, b6) {
            for (var S2 = "ec-" + c5[0].getName(b6), A2 = 0, k2 = 1 / 0, R6 = -1 / 0, B3 = r5[S2].length, G3 = 0; G3 < B3; G3++)
              k2 = Math.min(k2, r5[S2][G3]), R6 = Math.max(R6, r5[S2][G3]), A2 += r5[S2][G3];
            var Z3;
            return s === "min" ? Z3 = k2 : s === "max" ? Z3 = R6 : s === "average" ? Z3 = A2 / B3 : Z3 = A2, B3 === 0 ? NaN : Z3;
          });
        }
        function vzn(c5) {
          var s = {};
          c5.eachSeriesByType("map", function(r5) {
            var g5 = r5.getHostGeoModel(), b6 = g5 ? "o" + g5.id : "i" + r5.getMapType();
            (s[b6] = s[b6] || []).push(r5);
          }), Ye2(s, function(r5, g5) {
            for (var b6 = gzn(Ha2(r5, function(A2) {
              return A2.getData();
            }), r5[0].get("mapValueCalculation")), S2 = 0; S2 < r5.length; S2++)
              r5[S2].originalData = r5[S2].getData();
            for (var S2 = 0; S2 < r5.length; S2++)
              r5[S2].seriesGroup = r5, r5[S2].needsDrawMap = S2 === 0 && !r5[S2].getHostGeoModel(), r5[S2].setData(b6.cloneShallow()), r5[S2].mainSeries = r5[0];
          });
        }
        function yzn(c5) {
          var s = {};
          c5.eachSeriesByType("map", function(r5) {
            var g5 = r5.getMapType();
            if (!(r5.getHostGeoModel() || s[g5])) {
              var b6 = {};
              Ye2(r5.seriesGroup, function(A2) {
                var k2 = A2.coordinateSystem, R6 = A2.originalData;
                A2.get("showLegendSymbol") && c5.getComponent("legend") && R6.each(R6.mapDimension("value"), function(B3, G3) {
                  var Z3 = R6.getName(G3), X3 = k2.getRegion(Z3);
                  if (!(!X3 || isNaN(B3))) {
                    var tt = b6[Z3] || 0, it = k2.dataToPoint(X3.getCenter());
                    b6[Z3] = tt + 1, R6.setItemLayout(G3, { point: it, offset: tt });
                  }
                });
              });
              var S2 = r5.getData();
              S2.each(function(A2) {
                var k2 = S2.getName(A2), R6 = S2.getItemLayout(A2) || {};
                R6.showLabel = !b6[k2], S2.setItemLayout(A2, R6);
              }), s[g5] = true;
            }
          });
        }
        var bke = Gm, mzn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this) || this;
            return g5.type = "view", g5.dimensions = ["x", "y"], g5._roamTransformable = new YC(), g5._rawTransformable = new YC(), g5.name = r5, g5;
          }
          return s.prototype.setBoundingRect = function(r5, g5, b6, S2) {
            return this._rect = new lc2(r5, g5, b6, S2), this._rect;
          }, s.prototype.getBoundingRect = function() {
            return this._rect;
          }, s.prototype.setViewRect = function(r5, g5, b6, S2) {
            this._transformTo(r5, g5, b6, S2), this._viewRect = new lc2(r5, g5, b6, S2);
          }, s.prototype._transformTo = function(r5, g5, b6, S2) {
            var A2 = this.getBoundingRect(), k2 = this._rawTransformable;
            k2.transform = A2.calculateTransform(new lc2(r5, g5, b6, S2));
            var R6 = k2.parent;
            k2.parent = null, k2.decomposeTransform(), k2.parent = R6, this._updateTransform();
          }, s.prototype.setCenter = function(r5) {
            !r5 || (this._center = r5, this._updateCenterAndZoom());
          }, s.prototype.setZoom = function(r5) {
            r5 = r5 || 1;
            var g5 = this.zoomLimit;
            g5 && (g5.max != null && (r5 = Math.min(g5.max, r5)), g5.min != null && (r5 = Math.max(g5.min, r5))), this._zoom = r5, this._updateCenterAndZoom();
          }, s.prototype.getDefaultCenter = function() {
            var r5 = this.getBoundingRect(), g5 = r5.x + r5.width / 2, b6 = r5.y + r5.height / 2;
            return [g5, b6];
          }, s.prototype.getCenter = function() {
            return this._center || this.getDefaultCenter();
          }, s.prototype.getZoom = function() {
            return this._zoom || 1;
          }, s.prototype.getRoamTransform = function() {
            return this._roamTransformable.getLocalTransform();
          }, s.prototype._updateCenterAndZoom = function() {
            var r5 = this._rawTransformable.getLocalTransform(), g5 = this._roamTransformable, b6 = this.getDefaultCenter(), S2 = this.getCenter(), A2 = this.getZoom();
            S2 = Gm([], S2, r5), b6 = Gm([], b6, r5), g5.originX = S2[0], g5.originY = S2[1], g5.x = b6[0] - S2[0], g5.y = b6[1] - S2[1], g5.scaleX = g5.scaleY = A2, this._updateTransform();
          }, s.prototype._updateTransform = function() {
            var r5 = this._roamTransformable, g5 = this._rawTransformable;
            g5.parent = r5, r5.updateTransform(), g5.updateTransform(), Ej2(this.transform || (this.transform = []), g5.transform || bM()), this._rawTransform = g5.getLocalTransform(), this.invTransform = this.invTransform || [], Y4(this.invTransform, this.transform), this.decomposeTransform();
          }, s.prototype.getTransformInfo = function() {
            var r5 = this._rawTransformable, g5 = this._roamTransformable, b6 = new YC();
            return b6.transform = g5.transform, b6.decomposeTransform(), { roam: { x: b6.x, y: b6.y, scaleX: b6.scaleX, scaleY: b6.scaleY }, raw: { x: r5.x, y: r5.y, scaleX: r5.scaleX, scaleY: r5.scaleY } };
          }, s.prototype.getViewRect = function() {
            return this._viewRect;
          }, s.prototype.getViewRectAfterRoam = function() {
            var r5 = this.getBoundingRect().clone();
            return r5.applyTransform(this.transform), r5;
          }, s.prototype.dataToPoint = function(r5, g5, b6) {
            var S2 = g5 ? this._rawTransform : this.transform;
            return b6 = b6 || [], S2 ? bke(b6, r5, S2) : ux(b6, r5);
          }, s.prototype.pointToData = function(r5) {
            var g5 = this.invTransform;
            return g5 ? bke([], r5, g5) : [r5[0], r5[1]];
          }, s.prototype.convertToPixel = function(r5, g5, b6) {
            var S2 = _ke(g5);
            return S2 === this ? S2.dataToPoint(b6) : null;
          }, s.prototype.convertFromPixel = function(r5, g5, b6) {
            var S2 = _ke(g5);
            return S2 === this ? S2.pointToData(b6) : null;
          }, s.prototype.containPoint = function(r5) {
            return this.getViewRectAfterRoam().contain(r5[0], r5[1]);
          }, s.dimensions = ["x", "y"], s;
        }(YC);
        function _ke(c5) {
          var s = c5.seriesModel;
          return s ? s.coordinateSystem : null;
        }
        var qct = mzn, bzn = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, xke = ["lng", "lat"], wke = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this, r5) || this;
            S2.dimensions = xke, S2.type = "geo", S2._nameCoordMap = Ps(), S2.map = g5;
            var A2 = b6.projection, k2 = AR.load(g5, b6.nameMap, b6.nameProperty), R6 = AR.getGeoResource(g5);
            S2.resourceType = R6 ? R6.type : null;
            var B3 = S2.regions = k2.regions, G3 = bzn[R6.type];
            S2._regionsMap = k2.regionsMap, S2.regions = k2.regions, S2.projection = A2;
            var Z3;
            if (A2)
              for (var X3 = 0; X3 < B3.length; X3++) {
                var tt = B3[X3].getBoundingRect(A2);
                Z3 = Z3 || tt.clone(), Z3.union(tt);
              }
            else
              Z3 = k2.boundingRect;
            return S2.setBoundingRect(Z3.x, Z3.y, Z3.width, Z3.height), S2.aspectScale = A2 ? 1 : tc2(b6.aspectScale, G3.aspectScale), S2._invertLongitute = A2 ? false : G3.invertLongitute, S2;
          }
          return s.prototype._transformTo = function(r5, g5, b6, S2) {
            var A2 = this.getBoundingRect(), k2 = this._invertLongitute;
            A2 = A2.clone(), k2 && (A2.y = -A2.y - A2.height);
            var R6 = this._rawTransformable;
            R6.transform = A2.calculateTransform(new lc2(r5, g5, b6, S2));
            var B3 = R6.parent;
            R6.parent = null, R6.decomposeTransform(), R6.parent = B3, k2 && (R6.scaleY = -R6.scaleY), this._updateTransform();
          }, s.prototype.getRegion = function(r5) {
            return this._regionsMap.get(r5);
          }, s.prototype.getRegionByCoord = function(r5) {
            for (var g5 = this.regions, b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6];
              if (S2.type === "geoJSON" && S2.contain(r5))
                return g5[b6];
            }
          }, s.prototype.addGeoCoord = function(r5, g5) {
            this._nameCoordMap.set(r5, g5);
          }, s.prototype.getGeoCoord = function(r5) {
            var g5 = this._regionsMap.get(r5);
            return this._nameCoordMap.get(r5) || g5 && g5.getCenter();
          }, s.prototype.dataToPoint = function(r5, g5, b6) {
            if (gs(r5) && (r5 = this.getGeoCoord(r5)), r5) {
              var S2 = this.projection;
              return S2 && (r5 = S2.project(r5)), r5 && this.projectedToPoint(r5);
            }
          }, s.prototype.pointToData = function(r5) {
            var g5 = this.projection;
            return g5 && (r5 = g5.unproject(r5)), r5 && this.pointToProjected(r5);
          }, s.prototype.pointToProjected = function(r5) {
            return c5.prototype.pointToData.call(this, r5);
          }, s.prototype.projectedToPoint = function(r5, g5, b6) {
            return c5.prototype.dataToPoint.call(this, r5, g5, b6);
          }, s.prototype.convertToPixel = function(r5, g5, b6) {
            var S2 = Ske(g5);
            return S2 === this ? S2.dataToPoint(b6) : null;
          }, s.prototype.convertFromPixel = function(r5, g5, b6) {
            var S2 = Ske(g5);
            return S2 === this ? S2.pointToData(b6) : null;
          }, s;
        }(qct);
        A0(wke, qct);
        function Ske(c5) {
          var s = c5.geoModel, r5 = c5.seriesModel;
          return s ? s.coordinateSystem : r5 ? r5.coordinateSystem || (r5.getReferringComponents("geo", E0).models[0] || {}).coordinateSystem : null;
        }
        var Mke = wke;
        function Cke(c5, s) {
          var r5 = c5.get("boundingCoords");
          if (r5 != null) {
            var g5 = r5[0], b6 = r5[1];
            if (isFinite(g5[0]) && isFinite(g5[1]) && isFinite(b6[0]) && isFinite(b6[1])) {
              var S2 = this.projection;
              if (S2) {
                var A2 = g5[0], k2 = g5[1], R6 = b6[0], B3 = b6[1];
                g5 = [1 / 0, 1 / 0], b6 = [-1 / 0, -1 / 0];
                var G3 = function(ae2, de2, we2, Se2) {
                  for (var Oe2 = we2 - ae2, je2 = Se2 - de2, rn = 0; rn <= 100; rn++) {
                    var qe2 = rn / 100, An = S2.project([ae2 + Oe2 * qe2, de2 + je2 * qe2]);
                    BC(g5, g5, An), c2(b6, b6, An);
                  }
                };
                G3(A2, k2, R6, k2), G3(R6, k2, R6, B3), G3(R6, B3, A2, B3), G3(A2, B3, R6, k2);
              }
              this.setBoundingRect(g5[0], g5[1], b6[0] - g5[0], b6[1] - g5[1]);
            }
          }
          var Z3 = this.getBoundingRect(), X3 = c5.get("layoutCenter"), tt = c5.get("layoutSize"), it = s.getWidth(), pt = s.getHeight(), mt = Z3.width / Z3.height * this.aspectScale, Mt = false, kt, Gt;
          X3 && tt && (kt = [$o(X3[0], it), $o(X3[1], pt)], Gt = $o(tt, Math.min(it, pt)), !isNaN(kt[0]) && !isNaN(kt[1]) && !isNaN(Gt) && (Mt = true));
          var Ot;
          if (Mt)
            Ot = {}, mt > 1 ? (Ot.width = Gt, Ot.height = Gt / mt) : (Ot.height = Gt, Ot.width = Gt * mt), Ot.y = kt[1] - Ot.height / 2, Ot.x = kt[0] - Ot.width / 2;
          else {
            var ce2 = c5.getBoxLayoutParams();
            ce2.aspect = mt, Ot = $m(ce2, { width: it, height: pt });
          }
          this.setViewRect(Ot.x, Ot.y, Ot.width, Ot.height), this.setCenter(c5.get("center")), this.setZoom(c5.get("zoom"));
        }
        function _zn(c5, s) {
          Ye2(s.get("geoCoord"), function(r5, g5) {
            c5.addGeoCoord(g5, r5);
          });
        }
        var xzn = function() {
          function c5() {
            this.dimensions = xke;
          }
          return c5.prototype.create = function(s, r5) {
            var g5 = [];
            function b6(A2) {
              return { nameProperty: A2.get("nameProperty"), aspectScale: A2.get("aspectScale"), projection: A2.get("projection") };
            }
            s.eachComponent("geo", function(A2, k2) {
              var R6 = A2.get("map"), B3 = new Mke(R6 + k2, R6, sa2({ nameMap: A2.get("nameMap") }, b6(A2)));
              B3.zoomLimit = A2.get("scaleLimit"), g5.push(B3), A2.coordinateSystem = B3, B3.model = A2, B3.resize = Cke, B3.resize(A2, r5);
            }), s.eachSeries(function(A2) {
              var k2 = A2.get("coordinateSystem");
              if (k2 === "geo") {
                var R6 = A2.get("geoIndex") || 0;
                A2.coordinateSystem = g5[R6];
              }
            });
            var S2 = {};
            return s.eachSeriesByType("map", function(A2) {
              if (!A2.getHostGeoModel()) {
                var k2 = A2.getMapType();
                S2[k2] = S2[k2] || [], S2[k2].push(A2);
              }
            }), Ye2(S2, function(A2, k2) {
              var R6 = Ha2(A2, function(G3) {
                return G3.get("nameMap");
              }), B3 = new Mke(k2, k2, sa2({ nameMap: B4(R6) }, b6(A2[0])));
              B3.zoomLimit = Wm.apply(null, Ha2(A2, function(G3) {
                return G3.get("scaleLimit");
              })), g5.push(B3), B3.resize = Cke, B3.resize(A2[0], r5), Ye2(A2, function(G3) {
                G3.coordinateSystem = B3, _zn(B3, G3);
              });
            }), g5;
          }, c5.prototype.getFilledRegions = function(s, r5, g5, b6) {
            for (var S2 = (s || []).slice(), A2 = Ps(), k2 = 0; k2 < S2.length; k2++)
              A2.set(S2[k2].name, S2[k2]);
            var R6 = AR.load(r5, g5, b6);
            return Ye2(R6.regions, function(B3) {
              var G3 = B3.name;
              !A2.get(G3) && S2.push({ name: G3 });
            }), S2;
          }, c5;
        }(), wzn = new xzn(), Tke = wzn, Szn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            var S2 = AR.getGeoResource(r5.map);
            if (S2 && S2.type === "geoJSON") {
              var A2 = r5.itemStyle = r5.itemStyle || {};
              "color" in A2 || (A2.color = "#eee");
            }
            this.mergeDefaultAndTheme(r5, b6), wM(r5, "label", ["show"]);
          }, s.prototype.optionUpdated = function() {
            var r5 = this, g5 = this.option;
            g5.regions = Tke.getFilledRegions(g5.regions, g5.map, g5.nameMap, g5.nameProperty);
            var b6 = {};
            this._optionModelMap = VC(g5.regions || [], function(S2, A2) {
              var k2 = A2.name;
              return k2 && (S2.set(k2, new Ag2(A2, r5, r5.ecModel)), A2.selected && (b6[k2] = true)), S2;
            }, Ps()), g5.selectedMap || (g5.selectedMap = b6);
          }, s.prototype.getRegionModel = function(r5) {
            return this._optionModelMap.get(r5) || new Ag2(null, this, this.ecModel);
          }, s.prototype.getFormattedLabel = function(r5, g5) {
            var b6 = this.getRegionModel(r5), S2 = g5 === "normal" ? b6.get(["label", "formatter"]) : b6.get(["emphasis", "label", "formatter"]), A2 = { name: r5 };
            if (Tl(S2))
              return A2.status = g5, S2(A2);
            if (gs(S2))
              return S2.replace("{a}", r5 != null ? r5 : "");
          }, s.prototype.setZoom = function(r5) {
            this.option.zoom = r5;
          }, s.prototype.setCenter = function(r5) {
            this.option.center = r5;
          }, s.prototype.select = function(r5) {
            var g5 = this.option, b6 = g5.selectedMode;
            if (b6) {
              b6 !== "multiple" && (g5.selectedMap = null);
              var S2 = g5.selectedMap || (g5.selectedMap = {});
              S2[r5] = true;
            }
          }, s.prototype.unSelect = function(r5) {
            var g5 = this.option.selectedMap;
            g5 && (g5[r5] = false);
          }, s.prototype.toggleSelected = function(r5) {
            this[this.isSelected(r5) ? "unSelect" : "select"](r5);
          }, s.prototype.isSelected = function(r5) {
            var g5 = this.option.selectedMap;
            return !!(g5 && g5[r5]);
          }, s.type = "geo", s.layoutMode = "box", s.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, s;
        }(Rh2), Mzn = Szn;
        function Ake(c5, s) {
          return c5.pointToProjected ? c5.pointToProjected(s) : c5.pointToData(s);
        }
        function bHt(c5, s, r5) {
          var g5 = c5.getZoom(), b6 = c5.getCenter(), S2 = s.zoom, A2 = c5.projectedToPoint ? c5.projectedToPoint(b6) : c5.dataToPoint(b6);
          if (s.dx != null && s.dy != null && (A2[0] -= s.dx, A2[1] -= s.dy, c5.setCenter(Ake(c5, A2))), S2 != null) {
            if (r5) {
              var k2 = r5.min || 0, R6 = r5.max || 1 / 0;
              S2 = Math.max(Math.min(g5 * S2, R6), k2) / g5;
            }
            c5.scaleX *= S2, c5.scaleY *= S2;
            var B3 = (s.originX - c5.x) * (S2 - 1), G3 = (s.originY - c5.y) * (S2 - 1);
            c5.x -= B3, c5.y -= G3, c5.updateTransform(), c5.setCenter(Ake(c5, A2)), c5.setZoom(S2 * g5);
          }
          return { center: c5.getCenter(), zoom: c5.getZoom() };
        }
        var Czn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.focusBlurEnabled = true, r5;
          }
          return s.prototype.init = function(r5, g5) {
            this._api = g5;
          }, s.prototype.render = function(r5, g5, b6, S2) {
            if (this._model = r5, !r5.get("show")) {
              this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
              return;
            }
            this._mapDraw || (this._mapDraw = new mke(b6));
            var A2 = this._mapDraw;
            A2.draw(r5, g5, b6, this, S2), A2.group.on("click", this._handleRegionClick, this), A2.group.silent = r5.get("silent"), this.group.add(A2.group), this.updateSelectStatus(r5, g5, b6);
          }, s.prototype._handleRegionClick = function(r5) {
            var g5;
            gX(r5.target, function(b6) {
              return (g5 = Pl(b6).eventData) != null;
            }, true), g5 && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: g5.name });
          }, s.prototype.updateSelectStatus = function(r5, g5, b6) {
            var S2 = this;
            this._mapDraw.group.traverse(function(A2) {
              var k2 = Pl(A2).eventData;
              if (k2)
                return S2._model.isSelected(k2.name) ? b6.enterSelect(A2) : b6.leaveSelect(A2), true;
            });
          }, s.prototype.findHighDownDispatchers = function(r5) {
            return this._mapDraw && this._mapDraw.findHighDownDispatchers(r5, this._model);
          }, s.prototype.dispose = function() {
            this._mapDraw && this._mapDraw.remove();
          }, s.type = "geo", s;
        }(P0), Tzn = Czn;
        function Azn(c5, s, r5) {
          AR.registerMap(c5, s, r5);
        }
        function Ike(c5) {
          c5.registerCoordinateSystem("geo", Tke), c5.registerComponentModel(Mzn), c5.registerComponentView(Tzn), c5.registerImpl("registerMap", Azn), c5.registerImpl("getMap", function(r5) {
            return AR.getMapForUser(r5);
          });
          function s(r5, g5) {
            g5.update = "geo:updateSelectStatus", c5.registerAction(g5, function(b6, S2) {
              var A2 = {}, k2 = [];
              return S2.eachComponent({ mainType: "geo", query: b6 }, function(R6) {
                R6[r5](b6.name);
                var B3 = R6.coordinateSystem;
                Ye2(B3.regions, function(Z3) {
                  A2[Z3.name] = R6.isSelected(Z3.name) || false;
                });
                var G3 = [];
                Ye2(A2, function(Z3, X3) {
                  A2[X3] && G3.push(X3);
                }), k2.push({ geoIndex: R6.componentIndex, name: G3 });
              }), { selected: A2, allSelected: k2, name: b6.name };
            });
          }
          s("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), s("select", { type: "geoSelect", event: "geoselected" }), s("unSelect", { type: "geoUnSelect", event: "geounselected" }), c5.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(r5, g5) {
            var b6 = r5.componentType || "series";
            g5.eachComponent({ mainType: b6, query: r5 }, function(S2) {
              var A2 = S2.coordinateSystem;
              if (A2.type === "geo") {
                var k2 = bHt(A2, r5, S2.get("scaleLimit"));
                S2.setCenter && S2.setCenter(k2.center), S2.setZoom && S2.setZoom(k2.zoom), b6 === "series" && Ye2(S2.seriesGroup, function(R6) {
                  R6.setCenter(k2.center), R6.setZoom(k2.zoom);
                });
              }
            });
          });
        }
        function Izn(c5) {
          Fc2(Ike), c5.registerChartView(hzn), c5.registerSeriesModel(dzn), c5.registerLayout(yzn), c5.registerProcessor(c5.PRIORITY.PROCESSOR.STATISTIC, vzn), EAe("map", c5.registerAction);
        }
        function Dzn(c5) {
          var s = c5;
          s.hierNode = { defaultAncestor: null, ancestor: s, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
          for (var r5 = [s], g5, b6; g5 = r5.pop(); )
            if (b6 = g5.children, g5.isExpand && b6.length)
              for (var S2 = b6.length, A2 = S2 - 1; A2 >= 0; A2--) {
                var k2 = b6[A2];
                k2.hierNode = { defaultAncestor: null, ancestor: k2, prelim: 0, modifier: 0, change: 0, shift: 0, i: A2, thread: null }, r5.push(k2);
              }
        }
        function Ezn(c5, s) {
          var r5 = c5.isExpand ? c5.children : [], g5 = c5.parentNode.children, b6 = c5.hierNode.i ? g5[c5.hierNode.i - 1] : null;
          if (r5.length) {
            Lzn(c5);
            var S2 = (r5[0].hierNode.prelim + r5[r5.length - 1].hierNode.prelim) / 2;
            b6 ? (c5.hierNode.prelim = b6.hierNode.prelim + s(c5, b6), c5.hierNode.modifier = c5.hierNode.prelim - S2) : c5.hierNode.prelim = S2;
          } else
            b6 && (c5.hierNode.prelim = b6.hierNode.prelim + s(c5, b6));
          c5.parentNode.hierNode.defaultAncestor = Ozn(c5, b6, c5.parentNode.hierNode.defaultAncestor || g5[0], s);
        }
        function kzn(c5) {
          var s = c5.hierNode.prelim + c5.parentNode.hierNode.modifier;
          c5.setLayout({ x: s }, true), c5.hierNode.modifier += c5.parentNode.hierNode.modifier;
        }
        function Dke(c5) {
          return arguments.length ? c5 : Fzn;
        }
        function Zct(c5, s) {
          return c5 -= Math.PI / 2, { x: s * Math.cos(c5), y: s * Math.sin(c5) };
        }
        function Pzn(c5, s) {
          return $m(c5.getBoxLayoutParams(), { width: s.getWidth(), height: s.getHeight() });
        }
        function Lzn(c5) {
          for (var s = c5.children, r5 = s.length, g5 = 0, b6 = 0; --r5 >= 0; ) {
            var S2 = s[r5];
            S2.hierNode.prelim += g5, S2.hierNode.modifier += g5, b6 += S2.hierNode.change, g5 += S2.hierNode.shift + b6;
          }
        }
        function Ozn(c5, s, r5, g5) {
          if (s) {
            for (var b6 = c5, S2 = c5, A2 = S2.parentNode.children[0], k2 = s, R6 = b6.hierNode.modifier, B3 = S2.hierNode.modifier, G3 = A2.hierNode.modifier, Z3 = k2.hierNode.modifier; k2 = _Ht(k2), S2 = xHt(S2), k2 && S2; ) {
              b6 = _Ht(b6), A2 = xHt(A2), b6.hierNode.ancestor = c5;
              var X3 = k2.hierNode.prelim + Z3 - S2.hierNode.prelim - B3 + g5(k2, S2);
              X3 > 0 && (Nzn(Rzn(k2, c5, r5), c5, X3), B3 += X3, R6 += X3), Z3 += k2.hierNode.modifier, B3 += S2.hierNode.modifier, R6 += b6.hierNode.modifier, G3 += A2.hierNode.modifier;
            }
            k2 && !_Ht(b6) && (b6.hierNode.thread = k2, b6.hierNode.modifier += Z3 - R6), S2 && !xHt(A2) && (A2.hierNode.thread = S2, A2.hierNode.modifier += B3 - G3, r5 = c5);
          }
          return r5;
        }
        function _Ht(c5) {
          var s = c5.children;
          return s.length && c5.isExpand ? s[s.length - 1] : c5.hierNode.thread;
        }
        function xHt(c5) {
          var s = c5.children;
          return s.length && c5.isExpand ? s[0] : c5.hierNode.thread;
        }
        function Rzn(c5, s, r5) {
          return c5.hierNode.ancestor.parentNode === s.parentNode ? c5.hierNode.ancestor : r5;
        }
        function Nzn(c5, s, r5) {
          var g5 = r5 / (s.hierNode.i - c5.hierNode.i);
          s.hierNode.change -= g5, s.hierNode.shift += r5, s.hierNode.modifier += r5, s.hierNode.prelim += r5, c5.hierNode.change += g5;
        }
        function Fzn(c5, s) {
          return c5.parentNode === s.parentNode ? 1 : 2;
        }
        var Vzn = function() {
          function c5() {
            this.parentPoint = [], this.childPoints = [];
          }
          return c5;
        }(), Bzn = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new Vzn();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.childPoints, S2 = b6.length, A2 = g5.parentPoint, k2 = b6[0], R6 = b6[S2 - 1];
            if (S2 === 1) {
              r5.moveTo(A2[0], A2[1]), r5.lineTo(k2[0], k2[1]);
              return;
            }
            var B3 = g5.orient, G3 = B3 === "TB" || B3 === "BT" ? 0 : 1, Z3 = 1 - G3, X3 = $o(g5.forkPosition, 1), tt = [];
            tt[G3] = A2[G3], tt[Z3] = A2[Z3] + (R6[Z3] - A2[Z3]) * X3, r5.moveTo(A2[0], A2[1]), r5.lineTo(tt[0], tt[1]), r5.moveTo(k2[0], k2[1]), tt[G3] = k2[G3], r5.lineTo(tt[0], tt[1]), tt[G3] = R6[G3], r5.lineTo(tt[0], tt[1]), r5.lineTo(R6[0], R6[1]);
            for (var it = 1; it < S2 - 1; it++) {
              var pt = b6[it];
              r5.moveTo(pt[0], pt[1]), tt[G3] = pt[G3], r5.lineTo(tt[0], tt[1]);
            }
          }, s;
        }(Tc2), zzn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._mainGroup = new nu(), r5;
          }
          return s.prototype.init = function(r5, g5) {
            this._controller = new Hct(g5.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
          }, s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = r5.layoutInfo, k2 = this._mainGroup, R6 = r5.get("layout");
            R6 === "radial" ? (k2.x = A2.x + A2.width / 2, k2.y = A2.y + A2.height / 2) : (k2.x = A2.x, k2.y = A2.y), this._updateViewCoordSys(r5), this._updateController(r5, g5, b6);
            var B3 = this._data;
            S2.diff(B3).add(function(G3) {
              Eke(S2, G3) && kke(S2, G3, null, k2, r5);
            }).update(function(G3, Z3) {
              var X3 = B3.getItemGraphicEl(Z3);
              if (!Eke(S2, G3)) {
                X3 && Oke(B3, Z3, X3, k2, r5);
                return;
              }
              kke(S2, G3, X3, k2, r5);
            }).remove(function(G3) {
              var Z3 = B3.getItemGraphicEl(G3);
              Z3 && Oke(B3, G3, Z3, k2, r5);
            }).execute(), this._nodeScaleRatio = r5.get("nodeScaleRatio"), this._updateNodeAndLinkScale(r5), r5.get("expandAndCollapse") === true && S2.eachItemGraphicEl(function(G3, Z3) {
              G3.off("click").on("click", function() {
                b6.dispatchAction({ type: "treeExpandAndCollapse", seriesId: r5.id, dataIndex: Z3 });
              });
            }), this._data = S2;
          }, s.prototype._updateViewCoordSys = function(r5) {
            var g5 = r5.getData(), b6 = [];
            g5.each(function(G3) {
              var Z3 = g5.getItemLayout(G3);
              Z3 && !isNaN(Z3.x) && !isNaN(Z3.y) && b6.push([+Z3.x, +Z3.y]);
            });
            var S2 = [], A2 = [];
            PK(b6, S2, A2);
            var k2 = this._min, R6 = this._max;
            A2[0] - S2[0] === 0 && (S2[0] = k2 ? k2[0] : S2[0] - 1, A2[0] = R6 ? R6[0] : A2[0] + 1), A2[1] - S2[1] === 0 && (S2[1] = k2 ? k2[1] : S2[1] - 1, A2[1] = R6 ? R6[1] : A2[1] + 1);
            var B3 = r5.coordinateSystem = new qct();
            B3.zoomLimit = r5.get("scaleLimit"), B3.setBoundingRect(S2[0], S2[1], A2[0] - S2[0], A2[1] - S2[1]), B3.setCenter(r5.get("center")), B3.setZoom(r5.get("zoom")), this.group.attr({ x: B3.x, y: B3.y, scaleX: B3.scaleX, scaleY: B3.scaleY }), this._min = S2, this._max = A2;
          }, s.prototype._updateController = function(r5, g5, b6) {
            var S2 = this, A2 = this._controller, k2 = this._controllerHost, R6 = this.group;
            A2.setPointerChecker(function(B3, G3, Z3) {
              var X3 = R6.getBoundingRect();
              return X3.applyTransform(R6.transform), X3.contain(G3, Z3) && !XMt(B3, b6, r5);
            }), A2.enable(r5.get("roam")), k2.zoomLimit = r5.get("scaleLimit"), k2.zoom = r5.coordinateSystem.getZoom(), A2.off("pan").off("zoom").on("pan", function(B3) {
              pHt(k2, B3.dx, B3.dy), b6.dispatchAction({ seriesId: r5.id, type: "treeRoam", dx: B3.dx, dy: B3.dy });
            }).on("zoom", function(B3) {
              dHt(k2, B3.scale, B3.originX, B3.originY), b6.dispatchAction({ seriesId: r5.id, type: "treeRoam", zoom: B3.scale, originX: B3.originX, originY: B3.originY }), S2._updateNodeAndLinkScale(r5), b6.updateLabelLayout();
            });
          }, s.prototype._updateNodeAndLinkScale = function(r5) {
            var g5 = r5.getData(), b6 = this._getNodeGlobalScale(r5);
            g5.eachItemGraphicEl(function(S2, A2) {
              S2.setSymbolScale(b6);
            });
          }, s.prototype._getNodeGlobalScale = function(r5) {
            var g5 = r5.coordinateSystem;
            if (g5.type !== "view")
              return 1;
            var b6 = this._nodeScaleRatio, S2 = g5.scaleX || 1, A2 = g5.getZoom(), k2 = (A2 - 1) * b6 + 1;
            return k2 / S2;
          }, s.prototype.dispose = function() {
            this._controller && this._controller.dispose(), this._controllerHost = null;
          }, s.prototype.remove = function() {
            this._mainGroup.removeAll(), this._data = null;
          }, s.type = "tree", s;
        }(Ig2);
        function Eke(c5, s) {
          var r5 = c5.getItemLayout(s);
          return r5 && !isNaN(r5.x) && !isNaN(r5.y);
        }
        function kke(c5, s, r5, g5, b6) {
          var S2 = !r5, A2 = c5.tree.getNodeByDataIndex(s), k2 = A2.getModel(), R6 = A2.getVisual("style").fill, B3 = A2.isExpand === false && A2.children.length !== 0 ? R6 : "#fff", G3 = c5.tree.root, Z3 = A2.parentNode === G3 ? A2 : A2.parentNode || A2, X3 = c5.getItemGraphicEl(Z3.dataIndex), tt = Z3.getLayout(), it = X3 ? { x: X3.__oldX, y: X3.__oldY, rawX: X3.__radialOldRawX, rawY: X3.__radialOldRawY } : tt, pt = A2.getLayout();
          S2 ? (r5 = new Fct(c5, s, null, { symbolInnerColor: B3, useNameLabel: true }), r5.x = it.x, r5.y = it.y) : r5.updateData(c5, s, null, { symbolInnerColor: B3, useNameLabel: true }), r5.__radialOldRawX = r5.__radialRawX, r5.__radialOldRawY = r5.__radialRawY, r5.__radialRawX = pt.rawX, r5.__radialRawY = pt.rawY, g5.add(r5), c5.setItemGraphicEl(s, r5), r5.__oldX = r5.x, r5.__oldY = r5.y, Qf2(r5, { x: pt.x, y: pt.y }, b6);
          var mt = r5.getSymbolPath();
          if (b6.get("layout") === "radial") {
            var Mt = G3.children[0], kt = Mt.getLayout(), Gt = Mt.children.length, Ot = void 0, ce2 = void 0;
            if (pt.x === kt.x && A2.isExpand === true) {
              var ae2 = { x: (Mt.children[0].getLayout().x + Mt.children[Gt - 1].getLayout().x) / 2, y: (Mt.children[0].getLayout().y + Mt.children[Gt - 1].getLayout().y) / 2 };
              Ot = Math.atan2(ae2.y - kt.y, ae2.x - kt.x), Ot < 0 && (Ot = Math.PI * 2 + Ot), ce2 = ae2.x < kt.x, ce2 && (Ot = Ot - Math.PI);
            } else
              Ot = Math.atan2(pt.y - kt.y, pt.x - kt.x), Ot < 0 && (Ot = Math.PI * 2 + Ot), A2.children.length === 0 || A2.children.length !== 0 && A2.isExpand === false ? (ce2 = pt.x < kt.x, ce2 && (Ot = Ot - Math.PI)) : (ce2 = pt.x > kt.x, ce2 || (Ot = Ot - Math.PI));
            var de2 = ce2 ? "left" : "right", we2 = k2.getModel("label"), Se2 = we2.get("rotate"), Oe2 = Se2 * (Math.PI / 180), je2 = mt.getTextContent();
            je2 && (mt.setTextConfig({ position: we2.get("position") || de2, rotation: Se2 == null ? -Ot : Oe2, origin: "center" }), je2.setStyle("verticalAlign", "middle"));
          }
          var rn = k2.get(["emphasis", "focus"]), qe2 = rn === "ancestor" ? A2.getAncestorsIndices() : rn === "descendant" ? A2.getDescendantIndices() : null;
          qe2 && (Pl(r5).focus = qe2), jzn(b6, A2, G3, r5, it, tt, pt, g5), r5.__edge && (r5.onHoverStateChange = function(An) {
            if (An !== "blur") {
              var jn = A2.parentNode && c5.getItemGraphicEl(A2.parentNode.dataIndex);
              jn && jn.hoverState === xv || T3(r5.__edge, An);
            }
          });
        }
        function jzn(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6 = s.getModel(), B3 = c5.get("edgeShape"), G3 = c5.get("layout"), Z3 = c5.getOrient(), X3 = c5.get(["lineStyle", "curveness"]), tt = c5.get("edgeForkPosition"), it = R6.getModel("lineStyle").getLineStyle(), pt = g5.__edge;
          if (B3 === "curve")
            s.parentNode && s.parentNode !== r5 && (pt || (pt = g5.__edge = new KK({ shape: wHt(G3, Z3, X3, b6, b6) })), Qf2(pt, { shape: wHt(G3, Z3, X3, S2, A2) }, c5));
          else if (B3 === "polyline" && G3 === "orthogonal" && s !== r5 && s.children && s.children.length !== 0 && s.isExpand === true) {
            for (var mt = s.children, Mt = [], kt = 0; kt < mt.length; kt++) {
              var Gt = mt[kt].getLayout();
              Mt.push([Gt.x, Gt.y]);
            }
            pt || (pt = g5.__edge = new Bzn({ shape: { parentPoint: [A2.x, A2.y], childPoints: [[A2.x, A2.y]], orient: Z3, forkPosition: tt } })), Qf2(pt, { shape: { parentPoint: [A2.x, A2.y], childPoints: Mt } }, c5);
          }
          pt && (pt.useStyle(Cl({ strokeNoScale: true, fill: null }, it)), z1(pt, R6, "lineStyle"), MM(pt), k2.add(pt));
        }
        function Pke(c5, s, r5, g5, b6) {
          var S2 = s.tree.root, A2 = Lke(S2, c5), k2 = A2.source, R6 = A2.sourceLayout, B3 = s.getItemGraphicEl(c5.dataIndex);
          if (B3) {
            var G3 = s.getItemGraphicEl(k2.dataIndex), Z3 = G3.__edge, X3 = B3.__edge || (k2.isExpand === false || k2.children.length === 1 ? Z3 : void 0), tt = g5.get("edgeShape"), it = g5.get("layout"), pt = g5.get("orient"), mt = g5.get(["lineStyle", "curveness"]);
            X3 && (tt === "curve" ? A3(X3, { shape: wHt(it, pt, mt, R6, R6), style: { opacity: 0 } }, g5, { cb: function() {
              r5.remove(X3);
            }, removeOpt: b6 }) : tt === "polyline" && g5.get("layout") === "orthogonal" && A3(X3, { shape: { parentPoint: [R6.x, R6.y], childPoints: [[R6.x, R6.y]] }, style: { opacity: 0 } }, g5, { cb: function() {
              r5.remove(X3);
            }, removeOpt: b6 }));
          }
        }
        function Lke(c5, s) {
          for (var r5 = s.parentNode === c5 ? s : s.parentNode || s, g5; g5 = r5.getLayout(), g5 == null; )
            r5 = r5.parentNode === c5 ? r5 : r5.parentNode || r5;
          return { source: r5, sourceLayout: g5 };
        }
        function Oke(c5, s, r5, g5, b6) {
          var S2 = c5.tree.getNodeByDataIndex(s), A2 = c5.tree.root, k2 = Lke(A2, S2).sourceLayout, R6 = { duration: b6.get("animationDurationUpdate"), easing: b6.get("animationEasingUpdate") };
          A3(r5, { x: k2.x + 1, y: k2.y + 1 }, b6, { cb: function() {
            g5.remove(r5), c5.setItemGraphicEl(s, null);
          }, removeOpt: R6 }), r5.fadeOut(null, c5.hostModel, { fadeLabel: true, animation: R6 }), S2.children.forEach(function(B3) {
            Pke(B3, c5, g5, b6, R6);
          }), Pke(S2, c5, g5, b6, R6);
        }
        function wHt(c5, s, r5, g5, b6) {
          var S2, A2, k2, R6, B3, G3, Z3, X3;
          if (c5 === "radial") {
            B3 = g5.rawX, Z3 = g5.rawY, G3 = b6.rawX, X3 = b6.rawY;
            var tt = Zct(B3, Z3), it = Zct(B3, Z3 + (X3 - Z3) * r5), pt = Zct(G3, X3 + (Z3 - X3) * r5), mt = Zct(G3, X3);
            return { x1: tt.x || 0, y1: tt.y || 0, x2: mt.x || 0, y2: mt.y || 0, cpx1: it.x || 0, cpy1: it.y || 0, cpx2: pt.x || 0, cpy2: pt.y || 0 };
          } else
            B3 = g5.x, Z3 = g5.y, G3 = b6.x, X3 = b6.y, (s === "LR" || s === "RL") && (S2 = B3 + (G3 - B3) * r5, A2 = Z3, k2 = G3 + (B3 - G3) * r5, R6 = X3), (s === "TB" || s === "BT") && (S2 = B3, A2 = Z3 + (X3 - Z3) * r5, k2 = G3, R6 = X3 + (Z3 - X3) * r5);
          return { x1: B3, y1: Z3, x2: G3, y2: X3, cpx1: S2, cpy1: A2, cpx2: k2, cpy2: R6 };
        }
        var Wzn = zzn, rD = Df2();
        function Rke(c5) {
          var s = c5.mainData, r5 = c5.datas;
          r5 || (r5 = { main: s }, c5.datasAttr = { main: "data" }), c5.datas = c5.mainData = null, Nke(s, r5, c5), Ye2(r5, function(g5) {
            Ye2(s.TRANSFERABLE_METHODS, function(b6) {
              g5.wrapMethod(b6, Au(Gzn, c5));
            });
          }), s.wrapMethod("cloneShallow", Au(Uzn, c5)), Ye2(s.CHANGABLE_METHODS, function(g5) {
            s.wrapMethod(g5, Au(Hzn, c5));
          }), lx(r5[s.dataType] === s);
        }
        function Gzn(c5, s) {
          if ($zn(this)) {
            var r5 = sa2({}, rD(this).datas);
            r5[this.dataType] = s, Nke(s, r5, c5);
          } else
            SHt(s, this.dataType, rD(this).mainData, c5);
          return s;
        }
        function Hzn(c5, s) {
          return c5.struct && c5.struct.update(), s;
        }
        function Uzn(c5, s) {
          return Ye2(rD(s).datas, function(r5, g5) {
            r5 !== s && SHt(r5.cloneShallow(), g5, s, c5);
          }), s;
        }
        function qzn(c5) {
          var s = rD(this).mainData;
          return c5 == null || s == null ? s : rD(s).datas[c5];
        }
        function Zzn() {
          var c5 = rD(this).mainData;
          return c5 == null ? [{ data: c5 }] : Ha2(nf2(rD(c5).datas), function(s) {
            return { type: s, data: rD(c5).datas[s] };
          });
        }
        function $zn(c5) {
          return rD(c5).mainData === c5;
        }
        function Nke(c5, s, r5) {
          rD(c5).datas = {}, Ye2(s, function(g5, b6) {
            SHt(g5, b6, c5, r5);
          });
        }
        function SHt(c5, s, r5, g5) {
          rD(r5).datas[s] = c5, rD(c5).mainData = r5, c5.dataType = s, g5.struct && (c5[g5.structAttr] = g5.struct, g5.struct[g5.datasAttr[s]] = c5), c5.getLinkedData = qzn, c5.getLinkedDataAll = Zzn;
        }
        var Yzn = function() {
          function c5(s, r5) {
            this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = s || "", this.hostTree = r5;
          }
          return c5.prototype.isRemoved = function() {
            return this.dataIndex < 0;
          }, c5.prototype.eachNode = function(s, r5, g5) {
            Tl(s) && (g5 = r5, r5 = s, s = null), s = s || {}, gs(s) && (s = { order: s });
            var b6 = s.order || "preorder", S2 = this[s.attr || "children"], A2;
            b6 === "preorder" && (A2 = r5.call(g5, this));
            for (var k2 = 0; !A2 && k2 < S2.length; k2++)
              S2[k2].eachNode(s, r5, g5);
            b6 === "postorder" && r5.call(g5, this);
          }, c5.prototype.updateDepthAndHeight = function(s) {
            var r5 = 0;
            this.depth = s;
            for (var g5 = 0; g5 < this.children.length; g5++) {
              var b6 = this.children[g5];
              b6.updateDepthAndHeight(s + 1), b6.height > r5 && (r5 = b6.height);
            }
            this.height = r5 + 1;
          }, c5.prototype.getNodeById = function(s) {
            if (this.getId() === s)
              return this;
            for (var r5 = 0, g5 = this.children, b6 = g5.length; r5 < b6; r5++) {
              var S2 = g5[r5].getNodeById(s);
              if (S2)
                return S2;
            }
          }, c5.prototype.contains = function(s) {
            if (s === this)
              return true;
            for (var r5 = 0, g5 = this.children, b6 = g5.length; r5 < b6; r5++) {
              var S2 = g5[r5].contains(s);
              if (S2)
                return S2;
            }
          }, c5.prototype.getAncestors = function(s) {
            for (var r5 = [], g5 = s ? this : this.parentNode; g5; )
              r5.push(g5), g5 = g5.parentNode;
            return r5.reverse(), r5;
          }, c5.prototype.getAncestorsIndices = function() {
            for (var s = [], r5 = this; r5; )
              s.push(r5.dataIndex), r5 = r5.parentNode;
            return s.reverse(), s;
          }, c5.prototype.getDescendantIndices = function() {
            var s = [];
            return this.eachNode(function(r5) {
              s.push(r5.dataIndex);
            }), s;
          }, c5.prototype.getValue = function(s) {
            var r5 = this.hostTree.data;
            return r5.getStore().get(r5.getDimensionIndex(s || "value"), this.dataIndex);
          }, c5.prototype.setLayout = function(s, r5) {
            this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, s, r5);
          }, c5.prototype.getLayout = function() {
            return this.hostTree.data.getItemLayout(this.dataIndex);
          }, c5.prototype.getModel = function(s) {
            if (!(this.dataIndex < 0)) {
              var r5 = this.hostTree, g5 = r5.data.getItemModel(this.dataIndex);
              return g5.getModel(s);
            }
          }, c5.prototype.getLevelModel = function() {
            return (this.hostTree.levelModels || [])[this.depth];
          }, c5.prototype.setVisual = function(s, r5) {
            this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, s, r5);
          }, c5.prototype.getVisual = function(s) {
            return this.hostTree.data.getItemVisual(this.dataIndex, s);
          }, c5.prototype.getRawIndex = function() {
            return this.hostTree.data.getRawIndex(this.dataIndex);
          }, c5.prototype.getId = function() {
            return this.hostTree.data.getId(this.dataIndex);
          }, c5.prototype.getChildIndex = function() {
            if (this.parentNode) {
              for (var s = this.parentNode.children, r5 = 0; r5 < s.length; ++r5)
                if (s[r5] === this)
                  return r5;
              return -1;
            }
            return -1;
          }, c5.prototype.isAncestorOf = function(s) {
            for (var r5 = s.parentNode; r5; ) {
              if (r5 === this)
                return true;
              r5 = r5.parentNode;
            }
            return false;
          }, c5.prototype.isDescendantOf = function(s) {
            return s !== this && s.isAncestorOf(this);
          }, c5;
        }(), Kzn = function() {
          function c5(s) {
            this.type = "tree", this._nodes = [], this.hostModel = s;
          }
          return c5.prototype.eachNode = function(s, r5, g5) {
            this.root.eachNode(s, r5, g5);
          }, c5.prototype.getNodeByDataIndex = function(s) {
            var r5 = this.data.getRawIndex(s);
            return this._nodes[r5];
          }, c5.prototype.getNodeById = function(s) {
            return this.root.getNodeById(s);
          }, c5.prototype.update = function() {
            for (var s = this.data, r5 = this._nodes, g5 = 0, b6 = r5.length; g5 < b6; g5++)
              r5[g5].dataIndex = -1;
            for (var g5 = 0, b6 = s.count(); g5 < b6; g5++)
              r5[s.getRawIndex(g5)].dataIndex = g5;
          }, c5.prototype.clearLayouts = function() {
            this.data.clearItemLayouts();
          }, c5.createTree = function(s, r5, g5) {
            var b6 = new c5(r5), S2 = [], A2 = 1;
            k2(s);
            function k2(G3, Z3) {
              var X3 = G3.value;
              A2 = Math.max(A2, ja2(X3) ? X3.length : 1), S2.push(G3);
              var tt = new Yzn(Q0(G3.name, ""), b6);
              Z3 ? Xzn(tt, Z3) : b6.root = tt, b6._nodes.push(tt);
              var it = G3.children;
              if (it)
                for (var pt = 0; pt < it.length; pt++)
                  k2(it[pt], tt);
            }
            b6.root.updateDepthAndHeight(0);
            var R6 = Act(S2, { coordDimensions: ["value"], dimensionsCount: A2 }).dimensions, B3 = new m22(R6, r5);
            return B3.initData(S2), g5 && g5(B3), Rke({ mainData: B3, struct: b6, structAttr: "tree" }), b6.update(), b6;
          }, c5;
        }();
        function Xzn(c5, s) {
          var r5 = s.children;
          c5.parentNode !== s && (r5.push(c5), c5.parentNode = s);
        }
        var MHt = Kzn;
        function $ct(c5, s, r5) {
          if (c5 && Lu(s, c5.type) >= 0) {
            var g5 = r5.getData().tree.root, b6 = c5.targetNode;
            if (gs(b6) && (b6 = g5.getNodeById(b6)), b6 && g5.contains(b6))
              return { node: b6 };
            var S2 = c5.targetNodeId;
            if (S2 != null && (b6 = g5.getNodeById(S2)))
              return { node: b6 };
          }
        }
        function Fke(c5) {
          for (var s = []; c5; )
            c5 = c5.parentNode, c5 && s.push(c5);
          return s.reverse();
        }
        function CHt(c5, s) {
          var r5 = Fke(c5);
          return Lu(r5, s) >= 0;
        }
        function nCt(c5, s) {
          for (var r5 = []; c5; ) {
            var g5 = c5.dataIndex;
            r5.push({ name: c5.name, dataIndex: g5, value: s.getRawValue(g5) }), c5 = c5.parentNode;
          }
          return r5.reverse(), r5;
        }
        var Qzn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.hasSymbolVisual = true, r5.ignoreStyleOnData = true, r5;
          }
          return s.prototype.getInitialData = function(r5) {
            var g5 = { name: r5.name, children: r5.data }, b6 = r5.leaves || {}, S2 = new Ag2(b6, this, this.ecModel), A2 = MHt.createTree(g5, this, k2);
            function k2(Z3) {
              Z3.wrapMethod("getItemModel", function(X3, tt) {
                var it = A2.getNodeByDataIndex(tt);
                return it && it.children.length && it.isExpand || (X3.parentModel = S2), X3;
              });
            }
            var R6 = 0;
            A2.eachNode("preorder", function(Z3) {
              Z3.depth > R6 && (R6 = Z3.depth);
            });
            var B3 = r5.expandAndCollapse, G3 = B3 && r5.initialTreeDepth >= 0 ? r5.initialTreeDepth : R6;
            return A2.root.eachNode("preorder", function(Z3) {
              var X3 = Z3.hostTree.data.getRawDataItem(Z3.dataIndex);
              Z3.isExpand = X3 && X3.collapsed != null ? !X3.collapsed : Z3.depth <= G3;
            }), A2.data;
          }, s.prototype.getOrient = function() {
            var r5 = this.get("orient");
            return r5 === "horizontal" ? r5 = "LR" : r5 === "vertical" && (r5 = "TB"), r5;
          }, s.prototype.setZoom = function(r5) {
            this.option.zoom = r5;
          }, s.prototype.setCenter = function(r5) {
            this.option.center = r5;
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            for (var S2 = this.getData().tree, A2 = S2.root.children[0], k2 = S2.getNodeByDataIndex(r5), R6 = k2.getValue(), B3 = k2.name; k2 && k2 !== A2; )
              B3 = k2.parentNode.name + "." + B3, k2 = k2.parentNode;
            return W1("nameValue", { name: B3, value: R6, noValue: isNaN(R6) || R6 == null });
          }, s.prototype.getDataParams = function(r5) {
            var g5 = c5.prototype.getDataParams.apply(this, arguments), b6 = this.getData().tree.getNodeByDataIndex(r5);
            return g5.treeAncestors = nCt(b6, this), g5;
          }, s.type = "series.tree", s.layoutMode = "box", s.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, s;
        }(zv), Jzn = Qzn;
        function tjn(c5, s, r5) {
          for (var g5 = [c5], b6 = [], S2; S2 = g5.pop(); )
            if (b6.push(S2), S2.isExpand) {
              var A2 = S2.children;
              if (A2.length)
                for (var k2 = 0; k2 < A2.length; k2++)
                  g5.push(A2[k2]);
            }
          for (; S2 = b6.pop(); )
            s(S2, r5);
        }
        function Yct(c5, s) {
          for (var r5 = [c5], g5; g5 = r5.pop(); )
            if (s(g5), g5.isExpand) {
              var b6 = g5.children;
              if (b6.length)
                for (var S2 = b6.length - 1; S2 >= 0; S2--)
                  r5.push(b6[S2]);
            }
        }
        function ejn(c5, s) {
          c5.eachSeriesByType("tree", function(r5) {
            njn(r5, s);
          });
        }
        function njn(c5, s) {
          var r5 = Pzn(c5, s);
          c5.layoutInfo = r5;
          var g5 = c5.get("layout"), b6 = 0, S2 = 0, A2 = null;
          g5 === "radial" ? (b6 = 2 * Math.PI, S2 = Math.min(r5.height, r5.width) / 2, A2 = Dke(function(Gt, Ot) {
            return (Gt.parentNode === Ot.parentNode ? 1 : 2) / Gt.depth;
          })) : (b6 = r5.width, S2 = r5.height, A2 = Dke());
          var k2 = c5.getData().tree.root, R6 = k2.children[0];
          if (R6) {
            Dzn(k2), tjn(R6, Ezn, A2), k2.hierNode.modifier = -R6.hierNode.prelim, Yct(R6, kzn);
            var B3 = R6, G3 = R6, Z3 = R6;
            Yct(R6, function(Gt) {
              var Ot = Gt.getLayout().x;
              Ot < B3.getLayout().x && (B3 = Gt), Ot > G3.getLayout().x && (G3 = Gt), Gt.depth > Z3.depth && (Z3 = Gt);
            });
            var X3 = B3 === G3 ? 1 : A2(B3, G3) / 2, tt = X3 - B3.getLayout().x, it = 0, pt = 0, mt = 0, Mt = 0;
            if (g5 === "radial")
              it = b6 / (G3.getLayout().x + X3 + tt), pt = S2 / (Z3.depth - 1 || 1), Yct(R6, function(Gt) {
                mt = (Gt.getLayout().x + tt) * it, Mt = (Gt.depth - 1) * pt;
                var Ot = Zct(mt, Mt);
                Gt.setLayout({ x: Ot.x, y: Ot.y, rawX: mt, rawY: Mt }, true);
              });
            else {
              var kt = c5.getOrient();
              kt === "RL" || kt === "LR" ? (pt = S2 / (G3.getLayout().x + X3 + tt), it = b6 / (Z3.depth - 1 || 1), Yct(R6, function(Gt) {
                Mt = (Gt.getLayout().x + tt) * pt, mt = kt === "LR" ? (Gt.depth - 1) * it : b6 - (Gt.depth - 1) * it, Gt.setLayout({ x: mt, y: Mt }, true);
              })) : (kt === "TB" || kt === "BT") && (it = b6 / (G3.getLayout().x + X3 + tt), pt = S2 / (Z3.depth - 1 || 1), Yct(R6, function(Gt) {
                mt = (Gt.getLayout().x + tt) * it, Mt = kt === "TB" ? (Gt.depth - 1) * pt : S2 - (Gt.depth - 1) * pt, Gt.setLayout({ x: mt, y: Mt }, true);
              }));
            }
          }
        }
        function rjn(c5) {
          c5.eachSeriesByType("tree", function(s) {
            var r5 = s.getData(), g5 = r5.tree;
            g5.eachNode(function(b6) {
              var S2 = b6.getModel(), A2 = S2.getModel("itemStyle").getItemStyle(), k2 = r5.ensureUniqueItemVisual(b6.dataIndex, "style");
              sa2(k2, A2);
            });
          });
        }
        function ijn(c5) {
          c5.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(s, r5) {
            r5.eachComponent({ mainType: "series", subType: "tree", query: s }, function(g5) {
              var b6 = s.dataIndex, S2 = g5.getData().tree, A2 = S2.getNodeByDataIndex(b6);
              A2.isExpand = !A2.isExpand;
            });
          }), c5.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(s, r5) {
            r5.eachComponent({ mainType: "series", subType: "tree", query: s }, function(g5) {
              var b6 = g5.coordinateSystem, S2 = bHt(b6, s);
              g5.setCenter && g5.setCenter(S2.center), g5.setZoom && g5.setZoom(S2.zoom);
            });
          });
        }
        function ajn(c5) {
          c5.registerChartView(Wzn), c5.registerSeriesModel(Jzn), c5.registerLayout(ejn), c5.registerVisual(rjn), ijn(c5);
        }
        var Vke = ["treemapZoomToNode", "treemapRender", "treemapMove"];
        function ojn(c5) {
          for (var s = 0; s < Vke.length; s++)
            c5.registerAction({ type: Vke[s], update: "updateView" }, I0);
          c5.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(r5, g5) {
            g5.eachComponent({ mainType: "series", subType: "treemap", query: r5 }, b6);
            function b6(S2, A2) {
              var k2 = ["treemapZoomToNode", "treemapRootToNode"], R6 = $ct(r5, k2, S2);
              if (R6) {
                var B3 = S2.getViewRoot();
                B3 && (r5.direction = CHt(B3, R6.node) ? "rollUp" : "drillDown"), S2.resetViewRoot(R6.node);
              }
            }
          });
        }
        function Bke(c5) {
          var s = c5.getData(), r5 = s.tree, g5 = {};
          r5.eachNode(function(b6) {
            for (var S2 = b6; S2 && S2.depth > 1; )
              S2 = S2.parentNode;
            var A2 = PWt(c5.ecModel, S2.name || S2.dataIndex + "", g5);
            b6.setVisual("decal", A2);
          });
        }
        var sjn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.preventUsingHoverLayer = true, r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            var b6 = { name: r5.name, children: r5.data };
            zke(b6);
            var S2 = r5.levels || [], A2 = this.designatedVisualItemStyle = {}, k2 = new Ag2({ itemStyle: A2 }, this, g5);
            S2 = r5.levels = ljn(S2, g5);
            var R6 = Ha2(S2 || [], function(Z3) {
              return new Ag2(Z3, k2, g5);
            }, this), B3 = MHt.createTree(b6, this, G3);
            function G3(Z3) {
              Z3.wrapMethod("getItemModel", function(X3, tt) {
                var it = B3.getNodeByDataIndex(tt), pt = it ? R6[it.depth] : null;
                return X3.parentModel = pt || k2, X3;
              });
            }
            return B3.data;
          }, s.prototype.optionUpdated = function() {
            this.resetViewRoot();
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            var S2 = this.getData(), A2 = this.getRawValue(r5), k2 = S2.getName(r5);
            return W1("nameValue", { name: k2, value: A2 });
          }, s.prototype.getDataParams = function(r5) {
            var g5 = c5.prototype.getDataParams.apply(this, arguments), b6 = this.getData().tree.getNodeByDataIndex(r5);
            return g5.treeAncestors = nCt(b6, this), g5.treePathInfo = g5.treeAncestors, g5;
          }, s.prototype.setLayoutInfo = function(r5) {
            this.layoutInfo = this.layoutInfo || {}, sa2(this.layoutInfo, r5);
          }, s.prototype.mapIdToIndex = function(r5) {
            var g5 = this._idIndexMap;
            g5 || (g5 = this._idIndexMap = Ps(), this._idIndexMapCount = 0);
            var b6 = g5.get(r5);
            return b6 == null && g5.set(r5, b6 = this._idIndexMapCount++), b6;
          }, s.prototype.getViewRoot = function() {
            return this._viewRoot;
          }, s.prototype.resetViewRoot = function(r5) {
            r5 ? this._viewRoot = r5 : r5 = this._viewRoot;
            var g5 = this.getRawData().tree.root;
            (!r5 || r5 !== g5 && !g5.contains(r5)) && (this._viewRoot = g5);
          }, s.prototype.enableAriaDecal = function() {
            Bke(this);
          }, s.type = "series.treemap", s.layoutMode = "box", s.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, s;
        }(zv);
        function zke(c5) {
          var s = 0;
          Ye2(c5.children, function(g5) {
            zke(g5);
            var b6 = g5.value;
            ja2(b6) && (b6 = b6[0]), s += b6;
          });
          var r5 = c5.value;
          ja2(r5) && (r5 = r5[0]), (r5 == null || isNaN(r5)) && (r5 = s), r5 < 0 && (r5 = 0), ja2(c5.value) ? c5.value[0] = r5 : c5.value = r5;
        }
        function ljn(c5, s) {
          var r5 = xp(s.get("color")), g5 = xp(s.get(["aria", "decal", "decals"]));
          if (r5) {
            c5 = c5 || [];
            var b6, S2;
            Ye2(c5, function(k2) {
              var R6 = new Ag2(k2), B3 = R6.get("color"), G3 = R6.get("decal");
              (R6.get(["itemStyle", "color"]) || B3 && B3 !== "none") && (b6 = true), (R6.get(["itemStyle", "decal"]) || G3 && G3 !== "none") && (S2 = true);
            });
            var A2 = c5[0] || (c5[0] = {});
            return b6 || (A2.color = r5.slice()), !S2 && g5 && (A2.decal = g5.slice()), c5;
          }
        }
        var ujn = sjn, cjn = 8, jke = 8, THt = 5, fjn = function() {
          function c5(s) {
            this.group = new nu(), s.add(this.group);
          }
          return c5.prototype.render = function(s, r5, g5, b6) {
            var S2 = s.getModel("breadcrumb"), A2 = this.group;
            if (A2.removeAll(), !(!S2.get("show") || !g5)) {
              var k2 = S2.getModel("itemStyle"), R6 = k2.getModel("textStyle"), B3 = { pos: { left: S2.get("left"), right: S2.get("right"), top: S2.get("top"), bottom: S2.get("bottom") }, box: { width: r5.getWidth(), height: r5.getHeight() }, emptyItemWidth: S2.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
              this._prepare(g5, B3, R6), this._renderContent(s, B3, k2, R6, b6), eMt(A2, B3.pos, B3.box);
            }
          }, c5.prototype._prepare = function(s, r5, g5) {
            for (var b6 = s; b6; b6 = b6.parentNode) {
              var S2 = Q0(b6.getModel().get("name"), ""), A2 = g5.getTextRect(S2), k2 = Math.max(A2.width + cjn * 2, r5.emptyItemWidth);
              r5.totalWidth += k2 + jke, r5.renderList.push({ node: b6, text: S2, width: k2 });
            }
          }, c5.prototype._renderContent = function(s, r5, g5, b6, S2) {
            for (var A2 = 0, k2 = r5.emptyItemWidth, R6 = s.get(["breadcrumb", "height"]), B3 = _6n(r5.pos, r5.box), G3 = r5.totalWidth, Z3 = r5.renderList, X3 = Z3.length - 1; X3 >= 0; X3--) {
              var tt = Z3[X3], it = tt.node, pt = tt.width, mt = tt.text;
              G3 > B3.width && (G3 -= pt - k2, pt = k2, mt = null);
              var Mt = new Gb2({ shape: { points: hjn(A2, 0, pt, R6, X3 === Z3.length - 1, X3 === 0) }, style: Cl(g5.getItemStyle(), { lineJoin: "bevel" }), textContent: new hh2({ style: { text: mt, fill: b6.getTextColor(), font: b6.getFont() } }), textConfig: { position: "inside" }, z2: j8 * 1e4, onclick: Au(S2, it) });
              Mt.disableLabelAnimation = true, this.group.add(Mt), pjn(Mt, s, it), A2 += pt + jke;
            }
          }, c5.prototype.remove = function() {
            this.group.removeAll();
          }, c5;
        }();
        function hjn(c5, s, r5, g5, b6, S2) {
          var A2 = [[b6 ? c5 : c5 - THt, s], [c5 + r5, s], [c5 + r5, s + g5], [b6 ? c5 : c5 - THt, s + g5]];
          return !S2 && A2.splice(2, 0, [c5 + r5 + THt, s + g5 / 2]), !b6 && A2.push([c5, s + g5 / 2]), A2;
        }
        function pjn(c5, s, r5) {
          Pl(c5).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: s.componentIndex, seriesIndex: s.seriesIndex, seriesName: s.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: r5 && r5.dataIndex, name: r5 && r5.name }, treePathInfo: r5 && nCt(r5, s) };
        }
        var djn = fjn, gjn = function() {
          function c5() {
            this._storage = [], this._elExistsMap = {};
          }
          return c5.prototype.add = function(s, r5, g5, b6, S2) {
            return this._elExistsMap[s.id] ? false : (this._elExistsMap[s.id] = true, this._storage.push({ el: s, target: r5, duration: g5, delay: b6, easing: S2 }), true);
          }, c5.prototype.finished = function(s) {
            return this._finishedCallback = s, this;
          }, c5.prototype.start = function() {
            for (var s = this, r5 = this._storage.length, g5 = function() {
              r5--, r5 <= 0 && (s._storage.length = 0, s._elExistsMap = {}, s._finishedCallback && s._finishedCallback());
            }, b6 = 0, S2 = this._storage.length; b6 < S2; b6++) {
              var A2 = this._storage[b6];
              A2.el.animateTo(A2.target, { duration: A2.duration, delay: A2.delay, easing: A2.easing, setToFinal: true, done: g5, aborted: g5 });
            }
            return this;
          }, c5;
        }();
        function vjn() {
          return new gjn();
        }
        var AHt = nu, Wke = zf2, Gke = 3, Hke = "label", Uke = "upperLabel", yjn = j8 * 10, mjn = j8 * 2, bjn = j8 * 3, TW = aR([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), qke = function(c5) {
          var s = TW(c5);
          return s.stroke = s.fill = s.lineWidth = null, s;
        }, rCt = Df2(), _jn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._state = "ready", r5._storage = Kct(), r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            var A2 = g5.findComponents({ mainType: "series", subType: "treemap", query: S2 });
            if (!(Lu(A2, r5) < 0)) {
              this.seriesModel = r5, this.api = b6, this.ecModel = g5;
              var k2 = ["treemapZoomToNode", "treemapRootToNode"], R6 = $ct(S2, k2, r5), B3 = S2 && S2.type, G3 = r5.layoutInfo, Z3 = !this._oldTree, X3 = this._storage, tt = B3 === "treemapRootToNode" && R6 && X3 ? { rootNodeGroup: X3.nodeGroup[R6.node.getRawIndex()], direction: S2.direction } : null, it = this._giveContainerGroup(G3), pt = r5.get("animation"), mt = this._doRender(it, r5, tt);
              pt && !Z3 && (!B3 || B3 === "treemapZoomToNode" || B3 === "treemapRootToNode") ? this._doAnimation(it, mt, r5, tt) : mt.renderFinally(), this._resetController(b6), this._renderBreadcrumb(r5, b6, R6);
            }
          }, s.prototype._giveContainerGroup = function(r5) {
            var g5 = this._containerGroup;
            return g5 || (g5 = this._containerGroup = new AHt(), this._initEvents(g5), this.group.add(g5)), g5.x = r5.x, g5.y = r5.y, g5;
          }, s.prototype._doRender = function(r5, g5, b6) {
            var S2 = g5.getData().tree, A2 = this._oldTree, k2 = Kct(), R6 = Kct(), B3 = this._storage, G3 = [];
            function Z3(mt, Mt, kt, Gt) {
              return xjn(g5, R6, B3, b6, k2, G3, mt, Mt, kt, Gt);
            }
            tt(S2.root ? [S2.root] : [], A2 && A2.root ? [A2.root] : [], r5, S2 === A2 || !A2, 0);
            var X3 = it(B3);
            return this._oldTree = S2, this._storage = R6, { lastsForAnimation: k2, willDeleteEls: X3, renderFinally: pt };
            function tt(mt, Mt, kt, Gt, Ot) {
              Gt ? (Mt = mt, Ye2(mt, function(de2, we2) {
                !de2.isRemoved() && ae2(we2, we2);
              })) : new wR(Mt, mt, ce2, ce2).add(ae2).update(ae2).remove(Au(ae2, null)).execute();
              function ce2(de2) {
                return de2.getId();
              }
              function ae2(de2, we2) {
                var Se2 = de2 != null ? mt[de2] : null, Oe2 = we2 != null ? Mt[we2] : null, je2 = Z3(Se2, Oe2, kt, Ot);
                je2 && tt(Se2 && Se2.viewChildren || [], Oe2 && Oe2.viewChildren || [], je2, Gt, Ot + 1);
              }
            }
            function it(mt) {
              var Mt = Kct();
              return mt && Ye2(mt, function(kt, Gt) {
                var Ot = Mt[Gt];
                Ye2(kt, function(ce2) {
                  ce2 && (Ot.push(ce2), rCt(ce2).willDelete = true);
                });
              }), Mt;
            }
            function pt() {
              Ye2(X3, function(mt) {
                Ye2(mt, function(Mt) {
                  Mt.parent && Mt.parent.remove(Mt);
                });
              }), Ye2(G3, function(mt) {
                mt.invisible = true, mt.dirty();
              });
            }
          }, s.prototype._doAnimation = function(r5, g5, b6, S2) {
            var A2 = b6.get("animationDurationUpdate"), k2 = b6.get("animationEasing"), R6 = (Tl(A2) ? 0 : A2) || 0, B3 = (Tl(k2) ? null : k2) || "cubicOut", G3 = vjn();
            Ye2(g5.willDeleteEls, function(Z3, X3) {
              Ye2(Z3, function(tt, it) {
                if (!tt.invisible) {
                  var pt = tt.parent, mt, Mt = rCt(pt);
                  if (S2 && S2.direction === "drillDown")
                    mt = pt === S2.rootNodeGroup ? { shape: { x: 0, y: 0, width: Mt.nodeWidth, height: Mt.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
                  else {
                    var kt = 0, Gt = 0;
                    Mt.willDelete || (kt = Mt.nodeWidth / 2, Gt = Mt.nodeHeight / 2), mt = X3 === "nodeGroup" ? { x: kt, y: Gt, style: { opacity: 0 } } : { shape: { x: kt, y: Gt, width: 0, height: 0 }, style: { opacity: 0 } };
                  }
                  mt && G3.add(tt, mt, R6, 0, B3);
                }
              });
            }), Ye2(this._storage, function(Z3, X3) {
              Ye2(Z3, function(tt, it) {
                var pt = g5.lastsForAnimation[X3][it], mt = {};
                !pt || (tt instanceof nu ? pt.oldX != null && (mt.x = tt.x, mt.y = tt.y, tt.x = pt.oldX, tt.y = pt.oldY) : (pt.oldShape && (mt.shape = sa2({}, tt.shape), tt.setShape(pt.oldShape)), pt.fadein ? (tt.setStyle("opacity", 0), mt.style = { opacity: 1 }) : tt.style.opacity !== 1 && (mt.style = { opacity: 1 })), G3.add(tt, mt, R6, 0, B3));
              });
            }, this), this._state = "animating", G3.finished(Cs(function() {
              this._state = "ready", g5.renderFinally();
            }, this)).start();
          }, s.prototype._resetController = function(r5) {
            var g5 = this._controller;
            g5 || (g5 = this._controller = new Hct(r5.getZr()), g5.enable(this.seriesModel.get("roam")), g5.on("pan", Cs(this._onPan, this)), g5.on("zoom", Cs(this._onZoom, this)));
            var b6 = new lc2(0, 0, r5.getWidth(), r5.getHeight());
            g5.setPointerChecker(function(S2, A2, k2) {
              return b6.contain(A2, k2);
            });
          }, s.prototype._clearController = function() {
            var r5 = this._controller;
            r5 && (r5.dispose(), r5 = null);
          }, s.prototype._onPan = function(r5) {
            if (this._state !== "animating" && (Math.abs(r5.dx) > Gke || Math.abs(r5.dy) > Gke)) {
              var g5 = this.seriesModel.getData().tree.root;
              if (!g5)
                return;
              var b6 = g5.getLayout();
              if (!b6)
                return;
              this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: b6.x + r5.dx, y: b6.y + r5.dy, width: b6.width, height: b6.height } });
            }
          }, s.prototype._onZoom = function(r5) {
            var g5 = r5.originX, b6 = r5.originY;
            if (this._state !== "animating") {
              var S2 = this.seriesModel.getData().tree.root;
              if (!S2)
                return;
              var A2 = S2.getLayout();
              if (!A2)
                return;
              var k2 = new lc2(A2.x, A2.y, A2.width, A2.height), R6 = this.seriesModel.layoutInfo;
              g5 -= R6.x, b6 -= R6.y;
              var B3 = bM();
              _M(B3, B3, [-g5, -b6]), fK(B3, B3, [r5.scale, r5.scale]), _M(B3, B3, [g5, b6]), k2.applyTransform(B3), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: k2.x, y: k2.y, width: k2.width, height: k2.height } });
            }
          }, s.prototype._initEvents = function(r5) {
            var g5 = this;
            r5.on("click", function(b6) {
              if (g5._state === "ready") {
                var S2 = g5.seriesModel.get("nodeClick", true);
                if (S2) {
                  var A2 = g5.findTarget(b6.offsetX, b6.offsetY);
                  if (A2) {
                    var k2 = A2.node;
                    if (k2.getLayout().isLeafRoot)
                      g5._rootToNode(A2);
                    else if (S2 === "zoomToNode")
                      g5._zoomToNode(A2);
                    else if (S2 === "link") {
                      var R6 = k2.hostTree.data.getItemModel(k2.dataIndex), B3 = R6.get("link", true), G3 = R6.get("target", true) || "blank";
                      B3 && J2t(B3, G3);
                    }
                  }
                }
              }
            }, this);
          }, s.prototype._renderBreadcrumb = function(r5, g5, b6) {
            var S2 = this;
            b6 || (b6 = r5.get("leafDepth", true) != null ? { node: r5.getViewRoot() } : this.findTarget(g5.getWidth() / 2, g5.getHeight() / 2), b6 || (b6 = { node: r5.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new djn(this.group))).render(r5, g5, b6.node, function(A2) {
              S2._state !== "animating" && (CHt(r5.getViewRoot(), A2) ? S2._rootToNode({ node: A2 }) : S2._zoomToNode({ node: A2 }));
            });
          }, s.prototype.remove = function() {
            this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = Kct(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
          }, s.prototype.dispose = function() {
            this._clearController();
          }, s.prototype._zoomToNode = function(r5) {
            this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: r5.node });
          }, s.prototype._rootToNode = function(r5) {
            this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: r5.node });
          }, s.prototype.findTarget = function(r5, g5) {
            var b6, S2 = this.seriesModel.getViewRoot();
            return S2.eachNode({ attr: "viewChildren", order: "preorder" }, function(A2) {
              var k2 = this._storage.background[A2.getRawIndex()];
              if (k2) {
                var R6 = k2.transformCoordToLocal(r5, g5), B3 = k2.shape;
                if (B3.x <= R6[0] && R6[0] <= B3.x + B3.width && B3.y <= R6[1] && R6[1] <= B3.y + B3.height)
                  b6 = { node: A2, offsetX: R6[0], offsetY: R6[1] };
                else
                  return false;
              }
            }, this), b6;
          }, s.type = "treemap", s;
        }(Ig2);
        function Kct() {
          return { nodeGroup: [], background: [], content: [] };
        }
        function xjn(c5, s, r5, g5, b6, S2, A2, k2, R6, B3) {
          if (!A2)
            return;
          var G3 = A2.getLayout(), Z3 = c5.getData(), X3 = A2.getModel();
          if (Z3.setItemGraphicEl(A2.dataIndex, null), !G3 || !G3.isInView)
            return;
          var tt = G3.width, it = G3.height, pt = G3.borderWidth, mt = G3.invisible, Mt = A2.getRawIndex(), kt = k2 && k2.getRawIndex(), Gt = A2.viewChildren, Ot = G3.upperHeight, ce2 = Gt && Gt.length, ae2 = X3.getModel("itemStyle"), de2 = X3.getModel(["emphasis", "itemStyle"]), we2 = X3.getModel(["blur", "itemStyle"]), Se2 = X3.getModel(["select", "itemStyle"]), Oe2 = ae2.get("borderRadius") || 0, je2 = Ts("nodeGroup", AHt);
          if (!je2)
            return;
          if (R6.add(je2), je2.x = G3.x || 0, je2.y = G3.y || 0, je2.markRedraw(), rCt(je2).nodeWidth = tt, rCt(je2).nodeHeight = it, G3.isAboveViewRoot)
            return je2;
          var rn = Ts("background", Wke, B3, mjn);
          rn && rr(je2, rn, ce2 && G3.upperLabelHeight);
          var qe2 = X3.getModel("emphasis"), An = qe2.get("focus"), jn = qe2.get("blurScope"), _n = qe2.get("disabled"), Jr = An === "ancestor" ? A2.getAncestorsIndices() : An === "descendant" ? A2.getDescendantIndices() : An;
          if (ce2)
            Xj2(je2) && yR(je2, false), rn && (yR(rn, !_n), Z3.setItemGraphicEl(A2.dataIndex, rn), Out(rn, Jr, jn));
          else {
            var Qn = Ts("content", Wke, B3, bjn);
            Qn && Ar(je2, Qn), rn.disableMorphing = true, rn && Xj2(rn) && yR(rn, false), yR(je2, !_n), Z3.setItemGraphicEl(A2.dataIndex, je2), Out(je2, Jr, jn);
          }
          return je2;
          function rr(rl, ss, Us) {
            var sl = Pl(ss);
            if (sl.dataIndex = A2.dataIndex, sl.seriesIndex = c5.seriesIndex, ss.setShape({ x: 0, y: 0, width: tt, height: it, r: Oe2 }), mt)
              fi2(ss);
            else {
              ss.invisible = false;
              var ws = A2.getVisual("style"), Ll = ws.stroke, dh2 = qke(ae2);
              dh2.fill = Ll;
              var hu = TW(de2);
              hu.fill = de2.get("borderColor");
              var Nh2 = TW(we2);
              Nh2.fill = we2.get("borderColor");
              var cp = TW(Se2);
              if (cp.fill = Se2.get("borderColor"), Us) {
                var Xh2 = tt - 2 * pt;
                mi2(ss, Ll, ws.opacity, { x: pt, y: 0, width: Xh2, height: Ot });
              } else
                ss.removeTextContent();
              ss.setStyle(dh2), ss.ensureState("emphasis").style = hu, ss.ensureState("blur").style = Nh2, ss.ensureState("select").style = cp, MM(ss);
            }
            rl.add(ss);
          }
          function Ar(rl, ss) {
            var Us = Pl(ss);
            Us.dataIndex = A2.dataIndex, Us.seriesIndex = c5.seriesIndex;
            var sl = Math.max(tt - 2 * pt, 0), ws = Math.max(it - 2 * pt, 0);
            if (ss.culling = true, ss.setShape({ x: pt, y: pt, width: sl, height: ws, r: Oe2 }), mt)
              fi2(ss);
            else {
              ss.invisible = false;
              var Ll = A2.getVisual("style"), dh2 = Ll.fill, hu = qke(ae2);
              hu.fill = dh2, hu.decal = Ll.decal;
              var Nh2 = TW(de2), cp = TW(we2), Xh2 = TW(Se2);
              mi2(ss, dh2, Ll.opacity, null), ss.setStyle(hu), ss.ensureState("emphasis").style = Nh2, ss.ensureState("blur").style = cp, ss.ensureState("select").style = Xh2, MM(ss);
            }
            rl.add(ss);
          }
          function fi2(rl) {
            !rl.invisible && S2.push(rl);
          }
          function mi2(rl, ss, Us, sl) {
            var ws = X3.getModel(sl ? Uke : Hke), Ll = Q0(X3.get("name"), null), dh2 = ws.getShallow("show");
            Uw(rl, qb2(X3, sl ? Uke : Hke), { defaultText: dh2 ? Ll : null, inheritColor: ss, defaultOpacity: Us, labelFetcher: c5, labelDataIndex: A2.dataIndex });
            var hu = rl.getTextContent();
            if (hu) {
              var Nh2 = hu.style, cp = VY(Nh2.padding || 0);
              sl && (rl.setTextConfig({ layoutRect: sl }), hu.disableLabelLayout = true), hu.beforeUpdate = function() {
                var om = Math.max((sl ? sl.width : rl.shape.width) - cp[1] - cp[3], 0), Sv = Math.max((sl ? sl.height : rl.shape.height) - cp[0] - cp[2], 0);
                (Nh2.width !== om || Nh2.height !== Sv) && hu.setStyle({ width: om, height: Sv });
              }, Nh2.truncateMinChar = 2, Nh2.lineOverflow = "truncate", Oo(Nh2, sl, G3);
              var Xh2 = hu.getState("emphasis");
              Oo(Xh2 ? Xh2.style : null, sl, G3);
            }
          }
          function Oo(rl, ss, Us) {
            var sl = rl ? rl.text : null;
            if (!ss && Us.isLeafRoot && sl != null) {
              var ws = c5.get("drillDownIcon", true);
              rl.text = ws ? ws + " " + sl : sl;
            }
          }
          function Ts(rl, ss, Us, sl) {
            var ws = kt != null && r5[rl][kt], Ll = b6[rl];
            return ws ? (r5[rl][kt] = null, gl(Ll, ws)) : mt || (ws = new ss(), ws instanceof SM && (ws.z2 = wjn(Us, sl)), nl(Ll, ws)), s[rl][Mt] = ws;
          }
          function gl(rl, ss) {
            var Us = rl[Mt] = {};
            ss instanceof AHt ? (Us.oldX = ss.x, Us.oldY = ss.y) : Us.oldShape = sa2({}, ss.shape);
          }
          function nl(rl, ss) {
            var Us = rl[Mt] = {}, sl = A2.parentNode, ws = ss instanceof nu;
            if (sl && (!g5 || g5.direction === "drillDown")) {
              var Ll = 0, dh2 = 0, hu = b6.background[sl.getRawIndex()];
              !g5 && hu && hu.oldShape && (Ll = hu.oldShape.width, dh2 = hu.oldShape.height), ws ? (Us.oldX = 0, Us.oldY = dh2) : Us.oldShape = { x: Ll, y: dh2, width: 0, height: 0 };
            }
            Us.fadein = !ws;
          }
        }
        function wjn(c5, s) {
          return c5 * yjn + s;
        }
        var Sjn = _jn, Xct = Ye2, Mjn = Wl, iCt = -1, IHt = function() {
          function c5(s) {
            var r5 = s.mappingMethod, g5 = s.type, b6 = this.option = Ml(s);
            this.type = g5, this.mappingMethod = r5, this._normalizeData = Ajn[r5];
            var S2 = c5.visualHandlers[g5];
            this.applyVisual = S2.applyVisual, this.getColorMapper = S2.getColorMapper, this._normalizedToVisual = S2._normalizedToVisual[r5], r5 === "piecewise" ? (DHt(b6), Cjn(b6)) : r5 === "category" ? b6.categories ? Tjn(b6) : DHt(b6, true) : (lx(r5 !== "linear" || b6.dataExtent), DHt(b6));
          }
          return c5.prototype.mapValueToVisual = function(s) {
            var r5 = this._normalizeData(s);
            return this._normalizedToVisual(r5, s);
          }, c5.prototype.getNormalizer = function() {
            return Cs(this._normalizeData, this);
          }, c5.listVisualTypes = function() {
            return nf2(c5.visualHandlers);
          }, c5.isValidType = function(s) {
            return c5.visualHandlers.hasOwnProperty(s);
          }, c5.eachVisual = function(s, r5, g5) {
            Wl(s) ? Ye2(s, r5, g5) : r5.call(g5, s);
          }, c5.mapVisual = function(s, r5, g5) {
            var b6, S2 = ja2(s) ? [] : Wl(s) ? {} : (b6 = true, null);
            return c5.eachVisual(s, function(A2, k2) {
              var R6 = r5.call(g5, A2, k2);
              b6 ? S2 = R6 : S2[k2] = R6;
            }), S2;
          }, c5.retrieveVisuals = function(s) {
            var r5 = {}, g5;
            return s && Xct(c5.visualHandlers, function(b6, S2) {
              s.hasOwnProperty(S2) && (r5[S2] = s[S2], g5 = true);
            }), g5 ? r5 : null;
          }, c5.prepareVisualTypes = function(s) {
            if (ja2(s))
              s = s.slice();
            else if (Mjn(s)) {
              var r5 = [];
              Xct(s, function(g5, b6) {
                r5.push(b6);
              }), s = r5;
            } else
              return [];
            return s.sort(function(g5, b6) {
              return b6 === "color" && g5 !== "color" && g5.indexOf("color") === 0 ? 1 : -1;
            }), s;
          }, c5.dependsOn = function(s, r5) {
            return r5 === "color" ? !!(s && s.indexOf(r5) === 0) : s === r5;
          }, c5.findPieceIndex = function(s, r5, g5) {
            for (var b6, S2 = 1 / 0, A2 = 0, k2 = r5.length; A2 < k2; A2++) {
              var R6 = r5[A2].value;
              if (R6 != null) {
                if (R6 === s || gs(R6) && R6 === s + "")
                  return A2;
                g5 && X3(R6, A2);
              }
            }
            for (var A2 = 0, k2 = r5.length; A2 < k2; A2++) {
              var B3 = r5[A2], G3 = B3.interval, Z3 = B3.close;
              if (G3) {
                if (G3[0] === -1 / 0) {
                  if (oCt(Z3[1], s, G3[1]))
                    return A2;
                } else if (G3[1] === 1 / 0) {
                  if (oCt(Z3[0], G3[0], s))
                    return A2;
                } else if (oCt(Z3[0], G3[0], s) && oCt(Z3[1], s, G3[1]))
                  return A2;
                g5 && X3(G3[0], A2), g5 && X3(G3[1], A2);
              }
            }
            if (g5)
              return s === 1 / 0 ? r5.length - 1 : s === -1 / 0 ? 0 : b6;
            function X3(tt, it) {
              var pt = Math.abs(tt - s);
              pt < S2 && (S2 = pt, b6 = it);
            }
          }, c5.visualHandlers = { color: { applyVisual: Qct("color"), getColorMapper: function() {
            var s = this.option;
            return Cs(s.mappingMethod === "category" ? function(r5, g5) {
              return !g5 && (r5 = this._normalizeData(r5)), Jct.call(this, r5);
            } : function(r5, g5, b6) {
              var S2 = !!b6;
              return !g5 && (r5 = this._normalizeData(r5)), b6 = Slt(r5, s.parsedVisual, b6), S2 ? b6 : vk2(b6, "rgba");
            }, this);
          }, _normalizedToVisual: { linear: function(s) {
            return vk2(Slt(s, this.option.parsedVisual), "rgba");
          }, category: Jct, piecewise: function(s, r5) {
            var g5 = kHt.call(this, r5);
            return g5 == null && (g5 = vk2(Slt(s, this.option.parsedVisual), "rgba")), g5;
          }, fixed: AW } }, colorHue: aCt(function(s, r5) {
            return UC(s, r5);
          }), colorSaturation: aCt(function(s, r5) {
            return UC(s, null, r5);
          }), colorLightness: aCt(function(s, r5) {
            return UC(s, null, null, r5);
          }), colorAlpha: aCt(function(s, r5) {
            return YY(s, r5);
          }), decal: { applyVisual: Qct("decal"), _normalizedToVisual: { linear: null, category: Jct, piecewise: null, fixed: null } }, opacity: { applyVisual: Qct("opacity"), _normalizedToVisual: EHt([0, 1]) }, liftZ: { applyVisual: Qct("liftZ"), _normalizedToVisual: { linear: AW, category: AW, piecewise: AW, fixed: AW } }, symbol: { applyVisual: function(s, r5, g5) {
            var b6 = this.mapValueToVisual(s);
            g5("symbol", b6);
          }, _normalizedToVisual: { linear: Zke, category: Jct, piecewise: function(s, r5) {
            var g5 = kHt.call(this, r5);
            return g5 == null && (g5 = Zke.call(this, s)), g5;
          }, fixed: AW } }, symbolSize: { applyVisual: Qct("symbolSize"), _normalizedToVisual: EHt([0, 1]) } }, c5;
        }();
        function Cjn(c5) {
          var s = c5.pieceList;
          c5.hasSpecialVisual = false, Ye2(s, function(r5, g5) {
            r5.originIndex = g5, r5.visual != null && (c5.hasSpecialVisual = true);
          });
        }
        function Tjn(c5) {
          var s = c5.categories, r5 = c5.categoryMap = {}, g5 = c5.visual;
          if (Xct(s, function(A2, k2) {
            r5[A2] = k2;
          }), !ja2(g5)) {
            var b6 = [];
            Wl(g5) ? Xct(g5, function(A2, k2) {
              var R6 = r5[k2];
              b6[R6 != null ? R6 : iCt] = A2;
            }) : b6[iCt] = g5, g5 = $ke(c5, b6);
          }
          for (var S2 = s.length - 1; S2 >= 0; S2--)
            g5[S2] == null && (delete r5[s[S2]], s.pop());
        }
        function DHt(c5, s) {
          var r5 = c5.visual, g5 = [];
          Wl(r5) ? Xct(r5, function(S2) {
            g5.push(S2);
          }) : r5 != null && g5.push(r5);
          var b6 = { color: 1, symbol: 1 };
          !s && g5.length === 1 && !b6.hasOwnProperty(c5.type) && (g5[1] = g5[0]), $ke(c5, g5);
        }
        function aCt(c5) {
          return { applyVisual: function(s, r5, g5) {
            var b6 = this.mapValueToVisual(s);
            g5("color", c5(r5("color"), b6));
          }, _normalizedToVisual: EHt([0, 1]) };
        }
        function Zke(c5) {
          var s = this.option.visual;
          return s[Math.round(fh2(c5, [0, 1], [0, s.length - 1], true))] || {};
        }
        function Qct(c5) {
          return function(s, r5, g5) {
            g5(c5, this.mapValueToVisual(s));
          };
        }
        function Jct(c5) {
          var s = this.option.visual;
          return s[this.option.loop && c5 !== iCt ? c5 % s.length : c5];
        }
        function AW() {
          return this.option.visual[0];
        }
        function EHt(c5) {
          return { linear: function(s) {
            return fh2(s, c5, this.option.visual, true);
          }, category: Jct, piecewise: function(s, r5) {
            var g5 = kHt.call(this, r5);
            return g5 == null && (g5 = fh2(s, c5, this.option.visual, true)), g5;
          }, fixed: AW };
        }
        function kHt(c5) {
          var s = this.option, r5 = s.pieceList;
          if (s.hasSpecialVisual) {
            var g5 = IHt.findPieceIndex(c5, r5), b6 = r5[g5];
            if (b6 && b6.visual)
              return b6.visual[this.type];
          }
        }
        function $ke(c5, s) {
          return c5.visual = s, c5.type === "color" && (c5.parsedVisual = Ha2(s, function(r5) {
            return Bb2(r5);
          })), s;
        }
        var Ajn = { linear: function(c5) {
          return fh2(c5, this.option.dataExtent, [0, 1], true);
        }, piecewise: function(c5) {
          var s = this.option.pieceList, r5 = IHt.findPieceIndex(c5, s, true);
          if (r5 != null)
            return fh2(r5, [0, s.length - 1], [0, 1], true);
        }, category: function(c5) {
          var s = this.option.categories ? this.option.categoryMap[c5] : c5;
          return s == null ? iCt : s;
        }, fixed: I0 };
        function oCt(c5, s, r5) {
          return c5 ? s <= r5 : s < r5;
        }
        var Sx = IHt, Ijn = "itemStyle", Yke = Df2(), Djn = { seriesType: "treemap", reset: function(c5) {
          var s = c5.getData().tree, r5 = s.root;
          r5.isRemoved() || Kke(r5, {}, c5.getViewRoot().getAncestors(), c5);
        } };
        function Kke(c5, s, r5, g5) {
          var b6 = c5.getModel(), S2 = c5.getLayout(), A2 = c5.hostTree.data;
          if (!(!S2 || S2.invisible || !S2.isInView)) {
            var k2 = b6.getModel(Ijn), R6 = Ejn(k2, s, g5), B3 = A2.ensureUniqueItemVisual(c5.dataIndex, "style"), G3 = k2.get("borderColor"), Z3 = k2.get("borderColorSaturation"), X3;
            Z3 != null && (X3 = Xke(R6), G3 = kjn(Z3, X3)), B3.stroke = G3;
            var tt = c5.viewChildren;
            if (!tt || !tt.length)
              X3 = Xke(R6), B3.fill = X3;
            else {
              var it = Pjn(c5, b6, S2, k2, R6, tt);
              Ye2(tt, function(pt, mt) {
                if (pt.depth >= r5.length || pt === r5[pt.depth]) {
                  var Mt = Ljn(b6, R6, pt, mt, it, g5);
                  Kke(pt, Mt, r5, g5);
                }
              });
            }
          }
        }
        function Ejn(c5, s, r5) {
          var g5 = sa2({}, s), b6 = r5.designatedVisualItemStyle;
          return Ye2(["color", "colorAlpha", "colorSaturation"], function(S2) {
            b6[S2] = s[S2];
            var A2 = c5.get(S2);
            b6[S2] = null, A2 != null && (g5[S2] = A2);
          }), g5;
        }
        function Xke(c5) {
          var s = PHt(c5, "color");
          if (s) {
            var r5 = PHt(c5, "colorAlpha"), g5 = PHt(c5, "colorSaturation");
            return g5 && (s = UC(s, null, null, g5)), r5 && (s = YY(s, r5)), s;
          }
        }
        function kjn(c5, s) {
          return s != null ? UC(s, null, null, c5) : null;
        }
        function PHt(c5, s) {
          var r5 = c5[s];
          if (r5 != null && r5 !== "none")
            return r5;
        }
        function Pjn(c5, s, r5, g5, b6, S2) {
          if (!(!S2 || !S2.length)) {
            var A2 = LHt(s, "color") || b6.color != null && b6.color !== "none" && (LHt(s, "colorAlpha") || LHt(s, "colorSaturation"));
            if (A2) {
              var k2 = s.get("visualMin"), R6 = s.get("visualMax"), B3 = r5.dataExtent.slice();
              k2 != null && k2 < B3[0] && (B3[0] = k2), R6 != null && R6 > B3[1] && (B3[1] = R6);
              var G3 = s.get("colorMappingBy"), Z3 = { type: A2.name, dataExtent: B3, visual: A2.range };
              Z3.type === "color" && (G3 === "index" || G3 === "id") ? (Z3.mappingMethod = "category", Z3.loop = true) : Z3.mappingMethod = "linear";
              var X3 = new Sx(Z3);
              return Yke(X3).drColorMappingBy = G3, X3;
            }
          }
        }
        function LHt(c5, s) {
          var r5 = c5.get(s);
          return ja2(r5) && r5.length ? { name: s, range: r5 } : null;
        }
        function Ljn(c5, s, r5, g5, b6, S2) {
          var A2 = sa2({}, s);
          if (b6) {
            var k2 = b6.type, R6 = k2 === "color" && Yke(b6).drColorMappingBy, B3 = R6 === "index" ? g5 : R6 === "id" ? S2.mapIdToIndex(r5.getId()) : r5.getValue(c5.get("visualDimension"));
            A2[k2] = b6.mapValueToVisual(B3);
          }
          return A2;
        }
        var tft = Math.max, sCt = Math.min, Qke = Wm, OHt = Ye2, Jke = ["itemStyle", "borderWidth"], Ojn = ["itemStyle", "gapWidth"], Rjn = ["upperLabel", "show"], Njn = ["upperLabel", "height"], Fjn = { seriesType: "treemap", reset: function(c5, s, r5, g5) {
          var b6 = r5.getWidth(), S2 = r5.getHeight(), A2 = c5.option, k2 = $m(c5.getBoxLayoutParams(), { width: r5.getWidth(), height: r5.getHeight() }), R6 = A2.size || [], B3 = $o(Qke(k2.width, R6[0]), b6), G3 = $o(Qke(k2.height, R6[1]), S2), Z3 = g5 && g5.type, X3 = ["treemapZoomToNode", "treemapRootToNode"], tt = $ct(g5, X3, c5), it = Z3 === "treemapRender" || Z3 === "treemapMove" ? g5.rootRect : null, pt = c5.getViewRoot(), mt = Fke(pt);
          if (Z3 !== "treemapMove") {
            var Mt = Z3 === "treemapZoomToNode" ? Gjn(c5, tt, pt, B3, G3) : it ? [it.width, it.height] : [B3, G3], kt = A2.sort;
            kt && kt !== "asc" && kt !== "desc" && (kt = "desc");
            var Gt = { squareRatio: A2.squareRatio, sort: kt, leafDepth: A2.leafDepth };
            pt.hostTree.clearLayouts();
            var Ot = { x: 0, y: 0, width: Mt[0], height: Mt[1], area: Mt[0] * Mt[1] };
            pt.setLayout(Ot), t5e(pt, Gt, false, 0), Ot = pt.getLayout(), OHt(mt, function(ae2, de2) {
              var we2 = (mt[de2 + 1] || pt).getValue();
              ae2.setLayout(sa2({ dataExtent: [we2, we2], borderWidth: 0, upperHeight: 0 }, Ot));
            });
          }
          var ce2 = c5.getData().tree.root;
          ce2.setLayout(Hjn(k2, it, tt), true), c5.setLayoutInfo(k2), n5e(ce2, new lc2(-k2.x, -k2.y, b6, S2), mt, pt, 0);
        } };
        function t5e(c5, s, r5, g5) {
          var b6, S2;
          if (!c5.isRemoved()) {
            var A2 = c5.getLayout();
            b6 = A2.width, S2 = A2.height;
            var k2 = c5.getModel(), R6 = k2.get(Jke), B3 = k2.get(Ojn) / 2, G3 = r5e(k2), Z3 = Math.max(R6, G3), X3 = R6 - B3, tt = Z3 - B3;
            c5.setLayout({ borderWidth: R6, upperHeight: Z3, upperLabelHeight: G3 }, true), b6 = tft(b6 - 2 * X3, 0), S2 = tft(S2 - X3 - tt, 0);
            var it = b6 * S2, pt = Vjn(c5, k2, it, s, r5, g5);
            if (pt.length) {
              var mt = { x: X3, y: tt, width: b6, height: S2 }, Mt = sCt(b6, S2), kt = 1 / 0, Gt = [];
              Gt.area = 0;
              for (var Ot = 0, ce2 = pt.length; Ot < ce2; ) {
                var ae2 = pt[Ot];
                Gt.push(ae2), Gt.area += ae2.getLayout().area;
                var de2 = Wjn(Gt, Mt, s.squareRatio);
                de2 <= kt ? (Ot++, kt = de2) : (Gt.area -= Gt.pop().getLayout().area, e5e(Gt, Mt, mt, B3, false), Mt = sCt(mt.width, mt.height), Gt.length = Gt.area = 0, kt = 1 / 0);
              }
              if (Gt.length && e5e(Gt, Mt, mt, B3, true), !r5) {
                var we2 = k2.get("childrenVisibleMin");
                we2 != null && it < we2 && (r5 = true);
              }
              for (var Ot = 0, ce2 = pt.length; Ot < ce2; Ot++)
                t5e(pt[Ot], s, r5, g5 + 1);
            }
          }
        }
        function Vjn(c5, s, r5, g5, b6, S2) {
          var A2 = c5.children || [], k2 = g5.sort;
          k2 !== "asc" && k2 !== "desc" && (k2 = null);
          var R6 = g5.leafDepth != null && g5.leafDepth <= S2;
          if (b6 && !R6)
            return c5.viewChildren = [];
          A2 = jp(A2, function(tt) {
            return !tt.isRemoved();
          }), zjn(A2, k2);
          var B3 = jjn(s, A2, k2);
          if (B3.sum === 0)
            return c5.viewChildren = [];
          if (B3.sum = Bjn(s, r5, B3.sum, k2, A2), B3.sum === 0)
            return c5.viewChildren = [];
          for (var G3 = 0, Z3 = A2.length; G3 < Z3; G3++) {
            var X3 = A2[G3].getValue() / B3.sum * r5;
            A2[G3].setLayout({ area: X3 });
          }
          return R6 && (A2.length && c5.setLayout({ isLeafRoot: true }, true), A2.length = 0), c5.viewChildren = A2, c5.setLayout({ dataExtent: B3.dataExtent }, true), A2;
        }
        function Bjn(c5, s, r5, g5, b6) {
          if (!g5)
            return r5;
          for (var S2 = c5.get("visibleMin"), A2 = b6.length, k2 = A2, R6 = A2 - 1; R6 >= 0; R6--) {
            var B3 = b6[g5 === "asc" ? A2 - R6 - 1 : R6].getValue();
            B3 / r5 * s < S2 && (k2 = R6, r5 -= B3);
          }
          return g5 === "asc" ? b6.splice(0, A2 - k2) : b6.splice(k2, A2 - k2), r5;
        }
        function zjn(c5, s) {
          return s && c5.sort(function(r5, g5) {
            var b6 = s === "asc" ? r5.getValue() - g5.getValue() : g5.getValue() - r5.getValue();
            return b6 === 0 ? s === "asc" ? r5.dataIndex - g5.dataIndex : g5.dataIndex - r5.dataIndex : b6;
          }), c5;
        }
        function jjn(c5, s, r5) {
          for (var g5 = 0, b6 = 0, S2 = s.length; b6 < S2; b6++)
            g5 += s[b6].getValue();
          var A2 = c5.get("visualDimension"), k2;
          return !s || !s.length ? k2 = [NaN, NaN] : A2 === "value" && r5 ? (k2 = [s[s.length - 1].getValue(), s[0].getValue()], r5 === "asc" && k2.reverse()) : (k2 = [1 / 0, -1 / 0], OHt(s, function(R6) {
            var B3 = R6.getValue(A2);
            B3 < k2[0] && (k2[0] = B3), B3 > k2[1] && (k2[1] = B3);
          })), { sum: g5, dataExtent: k2 };
        }
        function Wjn(c5, s, r5) {
          for (var g5 = 0, b6 = 1 / 0, S2 = 0, A2 = void 0, k2 = c5.length; S2 < k2; S2++)
            A2 = c5[S2].getLayout().area, A2 && (A2 < b6 && (b6 = A2), A2 > g5 && (g5 = A2));
          var R6 = c5.area * c5.area, B3 = s * s * r5;
          return R6 ? tft(B3 * g5 / R6, R6 / (B3 * b6)) : 1 / 0;
        }
        function e5e(c5, s, r5, g5, b6) {
          var S2 = s === r5.width ? 0 : 1, A2 = 1 - S2, k2 = ["x", "y"], R6 = ["width", "height"], B3 = r5[k2[S2]], G3 = s ? c5.area / s : 0;
          (b6 || G3 > r5[R6[A2]]) && (G3 = r5[R6[A2]]);
          for (var Z3 = 0, X3 = c5.length; Z3 < X3; Z3++) {
            var tt = c5[Z3], it = {}, pt = G3 ? tt.getLayout().area / G3 : 0, mt = it[R6[A2]] = tft(G3 - 2 * g5, 0), Mt = r5[k2[S2]] + r5[R6[S2]] - B3, kt = Z3 === X3 - 1 || Mt < pt ? Mt : pt, Gt = it[R6[S2]] = tft(kt - 2 * g5, 0);
            it[k2[A2]] = r5[k2[A2]] + sCt(g5, mt / 2), it[k2[S2]] = B3 + sCt(g5, Gt / 2), B3 += kt, tt.setLayout(it, true);
          }
          r5[k2[A2]] += G3, r5[R6[A2]] -= G3;
        }
        function Gjn(c5, s, r5, g5, b6) {
          var S2 = (s || {}).node, A2 = [g5, b6];
          if (!S2 || S2 === r5)
            return A2;
          for (var k2, R6 = g5 * b6, B3 = R6 * c5.option.zoomToNodeRatio; k2 = S2.parentNode; ) {
            for (var G3 = 0, Z3 = k2.children, X3 = 0, tt = Z3.length; X3 < tt; X3++)
              G3 += Z3[X3].getValue();
            var it = S2.getValue();
            if (it === 0)
              return A2;
            B3 *= G3 / it;
            var pt = k2.getModel(), mt = pt.get(Jke), Mt = Math.max(mt, r5e(pt));
            B3 += 4 * mt * mt + (3 * mt + Mt) * Math.pow(B3, 0.5), B3 > Vj2 && (B3 = Vj2), S2 = k2;
          }
          B3 < R6 && (B3 = R6);
          var kt = Math.pow(B3 / R6, 0.5);
          return [g5 * kt, b6 * kt];
        }
        function Hjn(c5, s, r5) {
          if (s)
            return { x: s.x, y: s.y };
          var g5 = { x: 0, y: 0 };
          if (!r5)
            return g5;
          var b6 = r5.node, S2 = b6.getLayout();
          if (!S2)
            return g5;
          for (var A2 = [S2.width / 2, S2.height / 2], k2 = b6; k2; ) {
            var R6 = k2.getLayout();
            A2[0] += R6.x, A2[1] += R6.y, k2 = k2.parentNode;
          }
          return { x: c5.width / 2 - A2[0], y: c5.height / 2 - A2[1] };
        }
        function n5e(c5, s, r5, g5, b6) {
          var S2 = c5.getLayout(), A2 = r5[b6], k2 = A2 && A2 === c5;
          if (!(A2 && !k2 || b6 === r5.length && c5 !== g5)) {
            c5.setLayout({ isInView: true, invisible: !k2 && !s.intersect(S2), isAboveViewRoot: k2 }, true);
            var R6 = new lc2(s.x - S2.x, s.y - S2.y, s.width, s.height);
            OHt(c5.viewChildren || [], function(B3) {
              n5e(B3, R6, r5, g5, b6 + 1);
            });
          }
        }
        function r5e(c5) {
          return c5.get(Rjn) ? c5.get(Njn) : 0;
        }
        function Ujn(c5) {
          c5.registerSeriesModel(ujn), c5.registerChartView(Sjn), c5.registerVisual(Djn), c5.registerLayout(Fjn), ojn(c5);
        }
        function qjn(c5) {
          var s = c5.findComponents({ mainType: "legend" });
          !s || !s.length || c5.eachSeriesByType("graph", function(r5) {
            var g5 = r5.getCategoriesData(), b6 = r5.getGraph(), S2 = b6.data, A2 = g5.mapArray(g5.getName);
            S2.filterSelf(function(k2) {
              var R6 = S2.getItemModel(k2), B3 = R6.getShallow("category");
              if (B3 != null) {
                Oh2(B3) && (B3 = A2[B3]);
                for (var G3 = 0; G3 < s.length; G3++)
                  if (!s[G3].isSelected(B3))
                    return false;
              }
              return true;
            });
          });
        }
        function Zjn(c5) {
          var s = {};
          c5.eachSeriesByType("graph", function(r5) {
            var g5 = r5.getCategoriesData(), b6 = r5.getData(), S2 = {};
            g5.each(function(A2) {
              var k2 = g5.getName(A2);
              S2["ec-" + k2] = A2;
              var R6 = g5.getItemModel(A2), B3 = R6.getModel("itemStyle").getItemStyle();
              B3.fill || (B3.fill = r5.getColorFromPalette(k2, s)), g5.setItemVisual(A2, "style", B3);
              for (var G3 = ["symbol", "symbolSize", "symbolKeepAspect"], Z3 = 0; Z3 < G3.length; Z3++) {
                var X3 = R6.getShallow(G3[Z3], true);
                X3 != null && g5.setItemVisual(A2, G3[Z3], X3);
              }
            }), g5.count() && b6.each(function(A2) {
              var k2 = b6.getItemModel(A2), R6 = k2.getShallow("category");
              if (R6 != null) {
                gs(R6) && (R6 = S2["ec-" + R6]);
                var B3 = g5.getItemVisual(R6, "style"), G3 = b6.ensureUniqueItemVisual(A2, "style");
                sa2(G3, B3);
                for (var Z3 = ["symbol", "symbolSize", "symbolKeepAspect"], X3 = 0; X3 < Z3.length; X3++)
                  b6.setItemVisual(A2, Z3[X3], g5.getItemVisual(R6, Z3[X3]));
              }
            });
          });
        }
        function lCt(c5) {
          return c5 instanceof Array || (c5 = [c5, c5]), c5;
        }
        function $jn(c5) {
          c5.eachSeriesByType("graph", function(s) {
            var r5 = s.getGraph(), g5 = s.getEdgeData(), b6 = lCt(s.get("edgeSymbol")), S2 = lCt(s.get("edgeSymbolSize"));
            g5.setVisual("fromSymbol", b6 && b6[0]), g5.setVisual("toSymbol", b6 && b6[1]), g5.setVisual("fromSymbolSize", S2 && S2[0]), g5.setVisual("toSymbolSize", S2 && S2[1]), g5.setVisual("style", s.getModel("lineStyle").getLineStyle()), g5.each(function(A2) {
              var k2 = g5.getItemModel(A2), R6 = r5.getEdgeByIndex(A2), B3 = lCt(k2.getShallow("symbol", true)), G3 = lCt(k2.getShallow("symbolSize", true)), Z3 = k2.getModel("lineStyle").getLineStyle(), X3 = g5.ensureUniqueItemVisual(A2, "style");
              switch (sa2(X3, Z3), X3.stroke) {
                case "source": {
                  var tt = R6.node1.getVisual("style");
                  X3.stroke = tt && tt.fill;
                  break;
                }
                case "target": {
                  var tt = R6.node2.getVisual("style");
                  X3.stroke = tt && tt.fill;
                  break;
                }
              }
              B3[0] && R6.setVisual("fromSymbol", B3[0]), B3[1] && R6.setVisual("toSymbol", B3[1]), G3[0] && R6.setVisual("fromSymbolSize", G3[0]), G3[1] && R6.setVisual("toSymbolSize", G3[1]);
            });
          });
        }
        var RHt = "-->", uCt = function(c5) {
          return c5.get("autoCurveness") || null;
        }, i5e = function(c5, s) {
          var r5 = uCt(c5), g5 = 20, b6 = [];
          if (Oh2(r5))
            g5 = r5;
          else if (ja2(r5)) {
            c5.__curvenessList = r5;
            return;
          }
          s > g5 && (g5 = s);
          var S2 = g5 % 2 ? g5 + 2 : g5 + 3;
          b6 = [];
          for (var A2 = 0; A2 < S2; A2++)
            b6.push((A2 % 2 ? A2 + 1 : A2) / 10 * (A2 % 2 ? -1 : 1));
          c5.__curvenessList = b6;
        }, eft = function(c5, s, r5) {
          var g5 = [c5.id, c5.dataIndex].join("."), b6 = [s.id, s.dataIndex].join(".");
          return [r5.uid, g5, b6].join(RHt);
        }, a5e = function(c5) {
          var s = c5.split(RHt);
          return [s[0], s[2], s[1]].join(RHt);
        }, Yjn = function(c5, s) {
          var r5 = eft(c5.node1, c5.node2, s);
          return s.__edgeMap[r5];
        }, Kjn = function(c5, s) {
          var r5 = NHt(eft(c5.node1, c5.node2, s), s), g5 = NHt(eft(c5.node2, c5.node1, s), s);
          return r5 + g5;
        }, NHt = function(c5, s) {
          var r5 = s.__edgeMap;
          return r5[c5] ? r5[c5].length : 0;
        };
        function Xjn(c5) {
          !uCt(c5) || (c5.__curvenessList = [], c5.__edgeMap = {}, i5e(c5));
        }
        function Qjn(c5, s, r5, g5) {
          if (uCt(r5)) {
            var b6 = eft(c5, s, r5), S2 = r5.__edgeMap, A2 = S2[a5e(b6)];
            S2[b6] && !A2 ? S2[b6].isForward = true : A2 && S2[b6] && (A2.isForward = true, S2[b6].isForward = false), S2[b6] = S2[b6] || [], S2[b6].push(g5);
          }
        }
        function FHt(c5, s, r5, g5) {
          var b6 = uCt(s), S2 = ja2(b6);
          if (!b6)
            return null;
          var A2 = Yjn(c5, s);
          if (!A2)
            return null;
          for (var k2 = -1, R6 = 0; R6 < A2.length; R6++)
            if (A2[R6] === r5) {
              k2 = R6;
              break;
            }
          var B3 = Kjn(c5, s);
          i5e(s, B3), c5.lineStyle = c5.lineStyle || {};
          var G3 = eft(c5.node1, c5.node2, s), Z3 = s.__curvenessList, X3 = S2 || B3 % 2 ? 0 : 1;
          if (A2.isForward)
            return Z3[X3 + k2];
          var tt = a5e(G3), it = NHt(tt, s), pt = Z3[k2 + it + X3];
          return g5 ? S2 ? b6 && b6[0] === 0 ? (it + X3) % 2 ? pt : -pt : ((it % 2 ? 0 : 1) + X3) % 2 ? pt : -pt : (it + X3) % 2 ? pt : -pt : Z3[k2 + it + X3];
        }
        function o5e(c5) {
          var s = c5.coordinateSystem;
          if (!(s && s.type !== "view")) {
            var r5 = c5.getGraph();
            r5.eachNode(function(g5) {
              var b6 = g5.getModel();
              g5.setLayout([+b6.get("x"), +b6.get("y")]);
            }), s5e(r5, c5);
          }
        }
        function s5e(c5, s) {
          c5.eachEdge(function(r5, g5) {
            var b6 = pk2(r5.getModel().get(["lineStyle", "curveness"]), -FHt(r5, s, g5, true), 0), S2 = Iy(r5.node1.getLayout()), A2 = Iy(r5.node2.getLayout()), k2 = [S2, A2];
            +b6 && k2.push([(S2[0] + A2[0]) / 2 - (S2[1] - A2[1]) * b6, (S2[1] + A2[1]) / 2 - (A2[0] - S2[0]) * b6]), r5.setLayout(k2);
          });
        }
        function Jjn(c5, s) {
          c5.eachSeriesByType("graph", function(r5) {
            var g5 = r5.get("layout"), b6 = r5.coordinateSystem;
            if (b6 && b6.type !== "view") {
              var S2 = r5.getData(), A2 = [];
              Ye2(b6.dimensions, function(X3) {
                A2 = A2.concat(S2.mapDimensionsAll(X3));
              });
              for (var k2 = 0; k2 < S2.count(); k2++) {
                for (var R6 = [], B3 = false, G3 = 0; G3 < A2.length; G3++) {
                  var Z3 = S2.get(A2[G3], k2);
                  isNaN(Z3) || (B3 = true), R6.push(Z3);
                }
                B3 ? S2.setItemLayout(k2, b6.dataToPoint(R6)) : S2.setItemLayout(k2, [NaN, NaN]);
              }
              s5e(S2.graph, r5);
            } else
              (!g5 || g5 === "none") && o5e(r5);
          });
        }
        function nft(c5) {
          var s = c5.coordinateSystem;
          if (s.type !== "view")
            return 1;
          var r5 = c5.option.nodeScaleRatio, g5 = s.scaleX, b6 = s.getZoom(), S2 = (b6 - 1) * r5 + 1;
          return S2 / g5;
        }
        function rft(c5) {
          var s = c5.getVisual("symbolSize");
          return s instanceof Array && (s = (s[0] + s[1]) / 2), +s;
        }
        var l5e = Math.PI, VHt = [];
        function u5e(c5, s) {
          var r5 = c5.coordinateSystem;
          if (!(r5 && r5.type !== "view")) {
            var g5 = r5.getBoundingRect(), b6 = c5.getData(), S2 = b6.graph, A2 = g5.width / 2 + g5.x, k2 = g5.height / 2 + g5.y, R6 = Math.min(g5.width, g5.height) / 2, B3 = b6.count();
            b6.setLayout({ cx: A2, cy: k2 }), B3 && (tWn[s](c5, S2, b6, R6, A2, k2, B3), S2.eachEdge(function(G3, Z3) {
              var X3 = pk2(G3.getModel().get(["lineStyle", "curveness"]), FHt(G3, c5, Z3), 0), tt = Iy(G3.node1.getLayout()), it = Iy(G3.node2.getLayout()), pt, mt = (tt[0] + it[0]) / 2, Mt = (tt[1] + it[1]) / 2;
              +X3 && (X3 *= 3, pt = [A2 * X3 + mt * (1 - X3), k2 * X3 + Mt * (1 - X3)]), G3.setLayout([tt, it, pt]);
            }));
          }
        }
        var tWn = { value: function(c5, s, r5, g5, b6, S2, A2) {
          var k2 = 0, R6 = r5.getSum("value"), B3 = Math.PI * 2 / (R6 || A2);
          s.eachNode(function(G3) {
            var Z3 = G3.getValue("value"), X3 = B3 * (R6 ? Z3 : 1) / 2;
            k2 += X3, G3.setLayout([g5 * Math.cos(k2) + b6, g5 * Math.sin(k2) + S2]), k2 += X3;
          });
        }, symbolSize: function(c5, s, r5, g5, b6, S2, A2) {
          var k2 = 0;
          VHt.length = A2;
          var R6 = nft(c5);
          s.eachNode(function(Z3) {
            var X3 = rft(Z3);
            isNaN(X3) && (X3 = 2), X3 < 0 && (X3 = 0), X3 *= R6;
            var tt = Math.asin(X3 / 2 / g5);
            isNaN(tt) && (tt = l5e / 2), VHt[Z3.dataIndex] = tt, k2 += tt * 2;
          });
          var B3 = (2 * l5e - k2) / A2 / 2, G3 = 0;
          s.eachNode(function(Z3) {
            var X3 = B3 + VHt[Z3.dataIndex];
            G3 += X3, Z3.setLayout([g5 * Math.cos(G3) + b6, g5 * Math.sin(G3) + S2]), G3 += X3;
          });
        } };
        function eWn(c5) {
          c5.eachSeriesByType("graph", function(s) {
            s.get("layout") === "circular" && u5e(s, "symbolSize");
          });
        }
        var AX = EI;
        function nWn(c5, s, r5) {
          for (var g5 = c5, b6 = s, S2 = r5.rect, A2 = S2.width, k2 = S2.height, R6 = [S2.x + A2 / 2, S2.y + k2 / 2], B3 = r5.gravity == null ? 0.1 : r5.gravity, G3 = 0; G3 < g5.length; G3++) {
            var Z3 = g5[G3];
            Z3.p || (Z3.p = nm(A2 * (Math.random() - 0.5) + R6[0], k2 * (Math.random() - 0.5) + R6[1])), Z3.pp = Iy(Z3.p), Z3.edges = null;
          }
          var X3 = r5.friction == null ? 0.6 : r5.friction, tt = X3, it, pt;
          return { warmUp: function() {
            tt = X3 * 0.8;
          }, setFixed: function(mt) {
            g5[mt].fixed = true;
          }, setUnfixed: function(mt) {
            g5[mt].fixed = false;
          }, beforeStep: function(mt) {
            it = mt;
          }, afterStep: function(mt) {
            pt = mt;
          }, step: function(mt) {
            it && it(g5, b6);
            for (var Mt = [], kt = g5.length, Gt = 0; Gt < b6.length; Gt++) {
              var Ot = b6[Gt];
              if (!Ot.ignoreForceLayout) {
                var ce2 = Ot.n1, ae2 = Ot.n2;
                kI(Mt, ae2.p, ce2.p);
                var de2 = dj2(Mt) - Ot.d, we2 = ae2.w / (ce2.w + ae2.w);
                isNaN(we2) && (we2 = 0), z4(Mt, Mt), !ce2.fixed && AX(ce2.p, ce2.p, Mt, we2 * de2 * tt), !ae2.fixed && AX(ae2.p, ae2.p, Mt, -(1 - we2) * de2 * tt);
              }
            }
            for (var Gt = 0; Gt < kt; Gt++) {
              var Se2 = g5[Gt];
              Se2.fixed || (kI(Mt, R6, Se2.p), AX(Se2.p, Se2.p, Mt, B3 * tt));
            }
            for (var Gt = 0; Gt < kt; Gt++)
              for (var ce2 = g5[Gt], Oe2 = Gt + 1; Oe2 < kt; Oe2++) {
                var ae2 = g5[Oe2];
                kI(Mt, ae2.p, ce2.p);
                var de2 = dj2(Mt);
                de2 === 0 && (uzt(Mt, Math.random() - 0.5, Math.random() - 0.5), de2 = 1);
                var je2 = (ce2.rep + ae2.rep) / de2 / de2;
                !ce2.fixed && AX(ce2.pp, ce2.pp, Mt, je2), !ae2.fixed && AX(ae2.pp, ae2.pp, Mt, -je2);
              }
            for (var rn = [], Gt = 0; Gt < kt; Gt++) {
              var Se2 = g5[Gt];
              Se2.fixed || (kI(rn, Se2.p, Se2.pp), AX(Se2.p, Se2.p, rn, tt), ux(Se2.pp, Se2.p));
            }
            tt = tt * 0.992;
            var qe2 = tt < 0.01;
            pt && pt(g5, b6, qe2), mt && mt(qe2);
          } };
        }
        function rWn(c5) {
          c5.eachSeriesByType("graph", function(s) {
            var r5 = s.coordinateSystem;
            if (!(r5 && r5.type !== "view"))
              if (s.get("layout") === "force") {
                var g5 = s.preservedPoints || {}, b6 = s.getGraph(), S2 = b6.data, A2 = b6.edgeData, k2 = s.getModel("force"), R6 = k2.get("initLayout");
                s.preservedPoints ? S2.each(function(Gt) {
                  var Ot = S2.getId(Gt);
                  S2.setItemLayout(Gt, g5[Ot] || [NaN, NaN]);
                }) : !R6 || R6 === "none" ? o5e(s) : R6 === "circular" && u5e(s, "value");
                var B3 = S2.getDataExtent("value"), G3 = A2.getDataExtent("value"), Z3 = k2.get("repulsion"), X3 = k2.get("edgeLength"), tt = ja2(Z3) ? Z3 : [Z3, Z3], it = ja2(X3) ? X3 : [X3, X3];
                it = [it[1], it[0]];
                var pt = S2.mapArray("value", function(Gt, Ot) {
                  var ce2 = S2.getItemLayout(Ot), ae2 = fh2(Gt, B3, tt);
                  return isNaN(ae2) && (ae2 = (tt[0] + tt[1]) / 2), { w: ae2, rep: ae2, fixed: S2.getItemModel(Ot).get("fixed"), p: !ce2 || isNaN(ce2[0]) || isNaN(ce2[1]) ? null : ce2 };
                }), mt = A2.mapArray("value", function(Gt, Ot) {
                  var ce2 = b6.getEdgeByIndex(Ot), ae2 = fh2(Gt, G3, it);
                  isNaN(ae2) && (ae2 = (it[0] + it[1]) / 2);
                  var de2 = ce2.getModel(), we2 = pk2(ce2.getModel().get(["lineStyle", "curveness"]), -FHt(ce2, s, Ot, true), 0);
                  return { n1: pt[ce2.node1.dataIndex], n2: pt[ce2.node2.dataIndex], d: ae2, curveness: we2, ignoreForceLayout: de2.get("ignoreForceLayout") };
                }), Mt = r5.getBoundingRect(), kt = nWn(pt, mt, { rect: Mt, gravity: k2.get("gravity"), friction: k2.get("friction") });
                kt.beforeStep(function(Gt, Ot) {
                  for (var ce2 = 0, ae2 = Gt.length; ce2 < ae2; ce2++)
                    Gt[ce2].fixed && ux(Gt[ce2].p, b6.getNodeByIndex(ce2).getLayout());
                }), kt.afterStep(function(Gt, Ot, ce2) {
                  for (var ae2 = 0, de2 = Gt.length; ae2 < de2; ae2++)
                    Gt[ae2].fixed || b6.getNodeByIndex(ae2).setLayout(Gt[ae2].p), g5[S2.getId(ae2)] = Gt[ae2].p;
                  for (var ae2 = 0, de2 = Ot.length; ae2 < de2; ae2++) {
                    var we2 = Ot[ae2], Se2 = b6.getEdgeByIndex(ae2), Oe2 = we2.n1.p, je2 = we2.n2.p, rn = Se2.getLayout();
                    rn = rn ? rn.slice() : [], rn[0] = rn[0] || [], rn[1] = rn[1] || [], ux(rn[0], Oe2), ux(rn[1], je2), +we2.curveness && (rn[2] = [(Oe2[0] + je2[0]) / 2 - (Oe2[1] - je2[1]) * we2.curveness, (Oe2[1] + je2[1]) / 2 - (je2[0] - Oe2[0]) * we2.curveness]), Se2.setLayout(rn);
                  }
                }), s.forceLayout = kt, s.preservedPoints = g5, kt.step();
              } else
                s.forceLayout = null;
          });
        }
        function iWn(c5, s, r5) {
          var g5 = sa2(c5.getBoxLayoutParams(), { aspect: r5 });
          return $m(g5, { width: s.getWidth(), height: s.getHeight() });
        }
        function aWn(c5, s) {
          var r5 = [];
          return c5.eachSeriesByType("graph", function(g5) {
            var b6 = g5.get("coordinateSystem");
            if (!b6 || b6 === "view") {
              var S2 = g5.getData(), A2 = S2.mapArray(function(mt) {
                var Mt = S2.getItemModel(mt);
                return [+Mt.get("x"), +Mt.get("y")];
              }), k2 = [], R6 = [];
              PK(A2, k2, R6), R6[0] - k2[0] === 0 && (R6[0] += 1, k2[0] -= 1), R6[1] - k2[1] === 0 && (R6[1] += 1, k2[1] -= 1);
              var B3 = (R6[0] - k2[0]) / (R6[1] - k2[1]), G3 = iWn(g5, s, B3);
              isNaN(B3) && (k2 = [G3.x, G3.y], R6 = [G3.x + G3.width, G3.y + G3.height]);
              var Z3 = R6[0] - k2[0], X3 = R6[1] - k2[1], tt = G3.width, it = G3.height, pt = g5.coordinateSystem = new qct();
              pt.zoomLimit = g5.get("scaleLimit"), pt.setBoundingRect(k2[0], k2[1], Z3, X3), pt.setViewRect(G3.x, G3.y, tt, it), pt.setCenter(g5.get("center")), pt.setZoom(g5.get("zoom")), r5.push(pt);
            }
          }), r5;
        }
        var c5e = Zm.prototype, BHt = KK.prototype, f5e = function() {
          function c5() {
            this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
          }
          return c5;
        }();
        (function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s;
        })(f5e);
        function zHt(c5) {
          return isNaN(+c5.cpx1) || isNaN(+c5.cpy1);
        }
        var oWn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "ec-line", g5;
          }
          return s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new f5e();
          }, s.prototype.buildPath = function(r5, g5) {
            zHt(g5) ? c5e.buildPath.call(this, r5, g5) : BHt.buildPath.call(this, r5, g5);
          }, s.prototype.pointAt = function(r5) {
            return zHt(this.shape) ? c5e.pointAt.call(this, r5) : BHt.pointAt.call(this, r5);
          }, s.prototype.tangentAt = function(r5) {
            var g5 = this.shape, b6 = zHt(g5) ? [g5.x2 - g5.x1, g5.y2 - g5.y1] : BHt.tangentAt.call(this, r5);
            return z4(b6, b6);
          }, s;
        }(Tc2), sWn = oWn, jHt = ["fromSymbol", "toSymbol"];
        function h5e(c5) {
          return "_" + c5 + "Type";
        }
        function p5e(c5, s, r5) {
          var g5 = s.getItemVisual(r5, c5);
          if (!(!g5 || g5 === "none")) {
            var b6 = s.getItemVisual(r5, c5 + "Size"), S2 = s.getItemVisual(r5, c5 + "Rotate"), A2 = s.getItemVisual(r5, c5 + "Offset"), k2 = s.getItemVisual(r5, c5 + "KeepAspect"), R6 = vct(b6), B3 = vX(A2 || 0, R6), G3 = am(g5, -R6[0] / 2 + B3[0], -R6[1] / 2 + B3[1], R6[0], R6[1], null, k2);
            return G3.__specifiedRotation = S2 == null || isNaN(S2) ? void 0 : +S2 * Math.PI / 180 || 0, G3.name = c5, G3;
          }
        }
        function lWn(c5) {
          var s = new sWn({ name: "line", subPixelOptimize: true });
          return WHt(s.shape, c5), s;
        }
        function WHt(c5, s) {
          c5.x1 = s[0][0], c5.y1 = s[0][1], c5.x2 = s[1][0], c5.y2 = s[1][1], c5.percent = 1;
          var r5 = s[2];
          r5 ? (c5.cpx1 = r5[0], c5.cpy1 = r5[1]) : (c5.cpx1 = NaN, c5.cpy1 = NaN);
        }
        var uWn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this) || this;
            return S2._createLine(r5, g5, b6), S2;
          }
          return s.prototype._createLine = function(r5, g5, b6) {
            var S2 = r5.hostModel, A2 = r5.getItemLayout(g5), k2 = lWn(A2);
            k2.shape.percent = 0, tv(k2, { shape: { percent: 1 } }, S2, g5), this.add(k2), Ye2(jHt, function(R6) {
              var B3 = p5e(R6, r5, g5);
              this.add(B3), this[h5e(R6)] = r5.getItemVisual(g5, R6);
            }, this), this._updateCommonStl(r5, g5, b6);
          }, s.prototype.updateData = function(r5, g5, b6) {
            var S2 = r5.hostModel, A2 = this.childOfName("line"), k2 = r5.getItemLayout(g5), R6 = { shape: {} };
            WHt(R6.shape, k2), Qf2(A2, R6, S2, g5), Ye2(jHt, function(B3) {
              var G3 = r5.getItemVisual(g5, B3), Z3 = h5e(B3);
              if (this[Z3] !== G3) {
                this.remove(this.childOfName(B3));
                var X3 = p5e(B3, r5, g5);
                this.add(X3);
              }
              this[Z3] = G3;
            }, this), this._updateCommonStl(r5, g5, b6);
          }, s.prototype.getLinePath = function() {
            return this.childAt(0);
          }, s.prototype._updateCommonStl = function(r5, g5, b6) {
            var S2 = r5.hostModel, A2 = this.childOfName("line"), k2 = b6 && b6.emphasisLineStyle, R6 = b6 && b6.blurLineStyle, B3 = b6 && b6.selectLineStyle, G3 = b6 && b6.labelStatesModels, Z3 = b6 && b6.emphasisDisabled, X3 = b6 && b6.focus, tt = b6 && b6.blurScope;
            if (!b6 || r5.hasItemOption) {
              var it = r5.getItemModel(g5), pt = it.getModel("emphasis");
              k2 = pt.getModel("lineStyle").getLineStyle(), R6 = it.getModel(["blur", "lineStyle"]).getLineStyle(), B3 = it.getModel(["select", "lineStyle"]).getLineStyle(), Z3 = pt.get("disabled"), X3 = pt.get("focus"), tt = pt.get("blurScope"), G3 = qb2(it);
            }
            var mt = r5.getItemVisual(g5, "style"), Mt = mt.stroke;
            A2.useStyle(mt), A2.style.fill = null, A2.style.strokeNoScale = true, A2.ensureState("emphasis").style = k2, A2.ensureState("blur").style = R6, A2.ensureState("select").style = B3, Ye2(jHt, function(ae2) {
              var de2 = this.childOfName(ae2);
              if (de2) {
                de2.setColor(Mt), de2.style.opacity = mt.opacity;
                for (var we2 = 0; we2 < k0.length; we2++) {
                  var Se2 = k0[we2], Oe2 = A2.getState(Se2);
                  if (Oe2) {
                    var je2 = Oe2.style || {}, rn = de2.ensureState(Se2), qe2 = rn.style || (rn.style = {});
                    je2.stroke != null && (qe2[de2.__isEmptyBrush ? "stroke" : "fill"] = je2.stroke), je2.opacity != null && (qe2.opacity = je2.opacity);
                  }
                }
                de2.markRedraw();
              }
            }, this);
            var kt = S2.getRawValue(g5);
            Uw(this, G3, { labelDataIndex: g5, labelFetcher: { getFormattedLabel: function(ae2, de2) {
              return S2.getFormattedLabel(ae2, de2, r5.dataType);
            } }, inheritColor: Mt || "#000", defaultOpacity: mt.opacity, defaultText: (kt == null ? r5.getName(g5) : isFinite(kt) ? c0(kt) : kt) + "" });
            var Gt = this.getTextContent();
            if (Gt) {
              var Ot = G3.normal;
              Gt.__align = Gt.style.align, Gt.__verticalAlign = Gt.style.verticalAlign, Gt.__position = Ot.get("position") || "middle";
              var ce2 = Ot.get("distance");
              ja2(ce2) || (ce2 = [ce2, ce2]), Gt.__labelDistance = ce2;
            }
            this.setTextConfig({ position: null, local: true, inside: false }), f0(this, X3, tt, Z3);
          }, s.prototype.highlight = function() {
            GI(this);
          }, s.prototype.downplay = function() {
            HI(this);
          }, s.prototype.updateLayout = function(r5, g5) {
            this.setLinePoints(r5.getItemLayout(g5));
          }, s.prototype.setLinePoints = function(r5) {
            var g5 = this.childOfName("line");
            WHt(g5.shape, r5), g5.dirty();
          }, s.prototype.beforeUpdate = function() {
            var r5 = this, g5 = r5.childOfName("fromSymbol"), b6 = r5.childOfName("toSymbol"), S2 = r5.getTextContent();
            if (!g5 && !b6 && (!S2 || S2.ignore))
              return;
            for (var A2 = 1, k2 = this.parent; k2; )
              k2.scaleX && (A2 /= k2.scaleX), k2 = k2.parent;
            var R6 = r5.childOfName("line");
            if (!this.__dirty && !R6.__dirty)
              return;
            var B3 = R6.shape.percent, G3 = R6.pointAt(0), Z3 = R6.pointAt(B3), X3 = kI([], Z3, G3);
            z4(X3, X3);
            function tt(Oe2, je2) {
              var rn = Oe2.__specifiedRotation;
              if (rn == null) {
                var qe2 = R6.tangentAt(je2);
                Oe2.attr("rotation", (je2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(qe2[1], qe2[0]));
              } else
                Oe2.attr("rotation", rn);
            }
            if (g5 && (g5.setPosition(G3), tt(g5, 0), g5.scaleX = g5.scaleY = A2 * B3, g5.markRedraw()), b6 && (b6.setPosition(Z3), tt(b6, 1), b6.scaleX = b6.scaleY = A2 * B3, b6.markRedraw()), S2 && !S2.ignore) {
              S2.x = S2.y = 0, S2.originX = S2.originY = 0;
              var it = void 0, pt = void 0, mt = S2.__labelDistance, Mt = mt[0] * A2, kt = mt[1] * A2, Gt = B3 / 2, Ot = R6.tangentAt(Gt), ce2 = [Ot[1], -Ot[0]], ae2 = R6.pointAt(Gt);
              ce2[1] > 0 && (ce2[0] = -ce2[0], ce2[1] = -ce2[1]);
              var de2 = Ot[0] < 0 ? -1 : 1;
              if (S2.__position !== "start" && S2.__position !== "end") {
                var we2 = -Math.atan2(Ot[1], Ot[0]);
                Z3[0] < G3[0] && (we2 = Math.PI + we2), S2.rotation = we2;
              }
              var Se2 = void 0;
              switch (S2.__position) {
                case "insideStartTop":
                case "insideMiddleTop":
                case "insideEndTop":
                case "middle":
                  Se2 = -kt, pt = "bottom";
                  break;
                case "insideStartBottom":
                case "insideMiddleBottom":
                case "insideEndBottom":
                  Se2 = kt, pt = "top";
                  break;
                default:
                  Se2 = 0, pt = "middle";
              }
              switch (S2.__position) {
                case "end":
                  S2.x = X3[0] * Mt + Z3[0], S2.y = X3[1] * kt + Z3[1], it = X3[0] > 0.8 ? "left" : X3[0] < -0.8 ? "right" : "center", pt = X3[1] > 0.8 ? "top" : X3[1] < -0.8 ? "bottom" : "middle";
                  break;
                case "start":
                  S2.x = -X3[0] * Mt + G3[0], S2.y = -X3[1] * kt + G3[1], it = X3[0] > 0.8 ? "right" : X3[0] < -0.8 ? "left" : "center", pt = X3[1] > 0.8 ? "bottom" : X3[1] < -0.8 ? "top" : "middle";
                  break;
                case "insideStartTop":
                case "insideStart":
                case "insideStartBottom":
                  S2.x = Mt * de2 + G3[0], S2.y = G3[1] + Se2, it = Ot[0] < 0 ? "right" : "left", S2.originX = -Mt * de2, S2.originY = -Se2;
                  break;
                case "insideMiddleTop":
                case "insideMiddle":
                case "insideMiddleBottom":
                case "middle":
                  S2.x = ae2[0], S2.y = ae2[1] + Se2, it = "center", S2.originY = -Se2;
                  break;
                case "insideEndTop":
                case "insideEnd":
                case "insideEndBottom":
                  S2.x = -Mt * de2 + Z3[0], S2.y = Z3[1] + Se2, it = Ot[0] >= 0 ? "right" : "left", S2.originX = Mt * de2, S2.originY = -Se2;
                  break;
              }
              S2.scaleX = S2.scaleY = A2, S2.setStyle({ verticalAlign: S2.__verticalAlign || pt, align: S2.__align || it });
            }
          }, s;
        }(nu), GHt = uWn, cWn = function() {
          function c5(s) {
            this.group = new nu(), this._LineCtor = s || GHt;
          }
          return c5.prototype.updateData = function(s) {
            var r5 = this;
            this._progressiveEls = null;
            var g5 = this, b6 = g5.group, S2 = g5._lineData;
            g5._lineData = s, S2 || b6.removeAll();
            var A2 = d5e(s);
            s.diff(S2).add(function(k2) {
              r5._doAdd(s, k2, A2);
            }).update(function(k2, R6) {
              r5._doUpdate(S2, s, R6, k2, A2);
            }).remove(function(k2) {
              b6.remove(S2.getItemGraphicEl(k2));
            }).execute();
          }, c5.prototype.updateLayout = function() {
            var s = this._lineData;
            !s || s.eachItemGraphicEl(function(r5, g5) {
              r5.updateLayout(s, g5);
            }, this);
          }, c5.prototype.incrementalPrepareUpdate = function(s) {
            this._seriesScope = d5e(s), this._lineData = null, this.group.removeAll();
          }, c5.prototype.incrementalUpdate = function(s, r5) {
            this._progressiveEls = [];
            function g5(k2) {
              !k2.isGroup && !fWn(k2) && (k2.incremental = true, k2.ensureState("emphasis").hoverLayer = true);
            }
            for (var b6 = s.start; b6 < s.end; b6++) {
              var S2 = r5.getItemLayout(b6);
              if (HHt(S2)) {
                var A2 = new this._LineCtor(r5, b6, this._seriesScope);
                A2.traverse(g5), this.group.add(A2), r5.setItemGraphicEl(b6, A2), this._progressiveEls.push(A2);
              }
            }
          }, c5.prototype.remove = function() {
            this.group.removeAll();
          }, c5.prototype.eachRendered = function(s) {
            Ik(this._progressiveEls || this.group, s);
          }, c5.prototype._doAdd = function(s, r5, g5) {
            var b6 = s.getItemLayout(r5);
            if (HHt(b6)) {
              var S2 = new this._LineCtor(s, r5, g5);
              s.setItemGraphicEl(r5, S2), this.group.add(S2);
            }
          }, c5.prototype._doUpdate = function(s, r5, g5, b6, S2) {
            var A2 = s.getItemGraphicEl(g5);
            if (!HHt(r5.getItemLayout(b6))) {
              this.group.remove(A2);
              return;
            }
            A2 ? A2.updateData(r5, b6, S2) : A2 = new this._LineCtor(r5, b6, S2), r5.setItemGraphicEl(b6, A2), this.group.add(A2);
          }, c5;
        }();
        function fWn(c5) {
          return c5.animators && c5.animators.length > 0;
        }
        function d5e(c5) {
          var s = c5.hostModel, r5 = s.getModel("emphasis");
          return { lineStyle: s.getModel("lineStyle").getLineStyle(), emphasisLineStyle: r5.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: s.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: s.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: r5.get("disabled"), blurScope: r5.get("blurScope"), focus: r5.get("focus"), labelStatesModels: qb2(s) };
        }
        function g5e(c5) {
          return isNaN(c5[0]) || isNaN(c5[1]);
        }
        function HHt(c5) {
          return c5 && !g5e(c5[0]) && !g5e(c5[1]);
        }
        var UHt = cWn, qHt = [], ZHt = [], $Ht = [], IX = Hm, YHt = j4, v5e = Math.abs;
        function y5e(c5, s, r5) {
          for (var g5 = c5[0], b6 = c5[1], S2 = c5[2], A2 = 1 / 0, k2, R6 = r5 * r5, B3 = 0.1, G3 = 0.1; G3 <= 0.9; G3 += 0.1) {
            qHt[0] = IX(g5[0], b6[0], S2[0], G3), qHt[1] = IX(g5[1], b6[1], S2[1], G3);
            var Z3 = v5e(YHt(qHt, s) - R6);
            Z3 < A2 && (A2 = Z3, k2 = G3);
          }
          for (var X3 = 0; X3 < 32; X3++) {
            var tt = k2 + B3;
            ZHt[0] = IX(g5[0], b6[0], S2[0], k2), ZHt[1] = IX(g5[1], b6[1], S2[1], k2), $Ht[0] = IX(g5[0], b6[0], S2[0], tt), $Ht[1] = IX(g5[1], b6[1], S2[1], tt);
            var Z3 = YHt(ZHt, s) - R6;
            if (v5e(Z3) < 0.01)
              break;
            var it = YHt($Ht, s) - R6;
            B3 /= 2, Z3 < 0 ? it >= 0 ? k2 = k2 + B3 : k2 = k2 - B3 : it >= 0 ? k2 = k2 - B3 : k2 = k2 + B3;
          }
          return k2;
        }
        function KHt(c5, s) {
          var r5 = [], g5 = u0, b6 = [[], [], []], S2 = [[], []], A2 = [];
          s /= 2, c5.eachEdge(function(k2, R6) {
            var B3 = k2.getLayout(), G3 = k2.getVisual("fromSymbol"), Z3 = k2.getVisual("toSymbol");
            B3.__original || (B3.__original = [Iy(B3[0]), Iy(B3[1])], B3[2] && B3.__original.push(Iy(B3[2])));
            var X3 = B3.__original;
            if (B3[2] != null) {
              if (ux(b6[0], X3[0]), ux(b6[1], X3[2]), ux(b6[2], X3[1]), G3 && G3 !== "none") {
                var tt = rft(k2.node1), it = y5e(b6, X3[0], tt * s);
                g5(b6[0][0], b6[1][0], b6[2][0], it, r5), b6[0][0] = r5[3], b6[1][0] = r5[4], g5(b6[0][1], b6[1][1], b6[2][1], it, r5), b6[0][1] = r5[3], b6[1][1] = r5[4];
              }
              if (Z3 && Z3 !== "none") {
                var tt = rft(k2.node2), it = y5e(b6, X3[1], tt * s);
                g5(b6[0][0], b6[1][0], b6[2][0], it, r5), b6[1][0] = r5[1], b6[2][0] = r5[2], g5(b6[0][1], b6[1][1], b6[2][1], it, r5), b6[1][1] = r5[1], b6[2][1] = r5[2];
              }
              ux(B3[0], b6[0]), ux(B3[1], b6[2]), ux(B3[2], b6[1]);
            } else {
              if (ux(S2[0], X3[0]), ux(S2[1], X3[1]), kI(A2, S2[1], S2[0]), z4(A2, A2), G3 && G3 !== "none") {
                var tt = rft(k2.node1);
                EI(S2[0], S2[0], A2, tt * s);
              }
              if (Z3 && Z3 !== "none") {
                var tt = rft(k2.node2);
                EI(S2[1], S2[1], A2, -tt * s);
              }
              ux(B3[0], S2[0]), ux(B3[1], S2[1]);
            }
          });
        }
        function m5e(c5) {
          return c5.type === "view";
        }
        var hWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5, g5) {
            var b6 = new Vct(), S2 = new UHt(), A2 = this.group;
            this._controller = new Hct(g5.getZr()), this._controllerHost = { target: A2 }, A2.add(b6.group), A2.add(S2.group), this._symbolDraw = b6, this._lineDraw = S2, this._firstRender = true;
          }, s.prototype.render = function(r5, g5, b6) {
            var S2 = this, A2 = r5.coordinateSystem;
            this._model = r5;
            var k2 = this._symbolDraw, R6 = this._lineDraw, B3 = this.group;
            if (m5e(A2)) {
              var G3 = { x: A2.x, y: A2.y, scaleX: A2.scaleX, scaleY: A2.scaleY };
              this._firstRender ? B3.attr(G3) : Qf2(B3, G3, r5);
            }
            KHt(r5.getGraph(), nft(r5));
            var Z3 = r5.getData();
            k2.updateData(Z3);
            var X3 = r5.getEdgeData();
            R6.updateData(X3), this._updateNodeAndLinkScale(), this._updateController(r5, g5, b6), clearTimeout(this._layoutTimeout);
            var tt = r5.forceLayout, it = r5.get(["force", "layoutAnimation"]);
            tt && this._startForceLayoutIteration(tt, it), Z3.graph.eachNode(function(kt) {
              var Gt = kt.dataIndex, Ot = kt.getGraphicEl(), ce2 = kt.getModel();
              if (Ot) {
                Ot.off("drag").off("dragend");
                var ae2 = ce2.get("draggable");
                ae2 && Ot.on("drag", function() {
                  tt && (tt.warmUp(), !S2._layouting && S2._startForceLayoutIteration(tt, it), tt.setFixed(Gt), Z3.setItemLayout(Gt, [Ot.x, Ot.y]));
                }).on("dragend", function() {
                  tt && tt.setUnfixed(Gt);
                }), Ot.setDraggable(ae2 && !!tt);
                var de2 = ce2.get(["emphasis", "focus"]);
                de2 === "adjacency" && (Pl(Ot).focus = kt.getAdjacentDataIndices());
              }
            }), Z3.graph.eachEdge(function(kt) {
              var Gt = kt.getGraphicEl(), Ot = kt.getModel().get(["emphasis", "focus"]);
              !Gt || Ot === "adjacency" && (Pl(Gt).focus = { edge: [kt.dataIndex], node: [kt.node1.dataIndex, kt.node2.dataIndex] });
            });
            var pt = r5.get("layout") === "circular" && r5.get(["circular", "rotateLabel"]), mt = Z3.getLayout("cx"), Mt = Z3.getLayout("cy");
            Z3.eachItemGraphicEl(function(kt, Gt) {
              var Ot = Z3.getItemModel(Gt), ce2 = Ot.get(["label", "rotate"]) || 0, ae2 = kt.getSymbolPath();
              if (pt) {
                var de2 = Z3.getItemLayout(Gt), we2 = Math.atan2(de2[1] - Mt, de2[0] - mt);
                we2 < 0 && (we2 = Math.PI * 2 + we2);
                var Se2 = de2[0] < mt;
                Se2 && (we2 = we2 - Math.PI);
                var Oe2 = Se2 ? "left" : "right";
                ae2.setTextConfig({ rotation: -we2, position: Oe2, origin: "center" });
                var je2 = ae2.ensureState("emphasis");
                sa2(je2.textConfig || (je2.textConfig = {}), { position: Oe2 });
              } else
                ae2.setTextConfig({ rotation: ce2 *= Math.PI / 180 });
            }), this._firstRender = false;
          }, s.prototype.dispose = function() {
            this._controller && this._controller.dispose(), this._controllerHost = null;
          }, s.prototype._startForceLayoutIteration = function(r5, g5) {
            var b6 = this;
            (function S2() {
              r5.step(function(A2) {
                b6.updateLayout(b6._model), (b6._layouting = !A2) && (g5 ? b6._layoutTimeout = setTimeout(S2, 16) : S2());
              });
            })();
          }, s.prototype._updateController = function(r5, g5, b6) {
            var S2 = this, A2 = this._controller, k2 = this._controllerHost, R6 = this.group;
            if (A2.setPointerChecker(function(B3, G3, Z3) {
              var X3 = R6.getBoundingRect();
              return X3.applyTransform(R6.transform), X3.contain(G3, Z3) && !XMt(B3, b6, r5);
            }), !m5e(r5.coordinateSystem)) {
              A2.disable();
              return;
            }
            A2.enable(r5.get("roam")), k2.zoomLimit = r5.get("scaleLimit"), k2.zoom = r5.coordinateSystem.getZoom(), A2.off("pan").off("zoom").on("pan", function(B3) {
              pHt(k2, B3.dx, B3.dy), b6.dispatchAction({ seriesId: r5.id, type: "graphRoam", dx: B3.dx, dy: B3.dy });
            }).on("zoom", function(B3) {
              dHt(k2, B3.scale, B3.originX, B3.originY), b6.dispatchAction({ seriesId: r5.id, type: "graphRoam", zoom: B3.scale, originX: B3.originX, originY: B3.originY }), S2._updateNodeAndLinkScale(), KHt(r5.getGraph(), nft(r5)), S2._lineDraw.updateLayout(), b6.updateLabelLayout();
            });
          }, s.prototype._updateNodeAndLinkScale = function() {
            var r5 = this._model, g5 = r5.getData(), b6 = nft(r5);
            g5.eachItemGraphicEl(function(S2, A2) {
              S2 && S2.setSymbolScale(b6);
            });
          }, s.prototype.updateLayout = function(r5) {
            KHt(r5.getGraph(), nft(r5)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
          }, s.prototype.remove = function(r5, g5) {
            this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
          }, s.type = "graph", s;
        }(Ig2), pWn = hWn;
        function DX(c5) {
          return "_EC_" + c5;
        }
        var dWn = function() {
          function c5(s) {
            this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = s || false;
          }
          return c5.prototype.isDirected = function() {
            return this._directed;
          }, c5.prototype.addNode = function(s, r5) {
            s = s == null ? "" + r5 : "" + s;
            var g5 = this._nodesMap;
            if (!g5[DX(s)]) {
              var b6 = new IW(s, r5);
              return b6.hostGraph = this, this.nodes.push(b6), g5[DX(s)] = b6, b6;
            }
          }, c5.prototype.getNodeByIndex = function(s) {
            var r5 = this.data.getRawIndex(s);
            return this.nodes[r5];
          }, c5.prototype.getNodeById = function(s) {
            return this._nodesMap[DX(s)];
          }, c5.prototype.addEdge = function(s, r5, g5) {
            var b6 = this._nodesMap, S2 = this._edgesMap;
            if (Oh2(s) && (s = this.nodes[s]), Oh2(r5) && (r5 = this.nodes[r5]), s instanceof IW || (s = b6[DX(s)]), r5 instanceof IW || (r5 = b6[DX(r5)]), !(!s || !r5)) {
              var A2 = s.id + "-" + r5.id, k2 = new b5e(s, r5, g5);
              return k2.hostGraph = this, this._directed && (s.outEdges.push(k2), r5.inEdges.push(k2)), s.edges.push(k2), s !== r5 && r5.edges.push(k2), this.edges.push(k2), S2[A2] = k2, k2;
            }
          }, c5.prototype.getEdgeByIndex = function(s) {
            var r5 = this.edgeData.getRawIndex(s);
            return this.edges[r5];
          }, c5.prototype.getEdge = function(s, r5) {
            s instanceof IW && (s = s.id), r5 instanceof IW && (r5 = r5.id);
            var g5 = this._edgesMap;
            return this._directed ? g5[s + "-" + r5] : g5[s + "-" + r5] || g5[r5 + "-" + s];
          }, c5.prototype.eachNode = function(s, r5) {
            for (var g5 = this.nodes, b6 = g5.length, S2 = 0; S2 < b6; S2++)
              g5[S2].dataIndex >= 0 && s.call(r5, g5[S2], S2);
          }, c5.prototype.eachEdge = function(s, r5) {
            for (var g5 = this.edges, b6 = g5.length, S2 = 0; S2 < b6; S2++)
              g5[S2].dataIndex >= 0 && g5[S2].node1.dataIndex >= 0 && g5[S2].node2.dataIndex >= 0 && s.call(r5, g5[S2], S2);
          }, c5.prototype.breadthFirstTraverse = function(s, r5, g5, b6) {
            if (r5 instanceof IW || (r5 = this._nodesMap[DX(r5)]), !!r5) {
              for (var S2 = g5 === "out" ? "outEdges" : g5 === "in" ? "inEdges" : "edges", A2 = 0; A2 < this.nodes.length; A2++)
                this.nodes[A2].__visited = false;
              if (!s.call(b6, r5, null))
                for (var k2 = [r5]; k2.length; )
                  for (var R6 = k2.shift(), B3 = R6[S2], A2 = 0; A2 < B3.length; A2++) {
                    var G3 = B3[A2], Z3 = G3.node1 === R6 ? G3.node2 : G3.node1;
                    if (!Z3.__visited) {
                      if (s.call(b6, Z3, R6))
                        return;
                      k2.push(Z3), Z3.__visited = true;
                    }
                  }
            }
          }, c5.prototype.update = function() {
            for (var s = this.data, r5 = this.edgeData, g5 = this.nodes, b6 = this.edges, S2 = 0, A2 = g5.length; S2 < A2; S2++)
              g5[S2].dataIndex = -1;
            for (var S2 = 0, A2 = s.count(); S2 < A2; S2++)
              g5[s.getRawIndex(S2)].dataIndex = S2;
            r5.filterSelf(function(k2) {
              var R6 = b6[r5.getRawIndex(k2)];
              return R6.node1.dataIndex >= 0 && R6.node2.dataIndex >= 0;
            });
            for (var S2 = 0, A2 = b6.length; S2 < A2; S2++)
              b6[S2].dataIndex = -1;
            for (var S2 = 0, A2 = r5.count(); S2 < A2; S2++)
              b6[r5.getRawIndex(S2)].dataIndex = S2;
          }, c5.prototype.clone = function() {
            for (var s = new c5(this._directed), r5 = this.nodes, g5 = this.edges, b6 = 0; b6 < r5.length; b6++)
              s.addNode(r5[b6].id, r5[b6].dataIndex);
            for (var b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6];
              s.addEdge(S2.node1.id, S2.node2.id, S2.dataIndex);
            }
            return s;
          }, c5;
        }(), IW = function() {
          function c5(s, r5) {
            this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = s == null ? "" : s, this.dataIndex = r5 == null ? -1 : r5;
          }
          return c5.prototype.degree = function() {
            return this.edges.length;
          }, c5.prototype.inDegree = function() {
            return this.inEdges.length;
          }, c5.prototype.outDegree = function() {
            return this.outEdges.length;
          }, c5.prototype.getModel = function(s) {
            if (!(this.dataIndex < 0)) {
              var r5 = this.hostGraph, g5 = r5.data.getItemModel(this.dataIndex);
              return g5.getModel(s);
            }
          }, c5.prototype.getAdjacentDataIndices = function() {
            for (var s = { edge: [], node: [] }, r5 = 0; r5 < this.edges.length; r5++) {
              var g5 = this.edges[r5];
              g5.dataIndex < 0 || (s.edge.push(g5.dataIndex), s.node.push(g5.node1.dataIndex, g5.node2.dataIndex));
            }
            return s;
          }, c5;
        }(), b5e = function() {
          function c5(s, r5, g5) {
            this.dataIndex = -1, this.node1 = s, this.node2 = r5, this.dataIndex = g5 == null ? -1 : g5;
          }
          return c5.prototype.getModel = function(s) {
            if (!(this.dataIndex < 0)) {
              var r5 = this.hostGraph, g5 = r5.edgeData.getItemModel(this.dataIndex);
              return g5.getModel(s);
            }
          }, c5.prototype.getAdjacentDataIndices = function() {
            return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
          }, c5;
        }();
        function _5e(c5, s) {
          return { getValue: function(r5) {
            var g5 = this[c5][s];
            return g5.getStore().get(g5.getDimensionIndex(r5 || "value"), this.dataIndex);
          }, setVisual: function(r5, g5) {
            this.dataIndex >= 0 && this[c5][s].setItemVisual(this.dataIndex, r5, g5);
          }, getVisual: function(r5) {
            return this[c5][s].getItemVisual(this.dataIndex, r5);
          }, setLayout: function(r5, g5) {
            this.dataIndex >= 0 && this[c5][s].setItemLayout(this.dataIndex, r5, g5);
          }, getLayout: function() {
            return this[c5][s].getItemLayout(this.dataIndex);
          }, getGraphicEl: function() {
            return this[c5][s].getItemGraphicEl(this.dataIndex);
          }, getRawIndex: function() {
            return this[c5][s].getRawIndex(this.dataIndex);
          } };
        }
        A0(IW, _5e("hostGraph", "data")), A0(b5e, _5e("hostGraph", "edgeData"));
        var gWn = dWn;
        function x5e(c5, s, r5, g5, b6) {
          for (var S2 = new gWn(g5), A2 = 0; A2 < c5.length; A2++)
            S2.addNode(Wm(c5[A2].id, c5[A2].name, A2), A2);
          for (var k2 = [], R6 = [], B3 = 0, A2 = 0; A2 < s.length; A2++) {
            var G3 = s[A2], Z3 = G3.source, X3 = G3.target;
            S2.addEdge(Z3, X3, B3) && (R6.push(G3), k2.push(Wm(Q0(G3.id, null), Z3 + " > " + X3)), B3++);
          }
          var tt = r5.get("coordinateSystem"), it;
          if (tt === "cartesian2d" || tt === "polar")
            it = SR(c5, r5);
          else {
            var pt = oct.get(tt), mt = pt ? pt.dimensions || [] : [];
            Lu(mt, "value") < 0 && mt.concat(["value"]);
            var Mt = Act(c5, { coordDimensions: mt, encodeDefine: r5.getEncode() }).dimensions;
            it = new m22(Mt, r5), it.initData(c5);
          }
          var kt = new m22(["value"], r5);
          return kt.initData(R6, k2), b6 && b6(it, kt), Rke({ mainData: it, struct: S2, structAttr: "graph", datas: { node: it, edge: kt }, datasAttr: { node: "data", edge: "edgeData" } }), S2.update(), S2;
        }
        var vWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.hasSymbolVisual = true, r5;
          }
          return s.prototype.init = function(r5) {
            c5.prototype.init.apply(this, arguments);
            var g5 = this;
            function b6() {
              return g5._categoriesData;
            }
            this.legendVisualProvider = new jct(b6, b6), this.fillDataTextStyle(r5.edges || r5.links), this._updateCategoriesData();
          }, s.prototype.mergeOption = function(r5) {
            c5.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(r5.edges || r5.links), this._updateCategoriesData();
          }, s.prototype.mergeDefaultAndTheme = function(r5) {
            c5.prototype.mergeDefaultAndTheme.apply(this, arguments), wM(r5, "edgeLabel", ["show"]);
          }, s.prototype.getInitialData = function(r5, g5) {
            var b6 = r5.edges || r5.links || [], S2 = r5.data || r5.nodes || [], A2 = this;
            if (S2 && b6) {
              Xjn(this);
              var k2 = x5e(S2, b6, this, true, R6);
              return Ye2(k2.edges, function(B3) {
                Qjn(B3.node1, B3.node2, this, B3.dataIndex);
              }, this), k2.data;
            }
            function R6(B3, G3) {
              B3.wrapMethod("getItemModel", function(it) {
                var pt = A2._categoriesModels, mt = it.getShallow("category"), Mt = pt[mt];
                return Mt && (Mt.parentModel = it.parentModel, it.parentModel = Mt), it;
              });
              var Z3 = Ag2.prototype.getModel;
              function X3(it, pt) {
                var mt = Z3.call(this, it, pt);
                return mt.resolveParentPath = tt, mt;
              }
              G3.wrapMethod("getItemModel", function(it) {
                return it.resolveParentPath = tt, it.getModel = X3, it;
              });
              function tt(it) {
                if (it && (it[0] === "label" || it[1] === "label")) {
                  var pt = it.slice();
                  return it[0] === "label" ? pt[0] = "edgeLabel" : it[1] === "label" && (pt[1] = "edgeLabel"), pt;
                }
                return it;
              }
            }
          }, s.prototype.getGraph = function() {
            return this.getData().graph;
          }, s.prototype.getEdgeData = function() {
            return this.getGraph().edgeData;
          }, s.prototype.getCategoriesData = function() {
            return this._categoriesData;
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            if (b6 === "edge") {
              var S2 = this.getData(), A2 = this.getDataParams(r5, b6), k2 = S2.graph.getEdgeByIndex(r5), R6 = S2.getName(k2.node1.dataIndex), B3 = S2.getName(k2.node2.dataIndex), G3 = [];
              return R6 != null && G3.push(R6), B3 != null && G3.push(B3), W1("nameValue", { name: G3.join(" > "), value: A2.value, noValue: A2.value == null });
            }
            var Z3 = lAe({ series: this, dataIndex: r5, multipleSeries: g5 });
            return Z3;
          }, s.prototype._updateCategoriesData = function() {
            var r5 = Ha2(this.option.categories || [], function(b6) {
              return b6.value != null ? b6 : sa2({ value: 0 }, b6);
            }), g5 = new m22(["value"], this);
            g5.initData(r5), this._categoriesData = g5, this._categoriesModels = g5.mapArray(function(b6) {
              return g5.getItemModel(b6);
            });
          }, s.prototype.setZoom = function(r5) {
            this.option.zoom = r5;
          }, s.prototype.setCenter = function(r5) {
            this.option.center = r5;
          }, s.prototype.isAnimationEnabled = function() {
            return c5.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
          }, s.type = "series.graph", s.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], s.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, s;
        }(zv), yWn = vWn, mWn = { type: "graphRoam", event: "graphRoam", update: "none" };
        function bWn(c5) {
          c5.registerChartView(pWn), c5.registerSeriesModel(yWn), c5.registerProcessor(qjn), c5.registerVisual(Zjn), c5.registerVisual($jn), c5.registerLayout(Jjn), c5.registerLayout(c5.PRIORITY.VISUAL.POST_CHART_LAYOUT, eWn), c5.registerLayout(rWn), c5.registerCoordinateSystem("graphView", { dimensions: qct.dimensions, create: aWn }), c5.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, I0), c5.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, I0), c5.registerAction(mWn, function(s, r5) {
            r5.eachComponent({ mainType: "series", query: s }, function(g5) {
              var b6 = g5.coordinateSystem, S2 = bHt(b6, s);
              g5.setCenter && g5.setCenter(S2.center), g5.setZoom && g5.setZoom(S2.zoom);
            });
          });
        }
        var _Wn = function() {
          function c5() {
            this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
          }
          return c5;
        }(), xWn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "pointer", g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new _Wn();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = Math.cos, S2 = Math.sin, A2 = g5.r, k2 = g5.width, R6 = g5.angle, B3 = g5.x - b6(R6) * k2 * (k2 >= A2 / 3 ? 1 : 2), G3 = g5.y - S2(R6) * k2 * (k2 >= A2 / 3 ? 1 : 2);
            R6 = g5.angle - Math.PI / 2, r5.moveTo(B3, G3), r5.lineTo(g5.x + b6(R6) * k2, g5.y + S2(R6) * k2), r5.lineTo(g5.x + b6(g5.angle) * A2, g5.y + S2(g5.angle) * A2), r5.lineTo(g5.x - b6(R6) * k2, g5.y - S2(R6) * k2), r5.lineTo(B3, G3);
          }, s;
        }(Tc2), wWn = xWn;
        function SWn(c5, s) {
          var r5 = c5.get("center"), g5 = s.getWidth(), b6 = s.getHeight(), S2 = Math.min(g5, b6), A2 = $o(r5[0], s.getWidth()), k2 = $o(r5[1], s.getHeight()), R6 = $o(c5.get("radius"), S2 / 2);
          return { cx: A2, cy: k2, r: R6 };
        }
        function cCt(c5, s) {
          var r5 = c5 == null ? "" : c5 + "";
          return s && (gs(s) ? r5 = s.replace("{value}", r5) : Tl(s) && (r5 = s(c5))), r5;
        }
        var XHt = Math.PI * 2, MWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            this.group.removeAll();
            var S2 = r5.get(["axisLine", "lineStyle", "color"]), A2 = SWn(r5, b6);
            this._renderMain(r5, g5, b6, S2, A2), this._data = r5.getData();
          }, s.prototype.dispose = function() {
          }, s.prototype._renderMain = function(r5, g5, b6, S2, A2) {
            for (var k2 = this.group, R6 = r5.get("clockwise"), B3 = -r5.get("startAngle") / 180 * Math.PI, G3 = -r5.get("endAngle") / 180 * Math.PI, Z3 = r5.getModel("axisLine"), X3 = Z3.get("roundCap"), tt = X3 ? HMt : Ww, it = Z3.get("show"), pt = Z3.getModel("lineStyle"), mt = pt.get("width"), Mt = !((G3 - B3) % XHt) && G3 !== B3 ? XHt : (G3 - B3) % XHt, kt = B3, Gt = 0; it && Gt < S2.length; Gt++) {
              var Ot = Math.min(Math.max(S2[Gt][0], 0), 1);
              G3 = B3 + Mt * Ot;
              var ce2 = new tt({ shape: { startAngle: kt, endAngle: G3, cx: A2.cx, cy: A2.cy, clockwise: R6, r0: A2.r - mt, r: A2.r }, silent: true });
              ce2.setStyle({ fill: S2[Gt][1] }), ce2.setStyle(pt.getLineStyle(["color", "width"])), k2.add(ce2), kt = G3;
            }
            var ae2 = function(we2) {
              if (we2 <= 0)
                return S2[0][1];
              var Se2;
              for (Se2 = 0; Se2 < S2.length; Se2++)
                if (S2[Se2][0] >= we2 && (Se2 === 0 ? 0 : S2[Se2 - 1][0]) < we2)
                  return S2[Se2][1];
              return S2[Se2 - 1][1];
            };
            if (!R6) {
              var de2 = B3;
              B3 = G3, G3 = de2;
            }
            this._renderTicks(r5, g5, b6, ae2, A2, B3, G3, R6, mt), this._renderTitleAndDetail(r5, g5, b6, ae2, A2), this._renderAnchor(r5, A2), this._renderPointer(r5, g5, b6, ae2, A2, B3, G3, R6, mt);
          }, s.prototype._renderTicks = function(r5, g5, b6, S2, A2, k2, R6, B3, G3) {
            for (var Z3 = this.group, X3 = A2.cx, tt = A2.cy, it = A2.r, pt = +r5.get("min"), mt = +r5.get("max"), Mt = r5.getModel("splitLine"), kt = r5.getModel("axisTick"), Gt = r5.getModel("axisLabel"), Ot = r5.get("splitNumber"), ce2 = kt.get("splitNumber"), ae2 = $o(Mt.get("length"), it), de2 = $o(kt.get("length"), it), we2 = k2, Se2 = (R6 - k2) / Ot, Oe2 = Se2 / ce2, je2 = Mt.getModel("lineStyle").getLineStyle(), rn = kt.getModel("lineStyle").getLineStyle(), qe2 = Mt.get("distance"), An, jn, _n = 0; _n <= Ot; _n++) {
              if (An = Math.cos(we2), jn = Math.sin(we2), Mt.get("show")) {
                var Jr = qe2 ? qe2 + G3 : G3, Qn = new Zm({ shape: { x1: An * (it - Jr) + X3, y1: jn * (it - Jr) + tt, x2: An * (it - ae2 - Jr) + X3, y2: jn * (it - ae2 - Jr) + tt }, style: je2, silent: true });
                je2.stroke === "auto" && Qn.setStyle({ stroke: S2(_n / Ot) }), Z3.add(Qn);
              }
              if (Gt.get("show")) {
                var Jr = Gt.get("distance") + qe2, rr = cCt(c0(_n / Ot * (mt - pt) + pt), Gt.get("formatter")), Ar = S2(_n / Ot);
                Z3.add(new hh2({ style: Ey(Gt, { text: rr, x: An * (it - ae2 - Jr) + X3, y: jn * (it - ae2 - Jr) + tt, verticalAlign: jn < -0.8 ? "top" : jn > 0.8 ? "bottom" : "middle", align: An < -0.4 ? "left" : An > 0.4 ? "right" : "center" }, { inheritColor: Ar }), silent: true }));
              }
              if (kt.get("show") && _n !== Ot) {
                var Jr = kt.get("distance");
                Jr = Jr ? Jr + G3 : G3;
                for (var fi2 = 0; fi2 <= ce2; fi2++) {
                  An = Math.cos(we2), jn = Math.sin(we2);
                  var mi2 = new Zm({ shape: { x1: An * (it - Jr) + X3, y1: jn * (it - Jr) + tt, x2: An * (it - de2 - Jr) + X3, y2: jn * (it - de2 - Jr) + tt }, silent: true, style: rn });
                  rn.stroke === "auto" && mi2.setStyle({ stroke: S2((_n + fi2 / ce2) / Ot) }), Z3.add(mi2), we2 += Oe2;
                }
                we2 -= Oe2;
              } else
                we2 += Se2;
            }
          }, s.prototype._renderPointer = function(r5, g5, b6, S2, A2, k2, R6, B3, G3) {
            var Z3 = this.group, X3 = this._data, tt = this._progressEls, it = [], pt = r5.get(["pointer", "show"]), mt = r5.getModel("progress"), Mt = mt.get("show"), kt = r5.getData(), Gt = kt.mapDimension("value"), Ot = +r5.get("min"), ce2 = +r5.get("max"), ae2 = [Ot, ce2], de2 = [k2, R6];
            function we2(Oe2, je2) {
              var rn = kt.getItemModel(Oe2), qe2 = rn.getModel("pointer"), An = $o(qe2.get("width"), A2.r), jn = $o(qe2.get("length"), A2.r), _n = r5.get(["pointer", "icon"]), Jr = qe2.get("offsetCenter"), Qn = $o(Jr[0], A2.r), rr = $o(Jr[1], A2.r), Ar = qe2.get("keepAspect"), fi2;
              return _n ? fi2 = am(_n, Qn - An / 2, rr - jn, An, jn, null, Ar) : fi2 = new wWn({ shape: { angle: -Math.PI / 2, width: An, r: jn, x: Qn, y: rr } }), fi2.rotation = -(je2 + Math.PI / 2), fi2.x = A2.cx, fi2.y = A2.cy, fi2;
            }
            function Se2(Oe2, je2) {
              var rn = mt.get("roundCap"), qe2 = rn ? HMt : Ww, An = mt.get("overlap"), jn = An ? mt.get("width") : G3 / kt.count(), _n = An ? A2.r - jn : A2.r - (Oe2 + 1) * jn, Jr = An ? A2.r : A2.r - Oe2 * jn, Qn = new qe2({ shape: { startAngle: k2, endAngle: je2, cx: A2.cx, cy: A2.cy, clockwise: B3, r0: _n, r: Jr } });
              return An && (Qn.z2 = ce2 - kt.get(Gt, Oe2) % ce2), Qn;
            }
            (Mt || pt) && (kt.diff(X3).add(function(Oe2) {
              var je2 = kt.get(Gt, Oe2);
              if (pt) {
                var rn = we2(Oe2, k2);
                tv(rn, { rotation: -((isNaN(+je2) ? de2[0] : fh2(je2, ae2, de2, true)) + Math.PI / 2) }, r5), Z3.add(rn), kt.setItemGraphicEl(Oe2, rn);
              }
              if (Mt) {
                var qe2 = Se2(Oe2, k2), An = mt.get("clip");
                tv(qe2, { shape: { endAngle: fh2(je2, ae2, de2, An) } }, r5), Z3.add(qe2), Cut(r5.seriesIndex, kt.dataType, Oe2, qe2), it[Oe2] = qe2;
              }
            }).update(function(Oe2, je2) {
              var rn = kt.get(Gt, Oe2);
              if (pt) {
                var qe2 = X3.getItemGraphicEl(je2), An = qe2 ? qe2.rotation : k2, jn = we2(Oe2, An);
                jn.rotation = An, Qf2(jn, { rotation: -((isNaN(+rn) ? de2[0] : fh2(rn, ae2, de2, true)) + Math.PI / 2) }, r5), Z3.add(jn), kt.setItemGraphicEl(Oe2, jn);
              }
              if (Mt) {
                var _n = tt[je2], Jr = _n ? _n.shape.endAngle : k2, Qn = Se2(Oe2, Jr), rr = mt.get("clip");
                Qf2(Qn, { shape: { endAngle: fh2(rn, ae2, de2, rr) } }, r5), Z3.add(Qn), Cut(r5.seriesIndex, kt.dataType, Oe2, Qn), it[Oe2] = Qn;
              }
            }).execute(), kt.each(function(Oe2) {
              var je2 = kt.getItemModel(Oe2), rn = je2.getModel("emphasis"), qe2 = rn.get("focus"), An = rn.get("blurScope"), jn = rn.get("disabled");
              if (pt) {
                var _n = kt.getItemGraphicEl(Oe2), Jr = kt.getItemVisual(Oe2, "style"), Qn = Jr.fill;
                if (_n instanceof qm) {
                  var rr = _n.style;
                  _n.useStyle(sa2({ image: rr.image, x: rr.x, y: rr.y, width: rr.width, height: rr.height }, Jr));
                } else
                  _n.useStyle(Jr), _n.type !== "pointer" && _n.setColor(Qn);
                _n.setStyle(je2.getModel(["pointer", "itemStyle"]).getItemStyle()), _n.style.fill === "auto" && _n.setStyle("fill", S2(fh2(kt.get(Gt, Oe2), ae2, [0, 1], true))), _n.z2EmphasisLift = 0, z1(_n, je2), f0(_n, qe2, An, jn);
              }
              if (Mt) {
                var Ar = it[Oe2];
                Ar.useStyle(kt.getItemVisual(Oe2, "style")), Ar.setStyle(je2.getModel(["progress", "itemStyle"]).getItemStyle()), Ar.z2EmphasisLift = 0, z1(Ar, je2), f0(Ar, qe2, An, jn);
              }
            }), this._progressEls = it);
          }, s.prototype._renderAnchor = function(r5, g5) {
            var b6 = r5.getModel("anchor"), S2 = b6.get("show");
            if (S2) {
              var A2 = b6.get("size"), k2 = b6.get("icon"), R6 = b6.get("offsetCenter"), B3 = b6.get("keepAspect"), G3 = am(k2, g5.cx - A2 / 2 + $o(R6[0], g5.r), g5.cy - A2 / 2 + $o(R6[1], g5.r), A2, A2, null, B3);
              G3.z2 = b6.get("showAbove") ? 1 : 0, G3.setStyle(b6.getModel("itemStyle").getItemStyle()), this.group.add(G3);
            }
          }, s.prototype._renderTitleAndDetail = function(r5, g5, b6, S2, A2) {
            var k2 = this, R6 = r5.getData(), B3 = R6.mapDimension("value"), G3 = +r5.get("min"), Z3 = +r5.get("max"), X3 = new nu(), tt = [], it = [], pt = r5.isAnimationEnabled(), mt = r5.get(["pointer", "showAbove"]);
            R6.diff(this._data).add(function(Mt) {
              tt[Mt] = new hh2({ silent: true }), it[Mt] = new hh2({ silent: true });
            }).update(function(Mt, kt) {
              tt[Mt] = k2._titleEls[kt], it[Mt] = k2._detailEls[kt];
            }).execute(), R6.each(function(Mt) {
              var kt = R6.getItemModel(Mt), Gt = R6.get(B3, Mt), Ot = new nu(), ce2 = S2(fh2(Gt, [G3, Z3], [0, 1], true)), ae2 = kt.getModel("title");
              if (ae2.get("show")) {
                var de2 = ae2.get("offsetCenter"), we2 = A2.cx + $o(de2[0], A2.r), Se2 = A2.cy + $o(de2[1], A2.r), Oe2 = tt[Mt];
                Oe2.attr({ z2: mt ? 0 : 2, style: Ey(ae2, { x: we2, y: Se2, text: R6.getName(Mt), align: "center", verticalAlign: "middle" }, { inheritColor: ce2 }) }), Ot.add(Oe2);
              }
              var je2 = kt.getModel("detail");
              if (je2.get("show")) {
                var rn = je2.get("offsetCenter"), qe2 = A2.cx + $o(rn[0], A2.r), An = A2.cy + $o(rn[1], A2.r), jn = $o(je2.get("width"), A2.r), _n = $o(je2.get("height"), A2.r), Jr = r5.get(["progress", "show"]) ? R6.getItemVisual(Mt, "style").fill : ce2, Oe2 = it[Mt], Qn = je2.get("formatter");
                Oe2.attr({ z2: mt ? 0 : 2, style: Ey(je2, { x: qe2, y: An, text: cCt(Gt, Qn), width: isNaN(jn) ? null : jn, height: isNaN(_n) ? null : _n, align: "center", verticalAlign: "middle" }, { inheritColor: Jr }) }), NCe(Oe2, { normal: je2 }, Gt, function(Ar) {
                  return cCt(Ar, Qn);
                }), pt && FCe(Oe2, Mt, R6, r5, { getFormattedLabel: function(Ar, fi2, mi2, Oo, Ts, gl) {
                  return cCt(gl ? gl.interpolatedValue : Gt, Qn);
                } }), Ot.add(Oe2);
              }
              X3.add(Ot);
            }), this.group.add(X3), this._titleEls = tt, this._detailEls = it;
          }, s.type = "gauge", s;
        }(Ig2), CWn = MWn, TWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.visualStyleAccessPath = "itemStyle", r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            return MX(this, ["value"]);
          }, s.type = "series.gauge", s.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, s;
        }(zv), AWn = TWn;
        function IWn(c5) {
          c5.registerChartView(CWn), c5.registerSeriesModel(AWn);
        }
        var DWn = ["itemStyle", "opacity"], EWn = function(c5) {
          wn(s, c5);
          function s(r5, g5) {
            var b6 = c5.call(this) || this, S2 = b6, A2 = new Gw(), k2 = new hh2();
            return S2.setTextContent(k2), b6.setTextGuideLine(A2), b6.updateData(r5, g5, true), b6;
          }
          return s.prototype.updateData = function(r5, g5, b6) {
            var S2 = this, A2 = r5.hostModel, k2 = r5.getItemModel(g5), R6 = r5.getItemLayout(g5), B3 = k2.getModel("emphasis"), G3 = k2.get(DWn);
            G3 = G3 == null ? 1 : G3, b6 || nT(S2), S2.useStyle(r5.getItemVisual(g5, "style")), S2.style.lineJoin = "round", b6 ? (S2.setShape({ points: R6.points }), S2.style.opacity = 0, tv(S2, { style: { opacity: G3 } }, A2, g5)) : Qf2(S2, { style: { opacity: G3 }, shape: { points: R6.points } }, A2, g5), z1(S2, k2), this._updateLabel(r5, g5), f0(this, B3.get("focus"), B3.get("blurScope"), B3.get("disabled"));
          }, s.prototype._updateLabel = function(r5, g5) {
            var b6 = this, S2 = this.getTextGuideLine(), A2 = b6.getTextContent(), k2 = r5.hostModel, R6 = r5.getItemModel(g5), B3 = r5.getItemLayout(g5), G3 = B3.label, Z3 = r5.getItemVisual(g5, "style"), X3 = Z3.fill;
            Uw(A2, qb2(R6), { labelFetcher: r5.hostModel, labelDataIndex: g5, defaultOpacity: Z3.opacity, defaultText: r5.getName(g5) }, { normal: { align: G3.textAlign, verticalAlign: G3.verticalAlign } }), b6.setTextConfig({ local: true, inside: !!G3.inside, insideStroke: X3, outsideFill: X3 });
            var tt = G3.linePoints;
            S2.setShape({ points: tt }), b6.textGuideLineConfig = { anchor: tt ? new Bu(tt[0][0], tt[0][1]) : null }, Qf2(A2, { style: { x: G3.x, y: G3.y } }, k2, g5), A2.attr({ rotation: G3.rotation, originX: G3.x, originY: G3.y, z2: 10 }), OGt(b6, RGt(R6), { stroke: X3 });
          }, s;
        }(Gb2), kWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.ignoreLabelLineUpdate = true, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this._data, k2 = this.group;
            S2.diff(A2).add(function(R6) {
              var B3 = new EWn(S2, R6);
              S2.setItemGraphicEl(R6, B3), k2.add(B3);
            }).update(function(R6, B3) {
              var G3 = A2.getItemGraphicEl(B3);
              G3.updateData(S2, R6), k2.add(G3), S2.setItemGraphicEl(R6, G3);
            }).remove(function(R6) {
              var B3 = A2.getItemGraphicEl(R6);
              rW(B3, r5, R6);
            }).execute(), this._data = S2;
          }, s.prototype.remove = function() {
            this.group.removeAll(), this._data = null;
          }, s.prototype.dispose = function() {
          }, s.type = "funnel", s;
        }(Ig2), PWn = kWn, LWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5) {
            c5.prototype.init.apply(this, arguments), this.legendVisualProvider = new jct(Cs(this.getData, this), Cs(this.getRawData, this)), this._defaultLabelLine(r5);
          }, s.prototype.getInitialData = function(r5, g5) {
            return MX(this, { coordDimensions: ["value"], encodeDefaulter: Au(IWt, this) });
          }, s.prototype._defaultLabelLine = function(r5) {
            wM(r5, "labelLine", ["show"]);
            var g5 = r5.labelLine, b6 = r5.emphasis.labelLine;
            g5.show = g5.show && r5.label.show, b6.show = b6.show && r5.emphasis.label.show;
          }, s.prototype.getDataParams = function(r5) {
            var g5 = this.getData(), b6 = c5.prototype.getDataParams.call(this, r5), S2 = g5.mapDimension("value"), A2 = g5.getSum(S2);
            return b6.percent = A2 ? +(g5.get(S2, r5) / A2 * 100).toFixed(2) : 0, b6.$vars.push("percent"), b6;
          }, s.type = "series.funnel", s.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, s;
        }(zv), OWn = LWn;
        function RWn(c5, s) {
          return $m(c5.getBoxLayoutParams(), { width: s.getWidth(), height: s.getHeight() });
        }
        function NWn(c5, s) {
          for (var r5 = c5.mapDimension("value"), g5 = c5.mapArray(r5, function(R6) {
            return R6;
          }), b6 = [], S2 = s === "ascending", A2 = 0, k2 = c5.count(); A2 < k2; A2++)
            b6[A2] = A2;
          return Tl(s) ? b6.sort(s) : s !== "none" && b6.sort(function(R6, B3) {
            return S2 ? g5[R6] - g5[B3] : g5[B3] - g5[R6];
          }), b6;
        }
        function FWn(c5) {
          var s = c5.hostModel, r5 = s.get("orient");
          c5.each(function(g5) {
            var b6 = c5.getItemModel(g5), S2 = b6.getModel("label"), A2 = S2.get("position"), k2 = b6.getModel("labelLine"), R6 = c5.getItemLayout(g5), B3 = R6.points, G3 = A2 === "inner" || A2 === "inside" || A2 === "center" || A2 === "insideLeft" || A2 === "insideRight", Z3, X3, tt, it;
            if (G3)
              A2 === "insideLeft" ? (X3 = (B3[0][0] + B3[3][0]) / 2 + 5, tt = (B3[0][1] + B3[3][1]) / 2, Z3 = "left") : A2 === "insideRight" ? (X3 = (B3[1][0] + B3[2][0]) / 2 - 5, tt = (B3[1][1] + B3[2][1]) / 2, Z3 = "right") : (X3 = (B3[0][0] + B3[1][0] + B3[2][0] + B3[3][0]) / 4, tt = (B3[0][1] + B3[1][1] + B3[2][1] + B3[3][1]) / 4, Z3 = "center"), it = [[X3, tt], [X3, tt]];
            else {
              var pt = void 0, mt = void 0, Mt = void 0, kt = void 0, Gt = k2.get("length");
              A2 === "left" ? (pt = (B3[3][0] + B3[0][0]) / 2, mt = (B3[3][1] + B3[0][1]) / 2, Mt = pt - Gt, X3 = Mt - 5, Z3 = "right") : A2 === "right" ? (pt = (B3[1][0] + B3[2][0]) / 2, mt = (B3[1][1] + B3[2][1]) / 2, Mt = pt + Gt, X3 = Mt + 5, Z3 = "left") : A2 === "top" ? (pt = (B3[3][0] + B3[0][0]) / 2, mt = (B3[3][1] + B3[0][1]) / 2, kt = mt - Gt, tt = kt - 5, Z3 = "center") : A2 === "bottom" ? (pt = (B3[1][0] + B3[2][0]) / 2, mt = (B3[1][1] + B3[2][1]) / 2, kt = mt + Gt, tt = kt + 5, Z3 = "center") : A2 === "rightTop" ? (pt = r5 === "horizontal" ? B3[3][0] : B3[1][0], mt = r5 === "horizontal" ? B3[3][1] : B3[1][1], r5 === "horizontal" ? (kt = mt - Gt, tt = kt - 5, Z3 = "center") : (Mt = pt + Gt, X3 = Mt + 5, Z3 = "top")) : A2 === "rightBottom" ? (pt = B3[2][0], mt = B3[2][1], r5 === "horizontal" ? (kt = mt + Gt, tt = kt + 5, Z3 = "center") : (Mt = pt + Gt, X3 = Mt + 5, Z3 = "bottom")) : A2 === "leftTop" ? (pt = B3[0][0], mt = r5 === "horizontal" ? B3[0][1] : B3[1][1], r5 === "horizontal" ? (kt = mt - Gt, tt = kt - 5, Z3 = "center") : (Mt = pt - Gt, X3 = Mt - 5, Z3 = "right")) : A2 === "leftBottom" ? (pt = r5 === "horizontal" ? B3[1][0] : B3[3][0], mt = r5 === "horizontal" ? B3[1][1] : B3[2][1], r5 === "horizontal" ? (kt = mt + Gt, tt = kt + 5, Z3 = "center") : (Mt = pt - Gt, X3 = Mt - 5, Z3 = "right")) : (pt = (B3[1][0] + B3[2][0]) / 2, mt = (B3[1][1] + B3[2][1]) / 2, r5 === "horizontal" ? (kt = mt + Gt, tt = kt + 5, Z3 = "center") : (Mt = pt + Gt, X3 = Mt + 5, Z3 = "left")), r5 === "horizontal" ? (Mt = pt, X3 = Mt) : (kt = mt, tt = kt), it = [[pt, mt], [Mt, kt]];
            }
            R6.label = { linePoints: it, x: X3, y: tt, verticalAlign: "middle", textAlign: Z3, inside: G3 };
          });
        }
        function VWn(c5, s) {
          c5.eachSeriesByType("funnel", function(r5) {
            var g5 = r5.getData(), b6 = g5.mapDimension("value"), S2 = r5.get("sort"), A2 = RWn(r5, s), k2 = r5.get("orient"), R6 = A2.width, B3 = A2.height, G3 = NWn(g5, S2), Z3 = A2.x, X3 = A2.y, tt = k2 === "horizontal" ? [$o(r5.get("minSize"), B3), $o(r5.get("maxSize"), B3)] : [$o(r5.get("minSize"), R6), $o(r5.get("maxSize"), R6)], it = g5.getDataExtent(b6), pt = r5.get("min"), mt = r5.get("max");
            pt == null && (pt = Math.min(it[0], 0)), mt == null && (mt = it[1]);
            var Mt = r5.get("funnelAlign"), kt = r5.get("gap"), Gt = k2 === "horizontal" ? R6 : B3, Ot = (Gt - kt * (g5.count() - 1)) / g5.count(), ce2 = function(An, jn) {
              if (k2 === "horizontal") {
                var _n = g5.get(b6, An) || 0, Jr = fh2(_n, [pt, mt], tt, true), Qn = void 0;
                switch (Mt) {
                  case "top":
                    Qn = X3;
                    break;
                  case "center":
                    Qn = X3 + (B3 - Jr) / 2;
                    break;
                  case "bottom":
                    Qn = X3 + (B3 - Jr);
                    break;
                }
                return [[jn, Qn], [jn, Qn + Jr]];
              }
              var rr = g5.get(b6, An) || 0, Ar = fh2(rr, [pt, mt], tt, true), fi2;
              switch (Mt) {
                case "left":
                  fi2 = Z3;
                  break;
                case "center":
                  fi2 = Z3 + (R6 - Ar) / 2;
                  break;
                case "right":
                  fi2 = Z3 + R6 - Ar;
                  break;
              }
              return [[fi2, jn], [fi2 + Ar, jn]];
            };
            S2 === "ascending" && (Ot = -Ot, kt = -kt, k2 === "horizontal" ? Z3 += R6 : X3 += B3, G3 = G3.reverse());
            for (var ae2 = 0; ae2 < G3.length; ae2++) {
              var de2 = G3[ae2], we2 = G3[ae2 + 1], Se2 = g5.getItemModel(de2);
              if (k2 === "horizontal") {
                var Oe2 = Se2.get(["itemStyle", "width"]);
                Oe2 == null ? Oe2 = Ot : (Oe2 = $o(Oe2, R6), S2 === "ascending" && (Oe2 = -Oe2));
                var je2 = ce2(de2, Z3), rn = ce2(we2, Z3 + Oe2);
                Z3 += Oe2 + kt, g5.setItemLayout(de2, { points: je2.concat(rn.slice().reverse()) });
              } else {
                var qe2 = Se2.get(["itemStyle", "height"]);
                qe2 == null ? qe2 = Ot : (qe2 = $o(qe2, B3), S2 === "ascending" && (qe2 = -qe2));
                var je2 = ce2(de2, X3), rn = ce2(we2, X3 + qe2);
                X3 += qe2 + kt, g5.setItemLayout(de2, { points: je2.concat(rn.slice().reverse()) });
              }
            }
            FWn(g5);
          });
        }
        function BWn(c5) {
          c5.registerChartView(PWn), c5.registerSeriesModel(OWn), c5.registerLayout(VWn), c5.registerProcessor(zct("funnel"));
        }
        var zWn = 0.3, jWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._dataGroup = new nu(), r5._initialized = false, r5;
          }
          return s.prototype.init = function() {
            this.group.add(this._dataGroup);
          }, s.prototype.render = function(r5, g5, b6, S2) {
            this._progressiveEls = null;
            var A2 = this._dataGroup, k2 = r5.getData(), R6 = this._data, B3 = r5.coordinateSystem, G3 = B3.dimensions, Z3 = M5e(r5);
            k2.diff(R6).add(X3).update(tt).remove(it).execute();
            function X3(mt) {
              var Mt = S5e(k2, A2, mt, G3, B3);
              QHt(Mt, k2, mt, Z3);
            }
            function tt(mt, Mt) {
              var kt = R6.getItemGraphicEl(Mt), Gt = w5e(k2, mt, G3, B3);
              k2.setItemGraphicEl(mt, kt), Qf2(kt, { shape: { points: Gt } }, r5, mt), nT(kt), QHt(kt, k2, mt, Z3);
            }
            function it(mt) {
              var Mt = R6.getItemGraphicEl(mt);
              A2.remove(Mt);
            }
            if (!this._initialized) {
              this._initialized = true;
              var pt = WWn(B3, r5, function() {
                setTimeout(function() {
                  A2.removeClipPath();
                });
              });
              A2.setClipPath(pt);
            }
            this._data = k2;
          }, s.prototype.incrementalPrepareRender = function(r5, g5, b6) {
            this._initialized = true, this._data = null, this._dataGroup.removeAll();
          }, s.prototype.incrementalRender = function(r5, g5, b6) {
            for (var S2 = g5.getData(), A2 = g5.coordinateSystem, k2 = A2.dimensions, R6 = M5e(g5), B3 = this._progressiveEls = [], G3 = r5.start; G3 < r5.end; G3++) {
              var Z3 = S5e(S2, this._dataGroup, G3, k2, A2);
              Z3.incremental = true, QHt(Z3, S2, G3, R6), B3.push(Z3);
            }
          }, s.prototype.remove = function() {
            this._dataGroup && this._dataGroup.removeAll(), this._data = null;
          }, s.type = "parallel", s;
        }(Ig2);
        function WWn(c5, s, r5) {
          var g5 = c5.model, b6 = c5.getRect(), S2 = new zf2({ shape: { x: b6.x, y: b6.y, width: b6.width, height: b6.height } }), A2 = g5.get("layout") === "horizontal" ? "width" : "height";
          return S2.setShape(A2, 0), tv(S2, { shape: { width: b6.width, height: b6.height } }, s, r5), S2;
        }
        function w5e(c5, s, r5, g5) {
          for (var b6 = [], S2 = 0; S2 < r5.length; S2++) {
            var A2 = r5[S2], k2 = c5.get(c5.mapDimension(A2), s);
            GWn(k2, g5.getAxis(A2).type) || b6.push(g5.dataToPoint(k2, A2));
          }
          return b6;
        }
        function S5e(c5, s, r5, g5, b6) {
          var S2 = w5e(c5, r5, g5, b6), A2 = new Gw({ shape: { points: S2 }, z2: 10 });
          return s.add(A2), c5.setItemGraphicEl(r5, A2), A2;
        }
        function M5e(c5) {
          var s = c5.get("smooth", true);
          return s === true && (s = zWn), s = NI(s), fj2(s) && (s = 0), { smooth: s };
        }
        function QHt(c5, s, r5, g5) {
          c5.useStyle(s.getItemVisual(r5, "style")), c5.style.fill = null, c5.setShape("smooth", g5.smooth);
          var b6 = s.getItemModel(r5), S2 = b6.getModel("emphasis");
          z1(c5, b6, "lineStyle"), f0(c5, S2.get("focus"), S2.get("blurScope"), S2.get("disabled"));
        }
        function GWn(c5, s) {
          return s === "category" ? c5 == null : c5 == null || isNaN(c5);
        }
        var HWn = jWn, UWn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.visualStyleAccessPath = "lineStyle", r5.visualDrawType = "stroke", r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            return SR(null, this, { useEncodeDefaulter: Cs(qWn, null, this) });
          }, s.prototype.getRawIndicesByActiveState = function(r5) {
            var g5 = this.coordinateSystem, b6 = this.getData(), S2 = [];
            return g5.eachActiveState(b6, function(A2, k2) {
              r5 === A2 && S2.push(b6.getRawIndex(k2));
            }), S2;
          }, s.type = "series.parallel", s.dependencies = ["parallel"], s.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, s;
        }(zv);
        function qWn(c5) {
          var s = c5.ecModel.getComponent("parallel", c5.get("parallelIndex"));
          if (s) {
            var r5 = {};
            return Ye2(s.dimensions, function(g5) {
              var b6 = ZWn(g5);
              r5[g5] = b6;
            }), r5;
          }
        }
        function ZWn(c5) {
          return +c5.replace("dim", "");
        }
        var $Wn = UWn, YWn = ["lineStyle", "opacity"], KWn = { seriesType: "parallel", reset: function(c5, s) {
          var r5 = c5.coordinateSystem, g5 = { normal: c5.get(["lineStyle", "opacity"]), active: c5.get("activeOpacity"), inactive: c5.get("inactiveOpacity") };
          return { progress: function(b6, S2) {
            r5.eachActiveState(S2, function(A2, k2) {
              var R6 = g5[A2];
              if (A2 === "normal" && S2.hasItemOption) {
                var B3 = S2.getItemModel(k2).get(YWn, true);
                B3 != null && (R6 = B3);
              }
              var G3 = S2.ensureUniqueItemVisual(k2, "style");
              G3.opacity = R6;
            }, b6.start, b6.end);
          } };
        } }, XWn = KWn;
        function QWn(c5) {
          JWn(c5), tGn(c5);
        }
        function JWn(c5) {
          if (!c5.parallel) {
            var s = false;
            Ye2(c5.series, function(r5) {
              r5 && r5.type === "parallel" && (s = true);
            }), s && (c5.parallel = [{}]);
          }
        }
        function tGn(c5) {
          var s = xp(c5.parallelAxis);
          Ye2(s, function(r5) {
            if (Wl(r5)) {
              var g5 = r5.parallelIndex || 0, b6 = xp(c5.parallel)[g5];
              b6 && b6.parallelAxisDefault && bu(r5, b6.parallelAxisDefault, false);
            }
          });
        }
        var eGn = 5, nGn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            this._model = r5, this._api = b6, this._handlers || (this._handlers = {}, Ye2(rGn, function(S2, A2) {
              b6.getZr().on(A2, this._handlers[A2] = Cs(S2, this));
            }, this)), pX(this, "_throttledDispatchExpand", r5.get("axisExpandRate"), "fixRate");
          }, s.prototype.dispose = function(r5, g5) {
            hct(this, "_throttledDispatchExpand"), Ye2(this._handlers, function(b6, S2) {
              g5.getZr().off(S2, b6);
            }), this._handlers = null;
          }, s.prototype._throttledDispatchExpand = function(r5) {
            this._dispatchExpand(r5);
          }, s.prototype._dispatchExpand = function(r5) {
            r5 && this._api.dispatchAction(sa2({ type: "parallelAxisExpand" }, r5));
          }, s.type = "parallel", s;
        }(P0), rGn = { mousedown: function(c5) {
          JHt(this, "click") && (this._mouseDownPoint = [c5.offsetX, c5.offsetY]);
        }, mouseup: function(c5) {
          var s = this._mouseDownPoint;
          if (JHt(this, "click") && s) {
            var r5 = [c5.offsetX, c5.offsetY], g5 = Math.pow(s[0] - r5[0], 2) + Math.pow(s[1] - r5[1], 2);
            if (g5 > eGn)
              return;
            var b6 = this._model.coordinateSystem.getSlidedAxisExpandWindow([c5.offsetX, c5.offsetY]);
            b6.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: b6.axisExpandWindow });
          }
          this._mouseDownPoint = null;
        }, mousemove: function(c5) {
          if (!(this._mouseDownPoint || !JHt(this, "mousemove"))) {
            var s = this._model, r5 = s.coordinateSystem.getSlidedAxisExpandWindow([c5.offsetX, c5.offsetY]), g5 = r5.behavior;
            g5 === "jump" && this._throttledDispatchExpand.debounceNextCall(s.get("axisExpandDebounce")), this._throttledDispatchExpand(g5 === "none" ? null : { axisExpandWindow: r5.axisExpandWindow, animation: g5 === "jump" ? null : { duration: 0 } });
          }
        } };
        function JHt(c5, s) {
          var r5 = c5._model;
          return r5.get("axisExpandable") && r5.get("axisExpandTriggerOn") === s;
        }
        var iGn = nGn, aGn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function() {
            c5.prototype.init.apply(this, arguments), this.mergeOption({});
          }, s.prototype.mergeOption = function(r5) {
            var g5 = this.option;
            r5 && bu(g5, r5, true), this._initDimensions();
          }, s.prototype.contains = function(r5, g5) {
            var b6 = r5.get("parallelIndex");
            return b6 != null && g5.getComponent("parallel", b6) === this;
          }, s.prototype.setAxisExpand = function(r5) {
            Ye2(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(g5) {
              r5.hasOwnProperty(g5) && (this.option[g5] = r5[g5]);
            }, this);
          }, s.prototype._initDimensions = function() {
            var r5 = this.dimensions = [], g5 = this.parallelAxisIndex = [], b6 = jp(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(S2) {
              return (S2.get("parallelIndex") || 0) === this.componentIndex;
            }, this);
            Ye2(b6, function(S2) {
              r5.push("dim" + S2.get("dim")), g5.push(S2.componentIndex);
            });
          }, s.type = "parallel", s.dependencies = ["parallelAxis"], s.layoutMode = "box", s.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, s;
        }(Rh2), oGn = aGn, sGn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2, A2) {
            var k2 = c5.call(this, r5, g5, b6) || this;
            return k2.type = S2 || "value", k2.axisIndex = A2, k2;
          }
          return s.prototype.isHorizontal = function() {
            return this.coordinateSystem.getModel().get("layout") !== "horizontal";
          }, s;
        }(kk2), lGn = sGn;
        function DW(c5, s, r5, g5, b6, S2) {
          c5 = c5 || 0;
          var A2 = r5[1] - r5[0];
          if (b6 != null && (b6 = EX(b6, [0, A2])), S2 != null && (S2 = Math.max(S2, b6 != null ? b6 : 0)), g5 === "all") {
            var k2 = Math.abs(s[1] - s[0]);
            k2 = EX(k2, [0, A2]), b6 = S2 = EX(k2, [b6, S2]), g5 = 0;
          }
          s[0] = EX(s[0], r5), s[1] = EX(s[1], r5);
          var R6 = tUt(s, g5);
          s[g5] += c5;
          var B3 = b6 || 0, G3 = r5.slice();
          R6.sign < 0 ? G3[0] += B3 : G3[1] -= B3, s[g5] = EX(s[g5], G3);
          var Z3;
          return Z3 = tUt(s, g5), b6 != null && (Z3.sign !== R6.sign || Z3.span < b6) && (s[1 - g5] = s[g5] + R6.sign * b6), Z3 = tUt(s, g5), S2 != null && Z3.span > S2 && (s[1 - g5] = s[g5] + Z3.sign * S2), s;
        }
        function tUt(c5, s) {
          var r5 = c5[s] - c5[1 - s];
          return { span: Math.abs(r5), sign: r5 > 0 ? -1 : r5 < 0 ? 1 : s ? -1 : 1 };
        }
        function EX(c5, s) {
          return Math.min(s[1] != null ? s[1] : 1 / 0, Math.max(s[0] != null ? s[0] : -1 / 0, c5));
        }
        var eUt = Ye2, C5e = Math.min, T5e = Math.max, A5e = Math.floor, uGn = Math.ceil, I5e = c0, cGn = Math.PI, fGn = function() {
          function c5(s, r5, g5) {
            this.type = "parallel", this._axesMap = Ps(), this._axesLayout = {}, this.dimensions = s.dimensions, this._model = s, this._init(s, r5, g5);
          }
          return c5.prototype._init = function(s, r5, g5) {
            var b6 = s.dimensions, S2 = s.parallelAxisIndex;
            eUt(b6, function(A2, k2) {
              var R6 = S2[k2], B3 = r5.getComponent("parallelAxis", R6), G3 = this._axesMap.set(A2, new lGn(A2, LMt(B3), [0, 0], B3.get("type"), R6)), Z3 = G3.type === "category";
              G3.onBand = Z3 && B3.get("boundaryGap"), G3.inverse = B3.get("inverse"), B3.axis = G3, G3.model = B3, G3.coordinateSystem = B3.coordinateSystem = this;
            }, this);
          }, c5.prototype.update = function(s, r5) {
            this._updateAxesFromSeries(this._model, s);
          }, c5.prototype.containPoint = function(s) {
            var r5 = this._makeLayoutInfo(), g5 = r5.axisBase, b6 = r5.layoutBase, S2 = r5.pixelDimIndex, A2 = s[1 - S2], k2 = s[S2];
            return A2 >= g5 && A2 <= g5 + r5.axisLength && k2 >= b6 && k2 <= b6 + r5.layoutLength;
          }, c5.prototype.getModel = function() {
            return this._model;
          }, c5.prototype._updateAxesFromSeries = function(s, r5) {
            r5.eachSeries(function(g5) {
              if (s.contains(g5, r5)) {
                var b6 = g5.getData();
                eUt(this.dimensions, function(S2) {
                  var A2 = this._axesMap.get(S2);
                  A2.scale.unionExtentFromData(b6, b6.mapDimension(S2)), _X(A2.scale, A2.model);
                }, this);
              }
            }, this);
          }, c5.prototype.resize = function(s, r5) {
            this._rect = $m(s.getBoxLayoutParams(), { width: r5.getWidth(), height: r5.getHeight() }), this._layoutAxes();
          }, c5.prototype.getRect = function() {
            return this._rect;
          }, c5.prototype._makeLayoutInfo = function() {
            var s = this._model, r5 = this._rect, g5 = ["x", "y"], b6 = ["width", "height"], S2 = s.get("layout"), A2 = S2 === "horizontal" ? 0 : 1, k2 = r5[b6[A2]], R6 = [0, k2], B3 = this.dimensions.length, G3 = fCt(s.get("axisExpandWidth"), R6), Z3 = fCt(s.get("axisExpandCount") || 0, [0, B3]), X3 = s.get("axisExpandable") && B3 > 3 && B3 > Z3 && Z3 > 1 && G3 > 0 && k2 > 0, tt = s.get("axisExpandWindow"), it;
            if (tt)
              it = fCt(tt[1] - tt[0], R6), tt[1] = tt[0] + it;
            else {
              it = fCt(G3 * (Z3 - 1), R6);
              var pt = s.get("axisExpandCenter") || A5e(B3 / 2);
              tt = [G3 * pt - it / 2], tt[1] = tt[0] + it;
            }
            var mt = (k2 - it) / (B3 - Z3);
            mt < 3 && (mt = 0);
            var Mt = [A5e(I5e(tt[0] / G3, 1)) + 1, uGn(I5e(tt[1] / G3, 1)) - 1], kt = mt / G3 * tt[0];
            return { layout: S2, pixelDimIndex: A2, layoutBase: r5[g5[A2]], layoutLength: k2, axisBase: r5[g5[1 - A2]], axisLength: r5[b6[1 - A2]], axisExpandable: X3, axisExpandWidth: G3, axisCollapseWidth: mt, axisExpandWindow: tt, axisCount: B3, winInnerIndices: Mt, axisExpandWindow0Pos: kt };
          }, c5.prototype._layoutAxes = function() {
            var s = this._rect, r5 = this._axesMap, g5 = this.dimensions, b6 = this._makeLayoutInfo(), S2 = b6.layout;
            r5.each(function(A2) {
              var k2 = [0, b6.axisLength], R6 = A2.inverse ? 1 : 0;
              A2.setExtent(k2[R6], k2[1 - R6]);
            }), eUt(g5, function(A2, k2) {
              var R6 = (b6.axisExpandable ? pGn : hGn)(k2, b6), B3 = { horizontal: { x: R6.position, y: b6.axisLength }, vertical: { x: 0, y: R6.position } }, G3 = { horizontal: cGn / 2, vertical: 0 }, Z3 = [B3[S2].x + s.x, B3[S2].y + s.y], X3 = G3[S2], tt = bM();
              f3(tt, tt, X3), _M(tt, tt, Z3), this._axesLayout[A2] = { position: Z3, rotation: X3, transform: tt, axisNameAvailableWidth: R6.axisNameAvailableWidth, axisLabelShow: R6.axisLabelShow, nameTruncateMaxWidth: R6.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
            }, this);
          }, c5.prototype.getAxis = function(s) {
            return this._axesMap.get(s);
          }, c5.prototype.dataToPoint = function(s, r5) {
            return this.axisCoordToPoint(this._axesMap.get(r5).dataToCoord(s), r5);
          }, c5.prototype.eachActiveState = function(s, r5, g5, b6) {
            g5 == null && (g5 = 0), b6 == null && (b6 = s.count());
            var S2 = this._axesMap, A2 = this.dimensions, k2 = [], R6 = [];
            Ye2(A2, function(mt) {
              k2.push(s.mapDimension(mt)), R6.push(S2.get(mt).model);
            });
            for (var B3 = this.hasAxisBrushed(), G3 = g5; G3 < b6; G3++) {
              var Z3 = void 0;
              if (!B3)
                Z3 = "normal";
              else {
                Z3 = "active";
                for (var X3 = s.getValues(k2, G3), tt = 0, it = A2.length; tt < it; tt++) {
                  var pt = R6[tt].getActiveState(X3[tt]);
                  if (pt === "inactive") {
                    Z3 = "inactive";
                    break;
                  }
                }
              }
              r5(Z3, G3);
            }
          }, c5.prototype.hasAxisBrushed = function() {
            for (var s = this.dimensions, r5 = this._axesMap, g5 = false, b6 = 0, S2 = s.length; b6 < S2; b6++)
              r5.get(s[b6]).model.getActiveState() !== "normal" && (g5 = true);
            return g5;
          }, c5.prototype.axisCoordToPoint = function(s, r5) {
            var g5 = this._axesLayout[r5];
            return Lo([s, 0], g5.transform);
          }, c5.prototype.getAxisLayout = function(s) {
            return Ml(this._axesLayout[s]);
          }, c5.prototype.getSlidedAxisExpandWindow = function(s) {
            var r5 = this._makeLayoutInfo(), g5 = r5.pixelDimIndex, b6 = r5.axisExpandWindow.slice(), S2 = b6[1] - b6[0], A2 = [0, r5.axisExpandWidth * (r5.axisCount - 1)];
            if (!this.containPoint(s))
              return { behavior: "none", axisExpandWindow: b6 };
            var k2 = s[g5] - r5.layoutBase - r5.axisExpandWindow0Pos, R6, B3 = "slide", G3 = r5.axisCollapseWidth, Z3 = this._model.get("axisExpandSlideTriggerArea"), X3 = Z3[0] != null;
            if (G3)
              X3 && G3 && k2 < S2 * Z3[0] ? (B3 = "jump", R6 = k2 - S2 * Z3[2]) : X3 && G3 && k2 > S2 * (1 - Z3[0]) ? (B3 = "jump", R6 = k2 - S2 * (1 - Z3[2])) : (R6 = k2 - S2 * Z3[1]) >= 0 && (R6 = k2 - S2 * (1 - Z3[1])) <= 0 && (R6 = 0), R6 *= r5.axisExpandWidth / G3, R6 ? DW(R6, b6, A2, "all") : B3 = "none";
            else {
              var tt = b6[1] - b6[0], it = A2[1] * k2 / tt;
              b6 = [T5e(0, it - tt / 2)], b6[1] = C5e(A2[1], b6[0] + tt), b6[0] = b6[1] - tt;
            }
            return { axisExpandWindow: b6, behavior: B3 };
          }, c5;
        }();
        function fCt(c5, s) {
          return C5e(T5e(c5, s[0]), s[1]);
        }
        function hGn(c5, s) {
          var r5 = s.layoutLength / (s.axisCount - 1);
          return { position: r5 * c5, axisNameAvailableWidth: r5, axisLabelShow: true };
        }
        function pGn(c5, s) {
          var r5 = s.layoutLength, g5 = s.axisExpandWidth, b6 = s.axisCount, S2 = s.axisCollapseWidth, A2 = s.winInnerIndices, k2, R6 = S2, B3 = false, G3;
          return c5 < A2[0] ? (k2 = c5 * S2, G3 = S2) : c5 <= A2[1] ? (k2 = s.axisExpandWindow0Pos + c5 * g5 - s.axisExpandWindow[0], R6 = g5, B3 = true) : (k2 = r5 - (b6 - 1 - c5) * S2, G3 = S2), { position: k2, axisNameAvailableWidth: R6, axisLabelShow: B3, nameTruncateMaxWidth: G3 };
        }
        var dGn = fGn;
        function gGn(c5, s) {
          var r5 = [];
          return c5.eachComponent("parallel", function(g5, b6) {
            var S2 = new dGn(g5, c5, s);
            S2.name = "parallel_" + b6, S2.resize(g5, s), g5.coordinateSystem = S2, S2.model = g5, r5.push(S2);
          }), c5.eachSeries(function(g5) {
            if (g5.get("coordinateSystem") === "parallel") {
              var b6 = g5.getReferringComponents("parallel", E0).models[0];
              g5.coordinateSystem = b6.coordinateSystem;
            }
          }), r5;
        }
        var vGn = { create: gGn }, yGn = vGn, D5e = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.activeIntervals = [], r5;
          }
          return s.prototype.getAreaSelectStyle = function() {
            return aR([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
          }, s.prototype.setActiveIntervals = function(r5) {
            var g5 = this.activeIntervals = Ml(r5);
            if (g5)
              for (var b6 = g5.length - 1; b6 >= 0; b6--)
                h2(g5[b6]);
          }, s.prototype.getActiveState = function(r5) {
            var g5 = this.activeIntervals;
            if (!g5.length)
              return "normal";
            if (r5 == null || isNaN(+r5))
              return "inactive";
            if (g5.length === 1) {
              var b6 = g5[0];
              if (b6[0] <= r5 && r5 <= b6[1])
                return "active";
            } else
              for (var S2 = 0, A2 = g5.length; S2 < A2; S2++)
                if (g5[S2][0] <= r5 && r5 <= g5[S2][1])
                  return "active";
            return "inactive";
          }, s;
        }(Rh2);
        A0(D5e, Ect);
        var E5e = D5e, EW = true, ift = Math.min, kX = Math.max, mGn = Math.pow, bGn = 1e4, _Gn = 6, xGn = 6, k5e = "globalPan", wGn = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, SGn = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, P5e = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, MGn = 0, CGn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this) || this;
            return g5._track = [], g5._covers = [], g5._handlers = {}, g5._zr = r5, g5.group = new nu(), g5._uid = "brushController_" + MGn++, Ye2(PGn, function(b6, S2) {
              this._handlers[S2] = Cs(b6, this);
            }, g5), g5;
          }
          return s.prototype.enableBrush = function(r5) {
            return this._brushType && this._doDisableBrush(), r5.brushType && this._doEnableBrush(r5), this;
          }, s.prototype._doEnableBrush = function(r5) {
            var g5 = this._zr;
            this._enableGlobalPan || RBn(g5, k5e, this._uid), Ye2(this._handlers, function(b6, S2) {
              g5.on(S2, b6);
            }), this._brushType = r5.brushType, this._brushOption = bu(Ml(P5e), r5, true);
          }, s.prototype._doDisableBrush = function() {
            var r5 = this._zr;
            NBn(r5, k5e, this._uid), Ye2(this._handlers, function(g5, b6) {
              r5.off(b6, g5);
            }), this._brushType = this._brushOption = null;
          }, s.prototype.setPanels = function(r5) {
            if (r5 && r5.length) {
              var g5 = this._panels = {};
              Ye2(r5, function(b6) {
                g5[b6.panelId] = Ml(b6);
              });
            } else
              this._panels = null;
            return this;
          }, s.prototype.mount = function(r5) {
            r5 = r5 || {}, this._enableGlobalPan = r5.enableGlobalPan;
            var g5 = this.group;
            return this._zr.add(g5), g5.attr({ x: r5.x || 0, y: r5.y || 0, rotation: r5.rotation || 0, scaleX: r5.scaleX || 1, scaleY: r5.scaleY || 1 }), this._transform = g5.getLocalTransform(), this;
          }, s.prototype.updateCovers = function(r5) {
            r5 = Ha2(r5, function(X3) {
              return bu(Ml(P5e), X3, true);
            });
            var g5 = "\0-brush-index-", b6 = this._covers, S2 = this._covers = [], A2 = this, k2 = this._creatingCover;
            return new wR(b6, r5, B3, R6).add(G3).update(G3).remove(Z3).execute(), this;
            function R6(X3, tt) {
              return (X3.id != null ? X3.id : g5 + tt) + "-" + X3.brushType;
            }
            function B3(X3, tt) {
              return R6(X3.__brushOption, tt);
            }
            function G3(X3, tt) {
              var it = r5[X3];
              if (tt != null && b6[tt] === k2)
                S2[X3] = b6[tt];
              else {
                var pt = S2[X3] = tt != null ? (b6[tt].__brushOption = it, b6[tt]) : O5e(A2, L5e(A2, it));
                nUt(A2, pt);
              }
            }
            function Z3(X3) {
              b6[X3] !== k2 && A2.group.remove(b6[X3]);
            }
          }, s.prototype.unmount = function() {
            return this.enableBrush(false), aUt(this), this._zr.remove(this.group), this;
          }, s.prototype.dispose = function() {
            this.unmount(), this.off();
          }, s;
        }(Lw);
        function L5e(c5, s) {
          var r5 = hCt[s.brushType].createCover(c5, s);
          return r5.__brushOption = s, N5e(r5, s), c5.group.add(r5), r5;
        }
        function O5e(c5, s) {
          var r5 = rUt(s);
          return r5.endCreating && (r5.endCreating(c5, s), N5e(s, s.__brushOption)), s;
        }
        function R5e(c5, s) {
          var r5 = s.__brushOption;
          rUt(s).updateCoverShape(c5, s, r5.range, r5);
        }
        function N5e(c5, s) {
          var r5 = s.z;
          r5 == null && (r5 = bGn), c5.traverse(function(g5) {
            g5.z = r5, g5.z2 = r5;
          });
        }
        function nUt(c5, s) {
          rUt(s).updateCommon(c5, s), R5e(c5, s);
        }
        function rUt(c5) {
          return hCt[c5.__brushOption.brushType];
        }
        function iUt(c5, s, r5) {
          var g5 = c5._panels;
          if (!g5)
            return EW;
          var b6, S2 = c5._transform;
          return Ye2(g5, function(A2) {
            A2.isTargetByCursor(s, r5, S2) && (b6 = A2);
          }), b6;
        }
        function F5e(c5, s) {
          var r5 = c5._panels;
          if (!r5)
            return EW;
          var g5 = s.__brushOption.panelId;
          return g5 != null ? r5[g5] : EW;
        }
        function aUt(c5) {
          var s = c5._covers, r5 = s.length;
          return Ye2(s, function(g5) {
            c5.group.remove(g5);
          }, c5), s.length = 0, !!r5;
        }
        function kW(c5, s) {
          var r5 = Ha2(c5._covers, function(g5) {
            var b6 = g5.__brushOption, S2 = Ml(b6.range);
            return { brushType: b6.brushType, panelId: b6.panelId, range: S2 };
          });
          c5.trigger("brush", { areas: r5, isEnd: !!s.isEnd, removeOnClick: !!s.removeOnClick });
        }
        function TGn(c5) {
          var s = c5._track;
          if (!s.length)
            return false;
          var r5 = s[s.length - 1], g5 = s[0], b6 = r5[0] - g5[0], S2 = r5[1] - g5[1], A2 = mGn(b6 * b6 + S2 * S2, 0.5);
          return A2 > _Gn;
        }
        function V5e(c5) {
          var s = c5.length - 1;
          return s < 0 && (s = 0), [c5[0], c5[s]];
        }
        function B5e(c5, s, r5, g5) {
          var b6 = new nu();
          return b6.add(new zf2({ name: "main", style: sUt(r5), silent: true, draggable: true, cursor: "move", drift: Au(W5e, c5, s, b6, ["n", "s", "w", "e"]), ondragend: Au(kW, s, { isEnd: true }) })), Ye2(g5, function(S2) {
            b6.add(new zf2({ name: S2.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: Au(W5e, c5, s, b6, S2), ondragend: Au(kW, s, { isEnd: true }) }));
          }), b6;
        }
        function z5e(c5, s, r5, g5) {
          var b6 = g5.brushStyle.lineWidth || 0, S2 = kX(b6, xGn), A2 = r5[0][0], k2 = r5[1][0], R6 = A2 - b6 / 2, B3 = k2 - b6 / 2, G3 = r5[0][1], Z3 = r5[1][1], X3 = G3 - S2 + b6 / 2, tt = Z3 - S2 + b6 / 2, it = G3 - A2, pt = Z3 - k2, mt = it + b6, Mt = pt + b6;
          IR(c5, s, "main", A2, k2, it, pt), g5.transformable && (IR(c5, s, "w", R6, B3, S2, Mt), IR(c5, s, "e", X3, B3, S2, Mt), IR(c5, s, "n", R6, B3, mt, S2), IR(c5, s, "s", R6, tt, mt, S2), IR(c5, s, "nw", R6, B3, S2, S2), IR(c5, s, "ne", X3, B3, S2, S2), IR(c5, s, "sw", R6, tt, S2, S2), IR(c5, s, "se", X3, tt, S2, S2));
        }
        function oUt(c5, s) {
          var r5 = s.__brushOption, g5 = r5.transformable, b6 = s.childAt(0);
          b6.useStyle(sUt(r5)), b6.attr({ silent: !g5, cursor: g5 ? "move" : "default" }), Ye2([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(S2) {
            var A2 = s.childOfName(S2.join("")), k2 = S2.length === 1 ? lUt(c5, S2[0]) : IGn(c5, S2);
            A2 && A2.attr({ silent: !g5, invisible: !g5, cursor: g5 ? SGn[k2] + "-resize" : null });
          });
        }
        function IR(c5, s, r5, g5, b6, S2, A2) {
          var k2 = s.childOfName(r5);
          k2 && k2.setShape(EGn(uUt(c5, s, [[g5, b6], [g5 + S2, b6 + A2]])));
        }
        function sUt(c5) {
          return Cl({ strokeNoScale: true }, c5.brushStyle);
        }
        function j5e(c5, s, r5, g5) {
          var b6 = [ift(c5, r5), ift(s, g5)], S2 = [kX(c5, r5), kX(s, g5)];
          return [[b6[0], S2[0]], [b6[1], S2[1]]];
        }
        function AGn(c5) {
          return vo(c5.group);
        }
        function lUt(c5, s) {
          var r5 = { w: "left", e: "right", n: "top", s: "bottom" }, g5 = { left: "w", right: "e", top: "n", bottom: "s" }, b6 = Ks(r5[s], AGn(c5));
          return g5[b6];
        }
        function IGn(c5, s) {
          var r5 = [lUt(c5, s[0]), lUt(c5, s[1])];
          return (r5[0] === "e" || r5[0] === "w") && r5.reverse(), r5.join("");
        }
        function W5e(c5, s, r5, g5, b6, S2) {
          var A2 = r5.__brushOption, k2 = c5.toRectRange(A2.range), R6 = G5e(s, b6, S2);
          Ye2(g5, function(B3) {
            var G3 = wGn[B3];
            k2[G3[0]][G3[1]] += R6[G3[0]];
          }), A2.range = c5.fromRectRange(j5e(k2[0][0], k2[1][0], k2[0][1], k2[1][1])), nUt(s, r5), kW(s, { isEnd: false });
        }
        function DGn(c5, s, r5, g5) {
          var b6 = s.__brushOption.range, S2 = G5e(c5, r5, g5);
          Ye2(b6, function(A2) {
            A2[0] += S2[0], A2[1] += S2[1];
          }), nUt(c5, s), kW(c5, { isEnd: false });
        }
        function G5e(c5, s, r5) {
          var g5 = c5.group, b6 = g5.transformCoordToLocal(s, r5), S2 = g5.transformCoordToLocal(0, 0);
          return [b6[0] - S2[0], b6[1] - S2[1]];
        }
        function uUt(c5, s, r5) {
          var g5 = F5e(c5, s);
          return g5 && g5 !== EW ? g5.clipPath(r5, c5._transform) : Ml(r5);
        }
        function EGn(c5) {
          var s = ift(c5[0][0], c5[1][0]), r5 = ift(c5[0][1], c5[1][1]), g5 = kX(c5[0][0], c5[1][0]), b6 = kX(c5[0][1], c5[1][1]);
          return { x: s, y: r5, width: g5 - s, height: b6 - r5 };
        }
        function kGn(c5, s, r5) {
          if (!(!c5._brushType || LGn(c5, s.offsetX, s.offsetY))) {
            var g5 = c5._zr, b6 = c5._covers, S2 = iUt(c5, s, r5);
            if (!c5._dragging)
              for (var A2 = 0; A2 < b6.length; A2++) {
                var k2 = b6[A2].__brushOption;
                if (S2 && (S2 === EW || k2.panelId === S2.panelId) && hCt[k2.brushType].contain(b6[A2], r5[0], r5[1]))
                  return;
              }
            S2 && g5.setCursorStyle("crosshair");
          }
        }
        function cUt(c5) {
          var s = c5.event;
          s.preventDefault && s.preventDefault();
        }
        function fUt(c5, s, r5) {
          return c5.childOfName("main").contain(s, r5);
        }
        function H5e(c5, s, r5, g5) {
          var b6 = c5._creatingCover, S2 = c5._creatingPanel, A2 = c5._brushOption, k2;
          if (c5._track.push(r5.slice()), TGn(c5) || b6) {
            if (S2 && !b6) {
              A2.brushMode === "single" && aUt(c5);
              var R6 = Ml(A2);
              R6.brushType = U5e(R6.brushType, S2), R6.panelId = S2 === EW ? null : S2.panelId, b6 = c5._creatingCover = L5e(c5, R6), c5._covers.push(b6);
            }
            if (b6) {
              var B3 = hCt[U5e(c5._brushType, S2)], G3 = b6.__brushOption;
              G3.range = B3.getCreatingRange(uUt(c5, b6, c5._track)), g5 && (O5e(c5, b6), B3.updateCommon(c5, b6)), R5e(c5, b6), k2 = { isEnd: g5 };
            }
          } else
            g5 && A2.brushMode === "single" && A2.removeOnClick && iUt(c5, s, r5) && aUt(c5) && (k2 = { isEnd: g5, removeOnClick: true });
          return k2;
        }
        function U5e(c5, s) {
          return c5 === "auto" ? s.defaultBrushType : c5;
        }
        var PGn = { mousedown: function(c5) {
          if (this._dragging)
            q5e(this, c5);
          else if (!c5.target || !c5.target.draggable) {
            cUt(c5);
            var s = this.group.transformCoordToLocal(c5.offsetX, c5.offsetY);
            this._creatingCover = null;
            var r5 = this._creatingPanel = iUt(this, c5, s);
            r5 && (this._dragging = true, this._track = [s.slice()]);
          }
        }, mousemove: function(c5) {
          var s = c5.offsetX, r5 = c5.offsetY, g5 = this.group.transformCoordToLocal(s, r5);
          if (kGn(this, c5, g5), this._dragging) {
            cUt(c5);
            var b6 = H5e(this, c5, g5, false);
            b6 && kW(this, b6);
          }
        }, mouseup: function(c5) {
          q5e(this, c5);
        } };
        function q5e(c5, s) {
          if (c5._dragging) {
            cUt(s);
            var r5 = s.offsetX, g5 = s.offsetY, b6 = c5.group.transformCoordToLocal(r5, g5), S2 = H5e(c5, s, b6, true);
            c5._dragging = false, c5._track = [], c5._creatingCover = null, S2 && kW(c5, S2);
          }
        }
        function LGn(c5, s, r5) {
          var g5 = c5._zr;
          return s < 0 || s > g5.getWidth() || r5 < 0 || r5 > g5.getHeight();
        }
        var hCt = { lineX: Z5e(0), lineY: Z5e(1), rect: { createCover: function(c5, s) {
          function r5(g5) {
            return g5;
          }
          return B5e({ toRectRange: r5, fromRectRange: r5 }, c5, s, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
        }, getCreatingRange: function(c5) {
          var s = V5e(c5);
          return j5e(s[1][0], s[1][1], s[0][0], s[0][1]);
        }, updateCoverShape: function(c5, s, r5, g5) {
          z5e(c5, s, r5, g5);
        }, updateCommon: oUt, contain: fUt }, polygon: { createCover: function(c5, s) {
          var r5 = new nu();
          return r5.add(new Gw({ name: "main", style: sUt(s), silent: true })), r5;
        }, getCreatingRange: function(c5) {
          return c5;
        }, endCreating: function(c5, s) {
          s.remove(s.childAt(0)), s.add(new Gb2({ name: "main", draggable: true, drift: Au(DGn, c5, s), ondragend: Au(kW, c5, { isEnd: true }) }));
        }, updateCoverShape: function(c5, s, r5, g5) {
          s.childAt(0).setShape({ points: uUt(c5, s, r5) });
        }, updateCommon: oUt, contain: fUt } };
        function Z5e(c5) {
          return { createCover: function(s, r5) {
            return B5e({ toRectRange: function(g5) {
              var b6 = [g5, [0, 100]];
              return c5 && b6.reverse(), b6;
            }, fromRectRange: function(g5) {
              return g5[c5];
            } }, s, r5, [[["w"], ["e"]], [["n"], ["s"]]][c5]);
          }, getCreatingRange: function(s) {
            var r5 = V5e(s), g5 = ift(r5[0][c5], r5[1][c5]), b6 = kX(r5[0][c5], r5[1][c5]);
            return [g5, b6];
          }, updateCoverShape: function(s, r5, g5, b6) {
            var S2, A2 = F5e(s, r5);
            if (A2 !== EW && A2.getLinearBrushOtherExtent)
              S2 = A2.getLinearBrushOtherExtent(c5);
            else {
              var k2 = s._zr;
              S2 = [0, [k2.getWidth(), k2.getHeight()][1 - c5]];
            }
            var R6 = [g5, S2];
            c5 && R6.reverse(), z5e(s, r5, R6, b6);
          }, updateCommon: oUt, contain: fUt };
        }
        var hUt = CGn;
        function $5e(c5) {
          return c5 = pUt(c5), function(s) {
            return uc2(s, c5);
          };
        }
        function Y5e(c5, s) {
          return c5 = pUt(c5), function(r5) {
            var g5 = s != null ? s : r5, b6 = g5 ? c5.width : c5.height, S2 = g5 ? c5.x : c5.y;
            return [S2, S2 + (b6 || 0)];
          };
        }
        function K5e(c5, s, r5) {
          var g5 = pUt(c5);
          return function(b6, S2) {
            return g5.contain(S2[0], S2[1]) && !XMt(b6, s, r5);
          };
        }
        function pUt(c5) {
          return lc2.create(c5);
        }
        var OGn = ["axisLine", "axisTickLabel", "axisName"], RGn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5, g5) {
            c5.prototype.init.apply(this, arguments), (this._brushController = new hUt(g5.getZr())).on("brush", Cs(this._onBrush, this));
          }, s.prototype.render = function(r5, g5, b6, S2) {
            if (!NGn(r5, g5, S2)) {
              this.axisModel = r5, this.api = b6, this.group.removeAll();
              var A2 = this._axisGroup;
              if (this._axisGroup = new nu(), this.group.add(this._axisGroup), !!r5.get("show")) {
                var k2 = VGn(r5, g5), R6 = k2.coordinateSystem, B3 = r5.getAreaSelectStyle(), G3 = B3.width, Z3 = r5.axis.dim, X3 = R6.getAxisLayout(Z3), tt = sa2({ strokeContainThreshold: G3 }, X3), it = new TR(r5, tt);
                Ye2(OGn, it.add, it), this._axisGroup.add(it.getGroup()), this._refreshBrushController(tt, B3, r5, k2, G3, b6), of2(A2, this._axisGroup, r5);
              }
            }
          }, s.prototype._refreshBrushController = function(r5, g5, b6, S2, A2, k2) {
            var R6 = b6.axis.getExtent(), B3 = R6[1] - R6[0], G3 = Math.min(30, Math.abs(B3) * 0.1), Z3 = lc2.create({ x: R6[0], y: -A2 / 2, width: B3, height: A2 });
            Z3.x -= G3, Z3.width += 2 * G3, this._brushController.mount({ enableGlobalPan: true, rotation: r5.rotation, x: r5.position[0], y: r5.position[1] }).setPanels([{ panelId: "pl", clipPath: $5e(Z3), isTargetByCursor: K5e(Z3, k2, S2), getLinearBrushOtherExtent: Y5e(Z3, 0) }]).enableBrush({ brushType: "lineX", brushStyle: g5, removeOnClick: true }).updateCovers(FGn(b6));
          }, s.prototype._onBrush = function(r5) {
            var g5 = r5.areas, b6 = this.axisModel, S2 = b6.axis, A2 = Ha2(g5, function(k2) {
              return [S2.coordToData(k2.range[0], true), S2.coordToData(k2.range[1], true)];
            });
            (!b6.option.realtime === r5.isEnd || r5.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: b6.id, intervals: A2 });
          }, s.prototype.dispose = function() {
            this._brushController.dispose();
          }, s.type = "parallelAxis", s;
        }(P0);
        function NGn(c5, s, r5) {
          return r5 && r5.type === "axisAreaSelect" && s.findComponents({ mainType: "parallelAxis", query: r5 })[0] === c5;
        }
        function FGn(c5) {
          var s = c5.axis;
          return Ha2(c5.activeIntervals, function(r5) {
            return { brushType: "lineX", panelId: "pl", range: [s.dataToCoord(r5[0], true), s.dataToCoord(r5[1], true)] };
          });
        }
        function VGn(c5, s) {
          return s.getComponent("parallel", c5.get("parallelIndex"));
        }
        var BGn = RGn, zGn = { type: "axisAreaSelect", event: "axisAreaSelected" };
        function jGn(c5) {
          c5.registerAction(zGn, function(s, r5) {
            r5.eachComponent({ mainType: "parallelAxis", query: s }, function(g5) {
              g5.axis.model.setActiveIntervals(s.intervals);
            });
          }), c5.registerAction("parallelAxisExpand", function(s, r5) {
            r5.eachComponent({ mainType: "parallel", query: s }, function(g5) {
              g5.setAxisExpand(s);
            });
          });
        }
        var WGn = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
        function X5e(c5) {
          c5.registerComponentView(iGn), c5.registerComponentModel(oGn), c5.registerCoordinateSystem("parallel", yGn), c5.registerPreprocessor(QWn), c5.registerComponentModel(E5e), c5.registerComponentView(BGn), CX(c5, "parallel", E5e, WGn), jGn(c5);
        }
        function GGn(c5) {
          Fc2(X5e), c5.registerChartView(HWn), c5.registerSeriesModel($Wn), c5.registerVisual(c5.PRIORITY.VISUAL.BRUSH, XWn);
        }
        var HGn = function() {
          function c5() {
            this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
          }
          return c5;
        }(), UGn = function(c5) {
          wn(s, c5);
          function s(r5) {
            return c5.call(this, r5) || this;
          }
          return s.prototype.getDefaultShape = function() {
            return new HGn();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.extent;
            r5.moveTo(g5.x1, g5.y1), r5.bezierCurveTo(g5.cpx1, g5.cpy1, g5.cpx2, g5.cpy2, g5.x2, g5.y2), g5.orient === "vertical" ? (r5.lineTo(g5.x2 + b6, g5.y2), r5.bezierCurveTo(g5.cpx2 + b6, g5.cpy2, g5.cpx1 + b6, g5.cpy1, g5.x1 + b6, g5.y1)) : (r5.lineTo(g5.x2, g5.y2 + b6), r5.bezierCurveTo(g5.cpx2, g5.cpy2 + b6, g5.cpx1, g5.cpy1 + b6, g5.x1, g5.y1 + b6)), r5.closePath();
          }, s.prototype.highlight = function() {
            GI(this);
          }, s.prototype.downplay = function() {
            HI(this);
          }, s;
        }(Tc2), qGn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._focusAdjacencyDisabled = false, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = this, A2 = r5.getGraph(), k2 = this.group, R6 = r5.layoutInfo, B3 = R6.width, G3 = R6.height, Z3 = r5.getData(), X3 = r5.getData("edge"), tt = r5.get("orient");
            this._model = r5, k2.removeAll(), k2.x = R6.x, k2.y = R6.y, A2.eachEdge(function(it) {
              var pt = new UGn(), mt = Pl(pt);
              mt.dataIndex = it.dataIndex, mt.seriesIndex = r5.seriesIndex, mt.dataType = "edge";
              var Mt = it.getModel(), kt = Mt.getModel("lineStyle"), Gt = kt.get("curveness"), Ot = it.node1.getLayout(), ce2 = it.node1.getModel(), ae2 = ce2.get("localX"), de2 = ce2.get("localY"), we2 = it.node2.getLayout(), Se2 = it.node2.getModel(), Oe2 = Se2.get("localX"), je2 = Se2.get("localY"), rn = it.getLayout(), qe2, An, jn, _n, Jr, Qn, rr, Ar;
              switch (pt.shape.extent = Math.max(1, rn.dy), pt.shape.orient = tt, tt === "vertical" ? (qe2 = (ae2 != null ? ae2 * B3 : Ot.x) + rn.sy, An = (de2 != null ? de2 * G3 : Ot.y) + Ot.dy, jn = (Oe2 != null ? Oe2 * B3 : we2.x) + rn.ty, _n = je2 != null ? je2 * G3 : we2.y, Jr = qe2, Qn = An * (1 - Gt) + _n * Gt, rr = jn, Ar = An * Gt + _n * (1 - Gt)) : (qe2 = (ae2 != null ? ae2 * B3 : Ot.x) + Ot.dx, An = (de2 != null ? de2 * G3 : Ot.y) + rn.sy, jn = Oe2 != null ? Oe2 * B3 : we2.x, _n = (je2 != null ? je2 * G3 : we2.y) + rn.ty, Jr = qe2 * (1 - Gt) + jn * Gt, Qn = An, rr = qe2 * Gt + jn * (1 - Gt), Ar = _n), pt.setShape({ x1: qe2, y1: An, x2: jn, y2: _n, cpx1: Jr, cpy1: Qn, cpx2: rr, cpy2: Ar }), pt.useStyle(kt.getItemStyle()), pt.style.fill) {
                case "source":
                  pt.style.fill = it.node1.getVisual("color"), pt.style.decal = it.node1.getVisual("style").decal;
                  break;
                case "target":
                  pt.style.fill = it.node2.getVisual("color"), pt.style.decal = it.node2.getVisual("style").decal;
                  break;
                case "gradient":
                  var fi2 = it.node1.getVisual("color"), mi2 = it.node2.getVisual("color");
                  gs(fi2) && gs(mi2) && (pt.style.fill = new nW(0, 0, +(tt === "horizontal"), +(tt === "vertical"), [{ color: fi2, offset: 0 }, { color: mi2, offset: 1 }]));
              }
              var Oo = Mt.getModel("emphasis");
              z1(pt, Mt, "lineStyle", function(gl) {
                return gl.getItemStyle();
              }), k2.add(pt), X3.setItemGraphicEl(it.dataIndex, pt);
              var Ts = Oo.get("focus");
              f0(pt, Ts === "adjacency" ? it.getAdjacentDataIndices() : Ts, Oo.get("blurScope"), Oo.get("disabled")), Pl(pt).dataType = "edge";
            }), A2.eachNode(function(it) {
              var pt = it.getLayout(), mt = it.getModel(), Mt = mt.get("localX"), kt = mt.get("localY"), Gt = mt.getModel("emphasis"), Ot = new zf2({ shape: { x: Mt != null ? Mt * B3 : pt.x, y: kt != null ? kt * G3 : pt.y, width: pt.dx, height: pt.dy }, style: mt.getModel("itemStyle").getItemStyle(), z2: 10 });
              Uw(Ot, qb2(mt), { labelFetcher: r5, labelDataIndex: it.dataIndex, defaultText: it.id }), Ot.disableLabelAnimation = true, Ot.setStyle("fill", it.getVisual("color")), Ot.setStyle("decal", it.getVisual("style").decal), z1(Ot, mt), k2.add(Ot), Z3.setItemGraphicEl(it.dataIndex, Ot), Pl(Ot).dataType = "node";
              var ce2 = Gt.get("focus");
              f0(Ot, ce2 === "adjacency" ? it.getAdjacentDataIndices() : ce2, Gt.get("blurScope"), Gt.get("disabled"));
            }), Z3.eachItemGraphicEl(function(it, pt) {
              var mt = Z3.getItemModel(pt);
              mt.get("draggable") && (it.drift = function(Mt, kt) {
                S2._focusAdjacencyDisabled = true, this.shape.x += Mt, this.shape.y += kt, this.dirty(), b6.dispatchAction({ type: "dragNode", seriesId: r5.id, dataIndex: Z3.getRawIndex(pt), localX: this.shape.x / B3, localY: this.shape.y / G3 });
              }, it.ondragend = function() {
                S2._focusAdjacencyDisabled = false;
              }, it.draggable = true, it.cursor = "move");
            }), !this._data && r5.isAnimationEnabled() && k2.setClipPath(ZGn(k2.getBoundingRect(), r5, function() {
              k2.removeClipPath();
            })), this._data = r5.getData();
          }, s.prototype.dispose = function() {
          }, s.type = "sankey", s;
        }(Ig2);
        function ZGn(c5, s, r5) {
          var g5 = new zf2({ shape: { x: c5.x - 10, y: c5.y - 10, width: 0, height: c5.height + 20 } });
          return tv(g5, { shape: { width: c5.width + 20 } }, s, r5), g5;
        }
        var $Gn = qGn, YGn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            var b6 = r5.edges || r5.links, S2 = r5.data || r5.nodes, A2 = r5.levels;
            this.levelModels = [];
            for (var k2 = this.levelModels, R6 = 0; R6 < A2.length; R6++)
              A2[R6].depth != null && A2[R6].depth >= 0 && (k2[A2[R6].depth] = new Ag2(A2[R6], this, g5));
            if (S2 && b6) {
              var B3 = x5e(S2, b6, this, true, G3);
              return B3.data;
            }
            function G3(Z3, X3) {
              Z3.wrapMethod("getItemModel", function(tt, it) {
                var pt = tt.parentModel, mt = pt.getData().getItemLayout(it);
                if (mt) {
                  var Mt = mt.depth, kt = pt.levelModels[Mt];
                  kt && (tt.parentModel = kt);
                }
                return tt;
              }), X3.wrapMethod("getItemModel", function(tt, it) {
                var pt = tt.parentModel, mt = pt.getGraph().getEdgeByIndex(it), Mt = mt.node1.getLayout();
                if (Mt) {
                  var kt = Mt.depth, Gt = pt.levelModels[kt];
                  Gt && (tt.parentModel = Gt);
                }
                return tt;
              });
            }
          }, s.prototype.setNodePosition = function(r5, g5) {
            var b6 = this.option.data || this.option.nodes, S2 = b6[r5];
            S2.localX = g5[0], S2.localY = g5[1];
          }, s.prototype.getGraph = function() {
            return this.getData().graph;
          }, s.prototype.getEdgeData = function() {
            return this.getGraph().edgeData;
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            function S2(tt) {
              return isNaN(tt) || tt == null;
            }
            if (b6 === "edge") {
              var A2 = this.getDataParams(r5, b6), k2 = A2.data, R6 = A2.value, B3 = k2.source + " -- " + k2.target;
              return W1("nameValue", { name: B3, value: R6, noValue: S2(R6) });
            } else {
              var G3 = this.getGraph().getNodeByIndex(r5), Z3 = G3.getLayout().value, X3 = this.getDataParams(r5, b6).data.name;
              return W1("nameValue", { name: X3 != null ? X3 + "" : null, value: Z3, noValue: S2(Z3) });
            }
          }, s.prototype.optionUpdated = function() {
          }, s.prototype.getDataParams = function(r5, g5) {
            var b6 = c5.prototype.getDataParams.call(this, r5, g5);
            if (b6.value == null && g5 === "node") {
              var S2 = this.getGraph().getNodeByIndex(r5), A2 = S2.getLayout().value;
              b6.value = A2;
            }
            return b6;
          }, s.type = "series.sankey", s.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, s;
        }(zv), KGn = YGn;
        function XGn(c5, s) {
          c5.eachSeriesByType("sankey", function(r5) {
            var g5 = r5.get("nodeWidth"), b6 = r5.get("nodeGap"), S2 = QGn(r5, s);
            r5.layoutInfo = S2;
            var A2 = S2.width, k2 = S2.height, R6 = r5.getGraph(), B3 = R6.nodes, G3 = R6.edges;
            tHn(B3);
            var Z3 = jp(B3, function(pt) {
              return pt.getLayout().value === 0;
            }), X3 = Z3.length !== 0 ? 0 : r5.get("layoutIterations"), tt = r5.get("orient"), it = r5.get("nodeAlign");
            JGn(B3, G3, g5, b6, A2, k2, X3, tt, it);
          });
        }
        function QGn(c5, s) {
          return $m(c5.getBoxLayoutParams(), { width: s.getWidth(), height: s.getHeight() });
        }
        function JGn(c5, s, r5, g5, b6, S2, A2, k2, R6) {
          eHn(c5, s, r5, b6, S2, k2, R6), aHn(c5, s, S2, b6, g5, A2, k2), dHn(c5, k2);
        }
        function tHn(c5) {
          Ye2(c5, function(s) {
            var r5 = l9(s.outEdges, pCt), g5 = l9(s.inEdges, pCt), b6 = s.getValue() || 0, S2 = Math.max(r5, g5, b6);
            s.setLayout({ value: S2 }, true);
          });
        }
        function eHn(c5, s, r5, g5, b6, S2, A2) {
          for (var k2 = [], R6 = [], B3 = [], G3 = [], Z3 = 0, X3 = 0; X3 < s.length; X3++)
            k2[X3] = 1;
          for (var X3 = 0; X3 < c5.length; X3++)
            R6[X3] = c5[X3].inEdges.length, R6[X3] === 0 && B3.push(c5[X3]);
          for (var tt = -1; B3.length; ) {
            for (var it = 0; it < B3.length; it++) {
              var pt = B3[it], mt = pt.hostGraph.data.getRawDataItem(pt.dataIndex), Mt = mt.depth != null && mt.depth >= 0;
              Mt && mt.depth > tt && (tt = mt.depth), pt.setLayout({ depth: Mt ? mt.depth : Z3 }, true), S2 === "vertical" ? pt.setLayout({ dy: r5 }, true) : pt.setLayout({ dx: r5 }, true);
              for (var kt = 0; kt < pt.outEdges.length; kt++) {
                var Gt = pt.outEdges[kt], Ot = s.indexOf(Gt);
                k2[Ot] = 0;
                var ce2 = Gt.node2, ae2 = c5.indexOf(ce2);
                --R6[ae2] === 0 && G3.indexOf(ce2) < 0 && G3.push(ce2);
              }
            }
            ++Z3, B3 = G3, G3 = [];
          }
          for (var X3 = 0; X3 < k2.length; X3++)
            if (k2[X3] === 1)
              throw new Error("Sankey is a DAG, the original data has cycle!");
          var de2 = tt > Z3 - 1 ? tt : Z3 - 1;
          A2 && A2 !== "left" && nHn(c5, A2, S2, de2);
          var we2 = S2 === "vertical" ? (b6 - r5) / de2 : (g5 - r5) / de2;
          iHn(c5, we2, S2);
        }
        function Q5e(c5) {
          var s = c5.hostGraph.data.getRawDataItem(c5.dataIndex);
          return s.depth != null && s.depth >= 0;
        }
        function nHn(c5, s, r5, g5) {
          if (s === "right") {
            for (var b6 = [], S2 = c5, A2 = 0; S2.length; ) {
              for (var k2 = 0; k2 < S2.length; k2++) {
                var R6 = S2[k2];
                R6.setLayout({ skNodeHeight: A2 }, true);
                for (var B3 = 0; B3 < R6.inEdges.length; B3++) {
                  var G3 = R6.inEdges[B3];
                  b6.indexOf(G3.node1) < 0 && b6.push(G3.node1);
                }
              }
              S2 = b6, b6 = [], ++A2;
            }
            Ye2(c5, function(Z3) {
              Q5e(Z3) || Z3.setLayout({ depth: Math.max(0, g5 - Z3.getLayout().skNodeHeight) }, true);
            });
          } else
            s === "justify" && rHn(c5, g5);
        }
        function rHn(c5, s) {
          Ye2(c5, function(r5) {
            !Q5e(r5) && !r5.outEdges.length && r5.setLayout({ depth: s }, true);
          });
        }
        function iHn(c5, s, r5) {
          Ye2(c5, function(g5) {
            var b6 = g5.getLayout().depth * s;
            r5 === "vertical" ? g5.setLayout({ y: b6 }, true) : g5.setLayout({ x: b6 }, true);
          });
        }
        function aHn(c5, s, r5, g5, b6, S2, A2) {
          var k2 = oHn(c5, A2);
          sHn(k2, s, r5, g5, b6, A2), dUt(k2, b6, r5, g5, A2);
          for (var R6 = 1; S2 > 0; S2--)
            R6 *= 0.99, lHn(k2, R6, A2), dUt(k2, b6, r5, g5, A2), pHn(k2, R6, A2), dUt(k2, b6, r5, g5, A2);
        }
        function oHn(c5, s) {
          var r5 = [], g5 = s === "vertical" ? "y" : "x", b6 = SK(c5, function(S2) {
            return S2.getLayout()[g5];
          });
          return b6.keys.sort(function(S2, A2) {
            return S2 - A2;
          }), Ye2(b6.keys, function(S2) {
            r5.push(b6.buckets.get(S2));
          }), r5;
        }
        function sHn(c5, s, r5, g5, b6, S2) {
          var A2 = 1 / 0;
          Ye2(c5, function(k2) {
            var R6 = k2.length, B3 = 0;
            Ye2(k2, function(Z3) {
              B3 += Z3.getLayout().value;
            });
            var G3 = S2 === "vertical" ? (g5 - (R6 - 1) * b6) / B3 : (r5 - (R6 - 1) * b6) / B3;
            G3 < A2 && (A2 = G3);
          }), Ye2(c5, function(k2) {
            Ye2(k2, function(R6, B3) {
              var G3 = R6.getLayout().value * A2;
              S2 === "vertical" ? (R6.setLayout({ x: B3 }, true), R6.setLayout({ dx: G3 }, true)) : (R6.setLayout({ y: B3 }, true), R6.setLayout({ dy: G3 }, true));
            });
          }), Ye2(s, function(k2) {
            var R6 = +k2.getValue() * A2;
            k2.setLayout({ dy: R6 }, true);
          });
        }
        function dUt(c5, s, r5, g5, b6) {
          var S2 = b6 === "vertical" ? "x" : "y";
          Ye2(c5, function(A2) {
            A2.sort(function(pt, mt) {
              return pt.getLayout()[S2] - mt.getLayout()[S2];
            });
            for (var k2, R6, B3, G3 = 0, Z3 = A2.length, X3 = b6 === "vertical" ? "dx" : "dy", tt = 0; tt < Z3; tt++)
              R6 = A2[tt], B3 = G3 - R6.getLayout()[S2], B3 > 0 && (k2 = R6.getLayout()[S2] + B3, b6 === "vertical" ? R6.setLayout({ x: k2 }, true) : R6.setLayout({ y: k2 }, true)), G3 = R6.getLayout()[S2] + R6.getLayout()[X3] + s;
            var it = b6 === "vertical" ? g5 : r5;
            if (B3 = G3 - s - it, B3 > 0) {
              k2 = R6.getLayout()[S2] - B3, b6 === "vertical" ? R6.setLayout({ x: k2 }, true) : R6.setLayout({ y: k2 }, true), G3 = k2;
              for (var tt = Z3 - 2; tt >= 0; --tt)
                R6 = A2[tt], B3 = R6.getLayout()[S2] + R6.getLayout()[X3] + s - G3, B3 > 0 && (k2 = R6.getLayout()[S2] - B3, b6 === "vertical" ? R6.setLayout({ x: k2 }, true) : R6.setLayout({ y: k2 }, true)), G3 = R6.getLayout()[S2];
            }
          });
        }
        function lHn(c5, s, r5) {
          Ye2(c5.slice().reverse(), function(g5) {
            Ye2(g5, function(b6) {
              if (b6.outEdges.length) {
                var S2 = l9(b6.outEdges, uHn, r5) / l9(b6.outEdges, pCt);
                if (isNaN(S2)) {
                  var A2 = b6.outEdges.length;
                  S2 = A2 ? l9(b6.outEdges, cHn, r5) / A2 : 0;
                }
                if (r5 === "vertical") {
                  var k2 = b6.getLayout().x + (S2 - s9(b6, r5)) * s;
                  b6.setLayout({ x: k2 }, true);
                } else {
                  var R6 = b6.getLayout().y + (S2 - s9(b6, r5)) * s;
                  b6.setLayout({ y: R6 }, true);
                }
              }
            });
          });
        }
        function uHn(c5, s) {
          return s9(c5.node2, s) * c5.getValue();
        }
        function cHn(c5, s) {
          return s9(c5.node2, s);
        }
        function fHn(c5, s) {
          return s9(c5.node1, s) * c5.getValue();
        }
        function hHn(c5, s) {
          return s9(c5.node1, s);
        }
        function s9(c5, s) {
          return s === "vertical" ? c5.getLayout().x + c5.getLayout().dx / 2 : c5.getLayout().y + c5.getLayout().dy / 2;
        }
        function pCt(c5) {
          return c5.getValue();
        }
        function l9(c5, s, r5) {
          for (var g5 = 0, b6 = c5.length, S2 = -1; ++S2 < b6; ) {
            var A2 = +s(c5[S2], r5);
            isNaN(A2) || (g5 += A2);
          }
          return g5;
        }
        function pHn(c5, s, r5) {
          Ye2(c5, function(g5) {
            Ye2(g5, function(b6) {
              if (b6.inEdges.length) {
                var S2 = l9(b6.inEdges, fHn, r5) / l9(b6.inEdges, pCt);
                if (isNaN(S2)) {
                  var A2 = b6.inEdges.length;
                  S2 = A2 ? l9(b6.inEdges, hHn, r5) / A2 : 0;
                }
                if (r5 === "vertical") {
                  var k2 = b6.getLayout().x + (S2 - s9(b6, r5)) * s;
                  b6.setLayout({ x: k2 }, true);
                } else {
                  var R6 = b6.getLayout().y + (S2 - s9(b6, r5)) * s;
                  b6.setLayout({ y: R6 }, true);
                }
              }
            });
          });
        }
        function dHn(c5, s) {
          var r5 = s === "vertical" ? "x" : "y";
          Ye2(c5, function(g5) {
            g5.outEdges.sort(function(b6, S2) {
              return b6.node2.getLayout()[r5] - S2.node2.getLayout()[r5];
            }), g5.inEdges.sort(function(b6, S2) {
              return b6.node1.getLayout()[r5] - S2.node1.getLayout()[r5];
            });
          }), Ye2(c5, function(g5) {
            var b6 = 0, S2 = 0;
            Ye2(g5.outEdges, function(A2) {
              A2.setLayout({ sy: b6 }, true), b6 += A2.getLayout().dy;
            }), Ye2(g5.inEdges, function(A2) {
              A2.setLayout({ ty: S2 }, true), S2 += A2.getLayout().dy;
            });
          });
        }
        function gHn(c5) {
          c5.eachSeriesByType("sankey", function(s) {
            var r5 = s.getGraph(), g5 = r5.nodes;
            if (g5.length) {
              var b6 = 1 / 0, S2 = -1 / 0;
              Ye2(g5, function(A2) {
                var k2 = A2.getLayout().value;
                k2 < b6 && (b6 = k2), k2 > S2 && (S2 = k2);
              }), Ye2(g5, function(A2) {
                var k2 = new Sx({ type: "color", mappingMethod: "linear", dataExtent: [b6, S2], visual: s.get("color") }), R6 = k2.mapValueToVisual(A2.getLayout().value), B3 = A2.getModel().get(["itemStyle", "color"]);
                B3 != null ? (A2.setVisual("color", B3), A2.setVisual("style", { fill: B3 })) : (A2.setVisual("color", R6), A2.setVisual("style", { fill: R6 }));
              });
            }
          });
        }
        function vHn(c5) {
          c5.registerChartView($Gn), c5.registerSeriesModel(KGn), c5.registerLayout(XGn), c5.registerVisual(gHn), c5.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(s, r5) {
            r5.eachComponent({ mainType: "series", subType: "sankey", query: s }, function(g5) {
              g5.setNodePosition(s.dataIndex, [s.localX, s.localY]);
            });
          });
        }
        var J5e = function() {
          function c5() {
          }
          return c5.prototype.getInitialData = function(s, r5) {
            var g5, b6 = r5.getComponent("xAxis", this.get("xAxisIndex")), S2 = r5.getComponent("yAxis", this.get("yAxisIndex")), A2 = b6.get("type"), k2 = S2.get("type"), R6;
            A2 === "category" ? (s.layout = "horizontal", g5 = b6.getOrdinalMeta(), R6 = true) : k2 === "category" ? (s.layout = "vertical", g5 = S2.getOrdinalMeta(), R6 = true) : s.layout = s.layout || "horizontal";
            var B3 = ["x", "y"], G3 = s.layout === "horizontal" ? 0 : 1, Z3 = this._baseAxisDim = B3[G3], X3 = B3[1 - G3], tt = [b6, S2], it = tt[G3].get("type"), pt = tt[1 - G3].get("type"), mt = s.data;
            if (mt && R6) {
              var Mt = [];
              Ye2(mt, function(Ot, ce2) {
                var ae2;
                ja2(Ot) ? (ae2 = Ot.slice(), Ot.unshift(ce2)) : ja2(Ot.value) ? (ae2 = sa2({}, Ot), ae2.value = ae2.value.slice(), Ot.value.unshift(ce2)) : ae2 = Ot, Mt.push(ae2);
              }), s.data = Mt;
            }
            var kt = this.defaultValueDimensions, Gt = [{ name: Z3, type: wMt(it), ordinalMeta: g5, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: X3, type: wMt(pt), dimsDef: kt.slice() }];
            return MX(this, { coordDimensions: Gt, dimensionsCount: kt.length + 1, encodeDefaulter: Au(uTe, Gt, this) });
          }, c5.prototype.getBaseAxis = function() {
            var s = this._baseAxisDim;
            return this.ecModel.getComponent(s + "Axis", this.get(s + "AxisIndex")).axis;
          }, c5;
        }(), tPe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], r5.visualDrawType = "stroke", r5;
          }
          return s.type = "series.boxplot", s.dependencies = ["xAxis", "yAxis", "grid"], s.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, s;
        }(zv);
        A0(tPe, J5e, true);
        var yHn = tPe, mHn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this.group, k2 = this._data;
            this._data || A2.removeAll();
            var R6 = r5.get("layout") === "horizontal" ? 1 : 0;
            S2.diff(k2).add(function(B3) {
              if (S2.hasValue(B3)) {
                var G3 = S2.getItemLayout(B3), Z3 = ePe(G3, S2, B3, R6, true);
                S2.setItemGraphicEl(B3, Z3), A2.add(Z3);
              }
            }).update(function(B3, G3) {
              var Z3 = k2.getItemGraphicEl(G3);
              if (!S2.hasValue(B3)) {
                A2.remove(Z3);
                return;
              }
              var X3 = S2.getItemLayout(B3);
              Z3 ? (nT(Z3), nPe(X3, Z3, S2, B3)) : Z3 = ePe(X3, S2, B3, R6), A2.add(Z3), S2.setItemGraphicEl(B3, Z3);
            }).remove(function(B3) {
              var G3 = k2.getItemGraphicEl(B3);
              G3 && A2.remove(G3);
            }).execute(), this._data = S2;
          }, s.prototype.remove = function(r5) {
            var g5 = this.group, b6 = this._data;
            this._data = null, b6 && b6.eachItemGraphicEl(function(S2) {
              S2 && g5.remove(S2);
            });
          }, s.type = "boxplot", s;
        }(Ig2), bHn = function() {
          function c5() {
          }
          return c5;
        }(), _Hn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "boxplotBoxPath", g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new bHn();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.points, S2 = 0;
            for (r5.moveTo(b6[S2][0], b6[S2][1]), S2++; S2 < 4; S2++)
              r5.lineTo(b6[S2][0], b6[S2][1]);
            for (r5.closePath(); S2 < b6.length; S2++)
              r5.moveTo(b6[S2][0], b6[S2][1]), S2++, r5.lineTo(b6[S2][0], b6[S2][1]);
          }, s;
        }(Tc2);
        function ePe(c5, s, r5, g5, b6) {
          var S2 = c5.ends, A2 = new _Hn({ shape: { points: b6 ? xHn(S2, g5, c5) : S2 } });
          return nPe(c5, A2, s, r5, b6), A2;
        }
        function nPe(c5, s, r5, g5, b6) {
          var S2 = r5.hostModel, A2 = Jut[b6 ? "initProps" : "updateProps"];
          A2(s, { shape: { points: c5.ends } }, S2, g5), s.useStyle(r5.getItemVisual(g5, "style")), s.style.strokeNoScale = true, s.z2 = 100;
          var k2 = r5.getItemModel(g5), R6 = k2.getModel("emphasis");
          z1(s, k2), f0(s, R6.get("focus"), R6.get("blurScope"), R6.get("disabled"));
        }
        function xHn(c5, s, r5) {
          return Ha2(c5, function(g5) {
            return g5 = g5.slice(), g5[s] = r5.initBaseline, g5;
          });
        }
        var wHn = mHn;
        function SHn(c5, s) {
        }
        var aft = Ye2;
        function MHn(c5) {
          var s = CHn(c5);
          aft(s, function(r5) {
            var g5 = r5.seriesModels;
            !g5.length || (THn(r5), aft(g5, function(b6, S2) {
              AHn(b6, r5.boxOffsetList[S2], r5.boxWidthList[S2]);
            }));
          });
        }
        function CHn(c5) {
          var s = [], r5 = [];
          return c5.eachSeriesByType("boxplot", function(g5) {
            var b6 = g5.getBaseAxis(), S2 = Lu(r5, b6);
            S2 < 0 && (S2 = r5.length, r5[S2] = b6, s[S2] = { axis: b6, seriesModels: [] }), s[S2].seriesModels.push(g5);
          }), s;
        }
        function THn(c5) {
          var s = c5.axis, r5 = c5.seriesModels, g5 = r5.length, b6 = c5.boxWidthList = [], S2 = c5.boxOffsetList = [], A2 = [], k2;
          if (s.type === "category")
            k2 = s.getBandWidth();
          else {
            var R6 = 0;
            aft(r5, function(it) {
              R6 = Math.max(R6, it.getData().count());
            });
            var B3 = s.getExtent();
            k2 = Math.abs(B3[1] - B3[0]) / R6;
          }
          aft(r5, function(it) {
            var pt = it.get("boxWidth");
            ja2(pt) || (pt = [pt, pt]), A2.push([$o(pt[0], k2) || 0, $o(pt[1], k2) || 0]);
          });
          var G3 = k2 * 0.8 - 2, Z3 = G3 / g5 * 0.3, X3 = (G3 - Z3 * (g5 - 1)) / g5, tt = X3 / 2 - G3 / 2;
          aft(r5, function(it, pt) {
            S2.push(tt), tt += Z3 + X3, b6.push(Math.min(Math.max(X3, A2[pt][0]), A2[pt][1]));
          });
        }
        function AHn(c5, s, r5) {
          var g5 = c5.coordinateSystem, b6 = c5.getData(), S2 = r5 / 2, A2 = c5.get("layout") === "horizontal" ? 0 : 1, k2 = 1 - A2, R6 = ["x", "y"], B3 = b6.mapDimension(R6[A2]), G3 = b6.mapDimensionsAll(R6[k2]);
          if (B3 == null || G3.length < 5)
            return;
          for (var Z3 = 0; Z3 < b6.count(); Z3++) {
            var X3 = b6.get(B3, Z3), tt = Gt(X3, G3[2], Z3), it = Gt(X3, G3[0], Z3), pt = Gt(X3, G3[1], Z3), mt = Gt(X3, G3[3], Z3), Mt = Gt(X3, G3[4], Z3), kt = [];
            Ot(kt, pt, false), Ot(kt, mt, true), kt.push(it, pt, Mt, mt), ce2(kt, it), ce2(kt, Mt), ce2(kt, tt), b6.setItemLayout(Z3, { initBaseline: tt[k2], ends: kt });
          }
          function Gt(ae2, de2, we2) {
            var Se2 = b6.get(de2, we2), Oe2 = [];
            Oe2[A2] = ae2, Oe2[k2] = Se2;
            var je2;
            return isNaN(ae2) || isNaN(Se2) ? je2 = [NaN, NaN] : (je2 = g5.dataToPoint(Oe2), je2[A2] += s), je2;
          }
          function Ot(ae2, de2, we2) {
            var Se2 = de2.slice(), Oe2 = de2.slice();
            Se2[A2] += S2, Oe2[A2] -= S2, we2 ? ae2.push(Se2, Oe2) : ae2.push(Oe2, Se2);
          }
          function ce2(ae2, de2) {
            var we2 = de2.slice(), Se2 = de2.slice();
            we2[A2] -= S2, Se2[A2] += S2, ae2.push(we2, Se2);
          }
        }
        function IHn(c5, s) {
          s = s || {};
          for (var r5 = [], g5 = [], b6 = s.boundIQR, S2 = b6 === "none" || b6 === 0, A2 = 0; A2 < c5.length; A2++) {
            var k2 = h2(c5[A2].slice()), R6 = JC(k2, 0.25), B3 = JC(k2, 0.5), G3 = JC(k2, 0.75), Z3 = k2[0], X3 = k2[k2.length - 1], tt = (b6 == null ? 1.5 : b6) * (G3 - R6), it = S2 ? Z3 : Math.max(Z3, R6 - tt), pt = S2 ? X3 : Math.min(X3, G3 + tt), mt = s.itemNameFormatter, Mt = Tl(mt) ? mt({ value: A2 }) : gs(mt) ? mt.replace("{value}", A2 + "") : A2 + "";
            r5.push([Mt, it, R6, B3, G3, pt]);
            for (var kt = 0; kt < k2.length; kt++) {
              var Gt = k2[kt];
              if (Gt < it || Gt > pt) {
                var Ot = [Mt, Gt];
                g5.push(Ot);
              }
            }
          }
          return { boxData: r5, outliers: g5 };
        }
        var DHn = { type: "echarts:boxplot", transform: function(c5) {
          var s = c5.upstream;
          if (s.sourceFormat !== qw) {
            var r5 = "";
            rf2(r5);
          }
          var g5 = IHn(s.getRawData(), c5.config);
          return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: g5.boxData }, { data: g5.outliers }];
        } };
        function EHn(c5) {
          c5.registerSeriesModel(yHn), c5.registerChartView(wHn), c5.registerVisual(SHn), c5.registerLayout(MHn), c5.registerTransform(DHn);
        }
        var kHn = ["color", "borderColor"], PHn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(r5), this._isLargeDraw ? this._renderLarge(r5) : this._renderNormal(r5);
          }, s.prototype.incrementalPrepareRender = function(r5, g5, b6) {
            this._clear(), this._updateDrawMode(r5);
          }, s.prototype.incrementalRender = function(r5, g5, b6, S2) {
            this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(r5, g5) : this._incrementalRenderNormal(r5, g5);
          }, s.prototype.eachRendered = function(r5) {
            Ik(this._progressiveEls || this.group, r5);
          }, s.prototype._updateDrawMode = function(r5) {
            var g5 = r5.pipelineContext.large;
            (this._isLargeDraw == null || g5 !== this._isLargeDraw) && (this._isLargeDraw = g5, this._clear());
          }, s.prototype._renderNormal = function(r5) {
            var g5 = r5.getData(), b6 = this._data, S2 = this.group, A2 = g5.getLayout("isSimpleBox"), k2 = r5.get("clip", true), R6 = r5.coordinateSystem, B3 = R6.getArea && R6.getArea();
            this._data || S2.removeAll(), g5.diff(b6).add(function(G3) {
              if (g5.hasValue(G3)) {
                var Z3 = g5.getItemLayout(G3);
                if (k2 && rPe(B3, Z3))
                  return;
                var X3 = gUt(Z3, G3, true);
                tv(X3, { shape: { points: Z3.ends } }, r5, G3), vUt(X3, g5, G3, A2), S2.add(X3), g5.setItemGraphicEl(G3, X3);
              }
            }).update(function(G3, Z3) {
              var X3 = b6.getItemGraphicEl(Z3);
              if (!g5.hasValue(G3)) {
                S2.remove(X3);
                return;
              }
              var tt = g5.getItemLayout(G3);
              if (k2 && rPe(B3, tt)) {
                S2.remove(X3);
                return;
              }
              X3 ? (Qf2(X3, { shape: { points: tt.ends } }, r5, G3), nT(X3)) : X3 = gUt(tt), vUt(X3, g5, G3, A2), S2.add(X3), g5.setItemGraphicEl(G3, X3);
            }).remove(function(G3) {
              var Z3 = b6.getItemGraphicEl(G3);
              Z3 && S2.remove(Z3);
            }).execute(), this._data = g5;
          }, s.prototype._renderLarge = function(r5) {
            this._clear(), aPe(r5, this.group);
            var g5 = r5.get("clip", true) ? WMt(r5.coordinateSystem, false, r5) : null;
            g5 ? this.group.setClipPath(g5) : this.group.removeClipPath();
          }, s.prototype._incrementalRenderNormal = function(r5, g5) {
            for (var b6 = g5.getData(), S2 = b6.getLayout("isSimpleBox"), A2; (A2 = r5.next()) != null; ) {
              var k2 = b6.getItemLayout(A2), R6 = gUt(k2);
              vUt(R6, b6, A2, S2), R6.incremental = true, this.group.add(R6), this._progressiveEls.push(R6);
            }
          }, s.prototype._incrementalRenderLarge = function(r5, g5) {
            aPe(g5, this.group, this._progressiveEls, true);
          }, s.prototype.remove = function(r5) {
            this._clear();
          }, s.prototype._clear = function() {
            this.group.removeAll(), this._data = null;
          }, s.type = "candlestick", s;
        }(Ig2), LHn = function() {
          function c5() {
          }
          return c5;
        }(), OHn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "normalCandlestickBox", g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new LHn();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.points;
            this.__simpleBox ? (r5.moveTo(b6[4][0], b6[4][1]), r5.lineTo(b6[6][0], b6[6][1])) : (r5.moveTo(b6[0][0], b6[0][1]), r5.lineTo(b6[1][0], b6[1][1]), r5.lineTo(b6[2][0], b6[2][1]), r5.lineTo(b6[3][0], b6[3][1]), r5.closePath(), r5.moveTo(b6[4][0], b6[4][1]), r5.lineTo(b6[5][0], b6[5][1]), r5.moveTo(b6[6][0], b6[6][1]), r5.lineTo(b6[7][0], b6[7][1]));
          }, s;
        }(Tc2);
        function gUt(c5, s, r5) {
          var g5 = c5.ends;
          return new OHn({ shape: { points: r5 ? RHn(g5, c5) : g5 }, z2: 100 });
        }
        function rPe(c5, s) {
          for (var r5 = true, g5 = 0; g5 < s.ends.length; g5++)
            if (c5.contain(s.ends[g5][0], s.ends[g5][1])) {
              r5 = false;
              break;
            }
          return r5;
        }
        function vUt(c5, s, r5, g5) {
          var b6 = s.getItemModel(r5);
          c5.useStyle(s.getItemVisual(r5, "style")), c5.style.strokeNoScale = true, c5.__simpleBox = g5, z1(c5, b6);
        }
        function RHn(c5, s) {
          return Ha2(c5, function(r5) {
            return r5 = r5.slice(), r5[1] = s.initBaseline, r5;
          });
        }
        var NHn = function() {
          function c5() {
          }
          return c5;
        }(), iPe = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5.type = "largeCandlestickBox", g5;
          }
          return s.prototype.getDefaultShape = function() {
            return new NHn();
          }, s.prototype.buildPath = function(r5, g5) {
            for (var b6 = g5.points, S2 = 0; S2 < b6.length; )
              if (this.__sign === b6[S2++]) {
                var A2 = b6[S2++];
                r5.moveTo(A2, b6[S2++]), r5.lineTo(A2, b6[S2++]);
              } else
                S2 += 3;
          }, s;
        }(Tc2);
        function aPe(c5, s, r5, g5) {
          var b6 = c5.getData(), S2 = b6.getLayout("largePoints"), A2 = new iPe({ shape: { points: S2 }, __sign: 1 });
          s.add(A2);
          var k2 = new iPe({ shape: { points: S2 }, __sign: -1 });
          s.add(k2), oPe(1, A2, c5), oPe(-1, k2, c5), g5 && (A2.incremental = true, k2.incremental = true), r5 && r5.push(A2, k2);
        }
        function oPe(c5, s, r5, g5) {
          var b6 = r5.get(["itemStyle", c5 > 0 ? "borderColor" : "borderColor0"]) || r5.get(["itemStyle", c5 > 0 ? "color" : "color0"]), S2 = r5.getModel("itemStyle").getItemStyle(kHn);
          s.useStyle(S2), s.style.fill = null, s.style.stroke = b6;
        }
        var FHn = PHn, sPe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], r5;
          }
          return s.prototype.getShadowDim = function() {
            return "open";
          }, s.prototype.brushSelector = function(r5, g5, b6) {
            var S2 = g5.getItemLayout(r5);
            return S2 && b6.rect(S2.brushRect);
          }, s.type = "series.candlestick", s.dependencies = ["xAxis", "yAxis", "grid"], s.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, s;
        }(zv);
        A0(sPe, J5e, true);
        var VHn = sPe;
        function BHn(c5) {
          !c5 || !ja2(c5.series) || Ye2(c5.series, function(s) {
            Wl(s) && s.type === "k" && (s.type = "candlestick");
          });
        }
        var zHn = ["itemStyle", "borderColor"], jHn = ["itemStyle", "borderColor0"], WHn = ["itemStyle", "color"], GHn = ["itemStyle", "color0"], HHn = { seriesType: "candlestick", plan: hX(), performRawSeries: true, reset: function(c5, s) {
          function r5(S2, A2) {
            return A2.get(S2 > 0 ? WHn : GHn);
          }
          function g5(S2, A2) {
            return A2.get(S2 > 0 ? zHn : jHn);
          }
          if (!s.isSeriesFiltered(c5)) {
            var b6 = c5.pipelineContext.large;
            return !b6 && { progress: function(S2, A2) {
              for (var k2; (k2 = S2.next()) != null; ) {
                var R6 = A2.getItemModel(k2), B3 = A2.getItemLayout(k2).sign, G3 = R6.getItemStyle();
                G3.fill = r5(B3, R6), G3.stroke = g5(B3, R6) || G3.fill;
                var Z3 = A2.ensureUniqueItemVisual(k2, "style");
                sa2(Z3, G3);
              }
            } };
          }
        } }, UHn = HHn, qHn = { seriesType: "candlestick", plan: hX(), reset: function(c5) {
          var s = c5.coordinateSystem, r5 = c5.getData(), g5 = ZHn(c5, r5), b6 = 0, S2 = 1, A2 = ["x", "y"], k2 = r5.getDimensionIndex(r5.mapDimension(A2[b6])), R6 = Ha2(r5.mapDimensionsAll(A2[S2]), r5.getDimensionIndex, r5), B3 = R6[0], G3 = R6[1], Z3 = R6[2], X3 = R6[3];
          if (r5.setLayout({ candleWidth: g5, isSimpleBox: g5 <= 1.3 }), k2 < 0 || R6.length < 4)
            return;
          return { progress: c5.pipelineContext.large ? it : tt };
          function tt(pt, mt) {
            for (var Mt, kt = mt.getStore(); (Mt = pt.next()) != null; ) {
              var Gt = kt.get(k2, Mt), Ot = kt.get(B3, Mt), ce2 = kt.get(G3, Mt), ae2 = kt.get(Z3, Mt), de2 = kt.get(X3, Mt), we2 = Math.min(Ot, ce2), Se2 = Math.max(Ot, ce2), Oe2 = jn(we2, Gt), je2 = jn(Se2, Gt), rn = jn(ae2, Gt), qe2 = jn(de2, Gt), An = [];
              _n(An, je2, 0), _n(An, Oe2, 1), An.push(Qn(qe2), Qn(je2), Qn(rn), Qn(Oe2)), mt.setItemLayout(Mt, { sign: lPe(kt, Mt, Ot, ce2, G3), initBaseline: Ot > ce2 ? je2[S2] : Oe2[S2], ends: An, brushRect: Jr(ae2, de2, Gt) });
            }
            function jn(rr, Ar) {
              var fi2 = [];
              return fi2[b6] = Ar, fi2[S2] = rr, isNaN(Ar) || isNaN(rr) ? [NaN, NaN] : s.dataToPoint(fi2);
            }
            function _n(rr, Ar, fi2) {
              var mi2 = Ar.slice(), Oo = Ar.slice();
              mi2[b6] = wo(mi2[b6] + g5 / 2, 1, false), Oo[b6] = wo(Oo[b6] - g5 / 2, 1, true), fi2 ? rr.push(mi2, Oo) : rr.push(Oo, mi2);
            }
            function Jr(rr, Ar, fi2) {
              var mi2 = jn(rr, fi2), Oo = jn(Ar, fi2);
              return mi2[b6] -= g5 / 2, Oo[b6] -= g5 / 2, { x: mi2[0], y: mi2[1], width: g5, height: Oo[1] - mi2[1] };
            }
            function Qn(rr) {
              return rr[b6] = wo(rr[b6], 1), rr;
            }
          }
          function it(pt, mt) {
            for (var Mt = k3(pt.count * 4), kt = 0, Gt, Ot = [], ce2 = [], ae2, de2 = mt.getStore(); (ae2 = pt.next()) != null; ) {
              var we2 = de2.get(k2, ae2), Se2 = de2.get(B3, ae2), Oe2 = de2.get(G3, ae2), je2 = de2.get(Z3, ae2), rn = de2.get(X3, ae2);
              if (isNaN(we2) || isNaN(je2) || isNaN(rn)) {
                Mt[kt++] = NaN, kt += 3;
                continue;
              }
              Mt[kt++] = lPe(de2, ae2, Se2, Oe2, G3), Ot[b6] = we2, Ot[S2] = je2, Gt = s.dataToPoint(Ot, null, ce2), Mt[kt++] = Gt ? Gt[0] : NaN, Mt[kt++] = Gt ? Gt[1] : NaN, Ot[S2] = rn, Gt = s.dataToPoint(Ot, null, ce2), Mt[kt++] = Gt ? Gt[1] : NaN;
            }
            mt.setLayout("largePoints", Mt);
          }
        } };
        function lPe(c5, s, r5, g5, b6) {
          var S2;
          return r5 > g5 ? S2 = -1 : r5 < g5 ? S2 = 1 : S2 = s > 0 ? c5.get(b6, s - 1) <= g5 ? 1 : -1 : 1, S2;
        }
        function ZHn(c5, s) {
          var r5 = c5.getBaseAxis(), g5, b6 = r5.type === "category" ? r5.getBandWidth() : (g5 = r5.getExtent(), Math.abs(g5[1] - g5[0]) / s.count()), S2 = $o(tc2(c5.get("barMaxWidth"), b6), b6), A2 = $o(tc2(c5.get("barMinWidth"), 1), b6), k2 = c5.get("barWidth");
          return k2 != null ? $o(k2, b6) : Math.max(Math.min(b6 / 2, S2), A2);
        }
        var $Hn = qHn;
        function YHn(c5) {
          c5.registerChartView(FHn), c5.registerSeriesModel(VHn), c5.registerPreprocessor(BHn), c5.registerVisual(UHn), c5.registerLayout($Hn);
        }
        function uPe(c5, s) {
          var r5 = s.rippleEffectColor || s.color;
          c5.eachChild(function(g5) {
            g5.attr({ z: s.z, zlevel: s.zlevel, style: { stroke: s.brushType === "stroke" ? r5 : null, fill: s.brushType === "fill" ? r5 : null } });
          });
        }
        var KHn = function(c5) {
          wn(s, c5);
          function s(r5, g5) {
            var b6 = c5.call(this) || this, S2 = new Fct(r5, g5), A2 = new nu();
            return b6.add(S2), b6.add(A2), b6.updateData(r5, g5), b6;
          }
          return s.prototype.stopEffectAnimation = function() {
            this.childAt(1).removeAll();
          }, s.prototype.startEffectAnimation = function(r5) {
            for (var g5 = r5.symbolType, b6 = r5.color, S2 = r5.rippleNumber, A2 = this.childAt(1), k2 = 0; k2 < S2; k2++) {
              var R6 = am(g5, -1, -1, 2, 2, b6);
              R6.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
              var B3 = -k2 / S2 * r5.period + r5.effectOffset;
              R6.animate("", true).when(r5.period, { scaleX: r5.rippleScale / 2, scaleY: r5.rippleScale / 2 }).delay(B3).start(), R6.animateStyle(true).when(r5.period, { opacity: 0 }).delay(B3).start(), A2.add(R6);
            }
            uPe(A2, r5);
          }, s.prototype.updateEffectAnimation = function(r5) {
            for (var g5 = this._effectCfg, b6 = this.childAt(1), S2 = ["symbolType", "period", "rippleScale", "rippleNumber"], A2 = 0; A2 < S2.length; A2++) {
              var k2 = S2[A2];
              if (g5[k2] !== r5[k2]) {
                this.stopEffectAnimation(), this.startEffectAnimation(r5);
                return;
              }
            }
            uPe(b6, r5);
          }, s.prototype.highlight = function() {
            GI(this);
          }, s.prototype.downplay = function() {
            HI(this);
          }, s.prototype.getSymbolType = function() {
            var r5 = this.childAt(0);
            return r5 && r5.getSymbolType();
          }, s.prototype.updateData = function(r5, g5) {
            var b6 = this, S2 = r5.hostModel;
            this.childAt(0).updateData(r5, g5);
            var A2 = this.childAt(1), k2 = r5.getItemModel(g5), R6 = r5.getItemVisual(g5, "symbol"), B3 = vct(r5.getItemVisual(g5, "symbolSize")), G3 = r5.getItemVisual(g5, "style"), Z3 = G3 && G3.fill, X3 = k2.getModel("emphasis");
            A2.setScale(B3), A2.traverse(function(mt) {
              mt.setStyle("fill", Z3);
            });
            var tt = vX(r5.getItemVisual(g5, "symbolOffset"), B3);
            tt && (A2.x = tt[0], A2.y = tt[1]);
            var it = r5.getItemVisual(g5, "symbolRotate");
            A2.rotation = (it || 0) * Math.PI / 180 || 0;
            var pt = {};
            pt.showEffectOn = S2.get("showEffectOn"), pt.rippleScale = k2.get(["rippleEffect", "scale"]), pt.brushType = k2.get(["rippleEffect", "brushType"]), pt.period = k2.get(["rippleEffect", "period"]) * 1e3, pt.effectOffset = g5 / r5.count(), pt.z = S2.getShallow("z") || 0, pt.zlevel = S2.getShallow("zlevel") || 0, pt.symbolType = R6, pt.color = Z3, pt.rippleEffectColor = k2.get(["rippleEffect", "color"]), pt.rippleNumber = k2.get(["rippleEffect", "number"]), pt.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(pt) : this.startEffectAnimation(pt), this._effectCfg = pt) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(mt) {
              mt === "emphasis" ? pt.showEffectOn !== "render" && b6.startEffectAnimation(pt) : mt === "normal" && pt.showEffectOn !== "render" && b6.stopEffectAnimation();
            }), this._effectCfg = pt, f0(this, X3.get("focus"), X3.get("blurScope"), X3.get("disabled"));
          }, s.prototype.fadeOut = function(r5) {
            r5 && r5();
          }, s;
        }(nu), XHn = KHn, QHn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function() {
            this._symbolDraw = new Vct(XHn);
          }, s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this._symbolDraw;
            A2.updateData(S2, { clipShape: this._getClipShape(r5) }), this.group.add(A2.group);
          }, s.prototype._getClipShape = function(r5) {
            var g5 = r5.coordinateSystem, b6 = g5 && g5.getArea && g5.getArea();
            return r5.get("clip", true) ? b6 : null;
          }, s.prototype.updateTransform = function(r5, g5, b6) {
            var S2 = r5.getData();
            this.group.dirty();
            var A2 = Bct("").reset(r5, g5, b6);
            A2.progress && A2.progress({ start: 0, end: S2.count(), count: S2.count() }, S2), this._symbolDraw.updateLayout();
          }, s.prototype._updateGroupTransform = function(r5) {
            var g5 = r5.coordinateSystem;
            g5 && g5.getRoamTransform && (this.group.transform = hK(g5.getRoamTransform()), this.group.decomposeTransform());
          }, s.prototype.remove = function(r5, g5) {
            this._symbolDraw && this._symbolDraw.remove(true);
          }, s.type = "effectScatter", s;
        }(Ig2), JHn = QHn, tUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.hasSymbolVisual = true, r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            return SR(null, this, { useEncodeDefaulter: true });
          }, s.prototype.brushSelector = function(r5, g5, b6) {
            return b6.point(g5.getItemLayout(r5));
          }, s.type = "series.effectScatter", s.dependencies = ["grid", "polar"], s.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, s;
        }(zv), eUn = tUn;
        function nUn(c5) {
          c5.registerChartView(JHn), c5.registerSeriesModel(eUn), c5.registerLayout(Bct("effectScatter"));
        }
        var rUn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this) || this;
            return S2.add(S2.createLine(r5, g5, b6)), S2._updateEffectSymbol(r5, g5), S2;
          }
          return s.prototype.createLine = function(r5, g5, b6) {
            return new GHt(r5, g5, b6);
          }, s.prototype._updateEffectSymbol = function(r5, g5) {
            var b6 = r5.getItemModel(g5), S2 = b6.getModel("effect"), A2 = S2.get("symbolSize"), k2 = S2.get("symbol");
            ja2(A2) || (A2 = [A2, A2]);
            var R6 = r5.getItemVisual(g5, "style"), B3 = S2.get("color") || R6 && R6.stroke, G3 = this.childAt(1);
            this._symbolType !== k2 && (this.remove(G3), G3 = am(k2, -0.5, -0.5, 1, 1, B3), G3.z2 = 100, G3.culling = true, this.add(G3)), G3 && (G3.setStyle("shadowColor", B3), G3.setStyle(S2.getItemStyle(["color"])), G3.scaleX = A2[0], G3.scaleY = A2[1], G3.setColor(B3), this._symbolType = k2, this._symbolScale = A2, this._updateEffectAnimation(r5, S2, g5));
          }, s.prototype._updateEffectAnimation = function(r5, g5, b6) {
            var S2 = this.childAt(1);
            if (S2) {
              var A2 = r5.getItemLayout(b6), k2 = g5.get("period") * 1e3, R6 = g5.get("loop"), B3 = g5.get("constantSpeed"), G3 = Wm(g5.get("delay"), function(X3) {
                return X3 / r5.count() * k2 / 3;
              });
              if (S2.ignore = true, this._updateAnimationPoints(S2, A2), B3 > 0 && (k2 = this._getLineLength(S2) / B3 * 1e3), k2 !== this._period || R6 !== this._loop) {
                S2.stopAnimation();
                var Z3 = void 0;
                Tl(G3) ? Z3 = G3(b6) : Z3 = G3, S2.__t > 0 && (Z3 = -k2 * S2.__t), this._animateSymbol(S2, k2, Z3, R6);
              }
              this._period = k2, this._loop = R6;
            }
          }, s.prototype._animateSymbol = function(r5, g5, b6, S2) {
            if (g5 > 0) {
              r5.__t = 0;
              var A2 = this, k2 = r5.animate("", S2).when(g5, { __t: 1 }).delay(b6).during(function() {
                A2._updateSymbolPosition(r5);
              });
              S2 || k2.done(function() {
                A2.remove(r5);
              }), k2.start();
            }
          }, s.prototype._getLineLength = function(r5) {
            return LI(r5.__p1, r5.__cp1) + LI(r5.__cp1, r5.__p2);
          }, s.prototype._updateAnimationPoints = function(r5, g5) {
            r5.__p1 = g5[0], r5.__p2 = g5[1], r5.__cp1 = g5[2] || [(g5[0][0] + g5[1][0]) / 2, (g5[0][1] + g5[1][1]) / 2];
          }, s.prototype.updateData = function(r5, g5, b6) {
            this.childAt(0).updateData(r5, g5, b6), this._updateEffectSymbol(r5, g5);
          }, s.prototype._updateSymbolPosition = function(r5) {
            var g5 = r5.__p1, b6 = r5.__p2, S2 = r5.__cp1, A2 = r5.__t, k2 = [r5.x, r5.y], R6 = k2.slice(), B3 = Hm, G3 = ZY;
            k2[0] = B3(g5[0], S2[0], b6[0], A2), k2[1] = B3(g5[1], S2[1], b6[1], A2);
            var Z3 = G3(g5[0], S2[0], b6[0], A2), X3 = G3(g5[1], S2[1], b6[1], A2);
            r5.rotation = -Math.atan2(X3, Z3) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (r5.__lastT !== void 0 && r5.__lastT < r5.__t ? (r5.scaleY = LI(R6, k2) * 1.05, A2 === 1 && (k2[0] = R6[0] + (k2[0] - R6[0]) / 2, k2[1] = R6[1] + (k2[1] - R6[1]) / 2)) : r5.__lastT === 1 ? r5.scaleY = 2 * LI(g5, k2) : r5.scaleY = this._symbolScale[1]), r5.__lastT = r5.__t, r5.ignore = false, r5.x = k2[0], r5.y = k2[1];
          }, s.prototype.updateLayout = function(r5, g5) {
            this.childAt(0).updateLayout(r5, g5);
            var b6 = r5.getItemModel(g5).getModel("effect");
            this._updateEffectAnimation(r5, b6, g5);
          }, s;
        }(nu), cPe = rUn, iUn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6) {
            var S2 = c5.call(this) || this;
            return S2._createPolyline(r5, g5, b6), S2;
          }
          return s.prototype._createPolyline = function(r5, g5, b6) {
            var S2 = r5.getItemLayout(g5), A2 = new Gw({ shape: { points: S2 } });
            this.add(A2), this._updateCommonStl(r5, g5, b6);
          }, s.prototype.updateData = function(r5, g5, b6) {
            var S2 = r5.hostModel, A2 = this.childAt(0), k2 = { shape: { points: r5.getItemLayout(g5) } };
            Qf2(A2, k2, S2, g5), this._updateCommonStl(r5, g5, b6);
          }, s.prototype._updateCommonStl = function(r5, g5, b6) {
            var S2 = this.childAt(0), A2 = r5.getItemModel(g5), k2 = b6 && b6.emphasisLineStyle, R6 = b6 && b6.focus, B3 = b6 && b6.blurScope, G3 = b6 && b6.emphasisDisabled;
            if (!b6 || r5.hasItemOption) {
              var Z3 = A2.getModel("emphasis");
              k2 = Z3.getModel("lineStyle").getLineStyle(), G3 = Z3.get("disabled"), R6 = Z3.get("focus"), B3 = Z3.get("blurScope");
            }
            S2.useStyle(r5.getItemVisual(g5, "style")), S2.style.fill = null, S2.style.strokeNoScale = true;
            var X3 = S2.ensureState("emphasis");
            X3.style = k2, f0(this, R6, B3, G3);
          }, s.prototype.updateLayout = function(r5, g5) {
            var b6 = this.childAt(0);
            b6.setShape("points", r5.getItemLayout(g5));
          }, s;
        }(nu), fPe = iUn, aUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5._lastFrame = 0, r5._lastFramePercent = 0, r5;
          }
          return s.prototype.createLine = function(r5, g5, b6) {
            return new fPe(r5, g5, b6);
          }, s.prototype._updateAnimationPoints = function(r5, g5) {
            this._points = g5;
            for (var b6 = [0], S2 = 0, A2 = 1; A2 < g5.length; A2++) {
              var k2 = g5[A2 - 1], R6 = g5[A2];
              S2 += LI(k2, R6), b6.push(S2);
            }
            if (S2 === 0) {
              this._length = 0;
              return;
            }
            for (var A2 = 0; A2 < b6.length; A2++)
              b6[A2] /= S2;
            this._offsets = b6, this._length = S2;
          }, s.prototype._getLineLength = function() {
            return this._length;
          }, s.prototype._updateSymbolPosition = function(r5) {
            var g5 = r5.__t, b6 = this._points, S2 = this._offsets, A2 = b6.length;
            if (S2) {
              var k2 = this._lastFrame, R6;
              if (g5 < this._lastFramePercent) {
                var B3 = Math.min(k2 + 1, A2 - 1);
                for (R6 = B3; R6 >= 0 && !(S2[R6] <= g5); R6--)
                  ;
                R6 = Math.min(R6, A2 - 2);
              } else {
                for (R6 = k2; R6 < A2 && !(S2[R6] > g5); R6++)
                  ;
                R6 = Math.min(R6 - 1, A2 - 2);
              }
              var G3 = (g5 - S2[R6]) / (S2[R6 + 1] - S2[R6]), Z3 = b6[R6], X3 = b6[R6 + 1];
              r5.x = Z3[0] * (1 - G3) + G3 * X3[0], r5.y = Z3[1] * (1 - G3) + G3 * X3[1];
              var tt = X3[0] - Z3[0], it = X3[1] - Z3[1];
              r5.rotation = -Math.atan2(it, tt) - Math.PI / 2, this._lastFrame = R6, this._lastFramePercent = g5, r5.ignore = false;
            }
          }, s;
        }(cPe), oUn = aUn, sUn = function() {
          function c5() {
            this.polyline = false, this.curveness = 0, this.segs = [];
          }
          return c5;
        }(), lUn = function(c5) {
          wn(s, c5);
          function s(r5) {
            var g5 = c5.call(this, r5) || this;
            return g5._off = 0, g5.hoverDataIdx = -1, g5;
          }
          return s.prototype.reset = function() {
            this.notClear = false, this._off = 0;
          }, s.prototype.getDefaultStyle = function() {
            return { stroke: "#000", fill: null };
          }, s.prototype.getDefaultShape = function() {
            return new sUn();
          }, s.prototype.buildPath = function(r5, g5) {
            var b6 = g5.segs, S2 = g5.curveness, A2;
            if (g5.polyline)
              for (A2 = this._off; A2 < b6.length; ) {
                var k2 = b6[A2++];
                if (k2 > 0) {
                  r5.moveTo(b6[A2++], b6[A2++]);
                  for (var R6 = 1; R6 < k2; R6++)
                    r5.lineTo(b6[A2++], b6[A2++]);
                }
              }
            else
              for (A2 = this._off; A2 < b6.length; ) {
                var B3 = b6[A2++], G3 = b6[A2++], Z3 = b6[A2++], X3 = b6[A2++];
                if (r5.moveTo(B3, G3), S2 > 0) {
                  var tt = (B3 + Z3) / 2 - (G3 - X3) * S2, it = (G3 + X3) / 2 - (Z3 - B3) * S2;
                  r5.quadraticCurveTo(tt, it, Z3, X3);
                } else
                  r5.lineTo(Z3, X3);
              }
            this.incremental && (this._off = A2, this.notClear = true);
          }, s.prototype.findDataIndex = function(r5, g5) {
            var b6 = this.shape, S2 = b6.segs, A2 = b6.curveness, k2 = this.style.lineWidth;
            if (b6.polyline)
              for (var R6 = 0, B3 = 0; B3 < S2.length; ) {
                var G3 = S2[B3++];
                if (G3 > 0)
                  for (var Z3 = S2[B3++], X3 = S2[B3++], tt = 1; tt < G3; tt++) {
                    var it = S2[B3++], pt = S2[B3++];
                    if (_3(Z3, X3, it, pt, k2, r5, g5))
                      return R6;
                  }
                R6++;
              }
            else
              for (var R6 = 0, B3 = 0; B3 < S2.length; ) {
                var Z3 = S2[B3++], X3 = S2[B3++], it = S2[B3++], pt = S2[B3++];
                if (A2 > 0) {
                  var mt = (Z3 + it) / 2 - (X3 - pt) * A2, Mt = (X3 + pt) / 2 - (it - Z3) * A2;
                  if (ZSt(Z3, X3, mt, Mt, it, pt, k2, r5, g5))
                    return R6;
                } else if (_3(Z3, X3, it, pt, k2, r5, g5))
                  return R6;
                R6++;
              }
            return -1;
          }, s.prototype.contain = function(r5, g5) {
            var b6 = this.transformCoordToLocal(r5, g5), S2 = this.getBoundingRect();
            if (r5 = b6[0], g5 = b6[1], S2.contain(r5, g5)) {
              var A2 = this.hoverDataIdx = this.findDataIndex(r5, g5);
              return A2 >= 0;
            }
            return this.hoverDataIdx = -1, false;
          }, s.prototype.getBoundingRect = function() {
            var r5 = this._rect;
            if (!r5) {
              for (var g5 = this.shape, b6 = g5.segs, S2 = 1 / 0, A2 = 1 / 0, k2 = -1 / 0, R6 = -1 / 0, B3 = 0; B3 < b6.length; ) {
                var G3 = b6[B3++], Z3 = b6[B3++];
                S2 = Math.min(G3, S2), k2 = Math.max(G3, k2), A2 = Math.min(Z3, A2), R6 = Math.max(Z3, R6);
              }
              r5 = this._rect = new lc2(S2, A2, k2, R6);
            }
            return r5;
          }, s;
        }(Tc2), uUn = function() {
          function c5() {
            this.group = new nu();
          }
          return c5.prototype.updateData = function(s) {
            this._clear();
            var r5 = this._create();
            r5.setShape({ segs: s.getLayout("linesPoints") }), this._setCommon(r5, s);
          }, c5.prototype.incrementalPrepareUpdate = function(s) {
            this.group.removeAll(), this._clear();
          }, c5.prototype.incrementalUpdate = function(s, r5) {
            var g5 = this._newAdded[0], b6 = r5.getLayout("linesPoints"), S2 = g5 && g5.shape.segs;
            if (S2 && S2.length < 2e4) {
              var A2 = S2.length, k2 = new Float32Array(A2 + b6.length);
              k2.set(S2), k2.set(b6, A2), g5.setShape({ segs: k2 });
            } else {
              this._newAdded = [];
              var R6 = this._create();
              R6.incremental = true, R6.setShape({ segs: b6 }), this._setCommon(R6, r5), R6.__startIndex = s.start;
            }
          }, c5.prototype.remove = function() {
            this._clear();
          }, c5.prototype.eachRendered = function(s) {
            this._newAdded[0] && s(this._newAdded[0]);
          }, c5.prototype._create = function() {
            var s = new lUn({ cursor: "default" });
            return this._newAdded.push(s), this.group.add(s), s;
          }, c5.prototype._setCommon = function(s, r5, g5) {
            var b6 = r5.hostModel;
            s.setShape({ polyline: b6.get("polyline"), curveness: b6.get(["lineStyle", "curveness"]) }), s.useStyle(b6.getModel("lineStyle").getLineStyle()), s.style.strokeNoScale = true;
            var S2 = r5.getVisual("style");
            S2 && S2.stroke && s.setStyle("stroke", S2.stroke), s.setStyle("fill", null);
            var A2 = Pl(s);
            A2.seriesIndex = b6.seriesIndex, s.on("mousemove", function(k2) {
              A2.dataIndex = null;
              var R6 = s.hoverDataIdx;
              R6 > 0 && (A2.dataIndex = R6 + s.__startIndex);
            });
          }, c5.prototype._clear = function() {
            this._newAdded = [], this.group.removeAll();
          }, c5;
        }(), cUn = uUn, fUn = { seriesType: "lines", plan: hX(), reset: function(c5) {
          var s = c5.coordinateSystem;
          if (s) {
            var r5 = c5.get("polyline"), g5 = c5.pipelineContext.large;
            return { progress: function(b6, S2) {
              var A2 = [];
              if (g5) {
                var k2 = void 0, R6 = b6.end - b6.start;
                if (r5) {
                  for (var B3 = 0, G3 = b6.start; G3 < b6.end; G3++)
                    B3 += c5.getLineCoordsCount(G3);
                  k2 = new Float32Array(R6 + B3 * 2);
                } else
                  k2 = new Float32Array(R6 * 4);
                for (var Z3 = 0, X3 = [], G3 = b6.start; G3 < b6.end; G3++) {
                  var tt = c5.getLineCoords(G3, A2);
                  r5 && (k2[Z3++] = tt);
                  for (var it = 0; it < tt; it++)
                    X3 = s.dataToPoint(A2[it], false, X3), k2[Z3++] = X3[0], k2[Z3++] = X3[1];
                }
                S2.setLayout("linesPoints", k2);
              } else
                for (var G3 = b6.start; G3 < b6.end; G3++) {
                  var pt = S2.getItemModel(G3), tt = c5.getLineCoords(G3, A2), mt = [];
                  if (r5)
                    for (var Mt = 0; Mt < tt; Mt++)
                      mt.push(s.dataToPoint(A2[Mt]));
                  else {
                    mt[0] = s.dataToPoint(A2[0]), mt[1] = s.dataToPoint(A2[1]);
                    var kt = pt.get(["lineStyle", "curveness"]);
                    +kt && (mt[2] = [(mt[0][0] + mt[1][0]) / 2 - (mt[0][1] - mt[1][1]) * kt, (mt[0][1] + mt[1][1]) / 2 - (mt[1][0] - mt[0][0]) * kt]);
                  }
                  S2.setItemLayout(G3, mt);
                }
            } };
          }
        } }, hPe = fUn, hUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this._updateLineDraw(S2, r5), k2 = r5.get("zlevel"), R6 = r5.get(["effect", "trailLength"]), B3 = b6.getZr(), G3 = B3.painter.getType() === "svg";
            G3 || B3.painter.getLayer(k2).clear(true), this._lastZlevel != null && !G3 && B3.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(r5) && R6 > 0 && (G3 || B3.configLayer(k2, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(R6 / 10 + 0.9, 1), 0) })), A2.updateData(S2);
            var Z3 = r5.get("clip", true) && WMt(r5.coordinateSystem, false, r5);
            Z3 ? this.group.setClipPath(Z3) : this.group.removeClipPath(), this._lastZlevel = k2, this._finished = true;
          }, s.prototype.incrementalPrepareRender = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this._updateLineDraw(S2, r5);
            A2.incrementalPrepareUpdate(S2), this._clearLayer(b6), this._finished = false;
          }, s.prototype.incrementalRender = function(r5, g5, b6) {
            this._lineDraw.incrementalUpdate(r5, g5.getData()), this._finished = r5.end === g5.getData().count();
          }, s.prototype.eachRendered = function(r5) {
            this._lineDraw && this._lineDraw.eachRendered(r5);
          }, s.prototype.updateTransform = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = r5.pipelineContext;
            if (!this._finished || A2.large || A2.progressiveRender)
              return { update: true };
            var k2 = hPe.reset(r5, g5, b6);
            k2.progress && k2.progress({ start: 0, end: S2.count(), count: S2.count() }, S2), this._lineDraw.updateLayout(), this._clearLayer(b6);
          }, s.prototype._updateLineDraw = function(r5, g5) {
            var b6 = this._lineDraw, S2 = this._showEffect(g5), A2 = !!g5.get("polyline"), k2 = g5.pipelineContext, R6 = k2.large;
            return (!b6 || S2 !== this._hasEffet || A2 !== this._isPolyline || R6 !== this._isLargeDraw) && (b6 && b6.remove(), b6 = this._lineDraw = R6 ? new cUn() : new UHt(A2 ? S2 ? oUn : fPe : S2 ? cPe : GHt), this._hasEffet = S2, this._isPolyline = A2, this._isLargeDraw = R6), this.group.add(b6.group), b6;
          }, s.prototype._showEffect = function(r5) {
            return !!r5.get(["effect", "show"]);
          }, s.prototype._clearLayer = function(r5) {
            var g5 = r5.getZr(), b6 = g5.painter.getType() === "svg";
            !b6 && this._lastZlevel != null && g5.painter.getLayer(this._lastZlevel).clear(true);
          }, s.prototype.remove = function(r5, g5) {
            this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(g5);
          }, s.prototype.dispose = function(r5, g5) {
            this.remove(r5, g5);
          }, s.type = "lines", s;
        }(Ig2), pUn = hUn, dUn = typeof Uint32Array == "undefined" ? Array : Uint32Array, gUn = typeof Float64Array == "undefined" ? Array : Float64Array;
        function pPe(c5) {
          var s = c5.data;
          s && s[0] && s[0][0] && s[0][0].coord && (c5.data = Ha2(s, function(r5) {
            var g5 = [r5[0].coord, r5[1].coord], b6 = { coords: g5 };
            return r5[0].name && (b6.fromName = r5[0].name), r5[1].name && (b6.toName = r5[1].name), B4([b6, r5[0], r5[1]]);
          }));
        }
        var vUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.visualStyleAccessPath = "lineStyle", r5.visualDrawType = "stroke", r5;
          }
          return s.prototype.init = function(r5) {
            r5.data = r5.data || [], pPe(r5);
            var g5 = this._processFlatCoordsArray(r5.data);
            this._flatCoords = g5.flatCoords, this._flatCoordsOffset = g5.flatCoordsOffset, g5.flatCoords && (r5.data = new Float32Array(g5.count)), c5.prototype.init.apply(this, arguments);
          }, s.prototype.mergeOption = function(r5) {
            if (pPe(r5), r5.data) {
              var g5 = this._processFlatCoordsArray(r5.data);
              this._flatCoords = g5.flatCoords, this._flatCoordsOffset = g5.flatCoordsOffset, g5.flatCoords && (r5.data = new Float32Array(g5.count));
            }
            c5.prototype.mergeOption.apply(this, arguments);
          }, s.prototype.appendData = function(r5) {
            var g5 = this._processFlatCoordsArray(r5.data);
            g5.flatCoords && (this._flatCoords ? (this._flatCoords = zY(this._flatCoords, g5.flatCoords), this._flatCoordsOffset = zY(this._flatCoordsOffset, g5.flatCoordsOffset)) : (this._flatCoords = g5.flatCoords, this._flatCoordsOffset = g5.flatCoordsOffset), r5.data = new Float32Array(g5.count)), this.getRawData().appendData(r5.data);
          }, s.prototype._getCoordsFromItemModel = function(r5) {
            var g5 = this.getData().getItemModel(r5), b6 = g5.option instanceof Array ? g5.option : g5.getShallow("coords");
            return b6;
          }, s.prototype.getLineCoordsCount = function(r5) {
            return this._flatCoordsOffset ? this._flatCoordsOffset[r5 * 2 + 1] : this._getCoordsFromItemModel(r5).length;
          }, s.prototype.getLineCoords = function(r5, g5) {
            if (this._flatCoordsOffset) {
              for (var b6 = this._flatCoordsOffset[r5 * 2], S2 = this._flatCoordsOffset[r5 * 2 + 1], A2 = 0; A2 < S2; A2++)
                g5[A2] = g5[A2] || [], g5[A2][0] = this._flatCoords[b6 + A2 * 2], g5[A2][1] = this._flatCoords[b6 + A2 * 2 + 1];
              return S2;
            } else {
              for (var k2 = this._getCoordsFromItemModel(r5), A2 = 0; A2 < k2.length; A2++)
                g5[A2] = g5[A2] || [], g5[A2][0] = k2[A2][0], g5[A2][1] = k2[A2][1];
              return k2.length;
            }
          }, s.prototype._processFlatCoordsArray = function(r5) {
            var g5 = 0;
            if (this._flatCoords && (g5 = this._flatCoords.length), Oh2(r5[0])) {
              for (var b6 = r5.length, S2 = new dUn(b6), A2 = new gUn(b6), k2 = 0, R6 = 0, B3 = 0, G3 = 0; G3 < b6; ) {
                B3++;
                var Z3 = r5[G3++];
                S2[R6++] = k2 + g5, S2[R6++] = Z3;
                for (var X3 = 0; X3 < Z3; X3++) {
                  var tt = r5[G3++], it = r5[G3++];
                  A2[k2++] = tt, A2[k2++] = it;
                }
              }
              return { flatCoordsOffset: new Uint32Array(S2.buffer, 0, R6), flatCoords: A2, count: B3 };
            }
            return { flatCoordsOffset: null, flatCoords: null, count: r5.length };
          }, s.prototype.getInitialData = function(r5, g5) {
            var b6 = new m22(["value"], this);
            return b6.hasItemOption = false, b6.initData(r5.data, [], function(S2, A2, k2, R6) {
              if (S2 instanceof Array)
                return NaN;
              b6.hasItemOption = true;
              var B3 = S2.value;
              if (B3 != null)
                return B3 instanceof Array ? B3[R6] : B3;
            }), b6;
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            var S2 = this.getData(), A2 = S2.getItemModel(r5), k2 = A2.get("name");
            if (k2)
              return k2;
            var R6 = A2.get("fromName"), B3 = A2.get("toName"), G3 = [];
            return R6 != null && G3.push(R6), B3 != null && G3.push(B3), W1("nameValue", { name: G3.join(" > ") });
          }, s.prototype.preventIncremental = function() {
            return !!this.get(["effect", "show"]);
          }, s.prototype.getProgressive = function() {
            var r5 = this.option.progressive;
            return r5 == null ? this.option.large ? 1e4 : this.get("progressive") : r5;
          }, s.prototype.getProgressiveThreshold = function() {
            var r5 = this.option.progressiveThreshold;
            return r5 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : r5;
          }, s.prototype.getZLevelKey = function() {
            var r5 = this.getModel("effect"), g5 = r5.get("trailLength");
            return this.getData().count() > this.getProgressiveThreshold() ? this.id : r5.get("show") && g5 > 0 ? g5 + "" : "";
          }, s.type = "series.lines", s.dependencies = ["grid", "polar", "geo", "calendar"], s.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, s;
        }(zv), yUn = vUn;
        function dCt(c5) {
          return c5 instanceof Array || (c5 = [c5, c5]), c5;
        }
        var mUn = { seriesType: "lines", reset: function(c5) {
          var s = dCt(c5.get("symbol")), r5 = dCt(c5.get("symbolSize")), g5 = c5.getData();
          g5.setVisual("fromSymbol", s && s[0]), g5.setVisual("toSymbol", s && s[1]), g5.setVisual("fromSymbolSize", r5 && r5[0]), g5.setVisual("toSymbolSize", r5 && r5[1]);
          function b6(S2, A2) {
            var k2 = S2.getItemModel(A2), R6 = dCt(k2.getShallow("symbol", true)), B3 = dCt(k2.getShallow("symbolSize", true));
            R6[0] && S2.setItemVisual(A2, "fromSymbol", R6[0]), R6[1] && S2.setItemVisual(A2, "toSymbol", R6[1]), B3[0] && S2.setItemVisual(A2, "fromSymbolSize", B3[0]), B3[1] && S2.setItemVisual(A2, "toSymbolSize", B3[1]);
          }
          return { dataEach: g5.hasItemOption ? b6 : null };
        } }, bUn = mUn;
        function _Un(c5) {
          c5.registerChartView(pUn), c5.registerSeriesModel(yUn), c5.registerLayout(hPe), c5.registerVisual(bUn);
        }
        var xUn = 256, wUn = function() {
          function c5() {
            this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
            var s = T0.createCanvas();
            this.canvas = s;
          }
          return c5.prototype.update = function(s, r5, g5, b6, S2, A2) {
            var k2 = this._getBrush(), R6 = this._getGradient(S2, "inRange"), B3 = this._getGradient(S2, "outOfRange"), G3 = this.pointSize + this.blurSize, Z3 = this.canvas, X3 = Z3.getContext("2d"), tt = s.length;
            Z3.width = r5, Z3.height = g5;
            for (var it = 0; it < tt; ++it) {
              var pt = s[it], mt = pt[0], Mt = pt[1], kt = pt[2], Gt = b6(kt);
              X3.globalAlpha = Gt, X3.drawImage(k2, mt - G3, Mt - G3);
            }
            if (!Z3.width || !Z3.height)
              return Z3;
            for (var Ot = X3.getImageData(0, 0, Z3.width, Z3.height), ce2 = Ot.data, ae2 = 0, de2 = ce2.length, we2 = this.minOpacity, Se2 = this.maxOpacity, Oe2 = Se2 - we2; ae2 < de2; ) {
              var Gt = ce2[ae2 + 3] / 256, je2 = Math.floor(Gt * (xUn - 1)) * 4;
              if (Gt > 0) {
                var rn = A2(Gt) ? R6 : B3;
                Gt > 0 && (Gt = Gt * Oe2 + we2), ce2[ae2++] = rn[je2], ce2[ae2++] = rn[je2 + 1], ce2[ae2++] = rn[je2 + 2], ce2[ae2++] = rn[je2 + 3] * Gt * 256;
              } else
                ae2 += 4;
            }
            return X3.putImageData(Ot, 0, 0), Z3;
          }, c5.prototype._getBrush = function() {
            var s = this._brushCanvas || (this._brushCanvas = T0.createCanvas()), r5 = this.pointSize + this.blurSize, g5 = r5 * 2;
            s.width = g5, s.height = g5;
            var b6 = s.getContext("2d");
            return b6.clearRect(0, 0, g5, g5), b6.shadowOffsetX = g5, b6.shadowBlur = this.blurSize, b6.shadowColor = "#000", b6.beginPath(), b6.arc(-r5, r5, this.pointSize, 0, Math.PI * 2, true), b6.closePath(), b6.fill(), s;
          }, c5.prototype._getGradient = function(s, r5) {
            for (var g5 = this._gradientPixels, b6 = g5[r5] || (g5[r5] = new Uint8ClampedArray(256 * 4)), S2 = [0, 0, 0, 0], A2 = 0, k2 = 0; k2 < 256; k2++)
              s[r5](k2 / 255, true, S2), b6[A2++] = S2[0], b6[A2++] = S2[1], b6[A2++] = S2[2], b6[A2++] = S2[3];
            return b6;
          }, c5;
        }(), SUn = wUn;
        function MUn(c5, s, r5) {
          var g5 = c5[1] - c5[0];
          s = Ha2(s, function(A2) {
            return { interval: [(A2.interval[0] - c5[0]) / g5, (A2.interval[1] - c5[0]) / g5] };
          });
          var b6 = s.length, S2 = 0;
          return function(A2) {
            var k2;
            for (k2 = S2; k2 < b6; k2++) {
              var R6 = s[k2].interval;
              if (R6[0] <= A2 && A2 <= R6[1]) {
                S2 = k2;
                break;
              }
            }
            if (k2 === b6)
              for (k2 = S2 - 1; k2 >= 0; k2--) {
                var R6 = s[k2].interval;
                if (R6[0] <= A2 && A2 <= R6[1]) {
                  S2 = k2;
                  break;
                }
              }
            return k2 >= 0 && k2 < b6 && r5[k2];
          };
        }
        function CUn(c5, s) {
          var r5 = c5[1] - c5[0];
          return s = [(s[0] - c5[0]) / r5, (s[1] - c5[0]) / r5], function(g5) {
            return g5 >= s[0] && g5 <= s[1];
          };
        }
        function dPe(c5) {
          var s = c5.dimensions;
          return s[0] === "lng" && s[1] === "lat";
        }
        var TUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2;
            g5.eachComponent("visualMap", function(k2) {
              k2.eachTargetSeries(function(R6) {
                R6 === r5 && (S2 = k2);
              });
            }), this._progressiveEls = null, this.group.removeAll();
            var A2 = r5.coordinateSystem;
            A2.type === "cartesian2d" || A2.type === "calendar" ? this._renderOnCartesianAndCalendar(r5, b6, 0, r5.getData().count()) : dPe(A2) && this._renderOnGeo(A2, r5, S2, b6);
          }, s.prototype.incrementalPrepareRender = function(r5, g5, b6) {
            this.group.removeAll();
          }, s.prototype.incrementalRender = function(r5, g5, b6, S2) {
            var A2 = g5.coordinateSystem;
            A2 && (dPe(A2) ? this.render(g5, b6, S2) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(g5, S2, r5.start, r5.end, true)));
          }, s.prototype.eachRendered = function(r5) {
            Ik(this._progressiveEls || this.group, r5);
          }, s.prototype._renderOnCartesianAndCalendar = function(r5, g5, b6, S2, A2) {
            var k2 = r5.coordinateSystem, R6, B3, G3, Z3;
            if (CR(k2, "cartesian2d")) {
              var X3 = k2.getAxis("x"), tt = k2.getAxis("y");
              R6 = X3.getBandWidth(), B3 = tt.getBandWidth(), G3 = X3.scale.getExtent(), Z3 = tt.scale.getExtent();
            }
            for (var it = this.group, pt = r5.getData(), mt = r5.getModel(["emphasis", "itemStyle"]).getItemStyle(), Mt = r5.getModel(["blur", "itemStyle"]).getItemStyle(), kt = r5.getModel(["select", "itemStyle"]).getItemStyle(), Gt = r5.get(["itemStyle", "borderRadius"]), Ot = qb2(r5), ce2 = r5.getModel("emphasis"), ae2 = ce2.get("focus"), de2 = ce2.get("blurScope"), we2 = ce2.get("disabled"), Se2 = CR(k2, "cartesian2d") ? [pt.mapDimension("x"), pt.mapDimension("y"), pt.mapDimension("value")] : [pt.mapDimension("time"), pt.mapDimension("value")], Oe2 = b6; Oe2 < S2; Oe2++) {
              var je2 = void 0, rn = pt.getItemVisual(Oe2, "style");
              if (CR(k2, "cartesian2d")) {
                var qe2 = pt.get(Se2[0], Oe2), An = pt.get(Se2[1], Oe2);
                if (isNaN(pt.get(Se2[2], Oe2)) || qe2 < G3[0] || qe2 > G3[1] || An < Z3[0] || An > Z3[1])
                  continue;
                var jn = k2.dataToPoint([qe2, An]);
                je2 = new zf2({ shape: { x: Math.floor(Math.round(jn[0]) - R6 / 2), y: Math.floor(Math.round(jn[1]) - B3 / 2), width: Math.ceil(R6), height: Math.ceil(B3) }, style: rn });
              } else {
                if (isNaN(pt.get(Se2[1], Oe2)))
                  continue;
                je2 = new zf2({ z2: 1, shape: k2.dataToRect([pt.get(Se2[0], Oe2)]).contentShape, style: rn });
              }
              if (pt.hasItemOption) {
                var _n = pt.getItemModel(Oe2), Jr = _n.getModel("emphasis");
                mt = Jr.getModel("itemStyle").getItemStyle(), Mt = _n.getModel(["blur", "itemStyle"]).getItemStyle(), kt = _n.getModel(["select", "itemStyle"]).getItemStyle(), Gt = _n.get(["itemStyle", "borderRadius"]), ae2 = Jr.get("focus"), de2 = Jr.get("blurScope"), we2 = Jr.get("disabled"), Ot = qb2(_n);
              }
              je2.shape.r = Gt;
              var Qn = r5.getRawValue(Oe2), rr = "-";
              Qn && Qn[2] != null && (rr = Qn[2] + ""), Uw(je2, Ot, { labelFetcher: r5, labelDataIndex: Oe2, defaultOpacity: rn.opacity, defaultText: rr }), je2.ensureState("emphasis").style = mt, je2.ensureState("blur").style = Mt, je2.ensureState("select").style = kt, f0(je2, ae2, de2, we2), je2.incremental = A2, A2 && (je2.states.emphasis.hoverLayer = true), it.add(je2), pt.setItemGraphicEl(Oe2, je2), this._progressiveEls && this._progressiveEls.push(je2);
            }
          }, s.prototype._renderOnGeo = function(r5, g5, b6, S2) {
            var A2 = b6.targetVisuals.inRange, k2 = b6.targetVisuals.outOfRange, R6 = g5.getData(), B3 = this._hmLayer || this._hmLayer || new SUn();
            B3.blurSize = g5.get("blurSize"), B3.pointSize = g5.get("pointSize"), B3.minOpacity = g5.get("minOpacity"), B3.maxOpacity = g5.get("maxOpacity");
            var G3 = r5.getViewRect().clone(), Z3 = r5.getRoamTransform();
            G3.applyTransform(Z3);
            var X3 = Math.max(G3.x, 0), tt = Math.max(G3.y, 0), it = Math.min(G3.width + G3.x, S2.getWidth()), pt = Math.min(G3.height + G3.y, S2.getHeight()), mt = it - X3, Mt = pt - tt, kt = [R6.mapDimension("lng"), R6.mapDimension("lat"), R6.mapDimension("value")], Gt = R6.mapArray(kt, function(de2, we2, Se2) {
              var Oe2 = r5.dataToPoint([de2, we2]);
              return Oe2[0] -= X3, Oe2[1] -= tt, Oe2.push(Se2), Oe2;
            }), Ot = b6.getExtent(), ce2 = b6.type === "visualMap.continuous" ? CUn(Ot, b6.option.range) : MUn(Ot, b6.getPieceList(), b6.option.selected);
            B3.update(Gt, mt, Mt, A2.color.getNormalizer(), { inRange: A2.color.getColorMapper(), outOfRange: k2.color.getColorMapper() }, ce2);
            var ae2 = new qm({ style: { width: mt, height: Mt, x: X3, y: tt, image: B3.canvas }, silent: true });
            this.group.add(ae2);
          }, s.type = "heatmap", s;
        }(Ig2), AUn = TUn, IUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            return SR(null, this, { generateCoord: "value" });
          }, s.prototype.preventIncremental = function() {
            var r5 = oct.get(this.get("coordinateSystem"));
            if (r5 && r5.dimensions)
              return r5.dimensions[0] === "lng" && r5.dimensions[1] === "lat";
          }, s.type = "series.heatmap", s.dependencies = ["grid", "geo", "calendar"], s.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, s;
        }(zv), DUn = IUn;
        function EUn(c5) {
          c5.registerChartView(AUn), c5.registerSeriesModel(DUn);
        }
        var kUn = ["itemStyle", "borderWidth"], gPe = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], yUt = new qI(), PUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = this.group, A2 = r5.getData(), k2 = this._data, R6 = r5.coordinateSystem, B3 = R6.getBaseAxis(), G3 = B3.isHorizontal(), Z3 = R6.master.getRect(), X3 = { ecSize: { width: b6.getWidth(), height: b6.getHeight() }, seriesModel: r5, coordSys: R6, coordSysExtent: [[Z3.x, Z3.x + Z3.width], [Z3.y, Z3.y + Z3.height]], isHorizontal: G3, valueDim: gPe[+G3], categoryDim: gPe[1 - +G3] };
            return A2.diff(k2).add(function(tt) {
              if (A2.hasValue(tt)) {
                var it = wPe(A2, tt), pt = vPe(A2, tt, it, X3), mt = SPe(A2, X3, pt);
                A2.setItemGraphicEl(tt, mt), S2.add(mt), TPe(mt, X3, pt);
              }
            }).update(function(tt, it) {
              var pt = k2.getItemGraphicEl(it);
              if (!A2.hasValue(tt)) {
                S2.remove(pt);
                return;
              }
              var mt = wPe(A2, tt), Mt = vPe(A2, tt, mt, X3), kt = CPe(A2, Mt);
              pt && kt !== pt.__pictorialShapeStr && (S2.remove(pt), A2.setItemGraphicEl(tt, null), pt = null), pt ? BUn(pt, X3, Mt) : pt = SPe(A2, X3, Mt, true), A2.setItemGraphicEl(tt, pt), pt.__pictorialSymbolMeta = Mt, S2.add(pt), TPe(pt, X3, Mt);
            }).remove(function(tt) {
              var it = k2.getItemGraphicEl(tt);
              it && MPe(k2, tt, it.__pictorialSymbolMeta.animationModel, it);
            }).execute(), this._data = A2, this.group;
          }, s.prototype.remove = function(r5, g5) {
            var b6 = this.group, S2 = this._data;
            r5.get("animation") ? S2 && S2.eachItemGraphicEl(function(A2) {
              MPe(S2, Pl(A2).dataIndex, r5, A2);
            }) : b6.removeAll();
          }, s.type = "pictorialBar", s;
        }(Ig2);
        function vPe(c5, s, r5, g5) {
          var b6 = c5.getItemLayout(s), S2 = r5.get("symbolRepeat"), A2 = r5.get("symbolClip"), k2 = r5.get("symbolPosition") || "start", R6 = r5.get("symbolRotate"), B3 = (R6 || 0) * Math.PI / 180 || 0, G3 = r5.get("symbolPatternSize") || 2, Z3 = r5.isAnimationEnabled(), X3 = { dataIndex: s, layout: b6, itemModel: r5, symbolType: c5.getItemVisual(s, "symbol") || "circle", style: c5.getItemVisual(s, "style"), symbolClip: A2, symbolRepeat: S2, symbolRepeatDirection: r5.get("symbolRepeatDirection"), symbolPatternSize: G3, rotation: B3, animationModel: Z3 ? r5 : null, hoverScale: Z3 && r5.get(["emphasis", "scale"]), z2: r5.getShallow("z", true) || 0 };
          LUn(r5, S2, b6, g5, X3), OUn(c5, s, b6, S2, A2, X3.boundingLength, X3.pxSign, G3, g5, X3), RUn(r5, X3.symbolScale, B3, g5, X3);
          var tt = X3.symbolSize, it = vX(r5.get("symbolOffset"), tt);
          return NUn(r5, tt, b6, S2, A2, it, k2, X3.valueLineWidth, X3.boundingLength, X3.repeatCutLength, g5, X3), X3;
        }
        function LUn(c5, s, r5, g5, b6) {
          var S2 = g5.valueDim, A2 = c5.get("symbolBoundingData"), k2 = g5.coordSys.getOtherAxis(g5.coordSys.getBaseAxis()), R6 = k2.toGlobalCoord(k2.dataToCoord(0)), B3 = 1 - +(r5[S2.wh] <= 0), G3;
          if (ja2(A2)) {
            var Z3 = [mUt(k2, A2[0]) - R6, mUt(k2, A2[1]) - R6];
            Z3[1] < Z3[0] && Z3.reverse(), G3 = Z3[B3];
          } else
            A2 != null ? G3 = mUt(k2, A2) - R6 : s ? G3 = g5.coordSysExtent[S2.index][B3] - R6 : G3 = r5[S2.wh];
          b6.boundingLength = G3, s && (b6.repeatCutLength = r5[S2.wh]), b6.pxSign = G3 > 0 ? 1 : -1;
        }
        function mUt(c5, s) {
          return c5.toGlobalCoord(c5.dataToCoord(c5.scale.parse(s)));
        }
        function OUn(c5, s, r5, g5, b6, S2, A2, k2, R6, B3) {
          var G3 = R6.valueDim, Z3 = R6.categoryDim, X3 = Math.abs(r5[Z3.wh]), tt = c5.getItemVisual(s, "symbolSize"), it;
          ja2(tt) ? it = tt.slice() : tt == null ? it = ["100%", "100%"] : it = [tt, tt], it[Z3.index] = $o(it[Z3.index], X3), it[G3.index] = $o(it[G3.index], g5 ? X3 : Math.abs(S2)), B3.symbolSize = it;
          var pt = B3.symbolScale = [it[0] / k2, it[1] / k2];
          pt[G3.index] *= (R6.isHorizontal ? -1 : 1) * A2;
        }
        function RUn(c5, s, r5, g5, b6) {
          var S2 = c5.get(kUn) || 0;
          S2 && (yUt.attr({ scaleX: s[0], scaleY: s[1], rotation: r5 }), yUt.updateTransform(), S2 /= yUt.getLineScale(), S2 *= s[g5.valueDim.index]), b6.valueLineWidth = S2 || 0;
        }
        function NUn(c5, s, r5, g5, b6, S2, A2, k2, R6, B3, G3, Z3) {
          var X3 = G3.categoryDim, tt = G3.valueDim, it = Z3.pxSign, pt = Math.max(s[tt.index] + k2, 0), mt = pt;
          if (g5) {
            var Mt = Math.abs(R6), kt = Wm(c5.get("symbolMargin"), "15%") + "", Gt = false;
            kt.lastIndexOf("!") === kt.length - 1 && (Gt = true, kt = kt.slice(0, kt.length - 1));
            var Ot = $o(kt, s[tt.index]), ce2 = Math.max(pt + Ot * 2, 0), ae2 = Gt ? 0 : Ot * 2, de2 = OSt(g5), we2 = de2 ? g5 : APe((Mt + ae2) / ce2), Se2 = Mt - we2 * pt;
            Ot = Se2 / 2 / (Gt ? we2 : Math.max(we2 - 1, 1)), ce2 = pt + Ot * 2, ae2 = Gt ? 0 : Ot * 2, !de2 && g5 !== "fixed" && (we2 = B3 ? APe((Math.abs(B3) + ae2) / ce2) : 0), mt = we2 * ce2 - ae2, Z3.repeatTimes = we2, Z3.symbolMargin = Ot;
          }
          var Oe2 = it * (mt / 2), je2 = Z3.pathPosition = [];
          je2[X3.index] = r5[X3.wh] / 2, je2[tt.index] = A2 === "start" ? Oe2 : A2 === "end" ? R6 - Oe2 : R6 / 2, S2 && (je2[0] += S2[0], je2[1] += S2[1]);
          var rn = Z3.bundlePosition = [];
          rn[X3.index] = r5[X3.xy], rn[tt.index] = r5[tt.xy];
          var qe2 = Z3.barRectShape = sa2({}, r5);
          qe2[tt.wh] = it * Math.max(Math.abs(r5[tt.wh]), Math.abs(je2[tt.index] + Oe2)), qe2[X3.wh] = r5[X3.wh];
          var An = Z3.clipShape = {};
          An[X3.xy] = -r5[X3.xy], An[X3.wh] = G3.ecSize[X3.wh], An[tt.xy] = 0, An[tt.wh] = r5[tt.wh];
        }
        function yPe(c5) {
          var s = c5.symbolPatternSize, r5 = am(c5.symbolType, -s / 2, -s / 2, s, s);
          return r5.attr({ culling: true }), r5.type !== "image" && r5.setStyle({ strokeNoScale: true }), r5;
        }
        function mPe(c5, s, r5, g5) {
          var b6 = c5.__pictorialBundle, S2 = r5.symbolSize, A2 = r5.valueLineWidth, k2 = r5.pathPosition, R6 = s.valueDim, B3 = r5.repeatTimes || 0, G3 = 0, Z3 = S2[s.valueDim.index] + A2 + r5.symbolMargin * 2;
          for (bUt(c5, function(pt) {
            pt.__pictorialAnimationIndex = G3, pt.__pictorialRepeatTimes = B3, G3 < B3 ? PX2(pt, null, it(G3), r5, g5) : PX2(pt, null, { scaleX: 0, scaleY: 0 }, r5, g5, function() {
              b6.remove(pt);
            }), G3++;
          }); G3 < B3; G3++) {
            var X3 = yPe(r5);
            X3.__pictorialAnimationIndex = G3, X3.__pictorialRepeatTimes = B3, b6.add(X3);
            var tt = it(G3);
            PX2(X3, { x: tt.x, y: tt.y, scaleX: 0, scaleY: 0 }, { scaleX: tt.scaleX, scaleY: tt.scaleY, rotation: tt.rotation }, r5, g5);
          }
          function it(pt) {
            var mt = k2.slice(), Mt = r5.pxSign, kt = pt;
            return (r5.symbolRepeatDirection === "start" ? Mt > 0 : Mt < 0) && (kt = B3 - 1 - pt), mt[R6.index] = Z3 * (kt - B3 / 2 + 0.5) + k2[R6.index], { x: mt[0], y: mt[1], scaleX: r5.symbolScale[0], scaleY: r5.symbolScale[1], rotation: r5.rotation };
          }
        }
        function bPe(c5, s, r5, g5) {
          var b6 = c5.__pictorialBundle, S2 = c5.__pictorialMainPath;
          S2 ? PX2(S2, null, { x: r5.pathPosition[0], y: r5.pathPosition[1], scaleX: r5.symbolScale[0], scaleY: r5.symbolScale[1], rotation: r5.rotation }, r5, g5) : (S2 = c5.__pictorialMainPath = yPe(r5), b6.add(S2), PX2(S2, { x: r5.pathPosition[0], y: r5.pathPosition[1], scaleX: 0, scaleY: 0, rotation: r5.rotation }, { scaleX: r5.symbolScale[0], scaleY: r5.symbolScale[1] }, r5, g5));
        }
        function _Pe(c5, s, r5) {
          var g5 = sa2({}, s.barRectShape), b6 = c5.__pictorialBarRect;
          b6 ? PX2(b6, null, { shape: g5 }, s, r5) : (b6 = c5.__pictorialBarRect = new zf2({ z2: 2, shape: g5, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), b6.disableMorphing = true, c5.add(b6));
        }
        function xPe(c5, s, r5, g5) {
          if (r5.symbolClip) {
            var b6 = c5.__pictorialClipPath, S2 = sa2({}, r5.clipShape), A2 = s.valueDim, k2 = r5.animationModel, R6 = r5.dataIndex;
            if (b6)
              Qf2(b6, { shape: S2 }, k2, R6);
            else {
              S2[A2.wh] = 0, b6 = new zf2({ shape: S2 }), c5.__pictorialBundle.setClipPath(b6), c5.__pictorialClipPath = b6;
              var B3 = {};
              B3[A2.wh] = r5.clipShape[A2.wh], Jut[g5 ? "updateProps" : "initProps"](b6, { shape: B3 }, k2, R6);
            }
          }
        }
        function wPe(c5, s) {
          var r5 = c5.getItemModel(s);
          return r5.getAnimationDelayParams = FUn, r5.isAnimationEnabled = VUn, r5;
        }
        function FUn(c5) {
          return { index: c5.__pictorialAnimationIndex, count: c5.__pictorialRepeatTimes };
        }
        function VUn() {
          return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
        }
        function SPe(c5, s, r5, g5) {
          var b6 = new nu(), S2 = new nu();
          return b6.add(S2), b6.__pictorialBundle = S2, S2.x = r5.bundlePosition[0], S2.y = r5.bundlePosition[1], r5.symbolRepeat ? mPe(b6, s, r5) : bPe(b6, s, r5), _Pe(b6, r5, g5), xPe(b6, s, r5, g5), b6.__pictorialShapeStr = CPe(c5, r5), b6.__pictorialSymbolMeta = r5, b6;
        }
        function BUn(c5, s, r5) {
          var g5 = r5.animationModel, b6 = r5.dataIndex, S2 = c5.__pictorialBundle;
          Qf2(S2, { x: r5.bundlePosition[0], y: r5.bundlePosition[1] }, g5, b6), r5.symbolRepeat ? mPe(c5, s, r5, true) : bPe(c5, s, r5, true), _Pe(c5, r5, true), xPe(c5, s, r5, true);
        }
        function MPe(c5, s, r5, g5) {
          var b6 = g5.__pictorialBarRect;
          b6 && b6.removeTextContent();
          var S2 = [];
          bUt(g5, function(A2) {
            S2.push(A2);
          }), g5.__pictorialMainPath && S2.push(g5.__pictorialMainPath), g5.__pictorialClipPath && (r5 = null), Ye2(S2, function(A2) {
            A3(A2, { scaleX: 0, scaleY: 0 }, r5, s, function() {
              g5.parent && g5.parent.remove(g5);
            });
          }), c5.setItemGraphicEl(s, null);
        }
        function CPe(c5, s) {
          return [c5.getItemVisual(s.dataIndex, "symbol") || "none", !!s.symbolRepeat, !!s.symbolClip].join(":");
        }
        function bUt(c5, s, r5) {
          Ye2(c5.__pictorialBundle.children(), function(g5) {
            g5 !== c5.__pictorialBarRect && s.call(r5, g5);
          });
        }
        function PX2(c5, s, r5, g5, b6, S2) {
          s && c5.attr(s), g5.symbolClip && !b6 ? r5 && c5.attr(r5) : r5 && Jut[b6 ? "updateProps" : "initProps"](c5, r5, g5.animationModel, g5.dataIndex, S2);
        }
        function TPe(c5, s, r5) {
          var g5 = r5.dataIndex, b6 = r5.itemModel, S2 = b6.getModel("emphasis"), A2 = S2.getModel("itemStyle").getItemStyle(), k2 = b6.getModel(["blur", "itemStyle"]).getItemStyle(), R6 = b6.getModel(["select", "itemStyle"]).getItemStyle(), B3 = b6.getShallow("cursor"), G3 = S2.get("focus"), Z3 = S2.get("blurScope"), X3 = S2.get("scale");
          bUt(c5, function(pt) {
            if (pt instanceof qm) {
              var mt = pt.style;
              pt.useStyle(sa2({ image: mt.image, x: mt.x, y: mt.y, width: mt.width, height: mt.height }, r5.style));
            } else
              pt.useStyle(r5.style);
            var Mt = pt.ensureState("emphasis");
            Mt.style = A2, X3 && (Mt.scaleX = pt.scaleX * 1.1, Mt.scaleY = pt.scaleY * 1.1), pt.ensureState("blur").style = k2, pt.ensureState("select").style = R6, B3 && (pt.cursor = B3), pt.z2 = r5.z2;
          });
          var tt = s.valueDim.posDesc[+(r5.boundingLength > 0)], it = c5.__pictorialBarRect;
          Uw(it, qb2(b6), { labelFetcher: s.seriesModel, labelDataIndex: g5, defaultText: wX(s.seriesModel.getData(), g5), inheritColor: r5.style.fill, defaultOpacity: r5.style.opacity, defaultOutsidePosition: tt }), f0(c5, G3, Z3, S2.get("disabled"));
        }
        function APe(c5) {
          var s = Math.round(c5);
          return Math.abs(c5 - s) < 1e-4 ? s : Math.ceil(c5);
        }
        var zUn = PUn, jUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.hasSymbolVisual = true, r5.defaultSymbol = "roundRect", r5;
          }
          return s.prototype.getInitialData = function(r5) {
            return r5.stack = null, c5.prototype.getInitialData.apply(this, arguments);
          }, s.type = "series.pictorialBar", s.dependencies = ["grid"], s.defaultOption = $8(GMt.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), s;
        }(GMt), WUn = jUn;
        function GUn(c5) {
          c5.registerChartView(zUn), c5.registerSeriesModel(WUn), c5.registerLayout(c5.PRIORITY.VISUAL.LAYOUT, Au(BIe, "pictorialBar")), c5.registerLayout(c5.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, zIe("pictorialBar"));
        }
        var HUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._layers = [], r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = r5.getData(), A2 = this, k2 = this.group, R6 = r5.getLayerSeries(), B3 = S2.getLayout("layoutInfo"), G3 = B3.rect, Z3 = B3.boundaryGap;
            k2.x = 0, k2.y = G3.y + Z3[0];
            function X3(mt) {
              return mt.name;
            }
            var tt = new wR(this._layersSeries || [], R6, X3, X3), it = [];
            tt.add(Cs(pt, this, "add")).update(Cs(pt, this, "update")).remove(Cs(pt, this, "remove")).execute();
            function pt(mt, Mt, kt) {
              var Gt = A2._layers;
              if (mt === "remove") {
                k2.remove(Gt[Mt]);
                return;
              }
              for (var Ot = [], ce2 = [], ae2, de2 = R6[Mt].indices, we2 = 0; we2 < de2.length; we2++) {
                var Se2 = S2.getItemLayout(de2[we2]), Oe2 = Se2.x, je2 = Se2.y0, rn = Se2.y;
                Ot.push(Oe2, je2), ce2.push(Oe2, je2 + rn), ae2 = S2.getItemVisual(de2[we2], "style");
              }
              var qe2, An = S2.getItemLayout(de2[0]), jn = r5.getModel("label"), _n = jn.get("margin"), Jr = r5.getModel("emphasis");
              if (mt === "add") {
                var Qn = it[Mt] = new nu();
                qe2 = new JDe({ shape: { points: Ot, stackedOnPoints: ce2, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), Qn.add(qe2), k2.add(Qn), r5.isAnimationEnabled() && qe2.setClipPath(UUn(qe2.getBoundingRect(), r5, function() {
                  qe2.removeClipPath();
                }));
              } else {
                var Qn = Gt[kt];
                qe2 = Qn.childAt(0), k2.add(Qn), it[Mt] = Qn, Qf2(qe2, { shape: { points: Ot, stackedOnPoints: ce2 } }, r5), nT(qe2);
              }
              Uw(qe2, qb2(r5), { labelDataIndex: de2[we2 - 1], defaultText: S2.getName(de2[we2 - 1]), inheritColor: ae2.fill }, { normal: { verticalAlign: "middle" } }), qe2.setTextConfig({ position: null, local: true });
              var rr = qe2.getTextContent();
              rr && (rr.x = An.x - _n, rr.y = An.y0 + An.y / 2), qe2.useStyle(ae2), S2.setItemGraphicEl(Mt, qe2), z1(qe2, r5), f0(qe2, Jr.get("focus"), Jr.get("blurScope"), Jr.get("disabled"));
            }
            this._layersSeries = R6, this._layers = it;
          }, s.type = "themeRiver", s;
        }(Ig2);
        function UUn(c5, s, r5) {
          var g5 = new zf2({ shape: { x: c5.x - 10, y: c5.y - 10, width: 0, height: c5.height + 20 } });
          return tv(g5, { shape: { x: c5.x - 50, width: c5.width + 100, height: c5.height + 20 } }, s, r5), g5;
        }
        var qUn = HUn, _Ut = 2, ZUn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5) {
            c5.prototype.init.apply(this, arguments), this.legendVisualProvider = new jct(Cs(this.getData, this), Cs(this.getRawData, this));
          }, s.prototype.fixData = function(r5) {
            var g5 = r5.length, b6 = {}, S2 = SK(r5, function(X3) {
              return b6.hasOwnProperty(X3[0] + "") || (b6[X3[0] + ""] = -1), X3[2];
            }), A2 = [];
            S2.buckets.each(function(X3, tt) {
              A2.push({ name: tt, dataList: X3 });
            });
            for (var k2 = A2.length, R6 = 0; R6 < k2; ++R6) {
              for (var B3 = A2[R6].name, G3 = 0; G3 < A2[R6].dataList.length; ++G3) {
                var Z3 = A2[R6].dataList[G3][0] + "";
                b6[Z3] = R6;
              }
              for (var Z3 in b6)
                b6.hasOwnProperty(Z3) && b6[Z3] !== R6 && (b6[Z3] = R6, r5[g5] = [Z3, 0, B3], g5++);
            }
            return r5;
          }, s.prototype.getInitialData = function(r5, g5) {
            for (var b6 = this.getReferringComponents("singleAxis", E0).models[0], S2 = b6.get("type"), A2 = jp(r5.data, function(it) {
              return it[2] !== void 0;
            }), k2 = this.fixData(A2 || []), R6 = [], B3 = this.nameMap = Ps(), G3 = 0, Z3 = 0; Z3 < k2.length; ++Z3)
              R6.push(k2[Z3][_Ut]), B3.get(k2[Z3][_Ut]) || (B3.set(k2[Z3][_Ut], G3), G3++);
            var X3 = Act(k2, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: wMt(S2) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, tt = new m22(X3, this);
            return tt.initData(k2), tt;
          }, s.prototype.getLayerSeries = function() {
            for (var r5 = this.getData(), g5 = r5.count(), b6 = [], S2 = 0; S2 < g5; ++S2)
              b6[S2] = S2;
            var A2 = r5.mapDimension("single"), k2 = SK(b6, function(B3) {
              return r5.get("name", B3);
            }), R6 = [];
            return k2.buckets.each(function(B3, G3) {
              B3.sort(function(Z3, X3) {
                return r5.get(A2, Z3) - r5.get(A2, X3);
              }), R6.push({ name: G3, indices: B3 });
            }), R6;
          }, s.prototype.getAxisTooltipData = function(r5, g5, b6) {
            ja2(r5) || (r5 = r5 ? [r5] : []);
            for (var S2 = this.getData(), A2 = this.getLayerSeries(), k2 = [], R6 = A2.length, B3, G3 = 0; G3 < R6; ++G3) {
              for (var Z3 = Number.MAX_VALUE, X3 = -1, tt = A2[G3].indices.length, it = 0; it < tt; ++it) {
                var pt = S2.get(r5[0], A2[G3].indices[it]), mt = Math.abs(pt - g5);
                mt <= Z3 && (B3 = pt, Z3 = mt, X3 = A2[G3].indices[it]);
              }
              k2.push(X3);
            }
            return { dataIndices: k2, nestestValue: B3 };
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            var S2 = this.getData(), A2 = S2.getName(r5), k2 = S2.get(S2.mapDimension("value"), r5);
            return W1("nameValue", { name: A2, value: k2 });
          }, s.type = "series.themeRiver", s.dependencies = ["singleAxis"], s.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, s;
        }(zv), $Un = ZUn;
        function YUn(c5, s) {
          c5.eachSeriesByType("themeRiver", function(r5) {
            var g5 = r5.getData(), b6 = r5.coordinateSystem, S2 = {}, A2 = b6.getRect();
            S2.rect = A2;
            var k2 = r5.get("boundaryGap"), R6 = b6.getAxis();
            if (S2.boundaryGap = k2, R6.orient === "horizontal") {
              k2[0] = $o(k2[0], A2.height), k2[1] = $o(k2[1], A2.height);
              var B3 = A2.height - k2[0] - k2[1];
              IPe(g5, r5, B3);
            } else {
              k2[0] = $o(k2[0], A2.width), k2[1] = $o(k2[1], A2.width);
              var G3 = A2.width - k2[0] - k2[1];
              IPe(g5, r5, G3);
            }
            g5.setLayout("layoutInfo", S2);
          });
        }
        function IPe(c5, s, r5) {
          if (c5.count())
            for (var g5 = s.coordinateSystem, b6 = s.getLayerSeries(), S2 = c5.mapDimension("single"), A2 = c5.mapDimension("value"), k2 = Ha2(b6, function(mt) {
              return Ha2(mt.indices, function(Mt) {
                var kt = g5.dataToPoint(c5.get(S2, Mt));
                return kt[1] = c5.get(A2, Mt), kt;
              });
            }), R6 = KUn(k2), B3 = R6.y0, G3 = r5 / R6.max, Z3 = b6.length, X3 = b6[0].indices.length, tt, it = 0; it < X3; ++it) {
              tt = B3[it] * G3, c5.setItemLayout(b6[0].indices[it], { layerIndex: 0, x: k2[0][it][0], y0: tt, y: k2[0][it][1] * G3 });
              for (var pt = 1; pt < Z3; ++pt)
                tt += k2[pt - 1][it][1] * G3, c5.setItemLayout(b6[pt].indices[it], { layerIndex: pt, x: k2[pt][it][0], y0: tt, y: k2[pt][it][1] * G3 });
            }
        }
        function KUn(c5) {
          for (var s = c5.length, r5 = c5[0].length, g5 = [], b6 = [], S2 = 0, A2 = 0; A2 < r5; ++A2) {
            for (var k2 = 0, R6 = 0; R6 < s; ++R6)
              k2 += c5[R6][A2][1];
            k2 > S2 && (S2 = k2), g5.push(k2);
          }
          for (var B3 = 0; B3 < r5; ++B3)
            b6[B3] = (S2 - g5[B3]) / 2;
          S2 = 0;
          for (var G3 = 0; G3 < r5; ++G3) {
            var Z3 = g5[G3] + b6[G3];
            Z3 > S2 && (S2 = Z3);
          }
          return { y0: b6, max: S2 };
        }
        function XUn(c5) {
          c5.registerChartView(qUn), c5.registerSeriesModel($Un), c5.registerLayout(YUn), c5.registerProcessor(zct("themeRiver"));
        }
        var QUn = 2, JUn = 4, tqn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2) {
            var A2 = c5.call(this) || this;
            A2.z2 = QUn, A2.textConfig = { inside: true }, Pl(A2).seriesIndex = g5.seriesIndex;
            var k2 = new hh2({ z2: JUn, silent: r5.getModel().get(["label", "silent"]) });
            return A2.setTextContent(k2), A2.updateData(true, r5, g5, b6, S2), A2;
          }
          return s.prototype.updateData = function(r5, g5, b6, S2, A2) {
            this.node = g5, g5.piece = this, b6 = b6 || this._seriesModel, S2 = S2 || this._ecModel;
            var k2 = this;
            Pl(k2).dataIndex = g5.dataIndex;
            var R6 = g5.getModel(), B3 = R6.getModel("emphasis"), G3 = g5.getLayout(), Z3 = sa2({}, G3);
            Z3.label = null;
            var X3 = g5.getVisual("style");
            X3.lineJoin = "bevel";
            var tt = g5.getVisual("decal");
            tt && (X3.decal = mct(tt, A2));
            var it = SX(R6.getModel("itemStyle"), Z3, true);
            sa2(Z3, it), Ye2(k0, function(kt) {
              var Gt = k2.ensureState(kt), Ot = R6.getModel([kt, "itemStyle"]);
              Gt.style = Ot.getItemStyle();
              var ce2 = SX(Ot, Z3);
              ce2 && (Gt.shape = ce2);
            }), r5 ? (k2.setShape(Z3), k2.shape.r = G3.r0, Qf2(k2, { shape: { r: G3.r } }, b6, g5.dataIndex)) : (Qf2(k2, { shape: Z3 }, b6), nT(k2)), k2.useStyle(X3), this._updateLabel(b6);
            var pt = R6.getShallow("cursor");
            pt && k2.attr("cursor", pt), this._seriesModel = b6 || this._seriesModel, this._ecModel = S2 || this._ecModel;
            var mt = B3.get("focus"), Mt = mt === "ancestor" ? g5.getAncestorsIndices() : mt === "descendant" ? g5.getDescendantIndices() : mt;
            f0(this, Mt, B3.get("blurScope"), B3.get("disabled"));
          }, s.prototype._updateLabel = function(r5) {
            var g5 = this, b6 = this.node.getModel(), S2 = b6.getModel("label"), A2 = this.node.getLayout(), k2 = A2.endAngle - A2.startAngle, R6 = (A2.startAngle + A2.endAngle) / 2, B3 = Math.cos(R6), G3 = Math.sin(R6), Z3 = this, X3 = Z3.getTextContent(), tt = this.node.dataIndex, it = S2.get("minAngle") / 180 * Math.PI, pt = S2.get("show") && !(it != null && Math.abs(k2) < it);
            X3.ignore = !pt, Ye2(Yj2, function(Mt) {
              var kt = Mt === "normal" ? b6.getModel("label") : b6.getModel([Mt, "label"]), Gt = Mt === "normal", Ot = Gt ? X3 : X3.ensureState(Mt), ce2 = r5.getFormattedLabel(tt, Mt);
              Gt && (ce2 = ce2 || g5.node.name), Ot.style = Ey(kt, {}, null, Mt !== "normal", true), ce2 && (Ot.style.text = ce2);
              var ae2 = kt.get("show");
              ae2 != null && !Gt && (Ot.ignore = !ae2);
              var de2 = mt(kt, "position"), we2 = Gt ? Z3 : Z3.states[Mt], Se2 = we2.style.fill;
              we2.textConfig = { outsideFill: kt.get("color") === "inherit" ? Se2 : null, inside: de2 !== "outside" };
              var Oe2, je2 = mt(kt, "distance") || 0, rn = mt(kt, "align");
              de2 === "outside" ? (Oe2 = A2.r + je2, rn = R6 > Math.PI / 2 ? "right" : "left") : !rn || rn === "center" ? (k2 === 2 * Math.PI && A2.r0 === 0 ? Oe2 = 0 : Oe2 = (A2.r + A2.r0) / 2, rn = "center") : rn === "left" ? (Oe2 = A2.r0 + je2, R6 > Math.PI / 2 && (rn = "right")) : rn === "right" && (Oe2 = A2.r - je2, R6 > Math.PI / 2 && (rn = "left")), Ot.style.align = rn, Ot.style.verticalAlign = mt(kt, "verticalAlign") || "middle", Ot.x = Oe2 * B3 + A2.cx, Ot.y = Oe2 * G3 + A2.cy;
              var qe2 = mt(kt, "rotate"), An = 0;
              qe2 === "radial" ? (An = -R6, An < -Math.PI / 2 && (An += Math.PI)) : qe2 === "tangential" ? (An = Math.PI / 2 - R6, An > Math.PI / 2 ? An -= Math.PI : An < -Math.PI / 2 && (An += Math.PI)) : Oh2(qe2) && (An = qe2 * Math.PI / 180), Ot.rotation = An;
            });
            function mt(Mt, kt) {
              var Gt = Mt.get(kt);
              return Gt == null ? S2.get(kt) : Gt;
            }
            X3.dirtyStyle();
          }, s;
        }(Ww), DPe = tqn, xUt = "sunburstRootToNode", EPe = "sunburstHighlight", eqn = "sunburstUnhighlight";
        function nqn(c5) {
          c5.registerAction({ type: xUt, update: "updateView" }, function(s, r5) {
            r5.eachComponent({ mainType: "series", subType: "sunburst", query: s }, g5);
            function g5(b6, S2) {
              var A2 = $ct(s, [xUt], b6);
              if (A2) {
                var k2 = b6.getViewRoot();
                k2 && (s.direction = CHt(k2, A2.node) ? "rollUp" : "drillDown"), b6.resetViewRoot(A2.node);
              }
            }
          }), c5.registerAction({ type: EPe, update: "none" }, function(s, r5, g5) {
            s = sa2({}, s), r5.eachComponent({ mainType: "series", subType: "sunburst", query: s }, b6);
            function b6(S2) {
              var A2 = $ct(s, [EPe], S2);
              A2 && (s.dataIndex = A2.node.dataIndex);
            }
            g5.dispatchAction(sa2(s, { type: "highlight" }));
          }), c5.registerAction({ type: eqn, update: "updateView" }, function(s, r5, g5) {
            s = sa2({}, s), g5.dispatchAction(sa2(s, { type: "downplay" }));
          });
        }
        var rqn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            var A2 = this;
            this.seriesModel = r5, this.api = b6, this.ecModel = g5;
            var k2 = r5.getData(), R6 = k2.tree.root, B3 = r5.getViewRoot(), G3 = this.group, Z3 = r5.get("renderLabelForZeroData"), X3 = [];
            B3.eachNode(function(kt) {
              X3.push(kt);
            });
            var tt = this._oldChildren || [];
            it(X3, tt), Mt(R6, B3), this._initEvents(), this._oldChildren = X3;
            function it(kt, Gt) {
              if (kt.length === 0 && Gt.length === 0)
                return;
              new wR(Gt, kt, Ot, Ot).add(ce2).update(ce2).remove(Au(ce2, null)).execute();
              function Ot(ae2) {
                return ae2.getId();
              }
              function ce2(ae2, de2) {
                var we2 = ae2 == null ? null : kt[ae2], Se2 = de2 == null ? null : Gt[de2];
                pt(we2, Se2);
              }
            }
            function pt(kt, Gt) {
              if (!Z3 && kt && !kt.getValue() && (kt = null), kt !== R6 && Gt !== R6) {
                if (Gt && Gt.piece)
                  kt ? (Gt.piece.updateData(false, kt, r5, g5, b6), k2.setItemGraphicEl(kt.dataIndex, Gt.piece)) : mt(Gt);
                else if (kt) {
                  var Ot = new DPe(kt, r5, g5, b6);
                  G3.add(Ot), k2.setItemGraphicEl(kt.dataIndex, Ot);
                }
              }
            }
            function mt(kt) {
              !kt || kt.piece && (G3.remove(kt.piece), kt.piece = null);
            }
            function Mt(kt, Gt) {
              Gt.depth > 0 ? (A2.virtualPiece ? A2.virtualPiece.updateData(false, kt, r5, g5, b6) : (A2.virtualPiece = new DPe(kt, r5, g5, b6), G3.add(A2.virtualPiece)), Gt.piece.off("click"), A2.virtualPiece.on("click", function(Ot) {
                A2._rootToNode(Gt.parentNode);
              })) : A2.virtualPiece && (G3.remove(A2.virtualPiece), A2.virtualPiece = null);
            }
          }, s.prototype._initEvents = function() {
            var r5 = this;
            this.group.off("click"), this.group.on("click", function(g5) {
              var b6 = false, S2 = r5.seriesModel.getViewRoot();
              S2.eachNode(function(A2) {
                if (!b6 && A2.piece && A2.piece === g5.target) {
                  var k2 = A2.getModel().get("nodeClick");
                  if (k2 === "rootToNode")
                    r5._rootToNode(A2);
                  else if (k2 === "link") {
                    var R6 = A2.getModel(), B3 = R6.get("link");
                    if (B3) {
                      var G3 = R6.get("target", true) || "_blank";
                      J2t(B3, G3);
                    }
                  }
                  b6 = true;
                }
              });
            });
          }, s.prototype._rootToNode = function(r5) {
            r5 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: xUt, from: this.uid, seriesId: this.seriesModel.id, targetNode: r5 });
          }, s.prototype.containPoint = function(r5, g5) {
            var b6 = g5.getData(), S2 = b6.getItemLayout(0);
            if (S2) {
              var A2 = r5[0] - S2.cx, k2 = r5[1] - S2.cy, R6 = Math.sqrt(A2 * A2 + k2 * k2);
              return R6 <= S2.r && R6 >= S2.r0;
            }
          }, s.type = "sunburst", s;
        }(Ig2), iqn = rqn, aqn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.ignoreStyleOnData = true, r5;
          }
          return s.prototype.getInitialData = function(r5, g5) {
            var b6 = { name: r5.name, children: r5.data };
            kPe(b6);
            var S2 = this._levelModels = Ha2(r5.levels || [], function(R6) {
              return new Ag2(R6, this, g5);
            }, this), A2 = MHt.createTree(b6, this, k2);
            function k2(R6) {
              R6.wrapMethod("getItemModel", function(B3, G3) {
                var Z3 = A2.getNodeByDataIndex(G3), X3 = S2[Z3.depth];
                return X3 && (B3.parentModel = X3), B3;
              });
            }
            return A2.data;
          }, s.prototype.optionUpdated = function() {
            this.resetViewRoot();
          }, s.prototype.getDataParams = function(r5) {
            var g5 = c5.prototype.getDataParams.apply(this, arguments), b6 = this.getData().tree.getNodeByDataIndex(r5);
            return g5.treePathInfo = nCt(b6, this), g5;
          }, s.prototype.getLevelModel = function(r5) {
            return this._levelModels && this._levelModels[r5.depth];
          }, s.prototype.getViewRoot = function() {
            return this._viewRoot;
          }, s.prototype.resetViewRoot = function(r5) {
            r5 ? this._viewRoot = r5 : r5 = this._viewRoot;
            var g5 = this.getRawData().tree.root;
            (!r5 || r5 !== g5 && !g5.contains(r5)) && (this._viewRoot = g5);
          }, s.prototype.enableAriaDecal = function() {
            Bke(this);
          }, s.type = "series.sunburst", s.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, s;
        }(zv);
        function kPe(c5) {
          var s = 0;
          Ye2(c5.children, function(g5) {
            kPe(g5);
            var b6 = g5.value;
            ja2(b6) && (b6 = b6[0]), s += b6;
          });
          var r5 = c5.value;
          ja2(r5) && (r5 = r5[0]), (r5 == null || isNaN(r5)) && (r5 = s), r5 < 0 && (r5 = 0), ja2(c5.value) ? c5.value[0] = r5 : c5.value = r5;
        }
        var oqn = aqn, PPe = Math.PI / 180;
        function sqn(c5, s, r5) {
          s.eachSeriesByType(c5, function(g5) {
            var b6 = g5.get("center"), S2 = g5.get("radius");
            ja2(S2) || (S2 = [0, S2]), ja2(b6) || (b6 = [b6, b6]);
            var A2 = r5.getWidth(), k2 = r5.getHeight(), R6 = Math.min(A2, k2), B3 = $o(b6[0], A2), G3 = $o(b6[1], k2), Z3 = $o(S2[0], R6 / 2), X3 = $o(S2[1], R6 / 2), tt = -g5.get("startAngle") * PPe, it = g5.get("minAngle") * PPe, pt = g5.getData().tree.root, mt = g5.getViewRoot(), Mt = mt.depth, kt = g5.get("sort");
            kt != null && LPe(mt, kt);
            var Gt = 0;
            Ye2(mt.children, function(_n) {
              !isNaN(_n.getValue()) && Gt++;
            });
            var Ot = mt.getValue(), ce2 = Math.PI / (Ot || Gt) * 2, ae2 = mt.depth > 0, de2 = mt.height - (ae2 ? -1 : 1), we2 = (X3 - Z3) / (de2 || 1), Se2 = g5.get("clockwise"), Oe2 = g5.get("stillShowZeroSum"), je2 = Se2 ? 1 : -1, rn = function(_n, Jr) {
              if (_n) {
                var Qn = Jr;
                if (_n !== pt) {
                  var rr = _n.getValue(), Ar = Ot === 0 && Oe2 ? ce2 : rr * ce2;
                  Ar < it && (Ar = it), Qn = Jr + je2 * Ar;
                  var fi2 = _n.depth - Mt - (ae2 ? -1 : 1), mi2 = Z3 + we2 * fi2, Oo = Z3 + we2 * (fi2 + 1), Ts = g5.getLevelModel(_n);
                  if (Ts) {
                    var gl = Ts.get("r0", true), nl = Ts.get("r", true), rl = Ts.get("radius", true);
                    rl != null && (gl = rl[0], nl = rl[1]), gl != null && (mi2 = $o(gl, R6 / 2)), nl != null && (Oo = $o(nl, R6 / 2));
                  }
                  _n.setLayout({ angle: Ar, startAngle: Jr, endAngle: Qn, clockwise: Se2, cx: B3, cy: G3, r0: mi2, r: Oo });
                }
                if (_n.children && _n.children.length) {
                  var ss = 0;
                  Ye2(_n.children, function(Us) {
                    ss += rn(Us, Jr + ss);
                  });
                }
                return Qn - Jr;
              }
            };
            if (ae2) {
              var qe2 = Z3, An = Z3 + we2, jn = Math.PI * 2;
              pt.setLayout({ angle: jn, startAngle: tt, endAngle: tt + jn, clockwise: Se2, cx: B3, cy: G3, r0: qe2, r: An });
            }
            rn(mt, tt);
          });
        }
        function LPe(c5, s) {
          var r5 = c5.children || [];
          c5.children = lqn(r5, s), r5.length && Ye2(c5.children, function(g5) {
            LPe(g5, s);
          });
        }
        function lqn(c5, s) {
          if (Tl(s)) {
            var r5 = Ha2(c5, function(b6, S2) {
              var A2 = b6.getValue();
              return { params: { depth: b6.depth, height: b6.height, dataIndex: b6.dataIndex, getValue: function() {
                return A2;
              } }, index: S2 };
            });
            return r5.sort(function(b6, S2) {
              return s(b6.params, S2.params);
            }), Ha2(r5, function(b6) {
              return c5[b6.index];
            });
          } else {
            var g5 = s === "asc";
            return c5.sort(function(b6, S2) {
              var A2 = (b6.getValue() - S2.getValue()) * (g5 ? 1 : -1);
              return A2 === 0 ? (b6.dataIndex - S2.dataIndex) * (g5 ? -1 : 1) : A2;
            });
          }
        }
        function uqn(c5) {
          var s = {};
          function r5(g5, b6, S2) {
            for (var A2 = g5; A2 && A2.depth > 1; )
              A2 = A2.parentNode;
            var k2 = b6.getColorFromPalette(A2.name || A2.dataIndex + "", s);
            return g5.depth > 1 && gs(k2) && (k2 = wlt(k2, (g5.depth - 1) / (S2 - 1) * 0.5)), k2;
          }
          c5.eachSeriesByType("sunburst", function(g5) {
            var b6 = g5.getData(), S2 = b6.tree;
            S2.eachNode(function(A2) {
              var k2 = A2.getModel(), R6 = k2.getModel("itemStyle").getItemStyle();
              R6.fill || (R6.fill = r5(A2, g5, S2.root.height));
              var B3 = b6.ensureUniqueItemVisual(A2.dataIndex, "style");
              sa2(B3, R6);
            });
          });
        }
        function cqn(c5) {
          c5.registerChartView(iqn), c5.registerSeriesModel(oqn), c5.registerLayout(Au(sqn, "sunburst")), c5.registerProcessor(Au(zct, "sunburst")), c5.registerVisual(uqn), nqn(c5);
        }
        var OPe = { color: "fill", borderColor: "stroke" }, fqn = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, DR = Df2(), hqn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.optionUpdated = function() {
            this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
          }, s.prototype.getInitialData = function(r5, g5) {
            return SR(null, this);
          }, s.prototype.getDataParams = function(r5, g5, b6) {
            var S2 = c5.prototype.getDataParams.call(this, r5, g5);
            return b6 && (S2.info = DR(b6).info), S2;
          }, s.type = "series.custom", s.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], s.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, s;
        }(zv), pqn = hqn;
        function dqn(c5, s) {
          return s = s || [0, 0], Ha2(["x", "y"], function(r5, g5) {
            var b6 = this.getAxis(r5), S2 = s[g5], A2 = c5[g5] / 2;
            return b6.type === "category" ? b6.getBandWidth() : Math.abs(b6.dataToCoord(S2 - A2) - b6.dataToCoord(S2 + A2));
          }, this);
        }
        function gqn(c5) {
          var s = c5.master.getRect();
          return { coordSys: { type: "cartesian2d", x: s.x, y: s.y, width: s.width, height: s.height }, api: { coord: function(r5) {
            return c5.dataToPoint(r5);
          }, size: Cs(dqn, c5) } };
        }
        function vqn(c5, s) {
          return s = s || [0, 0], Ha2([0, 1], function(r5) {
            var g5 = s[r5], b6 = c5[r5] / 2, S2 = [], A2 = [];
            return S2[r5] = g5 - b6, A2[r5] = g5 + b6, S2[1 - r5] = A2[1 - r5] = s[1 - r5], Math.abs(this.dataToPoint(S2)[r5] - this.dataToPoint(A2)[r5]);
          }, this);
        }
        function yqn(c5) {
          var s = c5.getBoundingRect();
          return { coordSys: { type: "geo", x: s.x, y: s.y, width: s.width, height: s.height, zoom: c5.getZoom() }, api: { coord: function(r5) {
            return c5.dataToPoint(r5);
          }, size: Cs(vqn, c5) } };
        }
        function mqn(c5, s) {
          var r5 = this.getAxis(), g5 = s instanceof Array ? s[0] : s, b6 = (c5 instanceof Array ? c5[0] : c5) / 2;
          return r5.type === "category" ? r5.getBandWidth() : Math.abs(r5.dataToCoord(g5 - b6) - r5.dataToCoord(g5 + b6));
        }
        function bqn(c5) {
          var s = c5.getRect();
          return { coordSys: { type: "singleAxis", x: s.x, y: s.y, width: s.width, height: s.height }, api: { coord: function(r5) {
            return c5.dataToPoint(r5);
          }, size: Cs(mqn, c5) } };
        }
        function _qn(c5, s) {
          return s = s || [0, 0], Ha2(["Radius", "Angle"], function(r5, g5) {
            var b6 = "get" + r5 + "Axis", S2 = this[b6](), A2 = s[g5], k2 = c5[g5] / 2, R6 = S2.type === "category" ? S2.getBandWidth() : Math.abs(S2.dataToCoord(A2 - k2) - S2.dataToCoord(A2 + k2));
            return r5 === "Angle" && (R6 = R6 * Math.PI / 180), R6;
          }, this);
        }
        function xqn(c5) {
          var s = c5.getRadiusAxis(), r5 = c5.getAngleAxis(), g5 = s.getExtent();
          return g5[0] > g5[1] && g5.reverse(), { coordSys: { type: "polar", cx: c5.cx, cy: c5.cy, r: g5[1], r0: g5[0] }, api: { coord: function(b6) {
            var S2 = s.dataToRadius(b6[0]), A2 = r5.dataToAngle(b6[1]), k2 = c5.coordToPoint([S2, A2]);
            return k2.push(S2, A2 * Math.PI / 180), k2;
          }, size: Cs(_qn, c5) } };
        }
        function wqn(c5) {
          var s = c5.getRect(), r5 = c5.getRangeInfo();
          return { coordSys: { type: "calendar", x: s.x, y: s.y, width: s.width, height: s.height, cellWidth: c5.getCellWidth(), cellHeight: c5.getCellHeight(), rangeInfo: { start: r5.start, end: r5.end, weeks: r5.weeks, dayCount: r5.allDay } }, api: { coord: function(g5, b6) {
            return c5.dataToPoint(g5, b6);
          } } };
        }
        function RPe(c5, s, r5, g5) {
          return c5 && (c5.legacy || c5.legacy !== false && !r5 && !g5 && s !== "tspan" && (s === "text" || Ls(c5, "text")));
        }
        function NPe(c5, s, r5) {
          var g5 = c5, b6, S2, A2;
          if (s === "text")
            A2 = g5;
          else {
            A2 = {}, Ls(g5, "text") && (A2.text = g5.text), Ls(g5, "rich") && (A2.rich = g5.rich), Ls(g5, "textFill") && (A2.fill = g5.textFill), Ls(g5, "textStroke") && (A2.stroke = g5.textStroke), Ls(g5, "fontFamily") && (A2.fontFamily = g5.fontFamily), Ls(g5, "fontSize") && (A2.fontSize = g5.fontSize), Ls(g5, "fontStyle") && (A2.fontStyle = g5.fontStyle), Ls(g5, "fontWeight") && (A2.fontWeight = g5.fontWeight), S2 = { type: "text", style: A2, silent: true }, b6 = {};
            var k2 = Ls(g5, "textPosition");
            r5 ? b6.position = k2 ? g5.textPosition : "inside" : k2 && (b6.position = g5.textPosition), Ls(g5, "textPosition") && (b6.position = g5.textPosition), Ls(g5, "textOffset") && (b6.offset = g5.textOffset), Ls(g5, "textRotation") && (b6.rotation = g5.textRotation), Ls(g5, "textDistance") && (b6.distance = g5.textDistance);
          }
          return FPe(A2, c5), Ye2(A2.rich, function(R6) {
            FPe(R6, R6);
          }), { textConfig: b6, textContent: S2 };
        }
        function FPe(c5, s) {
          !s || (s.font = s.textFont || s.font, Ls(s, "textStrokeWidth") && (c5.lineWidth = s.textStrokeWidth), Ls(s, "textAlign") && (c5.align = s.textAlign), Ls(s, "textVerticalAlign") && (c5.verticalAlign = s.textVerticalAlign), Ls(s, "textLineHeight") && (c5.lineHeight = s.textLineHeight), Ls(s, "textWidth") && (c5.width = s.textWidth), Ls(s, "textHeight") && (c5.height = s.textHeight), Ls(s, "textBackgroundColor") && (c5.backgroundColor = s.textBackgroundColor), Ls(s, "textPadding") && (c5.padding = s.textPadding), Ls(s, "textBorderColor") && (c5.borderColor = s.textBorderColor), Ls(s, "textBorderWidth") && (c5.borderWidth = s.textBorderWidth), Ls(s, "textBorderRadius") && (c5.borderRadius = s.textBorderRadius), Ls(s, "textBoxShadowColor") && (c5.shadowColor = s.textBoxShadowColor), Ls(s, "textBoxShadowBlur") && (c5.shadowBlur = s.textBoxShadowBlur), Ls(s, "textBoxShadowOffsetX") && (c5.shadowOffsetX = s.textBoxShadowOffsetX), Ls(s, "textBoxShadowOffsetY") && (c5.shadowOffsetY = s.textBoxShadowOffsetY));
        }
        function VPe(c5, s, r5) {
          var g5 = c5;
          g5.textPosition = g5.textPosition || r5.position || "inside", r5.offset != null && (g5.textOffset = r5.offset), r5.rotation != null && (g5.textRotation = r5.rotation), r5.distance != null && (g5.textDistance = r5.distance);
          var b6 = g5.textPosition.indexOf("inside") >= 0, S2 = c5.fill || "#000";
          BPe(g5, s);
          var A2 = g5.textFill == null;
          return b6 ? A2 && (g5.textFill = r5.insideFill || "#fff", !g5.textStroke && r5.insideStroke && (g5.textStroke = r5.insideStroke), !g5.textStroke && (g5.textStroke = S2), g5.textStrokeWidth == null && (g5.textStrokeWidth = 2)) : (A2 && (g5.textFill = c5.fill || r5.outsideFill || "#000"), !g5.textStroke && r5.outsideStroke && (g5.textStroke = r5.outsideStroke)), g5.text = s.text, g5.rich = s.rich, Ye2(s.rich, function(k2) {
            BPe(k2, k2);
          }), g5;
        }
        function BPe(c5, s) {
          !s || (Ls(s, "fill") && (c5.textFill = s.fill), Ls(s, "stroke") && (c5.textStroke = s.fill), Ls(s, "lineWidth") && (c5.textStrokeWidth = s.lineWidth), Ls(s, "font") && (c5.font = s.font), Ls(s, "fontStyle") && (c5.fontStyle = s.fontStyle), Ls(s, "fontWeight") && (c5.fontWeight = s.fontWeight), Ls(s, "fontSize") && (c5.fontSize = s.fontSize), Ls(s, "fontFamily") && (c5.fontFamily = s.fontFamily), Ls(s, "align") && (c5.textAlign = s.align), Ls(s, "verticalAlign") && (c5.textVerticalAlign = s.verticalAlign), Ls(s, "lineHeight") && (c5.textLineHeight = s.lineHeight), Ls(s, "width") && (c5.textWidth = s.width), Ls(s, "height") && (c5.textHeight = s.height), Ls(s, "backgroundColor") && (c5.textBackgroundColor = s.backgroundColor), Ls(s, "padding") && (c5.textPadding = s.padding), Ls(s, "borderColor") && (c5.textBorderColor = s.borderColor), Ls(s, "borderWidth") && (c5.textBorderWidth = s.borderWidth), Ls(s, "borderRadius") && (c5.textBorderRadius = s.borderRadius), Ls(s, "shadowColor") && (c5.textBoxShadowColor = s.shadowColor), Ls(s, "shadowBlur") && (c5.textBoxShadowBlur = s.shadowBlur), Ls(s, "shadowOffsetX") && (c5.textBoxShadowOffsetX = s.shadowOffsetX), Ls(s, "shadowOffsetY") && (c5.textBoxShadowOffsetY = s.shadowOffsetY), Ls(s, "textShadowColor") && (c5.textShadowColor = s.textShadowColor), Ls(s, "textShadowBlur") && (c5.textShadowBlur = s.textShadowBlur), Ls(s, "textShadowOffsetX") && (c5.textShadowOffsetX = s.textShadowOffsetX), Ls(s, "textShadowOffsetY") && (c5.textShadowOffsetY = s.textShadowOffsetY));
        }
        var zPe = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, jPe = nf2(zPe);
        VC(xM, function(c5, s) {
          return c5[s] = 1, c5;
        }, {}), xM.join(", ");
        var gCt = ["", "style", "shape", "extra"], LX = Df2();
        function wUt(c5, s, r5, g5, b6) {
          var S2 = c5 + "Animation", A2 = q8(c5, g5, b6) || {}, k2 = LX(s).userDuring;
          return A2.duration > 0 && (A2.during = k2 ? Cs(Aqn, { el: s, userDuring: k2 }) : null, A2.setToFinal = true, A2.scope = c5), sa2(A2, r5[S2]), A2;
        }
        function vCt(c5, s, r5, g5) {
          g5 = g5 || {};
          var b6 = g5.dataIndex, S2 = g5.isInit, A2 = g5.clearStyle, k2 = r5.isAnimationEnabled(), R6 = LX(c5), B3 = s.style;
          R6.userDuring = s.during;
          var G3 = {}, Z3 = {};
          if (Dqn(c5, s, Z3), HPe("shape", s, Z3), HPe("extra", s, Z3), !S2 && k2 && (Iqn(c5, s, G3), GPe("shape", c5, s, G3), GPe("extra", c5, s, G3), Eqn(c5, s, B3, G3)), Z3.style = B3, Sqn(c5, Z3, A2), Cqn(c5, s), k2)
            if (S2) {
              var X3 = {};
              Ye2(gCt, function(it) {
                var pt = it ? s[it] : s;
                pt && pt.enterFrom && (it && (X3[it] = X3[it] || {}), sa2(it ? X3[it] : X3, pt.enterFrom));
              });
              var tt = wUt("enter", c5, s, r5, b6);
              tt.duration > 0 && c5.animateFrom(X3, tt);
            } else
              Mqn(c5, s, b6 || 0, r5, G3);
          WPe(c5, s), B3 ? c5.dirty() : c5.markRedraw();
        }
        function WPe(c5, s) {
          for (var r5 = LX(c5).leaveToProps, g5 = 0; g5 < gCt.length; g5++) {
            var b6 = gCt[g5], S2 = b6 ? s[b6] : s;
            S2 && S2.leaveTo && (r5 || (r5 = LX(c5).leaveToProps = {}), b6 && (r5[b6] = r5[b6] || {}), sa2(b6 ? r5[b6] : r5, S2.leaveTo));
          }
        }
        function yCt(c5, s, r5, g5) {
          if (c5) {
            var b6 = c5.parent, S2 = LX(c5).leaveToProps;
            if (S2) {
              var A2 = wUt("update", c5, s, r5, 0);
              A2.done = function() {
                b6.remove(c5), g5 && g5();
              }, c5.animateTo(S2, A2);
            } else
              b6.remove(c5), g5 && g5();
          }
        }
        function PW(c5) {
          return c5 === "all";
        }
        function Sqn(c5, s, r5) {
          var g5 = s.style;
          if (!c5.isGroup && g5) {
            if (r5) {
              c5.useStyle({});
              for (var b6 = c5.animators, S2 = 0; S2 < b6.length; S2++) {
                var A2 = b6[S2];
                A2.targetName === "style" && A2.changeTarget(c5.style);
              }
            }
            c5.setStyle(g5);
          }
          s && (s.style = null, s && c5.attr(s), s.style = g5);
        }
        function Mqn(c5, s, r5, g5, b6) {
          if (b6) {
            var S2 = wUt("update", c5, s, g5, r5);
            S2.duration > 0 && c5.animateFrom(b6, S2);
          }
        }
        function Cqn(c5, s) {
          Ls(s, "silent") && (c5.silent = s.silent), Ls(s, "ignore") && (c5.ignore = s.ignore), c5 instanceof SM && Ls(s, "invisible") && (c5.invisible = s.invisible), c5 instanceof Tc2 && Ls(s, "autoBatch") && (c5.autoBatch = s.autoBatch);
        }
        var R3 = {}, Tqn = { setTransform: function(c5, s) {
          return R3.el[c5] = s, this;
        }, getTransform: function(c5) {
          return R3.el[c5];
        }, setShape: function(c5, s) {
          var r5 = R3.el, g5 = r5.shape || (r5.shape = {});
          return g5[c5] = s, r5.dirtyShape && r5.dirtyShape(), this;
        }, getShape: function(c5) {
          var s = R3.el.shape;
          if (s)
            return s[c5];
        }, setStyle: function(c5, s) {
          var r5 = R3.el, g5 = r5.style;
          return g5 && (g5[c5] = s, r5.dirtyStyle && r5.dirtyStyle()), this;
        }, getStyle: function(c5) {
          var s = R3.el.style;
          if (s)
            return s[c5];
        }, setExtra: function(c5, s) {
          var r5 = R3.el.extra || (R3.el.extra = {});
          return r5[c5] = s, this;
        }, getExtra: function(c5) {
          var s = R3.el.extra;
          if (s)
            return s[c5];
        } };
        function Aqn() {
          var c5 = this, s = c5.el;
          if (s) {
            var r5 = LX(s).userDuring, g5 = c5.userDuring;
            if (r5 !== g5) {
              c5.el = c5.userDuring = null;
              return;
            }
            R3.el = s, g5(Tqn);
          }
        }
        function GPe(c5, s, r5, g5) {
          var b6 = r5[c5];
          if (b6) {
            var S2 = s[c5], A2;
            if (S2) {
              var k2 = r5.transition, R6 = b6.transition;
              if (R6)
                if (!A2 && (A2 = g5[c5] = {}), PW(R6))
                  sa2(A2, S2);
                else
                  for (var B3 = xp(R6), G3 = 0; G3 < B3.length; G3++) {
                    var Z3 = B3[G3], X3 = S2[Z3];
                    A2[Z3] = X3;
                  }
              else if (PW(k2) || Lu(k2, c5) >= 0) {
                !A2 && (A2 = g5[c5] = {});
                for (var tt = nf2(S2), G3 = 0; G3 < tt.length; G3++) {
                  var Z3 = tt[G3], X3 = S2[Z3];
                  kqn(b6[Z3], X3) && (A2[Z3] = X3);
                }
              }
            }
          }
        }
        function HPe(c5, s, r5) {
          var g5 = s[c5];
          if (g5)
            for (var b6 = r5[c5] = {}, S2 = nf2(g5), A2 = 0; A2 < S2.length; A2++) {
              var k2 = S2[A2];
              b6[k2] = l3(g5[k2]);
            }
        }
        function Iqn(c5, s, r5) {
          for (var g5 = s.transition, b6 = PW(g5) ? xM : xp(g5 || []), S2 = 0; S2 < b6.length; S2++) {
            var A2 = b6[S2];
            if (!(A2 === "style" || A2 === "shape" || A2 === "extra")) {
              var k2 = c5[A2];
              r5[A2] = k2;
            }
          }
        }
        function Dqn(c5, s, r5) {
          for (var g5 = 0; g5 < jPe.length; g5++) {
            var b6 = jPe[g5], S2 = zPe[b6], A2 = s[b6];
            A2 && (r5[S2[0]] = A2[0], r5[S2[1]] = A2[1]);
          }
          for (var g5 = 0; g5 < xM.length; g5++) {
            var k2 = xM[g5];
            s[k2] != null && (r5[k2] = s[k2]);
          }
        }
        function Eqn(c5, s, r5, g5) {
          if (r5) {
            var b6 = c5.style, S2;
            if (b6) {
              var A2 = r5.transition, k2 = s.transition;
              if (A2 && !PW(A2)) {
                var R6 = xp(A2);
                !S2 && (S2 = g5.style = {});
                for (var B3 = 0; B3 < R6.length; B3++) {
                  var G3 = R6[B3], Z3 = b6[G3];
                  S2[G3] = Z3;
                }
              } else if (c5.getAnimationStyleProps && (PW(k2) || PW(A2) || Lu(k2, "style") >= 0)) {
                var X3 = c5.getAnimationStyleProps(), tt = X3 ? X3.style : null;
                if (tt) {
                  !S2 && (S2 = g5.style = {});
                  for (var it = nf2(r5), B3 = 0; B3 < it.length; B3++) {
                    var G3 = it[B3];
                    if (tt[G3]) {
                      var Z3 = b6[G3];
                      S2[G3] = Z3;
                    }
                  }
                }
              }
            }
          }
        }
        function kqn(c5, s) {
          return Fb2(c5) ? c5 !== s : c5 != null && isFinite(c5);
        }
        var UPe = Df2(), Pqn = ["percent", "easing", "shape", "style", "extra"];
        function qPe(c5) {
          c5.stopAnimation("keyframe"), c5.attr(UPe(c5));
        }
        function mCt(c5, s, r5) {
          if (!(!r5.isAnimationEnabled() || !s)) {
            if (ja2(s)) {
              Ye2(s, function(k2) {
                mCt(c5, k2, r5);
              });
              return;
            }
            var g5 = s.keyframes, b6 = s.duration;
            if (r5 && b6 == null) {
              var S2 = q8("enter", r5, 0);
              b6 = S2 && S2.duration;
            }
            if (!(!g5 || !b6)) {
              var A2 = UPe(c5);
              Ye2(gCt, function(k2) {
                if (!(k2 && !c5[k2])) {
                  var R6;
                  g5.sort(function(B3, G3) {
                    return B3.percent - G3.percent;
                  }), Ye2(g5, function(B3) {
                    var G3 = c5.animators, Z3 = k2 ? B3[k2] : B3;
                    if (Z3) {
                      var X3 = nf2(Z3);
                      if (k2 || (X3 = jp(X3, function(pt) {
                        return Lu(Pqn, pt) < 0;
                      })), !!X3.length) {
                        R6 || (R6 = c5.animate(k2, s.loop, true), R6.scope = "keyframe");
                        for (var tt = 0; tt < G3.length; tt++)
                          G3[tt] !== R6 && G3[tt].targetName === R6.targetName && G3[tt].stopTracks(X3);
                        k2 && (A2[k2] = A2[k2] || {});
                        var it = k2 ? A2[k2] : A2;
                        Ye2(X3, function(pt) {
                          it[pt] = ((k2 ? c5[k2] : c5) || {})[pt];
                        }), R6.whenWithKeys(b6 * B3.percent, Z3, X3, B3.easing);
                      }
                    }
                  }), R6 && R6.delay(s.delay || 0).duration(b6).start(s.easing);
                }
              });
            }
          }
        }
        var ER = "emphasis", u9 = "normal", SUt = "blur", MUt = "select", c9 = [u9, ER, SUt, MUt], CUt = { normal: ["itemStyle"], emphasis: [ER, "itemStyle"], blur: [SUt, "itemStyle"], select: [MUt, "itemStyle"] }, TUt = { normal: ["label"], emphasis: [ER, "label"], blur: [SUt, "label"], select: [MUt, "label"] }, Lqn = ["x", "y"], Oqn = "e\0\0", iD = { normal: {}, emphasis: {}, blur: {}, select: {} }, Rqn = { cartesian2d: gqn, geo: yqn, singleAxis: bqn, polar: xqn, calendar: wqn };
        function AUt(c5) {
          return c5 instanceof Tc2;
        }
        function IUt(c5) {
          return c5 instanceof SM;
        }
        function Nqn(c5, s) {
          s.copyTransform(c5), IUt(s) && IUt(c5) && (s.setStyle(c5.style), s.z = c5.z, s.z2 = c5.z2, s.zlevel = c5.zlevel, s.invisible = c5.invisible, s.ignore = c5.ignore, AUt(s) && AUt(c5) && s.setShape(c5.shape));
        }
        var Fqn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            this._progressiveEls = null;
            var A2 = this._data, k2 = r5.getData(), R6 = this.group, B3 = $Pe(r5, k2, g5, b6);
            A2 || R6.removeAll(), k2.diff(A2).add(function(Z3) {
              kUt(b6, null, Z3, B3(Z3, S2), r5, R6, k2);
            }).remove(function(Z3) {
              var X3 = A2.getItemGraphicEl(Z3);
              yCt(X3, DR(X3).option, r5);
            }).update(function(Z3, X3) {
              var tt = A2.getItemGraphicEl(X3);
              kUt(b6, tt, Z3, B3(Z3, S2), r5, R6, k2);
            }).execute();
            var G3 = r5.get("clip", true) ? WMt(r5.coordinateSystem, false, r5) : null;
            G3 ? R6.setClipPath(G3) : R6.removeClipPath(), this._data = k2;
          }, s.prototype.incrementalPrepareRender = function(r5, g5, b6) {
            this.group.removeAll(), this._data = null;
          }, s.prototype.incrementalRender = function(r5, g5, b6, S2, A2) {
            var k2 = g5.getData(), R6 = $Pe(g5, k2, b6, S2), B3 = this._progressiveEls = [];
            function G3(tt) {
              tt.isGroup || (tt.incremental = true, tt.ensureState("emphasis").hoverLayer = true);
            }
            for (var Z3 = r5.start; Z3 < r5.end; Z3++) {
              var X3 = kUt(null, null, Z3, R6(Z3, A2), g5, this.group, k2);
              X3 && (X3.traverse(G3), B3.push(X3));
            }
          }, s.prototype.eachRendered = function(r5) {
            Ik(this._progressiveEls || this.group, r5);
          }, s.prototype.filterForExposedEvent = function(r5, g5, b6, S2) {
            var A2 = g5.element;
            if (A2 == null || b6.name === A2)
              return true;
            for (; (b6 = b6.__hostTarget || b6.parent) && b6 !== this.group; )
              if (b6.name === A2)
                return true;
            return false;
          }, s.type = "custom", s;
        }(Ig2), Vqn = Fqn;
        function DUt(c5) {
          var s = c5.type, r5;
          if (s === "path") {
            var g5 = c5.shape, b6 = g5.width != null && g5.height != null ? { x: g5.x || 0, y: g5.y || 0, width: g5.width, height: g5.height } : null, S2 = JPe(g5);
            r5 = Xt(S2, null, b6, g5.layout || "center"), DR(r5).customPathData = S2;
          } else if (s === "image")
            r5 = new qm({}), DR(r5).customImagePath = c5.style.image;
          else if (s === "text")
            r5 = new hh2({});
          else if (s === "group")
            r5 = new nu();
          else {
            if (s === "compoundPath")
              throw new Error('"compoundPath" is not supported yet.');
            var A2 = St(s);
            if (!A2) {
              var k2 = "";
              rf2(k2);
            }
            r5 = new A2();
          }
          return DR(r5).customGraphicType = s, r5.name = c5.name, r5.z2EmphasisLift = 1, r5.z2SelectLift = 1, r5;
        }
        function EUt(c5, s, r5, g5, b6, S2, A2) {
          qPe(s);
          var k2 = b6 && b6.normal.cfg;
          k2 && s.setTextConfig(k2), g5 && g5.transition == null && (g5.transition = Lqn);
          var R6 = g5 && g5.style;
          if (R6) {
            if (s.type === "text") {
              var B3 = R6;
              Ls(B3, "textFill") && (B3.fill = B3.textFill), Ls(B3, "textStroke") && (B3.stroke = B3.textStroke);
            }
            var G3 = void 0, Z3 = AUt(s) ? R6.decal : null;
            c5 && Z3 && (Z3.dirty = true, G3 = mct(Z3, c5)), R6.__decalPattern = G3;
          }
          if (IUt(s) && R6) {
            var G3 = R6.__decalPattern;
            G3 && (R6.decal = G3);
          }
          vCt(s, g5, S2, { dataIndex: r5, isInit: A2, clearStyle: true }), mCt(s, g5.keyframeAnimation, S2);
        }
        function ZPe(c5, s, r5, g5, b6) {
          var S2 = s.isGroup ? null : s, A2 = b6 && b6[c5].cfg;
          if (S2) {
            var k2 = S2.ensureState(c5);
            if (g5 === false) {
              var R6 = S2.getState(c5);
              R6 && (R6.style = null);
            } else
              k2.style = g5 || null;
            A2 && (k2.textConfig = A2), MM(S2);
          }
        }
        function Bqn(c5, s, r5) {
          if (!c5.isGroup) {
            var g5 = c5, b6 = r5.currentZ, S2 = r5.currentZLevel;
            g5.z = b6, g5.zlevel = S2;
            var A2 = s.z2;
            A2 != null && (g5.z2 = A2 || 0);
            for (var k2 = 0; k2 < c9.length; k2++)
              zqn(g5, s, c9[k2]);
          }
        }
        function zqn(c5, s, r5) {
          var g5 = r5 === u9, b6 = g5 ? s : bCt(s, r5), S2 = b6 ? b6.z2 : null, A2;
          S2 != null && (A2 = g5 ? c5 : c5.ensureState(r5), A2.z2 = S2 || 0);
        }
        function $Pe(c5, s, r5, g5) {
          var b6 = c5.get("renderItem"), S2 = c5.coordinateSystem, A2 = {};
          S2 && (A2 = S2.prepareCustoms ? S2.prepareCustoms(S2) : Rqn[S2.type](S2));
          for (var k2 = Cl({ getWidth: g5.getWidth, getHeight: g5.getHeight, getZr: g5.getZr, getDevicePixelRatio: g5.getDevicePixelRatio, value: Ot, style: ae2, ordinalRawValue: ce2, styleEmphasis: de2, visual: Oe2, barLayout: je2, currentSeriesIndices: rn, font: qe2 }, A2.api || {}), R6 = { context: {}, seriesId: c5.id, seriesName: c5.name, seriesIndex: c5.seriesIndex, coordSys: A2.coordSys, dataInsideLength: s.count(), encode: jqn(c5.getData()) }, B3, G3, Z3 = {}, X3 = {}, tt = {}, it = {}, pt = 0; pt < c9.length; pt++) {
            var mt = c9[pt];
            tt[mt] = c5.getModel(CUt[mt]), it[mt] = c5.getModel(TUt[mt]);
          }
          function Mt(An) {
            return An === B3 ? G3 || (G3 = s.getItemModel(An)) : s.getItemModel(An);
          }
          function kt(An, jn) {
            return s.hasItemOption ? An === B3 ? Z3[jn] || (Z3[jn] = Mt(An).getModel(CUt[jn])) : Mt(An).getModel(CUt[jn]) : tt[jn];
          }
          function Gt(An, jn) {
            return s.hasItemOption ? An === B3 ? X3[jn] || (X3[jn] = Mt(An).getModel(TUt[jn])) : Mt(An).getModel(TUt[jn]) : it[jn];
          }
          return function(An, jn) {
            return B3 = An, G3 = null, Z3 = {}, X3 = {}, b6 && b6(Cl({ dataIndexInside: An, dataIndex: s.getRawIndex(An), actionType: jn ? jn.type : null }, R6), k2);
          };
          function Ot(An, jn) {
            return jn == null && (jn = B3), s.getStore().get(s.getDimensionIndex(An || 0), jn);
          }
          function ce2(An, jn) {
            jn == null && (jn = B3), An = An || 0;
            var _n = s.getDimensionInfo(An);
            if (!_n) {
              var Jr = s.getDimensionIndex(An);
              return Jr >= 0 ? s.getStore().get(Jr, jn) : void 0;
            }
            var Qn = s.get(_n.name, jn), rr = _n && _n.ordinalMeta;
            return rr ? rr.categories[Qn] : Qn;
          }
          function ae2(An, jn) {
            jn == null && (jn = B3);
            var _n = s.getItemVisual(jn, "style"), Jr = _n && _n.fill, Qn = _n && _n.opacity, rr = kt(jn, u9).getItemStyle();
            Jr != null && (rr.fill = Jr), Qn != null && (rr.opacity = Qn);
            var Ar = { inheritColor: gs(Jr) ? Jr : "#000" }, fi2 = Gt(jn, u9), mi2 = Ey(fi2, null, Ar, false, true);
            mi2.text = fi2.getShallow("show") ? tc2(c5.getFormattedLabel(jn, u9), wX(s, jn)) : null;
            var Oo = H2t(fi2, Ar, false);
            return Se2(An, rr), rr = VPe(rr, mi2, Oo), An && we2(rr, An), rr.legacy = true, rr;
          }
          function de2(An, jn) {
            jn == null && (jn = B3);
            var _n = kt(jn, ER).getItemStyle(), Jr = Gt(jn, ER), Qn = Ey(Jr, null, null, true, true);
            Qn.text = Jr.getShallow("show") ? pk2(c5.getFormattedLabel(jn, ER), c5.getFormattedLabel(jn, u9), wX(s, jn)) : null;
            var rr = H2t(Jr, null, true);
            return Se2(An, _n), _n = VPe(_n, Qn, rr), An && we2(_n, An), _n.legacy = true, _n;
          }
          function we2(An, jn) {
            for (var _n in jn)
              Ls(jn, _n) && (An[_n] = jn[_n]);
          }
          function Se2(An, jn) {
            An && (An.textFill && (jn.textFill = An.textFill), An.textPosition && (jn.textPosition = An.textPosition));
          }
          function Oe2(An, jn) {
            if (jn == null && (jn = B3), Ls(OPe, An)) {
              var _n = s.getItemVisual(jn, "style");
              return _n ? _n[OPe[An]] : null;
            }
            if (Ls(fqn, An))
              return s.getItemVisual(jn, An);
          }
          function je2(An) {
            if (S2.type === "cartesian2d") {
              var jn = S2.getBaseAxis();
              return W8n(Cl({ axis: jn }, An));
            }
          }
          function rn() {
            return r5.getCurrentSeriesIndices();
          }
          function qe2(An) {
            return RCe(An, r5);
          }
        }
        function jqn(c5) {
          var s = {};
          return Ye2(c5.dimensions, function(r5) {
            var g5 = c5.getDimensionInfo(r5);
            if (!g5.isExtraCoord) {
              var b6 = g5.coordDim, S2 = s[b6] = s[b6] || [];
              S2[g5.coordDimIndex] = c5.getDimensionIndex(r5);
            }
          }), s;
        }
        function kUt(c5, s, r5, g5, b6, S2, A2) {
          if (!g5) {
            S2.remove(s);
            return;
          }
          var k2 = PUt(c5, s, r5, g5, b6, S2);
          return k2 && A2.setItemGraphicEl(r5, k2), k2 && f0(k2, g5.focus, g5.blurScope, g5.emphasisDisabled), k2;
        }
        function PUt(c5, s, r5, g5, b6, S2) {
          var A2 = -1, k2 = s;
          s && YPe(s, g5, b6) && (A2 = Lu(S2.childrenRef(), s), s = null);
          var R6 = !s, B3 = s;
          B3 ? B3.clearStates() : (B3 = DUt(g5), k2 && Nqn(k2, B3)), g5.morph === false ? B3.disableMorphing = true : B3.disableMorphing && (B3.disableMorphing = false), iD.normal.cfg = iD.normal.conOpt = iD.emphasis.cfg = iD.emphasis.conOpt = iD.blur.cfg = iD.blur.conOpt = iD.select.cfg = iD.select.conOpt = null, iD.isLegacy = false, Gqn(B3, r5, g5, b6, R6, iD), Wqn(B3, r5, g5, b6, R6), EUt(c5, B3, r5, g5, iD, b6, R6), Ls(g5, "info") && (DR(B3).info = g5.info);
          for (var G3 = 0; G3 < c9.length; G3++) {
            var Z3 = c9[G3];
            if (Z3 !== u9) {
              var X3 = bCt(g5, Z3), tt = LUt(g5, X3, Z3);
              ZPe(Z3, B3, X3, tt, iD);
            }
          }
          return Bqn(B3, g5, b6), g5.type === "group" && Hqn(c5, B3, r5, g5, b6), A2 >= 0 ? S2.replaceAt(B3, A2) : S2.add(B3), B3;
        }
        function YPe(c5, s, r5) {
          var g5 = DR(c5), b6 = s.type, S2 = s.shape, A2 = s.style;
          return r5.isUniversalTransitionEnabled() || b6 != null && b6 !== g5.customGraphicType || b6 === "path" && Zqn(S2) && JPe(S2) !== g5.customPathData || b6 === "image" && Ls(A2, "image") && A2.image !== g5.customImagePath;
        }
        function Wqn(c5, s, r5, g5, b6) {
          var S2 = r5.clipPath;
          if (S2 === false)
            c5 && c5.getClipPath() && c5.removeClipPath();
          else if (S2) {
            var A2 = c5.getClipPath();
            A2 && YPe(A2, S2, g5) && (A2 = null), A2 || (A2 = DUt(S2), c5.setClipPath(A2)), EUt(null, A2, s, S2, null, g5, b6);
          }
        }
        function Gqn(c5, s, r5, g5, b6, S2) {
          if (!c5.isGroup) {
            KPe(r5, null, S2), KPe(r5, ER, S2);
            var A2 = S2.normal.conOpt, k2 = S2.emphasis.conOpt, R6 = S2.blur.conOpt, B3 = S2.select.conOpt;
            if (A2 != null || k2 != null || B3 != null || R6 != null) {
              var G3 = c5.getTextContent();
              if (A2 === false)
                G3 && c5.removeTextContent();
              else {
                A2 = S2.normal.conOpt = A2 || { type: "text" }, G3 ? G3.clearStates() : (G3 = DUt(A2), c5.setTextContent(G3)), EUt(null, G3, s, A2, null, g5, b6);
                for (var Z3 = A2 && A2.style, X3 = 0; X3 < c9.length; X3++) {
                  var tt = c9[X3];
                  if (tt !== u9) {
                    var it = S2[tt].conOpt;
                    ZPe(tt, G3, it, LUt(A2, it, tt), null);
                  }
                }
                Z3 ? G3.dirty() : G3.markRedraw();
              }
            }
          }
        }
        function KPe(c5, s, r5) {
          var g5 = s ? bCt(c5, s) : c5, b6 = s ? LUt(c5, g5, ER) : c5.style, S2 = c5.type, A2 = g5 ? g5.textConfig : null, k2 = c5.textContent, R6 = k2 ? s ? bCt(k2, s) : k2 : null;
          if (b6 && (r5.isLegacy || RPe(b6, S2, !!A2, !!R6))) {
            r5.isLegacy = true;
            var B3 = NPe(b6, S2, !s);
            !A2 && B3.textConfig && (A2 = B3.textConfig), !R6 && B3.textContent && (R6 = B3.textContent);
          }
          if (!s && R6) {
            var G3 = R6;
            !G3.type && (G3.type = "text");
          }
          var Z3 = s ? r5[s] : r5.normal;
          Z3.cfg = A2, Z3.conOpt = R6;
        }
        function bCt(c5, s) {
          return s ? c5 ? c5[s] : null : c5;
        }
        function LUt(c5, s, r5) {
          var g5 = s && s.style;
          return g5 == null && r5 === ER && c5 && (g5 = c5.styleEmphasis), g5;
        }
        function Hqn(c5, s, r5, g5, b6) {
          var S2 = g5.children, A2 = S2 ? S2.length : 0, k2 = g5.$mergeChildren, R6 = k2 === "byName" || g5.diffChildrenByName, B3 = k2 === false;
          if (!(!A2 && !R6 && !B3)) {
            if (R6) {
              Uqn({ api: c5, oldChildren: s.children() || [], newChildren: S2 || [], dataIndex: r5, seriesModel: b6, group: s });
              return;
            }
            B3 && s.removeAll();
            for (var G3 = 0; G3 < A2; G3++)
              S2[G3] && PUt(c5, s.childAt(G3), r5, S2[G3], b6, s);
            for (var Z3 = s.childCount() - 1; Z3 >= G3; Z3--) {
              var X3 = s.childAt(Z3);
              yCt(X3, DR(s).option, b6);
            }
          }
        }
        function Uqn(c5) {
          new wR(c5.oldChildren, c5.newChildren, XPe, XPe, c5).add(QPe).update(QPe).remove(qqn).execute();
        }
        function XPe(c5, s) {
          var r5 = c5 && c5.name;
          return r5 != null ? r5 : Oqn + s;
        }
        function QPe(c5, s) {
          var r5 = this.context, g5 = c5 != null ? r5.newChildren[c5] : null, b6 = s != null ? r5.oldChildren[s] : null;
          PUt(r5.api, b6, r5.dataIndex, g5, r5.seriesModel, r5.group);
        }
        function qqn(c5) {
          var s = this.context, r5 = s.oldChildren[c5];
          yCt(r5, DR(r5).option, s.seriesModel);
        }
        function JPe(c5) {
          return c5 && (c5.pathData || c5.d);
        }
        function Zqn(c5) {
          return c5 && (Ls(c5, "pathData") || Ls(c5, "d"));
        }
        function $qn(c5) {
          c5.registerChartView(Vqn), c5.registerSeriesModel(pqn);
        }
        var LW = Df2(), t3e = Ml, OUt = Cs, Yqn = function() {
          function c5() {
            this._dragging = false, this.animationThreshold = 15;
          }
          return c5.prototype.render = function(s, r5, g5, b6) {
            var S2 = r5.get("value"), A2 = r5.get("status");
            if (this._axisModel = s, this._axisPointerModel = r5, this._api = g5, !(!b6 && this._lastValue === S2 && this._lastStatus === A2)) {
              this._lastValue = S2, this._lastStatus = A2;
              var k2 = this._group, R6 = this._handle;
              if (!A2 || A2 === "hide") {
                k2 && k2.hide(), R6 && R6.hide();
                return;
              }
              k2 && k2.show(), R6 && R6.show();
              var B3 = {};
              this.makeElOption(B3, S2, s, r5, g5);
              var G3 = B3.graphicKey;
              G3 !== this._lastGraphicKey && this.clear(g5), this._lastGraphicKey = G3;
              var Z3 = this._moveAnimation = this.determineAnimation(s, r5);
              if (!k2)
                k2 = this._group = new nu(), this.createPointerEl(k2, B3, s, r5), this.createLabelEl(k2, B3, s, r5), g5.getZr().add(k2);
              else {
                var X3 = Au(e3e, r5, Z3);
                this.updatePointerEl(k2, B3, X3), this.updateLabelEl(k2, B3, X3, r5);
              }
              i3e(k2, r5, true), this._renderHandle(S2);
            }
          }, c5.prototype.remove = function(s) {
            this.clear(s);
          }, c5.prototype.dispose = function(s) {
            this.clear(s);
          }, c5.prototype.determineAnimation = function(s, r5) {
            var g5 = r5.get("animation"), b6 = s.axis, S2 = b6.type === "category", A2 = r5.get("snap");
            if (!A2 && !S2)
              return false;
            if (g5 === "auto" || g5 == null) {
              var k2 = this.animationThreshold;
              if (S2 && b6.getBandWidth() > k2)
                return true;
              if (A2) {
                var R6 = lHt(s).seriesDataCount, B3 = b6.getExtent();
                return Math.abs(B3[0] - B3[1]) / R6 > k2;
              }
              return false;
            }
            return g5 === true;
          }, c5.prototype.makeElOption = function(s, r5, g5, b6, S2) {
          }, c5.prototype.createPointerEl = function(s, r5, g5, b6) {
            var S2 = r5.pointer;
            if (S2) {
              var A2 = LW(s).pointerEl = new Jut[S2.type](t3e(r5.pointer));
              s.add(A2);
            }
          }, c5.prototype.createLabelEl = function(s, r5, g5, b6) {
            if (r5.label) {
              var S2 = LW(s).labelEl = new hh2(t3e(r5.label));
              s.add(S2), r3e(S2, b6);
            }
          }, c5.prototype.updatePointerEl = function(s, r5, g5) {
            var b6 = LW(s).pointerEl;
            b6 && r5.pointer && (b6.setStyle(r5.pointer.style), g5(b6, { shape: r5.pointer.shape }));
          }, c5.prototype.updateLabelEl = function(s, r5, g5, b6) {
            var S2 = LW(s).labelEl;
            S2 && (S2.setStyle(r5.label.style), g5(S2, { x: r5.label.x, y: r5.label.y }), r3e(S2, b6));
          }, c5.prototype._renderHandle = function(s) {
            if (!(this._dragging || !this.updateHandleTransform)) {
              var r5 = this._axisPointerModel, g5 = this._api.getZr(), b6 = this._handle, S2 = r5.getModel("handle"), A2 = r5.get("status");
              if (!S2.get("show") || !A2 || A2 === "hide") {
                b6 && g5.remove(b6), this._handle = null;
                return;
              }
              var k2;
              this._handle || (k2 = true, b6 = this._handle = ph2(S2.get("icon"), { cursor: "move", draggable: true, onmousemove: function(B3) {
                OI(B3.event);
              }, onmousedown: OUt(this._onHandleDragMove, this, 0, 0), drift: OUt(this._onHandleDragMove, this), ondragend: OUt(this._onHandleDragEnd, this) }), g5.add(b6)), i3e(b6, r5, false), b6.setStyle(S2.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
              var R6 = S2.get("size");
              ja2(R6) || (R6 = [R6, R6]), b6.scaleX = R6[0] / 2, b6.scaleY = R6[1] / 2, pX(this, "_doDispatchAxisPointer", S2.get("throttle") || 0, "fixRate"), this._moveHandleToValue(s, k2);
            }
          }, c5.prototype._moveHandleToValue = function(s, r5) {
            e3e(this._axisPointerModel, !r5 && this._moveAnimation, this._handle, RUt(this.getHandleTransform(s, this._axisModel, this._axisPointerModel)));
          }, c5.prototype._onHandleDragMove = function(s, r5) {
            var g5 = this._handle;
            if (g5) {
              this._dragging = true;
              var b6 = this.updateHandleTransform(RUt(g5), [s, r5], this._axisModel, this._axisPointerModel);
              this._payloadInfo = b6, g5.stopAnimation(), g5.attr(RUt(b6)), LW(g5).lastProp = null, this._doDispatchAxisPointer();
            }
          }, c5.prototype._doDispatchAxisPointer = function() {
            var s = this._handle;
            if (s) {
              var r5 = this._payloadInfo, g5 = this._axisModel;
              this._api.dispatchAction({ type: "updateAxisPointer", x: r5.cursorPoint[0], y: r5.cursorPoint[1], tooltipOption: r5.tooltipOption, axesInfo: [{ axisDim: g5.axis.dim, axisIndex: g5.componentIndex }] });
            }
          }, c5.prototype._onHandleDragEnd = function() {
            this._dragging = false;
            var s = this._handle;
            if (s) {
              var r5 = this._axisPointerModel.get("value");
              this._moveHandleToValue(r5), this._api.dispatchAction({ type: "hideTip" });
            }
          }, c5.prototype.clear = function(s) {
            this._lastValue = null, this._lastStatus = null;
            var r5 = s.getZr(), g5 = this._group, b6 = this._handle;
            r5 && g5 && (this._lastGraphicKey = null, g5 && r5.remove(g5), b6 && r5.remove(b6), this._group = null, this._handle = null, this._payloadInfo = null), hct(this, "_doDispatchAxisPointer");
          }, c5.prototype.doClear = function() {
          }, c5.prototype.buildLabel = function(s, r5, g5) {
            return g5 = g5 || 0, { x: s[g5], y: s[1 - g5], width: r5[g5], height: r5[1 - g5] };
          }, c5;
        }();
        function e3e(c5, s, r5, g5) {
          n3e(LW(r5).lastProp, g5) || (LW(r5).lastProp = g5, s ? Qf2(r5, g5, c5) : (r5.stopAnimation(), r5.attr(g5)));
        }
        function n3e(c5, s) {
          if (Wl(c5) && Wl(s)) {
            var r5 = true;
            return Ye2(s, function(g5, b6) {
              r5 = r5 && n3e(c5[b6], g5);
            }), !!r5;
          } else
            return c5 === s;
        }
        function r3e(c5, s) {
          c5[s.get(["label", "show"]) ? "show" : "hide"]();
        }
        function RUt(c5) {
          return { x: c5.x || 0, y: c5.y || 0, rotation: c5.rotation || 0 };
        }
        function i3e(c5, s, r5) {
          var g5 = s.get("z"), b6 = s.get("zlevel");
          c5 && c5.traverse(function(S2) {
            S2.type !== "group" && (g5 != null && (S2.z = g5), b6 != null && (S2.zlevel = b6), S2.silent = r5);
          });
        }
        var NUt = Yqn;
        function FUt(c5) {
          var s = c5.get("type"), r5 = c5.getModel(s + "Style"), g5;
          return s === "line" ? (g5 = r5.getLineStyle(), g5.fill = null) : s === "shadow" && (g5 = r5.getAreaStyle(), g5.stroke = null), g5;
        }
        function a3e(c5, s, r5, g5, b6) {
          var S2 = r5.get("value"), A2 = o3e(S2, s.axis, s.ecModel, r5.get("seriesDataIndices"), { precision: r5.get(["label", "precision"]), formatter: r5.get(["label", "formatter"]) }), k2 = r5.getModel("label"), R6 = aX(k2.get("padding") || 0), B3 = k2.getFont(), G3 = tR(A2, B3), Z3 = b6.position, X3 = G3.width + R6[1] + R6[3], tt = G3.height + R6[0] + R6[2], it = b6.align;
          it === "right" && (Z3[0] -= X3), it === "center" && (Z3[0] -= X3 / 2);
          var pt = b6.verticalAlign;
          pt === "bottom" && (Z3[1] -= tt), pt === "middle" && (Z3[1] -= tt / 2), Kqn(Z3, X3, tt, g5);
          var mt = k2.get("backgroundColor");
          (!mt || mt === "auto") && (mt = s.get(["axisLine", "lineStyle", "color"])), c5.label = { x: Z3[0], y: Z3[1], style: Ey(k2, { text: A2, font: B3, fill: k2.getTextColor(), padding: R6, backgroundColor: mt }), z2: 10 };
        }
        function Kqn(c5, s, r5, g5) {
          var b6 = g5.getWidth(), S2 = g5.getHeight();
          c5[0] = Math.min(c5[0] + s, b6) - s, c5[1] = Math.min(c5[1] + r5, S2) - r5, c5[0] = Math.max(c5[0], 0), c5[1] = Math.max(c5[1], 0);
        }
        function o3e(c5, s, r5, g5, b6) {
          c5 = s.scale.parse(c5);
          var S2 = s.scale.getLabel({ value: c5 }, { precision: b6.precision }), A2 = b6.formatter;
          if (A2) {
            var k2 = { value: EGt(s, { value: c5 }), axisDimension: s.dim, axisIndex: s.index, seriesData: [] };
            Ye2(g5, function(R6) {
              var B3 = r5.getSeriesByIndex(R6.seriesIndex), G3 = R6.dataIndexInside, Z3 = B3 && B3.getDataParams(G3);
              Z3 && k2.seriesData.push(Z3);
            }), gs(A2) ? S2 = A2.replace("{value}", S2) : Tl(A2) && (S2 = A2(k2));
          }
          return S2;
        }
        function VUt(c5, s, r5) {
          var g5 = bM();
          return f3(g5, g5, r5.rotation), _M(g5, g5, r5.position), Lo([c5.dataToCoord(s), (r5.labelOffset || 0) + (r5.labelDirection || 1) * (r5.labelMargin || 0)], g5);
        }
        function s3e(c5, s, r5, g5, b6, S2) {
          var A2 = TR.innerTextLayout(r5.rotation, 0, r5.labelDirection);
          r5.labelMargin = b6.get(["label", "margin"]), a3e(s, g5, b6, S2, { position: VUt(g5.axis, c5, r5), align: A2.textAlign, verticalAlign: A2.textVerticalAlign });
        }
        function BUt(c5, s, r5) {
          return r5 = r5 || 0, { x1: c5[r5], y1: c5[1 - r5], x2: s[r5], y2: s[1 - r5] };
        }
        function l3e(c5, s, r5) {
          return r5 = r5 || 0, { x: c5[r5], y: c5[1 - r5], width: s[r5], height: s[1 - r5] };
        }
        function u3e(c5, s, r5, g5, b6, S2) {
          return { cx: c5, cy: s, r0: r5, r: g5, startAngle: b6, endAngle: S2, clockwise: true };
        }
        var Xqn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.makeElOption = function(r5, g5, b6, S2, A2) {
            var k2 = b6.axis, R6 = k2.grid, B3 = S2.get("type"), G3 = c3e(R6, k2).getOtherAxis(k2).getGlobalExtent(), Z3 = k2.toGlobalCoord(k2.dataToCoord(g5, true));
            if (B3 && B3 !== "none") {
              var X3 = FUt(S2), tt = Qqn[B3](k2, Z3, G3);
              tt.style = X3, r5.graphicKey = tt.type, r5.pointer = tt;
            }
            var it = iHt(R6.model, b6);
            s3e(g5, r5, it, b6, S2, A2);
          }, s.prototype.getHandleTransform = function(r5, g5, b6) {
            var S2 = iHt(g5.axis.grid.model, g5, { labelInside: false });
            S2.labelMargin = b6.get(["handle", "margin"]);
            var A2 = VUt(g5.axis, r5, S2);
            return { x: A2[0], y: A2[1], rotation: S2.rotation + (S2.labelDirection < 0 ? Math.PI : 0) };
          }, s.prototype.updateHandleTransform = function(r5, g5, b6, S2) {
            var A2 = b6.axis, k2 = A2.grid, R6 = A2.getGlobalExtent(true), B3 = c3e(k2, A2).getOtherAxis(A2).getGlobalExtent(), G3 = A2.dim === "x" ? 0 : 1, Z3 = [r5.x, r5.y];
            Z3[G3] += g5[G3], Z3[G3] = Math.min(R6[1], Z3[G3]), Z3[G3] = Math.max(R6[0], Z3[G3]);
            var X3 = (B3[1] + B3[0]) / 2, tt = [X3, X3];
            tt[G3] = Z3[G3];
            var it = [{ verticalAlign: "middle" }, { align: "center" }];
            return { x: Z3[0], y: Z3[1], rotation: r5.rotation, cursorPoint: tt, tooltipOption: it[G3] };
          }, s;
        }(NUt);
        function c3e(c5, s) {
          var r5 = {};
          return r5[s.dim + "AxisIndex"] = s.index, c5.getCartesian(r5);
        }
        var Qqn = { line: function(c5, s, r5) {
          var g5 = BUt([s, r5[0]], [s, r5[1]], f3e(c5));
          return { type: "Line", subPixelOptimize: true, shape: g5 };
        }, shadow: function(c5, s, r5) {
          var g5 = Math.max(1, c5.getBandWidth()), b6 = r5[1] - r5[0];
          return { type: "Rect", shape: l3e([s - g5 / 2, r5[0]], [g5, b6], f3e(c5)) };
        } };
        function f3e(c5) {
          return c5.dim === "x" ? 0 : 1;
        }
        var Jqn = Xqn, tZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "axisPointer", s.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, s;
        }(Rh2), eZn = tZn, kR = Df2(), nZn = Ye2;
        function h3e(c5, s, r5) {
          if (!os.node) {
            var g5 = s.getZr();
            kR(g5).records || (kR(g5).records = {}), rZn(g5, s);
            var b6 = kR(g5).records[c5] || (kR(g5).records[c5] = {});
            b6.handler = r5;
          }
        }
        function rZn(c5, s) {
          if (kR(c5).initialized)
            return;
          kR(c5).initialized = true, r5("click", Au(p3e, "click")), r5("mousemove", Au(p3e, "mousemove")), r5("globalout", aZn);
          function r5(g5, b6) {
            c5.on(g5, function(S2) {
              var A2 = oZn(s);
              nZn(kR(c5).records, function(k2) {
                k2 && b6(k2, S2, A2.dispatchAction);
              }), iZn(A2.pendings, s);
            });
          }
        }
        function iZn(c5, s) {
          var r5 = c5.showTip.length, g5 = c5.hideTip.length, b6;
          r5 ? b6 = c5.showTip[r5 - 1] : g5 && (b6 = c5.hideTip[g5 - 1]), b6 && (b6.dispatchAction = null, s.dispatchAction(b6));
        }
        function aZn(c5, s, r5) {
          c5.handler("leave", null, r5);
        }
        function p3e(c5, s, r5, g5) {
          s.handler(c5, r5, g5);
        }
        function oZn(c5) {
          var s = { showTip: [], hideTip: [] }, r5 = function(g5) {
            var b6 = s[g5.type];
            b6 ? b6.push(g5) : (g5.dispatchAction = r5, c5.dispatchAction(g5));
          };
          return { dispatchAction: r5, pendings: s };
        }
        function zUt(c5, s) {
          if (!os.node) {
            var r5 = s.getZr(), g5 = (kR(r5).records || {})[c5];
            g5 && (kR(r5).records[c5] = null);
          }
        }
        var sZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = g5.getComponent("tooltip"), A2 = r5.get("triggerOn") || S2 && S2.get("triggerOn") || "mousemove|click";
            h3e("axisPointer", b6, function(k2, R6, B3) {
              A2 !== "none" && (k2 === "leave" || A2.indexOf(k2) >= 0) && B3({ type: "updateAxisPointer", currTrigger: k2, x: R6 && R6.offsetX, y: R6 && R6.offsetY });
            });
          }, s.prototype.remove = function(r5, g5) {
            zUt("axisPointer", g5);
          }, s.prototype.dispose = function(r5, g5) {
            zUt("axisPointer", g5);
          }, s.type = "axisPointer", s;
        }(P0), lZn = sZn;
        function d3e(c5, s) {
          var r5 = [], g5 = c5.seriesIndex, b6;
          if (g5 == null || !(b6 = s.getSeriesByIndex(g5)))
            return { point: [] };
          var S2 = b6.getData(), A2 = nR(S2, c5);
          if (A2 == null || A2 < 0 || ja2(A2))
            return { point: [] };
          var k2 = S2.getItemGraphicEl(A2), R6 = b6.coordinateSystem;
          if (b6.getTooltipPosition)
            r5 = b6.getTooltipPosition(A2) || [];
          else if (R6 && R6.dataToPoint)
            if (c5.isStacked) {
              var B3 = R6.getBaseAxis(), G3 = R6.getOtherAxis(B3), Z3 = G3.dim, X3 = B3.dim, tt = Z3 === "x" || Z3 === "radius" ? 1 : 0, it = S2.mapDimension(X3), pt = [];
              pt[tt] = S2.get(it, A2), pt[1 - tt] = S2.get(S2.getCalculationInfo("stackResultDimension"), A2), r5 = R6.dataToPoint(pt) || [];
            } else
              r5 = R6.dataToPoint(S2.getValues(Ha2(R6.dimensions, function(Mt) {
                return S2.mapDimension(Mt);
              }), A2)) || [];
          else if (k2) {
            var mt = k2.getBoundingRect().clone();
            mt.applyTransform(k2.transform), r5 = [mt.x + mt.width / 2, mt.y + mt.height / 2];
          }
          return { point: r5, el: k2 };
        }
        var g3e = Df2();
        function uZn(c5, s, r5) {
          var g5 = c5.currTrigger, b6 = [c5.x, c5.y], S2 = c5, A2 = c5.dispatchAction || Cs(r5.dispatchAction, r5), k2 = s.getComponent("axisPointer").coordSysAxesInfo;
          if (k2) {
            _Ct(b6) && (b6 = d3e({ seriesIndex: S2.seriesIndex, dataIndex: S2.dataIndex }, s).point);
            var R6 = _Ct(b6), B3 = S2.axesInfo, G3 = k2.axesInfo, Z3 = g5 === "leave" || _Ct(b6), X3 = {}, tt = {}, it = { list: [], map: {} }, pt = { showPointer: Au(fZn, tt), showTooltip: Au(hZn, it) };
            Ye2(k2.coordSysMap, function(Mt, kt) {
              var Gt = R6 || Mt.containPoint(b6);
              Ye2(k2.coordSysAxesInfo[kt], function(Ot, ce2) {
                var ae2 = Ot.axis, de2 = vZn(B3, Ot);
                if (!Z3 && Gt && (!B3 || de2)) {
                  var we2 = de2 && de2.value;
                  we2 == null && !R6 && (we2 = ae2.pointToData(b6)), we2 != null && v3e(Ot, we2, pt, false, X3);
                }
              });
            });
            var mt = {};
            return Ye2(G3, function(Mt, kt) {
              var Gt = Mt.linkGroup;
              Gt && !tt[kt] && Ye2(Gt.axesInfo, function(Ot, ce2) {
                var ae2 = tt[ce2];
                if (Ot !== Mt && ae2) {
                  var de2 = ae2.value;
                  Gt.mapper && (de2 = Mt.axis.scale.parse(Gt.mapper(de2, y3e(Ot), y3e(Mt)))), mt[Mt.key] = de2;
                }
              });
            }), Ye2(mt, function(Mt, kt) {
              v3e(G3[kt], Mt, pt, true, X3);
            }), pZn(tt, G3, X3), dZn(it, b6, c5, A2), gZn(G3, A2, r5), X3;
          }
        }
        function v3e(c5, s, r5, g5, b6) {
          var S2 = c5.axis;
          if (!(S2.scale.isBlank() || !S2.containData(s))) {
            if (!c5.involveSeries) {
              r5.showPointer(c5, s);
              return;
            }
            var A2 = cZn(s, c5), k2 = A2.payloadBatch, R6 = A2.snapToValue;
            k2[0] && b6.seriesIndex == null && sa2(b6, k2[0]), !g5 && c5.snap && S2.containData(R6) && R6 != null && (s = R6), r5.showPointer(c5, s, k2), r5.showTooltip(c5, A2, R6);
          }
        }
        function cZn(c5, s) {
          var r5 = s.axis, g5 = r5.dim, b6 = c5, S2 = [], A2 = Number.MAX_VALUE, k2 = -1;
          return Ye2(s.seriesModels, function(R6, B3) {
            var G3 = R6.getData().mapDimensionsAll(g5), Z3, X3;
            if (R6.getAxisTooltipData) {
              var tt = R6.getAxisTooltipData(G3, c5, r5);
              X3 = tt.dataIndices, Z3 = tt.nestestValue;
            } else {
              if (X3 = R6.getData().indicesOfNearest(G3[0], c5, r5.type === "category" ? 0.5 : null), !X3.length)
                return;
              Z3 = R6.getData().get(G3[0], X3[0]);
            }
            if (!(Z3 == null || !isFinite(Z3))) {
              var it = c5 - Z3, pt = Math.abs(it);
              pt <= A2 && ((pt < A2 || it >= 0 && k2 < 0) && (A2 = pt, k2 = it, b6 = Z3, S2.length = 0), Ye2(X3, function(mt) {
                S2.push({ seriesIndex: R6.seriesIndex, dataIndexInside: mt, dataIndex: R6.getData().getRawIndex(mt) });
              }));
            }
          }), { payloadBatch: S2, snapToValue: b6 };
        }
        function fZn(c5, s, r5, g5) {
          c5[s.key] = { value: r5, payloadBatch: g5 };
        }
        function hZn(c5, s, r5, g5) {
          var b6 = r5.payloadBatch, S2 = s.axis, A2 = S2.model, k2 = s.axisPointerModel;
          if (!(!s.triggerTooltip || !b6.length)) {
            var R6 = s.coordSys.model, B3 = Wct(R6), G3 = c5.map[B3];
            G3 || (G3 = c5.map[B3] = { coordSysId: R6.id, coordSysIndex: R6.componentIndex, coordSysType: R6.type, coordSysMainType: R6.mainType, dataByAxis: [] }, c5.list.push(G3)), G3.dataByAxis.push({ axisDim: S2.dim, axisIndex: A2.componentIndex, axisType: A2.type, axisId: A2.id, value: g5, valueLabelOpt: { precision: k2.get(["label", "precision"]), formatter: k2.get(["label", "formatter"]) }, seriesDataIndices: b6.slice() });
          }
        }
        function pZn(c5, s, r5) {
          var g5 = r5.axesInfo = [];
          Ye2(s, function(b6, S2) {
            var A2 = b6.axisPointerModel.option, k2 = c5[S2];
            k2 ? (!b6.useHandle && (A2.status = "show"), A2.value = k2.value, A2.seriesDataIndices = (k2.payloadBatch || []).slice()) : !b6.useHandle && (A2.status = "hide"), A2.status === "show" && g5.push({ axisDim: b6.axis.dim, axisIndex: b6.axis.model.componentIndex, value: A2.value });
          });
        }
        function dZn(c5, s, r5, g5) {
          if (_Ct(s) || !c5.list.length) {
            g5({ type: "hideTip" });
            return;
          }
          var b6 = ((c5.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
          g5({ type: "showTip", escapeConnect: true, x: s[0], y: s[1], tooltipOption: r5.tooltipOption, position: r5.position, dataIndexInside: b6.dataIndexInside, dataIndex: b6.dataIndex, seriesIndex: b6.seriesIndex, dataByCoordSys: c5.list });
        }
        function gZn(c5, s, r5) {
          var g5 = r5.getZr(), b6 = "axisPointerLastHighlights", S2 = g3e(g5)[b6] || {}, A2 = g3e(g5)[b6] = {};
          Ye2(c5, function(B3, G3) {
            var Z3 = B3.axisPointerModel.option;
            Z3.status === "show" && Ye2(Z3.seriesDataIndices, function(X3) {
              var tt = X3.seriesIndex + " | " + X3.dataIndex;
              A2[tt] = X3;
            });
          });
          var k2 = [], R6 = [];
          Ye2(S2, function(B3, G3) {
            !A2[G3] && R6.push(B3);
          }), Ye2(A2, function(B3, G3) {
            !S2[G3] && k2.push(B3);
          }), R6.length && r5.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: R6 }), k2.length && r5.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: k2 });
        }
        function vZn(c5, s) {
          for (var r5 = 0; r5 < (c5 || []).length; r5++) {
            var g5 = c5[r5];
            if (s.axis.dim === g5.axisDim && s.axis.model.componentIndex === g5.axisIndex)
              return g5;
          }
        }
        function y3e(c5) {
          var s = c5.axis.model, r5 = {}, g5 = r5.axisDim = c5.axis.dim;
          return r5.axisIndex = r5[g5 + "AxisIndex"] = s.componentIndex, r5.axisName = r5[g5 + "AxisName"] = s.name, r5.axisId = r5[g5 + "AxisId"] = s.id, r5;
        }
        function _Ct(c5) {
          return !c5 || c5[0] == null || isNaN(c5[0]) || c5[1] == null || isNaN(c5[1]);
        }
        function oft(c5) {
          SW.registerAxisPointerClass("CartesianAxisPointer", Jqn), c5.registerComponentModel(eZn), c5.registerComponentView(lZn), c5.registerPreprocessor(function(s) {
            if (s) {
              (!s.axisPointer || s.axisPointer.length === 0) && (s.axisPointer = {});
              var r5 = s.axisPointer.link;
              r5 && !ja2(r5) && (s.axisPointer.link = [r5]);
            }
          }), c5.registerProcessor(c5.PRIORITY.PROCESSOR.STATISTIC, function(s, r5) {
            s.getComponent("axisPointer").coordSysAxesInfo = iBn(s, r5);
          }), c5.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, uZn);
        }
        function yZn(c5) {
          Fc2(qEe), Fc2(oft);
        }
        var mZn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.makeElOption = function(r5, g5, b6, S2, A2) {
            var k2 = b6.axis;
            k2.dim === "angle" && (this.animationThreshold = Math.PI / 18);
            var R6 = k2.polar, B3 = R6.getOtherAxis(k2), G3 = B3.getExtent(), Z3 = k2.dataToCoord(g5), X3 = S2.get("type");
            if (X3 && X3 !== "none") {
              var tt = FUt(S2), it = _Zn[X3](k2, R6, Z3, G3);
              it.style = tt, r5.graphicKey = it.type, r5.pointer = it;
            }
            var pt = S2.get(["label", "margin"]), mt = bZn(g5, b6, S2, R6, pt);
            a3e(r5, b6, S2, A2, mt);
          }, s;
        }(NUt);
        function bZn(c5, s, r5, g5, b6) {
          var S2 = s.axis, A2 = S2.dataToCoord(c5), k2 = g5.getAngleAxis().getExtent()[0];
          k2 = k2 / 180 * Math.PI;
          var R6 = g5.getRadiusAxis().getExtent(), B3, G3, Z3;
          if (S2.dim === "radius") {
            var X3 = bM();
            f3(X3, X3, k2), _M(X3, X3, [g5.cx, g5.cy]), B3 = Lo([A2, -b6], X3);
            var tt = s.getModel("axisLabel").get("rotate") || 0, it = TR.innerTextLayout(k2, tt * Math.PI / 180, -1);
            G3 = it.textAlign, Z3 = it.textVerticalAlign;
          } else {
            var pt = R6[1];
            B3 = g5.coordToPoint([pt + b6, A2]);
            var mt = g5.cx, Mt = g5.cy;
            G3 = Math.abs(B3[0] - mt) / pt < 0.3 ? "center" : B3[0] > mt ? "left" : "right", Z3 = Math.abs(B3[1] - Mt) / pt < 0.3 ? "middle" : B3[1] > Mt ? "top" : "bottom";
          }
          return { position: B3, align: G3, verticalAlign: Z3 };
        }
        var _Zn = { line: function(c5, s, r5, g5) {
          return c5.dim === "angle" ? { type: "Line", shape: BUt(s.coordToPoint([g5[0], r5]), s.coordToPoint([g5[1], r5])) } : { type: "Circle", shape: { cx: s.cx, cy: s.cy, r: r5 } };
        }, shadow: function(c5, s, r5, g5) {
          var b6 = Math.max(1, c5.getBandWidth()), S2 = Math.PI / 180;
          return c5.dim === "angle" ? { type: "Sector", shape: u3e(s.cx, s.cy, g5[0], g5[1], (-r5 - b6 / 2) * S2, (-r5 + b6 / 2) * S2) } : { type: "Sector", shape: u3e(s.cx, s.cy, r5 - b6 / 2, r5 + b6 / 2, 0, Math.PI * 2) };
        } }, xZn = mZn, wZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.findAxisModel = function(r5) {
            var g5, b6 = this.ecModel;
            return b6.eachComponent(r5, function(S2) {
              S2.getCoordSysModel() === this && (g5 = S2);
            }, this), g5;
          }, s.type = "polar", s.dependencies = ["radiusAxis", "angleAxis"], s.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, s;
        }(Rh2), SZn = wZn, jUt = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.getCoordSysModel = function() {
            return this.getReferringComponents("polar", E0).models[0];
          }, s.type = "polarAxis", s;
        }(Rh2);
        A0(jUt, Ect);
        var MZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "angleAxis", s;
        }(jUt), CZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "radiusAxis", s;
        }(jUt), WUt = function(c5) {
          wn(s, c5);
          function s(r5, g5) {
            return c5.call(this, "radius", r5, g5) || this;
          }
          return s.prototype.pointToData = function(r5, g5) {
            return this.polar.pointToData(r5, g5)[this.dim === "radius" ? 0 : 1];
          }, s;
        }(kk2);
        WUt.prototype.dataToRadius = kk2.prototype.dataToCoord, WUt.prototype.radiusToData = kk2.prototype.coordToData;
        var TZn = WUt, AZn = Df2(), GUt = function(c5) {
          wn(s, c5);
          function s(r5, g5) {
            return c5.call(this, "angle", r5, g5 || [0, 360]) || this;
          }
          return s.prototype.pointToData = function(r5, g5) {
            return this.polar.pointToData(r5, g5)[this.dim === "radius" ? 0 : 1];
          }, s.prototype.calculateCategoryInterval = function() {
            var r5 = this, g5 = r5.getLabelModel(), b6 = r5.scale, S2 = b6.getExtent(), A2 = b6.count();
            if (S2[1] - S2[0] < 1)
              return 0;
            var k2 = S2[0], R6 = r5.dataToCoord(k2 + 1) - r5.dataToCoord(k2), B3 = Math.abs(R6), G3 = tR(k2 == null ? "" : k2 + "", g5.getFont(), "center", "top"), Z3 = Math.max(G3.height, 7), X3 = Z3 / B3;
            isNaN(X3) && (X3 = 1 / 0);
            var tt = Math.max(0, Math.floor(X3)), it = AZn(r5.model), pt = it.lastAutoInterval, mt = it.lastTickCount;
            return pt != null && mt != null && Math.abs(pt - tt) <= 1 && Math.abs(mt - A2) <= 1 && pt > tt ? tt = pt : (it.lastTickCount = A2, it.lastAutoInterval = tt), tt;
          }, s;
        }(kk2);
        GUt.prototype.dataToAngle = kk2.prototype.dataToCoord, GUt.prototype.angleToData = kk2.prototype.coordToData;
        var IZn = GUt, m3e = ["radius", "angle"], DZn = function() {
          function c5(s) {
            this.dimensions = m3e, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new TZn(), this._angleAxis = new IZn(), this.axisPointerEnabled = true, this.name = s || "", this._radiusAxis.polar = this._angleAxis.polar = this;
          }
          return c5.prototype.containPoint = function(s) {
            var r5 = this.pointToCoord(s);
            return this._radiusAxis.contain(r5[0]) && this._angleAxis.contain(r5[1]);
          }, c5.prototype.containData = function(s) {
            return this._radiusAxis.containData(s[0]) && this._angleAxis.containData(s[1]);
          }, c5.prototype.getAxis = function(s) {
            var r5 = "_" + s + "Axis";
            return this[r5];
          }, c5.prototype.getAxes = function() {
            return [this._radiusAxis, this._angleAxis];
          }, c5.prototype.getAxesByScale = function(s) {
            var r5 = [], g5 = this._angleAxis, b6 = this._radiusAxis;
            return g5.scale.type === s && r5.push(g5), b6.scale.type === s && r5.push(b6), r5;
          }, c5.prototype.getAngleAxis = function() {
            return this._angleAxis;
          }, c5.prototype.getRadiusAxis = function() {
            return this._radiusAxis;
          }, c5.prototype.getOtherAxis = function(s) {
            var r5 = this._angleAxis;
            return s === r5 ? this._radiusAxis : r5;
          }, c5.prototype.getBaseAxis = function() {
            return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
          }, c5.prototype.getTooltipAxes = function(s) {
            var r5 = s != null && s !== "auto" ? this.getAxis(s) : this.getBaseAxis();
            return { baseAxes: [r5], otherAxes: [this.getOtherAxis(r5)] };
          }, c5.prototype.dataToPoint = function(s, r5) {
            return this.coordToPoint([this._radiusAxis.dataToRadius(s[0], r5), this._angleAxis.dataToAngle(s[1], r5)]);
          }, c5.prototype.pointToData = function(s, r5) {
            var g5 = this.pointToCoord(s);
            return [this._radiusAxis.radiusToData(g5[0], r5), this._angleAxis.angleToData(g5[1], r5)];
          }, c5.prototype.pointToCoord = function(s) {
            var r5 = s[0] - this.cx, g5 = s[1] - this.cy, b6 = this.getAngleAxis(), S2 = b6.getExtent(), A2 = Math.min(S2[0], S2[1]), k2 = Math.max(S2[0], S2[1]);
            b6.inverse ? A2 = k2 - 360 : k2 = A2 + 360;
            var R6 = Math.sqrt(r5 * r5 + g5 * g5);
            r5 /= R6, g5 /= R6;
            for (var B3 = Math.atan2(-g5, r5) / Math.PI * 180, G3 = B3 < A2 ? 1 : -1; B3 < A2 || B3 > k2; )
              B3 += G3 * 360;
            return [R6, B3];
          }, c5.prototype.coordToPoint = function(s) {
            var r5 = s[0], g5 = s[1] / 180 * Math.PI, b6 = Math.cos(g5) * r5 + this.cx, S2 = -Math.sin(g5) * r5 + this.cy;
            return [b6, S2];
          }, c5.prototype.getArea = function() {
            var s = this.getAngleAxis(), r5 = this.getRadiusAxis(), g5 = r5.getExtent().slice();
            g5[0] > g5[1] && g5.reverse();
            var b6 = s.getExtent(), S2 = Math.PI / 180;
            return { cx: this.cx, cy: this.cy, r0: g5[0], r: g5[1], startAngle: -b6[0] * S2, endAngle: -b6[1] * S2, clockwise: s.inverse, contain: function(A2, k2) {
              var R6 = A2 - this.cx, B3 = k2 - this.cy, G3 = R6 * R6 + B3 * B3 - 1e-4, Z3 = this.r, X3 = this.r0;
              return G3 <= Z3 * Z3 && G3 >= X3 * X3;
            } };
          }, c5.prototype.convertToPixel = function(s, r5, g5) {
            var b6 = b3e(r5);
            return b6 === this ? this.dataToPoint(g5) : null;
          }, c5.prototype.convertFromPixel = function(s, r5, g5) {
            var b6 = b3e(r5);
            return b6 === this ? this.pointToData(g5) : null;
          }, c5;
        }();
        function b3e(c5) {
          var s = c5.seriesModel, r5 = c5.polarModel;
          return r5 && r5.coordinateSystem || s && s.coordinateSystem;
        }
        var EZn = DZn;
        function kZn(c5, s, r5) {
          var g5 = s.get("center"), b6 = r5.getWidth(), S2 = r5.getHeight();
          c5.cx = $o(g5[0], b6), c5.cy = $o(g5[1], S2);
          var A2 = c5.getRadiusAxis(), k2 = Math.min(b6, S2) / 2, R6 = s.get("radius");
          R6 == null ? R6 = [0, "100%"] : ja2(R6) || (R6 = [0, R6]);
          var B3 = [$o(R6[0], k2), $o(R6[1], k2)];
          A2.inverse ? A2.setExtent(B3[1], B3[0]) : A2.setExtent(B3[0], B3[1]);
        }
        function PZn(c5, s) {
          var r5 = this, g5 = r5.getAngleAxis(), b6 = r5.getRadiusAxis();
          if (g5.scale.setExtent(1 / 0, -1 / 0), b6.scale.setExtent(1 / 0, -1 / 0), c5.eachSeries(function(k2) {
            if (k2.coordinateSystem === r5) {
              var R6 = k2.getData();
              Ye2(OMt(R6, "radius"), function(B3) {
                b6.scale.unionExtentFromData(R6, B3);
              }), Ye2(OMt(R6, "angle"), function(B3) {
                g5.scale.unionExtentFromData(R6, B3);
              });
            }
          }), _X(g5.scale, g5.model), _X(b6.scale, b6.model), g5.type === "category" && !g5.onBand) {
            var S2 = g5.getExtent(), A2 = 360 / g5.scale.count();
            g5.inverse ? S2[1] += A2 : S2[1] -= A2, g5.setExtent(S2[0], S2[1]);
          }
        }
        function LZn(c5) {
          return c5.mainType === "angleAxis";
        }
        function _3e(c5, s) {
          if (c5.type = s.get("type"), c5.scale = LMt(s), c5.onBand = s.get("boundaryGap") && c5.type === "category", c5.inverse = s.get("inverse"), LZn(s)) {
            c5.inverse = c5.inverse !== s.get("clockwise");
            var r5 = s.get("startAngle");
            c5.setExtent(r5, r5 + (c5.inverse ? -360 : 360));
          }
          s.axis = c5, c5.model = s;
        }
        var OZn = { dimensions: m3e, create: function(c5, s) {
          var r5 = [];
          return c5.eachComponent("polar", function(g5, b6) {
            var S2 = new EZn(b6 + "");
            S2.update = PZn;
            var A2 = S2.getRadiusAxis(), k2 = S2.getAngleAxis(), R6 = g5.findAxisModel("radiusAxis"), B3 = g5.findAxisModel("angleAxis");
            _3e(A2, R6), _3e(k2, B3), kZn(S2, g5, s), r5.push(S2), g5.coordinateSystem = S2, S2.model = g5;
          }), c5.eachSeries(function(g5) {
            if (g5.get("coordinateSystem") === "polar") {
              var b6 = g5.getReferringComponents("polar", E0).models[0];
              g5.coordinateSystem = b6.coordinateSystem;
            }
          }), r5;
        } }, RZn = OZn, NZn = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
        function xCt(c5, s, r5) {
          s[1] > s[0] && (s = s.slice().reverse());
          var g5 = c5.coordToPoint([s[0], r5]), b6 = c5.coordToPoint([s[1], r5]);
          return { x1: g5[0], y1: g5[1], x2: b6[0], y2: b6[1] };
        }
        function wCt(c5) {
          var s = c5.getRadiusAxis();
          return s.inverse ? 0 : 1;
        }
        function x3e(c5) {
          var s = c5[0], r5 = c5[c5.length - 1];
          s && r5 && Math.abs(Math.abs(s.coord - r5.coord) - 360) < 1e-4 && c5.pop();
        }
        var FZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.axisPointerClass = "PolarAxisPointer", r5;
          }
          return s.prototype.render = function(r5, g5) {
            if (this.group.removeAll(), !!r5.get("show")) {
              var b6 = r5.axis, S2 = b6.polar, A2 = S2.getRadiusAxis().getExtent(), k2 = b6.getTicksCoords(), R6 = b6.getMinorTicksCoords(), B3 = Ha2(b6.getViewLabels(), function(G3) {
                G3 = Ml(G3);
                var Z3 = b6.scale, X3 = Z3.type === "ordinal" ? Z3.getRawOrdinalNumber(G3.tickValue) : G3.tickValue;
                return G3.coord = b6.dataToCoord(X3), G3;
              });
              x3e(B3), x3e(k2), Ye2(NZn, function(G3) {
                r5.get([G3, "show"]) && (!b6.scale.isBlank() || G3 === "axisLine") && VZn[G3](this.group, r5, S2, k2, R6, A2, B3);
              }, this);
            }
          }, s.type = "angleAxis", s;
        }(SW), VZn = { axisLine: function(c5, s, r5, g5, b6, S2) {
          var A2 = s.getModel(["axisLine", "lineStyle"]), k2 = wCt(r5), R6 = k2 ? 0 : 1, B3;
          S2[R6] === 0 ? B3 = new qI({ shape: { cx: r5.cx, cy: r5.cy, r: S2[k2] }, style: A2.getLineStyle(), z2: 1, silent: true }) : B3 = new ZK({ shape: { cx: r5.cx, cy: r5.cy, r: S2[k2], r0: S2[R6] }, style: A2.getLineStyle(), z2: 1, silent: true }), B3.style.fill = null, c5.add(B3);
        }, axisTick: function(c5, s, r5, g5, b6, S2) {
          var A2 = s.getModel("axisTick"), k2 = (A2.get("inside") ? -1 : 1) * A2.get("length"), R6 = S2[wCt(r5)], B3 = Ha2(g5, function(G3) {
            return new Zm({ shape: xCt(r5, [R6, R6 + k2], G3.coord) });
          });
          c5.add(Wn(B3, { style: Cl(A2.getModel("lineStyle").getLineStyle(), { stroke: s.get(["axisLine", "lineStyle", "color"]) }) }));
        }, minorTick: function(c5, s, r5, g5, b6, S2) {
          if (b6.length) {
            for (var A2 = s.getModel("axisTick"), k2 = s.getModel("minorTick"), R6 = (A2.get("inside") ? -1 : 1) * k2.get("length"), B3 = S2[wCt(r5)], G3 = [], Z3 = 0; Z3 < b6.length; Z3++)
              for (var X3 = 0; X3 < b6[Z3].length; X3++)
                G3.push(new Zm({ shape: xCt(r5, [B3, B3 + R6], b6[Z3][X3].coord) }));
            c5.add(Wn(G3, { style: Cl(k2.getModel("lineStyle").getLineStyle(), Cl(A2.getLineStyle(), { stroke: s.get(["axisLine", "lineStyle", "color"]) })) }));
          }
        }, axisLabel: function(c5, s, r5, g5, b6, S2, A2) {
          var k2 = s.getCategories(true), R6 = s.getModel("axisLabel"), B3 = R6.get("margin"), G3 = s.get("triggerEvent");
          Ye2(A2, function(Z3, X3) {
            var tt = R6, it = Z3.tickValue, pt = S2[wCt(r5)], mt = r5.coordToPoint([pt + B3, Z3.coord]), Mt = r5.cx, kt = r5.cy, Gt = Math.abs(mt[0] - Mt) / pt < 0.3 ? "center" : mt[0] > Mt ? "left" : "right", Ot = Math.abs(mt[1] - kt) / pt < 0.3 ? "middle" : mt[1] > kt ? "top" : "bottom";
            if (k2 && k2[it]) {
              var ce2 = k2[it];
              Wl(ce2) && ce2.textStyle && (tt = new Ag2(ce2.textStyle, R6, R6.ecModel));
            }
            var ae2 = new hh2({ silent: TR.isLabelSilent(s), style: Ey(tt, { x: mt[0], y: mt[1], fill: tt.getTextColor() || s.get(["axisLine", "lineStyle", "color"]), text: Z3.formattedLabel, align: Gt, verticalAlign: Ot }) });
            if (c5.add(ae2), G3) {
              var de2 = TR.makeAxisEventDataBase(s);
              de2.targetType = "axisLabel", de2.value = Z3.rawLabel, Pl(ae2).eventData = de2;
            }
          }, this);
        }, splitLine: function(c5, s, r5, g5, b6, S2) {
          var A2 = s.getModel("splitLine"), k2 = A2.getModel("lineStyle"), R6 = k2.get("color"), B3 = 0;
          R6 = R6 instanceof Array ? R6 : [R6];
          for (var G3 = [], Z3 = 0; Z3 < g5.length; Z3++) {
            var X3 = B3++ % R6.length;
            G3[X3] = G3[X3] || [], G3[X3].push(new Zm({ shape: xCt(r5, S2, g5[Z3].coord) }));
          }
          for (var Z3 = 0; Z3 < G3.length; Z3++)
            c5.add(Wn(G3[Z3], { style: Cl({ stroke: R6[Z3 % R6.length] }, k2.getLineStyle()), silent: true, z: s.get("z") }));
        }, minorSplitLine: function(c5, s, r5, g5, b6, S2) {
          if (b6.length) {
            for (var A2 = s.getModel("minorSplitLine"), k2 = A2.getModel("lineStyle"), R6 = [], B3 = 0; B3 < b6.length; B3++)
              for (var G3 = 0; G3 < b6[B3].length; G3++)
                R6.push(new Zm({ shape: xCt(r5, S2, b6[B3][G3].coord) }));
            c5.add(Wn(R6, { style: k2.getLineStyle(), silent: true, z: s.get("z") }));
          }
        }, splitArea: function(c5, s, r5, g5, b6, S2) {
          if (g5.length) {
            var A2 = s.getModel("splitArea"), k2 = A2.getModel("areaStyle"), R6 = k2.get("color"), B3 = 0;
            R6 = R6 instanceof Array ? R6 : [R6];
            for (var G3 = [], Z3 = Math.PI / 180, X3 = -g5[0].coord * Z3, tt = Math.min(S2[0], S2[1]), it = Math.max(S2[0], S2[1]), pt = s.get("clockwise"), mt = 1, Mt = g5.length; mt <= Mt; mt++) {
              var kt = mt === Mt ? g5[0].coord : g5[mt].coord, Gt = B3++ % R6.length;
              G3[Gt] = G3[Gt] || [], G3[Gt].push(new Ww({ shape: { cx: r5.cx, cy: r5.cy, r0: tt, r: it, startAngle: X3, endAngle: -kt * Z3, clockwise: pt }, silent: true })), X3 = -kt * Z3;
            }
            for (var mt = 0; mt < G3.length; mt++)
              c5.add(Wn(G3[mt], { style: Cl({ fill: R6[mt % R6.length] }, k2.getAreaStyle()), silent: true }));
          }
        } }, BZn = FZn, zZn = ["axisLine", "axisTickLabel", "axisName"], jZn = ["splitLine", "splitArea", "minorSplitLine"], WZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.axisPointerClass = "PolarAxisPointer", r5;
          }
          return s.prototype.render = function(r5, g5) {
            if (this.group.removeAll(), !!r5.get("show")) {
              var b6 = this._axisGroup, S2 = this._axisGroup = new nu();
              this.group.add(S2);
              var A2 = r5.axis, k2 = A2.polar, R6 = k2.getAngleAxis(), B3 = A2.getTicksCoords(), G3 = A2.getMinorTicksCoords(), Z3 = R6.getExtent()[0], X3 = A2.getExtent(), tt = HZn(k2, r5, Z3), it = new TR(r5, tt);
              Ye2(zZn, it.add, it), S2.add(it.getGroup()), of2(b6, S2, r5), Ye2(jZn, function(pt) {
                r5.get([pt, "show"]) && !A2.scale.isBlank() && GZn[pt](this.group, r5, k2, Z3, X3, B3, G3);
              }, this);
            }
          }, s.type = "radiusAxis", s;
        }(SW), GZn = { splitLine: function(c5, s, r5, g5, b6, S2) {
          var A2 = s.getModel("splitLine"), k2 = A2.getModel("lineStyle"), R6 = k2.get("color"), B3 = 0;
          R6 = R6 instanceof Array ? R6 : [R6];
          for (var G3 = [], Z3 = 0; Z3 < S2.length; Z3++) {
            var X3 = B3++ % R6.length;
            G3[X3] = G3[X3] || [], G3[X3].push(new qI({ shape: { cx: r5.cx, cy: r5.cy, r: S2[Z3].coord } }));
          }
          for (var Z3 = 0; Z3 < G3.length; Z3++)
            c5.add(Wn(G3[Z3], { style: Cl({ stroke: R6[Z3 % R6.length], fill: null }, k2.getLineStyle()), silent: true }));
        }, minorSplitLine: function(c5, s, r5, g5, b6, S2, A2) {
          if (A2.length) {
            for (var k2 = s.getModel("minorSplitLine"), R6 = k2.getModel("lineStyle"), B3 = [], G3 = 0; G3 < A2.length; G3++)
              for (var Z3 = 0; Z3 < A2[G3].length; Z3++)
                B3.push(new qI({ shape: { cx: r5.cx, cy: r5.cy, r: A2[G3][Z3].coord } }));
            c5.add(Wn(B3, { style: Cl({ fill: null }, R6.getLineStyle()), silent: true }));
          }
        }, splitArea: function(c5, s, r5, g5, b6, S2) {
          if (S2.length) {
            var A2 = s.getModel("splitArea"), k2 = A2.getModel("areaStyle"), R6 = k2.get("color"), B3 = 0;
            R6 = R6 instanceof Array ? R6 : [R6];
            for (var G3 = [], Z3 = S2[0].coord, X3 = 1; X3 < S2.length; X3++) {
              var tt = B3++ % R6.length;
              G3[tt] = G3[tt] || [], G3[tt].push(new Ww({ shape: { cx: r5.cx, cy: r5.cy, r0: Z3, r: S2[X3].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), Z3 = S2[X3].coord;
            }
            for (var X3 = 0; X3 < G3.length; X3++)
              c5.add(Wn(G3[X3], { style: Cl({ fill: R6[X3 % R6.length] }, k2.getAreaStyle()), silent: true }));
          }
        } };
        function HZn(c5, s, r5) {
          return { position: [c5.cx, c5.cy], rotation: r5 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: s.getModel("axisLabel").get("rotate"), z2: 1 };
        }
        var UZn = WZn;
        function w3e(c5) {
          return c5.get("stack") || "__ec_stack_" + c5.seriesIndex;
        }
        function S3e(c5, s) {
          return s.dim + c5.model.componentIndex;
        }
        function qZn(c5, s, r5) {
          var g5 = {}, b6 = ZZn(jp(s.getSeriesByType(c5), function(S2) {
            return !s.isSeriesFiltered(S2) && S2.coordinateSystem && S2.coordinateSystem.type === "polar";
          }));
          s.eachSeriesByType(c5, function(S2) {
            if (S2.coordinateSystem.type === "polar") {
              var A2 = S2.getData(), k2 = S2.coordinateSystem, R6 = k2.getBaseAxis(), B3 = S3e(k2, R6), G3 = w3e(S2), Z3 = b6[B3][G3], X3 = Z3.offset, tt = Z3.width, it = k2.getOtherAxis(R6), pt = S2.coordinateSystem.cx, mt = S2.coordinateSystem.cy, Mt = S2.get("barMinHeight") || 0, kt = S2.get("barMinAngle") || 0;
              g5[G3] = g5[G3] || [];
              for (var Gt = A2.mapDimension(it.dim), Ot = A2.mapDimension(R6.dim), ce2 = e9(A2, Gt), ae2 = R6.dim !== "radius" || !S2.get("roundCap", true), de2 = it.dataToCoord(0), we2 = 0, Se2 = A2.count(); we2 < Se2; we2++) {
                var Oe2 = A2.get(Gt, we2), je2 = A2.get(Ot, we2), rn = Oe2 >= 0 ? "p" : "n", qe2 = de2;
                ce2 && (g5[G3][je2] || (g5[G3][je2] = { p: de2, n: de2 }), qe2 = g5[G3][je2][rn]);
                var An = void 0, jn = void 0, _n = void 0, Jr = void 0;
                if (it.dim === "radius") {
                  var Qn = it.dataToCoord(Oe2) - de2, rr = R6.dataToCoord(je2);
                  Math.abs(Qn) < Mt && (Qn = (Qn < 0 ? -1 : 1) * Mt), An = qe2, jn = qe2 + Qn, _n = rr - X3, Jr = _n - tt, ce2 && (g5[G3][je2][rn] = jn);
                } else {
                  var Ar = it.dataToCoord(Oe2, ae2) - de2, fi2 = R6.dataToCoord(je2);
                  Math.abs(Ar) < kt && (Ar = (Ar < 0 ? -1 : 1) * kt), An = fi2 + X3, jn = An + tt, _n = qe2, Jr = qe2 + Ar, ce2 && (g5[G3][je2][rn] = Jr);
                }
                A2.setItemLayout(we2, { cx: pt, cy: mt, r0: An, r: jn, startAngle: -_n * Math.PI / 180, endAngle: -Jr * Math.PI / 180, clockwise: _n >= Jr });
              }
            }
          });
        }
        function ZZn(c5) {
          var s = {};
          Ye2(c5, function(g5, b6) {
            var S2 = g5.getData(), A2 = g5.coordinateSystem, k2 = A2.getBaseAxis(), R6 = S3e(A2, k2), B3 = k2.getExtent(), G3 = k2.type === "category" ? k2.getBandWidth() : Math.abs(B3[1] - B3[0]) / S2.count(), Z3 = s[R6] || { bandWidth: G3, remainedWidth: G3, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, X3 = Z3.stacks;
            s[R6] = Z3;
            var tt = w3e(g5);
            X3[tt] || Z3.autoWidthCount++, X3[tt] = X3[tt] || { width: 0, maxWidth: 0 };
            var it = $o(g5.get("barWidth"), G3), pt = $o(g5.get("barMaxWidth"), G3), mt = g5.get("barGap"), Mt = g5.get("barCategoryGap");
            it && !X3[tt].width && (it = Math.min(Z3.remainedWidth, it), X3[tt].width = it, Z3.remainedWidth -= it), pt && (X3[tt].maxWidth = pt), mt != null && (Z3.gap = mt), Mt != null && (Z3.categoryGap = Mt);
          });
          var r5 = {};
          return Ye2(s, function(g5, b6) {
            r5[b6] = {};
            var S2 = g5.stacks, A2 = g5.bandWidth, k2 = $o(g5.categoryGap, A2), R6 = $o(g5.gap, 1), B3 = g5.remainedWidth, G3 = g5.autoWidthCount, Z3 = (B3 - k2) / (G3 + (G3 - 1) * R6);
            Z3 = Math.max(Z3, 0), Ye2(S2, function(pt, mt) {
              var Mt = pt.maxWidth;
              Mt && Mt < Z3 && (Mt = Math.min(Mt, B3), pt.width && (Mt = Math.min(Mt, pt.width)), B3 -= Mt, pt.width = Mt, G3--);
            }), Z3 = (B3 - k2) / (G3 + (G3 - 1) * R6), Z3 = Math.max(Z3, 0);
            var X3 = 0, tt;
            Ye2(S2, function(pt, mt) {
              pt.width || (pt.width = Z3), tt = pt, X3 += pt.width * (1 + R6);
            }), tt && (X3 -= tt.width * R6);
            var it = -X3 / 2;
            Ye2(S2, function(pt, mt) {
              r5[b6][mt] = r5[b6][mt] || { offset: it, width: pt.width }, it += pt.width * (1 + R6);
            });
          }), r5;
        }
        var $Zn = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, YZn = { splitNumber: 5 }, KZn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "polar", s;
        }(P0);
        function XZn(c5) {
          Fc2(oft), SW.registerAxisPointerClass("PolarAxisPointer", xZn), c5.registerCoordinateSystem("polar", RZn), c5.registerComponentModel(SZn), c5.registerComponentView(KZn), CX(c5, "angle", MZn, $Zn), CX(c5, "radius", CZn, YZn), c5.registerComponentView(BZn), c5.registerComponentView(UZn), c5.registerLayout(Au(qZn, "bar"));
        }
        function HUt(c5, s) {
          s = s || {};
          var r5 = c5.coordinateSystem, g5 = c5.axis, b6 = {}, S2 = g5.position, A2 = g5.orient, k2 = r5.getRect(), R6 = [k2.x, k2.x + k2.width, k2.y, k2.y + k2.height], B3 = { horizontal: { top: R6[2], bottom: R6[3] }, vertical: { left: R6[0], right: R6[1] } };
          b6.position = [A2 === "vertical" ? B3.vertical[S2] : R6[0], A2 === "horizontal" ? B3.horizontal[S2] : R6[3]];
          var G3 = { horizontal: 0, vertical: 1 };
          b6.rotation = Math.PI / 2 * G3[A2];
          var Z3 = { top: -1, bottom: 1, right: 1, left: -1 };
          b6.labelDirection = b6.tickDirection = b6.nameDirection = Z3[S2], c5.get(["axisTick", "inside"]) && (b6.tickDirection = -b6.tickDirection), Wm(s.labelInside, c5.get(["axisLabel", "inside"])) && (b6.labelDirection = -b6.labelDirection);
          var X3 = s.rotate;
          return X3 == null && (X3 = c5.get(["axisLabel", "rotate"])), b6.labelRotation = S2 === "top" ? -X3 : X3, b6.z2 = 1, b6;
        }
        var QZn = ["axisLine", "axisTickLabel", "axisName"], JZn = ["splitArea", "splitLine"], t$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.axisPointerClass = "SingleAxisPointer", r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            var A2 = this.group;
            A2.removeAll();
            var k2 = this._axisGroup;
            this._axisGroup = new nu();
            var R6 = HUt(r5), B3 = new TR(r5, R6);
            Ye2(QZn, B3.add, B3), A2.add(this._axisGroup), A2.add(B3.getGroup()), Ye2(JZn, function(G3) {
              r5.get([G3, "show"]) && e$n[G3](this, this.group, this._axisGroup, r5);
            }, this), of2(k2, this._axisGroup, r5), c5.prototype.render.call(this, r5, g5, b6, S2);
          }, s.prototype.remove = function() {
            WEe(this);
          }, s.type = "singleAxis", s;
        }(SW), e$n = { splitLine: function(c5, s, r5, g5) {
          var b6 = g5.axis;
          if (!b6.scale.isBlank()) {
            var S2 = g5.getModel("splitLine"), A2 = S2.getModel("lineStyle"), k2 = A2.get("color");
            k2 = k2 instanceof Array ? k2 : [k2];
            for (var R6 = g5.coordinateSystem.getRect(), B3 = b6.isHorizontal(), G3 = [], Z3 = 0, X3 = b6.getTicksCoords({ tickModel: S2 }), tt = [], it = [], pt = 0; pt < X3.length; ++pt) {
              var mt = b6.toGlobalCoord(X3[pt].coord);
              B3 ? (tt[0] = mt, tt[1] = R6.y, it[0] = mt, it[1] = R6.y + R6.height) : (tt[0] = R6.x, tt[1] = mt, it[0] = R6.x + R6.width, it[1] = mt);
              var Mt = Z3++ % k2.length;
              G3[Mt] = G3[Mt] || [], G3[Mt].push(new Zm({ subPixelOptimize: true, shape: { x1: tt[0], y1: tt[1], x2: it[0], y2: it[1] }, silent: true }));
            }
            for (var kt = A2.getLineStyle(["color"]), pt = 0; pt < G3.length; ++pt)
              s.add(Wn(G3[pt], { style: Cl({ stroke: k2[pt % k2.length] }, kt), silent: true }));
          }
        }, splitArea: function(c5, s, r5, g5) {
          jEe(c5, r5, g5, g5);
        } }, n$n = t$n, M3e = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.getCoordSysModel = function() {
            return this;
          }, s.type = "singleAxis", s.layoutMode = "box", s.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, s;
        }(Rh2);
        A0(M3e, Ect.prototype);
        var UUt = M3e, r$n = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2, A2) {
            var k2 = c5.call(this, r5, g5, b6) || this;
            return k2.type = S2 || "value", k2.position = A2 || "bottom", k2;
          }
          return s.prototype.isHorizontal = function() {
            var r5 = this.position;
            return r5 === "top" || r5 === "bottom";
          }, s.prototype.pointToData = function(r5, g5) {
            return this.coordinateSystem.pointToData(r5)[0];
          }, s;
        }(kk2), i$n = r$n, C3e = ["single"], a$n = function() {
          function c5(s, r5, g5) {
            this.type = "single", this.dimension = "single", this.dimensions = C3e, this.axisPointerEnabled = true, this.model = s, this._init(s, r5, g5);
          }
          return c5.prototype._init = function(s, r5, g5) {
            var b6 = this.dimension, S2 = new i$n(b6, LMt(s), [0, 0], s.get("type"), s.get("position")), A2 = S2.type === "category";
            S2.onBand = A2 && s.get("boundaryGap"), S2.inverse = s.get("inverse"), S2.orient = s.get("orient"), s.axis = S2, S2.model = s, S2.coordinateSystem = this, this._axis = S2;
          }, c5.prototype.update = function(s, r5) {
            s.eachSeries(function(g5) {
              if (g5.coordinateSystem === this) {
                var b6 = g5.getData();
                Ye2(b6.mapDimensionsAll(this.dimension), function(S2) {
                  this._axis.scale.unionExtentFromData(b6, S2);
                }, this), _X(this._axis.scale, this._axis.model);
              }
            }, this);
          }, c5.prototype.resize = function(s, r5) {
            this._rect = $m({ left: s.get("left"), top: s.get("top"), right: s.get("right"), bottom: s.get("bottom"), width: s.get("width"), height: s.get("height") }, { width: r5.getWidth(), height: r5.getHeight() }), this._adjustAxis();
          }, c5.prototype.getRect = function() {
            return this._rect;
          }, c5.prototype._adjustAxis = function() {
            var s = this._rect, r5 = this._axis, g5 = r5.isHorizontal(), b6 = g5 ? [0, s.width] : [0, s.height], S2 = r5.reverse ? 1 : 0;
            r5.setExtent(b6[S2], b6[1 - S2]), this._updateAxisTransform(r5, g5 ? s.x : s.y);
          }, c5.prototype._updateAxisTransform = function(s, r5) {
            var g5 = s.getExtent(), b6 = g5[0] + g5[1], S2 = s.isHorizontal();
            s.toGlobalCoord = S2 ? function(A2) {
              return A2 + r5;
            } : function(A2) {
              return b6 - A2 + r5;
            }, s.toLocalCoord = S2 ? function(A2) {
              return A2 - r5;
            } : function(A2) {
              return b6 - A2 + r5;
            };
          }, c5.prototype.getAxis = function() {
            return this._axis;
          }, c5.prototype.getBaseAxis = function() {
            return this._axis;
          }, c5.prototype.getAxes = function() {
            return [this._axis];
          }, c5.prototype.getTooltipAxes = function() {
            return { baseAxes: [this.getAxis()], otherAxes: [] };
          }, c5.prototype.containPoint = function(s) {
            var r5 = this.getRect(), g5 = this.getAxis(), b6 = g5.orient;
            return b6 === "horizontal" ? g5.contain(g5.toLocalCoord(s[0])) && s[1] >= r5.y && s[1] <= r5.y + r5.height : g5.contain(g5.toLocalCoord(s[1])) && s[0] >= r5.y && s[0] <= r5.y + r5.height;
          }, c5.prototype.pointToData = function(s) {
            var r5 = this.getAxis();
            return [r5.coordToData(r5.toLocalCoord(s[r5.orient === "horizontal" ? 0 : 1]))];
          }, c5.prototype.dataToPoint = function(s) {
            var r5 = this.getAxis(), g5 = this.getRect(), b6 = [], S2 = r5.orient === "horizontal" ? 0 : 1;
            return s instanceof Array && (s = s[0]), b6[S2] = r5.toGlobalCoord(r5.dataToCoord(+s)), b6[1 - S2] = S2 === 0 ? g5.y + g5.height / 2 : g5.x + g5.width / 2, b6;
          }, c5.prototype.convertToPixel = function(s, r5, g5) {
            var b6 = T3e(r5);
            return b6 === this ? this.dataToPoint(g5) : null;
          }, c5.prototype.convertFromPixel = function(s, r5, g5) {
            var b6 = T3e(r5);
            return b6 === this ? this.pointToData(g5) : null;
          }, c5;
        }();
        function T3e(c5) {
          var s = c5.seriesModel, r5 = c5.singleAxisModel;
          return r5 && r5.coordinateSystem || s && s.coordinateSystem;
        }
        function o$n(c5, s) {
          var r5 = [];
          return c5.eachComponent("singleAxis", function(g5, b6) {
            var S2 = new a$n(g5, c5, s);
            S2.name = "single_" + b6, S2.resize(g5, s), g5.coordinateSystem = S2, r5.push(S2);
          }), c5.eachSeries(function(g5) {
            if (g5.get("coordinateSystem") === "singleAxis") {
              var b6 = g5.getReferringComponents("singleAxis", E0).models[0];
              g5.coordinateSystem = b6 && b6.coordinateSystem;
            }
          }), r5;
        }
        var s$n = { create: o$n, dimensions: C3e }, l$n = s$n, A3e = ["x", "y"], u$n = ["width", "height"], c$n = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.makeElOption = function(r5, g5, b6, S2, A2) {
            var k2 = b6.axis, R6 = k2.coordinateSystem, B3 = qUt(R6, 1 - SCt(k2)), G3 = R6.dataToPoint(g5)[0], Z3 = S2.get("type");
            if (Z3 && Z3 !== "none") {
              var X3 = FUt(S2), tt = f$n[Z3](k2, G3, B3);
              tt.style = X3, r5.graphicKey = tt.type, r5.pointer = tt;
            }
            var it = HUt(b6);
            s3e(g5, r5, it, b6, S2, A2);
          }, s.prototype.getHandleTransform = function(r5, g5, b6) {
            var S2 = HUt(g5, { labelInside: false });
            S2.labelMargin = b6.get(["handle", "margin"]);
            var A2 = VUt(g5.axis, r5, S2);
            return { x: A2[0], y: A2[1], rotation: S2.rotation + (S2.labelDirection < 0 ? Math.PI : 0) };
          }, s.prototype.updateHandleTransform = function(r5, g5, b6, S2) {
            var A2 = b6.axis, k2 = A2.coordinateSystem, R6 = SCt(A2), B3 = qUt(k2, R6), G3 = [r5.x, r5.y];
            G3[R6] += g5[R6], G3[R6] = Math.min(B3[1], G3[R6]), G3[R6] = Math.max(B3[0], G3[R6]);
            var Z3 = qUt(k2, 1 - R6), X3 = (Z3[1] + Z3[0]) / 2, tt = [X3, X3];
            return tt[R6] = G3[R6], { x: G3[0], y: G3[1], rotation: r5.rotation, cursorPoint: tt, tooltipOption: { verticalAlign: "middle" } };
          }, s;
        }(NUt), f$n = { line: function(c5, s, r5) {
          var g5 = BUt([s, r5[0]], [s, r5[1]], SCt(c5));
          return { type: "Line", subPixelOptimize: true, shape: g5 };
        }, shadow: function(c5, s, r5) {
          var g5 = c5.getBandWidth(), b6 = r5[1] - r5[0];
          return { type: "Rect", shape: l3e([s - g5 / 2, r5[0]], [g5, b6], SCt(c5)) };
        } };
        function SCt(c5) {
          return c5.isHorizontal() ? 0 : 1;
        }
        function qUt(c5, s) {
          var r5 = c5.getRect();
          return [r5[A3e[s]], r5[A3e[s]] + r5[u$n[s]]];
        }
        var h$n = c$n, p$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "single", s;
        }(P0);
        function d$n(c5) {
          Fc2(oft), SW.registerAxisPointerClass("SingleAxisPointer", h$n), c5.registerComponentView(p$n), c5.registerComponentView(n$n), c5.registerComponentModel(UUt), CX(c5, "single", UUt, UUt.defaultOption), c5.registerCoordinateSystem("single", l$n);
        }
        var g$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            var S2 = oX(r5);
            c5.prototype.init.apply(this, arguments), I3e(r5, S2);
          }, s.prototype.mergeOption = function(r5) {
            c5.prototype.mergeOption.apply(this, arguments), I3e(this.option, r5);
          }, s.prototype.getCellSize = function() {
            return this.option.cellSize;
          }, s.type = "calendar", s.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, s;
        }(Rh2);
        function I3e(c5, s) {
          var r5 = c5.cellSize, g5;
          ja2(r5) ? g5 = r5 : g5 = c5.cellSize = [r5, r5], g5.length === 1 && (g5[1] = g5[0]);
          var b6 = Ha2([0, 1], function(S2) {
            return x6n(s, S2) && (g5[S2] = "auto"), g5[S2] != null && g5[S2] !== "auto";
          });
          Y8(c5, s, { type: "box", ignoreSize: b6 });
        }
        var v$n = g$n, y$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2 = this.group;
            S2.removeAll();
            var A2 = r5.coordinateSystem, k2 = A2.getRangeInfo(), R6 = A2.getOrient(), B3 = g5.getLocaleModel();
            this._renderDayRect(r5, k2, S2), this._renderLines(r5, k2, R6, S2), this._renderYearText(r5, k2, R6, S2), this._renderMonthText(r5, B3, R6, S2), this._renderWeekText(r5, B3, k2, R6, S2);
          }, s.prototype._renderDayRect = function(r5, g5, b6) {
            for (var S2 = r5.coordinateSystem, A2 = r5.getModel("itemStyle").getItemStyle(), k2 = S2.getCellWidth(), R6 = S2.getCellHeight(), B3 = g5.start.time; B3 <= g5.end.time; B3 = S2.getNextNDay(B3, 1).time) {
              var G3 = S2.dataToRect([B3], false).tl, Z3 = new zf2({ shape: { x: G3[0], y: G3[1], width: k2, height: R6 }, cursor: "default", style: A2 });
              b6.add(Z3);
            }
          }, s.prototype._renderLines = function(r5, g5, b6, S2) {
            var A2 = this, k2 = r5.coordinateSystem, R6 = r5.getModel(["splitLine", "lineStyle"]).getLineStyle(), B3 = r5.get(["splitLine", "show"]), G3 = R6.lineWidth;
            this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
            for (var Z3 = g5.start, X3 = 0; Z3.time <= g5.end.time; X3++) {
              it(Z3.formatedDate), X3 === 0 && (Z3 = k2.getDateInfo(g5.start.y + "-" + g5.start.m));
              var tt = Z3.date;
              tt.setMonth(tt.getMonth() + 1), Z3 = k2.getDateInfo(tt);
            }
            it(k2.getNextNDay(g5.end.time, 1).formatedDate);
            function it(pt) {
              A2._firstDayOfMonth.push(k2.getDateInfo(pt)), A2._firstDayPoints.push(k2.dataToRect([pt], false).tl);
              var mt = A2._getLinePointsOfOneWeek(r5, pt, b6);
              A2._tlpoints.push(mt[0]), A2._blpoints.push(mt[mt.length - 1]), B3 && A2._drawSplitline(mt, R6, S2);
            }
            B3 && this._drawSplitline(A2._getEdgesPoints(A2._tlpoints, G3, b6), R6, S2), B3 && this._drawSplitline(A2._getEdgesPoints(A2._blpoints, G3, b6), R6, S2);
          }, s.prototype._getEdgesPoints = function(r5, g5, b6) {
            var S2 = [r5[0].slice(), r5[r5.length - 1].slice()], A2 = b6 === "horizontal" ? 0 : 1;
            return S2[0][A2] = S2[0][A2] - g5 / 2, S2[1][A2] = S2[1][A2] + g5 / 2, S2;
          }, s.prototype._drawSplitline = function(r5, g5, b6) {
            var S2 = new Gw({ z2: 20, shape: { points: r5 }, style: g5 });
            b6.add(S2);
          }, s.prototype._getLinePointsOfOneWeek = function(r5, g5, b6) {
            for (var S2 = r5.coordinateSystem, A2 = S2.getDateInfo(g5), k2 = [], R6 = 0; R6 < 7; R6++) {
              var B3 = S2.getNextNDay(A2.time, R6), G3 = S2.dataToRect([B3.time], false);
              k2[2 * B3.day] = G3.tl, k2[2 * B3.day + 1] = G3[b6 === "horizontal" ? "bl" : "tr"];
            }
            return k2;
          }, s.prototype._formatterLabel = function(r5, g5) {
            return gs(r5) && r5 ? m6n(r5, g5) : Tl(r5) ? r5(g5) : g5.nameMap;
          }, s.prototype._yearTextPositionControl = function(r5, g5, b6, S2, A2) {
            var k2 = g5[0], R6 = g5[1], B3 = ["center", "bottom"];
            S2 === "bottom" ? (R6 += A2, B3 = ["center", "top"]) : S2 === "left" ? k2 -= A2 : S2 === "right" ? (k2 += A2, B3 = ["center", "top"]) : R6 -= A2;
            var G3 = 0;
            return (S2 === "left" || S2 === "right") && (G3 = Math.PI / 2), { rotation: G3, x: k2, y: R6, style: { align: B3[0], verticalAlign: B3[1] } };
          }, s.prototype._renderYearText = function(r5, g5, b6, S2) {
            var A2 = r5.getModel("yearLabel");
            if (A2.get("show")) {
              var k2 = A2.get("margin"), R6 = A2.get("position");
              R6 || (R6 = b6 !== "horizontal" ? "top" : "left");
              var B3 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], G3 = (B3[0][0] + B3[1][0]) / 2, Z3 = (B3[0][1] + B3[1][1]) / 2, X3 = b6 === "horizontal" ? 0 : 1, tt = { top: [G3, B3[X3][1]], bottom: [G3, B3[1 - X3][1]], left: [B3[1 - X3][0], Z3], right: [B3[X3][0], Z3] }, it = g5.start.y;
              +g5.end.y > +g5.start.y && (it = it + "-" + g5.end.y);
              var pt = A2.get("formatter"), mt = { start: g5.start.y, end: g5.end.y, nameMap: it }, Mt = this._formatterLabel(pt, mt), kt = new hh2({ z2: 30, style: Ey(A2, { text: Mt }) });
              kt.attr(this._yearTextPositionControl(kt, tt[R6], b6, R6, k2)), S2.add(kt);
            }
          }, s.prototype._monthTextPositionControl = function(r5, g5, b6, S2, A2) {
            var k2 = "left", R6 = "top", B3 = r5[0], G3 = r5[1];
            return b6 === "horizontal" ? (G3 = G3 + A2, g5 && (k2 = "center"), S2 === "start" && (R6 = "bottom")) : (B3 = B3 + A2, g5 && (R6 = "middle"), S2 === "start" && (k2 = "right")), { x: B3, y: G3, align: k2, verticalAlign: R6 };
          }, s.prototype._renderMonthText = function(r5, g5, b6, S2) {
            var A2 = r5.getModel("monthLabel");
            if (A2.get("show")) {
              var k2 = A2.get("nameMap"), R6 = A2.get("margin"), B3 = A2.get("position"), G3 = A2.get("align"), Z3 = [this._tlpoints, this._blpoints];
              (!k2 || gs(k2)) && (k2 && (g5 = _Wt(k2) || g5), k2 = g5.get(["time", "monthAbbr"]) || []);
              var X3 = B3 === "start" ? 0 : 1, tt = b6 === "horizontal" ? 0 : 1;
              R6 = B3 === "start" ? -R6 : R6;
              for (var it = G3 === "center", pt = 0; pt < Z3[X3].length - 1; pt++) {
                var mt = Z3[X3][pt].slice(), Mt = this._firstDayOfMonth[pt];
                if (it) {
                  var kt = this._firstDayPoints[pt];
                  mt[tt] = (kt[tt] + Z3[0][pt + 1][tt]) / 2;
                }
                var Gt = A2.get("formatter"), Ot = k2[+Mt.m - 1], ce2 = { yyyy: Mt.y, yy: (Mt.y + "").slice(2), MM: Mt.m, M: +Mt.m, nameMap: Ot }, ae2 = this._formatterLabel(Gt, ce2), de2 = new hh2({ z2: 30, style: sa2(Ey(A2, { text: ae2 }), this._monthTextPositionControl(mt, it, b6, B3, R6)) });
                S2.add(de2);
              }
            }
          }, s.prototype._weekTextPositionControl = function(r5, g5, b6, S2, A2) {
            var k2 = "center", R6 = "middle", B3 = r5[0], G3 = r5[1], Z3 = b6 === "start";
            return g5 === "horizontal" ? (B3 = B3 + S2 + (Z3 ? 1 : -1) * A2[0] / 2, k2 = Z3 ? "right" : "left") : (G3 = G3 + S2 + (Z3 ? 1 : -1) * A2[1] / 2, R6 = Z3 ? "bottom" : "top"), { x: B3, y: G3, align: k2, verticalAlign: R6 };
          }, s.prototype._renderWeekText = function(r5, g5, b6, S2, A2) {
            var k2 = r5.getModel("dayLabel");
            if (k2.get("show")) {
              var R6 = r5.coordinateSystem, B3 = k2.get("position"), G3 = k2.get("nameMap"), Z3 = k2.get("margin"), X3 = R6.getFirstDayOfWeek();
              if (!G3 || gs(G3)) {
                G3 && (g5 = _Wt(G3) || g5);
                var tt = g5.get(["time", "dayOfWeekShort"]);
                G3 = tt || Ha2(g5.get(["time", "dayOfWeekAbbr"]), function(ce2) {
                  return ce2[0];
                });
              }
              var it = R6.getNextNDay(b6.end.time, 7 - b6.lweek).time, pt = [R6.getCellWidth(), R6.getCellHeight()];
              Z3 = $o(Z3, Math.min(pt[1], pt[0])), B3 === "start" && (it = R6.getNextNDay(b6.start.time, -(7 + b6.fweek)).time, Z3 = -Z3);
              for (var mt = 0; mt < 7; mt++) {
                var Mt = R6.getNextNDay(it, mt), kt = R6.dataToRect([Mt.time], false).center, Gt = mt;
                Gt = Math.abs((mt + X3) % 7);
                var Ot = new hh2({ z2: 30, style: sa2(Ey(k2, { text: G3[Gt] }), this._weekTextPositionControl(kt, S2, B3, Z3, pt)) });
                A2.add(Ot);
              }
            }
          }, s.type = "calendar", s;
        }(P0), m$n = y$n, ZUt = 864e5, b$n = function() {
          function c5(s, r5, g5) {
            this.type = "calendar", this.dimensions = c5.dimensions, this.getDimensionsInfo = c5.getDimensionsInfo, this._model = s;
          }
          return c5.getDimensionsInfo = function() {
            return [{ name: "time", type: "time" }, "value"];
          }, c5.prototype.getRangeInfo = function() {
            return this._rangeInfo;
          }, c5.prototype.getModel = function() {
            return this._model;
          }, c5.prototype.getRect = function() {
            return this._rect;
          }, c5.prototype.getCellWidth = function() {
            return this._sw;
          }, c5.prototype.getCellHeight = function() {
            return this._sh;
          }, c5.prototype.getOrient = function() {
            return this._orient;
          }, c5.prototype.getFirstDayOfWeek = function() {
            return this._firstDayOfWeek;
          }, c5.prototype.getDateInfo = function(s) {
            s = QC(s);
            var r5 = s.getFullYear(), g5 = s.getMonth() + 1, b6 = g5 < 10 ? "0" + g5 : "" + g5, S2 = s.getDate(), A2 = S2 < 10 ? "0" + S2 : "" + S2, k2 = s.getDay();
            return k2 = Math.abs((k2 + 7 - this.getFirstDayOfWeek()) % 7), { y: r5 + "", m: b6, d: A2, day: k2, time: s.getTime(), formatedDate: r5 + "-" + b6 + "-" + A2, date: s };
          }, c5.prototype.getNextNDay = function(s, r5) {
            return r5 = r5 || 0, r5 === 0 ? this.getDateInfo(s) : (s = new Date(this.getDateInfo(s).time), s.setDate(s.getDate() + r5), this.getDateInfo(s));
          }, c5.prototype.update = function(s, r5) {
            this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
            var g5 = this._rangeInfo.weeks || 1, b6 = ["width", "height"], S2 = this._model.getCellSize().slice(), A2 = this._model.getBoxLayoutParams(), k2 = this._orient === "horizontal" ? [g5, 7] : [7, g5];
            Ye2([0, 1], function(Z3) {
              G3(S2, Z3) && (A2[b6[Z3]] = S2[Z3] * k2[Z3]);
            });
            var R6 = { width: r5.getWidth(), height: r5.getHeight() }, B3 = this._rect = $m(A2, R6);
            Ye2([0, 1], function(Z3) {
              G3(S2, Z3) || (S2[Z3] = B3[b6[Z3]] / k2[Z3]);
            });
            function G3(Z3, X3) {
              return Z3[X3] != null && Z3[X3] !== "auto";
            }
            this._sw = S2[0], this._sh = S2[1];
          }, c5.prototype.dataToPoint = function(s, r5) {
            ja2(s) && (s = s[0]), r5 == null && (r5 = true);
            var g5 = this.getDateInfo(s), b6 = this._rangeInfo, S2 = g5.formatedDate;
            if (r5 && !(g5.time >= b6.start.time && g5.time < b6.end.time + ZUt))
              return [NaN, NaN];
            var A2 = g5.day, k2 = this._getRangeInfo([b6.start.time, S2]).nthWeek;
            return this._orient === "vertical" ? [this._rect.x + A2 * this._sw + this._sw / 2, this._rect.y + k2 * this._sh + this._sh / 2] : [this._rect.x + k2 * this._sw + this._sw / 2, this._rect.y + A2 * this._sh + this._sh / 2];
          }, c5.prototype.pointToData = function(s) {
            var r5 = this.pointToDate(s);
            return r5 && r5.time;
          }, c5.prototype.dataToRect = function(s, r5) {
            var g5 = this.dataToPoint(s, r5);
            return { contentShape: { x: g5[0] - (this._sw - this._lineWidth) / 2, y: g5[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: g5, tl: [g5[0] - this._sw / 2, g5[1] - this._sh / 2], tr: [g5[0] + this._sw / 2, g5[1] - this._sh / 2], br: [g5[0] + this._sw / 2, g5[1] + this._sh / 2], bl: [g5[0] - this._sw / 2, g5[1] + this._sh / 2] };
          }, c5.prototype.pointToDate = function(s) {
            var r5 = Math.floor((s[0] - this._rect.x) / this._sw) + 1, g5 = Math.floor((s[1] - this._rect.y) / this._sh) + 1, b6 = this._rangeInfo.range;
            return this._orient === "vertical" ? this._getDateByWeeksAndDay(g5, r5 - 1, b6) : this._getDateByWeeksAndDay(r5, g5 - 1, b6);
          }, c5.prototype.convertToPixel = function(s, r5, g5) {
            var b6 = D3e(r5);
            return b6 === this ? b6.dataToPoint(g5) : null;
          }, c5.prototype.convertFromPixel = function(s, r5, g5) {
            var b6 = D3e(r5);
            return b6 === this ? b6.pointToData(g5) : null;
          }, c5.prototype.containPoint = function(s) {
            return console.warn("Not implemented."), false;
          }, c5.prototype._initRangeOption = function() {
            var s = this._model.get("range"), r5;
            if (ja2(s) && s.length === 1 && (s = s[0]), ja2(s))
              r5 = s;
            else {
              var g5 = s.toString();
              if (/^\d{4}$/.test(g5) && (r5 = [g5 + "-01-01", g5 + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(g5)) {
                var b6 = this.getDateInfo(g5), S2 = b6.date;
                S2.setMonth(S2.getMonth() + 1);
                var A2 = this.getNextNDay(S2, -1);
                r5 = [b6.formatedDate, A2.formatedDate];
              }
              /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(g5) && (r5 = [g5, g5]);
            }
            if (!r5)
              return s;
            var k2 = this._getRangeInfo(r5);
            return k2.start.time > k2.end.time && r5.reverse(), r5;
          }, c5.prototype._getRangeInfo = function(s) {
            var r5 = [this.getDateInfo(s[0]), this.getDateInfo(s[1])], g5;
            r5[0].time > r5[1].time && (g5 = true, r5.reverse());
            var b6 = Math.floor(r5[1].time / ZUt) - Math.floor(r5[0].time / ZUt) + 1, S2 = new Date(r5[0].time), A2 = S2.getDate(), k2 = r5[1].date.getDate();
            S2.setDate(A2 + b6 - 1);
            var R6 = S2.getDate();
            if (R6 !== k2)
              for (var B3 = S2.getTime() - r5[1].time > 0 ? 1 : -1; (R6 = S2.getDate()) !== k2 && (S2.getTime() - r5[1].time) * B3 > 0; )
                b6 -= B3, S2.setDate(R6 - B3);
            var G3 = Math.floor((b6 + r5[0].day + 6) / 7), Z3 = g5 ? -G3 + 1 : G3 - 1;
            return g5 && r5.reverse(), { range: [r5[0].formatedDate, r5[1].formatedDate], start: r5[0], end: r5[1], allDay: b6, weeks: G3, nthWeek: Z3, fweek: r5[0].day, lweek: r5[1].day };
          }, c5.prototype._getDateByWeeksAndDay = function(s, r5, g5) {
            var b6 = this._getRangeInfo(g5);
            if (s > b6.weeks || s === 0 && r5 < b6.fweek || s === b6.weeks && r5 > b6.lweek)
              return null;
            var S2 = (s - 1) * 7 - b6.fweek + r5, A2 = new Date(b6.start.time);
            return A2.setDate(+b6.start.d + S2), this.getDateInfo(A2);
          }, c5.create = function(s, r5) {
            var g5 = [];
            return s.eachComponent("calendar", function(b6) {
              var S2 = new c5(b6, s, r5);
              g5.push(S2), b6.coordinateSystem = S2;
            }), s.eachSeries(function(b6) {
              b6.get("coordinateSystem") === "calendar" && (b6.coordinateSystem = g5[b6.get("calendarIndex") || 0]);
            }), g5;
          }, c5.dimensions = ["time", "value"], c5;
        }();
        function D3e(c5) {
          var s = c5.calendarModel, r5 = c5.seriesModel, g5 = s ? s.coordinateSystem : r5 ? r5.coordinateSystem : null;
          return g5;
        }
        var _$n = b$n;
        function x$n(c5) {
          c5.registerComponentModel(v$n), c5.registerComponentView(m$n), c5.registerCoordinateSystem("calendar", _$n);
        }
        function w$n(c5, s) {
          var r5 = c5.existing;
          if (s.id = c5.keyInfo.id, !s.type && r5 && (s.type = r5.type), s.parentId == null) {
            var g5 = s.parentOption;
            g5 ? s.parentId = g5.id : r5 && (s.parentId = r5.parentId);
          }
          s.parentOption = null;
        }
        function E3e(c5, s) {
          var r5;
          return Ye2(s, function(g5) {
            c5[g5] != null && c5[g5] !== "auto" && (r5 = true);
          }), r5;
        }
        function S$n(c5, s, r5) {
          var g5 = sa2({}, r5), b6 = c5[s], S2 = r5.$action || "merge";
          S2 === "merge" ? b6 ? (bu(b6, g5, true), Y8(b6, g5, { ignoreSize: true }), iTe(r5, b6), MCt(r5, b6), MCt(r5, b6, "shape"), MCt(r5, b6, "style"), MCt(r5, b6, "extra"), r5.clipPath = b6.clipPath) : c5[s] = g5 : S2 === "replace" ? c5[s] = g5 : S2 === "remove" && b6 && (c5[s] = null);
        }
        var k3e = ["transition", "enterFrom", "leaveTo"], M$n = k3e.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
        function MCt(c5, s, r5) {
          if (r5 && (!c5[r5] && s[r5] && (c5[r5] = {}), c5 = c5[r5], s = s[r5]), !(!c5 || !s))
            for (var g5 = r5 ? k3e : M$n, b6 = 0; b6 < g5.length; b6++) {
              var S2 = g5[b6];
              c5[S2] == null && s[S2] != null && (c5[S2] = s[S2]);
            }
        }
        function C$n(c5, s) {
          if (!!c5 && (c5.hv = s.hv = [E3e(s, ["left", "right"]), E3e(s, ["top", "bottom"])], c5.type === "group")) {
            var r5 = c5, g5 = s;
            r5.width == null && (r5.width = g5.width = 0), r5.height == null && (r5.height = g5.height = 0);
          }
        }
        var T$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.preventAutoZ = true, r5;
          }
          return s.prototype.mergeOption = function(r5, g5) {
            var b6 = this.option.elements;
            this.option.elements = null, c5.prototype.mergeOption.call(this, r5, g5), this.option.elements = b6;
          }, s.prototype.optionUpdated = function(r5, g5) {
            var b6 = this.option, S2 = (g5 ? b6 : r5).elements, A2 = b6.elements = g5 ? [] : b6.elements, k2 = [];
            this._flatten(S2, k2, null);
            var R6 = m3(A2, k2, "normalMerge"), B3 = this._elOptionsToUpdate = [];
            Ye2(R6, function(G3, Z3) {
              var X3 = G3.newOption;
              !X3 || (B3.push(X3), w$n(G3, X3), S$n(A2, Z3, X3), C$n(A2[Z3], X3));
            }, this), b6.elements = jp(A2, function(G3) {
              return G3 && delete G3.$action, G3 != null;
            });
          }, s.prototype._flatten = function(r5, g5, b6) {
            Ye2(r5, function(S2) {
              if (S2) {
                b6 && (S2.parentOption = b6), g5.push(S2);
                var A2 = S2.children;
                S2.type === "group" && A2 && this._flatten(A2, g5, S2), delete S2.children;
              }
            }, this);
          }, s.prototype.useElOptionsToUpdate = function() {
            var r5 = this._elOptionsToUpdate;
            return this._elOptionsToUpdate = null, r5;
          }, s.type = "graphic", s.defaultOption = { elements: [] }, s;
        }(Rh2), P3e = { path: null, compoundPath: null, group: nu, image: qm, text: hh2 }, aD = Df2(), A$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function() {
            this._elMap = Ps();
          }, s.prototype.render = function(r5, g5, b6) {
            r5 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = r5, this._updateElements(r5), this._relocate(r5, b6);
          }, s.prototype._updateElements = function(r5) {
            var g5 = r5.useElOptionsToUpdate();
            if (g5) {
              var b6 = this._elMap, S2 = this.group, A2 = r5.get("z"), k2 = r5.get("zlevel");
              Ye2(g5, function(R6) {
                var B3 = Q0(R6.id, null), G3 = B3 != null ? b6.get(B3) : null, Z3 = Q0(R6.parentId, null), X3 = Z3 != null ? b6.get(Z3) : S2, tt = R6.type, it = R6.style;
                tt === "text" && it && R6.hv && R6.hv[1] && (it.textVerticalAlign = it.textBaseline = it.verticalAlign = it.align = null);
                var pt = R6.textContent, mt = R6.textConfig;
                if (it && RPe(it, tt, !!mt, !!pt)) {
                  var Mt = NPe(it, tt, true);
                  !mt && Mt.textConfig && (mt = R6.textConfig = Mt.textConfig), !pt && Mt.textContent && (pt = Mt.textContent);
                }
                var kt = I$n(R6), Gt = R6.$action || "merge", Ot = Gt === "merge", ce2 = Gt === "replace";
                if (Ot) {
                  var ae2 = !G3, de2 = G3;
                  ae2 ? de2 = L3e(B3, X3, R6.type, b6) : (de2 && (aD(de2).isNew = false), qPe(de2)), de2 && (vCt(de2, kt, r5, { isInit: ae2 }), O3e(de2, R6, A2, k2));
                } else if (ce2) {
                  CCt(G3, R6, b6, r5);
                  var we2 = L3e(B3, X3, R6.type, b6);
                  we2 && (vCt(we2, kt, r5, { isInit: true }), O3e(we2, R6, A2, k2));
                } else
                  Gt === "remove" && (WPe(G3, R6), CCt(G3, R6, b6, r5));
                var Se2 = b6.get(B3);
                if (Se2 && pt)
                  if (Ot) {
                    var Oe2 = Se2.getTextContent();
                    Oe2 ? Oe2.attr(pt) : Se2.setTextContent(new hh2(pt));
                  } else
                    ce2 && Se2.setTextContent(new hh2(pt));
                if (Se2) {
                  var je2 = R6.clipPath;
                  if (je2) {
                    var rn = je2.type, qe2 = void 0, ae2 = false;
                    if (Ot) {
                      var An = Se2.getClipPath();
                      ae2 = !An || aD(An).type !== rn, qe2 = ae2 ? $Ut(rn) : An;
                    } else
                      ce2 && (ae2 = true, qe2 = $Ut(rn));
                    Se2.setClipPath(qe2), vCt(qe2, je2, r5, { isInit: ae2 }), mCt(qe2, je2.keyframeAnimation, r5);
                  }
                  var jn = aD(Se2);
                  Se2.setTextConfig(mt), jn.option = R6, D$n(Se2, r5, R6), Ub2({ el: Se2, componentModel: r5, itemName: Se2.name, itemTooltipOption: R6.tooltip }), mCt(Se2, R6.keyframeAnimation, r5);
                }
              });
            }
          }, s.prototype._relocate = function(r5, g5) {
            for (var b6 = r5.option.elements, S2 = this.group, A2 = this._elMap, k2 = g5.getWidth(), R6 = g5.getHeight(), B3 = ["x", "y"], G3 = 0; G3 < b6.length; G3++) {
              var Z3 = b6[G3], X3 = Q0(Z3.id, null), tt = X3 != null ? A2.get(X3) : null;
              if (!(!tt || !tt.isGroup)) {
                var it = tt.parent, pt = it === S2, mt = aD(tt), Mt = aD(it);
                mt.width = $o(mt.option.width, pt ? k2 : Mt.width) || 0, mt.height = $o(mt.option.height, pt ? R6 : Mt.height) || 0;
              }
            }
            for (var G3 = b6.length - 1; G3 >= 0; G3--) {
              var Z3 = b6[G3], X3 = Q0(Z3.id, null), tt = X3 != null ? A2.get(X3) : null;
              if (tt) {
                var it = tt.parent, Mt = aD(it), kt = it === S2 ? { width: k2, height: R6 } : { width: Mt.width, height: Mt.height }, Gt = {}, Ot = eMt(tt, Z3, kt, null, { hv: Z3.hv, boundingMode: Z3.bounding }, Gt);
                if (!aD(tt).isNew && Ot) {
                  for (var ce2 = Z3.transition, ae2 = {}, de2 = 0; de2 < B3.length; de2++) {
                    var we2 = B3[de2], Se2 = Gt[we2];
                    ce2 && (PW(ce2) || Lu(ce2, we2) >= 0) ? ae2[we2] = Se2 : tt[we2] = Se2;
                  }
                  Qf2(tt, ae2, r5, 0);
                } else
                  tt.attr(Gt);
              }
            }
          }, s.prototype._clear = function() {
            var r5 = this, g5 = this._elMap;
            g5.each(function(b6) {
              CCt(b6, aD(b6).option, g5, r5._lastGraphicModel);
            }), this._elMap = Ps();
          }, s.prototype.dispose = function() {
            this._clear();
          }, s.type = "graphic", s;
        }(P0);
        function $Ut(c5) {
          var s = Ls(P3e, c5) ? P3e[c5] : St(c5), r5 = new s({});
          return aD(r5).type = c5, r5;
        }
        function L3e(c5, s, r5, g5) {
          var b6 = $Ut(r5);
          return s.add(b6), g5.set(c5, b6), aD(b6).id = c5, aD(b6).isNew = true, b6;
        }
        function CCt(c5, s, r5, g5) {
          var b6 = c5 && c5.parent;
          b6 && (c5.type === "group" && c5.traverse(function(S2) {
            CCt(S2, s, r5, g5);
          }), yCt(c5, s, g5), r5.removeKey(aD(c5).id));
        }
        function O3e(c5, s, r5, g5) {
          if (!c5.isGroup) {
            var b6 = c5;
            b6.cursor = tc2(s.cursor, SM.prototype.cursor), b6.z = tc2(s.z, r5 || 0), b6.zlevel = tc2(s.zlevel, g5 || 0);
            var S2 = s.z2;
            S2 != null && (b6.z2 = S2 || 0);
          }
          Ye2(nf2(s), function(A2) {
            var k2 = s[A2];
            A2.indexOf("on") === 0 && Tl(k2) && (c5[A2] = k2);
          }), c5.draggable = s.draggable, s.name != null && (c5.name = s.name), s.id != null && (c5.id = s.id);
        }
        function I$n(c5) {
          return c5 = sa2({}, c5), Ye2(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(rTe), function(s) {
            delete c5[s];
          }), c5;
        }
        function D$n(c5, s, r5) {
          var g5 = Pl(c5).eventData;
          !c5.silent && !c5.ignore && !g5 && (g5 = Pl(c5).eventData = { componentType: "graphic", componentIndex: s.componentIndex, name: c5.name }), g5 && (g5.info = r5.info);
        }
        function E$n(c5) {
          c5.registerComponentModel(T$n), c5.registerComponentView(A$n), c5.registerPreprocessor(function(s) {
            var r5 = s.graphic;
            ja2(r5) ? !r5[0] || !r5[0].elements ? s.graphic = [{ elements: r5 }] : s.graphic = [s.graphic[0]] : r5 && !r5.elements && (s.graphic = [{ elements: [r5] }]);
          });
        }
        var R3e = ["x", "y", "radius", "angle", "single"], k$n = ["cartesian2d", "polar", "singleAxis"];
        function P$n(c5) {
          var s = c5.get("coordinateSystem");
          return Lu(k$n, s) >= 0;
        }
        function f9(c5) {
          return c5 + "Axis";
        }
        function L$n(c5, s) {
          var r5 = Ps(), g5 = [], b6 = Ps();
          c5.eachComponent({ mainType: "dataZoom", query: s }, function(G3) {
            b6.get(G3.uid) || k2(G3);
          });
          var S2;
          do
            S2 = false, c5.eachComponent("dataZoom", A2);
          while (S2);
          function A2(G3) {
            !b6.get(G3.uid) && R6(G3) && (k2(G3), S2 = true);
          }
          function k2(G3) {
            b6.set(G3.uid, true), g5.push(G3), B3(G3);
          }
          function R6(G3) {
            var Z3 = false;
            return G3.eachTargetAxis(function(X3, tt) {
              var it = r5.get(X3);
              it && it[tt] && (Z3 = true);
            }), Z3;
          }
          function B3(G3) {
            G3.eachTargetAxis(function(Z3, X3) {
              (r5.get(Z3) || r5.set(Z3, []))[X3] = true;
            });
          }
          return g5;
        }
        function N3e(c5) {
          var s = c5.ecModel, r5 = { infoList: [], infoMap: Ps() };
          return c5.eachTargetAxis(function(g5, b6) {
            var S2 = s.getComponent(f9(g5), b6);
            if (S2) {
              var A2 = S2.getCoordSysModel();
              if (A2) {
                var k2 = A2.uid, R6 = r5.infoMap.get(k2);
                R6 || (R6 = { model: A2, axisModels: [] }, r5.infoList.push(R6), r5.infoMap.set(k2, R6)), R6.axisModels.push(S2);
              }
            }
          }), r5;
        }
        var YUt = function() {
          function c5() {
            this.indexList = [], this.indexMap = [];
          }
          return c5.prototype.add = function(s) {
            this.indexMap[s] || (this.indexList.push(s), this.indexMap[s] = true);
          }, c5;
        }(), O$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._autoThrottle = true, r5._noTarget = true, r5._rangePropMode = ["percent", "percent"], r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            var S2 = F3e(r5);
            this.settledOption = S2, this.mergeDefaultAndTheme(r5, b6), this._doInit(S2);
          }, s.prototype.mergeOption = function(r5) {
            var g5 = F3e(r5);
            bu(this.option, r5, true), bu(this.settledOption, g5, true), this._doInit(g5);
          }, s.prototype._doInit = function(r5) {
            var g5 = this.option;
            this._setDefaultThrottle(r5), this._updateRangeUse(r5);
            var b6 = this.settledOption;
            Ye2([["start", "startValue"], ["end", "endValue"]], function(S2, A2) {
              this._rangePropMode[A2] === "value" && (g5[S2[0]] = b6[S2[0]] = null);
            }, this), this._resetTarget();
          }, s.prototype._resetTarget = function() {
            var r5 = this.get("orient", true), g5 = this._targetAxisInfoMap = Ps(), b6 = this._fillSpecifiedTargetAxis(g5);
            b6 ? this._orient = r5 || this._makeAutoOrientByTargetAxis() : (this._orient = r5 || "horizontal", this._fillAutoTargetAxisByOrient(g5, this._orient)), this._noTarget = true, g5.each(function(S2) {
              S2.indexList.length && (this._noTarget = false);
            }, this);
          }, s.prototype._fillSpecifiedTargetAxis = function(r5) {
            var g5 = false;
            return Ye2(R3e, function(b6) {
              var S2 = this.getReferringComponents(f9(b6), VSt);
              if (S2.specified) {
                g5 = true;
                var A2 = new YUt();
                Ye2(S2.models, function(k2) {
                  A2.add(k2.componentIndex);
                }), r5.set(b6, A2);
              }
            }, this), g5;
          }, s.prototype._fillAutoTargetAxisByOrient = function(r5, g5) {
            var b6 = this.ecModel, S2 = true;
            if (S2) {
              var A2 = g5 === "vertical" ? "y" : "x", k2 = b6.findComponents({ mainType: A2 + "Axis" });
              R6(k2, A2);
            }
            if (S2) {
              var k2 = b6.findComponents({ mainType: "singleAxis", filter: function(G3) {
                return G3.get("orient", true) === g5;
              } });
              R6(k2, "single");
            }
            function R6(B3, G3) {
              var Z3 = B3[0];
              if (Z3) {
                var X3 = new YUt();
                if (X3.add(Z3.componentIndex), r5.set(G3, X3), S2 = false, G3 === "x" || G3 === "y") {
                  var tt = Z3.getReferringComponents("grid", E0).models[0];
                  tt && Ye2(B3, function(it) {
                    Z3.componentIndex !== it.componentIndex && tt === it.getReferringComponents("grid", E0).models[0] && X3.add(it.componentIndex);
                  });
                }
              }
            }
            S2 && Ye2(R3e, function(B3) {
              if (S2) {
                var G3 = b6.findComponents({ mainType: f9(B3), filter: function(X3) {
                  return X3.get("type", true) === "category";
                } });
                if (G3[0]) {
                  var Z3 = new YUt();
                  Z3.add(G3[0].componentIndex), r5.set(B3, Z3), S2 = false;
                }
              }
            }, this);
          }, s.prototype._makeAutoOrientByTargetAxis = function() {
            var r5;
            return this.eachTargetAxis(function(g5) {
              !r5 && (r5 = g5);
            }, this), r5 === "y" ? "vertical" : "horizontal";
          }, s.prototype._setDefaultThrottle = function(r5) {
            if (r5.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
              var g5 = this.ecModel.option;
              this.option.throttle = g5.animation && g5.animationDurationUpdate > 0 ? 100 : 20;
            }
          }, s.prototype._updateRangeUse = function(r5) {
            var g5 = this._rangePropMode, b6 = this.get("rangeMode");
            Ye2([["start", "startValue"], ["end", "endValue"]], function(S2, A2) {
              var k2 = r5[S2[0]] != null, R6 = r5[S2[1]] != null;
              k2 && !R6 ? g5[A2] = "percent" : !k2 && R6 ? g5[A2] = "value" : b6 ? g5[A2] = b6[A2] : k2 && (g5[A2] = "percent");
            });
          }, s.prototype.noTarget = function() {
            return this._noTarget;
          }, s.prototype.getFirstTargetAxisModel = function() {
            var r5;
            return this.eachTargetAxis(function(g5, b6) {
              r5 == null && (r5 = this.ecModel.getComponent(f9(g5), b6));
            }, this), r5;
          }, s.prototype.eachTargetAxis = function(r5, g5) {
            this._targetAxisInfoMap.each(function(b6, S2) {
              Ye2(b6.indexList, function(A2) {
                r5.call(g5, S2, A2);
              });
            });
          }, s.prototype.getAxisProxy = function(r5, g5) {
            var b6 = this.getAxisModel(r5, g5);
            if (b6)
              return b6.__dzAxisProxy;
          }, s.prototype.getAxisModel = function(r5, g5) {
            var b6 = this._targetAxisInfoMap.get(r5);
            if (b6 && b6.indexMap[g5])
              return this.ecModel.getComponent(f9(r5), g5);
          }, s.prototype.setRawRange = function(r5) {
            var g5 = this.option, b6 = this.settledOption;
            Ye2([["start", "startValue"], ["end", "endValue"]], function(S2) {
              (r5[S2[0]] != null || r5[S2[1]] != null) && (g5[S2[0]] = b6[S2[0]] = r5[S2[0]], g5[S2[1]] = b6[S2[1]] = r5[S2[1]]);
            }, this), this._updateRangeUse(r5);
          }, s.prototype.setCalculatedRange = function(r5) {
            var g5 = this.option;
            Ye2(["start", "startValue", "end", "endValue"], function(b6) {
              g5[b6] = r5[b6];
            });
          }, s.prototype.getPercentRange = function() {
            var r5 = this.findRepresentativeAxisProxy();
            if (r5)
              return r5.getDataPercentWindow();
          }, s.prototype.getValueRange = function(r5, g5) {
            if (r5 == null && g5 == null) {
              var b6 = this.findRepresentativeAxisProxy();
              if (b6)
                return b6.getDataValueWindow();
            } else
              return this.getAxisProxy(r5, g5).getDataValueWindow();
          }, s.prototype.findRepresentativeAxisProxy = function(r5) {
            if (r5)
              return r5.__dzAxisProxy;
            for (var g5, b6 = this._targetAxisInfoMap.keys(), S2 = 0; S2 < b6.length; S2++)
              for (var A2 = b6[S2], k2 = this._targetAxisInfoMap.get(A2), R6 = 0; R6 < k2.indexList.length; R6++) {
                var B3 = this.getAxisProxy(A2, k2.indexList[R6]);
                if (B3.hostedBy(this))
                  return B3;
                g5 || (g5 = B3);
              }
            return g5;
          }, s.prototype.getRangePropMode = function() {
            return this._rangePropMode.slice();
          }, s.prototype.getOrient = function() {
            return this._orient;
          }, s.type = "dataZoom", s.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], s.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, s;
        }(Rh2);
        function F3e(c5) {
          var s = {};
          return Ye2(["start", "end", "startValue", "endValue", "throttle"], function(r5) {
            c5.hasOwnProperty(r5) && (s[r5] = c5[r5]);
          }), s;
        }
        var sft = O$n, R$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "dataZoom.select", s;
        }(sft), N$n = R$n, F$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            this.dataZoomModel = r5, this.ecModel = g5, this.api = b6;
          }, s.type = "dataZoom", s;
        }(P0), KUt = F$n, V$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "dataZoom.select", s;
        }(KUt), B$n = V$n, OX = Ye2, V3e = h2, z$n = function() {
          function c5(s, r5, g5, b6) {
            this._dimName = s, this._axisIndex = r5, this.ecModel = b6, this._dataZoomModel = g5;
          }
          return c5.prototype.hostedBy = function(s) {
            return this._dataZoomModel === s;
          }, c5.prototype.getDataValueWindow = function() {
            return this._valueWindow.slice();
          }, c5.prototype.getDataPercentWindow = function() {
            return this._percentWindow.slice();
          }, c5.prototype.getTargetSeriesModels = function() {
            var s = [];
            return this.ecModel.eachSeries(function(r5) {
              if (P$n(r5)) {
                var g5 = f9(this._dimName), b6 = r5.getReferringComponents(g5, E0).models[0];
                b6 && this._axisIndex === b6.componentIndex && s.push(r5);
              }
            }, this), s;
          }, c5.prototype.getAxisModel = function() {
            return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
          }, c5.prototype.getMinMaxSpan = function() {
            return Ml(this._minMaxSpan);
          }, c5.prototype.calculateDataWindow = function(s) {
            var r5 = this._dataExtent, g5 = this.getAxisModel(), b6 = g5.axis.scale, S2 = this._dataZoomModel.getRangePropMode(), A2 = [0, 100], k2 = [], R6 = [], B3;
            OX(["start", "end"], function(X3, tt) {
              var it = s[X3], pt = s[X3 + "Value"];
              S2[tt] === "percent" ? (it == null && (it = A2[tt]), pt = b6.parse(fh2(it, A2, r5))) : (B3 = true, pt = pt == null ? r5[tt] : b6.parse(pt), it = fh2(pt, r5, A2)), R6[tt] = pt, k2[tt] = it;
            }), V3e(R6), V3e(k2);
            var G3 = this._minMaxSpan;
            B3 ? Z3(R6, k2, r5, A2, false) : Z3(k2, R6, A2, r5, true);
            function Z3(X3, tt, it, pt, mt) {
              var Mt = mt ? "Span" : "ValueSpan";
              DW(0, X3, it, "all", G3["min" + Mt], G3["max" + Mt]);
              for (var kt = 0; kt < 2; kt++)
                tt[kt] = fh2(X3[kt], it, pt, true), mt && (tt[kt] = b6.parse(tt[kt]));
            }
            return { valueWindow: R6, percentWindow: k2 };
          }, c5.prototype.reset = function(s) {
            if (s === this._dataZoomModel) {
              var r5 = this.getTargetSeriesModels();
              this._dataExtent = j$n(this, this._dimName, r5), this._updateMinMaxSpan();
              var g5 = this.calculateDataWindow(s.settledOption);
              this._valueWindow = g5.valueWindow, this._percentWindow = g5.percentWindow, this._setAxisModel();
            }
          }, c5.prototype.filterData = function(s, r5) {
            if (s !== this._dataZoomModel)
              return;
            var g5 = this._dimName, b6 = this.getTargetSeriesModels(), S2 = s.get("filterMode"), A2 = this._valueWindow;
            if (S2 === "none")
              return;
            OX(b6, function(R6) {
              var B3 = R6.getData(), G3 = B3.mapDimensionsAll(g5);
              if (G3.length) {
                if (S2 === "weakFilter") {
                  var Z3 = B3.getStore(), X3 = Ha2(G3, function(tt) {
                    return B3.getDimensionIndex(tt);
                  }, B3);
                  B3.filterSelf(function(tt) {
                    for (var it, pt, mt, Mt = 0; Mt < G3.length; Mt++) {
                      var kt = Z3.get(X3[Mt], tt), Gt = !isNaN(kt), Ot = kt < A2[0], ce2 = kt > A2[1];
                      if (Gt && !Ot && !ce2)
                        return true;
                      Gt && (mt = true), Ot && (it = true), ce2 && (pt = true);
                    }
                    return mt && it && pt;
                  });
                } else
                  OX(G3, function(tt) {
                    if (S2 === "empty")
                      R6.setData(B3 = B3.map(tt, function(pt) {
                        return k2(pt) ? pt : NaN;
                      }));
                    else {
                      var it = {};
                      it[tt] = A2, B3.selectRange(it);
                    }
                  });
                OX(G3, function(tt) {
                  B3.setApproximateExtent(A2, tt);
                });
              }
            });
            function k2(R6) {
              return R6 >= A2[0] && R6 <= A2[1];
            }
          }, c5.prototype._updateMinMaxSpan = function() {
            var s = this._minMaxSpan = {}, r5 = this._dataZoomModel, g5 = this._dataExtent;
            OX(["min", "max"], function(b6) {
              var S2 = r5.get(b6 + "Span"), A2 = r5.get(b6 + "ValueSpan");
              A2 != null && (A2 = this.getAxisModel().axis.scale.parse(A2)), A2 != null ? S2 = fh2(g5[0] + A2, g5, [0, 100], true) : S2 != null && (A2 = fh2(S2, [0, 100], g5, true) - g5[0]), s[b6 + "Span"] = S2, s[b6 + "ValueSpan"] = A2;
            }, this);
          }, c5.prototype._setAxisModel = function() {
            var s = this.getAxisModel(), r5 = this._percentWindow, g5 = this._valueWindow;
            if (r5) {
              var b6 = jlt(g5, [0, 500]);
              b6 = Math.min(b6, 20);
              var S2 = s.axis.scale.rawExtentInfo;
              r5[0] !== 0 && S2.setDeterminedMinMax("min", +g5[0].toFixed(b6)), r5[1] !== 100 && S2.setDeterminedMinMax("max", +g5[1].toFixed(b6)), S2.freeze();
            }
          }, c5;
        }();
        function j$n(c5, s, r5) {
          var g5 = [1 / 0, -1 / 0];
          OX(r5, function(A2) {
            f9n(g5, A2.getData(), s);
          });
          var b6 = c5.getAxisModel(), S2 = $Ie(b6.axis.scale, b6, g5).calculate();
          return [S2.min, S2.max];
        }
        var W$n = z$n, G$n = { getTargetSeries: function(c5) {
          function s(b6) {
            c5.eachComponent("dataZoom", function(S2) {
              S2.eachTargetAxis(function(A2, k2) {
                var R6 = c5.getComponent(f9(A2), k2);
                b6(A2, k2, R6, S2);
              });
            });
          }
          s(function(b6, S2, A2, k2) {
            A2.__dzAxisProxy = null;
          });
          var r5 = [];
          s(function(b6, S2, A2, k2) {
            A2.__dzAxisProxy || (A2.__dzAxisProxy = new W$n(b6, S2, k2, c5), r5.push(A2.__dzAxisProxy));
          });
          var g5 = Ps();
          return Ye2(r5, function(b6) {
            Ye2(b6.getTargetSeriesModels(), function(S2) {
              g5.set(S2.uid, S2);
            });
          }), g5;
        }, overallReset: function(c5, s) {
          c5.eachComponent("dataZoom", function(r5) {
            r5.eachTargetAxis(function(g5, b6) {
              r5.getAxisProxy(g5, b6).reset(r5);
            }), r5.eachTargetAxis(function(g5, b6) {
              r5.getAxisProxy(g5, b6).filterData(r5, s);
            });
          }), c5.eachComponent("dataZoom", function(r5) {
            var g5 = r5.findRepresentativeAxisProxy();
            if (g5) {
              var b6 = g5.getDataPercentWindow(), S2 = g5.getDataValueWindow();
              r5.setCalculatedRange({ start: b6[0], end: b6[1], startValue: S2[0], endValue: S2[1] });
            }
          });
        } }, H$n = G$n;
        function U$n(c5) {
          c5.registerAction("dataZoom", function(s, r5) {
            var g5 = L$n(r5, s);
            Ye2(g5, function(b6) {
              b6.setRawRange({ start: s.start, end: s.end, startValue: s.startValue, endValue: s.endValue });
            });
          });
        }
        var B3e = false;
        function XUt(c5) {
          B3e || (B3e = true, c5.registerProcessor(c5.PRIORITY.PROCESSOR.FILTER, H$n), U$n(c5), c5.registerSubTypeDefaulter("dataZoom", function() {
            return "slider";
          }));
        }
        function q$n(c5) {
          c5.registerComponentModel(N$n), c5.registerComponentView(B$n), XUt(c5);
        }
        var oD = function() {
          function c5() {
          }
          return c5;
        }(), z3e = {};
        function RX(c5, s) {
          z3e[c5] = s;
        }
        function j3e(c5) {
          return z3e[c5];
        }
        var Z$n = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.optionUpdated = function() {
            c5.prototype.optionUpdated.apply(this, arguments);
            var r5 = this.ecModel;
            Ye2(this.option.feature, function(g5, b6) {
              var S2 = j3e(b6);
              S2 && (S2.getDefaultOption && (S2.defaultOption = S2.getDefaultOption(r5)), bu(g5, S2.defaultOption));
            });
          }, s.type = "toolbox", s.layoutMode = { type: "box", ignoreSize: true }, s.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, s;
        }(Rh2), $$n = Z$n;
        function Y$n(c5, s, r5) {
          var g5 = s.getBoxLayoutParams(), b6 = s.get("padding"), S2 = { width: r5.getWidth(), height: r5.getHeight() }, A2 = $m(g5, S2, b6);
          lW(s.get("orient"), c5, s.get("itemGap"), A2.width, A2.height), eMt(c5, g5, S2, b6);
        }
        function W3e(c5, s) {
          var r5 = aX(s.get("padding")), g5 = s.getItemStyle(["color", "opacity"]);
          return g5.fill = s.get("backgroundColor"), c5 = new zf2({ shape: { x: c5.x - r5[3], y: c5.y - r5[0], width: c5.width + r5[1] + r5[3], height: c5.height + r5[0] + r5[2], r: s.get("borderRadius") }, style: g5, silent: true, z2: -1 }), c5;
        }
        var K$n = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            var A2 = this.group;
            if (A2.removeAll(), !r5.get("show"))
              return;
            var k2 = +r5.get("itemSize"), R6 = r5.get("feature") || {}, B3 = this._features || (this._features = {}), G3 = [];
            Ye2(R6, function(tt, it) {
              G3.push(it);
            }), new wR(this._featureNames || [], G3).add(Z3).update(Z3).remove(Au(Z3, null)).execute(), this._featureNames = G3;
            function Z3(tt, it) {
              var pt = G3[tt], mt = G3[it], Mt = R6[pt], kt = new Ag2(Mt, r5, r5.ecModel), Gt;
              if (S2 && S2.newTitle != null && S2.featureName === pt && (Mt.title = S2.newTitle), pt && !mt) {
                if (X$n(pt))
                  Gt = { onclick: kt.option.onclick, featureName: pt };
                else {
                  var Ot = j3e(pt);
                  if (!Ot)
                    return;
                  Gt = new Ot();
                }
                B3[pt] = Gt;
              } else if (Gt = B3[mt], !Gt)
                return;
              Gt.uid = nX("toolbox-feature"), Gt.model = kt, Gt.ecModel = g5, Gt.api = b6;
              var ce2 = Gt instanceof oD;
              if (!pt && mt) {
                ce2 && Gt.dispose && Gt.dispose(g5, b6);
                return;
              }
              if (!kt.get("show") || ce2 && Gt.unusable) {
                ce2 && Gt.remove && Gt.remove(g5, b6);
                return;
              }
              X3(kt, Gt, pt), kt.setIconStatus = function(ae2, de2) {
                var we2 = this.option, Se2 = this.iconPaths;
                we2.iconStatus = we2.iconStatus || {}, we2.iconStatus[ae2] = de2, Se2[ae2] && (de2 === "emphasis" ? GI : HI)(Se2[ae2]);
              }, Gt instanceof oD && Gt.render && Gt.render(kt, g5, b6, S2);
            }
            function X3(tt, it, pt) {
              var mt = tt.getModel("iconStyle"), Mt = tt.getModel(["emphasis", "iconStyle"]), kt = it instanceof oD && it.getIcons ? it.getIcons() : tt.get("icon"), Gt = tt.get("title") || {}, Ot, ce2;
              gs(kt) ? (Ot = {}, Ot[pt] = kt) : Ot = kt, gs(Gt) ? (ce2 = {}, ce2[pt] = Gt) : ce2 = Gt;
              var ae2 = tt.iconPaths = {};
              Ye2(Ot, function(de2, we2) {
                var Se2 = ph2(de2, {}, { x: -k2 / 2, y: -k2 / 2, width: k2, height: k2 });
                Se2.setStyle(mt.getItemStyle());
                var Oe2 = Se2.ensureState("emphasis");
                Oe2.style = Mt.getItemStyle();
                var je2 = new hh2({ style: { text: ce2[we2], align: Mt.get("textAlign"), borderRadius: Mt.get("textBorderRadius"), padding: Mt.get("textPadding"), fill: null }, ignore: true });
                Se2.setTextContent(je2), Ub2({ el: Se2, componentModel: r5, itemName: we2, formatterParamsExtra: { title: ce2[we2] } }), Se2.__title = ce2[we2], Se2.on("mouseover", function() {
                  var rn = Mt.getItemStyle(), qe2 = r5.get("orient") === "vertical" ? r5.get("right") == null ? "right" : "left" : r5.get("bottom") == null ? "bottom" : "top";
                  je2.setStyle({ fill: Mt.get("textFill") || rn.fill || rn.stroke || "#000", backgroundColor: Mt.get("textBackgroundColor") }), Se2.setTextConfig({ position: Mt.get("textPosition") || qe2 }), je2.ignore = !r5.get("showTitle"), GI(this);
                }).on("mouseout", function() {
                  tt.get(["iconStatus", we2]) !== "emphasis" && HI(this), je2.hide();
                }), (tt.get(["iconStatus", we2]) === "emphasis" ? GI : HI)(Se2), A2.add(Se2), Se2.on("click", Cs(it.onclick, it, g5, b6, we2)), ae2[we2] = Se2;
              });
            }
            Y$n(A2, r5, b6), A2.add(W3e(A2.getBoundingRect(), r5)), A2.eachChild(function(tt) {
              var it = tt.__title, pt = tt.ensureState("emphasis"), mt = pt.textConfig || (pt.textConfig = {}), Mt = tt.getTextContent(), kt = Mt && Mt.states.emphasis;
              if (kt && !Tl(kt) && it) {
                var Gt = kt.style || (kt.style = {}), Ot = tR(it, hh2.makeFont(Gt)), ce2 = tt.x + A2.x, ae2 = tt.y + A2.y + k2, de2 = false;
                ae2 + Ot.height > b6.getHeight() && (mt.position = "top", de2 = true);
                var we2 = de2 ? -5 - Ot.height : k2 + 8;
                ce2 + Ot.width / 2 > b6.getWidth() ? (mt.position = ["100%", we2], Gt.align = "right") : ce2 - Ot.width / 2 < 0 && (mt.position = [0, we2], Gt.align = "left");
              }
            });
          }, s.prototype.updateView = function(r5, g5, b6, S2) {
            Ye2(this._features, function(A2) {
              A2 instanceof oD && A2.updateView && A2.updateView(A2.model, g5, b6, S2);
            });
          }, s.prototype.remove = function(r5, g5) {
            Ye2(this._features, function(b6) {
              b6 instanceof oD && b6.remove && b6.remove(r5, g5);
            }), this.group.removeAll();
          }, s.prototype.dispose = function(r5, g5) {
            Ye2(this._features, function(b6) {
              b6 instanceof oD && b6.dispose && b6.dispose(r5, g5);
            });
          }, s.type = "toolbox", s;
        }(P0);
        function X$n(c5) {
          return c5.indexOf("my") === 0;
        }
        var Q$n = K$n, J$n = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.onclick = function(r5, g5) {
            var b6 = this.model, S2 = b6.get("name") || r5.get("title.0.text") || "echarts", A2 = g5.getZr().painter.getType() === "svg", k2 = A2 ? "svg" : b6.get("type", true) || "png", R6 = g5.getConnectedDataURL({ type: k2, backgroundColor: b6.get("backgroundColor", true) || r5.get("backgroundColor") || "#fff", connectedBackgroundColor: b6.get("connectedBackgroundColor"), excludeComponents: b6.get("excludeComponents"), pixelRatio: b6.get("pixelRatio") }), B3 = os.browser;
            if (Tl(MouseEvent) && (B3.newEdge || !B3.ie && !B3.edge)) {
              var G3 = document.createElement("a");
              G3.download = S2 + "." + k2, G3.target = "_blank", G3.href = R6;
              var Z3 = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
              G3.dispatchEvent(Z3);
            } else if (window.navigator.msSaveOrOpenBlob || A2) {
              var X3 = R6.split(","), tt = X3[0].indexOf("base64") > -1, it = A2 ? decodeURIComponent(X3[1]) : X3[1];
              tt && (it = window.atob(it));
              var pt = S2 + "." + k2;
              if (window.navigator.msSaveOrOpenBlob) {
                for (var mt = it.length, Mt = new Uint8Array(mt); mt--; )
                  Mt[mt] = it.charCodeAt(mt);
                var kt = new Blob([Mt]);
                window.navigator.msSaveOrOpenBlob(kt, pt);
              } else {
                var Gt = document.createElement("iframe");
                document.body.appendChild(Gt);
                var Ot = Gt.contentWindow, ce2 = Ot.document;
                ce2.open("image/svg+xml", "replace"), ce2.write(it), ce2.close(), Ot.focus(), ce2.execCommand("SaveAs", true, pt), document.body.removeChild(Gt);
              }
            } else {
              var ae2 = b6.get("lang"), de2 = '<body style="margin:0;"><img src="' + R6 + '" style="max-width:100%;" title="' + (ae2 && ae2[0] || "") + '" /></body>', we2 = window.open();
              we2.document.write(de2), we2.document.title = S2;
            }
          }, s.getDefaultOption = function(r5) {
            var g5 = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: r5.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: r5.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
            return g5;
          }, s;
        }(oD), tYn = J$n, G3e = "__ec_magicType_stack__", eYn = [["line", "bar"], ["stack"]], nYn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.getIcons = function() {
            var r5 = this.model, g5 = r5.get("icon"), b6 = {};
            return Ye2(r5.get("type"), function(S2) {
              g5[S2] && (b6[S2] = g5[S2]);
            }), b6;
          }, s.getDefaultOption = function(r5) {
            var g5 = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: r5.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
            return g5;
          }, s.prototype.onclick = function(r5, g5, b6) {
            var S2 = this.model, A2 = S2.get(["seriesIndex", b6]);
            if (H3e[b6]) {
              var k2 = { series: [] }, R6 = function(Z3) {
                var X3 = Z3.subType, tt = Z3.id, it = H3e[b6](X3, tt, Z3, S2);
                it && (Cl(it, Z3.option), k2.series.push(it));
                var pt = Z3.coordinateSystem;
                if (pt && pt.type === "cartesian2d" && (b6 === "line" || b6 === "bar")) {
                  var mt = pt.getAxesByScale("ordinal")[0];
                  if (mt) {
                    var Mt = mt.dim, kt = Mt + "Axis", Gt = Z3.getReferringComponents(kt, E0).models[0], Ot = Gt.componentIndex;
                    k2[kt] = k2[kt] || [];
                    for (var ce2 = 0; ce2 <= Ot; ce2++)
                      k2[kt][Ot] = k2[kt][Ot] || {};
                    k2[kt][Ot].boundaryGap = b6 === "bar";
                  }
                }
              };
              Ye2(eYn, function(Z3) {
                Lu(Z3, b6) >= 0 && Ye2(Z3, function(X3) {
                  S2.setIconStatus(X3, "normal");
                });
              }), S2.setIconStatus(b6, "emphasis"), r5.eachComponent({ mainType: "series", query: A2 == null ? null : { seriesIndex: A2 } }, R6);
              var B3, G3 = b6;
              b6 === "stack" && (B3 = bu({ stack: S2.option.title.tiled, tiled: S2.option.title.stack }, S2.option.title), S2.get(["iconStatus", b6]) !== "emphasis" && (G3 = "tiled")), g5.dispatchAction({ type: "changeMagicType", currentType: G3, newOption: k2, newTitle: B3, featureName: "magicType" });
            }
          }, s;
        }(oD), H3e = { line: function(c5, s, r5, g5) {
          if (c5 === "bar")
            return bu({ id: s, type: "line", data: r5.get("data"), stack: r5.get("stack"), markPoint: r5.get("markPoint"), markLine: r5.get("markLine") }, g5.get(["option", "line"]) || {}, true);
        }, bar: function(c5, s, r5, g5) {
          if (c5 === "line")
            return bu({ id: s, type: "bar", data: r5.get("data"), stack: r5.get("stack"), markPoint: r5.get("markPoint"), markLine: r5.get("markLine") }, g5.get(["option", "bar"]) || {}, true);
        }, stack: function(c5, s, r5, g5) {
          var b6 = r5.get("stack") === G3e;
          if (c5 === "line" || c5 === "bar")
            return g5.setIconStatus("stack", b6 ? "normal" : "emphasis"), bu({ id: s, stack: b6 ? "" : G3e }, g5.get(["option", "stack"]) || {}, true);
        } };
        E3({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(c5, s) {
          s.mergeOption(c5.newOption);
        });
        var rYn = nYn, TCt = new Array(60).join("-"), NX = "	";
        function iYn(c5) {
          var s = {}, r5 = [], g5 = [];
          return c5.eachRawSeries(function(b6) {
            var S2 = b6.coordinateSystem;
            if (S2 && (S2.type === "cartesian2d" || S2.type === "polar")) {
              var A2 = S2.getBaseAxis();
              if (A2.type === "category") {
                var k2 = A2.dim + "_" + A2.index;
                s[k2] || (s[k2] = { categoryAxis: A2, valueAxis: S2.getOtherAxis(A2), series: [] }, g5.push({ axisDim: A2.dim, axisIndex: A2.index })), s[k2].series.push(b6);
              } else
                r5.push(b6);
            } else
              r5.push(b6);
          }), { seriesGroupByCategoryAxis: s, other: r5, meta: g5 };
        }
        function aYn(c5) {
          var s = [];
          return Ye2(c5, function(r5, g5) {
            var b6 = r5.categoryAxis, S2 = r5.valueAxis, A2 = S2.dim, k2 = [" "].concat(Ha2(r5.series, function(tt) {
              return tt.name;
            })), R6 = [b6.model.getCategories()];
            Ye2(r5.series, function(tt) {
              var it = tt.getRawData();
              R6.push(tt.getRawData().mapArray(it.mapDimension(A2), function(pt) {
                return pt;
              }));
            });
            for (var B3 = [k2.join(NX)], G3 = 0; G3 < R6[0].length; G3++) {
              for (var Z3 = [], X3 = 0; X3 < R6.length; X3++)
                Z3.push(R6[X3][G3]);
              B3.push(Z3.join(NX));
            }
            s.push(B3.join(`
`));
          }), s.join(`

` + TCt + `

`);
        }
        function oYn(c5) {
          return Ha2(c5, function(s) {
            var r5 = s.getRawData(), g5 = [s.name], b6 = [];
            return r5.each(r5.dimensions, function() {
              for (var S2 = arguments.length, A2 = arguments[S2 - 1], k2 = r5.getName(A2), R6 = 0; R6 < S2 - 1; R6++)
                b6[R6] = arguments[R6];
              g5.push((k2 ? k2 + NX : "") + b6.join(NX));
            }), g5.join(`
`);
          }).join(`

` + TCt + `

`);
        }
        function sYn(c5) {
          var s = iYn(c5);
          return { value: jp([aYn(s.seriesGroupByCategoryAxis), oYn(s.other)], function(r5) {
            return !!r5.replace(/[\n\t\s]/g, "");
          }).join(`

` + TCt + `

`), meta: s.meta };
        }
        function ACt(c5) {
          return c5.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
        }
        function lYn(c5) {
          var s = c5.slice(0, c5.indexOf(`
`));
          if (s.indexOf(NX) >= 0)
            return true;
        }
        var QUt = new RegExp("[" + NX + "]+", "g");
        function uYn(c5) {
          for (var s = c5.split(/\n+/g), r5 = ACt(s.shift()).split(QUt), g5 = [], b6 = Ha2(r5, function(R6) {
            return { name: R6, data: [] };
          }), S2 = 0; S2 < s.length; S2++) {
            var A2 = ACt(s[S2]).split(QUt);
            g5.push(A2.shift());
            for (var k2 = 0; k2 < A2.length; k2++)
              b6[k2] && (b6[k2].data[S2] = A2[k2]);
          }
          return { series: b6, categories: g5 };
        }
        function cYn(c5) {
          for (var s = c5.split(/\n+/g), r5 = ACt(s.shift()), g5 = [], b6 = 0; b6 < s.length; b6++) {
            var S2 = ACt(s[b6]);
            if (S2) {
              var A2 = S2.split(QUt), k2 = "", R6 = void 0, B3 = false;
              isNaN(A2[0]) ? (B3 = true, k2 = A2[0], A2 = A2.slice(1), g5[b6] = { name: k2, value: [] }, R6 = g5[b6].value) : R6 = g5[b6] = [];
              for (var G3 = 0; G3 < A2.length; G3++)
                R6.push(+A2[G3]);
              R6.length === 1 && (B3 ? g5[b6].value = R6[0] : g5[b6] = R6[0]);
            }
          }
          return { name: r5, data: g5 };
        }
        function fYn(c5, s) {
          var r5 = c5.split(new RegExp(`
*` + TCt + `
*`, "g")), g5 = { series: [] };
          return Ye2(r5, function(b6, S2) {
            if (lYn(b6)) {
              var A2 = uYn(b6), k2 = s[S2], R6 = k2.axisDim + "Axis";
              k2 && (g5[R6] = g5[R6] || [], g5[R6][k2.axisIndex] = { data: A2.categories }, g5.series = g5.series.concat(A2.series));
            } else {
              var A2 = cYn(b6);
              g5.series.push(A2);
            }
          }), g5;
        }
        var hYn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.onclick = function(r5, g5) {
            setTimeout(function() {
              g5.dispatchAction({ type: "hideTip" });
            });
            var b6 = g5.getDom(), S2 = this.model;
            this._dom && b6.removeChild(this._dom);
            var A2 = document.createElement("div");
            A2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", A2.style.backgroundColor = S2.get("backgroundColor") || "#fff";
            var k2 = document.createElement("h4"), R6 = S2.get("lang") || [];
            k2.innerHTML = R6[0] || S2.get("title"), k2.style.cssText = "margin:10px 20px", k2.style.color = S2.get("textColor");
            var B3 = document.createElement("div"), G3 = document.createElement("textarea");
            B3.style.cssText = "overflow:auto";
            var Z3 = S2.get("optionToContent"), X3 = S2.get("contentToOption"), tt = sYn(r5);
            if (Tl(Z3)) {
              var it = Z3(g5.getOption());
              gs(it) ? B3.innerHTML = it : cj2(it) && B3.appendChild(it);
            } else {
              G3.readOnly = S2.get("readOnly");
              var pt = G3.style;
              pt.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", pt.color = S2.get("textColor"), pt.borderColor = S2.get("textareaBorderColor"), pt.backgroundColor = S2.get("textareaColor"), G3.value = tt.value, B3.appendChild(G3);
            }
            var mt = tt.meta, Mt = document.createElement("div");
            Mt.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
            var kt = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", Gt = document.createElement("div"), Ot = document.createElement("div");
            kt += ";background-color:" + S2.get("buttonColor"), kt += ";color:" + S2.get("buttonTextColor");
            var ce2 = this;
            function ae2() {
              b6.removeChild(A2), ce2._dom = null;
            }
            flt(Gt, "click", ae2), flt(Ot, "click", function() {
              if (X3 == null && Z3 != null || X3 != null && Z3 == null) {
                ae2();
                return;
              }
              var de2;
              try {
                Tl(X3) ? de2 = X3(B3, g5.getOption()) : de2 = fYn(G3.value, mt);
              } catch (we2) {
                throw ae2(), new Error("Data view format error " + we2);
              }
              de2 && g5.dispatchAction({ type: "changeDataView", newOption: de2 }), ae2();
            }), Gt.innerHTML = R6[1], Ot.innerHTML = R6[2], Ot.style.cssText = Gt.style.cssText = kt, !S2.get("readOnly") && Mt.appendChild(Ot), Mt.appendChild(Gt), A2.appendChild(k2), A2.appendChild(B3), A2.appendChild(Mt), B3.style.height = b6.clientHeight - 80 + "px", b6.appendChild(A2), this._dom = A2;
          }, s.prototype.remove = function(r5, g5) {
            this._dom && g5.getDom().removeChild(this._dom);
          }, s.prototype.dispose = function(r5, g5) {
            this.remove(r5, g5);
          }, s.getDefaultOption = function(r5) {
            var g5 = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: r5.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: r5.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
            return g5;
          }, s;
        }(oD);
        function pYn(c5, s) {
          return Ha2(c5, function(r5, g5) {
            var b6 = s && s[g5];
            if (Wl(b6) && !ja2(b6)) {
              var S2 = Wl(r5) && !ja2(r5);
              S2 || (r5 = { value: r5 });
              var A2 = b6.name != null && r5.name == null;
              return r5 = Cl(r5, b6), A2 && delete r5.name, r5;
            } else
              return r5;
          });
        }
        E3({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(c5, s) {
          var r5 = [];
          Ye2(c5.newOption.series, function(g5) {
            var b6 = s.getSeriesByName(g5.name)[0];
            if (!b6)
              r5.push(sa2({ type: "scatter" }, g5));
            else {
              var S2 = b6.get("data");
              r5.push({ name: g5.name, data: pYn(g5.data, S2) });
            }
          }), s.mergeOption(Cl({ series: r5 }, c5.newOption));
        });
        var dYn = hYn, U3e = Ye2, q3e = Df2();
        function gYn(c5, s) {
          var r5 = JUt(c5);
          U3e(s, function(g5, b6) {
            for (var S2 = r5.length - 1; S2 >= 0; S2--) {
              var A2 = r5[S2];
              if (A2[b6])
                break;
            }
            if (S2 < 0) {
              var k2 = c5.queryComponents({ mainType: "dataZoom", subType: "select", id: b6 })[0];
              if (k2) {
                var R6 = k2.getPercentRange();
                r5[0][b6] = { dataZoomId: b6, start: R6[0], end: R6[1] };
              }
            }
          }), r5.push(s);
        }
        function vYn(c5) {
          var s = JUt(c5), r5 = s[s.length - 1];
          s.length > 1 && s.pop();
          var g5 = {};
          return U3e(r5, function(b6, S2) {
            for (var A2 = s.length - 1; A2 >= 0; A2--)
              if (b6 = s[A2][S2], b6) {
                g5[S2] = b6;
                break;
              }
          }), g5;
        }
        function yYn(c5) {
          q3e(c5).snapshots = null;
        }
        function mYn(c5) {
          return JUt(c5).length;
        }
        function JUt(c5) {
          var s = q3e(c5);
          return s.snapshots || (s.snapshots = [{}]), s.snapshots;
        }
        var bYn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.onclick = function(r5, g5) {
            yYn(r5), g5.dispatchAction({ type: "restore", from: this.uid });
          }, s.getDefaultOption = function(r5) {
            var g5 = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: r5.getLocaleModel().get(["toolbox", "restore", "title"]) };
            return g5;
          }, s;
        }(oD);
        E3({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(c5, s) {
          s.resetOption("recreate");
        });
        var _Yn = bYn, xYn = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], wYn = function() {
          function c5(s, r5, g5) {
            var b6 = this;
            this._targetInfoList = [];
            var S2 = Z3e(r5, s);
            Ye2(SYn, function(A2, k2) {
              (!g5 || !g5.include || Lu(g5.include, k2) >= 0) && A2(S2, b6._targetInfoList);
            });
          }
          return c5.prototype.setOutputRanges = function(s, r5) {
            return this.matchOutputRanges(s, r5, function(g5, b6, S2) {
              if ((g5.coordRanges || (g5.coordRanges = [])).push(b6), !g5.coordRange) {
                g5.coordRange = b6;
                var A2 = eqt[g5.brushType](0, S2, b6);
                g5.__rangeOffset = { offset: X3e[g5.brushType](A2.values, g5.range, [1, 1]), xyMinMax: A2.xyMinMax };
              }
            }), s;
          }, c5.prototype.matchOutputRanges = function(s, r5, g5) {
            Ye2(s, function(b6) {
              var S2 = this.findTargetInfo(b6, r5);
              S2 && S2 !== true && Ye2(S2.coordSyses, function(A2) {
                var k2 = eqt[b6.brushType](1, A2, b6.range, true);
                g5(b6, k2.values, A2, r5);
              });
            }, this);
          }, c5.prototype.setInputRanges = function(s, r5) {
            Ye2(s, function(g5) {
              var b6 = this.findTargetInfo(g5, r5);
              if (g5.range = g5.range || [], b6 && b6 !== true) {
                g5.panelId = b6.panelId;
                var S2 = eqt[g5.brushType](0, b6.coordSys, g5.coordRange), A2 = g5.__rangeOffset;
                g5.range = A2 ? X3e[g5.brushType](S2.values, A2.offset, MYn(S2.xyMinMax, A2.xyMinMax)) : S2.values;
              }
            }, this);
          }, c5.prototype.makePanelOpts = function(s, r5) {
            return Ha2(this._targetInfoList, function(g5) {
              var b6 = g5.getPanelRect();
              return { panelId: g5.panelId, defaultBrushType: r5 ? r5(g5) : null, clipPath: $5e(b6), isTargetByCursor: K5e(b6, s, g5.coordSysModel), getLinearBrushOtherExtent: Y5e(b6) };
            });
          }, c5.prototype.controlSeries = function(s, r5, g5) {
            var b6 = this.findTargetInfo(s, g5);
            return b6 === true || b6 && Lu(b6.coordSyses, r5.coordinateSystem) >= 0;
          }, c5.prototype.findTargetInfo = function(s, r5) {
            for (var g5 = this._targetInfoList, b6 = Z3e(r5, s), S2 = 0; S2 < g5.length; S2++) {
              var A2 = g5[S2], k2 = s.panelId;
              if (k2) {
                if (A2.panelId === k2)
                  return A2;
              } else
                for (var R6 = 0; R6 < $3e.length; R6++)
                  if ($3e[R6](b6, A2))
                    return A2;
            }
            return true;
          }, c5;
        }();
        function tqt(c5) {
          return c5[0] > c5[1] && c5.reverse(), c5;
        }
        function Z3e(c5, s) {
          return Wj2(c5, s, { includeMainTypes: xYn });
        }
        var SYn = { grid: function(c5, s) {
          var r5 = c5.xAxisModels, g5 = c5.yAxisModels, b6 = c5.gridModels, S2 = Ps(), A2 = {}, k2 = {};
          !r5 && !g5 && !b6 || (Ye2(r5, function(R6) {
            var B3 = R6.axis.grid.model;
            S2.set(B3.id, B3), A2[B3.id] = true;
          }), Ye2(g5, function(R6) {
            var B3 = R6.axis.grid.model;
            S2.set(B3.id, B3), k2[B3.id] = true;
          }), Ye2(b6, function(R6) {
            S2.set(R6.id, R6), A2[R6.id] = true, k2[R6.id] = true;
          }), S2.each(function(R6) {
            var B3 = R6.coordinateSystem, G3 = [];
            Ye2(B3.getCartesians(), function(Z3, X3) {
              (Lu(r5, Z3.getAxis("x").model) >= 0 || Lu(g5, Z3.getAxis("y").model) >= 0) && G3.push(Z3);
            }), s.push({ panelId: "grid--" + R6.id, gridModel: R6, coordSysModel: R6, coordSys: G3[0], coordSyses: G3, getPanelRect: Y3e.grid, xAxisDeclared: A2[R6.id], yAxisDeclared: k2[R6.id] });
          }));
        }, geo: function(c5, s) {
          Ye2(c5.geoModels, function(r5) {
            var g5 = r5.coordinateSystem;
            s.push({ panelId: "geo--" + r5.id, geoModel: r5, coordSysModel: r5, coordSys: g5, coordSyses: [g5], getPanelRect: Y3e.geo });
          });
        } }, $3e = [function(c5, s) {
          var r5 = c5.xAxisModel, g5 = c5.yAxisModel, b6 = c5.gridModel;
          return !b6 && r5 && (b6 = r5.axis.grid.model), !b6 && g5 && (b6 = g5.axis.grid.model), b6 && b6 === s.gridModel;
        }, function(c5, s) {
          var r5 = c5.geoModel;
          return r5 && r5 === s.geoModel;
        }], Y3e = { grid: function() {
          return this.coordSys.master.getRect().clone();
        }, geo: function() {
          var c5 = this.coordSys, s = c5.getBoundingRect().clone();
          return s.applyTransform(vo(c5)), s;
        } }, eqt = { lineX: Au(K3e, 0), lineY: Au(K3e, 1), rect: function(c5, s, r5, g5) {
          var b6 = c5 ? s.pointToData([r5[0][0], r5[1][0]], g5) : s.dataToPoint([r5[0][0], r5[1][0]], g5), S2 = c5 ? s.pointToData([r5[0][1], r5[1][1]], g5) : s.dataToPoint([r5[0][1], r5[1][1]], g5), A2 = [tqt([b6[0], S2[0]]), tqt([b6[1], S2[1]])];
          return { values: A2, xyMinMax: A2 };
        }, polygon: function(c5, s, r5, g5) {
          var b6 = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], S2 = Ha2(r5, function(A2) {
            var k2 = c5 ? s.pointToData(A2, g5) : s.dataToPoint(A2, g5);
            return b6[0][0] = Math.min(b6[0][0], k2[0]), b6[1][0] = Math.min(b6[1][0], k2[1]), b6[0][1] = Math.max(b6[0][1], k2[0]), b6[1][1] = Math.max(b6[1][1], k2[1]), k2;
          });
          return { values: S2, xyMinMax: b6 };
        } };
        function K3e(c5, s, r5, g5) {
          var b6 = r5.getAxis(["x", "y"][c5]), S2 = tqt(Ha2([0, 1], function(k2) {
            return s ? b6.coordToData(b6.toLocalCoord(g5[k2]), true) : b6.toGlobalCoord(b6.dataToCoord(g5[k2]));
          })), A2 = [];
          return A2[c5] = S2, A2[1 - c5] = [NaN, NaN], { values: S2, xyMinMax: A2 };
        }
        var X3e = { lineX: Au(Q3e, 0), lineY: Au(Q3e, 1), rect: function(c5, s, r5) {
          return [[c5[0][0] - r5[0] * s[0][0], c5[0][1] - r5[0] * s[0][1]], [c5[1][0] - r5[1] * s[1][0], c5[1][1] - r5[1] * s[1][1]]];
        }, polygon: function(c5, s, r5) {
          return Ha2(c5, function(g5, b6) {
            return [g5[0] - r5[0] * s[b6][0], g5[1] - r5[1] * s[b6][1]];
          });
        } };
        function Q3e(c5, s, r5, g5) {
          return [s[0] - g5[c5] * r5[0], s[1] - g5[c5] * r5[1]];
        }
        function MYn(c5, s) {
          var r5 = J3e(c5), g5 = J3e(s), b6 = [r5[0] / g5[0], r5[1] / g5[1]];
          return isNaN(b6[0]) && (b6[0] = 1), isNaN(b6[1]) && (b6[1] = 1), b6;
        }
        function J3e(c5) {
          return c5 ? [c5[0][1] - c5[0][0], c5[1][1] - c5[1][0]] : [NaN, NaN];
        }
        var nqt = wYn, rqt = Ye2, CYn = Uzt("toolbox-dataZoom_"), TYn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.render = function(r5, g5, b6, S2) {
            this._brushController || (this._brushController = new hUt(b6.getZr()), this._brushController.on("brush", Cs(this._onBrush, this)).mount()), DYn(r5, g5, this, S2, b6), IYn(r5, g5);
          }, s.prototype.onclick = function(r5, g5, b6) {
            AYn[b6].call(this);
          }, s.prototype.remove = function(r5, g5) {
            this._brushController && this._brushController.unmount();
          }, s.prototype.dispose = function(r5, g5) {
            this._brushController && this._brushController.dispose();
          }, s.prototype._onBrush = function(r5) {
            var g5 = r5.areas;
            if (!r5.isEnd || !g5.length)
              return;
            var b6 = {}, S2 = this.ecModel;
            this._brushController.updateCovers([]);
            var A2 = new nqt(iqt(this.model), S2, { include: ["grid"] });
            A2.matchOutputRanges(g5, S2, function(B3, G3, Z3) {
              if (Z3.type === "cartesian2d") {
                var X3 = B3.brushType;
                X3 === "rect" ? (k2("x", Z3, G3[0]), k2("y", Z3, G3[1])) : k2({ lineX: "x", lineY: "y" }[X3], Z3, G3);
              }
            }), gYn(S2, b6), this._dispatchZoomAction(b6);
            function k2(B3, G3, Z3) {
              var X3 = G3.getAxis(B3), tt = X3.model, it = R6(B3, tt, S2), pt = it.findRepresentativeAxisProxy(tt).getMinMaxSpan();
              (pt.minValueSpan != null || pt.maxValueSpan != null) && (Z3 = DW(0, Z3.slice(), X3.scale.getExtent(), 0, pt.minValueSpan, pt.maxValueSpan)), it && (b6[it.id] = { dataZoomId: it.id, startValue: Z3[0], endValue: Z3[1] });
            }
            function R6(B3, G3, Z3) {
              var X3;
              return Z3.eachComponent({ mainType: "dataZoom", subType: "select" }, function(tt) {
                var it = tt.getAxisModel(B3, G3.componentIndex);
                it && (X3 = tt);
              }), X3;
            }
          }, s.prototype._dispatchZoomAction = function(r5) {
            var g5 = [];
            rqt(r5, function(b6, S2) {
              g5.push(Ml(b6));
            }), g5.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: g5 });
          }, s.getDefaultOption = function(r5) {
            var g5 = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: r5.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
            return g5;
          }, s;
        }(oD), AYn = { zoom: function() {
          var c5 = !this._isZoomActive;
          this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: c5 });
        }, back: function() {
          this._dispatchZoomAction(vYn(this.ecModel));
        } };
        function iqt(c5) {
          var s = { xAxisIndex: c5.get("xAxisIndex", true), yAxisIndex: c5.get("yAxisIndex", true), xAxisId: c5.get("xAxisId", true), yAxisId: c5.get("yAxisId", true) };
          return s.xAxisIndex == null && s.xAxisId == null && (s.xAxisIndex = "all"), s.yAxisIndex == null && s.yAxisId == null && (s.yAxisIndex = "all"), s;
        }
        function IYn(c5, s) {
          c5.setIconStatus("back", mYn(s) > 1 ? "emphasis" : "normal");
        }
        function DYn(c5, s, r5, g5, b6) {
          var S2 = r5._isZoomActive;
          g5 && g5.type === "takeGlobalCursor" && (S2 = g5.key === "dataZoomSelect" ? g5.dataZoomSelectActive : false), r5._isZoomActive = S2, c5.setIconStatus("zoom", S2 ? "emphasis" : "normal");
          var A2 = new nqt(iqt(c5), s, { include: ["grid"] }), k2 = A2.makePanelOpts(b6, function(R6) {
            return R6.xAxisDeclared && !R6.yAxisDeclared ? "lineX" : !R6.xAxisDeclared && R6.yAxisDeclared ? "lineY" : "rect";
          });
          r5._brushController.setPanels(k2).enableBrush(S2 && k2.length ? { brushType: "auto", brushStyle: c5.getModel("brushStyle").getItemStyle() } : false);
        }
        A6n("dataZoom", function(c5) {
          var s = c5.getComponent("toolbox", 0), r5 = ["feature", "dataZoom"];
          if (!s || s.get(r5) == null)
            return;
          var g5 = s.getModel(r5), b6 = [], S2 = iqt(g5), A2 = Wj2(c5, S2);
          rqt(A2.xAxisModels, function(R6) {
            return k2(R6, "xAxis", "xAxisIndex");
          }), rqt(A2.yAxisModels, function(R6) {
            return k2(R6, "yAxis", "yAxisIndex");
          });
          function k2(R6, B3, G3) {
            var Z3 = R6.componentIndex, X3 = { type: "select", $fromToolbox: true, filterMode: g5.get("filterMode", true) || "filter", id: CYn + B3 + Z3 };
            X3[G3] = Z3, b6.push(X3);
          }
          return b6;
        });
        var EYn = TYn;
        function kYn(c5) {
          c5.registerComponentModel($$n), c5.registerComponentView(Q$n), RX("saveAsImage", tYn), RX("magicType", rYn), RX("dataView", dYn), RX("dataZoom", EYn), RX("restore", _Yn), Fc2(q$n);
        }
        var PYn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "tooltip", s.dependencies = ["axisPointer"], s.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, s;
        }(Rh2), LYn = PYn;
        function tLe(c5) {
          var s = c5.get("confine");
          return s != null ? !!s : c5.get("renderMode") === "richText";
        }
        function eLe(c5) {
          if (os.domSupported) {
            for (var s = document.documentElement.style, r5 = 0, g5 = c5.length; r5 < g5; r5++)
              if (c5[r5] in s)
                return c5[r5];
          }
        }
        var nLe = eLe(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), OYn = eLe(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
        function rLe(c5, s) {
          if (!c5)
            return s;
          s = tTe(s, true);
          var r5 = c5.indexOf(s);
          return c5 = r5 === -1 ? s : "-" + c5.slice(0, r5) + "-" + s, c5.toLowerCase();
        }
        function RYn(c5, s) {
          var r5 = c5.currentStyle || document.defaultView && document.defaultView.getComputedStyle(c5);
          return r5 ? s ? r5[s] : r5 : null;
        }
        var NYn = rLe(OYn, "transition"), aqt = rLe(nLe, "transform"), FYn = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (os.transform3dSupported ? "will-change:transform;" : "");
        function VYn(c5) {
          return c5 = c5 === "left" ? "right" : c5 === "right" ? "left" : c5 === "top" ? "bottom" : "top", c5;
        }
        function BYn(c5, s, r5) {
          if (!gs(r5) || r5 === "inside")
            return "";
          var g5 = c5.get("backgroundColor"), b6 = c5.get("borderWidth");
          s = oW(s);
          var S2 = VYn(r5), A2 = Math.max(Math.round(b6) * 1.5, 6), k2 = "", R6 = aqt + ":", B3;
          Lu(["left", "right"], S2) > -1 ? (k2 += "top:50%", R6 += "translateY(-50%) rotate(" + (B3 = S2 === "left" ? -225 : -45) + "deg)") : (k2 += "left:50%", R6 += "translateX(-50%) rotate(" + (B3 = S2 === "top" ? 225 : 45) + "deg)");
          var G3 = B3 * Math.PI / 180, Z3 = A2 + b6, X3 = Z3 * Math.abs(Math.cos(G3)) + Z3 * Math.abs(Math.sin(G3)), tt = Math.round(((X3 - Math.SQRT2 * b6) / 2 + Math.SQRT2 * b6 - (X3 - Z3) / 2) * 100) / 100;
          k2 += ";" + S2 + ":-" + tt + "px";
          var it = s + " solid " + b6 + "px;", pt = ["position:absolute;width:" + A2 + "px;height:" + A2 + "px;", k2 + ";" + R6 + ";", "border-bottom:" + it, "border-right:" + it, "background-color:" + g5 + ";"];
          return '<div style="' + pt.join("") + '"></div>';
        }
        function zYn(c5, s) {
          var r5 = "cubic-bezier(0.23,1,0.32,1)", g5 = " " + c5 / 2 + "s " + r5, b6 = "opacity" + g5 + ",visibility" + g5;
          return s || (g5 = " " + c5 + "s " + r5, b6 += os.transformSupported ? "," + aqt + g5 : ",left" + g5 + ",top" + g5), NYn + ":" + b6;
        }
        function iLe(c5, s, r5) {
          var g5 = c5.toFixed(0) + "px", b6 = s.toFixed(0) + "px";
          if (!os.transformSupported)
            return r5 ? "top:" + b6 + ";left:" + g5 + ";" : [["top", b6], ["left", g5]];
          var S2 = os.transform3dSupported, A2 = "translate" + (S2 ? "3d" : "") + "(" + g5 + "," + b6 + (S2 ? ",0" : "") + ")";
          return r5 ? "top:0;left:0;" + aqt + ":" + A2 + ";" : [["top", 0], ["left", 0], [nLe, A2]];
        }
        function jYn(c5) {
          var s = [], r5 = c5.get("fontSize"), g5 = c5.getTextColor();
          g5 && s.push("color:" + g5), s.push("font:" + c5.getFont()), r5 && s.push("line-height:" + Math.round(r5 * 3 / 2) + "px");
          var b6 = c5.get("textShadowColor"), S2 = c5.get("textShadowBlur") || 0, A2 = c5.get("textShadowOffsetX") || 0, k2 = c5.get("textShadowOffsetY") || 0;
          return b6 && S2 && s.push("text-shadow:" + A2 + "px " + k2 + "px " + S2 + "px " + b6), Ye2(["decoration", "align"], function(R6) {
            var B3 = c5.get(R6);
            B3 && s.push("text-" + R6 + ":" + B3);
          }), s.join(";");
        }
        function WYn(c5, s, r5) {
          var g5 = [], b6 = c5.get("transitionDuration"), S2 = c5.get("backgroundColor"), A2 = c5.get("shadowBlur"), k2 = c5.get("shadowColor"), R6 = c5.get("shadowOffsetX"), B3 = c5.get("shadowOffsetY"), G3 = c5.getModel("textStyle"), Z3 = sAe(c5, "html"), X3 = R6 + "px " + B3 + "px " + A2 + "px " + k2;
          return g5.push("box-shadow:" + X3), s && b6 && g5.push(zYn(b6, r5)), S2 && g5.push("background-color:" + S2), Ye2(["width", "color", "radius"], function(tt) {
            var it = "border-" + tt, pt = tTe(it), mt = c5.get(pt);
            mt != null && g5.push(it + ":" + mt + (tt === "color" ? "" : "px"));
          }), g5.push(jYn(G3)), Z3 != null && g5.push("padding:" + aX(Z3).join("px ") + "px"), g5.join(";") + ";";
        }
        function aLe(c5, s, r5, g5, b6) {
          var S2 = s && s.painter;
          if (r5) {
            var A2 = S2 && S2.getViewportRoot();
            A2 && rSt(c5, A2, document.body, g5, b6);
          } else {
            c5[0] = g5, c5[1] = b6;
            var k2 = S2 && S2.getViewportRootOffset();
            k2 && (c5[0] += k2.offsetLeft, c5[1] += k2.offsetTop);
          }
          c5[2] = c5[0] / s.getWidth(), c5[3] = c5[1] / s.getHeight();
        }
        var GYn = function() {
          function c5(s, r5, g5) {
            if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, os.wxa)
              return null;
            var b6 = document.createElement("div");
            b6.domBelongToZr = true, this.el = b6;
            var S2 = this._zr = r5.getZr(), A2 = this._appendToBody = g5 && g5.appendToBody;
            aLe(this._styleCoord, S2, A2, r5.getWidth() / 2, r5.getHeight() / 2), A2 ? document.body.appendChild(b6) : s.appendChild(b6), this._container = s;
            var k2 = this;
            b6.onmouseenter = function() {
              k2._enterable && (clearTimeout(k2._hideTimeout), k2._show = true), k2._inContent = true;
            }, b6.onmousemove = function(R6) {
              if (R6 = R6 || window.event, !k2._enterable) {
                var B3 = S2.handler, G3 = S2.painter.getViewportRoot();
                N1(G3, R6, true), B3.dispatch("mousemove", R6);
              }
            }, b6.onmouseleave = function() {
              k2._inContent = false, k2._enterable && k2._show && k2.hideLater(k2._hideDelay);
            };
          }
          return c5.prototype.update = function(s) {
            var r5 = this._container, g5 = RYn(r5, "position"), b6 = r5.style;
            b6.position !== "absolute" && g5 !== "absolute" && (b6.position = "relative");
            var S2 = s.get("alwaysShowContent");
            S2 && this._moveIfResized(), this.el.className = s.get("className") || "";
          }, c5.prototype.show = function(s, r5) {
            clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
            var g5 = this.el, b6 = g5.style, S2 = this._styleCoord;
            g5.innerHTML ? b6.cssText = FYn + WYn(s, !this._firstShow, this._longHide) + iLe(S2[0], S2[1], true) + ("border-color:" + oW(r5) + ";") + (s.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : b6.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
          }, c5.prototype.setContent = function(s, r5, g5, b6, S2) {
            var A2 = this.el;
            if (s == null) {
              A2.innerHTML = "";
              return;
            }
            var k2 = "";
            if (gs(S2) && g5.get("trigger") === "item" && !tLe(g5) && (k2 = BYn(g5, b6, S2)), gs(s))
              A2.innerHTML = s + k2;
            else if (s) {
              A2.innerHTML = "", ja2(s) || (s = [s]);
              for (var R6 = 0; R6 < s.length; R6++)
                cj2(s[R6]) && s[R6].parentNode !== A2 && A2.appendChild(s[R6]);
              if (k2 && A2.childNodes.length) {
                var B3 = document.createElement("div");
                B3.innerHTML = k2, A2.appendChild(B3);
              }
            }
          }, c5.prototype.setEnterable = function(s) {
            this._enterable = s;
          }, c5.prototype.getSize = function() {
            var s = this.el;
            return [s.offsetWidth, s.offsetHeight];
          }, c5.prototype.moveTo = function(s, r5) {
            var g5 = this._styleCoord;
            if (aLe(g5, this._zr, this._appendToBody, s, r5), g5[0] != null && g5[1] != null) {
              var b6 = this.el.style, S2 = iLe(g5[0], g5[1]);
              Ye2(S2, function(A2) {
                b6[A2[0]] = A2[1];
              });
            }
          }, c5.prototype._moveIfResized = function() {
            var s = this._styleCoord[2], r5 = this._styleCoord[3];
            this.moveTo(s * this._zr.getWidth(), r5 * this._zr.getHeight());
          }, c5.prototype.hide = function() {
            var s = this, r5 = this.el.style;
            r5.visibility = "hidden", r5.opacity = "0", os.transform3dSupported && (r5.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
              return s._longHide = true;
            }, 500);
          }, c5.prototype.hideLater = function(s) {
            this._show && !(this._inContent && this._enterable) && (s ? (this._hideDelay = s, this._show = false, this._hideTimeout = setTimeout(Cs(this.hide, this), s)) : this.hide());
          }, c5.prototype.isShow = function() {
            return this._show;
          }, c5.prototype.dispose = function() {
            this.el.parentNode.removeChild(this.el);
          }, c5;
        }(), HYn = GYn, UYn = function() {
          function c5(s) {
            this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = s.getZr(), sLe(this._styleCoord, this._zr, s.getWidth() / 2, s.getHeight() / 2);
          }
          return c5.prototype.update = function(s) {
            var r5 = s.get("alwaysShowContent");
            r5 && this._moveIfResized();
          }, c5.prototype.show = function() {
            this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
          }, c5.prototype.setContent = function(s, r5, g5, b6, S2) {
            var A2 = this;
            Wl(s) && rf2(""), this.el && this._zr.remove(this.el);
            var k2 = g5.getModel("textStyle");
            this.el = new hh2({ style: { rich: r5.richTextStyles, text: s, lineHeight: 22, borderWidth: 1, borderColor: b6, textShadowColor: k2.get("textShadowColor"), fill: g5.get(["textStyle", "color"]), padding: sAe(g5, "richText"), verticalAlign: "top", align: "left" }, z: g5.get("z") }), Ye2(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(B3) {
              A2.el.style[B3] = g5.get(B3);
            }), Ye2(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(B3) {
              A2.el.style[B3] = k2.get(B3) || 0;
            }), this._zr.add(this.el);
            var R6 = this;
            this.el.on("mouseover", function() {
              R6._enterable && (clearTimeout(R6._hideTimeout), R6._show = true), R6._inContent = true;
            }), this.el.on("mouseout", function() {
              R6._enterable && R6._show && R6.hideLater(R6._hideDelay), R6._inContent = false;
            });
          }, c5.prototype.setEnterable = function(s) {
            this._enterable = s;
          }, c5.prototype.getSize = function() {
            var s = this.el, r5 = this.el.getBoundingRect(), g5 = oLe(s.style);
            return [r5.width + g5.left + g5.right, r5.height + g5.top + g5.bottom];
          }, c5.prototype.moveTo = function(s, r5) {
            var g5 = this.el;
            if (g5) {
              var b6 = this._styleCoord;
              sLe(b6, this._zr, s, r5), s = b6[0], r5 = b6[1];
              var S2 = g5.style, A2 = h9(S2.borderWidth || 0), k2 = oLe(S2);
              g5.x = s + A2 + k2.left, g5.y = r5 + A2 + k2.top, g5.markRedraw();
            }
          }, c5.prototype._moveIfResized = function() {
            var s = this._styleCoord[2], r5 = this._styleCoord[3];
            this.moveTo(s * this._zr.getWidth(), r5 * this._zr.getHeight());
          }, c5.prototype.hide = function() {
            this.el && this.el.hide(), this._show = false;
          }, c5.prototype.hideLater = function(s) {
            this._show && !(this._inContent && this._enterable) && (s ? (this._hideDelay = s, this._show = false, this._hideTimeout = setTimeout(Cs(this.hide, this), s)) : this.hide());
          }, c5.prototype.isShow = function() {
            return this._show;
          }, c5.prototype.dispose = function() {
            this._zr.remove(this.el);
          }, c5;
        }();
        function h9(c5) {
          return Math.max(0, c5);
        }
        function oLe(c5) {
          var s = h9(c5.shadowBlur || 0), r5 = h9(c5.shadowOffsetX || 0), g5 = h9(c5.shadowOffsetY || 0);
          return { left: h9(s - r5), right: h9(s + r5), top: h9(s - g5), bottom: h9(s + g5) };
        }
        function sLe(c5, s, r5, g5) {
          c5[0] = r5, c5[1] = g5, c5[2] = c5[0] / s.getWidth(), c5[3] = c5[1] / s.getHeight();
        }
        var qYn = UYn, ZYn = new zf2({ shape: { x: -1, y: -1, width: 2, height: 2 } }), $Yn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5, g5) {
            if (!(os.node || !g5.getDom())) {
              var b6 = r5.getComponent("tooltip"), S2 = this._renderMode = $zt(b6.get("renderMode"));
              this._tooltipContent = S2 === "richText" ? new qYn(g5) : new HYn(g5.getDom(), g5, { appendToBody: b6.get("appendToBody", true) });
            }
          }, s.prototype.render = function(r5, g5, b6) {
            if (!(os.node || !b6.getDom())) {
              this.group.removeAll(), this._tooltipModel = r5, this._ecModel = g5, this._api = b6, this._alwaysShowContent = r5.get("alwaysShowContent");
              var S2 = this._tooltipContent;
              S2.update(r5), S2.setEnterable(r5.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && r5.get("transitionDuration") ? pX(this, "_updatePosition", 50, "fixRate") : hct(this, "_updatePosition");
            }
          }, s.prototype._initGlobalListener = function() {
            var r5 = this._tooltipModel, g5 = r5.get("triggerOn");
            h3e("itemTooltip", this._api, Cs(function(b6, S2, A2) {
              g5 !== "none" && (g5.indexOf(b6) >= 0 ? this._tryShow(S2, A2) : b6 === "leave" && this._hide(A2));
            }, this));
          }, s.prototype._keepShow = function() {
            var r5 = this._tooltipModel, g5 = this._ecModel, b6 = this._api;
            if (this._lastX != null && this._lastY != null && r5.get("triggerOn") !== "none") {
              var S2 = this;
              clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
                !b6.isDisposed() && S2.manuallyShowTip(r5, g5, b6, { x: S2._lastX, y: S2._lastY, dataByCoordSys: S2._lastDataByCoordSys });
              });
            }
          }, s.prototype.manuallyShowTip = function(r5, g5, b6, S2) {
            if (!(S2.from === this.uid || os.node || !b6.getDom())) {
              var A2 = lLe(S2, b6);
              this._ticket = "";
              var k2 = S2.dataByCoordSys, R6 = QYn(S2, g5, b6);
              if (R6) {
                var B3 = R6.el.getBoundingRect().clone();
                B3.applyTransform(R6.el.transform), this._tryShow({ offsetX: B3.x + B3.width / 2, offsetY: B3.y + B3.height / 2, target: R6.el, position: S2.position, positionDefault: "bottom" }, A2);
              } else if (S2.tooltip && S2.x != null && S2.y != null) {
                var G3 = ZYn;
                G3.x = S2.x, G3.y = S2.y, G3.update(), Pl(G3).tooltipConfig = { name: null, option: S2.tooltip }, this._tryShow({ offsetX: S2.x, offsetY: S2.y, target: G3 }, A2);
              } else if (k2)
                this._tryShow({ offsetX: S2.x, offsetY: S2.y, position: S2.position, dataByCoordSys: k2, tooltipOption: S2.tooltipOption }, A2);
              else if (S2.seriesIndex != null) {
                if (this._manuallyAxisShowTip(r5, g5, b6, S2))
                  return;
                var Z3 = d3e(S2, g5), X3 = Z3.point[0], tt = Z3.point[1];
                X3 != null && tt != null && this._tryShow({ offsetX: X3, offsetY: tt, target: Z3.el, position: S2.position, positionDefault: "bottom" }, A2);
              } else
                S2.x != null && S2.y != null && (b6.dispatchAction({ type: "updateAxisPointer", x: S2.x, y: S2.y }), this._tryShow({ offsetX: S2.x, offsetY: S2.y, position: S2.position, target: b6.getZr().findHover(S2.x, S2.y).target }, A2));
            }
          }, s.prototype.manuallyHideTip = function(r5, g5, b6, S2) {
            var A2 = this._tooltipContent;
            !this._alwaysShowContent && this._tooltipModel && A2.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, S2.from !== this.uid && this._hide(lLe(S2, b6));
          }, s.prototype._manuallyAxisShowTip = function(r5, g5, b6, S2) {
            var A2 = S2.seriesIndex, k2 = S2.dataIndex, R6 = g5.getComponent("axisPointer").coordSysAxesInfo;
            if (!(A2 == null || k2 == null || R6 == null)) {
              var B3 = g5.getSeriesByIndex(A2);
              if (B3) {
                var G3 = B3.getData(), Z3 = lft([G3.getItemModel(k2), B3, (B3.coordinateSystem || {}).model], this._tooltipModel);
                if (Z3.get("trigger") === "axis")
                  return b6.dispatchAction({ type: "updateAxisPointer", seriesIndex: A2, dataIndex: k2, position: S2.position }), true;
              }
            }
          }, s.prototype._tryShow = function(r5, g5) {
            var b6 = r5.target, S2 = this._tooltipModel;
            if (S2) {
              this._lastX = r5.offsetX, this._lastY = r5.offsetY;
              var A2 = r5.dataByCoordSys;
              if (A2 && A2.length)
                this._showAxisTooltip(A2, r5);
              else if (b6) {
                this._lastDataByCoordSys = null;
                var k2, R6;
                gX(b6, function(B3) {
                  if (Pl(B3).dataIndex != null)
                    return k2 = B3, true;
                  if (Pl(B3).tooltipConfig != null)
                    return R6 = B3, true;
                }, true), k2 ? this._showSeriesItemTooltip(r5, k2, g5) : R6 ? this._showComponentItemTooltip(r5, R6, g5) : this._hide(g5);
              } else
                this._lastDataByCoordSys = null, this._hide(g5);
            }
          }, s.prototype._showOrMove = function(r5, g5) {
            var b6 = r5.get("showDelay");
            g5 = Cs(g5, this), clearTimeout(this._showTimout), b6 > 0 ? this._showTimout = setTimeout(g5, b6) : g5();
          }, s.prototype._showAxisTooltip = function(r5, g5) {
            var b6 = this._ecModel, S2 = this._tooltipModel, A2 = [g5.offsetX, g5.offsetY], k2 = lft([g5.tooltipOption], S2), R6 = this._renderMode, B3 = [], G3 = W1("section", { blocks: [], noHeader: true }), Z3 = [], X3 = new ZWt();
            Ye2(r5, function(kt) {
              Ye2(kt.dataByAxis, function(Gt) {
                var Ot = b6.getComponent(Gt.axisDim + "Axis", Gt.axisIndex), ce2 = Gt.value;
                if (!(!Ot || ce2 == null)) {
                  var ae2 = o3e(ce2, Ot.axis, b6, Gt.seriesDataIndices, Gt.valueLabelOpt), de2 = W1("section", { header: ae2, noHeader: !Tg2(ae2), sortBlocks: true, blocks: [] });
                  G3.blocks.push(de2), Ye2(Gt.seriesDataIndices, function(we2) {
                    var Se2 = b6.getSeriesByIndex(we2.seriesIndex), Oe2 = we2.dataIndexInside, je2 = Se2.getDataParams(Oe2);
                    if (!(je2.dataIndex < 0)) {
                      je2.axisDim = Gt.axisDim, je2.axisIndex = Gt.axisIndex, je2.axisType = Gt.axisType, je2.axisId = Gt.axisId, je2.axisValue = EGt(Ot.axis, { value: ce2 }), je2.axisValueLabel = ae2, je2.marker = X3.makeTooltipMarker("item", oW(je2.color), R6);
                      var rn = jTe(Se2.formatTooltip(Oe2, true, null)), qe2 = rn.frag;
                      if (qe2) {
                        var An = lft([Se2], S2).get("valueFormatter");
                        de2.blocks.push(An ? sa2({ valueFormatter: An }, qe2) : qe2);
                      }
                      rn.text && Z3.push(rn.text), B3.push(je2);
                    }
                  });
                }
              });
            }), G3.blocks.reverse(), Z3.reverse();
            var tt = g5.position, it = k2.get("order"), pt = iAe(G3, X3, R6, it, b6.get("useUTC"), k2.get("textStyle"));
            pt && Z3.unshift(pt);
            var mt = R6 === "richText" ? `

` : "<br/>", Mt = Z3.join(mt);
            this._showOrMove(k2, function() {
              this._updateContentNotChangedOnAxis(r5, B3) ? this._updatePosition(k2, tt, A2[0], A2[1], this._tooltipContent, B3) : this._showTooltipContent(k2, Mt, B3, Math.random() + "", A2[0], A2[1], tt, null, X3);
            });
          }, s.prototype._showSeriesItemTooltip = function(r5, g5, b6) {
            var S2 = this._ecModel, A2 = Pl(g5), k2 = A2.seriesIndex, R6 = S2.getSeriesByIndex(k2), B3 = A2.dataModel || R6, G3 = A2.dataIndex, Z3 = A2.dataType, X3 = B3.getData(Z3), tt = this._renderMode, it = r5.positionDefault, pt = lft([X3.getItemModel(G3), B3, R6 && (R6.coordinateSystem || {}).model], this._tooltipModel, it ? { position: it } : null), mt = pt.get("trigger");
            if (!(mt != null && mt !== "item")) {
              var Mt = B3.getDataParams(G3, Z3), kt = new ZWt();
              Mt.marker = kt.makeTooltipMarker("item", oW(Mt.color), tt);
              var Gt = jTe(B3.formatTooltip(G3, false, Z3)), Ot = pt.get("order"), ce2 = pt.get("valueFormatter"), ae2 = Gt.frag, de2 = ae2 ? iAe(ce2 ? sa2({ valueFormatter: ce2 }, ae2) : ae2, kt, tt, Ot, S2.get("useUTC"), pt.get("textStyle")) : Gt.text, we2 = "item_" + B3.name + "_" + G3;
              this._showOrMove(pt, function() {
                this._showTooltipContent(pt, de2, Mt, we2, r5.offsetX, r5.offsetY, r5.position, r5.target, kt);
              }), b6({ type: "showTip", dataIndexInside: G3, dataIndex: X3.getRawIndex(G3), seriesIndex: k2, from: this.uid });
            }
          }, s.prototype._showComponentItemTooltip = function(r5, g5, b6) {
            var S2 = Pl(g5), A2 = S2.tooltipConfig, k2 = A2.option || {};
            if (gs(k2)) {
              var R6 = k2;
              k2 = { content: R6, formatter: R6 };
            }
            var B3 = [k2], G3 = this._ecModel.getComponent(S2.componentMainType, S2.componentIndex);
            G3 && B3.push(G3), B3.push({ formatter: k2.content });
            var Z3 = r5.positionDefault, X3 = lft(B3, this._tooltipModel, Z3 ? { position: Z3 } : null), tt = X3.get("content"), it = Math.random() + "", pt = new ZWt();
            this._showOrMove(X3, function() {
              var mt = Ml(X3.get("formatterParams") || {});
              this._showTooltipContent(X3, tt, mt, it, r5.offsetX, r5.offsetY, r5.position, g5, pt);
            }), b6({ type: "showTip", from: this.uid });
          }, s.prototype._showTooltipContent = function(r5, g5, b6, S2, A2, k2, R6, B3, G3) {
            if (this._ticket = "", !(!r5.get("showContent") || !r5.get("show"))) {
              var Z3 = this._tooltipContent;
              Z3.setEnterable(r5.get("enterable"));
              var X3 = r5.get("formatter");
              R6 = R6 || r5.get("position");
              var tt = g5, it = this._getNearestPoint([A2, k2], b6, r5.get("trigger"), r5.get("borderColor")), pt = it.color;
              if (X3)
                if (gs(X3)) {
                  var mt = r5.ecModel.get("useUTC"), Mt = ja2(b6) ? b6[0] : b6, kt = Mt && Mt.axisType && Mt.axisType.indexOf("time") >= 0;
                  tt = X3, kt && (tt = $2t(Mt.axisValue, tt, mt)), tt = nTe(tt, b6, true);
                } else if (Tl(X3)) {
                  var Gt = Cs(function(Ot, ce2) {
                    Ot === this._ticket && (Z3.setContent(ce2, G3, r5, pt, R6), this._updatePosition(r5, R6, A2, k2, Z3, b6, B3));
                  }, this);
                  this._ticket = S2, tt = X3(b6, S2, Gt);
                } else
                  tt = X3;
              Z3.setContent(tt, G3, r5, pt, R6), Z3.show(r5, pt), this._updatePosition(r5, R6, A2, k2, Z3, b6, B3);
            }
          }, s.prototype._getNearestPoint = function(r5, g5, b6, S2) {
            if (b6 === "axis" || ja2(g5))
              return { color: S2 || (this._renderMode === "html" ? "#fff" : "none") };
            if (!ja2(g5))
              return { color: S2 || g5.color || g5.borderColor };
          }, s.prototype._updatePosition = function(r5, g5, b6, S2, A2, k2, R6) {
            var B3 = this._api.getWidth(), G3 = this._api.getHeight();
            g5 = g5 || r5.get("position");
            var Z3 = A2.getSize(), X3 = r5.get("align"), tt = r5.get("verticalAlign"), it = R6 && R6.getBoundingRect().clone();
            if (R6 && it.applyTransform(R6.transform), Tl(g5) && (g5 = g5([b6, S2], k2, A2.el, it, { viewSize: [B3, G3], contentSize: Z3.slice() })), ja2(g5))
              b6 = $o(g5[0], B3), S2 = $o(g5[1], G3);
            else if (Wl(g5)) {
              var pt = g5;
              pt.width = Z3[0], pt.height = Z3[1];
              var mt = $m(pt, { width: B3, height: G3 });
              b6 = mt.x, S2 = mt.y, X3 = null, tt = null;
            } else if (gs(g5) && R6) {
              var Mt = XYn(g5, it, Z3, r5.get("borderWidth"));
              b6 = Mt[0], S2 = Mt[1];
            } else {
              var Mt = YYn(b6, S2, A2, B3, G3, X3 ? null : 20, tt ? null : 20);
              b6 = Mt[0], S2 = Mt[1];
            }
            if (X3 && (b6 -= uLe(X3) ? Z3[0] / 2 : X3 === "right" ? Z3[0] : 0), tt && (S2 -= uLe(tt) ? Z3[1] / 2 : tt === "bottom" ? Z3[1] : 0), tLe(r5)) {
              var Mt = KYn(b6, S2, A2, B3, G3);
              b6 = Mt[0], S2 = Mt[1];
            }
            A2.moveTo(b6, S2);
          }, s.prototype._updateContentNotChangedOnAxis = function(r5, g5) {
            var b6 = this._lastDataByCoordSys, S2 = this._cbParamsList, A2 = !!b6 && b6.length === r5.length;
            return A2 && Ye2(b6, function(k2, R6) {
              var B3 = k2.dataByAxis || [], G3 = r5[R6] || {}, Z3 = G3.dataByAxis || [];
              A2 = A2 && B3.length === Z3.length, A2 && Ye2(B3, function(X3, tt) {
                var it = Z3[tt] || {}, pt = X3.seriesDataIndices || [], mt = it.seriesDataIndices || [];
                A2 = A2 && X3.value === it.value && X3.axisType === it.axisType && X3.axisId === it.axisId && pt.length === mt.length, A2 && Ye2(pt, function(Mt, kt) {
                  var Gt = mt[kt];
                  A2 = A2 && Mt.seriesIndex === Gt.seriesIndex && Mt.dataIndex === Gt.dataIndex;
                }), S2 && Ye2(X3.seriesDataIndices, function(Mt) {
                  var kt = Mt.seriesIndex, Gt = g5[kt], Ot = S2[kt];
                  Gt && Ot && Ot.data !== Gt.data && (A2 = false);
                });
              });
            }), this._lastDataByCoordSys = r5, this._cbParamsList = g5, !!A2;
          }, s.prototype._hide = function(r5) {
            this._lastDataByCoordSys = null, r5({ type: "hideTip", from: this.uid });
          }, s.prototype.dispose = function(r5, g5) {
            os.node || !g5.getDom() || (hct(this, "_updatePosition"), this._tooltipContent.dispose(), zUt("itemTooltip", g5));
          }, s.type = "tooltip", s;
        }(P0);
        function lft(c5, s, r5) {
          var g5 = s.ecModel, b6;
          r5 ? (b6 = new Ag2(r5, g5, g5), b6 = new Ag2(s.option, b6, g5)) : b6 = s;
          for (var S2 = c5.length - 1; S2 >= 0; S2--) {
            var A2 = c5[S2];
            A2 && (A2 instanceof Ag2 && (A2 = A2.get("tooltip", true)), gs(A2) && (A2 = { formatter: A2 }), A2 && (b6 = new Ag2(A2, b6, g5)));
          }
          return b6;
        }
        function lLe(c5, s) {
          return c5.dispatchAction || Cs(s.dispatchAction, s);
        }
        function YYn(c5, s, r5, g5, b6, S2, A2) {
          var k2 = r5.getSize(), R6 = k2[0], B3 = k2[1];
          return S2 != null && (c5 + R6 + S2 + 2 > g5 ? c5 -= R6 + S2 : c5 += S2), A2 != null && (s + B3 + A2 > b6 ? s -= B3 + A2 : s += A2), [c5, s];
        }
        function KYn(c5, s, r5, g5, b6) {
          var S2 = r5.getSize(), A2 = S2[0], k2 = S2[1];
          return c5 = Math.min(c5 + A2, g5) - A2, s = Math.min(s + k2, b6) - k2, c5 = Math.max(c5, 0), s = Math.max(s, 0), [c5, s];
        }
        function XYn(c5, s, r5, g5) {
          var b6 = r5[0], S2 = r5[1], A2 = Math.ceil(Math.SQRT2 * g5) + 8, k2 = 0, R6 = 0, B3 = s.width, G3 = s.height;
          switch (c5) {
            case "inside":
              k2 = s.x + B3 / 2 - b6 / 2, R6 = s.y + G3 / 2 - S2 / 2;
              break;
            case "top":
              k2 = s.x + B3 / 2 - b6 / 2, R6 = s.y - S2 - A2;
              break;
            case "bottom":
              k2 = s.x + B3 / 2 - b6 / 2, R6 = s.y + G3 + A2;
              break;
            case "left":
              k2 = s.x - b6 - A2, R6 = s.y + G3 / 2 - S2 / 2;
              break;
            case "right":
              k2 = s.x + B3 + A2, R6 = s.y + G3 / 2 - S2 / 2;
          }
          return [k2, R6];
        }
        function uLe(c5) {
          return c5 === "center" || c5 === "middle";
        }
        function QYn(c5, s, r5) {
          var g5 = rR(c5).queryOptionMap, b6 = g5.keys()[0];
          if (!(!b6 || b6 === "series")) {
            var S2 = Gj2(s, b6, g5.get(b6), { useDefault: false, enableAll: false, enableNone: false }), A2 = S2.models[0];
            if (A2) {
              var k2 = r5.getViewOfComponentModel(A2), R6;
              if (k2.group.traverse(function(B3) {
                var G3 = Pl(B3).tooltipConfig;
                if (G3 && G3.name === c5.name)
                  return R6 = B3, true;
              }), R6)
                return { componentMainType: b6, componentIndex: A2.componentIndex, el: R6 };
            }
          }
        }
        var JYn = $Yn;
        function tKn(c5) {
          Fc2(oft), c5.registerComponentModel(LYn), c5.registerComponentView(JYn), c5.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, I0), c5.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, I0);
        }
        var eKn = ["rect", "polygon", "keep", "clear"];
        function nKn(c5, s) {
          var r5 = xp(c5 ? c5.brush : []);
          if (r5.length) {
            var g5 = [];
            Ye2(r5, function(R6) {
              var B3 = R6.hasOwnProperty("toolbox") ? R6.toolbox : [];
              B3 instanceof Array && (g5 = g5.concat(B3));
            });
            var b6 = c5 && c5.toolbox;
            ja2(b6) && (b6 = b6[0]), b6 || (b6 = { feature: {} }, c5.toolbox = [b6]);
            var S2 = b6.feature || (b6.feature = {}), A2 = S2.brush || (S2.brush = {}), k2 = A2.type || (A2.type = []);
            k2.push.apply(k2, g5), rKn(k2), s && !k2.length && k2.push.apply(k2, eKn);
          }
        }
        function rKn(c5) {
          var s = {};
          Ye2(c5, function(r5) {
            s[r5] = 1;
          }), c5.length = 0, Ye2(s, function(r5, g5) {
            c5.push(g5);
          });
        }
        var cLe = Ye2;
        function fLe(c5) {
          if (c5) {
            for (var s in c5)
              if (c5.hasOwnProperty(s))
                return true;
          }
        }
        function oqt(c5, s, r5) {
          var g5 = {};
          return cLe(s, function(S2) {
            var A2 = g5[S2] = b6();
            cLe(c5[S2], function(k2, R6) {
              if (Sx.isValidType(R6)) {
                var B3 = { type: R6, visual: k2 };
                r5 && r5(B3, S2), A2[R6] = new Sx(B3), R6 === "opacity" && (B3 = Ml(B3), B3.type = "colorAlpha", A2.__hidden.__alphaForOpacity = new Sx(B3));
              }
            });
          }), g5;
          function b6() {
            var S2 = function() {
            };
            S2.prototype.__hidden = S2.prototype;
            var A2 = new S2();
            return A2;
          }
        }
        function hLe(c5, s, r5) {
          var g5;
          Ye2(r5, function(b6) {
            s.hasOwnProperty(b6) && fLe(s[b6]) && (g5 = true);
          }), g5 && Ye2(r5, function(b6) {
            s.hasOwnProperty(b6) && fLe(s[b6]) ? c5[b6] = Ml(s[b6]) : delete c5[b6];
          });
        }
        function iKn(c5, s, r5, g5, b6, S2) {
          var A2 = {};
          Ye2(c5, function(Z3) {
            var X3 = Sx.prepareVisualTypes(s[Z3]);
            A2[Z3] = X3;
          });
          var k2;
          function R6(Z3) {
            return JWt(r5, k2, Z3);
          }
          function B3(Z3, X3) {
            DAe(r5, k2, Z3, X3);
          }
          S2 == null ? r5.each(G3) : r5.each([S2], G3);
          function G3(Z3, X3) {
            k2 = S2 == null ? Z3 : X3;
            var tt = r5.getRawDataItem(k2);
            if (!(tt && tt.visualMap === false))
              for (var it = g5.call(b6, Z3), pt = s[it], mt = A2[it], Mt = 0, kt = mt.length; Mt < kt; Mt++) {
                var Gt = mt[Mt];
                pt[Gt] && pt[Gt].applyVisual(Z3, R6, B3);
              }
          }
        }
        function aKn(c5, s, r5, g5) {
          var b6 = {};
          return Ye2(c5, function(S2) {
            var A2 = Sx.prepareVisualTypes(s[S2]);
            b6[S2] = A2;
          }), { progress: function(S2, A2) {
            var k2;
            g5 != null && (k2 = A2.getDimensionIndex(g5));
            function R6(Ot) {
              return JWt(A2, G3, Ot);
            }
            function B3(Ot, ce2) {
              DAe(A2, G3, Ot, ce2);
            }
            for (var G3, Z3 = A2.getStore(); (G3 = S2.next()) != null; ) {
              var X3 = A2.getRawDataItem(G3);
              if (!(X3 && X3.visualMap === false))
                for (var tt = g5 != null ? Z3.get(k2, G3) : G3, it = r5(tt), pt = s[it], mt = b6[it], Mt = 0, kt = mt.length; Mt < kt; Mt++) {
                  var Gt = mt[Mt];
                  pt[Gt] && pt[Gt].applyVisual(tt, R6, B3);
                }
            }
          } };
        }
        function oKn(c5) {
          var s = c5.brushType, r5 = { point: function(g5) {
            return pLe[s].point(g5, r5, c5);
          }, rect: function(g5) {
            return pLe[s].rect(g5, r5, c5);
          } };
          return r5;
        }
        var pLe = { lineX: dLe(0), lineY: dLe(1), rect: { point: function(c5, s, r5) {
          return c5 && r5.boundingRect.contain(c5[0], c5[1]);
        }, rect: function(c5, s, r5) {
          return c5 && r5.boundingRect.intersect(c5);
        } }, polygon: { point: function(c5, s, r5) {
          return c5 && r5.boundingRect.contain(c5[0], c5[1]) && gW(r5.range, c5[0], c5[1]);
        }, rect: function(c5, s, r5) {
          var g5 = r5.range;
          if (!c5 || g5.length <= 1)
            return false;
          var b6 = c5.x, S2 = c5.y, A2 = c5.width, k2 = c5.height, R6 = g5[0];
          if (gW(g5, b6, S2) || gW(g5, b6 + A2, S2) || gW(g5, b6, S2 + k2) || gW(g5, b6 + A2, S2 + k2) || lc2.create(c5).contain(R6[0], R6[1]) || j1(b6, S2, b6 + A2, S2, g5) || j1(b6, S2, b6, S2 + k2, g5) || j1(b6 + A2, S2, b6 + A2, S2 + k2, g5) || j1(b6, S2 + k2, b6 + A2, S2 + k2, g5))
            return true;
        } } };
        function dLe(c5) {
          var s = ["x", "y"], r5 = ["width", "height"];
          return { point: function(g5, b6, S2) {
            if (g5) {
              var A2 = S2.range, k2 = g5[c5];
              return uft(k2, A2);
            }
          }, rect: function(g5, b6, S2) {
            if (g5) {
              var A2 = S2.range, k2 = [g5[s[c5]], g5[s[c5]] + g5[r5[c5]]];
              return k2[1] < k2[0] && k2.reverse(), uft(k2[0], A2) || uft(k2[1], A2) || uft(A2[0], k2) || uft(A2[1], k2);
            }
          } };
        }
        function uft(c5, s) {
          return s[0] <= c5 && c5 <= s[1];
        }
        var gLe = ["inBrush", "outOfBrush"], sqt = "__ecBrushSelect", lqt = "__ecInBrushSelectEvent";
        function vLe(c5) {
          c5.eachComponent({ mainType: "brush" }, function(s) {
            var r5 = s.brushTargetManager = new nqt(s.option, c5);
            r5.setInputRanges(s.areas, c5);
          });
        }
        function sKn(c5, s, r5) {
          var g5 = [], b6, S2;
          c5.eachComponent({ mainType: "brush" }, function(A2) {
            r5 && r5.type === "takeGlobalCursor" && A2.setBrushOption(r5.key === "brush" ? r5.brushOption : { brushType: false });
          }), vLe(c5), c5.eachComponent({ mainType: "brush" }, function(A2, k2) {
            var R6 = { brushId: A2.id, brushIndex: k2, brushName: A2.name, areas: Ml(A2.areas), selected: [] };
            g5.push(R6);
            var B3 = A2.option, G3 = B3.brushLink, Z3 = [], X3 = [], tt = [], it = false;
            k2 || (b6 = B3.throttleType, S2 = B3.throttleDelay);
            var pt = Ha2(A2.areas, function(ce2) {
              var ae2 = fKn[ce2.brushType], de2 = Cl({ boundingRect: ae2 ? ae2(ce2) : void 0 }, ce2);
              return de2.selectors = oKn(de2), de2;
            }), mt = oqt(A2.option, gLe, function(ce2) {
              ce2.mappingMethod = "fixed";
            });
            ja2(G3) && Ye2(G3, function(ce2) {
              Z3[ce2] = 1;
            });
            function Mt(ce2) {
              return G3 === "all" || !!Z3[ce2];
            }
            function kt(ce2) {
              return !!ce2.length;
            }
            c5.eachSeries(function(ce2, ae2) {
              var de2 = tt[ae2] = [];
              ce2.subType === "parallel" ? Gt(ce2, ae2) : Ot(ce2, ae2, de2);
            });
            function Gt(ce2, ae2) {
              var de2 = ce2.coordinateSystem;
              it = it || de2.hasAxisBrushed(), Mt(ae2) && de2.eachActiveState(ce2.getData(), function(we2, Se2) {
                we2 === "active" && (X3[Se2] = 1);
              });
            }
            function Ot(ce2, ae2, de2) {
              if (!(!ce2.brushSelector || cKn(A2, ae2)) && (Ye2(pt, function(Se2) {
                A2.brushTargetManager.controlSeries(Se2, ce2, c5) && de2.push(Se2), it = it || kt(de2);
              }), Mt(ae2) && kt(de2))) {
                var we2 = ce2.getData();
                we2.each(function(Se2) {
                  yLe(ce2, de2, we2, Se2) && (X3[Se2] = 1);
                });
              }
            }
            c5.eachSeries(function(ce2, ae2) {
              var de2 = { seriesId: ce2.id, seriesIndex: ae2, seriesName: ce2.name, dataIndex: [] };
              R6.selected.push(de2);
              var we2 = tt[ae2], Se2 = ce2.getData(), Oe2 = Mt(ae2) ? function(je2) {
                return X3[je2] ? (de2.dataIndex.push(Se2.getRawIndex(je2)), "inBrush") : "outOfBrush";
              } : function(je2) {
                return yLe(ce2, we2, Se2, je2) ? (de2.dataIndex.push(Se2.getRawIndex(je2)), "inBrush") : "outOfBrush";
              };
              (Mt(ae2) ? it : kt(we2)) && iKn(gLe, mt, Se2, Oe2);
            });
          }), lKn(s, b6, S2, g5, r5);
        }
        function lKn(c5, s, r5, g5, b6) {
          if (b6) {
            var S2 = c5.getZr();
            if (!S2[lqt]) {
              S2[sqt] || (S2[sqt] = uKn);
              var A2 = pX(S2, sqt, r5, s);
              A2(c5, g5);
            }
          }
        }
        function uKn(c5, s) {
          if (!c5.isDisposed()) {
            var r5 = c5.getZr();
            r5[lqt] = true, c5.dispatchAction({ type: "brushSelect", batch: s }), r5[lqt] = false;
          }
        }
        function yLe(c5, s, r5, g5) {
          for (var b6 = 0, S2 = s.length; b6 < S2; b6++) {
            var A2 = s[b6];
            if (c5.brushSelector(g5, r5, A2.selectors, A2))
              return true;
          }
        }
        function cKn(c5, s) {
          var r5 = c5.option.seriesIndex;
          return r5 != null && r5 !== "all" && (ja2(r5) ? Lu(r5, s) < 0 : s !== r5);
        }
        var fKn = { rect: function(c5) {
          return mLe(c5.range);
        }, polygon: function(c5) {
          for (var s, r5 = c5.range, g5 = 0, b6 = r5.length; g5 < b6; g5++) {
            s = s || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
            var S2 = r5[g5];
            S2[0] < s[0][0] && (s[0][0] = S2[0]), S2[0] > s[0][1] && (s[0][1] = S2[0]), S2[1] < s[1][0] && (s[1][0] = S2[1]), S2[1] > s[1][1] && (s[1][1] = S2[1]);
          }
          return s && mLe(s);
        } };
        function mLe(c5) {
          return new lc2(c5[0][0], c5[1][0], c5[0][1] - c5[0][0], c5[1][1] - c5[1][0]);
        }
        var hKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5, g5) {
            this.ecModel = r5, this.api = g5, this.model, (this._brushController = new hUt(g5.getZr())).on("brush", Cs(this._onBrush, this)).mount();
          }, s.prototype.render = function(r5, g5, b6, S2) {
            this.model = r5, this._updateController(r5, g5, b6, S2);
          }, s.prototype.updateTransform = function(r5, g5, b6, S2) {
            vLe(g5), this._updateController(r5, g5, b6, S2);
          }, s.prototype.updateVisual = function(r5, g5, b6, S2) {
            this.updateTransform(r5, g5, b6, S2);
          }, s.prototype.updateView = function(r5, g5, b6, S2) {
            this._updateController(r5, g5, b6, S2);
          }, s.prototype._updateController = function(r5, g5, b6, S2) {
            (!S2 || S2.$from !== r5.id) && this._brushController.setPanels(r5.brushTargetManager.makePanelOpts(b6)).enableBrush(r5.brushOption).updateCovers(r5.areas.slice());
          }, s.prototype.dispose = function() {
            this._brushController.dispose();
          }, s.prototype._onBrush = function(r5) {
            var g5 = this.model.id, b6 = this.model.brushTargetManager.setOutputRanges(r5.areas, this.ecModel);
            (!r5.isEnd || r5.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: g5, areas: Ml(b6), $from: g5 }), r5.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: g5, areas: Ml(b6), $from: g5 });
          }, s.type = "brush", s;
        }(P0), pKn = hKn, dKn = "#ddd", gKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.areas = [], r5.brushOption = {}, r5;
          }
          return s.prototype.optionUpdated = function(r5, g5) {
            var b6 = this.option;
            !g5 && hLe(b6, r5, ["inBrush", "outOfBrush"]);
            var S2 = b6.inBrush = b6.inBrush || {};
            b6.outOfBrush = b6.outOfBrush || { color: dKn }, S2.hasOwnProperty("liftZ") || (S2.liftZ = 5);
          }, s.prototype.setAreas = function(r5) {
            !r5 || (this.areas = Ha2(r5, function(g5) {
              return bLe(this.option, g5);
            }, this));
          }, s.prototype.setBrushOption = function(r5) {
            this.brushOption = bLe(this.option, r5), this.brushType = this.brushOption.brushType;
          }, s.type = "brush", s.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], s.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, s;
        }(Rh2);
        function bLe(c5, s) {
          return bu({ brushType: c5.brushType, brushMode: c5.brushMode, transformable: c5.transformable, brushStyle: new Ag2(c5.brushStyle).getItemStyle(), removeOnClick: c5.removeOnClick, z: c5.z }, s, true);
        }
        var vKn = gKn, yKn = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], mKn = function(c5) {
          wn(s, c5);
          function s() {
            return c5 !== null && c5.apply(this, arguments) || this;
          }
          return s.prototype.render = function(r5, g5, b6) {
            var S2, A2, k2;
            g5.eachComponent({ mainType: "brush" }, function(R6) {
              S2 = R6.brushType, A2 = R6.brushOption.brushMode || "single", k2 = k2 || !!R6.areas.length;
            }), this._brushType = S2, this._brushMode = A2, Ye2(r5.get("type", true), function(R6) {
              r5.setIconStatus(R6, (R6 === "keep" ? A2 === "multiple" : R6 === "clear" ? k2 : R6 === S2) ? "emphasis" : "normal");
            });
          }, s.prototype.updateView = function(r5, g5, b6) {
            this.render(r5, g5, b6);
          }, s.prototype.getIcons = function() {
            var r5 = this.model, g5 = r5.get("icon", true), b6 = {};
            return Ye2(r5.get("type", true), function(S2) {
              g5[S2] && (b6[S2] = g5[S2]);
            }), b6;
          }, s.prototype.onclick = function(r5, g5, b6) {
            var S2 = this._brushType, A2 = this._brushMode;
            b6 === "clear" ? (g5.dispatchAction({ type: "axisAreaSelect", intervals: [] }), g5.dispatchAction({ type: "brush", command: "clear", areas: [] })) : g5.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: b6 === "keep" ? S2 : S2 === b6 ? false : b6, brushMode: b6 === "keep" ? A2 === "multiple" ? "single" : "multiple" : A2 } });
          }, s.getDefaultOption = function(r5) {
            var g5 = { show: true, type: yKn.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: r5.getLocaleModel().get(["toolbox", "brush", "title"]) };
            return g5;
          }, s;
        }(oD), bKn = mKn;
        function _Kn(c5) {
          c5.registerComponentView(pKn), c5.registerComponentModel(vKn), c5.registerPreprocessor(nKn), c5.registerVisual(c5.PRIORITY.VISUAL.BRUSH, sKn), c5.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(s, r5) {
            r5.eachComponent({ mainType: "brush", query: s }, function(g5) {
              g5.setAreas(s.areas);
            });
          }), c5.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, I0), c5.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, I0), RX("brush", bKn);
        }
        var xKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.layoutMode = { type: "box", ignoreSize: true }, r5;
          }
          return s.type = "title", s.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, s;
        }(Rh2), wKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            if (this.group.removeAll(), !!r5.get("show")) {
              var S2 = this.group, A2 = r5.getModel("textStyle"), k2 = r5.getModel("subtextStyle"), R6 = r5.get("textAlign"), B3 = tc2(r5.get("textBaseline"), r5.get("textVerticalAlign")), G3 = new hh2({ style: Ey(A2, { text: r5.get("text"), fill: A2.getTextColor() }, { disableBox: true }), z2: 10 }), Z3 = G3.getBoundingRect(), X3 = r5.get("subtext"), tt = new hh2({ style: Ey(k2, { text: X3, fill: k2.getTextColor(), y: Z3.height + r5.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), it = r5.get("link"), pt = r5.get("sublink"), mt = r5.get("triggerEvent", true);
              G3.silent = !it && !mt, tt.silent = !pt && !mt, it && G3.on("click", function() {
                J2t(it, "_" + r5.get("target"));
              }), pt && tt.on("click", function() {
                J2t(pt, "_" + r5.get("subtarget"));
              }), Pl(G3).eventData = Pl(tt).eventData = mt ? { componentType: "title", componentIndex: r5.componentIndex } : null, S2.add(G3), X3 && S2.add(tt);
              var Mt = S2.getBoundingRect(), kt = r5.getBoxLayoutParams();
              kt.width = Mt.width, kt.height = Mt.height;
              var Gt = $m(kt, { width: b6.getWidth(), height: b6.getHeight() }, r5.get("padding"));
              R6 || (R6 = r5.get("left") || r5.get("right"), R6 === "middle" && (R6 = "center"), R6 === "right" ? Gt.x += Gt.width : R6 === "center" && (Gt.x += Gt.width / 2)), B3 || (B3 = r5.get("top") || r5.get("bottom"), B3 === "center" && (B3 = "middle"), B3 === "bottom" ? Gt.y += Gt.height : B3 === "middle" && (Gt.y += Gt.height / 2), B3 = B3 || "top"), S2.x = Gt.x, S2.y = Gt.y, S2.markRedraw();
              var Ot = { align: R6, verticalAlign: B3 };
              G3.setStyle(Ot), tt.setStyle(Ot), Mt = S2.getBoundingRect();
              var ce2 = Gt.margin, ae2 = r5.getItemStyle(["color", "opacity"]);
              ae2.fill = r5.get("backgroundColor");
              var de2 = new zf2({ shape: { x: Mt.x - ce2[3], y: Mt.y - ce2[0], width: Mt.width + ce2[1] + ce2[3], height: Mt.height + ce2[0] + ce2[2], r: r5.get("borderRadius") }, style: ae2, subPixelOptimize: true, silent: true });
              S2.add(de2);
            }
          }, s.type = "title", s;
        }(P0);
        function SKn(c5) {
          c5.registerComponentModel(xKn), c5.registerComponentView(wKn);
        }
        var MKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.layoutMode = "box", r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            this.mergeDefaultAndTheme(r5, b6), this._initData();
          }, s.prototype.mergeOption = function(r5) {
            c5.prototype.mergeOption.apply(this, arguments), this._initData();
          }, s.prototype.setCurrentIndex = function(r5) {
            r5 == null && (r5 = this.option.currentIndex);
            var g5 = this._data.count();
            this.option.loop ? r5 = (r5 % g5 + g5) % g5 : (r5 >= g5 && (r5 = g5 - 1), r5 < 0 && (r5 = 0)), this.option.currentIndex = r5;
          }, s.prototype.getCurrentIndex = function() {
            return this.option.currentIndex;
          }, s.prototype.isIndexMax = function() {
            return this.getCurrentIndex() >= this._data.count() - 1;
          }, s.prototype.setPlayState = function(r5) {
            this.option.autoPlay = !!r5;
          }, s.prototype.getPlayState = function() {
            return !!this.option.autoPlay;
          }, s.prototype._initData = function() {
            var r5 = this.option, g5 = r5.data || [], b6 = r5.axisType, S2 = this._names = [], A2;
            b6 === "category" ? (A2 = [], Ye2(g5, function(B3, G3) {
              var Z3 = Q0(Sk(B3), ""), X3;
              Wl(B3) ? (X3 = Ml(B3), X3.value = G3) : X3 = G3, A2.push(X3), S2.push(Z3);
            })) : A2 = g5;
            var k2 = { category: "ordinal", time: "time", value: "number" }[b6] || "number", R6 = this._data = new m22([{ name: "value", type: k2 }], this);
            R6.initData(A2, S2);
          }, s.prototype.getData = function() {
            return this._data;
          }, s.prototype.getCategories = function() {
            if (this.get("axisType") === "category")
              return this._names.slice();
          }, s.type = "timeline", s.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, s;
        }(Rh2), _Le = MKn, xLe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "timeline.slider", s.defaultOption = $8(_Le.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), s;
        }(_Le);
        A0(xLe, jWt.prototype);
        var CKn = xLe, TKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "timeline", s;
        }(P0), AKn = TKn, IKn = function(c5) {
          wn(s, c5);
          function s(r5, g5, b6, S2) {
            var A2 = c5.call(this, r5, g5, b6) || this;
            return A2.type = S2 || "value", A2;
          }
          return s.prototype.getLabelModel = function() {
            return this.model.getModel("label");
          }, s.prototype.isHorizontal = function() {
            return this.model.get("orient") === "horizontal";
          }, s;
        }(kk2), DKn = IKn, uqt = Math.PI, wLe = Df2(), EKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function(r5, g5) {
            this.api = g5;
          }, s.prototype.render = function(r5, g5, b6) {
            if (this.model = r5, this.api = b6, this.ecModel = g5, this.group.removeAll(), r5.get("show", true)) {
              var S2 = this._layout(r5, b6), A2 = this._createGroup("_mainGroup"), k2 = this._createGroup("_labelGroup"), R6 = this._axis = this._createAxis(S2, r5);
              r5.formatTooltip = function(B3) {
                var G3 = R6.scale.getLabel({ value: B3 });
                return W1("nameValue", { noName: true, value: G3 });
              }, Ye2(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(B3) {
                this["_render" + B3](S2, A2, R6, r5);
              }, this), this._renderAxisLabel(S2, k2, R6, r5), this._position(S2, r5);
            }
            this._doPlayStop(), this._updateTicksStatus();
          }, s.prototype.remove = function() {
            this._clearTimer(), this.group.removeAll();
          }, s.prototype.dispose = function() {
            this._clearTimer();
          }, s.prototype._layout = function(r5, g5) {
            var b6 = r5.get(["label", "position"]), S2 = r5.get("orient"), A2 = PKn(r5, g5), k2;
            b6 == null || b6 === "auto" ? k2 = S2 === "horizontal" ? A2.y + A2.height / 2 < g5.getHeight() / 2 ? "-" : "+" : A2.x + A2.width / 2 < g5.getWidth() / 2 ? "+" : "-" : gs(b6) ? k2 = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[S2][b6] : k2 = b6;
            var R6 = { horizontal: "center", vertical: k2 >= 0 || k2 === "+" ? "left" : "right" }, B3 = { horizontal: k2 >= 0 || k2 === "+" ? "top" : "bottom", vertical: "middle" }, G3 = { horizontal: 0, vertical: uqt / 2 }, Z3 = S2 === "vertical" ? A2.height : A2.width, X3 = r5.getModel("controlStyle"), tt = X3.get("show", true), it = tt ? X3.get("itemSize") : 0, pt = tt ? X3.get("itemGap") : 0, mt = it + pt, Mt = r5.get(["label", "rotate"]) || 0;
            Mt = Mt * uqt / 180;
            var kt, Gt, Ot, ce2 = X3.get("position", true), ae2 = tt && X3.get("showPlayBtn", true), de2 = tt && X3.get("showPrevBtn", true), we2 = tt && X3.get("showNextBtn", true), Se2 = 0, Oe2 = Z3;
            ce2 === "left" || ce2 === "bottom" ? (ae2 && (kt = [0, 0], Se2 += mt), de2 && (Gt = [Se2, 0], Se2 += mt), we2 && (Ot = [Oe2 - it, 0], Oe2 -= mt)) : (ae2 && (kt = [Oe2 - it, 0], Oe2 -= mt), de2 && (Gt = [0, 0], Se2 += mt), we2 && (Ot = [Oe2 - it, 0], Oe2 -= mt));
            var je2 = [Se2, Oe2];
            return r5.get("inverse") && je2.reverse(), { viewRect: A2, mainLength: Z3, orient: S2, rotation: G3[S2], labelRotation: Mt, labelPosOpt: k2, labelAlign: r5.get(["label", "align"]) || R6[S2], labelBaseline: r5.get(["label", "verticalAlign"]) || r5.get(["label", "baseline"]) || B3[S2], playPosition: kt, prevBtnPosition: Gt, nextBtnPosition: Ot, axisExtent: je2, controlSize: it, controlGap: pt };
          }, s.prototype._position = function(r5, g5) {
            var b6 = this._mainGroup, S2 = this._labelGroup, A2 = r5.viewRect;
            if (r5.orient === "vertical") {
              var k2 = bM(), R6 = A2.x, B3 = A2.y + A2.height;
              _M(k2, k2, [-R6, -B3]), f3(k2, k2, -uqt / 2), _M(k2, k2, [R6, B3]), A2 = A2.clone(), A2.applyTransform(k2);
            }
            var G3 = kt(A2), Z3 = kt(b6.getBoundingRect()), X3 = kt(S2.getBoundingRect()), tt = [b6.x, b6.y], it = [S2.x, S2.y];
            it[0] = tt[0] = G3[0][0];
            var pt = r5.labelPosOpt;
            if (pt == null || gs(pt)) {
              var mt = pt === "+" ? 0 : 1;
              Gt(tt, Z3, G3, 1, mt), Gt(it, X3, G3, 1, 1 - mt);
            } else {
              var mt = pt >= 0 ? 0 : 1;
              Gt(tt, Z3, G3, 1, mt), it[1] = tt[1] + pt;
            }
            b6.setPosition(tt), S2.setPosition(it), b6.rotation = S2.rotation = r5.rotation, Mt(b6), Mt(S2);
            function Mt(Ot) {
              Ot.originX = G3[0][0] - Ot.x, Ot.originY = G3[1][0] - Ot.y;
            }
            function kt(Ot) {
              return [[Ot.x, Ot.x + Ot.width], [Ot.y, Ot.y + Ot.height]];
            }
            function Gt(Ot, ce2, ae2, de2, we2) {
              Ot[de2] += ae2[de2][we2] - ce2[de2][we2];
            }
          }, s.prototype._createAxis = function(r5, g5) {
            var b6 = g5.getData(), S2 = g5.get("axisType"), A2 = kKn(g5, S2);
            A2.getTicks = function() {
              return b6.mapArray(["value"], function(B3) {
                return { value: B3 };
              });
            };
            var k2 = b6.getDataExtent("value");
            A2.setExtent(k2[0], k2[1]), A2.calcNiceTicks();
            var R6 = new DKn("value", A2, r5.axisExtent, S2);
            return R6.model = g5, R6;
          }, s.prototype._createGroup = function(r5) {
            var g5 = this[r5] = new nu();
            return this.group.add(g5), g5;
          }, s.prototype._renderAxisLine = function(r5, g5, b6, S2) {
            var A2 = b6.getExtent();
            if (S2.get(["lineStyle", "show"])) {
              var k2 = new Zm({ shape: { x1: A2[0], y1: 0, x2: A2[1], y2: 0 }, style: sa2({ lineCap: "round" }, S2.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
              g5.add(k2);
              var R6 = this._progressLine = new Zm({ shape: { x1: A2[0], x2: this._currentPointer ? this._currentPointer.x : A2[0], y1: 0, y2: 0 }, style: Cl({ lineCap: "round", lineWidth: k2.style.lineWidth }, S2.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
              g5.add(R6);
            }
          }, s.prototype._renderAxisTick = function(r5, g5, b6, S2) {
            var A2 = this, k2 = S2.getData(), R6 = b6.scale.getTicks();
            this._tickSymbols = [], Ye2(R6, function(B3) {
              var G3 = b6.dataToCoord(B3.value), Z3 = k2.getItemModel(B3.value), X3 = Z3.getModel("itemStyle"), tt = Z3.getModel(["emphasis", "itemStyle"]), it = Z3.getModel(["progress", "itemStyle"]), pt = { x: G3, y: 0, onclick: Cs(A2._changeTimeline, A2, B3.value) }, mt = SLe(Z3, X3, g5, pt);
              mt.ensureState("emphasis").style = tt.getItemStyle(), mt.ensureState("progress").style = it.getItemStyle(), vR(mt);
              var Mt = Pl(mt);
              Z3.get("tooltip") ? (Mt.dataIndex = B3.value, Mt.dataModel = S2) : Mt.dataIndex = Mt.dataModel = null, A2._tickSymbols.push(mt);
            });
          }, s.prototype._renderAxisLabel = function(r5, g5, b6, S2) {
            var A2 = this, k2 = b6.getLabelModel();
            if (k2.get("show")) {
              var R6 = S2.getData(), B3 = b6.getViewLabels();
              this._tickLabels = [], Ye2(B3, function(G3) {
                var Z3 = G3.tickValue, X3 = R6.getItemModel(Z3), tt = X3.getModel("label"), it = X3.getModel(["emphasis", "label"]), pt = X3.getModel(["progress", "label"]), mt = b6.dataToCoord(G3.tickValue), Mt = new hh2({ x: mt, y: 0, rotation: r5.labelRotation - r5.rotation, onclick: Cs(A2._changeTimeline, A2, Z3), silent: false, style: Ey(tt, { text: G3.formattedLabel, align: r5.labelAlign, verticalAlign: r5.labelBaseline }) });
                Mt.ensureState("emphasis").style = Ey(it), Mt.ensureState("progress").style = Ey(pt), g5.add(Mt), vR(Mt), wLe(Mt).dataIndex = Z3, A2._tickLabels.push(Mt);
              });
            }
          }, s.prototype._renderControl = function(r5, g5, b6, S2) {
            var A2 = r5.controlSize, k2 = r5.rotation, R6 = S2.getModel("controlStyle").getItemStyle(), B3 = S2.getModel(["emphasis", "controlStyle"]).getItemStyle(), G3 = S2.getPlayState(), Z3 = S2.get("inverse", true);
            X3(r5.nextBtnPosition, "next", Cs(this._changeTimeline, this, Z3 ? "-" : "+")), X3(r5.prevBtnPosition, "prev", Cs(this._changeTimeline, this, Z3 ? "+" : "-")), X3(r5.playPosition, G3 ? "stop" : "play", Cs(this._handlePlayClick, this, !G3), true);
            function X3(tt, it, pt, mt) {
              if (tt) {
                var Mt = f22(tc2(S2.get(["controlStyle", it + "BtnSize"]), A2), A2), kt = [0, -Mt / 2, Mt, Mt], Gt = LKn(S2, it + "Icon", kt, { x: tt[0], y: tt[1], originX: A2 / 2, originY: 0, rotation: mt ? -k2 : 0, rectHover: true, style: R6, onclick: pt });
                Gt.ensureState("emphasis").style = B3, g5.add(Gt), vR(Gt);
              }
            }
          }, s.prototype._renderCurrentPointer = function(r5, g5, b6, S2) {
            var A2 = S2.getData(), k2 = S2.getCurrentIndex(), R6 = A2.getItemModel(k2).getModel("checkpointStyle"), B3 = this, G3 = { onCreate: function(Z3) {
              Z3.draggable = true, Z3.drift = Cs(B3._handlePointerDrag, B3), Z3.ondragend = Cs(B3._handlePointerDragend, B3), MLe(Z3, B3._progressLine, k2, b6, S2, true);
            }, onUpdate: function(Z3) {
              MLe(Z3, B3._progressLine, k2, b6, S2);
            } };
            this._currentPointer = SLe(R6, R6, this._mainGroup, {}, this._currentPointer, G3);
          }, s.prototype._handlePlayClick = function(r5) {
            this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: r5, from: this.uid });
          }, s.prototype._handlePointerDrag = function(r5, g5, b6) {
            this._clearTimer(), this._pointerChangeTimeline([b6.offsetX, b6.offsetY]);
          }, s.prototype._handlePointerDragend = function(r5) {
            this._pointerChangeTimeline([r5.offsetX, r5.offsetY], true);
          }, s.prototype._pointerChangeTimeline = function(r5, g5) {
            var b6 = this._toAxisCoord(r5)[0], S2 = this._axis, A2 = h2(S2.getExtent().slice());
            b6 > A2[1] && (b6 = A2[1]), b6 < A2[0] && (b6 = A2[0]), this._currentPointer.x = b6, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = b6, this._progressLine.dirty();
            var k2 = this._findNearestTick(b6), R6 = this.model;
            (g5 || k2 !== R6.getCurrentIndex() && R6.get("realtime")) && this._changeTimeline(k2);
          }, s.prototype._doPlayStop = function() {
            var r5 = this;
            this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
              var g5 = r5.model;
              r5._changeTimeline(g5.getCurrentIndex() + (g5.get("rewind", true) ? -1 : 1));
            }, this.model.get("playInterval")));
          }, s.prototype._toAxisCoord = function(r5) {
            var g5 = this._mainGroup.getLocalTransform();
            return Lo(r5, g5, true);
          }, s.prototype._findNearestTick = function(r5) {
            var g5 = this.model.getData(), b6 = 1 / 0, S2, A2 = this._axis;
            return g5.each(["value"], function(k2, R6) {
              var B3 = A2.dataToCoord(k2), G3 = Math.abs(B3 - r5);
              G3 < b6 && (b6 = G3, S2 = R6);
            }), S2;
          }, s.prototype._clearTimer = function() {
            this._timer && (clearTimeout(this._timer), this._timer = null);
          }, s.prototype._changeTimeline = function(r5) {
            var g5 = this.model.getCurrentIndex();
            r5 === "+" ? r5 = g5 + 1 : r5 === "-" && (r5 = g5 - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: r5, from: this.uid });
          }, s.prototype._updateTicksStatus = function() {
            var r5 = this.model.getCurrentIndex(), g5 = this._tickSymbols, b6 = this._tickLabels;
            if (g5)
              for (var S2 = 0; S2 < g5.length; S2++)
                g5 && g5[S2] && g5[S2].toggleState("progress", S2 < r5);
            if (b6)
              for (var S2 = 0; S2 < b6.length; S2++)
                b6 && b6[S2] && b6[S2].toggleState("progress", wLe(b6[S2]).dataIndex <= r5);
          }, s.type = "timeline.slider", s;
        }(AKn);
        function kKn(c5, s) {
          if (s = s || c5.get("type"), s)
            switch (s) {
              case "category":
                return new CGt({ ordinalMeta: c5.getCategories(), extent: [1 / 0, -1 / 0] });
              case "time":
                return new UIe({ locale: c5.ecModel.getLocaleModel(), useUTC: c5.ecModel.get("useUTC") });
              default:
                return new n9();
            }
        }
        function PKn(c5, s) {
          return $m(c5.getBoxLayoutParams(), { width: s.getWidth(), height: s.getHeight() }, c5.get("padding"));
        }
        function LKn(c5, s, r5, g5) {
          var b6 = g5.style, S2 = ph2(c5.get(["controlStyle", s]), g5 || {}, new lc2(r5[0], r5[1], r5[2], r5[3]));
          return b6 && S2.setStyle(b6), S2;
        }
        function SLe(c5, s, r5, g5, b6, S2) {
          var A2 = s.get("color");
          if (b6)
            b6.setColor(A2), r5.add(b6), S2 && S2.onUpdate(b6);
          else {
            var k2 = c5.get("symbol");
            b6 = am(k2, -1, -1, 2, 2, A2), b6.setStyle("strokeNoScale", true), r5.add(b6), S2 && S2.onCreate(b6);
          }
          var R6 = s.getItemStyle(["color"]);
          b6.setStyle(R6), g5 = bu({ rectHover: true, z2: 100 }, g5, true);
          var B3 = vct(c5.get("symbolSize"));
          g5.scaleX = B3[0] / 2, g5.scaleY = B3[1] / 2;
          var G3 = vX(c5.get("symbolOffset"), B3);
          G3 && (g5.x = (g5.x || 0) + G3[0], g5.y = (g5.y || 0) + G3[1]);
          var Z3 = c5.get("symbolRotate");
          return g5.rotation = (Z3 || 0) * Math.PI / 180 || 0, b6.attr(g5), b6.updateTransform(), b6;
        }
        function MLe(c5, s, r5, g5, b6, S2) {
          if (!c5.dragging) {
            var A2 = b6.getModel("checkpointStyle"), k2 = g5.dataToCoord(b6.getData().get("value", r5));
            if (S2 || !A2.get("animation", true))
              c5.attr({ x: k2, y: 0 }), s && s.attr({ shape: { x2: k2 } });
            else {
              var R6 = { duration: A2.get("animationDuration", true), easing: A2.get("animationEasing", true) };
              c5.stopAnimation(null, true), c5.animateTo({ x: k2, y: 0 }, R6), s && s.animateTo({ shape: { x2: k2 } }, R6);
            }
          }
        }
        var OKn = EKn;
        function RKn(c5) {
          c5.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(s, r5, g5) {
            var b6 = r5.getComponent("timeline");
            return b6 && s.currentIndex != null && (b6.setCurrentIndex(s.currentIndex), !b6.get("loop", true) && b6.isIndexMax() && b6.getPlayState() && (b6.setPlayState(false), g5.dispatchAction({ type: "timelinePlayChange", playState: false, from: s.from }))), r5.resetOption("timeline", { replaceMerge: b6.get("replaceMerge", true) }), Cl({ currentIndex: b6.option.currentIndex }, s);
          }), c5.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(s, r5) {
            var g5 = r5.getComponent("timeline");
            g5 && s.playState != null && g5.setPlayState(s.playState);
          });
        }
        function NKn(c5) {
          var s = c5 && c5.timeline;
          ja2(s) || (s = s ? [s] : []), Ye2(s, function(r5) {
            !r5 || FKn(r5);
          });
        }
        function FKn(c5) {
          var s = c5.type, r5 = { number: "value", time: "time" };
          if (r5[s] && (c5.axisType = r5[s], delete c5.type), CLe(c5), OW(c5, "controlPosition")) {
            var g5 = c5.controlStyle || (c5.controlStyle = {});
            OW(g5, "position") || (g5.position = c5.controlPosition), g5.position === "none" && !OW(g5, "show") && (g5.show = false, delete g5.position), delete c5.controlPosition;
          }
          Ye2(c5.data || [], function(b6) {
            Wl(b6) && !ja2(b6) && (!OW(b6, "value") && OW(b6, "name") && (b6.value = b6.name), CLe(b6));
          });
        }
        function CLe(c5) {
          var s = c5.itemStyle || (c5.itemStyle = {}), r5 = s.emphasis || (s.emphasis = {}), g5 = c5.label || c5.label || {}, b6 = g5.normal || (g5.normal = {}), S2 = { normal: 1, emphasis: 1 };
          Ye2(g5, function(A2, k2) {
            !S2[k2] && !OW(b6, k2) && (b6[k2] = A2);
          }), r5.label && !OW(g5, "emphasis") && (g5.emphasis = r5.label, delete r5.label);
        }
        function OW(c5, s) {
          return c5.hasOwnProperty(s);
        }
        function VKn(c5) {
          c5.registerComponentModel(CKn), c5.registerComponentView(OKn), c5.registerSubTypeDefaulter("timeline", function() {
            return "slider";
          }), RKn(c5), c5.registerPreprocessor(NKn);
        }
        function cqt(c5, s) {
          if (!c5)
            return false;
          for (var r5 = ja2(c5) ? c5 : [c5], g5 = 0; g5 < r5.length; g5++)
            if (r5[g5] && r5[g5][s])
              return true;
          return false;
        }
        function ICt(c5) {
          wM(c5, "label", ["show"]);
        }
        var DCt = Df2(), TLe = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.createdBySelf = false, r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            this.mergeDefaultAndTheme(r5, b6), this._mergeOption(r5, b6, false, true);
          }, s.prototype.isAnimationEnabled = function() {
            if (os.node)
              return false;
            var r5 = this.__hostSeries;
            return this.getShallow("animation") && r5 && r5.isAnimationEnabled();
          }, s.prototype.mergeOption = function(r5, g5) {
            this._mergeOption(r5, g5, false, false);
          }, s.prototype._mergeOption = function(r5, g5, b6, S2) {
            var A2 = this.mainType;
            b6 || g5.eachSeries(function(k2) {
              var R6 = k2.get(this.mainType, true), B3 = DCt(k2)[A2];
              if (!R6 || !R6.data) {
                DCt(k2)[A2] = null;
                return;
              }
              B3 ? B3._mergeOption(R6, g5, true) : (S2 && ICt(R6), Ye2(R6.data, function(G3) {
                G3 instanceof Array ? (ICt(G3[0]), ICt(G3[1])) : ICt(G3);
              }), B3 = this.createMarkerModelFromSeries(R6, this, g5), sa2(B3, { mainType: this.mainType, seriesIndex: k2.seriesIndex, name: k2.name, createdBySelf: true }), B3.__hostSeries = k2), DCt(k2)[A2] = B3;
            }, this);
          }, s.prototype.formatTooltip = function(r5, g5, b6) {
            var S2 = this.getData(), A2 = this.getRawValue(r5), k2 = S2.getName(r5);
            return W1("section", { header: this.name, blocks: [W1("nameValue", { name: k2, value: A2, noName: !k2, noValue: A2 == null })] });
          }, s.prototype.getData = function() {
            return this._data;
          }, s.prototype.setData = function(r5) {
            this._data = r5;
          }, s.getMarkerModelFromSeries = function(r5, g5) {
            return DCt(r5)[g5];
          }, s.type = "marker", s.dependencies = ["series", "grid", "polar", "geo"], s;
        }(Rh2);
        A0(TLe, jWt.prototype);
        var p9 = TLe, BKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.createMarkerModelFromSeries = function(r5, g5, b6) {
            return new s(r5, g5, b6);
          }, s.type = "markPoint", s.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, s;
        }(p9), zKn = BKn;
        function jKn(c5) {
          return !(isNaN(parseFloat(c5.x)) && isNaN(parseFloat(c5.y)));
        }
        function WKn(c5) {
          return !isNaN(parseFloat(c5.x)) && !isNaN(parseFloat(c5.y));
        }
        function ECt(c5, s, r5, g5, b6, S2) {
          var A2 = [], k2 = e9(s, g5), R6 = k2 ? s.getCalculationInfo("stackResultDimension") : g5, B3 = hqt(s, R6, c5), G3 = s.indicesOfNearest(R6, B3)[0];
          A2[b6] = s.get(r5, G3), A2[S2] = s.get(R6, G3);
          var Z3 = s.get(g5, G3), X3 = XC(s.get(g5, G3));
          return X3 = Math.min(X3, 20), X3 >= 0 && (A2[S2] = +A2[S2].toFixed(X3)), [A2, Z3];
        }
        var fqt = { min: Au(ECt, "min"), max: Au(ECt, "max"), average: Au(ECt, "average"), median: Au(ECt, "median") };
        function cft(c5, s) {
          var r5 = c5.getData(), g5 = c5.coordinateSystem;
          if (s && !WKn(s) && !ja2(s.coord) && g5) {
            var b6 = g5.dimensions, S2 = ALe(s, r5, g5, c5);
            if (s = Ml(s), s.type && fqt[s.type] && S2.baseAxis && S2.valueAxis) {
              var A2 = Lu(b6, S2.baseAxis.dim), k2 = Lu(b6, S2.valueAxis.dim), R6 = fqt[s.type](r5, S2.baseDataDim, S2.valueDataDim, A2, k2);
              s.coord = R6[0], s.value = R6[1];
            } else {
              for (var B3 = [s.xAxis != null ? s.xAxis : s.radiusAxis, s.yAxis != null ? s.yAxis : s.angleAxis], G3 = 0; G3 < 2; G3++)
                fqt[B3[G3]] && (B3[G3] = hqt(r5, r5.mapDimension(b6[G3]), B3[G3]));
              s.coord = B3;
            }
          }
          return s;
        }
        function ALe(c5, s, r5, g5) {
          var b6 = {};
          return c5.valueIndex != null || c5.valueDim != null ? (b6.valueDataDim = c5.valueIndex != null ? s.getDimension(c5.valueIndex) : c5.valueDim, b6.valueAxis = r5.getAxis(GKn(g5, b6.valueDataDim)), b6.baseAxis = r5.getOtherAxis(b6.valueAxis), b6.baseDataDim = s.mapDimension(b6.baseAxis.dim)) : (b6.baseAxis = g5.getBaseAxis(), b6.valueAxis = r5.getOtherAxis(b6.baseAxis), b6.baseDataDim = s.mapDimension(b6.baseAxis.dim), b6.valueDataDim = s.mapDimension(b6.valueAxis.dim)), b6;
        }
        function GKn(c5, s) {
          var r5 = c5.getData().getDimensionInfo(s);
          return r5 && r5.coordDim;
        }
        function fft(c5, s) {
          return c5 && c5.containData && s.coord && !jKn(s) ? c5.containData(s.coord) : true;
        }
        function ILe(c5, s) {
          return c5 ? function(r5, g5, b6, S2) {
            var A2 = S2 < 2 ? r5.coord && r5.coord[S2] : r5.value;
            return X8(A2, s[S2]);
          } : function(r5, g5, b6, S2) {
            return X8(r5.value, s[S2]);
          };
        }
        function hqt(c5, s, r5) {
          if (r5 === "average") {
            var g5 = 0, b6 = 0;
            return c5.each(s, function(S2, A2) {
              isNaN(S2) || (g5 += S2, b6++);
            }), g5 / b6;
          } else
            return r5 === "median" ? c5.getMedian(s) : c5.getDataExtent(s)[r5 === "max" ? 1 : 0];
        }
        var pqt = Df2(), HKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.init = function() {
            this.markerGroupMap = Ps();
          }, s.prototype.render = function(r5, g5, b6) {
            var S2 = this, A2 = this.markerGroupMap;
            A2.each(function(k2) {
              pqt(k2).keep = false;
            }), g5.eachSeries(function(k2) {
              var R6 = p9.getMarkerModelFromSeries(k2, S2.type);
              R6 && S2.renderSeries(k2, R6, g5, b6);
            }), A2.each(function(k2) {
              !pqt(k2).keep && S2.group.remove(k2.group);
            });
          }, s.prototype.markKeep = function(r5) {
            pqt(r5).keep = true;
          }, s.prototype.blurSeries = function(r5) {
            var g5 = this;
            Ye2(r5, function(b6) {
              var S2 = p9.getMarkerModelFromSeries(b6, g5.type);
              if (S2) {
                var A2 = S2.getData();
                A2.eachItemGraphicEl(function(k2) {
                  k2 && _2t(k2);
                });
              }
            });
          }, s.type = "marker", s;
        }(P0), dqt = HKn;
        function DLe(c5, s, r5) {
          var g5 = s.coordinateSystem;
          c5.each(function(b6) {
            var S2 = c5.getItemModel(b6), A2, k2 = $o(S2.get("x"), r5.getWidth()), R6 = $o(S2.get("y"), r5.getHeight());
            if (!isNaN(k2) && !isNaN(R6))
              A2 = [k2, R6];
            else if (s.getMarkerPosition)
              A2 = s.getMarkerPosition(c5.getValues(c5.dimensions, b6));
            else if (g5) {
              var B3 = c5.get(g5.dimensions[0], b6), G3 = c5.get(g5.dimensions[1], b6);
              A2 = g5.dataToPoint([B3, G3]);
            }
            isNaN(k2) || (A2[0] = k2), isNaN(R6) || (A2[1] = R6), c5.setItemLayout(b6, A2);
          });
        }
        var UKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.updateTransform = function(r5, g5, b6) {
            g5.eachSeries(function(S2) {
              var A2 = p9.getMarkerModelFromSeries(S2, "markPoint");
              A2 && (DLe(A2.getData(), S2, b6), this.markerGroupMap.get(S2.id).updateLayout());
            }, this);
          }, s.prototype.renderSeries = function(r5, g5, b6, S2) {
            var A2 = r5.coordinateSystem, k2 = r5.id, R6 = r5.getData(), B3 = this.markerGroupMap, G3 = B3.get(k2) || B3.set(k2, new Vct()), Z3 = qKn(A2, r5, g5);
            g5.setData(Z3), DLe(g5.getData(), r5, S2), Z3.each(function(X3) {
              var tt = Z3.getItemModel(X3), it = tt.getShallow("symbol"), pt = tt.getShallow("symbolSize"), mt = tt.getShallow("symbolRotate"), Mt = tt.getShallow("symbolOffset"), kt = tt.getShallow("symbolKeepAspect");
              if (Tl(it) || Tl(pt) || Tl(mt) || Tl(Mt)) {
                var Gt = g5.getRawValue(X3), Ot = g5.getDataParams(X3);
                Tl(it) && (it = it(Gt, Ot)), Tl(pt) && (pt = pt(Gt, Ot)), Tl(mt) && (mt = mt(Gt, Ot)), Tl(Mt) && (Mt = Mt(Gt, Ot));
              }
              var ce2 = tt.getModel("itemStyle").getItemStyle(), ae2 = gct(R6, "color");
              ce2.fill || (ce2.fill = ae2), Z3.setItemVisual(X3, { symbol: it, symbolSize: pt, symbolRotate: mt, symbolOffset: Mt, symbolKeepAspect: kt, style: ce2 });
            }), G3.updateData(Z3), this.group.add(G3.group), Z3.eachItemGraphicEl(function(X3) {
              X3.traverse(function(tt) {
                Pl(tt).dataModel = g5;
              });
            }), this.markKeep(G3), G3.group.silent = g5.get("silent") || r5.get("silent");
          }, s.type = "markPoint", s;
        }(dqt);
        function qKn(c5, s, r5) {
          var g5;
          c5 ? g5 = Ha2(c5 && c5.dimensions, function(k2) {
            var R6 = s.getData().getDimensionInfo(s.getData().mapDimension(k2)) || {};
            return sa2(sa2({}, R6), { name: k2, ordinalMeta: null });
          }) : g5 = [{ name: "value", type: "float" }];
          var b6 = new m22(g5, r5), S2 = Ha2(r5.get("data"), Au(cft, s));
          c5 && (S2 = jp(S2, Au(fft, c5)));
          var A2 = ILe(!!c5, g5);
          return b6.initData(S2, null, A2), b6;
        }
        var ZKn = UKn;
        function $Kn(c5) {
          c5.registerComponentModel(zKn), c5.registerComponentView(ZKn), c5.registerPreprocessor(function(s) {
            cqt(s.series, "markPoint") && (s.markPoint = s.markPoint || {});
          });
        }
        var YKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.createMarkerModelFromSeries = function(r5, g5, b6) {
            return new s(r5, g5, b6);
          }, s.type = "markLine", s.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, s;
        }(p9), KKn = YKn, kCt = Df2(), XKn = function(c5, s, r5, g5) {
          var b6 = c5.getData(), S2;
          if (ja2(g5))
            S2 = g5;
          else {
            var A2 = g5.type;
            if (A2 === "min" || A2 === "max" || A2 === "average" || A2 === "median" || g5.xAxis != null || g5.yAxis != null) {
              var k2 = void 0, R6 = void 0;
              if (g5.yAxis != null || g5.xAxis != null)
                k2 = s.getAxis(g5.yAxis != null ? "y" : "x"), R6 = Wm(g5.yAxis, g5.xAxis);
              else {
                var B3 = ALe(g5, b6, s, c5);
                k2 = B3.valueAxis;
                var G3 = DIe(b6, B3.valueDataDim);
                R6 = hqt(b6, G3, A2);
              }
              var Z3 = k2.dim === "x" ? 0 : 1, X3 = 1 - Z3, tt = Ml(g5), it = { coord: [] };
              tt.type = null, tt.coord = [], tt.coord[X3] = -1 / 0, it.coord[X3] = 1 / 0;
              var pt = r5.get("precision");
              pt >= 0 && Oh2(R6) && (R6 = +R6.toFixed(Math.min(pt, 20))), tt.coord[Z3] = it.coord[Z3] = R6, S2 = [tt, it, { type: A2, valueIndex: g5.valueIndex, value: R6 }];
            } else
              S2 = [];
          }
          var mt = [cft(c5, S2[0]), cft(c5, S2[1]), sa2({}, S2[2])];
          return mt[2].type = mt[2].type || null, bu(mt[2], mt[0]), bu(mt[2], mt[1]), mt;
        };
        function PCt(c5) {
          return !isNaN(c5) && !isFinite(c5);
        }
        function ELe(c5, s, r5, g5) {
          var b6 = 1 - c5, S2 = g5.dimensions[c5];
          return PCt(s[b6]) && PCt(r5[b6]) && s[c5] === r5[c5] && g5.getAxis(S2).containData(s[c5]);
        }
        function QKn(c5, s) {
          if (c5.type === "cartesian2d") {
            var r5 = s[0].coord, g5 = s[1].coord;
            if (r5 && g5 && (ELe(1, r5, g5, c5) || ELe(0, r5, g5, c5)))
              return true;
          }
          return fft(c5, s[0]) && fft(c5, s[1]);
        }
        function gqt(c5, s, r5, g5, b6) {
          var S2 = g5.coordinateSystem, A2 = c5.getItemModel(s), k2, R6 = $o(A2.get("x"), b6.getWidth()), B3 = $o(A2.get("y"), b6.getHeight());
          if (!isNaN(R6) && !isNaN(B3))
            k2 = [R6, B3];
          else {
            if (g5.getMarkerPosition)
              k2 = g5.getMarkerPosition(c5.getValues(c5.dimensions, s));
            else {
              var G3 = S2.dimensions, Z3 = c5.get(G3[0], s), X3 = c5.get(G3[1], s);
              k2 = S2.dataToPoint([Z3, X3]);
            }
            if (CR(S2, "cartesian2d")) {
              var tt = S2.getAxis("x"), it = S2.getAxis("y"), G3 = S2.dimensions;
              PCt(c5.get(G3[0], s)) ? k2[0] = tt.toGlobalCoord(tt.getExtent()[r5 ? 0 : 1]) : PCt(c5.get(G3[1], s)) && (k2[1] = it.toGlobalCoord(it.getExtent()[r5 ? 0 : 1]));
            }
            isNaN(R6) || (k2[0] = R6), isNaN(B3) || (k2[1] = B3);
          }
          c5.setItemLayout(s, k2);
        }
        var JKn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.updateTransform = function(r5, g5, b6) {
            g5.eachSeries(function(S2) {
              var A2 = p9.getMarkerModelFromSeries(S2, "markLine");
              if (A2) {
                var k2 = A2.getData(), R6 = kCt(A2).from, B3 = kCt(A2).to;
                R6.each(function(G3) {
                  gqt(R6, G3, true, S2, b6), gqt(B3, G3, false, S2, b6);
                }), k2.each(function(G3) {
                  k2.setItemLayout(G3, [R6.getItemLayout(G3), B3.getItemLayout(G3)]);
                }), this.markerGroupMap.get(S2.id).updateLayout();
              }
            }, this);
          }, s.prototype.renderSeries = function(r5, g5, b6, S2) {
            var A2 = r5.coordinateSystem, k2 = r5.id, R6 = r5.getData(), B3 = this.markerGroupMap, G3 = B3.get(k2) || B3.set(k2, new UHt());
            this.group.add(G3.group);
            var Z3 = tXn(A2, r5, g5), X3 = Z3.from, tt = Z3.to, it = Z3.line;
            kCt(g5).from = X3, kCt(g5).to = tt, g5.setData(it);
            var pt = g5.get("symbol"), mt = g5.get("symbolSize"), Mt = g5.get("symbolRotate"), kt = g5.get("symbolOffset");
            ja2(pt) || (pt = [pt, pt]), ja2(mt) || (mt = [mt, mt]), ja2(Mt) || (Mt = [Mt, Mt]), ja2(kt) || (kt = [kt, kt]), Z3.from.each(function(Ot) {
              Gt(X3, Ot, true), Gt(tt, Ot, false);
            }), it.each(function(Ot) {
              var ce2 = it.getItemModel(Ot).getModel("lineStyle").getLineStyle();
              it.setItemLayout(Ot, [X3.getItemLayout(Ot), tt.getItemLayout(Ot)]), ce2.stroke == null && (ce2.stroke = X3.getItemVisual(Ot, "style").fill), it.setItemVisual(Ot, { fromSymbolKeepAspect: X3.getItemVisual(Ot, "symbolKeepAspect"), fromSymbolOffset: X3.getItemVisual(Ot, "symbolOffset"), fromSymbolRotate: X3.getItemVisual(Ot, "symbolRotate"), fromSymbolSize: X3.getItemVisual(Ot, "symbolSize"), fromSymbol: X3.getItemVisual(Ot, "symbol"), toSymbolKeepAspect: tt.getItemVisual(Ot, "symbolKeepAspect"), toSymbolOffset: tt.getItemVisual(Ot, "symbolOffset"), toSymbolRotate: tt.getItemVisual(Ot, "symbolRotate"), toSymbolSize: tt.getItemVisual(Ot, "symbolSize"), toSymbol: tt.getItemVisual(Ot, "symbol"), style: ce2 });
            }), G3.updateData(it), Z3.line.eachItemGraphicEl(function(Ot, ce2) {
              Ot.traverse(function(ae2) {
                Pl(ae2).dataModel = g5;
              });
            });
            function Gt(Ot, ce2, ae2) {
              var de2 = Ot.getItemModel(ce2);
              gqt(Ot, ce2, ae2, r5, S2);
              var we2 = de2.getModel("itemStyle").getItemStyle();
              we2.fill == null && (we2.fill = gct(R6, "color")), Ot.setItemVisual(ce2, { symbolKeepAspect: de2.get("symbolKeepAspect"), symbolOffset: tc2(de2.get("symbolOffset", true), kt[ae2 ? 0 : 1]), symbolRotate: tc2(de2.get("symbolRotate", true), Mt[ae2 ? 0 : 1]), symbolSize: tc2(de2.get("symbolSize"), mt[ae2 ? 0 : 1]), symbol: tc2(de2.get("symbol", true), pt[ae2 ? 0 : 1]), style: we2 });
            }
            this.markKeep(G3), G3.group.silent = g5.get("silent") || r5.get("silent");
          }, s.type = "markLine", s;
        }(dqt);
        function tXn(c5, s, r5) {
          var g5;
          c5 ? g5 = Ha2(c5 && c5.dimensions, function(B3) {
            var G3 = s.getData().getDimensionInfo(s.getData().mapDimension(B3)) || {};
            return sa2(sa2({}, G3), { name: B3, ordinalMeta: null });
          }) : g5 = [{ name: "value", type: "float" }];
          var b6 = new m22(g5, r5), S2 = new m22(g5, r5), A2 = new m22([], r5), k2 = Ha2(r5.get("data"), Au(XKn, s, c5, r5));
          c5 && (k2 = jp(k2, Au(QKn, c5)));
          var R6 = ILe(!!c5, g5);
          return b6.initData(Ha2(k2, function(B3) {
            return B3[0];
          }), null, R6), S2.initData(Ha2(k2, function(B3) {
            return B3[1];
          }), null, R6), A2.initData(Ha2(k2, function(B3) {
            return B3[2];
          })), A2.hasItemOption = true, { from: b6, to: S2, line: A2 };
        }
        var eXn = JKn;
        function nXn(c5) {
          c5.registerComponentModel(KKn), c5.registerComponentView(eXn), c5.registerPreprocessor(function(s) {
            cqt(s.series, "markLine") && (s.markLine = s.markLine || {});
          });
        }
        var rXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.createMarkerModelFromSeries = function(r5, g5, b6) {
            return new s(r5, g5, b6);
          }, s.type = "markArea", s.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, s;
        }(p9), iXn = rXn, LCt = Df2(), aXn = function(c5, s, r5, g5) {
          var b6 = cft(c5, g5[0]), S2 = cft(c5, g5[1]), A2 = b6.coord, k2 = S2.coord;
          A2[0] = Wm(A2[0], -1 / 0), A2[1] = Wm(A2[1], -1 / 0), k2[0] = Wm(k2[0], 1 / 0), k2[1] = Wm(k2[1], 1 / 0);
          var R6 = B4([{}, b6, S2]);
          return R6.coord = [b6.coord, S2.coord], R6.x0 = b6.x, R6.y0 = b6.y, R6.x1 = S2.x, R6.y1 = S2.y, R6;
        };
        function OCt(c5) {
          return !isNaN(c5) && !isFinite(c5);
        }
        function kLe(c5, s, r5, g5) {
          var b6 = 1 - c5;
          return OCt(s[b6]) && OCt(r5[b6]);
        }
        function oXn(c5, s) {
          var r5 = s.coord[0], g5 = s.coord[1];
          return CR(c5, "cartesian2d") && r5 && g5 && (kLe(1, r5, g5) || kLe(0, r5, g5)) ? true : fft(c5, { coord: r5, x: s.x0, y: s.y0 }) || fft(c5, { coord: g5, x: s.x1, y: s.y1 });
        }
        function PLe(c5, s, r5, g5, b6) {
          var S2 = g5.coordinateSystem, A2 = c5.getItemModel(s), k2, R6 = $o(A2.get(r5[0]), b6.getWidth()), B3 = $o(A2.get(r5[1]), b6.getHeight());
          if (!isNaN(R6) && !isNaN(B3))
            k2 = [R6, B3];
          else {
            if (g5.getMarkerPosition)
              k2 = g5.getMarkerPosition(c5.getValues(r5, s));
            else {
              var G3 = c5.get(r5[0], s), Z3 = c5.get(r5[1], s), X3 = [G3, Z3];
              S2.clampData && S2.clampData(X3, X3), k2 = S2.dataToPoint(X3, true);
            }
            if (CR(S2, "cartesian2d")) {
              var tt = S2.getAxis("x"), it = S2.getAxis("y"), G3 = c5.get(r5[0], s), Z3 = c5.get(r5[1], s);
              OCt(G3) ? k2[0] = tt.toGlobalCoord(tt.getExtent()[r5[0] === "x0" ? 0 : 1]) : OCt(Z3) && (k2[1] = it.toGlobalCoord(it.getExtent()[r5[1] === "y0" ? 0 : 1]));
            }
            isNaN(R6) || (k2[0] = R6), isNaN(B3) || (k2[1] = B3);
          }
          return k2;
        }
        var LLe = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], sXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.updateTransform = function(r5, g5, b6) {
            g5.eachSeries(function(S2) {
              var A2 = p9.getMarkerModelFromSeries(S2, "markArea");
              if (A2) {
                var k2 = A2.getData();
                k2.each(function(R6) {
                  var B3 = Ha2(LLe, function(Z3) {
                    return PLe(k2, R6, Z3, S2, b6);
                  });
                  k2.setItemLayout(R6, B3);
                  var G3 = k2.getItemGraphicEl(R6);
                  G3.setShape("points", B3);
                });
              }
            }, this);
          }, s.prototype.renderSeries = function(r5, g5, b6, S2) {
            var A2 = r5.coordinateSystem, k2 = r5.id, R6 = r5.getData(), B3 = this.markerGroupMap, G3 = B3.get(k2) || B3.set(k2, { group: new nu() });
            this.group.add(G3.group), this.markKeep(G3);
            var Z3 = lXn(A2, r5, g5);
            g5.setData(Z3), Z3.each(function(X3) {
              var tt = Ha2(LLe, function(we2) {
                return PLe(Z3, X3, we2, r5, S2);
              }), it = A2.getAxis("x").scale, pt = A2.getAxis("y").scale, mt = it.getExtent(), Mt = pt.getExtent(), kt = [it.parse(Z3.get("x0", X3)), it.parse(Z3.get("x1", X3))], Gt = [pt.parse(Z3.get("y0", X3)), pt.parse(Z3.get("y1", X3))];
              h2(kt), h2(Gt);
              var Ot = !(mt[0] > kt[1] || mt[1] < kt[0] || Mt[0] > Gt[1] || Mt[1] < Gt[0]), ce2 = !Ot;
              Z3.setItemLayout(X3, { points: tt, allClipped: ce2 });
              var ae2 = Z3.getItemModel(X3).getModel("itemStyle").getItemStyle(), de2 = gct(R6, "color");
              ae2.fill || (ae2.fill = de2, gs(ae2.fill) && (ae2.fill = YY(ae2.fill, 0.4))), ae2.stroke || (ae2.stroke = de2), Z3.setItemVisual(X3, "style", ae2);
            }), Z3.diff(LCt(G3).data).add(function(X3) {
              var tt = Z3.getItemLayout(X3);
              if (!tt.allClipped) {
                var it = new Gb2({ shape: { points: tt.points } });
                Z3.setItemGraphicEl(X3, it), G3.group.add(it);
              }
            }).update(function(X3, tt) {
              var it = LCt(G3).data.getItemGraphicEl(tt), pt = Z3.getItemLayout(X3);
              pt.allClipped ? it && G3.group.remove(it) : (it ? Qf2(it, { shape: { points: pt.points } }, g5, X3) : it = new Gb2({ shape: { points: pt.points } }), Z3.setItemGraphicEl(X3, it), G3.group.add(it));
            }).remove(function(X3) {
              var tt = LCt(G3).data.getItemGraphicEl(X3);
              G3.group.remove(tt);
            }).execute(), Z3.eachItemGraphicEl(function(X3, tt) {
              var it = Z3.getItemModel(tt), pt = Z3.getItemVisual(tt, "style");
              X3.useStyle(Z3.getItemVisual(tt, "style")), Uw(X3, qb2(it), { labelFetcher: g5, labelDataIndex: tt, defaultText: Z3.getName(tt) || "", inheritColor: gs(pt.fill) ? YY(pt.fill, 1) : "#000" }), z1(X3, it), f0(X3, null, null, it.get(["emphasis", "disabled"])), Pl(X3).dataModel = g5;
            }), LCt(G3).data = Z3, G3.group.silent = g5.get("silent") || r5.get("silent");
          }, s.type = "markArea", s;
        }(dqt);
        function lXn(c5, s, r5) {
          var g5, b6, S2 = ["x0", "y0", "x1", "y1"];
          if (c5) {
            var A2 = Ha2(c5 && c5.dimensions, function(B3) {
              var G3 = s.getData(), Z3 = G3.getDimensionInfo(G3.mapDimension(B3)) || {};
              return sa2(sa2({}, Z3), { name: B3, ordinalMeta: null });
            });
            b6 = Ha2(S2, function(B3, G3) {
              return { name: B3, type: A2[G3 % 2].type };
            }), g5 = new m22(b6, r5);
          } else
            b6 = [{ name: "value", type: "float" }], g5 = new m22(b6, r5);
          var k2 = Ha2(r5.get("data"), Au(aXn, s, c5, r5));
          c5 && (k2 = jp(k2, Au(oXn, c5)));
          var R6 = c5 ? function(B3, G3, Z3, X3) {
            var tt = B3.coord[Math.floor(X3 / 2)][X3 % 2];
            return X8(tt, b6[X3]);
          } : function(B3, G3, Z3, X3) {
            return X8(B3.value, b6[X3]);
          };
          return g5.initData(k2, null, R6), g5.hasItemOption = true, g5;
        }
        var uXn = sXn;
        function cXn(c5) {
          c5.registerComponentModel(iXn), c5.registerComponentView(uXn), c5.registerPreprocessor(function(s) {
            cqt(s.series, "markArea") && (s.markArea = s.markArea || {});
          });
        }
        var fXn = function(c5, s) {
          if (s === "all")
            return { type: "all", title: c5.getLocaleModel().get(["legend", "selector", "all"]) };
          if (s === "inverse")
            return { type: "inverse", title: c5.getLocaleModel().get(["legend", "selector", "inverse"]) };
        }, hXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.layoutMode = { type: "box", ignoreSize: true }, r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            this.mergeDefaultAndTheme(r5, b6), r5.selected = r5.selected || {}, this._updateSelector(r5);
          }, s.prototype.mergeOption = function(r5, g5) {
            c5.prototype.mergeOption.call(this, r5, g5), this._updateSelector(r5);
          }, s.prototype._updateSelector = function(r5) {
            var g5 = r5.selector, b6 = this.ecModel;
            g5 === true && (g5 = r5.selector = ["all", "inverse"]), ja2(g5) && Ye2(g5, function(S2, A2) {
              gs(S2) && (S2 = { type: S2 }), g5[A2] = bu(S2, fXn(b6, S2.type));
            });
          }, s.prototype.optionUpdated = function() {
            this._updateData(this.ecModel);
            var r5 = this._data;
            if (r5[0] && this.get("selectedMode") === "single") {
              for (var g5 = false, b6 = 0; b6 < r5.length; b6++) {
                var S2 = r5[b6].get("name");
                if (this.isSelected(S2)) {
                  this.select(S2), g5 = true;
                  break;
                }
              }
              !g5 && this.select(r5[0].get("name"));
            }
          }, s.prototype._updateData = function(r5) {
            var g5 = [], b6 = [];
            r5.eachRawSeries(function(k2) {
              var R6 = k2.name;
              b6.push(R6);
              var B3;
              if (k2.legendVisualProvider) {
                var G3 = k2.legendVisualProvider, Z3 = G3.getAllNames();
                r5.isSeriesFiltered(k2) || (b6 = b6.concat(Z3)), Z3.length ? g5 = g5.concat(Z3) : B3 = true;
              } else
                B3 = true;
              B3 && Xlt(k2) && g5.push(k2.name);
            }), this._availableNames = b6;
            var S2 = this.get("data") || g5, A2 = Ha2(S2, function(k2) {
              return (gs(k2) || Oh2(k2)) && (k2 = { name: k2 }), new Ag2(k2, this, this.ecModel);
            }, this);
            this._data = A2;
          }, s.prototype.getData = function() {
            return this._data;
          }, s.prototype.select = function(r5) {
            var g5 = this.option.selected, b6 = this.get("selectedMode");
            if (b6 === "single") {
              var S2 = this._data;
              Ye2(S2, function(A2) {
                g5[A2.get("name")] = false;
              });
            }
            g5[r5] = true;
          }, s.prototype.unSelect = function(r5) {
            this.get("selectedMode") !== "single" && (this.option.selected[r5] = false);
          }, s.prototype.toggleSelected = function(r5) {
            var g5 = this.option.selected;
            g5.hasOwnProperty(r5) || (g5[r5] = true), this[g5[r5] ? "unSelect" : "select"](r5);
          }, s.prototype.allSelect = function() {
            var r5 = this._data, g5 = this.option.selected;
            Ye2(r5, function(b6) {
              g5[b6.get("name", true)] = true;
            });
          }, s.prototype.inverseSelect = function() {
            var r5 = this._data, g5 = this.option.selected;
            Ye2(r5, function(b6) {
              var S2 = b6.get("name", true);
              g5.hasOwnProperty(S2) || (g5[S2] = true), g5[S2] = !g5[S2];
            });
          }, s.prototype.isSelected = function(r5) {
            var g5 = this.option.selected;
            return !(g5.hasOwnProperty(r5) && !g5[r5]) && Lu(this._availableNames, r5) >= 0;
          }, s.prototype.getOrient = function() {
            return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
          }, s.type = "legend.plain", s.dependencies = ["series"], s.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, s;
        }(Rh2), vqt = hXn, FX = Au, yqt = Ye2, RCt = nu, pXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.newlineDisabled = false, r5;
          }
          return s.prototype.init = function() {
            this.group.add(this._contentGroup = new RCt()), this.group.add(this._selectorGroup = new RCt()), this._isFirstRender = true;
          }, s.prototype.getContentGroup = function() {
            return this._contentGroup;
          }, s.prototype.getSelectorGroup = function() {
            return this._selectorGroup;
          }, s.prototype.render = function(r5, g5, b6) {
            var S2 = this._isFirstRender;
            if (this._isFirstRender = false, this.resetInner(), !!r5.get("show", true)) {
              var A2 = r5.get("align"), k2 = r5.get("orient");
              (!A2 || A2 === "auto") && (A2 = r5.get("left") === "right" && k2 === "vertical" ? "right" : "left");
              var R6 = r5.get("selector", true), B3 = r5.get("selectorPosition", true);
              R6 && (!B3 || B3 === "auto") && (B3 = k2 === "horizontal" ? "end" : "start"), this.renderInner(A2, r5, g5, b6, R6, k2, B3);
              var G3 = r5.getBoxLayoutParams(), Z3 = { width: b6.getWidth(), height: b6.getHeight() }, X3 = r5.get("padding"), tt = $m(G3, Z3, X3), it = this.layoutInner(r5, A2, tt, S2, R6, B3), pt = $m(Cl({ width: it.width, height: it.height }, G3), Z3, X3);
              this.group.x = pt.x - it.x, this.group.y = pt.y - it.y, this.group.markRedraw(), this.group.add(this._backgroundEl = W3e(it, r5));
            }
          }, s.prototype.resetInner = function() {
            this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
          }, s.prototype.renderInner = function(r5, g5, b6, S2, A2, k2, R6) {
            var B3 = this.getContentGroup(), G3 = Ps(), Z3 = g5.get("selectedMode"), X3 = [];
            b6.eachRawSeries(function(tt) {
              !tt.get("legendHoverLink") && X3.push(tt.id);
            }), yqt(g5.getData(), function(tt, it) {
              var pt = tt.get("name");
              if (!this.newlineDisabled && (pt === "" || pt === `
`)) {
                var mt = new RCt();
                mt.newline = true, B3.add(mt);
                return;
              }
              var Mt = b6.getSeriesByName(pt)[0];
              if (!G3.get(pt))
                if (Mt) {
                  var kt = Mt.getData(), Gt = kt.getVisual("legendLineStyle") || {}, Ot = kt.getVisual("legendIcon"), ce2 = kt.getVisual("style"), ae2 = this._createItem(Mt, pt, it, tt, g5, r5, Gt, ce2, Ot, Z3);
                  ae2.on("click", FX(OLe, pt, null, S2, X3)).on("mouseover", FX(mqt, Mt.name, null, S2, X3)).on("mouseout", FX(bqt, Mt.name, null, S2, X3)), G3.set(pt, true);
                } else
                  b6.eachRawSeries(function(de2) {
                    if (!G3.get(pt) && de2.legendVisualProvider) {
                      var we2 = de2.legendVisualProvider;
                      if (!we2.containName(pt))
                        return;
                      var Se2 = we2.indexOfName(pt), Oe2 = we2.getItemVisual(Se2, "style"), je2 = we2.getItemVisual(Se2, "legendIcon"), rn = Bb2(Oe2.fill);
                      rn && rn[3] === 0 && (rn[3] = 0.2, Oe2 = sa2(sa2({}, Oe2), { fill: vk2(rn, "rgba") }));
                      var qe2 = this._createItem(de2, pt, it, tt, g5, r5, {}, Oe2, je2, Z3);
                      qe2.on("click", FX(OLe, null, pt, S2, X3)).on("mouseover", FX(mqt, null, pt, S2, X3)).on("mouseout", FX(bqt, null, pt, S2, X3)), G3.set(pt, true);
                    }
                  }, this);
            }, this), A2 && this._createSelector(A2, g5, S2, k2, R6);
          }, s.prototype._createSelector = function(r5, g5, b6, S2, A2) {
            var k2 = this.getSelectorGroup();
            yqt(r5, function(R6) {
              var B3 = R6.type, G3 = new hh2({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
                b6.dispatchAction({ type: B3 === "all" ? "legendAllSelect" : "legendInverseSelect" });
              } });
              k2.add(G3);
              var Z3 = g5.getModel("selectorLabel"), X3 = g5.getModel(["emphasis", "selectorLabel"]);
              Uw(G3, { normal: Z3, emphasis: X3 }, { defaultText: R6.title }), vR(G3);
            });
          }, s.prototype._createItem = function(r5, g5, b6, S2, A2, k2, R6, B3, G3, Z3) {
            var X3 = r5.visualDrawType, tt = A2.get("itemWidth"), it = A2.get("itemHeight"), pt = A2.isSelected(g5), mt = S2.get("symbolRotate"), Mt = S2.get("symbolKeepAspect"), kt = S2.get("icon");
            G3 = kt || G3 || "roundRect";
            var Gt = dXn(G3, S2, R6, B3, X3, pt), Ot = new RCt(), ce2 = S2.getModel("textStyle");
            if (Tl(r5.getLegendIcon) && (!kt || kt === "inherit"))
              Ot.add(r5.getLegendIcon({ itemWidth: tt, itemHeight: it, icon: G3, iconRotate: mt, itemStyle: Gt.itemStyle, lineStyle: Gt.lineStyle, symbolKeepAspect: Mt }));
            else {
              var ae2 = kt === "inherit" && r5.getData().getVisual("symbol") ? mt === "inherit" ? r5.getData().getVisual("symbolRotate") : mt : 0;
              Ot.add(gXn({ itemWidth: tt, itemHeight: it, icon: G3, iconRotate: ae2, itemStyle: Gt.itemStyle, lineStyle: Gt.lineStyle, symbolKeepAspect: Mt }));
            }
            var de2 = k2 === "left" ? tt + 5 : -5, we2 = k2, Se2 = A2.get("formatter"), Oe2 = g5;
            gs(Se2) && Se2 ? Oe2 = Se2.replace("{name}", g5 != null ? g5 : "") : Tl(Se2) && (Oe2 = Se2(g5));
            var je2 = S2.get("inactiveColor");
            Ot.add(new hh2({ style: Ey(ce2, { text: Oe2, x: de2, y: it / 2, fill: pt ? ce2.getTextColor() : je2, align: we2, verticalAlign: "middle" }) }));
            var rn = new zf2({ shape: Ot.getBoundingRect(), invisible: true }), qe2 = S2.getModel("tooltip");
            return qe2.get("show") && Ub2({ el: rn, componentModel: A2, itemName: g5, itemTooltipOption: qe2.option }), Ot.add(rn), Ot.eachChild(function(An) {
              An.silent = true;
            }), rn.silent = !Z3, this.getContentGroup().add(Ot), vR(Ot), Ot.__legendDataIndex = b6, Ot;
          }, s.prototype.layoutInner = function(r5, g5, b6, S2, A2, k2) {
            var R6 = this.getContentGroup(), B3 = this.getSelectorGroup();
            lW(r5.get("orient"), R6, r5.get("itemGap"), b6.width, b6.height);
            var G3 = R6.getBoundingRect(), Z3 = [-G3.x, -G3.y];
            if (B3.markRedraw(), R6.markRedraw(), A2) {
              lW("horizontal", B3, r5.get("selectorItemGap", true));
              var X3 = B3.getBoundingRect(), tt = [-X3.x, -X3.y], it = r5.get("selectorButtonGap", true), pt = r5.getOrient().index, mt = pt === 0 ? "width" : "height", Mt = pt === 0 ? "height" : "width", kt = pt === 0 ? "y" : "x";
              k2 === "end" ? tt[pt] += G3[mt] + it : Z3[pt] += X3[mt] + it, tt[1 - pt] += G3[Mt] / 2 - X3[Mt] / 2, B3.x = tt[0], B3.y = tt[1], R6.x = Z3[0], R6.y = Z3[1];
              var Gt = { x: 0, y: 0 };
              return Gt[mt] = G3[mt] + it + X3[mt], Gt[Mt] = Math.max(G3[Mt], X3[Mt]), Gt[kt] = Math.min(0, X3[kt] + tt[1 - pt]), Gt;
            } else
              return R6.x = Z3[0], R6.y = Z3[1], this.group.getBoundingRect();
          }, s.prototype.remove = function() {
            this.getContentGroup().removeAll(), this._isFirstRender = true;
          }, s.type = "legend.plain", s;
        }(P0);
        function dXn(c5, s, r5, g5, b6, S2) {
          function A2(it, pt) {
            it.lineWidth === "auto" && (it.lineWidth = pt.lineWidth > 0 ? 2 : 0), yqt(it, function(mt, Mt) {
              it[Mt] === "inherit" && (it[Mt] = pt[Mt]);
            });
          }
          var k2 = s.getModel("itemStyle"), R6 = k2.getItemStyle(), B3 = c5.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
          R6.decal = g5.decal, R6.fill === "inherit" && (R6.fill = g5[b6]), R6.stroke === "inherit" && (R6.stroke = g5[B3]), R6.opacity === "inherit" && (R6.opacity = (b6 === "fill" ? g5 : r5).opacity), A2(R6, g5);
          var G3 = s.getModel("lineStyle"), Z3 = G3.getLineStyle();
          if (A2(Z3, r5), R6.fill === "auto" && (R6.fill = g5.fill), R6.stroke === "auto" && (R6.stroke = g5.fill), Z3.stroke === "auto" && (Z3.stroke = g5.fill), !S2) {
            var X3 = s.get("inactiveBorderWidth"), tt = R6[B3];
            R6.lineWidth = X3 === "auto" ? g5.lineWidth > 0 && tt ? 2 : 0 : R6.lineWidth, R6.fill = s.get("inactiveColor"), R6.stroke = s.get("inactiveBorderColor"), Z3.stroke = G3.get("inactiveColor"), Z3.lineWidth = G3.get("inactiveWidth");
          }
          return { itemStyle: R6, lineStyle: Z3 };
        }
        function gXn(c5) {
          var s = c5.icon || "roundRect", r5 = am(s, 0, 0, c5.itemWidth, c5.itemHeight, c5.itemStyle.fill, c5.symbolKeepAspect);
          return r5.setStyle(c5.itemStyle), r5.rotation = (c5.iconRotate || 0) * Math.PI / 180, r5.setOrigin([c5.itemWidth / 2, c5.itemHeight / 2]), s.indexOf("empty") > -1 && (r5.style.stroke = r5.style.fill, r5.style.fill = "#fff", r5.style.lineWidth = 2), r5;
        }
        function OLe(c5, s, r5, g5) {
          bqt(c5, s, r5, g5), r5.dispatchAction({ type: "legendToggleSelect", name: c5 != null ? c5 : s }), mqt(c5, s, r5, g5);
        }
        function RLe(c5) {
          for (var s = c5.getZr().storage.getDisplayList(), r5, g5 = 0, b6 = s.length; g5 < b6 && !(r5 = s[g5].states.emphasis); )
            g5++;
          return r5 && r5.hoverLayer;
        }
        function mqt(c5, s, r5, g5) {
          RLe(r5) || r5.dispatchAction({ type: "highlight", seriesName: c5, name: s, excludeSeriesId: g5 });
        }
        function bqt(c5, s, r5, g5) {
          RLe(r5) || r5.dispatchAction({ type: "downplay", seriesName: c5, name: s, excludeSeriesId: g5 });
        }
        var NLe = pXn;
        function vXn(c5) {
          var s = c5.findComponents({ mainType: "legend" });
          s && s.length && c5.filterSeries(function(r5) {
            for (var g5 = 0; g5 < s.length; g5++)
              if (!s[g5].isSelected(r5.name))
                return false;
            return true;
          });
        }
        function hft(c5, s, r5) {
          var g5 = {}, b6 = c5 === "toggleSelected", S2;
          return r5.eachComponent("legend", function(A2) {
            b6 && S2 != null ? A2[S2 ? "select" : "unSelect"](s.name) : c5 === "allSelect" || c5 === "inverseSelect" ? A2[c5]() : (A2[c5](s.name), S2 = A2.isSelected(s.name));
            var k2 = A2.getData();
            Ye2(k2, function(R6) {
              var B3 = R6.get("name");
              if (!(B3 === `
` || B3 === "")) {
                var G3 = A2.isSelected(B3);
                g5.hasOwnProperty(B3) ? g5[B3] = g5[B3] && G3 : g5[B3] = G3;
              }
            });
          }), c5 === "allSelect" || c5 === "inverseSelect" ? { selected: g5 } : { name: s.name, selected: g5 };
        }
        function yXn(c5) {
          c5.registerAction("legendToggleSelect", "legendselectchanged", Au(hft, "toggleSelected")), c5.registerAction("legendAllSelect", "legendselectall", Au(hft, "allSelect")), c5.registerAction("legendInverseSelect", "legendinverseselect", Au(hft, "inverseSelect")), c5.registerAction("legendSelect", "legendselected", Au(hft, "select")), c5.registerAction("legendUnSelect", "legendunselected", Au(hft, "unSelect"));
        }
        function FLe(c5) {
          c5.registerComponentModel(vqt), c5.registerComponentView(NLe), c5.registerProcessor(c5.PRIORITY.PROCESSOR.SERIES_FILTER, vXn), c5.registerSubTypeDefaulter("legend", function() {
            return "plain";
          }), yXn(c5);
        }
        var mXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.setScrollDataIndex = function(r5) {
            this.option.scrollDataIndex = r5;
          }, s.prototype.init = function(r5, g5, b6) {
            var S2 = oX(r5);
            c5.prototype.init.call(this, r5, g5, b6), VLe(this, r5, S2);
          }, s.prototype.mergeOption = function(r5, g5) {
            c5.prototype.mergeOption.call(this, r5, g5), VLe(this, this.option, r5);
          }, s.type = "legend.scroll", s.defaultOption = $8(vqt.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), s;
        }(vqt);
        function VLe(c5, s, r5) {
          var g5 = c5.getOrient(), b6 = [1, 1];
          b6[g5.index] = 0, Y8(s, r5, { type: "box", ignoreSize: !!b6 });
        }
        var bXn = mXn, BLe = nu, _qt = ["width", "height"], xqt = ["x", "y"], _Xn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.newlineDisabled = true, r5._currentIndex = 0, r5;
          }
          return s.prototype.init = function() {
            c5.prototype.init.call(this), this.group.add(this._containerGroup = new BLe()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new BLe());
          }, s.prototype.resetInner = function() {
            c5.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
          }, s.prototype.renderInner = function(r5, g5, b6, S2, A2, k2, R6) {
            var B3 = this;
            c5.prototype.renderInner.call(this, r5, g5, b6, S2, A2, k2, R6);
            var G3 = this._controllerGroup, Z3 = g5.get("pageIconSize", true), X3 = ja2(Z3) ? Z3 : [Z3, Z3];
            it("pagePrev", 0);
            var tt = g5.getModel("pageTextStyle");
            G3.add(new hh2({ name: "pageText", style: { text: "xx/xx", fill: tt.getTextColor(), font: tt.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), it("pageNext", 1);
            function it(pt, mt) {
              var Mt = pt + "DataIndex", kt = ph2(g5.get("pageIcons", true)[g5.getOrient().name][mt], { onclick: Cs(B3._pageGo, B3, Mt, g5, S2) }, { x: -X3[0] / 2, y: -X3[1] / 2, width: X3[0], height: X3[1] });
              kt.name = pt, G3.add(kt);
            }
          }, s.prototype.layoutInner = function(r5, g5, b6, S2, A2, k2) {
            var R6 = this.getSelectorGroup(), B3 = r5.getOrient().index, G3 = _qt[B3], Z3 = xqt[B3], X3 = _qt[1 - B3], tt = xqt[1 - B3];
            A2 && lW("horizontal", R6, r5.get("selectorItemGap", true));
            var it = r5.get("selectorButtonGap", true), pt = R6.getBoundingRect(), mt = [-pt.x, -pt.y], Mt = Ml(b6);
            A2 && (Mt[G3] = b6[G3] - pt[G3] - it);
            var kt = this._layoutContentAndController(r5, S2, Mt, B3, G3, X3, tt, Z3);
            if (A2) {
              if (k2 === "end")
                mt[B3] += kt[G3] + it;
              else {
                var Gt = pt[G3] + it;
                mt[B3] -= Gt, kt[Z3] -= Gt;
              }
              kt[G3] += pt[G3] + it, mt[1 - B3] += kt[tt] + kt[X3] / 2 - pt[X3] / 2, kt[X3] = Math.max(kt[X3], pt[X3]), kt[tt] = Math.min(kt[tt], pt[tt] + mt[1 - B3]), R6.x = mt[0], R6.y = mt[1], R6.markRedraw();
            }
            return kt;
          }, s.prototype._layoutContentAndController = function(r5, g5, b6, S2, A2, k2, R6, B3) {
            var G3 = this.getContentGroup(), Z3 = this._containerGroup, X3 = this._controllerGroup;
            lW(r5.get("orient"), G3, r5.get("itemGap"), S2 ? b6.width : null, S2 ? null : b6.height), lW("horizontal", X3, r5.get("pageButtonItemGap", true));
            var tt = G3.getBoundingRect(), it = X3.getBoundingRect(), pt = this._showController = tt[A2] > b6[A2], mt = [-tt.x, -tt.y];
            g5 || (mt[S2] = G3[B3]);
            var Mt = [0, 0], kt = [-it.x, -it.y], Gt = tc2(r5.get("pageButtonGap", true), r5.get("itemGap", true));
            if (pt) {
              var Ot = r5.get("pageButtonPosition", true);
              Ot === "end" ? kt[S2] += b6[A2] - it[A2] : Mt[S2] += it[A2] + Gt;
            }
            kt[1 - S2] += tt[k2] / 2 - it[k2] / 2, G3.setPosition(mt), Z3.setPosition(Mt), X3.setPosition(kt);
            var ce2 = { x: 0, y: 0 };
            if (ce2[A2] = pt ? b6[A2] : tt[A2], ce2[k2] = Math.max(tt[k2], it[k2]), ce2[R6] = Math.min(0, it[R6] + kt[1 - S2]), Z3.__rectSize = b6[A2], pt) {
              var ae2 = { x: 0, y: 0 };
              ae2[A2] = Math.max(b6[A2] - it[A2] - Gt, 0), ae2[k2] = ce2[k2], Z3.setClipPath(new zf2({ shape: ae2 })), Z3.__rectSize = ae2[A2];
            } else
              X3.eachChild(function(we2) {
                we2.attr({ invisible: true, silent: true });
              });
            var de2 = this._getPageInfo(r5);
            return de2.pageIndex != null && Qf2(G3, { x: de2.contentPosition[0], y: de2.contentPosition[1] }, pt ? r5 : null), this._updatePageInfoView(r5, de2), ce2;
          }, s.prototype._pageGo = function(r5, g5, b6) {
            var S2 = this._getPageInfo(g5)[r5];
            S2 != null && b6.dispatchAction({ type: "legendScroll", scrollDataIndex: S2, legendId: g5.id });
          }, s.prototype._updatePageInfoView = function(r5, g5) {
            var b6 = this._controllerGroup;
            Ye2(["pagePrev", "pageNext"], function(G3) {
              var Z3 = G3 + "DataIndex", X3 = g5[Z3] != null, tt = b6.childOfName(G3);
              tt && (tt.setStyle("fill", X3 ? r5.get("pageIconColor", true) : r5.get("pageIconInactiveColor", true)), tt.cursor = X3 ? "pointer" : "default");
            });
            var S2 = b6.childOfName("pageText"), A2 = r5.get("pageFormatter"), k2 = g5.pageIndex, R6 = k2 != null ? k2 + 1 : 0, B3 = g5.pageCount;
            S2 && A2 && S2.setStyle("text", gs(A2) ? A2.replace("{current}", R6 == null ? "" : R6 + "").replace("{total}", B3 == null ? "" : B3 + "") : A2({ current: R6, total: B3 }));
          }, s.prototype._getPageInfo = function(r5) {
            var g5 = r5.get("scrollDataIndex", true), b6 = this.getContentGroup(), S2 = this._containerGroup.__rectSize, A2 = r5.getOrient().index, k2 = _qt[A2], R6 = xqt[A2], B3 = this._findTargetItemIndex(g5), G3 = b6.children(), Z3 = G3[B3], X3 = G3.length, tt = X3 ? 1 : 0, it = { contentPosition: [b6.x, b6.y], pageCount: tt, pageIndex: tt - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
            if (!Z3)
              return it;
            var pt = Ot(Z3);
            it.contentPosition[A2] = -pt.s;
            for (var mt = B3 + 1, Mt = pt, kt = pt, Gt = null; mt <= X3; ++mt)
              Gt = Ot(G3[mt]), (!Gt && kt.e > Mt.s + S2 || Gt && !ce2(Gt, Mt.s)) && (kt.i > Mt.i ? Mt = kt : Mt = Gt, Mt && (it.pageNextDataIndex == null && (it.pageNextDataIndex = Mt.i), ++it.pageCount)), kt = Gt;
            for (var mt = B3 - 1, Mt = pt, kt = pt, Gt = null; mt >= -1; --mt)
              Gt = Ot(G3[mt]), (!Gt || !ce2(kt, Gt.s)) && Mt.i < kt.i && (kt = Mt, it.pagePrevDataIndex == null && (it.pagePrevDataIndex = Mt.i), ++it.pageCount, ++it.pageIndex), Mt = Gt;
            return it;
            function Ot(ae2) {
              if (ae2) {
                var de2 = ae2.getBoundingRect(), we2 = de2[R6] + ae2[R6];
                return { s: we2, e: we2 + de2[k2], i: ae2.__legendDataIndex };
              }
            }
            function ce2(ae2, de2) {
              return ae2.e >= de2 && ae2.s <= de2 + S2;
            }
          }, s.prototype._findTargetItemIndex = function(r5) {
            if (!this._showController)
              return 0;
            var g5, b6 = this.getContentGroup(), S2;
            return b6.eachChild(function(A2, k2) {
              var R6 = A2.__legendDataIndex;
              S2 == null && R6 != null && (S2 = k2), R6 === r5 && (g5 = k2);
            }), g5 != null ? g5 : S2;
          }, s.type = "legend.scroll", s;
        }(NLe), xXn = _Xn;
        function wXn(c5) {
          c5.registerAction("legendScroll", "legendscroll", function(s, r5) {
            var g5 = s.scrollDataIndex;
            g5 != null && r5.eachComponent({ mainType: "legend", subType: "scroll", query: s }, function(b6) {
              b6.setScrollDataIndex(g5);
            });
          });
        }
        function SXn(c5) {
          Fc2(FLe), c5.registerComponentModel(bXn), c5.registerComponentView(xXn), wXn(c5);
        }
        function MXn(c5) {
          Fc2(FLe), Fc2(SXn);
        }
        var CXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "dataZoom.inside", s.defaultOption = $8(sft.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), s;
        }(sft), TXn = CXn, wqt = Df2();
        function AXn(c5, s, r5) {
          wqt(c5).coordSysRecordMap.each(function(g5) {
            var b6 = g5.dataZoomInfoMap.get(s.uid);
            b6 && (b6.getRange = r5);
          });
        }
        function IXn(c5, s) {
          for (var r5 = wqt(c5).coordSysRecordMap, g5 = r5.keys(), b6 = 0; b6 < g5.length; b6++) {
            var S2 = g5[b6], A2 = r5.get(S2), k2 = A2.dataZoomInfoMap;
            if (k2) {
              var R6 = s.uid, B3 = k2.get(R6);
              B3 && (k2.removeKey(R6), k2.keys().length || zLe(r5, A2));
            }
          }
        }
        function zLe(c5, s) {
          if (s) {
            c5.removeKey(s.model.uid);
            var r5 = s.controller;
            r5 && r5.dispose();
          }
        }
        function DXn(c5, s) {
          var r5 = { model: s, containsPoint: Au(kXn, s), dispatchAction: Au(EXn, c5), dataZoomInfoMap: null, controller: null }, g5 = r5.controller = new Hct(c5.getZr());
          return Ye2(["pan", "zoom", "scrollMove"], function(b6) {
            g5.on(b6, function(S2) {
              var A2 = [];
              r5.dataZoomInfoMap.each(function(k2) {
                if (S2.isAvailableBehavior(k2.model.option)) {
                  var R6 = (k2.getRange || {})[b6], B3 = R6 && R6(k2.dzReferCoordSysInfo, r5.model.mainType, r5.controller, S2);
                  !k2.model.get("disabled", true) && B3 && A2.push({ dataZoomId: k2.model.id, start: B3[0], end: B3[1] });
                }
              }), A2.length && r5.dispatchAction(A2);
            });
          }), r5;
        }
        function EXn(c5, s) {
          c5.isDisposed() || c5.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: s });
        }
        function kXn(c5, s, r5, g5) {
          return c5.coordinateSystem.containPoint([r5, g5]);
        }
        function PXn(c5) {
          var s, r5 = "type_", g5 = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, b6 = true;
          return c5.each(function(S2) {
            var A2 = S2.model, k2 = A2.get("disabled", true) ? false : A2.get("zoomLock", true) ? "move" : true;
            g5[r5 + k2] > g5[r5 + s] && (s = k2), b6 = b6 && A2.get("preventDefaultMouseMove", true);
          }), { controlType: s, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!b6 } };
        }
        function LXn(c5) {
          c5.registerProcessor(c5.PRIORITY.PROCESSOR.FILTER, function(s, r5) {
            var g5 = wqt(r5), b6 = g5.coordSysRecordMap || (g5.coordSysRecordMap = Ps());
            b6.each(function(S2) {
              S2.dataZoomInfoMap = null;
            }), s.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(S2) {
              var A2 = N3e(S2);
              Ye2(A2.infoList, function(k2) {
                var R6 = k2.model.uid, B3 = b6.get(R6) || b6.set(R6, DXn(r5, k2.model)), G3 = B3.dataZoomInfoMap || (B3.dataZoomInfoMap = Ps());
                G3.set(S2.uid, { dzReferCoordSysInfo: k2, model: S2, getRange: null });
              });
            }), b6.each(function(S2) {
              var A2 = S2.controller, k2, R6 = S2.dataZoomInfoMap;
              if (R6) {
                var B3 = R6.keys()[0];
                B3 != null && (k2 = R6.get(B3));
              }
              if (!k2) {
                zLe(b6, S2);
                return;
              }
              var G3 = PXn(R6);
              A2.enable(G3.controlType, G3.opt), A2.setPointerChecker(S2.containsPoint), pX(S2, "dispatchAction", k2.model.get("throttle", true), "fixRate");
            });
          });
        }
        var OXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "dataZoom.inside", r5;
          }
          return s.prototype.render = function(r5, g5, b6) {
            if (c5.prototype.render.apply(this, arguments), r5.noTarget()) {
              this._clear();
              return;
            }
            this.range = r5.getPercentRange(), AXn(b6, r5, { pan: Cs(Sqt.pan, this), zoom: Cs(Sqt.zoom, this), scrollMove: Cs(Sqt.scrollMove, this) });
          }, s.prototype.dispose = function() {
            this._clear(), c5.prototype.dispose.apply(this, arguments);
          }, s.prototype._clear = function() {
            IXn(this.api, this.dataZoomModel), this.range = null;
          }, s.type = "dataZoom.inside", s;
        }(KUt), Sqt = { zoom: function(c5, s, r5, g5) {
          var b6 = this.range, S2 = b6.slice(), A2 = c5.axisModels[0];
          if (A2) {
            var k2 = Mqt[s](null, [g5.originX, g5.originY], A2, r5, c5), R6 = (k2.signal > 0 ? k2.pixelStart + k2.pixelLength - k2.pixel : k2.pixel - k2.pixelStart) / k2.pixelLength * (S2[1] - S2[0]) + S2[0], B3 = Math.max(1 / g5.scale, 0);
            S2[0] = (S2[0] - R6) * B3 + R6, S2[1] = (S2[1] - R6) * B3 + R6;
            var G3 = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
            if (DW(0, S2, [0, 100], 0, G3.minSpan, G3.maxSpan), this.range = S2, b6[0] !== S2[0] || b6[1] !== S2[1])
              return S2;
          }
        }, pan: jLe(function(c5, s, r5, g5, b6, S2) {
          var A2 = Mqt[g5]([S2.oldX, S2.oldY], [S2.newX, S2.newY], s, b6, r5);
          return A2.signal * (c5[1] - c5[0]) * A2.pixel / A2.pixelLength;
        }), scrollMove: jLe(function(c5, s, r5, g5, b6, S2) {
          var A2 = Mqt[g5]([0, 0], [S2.scrollDelta, S2.scrollDelta], s, b6, r5);
          return A2.signal * (c5[1] - c5[0]) * S2.scrollDelta;
        }) };
        function jLe(c5) {
          return function(s, r5, g5, b6) {
            var S2 = this.range, A2 = S2.slice(), k2 = s.axisModels[0];
            if (k2) {
              var R6 = c5(A2, k2, s, r5, g5, b6);
              if (DW(R6, A2, [0, 100], "all"), this.range = A2, S2[0] !== A2[0] || S2[1] !== A2[1])
                return A2;
            }
          };
        }
        var Mqt = { grid: function(c5, s, r5, g5, b6) {
          var S2 = r5.axis, A2 = {}, k2 = b6.model.coordinateSystem.getRect();
          return c5 = c5 || [0, 0], S2.dim === "x" ? (A2.pixel = s[0] - c5[0], A2.pixelLength = k2.width, A2.pixelStart = k2.x, A2.signal = S2.inverse ? 1 : -1) : (A2.pixel = s[1] - c5[1], A2.pixelLength = k2.height, A2.pixelStart = k2.y, A2.signal = S2.inverse ? -1 : 1), A2;
        }, polar: function(c5, s, r5, g5, b6) {
          var S2 = r5.axis, A2 = {}, k2 = b6.model.coordinateSystem, R6 = k2.getRadiusAxis().getExtent(), B3 = k2.getAngleAxis().getExtent();
          return c5 = c5 ? k2.pointToCoord(c5) : [0, 0], s = k2.pointToCoord(s), r5.mainType === "radiusAxis" ? (A2.pixel = s[0] - c5[0], A2.pixelLength = R6[1] - R6[0], A2.pixelStart = R6[0], A2.signal = S2.inverse ? 1 : -1) : (A2.pixel = s[1] - c5[1], A2.pixelLength = B3[1] - B3[0], A2.pixelStart = B3[0], A2.signal = S2.inverse ? -1 : 1), A2;
        }, singleAxis: function(c5, s, r5, g5, b6) {
          var S2 = r5.axis, A2 = b6.model.coordinateSystem.getRect(), k2 = {};
          return c5 = c5 || [0, 0], S2.orient === "horizontal" ? (k2.pixel = s[0] - c5[0], k2.pixelLength = A2.width, k2.pixelStart = A2.x, k2.signal = S2.inverse ? 1 : -1) : (k2.pixel = s[1] - c5[1], k2.pixelLength = A2.height, k2.pixelStart = A2.y, k2.signal = S2.inverse ? -1 : 1), k2;
        } }, RXn = OXn;
        function WLe(c5) {
          XUt(c5), c5.registerComponentModel(TXn), c5.registerComponentView(RXn), LXn(c5);
        }
        var NXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.type = "dataZoom.slider", s.layoutMode = "box", s.defaultOption = $8(sft.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), s;
        }(sft), FXn = NXn, pft = zf2, GLe = 7, VXn = 1, Cqt = 30, BXn = 7, dft = "horizontal", HLe = "vertical", zXn = 5, jXn = ["line", "bar", "candlestick", "scatter"], WXn = { easing: "cubicOut", duration: 100, delay: 0 }, GXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._displayables = {}, r5;
          }
          return s.prototype.init = function(r5, g5) {
            this.api = g5, this._onBrush = Cs(this._onBrush, this), this._onBrushEnd = Cs(this._onBrushEnd, this);
          }, s.prototype.render = function(r5, g5, b6, S2) {
            if (c5.prototype.render.apply(this, arguments), pX(this, "_dispatchZoomAction", r5.get("throttle"), "fixRate"), this._orient = r5.getOrient(), r5.get("show") === false) {
              this.group.removeAll();
              return;
            }
            if (r5.noTarget()) {
              this._clear(), this.group.removeAll();
              return;
            }
            (!S2 || S2.type !== "dataZoom" || S2.from !== this.uid) && this._buildView(), this._updateView();
          }, s.prototype.dispose = function() {
            this._clear(), c5.prototype.dispose.apply(this, arguments);
          }, s.prototype._clear = function() {
            hct(this, "_dispatchZoomAction");
            var r5 = this.api.getZr();
            r5.off("mousemove", this._onBrush), r5.off("mouseup", this._onBrushEnd);
          }, s.prototype._buildView = function() {
            var r5 = this.group;
            r5.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
            var g5 = this._displayables.sliderGroup = new nu();
            this._renderBackground(), this._renderHandle(), this._renderDataShadow(), r5.add(g5), this._positionGroup();
          }, s.prototype._resetLocation = function() {
            var r5 = this.dataZoomModel, g5 = this.api, b6 = r5.get("brushSelect"), S2 = b6 ? BXn : 0, A2 = this._findCoordRect(), k2 = { width: g5.getWidth(), height: g5.getHeight() }, R6 = this._orient === dft ? { right: k2.width - A2.x - A2.width, top: k2.height - Cqt - GLe - S2, width: A2.width, height: Cqt } : { right: GLe, top: A2.y, width: Cqt, height: A2.height }, B3 = oX(r5.option);
            Ye2(["right", "top", "width", "height"], function(Z3) {
              B3[Z3] === "ph" && (B3[Z3] = R6[Z3]);
            });
            var G3 = $m(B3, k2);
            this._location = { x: G3.x, y: G3.y }, this._size = [G3.width, G3.height], this._orient === HLe && this._size.reverse();
          }, s.prototype._positionGroup = function() {
            var r5 = this.group, g5 = this._location, b6 = this._orient, S2 = this.dataZoomModel.getFirstTargetAxisModel(), A2 = S2 && S2.get("inverse"), k2 = this._displayables.sliderGroup, R6 = (this._dataShadowInfo || {}).otherAxisInverse;
            k2.attr(b6 === dft && !A2 ? { scaleY: R6 ? 1 : -1, scaleX: 1 } : b6 === dft && A2 ? { scaleY: R6 ? 1 : -1, scaleX: -1 } : b6 === HLe && !A2 ? { scaleY: R6 ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: R6 ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
            var B3 = r5.getBoundingRect([k2]);
            r5.x = g5.x - B3.x, r5.y = g5.y - B3.y, r5.markRedraw();
          }, s.prototype._getViewExtent = function() {
            return [0, this._size[0]];
          }, s.prototype._renderBackground = function() {
            var r5 = this.dataZoomModel, g5 = this._size, b6 = this._displayables.sliderGroup, S2 = r5.get("brushSelect");
            b6.add(new pft({ silent: true, shape: { x: 0, y: 0, width: g5[0], height: g5[1] }, style: { fill: r5.get("backgroundColor") }, z2: -40 }));
            var A2 = new pft({ shape: { x: 0, y: 0, width: g5[0], height: g5[1] }, style: { fill: "transparent" }, z2: 0, onclick: Cs(this._onClickPanel, this) }), k2 = this.api.getZr();
            S2 ? (A2.on("mousedown", this._onBrushStart, this), A2.cursor = "crosshair", k2.on("mousemove", this._onBrush), k2.on("mouseup", this._onBrushEnd)) : (k2.off("mousemove", this._onBrush), k2.off("mouseup", this._onBrushEnd)), b6.add(A2);
          }, s.prototype._renderDataShadow = function() {
            var r5 = this._dataShadowInfo = this._prepareDataShadowInfo();
            if (this._displayables.dataShadowSegs = [], !r5)
              return;
            var g5 = this._size, b6 = this._shadowSize || [], S2 = r5.series, A2 = S2.getRawData(), k2 = S2.getShadowDim ? S2.getShadowDim() : r5.otherDim;
            if (k2 == null)
              return;
            var R6 = this._shadowPolygonPts, B3 = this._shadowPolylinePts;
            if (A2 !== this._shadowData || k2 !== this._shadowDim || g5[0] !== b6[0] || g5[1] !== b6[1]) {
              var G3 = A2.getDataExtent(k2), Z3 = (G3[1] - G3[0]) * 0.3;
              G3 = [G3[0] - Z3, G3[1] + Z3];
              var X3 = [0, g5[1]], tt = [0, g5[0]], it = [[g5[0], 0], [0, 0]], pt = [], mt = tt[1] / (A2.count() - 1), Mt = 0, kt = Math.round(A2.count() / g5[0]), Gt;
              A2.each([k2], function(we2, Se2) {
                if (kt > 0 && Se2 % kt) {
                  Mt += mt;
                  return;
                }
                var Oe2 = we2 == null || isNaN(we2) || we2 === "", je2 = Oe2 ? 0 : fh2(we2, G3, X3, true);
                Oe2 && !Gt && Se2 ? (it.push([it[it.length - 1][0], 0]), pt.push([pt[pt.length - 1][0], 0])) : !Oe2 && Gt && (it.push([Mt, 0]), pt.push([Mt, 0])), it.push([Mt, je2]), pt.push([Mt, je2]), Mt += mt, Gt = Oe2;
              }), R6 = this._shadowPolygonPts = it, B3 = this._shadowPolylinePts = pt;
            }
            this._shadowData = A2, this._shadowDim = k2, this._shadowSize = [g5[0], g5[1]];
            var Ot = this.dataZoomModel;
            function ce2(we2) {
              var Se2 = Ot.getModel(we2 ? "selectedDataBackground" : "dataBackground"), Oe2 = new nu(), je2 = new Gb2({ shape: { points: R6 }, segmentIgnoreThreshold: 1, style: Se2.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), rn = new Gw({ shape: { points: B3 }, segmentIgnoreThreshold: 1, style: Se2.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
              return Oe2.add(je2), Oe2.add(rn), Oe2;
            }
            for (var ae2 = 0; ae2 < 3; ae2++) {
              var de2 = ce2(ae2 === 1);
              this._displayables.sliderGroup.add(de2), this._displayables.dataShadowSegs.push(de2);
            }
          }, s.prototype._prepareDataShadowInfo = function() {
            var r5 = this.dataZoomModel, g5 = r5.get("showDataShadow");
            if (g5 !== false) {
              var b6, S2 = this.ecModel;
              return r5.eachTargetAxis(function(A2, k2) {
                var R6 = r5.getAxisProxy(A2, k2).getTargetSeriesModels();
                Ye2(R6, function(B3) {
                  if (!b6 && !(g5 !== true && Lu(jXn, B3.get("type")) < 0)) {
                    var G3 = S2.getComponent(f9(A2), k2).axis, Z3 = HXn(A2), X3, tt = B3.coordinateSystem;
                    Z3 != null && tt.getOtherAxis && (X3 = tt.getOtherAxis(G3).inverse), Z3 = B3.getData().mapDimension(Z3), b6 = { thisAxis: G3, series: B3, thisDim: A2, otherDim: Z3, otherAxisInverse: X3 };
                  }
                }, this);
              }, this), b6;
            }
          }, s.prototype._renderHandle = function() {
            var r5 = this.group, g5 = this._displayables, b6 = g5.handles = [null, null], S2 = g5.handleLabels = [null, null], A2 = this._displayables.sliderGroup, k2 = this._size, R6 = this.dataZoomModel, B3 = this.api, G3 = R6.get("borderRadius") || 0, Z3 = R6.get("brushSelect"), X3 = g5.filler = new pft({ silent: Z3, style: { fill: R6.get("fillerColor") }, textConfig: { position: "inside" } });
            A2.add(X3), A2.add(new pft({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: k2[0], height: k2[1], r: G3 }, style: { stroke: R6.get("dataBackgroundColor") || R6.get("borderColor"), lineWidth: VXn, fill: "rgba(0,0,0,0)" } })), Ye2([0, 1], function(Gt) {
              var Ot = R6.get("handleIcon");
              !pMt[Ot] && Ot.indexOf("path://") < 0 && Ot.indexOf("image://") < 0 && (Ot = "path://" + Ot);
              var ce2 = am(Ot, -1, 0, 2, 2, null, true);
              ce2.attr({ cursor: ULe(this._orient), draggable: true, drift: Cs(this._onDragMove, this, Gt), ondragend: Cs(this._onDragEnd, this), onmouseover: Cs(this._showDataInfo, this, true), onmouseout: Cs(this._showDataInfo, this, false), z2: 5 });
              var ae2 = ce2.getBoundingRect(), de2 = R6.get("handleSize");
              this._handleHeight = $o(de2, this._size[1]), this._handleWidth = ae2.width / ae2.height * this._handleHeight, ce2.setStyle(R6.getModel("handleStyle").getItemStyle()), ce2.style.strokeNoScale = true, ce2.rectHover = true, ce2.ensureState("emphasis").style = R6.getModel(["emphasis", "handleStyle"]).getItemStyle(), vR(ce2);
              var we2 = R6.get("handleColor");
              we2 != null && (ce2.style.fill = we2), A2.add(b6[Gt] = ce2);
              var Se2 = R6.getModel("textStyle");
              r5.add(S2[Gt] = new hh2({ silent: true, invisible: true, style: Ey(Se2, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: Se2.getTextColor(), font: Se2.getFont() }), z2: 10 }));
            }, this);
            var tt = X3;
            if (Z3) {
              var it = $o(R6.get("moveHandleSize"), k2[1]), pt = g5.moveHandle = new zf2({ style: R6.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: k2[1] - 0.5, height: it } }), mt = it * 0.8, Mt = g5.moveHandleIcon = am(R6.get("moveHandleIcon"), -mt / 2, -mt / 2, mt, mt, "#fff", true);
              Mt.silent = true, Mt.y = k2[1] + it / 2 - 0.5, pt.ensureState("emphasis").style = R6.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
              var kt = Math.min(k2[1] / 2, Math.max(it, 10));
              tt = g5.moveZone = new zf2({ invisible: true, shape: { y: k2[1] - kt, height: it + kt } }), tt.on("mouseover", function() {
                B3.enterEmphasis(pt);
              }).on("mouseout", function() {
                B3.leaveEmphasis(pt);
              }), A2.add(pt), A2.add(Mt), A2.add(tt);
            }
            tt.attr({ draggable: true, cursor: ULe(this._orient), drift: Cs(this._onDragMove, this, "all"), ondragstart: Cs(this._showDataInfo, this, true), ondragend: Cs(this._onDragEnd, this), onmouseover: Cs(this._showDataInfo, this, true), onmouseout: Cs(this._showDataInfo, this, false) });
          }, s.prototype._resetInterval = function() {
            var r5 = this._range = this.dataZoomModel.getPercentRange(), g5 = this._getViewExtent();
            this._handleEnds = [fh2(r5[0], [0, 100], g5, true), fh2(r5[1], [0, 100], g5, true)];
          }, s.prototype._updateInterval = function(r5, g5) {
            var b6 = this.dataZoomModel, S2 = this._handleEnds, A2 = this._getViewExtent(), k2 = b6.findRepresentativeAxisProxy().getMinMaxSpan(), R6 = [0, 100];
            DW(g5, S2, A2, b6.get("zoomLock") ? "all" : r5, k2.minSpan != null ? fh2(k2.minSpan, R6, A2, true) : null, k2.maxSpan != null ? fh2(k2.maxSpan, R6, A2, true) : null);
            var B3 = this._range, G3 = this._range = h2([fh2(S2[0], A2, R6, true), fh2(S2[1], A2, R6, true)]);
            return !B3 || B3[0] !== G3[0] || B3[1] !== G3[1];
          }, s.prototype._updateView = function(r5) {
            var g5 = this._displayables, b6 = this._handleEnds, S2 = h2(b6.slice()), A2 = this._size;
            Ye2([0, 1], function(tt) {
              var it = g5.handles[tt], pt = this._handleHeight;
              it.attr({ scaleX: pt / 2, scaleY: pt / 2, x: b6[tt] + (tt ? -1 : 1), y: A2[1] / 2 - pt / 2 });
            }, this), g5.filler.setShape({ x: S2[0], y: 0, width: S2[1] - S2[0], height: A2[1] });
            var k2 = { x: S2[0], width: S2[1] - S2[0] };
            g5.moveHandle && (g5.moveHandle.setShape(k2), g5.moveZone.setShape(k2), g5.moveZone.getBoundingRect(), g5.moveHandleIcon && g5.moveHandleIcon.attr("x", k2.x + k2.width / 2));
            for (var R6 = g5.dataShadowSegs, B3 = [0, S2[0], S2[1], A2[0]], G3 = 0; G3 < R6.length; G3++) {
              var Z3 = R6[G3], X3 = Z3.getClipPath();
              X3 || (X3 = new zf2(), Z3.setClipPath(X3)), X3.setShape({ x: B3[G3], y: 0, width: B3[G3 + 1] - B3[G3], height: A2[1] });
            }
            this._updateDataInfo(r5);
          }, s.prototype._updateDataInfo = function(r5) {
            var g5 = this.dataZoomModel, b6 = this._displayables, S2 = b6.handleLabels, A2 = this._orient, k2 = ["", ""];
            if (g5.get("showDetail")) {
              var R6 = g5.findRepresentativeAxisProxy();
              if (R6) {
                var B3 = R6.getAxisModel().axis, G3 = this._range, Z3 = r5 ? R6.calculateDataWindow({ start: G3[0], end: G3[1] }).valueWindow : R6.getDataValueWindow();
                k2 = [this._formatLabel(Z3[0], B3), this._formatLabel(Z3[1], B3)];
              }
            }
            var X3 = h2(this._handleEnds.slice());
            tt.call(this, 0), tt.call(this, 1);
            function tt(it) {
              var pt = vo(b6.handles[it].parent, this.group), mt = Ks(it === 0 ? "right" : "left", pt), Mt = this._handleWidth / 2 + zXn, kt = Lo([X3[it] + (it === 0 ? -Mt : Mt), this._size[1] / 2], pt);
              S2[it].setStyle({ x: kt[0], y: kt[1], verticalAlign: A2 === dft ? "middle" : mt, align: A2 === dft ? mt : "center", text: k2[it] });
            }
          }, s.prototype._formatLabel = function(r5, g5) {
            var b6 = this.dataZoomModel, S2 = b6.get("labelFormatter"), A2 = b6.get("labelPrecision");
            (A2 == null || A2 === "auto") && (A2 = g5.getPixelPrecision());
            var k2 = r5 == null || isNaN(r5) ? "" : g5.type === "category" || g5.type === "time" ? g5.scale.getLabel({ value: Math.round(r5) }) : r5.toFixed(Math.min(A2, 20));
            return Tl(S2) ? S2(r5, k2) : gs(S2) ? S2.replace("{value}", k2) : k2;
          }, s.prototype._showDataInfo = function(r5) {
            r5 = this._dragging || r5;
            var g5 = this._displayables, b6 = g5.handleLabels;
            b6[0].attr("invisible", !r5), b6[1].attr("invisible", !r5), g5.moveHandle && this.api[r5 ? "enterEmphasis" : "leaveEmphasis"](g5.moveHandle, 1);
          }, s.prototype._onDragMove = function(r5, g5, b6, S2) {
            this._dragging = true, OI(S2.event);
            var A2 = this._displayables.sliderGroup.getLocalTransform(), k2 = Lo([g5, b6], A2, true), R6 = this._updateInterval(r5, k2[0]), B3 = this.dataZoomModel.get("realtime");
            this._updateView(!B3), R6 && B3 && this._dispatchZoomAction(true);
          }, s.prototype._onDragEnd = function() {
            this._dragging = false, this._showDataInfo(false);
            var r5 = this.dataZoomModel.get("realtime");
            !r5 && this._dispatchZoomAction(false);
          }, s.prototype._onClickPanel = function(r5) {
            var g5 = this._size, b6 = this._displayables.sliderGroup.transformCoordToLocal(r5.offsetX, r5.offsetY);
            if (!(b6[0] < 0 || b6[0] > g5[0] || b6[1] < 0 || b6[1] > g5[1])) {
              var S2 = this._handleEnds, A2 = (S2[0] + S2[1]) / 2, k2 = this._updateInterval("all", b6[0] - A2);
              this._updateView(), k2 && this._dispatchZoomAction(false);
            }
          }, s.prototype._onBrushStart = function(r5) {
            var g5 = r5.offsetX, b6 = r5.offsetY;
            this._brushStart = new Bu(g5, b6), this._brushing = true, this._brushStartTime = +new Date();
          }, s.prototype._onBrushEnd = function(r5) {
            if (this._brushing) {
              var g5 = this._displayables.brushRect;
              if (this._brushing = false, !!g5) {
                g5.attr("ignore", true);
                var b6 = g5.shape, S2 = +new Date();
                if (!(S2 - this._brushStartTime < 200 && Math.abs(b6.width) < 5)) {
                  var A2 = this._getViewExtent(), k2 = [0, 100];
                  this._range = h2([fh2(b6.x, A2, k2, true), fh2(b6.x + b6.width, A2, k2, true)]), this._handleEnds = [b6.x, b6.x + b6.width], this._updateView(), this._dispatchZoomAction(false);
                }
              }
            }
          }, s.prototype._onBrush = function(r5) {
            this._brushing && (OI(r5.event), this._updateBrushRect(r5.offsetX, r5.offsetY));
          }, s.prototype._updateBrushRect = function(r5, g5) {
            var b6 = this._displayables, S2 = this.dataZoomModel, A2 = b6.brushRect;
            A2 || (A2 = b6.brushRect = new pft({ silent: true, style: S2.getModel("brushStyle").getItemStyle() }), b6.sliderGroup.add(A2)), A2.attr("ignore", false);
            var k2 = this._brushStart, R6 = this._displayables.sliderGroup, B3 = R6.transformCoordToLocal(r5, g5), G3 = R6.transformCoordToLocal(k2.x, k2.y), Z3 = this._size;
            B3[0] = Math.max(Math.min(Z3[0], B3[0]), 0), A2.setShape({ x: G3[0], y: 0, width: B3[0] - G3[0], height: Z3[1] });
          }, s.prototype._dispatchZoomAction = function(r5) {
            var g5 = this._range;
            this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: r5 ? WXn : null, start: g5[0], end: g5[1] });
          }, s.prototype._findCoordRect = function() {
            var r5, g5 = N3e(this.dataZoomModel).infoList;
            if (!r5 && g5.length) {
              var b6 = g5[0].model.coordinateSystem;
              r5 = b6.getRect && b6.getRect();
            }
            if (!r5) {
              var S2 = this.api.getWidth(), A2 = this.api.getHeight();
              r5 = { x: S2 * 0.2, y: A2 * 0.2, width: S2 * 0.6, height: A2 * 0.6 };
            }
            return r5;
          }, s.type = "dataZoom.slider", s;
        }(KUt);
        function HXn(c5) {
          var s = { x: "y", y: "x", radius: "angle", angle: "radius" };
          return s[c5];
        }
        function ULe(c5) {
          return c5 === "vertical" ? "ns-resize" : "ew-resize";
        }
        var UXn = GXn;
        function qLe(c5) {
          c5.registerComponentModel(FXn), c5.registerComponentView(UXn), XUt(c5);
        }
        function qXn(c5) {
          Fc2(WLe), Fc2(qLe);
        }
        var ZXn = { get: function(c5, s, r5) {
          var g5 = Ml(($Xn[c5] || {})[s]);
          return r5 && ja2(g5) ? g5[g5.length - 1] : g5;
        } }, $Xn = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, ZLe = ZXn, $Le = Sx.mapVisual, YXn = Sx.eachVisual, KXn = ja2, YLe = Ye2, XXn = h2, QXn = fh2, JXn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.stateList = ["inRange", "outOfRange"], r5.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], r5.layoutMode = { type: "box", ignoreSize: true }, r5.dataBound = [-1 / 0, 1 / 0], r5.targetVisuals = {}, r5.controllerVisuals = {}, r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            this.mergeDefaultAndTheme(r5, b6);
          }, s.prototype.optionUpdated = function(r5, g5) {
            var b6 = this.option;
            !g5 && hLe(b6, r5, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
          }, s.prototype.resetVisual = function(r5) {
            var g5 = this.stateList;
            r5 = Cs(r5, this), this.controllerVisuals = oqt(this.option.controller, g5, r5), this.targetVisuals = oqt(this.option.target, g5, r5);
          }, s.prototype.getItemSymbol = function() {
            return null;
          }, s.prototype.getTargetSeriesIndices = function() {
            var r5 = this.option.seriesIndex, g5 = [];
            return r5 == null || r5 === "all" ? this.ecModel.eachSeries(function(b6, S2) {
              g5.push(S2);
            }) : g5 = xp(r5), g5;
          }, s.prototype.eachTargetSeries = function(r5, g5) {
            Ye2(this.getTargetSeriesIndices(), function(b6) {
              var S2 = this.ecModel.getSeriesByIndex(b6);
              S2 && r5.call(g5, S2);
            }, this);
          }, s.prototype.isTargetSeries = function(r5) {
            var g5 = false;
            return this.eachTargetSeries(function(b6) {
              b6 === r5 && (g5 = true);
            }), g5;
          }, s.prototype.formatValueText = function(r5, g5, b6) {
            var S2 = this.option, A2 = S2.precision, k2 = this.dataBound, R6 = S2.formatter, B3;
            b6 = b6 || ["<", ">"], ja2(r5) && (r5 = r5.slice(), B3 = true);
            var G3 = g5 ? r5 : B3 ? [Z3(r5[0]), Z3(r5[1])] : Z3(r5);
            if (gs(R6))
              return R6.replace("{value}", B3 ? G3[0] : G3).replace("{value2}", B3 ? G3[1] : G3);
            if (Tl(R6))
              return B3 ? R6(r5[0], r5[1]) : R6(r5);
            if (B3)
              return r5[0] === k2[0] ? b6[0] + " " + G3[1] : r5[1] === k2[1] ? b6[1] + " " + G3[0] : G3[0] + " - " + G3[1];
            return G3;
            function Z3(X3) {
              return X3 === k2[0] ? "min" : X3 === k2[1] ? "max" : (+X3).toFixed(Math.min(A2, 20));
            }
          }, s.prototype.resetExtent = function() {
            var r5 = this.option, g5 = XXn([r5.min, r5.max]);
            this._dataExtent = g5;
          }, s.prototype.getDataDimensionIndex = function(r5) {
            var g5 = this.option.dimension;
            if (g5 != null)
              return r5.getDimensionIndex(g5);
            for (var b6 = r5.dimensions, S2 = b6.length - 1; S2 >= 0; S2--) {
              var A2 = b6[S2], k2 = r5.getDimensionInfo(A2);
              if (!k2.isCalculationCoord)
                return k2.storeDimIndex;
            }
          }, s.prototype.getExtent = function() {
            return this._dataExtent.slice();
          }, s.prototype.completeVisualOption = function() {
            var r5 = this.ecModel, g5 = this.option, b6 = { inRange: g5.inRange, outOfRange: g5.outOfRange }, S2 = g5.target || (g5.target = {}), A2 = g5.controller || (g5.controller = {});
            bu(S2, b6), bu(A2, b6);
            var k2 = this.isCategory();
            R6.call(this, S2), R6.call(this, A2), B3.call(this, S2, "inRange", "outOfRange"), G3.call(this, A2);
            function R6(Z3) {
              KXn(g5.color) && !Z3.inRange && (Z3.inRange = { color: g5.color.slice().reverse() }), Z3.inRange = Z3.inRange || { color: r5.get("gradientColor") };
            }
            function B3(Z3, X3, tt) {
              var it = Z3[X3], pt = Z3[tt];
              it && !pt && (pt = Z3[tt] = {}, YLe(it, function(mt, Mt) {
                if (Sx.isValidType(Mt)) {
                  var kt = ZLe.get(Mt, "inactive", k2);
                  kt != null && (pt[Mt] = kt, Mt === "color" && !pt.hasOwnProperty("opacity") && !pt.hasOwnProperty("colorAlpha") && (pt.opacity = [0, 0]));
                }
              }));
            }
            function G3(Z3) {
              var X3 = (Z3.inRange || {}).symbol || (Z3.outOfRange || {}).symbol, tt = (Z3.inRange || {}).symbolSize || (Z3.outOfRange || {}).symbolSize, it = this.get("inactiveColor"), pt = this.getItemSymbol(), mt = pt || "roundRect";
              YLe(this.stateList, function(Mt) {
                var kt = this.itemSize, Gt = Z3[Mt];
                Gt || (Gt = Z3[Mt] = { color: k2 ? it : [it] }), Gt.symbol == null && (Gt.symbol = X3 && Ml(X3) || (k2 ? mt : [mt])), Gt.symbolSize == null && (Gt.symbolSize = tt && Ml(tt) || (k2 ? kt[0] : [kt[0], kt[0]])), Gt.symbol = $Le(Gt.symbol, function(ae2) {
                  return ae2 === "none" ? mt : ae2;
                });
                var Ot = Gt.symbolSize;
                if (Ot != null) {
                  var ce2 = -1 / 0;
                  YXn(Ot, function(ae2) {
                    ae2 > ce2 && (ce2 = ae2);
                  }), Gt.symbolSize = $Le(Ot, function(ae2) {
                    return QXn(ae2, [0, ce2], [0, kt[0]], true);
                  });
                }
              }, this);
            }
          }, s.prototype.resetItemSize = function() {
            this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
          }, s.prototype.isCategory = function() {
            return !!this.option.categories;
          }, s.prototype.setSelected = function(r5) {
          }, s.prototype.getSelected = function() {
            return null;
          }, s.prototype.getValueState = function(r5) {
            return null;
          }, s.prototype.getVisualMeta = function(r5) {
            return null;
          }, s.type = "visualMap", s.dependencies = ["series"], s.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, s;
        }(Rh2), NCt = JXn, KLe = [20, 140], tQn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.optionUpdated = function(r5, g5) {
            c5.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(b6) {
              b6.mappingMethod = "linear", b6.dataExtent = this.getExtent();
            }), this._resetRange();
          }, s.prototype.resetItemSize = function() {
            c5.prototype.resetItemSize.apply(this, arguments);
            var r5 = this.itemSize;
            (r5[0] == null || isNaN(r5[0])) && (r5[0] = KLe[0]), (r5[1] == null || isNaN(r5[1])) && (r5[1] = KLe[1]);
          }, s.prototype._resetRange = function() {
            var r5 = this.getExtent(), g5 = this.option.range;
            !g5 || g5.auto ? (r5.auto = 1, this.option.range = r5) : ja2(g5) && (g5[0] > g5[1] && g5.reverse(), g5[0] = Math.max(g5[0], r5[0]), g5[1] = Math.min(g5[1], r5[1]));
          }, s.prototype.completeVisualOption = function() {
            c5.prototype.completeVisualOption.apply(this, arguments), Ye2(this.stateList, function(r5) {
              var g5 = this.option.controller[r5].symbolSize;
              g5 && g5[0] !== g5[1] && (g5[0] = g5[1] / 3);
            }, this);
          }, s.prototype.setSelected = function(r5) {
            this.option.range = r5.slice(), this._resetRange();
          }, s.prototype.getSelected = function() {
            var r5 = this.getExtent(), g5 = h2((this.get("range") || []).slice());
            return g5[0] > r5[1] && (g5[0] = r5[1]), g5[1] > r5[1] && (g5[1] = r5[1]), g5[0] < r5[0] && (g5[0] = r5[0]), g5[1] < r5[0] && (g5[1] = r5[0]), g5;
          }, s.prototype.getValueState = function(r5) {
            var g5 = this.option.range, b6 = this.getExtent();
            return (g5[0] <= b6[0] || g5[0] <= r5) && (g5[1] >= b6[1] || r5 <= g5[1]) ? "inRange" : "outOfRange";
          }, s.prototype.findTargetDataIndices = function(r5) {
            var g5 = [];
            return this.eachTargetSeries(function(b6) {
              var S2 = [], A2 = b6.getData();
              A2.each(this.getDataDimensionIndex(A2), function(k2, R6) {
                r5[0] <= k2 && k2 <= r5[1] && S2.push(R6);
              }, this), g5.push({ seriesId: b6.id, dataIndex: S2 });
            }, this), g5;
          }, s.prototype.getVisualMeta = function(r5) {
            var g5 = XLe(this, "outOfRange", this.getExtent()), b6 = XLe(this, "inRange", this.option.range.slice()), S2 = [];
            function A2(tt, it) {
              S2.push({ value: tt, color: r5(tt, it) });
            }
            for (var k2 = 0, R6 = 0, B3 = b6.length, G3 = g5.length; R6 < G3 && (!b6.length || g5[R6] <= b6[0]); R6++)
              g5[R6] < b6[k2] && A2(g5[R6], "outOfRange");
            for (var Z3 = 1; k2 < B3; k2++, Z3 = 0)
              Z3 && S2.length && A2(b6[k2], "outOfRange"), A2(b6[k2], "inRange");
            for (var Z3 = 1; R6 < G3; R6++)
              (!b6.length || b6[b6.length - 1] < g5[R6]) && (Z3 && (S2.length && A2(S2[S2.length - 1].value, "outOfRange"), Z3 = 0), A2(g5[R6], "outOfRange"));
            var X3 = S2.length;
            return { stops: S2, outerColors: [X3 ? S2[0].color : "transparent", X3 ? S2[X3 - 1].color : "transparent"] };
          }, s.type = "visualMap.continuous", s.defaultOption = $8(NCt.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), s;
        }(NCt);
        function XLe(c5, s, r5) {
          if (r5[0] === r5[1])
            return r5.slice();
          for (var g5 = 200, b6 = (r5[1] - r5[0]) / g5, S2 = r5[0], A2 = [], k2 = 0; k2 <= g5 && S2 < r5[1]; k2++)
            A2.push(S2), S2 += b6;
          return A2.push(r5[1]), A2;
        }
        var eQn = tQn, nQn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, r5;
          }
          return s.prototype.init = function(r5, g5) {
            this.ecModel = r5, this.api = g5;
          }, s.prototype.render = function(r5, g5, b6, S2) {
            if (this.visualMapModel = r5, r5.get("show") === false) {
              this.group.removeAll();
              return;
            }
            this.doRender(r5, g5, b6, S2);
          }, s.prototype.renderBackground = function(r5) {
            var g5 = this.visualMapModel, b6 = aX(g5.get("padding") || 0), S2 = r5.getBoundingRect();
            r5.add(new zf2({ z2: -1, silent: true, shape: { x: S2.x - b6[3], y: S2.y - b6[0], width: S2.width + b6[3] + b6[1], height: S2.height + b6[0] + b6[2] }, style: { fill: g5.get("backgroundColor"), stroke: g5.get("borderColor"), lineWidth: g5.get("borderWidth") } }));
          }, s.prototype.getControllerVisual = function(r5, g5, b6) {
            b6 = b6 || {};
            var S2 = b6.forceState, A2 = this.visualMapModel, k2 = {};
            if (g5 === "color") {
              var R6 = A2.get("contentColor");
              k2.color = R6;
            }
            function B3(tt) {
              return k2[tt];
            }
            function G3(tt, it) {
              k2[tt] = it;
            }
            var Z3 = A2.controllerVisuals[S2 || A2.getValueState(r5)], X3 = Sx.prepareVisualTypes(Z3);
            return Ye2(X3, function(tt) {
              var it = Z3[tt];
              b6.convertOpacityToAlpha && tt === "opacity" && (tt = "colorAlpha", it = Z3.__alphaForOpacity), Sx.dependsOn(tt, g5) && it && it.applyVisual(r5, B3, G3);
            }), k2[g5];
          }, s.prototype.positionGroup = function(r5) {
            var g5 = this.visualMapModel, b6 = this.api;
            eMt(r5, g5.getBoxLayoutParams(), { width: b6.getWidth(), height: b6.getHeight() });
          }, s.prototype.doRender = function(r5, g5, b6, S2) {
          }, s.type = "visualMap", s;
        }(P0), QLe = nQn, JLe = [["left", "right", "width"], ["top", "bottom", "height"]];
        function tOe(c5, s, r5) {
          var g5 = c5.option, b6 = g5.align;
          if (b6 != null && b6 !== "auto")
            return b6;
          for (var S2 = { width: s.getWidth(), height: s.getHeight() }, A2 = g5.orient === "horizontal" ? 1 : 0, k2 = JLe[A2], R6 = [0, null, 10], B3 = {}, G3 = 0; G3 < 3; G3++)
            B3[JLe[1 - A2][G3]] = R6[G3], B3[k2[G3]] = G3 === 2 ? r5[0] : g5[k2[G3]];
          var Z3 = [["x", "width", 3], ["y", "height", 0]][A2], X3 = $m(B3, S2, g5.padding);
          return k2[(X3.margin[Z3[2]] || 0) + X3[Z3[0]] + X3[Z3[1]] * 0.5 < S2[Z3[1]] * 0.5 ? 0 : 1];
        }
        function FCt(c5, s) {
          return Ye2(c5 || [], function(r5) {
            r5.dataIndex != null && (r5.dataIndexInside = r5.dataIndex, r5.dataIndex = null), r5.highlightKey = "visualMap" + (s ? s.componentIndex : "");
          }), c5;
        }
        var N32 = fh2, rQn = Ye2, eOe = Math.min, Tqt = Math.max, iQn = 12, aQn = 6, oQn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._shapes = {}, r5._dataInterval = [], r5._handleEnds = [], r5._hoverLinkDataIndices = [], r5;
          }
          return s.prototype.doRender = function(r5, g5, b6, S2) {
            this._api = b6, (!S2 || S2.type !== "selectDataRange" || S2.from !== this.uid) && this._buildView();
          }, s.prototype._buildView = function() {
            this.group.removeAll();
            var r5 = this.visualMapModel, g5 = this.group;
            this._orient = r5.get("orient"), this._useHandle = r5.get("calculable"), this._resetInterval(), this._renderBar(g5);
            var b6 = r5.get("text");
            this._renderEndsText(g5, b6, 0), this._renderEndsText(g5, b6, 1), this._updateView(true), this.renderBackground(g5), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(g5);
          }, s.prototype._renderEndsText = function(r5, g5, b6) {
            if (g5) {
              var S2 = g5[1 - b6];
              S2 = S2 != null ? S2 + "" : "";
              var A2 = this.visualMapModel, k2 = A2.get("textGap"), R6 = A2.itemSize, B3 = this._shapes.mainGroup, G3 = this._applyTransform([R6[0] / 2, b6 === 0 ? -k2 : R6[1] + k2], B3), Z3 = this._applyTransform(b6 === 0 ? "bottom" : "top", B3), X3 = this._orient, tt = this.visualMapModel.textStyleModel;
              this.group.add(new hh2({ style: { x: G3[0], y: G3[1], verticalAlign: X3 === "horizontal" ? "middle" : Z3, align: X3 === "horizontal" ? Z3 : "center", text: S2, font: tt.getFont(), fill: tt.getTextColor() } }));
            }
          }, s.prototype._renderBar = function(r5) {
            var g5 = this.visualMapModel, b6 = this._shapes, S2 = g5.itemSize, A2 = this._orient, k2 = this._useHandle, R6 = tOe(g5, this.api, S2), B3 = b6.mainGroup = this._createBarGroup(R6), G3 = new nu();
            B3.add(G3), G3.add(b6.outOfRange = nOe()), G3.add(b6.inRange = nOe(null, k2 ? iOe(this._orient) : null, Cs(this._dragHandle, this, "all", false), Cs(this._dragHandle, this, "all", true))), G3.setClipPath(new zf2({ shape: { x: 0, y: 0, width: S2[0], height: S2[1], r: 3 } }));
            var Z3 = g5.textStyleModel.getTextRect("\u56FD"), X3 = Tqt(Z3.width, Z3.height);
            k2 && (b6.handleThumbs = [], b6.handleLabels = [], b6.handleLabelPoints = [], this._createHandle(g5, B3, 0, S2, X3, A2), this._createHandle(g5, B3, 1, S2, X3, A2)), this._createIndicator(g5, B3, S2, X3, A2), r5.add(B3);
          }, s.prototype._createHandle = function(r5, g5, b6, S2, A2, k2) {
            var R6 = Cs(this._dragHandle, this, b6, false), B3 = Cs(this._dragHandle, this, b6, true), G3 = f22(r5.get("handleSize"), S2[0]), Z3 = am(r5.get("handleIcon"), -G3 / 2, -G3 / 2, G3, G3, null, true), X3 = iOe(this._orient);
            Z3.attr({ cursor: X3, draggable: true, drift: R6, ondragend: B3, onmousemove: function(Mt) {
              OI(Mt.event);
            } }), Z3.x = S2[0] / 2, Z3.useStyle(r5.getModel("handleStyle").getItemStyle()), Z3.setStyle({ strokeNoScale: true, strokeFirst: true }), Z3.style.lineWidth *= 2, Z3.ensureState("emphasis").style = r5.getModel(["emphasis", "handleStyle"]).getItemStyle(), yR(Z3, true), g5.add(Z3);
            var tt = this.visualMapModel.textStyleModel, it = new hh2({ cursor: X3, draggable: true, drift: R6, onmousemove: function(Mt) {
              OI(Mt.event);
            }, ondragend: B3, style: { x: 0, y: 0, text: "", font: tt.getFont(), fill: tt.getTextColor() } });
            it.ensureState("blur").style = { opacity: 0.1 }, it.stateTransition = { duration: 200 }, this.group.add(it);
            var pt = [G3, 0], mt = this._shapes;
            mt.handleThumbs[b6] = Z3, mt.handleLabelPoints[b6] = pt, mt.handleLabels[b6] = it;
          }, s.prototype._createIndicator = function(r5, g5, b6, S2, A2) {
            var k2 = f22(r5.get("indicatorSize"), b6[0]), R6 = am(r5.get("indicatorIcon"), -k2 / 2, -k2 / 2, k2, k2, null, true);
            R6.attr({ cursor: "move", invisible: true, silent: true, x: b6[0] / 2 });
            var B3 = r5.getModel("indicatorStyle").getItemStyle();
            if (R6 instanceof qm) {
              var G3 = R6.style;
              R6.useStyle(sa2({ image: G3.image, x: G3.x, y: G3.y, width: G3.width, height: G3.height }, B3));
            } else
              R6.useStyle(B3);
            g5.add(R6);
            var Z3 = this.visualMapModel.textStyleModel, X3 = new hh2({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: Z3.getFont(), fill: Z3.getTextColor() } });
            this.group.add(X3);
            var tt = [(A2 === "horizontal" ? S2 / 2 : aQn) + b6[0] / 2, 0], it = this._shapes;
            it.indicator = R6, it.indicatorLabel = X3, it.indicatorLabelPoint = tt, this._firstShowIndicator = true;
          }, s.prototype._dragHandle = function(r5, g5, b6, S2) {
            if (this._useHandle) {
              if (this._dragging = !g5, !g5) {
                var A2 = this._applyTransform([b6, S2], this._shapes.mainGroup, true);
                this._updateInterval(r5, A2[1]), this._hideIndicator(), this._updateView();
              }
              g5 === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), g5 ? !this._hovering && this._clearHoverLinkToSeries() : rOe(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[r5], false);
            }
          }, s.prototype._resetInterval = function() {
            var r5 = this.visualMapModel, g5 = this._dataInterval = r5.getSelected(), b6 = r5.getExtent(), S2 = [0, r5.itemSize[1]];
            this._handleEnds = [N32(g5[0], b6, S2, true), N32(g5[1], b6, S2, true)];
          }, s.prototype._updateInterval = function(r5, g5) {
            g5 = g5 || 0;
            var b6 = this.visualMapModel, S2 = this._handleEnds, A2 = [0, b6.itemSize[1]];
            DW(g5, S2, A2, r5, 0);
            var k2 = b6.getExtent();
            this._dataInterval = [N32(S2[0], A2, k2, true), N32(S2[1], A2, k2, true)];
          }, s.prototype._updateView = function(r5) {
            var g5 = this.visualMapModel, b6 = g5.getExtent(), S2 = this._shapes, A2 = [0, g5.itemSize[1]], k2 = r5 ? A2 : this._handleEnds, R6 = this._createBarVisual(this._dataInterval, b6, k2, "inRange"), B3 = this._createBarVisual(b6, b6, A2, "outOfRange");
            S2.inRange.setStyle({ fill: R6.barColor }).setShape("points", R6.barPoints), S2.outOfRange.setStyle({ fill: B3.barColor }).setShape("points", B3.barPoints), this._updateHandle(k2, R6);
          }, s.prototype._createBarVisual = function(r5, g5, b6, S2) {
            var A2 = { forceState: S2, convertOpacityToAlpha: true }, k2 = this._makeColorGradient(r5, A2), R6 = [this.getControllerVisual(r5[0], "symbolSize", A2), this.getControllerVisual(r5[1], "symbolSize", A2)], B3 = this._createBarPoints(b6, R6);
            return { barColor: new nW(0, 0, 0, 1, k2), barPoints: B3, handlesColor: [k2[0].color, k2[k2.length - 1].color] };
          }, s.prototype._makeColorGradient = function(r5, g5) {
            var b6 = 100, S2 = [], A2 = (r5[1] - r5[0]) / b6;
            S2.push({ color: this.getControllerVisual(r5[0], "color", g5), offset: 0 });
            for (var k2 = 1; k2 < b6; k2++) {
              var R6 = r5[0] + A2 * k2;
              if (R6 > r5[1])
                break;
              S2.push({ color: this.getControllerVisual(R6, "color", g5), offset: k2 / b6 });
            }
            return S2.push({ color: this.getControllerVisual(r5[1], "color", g5), offset: 1 }), S2;
          }, s.prototype._createBarPoints = function(r5, g5) {
            var b6 = this.visualMapModel.itemSize;
            return [[b6[0] - g5[0], r5[0]], [b6[0], r5[0]], [b6[0], r5[1]], [b6[0] - g5[1], r5[1]]];
          }, s.prototype._createBarGroup = function(r5) {
            var g5 = this._orient, b6 = this.visualMapModel.get("inverse");
            return new nu(g5 === "horizontal" && !b6 ? { scaleX: r5 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : g5 === "horizontal" && b6 ? { scaleX: r5 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : g5 === "vertical" && !b6 ? { scaleX: r5 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: r5 === "left" ? 1 : -1 });
          }, s.prototype._updateHandle = function(r5, g5) {
            if (this._useHandle) {
              var b6 = this._shapes, S2 = this.visualMapModel, A2 = b6.handleThumbs, k2 = b6.handleLabels, R6 = S2.itemSize, B3 = S2.getExtent();
              rQn([0, 1], function(G3) {
                var Z3 = A2[G3];
                Z3.setStyle("fill", g5.handlesColor[G3]), Z3.y = r5[G3];
                var X3 = N32(r5[G3], [0, R6[1]], B3, true), tt = this.getControllerVisual(X3, "symbolSize");
                Z3.scaleX = Z3.scaleY = tt / R6[0], Z3.x = R6[0] - tt / 2;
                var it = Lo(b6.handleLabelPoints[G3], vo(Z3, this.group));
                k2[G3].setStyle({ x: it[0], y: it[1], text: S2.formatValueText(this._dataInterval[G3]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", b6.mainGroup) : "center" });
              }, this);
            }
          }, s.prototype._showIndicator = function(r5, g5, b6, S2) {
            var A2 = this.visualMapModel, k2 = A2.getExtent(), R6 = A2.itemSize, B3 = [0, R6[1]], G3 = this._shapes, Z3 = G3.indicator;
            if (Z3) {
              Z3.attr("invisible", false);
              var X3 = { convertOpacityToAlpha: true }, tt = this.getControllerVisual(r5, "color", X3), it = this.getControllerVisual(r5, "symbolSize"), pt = N32(r5, k2, B3, true), mt = R6[0] - it / 2, Mt = { x: Z3.x, y: Z3.y };
              Z3.y = pt, Z3.x = mt;
              var kt = Lo(G3.indicatorLabelPoint, vo(Z3, this.group)), Gt = G3.indicatorLabel;
              Gt.attr("invisible", false);
              var Ot = this._applyTransform("left", G3.mainGroup), ce2 = this._orient, ae2 = ce2 === "horizontal";
              Gt.setStyle({ text: (b6 || "") + A2.formatValueText(g5), verticalAlign: ae2 ? Ot : "middle", align: ae2 ? "center" : Ot });
              var de2 = { x: mt, y: pt, style: { fill: tt } }, we2 = { style: { x: kt[0], y: kt[1] } };
              if (A2.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
                var Se2 = { duration: 100, easing: "cubicInOut", additive: true };
                Z3.x = Mt.x, Z3.y = Mt.y, Z3.animateTo(de2, Se2), Gt.animateTo(we2, Se2);
              } else
                Z3.attr(de2), Gt.attr(we2);
              this._firstShowIndicator = false;
              var Oe2 = this._shapes.handleLabels;
              if (Oe2)
                for (var je2 = 0; je2 < Oe2.length; je2++)
                  this._api.enterBlur(Oe2[je2]);
            }
          }, s.prototype._enableHoverLinkToSeries = function() {
            var r5 = this;
            this._shapes.mainGroup.on("mousemove", function(g5) {
              if (r5._hovering = true, !r5._dragging) {
                var b6 = r5.visualMapModel.itemSize, S2 = r5._applyTransform([g5.offsetX, g5.offsetY], r5._shapes.mainGroup, true, true);
                S2[1] = eOe(Tqt(0, S2[1]), b6[1]), r5._doHoverLinkToSeries(S2[1], 0 <= S2[0] && S2[0] <= b6[0]);
              }
            }).on("mouseout", function() {
              r5._hovering = false, !r5._dragging && r5._clearHoverLinkToSeries();
            });
          }, s.prototype._enableHoverLinkFromSeries = function() {
            var r5 = this.api.getZr();
            this.visualMapModel.option.hoverLink ? (r5.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), r5.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
          }, s.prototype._doHoverLinkToSeries = function(r5, g5) {
            var b6 = this.visualMapModel, S2 = b6.itemSize;
            if (b6.option.hoverLink) {
              var A2 = [0, S2[1]], k2 = b6.getExtent();
              r5 = eOe(Tqt(A2[0], r5), A2[1]);
              var R6 = sQn(b6, k2, A2), B3 = [r5 - R6, r5 + R6], G3 = N32(r5, A2, k2, true), Z3 = [N32(B3[0], A2, k2, true), N32(B3[1], A2, k2, true)];
              B3[0] < A2[0] && (Z3[0] = -1 / 0), B3[1] > A2[1] && (Z3[1] = 1 / 0), g5 && (Z3[0] === -1 / 0 ? this._showIndicator(G3, Z3[1], "< ", R6) : Z3[1] === 1 / 0 ? this._showIndicator(G3, Z3[0], "> ", R6) : this._showIndicator(G3, G3, "\u2248 ", R6));
              var X3 = this._hoverLinkDataIndices, tt = [];
              (g5 || rOe(b6)) && (tt = this._hoverLinkDataIndices = b6.findTargetDataIndices(Z3));
              var it = Qlt(X3, tt);
              this._dispatchHighDown("downplay", FCt(it[0], b6)), this._dispatchHighDown("highlight", FCt(it[1], b6));
            }
          }, s.prototype._hoverLinkFromSeriesMouseOver = function(r5) {
            var g5 = r5.target, b6 = this.visualMapModel;
            if (!(!g5 || Pl(g5).dataIndex == null)) {
              var S2 = Pl(g5), A2 = this.ecModel.getSeriesByIndex(S2.seriesIndex);
              if (b6.isTargetSeries(A2)) {
                var k2 = A2.getData(S2.dataType), R6 = k2.getStore().get(b6.getDataDimensionIndex(k2), S2.dataIndex);
                isNaN(R6) || this._showIndicator(R6, R6);
              }
            }
          }, s.prototype._hideIndicator = function() {
            var r5 = this._shapes;
            r5.indicator && r5.indicator.attr("invisible", true), r5.indicatorLabel && r5.indicatorLabel.attr("invisible", true);
            var g5 = this._shapes.handleLabels;
            if (g5)
              for (var b6 = 0; b6 < g5.length; b6++)
                this._api.leaveBlur(g5[b6]);
          }, s.prototype._clearHoverLinkToSeries = function() {
            this._hideIndicator();
            var r5 = this._hoverLinkDataIndices;
            this._dispatchHighDown("downplay", FCt(r5, this.visualMapModel)), r5.length = 0;
          }, s.prototype._clearHoverLinkFromSeries = function() {
            this._hideIndicator();
            var r5 = this.api.getZr();
            r5.off("mouseover", this._hoverLinkFromSeriesMouseOver), r5.off("mouseout", this._hideIndicator);
          }, s.prototype._applyTransform = function(r5, g5, b6, S2) {
            var A2 = vo(g5, S2 ? null : this.group);
            return ja2(r5) ? Lo(r5, A2, b6) : Ks(r5, A2, b6);
          }, s.prototype._dispatchHighDown = function(r5, g5) {
            g5 && g5.length && this.api.dispatchAction({ type: r5, batch: g5 });
          }, s.prototype.dispose = function() {
            this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
          }, s.prototype.remove = function() {
            this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
          }, s.type = "visualMap.continuous", s;
        }(QLe);
        function nOe(c5, s, r5, g5) {
          return new Gb2({ shape: { points: c5 }, draggable: !!r5, cursor: s, drift: r5, onmousemove: function(b6) {
            OI(b6.event);
          }, ondragend: g5 });
        }
        function sQn(c5, s, r5) {
          var g5 = iQn / 2, b6 = c5.get("hoverLinkDataSize");
          return b6 && (g5 = N32(b6, s, r5, true) / 2), g5;
        }
        function rOe(c5) {
          var s = c5.get("hoverLinkOnHandle");
          return !!(s == null ? c5.get("realtime") : s);
        }
        function iOe(c5) {
          return c5 === "vertical" ? "ns-resize" : "ew-resize";
        }
        var lQn = oQn, uQn = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, cQn = function(c5, s) {
          s.eachComponent({ mainType: "visualMap", query: c5 }, function(r5) {
            r5.setSelected(c5.selected);
          });
        }, fQn = [{ createOnAllSeries: true, reset: function(c5, s) {
          var r5 = [];
          return s.eachComponent("visualMap", function(g5) {
            var b6 = c5.pipelineContext;
            !g5.isTargetSeries(c5) || b6 && b6.large || r5.push(aKn(g5.stateList, g5.targetVisuals, Cs(g5.getValueState, g5), g5.getDataDimensionIndex(c5.getData())));
          }), r5;
        } }, { createOnAllSeries: true, reset: function(c5, s) {
          var r5 = c5.getData(), g5 = [];
          s.eachComponent("visualMap", function(b6) {
            if (b6.isTargetSeries(c5)) {
              var S2 = b6.getVisualMeta(Cs(hQn, null, c5, b6)) || { stops: [], outerColors: [] }, A2 = b6.getDataDimensionIndex(r5);
              A2 >= 0 && (S2.dimension = A2, g5.push(S2));
            }
          }), c5.getData().setVisual("visualMeta", g5);
        } }];
        function hQn(c5, s, r5, g5) {
          for (var b6 = s.targetVisuals[g5], S2 = Sx.prepareVisualTypes(b6), A2 = { color: gct(c5.getData(), "color") }, k2 = 0, R6 = S2.length; k2 < R6; k2++) {
            var B3 = S2[k2], G3 = b6[B3 === "opacity" ? "__alphaForOpacity" : B3];
            G3 && G3.applyVisual(r5, Z3, X3);
          }
          return A2.color;
          function Z3(tt) {
            return A2[tt];
          }
          function X3(tt, it) {
            A2[tt] = it;
          }
        }
        var aOe = Ye2;
        function pQn(c5) {
          var s = c5 && c5.visualMap;
          ja2(s) || (s = s ? [s] : []), aOe(s, function(r5) {
            if (r5) {
              VX(r5, "splitList") && !VX(r5, "pieces") && (r5.pieces = r5.splitList, delete r5.splitList);
              var g5 = r5.pieces;
              g5 && ja2(g5) && aOe(g5, function(b6) {
                Wl(b6) && (VX(b6, "start") && !VX(b6, "min") && (b6.min = b6.start), VX(b6, "end") && !VX(b6, "max") && (b6.max = b6.end));
              });
            }
          });
        }
        function VX(c5, s) {
          return c5 && c5.hasOwnProperty && c5.hasOwnProperty(s);
        }
        var oOe = false;
        function sOe(c5) {
          oOe || (oOe = true, c5.registerSubTypeDefaulter("visualMap", function(s) {
            return !s.categories && (!(s.pieces ? s.pieces.length > 0 : s.splitNumber > 0) || s.calculable) ? "continuous" : "piecewise";
          }), c5.registerAction(uQn, cQn), Ye2(fQn, function(s) {
            c5.registerVisual(c5.PRIORITY.VISUAL.COMPONENT, s);
          }), c5.registerPreprocessor(pQn));
        }
        function lOe(c5) {
          c5.registerComponentModel(eQn), c5.registerComponentView(lQn), sOe(c5);
        }
        var dQn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5._pieceList = [], r5;
          }
          return s.prototype.optionUpdated = function(r5, g5) {
            c5.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
            var b6 = this._mode = this._determineMode();
            this._pieceList = [], gQn[this._mode].call(this, this._pieceList), this._resetSelected(r5, g5);
            var S2 = this.option.categories;
            this.resetVisual(function(A2, k2) {
              b6 === "categories" ? (A2.mappingMethod = "category", A2.categories = Ml(S2)) : (A2.dataExtent = this.getExtent(), A2.mappingMethod = "piecewise", A2.pieceList = Ha2(this._pieceList, function(R6) {
                return R6 = Ml(R6), k2 !== "inRange" && (R6.visual = null), R6;
              }));
            });
          }, s.prototype.completeVisualOption = function() {
            var r5 = this.option, g5 = {}, b6 = Sx.listVisualTypes(), S2 = this.isCategory();
            Ye2(r5.pieces, function(k2) {
              Ye2(b6, function(R6) {
                k2.hasOwnProperty(R6) && (g5[R6] = 1);
              });
            }), Ye2(g5, function(k2, R6) {
              var B3 = false;
              Ye2(this.stateList, function(G3) {
                B3 = B3 || A2(r5, G3, R6) || A2(r5.target, G3, R6);
              }, this), !B3 && Ye2(this.stateList, function(G3) {
                (r5[G3] || (r5[G3] = {}))[R6] = ZLe.get(R6, G3 === "inRange" ? "active" : "inactive", S2);
              });
            }, this);
            function A2(k2, R6, B3) {
              return k2 && k2[R6] && k2[R6].hasOwnProperty(B3);
            }
            c5.prototype.completeVisualOption.apply(this, arguments);
          }, s.prototype._resetSelected = function(r5, g5) {
            var b6 = this.option, S2 = this._pieceList, A2 = (g5 ? b6 : r5).selected || {};
            if (b6.selected = A2, Ye2(S2, function(R6, B3) {
              var G3 = this.getSelectedMapKey(R6);
              A2.hasOwnProperty(G3) || (A2[G3] = true);
            }, this), b6.selectedMode === "single") {
              var k2 = false;
              Ye2(S2, function(R6, B3) {
                var G3 = this.getSelectedMapKey(R6);
                A2[G3] && (k2 ? A2[G3] = false : k2 = true);
              }, this);
            }
          }, s.prototype.getItemSymbol = function() {
            return this.get("itemSymbol");
          }, s.prototype.getSelectedMapKey = function(r5) {
            return this._mode === "categories" ? r5.value + "" : r5.index + "";
          }, s.prototype.getPieceList = function() {
            return this._pieceList;
          }, s.prototype._determineMode = function() {
            var r5 = this.option;
            return r5.pieces && r5.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
          }, s.prototype.setSelected = function(r5) {
            this.option.selected = Ml(r5);
          }, s.prototype.getValueState = function(r5) {
            var g5 = Sx.findPieceIndex(r5, this._pieceList);
            return g5 != null && this.option.selected[this.getSelectedMapKey(this._pieceList[g5])] ? "inRange" : "outOfRange";
          }, s.prototype.findTargetDataIndices = function(r5) {
            var g5 = [], b6 = this._pieceList;
            return this.eachTargetSeries(function(S2) {
              var A2 = [], k2 = S2.getData();
              k2.each(this.getDataDimensionIndex(k2), function(R6, B3) {
                var G3 = Sx.findPieceIndex(R6, b6);
                G3 === r5 && A2.push(B3);
              }, this), g5.push({ seriesId: S2.id, dataIndex: A2 });
            }, this), g5;
          }, s.prototype.getRepresentValue = function(r5) {
            var g5;
            if (this.isCategory())
              g5 = r5.value;
            else if (r5.value != null)
              g5 = r5.value;
            else {
              var b6 = r5.interval || [];
              g5 = b6[0] === -1 / 0 && b6[1] === 1 / 0 ? 0 : (b6[0] + b6[1]) / 2;
            }
            return g5;
          }, s.prototype.getVisualMeta = function(r5) {
            if (this.isCategory())
              return;
            var g5 = [], b6 = ["", ""], S2 = this;
            function A2(G3, Z3) {
              var X3 = S2.getRepresentValue({ interval: G3 });
              Z3 || (Z3 = S2.getValueState(X3));
              var tt = r5(X3, Z3);
              G3[0] === -1 / 0 ? b6[0] = tt : G3[1] === 1 / 0 ? b6[1] = tt : g5.push({ value: G3[0], color: tt }, { value: G3[1], color: tt });
            }
            var k2 = this._pieceList.slice();
            if (!k2.length)
              k2.push({ interval: [-1 / 0, 1 / 0] });
            else {
              var R6 = k2[0].interval[0];
              R6 !== -1 / 0 && k2.unshift({ interval: [-1 / 0, R6] }), R6 = k2[k2.length - 1].interval[1], R6 !== 1 / 0 && k2.push({ interval: [R6, 1 / 0] });
            }
            var B3 = -1 / 0;
            return Ye2(k2, function(G3) {
              var Z3 = G3.interval;
              Z3 && (Z3[0] > B3 && A2([B3, Z3[0]], "outOfRange"), A2(Z3.slice()), B3 = Z3[1]);
            }, this), { stops: g5, outerColors: b6 };
          }, s.type = "visualMap.piecewise", s.defaultOption = $8(NCt.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), s;
        }(NCt), gQn = { splitNumber: function(c5) {
          var s = this.option, r5 = Math.min(s.precision, 20), g5 = this.getExtent(), b6 = s.splitNumber;
          b6 = Math.max(parseInt(b6, 10), 1), s.splitNumber = b6;
          for (var S2 = (g5[1] - g5[0]) / b6; +S2.toFixed(r5) !== S2 && r5 < 5; )
            r5++;
          s.precision = r5, S2 = +S2.toFixed(r5), s.minOpen && c5.push({ interval: [-1 / 0, g5[0]], close: [0, 0] });
          for (var A2 = 0, k2 = g5[0]; A2 < b6; k2 += S2, A2++) {
            var R6 = A2 === b6 - 1 ? g5[1] : k2 + S2;
            c5.push({ interval: [k2, R6], close: [1, 1] });
          }
          s.maxOpen && c5.push({ interval: [g5[1], 1 / 0], close: [0, 0] }), qlt(c5), Ye2(c5, function(B3, G3) {
            B3.index = G3, B3.text = this.formatValueText(B3.interval);
          }, this);
        }, categories: function(c5) {
          var s = this.option;
          Ye2(s.categories, function(r5) {
            c5.push({ text: this.formatValueText(r5, true), value: r5 });
          }, this), uOe(s, c5);
        }, pieces: function(c5) {
          var s = this.option;
          Ye2(s.pieces, function(r5, g5) {
            Wl(r5) || (r5 = { value: r5 });
            var b6 = { text: "", index: g5 };
            if (r5.label != null && (b6.text = r5.label), r5.hasOwnProperty("value")) {
              var S2 = b6.value = r5.value;
              b6.interval = [S2, S2], b6.close = [1, 1];
            } else {
              for (var A2 = b6.interval = [], k2 = b6.close = [0, 0], R6 = [1, 0, 1], B3 = [-1 / 0, 1 / 0], G3 = [], Z3 = 0; Z3 < 2; Z3++) {
                for (var X3 = [["gte", "gt", "min"], ["lte", "lt", "max"]][Z3], tt = 0; tt < 3 && A2[Z3] == null; tt++)
                  A2[Z3] = r5[X3[tt]], k2[Z3] = R6[tt], G3[Z3] = tt === 2;
                A2[Z3] == null && (A2[Z3] = B3[Z3]);
              }
              G3[0] && A2[1] === 1 / 0 && (k2[0] = 0), G3[1] && A2[0] === -1 / 0 && (k2[1] = 0), A2[0] === A2[1] && k2[0] && k2[1] && (b6.value = A2[0]);
            }
            b6.visual = Sx.retrieveVisuals(r5), c5.push(b6);
          }, this), uOe(s, c5), qlt(c5), Ye2(c5, function(r5) {
            var g5 = r5.close, b6 = [["<", "\u2264"][g5[1]], [">", "\u2265"][g5[0]]];
            r5.text = r5.text || this.formatValueText(r5.value != null ? r5.value : r5.interval, false, b6);
          }, this);
        } };
        function uOe(c5, s) {
          var r5 = c5.inverse;
          (c5.orient === "vertical" ? !r5 : r5) && s.reverse();
        }
        var vQn = dQn, yQn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = s.type, r5;
          }
          return s.prototype.doRender = function() {
            var r5 = this.group;
            r5.removeAll();
            var g5 = this.visualMapModel, b6 = g5.get("textGap"), S2 = g5.textStyleModel, A2 = S2.getFont(), k2 = S2.getTextColor(), R6 = this._getItemAlign(), B3 = g5.itemSize, G3 = this._getViewData(), Z3 = G3.endsText, X3 = Wm(g5.get("showLabel", true), !Z3);
            Z3 && this._renderEndsText(r5, Z3[0], B3, X3, R6), Ye2(G3.viewPieceList, function(tt) {
              var it = tt.piece, pt = new nu();
              pt.onclick = Cs(this._onItemClick, this, it), this._enableHoverLink(pt, tt.indexInModelPieceList);
              var mt = g5.getRepresentValue(it);
              if (this._createItemSymbol(pt, mt, [0, 0, B3[0], B3[1]]), X3) {
                var Mt = this.visualMapModel.getValueState(mt);
                pt.add(new hh2({ style: { x: R6 === "right" ? -b6 : B3[0] + b6, y: B3[1] / 2, text: it.text, verticalAlign: "middle", align: R6, font: A2, fill: k2, opacity: Mt === "outOfRange" ? 0.5 : 1 } }));
              }
              r5.add(pt);
            }, this), Z3 && this._renderEndsText(r5, Z3[1], B3, X3, R6), lW(g5.get("orient"), r5, g5.get("itemGap")), this.renderBackground(r5), this.positionGroup(r5);
          }, s.prototype._enableHoverLink = function(r5, g5) {
            var b6 = this;
            r5.on("mouseover", function() {
              return S2("highlight");
            }).on("mouseout", function() {
              return S2("downplay");
            });
            var S2 = function(A2) {
              var k2 = b6.visualMapModel;
              k2.option.hoverLink && b6.api.dispatchAction({ type: A2, batch: FCt(k2.findTargetDataIndices(g5), k2) });
            };
          }, s.prototype._getItemAlign = function() {
            var r5 = this.visualMapModel, g5 = r5.option;
            if (g5.orient === "vertical")
              return tOe(r5, this.api, r5.itemSize);
            var b6 = g5.align;
            return (!b6 || b6 === "auto") && (b6 = "left"), b6;
          }, s.prototype._renderEndsText = function(r5, g5, b6, S2, A2) {
            if (g5) {
              var k2 = new nu(), R6 = this.visualMapModel.textStyleModel;
              k2.add(new hh2({ style: { x: S2 ? A2 === "right" ? b6[0] : 0 : b6[0] / 2, y: b6[1] / 2, verticalAlign: "middle", align: S2 ? A2 : "center", text: g5, font: R6.getFont(), fill: R6.getTextColor() } })), r5.add(k2);
            }
          }, s.prototype._getViewData = function() {
            var r5 = this.visualMapModel, g5 = Ha2(r5.getPieceList(), function(k2, R6) {
              return { piece: k2, indexInModelPieceList: R6 };
            }), b6 = r5.get("text"), S2 = r5.get("orient"), A2 = r5.get("inverse");
            return (S2 === "horizontal" ? A2 : !A2) ? g5.reverse() : b6 && (b6 = b6.slice().reverse()), { viewPieceList: g5, endsText: b6 };
          }, s.prototype._createItemSymbol = function(r5, g5, b6) {
            r5.add(am(this.getControllerVisual(g5, "symbol"), b6[0], b6[1], b6[2], b6[3], this.getControllerVisual(g5, "color")));
          }, s.prototype._onItemClick = function(r5) {
            var g5 = this.visualMapModel, b6 = g5.option, S2 = Ml(b6.selected), A2 = g5.getSelectedMapKey(r5);
            b6.selectedMode === "single" ? (S2[A2] = true, Ye2(S2, function(k2, R6) {
              S2[R6] = R6 === A2;
            })) : S2[A2] = !S2[A2], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: S2 });
          }, s.type = "visualMap.piecewise", s;
        }(QLe), mQn = yQn;
        function cOe(c5) {
          c5.registerComponentModel(vQn), c5.registerComponentView(mQn), sOe(c5);
        }
        function bQn(c5) {
          Fc2(lOe), Fc2(cOe);
        }
        var _Qn = { label: { enabled: true }, decal: { show: false } }, fOe = Df2(), xQn = {};
        function wQn(c5, s) {
          var r5 = c5.getModel("aria");
          if (!r5.get("enabled"))
            return;
          var g5 = Ml(_Qn);
          bu(g5.label, c5.getLocaleModel().get("aria"), false), bu(r5.option, g5, false), b6(), S2();
          function b6() {
            var B3 = r5.getModel("decal"), G3 = B3.get("show");
            if (G3) {
              var Z3 = Ps();
              c5.eachSeries(function(X3) {
                if (!X3.isColorBySeries()) {
                  var tt = Z3.get(X3.type);
                  tt || (tt = {}, Z3.set(X3.type, tt)), fOe(X3).scope = tt;
                }
              }), c5.eachRawSeries(function(X3) {
                if (c5.isSeriesFiltered(X3))
                  return;
                if (Tl(X3.enableAriaDecal)) {
                  X3.enableAriaDecal();
                  return;
                }
                var tt = X3.getData();
                if (X3.isColorBySeries()) {
                  var it = PWt(X3.ecModel, X3.name, xQn, c5.getSeriesCount()), pt = tt.getVisual("decal");
                  tt.setVisual("decal", Ot(pt, it));
                } else {
                  var mt = X3.getRawData(), Mt = {}, kt = fOe(X3).scope;
                  tt.each(function(ce2) {
                    var ae2 = tt.getRawIndex(ce2);
                    Mt[ae2] = ce2;
                  });
                  var Gt = mt.count();
                  mt.each(function(ce2) {
                    var ae2 = Mt[ce2], de2 = mt.getName(ce2) || ce2 + "", we2 = PWt(X3.ecModel, de2, kt, Gt), Se2 = tt.getItemVisual(ae2, "decal");
                    tt.setItemVisual(ae2, "decal", Ot(Se2, we2));
                  });
                }
                function Ot(ce2, ae2) {
                  var de2 = ce2 ? sa2(sa2({}, ae2), ce2) : ae2;
                  return de2.dirty = true, de2;
                }
              });
            }
          }
          function S2() {
            var B3 = c5.getLocaleModel().get("aria"), G3 = r5.getModel("label");
            if (G3.option = Cl(G3.option, B3), !!G3.get("enabled")) {
              var Z3 = s.getZr().dom;
              if (G3.get("description")) {
                Z3.setAttribute("aria-label", G3.get("description"));
                return;
              }
              var X3 = c5.getSeriesCount(), tt = G3.get(["data", "maxCount"]) || 10, it = G3.get(["series", "maxCount"]) || 10, pt = Math.min(X3, it), mt;
              if (!(X3 < 1)) {
                var Mt = k2();
                if (Mt) {
                  var kt = G3.get(["general", "withTitle"]);
                  mt = A2(kt, { title: Mt });
                } else
                  mt = G3.get(["general", "withoutTitle"]);
                var Gt = [], Ot = X3 > 1 ? G3.get(["series", "multiple", "prefix"]) : G3.get(["series", "single", "prefix"]);
                mt += A2(Ot, { seriesCount: X3 }), c5.eachSeries(function(we2, Se2) {
                  if (Se2 < pt) {
                    var Oe2 = void 0, je2 = we2.get("name"), rn = je2 ? "withName" : "withoutName";
                    Oe2 = X3 > 1 ? G3.get(["series", "multiple", rn]) : G3.get(["series", "single", rn]), Oe2 = A2(Oe2, { seriesId: we2.seriesIndex, seriesName: we2.get("name"), seriesType: R6(we2.subType) });
                    var qe2 = we2.getData();
                    if (qe2.count() > tt) {
                      var An = G3.get(["data", "partialData"]);
                      Oe2 += A2(An, { displayCnt: tt });
                    } else
                      Oe2 += G3.get(["data", "allData"]);
                    for (var jn = G3.get(["data", "separator", "middle"]), _n = G3.get(["data", "separator", "end"]), Jr = [], Qn = 0; Qn < qe2.count(); Qn++)
                      if (Qn < tt) {
                        var rr = qe2.getName(Qn), Ar = qe2.getValues(Qn), fi2 = G3.get(["data", rr ? "withName" : "withoutName"]);
                        Jr.push(A2(fi2, { name: rr, value: Ar.join(jn) }));
                      }
                    Oe2 += Jr.join(jn) + _n, Gt.push(Oe2);
                  }
                });
                var ce2 = G3.getModel(["series", "multiple", "separator"]), ae2 = ce2.get("middle"), de2 = ce2.get("end");
                mt += Gt.join(ae2) + de2, Z3.setAttribute("aria-label", mt);
              }
            }
          }
          function A2(B3, G3) {
            if (!gs(B3))
              return B3;
            var Z3 = B3;
            return Ye2(G3, function(X3, tt) {
              Z3 = Z3.replace(new RegExp("\\{\\s*" + tt + "\\s*\\}", "g"), X3);
            }), Z3;
          }
          function k2() {
            var B3 = c5.get("title");
            return B3 && B3.length && (B3 = B3[0]), B3 && B3.text;
          }
          function R6(B3) {
            return c5.getLocaleModel().get(["series", "typeNames"])[B3] || "\u81EA\u5B9A\u4E49\u56FE";
          }
        }
        function SQn(c5) {
          if (!(!c5 || !c5.aria)) {
            var s = c5.aria;
            s.show != null && (s.enabled = s.show), s.label = s.label || {}, Ye2(["description", "general", "series", "data"], function(r5) {
              s[r5] != null && (s.label[r5] = s[r5]);
            });
          }
        }
        function MQn(c5) {
          c5.registerPreprocessor(SQn), c5.registerVisual(c5.PRIORITY.VISUAL.ARIA, wQn);
        }
        var hOe = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, CQn = function() {
          function c5(s) {
            var r5 = this._condVal = gs(s) ? new RegExp(s) : lzt(s) ? s : null;
            if (r5 == null) {
              var g5 = "";
              rf2(g5);
            }
          }
          return c5.prototype.evaluate = function(s) {
            var r5 = typeof s;
            return gs(r5) ? this._condVal.test(s) : Oh2(r5) ? this._condVal.test(s + "") : false;
          }, c5;
        }(), TQn = function() {
          function c5() {
          }
          return c5.prototype.evaluate = function() {
            return this.value;
          }, c5;
        }(), AQn = function() {
          function c5() {
          }
          return c5.prototype.evaluate = function() {
            for (var s = this.children, r5 = 0; r5 < s.length; r5++)
              if (!s[r5].evaluate())
                return false;
            return true;
          }, c5;
        }(), IQn = function() {
          function c5() {
          }
          return c5.prototype.evaluate = function() {
            for (var s = this.children, r5 = 0; r5 < s.length; r5++)
              if (s[r5].evaluate())
                return true;
            return false;
          }, c5;
        }(), DQn = function() {
          function c5() {
          }
          return c5.prototype.evaluate = function() {
            return !this.child.evaluate();
          }, c5;
        }(), EQn = function() {
          function c5() {
          }
          return c5.prototype.evaluate = function() {
            for (var s = !!this.valueParser, r5 = this.getValue, g5 = r5(this.valueGetterParam), b6 = s ? this.valueParser(g5) : null, S2 = 0; S2 < this.subCondList.length; S2++)
              if (!this.subCondList[S2].evaluate(s ? b6 : g5))
                return false;
            return true;
          }, c5;
        }();
        function Aqt(c5, s) {
          if (c5 === true || c5 === false) {
            var r5 = new TQn();
            return r5.value = c5, r5;
          }
          var g5 = "";
          return dOe(c5) || rf2(g5), c5.and ? pOe("and", c5, s) : c5.or ? pOe("or", c5, s) : c5.not ? kQn(c5, s) : PQn(c5, s);
        }
        function pOe(c5, s, r5) {
          var g5 = s[c5], b6 = "";
          ja2(g5) || rf2(b6), g5.length || rf2(b6);
          var S2 = c5 === "and" ? new AQn() : new IQn();
          return S2.children = Ha2(g5, function(A2) {
            return Aqt(A2, r5);
          }), S2.children.length || rf2(b6), S2;
        }
        function kQn(c5, s) {
          var r5 = c5.not, g5 = "";
          dOe(r5) || rf2(g5);
          var b6 = new DQn();
          return b6.child = Aqt(r5, s), b6.child || rf2(g5), b6;
        }
        function PQn(c5, s) {
          for (var r5 = "", g5 = s.prepareGetValue(c5), b6 = [], S2 = nf2(c5), A2 = c5.parser, k2 = A2 ? GTe(A2) : null, R6 = 0; R6 < S2.length; R6++) {
            var B3 = S2[R6];
            if (!(B3 === "parser" || s.valueGetterAttrMap.get(B3))) {
              var G3 = Ls(hOe, B3) ? hOe[B3] : B3, Z3 = c5[B3], X3 = k2 ? k2(Z3) : Z3, tt = fNn(G3, X3) || G3 === "reg" && new CQn(X3);
              tt || rf2(r5), b6.push(tt);
            }
          }
          b6.length || rf2(r5);
          var it = new EQn();
          return it.valueGetterParam = g5, it.valueParser = k2, it.getValue = s.getValue, it.subCondList = b6, it;
        }
        function dOe(c5) {
          return Wl(c5) && !Fb2(c5);
        }
        var LQn = function() {
          function c5(s, r5) {
            this._cond = Aqt(s, r5);
          }
          return c5.prototype.evaluate = function() {
            return this._cond.evaluate();
          }, c5;
        }();
        function OQn(c5, s) {
          return new LQn(c5, s);
        }
        var RQn = { type: "echarts:filter", transform: function(c5) {
          for (var s = c5.upstream, r5, g5 = OQn(c5.config, { valueGetterAttrMap: Ps({ dimension: true }), prepareGetValue: function(k2) {
            var R6 = "", B3 = k2.dimension;
            Ls(k2, "dimension") || rf2(R6);
            var G3 = s.getDimensionInfo(B3);
            return G3 || rf2(R6), { dimIdx: G3.index };
          }, getValue: function(k2) {
            return s.retrieveValueFromItem(r5, k2.dimIdx);
          } }), b6 = [], S2 = 0, A2 = s.count(); S2 < A2; S2++)
            r5 = s.getRawDataItem(S2), g5.evaluate() && b6.push(r5);
          return { data: b6 };
        } }, NQn = { type: "echarts:sort", transform: function(c5) {
          var s = c5.upstream, r5 = c5.config, g5 = "", b6 = xp(r5);
          b6.length || rf2(g5);
          var S2 = [];
          Ye2(b6, function(G3) {
            var Z3 = G3.dimension, X3 = G3.order, tt = G3.parser, it = G3.incomparable;
            if (Z3 == null && rf2(g5), X3 !== "asc" && X3 !== "desc" && rf2(g5), it && it !== "min" && it !== "max") {
              var pt = "";
              rf2(pt);
            }
            if (X3 !== "asc" && X3 !== "desc") {
              var mt = "";
              rf2(mt);
            }
            var Mt = s.getDimensionInfo(Z3);
            Mt || rf2(g5);
            var kt = tt ? GTe(tt) : null;
            tt && !kt && rf2(g5), S2.push({ dimIdx: Mt.index, parser: kt, comparator: new UTe(X3, it) });
          });
          var A2 = s.sourceFormat;
          A2 !== qw && A2 !== XI && rf2(g5);
          for (var k2 = [], R6 = 0, B3 = s.count(); R6 < B3; R6++)
            k2.push(s.getRawDataItem(R6));
          return k2.sort(function(G3, Z3) {
            for (var X3 = 0; X3 < S2.length; X3++) {
              var tt = S2[X3], it = s.retrieveValueFromItem(G3, tt.dimIdx), pt = s.retrieveValueFromItem(Z3, tt.dimIdx);
              tt.parser && (it = tt.parser(it), pt = tt.parser(pt));
              var mt = tt.comparator.evaluate(it, pt);
              if (mt !== 0)
                return mt;
            }
            return 0;
          }), { data: k2 };
        } };
        function FQn(c5) {
          c5.registerTransform(RQn), c5.registerTransform(NQn);
        }
        var VQn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "dataset", r5;
          }
          return s.prototype.init = function(r5, g5, b6) {
            c5.prototype.init.call(this, r5, g5, b6), this._sourceManager = new XTe(this), QTe(this);
          }, s.prototype.mergeOption = function(r5, g5) {
            c5.prototype.mergeOption.call(this, r5, g5), QTe(this);
          }, s.prototype.optionUpdated = function() {
            this._sourceManager.dirty();
          }, s.prototype.getSourceManager = function() {
            return this._sourceManager;
          }, s.type = "dataset", s.defaultOption = { seriesLayoutBy: D3 }, s;
        }(Rh2), BQn = function(c5) {
          wn(s, c5);
          function s() {
            var r5 = c5 !== null && c5.apply(this, arguments) || this;
            return r5.type = "dataset", r5;
          }
          return s.type = "dataset", s;
        }(P0);
        function zQn(c5) {
          c5.registerComponentModel(VQn), c5.registerComponentView(BQn);
        }
        var F32 = jI.CMD;
        function BX(c5, s) {
          return Math.abs(c5 - s) < 1e-5;
        }
        function Iqt(c5) {
          var s = c5.data, r5 = c5.len(), g5 = [], b6, S2 = 0, A2 = 0, k2 = 0, R6 = 0;
          function B3(qe2, An) {
            b6 && b6.length > 2 && g5.push(b6), b6 = [qe2, An];
          }
          function G3(qe2, An, jn, _n) {
            BX(qe2, jn) && BX(An, _n) || b6.push(qe2, An, jn, _n, jn, _n);
          }
          function Z3(qe2, An, jn, _n, Jr, Qn) {
            var rr = Math.abs(An - qe2), Ar = Math.tan(rr / 4) * 4 / 3, fi2 = An < qe2 ? -1 : 1, mi2 = Math.cos(qe2), Oo = Math.sin(qe2), Ts = Math.cos(An), gl = Math.sin(An), nl = mi2 * Jr + jn, rl = Oo * Qn + _n, ss = Ts * Jr + jn, Us = gl * Qn + _n, sl = Jr * Ar * fi2, ws = Qn * Ar * fi2;
            b6.push(nl - sl * Oo, rl + ws * mi2, ss + sl * gl, Us - ws * Ts, ss, Us);
          }
          for (var X3, tt, it, pt, mt = 0; mt < r5; ) {
            var Mt = s[mt++], kt = mt === 1;
            switch (kt && (S2 = s[mt], A2 = s[mt + 1], k2 = S2, R6 = A2, (Mt === F32.L || Mt === F32.C || Mt === F32.Q) && (b6 = [k2, R6])), Mt) {
              case F32.M:
                S2 = k2 = s[mt++], A2 = R6 = s[mt++], B3(k2, R6);
                break;
              case F32.L:
                X3 = s[mt++], tt = s[mt++], G3(S2, A2, X3, tt), S2 = X3, A2 = tt;
                break;
              case F32.C:
                b6.push(s[mt++], s[mt++], s[mt++], s[mt++], S2 = s[mt++], A2 = s[mt++]);
                break;
              case F32.Q:
                X3 = s[mt++], tt = s[mt++], it = s[mt++], pt = s[mt++], b6.push(S2 + 2 / 3 * (X3 - S2), A2 + 2 / 3 * (tt - A2), it + 2 / 3 * (X3 - it), pt + 2 / 3 * (tt - pt), it, pt), S2 = it, A2 = pt;
                break;
              case F32.A:
                var Gt = s[mt++], Ot = s[mt++], ce2 = s[mt++], ae2 = s[mt++], de2 = s[mt++], we2 = s[mt++] + de2;
                mt += 1;
                var Se2 = !s[mt++];
                X3 = Math.cos(de2) * ce2 + Gt, tt = Math.sin(de2) * ae2 + Ot, kt ? (k2 = X3, R6 = tt, B3(k2, R6)) : G3(S2, A2, X3, tt), S2 = Math.cos(we2) * ce2 + Gt, A2 = Math.sin(we2) * ae2 + Ot;
                for (var Oe2 = (Se2 ? -1 : 1) * Math.PI / 2, je2 = de2; Se2 ? je2 > we2 : je2 < we2; je2 += Oe2) {
                  var rn = Se2 ? Math.max(je2 + Oe2, we2) : Math.min(je2 + Oe2, we2);
                  Z3(je2, rn, Gt, Ot, ce2, ae2);
                }
                break;
              case F32.R:
                k2 = S2 = s[mt++], R6 = A2 = s[mt++], X3 = k2 + s[mt++], tt = R6 + s[mt++], B3(X3, R6), G3(X3, R6, X3, tt), G3(X3, tt, k2, tt), G3(k2, tt, k2, R6), G3(k2, R6, X3, R6);
                break;
              case F32.Z:
                b6 && G3(S2, A2, k2, R6), S2 = k2, A2 = R6;
                break;
            }
          }
          return b6 && b6.length > 2 && g5.push(b6), g5;
        }
        function Dqt(c5, s, r5, g5, b6, S2, A2, k2, R6, B3) {
          if (BX(c5, r5) && BX(s, g5) && BX(b6, A2) && BX(S2, k2)) {
            R6.push(A2, k2);
            return;
          }
          var G3 = 2 / B3, Z3 = G3 * G3, X3 = A2 - c5, tt = k2 - s, it = Math.sqrt(X3 * X3 + tt * tt);
          X3 /= it, tt /= it;
          var pt = r5 - c5, mt = g5 - s, Mt = b6 - A2, kt = S2 - k2, Gt = pt * pt + mt * mt, Ot = Mt * Mt + kt * kt;
          if (Gt < Z3 && Ot < Z3) {
            R6.push(A2, k2);
            return;
          }
          var ce2 = X3 * pt + tt * mt, ae2 = -X3 * Mt - tt * kt, de2 = Gt - ce2 * ce2, we2 = Ot - ae2 * ae2;
          if (de2 < Z3 && ce2 >= 0 && we2 < Z3 && ae2 >= 0) {
            R6.push(A2, k2);
            return;
          }
          var Se2 = [], Oe2 = [];
          GC(c5, r5, b6, A2, 0.5, Se2), GC(s, g5, S2, k2, 0.5, Oe2), Dqt(Se2[0], Oe2[0], Se2[1], Oe2[1], Se2[2], Oe2[2], Se2[3], Oe2[3], R6, B3), Dqt(Se2[4], Oe2[4], Se2[5], Oe2[5], Se2[6], Oe2[6], Se2[7], Oe2[7], R6, B3);
        }
        function jQn(c5, s) {
          var r5 = Iqt(c5), g5 = [];
          s = s || 1;
          for (var b6 = 0; b6 < r5.length; b6++) {
            var S2 = r5[b6], A2 = [], k2 = S2[0], R6 = S2[1];
            A2.push(k2, R6);
            for (var B3 = 2; B3 < S2.length; ) {
              var G3 = S2[B3++], Z3 = S2[B3++], X3 = S2[B3++], tt = S2[B3++], it = S2[B3++], pt = S2[B3++];
              Dqt(k2, R6, G3, Z3, X3, tt, it, pt, A2, s), k2 = it, R6 = pt;
            }
            g5.push(A2);
          }
          return g5;
        }
        function gOe(c5, s, r5) {
          var g5 = c5[s], b6 = c5[1 - s], S2 = Math.abs(g5 / b6), A2 = Math.ceil(Math.sqrt(S2 * r5)), k2 = Math.floor(r5 / A2);
          k2 === 0 && (k2 = 1, A2 = r5);
          for (var R6 = [], B3 = 0; B3 < A2; B3++)
            R6.push(k2);
          var G3 = A2 * k2, Z3 = r5 - G3;
          if (Z3 > 0)
            for (var B3 = 0; B3 < Z3; B3++)
              R6[B3 % A2] += 1;
          return R6;
        }
        function vOe(c5, s, r5) {
          for (var g5 = c5.r0, b6 = c5.r, S2 = c5.startAngle, A2 = c5.endAngle, k2 = Math.abs(A2 - S2), R6 = k2 * b6, B3 = b6 - g5, G3 = R6 > Math.abs(B3), Z3 = gOe([R6, B3], G3 ? 0 : 1, s), X3 = (G3 ? k2 : B3) / Z3.length, tt = 0; tt < Z3.length; tt++)
            for (var it = (G3 ? B3 : k2) / Z3[tt], pt = 0; pt < Z3[tt]; pt++) {
              var mt = {};
              G3 ? (mt.startAngle = S2 + X3 * tt, mt.endAngle = S2 + X3 * (tt + 1), mt.r0 = g5 + it * pt, mt.r = g5 + it * (pt + 1)) : (mt.startAngle = S2 + it * pt, mt.endAngle = S2 + it * (pt + 1), mt.r0 = g5 + X3 * tt, mt.r = g5 + X3 * (tt + 1)), mt.clockwise = c5.clockwise, mt.cx = c5.cx, mt.cy = c5.cy, r5.push(mt);
            }
        }
        function WQn(c5, s, r5) {
          for (var g5 = c5.width, b6 = c5.height, S2 = g5 > b6, A2 = gOe([g5, b6], S2 ? 0 : 1, s), k2 = S2 ? "width" : "height", R6 = S2 ? "height" : "width", B3 = S2 ? "x" : "y", G3 = S2 ? "y" : "x", Z3 = c5[k2] / A2.length, X3 = 0; X3 < A2.length; X3++)
            for (var tt = c5[R6] / A2[X3], it = 0; it < A2[X3]; it++) {
              var pt = {};
              pt[B3] = X3 * Z3, pt[G3] = it * tt, pt[k2] = Z3, pt[R6] = tt, pt.x += c5.x, pt.y += c5.y, r5.push(pt);
            }
        }
        function yOe(c5, s, r5, g5) {
          return c5 * g5 - r5 * s;
        }
        function GQn(c5, s, r5, g5, b6, S2, A2, k2) {
          var R6 = r5 - c5, B3 = g5 - s, G3 = A2 - b6, Z3 = k2 - S2, X3 = yOe(G3, Z3, R6, B3);
          if (Math.abs(X3) < 1e-6)
            return null;
          var tt = c5 - b6, it = s - S2, pt = yOe(tt, it, G3, Z3) / X3;
          return pt < 0 || pt > 1 ? null : new Bu(pt * R6 + c5, pt * B3 + s);
        }
        function HQn(c5, s, r5) {
          var g5 = new Bu();
          Bu.sub(g5, r5, s), g5.normalize();
          var b6 = new Bu();
          Bu.sub(b6, c5, s);
          var S2 = b6.dot(g5);
          return S2;
        }
        function zX(c5, s) {
          var r5 = c5[c5.length - 1];
          r5 && r5[0] === s[0] && r5[1] === s[1] || c5.push(s);
        }
        function UQn(c5, s, r5) {
          for (var g5 = c5.length, b6 = [], S2 = 0; S2 < g5; S2++) {
            var A2 = c5[S2], k2 = c5[(S2 + 1) % g5], R6 = GQn(A2[0], A2[1], k2[0], k2[1], s.x, s.y, r5.x, r5.y);
            R6 && b6.push({ projPt: HQn(R6, s, r5), pt: R6, idx: S2 });
          }
          if (b6.length < 2)
            return [{ points: c5 }, { points: c5 }];
          b6.sort(function(mt, Mt) {
            return mt.projPt - Mt.projPt;
          });
          var B3 = b6[0], G3 = b6[b6.length - 1];
          if (G3.idx < B3.idx) {
            var Z3 = B3;
            B3 = G3, G3 = Z3;
          }
          for (var X3 = [B3.pt.x, B3.pt.y], tt = [G3.pt.x, G3.pt.y], it = [X3], pt = [tt], S2 = B3.idx + 1; S2 <= G3.idx; S2++)
            zX(it, c5[S2].slice());
          zX(it, tt), zX(it, X3);
          for (var S2 = G3.idx + 1; S2 <= B3.idx + g5; S2++)
            zX(pt, c5[S2 % g5].slice());
          return zX(pt, X3), zX(pt, tt), [{ points: it }, { points: pt }];
        }
        function mOe(c5) {
          var s = c5.points, r5 = [], g5 = [];
          PK(s, r5, g5);
          var b6 = new lc2(r5[0], r5[1], g5[0] - r5[0], g5[1] - r5[1]), S2 = b6.width, A2 = b6.height, k2 = b6.x, R6 = b6.y, B3 = new Bu(), G3 = new Bu();
          return S2 > A2 ? (B3.x = G3.x = k2 + S2 / 2, B3.y = R6, G3.y = R6 + A2) : (B3.y = G3.y = R6 + A2 / 2, B3.x = k2, G3.x = k2 + S2), UQn(s, B3, G3);
        }
        function VCt(c5, s, r5, g5) {
          if (r5 === 1)
            g5.push(s);
          else {
            var b6 = Math.floor(r5 / 2), S2 = c5(s);
            VCt(c5, S2[0], b6, g5), VCt(c5, S2[1], r5 - b6, g5);
          }
          return g5;
        }
        function qQn(c5, s) {
          for (var r5 = [], g5 = 0; g5 < s; g5++)
            r5.push(jut(c5));
          return r5;
        }
        function ZQn(c5, s) {
          s.setStyle(c5.style), s.z = c5.z, s.z2 = c5.z2, s.zlevel = c5.zlevel;
        }
        function $Qn(c5) {
          for (var s = [], r5 = 0; r5 < c5.length; )
            s.push([c5[r5++], c5[r5++]]);
          return s;
        }
        function YQn(c5, s) {
          var r5 = [], g5 = c5.shape, b6;
          switch (c5.type) {
            case "rect":
              WQn(g5, s, r5), b6 = zf2;
              break;
            case "sector":
              vOe(g5, s, r5), b6 = Ww;
              break;
            case "circle":
              vOe({ r0: 0, r: g5.r, startAngle: 0, endAngle: Math.PI * 2, cx: g5.cx, cy: g5.cy }, s, r5), b6 = Ww;
              break;
            default:
              var S2 = c5.getComputedTransform(), A2 = S2 ? Math.sqrt(Math.max(S2[0] * S2[0] + S2[1] * S2[1], S2[2] * S2[2] + S2[3] * S2[3])) : 1, k2 = Ha2(jQn(c5.getUpdatedPathProxy(), A2), function(Mt) {
                return $Qn(Mt);
              }), R6 = k2.length;
              if (R6 === 0)
                VCt(mOe, { points: k2[0] }, s, r5);
              else if (R6 === s)
                for (var B3 = 0; B3 < R6; B3++)
                  r5.push({ points: k2[B3] });
              else {
                var G3 = 0, Z3 = Ha2(k2, function(Mt) {
                  var kt = [], Gt = [];
                  PK(Mt, kt, Gt);
                  var Ot = (Gt[1] - kt[1]) * (Gt[0] - kt[0]);
                  return G3 += Ot, { poly: Mt, area: Ot };
                });
                Z3.sort(function(Mt, kt) {
                  return kt.area - Mt.area;
                });
                for (var X3 = s, B3 = 0; B3 < R6; B3++) {
                  var tt = Z3[B3];
                  if (X3 <= 0)
                    break;
                  var it = B3 === R6 - 1 ? X3 : Math.ceil(tt.area / G3 * s);
                  it < 0 || (VCt(mOe, { points: tt.poly }, it, r5), X3 -= it);
                }
              }
              b6 = Gb2;
              break;
          }
          if (!b6)
            return qQn(c5, s);
          for (var pt = [], B3 = 0; B3 < r5.length; B3++) {
            var mt = new b6();
            mt.setShape(r5[B3]), ZQn(c5, mt), pt.push(mt);
          }
          return pt;
        }
        function KQn(c5, s) {
          var r5 = c5.length, g5 = s.length;
          if (r5 === g5)
            return [c5, s];
          for (var b6 = [], S2 = [], A2 = r5 < g5 ? c5 : s, k2 = Math.min(r5, g5), R6 = Math.abs(g5 - r5) / 6, B3 = (k2 - 2) / 6, G3 = Math.ceil(R6 / B3) + 1, Z3 = [A2[0], A2[1]], X3 = R6, tt = 2; tt < k2; ) {
            var it = A2[tt - 2], pt = A2[tt - 1], mt = A2[tt++], Mt = A2[tt++], kt = A2[tt++], Gt = A2[tt++], Ot = A2[tt++], ce2 = A2[tt++];
            if (X3 <= 0) {
              Z3.push(mt, Mt, kt, Gt, Ot, ce2);
              continue;
            }
            for (var ae2 = Math.min(X3, G3 - 1) + 1, de2 = 1; de2 <= ae2; de2++) {
              var we2 = de2 / ae2;
              GC(it, mt, kt, Ot, we2, b6), GC(pt, Mt, Gt, ce2, we2, S2), it = b6[3], pt = S2[3], Z3.push(b6[1], S2[1], b6[2], S2[2], it, pt), mt = b6[5], Mt = S2[5], kt = b6[6], Gt = S2[6];
            }
            X3 -= ae2 - 1;
          }
          return A2 === c5 ? [Z3, s] : [c5, Z3];
        }
        function bOe(c5, s) {
          for (var r5 = c5.length, g5 = c5[r5 - 2], b6 = c5[r5 - 1], S2 = [], A2 = 0; A2 < s.length; )
            S2[A2++] = g5, S2[A2++] = b6;
          return S2;
        }
        function XQn(c5, s) {
          for (var r5, g5, b6, S2 = [], A2 = [], k2 = 0; k2 < Math.max(c5.length, s.length); k2++) {
            var R6 = c5[k2], B3 = s[k2], G3 = void 0, Z3 = void 0;
            R6 ? B3 ? (r5 = KQn(R6, B3), G3 = r5[0], Z3 = r5[1], g5 = G3, b6 = Z3) : (Z3 = bOe(b6 || R6, R6), G3 = R6) : (G3 = bOe(g5 || B3, B3), Z3 = B3), S2.push(G3), A2.push(Z3);
          }
          return [S2, A2];
        }
        function _Oe(c5) {
          for (var s = 0, r5 = 0, g5 = 0, b6 = c5.length, S2 = 0, A2 = b6 - 2; S2 < b6; A2 = S2, S2 += 2) {
            var k2 = c5[A2], R6 = c5[A2 + 1], B3 = c5[S2], G3 = c5[S2 + 1], Z3 = k2 * G3 - B3 * R6;
            s += Z3, r5 += (k2 + B3) * Z3, g5 += (R6 + G3) * Z3;
          }
          return s === 0 ? [c5[0] || 0, c5[1] || 0] : [r5 / s / 3, g5 / s / 3, s];
        }
        function QQn(c5, s, r5, g5) {
          for (var b6 = (c5.length - 2) / 6, S2 = 1 / 0, A2 = 0, k2 = c5.length, R6 = k2 - 2, B3 = 0; B3 < b6; B3++) {
            for (var G3 = B3 * 6, Z3 = 0, X3 = 0; X3 < k2; X3 += 2) {
              var tt = X3 === 0 ? G3 : (G3 + X3 - 2) % R6 + 2, it = c5[tt] - r5[0], pt = c5[tt + 1] - r5[1], mt = s[X3] - g5[0], Mt = s[X3 + 1] - g5[1], kt = mt - it, Gt = Mt - pt;
              Z3 += kt * kt + Gt * Gt;
            }
            Z3 < S2 && (S2 = Z3, A2 = B3);
          }
          return A2;
        }
        function JQn(c5) {
          for (var s = [], r5 = c5.length, g5 = 0; g5 < r5; g5 += 2)
            s[g5] = c5[r5 - g5 - 2], s[g5 + 1] = c5[r5 - g5 - 1];
          return s;
        }
        function tJn(c5, s, r5, g5) {
          for (var b6 = [], S2, A2 = 0; A2 < c5.length; A2++) {
            var k2 = c5[A2], R6 = s[A2], B3 = _Oe(k2), G3 = _Oe(R6);
            S2 == null && (S2 = B3[2] < 0 != G3[2] < 0);
            var Z3 = [], X3 = [], tt = 0, it = 1 / 0, pt = [], mt = k2.length;
            S2 && (k2 = JQn(k2));
            for (var Mt = QQn(k2, R6, B3, G3) * 6, kt = mt - 2, Gt = 0; Gt < kt; Gt += 2) {
              var Ot = (Mt + Gt) % kt + 2;
              Z3[Gt + 2] = k2[Ot] - B3[0], Z3[Gt + 3] = k2[Ot + 1] - B3[1];
            }
            if (Z3[0] = k2[Mt] - B3[0], Z3[1] = k2[Mt + 1] - B3[1], r5 > 0)
              for (var ce2 = g5 / r5, ae2 = -g5 / 2; ae2 <= g5 / 2; ae2 += ce2) {
                for (var de2 = Math.sin(ae2), we2 = Math.cos(ae2), Se2 = 0, Gt = 0; Gt < k2.length; Gt += 2) {
                  var Oe2 = Z3[Gt], je2 = Z3[Gt + 1], rn = R6[Gt] - G3[0], qe2 = R6[Gt + 1] - G3[1], An = rn * we2 - qe2 * de2, jn = rn * de2 + qe2 * we2;
                  pt[Gt] = An, pt[Gt + 1] = jn;
                  var _n = An - Oe2, Jr = jn - je2;
                  Se2 += _n * _n + Jr * Jr;
                }
                if (Se2 < it) {
                  it = Se2, tt = ae2;
                  for (var Qn = 0; Qn < pt.length; Qn++)
                    X3[Qn] = pt[Qn];
                }
              }
            else
              for (var rr = 0; rr < mt; rr += 2)
                X3[rr] = R6[rr] - G3[0], X3[rr + 1] = R6[rr + 1] - G3[1];
            b6.push({ from: Z3, to: X3, fromCp: B3, toCp: G3, rotation: -tt });
          }
          return b6;
        }
        function BCt(c5) {
          return c5.__isCombineMorphing;
        }
        var xOe = "__mOriginal_";
        function zCt(c5, s, r5) {
          var g5 = xOe + s, b6 = c5[g5] || c5[s];
          c5[g5] || (c5[g5] = c5[s]);
          var S2 = r5.replace, A2 = r5.after, k2 = r5.before;
          c5[s] = function() {
            var R6 = arguments, B3;
            return k2 && k2.apply(this, R6), S2 ? B3 = S2.apply(this, R6) : B3 = b6.apply(this, R6), A2 && A2.apply(this, R6), B3;
          };
        }
        function gft(c5, s) {
          var r5 = xOe + s;
          c5[r5] && (c5[s] = c5[r5], c5[r5] = null);
        }
        function wOe(c5, s) {
          for (var r5 = 0; r5 < c5.length; r5++)
            for (var g5 = c5[r5], b6 = 0; b6 < g5.length; ) {
              var S2 = g5[b6], A2 = g5[b6 + 1];
              g5[b6++] = s[0] * S2 + s[2] * A2 + s[4], g5[b6++] = s[1] * S2 + s[3] * A2 + s[5];
            }
        }
        function SOe(c5, s) {
          var r5 = c5.getUpdatedPathProxy(), g5 = s.getUpdatedPathProxy(), b6 = XQn(Iqt(r5), Iqt(g5)), S2 = b6[0], A2 = b6[1], k2 = c5.getComputedTransform(), R6 = s.getComputedTransform();
          function B3() {
            this.transform = null;
          }
          k2 && wOe(S2, k2), R6 && wOe(A2, R6), zCt(s, "updateTransform", { replace: B3 }), s.transform = null;
          var G3 = tJn(S2, A2, 10, Math.PI), Z3 = [];
          zCt(s, "buildPath", { replace: function(X3) {
            for (var tt = s.__morphT, it = 1 - tt, pt = [], mt = 0; mt < G3.length; mt++) {
              var Mt = G3[mt], kt = Mt.from, Gt = Mt.to, Ot = Mt.rotation * tt, ce2 = Mt.fromCp, ae2 = Mt.toCp, de2 = Math.sin(Ot), we2 = Math.cos(Ot);
              jY(pt, ce2, ae2, tt);
              for (var Se2 = 0; Se2 < kt.length; Se2 += 2) {
                var Oe2 = kt[Se2], je2 = kt[Se2 + 1], rn = Gt[Se2], qe2 = Gt[Se2 + 1], An = Oe2 * it + rn * tt, jn = je2 * it + qe2 * tt;
                Z3[Se2] = An * we2 - jn * de2 + pt[0], Z3[Se2 + 1] = An * de2 + jn * we2 + pt[1];
              }
              var _n = Z3[0], Jr = Z3[1];
              X3.moveTo(_n, Jr);
              for (var Se2 = 2; Se2 < kt.length; ) {
                var rn = Z3[Se2++], qe2 = Z3[Se2++], Qn = Z3[Se2++], rr = Z3[Se2++], Ar = Z3[Se2++], fi2 = Z3[Se2++];
                _n === rn && Jr === qe2 && Qn === Ar && rr === fi2 ? X3.lineTo(Ar, fi2) : X3.bezierCurveTo(rn, qe2, Qn, rr, Ar, fi2), _n = Ar, Jr = fi2;
              }
            }
          } });
        }
        function Eqt(c5, s, r5) {
          if (!c5 || !s)
            return s;
          var g5 = r5.done, b6 = r5.during;
          SOe(c5, s), s.__morphT = 0;
          function S2() {
            gft(s, "buildPath"), gft(s, "updateTransform"), s.__morphT = -1, s.createPathProxy(), s.dirtyShape();
          }
          return s.animateTo({ __morphT: 1 }, Cl({ during: function(A2) {
            s.dirtyShape(), b6 && b6(A2);
          }, done: function() {
            S2(), g5 && g5();
          } }, r5)), s;
        }
        function eJn(c5, s, r5, g5, b6, S2) {
          var A2 = 16;
          c5 = b6 === r5 ? 0 : Math.round(32767 * (c5 - r5) / (b6 - r5)), s = S2 === g5 ? 0 : Math.round(32767 * (s - g5) / (S2 - g5));
          for (var k2 = 0, R6, B3 = (1 << A2) / 2; B3 > 0; B3 /= 2) {
            var G3 = 0, Z3 = 0;
            (c5 & B3) > 0 && (G3 = 1), (s & B3) > 0 && (Z3 = 1), k2 += B3 * B3 * (3 * G3 ^ Z3), Z3 === 0 && (G3 === 1 && (c5 = B3 - 1 - c5, s = B3 - 1 - s), R6 = c5, c5 = s, s = R6);
          }
          return k2;
        }
        function jCt(c5) {
          var s = 1 / 0, r5 = 1 / 0, g5 = -1 / 0, b6 = -1 / 0, S2 = Ha2(c5, function(k2) {
            var R6 = k2.getBoundingRect(), B3 = k2.getComputedTransform(), G3 = R6.x + R6.width / 2 + (B3 ? B3[4] : 0), Z3 = R6.y + R6.height / 2 + (B3 ? B3[5] : 0);
            return s = Math.min(G3, s), r5 = Math.min(Z3, r5), g5 = Math.max(G3, g5), b6 = Math.max(Z3, b6), [G3, Z3];
          }), A2 = Ha2(S2, function(k2, R6) {
            return { cp: k2, z: eJn(k2[0], k2[1], s, r5, g5, b6), path: c5[R6] };
          });
          return A2.sort(function(k2, R6) {
            return k2.z - R6.z;
          }).map(function(k2) {
            return k2.path;
          });
        }
        function MOe(c5) {
          return YQn(c5.path, c5.count);
        }
        function kqt() {
          return { fromIndividuals: [], toIndividuals: [], count: 0 };
        }
        function nJn(c5, s, r5) {
          var g5 = [];
          function b6(ce2) {
            for (var ae2 = 0; ae2 < ce2.length; ae2++) {
              var de2 = ce2[ae2];
              BCt(de2) ? b6(de2.childrenRef()) : de2 instanceof Tc2 && g5.push(de2);
            }
          }
          b6(c5);
          var S2 = g5.length;
          if (!S2)
            return kqt();
          var A2 = r5.dividePath || MOe, k2 = A2({ path: s, count: S2 });
          if (k2.length !== S2)
            return console.error("Invalid morphing: unmatched splitted path"), kqt();
          g5 = jCt(g5), k2 = jCt(k2);
          for (var R6 = r5.done, B3 = r5.during, G3 = r5.individualDelay, Z3 = new YC(), X3 = 0; X3 < S2; X3++) {
            var tt = g5[X3], it = k2[X3];
            it.parent = s, it.copyTransform(Z3), G3 || SOe(tt, it);
          }
          s.__isCombineMorphing = true, s.childrenRef = function() {
            return k2;
          };
          function pt(ce2) {
            for (var ae2 = 0; ae2 < k2.length; ae2++)
              k2[ae2].addSelfToZr(ce2);
          }
          zCt(s, "addSelfToZr", { after: function(ce2) {
            pt(ce2);
          } }), zCt(s, "removeSelfFromZr", { after: function(ce2) {
            for (var ae2 = 0; ae2 < k2.length; ae2++)
              k2[ae2].removeSelfFromZr(ce2);
          } });
          function mt() {
            s.__isCombineMorphing = false, s.__morphT = -1, s.childrenRef = null, gft(s, "addSelfToZr"), gft(s, "removeSelfFromZr");
          }
          var Mt = k2.length;
          if (G3)
            for (var kt = Mt, Gt = function() {
              kt--, kt === 0 && (mt(), R6 && R6());
            }, X3 = 0; X3 < Mt; X3++) {
              var Ot = G3 ? Cl({ delay: (r5.delay || 0) + G3(X3, Mt, g5[X3], k2[X3]), done: Gt }, r5) : r5;
              Eqt(g5[X3], k2[X3], Ot);
            }
          else
            s.__morphT = 0, s.animateTo({ __morphT: 1 }, Cl({ during: function(ce2) {
              for (var ae2 = 0; ae2 < Mt; ae2++) {
                var de2 = k2[ae2];
                de2.__morphT = s.__morphT, de2.dirtyShape();
              }
              B3 && B3(ce2);
            }, done: function() {
              mt();
              for (var ce2 = 0; ce2 < c5.length; ce2++)
                gft(c5[ce2], "updateTransform");
              R6 && R6();
            } }, r5));
          return s.__zr && pt(s.__zr), { fromIndividuals: g5, toIndividuals: k2, count: Mt };
        }
        function rJn(c5, s, r5) {
          var g5 = s.length, b6 = [], S2 = r5.dividePath || MOe;
          function A2(tt) {
            for (var it = 0; it < tt.length; it++) {
              var pt = tt[it];
              BCt(pt) ? A2(pt.childrenRef()) : pt instanceof Tc2 && b6.push(pt);
            }
          }
          if (BCt(c5)) {
            A2(c5.childrenRef());
            var k2 = b6.length;
            if (k2 < g5)
              for (var R6 = 0, B3 = k2; B3 < g5; B3++)
                b6.push(jut(b6[R6++ % k2]));
            b6.length = g5;
          } else {
            b6 = S2({ path: c5, count: g5 });
            for (var G3 = c5.getComputedTransform(), B3 = 0; B3 < b6.length; B3++)
              b6[B3].setLocalTransform(G3);
            if (b6.length !== g5)
              return console.error("Invalid morphing: unmatched splitted path"), kqt();
          }
          b6 = jCt(b6), s = jCt(s);
          for (var Z3 = r5.individualDelay, B3 = 0; B3 < g5; B3++) {
            var X3 = Z3 ? Cl({ delay: (r5.delay || 0) + Z3(B3, g5, b6[B3], s[B3]) }, r5) : r5;
            Eqt(b6[B3], s[B3], X3);
          }
          return { fromIndividuals: b6, toIndividuals: s, count: s.length };
        }
        function COe(c5) {
          return ja2(c5[0]);
        }
        function TOe(c5, s) {
          for (var r5 = [], g5 = c5.length, b6 = 0; b6 < g5; b6++)
            r5.push({ one: c5[b6], many: [] });
          for (var b6 = 0; b6 < s.length; b6++) {
            var S2 = s[b6].length, A2 = void 0;
            for (A2 = 0; A2 < S2; A2++)
              r5[A2 % g5].many.push(s[b6][A2]);
          }
          for (var k2 = 0, b6 = g5 - 1; b6 >= 0; b6--)
            if (!r5[b6].many.length) {
              var R6 = r5[k2].many;
              if (R6.length <= 1)
                if (k2)
                  k2 = 0;
                else
                  return r5;
              var S2 = R6.length, B3 = Math.ceil(S2 / 2);
              r5[b6].many = R6.slice(B3, S2), r5[k2].many = R6.slice(0, B3), k2++;
            }
          return r5;
        }
        var iJn = { clone: function(c5) {
          for (var s = [], r5 = 1 - Math.pow(1 - c5.path.style.opacity, 1 / c5.count), g5 = 0; g5 < c5.count; g5++) {
            var b6 = jut(c5.path);
            b6.setStyle("opacity", r5), s.push(b6);
          }
          return s;
        }, split: null };
        function Pqt(c5, s, r5, g5, b6, S2) {
          if (!c5.length || !s.length)
            return;
          var A2 = q8("update", g5, b6);
          if (!(A2 && A2.duration > 0))
            return;
          var k2 = g5.getModel("universalTransition").get("delay"), R6 = Object.assign({ setToFinal: true }, A2), B3, G3;
          COe(c5) && (B3 = c5, G3 = s), COe(s) && (B3 = s, G3 = c5);
          function Z3(Mt, kt, Gt, Ot, ce2) {
            var ae2 = Mt.many, de2 = Mt.one;
            if (ae2.length === 1 && !ce2) {
              var we2 = kt ? ae2[0] : de2, Se2 = kt ? de2 : ae2[0];
              if (BCt(we2))
                Z3({ many: [we2], one: Se2 }, true, Gt, Ot, true);
              else {
                var Oe2 = k2 ? Cl({ delay: k2(Gt, Ot) }, R6) : R6;
                Eqt(we2, Se2, Oe2), S2(we2, Se2, we2, Se2, Oe2);
              }
            } else
              for (var je2 = Cl({ dividePath: iJn[r5], individualDelay: k2 && function(Jr, Qn, rr, Ar) {
                return k2(Jr + Gt, Ot);
              } }, R6), rn = kt ? nJn(ae2, de2, je2) : rJn(de2, ae2, je2), qe2 = rn.fromIndividuals, An = rn.toIndividuals, jn = qe2.length, _n = 0; _n < jn; _n++) {
                var Oe2 = k2 ? Cl({ delay: k2(_n, jn) }, R6) : R6;
                S2(qe2[_n], An[_n], kt ? ae2[_n] : Mt.one, kt ? Mt.one : ae2[_n], Oe2);
              }
          }
          for (var X3 = B3 ? B3 === c5 : c5.length > s.length, tt = B3 ? TOe(G3, B3) : TOe(X3 ? s : c5, [X3 ? c5 : s]), it = 0, pt = 0; pt < tt.length; pt++)
            it += tt[pt].many.length;
          for (var mt = 0, pt = 0; pt < tt.length; pt++)
            Z3(tt[pt], X3, mt, it), mt += tt[pt].many.length;
        }
        function RW(c5) {
          if (!c5)
            return [];
          if (ja2(c5)) {
            for (var s = [], r5 = 0; r5 < c5.length; r5++)
              s.push(RW(c5[r5]));
            return s;
          }
          var g5 = [];
          return c5.traverse(function(b6) {
            b6 instanceof Tc2 && !b6.disableMorphing && !b6.invisible && !b6.ignore && g5.push(b6);
          }), g5;
        }
        var AOe = 1e4, aJn = Df2();
        function oJn(c5) {
          for (var s = c5.dimensions, r5 = 0; r5 < s.length; r5++) {
            var g5 = c5.getDimensionInfo(s[r5]);
            if (g5 && g5.otherDims.itemGroupId === 0)
              return s[r5];
          }
        }
        function IOe(c5) {
          var s = [];
          return Ye2(c5, function(r5) {
            var g5 = r5.data;
            if (!(g5.count() > AOe))
              for (var b6 = g5.getIndices(), S2 = oJn(g5), A2 = 0; A2 < b6.length; A2++)
                s.push({ data: g5, dim: r5.dim || S2, divide: r5.divide, dataIndex: A2 });
          }), s;
        }
        function Lqt(c5, s, r5) {
          c5.traverse(function(g5) {
            g5 instanceof Tc2 && tv(g5, { style: { opacity: 0 } }, s, { dataIndex: r5, isFrom: true });
          });
        }
        function Oqt(c5) {
          if (c5.parent) {
            var s = c5.getComputedTransform();
            c5.setLocalTransform(s), c5.parent.remove(c5);
          }
        }
        function jX(c5) {
          c5.stopAnimation(), c5.isGroup && c5.traverse(function(s) {
            s.stopAnimation();
          });
        }
        function sJn(c5, s, r5) {
          var g5 = q8("update", r5, s);
          g5 && c5.traverse(function(b6) {
            if (b6 instanceof SM) {
              var S2 = fWt(b6);
              S2 && b6.animateFrom({ style: S2 }, g5);
            }
          });
        }
        function lJn(c5, s) {
          var r5 = c5.length;
          if (r5 !== s.length)
            return false;
          for (var g5 = 0; g5 < r5; g5++) {
            var b6 = c5[g5], S2 = s[g5];
            if (b6.data.getId(b6.dataIndex) !== S2.data.getId(S2.dataIndex))
              return false;
          }
          return true;
        }
        function DOe(c5, s, r5) {
          var g5 = IOe(c5), b6 = IOe(s);
          function S2(Mt, kt, Gt, Ot, ce2) {
            (Gt || Mt) && kt.animateFrom({ style: Gt && Gt !== Mt ? sa2(sa2({}, Gt.style), Mt.style) : Mt.style }, ce2);
          }
          function A2(Mt) {
            for (var kt = 0; kt < Mt.length; kt++)
              if (Mt[kt].dim)
                return Mt[kt].dim;
          }
          var k2 = A2(g5), R6 = A2(b6), B3 = false;
          function G3(Mt, kt) {
            return function(Gt) {
              var Ot = Gt.data, ce2 = Gt.dataIndex;
              if (kt)
                return Ot.getId(ce2);
              var ae2 = Ot.hostModel && Ot.hostModel.get("dataGroupId"), de2 = Mt ? k2 || R6 : R6 || k2, we2 = de2 && Ot.getDimensionInfo(de2), Se2 = we2 && we2.ordinalMeta;
              if (we2) {
                var Oe2 = Ot.get(we2.name, ce2);
                return Se2 && Se2.categories[Oe2] || Oe2 + "";
              }
              var je2 = Ot.getRawDataItem(ce2);
              return je2 && je2.groupId ? je2.groupId + "" : ae2 || Ot.getId(ce2);
            };
          }
          var Z3 = lJn(g5, b6), X3 = {};
          if (!Z3)
            for (var tt = 0; tt < b6.length; tt++) {
              var it = b6[tt], pt = it.data.getItemGraphicEl(it.dataIndex);
              pt && (X3[pt.id] = true);
            }
          function mt(Mt, kt) {
            var Gt = g5[kt], Ot = b6[Mt], ce2 = Ot.data.hostModel, ae2 = Gt.data.getItemGraphicEl(Gt.dataIndex), de2 = Ot.data.getItemGraphicEl(Ot.dataIndex);
            if (ae2 === de2) {
              de2 && sJn(de2, Ot.dataIndex, ce2);
              return;
            }
            ae2 && X3[ae2.id] || de2 && (jX(de2), ae2 ? (jX(ae2), Oqt(ae2), B3 = true, Pqt(RW(ae2), RW(de2), Ot.divide, ce2, Mt, S2)) : Lqt(de2, ce2, Mt));
          }
          new wR(g5, b6, G3(true, Z3), G3(false, Z3), null, "multiple").update(mt).updateManyToOne(function(Mt, kt) {
            var Gt = b6[Mt], Ot = Gt.data, ce2 = Ot.hostModel, ae2 = Ot.getItemGraphicEl(Gt.dataIndex), de2 = jp(Ha2(kt, function(we2) {
              return g5[we2].data.getItemGraphicEl(g5[we2].dataIndex);
            }), function(we2) {
              return we2 && we2 !== ae2 && !X3[we2.id];
            });
            ae2 && (jX(ae2), de2.length ? (Ye2(de2, function(we2) {
              jX(we2), Oqt(we2);
            }), B3 = true, Pqt(RW(de2), RW(ae2), Gt.divide, ce2, Mt, S2)) : Lqt(ae2, ce2, Gt.dataIndex));
          }).updateOneToMany(function(Mt, kt) {
            var Gt = g5[kt], Ot = Gt.data.getItemGraphicEl(Gt.dataIndex);
            if (!(Ot && X3[Ot.id])) {
              var ce2 = jp(Ha2(Mt, function(de2) {
                return b6[de2].data.getItemGraphicEl(b6[de2].dataIndex);
              }), function(de2) {
                return de2 && de2 !== Ot;
              }), ae2 = b6[Mt[0]].data.hostModel;
              ce2.length && (Ye2(ce2, function(de2) {
                return jX(de2);
              }), Ot ? (jX(Ot), Oqt(Ot), B3 = true, Pqt(RW(Ot), RW(ce2), Gt.divide, ae2, Mt[0], S2)) : Ye2(ce2, function(de2) {
                return Lqt(de2, ae2, Mt[0]);
              }));
            }
          }).updateManyToMany(function(Mt, kt) {
            new wR(kt, Mt, function(Gt) {
              return g5[Gt].data.getId(g5[Gt].dataIndex);
            }, function(Gt) {
              return b6[Gt].data.getId(b6[Gt].dataIndex);
            }).update(function(Gt, Ot) {
              mt(Mt[Gt], kt[Ot]);
            }).execute();
          }).execute(), B3 && Ye2(s, function(Mt) {
            var kt = Mt.data, Gt = kt.hostModel, Ot = Gt && r5.getViewOfSeriesModel(Gt), ce2 = q8("update", Gt, 0);
            Ot && Gt.isAnimationEnabled() && ce2 && ce2.duration > 0 && Ot.group.traverse(function(ae2) {
              ae2 instanceof Tc2 && !ae2.animators.length && ae2.animateFrom({ style: { opacity: 0 } }, ce2);
            });
          });
        }
        function EOe(c5) {
          var s = c5.getModel("universalTransition").get("seriesKey");
          return s || c5.id;
        }
        function kOe(c5) {
          return ja2(c5) ? c5.sort().join(",") : c5;
        }
        function d9(c5) {
          if (c5.hostModel)
            return c5.hostModel.getModel("universalTransition").get("divideShape");
        }
        function uJn(c5, s) {
          var r5 = Ps(), g5 = Ps(), b6 = Ps();
          return Ye2(c5.oldSeries, function(S2, A2) {
            var k2 = c5.oldData[A2], R6 = EOe(S2), B3 = kOe(R6);
            g5.set(B3, k2), ja2(R6) && Ye2(R6, function(G3) {
              b6.set(G3, { data: k2, key: B3 });
            });
          }), Ye2(s.updatedSeries, function(S2) {
            if (S2.isUniversalTransitionEnabled() && S2.isAnimationEnabled()) {
              var A2 = S2.getData(), k2 = EOe(S2), R6 = kOe(k2), B3 = g5.get(R6);
              if (B3)
                r5.set(R6, { oldSeries: [{ divide: d9(B3), data: B3 }], newSeries: [{ divide: d9(A2), data: A2 }] });
              else if (ja2(k2)) {
                var G3 = [];
                Ye2(k2, function(tt) {
                  var it = g5.get(tt);
                  it && G3.push({ divide: d9(it), data: it });
                }), G3.length && r5.set(R6, { oldSeries: G3, newSeries: [{ data: A2, divide: d9(A2) }] });
              } else {
                var Z3 = b6.get(k2);
                if (Z3) {
                  var X3 = r5.get(Z3.key);
                  X3 || (X3 = { oldSeries: [{ data: Z3.data, divide: d9(Z3.data) }], newSeries: [] }, r5.set(Z3.key, X3)), X3.newSeries.push({ data: A2, divide: d9(A2) });
                }
              }
            }
          }), r5;
        }
        function POe(c5, s) {
          for (var r5 = 0; r5 < c5.length; r5++) {
            var g5 = s.seriesIndex != null && s.seriesIndex === c5[r5].seriesIndex || s.seriesId != null && s.seriesId === c5[r5].id;
            if (g5)
              return r5;
          }
        }
        function cJn(c5, s, r5, g5) {
          var b6 = [], S2 = [];
          Ye2(xp(c5.from), function(A2) {
            var k2 = POe(s.oldSeries, A2);
            k2 >= 0 && b6.push({ data: s.oldData[k2], divide: d9(s.oldData[k2]), dim: A2.dimension });
          }), Ye2(xp(c5.to), function(A2) {
            var k2 = POe(r5.updatedSeries, A2);
            if (k2 >= 0) {
              var R6 = r5.updatedSeries[k2].getData();
              S2.push({ data: R6, divide: d9(R6), dim: A2.dimension });
            }
          }), b6.length > 0 && S2.length > 0 && DOe(b6, S2, g5);
        }
        function fJn(c5) {
          c5.registerUpdateLifecycle("series:beforeupdate", function(s, r5, g5) {
            Ye2(xp(g5.seriesTransition), function(b6) {
              Ye2(xp(b6.to), function(S2) {
                for (var A2 = g5.updatedSeries, k2 = 0; k2 < A2.length; k2++)
                  (S2.seriesIndex != null && S2.seriesIndex === A2[k2].seriesIndex || S2.seriesId != null && S2.seriesId === A2[k2].id) && (A2[k2][sMt] = true);
              });
            });
          }), c5.registerUpdateLifecycle("series:transition", function(s, r5, g5) {
            var b6 = aJn(r5);
            if (b6.oldSeries && g5.updatedSeries && g5.optionChanged) {
              var S2 = g5.seriesTransition;
              if (S2)
                Ye2(xp(S2), function(X3) {
                  cJn(X3, b6, g5, r5);
                });
              else {
                var A2 = uJn(b6, g5);
                Ye2(A2.keys(), function(X3) {
                  var tt = A2.get(X3);
                  DOe(tt.oldSeries, tt.newSeries, r5);
                });
              }
              Ye2(g5.updatedSeries, function(X3) {
                X3[sMt] && (X3[sMt] = false);
              });
            }
            for (var k2 = s.getSeries(), R6 = b6.oldSeries = [], B3 = b6.oldData = [], G3 = 0; G3 < k2.length; G3++) {
              var Z3 = k2[G3].getData();
              Z3.count() < AOe && (R6.push(k2[G3]), B3.push(Z3));
            }
          });
        }
        Fc2([D7n]), Fc2([w7n]), Fc2([J7n, yVn, DVn, yBn, OBn, Izn, ajn, Ujn, bWn, IWn, BWn, GGn, vHn, EHn, YHn, nUn, _Un, EUn, GUn, XUn, cqn, $qn]), Fc2(yZn), Fc2(XZn), Fc2(Ike), Fc2(d$n), Fc2(X5e), Fc2(x$n), Fc2(E$n), Fc2(kYn), Fc2(tKn), Fc2(oft), Fc2(_Kn), Fc2(SKn), Fc2(VKn), Fc2($Kn), Fc2(nXn), Fc2(cXn), Fc2(MXn), Fc2(qXn), Fc2(WLe), Fc2(qLe), Fc2(bQn), Fc2(lOe), Fc2(cOe), Fc2(MQn), Fc2(FQn), Fc2(zQn), Fc2(fJn), Fc2(j9n);
        function hJn(c5) {
          const { defaultOptions: s } = c5 != null ? c5 : {}, r5 = O2.useRef(null), g5 = O2.useRef(), b6 = O2.useRef(s);
          return O2.useEffect(() => {
            if (!r5.current)
              return;
            const S2 = r8n(r5.current);
            g5.current = S2, b6.current && S2.setOption(b6.current);
          }, []), O2.useEffect(() => () => {
            var S2, A2, k2, R6;
            (A2 = (S2 = g5.current) == null ? void 0 : S2.dispose) == null || A2.call(S2), (R6 = (k2 = g5.current) == null ? void 0 : k2.off) == null || R6.call(k2, "*"), g5.current = void 0;
          }, []), hr("resize", () => {
            requestAnimationFrame(() => {
              var S2, A2;
              (A2 = (S2 = g5 == null ? void 0 : g5.current) == null ? void 0 : S2.resize) == null || A2.call(S2);
            });
          }), { chart: g5, container: r5 };
        }
        class pJn {
          constructor() {
            E(this, "chartsEmitters", /* @__PURE__ */ new Map()), E(this, "add", (s, r5, g5, b6) => {
              r5 && g5 ? this.chartsEmitters.set(s, { chart: r5, option: g5, title: b6 }) : console.log("\u6DFB\u52A0\u5931\u8D25");
            }), E(this, "get", (s) => this.chartsEmitters.get(s)), E(this, "clear", () => {
              this.chartsEmitters.clear();
            }), E(this, "delete", (s) => {
              this.chartsEmitters.delete(s);
            }), E(this, "list", () => {
              var s, r5, g5;
              const b6 = [];
              for (const S2 of this.chartsEmitters.keys())
                b6.push({ id: S2, chart: (s = this.chartsEmitters.get(S2)) == null ? void 0 : s.chart, option: (r5 = this.chartsEmitters.get(S2)) == null ? void 0 : r5.option, title: (g5 = this.chartsEmitters.get(S2)) == null ? void 0 : g5.title });
              return b6;
            });
          }
        }
        const dJn = new pJn();
        var WCt = { exports: {} };
        /**
        * @license
        * Lodash <https://lodash.com/>
        * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
        * Released under MIT license <https://lodash.com/license>
        * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
        * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
        */
        (function(c5, s) {
          (function() {
            var r5, g5 = "4.17.21", b6 = 200, S2 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", A2 = "Expected a function", k2 = "Invalid `variable` option passed into `_.template`", R6 = "__lodash_hash_undefined__", B3 = 500, G3 = "__lodash_placeholder__", Z3 = 1, X3 = 2, tt = 4, it = 1, pt = 2, mt = 1, Mt = 2, kt = 4, Gt = 8, Ot = 16, ce2 = 32, ae2 = 64, de2 = 128, we2 = 256, Se2 = 512, Oe2 = 30, je2 = "...", rn = 800, qe2 = 16, An = 1, jn = 2, _n = 3, Jr = 1 / 0, Qn = 9007199254740991, rr = 17976931348623157e292, Ar = 0 / 0, fi2 = 4294967295, mi2 = fi2 - 1, Oo = fi2 >>> 1, Ts = [["ary", de2], ["bind", mt], ["bindKey", Mt], ["curry", Gt], ["curryRight", Ot], ["flip", Se2], ["partial", ce2], ["partialRight", ae2], ["rearg", we2]], gl = "[object Arguments]", nl = "[object Array]", rl = "[object AsyncFunction]", ss = "[object Boolean]", Us = "[object Date]", sl = "[object DOMException]", ws = "[object Error]", Ll = "[object Function]", dh2 = "[object GeneratorFunction]", hu = "[object Map]", Nh2 = "[object Number]", cp = "[object Null]", Xh2 = "[object Object]", om = "[object Promise]", Sv = "[object Proxy]", U1 = "[object RegExp]", Jd2 = "[object Set]", jv = "[object String]", Mv = "[object Symbol]", fT = "[object Undefined]", yo = "[object WeakMap]", oa2 = "[object WeakSet]", ea2 = "[object ArrayBuffer]", _o = "[object DataView]", Vs = "[object Float32Array]", ru = "[object Float64Array]", kf2 = "[object Int8Array]", wf2 = "[object Int16Array]", rd2 = "[object Int32Array]", Cv = "[object Uint8Array]", kg2 = "[object Uint8ClampedArray]", ty = "[object Uint16Array]", Pg2 = "[object Uint32Array]", $b2 = /\b__p \+= '';/g, Mx = /\b(__p \+=) '' \+/g, _2 = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Cx = /&(?:amp|lt|gt|quot|#39);/g, p0 = /[&<>"']/g, Qh2 = RegExp(Cx.source), sm = RegExp(p0.source), q1 = /<%-([\s\S]+?)%>/g, AM = /<%([\s\S]+?)%>/g, Xw = /<%=([\s\S]+?)%>/g, Tx = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, x22 = /^\w*$/, cD = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, fD = /[\\^$.*+?()[\]{}|]/g, Dft = RegExp(fD.source), B32 = /^\s+/, Eft = /\s/, kft = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Pft = /\{\n\/\* \[wrapped with (.+)\] \*/, Lft = /,? & /, m9 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, Sr = /[()=,{}\[\]\/\s]/, Ir = /\\(\\)?/g, Fn = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, lr = /\w*$/, er = /^[-+]0x[0-9a-f]+$/i, Gi2 = /^0b[01]+$/i, zi2 = /^\[object .+?Constructor\]$/, Ta2 = /^0o[0-7]+$/i, Li2 = /^(?:0|[1-9]\d*)$/, zo = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, ql = /($^)/, jf2 = /['\n\r\u2028\u2029\\]/g, Ic2 = "\\ud800-\\udfff", Ad2 = "\\u0300-\\u036f", jc2 = "\\ufe20-\\ufe2f", dd2 = "\\u20d0-\\u20ff", Bd2 = Ad2 + jc2 + dd2, du = "\\u2700-\\u27bf", id2 = "a-z\\xdf-\\xf6\\xf8-\\xff", Ax = "\\xac\\xb1\\xd7\\xf7", hT = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", b9 = "\\u2000-\\u206f", Qw = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", Rk = "A-Z\\xc0-\\xd6\\xd8-\\xde", Nk = "\\ufe0e\\ufe0f", ey = Ax + hT + b9 + Qw, hD = "['\u2019]", LR = "[" + Ic2 + "]", Fk = "[" + ey + "]", OR = "[" + Bd2 + "]", z32 = "\\d+", Z1 = "[" + du + "]", RR = "[" + id2 + "]", pD = "[^" + Ic2 + ey + z32 + du + id2 + Rk + "]", NR = "\\ud83c[\\udffb-\\udfff]", j3 = "(?:" + OR + "|" + NR + ")", IM = "[^" + Ic2 + "]", BW = "(?:\\ud83c[\\udde6-\\uddff]){2}", zW = "[\\ud800-\\udbff][\\udc00-\\udfff]", Yb2 = "[" + Rk + "]", gTt = "\\u200d", dD = "(?:" + RR + "|" + pD + ")", YX = "(?:" + Yb2 + "|" + pD + ")", Oft = "(?:" + hD + "(?:d|ll|m|re|s|t|ve))?", vTt = "(?:" + hD + "(?:D|LL|M|RE|S|T|VE))?", yTt = j3 + "?", mTt = "[" + Nk + "]?", bTt = "(?:" + gTt + "(?:" + [IM, BW, zW].join("|") + ")" + mTt + yTt + ")*", _Tt = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", TZt = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Rft = mTt + yTt + bTt, KX = "(?:" + [Z1, BW, zW].join("|") + ")" + Rft, AZt = "(?:" + [IM + OR + "?", OR, BW, zW, LR].join("|") + ")", xTt = RegExp(hD, "g"), wTt = RegExp(OR, "g"), XX = RegExp(NR + "(?=" + NR + ")|" + AZt + Rft, "g"), Nft = RegExp([Yb2 + "?" + RR + "+" + Oft + "(?=" + [Fk, Yb2, "$"].join("|") + ")", YX + "+" + vTt + "(?=" + [Fk, Yb2 + dD, "$"].join("|") + ")", Yb2 + "?" + dD + "+" + Oft, Yb2 + "+" + vTt, TZt, _Tt, z32, KX].join("|"), "g"), Fft = RegExp("[" + gTt + Ic2 + Bd2 + Nk + "]"), Kb2 = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, Vft = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], STt = -1, Tv = {};
            Tv[Vs] = Tv[ru] = Tv[kf2] = Tv[wf2] = Tv[rd2] = Tv[Cv] = Tv[kg2] = Tv[ty] = Tv[Pg2] = true, Tv[gl] = Tv[nl] = Tv[ea2] = Tv[ss] = Tv[_o] = Tv[Us] = Tv[ws] = Tv[Ll] = Tv[hu] = Tv[Nh2] = Tv[Xh2] = Tv[U1] = Tv[Jd2] = Tv[jv] = Tv[yo] = false;
            var ev = {};
            ev[gl] = ev[nl] = ev[ea2] = ev[_o] = ev[ss] = ev[Us] = ev[Vs] = ev[ru] = ev[kf2] = ev[wf2] = ev[rd2] = ev[hu] = ev[Nh2] = ev[Xh2] = ev[U1] = ev[Jd2] = ev[jv] = ev[Mv] = ev[Cv] = ev[kg2] = ev[ty] = ev[Pg2] = true, ev[ws] = ev[Ll] = ev[yo] = false;
            var gD = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, MTt = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, IZt = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, CTt = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, Bft = parseFloat, TTt = parseInt, QX = typeof tn == "object" && tn && tn.Object === Object && tn, DZt = typeof self == "object" && self && self.Object === Object && self, Xm = QX || DZt || Function("return this")(), zft = s && !s.nodeType && s, W32 = zft && true && c5 && !c5.nodeType && c5, jft = W32 && W32.exports === zft, jW = jft && QX.process, w22 = function() {
              try {
                var bi2 = W32 && W32.require && W32.require("util").types;
                return bi2 || jW && jW.binding && jW.binding("util");
              } catch {
              }
            }(), Wft = w22 && w22.isArrayBuffer, ATt = w22 && w22.isDate, ITt = w22 && w22.isMap, DTt = w22 && w22.isRegExp, _9 = w22 && w22.isSet, ETt = w22 && w22.isTypedArray;
            function S22(bi2, Ua2, _a2) {
              switch (_a2.length) {
                case 0:
                  return bi2.call(Ua2);
                case 1:
                  return bi2.call(Ua2, _a2[0]);
                case 2:
                  return bi2.call(Ua2, _a2[0], _a2[1]);
                case 3:
                  return bi2.call(Ua2, _a2[0], _a2[1], _a2[2]);
              }
              return bi2.apply(Ua2, _a2);
            }
            function JX(bi2, Ua2, _a2, Dl) {
              for (var vc2 = -1, gd2 = bi2 == null ? 0 : bi2.length; ++vc2 < gd2; ) {
                var ny = bi2[vc2];
                Ua2(Dl, ny, _a2(ny), bi2);
              }
              return Dl;
            }
            function Jw(bi2, Ua2) {
              for (var _a2 = -1, Dl = bi2 == null ? 0 : bi2.length; ++_a2 < Dl && Ua2(bi2[_a2], _a2, bi2) !== false; )
                ;
              return bi2;
            }
            function kTt(bi2, Ua2) {
              for (var _a2 = bi2 == null ? 0 : bi2.length; _a2-- && Ua2(bi2[_a2], _a2, bi2) !== false; )
                ;
              return bi2;
            }
            function PTt(bi2, Ua2) {
              for (var _a2 = -1, Dl = bi2 == null ? 0 : bi2.length; ++_a2 < Dl; )
                if (!Ua2(bi2[_a2], _a2, bi2))
                  return false;
              return true;
            }
            function G32(bi2, Ua2) {
              for (var _a2 = -1, Dl = bi2 == null ? 0 : bi2.length, vc2 = 0, gd2 = []; ++_a2 < Dl; ) {
                var ny = bi2[_a2];
                Ua2(ny, _a2, bi2) && (gd2[vc2++] = ny);
              }
              return gd2;
            }
            function FR(bi2, Ua2) {
              var _a2 = bi2 == null ? 0 : bi2.length;
              return !!_a2 && Vk(bi2, Ua2, 0) > -1;
            }
            function Gft(bi2, Ua2, _a2) {
              for (var Dl = -1, vc2 = bi2 == null ? 0 : bi2.length; ++Dl < vc2; )
                if (_a2(Ua2, bi2[Dl]))
                  return true;
              return false;
            }
            function Wv(bi2, Ua2) {
              for (var _a2 = -1, Dl = bi2 == null ? 0 : bi2.length, vc2 = Array(Dl); ++_a2 < Dl; )
                vc2[_a2] = Ua2(bi2[_a2], _a2, bi2);
              return vc2;
            }
            function H3(bi2, Ua2) {
              for (var _a2 = -1, Dl = Ua2.length, vc2 = bi2.length; ++_a2 < Dl; )
                bi2[vc2 + _a2] = Ua2[_a2];
              return bi2;
            }
            function tQ(bi2, Ua2, _a2, Dl) {
              var vc2 = -1, gd2 = bi2 == null ? 0 : bi2.length;
              for (Dl && gd2 && (_a2 = bi2[++vc2]); ++vc2 < gd2; )
                _a2 = Ua2(_a2, bi2[vc2], vc2, bi2);
              return _a2;
            }
            function EZt(bi2, Ua2, _a2, Dl) {
              var vc2 = bi2 == null ? 0 : bi2.length;
              for (Dl && vc2 && (_a2 = bi2[--vc2]); vc2--; )
                _a2 = Ua2(_a2, bi2[vc2], vc2, bi2);
              return _a2;
            }
            function L0(bi2, Ua2) {
              for (var _a2 = -1, Dl = bi2 == null ? 0 : bi2.length; ++_a2 < Dl; )
                if (Ua2(bi2[_a2], _a2, bi2))
                  return true;
              return false;
            }
            var WW = HW("length");
            function LTt(bi2) {
              return bi2.split("");
            }
            function GW(bi2) {
              return bi2.match(m9) || [];
            }
            function eQ(bi2, Ua2, _a2) {
              var Dl;
              return _a2(bi2, function(vc2, gd2, ny) {
                if (Ua2(vc2, gd2, ny))
                  return Dl = gd2, false;
              }), Dl;
            }
            function x9(bi2, Ua2, _a2, Dl) {
              for (var vc2 = bi2.length, gd2 = _a2 + (Dl ? 1 : -1); Dl ? gd2-- : ++gd2 < vc2; )
                if (Ua2(bi2[gd2], gd2, bi2))
                  return gd2;
              return -1;
            }
            function Vk(bi2, Ua2, _a2) {
              return Ua2 === Ua2 ? NZt(bi2, Ua2, _a2) : x9(bi2, nQ, _a2);
            }
            function kZt(bi2, Ua2, _a2, Dl) {
              for (var vc2 = _a2 - 1, gd2 = bi2.length; ++vc2 < gd2; )
                if (Dl(bi2[vc2], Ua2))
                  return vc2;
              return -1;
            }
            function nQ(bi2) {
              return bi2 !== bi2;
            }
            function OTt(bi2, Ua2) {
              var _a2 = bi2 == null ? 0 : bi2.length;
              return _a2 ? qW(bi2, Ua2) / _a2 : Ar;
            }
            function HW(bi2) {
              return function(Ua2) {
                return Ua2 == null ? r5 : Ua2[bi2];
              };
            }
            function UW(bi2) {
              return function(Ua2) {
                return bi2 == null ? r5 : bi2[Ua2];
              };
            }
            function Id2(bi2, Ua2, _a2, Dl, vc2) {
              return vc2(bi2, function(gd2, ny, vd2) {
                _a2 = Dl ? (Dl = false, gd2) : Ua2(_a2, gd2, ny, vd2);
              }), _a2;
            }
            function Qm(bi2, Ua2) {
              var _a2 = bi2.length;
              for (bi2.sort(Ua2); _a2--; )
                bi2[_a2] = bi2[_a2].value;
              return bi2;
            }
            function qW(bi2, Ua2) {
              for (var _a2, Dl = -1, vc2 = bi2.length; ++Dl < vc2; ) {
                var gd2 = Ua2(bi2[Dl]);
                gd2 !== r5 && (_a2 = _a2 === r5 ? gd2 : _a2 + gd2);
              }
              return _a2;
            }
            function ZW(bi2, Ua2) {
              for (var _a2 = -1, Dl = Array(bi2); ++_a2 < bi2; )
                Dl[_a2] = Ua2(_a2);
              return Dl;
            }
            function rQ(bi2, Ua2) {
              return Wv(Ua2, function(_a2) {
                return [_a2, bi2[_a2]];
              });
            }
            function $W(bi2) {
              return bi2 && bi2.slice(0, Uft(bi2) + 1).replace(B32, "");
            }
            function Xb2(bi2) {
              return function(Ua2) {
                return bi2(Ua2);
              };
            }
            function w9(bi2, Ua2) {
              return Wv(Ua2, function(_a2) {
                return bi2[_a2];
              });
            }
            function U32(bi2, Ua2) {
              return bi2.has(Ua2);
            }
            function iQ(bi2, Ua2) {
              for (var _a2 = -1, Dl = bi2.length; ++_a2 < Dl && Vk(Ua2, bi2[_a2], 0) > -1; )
                ;
              return _a2;
            }
            function YW(bi2, Ua2) {
              for (var _a2 = bi2.length; _a2-- && Vk(Ua2, bi2[_a2], 0) > -1; )
                ;
              return _a2;
            }
            function aQ(bi2, Ua2) {
              for (var _a2 = bi2.length, Dl = 0; _a2--; )
                bi2[_a2] === Ua2 && ++Dl;
              return Dl;
            }
            var oQ = UW(gD), PZt = UW(MTt);
            function sQ(bi2) {
              return "\\" + CTt[bi2];
            }
            function lQ(bi2, Ua2) {
              return bi2 == null ? r5 : bi2[Ua2];
            }
            function S9(bi2) {
              return Fft.test(bi2);
            }
            function LZt(bi2) {
              return Kb2.test(bi2);
            }
            function OZt(bi2) {
              for (var Ua2, _a2 = []; !(Ua2 = bi2.next()).done; )
                _a2.push(Ua2.value);
              return _a2;
            }
            function Hft(bi2) {
              var Ua2 = -1, _a2 = Array(bi2.size);
              return bi2.forEach(function(Dl, vc2) {
                _a2[++Ua2] = [vc2, Dl];
              }), _a2;
            }
            function tS(bi2, Ua2) {
              return function(_a2) {
                return bi2(Ua2(_a2));
              };
            }
            function Bk(bi2, Ua2) {
              for (var _a2 = -1, Dl = bi2.length, vc2 = 0, gd2 = []; ++_a2 < Dl; ) {
                var ny = bi2[_a2];
                (ny === Ua2 || ny === G3) && (bi2[_a2] = G3, gd2[vc2++] = _a2);
              }
              return gd2;
            }
            function M9(bi2) {
              var Ua2 = -1, _a2 = Array(bi2.size);
              return bi2.forEach(function(Dl) {
                _a2[++Ua2] = Dl;
              }), _a2;
            }
            function RZt(bi2) {
              var Ua2 = -1, _a2 = Array(bi2.size);
              return bi2.forEach(function(Dl) {
                _a2[++Ua2] = [Dl, Dl];
              }), _a2;
            }
            function NZt(bi2, Ua2, _a2) {
              for (var Dl = _a2 - 1, vc2 = bi2.length; ++Dl < vc2; )
                if (bi2[Dl] === Ua2)
                  return Dl;
              return -1;
            }
            function FZt(bi2, Ua2, _a2) {
              for (var Dl = _a2 + 1; Dl--; )
                if (bi2[Dl] === Ua2)
                  return Dl;
              return Dl;
            }
            function C9(bi2) {
              return S9(bi2) ? wp(bi2) : WW(bi2);
            }
            function pT(bi2) {
              return S9(bi2) ? T9(bi2) : LTt(bi2);
            }
            function Uft(bi2) {
              for (var Ua2 = bi2.length; Ua2-- && Eft.test(bi2.charAt(Ua2)); )
                ;
              return Ua2;
            }
            var VZt = UW(IZt);
            function wp(bi2) {
              for (var Ua2 = XX.lastIndex = 0; XX.test(bi2); )
                ++Ua2;
              return Ua2;
            }
            function T9(bi2) {
              return bi2.match(XX) || [];
            }
            function Av(bi2) {
              return bi2.match(Nft) || [];
            }
            var KW = function bi2(Ua2) {
              Ua2 = Ua2 == null ? Xm : q32.defaults(Xm.Object(), Ua2, q32.pick(Xm, Vft));
              var _a2 = Ua2.Array, Dl = Ua2.Date, vc2 = Ua2.Error, gd2 = Ua2.Function, ny = Ua2.Math, vd2 = Ua2.Object, qft = Ua2.RegExp, uQ = Ua2.String, DM = Ua2.TypeError, A9 = _a2.prototype, BZt = gd2.prototype, I9 = vd2.prototype, D9 = Ua2["__core-js_shared__"], Qb = BZt.toString, zd2 = I9.hasOwnProperty, lm = 0, RTt = function() {
                var st = /[^.]+$/.exec(D9 && D9.keys && D9.keys.IE_PROTO || "");
                return st ? "Symbol(src)_1." + st : "";
              }(), XW = I9.toString, zZt = Qb.call(vd2), NTt = Xm._, jZt = qft("^" + Qb.call(zd2).replace(fD, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), cQ = jft ? Ua2.Buffer : r5, Z32 = Ua2.Symbol, QW = Ua2.Uint8Array, Zft = cQ ? cQ.allocUnsafe : r5, JW = tS(vd2.getPrototypeOf, vd2), FTt = vd2.create, fQ = I9.propertyIsEnumerable, $3 = A9.splice, VTt = Z32 ? Z32.isConcatSpreadable : r5, tG = Z32 ? Z32.iterator : r5, EM = Z32 ? Z32.toStringTag : r5, hQ = function() {
                try {
                  var st = nv(vd2, "defineProperty");
                  return st({}, "", {}), st;
                } catch {
                }
              }(), WZt = Ua2.clearTimeout !== Xm.clearTimeout && Ua2.clearTimeout, fp = Dl && Dl.now !== Xm.Date.now && Dl.now, GZt = Ua2.setTimeout !== Xm.setTimeout && Ua2.setTimeout, pQ = ny.ceil, dQ = ny.floor, $ft = vd2.getOwnPropertySymbols, HZt = cQ ? cQ.isBuffer : r5, BTt = Ua2.isFinite, UZt = A9.join, qZt = tS(vd2.keys, vd2), um = ny.max, Jb2 = ny.min, ZZt = Dl.now, $Zt = Ua2.parseInt, zTt = ny.random, YZt = A9.reverse, eG = nv(Ua2, "DataView"), nG = nv(Ua2, "Map"), VR = nv(Ua2, "Promise"), Y32 = nv(Ua2, "Set"), BR = nv(Ua2, "WeakMap"), zk = nv(vd2, "create"), t_ = BR && new BR(), zR = {}, jTt = gn(eG), KZt = gn(nG), WTt = gn(VR), XZt = gn(Y32), Py = gn(BR), jk2 = Z32 ? Z32.prototype : r5, dT = jk2 ? jk2.valueOf : r5, Yft = jk2 ? jk2.toString : r5;
              function En(st) {
                if (rg2(st) && !Wc2(st) && !(st instanceof Jh2)) {
                  if (st instanceof Ix)
                    return st;
                  if (zd2.call(st, "__wrapped__"))
                    return dr(st);
                }
                return new Ix(st);
              }
              var jR = function() {
                function st() {
                }
                return function(xt) {
                  if (!ng2(xt))
                    return {};
                  if (FTt)
                    return FTt(xt);
                  st.prototype = xt;
                  var Qt = new st();
                  return st.prototype = r5, Qt;
                };
              }();
              function rG() {
              }
              function Ix(st, xt) {
                this.__wrapped__ = st, this.__actions__ = [], this.__chain__ = !!xt, this.__index__ = 0, this.__values__ = r5;
              }
              En.templateSettings = { escape: q1, evaluate: AM, interpolate: Xw, variable: "", imports: { _: En } }, En.prototype = rG.prototype, En.prototype.constructor = En, Ix.prototype = jR(rG.prototype), Ix.prototype.constructor = Ix;
              function Jh2(st) {
                this.__wrapped__ = st, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = fi2, this.__views__ = [];
              }
              function QZt() {
                var st = new Jh2(this.__wrapped__);
                return st.__actions__ = ei2(this.__actions__), st.__dir__ = this.__dir__, st.__filtered__ = this.__filtered__, st.__iteratees__ = ei2(this.__iteratees__), st.__takeCount__ = this.__takeCount__, st.__views__ = ei2(this.__views__), st;
              }
              function JZt() {
                if (this.__filtered__) {
                  var st = new Jh2(this);
                  st.__dir__ = -1, st.__filtered__ = true;
                } else
                  st = this.clone(), st.__dir__ *= -1;
                return st;
              }
              function GTt() {
                var st = this.__wrapped__.value(), xt = this.__dir__, Qt = Wc2(st), Ae2 = xt < 0, an = Qt ? st.length : 0, Un = Xi2(0, an, this.__views__), Br = Un.start, qr = Un.end, Ai2 = qr - Br, So = Ae2 ? qr : Br - 1, Mo = this.__iteratees__, Ao = Mo.length, Xs = 0, Yl = Jb2(Ai2, this.__takeCount__);
                if (!Qt || !Ae2 && an == Ai2 && Yl == Ai2)
                  return uAt(st, this.__actions__);
                var Pu = [];
                t:
                  for (; Ai2-- && Xs < Yl; ) {
                    So += xt;
                    for (var Mf2 = -1, Uu = st[So]; ++Mf2 < Ao; ) {
                      var nc2 = Mo[Mf2], lf2 = nc2.iteratee, rb2 = nc2.type, r1 = lf2(Uu);
                      if (rb2 == jn)
                        Uu = r1;
                      else if (!r1) {
                        if (rb2 == An)
                          continue t;
                        break t;
                      }
                    }
                    Pu[Xs++] = Uu;
                  }
                return Pu;
              }
              Jh2.prototype = jR(rG.prototype), Jh2.prototype.constructor = Jh2;
              function WR(st) {
                var xt = -1, Qt = st == null ? 0 : st.length;
                for (this.clear(); ++xt < Qt; ) {
                  var Ae2 = st[xt];
                  this.set(Ae2[0], Ae2[1]);
                }
              }
              function t$t() {
                this.__data__ = zk ? zk(null) : {}, this.size = 0;
              }
              function Kft(st) {
                var xt = this.has(st) && delete this.__data__[st];
                return this.size -= xt ? 1 : 0, xt;
              }
              function Xft(st) {
                var xt = this.__data__;
                if (zk) {
                  var Qt = xt[st];
                  return Qt === R6 ? r5 : Qt;
                }
                return zd2.call(xt, st) ? xt[st] : r5;
              }
              function e$t(st) {
                var xt = this.__data__;
                return zk ? xt[st] !== r5 : zd2.call(xt, st);
              }
              function n$t(st, xt) {
                var Qt = this.__data__;
                return this.size += this.has(st) ? 0 : 1, Qt[st] = zk && xt === r5 ? R6 : xt, this;
              }
              WR.prototype.clear = t$t, WR.prototype.delete = Kft, WR.prototype.get = Xft, WR.prototype.has = e$t, WR.prototype.set = n$t;
              function gT(st) {
                var xt = -1, Qt = st == null ? 0 : st.length;
                for (this.clear(); ++xt < Qt; ) {
                  var Ae2 = st[xt];
                  this.set(Ae2[0], Ae2[1]);
                }
              }
              function r$t() {
                this.__data__ = [], this.size = 0;
              }
              function Qft(st) {
                var xt = this.__data__, Qt = sG(xt, st);
                if (Qt < 0)
                  return false;
                var Ae2 = xt.length - 1;
                return Qt == Ae2 ? xt.pop() : $3.call(xt, Qt, 1), --this.size, true;
              }
              function i$t(st) {
                var xt = this.__data__, Qt = sG(xt, st);
                return Qt < 0 ? r5 : xt[Qt][1];
              }
              function kM(st) {
                return sG(this.__data__, st) > -1;
              }
              function HTt(st, xt) {
                var Qt = this.__data__, Ae2 = sG(Qt, st);
                return Ae2 < 0 ? (++this.size, Qt.push([st, xt])) : Qt[Ae2][1] = xt, this;
              }
              gT.prototype.clear = r$t, gT.prototype.delete = Qft, gT.prototype.get = i$t, gT.prototype.has = kM, gT.prototype.set = HTt;
              function vT(st) {
                var xt = -1, Qt = st == null ? 0 : st.length;
                for (this.clear(); ++xt < Qt; ) {
                  var Ae2 = st[xt];
                  this.set(Ae2[0], Ae2[1]);
                }
              }
              function UTt() {
                this.size = 0, this.__data__ = { hash: new WR(), map: new (nG || gT)(), string: new WR() };
              }
              function a$t(st) {
                var xt = t1(this, st).delete(st);
                return this.size -= xt ? 1 : 0, xt;
              }
              function o$t(st) {
                return t1(this, st).get(st);
              }
              function s$t(st) {
                return t1(this, st).has(st);
              }
              function qTt(st, xt) {
                var Qt = t1(this, st), Ae2 = Qt.size;
                return Qt.set(st, xt), this.size += Qt.size == Ae2 ? 0 : 1, this;
              }
              vT.prototype.clear = UTt, vT.prototype.delete = a$t, vT.prototype.get = o$t, vT.prototype.has = s$t, vT.prototype.set = qTt;
              function Wk(st) {
                var xt = -1, Qt = st == null ? 0 : st.length;
                for (this.__data__ = new vT(); ++xt < Qt; )
                  this.add(st[xt]);
              }
              function iG(st) {
                return this.__data__.set(st, R6), this;
              }
              function l$t(st) {
                return this.__data__.has(st);
              }
              Wk.prototype.add = Wk.prototype.push = iG, Wk.prototype.has = l$t;
              function yT(st) {
                var xt = this.__data__ = new gT(st);
                this.size = xt.size;
              }
              function ZTt() {
                this.__data__ = new gT(), this.size = 0;
              }
              function Jft(st) {
                var xt = this.__data__, Qt = xt.delete(st);
                return this.size = xt.size, Qt;
              }
              function u$t(st) {
                return this.__data__.get(st);
              }
              function c$t(st) {
                return this.__data__.has(st);
              }
              function f$t(st, xt) {
                var Qt = this.__data__;
                if (Qt instanceof gT) {
                  var Ae2 = Qt.__data__;
                  if (!nG || Ae2.length < b6 - 1)
                    return Ae2.push([st, xt]), this.size = ++Qt.size, this;
                  Qt = this.__data__ = new vT(Ae2);
                }
                return Qt.set(st, xt), this.size = Qt.size, this;
              }
              yT.prototype.clear = ZTt, yT.prototype.delete = Jft, yT.prototype.get = u$t, yT.prototype.has = c$t, yT.prototype.set = f$t;
              function $Tt(st, xt) {
                var Qt = Wc2(st), Ae2 = !Qt && o_(st), an = !Qt && !Ae2 && Zs(st), Un = !Qt && !Ae2 && !an && TT(st), Br = Qt || Ae2 || an || Un, qr = Br ? ZW(st.length, uQ) : [], Ai2 = qr.length;
                for (var So in st)
                  (xt || zd2.call(st, So)) && !(Br && (So == "length" || an && (So == "offset" || So == "parent") || Un && (So == "buffer" || So == "byteLength" || So == "byteOffset") || tp(So, Ai2))) && qr.push(So);
                return qr;
              }
              function aG(st) {
                var xt = st.length;
                return xt ? st[hht(0, xt - 1)] : r5;
              }
              function h$t(st, xt) {
                return OM(ei2(st), GR(xt, 0, st.length));
              }
              function p$t(st) {
                return OM(ei2(st));
              }
              function tht(st, xt, Qt) {
                (Qt !== r5 && !tb2(st[xt], Qt) || Qt === r5 && !(xt in st)) && Gk(st, xt, Qt);
              }
              function oG(st, xt, Qt) {
                var Ae2 = st[xt];
                (!(zd2.call(st, xt) && tb2(Ae2, Qt)) || Qt === r5 && !(xt in st)) && Gk(st, xt, Qt);
              }
              function sG(st, xt) {
                for (var Qt = st.length; Qt--; )
                  if (tb2(st[Qt][0], xt))
                    return Qt;
                return -1;
              }
              function d$t(st, xt, Qt, Ae2) {
                return K3(st, function(an, Un, Br) {
                  xt(Ae2, an, Qt(an), Br);
                }), Ae2;
              }
              function eht(st, xt) {
                return st && oi2(xt, Zv(xt), st);
              }
              function M22(st, xt) {
                return st && oi2(xt, Sn(xt), st);
              }
              function Gk(st, xt, Qt) {
                xt == "__proto__" && hQ ? hQ(st, xt, { configurable: true, enumerable: true, value: Qt, writable: true }) : st[xt] = Qt;
              }
              function gQ(st, xt) {
                for (var Qt = -1, Ae2 = xt.length, an = _a2(Ae2), Un = st == null; ++Qt < Ae2; )
                  an[Qt] = Un ? r5 : AD(st, xt[Qt]);
                return an;
              }
              function GR(st, xt, Qt) {
                return st === st && (Qt !== r5 && (st = st <= Qt ? st : Qt), xt !== r5 && (st = st >= xt ? st : xt)), st;
              }
              function PM(st, xt, Qt, Ae2, an, Un) {
                var Br, qr = xt & Z3, Ai2 = xt & X3, So = xt & tt;
                if (Qt && (Br = an ? Qt(st, Ae2, an, Un) : Qt(st)), Br !== r5)
                  return Br;
                if (!ng2(st))
                  return st;
                var Mo = Wc2(st);
                if (Mo) {
                  if (Br = Zl(st), !qr)
                    return ei2(st, Br);
                } else {
                  var Ao = Bi2(st), Xs = Ao == Ll || Ao == dh2;
                  if (Zs(st))
                    return oe2(st, qr);
                  if (Ao == Xh2 || Ao == gl || Xs && !an) {
                    if (Br = Ai2 || Xs ? {} : Yc2(st), !qr)
                      return Ai2 ? Ca2(st, M22(Br, st)) : Va2(st, eht(Br, st));
                  } else {
                    if (!ev[Ao])
                      return an ? st : {};
                    Br = Kc2(st, Ao, qr);
                  }
                }
                Un || (Un = new yT());
                var Yl = Un.get(st);
                if (Yl)
                  return Yl;
                Un.set(st, Br), s6(st) ? st.forEach(function(Uu) {
                  Br.add(PM(Uu, xt, Qt, Uu, st, Un));
                }) : sd2(st) && st.forEach(function(Uu, nc2) {
                  Br.set(nc2, PM(Uu, xt, Qt, nc2, st, Un));
                });
                var Pu = So ? Ai2 ? Jm : Gv : Ai2 ? Sn : Zv, Mf2 = Mo ? r5 : Pu(st);
                return Jw(Mf2 || st, function(Uu, nc2) {
                  Mf2 && (nc2 = Uu, Uu = st[nc2]), oG(Br, nc2, PM(Uu, xt, Qt, nc2, st, Un));
                }), Br;
              }
              function nht(st) {
                var xt = Zv(st);
                return function(Qt) {
                  return YTt(Qt, st, xt);
                };
              }
              function YTt(st, xt, Qt) {
                var Ae2 = Qt.length;
                if (st == null)
                  return !Ae2;
                for (st = vd2(st); Ae2--; ) {
                  var an = Qt[Ae2], Un = xt[an], Br = st[an];
                  if (Br === r5 && !(an in st) || !Un(Br))
                    return false;
                }
                return true;
              }
              function KTt(st, xt, Qt) {
                if (typeof st != "function")
                  throw new DM(A2);
                return Hk(function() {
                  st.apply(r5, Qt);
                }, xt);
              }
              function lG(st, xt, Qt, Ae2) {
                var an = -1, Un = FR, Br = true, qr = st.length, Ai2 = [], So = xt.length;
                if (!qr)
                  return Ai2;
                Qt && (xt = Wv(xt, Xb2(Qt))), Ae2 ? (Un = Gft, Br = false) : xt.length >= b6 && (Un = U32, Br = false, xt = new Wk(xt));
                t:
                  for (; ++an < qr; ) {
                    var Mo = st[an], Ao = Qt == null ? Mo : Qt(Mo);
                    if (Mo = Ae2 || Mo !== 0 ? Mo : 0, Br && Ao === Ao) {
                      for (var Xs = So; Xs--; )
                        if (xt[Xs] === Ao)
                          continue t;
                      Ai2.push(Mo);
                    } else
                      Un(xt, Ao, Ae2) || Ai2.push(Mo);
                  }
                return Ai2;
              }
              var K3 = Ei2(Y1), XTt = Ei2(vQ, true);
              function QTt(st, xt) {
                var Qt = true;
                return K3(st, function(Ae2, an, Un) {
                  return Qt = !!xt(Ae2, an, Un), Qt;
                }), Qt;
              }
              function uG(st, xt, Qt) {
                for (var Ae2 = -1, an = st.length; ++Ae2 < an; ) {
                  var Un = st[Ae2], Br = xt(Un);
                  if (Br != null && (qr === r5 ? Br === Br && !uy(Br) : Qt(Br, qr)))
                    var qr = Br, Ai2 = Un;
                }
                return Ai2;
              }
              function rht(st, xt, Qt, Ae2) {
                var an = st.length;
                for (Qt = Hc2(Qt), Qt < 0 && (Qt = -Qt > an ? 0 : an + Qt), Ae2 = Ae2 === r5 || Ae2 > an ? an : Hc2(Ae2), Ae2 < 0 && (Ae2 += an), Ae2 = Qt > Ae2 ? 0 : u6(Ae2); Qt < Ae2; )
                  st[Qt++] = xt;
                return st;
              }
              function E9(st, xt) {
                var Qt = [];
                return K3(st, function(Ae2, an, Un) {
                  xt(Ae2, an, Un) && Qt.push(Ae2);
                }), Qt;
              }
              function $1(st, xt, Qt, Ae2, an) {
                var Un = -1, Br = st.length;
                for (Qt || (Qt = Og2), an || (an = []); ++Un < Br; ) {
                  var qr = st[Un];
                  xt > 0 && Qt(qr) ? xt > 1 ? $1(qr, xt - 1, Qt, Ae2, an) : H3(an, qr) : Ae2 || (an[an.length] = qr);
                }
                return an;
              }
              var iht = Wi2(), JTt = Wi2(true);
              function Y1(st, xt) {
                return st && iht(st, xt, Zv);
              }
              function vQ(st, xt) {
                return st && JTt(st, xt, Zv);
              }
              function yQ(st, xt) {
                return G32(xt, function(Qt) {
                  return rv(st[Qt]);
                });
              }
              function HR(st, xt) {
                xt = ge2(xt, st);
                for (var Qt = 0, Ae2 = xt.length; st != null && Qt < Ae2; )
                  st = st[Mr(xt[Qt++])];
                return Qt && Qt == Ae2 ? st : r5;
              }
              function aht(st, xt, Qt) {
                var Ae2 = xt(st);
                return Wc2(st) ? Ae2 : H3(Ae2, Qt(st));
              }
              function e_(st) {
                return st == null ? st === r5 ? fT : cp : EM && EM in vd2(st) ? Hv(st) : Q1(st);
              }
              function mQ(st, xt) {
                return st > xt;
              }
              function oht(st, xt) {
                return st != null && zd2.call(st, xt);
              }
              function tAt(st, xt) {
                return st != null && xt in vd2(st);
              }
              function bQ(st, xt, Qt) {
                return st >= Jb2(xt, Qt) && st < um(xt, Qt);
              }
              function sht(st, xt, Qt) {
                for (var Ae2 = Qt ? Gft : FR, an = st[0].length, Un = st.length, Br = Un, qr = _a2(Un), Ai2 = 1 / 0, So = []; Br--; ) {
                  var Mo = st[Br];
                  Br && xt && (Mo = Wv(Mo, Xb2(xt))), Ai2 = Jb2(Mo.length, Ai2), qr[Br] = !Qt && (xt || an >= 120 && Mo.length >= 120) ? new Wk(Br && Mo) : r5;
                }
                Mo = st[0];
                var Ao = -1, Xs = qr[0];
                t:
                  for (; ++Ao < an && So.length < Ai2; ) {
                    var Yl = Mo[Ao], Pu = xt ? xt(Yl) : Yl;
                    if (Yl = Qt || Yl !== 0 ? Yl : 0, !(Xs ? U32(Xs, Pu) : Ae2(So, Pu, Qt))) {
                      for (Br = Un; --Br; ) {
                        var Mf2 = qr[Br];
                        if (!(Mf2 ? U32(Mf2, Pu) : Ae2(st[Br], Pu, Qt)))
                          continue t;
                      }
                      Xs && Xs.push(Pu), So.push(Yl);
                    }
                  }
                return So;
              }
              function yc2(st, xt, Qt, Ae2) {
                return Y1(st, function(an, Un, Br) {
                  xt(Ae2, Qt(an), Un, Br);
                }), Ae2;
              }
              function k9(st, xt, Qt) {
                xt = ge2(xt, st), st = mT(st, xt);
                var Ae2 = st == null ? st : st[Mr(Uv(xt))];
                return Ae2 == null ? r5 : S22(Ae2, st, Qt);
              }
              function eAt(st) {
                return rg2(st) && e_(st) == gl;
              }
              function g$t(st) {
                return rg2(st) && e_(st) == ea2;
              }
              function v$t(st) {
                return rg2(st) && e_(st) == Us;
              }
              function P9(st, xt, Qt, Ae2, an) {
                return st === xt ? true : st == null || xt == null || !rg2(st) && !rg2(xt) ? st !== st && xt !== xt : _Q(st, xt, Qt, Ae2, P9, an);
              }
              function _Q(st, xt, Qt, Ae2, an, Un) {
                var Br = Wc2(st), qr = Wc2(xt), Ai2 = Br ? nl : Bi2(st), So = qr ? nl : Bi2(xt);
                Ai2 = Ai2 == gl ? Xh2 : Ai2, So = So == gl ? Xh2 : So;
                var Mo = Ai2 == Xh2, Ao = So == Xh2, Xs = Ai2 == So;
                if (Xs && Zs(st)) {
                  if (!Zs(xt))
                    return false;
                  Br = true, Mo = false;
                }
                if (Xs && !Mo)
                  return Un || (Un = new yT()), Br || TT(st) ? Lg2(st, xt, Qt, Ae2, an, Un) : n_(st, xt, Ai2, Qt, Ae2, an, Un);
                if (!(Qt & it)) {
                  var Yl = Mo && zd2.call(st, "__wrapped__"), Pu = Ao && zd2.call(xt, "__wrapped__");
                  if (Yl || Pu) {
                    var Mf2 = Yl ? st.value() : st, Uu = Pu ? xt.value() : xt;
                    return Un || (Un = new yT()), an(Mf2, Uu, Qt, Ae2, Un);
                  }
                }
                return Xs ? (Un || (Un = new yT()), Dx(st, xt, Qt, Ae2, an, Un)) : false;
              }
              function UR(st) {
                return rg2(st) && Bi2(st) == hu;
              }
              function cG(st, xt, Qt, Ae2) {
                var an = Qt.length, Un = an, Br = !Ae2;
                if (st == null)
                  return !Un;
                for (st = vd2(st); an--; ) {
                  var qr = Qt[an];
                  if (Br && qr[2] ? qr[1] !== st[qr[0]] : !(qr[0] in st))
                    return false;
                }
                for (; ++an < Un; ) {
                  qr = Qt[an];
                  var Ai2 = qr[0], So = st[Ai2], Mo = qr[1];
                  if (Br && qr[2]) {
                    if (So === r5 && !(Ai2 in st))
                      return false;
                  } else {
                    var Ao = new yT();
                    if (Ae2)
                      var Xs = Ae2(So, Mo, Ai2, st, xt, Ao);
                    if (!(Xs === r5 ? P9(Mo, So, it | pt, Ae2, Ao) : Xs))
                      return false;
                  }
                }
                return true;
              }
              function fG(st) {
                if (!ng2(st) || nS(st))
                  return false;
                var xt = rv(st) ? jZt : zi2;
                return xt.test(gn(st));
              }
              function y$t(st) {
                return rg2(st) && e_(st) == U1;
              }
              function nAt(st) {
                return rg2(st) && Bi2(st) == Jd2;
              }
              function m$t(st) {
                return rg2(st) && Wd2(st.length) && !!Tv[e_(st)];
              }
              function qR(st) {
                return typeof st == "function" ? st : st == null ? nb2 : typeof st == "object" ? Wc2(st) ? wQ(st[0], st[1]) : uht(st) : n5(st);
              }
              function L9(st) {
                if (!tg2(st))
                  return qZt(st);
                var xt = [];
                for (var Qt in vd2(st))
                  zd2.call(st, Qt) && Qt != "constructor" && xt.push(Qt);
                return xt;
              }
              function lht(st) {
                if (!ng2(st))
                  return X1(st);
                var xt = tg2(st), Qt = [];
                for (var Ae2 in st)
                  Ae2 == "constructor" && (xt || !zd2.call(st, Ae2)) || Qt.push(Ae2);
                return Qt;
              }
              function xQ(st, xt) {
                return st < xt;
              }
              function rAt(st, xt) {
                var Qt = -1, Ae2 = ri2(st) ? _a2(st.length) : [];
                return K3(st, function(an, Un, Br) {
                  Ae2[++Qt] = xt(an, Un, Br);
                }), Ae2;
              }
              function uht(st) {
                var xt = Dv(st);
                return xt.length == 1 && xt[0][2] ? O0(xt[0][0], xt[0][1]) : function(Qt) {
                  return Qt === st || cG(Qt, st, xt);
                };
              }
              function wQ(st, xt) {
                return md2(st) && Jf2(xt) ? O0(Mr(st), xt) : function(Qt) {
                  var Ae2 = AD(Qt, st);
                  return Ae2 === r5 && Ae2 === xt ? Z9(Qt, st) : P9(xt, Ae2, it | pt);
                };
              }
              function X32(st, xt, Qt, Ae2, an) {
                st !== xt && iht(xt, function(Un, Br) {
                  if (an || (an = new yT()), ng2(Un))
                    b$t(st, xt, Br, Qt, X32, Ae2, an);
                  else {
                    var qr = Ae2 ? Ae2($R(st, Br), Un, Br + "", st, xt, an) : r5;
                    qr === r5 && (qr = Un), tht(st, Br, qr);
                  }
                }, Sn);
              }
              function b$t(st, xt, Qt, Ae2, an, Un, Br) {
                var qr = $R(st, Qt), Ai2 = $R(xt, Qt), So = Br.get(Ai2);
                if (So) {
                  tht(st, Qt, So);
                  return;
                }
                var Mo = Un ? Un(qr, Ai2, Qt + "", st, xt, Br) : r5, Ao = Mo === r5;
                if (Ao) {
                  var Xs = Wc2(Ai2), Yl = !Xs && Zs(Ai2), Pu = !Xs && !Yl && TT(Ai2);
                  Mo = Ai2, Xs || Yl || Pu ? Wc2(qr) ? Mo = qr : va(qr) ? Mo = ei2(qr) : Yl ? (Ao = false, Mo = oe2(Ai2, true)) : Pu ? (Ao = false, Mo = vn(Ai2, true)) : Mo = [] : sS(Ai2) || o_(Ai2) ? (Mo = qr, o_(qr) ? Mo = eJ(qr) : (!ng2(qr) || rv(qr)) && (Mo = Yc2(Ai2))) : Ao = false;
                }
                Ao && (Br.set(Ai2, Mo), an(Mo, Ai2, Ae2, Un, Br), Br.delete(Ai2)), tht(st, Qt, Mo);
              }
              function cht(st, xt) {
                var Qt = st.length;
                if (Qt)
                  return xt += xt < 0 ? Qt : 0, tp(xt, Qt) ? st[xt] : r5;
              }
              function fht(st, xt, Qt) {
                xt.length ? xt = Wv(xt, function(Un) {
                  return Wc2(Un) ? function(Br) {
                    return HR(Br, Un.length === 1 ? Un[0] : Un);
                  } : Un;
                }) : xt = [nb2];
                var Ae2 = -1;
                xt = Wv(xt, Xb2(vu()));
                var an = rAt(st, function(Un, Br, qr) {
                  var Ai2 = Wv(xt, function(So) {
                    return So(Un);
                  });
                  return { criteria: Ai2, index: ++Ae2, value: Un };
                });
                return Qm(an, function(Un, Br) {
                  return Lr(Un, Br, Qt);
                });
              }
              function _$t(st, xt) {
                return iAt(st, xt, function(Qt, Ae2) {
                  return Z9(st, Ae2);
                });
              }
              function iAt(st, xt, Qt) {
                for (var Ae2 = -1, an = xt.length, Un = {}; ++Ae2 < an; ) {
                  var Br = xt[Ae2], qr = HR(st, Br);
                  Qt(qr, Br) && hG(Un, ge2(Br, st), qr);
                }
                return Un;
              }
              function x$t(st) {
                return function(xt) {
                  return HR(xt, st);
                };
              }
              function SQ(st, xt, Qt, Ae2) {
                var an = Ae2 ? kZt : Vk, Un = -1, Br = xt.length, qr = st;
                for (st === xt && (xt = ei2(xt)), Qt && (qr = Wv(st, Xb2(Qt))); ++Un < Br; )
                  for (var Ai2 = 0, So = xt[Un], Mo = Qt ? Qt(So) : So; (Ai2 = an(qr, Mo, Ai2, Ae2)) > -1; )
                    qr !== st && $3.call(qr, Ai2, 1), $3.call(st, Ai2, 1);
                return st;
              }
              function ZR(st, xt) {
                for (var Qt = st ? xt.length : 0, Ae2 = Qt - 1; Qt--; ) {
                  var an = xt[Qt];
                  if (Qt == Ae2 || an !== Un) {
                    var Un = an;
                    tp(an) ? $3.call(st, an, 1) : dht(st, an);
                  }
                }
                return st;
              }
              function hht(st, xt) {
                return st + dQ(zTt() * (xt - st + 1));
              }
              function w$t(st, xt, Qt, Ae2) {
                for (var an = -1, Un = um(pQ((xt - st) / (Qt || 1)), 0), Br = _a2(Un); Un--; )
                  Br[Ae2 ? Un : ++an] = st, st += Qt;
                return Br;
              }
              function MQ(st, xt) {
                var Qt = "";
                if (!st || xt < 1 || xt > Qn)
                  return Qt;
                do
                  xt % 2 && (Qt += st), xt = dQ(xt / 2), xt && (st += st);
                while (xt);
                return Qt;
              }
              function gh2(st, xt) {
                return YR(a_(st, xt, nb2), st + "");
              }
              function CQ(st) {
                return aG(lL(st));
              }
              function S$t(st, xt) {
                var Qt = lL(st);
                return OM(Qt, GR(xt, 0, Qt.length));
              }
              function hG(st, xt, Qt, Ae2) {
                if (!ng2(st))
                  return st;
                xt = ge2(xt, st);
                for (var an = -1, Un = xt.length, Br = Un - 1, qr = st; qr != null && ++an < Un; ) {
                  var Ai2 = Mr(xt[an]), So = Qt;
                  if (Ai2 === "__proto__" || Ai2 === "constructor" || Ai2 === "prototype")
                    return st;
                  if (an != Br) {
                    var Mo = qr[Ai2];
                    So = Ae2 ? Ae2(Mo, Ai2, qr) : r5, So === r5 && (So = ng2(Mo) ? Mo : tp(xt[an + 1]) ? [] : {});
                  }
                  oG(qr, Ai2, So), qr = qr[Ai2];
                }
                return st;
              }
              var aAt = t_ ? function(st, xt) {
                return t_.set(st, xt), st;
              } : nb2, oAt = hQ ? function(st, xt) {
                return hQ(st, "toString", { configurable: true, enumerable: false, value: WG(xt), writable: true });
              } : nb2;
              function M$t(st) {
                return OM(lL(st));
              }
              function LM(st, xt, Qt) {
                var Ae2 = -1, an = st.length;
                xt < 0 && (xt = -xt > an ? 0 : an + xt), Qt = Qt > an ? an : Qt, Qt < 0 && (Qt += an), an = xt > Qt ? 0 : Qt - xt >>> 0, xt >>>= 0;
                for (var Un = _a2(an); ++Ae2 < an; )
                  Un[Ae2] = st[Ae2 + xt];
                return Un;
              }
              function C$t(st, xt) {
                var Qt;
                return K3(st, function(Ae2, an, Un) {
                  return Qt = xt(Ae2, an, Un), !Qt;
                }), !!Qt;
              }
              function TQ(st, xt, Qt) {
                var Ae2 = 0, an = st == null ? Ae2 : st.length;
                if (typeof xt == "number" && xt === xt && an <= Oo) {
                  for (; Ae2 < an; ) {
                    var Un = Ae2 + an >>> 1, Br = st[Un];
                    Br !== null && !uy(Br) && (Qt ? Br <= xt : Br < xt) ? Ae2 = Un + 1 : an = Un;
                  }
                  return an;
                }
                return AQ(st, xt, nb2, Qt);
              }
              function AQ(st, xt, Qt, Ae2) {
                var an = 0, Un = st == null ? 0 : st.length;
                if (Un === 0)
                  return 0;
                xt = Qt(xt);
                for (var Br = xt !== xt, qr = xt === null, Ai2 = uy(xt), So = xt === r5; an < Un; ) {
                  var Mo = dQ((an + Un) / 2), Ao = Qt(st[Mo]), Xs = Ao !== r5, Yl = Ao === null, Pu = Ao === Ao, Mf2 = uy(Ao);
                  if (Br)
                    var Uu = Ae2 || Pu;
                  else
                    So ? Uu = Pu && (Ae2 || Xs) : qr ? Uu = Pu && Xs && (Ae2 || !Yl) : Ai2 ? Uu = Pu && Xs && !Yl && (Ae2 || !Mf2) : Yl || Mf2 ? Uu = false : Uu = Ae2 ? Ao <= xt : Ao < xt;
                  Uu ? an = Mo + 1 : Un = Mo;
                }
                return Jb2(Un, mi2);
              }
              function sAt(st, xt) {
                for (var Qt = -1, Ae2 = st.length, an = 0, Un = []; ++Qt < Ae2; ) {
                  var Br = st[Qt], qr = xt ? xt(Br) : Br;
                  if (!Qt || !tb2(qr, Ai2)) {
                    var Ai2 = qr;
                    Un[an++] = Br === 0 ? 0 : Br;
                  }
                }
                return Un;
              }
              function pht(st) {
                return typeof st == "number" ? st : uy(st) ? Ar : +st;
              }
              function C2(st) {
                if (typeof st == "string")
                  return st;
                if (Wc2(st))
                  return Wv(st, C2) + "";
                if (uy(st))
                  return Yft ? Yft.call(st) : "";
                var xt = st + "";
                return xt == "0" && 1 / st == -Jr ? "-0" : xt;
              }
              function vD(st, xt, Qt) {
                var Ae2 = -1, an = FR, Un = st.length, Br = true, qr = [], Ai2 = qr;
                if (Qt)
                  Br = false, an = Gft;
                else if (Un >= b6) {
                  var So = xt ? null : vh2(st);
                  if (So)
                    return M9(So);
                  Br = false, an = U32, Ai2 = new Wk();
                } else
                  Ai2 = xt ? [] : qr;
                t:
                  for (; ++Ae2 < Un; ) {
                    var Mo = st[Ae2], Ao = xt ? xt(Mo) : Mo;
                    if (Mo = Qt || Mo !== 0 ? Mo : 0, Br && Ao === Ao) {
                      for (var Xs = Ai2.length; Xs--; )
                        if (Ai2[Xs] === Ao)
                          continue t;
                      xt && Ai2.push(Ao), qr.push(Mo);
                    } else
                      an(Ai2, Ao, Qt) || (Ai2 !== qr && Ai2.push(Ao), qr.push(Mo));
                  }
                return qr;
              }
              function dht(st, xt) {
                return xt = ge2(xt, st), st = mT(st, xt), st == null || delete st[Mr(Uv(xt))];
              }
              function lAt(st, xt, Qt, Ae2) {
                return hG(st, xt, Qt(HR(st, xt)), Ae2);
              }
              function IQ(st, xt, Qt, Ae2) {
                for (var an = st.length, Un = Ae2 ? an : -1; (Ae2 ? Un-- : ++Un < an) && xt(st[Un], Un, st); )
                  ;
                return Qt ? LM(st, Ae2 ? 0 : Un, Ae2 ? Un + 1 : an) : LM(st, Ae2 ? Un + 1 : 0, Ae2 ? an : Un);
              }
              function uAt(st, xt) {
                var Qt = st;
                return Qt instanceof Jh2 && (Qt = Qt.value()), tQ(xt, function(Ae2, an) {
                  return an.func.apply(an.thisArg, H3([Ae2], an.args));
                }, Qt);
              }
              function DQ(st, xt, Qt) {
                var Ae2 = st.length;
                if (Ae2 < 2)
                  return Ae2 ? vD(st[0]) : [];
                for (var an = -1, Un = _a2(Ae2); ++an < Ae2; )
                  for (var Br = st[an], qr = -1; ++qr < Ae2; )
                    qr != an && (Un[an] = lG(Un[an] || Br, st[qr], xt, Qt));
                return vD($1(Un, 1), xt, Qt);
              }
              function cAt(st, xt, Qt) {
                for (var Ae2 = -1, an = st.length, Un = xt.length, Br = {}; ++Ae2 < an; ) {
                  var qr = Ae2 < Un ? xt[Ae2] : r5;
                  Qt(Br, st[Ae2], qr);
                }
                return Br;
              }
              function ght(st) {
                return va(st) ? st : [];
              }
              function Bt(st) {
                return typeof st == "function" ? st : nb2;
              }
              function ge2(st, xt) {
                return Wc2(st) ? st : md2(st, xt) ? [st] : ir(ld2(st));
              }
              var Ht = gh2;
              function qt(st, xt, Qt) {
                var Ae2 = st.length;
                return Qt = Qt === r5 ? Ae2 : Qt, !xt && Qt >= Ae2 ? st : LM(st, xt, Qt);
              }
              var Zt = WZt || function(st) {
                return Xm.clearTimeout(st);
              };
              function oe2(st, xt) {
                if (xt)
                  return st.slice();
                var Qt = st.length, Ae2 = Zft ? Zft(Qt) : new st.constructor(Qt);
                return st.copy(Ae2), Ae2;
              }
              function Ne2(st) {
                var xt = new st.constructor(st.byteLength);
                return new QW(xt).set(new QW(st)), xt;
              }
              function Ge2(st, xt) {
                var Qt = xt ? Ne2(st.buffer) : st.buffer;
                return new st.constructor(Qt, st.byteOffset, st.byteLength);
              }
              function Ve(st) {
                var xt = new st.constructor(st.source, lr.exec(st));
                return xt.lastIndex = st.lastIndex, xt;
              }
              function pn(st) {
                return dT ? vd2(dT.call(st)) : {};
              }
              function vn(st, xt) {
                var Qt = xt ? Ne2(st.buffer) : st.buffer;
                return new st.constructor(Qt, st.byteOffset, st.length);
              }
              function Gn(st, xt) {
                if (st !== xt) {
                  var Qt = st !== r5, Ae2 = st === null, an = st === st, Un = uy(st), Br = xt !== r5, qr = xt === null, Ai2 = xt === xt, So = uy(xt);
                  if (!qr && !So && !Un && st > xt || Un && Br && Ai2 && !qr && !So || Ae2 && Br && Ai2 || !Qt && Ai2 || !an)
                    return 1;
                  if (!Ae2 && !Un && !So && st < xt || So && Qt && an && !Ae2 && !Un || qr && Qt && an || !Br && an || !Ai2)
                    return -1;
                }
                return 0;
              }
              function Lr(st, xt, Qt) {
                for (var Ae2 = -1, an = st.criteria, Un = xt.criteria, Br = an.length, qr = Qt.length; ++Ae2 < Br; ) {
                  var Ai2 = Gn(an[Ae2], Un[Ae2]);
                  if (Ai2) {
                    if (Ae2 >= qr)
                      return Ai2;
                    var So = Qt[Ae2];
                    return Ai2 * (So == "desc" ? -1 : 1);
                  }
                }
                return st.index - xt.index;
              }
              function Wr(st, xt, Qt, Ae2) {
                for (var an = -1, Un = st.length, Br = Qt.length, qr = -1, Ai2 = xt.length, So = um(Un - Br, 0), Mo = _a2(Ai2 + So), Ao = !Ae2; ++qr < Ai2; )
                  Mo[qr] = xt[qr];
                for (; ++an < Br; )
                  (Ao || an < Un) && (Mo[Qt[an]] = st[an]);
                for (; So--; )
                  Mo[qr++] = st[an++];
                return Mo;
              }
              function Gr(st, xt, Qt, Ae2) {
                for (var an = -1, Un = st.length, Br = -1, qr = Qt.length, Ai2 = -1, So = xt.length, Mo = um(Un - qr, 0), Ao = _a2(Mo + So), Xs = !Ae2; ++an < Mo; )
                  Ao[an] = st[an];
                for (var Yl = an; ++Ai2 < So; )
                  Ao[Yl + Ai2] = xt[Ai2];
                for (; ++Br < qr; )
                  (Xs || an < Un) && (Ao[Yl + Qt[Br]] = st[an++]);
                return Ao;
              }
              function ei2(st, xt) {
                var Qt = -1, Ae2 = st.length;
                for (xt || (xt = _a2(Ae2)); ++Qt < Ae2; )
                  xt[Qt] = st[Qt];
                return xt;
              }
              function oi2(st, xt, Qt, Ae2) {
                var an = !Qt;
                Qt || (Qt = {});
                for (var Un = -1, Br = xt.length; ++Un < Br; ) {
                  var qr = xt[Un], Ai2 = Ae2 ? Ae2(Qt[qr], st[qr], qr, Qt, st) : r5;
                  Ai2 === r5 && (Ai2 = st[qr]), an ? Gk(Qt, qr, Ai2) : oG(Qt, qr, Ai2);
                }
                return Qt;
              }
              function Va2(st, xt) {
                return oi2(st, eS(st), xt);
              }
              function Ca2(st, xt) {
                return oi2(st, so(st), xt);
              }
              function Go(st, xt) {
                return function(Qt, Ae2) {
                  var an = Wc2(Qt) ? JX : d$t, Un = xt ? xt() : {};
                  return an(Qt, st, vu(Ae2, 2), Un);
                };
              }
              function un(st) {
                return gh2(function(xt, Qt) {
                  var Ae2 = -1, an = Qt.length, Un = an > 1 ? Qt[an - 1] : r5, Br = an > 2 ? Qt[2] : r5;
                  for (Un = st.length > 3 && typeof Un == "function" ? (an--, Un) : r5, Br && Fh2(Qt[0], Qt[1], Br) && (Un = an < 3 ? r5 : Un, an = 1), xt = vd2(xt); ++Ae2 < an; ) {
                    var qr = Qt[Ae2];
                    qr && st(xt, qr, Ae2, Un);
                  }
                  return xt;
                });
              }
              function Ei2(st, xt) {
                return function(Qt, Ae2) {
                  if (Qt == null)
                    return Qt;
                  if (!ri2(Qt))
                    return st(Qt, Ae2);
                  for (var an = Qt.length, Un = xt ? an : -1, Br = vd2(Qt); (xt ? Un-- : ++Un < an) && Ae2(Br[Un], Un, Br) !== false; )
                    ;
                  return Qt;
                };
              }
              function Wi2(st) {
                return function(xt, Qt, Ae2) {
                  for (var an = -1, Un = vd2(xt), Br = Ae2(xt), qr = Br.length; qr--; ) {
                    var Ai2 = Br[st ? qr : ++an];
                    if (Qt(Un[Ai2], Ai2, Un) === false)
                      break;
                  }
                  return xt;
                };
              }
              function La2(st, xt, Qt) {
                var Ae2 = xt & mt, an = Zi2(st);
                function Un() {
                  var Br = this && this !== Xm && this instanceof Un ? an : st;
                  return Br.apply(Ae2 ? Qt : this, arguments);
                }
                return Un;
              }
              function Aa2(st) {
                return function(xt) {
                  xt = ld2(xt);
                  var Qt = S9(xt) ? pT(xt) : r5, Ae2 = Qt ? Qt[0] : xt.charAt(0), an = Qt ? qt(Qt, 1).join("") : xt.slice(1);
                  return Ae2[st]() + an;
                };
              }
              function Oi2(st) {
                return function(xt) {
                  return tQ(e5(lJ(xt).replace(xTt, "")), st, "");
                };
              }
              function Zi2(st) {
                return function() {
                  var xt = arguments;
                  switch (xt.length) {
                    case 0:
                      return new st();
                    case 1:
                      return new st(xt[0]);
                    case 2:
                      return new st(xt[0], xt[1]);
                    case 3:
                      return new st(xt[0], xt[1], xt[2]);
                    case 4:
                      return new st(xt[0], xt[1], xt[2], xt[3]);
                    case 5:
                      return new st(xt[0], xt[1], xt[2], xt[3], xt[4]);
                    case 6:
                      return new st(xt[0], xt[1], xt[2], xt[3], xt[4], xt[5]);
                    case 7:
                      return new st(xt[0], xt[1], xt[2], xt[3], xt[4], xt[5], xt[6]);
                  }
                  var Qt = jR(st.prototype), Ae2 = st.apply(Qt, xt);
                  return ng2(Ae2) ? Ae2 : Qt;
                };
              }
              function Ka2(st, xt, Qt) {
                var Ae2 = Zi2(st);
                function an() {
                  for (var Un = arguments.length, Br = _a2(Un), qr = Un, Ai2 = r_(an); qr--; )
                    Br[qr] = arguments[qr];
                  var So = Un < 3 && Br[0] !== Ai2 && Br[Un - 1] !== Ai2 ? [] : Bk(Br, Ai2);
                  if (Un -= So.length, Un < Qt)
                    return qo(st, xt, bl, an.placeholder, r5, Br, So, r5, r5, Qt - Un);
                  var Mo = this && this !== Xm && this instanceof an ? Ae2 : st;
                  return S22(Mo, this, Br);
                }
                return an;
              }
              function Fo(st) {
                return function(xt, Qt, Ae2) {
                  var an = vd2(xt);
                  if (!ri2(xt)) {
                    var Un = vu(Qt, 3);
                    xt = Zv(xt), Qt = function(qr) {
                      return Un(an[qr], qr, an);
                    };
                  }
                  var Br = st(xt, Qt, Ae2);
                  return Br > -1 ? an[Un ? xt[Br] : Br] : r5;
                };
              }
              function Si2(st) {
                return Iv(function(xt) {
                  var Qt = xt.length, Ae2 = Qt, an = Ix.prototype.thru;
                  for (st && xt.reverse(); Ae2--; ) {
                    var Un = xt[Ae2];
                    if (typeof Un != "function")
                      throw new DM(A2);
                    if (an && !Br && ry(Un) == "wrapper")
                      var Br = new Ix([], true);
                  }
                  for (Ae2 = Br ? Ae2 : Qt; ++Ae2 < Qt; ) {
                    Un = xt[Ae2];
                    var qr = ry(Un), Ai2 = qr == "wrapper" ? Ex(Un) : r5;
                    Ai2 && fm(Ai2[0]) && Ai2[1] == (de2 | Gt | ce2 | we2) && !Ai2[4].length && Ai2[9] == 1 ? Br = Br[ry(Ai2[0])].apply(Br, Ai2[3]) : Br = Un.length == 1 && fm(Un) ? Br[qr]() : Br.thru(Un);
                  }
                  return function() {
                    var So = arguments, Mo = So[0];
                    if (Br && So.length == 1 && Wc2(Mo))
                      return Br.plant(Mo).value();
                    for (var Ao = 0, Xs = Qt ? xt[Ao].apply(this, So) : Mo; ++Ao < Qt; )
                      Xs = xt[Ao].call(this, Xs);
                    return Xs;
                  };
                });
              }
              function bl(st, xt, Qt, Ae2, an, Un, Br, qr, Ai2, So) {
                var Mo = xt & de2, Ao = xt & mt, Xs = xt & Mt, Yl = xt & (Gt | Ot), Pu = xt & Se2, Mf2 = Xs ? r5 : Zi2(st);
                function Uu() {
                  for (var nc2 = arguments.length, lf2 = _a2(nc2), rb2 = nc2; rb2--; )
                    lf2[rb2] = arguments[rb2];
                  if (Yl)
                    var r1 = r_(Uu), Vt = aQ(lf2, r1);
                  if (Ae2 && (lf2 = Wr(lf2, Ae2, an, Yl)), Un && (lf2 = Gr(lf2, Un, Br, Yl)), nc2 -= Vt, Yl && nc2 < So) {
                    var ve2 = Bk(lf2, r1);
                    return qo(st, xt, bl, Uu.placeholder, Qt, lf2, ve2, qr, Ai2, So - nc2);
                  }
                  var Ut = Ao ? Qt : this, $t = Xs ? Ut[st] : st;
                  return nc2 = lf2.length, qr ? lf2 = bT(lf2, qr) : Pu && nc2 > 1 && lf2.reverse(), Mo && Ai2 < nc2 && (lf2.length = Ai2), this && this !== Xm && this instanceof Uu && ($t = Mf2 || Zi2($t)), $t.apply(Ut, lf2);
                }
                return Uu;
              }
              function vl(st, xt) {
                return function(Qt, Ae2) {
                  return yc2(Qt, st, xt(Ae2), {});
                };
              }
              function xa2(st, xt) {
                return function(Qt, Ae2) {
                  var an;
                  if (Qt === r5 && Ae2 === r5)
                    return xt;
                  if (Qt !== r5 && (an = Qt), Ae2 !== r5) {
                    if (an === r5)
                      return Ae2;
                    typeof Qt == "string" || typeof Ae2 == "string" ? (Qt = C2(Qt), Ae2 = C2(Ae2)) : (Qt = pht(Qt), Ae2 = pht(Ae2)), an = st(Qt, Ae2);
                  }
                  return an;
                };
              }
              function gu(st) {
                return Iv(function(xt) {
                  return xt = Wv(xt, Xb2(vu())), gh2(function(Qt) {
                    var Ae2 = this;
                    return st(xt, function(an) {
                      return S22(an, Ae2, Qt);
                    });
                  });
                });
              }
              function Na2(st, xt) {
                xt = xt === r5 ? " " : C2(xt);
                var Qt = xt.length;
                if (Qt < 2)
                  return Qt ? MQ(xt, st) : xt;
                var Ae2 = MQ(xt, pQ(st / C9(xt)));
                return S9(xt) ? qt(pT(Ae2), 0, st).join("") : Ae2.slice(0, st);
              }
              function ga(st, xt, Qt, Ae2) {
                var an = xt & mt, Un = Zi2(st);
                function Br() {
                  for (var qr = -1, Ai2 = arguments.length, So = -1, Mo = Ae2.length, Ao = _a2(Mo + Ai2), Xs = this && this !== Xm && this instanceof Br ? Un : st; ++So < Mo; )
                    Ao[So] = Ae2[So];
                  for (; Ai2--; )
                    Ao[So++] = arguments[++qr];
                  return S22(Xs, an ? Qt : this, Ao);
                }
                return Br;
              }
              function ca2(st) {
                return function(xt, Qt, Ae2) {
                  return Ae2 && typeof Ae2 != "number" && Fh2(xt, Qt, Ae2) && (Qt = Ae2 = r5), xt = AT(xt), Qt === r5 ? (Qt = xt, xt = 0) : Qt = AT(Qt), Ae2 = Ae2 === r5 ? xt < Qt ? 1 : -1 : AT(Ae2), w$t(xt, Qt, Ae2, st);
                };
              }
              function fs(st) {
                return function(xt, Qt) {
                  return typeof xt == "string" && typeof Qt == "string" || (xt = l_(xt), Qt = l_(Qt)), st(xt, Qt);
                };
              }
              function qo(st, xt, Qt, Ae2, an, Un, Br, qr, Ai2, So) {
                var Mo = xt & Gt, Ao = Mo ? Br : r5, Xs = Mo ? r5 : Br, Yl = Mo ? Un : r5, Pu = Mo ? r5 : Un;
                xt |= Mo ? ce2 : ae2, xt &= ~(Mo ? ae2 : ce2), xt & kt || (xt &= ~(mt | Mt));
                var Mf2 = [st, xt, an, Yl, Ao, Pu, Xs, qr, Ai2, So], Uu = Qt.apply(r5, Mf2);
                return fm(st) && _T(Uu, Mf2), Uu.placeholder = Ae2, Q3(Uu, st, xt);
              }
              function Hu(st) {
                var xt = ny[st];
                return function(Qt, Ae2) {
                  if (Qt = l_(Qt), Ae2 = Ae2 == null ? 0 : Jb2(Hc2(Ae2), 292), Ae2 && BTt(Qt)) {
                    var an = (ld2(Qt) + "e").split("e"), Un = xt(an[0] + "e" + (+an[1] + Ae2));
                    return an = (ld2(Un) + "e").split("e"), +(an[0] + "e" + (+an[1] - Ae2));
                  }
                  return xt(Qt);
                };
              }
              var vh2 = Y32 && 1 / M9(new Y32([, -0]))[1] == Jr ? function(st) {
                return new Y32(st);
              } : ju;
              function Wf2(st) {
                return function(xt) {
                  var Qt = Bi2(xt);
                  return Qt == hu ? Hft(xt) : Qt == Jd2 ? RZt(xt) : rQ(xt, st(xt));
                };
              }
              function mc2(st, xt, Qt, Ae2, an, Un, Br, qr) {
                var Ai2 = xt & Mt;
                if (!Ai2 && typeof st != "function")
                  throw new DM(A2);
                var So = Ae2 ? Ae2.length : 0;
                if (So || (xt &= ~(ce2 | ae2), Ae2 = an = r5), Br = Br === r5 ? Br : um(Hc2(Br), 0), qr = qr === r5 ? qr : Hc2(qr), So -= an ? an.length : 0, xt & ae2) {
                  var Mo = Ae2, Ao = an;
                  Ae2 = an = r5;
                }
                var Xs = Ai2 ? r5 : Ex(st), Yl = [st, xt, Qt, Ae2, an, Mo, Ao, Un, Br, qr];
                if (Xs && i_(Yl, Xs), st = Yl[0], xt = Yl[1], Qt = Yl[2], Ae2 = Yl[3], an = Yl[4], qr = Yl[9] = Yl[9] === r5 ? Ai2 ? 0 : st.length : um(Yl[9] - So, 0), !qr && xt & (Gt | Ot) && (xt &= ~(Gt | Ot)), !xt || xt == mt)
                  var Pu = La2(st, xt, Qt);
                else
                  xt == Gt || xt == Ot ? Pu = Ka2(st, xt, qr) : (xt == ce2 || xt == (mt | ce2)) && !an.length ? Pu = ga(st, xt, Qt, Ae2) : Pu = bl.apply(r5, Yl);
                var Mf2 = Xs ? aAt : _T;
                return Q3(Mf2(Pu, Yl), st, xt);
              }
              function yd2(st, xt, Qt, Ae2) {
                return st === r5 || tb2(st, I9[Qt]) && !zd2.call(Ae2, Qt) ? xt : st;
              }
              function Gf2(st, xt, Qt, Ae2, an, Un) {
                return ng2(st) && ng2(xt) && (Un.set(xt, st), X32(st, xt, r5, Gf2, Un), Un.delete(xt)), st;
              }
              function hp(st) {
                return sS(st) ? r5 : st;
              }
              function Lg2(st, xt, Qt, Ae2, an, Un) {
                var Br = Qt & it, qr = st.length, Ai2 = xt.length;
                if (qr != Ai2 && !(Br && Ai2 > qr))
                  return false;
                var So = Un.get(st), Mo = Un.get(xt);
                if (So && Mo)
                  return So == xt && Mo == st;
                var Ao = -1, Xs = true, Yl = Qt & pt ? new Wk() : r5;
                for (Un.set(st, xt), Un.set(xt, st); ++Ao < qr; ) {
                  var Pu = st[Ao], Mf2 = xt[Ao];
                  if (Ae2)
                    var Uu = Br ? Ae2(Mf2, Pu, Ao, xt, st, Un) : Ae2(Pu, Mf2, Ao, st, xt, Un);
                  if (Uu !== r5) {
                    if (Uu)
                      continue;
                    Xs = false;
                    break;
                  }
                  if (Yl) {
                    if (!L0(xt, function(nc2, lf2) {
                      if (!U32(Yl, lf2) && (Pu === nc2 || an(Pu, nc2, Qt, Ae2, Un)))
                        return Yl.push(lf2);
                    })) {
                      Xs = false;
                      break;
                    }
                  } else if (!(Pu === Mf2 || an(Pu, Mf2, Qt, Ae2, Un))) {
                    Xs = false;
                    break;
                  }
                }
                return Un.delete(st), Un.delete(xt), Xs;
              }
              function n_(st, xt, Qt, Ae2, an, Un, Br) {
                switch (Qt) {
                  case _o:
                    if (st.byteLength != xt.byteLength || st.byteOffset != xt.byteOffset)
                      return false;
                    st = st.buffer, xt = xt.buffer;
                  case ea2:
                    return !(st.byteLength != xt.byteLength || !Un(new QW(st), new QW(xt)));
                  case ss:
                  case Us:
                  case Nh2:
                    return tb2(+st, +xt);
                  case ws:
                    return st.name == xt.name && st.message == xt.message;
                  case U1:
                  case jv:
                    return st == xt + "";
                  case hu:
                    var qr = Hft;
                  case Jd2:
                    var Ai2 = Ae2 & it;
                    if (qr || (qr = M9), st.size != xt.size && !Ai2)
                      return false;
                    var So = Br.get(st);
                    if (So)
                      return So == xt;
                    Ae2 |= pt, Br.set(st, xt);
                    var Mo = Lg2(qr(st), qr(xt), Ae2, an, Un, Br);
                    return Br.delete(st), Mo;
                  case Mv:
                    if (dT)
                      return dT.call(st) == dT.call(xt);
                }
                return false;
              }
              function Dx(st, xt, Qt, Ae2, an, Un) {
                var Br = Qt & it, qr = Gv(st), Ai2 = qr.length, So = Gv(xt), Mo = So.length;
                if (Ai2 != Mo && !Br)
                  return false;
                for (var Ao = Ai2; Ao--; ) {
                  var Xs = qr[Ao];
                  if (!(Br ? Xs in xt : zd2.call(xt, Xs)))
                    return false;
                }
                var Yl = Un.get(st), Pu = Un.get(xt);
                if (Yl && Pu)
                  return Yl == xt && Pu == st;
                var Mf2 = true;
                Un.set(st, xt), Un.set(xt, st);
                for (var Uu = Br; ++Ao < Ai2; ) {
                  Xs = qr[Ao];
                  var nc2 = st[Xs], lf2 = xt[Xs];
                  if (Ae2)
                    var rb2 = Br ? Ae2(lf2, nc2, Xs, xt, st, Un) : Ae2(nc2, lf2, Xs, st, xt, Un);
                  if (!(rb2 === r5 ? nc2 === lf2 || an(nc2, lf2, Qt, Ae2, Un) : rb2)) {
                    Mf2 = false;
                    break;
                  }
                  Uu || (Uu = Xs == "constructor");
                }
                if (Mf2 && !Uu) {
                  var r1 = st.constructor, Vt = xt.constructor;
                  r1 != Vt && "constructor" in st && "constructor" in xt && !(typeof r1 == "function" && r1 instanceof r1 && typeof Vt == "function" && Vt instanceof Vt) && (Mf2 = false);
                }
                return Un.delete(st), Un.delete(xt), Mf2;
              }
              function Iv(st) {
                return YR(a_(st, r5, Ng2), st + "");
              }
              function Gv(st) {
                return aht(st, Zv, eS);
              }
              function Jm(st) {
                return aht(st, Sn, so);
              }
              var Ex = t_ ? function(st) {
                return t_.get(st);
              } : ju;
              function ry(st) {
                for (var xt = st.name + "", Qt = zR[xt], Ae2 = zd2.call(zR, xt) ? Qt.length : 0; Ae2--; ) {
                  var an = Qt[Ae2], Un = an.func;
                  if (Un == null || Un == st)
                    return an.name;
                }
                return xt;
              }
              function r_(st) {
                var xt = zd2.call(En, "placeholder") ? En : st;
                return xt.placeholder;
              }
              function vu() {
                var st = En.iteratee || Ox;
                return st = st === Ox ? qR : st, arguments.length ? st(arguments[0], arguments[1]) : st;
              }
              function t1(st, xt) {
                var Qt = st.__data__;
                return cm(xt) ? Qt[typeof xt == "string" ? "string" : "hash"] : Qt.map;
              }
              function Dv(st) {
                for (var xt = Zv(st), Qt = xt.length; Qt--; ) {
                  var Ae2 = xt[Qt], an = st[Ae2];
                  xt[Qt] = [Ae2, an, Jf2(an)];
                }
                return xt;
              }
              function nv(st, xt) {
                var Qt = lQ(st, xt);
                return fG(Qt) ? Qt : r5;
              }
              function Hv(st) {
                var xt = zd2.call(st, EM), Qt = st[EM];
                try {
                  st[EM] = r5;
                  var Ae2 = true;
                } catch {
                }
                var an = XW.call(st);
                return Ae2 && (xt ? st[EM] = Qt : delete st[EM]), an;
              }
              var eS = $ft ? function(st) {
                return st == null ? [] : (st = vd2(st), G32($ft(st), function(xt) {
                  return fQ.call(st, xt);
                }));
              } : NM, so = $ft ? function(st) {
                for (var xt = []; st; )
                  H3(xt, eS(st)), st = JW(st);
                return xt;
              } : NM, Bi2 = e_;
              (eG && Bi2(new eG(new ArrayBuffer(1))) != _o || nG && Bi2(new nG()) != hu || VR && Bi2(VR.resolve()) != om || Y32 && Bi2(new Y32()) != Jd2 || BR && Bi2(new BR()) != yo) && (Bi2 = function(st) {
                var xt = e_(st), Qt = xt == Xh2 ? st.constructor : r5, Ae2 = Qt ? gn(Qt) : "";
                if (Ae2)
                  switch (Ae2) {
                    case jTt:
                      return _o;
                    case KZt:
                      return hu;
                    case WTt:
                      return om;
                    case XZt:
                      return Jd2;
                    case Py:
                      return yo;
                  }
                return xt;
              });
              function Xi2(st, xt, Qt) {
                for (var Ae2 = -1, an = Qt.length; ++Ae2 < an; ) {
                  var Un = Qt[Ae2], Br = Un.size;
                  switch (Un.type) {
                    case "drop":
                      st += Br;
                      break;
                    case "dropRight":
                      xt -= Br;
                      break;
                    case "take":
                      xt = Jb2(xt, st + Br);
                      break;
                    case "takeRight":
                      st = um(st, xt - Br);
                      break;
                  }
                }
                return { start: st, end: xt };
              }
              function co(st) {
                var xt = st.match(Pft);
                return xt ? xt[1].split(Lft) : [];
              }
              function Es(st, xt, Qt) {
                xt = ge2(xt, st);
                for (var Ae2 = -1, an = xt.length, Un = false; ++Ae2 < an; ) {
                  var Br = Mr(xt[Ae2]);
                  if (!(Un = st != null && Qt(st, Br)))
                    break;
                  st = st[Br];
                }
                return Un || ++Ae2 != an ? Un : (an = st == null ? 0 : st.length, !!an && Wd2(an) && tp(Br, an) && (Wc2(st) || o_(st)));
              }
              function Zl(st) {
                var xt = st.length, Qt = new st.constructor(xt);
                return xt && typeof st[0] == "string" && zd2.call(st, "index") && (Qt.index = st.index, Qt.input = st.input), Qt;
              }
              function Yc2(st) {
                return typeof st.constructor == "function" && !tg2(st) ? jR(JW(st)) : {};
              }
              function Kc2(st, xt, Qt) {
                var Ae2 = st.constructor;
                switch (xt) {
                  case ea2:
                    return Ne2(st);
                  case ss:
                  case Us:
                    return new Ae2(+st);
                  case _o:
                    return Ge2(st, Qt);
                  case Vs:
                  case ru:
                  case kf2:
                  case wf2:
                  case rd2:
                  case Cv:
                  case kg2:
                  case ty:
                  case Pg2:
                    return vn(st, Qt);
                  case hu:
                    return new Ae2();
                  case Nh2:
                  case jv:
                    return new Ae2(st);
                  case U1:
                    return Ve(st);
                  case Jd2:
                    return new Ae2();
                  case Mv:
                    return pn(st);
                }
              }
              function Dp(st, xt) {
                var Qt = xt.length;
                if (!Qt)
                  return st;
                var Ae2 = Qt - 1;
                return xt[Ae2] = (Qt > 1 ? "& " : "") + xt[Ae2], xt = xt.join(Qt > 2 ? ", " : " "), st.replace(kft, `{
/* [wrapped with ` + xt + `] */
`);
              }
              function Og2(st) {
                return Wc2(st) || o_(st) || !!(VTt && st && st[VTt]);
              }
              function tp(st, xt) {
                var Qt = typeof st;
                return xt = xt == null ? Qn : xt, !!xt && (Qt == "number" || Qt != "symbol" && Li2.test(st)) && st > -1 && st % 1 == 0 && st < xt;
              }
              function Fh2(st, xt, Qt) {
                if (!ng2(Qt))
                  return false;
                var Ae2 = typeof xt;
                return (Ae2 == "number" ? ri2(Qt) && tp(xt, Qt.length) : Ae2 == "string" && xt in Qt) ? tb2(Qt[xt], st) : false;
              }
              function md2(st, xt) {
                if (Wc2(st))
                  return false;
                var Qt = typeof st;
                return Qt == "number" || Qt == "symbol" || Qt == "boolean" || st == null || uy(st) ? true : x22.test(st) || !Tx.test(st) || xt != null && st in vd2(xt);
              }
              function cm(st) {
                var xt = typeof st;
                return xt == "string" || xt == "number" || xt == "symbol" || xt == "boolean" ? st !== "__proto__" : st === null;
              }
              function fm(st) {
                var xt = ry(st), Qt = En[xt];
                if (typeof Qt != "function" || !(xt in Jh2.prototype))
                  return false;
                if (st === Qt)
                  return true;
                var Ae2 = Ex(Qt);
                return !!Ae2 && st === Ae2[0];
              }
              function nS(st) {
                return !!RTt && RTt in st;
              }
              var K1 = D9 ? rv : $G;
              function tg2(st) {
                var xt = st && st.constructor, Qt = typeof xt == "function" && xt.prototype || I9;
                return st === Qt;
              }
              function Jf2(st) {
                return st === st && !ng2(st);
              }
              function O0(st, xt) {
                return function(Qt) {
                  return Qt == null ? false : Qt[st] === xt && (xt !== r5 || st in vd2(Qt));
                };
              }
              function hm(st) {
                var xt = Kk(st, function(Ae2) {
                  return Qt.size === B3 && Qt.clear(), Ae2;
                }), Qt = xt.cache;
                return xt;
              }
              function i_(st, xt) {
                var Qt = st[1], Ae2 = xt[1], an = Qt | Ae2, Un = an < (mt | Mt | de2), Br = Ae2 == de2 && Qt == Gt || Ae2 == de2 && Qt == we2 && st[7].length <= xt[8] || Ae2 == (de2 | we2) && xt[7].length <= xt[8] && Qt == Gt;
                if (!(Un || Br))
                  return st;
                Ae2 & mt && (st[2] = xt[2], an |= Qt & mt ? 0 : kt);
                var qr = xt[3];
                if (qr) {
                  var Ai2 = st[3];
                  st[3] = Ai2 ? Wr(Ai2, qr, xt[4]) : qr, st[4] = Ai2 ? Bk(st[3], G3) : xt[4];
                }
                return qr = xt[5], qr && (Ai2 = st[5], st[5] = Ai2 ? Gr(Ai2, qr, xt[6]) : qr, st[6] = Ai2 ? Bk(st[5], G3) : xt[6]), qr = xt[7], qr && (st[7] = qr), Ae2 & de2 && (st[8] = st[8] == null ? xt[8] : Jb2(st[8], xt[8])), st[9] == null && (st[9] = xt[9]), st[0] = xt[0], st[1] = an, st;
              }
              function X1(st) {
                var xt = [];
                if (st != null)
                  for (var Qt in vd2(st))
                    xt.push(Qt);
                return xt;
              }
              function Q1(st) {
                return XW.call(st);
              }
              function a_(st, xt, Qt) {
                return xt = um(xt === r5 ? st.length - 1 : xt, 0), function() {
                  for (var Ae2 = arguments, an = -1, Un = um(Ae2.length - xt, 0), Br = _a2(Un); ++an < Un; )
                    Br[an] = Ae2[xt + an];
                  an = -1;
                  for (var qr = _a2(xt + 1); ++an < xt; )
                    qr[an] = Ae2[an];
                  return qr[xt] = Qt(Br), S22(st, this, qr);
                };
              }
              function mT(st, xt) {
                return xt.length < 2 ? st : HR(st, LM(xt, 0, -1));
              }
              function bT(st, xt) {
                for (var Qt = st.length, Ae2 = Jb2(xt.length, Qt), an = ei2(st); Ae2--; ) {
                  var Un = xt[Ae2];
                  st[Ae2] = tp(Un, Qt) ? an[Un] : r5;
                }
                return st;
              }
              function $R(st, xt) {
                if (!(xt === "constructor" && typeof st[xt] == "function") && xt != "__proto__")
                  return st[xt];
              }
              var _T = O9(aAt), Hk = GZt || function(st, xt) {
                return Xm.setTimeout(st, xt);
              }, YR = O9(oAt);
              function Q3(st, xt, Qt) {
                var Ae2 = xt + "";
                return YR(st, Dp(Ae2, sr(co(Ae2), Qt)));
              }
              function O9(st) {
                var xt = 0, Qt = 0;
                return function() {
                  var Ae2 = ZZt(), an = qe2 - (Ae2 - Qt);
                  if (Qt = Ae2, an > 0) {
                    if (++xt >= rn)
                      return arguments[0];
                  } else
                    xt = 0;
                  return st.apply(r5, arguments);
                };
              }
              function OM(st, xt) {
                var Qt = -1, Ae2 = st.length, an = Ae2 - 1;
                for (xt = xt === r5 ? Ae2 : xt; ++Qt < xt; ) {
                  var Un = hht(Qt, an), Br = st[Un];
                  st[Un] = st[Qt], st[Qt] = Br;
                }
                return st.length = xt, st;
              }
              var ir = hm(function(st) {
                var xt = [];
                return st.charCodeAt(0) === 46 && xt.push(""), st.replace(cD, function(Qt, Ae2, an, Un) {
                  xt.push(an ? Un.replace(Ir, "$1") : Ae2 || Qt);
                }), xt;
              });
              function Mr(st) {
                if (typeof st == "string" || uy(st))
                  return st;
                var xt = st + "";
                return xt == "0" && 1 / st == -Jr ? "-0" : xt;
              }
              function gn(st) {
                if (st != null) {
                  try {
                    return Qb.call(st);
                  } catch {
                  }
                  try {
                    return st + "";
                  } catch {
                  }
                }
                return "";
              }
              function sr(st, xt) {
                return Jw(Ts, function(Qt) {
                  var Ae2 = "_." + Qt[0];
                  xt & Qt[1] && !FR(st, Ae2) && st.push(Ae2);
                }), st.sort();
              }
              function dr(st) {
                if (st instanceof Jh2)
                  return st.clone();
                var xt = new Ix(st.__wrapped__, st.__chain__);
                return xt.__actions__ = ei2(st.__actions__), xt.__index__ = st.__index__, xt.__values__ = st.__values__, xt;
              }
              function ji2(st, xt, Qt) {
                (Qt ? Fh2(st, xt, Qt) : xt === r5) ? xt = 1 : xt = um(Hc2(xt), 0);
                var Ae2 = st == null ? 0 : st.length;
                if (!Ae2 || xt < 1)
                  return [];
                for (var an = 0, Un = 0, Br = _a2(pQ(Ae2 / xt)); an < Ae2; )
                  Br[Un++] = LM(st, an, an += xt);
                return Br;
              }
              function qa2(st) {
                for (var xt = -1, Qt = st == null ? 0 : st.length, Ae2 = 0, an = []; ++xt < Qt; ) {
                  var Un = st[xt];
                  Un && (an[Ae2++] = Un);
                }
                return an;
              }
              function wa2() {
                var st = arguments.length;
                if (!st)
                  return [];
                for (var xt = _a2(st - 1), Qt = arguments[0], Ae2 = st; Ae2--; )
                  xt[Ae2 - 1] = arguments[Ae2];
                return H3(Wc2(Qt) ? ei2(Qt) : [Qt], $1(xt, 1));
              }
              var li2 = gh2(function(st, xt) {
                return va(st) ? lG(st, $1(xt, 1, va, true)) : [];
              }), jo = gh2(function(st, xt) {
                var Qt = Uv(xt);
                return va(Qt) && (Qt = r5), va(st) ? lG(st, $1(xt, 1, va, true), vu(Qt, 2)) : [];
              }), Al = gh2(function(st, xt) {
                var Qt = Uv(xt);
                return va(Qt) && (Qt = r5), va(st) ? lG(st, $1(xt, 1, va, true), r5, Qt) : [];
              });
              function Sf2(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                return Ae2 ? (xt = Qt || xt === r5 ? 1 : Hc2(xt), LM(st, xt < 0 ? 0 : xt, Ae2)) : [];
              }
              function sf2(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                return Ae2 ? (xt = Qt || xt === r5 ? 1 : Hc2(xt), xt = Ae2 - xt, LM(st, 0, xt < 0 ? 0 : xt)) : [];
              }
              function Vc2(st, xt) {
                return st && st.length ? IQ(st, vu(xt, 3), true, true) : [];
              }
              function zu(st, xt) {
                return st && st.length ? IQ(st, vu(xt, 3), true) : [];
              }
              function ad2(st, xt, Qt, Ae2) {
                var an = st == null ? 0 : st.length;
                return an ? (Qt && typeof Qt != "number" && Fh2(st, xt, Qt) && (Qt = 0, Ae2 = an), rht(st, xt, Qt, Ae2)) : [];
              }
              function Rg2(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                if (!Ae2)
                  return -1;
                var an = Qt == null ? 0 : Hc2(Qt);
                return an < 0 && (an = um(Ae2 + an, 0)), x9(st, vu(xt, 3), an);
              }
              function bc2(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                if (!Ae2)
                  return -1;
                var an = Ae2 - 1;
                return Qt !== r5 && (an = Hc2(Qt), an = Qt < 0 ? um(Ae2 + an, 0) : Jb2(an, Ae2 - 1)), x9(st, vu(xt, 3), an, true);
              }
              function Ng2(st) {
                var xt = st == null ? 0 : st.length;
                return xt ? $1(st, 1) : [];
              }
              function pm(st) {
                var xt = st == null ? 0 : st.length;
                return xt ? $1(st, Jr) : [];
              }
              function T22(st, xt) {
                var Qt = st == null ? 0 : st.length;
                return Qt ? (xt = xt === r5 ? 1 : Hc2(xt), $1(st, xt)) : [];
              }
              function yD(st) {
                for (var xt = -1, Qt = st == null ? 0 : st.length, Ae2 = {}; ++xt < Qt; ) {
                  var an = st[xt];
                  Ae2[an[0]] = an[1];
                }
                return Ae2;
              }
              function rS(st) {
                return st && st.length ? st[0] : r5;
              }
              function Uk(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                if (!Ae2)
                  return -1;
                var an = Qt == null ? 0 : Hc2(Qt);
                return an < 0 && (an = um(Ae2 + an, 0)), Vk(st, xt, an);
              }
              function xT(st) {
                var xt = st == null ? 0 : st.length;
                return xt ? LM(st, 0, -1) : [];
              }
              var iy = gh2(function(st) {
                var xt = Wv(st, ght);
                return xt.length && xt[0] === st[0] ? sht(xt) : [];
              }), A22 = gh2(function(st) {
                var xt = Uv(st), Qt = Wv(st, ght);
                return xt === Uv(Qt) ? xt = r5 : Qt.pop(), Qt.length && Qt[0] === st[0] ? sht(Qt, vu(xt, 2)) : [];
              }), ay = gh2(function(st) {
                var xt = Uv(st), Qt = Wv(st, ght);
                return xt = typeof xt == "function" ? xt : r5, xt && Qt.pop(), Qt.length && Qt[0] === st[0] ? sht(Qt, r5, xt) : [];
              });
              function RM(st, xt) {
                return st == null ? "" : UZt.call(st, xt);
              }
              function Uv(st) {
                var xt = st == null ? 0 : st.length;
                return xt ? st[xt - 1] : r5;
              }
              function qk2(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                if (!Ae2)
                  return -1;
                var an = Ae2;
                return Qt !== r5 && (an = Hc2(Qt), an = an < 0 ? um(Ae2 + an, 0) : Jb2(an, Ae2 - 1)), xt === xt ? FZt(st, xt, an) : x9(st, nQ, an, true);
              }
              function KR(st, xt) {
                return st && st.length ? cht(st, Hc2(xt)) : r5;
              }
              var kx = gh2(wT);
              function wT(st, xt) {
                return st && st.length && xt && xt.length ? SQ(st, xt) : st;
              }
              function ST(st, xt, Qt) {
                return st && st.length && xt && xt.length ? SQ(st, xt, vu(Qt, 2)) : st;
              }
              function Ly(st, xt, Qt) {
                return st && st.length && xt && xt.length ? SQ(st, xt, r5, Qt) : st;
              }
              var XR = Iv(function(st, xt) {
                var Qt = st == null ? 0 : st.length, Ae2 = gQ(st, xt);
                return ZR(st, Wv(xt, function(an) {
                  return tp(an, Qt) ? +an : an;
                }).sort(Gn)), Ae2;
              });
              function I22(st, xt) {
                var Qt = [];
                if (!(st && st.length))
                  return Qt;
                var Ae2 = -1, an = [], Un = st.length;
                for (xt = vu(xt, 3); ++Ae2 < Un; ) {
                  var Br = st[Ae2];
                  xt(Br, Ae2, st) && (Qt.push(Br), an.push(Ae2));
                }
                return ZR(st, an), Qt;
              }
              function mD(st) {
                return st == null ? st : YZt.call(st);
              }
              function Zk(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                return Ae2 ? (Qt && typeof Qt != "number" && Fh2(st, xt, Qt) ? (xt = 0, Qt = Ae2) : (xt = xt == null ? 0 : Hc2(xt), Qt = Qt === r5 ? Ae2 : Hc2(Qt)), LM(st, xt, Qt)) : [];
              }
              function EQ(st, xt) {
                return TQ(st, xt);
              }
              function kQ(st, xt, Qt) {
                return AQ(st, xt, vu(Qt, 2));
              }
              function vht(st, xt) {
                var Qt = st == null ? 0 : st.length;
                if (Qt) {
                  var Ae2 = TQ(st, xt);
                  if (Ae2 < Qt && tb2(st[Ae2], xt))
                    return Ae2;
                }
                return -1;
              }
              function pG(st, xt) {
                return TQ(st, xt, true);
              }
              function dG(st, xt, Qt) {
                return AQ(st, xt, vu(Qt, 2), true);
              }
              function PQ(st, xt) {
                var Qt = st == null ? 0 : st.length;
                if (Qt) {
                  var Ae2 = TQ(st, xt, true) - 1;
                  if (tb2(st[Ae2], xt))
                    return Ae2;
                }
                return -1;
              }
              function gG(st) {
                return st && st.length ? sAt(st) : [];
              }
              function R9(st, xt) {
                return st && st.length ? sAt(st, vu(xt, 2)) : [];
              }
              function yht(st) {
                var xt = st == null ? 0 : st.length;
                return xt ? LM(st, 1, xt) : [];
              }
              function LQ(st, xt, Qt) {
                return st && st.length ? (xt = Qt || xt === r5 ? 1 : Hc2(xt), LM(st, 0, xt < 0 ? 0 : xt)) : [];
              }
              function vG(st, xt, Qt) {
                var Ae2 = st == null ? 0 : st.length;
                return Ae2 ? (xt = Qt || xt === r5 ? 1 : Hc2(xt), xt = Ae2 - xt, LM(st, xt < 0 ? 0 : xt, Ae2)) : [];
              }
              function OQ(st, xt) {
                return st && st.length ? IQ(st, vu(xt, 3), false, true) : [];
              }
              function yG(st, xt) {
                return st && st.length ? IQ(st, vu(xt, 3)) : [];
              }
              var mG = gh2(function(st) {
                return vD($1(st, 1, va, true));
              }), e1 = gh2(function(st) {
                var xt = Uv(st);
                return va(xt) && (xt = r5), vD($1(st, 1, va, true), vu(xt, 2));
              }), QR = gh2(function(st) {
                var xt = Uv(st);
                return xt = typeof xt == "function" ? xt : r5, vD($1(st, 1, va, true), r5, xt);
              });
              function RQ(st) {
                return st && st.length ? vD(st) : [];
              }
              function mht(st, xt) {
                return st && st.length ? vD(st, vu(xt, 2)) : [];
              }
              function bht(st, xt) {
                return xt = typeof xt == "function" ? xt : r5, st && st.length ? vD(st, r5, xt) : [];
              }
              function iS(st) {
                if (!(st && st.length))
                  return [];
                var xt = 0;
                return st = G32(st, function(Qt) {
                  if (va(Qt))
                    return xt = um(Qt.length, xt), true;
                }), ZW(xt, function(Qt) {
                  return Wv(st, HW(Qt));
                });
              }
              function bG(st, xt) {
                if (!(st && st.length))
                  return [];
                var Qt = iS(st);
                return xt == null ? Qt : Wv(Qt, function(Ae2) {
                  return S22(xt, r5, Ae2);
                });
              }
              var Fg2 = gh2(function(st, xt) {
                return va(st) ? lG(st, xt) : [];
              }), jd2 = gh2(function(st) {
                return DQ(G32(st, va));
              }), _G = gh2(function(st) {
                var xt = Uv(st);
                return va(xt) && (xt = r5), DQ(G32(st, va), vu(xt, 2));
              }), NQ = gh2(function(st) {
                var xt = Uv(st);
                return xt = typeof xt == "function" ? xt : r5, DQ(G32(st, va), r5, xt);
              }), xG = gh2(iS);
              function _ht(st, xt) {
                return cAt(st || [], xt || [], oG);
              }
              function FQ(st, xt) {
                return cAt(st || [], xt || [], hG);
              }
              var xht = gh2(function(st) {
                var xt = st.length, Qt = xt > 1 ? st[xt - 1] : r5;
                return Qt = typeof Qt == "function" ? (st.pop(), Qt) : r5, bG(st, Qt);
              });
              function N9(st) {
                var xt = En(st);
                return xt.__chain__ = true, xt;
              }
              function VQ(st, xt) {
                return xt(st), st;
              }
              function qv(st, xt) {
                return xt(st);
              }
              var F9 = Iv(function(st) {
                var xt = st.length, Qt = xt ? st[0] : 0, Ae2 = this.__wrapped__, an = function(Un) {
                  return gQ(Un, st);
                };
                return xt > 1 || this.__actions__.length || !(Ae2 instanceof Jh2) || !tp(Qt) ? this.thru(an) : (Ae2 = Ae2.slice(Qt, +Qt + (xt ? 1 : 0)), Ae2.__actions__.push({ func: qv, args: [an], thisArg: r5 }), new Ix(Ae2, this.__chain__).thru(function(Un) {
                  return xt && !Un.length && Un.push(r5), Un;
                }));
              });
              function bD() {
                return N9(this);
              }
              function BQ() {
                return new Ix(this.value(), this.__chain__);
              }
              function wG() {
                this.__values__ === r5 && (this.__values__ = tJ(this.value()));
                var st = this.__index__ >= this.__values__.length, xt = st ? r5 : this.__values__[this.__index__++];
                return { done: st, value: xt };
              }
              function aS() {
                return this;
              }
              function J3(st) {
                for (var xt, Qt = this; Qt instanceof rG; ) {
                  var Ae2 = dr(Qt);
                  Ae2.__index__ = 0, Ae2.__values__ = r5, xt ? an.__wrapped__ = Ae2 : xt = Ae2;
                  var an = Ae2;
                  Qt = Qt.__wrapped__;
                }
                return an.__wrapped__ = st, xt;
              }
              function zQ() {
                var st = this.__wrapped__;
                if (st instanceof Jh2) {
                  var xt = st;
                  return this.__actions__.length && (xt = new Jh2(this)), xt = xt.reverse(), xt.__actions__.push({ func: qv, args: [mD], thisArg: r5 }), new Ix(xt, this.__chain__);
                }
                return this.thru(mD);
              }
              function jQ() {
                return uAt(this.__wrapped__, this.__actions__);
              }
              var JR = Go(function(st, xt, Qt) {
                zd2.call(st, Qt) ? ++st[Qt] : Gk(st, Qt, 1);
              });
              function V9(st, xt, Qt) {
                var Ae2 = Wc2(st) ? PTt : QTt;
                return Qt && Fh2(st, xt, Qt) && (xt = r5), Ae2(st, vu(xt, 3));
              }
              function SG(st, xt) {
                var Qt = Wc2(st) ? G32 : E9;
                return Qt(st, vu(xt, 3));
              }
              var Px = Fo(Rg2), wht = Fo(bc2);
              function J1(st, xt) {
                return $1(_D(st, xt), 1);
              }
              function Sht(st, xt) {
                return $1(_D(st, xt), Jr);
              }
              function WQ(st, xt, Qt) {
                return Qt = Qt === r5 ? 1 : Hc2(Qt), $1(_D(st, xt), Qt);
              }
              function MT(st, xt) {
                var Qt = Wc2(st) ? Jw : K3;
                return Qt(st, vu(xt, 3));
              }
              function tL(st, xt) {
                var Qt = Wc2(st) ? kTt : XTt;
                return Qt(st, vu(xt, 3));
              }
              var MG = Go(function(st, xt, Qt) {
                zd2.call(st, Qt) ? st[Qt].push(xt) : Gk(st, Qt, [xt]);
              });
              function Xc2(st, xt, Qt, Ae2) {
                st = ri2(st) ? st : lL(st), Qt = Qt && !Ae2 ? Hc2(Qt) : 0;
                var an = st.length;
                return Qt < 0 && (Qt = um(an + Qt, 0)), l6(st) ? Qt <= an && st.indexOf(xt, Qt) > -1 : !!an && Vk(st, xt, Qt) > -1;
              }
              var oS = gh2(function(st, xt, Qt) {
                var Ae2 = -1, an = typeof xt == "function", Un = ri2(st) ? _a2(st.length) : [];
                return K3(st, function(Br) {
                  Un[++Ae2] = an ? S22(xt, Br, Qt) : k9(Br, xt, Qt);
                }), Un;
              }), B9 = Go(function(st, xt, Qt) {
                Gk(st, Qt, xt);
              });
              function _D(st, xt) {
                var Qt = Wc2(st) ? Wv : rAt;
                return Qt(st, vu(xt, 3));
              }
              function t6(st, xt, Qt, Ae2) {
                return st == null ? [] : (Wc2(xt) || (xt = xt == null ? [] : [xt]), Qt = Ae2 ? r5 : Qt, Wc2(Qt) || (Qt = Qt == null ? [] : [Qt]), fht(st, xt, Qt));
              }
              var CG = Go(function(st, xt, Qt) {
                st[Qt ? 0 : 1].push(xt);
              }, function() {
                return [[], []];
              });
              function z9(st, xt, Qt) {
                var Ae2 = Wc2(st) ? tQ : Id2, an = arguments.length < 3;
                return Ae2(st, vu(xt, 4), Qt, an, K3);
              }
              function Mht(st, xt, Qt) {
                var Ae2 = Wc2(st) ? EZt : Id2, an = arguments.length < 3;
                return Ae2(st, vu(xt, 4), Qt, an, XTt);
              }
              function j9(st, xt) {
                var Qt = Wc2(st) ? G32 : E9;
                return Qt(st, G9(vu(xt, 3)));
              }
              function W9(st) {
                var xt = Wc2(st) ? aG : CQ;
                return xt(st);
              }
              function xD(st, xt, Qt) {
                (Qt ? Fh2(st, xt, Qt) : xt === r5) ? xt = 1 : xt = Hc2(xt);
                var Ae2 = Wc2(st) ? h$t : S$t;
                return Ae2(st, xt);
              }
              function TG(st) {
                var xt = Wc2(st) ? p$t : M$t;
                return xt(st);
              }
              function od2(st) {
                if (st == null)
                  return 0;
                if (ri2(st))
                  return l6(st) ? C9(st) : st.length;
                var xt = Bi2(st);
                return xt == hu || xt == Jd2 ? st.size : L9(st).length;
              }
              function oy(st, xt, Qt) {
                var Ae2 = Wc2(st) ? L0 : C$t;
                return Qt && Fh2(st, xt, Qt) && (xt = r5), Ae2(st, vu(xt, 3));
              }
              var e6 = gh2(function(st, xt) {
                if (st == null)
                  return [];
                var Qt = xt.length;
                return Qt > 1 && Fh2(st, xt[0], xt[1]) ? xt = [] : Qt > 2 && Fh2(xt[0], xt[1], xt[2]) && (xt = [xt[0]]), fht(st, $1(xt, 1), []);
              }), wD = fp || function() {
                return Xm.Date.now();
              };
              function n6(st, xt) {
                if (typeof xt != "function")
                  throw new DM(A2);
                return st = Hc2(st), function() {
                  if (--st < 1)
                    return xt.apply(this, arguments);
                };
              }
              function r6(st, xt, Qt) {
                return xt = Qt ? r5 : xt, xt = st && xt == null ? st.length : xt, mc2(st, de2, r5, r5, r5, r5, xt);
              }
              function $k(st, xt) {
                var Qt;
                if (typeof xt != "function")
                  throw new DM(A2);
                return st = Hc2(st), function() {
                  return --st > 0 && (Qt = xt.apply(this, arguments)), st <= 1 && (xt = r5), Qt;
                };
              }
              var SD = gh2(function(st, xt, Qt) {
                var Ae2 = mt;
                if (Qt.length) {
                  var an = Bk(Qt, r_(SD));
                  Ae2 |= ce2;
                }
                return mc2(st, Ae2, xt, Qt, an);
              }), i6 = gh2(function(st, xt, Qt) {
                var Ae2 = mt | Mt;
                if (Qt.length) {
                  var an = Bk(Qt, r_(i6));
                  Ae2 |= ce2;
                }
                return mc2(xt, Ae2, st, Qt, an);
              });
              function a6(st, xt, Qt) {
                xt = Qt ? r5 : xt;
                var Ae2 = mc2(st, Gt, r5, r5, r5, r5, r5, xt);
                return Ae2.placeholder = a6.placeholder, Ae2;
              }
              function dm(st, xt, Qt) {
                xt = Qt ? r5 : xt;
                var Ae2 = mc2(st, Ot, r5, r5, r5, r5, r5, xt);
                return Ae2.placeholder = dm.placeholder, Ae2;
              }
              function Yk(st, xt, Qt) {
                var Ae2, an, Un, Br, qr, Ai2, So = 0, Mo = false, Ao = false, Xs = true;
                if (typeof st != "function")
                  throw new DM(A2);
                xt = l_(xt) || 0, ng2(Qt) && (Mo = !!Qt.leading, Ao = "maxWait" in Qt, Un = Ao ? um(l_(Qt.maxWait) || 0, xt) : Un, Xs = "trailing" in Qt ? !!Qt.trailing : Xs);
                function Yl(ve2) {
                  var Ut = Ae2, $t = an;
                  return Ae2 = an = r5, So = ve2, Br = st.apply($t, Ut), Br;
                }
                function Pu(ve2) {
                  return So = ve2, qr = Hk(nc2, xt), Mo ? Yl(ve2) : Br;
                }
                function Mf2(ve2) {
                  var Ut = ve2 - Ai2, $t = ve2 - So, Yt = xt - Ut;
                  return Ao ? Jb2(Yt, Un - $t) : Yt;
                }
                function Uu(ve2) {
                  var Ut = ve2 - Ai2, $t = ve2 - So;
                  return Ai2 === r5 || Ut >= xt || Ut < 0 || Ao && $t >= Un;
                }
                function nc2() {
                  var ve2 = wD();
                  if (Uu(ve2))
                    return lf2(ve2);
                  qr = Hk(nc2, Mf2(ve2));
                }
                function lf2(ve2) {
                  return qr = r5, Xs && Ae2 ? Yl(ve2) : (Ae2 = an = r5, Br);
                }
                function rb2() {
                  qr !== r5 && Zt(qr), So = 0, Ae2 = Ai2 = an = qr = r5;
                }
                function r1() {
                  return qr === r5 ? Br : lf2(wD());
                }
                function Vt() {
                  var ve2 = wD(), Ut = Uu(ve2);
                  if (Ae2 = arguments, an = this, Ai2 = ve2, Ut) {
                    if (qr === r5)
                      return Pu(Ai2);
                    if (Ao)
                      return Zt(qr), qr = Hk(nc2, xt), Yl(Ai2);
                  }
                  return qr === r5 && (qr = Hk(nc2, xt)), Br;
                }
                return Vt.cancel = rb2, Vt.flush = r1, Vt;
              }
              var MD = gh2(function(st, xt) {
                return KTt(st, 1, xt);
              }), GQ = gh2(function(st, xt, Qt) {
                return KTt(st, l_(xt) || 0, Qt);
              });
              function o6(st) {
                return mc2(st, Se2);
              }
              function Kk(st, xt) {
                if (typeof st != "function" || xt != null && typeof xt != "function")
                  throw new DM(A2);
                var Qt = function() {
                  var Ae2 = arguments, an = xt ? xt.apply(this, Ae2) : Ae2[0], Un = Qt.cache;
                  if (Un.has(an))
                    return Un.get(an);
                  var Br = st.apply(this, Ae2);
                  return Qt.cache = Un.set(an, Br) || Un, Br;
                };
                return Qt.cache = new (Kk.Cache || vT)(), Qt;
              }
              Kk.Cache = vT;
              function G9(st) {
                if (typeof st != "function")
                  throw new DM(A2);
                return function() {
                  var xt = arguments;
                  switch (xt.length) {
                    case 0:
                      return !st.call(this);
                    case 1:
                      return !st.call(this, xt[0]);
                    case 2:
                      return !st.call(this, xt[0], xt[1]);
                    case 3:
                      return !st.call(this, xt[0], xt[1], xt[2]);
                  }
                  return !st.apply(this, xt);
                };
              }
              function Cht(st) {
                return $k(2, st);
              }
              var Tht = Ht(function(st, xt) {
                xt = xt.length == 1 && Wc2(xt[0]) ? Wv(xt[0], Xb2(vu())) : Wv($1(xt, 1), Xb2(vu()));
                var Qt = xt.length;
                return gh2(function(Ae2) {
                  for (var an = -1, Un = Jb2(Ae2.length, Qt); ++an < Un; )
                    Ae2[an] = xt[an].call(this, Ae2[an]);
                  return S22(st, this, Ae2);
                });
              }), AG = gh2(function(st, xt) {
                var Qt = Bk(xt, r_(AG));
                return mc2(st, ce2, r5, xt, Qt);
              }), sy = gh2(function(st, xt) {
                var Qt = Bk(xt, r_(sy));
                return mc2(st, ae2, r5, xt, Qt);
              }), HQ = Iv(function(st, xt) {
                return mc2(st, we2, r5, r5, r5, xt);
              });
              function IG(st, xt) {
                if (typeof st != "function")
                  throw new DM(A2);
                return xt = xt === r5 ? xt : Hc2(xt), gh2(st, xt);
              }
              function DG(st, xt) {
                if (typeof st != "function")
                  throw new DM(A2);
                return xt = xt == null ? 0 : um(Hc2(xt), 0), gh2(function(Qt) {
                  var Ae2 = Qt[xt], an = qt(Qt, 0, xt);
                  return Ae2 && H3(an, Ae2), S22(st, this, an);
                });
              }
              function UQ(st, xt, Qt) {
                var Ae2 = true, an = true;
                if (typeof st != "function")
                  throw new DM(A2);
                return ng2(Qt) && (Ae2 = "leading" in Qt ? !!Qt.leading : Ae2, an = "trailing" in Qt ? !!Qt.trailing : an), Yk(st, xt, { leading: Ae2, maxWait: xt, trailing: an });
              }
              function CD(st) {
                return r6(st, 1);
              }
              function H9(st, xt) {
                return AG(Bt(xt), st);
              }
              function Aht() {
                if (!arguments.length)
                  return [];
                var st = arguments[0];
                return Wc2(st) ? st : [st];
              }
              function qQ(st) {
                return PM(st, tt);
              }
              function Iht(st, xt) {
                return xt = typeof xt == "function" ? xt : r5, PM(st, tt, xt);
              }
              function Pf2(st) {
                return PM(st, Z3 | tt);
              }
              function n1(st, xt) {
                return xt = typeof xt == "function" ? xt : r5, PM(st, Z3 | tt, xt);
              }
              function eg2(st, xt) {
                return xt == null || YTt(st, xt, Zv(xt));
              }
              function tb2(st, xt) {
                return st === xt || st !== st && xt !== xt;
              }
              var EG = fs(mQ), ZQ = fs(function(st, xt) {
                return st >= xt;
              }), o_ = eAt(function() {
                return arguments;
              }()) ? eAt : function(st) {
                return rg2(st) && zd2.call(st, "callee") && !fQ.call(st, "callee");
              }, Wc2 = _a2.isArray, CT = Wft ? Xb2(Wft) : g$t;
              function ri2(st) {
                return st != null && Wd2(st.length) && !rv(st);
              }
              function va(st) {
                return rg2(st) && ri2(st);
              }
              function ya2(st) {
                return st === true || st === false || rg2(st) && e_(st) == ss;
              }
              var Zs = HZt || $G, Gc2 = ATt ? Xb2(ATt) : v$t;
              function pp(st) {
                return rg2(st) && st.nodeType === 1 && !sS(st);
              }
              function ly(st) {
                if (st == null)
                  return true;
                if (ri2(st) && (Wc2(st) || typeof st == "string" || typeof st.splice == "function" || Zs(st) || TT(st) || o_(st)))
                  return !st.length;
                var xt = Bi2(st);
                if (xt == hu || xt == Jd2)
                  return !st.size;
                if (tg2(st))
                  return !L9(st).length;
                for (var Qt in st)
                  if (zd2.call(st, Qt))
                    return false;
                return true;
              }
              function bd2(st, xt) {
                return P9(st, xt);
              }
              function kG(st, xt, Qt) {
                Qt = typeof Qt == "function" ? Qt : r5;
                var Ae2 = Qt ? Qt(st, xt) : r5;
                return Ae2 === r5 ? P9(st, xt, r5, Qt) : !!Ae2;
              }
              function PG(st) {
                if (!rg2(st))
                  return false;
                var xt = e_(st);
                return xt == ws || xt == sl || typeof st.message == "string" && typeof st.name == "string" && !sS(st);
              }
              function s_(st) {
                return typeof st == "number" && BTt(st);
              }
              function rv(st) {
                if (!ng2(st))
                  return false;
                var xt = e_(st);
                return xt == Ll || xt == dh2 || xt == rl || xt == Sv;
              }
              function $Q(st) {
                return typeof st == "number" && st == Hc2(st);
              }
              function Wd2(st) {
                return typeof st == "number" && st > -1 && st % 1 == 0 && st <= Qn;
              }
              function ng2(st) {
                var xt = typeof st;
                return st != null && (xt == "object" || xt == "function");
              }
              function rg2(st) {
                return st != null && typeof st == "object";
              }
              var sd2 = ITt ? Xb2(ITt) : UR;
              function YQ(st, xt) {
                return st === xt || cG(st, xt, Dv(xt));
              }
              function KQ(st, xt, Qt) {
                return Qt = typeof Qt == "function" ? Qt : r5, cG(st, xt, Dv(xt), Qt);
              }
              function U9(st) {
                return eL(st) && st != +st;
              }
              function Dht(st) {
                if (K1(st))
                  throw new vc2(S2);
                return fG(st);
              }
              function XQ(st) {
                return st === null;
              }
              function QQ(st) {
                return st == null;
              }
              function eL(st) {
                return typeof st == "number" || rg2(st) && e_(st) == Nh2;
              }
              function sS(st) {
                if (!rg2(st) || e_(st) != Xh2)
                  return false;
                var xt = JW(st);
                if (xt === null)
                  return true;
                var Qt = zd2.call(xt, "constructor") && xt.constructor;
                return typeof Qt == "function" && Qt instanceof Qt && Qb.call(Qt) == zZt;
              }
              var TD = DTt ? Xb2(DTt) : y$t;
              function nL(st) {
                return $Q(st) && st >= -Qn && st <= Qn;
              }
              var s6 = _9 ? Xb2(_9) : nAt;
              function l6(st) {
                return typeof st == "string" || !Wc2(st) && rg2(st) && e_(st) == jv;
              }
              function uy(st) {
                return typeof st == "symbol" || rg2(st) && e_(st) == Mv;
              }
              var TT = ETt ? Xb2(ETt) : m$t;
              function JQ(st) {
                return st === r5;
              }
              function Lf2(st) {
                return rg2(st) && Bi2(st) == yo;
              }
              function Xk(st) {
                return rg2(st) && e_(st) == oa2;
              }
              var q9 = fs(xQ), Eht = fs(function(st, xt) {
                return st <= xt;
              });
              function tJ(st) {
                if (!st)
                  return [];
                if (ri2(st))
                  return l6(st) ? pT(st) : ei2(st);
                if (tG && st[tG])
                  return OZt(st[tG]());
                var xt = Bi2(st), Qt = xt == hu ? Hft : xt == Jd2 ? M9 : lL;
                return Qt(st);
              }
              function AT(st) {
                if (!st)
                  return st === 0 ? st : 0;
                if (st = l_(st), st === Jr || st === -Jr) {
                  var xt = st < 0 ? -1 : 1;
                  return xt * rr;
                }
                return st === st ? st : 0;
              }
              function Hc2(st) {
                var xt = AT(st), Qt = xt % 1;
                return xt === xt ? Qt ? xt - Qt : xt : 0;
              }
              function u6(st) {
                return st ? GR(Hc2(st), 0, fi2) : 0;
              }
              function l_(st) {
                if (typeof st == "number")
                  return st;
                if (uy(st))
                  return Ar;
                if (ng2(st)) {
                  var xt = typeof st.valueOf == "function" ? st.valueOf() : st;
                  st = ng2(xt) ? xt + "" : xt;
                }
                if (typeof st != "string")
                  return st === 0 ? st : +st;
                st = $W(st);
                var Qt = Gi2.test(st);
                return Qt || Ta2.test(st) ? TTt(st.slice(2), Qt ? 2 : 8) : er.test(st) ? Ar : +st;
              }
              function eJ(st) {
                return oi2(st, Sn(st));
              }
              function nJ(st) {
                return st ? GR(Hc2(st), -Qn, Qn) : st === 0 ? st : 0;
              }
              function ld2(st) {
                return st == null ? "" : C2(st);
              }
              var kht = un(function(st, xt) {
                if (tg2(xt) || ri2(xt)) {
                  oi2(xt, Zv(xt), st);
                  return;
                }
                for (var Qt in xt)
                  zd2.call(xt, Qt) && oG(st, Qt, xt[Qt]);
              }), R0 = un(function(st, xt) {
                oi2(xt, Sn(xt), st);
              }), cy = un(function(st, xt, Qt, Ae2) {
                oi2(xt, Sn(xt), st, Ae2);
              }), LG = un(function(st, xt, Qt, Ae2) {
                oi2(xt, Zv(xt), st, Ae2);
              }), Pht = Iv(gQ);
              function rL(st, xt) {
                var Qt = jR(st);
                return xt == null ? Qt : eht(Qt, xt);
              }
              var OG = gh2(function(st, xt) {
                st = vd2(st);
                var Qt = -1, Ae2 = xt.length, an = Ae2 > 2 ? xt[2] : r5;
                for (an && Fh2(xt[0], xt[1], an) && (Ae2 = 1); ++Qt < Ae2; )
                  for (var Un = xt[Qt], Br = Sn(Un), qr = -1, Ai2 = Br.length; ++qr < Ai2; ) {
                    var So = Br[qr], Mo = st[So];
                    (Mo === r5 || tb2(Mo, I9[So]) && !zd2.call(st, So)) && (st[So] = Un[So]);
                  }
                return st;
              }), c6 = gh2(function(st) {
                return st.push(r5, Gf2), S22(yh2, r5, st);
              });
              function IT(st, xt) {
                return eQ(st, vu(xt, 3), Y1);
              }
              function eb2(st, xt) {
                return eQ(st, vu(xt, 3), vQ);
              }
              function Qk(st, xt) {
                return st == null ? st : iht(st, vu(xt, 3), Sn);
              }
              function iL(st, xt) {
                return st == null ? st : JTt(st, vu(xt, 3), Sn);
              }
              function f6(st, xt) {
                return st && Y1(st, vu(xt, 3));
              }
              function h6(st, xt) {
                return st && vQ(st, vu(xt, 3));
              }
              function aL(st) {
                return st == null ? [] : yQ(st, Zv(st));
              }
              function N0(st) {
                return st == null ? [] : yQ(st, Sn(st));
              }
              function AD(st, xt, Qt) {
                var Ae2 = st == null ? r5 : HR(st, xt);
                return Ae2 === r5 ? Qt : Ae2;
              }
              function Jk(st, xt) {
                return st != null && Es(st, xt, oht);
              }
              function Z9(st, xt) {
                return st != null && Es(st, xt, tAt);
              }
              var p6 = vl(function(st, xt, Qt) {
                xt != null && typeof xt.toString != "function" && (xt = XW.call(xt)), st[xt] = Qt;
              }, WG(nb2)), d6 = vl(function(st, xt, Qt) {
                xt != null && typeof xt.toString != "function" && (xt = XW.call(xt)), zd2.call(st, xt) ? st[xt].push(Qt) : st[xt] = [Qt];
              }, vu), oL = gh2(k9);
              function Zv(st) {
                return ri2(st) ? $Tt(st) : L9(st);
              }
              function Sn(st) {
                return ri2(st) ? $Tt(st, true) : lht(st);
              }
              function sL(st, xt) {
                var Qt = {};
                return xt = vu(xt, 3), Y1(st, function(Ae2, an, Un) {
                  Gk(Qt, xt(Ae2, an, Un), Ae2);
                }), Qt;
              }
              function $9(st, xt) {
                var Qt = {};
                return xt = vu(xt, 3), Y1(st, function(Ae2, an, Un) {
                  Gk(Qt, an, xt(Ae2, an, Un));
                }), Qt;
              }
              var Lx = un(function(st, xt, Qt) {
                X32(st, xt, Qt);
              }), yh2 = un(function(st, xt, Qt, Ae2) {
                X32(st, xt, Qt, Ae2);
              }), Lht = Iv(function(st, xt) {
                var Qt = {};
                if (st == null)
                  return Qt;
                var Ae2 = false;
                xt = Wv(xt, function(Un) {
                  return Un = ge2(Un, st), Ae2 || (Ae2 = Un.length > 1), Un;
                }), oi2(st, Jm(st), Qt), Ae2 && (Qt = PM(Qt, Z3 | X3 | tt, hp));
                for (var an = xt.length; an--; )
                  dht(Qt, xt[an]);
                return Qt;
              });
              function RG(st, xt) {
                return ID(st, G9(vu(xt)));
              }
              var NG = Iv(function(st, xt) {
                return st == null ? {} : _$t(st, xt);
              });
              function ID(st, xt) {
                if (st == null)
                  return {};
                var Qt = Wv(Jm(st), function(Ae2) {
                  return [Ae2];
                });
                return xt = vu(xt), iAt(st, Qt, function(Ae2, an) {
                  return xt(Ae2, an[0]);
                });
              }
              function Oht(st, xt, Qt) {
                xt = ge2(xt, st);
                var Ae2 = -1, an = xt.length;
                for (an || (an = 1, st = r5); ++Ae2 < an; ) {
                  var Un = st == null ? r5 : st[Mr(xt[Ae2])];
                  Un === r5 && (Ae2 = an, Un = Qt), st = rv(Un) ? Un.call(st) : Un;
                }
                return st;
              }
              function FG(st, xt, Qt) {
                return st == null ? st : hG(st, xt, Qt);
              }
              function Rht(st, xt, Qt, Ae2) {
                return Ae2 = typeof Ae2 == "function" ? Ae2 : r5, st == null ? st : hG(st, xt, Qt, Ae2);
              }
              var Y9 = Wf2(Zv), rJ = Wf2(Sn);
              function F0(st, xt, Qt) {
                var Ae2 = Wc2(st), an = Ae2 || Zs(st) || TT(st);
                if (xt = vu(xt, 4), Qt == null) {
                  var Un = st && st.constructor;
                  an ? Qt = Ae2 ? new Un() : [] : ng2(st) ? Qt = rv(Un) ? jR(JW(st)) : {} : Qt = {};
                }
                return (an ? Jw : Y1)(st, function(Br, qr, Ai2) {
                  return xt(Qt, Br, qr, Ai2);
                }), Qt;
              }
              function iJ(st, xt) {
                return st == null ? true : dht(st, xt);
              }
              function VG(st, xt, Qt) {
                return st == null ? st : lAt(st, xt, Bt(Qt));
              }
              function aJ(st, xt, Qt, Ae2) {
                return Ae2 = typeof Ae2 == "function" ? Ae2 : r5, st == null ? st : lAt(st, xt, Bt(Qt), Ae2);
              }
              function lL(st) {
                return st == null ? [] : w9(st, Zv(st));
              }
              function Nht(st) {
                return st == null ? [] : w9(st, Sn(st));
              }
              function DT(st, xt, Qt) {
                return Qt === r5 && (Qt = xt, xt = r5), Qt !== r5 && (Qt = l_(Qt), Qt = Qt === Qt ? Qt : 0), xt !== r5 && (xt = l_(xt), xt = xt === xt ? xt : 0), GR(l_(st), xt, Qt);
              }
              function oJ(st, xt, Qt) {
                return xt = AT(xt), Qt === r5 ? (Qt = xt, xt = 0) : Qt = AT(Qt), st = l_(st), bQ(st, xt, Qt);
              }
              function BG(st, xt, Qt) {
                if (Qt && typeof Qt != "boolean" && Fh2(st, xt, Qt) && (xt = Qt = r5), Qt === r5 && (typeof xt == "boolean" ? (Qt = xt, xt = r5) : typeof st == "boolean" && (Qt = st, st = r5)), st === r5 && xt === r5 ? (st = 0, xt = 1) : (st = AT(st), xt === r5 ? (xt = st, st = 0) : xt = AT(xt)), st > xt) {
                  var Ae2 = st;
                  st = xt, xt = Ae2;
                }
                if (Qt || st % 1 || xt % 1) {
                  var an = zTt();
                  return Jb2(st + an * (xt - st + Bft("1e-" + ((an + "").length - 1))), xt);
                }
                return hht(st, xt);
              }
              var g6 = Oi2(function(st, xt, Qt) {
                return xt = xt.toLowerCase(), st + (Qt ? sJ(xt) : xt);
              });
              function sJ(st) {
                return v6(ld2(st).toLowerCase());
              }
              function lJ(st) {
                return st = ld2(st), st && st.replace(zo, oQ).replace(wTt, "");
              }
              function DD(st, xt, Qt) {
                st = ld2(st), xt = C2(xt);
                var Ae2 = st.length;
                Qt = Qt === r5 ? Ae2 : GR(Hc2(Qt), 0, Ae2);
                var an = Qt;
                return Qt -= xt.length, Qt >= 0 && st.slice(Qt, an) == xt;
              }
              function zG(st) {
                return st = ld2(st), st && sm.test(st) ? st.replace(p0, PZt) : st;
              }
              function Fht(st) {
                return st = ld2(st), st && Dft.test(st) ? st.replace(fD, "\\$&") : st;
              }
              var D22 = Oi2(function(st, xt, Qt) {
                return st + (Qt ? "-" : "") + xt.toLowerCase();
              }), Vht = Oi2(function(st, xt, Qt) {
                return st + (Qt ? " " : "") + xt.toLowerCase();
              }), Bht = Aa2("toLowerCase");
              function K9(st, xt, Qt) {
                st = ld2(st), xt = Hc2(xt);
                var Ae2 = xt ? C9(st) : 0;
                if (!xt || Ae2 >= xt)
                  return st;
                var an = (xt - Ae2) / 2;
                return Na2(dQ(an), Qt) + st + Na2(pQ(an), Qt);
              }
              function zht(st, xt, Qt) {
                st = ld2(st), xt = Hc2(xt);
                var Ae2 = xt ? C9(st) : 0;
                return xt && Ae2 < xt ? st + Na2(xt - Ae2, Qt) : st;
              }
              function jht(st, xt, Qt) {
                st = ld2(st), xt = Hc2(xt);
                var Ae2 = xt ? C9(st) : 0;
                return xt && Ae2 < xt ? Na2(xt - Ae2, Qt) + st : st;
              }
              function uJ(st, xt, Qt) {
                return Qt || xt == null ? xt = 0 : xt && (xt = +xt), $Zt(ld2(st).replace(B32, ""), xt || 0);
              }
              function cJ(st, xt, Qt) {
                return (Qt ? Fh2(st, xt, Qt) : xt === r5) ? xt = 1 : xt = Hc2(xt), MQ(ld2(st), xt);
              }
              function fJ() {
                var st = arguments, xt = ld2(st[0]);
                return st.length < 3 ? xt : xt.replace(st[1], st[2]);
              }
              var Wht = Oi2(function(st, xt, Qt) {
                return st + (Qt ? "_" : "") + xt.toLowerCase();
              });
              function X9(st, xt, Qt) {
                return Qt && typeof Qt != "number" && Fh2(st, xt, Qt) && (xt = Qt = r5), Qt = Qt === r5 ? fi2 : Qt >>> 0, Qt ? (st = ld2(st), st && (typeof xt == "string" || xt != null && !TD(xt)) && (xt = C2(xt), !xt && S9(st)) ? qt(pT(st), 0, Qt) : st.split(xt, Qt)) : [];
              }
              var gm = Oi2(function(st, xt, Qt) {
                return st + (Qt ? " " : "") + v6(xt);
              });
              function Q9(st, xt, Qt) {
                return st = ld2(st), Qt = Qt == null ? 0 : GR(Hc2(Qt), 0, st.length), xt = C2(xt), st.slice(Qt, Qt + xt.length) == xt;
              }
              function hJ(st, xt, Qt) {
                var Ae2 = En.templateSettings;
                Qt && Fh2(st, xt, Qt) && (xt = r5), st = ld2(st), xt = cy({}, xt, Ae2, yd2);
                var an = cy({}, xt.imports, Ae2.imports, yd2), Un = Zv(an), Br = w9(an, Un), qr, Ai2, So = 0, Mo = xt.interpolate || ql, Ao = "__p += '", Xs = qft((xt.escape || ql).source + "|" + Mo.source + "|" + (Mo === Xw ? Fn : ql).source + "|" + (xt.evaluate || ql).source + "|$", "g"), Yl = "//# sourceURL=" + (zd2.call(xt, "sourceURL") ? (xt.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++STt + "]") + `
`;
                st.replace(Xs, function(Uu, nc2, lf2, rb2, r1, Vt) {
                  return lf2 || (lf2 = rb2), Ao += st.slice(So, Vt).replace(jf2, sQ), nc2 && (qr = true, Ao += `' +
__e(` + nc2 + `) +
'`), r1 && (Ai2 = true, Ao += `';
` + r1 + `;
__p += '`), lf2 && (Ao += `' +
((__t = (` + lf2 + `)) == null ? '' : __t) +
'`), So = Vt + Uu.length, Uu;
                }), Ao += `';
`;
                var Pu = zd2.call(xt, "variable") && xt.variable;
                if (!Pu)
                  Ao = `with (obj) {
` + Ao + `
}
`;
                else if (Sr.test(Pu))
                  throw new vc2(k2);
                Ao = (Ai2 ? Ao.replace($b2, "") : Ao).replace(Mx, "$1").replace(_2, "$1;"), Ao = "function(" + (Pu || "obj") + `) {
` + (Pu ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (qr ? ", __e = _.escape" : "") + (Ai2 ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Ao + `return __p
}`;
                var Mf2 = k22(function() {
                  return gd2(Un, Yl + "return " + Ao).apply(r5, Br);
                });
                if (Mf2.source = Ao, PG(Mf2))
                  throw Mf2;
                return Mf2;
              }
              function pJ(st) {
                return ld2(st).toLowerCase();
              }
              function Ght(st) {
                return ld2(st).toUpperCase();
              }
              function E2(st, xt, Qt) {
                if (st = ld2(st), st && (Qt || xt === r5))
                  return $W(st);
                if (!st || !(xt = C2(xt)))
                  return st;
                var Ae2 = pT(st), an = pT(xt), Un = iQ(Ae2, an), Br = YW(Ae2, an) + 1;
                return qt(Ae2, Un, Br).join("");
              }
              function jG(st, xt, Qt) {
                if (st = ld2(st), st && (Qt || xt === r5))
                  return st.slice(0, Uft(st) + 1);
                if (!st || !(xt = C2(xt)))
                  return st;
                var Ae2 = pT(st), an = YW(Ae2, pT(xt)) + 1;
                return qt(Ae2, 0, an).join("");
              }
              function t5(st, xt, Qt) {
                if (st = ld2(st), st && (Qt || xt === r5))
                  return st.replace(B32, "");
                if (!st || !(xt = C2(xt)))
                  return st;
                var Ae2 = pT(st), an = iQ(Ae2, pT(xt));
                return qt(Ae2, an).join("");
              }
              function lS(st, xt) {
                var Qt = Oe2, Ae2 = je2;
                if (ng2(xt)) {
                  var an = "separator" in xt ? xt.separator : an;
                  Qt = "length" in xt ? Hc2(xt.length) : Qt, Ae2 = "omission" in xt ? C2(xt.omission) : Ae2;
                }
                st = ld2(st);
                var Un = st.length;
                if (S9(st)) {
                  var Br = pT(st);
                  Un = Br.length;
                }
                if (Qt >= Un)
                  return st;
                var qr = Qt - C9(Ae2);
                if (qr < 1)
                  return Ae2;
                var Ai2 = Br ? qt(Br, 0, qr).join("") : st.slice(0, qr);
                if (an === r5)
                  return Ai2 + Ae2;
                if (Br && (qr += Ai2.length - qr), TD(an)) {
                  if (st.slice(qr).search(an)) {
                    var So, Mo = Ai2;
                    for (an.global || (an = qft(an.source, ld2(lr.exec(an)) + "g")), an.lastIndex = 0; So = an.exec(Mo); )
                      var Ao = So.index;
                    Ai2 = Ai2.slice(0, Ao === r5 ? qr : Ao);
                  }
                } else if (st.indexOf(C2(an), qr) != qr) {
                  var Xs = Ai2.lastIndexOf(an);
                  Xs > -1 && (Ai2 = Ai2.slice(0, Xs));
                }
                return Ai2 + Ae2;
              }
              function Hht(st) {
                return st = ld2(st), st && Qh2.test(st) ? st.replace(Cx, VZt) : st;
              }
              var dJ = Oi2(function(st, xt, Qt) {
                return st + (Qt ? " " : "") + xt.toUpperCase();
              }), v6 = Aa2("toUpperCase");
              function e5(st, xt, Qt) {
                return st = ld2(st), xt = Qt ? r5 : xt, xt === r5 ? LZt(st) ? Av(st) : GW(st) : st.match(xt) || [];
              }
              var k22 = gh2(function(st, xt) {
                try {
                  return S22(st, r5, xt);
                } catch (Qt) {
                  return PG(Qt) ? Qt : new vc2(Qt);
                }
              }), uL = Iv(function(st, xt) {
                return Jw(xt, function(Qt) {
                  Qt = Mr(Qt), Gk(st, Qt, SD(st[Qt], st));
                }), st;
              });
              function Uht(st) {
                var xt = st == null ? 0 : st.length, Qt = vu();
                return st = xt ? Wv(st, function(Ae2) {
                  if (typeof Ae2[1] != "function")
                    throw new DM(A2);
                  return [Qt(Ae2[0]), Ae2[1]];
                }) : [], gh2(function(Ae2) {
                  for (var an = -1; ++an < xt; ) {
                    var Un = st[an];
                    if (S22(Un[0], this, Ae2))
                      return S22(Un[1], this, Ae2);
                  }
                });
              }
              function J9(st) {
                return nht(PM(st, Z3));
              }
              function WG(st) {
                return function() {
                  return st;
                };
              }
              function ET(st, xt) {
                return st == null || st !== st ? xt : st;
              }
              var Oy = Si2(), GG = Si2(true);
              function nb2(st) {
                return st;
              }
              function Ox(st) {
                return qR(typeof st == "function" ? st : PM(st, Z3));
              }
              function t7(st) {
                return uht(PM(st, Z3));
              }
              function y6(st, xt) {
                return wQ(st, PM(xt, Z3));
              }
              var kT = gh2(function(st, xt) {
                return function(Qt) {
                  return k9(Qt, st, xt);
                };
              }), HG = gh2(function(st, xt) {
                return function(Qt) {
                  return k9(st, Qt, xt);
                };
              });
              function V0(st, xt, Qt) {
                var Ae2 = Zv(xt), an = yQ(xt, Ae2);
                Qt == null && !(ng2(xt) && (an.length || !Ae2.length)) && (Qt = xt, xt = st, st = this, an = yQ(xt, Zv(xt)));
                var Un = !(ng2(Qt) && "chain" in Qt) || !!Qt.chain, Br = rv(st);
                return Jw(an, function(qr) {
                  var Ai2 = xt[qr];
                  st[qr] = Ai2, Br && (st.prototype[qr] = function() {
                    var So = this.__chain__;
                    if (Un || So) {
                      var Mo = st(this.__wrapped__), Ao = Mo.__actions__ = ei2(this.__actions__);
                      return Ao.push({ func: Ai2, args: arguments, thisArg: st }), Mo.__chain__ = So, Mo;
                    }
                    return Ai2.apply(st, H3([this.value()], arguments));
                  });
                }), st;
              }
              function UG() {
                return Xm._ === this && (Xm._ = NTt), this;
              }
              function ju() {
              }
              function gJ(st) {
                return st = Hc2(st), gh2(function(xt) {
                  return cht(xt, st);
                });
              }
              var qht = gu(Wv), qG = gu(PTt), Zht = gu(L0);
              function n5(st) {
                return md2(st) ? HW(Mr(st)) : x$t(st);
              }
              function m6(st) {
                return function(xt) {
                  return st == null ? r5 : HR(st, xt);
                };
              }
              var r52 = ca2(), ZG = ca2(true);
              function NM() {
                return [];
              }
              function $G() {
                return false;
              }
              function vJ() {
                return {};
              }
              function YG() {
                return "";
              }
              function i5() {
                return true;
              }
              function e7(st, xt) {
                if (st = Hc2(st), st < 1 || st > Qn)
                  return [];
                var Qt = fi2, Ae2 = Jb2(st, fi2);
                xt = vu(xt), st -= fi2;
                for (var an = ZW(Ae2, xt); ++Qt < st; )
                  xt(Qt);
                return an;
              }
              function KG(st) {
                return Wc2(st) ? Wv(st, Mr) : uy(st) ? [st] : ei2(ir(ld2(st)));
              }
              function yJ(st) {
                var xt = ++lm;
                return ld2(st) + xt;
              }
              var mJ = xa2(function(st, xt) {
                return st + xt;
              }, 0), n7 = Hu("ceil"), XG = xa2(function(st, xt) {
                return st / xt;
              }, 1), a5 = Hu("floor");
              function bJ(st) {
                return st && st.length ? uG(st, nb2, mQ) : r5;
              }
              function QG(st, xt) {
                return st && st.length ? uG(st, vu(xt, 2), mQ) : r5;
              }
              function JG(st) {
                return OTt(st, nb2);
              }
              function r7(st, xt) {
                return OTt(st, vu(xt, 2));
              }
              function $ht(st) {
                return st && st.length ? uG(st, nb2, xQ) : r5;
              }
              function _J(st, xt) {
                return st && st.length ? uG(st, vu(xt, 2), xQ) : r5;
              }
              var tH = xa2(function(st, xt) {
                return st * xt;
              }, 1), cL = Hu("round"), xJ = xa2(function(st, xt) {
                return st - xt;
              }, 0);
              function Yht(st) {
                return st && st.length ? qW(st, nb2) : 0;
              }
              function i7(st, xt) {
                return st && st.length ? qW(st, vu(xt, 2)) : 0;
              }
              return En.after = n6, En.ary = r6, En.assign = kht, En.assignIn = R0, En.assignInWith = cy, En.assignWith = LG, En.at = Pht, En.before = $k, En.bind = SD, En.bindAll = uL, En.bindKey = i6, En.castArray = Aht, En.chain = N9, En.chunk = ji2, En.compact = qa2, En.concat = wa2, En.cond = Uht, En.conforms = J9, En.constant = WG, En.countBy = JR, En.create = rL, En.curry = a6, En.curryRight = dm, En.debounce = Yk, En.defaults = OG, En.defaultsDeep = c6, En.defer = MD, En.delay = GQ, En.difference = li2, En.differenceBy = jo, En.differenceWith = Al, En.drop = Sf2, En.dropRight = sf2, En.dropRightWhile = Vc2, En.dropWhile = zu, En.fill = ad2, En.filter = SG, En.flatMap = J1, En.flatMapDeep = Sht, En.flatMapDepth = WQ, En.flatten = Ng2, En.flattenDeep = pm, En.flattenDepth = T22, En.flip = o6, En.flow = Oy, En.flowRight = GG, En.fromPairs = yD, En.functions = aL, En.functionsIn = N0, En.groupBy = MG, En.initial = xT, En.intersection = iy, En.intersectionBy = A22, En.intersectionWith = ay, En.invert = p6, En.invertBy = d6, En.invokeMap = oS, En.iteratee = Ox, En.keyBy = B9, En.keys = Zv, En.keysIn = Sn, En.map = _D, En.mapKeys = sL, En.mapValues = $9, En.matches = t7, En.matchesProperty = y6, En.memoize = Kk, En.merge = Lx, En.mergeWith = yh2, En.method = kT, En.methodOf = HG, En.mixin = V0, En.negate = G9, En.nthArg = gJ, En.omit = Lht, En.omitBy = RG, En.once = Cht, En.orderBy = t6, En.over = qht, En.overArgs = Tht, En.overEvery = qG, En.overSome = Zht, En.partial = AG, En.partialRight = sy, En.partition = CG, En.pick = NG, En.pickBy = ID, En.property = n5, En.propertyOf = m6, En.pull = kx, En.pullAll = wT, En.pullAllBy = ST, En.pullAllWith = Ly, En.pullAt = XR, En.range = r52, En.rangeRight = ZG, En.rearg = HQ, En.reject = j9, En.remove = I22, En.rest = IG, En.reverse = mD, En.sampleSize = xD, En.set = FG, En.setWith = Rht, En.shuffle = TG, En.slice = Zk, En.sortBy = e6, En.sortedUniq = gG, En.sortedUniqBy = R9, En.split = X9, En.spread = DG, En.tail = yht, En.take = LQ, En.takeRight = vG, En.takeRightWhile = OQ, En.takeWhile = yG, En.tap = VQ, En.throttle = UQ, En.thru = qv, En.toArray = tJ, En.toPairs = Y9, En.toPairsIn = rJ, En.toPath = KG, En.toPlainObject = eJ, En.transform = F0, En.unary = CD, En.union = mG, En.unionBy = e1, En.unionWith = QR, En.uniq = RQ, En.uniqBy = mht, En.uniqWith = bht, En.unset = iJ, En.unzip = iS, En.unzipWith = bG, En.update = VG, En.updateWith = aJ, En.values = lL, En.valuesIn = Nht, En.without = Fg2, En.words = e5, En.wrap = H9, En.xor = jd2, En.xorBy = _G, En.xorWith = NQ, En.zip = xG, En.zipObject = _ht, En.zipObjectDeep = FQ, En.zipWith = xht, En.entries = Y9, En.entriesIn = rJ, En.extend = R0, En.extendWith = cy, V0(En, En), En.add = mJ, En.attempt = k22, En.camelCase = g6, En.capitalize = sJ, En.ceil = n7, En.clamp = DT, En.clone = qQ, En.cloneDeep = Pf2, En.cloneDeepWith = n1, En.cloneWith = Iht, En.conformsTo = eg2, En.deburr = lJ, En.defaultTo = ET, En.divide = XG, En.endsWith = DD, En.eq = tb2, En.escape = zG, En.escapeRegExp = Fht, En.every = V9, En.find = Px, En.findIndex = Rg2, En.findKey = IT, En.findLast = wht, En.findLastIndex = bc2, En.findLastKey = eb2, En.floor = a5, En.forEach = MT, En.forEachRight = tL, En.forIn = Qk, En.forInRight = iL, En.forOwn = f6, En.forOwnRight = h6, En.get = AD, En.gt = EG, En.gte = ZQ, En.has = Jk, En.hasIn = Z9, En.head = rS, En.identity = nb2, En.includes = Xc2, En.indexOf = Uk, En.inRange = oJ, En.invoke = oL, En.isArguments = o_, En.isArray = Wc2, En.isArrayBuffer = CT, En.isArrayLike = ri2, En.isArrayLikeObject = va, En.isBoolean = ya2, En.isBuffer = Zs, En.isDate = Gc2, En.isElement = pp, En.isEmpty = ly, En.isEqual = bd2, En.isEqualWith = kG, En.isError = PG, En.isFinite = s_, En.isFunction = rv, En.isInteger = $Q, En.isLength = Wd2, En.isMap = sd2, En.isMatch = YQ, En.isMatchWith = KQ, En.isNaN = U9, En.isNative = Dht, En.isNil = QQ, En.isNull = XQ, En.isNumber = eL, En.isObject = ng2, En.isObjectLike = rg2, En.isPlainObject = sS, En.isRegExp = TD, En.isSafeInteger = nL, En.isSet = s6, En.isString = l6, En.isSymbol = uy, En.isTypedArray = TT, En.isUndefined = JQ, En.isWeakMap = Lf2, En.isWeakSet = Xk, En.join = RM, En.kebabCase = D22, En.last = Uv, En.lastIndexOf = qk2, En.lowerCase = Vht, En.lowerFirst = Bht, En.lt = q9, En.lte = Eht, En.max = bJ, En.maxBy = QG, En.mean = JG, En.meanBy = r7, En.min = $ht, En.minBy = _J, En.stubArray = NM, En.stubFalse = $G, En.stubObject = vJ, En.stubString = YG, En.stubTrue = i5, En.multiply = tH, En.nth = KR, En.noConflict = UG, En.noop = ju, En.now = wD, En.pad = K9, En.padEnd = zht, En.padStart = jht, En.parseInt = uJ, En.random = BG, En.reduce = z9, En.reduceRight = Mht, En.repeat = cJ, En.replace = fJ, En.result = Oht, En.round = cL, En.runInContext = bi2, En.sample = W9, En.size = od2, En.snakeCase = Wht, En.some = oy, En.sortedIndex = EQ, En.sortedIndexBy = kQ, En.sortedIndexOf = vht, En.sortedLastIndex = pG, En.sortedLastIndexBy = dG, En.sortedLastIndexOf = PQ, En.startCase = gm, En.startsWith = Q9, En.subtract = xJ, En.sum = Yht, En.sumBy = i7, En.template = hJ, En.times = e7, En.toFinite = AT, En.toInteger = Hc2, En.toLength = u6, En.toLower = pJ, En.toNumber = l_, En.toSafeInteger = nJ, En.toString = ld2, En.toUpper = Ght, En.trim = E2, En.trimEnd = jG, En.trimStart = t5, En.truncate = lS, En.unescape = Hht, En.uniqueId = yJ, En.upperCase = dJ, En.upperFirst = v6, En.each = MT, En.eachRight = tL, En.first = rS, V0(En, function() {
                var st = {};
                return Y1(En, function(xt, Qt) {
                  zd2.call(En.prototype, Qt) || (st[Qt] = xt);
                }), st;
              }(), { chain: false }), En.VERSION = g5, Jw(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(st) {
                En[st].placeholder = En;
              }), Jw(["drop", "take"], function(st, xt) {
                Jh2.prototype[st] = function(Qt) {
                  Qt = Qt === r5 ? 1 : um(Hc2(Qt), 0);
                  var Ae2 = this.__filtered__ && !xt ? new Jh2(this) : this.clone();
                  return Ae2.__filtered__ ? Ae2.__takeCount__ = Jb2(Qt, Ae2.__takeCount__) : Ae2.__views__.push({ size: Jb2(Qt, fi2), type: st + (Ae2.__dir__ < 0 ? "Right" : "") }), Ae2;
                }, Jh2.prototype[st + "Right"] = function(Qt) {
                  return this.reverse()[st](Qt).reverse();
                };
              }), Jw(["filter", "map", "takeWhile"], function(st, xt) {
                var Qt = xt + 1, Ae2 = Qt == An || Qt == _n;
                Jh2.prototype[st] = function(an) {
                  var Un = this.clone();
                  return Un.__iteratees__.push({ iteratee: vu(an, 3), type: Qt }), Un.__filtered__ = Un.__filtered__ || Ae2, Un;
                };
              }), Jw(["head", "last"], function(st, xt) {
                var Qt = "take" + (xt ? "Right" : "");
                Jh2.prototype[st] = function() {
                  return this[Qt](1).value()[0];
                };
              }), Jw(["initial", "tail"], function(st, xt) {
                var Qt = "drop" + (xt ? "" : "Right");
                Jh2.prototype[st] = function() {
                  return this.__filtered__ ? new Jh2(this) : this[Qt](1);
                };
              }), Jh2.prototype.compact = function() {
                return this.filter(nb2);
              }, Jh2.prototype.find = function(st) {
                return this.filter(st).head();
              }, Jh2.prototype.findLast = function(st) {
                return this.reverse().find(st);
              }, Jh2.prototype.invokeMap = gh2(function(st, xt) {
                return typeof st == "function" ? new Jh2(this) : this.map(function(Qt) {
                  return k9(Qt, st, xt);
                });
              }), Jh2.prototype.reject = function(st) {
                return this.filter(G9(vu(st)));
              }, Jh2.prototype.slice = function(st, xt) {
                st = Hc2(st);
                var Qt = this;
                return Qt.__filtered__ && (st > 0 || xt < 0) ? new Jh2(Qt) : (st < 0 ? Qt = Qt.takeRight(-st) : st && (Qt = Qt.drop(st)), xt !== r5 && (xt = Hc2(xt), Qt = xt < 0 ? Qt.dropRight(-xt) : Qt.take(xt - st)), Qt);
              }, Jh2.prototype.takeRightWhile = function(st) {
                return this.reverse().takeWhile(st).reverse();
              }, Jh2.prototype.toArray = function() {
                return this.take(fi2);
              }, Y1(Jh2.prototype, function(st, xt) {
                var Qt = /^(?:filter|find|map|reject)|While$/.test(xt), Ae2 = /^(?:head|last)$/.test(xt), an = En[Ae2 ? "take" + (xt == "last" ? "Right" : "") : xt], Un = Ae2 || /^find/.test(xt);
                !an || (En.prototype[xt] = function() {
                  var Br = this.__wrapped__, qr = Ae2 ? [1] : arguments, Ai2 = Br instanceof Jh2, So = qr[0], Mo = Ai2 || Wc2(Br), Ao = function(nc2) {
                    var lf2 = an.apply(En, H3([nc2], qr));
                    return Ae2 && Xs ? lf2[0] : lf2;
                  };
                  Mo && Qt && typeof So == "function" && So.length != 1 && (Ai2 = Mo = false);
                  var Xs = this.__chain__, Yl = !!this.__actions__.length, Pu = Un && !Xs, Mf2 = Ai2 && !Yl;
                  if (!Un && Mo) {
                    Br = Mf2 ? Br : new Jh2(this);
                    var Uu = st.apply(Br, qr);
                    return Uu.__actions__.push({ func: qv, args: [Ao], thisArg: r5 }), new Ix(Uu, Xs);
                  }
                  return Pu && Mf2 ? st.apply(this, qr) : (Uu = this.thru(Ao), Pu ? Ae2 ? Uu.value()[0] : Uu.value() : Uu);
                });
              }), Jw(["pop", "push", "shift", "sort", "splice", "unshift"], function(st) {
                var xt = A9[st], Qt = /^(?:push|sort|unshift)$/.test(st) ? "tap" : "thru", Ae2 = /^(?:pop|shift)$/.test(st);
                En.prototype[st] = function() {
                  var an = arguments;
                  if (Ae2 && !this.__chain__) {
                    var Un = this.value();
                    return xt.apply(Wc2(Un) ? Un : [], an);
                  }
                  return this[Qt](function(Br) {
                    return xt.apply(Wc2(Br) ? Br : [], an);
                  });
                };
              }), Y1(Jh2.prototype, function(st, xt) {
                var Qt = En[xt];
                if (Qt) {
                  var Ae2 = Qt.name + "";
                  zd2.call(zR, Ae2) || (zR[Ae2] = []), zR[Ae2].push({ name: xt, func: Qt });
                }
              }), zR[bl(r5, Mt).name] = [{ name: "wrapper", func: r5 }], Jh2.prototype.clone = QZt, Jh2.prototype.reverse = JZt, Jh2.prototype.value = GTt, En.prototype.at = F9, En.prototype.chain = bD, En.prototype.commit = BQ, En.prototype.next = wG, En.prototype.plant = J3, En.prototype.reverse = zQ, En.prototype.toJSON = En.prototype.valueOf = En.prototype.value = jQ, En.prototype.first = En.prototype.head, tG && (En.prototype[tG] = aS), En;
            }, q32 = KW();
            W32 ? ((W32.exports = q32)._ = q32, zft._ = q32) : Xm._ = q32;
          }).call(tn);
        })(WCt, WCt.exports);
        class LOe {
          constructor() {
            E(this, "subscriptions", /* @__PURE__ */ new Map()), E(this, "emitEffectCache", /* @__PURE__ */ new Map()), E(this, "useSubscription", (s, r5) => {
              const g5 = O2.useRef();
              O2.useEffect(() => {
                var b6, S2;
                g5.current = r5;
                function A2(R6) {
                  g5.current && g5.current(R6);
                }
                const k2 = (S2 = (b6 = this.subscriptions) == null ? void 0 : b6.get(s)) != null ? S2 : [];
                return k2.push(A2), this.subscriptions.set(s, k2), this.emitEffect(s), () => {
                  this.subscriptions.delete(s);
                };
              });
            }), E(this, "emit", (s, ...r5) => {
              if (typeof s == "string" || typeof s == "number") {
                const g5 = this.subscriptions.get(s);
                g5 == null || g5.forEach((b6) => {
                  b6 == null || b6({ params: WCt.exports.cloneDeep(r5), event: s });
                }), this.emitEffectCache.set(s, { params: WCt.exports.cloneDeep(r5), event: s });
              } else
                throw new TypeError("event must be string or number !");
            }), E(this, "emitEffect", (s) => {
              const r5 = this.emitEffectCache.get(s), g5 = this.subscriptions.get(s);
              r5 && (g5 == null || g5.forEach((b6) => {
                b6 == null || b6(T2({}, r5));
              }));
            }), E(this, "removeListener", (s) => {
              this.subscriptions.delete(s);
            }), E(this, "clear", () => {
              this.subscriptions.clear();
            }), this.clear();
          }
        }
        const gJn = new LOe();
        function GCt(c5) {
          const s = O2.useRef(), r5 = O2.useMemo(() => c5 != null ? c5 : { global: false }, [c5]);
          return s.current || (s.current = r5.global ? s.current = gJn : s.current = new LOe()), O2.useEffect(() => () => {
            var g5;
            return (g5 = s.current) == null ? void 0 : g5.clear();
          }, []), s.current;
        }
        const Rqt = ({ id: c5, title: s, chart: r5, option: g5 }, b6) => {
          const S2 = O2.useRef(), A2 = GCt({ global: true });
          S2.current = O2.useMemo(() => {
            if (!S2.current)
              return dJn;
          }, []);
          const { run: k2 } = Nn(() => {
            c5 && A2.emit("list");
          }, { wait: 100 });
          return O2.useEffect(() => {
            console.log(r5 == null ? void 0 : r5.current), S2.current && (r5 == null ? void 0 : r5.current) && c5 && g5 && (S2.current.add(c5, r5 == null ? void 0 : r5.current, g5, s), k2());
          }, b6), { tool: S2.current };
        };
        var vJn = O2.createContext({}), OOe = vJn;
        function Qd2(c5, s, r5) {
          return s in c5 ? Object.defineProperty(c5, s, { value: r5, enumerable: true, configurable: true, writable: true }) : c5[s] = r5, c5;
        }
        function ROe(c5, s) {
          var r5 = Object.keys(c5);
          if (Object.getOwnPropertySymbols) {
            var g5 = Object.getOwnPropertySymbols(c5);
            s && (g5 = g5.filter(function(b6) {
              return Object.getOwnPropertyDescriptor(c5, b6).enumerable;
            })), r5.push.apply(r5, g5);
          }
          return r5;
        }
        function xf2(c5) {
          for (var s = 1; s < arguments.length; s++) {
            var r5 = arguments[s] != null ? arguments[s] : {};
            s % 2 ? ROe(Object(r5), true).forEach(function(g5) {
              Qd2(c5, g5, r5[g5]);
            }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(c5, Object.getOwnPropertyDescriptors(r5)) : ROe(Object(r5)).forEach(function(g5) {
              Object.defineProperty(c5, g5, Object.getOwnPropertyDescriptor(r5, g5));
            });
          }
          return c5;
        }
        function NOe(c5) {
          if (Array.isArray(c5))
            return c5;
        }
        function yJn(c5, s) {
          var r5 = c5 == null ? null : typeof Symbol != "undefined" && c5[Symbol.iterator] || c5["@@iterator"];
          if (r5 != null) {
            var g5 = [], b6 = true, S2 = false, A2, k2;
            try {
              for (r5 = r5.call(c5); !(b6 = (A2 = r5.next()).done) && (g5.push(A2.value), !(s && g5.length === s)); b6 = true)
                ;
            } catch (R6) {
              S2 = true, k2 = R6;
            } finally {
              try {
                !b6 && r5.return != null && r5.return();
              } finally {
                if (S2)
                  throw k2;
              }
            }
            return g5;
          }
        }
        function Nqt(c5, s) {
          (s == null || s > c5.length) && (s = c5.length);
          for (var r5 = 0, g5 = new Array(s); r5 < s; r5++)
            g5[r5] = c5[r5];
          return g5;
        }
        function Fqt(c5, s) {
          if (c5) {
            if (typeof c5 == "string")
              return Nqt(c5, s);
            var r5 = Object.prototype.toString.call(c5).slice(8, -1);
            if (r5 === "Object" && c5.constructor && (r5 = c5.constructor.name), r5 === "Map" || r5 === "Set")
              return Array.from(c5);
            if (r5 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r5))
              return Nqt(c5, s);
          }
        }
        function FOe() {
          throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
        }
        function sD(c5, s) {
          return NOe(c5) || yJn(c5, s) || Fqt(c5, s) || FOe();
        }
        function mJn(c5, s) {
          if (c5 == null)
            return {};
          var r5 = {}, g5 = Object.keys(c5), b6, S2;
          for (S2 = 0; S2 < g5.length; S2++)
            b6 = g5[S2], !(s.indexOf(b6) >= 0) && (r5[b6] = c5[b6]);
          return r5;
        }
        function WX(c5, s) {
          if (c5 == null)
            return {};
          var r5 = mJn(c5, s), g5, b6;
          if (Object.getOwnPropertySymbols) {
            var S2 = Object.getOwnPropertySymbols(c5);
            for (b6 = 0; b6 < S2.length; b6++)
              g5 = S2[b6], !(s.indexOf(g5) >= 0) && (!Object.prototype.propertyIsEnumerable.call(c5, g5) || (r5[g5] = c5[g5]));
          }
          return r5;
        }
        var VOe = { exports: {} };
        /*!
          Copyright (c) 2018 Jed Watson.
          Licensed under the MIT License (MIT), see
          http://jedwatson.github.io/classnames
        */
        (function(c5) {
          (function() {
            var s = {}.hasOwnProperty;
            function r5() {
              for (var g5 = [], b6 = 0; b6 < arguments.length; b6++) {
                var S2 = arguments[b6];
                if (S2) {
                  var A2 = typeof S2;
                  if (A2 === "string" || A2 === "number")
                    g5.push(S2);
                  else if (Array.isArray(S2)) {
                    if (S2.length) {
                      var k2 = r5.apply(null, S2);
                      k2 && g5.push(k2);
                    }
                  } else if (A2 === "object")
                    if (S2.toString === Object.prototype.toString)
                      for (var R6 in S2)
                        s.call(S2, R6) && S2[R6] && g5.push(R6);
                    else
                      g5.push(S2.toString());
                }
              }
              return g5.join(" ");
            }
            c5.exports ? (r5.default = r5, c5.exports = r5) : window.classNames = r5;
          })();
        })(VOe);
        var GX = VOe.exports;
        function Yw(c5) {
          return Yw = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(s) {
            return typeof s;
          } : function(s) {
            return s && typeof Symbol == "function" && s.constructor === Symbol && s !== Symbol.prototype ? "symbol" : typeof s;
          }, Yw(c5);
        }
        function lD(c5, s) {
          bJn(c5) && (c5 = "100%");
          var r5 = _Jn(c5);
          return c5 = s === 360 ? c5 : Math.min(s, Math.max(0, parseFloat(c5))), r5 && (c5 = parseInt(String(c5 * s), 10) / 100), Math.abs(c5 - s) < 1e-6 ? 1 : (s === 360 ? c5 = (c5 < 0 ? c5 % s + s : c5 % s) / parseFloat(String(s)) : c5 = c5 % s / parseFloat(String(s)), c5);
        }
        function bJn(c5) {
          return typeof c5 == "string" && c5.indexOf(".") !== -1 && parseFloat(c5) === 1;
        }
        function _Jn(c5) {
          return typeof c5 == "string" && c5.indexOf("%") !== -1;
        }
        function xJn(c5) {
          return c5 = parseFloat(c5), (isNaN(c5) || c5 < 0 || c5 > 1) && (c5 = 1), c5;
        }
        function HCt(c5) {
          return c5 <= 1 ? Number(c5) * 100 + "%" : c5;
        }
        function Vqt(c5) {
          return c5.length === 1 ? "0" + c5 : String(c5);
        }
        function wJn(c5, s, r5) {
          return { r: lD(c5, 255) * 255, g: lD(s, 255) * 255, b: lD(r5, 255) * 255 };
        }
        function Bqt(c5, s, r5) {
          return r5 < 0 && (r5 += 1), r5 > 1 && (r5 -= 1), r5 < 1 / 6 ? c5 + (s - c5) * (6 * r5) : r5 < 1 / 2 ? s : r5 < 2 / 3 ? c5 + (s - c5) * (2 / 3 - r5) * 6 : c5;
        }
        function SJn(c5, s, r5) {
          var g5, b6, S2;
          if (c5 = lD(c5, 360), s = lD(s, 100), r5 = lD(r5, 100), s === 0)
            b6 = r5, S2 = r5, g5 = r5;
          else {
            var A2 = r5 < 0.5 ? r5 * (1 + s) : r5 + s - r5 * s, k2 = 2 * r5 - A2;
            g5 = Bqt(k2, A2, c5 + 1 / 3), b6 = Bqt(k2, A2, c5), S2 = Bqt(k2, A2, c5 - 1 / 3);
          }
          return { r: g5 * 255, g: b6 * 255, b: S2 * 255 };
        }
        function MJn(c5, s, r5) {
          c5 = lD(c5, 255), s = lD(s, 255), r5 = lD(r5, 255);
          var g5 = Math.max(c5, s, r5), b6 = Math.min(c5, s, r5), S2 = 0, A2 = g5, k2 = g5 - b6, R6 = g5 === 0 ? 0 : k2 / g5;
          if (g5 === b6)
            S2 = 0;
          else {
            switch (g5) {
              case c5:
                S2 = (s - r5) / k2 + (s < r5 ? 6 : 0);
                break;
              case s:
                S2 = (r5 - c5) / k2 + 2;
                break;
              case r5:
                S2 = (c5 - s) / k2 + 4;
                break;
            }
            S2 /= 6;
          }
          return { h: S2, s: R6, v: A2 };
        }
        function CJn(c5, s, r5) {
          c5 = lD(c5, 360) * 6, s = lD(s, 100), r5 = lD(r5, 100);
          var g5 = Math.floor(c5), b6 = c5 - g5, S2 = r5 * (1 - s), A2 = r5 * (1 - b6 * s), k2 = r5 * (1 - (1 - b6) * s), R6 = g5 % 6, B3 = [r5, A2, S2, S2, k2, r5][R6], G3 = [k2, r5, r5, A2, S2, S2][R6], Z3 = [S2, S2, k2, r5, r5, A2][R6];
          return { r: B3 * 255, g: G3 * 255, b: Z3 * 255 };
        }
        function TJn(c5, s, r5, g5) {
          var b6 = [Vqt(Math.round(c5).toString(16)), Vqt(Math.round(s).toString(16)), Vqt(Math.round(r5).toString(16))];
          return g5 && b6[0].startsWith(b6[0].charAt(1)) && b6[1].startsWith(b6[1].charAt(1)) && b6[2].startsWith(b6[2].charAt(1)) ? b6[0].charAt(0) + b6[1].charAt(0) + b6[2].charAt(0) : b6.join("");
        }
        function BOe(c5) {
          return oT(c5) / 255;
        }
        function oT(c5) {
          return parseInt(c5, 16);
        }
        var zOe = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
        function vft(c5) {
          var s = { r: 0, g: 0, b: 0 }, r5 = 1, g5 = null, b6 = null, S2 = null, A2 = false, k2 = false;
          return typeof c5 == "string" && (c5 = DJn(c5)), typeof c5 == "object" && (PR(c5.r) && PR(c5.g) && PR(c5.b) ? (s = wJn(c5.r, c5.g, c5.b), A2 = true, k2 = String(c5.r).substr(-1) === "%" ? "prgb" : "rgb") : PR(c5.h) && PR(c5.s) && PR(c5.v) ? (g5 = HCt(c5.s), b6 = HCt(c5.v), s = CJn(c5.h, g5, b6), A2 = true, k2 = "hsv") : PR(c5.h) && PR(c5.s) && PR(c5.l) && (g5 = HCt(c5.s), S2 = HCt(c5.l), s = SJn(c5.h, g5, S2), A2 = true, k2 = "hsl"), Object.prototype.hasOwnProperty.call(c5, "a") && (r5 = c5.a)), r5 = xJn(r5), { ok: A2, format: c5.format || k2, r: Math.min(255, Math.max(s.r, 0)), g: Math.min(255, Math.max(s.g, 0)), b: Math.min(255, Math.max(s.b, 0)), a: r5 };
        }
        var AJn = "[-\\+]?\\d+%?", IJn = "[-\\+]?\\d*\\.\\d+%?", g9 = "(?:" + IJn + ")|(?:" + AJn + ")", zqt = "[\\s|\\(]+(" + g9 + ")[,|\\s]+(" + g9 + ")[,|\\s]+(" + g9 + ")\\s*\\)?", jqt = "[\\s|\\(]+(" + g9 + ")[,|\\s]+(" + g9 + ")[,|\\s]+(" + g9 + ")[,|\\s]+(" + g9 + ")\\s*\\)?", Ok = { CSS_UNIT: new RegExp(g9), rgb: new RegExp("rgb" + zqt), rgba: new RegExp("rgba" + jqt), hsl: new RegExp("hsl" + zqt), hsla: new RegExp("hsla" + jqt), hsv: new RegExp("hsv" + zqt), hsva: new RegExp("hsva" + jqt), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
        function DJn(c5) {
          if (c5 = c5.trim().toLowerCase(), c5.length === 0)
            return false;
          var s = false;
          if (zOe[c5])
            c5 = zOe[c5], s = true;
          else if (c5 === "transparent")
            return { r: 0, g: 0, b: 0, a: 0, format: "name" };
          var r5 = Ok.rgb.exec(c5);
          return r5 ? { r: r5[1], g: r5[2], b: r5[3] } : (r5 = Ok.rgba.exec(c5), r5 ? { r: r5[1], g: r5[2], b: r5[3], a: r5[4] } : (r5 = Ok.hsl.exec(c5), r5 ? { h: r5[1], s: r5[2], l: r5[3] } : (r5 = Ok.hsla.exec(c5), r5 ? { h: r5[1], s: r5[2], l: r5[3], a: r5[4] } : (r5 = Ok.hsv.exec(c5), r5 ? { h: r5[1], s: r5[2], v: r5[3] } : (r5 = Ok.hsva.exec(c5), r5 ? { h: r5[1], s: r5[2], v: r5[3], a: r5[4] } : (r5 = Ok.hex8.exec(c5), r5 ? { r: oT(r5[1]), g: oT(r5[2]), b: oT(r5[3]), a: BOe(r5[4]), format: s ? "name" : "hex8" } : (r5 = Ok.hex6.exec(c5), r5 ? { r: oT(r5[1]), g: oT(r5[2]), b: oT(r5[3]), format: s ? "name" : "hex" } : (r5 = Ok.hex4.exec(c5), r5 ? { r: oT(r5[1] + r5[1]), g: oT(r5[2] + r5[2]), b: oT(r5[3] + r5[3]), a: BOe(r5[4] + r5[4]), format: s ? "name" : "hex8" } : (r5 = Ok.hex3.exec(c5), r5 ? { r: oT(r5[1] + r5[1]), g: oT(r5[2] + r5[2]), b: oT(r5[3] + r5[3]), format: s ? "name" : "hex" } : false)))))))));
        }
        function PR(c5) {
          return Boolean(Ok.CSS_UNIT.exec(String(c5)));
        }
        var UCt = 2, jOe = 0.16, EJn = 0.05, kJn = 0.05, PJn = 0.15, WOe = 5, GOe = 4, LJn = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
        function HOe(c5) {
          var s = c5.r, r5 = c5.g, g5 = c5.b, b6 = MJn(s, r5, g5);
          return { h: b6.h * 360, s: b6.s, v: b6.v };
        }
        function qCt(c5) {
          var s = c5.r, r5 = c5.g, g5 = c5.b;
          return "#".concat(TJn(s, r5, g5, false));
        }
        function OJn(c5, s, r5) {
          var g5 = r5 / 100, b6 = { r: (s.r - c5.r) * g5 + c5.r, g: (s.g - c5.g) * g5 + c5.g, b: (s.b - c5.b) * g5 + c5.b };
          return b6;
        }
        function UOe(c5, s, r5) {
          var g5;
          return Math.round(c5.h) >= 60 && Math.round(c5.h) <= 240 ? g5 = r5 ? Math.round(c5.h) - UCt * s : Math.round(c5.h) + UCt * s : g5 = r5 ? Math.round(c5.h) + UCt * s : Math.round(c5.h) - UCt * s, g5 < 0 ? g5 += 360 : g5 >= 360 && (g5 -= 360), g5;
        }
        function qOe(c5, s, r5) {
          if (c5.h === 0 && c5.s === 0)
            return c5.s;
          var g5;
          return r5 ? g5 = c5.s - jOe * s : s === GOe ? g5 = c5.s + jOe : g5 = c5.s + EJn * s, g5 > 1 && (g5 = 1), r5 && s === WOe && g5 > 0.1 && (g5 = 0.1), g5 < 0.06 && (g5 = 0.06), Number(g5.toFixed(2));
        }
        function ZOe(c5, s, r5) {
          var g5;
          return r5 ? g5 = c5.v + kJn * s : g5 = c5.v - PJn * s, g5 > 1 && (g5 = 1), Number(g5.toFixed(2));
        }
        function Wqt(c5) {
          for (var s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r5 = [], g5 = vft(c5), b6 = WOe; b6 > 0; b6 -= 1) {
            var S2 = HOe(g5), A2 = qCt(vft({ h: UOe(S2, b6, true), s: qOe(S2, b6, true), v: ZOe(S2, b6, true) }));
            r5.push(A2);
          }
          r5.push(qCt(g5));
          for (var k2 = 1; k2 <= GOe; k2 += 1) {
            var R6 = HOe(g5), B3 = qCt(vft({ h: UOe(R6, k2), s: qOe(R6, k2), v: ZOe(R6, k2) }));
            r5.push(B3);
          }
          return s.theme === "dark" ? LJn.map(function(G3) {
            var Z3 = G3.index, X3 = G3.opacity, tt = qCt(OJn(vft(s.backgroundColor || "#141414"), vft(r5[Z3]), X3 * 100));
            return tt;
          }) : r5;
        }
        var Gqt = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, Kw = {}, Hqt = {};
        Object.keys(Gqt).forEach(function(c5) {
          Kw[c5] = Wqt(Gqt[c5]), Kw[c5].primary = Kw[c5][5], Hqt[c5] = Wqt(Gqt[c5], { theme: "dark", backgroundColor: "#141414" }), Hqt[c5].primary = Hqt[c5][5];
        }), Kw.red, Kw.volcano, Kw.gold, Kw.orange, Kw.yellow, Kw.lime, Kw.green, Kw.cyan, Kw.blue, Kw.geekblue, Kw.purple, Kw.magenta, Kw.grey;
        var $Oe = {};
        function RJn(c5, s) {
        }
        function NJn(c5, s, r5) {
          !s && !$Oe[r5] && (c5(false, r5), $Oe[r5] = true);
        }
        function V32(c5, s) {
          NJn(RJn, c5, s);
        }
        function YOe() {
          return !!(typeof window != "undefined" && window.document && window.document.createElement);
        }
        var FJn = "rc-util-key";
        function KOe() {
          var c5 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, s = c5.mark;
          return s ? s.startsWith("data-") ? s : "data-".concat(s) : FJn;
        }
        function Uqt(c5) {
          if (c5.attachTo)
            return c5.attachTo;
          var s = document.querySelector("head");
          return s || document.body;
        }
        function XOe(c5) {
          var s, r5 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
          if (!YOe())
            return null;
          var g5 = document.createElement("style");
          if (!((s = r5.csp) === null || s === void 0) && s.nonce) {
            var b6;
            g5.nonce = (b6 = r5.csp) === null || b6 === void 0 ? void 0 : b6.nonce;
          }
          g5.innerHTML = c5;
          var S2 = Uqt(r5), A2 = S2.firstChild;
          return r5.prepend && S2.prepend ? S2.prepend(g5) : r5.prepend && A2 ? S2.insertBefore(g5, A2) : S2.appendChild(g5), g5;
        }
        var qqt = /* @__PURE__ */ new Map();
        function VJn(c5) {
          var s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r5 = Uqt(s);
          return Array.from(qqt.get(r5).children).find(function(g5) {
            return g5.tagName === "STYLE" && g5.getAttribute(KOe(s)) === c5;
          });
        }
        function QOe(c5, s) {
          var r5 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, g5 = Uqt(r5);
          if (!qqt.has(g5)) {
            var b6 = XOe("", r5), S2 = b6.parentNode;
            qqt.set(g5, S2), S2.removeChild(b6);
          }
          var A2 = VJn(s, r5);
          if (A2) {
            var k2, R6;
            if (((k2 = r5.csp) === null || k2 === void 0 ? void 0 : k2.nonce) && A2.nonce !== ((R6 = r5.csp) === null || R6 === void 0 ? void 0 : R6.nonce)) {
              var B3;
              A2.nonce = (B3 = r5.csp) === null || B3 === void 0 ? void 0 : B3.nonce;
            }
            return A2.innerHTML !== c5 && (A2.innerHTML = c5), A2;
          }
          var G3 = XOe(c5, r5);
          return G3.setAttribute(KOe(r5), s), G3;
        }
        function BJn(c5, s) {
          V32(c5, "[@ant-design/icons] ".concat(s));
        }
        function JOe(c5) {
          return Yw(c5) === "object" && typeof c5.name == "string" && typeof c5.theme == "string" && (Yw(c5.icon) === "object" || typeof c5.icon == "function");
        }
        function t4e() {
          var c5 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          return Object.keys(c5).reduce(function(s, r5) {
            var g5 = c5[r5];
            switch (r5) {
              case "class":
                s.className = g5, delete s.class;
                break;
              default:
                s[r5] = g5;
            }
            return s;
          }, {});
        }
        function Zqt(c5, s, r5) {
          return r5 ? q3.default.createElement(c5.tag, xf2(xf2({ key: s }, t4e(c5.attrs)), r5), (c5.children || []).map(function(g5, b6) {
            return Zqt(g5, "".concat(s, "-").concat(c5.tag, "-").concat(b6));
          })) : q3.default.createElement(c5.tag, xf2({ key: s }, t4e(c5.attrs)), (c5.children || []).map(function(g5, b6) {
            return Zqt(g5, "".concat(s, "-").concat(c5.tag, "-").concat(b6));
          }));
        }
        function e4e(c5) {
          return Wqt(c5)[0];
        }
        function n4e(c5) {
          return c5 ? Array.isArray(c5) ? c5 : [c5] : [];
        }
        var zJn = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, jJn = function() {
          var c5 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : zJn, s = O2.useContext(OOe), r5 = s.csp;
          O2.useEffect(function() {
            QOe(c5, "@ant-design-icons", { prepend: true, csp: r5 });
          }, []);
        }, WJn = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], yft = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
        function GJn(c5) {
          var s = c5.primaryColor, r5 = c5.secondaryColor;
          yft.primaryColor = s, yft.secondaryColor = r5 || e4e(s), yft.calculated = !!r5;
        }
        function HJn() {
          return xf2({}, yft);
        }
        var ZCt = function(c5) {
          var s = c5.icon, r5 = c5.className, g5 = c5.onClick, b6 = c5.style, S2 = c5.primaryColor, A2 = c5.secondaryColor, k2 = WX(c5, WJn), R6 = yft;
          if (S2 && (R6 = { primaryColor: S2, secondaryColor: A2 || e4e(S2) }), jJn(), BJn(JOe(s), "icon should be icon definiton, but got ".concat(s)), !JOe(s))
            return null;
          var B3 = s;
          return B3 && typeof B3.icon == "function" && (B3 = xf2(xf2({}, B3), {}, { icon: B3.icon(R6.primaryColor, R6.secondaryColor) })), Zqt(B3.icon, "svg-".concat(B3.name), xf2({ className: r5, onClick: g5, style: b6, "data-icon": B3.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, k2));
        };
        ZCt.displayName = "IconReact", ZCt.getTwoToneColors = HJn, ZCt.setTwoToneColors = GJn;
        var $qt = ZCt;
        function r4e(c5) {
          var s = n4e(c5), r5 = sD(s, 2), g5 = r5[0], b6 = r5[1];
          return $qt.setTwoToneColors({ primaryColor: g5, secondaryColor: b6 });
        }
        function UJn() {
          var c5 = $qt.getTwoToneColors();
          return c5.calculated ? [c5.primaryColor, c5.secondaryColor] : c5.primaryColor;
        }
        var qJn = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
        r4e("#1890ff");
        var $Ct = K.forwardRef(function(c5, s) {
          var r5, g5 = c5.className, b6 = c5.icon, S2 = c5.spin, A2 = c5.rotate, k2 = c5.tabIndex, R6 = c5.onClick, B3 = c5.twoToneColor, G3 = WX(c5, qJn), Z3 = K.useContext(OOe), X3 = Z3.prefixCls, tt = X3 === void 0 ? "anticon" : X3, it = GX(tt, (r5 = {}, Qd2(r5, "".concat(tt, "-").concat(b6.name), !!b6.name), Qd2(r5, "".concat(tt, "-spin"), !!S2 || b6.name === "loading"), r5), g5), pt = k2;
          pt === void 0 && R6 && (pt = -1);
          var mt = A2 ? { msTransform: "rotate(".concat(A2, "deg)"), transform: "rotate(".concat(A2, "deg)") } : void 0, Mt = n4e(B3), kt = sD(Mt, 2), Gt = kt[0], Ot = kt[1];
          return K.createElement("span", xf2(xf2({ role: "img", "aria-label": b6.name }, G3), {}, { ref: s, tabIndex: pt, onClick: R6, className: it }), K.createElement($qt, { icon: b6, primaryColor: Gt, secondaryColor: Ot, style: mt }));
        });
        $Ct.displayName = "AntdIcon", $Ct.getTwoToneColor = UJn, $Ct.setTwoToneColor = r4e;
        var ZJn = $Ct, $Jn = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, YJn = $Jn, i4e = function(c5, s) {
          return K.createElement(ZJn, xf2(xf2({}, c5), {}, { ref: s, icon: YJn }));
        };
        i4e.displayName = "LoadingOutlined";
        var KJn = K.forwardRef(i4e);
        function Ym() {
          return Ym = Object.assign || function(c5) {
            for (var s = 1; s < arguments.length; s++) {
              var r5 = arguments[s];
              for (var g5 in r5)
                Object.prototype.hasOwnProperty.call(r5, g5) && (c5[g5] = r5[g5]);
            }
            return c5;
          }, Ym.apply(this, arguments);
        }
        function mft(c5, s) {
          if (!(c5 instanceof s))
            throw new TypeError("Cannot call a class as a function");
        }
        function a4e(c5, s) {
          for (var r5 = 0; r5 < s.length; r5++) {
            var g5 = s[r5];
            g5.enumerable = g5.enumerable || false, g5.configurable = true, "value" in g5 && (g5.writable = true), Object.defineProperty(c5, g5.key, g5);
          }
        }
        function bft(c5, s, r5) {
          return s && a4e(c5.prototype, s), r5 && a4e(c5, r5), Object.defineProperty(c5, "prototype", { writable: false }), c5;
        }
        function Yqt(c5, s) {
          return Yqt = Object.setPrototypeOf || function(r5, g5) {
            return r5.__proto__ = g5, r5;
          }, Yqt(c5, s);
        }
        function Kqt(c5, s) {
          if (typeof s != "function" && s !== null)
            throw new TypeError("Super expression must either be null or a function");
          c5.prototype = Object.create(s && s.prototype, { constructor: { value: c5, writable: true, configurable: true } }), Object.defineProperty(c5, "prototype", { writable: false }), s && Yqt(c5, s);
        }
        function YCt(c5) {
          return YCt = Object.setPrototypeOf ? Object.getPrototypeOf : function(s) {
            return s.__proto__ || Object.getPrototypeOf(s);
          }, YCt(c5);
        }
        function XJn() {
          if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
            })), true;
          } catch {
            return false;
          }
        }
        function Xqt(c5) {
          if (c5 === void 0)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return c5;
        }
        function QJn(c5, s) {
          if (s && (Yw(s) === "object" || typeof s == "function"))
            return s;
          if (s !== void 0)
            throw new TypeError("Derived constructors may only return object or undefined");
          return Xqt(c5);
        }
        function Qqt(c5) {
          var s = XJn();
          return function() {
            var r5 = YCt(c5), g5;
            if (s) {
              var b6 = YCt(this).constructor;
              g5 = Reflect.construct(r5, arguments, b6);
            } else
              g5 = r5.apply(this, arguments);
            return QJn(this, g5);
          };
        }
        var Jqt = { exports: {} }, Eg2 = {};
        /** @license React v16.13.1
        * react-is.production.min.js
        *
        * Copyright (c) Facebook, Inc. and its affiliates.
        *
        * This source code is licensed under the MIT license found in the
        * LICENSE file in the root directory of this source tree.
        */
        var Zb2 = typeof Symbol == "function" && Symbol.for, tZt = Zb2 ? Symbol.for("react.element") : 60103, eZt = Zb2 ? Symbol.for("react.portal") : 60106, KCt = Zb2 ? Symbol.for("react.fragment") : 60107, XCt = Zb2 ? Symbol.for("react.strict_mode") : 60108, QCt = Zb2 ? Symbol.for("react.profiler") : 60114, JCt = Zb2 ? Symbol.for("react.provider") : 60109, tTt = Zb2 ? Symbol.for("react.context") : 60110, nZt = Zb2 ? Symbol.for("react.async_mode") : 60111, eTt = Zb2 ? Symbol.for("react.concurrent_mode") : 60111, nTt = Zb2 ? Symbol.for("react.forward_ref") : 60112, rTt = Zb2 ? Symbol.for("react.suspense") : 60113, JJn = Zb2 ? Symbol.for("react.suspense_list") : 60120, iTt = Zb2 ? Symbol.for("react.memo") : 60115, aTt = Zb2 ? Symbol.for("react.lazy") : 60116, ttr = Zb2 ? Symbol.for("react.block") : 60121, etr = Zb2 ? Symbol.for("react.fundamental") : 60117, ntr = Zb2 ? Symbol.for("react.responder") : 60118, rtr = Zb2 ? Symbol.for("react.scope") : 60119;
        function sT(c5) {
          if (typeof c5 == "object" && c5 !== null) {
            var s = c5.$$typeof;
            switch (s) {
              case tZt:
                switch (c5 = c5.type, c5) {
                  case nZt:
                  case eTt:
                  case KCt:
                  case QCt:
                  case XCt:
                  case rTt:
                    return c5;
                  default:
                    switch (c5 = c5 && c5.$$typeof, c5) {
                      case tTt:
                      case nTt:
                      case aTt:
                      case iTt:
                      case JCt:
                        return c5;
                      default:
                        return s;
                    }
                }
              case eZt:
                return s;
            }
          }
        }
        function o4e(c5) {
          return sT(c5) === eTt;
        }
        Eg2.AsyncMode = nZt, Eg2.ConcurrentMode = eTt, Eg2.ContextConsumer = tTt, Eg2.ContextProvider = JCt, Eg2.Element = tZt, Eg2.ForwardRef = nTt, Eg2.Fragment = KCt, Eg2.Lazy = aTt, Eg2.Memo = iTt, Eg2.Portal = eZt, Eg2.Profiler = QCt, Eg2.StrictMode = XCt, Eg2.Suspense = rTt, Eg2.isAsyncMode = function(c5) {
          return o4e(c5) || sT(c5) === nZt;
        }, Eg2.isConcurrentMode = o4e, Eg2.isContextConsumer = function(c5) {
          return sT(c5) === tTt;
        }, Eg2.isContextProvider = function(c5) {
          return sT(c5) === JCt;
        }, Eg2.isElement = function(c5) {
          return typeof c5 == "object" && c5 !== null && c5.$$typeof === tZt;
        }, Eg2.isForwardRef = function(c5) {
          return sT(c5) === nTt;
        }, Eg2.isFragment = function(c5) {
          return sT(c5) === KCt;
        }, Eg2.isLazy = function(c5) {
          return sT(c5) === aTt;
        }, Eg2.isMemo = function(c5) {
          return sT(c5) === iTt;
        }, Eg2.isPortal = function(c5) {
          return sT(c5) === eZt;
        }, Eg2.isProfiler = function(c5) {
          return sT(c5) === QCt;
        }, Eg2.isStrictMode = function(c5) {
          return sT(c5) === XCt;
        }, Eg2.isSuspense = function(c5) {
          return sT(c5) === rTt;
        }, Eg2.isValidElementType = function(c5) {
          return typeof c5 == "string" || typeof c5 == "function" || c5 === KCt || c5 === eTt || c5 === QCt || c5 === XCt || c5 === rTt || c5 === JJn || typeof c5 == "object" && c5 !== null && (c5.$$typeof === aTt || c5.$$typeof === iTt || c5.$$typeof === JCt || c5.$$typeof === tTt || c5.$$typeof === nTt || c5.$$typeof === etr || c5.$$typeof === ntr || c5.$$typeof === rtr || c5.$$typeof === ttr);
        }, Eg2.typeOf = sT, Jqt.exports = Eg2;
        function rZt(c5) {
          var s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r5 = [];
          return q3.default.Children.forEach(c5, function(g5) {
            g5 == null && !s.keepEmpty || (Array.isArray(g5) ? r5 = r5.concat(rZt(g5)) : Jqt.exports.isFragment(g5) && g5.props ? r5 = r5.concat(rZt(g5.props.children, s)) : r5.push(g5));
          }), r5;
        }
        function itr(c5, s) {
          typeof c5 == "function" ? c5(s) : Yw(c5) === "object" && c5 && "current" in c5 && (c5.current = s);
        }
        function atr() {
          for (var c5 = arguments.length, s = new Array(c5), r5 = 0; r5 < c5; r5++)
            s[r5] = arguments[r5];
          var g5 = s.filter(function(b6) {
            return b6;
          });
          return g5.length <= 1 ? g5[0] : function(b6) {
            s.forEach(function(S2) {
              itr(S2, b6);
            });
          };
        }
        function otr(c5) {
          var s, r5, g5 = Jqt.exports.isMemo(c5) ? c5.type.type : c5.type;
          return !(typeof g5 == "function" && !(!((s = g5.prototype) === null || s === void 0) && s.render) || typeof c5 == "function" && !(!((r5 = c5.prototype) === null || r5 === void 0) && r5.render));
        }
        function str() {
          try {
            if (!Object.assign)
              return false;
            var c5 = new String("abc");
            if (c5[5] = "de", Object.getOwnPropertyNames(c5)[0] === "5")
              return false;
            for (var s = {}, r5 = 0; r5 < 10; r5++)
              s["_" + String.fromCharCode(r5)] = r5;
            var g5 = Object.getOwnPropertyNames(s).map(function(S2) {
              return s[S2];
            });
            if (g5.join("") !== "0123456789")
              return false;
            var b6 = {};
            return "abcdefghijklmnopqrst".split("").forEach(function(S2) {
              b6[S2] = S2;
            }), Object.keys(Object.assign({}, b6)).join("") === "abcdefghijklmnopqrst";
          } catch {
            return false;
          }
        }
        str();
        function ltr(c5) {
          if (Array.isArray(c5))
            return Nqt(c5);
        }
        function s4e(c5) {
          if (typeof Symbol != "undefined" && c5[Symbol.iterator] != null || c5["@@iterator"] != null)
            return Array.from(c5);
        }
        function utr() {
          throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
        }
        function Wp(c5) {
          return ltr(c5) || s4e(c5) || Fqt(c5) || utr();
        }
        var HX = "RC_FORM_INTERNAL_HOOKS", h0 = function() {
          V32(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
        }, _ft = K.createContext({ getFieldValue: h0, getFieldsValue: h0, getFieldError: h0, getFieldWarning: h0, getFieldsError: h0, isFieldsTouched: h0, isFieldTouched: h0, isFieldValidating: h0, isFieldsValidating: h0, resetFields: h0, setFields: h0, setFieldsValue: h0, validateFields: h0, submit: h0, getInternalHooks: function() {
          return h0(), { dispatch: h0, initEntityValue: h0, registerField: h0, useSubscribe: h0, setInitialValues: h0, setCallbacks: h0, getFields: h0, setValidateMessages: h0, setPreserve: h0, getInitialValue: h0 };
        } });
        function iZt(c5) {
          return c5 == null ? [] : Array.isArray(c5) ? c5 : [c5];
        }
        var l4e = { exports: {} };
        (function(c5) {
          var s = function(r5) {
            var g5 = Object.prototype, b6 = g5.hasOwnProperty, S2, A2 = typeof Symbol == "function" ? Symbol : {}, k2 = A2.iterator || "@@iterator", R6 = A2.asyncIterator || "@@asyncIterator", B3 = A2.toStringTag || "@@toStringTag";
            function G3(Qn, rr, Ar) {
              return Object.defineProperty(Qn, rr, { value: Ar, enumerable: true, configurable: true, writable: true }), Qn[rr];
            }
            try {
              G3({}, "");
            } catch {
              G3 = function(Qn, rr, Ar) {
                return Qn[rr] = Ar;
              };
            }
            function Z3(Qn, rr, Ar, fi2) {
              var mi2 = rr && rr.prototype instanceof kt ? rr : kt, Oo = Object.create(mi2.prototype), Ts = new jn(fi2 || []);
              return Oo._invoke = je2(Qn, Ar, Ts), Oo;
            }
            r5.wrap = Z3;
            function X3(Qn, rr, Ar) {
              try {
                return { type: "normal", arg: Qn.call(rr, Ar) };
              } catch (fi2) {
                return { type: "throw", arg: fi2 };
              }
            }
            var tt = "suspendedStart", it = "suspendedYield", pt = "executing", mt = "completed", Mt = {};
            function kt() {
            }
            function Gt() {
            }
            function Ot() {
            }
            var ce2 = {};
            G3(ce2, k2, function() {
              return this;
            });
            var ae2 = Object.getPrototypeOf, de2 = ae2 && ae2(ae2(_n([])));
            de2 && de2 !== g5 && b6.call(de2, k2) && (ce2 = de2);
            var we2 = Ot.prototype = kt.prototype = Object.create(ce2);
            Gt.prototype = Ot, G3(we2, "constructor", Ot), G3(Ot, "constructor", Gt), Gt.displayName = G3(Ot, B3, "GeneratorFunction");
            function Se2(Qn) {
              ["next", "throw", "return"].forEach(function(rr) {
                G3(Qn, rr, function(Ar) {
                  return this._invoke(rr, Ar);
                });
              });
            }
            r5.isGeneratorFunction = function(Qn) {
              var rr = typeof Qn == "function" && Qn.constructor;
              return rr ? rr === Gt || (rr.displayName || rr.name) === "GeneratorFunction" : false;
            }, r5.mark = function(Qn) {
              return Object.setPrototypeOf ? Object.setPrototypeOf(Qn, Ot) : (Qn.__proto__ = Ot, G3(Qn, B3, "GeneratorFunction")), Qn.prototype = Object.create(we2), Qn;
            }, r5.awrap = function(Qn) {
              return { __await: Qn };
            };
            function Oe2(Qn, rr) {
              function Ar(Oo, Ts, gl, nl) {
                var rl = X3(Qn[Oo], Qn, Ts);
                if (rl.type === "throw")
                  nl(rl.arg);
                else {
                  var ss = rl.arg, Us = ss.value;
                  return Us && typeof Us == "object" && b6.call(Us, "__await") ? rr.resolve(Us.__await).then(function(sl) {
                    Ar("next", sl, gl, nl);
                  }, function(sl) {
                    Ar("throw", sl, gl, nl);
                  }) : rr.resolve(Us).then(function(sl) {
                    ss.value = sl, gl(ss);
                  }, function(sl) {
                    return Ar("throw", sl, gl, nl);
                  });
                }
              }
              var fi2;
              function mi2(Oo, Ts) {
                function gl() {
                  return new rr(function(nl, rl) {
                    Ar(Oo, Ts, nl, rl);
                  });
                }
                return fi2 = fi2 ? fi2.then(gl, gl) : gl();
              }
              this._invoke = mi2;
            }
            Se2(Oe2.prototype), G3(Oe2.prototype, R6, function() {
              return this;
            }), r5.AsyncIterator = Oe2, r5.async = function(Qn, rr, Ar, fi2, mi2) {
              mi2 === void 0 && (mi2 = Promise);
              var Oo = new Oe2(Z3(Qn, rr, Ar, fi2), mi2);
              return r5.isGeneratorFunction(rr) ? Oo : Oo.next().then(function(Ts) {
                return Ts.done ? Ts.value : Oo.next();
              });
            };
            function je2(Qn, rr, Ar) {
              var fi2 = tt;
              return function(mi2, Oo) {
                if (fi2 === pt)
                  throw new Error("Generator is already running");
                if (fi2 === mt) {
                  if (mi2 === "throw")
                    throw Oo;
                  return Jr();
                }
                for (Ar.method = mi2, Ar.arg = Oo; ; ) {
                  var Ts = Ar.delegate;
                  if (Ts) {
                    var gl = rn(Ts, Ar);
                    if (gl) {
                      if (gl === Mt)
                        continue;
                      return gl;
                    }
                  }
                  if (Ar.method === "next")
                    Ar.sent = Ar._sent = Ar.arg;
                  else if (Ar.method === "throw") {
                    if (fi2 === tt)
                      throw fi2 = mt, Ar.arg;
                    Ar.dispatchException(Ar.arg);
                  } else
                    Ar.method === "return" && Ar.abrupt("return", Ar.arg);
                  fi2 = pt;
                  var nl = X3(Qn, rr, Ar);
                  if (nl.type === "normal") {
                    if (fi2 = Ar.done ? mt : it, nl.arg === Mt)
                      continue;
                    return { value: nl.arg, done: Ar.done };
                  } else
                    nl.type === "throw" && (fi2 = mt, Ar.method = "throw", Ar.arg = nl.arg);
                }
              };
            }
            function rn(Qn, rr) {
              var Ar = Qn.iterator[rr.method];
              if (Ar === S2) {
                if (rr.delegate = null, rr.method === "throw") {
                  if (Qn.iterator.return && (rr.method = "return", rr.arg = S2, rn(Qn, rr), rr.method === "throw"))
                    return Mt;
                  rr.method = "throw", rr.arg = new TypeError("The iterator does not provide a 'throw' method");
                }
                return Mt;
              }
              var fi2 = X3(Ar, Qn.iterator, rr.arg);
              if (fi2.type === "throw")
                return rr.method = "throw", rr.arg = fi2.arg, rr.delegate = null, Mt;
              var mi2 = fi2.arg;
              if (!mi2)
                return rr.method = "throw", rr.arg = new TypeError("iterator result is not an object"), rr.delegate = null, Mt;
              if (mi2.done)
                rr[Qn.resultName] = mi2.value, rr.next = Qn.nextLoc, rr.method !== "return" && (rr.method = "next", rr.arg = S2);
              else
                return mi2;
              return rr.delegate = null, Mt;
            }
            Se2(we2), G3(we2, B3, "Generator"), G3(we2, k2, function() {
              return this;
            }), G3(we2, "toString", function() {
              return "[object Generator]";
            });
            function qe2(Qn) {
              var rr = { tryLoc: Qn[0] };
              1 in Qn && (rr.catchLoc = Qn[1]), 2 in Qn && (rr.finallyLoc = Qn[2], rr.afterLoc = Qn[3]), this.tryEntries.push(rr);
            }
            function An(Qn) {
              var rr = Qn.completion || {};
              rr.type = "normal", delete rr.arg, Qn.completion = rr;
            }
            function jn(Qn) {
              this.tryEntries = [{ tryLoc: "root" }], Qn.forEach(qe2, this), this.reset(true);
            }
            r5.keys = function(Qn) {
              var rr = [];
              for (var Ar in Qn)
                rr.push(Ar);
              return rr.reverse(), function fi2() {
                for (; rr.length; ) {
                  var mi2 = rr.pop();
                  if (mi2 in Qn)
                    return fi2.value = mi2, fi2.done = false, fi2;
                }
                return fi2.done = true, fi2;
              };
            };
            function _n(Qn) {
              if (Qn) {
                var rr = Qn[k2];
                if (rr)
                  return rr.call(Qn);
                if (typeof Qn.next == "function")
                  return Qn;
                if (!isNaN(Qn.length)) {
                  var Ar = -1, fi2 = function mi2() {
                    for (; ++Ar < Qn.length; )
                      if (b6.call(Qn, Ar))
                        return mi2.value = Qn[Ar], mi2.done = false, mi2;
                    return mi2.value = S2, mi2.done = true, mi2;
                  };
                  return fi2.next = fi2;
                }
              }
              return { next: Jr };
            }
            r5.values = _n;
            function Jr() {
              return { value: S2, done: true };
            }
            return jn.prototype = { constructor: jn, reset: function(Qn) {
              if (this.prev = 0, this.next = 0, this.sent = this._sent = S2, this.done = false, this.delegate = null, this.method = "next", this.arg = S2, this.tryEntries.forEach(An), !Qn)
                for (var rr in this)
                  rr.charAt(0) === "t" && b6.call(this, rr) && !isNaN(+rr.slice(1)) && (this[rr] = S2);
            }, stop: function() {
              this.done = true;
              var Qn = this.tryEntries[0], rr = Qn.completion;
              if (rr.type === "throw")
                throw rr.arg;
              return this.rval;
            }, dispatchException: function(Qn) {
              if (this.done)
                throw Qn;
              var rr = this;
              function Ar(nl, rl) {
                return Oo.type = "throw", Oo.arg = Qn, rr.next = nl, rl && (rr.method = "next", rr.arg = S2), !!rl;
              }
              for (var fi2 = this.tryEntries.length - 1; fi2 >= 0; --fi2) {
                var mi2 = this.tryEntries[fi2], Oo = mi2.completion;
                if (mi2.tryLoc === "root")
                  return Ar("end");
                if (mi2.tryLoc <= this.prev) {
                  var Ts = b6.call(mi2, "catchLoc"), gl = b6.call(mi2, "finallyLoc");
                  if (Ts && gl) {
                    if (this.prev < mi2.catchLoc)
                      return Ar(mi2.catchLoc, true);
                    if (this.prev < mi2.finallyLoc)
                      return Ar(mi2.finallyLoc);
                  } else if (Ts) {
                    if (this.prev < mi2.catchLoc)
                      return Ar(mi2.catchLoc, true);
                  } else if (gl) {
                    if (this.prev < mi2.finallyLoc)
                      return Ar(mi2.finallyLoc);
                  } else
                    throw new Error("try statement without catch or finally");
                }
              }
            }, abrupt: function(Qn, rr) {
              for (var Ar = this.tryEntries.length - 1; Ar >= 0; --Ar) {
                var fi2 = this.tryEntries[Ar];
                if (fi2.tryLoc <= this.prev && b6.call(fi2, "finallyLoc") && this.prev < fi2.finallyLoc) {
                  var mi2 = fi2;
                  break;
                }
              }
              mi2 && (Qn === "break" || Qn === "continue") && mi2.tryLoc <= rr && rr <= mi2.finallyLoc && (mi2 = null);
              var Oo = mi2 ? mi2.completion : {};
              return Oo.type = Qn, Oo.arg = rr, mi2 ? (this.method = "next", this.next = mi2.finallyLoc, Mt) : this.complete(Oo);
            }, complete: function(Qn, rr) {
              if (Qn.type === "throw")
                throw Qn.arg;
              return Qn.type === "break" || Qn.type === "continue" ? this.next = Qn.arg : Qn.type === "return" ? (this.rval = this.arg = Qn.arg, this.method = "return", this.next = "end") : Qn.type === "normal" && rr && (this.next = rr), Mt;
            }, finish: function(Qn) {
              for (var rr = this.tryEntries.length - 1; rr >= 0; --rr) {
                var Ar = this.tryEntries[rr];
                if (Ar.finallyLoc === Qn)
                  return this.complete(Ar.completion, Ar.afterLoc), An(Ar), Mt;
              }
            }, catch: function(Qn) {
              for (var rr = this.tryEntries.length - 1; rr >= 0; --rr) {
                var Ar = this.tryEntries[rr];
                if (Ar.tryLoc === Qn) {
                  var fi2 = Ar.completion;
                  if (fi2.type === "throw") {
                    var mi2 = fi2.arg;
                    An(Ar);
                  }
                  return mi2;
                }
              }
              throw new Error("illegal catch attempt");
            }, delegateYield: function(Qn, rr, Ar) {
              return this.delegate = { iterator: _n(Qn), resultName: rr, nextLoc: Ar }, this.method === "next" && (this.arg = S2), Mt;
            } }, r5;
          }(c5.exports);
          try {
            regeneratorRuntime = s;
          } catch {
            typeof globalThis == "object" ? globalThis.regeneratorRuntime = s : Function("r", "regeneratorRuntime = r")(s);
          }
        })(l4e);
        var v9 = l4e.exports;
        function u4e(c5, s, r5, g5, b6, S2, A2) {
          try {
            var k2 = c5[S2](A2), R6 = k2.value;
          } catch (B3) {
            r5(B3);
            return;
          }
          k2.done ? s(R6) : Promise.resolve(R6).then(g5, b6);
        }
        function oTt(c5) {
          return function() {
            var s = this, r5 = arguments;
            return new Promise(function(g5, b6) {
              var S2 = c5.apply(s, r5);
              function A2(R6) {
                u4e(S2, g5, b6, A2, k2, "next", R6);
              }
              function k2(R6) {
                u4e(S2, g5, b6, A2, k2, "throw", R6);
              }
              A2(void 0);
            });
          };
        }
        function NW() {
          return NW = Object.assign || function(c5) {
            for (var s = 1; s < arguments.length; s++) {
              var r5 = arguments[s];
              for (var g5 in r5)
                Object.prototype.hasOwnProperty.call(r5, g5) && (c5[g5] = r5[g5]);
            }
            return c5;
          }, NW.apply(this, arguments);
        }
        function ctr(c5, s) {
          c5.prototype = Object.create(s.prototype), c5.prototype.constructor = c5, xft(c5, s);
        }
        function aZt(c5) {
          return aZt = Object.setPrototypeOf ? Object.getPrototypeOf : function(s) {
            return s.__proto__ || Object.getPrototypeOf(s);
          }, aZt(c5);
        }
        function xft(c5, s) {
          return xft = Object.setPrototypeOf || function(r5, g5) {
            return r5.__proto__ = g5, r5;
          }, xft(c5, s);
        }
        function ftr() {
          if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
            })), true;
          } catch {
            return false;
          }
        }
        function sTt(c5, s, r5) {
          return ftr() ? sTt = Reflect.construct : sTt = function(g5, b6, S2) {
            var A2 = [null];
            A2.push.apply(A2, b6);
            var k2 = Function.bind.apply(g5, A2), R6 = new k2();
            return S2 && xft(R6, S2.prototype), R6;
          }, sTt.apply(null, arguments);
        }
        function htr(c5) {
          return Function.toString.call(c5).indexOf("[native code]") !== -1;
        }
        function oZt(c5) {
          var s = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
          return oZt = function(r5) {
            if (r5 === null || !htr(r5))
              return r5;
            if (typeof r5 != "function")
              throw new TypeError("Super expression must either be null or a function");
            if (typeof s != "undefined") {
              if (s.has(r5))
                return s.get(r5);
              s.set(r5, g5);
            }
            function g5() {
              return sTt(r5, arguments, aZt(this).constructor);
            }
            return g5.prototype = Object.create(r5.prototype, { constructor: { value: g5, enumerable: false, writable: true, configurable: true } }), xft(g5, r5);
          }, oZt(c5);
        }
        var ptr = /%[sdj%]/g, dtr = function() {
        };
        typeof process != "undefined" && process.env;
        function sZt(c5) {
          if (!c5 || !c5.length)
            return null;
          var s = {};
          return c5.forEach(function(r5) {
            var g5 = r5.field;
            s[g5] = s[g5] || [], s[g5].push(r5);
          }), s;
        }
        function lT(c5) {
          for (var s = arguments.length, r5 = new Array(s > 1 ? s - 1 : 0), g5 = 1; g5 < s; g5++)
            r5[g5 - 1] = arguments[g5];
          var b6 = 0, S2 = r5.length;
          if (typeof c5 == "function")
            return c5.apply(null, r5);
          if (typeof c5 == "string") {
            var A2 = c5.replace(ptr, function(k2) {
              if (k2 === "%%")
                return "%";
              if (b6 >= S2)
                return k2;
              switch (k2) {
                case "%s":
                  return String(r5[b6++]);
                case "%d":
                  return Number(r5[b6++]);
                case "%j":
                  try {
                    return JSON.stringify(r5[b6++]);
                  } catch {
                    return "[Circular]";
                  }
                  break;
                default:
                  return k2;
              }
            });
            return A2;
          }
          return c5;
        }
        function gtr(c5) {
          return c5 === "string" || c5 === "url" || c5 === "hex" || c5 === "email" || c5 === "date" || c5 === "pattern";
        }
        function H1(c5, s) {
          return !!(c5 == null || s === "array" && Array.isArray(c5) && !c5.length || gtr(s) && typeof c5 == "string" && !c5);
        }
        function vtr(c5, s, r5) {
          var g5 = [], b6 = 0, S2 = c5.length;
          function A2(k2) {
            g5.push.apply(g5, k2 || []), b6++, b6 === S2 && r5(g5);
          }
          c5.forEach(function(k2) {
            s(k2, A2);
          });
        }
        function c4e(c5, s, r5) {
          var g5 = 0, b6 = c5.length;
          function S2(A2) {
            if (A2 && A2.length) {
              r5(A2);
              return;
            }
            var k2 = g5;
            g5 = g5 + 1, k2 < b6 ? s(c5[k2], S2) : r5([]);
          }
          S2([]);
        }
        function ytr(c5) {
          var s = [];
          return Object.keys(c5).forEach(function(r5) {
            s.push.apply(s, c5[r5] || []);
          }), s;
        }
        var f4e = function(c5) {
          ctr(s, c5);
          function s(r5, g5) {
            var b6;
            return b6 = c5.call(this, "Async Validation Error") || this, b6.errors = r5, b6.fields = g5, b6;
          }
          return s;
        }(oZt(Error));
        function mtr(c5, s, r5, g5, b6) {
          if (s.first) {
            var S2 = new Promise(function(X3, tt) {
              var it = function(mt) {
                return g5(mt), mt.length ? tt(new f4e(mt, sZt(mt))) : X3(b6);
              }, pt = ytr(c5);
              c4e(pt, r5, it);
            });
            return S2.catch(function(X3) {
              return X3;
            }), S2;
          }
          var A2 = s.firstFields === true ? Object.keys(c5) : s.firstFields || [], k2 = Object.keys(c5), R6 = k2.length, B3 = 0, G3 = [], Z3 = new Promise(function(X3, tt) {
            var it = function(pt) {
              if (G3.push.apply(G3, pt), B3++, B3 === R6)
                return g5(G3), G3.length ? tt(new f4e(G3, sZt(G3))) : X3(b6);
            };
            k2.length || (g5(G3), X3(b6)), k2.forEach(function(pt) {
              var mt = c5[pt];
              A2.indexOf(pt) !== -1 ? c4e(mt, r5, it) : vtr(mt, r5, it);
            });
          });
          return Z3.catch(function(X3) {
            return X3;
          }), Z3;
        }
        function btr(c5) {
          return !!(c5 && c5.message !== void 0);
        }
        function _tr(c5, s) {
          for (var r5 = c5, g5 = 0; g5 < s.length; g5++) {
            if (r5 == null)
              return r5;
            r5 = r5[s[g5]];
          }
          return r5;
        }
        function h4e(c5, s) {
          return function(r5) {
            var g5;
            return c5.fullFields ? g5 = _tr(s, c5.fullFields) : g5 = s[r5.field || c5.fullField], btr(r5) ? (r5.field = r5.field || c5.fullField, r5.fieldValue = g5, r5) : { message: typeof r5 == "function" ? r5() : r5, fieldValue: g5, field: r5.field || c5.fullField };
          };
        }
        function p4e(c5, s) {
          if (s) {
            for (var r5 in s)
              if (s.hasOwnProperty(r5)) {
                var g5 = s[r5];
                typeof g5 == "object" && typeof c5[r5] == "object" ? c5[r5] = NW({}, c5[r5], g5) : c5[r5] = g5;
              }
          }
          return c5;
        }
        var d4e = function(c5, s, r5, g5, b6, S2) {
          c5.required && (!r5.hasOwnProperty(c5.field) || H1(s, S2 || c5.type)) && g5.push(lT(b6.messages.required, c5.fullField));
        }, xtr = function(c5, s, r5, g5, b6) {
          (/^\s+$/.test(s) || s === "") && g5.push(lT(b6.messages.whitespace, c5.fullField));
        }, lZt = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, wft = { integer: function(c5) {
          return wft.number(c5) && parseInt(c5, 10) === c5;
        }, float: function(c5) {
          return wft.number(c5) && !wft.integer(c5);
        }, array: function(c5) {
          return Array.isArray(c5);
        }, regexp: function(c5) {
          if (c5 instanceof RegExp)
            return true;
          try {
            return !!new RegExp(c5);
          } catch {
            return false;
          }
        }, date: function(c5) {
          return typeof c5.getTime == "function" && typeof c5.getMonth == "function" && typeof c5.getYear == "function" && !isNaN(c5.getTime());
        }, number: function(c5) {
          return isNaN(c5) ? false : typeof c5 == "number";
        }, object: function(c5) {
          return typeof c5 == "object" && !wft.array(c5);
        }, method: function(c5) {
          return typeof c5 == "function";
        }, email: function(c5) {
          return typeof c5 == "string" && c5.length <= 320 && !!c5.match(lZt.email);
        }, url: function(c5) {
          return typeof c5 == "string" && c5.length <= 2048 && !!c5.match(lZt.url);
        }, hex: function(c5) {
          return typeof c5 == "string" && !!c5.match(lZt.hex);
        } }, wtr = function(c5, s, r5, g5, b6) {
          if (c5.required && s === void 0) {
            d4e(c5, s, r5, g5, b6);
            return;
          }
          var S2 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], A2 = c5.type;
          S2.indexOf(A2) > -1 ? wft[A2](s) || g5.push(lT(b6.messages.types[A2], c5.fullField, c5.type)) : A2 && typeof s !== c5.type && g5.push(lT(b6.messages.types[A2], c5.fullField, c5.type));
        }, Str = function(c5, s, r5, g5, b6) {
          var S2 = typeof c5.len == "number", A2 = typeof c5.min == "number", k2 = typeof c5.max == "number", R6 = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, B3 = s, G3 = null, Z3 = typeof s == "number", X3 = typeof s == "string", tt = Array.isArray(s);
          if (Z3 ? G3 = "number" : X3 ? G3 = "string" : tt && (G3 = "array"), !G3)
            return false;
          tt && (B3 = s.length), X3 && (B3 = s.replace(R6, "_").length), S2 ? B3 !== c5.len && g5.push(lT(b6.messages[G3].len, c5.fullField, c5.len)) : A2 && !k2 && B3 < c5.min ? g5.push(lT(b6.messages[G3].min, c5.fullField, c5.min)) : k2 && !A2 && B3 > c5.max ? g5.push(lT(b6.messages[G3].max, c5.fullField, c5.max)) : A2 && k2 && (B3 < c5.min || B3 > c5.max) && g5.push(lT(b6.messages[G3].range, c5.fullField, c5.min, c5.max));
        }, UX = "enum", Mtr = function(c5, s, r5, g5, b6) {
          c5[UX] = Array.isArray(c5[UX]) ? c5[UX] : [], c5[UX].indexOf(s) === -1 && g5.push(lT(b6.messages[UX], c5.fullField, c5[UX].join(", ")));
        }, Ctr = function(c5, s, r5, g5, b6) {
          if (c5.pattern) {
            if (c5.pattern instanceof RegExp)
              c5.pattern.lastIndex = 0, c5.pattern.test(s) || g5.push(lT(b6.messages.pattern.mismatch, c5.fullField, s, c5.pattern));
            else if (typeof c5.pattern == "string") {
              var S2 = new RegExp(c5.pattern);
              S2.test(s) || g5.push(lT(b6.messages.pattern.mismatch, c5.fullField, s, c5.pattern));
            }
          }
        }, Ip = { required: d4e, whitespace: xtr, type: wtr, range: Str, enum: Mtr, pattern: Ctr }, Ttr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s, "string") && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6, "string"), H1(s, "string") || (Ip.type(c5, s, g5, S2, b6), Ip.range(c5, s, g5, S2, b6), Ip.pattern(c5, s, g5, S2, b6), c5.whitespace === true && Ip.whitespace(c5, s, g5, S2, b6));
          }
          r5(S2);
        }, Atr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), s !== void 0 && Ip.type(c5, s, g5, S2, b6);
          }
          r5(S2);
        }, Itr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (s === "" && (s = void 0), H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), s !== void 0 && (Ip.type(c5, s, g5, S2, b6), Ip.range(c5, s, g5, S2, b6));
          }
          r5(S2);
        }, Dtr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), s !== void 0 && Ip.type(c5, s, g5, S2, b6);
          }
          r5(S2);
        }, Etr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), H1(s) || Ip.type(c5, s, g5, S2, b6);
          }
          r5(S2);
        }, ktr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), s !== void 0 && (Ip.type(c5, s, g5, S2, b6), Ip.range(c5, s, g5, S2, b6));
          }
          r5(S2);
        }, Ptr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), s !== void 0 && (Ip.type(c5, s, g5, S2, b6), Ip.range(c5, s, g5, S2, b6));
          }
          r5(S2);
        }, Ltr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (s == null && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6, "array"), s != null && (Ip.type(c5, s, g5, S2, b6), Ip.range(c5, s, g5, S2, b6));
          }
          r5(S2);
        }, Otr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), s !== void 0 && Ip.type(c5, s, g5, S2, b6);
          }
          r5(S2);
        }, Rtr = "enum", Ntr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), s !== void 0 && Ip[Rtr](c5, s, g5, S2, b6);
          }
          r5(S2);
        }, Ftr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s, "string") && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6), H1(s, "string") || Ip.pattern(c5, s, g5, S2, b6);
          }
          r5(S2);
        }, Vtr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s, "date") && !c5.required)
              return r5();
            if (Ip.required(c5, s, g5, S2, b6), !H1(s, "date")) {
              var k2;
              s instanceof Date ? k2 = s : k2 = new Date(s), Ip.type(c5, k2, g5, S2, b6), k2 && Ip.range(c5, k2.getTime(), g5, S2, b6);
            }
          }
          r5(S2);
        }, Btr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = Array.isArray(s) ? "array" : typeof s;
          Ip.required(c5, s, g5, S2, b6, A2), r5(S2);
        }, uZt = function(c5, s, r5, g5, b6) {
          var S2 = c5.type, A2 = [], k2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (k2) {
            if (H1(s, S2) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, A2, b6, S2), H1(s, S2) || Ip.type(c5, s, g5, A2, b6);
          }
          r5(A2);
        }, ztr = function(c5, s, r5, g5, b6) {
          var S2 = [], A2 = c5.required || !c5.required && g5.hasOwnProperty(c5.field);
          if (A2) {
            if (H1(s) && !c5.required)
              return r5();
            Ip.required(c5, s, g5, S2, b6);
          }
          r5(S2);
        }, Sft = { string: Ttr, method: Atr, number: Itr, boolean: Dtr, regexp: Etr, integer: ktr, float: Ptr, array: Ltr, object: Otr, enum: Ntr, pattern: Ftr, date: Vtr, url: uZt, hex: uZt, email: uZt, required: Btr, any: ztr };
        function cZt() {
          return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
            var c5 = JSON.parse(JSON.stringify(this));
            return c5.clone = this.clone, c5;
          } };
        }
        var fZt = cZt(), Mft = function() {
          function c5(r5) {
            this.rules = null, this._messages = fZt, this.define(r5);
          }
          var s = c5.prototype;
          return s.define = function(r5) {
            var g5 = this;
            if (!r5)
              throw new Error("Cannot configure a schema with no rules");
            if (typeof r5 != "object" || Array.isArray(r5))
              throw new Error("Rules must be an object");
            this.rules = {}, Object.keys(r5).forEach(function(b6) {
              var S2 = r5[b6];
              g5.rules[b6] = Array.isArray(S2) ? S2 : [S2];
            });
          }, s.messages = function(r5) {
            return r5 && (this._messages = p4e(cZt(), r5)), this._messages;
          }, s.validate = function(r5, g5, b6) {
            var S2 = this;
            g5 === void 0 && (g5 = {}), b6 === void 0 && (b6 = function() {
            });
            var A2 = r5, k2 = g5, R6 = b6;
            if (typeof k2 == "function" && (R6 = k2, k2 = {}), !this.rules || Object.keys(this.rules).length === 0)
              return R6 && R6(null, A2), Promise.resolve(A2);
            function B3(it) {
              var pt = [], mt = {};
              function Mt(Gt) {
                if (Array.isArray(Gt)) {
                  var Ot;
                  pt = (Ot = pt).concat.apply(Ot, Gt);
                } else
                  pt.push(Gt);
              }
              for (var kt = 0; kt < it.length; kt++)
                Mt(it[kt]);
              pt.length ? (mt = sZt(pt), R6(pt, mt)) : R6(null, A2);
            }
            if (k2.messages) {
              var G3 = this.messages();
              G3 === fZt && (G3 = cZt()), p4e(G3, k2.messages), k2.messages = G3;
            } else
              k2.messages = this.messages();
            var Z3 = {}, X3 = k2.keys || Object.keys(this.rules);
            X3.forEach(function(it) {
              var pt = S2.rules[it], mt = A2[it];
              pt.forEach(function(Mt) {
                var kt = Mt;
                typeof kt.transform == "function" && (A2 === r5 && (A2 = NW({}, A2)), mt = A2[it] = kt.transform(mt)), typeof kt == "function" ? kt = { validator: kt } : kt = NW({}, kt), kt.validator = S2.getValidationMethod(kt), kt.validator && (kt.field = it, kt.fullField = kt.fullField || it, kt.type = S2.getType(kt), Z3[it] = Z3[it] || [], Z3[it].push({ rule: kt, value: mt, source: A2, field: it }));
              });
            });
            var tt = {};
            return mtr(Z3, k2, function(it, pt) {
              var mt = it.rule, Mt = (mt.type === "object" || mt.type === "array") && (typeof mt.fields == "object" || typeof mt.defaultField == "object");
              Mt = Mt && (mt.required || !mt.required && it.value), mt.field = it.field;
              function kt(ce2, ae2) {
                return NW({}, ae2, { fullField: mt.fullField + "." + ce2, fullFields: mt.fullFields ? [].concat(mt.fullFields, [ce2]) : [ce2] });
              }
              function Gt(ce2) {
                ce2 === void 0 && (ce2 = []);
                var ae2 = Array.isArray(ce2) ? ce2 : [ce2];
                !k2.suppressWarning && ae2.length && c5.warning("async-validator:", ae2), ae2.length && mt.message !== void 0 && (ae2 = [].concat(mt.message));
                var de2 = ae2.map(h4e(mt, A2));
                if (k2.first && de2.length)
                  return tt[mt.field] = 1, pt(de2);
                if (!Mt)
                  pt(de2);
                else {
                  if (mt.required && !it.value)
                    return mt.message !== void 0 ? de2 = [].concat(mt.message).map(h4e(mt, A2)) : k2.error && (de2 = [k2.error(mt, lT(k2.messages.required, mt.field))]), pt(de2);
                  var we2 = {};
                  mt.defaultField && Object.keys(it.value).map(function(je2) {
                    we2[je2] = mt.defaultField;
                  }), we2 = NW({}, we2, it.rule.fields);
                  var Se2 = {};
                  Object.keys(we2).forEach(function(je2) {
                    var rn = we2[je2], qe2 = Array.isArray(rn) ? rn : [rn];
                    Se2[je2] = qe2.map(kt.bind(null, je2));
                  });
                  var Oe2 = new c5(Se2);
                  Oe2.messages(k2.messages), it.rule.options && (it.rule.options.messages = k2.messages, it.rule.options.error = k2.error), Oe2.validate(it.value, it.rule.options || k2, function(je2) {
                    var rn = [];
                    de2 && de2.length && rn.push.apply(rn, de2), je2 && je2.length && rn.push.apply(rn, je2), pt(rn.length ? rn : null);
                  });
                }
              }
              var Ot;
              mt.asyncValidator ? Ot = mt.asyncValidator(mt, it.value, Gt, it.source, k2) : mt.validator && (Ot = mt.validator(mt, it.value, Gt, it.source, k2), Ot === true ? Gt() : Ot === false ? Gt(typeof mt.message == "function" ? mt.message(mt.fullField || mt.field) : mt.message || (mt.fullField || mt.field) + " fails") : Ot instanceof Array ? Gt(Ot) : Ot instanceof Error && Gt(Ot.message)), Ot && Ot.then && Ot.then(function() {
                return Gt();
              }, function(ce2) {
                return Gt(ce2);
              });
            }, function(it) {
              B3(it);
            }, A2);
          }, s.getType = function(r5) {
            if (r5.type === void 0 && r5.pattern instanceof RegExp && (r5.type = "pattern"), typeof r5.validator != "function" && r5.type && !Sft.hasOwnProperty(r5.type))
              throw new Error(lT("Unknown rule type %s", r5.type));
            return r5.type || "string";
          }, s.getValidationMethod = function(r5) {
            if (typeof r5.validator == "function")
              return r5.validator;
            var g5 = Object.keys(r5), b6 = g5.indexOf("message");
            return b6 !== -1 && g5.splice(b6, 1), g5.length === 1 && g5[0] === "required" ? Sft.required : Sft[this.getType(r5)] || void 0;
          }, c5;
        }();
        Mft.register = function(c5, s) {
          if (typeof s != "function")
            throw new Error("Cannot register a validator by type, validator is not a function");
          Sft[c5] = s;
        }, Mft.warning = dtr, Mft.messages = fZt, Mft.validators = Sft;
        var uT = "'${name}' is not a valid ${type}", g4e = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: uT, method: uT, array: uT, object: uT, number: uT, date: uT, boolean: uT, integer: uT, float: uT, regexp: uT, email: uT, url: uT, hex: uT }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
        function v4e(c5, s) {
          for (var r5 = c5, g5 = 0; g5 < s.length; g5 += 1) {
            if (r5 == null)
              return;
            r5 = r5[s[g5]];
          }
          return r5;
        }
        function jtr(c5) {
          return NOe(c5) || s4e(c5) || Fqt(c5) || FOe();
        }
        function y4e(c5, s, r5, g5) {
          if (!s.length)
            return r5;
          var b6 = jtr(s), S2 = b6[0], A2 = b6.slice(1), k2;
          return !c5 && typeof S2 == "number" ? k2 = [] : Array.isArray(c5) ? k2 = Wp(c5) : k2 = xf2({}, c5), g5 && r5 === void 0 && A2.length === 1 ? delete k2[S2][A2[0]] : k2[S2] = y4e(k2[S2], A2, r5, g5), k2;
        }
        function Wtr(c5, s, r5) {
          var g5 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
          return s.length && g5 && r5 === void 0 && !v4e(c5, s.slice(0, -1)) ? c5 : y4e(c5, s, r5, g5);
        }
        function Km(c5) {
          return iZt(c5);
        }
        function qX(c5, s) {
          var r5 = v4e(c5, s);
          return r5;
        }
        function FW(c5, s, r5) {
          var g5 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, b6 = Wtr(c5, s, r5, g5);
          return b6;
        }
        function m4e(c5, s) {
          var r5 = {};
          return s.forEach(function(g5) {
            var b6 = qX(c5, g5);
            r5 = FW(r5, g5, b6);
          }), r5;
        }
        function Cft(c5, s) {
          return c5 && c5.some(function(r5) {
            return x4e(r5, s);
          });
        }
        function b4e(c5) {
          return Yw(c5) === "object" && c5 !== null && Object.getPrototypeOf(c5) === Object.prototype;
        }
        function _4e(c5, s) {
          var r5 = Array.isArray(c5) ? Wp(c5) : xf2({}, c5);
          return s && Object.keys(s).forEach(function(g5) {
            var b6 = r5[g5], S2 = s[g5], A2 = b4e(b6) && b4e(S2);
            r5[g5] = A2 ? _4e(b6, S2 || {}) : S2;
          }), r5;
        }
        function lTt(c5) {
          for (var s = arguments.length, r5 = new Array(s > 1 ? s - 1 : 0), g5 = 1; g5 < s; g5++)
            r5[g5 - 1] = arguments[g5];
          return r5.reduce(function(b6, S2) {
            return _4e(b6, S2);
          }, c5);
        }
        function x4e(c5, s) {
          return !c5 || !s || c5.length !== s.length ? false : c5.every(function(r5, g5) {
            return s[g5] === r5;
          });
        }
        function Gtr(c5, s) {
          if (c5 === s)
            return true;
          if (!c5 && s || c5 && !s || !c5 || !s || Yw(c5) !== "object" || Yw(s) !== "object")
            return false;
          var r5 = Object.keys(c5), g5 = Object.keys(s), b6 = new Set([].concat(Wp(r5), Wp(g5)));
          return Wp(b6).every(function(S2) {
            var A2 = c5[S2], k2 = s[S2];
            return typeof A2 == "function" && typeof k2 == "function" ? true : A2 === k2;
          });
        }
        function Htr(c5) {
          var s = arguments.length <= 1 ? void 0 : arguments[1];
          return s && s.target && Yw(s.target) === "object" && c5 in s.target ? s.target[c5] : s;
        }
        function w4e(c5, s, r5) {
          var g5 = c5.length;
          if (s < 0 || s >= g5 || r5 < 0 || r5 >= g5)
            return c5;
          var b6 = c5[s], S2 = s - r5;
          return S2 > 0 ? [].concat(Wp(c5.slice(0, r5)), [b6], Wp(c5.slice(r5, s)), Wp(c5.slice(s + 1, g5))) : S2 < 0 ? [].concat(Wp(c5.slice(0, s)), Wp(c5.slice(s + 1, r5 + 1)), [b6], Wp(c5.slice(r5 + 1, g5))) : c5;
        }
        var Utr = Mft;
        function qtr(c5, s) {
          return c5.replace(/\$\{\w+\}/g, function(r5) {
            var g5 = r5.slice(2, -1);
            return s[g5];
          });
        }
        function hZt(c5, s, r5, g5, b6) {
          return pZt.apply(this, arguments);
        }
        function pZt() {
          return pZt = oTt(v9.mark(function c5(s, r5, g5, b6, S2) {
            var A2, k2, R6, B3, G3, Z3, X3, tt;
            return v9.wrap(function(it) {
              for (; ; )
                switch (it.prev = it.next) {
                  case 0:
                    return A2 = xf2({}, g5), delete A2.ruleIndex, k2 = null, A2 && A2.type === "array" && A2.defaultField && (k2 = A2.defaultField, delete A2.defaultField), R6 = new Utr(Qd2({}, s, [A2])), B3 = lTt({}, g4e, b6.validateMessages), R6.messages(B3), G3 = [], it.prev = 8, it.next = 11, Promise.resolve(R6.validate(Qd2({}, s, r5), xf2({}, b6)));
                  case 11:
                    it.next = 16;
                    break;
                  case 13:
                    it.prev = 13, it.t0 = it.catch(8), it.t0.errors ? G3 = it.t0.errors.map(function(pt, mt) {
                      var Mt = pt.message;
                      return K.isValidElement(Mt) ? K.cloneElement(Mt, { key: "error_".concat(mt) }) : Mt;
                    }) : (console.error(it.t0), G3 = [B3.default]);
                  case 16:
                    if (!(!G3.length && k2)) {
                      it.next = 21;
                      break;
                    }
                    return it.next = 19, Promise.all(r5.map(function(pt, mt) {
                      return hZt("".concat(s, ".").concat(mt), pt, k2, b6, S2);
                    }));
                  case 19:
                    return Z3 = it.sent, it.abrupt("return", Z3.reduce(function(pt, mt) {
                      return [].concat(Wp(pt), Wp(mt));
                    }, []));
                  case 21:
                    return X3 = xf2(xf2({}, g5), {}, { name: s, enum: (g5.enum || []).join(", ") }, S2), tt = G3.map(function(pt) {
                      return typeof pt == "string" ? qtr(pt, X3) : pt;
                    }), it.abrupt("return", tt);
                  case 24:
                  case "end":
                    return it.stop();
                }
            }, c5, null, [[8, 13]]);
          })), pZt.apply(this, arguments);
        }
        function Ztr(c5, s, r5, g5, b6, S2) {
          var A2 = c5.join("."), k2 = r5.map(function(G3, Z3) {
            var X3 = G3.validator, tt = xf2(xf2({}, G3), {}, { ruleIndex: Z3 });
            return X3 && (tt.validator = function(it, pt, mt) {
              var Mt = false, kt = function() {
                for (var Ot = arguments.length, ce2 = new Array(Ot), ae2 = 0; ae2 < Ot; ae2++)
                  ce2[ae2] = arguments[ae2];
                Promise.resolve().then(function() {
                  V32(!Mt, "Your validator function has already return a promise. `callback` will be ignored."), Mt || mt.apply(void 0, ce2);
                });
              }, Gt = X3(it, pt, kt);
              Mt = Gt && typeof Gt.then == "function" && typeof Gt.catch == "function", V32(Mt, "`callback` is deprecated. Please return a promise instead."), Mt && Gt.then(function() {
                mt();
              }).catch(function(Ot) {
                mt(Ot || " ");
              });
            }), tt;
          }).sort(function(G3, Z3) {
            var X3 = G3.warningOnly, tt = G3.ruleIndex, it = Z3.warningOnly, pt = Z3.ruleIndex;
            return !!X3 == !!it ? tt - pt : X3 ? 1 : -1;
          }), R6;
          if (b6 === true)
            R6 = new Promise(function() {
              var G3 = oTt(v9.mark(function Z3(X3, tt) {
                var it, pt, mt;
                return v9.wrap(function(Mt) {
                  for (; ; )
                    switch (Mt.prev = Mt.next) {
                      case 0:
                        it = 0;
                      case 1:
                        if (!(it < k2.length)) {
                          Mt.next = 12;
                          break;
                        }
                        return pt = k2[it], Mt.next = 5, hZt(A2, s, pt, g5, S2);
                      case 5:
                        if (mt = Mt.sent, !mt.length) {
                          Mt.next = 9;
                          break;
                        }
                        return tt([{ errors: mt, rule: pt }]), Mt.abrupt("return");
                      case 9:
                        it += 1, Mt.next = 1;
                        break;
                      case 12:
                        X3([]);
                      case 13:
                      case "end":
                        return Mt.stop();
                    }
                }, Z3);
              }));
              return function(Z3, X3) {
                return G3.apply(this, arguments);
              };
            }());
          else {
            var B3 = k2.map(function(G3) {
              return hZt(A2, s, G3, g5, S2).then(function(Z3) {
                return { errors: Z3, rule: G3 };
              });
            });
            R6 = (b6 ? Ytr(B3) : $tr(B3)).then(function(G3) {
              return Promise.reject(G3);
            });
          }
          return R6.catch(function(G3) {
            return G3;
          }), R6;
        }
        function $tr(c5) {
          return dZt.apply(this, arguments);
        }
        function dZt() {
          return dZt = oTt(v9.mark(function c5(s) {
            return v9.wrap(function(r5) {
              for (; ; )
                switch (r5.prev = r5.next) {
                  case 0:
                    return r5.abrupt("return", Promise.all(s).then(function(g5) {
                      var b6, S2 = (b6 = []).concat.apply(b6, Wp(g5));
                      return S2;
                    }));
                  case 1:
                  case "end":
                    return r5.stop();
                }
            }, c5);
          })), dZt.apply(this, arguments);
        }
        function Ytr(c5) {
          return gZt.apply(this, arguments);
        }
        function gZt() {
          return gZt = oTt(v9.mark(function c5(s) {
            var r5;
            return v9.wrap(function(g5) {
              for (; ; )
                switch (g5.prev = g5.next) {
                  case 0:
                    return r5 = 0, g5.abrupt("return", new Promise(function(b6) {
                      s.forEach(function(S2) {
                        S2.then(function(A2) {
                          A2.errors.length && b6([A2]), r5 += 1, r5 === s.length && b6([]);
                        });
                      });
                    }));
                  case 2:
                  case "end":
                    return g5.stop();
                }
            }, c5);
          })), gZt.apply(this, arguments);
        }
        var Ktr = ["name"], uD = [];
        function S4e(c5, s, r5, g5, b6, S2) {
          return typeof c5 == "function" ? c5(s, r5, "source" in S2 ? { source: S2.source } : {}) : g5 !== b6;
        }
        var vZt = function(c5) {
          Kqt(r5, c5);
          var s = Qqt(r5);
          function r5(g5) {
            var b6;
            if (mft(this, r5), b6 = s.call(this, g5), b6.state = { resetCount: 0 }, b6.cancelRegisterFunc = null, b6.mounted = false, b6.touched = false, b6.dirty = false, b6.validatePromise = null, b6.prevValidating = void 0, b6.errors = uD, b6.warnings = uD, b6.cancelRegister = function() {
              var R6 = b6.props, B3 = R6.preserve, G3 = R6.isListField, Z3 = R6.name;
              b6.cancelRegisterFunc && b6.cancelRegisterFunc(G3, B3, Km(Z3)), b6.cancelRegisterFunc = null;
            }, b6.getNamePath = function() {
              var R6 = b6.props, B3 = R6.name, G3 = R6.fieldContext, Z3 = G3.prefixName, X3 = Z3 === void 0 ? [] : Z3;
              return B3 !== void 0 ? [].concat(Wp(X3), Wp(B3)) : [];
            }, b6.getRules = function() {
              var R6 = b6.props, B3 = R6.rules, G3 = B3 === void 0 ? [] : B3, Z3 = R6.fieldContext;
              return G3.map(function(X3) {
                return typeof X3 == "function" ? X3(Z3) : X3;
              });
            }, b6.refresh = function() {
              !b6.mounted || b6.setState(function(R6) {
                var B3 = R6.resetCount;
                return { resetCount: B3 + 1 };
              });
            }, b6.triggerMetaEvent = function(R6) {
              var B3 = b6.props.onMetaChange;
              B3 == null || B3(xf2(xf2({}, b6.getMeta()), {}, { destroy: R6 }));
            }, b6.onStoreChange = function(R6, B3, G3) {
              var Z3 = b6.props, X3 = Z3.shouldUpdate, tt = Z3.dependencies, it = tt === void 0 ? [] : tt, pt = Z3.onReset, mt = G3.store, Mt = b6.getNamePath(), kt = b6.getValue(R6), Gt = b6.getValue(mt), Ot = B3 && Cft(B3, Mt);
              switch (G3.type === "valueUpdate" && G3.source === "external" && kt !== Gt && (b6.touched = true, b6.dirty = true, b6.validatePromise = null, b6.errors = uD, b6.warnings = uD, b6.triggerMetaEvent()), G3.type) {
                case "reset":
                  if (!B3 || Ot) {
                    b6.touched = false, b6.dirty = false, b6.validatePromise = null, b6.errors = uD, b6.warnings = uD, b6.triggerMetaEvent(), pt == null || pt(), b6.refresh();
                    return;
                  }
                  break;
                case "remove": {
                  if (X3) {
                    b6.reRender();
                    return;
                  }
                  break;
                }
                case "setField": {
                  if (Ot) {
                    var ce2 = G3.data;
                    "touched" in ce2 && (b6.touched = ce2.touched), "validating" in ce2 && !("originRCField" in ce2) && (b6.validatePromise = ce2.validating ? Promise.resolve([]) : null), "errors" in ce2 && (b6.errors = ce2.errors || uD), "warnings" in ce2 && (b6.warnings = ce2.warnings || uD), b6.dirty = true, b6.triggerMetaEvent(), b6.reRender();
                    return;
                  }
                  if (X3 && !Mt.length && S4e(X3, R6, mt, kt, Gt, G3)) {
                    b6.reRender();
                    return;
                  }
                  break;
                }
                case "dependenciesUpdate": {
                  var ae2 = it.map(Km);
                  if (ae2.some(function(de2) {
                    return Cft(G3.relatedFields, de2);
                  })) {
                    b6.reRender();
                    return;
                  }
                  break;
                }
                default:
                  if (Ot || (!it.length || Mt.length || X3) && S4e(X3, R6, mt, kt, Gt, G3)) {
                    b6.reRender();
                    return;
                  }
                  break;
              }
              X3 === true && b6.reRender();
            }, b6.validateRules = function(R6) {
              var B3 = b6.getNamePath(), G3 = b6.getValue(), Z3 = Promise.resolve().then(function() {
                if (!b6.mounted)
                  return [];
                var X3 = b6.props, tt = X3.validateFirst, it = tt === void 0 ? false : tt, pt = X3.messageVariables, mt = R6 || {}, Mt = mt.triggerName, kt = b6.getRules();
                Mt && (kt = kt.filter(function(Ot) {
                  var ce2 = Ot.validateTrigger;
                  if (!ce2)
                    return true;
                  var ae2 = iZt(ce2);
                  return ae2.includes(Mt);
                }));
                var Gt = Ztr(B3, G3, kt, R6, it, pt);
                return Gt.catch(function(Ot) {
                  return Ot;
                }).then(function() {
                  var Ot = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : uD;
                  if (b6.validatePromise === Z3) {
                    b6.validatePromise = null;
                    var ce2 = [], ae2 = [];
                    Ot.forEach(function(de2) {
                      var we2 = de2.rule.warningOnly, Se2 = de2.errors, Oe2 = Se2 === void 0 ? uD : Se2;
                      we2 ? ae2.push.apply(ae2, Wp(Oe2)) : ce2.push.apply(ce2, Wp(Oe2));
                    }), b6.errors = ce2, b6.warnings = ae2, b6.triggerMetaEvent(), b6.reRender();
                  }
                }), Gt;
              });
              return b6.validatePromise = Z3, b6.dirty = true, b6.errors = uD, b6.warnings = uD, b6.triggerMetaEvent(), b6.reRender(), Z3;
            }, b6.isFieldValidating = function() {
              return !!b6.validatePromise;
            }, b6.isFieldTouched = function() {
              return b6.touched;
            }, b6.isFieldDirty = function() {
              if (b6.dirty || b6.props.initialValue !== void 0)
                return true;
              var R6 = b6.props.fieldContext, B3 = R6.getInternalHooks(HX), G3 = B3.getInitialValue;
              return G3(b6.getNamePath()) !== void 0;
            }, b6.getErrors = function() {
              return b6.errors;
            }, b6.getWarnings = function() {
              return b6.warnings;
            }, b6.isListField = function() {
              return b6.props.isListField;
            }, b6.isList = function() {
              return b6.props.isList;
            }, b6.isPreserve = function() {
              return b6.props.preserve;
            }, b6.getMeta = function() {
              b6.prevValidating = b6.isFieldValidating();
              var R6 = { touched: b6.isFieldTouched(), validating: b6.prevValidating, errors: b6.errors, warnings: b6.warnings, name: b6.getNamePath() };
              return R6;
            }, b6.getOnlyChild = function(R6) {
              if (typeof R6 == "function") {
                var B3 = b6.getMeta();
                return xf2(xf2({}, b6.getOnlyChild(R6(b6.getControlled(), B3, b6.props.fieldContext))), {}, { isFunction: true });
              }
              var G3 = rZt(R6);
              return G3.length !== 1 || !K.isValidElement(G3[0]) ? { child: G3, isFunction: false } : { child: G3[0], isFunction: false };
            }, b6.getValue = function(R6) {
              var B3 = b6.props.fieldContext.getFieldsValue, G3 = b6.getNamePath();
              return qX(R6 || B3(true), G3);
            }, b6.getControlled = function() {
              var R6 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, B3 = b6.props, G3 = B3.trigger, Z3 = B3.validateTrigger, X3 = B3.getValueFromEvent, tt = B3.normalize, it = B3.valuePropName, pt = B3.getValueProps, mt = B3.fieldContext, Mt = Z3 !== void 0 ? Z3 : mt.validateTrigger, kt = b6.getNamePath(), Gt = mt.getInternalHooks, Ot = mt.getFieldsValue, ce2 = Gt(HX), ae2 = ce2.dispatch, de2 = b6.getValue(), we2 = pt || function(rn) {
                return Qd2({}, it, rn);
              }, Se2 = R6[G3], Oe2 = xf2(xf2({}, R6), we2(de2));
              Oe2[G3] = function() {
                b6.touched = true, b6.dirty = true, b6.triggerMetaEvent();
                for (var rn, qe2 = arguments.length, An = new Array(qe2), jn = 0; jn < qe2; jn++)
                  An[jn] = arguments[jn];
                X3 ? rn = X3.apply(void 0, An) : rn = Htr.apply(void 0, [it].concat(An)), tt && (rn = tt(rn, de2, Ot(true))), ae2({ type: "updateValue", namePath: kt, value: rn }), Se2 && Se2.apply(void 0, An);
              };
              var je2 = iZt(Mt || []);
              return je2.forEach(function(rn) {
                var qe2 = Oe2[rn];
                Oe2[rn] = function() {
                  qe2 && qe2.apply(void 0, arguments);
                  var An = b6.props.rules;
                  An && An.length && ae2({ type: "validateField", namePath: kt, triggerName: rn });
                };
              }), Oe2;
            }, g5.fieldContext) {
              var S2 = g5.fieldContext.getInternalHooks, A2 = S2(HX), k2 = A2.initEntityValue;
              k2(Xqt(b6));
            }
            return b6;
          }
          return bft(r5, [{ key: "componentDidMount", value: function() {
            var g5 = this.props, b6 = g5.shouldUpdate, S2 = g5.fieldContext;
            if (this.mounted = true, S2) {
              var A2 = S2.getInternalHooks, k2 = A2(HX), R6 = k2.registerField;
              this.cancelRegisterFunc = R6(this);
            }
            b6 === true && this.reRender();
          } }, { key: "componentWillUnmount", value: function() {
            this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
          } }, { key: "reRender", value: function() {
            !this.mounted || this.forceUpdate();
          } }, { key: "render", value: function() {
            var g5 = this.state.resetCount, b6 = this.props.children, S2 = this.getOnlyChild(b6), A2 = S2.child, k2 = S2.isFunction, R6;
            return k2 ? R6 = A2 : K.isValidElement(A2) ? R6 = K.cloneElement(A2, this.getControlled(A2.props)) : (V32(!A2, "`children` of Field is not validate ReactElement."), R6 = A2), K.createElement(K.Fragment, { key: g5 }, R6);
          } }]), r5;
        }(K.Component);
        vZt.contextType = _ft, vZt.defaultProps = { trigger: "onChange", valuePropName: "value" };
        function M4e(c5) {
          var s = c5.name, r5 = WX(c5, Ktr), g5 = K.useContext(_ft), b6 = s !== void 0 ? Km(s) : void 0, S2 = "keep";
          return r5.isListField || (S2 = "_".concat((b6 || []).join("_"))), K.createElement(vZt, Ym({ key: S2, name: b6 }, r5, { fieldContext: g5 }));
        }
        var Xtr = K.createContext(null), Qtr = function(c5) {
          var s = c5.name, r5 = c5.initialValue, g5 = c5.children, b6 = c5.rules, S2 = c5.validateTrigger, A2 = K.useContext(_ft), k2 = K.useRef({ keys: [], id: 0 }), R6 = k2.current, B3 = K.useMemo(function() {
            var tt = Km(A2.prefixName) || [];
            return [].concat(Wp(tt), Wp(Km(s)));
          }, [A2.prefixName, s]), G3 = K.useMemo(function() {
            return xf2(xf2({}, A2), {}, { prefixName: B3 });
          }, [A2, B3]), Z3 = K.useMemo(function() {
            return { getKey: function(tt) {
              var it = B3.length, pt = tt[it];
              return [R6.keys[pt], tt.slice(it + 1)];
            } };
          }, [B3]);
          if (typeof g5 != "function")
            return V32(false, "Form.List only accepts function as children."), null;
          var X3 = function(tt, it, pt) {
            var mt = pt.source;
            return mt === "internal" ? false : tt !== it;
          };
          return K.createElement(Xtr.Provider, { value: Z3 }, K.createElement(_ft.Provider, { value: G3 }, K.createElement(M4e, { name: [], shouldUpdate: X3, rules: b6, validateTrigger: S2, initialValue: r5, isList: true }, function(tt, it) {
            var pt = tt.value, mt = pt === void 0 ? [] : pt, Mt = tt.onChange, kt = A2.getFieldValue, Gt = function() {
              var ae2 = kt(B3 || []);
              return ae2 || [];
            }, Ot = { add: function(ae2, de2) {
              var we2 = Gt();
              de2 >= 0 && de2 <= we2.length ? (R6.keys = [].concat(Wp(R6.keys.slice(0, de2)), [R6.id], Wp(R6.keys.slice(de2))), Mt([].concat(Wp(we2.slice(0, de2)), [ae2], Wp(we2.slice(de2))))) : (R6.keys = [].concat(Wp(R6.keys), [R6.id]), Mt([].concat(Wp(we2), [ae2]))), R6.id += 1;
            }, remove: function(ae2) {
              var de2 = Gt(), we2 = new Set(Array.isArray(ae2) ? ae2 : [ae2]);
              we2.size <= 0 || (R6.keys = R6.keys.filter(function(Se2, Oe2) {
                return !we2.has(Oe2);
              }), Mt(de2.filter(function(Se2, Oe2) {
                return !we2.has(Oe2);
              })));
            }, move: function(ae2, de2) {
              if (ae2 !== de2) {
                var we2 = Gt();
                ae2 < 0 || ae2 >= we2.length || de2 < 0 || de2 >= we2.length || (R6.keys = w4e(R6.keys, ae2, de2), Mt(w4e(we2, ae2, de2)));
              }
            } }, ce2 = mt || [];
            return Array.isArray(ce2) || (ce2 = []), g5(ce2.map(function(ae2, de2) {
              var we2 = R6.keys[de2];
              return we2 === void 0 && (R6.keys[de2] = R6.id, we2 = R6.keys[de2], R6.id += 1), { name: de2, key: we2, isListField: true };
            }), Ot, it);
          })));
        };
        function Jtr(c5) {
          var s = false, r5 = c5.length, g5 = [];
          return c5.length ? new Promise(function(b6, S2) {
            c5.forEach(function(A2, k2) {
              A2.catch(function(R6) {
                return s = true, R6;
              }).then(function(R6) {
                r5 -= 1, g5[k2] = R6, !(r5 > 0) && (s && S2(g5), b6(g5));
              });
            });
          }) : Promise.resolve([]);
        }
        var C4e = "__@field_split__";
        function yZt(c5) {
          return c5.map(function(s) {
            return "".concat(Yw(s), ":").concat(s);
          }).join(C4e);
        }
        var Tft = function() {
          function c5() {
            mft(this, c5), this.kvs = /* @__PURE__ */ new Map();
          }
          return bft(c5, [{ key: "set", value: function(s, r5) {
            this.kvs.set(yZt(s), r5);
          } }, { key: "get", value: function(s) {
            return this.kvs.get(yZt(s));
          } }, { key: "update", value: function(s, r5) {
            var g5 = this.get(s), b6 = r5(g5);
            b6 ? this.set(s, b6) : this.delete(s);
          } }, { key: "delete", value: function(s) {
            this.kvs.delete(yZt(s));
          } }, { key: "map", value: function(s) {
            return Wp(this.kvs.entries()).map(function(r5) {
              var g5 = sD(r5, 2), b6 = g5[0], S2 = g5[1], A2 = b6.split(C4e);
              return s({ key: A2.map(function(k2) {
                var R6 = k2.match(/^([^:]*):(.*)$/), B3 = sD(R6, 3), G3 = B3[1], Z3 = B3[2];
                return G3 === "number" ? Number(Z3) : Z3;
              }), value: S2 });
            });
          } }, { key: "toJSON", value: function() {
            var s = {};
            return this.map(function(r5) {
              var g5 = r5.key, b6 = r5.value;
              return s[g5.join(".")] = b6, null;
            }), s;
          } }]), c5;
        }(), ter = ["name", "errors"], eer = bft(function c5(s) {
          var r5 = this;
          mft(this, c5), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
            return { getFieldValue: r5.getFieldValue, getFieldsValue: r5.getFieldsValue, getFieldError: r5.getFieldError, getFieldWarning: r5.getFieldWarning, getFieldsError: r5.getFieldsError, isFieldsTouched: r5.isFieldsTouched, isFieldTouched: r5.isFieldTouched, isFieldValidating: r5.isFieldValidating, isFieldsValidating: r5.isFieldsValidating, resetFields: r5.resetFields, setFields: r5.setFields, setFieldsValue: r5.setFieldsValue, validateFields: r5.validateFields, submit: r5.submit, getInternalHooks: r5.getInternalHooks };
          }, this.getInternalHooks = function(g5) {
            return g5 === HX ? (r5.formHooked = true, { dispatch: r5.dispatch, initEntityValue: r5.initEntityValue, registerField: r5.registerField, useSubscribe: r5.useSubscribe, setInitialValues: r5.setInitialValues, setCallbacks: r5.setCallbacks, setValidateMessages: r5.setValidateMessages, getFields: r5.getFields, setPreserve: r5.setPreserve, getInitialValue: r5.getInitialValue }) : (V32(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
          }, this.useSubscribe = function(g5) {
            r5.subscribable = g5;
          }, this.setInitialValues = function(g5, b6) {
            r5.initialValues = g5 || {}, b6 && (r5.store = lTt({}, g5, r5.store));
          }, this.getInitialValue = function(g5) {
            return qX(r5.initialValues, g5);
          }, this.setCallbacks = function(g5) {
            r5.callbacks = g5;
          }, this.setValidateMessages = function(g5) {
            r5.validateMessages = g5;
          }, this.setPreserve = function(g5) {
            r5.preserve = g5;
          }, this.timeoutId = null, this.warningUnhooked = function() {
          }, this.getFieldEntities = function() {
            var g5 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
            return g5 ? r5.fieldEntities.filter(function(b6) {
              return b6.getNamePath().length;
            }) : r5.fieldEntities;
          }, this.getFieldsMap = function() {
            var g5 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, b6 = new Tft();
            return r5.getFieldEntities(g5).forEach(function(S2) {
              var A2 = S2.getNamePath();
              b6.set(A2, S2);
            }), b6;
          }, this.getFieldEntitiesForNamePathList = function(g5) {
            if (!g5)
              return r5.getFieldEntities(true);
            var b6 = r5.getFieldsMap(true);
            return g5.map(function(S2) {
              var A2 = Km(S2);
              return b6.get(A2) || { INVALIDATE_NAME_PATH: Km(S2) };
            });
          }, this.getFieldsValue = function(g5, b6) {
            if (r5.warningUnhooked(), g5 === true && !b6)
              return r5.store;
            var S2 = r5.getFieldEntitiesForNamePathList(Array.isArray(g5) ? g5 : null), A2 = [];
            return S2.forEach(function(k2) {
              var R6, B3 = "INVALIDATE_NAME_PATH" in k2 ? k2.INVALIDATE_NAME_PATH : k2.getNamePath();
              if (!(!g5 && ((R6 = k2.isListField) === null || R6 === void 0 ? void 0 : R6.call(k2))))
                if (!b6)
                  A2.push(B3);
                else {
                  var G3 = "getMeta" in k2 ? k2.getMeta() : null;
                  b6(G3) && A2.push(B3);
                }
            }), m4e(r5.store, A2.map(Km));
          }, this.getFieldValue = function(g5) {
            r5.warningUnhooked();
            var b6 = Km(g5);
            return qX(r5.store, b6);
          }, this.getFieldsError = function(g5) {
            r5.warningUnhooked();
            var b6 = r5.getFieldEntitiesForNamePathList(g5);
            return b6.map(function(S2, A2) {
              return S2 && !("INVALIDATE_NAME_PATH" in S2) ? { name: S2.getNamePath(), errors: S2.getErrors(), warnings: S2.getWarnings() } : { name: Km(g5[A2]), errors: [], warnings: [] };
            });
          }, this.getFieldError = function(g5) {
            r5.warningUnhooked();
            var b6 = Km(g5), S2 = r5.getFieldsError([b6])[0];
            return S2.errors;
          }, this.getFieldWarning = function(g5) {
            r5.warningUnhooked();
            var b6 = Km(g5), S2 = r5.getFieldsError([b6])[0];
            return S2.warnings;
          }, this.isFieldsTouched = function() {
            r5.warningUnhooked();
            for (var g5 = arguments.length, b6 = new Array(g5), S2 = 0; S2 < g5; S2++)
              b6[S2] = arguments[S2];
            var A2 = b6[0], k2 = b6[1], R6, B3 = false;
            b6.length === 0 ? R6 = null : b6.length === 1 ? Array.isArray(A2) ? (R6 = A2.map(Km), B3 = false) : (R6 = null, B3 = A2) : (R6 = A2.map(Km), B3 = k2);
            var G3 = r5.getFieldEntities(true), Z3 = function(pt) {
              return pt.isFieldTouched();
            };
            if (!R6)
              return B3 ? G3.every(Z3) : G3.some(Z3);
            var X3 = new Tft();
            R6.forEach(function(pt) {
              X3.set(pt, []);
            }), G3.forEach(function(pt) {
              var mt = pt.getNamePath();
              R6.forEach(function(Mt) {
                Mt.every(function(kt, Gt) {
                  return mt[Gt] === kt;
                }) && X3.update(Mt, function(kt) {
                  return [].concat(Wp(kt), [pt]);
                });
              });
            });
            var tt = function(pt) {
              return pt.some(Z3);
            }, it = X3.map(function(pt) {
              var mt = pt.value;
              return mt;
            });
            return B3 ? it.every(tt) : it.some(tt);
          }, this.isFieldTouched = function(g5) {
            return r5.warningUnhooked(), r5.isFieldsTouched([g5]);
          }, this.isFieldsValidating = function(g5) {
            r5.warningUnhooked();
            var b6 = r5.getFieldEntities();
            if (!g5)
              return b6.some(function(A2) {
                return A2.isFieldValidating();
              });
            var S2 = g5.map(Km);
            return b6.some(function(A2) {
              var k2 = A2.getNamePath();
              return Cft(S2, k2) && A2.isFieldValidating();
            });
          }, this.isFieldValidating = function(g5) {
            return r5.warningUnhooked(), r5.isFieldsValidating([g5]);
          }, this.resetWithFieldInitialValue = function() {
            var g5 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, b6 = new Tft(), S2 = r5.getFieldEntities(true);
            S2.forEach(function(R6) {
              var B3 = R6.props.initialValue, G3 = R6.getNamePath();
              if (B3 !== void 0) {
                var Z3 = b6.get(G3) || /* @__PURE__ */ new Set();
                Z3.add({ entity: R6, value: B3 }), b6.set(G3, Z3);
              }
            });
            var A2 = function(R6) {
              R6.forEach(function(B3) {
                var G3 = B3.props.initialValue;
                if (G3 !== void 0) {
                  var Z3 = B3.getNamePath(), X3 = r5.getInitialValue(Z3);
                  if (X3 !== void 0)
                    V32(false, "Form already set 'initialValues' with path '".concat(Z3.join("."), "'. Field can not overwrite it."));
                  else {
                    var tt = b6.get(Z3);
                    if (tt && tt.size > 1)
                      V32(false, "Multiple Field with path '".concat(Z3.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                    else if (tt) {
                      var it = r5.getFieldValue(Z3);
                      (!g5.skipExist || it === void 0) && (r5.store = FW(r5.store, Z3, Wp(tt)[0].value));
                    }
                  }
                }
              });
            }, k2;
            g5.entities ? k2 = g5.entities : g5.namePathList ? (k2 = [], g5.namePathList.forEach(function(R6) {
              var B3 = b6.get(R6);
              if (B3) {
                var G3;
                (G3 = k2).push.apply(G3, Wp(Wp(B3).map(function(Z3) {
                  return Z3.entity;
                })));
              }
            })) : k2 = S2, A2(k2);
          }, this.resetFields = function(g5) {
            r5.warningUnhooked();
            var b6 = r5.store;
            if (!g5) {
              r5.store = lTt({}, r5.initialValues), r5.resetWithFieldInitialValue(), r5.notifyObservers(b6, null, { type: "reset" });
              return;
            }
            var S2 = g5.map(Km);
            S2.forEach(function(A2) {
              var k2 = r5.getInitialValue(A2);
              r5.store = FW(r5.store, A2, k2);
            }), r5.resetWithFieldInitialValue({ namePathList: S2 }), r5.notifyObservers(b6, S2, { type: "reset" });
          }, this.setFields = function(g5) {
            r5.warningUnhooked();
            var b6 = r5.store;
            g5.forEach(function(S2) {
              var A2 = S2.name;
              S2.errors;
              var k2 = WX(S2, ter), R6 = Km(A2);
              "value" in k2 && (r5.store = FW(r5.store, R6, k2.value)), r5.notifyObservers(b6, [R6], { type: "setField", data: S2 });
            });
          }, this.getFields = function() {
            var g5 = r5.getFieldEntities(true), b6 = g5.map(function(S2) {
              var A2 = S2.getNamePath(), k2 = S2.getMeta(), R6 = xf2(xf2({}, k2), {}, { name: A2, value: r5.getFieldValue(A2) });
              return Object.defineProperty(R6, "originRCField", { value: true }), R6;
            });
            return b6;
          }, this.initEntityValue = function(g5) {
            var b6 = g5.props.initialValue;
            if (b6 !== void 0) {
              var S2 = g5.getNamePath(), A2 = qX(r5.store, S2);
              A2 === void 0 && (r5.store = FW(r5.store, S2, b6));
            }
          }, this.registerField = function(g5) {
            if (r5.fieldEntities.push(g5), g5.props.initialValue !== void 0) {
              var b6 = r5.store;
              r5.resetWithFieldInitialValue({ entities: [g5], skipExist: true }), r5.notifyObservers(b6, [g5.getNamePath()], { type: "valueUpdate", source: "internal" });
            }
            return function(S2, A2) {
              var k2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
              r5.fieldEntities = r5.fieldEntities.filter(function(X3) {
                return X3 !== g5;
              });
              var R6 = A2 !== void 0 ? A2 : r5.preserve;
              if (R6 === false && (!S2 || k2.length > 1)) {
                var B3 = g5.getNamePath(), G3 = S2 ? void 0 : qX(r5.initialValues, B3);
                if (B3.length && r5.getFieldValue(B3) !== G3 && r5.fieldEntities.every(function(X3) {
                  return !x4e(X3.getNamePath(), B3);
                })) {
                  var Z3 = r5.store;
                  r5.store = FW(Z3, B3, G3, true), r5.notifyObservers(Z3, [B3], { type: "remove" }), r5.triggerDependenciesUpdate(Z3, B3);
                }
              }
            };
          }, this.dispatch = function(g5) {
            switch (g5.type) {
              case "updateValue": {
                var b6 = g5.namePath, S2 = g5.value;
                r5.updateValue(b6, S2);
                break;
              }
              case "validateField": {
                var A2 = g5.namePath, k2 = g5.triggerName;
                r5.validateFields([A2], { triggerName: k2 });
                break;
              }
            }
          }, this.notifyObservers = function(g5, b6, S2) {
            if (r5.subscribable) {
              var A2 = xf2(xf2({}, S2), {}, { store: r5.getFieldsValue(true) });
              r5.getFieldEntities().forEach(function(k2) {
                var R6 = k2.onStoreChange;
                R6(g5, b6, A2);
              });
            } else
              r5.forceRootUpdate();
          }, this.triggerDependenciesUpdate = function(g5, b6) {
            var S2 = r5.getDependencyChildrenFields(b6);
            return S2.length && r5.validateFields(S2), r5.notifyObservers(g5, S2, { type: "dependenciesUpdate", relatedFields: [b6].concat(Wp(S2)) }), S2;
          }, this.updateValue = function(g5, b6) {
            var S2 = Km(g5), A2 = r5.store;
            r5.store = FW(r5.store, S2, b6), r5.notifyObservers(A2, [S2], { type: "valueUpdate", source: "internal" });
            var k2 = r5.triggerDependenciesUpdate(A2, S2), R6 = r5.callbacks.onValuesChange;
            if (R6) {
              var B3 = m4e(r5.store, [S2]);
              R6(B3, r5.getFieldsValue());
            }
            r5.triggerOnFieldsChange([S2].concat(Wp(k2)));
          }, this.setFieldsValue = function(g5) {
            r5.warningUnhooked();
            var b6 = r5.store;
            g5 && (r5.store = lTt(r5.store, g5)), r5.notifyObservers(b6, null, { type: "valueUpdate", source: "external" });
          }, this.getDependencyChildrenFields = function(g5) {
            var b6 = /* @__PURE__ */ new Set(), S2 = [], A2 = new Tft();
            r5.getFieldEntities().forEach(function(R6) {
              var B3 = R6.props.dependencies;
              (B3 || []).forEach(function(G3) {
                var Z3 = Km(G3);
                A2.update(Z3, function() {
                  var X3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                  return X3.add(R6), X3;
                });
              });
            });
            var k2 = function R6(B3) {
              var G3 = A2.get(B3) || /* @__PURE__ */ new Set();
              G3.forEach(function(Z3) {
                if (!b6.has(Z3)) {
                  b6.add(Z3);
                  var X3 = Z3.getNamePath();
                  Z3.isFieldDirty() && X3.length && (S2.push(X3), R6(X3));
                }
              });
            };
            return k2(g5), S2;
          }, this.triggerOnFieldsChange = function(g5, b6) {
            var S2 = r5.callbacks.onFieldsChange;
            if (S2) {
              var A2 = r5.getFields();
              if (b6) {
                var k2 = new Tft();
                b6.forEach(function(B3) {
                  var G3 = B3.name, Z3 = B3.errors;
                  k2.set(G3, Z3);
                }), A2.forEach(function(B3) {
                  B3.errors = k2.get(B3.name) || B3.errors;
                });
              }
              var R6 = A2.filter(function(B3) {
                var G3 = B3.name;
                return Cft(g5, G3);
              });
              S2(R6, A2);
            }
          }, this.validateFields = function(g5, b6) {
            r5.warningUnhooked();
            var S2 = !!g5, A2 = S2 ? g5.map(Km) : [], k2 = [];
            r5.getFieldEntities(true).forEach(function(G3) {
              if (S2 || A2.push(G3.getNamePath()), (b6 == null ? void 0 : b6.recursive) && S2) {
                var Z3 = G3.getNamePath();
                Z3.every(function(it, pt) {
                  return g5[pt] === it || g5[pt] === void 0;
                }) && A2.push(Z3);
              }
              if (!(!G3.props.rules || !G3.props.rules.length)) {
                var X3 = G3.getNamePath();
                if (!S2 || Cft(A2, X3)) {
                  var tt = G3.validateRules(xf2({ validateMessages: xf2(xf2({}, g4e), r5.validateMessages) }, b6));
                  k2.push(tt.then(function() {
                    return { name: X3, errors: [], warnings: [] };
                  }).catch(function(it) {
                    var pt = [], mt = [];
                    return it.forEach(function(Mt) {
                      var kt = Mt.rule.warningOnly, Gt = Mt.errors;
                      kt ? mt.push.apply(mt, Wp(Gt)) : pt.push.apply(pt, Wp(Gt));
                    }), pt.length ? Promise.reject({ name: X3, errors: pt, warnings: mt }) : { name: X3, errors: pt, warnings: mt };
                  }));
                }
              }
            });
            var R6 = Jtr(k2);
            r5.lastValidatePromise = R6, R6.catch(function(G3) {
              return G3;
            }).then(function(G3) {
              var Z3 = G3.map(function(X3) {
                var tt = X3.name;
                return tt;
              });
              r5.notifyObservers(r5.store, Z3, { type: "validateFinish" }), r5.triggerOnFieldsChange(Z3, G3);
            });
            var B3 = R6.then(function() {
              return r5.lastValidatePromise === R6 ? Promise.resolve(r5.getFieldsValue(A2)) : Promise.reject([]);
            }).catch(function(G3) {
              var Z3 = G3.filter(function(X3) {
                return X3 && X3.errors.length;
              });
              return Promise.reject({ values: r5.getFieldsValue(A2), errorFields: Z3, outOfDate: r5.lastValidatePromise !== R6 });
            });
            return B3.catch(function(G3) {
              return G3;
            }), B3;
          }, this.submit = function() {
            r5.warningUnhooked(), r5.validateFields().then(function(g5) {
              var b6 = r5.callbacks.onFinish;
              if (b6)
                try {
                  b6(g5);
                } catch (S2) {
                  console.error(S2);
                }
            }).catch(function(g5) {
              var b6 = r5.callbacks.onFinishFailed;
              b6 && b6(g5);
            });
          }, this.forceRootUpdate = s;
        });
        function T4e(c5) {
          var s = K.useRef(), r5 = K.useState({}), g5 = sD(r5, 2), b6 = g5[1];
          if (!s.current)
            if (c5)
              s.current = c5;
            else {
              var S2 = function() {
                b6({});
              }, A2 = new eer(S2);
              s.current = A2.getForm();
            }
          return [s.current];
        }
        var mZt = K.createContext({ triggerFormChange: function() {
        }, triggerFormFinish: function() {
        }, registerForm: function() {
        }, unregisterForm: function() {
        } }), ner = function(c5) {
          var s = c5.validateMessages, r5 = c5.onFormChange, g5 = c5.onFormFinish, b6 = c5.children, S2 = K.useContext(mZt), A2 = K.useRef({});
          return K.createElement(mZt.Provider, { value: xf2(xf2({}, S2), {}, { validateMessages: xf2(xf2({}, S2.validateMessages), s), triggerFormChange: function(k2, R6) {
            r5 && r5(k2, { changedFields: R6, forms: A2.current }), S2.triggerFormChange(k2, R6);
          }, triggerFormFinish: function(k2, R6) {
            g5 && g5(k2, { values: R6, forms: A2.current }), S2.triggerFormFinish(k2, R6);
          }, registerForm: function(k2, R6) {
            k2 && (A2.current = xf2(xf2({}, A2.current), {}, Qd2({}, k2, R6))), S2.registerForm(k2, R6);
          }, unregisterForm: function(k2) {
            var R6 = xf2({}, A2.current);
            delete R6[k2], A2.current = R6, S2.unregisterForm(k2);
          } }) }, b6);
        }, rer = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], ier = function(c5, s) {
          var r5 = c5.name, g5 = c5.initialValues, b6 = c5.fields, S2 = c5.form, A2 = c5.preserve, k2 = c5.children, R6 = c5.component, B3 = R6 === void 0 ? "form" : R6, G3 = c5.validateMessages, Z3 = c5.validateTrigger, X3 = Z3 === void 0 ? "onChange" : Z3, tt = c5.onValuesChange, it = c5.onFieldsChange, pt = c5.onFinish, mt = c5.onFinishFailed, Mt = WX(c5, rer), kt = K.useContext(mZt), Gt = T4e(S2), Ot = sD(Gt, 1), ce2 = Ot[0], ae2 = ce2.getInternalHooks(HX), de2 = ae2.useSubscribe, we2 = ae2.setInitialValues, Se2 = ae2.setCallbacks, Oe2 = ae2.setValidateMessages, je2 = ae2.setPreserve;
          K.useImperativeHandle(s, function() {
            return ce2;
          }), K.useEffect(function() {
            return kt.registerForm(r5, ce2), function() {
              kt.unregisterForm(r5);
            };
          }, [kt, ce2, r5]), Oe2(xf2(xf2({}, kt.validateMessages), G3)), Se2({ onValuesChange: tt, onFieldsChange: function(rr) {
            if (kt.triggerFormChange(r5, rr), it) {
              for (var Ar = arguments.length, fi2 = new Array(Ar > 1 ? Ar - 1 : 0), mi2 = 1; mi2 < Ar; mi2++)
                fi2[mi2 - 1] = arguments[mi2];
              it.apply(void 0, [rr].concat(fi2));
            }
          }, onFinish: function(rr) {
            kt.triggerFormFinish(r5, rr), pt && pt(rr);
          }, onFinishFailed: mt }), je2(A2);
          var rn = K.useRef(null);
          we2(g5, !rn.current), rn.current || (rn.current = true);
          var qe2 = k2, An = typeof k2 == "function";
          if (An) {
            var jn = ce2.getFieldsValue(true);
            qe2 = k2(jn, ce2);
          }
          de2(!An);
          var _n = K.useRef();
          K.useEffect(function() {
            Gtr(_n.current || [], b6 || []) || ce2.setFields(b6 || []), _n.current = b6;
          }, [b6, ce2]);
          var Jr = K.useMemo(function() {
            return xf2(xf2({}, ce2), {}, { validateTrigger: X3 });
          }, [ce2, X3]), Qn = K.createElement(_ft.Provider, { value: Jr }, qe2);
          return B3 === false ? Qn : K.createElement(B3, Ym({}, Mt, { onSubmit: function(rr) {
            rr.preventDefault(), rr.stopPropagation(), ce2.submit();
          }, onReset: function(rr) {
            var Ar;
            rr.preventDefault(), ce2.resetFields(), (Ar = Mt.onReset) === null || Ar === void 0 || Ar.call(Mt, rr);
          } }), Qn);
        }, aer = K.forwardRef(ier), uTt = aer;
        uTt.FormProvider = ner, uTt.Field = M4e, uTt.List = Qtr, uTt.useForm = T4e;
        var oer = function(c5, s, r5) {
          V32(c5, "[antd: ".concat(s, "] ").concat(r5));
        }, ser = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, ler = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, uer = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, A4e = uer, cer = { lang: Ym({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, ler), timePickerLocale: Ym({}, A4e) }, I4e = cer, cT = "${label} is not a valid ${type}", fer = { locale: "en", Pagination: ser, DatePicker: I4e, TimePicker: A4e, Calendar: I4e, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: cT, method: cT, array: cT, object: cT, number: cT, date: cT, boolean: cT, integer: cT, float: cT, regexp: cT, email: cT, url: cT, hex: cT }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, D4e = fer, her = O2.createContext(void 0), per = her, bZt = function(c5) {
          Kqt(r5, c5);
          var s = Qqt(r5);
          function r5() {
            return mft(this, r5), s.apply(this, arguments);
          }
          return bft(r5, [{ key: "getLocale", value: function() {
            var g5 = this.props, b6 = g5.componentName, S2 = g5.defaultLocale, A2 = S2 || D4e[b6 != null ? b6 : "global"], k2 = this.context, R6 = b6 && k2 ? k2[b6] : {};
            return Ym(Ym({}, A2 instanceof Function ? A2() : A2), R6 || {});
          } }, { key: "getLocaleCode", value: function() {
            var g5 = this.context, b6 = g5 && g5.locale;
            return g5 && g5.exist && !b6 ? D4e.locale : b6;
          } }, { key: "render", value: function() {
            return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
          } }]), r5;
        }(K.Component);
        bZt.defaultProps = { componentName: "global" }, bZt.contextType = per;
        var der = function() {
          var c5 = K.useContext(y9), s = c5.getPrefixCls, r5 = s("empty-img-default");
          return K.createElement("svg", { className: r5, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, K.createElement("g", { fill: "none", fillRule: "evenodd" }, K.createElement("g", { transform: "translate(24 31.67)" }, K.createElement("ellipse", { className: "".concat(r5, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), K.createElement("path", { className: "".concat(r5, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), K.createElement("path", { className: "".concat(r5, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), K.createElement("path", { className: "".concat(r5, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), K.createElement("path", { className: "".concat(r5, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), K.createElement("path", { className: "".concat(r5, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), K.createElement("g", { className: "".concat(r5, "-g"), transform: "translate(149.65 15.383)" }, K.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), K.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
        }, ger = der, ver = function() {
          var c5 = K.useContext(y9), s = c5.getPrefixCls, r5 = s("empty-img-simple");
          return K.createElement("svg", { className: r5, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, K.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, K.createElement("ellipse", { className: "".concat(r5, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), K.createElement("g", { className: "".concat(r5, "-g"), fillRule: "nonzero" }, K.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), K.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(r5, "-path") }))));
        }, yer = ver, mer = globalThis && globalThis.__rest || function(c5, s) {
          var r5 = {};
          for (var g5 in c5)
            Object.prototype.hasOwnProperty.call(c5, g5) && s.indexOf(g5) < 0 && (r5[g5] = c5[g5]);
          if (c5 != null && typeof Object.getOwnPropertySymbols == "function")
            for (var b6 = 0, g5 = Object.getOwnPropertySymbols(c5); b6 < g5.length; b6++)
              s.indexOf(g5[b6]) < 0 && Object.prototype.propertyIsEnumerable.call(c5, g5[b6]) && (r5[g5[b6]] = c5[g5[b6]]);
          return r5;
        }, E4e = K.createElement(ger, null), k4e = K.createElement(yer, null), _Zt = function(c5) {
          var s = c5.className, r5 = c5.prefixCls, g5 = c5.image, b6 = g5 === void 0 ? E4e : g5, S2 = c5.description, A2 = c5.children, k2 = c5.imageStyle, R6 = mer(c5, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), B3 = K.useContext(y9), G3 = B3.getPrefixCls, Z3 = B3.direction;
          return K.createElement(bZt, { componentName: "Empty" }, function(X3) {
            var tt, it = G3("empty", r5), pt = typeof S2 != "undefined" ? S2 : X3.description, mt = typeof pt == "string" ? pt : "empty", Mt = null;
            return typeof b6 == "string" ? Mt = K.createElement("img", { alt: mt, src: b6 }) : Mt = b6, K.createElement("div", Ym({ className: GX(it, (tt = {}, Qd2(tt, "".concat(it, "-normal"), b6 === k4e), Qd2(tt, "".concat(it, "-rtl"), Z3 === "rtl"), tt), s) }, R6), K.createElement("div", { className: "".concat(it, "-image"), style: k2 }, Mt), pt && K.createElement("div", { className: "".concat(it, "-description") }, pt), A2 && K.createElement("div", { className: "".concat(it, "-footer") }, A2));
          });
        };
        _Zt.PRESENTED_IMAGE_DEFAULT = E4e, _Zt.PRESENTED_IMAGE_SIMPLE = k4e;
        var Aft = _Zt, ber = function(c5) {
          return K.createElement(P4e, null, function(s) {
            var r5 = s.getPrefixCls, g5 = r5("empty");
            switch (c5) {
              case "Table":
              case "List":
                return K.createElement(Aft, { image: Aft.PRESENTED_IMAGE_SIMPLE });
              case "Select":
              case "TreeSelect":
              case "Cascader":
              case "Transfer":
              case "Mentions":
                return K.createElement(Aft, { image: Aft.PRESENTED_IMAGE_SIMPLE, className: "".concat(g5, "-small") });
              default:
                return K.createElement(Aft, null);
            }
          });
        }, _er = ber, xer = function(c5, s) {
          return s || (c5 ? "ant-".concat(c5) : "ant");
        }, y9 = K.createContext({ getPrefixCls: xer, renderEmpty: _er }), P4e = y9.Consumer, wer = K.createContext(void 0), Ser = wer, L4e = function(c5) {
          return +setTimeout(c5, 16);
        }, O4e = function(c5) {
          return clearTimeout(c5);
        };
        typeof window != "undefined" && "requestAnimationFrame" in window && (L4e = function(c5) {
          return window.requestAnimationFrame(c5);
        }, O4e = function(c5) {
          return window.cancelAnimationFrame(c5);
        });
        var R4e = 0, xZt = /* @__PURE__ */ new Map();
        function N4e(c5) {
          xZt.delete(c5);
        }
        function cTt(c5) {
          var s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
          R4e += 1;
          var r5 = R4e;
          function g5(b6) {
            if (b6 === 0)
              N4e(r5), c5();
            else {
              var S2 = L4e(function() {
                g5(b6 - 1);
              });
              xZt.set(r5, S2);
            }
          }
          return g5(s), r5;
        }
        cTt.cancel = function(c5) {
          var s = xZt.get(c5);
          return N4e(s), O4e(s);
        };
        function Mer(c5, s) {
          var r5 = s || {}, g5 = r5.defaultValue, b6 = r5.value, S2 = r5.onChange, A2 = r5.postState, k2 = K.useState(function() {
            return b6 !== void 0 ? b6 : g5 !== void 0 ? typeof g5 == "function" ? g5() : g5 : typeof c5 == "function" ? c5() : c5;
          }), R6 = sD(k2, 2), B3 = R6[0], G3 = R6[1], Z3 = b6 !== void 0 ? b6 : B3;
          A2 && (Z3 = A2(Z3));
          var X3 = K.useRef(S2);
          X3.current = S2;
          var tt = K.useCallback(function(pt) {
            G3(pt), Z3 !== pt && X3.current && X3.current(pt, Z3);
          }, [Z3, X3]), it = K.useRef(true);
          return K.useEffect(function() {
            if (it.current) {
              it.current = false;
              return;
            }
            b6 === void 0 && G3(b6);
          }, [b6]), [Z3, tt];
        }
        var Ac2 = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(c5) {
          var s = c5.keyCode;
          if (c5.altKey && !c5.ctrlKey || c5.metaKey || s >= Ac2.F1 && s <= Ac2.F12)
            return false;
          switch (s) {
            case Ac2.ALT:
            case Ac2.CAPS_LOCK:
            case Ac2.CONTEXT_MENU:
            case Ac2.CTRL:
            case Ac2.DOWN:
            case Ac2.END:
            case Ac2.ESC:
            case Ac2.HOME:
            case Ac2.INSERT:
            case Ac2.LEFT:
            case Ac2.MAC_FF_META:
            case Ac2.META:
            case Ac2.NUMLOCK:
            case Ac2.NUM_CENTER:
            case Ac2.PAGE_DOWN:
            case Ac2.PAGE_UP:
            case Ac2.PAUSE:
            case Ac2.PRINT_SCREEN:
            case Ac2.RIGHT:
            case Ac2.SHIFT:
            case Ac2.UP:
            case Ac2.WIN_KEY:
            case Ac2.WIN_KEY_RIGHT:
              return false;
            default:
              return true;
          }
        }, isCharacterKey: function(c5) {
          if (c5 >= Ac2.ZERO && c5 <= Ac2.NINE || c5 >= Ac2.NUM_ZERO && c5 <= Ac2.NUM_MULTIPLY || c5 >= Ac2.A && c5 <= Ac2.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && c5 === 0)
            return true;
          switch (c5) {
            case Ac2.SPACE:
            case Ac2.QUESTION_MARK:
            case Ac2.NUM_PLUS:
            case Ac2.NUM_MINUS:
            case Ac2.NUM_PERIOD:
            case Ac2.NUM_DIVISION:
            case Ac2.SEMICOLON:
            case Ac2.DASH:
            case Ac2.EQUALS:
            case Ac2.COMMA:
            case Ac2.PERIOD:
            case Ac2.SLASH:
            case Ac2.APOSTROPHE:
            case Ac2.SINGLE_QUOTE:
            case Ac2.OPEN_SQUARE_BRACKET:
            case Ac2.BACKSLASH:
            case Ac2.CLOSE_SQUARE_BRACKET:
              return true;
            default:
              return false;
          }
        } }, F4e = function() {
          for (var c5 = arguments.length, s = new Array(c5), r5 = 0; r5 < c5; r5++)
            s[r5] = arguments[r5];
          return s;
        }, Cer = K.isValidElement;
        function Ter(c5, s, r5) {
          return Cer(c5) ? K.cloneElement(c5, typeof r5 == "function" ? r5(c5.props || {}) : r5) : s;
        }
        function Aer(c5, s) {
          return Ter(c5, c5, s);
        }
        var V4e = ["xxl", "xl", "lg", "md", "sm", "xs"], fTt = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, VW = /* @__PURE__ */ new Map(), wZt = -1, hTt = {}, Ier = { matchHandlers: {}, dispatch: function(c5) {
          return hTt = c5, VW.forEach(function(s) {
            return s(hTt);
          }), VW.size >= 1;
        }, subscribe: function(c5) {
          return VW.size || this.register(), wZt += 1, VW.set(wZt, c5), c5(hTt), wZt;
        }, unsubscribe: function(c5) {
          VW.delete(c5), VW.size || this.unregister();
        }, unregister: function() {
          var c5 = this;
          Object.keys(fTt).forEach(function(s) {
            var r5 = fTt[s], g5 = c5.matchHandlers[r5];
            g5 == null || g5.mql.removeListener(g5 == null ? void 0 : g5.listener);
          }), VW.clear();
        }, register: function() {
          var c5 = this;
          Object.keys(fTt).forEach(function(s) {
            var r5 = fTt[s], g5 = function(S2) {
              var A2 = S2.matches;
              c5.dispatch(Ym(Ym({}, hTt), Qd2({}, s, A2)));
            }, b6 = window.matchMedia(r5);
            b6.addListener(g5), c5.matchHandlers[r5] = { mql: b6, listener: g5 }, g5(b6);
          });
        } }, B4e = Ier, Der = 0, ZX = {};
        function pTt(c5) {
          var s = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, r5 = Der++, g5 = s;
          function b6() {
            g5 -= 1, g5 <= 0 ? (c5(), delete ZX[r5]) : ZX[r5] = cTt(b6);
          }
          return ZX[r5] = cTt(b6), r5;
        }
        pTt.cancel = function(c5) {
          c5 !== void 0 && (cTt.cancel(ZX[c5]), delete ZX[c5]);
        }, pTt.ids = ZX;
        var SZt;
        function z4e(c5) {
          return !c5 || c5.offsetParent === null || c5.hidden;
        }
        function Eer(c5) {
          var s = (c5 || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
          return s && s[1] && s[2] && s[3] ? !(s[1] === s[2] && s[2] === s[3]) : true;
        }
        var j4e = function(c5) {
          Kqt(r5, c5);
          var s = Qqt(r5);
          function r5() {
            var g5;
            return mft(this, r5), g5 = s.apply(this, arguments), g5.containerRef = K.createRef(), g5.animationStart = false, g5.destroyed = false, g5.onClick = function(b6, S2) {
              var A2, k2, R6 = g5.props, B3 = R6.insertExtraNode, G3 = R6.disabled;
              if (!(G3 || !b6 || z4e(b6) || b6.className.indexOf("-leave") >= 0)) {
                g5.extraNode = document.createElement("div");
                var Z3 = Xqt(g5), X3 = Z3.extraNode, tt = g5.context.getPrefixCls;
                X3.className = "".concat(tt(""), "-click-animating-node");
                var it = g5.getAttributeName();
                if (b6.setAttribute(it, "true"), S2 && S2 !== "#ffffff" && S2 !== "rgb(255, 255, 255)" && Eer(S2) && !/rgba\((?:\d*, ){3}0\)/.test(S2) && S2 !== "transparent") {
                  X3.style.borderColor = S2;
                  var pt = ((A2 = b6.getRootNode) === null || A2 === void 0 ? void 0 : A2.call(b6)) || b6.ownerDocument, mt = pt instanceof Document ? pt.body : (k2 = pt.firstChild) !== null && k2 !== void 0 ? k2 : pt;
                  SZt = QOe(`
      [`.concat(tt(""), "-click-animating-without-extra-node='true']::after, .").concat(tt(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(S2, `;
      }`), "antd-wave", { csp: g5.csp, attachTo: mt });
                }
                B3 && b6.appendChild(X3), ["transition", "animation"].forEach(function(Mt) {
                  b6.addEventListener("".concat(Mt, "start"), g5.onTransitionStart), b6.addEventListener("".concat(Mt, "end"), g5.onTransitionEnd);
                });
              }
            }, g5.onTransitionStart = function(b6) {
              if (!g5.destroyed) {
                var S2 = g5.containerRef.current;
                !b6 || b6.target !== S2 || g5.animationStart || g5.resetEffect(S2);
              }
            }, g5.onTransitionEnd = function(b6) {
              !b6 || b6.animationName !== "fadeEffect" || g5.resetEffect(b6.target);
            }, g5.bindAnimationEvent = function(b6) {
              if (!(!b6 || !b6.getAttribute || b6.getAttribute("disabled") || b6.className.indexOf("disabled") >= 0)) {
                var S2 = function(A2) {
                  if (!(A2.target.tagName === "INPUT" || z4e(A2.target))) {
                    g5.resetEffect(b6);
                    var k2 = getComputedStyle(b6).getPropertyValue("border-top-color") || getComputedStyle(b6).getPropertyValue("border-color") || getComputedStyle(b6).getPropertyValue("background-color");
                    g5.clickWaveTimeoutId = window.setTimeout(function() {
                      return g5.onClick(b6, k2);
                    }, 0), pTt.cancel(g5.animationStartId), g5.animationStart = true, g5.animationStartId = pTt(function() {
                      g5.animationStart = false;
                    }, 10);
                  }
                };
                return b6.addEventListener("click", S2, true), { cancel: function() {
                  b6.removeEventListener("click", S2, true);
                } };
              }
            }, g5.renderWave = function(b6) {
              var S2 = b6.csp, A2 = g5.props.children;
              if (g5.csp = S2, !K.isValidElement(A2))
                return A2;
              var k2 = g5.containerRef;
              return otr(A2) && (k2 = atr(A2.ref, g5.containerRef)), Aer(A2, { ref: k2 });
            }, g5;
          }
          return bft(r5, [{ key: "componentDidMount", value: function() {
            var g5 = this.containerRef.current;
            !g5 || g5.nodeType !== 1 || (this.instance = this.bindAnimationEvent(g5));
          } }, { key: "componentWillUnmount", value: function() {
            this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
          } }, { key: "getAttributeName", value: function() {
            var g5 = this.context.getPrefixCls, b6 = this.props.insertExtraNode;
            return b6 ? "".concat(g5(""), "-click-animating") : "".concat(g5(""), "-click-animating-without-extra-node");
          } }, { key: "resetEffect", value: function(g5) {
            var b6 = this;
            if (!(!g5 || g5 === this.extraNode || !(g5 instanceof Element))) {
              var S2 = this.props.insertExtraNode, A2 = this.getAttributeName();
              g5.setAttribute(A2, "false"), SZt && (SZt.innerHTML = ""), S2 && this.extraNode && g5.contains(this.extraNode) && g5.removeChild(this.extraNode), ["transition", "animation"].forEach(function(k2) {
                g5.removeEventListener("".concat(k2, "start"), b6.onTransitionStart), g5.removeEventListener("".concat(k2, "end"), b6.onTransitionEnd);
              });
            }
          } }, { key: "render", value: function() {
            return K.createElement(P4e, null, this.renderWave);
          } }]), r5;
        }(K.Component);
        j4e.contextType = y9;
        var MZt = { exports: {} }, Ift = {};
        /** @license React v17.0.2
        * react-jsx-runtime.production.min.js
        *
        * Copyright (c) Facebook, Inc. and its affiliates.
        *
        * This source code is licensed under the MIT license found in the
        * LICENSE file in the root directory of this source tree.
        */
        var ker = q3.default, W4e = 60103;
        if (Ift.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
          var G4e = Symbol.for;
          W4e = G4e("react.element"), Ift.Fragment = G4e("react.fragment");
        }
        var Per = ker.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, Ler = Object.prototype.hasOwnProperty, Oer = { key: true, ref: true, __self: true, __source: true };
        function H4e(c5, s, r5) {
          var g5, b6 = {}, S2 = null, A2 = null;
          r5 !== void 0 && (S2 = "" + r5), s.key !== void 0 && (S2 = "" + s.key), s.ref !== void 0 && (A2 = s.ref);
          for (g5 in s)
            Ler.call(s, g5) && !Oer.hasOwnProperty(g5) && (b6[g5] = s[g5]);
          if (c5 && c5.defaultProps)
            for (g5 in s = c5.defaultProps, s)
              b6[g5] === void 0 && (b6[g5] = s[g5]);
          return { $$typeof: W4e, type: c5, key: S2, ref: A2, props: b6, _owner: Per.current };
        }
        Ift.jsx = H4e, Ift.jsxs = H4e, MZt.exports = Ift;
        const $X = MZt.exports.jsx, Rer = MZt.exports.jsxs;
        var Ner = O2.createContext({}), U4e = Ner, Fer = function() {
          return YOe() && window.document.documentElement;
        }, dTt, Ver = function() {
          if (!Fer())
            return false;
          if (dTt !== void 0)
            return dTt;
          var c5 = document.createElement("div");
          return c5.style.display = "flex", c5.style.flexDirection = "column", c5.style.rowGap = "1px", c5.appendChild(document.createElement("div")), c5.appendChild(document.createElement("div")), document.body.appendChild(c5), dTt = c5.scrollHeight === 1, document.body.removeChild(c5), dTt;
        }, Ber = function() {
          var c5 = K.useState(false), s = sD(c5, 2), r5 = s[0], g5 = s[1];
          return K.useEffect(function() {
            g5(Ver());
          }, []), r5;
        }, zer = globalThis && globalThis.__rest || function(c5, s) {
          var r5 = {};
          for (var g5 in c5)
            Object.prototype.hasOwnProperty.call(c5, g5) && s.indexOf(g5) < 0 && (r5[g5] = c5[g5]);
          if (c5 != null && typeof Object.getOwnPropertySymbols == "function")
            for (var b6 = 0, g5 = Object.getOwnPropertySymbols(c5); b6 < g5.length; b6++)
              s.indexOf(g5[b6]) < 0 && Object.prototype.propertyIsEnumerable.call(c5, g5[b6]) && (r5[g5[b6]] = c5[g5[b6]]);
          return r5;
        };
        F4e("top", "middle", "bottom", "stretch"), F4e("start", "end", "center", "space-around", "space-between");
        var q4e = K.forwardRef(function(c5, s) {
          var r5, g5 = c5.prefixCls, b6 = c5.justify, S2 = c5.align, A2 = c5.className, k2 = c5.style, R6 = c5.children, B3 = c5.gutter, G3 = B3 === void 0 ? 0 : B3, Z3 = c5.wrap, X3 = zer(c5, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), tt = K.useContext(y9), it = tt.getPrefixCls, pt = tt.direction, mt = K.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), Mt = sD(mt, 2), kt = Mt[0], Gt = Mt[1], Ot = Ber(), ce2 = K.useRef(G3);
          K.useEffect(function() {
            var Qn = B4e.subscribe(function(rr) {
              var Ar = ce2.current || 0;
              (!Array.isArray(Ar) && Yw(Ar) === "object" || Array.isArray(Ar) && (Yw(Ar[0]) === "object" || Yw(Ar[1]) === "object")) && Gt(rr);
            });
            return function() {
              return B4e.unsubscribe(Qn);
            };
          }, []);
          var ae2 = function() {
            var Qn = [0, 0], rr = Array.isArray(G3) ? G3 : [G3, 0];
            return rr.forEach(function(Ar, fi2) {
              if (Yw(Ar) === "object")
                for (var mi2 = 0; mi2 < V4e.length; mi2++) {
                  var Oo = V4e[mi2];
                  if (kt[Oo] && Ar[Oo] !== void 0) {
                    Qn[fi2] = Ar[Oo];
                    break;
                  }
                }
              else
                Qn[fi2] = Ar || 0;
            }), Qn;
          }, de2 = it("row", g5), we2 = ae2(), Se2 = GX(de2, (r5 = {}, Qd2(r5, "".concat(de2, "-no-wrap"), Z3 === false), Qd2(r5, "".concat(de2, "-").concat(b6), b6), Qd2(r5, "".concat(de2, "-").concat(S2), S2), Qd2(r5, "".concat(de2, "-rtl"), pt === "rtl"), r5), A2), Oe2 = {}, je2 = we2[0] > 0 ? we2[0] / -2 : void 0, rn = we2[1] > 0 ? we2[1] / -2 : void 0;
          if (je2 && (Oe2.marginLeft = je2, Oe2.marginRight = je2), Ot) {
            var qe2 = sD(we2, 2);
            Oe2.rowGap = qe2[1];
          } else
            rn && (Oe2.marginTop = rn, Oe2.marginBottom = rn);
          var An = sD(we2, 2), jn = An[0], _n = An[1], Jr = K.useMemo(function() {
            return { gutter: [jn, _n], wrap: Z3, supportFlexGap: Ot };
          }, [jn, _n, Z3, Ot]);
          return K.createElement(U4e.Provider, { value: Jr }, K.createElement("div", Ym({}, X3, { className: Se2, style: Ym(Ym({}, Oe2), k2), ref: s }), R6));
        });
        q4e.displayName = "Row";
        var jer = q4e, Wer = globalThis && globalThis.__rest || function(c5, s) {
          var r5 = {};
          for (var g5 in c5)
            Object.prototype.hasOwnProperty.call(c5, g5) && s.indexOf(g5) < 0 && (r5[g5] = c5[g5]);
          if (c5 != null && typeof Object.getOwnPropertySymbols == "function")
            for (var b6 = 0, g5 = Object.getOwnPropertySymbols(c5); b6 < g5.length; b6++)
              s.indexOf(g5[b6]) < 0 && Object.prototype.propertyIsEnumerable.call(c5, g5[b6]) && (r5[g5[b6]] = c5[g5[b6]]);
          return r5;
        };
        function Ger(c5) {
          return typeof c5 == "number" ? "".concat(c5, " ").concat(c5, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(c5) ? "0 0 ".concat(c5) : c5;
        }
        var Her = ["xs", "sm", "md", "lg", "xl", "xxl"], Z4e = K.forwardRef(function(c5, s) {
          var r5, g5 = K.useContext(y9), b6 = g5.getPrefixCls, S2 = g5.direction, A2 = K.useContext(U4e), k2 = A2.gutter, R6 = A2.wrap, B3 = A2.supportFlexGap, G3 = c5.prefixCls, Z3 = c5.span, X3 = c5.order, tt = c5.offset, it = c5.push, pt = c5.pull, mt = c5.className, Mt = c5.children, kt = c5.flex, Gt = c5.style, Ot = Wer(c5, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), ce2 = b6("col", G3), ae2 = {};
          Her.forEach(function(je2) {
            var rn, qe2 = {}, An = c5[je2];
            typeof An == "number" ? qe2.span = An : Yw(An) === "object" && (qe2 = An || {}), delete Ot[je2], ae2 = Ym(Ym({}, ae2), (rn = {}, Qd2(rn, "".concat(ce2, "-").concat(je2, "-").concat(qe2.span), qe2.span !== void 0), Qd2(rn, "".concat(ce2, "-").concat(je2, "-order-").concat(qe2.order), qe2.order || qe2.order === 0), Qd2(rn, "".concat(ce2, "-").concat(je2, "-offset-").concat(qe2.offset), qe2.offset || qe2.offset === 0), Qd2(rn, "".concat(ce2, "-").concat(je2, "-push-").concat(qe2.push), qe2.push || qe2.push === 0), Qd2(rn, "".concat(ce2, "-").concat(je2, "-pull-").concat(qe2.pull), qe2.pull || qe2.pull === 0), Qd2(rn, "".concat(ce2, "-rtl"), S2 === "rtl"), rn));
          });
          var de2 = GX(ce2, (r5 = {}, Qd2(r5, "".concat(ce2, "-").concat(Z3), Z3 !== void 0), Qd2(r5, "".concat(ce2, "-order-").concat(X3), X3), Qd2(r5, "".concat(ce2, "-offset-").concat(tt), tt), Qd2(r5, "".concat(ce2, "-push-").concat(it), it), Qd2(r5, "".concat(ce2, "-pull-").concat(pt), pt), r5), mt, ae2), we2 = {};
          if (k2 && k2[0] > 0) {
            var Se2 = k2[0] / 2;
            we2.paddingLeft = Se2, we2.paddingRight = Se2;
          }
          if (k2 && k2[1] > 0 && !B3) {
            var Oe2 = k2[1] / 2;
            we2.paddingTop = Oe2, we2.paddingBottom = Oe2;
          }
          return kt && (we2.flex = Ger(kt), R6 === false && !we2.minWidth && (we2.minWidth = 0)), K.createElement("div", Ym({}, Ot, { style: Ym(Ym({}, we2), Gt), className: de2, ref: s }), Mt);
        });
        Z4e.displayName = "Col";
        var Uer = Z4e, $4e = K.forwardRef(function(c5, s) {
          var r5, g5 = c5.prefixCls, b6 = g5 === void 0 ? "rc-switch" : g5, S2 = c5.className, A2 = c5.checked, k2 = c5.defaultChecked, R6 = c5.disabled, B3 = c5.loadingIcon, G3 = c5.checkedChildren, Z3 = c5.unCheckedChildren, X3 = c5.onClick, tt = c5.onChange, it = c5.onKeyDown, pt = WX(c5, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), mt = Mer(false, { value: A2, defaultValue: k2 }), Mt = sD(mt, 2), kt = Mt[0], Gt = Mt[1];
          function Ot(we2, Se2) {
            var Oe2 = kt;
            return R6 || (Oe2 = we2, Gt(Oe2), tt == null || tt(Oe2, Se2)), Oe2;
          }
          function ce2(we2) {
            we2.which === Ac2.LEFT ? Ot(false, we2) : we2.which === Ac2.RIGHT && Ot(true, we2), it == null || it(we2);
          }
          function ae2(we2) {
            var Se2 = Ot(!kt, we2);
            X3 == null || X3(Se2, we2);
          }
          var de2 = GX(b6, S2, (r5 = {}, Qd2(r5, "".concat(b6, "-checked"), kt), Qd2(r5, "".concat(b6, "-disabled"), R6), r5));
          return K.createElement("button", Object.assign({}, pt, { type: "button", role: "switch", "aria-checked": kt, disabled: R6, className: de2, ref: s, onKeyDown: ce2, onClick: ae2 }), B3, K.createElement("span", { className: "".concat(b6, "-inner") }, kt ? G3 : Z3));
        });
        $4e.displayName = "Switch";
        var qer = globalThis && globalThis.__rest || function(c5, s) {
          var r5 = {};
          for (var g5 in c5)
            Object.prototype.hasOwnProperty.call(c5, g5) && s.indexOf(g5) < 0 && (r5[g5] = c5[g5]);
          if (c5 != null && typeof Object.getOwnPropertySymbols == "function")
            for (var b6 = 0, g5 = Object.getOwnPropertySymbols(c5); b6 < g5.length; b6++)
              s.indexOf(g5[b6]) < 0 && Object.prototype.propertyIsEnumerable.call(c5, g5[b6]) && (r5[g5[b6]] = c5[g5[b6]]);
          return r5;
        }, CZt = K.forwardRef(function(c5, s) {
          var r5, g5 = c5.prefixCls, b6 = c5.size, S2 = c5.loading, A2 = c5.className, k2 = A2 === void 0 ? "" : A2, R6 = c5.disabled, B3 = qer(c5, ["prefixCls", "size", "loading", "className", "disabled"]);
          oer("checked" in B3 || !("value" in B3), "Switch", "`value` is not a valid prop, do you mean `checked`?");
          var G3 = K.useContext(y9), Z3 = G3.getPrefixCls, X3 = G3.direction, tt = K.useContext(Ser), it = Z3("switch", g5), pt = K.createElement("div", { className: "".concat(it, "-handle") }, S2 && K.createElement(KJn, { className: "".concat(it, "-loading-icon") })), mt = GX((r5 = {}, Qd2(r5, "".concat(it, "-small"), (b6 || tt) === "small"), Qd2(r5, "".concat(it, "-loading"), S2), Qd2(r5, "".concat(it, "-rtl"), X3 === "rtl"), r5), k2);
          return K.createElement(j4e, { insertExtraNode: true }, K.createElement($4e, Ym({}, B3, { prefixCls: it, className: mt, disabled: R6 || S2, ref: s, loadingIcon: pt })));
        });
        CZt.__ANT_SWITCH = true, CZt.displayName = "Switch";
        var Zer = CZt, $er = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, Yer = {};
        (function(c5) {
          var s = Object.defineProperty, r5 = Object.getOwnPropertySymbols, g5 = Object.prototype.hasOwnProperty, b6 = Object.prototype.propertyIsEnumerable, S2 = (Bt, ge2, Ht) => ge2 in Bt ? s(Bt, ge2, { enumerable: true, configurable: true, writable: true, value: Ht }) : Bt[ge2] = Ht, A2 = (Bt, ge2) => {
            for (var Ht in ge2 || (ge2 = {}))
              g5.call(ge2, Ht) && S2(Bt, Ht, ge2[Ht]);
            if (r5)
              for (var Ht of r5(ge2))
                b6.call(ge2, Ht) && S2(Bt, Ht, ge2[Ht]);
            return Bt;
          }, k2 = (Bt, ge2, Ht) => (S2(Bt, typeof ge2 != "symbol" ? ge2 + "" : ge2, Ht), Ht);
          Object.defineProperties(c5, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
          var R6 = q3.default;
          function B3(Bt) {
            return Bt && typeof Bt == "object" && "default" in Bt ? Bt : { default: Bt };
          }
          function G3(Bt) {
            if (Bt && Bt.__esModule)
              return Bt;
            var ge2 = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
            return Bt && Object.keys(Bt).forEach(function(Ht) {
              if (Ht !== "default") {
                var qt = Object.getOwnPropertyDescriptor(Bt, Ht);
                Object.defineProperty(ge2, Ht, qt.get ? qt : { enumerable: true, get: function() {
                  return Bt[Ht];
                } });
              }
            }), ge2.default = Bt, Object.freeze(ge2);
          }
          var Z3 = B3(R6), X3 = G3(R6);
          class tt {
            constructor() {
              k2(this, "chartsEmitters", /* @__PURE__ */ new Map()), k2(this, "add", (ge2, Ht, qt, Zt) => {
                Ht && qt ? this.chartsEmitters.set(ge2, { chart: Ht, option: qt, title: Zt }) : console.log("\u6DFB\u52A0\u5931\u8D25");
              }), k2(this, "get", (ge2) => this.chartsEmitters.get(ge2)), k2(this, "clear", () => {
                this.chartsEmitters.clear();
              }), k2(this, "delete", (ge2) => {
                this.chartsEmitters.delete(ge2);
              }), k2(this, "list", () => {
                var ge2, Ht, qt;
                const Zt = [];
                for (const oe2 of this.chartsEmitters.keys())
                  Zt.push({ id: oe2, chart: (ge2 = this.chartsEmitters.get(oe2)) == null ? void 0 : ge2.chart, option: (Ht = this.chartsEmitters.get(oe2)) == null ? void 0 : Ht.option, title: (qt = this.chartsEmitters.get(oe2)) == null ? void 0 : qt.title });
                return Zt;
              });
            }
          }
          const it = new tt();
          var pt = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof tn != "undefined" ? tn : typeof self != "undefined" ? self : {};
          function mt(Bt) {
            return Bt && Bt.__esModule && Object.prototype.hasOwnProperty.call(Bt, "default") ? Bt.default : Bt;
          }
          var Mt = { exports: {} };
          /**
          * @license
          * Lodash <https://lodash.com/>
          * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
          * Released under MIT license <https://lodash.com/license>
          * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
          * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
          */
          (function(Bt, ge2) {
            (function() {
              var Ht, qt = "4.17.21", Zt = 200, oe2 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", Ne2 = "Expected a function", Ge2 = "Invalid `variable` option passed into `_.template`", Ve = "__lodash_hash_undefined__", pn = 500, vn = "__lodash_placeholder__", Gn = 1, Lr = 2, Wr = 4, Gr = 1, ei2 = 2, oi2 = 1, Va2 = 2, Ca2 = 4, Go = 8, un = 16, Ei2 = 32, Wi2 = 64, La2 = 128, Aa2 = 256, Oi2 = 512, Zi2 = 30, Ka2 = "...", Fo = 800, Si2 = 16, bl = 1, vl = 2, xa2 = 3, gu = 1 / 0, Na2 = 9007199254740991, ga = 17976931348623157e292, ca2 = 0 / 0, fs = 4294967295, qo = fs - 1, Hu = fs >>> 1, vh2 = [["ary", La2], ["bind", oi2], ["bindKey", Va2], ["curry", Go], ["curryRight", un], ["flip", Oi2], ["partial", Ei2], ["partialRight", Wi2], ["rearg", Aa2]], Wf2 = "[object Arguments]", mc2 = "[object Array]", yd2 = "[object AsyncFunction]", Gf2 = "[object Boolean]", hp = "[object Date]", Lg2 = "[object DOMException]", n_ = "[object Error]", Dx = "[object Function]", Iv = "[object GeneratorFunction]", Gv = "[object Map]", Jm = "[object Number]", Ex = "[object Null]", ry = "[object Object]", r_ = "[object Promise]", vu = "[object Proxy]", t1 = "[object RegExp]", Dv = "[object Set]", nv = "[object String]", Hv = "[object Symbol]", eS = "[object Undefined]", so = "[object WeakMap]", Bi2 = "[object WeakSet]", Xi2 = "[object ArrayBuffer]", co = "[object DataView]", Es = "[object Float32Array]", Zl = "[object Float64Array]", Yc2 = "[object Int8Array]", Kc2 = "[object Int16Array]", Dp = "[object Int32Array]", Og2 = "[object Uint8Array]", tp = "[object Uint8ClampedArray]", Fh2 = "[object Uint16Array]", md2 = "[object Uint32Array]", cm = /\b__p \+= '';/g, fm = /\b(__p \+=) '' \+/g, nS = /(__e\(.*?\)|\b__t\)) \+\n'';/g, K1 = /&(?:amp|lt|gt|quot|#39);/g, tg2 = /[&<>"']/g, Jf2 = RegExp(K1.source), O0 = RegExp(tg2.source), hm = /<%-([\s\S]+?)%>/g, i_ = /<%([\s\S]+?)%>/g, X1 = /<%=([\s\S]+?)%>/g, Q1 = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, a_ = /^\w*$/, mT = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, bT = /[\\^$.*+?()[\]{}|]/g, $R = RegExp(bT.source), _T = /^\s+/, Hk = /\s/, YR = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Q3 = /\{\n\/\* \[wrapped with (.+)\] \*/, O9 = /,? & /, OM = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, ir = /[()=,{}\[\]\/\s]/, Mr = /\\(\\)?/g, gn = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, sr = /\w*$/, dr = /^[-+]0x[0-9a-f]+$/i, ji2 = /^0b[01]+$/i, qa2 = /^\[object .+?Constructor\]$/, wa2 = /^0o[0-7]+$/i, li2 = /^(?:0|[1-9]\d*)$/, jo = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, Al = /($^)/, Sf2 = /['\n\r\u2028\u2029\\]/g, sf2 = "\\ud800-\\udfff", Vc2 = "\\u0300-\\u036f", zu = "\\ufe20-\\ufe2f", ad2 = "\\u20d0-\\u20ff", Rg2 = Vc2 + zu + ad2, bc2 = "\\u2700-\\u27bf", Ng2 = "a-z\\xdf-\\xf6\\xf8-\\xff", pm = "\\xac\\xb1\\xd7\\xf7", T22 = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", yD = "\\u2000-\\u206f", rS = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", Uk = "A-Z\\xc0-\\xd6\\xd8-\\xde", xT = "\\ufe0e\\ufe0f", iy = pm + T22 + yD + rS, A22 = "['\u2019]", ay = "[" + sf2 + "]", RM = "[" + iy + "]", Uv = "[" + Rg2 + "]", qk2 = "\\d+", KR = "[" + bc2 + "]", kx = "[" + Ng2 + "]", wT = "[^" + sf2 + iy + qk2 + bc2 + Ng2 + Uk + "]", ST = "\\ud83c[\\udffb-\\udfff]", Ly = "(?:" + Uv + "|" + ST + ")", XR = "[^" + sf2 + "]", I22 = "(?:\\ud83c[\\udde6-\\uddff]){2}", mD = "[\\ud800-\\udbff][\\udc00-\\udfff]", Zk = "[" + Uk + "]", EQ = "\\u200d", kQ = "(?:" + kx + "|" + wT + ")", vht = "(?:" + Zk + "|" + wT + ")", pG = "(?:" + A22 + "(?:d|ll|m|re|s|t|ve))?", dG = "(?:" + A22 + "(?:D|LL|M|RE|S|T|VE))?", PQ = Ly + "?", gG = "[" + xT + "]?", R9 = "(?:" + EQ + "(?:" + [XR, I22, mD].join("|") + ")" + gG + PQ + ")*", yht = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", LQ = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", vG = gG + PQ + R9, OQ = "(?:" + [KR, I22, mD].join("|") + ")" + vG, yG = "(?:" + [XR + Uv + "?", Uv, I22, mD, ay].join("|") + ")", mG = RegExp(A22, "g"), e1 = RegExp(Uv, "g"), QR = RegExp(ST + "(?=" + ST + ")|" + yG + vG, "g"), RQ = RegExp([Zk + "?" + kx + "+" + pG + "(?=" + [RM, Zk, "$"].join("|") + ")", vht + "+" + dG + "(?=" + [RM, Zk + kQ, "$"].join("|") + ")", Zk + "?" + kQ + "+" + pG, Zk + "+" + dG, LQ, yht, qk2, OQ].join("|"), "g"), mht = RegExp("[" + EQ + sf2 + Rg2 + xT + "]"), bht = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, iS = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], bG = -1, Fg2 = {};
              Fg2[Es] = Fg2[Zl] = Fg2[Yc2] = Fg2[Kc2] = Fg2[Dp] = Fg2[Og2] = Fg2[tp] = Fg2[Fh2] = Fg2[md2] = true, Fg2[Wf2] = Fg2[mc2] = Fg2[Xi2] = Fg2[Gf2] = Fg2[co] = Fg2[hp] = Fg2[n_] = Fg2[Dx] = Fg2[Gv] = Fg2[Jm] = Fg2[ry] = Fg2[t1] = Fg2[Dv] = Fg2[nv] = Fg2[so] = false;
              var jd2 = {};
              jd2[Wf2] = jd2[mc2] = jd2[Xi2] = jd2[co] = jd2[Gf2] = jd2[hp] = jd2[Es] = jd2[Zl] = jd2[Yc2] = jd2[Kc2] = jd2[Dp] = jd2[Gv] = jd2[Jm] = jd2[ry] = jd2[t1] = jd2[Dv] = jd2[nv] = jd2[Hv] = jd2[Og2] = jd2[tp] = jd2[Fh2] = jd2[md2] = true, jd2[n_] = jd2[Dx] = jd2[so] = false;
              var _G = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, NQ = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, xG = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, _ht = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, FQ = parseFloat, xht = parseInt, N9 = typeof pt == "object" && pt && pt.Object === Object && pt, VQ = typeof self == "object" && self && self.Object === Object && self, qv = N9 || VQ || Function("return this")(), F9 = ge2 && !ge2.nodeType && ge2, bD = F9 && true && Bt && !Bt.nodeType && Bt, BQ = bD && bD.exports === F9, wG = BQ && N9.process, aS = function() {
                try {
                  var ri2 = bD && bD.require && bD.require("util").types;
                  return ri2 || wG && wG.binding && wG.binding("util");
                } catch {
                }
              }(), J3 = aS && aS.isArrayBuffer, zQ = aS && aS.isDate, jQ = aS && aS.isMap, JR = aS && aS.isRegExp, V9 = aS && aS.isSet, SG = aS && aS.isTypedArray;
              function Px(ri2, va, ya2) {
                switch (ya2.length) {
                  case 0:
                    return ri2.call(va);
                  case 1:
                    return ri2.call(va, ya2[0]);
                  case 2:
                    return ri2.call(va, ya2[0], ya2[1]);
                  case 3:
                    return ri2.call(va, ya2[0], ya2[1], ya2[2]);
                }
                return ri2.apply(va, ya2);
              }
              function wht(ri2, va, ya2, Zs) {
                for (var Gc2 = -1, pp = ri2 == null ? 0 : ri2.length; ++Gc2 < pp; ) {
                  var ly = ri2[Gc2];
                  va(Zs, ly, ya2(ly), ri2);
                }
                return Zs;
              }
              function J1(ri2, va) {
                for (var ya2 = -1, Zs = ri2 == null ? 0 : ri2.length; ++ya2 < Zs && va(ri2[ya2], ya2, ri2) !== false; )
                  ;
                return ri2;
              }
              function Sht(ri2, va) {
                for (var ya2 = ri2 == null ? 0 : ri2.length; ya2-- && va(ri2[ya2], ya2, ri2) !== false; )
                  ;
                return ri2;
              }
              function WQ(ri2, va) {
                for (var ya2 = -1, Zs = ri2 == null ? 0 : ri2.length; ++ya2 < Zs; )
                  if (!va(ri2[ya2], ya2, ri2))
                    return false;
                return true;
              }
              function MT(ri2, va) {
                for (var ya2 = -1, Zs = ri2 == null ? 0 : ri2.length, Gc2 = 0, pp = []; ++ya2 < Zs; ) {
                  var ly = ri2[ya2];
                  va(ly, ya2, ri2) && (pp[Gc2++] = ly);
                }
                return pp;
              }
              function tL(ri2, va) {
                var ya2 = ri2 == null ? 0 : ri2.length;
                return !!ya2 && xD(ri2, va, 0) > -1;
              }
              function MG(ri2, va, ya2) {
                for (var Zs = -1, Gc2 = ri2 == null ? 0 : ri2.length; ++Zs < Gc2; )
                  if (ya2(va, ri2[Zs]))
                    return true;
                return false;
              }
              function Xc2(ri2, va) {
                for (var ya2 = -1, Zs = ri2 == null ? 0 : ri2.length, Gc2 = Array(Zs); ++ya2 < Zs; )
                  Gc2[ya2] = va(ri2[ya2], ya2, ri2);
                return Gc2;
              }
              function oS(ri2, va) {
                for (var ya2 = -1, Zs = va.length, Gc2 = ri2.length; ++ya2 < Zs; )
                  ri2[Gc2 + ya2] = va[ya2];
                return ri2;
              }
              function B9(ri2, va, ya2, Zs) {
                var Gc2 = -1, pp = ri2 == null ? 0 : ri2.length;
                for (Zs && pp && (ya2 = ri2[++Gc2]); ++Gc2 < pp; )
                  ya2 = va(ya2, ri2[Gc2], Gc2, ri2);
                return ya2;
              }
              function _D(ri2, va, ya2, Zs) {
                var Gc2 = ri2 == null ? 0 : ri2.length;
                for (Zs && Gc2 && (ya2 = ri2[--Gc2]); Gc2--; )
                  ya2 = va(ya2, ri2[Gc2], Gc2, ri2);
                return ya2;
              }
              function t6(ri2, va) {
                for (var ya2 = -1, Zs = ri2 == null ? 0 : ri2.length; ++ya2 < Zs; )
                  if (va(ri2[ya2], ya2, ri2))
                    return true;
                return false;
              }
              var CG = e6("length");
              function z9(ri2) {
                return ri2.split("");
              }
              function Mht(ri2) {
                return ri2.match(OM) || [];
              }
              function j9(ri2, va, ya2) {
                var Zs;
                return ya2(ri2, function(Gc2, pp, ly) {
                  if (va(Gc2, pp, ly))
                    return Zs = pp, false;
                }), Zs;
              }
              function W9(ri2, va, ya2, Zs) {
                for (var Gc2 = ri2.length, pp = ya2 + (Zs ? 1 : -1); Zs ? pp-- : ++pp < Gc2; )
                  if (va(ri2[pp], pp, ri2))
                    return pp;
                return -1;
              }
              function xD(ri2, va, ya2) {
                return va === va ? qQ(ri2, va, ya2) : W9(ri2, od2, ya2);
              }
              function TG(ri2, va, ya2, Zs) {
                for (var Gc2 = ya2 - 1, pp = ri2.length; ++Gc2 < pp; )
                  if (Zs(ri2[Gc2], va))
                    return Gc2;
                return -1;
              }
              function od2(ri2) {
                return ri2 !== ri2;
              }
              function oy(ri2, va) {
                var ya2 = ri2 == null ? 0 : ri2.length;
                return ya2 ? $k(ri2, va) / ya2 : ca2;
              }
              function e6(ri2) {
                return function(va) {
                  return va == null ? Ht : va[ri2];
                };
              }
              function wD(ri2) {
                return function(va) {
                  return ri2 == null ? Ht : ri2[va];
                };
              }
              function n6(ri2, va, ya2, Zs, Gc2) {
                return Gc2(ri2, function(pp, ly, bd2) {
                  ya2 = Zs ? (Zs = false, pp) : va(ya2, pp, ly, bd2);
                }), ya2;
              }
              function r6(ri2, va) {
                var ya2 = ri2.length;
                for (ri2.sort(va); ya2--; )
                  ri2[ya2] = ri2[ya2].value;
                return ri2;
              }
              function $k(ri2, va) {
                for (var ya2, Zs = -1, Gc2 = ri2.length; ++Zs < Gc2; ) {
                  var pp = va(ri2[Zs]);
                  pp !== Ht && (ya2 = ya2 === Ht ? pp : ya2 + pp);
                }
                return ya2;
              }
              function SD(ri2, va) {
                for (var ya2 = -1, Zs = Array(ri2); ++ya2 < ri2; )
                  Zs[ya2] = va(ya2);
                return Zs;
              }
              function i6(ri2, va) {
                return Xc2(va, function(ya2) {
                  return [ya2, ri2[ya2]];
                });
              }
              function a6(ri2) {
                return ri2 && ri2.slice(0, eg2(ri2) + 1).replace(_T, "");
              }
              function dm(ri2) {
                return function(va) {
                  return ri2(va);
                };
              }
              function Yk(ri2, va) {
                return Xc2(va, function(ya2) {
                  return ri2[ya2];
                });
              }
              function MD(ri2, va) {
                return ri2.has(va);
              }
              function GQ(ri2, va) {
                for (var ya2 = -1, Zs = ri2.length; ++ya2 < Zs && xD(va, ri2[ya2], 0) > -1; )
                  ;
                return ya2;
              }
              function o6(ri2, va) {
                for (var ya2 = ri2.length; ya2-- && xD(va, ri2[ya2], 0) > -1; )
                  ;
                return ya2;
              }
              function Kk(ri2, va) {
                for (var ya2 = ri2.length, Zs = 0; ya2--; )
                  ri2[ya2] === va && ++Zs;
                return Zs;
              }
              var G9 = wD(_G), Cht = wD(NQ);
              function Tht(ri2) {
                return "\\" + _ht[ri2];
              }
              function AG(ri2, va) {
                return ri2 == null ? Ht : ri2[va];
              }
              function sy(ri2) {
                return mht.test(ri2);
              }
              function HQ(ri2) {
                return bht.test(ri2);
              }
              function IG(ri2) {
                for (var va, ya2 = []; !(va = ri2.next()).done; )
                  ya2.push(va.value);
                return ya2;
              }
              function DG(ri2) {
                var va = -1, ya2 = Array(ri2.size);
                return ri2.forEach(function(Zs, Gc2) {
                  ya2[++va] = [Gc2, Zs];
                }), ya2;
              }
              function UQ(ri2, va) {
                return function(ya2) {
                  return ri2(va(ya2));
                };
              }
              function CD(ri2, va) {
                for (var ya2 = -1, Zs = ri2.length, Gc2 = 0, pp = []; ++ya2 < Zs; ) {
                  var ly = ri2[ya2];
                  (ly === va || ly === vn) && (ri2[ya2] = vn, pp[Gc2++] = ya2);
                }
                return pp;
              }
              function H9(ri2) {
                var va = -1, ya2 = Array(ri2.size);
                return ri2.forEach(function(Zs) {
                  ya2[++va] = Zs;
                }), ya2;
              }
              function Aht(ri2) {
                var va = -1, ya2 = Array(ri2.size);
                return ri2.forEach(function(Zs) {
                  ya2[++va] = [Zs, Zs];
                }), ya2;
              }
              function qQ(ri2, va, ya2) {
                for (var Zs = ya2 - 1, Gc2 = ri2.length; ++Zs < Gc2; )
                  if (ri2[Zs] === va)
                    return Zs;
                return -1;
              }
              function Iht(ri2, va, ya2) {
                for (var Zs = ya2 + 1; Zs--; )
                  if (ri2[Zs] === va)
                    return Zs;
                return Zs;
              }
              function Pf2(ri2) {
                return sy(ri2) ? EG(ri2) : CG(ri2);
              }
              function n1(ri2) {
                return sy(ri2) ? ZQ(ri2) : z9(ri2);
              }
              function eg2(ri2) {
                for (var va = ri2.length; va-- && Hk.test(ri2.charAt(va)); )
                  ;
                return va;
              }
              var tb2 = wD(xG);
              function EG(ri2) {
                for (var va = QR.lastIndex = 0; QR.test(ri2); )
                  ++va;
                return va;
              }
              function ZQ(ri2) {
                return ri2.match(QR) || [];
              }
              function o_(ri2) {
                return ri2.match(RQ) || [];
              }
              var Wc2 = function ri2(va) {
                va = va == null ? qv : CT.defaults(qv.Object(), va, CT.pick(qv, iS));
                var ya2 = va.Array, Zs = va.Date, Gc2 = va.Error, pp = va.Function, ly = va.Math, bd2 = va.Object, kG = va.RegExp, PG = va.String, s_ = va.TypeError, rv = ya2.prototype, $Q = pp.prototype, Wd2 = bd2.prototype, ng2 = va["__core-js_shared__"], rg2 = $Q.toString, sd2 = Wd2.hasOwnProperty, YQ = 0, KQ = function() {
                  var ct = /[^.]+$/.exec(ng2 && ng2.keys && ng2.keys.IE_PROTO || "");
                  return ct ? "Symbol(src)_1." + ct : "";
                }(), U9 = Wd2.toString, Dht = rg2.call(bd2), XQ = qv._, QQ = kG("^" + rg2.call(sd2).replace(bT, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), eL = BQ ? va.Buffer : Ht, sS = va.Symbol, TD = va.Uint8Array, nL = eL ? eL.allocUnsafe : Ht, s6 = UQ(bd2.getPrototypeOf, bd2), l6 = bd2.create, uy = Wd2.propertyIsEnumerable, TT = rv.splice, JQ = sS ? sS.isConcatSpreadable : Ht, Lf2 = sS ? sS.iterator : Ht, Xk = sS ? sS.toStringTag : Ht, q9 = function() {
                  try {
                    var ct = $i2(bd2, "defineProperty");
                    return ct({}, "", {}), ct;
                  } catch {
                  }
                }(), Eht = va.clearTimeout !== qv.clearTimeout && va.clearTimeout, tJ = Zs && Zs.now !== qv.Date.now && Zs.now, AT = va.setTimeout !== qv.setTimeout && va.setTimeout, Hc2 = ly.ceil, u6 = ly.floor, l_ = bd2.getOwnPropertySymbols, eJ = eL ? eL.isBuffer : Ht, nJ = va.isFinite, ld2 = rv.join, kht = UQ(bd2.keys, bd2), R0 = ly.max, cy = ly.min, LG = Zs.now, Pht = va.parseInt, rL = ly.random, OG = rv.reverse, c6 = $i2(va, "DataView"), IT = $i2(va, "Map"), eb2 = $i2(va, "Promise"), Qk = $i2(va, "Set"), iL = $i2(va, "WeakMap"), f6 = $i2(bd2, "create"), h6 = iL && new iL(), aL = {}, N0 = ma2(c6), AD = ma2(IT), Jk = ma2(eb2), Z9 = ma2(Qk), p6 = ma2(iL), d6 = sS ? sS.prototype : Ht, oL = d6 ? d6.valueOf : Ht, Zv = d6 ? d6.toString : Ht;
                function Sn(ct) {
                  if (j0(ct) && !Bo(ct) && !(ct instanceof yh2)) {
                    if (ct instanceof Lx)
                      return ct;
                    if (sd2.call(ct, "__wrapped__"))
                      return Ho(ct);
                  }
                  return new Lx(ct);
                }
                var sL = function() {
                  function ct() {
                  }
                  return function(It) {
                    if (!ov(It))
                      return {};
                    if (l6)
                      return l6(It);
                    ct.prototype = It;
                    var Kt = new ct();
                    return ct.prototype = Ht, Kt;
                  };
                }();
                function $9() {
                }
                function Lx(ct, It) {
                  this.__wrapped__ = ct, this.__actions__ = [], this.__chain__ = !!It, this.__index__ = 0, this.__values__ = Ht;
                }
                Sn.templateSettings = { escape: hm, evaluate: i_, interpolate: X1, variable: "", imports: { _: Sn } }, Sn.prototype = $9.prototype, Sn.prototype.constructor = Sn, Lx.prototype = sL($9.prototype), Lx.prototype.constructor = Lx;
                function yh2(ct) {
                  this.__wrapped__ = ct, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = fs, this.__views__ = [];
                }
                function Lht() {
                  var ct = new yh2(this.__wrapped__);
                  return ct.__actions__ = on(this.__actions__), ct.__dir__ = this.__dir__, ct.__filtered__ = this.__filtered__, ct.__iteratees__ = on(this.__iteratees__), ct.__takeCount__ = this.__takeCount__, ct.__views__ = on(this.__views__), ct;
                }
                function RG() {
                  if (this.__filtered__) {
                    var ct = new yh2(this);
                    ct.__dir__ = -1, ct.__filtered__ = true;
                  } else
                    ct = this.clone(), ct.__dir__ *= -1;
                  return ct;
                }
                function NG() {
                  var ct = this.__wrapped__.value(), It = this.__dir__, Kt = Bo(ct), De2 = It < 0, fn = Kt ? ct.length : 0, Zn = Tf2(0, fn, this.__views__), Or = Zn.start, ti2 = Zn.end, Di2 = ti2 - Or, Co = De2 ? ti2 : Or - 1, Eo = this.__iteratees__, Yo = Eo.length, Ds = 0, Hl = cy(Di2, this.__takeCount__);
                  if (!Kt || !De2 && fn == Di2 && Hl == Di2)
                    return ve2(ct, this.__actions__);
                  var ic2 = [];
                  t:
                    for (; Di2-- && Ds < Hl; ) {
                      Co += It;
                      for (var qf2 = -1, Zu = ct[Co]; ++qf2 < Yo; ) {
                        var Vh2 = Eo[qf2], ap = Vh2.iteratee, dS = Vh2.type, cb2 = ap(Zu);
                        if (dS == vl)
                          Zu = cb2;
                        else if (!cb2) {
                          if (dS == bl)
                            continue t;
                          break t;
                        }
                      }
                      ic2[Ds++] = Zu;
                    }
                  return ic2;
                }
                yh2.prototype = sL($9.prototype), yh2.prototype.constructor = yh2;
                function ID(ct) {
                  var It = -1, Kt = ct == null ? 0 : ct.length;
                  for (this.clear(); ++It < Kt; ) {
                    var De2 = ct[It];
                    this.set(De2[0], De2[1]);
                  }
                }
                function Oht() {
                  this.__data__ = f6 ? f6(null) : {}, this.size = 0;
                }
                function FG(ct) {
                  var It = this.has(ct) && delete this.__data__[ct];
                  return this.size -= It ? 1 : 0, It;
                }
                function Rht(ct) {
                  var It = this.__data__;
                  if (f6) {
                    var Kt = It[ct];
                    return Kt === Ve ? Ht : Kt;
                  }
                  return sd2.call(It, ct) ? It[ct] : Ht;
                }
                function Y9(ct) {
                  var It = this.__data__;
                  return f6 ? It[ct] !== Ht : sd2.call(It, ct);
                }
                function rJ(ct, It) {
                  var Kt = this.__data__;
                  return this.size += this.has(ct) ? 0 : 1, Kt[ct] = f6 && It === Ht ? Ve : It, this;
                }
                ID.prototype.clear = Oht, ID.prototype.delete = FG, ID.prototype.get = Rht, ID.prototype.has = Y9, ID.prototype.set = rJ;
                function F0(ct) {
                  var It = -1, Kt = ct == null ? 0 : ct.length;
                  for (this.clear(); ++It < Kt; ) {
                    var De2 = ct[It];
                    this.set(De2[0], De2[1]);
                  }
                }
                function iJ() {
                  this.__data__ = [], this.size = 0;
                }
                function VG(ct) {
                  var It = this.__data__, Kt = Q9(It, ct);
                  if (Kt < 0)
                    return false;
                  var De2 = It.length - 1;
                  return Kt == De2 ? It.pop() : TT.call(It, Kt, 1), --this.size, true;
                }
                function aJ(ct) {
                  var It = this.__data__, Kt = Q9(It, ct);
                  return Kt < 0 ? Ht : It[Kt][1];
                }
                function lL(ct) {
                  return Q9(this.__data__, ct) > -1;
                }
                function Nht(ct, It) {
                  var Kt = this.__data__, De2 = Q9(Kt, ct);
                  return De2 < 0 ? (++this.size, Kt.push([ct, It])) : Kt[De2][1] = It, this;
                }
                F0.prototype.clear = iJ, F0.prototype.delete = VG, F0.prototype.get = aJ, F0.prototype.has = lL, F0.prototype.set = Nht;
                function DT(ct) {
                  var It = -1, Kt = ct == null ? 0 : ct.length;
                  for (this.clear(); ++It < Kt; ) {
                    var De2 = ct[It];
                    this.set(De2[0], De2[1]);
                  }
                }
                function oJ() {
                  this.size = 0, this.__data__ = { hash: new ID(), map: new (IT || F0)(), string: new ID() };
                }
                function BG(ct) {
                  var It = lo(this, ct).delete(ct);
                  return this.size -= It ? 1 : 0, It;
                }
                function g6(ct) {
                  return lo(this, ct).get(ct);
                }
                function sJ(ct) {
                  return lo(this, ct).has(ct);
                }
                function lJ(ct, It) {
                  var Kt = lo(this, ct), De2 = Kt.size;
                  return Kt.set(ct, It), this.size += Kt.size == De2 ? 0 : 1, this;
                }
                DT.prototype.clear = oJ, DT.prototype.delete = BG, DT.prototype.get = g6, DT.prototype.has = sJ, DT.prototype.set = lJ;
                function DD(ct) {
                  var It = -1, Kt = ct == null ? 0 : ct.length;
                  for (this.__data__ = new DT(); ++It < Kt; )
                    this.add(ct[It]);
                }
                function zG(ct) {
                  return this.__data__.set(ct, Ve), this;
                }
                function Fht(ct) {
                  return this.__data__.has(ct);
                }
                DD.prototype.add = DD.prototype.push = zG, DD.prototype.has = Fht;
                function D22(ct) {
                  var It = this.__data__ = new F0(ct);
                  this.size = It.size;
                }
                function Vht() {
                  this.__data__ = new F0(), this.size = 0;
                }
                function Bht(ct) {
                  var It = this.__data__, Kt = It.delete(ct);
                  return this.size = It.size, Kt;
                }
                function K9(ct) {
                  return this.__data__.get(ct);
                }
                function zht(ct) {
                  return this.__data__.has(ct);
                }
                function jht(ct, It) {
                  var Kt = this.__data__;
                  if (Kt instanceof F0) {
                    var De2 = Kt.__data__;
                    if (!IT || De2.length < Zt - 1)
                      return De2.push([ct, It]), this.size = ++Kt.size, this;
                    Kt = this.__data__ = new DT(De2);
                  }
                  return Kt.set(ct, It), this.size = Kt.size, this;
                }
                D22.prototype.clear = Vht, D22.prototype.delete = Bht, D22.prototype.get = K9, D22.prototype.has = zht, D22.prototype.set = jht;
                function uJ(ct, It) {
                  var Kt = Bo(ct), De2 = !Kt && fa2(ct), fn = !Kt && !De2 && kD(ct), Zn = !Kt && !De2 && !fn && g7(ct), Or = Kt || De2 || fn || Zn, ti2 = Or ? SD(ct.length, PG) : [], Di2 = ti2.length;
                  for (var Co in ct)
                    (It || sd2.call(ct, Co)) && !(Or && (Co == "length" || fn && (Co == "offset" || Co == "parent") || Zn && (Co == "buffer" || Co == "byteLength" || Co == "byteOffset") || Ny(Co, Di2))) && ti2.push(Co);
                  return ti2;
                }
                function cJ(ct) {
                  var It = ct.length;
                  return It ? ct[xt(0, It - 1)] : Ht;
                }
                function fJ(ct, It) {
                  return gr(on(ct), t5(It, 0, ct.length));
                }
                function Wht(ct) {
                  return gr(on(ct));
                }
                function X9(ct, It, Kt) {
                  (Kt !== Ht && !h_(ct[It], Kt) || Kt === Ht && !(It in ct)) && E2(ct, It, Kt);
                }
                function gm(ct, It, Kt) {
                  var De2 = ct[It];
                  (!(sd2.call(ct, It) && h_(De2, Kt)) || Kt === Ht && !(It in ct)) && E2(ct, It, Kt);
                }
                function Q9(ct, It) {
                  for (var Kt = ct.length; Kt--; )
                    if (h_(ct[Kt][0], It))
                      return Kt;
                  return -1;
                }
                function hJ(ct, It, Kt, De2) {
                  return k22(ct, function(fn, Zn, Or) {
                    It(De2, fn, Kt(fn), Or);
                  }), De2;
                }
                function pJ(ct, It) {
                  return ct && di2(It, qu(It), ct);
                }
                function Ght(ct, It) {
                  return ct && di2(It, pS(It), ct);
                }
                function E2(ct, It, Kt) {
                  It == "__proto__" && q9 ? q9(ct, It, { configurable: true, enumerable: true, value: Kt, writable: true }) : ct[It] = Kt;
                }
                function jG(ct, It) {
                  for (var Kt = -1, De2 = It.length, fn = ya2(De2), Zn = ct == null; ++Kt < De2; )
                    fn[Kt] = Zn ? Ht : C6(ct, It[Kt]);
                  return fn;
                }
                function t5(ct, It, Kt) {
                  return ct === ct && (Kt !== Ht && (ct = ct <= Kt ? ct : Kt), It !== Ht && (ct = ct >= It ? ct : It)), ct;
                }
                function lS(ct, It, Kt, De2, fn, Zn) {
                  var Or, ti2 = It & Gn, Di2 = It & Lr, Co = It & Wr;
                  if (Kt && (Or = fn ? Kt(ct, De2, fn, Zn) : Kt(ct)), Or !== Ht)
                    return Or;
                  if (!ov(ct))
                    return ct;
                  var Eo = Bo(ct);
                  if (Eo) {
                    if (Or = Bg2(ct), !ti2)
                      return on(ct, Or);
                  } else {
                    var Yo = Iu(ct), Ds = Yo == Dx || Yo == Iv;
                    if (kD(ct))
                      return yn(ct, ti2);
                    if (Yo == ry || Yo == Wf2 || Ds && !fn) {
                      if (Or = Di2 || Ds ? {} : z0(ct), !ti2)
                        return Di2 ? Oa2(ct, Ght(Or, ct)) : Yi2(ct, pJ(Or, ct));
                    } else {
                      if (!jd2[Yo])
                        return fn ? ct : {};
                      Or = zg2(ct, Yo, ti2);
                    }
                  }
                  Zn || (Zn = new D22());
                  var Hl = Zn.get(ct);
                  if (Hl)
                    return Hl;
                  Zn.set(ct, Or), d7(ct) ? ct.forEach(function(Zu) {
                    Or.add(lS(Zu, It, Kt, Zu, ct, Zn));
                  }) : RAt(ct) && ct.forEach(function(Zu, Vh2) {
                    Or.set(Vh2, lS(Zu, It, Kt, Vh2, ct, Zn));
                  });
                  var ic2 = Co ? Di2 ? cS : VM : Di2 ? pS : qu, qf2 = Eo ? Ht : ic2(ct);
                  return J1(qf2 || ct, function(Zu, Vh2) {
                    qf2 && (Vh2 = Zu, Zu = ct[Vh2]), gm(Or, Vh2, lS(Zu, It, Kt, Vh2, ct, Zn));
                  }), Or;
                }
                function Hht(ct) {
                  var It = qu(ct);
                  return function(Kt) {
                    return dJ(Kt, ct, It);
                  };
                }
                function dJ(ct, It, Kt) {
                  var De2 = Kt.length;
                  if (ct == null)
                    return !De2;
                  for (ct = bd2(ct); De2--; ) {
                    var fn = Kt[De2], Zn = It[fn], Or = ct[fn];
                    if (Or === Ht && !(fn in ct) || !Zn(Or))
                      return false;
                  }
                  return true;
                }
                function v6(ct, It, Kt) {
                  if (typeof ct != "function")
                    throw new s_(Ne2);
                  return br(function() {
                    ct.apply(Ht, Kt);
                  }, It);
                }
                function e5(ct, It, Kt, De2) {
                  var fn = -1, Zn = tL, Or = true, ti2 = ct.length, Di2 = [], Co = It.length;
                  if (!ti2)
                    return Di2;
                  Kt && (It = Xc2(It, dm(Kt))), De2 ? (Zn = MG, Or = false) : It.length >= Zt && (Zn = MD, Or = false, It = new DD(It));
                  t:
                    for (; ++fn < ti2; ) {
                      var Eo = ct[fn], Yo = Kt == null ? Eo : Kt(Eo);
                      if (Eo = De2 || Eo !== 0 ? Eo : 0, Or && Yo === Yo) {
                        for (var Ds = Co; Ds--; )
                          if (It[Ds] === Yo)
                            continue t;
                        Di2.push(Eo);
                      } else
                        Zn(It, Yo, De2) || Di2.push(Eo);
                    }
                  return Di2;
                }
                var k22 = Qi2(Ox), uL = Qi2(t7, true);
                function Uht(ct, It) {
                  var Kt = true;
                  return k22(ct, function(De2, fn, Zn) {
                    return Kt = !!It(De2, fn, Zn), Kt;
                  }), Kt;
                }
                function J9(ct, It, Kt) {
                  for (var De2 = -1, fn = ct.length; ++De2 < fn; ) {
                    var Zn = ct[De2], Or = It(Zn);
                    if (Or != null && (ti2 === Ht ? Or === Or && !p_(Or) : Kt(Or, ti2)))
                      var ti2 = Or, Di2 = Zn;
                  }
                  return Di2;
                }
                function WG(ct, It, Kt, De2) {
                  var fn = ct.length;
                  for (Kt = Uf2(Kt), Kt < 0 && (Kt = -Kt > fn ? 0 : fn + Kt), De2 = De2 === Ht || De2 > fn ? fn : Uf2(De2), De2 < 0 && (De2 += fn), De2 = Kt > De2 ? 0 : BAt(De2); Kt < De2; )
                    ct[Kt++] = It;
                  return ct;
                }
                function ET(ct, It) {
                  var Kt = [];
                  return k22(ct, function(De2, fn, Zn) {
                    It(De2, fn, Zn) && Kt.push(De2);
                  }), Kt;
                }
                function Oy(ct, It, Kt, De2, fn) {
                  var Zn = -1, Or = ct.length;
                  for (Kt || (Kt = Nx), fn || (fn = []); ++Zn < Or; ) {
                    var ti2 = ct[Zn];
                    It > 0 && Kt(ti2) ? It > 1 ? Oy(ti2, It - 1, Kt, De2, fn) : oS(fn, ti2) : De2 || (fn[fn.length] = ti2);
                  }
                  return fn;
                }
                var GG = ro(), nb2 = ro(true);
                function Ox(ct, It) {
                  return ct && GG(ct, It, qu);
                }
                function t7(ct, It) {
                  return ct && nb2(ct, It, qu);
                }
                function y6(ct, It) {
                  return MT(It, function(Kt) {
                    return ip(ct[Kt]);
                  });
                }
                function kT(ct, It) {
                  It = Re2(It, ct);
                  for (var Kt = 0, De2 = It.length; ct != null && Kt < De2; )
                    ct = ct[Fa2(It[Kt++])];
                  return Kt && Kt == De2 ? ct : Ht;
                }
                function HG(ct, It, Kt) {
                  var De2 = It(ct);
                  return Bo(ct) ? De2 : oS(De2, Kt(ct));
                }
                function V0(ct) {
                  return ct == null ? ct === Ht ? eS : Ex : Xk && Xk in bd2(ct) ? xo(ct) : hL(ct);
                }
                function UG(ct, It) {
                  return ct > It;
                }
                function ju(ct, It) {
                  return ct != null && sd2.call(ct, It);
                }
                function gJ(ct, It) {
                  return ct != null && It in bd2(ct);
                }
                function qht(ct, It, Kt) {
                  return ct >= cy(It, Kt) && ct < R0(It, Kt);
                }
                function qG(ct, It, Kt) {
                  for (var De2 = Kt ? MG : tL, fn = ct[0].length, Zn = ct.length, Or = Zn, ti2 = ya2(Zn), Di2 = 1 / 0, Co = []; Or--; ) {
                    var Eo = ct[Or];
                    Or && It && (Eo = Xc2(Eo, dm(It))), Di2 = cy(Eo.length, Di2), ti2[Or] = !Kt && (It || fn >= 120 && Eo.length >= 120) ? new DD(Or && Eo) : Ht;
                  }
                  Eo = ct[0];
                  var Yo = -1, Ds = ti2[0];
                  t:
                    for (; ++Yo < fn && Co.length < Di2; ) {
                      var Hl = Eo[Yo], ic2 = It ? It(Hl) : Hl;
                      if (Hl = Kt || Hl !== 0 ? Hl : 0, !(Ds ? MD(Ds, ic2) : De2(Co, ic2, Kt))) {
                        for (Or = Zn; --Or; ) {
                          var qf2 = ti2[Or];
                          if (!(qf2 ? MD(qf2, ic2) : De2(ct[Or], ic2, Kt)))
                            continue t;
                        }
                        Ds && Ds.push(ic2), Co.push(Hl);
                      }
                    }
                  return Co;
                }
                function Zht(ct, It, Kt, De2) {
                  return Ox(ct, function(fn, Zn, Or) {
                    It(De2, Kt(fn), Zn, Or);
                  }), De2;
                }
                function n5(ct, It, Kt) {
                  It = Re2(It, ct), ct = SJ(ct, It);
                  var De2 = ct == null ? ct : ct[Fa2(a1(It))];
                  return De2 == null ? Ht : Px(De2, ct, Kt);
                }
                function m6(ct) {
                  return j0(ct) && V0(ct) == Wf2;
                }
                function r52(ct) {
                  return j0(ct) && V0(ct) == Xi2;
                }
                function ZG(ct) {
                  return j0(ct) && V0(ct) == hp;
                }
                function NM(ct, It, Kt, De2, fn) {
                  return ct === It ? true : ct == null || It == null || !j0(ct) && !j0(It) ? ct !== ct && It !== It : $G(ct, It, Kt, De2, NM, fn);
                }
                function $G(ct, It, Kt, De2, fn, Zn) {
                  var Or = Bo(ct), ti2 = Bo(It), Di2 = Or ? mc2 : Iu(ct), Co = ti2 ? mc2 : Iu(It);
                  Di2 = Di2 == Wf2 ? ry : Di2, Co = Co == Wf2 ? ry : Co;
                  var Eo = Di2 == ry, Yo = Co == ry, Ds = Di2 == Co;
                  if (Ds && kD(ct)) {
                    if (!kD(It))
                      return false;
                    Or = true, Eo = false;
                  }
                  if (Ds && !Eo)
                    return Zn || (Zn = new D22()), Or || g7(ct) ? Rx(ct, It, Kt, De2, fn, Zn) : PT(ct, It, Di2, Kt, De2, fn, Zn);
                  if (!(Kt & Gr)) {
                    var Hl = Eo && sd2.call(ct, "__wrapped__"), ic2 = Yo && sd2.call(It, "__wrapped__");
                    if (Hl || ic2) {
                      var qf2 = Hl ? ct.value() : ct, Zu = ic2 ? It.value() : It;
                      return Zn || (Zn = new D22()), fn(qf2, Zu, Kt, De2, Zn);
                    }
                  }
                  return Ds ? (Zn || (Zn = new D22()), u_(ct, It, Kt, De2, fn, Zn)) : false;
                }
                function vJ(ct) {
                  return j0(ct) && Iu(ct) == Gv;
                }
                function YG(ct, It, Kt, De2) {
                  var fn = Kt.length, Zn = fn, Or = !De2;
                  if (ct == null)
                    return !Zn;
                  for (ct = bd2(ct); fn--; ) {
                    var ti2 = Kt[fn];
                    if (Or && ti2[2] ? ti2[1] !== ct[ti2[0]] : !(ti2[0] in ct))
                      return false;
                  }
                  for (; ++fn < Zn; ) {
                    ti2 = Kt[fn];
                    var Di2 = ti2[0], Co = ct[Di2], Eo = ti2[1];
                    if (Or && ti2[2]) {
                      if (Co === Ht && !(Di2 in ct))
                        return false;
                    } else {
                      var Yo = new D22();
                      if (De2)
                        var Ds = De2(Co, Eo, Di2, ct, It, Yo);
                      if (!(Ds === Ht ? NM(Eo, Co, Gr | ei2, De2, Yo) : Ds))
                        return false;
                    }
                  }
                  return true;
                }
                function i5(ct) {
                  if (!ov(ct) || ab2(ct))
                    return false;
                  var It = ip(ct) ? QQ : qa2;
                  return It.test(ma2(ct));
                }
                function e7(ct) {
                  return j0(ct) && V0(ct) == t1;
                }
                function KG(ct) {
                  return j0(ct) && Iu(ct) == Dv;
                }
                function yJ(ct) {
                  return j0(ct) && aH(ct.length) && !!Fg2[V0(ct)];
                }
                function mJ(ct) {
                  return typeof ct == "function" ? ct : ct == null ? Bx : typeof ct == "object" ? Bo(ct) ? JG(ct[0], ct[1]) : QG(ct) : rIt(ct);
                }
                function n7(ct) {
                  if (!i1(ct))
                    return kht(ct);
                  var It = [];
                  for (var Kt in bd2(ct))
                    sd2.call(ct, Kt) && Kt != "constructor" && It.push(Kt);
                  return It;
                }
                function XG(ct) {
                  if (!ov(ct))
                    return Kht(ct);
                  var It = i1(ct), Kt = [];
                  for (var De2 in ct)
                    De2 == "constructor" && (It || !sd2.call(ct, De2)) || Kt.push(De2);
                  return Kt;
                }
                function a5(ct, It) {
                  return ct < It;
                }
                function bJ(ct, It) {
                  var Kt = -1, De2 = cf2(ct) ? ya2(ct.length) : [];
                  return k22(ct, function(fn, Zn, Or) {
                    De2[++Kt] = It(fn, Zn, Or);
                  }), De2;
                }
                function QG(ct) {
                  var It = na2(ct);
                  return It.length == 1 && It[0][2] ? fS(It[0][0], It[0][1]) : function(Kt) {
                    return Kt === ct || YG(Kt, ct, It);
                  };
                }
                function JG(ct, It) {
                  return Yv(ct) && f_(It) ? fS(Fa2(ct), It) : function(Kt) {
                    var De2 = C6(Kt, ct);
                    return De2 === Ht && De2 === It ? Pn(Kt, ct) : NM(It, De2, Gr | ei2);
                  };
                }
                function r7(ct, It, Kt, De2, fn) {
                  ct !== It && GG(It, function(Zn, Or) {
                    if (fn || (fn = new D22()), ov(Zn))
                      $ht(ct, It, Or, Kt, r7, De2, fn);
                    else {
                      var ti2 = De2 ? De2(eH(ct, Or), Zn, Or + "", ct, It, fn) : Ht;
                      ti2 === Ht && (ti2 = Zn), X9(ct, Or, ti2);
                    }
                  }, pS);
                }
                function $ht(ct, It, Kt, De2, fn, Zn, Or) {
                  var ti2 = eH(ct, Kt), Di2 = eH(It, Kt), Co = Or.get(Di2);
                  if (Co) {
                    X9(ct, Kt, Co);
                    return;
                  }
                  var Eo = Zn ? Zn(ti2, Di2, Kt + "", ct, It, Or) : Ht, Yo = Eo === Ht;
                  if (Yo) {
                    var Ds = Bo(Di2), Hl = !Ds && kD(Di2), ic2 = !Ds && !Hl && g7(Di2);
                    Eo = Di2, Ds || Hl || ic2 ? Bo(ti2) ? Eo = ti2 : _h(ti2) ? Eo = on(ti2) : Hl ? (Yo = false, Eo = yn(Di2, true)) : ic2 ? (Yo = false, Eo = si2(Di2, true)) : Eo = [] : h7(Di2) || fa2(Di2) ? (Eo = ti2, fa2(ti2) ? Eo = sb2(ti2) : (!ov(ti2) || ip(ti2)) && (Eo = z0(Di2))) : Yo = false;
                  }
                  Yo && (Or.set(Di2, Eo), fn(Eo, Di2, De2, Zn, Or), Or.delete(Di2)), X9(ct, Kt, Eo);
                }
                function _J(ct, It) {
                  var Kt = ct.length;
                  if (Kt)
                    return It += It < 0 ? Kt : 0, Ny(It, Kt) ? ct[It] : Ht;
                }
                function tH(ct, It, Kt) {
                  It.length ? It = Xc2(It, function(Zn) {
                    return Bo(Zn) ? function(Or) {
                      return kT(Or, Zn.length === 1 ? Zn[0] : Zn);
                    } : Zn;
                  }) : It = [Bx];
                  var De2 = -1;
                  It = Xc2(It, dm(_u()));
                  var fn = bJ(ct, function(Zn, Or, ti2) {
                    var Di2 = Xc2(It, function(Co) {
                      return Co(Zn);
                    });
                    return { criteria: Di2, index: ++De2, value: Zn };
                  });
                  return r6(fn, function(Zn, Or) {
                    return Wa2(Zn, Or, Kt);
                  });
                }
                function cL(ct, It) {
                  return xJ(ct, It, function(Kt, De2) {
                    return Pn(ct, De2);
                  });
                }
                function xJ(ct, It, Kt) {
                  for (var De2 = -1, fn = It.length, Zn = {}; ++De2 < fn; ) {
                    var Or = It[De2], ti2 = kT(ct, Or);
                    Kt(ti2, Or) && qr(Zn, Re2(Or, ct), ti2);
                  }
                  return Zn;
                }
                function Yht(ct) {
                  return function(It) {
                    return kT(It, ct);
                  };
                }
                function i7(ct, It, Kt, De2) {
                  var fn = De2 ? TG : xD, Zn = -1, Or = It.length, ti2 = ct;
                  for (ct === It && (It = on(It)), Kt && (ti2 = Xc2(ct, dm(Kt))); ++Zn < Or; )
                    for (var Di2 = 0, Co = It[Zn], Eo = Kt ? Kt(Co) : Co; (Di2 = fn(ti2, Eo, Di2, De2)) > -1; )
                      ti2 !== ct && TT.call(ti2, Di2, 1), TT.call(ct, Di2, 1);
                  return ct;
                }
                function st(ct, It) {
                  for (var Kt = ct ? It.length : 0, De2 = Kt - 1; Kt--; ) {
                    var fn = It[Kt];
                    if (Kt == De2 || fn !== Zn) {
                      var Zn = fn;
                      Ny(fn) ? TT.call(ct, fn, 1) : rb2(ct, fn);
                    }
                  }
                  return ct;
                }
                function xt(ct, It) {
                  return ct + u6(rL() * (It - ct + 1));
                }
                function Qt(ct, It, Kt, De2) {
                  for (var fn = -1, Zn = R0(Hc2((It - ct) / (Kt || 1)), 0), Or = ya2(Zn); Zn--; )
                    Or[De2 ? Zn : ++fn] = ct, ct += Kt;
                  return Or;
                }
                function Ae2(ct, It) {
                  var Kt = "";
                  if (!ct || It < 1 || It > Na2)
                    return Kt;
                  do
                    It % 2 && (Kt += ct), It = u6(It / 2), It && (ct += ct);
                  while (It);
                  return Kt;
                }
                function an(ct, It) {
                  return Dr(wJ(ct, It, Bx), ct + "");
                }
                function Un(ct) {
                  return cJ(_7(ct));
                }
                function Br(ct, It) {
                  var Kt = _7(ct);
                  return gr(Kt, t5(It, 0, Kt.length));
                }
                function qr(ct, It, Kt, De2) {
                  if (!ov(ct))
                    return ct;
                  It = Re2(It, ct);
                  for (var fn = -1, Zn = It.length, Or = Zn - 1, ti2 = ct; ti2 != null && ++fn < Zn; ) {
                    var Di2 = Fa2(It[fn]), Co = Kt;
                    if (Di2 === "__proto__" || Di2 === "constructor" || Di2 === "prototype")
                      return ct;
                    if (fn != Or) {
                      var Eo = ti2[Di2];
                      Co = De2 ? De2(Eo, Di2, ti2) : Ht, Co === Ht && (Co = ov(Eo) ? Eo : Ny(It[fn + 1]) ? [] : {});
                    }
                    gm(ti2, Di2, Co), ti2 = ti2[Di2];
                  }
                  return ct;
                }
                var Ai2 = h6 ? function(ct, It) {
                  return h6.set(ct, It), ct;
                } : Bx, So = q9 ? function(ct, It) {
                  return q9(ct, "toString", { configurable: true, enumerable: false, value: qM(It), writable: true });
                } : Bx;
                function Mo(ct) {
                  return gr(_7(ct));
                }
                function Ao(ct, It, Kt) {
                  var De2 = -1, fn = ct.length;
                  It < 0 && (It = -It > fn ? 0 : fn + It), Kt = Kt > fn ? fn : Kt, Kt < 0 && (Kt += fn), fn = It > Kt ? 0 : Kt - It >>> 0, It >>>= 0;
                  for (var Zn = ya2(fn); ++De2 < fn; )
                    Zn[De2] = ct[De2 + It];
                  return Zn;
                }
                function Xs(ct, It) {
                  var Kt;
                  return k22(ct, function(De2, fn, Zn) {
                    return Kt = It(De2, fn, Zn), !Kt;
                  }), !!Kt;
                }
                function Yl(ct, It, Kt) {
                  var De2 = 0, fn = ct == null ? De2 : ct.length;
                  if (typeof It == "number" && It === It && fn <= Hu) {
                    for (; De2 < fn; ) {
                      var Zn = De2 + fn >>> 1, Or = ct[Zn];
                      Or !== null && !p_(Or) && (Kt ? Or <= It : Or < It) ? De2 = Zn + 1 : fn = Zn;
                    }
                    return fn;
                  }
                  return Pu(ct, It, Bx, Kt);
                }
                function Pu(ct, It, Kt, De2) {
                  var fn = 0, Zn = ct == null ? 0 : ct.length;
                  if (Zn === 0)
                    return 0;
                  It = Kt(It);
                  for (var Or = It !== It, ti2 = It === null, Di2 = p_(It), Co = It === Ht; fn < Zn; ) {
                    var Eo = u6((fn + Zn) / 2), Yo = Kt(ct[Eo]), Ds = Yo !== Ht, Hl = Yo === null, ic2 = Yo === Yo, qf2 = p_(Yo);
                    if (Or)
                      var Zu = De2 || ic2;
                    else
                      Co ? Zu = ic2 && (De2 || Ds) : ti2 ? Zu = ic2 && Ds && (De2 || !Hl) : Di2 ? Zu = ic2 && Ds && !Hl && (De2 || !qf2) : Hl || qf2 ? Zu = false : Zu = De2 ? Yo <= It : Yo < It;
                    Zu ? fn = Eo + 1 : Zn = Eo;
                  }
                  return cy(Zn, qo);
                }
                function Mf2(ct, It) {
                  for (var Kt = -1, De2 = ct.length, fn = 0, Zn = []; ++Kt < De2; ) {
                    var Or = ct[Kt], ti2 = It ? It(Or) : Or;
                    if (!Kt || !h_(ti2, Di2)) {
                      var Di2 = ti2;
                      Zn[fn++] = Or === 0 ? 0 : Or;
                    }
                  }
                  return Zn;
                }
                function Uu(ct) {
                  return typeof ct == "number" ? ct : p_(ct) ? ca2 : +ct;
                }
                function nc2(ct) {
                  if (typeof ct == "string")
                    return ct;
                  if (Bo(ct))
                    return Xc2(ct, nc2) + "";
                  if (p_(ct))
                    return Zv ? Zv.call(ct) : "";
                  var It = ct + "";
                  return It == "0" && 1 / ct == -gu ? "-0" : It;
                }
                function lf2(ct, It, Kt) {
                  var De2 = -1, fn = tL, Zn = ct.length, Or = true, ti2 = [], Di2 = ti2;
                  if (Kt)
                    Or = false, fn = MG;
                  else if (Zn >= Zt) {
                    var Co = It ? null : Gp(ct);
                    if (Co)
                      return H9(Co);
                    Or = false, fn = MD, Di2 = new DD();
                  } else
                    Di2 = It ? [] : ti2;
                  t:
                    for (; ++De2 < Zn; ) {
                      var Eo = ct[De2], Yo = It ? It(Eo) : Eo;
                      if (Eo = Kt || Eo !== 0 ? Eo : 0, Or && Yo === Yo) {
                        for (var Ds = Di2.length; Ds--; )
                          if (Di2[Ds] === Yo)
                            continue t;
                        It && Di2.push(Yo), ti2.push(Eo);
                      } else
                        fn(Di2, Yo, Kt) || (Di2 !== ti2 && Di2.push(Yo), ti2.push(Eo));
                    }
                  return ti2;
                }
                function rb2(ct, It) {
                  return It = Re2(It, ct), ct = SJ(ct, It), ct == null || delete ct[Fa2(a1(It))];
                }
                function r1(ct, It, Kt, De2) {
                  return qr(ct, It, Kt(kT(ct, It)), De2);
                }
                function Vt(ct, It, Kt, De2) {
                  for (var fn = ct.length, Zn = De2 ? fn : -1; (De2 ? Zn-- : ++Zn < fn) && It(ct[Zn], Zn, ct); )
                    ;
                  return Kt ? Ao(ct, De2 ? 0 : Zn, De2 ? Zn + 1 : fn) : Ao(ct, De2 ? Zn + 1 : 0, De2 ? fn : Zn);
                }
                function ve2(ct, It) {
                  var Kt = ct;
                  return Kt instanceof yh2 && (Kt = Kt.value()), B9(It, function(De2, fn) {
                    return fn.func.apply(fn.thisArg, oS([De2], fn.args));
                  }, Kt);
                }
                function Ut(ct, It, Kt) {
                  var De2 = ct.length;
                  if (De2 < 2)
                    return De2 ? lf2(ct[0]) : [];
                  for (var fn = -1, Zn = ya2(De2); ++fn < De2; )
                    for (var Or = ct[fn], ti2 = -1; ++ti2 < De2; )
                      ti2 != fn && (Zn[fn] = e5(Zn[fn] || Or, ct[ti2], It, Kt));
                  return lf2(Oy(Zn, 1), It, Kt);
                }
                function $t(ct, It, Kt) {
                  for (var De2 = -1, fn = ct.length, Zn = It.length, Or = {}; ++De2 < fn; ) {
                    var ti2 = De2 < Zn ? It[De2] : Ht;
                    Kt(Or, ct[De2], ti2);
                  }
                  return Or;
                }
                function Yt(ct) {
                  return _h(ct) ? ct : [];
                }
                function se2(ct) {
                  return typeof ct == "function" ? ct : Bx;
                }
                function Re2(ct, It) {
                  return Bo(ct) ? ct : Yv(ct, It) ? [ct] : Hi2(Pd2(ct));
                }
                var He2 = an;
                function nn(ct, It, Kt) {
                  var De2 = ct.length;
                  return Kt = Kt === Ht ? De2 : Kt, !It && Kt >= De2 ? ct : Ao(ct, It, Kt);
                }
                var dn = Eht || function(ct) {
                  return qv.clearTimeout(ct);
                };
                function yn(ct, It) {
                  if (It)
                    return ct.slice();
                  var Kt = ct.length, De2 = nL ? nL(Kt) : new ct.constructor(Kt);
                  return ct.copy(De2), De2;
                }
                function Yn(ct) {
                  var It = new ct.constructor(ct.byteLength);
                  return new TD(It).set(new TD(ct)), It;
                }
                function Rr(ct, It) {
                  var Kt = It ? Yn(ct.buffer) : ct.buffer;
                  return new ct.constructor(Kt, ct.byteOffset, ct.byteLength);
                }
                function Ur(ct) {
                  var It = new ct.constructor(ct.source, sr.exec(ct));
                  return It.lastIndex = ct.lastIndex, It;
                }
                function Hr(ct) {
                  return oL ? bd2(oL.call(ct)) : {};
                }
                function si2(ct, It) {
                  var Kt = It ? Yn(ct.buffer) : ct.buffer;
                  return new ct.constructor(Kt, ct.byteOffset, ct.length);
                }
                function _i(ct, It) {
                  if (ct !== It) {
                    var Kt = ct !== Ht, De2 = ct === null, fn = ct === ct, Zn = p_(ct), Or = It !== Ht, ti2 = It === null, Di2 = It === It, Co = p_(It);
                    if (!ti2 && !Co && !Zn && ct > It || Zn && Or && Di2 && !ti2 && !Co || De2 && Or && Di2 || !Kt && Di2 || !fn)
                      return 1;
                    if (!De2 && !Zn && !Co && ct < It || Co && Kt && fn && !De2 && !Zn || ti2 && Kt && fn || !Or && fn || !Di2)
                      return -1;
                  }
                  return 0;
                }
                function Wa2(ct, It, Kt) {
                  for (var De2 = -1, fn = ct.criteria, Zn = It.criteria, Or = fn.length, ti2 = Kt.length; ++De2 < Or; ) {
                    var Di2 = _i(fn[De2], Zn[De2]);
                    if (Di2) {
                      if (De2 >= ti2)
                        return Di2;
                      var Co = Kt[De2];
                      return Di2 * (Co == "desc" ? -1 : 1);
                    }
                  }
                  return ct.index - It.index;
                }
                function Ia2(ct, It, Kt, De2) {
                  for (var fn = -1, Zn = ct.length, Or = Kt.length, ti2 = -1, Di2 = It.length, Co = R0(Zn - Or, 0), Eo = ya2(Di2 + Co), Yo = !De2; ++ti2 < Di2; )
                    Eo[ti2] = It[ti2];
                  for (; ++fn < Or; )
                    (Yo || fn < Zn) && (Eo[Kt[fn]] = ct[fn]);
                  for (; Co--; )
                    Eo[ti2++] = ct[fn++];
                  return Eo;
                }
                function ts(ct, It, Kt, De2) {
                  for (var fn = -1, Zn = ct.length, Or = -1, ti2 = Kt.length, Di2 = -1, Co = It.length, Eo = R0(Zn - ti2, 0), Yo = ya2(Eo + Co), Ds = !De2; ++fn < Eo; )
                    Yo[fn] = ct[fn];
                  for (var Hl = fn; ++Di2 < Co; )
                    Yo[Hl + Di2] = It[Di2];
                  for (; ++Or < ti2; )
                    (Ds || fn < Zn) && (Yo[Hl + Kt[Or]] = ct[fn++]);
                  return Yo;
                }
                function on(ct, It) {
                  var Kt = -1, De2 = ct.length;
                  for (It || (It = ya2(De2)); ++Kt < De2; )
                    It[Kt] = ct[Kt];
                  return It;
                }
                function di2(ct, It, Kt, De2) {
                  var fn = !Kt;
                  Kt || (Kt = {});
                  for (var Zn = -1, Or = It.length; ++Zn < Or; ) {
                    var ti2 = It[Zn], Di2 = De2 ? De2(Kt[ti2], ct[ti2], ti2, Kt, ct) : Ht;
                    Di2 === Ht && (Di2 = ct[ti2]), fn ? E2(Kt, ti2, Di2) : gm(Kt, ti2, Di2);
                  }
                  return Kt;
                }
                function Yi2(ct, It) {
                  return di2(ct, Os(ct), It);
                }
                function Oa2(ct, It) {
                  return di2(ct, Kl(ct), It);
                }
                function Da2(ct, It) {
                  return function(Kt, De2) {
                    var fn = Bo(Kt) ? wht : hJ, Zn = It ? It() : {};
                    return fn(Kt, ct, _u(De2, 2), Zn);
                  };
                }
                function Fi2(ct) {
                  return an(function(It, Kt) {
                    var De2 = -1, fn = Kt.length, Zn = fn > 1 ? Kt[fn - 1] : Ht, Or = fn > 2 ? Kt[2] : Ht;
                    for (Zn = ct.length > 3 && typeof Zn == "function" ? (fn--, Zn) : Ht, Or && Hd2(Kt[0], Kt[1], Or) && (Zn = fn < 3 ? Ht : Zn, fn = 1), It = bd2(It); ++De2 < fn; ) {
                      var ti2 = Kt[De2];
                      ti2 && ct(It, ti2, De2, Zn);
                    }
                    return It;
                  });
                }
                function Qi2(ct, It) {
                  return function(Kt, De2) {
                    if (Kt == null)
                      return Kt;
                    if (!cf2(Kt))
                      return ct(Kt, De2);
                    for (var fn = Kt.length, Zn = It ? fn : -1, Or = bd2(Kt); (It ? Zn-- : ++Zn < fn) && De2(Or[Zn], Zn, Or) !== false; )
                      ;
                    return Kt;
                  };
                }
                function ro(ct) {
                  return function(It, Kt, De2) {
                    for (var fn = -1, Zn = bd2(It), Or = De2(It), ti2 = Or.length; ti2--; ) {
                      var Di2 = Or[ct ? ti2 : ++fn];
                      if (Kt(Zn[Di2], Di2, Zn) === false)
                        break;
                    }
                    return It;
                  };
                }
                function Wo(ct, It, Kt) {
                  var De2 = It & oi2, fn = yl(ct);
                  function Zn() {
                    var Or = this && this !== qv && this instanceof Zn ? fn : ct;
                    return Or.apply(De2 ? Kt : this, arguments);
                  }
                  return Zn;
                }
                function Ii2(ct) {
                  return function(It) {
                    It = Pd2(It);
                    var Kt = sy(It) ? n1(It) : Ht, De2 = Kt ? Kt[0] : It.charAt(0), fn = Kt ? nn(Kt, 1).join("") : It.slice(1);
                    return De2[ct]() + fn;
                  };
                }
                function _l(ct) {
                  return function(It) {
                    return B9(tIt(ZAt(It).replace(mG, "")), ct, "");
                  };
                }
                function yl(ct) {
                  return function() {
                    var It = arguments;
                    switch (It.length) {
                      case 0:
                        return new ct();
                      case 1:
                        return new ct(It[0]);
                      case 2:
                        return new ct(It[0], It[1]);
                      case 3:
                        return new ct(It[0], It[1], It[2]);
                      case 4:
                        return new ct(It[0], It[1], It[2], It[3]);
                      case 5:
                        return new ct(It[0], It[1], It[2], It[3], It[4]);
                      case 6:
                        return new ct(It[0], It[1], It[2], It[3], It[4], It[5]);
                      case 7:
                        return new ct(It[0], It[1], It[2], It[3], It[4], It[5], It[6]);
                    }
                    var Kt = sL(ct.prototype), De2 = ct.apply(Kt, It);
                    return ov(De2) ? De2 : Kt;
                  };
                }
                function Ra2(ct, It, Kt) {
                  var De2 = yl(ct);
                  function fn() {
                    for (var Zn = arguments.length, Or = ya2(Zn), ti2 = Zn, Di2 = Vg2(fn); ti2--; )
                      Or[ti2] = arguments[ti2];
                    var Co = Zn < 3 && Or[0] !== Di2 && Or[Zn - 1] !== Di2 ? [] : CD(Or, Di2);
                    if (Zn -= Co.length, Zn < Kt)
                      return Gd2(ct, It, ha2, fn.placeholder, Ht, Or, Co, Ht, Ht, Kt - Zn);
                    var Eo = this && this !== qv && this instanceof fn ? De2 : ct;
                    return Px(Eo, this, Or);
                  }
                  return fn;
                }
                function Su(ct) {
                  return function(It, Kt, De2) {
                    var fn = bd2(It);
                    if (!cf2(It)) {
                      var Zn = _u(Kt, 3);
                      It = qu(It), Kt = function(ti2) {
                        return Zn(fn[ti2], ti2, fn);
                      };
                    }
                    var Or = ct(It, Kt, De2);
                    return Or > -1 ? fn[Zn ? It[Or] : Or] : Ht;
                  };
                }
                function Ga2(ct) {
                  return ib2(function(It) {
                    var Kt = It.length, De2 = Kt, fn = Lx.prototype.thru;
                    for (ct && It.reverse(); De2--; ) {
                      var Zn = It[De2];
                      if (typeof Zn != "function")
                        throw new s_(Ne2);
                      if (fn && !Or && fy(Zn) == "wrapper")
                        var Or = new Lx([], true);
                    }
                    for (De2 = Or ? De2 : Kt; ++De2 < Kt; ) {
                      Zn = It[De2];
                      var ti2 = fy(Zn), Di2 = ti2 == "wrapper" ? d0(Zn) : Ht;
                      Di2 && hy(Di2[0]) && Di2[1] == (La2 | Go | Ei2 | Aa2) && !Di2[4].length && Di2[9] == 1 ? Or = Or[fy(Di2[0])].apply(Or, Di2[3]) : Or = Zn.length == 1 && hy(Zn) ? Or[ti2]() : Or.thru(Zn);
                    }
                    return function() {
                      var Co = arguments, Eo = Co[0];
                      if (Or && Co.length == 1 && Bo(Eo))
                        return Or.plant(Eo).value();
                      for (var Yo = 0, Ds = Kt ? It[Yo].apply(this, Co) : Eo; ++Yo < Kt; )
                        Ds = It[Yo].call(this, Ds);
                      return Ds;
                    };
                  });
                }
                function ha2(ct, It, Kt, De2, fn, Zn, Or, ti2, Di2, Co) {
                  var Eo = It & La2, Yo = It & oi2, Ds = It & Va2, Hl = It & (Go | un), ic2 = It & Oi2, qf2 = Ds ? Ht : yl(ct);
                  function Zu() {
                    for (var Vh2 = arguments.length, ap = ya2(Vh2), dS = Vh2; dS--; )
                      ap[dS] = arguments[dS];
                    if (Hl)
                      var cb2 = Vg2(Zu), zx = Kk(ap, cb2);
                    if (De2 && (ap = Ia2(ap, De2, fn, Hl)), Zn && (ap = ts(ap, Zn, Or, Hl)), Vh2 -= zx, Hl && Vh2 < Co) {
                      var ig2 = CD(ap, cb2);
                      return Gd2(ct, It, ha2, Zu.placeholder, Kt, ap, ig2, ti2, Di2, Co - Vh2);
                    }
                    var RT = Yo ? Kt : this, d_ = Ds ? RT[ct] : ct;
                    return Vh2 = ap.length, ti2 ? ap = Xht(ap, ti2) : ic2 && Vh2 > 1 && ap.reverse(), Eo && Di2 < Vh2 && (ap.length = Di2), this && this !== qv && this instanceof Zu && (d_ = qf2 || yl(d_)), d_.apply(RT, ap);
                  }
                  return Zu;
                }
                function pa2(ct, It) {
                  return function(Kt, De2) {
                    return Zht(Kt, ct, It(De2), {});
                  };
                }
                function hs(ct, It) {
                  return function(Kt, De2) {
                    var fn;
                    if (Kt === Ht && De2 === Ht)
                      return It;
                    if (Kt !== Ht && (fn = Kt), De2 !== Ht) {
                      if (fn === Ht)
                        return De2;
                      typeof Kt == "string" || typeof De2 == "string" ? (Kt = nc2(Kt), De2 = nc2(De2)) : (Kt = Uu(Kt), De2 = Uu(De2)), fn = ct(Kt, De2);
                    }
                    return fn;
                  };
                }
                function Zo(ct) {
                  return ib2(function(It) {
                    return It = Xc2(It, dm(_u())), an(function(Kt) {
                      var De2 = this;
                      return ct(It, function(fn) {
                        return Px(fn, De2, Kt);
                      });
                    });
                  });
                }
                function rc2(ct, It) {
                  It = It === Ht ? " " : nc2(It);
                  var Kt = It.length;
                  if (Kt < 2)
                    return Kt ? Ae2(It, ct) : It;
                  var De2 = Ae2(It, Hc2(ct / Pf2(It)));
                  return sy(It) ? nn(n1(De2), 0, ct).join("") : De2.slice(0, ct);
                }
                function ep(ct, It, Kt, De2) {
                  var fn = It & oi2, Zn = yl(ct);
                  function Or() {
                    for (var ti2 = -1, Di2 = arguments.length, Co = -1, Eo = De2.length, Yo = ya2(Eo + Di2), Ds = this && this !== qv && this instanceof Or ? Zn : ct; ++Co < Eo; )
                      Yo[Co] = De2[Co];
                    for (; Di2--; )
                      Yo[Co++] = arguments[++ti2];
                    return Px(Ds, fn ? Kt : this, Yo);
                  }
                  return Or;
                }
                function mh2(ct) {
                  return function(It, Kt, De2) {
                    return De2 && typeof De2 != "number" && Hd2(It, Kt, De2) && (Kt = De2 = Ht), It = LD(It), Kt === Ht ? (Kt = It, It = 0) : Kt = LD(Kt), De2 = De2 === Ht ? It < Kt ? 1 : -1 : LD(De2), Qt(It, Kt, De2, ct);
                  };
                }
                function Cf2(ct) {
                  return function(It, Kt) {
                    return typeof It == "string" && typeof Kt == "string" || (It = kd2(It), Kt = kd2(Kt)), ct(It, Kt);
                  };
                }
                function Gd2(ct, It, Kt, De2, fn, Zn, Or, ti2, Di2, Co) {
                  var Eo = It & Go, Yo = Eo ? Or : Ht, Ds = Eo ? Ht : Or, Hl = Eo ? Zn : Ht, ic2 = Eo ? Ht : Zn;
                  It |= Eo ? Ei2 : Wi2, It &= ~(Eo ? Wi2 : Ei2), It & Ca2 || (It &= ~(oi2 | Va2));
                  var qf2 = [ct, It, fn, Hl, Yo, ic2, Ds, ti2, Di2, Co], Zu = Kt.apply(Ht, qf2);
                  return hy(ct) && b62(Zu, qf2), Zu.placeholder = De2, On(Zu, ct, It);
                }
                function bh2(ct) {
                  var It = ly[ct];
                  return function(Kt, De2) {
                    if (Kt = kd2(Kt), De2 = De2 == null ? 0 : cy(Uf2(De2), 292), De2 && nJ(Kt)) {
                      var fn = (Pd2(Kt) + "e").split("e"), Zn = It(fn[0] + "e" + (+fn[1] + De2));
                      return fn = (Pd2(Zn) + "e").split("e"), +(fn[0] + "e" + (+fn[1] - De2));
                    }
                    return It(Kt);
                  };
                }
                var Gp = Qk && 1 / H9(new Qk([, -0]))[1] == gu ? function(ct) {
                  return new Qk(ct);
                } : E6;
                function $v(ct) {
                  return function(It) {
                    var Kt = Iu(It);
                    return Kt == Gv ? DG(It) : Kt == Dv ? Aht(It) : i6(It, ct(It));
                  };
                }
                function B0(ct, It, Kt, De2, fn, Zn, Or, ti2) {
                  var Di2 = It & Va2;
                  if (!Di2 && typeof ct != "function")
                    throw new s_(Ne2);
                  var Co = De2 ? De2.length : 0;
                  if (Co || (It &= ~(Ei2 | Wi2), De2 = fn = Ht), Or = Or === Ht ? Or : R0(Uf2(Or), 0), ti2 = ti2 === Ht ? ti2 : Uf2(ti2), Co -= fn ? fn.length : 0, It & Wi2) {
                    var Eo = De2, Yo = fn;
                    De2 = fn = Ht;
                  }
                  var Ds = Di2 ? Ht : d0(ct), Hl = [ct, It, Kt, De2, fn, Eo, Yo, Zn, Or, ti2];
                  if (Ds && o5(Hl, Ds), ct = Hl[0], It = Hl[1], Kt = Hl[2], De2 = Hl[3], fn = Hl[4], ti2 = Hl[9] = Hl[9] === Ht ? Di2 ? 0 : ct.length : R0(Hl[9] - Co, 0), !ti2 && It & (Go | un) && (It &= ~(Go | un)), !It || It == oi2)
                    var ic2 = Wo(ct, It, Kt);
                  else
                    It == Go || It == un ? ic2 = Ra2(ct, It, ti2) : (It == Ei2 || It == (oi2 | Ei2)) && !fn.length ? ic2 = ep(ct, It, Kt, De2) : ic2 = ha2.apply(Ht, Hl);
                  var qf2 = Ds ? Ai2 : b62;
                  return On(qf2(ic2, Hl), ct, It);
                }
                function uS(ct, It, Kt, De2) {
                  return ct === Ht || h_(ct, Wd2[Kt]) && !sd2.call(De2, Kt) ? It : ct;
                }
                function FM(ct, It, Kt, De2, fn, Zn) {
                  return ov(ct) && ov(It) && (Zn.set(It, ct), r7(ct, It, Ht, FM, Zn), Zn.delete(It)), ct;
                }
                function Ry(ct) {
                  return h7(ct) ? Ht : ct;
                }
                function Rx(ct, It, Kt, De2, fn, Zn) {
                  var Or = Kt & Gr, ti2 = ct.length, Di2 = It.length;
                  if (ti2 != Di2 && !(Or && Di2 > ti2))
                    return false;
                  var Co = Zn.get(ct), Eo = Zn.get(It);
                  if (Co && Eo)
                    return Co == It && Eo == ct;
                  var Yo = -1, Ds = true, Hl = Kt & ei2 ? new DD() : Ht;
                  for (Zn.set(ct, It), Zn.set(It, ct); ++Yo < ti2; ) {
                    var ic2 = ct[Yo], qf2 = It[Yo];
                    if (De2)
                      var Zu = Or ? De2(qf2, ic2, Yo, It, ct, Zn) : De2(ic2, qf2, Yo, ct, It, Zn);
                    if (Zu !== Ht) {
                      if (Zu)
                        continue;
                      Ds = false;
                      break;
                    }
                    if (Hl) {
                      if (!t6(It, function(Vh2, ap) {
                        if (!MD(Hl, ap) && (ic2 === Vh2 || fn(ic2, Vh2, Kt, De2, Zn)))
                          return Hl.push(ap);
                      })) {
                        Ds = false;
                        break;
                      }
                    } else if (!(ic2 === qf2 || fn(ic2, qf2, Kt, De2, Zn))) {
                      Ds = false;
                      break;
                    }
                  }
                  return Zn.delete(ct), Zn.delete(It), Ds;
                }
                function PT(ct, It, Kt, De2, fn, Zn, Or) {
                  switch (Kt) {
                    case co:
                      if (ct.byteLength != It.byteLength || ct.byteOffset != It.byteOffset)
                        return false;
                      ct = ct.buffer, It = It.buffer;
                    case Xi2:
                      return !(ct.byteLength != It.byteLength || !Zn(new TD(ct), new TD(It)));
                    case Gf2:
                    case hp:
                    case Jm:
                      return h_(+ct, +It);
                    case n_:
                      return ct.name == It.name && ct.message == It.message;
                    case t1:
                    case nv:
                      return ct == It + "";
                    case Gv:
                      var ti2 = DG;
                    case Dv:
                      var Di2 = De2 & Gr;
                      if (ti2 || (ti2 = H9), ct.size != It.size && !Di2)
                        return false;
                      var Co = Or.get(ct);
                      if (Co)
                        return Co == It;
                      De2 |= ei2, Or.set(ct, It);
                      var Eo = Rx(ti2(ct), ti2(It), De2, fn, Zn, Or);
                      return Or.delete(ct), Eo;
                    case Hv:
                      if (oL)
                        return oL.call(ct) == oL.call(It);
                  }
                  return false;
                }
                function u_(ct, It, Kt, De2, fn, Zn) {
                  var Or = Kt & Gr, ti2 = VM(ct), Di2 = ti2.length, Co = VM(It), Eo = Co.length;
                  if (Di2 != Eo && !Or)
                    return false;
                  for (var Yo = Di2; Yo--; ) {
                    var Ds = ti2[Yo];
                    if (!(Or ? Ds in It : sd2.call(It, Ds)))
                      return false;
                  }
                  var Hl = Zn.get(ct), ic2 = Zn.get(It);
                  if (Hl && ic2)
                    return Hl == It && ic2 == ct;
                  var qf2 = true;
                  Zn.set(ct, It), Zn.set(It, ct);
                  for (var Zu = Or; ++Yo < Di2; ) {
                    Ds = ti2[Yo];
                    var Vh2 = ct[Ds], ap = It[Ds];
                    if (De2)
                      var dS = Or ? De2(ap, Vh2, Ds, It, ct, Zn) : De2(Vh2, ap, Ds, ct, It, Zn);
                    if (!(dS === Ht ? Vh2 === ap || fn(Vh2, ap, Kt, De2, Zn) : dS)) {
                      qf2 = false;
                      break;
                    }
                    Zu || (Zu = Ds == "constructor");
                  }
                  if (qf2 && !Zu) {
                    var cb2 = ct.constructor, zx = It.constructor;
                    cb2 != zx && "constructor" in ct && "constructor" in It && !(typeof cb2 == "function" && cb2 instanceof cb2 && typeof zx == "function" && zx instanceof zx) && (qf2 = false);
                  }
                  return Zn.delete(ct), Zn.delete(It), qf2;
                }
                function ib2(ct) {
                  return Dr(wJ(ct, Ht, pL), ct + "");
                }
                function VM(ct) {
                  return HG(ct, qu, Os);
                }
                function cS(ct) {
                  return HG(ct, pS, Kl);
                }
                var d0 = h6 ? function(ct) {
                  return h6.get(ct);
                } : E6;
                function fy(ct) {
                  for (var It = ct.name + "", Kt = aL[It], De2 = sd2.call(aL, It) ? Kt.length : 0; De2--; ) {
                    var fn = Kt[De2], Zn = fn.func;
                    if (Zn == null || Zn == ct)
                      return fn.name;
                  }
                  return It;
                }
                function Vg2(ct) {
                  var It = sd2.call(Sn, "placeholder") ? Sn : ct;
                  return It.placeholder;
                }
                function _u() {
                  var ct = Sn.iteratee || ub2;
                  return ct = ct === ub2 ? mJ : ct, arguments.length ? ct(arguments[0], arguments[1]) : ct;
                }
                function lo(ct, It) {
                  var Kt = ct.__data__;
                  return np(It) ? Kt[typeof It == "string" ? "string" : "hash"] : Kt.map;
                }
                function na2(ct) {
                  for (var It = qu(ct), Kt = It.length; Kt--; ) {
                    var De2 = It[Kt], fn = ct[De2];
                    It[Kt] = [De2, fn, f_(fn)];
                  }
                  return It;
                }
                function $i2(ct, It) {
                  var Kt = AG(ct, It);
                  return i5(Kt) ? Kt : Ht;
                }
                function xo(ct) {
                  var It = sd2.call(ct, Xk), Kt = ct[Xk];
                  try {
                    ct[Xk] = Ht;
                    var De2 = true;
                  } catch {
                  }
                  var fn = U9.call(ct);
                  return De2 && (It ? ct[Xk] = Kt : delete ct[Xk]), fn;
                }
                var Os = l_ ? function(ct) {
                  return ct == null ? [] : (ct = bd2(ct), MT(l_(ct), function(It) {
                    return uy.call(ct, It);
                  }));
                } : Spt, Kl = l_ ? function(ct) {
                  for (var It = []; ct; )
                    oS(It, Os(ct)), ct = s6(ct);
                  return It;
                } : Spt, Iu = V0;
                (c6 && Iu(new c6(new ArrayBuffer(1))) != co || IT && Iu(new IT()) != Gv || eb2 && Iu(eb2.resolve()) != r_ || Qk && Iu(new Qk()) != Dv || iL && Iu(new iL()) != so) && (Iu = function(ct) {
                  var It = V0(ct), Kt = It == ry ? ct.constructor : Ht, De2 = Kt ? ma2(Kt) : "";
                  if (De2)
                    switch (De2) {
                      case N0:
                        return co;
                      case AD:
                        return Gv;
                      case Jk:
                        return r_;
                      case Z9:
                        return Dv;
                      case p6:
                        return so;
                    }
                  return It;
                });
                function Tf2(ct, It, Kt) {
                  for (var De2 = -1, fn = Kt.length; ++De2 < fn; ) {
                    var Zn = Kt[De2], Or = Zn.size;
                    switch (Zn.type) {
                      case "drop":
                        ct += Or;
                        break;
                      case "dropRight":
                        It -= Or;
                        break;
                      case "take":
                        It = cy(It, ct + Or);
                        break;
                      case "takeRight":
                        ct = R0(ct, It - Or);
                        break;
                    }
                  }
                  return { start: ct, end: It };
                }
                function ud2(ct) {
                  var It = ct.match(Q3);
                  return It ? It[1].split(O9) : [];
                }
                function iv(ct, It, Kt) {
                  It = Re2(It, ct);
                  for (var De2 = -1, fn = It.length, Zn = false; ++De2 < fn; ) {
                    var Or = Fa2(It[De2]);
                    if (!(Zn = ct != null && Kt(ct, Or)))
                      break;
                    ct = ct[Or];
                  }
                  return Zn || ++De2 != fn ? Zn : (fn = ct == null ? 0 : ct.length, !!fn && aH(fn) && Ny(Or, fn) && (Bo(ct) || fa2(ct)));
                }
                function Bg2(ct) {
                  var It = ct.length, Kt = new ct.constructor(It);
                  return It && typeof ct[0] == "string" && sd2.call(ct, "index") && (Kt.index = ct.index, Kt.input = ct.input), Kt;
                }
                function z0(ct) {
                  return typeof ct.constructor == "function" && !i1(ct) ? sL(s6(ct)) : {};
                }
                function zg2(ct, It, Kt) {
                  var De2 = ct.constructor;
                  switch (It) {
                    case Xi2:
                      return Yn(ct);
                    case Gf2:
                    case hp:
                      return new De2(+ct);
                    case co:
                      return Rr(ct, Kt);
                    case Es:
                    case Zl:
                    case Yc2:
                    case Kc2:
                    case Dp:
                    case Og2:
                    case tp:
                    case Fh2:
                    case md2:
                      return si2(ct, Kt);
                    case Gv:
                      return new De2();
                    case Jm:
                    case nv:
                      return new De2(ct);
                    case t1:
                      return Ur(ct);
                    case Dv:
                      return new De2();
                    case Hv:
                      return Hr(ct);
                  }
                }
                function c_(ct, It) {
                  var Kt = It.length;
                  if (!Kt)
                    return ct;
                  var De2 = Kt - 1;
                  return It[De2] = (Kt > 1 ? "& " : "") + It[De2], It = It.join(Kt > 2 ? ", " : " "), ct.replace(YR, `{
/* [wrapped with ` + It + `] */
`);
                }
                function Nx(ct) {
                  return Bo(ct) || fa2(ct) || !!(JQ && ct && ct[JQ]);
                }
                function Ny(ct, It) {
                  var Kt = typeof ct;
                  return It = It == null ? Na2 : It, !!It && (Kt == "number" || Kt != "symbol" && li2.test(ct)) && ct > -1 && ct % 1 == 0 && ct < It;
                }
                function Hd2(ct, It, Kt) {
                  if (!ov(Kt))
                    return false;
                  var De2 = typeof It;
                  return (De2 == "number" ? cf2(Kt) && Ny(It, Kt.length) : De2 == "string" && It in Kt) ? h_(Kt[It], ct) : false;
                }
                function Yv(ct, It) {
                  if (Bo(ct))
                    return false;
                  var Kt = typeof ct;
                  return Kt == "number" || Kt == "symbol" || Kt == "boolean" || ct == null || p_(ct) ? true : a_.test(ct) || !Q1.test(ct) || It != null && ct in bd2(It);
                }
                function np(ct) {
                  var It = typeof ct;
                  return It == "string" || It == "number" || It == "symbol" || It == "boolean" ? ct !== "__proto__" : ct === null;
                }
                function hy(ct) {
                  var It = fy(ct), Kt = Sn[It];
                  if (typeof Kt != "function" || !(It in yh2.prototype))
                    return false;
                  if (ct === Kt)
                    return true;
                  var De2 = d0(Kt);
                  return !!De2 && ct === De2[0];
                }
                function ab2(ct) {
                  return !!KQ && KQ in ct;
                }
                var BM = ng2 ? ip : Mpt;
                function i1(ct) {
                  var It = ct && ct.constructor, Kt = typeof It == "function" && It.prototype || Wd2;
                  return ct === Kt;
                }
                function f_(ct) {
                  return ct === ct && !ov(ct);
                }
                function fS(ct, It) {
                  return function(Kt) {
                    return Kt == null ? false : Kt[ct] === It && (It !== Ht || ct in bd2(Kt));
                  };
                }
                function fL(ct) {
                  var It = u5(ct, function(De2) {
                    return Kt.size === pn && Kt.clear(), De2;
                  }), Kt = It.cache;
                  return It;
                }
                function o5(ct, It) {
                  var Kt = ct[1], De2 = It[1], fn = Kt | De2, Zn = fn < (oi2 | Va2 | La2), Or = De2 == La2 && Kt == Go || De2 == La2 && Kt == Aa2 && ct[7].length <= It[8] || De2 == (La2 | Aa2) && It[7].length <= It[8] && Kt == Go;
                  if (!(Zn || Or))
                    return ct;
                  De2 & oi2 && (ct[2] = It[2], fn |= Kt & oi2 ? 0 : Ca2);
                  var ti2 = It[3];
                  if (ti2) {
                    var Di2 = ct[3];
                    ct[3] = Di2 ? Ia2(Di2, ti2, It[4]) : ti2, ct[4] = Di2 ? CD(ct[3], vn) : It[4];
                  }
                  return ti2 = It[5], ti2 && (Di2 = ct[5], ct[5] = Di2 ? ts(Di2, ti2, It[6]) : ti2, ct[6] = Di2 ? CD(ct[5], vn) : It[6]), ti2 = It[7], ti2 && (ct[7] = ti2), De2 & La2 && (ct[8] = ct[8] == null ? It[8] : cy(ct[8], It[8])), ct[9] == null && (ct[9] = It[9]), ct[0] = It[0], ct[1] = fn, ct;
                }
                function Kht(ct) {
                  var It = [];
                  if (ct != null)
                    for (var Kt in bd2(ct))
                      It.push(Kt);
                  return It;
                }
                function hL(ct) {
                  return U9.call(ct);
                }
                function wJ(ct, It, Kt) {
                  return It = R0(It === Ht ? ct.length - 1 : It, 0), function() {
                    for (var De2 = arguments, fn = -1, Zn = R0(De2.length - It, 0), Or = ya2(Zn); ++fn < Zn; )
                      Or[fn] = De2[It + fn];
                    fn = -1;
                    for (var ti2 = ya2(It + 1); ++fn < It; )
                      ti2[fn] = De2[fn];
                    return ti2[It] = Kt(Or), Px(ct, this, ti2);
                  };
                }
                function SJ(ct, It) {
                  return It.length < 2 ? ct : kT(ct, Ao(It, 0, -1));
                }
                function Xht(ct, It) {
                  for (var Kt = ct.length, De2 = cy(It.length, Kt), fn = on(ct); De2--; ) {
                    var Zn = It[De2];
                    ct[De2] = Ny(Zn, Kt) ? fn[Zn] : Ht;
                  }
                  return ct;
                }
                function eH(ct, It) {
                  if (!(It === "constructor" && typeof ct[It] == "function") && It != "__proto__")
                    return ct[It];
                }
                var b62 = ur(Ai2), br = AT || function(ct, It) {
                  return qv.setTimeout(ct, It);
                }, Dr = ur(So);
                function On(ct, It, Kt) {
                  var De2 = It + "";
                  return Dr(ct, c_(De2, Ri2(ud2(De2), Kt)));
                }
                function ur(ct) {
                  var It = 0, Kt = 0;
                  return function() {
                    var De2 = LG(), fn = Si2 - (De2 - Kt);
                    if (Kt = De2, fn > 0) {
                      if (++It >= Fo)
                        return arguments[0];
                    } else
                      It = 0;
                    return ct.apply(Ht, arguments);
                  };
                }
                function gr(ct, It) {
                  var Kt = -1, De2 = ct.length, fn = De2 - 1;
                  for (It = It === Ht ? De2 : It; ++Kt < It; ) {
                    var Zn = xt(Kt, fn), Or = ct[Zn];
                    ct[Zn] = ct[Kt], ct[Kt] = Or;
                  }
                  return ct.length = It, ct;
                }
                var Hi2 = fL(function(ct) {
                  var It = [];
                  return ct.charCodeAt(0) === 46 && It.push(""), ct.replace(mT, function(Kt, De2, fn, Zn) {
                    It.push(fn ? Zn.replace(Mr, "$1") : De2 || Kt);
                  }), It;
                });
                function Fa2(ct) {
                  if (typeof ct == "string" || p_(ct))
                    return ct;
                  var It = ct + "";
                  return It == "0" && 1 / ct == -gu ? "-0" : It;
                }
                function ma2(ct) {
                  if (ct != null) {
                    try {
                      return rg2.call(ct);
                    } catch {
                    }
                    try {
                      return ct + "";
                    } catch {
                    }
                  }
                  return "";
                }
                function Ri2(ct, It) {
                  return J1(vh2, function(Kt) {
                    var De2 = "_." + Kt[0];
                    It & Kt[1] && !tL(ct, De2) && ct.push(De2);
                  }), ct.sort();
                }
                function Ho(ct) {
                  if (ct instanceof yh2)
                    return ct.clone();
                  var It = new Lx(ct.__wrapped__, ct.__chain__);
                  return It.__actions__ = on(ct.__actions__), It.__index__ = ct.__index__, It.__values__ = ct.__values__, It;
                }
                function iu(ct, It, Kt) {
                  (Kt ? Hd2(ct, It, Kt) : It === Ht) ? It = 1 : It = R0(Uf2(It), 0);
                  var De2 = ct == null ? 0 : ct.length;
                  if (!De2 || It < 1)
                    return [];
                  for (var fn = 0, Zn = 0, Or = ya2(Hc2(De2 / It)); fn < De2; )
                    Or[Zn++] = Ao(ct, fn, fn += It);
                  return Or;
                }
                function th2(ct) {
                  for (var It = -1, Kt = ct == null ? 0 : ct.length, De2 = 0, fn = []; ++It < Kt; ) {
                    var Zn = ct[It];
                    Zn && (fn[De2++] = Zn);
                  }
                  return fn;
                }
                function rp() {
                  var ct = arguments.length;
                  if (!ct)
                    return [];
                  for (var It = ya2(ct - 1), Kt = arguments[0], De2 = ct; De2--; )
                    It[De2 - 1] = arguments[De2];
                  return oS(Bo(Kt) ? on(Kt) : [Kt], Oy(It, 1));
                }
                var Dd2 = an(function(ct, It) {
                  return _h(ct) ? e5(ct, Oy(It, 1, _h, true)) : [];
                }), Hf2 = an(function(ct, It) {
                  var Kt = a1(It);
                  return _h(Kt) && (Kt = Ht), _h(ct) ? e5(ct, Oy(It, 1, _h, true), _u(Kt, 2)) : [];
                }), Ed2 = an(function(ct, It) {
                  var Kt = a1(It);
                  return _h(Kt) && (Kt = Ht), _h(ct) ? e5(ct, Oy(It, 1, _h, true), Ht, Kt) : [];
                });
                function Kv(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  return De2 ? (It = Kt || It === Ht ? 1 : Uf2(It), Ao(ct, It < 0 ? 0 : It, De2)) : [];
                }
                function Bc2(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  return De2 ? (It = Kt || It === Ht ? 1 : Uf2(It), It = De2 - It, Ao(ct, 0, It < 0 ? 0 : It)) : [];
                }
                function py(ct, It) {
                  return ct && ct.length ? Vt(ct, _u(It, 3), true, true) : [];
                }
                function Fx(ct, It) {
                  return ct && ct.length ? Vt(ct, _u(It, 3), true) : [];
                }
                function LT(ct, It, Kt, De2) {
                  var fn = ct == null ? 0 : ct.length;
                  return fn ? (Kt && typeof Kt != "number" && Hd2(ct, It, Kt) && (Kt = 0, De2 = fn), WG(ct, It, Kt, De2)) : [];
                }
                function _6(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  if (!De2)
                    return -1;
                  var fn = Kt == null ? 0 : Uf2(Kt);
                  return fn < 0 && (fn = R0(De2 + fn, 0)), W9(ct, _u(It, 3), fn);
                }
                function zM(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  if (!De2)
                    return -1;
                  var fn = De2 - 1;
                  return Kt !== Ht && (fn = Uf2(Kt), fn = Kt < 0 ? R0(De2 + fn, 0) : cy(fn, De2 - 1)), W9(ct, _u(It, 3), fn, true);
                }
                function pL(ct) {
                  var It = ct == null ? 0 : ct.length;
                  return It ? Oy(ct, 1) : [];
                }
                function s5(ct) {
                  var It = ct == null ? 0 : ct.length;
                  return It ? Oy(ct, gu) : [];
                }
                function vm(ct, It) {
                  var Kt = ct == null ? 0 : ct.length;
                  return Kt ? (It = It === Ht ? 1 : Uf2(It), Oy(ct, It)) : [];
                }
                function ED(ct) {
                  for (var It = -1, Kt = ct == null ? 0 : ct.length, De2 = {}; ++It < Kt; ) {
                    var fn = ct[It];
                    De2[fn[0]] = fn[1];
                  }
                  return De2;
                }
                function dL(ct) {
                  return ct && ct.length ? ct[0] : Ht;
                }
                function l5(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  if (!De2)
                    return -1;
                  var fn = Kt == null ? 0 : Uf2(Kt);
                  return fn < 0 && (fn = R0(De2 + fn, 0)), xD(ct, It, fn);
                }
                function x6(ct) {
                  var It = ct == null ? 0 : ct.length;
                  return It ? Ao(ct, 0, -1) : [];
                }
                var w6 = an(function(ct) {
                  var It = Xc2(ct, Yt);
                  return It.length && It[0] === ct[0] ? qG(It) : [];
                }), nH = an(function(ct) {
                  var It = a1(ct), Kt = Xc2(ct, Yt);
                  return It === a1(Kt) ? It = Ht : Kt.pop(), Kt.length && Kt[0] === ct[0] ? qG(Kt, _u(It, 2)) : [];
                }), a7 = an(function(ct) {
                  var It = a1(ct), Kt = Xc2(ct, Yt);
                  return It = typeof It == "function" ? It : Ht, It && Kt.pop(), Kt.length && Kt[0] === ct[0] ? qG(Kt, Ht, It) : [];
                });
                function o7(ct, It) {
                  return ct == null ? "" : ld2.call(ct, It);
                }
                function a1(ct) {
                  var It = ct == null ? 0 : ct.length;
                  return It ? ct[It - 1] : Ht;
                }
                function gL(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  if (!De2)
                    return -1;
                  var fn = De2;
                  return Kt !== Ht && (fn = Uf2(Kt), fn = fn < 0 ? R0(De2 + fn, 0) : cy(fn, De2 - 1)), It === It ? Iht(ct, It, fn) : W9(ct, od2, fn, true);
                }
                function rH(ct, It) {
                  return ct && ct.length ? _J(ct, Uf2(It)) : Ht;
                }
                var Qht = an(MJ);
                function MJ(ct, It) {
                  return ct && ct.length && It && It.length ? i7(ct, It) : ct;
                }
                function s7(ct, It, Kt) {
                  return ct && ct.length && It && It.length ? i7(ct, It, _u(Kt, 2)) : ct;
                }
                function fAt(ct, It, Kt) {
                  return ct && ct.length && It && It.length ? i7(ct, It, Ht, Kt) : ct;
                }
                var hAt = ib2(function(ct, It) {
                  var Kt = ct == null ? 0 : ct.length, De2 = jG(ct, It);
                  return st(ct, Xc2(It, function(fn) {
                    return Ny(fn, Kt) ? +fn : fn;
                  }).sort(_i)), De2;
                });
                function T$t(ct, It) {
                  var Kt = [];
                  if (!(ct && ct.length))
                    return Kt;
                  var De2 = -1, fn = [], Zn = ct.length;
                  for (It = _u(It, 3); ++De2 < Zn; ) {
                    var Or = ct[De2];
                    It(Or, De2, ct) && (Kt.push(Or), fn.push(De2));
                  }
                  return st(ct, fn), Kt;
                }
                function CJ(ct) {
                  return ct == null ? ct : OG.call(ct);
                }
                function pAt(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  return De2 ? (Kt && typeof Kt != "number" && Hd2(ct, It, Kt) ? (It = 0, Kt = De2) : (It = It == null ? 0 : Uf2(It), Kt = Kt === Ht ? De2 : Uf2(Kt)), Ao(ct, It, Kt)) : [];
                }
                function dAt(ct, It) {
                  return Yl(ct, It);
                }
                function gAt(ct, It, Kt) {
                  return Pu(ct, It, _u(Kt, 2));
                }
                function A$t(ct, It) {
                  var Kt = ct == null ? 0 : ct.length;
                  if (Kt) {
                    var De2 = Yl(ct, It);
                    if (De2 < Kt && h_(ct[De2], It))
                      return De2;
                  }
                  return -1;
                }
                function I$t(ct, It) {
                  return Yl(ct, It, true);
                }
                function D$t(ct, It, Kt) {
                  return Pu(ct, It, _u(Kt, 2), true);
                }
                function vAt(ct, It) {
                  var Kt = ct == null ? 0 : ct.length;
                  if (Kt) {
                    var De2 = Yl(ct, It, true) - 1;
                    if (h_(ct[De2], It))
                      return De2;
                  }
                  return -1;
                }
                function E$t(ct) {
                  return ct && ct.length ? Mf2(ct) : [];
                }
                function k$t(ct, It) {
                  return ct && ct.length ? Mf2(ct, _u(It, 2)) : [];
                }
                function P$t(ct) {
                  var It = ct == null ? 0 : ct.length;
                  return It ? Ao(ct, 1, It) : [];
                }
                function L$t(ct, It, Kt) {
                  return ct && ct.length ? (It = Kt || It === Ht ? 1 : Uf2(It), Ao(ct, 0, It < 0 ? 0 : It)) : [];
                }
                function Jht(ct, It, Kt) {
                  var De2 = ct == null ? 0 : ct.length;
                  return De2 ? (It = Kt || It === Ht ? 1 : Uf2(It), It = De2 - It, Ao(ct, It < 0 ? 0 : It, De2)) : [];
                }
                function O$t(ct, It) {
                  return ct && ct.length ? Vt(ct, _u(It, 3), false, true) : [];
                }
                function R$t(ct, It) {
                  return ct && ct.length ? Vt(ct, _u(It, 3)) : [];
                }
                var N$t = an(function(ct) {
                  return lf2(Oy(ct, 1, _h, true));
                }), F$t = an(function(ct) {
                  var It = a1(ct);
                  return _h(It) && (It = Ht), lf2(Oy(ct, 1, _h, true), _u(It, 2));
                }), V$t = an(function(ct) {
                  var It = a1(ct);
                  return It = typeof It == "function" ? It : Ht, lf2(Oy(ct, 1, _h, true), Ht, It);
                });
                function Ev(ct) {
                  return ct && ct.length ? lf2(ct) : [];
                }
                function av(ct, It) {
                  return ct && ct.length ? lf2(ct, _u(It, 2)) : [];
                }
                function B$t(ct, It) {
                  return It = typeof It == "function" ? It : Ht, ct && ct.length ? lf2(ct, Ht, It) : [];
                }
                function tpt(ct) {
                  if (!(ct && ct.length))
                    return [];
                  var It = 0;
                  return ct = MT(ct, function(Kt) {
                    if (_h(Kt))
                      return It = R0(Kt.length, It), true;
                  }), SD(It, function(Kt) {
                    return Xc2(ct, e6(Kt));
                  });
                }
                function yAt(ct, It) {
                  if (!(ct && ct.length))
                    return [];
                  var Kt = tpt(ct);
                  return It == null ? Kt : Xc2(Kt, function(De2) {
                    return Px(It, Ht, De2);
                  });
                }
                var z$t = an(function(ct, It) {
                  return _h(ct) ? e5(ct, It) : [];
                }), j$t = an(function(ct) {
                  return Ut(MT(ct, _h));
                }), W$t = an(function(ct) {
                  var It = a1(ct);
                  return _h(It) && (It = Ht), Ut(MT(ct, _h), _u(It, 2));
                }), mAt = an(function(ct) {
                  var It = a1(ct);
                  return It = typeof It == "function" ? It : Ht, Ut(MT(ct, _h), Ht, It);
                }), G$t = an(tpt);
                function ob2(ct, It) {
                  return $t(ct || [], It || [], gm);
                }
                function ept(ct, It) {
                  return $t(ct || [], It || [], qr);
                }
                var S6 = an(function(ct) {
                  var It = ct.length, Kt = It > 1 ? ct[It - 1] : Ht;
                  return Kt = typeof Kt == "function" ? (ct.pop(), Kt) : Ht, yAt(ct, Kt);
                });
                function npt(ct) {
                  var It = Sn(ct);
                  return It.__chain__ = true, It;
                }
                function rpt(ct, It) {
                  return It(ct), ct;
                }
                function Vx(ct, It) {
                  return It(ct);
                }
                var bAt = ib2(function(ct) {
                  var It = ct.length, Kt = It ? ct[0] : 0, De2 = this.__wrapped__, fn = function(Zn) {
                    return jG(Zn, ct);
                  };
                  return It > 1 || this.__actions__.length || !(De2 instanceof yh2) || !Ny(Kt) ? this.thru(fn) : (De2 = De2.slice(Kt, +Kt + (It ? 1 : 0)), De2.__actions__.push({ func: Vx, args: [fn], thisArg: Ht }), new Lx(De2, this.__chain__).thru(function(Zn) {
                    return It && !Zn.length && Zn.push(Ht), Zn;
                  }));
                });
                function _At() {
                  return npt(this);
                }
                function xAt() {
                  return new Lx(this.value(), this.__chain__);
                }
                function wAt() {
                  this.__values__ === Ht && (this.__values__ = VAt(this.value()));
                  var ct = this.__index__ >= this.__values__.length, It = ct ? Ht : this.__values__[this.__index__++];
                  return { done: ct, value: It };
                }
                function SAt() {
                  return this;
                }
                function MAt(ct) {
                  for (var It, Kt = this; Kt instanceof $9; ) {
                    var De2 = Ho(Kt);
                    De2.__index__ = 0, De2.__values__ = Ht, It ? fn.__wrapped__ = De2 : It = De2;
                    var fn = De2;
                    Kt = Kt.__wrapped__;
                  }
                  return fn.__wrapped__ = ct, It;
                }
                function P22() {
                  var ct = this.__wrapped__;
                  if (ct instanceof yh2) {
                    var It = ct;
                    return this.__actions__.length && (It = new yh2(this)), It = It.reverse(), It.__actions__.push({ func: Vx, args: [CJ], thisArg: Ht }), new Lx(It, this.__chain__);
                  }
                  return this.thru(CJ);
                }
                function H$t() {
                  return ve2(this.__wrapped__, this.__actions__);
                }
                var jM = Da2(function(ct, It, Kt) {
                  sd2.call(ct, Kt) ? ++ct[Kt] : E2(ct, Kt, 1);
                });
                function U$t(ct, It, Kt) {
                  var De2 = Bo(ct) ? WQ : Uht;
                  return Kt && Hd2(ct, It, Kt) && (It = Ht), De2(ct, _u(It, 3));
                }
                function CAt(ct, It) {
                  var Kt = Bo(ct) ? MT : ET;
                  return Kt(ct, _u(It, 3));
                }
                var vL = Su(_6), TJ = Su(zM);
                function ipt(ct, It) {
                  return Oy(iH(ct, It), 1);
                }
                function Xv(ct, It) {
                  return Oy(iH(ct, It), gu);
                }
                function yL(ct, It, Kt) {
                  return Kt = Kt === Ht ? 1 : Uf2(Kt), Oy(iH(ct, It), Kt);
                }
                function AJ(ct, It) {
                  var Kt = Bo(ct) ? J1 : k22;
                  return Kt(ct, _u(It, 3));
                }
                function TAt(ct, It) {
                  var Kt = Bo(ct) ? Sht : uL;
                  return Kt(ct, _u(It, 3));
                }
                var apt = Da2(function(ct, It, Kt) {
                  sd2.call(ct, Kt) ? ct[Kt].push(It) : E2(ct, Kt, [It]);
                });
                function q$t(ct, It, Kt, De2) {
                  ct = cf2(ct) ? ct : _7(ct), Kt = Kt && !De2 ? Uf2(Kt) : 0;
                  var fn = ct.length;
                  return Kt < 0 && (Kt = R0(fn + Kt, 0)), PD(ct) ? Kt <= fn && ct.indexOf(It, Kt) > -1 : !!fn && xD(ct, It, Kt) > -1;
                }
                var Z$t = an(function(ct, It, Kt) {
                  var De2 = -1, fn = typeof It == "function", Zn = cf2(ct) ? ya2(ct.length) : [];
                  return k22(ct, function(Or) {
                    Zn[++De2] = fn ? Px(It, Or, Kt) : n5(Or, It, Kt);
                  }), Zn;
                }), $$t = Da2(function(ct, It, Kt) {
                  E2(ct, Kt, It);
                });
                function iH(ct, It) {
                  var Kt = Bo(ct) ? Xc2 : bJ;
                  return Kt(ct, _u(It, 3));
                }
                function IJ(ct, It, Kt, De2) {
                  return ct == null ? [] : (Bo(It) || (It = It == null ? [] : [It]), Kt = De2 ? Ht : Kt, Bo(Kt) || (Kt = Kt == null ? [] : [Kt]), tH(ct, It, Kt));
                }
                var l7 = Da2(function(ct, It, Kt) {
                  ct[Kt ? 0 : 1].push(It);
                }, function() {
                  return [[], []];
                });
                function Y$t(ct, It, Kt) {
                  var De2 = Bo(ct) ? B9 : n6, fn = arguments.length < 3;
                  return De2(ct, _u(It, 4), Kt, fn, k22);
                }
                function AAt(ct, It, Kt) {
                  var De2 = Bo(ct) ? _D : n6, fn = arguments.length < 3;
                  return De2(ct, _u(It, 4), Kt, fn, uL);
                }
                function IAt(ct, It) {
                  var Kt = Bo(ct) ? MT : ET;
                  return Kt(ct, kJ(_u(It, 3)));
                }
                function opt(ct) {
                  var It = Bo(ct) ? cJ : Un;
                  return It(ct);
                }
                function spt(ct, It, Kt) {
                  (Kt ? Hd2(ct, It, Kt) : It === Ht) ? It = 1 : It = Uf2(It);
                  var De2 = Bo(ct) ? fJ : Br;
                  return De2(ct, It);
                }
                function DAt(ct) {
                  var It = Bo(ct) ? Wht : Mo;
                  return It(ct);
                }
                function K$t(ct) {
                  if (ct == null)
                    return 0;
                  if (cf2(ct))
                    return PD(ct) ? Pf2(ct) : ct.length;
                  var It = Iu(ct);
                  return It == Gv || It == Dv ? ct.size : n7(ct).length;
                }
                function lpt(ct, It, Kt) {
                  var De2 = Bo(ct) ? t6 : Xs;
                  return Kt && Hd2(ct, It, Kt) && (It = Ht), De2(ct, _u(It, 3));
                }
                var upt = an(function(ct, It) {
                  if (ct == null)
                    return [];
                  var Kt = It.length;
                  return Kt > 1 && Hd2(ct, It[0], It[1]) ? It = [] : Kt > 2 && Hd2(It[0], It[1], It[2]) && (It = [It[0]]), tH(ct, Oy(It, 1), []);
                }), DJ = tJ || function() {
                  return qv.Date.now();
                };
                function EAt(ct, It) {
                  if (typeof It != "function")
                    throw new s_(Ne2);
                  return ct = Uf2(ct), function() {
                    if (--ct < 1)
                      return It.apply(this, arguments);
                  };
                }
                function hS(ct, It, Kt) {
                  return It = Kt ? Ht : It, It = ct && It == null ? ct.length : It, B0(ct, La2, Ht, Ht, Ht, Ht, It);
                }
                function EJ(ct, It) {
                  var Kt;
                  if (typeof It != "function")
                    throw new s_(Ne2);
                  return ct = Uf2(ct), function() {
                    return --ct > 0 && (Kt = It.apply(this, arguments)), ct <= 1 && (It = Ht), Kt;
                  };
                }
                var M6 = an(function(ct, It, Kt) {
                  var De2 = oi2;
                  if (Kt.length) {
                    var fn = CD(Kt, Vg2(M6));
                    De2 |= Ei2;
                  }
                  return B0(ct, De2, It, Kt, fn);
                }), cpt = an(function(ct, It, Kt) {
                  var De2 = oi2 | Va2;
                  if (Kt.length) {
                    var fn = CD(Kt, Vg2(cpt));
                    De2 |= Ei2;
                  }
                  return B0(It, De2, ct, Kt, fn);
                });
                function fpt(ct, It, Kt) {
                  It = Kt ? Ht : It;
                  var De2 = B0(ct, Go, Ht, Ht, Ht, Ht, Ht, It);
                  return De2.placeholder = fpt.placeholder, De2;
                }
                function kAt(ct, It, Kt) {
                  It = Kt ? Ht : It;
                  var De2 = B0(ct, un, Ht, Ht, Ht, Ht, Ht, It);
                  return De2.placeholder = kAt.placeholder, De2;
                }
                function PAt(ct, It, Kt) {
                  var De2, fn, Zn, Or, ti2, Di2, Co = 0, Eo = false, Yo = false, Ds = true;
                  if (typeof ct != "function")
                    throw new s_(Ne2);
                  It = kd2(It) || 0, ov(Kt) && (Eo = !!Kt.leading, Yo = "maxWait" in Kt, Zn = Yo ? R0(kd2(Kt.maxWait) || 0, It) : Zn, Ds = "trailing" in Kt ? !!Kt.trailing : Ds);
                  function Hl(ig2) {
                    var RT = De2, d_ = fn;
                    return De2 = fn = Ht, Co = ig2, Or = ct.apply(d_, RT), Or;
                  }
                  function ic2(ig2) {
                    return Co = ig2, ti2 = br(Vh2, It), Eo ? Hl(ig2) : Or;
                  }
                  function qf2(ig2) {
                    var RT = ig2 - Di2, d_ = ig2 - Co, Ept = It - RT;
                    return Yo ? cy(Ept, Zn - d_) : Ept;
                  }
                  function Zu(ig2) {
                    var RT = ig2 - Di2, d_ = ig2 - Co;
                    return Di2 === Ht || RT >= It || RT < 0 || Yo && d_ >= Zn;
                  }
                  function Vh2() {
                    var ig2 = DJ();
                    if (Zu(ig2))
                      return ap(ig2);
                    ti2 = br(Vh2, qf2(ig2));
                  }
                  function ap(ig2) {
                    return ti2 = Ht, Ds && De2 ? Hl(ig2) : (De2 = fn = Ht, Or);
                  }
                  function dS() {
                    ti2 !== Ht && dn(ti2), Co = 0, De2 = Di2 = fn = ti2 = Ht;
                  }
                  function cb2() {
                    return ti2 === Ht ? Or : ap(DJ());
                  }
                  function zx() {
                    var ig2 = DJ(), RT = Zu(ig2);
                    if (De2 = arguments, fn = this, Di2 = ig2, RT) {
                      if (ti2 === Ht)
                        return ic2(Di2);
                      if (Yo)
                        return dn(ti2), ti2 = br(Vh2, It), Hl(Di2);
                    }
                    return ti2 === Ht && (ti2 = br(Vh2, It)), Or;
                  }
                  return zx.cancel = dS, zx.flush = cb2, zx;
                }
                var X$t = an(function(ct, It) {
                  return v6(ct, 1, It);
                }), Q$t = an(function(ct, It, Kt) {
                  return v6(ct, kd2(It) || 0, Kt);
                });
                function J$t(ct) {
                  return B0(ct, Oi2);
                }
                function u5(ct, It) {
                  if (typeof ct != "function" || It != null && typeof It != "function")
                    throw new s_(Ne2);
                  var Kt = function() {
                    var De2 = arguments, fn = It ? It.apply(this, De2) : De2[0], Zn = Kt.cache;
                    if (Zn.has(fn))
                      return Zn.get(fn);
                    var Or = ct.apply(this, De2);
                    return Kt.cache = Zn.set(fn, Or) || Zn, Or;
                  };
                  return Kt.cache = new (u5.Cache || DT)(), Kt;
                }
                u5.Cache = DT;
                function kJ(ct) {
                  if (typeof ct != "function")
                    throw new s_(Ne2);
                  return function() {
                    var It = arguments;
                    switch (It.length) {
                      case 0:
                        return !ct.call(this);
                      case 1:
                        return !ct.call(this, It[0]);
                      case 2:
                        return !ct.call(this, It[0], It[1]);
                      case 3:
                        return !ct.call(this, It[0], It[1], It[2]);
                    }
                    return !ct.apply(this, It);
                  };
                }
                function tYt(ct) {
                  return EJ(2, ct);
                }
                var hpt = He2(function(ct, It) {
                  It = It.length == 1 && Bo(It[0]) ? Xc2(It[0], dm(_u())) : Xc2(Oy(It, 1), dm(_u()));
                  var Kt = It.length;
                  return an(function(De2) {
                    for (var fn = -1, Zn = cy(De2.length, Kt); ++fn < Zn; )
                      De2[fn] = It[fn].call(this, De2[fn]);
                    return Px(ct, this, De2);
                  });
                }), PJ = an(function(ct, It) {
                  var Kt = CD(It, Vg2(PJ));
                  return B0(ct, Ei2, Ht, It, Kt);
                }), c52 = an(function(ct, It) {
                  var Kt = CD(It, Vg2(c52));
                  return B0(ct, Wi2, Ht, It, Kt);
                }), LJ = ib2(function(ct, It) {
                  return B0(ct, Aa2, Ht, Ht, Ht, It);
                });
                function eYt(ct, It) {
                  if (typeof ct != "function")
                    throw new s_(Ne2);
                  return It = It === Ht ? It : Uf2(It), an(ct, It);
                }
                function nYt(ct, It) {
                  if (typeof ct != "function")
                    throw new s_(Ne2);
                  return It = It == null ? 0 : R0(Uf2(It), 0), an(function(Kt) {
                    var De2 = Kt[It], fn = nn(Kt, 0, It);
                    return De2 && oS(fn, De2), Px(ct, this, fn);
                  });
                }
                function rYt(ct, It, Kt) {
                  var De2 = true, fn = true;
                  if (typeof ct != "function")
                    throw new s_(Ne2);
                  return ov(Kt) && (De2 = "leading" in Kt ? !!Kt.leading : De2, fn = "trailing" in Kt ? !!Kt.trailing : fn), PAt(ct, It, { leading: De2, maxWait: It, trailing: fn });
                }
                function u7(ct) {
                  return hS(ct, 1);
                }
                function OT(ct, It) {
                  return PJ(se2(It), ct);
                }
                function LAt() {
                  if (!arguments.length)
                    return [];
                  var ct = arguments[0];
                  return Bo(ct) ? ct : [ct];
                }
                function iYt(ct) {
                  return lS(ct, Wr);
                }
                function aYt(ct, It) {
                  return It = typeof It == "function" ? It : Ht, lS(ct, Wr, It);
                }
                function oYt(ct) {
                  return lS(ct, Gn | Wr);
                }
                function sYt(ct, It) {
                  return It = typeof It == "function" ? It : Ht, lS(ct, Gn | Wr, It);
                }
                function lYt(ct, It) {
                  return It == null || dJ(ct, It, qu(It));
                }
                function h_(ct, It) {
                  return ct === It || ct !== ct && It !== It;
                }
                var Mi2 = Cf2(UG), uo = Cf2(function(ct, It) {
                  return ct >= It;
                }), fa2 = m6(function() {
                  return arguments;
                }()) ? m6 : function(ct) {
                  return j0(ct) && sd2.call(ct, "callee") && !uy.call(ct, "callee");
                }, Bo = ya2.isArray, uf2 = J3 ? dm(J3) : r52;
                function cf2(ct) {
                  return ct != null && aH(ct.length) && !ip(ct);
                }
                function _h(ct) {
                  return j0(ct) && cf2(ct);
                }
                function jg2(ct) {
                  return ct === true || ct === false || j0(ct) && V0(ct) == Gf2;
                }
                var kD = eJ || Mpt, uYt = zQ ? dm(zQ) : ZG;
                function WM(ct) {
                  return j0(ct) && ct.nodeType === 1 && !h7(ct);
                }
                function OJ(ct) {
                  if (ct == null)
                    return true;
                  if (cf2(ct) && (Bo(ct) || typeof ct == "string" || typeof ct.splice == "function" || kD(ct) || g7(ct) || fa2(ct)))
                    return !ct.length;
                  var It = Iu(ct);
                  if (It == Gv || It == Dv)
                    return !ct.size;
                  if (i1(ct))
                    return !n7(ct).length;
                  for (var Kt in ct)
                    if (sd2.call(ct, Kt))
                      return false;
                  return true;
                }
                function cYt(ct, It) {
                  return NM(ct, It);
                }
                function c7(ct, It, Kt) {
                  Kt = typeof Kt == "function" ? Kt : Ht;
                  var De2 = Kt ? Kt(ct, It) : Ht;
                  return De2 === Ht ? NM(ct, It, Ht, Kt) : !!De2;
                }
                function f7(ct) {
                  if (!j0(ct))
                    return false;
                  var It = V0(ct);
                  return It == n_ || It == Lg2 || typeof ct.message == "string" && typeof ct.name == "string" && !h7(ct);
                }
                function RJ(ct) {
                  return typeof ct == "number" && nJ(ct);
                }
                function ip(ct) {
                  if (!ov(ct))
                    return false;
                  var It = V0(ct);
                  return It == Dx || It == Iv || It == yd2 || It == vu;
                }
                function OAt(ct) {
                  return typeof ct == "number" && ct == Uf2(ct);
                }
                function aH(ct) {
                  return typeof ct == "number" && ct > -1 && ct % 1 == 0 && ct <= Na2;
                }
                function ov(ct) {
                  var It = typeof ct;
                  return ct != null && (It == "object" || It == "function");
                }
                function j0(ct) {
                  return ct != null && typeof ct == "object";
                }
                var RAt = jQ ? dm(jQ) : vJ;
                function fYt(ct, It) {
                  return ct === It || YG(ct, It, na2(It));
                }
                function NJ(ct, It, Kt) {
                  return Kt = typeof Kt == "function" ? Kt : Ht, YG(ct, It, na2(It), Kt);
                }
                function mL(ct) {
                  return ppt(ct) && ct != +ct;
                }
                function FJ(ct) {
                  if (BM(ct))
                    throw new Gc2(oe2);
                  return i5(ct);
                }
                function NAt(ct) {
                  return ct === null;
                }
                function VJ(ct) {
                  return ct == null;
                }
                function ppt(ct) {
                  return typeof ct == "number" || j0(ct) && V0(ct) == Jm;
                }
                function h7(ct) {
                  if (!j0(ct) || V0(ct) != ry)
                    return false;
                  var It = s6(ct);
                  if (It === null)
                    return true;
                  var Kt = sd2.call(It, "constructor") && It.constructor;
                  return typeof Kt == "function" && Kt instanceof Kt && rg2.call(Kt) == Dht;
                }
                var p7 = JR ? dm(JR) : e7;
                function FAt(ct) {
                  return OAt(ct) && ct >= -Na2 && ct <= Na2;
                }
                var d7 = V9 ? dm(V9) : KG;
                function PD(ct) {
                  return typeof ct == "string" || !Bo(ct) && j0(ct) && V0(ct) == nv;
                }
                function p_(ct) {
                  return typeof ct == "symbol" || j0(ct) && V0(ct) == Hv;
                }
                var g7 = SG ? dm(SG) : yJ;
                function hYt(ct) {
                  return ct === Ht;
                }
                function pYt(ct) {
                  return j0(ct) && Iu(ct) == so;
                }
                function BJ(ct) {
                  return j0(ct) && V0(ct) == Bi2;
                }
                var zJ = Cf2(a5), dpt = Cf2(function(ct, It) {
                  return ct <= It;
                });
                function VAt(ct) {
                  if (!ct)
                    return [];
                  if (cf2(ct))
                    return PD(ct) ? n1(ct) : on(ct);
                  if (Lf2 && ct[Lf2])
                    return IG(ct[Lf2]());
                  var It = Iu(ct), Kt = It == Gv ? DG : It == Dv ? H9 : _7;
                  return Kt(ct);
                }
                function LD(ct) {
                  if (!ct)
                    return ct === 0 ? ct : 0;
                  if (ct = kd2(ct), ct === gu || ct === -gu) {
                    var It = ct < 0 ? -1 : 1;
                    return It * ga;
                  }
                  return ct === ct ? ct : 0;
                }
                function Uf2(ct) {
                  var It = LD(ct), Kt = It % 1;
                  return It === It ? Kt ? It - Kt : It : 0;
                }
                function BAt(ct) {
                  return ct ? t5(Uf2(ct), 0, fs) : 0;
                }
                function kd2(ct) {
                  if (typeof ct == "number")
                    return ct;
                  if (p_(ct))
                    return ca2;
                  if (ov(ct)) {
                    var It = typeof ct.valueOf == "function" ? ct.valueOf() : ct;
                    ct = ov(It) ? It + "" : It;
                  }
                  if (typeof ct != "string")
                    return ct === 0 ? ct : +ct;
                  ct = a6(ct);
                  var Kt = ji2.test(ct);
                  return Kt || wa2.test(ct) ? xht(ct.slice(2), Kt ? 2 : 8) : dr.test(ct) ? ca2 : +ct;
                }
                function sb2(ct) {
                  return di2(ct, pS(ct));
                }
                function dYt(ct) {
                  return ct ? t5(Uf2(ct), -Na2, Na2) : ct === 0 ? ct : 0;
                }
                function Pd2(ct) {
                  return ct == null ? "" : nc2(ct);
                }
                var zAt = Fi2(function(ct, It) {
                  if (i1(It) || cf2(It)) {
                    di2(It, qu(It), ct);
                    return;
                  }
                  for (var Kt in It)
                    sd2.call(It, Kt) && gm(ct, Kt, It[Kt]);
                }), jAt = Fi2(function(ct, It) {
                  di2(It, pS(It), ct);
                }), v7 = Fi2(function(ct, It, Kt, De2) {
                  di2(It, pS(It), ct, De2);
                }), oH = Fi2(function(ct, It, Kt, De2) {
                  di2(It, qu(It), ct, De2);
                }), gpt = ib2(jG);
                function y7(ct, It) {
                  var Kt = sL(ct);
                  return It == null ? Kt : pJ(Kt, It);
                }
                var sH = an(function(ct, It) {
                  ct = bd2(ct);
                  var Kt = -1, De2 = It.length, fn = De2 > 2 ? It[2] : Ht;
                  for (fn && Hd2(It[0], It[1], fn) && (De2 = 1); ++Kt < De2; )
                    for (var Zn = It[Kt], Or = pS(Zn), ti2 = -1, Di2 = Or.length; ++ti2 < Di2; ) {
                      var Co = Or[ti2], Eo = ct[Co];
                      (Eo === Ht || h_(Eo, Wd2[Co]) && !sd2.call(ct, Co)) && (ct[Co] = Zn[Co]);
                    }
                  return ct;
                }), lH = an(function(ct) {
                  return ct.push(Ht, FM), Px(GAt, Ht, ct);
                });
                function jJ(ct, It) {
                  return j9(ct, _u(It, 3), Ox);
                }
                function m7(ct, It) {
                  return j9(ct, _u(It, 3), t7);
                }
                function gYt(ct, It) {
                  return ct == null ? ct : GG(ct, _u(It, 3), pS);
                }
                function vYt(ct, It) {
                  return ct == null ? ct : nb2(ct, _u(It, 3), pS);
                }
                function yYt(ct, It) {
                  return ct && Ox(ct, _u(It, 3));
                }
                function mYt(ct, It) {
                  return ct && t7(ct, _u(It, 3));
                }
                function bYt(ct) {
                  return ct == null ? [] : y6(ct, qu(ct));
                }
                function WJ(ct) {
                  return ct == null ? [] : y6(ct, pS(ct));
                }
                function C6(ct, It, Kt) {
                  var De2 = ct == null ? Ht : kT(ct, It);
                  return De2 === Ht ? Kt : De2;
                }
                function WAt(ct, It) {
                  return ct != null && iv(ct, It, ju);
                }
                function Pn(ct, It) {
                  return ct != null && iv(ct, It, gJ);
                }
                var b7 = pa2(function(ct, It, Kt) {
                  It != null && typeof It.toString != "function" && (It = U9.call(It)), ct[It] = Kt;
                }, qM(Bx)), GJ = pa2(function(ct, It, Kt) {
                  It != null && typeof It.toString != "function" && (It = U9.call(It)), sd2.call(ct, It) ? ct[It].push(Kt) : ct[It] = [Kt];
                }, _u), GM = an(n5);
                function qu(ct) {
                  return cf2(ct) ? uJ(ct) : n7(ct);
                }
                function pS(ct) {
                  return cf2(ct) ? uJ(ct, true) : XG(ct);
                }
                function _Yt(ct, It) {
                  var Kt = {};
                  return It = _u(It, 3), Ox(ct, function(De2, fn, Zn) {
                    E2(Kt, It(De2, fn, Zn), De2);
                  }), Kt;
                }
                function xYt(ct, It) {
                  var Kt = {};
                  return It = _u(It, 3), Ox(ct, function(De2, fn, Zn) {
                    E2(Kt, fn, It(De2, fn, Zn));
                  }), Kt;
                }
                var T6 = Fi2(function(ct, It, Kt) {
                  r7(ct, It, Kt);
                }), GAt = Fi2(function(ct, It, Kt, De2) {
                  r7(ct, It, Kt, De2);
                }), wYt = ib2(function(ct, It) {
                  var Kt = {};
                  if (ct == null)
                    return Kt;
                  var De2 = false;
                  It = Xc2(It, function(Zn) {
                    return Zn = Re2(Zn, ct), De2 || (De2 = Zn.length > 1), Zn;
                  }), di2(ct, cS(ct), Kt), De2 && (Kt = lS(Kt, Gn | Lr | Wr, Ry));
                  for (var fn = It.length; fn--; )
                    rb2(Kt, It[fn]);
                  return Kt;
                });
                function SYt(ct, It) {
                  return HAt(ct, kJ(_u(It)));
                }
                var MYt = ib2(function(ct, It) {
                  return ct == null ? {} : cL(ct, It);
                });
                function HAt(ct, It) {
                  if (ct == null)
                    return {};
                  var Kt = Xc2(cS(ct), function(De2) {
                    return [De2];
                  });
                  return It = _u(It), xJ(ct, Kt, function(De2, fn) {
                    return It(De2, fn[0]);
                  });
                }
                function f5(ct, It, Kt) {
                  It = Re2(It, ct);
                  var De2 = -1, fn = It.length;
                  for (fn || (fn = 1, ct = Ht); ++De2 < fn; ) {
                    var Zn = ct == null ? Ht : ct[Fa2(It[De2])];
                    Zn === Ht && (De2 = fn, Zn = Kt), ct = ip(Zn) ? Zn.call(ct) : Zn;
                  }
                  return ct;
                }
                function CYt(ct, It, Kt) {
                  return ct == null ? ct : qr(ct, It, Kt);
                }
                function TYt(ct, It, Kt, De2) {
                  return De2 = typeof De2 == "function" ? De2 : Ht, ct == null ? ct : qr(ct, It, Kt, De2);
                }
                var UAt = $v(qu), qAt = $v(pS);
                function AYt(ct, It, Kt) {
                  var De2 = Bo(ct), fn = De2 || kD(ct) || g7(ct);
                  if (It = _u(It, 4), Kt == null) {
                    var Zn = ct && ct.constructor;
                    fn ? Kt = De2 ? new Zn() : [] : ov(ct) ? Kt = ip(Zn) ? sL(s6(ct)) : {} : Kt = {};
                  }
                  return (fn ? J1 : Ox)(ct, function(Or, ti2, Di2) {
                    return It(Kt, Or, ti2, Di2);
                  }), Kt;
                }
                function h5(ct, It) {
                  return ct == null ? true : rb2(ct, It);
                }
                function IYt(ct, It, Kt) {
                  return ct == null ? ct : r1(ct, It, se2(Kt));
                }
                function DYt(ct, It, Kt, De2) {
                  return De2 = typeof De2 == "function" ? De2 : Ht, ct == null ? ct : r1(ct, It, se2(Kt), De2);
                }
                function _7(ct) {
                  return ct == null ? [] : Yk(ct, qu(ct));
                }
                function EYt(ct) {
                  return ct == null ? [] : Yk(ct, pS(ct));
                }
                function kYt(ct, It, Kt) {
                  return Kt === Ht && (Kt = It, It = Ht), Kt !== Ht && (Kt = kd2(Kt), Kt = Kt === Kt ? Kt : 0), It !== Ht && (It = kd2(It), It = It === It ? It : 0), t5(kd2(ct), It, Kt);
                }
                function A6(ct, It, Kt) {
                  return It = LD(It), Kt === Ht ? (Kt = It, It = 0) : Kt = LD(Kt), ct = kd2(ct), qht(ct, It, Kt);
                }
                function PYt(ct, It, Kt) {
                  if (Kt && typeof Kt != "boolean" && Hd2(ct, It, Kt) && (It = Kt = Ht), Kt === Ht && (typeof It == "boolean" ? (Kt = It, It = Ht) : typeof ct == "boolean" && (Kt = ct, ct = Ht)), ct === Ht && It === Ht ? (ct = 0, It = 1) : (ct = LD(ct), It === Ht ? (It = ct, ct = 0) : It = LD(It)), ct > It) {
                    var De2 = ct;
                    ct = It, It = De2;
                  }
                  if (Kt || ct % 1 || It % 1) {
                    var fn = rL();
                    return cy(ct + fn * (It - ct + FQ("1e-" + ((fn + "").length - 1))), It);
                  }
                  return xt(ct, It);
                }
                var LYt = _l(function(ct, It, Kt) {
                  return It = It.toLowerCase(), ct + (Kt ? HM(It) : It);
                });
                function HM(ct) {
                  return x7(Pd2(ct).toLowerCase());
                }
                function ZAt(ct) {
                  return ct = Pd2(ct), ct && ct.replace(jo, G9).replace(e1, "");
                }
                function OYt(ct, It, Kt) {
                  ct = Pd2(ct), It = nc2(It);
                  var De2 = ct.length;
                  Kt = Kt === Ht ? De2 : t5(Uf2(Kt), 0, De2);
                  var fn = Kt;
                  return Kt -= It.length, Kt >= 0 && ct.slice(Kt, fn) == It;
                }
                function RYt(ct) {
                  return ct = Pd2(ct), ct && O0.test(ct) ? ct.replace(tg2, Cht) : ct;
                }
                function NYt(ct) {
                  return ct = Pd2(ct), ct && $R.test(ct) ? ct.replace(bT, "\\$&") : ct;
                }
                var FYt = _l(function(ct, It, Kt) {
                  return ct + (Kt ? "-" : "") + It.toLowerCase();
                }), $At = _l(function(ct, It, Kt) {
                  return ct + (Kt ? " " : "") + It.toLowerCase();
                }), YAt = Ii2("toLowerCase");
                function VYt(ct, It, Kt) {
                  ct = Pd2(ct), It = Uf2(It);
                  var De2 = It ? Pf2(ct) : 0;
                  if (!It || De2 >= It)
                    return ct;
                  var fn = (It - De2) / 2;
                  return rc2(u6(fn), Kt) + ct + rc2(Hc2(fn), Kt);
                }
                function BYt(ct, It, Kt) {
                  ct = Pd2(ct), It = Uf2(It);
                  var De2 = It ? Pf2(ct) : 0;
                  return It && De2 < It ? ct + rc2(It - De2, Kt) : ct;
                }
                function vpt(ct, It, Kt) {
                  ct = Pd2(ct), It = Uf2(It);
                  var De2 = It ? Pf2(ct) : 0;
                  return It && De2 < It ? rc2(It - De2, Kt) + ct : ct;
                }
                function uH(ct, It, Kt) {
                  return Kt || It == null ? It = 0 : It && (It = +It), Pht(Pd2(ct).replace(_T, ""), It || 0);
                }
                function HJ(ct, It, Kt) {
                  return (Kt ? Hd2(ct, It, Kt) : It === Ht) ? It = 1 : It = Uf2(It), Ae2(Pd2(ct), It);
                }
                function zYt() {
                  var ct = arguments, It = Pd2(ct[0]);
                  return ct.length < 3 ? It : It.replace(ct[1], ct[2]);
                }
                var KAt = _l(function(ct, It, Kt) {
                  return ct + (Kt ? "_" : "") + It.toLowerCase();
                });
                function jYt(ct, It, Kt) {
                  return Kt && typeof Kt != "number" && Hd2(ct, It, Kt) && (It = Kt = Ht), Kt = Kt === Ht ? fs : Kt >>> 0, Kt ? (ct = Pd2(ct), ct && (typeof It == "string" || It != null && !p7(It)) && (It = nc2(It), !It && sy(ct)) ? nn(n1(ct), 0, Kt) : ct.split(It, Kt)) : [];
                }
                var p5 = _l(function(ct, It, Kt) {
                  return ct + (Kt ? " " : "") + x7(It);
                });
                function ypt(ct, It, Kt) {
                  return ct = Pd2(ct), Kt = Kt == null ? 0 : t5(Uf2(Kt), 0, ct.length), It = nc2(It), ct.slice(Kt, Kt + It.length) == It;
                }
                function I6(ct, It, Kt) {
                  var De2 = Sn.templateSettings;
                  Kt && Hd2(ct, It, Kt) && (It = Ht), ct = Pd2(ct), It = v7({}, It, De2, uS);
                  var fn = v7({}, It.imports, De2.imports, uS), Zn = qu(fn), Or = Yk(fn, Zn), ti2, Di2, Co = 0, Eo = It.interpolate || Al, Yo = "__p += '", Ds = kG((It.escape || Al).source + "|" + Eo.source + "|" + (Eo === X1 ? gn : Al).source + "|" + (It.evaluate || Al).source + "|$", "g"), Hl = "//# sourceURL=" + (sd2.call(It, "sourceURL") ? (It.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++bG + "]") + `
`;
                  ct.replace(Ds, function(Zu, Vh2, ap, dS, cb2, zx) {
                    return ap || (ap = dS), Yo += ct.slice(Co, zx).replace(Sf2, Tht), Vh2 && (ti2 = true, Yo += `' +
__e(` + Vh2 + `) +
'`), cb2 && (Di2 = true, Yo += `';
` + cb2 + `;
__p += '`), ap && (Yo += `' +
((__t = (` + ap + `)) == null ? '' : __t) +
'`), Co = zx + Zu.length, Zu;
                  }), Yo += `';
`;
                  var ic2 = sd2.call(It, "variable") && It.variable;
                  if (!ic2)
                    Yo = `with (obj) {
` + Yo + `
}
`;
                  else if (ir.test(ic2))
                    throw new Gc2(Ge2);
                  Yo = (Di2 ? Yo.replace(cm, "") : Yo).replace(fm, "$1").replace(nS, "$1;"), Yo = "function(" + (ic2 || "obj") + `) {
` + (ic2 ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (ti2 ? ", __e = _.escape" : "") + (Di2 ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Yo + `return __p
}`;
                  var qf2 = mpt(function() {
                    return pp(Zn, Hl + "return " + Yo).apply(Ht, Or);
                  });
                  if (qf2.source = Yo, f7(qf2))
                    throw qf2;
                  return qf2;
                }
                function UM(ct) {
                  return Pd2(ct).toLowerCase();
                }
                function WYt(ct) {
                  return Pd2(ct).toUpperCase();
                }
                function XAt(ct, It, Kt) {
                  if (ct = Pd2(ct), ct && (Kt || It === Ht))
                    return a6(ct);
                  if (!ct || !(It = nc2(It)))
                    return ct;
                  var De2 = n1(ct), fn = n1(It), Zn = GQ(De2, fn), Or = o6(De2, fn) + 1;
                  return nn(De2, Zn, Or).join("");
                }
                function QAt(ct, It, Kt) {
                  if (ct = Pd2(ct), ct && (Kt || It === Ht))
                    return ct.slice(0, eg2(ct) + 1);
                  if (!ct || !(It = nc2(It)))
                    return ct;
                  var De2 = n1(ct), fn = o6(De2, n1(It)) + 1;
                  return nn(De2, 0, fn).join("");
                }
                function cH(ct, It, Kt) {
                  if (ct = Pd2(ct), ct && (Kt || It === Ht))
                    return ct.replace(_T, "");
                  if (!ct || !(It = nc2(It)))
                    return ct;
                  var De2 = n1(ct), fn = GQ(De2, n1(It));
                  return nn(De2, fn).join("");
                }
                function bL(ct, It) {
                  var Kt = Zi2, De2 = Ka2;
                  if (ov(It)) {
                    var fn = "separator" in It ? It.separator : fn;
                    Kt = "length" in It ? Uf2(It.length) : Kt, De2 = "omission" in It ? nc2(It.omission) : De2;
                  }
                  ct = Pd2(ct);
                  var Zn = ct.length;
                  if (sy(ct)) {
                    var Or = n1(ct);
                    Zn = Or.length;
                  }
                  if (Kt >= Zn)
                    return ct;
                  var ti2 = Kt - Pf2(De2);
                  if (ti2 < 1)
                    return De2;
                  var Di2 = Or ? nn(Or, 0, ti2).join("") : ct.slice(0, ti2);
                  if (fn === Ht)
                    return Di2 + De2;
                  if (Or && (ti2 += Di2.length - ti2), p7(fn)) {
                    if (ct.slice(ti2).search(fn)) {
                      var Co, Eo = Di2;
                      for (fn.global || (fn = kG(fn.source, Pd2(sr.exec(fn)) + "g")), fn.lastIndex = 0; Co = fn.exec(Eo); )
                        var Yo = Co.index;
                      Di2 = Di2.slice(0, Yo === Ht ? ti2 : Yo);
                    }
                  } else if (ct.indexOf(nc2(fn), ti2) != ti2) {
                    var Ds = Di2.lastIndexOf(fn);
                    Ds > -1 && (Di2 = Di2.slice(0, Ds));
                  }
                  return Di2 + De2;
                }
                function JAt(ct) {
                  return ct = Pd2(ct), ct && Jf2.test(ct) ? ct.replace(K1, tb2) : ct;
                }
                var GYt = _l(function(ct, It, Kt) {
                  return ct + (Kt ? " " : "") + It.toUpperCase();
                }), x7 = Ii2("toUpperCase");
                function tIt(ct, It, Kt) {
                  return ct = Pd2(ct), It = Kt ? Ht : It, It === Ht ? HQ(ct) ? o_(ct) : Mht(ct) : ct.match(It) || [];
                }
                var mpt = an(function(ct, It) {
                  try {
                    return Px(ct, Ht, It);
                  } catch (Kt) {
                    return f7(Kt) ? Kt : new Gc2(Kt);
                  }
                }), lb2 = ib2(function(ct, It) {
                  return J1(It, function(Kt) {
                    Kt = Fa2(Kt), E2(ct, Kt, M6(ct[Kt], ct));
                  }), ct;
                });
                function bpt(ct) {
                  var It = ct == null ? 0 : ct.length, Kt = _u();
                  return ct = It ? Xc2(ct, function(De2) {
                    if (typeof De2[1] != "function")
                      throw new s_(Ne2);
                    return [Kt(De2[0]), De2[1]];
                  }) : [], an(function(De2) {
                    for (var fn = -1; ++fn < It; ) {
                      var Zn = ct[fn];
                      if (Px(Zn[0], this, De2))
                        return Px(Zn[1], this, De2);
                    }
                  });
                }
                function eIt(ct) {
                  return Hht(lS(ct, Gn));
                }
                function qM(ct) {
                  return function() {
                    return ct;
                  };
                }
                function _pt(ct, It) {
                  return ct == null || ct !== ct ? It : ct;
                }
                var UJ = Ga2(), D6 = Ga2(true);
                function Bx(ct) {
                  return ct;
                }
                function ub2(ct) {
                  return mJ(typeof ct == "function" ? ct : lS(ct, Gn));
                }
                function xpt(ct) {
                  return QG(lS(ct, Gn));
                }
                function HYt(ct, It) {
                  return JG(ct, lS(It, Gn));
                }
                var UYt = an(function(ct, It) {
                  return function(Kt) {
                    return n5(Kt, ct, It);
                  };
                }), qYt = an(function(ct, It) {
                  return function(Kt) {
                    return n5(ct, Kt, It);
                  };
                });
                function fH(ct, It, Kt) {
                  var De2 = qu(It), fn = y6(It, De2);
                  Kt == null && !(ov(It) && (fn.length || !De2.length)) && (Kt = It, It = ct, ct = this, fn = y6(It, qu(It)));
                  var Zn = !(ov(Kt) && "chain" in Kt) || !!Kt.chain, Or = ip(ct);
                  return J1(fn, function(ti2) {
                    var Di2 = It[ti2];
                    ct[ti2] = Di2, Or && (ct.prototype[ti2] = function() {
                      var Co = this.__chain__;
                      if (Zn || Co) {
                        var Eo = ct(this.__wrapped__), Yo = Eo.__actions__ = on(this.__actions__);
                        return Yo.push({ func: Di2, args: arguments, thisArg: ct }), Eo.__chain__ = Co, Eo;
                      }
                      return Di2.apply(ct, oS([this.value()], arguments));
                    });
                  }), ct;
                }
                function ZYt() {
                  return qv._ === this && (qv._ = XQ), this;
                }
                function E6() {
                }
                function nIt(ct) {
                  return ct = Uf2(ct), an(function(It) {
                    return _J(It, ct);
                  });
                }
                var $Yt = Zo(Xc2), YYt = Zo(WQ), hH = Zo(t6);
                function rIt(ct) {
                  return Yv(ct) ? e6(Fa2(ct)) : Yht(ct);
                }
                function KYt(ct) {
                  return function(It) {
                    return ct == null ? Ht : kT(ct, It);
                  };
                }
                var wpt = mh2(), iIt = mh2(true);
                function Spt() {
                  return [];
                }
                function Mpt() {
                  return false;
                }
                function XYt() {
                  return {};
                }
                function aIt() {
                  return "";
                }
                function Cpt() {
                  return true;
                }
                function QYt(ct, It) {
                  if (ct = Uf2(ct), ct < 1 || ct > Na2)
                    return [];
                  var Kt = fs, De2 = cy(ct, fs);
                  It = _u(It), ct -= fs;
                  for (var fn = SD(De2, It); ++Kt < ct; )
                    It(Kt);
                  return fn;
                }
                function Tpt(ct) {
                  return Bo(ct) ? Xc2(ct, Fa2) : p_(ct) ? [ct] : on(Hi2(Pd2(ct)));
                }
                function oIt(ct) {
                  var It = ++YQ;
                  return Pd2(ct) + It;
                }
                var sIt = hs(function(ct, It) {
                  return ct + It;
                }, 0), lIt = bh2("ceil"), qJ = hs(function(ct, It) {
                  return ct / It;
                }, 1), JYt = bh2("floor");
                function uIt(ct) {
                  return ct && ct.length ? J9(ct, Bx, UG) : Ht;
                }
                function cIt(ct, It) {
                  return ct && ct.length ? J9(ct, _u(It, 2), UG) : Ht;
                }
                function tKt(ct) {
                  return oy(ct, Bx);
                }
                function fIt(ct, It) {
                  return oy(ct, _u(It, 2));
                }
                function eKt(ct) {
                  return ct && ct.length ? J9(ct, Bx, a5) : Ht;
                }
                function Apt(ct, It) {
                  return ct && ct.length ? J9(ct, _u(It, 2), a5) : Ht;
                }
                var hIt = hs(function(ct, It) {
                  return ct * It;
                }, 1), Ipt = bh2("round"), nKt = hs(function(ct, It) {
                  return ct - It;
                }, 0);
                function Dpt(ct) {
                  return ct && ct.length ? $k(ct, Bx) : 0;
                }
                function xh2(ct, It) {
                  return ct && ct.length ? $k(ct, _u(It, 2)) : 0;
                }
                return Sn.after = EAt, Sn.ary = hS, Sn.assign = zAt, Sn.assignIn = jAt, Sn.assignInWith = v7, Sn.assignWith = oH, Sn.at = gpt, Sn.before = EJ, Sn.bind = M6, Sn.bindAll = lb2, Sn.bindKey = cpt, Sn.castArray = LAt, Sn.chain = npt, Sn.chunk = iu, Sn.compact = th2, Sn.concat = rp, Sn.cond = bpt, Sn.conforms = eIt, Sn.constant = qM, Sn.countBy = jM, Sn.create = y7, Sn.curry = fpt, Sn.curryRight = kAt, Sn.debounce = PAt, Sn.defaults = sH, Sn.defaultsDeep = lH, Sn.defer = X$t, Sn.delay = Q$t, Sn.difference = Dd2, Sn.differenceBy = Hf2, Sn.differenceWith = Ed2, Sn.drop = Kv, Sn.dropRight = Bc2, Sn.dropRightWhile = py, Sn.dropWhile = Fx, Sn.fill = LT, Sn.filter = CAt, Sn.flatMap = ipt, Sn.flatMapDeep = Xv, Sn.flatMapDepth = yL, Sn.flatten = pL, Sn.flattenDeep = s5, Sn.flattenDepth = vm, Sn.flip = J$t, Sn.flow = UJ, Sn.flowRight = D6, Sn.fromPairs = ED, Sn.functions = bYt, Sn.functionsIn = WJ, Sn.groupBy = apt, Sn.initial = x6, Sn.intersection = w6, Sn.intersectionBy = nH, Sn.intersectionWith = a7, Sn.invert = b7, Sn.invertBy = GJ, Sn.invokeMap = Z$t, Sn.iteratee = ub2, Sn.keyBy = $$t, Sn.keys = qu, Sn.keysIn = pS, Sn.map = iH, Sn.mapKeys = _Yt, Sn.mapValues = xYt, Sn.matches = xpt, Sn.matchesProperty = HYt, Sn.memoize = u5, Sn.merge = T6, Sn.mergeWith = GAt, Sn.method = UYt, Sn.methodOf = qYt, Sn.mixin = fH, Sn.negate = kJ, Sn.nthArg = nIt, Sn.omit = wYt, Sn.omitBy = SYt, Sn.once = tYt, Sn.orderBy = IJ, Sn.over = $Yt, Sn.overArgs = hpt, Sn.overEvery = YYt, Sn.overSome = hH, Sn.partial = PJ, Sn.partialRight = c52, Sn.partition = l7, Sn.pick = MYt, Sn.pickBy = HAt, Sn.property = rIt, Sn.propertyOf = KYt, Sn.pull = Qht, Sn.pullAll = MJ, Sn.pullAllBy = s7, Sn.pullAllWith = fAt, Sn.pullAt = hAt, Sn.range = wpt, Sn.rangeRight = iIt, Sn.rearg = LJ, Sn.reject = IAt, Sn.remove = T$t, Sn.rest = eYt, Sn.reverse = CJ, Sn.sampleSize = spt, Sn.set = CYt, Sn.setWith = TYt, Sn.shuffle = DAt, Sn.slice = pAt, Sn.sortBy = upt, Sn.sortedUniq = E$t, Sn.sortedUniqBy = k$t, Sn.split = jYt, Sn.spread = nYt, Sn.tail = P$t, Sn.take = L$t, Sn.takeRight = Jht, Sn.takeRightWhile = O$t, Sn.takeWhile = R$t, Sn.tap = rpt, Sn.throttle = rYt, Sn.thru = Vx, Sn.toArray = VAt, Sn.toPairs = UAt, Sn.toPairsIn = qAt, Sn.toPath = Tpt, Sn.toPlainObject = sb2, Sn.transform = AYt, Sn.unary = u7, Sn.union = N$t, Sn.unionBy = F$t, Sn.unionWith = V$t, Sn.uniq = Ev, Sn.uniqBy = av, Sn.uniqWith = B$t, Sn.unset = h5, Sn.unzip = tpt, Sn.unzipWith = yAt, Sn.update = IYt, Sn.updateWith = DYt, Sn.values = _7, Sn.valuesIn = EYt, Sn.without = z$t, Sn.words = tIt, Sn.wrap = OT, Sn.xor = j$t, Sn.xorBy = W$t, Sn.xorWith = mAt, Sn.zip = G$t, Sn.zipObject = ob2, Sn.zipObjectDeep = ept, Sn.zipWith = S6, Sn.entries = UAt, Sn.entriesIn = qAt, Sn.extend = jAt, Sn.extendWith = v7, fH(Sn, Sn), Sn.add = sIt, Sn.attempt = mpt, Sn.camelCase = LYt, Sn.capitalize = HM, Sn.ceil = lIt, Sn.clamp = kYt, Sn.clone = iYt, Sn.cloneDeep = oYt, Sn.cloneDeepWith = sYt, Sn.cloneWith = aYt, Sn.conformsTo = lYt, Sn.deburr = ZAt, Sn.defaultTo = _pt, Sn.divide = qJ, Sn.endsWith = OYt, Sn.eq = h_, Sn.escape = RYt, Sn.escapeRegExp = NYt, Sn.every = U$t, Sn.find = vL, Sn.findIndex = _6, Sn.findKey = jJ, Sn.findLast = TJ, Sn.findLastIndex = zM, Sn.findLastKey = m7, Sn.floor = JYt, Sn.forEach = AJ, Sn.forEachRight = TAt, Sn.forIn = gYt, Sn.forInRight = vYt, Sn.forOwn = yYt, Sn.forOwnRight = mYt, Sn.get = C6, Sn.gt = Mi2, Sn.gte = uo, Sn.has = WAt, Sn.hasIn = Pn, Sn.head = dL, Sn.identity = Bx, Sn.includes = q$t, Sn.indexOf = l5, Sn.inRange = A6, Sn.invoke = GM, Sn.isArguments = fa2, Sn.isArray = Bo, Sn.isArrayBuffer = uf2, Sn.isArrayLike = cf2, Sn.isArrayLikeObject = _h, Sn.isBoolean = jg2, Sn.isBuffer = kD, Sn.isDate = uYt, Sn.isElement = WM, Sn.isEmpty = OJ, Sn.isEqual = cYt, Sn.isEqualWith = c7, Sn.isError = f7, Sn.isFinite = RJ, Sn.isFunction = ip, Sn.isInteger = OAt, Sn.isLength = aH, Sn.isMap = RAt, Sn.isMatch = fYt, Sn.isMatchWith = NJ, Sn.isNaN = mL, Sn.isNative = FJ, Sn.isNil = VJ, Sn.isNull = NAt, Sn.isNumber = ppt, Sn.isObject = ov, Sn.isObjectLike = j0, Sn.isPlainObject = h7, Sn.isRegExp = p7, Sn.isSafeInteger = FAt, Sn.isSet = d7, Sn.isString = PD, Sn.isSymbol = p_, Sn.isTypedArray = g7, Sn.isUndefined = hYt, Sn.isWeakMap = pYt, Sn.isWeakSet = BJ, Sn.join = o7, Sn.kebabCase = FYt, Sn.last = a1, Sn.lastIndexOf = gL, Sn.lowerCase = $At, Sn.lowerFirst = YAt, Sn.lt = zJ, Sn.lte = dpt, Sn.max = uIt, Sn.maxBy = cIt, Sn.mean = tKt, Sn.meanBy = fIt, Sn.min = eKt, Sn.minBy = Apt, Sn.stubArray = Spt, Sn.stubFalse = Mpt, Sn.stubObject = XYt, Sn.stubString = aIt, Sn.stubTrue = Cpt, Sn.multiply = hIt, Sn.nth = rH, Sn.noConflict = ZYt, Sn.noop = E6, Sn.now = DJ, Sn.pad = VYt, Sn.padEnd = BYt, Sn.padStart = vpt, Sn.parseInt = uH, Sn.random = PYt, Sn.reduce = Y$t, Sn.reduceRight = AAt, Sn.repeat = HJ, Sn.replace = zYt, Sn.result = f5, Sn.round = Ipt, Sn.runInContext = ri2, Sn.sample = opt, Sn.size = K$t, Sn.snakeCase = KAt, Sn.some = lpt, Sn.sortedIndex = dAt, Sn.sortedIndexBy = gAt, Sn.sortedIndexOf = A$t, Sn.sortedLastIndex = I$t, Sn.sortedLastIndexBy = D$t, Sn.sortedLastIndexOf = vAt, Sn.startCase = p5, Sn.startsWith = ypt, Sn.subtract = nKt, Sn.sum = Dpt, Sn.sumBy = xh2, Sn.template = I6, Sn.times = QYt, Sn.toFinite = LD, Sn.toInteger = Uf2, Sn.toLength = BAt, Sn.toLower = UM, Sn.toNumber = kd2, Sn.toSafeInteger = dYt, Sn.toString = Pd2, Sn.toUpper = WYt, Sn.trim = XAt, Sn.trimEnd = QAt, Sn.trimStart = cH, Sn.truncate = bL, Sn.unescape = JAt, Sn.uniqueId = oIt, Sn.upperCase = GYt, Sn.upperFirst = x7, Sn.each = AJ, Sn.eachRight = TAt, Sn.first = dL, fH(Sn, function() {
                  var ct = {};
                  return Ox(Sn, function(It, Kt) {
                    sd2.call(Sn.prototype, Kt) || (ct[Kt] = It);
                  }), ct;
                }(), { chain: false }), Sn.VERSION = qt, J1(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(ct) {
                  Sn[ct].placeholder = Sn;
                }), J1(["drop", "take"], function(ct, It) {
                  yh2.prototype[ct] = function(Kt) {
                    Kt = Kt === Ht ? 1 : R0(Uf2(Kt), 0);
                    var De2 = this.__filtered__ && !It ? new yh2(this) : this.clone();
                    return De2.__filtered__ ? De2.__takeCount__ = cy(Kt, De2.__takeCount__) : De2.__views__.push({ size: cy(Kt, fs), type: ct + (De2.__dir__ < 0 ? "Right" : "") }), De2;
                  }, yh2.prototype[ct + "Right"] = function(Kt) {
                    return this.reverse()[ct](Kt).reverse();
                  };
                }), J1(["filter", "map", "takeWhile"], function(ct, It) {
                  var Kt = It + 1, De2 = Kt == bl || Kt == xa2;
                  yh2.prototype[ct] = function(fn) {
                    var Zn = this.clone();
                    return Zn.__iteratees__.push({ iteratee: _u(fn, 3), type: Kt }), Zn.__filtered__ = Zn.__filtered__ || De2, Zn;
                  };
                }), J1(["head", "last"], function(ct, It) {
                  var Kt = "take" + (It ? "Right" : "");
                  yh2.prototype[ct] = function() {
                    return this[Kt](1).value()[0];
                  };
                }), J1(["initial", "tail"], function(ct, It) {
                  var Kt = "drop" + (It ? "" : "Right");
                  yh2.prototype[ct] = function() {
                    return this.__filtered__ ? new yh2(this) : this[Kt](1);
                  };
                }), yh2.prototype.compact = function() {
                  return this.filter(Bx);
                }, yh2.prototype.find = function(ct) {
                  return this.filter(ct).head();
                }, yh2.prototype.findLast = function(ct) {
                  return this.reverse().find(ct);
                }, yh2.prototype.invokeMap = an(function(ct, It) {
                  return typeof ct == "function" ? new yh2(this) : this.map(function(Kt) {
                    return n5(Kt, ct, It);
                  });
                }), yh2.prototype.reject = function(ct) {
                  return this.filter(kJ(_u(ct)));
                }, yh2.prototype.slice = function(ct, It) {
                  ct = Uf2(ct);
                  var Kt = this;
                  return Kt.__filtered__ && (ct > 0 || It < 0) ? new yh2(Kt) : (ct < 0 ? Kt = Kt.takeRight(-ct) : ct && (Kt = Kt.drop(ct)), It !== Ht && (It = Uf2(It), Kt = It < 0 ? Kt.dropRight(-It) : Kt.take(It - ct)), Kt);
                }, yh2.prototype.takeRightWhile = function(ct) {
                  return this.reverse().takeWhile(ct).reverse();
                }, yh2.prototype.toArray = function() {
                  return this.take(fs);
                }, Ox(yh2.prototype, function(ct, It) {
                  var Kt = /^(?:filter|find|map|reject)|While$/.test(It), De2 = /^(?:head|last)$/.test(It), fn = Sn[De2 ? "take" + (It == "last" ? "Right" : "") : It], Zn = De2 || /^find/.test(It);
                  !fn || (Sn.prototype[It] = function() {
                    var Or = this.__wrapped__, ti2 = De2 ? [1] : arguments, Di2 = Or instanceof yh2, Co = ti2[0], Eo = Di2 || Bo(Or), Yo = function(Vh2) {
                      var ap = fn.apply(Sn, oS([Vh2], ti2));
                      return De2 && Ds ? ap[0] : ap;
                    };
                    Eo && Kt && typeof Co == "function" && Co.length != 1 && (Di2 = Eo = false);
                    var Ds = this.__chain__, Hl = !!this.__actions__.length, ic2 = Zn && !Ds, qf2 = Di2 && !Hl;
                    if (!Zn && Eo) {
                      Or = qf2 ? Or : new yh2(this);
                      var Zu = ct.apply(Or, ti2);
                      return Zu.__actions__.push({ func: Vx, args: [Yo], thisArg: Ht }), new Lx(Zu, Ds);
                    }
                    return ic2 && qf2 ? ct.apply(this, ti2) : (Zu = this.thru(Yo), ic2 ? De2 ? Zu.value()[0] : Zu.value() : Zu);
                  });
                }), J1(["pop", "push", "shift", "sort", "splice", "unshift"], function(ct) {
                  var It = rv[ct], Kt = /^(?:push|sort|unshift)$/.test(ct) ? "tap" : "thru", De2 = /^(?:pop|shift)$/.test(ct);
                  Sn.prototype[ct] = function() {
                    var fn = arguments;
                    if (De2 && !this.__chain__) {
                      var Zn = this.value();
                      return It.apply(Bo(Zn) ? Zn : [], fn);
                    }
                    return this[Kt](function(Or) {
                      return It.apply(Bo(Or) ? Or : [], fn);
                    });
                  };
                }), Ox(yh2.prototype, function(ct, It) {
                  var Kt = Sn[It];
                  if (Kt) {
                    var De2 = Kt.name + "";
                    sd2.call(aL, De2) || (aL[De2] = []), aL[De2].push({ name: It, func: Kt });
                  }
                }), aL[ha2(Ht, Va2).name] = [{ name: "wrapper", func: Ht }], yh2.prototype.clone = Lht, yh2.prototype.reverse = RG, yh2.prototype.value = NG, Sn.prototype.at = bAt, Sn.prototype.chain = _At, Sn.prototype.commit = xAt, Sn.prototype.next = wAt, Sn.prototype.plant = MAt, Sn.prototype.reverse = P22, Sn.prototype.toJSON = Sn.prototype.valueOf = Sn.prototype.value = H$t, Sn.prototype.first = Sn.prototype.head, Lf2 && (Sn.prototype[Lf2] = SAt), Sn;
              }, CT = Wc2();
              bD ? ((bD.exports = CT)._ = CT, F9._ = CT) : qv._ = CT;
            }).call(pt);
          })(Mt, Mt.exports);
          class kt {
            constructor() {
              k2(this, "subscriptions", /* @__PURE__ */ new Map()), k2(this, "emitEffectCache", /* @__PURE__ */ new Map()), k2(this, "useSubscription", (ge2, Ht) => {
                const qt = R6.useRef();
                R6.useEffect(() => {
                  var Zt, oe2;
                  qt.current = Ht;
                  function Ne2(Ve) {
                    qt.current && qt.current(Ve);
                  }
                  const Ge2 = (oe2 = (Zt = this.subscriptions) == null ? void 0 : Zt.get(ge2)) != null ? oe2 : [];
                  return Ge2.push(Ne2), this.subscriptions.set(ge2, Ge2), this.emitEffect(ge2), () => {
                    this.subscriptions.delete(ge2);
                  };
                });
              }), k2(this, "emit", (ge2, ...Ht) => {
                if (typeof ge2 == "string" || typeof ge2 == "number") {
                  const qt = this.subscriptions.get(ge2);
                  qt == null || qt.forEach((Zt) => {
                    Zt == null || Zt({ params: Mt.exports.cloneDeep(Ht), event: ge2 });
                  }), this.emitEffectCache.set(ge2, { params: Mt.exports.cloneDeep(Ht), event: ge2 });
                } else
                  throw new TypeError("event must be string or number !");
              }), k2(this, "emitEffect", (ge2) => {
                const Ht = this.emitEffectCache.get(ge2), qt = this.subscriptions.get(ge2);
                Ht && (qt == null || qt.forEach((Zt) => {
                  Zt == null || Zt(A2({}, Ht));
                }));
              }), k2(this, "removeListener", (ge2) => {
                this.subscriptions.delete(ge2);
              }), k2(this, "clear", () => {
                this.subscriptions.clear();
              }), this.clear();
            }
          }
          const Gt = new kt();
          function Ot(Bt) {
            const ge2 = R6.useRef(), Ht = R6.useMemo(() => Bt != null ? Bt : { global: false }, [Bt]);
            return ge2.current || (ge2.current = Ht.global ? ge2.current = Gt : ge2.current = new kt()), R6.useEffect(() => () => {
              var qt;
              return (qt = ge2.current) == null ? void 0 : qt.clear();
            }, []), ge2.current;
          }
          var ce2 = globalThis && globalThis.__read || function(Bt, ge2) {
            var Ht = typeof Symbol == "function" && Bt[Symbol.iterator];
            if (!Ht)
              return Bt;
            var qt = Ht.call(Bt), Zt, oe2 = [], Ne2;
            try {
              for (; (ge2 === void 0 || ge2-- > 0) && !(Zt = qt.next()).done; )
                oe2.push(Zt.value);
            } catch (Ge2) {
              Ne2 = { error: Ge2 };
            } finally {
              try {
                Zt && !Zt.done && (Ht = qt.return) && Ht.call(qt);
              } finally {
                if (Ne2)
                  throw Ne2.error;
              }
            }
            return oe2;
          };
          function ae2(Bt, ge2) {
            Bt === void 0 && (Bt = false);
            var Ht = ce2(R6.useState(Bt), 2), qt = Ht[0], Zt = Ht[1], oe2 = R6.useMemo(function() {
              var Ne2 = ge2 === void 0 ? !Bt : ge2, Ge2 = function() {
                return Zt(function(Gn) {
                  return Gn === Bt ? Ne2 : Bt;
                });
              }, Ve = function(Gn) {
                return Zt(Gn);
              }, pn = function() {
                return Zt(Bt);
              }, vn = function() {
                return Zt(Ne2);
              };
              return { toggle: Ge2, set: Ve, setLeft: pn, setRight: vn };
            }, []);
            return [qt, oe2];
          }
          var de2 = globalThis && globalThis.__read || function(Bt, ge2) {
            var Ht = typeof Symbol == "function" && Bt[Symbol.iterator];
            if (!Ht)
              return Bt;
            var qt = Ht.call(Bt), Zt, oe2 = [], Ne2;
            try {
              for (; (ge2 === void 0 || ge2-- > 0) && !(Zt = qt.next()).done; )
                oe2.push(Zt.value);
            } catch (Ge2) {
              Ne2 = { error: Ge2 };
            } finally {
              try {
                Zt && !Zt.done && (Ht = qt.return) && Ht.call(qt);
              } finally {
                if (Ne2)
                  throw Ne2.error;
              }
            }
            return oe2;
          };
          function we2(Bt) {
            Bt === void 0 && (Bt = false);
            var ge2 = de2(ae2(Bt), 2), Ht = ge2[0], qt = ge2[1], Zt = qt.toggle, oe2 = qt.set, Ne2 = R6.useMemo(function() {
              var Ge2 = function() {
                return oe2(true);
              }, Ve = function() {
                return oe2(false);
              };
              return { toggle: Zt, set: function(pn) {
                return oe2(!!pn);
              }, setTrue: Ge2, setFalse: Ve };
            }, []);
            return [Ht, Ne2];
          }
          function Se2(Bt) {
            var ge2 = R6.useRef(Bt);
            return ge2.current = Bt, ge2;
          }
          var Oe2 = function(Bt) {
            var ge2 = Se2(Bt);
            R6.useEffect(function() {
              return function() {
                ge2.current();
              };
            }, []);
          }, je2 = Oe2;
          function rn(Bt) {
            var ge2 = typeof Bt;
            return Bt != null && (ge2 == "object" || ge2 == "function");
          }
          var qe2 = rn, An = typeof pt == "object" && pt && pt.Object === Object && pt, jn = An, _n = jn, Jr = typeof self == "object" && self && self.Object === Object && self, Qn = _n || Jr || Function("return this")(), rr = Qn, Ar = rr, fi2 = function() {
            return Ar.Date.now();
          }, mi2 = fi2, Oo = /\s/;
          function Ts(Bt) {
            for (var ge2 = Bt.length; ge2-- && Oo.test(Bt.charAt(ge2)); )
              ;
            return ge2;
          }
          var gl = Ts, nl = gl, rl = /^\s+/;
          function ss(Bt) {
            return Bt && Bt.slice(0, nl(Bt) + 1).replace(rl, "");
          }
          var Us = ss, sl = rr, ws = sl.Symbol, Ll = ws, dh2 = Ll, hu = Object.prototype, Nh2 = hu.hasOwnProperty, cp = hu.toString, Xh2 = dh2 ? dh2.toStringTag : void 0;
          function om(Bt) {
            var ge2 = Nh2.call(Bt, Xh2), Ht = Bt[Xh2];
            try {
              Bt[Xh2] = void 0;
              var qt = true;
            } catch {
            }
            var Zt = cp.call(Bt);
            return qt && (ge2 ? Bt[Xh2] = Ht : delete Bt[Xh2]), Zt;
          }
          var Sv = om, U1 = Object.prototype, Jd2 = U1.toString;
          function jv(Bt) {
            return Jd2.call(Bt);
          }
          var Mv = jv, fT = Ll, yo = Sv, oa2 = Mv, ea2 = "[object Null]", _o = "[object Undefined]", Vs = fT ? fT.toStringTag : void 0;
          function ru(Bt) {
            return Bt == null ? Bt === void 0 ? _o : ea2 : Vs && Vs in Object(Bt) ? yo(Bt) : oa2(Bt);
          }
          var kf2 = ru;
          function wf2(Bt) {
            return Bt != null && typeof Bt == "object";
          }
          var rd2 = wf2, Cv = kf2, kg2 = rd2, ty = "[object Symbol]";
          function Pg2(Bt) {
            return typeof Bt == "symbol" || kg2(Bt) && Cv(Bt) == ty;
          }
          var $b2 = Pg2, Mx = Us, _2 = qe2, Cx = $b2, p0 = 0 / 0, Qh2 = /^[-+]0x[0-9a-f]+$/i, sm = /^0b[01]+$/i, q1 = /^0o[0-7]+$/i, AM = parseInt;
          function Xw(Bt) {
            if (typeof Bt == "number")
              return Bt;
            if (Cx(Bt))
              return p0;
            if (_2(Bt)) {
              var ge2 = typeof Bt.valueOf == "function" ? Bt.valueOf() : Bt;
              Bt = _2(ge2) ? ge2 + "" : ge2;
            }
            if (typeof Bt != "string")
              return Bt === 0 ? Bt : +Bt;
            Bt = Mx(Bt);
            var Ht = sm.test(Bt);
            return Ht || q1.test(Bt) ? AM(Bt.slice(2), Ht ? 2 : 8) : Qh2.test(Bt) ? p0 : +Bt;
          }
          var Tx = Xw, x22 = qe2, cD = mi2, fD = Tx, Dft = "Expected a function", B32 = Math.max, Eft = Math.min;
          function kft(Bt, ge2, Ht) {
            var qt, Zt, oe2, Ne2, Ge2, Ve, pn = 0, vn = false, Gn = false, Lr = true;
            if (typeof Bt != "function")
              throw new TypeError(Dft);
            ge2 = fD(ge2) || 0, x22(Ht) && (vn = !!Ht.leading, Gn = "maxWait" in Ht, oe2 = Gn ? B32(fD(Ht.maxWait) || 0, ge2) : oe2, Lr = "trailing" in Ht ? !!Ht.trailing : Lr);
            function Wr(Wi2) {
              var La2 = qt, Aa2 = Zt;
              return qt = Zt = void 0, pn = Wi2, Ne2 = Bt.apply(Aa2, La2), Ne2;
            }
            function Gr(Wi2) {
              return pn = Wi2, Ge2 = setTimeout(Va2, ge2), vn ? Wr(Wi2) : Ne2;
            }
            function ei2(Wi2) {
              var La2 = Wi2 - Ve, Aa2 = Wi2 - pn, Oi2 = ge2 - La2;
              return Gn ? Eft(Oi2, oe2 - Aa2) : Oi2;
            }
            function oi2(Wi2) {
              var La2 = Wi2 - Ve, Aa2 = Wi2 - pn;
              return Ve === void 0 || La2 >= ge2 || La2 < 0 || Gn && Aa2 >= oe2;
            }
            function Va2() {
              var Wi2 = cD();
              if (oi2(Wi2))
                return Ca2(Wi2);
              Ge2 = setTimeout(Va2, ei2(Wi2));
            }
            function Ca2(Wi2) {
              return Ge2 = void 0, Lr && qt ? Wr(Wi2) : (qt = Zt = void 0, Ne2);
            }
            function Go() {
              Ge2 !== void 0 && clearTimeout(Ge2), pn = 0, qt = Ve = Zt = Ge2 = void 0;
            }
            function un() {
              return Ge2 === void 0 ? Ne2 : Ca2(cD());
            }
            function Ei2() {
              var Wi2 = cD(), La2 = oi2(Wi2);
              if (qt = arguments, Zt = this, Ve = Wi2, La2) {
                if (Ge2 === void 0)
                  return Gr(Ve);
                if (Gn)
                  return clearTimeout(Ge2), Ge2 = setTimeout(Va2, ge2), Wr(Ve);
              }
              return Ge2 === void 0 && (Ge2 = setTimeout(Va2, ge2)), Ne2;
            }
            return Ei2.cancel = Go, Ei2.flush = un, Ei2;
          }
          var Pft = kft, Lft = globalThis && globalThis.__read || function(Bt, ge2) {
            var Ht = typeof Symbol == "function" && Bt[Symbol.iterator];
            if (!Ht)
              return Bt;
            var qt = Ht.call(Bt), Zt, oe2 = [], Ne2;
            try {
              for (; (ge2 === void 0 || ge2-- > 0) && !(Zt = qt.next()).done; )
                oe2.push(Zt.value);
            } catch (Ge2) {
              Ne2 = { error: Ge2 };
            } finally {
              try {
                Zt && !Zt.done && (Ht = qt.return) && Ht.call(qt);
              } finally {
                if (Ne2)
                  throw Ne2.error;
              }
            }
            return oe2;
          }, m9 = globalThis && globalThis.__spread || function() {
            for (var Bt = [], ge2 = 0; ge2 < arguments.length; ge2++)
              Bt = Bt.concat(Lft(arguments[ge2]));
            return Bt;
          };
          function Sr(Bt, ge2) {
            var Ht, qt = Se2(Bt), Zt = (Ht = ge2 == null ? void 0 : ge2.wait) !== null && Ht !== void 0 ? Ht : 1e3, oe2 = R6.useMemo(function() {
              return Pft(function() {
                for (var Ne2 = [], Ge2 = 0; Ge2 < arguments.length; Ge2++)
                  Ne2[Ge2] = arguments[Ge2];
                return qt.current.apply(qt, m9(Ne2));
              }, Zt, ge2);
            }, []);
            return je2(function() {
              oe2.cancel();
            }), { run: oe2, cancel: oe2.cancel, flush: oe2.flush };
          }
          const Ir = ({ id: Bt, title: ge2, chart: Ht, option: qt }, Zt) => {
            const oe2 = R6.useRef(), Ne2 = Ot({ global: true });
            oe2.current = R6.useMemo(() => {
              if (!oe2.current)
                return it;
            }, []);
            const { run: Ge2 } = Sr(() => {
              Bt && Ne2.emit("list");
            }, { wait: 100 });
            return R6.useEffect(() => {
              console.log(Ht == null ? void 0 : Ht.current), oe2.current && (Ht == null ? void 0 : Ht.current) && Bt && qt && (oe2.current.add(Bt, Ht == null ? void 0 : Ht.current, qt, ge2), Ge2());
            }, Zt), { tool: oe2.current };
          };
          var Fn = R6.createContext({}), lr = Fn;
          function er(Bt, ge2, Ht) {
            return ge2 in Bt ? Object.defineProperty(Bt, ge2, { value: Ht, enumerable: true, configurable: true, writable: true }) : Bt[ge2] = Ht, Bt;
          }
          function Gi2(Bt, ge2) {
            var Ht = Object.keys(Bt);
            if (Object.getOwnPropertySymbols) {
              var qt = Object.getOwnPropertySymbols(Bt);
              ge2 && (qt = qt.filter(function(Zt) {
                return Object.getOwnPropertyDescriptor(Bt, Zt).enumerable;
              })), Ht.push.apply(Ht, qt);
            }
            return Ht;
          }
          function zi2(Bt) {
            for (var ge2 = 1; ge2 < arguments.length; ge2++) {
              var Ht = arguments[ge2] != null ? arguments[ge2] : {};
              ge2 % 2 ? Gi2(Object(Ht), true).forEach(function(qt) {
                er(Bt, qt, Ht[qt]);
              }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Bt, Object.getOwnPropertyDescriptors(Ht)) : Gi2(Object(Ht)).forEach(function(qt) {
                Object.defineProperty(Bt, qt, Object.getOwnPropertyDescriptor(Ht, qt));
              });
            }
            return Bt;
          }
          function Ta2(Bt) {
            if (Array.isArray(Bt))
              return Bt;
          }
          function Li2(Bt, ge2) {
            var Ht = Bt == null ? null : typeof Symbol != "undefined" && Bt[Symbol.iterator] || Bt["@@iterator"];
            if (Ht != null) {
              var qt = [], Zt = true, oe2 = false, Ne2, Ge2;
              try {
                for (Ht = Ht.call(Bt); !(Zt = (Ne2 = Ht.next()).done) && (qt.push(Ne2.value), !(ge2 && qt.length === ge2)); Zt = true)
                  ;
              } catch (Ve) {
                oe2 = true, Ge2 = Ve;
              } finally {
                try {
                  !Zt && Ht.return != null && Ht.return();
                } finally {
                  if (oe2)
                    throw Ge2;
                }
              }
              return qt;
            }
          }
          function zo(Bt, ge2) {
            (ge2 == null || ge2 > Bt.length) && (ge2 = Bt.length);
            for (var Ht = 0, qt = new Array(ge2); Ht < ge2; Ht++)
              qt[Ht] = Bt[Ht];
            return qt;
          }
          function ql(Bt, ge2) {
            if (Bt) {
              if (typeof Bt == "string")
                return zo(Bt, ge2);
              var Ht = Object.prototype.toString.call(Bt).slice(8, -1);
              if (Ht === "Object" && Bt.constructor && (Ht = Bt.constructor.name), Ht === "Map" || Ht === "Set")
                return Array.from(Bt);
              if (Ht === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ht))
                return zo(Bt, ge2);
            }
          }
          function jf2() {
            throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          function Ic2(Bt, ge2) {
            return Ta2(Bt) || Li2(Bt, ge2) || ql(Bt, ge2) || jf2();
          }
          function Ad2(Bt, ge2) {
            if (Bt == null)
              return {};
            var Ht = {}, qt = Object.keys(Bt), Zt, oe2;
            for (oe2 = 0; oe2 < qt.length; oe2++)
              Zt = qt[oe2], !(ge2.indexOf(Zt) >= 0) && (Ht[Zt] = Bt[Zt]);
            return Ht;
          }
          function jc2(Bt, ge2) {
            if (Bt == null)
              return {};
            var Ht = Ad2(Bt, ge2), qt, Zt;
            if (Object.getOwnPropertySymbols) {
              var oe2 = Object.getOwnPropertySymbols(Bt);
              for (Zt = 0; Zt < oe2.length; Zt++)
                qt = oe2[Zt], !(ge2.indexOf(qt) >= 0) && (!Object.prototype.propertyIsEnumerable.call(Bt, qt) || (Ht[qt] = Bt[qt]));
            }
            return Ht;
          }
          var dd2 = { exports: {} };
          /*!
            Copyright (c) 2018 Jed Watson.
            Licensed under the MIT License (MIT), see
            http://jedwatson.github.io/classnames
          */
          (function(Bt) {
            (function() {
              var ge2 = {}.hasOwnProperty;
              function Ht() {
                for (var qt = [], Zt = 0; Zt < arguments.length; Zt++) {
                  var oe2 = arguments[Zt];
                  if (oe2) {
                    var Ne2 = typeof oe2;
                    if (Ne2 === "string" || Ne2 === "number")
                      qt.push(oe2);
                    else if (Array.isArray(oe2)) {
                      if (oe2.length) {
                        var Ge2 = Ht.apply(null, oe2);
                        Ge2 && qt.push(Ge2);
                      }
                    } else if (Ne2 === "object")
                      if (oe2.toString === Object.prototype.toString)
                        for (var Ve in oe2)
                          ge2.call(oe2, Ve) && oe2[Ve] && qt.push(Ve);
                      else
                        qt.push(oe2.toString());
                  }
                }
                return qt.join(" ");
              }
              Bt.exports ? (Ht.default = Ht, Bt.exports = Ht) : window.classNames = Ht;
            })();
          })(dd2);
          var Bd2 = dd2.exports;
          function du(Bt) {
            return du = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(ge2) {
              return typeof ge2;
            } : function(ge2) {
              return ge2 && typeof Symbol == "function" && ge2.constructor === Symbol && ge2 !== Symbol.prototype ? "symbol" : typeof ge2;
            }, du(Bt);
          }
          function id2(Bt, ge2) {
            Ax(Bt) && (Bt = "100%");
            var Ht = hT(Bt);
            return Bt = ge2 === 360 ? Bt : Math.min(ge2, Math.max(0, parseFloat(Bt))), Ht && (Bt = parseInt(String(Bt * ge2), 10) / 100), Math.abs(Bt - ge2) < 1e-6 ? 1 : (ge2 === 360 ? Bt = (Bt < 0 ? Bt % ge2 + ge2 : Bt % ge2) / parseFloat(String(ge2)) : Bt = Bt % ge2 / parseFloat(String(ge2)), Bt);
          }
          function Ax(Bt) {
            return typeof Bt == "string" && Bt.indexOf(".") !== -1 && parseFloat(Bt) === 1;
          }
          function hT(Bt) {
            return typeof Bt == "string" && Bt.indexOf("%") !== -1;
          }
          function b9(Bt) {
            return Bt = parseFloat(Bt), (isNaN(Bt) || Bt < 0 || Bt > 1) && (Bt = 1), Bt;
          }
          function Qw(Bt) {
            return Bt <= 1 ? Number(Bt) * 100 + "%" : Bt;
          }
          function Rk(Bt) {
            return Bt.length === 1 ? "0" + Bt : String(Bt);
          }
          function Nk(Bt, ge2, Ht) {
            return { r: id2(Bt, 255) * 255, g: id2(ge2, 255) * 255, b: id2(Ht, 255) * 255 };
          }
          function ey(Bt, ge2, Ht) {
            return Ht < 0 && (Ht += 1), Ht > 1 && (Ht -= 1), Ht < 1 / 6 ? Bt + (ge2 - Bt) * (6 * Ht) : Ht < 1 / 2 ? ge2 : Ht < 2 / 3 ? Bt + (ge2 - Bt) * (2 / 3 - Ht) * 6 : Bt;
          }
          function hD(Bt, ge2, Ht) {
            var qt, Zt, oe2;
            if (Bt = id2(Bt, 360), ge2 = id2(ge2, 100), Ht = id2(Ht, 100), ge2 === 0)
              Zt = Ht, oe2 = Ht, qt = Ht;
            else {
              var Ne2 = Ht < 0.5 ? Ht * (1 + ge2) : Ht + ge2 - Ht * ge2, Ge2 = 2 * Ht - Ne2;
              qt = ey(Ge2, Ne2, Bt + 1 / 3), Zt = ey(Ge2, Ne2, Bt), oe2 = ey(Ge2, Ne2, Bt - 1 / 3);
            }
            return { r: qt * 255, g: Zt * 255, b: oe2 * 255 };
          }
          function LR(Bt, ge2, Ht) {
            Bt = id2(Bt, 255), ge2 = id2(ge2, 255), Ht = id2(Ht, 255);
            var qt = Math.max(Bt, ge2, Ht), Zt = Math.min(Bt, ge2, Ht), oe2 = 0, Ne2 = qt, Ge2 = qt - Zt, Ve = qt === 0 ? 0 : Ge2 / qt;
            if (qt === Zt)
              oe2 = 0;
            else {
              switch (qt) {
                case Bt:
                  oe2 = (ge2 - Ht) / Ge2 + (ge2 < Ht ? 6 : 0);
                  break;
                case ge2:
                  oe2 = (Ht - Bt) / Ge2 + 2;
                  break;
                case Ht:
                  oe2 = (Bt - ge2) / Ge2 + 4;
                  break;
              }
              oe2 /= 6;
            }
            return { h: oe2, s: Ve, v: Ne2 };
          }
          function Fk(Bt, ge2, Ht) {
            Bt = id2(Bt, 360) * 6, ge2 = id2(ge2, 100), Ht = id2(Ht, 100);
            var qt = Math.floor(Bt), Zt = Bt - qt, oe2 = Ht * (1 - ge2), Ne2 = Ht * (1 - Zt * ge2), Ge2 = Ht * (1 - (1 - Zt) * ge2), Ve = qt % 6, pn = [Ht, Ne2, oe2, oe2, Ge2, Ht][Ve], vn = [Ge2, Ht, Ht, Ne2, oe2, oe2][Ve], Gn = [oe2, oe2, Ge2, Ht, Ht, Ne2][Ve];
            return { r: pn * 255, g: vn * 255, b: Gn * 255 };
          }
          function OR(Bt, ge2, Ht, qt) {
            var Zt = [Rk(Math.round(Bt).toString(16)), Rk(Math.round(ge2).toString(16)), Rk(Math.round(Ht).toString(16))];
            return qt && Zt[0].startsWith(Zt[0].charAt(1)) && Zt[1].startsWith(Zt[1].charAt(1)) && Zt[2].startsWith(Zt[2].charAt(1)) ? Zt[0].charAt(0) + Zt[1].charAt(0) + Zt[2].charAt(0) : Zt.join("");
          }
          function z32(Bt) {
            return Z1(Bt) / 255;
          }
          function Z1(Bt) {
            return parseInt(Bt, 16);
          }
          var RR = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
          function pD(Bt) {
            var ge2 = { r: 0, g: 0, b: 0 }, Ht = 1, qt = null, Zt = null, oe2 = null, Ne2 = false, Ge2 = false;
            return typeof Bt == "string" && (Bt = gTt(Bt)), typeof Bt == "object" && (dD(Bt.r) && dD(Bt.g) && dD(Bt.b) ? (ge2 = Nk(Bt.r, Bt.g, Bt.b), Ne2 = true, Ge2 = String(Bt.r).substr(-1) === "%" ? "prgb" : "rgb") : dD(Bt.h) && dD(Bt.s) && dD(Bt.v) ? (qt = Qw(Bt.s), Zt = Qw(Bt.v), ge2 = Fk(Bt.h, qt, Zt), Ne2 = true, Ge2 = "hsv") : dD(Bt.h) && dD(Bt.s) && dD(Bt.l) && (qt = Qw(Bt.s), oe2 = Qw(Bt.l), ge2 = hD(Bt.h, qt, oe2), Ne2 = true, Ge2 = "hsl"), Object.prototype.hasOwnProperty.call(Bt, "a") && (Ht = Bt.a)), Ht = b9(Ht), { ok: Ne2, format: Bt.format || Ge2, r: Math.min(255, Math.max(ge2.r, 0)), g: Math.min(255, Math.max(ge2.g, 0)), b: Math.min(255, Math.max(ge2.b, 0)), a: Ht };
          }
          var NR = "[-\\+]?\\d+%?", j3 = "[-\\+]?\\d*\\.\\d+%?", IM = "(?:" + j3 + ")|(?:" + NR + ")", BW = "[\\s|\\(]+(" + IM + ")[,|\\s]+(" + IM + ")[,|\\s]+(" + IM + ")\\s*\\)?", zW = "[\\s|\\(]+(" + IM + ")[,|\\s]+(" + IM + ")[,|\\s]+(" + IM + ")[,|\\s]+(" + IM + ")\\s*\\)?", Yb2 = { CSS_UNIT: new RegExp(IM), rgb: new RegExp("rgb" + BW), rgba: new RegExp("rgba" + zW), hsl: new RegExp("hsl" + BW), hsla: new RegExp("hsla" + zW), hsv: new RegExp("hsv" + BW), hsva: new RegExp("hsva" + zW), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
          function gTt(Bt) {
            if (Bt = Bt.trim().toLowerCase(), Bt.length === 0)
              return false;
            var ge2 = false;
            if (RR[Bt])
              Bt = RR[Bt], ge2 = true;
            else if (Bt === "transparent")
              return { r: 0, g: 0, b: 0, a: 0, format: "name" };
            var Ht = Yb2.rgb.exec(Bt);
            return Ht ? { r: Ht[1], g: Ht[2], b: Ht[3] } : (Ht = Yb2.rgba.exec(Bt), Ht ? { r: Ht[1], g: Ht[2], b: Ht[3], a: Ht[4] } : (Ht = Yb2.hsl.exec(Bt), Ht ? { h: Ht[1], s: Ht[2], l: Ht[3] } : (Ht = Yb2.hsla.exec(Bt), Ht ? { h: Ht[1], s: Ht[2], l: Ht[3], a: Ht[4] } : (Ht = Yb2.hsv.exec(Bt), Ht ? { h: Ht[1], s: Ht[2], v: Ht[3] } : (Ht = Yb2.hsva.exec(Bt), Ht ? { h: Ht[1], s: Ht[2], v: Ht[3], a: Ht[4] } : (Ht = Yb2.hex8.exec(Bt), Ht ? { r: Z1(Ht[1]), g: Z1(Ht[2]), b: Z1(Ht[3]), a: z32(Ht[4]), format: ge2 ? "name" : "hex8" } : (Ht = Yb2.hex6.exec(Bt), Ht ? { r: Z1(Ht[1]), g: Z1(Ht[2]), b: Z1(Ht[3]), format: ge2 ? "name" : "hex" } : (Ht = Yb2.hex4.exec(Bt), Ht ? { r: Z1(Ht[1] + Ht[1]), g: Z1(Ht[2] + Ht[2]), b: Z1(Ht[3] + Ht[3]), a: z32(Ht[4] + Ht[4]), format: ge2 ? "name" : "hex8" } : (Ht = Yb2.hex3.exec(Bt), Ht ? { r: Z1(Ht[1] + Ht[1]), g: Z1(Ht[2] + Ht[2]), b: Z1(Ht[3] + Ht[3]), format: ge2 ? "name" : "hex" } : false)))))))));
          }
          function dD(Bt) {
            return Boolean(Yb2.CSS_UNIT.exec(String(Bt)));
          }
          var YX = 2, Oft = 0.16, vTt = 0.05, yTt = 0.05, mTt = 0.15, bTt = 5, _Tt = 4, TZt = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
          function Rft(Bt) {
            var ge2 = Bt.r, Ht = Bt.g, qt = Bt.b, Zt = LR(ge2, Ht, qt);
            return { h: Zt.h * 360, s: Zt.s, v: Zt.v };
          }
          function KX(Bt) {
            var ge2 = Bt.r, Ht = Bt.g, qt = Bt.b;
            return "#".concat(OR(ge2, Ht, qt, false));
          }
          function AZt(Bt, ge2, Ht) {
            var qt = Ht / 100, Zt = { r: (ge2.r - Bt.r) * qt + Bt.r, g: (ge2.g - Bt.g) * qt + Bt.g, b: (ge2.b - Bt.b) * qt + Bt.b };
            return Zt;
          }
          function xTt(Bt, ge2, Ht) {
            var qt;
            return Math.round(Bt.h) >= 60 && Math.round(Bt.h) <= 240 ? qt = Ht ? Math.round(Bt.h) - YX * ge2 : Math.round(Bt.h) + YX * ge2 : qt = Ht ? Math.round(Bt.h) + YX * ge2 : Math.round(Bt.h) - YX * ge2, qt < 0 ? qt += 360 : qt >= 360 && (qt -= 360), qt;
          }
          function wTt(Bt, ge2, Ht) {
            if (Bt.h === 0 && Bt.s === 0)
              return Bt.s;
            var qt;
            return Ht ? qt = Bt.s - Oft * ge2 : ge2 === _Tt ? qt = Bt.s + Oft : qt = Bt.s + vTt * ge2, qt > 1 && (qt = 1), Ht && ge2 === bTt && qt > 0.1 && (qt = 0.1), qt < 0.06 && (qt = 0.06), Number(qt.toFixed(2));
          }
          function XX(Bt, ge2, Ht) {
            var qt;
            return Ht ? qt = Bt.v + yTt * ge2 : qt = Bt.v - mTt * ge2, qt > 1 && (qt = 1), Number(qt.toFixed(2));
          }
          function Nft(Bt) {
            for (var ge2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ht = [], qt = pD(Bt), Zt = bTt; Zt > 0; Zt -= 1) {
              var oe2 = Rft(qt), Ne2 = KX(pD({ h: xTt(oe2, Zt, true), s: wTt(oe2, Zt, true), v: XX(oe2, Zt, true) }));
              Ht.push(Ne2);
            }
            Ht.push(KX(qt));
            for (var Ge2 = 1; Ge2 <= _Tt; Ge2 += 1) {
              var Ve = Rft(qt), pn = KX(pD({ h: xTt(Ve, Ge2), s: wTt(Ve, Ge2), v: XX(Ve, Ge2) }));
              Ht.push(pn);
            }
            return ge2.theme === "dark" ? TZt.map(function(vn) {
              var Gn = vn.index, Lr = vn.opacity, Wr = KX(AZt(pD(ge2.backgroundColor || "#141414"), pD(Ht[Gn]), Lr * 100));
              return Wr;
            }) : Ht;
          }
          var Fft = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, Kb2 = {}, Vft = {};
          Object.keys(Fft).forEach(function(Bt) {
            Kb2[Bt] = Nft(Fft[Bt]), Kb2[Bt].primary = Kb2[Bt][5], Vft[Bt] = Nft(Fft[Bt], { theme: "dark", backgroundColor: "#141414" }), Vft[Bt].primary = Vft[Bt][5];
          }), Kb2.red, Kb2.volcano, Kb2.gold, Kb2.orange, Kb2.yellow, Kb2.lime, Kb2.green, Kb2.cyan, Kb2.blue, Kb2.geekblue, Kb2.purple, Kb2.magenta, Kb2.grey;
          var STt = {};
          function Tv(Bt, ge2) {
          }
          function ev(Bt, ge2, Ht) {
            !ge2 && !STt[Ht] && (Bt(false, Ht), STt[Ht] = true);
          }
          function gD(Bt, ge2) {
            ev(Tv, Bt, ge2);
          }
          function MTt() {
            return !!(typeof window != "undefined" && window.document && window.document.createElement);
          }
          var IZt = "rc-util-key";
          function CTt() {
            var Bt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, ge2 = Bt.mark;
            return ge2 ? ge2.startsWith("data-") ? ge2 : "data-".concat(ge2) : IZt;
          }
          function Bft(Bt) {
            if (Bt.attachTo)
              return Bt.attachTo;
            var ge2 = document.querySelector("head");
            return ge2 || document.body;
          }
          function TTt(Bt) {
            var ge2, Ht = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            if (!MTt())
              return null;
            var qt = document.createElement("style");
            if (!((ge2 = Ht.csp) === null || ge2 === void 0) && ge2.nonce) {
              var Zt;
              qt.nonce = (Zt = Ht.csp) === null || Zt === void 0 ? void 0 : Zt.nonce;
            }
            qt.innerHTML = Bt;
            var oe2 = Bft(Ht), Ne2 = oe2.firstChild;
            return Ht.prepend && oe2.prepend ? oe2.prepend(qt) : Ht.prepend && Ne2 ? oe2.insertBefore(qt, Ne2) : oe2.appendChild(qt), qt;
          }
          var QX = /* @__PURE__ */ new Map();
          function DZt(Bt) {
            var ge2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ht = Bft(ge2);
            return Array.from(QX.get(Ht).children).find(function(qt) {
              return qt.tagName === "STYLE" && qt.getAttribute(CTt(ge2)) === Bt;
            });
          }
          function Xm(Bt, ge2) {
            var Ht = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, qt = Bft(Ht);
            if (!QX.has(qt)) {
              var Zt = TTt("", Ht), oe2 = Zt.parentNode;
              QX.set(qt, oe2), oe2.removeChild(Zt);
            }
            var Ne2 = DZt(ge2, Ht);
            if (Ne2) {
              var Ge2, Ve;
              if (((Ge2 = Ht.csp) === null || Ge2 === void 0 ? void 0 : Ge2.nonce) && Ne2.nonce !== ((Ve = Ht.csp) === null || Ve === void 0 ? void 0 : Ve.nonce)) {
                var pn;
                Ne2.nonce = (pn = Ht.csp) === null || pn === void 0 ? void 0 : pn.nonce;
              }
              return Ne2.innerHTML !== Bt && (Ne2.innerHTML = Bt), Ne2;
            }
            var vn = TTt(Bt, Ht);
            return vn.setAttribute(CTt(Ht), ge2), vn;
          }
          function zft(Bt, ge2) {
            gD(Bt, "[@ant-design/icons] ".concat(ge2));
          }
          function W32(Bt) {
            return du(Bt) === "object" && typeof Bt.name == "string" && typeof Bt.theme == "string" && (du(Bt.icon) === "object" || typeof Bt.icon == "function");
          }
          function jft() {
            var Bt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
            return Object.keys(Bt).reduce(function(ge2, Ht) {
              var qt = Bt[Ht];
              switch (Ht) {
                case "class":
                  ge2.className = qt, delete ge2.class;
                  break;
                default:
                  ge2[Ht] = qt;
              }
              return ge2;
            }, {});
          }
          function jW(Bt, ge2, Ht) {
            return Ht ? Z3.default.createElement(Bt.tag, zi2(zi2({ key: ge2 }, jft(Bt.attrs)), Ht), (Bt.children || []).map(function(qt, Zt) {
              return jW(qt, "".concat(ge2, "-").concat(Bt.tag, "-").concat(Zt));
            })) : Z3.default.createElement(Bt.tag, zi2({ key: ge2 }, jft(Bt.attrs)), (Bt.children || []).map(function(qt, Zt) {
              return jW(qt, "".concat(ge2, "-").concat(Bt.tag, "-").concat(Zt));
            }));
          }
          function w22(Bt) {
            return Nft(Bt)[0];
          }
          function Wft(Bt) {
            return Bt ? Array.isArray(Bt) ? Bt : [Bt] : [];
          }
          var ATt = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, ITt = function() {
            var Bt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : ATt, ge2 = R6.useContext(lr), Ht = ge2.csp;
            R6.useEffect(function() {
              Xm(Bt, "@ant-design-icons", { prepend: true, csp: Ht });
            }, []);
          }, DTt = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], _9 = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
          function ETt(Bt) {
            var ge2 = Bt.primaryColor, Ht = Bt.secondaryColor;
            _9.primaryColor = ge2, _9.secondaryColor = Ht || w22(ge2), _9.calculated = !!Ht;
          }
          function S22() {
            return zi2({}, _9);
          }
          var JX = function(Bt) {
            var ge2 = Bt.icon, Ht = Bt.className, qt = Bt.onClick, Zt = Bt.style, oe2 = Bt.primaryColor, Ne2 = Bt.secondaryColor, Ge2 = jc2(Bt, DTt), Ve = _9;
            if (oe2 && (Ve = { primaryColor: oe2, secondaryColor: Ne2 || w22(oe2) }), ITt(), zft(W32(ge2), "icon should be icon definiton, but got ".concat(ge2)), !W32(ge2))
              return null;
            var pn = ge2;
            return pn && typeof pn.icon == "function" && (pn = zi2(zi2({}, pn), {}, { icon: pn.icon(Ve.primaryColor, Ve.secondaryColor) })), jW(pn.icon, "svg-".concat(pn.name), zi2({ className: Ht, onClick: qt, style: Zt, "data-icon": pn.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, Ge2));
          };
          JX.displayName = "IconReact", JX.getTwoToneColors = S22, JX.setTwoToneColors = ETt;
          var Jw = JX;
          function kTt(Bt) {
            var ge2 = Wft(Bt), Ht = Ic2(ge2, 2), qt = Ht[0], Zt = Ht[1];
            return Jw.setTwoToneColors({ primaryColor: qt, secondaryColor: Zt });
          }
          function PTt() {
            var Bt = Jw.getTwoToneColors();
            return Bt.calculated ? [Bt.primaryColor, Bt.secondaryColor] : Bt.primaryColor;
          }
          var G32 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
          kTt("#1890ff");
          var FR = X3.forwardRef(function(Bt, ge2) {
            var Ht, qt = Bt.className, Zt = Bt.icon, oe2 = Bt.spin, Ne2 = Bt.rotate, Ge2 = Bt.tabIndex, Ve = Bt.onClick, pn = Bt.twoToneColor, vn = jc2(Bt, G32), Gn = X3.useContext(lr), Lr = Gn.prefixCls, Wr = Lr === void 0 ? "anticon" : Lr, Gr = Bd2(Wr, (Ht = {}, er(Ht, "".concat(Wr, "-").concat(Zt.name), !!Zt.name), er(Ht, "".concat(Wr, "-spin"), !!oe2 || Zt.name === "loading"), Ht), qt), ei2 = Ge2;
            ei2 === void 0 && Ve && (ei2 = -1);
            var oi2 = Ne2 ? { msTransform: "rotate(".concat(Ne2, "deg)"), transform: "rotate(".concat(Ne2, "deg)") } : void 0, Va2 = Wft(pn), Ca2 = Ic2(Va2, 2), Go = Ca2[0], un = Ca2[1];
            return X3.createElement("span", zi2(zi2({ role: "img", "aria-label": Zt.name }, vn), {}, { ref: ge2, tabIndex: ei2, onClick: Ve, className: Gr }), X3.createElement(Jw, { icon: Zt, primaryColor: Go, secondaryColor: un, style: oi2 }));
          });
          FR.displayName = "AntdIcon", FR.getTwoToneColor = PTt, FR.setTwoToneColor = kTt;
          var Gft = FR, Wv = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, H3 = Wv, tQ = function(Bt, ge2) {
            return X3.createElement(Gft, zi2(zi2({}, Bt), {}, { ref: ge2, icon: H3 }));
          };
          tQ.displayName = "LoadingOutlined";
          var EZt = X3.forwardRef(tQ);
          function L0() {
            return L0 = Object.assign || function(Bt) {
              for (var ge2 = 1; ge2 < arguments.length; ge2++) {
                var Ht = arguments[ge2];
                for (var qt in Ht)
                  Object.prototype.hasOwnProperty.call(Ht, qt) && (Bt[qt] = Ht[qt]);
              }
              return Bt;
            }, L0.apply(this, arguments);
          }
          function WW(Bt, ge2) {
            if (!(Bt instanceof ge2))
              throw new TypeError("Cannot call a class as a function");
          }
          function LTt(Bt, ge2) {
            for (var Ht = 0; Ht < ge2.length; Ht++) {
              var qt = ge2[Ht];
              qt.enumerable = qt.enumerable || false, qt.configurable = true, "value" in qt && (qt.writable = true), Object.defineProperty(Bt, qt.key, qt);
            }
          }
          function GW(Bt, ge2, Ht) {
            return ge2 && LTt(Bt.prototype, ge2), Ht && LTt(Bt, Ht), Object.defineProperty(Bt, "prototype", { writable: false }), Bt;
          }
          function eQ(Bt, ge2) {
            return eQ = Object.setPrototypeOf || function(Ht, qt) {
              return Ht.__proto__ = qt, Ht;
            }, eQ(Bt, ge2);
          }
          function x9(Bt, ge2) {
            if (typeof ge2 != "function" && ge2 !== null)
              throw new TypeError("Super expression must either be null or a function");
            Bt.prototype = Object.create(ge2 && ge2.prototype, { constructor: { value: Bt, writable: true, configurable: true } }), Object.defineProperty(Bt, "prototype", { writable: false }), ge2 && eQ(Bt, ge2);
          }
          function Vk(Bt) {
            return Vk = Object.setPrototypeOf ? Object.getPrototypeOf : function(ge2) {
              return ge2.__proto__ || Object.getPrototypeOf(ge2);
            }, Vk(Bt);
          }
          function kZt() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function nQ(Bt) {
            if (Bt === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return Bt;
          }
          function OTt(Bt, ge2) {
            if (ge2 && (du(ge2) === "object" || typeof ge2 == "function"))
              return ge2;
            if (ge2 !== void 0)
              throw new TypeError("Derived constructors may only return object or undefined");
            return nQ(Bt);
          }
          function HW(Bt) {
            var ge2 = kZt();
            return function() {
              var Ht = Vk(Bt), qt;
              if (ge2) {
                var Zt = Vk(this).constructor;
                qt = Reflect.construct(Ht, arguments, Zt);
              } else
                qt = Ht.apply(this, arguments);
              return OTt(this, qt);
            };
          }
          var UW = { exports: {} }, Id2 = {};
          /** @license React v16.13.1
          * react-is.production.min.js
          *
          * Copyright (c) Facebook, Inc. and its affiliates.
          *
          * This source code is licensed under the MIT license found in the
          * LICENSE file in the root directory of this source tree.
          */
          var Qm = typeof Symbol == "function" && Symbol.for, qW = Qm ? Symbol.for("react.element") : 60103, ZW = Qm ? Symbol.for("react.portal") : 60106, rQ = Qm ? Symbol.for("react.fragment") : 60107, $W = Qm ? Symbol.for("react.strict_mode") : 60108, Xb2 = Qm ? Symbol.for("react.profiler") : 60114, w9 = Qm ? Symbol.for("react.provider") : 60109, U32 = Qm ? Symbol.for("react.context") : 60110, iQ = Qm ? Symbol.for("react.async_mode") : 60111, YW = Qm ? Symbol.for("react.concurrent_mode") : 60111, aQ = Qm ? Symbol.for("react.forward_ref") : 60112, oQ = Qm ? Symbol.for("react.suspense") : 60113, PZt = Qm ? Symbol.for("react.suspense_list") : 60120, sQ = Qm ? Symbol.for("react.memo") : 60115, lQ = Qm ? Symbol.for("react.lazy") : 60116, S9 = Qm ? Symbol.for("react.block") : 60121, LZt = Qm ? Symbol.for("react.fundamental") : 60117, OZt = Qm ? Symbol.for("react.responder") : 60118, Hft = Qm ? Symbol.for("react.scope") : 60119;
          function tS(Bt) {
            if (typeof Bt == "object" && Bt !== null) {
              var ge2 = Bt.$$typeof;
              switch (ge2) {
                case qW:
                  switch (Bt = Bt.type, Bt) {
                    case iQ:
                    case YW:
                    case rQ:
                    case Xb2:
                    case $W:
                    case oQ:
                      return Bt;
                    default:
                      switch (Bt = Bt && Bt.$$typeof, Bt) {
                        case U32:
                        case aQ:
                        case lQ:
                        case sQ:
                        case w9:
                          return Bt;
                        default:
                          return ge2;
                      }
                  }
                case ZW:
                  return ge2;
              }
            }
          }
          function Bk(Bt) {
            return tS(Bt) === YW;
          }
          Id2.AsyncMode = iQ, Id2.ConcurrentMode = YW, Id2.ContextConsumer = U32, Id2.ContextProvider = w9, Id2.Element = qW, Id2.ForwardRef = aQ, Id2.Fragment = rQ, Id2.Lazy = lQ, Id2.Memo = sQ, Id2.Portal = ZW, Id2.Profiler = Xb2, Id2.StrictMode = $W, Id2.Suspense = oQ, Id2.isAsyncMode = function(Bt) {
            return Bk(Bt) || tS(Bt) === iQ;
          }, Id2.isConcurrentMode = Bk, Id2.isContextConsumer = function(Bt) {
            return tS(Bt) === U32;
          }, Id2.isContextProvider = function(Bt) {
            return tS(Bt) === w9;
          }, Id2.isElement = function(Bt) {
            return typeof Bt == "object" && Bt !== null && Bt.$$typeof === qW;
          }, Id2.isForwardRef = function(Bt) {
            return tS(Bt) === aQ;
          }, Id2.isFragment = function(Bt) {
            return tS(Bt) === rQ;
          }, Id2.isLazy = function(Bt) {
            return tS(Bt) === lQ;
          }, Id2.isMemo = function(Bt) {
            return tS(Bt) === sQ;
          }, Id2.isPortal = function(Bt) {
            return tS(Bt) === ZW;
          }, Id2.isProfiler = function(Bt) {
            return tS(Bt) === Xb2;
          }, Id2.isStrictMode = function(Bt) {
            return tS(Bt) === $W;
          }, Id2.isSuspense = function(Bt) {
            return tS(Bt) === oQ;
          }, Id2.isValidElementType = function(Bt) {
            return typeof Bt == "string" || typeof Bt == "function" || Bt === rQ || Bt === YW || Bt === Xb2 || Bt === $W || Bt === oQ || Bt === PZt || typeof Bt == "object" && Bt !== null && (Bt.$$typeof === lQ || Bt.$$typeof === sQ || Bt.$$typeof === w9 || Bt.$$typeof === U32 || Bt.$$typeof === aQ || Bt.$$typeof === LZt || Bt.$$typeof === OZt || Bt.$$typeof === Hft || Bt.$$typeof === S9);
          }, Id2.typeOf = tS, UW.exports = Id2;
          function M9(Bt) {
            var ge2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ht = [];
            return Z3.default.Children.forEach(Bt, function(qt) {
              qt == null && !ge2.keepEmpty || (Array.isArray(qt) ? Ht = Ht.concat(M9(qt)) : UW.exports.isFragment(qt) && qt.props ? Ht = Ht.concat(M9(qt.props.children, ge2)) : Ht.push(qt));
            }), Ht;
          }
          function RZt(Bt, ge2) {
            typeof Bt == "function" ? Bt(ge2) : du(Bt) === "object" && Bt && "current" in Bt && (Bt.current = ge2);
          }
          function NZt() {
            for (var Bt = arguments.length, ge2 = new Array(Bt), Ht = 0; Ht < Bt; Ht++)
              ge2[Ht] = arguments[Ht];
            var qt = ge2.filter(function(Zt) {
              return Zt;
            });
            return qt.length <= 1 ? qt[0] : function(Zt) {
              ge2.forEach(function(oe2) {
                RZt(oe2, Zt);
              });
            };
          }
          function FZt(Bt) {
            var ge2, Ht, qt = UW.exports.isMemo(Bt) ? Bt.type.type : Bt.type;
            return !(typeof qt == "function" && !(!((ge2 = qt.prototype) === null || ge2 === void 0) && ge2.render) || typeof Bt == "function" && !(!((Ht = Bt.prototype) === null || Ht === void 0) && Ht.render));
          }
          function C9() {
            try {
              if (!Object.assign)
                return false;
              var Bt = new String("abc");
              if (Bt[5] = "de", Object.getOwnPropertyNames(Bt)[0] === "5")
                return false;
              for (var ge2 = {}, Ht = 0; Ht < 10; Ht++)
                ge2["_" + String.fromCharCode(Ht)] = Ht;
              var qt = Object.getOwnPropertyNames(ge2).map(function(oe2) {
                return ge2[oe2];
              });
              if (qt.join("") !== "0123456789")
                return false;
              var Zt = {};
              return "abcdefghijklmnopqrst".split("").forEach(function(oe2) {
                Zt[oe2] = oe2;
              }), Object.keys(Object.assign({}, Zt)).join("") === "abcdefghijklmnopqrst";
            } catch {
              return false;
            }
          }
          C9();
          function pT(Bt) {
            if (Array.isArray(Bt))
              return zo(Bt);
          }
          function Uft(Bt) {
            if (typeof Symbol != "undefined" && Bt[Symbol.iterator] != null || Bt["@@iterator"] != null)
              return Array.from(Bt);
          }
          function VZt() {
            throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          function wp(Bt) {
            return pT(Bt) || Uft(Bt) || ql(Bt) || VZt();
          }
          var T9 = "RC_FORM_INTERNAL_HOOKS", Av = function() {
            gD(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
          }, KW = X3.createContext({ getFieldValue: Av, getFieldsValue: Av, getFieldError: Av, getFieldWarning: Av, getFieldsError: Av, isFieldsTouched: Av, isFieldTouched: Av, isFieldValidating: Av, isFieldsValidating: Av, resetFields: Av, setFields: Av, setFieldsValue: Av, validateFields: Av, submit: Av, getInternalHooks: function() {
            return Av(), { dispatch: Av, initEntityValue: Av, registerField: Av, useSubscribe: Av, setInitialValues: Av, setCallbacks: Av, getFields: Av, setValidateMessages: Av, setPreserve: Av, getInitialValue: Av };
          } });
          function q32(Bt) {
            return Bt == null ? [] : Array.isArray(Bt) ? Bt : [Bt];
          }
          var bi2 = { exports: {} };
          (function(Bt) {
            var ge2 = function(Ht) {
              var qt = Object.prototype, Zt = qt.hasOwnProperty, oe2, Ne2 = typeof Symbol == "function" ? Symbol : {}, Ge2 = Ne2.iterator || "@@iterator", Ve = Ne2.asyncIterator || "@@asyncIterator", pn = Ne2.toStringTag || "@@toStringTag";
              function vn(Na2, ga, ca2) {
                return Object.defineProperty(Na2, ga, { value: ca2, enumerable: true, configurable: true, writable: true }), Na2[ga];
              }
              try {
                vn({}, "");
              } catch {
                vn = function(Na2, ga, ca2) {
                  return Na2[ga] = ca2;
                };
              }
              function Gn(Na2, ga, ca2, fs) {
                var qo = ga && ga.prototype instanceof Ca2 ? ga : Ca2, Hu = Object.create(qo.prototype), vh2 = new vl(fs || []);
                return Hu._invoke = Ka2(Na2, ca2, vh2), Hu;
              }
              Ht.wrap = Gn;
              function Lr(Na2, ga, ca2) {
                try {
                  return { type: "normal", arg: Na2.call(ga, ca2) };
                } catch (fs) {
                  return { type: "throw", arg: fs };
                }
              }
              var Wr = "suspendedStart", Gr = "suspendedYield", ei2 = "executing", oi2 = "completed", Va2 = {};
              function Ca2() {
              }
              function Go() {
              }
              function un() {
              }
              var Ei2 = {};
              vn(Ei2, Ge2, function() {
                return this;
              });
              var Wi2 = Object.getPrototypeOf, La2 = Wi2 && Wi2(Wi2(xa2([])));
              La2 && La2 !== qt && Zt.call(La2, Ge2) && (Ei2 = La2);
              var Aa2 = un.prototype = Ca2.prototype = Object.create(Ei2);
              Go.prototype = un, vn(Aa2, "constructor", un), vn(un, "constructor", Go), Go.displayName = vn(un, pn, "GeneratorFunction");
              function Oi2(Na2) {
                ["next", "throw", "return"].forEach(function(ga) {
                  vn(Na2, ga, function(ca2) {
                    return this._invoke(ga, ca2);
                  });
                });
              }
              Ht.isGeneratorFunction = function(Na2) {
                var ga = typeof Na2 == "function" && Na2.constructor;
                return ga ? ga === Go || (ga.displayName || ga.name) === "GeneratorFunction" : false;
              }, Ht.mark = function(Na2) {
                return Object.setPrototypeOf ? Object.setPrototypeOf(Na2, un) : (Na2.__proto__ = un, vn(Na2, pn, "GeneratorFunction")), Na2.prototype = Object.create(Aa2), Na2;
              }, Ht.awrap = function(Na2) {
                return { __await: Na2 };
              };
              function Zi2(Na2, ga) {
                function ca2(Hu, vh2, Wf2, mc2) {
                  var yd2 = Lr(Na2[Hu], Na2, vh2);
                  if (yd2.type === "throw")
                    mc2(yd2.arg);
                  else {
                    var Gf2 = yd2.arg, hp = Gf2.value;
                    return hp && typeof hp == "object" && Zt.call(hp, "__await") ? ga.resolve(hp.__await).then(function(Lg2) {
                      ca2("next", Lg2, Wf2, mc2);
                    }, function(Lg2) {
                      ca2("throw", Lg2, Wf2, mc2);
                    }) : ga.resolve(hp).then(function(Lg2) {
                      Gf2.value = Lg2, Wf2(Gf2);
                    }, function(Lg2) {
                      return ca2("throw", Lg2, Wf2, mc2);
                    });
                  }
                }
                var fs;
                function qo(Hu, vh2) {
                  function Wf2() {
                    return new ga(function(mc2, yd2) {
                      ca2(Hu, vh2, mc2, yd2);
                    });
                  }
                  return fs = fs ? fs.then(Wf2, Wf2) : Wf2();
                }
                this._invoke = qo;
              }
              Oi2(Zi2.prototype), vn(Zi2.prototype, Ve, function() {
                return this;
              }), Ht.AsyncIterator = Zi2, Ht.async = function(Na2, ga, ca2, fs, qo) {
                qo === void 0 && (qo = Promise);
                var Hu = new Zi2(Gn(Na2, ga, ca2, fs), qo);
                return Ht.isGeneratorFunction(ga) ? Hu : Hu.next().then(function(vh2) {
                  return vh2.done ? vh2.value : Hu.next();
                });
              };
              function Ka2(Na2, ga, ca2) {
                var fs = Wr;
                return function(qo, Hu) {
                  if (fs === ei2)
                    throw new Error("Generator is already running");
                  if (fs === oi2) {
                    if (qo === "throw")
                      throw Hu;
                    return gu();
                  }
                  for (ca2.method = qo, ca2.arg = Hu; ; ) {
                    var vh2 = ca2.delegate;
                    if (vh2) {
                      var Wf2 = Fo(vh2, ca2);
                      if (Wf2) {
                        if (Wf2 === Va2)
                          continue;
                        return Wf2;
                      }
                    }
                    if (ca2.method === "next")
                      ca2.sent = ca2._sent = ca2.arg;
                    else if (ca2.method === "throw") {
                      if (fs === Wr)
                        throw fs = oi2, ca2.arg;
                      ca2.dispatchException(ca2.arg);
                    } else
                      ca2.method === "return" && ca2.abrupt("return", ca2.arg);
                    fs = ei2;
                    var mc2 = Lr(Na2, ga, ca2);
                    if (mc2.type === "normal") {
                      if (fs = ca2.done ? oi2 : Gr, mc2.arg === Va2)
                        continue;
                      return { value: mc2.arg, done: ca2.done };
                    } else
                      mc2.type === "throw" && (fs = oi2, ca2.method = "throw", ca2.arg = mc2.arg);
                  }
                };
              }
              function Fo(Na2, ga) {
                var ca2 = Na2.iterator[ga.method];
                if (ca2 === oe2) {
                  if (ga.delegate = null, ga.method === "throw") {
                    if (Na2.iterator.return && (ga.method = "return", ga.arg = oe2, Fo(Na2, ga), ga.method === "throw"))
                      return Va2;
                    ga.method = "throw", ga.arg = new TypeError("The iterator does not provide a 'throw' method");
                  }
                  return Va2;
                }
                var fs = Lr(ca2, Na2.iterator, ga.arg);
                if (fs.type === "throw")
                  return ga.method = "throw", ga.arg = fs.arg, ga.delegate = null, Va2;
                var qo = fs.arg;
                if (!qo)
                  return ga.method = "throw", ga.arg = new TypeError("iterator result is not an object"), ga.delegate = null, Va2;
                if (qo.done)
                  ga[Na2.resultName] = qo.value, ga.next = Na2.nextLoc, ga.method !== "return" && (ga.method = "next", ga.arg = oe2);
                else
                  return qo;
                return ga.delegate = null, Va2;
              }
              Oi2(Aa2), vn(Aa2, pn, "Generator"), vn(Aa2, Ge2, function() {
                return this;
              }), vn(Aa2, "toString", function() {
                return "[object Generator]";
              });
              function Si2(Na2) {
                var ga = { tryLoc: Na2[0] };
                1 in Na2 && (ga.catchLoc = Na2[1]), 2 in Na2 && (ga.finallyLoc = Na2[2], ga.afterLoc = Na2[3]), this.tryEntries.push(ga);
              }
              function bl(Na2) {
                var ga = Na2.completion || {};
                ga.type = "normal", delete ga.arg, Na2.completion = ga;
              }
              function vl(Na2) {
                this.tryEntries = [{ tryLoc: "root" }], Na2.forEach(Si2, this), this.reset(true);
              }
              Ht.keys = function(Na2) {
                var ga = [];
                for (var ca2 in Na2)
                  ga.push(ca2);
                return ga.reverse(), function fs() {
                  for (; ga.length; ) {
                    var qo = ga.pop();
                    if (qo in Na2)
                      return fs.value = qo, fs.done = false, fs;
                  }
                  return fs.done = true, fs;
                };
              };
              function xa2(Na2) {
                if (Na2) {
                  var ga = Na2[Ge2];
                  if (ga)
                    return ga.call(Na2);
                  if (typeof Na2.next == "function")
                    return Na2;
                  if (!isNaN(Na2.length)) {
                    var ca2 = -1, fs = function qo() {
                      for (; ++ca2 < Na2.length; )
                        if (Zt.call(Na2, ca2))
                          return qo.value = Na2[ca2], qo.done = false, qo;
                      return qo.value = oe2, qo.done = true, qo;
                    };
                    return fs.next = fs;
                  }
                }
                return { next: gu };
              }
              Ht.values = xa2;
              function gu() {
                return { value: oe2, done: true };
              }
              return vl.prototype = { constructor: vl, reset: function(Na2) {
                if (this.prev = 0, this.next = 0, this.sent = this._sent = oe2, this.done = false, this.delegate = null, this.method = "next", this.arg = oe2, this.tryEntries.forEach(bl), !Na2)
                  for (var ga in this)
                    ga.charAt(0) === "t" && Zt.call(this, ga) && !isNaN(+ga.slice(1)) && (this[ga] = oe2);
              }, stop: function() {
                this.done = true;
                var Na2 = this.tryEntries[0], ga = Na2.completion;
                if (ga.type === "throw")
                  throw ga.arg;
                return this.rval;
              }, dispatchException: function(Na2) {
                if (this.done)
                  throw Na2;
                var ga = this;
                function ca2(mc2, yd2) {
                  return Hu.type = "throw", Hu.arg = Na2, ga.next = mc2, yd2 && (ga.method = "next", ga.arg = oe2), !!yd2;
                }
                for (var fs = this.tryEntries.length - 1; fs >= 0; --fs) {
                  var qo = this.tryEntries[fs], Hu = qo.completion;
                  if (qo.tryLoc === "root")
                    return ca2("end");
                  if (qo.tryLoc <= this.prev) {
                    var vh2 = Zt.call(qo, "catchLoc"), Wf2 = Zt.call(qo, "finallyLoc");
                    if (vh2 && Wf2) {
                      if (this.prev < qo.catchLoc)
                        return ca2(qo.catchLoc, true);
                      if (this.prev < qo.finallyLoc)
                        return ca2(qo.finallyLoc);
                    } else if (vh2) {
                      if (this.prev < qo.catchLoc)
                        return ca2(qo.catchLoc, true);
                    } else if (Wf2) {
                      if (this.prev < qo.finallyLoc)
                        return ca2(qo.finallyLoc);
                    } else
                      throw new Error("try statement without catch or finally");
                  }
                }
              }, abrupt: function(Na2, ga) {
                for (var ca2 = this.tryEntries.length - 1; ca2 >= 0; --ca2) {
                  var fs = this.tryEntries[ca2];
                  if (fs.tryLoc <= this.prev && Zt.call(fs, "finallyLoc") && this.prev < fs.finallyLoc) {
                    var qo = fs;
                    break;
                  }
                }
                qo && (Na2 === "break" || Na2 === "continue") && qo.tryLoc <= ga && ga <= qo.finallyLoc && (qo = null);
                var Hu = qo ? qo.completion : {};
                return Hu.type = Na2, Hu.arg = ga, qo ? (this.method = "next", this.next = qo.finallyLoc, Va2) : this.complete(Hu);
              }, complete: function(Na2, ga) {
                if (Na2.type === "throw")
                  throw Na2.arg;
                return Na2.type === "break" || Na2.type === "continue" ? this.next = Na2.arg : Na2.type === "return" ? (this.rval = this.arg = Na2.arg, this.method = "return", this.next = "end") : Na2.type === "normal" && ga && (this.next = ga), Va2;
              }, finish: function(Na2) {
                for (var ga = this.tryEntries.length - 1; ga >= 0; --ga) {
                  var ca2 = this.tryEntries[ga];
                  if (ca2.finallyLoc === Na2)
                    return this.complete(ca2.completion, ca2.afterLoc), bl(ca2), Va2;
                }
              }, catch: function(Na2) {
                for (var ga = this.tryEntries.length - 1; ga >= 0; --ga) {
                  var ca2 = this.tryEntries[ga];
                  if (ca2.tryLoc === Na2) {
                    var fs = ca2.completion;
                    if (fs.type === "throw") {
                      var qo = fs.arg;
                      bl(ca2);
                    }
                    return qo;
                  }
                }
                throw new Error("illegal catch attempt");
              }, delegateYield: function(Na2, ga, ca2) {
                return this.delegate = { iterator: xa2(Na2), resultName: ga, nextLoc: ca2 }, this.method === "next" && (this.arg = oe2), Va2;
              } }, Ht;
            }(Bt.exports);
            try {
              regeneratorRuntime = ge2;
            } catch {
              typeof globalThis == "object" ? globalThis.regeneratorRuntime = ge2 : Function("r", "regeneratorRuntime = r")(ge2);
            }
          })(bi2);
          var Ua2 = bi2.exports;
          function _a2(Bt, ge2, Ht, qt, Zt, oe2, Ne2) {
            try {
              var Ge2 = Bt[oe2](Ne2), Ve = Ge2.value;
            } catch (pn) {
              Ht(pn);
              return;
            }
            Ge2.done ? ge2(Ve) : Promise.resolve(Ve).then(qt, Zt);
          }
          function Dl(Bt) {
            return function() {
              var ge2 = this, Ht = arguments;
              return new Promise(function(qt, Zt) {
                var oe2 = Bt.apply(ge2, Ht);
                function Ne2(Ve) {
                  _a2(oe2, qt, Zt, Ne2, Ge2, "next", Ve);
                }
                function Ge2(Ve) {
                  _a2(oe2, qt, Zt, Ne2, Ge2, "throw", Ve);
                }
                Ne2(void 0);
              });
            };
          }
          function vc2() {
            return vc2 = Object.assign || function(Bt) {
              for (var ge2 = 1; ge2 < arguments.length; ge2++) {
                var Ht = arguments[ge2];
                for (var qt in Ht)
                  Object.prototype.hasOwnProperty.call(Ht, qt) && (Bt[qt] = Ht[qt]);
              }
              return Bt;
            }, vc2.apply(this, arguments);
          }
          function gd2(Bt, ge2) {
            Bt.prototype = Object.create(ge2.prototype), Bt.prototype.constructor = Bt, vd2(Bt, ge2);
          }
          function ny(Bt) {
            return ny = Object.setPrototypeOf ? Object.getPrototypeOf : function(ge2) {
              return ge2.__proto__ || Object.getPrototypeOf(ge2);
            }, ny(Bt);
          }
          function vd2(Bt, ge2) {
            return vd2 = Object.setPrototypeOf || function(Ht, qt) {
              return Ht.__proto__ = qt, Ht;
            }, vd2(Bt, ge2);
          }
          function qft() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function uQ(Bt, ge2, Ht) {
            return qft() ? uQ = Reflect.construct : uQ = function(qt, Zt, oe2) {
              var Ne2 = [null];
              Ne2.push.apply(Ne2, Zt);
              var Ge2 = Function.bind.apply(qt, Ne2), Ve = new Ge2();
              return oe2 && vd2(Ve, oe2.prototype), Ve;
            }, uQ.apply(null, arguments);
          }
          function DM(Bt) {
            return Function.toString.call(Bt).indexOf("[native code]") !== -1;
          }
          function A9(Bt) {
            var ge2 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
            return A9 = function(Ht) {
              if (Ht === null || !DM(Ht))
                return Ht;
              if (typeof Ht != "function")
                throw new TypeError("Super expression must either be null or a function");
              if (typeof ge2 != "undefined") {
                if (ge2.has(Ht))
                  return ge2.get(Ht);
                ge2.set(Ht, qt);
              }
              function qt() {
                return uQ(Ht, arguments, ny(this).constructor);
              }
              return qt.prototype = Object.create(Ht.prototype, { constructor: { value: qt, enumerable: false, writable: true, configurable: true } }), vd2(qt, Ht);
            }, A9(Bt);
          }
          var BZt = /%[sdj%]/g, I9 = function() {
          };
          typeof process != "undefined" && process.env;
          function D9(Bt) {
            if (!Bt || !Bt.length)
              return null;
            var ge2 = {};
            return Bt.forEach(function(Ht) {
              var qt = Ht.field;
              ge2[qt] = ge2[qt] || [], ge2[qt].push(Ht);
            }), ge2;
          }
          function Qb(Bt) {
            for (var ge2 = arguments.length, Ht = new Array(ge2 > 1 ? ge2 - 1 : 0), qt = 1; qt < ge2; qt++)
              Ht[qt - 1] = arguments[qt];
            var Zt = 0, oe2 = Ht.length;
            if (typeof Bt == "function")
              return Bt.apply(null, Ht);
            if (typeof Bt == "string") {
              var Ne2 = Bt.replace(BZt, function(Ge2) {
                if (Ge2 === "%%")
                  return "%";
                if (Zt >= oe2)
                  return Ge2;
                switch (Ge2) {
                  case "%s":
                    return String(Ht[Zt++]);
                  case "%d":
                    return Number(Ht[Zt++]);
                  case "%j":
                    try {
                      return JSON.stringify(Ht[Zt++]);
                    } catch {
                      return "[Circular]";
                    }
                    break;
                  default:
                    return Ge2;
                }
              });
              return Ne2;
            }
            return Bt;
          }
          function zd2(Bt) {
            return Bt === "string" || Bt === "url" || Bt === "hex" || Bt === "email" || Bt === "date" || Bt === "pattern";
          }
          function lm(Bt, ge2) {
            return !!(Bt == null || ge2 === "array" && Array.isArray(Bt) && !Bt.length || zd2(ge2) && typeof Bt == "string" && !Bt);
          }
          function RTt(Bt, ge2, Ht) {
            var qt = [], Zt = 0, oe2 = Bt.length;
            function Ne2(Ge2) {
              qt.push.apply(qt, Ge2 || []), Zt++, Zt === oe2 && Ht(qt);
            }
            Bt.forEach(function(Ge2) {
              ge2(Ge2, Ne2);
            });
          }
          function XW(Bt, ge2, Ht) {
            var qt = 0, Zt = Bt.length;
            function oe2(Ne2) {
              if (Ne2 && Ne2.length) {
                Ht(Ne2);
                return;
              }
              var Ge2 = qt;
              qt = qt + 1, Ge2 < Zt ? ge2(Bt[Ge2], oe2) : Ht([]);
            }
            oe2([]);
          }
          function zZt(Bt) {
            var ge2 = [];
            return Object.keys(Bt).forEach(function(Ht) {
              ge2.push.apply(ge2, Bt[Ht] || []);
            }), ge2;
          }
          var NTt = function(Bt) {
            gd2(ge2, Bt);
            function ge2(Ht, qt) {
              var Zt;
              return Zt = Bt.call(this, "Async Validation Error") || this, Zt.errors = Ht, Zt.fields = qt, Zt;
            }
            return ge2;
          }(A9(Error));
          function jZt(Bt, ge2, Ht, qt, Zt) {
            if (ge2.first) {
              var oe2 = new Promise(function(Lr, Wr) {
                var Gr = function(oi2) {
                  return qt(oi2), oi2.length ? Wr(new NTt(oi2, D9(oi2))) : Lr(Zt);
                }, ei2 = zZt(Bt);
                XW(ei2, Ht, Gr);
              });
              return oe2.catch(function(Lr) {
                return Lr;
              }), oe2;
            }
            var Ne2 = ge2.firstFields === true ? Object.keys(Bt) : ge2.firstFields || [], Ge2 = Object.keys(Bt), Ve = Ge2.length, pn = 0, vn = [], Gn = new Promise(function(Lr, Wr) {
              var Gr = function(ei2) {
                if (vn.push.apply(vn, ei2), pn++, pn === Ve)
                  return qt(vn), vn.length ? Wr(new NTt(vn, D9(vn))) : Lr(Zt);
              };
              Ge2.length || (qt(vn), Lr(Zt)), Ge2.forEach(function(ei2) {
                var oi2 = Bt[ei2];
                Ne2.indexOf(ei2) !== -1 ? XW(oi2, Ht, Gr) : RTt(oi2, Ht, Gr);
              });
            });
            return Gn.catch(function(Lr) {
              return Lr;
            }), Gn;
          }
          function cQ(Bt) {
            return !!(Bt && Bt.message !== void 0);
          }
          function Z32(Bt, ge2) {
            for (var Ht = Bt, qt = 0; qt < ge2.length; qt++) {
              if (Ht == null)
                return Ht;
              Ht = Ht[ge2[qt]];
            }
            return Ht;
          }
          function QW(Bt, ge2) {
            return function(Ht) {
              var qt;
              return Bt.fullFields ? qt = Z32(ge2, Bt.fullFields) : qt = ge2[Ht.field || Bt.fullField], cQ(Ht) ? (Ht.field = Ht.field || Bt.fullField, Ht.fieldValue = qt, Ht) : { message: typeof Ht == "function" ? Ht() : Ht, fieldValue: qt, field: Ht.field || Bt.fullField };
            };
          }
          function Zft(Bt, ge2) {
            if (ge2) {
              for (var Ht in ge2)
                if (ge2.hasOwnProperty(Ht)) {
                  var qt = ge2[Ht];
                  typeof qt == "object" && typeof Bt[Ht] == "object" ? Bt[Ht] = vc2({}, Bt[Ht], qt) : Bt[Ht] = qt;
                }
            }
            return Bt;
          }
          var JW = function(Bt, ge2, Ht, qt, Zt, oe2) {
            Bt.required && (!Ht.hasOwnProperty(Bt.field) || lm(ge2, oe2 || Bt.type)) && qt.push(Qb(Zt.messages.required, Bt.fullField));
          }, FTt = function(Bt, ge2, Ht, qt, Zt) {
            (/^\s+$/.test(ge2) || ge2 === "") && qt.push(Qb(Zt.messages.whitespace, Bt.fullField));
          }, fQ = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, $3 = { integer: function(Bt) {
            return $3.number(Bt) && parseInt(Bt, 10) === Bt;
          }, float: function(Bt) {
            return $3.number(Bt) && !$3.integer(Bt);
          }, array: function(Bt) {
            return Array.isArray(Bt);
          }, regexp: function(Bt) {
            if (Bt instanceof RegExp)
              return true;
            try {
              return !!new RegExp(Bt);
            } catch {
              return false;
            }
          }, date: function(Bt) {
            return typeof Bt.getTime == "function" && typeof Bt.getMonth == "function" && typeof Bt.getYear == "function" && !isNaN(Bt.getTime());
          }, number: function(Bt) {
            return isNaN(Bt) ? false : typeof Bt == "number";
          }, object: function(Bt) {
            return typeof Bt == "object" && !$3.array(Bt);
          }, method: function(Bt) {
            return typeof Bt == "function";
          }, email: function(Bt) {
            return typeof Bt == "string" && Bt.length <= 320 && !!Bt.match(fQ.email);
          }, url: function(Bt) {
            return typeof Bt == "string" && Bt.length <= 2048 && !!Bt.match(fQ.url);
          }, hex: function(Bt) {
            return typeof Bt == "string" && !!Bt.match(fQ.hex);
          } }, VTt = function(Bt, ge2, Ht, qt, Zt) {
            if (Bt.required && ge2 === void 0) {
              JW(Bt, ge2, Ht, qt, Zt);
              return;
            }
            var oe2 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], Ne2 = Bt.type;
            oe2.indexOf(Ne2) > -1 ? $3[Ne2](ge2) || qt.push(Qb(Zt.messages.types[Ne2], Bt.fullField, Bt.type)) : Ne2 && typeof ge2 !== Bt.type && qt.push(Qb(Zt.messages.types[Ne2], Bt.fullField, Bt.type));
          }, tG = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = typeof Bt.len == "number", Ne2 = typeof Bt.min == "number", Ge2 = typeof Bt.max == "number", Ve = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, pn = ge2, vn = null, Gn = typeof ge2 == "number", Lr = typeof ge2 == "string", Wr = Array.isArray(ge2);
            if (Gn ? vn = "number" : Lr ? vn = "string" : Wr && (vn = "array"), !vn)
              return false;
            Wr && (pn = ge2.length), Lr && (pn = ge2.replace(Ve, "_").length), oe2 ? pn !== Bt.len && qt.push(Qb(Zt.messages[vn].len, Bt.fullField, Bt.len)) : Ne2 && !Ge2 && pn < Bt.min ? qt.push(Qb(Zt.messages[vn].min, Bt.fullField, Bt.min)) : Ge2 && !Ne2 && pn > Bt.max ? qt.push(Qb(Zt.messages[vn].max, Bt.fullField, Bt.max)) : Ne2 && Ge2 && (pn < Bt.min || pn > Bt.max) && qt.push(Qb(Zt.messages[vn].range, Bt.fullField, Bt.min, Bt.max));
          }, EM = "enum", hQ = function(Bt, ge2, Ht, qt, Zt) {
            Bt[EM] = Array.isArray(Bt[EM]) ? Bt[EM] : [], Bt[EM].indexOf(ge2) === -1 && qt.push(Qb(Zt.messages[EM], Bt.fullField, Bt[EM].join(", ")));
          }, WZt = function(Bt, ge2, Ht, qt, Zt) {
            if (Bt.pattern) {
              if (Bt.pattern instanceof RegExp)
                Bt.pattern.lastIndex = 0, Bt.pattern.test(ge2) || qt.push(Qb(Zt.messages.pattern.mismatch, Bt.fullField, ge2, Bt.pattern));
              else if (typeof Bt.pattern == "string") {
                var oe2 = new RegExp(Bt.pattern);
                oe2.test(ge2) || qt.push(Qb(Zt.messages.pattern.mismatch, Bt.fullField, ge2, Bt.pattern));
              }
            }
          }, fp = { required: JW, whitespace: FTt, type: VTt, range: tG, enum: hQ, pattern: WZt }, GZt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2, "string") && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt, "string"), lm(ge2, "string") || (fp.type(Bt, ge2, qt, oe2, Zt), fp.range(Bt, ge2, qt, oe2, Zt), fp.pattern(Bt, ge2, qt, oe2, Zt), Bt.whitespace === true && fp.whitespace(Bt, ge2, qt, oe2, Zt));
            }
            Ht(oe2);
          }, pQ = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), ge2 !== void 0 && fp.type(Bt, ge2, qt, oe2, Zt);
            }
            Ht(oe2);
          }, dQ = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (ge2 === "" && (ge2 = void 0), lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), ge2 !== void 0 && (fp.type(Bt, ge2, qt, oe2, Zt), fp.range(Bt, ge2, qt, oe2, Zt));
            }
            Ht(oe2);
          }, $ft = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), ge2 !== void 0 && fp.type(Bt, ge2, qt, oe2, Zt);
            }
            Ht(oe2);
          }, HZt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), lm(ge2) || fp.type(Bt, ge2, qt, oe2, Zt);
            }
            Ht(oe2);
          }, BTt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), ge2 !== void 0 && (fp.type(Bt, ge2, qt, oe2, Zt), fp.range(Bt, ge2, qt, oe2, Zt));
            }
            Ht(oe2);
          }, UZt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), ge2 !== void 0 && (fp.type(Bt, ge2, qt, oe2, Zt), fp.range(Bt, ge2, qt, oe2, Zt));
            }
            Ht(oe2);
          }, qZt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (ge2 == null && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt, "array"), ge2 != null && (fp.type(Bt, ge2, qt, oe2, Zt), fp.range(Bt, ge2, qt, oe2, Zt));
            }
            Ht(oe2);
          }, um = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), ge2 !== void 0 && fp.type(Bt, ge2, qt, oe2, Zt);
            }
            Ht(oe2);
          }, Jb2 = "enum", ZZt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), ge2 !== void 0 && fp[Jb2](Bt, ge2, qt, oe2, Zt);
            }
            Ht(oe2);
          }, $Zt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2, "string") && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt), lm(ge2, "string") || fp.pattern(Bt, ge2, qt, oe2, Zt);
            }
            Ht(oe2);
          }, zTt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2, "date") && !Bt.required)
                return Ht();
              if (fp.required(Bt, ge2, qt, oe2, Zt), !lm(ge2, "date")) {
                var Ge2;
                ge2 instanceof Date ? Ge2 = ge2 : Ge2 = new Date(ge2), fp.type(Bt, Ge2, qt, oe2, Zt), Ge2 && fp.range(Bt, Ge2.getTime(), qt, oe2, Zt);
              }
            }
            Ht(oe2);
          }, YZt = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Array.isArray(ge2) ? "array" : typeof ge2;
            fp.required(Bt, ge2, qt, oe2, Zt, Ne2), Ht(oe2);
          }, eG = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = Bt.type, Ne2 = [], Ge2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ge2) {
              if (lm(ge2, oe2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, Ne2, Zt, oe2), lm(ge2, oe2) || fp.type(Bt, ge2, qt, Ne2, Zt);
            }
            Ht(Ne2);
          }, nG = function(Bt, ge2, Ht, qt, Zt) {
            var oe2 = [], Ne2 = Bt.required || !Bt.required && qt.hasOwnProperty(Bt.field);
            if (Ne2) {
              if (lm(ge2) && !Bt.required)
                return Ht();
              fp.required(Bt, ge2, qt, oe2, Zt);
            }
            Ht(oe2);
          }, VR = { string: GZt, method: pQ, number: dQ, boolean: $ft, regexp: HZt, integer: BTt, float: UZt, array: qZt, object: um, enum: ZZt, pattern: $Zt, date: zTt, url: eG, hex: eG, email: eG, required: YZt, any: nG };
          function Y32() {
            return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
              var Bt = JSON.parse(JSON.stringify(this));
              return Bt.clone = this.clone, Bt;
            } };
          }
          var BR = Y32(), zk = function() {
            function Bt(Ht) {
              this.rules = null, this._messages = BR, this.define(Ht);
            }
            var ge2 = Bt.prototype;
            return ge2.define = function(Ht) {
              var qt = this;
              if (!Ht)
                throw new Error("Cannot configure a schema with no rules");
              if (typeof Ht != "object" || Array.isArray(Ht))
                throw new Error("Rules must be an object");
              this.rules = {}, Object.keys(Ht).forEach(function(Zt) {
                var oe2 = Ht[Zt];
                qt.rules[Zt] = Array.isArray(oe2) ? oe2 : [oe2];
              });
            }, ge2.messages = function(Ht) {
              return Ht && (this._messages = Zft(Y32(), Ht)), this._messages;
            }, ge2.validate = function(Ht, qt, Zt) {
              var oe2 = this;
              qt === void 0 && (qt = {}), Zt === void 0 && (Zt = function() {
              });
              var Ne2 = Ht, Ge2 = qt, Ve = Zt;
              if (typeof Ge2 == "function" && (Ve = Ge2, Ge2 = {}), !this.rules || Object.keys(this.rules).length === 0)
                return Ve && Ve(null, Ne2), Promise.resolve(Ne2);
              function pn(Gr) {
                var ei2 = [], oi2 = {};
                function Va2(Go) {
                  if (Array.isArray(Go)) {
                    var un;
                    ei2 = (un = ei2).concat.apply(un, Go);
                  } else
                    ei2.push(Go);
                }
                for (var Ca2 = 0; Ca2 < Gr.length; Ca2++)
                  Va2(Gr[Ca2]);
                ei2.length ? (oi2 = D9(ei2), Ve(ei2, oi2)) : Ve(null, Ne2);
              }
              if (Ge2.messages) {
                var vn = this.messages();
                vn === BR && (vn = Y32()), Zft(vn, Ge2.messages), Ge2.messages = vn;
              } else
                Ge2.messages = this.messages();
              var Gn = {}, Lr = Ge2.keys || Object.keys(this.rules);
              Lr.forEach(function(Gr) {
                var ei2 = oe2.rules[Gr], oi2 = Ne2[Gr];
                ei2.forEach(function(Va2) {
                  var Ca2 = Va2;
                  typeof Ca2.transform == "function" && (Ne2 === Ht && (Ne2 = vc2({}, Ne2)), oi2 = Ne2[Gr] = Ca2.transform(oi2)), typeof Ca2 == "function" ? Ca2 = { validator: Ca2 } : Ca2 = vc2({}, Ca2), Ca2.validator = oe2.getValidationMethod(Ca2), Ca2.validator && (Ca2.field = Gr, Ca2.fullField = Ca2.fullField || Gr, Ca2.type = oe2.getType(Ca2), Gn[Gr] = Gn[Gr] || [], Gn[Gr].push({ rule: Ca2, value: oi2, source: Ne2, field: Gr }));
                });
              });
              var Wr = {};
              return jZt(Gn, Ge2, function(Gr, ei2) {
                var oi2 = Gr.rule, Va2 = (oi2.type === "object" || oi2.type === "array") && (typeof oi2.fields == "object" || typeof oi2.defaultField == "object");
                Va2 = Va2 && (oi2.required || !oi2.required && Gr.value), oi2.field = Gr.field;
                function Ca2(Ei2, Wi2) {
                  return vc2({}, Wi2, { fullField: oi2.fullField + "." + Ei2, fullFields: oi2.fullFields ? [].concat(oi2.fullFields, [Ei2]) : [Ei2] });
                }
                function Go(Ei2) {
                  Ei2 === void 0 && (Ei2 = []);
                  var Wi2 = Array.isArray(Ei2) ? Ei2 : [Ei2];
                  !Ge2.suppressWarning && Wi2.length && Bt.warning("async-validator:", Wi2), Wi2.length && oi2.message !== void 0 && (Wi2 = [].concat(oi2.message));
                  var La2 = Wi2.map(QW(oi2, Ne2));
                  if (Ge2.first && La2.length)
                    return Wr[oi2.field] = 1, ei2(La2);
                  if (!Va2)
                    ei2(La2);
                  else {
                    if (oi2.required && !Gr.value)
                      return oi2.message !== void 0 ? La2 = [].concat(oi2.message).map(QW(oi2, Ne2)) : Ge2.error && (La2 = [Ge2.error(oi2, Qb(Ge2.messages.required, oi2.field))]), ei2(La2);
                    var Aa2 = {};
                    oi2.defaultField && Object.keys(Gr.value).map(function(Ka2) {
                      Aa2[Ka2] = oi2.defaultField;
                    }), Aa2 = vc2({}, Aa2, Gr.rule.fields);
                    var Oi2 = {};
                    Object.keys(Aa2).forEach(function(Ka2) {
                      var Fo = Aa2[Ka2], Si2 = Array.isArray(Fo) ? Fo : [Fo];
                      Oi2[Ka2] = Si2.map(Ca2.bind(null, Ka2));
                    });
                    var Zi2 = new Bt(Oi2);
                    Zi2.messages(Ge2.messages), Gr.rule.options && (Gr.rule.options.messages = Ge2.messages, Gr.rule.options.error = Ge2.error), Zi2.validate(Gr.value, Gr.rule.options || Ge2, function(Ka2) {
                      var Fo = [];
                      La2 && La2.length && Fo.push.apply(Fo, La2), Ka2 && Ka2.length && Fo.push.apply(Fo, Ka2), ei2(Fo.length ? Fo : null);
                    });
                  }
                }
                var un;
                oi2.asyncValidator ? un = oi2.asyncValidator(oi2, Gr.value, Go, Gr.source, Ge2) : oi2.validator && (un = oi2.validator(oi2, Gr.value, Go, Gr.source, Ge2), un === true ? Go() : un === false ? Go(typeof oi2.message == "function" ? oi2.message(oi2.fullField || oi2.field) : oi2.message || (oi2.fullField || oi2.field) + " fails") : un instanceof Array ? Go(un) : un instanceof Error && Go(un.message)), un && un.then && un.then(function() {
                  return Go();
                }, function(Ei2) {
                  return Go(Ei2);
                });
              }, function(Gr) {
                pn(Gr);
              }, Ne2);
            }, ge2.getType = function(Ht) {
              if (Ht.type === void 0 && Ht.pattern instanceof RegExp && (Ht.type = "pattern"), typeof Ht.validator != "function" && Ht.type && !VR.hasOwnProperty(Ht.type))
                throw new Error(Qb("Unknown rule type %s", Ht.type));
              return Ht.type || "string";
            }, ge2.getValidationMethod = function(Ht) {
              if (typeof Ht.validator == "function")
                return Ht.validator;
              var qt = Object.keys(Ht), Zt = qt.indexOf("message");
              return Zt !== -1 && qt.splice(Zt, 1), qt.length === 1 && qt[0] === "required" ? VR.required : VR[this.getType(Ht)] || void 0;
            }, Bt;
          }();
          zk.register = function(Bt, ge2) {
            if (typeof ge2 != "function")
              throw new Error("Cannot register a validator by type, validator is not a function");
            VR[Bt] = ge2;
          }, zk.warning = I9, zk.messages = BR, zk.validators = VR;
          var t_ = "'${name}' is not a valid ${type}", zR = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: t_, method: t_, array: t_, object: t_, number: t_, date: t_, boolean: t_, integer: t_, float: t_, regexp: t_, email: t_, url: t_, hex: t_ }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
          function jTt(Bt, ge2) {
            for (var Ht = Bt, qt = 0; qt < ge2.length; qt += 1) {
              if (Ht == null)
                return;
              Ht = Ht[ge2[qt]];
            }
            return Ht;
          }
          function KZt(Bt) {
            return Ta2(Bt) || Uft(Bt) || ql(Bt) || jf2();
          }
          function WTt(Bt, ge2, Ht, qt) {
            if (!ge2.length)
              return Ht;
            var Zt = KZt(ge2), oe2 = Zt[0], Ne2 = Zt.slice(1), Ge2;
            return !Bt && typeof oe2 == "number" ? Ge2 = [] : Array.isArray(Bt) ? Ge2 = wp(Bt) : Ge2 = zi2({}, Bt), qt && Ht === void 0 && Ne2.length === 1 ? delete Ge2[oe2][Ne2[0]] : Ge2[oe2] = WTt(Ge2[oe2], Ne2, Ht, qt), Ge2;
          }
          function XZt(Bt, ge2, Ht) {
            var qt = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
            return ge2.length && qt && Ht === void 0 && !jTt(Bt, ge2.slice(0, -1)) ? Bt : WTt(Bt, ge2, Ht, qt);
          }
          function Py(Bt) {
            return q32(Bt);
          }
          function jk2(Bt, ge2) {
            var Ht = jTt(Bt, ge2);
            return Ht;
          }
          function dT(Bt, ge2, Ht) {
            var qt = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, Zt = XZt(Bt, ge2, Ht, qt);
            return Zt;
          }
          function Yft(Bt, ge2) {
            var Ht = {};
            return ge2.forEach(function(qt) {
              var Zt = jk2(Bt, qt);
              Ht = dT(Ht, qt, Zt);
            }), Ht;
          }
          function En(Bt, ge2) {
            return Bt && Bt.some(function(Ht) {
              return Jh2(Ht, ge2);
            });
          }
          function jR(Bt) {
            return du(Bt) === "object" && Bt !== null && Object.getPrototypeOf(Bt) === Object.prototype;
          }
          function rG(Bt, ge2) {
            var Ht = Array.isArray(Bt) ? wp(Bt) : zi2({}, Bt);
            return ge2 && Object.keys(ge2).forEach(function(qt) {
              var Zt = Ht[qt], oe2 = ge2[qt], Ne2 = jR(Zt) && jR(oe2);
              Ht[qt] = Ne2 ? rG(Zt, oe2 || {}) : oe2;
            }), Ht;
          }
          function Ix(Bt) {
            for (var ge2 = arguments.length, Ht = new Array(ge2 > 1 ? ge2 - 1 : 0), qt = 1; qt < ge2; qt++)
              Ht[qt - 1] = arguments[qt];
            return Ht.reduce(function(Zt, oe2) {
              return rG(Zt, oe2);
            }, Bt);
          }
          function Jh2(Bt, ge2) {
            return !Bt || !ge2 || Bt.length !== ge2.length ? false : Bt.every(function(Ht, qt) {
              return ge2[qt] === Ht;
            });
          }
          function QZt(Bt, ge2) {
            if (Bt === ge2)
              return true;
            if (!Bt && ge2 || Bt && !ge2 || !Bt || !ge2 || du(Bt) !== "object" || du(ge2) !== "object")
              return false;
            var Ht = Object.keys(Bt), qt = Object.keys(ge2), Zt = new Set([].concat(wp(Ht), wp(qt)));
            return wp(Zt).every(function(oe2) {
              var Ne2 = Bt[oe2], Ge2 = ge2[oe2];
              return typeof Ne2 == "function" && typeof Ge2 == "function" ? true : Ne2 === Ge2;
            });
          }
          function JZt(Bt) {
            var ge2 = arguments.length <= 1 ? void 0 : arguments[1];
            return ge2 && ge2.target && du(ge2.target) === "object" && Bt in ge2.target ? ge2.target[Bt] : ge2;
          }
          function GTt(Bt, ge2, Ht) {
            var qt = Bt.length;
            if (ge2 < 0 || ge2 >= qt || Ht < 0 || Ht >= qt)
              return Bt;
            var Zt = Bt[ge2], oe2 = ge2 - Ht;
            return oe2 > 0 ? [].concat(wp(Bt.slice(0, Ht)), [Zt], wp(Bt.slice(Ht, ge2)), wp(Bt.slice(ge2 + 1, qt))) : oe2 < 0 ? [].concat(wp(Bt.slice(0, ge2)), wp(Bt.slice(ge2 + 1, Ht + 1)), [Zt], wp(Bt.slice(Ht + 1, qt))) : Bt;
          }
          var WR = zk;
          function t$t(Bt, ge2) {
            return Bt.replace(/\$\{\w+\}/g, function(Ht) {
              var qt = Ht.slice(2, -1);
              return ge2[qt];
            });
          }
          function Kft(Bt, ge2, Ht, qt, Zt) {
            return Xft.apply(this, arguments);
          }
          function Xft() {
            return Xft = Dl(Ua2.mark(function Bt(ge2, Ht, qt, Zt, oe2) {
              var Ne2, Ge2, Ve, pn, vn, Gn, Lr, Wr;
              return Ua2.wrap(function(Gr) {
                for (; ; )
                  switch (Gr.prev = Gr.next) {
                    case 0:
                      return Ne2 = zi2({}, qt), delete Ne2.ruleIndex, Ge2 = null, Ne2 && Ne2.type === "array" && Ne2.defaultField && (Ge2 = Ne2.defaultField, delete Ne2.defaultField), Ve = new WR(er({}, ge2, [Ne2])), pn = Ix({}, zR, Zt.validateMessages), Ve.messages(pn), vn = [], Gr.prev = 8, Gr.next = 11, Promise.resolve(Ve.validate(er({}, ge2, Ht), zi2({}, Zt)));
                    case 11:
                      Gr.next = 16;
                      break;
                    case 13:
                      Gr.prev = 13, Gr.t0 = Gr.catch(8), Gr.t0.errors ? vn = Gr.t0.errors.map(function(ei2, oi2) {
                        var Va2 = ei2.message;
                        return X3.isValidElement(Va2) ? X3.cloneElement(Va2, { key: "error_".concat(oi2) }) : Va2;
                      }) : (console.error(Gr.t0), vn = [pn.default]);
                    case 16:
                      if (!(!vn.length && Ge2)) {
                        Gr.next = 21;
                        break;
                      }
                      return Gr.next = 19, Promise.all(Ht.map(function(ei2, oi2) {
                        return Kft("".concat(ge2, ".").concat(oi2), ei2, Ge2, Zt, oe2);
                      }));
                    case 19:
                      return Gn = Gr.sent, Gr.abrupt("return", Gn.reduce(function(ei2, oi2) {
                        return [].concat(wp(ei2), wp(oi2));
                      }, []));
                    case 21:
                      return Lr = zi2(zi2({}, qt), {}, { name: ge2, enum: (qt.enum || []).join(", ") }, oe2), Wr = vn.map(function(ei2) {
                        return typeof ei2 == "string" ? t$t(ei2, Lr) : ei2;
                      }), Gr.abrupt("return", Wr);
                    case 24:
                    case "end":
                      return Gr.stop();
                  }
              }, Bt, null, [[8, 13]]);
            })), Xft.apply(this, arguments);
          }
          function e$t(Bt, ge2, Ht, qt, Zt, oe2) {
            var Ne2 = Bt.join("."), Ge2 = Ht.map(function(vn, Gn) {
              var Lr = vn.validator, Wr = zi2(zi2({}, vn), {}, { ruleIndex: Gn });
              return Lr && (Wr.validator = function(Gr, ei2, oi2) {
                var Va2 = false, Ca2 = function() {
                  for (var un = arguments.length, Ei2 = new Array(un), Wi2 = 0; Wi2 < un; Wi2++)
                    Ei2[Wi2] = arguments[Wi2];
                  Promise.resolve().then(function() {
                    gD(!Va2, "Your validator function has already return a promise. `callback` will be ignored."), Va2 || oi2.apply(void 0, Ei2);
                  });
                }, Go = Lr(Gr, ei2, Ca2);
                Va2 = Go && typeof Go.then == "function" && typeof Go.catch == "function", gD(Va2, "`callback` is deprecated. Please return a promise instead."), Va2 && Go.then(function() {
                  oi2();
                }).catch(function(un) {
                  oi2(un || " ");
                });
              }), Wr;
            }).sort(function(vn, Gn) {
              var Lr = vn.warningOnly, Wr = vn.ruleIndex, Gr = Gn.warningOnly, ei2 = Gn.ruleIndex;
              return !!Lr == !!Gr ? Wr - ei2 : Lr ? 1 : -1;
            }), Ve;
            if (Zt === true)
              Ve = new Promise(function() {
                var vn = Dl(Ua2.mark(function Gn(Lr, Wr) {
                  var Gr, ei2, oi2;
                  return Ua2.wrap(function(Va2) {
                    for (; ; )
                      switch (Va2.prev = Va2.next) {
                        case 0:
                          Gr = 0;
                        case 1:
                          if (!(Gr < Ge2.length)) {
                            Va2.next = 12;
                            break;
                          }
                          return ei2 = Ge2[Gr], Va2.next = 5, Kft(Ne2, ge2, ei2, qt, oe2);
                        case 5:
                          if (oi2 = Va2.sent, !oi2.length) {
                            Va2.next = 9;
                            break;
                          }
                          return Wr([{ errors: oi2, rule: ei2 }]), Va2.abrupt("return");
                        case 9:
                          Gr += 1, Va2.next = 1;
                          break;
                        case 12:
                          Lr([]);
                        case 13:
                        case "end":
                          return Va2.stop();
                      }
                  }, Gn);
                }));
                return function(Gn, Lr) {
                  return vn.apply(this, arguments);
                };
              }());
            else {
              var pn = Ge2.map(function(vn) {
                return Kft(Ne2, ge2, vn, qt, oe2).then(function(Gn) {
                  return { errors: Gn, rule: vn };
                });
              });
              Ve = (Zt ? r$t(pn) : n$t(pn)).then(function(vn) {
                return Promise.reject(vn);
              });
            }
            return Ve.catch(function(vn) {
              return vn;
            }), Ve;
          }
          function n$t(Bt) {
            return gT.apply(this, arguments);
          }
          function gT() {
            return gT = Dl(Ua2.mark(function Bt(ge2) {
              return Ua2.wrap(function(Ht) {
                for (; ; )
                  switch (Ht.prev = Ht.next) {
                    case 0:
                      return Ht.abrupt("return", Promise.all(ge2).then(function(qt) {
                        var Zt, oe2 = (Zt = []).concat.apply(Zt, wp(qt));
                        return oe2;
                      }));
                    case 1:
                    case "end":
                      return Ht.stop();
                  }
              }, Bt);
            })), gT.apply(this, arguments);
          }
          function r$t(Bt) {
            return Qft.apply(this, arguments);
          }
          function Qft() {
            return Qft = Dl(Ua2.mark(function Bt(ge2) {
              var Ht;
              return Ua2.wrap(function(qt) {
                for (; ; )
                  switch (qt.prev = qt.next) {
                    case 0:
                      return Ht = 0, qt.abrupt("return", new Promise(function(Zt) {
                        ge2.forEach(function(oe2) {
                          oe2.then(function(Ne2) {
                            Ne2.errors.length && Zt([Ne2]), Ht += 1, Ht === ge2.length && Zt([]);
                          });
                        });
                      }));
                    case 2:
                    case "end":
                      return qt.stop();
                  }
              }, Bt);
            })), Qft.apply(this, arguments);
          }
          var i$t = ["name"], kM = [];
          function HTt(Bt, ge2, Ht, qt, Zt, oe2) {
            return typeof Bt == "function" ? Bt(ge2, Ht, "source" in oe2 ? { source: oe2.source } : {}) : qt !== Zt;
          }
          var vT = function(Bt) {
            x9(Ht, Bt);
            var ge2 = HW(Ht);
            function Ht(qt) {
              var Zt;
              if (WW(this, Ht), Zt = ge2.call(this, qt), Zt.state = { resetCount: 0 }, Zt.cancelRegisterFunc = null, Zt.mounted = false, Zt.touched = false, Zt.dirty = false, Zt.validatePromise = null, Zt.prevValidating = void 0, Zt.errors = kM, Zt.warnings = kM, Zt.cancelRegister = function() {
                var Ve = Zt.props, pn = Ve.preserve, vn = Ve.isListField, Gn = Ve.name;
                Zt.cancelRegisterFunc && Zt.cancelRegisterFunc(vn, pn, Py(Gn)), Zt.cancelRegisterFunc = null;
              }, Zt.getNamePath = function() {
                var Ve = Zt.props, pn = Ve.name, vn = Ve.fieldContext, Gn = vn.prefixName, Lr = Gn === void 0 ? [] : Gn;
                return pn !== void 0 ? [].concat(wp(Lr), wp(pn)) : [];
              }, Zt.getRules = function() {
                var Ve = Zt.props, pn = Ve.rules, vn = pn === void 0 ? [] : pn, Gn = Ve.fieldContext;
                return vn.map(function(Lr) {
                  return typeof Lr == "function" ? Lr(Gn) : Lr;
                });
              }, Zt.refresh = function() {
                !Zt.mounted || Zt.setState(function(Ve) {
                  var pn = Ve.resetCount;
                  return { resetCount: pn + 1 };
                });
              }, Zt.triggerMetaEvent = function(Ve) {
                var pn = Zt.props.onMetaChange;
                pn == null || pn(zi2(zi2({}, Zt.getMeta()), {}, { destroy: Ve }));
              }, Zt.onStoreChange = function(Ve, pn, vn) {
                var Gn = Zt.props, Lr = Gn.shouldUpdate, Wr = Gn.dependencies, Gr = Wr === void 0 ? [] : Wr, ei2 = Gn.onReset, oi2 = vn.store, Va2 = Zt.getNamePath(), Ca2 = Zt.getValue(Ve), Go = Zt.getValue(oi2), un = pn && En(pn, Va2);
                switch (vn.type === "valueUpdate" && vn.source === "external" && Ca2 !== Go && (Zt.touched = true, Zt.dirty = true, Zt.validatePromise = null, Zt.errors = kM, Zt.warnings = kM, Zt.triggerMetaEvent()), vn.type) {
                  case "reset":
                    if (!pn || un) {
                      Zt.touched = false, Zt.dirty = false, Zt.validatePromise = null, Zt.errors = kM, Zt.warnings = kM, Zt.triggerMetaEvent(), ei2 == null || ei2(), Zt.refresh();
                      return;
                    }
                    break;
                  case "remove": {
                    if (Lr) {
                      Zt.reRender();
                      return;
                    }
                    break;
                  }
                  case "setField": {
                    if (un) {
                      var Ei2 = vn.data;
                      "touched" in Ei2 && (Zt.touched = Ei2.touched), "validating" in Ei2 && !("originRCField" in Ei2) && (Zt.validatePromise = Ei2.validating ? Promise.resolve([]) : null), "errors" in Ei2 && (Zt.errors = Ei2.errors || kM), "warnings" in Ei2 && (Zt.warnings = Ei2.warnings || kM), Zt.dirty = true, Zt.triggerMetaEvent(), Zt.reRender();
                      return;
                    }
                    if (Lr && !Va2.length && HTt(Lr, Ve, oi2, Ca2, Go, vn)) {
                      Zt.reRender();
                      return;
                    }
                    break;
                  }
                  case "dependenciesUpdate": {
                    var Wi2 = Gr.map(Py);
                    if (Wi2.some(function(La2) {
                      return En(vn.relatedFields, La2);
                    })) {
                      Zt.reRender();
                      return;
                    }
                    break;
                  }
                  default:
                    if (un || (!Gr.length || Va2.length || Lr) && HTt(Lr, Ve, oi2, Ca2, Go, vn)) {
                      Zt.reRender();
                      return;
                    }
                    break;
                }
                Lr === true && Zt.reRender();
              }, Zt.validateRules = function(Ve) {
                var pn = Zt.getNamePath(), vn = Zt.getValue(), Gn = Promise.resolve().then(function() {
                  if (!Zt.mounted)
                    return [];
                  var Lr = Zt.props, Wr = Lr.validateFirst, Gr = Wr === void 0 ? false : Wr, ei2 = Lr.messageVariables, oi2 = Ve || {}, Va2 = oi2.triggerName, Ca2 = Zt.getRules();
                  Va2 && (Ca2 = Ca2.filter(function(un) {
                    var Ei2 = un.validateTrigger;
                    if (!Ei2)
                      return true;
                    var Wi2 = q32(Ei2);
                    return Wi2.includes(Va2);
                  }));
                  var Go = e$t(pn, vn, Ca2, Ve, Gr, ei2);
                  return Go.catch(function(un) {
                    return un;
                  }).then(function() {
                    var un = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : kM;
                    if (Zt.validatePromise === Gn) {
                      Zt.validatePromise = null;
                      var Ei2 = [], Wi2 = [];
                      un.forEach(function(La2) {
                        var Aa2 = La2.rule.warningOnly, Oi2 = La2.errors, Zi2 = Oi2 === void 0 ? kM : Oi2;
                        Aa2 ? Wi2.push.apply(Wi2, wp(Zi2)) : Ei2.push.apply(Ei2, wp(Zi2));
                      }), Zt.errors = Ei2, Zt.warnings = Wi2, Zt.triggerMetaEvent(), Zt.reRender();
                    }
                  }), Go;
                });
                return Zt.validatePromise = Gn, Zt.dirty = true, Zt.errors = kM, Zt.warnings = kM, Zt.triggerMetaEvent(), Zt.reRender(), Gn;
              }, Zt.isFieldValidating = function() {
                return !!Zt.validatePromise;
              }, Zt.isFieldTouched = function() {
                return Zt.touched;
              }, Zt.isFieldDirty = function() {
                if (Zt.dirty || Zt.props.initialValue !== void 0)
                  return true;
                var Ve = Zt.props.fieldContext, pn = Ve.getInternalHooks(T9), vn = pn.getInitialValue;
                return vn(Zt.getNamePath()) !== void 0;
              }, Zt.getErrors = function() {
                return Zt.errors;
              }, Zt.getWarnings = function() {
                return Zt.warnings;
              }, Zt.isListField = function() {
                return Zt.props.isListField;
              }, Zt.isList = function() {
                return Zt.props.isList;
              }, Zt.isPreserve = function() {
                return Zt.props.preserve;
              }, Zt.getMeta = function() {
                Zt.prevValidating = Zt.isFieldValidating();
                var Ve = { touched: Zt.isFieldTouched(), validating: Zt.prevValidating, errors: Zt.errors, warnings: Zt.warnings, name: Zt.getNamePath() };
                return Ve;
              }, Zt.getOnlyChild = function(Ve) {
                if (typeof Ve == "function") {
                  var pn = Zt.getMeta();
                  return zi2(zi2({}, Zt.getOnlyChild(Ve(Zt.getControlled(), pn, Zt.props.fieldContext))), {}, { isFunction: true });
                }
                var vn = M9(Ve);
                return vn.length !== 1 || !X3.isValidElement(vn[0]) ? { child: vn, isFunction: false } : { child: vn[0], isFunction: false };
              }, Zt.getValue = function(Ve) {
                var pn = Zt.props.fieldContext.getFieldsValue, vn = Zt.getNamePath();
                return jk2(Ve || pn(true), vn);
              }, Zt.getControlled = function() {
                var Ve = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, pn = Zt.props, vn = pn.trigger, Gn = pn.validateTrigger, Lr = pn.getValueFromEvent, Wr = pn.normalize, Gr = pn.valuePropName, ei2 = pn.getValueProps, oi2 = pn.fieldContext, Va2 = Gn !== void 0 ? Gn : oi2.validateTrigger, Ca2 = Zt.getNamePath(), Go = oi2.getInternalHooks, un = oi2.getFieldsValue, Ei2 = Go(T9), Wi2 = Ei2.dispatch, La2 = Zt.getValue(), Aa2 = ei2 || function(Fo) {
                  return er({}, Gr, Fo);
                }, Oi2 = Ve[vn], Zi2 = zi2(zi2({}, Ve), Aa2(La2));
                Zi2[vn] = function() {
                  Zt.touched = true, Zt.dirty = true, Zt.triggerMetaEvent();
                  for (var Fo, Si2 = arguments.length, bl = new Array(Si2), vl = 0; vl < Si2; vl++)
                    bl[vl] = arguments[vl];
                  Lr ? Fo = Lr.apply(void 0, bl) : Fo = JZt.apply(void 0, [Gr].concat(bl)), Wr && (Fo = Wr(Fo, La2, un(true))), Wi2({ type: "updateValue", namePath: Ca2, value: Fo }), Oi2 && Oi2.apply(void 0, bl);
                };
                var Ka2 = q32(Va2 || []);
                return Ka2.forEach(function(Fo) {
                  var Si2 = Zi2[Fo];
                  Zi2[Fo] = function() {
                    Si2 && Si2.apply(void 0, arguments);
                    var bl = Zt.props.rules;
                    bl && bl.length && Wi2({ type: "validateField", namePath: Ca2, triggerName: Fo });
                  };
                }), Zi2;
              }, qt.fieldContext) {
                var oe2 = qt.fieldContext.getInternalHooks, Ne2 = oe2(T9), Ge2 = Ne2.initEntityValue;
                Ge2(nQ(Zt));
              }
              return Zt;
            }
            return GW(Ht, [{ key: "componentDidMount", value: function() {
              var qt = this.props, Zt = qt.shouldUpdate, oe2 = qt.fieldContext;
              if (this.mounted = true, oe2) {
                var Ne2 = oe2.getInternalHooks, Ge2 = Ne2(T9), Ve = Ge2.registerField;
                this.cancelRegisterFunc = Ve(this);
              }
              Zt === true && this.reRender();
            } }, { key: "componentWillUnmount", value: function() {
              this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
            } }, { key: "reRender", value: function() {
              !this.mounted || this.forceUpdate();
            } }, { key: "render", value: function() {
              var qt = this.state.resetCount, Zt = this.props.children, oe2 = this.getOnlyChild(Zt), Ne2 = oe2.child, Ge2 = oe2.isFunction, Ve;
              return Ge2 ? Ve = Ne2 : X3.isValidElement(Ne2) ? Ve = X3.cloneElement(Ne2, this.getControlled(Ne2.props)) : (gD(!Ne2, "`children` of Field is not validate ReactElement."), Ve = Ne2), X3.createElement(X3.Fragment, { key: qt }, Ve);
            } }]), Ht;
          }(X3.Component);
          vT.contextType = KW, vT.defaultProps = { trigger: "onChange", valuePropName: "value" };
          function UTt(Bt) {
            var ge2 = Bt.name, Ht = jc2(Bt, i$t), qt = X3.useContext(KW), Zt = ge2 !== void 0 ? Py(ge2) : void 0, oe2 = "keep";
            return Ht.isListField || (oe2 = "_".concat((Zt || []).join("_"))), X3.createElement(vT, L0({ key: oe2, name: Zt }, Ht, { fieldContext: qt }));
          }
          var a$t = X3.createContext(null), o$t = function(Bt) {
            var ge2 = Bt.name, Ht = Bt.initialValue, qt = Bt.children, Zt = Bt.rules, oe2 = Bt.validateTrigger, Ne2 = X3.useContext(KW), Ge2 = X3.useRef({ keys: [], id: 0 }), Ve = Ge2.current, pn = X3.useMemo(function() {
              var Wr = Py(Ne2.prefixName) || [];
              return [].concat(wp(Wr), wp(Py(ge2)));
            }, [Ne2.prefixName, ge2]), vn = X3.useMemo(function() {
              return zi2(zi2({}, Ne2), {}, { prefixName: pn });
            }, [Ne2, pn]), Gn = X3.useMemo(function() {
              return { getKey: function(Wr) {
                var Gr = pn.length, ei2 = Wr[Gr];
                return [Ve.keys[ei2], Wr.slice(Gr + 1)];
              } };
            }, [pn]);
            if (typeof qt != "function")
              return gD(false, "Form.List only accepts function as children."), null;
            var Lr = function(Wr, Gr, ei2) {
              var oi2 = ei2.source;
              return oi2 === "internal" ? false : Wr !== Gr;
            };
            return X3.createElement(a$t.Provider, { value: Gn }, X3.createElement(KW.Provider, { value: vn }, X3.createElement(UTt, { name: [], shouldUpdate: Lr, rules: Zt, validateTrigger: oe2, initialValue: Ht, isList: true }, function(Wr, Gr) {
              var ei2 = Wr.value, oi2 = ei2 === void 0 ? [] : ei2, Va2 = Wr.onChange, Ca2 = Ne2.getFieldValue, Go = function() {
                var Wi2 = Ca2(pn || []);
                return Wi2 || [];
              }, un = { add: function(Wi2, La2) {
                var Aa2 = Go();
                La2 >= 0 && La2 <= Aa2.length ? (Ve.keys = [].concat(wp(Ve.keys.slice(0, La2)), [Ve.id], wp(Ve.keys.slice(La2))), Va2([].concat(wp(Aa2.slice(0, La2)), [Wi2], wp(Aa2.slice(La2))))) : (Ve.keys = [].concat(wp(Ve.keys), [Ve.id]), Va2([].concat(wp(Aa2), [Wi2]))), Ve.id += 1;
              }, remove: function(Wi2) {
                var La2 = Go(), Aa2 = new Set(Array.isArray(Wi2) ? Wi2 : [Wi2]);
                Aa2.size <= 0 || (Ve.keys = Ve.keys.filter(function(Oi2, Zi2) {
                  return !Aa2.has(Zi2);
                }), Va2(La2.filter(function(Oi2, Zi2) {
                  return !Aa2.has(Zi2);
                })));
              }, move: function(Wi2, La2) {
                if (Wi2 !== La2) {
                  var Aa2 = Go();
                  Wi2 < 0 || Wi2 >= Aa2.length || La2 < 0 || La2 >= Aa2.length || (Ve.keys = GTt(Ve.keys, Wi2, La2), Va2(GTt(Aa2, Wi2, La2)));
                }
              } }, Ei2 = oi2 || [];
              return Array.isArray(Ei2) || (Ei2 = []), qt(Ei2.map(function(Wi2, La2) {
                var Aa2 = Ve.keys[La2];
                return Aa2 === void 0 && (Ve.keys[La2] = Ve.id, Aa2 = Ve.keys[La2], Ve.id += 1), { name: La2, key: Aa2, isListField: true };
              }), un, Gr);
            })));
          };
          function s$t(Bt) {
            var ge2 = false, Ht = Bt.length, qt = [];
            return Bt.length ? new Promise(function(Zt, oe2) {
              Bt.forEach(function(Ne2, Ge2) {
                Ne2.catch(function(Ve) {
                  return ge2 = true, Ve;
                }).then(function(Ve) {
                  Ht -= 1, qt[Ge2] = Ve, !(Ht > 0) && (ge2 && oe2(qt), Zt(qt));
                });
              });
            }) : Promise.resolve([]);
          }
          var qTt = "__@field_split__";
          function Wk(Bt) {
            return Bt.map(function(ge2) {
              return "".concat(du(ge2), ":").concat(ge2);
            }).join(qTt);
          }
          var iG = function() {
            function Bt() {
              WW(this, Bt), this.kvs = /* @__PURE__ */ new Map();
            }
            return GW(Bt, [{ key: "set", value: function(ge2, Ht) {
              this.kvs.set(Wk(ge2), Ht);
            } }, { key: "get", value: function(ge2) {
              return this.kvs.get(Wk(ge2));
            } }, { key: "update", value: function(ge2, Ht) {
              var qt = this.get(ge2), Zt = Ht(qt);
              Zt ? this.set(ge2, Zt) : this.delete(ge2);
            } }, { key: "delete", value: function(ge2) {
              this.kvs.delete(Wk(ge2));
            } }, { key: "map", value: function(ge2) {
              return wp(this.kvs.entries()).map(function(Ht) {
                var qt = Ic2(Ht, 2), Zt = qt[0], oe2 = qt[1], Ne2 = Zt.split(qTt);
                return ge2({ key: Ne2.map(function(Ge2) {
                  var Ve = Ge2.match(/^([^:]*):(.*)$/), pn = Ic2(Ve, 3), vn = pn[1], Gn = pn[2];
                  return vn === "number" ? Number(Gn) : Gn;
                }), value: oe2 });
              });
            } }, { key: "toJSON", value: function() {
              var ge2 = {};
              return this.map(function(Ht) {
                var qt = Ht.key, Zt = Ht.value;
                return ge2[qt.join(".")] = Zt, null;
              }), ge2;
            } }]), Bt;
          }(), l$t = ["name", "errors"], yT = GW(function Bt(ge2) {
            var Ht = this;
            WW(this, Bt), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
              return { getFieldValue: Ht.getFieldValue, getFieldsValue: Ht.getFieldsValue, getFieldError: Ht.getFieldError, getFieldWarning: Ht.getFieldWarning, getFieldsError: Ht.getFieldsError, isFieldsTouched: Ht.isFieldsTouched, isFieldTouched: Ht.isFieldTouched, isFieldValidating: Ht.isFieldValidating, isFieldsValidating: Ht.isFieldsValidating, resetFields: Ht.resetFields, setFields: Ht.setFields, setFieldsValue: Ht.setFieldsValue, validateFields: Ht.validateFields, submit: Ht.submit, getInternalHooks: Ht.getInternalHooks };
            }, this.getInternalHooks = function(qt) {
              return qt === T9 ? (Ht.formHooked = true, { dispatch: Ht.dispatch, initEntityValue: Ht.initEntityValue, registerField: Ht.registerField, useSubscribe: Ht.useSubscribe, setInitialValues: Ht.setInitialValues, setCallbacks: Ht.setCallbacks, setValidateMessages: Ht.setValidateMessages, getFields: Ht.getFields, setPreserve: Ht.setPreserve, getInitialValue: Ht.getInitialValue }) : (gD(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
            }, this.useSubscribe = function(qt) {
              Ht.subscribable = qt;
            }, this.setInitialValues = function(qt, Zt) {
              Ht.initialValues = qt || {}, Zt && (Ht.store = Ix({}, qt, Ht.store));
            }, this.getInitialValue = function(qt) {
              return jk2(Ht.initialValues, qt);
            }, this.setCallbacks = function(qt) {
              Ht.callbacks = qt;
            }, this.setValidateMessages = function(qt) {
              Ht.validateMessages = qt;
            }, this.setPreserve = function(qt) {
              Ht.preserve = qt;
            }, this.timeoutId = null, this.warningUnhooked = function() {
            }, this.getFieldEntities = function() {
              var qt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
              return qt ? Ht.fieldEntities.filter(function(Zt) {
                return Zt.getNamePath().length;
              }) : Ht.fieldEntities;
            }, this.getFieldsMap = function() {
              var qt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, Zt = new iG();
              return Ht.getFieldEntities(qt).forEach(function(oe2) {
                var Ne2 = oe2.getNamePath();
                Zt.set(Ne2, oe2);
              }), Zt;
            }, this.getFieldEntitiesForNamePathList = function(qt) {
              if (!qt)
                return Ht.getFieldEntities(true);
              var Zt = Ht.getFieldsMap(true);
              return qt.map(function(oe2) {
                var Ne2 = Py(oe2);
                return Zt.get(Ne2) || { INVALIDATE_NAME_PATH: Py(oe2) };
              });
            }, this.getFieldsValue = function(qt, Zt) {
              if (Ht.warningUnhooked(), qt === true && !Zt)
                return Ht.store;
              var oe2 = Ht.getFieldEntitiesForNamePathList(Array.isArray(qt) ? qt : null), Ne2 = [];
              return oe2.forEach(function(Ge2) {
                var Ve, pn = "INVALIDATE_NAME_PATH" in Ge2 ? Ge2.INVALIDATE_NAME_PATH : Ge2.getNamePath();
                if (!(!qt && ((Ve = Ge2.isListField) === null || Ve === void 0 ? void 0 : Ve.call(Ge2))))
                  if (!Zt)
                    Ne2.push(pn);
                  else {
                    var vn = "getMeta" in Ge2 ? Ge2.getMeta() : null;
                    Zt(vn) && Ne2.push(pn);
                  }
              }), Yft(Ht.store, Ne2.map(Py));
            }, this.getFieldValue = function(qt) {
              Ht.warningUnhooked();
              var Zt = Py(qt);
              return jk2(Ht.store, Zt);
            }, this.getFieldsError = function(qt) {
              Ht.warningUnhooked();
              var Zt = Ht.getFieldEntitiesForNamePathList(qt);
              return Zt.map(function(oe2, Ne2) {
                return oe2 && !("INVALIDATE_NAME_PATH" in oe2) ? { name: oe2.getNamePath(), errors: oe2.getErrors(), warnings: oe2.getWarnings() } : { name: Py(qt[Ne2]), errors: [], warnings: [] };
              });
            }, this.getFieldError = function(qt) {
              Ht.warningUnhooked();
              var Zt = Py(qt), oe2 = Ht.getFieldsError([Zt])[0];
              return oe2.errors;
            }, this.getFieldWarning = function(qt) {
              Ht.warningUnhooked();
              var Zt = Py(qt), oe2 = Ht.getFieldsError([Zt])[0];
              return oe2.warnings;
            }, this.isFieldsTouched = function() {
              Ht.warningUnhooked();
              for (var qt = arguments.length, Zt = new Array(qt), oe2 = 0; oe2 < qt; oe2++)
                Zt[oe2] = arguments[oe2];
              var Ne2 = Zt[0], Ge2 = Zt[1], Ve, pn = false;
              Zt.length === 0 ? Ve = null : Zt.length === 1 ? Array.isArray(Ne2) ? (Ve = Ne2.map(Py), pn = false) : (Ve = null, pn = Ne2) : (Ve = Ne2.map(Py), pn = Ge2);
              var vn = Ht.getFieldEntities(true), Gn = function(ei2) {
                return ei2.isFieldTouched();
              };
              if (!Ve)
                return pn ? vn.every(Gn) : vn.some(Gn);
              var Lr = new iG();
              Ve.forEach(function(ei2) {
                Lr.set(ei2, []);
              }), vn.forEach(function(ei2) {
                var oi2 = ei2.getNamePath();
                Ve.forEach(function(Va2) {
                  Va2.every(function(Ca2, Go) {
                    return oi2[Go] === Ca2;
                  }) && Lr.update(Va2, function(Ca2) {
                    return [].concat(wp(Ca2), [ei2]);
                  });
                });
              });
              var Wr = function(ei2) {
                return ei2.some(Gn);
              }, Gr = Lr.map(function(ei2) {
                var oi2 = ei2.value;
                return oi2;
              });
              return pn ? Gr.every(Wr) : Gr.some(Wr);
            }, this.isFieldTouched = function(qt) {
              return Ht.warningUnhooked(), Ht.isFieldsTouched([qt]);
            }, this.isFieldsValidating = function(qt) {
              Ht.warningUnhooked();
              var Zt = Ht.getFieldEntities();
              if (!qt)
                return Zt.some(function(Ne2) {
                  return Ne2.isFieldValidating();
                });
              var oe2 = qt.map(Py);
              return Zt.some(function(Ne2) {
                var Ge2 = Ne2.getNamePath();
                return En(oe2, Ge2) && Ne2.isFieldValidating();
              });
            }, this.isFieldValidating = function(qt) {
              return Ht.warningUnhooked(), Ht.isFieldsValidating([qt]);
            }, this.resetWithFieldInitialValue = function() {
              var qt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Zt = new iG(), oe2 = Ht.getFieldEntities(true);
              oe2.forEach(function(Ve) {
                var pn = Ve.props.initialValue, vn = Ve.getNamePath();
                if (pn !== void 0) {
                  var Gn = Zt.get(vn) || /* @__PURE__ */ new Set();
                  Gn.add({ entity: Ve, value: pn }), Zt.set(vn, Gn);
                }
              });
              var Ne2 = function(Ve) {
                Ve.forEach(function(pn) {
                  var vn = pn.props.initialValue;
                  if (vn !== void 0) {
                    var Gn = pn.getNamePath(), Lr = Ht.getInitialValue(Gn);
                    if (Lr !== void 0)
                      gD(false, "Form already set 'initialValues' with path '".concat(Gn.join("."), "'. Field can not overwrite it."));
                    else {
                      var Wr = Zt.get(Gn);
                      if (Wr && Wr.size > 1)
                        gD(false, "Multiple Field with path '".concat(Gn.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                      else if (Wr) {
                        var Gr = Ht.getFieldValue(Gn);
                        (!qt.skipExist || Gr === void 0) && (Ht.store = dT(Ht.store, Gn, wp(Wr)[0].value));
                      }
                    }
                  }
                });
              }, Ge2;
              qt.entities ? Ge2 = qt.entities : qt.namePathList ? (Ge2 = [], qt.namePathList.forEach(function(Ve) {
                var pn = Zt.get(Ve);
                if (pn) {
                  var vn;
                  (vn = Ge2).push.apply(vn, wp(wp(pn).map(function(Gn) {
                    return Gn.entity;
                  })));
                }
              })) : Ge2 = oe2, Ne2(Ge2);
            }, this.resetFields = function(qt) {
              Ht.warningUnhooked();
              var Zt = Ht.store;
              if (!qt) {
                Ht.store = Ix({}, Ht.initialValues), Ht.resetWithFieldInitialValue(), Ht.notifyObservers(Zt, null, { type: "reset" });
                return;
              }
              var oe2 = qt.map(Py);
              oe2.forEach(function(Ne2) {
                var Ge2 = Ht.getInitialValue(Ne2);
                Ht.store = dT(Ht.store, Ne2, Ge2);
              }), Ht.resetWithFieldInitialValue({ namePathList: oe2 }), Ht.notifyObservers(Zt, oe2, { type: "reset" });
            }, this.setFields = function(qt) {
              Ht.warningUnhooked();
              var Zt = Ht.store;
              qt.forEach(function(oe2) {
                var Ne2 = oe2.name;
                oe2.errors;
                var Ge2 = jc2(oe2, l$t), Ve = Py(Ne2);
                "value" in Ge2 && (Ht.store = dT(Ht.store, Ve, Ge2.value)), Ht.notifyObservers(Zt, [Ve], { type: "setField", data: oe2 });
              });
            }, this.getFields = function() {
              var qt = Ht.getFieldEntities(true), Zt = qt.map(function(oe2) {
                var Ne2 = oe2.getNamePath(), Ge2 = oe2.getMeta(), Ve = zi2(zi2({}, Ge2), {}, { name: Ne2, value: Ht.getFieldValue(Ne2) });
                return Object.defineProperty(Ve, "originRCField", { value: true }), Ve;
              });
              return Zt;
            }, this.initEntityValue = function(qt) {
              var Zt = qt.props.initialValue;
              if (Zt !== void 0) {
                var oe2 = qt.getNamePath(), Ne2 = jk2(Ht.store, oe2);
                Ne2 === void 0 && (Ht.store = dT(Ht.store, oe2, Zt));
              }
            }, this.registerField = function(qt) {
              if (Ht.fieldEntities.push(qt), qt.props.initialValue !== void 0) {
                var Zt = Ht.store;
                Ht.resetWithFieldInitialValue({ entities: [qt], skipExist: true }), Ht.notifyObservers(Zt, [qt.getNamePath()], { type: "valueUpdate", source: "internal" });
              }
              return function(oe2, Ne2) {
                var Ge2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
                Ht.fieldEntities = Ht.fieldEntities.filter(function(Lr) {
                  return Lr !== qt;
                });
                var Ve = Ne2 !== void 0 ? Ne2 : Ht.preserve;
                if (Ve === false && (!oe2 || Ge2.length > 1)) {
                  var pn = qt.getNamePath(), vn = oe2 ? void 0 : jk2(Ht.initialValues, pn);
                  if (pn.length && Ht.getFieldValue(pn) !== vn && Ht.fieldEntities.every(function(Lr) {
                    return !Jh2(Lr.getNamePath(), pn);
                  })) {
                    var Gn = Ht.store;
                    Ht.store = dT(Gn, pn, vn, true), Ht.notifyObservers(Gn, [pn], { type: "remove" }), Ht.triggerDependenciesUpdate(Gn, pn);
                  }
                }
              };
            }, this.dispatch = function(qt) {
              switch (qt.type) {
                case "updateValue": {
                  var Zt = qt.namePath, oe2 = qt.value;
                  Ht.updateValue(Zt, oe2);
                  break;
                }
                case "validateField": {
                  var Ne2 = qt.namePath, Ge2 = qt.triggerName;
                  Ht.validateFields([Ne2], { triggerName: Ge2 });
                  break;
                }
              }
            }, this.notifyObservers = function(qt, Zt, oe2) {
              if (Ht.subscribable) {
                var Ne2 = zi2(zi2({}, oe2), {}, { store: Ht.getFieldsValue(true) });
                Ht.getFieldEntities().forEach(function(Ge2) {
                  var Ve = Ge2.onStoreChange;
                  Ve(qt, Zt, Ne2);
                });
              } else
                Ht.forceRootUpdate();
            }, this.triggerDependenciesUpdate = function(qt, Zt) {
              var oe2 = Ht.getDependencyChildrenFields(Zt);
              return oe2.length && Ht.validateFields(oe2), Ht.notifyObservers(qt, oe2, { type: "dependenciesUpdate", relatedFields: [Zt].concat(wp(oe2)) }), oe2;
            }, this.updateValue = function(qt, Zt) {
              var oe2 = Py(qt), Ne2 = Ht.store;
              Ht.store = dT(Ht.store, oe2, Zt), Ht.notifyObservers(Ne2, [oe2], { type: "valueUpdate", source: "internal" });
              var Ge2 = Ht.triggerDependenciesUpdate(Ne2, oe2), Ve = Ht.callbacks.onValuesChange;
              if (Ve) {
                var pn = Yft(Ht.store, [oe2]);
                Ve(pn, Ht.getFieldsValue());
              }
              Ht.triggerOnFieldsChange([oe2].concat(wp(Ge2)));
            }, this.setFieldsValue = function(qt) {
              Ht.warningUnhooked();
              var Zt = Ht.store;
              qt && (Ht.store = Ix(Ht.store, qt)), Ht.notifyObservers(Zt, null, { type: "valueUpdate", source: "external" });
            }, this.getDependencyChildrenFields = function(qt) {
              var Zt = /* @__PURE__ */ new Set(), oe2 = [], Ne2 = new iG();
              Ht.getFieldEntities().forEach(function(Ve) {
                var pn = Ve.props.dependencies;
                (pn || []).forEach(function(vn) {
                  var Gn = Py(vn);
                  Ne2.update(Gn, function() {
                    var Lr = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                    return Lr.add(Ve), Lr;
                  });
                });
              });
              var Ge2 = function Ve(pn) {
                var vn = Ne2.get(pn) || /* @__PURE__ */ new Set();
                vn.forEach(function(Gn) {
                  if (!Zt.has(Gn)) {
                    Zt.add(Gn);
                    var Lr = Gn.getNamePath();
                    Gn.isFieldDirty() && Lr.length && (oe2.push(Lr), Ve(Lr));
                  }
                });
              };
              return Ge2(qt), oe2;
            }, this.triggerOnFieldsChange = function(qt, Zt) {
              var oe2 = Ht.callbacks.onFieldsChange;
              if (oe2) {
                var Ne2 = Ht.getFields();
                if (Zt) {
                  var Ge2 = new iG();
                  Zt.forEach(function(pn) {
                    var vn = pn.name, Gn = pn.errors;
                    Ge2.set(vn, Gn);
                  }), Ne2.forEach(function(pn) {
                    pn.errors = Ge2.get(pn.name) || pn.errors;
                  });
                }
                var Ve = Ne2.filter(function(pn) {
                  var vn = pn.name;
                  return En(qt, vn);
                });
                oe2(Ve, Ne2);
              }
            }, this.validateFields = function(qt, Zt) {
              Ht.warningUnhooked();
              var oe2 = !!qt, Ne2 = oe2 ? qt.map(Py) : [], Ge2 = [];
              Ht.getFieldEntities(true).forEach(function(vn) {
                if (oe2 || Ne2.push(vn.getNamePath()), (Zt == null ? void 0 : Zt.recursive) && oe2) {
                  var Gn = vn.getNamePath();
                  Gn.every(function(Gr, ei2) {
                    return qt[ei2] === Gr || qt[ei2] === void 0;
                  }) && Ne2.push(Gn);
                }
                if (!(!vn.props.rules || !vn.props.rules.length)) {
                  var Lr = vn.getNamePath();
                  if (!oe2 || En(Ne2, Lr)) {
                    var Wr = vn.validateRules(zi2({ validateMessages: zi2(zi2({}, zR), Ht.validateMessages) }, Zt));
                    Ge2.push(Wr.then(function() {
                      return { name: Lr, errors: [], warnings: [] };
                    }).catch(function(Gr) {
                      var ei2 = [], oi2 = [];
                      return Gr.forEach(function(Va2) {
                        var Ca2 = Va2.rule.warningOnly, Go = Va2.errors;
                        Ca2 ? oi2.push.apply(oi2, wp(Go)) : ei2.push.apply(ei2, wp(Go));
                      }), ei2.length ? Promise.reject({ name: Lr, errors: ei2, warnings: oi2 }) : { name: Lr, errors: ei2, warnings: oi2 };
                    }));
                  }
                }
              });
              var Ve = s$t(Ge2);
              Ht.lastValidatePromise = Ve, Ve.catch(function(vn) {
                return vn;
              }).then(function(vn) {
                var Gn = vn.map(function(Lr) {
                  var Wr = Lr.name;
                  return Wr;
                });
                Ht.notifyObservers(Ht.store, Gn, { type: "validateFinish" }), Ht.triggerOnFieldsChange(Gn, vn);
              });
              var pn = Ve.then(function() {
                return Ht.lastValidatePromise === Ve ? Promise.resolve(Ht.getFieldsValue(Ne2)) : Promise.reject([]);
              }).catch(function(vn) {
                var Gn = vn.filter(function(Lr) {
                  return Lr && Lr.errors.length;
                });
                return Promise.reject({ values: Ht.getFieldsValue(Ne2), errorFields: Gn, outOfDate: Ht.lastValidatePromise !== Ve });
              });
              return pn.catch(function(vn) {
                return vn;
              }), pn;
            }, this.submit = function() {
              Ht.warningUnhooked(), Ht.validateFields().then(function(qt) {
                var Zt = Ht.callbacks.onFinish;
                if (Zt)
                  try {
                    Zt(qt);
                  } catch (oe2) {
                    console.error(oe2);
                  }
              }).catch(function(qt) {
                var Zt = Ht.callbacks.onFinishFailed;
                Zt && Zt(qt);
              });
            }, this.forceRootUpdate = ge2;
          });
          function ZTt(Bt) {
            var ge2 = X3.useRef(), Ht = X3.useState({}), qt = Ic2(Ht, 2), Zt = qt[1];
            if (!ge2.current)
              if (Bt)
                ge2.current = Bt;
              else {
                var oe2 = function() {
                  Zt({});
                }, Ne2 = new yT(oe2);
                ge2.current = Ne2.getForm();
              }
            return [ge2.current];
          }
          var Jft = X3.createContext({ triggerFormChange: function() {
          }, triggerFormFinish: function() {
          }, registerForm: function() {
          }, unregisterForm: function() {
          } }), u$t = function(Bt) {
            var ge2 = Bt.validateMessages, Ht = Bt.onFormChange, qt = Bt.onFormFinish, Zt = Bt.children, oe2 = X3.useContext(Jft), Ne2 = X3.useRef({});
            return X3.createElement(Jft.Provider, { value: zi2(zi2({}, oe2), {}, { validateMessages: zi2(zi2({}, oe2.validateMessages), ge2), triggerFormChange: function(Ge2, Ve) {
              Ht && Ht(Ge2, { changedFields: Ve, forms: Ne2.current }), oe2.triggerFormChange(Ge2, Ve);
            }, triggerFormFinish: function(Ge2, Ve) {
              qt && qt(Ge2, { values: Ve, forms: Ne2.current }), oe2.triggerFormFinish(Ge2, Ve);
            }, registerForm: function(Ge2, Ve) {
              Ge2 && (Ne2.current = zi2(zi2({}, Ne2.current), {}, er({}, Ge2, Ve))), oe2.registerForm(Ge2, Ve);
            }, unregisterForm: function(Ge2) {
              var Ve = zi2({}, Ne2.current);
              delete Ve[Ge2], Ne2.current = Ve, oe2.unregisterForm(Ge2);
            } }) }, Zt);
          }, c$t = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], f$t = function(Bt, ge2) {
            var Ht = Bt.name, qt = Bt.initialValues, Zt = Bt.fields, oe2 = Bt.form, Ne2 = Bt.preserve, Ge2 = Bt.children, Ve = Bt.component, pn = Ve === void 0 ? "form" : Ve, vn = Bt.validateMessages, Gn = Bt.validateTrigger, Lr = Gn === void 0 ? "onChange" : Gn, Wr = Bt.onValuesChange, Gr = Bt.onFieldsChange, ei2 = Bt.onFinish, oi2 = Bt.onFinishFailed, Va2 = jc2(Bt, c$t), Ca2 = X3.useContext(Jft), Go = ZTt(oe2), un = Ic2(Go, 1), Ei2 = un[0], Wi2 = Ei2.getInternalHooks(T9), La2 = Wi2.useSubscribe, Aa2 = Wi2.setInitialValues, Oi2 = Wi2.setCallbacks, Zi2 = Wi2.setValidateMessages, Ka2 = Wi2.setPreserve;
            X3.useImperativeHandle(ge2, function() {
              return Ei2;
            }), X3.useEffect(function() {
              return Ca2.registerForm(Ht, Ei2), function() {
                Ca2.unregisterForm(Ht);
              };
            }, [Ca2, Ei2, Ht]), Zi2(zi2(zi2({}, Ca2.validateMessages), vn)), Oi2({ onValuesChange: Wr, onFieldsChange: function(ga) {
              if (Ca2.triggerFormChange(Ht, ga), Gr) {
                for (var ca2 = arguments.length, fs = new Array(ca2 > 1 ? ca2 - 1 : 0), qo = 1; qo < ca2; qo++)
                  fs[qo - 1] = arguments[qo];
                Gr.apply(void 0, [ga].concat(fs));
              }
            }, onFinish: function(ga) {
              Ca2.triggerFormFinish(Ht, ga), ei2 && ei2(ga);
            }, onFinishFailed: oi2 }), Ka2(Ne2);
            var Fo = X3.useRef(null);
            Aa2(qt, !Fo.current), Fo.current || (Fo.current = true);
            var Si2 = Ge2, bl = typeof Ge2 == "function";
            if (bl) {
              var vl = Ei2.getFieldsValue(true);
              Si2 = Ge2(vl, Ei2);
            }
            La2(!bl);
            var xa2 = X3.useRef();
            X3.useEffect(function() {
              QZt(xa2.current || [], Zt || []) || Ei2.setFields(Zt || []), xa2.current = Zt;
            }, [Zt, Ei2]);
            var gu = X3.useMemo(function() {
              return zi2(zi2({}, Ei2), {}, { validateTrigger: Lr });
            }, [Ei2, Lr]), Na2 = X3.createElement(KW.Provider, { value: gu }, Si2);
            return pn === false ? Na2 : X3.createElement(pn, L0({}, Va2, { onSubmit: function(ga) {
              ga.preventDefault(), ga.stopPropagation(), Ei2.submit();
            }, onReset: function(ga) {
              var ca2;
              ga.preventDefault(), Ei2.resetFields(), (ca2 = Va2.onReset) === null || ca2 === void 0 || ca2.call(Va2, ga);
            } }), Na2);
          }, $Tt = X3.forwardRef(f$t), aG = $Tt;
          aG.FormProvider = u$t, aG.Field = UTt, aG.List = o$t, aG.useForm = ZTt;
          var h$t = function(Bt, ge2, Ht) {
            gD(Bt, "[antd: ".concat(ge2, "] ").concat(Ht));
          }, p$t = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, tht = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, oG = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, sG = oG, d$t = { lang: L0({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, tht), timePickerLocale: L0({}, sG) }, eht = d$t, M22 = "${label} is not a valid ${type}", Gk = { locale: "en", Pagination: p$t, DatePicker: eht, TimePicker: sG, Calendar: eht, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: M22, method: M22, array: M22, object: M22, number: M22, date: M22, boolean: M22, integer: M22, float: M22, regexp: M22, email: M22, url: M22, hex: M22 }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, gQ = Gk, GR = R6.createContext(void 0), PM = GR, nht = function(Bt) {
            x9(Ht, Bt);
            var ge2 = HW(Ht);
            function Ht() {
              return WW(this, Ht), ge2.apply(this, arguments);
            }
            return GW(Ht, [{ key: "getLocale", value: function() {
              var qt = this.props, Zt = qt.componentName, oe2 = qt.defaultLocale, Ne2 = oe2 || gQ[Zt != null ? Zt : "global"], Ge2 = this.context, Ve = Zt && Ge2 ? Ge2[Zt] : {};
              return L0(L0({}, Ne2 instanceof Function ? Ne2() : Ne2), Ve || {});
            } }, { key: "getLocaleCode", value: function() {
              var qt = this.context, Zt = qt && qt.locale;
              return qt && qt.exist && !Zt ? gQ.locale : Zt;
            } }, { key: "render", value: function() {
              return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
            } }]), Ht;
          }(X3.Component);
          nht.defaultProps = { componentName: "global" }, nht.contextType = PM;
          var YTt = function() {
            var Bt = X3.useContext(Y1), ge2 = Bt.getPrefixCls, Ht = ge2("empty-img-default");
            return X3.createElement("svg", { className: Ht, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, X3.createElement("g", { fill: "none", fillRule: "evenodd" }, X3.createElement("g", { transform: "translate(24 31.67)" }, X3.createElement("ellipse", { className: "".concat(Ht, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), X3.createElement("path", { className: "".concat(Ht, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), X3.createElement("path", { className: "".concat(Ht, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), X3.createElement("path", { className: "".concat(Ht, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), X3.createElement("path", { className: "".concat(Ht, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), X3.createElement("path", { className: "".concat(Ht, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), X3.createElement("g", { className: "".concat(Ht, "-g"), transform: "translate(149.65 15.383)" }, X3.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), X3.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
          }, KTt = YTt, lG = function() {
            var Bt = X3.useContext(Y1), ge2 = Bt.getPrefixCls, Ht = ge2("empty-img-simple");
            return X3.createElement("svg", { className: Ht, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, X3.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, X3.createElement("ellipse", { className: "".concat(Ht, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), X3.createElement("g", { className: "".concat(Ht, "-g"), fillRule: "nonzero" }, X3.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), X3.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(Ht, "-path") }))));
          }, K3 = lG, XTt = globalThis && globalThis.__rest || function(Bt, ge2) {
            var Ht = {};
            for (var qt in Bt)
              Object.prototype.hasOwnProperty.call(Bt, qt) && ge2.indexOf(qt) < 0 && (Ht[qt] = Bt[qt]);
            if (Bt != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Zt = 0, qt = Object.getOwnPropertySymbols(Bt); Zt < qt.length; Zt++)
                ge2.indexOf(qt[Zt]) < 0 && Object.prototype.propertyIsEnumerable.call(Bt, qt[Zt]) && (Ht[qt[Zt]] = Bt[qt[Zt]]);
            return Ht;
          }, QTt = X3.createElement(KTt, null), uG = X3.createElement(K3, null), rht = function(Bt) {
            var ge2 = Bt.className, Ht = Bt.prefixCls, qt = Bt.image, Zt = qt === void 0 ? QTt : qt, oe2 = Bt.description, Ne2 = Bt.children, Ge2 = Bt.imageStyle, Ve = XTt(Bt, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), pn = X3.useContext(Y1), vn = pn.getPrefixCls, Gn = pn.direction;
            return X3.createElement(nht, { componentName: "Empty" }, function(Lr) {
              var Wr, Gr = vn("empty", Ht), ei2 = typeof oe2 != "undefined" ? oe2 : Lr.description, oi2 = typeof ei2 == "string" ? ei2 : "empty", Va2 = null;
              return typeof Zt == "string" ? Va2 = X3.createElement("img", { alt: oi2, src: Zt }) : Va2 = Zt, X3.createElement("div", L0({ className: Bd2(Gr, (Wr = {}, er(Wr, "".concat(Gr, "-normal"), Zt === uG), er(Wr, "".concat(Gr, "-rtl"), Gn === "rtl"), Wr), ge2) }, Ve), X3.createElement("div", { className: "".concat(Gr, "-image"), style: Ge2 }, Va2), ei2 && X3.createElement("div", { className: "".concat(Gr, "-description") }, ei2), Ne2 && X3.createElement("div", { className: "".concat(Gr, "-footer") }, Ne2));
            });
          };
          rht.PRESENTED_IMAGE_DEFAULT = QTt, rht.PRESENTED_IMAGE_SIMPLE = uG;
          var E9 = rht, $1 = function(Bt) {
            return X3.createElement(vQ, null, function(ge2) {
              var Ht = ge2.getPrefixCls, qt = Ht("empty");
              switch (Bt) {
                case "Table":
                case "List":
                  return X3.createElement(E9, { image: E9.PRESENTED_IMAGE_SIMPLE });
                case "Select":
                case "TreeSelect":
                case "Cascader":
                case "Transfer":
                case "Mentions":
                  return X3.createElement(E9, { image: E9.PRESENTED_IMAGE_SIMPLE, className: "".concat(qt, "-small") });
                default:
                  return X3.createElement(E9, null);
              }
            });
          }, iht = $1, JTt = function(Bt, ge2) {
            return ge2 || (Bt ? "ant-".concat(Bt) : "ant");
          }, Y1 = X3.createContext({ getPrefixCls: JTt, renderEmpty: iht }), vQ = Y1.Consumer, yQ = X3.createContext(void 0), HR = yQ, aht = function(Bt) {
            return +setTimeout(Bt, 16);
          }, e_ = function(Bt) {
            return clearTimeout(Bt);
          };
          typeof window != "undefined" && "requestAnimationFrame" in window && (aht = function(Bt) {
            return window.requestAnimationFrame(Bt);
          }, e_ = function(Bt) {
            return window.cancelAnimationFrame(Bt);
          });
          var mQ = 0, oht = /* @__PURE__ */ new Map();
          function tAt(Bt) {
            oht.delete(Bt);
          }
          function bQ(Bt) {
            var ge2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
            mQ += 1;
            var Ht = mQ;
            function qt(Zt) {
              if (Zt === 0)
                tAt(Ht), Bt();
              else {
                var oe2 = aht(function() {
                  qt(Zt - 1);
                });
                oht.set(Ht, oe2);
              }
            }
            return qt(ge2), Ht;
          }
          bQ.cancel = function(Bt) {
            var ge2 = oht.get(Bt);
            return tAt(ge2), e_(ge2);
          };
          function sht(Bt, ge2) {
            var Ht = ge2 || {}, qt = Ht.defaultValue, Zt = Ht.value, oe2 = Ht.onChange, Ne2 = Ht.postState, Ge2 = X3.useState(function() {
              return Zt !== void 0 ? Zt : qt !== void 0 ? typeof qt == "function" ? qt() : qt : typeof Bt == "function" ? Bt() : Bt;
            }), Ve = Ic2(Ge2, 2), pn = Ve[0], vn = Ve[1], Gn = Zt !== void 0 ? Zt : pn;
            Ne2 && (Gn = Ne2(Gn));
            var Lr = X3.useRef(oe2);
            Lr.current = oe2;
            var Wr = X3.useCallback(function(ei2) {
              vn(ei2), Gn !== ei2 && Lr.current && Lr.current(ei2, Gn);
            }, [Gn, Lr]), Gr = X3.useRef(true);
            return X3.useEffect(function() {
              if (Gr.current) {
                Gr.current = false;
                return;
              }
              Zt === void 0 && vn(Zt);
            }, [Zt]), [Gn, Wr];
          }
          var yc2 = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(Bt) {
            var ge2 = Bt.keyCode;
            if (Bt.altKey && !Bt.ctrlKey || Bt.metaKey || ge2 >= yc2.F1 && ge2 <= yc2.F12)
              return false;
            switch (ge2) {
              case yc2.ALT:
              case yc2.CAPS_LOCK:
              case yc2.CONTEXT_MENU:
              case yc2.CTRL:
              case yc2.DOWN:
              case yc2.END:
              case yc2.ESC:
              case yc2.HOME:
              case yc2.INSERT:
              case yc2.LEFT:
              case yc2.MAC_FF_META:
              case yc2.META:
              case yc2.NUMLOCK:
              case yc2.NUM_CENTER:
              case yc2.PAGE_DOWN:
              case yc2.PAGE_UP:
              case yc2.PAUSE:
              case yc2.PRINT_SCREEN:
              case yc2.RIGHT:
              case yc2.SHIFT:
              case yc2.UP:
              case yc2.WIN_KEY:
              case yc2.WIN_KEY_RIGHT:
                return false;
              default:
                return true;
            }
          }, isCharacterKey: function(Bt) {
            if (Bt >= yc2.ZERO && Bt <= yc2.NINE || Bt >= yc2.NUM_ZERO && Bt <= yc2.NUM_MULTIPLY || Bt >= yc2.A && Bt <= yc2.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && Bt === 0)
              return true;
            switch (Bt) {
              case yc2.SPACE:
              case yc2.QUESTION_MARK:
              case yc2.NUM_PLUS:
              case yc2.NUM_MINUS:
              case yc2.NUM_PERIOD:
              case yc2.NUM_DIVISION:
              case yc2.SEMICOLON:
              case yc2.DASH:
              case yc2.EQUALS:
              case yc2.COMMA:
              case yc2.PERIOD:
              case yc2.SLASH:
              case yc2.APOSTROPHE:
              case yc2.SINGLE_QUOTE:
              case yc2.OPEN_SQUARE_BRACKET:
              case yc2.BACKSLASH:
              case yc2.CLOSE_SQUARE_BRACKET:
                return true;
              default:
                return false;
            }
          } }, k9 = function() {
            for (var Bt = arguments.length, ge2 = new Array(Bt), Ht = 0; Ht < Bt; Ht++)
              ge2[Ht] = arguments[Ht];
            return ge2;
          }, eAt = X3.isValidElement;
          function g$t(Bt, ge2, Ht) {
            return eAt(Bt) ? X3.cloneElement(Bt, typeof Ht == "function" ? Ht(Bt.props || {}) : Ht) : ge2;
          }
          function v$t(Bt, ge2) {
            return g$t(Bt, Bt, ge2);
          }
          var P9 = ["xxl", "xl", "lg", "md", "sm", "xs"], _Q = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, UR = /* @__PURE__ */ new Map(), cG = -1, fG = {}, y$t = { matchHandlers: {}, dispatch: function(Bt) {
            return fG = Bt, UR.forEach(function(ge2) {
              return ge2(fG);
            }), UR.size >= 1;
          }, subscribe: function(Bt) {
            return UR.size || this.register(), cG += 1, UR.set(cG, Bt), Bt(fG), cG;
          }, unsubscribe: function(Bt) {
            UR.delete(Bt), UR.size || this.unregister();
          }, unregister: function() {
            var Bt = this;
            Object.keys(_Q).forEach(function(ge2) {
              var Ht = _Q[ge2], qt = Bt.matchHandlers[Ht];
              qt == null || qt.mql.removeListener(qt == null ? void 0 : qt.listener);
            }), UR.clear();
          }, register: function() {
            var Bt = this;
            Object.keys(_Q).forEach(function(ge2) {
              var Ht = _Q[ge2], qt = function(oe2) {
                var Ne2 = oe2.matches;
                Bt.dispatch(L0(L0({}, fG), er({}, ge2, Ne2)));
              }, Zt = window.matchMedia(Ht);
              Zt.addListener(qt), Bt.matchHandlers[Ht] = { mql: Zt, listener: qt }, qt(Zt);
            });
          } }, nAt = y$t, m$t = 0, qR = {};
          function L9(Bt) {
            var ge2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, Ht = m$t++, qt = ge2;
            function Zt() {
              qt -= 1, qt <= 0 ? (Bt(), delete qR[Ht]) : qR[Ht] = bQ(Zt);
            }
            return qR[Ht] = bQ(Zt), Ht;
          }
          L9.cancel = function(Bt) {
            Bt !== void 0 && (bQ.cancel(qR[Bt]), delete qR[Bt]);
          }, L9.ids = qR;
          var lht;
          function xQ(Bt) {
            return !Bt || Bt.offsetParent === null || Bt.hidden;
          }
          function rAt(Bt) {
            var ge2 = (Bt || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
            return ge2 && ge2[1] && ge2[2] && ge2[3] ? !(ge2[1] === ge2[2] && ge2[2] === ge2[3]) : true;
          }
          var uht = function(Bt) {
            x9(Ht, Bt);
            var ge2 = HW(Ht);
            function Ht() {
              var qt;
              return WW(this, Ht), qt = ge2.apply(this, arguments), qt.containerRef = X3.createRef(), qt.animationStart = false, qt.destroyed = false, qt.onClick = function(Zt, oe2) {
                var Ne2, Ge2, Ve = qt.props, pn = Ve.insertExtraNode, vn = Ve.disabled;
                if (!(vn || !Zt || xQ(Zt) || Zt.className.indexOf("-leave") >= 0)) {
                  qt.extraNode = document.createElement("div");
                  var Gn = nQ(qt), Lr = Gn.extraNode, Wr = qt.context.getPrefixCls;
                  Lr.className = "".concat(Wr(""), "-click-animating-node");
                  var Gr = qt.getAttributeName();
                  if (Zt.setAttribute(Gr, "true"), oe2 && oe2 !== "#ffffff" && oe2 !== "rgb(255, 255, 255)" && rAt(oe2) && !/rgba\((?:\d*, ){3}0\)/.test(oe2) && oe2 !== "transparent") {
                    Lr.style.borderColor = oe2;
                    var ei2 = ((Ne2 = Zt.getRootNode) === null || Ne2 === void 0 ? void 0 : Ne2.call(Zt)) || Zt.ownerDocument, oi2 = ei2 instanceof Document ? ei2.body : (Ge2 = ei2.firstChild) !== null && Ge2 !== void 0 ? Ge2 : ei2;
                    lht = Xm(`
      [`.concat(Wr(""), "-click-animating-without-extra-node='true']::after, .").concat(Wr(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(oe2, `;
      }`), "antd-wave", { csp: qt.csp, attachTo: oi2 });
                  }
                  pn && Zt.appendChild(Lr), ["transition", "animation"].forEach(function(Va2) {
                    Zt.addEventListener("".concat(Va2, "start"), qt.onTransitionStart), Zt.addEventListener("".concat(Va2, "end"), qt.onTransitionEnd);
                  });
                }
              }, qt.onTransitionStart = function(Zt) {
                if (!qt.destroyed) {
                  var oe2 = qt.containerRef.current;
                  !Zt || Zt.target !== oe2 || qt.animationStart || qt.resetEffect(oe2);
                }
              }, qt.onTransitionEnd = function(Zt) {
                !Zt || Zt.animationName !== "fadeEffect" || qt.resetEffect(Zt.target);
              }, qt.bindAnimationEvent = function(Zt) {
                if (!(!Zt || !Zt.getAttribute || Zt.getAttribute("disabled") || Zt.className.indexOf("disabled") >= 0)) {
                  var oe2 = function(Ne2) {
                    if (!(Ne2.target.tagName === "INPUT" || xQ(Ne2.target))) {
                      qt.resetEffect(Zt);
                      var Ge2 = getComputedStyle(Zt).getPropertyValue("border-top-color") || getComputedStyle(Zt).getPropertyValue("border-color") || getComputedStyle(Zt).getPropertyValue("background-color");
                      qt.clickWaveTimeoutId = window.setTimeout(function() {
                        return qt.onClick(Zt, Ge2);
                      }, 0), L9.cancel(qt.animationStartId), qt.animationStart = true, qt.animationStartId = L9(function() {
                        qt.animationStart = false;
                      }, 10);
                    }
                  };
                  return Zt.addEventListener("click", oe2, true), { cancel: function() {
                    Zt.removeEventListener("click", oe2, true);
                  } };
                }
              }, qt.renderWave = function(Zt) {
                var oe2 = Zt.csp, Ne2 = qt.props.children;
                if (qt.csp = oe2, !X3.isValidElement(Ne2))
                  return Ne2;
                var Ge2 = qt.containerRef;
                return FZt(Ne2) && (Ge2 = NZt(Ne2.ref, qt.containerRef)), v$t(Ne2, { ref: Ge2 });
              }, qt;
            }
            return GW(Ht, [{ key: "componentDidMount", value: function() {
              var qt = this.containerRef.current;
              !qt || qt.nodeType !== 1 || (this.instance = this.bindAnimationEvent(qt));
            } }, { key: "componentWillUnmount", value: function() {
              this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
            } }, { key: "getAttributeName", value: function() {
              var qt = this.context.getPrefixCls, Zt = this.props.insertExtraNode;
              return Zt ? "".concat(qt(""), "-click-animating") : "".concat(qt(""), "-click-animating-without-extra-node");
            } }, { key: "resetEffect", value: function(qt) {
              var Zt = this;
              if (!(!qt || qt === this.extraNode || !(qt instanceof Element))) {
                var oe2 = this.props.insertExtraNode, Ne2 = this.getAttributeName();
                qt.setAttribute(Ne2, "false"), lht && (lht.innerHTML = ""), oe2 && this.extraNode && qt.contains(this.extraNode) && qt.removeChild(this.extraNode), ["transition", "animation"].forEach(function(Ge2) {
                  qt.removeEventListener("".concat(Ge2, "start"), Zt.onTransitionStart), qt.removeEventListener("".concat(Ge2, "end"), Zt.onTransitionEnd);
                });
              }
            } }, { key: "render", value: function() {
              return X3.createElement(vQ, null, this.renderWave);
            } }]), Ht;
          }(X3.Component);
          uht.contextType = Y1;
          var wQ = { exports: {} }, X32 = {};
          /** @license React v17.0.2
          * react-jsx-runtime.production.min.js
          *
          * Copyright (c) Facebook, Inc. and its affiliates.
          *
          * This source code is licensed under the MIT license found in the
          * LICENSE file in the root directory of this source tree.
          */
          var b$t = Z3.default, cht = 60103;
          if (X32.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
            var fht = Symbol.for;
            cht = fht("react.element"), X32.Fragment = fht("react.fragment");
          }
          var _$t = b$t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, iAt = Object.prototype.hasOwnProperty, x$t = { key: true, ref: true, __self: true, __source: true };
          function SQ(Bt, ge2, Ht) {
            var qt, Zt = {}, oe2 = null, Ne2 = null;
            Ht !== void 0 && (oe2 = "" + Ht), ge2.key !== void 0 && (oe2 = "" + ge2.key), ge2.ref !== void 0 && (Ne2 = ge2.ref);
            for (qt in ge2)
              iAt.call(ge2, qt) && !x$t.hasOwnProperty(qt) && (Zt[qt] = ge2[qt]);
            if (Bt && Bt.defaultProps)
              for (qt in ge2 = Bt.defaultProps, ge2)
                Zt[qt] === void 0 && (Zt[qt] = ge2[qt]);
            return { $$typeof: cht, type: Bt, key: oe2, ref: Ne2, props: Zt, _owner: _$t.current };
          }
          X32.jsx = SQ, X32.jsxs = SQ, wQ.exports = X32;
          const ZR = wQ.exports.jsx, hht = wQ.exports.jsxs;
          var w$t = R6.createContext({}), MQ = w$t, gh2 = function() {
            return MTt() && window.document.documentElement;
          }, CQ, S$t = function() {
            if (!gh2())
              return false;
            if (CQ !== void 0)
              return CQ;
            var Bt = document.createElement("div");
            return Bt.style.display = "flex", Bt.style.flexDirection = "column", Bt.style.rowGap = "1px", Bt.appendChild(document.createElement("div")), Bt.appendChild(document.createElement("div")), document.body.appendChild(Bt), CQ = Bt.scrollHeight === 1, document.body.removeChild(Bt), CQ;
          }, hG = function() {
            var Bt = X3.useState(false), ge2 = Ic2(Bt, 2), Ht = ge2[0], qt = ge2[1];
            return X3.useEffect(function() {
              qt(S$t());
            }, []), Ht;
          }, aAt = globalThis && globalThis.__rest || function(Bt, ge2) {
            var Ht = {};
            for (var qt in Bt)
              Object.prototype.hasOwnProperty.call(Bt, qt) && ge2.indexOf(qt) < 0 && (Ht[qt] = Bt[qt]);
            if (Bt != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Zt = 0, qt = Object.getOwnPropertySymbols(Bt); Zt < qt.length; Zt++)
                ge2.indexOf(qt[Zt]) < 0 && Object.prototype.propertyIsEnumerable.call(Bt, qt[Zt]) && (Ht[qt[Zt]] = Bt[qt[Zt]]);
            return Ht;
          };
          k9("top", "middle", "bottom", "stretch"), k9("start", "end", "center", "space-around", "space-between");
          var oAt = X3.forwardRef(function(Bt, ge2) {
            var Ht, qt = Bt.prefixCls, Zt = Bt.justify, oe2 = Bt.align, Ne2 = Bt.className, Ge2 = Bt.style, Ve = Bt.children, pn = Bt.gutter, vn = pn === void 0 ? 0 : pn, Gn = Bt.wrap, Lr = aAt(Bt, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Wr = X3.useContext(Y1), Gr = Wr.getPrefixCls, ei2 = Wr.direction, oi2 = X3.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), Va2 = Ic2(oi2, 2), Ca2 = Va2[0], Go = Va2[1], un = hG(), Ei2 = X3.useRef(vn);
            X3.useEffect(function() {
              var Na2 = nAt.subscribe(function(ga) {
                var ca2 = Ei2.current || 0;
                (!Array.isArray(ca2) && du(ca2) === "object" || Array.isArray(ca2) && (du(ca2[0]) === "object" || du(ca2[1]) === "object")) && Go(ga);
              });
              return function() {
                return nAt.unsubscribe(Na2);
              };
            }, []);
            var Wi2 = function() {
              var Na2 = [0, 0], ga = Array.isArray(vn) ? vn : [vn, 0];
              return ga.forEach(function(ca2, fs) {
                if (du(ca2) === "object")
                  for (var qo = 0; qo < P9.length; qo++) {
                    var Hu = P9[qo];
                    if (Ca2[Hu] && ca2[Hu] !== void 0) {
                      Na2[fs] = ca2[Hu];
                      break;
                    }
                  }
                else
                  Na2[fs] = ca2 || 0;
              }), Na2;
            }, La2 = Gr("row", qt), Aa2 = Wi2(), Oi2 = Bd2(La2, (Ht = {}, er(Ht, "".concat(La2, "-no-wrap"), Gn === false), er(Ht, "".concat(La2, "-").concat(Zt), Zt), er(Ht, "".concat(La2, "-").concat(oe2), oe2), er(Ht, "".concat(La2, "-rtl"), ei2 === "rtl"), Ht), Ne2), Zi2 = {}, Ka2 = Aa2[0] > 0 ? Aa2[0] / -2 : void 0, Fo = Aa2[1] > 0 ? Aa2[1] / -2 : void 0;
            if (Ka2 && (Zi2.marginLeft = Ka2, Zi2.marginRight = Ka2), un) {
              var Si2 = Ic2(Aa2, 2);
              Zi2.rowGap = Si2[1];
            } else
              Fo && (Zi2.marginTop = Fo, Zi2.marginBottom = Fo);
            var bl = Ic2(Aa2, 2), vl = bl[0], xa2 = bl[1], gu = X3.useMemo(function() {
              return { gutter: [vl, xa2], wrap: Gn, supportFlexGap: un };
            }, [vl, xa2, Gn, un]);
            return X3.createElement(MQ.Provider, { value: gu }, X3.createElement("div", L0({}, Lr, { className: Oi2, style: L0(L0({}, Zi2), Ge2), ref: ge2 }), Ve));
          });
          oAt.displayName = "Row";
          var M$t = oAt, LM = globalThis && globalThis.__rest || function(Bt, ge2) {
            var Ht = {};
            for (var qt in Bt)
              Object.prototype.hasOwnProperty.call(Bt, qt) && ge2.indexOf(qt) < 0 && (Ht[qt] = Bt[qt]);
            if (Bt != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Zt = 0, qt = Object.getOwnPropertySymbols(Bt); Zt < qt.length; Zt++)
                ge2.indexOf(qt[Zt]) < 0 && Object.prototype.propertyIsEnumerable.call(Bt, qt[Zt]) && (Ht[qt[Zt]] = Bt[qt[Zt]]);
            return Ht;
          };
          function C$t(Bt) {
            return typeof Bt == "number" ? "".concat(Bt, " ").concat(Bt, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(Bt) ? "0 0 ".concat(Bt) : Bt;
          }
          var TQ = ["xs", "sm", "md", "lg", "xl", "xxl"], AQ = X3.forwardRef(function(Bt, ge2) {
            var Ht, qt = X3.useContext(Y1), Zt = qt.getPrefixCls, oe2 = qt.direction, Ne2 = X3.useContext(MQ), Ge2 = Ne2.gutter, Ve = Ne2.wrap, pn = Ne2.supportFlexGap, vn = Bt.prefixCls, Gn = Bt.span, Lr = Bt.order, Wr = Bt.offset, Gr = Bt.push, ei2 = Bt.pull, oi2 = Bt.className, Va2 = Bt.children, Ca2 = Bt.flex, Go = Bt.style, un = LM(Bt, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), Ei2 = Zt("col", vn), Wi2 = {};
            TQ.forEach(function(Ka2) {
              var Fo, Si2 = {}, bl = Bt[Ka2];
              typeof bl == "number" ? Si2.span = bl : du(bl) === "object" && (Si2 = bl || {}), delete un[Ka2], Wi2 = L0(L0({}, Wi2), (Fo = {}, er(Fo, "".concat(Ei2, "-").concat(Ka2, "-").concat(Si2.span), Si2.span !== void 0), er(Fo, "".concat(Ei2, "-").concat(Ka2, "-order-").concat(Si2.order), Si2.order || Si2.order === 0), er(Fo, "".concat(Ei2, "-").concat(Ka2, "-offset-").concat(Si2.offset), Si2.offset || Si2.offset === 0), er(Fo, "".concat(Ei2, "-").concat(Ka2, "-push-").concat(Si2.push), Si2.push || Si2.push === 0), er(Fo, "".concat(Ei2, "-").concat(Ka2, "-pull-").concat(Si2.pull), Si2.pull || Si2.pull === 0), er(Fo, "".concat(Ei2, "-rtl"), oe2 === "rtl"), Fo));
            });
            var La2 = Bd2(Ei2, (Ht = {}, er(Ht, "".concat(Ei2, "-").concat(Gn), Gn !== void 0), er(Ht, "".concat(Ei2, "-order-").concat(Lr), Lr), er(Ht, "".concat(Ei2, "-offset-").concat(Wr), Wr), er(Ht, "".concat(Ei2, "-push-").concat(Gr), Gr), er(Ht, "".concat(Ei2, "-pull-").concat(ei2), ei2), Ht), oi2, Wi2), Aa2 = {};
            if (Ge2 && Ge2[0] > 0) {
              var Oi2 = Ge2[0] / 2;
              Aa2.paddingLeft = Oi2, Aa2.paddingRight = Oi2;
            }
            if (Ge2 && Ge2[1] > 0 && !pn) {
              var Zi2 = Ge2[1] / 2;
              Aa2.paddingTop = Zi2, Aa2.paddingBottom = Zi2;
            }
            return Ca2 && (Aa2.flex = C$t(Ca2), Ve === false && !Aa2.minWidth && (Aa2.minWidth = 0)), X3.createElement("div", L0({}, un, { style: L0(L0({}, Aa2), Go), className: La2, ref: ge2 }), Va2);
          });
          AQ.displayName = "Col";
          var sAt = AQ, pht = X3.forwardRef(function(Bt, ge2) {
            var Ht, qt = Bt.prefixCls, Zt = qt === void 0 ? "rc-switch" : qt, oe2 = Bt.className, Ne2 = Bt.checked, Ge2 = Bt.defaultChecked, Ve = Bt.disabled, pn = Bt.loadingIcon, vn = Bt.checkedChildren, Gn = Bt.unCheckedChildren, Lr = Bt.onClick, Wr = Bt.onChange, Gr = Bt.onKeyDown, ei2 = jc2(Bt, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), oi2 = sht(false, { value: Ne2, defaultValue: Ge2 }), Va2 = Ic2(oi2, 2), Ca2 = Va2[0], Go = Va2[1];
            function un(Aa2, Oi2) {
              var Zi2 = Ca2;
              return Ve || (Zi2 = Aa2, Go(Zi2), Wr == null || Wr(Zi2, Oi2)), Zi2;
            }
            function Ei2(Aa2) {
              Aa2.which === yc2.LEFT ? un(false, Aa2) : Aa2.which === yc2.RIGHT && un(true, Aa2), Gr == null || Gr(Aa2);
            }
            function Wi2(Aa2) {
              var Oi2 = un(!Ca2, Aa2);
              Lr == null || Lr(Oi2, Aa2);
            }
            var La2 = Bd2(Zt, oe2, (Ht = {}, er(Ht, "".concat(Zt, "-checked"), Ca2), er(Ht, "".concat(Zt, "-disabled"), Ve), Ht));
            return X3.createElement("button", Object.assign({}, ei2, { type: "button", role: "switch", "aria-checked": Ca2, disabled: Ve, className: La2, ref: ge2, onKeyDown: Ei2, onClick: Wi2 }), pn, X3.createElement("span", { className: "".concat(Zt, "-inner") }, Ca2 ? vn : Gn));
          });
          pht.displayName = "Switch";
          var C2 = globalThis && globalThis.__rest || function(Bt, ge2) {
            var Ht = {};
            for (var qt in Bt)
              Object.prototype.hasOwnProperty.call(Bt, qt) && ge2.indexOf(qt) < 0 && (Ht[qt] = Bt[qt]);
            if (Bt != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Zt = 0, qt = Object.getOwnPropertySymbols(Bt); Zt < qt.length; Zt++)
                ge2.indexOf(qt[Zt]) < 0 && Object.prototype.propertyIsEnumerable.call(Bt, qt[Zt]) && (Ht[qt[Zt]] = Bt[qt[Zt]]);
            return Ht;
          }, vD = X3.forwardRef(function(Bt, ge2) {
            var Ht, qt = Bt.prefixCls, Zt = Bt.size, oe2 = Bt.loading, Ne2 = Bt.className, Ge2 = Ne2 === void 0 ? "" : Ne2, Ve = Bt.disabled, pn = C2(Bt, ["prefixCls", "size", "loading", "className", "disabled"]);
            h$t("checked" in pn || !("value" in pn), "Switch", "`value` is not a valid prop, do you mean `checked`?");
            var vn = X3.useContext(Y1), Gn = vn.getPrefixCls, Lr = vn.direction, Wr = X3.useContext(HR), Gr = Gn("switch", qt), ei2 = X3.createElement("div", { className: "".concat(Gr, "-handle") }, oe2 && X3.createElement(EZt, { className: "".concat(Gr, "-loading-icon") })), oi2 = Bd2((Ht = {}, er(Ht, "".concat(Gr, "-small"), (Zt || Wr) === "small"), er(Ht, "".concat(Gr, "-loading"), oe2), er(Ht, "".concat(Gr, "-rtl"), Lr === "rtl"), Ht), Ge2);
            return X3.createElement(uht, { insertExtraNode: true }, X3.createElement(pht, L0({}, pn, { prefixCls: Gr, className: oi2, disabled: Ve || oe2, ref: ge2, loadingIcon: ei2 })));
          });
          vD.__ANT_SWITCH = true, vD.displayName = "Switch";
          var dht = vD, lAt = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, IQ = {};
          (function(Bt) {
            var ge2 = Object.defineProperty, Ht = (Vt, ve2, Ut) => ve2 in Vt ? ge2(Vt, ve2, { enumerable: true, configurable: true, writable: true, value: Ut }) : Vt[ve2] = Ut, qt = (Vt, ve2, Ut) => (Ht(Vt, typeof ve2 != "symbol" ? ve2 + "" : ve2, Ut), Ut);
            Object.defineProperties(Bt, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
            var Zt = Z3.default;
            function oe2(Vt) {
              return Vt && typeof Vt == "object" && "default" in Vt ? Vt : { default: Vt };
            }
            function Ne2(Vt) {
              if (Vt && Vt.__esModule)
                return Vt;
              var ve2 = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
              return Vt && Object.keys(Vt).forEach(function(Ut) {
                if (Ut !== "default") {
                  var $t = Object.getOwnPropertyDescriptor(Vt, Ut);
                  Object.defineProperty(ve2, Ut, $t.get ? $t : { enumerable: true, get: function() {
                    return Vt[Ut];
                  } });
                }
              }), ve2.default = Vt, Object.freeze(ve2);
            }
            var Ge2 = oe2(Zt), Ve = Ne2(Zt);
            class pn {
              constructor() {
                qt(this, "chartsEmitters", /* @__PURE__ */ new Map()), qt(this, "add", (ve2, Ut, $t, Yt) => {
                  Ut && $t ? this.chartsEmitters.set(ve2, { chart: Ut, option: $t, title: Yt }) : console.log("\u6DFB\u52A0\u5931\u8D25");
                }), qt(this, "get", (ve2) => this.chartsEmitters.get(ve2)), qt(this, "clear", () => {
                  this.chartsEmitters.clear();
                }), qt(this, "delete", (ve2) => {
                  this.chartsEmitters.delete(ve2);
                }), qt(this, "list", () => {
                  var ve2, Ut, $t;
                  const Yt = [];
                  for (const se2 of this.chartsEmitters.keys())
                    Yt.push({ id: se2, chart: (ve2 = this.chartsEmitters.get(se2)) == null ? void 0 : ve2.chart, option: (Ut = this.chartsEmitters.get(se2)) == null ? void 0 : Ut.option, title: ($t = this.chartsEmitters.get(se2)) == null ? void 0 : $t.title });
                  return Yt;
                });
              }
            }
            const vn = new pn();
            var Gn = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof pt != "undefined" ? pt : typeof self != "undefined" ? self : {};
            function Lr(Vt) {
              return Vt && Vt.__esModule && Object.prototype.hasOwnProperty.call(Vt, "default") ? Vt.default : Vt;
            }
            var Wr = { exports: {} };
            /**
            * @license
            * Lodash <https://lodash.com/>
            * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
            * Released under MIT license <https://lodash.com/license>
            * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
            * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
            */
            (function(Vt, ve2) {
              (function() {
                var Ut, $t = "4.17.21", Yt = 200, se2 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", Re2 = "Expected a function", He2 = "Invalid `variable` option passed into `_.template`", nn = "__lodash_hash_undefined__", dn = 500, yn = "__lodash_placeholder__", Yn = 1, Rr = 2, Ur = 4, Hr = 1, si2 = 2, _i = 1, Wa2 = 2, Ia2 = 4, ts = 8, on = 16, di2 = 32, Yi2 = 64, Oa2 = 128, Da2 = 256, Fi2 = 512, Qi2 = 30, ro = "...", Wo = 800, Ii2 = 16, _l = 1, yl = 2, Ra2 = 3, Su = 1 / 0, Ga2 = 9007199254740991, ha2 = 17976931348623157e292, pa2 = 0 / 0, hs = 4294967295, Zo = hs - 1, rc2 = hs >>> 1, ep = [["ary", Oa2], ["bind", _i], ["bindKey", Wa2], ["curry", ts], ["curryRight", on], ["flip", Fi2], ["partial", di2], ["partialRight", Yi2], ["rearg", Da2]], mh2 = "[object Arguments]", Cf2 = "[object Array]", Gd2 = "[object AsyncFunction]", bh2 = "[object Boolean]", Gp = "[object Date]", $v = "[object DOMException]", B0 = "[object Error]", uS = "[object Function]", FM = "[object GeneratorFunction]", Ry = "[object Map]", Rx = "[object Number]", PT = "[object Null]", u_ = "[object Object]", ib2 = "[object Promise]", VM = "[object Proxy]", cS = "[object RegExp]", d0 = "[object Set]", fy = "[object String]", Vg2 = "[object Symbol]", _u = "[object Undefined]", lo = "[object WeakMap]", na2 = "[object WeakSet]", $i2 = "[object ArrayBuffer]", xo = "[object DataView]", Os = "[object Float32Array]", Kl = "[object Float64Array]", Iu = "[object Int8Array]", Tf2 = "[object Int16Array]", ud2 = "[object Int32Array]", iv = "[object Uint8Array]", Bg2 = "[object Uint8ClampedArray]", z0 = "[object Uint16Array]", zg2 = "[object Uint32Array]", c_ = /\b__p \+= '';/g, Nx = /\b(__p \+=) '' \+/g, Ny = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Hd2 = /&(?:amp|lt|gt|quot|#39);/g, Yv = /[&<>"']/g, np = RegExp(Hd2.source), hy = RegExp(Yv.source), ab2 = /<%-([\s\S]+?)%>/g, BM = /<%([\s\S]+?)%>/g, i1 = /<%=([\s\S]+?)%>/g, f_ = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, fS = /^\w*$/, fL = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, o5 = /[\\^$.*+?()[\]{}|]/g, Kht = RegExp(o5.source), hL = /^\s+/, wJ = /\s/, SJ = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Xht = /\{\n\/\* \[wrapped with (.+)\] \*/, eH = /,? & /, b62 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, br = /[()=,{}\[\]\/\s]/, Dr = /\\(\\)?/g, On = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, ur = /\w*$/, gr = /^[-+]0x[0-9a-f]+$/i, Hi2 = /^0b[01]+$/i, Fa2 = /^\[object .+?Constructor\]$/, ma2 = /^0o[0-7]+$/i, Ri2 = /^(?:0|[1-9]\d*)$/, Ho = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, iu = /($^)/, th2 = /['\n\r\u2028\u2029\\]/g, rp = "\\ud800-\\udfff", Dd2 = "\\u0300-\\u036f", Hf2 = "\\ufe20-\\ufe2f", Ed2 = "\\u20d0-\\u20ff", Kv = Dd2 + Hf2 + Ed2, Bc2 = "\\u2700-\\u27bf", py = "a-z\\xdf-\\xf6\\xf8-\\xff", Fx = "\\xac\\xb1\\xd7\\xf7", LT = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", _6 = "\\u2000-\\u206f", zM = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", pL = "A-Z\\xc0-\\xd6\\xd8-\\xde", s5 = "\\ufe0e\\ufe0f", vm = Fx + LT + _6 + zM, ED = "['\u2019]", dL = "[" + rp + "]", l5 = "[" + vm + "]", x6 = "[" + Kv + "]", w6 = "\\d+", nH = "[" + Bc2 + "]", a7 = "[" + py + "]", o7 = "[^" + rp + vm + w6 + Bc2 + py + pL + "]", a1 = "\\ud83c[\\udffb-\\udfff]", gL = "(?:" + x6 + "|" + a1 + ")", rH = "[^" + rp + "]", Qht = "(?:\\ud83c[\\udde6-\\uddff]){2}", MJ = "[\\ud800-\\udbff][\\udc00-\\udfff]", s7 = "[" + pL + "]", fAt = "\\u200d", hAt = "(?:" + a7 + "|" + o7 + ")", T$t = "(?:" + s7 + "|" + o7 + ")", CJ = "(?:" + ED + "(?:d|ll|m|re|s|t|ve))?", pAt = "(?:" + ED + "(?:D|LL|M|RE|S|T|VE))?", dAt = gL + "?", gAt = "[" + s5 + "]?", A$t = "(?:" + fAt + "(?:" + [rH, Qht, MJ].join("|") + ")" + gAt + dAt + ")*", I$t = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", D$t = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", vAt = gAt + dAt + A$t, E$t = "(?:" + [nH, Qht, MJ].join("|") + ")" + vAt, k$t = "(?:" + [rH + x6 + "?", x6, Qht, MJ, dL].join("|") + ")", P$t = RegExp(ED, "g"), L$t = RegExp(x6, "g"), Jht = RegExp(a1 + "(?=" + a1 + ")|" + k$t + vAt, "g"), O$t = RegExp([s7 + "?" + a7 + "+" + CJ + "(?=" + [l5, s7, "$"].join("|") + ")", T$t + "+" + pAt + "(?=" + [l5, s7 + hAt, "$"].join("|") + ")", s7 + "?" + hAt + "+" + CJ, s7 + "+" + pAt, D$t, I$t, w6, E$t].join("|"), "g"), R$t = RegExp("[" + fAt + rp + Kv + s5 + "]"), N$t = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, F$t = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], V$t = -1, Ev = {};
                Ev[Os] = Ev[Kl] = Ev[Iu] = Ev[Tf2] = Ev[ud2] = Ev[iv] = Ev[Bg2] = Ev[z0] = Ev[zg2] = true, Ev[mh2] = Ev[Cf2] = Ev[$i2] = Ev[bh2] = Ev[xo] = Ev[Gp] = Ev[B0] = Ev[uS] = Ev[Ry] = Ev[Rx] = Ev[u_] = Ev[cS] = Ev[d0] = Ev[fy] = Ev[lo] = false;
                var av = {};
                av[mh2] = av[Cf2] = av[$i2] = av[xo] = av[bh2] = av[Gp] = av[Os] = av[Kl] = av[Iu] = av[Tf2] = av[ud2] = av[Ry] = av[Rx] = av[u_] = av[cS] = av[d0] = av[fy] = av[Vg2] = av[iv] = av[Bg2] = av[z0] = av[zg2] = true, av[B0] = av[uS] = av[lo] = false;
                var B$t = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, tpt = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, yAt = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, z$t = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, j$t = parseFloat, W$t = parseInt, mAt = typeof Gn == "object" && Gn && Gn.Object === Object && Gn, G$t = typeof self == "object" && self && self.Object === Object && self, ob2 = mAt || G$t || Function("return this")(), ept = ve2 && !ve2.nodeType && ve2, S6 = ept && true && Vt && !Vt.nodeType && Vt, npt = S6 && S6.exports === ept, rpt = npt && mAt.process, Vx = function() {
                  try {
                    var Mi2 = S6 && S6.require && S6.require("util").types;
                    return Mi2 || rpt && rpt.binding && rpt.binding("util");
                  } catch {
                  }
                }(), bAt = Vx && Vx.isArrayBuffer, _At = Vx && Vx.isDate, xAt = Vx && Vx.isMap, wAt = Vx && Vx.isRegExp, SAt = Vx && Vx.isSet, MAt = Vx && Vx.isTypedArray;
                function P22(Mi2, uo, fa2) {
                  switch (fa2.length) {
                    case 0:
                      return Mi2.call(uo);
                    case 1:
                      return Mi2.call(uo, fa2[0]);
                    case 2:
                      return Mi2.call(uo, fa2[0], fa2[1]);
                    case 3:
                      return Mi2.call(uo, fa2[0], fa2[1], fa2[2]);
                  }
                  return Mi2.apply(uo, fa2);
                }
                function H$t(Mi2, uo, fa2, Bo) {
                  for (var uf2 = -1, cf2 = Mi2 == null ? 0 : Mi2.length; ++uf2 < cf2; ) {
                    var _h = Mi2[uf2];
                    uo(Bo, _h, fa2(_h), Mi2);
                  }
                  return Bo;
                }
                function jM(Mi2, uo) {
                  for (var fa2 = -1, Bo = Mi2 == null ? 0 : Mi2.length; ++fa2 < Bo && uo(Mi2[fa2], fa2, Mi2) !== false; )
                    ;
                  return Mi2;
                }
                function U$t(Mi2, uo) {
                  for (var fa2 = Mi2 == null ? 0 : Mi2.length; fa2-- && uo(Mi2[fa2], fa2, Mi2) !== false; )
                    ;
                  return Mi2;
                }
                function CAt(Mi2, uo) {
                  for (var fa2 = -1, Bo = Mi2 == null ? 0 : Mi2.length; ++fa2 < Bo; )
                    if (!uo(Mi2[fa2], fa2, Mi2))
                      return false;
                  return true;
                }
                function vL(Mi2, uo) {
                  for (var fa2 = -1, Bo = Mi2 == null ? 0 : Mi2.length, uf2 = 0, cf2 = []; ++fa2 < Bo; ) {
                    var _h = Mi2[fa2];
                    uo(_h, fa2, Mi2) && (cf2[uf2++] = _h);
                  }
                  return cf2;
                }
                function TJ(Mi2, uo) {
                  var fa2 = Mi2 == null ? 0 : Mi2.length;
                  return !!fa2 && l7(Mi2, uo, 0) > -1;
                }
                function ipt(Mi2, uo, fa2) {
                  for (var Bo = -1, uf2 = Mi2 == null ? 0 : Mi2.length; ++Bo < uf2; )
                    if (fa2(uo, Mi2[Bo]))
                      return true;
                  return false;
                }
                function Xv(Mi2, uo) {
                  for (var fa2 = -1, Bo = Mi2 == null ? 0 : Mi2.length, uf2 = Array(Bo); ++fa2 < Bo; )
                    uf2[fa2] = uo(Mi2[fa2], fa2, Mi2);
                  return uf2;
                }
                function yL(Mi2, uo) {
                  for (var fa2 = -1, Bo = uo.length, uf2 = Mi2.length; ++fa2 < Bo; )
                    Mi2[uf2 + fa2] = uo[fa2];
                  return Mi2;
                }
                function AJ(Mi2, uo, fa2, Bo) {
                  var uf2 = -1, cf2 = Mi2 == null ? 0 : Mi2.length;
                  for (Bo && cf2 && (fa2 = Mi2[++uf2]); ++uf2 < cf2; )
                    fa2 = uo(fa2, Mi2[uf2], uf2, Mi2);
                  return fa2;
                }
                function TAt(Mi2, uo, fa2, Bo) {
                  var uf2 = Mi2 == null ? 0 : Mi2.length;
                  for (Bo && uf2 && (fa2 = Mi2[--uf2]); uf2--; )
                    fa2 = uo(fa2, Mi2[uf2], uf2, Mi2);
                  return fa2;
                }
                function apt(Mi2, uo) {
                  for (var fa2 = -1, Bo = Mi2 == null ? 0 : Mi2.length; ++fa2 < Bo; )
                    if (uo(Mi2[fa2], fa2, Mi2))
                      return true;
                  return false;
                }
                var q$t = opt("length");
                function Z$t(Mi2) {
                  return Mi2.split("");
                }
                function $$t(Mi2) {
                  return Mi2.match(b62) || [];
                }
                function iH(Mi2, uo, fa2) {
                  var Bo;
                  return fa2(Mi2, function(uf2, cf2, _h) {
                    if (uo(uf2, cf2, _h))
                      return Bo = cf2, false;
                  }), Bo;
                }
                function IJ(Mi2, uo, fa2, Bo) {
                  for (var uf2 = Mi2.length, cf2 = fa2 + (Bo ? 1 : -1); Bo ? cf2-- : ++cf2 < uf2; )
                    if (uo(Mi2[cf2], cf2, Mi2))
                      return cf2;
                  return -1;
                }
                function l7(Mi2, uo, fa2) {
                  return uo === uo ? nYt(Mi2, uo, fa2) : IJ(Mi2, AAt, fa2);
                }
                function Y$t(Mi2, uo, fa2, Bo) {
                  for (var uf2 = fa2 - 1, cf2 = Mi2.length; ++uf2 < cf2; )
                    if (Bo(Mi2[uf2], uo))
                      return uf2;
                  return -1;
                }
                function AAt(Mi2) {
                  return Mi2 !== Mi2;
                }
                function IAt(Mi2, uo) {
                  var fa2 = Mi2 == null ? 0 : Mi2.length;
                  return fa2 ? lpt(Mi2, uo) / fa2 : pa2;
                }
                function opt(Mi2) {
                  return function(uo) {
                    return uo == null ? Ut : uo[Mi2];
                  };
                }
                function spt(Mi2) {
                  return function(uo) {
                    return Mi2 == null ? Ut : Mi2[uo];
                  };
                }
                function DAt(Mi2, uo, fa2, Bo, uf2) {
                  return uf2(Mi2, function(cf2, _h, jg2) {
                    fa2 = Bo ? (Bo = false, cf2) : uo(fa2, cf2, _h, jg2);
                  }), fa2;
                }
                function K$t(Mi2, uo) {
                  var fa2 = Mi2.length;
                  for (Mi2.sort(uo); fa2--; )
                    Mi2[fa2] = Mi2[fa2].value;
                  return Mi2;
                }
                function lpt(Mi2, uo) {
                  for (var fa2, Bo = -1, uf2 = Mi2.length; ++Bo < uf2; ) {
                    var cf2 = uo(Mi2[Bo]);
                    cf2 !== Ut && (fa2 = fa2 === Ut ? cf2 : fa2 + cf2);
                  }
                  return fa2;
                }
                function upt(Mi2, uo) {
                  for (var fa2 = -1, Bo = Array(Mi2); ++fa2 < Mi2; )
                    Bo[fa2] = uo(fa2);
                  return Bo;
                }
                function DJ(Mi2, uo) {
                  return Xv(uo, function(fa2) {
                    return [fa2, Mi2[fa2]];
                  });
                }
                function EAt(Mi2) {
                  return Mi2 && Mi2.slice(0, LAt(Mi2) + 1).replace(hL, "");
                }
                function hS(Mi2) {
                  return function(uo) {
                    return Mi2(uo);
                  };
                }
                function EJ(Mi2, uo) {
                  return Xv(uo, function(fa2) {
                    return Mi2[fa2];
                  });
                }
                function M6(Mi2, uo) {
                  return Mi2.has(uo);
                }
                function cpt(Mi2, uo) {
                  for (var fa2 = -1, Bo = Mi2.length; ++fa2 < Bo && l7(uo, Mi2[fa2], 0) > -1; )
                    ;
                  return fa2;
                }
                function fpt(Mi2, uo) {
                  for (var fa2 = Mi2.length; fa2-- && l7(uo, Mi2[fa2], 0) > -1; )
                    ;
                  return fa2;
                }
                function kAt(Mi2, uo) {
                  for (var fa2 = Mi2.length, Bo = 0; fa2--; )
                    Mi2[fa2] === uo && ++Bo;
                  return Bo;
                }
                var PAt = spt(B$t), X$t = spt(tpt);
                function Q$t(Mi2) {
                  return "\\" + z$t[Mi2];
                }
                function J$t(Mi2, uo) {
                  return Mi2 == null ? Ut : Mi2[uo];
                }
                function u5(Mi2) {
                  return R$t.test(Mi2);
                }
                function kJ(Mi2) {
                  return N$t.test(Mi2);
                }
                function tYt(Mi2) {
                  for (var uo, fa2 = []; !(uo = Mi2.next()).done; )
                    fa2.push(uo.value);
                  return fa2;
                }
                function hpt(Mi2) {
                  var uo = -1, fa2 = Array(Mi2.size);
                  return Mi2.forEach(function(Bo, uf2) {
                    fa2[++uo] = [uf2, Bo];
                  }), fa2;
                }
                function PJ(Mi2, uo) {
                  return function(fa2) {
                    return Mi2(uo(fa2));
                  };
                }
                function c52(Mi2, uo) {
                  for (var fa2 = -1, Bo = Mi2.length, uf2 = 0, cf2 = []; ++fa2 < Bo; ) {
                    var _h = Mi2[fa2];
                    (_h === uo || _h === yn) && (Mi2[fa2] = yn, cf2[uf2++] = fa2);
                  }
                  return cf2;
                }
                function LJ(Mi2) {
                  var uo = -1, fa2 = Array(Mi2.size);
                  return Mi2.forEach(function(Bo) {
                    fa2[++uo] = Bo;
                  }), fa2;
                }
                function eYt(Mi2) {
                  var uo = -1, fa2 = Array(Mi2.size);
                  return Mi2.forEach(function(Bo) {
                    fa2[++uo] = [Bo, Bo];
                  }), fa2;
                }
                function nYt(Mi2, uo, fa2) {
                  for (var Bo = fa2 - 1, uf2 = Mi2.length; ++Bo < uf2; )
                    if (Mi2[Bo] === uo)
                      return Bo;
                  return -1;
                }
                function rYt(Mi2, uo, fa2) {
                  for (var Bo = fa2 + 1; Bo--; )
                    if (Mi2[Bo] === uo)
                      return Bo;
                  return Bo;
                }
                function u7(Mi2) {
                  return u5(Mi2) ? aYt(Mi2) : q$t(Mi2);
                }
                function OT(Mi2) {
                  return u5(Mi2) ? oYt(Mi2) : Z$t(Mi2);
                }
                function LAt(Mi2) {
                  for (var uo = Mi2.length; uo-- && wJ.test(Mi2.charAt(uo)); )
                    ;
                  return uo;
                }
                var iYt = spt(yAt);
                function aYt(Mi2) {
                  for (var uo = Jht.lastIndex = 0; Jht.test(Mi2); )
                    ++uo;
                  return uo;
                }
                function oYt(Mi2) {
                  return Mi2.match(Jht) || [];
                }
                function sYt(Mi2) {
                  return Mi2.match(O$t) || [];
                }
                var lYt = function Mi2(uo) {
                  uo = uo == null ? ob2 : h_.defaults(ob2.Object(), uo, h_.pick(ob2, F$t));
                  var fa2 = uo.Array, Bo = uo.Date, uf2 = uo.Error, cf2 = uo.Function, _h = uo.Math, jg2 = uo.Object, kD = uo.RegExp, uYt = uo.String, WM = uo.TypeError, OJ = fa2.prototype, cYt = cf2.prototype, c7 = jg2.prototype, f7 = uo["__core-js_shared__"], RJ = cYt.toString, ip = c7.hasOwnProperty, OAt = 0, aH = function() {
                    var ft = /[^.]+$/.exec(f7 && f7.keys && f7.keys.IE_PROTO || "");
                    return ft ? "Symbol(src)_1." + ft : "";
                  }(), ov = c7.toString, j0 = RJ.call(jg2), RAt = ob2._, fYt = kD("^" + RJ.call(ip).replace(o5, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), NJ = npt ? uo.Buffer : Ut, mL = uo.Symbol, FJ = uo.Uint8Array, NAt = NJ ? NJ.allocUnsafe : Ut, VJ = PJ(jg2.getPrototypeOf, jg2), ppt = jg2.create, h7 = c7.propertyIsEnumerable, p7 = OJ.splice, FAt = mL ? mL.isConcatSpreadable : Ut, d7 = mL ? mL.iterator : Ut, PD = mL ? mL.toStringTag : Ut, p_ = function() {
                    try {
                      var ft = pH(jg2, "defineProperty");
                      return ft({}, "", {}), ft;
                    } catch {
                    }
                  }(), g7 = uo.clearTimeout !== ob2.clearTimeout && uo.clearTimeout, hYt = Bo && Bo.now !== ob2.Date.now && Bo.now, pYt = uo.setTimeout !== ob2.setTimeout && uo.setTimeout, BJ = _h.ceil, zJ = _h.floor, dpt = jg2.getOwnPropertySymbols, VAt = NJ ? NJ.isBuffer : Ut, LD = uo.isFinite, Uf2 = OJ.join, BAt = PJ(jg2.keys, jg2), kd2 = _h.max, sb2 = _h.min, dYt = Bo.now, Pd2 = uo.parseInt, zAt = _h.random, jAt = OJ.reverse, v7 = pH(uo, "DataView"), oH = pH(uo, "Map"), gpt = pH(uo, "Promise"), y7 = pH(uo, "Set"), sH = pH(uo, "WeakMap"), lH = pH(jg2, "create"), jJ = sH && new sH(), m7 = {}, gYt = dH(v7), vYt = dH(oH), yYt = dH(gpt), mYt = dH(y7), bYt = dH(sH), WJ = mL ? mL.prototype : Ut, C6 = WJ ? WJ.valueOf : Ut, WAt = WJ ? WJ.toString : Ut;
                  function Pn(ft) {
                    if (Fy(ft) && !Zf2(ft) && !(ft instanceof qu)) {
                      if (ft instanceof GM)
                        return ft;
                      if (ip.call(ft, "__wrapped__"))
                        return MRe(ft);
                    }
                    return new GM(ft);
                  }
                  var b7 = function() {
                    function ft() {
                    }
                    return function(Dt) {
                      if (!dy(Dt))
                        return {};
                      if (ppt)
                        return ppt(Dt);
                      ft.prototype = Dt;
                      var ee2 = new ft();
                      return ft.prototype = Ut, ee2;
                    };
                  }();
                  function GJ() {
                  }
                  function GM(ft, Dt) {
                    this.__wrapped__ = ft, this.__actions__ = [], this.__chain__ = !!Dt, this.__index__ = 0, this.__values__ = Ut;
                  }
                  Pn.templateSettings = { escape: ab2, evaluate: BM, interpolate: i1, variable: "", imports: { _: Pn } }, Pn.prototype = GJ.prototype, Pn.prototype.constructor = Pn, GM.prototype = b7(GJ.prototype), GM.prototype.constructor = GM;
                  function qu(ft) {
                    this.__wrapped__ = ft, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = hs, this.__views__ = [];
                  }
                  function pS() {
                    var ft = new qu(this.__wrapped__);
                    return ft.__actions__ = ZM(this.__actions__), ft.__dir__ = this.__dir__, ft.__filtered__ = this.__filtered__, ft.__iteratees__ = ZM(this.__iteratees__), ft.__takeCount__ = this.__takeCount__, ft.__views__ = ZM(this.__views__), ft;
                  }
                  function _Yt() {
                    if (this.__filtered__) {
                      var ft = new qu(this);
                      ft.__dir__ = -1, ft.__filtered__ = true;
                    } else
                      ft = this.clone(), ft.__dir__ *= -1;
                    return ft;
                  }
                  function xYt() {
                    var ft = this.__wrapped__.value(), Dt = this.__dir__, ee2 = Zf2(ft), Fe2 = Dt < 0, hn = ee2 ? ft.length : 0, $n = pnr(0, hn, this.__views__), jr = $n.start, ni2 = $n.end, Vi2 = ni2 - jr, Ro = Fe2 ? ni2 : jr - 1, No = this.__iteratees__, ls = No.length, xl = 0, Tu = sb2(Vi2, this.__takeCount__);
                    if (!ee2 || !Fe2 && hn == Vi2 && Tu == Vi2)
                      return Vh2(ft, this.__actions__);
                    var Dc2 = [];
                    t:
                      for (; Vi2-- && xl < Tu; ) {
                        Ro += Dt;
                        for (var Bh2 = -1, Ec2 = ft[Ro]; ++Bh2 < ls; ) {
                          var Sp = No[Bh2], Hp = Sp.iteratee, FT = Sp.type, O22 = Hp(Ec2);
                          if (FT == yl)
                            Ec2 = O22;
                          else if (!O22) {
                            if (FT == _l)
                              continue t;
                            break t;
                          }
                        }
                        Dc2[xl++] = Ec2;
                      }
                    return Dc2;
                  }
                  qu.prototype = b7(GJ.prototype), qu.prototype.constructor = qu;
                  function T6(ft) {
                    var Dt = -1, ee2 = ft == null ? 0 : ft.length;
                    for (this.clear(); ++Dt < ee2; ) {
                      var Fe2 = ft[Dt];
                      this.set(Fe2[0], Fe2[1]);
                    }
                  }
                  function GAt() {
                    this.__data__ = lH ? lH(null) : {}, this.size = 0;
                  }
                  function wYt(ft) {
                    var Dt = this.has(ft) && delete this.__data__[ft];
                    return this.size -= Dt ? 1 : 0, Dt;
                  }
                  function SYt(ft) {
                    var Dt = this.__data__;
                    if (lH) {
                      var ee2 = Dt[ft];
                      return ee2 === nn ? Ut : ee2;
                    }
                    return ip.call(Dt, ft) ? Dt[ft] : Ut;
                  }
                  function MYt(ft) {
                    var Dt = this.__data__;
                    return lH ? Dt[ft] !== Ut : ip.call(Dt, ft);
                  }
                  function HAt(ft, Dt) {
                    var ee2 = this.__data__;
                    return this.size += this.has(ft) ? 0 : 1, ee2[ft] = lH && Dt === Ut ? nn : Dt, this;
                  }
                  T6.prototype.clear = GAt, T6.prototype.delete = wYt, T6.prototype.get = SYt, T6.prototype.has = MYt, T6.prototype.set = HAt;
                  function f5(ft) {
                    var Dt = -1, ee2 = ft == null ? 0 : ft.length;
                    for (this.clear(); ++Dt < ee2; ) {
                      var Fe2 = ft[Dt];
                      this.set(Fe2[0], Fe2[1]);
                    }
                  }
                  function CYt() {
                    this.__data__ = [], this.size = 0;
                  }
                  function TYt(ft) {
                    var Dt = this.__data__, ee2 = HJ(Dt, ft);
                    if (ee2 < 0)
                      return false;
                    var Fe2 = Dt.length - 1;
                    return ee2 == Fe2 ? Dt.pop() : p7.call(Dt, ee2, 1), --this.size, true;
                  }
                  function UAt(ft) {
                    var Dt = this.__data__, ee2 = HJ(Dt, ft);
                    return ee2 < 0 ? Ut : Dt[ee2][1];
                  }
                  function qAt(ft) {
                    return HJ(this.__data__, ft) > -1;
                  }
                  function AYt(ft, Dt) {
                    var ee2 = this.__data__, Fe2 = HJ(ee2, ft);
                    return Fe2 < 0 ? (++this.size, ee2.push([ft, Dt])) : ee2[Fe2][1] = Dt, this;
                  }
                  f5.prototype.clear = CYt, f5.prototype.delete = TYt, f5.prototype.get = UAt, f5.prototype.has = qAt, f5.prototype.set = AYt;
                  function h5(ft) {
                    var Dt = -1, ee2 = ft == null ? 0 : ft.length;
                    for (this.clear(); ++Dt < ee2; ) {
                      var Fe2 = ft[Dt];
                      this.set(Fe2[0], Fe2[1]);
                    }
                  }
                  function IYt() {
                    this.size = 0, this.__data__ = { hash: new T6(), map: new (oH || f5)(), string: new T6() };
                  }
                  function DYt(ft) {
                    var Dt = bIt(this, ft).delete(ft);
                    return this.size -= Dt ? 1 : 0, Dt;
                  }
                  function _7(ft) {
                    return bIt(this, ft).get(ft);
                  }
                  function EYt(ft) {
                    return bIt(this, ft).has(ft);
                  }
                  function kYt(ft, Dt) {
                    var ee2 = bIt(this, ft), Fe2 = ee2.size;
                    return ee2.set(ft, Dt), this.size += ee2.size == Fe2 ? 0 : 1, this;
                  }
                  h5.prototype.clear = IYt, h5.prototype.delete = DYt, h5.prototype.get = _7, h5.prototype.has = EYt, h5.prototype.set = kYt;
                  function A6(ft) {
                    var Dt = -1, ee2 = ft == null ? 0 : ft.length;
                    for (this.__data__ = new h5(); ++Dt < ee2; )
                      this.add(ft[Dt]);
                  }
                  function PYt(ft) {
                    return this.__data__.set(ft, nn), this;
                  }
                  function LYt(ft) {
                    return this.__data__.has(ft);
                  }
                  A6.prototype.add = A6.prototype.push = PYt, A6.prototype.has = LYt;
                  function HM(ft) {
                    var Dt = this.__data__ = new f5(ft);
                    this.size = Dt.size;
                  }
                  function ZAt() {
                    this.__data__ = new f5(), this.size = 0;
                  }
                  function OYt(ft) {
                    var Dt = this.__data__, ee2 = Dt.delete(ft);
                    return this.size = Dt.size, ee2;
                  }
                  function RYt(ft) {
                    return this.__data__.get(ft);
                  }
                  function NYt(ft) {
                    return this.__data__.has(ft);
                  }
                  function FYt(ft, Dt) {
                    var ee2 = this.__data__;
                    if (ee2 instanceof f5) {
                      var Fe2 = ee2.__data__;
                      if (!oH || Fe2.length < Yt - 1)
                        return Fe2.push([ft, Dt]), this.size = ++ee2.size, this;
                      ee2 = this.__data__ = new h5(Fe2);
                    }
                    return ee2.set(ft, Dt), this.size = ee2.size, this;
                  }
                  HM.prototype.clear = ZAt, HM.prototype.delete = OYt, HM.prototype.get = RYt, HM.prototype.has = NYt, HM.prototype.set = FYt;
                  function $At(ft, Dt) {
                    var ee2 = Zf2(ft), Fe2 = !ee2 && gH(ft), hn = !ee2 && !Fe2 && w7(ft), $n = !ee2 && !Fe2 && !hn && KJ(ft), jr = ee2 || Fe2 || hn || $n, ni2 = jr ? upt(ft.length, uYt) : [], Vi2 = ni2.length;
                    for (var Ro in ft)
                      (Dt || ip.call(ft, Ro)) && !(jr && (Ro == "length" || hn && (Ro == "offset" || Ro == "parent") || $n && (Ro == "buffer" || Ro == "byteLength" || Ro == "byteOffset") || L6(Ro, Vi2))) && ni2.push(Ro);
                    return ni2;
                  }
                  function YAt(ft) {
                    var Dt = ft.length;
                    return Dt ? ft[Ipt(0, Dt - 1)] : Ut;
                  }
                  function VYt(ft, Dt) {
                    return _It(ZM(ft), I6(Dt, 0, ft.length));
                  }
                  function BYt(ft) {
                    return _It(ZM(ft));
                  }
                  function vpt(ft, Dt, ee2) {
                    (ee2 !== Ut && !d5(ft[Dt], ee2) || ee2 === Ut && !(Dt in ft)) && p5(ft, Dt, ee2);
                  }
                  function uH(ft, Dt, ee2) {
                    var Fe2 = ft[Dt];
                    (!(ip.call(ft, Dt) && d5(Fe2, ee2)) || ee2 === Ut && !(Dt in ft)) && p5(ft, Dt, ee2);
                  }
                  function HJ(ft, Dt) {
                    for (var ee2 = ft.length; ee2--; )
                      if (d5(ft[ee2][0], Dt))
                        return ee2;
                    return -1;
                  }
                  function zYt(ft, Dt, ee2, Fe2) {
                    return bL(ft, function(hn, $n, jr) {
                      Dt(Fe2, hn, ee2(hn), jr);
                    }), Fe2;
                  }
                  function KAt(ft, Dt) {
                    return ft && _L(Dt, g_(Dt), ft);
                  }
                  function jYt(ft, Dt) {
                    return ft && _L(Dt, YM(Dt), ft);
                  }
                  function p5(ft, Dt, ee2) {
                    Dt == "__proto__" && p_ ? p_(ft, Dt, { configurable: true, enumerable: true, value: ee2, writable: true }) : ft[Dt] = ee2;
                  }
                  function ypt(ft, Dt) {
                    for (var ee2 = -1, Fe2 = Dt.length, hn = fa2(Fe2), $n = ft == null; ++ee2 < Fe2; )
                      hn[ee2] = $n ? Ut : xKt(ft, Dt[ee2]);
                    return hn;
                  }
                  function I6(ft, Dt, ee2) {
                    return ft === ft && (ee2 !== Ut && (ft = ft <= ee2 ? ft : ee2), Dt !== Ut && (ft = ft >= Dt ? ft : Dt)), ft;
                  }
                  function UM(ft, Dt, ee2, Fe2, hn, $n) {
                    var jr, ni2 = Dt & Yn, Vi2 = Dt & Rr, Ro = Dt & Ur;
                    if (ee2 && (jr = hn ? ee2(ft, Fe2, hn, $n) : ee2(ft)), jr !== Ut)
                      return jr;
                    if (!dy(ft))
                      return ft;
                    var No = Zf2(ft);
                    if (No) {
                      if (jr = gnr(ft), !ni2)
                        return ZM(ft, jr);
                    } else {
                      var ls = gS(ft), xl = ls == uS || ls == FM;
                      if (w7(ft))
                        return K4e(ft, ni2);
                      if (ls == u_ || ls == mh2 || xl && !hn) {
                        if (jr = Vi2 || xl ? {} : gRe(ft), !ni2)
                          return Vi2 ? inr(ft, jYt(jr, ft)) : rnr(ft, KAt(jr, ft));
                      } else {
                        if (!av[ls])
                          return hn ? ft : {};
                        jr = vnr(ft, ls, ni2);
                      }
                    }
                    $n || ($n = new HM());
                    var Tu = $n.get(ft);
                    if (Tu)
                      return Tu;
                    $n.set(ft, jr), HRe(ft) ? ft.forEach(function(Ec2) {
                      jr.add(UM(Ec2, Dt, ee2, Ec2, ft, $n));
                    }) : WRe(ft) && ft.forEach(function(Ec2, Sp) {
                      jr.set(Sp, UM(Ec2, Dt, ee2, Sp, ft, $n));
                    });
                    var Dc2 = Ro ? Vi2 ? sKt : oKt : Vi2 ? YM : g_, Bh2 = No ? Ut : Dc2(ft);
                    return jM(Bh2 || ft, function(Ec2, Sp) {
                      Bh2 && (Sp = Ec2, Ec2 = ft[Sp]), uH(jr, Sp, UM(Ec2, Dt, ee2, Sp, ft, $n));
                    }), jr;
                  }
                  function WYt(ft) {
                    var Dt = g_(ft);
                    return function(ee2) {
                      return XAt(ee2, ft, Dt);
                    };
                  }
                  function XAt(ft, Dt, ee2) {
                    var Fe2 = ee2.length;
                    if (ft == null)
                      return !Fe2;
                    for (ft = jg2(ft); Fe2--; ) {
                      var hn = ee2[Fe2], $n = Dt[hn], jr = ft[hn];
                      if (jr === Ut && !(hn in ft) || !$n(jr))
                        return false;
                    }
                    return true;
                  }
                  function QAt(ft, Dt, ee2) {
                    if (typeof ft != "function")
                      throw new WM(Re2);
                    return Lpt(function() {
                      ft.apply(Ut, ee2);
                    }, Dt);
                  }
                  function cH(ft, Dt, ee2, Fe2) {
                    var hn = -1, $n = TJ, jr = true, ni2 = ft.length, Vi2 = [], Ro = Dt.length;
                    if (!ni2)
                      return Vi2;
                    ee2 && (Dt = Xv(Dt, hS(ee2))), Fe2 ? ($n = ipt, jr = false) : Dt.length >= Yt && ($n = M6, jr = false, Dt = new A6(Dt));
                    t:
                      for (; ++hn < ni2; ) {
                        var No = ft[hn], ls = ee2 == null ? No : ee2(No);
                        if (No = Fe2 || No !== 0 ? No : 0, jr && ls === ls) {
                          for (var xl = Ro; xl--; )
                            if (Dt[xl] === ls)
                              continue t;
                          Vi2.push(No);
                        } else
                          $n(Dt, ls, Fe2) || Vi2.push(No);
                      }
                    return Vi2;
                  }
                  var bL = eRe(qM), JAt = eRe(_pt, true);
                  function GYt(ft, Dt) {
                    var ee2 = true;
                    return bL(ft, function(Fe2, hn, $n) {
                      return ee2 = !!Dt(Fe2, hn, $n), ee2;
                    }), ee2;
                  }
                  function x7(ft, Dt, ee2) {
                    for (var Fe2 = -1, hn = ft.length; ++Fe2 < hn; ) {
                      var $n = ft[Fe2], jr = Dt($n);
                      if (jr != null && (ni2 === Ut ? jr === jr && !NT(jr) : ee2(jr, ni2)))
                        var ni2 = jr, Vi2 = $n;
                    }
                    return Vi2;
                  }
                  function tIt(ft, Dt, ee2, Fe2) {
                    var hn = ft.length;
                    for (ee2 = wh2(ee2), ee2 < 0 && (ee2 = -ee2 > hn ? 0 : hn + ee2), Fe2 = Fe2 === Ut || Fe2 > hn ? hn : wh2(Fe2), Fe2 < 0 && (Fe2 += hn), Fe2 = ee2 > Fe2 ? 0 : qRe(Fe2); ee2 < Fe2; )
                      ft[ee2++] = Dt;
                    return ft;
                  }
                  function mpt(ft, Dt) {
                    var ee2 = [];
                    return bL(ft, function(Fe2, hn, $n) {
                      Dt(Fe2, hn, $n) && ee2.push(Fe2);
                    }), ee2;
                  }
                  function lb2(ft, Dt, ee2, Fe2, hn) {
                    var $n = -1, jr = ft.length;
                    for (ee2 || (ee2 = mnr), hn || (hn = []); ++$n < jr; ) {
                      var ni2 = ft[$n];
                      Dt > 0 && ee2(ni2) ? Dt > 1 ? lb2(ni2, Dt - 1, ee2, Fe2, hn) : yL(hn, ni2) : Fe2 || (hn[hn.length] = ni2);
                    }
                    return hn;
                  }
                  var bpt = nRe(), eIt = nRe(true);
                  function qM(ft, Dt) {
                    return ft && bpt(ft, Dt, g_);
                  }
                  function _pt(ft, Dt) {
                    return ft && eIt(ft, Dt, g_);
                  }
                  function UJ(ft, Dt) {
                    return vL(Dt, function(ee2) {
                      return O6(ft[ee2]);
                    });
                  }
                  function D6(ft, Dt) {
                    Dt = ig2(Dt, ft);
                    for (var ee2 = 0, Fe2 = Dt.length; ft != null && ee2 < Fe2; )
                      ft = ft[xL(Dt[ee2++])];
                    return ee2 && ee2 == Fe2 ? ft : Ut;
                  }
                  function Bx(ft, Dt, ee2) {
                    var Fe2 = Dt(ft);
                    return Zf2(ft) ? Fe2 : yL(Fe2, ee2(ft));
                  }
                  function ub2(ft) {
                    return ft == null ? ft === Ut ? _u : PT : PD && PD in jg2(ft) ? hnr(ft) : Cnr(ft);
                  }
                  function xpt(ft, Dt) {
                    return ft > Dt;
                  }
                  function HYt(ft, Dt) {
                    return ft != null && ip.call(ft, Dt);
                  }
                  function UYt(ft, Dt) {
                    return ft != null && Dt in jg2(ft);
                  }
                  function qYt(ft, Dt, ee2) {
                    return ft >= sb2(Dt, ee2) && ft < kd2(Dt, ee2);
                  }
                  function fH(ft, Dt, ee2) {
                    for (var Fe2 = ee2 ? ipt : TJ, hn = ft[0].length, $n = ft.length, jr = $n, ni2 = fa2($n), Vi2 = 1 / 0, Ro = []; jr--; ) {
                      var No = ft[jr];
                      jr && Dt && (No = Xv(No, hS(Dt))), Vi2 = sb2(No.length, Vi2), ni2[jr] = !ee2 && (Dt || hn >= 120 && No.length >= 120) ? new A6(jr && No) : Ut;
                    }
                    No = ft[0];
                    var ls = -1, xl = ni2[0];
                    t:
                      for (; ++ls < hn && Ro.length < Vi2; ) {
                        var Tu = No[ls], Dc2 = Dt ? Dt(Tu) : Tu;
                        if (Tu = ee2 || Tu !== 0 ? Tu : 0, !(xl ? M6(xl, Dc2) : Fe2(Ro, Dc2, ee2))) {
                          for (jr = $n; --jr; ) {
                            var Bh2 = ni2[jr];
                            if (!(Bh2 ? M6(Bh2, Dc2) : Fe2(ft[jr], Dc2, ee2)))
                              continue t;
                          }
                          xl && xl.push(Dc2), Ro.push(Tu);
                        }
                      }
                    return Ro;
                  }
                  function ZYt(ft, Dt, ee2, Fe2) {
                    return qM(ft, function(hn, $n, jr) {
                      Dt(Fe2, ee2(hn), $n, jr);
                    }), Fe2;
                  }
                  function E6(ft, Dt, ee2) {
                    Dt = ig2(Dt, ft), ft = bRe(ft, Dt);
                    var Fe2 = ft == null ? ft : ft[xL(OD(Dt))];
                    return Fe2 == null ? Ut : P22(Fe2, ft, ee2);
                  }
                  function nIt(ft) {
                    return Fy(ft) && ub2(ft) == mh2;
                  }
                  function $Yt(ft) {
                    return Fy(ft) && ub2(ft) == $i2;
                  }
                  function YYt(ft) {
                    return Fy(ft) && ub2(ft) == Gp;
                  }
                  function hH(ft, Dt, ee2, Fe2, hn) {
                    return ft === Dt ? true : ft == null || Dt == null || !Fy(ft) && !Fy(Dt) ? ft !== ft && Dt !== Dt : rIt(ft, Dt, ee2, Fe2, hH, hn);
                  }
                  function rIt(ft, Dt, ee2, Fe2, hn, $n) {
                    var jr = Zf2(ft), ni2 = Zf2(Dt), Vi2 = jr ? Cf2 : gS(ft), Ro = ni2 ? Cf2 : gS(Dt);
                    Vi2 = Vi2 == mh2 ? u_ : Vi2, Ro = Ro == mh2 ? u_ : Ro;
                    var No = Vi2 == u_, ls = Ro == u_, xl = Vi2 == Ro;
                    if (xl && w7(ft)) {
                      if (!w7(Dt))
                        return false;
                      jr = true, No = false;
                    }
                    if (xl && !No)
                      return $n || ($n = new HM()), jr || KJ(ft) ? hRe(ft, Dt, ee2, Fe2, hn, $n) : cnr(ft, Dt, Vi2, ee2, Fe2, hn, $n);
                    if (!(ee2 & Hr)) {
                      var Tu = No && ip.call(ft, "__wrapped__"), Dc2 = ls && ip.call(Dt, "__wrapped__");
                      if (Tu || Dc2) {
                        var Bh2 = Tu ? ft.value() : ft, Ec2 = Dc2 ? Dt.value() : Dt;
                        return $n || ($n = new HM()), hn(Bh2, Ec2, ee2, Fe2, $n);
                      }
                    }
                    return xl ? ($n || ($n = new HM()), fnr(ft, Dt, ee2, Fe2, hn, $n)) : false;
                  }
                  function KYt(ft) {
                    return Fy(ft) && gS(ft) == Ry;
                  }
                  function wpt(ft, Dt, ee2, Fe2) {
                    var hn = ee2.length, $n = hn, jr = !Fe2;
                    if (ft == null)
                      return !$n;
                    for (ft = jg2(ft); hn--; ) {
                      var ni2 = ee2[hn];
                      if (jr && ni2[2] ? ni2[1] !== ft[ni2[0]] : !(ni2[0] in ft))
                        return false;
                    }
                    for (; ++hn < $n; ) {
                      ni2 = ee2[hn];
                      var Vi2 = ni2[0], Ro = ft[Vi2], No = ni2[1];
                      if (jr && ni2[2]) {
                        if (Ro === Ut && !(Vi2 in ft))
                          return false;
                      } else {
                        var ls = new HM();
                        if (Fe2)
                          var xl = Fe2(Ro, No, Vi2, ft, Dt, ls);
                        if (!(xl === Ut ? hH(No, Ro, Hr | si2, Fe2, ls) : xl))
                          return false;
                      }
                    }
                    return true;
                  }
                  function iIt(ft) {
                    if (!dy(ft) || _nr(ft))
                      return false;
                    var Dt = O6(ft) ? fYt : Fa2;
                    return Dt.test(dH(ft));
                  }
                  function Spt(ft) {
                    return Fy(ft) && ub2(ft) == cS;
                  }
                  function Mpt(ft) {
                    return Fy(ft) && gS(ft) == d0;
                  }
                  function XYt(ft) {
                    return Fy(ft) && TIt(ft.length) && !!Ev[ub2(ft)];
                  }
                  function aIt(ft) {
                    return typeof ft == "function" ? ft : ft == null ? KM : typeof ft == "object" ? Zf2(ft) ? lIt(ft[0], ft[1]) : sIt(ft) : r6e(ft);
                  }
                  function Cpt(ft) {
                    if (!Ppt(ft))
                      return BAt(ft);
                    var Dt = [];
                    for (var ee2 in jg2(ft))
                      ip.call(ft, ee2) && ee2 != "constructor" && Dt.push(ee2);
                    return Dt;
                  }
                  function QYt(ft) {
                    if (!dy(ft))
                      return Mnr(ft);
                    var Dt = Ppt(ft), ee2 = [];
                    for (var Fe2 in ft)
                      Fe2 == "constructor" && (Dt || !ip.call(ft, Fe2)) || ee2.push(Fe2);
                    return ee2;
                  }
                  function Tpt(ft, Dt) {
                    return ft < Dt;
                  }
                  function oIt(ft, Dt) {
                    var ee2 = -1, Fe2 = $M(ft) ? fa2(ft.length) : [];
                    return bL(ft, function(hn, $n, jr) {
                      Fe2[++ee2] = Dt(hn, $n, jr);
                    }), Fe2;
                  }
                  function sIt(ft) {
                    var Dt = uKt(ft);
                    return Dt.length == 1 && Dt[0][2] ? yRe(Dt[0][0], Dt[0][1]) : function(ee2) {
                      return ee2 === ft || wpt(ee2, ft, Dt);
                    };
                  }
                  function lIt(ft, Dt) {
                    return fKt(ft) && vRe(Dt) ? yRe(xL(ft), Dt) : function(ee2) {
                      var Fe2 = xKt(ee2, ft);
                      return Fe2 === Ut && Fe2 === Dt ? wKt(ee2, ft) : hH(Dt, Fe2, Hr | si2);
                    };
                  }
                  function qJ(ft, Dt, ee2, Fe2, hn) {
                    ft !== Dt && bpt(Dt, function($n, jr) {
                      if (hn || (hn = new HM()), dy($n))
                        JYt(ft, Dt, jr, ee2, qJ, Fe2, hn);
                      else {
                        var ni2 = Fe2 ? Fe2(pKt(ft, jr), $n, jr + "", ft, Dt, hn) : Ut;
                        ni2 === Ut && (ni2 = $n), vpt(ft, jr, ni2);
                      }
                    }, YM);
                  }
                  function JYt(ft, Dt, ee2, Fe2, hn, $n, jr) {
                    var ni2 = pKt(ft, ee2), Vi2 = pKt(Dt, ee2), Ro = jr.get(Vi2);
                    if (Ro) {
                      vpt(ft, ee2, Ro);
                      return;
                    }
                    var No = $n ? $n(ni2, Vi2, ee2 + "", ft, Dt, jr) : Ut, ls = No === Ut;
                    if (ls) {
                      var xl = Zf2(Vi2), Tu = !xl && w7(Vi2), Dc2 = !xl && !Tu && KJ(Vi2);
                      No = Vi2, xl || Tu || Dc2 ? Zf2(ni2) ? No = ni2 : ym(ni2) ? No = ZM(ni2) : Tu ? (ls = false, No = K4e(Vi2, true)) : Dc2 ? (ls = false, No = X4e(Vi2, true)) : No = [] : Opt(Vi2) || gH(Vi2) ? (No = ni2, gH(ni2) ? No = ZRe(ni2) : (!dy(ni2) || O6(ni2)) && (No = gRe(Vi2))) : ls = false;
                    }
                    ls && (jr.set(Vi2, No), hn(No, Vi2, Fe2, $n, jr), jr.delete(Vi2)), vpt(ft, ee2, No);
                  }
                  function uIt(ft, Dt) {
                    var ee2 = ft.length;
                    if (ee2)
                      return Dt += Dt < 0 ? ee2 : 0, L6(Dt, ee2) ? ft[Dt] : Ut;
                  }
                  function cIt(ft, Dt, ee2) {
                    Dt.length ? Dt = Xv(Dt, function($n) {
                      return Zf2($n) ? function(jr) {
                        return D6(jr, $n.length === 1 ? $n[0] : $n);
                      } : $n;
                    }) : Dt = [KM];
                    var Fe2 = -1;
                    Dt = Xv(Dt, hS(xc2()));
                    var hn = oIt(ft, function($n, jr, ni2) {
                      var Vi2 = Xv(Dt, function(Ro) {
                        return Ro($n);
                      });
                      return { criteria: Vi2, index: ++Fe2, value: $n };
                    });
                    return K$t(hn, function($n, jr) {
                      return nnr($n, jr, ee2);
                    });
                  }
                  function tKt(ft, Dt) {
                    return fIt(ft, Dt, function(ee2, Fe2) {
                      return wKt(ft, Fe2);
                    });
                  }
                  function fIt(ft, Dt, ee2) {
                    for (var Fe2 = -1, hn = Dt.length, $n = {}; ++Fe2 < hn; ) {
                      var jr = Dt[Fe2], ni2 = D6(ft, jr);
                      ee2(ni2, jr) && Kt($n, ig2(jr, ft), ni2);
                    }
                    return $n;
                  }
                  function eKt(ft) {
                    return function(Dt) {
                      return D6(Dt, ft);
                    };
                  }
                  function Apt(ft, Dt, ee2, Fe2) {
                    var hn = Fe2 ? Y$t : l7, $n = -1, jr = Dt.length, ni2 = ft;
                    for (ft === Dt && (Dt = ZM(Dt)), ee2 && (ni2 = Xv(ft, hS(ee2))); ++$n < jr; )
                      for (var Vi2 = 0, Ro = Dt[$n], No = ee2 ? ee2(Ro) : Ro; (Vi2 = hn(ni2, No, Vi2, Fe2)) > -1; )
                        ni2 !== ft && p7.call(ni2, Vi2, 1), p7.call(ft, Vi2, 1);
                    return ft;
                  }
                  function hIt(ft, Dt) {
                    for (var ee2 = ft ? Dt.length : 0, Fe2 = ee2 - 1; ee2--; ) {
                      var hn = Dt[ee2];
                      if (ee2 == Fe2 || hn !== $n) {
                        var $n = hn;
                        L6(hn) ? p7.call(ft, hn, 1) : ic2(ft, hn);
                      }
                    }
                    return ft;
                  }
                  function Ipt(ft, Dt) {
                    return ft + zJ(zAt() * (Dt - ft + 1));
                  }
                  function nKt(ft, Dt, ee2, Fe2) {
                    for (var hn = -1, $n = kd2(BJ((Dt - ft) / (ee2 || 1)), 0), jr = fa2($n); $n--; )
                      jr[Fe2 ? $n : ++hn] = ft, ft += ee2;
                    return jr;
                  }
                  function Dpt(ft, Dt) {
                    var ee2 = "";
                    if (!ft || Dt < 1 || Dt > Ga2)
                      return ee2;
                    do
                      Dt % 2 && (ee2 += ft), Dt = zJ(Dt / 2), Dt && (ft += ft);
                    while (Dt);
                    return ee2;
                  }
                  function xh2(ft, Dt) {
                    return dKt(mRe(ft, Dt, KM), ft + "");
                  }
                  function ct(ft) {
                    return YAt(XJ(ft));
                  }
                  function It(ft, Dt) {
                    var ee2 = XJ(ft);
                    return _It(ee2, I6(Dt, 0, ee2.length));
                  }
                  function Kt(ft, Dt, ee2, Fe2) {
                    if (!dy(ft))
                      return ft;
                    Dt = ig2(Dt, ft);
                    for (var hn = -1, $n = Dt.length, jr = $n - 1, ni2 = ft; ni2 != null && ++hn < $n; ) {
                      var Vi2 = xL(Dt[hn]), Ro = ee2;
                      if (Vi2 === "__proto__" || Vi2 === "constructor" || Vi2 === "prototype")
                        return ft;
                      if (hn != jr) {
                        var No = ni2[Vi2];
                        Ro = Fe2 ? Fe2(No, Vi2, ni2) : Ut, Ro === Ut && (Ro = dy(No) ? No : L6(Dt[hn + 1]) ? [] : {});
                      }
                      uH(ni2, Vi2, Ro), ni2 = ni2[Vi2];
                    }
                    return ft;
                  }
                  var De2 = jJ ? function(ft, Dt) {
                    return jJ.set(ft, Dt), ft;
                  } : KM, fn = p_ ? function(ft, Dt) {
                    return p_(ft, "toString", { configurable: true, enumerable: false, value: MKt(Dt), writable: true });
                  } : KM;
                  function Zn(ft) {
                    return _It(XJ(ft));
                  }
                  function Or(ft, Dt, ee2) {
                    var Fe2 = -1, hn = ft.length;
                    Dt < 0 && (Dt = -Dt > hn ? 0 : hn + Dt), ee2 = ee2 > hn ? hn : ee2, ee2 < 0 && (ee2 += hn), hn = Dt > ee2 ? 0 : ee2 - Dt >>> 0, Dt >>>= 0;
                    for (var $n = fa2(hn); ++Fe2 < hn; )
                      $n[Fe2] = ft[Fe2 + Dt];
                    return $n;
                  }
                  function ti2(ft, Dt) {
                    var ee2;
                    return bL(ft, function(Fe2, hn, $n) {
                      return ee2 = Dt(Fe2, hn, $n), !ee2;
                    }), !!ee2;
                  }
                  function Di2(ft, Dt, ee2) {
                    var Fe2 = 0, hn = ft == null ? Fe2 : ft.length;
                    if (typeof Dt == "number" && Dt === Dt && hn <= rc2) {
                      for (; Fe2 < hn; ) {
                        var $n = Fe2 + hn >>> 1, jr = ft[$n];
                        jr !== null && !NT(jr) && (ee2 ? jr <= Dt : jr < Dt) ? Fe2 = $n + 1 : hn = $n;
                      }
                      return hn;
                    }
                    return Co(ft, Dt, KM, ee2);
                  }
                  function Co(ft, Dt, ee2, Fe2) {
                    var hn = 0, $n = ft == null ? 0 : ft.length;
                    if ($n === 0)
                      return 0;
                    Dt = ee2(Dt);
                    for (var jr = Dt !== Dt, ni2 = Dt === null, Vi2 = NT(Dt), Ro = Dt === Ut; hn < $n; ) {
                      var No = zJ((hn + $n) / 2), ls = ee2(ft[No]), xl = ls !== Ut, Tu = ls === null, Dc2 = ls === ls, Bh2 = NT(ls);
                      if (jr)
                        var Ec2 = Fe2 || Dc2;
                      else
                        Ro ? Ec2 = Dc2 && (Fe2 || xl) : ni2 ? Ec2 = Dc2 && xl && (Fe2 || !Tu) : Vi2 ? Ec2 = Dc2 && xl && !Tu && (Fe2 || !Bh2) : Tu || Bh2 ? Ec2 = false : Ec2 = Fe2 ? ls <= Dt : ls < Dt;
                      Ec2 ? hn = No + 1 : $n = No;
                    }
                    return sb2($n, Zo);
                  }
                  function Eo(ft, Dt) {
                    for (var ee2 = -1, Fe2 = ft.length, hn = 0, $n = []; ++ee2 < Fe2; ) {
                      var jr = ft[ee2], ni2 = Dt ? Dt(jr) : jr;
                      if (!ee2 || !d5(ni2, Vi2)) {
                        var Vi2 = ni2;
                        $n[hn++] = jr === 0 ? 0 : jr;
                      }
                    }
                    return $n;
                  }
                  function Yo(ft) {
                    return typeof ft == "number" ? ft : NT(ft) ? pa2 : +ft;
                  }
                  function Ds(ft) {
                    if (typeof ft == "string")
                      return ft;
                    if (Zf2(ft))
                      return Xv(ft, Ds) + "";
                    if (NT(ft))
                      return WAt ? WAt.call(ft) : "";
                    var Dt = ft + "";
                    return Dt == "0" && 1 / ft == -Su ? "-0" : Dt;
                  }
                  function Hl(ft, Dt, ee2) {
                    var Fe2 = -1, hn = TJ, $n = ft.length, jr = true, ni2 = [], Vi2 = ni2;
                    if (ee2)
                      jr = false, hn = ipt;
                    else if ($n >= Yt) {
                      var Ro = Dt ? null : lnr(ft);
                      if (Ro)
                        return LJ(Ro);
                      jr = false, hn = M6, Vi2 = new A6();
                    } else
                      Vi2 = Dt ? [] : ni2;
                    t:
                      for (; ++Fe2 < $n; ) {
                        var No = ft[Fe2], ls = Dt ? Dt(No) : No;
                        if (No = ee2 || No !== 0 ? No : 0, jr && ls === ls) {
                          for (var xl = Vi2.length; xl--; )
                            if (Vi2[xl] === ls)
                              continue t;
                          Dt && Vi2.push(ls), ni2.push(No);
                        } else
                          hn(Vi2, ls, ee2) || (Vi2 !== ni2 && Vi2.push(ls), ni2.push(No));
                      }
                    return ni2;
                  }
                  function ic2(ft, Dt) {
                    return Dt = ig2(Dt, ft), ft = bRe(ft, Dt), ft == null || delete ft[xL(OD(Dt))];
                  }
                  function qf2(ft, Dt, ee2, Fe2) {
                    return Kt(ft, Dt, ee2(D6(ft, Dt)), Fe2);
                  }
                  function Zu(ft, Dt, ee2, Fe2) {
                    for (var hn = ft.length, $n = Fe2 ? hn : -1; (Fe2 ? $n-- : ++$n < hn) && Dt(ft[$n], $n, ft); )
                      ;
                    return ee2 ? Or(ft, Fe2 ? 0 : $n, Fe2 ? $n + 1 : hn) : Or(ft, Fe2 ? $n + 1 : 0, Fe2 ? hn : $n);
                  }
                  function Vh2(ft, Dt) {
                    var ee2 = ft;
                    return ee2 instanceof qu && (ee2 = ee2.value()), AJ(Dt, function(Fe2, hn) {
                      return hn.func.apply(hn.thisArg, yL([Fe2], hn.args));
                    }, ee2);
                  }
                  function ap(ft, Dt, ee2) {
                    var Fe2 = ft.length;
                    if (Fe2 < 2)
                      return Fe2 ? Hl(ft[0]) : [];
                    for (var hn = -1, $n = fa2(Fe2); ++hn < Fe2; )
                      for (var jr = ft[hn], ni2 = -1; ++ni2 < Fe2; )
                        ni2 != hn && ($n[hn] = cH($n[hn] || jr, ft[ni2], Dt, ee2));
                    return Hl(lb2($n, 1), Dt, ee2);
                  }
                  function dS(ft, Dt, ee2) {
                    for (var Fe2 = -1, hn = ft.length, $n = Dt.length, jr = {}; ++Fe2 < hn; ) {
                      var ni2 = Fe2 < $n ? Dt[Fe2] : Ut;
                      ee2(jr, ft[Fe2], ni2);
                    }
                    return jr;
                  }
                  function cb2(ft) {
                    return ym(ft) ? ft : [];
                  }
                  function zx(ft) {
                    return typeof ft == "function" ? ft : KM;
                  }
                  function ig2(ft, Dt) {
                    return Zf2(ft) ? ft : fKt(ft, Dt) ? [ft] : SRe(ag2(ft));
                  }
                  var RT = xh2;
                  function d_(ft, Dt, ee2) {
                    var Fe2 = ft.length;
                    return ee2 = ee2 === Ut ? Fe2 : ee2, !Dt && ee2 >= Fe2 ? ft : Or(ft, Dt, ee2);
                  }
                  var Ept = g7 || function(ft) {
                    return ob2.clearTimeout(ft);
                  };
                  function K4e(ft, Dt) {
                    if (Dt)
                      return ft.slice();
                    var ee2 = ft.length, Fe2 = NAt ? NAt(ee2) : new ft.constructor(ee2);
                    return ft.copy(Fe2), Fe2;
                  }
                  function rKt(ft) {
                    var Dt = new ft.constructor(ft.byteLength);
                    return new FJ(Dt).set(new FJ(ft)), Dt;
                  }
                  function Jer(ft, Dt) {
                    var ee2 = Dt ? rKt(ft.buffer) : ft.buffer;
                    return new ft.constructor(ee2, ft.byteOffset, ft.byteLength);
                  }
                  function tnr(ft) {
                    var Dt = new ft.constructor(ft.source, ur.exec(ft));
                    return Dt.lastIndex = ft.lastIndex, Dt;
                  }
                  function enr(ft) {
                    return C6 ? jg2(C6.call(ft)) : {};
                  }
                  function X4e(ft, Dt) {
                    var ee2 = Dt ? rKt(ft.buffer) : ft.buffer;
                    return new ft.constructor(ee2, ft.byteOffset, ft.length);
                  }
                  function Q4e(ft, Dt) {
                    if (ft !== Dt) {
                      var ee2 = ft !== Ut, Fe2 = ft === null, hn = ft === ft, $n = NT(ft), jr = Dt !== Ut, ni2 = Dt === null, Vi2 = Dt === Dt, Ro = NT(Dt);
                      if (!ni2 && !Ro && !$n && ft > Dt || $n && jr && Vi2 && !ni2 && !Ro || Fe2 && jr && Vi2 || !ee2 && Vi2 || !hn)
                        return 1;
                      if (!Fe2 && !$n && !Ro && ft < Dt || Ro && ee2 && hn && !Fe2 && !$n || ni2 && ee2 && hn || !jr && hn || !Vi2)
                        return -1;
                    }
                    return 0;
                  }
                  function nnr(ft, Dt, ee2) {
                    for (var Fe2 = -1, hn = ft.criteria, $n = Dt.criteria, jr = hn.length, ni2 = ee2.length; ++Fe2 < jr; ) {
                      var Vi2 = Q4e(hn[Fe2], $n[Fe2]);
                      if (Vi2) {
                        if (Fe2 >= ni2)
                          return Vi2;
                        var Ro = ee2[Fe2];
                        return Vi2 * (Ro == "desc" ? -1 : 1);
                      }
                    }
                    return ft.index - Dt.index;
                  }
                  function J4e(ft, Dt, ee2, Fe2) {
                    for (var hn = -1, $n = ft.length, jr = ee2.length, ni2 = -1, Vi2 = Dt.length, Ro = kd2($n - jr, 0), No = fa2(Vi2 + Ro), ls = !Fe2; ++ni2 < Vi2; )
                      No[ni2] = Dt[ni2];
                    for (; ++hn < jr; )
                      (ls || hn < $n) && (No[ee2[hn]] = ft[hn]);
                    for (; Ro--; )
                      No[ni2++] = ft[hn++];
                    return No;
                  }
                  function tRe(ft, Dt, ee2, Fe2) {
                    for (var hn = -1, $n = ft.length, jr = -1, ni2 = ee2.length, Vi2 = -1, Ro = Dt.length, No = kd2($n - ni2, 0), ls = fa2(No + Ro), xl = !Fe2; ++hn < No; )
                      ls[hn] = ft[hn];
                    for (var Tu = hn; ++Vi2 < Ro; )
                      ls[Tu + Vi2] = Dt[Vi2];
                    for (; ++jr < ni2; )
                      (xl || hn < $n) && (ls[Tu + ee2[jr]] = ft[hn++]);
                    return ls;
                  }
                  function ZM(ft, Dt) {
                    var ee2 = -1, Fe2 = ft.length;
                    for (Dt || (Dt = fa2(Fe2)); ++ee2 < Fe2; )
                      Dt[ee2] = ft[ee2];
                    return Dt;
                  }
                  function _L(ft, Dt, ee2, Fe2) {
                    var hn = !ee2;
                    ee2 || (ee2 = {});
                    for (var $n = -1, jr = Dt.length; ++$n < jr; ) {
                      var ni2 = Dt[$n], Vi2 = Fe2 ? Fe2(ee2[ni2], ft[ni2], ni2, ee2, ft) : Ut;
                      Vi2 === Ut && (Vi2 = ft[ni2]), hn ? p5(ee2, ni2, Vi2) : uH(ee2, ni2, Vi2);
                    }
                    return ee2;
                  }
                  function rnr(ft, Dt) {
                    return _L(ft, cKt(ft), Dt);
                  }
                  function inr(ft, Dt) {
                    return _L(ft, pRe(ft), Dt);
                  }
                  function pIt(ft, Dt) {
                    return function(ee2, Fe2) {
                      var hn = Zf2(ee2) ? H$t : zYt, $n = Dt ? Dt() : {};
                      return hn(ee2, ft, xc2(Fe2, 2), $n);
                    };
                  }
                  function ZJ(ft) {
                    return xh2(function(Dt, ee2) {
                      var Fe2 = -1, hn = ee2.length, $n = hn > 1 ? ee2[hn - 1] : Ut, jr = hn > 2 ? ee2[2] : Ut;
                      for ($n = ft.length > 3 && typeof $n == "function" ? (hn--, $n) : Ut, jr && L2(ee2[0], ee2[1], jr) && ($n = hn < 3 ? Ut : $n, hn = 1), Dt = jg2(Dt); ++Fe2 < hn; ) {
                        var ni2 = ee2[Fe2];
                        ni2 && ft(Dt, ni2, Fe2, $n);
                      }
                      return Dt;
                    });
                  }
                  function eRe(ft, Dt) {
                    return function(ee2, Fe2) {
                      if (ee2 == null)
                        return ee2;
                      if (!$M(ee2))
                        return ft(ee2, Fe2);
                      for (var hn = ee2.length, $n = Dt ? hn : -1, jr = jg2(ee2); (Dt ? $n-- : ++$n < hn) && Fe2(jr[$n], $n, jr) !== false; )
                        ;
                      return ee2;
                    };
                  }
                  function nRe(ft) {
                    return function(Dt, ee2, Fe2) {
                      for (var hn = -1, $n = jg2(Dt), jr = Fe2(Dt), ni2 = jr.length; ni2--; ) {
                        var Vi2 = jr[ft ? ni2 : ++hn];
                        if (ee2($n[Vi2], Vi2, $n) === false)
                          break;
                      }
                      return Dt;
                    };
                  }
                  function anr(ft, Dt, ee2) {
                    var Fe2 = Dt & _i, hn = kpt(ft);
                    function $n() {
                      var jr = this && this !== ob2 && this instanceof $n ? hn : ft;
                      return jr.apply(Fe2 ? ee2 : this, arguments);
                    }
                    return $n;
                  }
                  function rRe(ft) {
                    return function(Dt) {
                      Dt = ag2(Dt);
                      var ee2 = u5(Dt) ? OT(Dt) : Ut, Fe2 = ee2 ? ee2[0] : Dt.charAt(0), hn = ee2 ? d_(ee2, 1).join("") : Dt.slice(1);
                      return Fe2[ft]() + hn;
                    };
                  }
                  function $J(ft) {
                    return function(Dt) {
                      return AJ(e6e(t6e(Dt).replace(P$t, "")), ft, "");
                    };
                  }
                  function kpt(ft) {
                    return function() {
                      var Dt = arguments;
                      switch (Dt.length) {
                        case 0:
                          return new ft();
                        case 1:
                          return new ft(Dt[0]);
                        case 2:
                          return new ft(Dt[0], Dt[1]);
                        case 3:
                          return new ft(Dt[0], Dt[1], Dt[2]);
                        case 4:
                          return new ft(Dt[0], Dt[1], Dt[2], Dt[3]);
                        case 5:
                          return new ft(Dt[0], Dt[1], Dt[2], Dt[3], Dt[4]);
                        case 6:
                          return new ft(Dt[0], Dt[1], Dt[2], Dt[3], Dt[4], Dt[5]);
                        case 7:
                          return new ft(Dt[0], Dt[1], Dt[2], Dt[3], Dt[4], Dt[5], Dt[6]);
                      }
                      var ee2 = b7(ft.prototype), Fe2 = ft.apply(ee2, Dt);
                      return dy(Fe2) ? Fe2 : ee2;
                    };
                  }
                  function onr(ft, Dt, ee2) {
                    var Fe2 = kpt(ft);
                    function hn() {
                      for (var $n = arguments.length, jr = fa2($n), ni2 = $n, Vi2 = YJ(hn); ni2--; )
                        jr[ni2] = arguments[ni2];
                      var Ro = $n < 3 && jr[0] !== Vi2 && jr[$n - 1] !== Vi2 ? [] : c52(jr, Vi2);
                      if ($n -= Ro.length, $n < ee2)
                        return lRe(ft, Dt, dIt, hn.placeholder, Ut, jr, Ro, Ut, Ut, ee2 - $n);
                      var No = this && this !== ob2 && this instanceof hn ? Fe2 : ft;
                      return P22(No, this, jr);
                    }
                    return hn;
                  }
                  function iRe(ft) {
                    return function(Dt, ee2, Fe2) {
                      var hn = jg2(Dt);
                      if (!$M(Dt)) {
                        var $n = xc2(ee2, 3);
                        Dt = g_(Dt), ee2 = function(ni2) {
                          return $n(hn[ni2], ni2, hn);
                        };
                      }
                      var jr = ft(Dt, ee2, Fe2);
                      return jr > -1 ? hn[$n ? Dt[jr] : jr] : Ut;
                    };
                  }
                  function aRe(ft) {
                    return P6(function(Dt) {
                      var ee2 = Dt.length, Fe2 = ee2, hn = GM.prototype.thru;
                      for (ft && Dt.reverse(); Fe2--; ) {
                        var $n = Dt[Fe2];
                        if (typeof $n != "function")
                          throw new WM(Re2);
                        if (hn && !jr && mIt($n) == "wrapper")
                          var jr = new GM([], true);
                      }
                      for (Fe2 = jr ? Fe2 : ee2; ++Fe2 < ee2; ) {
                        $n = Dt[Fe2];
                        var ni2 = mIt($n), Vi2 = ni2 == "wrapper" ? lKt($n) : Ut;
                        Vi2 && hKt(Vi2[0]) && Vi2[1] == (Oa2 | ts | di2 | Da2) && !Vi2[4].length && Vi2[9] == 1 ? jr = jr[mIt(Vi2[0])].apply(jr, Vi2[3]) : jr = $n.length == 1 && hKt($n) ? jr[ni2]() : jr.thru($n);
                      }
                      return function() {
                        var Ro = arguments, No = Ro[0];
                        if (jr && Ro.length == 1 && Zf2(No))
                          return jr.plant(No).value();
                        for (var ls = 0, xl = ee2 ? Dt[ls].apply(this, Ro) : No; ++ls < ee2; )
                          xl = Dt[ls].call(this, xl);
                        return xl;
                      };
                    });
                  }
                  function dIt(ft, Dt, ee2, Fe2, hn, $n, jr, ni2, Vi2, Ro) {
                    var No = Dt & Oa2, ls = Dt & _i, xl = Dt & Wa2, Tu = Dt & (ts | on), Dc2 = Dt & Fi2, Bh2 = xl ? Ut : kpt(ft);
                    function Ec2() {
                      for (var Sp = arguments.length, Hp = fa2(Sp), FT = Sp; FT--; )
                        Hp[FT] = arguments[FT];
                      if (Tu)
                        var O22 = YJ(Ec2), VT = kAt(Hp, O22);
                      if (Fe2 && (Hp = J4e(Hp, Fe2, hn, Tu)), $n && (Hp = tRe(Hp, $n, jr, Tu)), Sp -= VT, Tu && Sp < Ro) {
                        var mm = c52(Hp, O22);
                        return lRe(ft, Dt, dIt, Ec2.placeholder, ee2, Hp, mm, ni2, Vi2, Ro - Sp);
                      }
                      var g52 = ls ? ee2 : this, N6 = xl ? g52[ft] : ft;
                      return Sp = Hp.length, ni2 ? Hp = Tnr(Hp, ni2) : Dc2 && Sp > 1 && Hp.reverse(), No && Vi2 < Sp && (Hp.length = Vi2), this && this !== ob2 && this instanceof Ec2 && (N6 = Bh2 || kpt(N6)), N6.apply(g52, Hp);
                    }
                    return Ec2;
                  }
                  function oRe(ft, Dt) {
                    return function(ee2, Fe2) {
                      return ZYt(ee2, ft, Dt(Fe2), {});
                    };
                  }
                  function gIt(ft, Dt) {
                    return function(ee2, Fe2) {
                      var hn;
                      if (ee2 === Ut && Fe2 === Ut)
                        return Dt;
                      if (ee2 !== Ut && (hn = ee2), Fe2 !== Ut) {
                        if (hn === Ut)
                          return Fe2;
                        typeof ee2 == "string" || typeof Fe2 == "string" ? (ee2 = Ds(ee2), Fe2 = Ds(Fe2)) : (ee2 = Yo(ee2), Fe2 = Yo(Fe2)), hn = ft(ee2, Fe2);
                      }
                      return hn;
                    };
                  }
                  function iKt(ft) {
                    return P6(function(Dt) {
                      return Dt = Xv(Dt, hS(xc2())), xh2(function(ee2) {
                        var Fe2 = this;
                        return ft(Dt, function(hn) {
                          return P22(hn, Fe2, ee2);
                        });
                      });
                    });
                  }
                  function vIt(ft, Dt) {
                    Dt = Dt === Ut ? " " : Ds(Dt);
                    var ee2 = Dt.length;
                    if (ee2 < 2)
                      return ee2 ? Dpt(Dt, ft) : Dt;
                    var Fe2 = Dpt(Dt, BJ(ft / u7(Dt)));
                    return u5(Dt) ? d_(OT(Fe2), 0, ft).join("") : Fe2.slice(0, ft);
                  }
                  function snr(ft, Dt, ee2, Fe2) {
                    var hn = Dt & _i, $n = kpt(ft);
                    function jr() {
                      for (var ni2 = -1, Vi2 = arguments.length, Ro = -1, No = Fe2.length, ls = fa2(No + Vi2), xl = this && this !== ob2 && this instanceof jr ? $n : ft; ++Ro < No; )
                        ls[Ro] = Fe2[Ro];
                      for (; Vi2--; )
                        ls[Ro++] = arguments[++ni2];
                      return P22(xl, hn ? ee2 : this, ls);
                    }
                    return jr;
                  }
                  function sRe(ft) {
                    return function(Dt, ee2, Fe2) {
                      return Fe2 && typeof Fe2 != "number" && L2(Dt, ee2, Fe2) && (ee2 = Fe2 = Ut), Dt = R62(Dt), ee2 === Ut ? (ee2 = Dt, Dt = 0) : ee2 = R62(ee2), Fe2 = Fe2 === Ut ? Dt < ee2 ? 1 : -1 : R62(Fe2), nKt(Dt, ee2, Fe2, ft);
                    };
                  }
                  function yIt(ft) {
                    return function(Dt, ee2) {
                      return typeof Dt == "string" && typeof ee2 == "string" || (Dt = RD(Dt), ee2 = RD(ee2)), ft(Dt, ee2);
                    };
                  }
                  function lRe(ft, Dt, ee2, Fe2, hn, $n, jr, ni2, Vi2, Ro) {
                    var No = Dt & ts, ls = No ? jr : Ut, xl = No ? Ut : jr, Tu = No ? $n : Ut, Dc2 = No ? Ut : $n;
                    Dt |= No ? di2 : Yi2, Dt &= ~(No ? Yi2 : di2), Dt & Ia2 || (Dt &= ~(_i | Wa2));
                    var Bh2 = [ft, Dt, hn, Tu, ls, Dc2, xl, ni2, Vi2, Ro], Ec2 = ee2.apply(Ut, Bh2);
                    return hKt(ft) && _Re(Ec2, Bh2), Ec2.placeholder = Fe2, xRe(Ec2, ft, Dt);
                  }
                  function aKt(ft) {
                    var Dt = _h[ft];
                    return function(ee2, Fe2) {
                      if (ee2 = RD(ee2), Fe2 = Fe2 == null ? 0 : sb2(wh2(Fe2), 292), Fe2 && LD(ee2)) {
                        var hn = (ag2(ee2) + "e").split("e"), $n = Dt(hn[0] + "e" + (+hn[1] + Fe2));
                        return hn = (ag2($n) + "e").split("e"), +(hn[0] + "e" + (+hn[1] - Fe2));
                      }
                      return Dt(ee2);
                    };
                  }
                  var lnr = y7 && 1 / LJ(new y7([, -0]))[1] == Su ? function(ft) {
                    return new y7(ft);
                  } : AKt;
                  function uRe(ft) {
                    return function(Dt) {
                      var ee2 = gS(Dt);
                      return ee2 == Ry ? hpt(Dt) : ee2 == d0 ? eYt(Dt) : DJ(Dt, ft(Dt));
                    };
                  }
                  function k6(ft, Dt, ee2, Fe2, hn, $n, jr, ni2) {
                    var Vi2 = Dt & Wa2;
                    if (!Vi2 && typeof ft != "function")
                      throw new WM(Re2);
                    var Ro = Fe2 ? Fe2.length : 0;
                    if (Ro || (Dt &= ~(di2 | Yi2), Fe2 = hn = Ut), jr = jr === Ut ? jr : kd2(wh2(jr), 0), ni2 = ni2 === Ut ? ni2 : wh2(ni2), Ro -= hn ? hn.length : 0, Dt & Yi2) {
                      var No = Fe2, ls = hn;
                      Fe2 = hn = Ut;
                    }
                    var xl = Vi2 ? Ut : lKt(ft), Tu = [ft, Dt, ee2, Fe2, hn, No, ls, $n, jr, ni2];
                    if (xl && Snr(Tu, xl), ft = Tu[0], Dt = Tu[1], ee2 = Tu[2], Fe2 = Tu[3], hn = Tu[4], ni2 = Tu[9] = Tu[9] === Ut ? Vi2 ? 0 : ft.length : kd2(Tu[9] - Ro, 0), !ni2 && Dt & (ts | on) && (Dt &= ~(ts | on)), !Dt || Dt == _i)
                      var Dc2 = anr(ft, Dt, ee2);
                    else
                      Dt == ts || Dt == on ? Dc2 = onr(ft, Dt, ni2) : (Dt == di2 || Dt == (_i | di2)) && !hn.length ? Dc2 = snr(ft, Dt, ee2, Fe2) : Dc2 = dIt.apply(Ut, Tu);
                    var Bh2 = xl ? De2 : _Re;
                    return xRe(Bh2(Dc2, Tu), ft, Dt);
                  }
                  function cRe(ft, Dt, ee2, Fe2) {
                    return ft === Ut || d5(ft, c7[ee2]) && !ip.call(Fe2, ee2) ? Dt : ft;
                  }
                  function fRe(ft, Dt, ee2, Fe2, hn, $n) {
                    return dy(ft) && dy(Dt) && ($n.set(Dt, ft), qJ(ft, Dt, Ut, fRe, $n), $n.delete(Dt)), ft;
                  }
                  function unr(ft) {
                    return Opt(ft) ? Ut : ft;
                  }
                  function hRe(ft, Dt, ee2, Fe2, hn, $n) {
                    var jr = ee2 & Hr, ni2 = ft.length, Vi2 = Dt.length;
                    if (ni2 != Vi2 && !(jr && Vi2 > ni2))
                      return false;
                    var Ro = $n.get(ft), No = $n.get(Dt);
                    if (Ro && No)
                      return Ro == Dt && No == ft;
                    var ls = -1, xl = true, Tu = ee2 & si2 ? new A6() : Ut;
                    for ($n.set(ft, Dt), $n.set(Dt, ft); ++ls < ni2; ) {
                      var Dc2 = ft[ls], Bh2 = Dt[ls];
                      if (Fe2)
                        var Ec2 = jr ? Fe2(Bh2, Dc2, ls, Dt, ft, $n) : Fe2(Dc2, Bh2, ls, ft, Dt, $n);
                      if (Ec2 !== Ut) {
                        if (Ec2)
                          continue;
                        xl = false;
                        break;
                      }
                      if (Tu) {
                        if (!apt(Dt, function(Sp, Hp) {
                          if (!M6(Tu, Hp) && (Dc2 === Sp || hn(Dc2, Sp, ee2, Fe2, $n)))
                            return Tu.push(Hp);
                        })) {
                          xl = false;
                          break;
                        }
                      } else if (!(Dc2 === Bh2 || hn(Dc2, Bh2, ee2, Fe2, $n))) {
                        xl = false;
                        break;
                      }
                    }
                    return $n.delete(ft), $n.delete(Dt), xl;
                  }
                  function cnr(ft, Dt, ee2, Fe2, hn, $n, jr) {
                    switch (ee2) {
                      case xo:
                        if (ft.byteLength != Dt.byteLength || ft.byteOffset != Dt.byteOffset)
                          return false;
                        ft = ft.buffer, Dt = Dt.buffer;
                      case $i2:
                        return !(ft.byteLength != Dt.byteLength || !$n(new FJ(ft), new FJ(Dt)));
                      case bh2:
                      case Gp:
                      case Rx:
                        return d5(+ft, +Dt);
                      case B0:
                        return ft.name == Dt.name && ft.message == Dt.message;
                      case cS:
                      case fy:
                        return ft == Dt + "";
                      case Ry:
                        var ni2 = hpt;
                      case d0:
                        var Vi2 = Fe2 & Hr;
                        if (ni2 || (ni2 = LJ), ft.size != Dt.size && !Vi2)
                          return false;
                        var Ro = jr.get(ft);
                        if (Ro)
                          return Ro == Dt;
                        Fe2 |= si2, jr.set(ft, Dt);
                        var No = hRe(ni2(ft), ni2(Dt), Fe2, hn, $n, jr);
                        return jr.delete(ft), No;
                      case Vg2:
                        if (C6)
                          return C6.call(ft) == C6.call(Dt);
                    }
                    return false;
                  }
                  function fnr(ft, Dt, ee2, Fe2, hn, $n) {
                    var jr = ee2 & Hr, ni2 = oKt(ft), Vi2 = ni2.length, Ro = oKt(Dt), No = Ro.length;
                    if (Vi2 != No && !jr)
                      return false;
                    for (var ls = Vi2; ls--; ) {
                      var xl = ni2[ls];
                      if (!(jr ? xl in Dt : ip.call(Dt, xl)))
                        return false;
                    }
                    var Tu = $n.get(ft), Dc2 = $n.get(Dt);
                    if (Tu && Dc2)
                      return Tu == Dt && Dc2 == ft;
                    var Bh2 = true;
                    $n.set(ft, Dt), $n.set(Dt, ft);
                    for (var Ec2 = jr; ++ls < Vi2; ) {
                      xl = ni2[ls];
                      var Sp = ft[xl], Hp = Dt[xl];
                      if (Fe2)
                        var FT = jr ? Fe2(Hp, Sp, xl, Dt, ft, $n) : Fe2(Sp, Hp, xl, ft, Dt, $n);
                      if (!(FT === Ut ? Sp === Hp || hn(Sp, Hp, ee2, Fe2, $n) : FT)) {
                        Bh2 = false;
                        break;
                      }
                      Ec2 || (Ec2 = xl == "constructor");
                    }
                    if (Bh2 && !Ec2) {
                      var O22 = ft.constructor, VT = Dt.constructor;
                      O22 != VT && "constructor" in ft && "constructor" in Dt && !(typeof O22 == "function" && O22 instanceof O22 && typeof VT == "function" && VT instanceof VT) && (Bh2 = false);
                    }
                    return $n.delete(ft), $n.delete(Dt), Bh2;
                  }
                  function P6(ft) {
                    return dKt(mRe(ft, Ut, ARe), ft + "");
                  }
                  function oKt(ft) {
                    return Bx(ft, g_, cKt);
                  }
                  function sKt(ft) {
                    return Bx(ft, YM, pRe);
                  }
                  var lKt = jJ ? function(ft) {
                    return jJ.get(ft);
                  } : AKt;
                  function mIt(ft) {
                    for (var Dt = ft.name + "", ee2 = m7[Dt], Fe2 = ip.call(m7, Dt) ? ee2.length : 0; Fe2--; ) {
                      var hn = ee2[Fe2], $n = hn.func;
                      if ($n == null || $n == ft)
                        return hn.name;
                    }
                    return Dt;
                  }
                  function YJ(ft) {
                    var Dt = ip.call(Pn, "placeholder") ? Pn : ft;
                    return Dt.placeholder;
                  }
                  function xc2() {
                    var ft = Pn.iteratee || CKt;
                    return ft = ft === CKt ? aIt : ft, arguments.length ? ft(arguments[0], arguments[1]) : ft;
                  }
                  function bIt(ft, Dt) {
                    var ee2 = ft.__data__;
                    return bnr(Dt) ? ee2[typeof Dt == "string" ? "string" : "hash"] : ee2.map;
                  }
                  function uKt(ft) {
                    for (var Dt = g_(ft), ee2 = Dt.length; ee2--; ) {
                      var Fe2 = Dt[ee2], hn = ft[Fe2];
                      Dt[ee2] = [Fe2, hn, vRe(hn)];
                    }
                    return Dt;
                  }
                  function pH(ft, Dt) {
                    var ee2 = J$t(ft, Dt);
                    return iIt(ee2) ? ee2 : Ut;
                  }
                  function hnr(ft) {
                    var Dt = ip.call(ft, PD), ee2 = ft[PD];
                    try {
                      ft[PD] = Ut;
                      var Fe2 = true;
                    } catch {
                    }
                    var hn = ov.call(ft);
                    return Fe2 && (Dt ? ft[PD] = ee2 : delete ft[PD]), hn;
                  }
                  var cKt = dpt ? function(ft) {
                    return ft == null ? [] : (ft = jg2(ft), vL(dpt(ft), function(Dt) {
                      return h7.call(ft, Dt);
                    }));
                  } : IKt, pRe = dpt ? function(ft) {
                    for (var Dt = []; ft; )
                      yL(Dt, cKt(ft)), ft = VJ(ft);
                    return Dt;
                  } : IKt, gS = ub2;
                  (v7 && gS(new v7(new ArrayBuffer(1))) != xo || oH && gS(new oH()) != Ry || gpt && gS(gpt.resolve()) != ib2 || y7 && gS(new y7()) != d0 || sH && gS(new sH()) != lo) && (gS = function(ft) {
                    var Dt = ub2(ft), ee2 = Dt == u_ ? ft.constructor : Ut, Fe2 = ee2 ? dH(ee2) : "";
                    if (Fe2)
                      switch (Fe2) {
                        case gYt:
                          return xo;
                        case vYt:
                          return Ry;
                        case yYt:
                          return ib2;
                        case mYt:
                          return d0;
                        case bYt:
                          return lo;
                      }
                    return Dt;
                  });
                  function pnr(ft, Dt, ee2) {
                    for (var Fe2 = -1, hn = ee2.length; ++Fe2 < hn; ) {
                      var $n = ee2[Fe2], jr = $n.size;
                      switch ($n.type) {
                        case "drop":
                          ft += jr;
                          break;
                        case "dropRight":
                          Dt -= jr;
                          break;
                        case "take":
                          Dt = sb2(Dt, ft + jr);
                          break;
                        case "takeRight":
                          ft = kd2(ft, Dt - jr);
                          break;
                      }
                    }
                    return { start: ft, end: Dt };
                  }
                  function dnr(ft) {
                    var Dt = ft.match(Xht);
                    return Dt ? Dt[1].split(eH) : [];
                  }
                  function dRe(ft, Dt, ee2) {
                    Dt = ig2(Dt, ft);
                    for (var Fe2 = -1, hn = Dt.length, $n = false; ++Fe2 < hn; ) {
                      var jr = xL(Dt[Fe2]);
                      if (!($n = ft != null && ee2(ft, jr)))
                        break;
                      ft = ft[jr];
                    }
                    return $n || ++Fe2 != hn ? $n : (hn = ft == null ? 0 : ft.length, !!hn && TIt(hn) && L6(jr, hn) && (Zf2(ft) || gH(ft)));
                  }
                  function gnr(ft) {
                    var Dt = ft.length, ee2 = new ft.constructor(Dt);
                    return Dt && typeof ft[0] == "string" && ip.call(ft, "index") && (ee2.index = ft.index, ee2.input = ft.input), ee2;
                  }
                  function gRe(ft) {
                    return typeof ft.constructor == "function" && !Ppt(ft) ? b7(VJ(ft)) : {};
                  }
                  function vnr(ft, Dt, ee2) {
                    var Fe2 = ft.constructor;
                    switch (Dt) {
                      case $i2:
                        return rKt(ft);
                      case bh2:
                      case Gp:
                        return new Fe2(+ft);
                      case xo:
                        return Jer(ft, ee2);
                      case Os:
                      case Kl:
                      case Iu:
                      case Tf2:
                      case ud2:
                      case iv:
                      case Bg2:
                      case z0:
                      case zg2:
                        return X4e(ft, ee2);
                      case Ry:
                        return new Fe2();
                      case Rx:
                      case fy:
                        return new Fe2(ft);
                      case cS:
                        return tnr(ft);
                      case d0:
                        return new Fe2();
                      case Vg2:
                        return enr(ft);
                    }
                  }
                  function ynr(ft, Dt) {
                    var ee2 = Dt.length;
                    if (!ee2)
                      return ft;
                    var Fe2 = ee2 - 1;
                    return Dt[Fe2] = (ee2 > 1 ? "& " : "") + Dt[Fe2], Dt = Dt.join(ee2 > 2 ? ", " : " "), ft.replace(SJ, `{
/* [wrapped with ` + Dt + `] */
`);
                  }
                  function mnr(ft) {
                    return Zf2(ft) || gH(ft) || !!(FAt && ft && ft[FAt]);
                  }
                  function L6(ft, Dt) {
                    var ee2 = typeof ft;
                    return Dt = Dt == null ? Ga2 : Dt, !!Dt && (ee2 == "number" || ee2 != "symbol" && Ri2.test(ft)) && ft > -1 && ft % 1 == 0 && ft < Dt;
                  }
                  function L2(ft, Dt, ee2) {
                    if (!dy(ee2))
                      return false;
                    var Fe2 = typeof Dt;
                    return (Fe2 == "number" ? $M(ee2) && L6(Dt, ee2.length) : Fe2 == "string" && Dt in ee2) ? d5(ee2[Dt], ft) : false;
                  }
                  function fKt(ft, Dt) {
                    if (Zf2(ft))
                      return false;
                    var ee2 = typeof ft;
                    return ee2 == "number" || ee2 == "symbol" || ee2 == "boolean" || ft == null || NT(ft) ? true : fS.test(ft) || !f_.test(ft) || Dt != null && ft in jg2(Dt);
                  }
                  function bnr(ft) {
                    var Dt = typeof ft;
                    return Dt == "string" || Dt == "number" || Dt == "symbol" || Dt == "boolean" ? ft !== "__proto__" : ft === null;
                  }
                  function hKt(ft) {
                    var Dt = mIt(ft), ee2 = Pn[Dt];
                    if (typeof ee2 != "function" || !(Dt in qu.prototype))
                      return false;
                    if (ft === ee2)
                      return true;
                    var Fe2 = lKt(ee2);
                    return !!Fe2 && ft === Fe2[0];
                  }
                  function _nr(ft) {
                    return !!aH && aH in ft;
                  }
                  var xnr = f7 ? O6 : DKt;
                  function Ppt(ft) {
                    var Dt = ft && ft.constructor, ee2 = typeof Dt == "function" && Dt.prototype || c7;
                    return ft === ee2;
                  }
                  function vRe(ft) {
                    return ft === ft && !dy(ft);
                  }
                  function yRe(ft, Dt) {
                    return function(ee2) {
                      return ee2 == null ? false : ee2[ft] === Dt && (Dt !== Ut || ft in jg2(ee2));
                    };
                  }
                  function wnr(ft) {
                    var Dt = MIt(ft, function(Fe2) {
                      return ee2.size === dn && ee2.clear(), Fe2;
                    }), ee2 = Dt.cache;
                    return Dt;
                  }
                  function Snr(ft, Dt) {
                    var ee2 = ft[1], Fe2 = Dt[1], hn = ee2 | Fe2, $n = hn < (_i | Wa2 | Oa2), jr = Fe2 == Oa2 && ee2 == ts || Fe2 == Oa2 && ee2 == Da2 && ft[7].length <= Dt[8] || Fe2 == (Oa2 | Da2) && Dt[7].length <= Dt[8] && ee2 == ts;
                    if (!($n || jr))
                      return ft;
                    Fe2 & _i && (ft[2] = Dt[2], hn |= ee2 & _i ? 0 : Ia2);
                    var ni2 = Dt[3];
                    if (ni2) {
                      var Vi2 = ft[3];
                      ft[3] = Vi2 ? J4e(Vi2, ni2, Dt[4]) : ni2, ft[4] = Vi2 ? c52(ft[3], yn) : Dt[4];
                    }
                    return ni2 = Dt[5], ni2 && (Vi2 = ft[5], ft[5] = Vi2 ? tRe(Vi2, ni2, Dt[6]) : ni2, ft[6] = Vi2 ? c52(ft[5], yn) : Dt[6]), ni2 = Dt[7], ni2 && (ft[7] = ni2), Fe2 & Oa2 && (ft[8] = ft[8] == null ? Dt[8] : sb2(ft[8], Dt[8])), ft[9] == null && (ft[9] = Dt[9]), ft[0] = Dt[0], ft[1] = hn, ft;
                  }
                  function Mnr(ft) {
                    var Dt = [];
                    if (ft != null)
                      for (var ee2 in jg2(ft))
                        Dt.push(ee2);
                    return Dt;
                  }
                  function Cnr(ft) {
                    return ov.call(ft);
                  }
                  function mRe(ft, Dt, ee2) {
                    return Dt = kd2(Dt === Ut ? ft.length - 1 : Dt, 0), function() {
                      for (var Fe2 = arguments, hn = -1, $n = kd2(Fe2.length - Dt, 0), jr = fa2($n); ++hn < $n; )
                        jr[hn] = Fe2[Dt + hn];
                      hn = -1;
                      for (var ni2 = fa2(Dt + 1); ++hn < Dt; )
                        ni2[hn] = Fe2[hn];
                      return ni2[Dt] = ee2(jr), P22(ft, this, ni2);
                    };
                  }
                  function bRe(ft, Dt) {
                    return Dt.length < 2 ? ft : D6(ft, Or(Dt, 0, -1));
                  }
                  function Tnr(ft, Dt) {
                    for (var ee2 = ft.length, Fe2 = sb2(Dt.length, ee2), hn = ZM(ft); Fe2--; ) {
                      var $n = Dt[Fe2];
                      ft[Fe2] = L6($n, ee2) ? hn[$n] : Ut;
                    }
                    return ft;
                  }
                  function pKt(ft, Dt) {
                    if (!(Dt === "constructor" && typeof ft[Dt] == "function") && Dt != "__proto__")
                      return ft[Dt];
                  }
                  var _Re = wRe(De2), Lpt = pYt || function(ft, Dt) {
                    return ob2.setTimeout(ft, Dt);
                  }, dKt = wRe(fn);
                  function xRe(ft, Dt, ee2) {
                    var Fe2 = Dt + "";
                    return dKt(ft, ynr(Fe2, Anr(dnr(Fe2), ee2)));
                  }
                  function wRe(ft) {
                    var Dt = 0, ee2 = 0;
                    return function() {
                      var Fe2 = dYt(), hn = Ii2 - (Fe2 - ee2);
                      if (ee2 = Fe2, hn > 0) {
                        if (++Dt >= Wo)
                          return arguments[0];
                      } else
                        Dt = 0;
                      return ft.apply(Ut, arguments);
                    };
                  }
                  function _It(ft, Dt) {
                    var ee2 = -1, Fe2 = ft.length, hn = Fe2 - 1;
                    for (Dt = Dt === Ut ? Fe2 : Dt; ++ee2 < Dt; ) {
                      var $n = Ipt(ee2, hn), jr = ft[$n];
                      ft[$n] = ft[ee2], ft[ee2] = jr;
                    }
                    return ft.length = Dt, ft;
                  }
                  var SRe = wnr(function(ft) {
                    var Dt = [];
                    return ft.charCodeAt(0) === 46 && Dt.push(""), ft.replace(fL, function(ee2, Fe2, hn, $n) {
                      Dt.push(hn ? $n.replace(Dr, "$1") : Fe2 || ee2);
                    }), Dt;
                  });
                  function xL(ft) {
                    if (typeof ft == "string" || NT(ft))
                      return ft;
                    var Dt = ft + "";
                    return Dt == "0" && 1 / ft == -Su ? "-0" : Dt;
                  }
                  function dH(ft) {
                    if (ft != null) {
                      try {
                        return RJ.call(ft);
                      } catch {
                      }
                      try {
                        return ft + "";
                      } catch {
                      }
                    }
                    return "";
                  }
                  function Anr(ft, Dt) {
                    return jM(ep, function(ee2) {
                      var Fe2 = "_." + ee2[0];
                      Dt & ee2[1] && !TJ(ft, Fe2) && ft.push(Fe2);
                    }), ft.sort();
                  }
                  function MRe(ft) {
                    if (ft instanceof qu)
                      return ft.clone();
                    var Dt = new GM(ft.__wrapped__, ft.__chain__);
                    return Dt.__actions__ = ZM(ft.__actions__), Dt.__index__ = ft.__index__, Dt.__values__ = ft.__values__, Dt;
                  }
                  function Inr(ft, Dt, ee2) {
                    (ee2 ? L2(ft, Dt, ee2) : Dt === Ut) ? Dt = 1 : Dt = kd2(wh2(Dt), 0);
                    var Fe2 = ft == null ? 0 : ft.length;
                    if (!Fe2 || Dt < 1)
                      return [];
                    for (var hn = 0, $n = 0, jr = fa2(BJ(Fe2 / Dt)); hn < Fe2; )
                      jr[$n++] = Or(ft, hn, hn += Dt);
                    return jr;
                  }
                  function Dnr(ft) {
                    for (var Dt = -1, ee2 = ft == null ? 0 : ft.length, Fe2 = 0, hn = []; ++Dt < ee2; ) {
                      var $n = ft[Dt];
                      $n && (hn[Fe2++] = $n);
                    }
                    return hn;
                  }
                  function Enr() {
                    var ft = arguments.length;
                    if (!ft)
                      return [];
                    for (var Dt = fa2(ft - 1), ee2 = arguments[0], Fe2 = ft; Fe2--; )
                      Dt[Fe2 - 1] = arguments[Fe2];
                    return yL(Zf2(ee2) ? ZM(ee2) : [ee2], lb2(Dt, 1));
                  }
                  var knr = xh2(function(ft, Dt) {
                    return ym(ft) ? cH(ft, lb2(Dt, 1, ym, true)) : [];
                  }), Pnr = xh2(function(ft, Dt) {
                    var ee2 = OD(Dt);
                    return ym(ee2) && (ee2 = Ut), ym(ft) ? cH(ft, lb2(Dt, 1, ym, true), xc2(ee2, 2)) : [];
                  }), Lnr = xh2(function(ft, Dt) {
                    var ee2 = OD(Dt);
                    return ym(ee2) && (ee2 = Ut), ym(ft) ? cH(ft, lb2(Dt, 1, ym, true), Ut, ee2) : [];
                  });
                  function Onr(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    return Fe2 ? (Dt = ee2 || Dt === Ut ? 1 : wh2(Dt), Or(ft, Dt < 0 ? 0 : Dt, Fe2)) : [];
                  }
                  function Rnr(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    return Fe2 ? (Dt = ee2 || Dt === Ut ? 1 : wh2(Dt), Dt = Fe2 - Dt, Or(ft, 0, Dt < 0 ? 0 : Dt)) : [];
                  }
                  function Nnr(ft, Dt) {
                    return ft && ft.length ? Zu(ft, xc2(Dt, 3), true, true) : [];
                  }
                  function Fnr(ft, Dt) {
                    return ft && ft.length ? Zu(ft, xc2(Dt, 3), true) : [];
                  }
                  function Vnr(ft, Dt, ee2, Fe2) {
                    var hn = ft == null ? 0 : ft.length;
                    return hn ? (ee2 && typeof ee2 != "number" && L2(ft, Dt, ee2) && (ee2 = 0, Fe2 = hn), tIt(ft, Dt, ee2, Fe2)) : [];
                  }
                  function CRe(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    if (!Fe2)
                      return -1;
                    var hn = ee2 == null ? 0 : wh2(ee2);
                    return hn < 0 && (hn = kd2(Fe2 + hn, 0)), IJ(ft, xc2(Dt, 3), hn);
                  }
                  function TRe(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    if (!Fe2)
                      return -1;
                    var hn = Fe2 - 1;
                    return ee2 !== Ut && (hn = wh2(ee2), hn = ee2 < 0 ? kd2(Fe2 + hn, 0) : sb2(hn, Fe2 - 1)), IJ(ft, xc2(Dt, 3), hn, true);
                  }
                  function ARe(ft) {
                    var Dt = ft == null ? 0 : ft.length;
                    return Dt ? lb2(ft, 1) : [];
                  }
                  function Bnr(ft) {
                    var Dt = ft == null ? 0 : ft.length;
                    return Dt ? lb2(ft, Su) : [];
                  }
                  function znr(ft, Dt) {
                    var ee2 = ft == null ? 0 : ft.length;
                    return ee2 ? (Dt = Dt === Ut ? 1 : wh2(Dt), lb2(ft, Dt)) : [];
                  }
                  function jnr(ft) {
                    for (var Dt = -1, ee2 = ft == null ? 0 : ft.length, Fe2 = {}; ++Dt < ee2; ) {
                      var hn = ft[Dt];
                      Fe2[hn[0]] = hn[1];
                    }
                    return Fe2;
                  }
                  function IRe(ft) {
                    return ft && ft.length ? ft[0] : Ut;
                  }
                  function Wnr(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    if (!Fe2)
                      return -1;
                    var hn = ee2 == null ? 0 : wh2(ee2);
                    return hn < 0 && (hn = kd2(Fe2 + hn, 0)), l7(ft, Dt, hn);
                  }
                  function Gnr(ft) {
                    var Dt = ft == null ? 0 : ft.length;
                    return Dt ? Or(ft, 0, -1) : [];
                  }
                  var Hnr = xh2(function(ft) {
                    var Dt = Xv(ft, cb2);
                    return Dt.length && Dt[0] === ft[0] ? fH(Dt) : [];
                  }), Unr = xh2(function(ft) {
                    var Dt = OD(ft), ee2 = Xv(ft, cb2);
                    return Dt === OD(ee2) ? Dt = Ut : ee2.pop(), ee2.length && ee2[0] === ft[0] ? fH(ee2, xc2(Dt, 2)) : [];
                  }), qnr = xh2(function(ft) {
                    var Dt = OD(ft), ee2 = Xv(ft, cb2);
                    return Dt = typeof Dt == "function" ? Dt : Ut, Dt && ee2.pop(), ee2.length && ee2[0] === ft[0] ? fH(ee2, Ut, Dt) : [];
                  });
                  function Znr(ft, Dt) {
                    return ft == null ? "" : Uf2.call(ft, Dt);
                  }
                  function OD(ft) {
                    var Dt = ft == null ? 0 : ft.length;
                    return Dt ? ft[Dt - 1] : Ut;
                  }
                  function $nr(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    if (!Fe2)
                      return -1;
                    var hn = Fe2;
                    return ee2 !== Ut && (hn = wh2(ee2), hn = hn < 0 ? kd2(Fe2 + hn, 0) : sb2(hn, Fe2 - 1)), Dt === Dt ? rYt(ft, Dt, hn) : IJ(ft, AAt, hn, true);
                  }
                  function Ynr(ft, Dt) {
                    return ft && ft.length ? uIt(ft, wh2(Dt)) : Ut;
                  }
                  var Knr = xh2(DRe);
                  function DRe(ft, Dt) {
                    return ft && ft.length && Dt && Dt.length ? Apt(ft, Dt) : ft;
                  }
                  function Xnr(ft, Dt, ee2) {
                    return ft && ft.length && Dt && Dt.length ? Apt(ft, Dt, xc2(ee2, 2)) : ft;
                  }
                  function Qnr(ft, Dt, ee2) {
                    return ft && ft.length && Dt && Dt.length ? Apt(ft, Dt, Ut, ee2) : ft;
                  }
                  var Jnr = P6(function(ft, Dt) {
                    var ee2 = ft == null ? 0 : ft.length, Fe2 = ypt(ft, Dt);
                    return hIt(ft, Xv(Dt, function(hn) {
                      return L6(hn, ee2) ? +hn : hn;
                    }).sort(Q4e)), Fe2;
                  });
                  function trr(ft, Dt) {
                    var ee2 = [];
                    if (!(ft && ft.length))
                      return ee2;
                    var Fe2 = -1, hn = [], $n = ft.length;
                    for (Dt = xc2(Dt, 3); ++Fe2 < $n; ) {
                      var jr = ft[Fe2];
                      Dt(jr, Fe2, ft) && (ee2.push(jr), hn.push(Fe2));
                    }
                    return hIt(ft, hn), ee2;
                  }
                  function gKt(ft) {
                    return ft == null ? ft : jAt.call(ft);
                  }
                  function err(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    return Fe2 ? (ee2 && typeof ee2 != "number" && L2(ft, Dt, ee2) ? (Dt = 0, ee2 = Fe2) : (Dt = Dt == null ? 0 : wh2(Dt), ee2 = ee2 === Ut ? Fe2 : wh2(ee2)), Or(ft, Dt, ee2)) : [];
                  }
                  function nrr(ft, Dt) {
                    return Di2(ft, Dt);
                  }
                  function rrr(ft, Dt, ee2) {
                    return Co(ft, Dt, xc2(ee2, 2));
                  }
                  function irr(ft, Dt) {
                    var ee2 = ft == null ? 0 : ft.length;
                    if (ee2) {
                      var Fe2 = Di2(ft, Dt);
                      if (Fe2 < ee2 && d5(ft[Fe2], Dt))
                        return Fe2;
                    }
                    return -1;
                  }
                  function arr(ft, Dt) {
                    return Di2(ft, Dt, true);
                  }
                  function orr(ft, Dt, ee2) {
                    return Co(ft, Dt, xc2(ee2, 2), true);
                  }
                  function srr(ft, Dt) {
                    var ee2 = ft == null ? 0 : ft.length;
                    if (ee2) {
                      var Fe2 = Di2(ft, Dt, true) - 1;
                      if (d5(ft[Fe2], Dt))
                        return Fe2;
                    }
                    return -1;
                  }
                  function lrr(ft) {
                    return ft && ft.length ? Eo(ft) : [];
                  }
                  function urr(ft, Dt) {
                    return ft && ft.length ? Eo(ft, xc2(Dt, 2)) : [];
                  }
                  function crr(ft) {
                    var Dt = ft == null ? 0 : ft.length;
                    return Dt ? Or(ft, 1, Dt) : [];
                  }
                  function frr(ft, Dt, ee2) {
                    return ft && ft.length ? (Dt = ee2 || Dt === Ut ? 1 : wh2(Dt), Or(ft, 0, Dt < 0 ? 0 : Dt)) : [];
                  }
                  function hrr(ft, Dt, ee2) {
                    var Fe2 = ft == null ? 0 : ft.length;
                    return Fe2 ? (Dt = ee2 || Dt === Ut ? 1 : wh2(Dt), Dt = Fe2 - Dt, Or(ft, Dt < 0 ? 0 : Dt, Fe2)) : [];
                  }
                  function prr(ft, Dt) {
                    return ft && ft.length ? Zu(ft, xc2(Dt, 3), false, true) : [];
                  }
                  function drr(ft, Dt) {
                    return ft && ft.length ? Zu(ft, xc2(Dt, 3)) : [];
                  }
                  var grr = xh2(function(ft) {
                    return Hl(lb2(ft, 1, ym, true));
                  }), vrr = xh2(function(ft) {
                    var Dt = OD(ft);
                    return ym(Dt) && (Dt = Ut), Hl(lb2(ft, 1, ym, true), xc2(Dt, 2));
                  }), yrr = xh2(function(ft) {
                    var Dt = OD(ft);
                    return Dt = typeof Dt == "function" ? Dt : Ut, Hl(lb2(ft, 1, ym, true), Ut, Dt);
                  });
                  function mrr(ft) {
                    return ft && ft.length ? Hl(ft) : [];
                  }
                  function brr(ft, Dt) {
                    return ft && ft.length ? Hl(ft, xc2(Dt, 2)) : [];
                  }
                  function _rr(ft, Dt) {
                    return Dt = typeof Dt == "function" ? Dt : Ut, ft && ft.length ? Hl(ft, Ut, Dt) : [];
                  }
                  function vKt(ft) {
                    if (!(ft && ft.length))
                      return [];
                    var Dt = 0;
                    return ft = vL(ft, function(ee2) {
                      if (ym(ee2))
                        return Dt = kd2(ee2.length, Dt), true;
                    }), upt(Dt, function(ee2) {
                      return Xv(ft, opt(ee2));
                    });
                  }
                  function ERe(ft, Dt) {
                    if (!(ft && ft.length))
                      return [];
                    var ee2 = vKt(ft);
                    return Dt == null ? ee2 : Xv(ee2, function(Fe2) {
                      return P22(Dt, Ut, Fe2);
                    });
                  }
                  var xrr = xh2(function(ft, Dt) {
                    return ym(ft) ? cH(ft, Dt) : [];
                  }), wrr = xh2(function(ft) {
                    return ap(vL(ft, ym));
                  }), Srr = xh2(function(ft) {
                    var Dt = OD(ft);
                    return ym(Dt) && (Dt = Ut), ap(vL(ft, ym), xc2(Dt, 2));
                  }), Mrr = xh2(function(ft) {
                    var Dt = OD(ft);
                    return Dt = typeof Dt == "function" ? Dt : Ut, ap(vL(ft, ym), Ut, Dt);
                  }), Crr = xh2(vKt);
                  function Trr(ft, Dt) {
                    return dS(ft || [], Dt || [], uH);
                  }
                  function Arr(ft, Dt) {
                    return dS(ft || [], Dt || [], Kt);
                  }
                  var Irr = xh2(function(ft) {
                    var Dt = ft.length, ee2 = Dt > 1 ? ft[Dt - 1] : Ut;
                    return ee2 = typeof ee2 == "function" ? (ft.pop(), ee2) : Ut, ERe(ft, ee2);
                  });
                  function kRe(ft) {
                    var Dt = Pn(ft);
                    return Dt.__chain__ = true, Dt;
                  }
                  function Drr(ft, Dt) {
                    return Dt(ft), ft;
                  }
                  function xIt(ft, Dt) {
                    return Dt(ft);
                  }
                  var Err = P6(function(ft) {
                    var Dt = ft.length, ee2 = Dt ? ft[0] : 0, Fe2 = this.__wrapped__, hn = function($n) {
                      return ypt($n, ft);
                    };
                    return Dt > 1 || this.__actions__.length || !(Fe2 instanceof qu) || !L6(ee2) ? this.thru(hn) : (Fe2 = Fe2.slice(ee2, +ee2 + (Dt ? 1 : 0)), Fe2.__actions__.push({ func: xIt, args: [hn], thisArg: Ut }), new GM(Fe2, this.__chain__).thru(function($n) {
                      return Dt && !$n.length && $n.push(Ut), $n;
                    }));
                  });
                  function krr() {
                    return kRe(this);
                  }
                  function Prr() {
                    return new GM(this.value(), this.__chain__);
                  }
                  function Lrr() {
                    this.__values__ === Ut && (this.__values__ = URe(this.value()));
                    var ft = this.__index__ >= this.__values__.length, Dt = ft ? Ut : this.__values__[this.__index__++];
                    return { done: ft, value: Dt };
                  }
                  function Orr() {
                    return this;
                  }
                  function Rrr(ft) {
                    for (var Dt, ee2 = this; ee2 instanceof GJ; ) {
                      var Fe2 = MRe(ee2);
                      Fe2.__index__ = 0, Fe2.__values__ = Ut, Dt ? hn.__wrapped__ = Fe2 : Dt = Fe2;
                      var hn = Fe2;
                      ee2 = ee2.__wrapped__;
                    }
                    return hn.__wrapped__ = ft, Dt;
                  }
                  function Nrr() {
                    var ft = this.__wrapped__;
                    if (ft instanceof qu) {
                      var Dt = ft;
                      return this.__actions__.length && (Dt = new qu(this)), Dt = Dt.reverse(), Dt.__actions__.push({ func: xIt, args: [gKt], thisArg: Ut }), new GM(Dt, this.__chain__);
                    }
                    return this.thru(gKt);
                  }
                  function Frr() {
                    return Vh2(this.__wrapped__, this.__actions__);
                  }
                  var Vrr = pIt(function(ft, Dt, ee2) {
                    ip.call(ft, ee2) ? ++ft[ee2] : p5(ft, ee2, 1);
                  });
                  function Brr(ft, Dt, ee2) {
                    var Fe2 = Zf2(ft) ? CAt : GYt;
                    return ee2 && L2(ft, Dt, ee2) && (Dt = Ut), Fe2(ft, xc2(Dt, 3));
                  }
                  function zrr(ft, Dt) {
                    var ee2 = Zf2(ft) ? vL : mpt;
                    return ee2(ft, xc2(Dt, 3));
                  }
                  var jrr = iRe(CRe), Wrr = iRe(TRe);
                  function Grr(ft, Dt) {
                    return lb2(wIt(ft, Dt), 1);
                  }
                  function Hrr(ft, Dt) {
                    return lb2(wIt(ft, Dt), Su);
                  }
                  function Urr(ft, Dt, ee2) {
                    return ee2 = ee2 === Ut ? 1 : wh2(ee2), lb2(wIt(ft, Dt), ee2);
                  }
                  function PRe(ft, Dt) {
                    var ee2 = Zf2(ft) ? jM : bL;
                    return ee2(ft, xc2(Dt, 3));
                  }
                  function LRe(ft, Dt) {
                    var ee2 = Zf2(ft) ? U$t : JAt;
                    return ee2(ft, xc2(Dt, 3));
                  }
                  var qrr = pIt(function(ft, Dt, ee2) {
                    ip.call(ft, ee2) ? ft[ee2].push(Dt) : p5(ft, ee2, [Dt]);
                  });
                  function Zrr(ft, Dt, ee2, Fe2) {
                    ft = $M(ft) ? ft : XJ(ft), ee2 = ee2 && !Fe2 ? wh2(ee2) : 0;
                    var hn = ft.length;
                    return ee2 < 0 && (ee2 = kd2(hn + ee2, 0)), AIt(ft) ? ee2 <= hn && ft.indexOf(Dt, ee2) > -1 : !!hn && l7(ft, Dt, ee2) > -1;
                  }
                  var $rr = xh2(function(ft, Dt, ee2) {
                    var Fe2 = -1, hn = typeof Dt == "function", $n = $M(ft) ? fa2(ft.length) : [];
                    return bL(ft, function(jr) {
                      $n[++Fe2] = hn ? P22(Dt, jr, ee2) : E6(jr, Dt, ee2);
                    }), $n;
                  }), Yrr = pIt(function(ft, Dt, ee2) {
                    p5(ft, ee2, Dt);
                  });
                  function wIt(ft, Dt) {
                    var ee2 = Zf2(ft) ? Xv : oIt;
                    return ee2(ft, xc2(Dt, 3));
                  }
                  function Krr(ft, Dt, ee2, Fe2) {
                    return ft == null ? [] : (Zf2(Dt) || (Dt = Dt == null ? [] : [Dt]), ee2 = Fe2 ? Ut : ee2, Zf2(ee2) || (ee2 = ee2 == null ? [] : [ee2]), cIt(ft, Dt, ee2));
                  }
                  var Xrr = pIt(function(ft, Dt, ee2) {
                    ft[ee2 ? 0 : 1].push(Dt);
                  }, function() {
                    return [[], []];
                  });
                  function Qrr(ft, Dt, ee2) {
                    var Fe2 = Zf2(ft) ? AJ : DAt, hn = arguments.length < 3;
                    return Fe2(ft, xc2(Dt, 4), ee2, hn, bL);
                  }
                  function Jrr(ft, Dt, ee2) {
                    var Fe2 = Zf2(ft) ? TAt : DAt, hn = arguments.length < 3;
                    return Fe2(ft, xc2(Dt, 4), ee2, hn, JAt);
                  }
                  function tir(ft, Dt) {
                    var ee2 = Zf2(ft) ? vL : mpt;
                    return ee2(ft, CIt(xc2(Dt, 3)));
                  }
                  function eir(ft) {
                    var Dt = Zf2(ft) ? YAt : ct;
                    return Dt(ft);
                  }
                  function nir(ft, Dt, ee2) {
                    (ee2 ? L2(ft, Dt, ee2) : Dt === Ut) ? Dt = 1 : Dt = wh2(Dt);
                    var Fe2 = Zf2(ft) ? VYt : It;
                    return Fe2(ft, Dt);
                  }
                  function rir(ft) {
                    var Dt = Zf2(ft) ? BYt : Zn;
                    return Dt(ft);
                  }
                  function iir(ft) {
                    if (ft == null)
                      return 0;
                    if ($M(ft))
                      return AIt(ft) ? u7(ft) : ft.length;
                    var Dt = gS(ft);
                    return Dt == Ry || Dt == d0 ? ft.size : Cpt(ft).length;
                  }
                  function air(ft, Dt, ee2) {
                    var Fe2 = Zf2(ft) ? apt : ti2;
                    return ee2 && L2(ft, Dt, ee2) && (Dt = Ut), Fe2(ft, xc2(Dt, 3));
                  }
                  var oir = xh2(function(ft, Dt) {
                    if (ft == null)
                      return [];
                    var ee2 = Dt.length;
                    return ee2 > 1 && L2(ft, Dt[0], Dt[1]) ? Dt = [] : ee2 > 2 && L2(Dt[0], Dt[1], Dt[2]) && (Dt = [Dt[0]]), cIt(ft, lb2(Dt, 1), []);
                  }), SIt = hYt || function() {
                    return ob2.Date.now();
                  };
                  function sir(ft, Dt) {
                    if (typeof Dt != "function")
                      throw new WM(Re2);
                    return ft = wh2(ft), function() {
                      if (--ft < 1)
                        return Dt.apply(this, arguments);
                    };
                  }
                  function ORe(ft, Dt, ee2) {
                    return Dt = ee2 ? Ut : Dt, Dt = ft && Dt == null ? ft.length : Dt, k6(ft, Oa2, Ut, Ut, Ut, Ut, Dt);
                  }
                  function RRe(ft, Dt) {
                    var ee2;
                    if (typeof Dt != "function")
                      throw new WM(Re2);
                    return ft = wh2(ft), function() {
                      return --ft > 0 && (ee2 = Dt.apply(this, arguments)), ft <= 1 && (Dt = Ut), ee2;
                    };
                  }
                  var yKt = xh2(function(ft, Dt, ee2) {
                    var Fe2 = _i;
                    if (ee2.length) {
                      var hn = c52(ee2, YJ(yKt));
                      Fe2 |= di2;
                    }
                    return k6(ft, Fe2, Dt, ee2, hn);
                  }), NRe = xh2(function(ft, Dt, ee2) {
                    var Fe2 = _i | Wa2;
                    if (ee2.length) {
                      var hn = c52(ee2, YJ(NRe));
                      Fe2 |= di2;
                    }
                    return k6(Dt, Fe2, ft, ee2, hn);
                  });
                  function FRe(ft, Dt, ee2) {
                    Dt = ee2 ? Ut : Dt;
                    var Fe2 = k6(ft, ts, Ut, Ut, Ut, Ut, Ut, Dt);
                    return Fe2.placeholder = FRe.placeholder, Fe2;
                  }
                  function VRe(ft, Dt, ee2) {
                    Dt = ee2 ? Ut : Dt;
                    var Fe2 = k6(ft, on, Ut, Ut, Ut, Ut, Ut, Dt);
                    return Fe2.placeholder = VRe.placeholder, Fe2;
                  }
                  function BRe(ft, Dt, ee2) {
                    var Fe2, hn, $n, jr, ni2, Vi2, Ro = 0, No = false, ls = false, xl = true;
                    if (typeof ft != "function")
                      throw new WM(Re2);
                    Dt = RD(Dt) || 0, dy(ee2) && (No = !!ee2.leading, ls = "maxWait" in ee2, $n = ls ? kd2(RD(ee2.maxWait) || 0, Dt) : $n, xl = "trailing" in ee2 ? !!ee2.trailing : xl);
                    function Tu(mm) {
                      var g52 = Fe2, N6 = hn;
                      return Fe2 = hn = Ut, Ro = mm, jr = ft.apply(N6, g52), jr;
                    }
                    function Dc2(mm) {
                      return Ro = mm, ni2 = Lpt(Sp, Dt), No ? Tu(mm) : jr;
                    }
                    function Bh2(mm) {
                      var g52 = mm - Vi2, N6 = mm - Ro, i6e = Dt - g52;
                      return ls ? sb2(i6e, $n - N6) : i6e;
                    }
                    function Ec2(mm) {
                      var g52 = mm - Vi2, N6 = mm - Ro;
                      return Vi2 === Ut || g52 >= Dt || g52 < 0 || ls && N6 >= $n;
                    }
                    function Sp() {
                      var mm = SIt();
                      if (Ec2(mm))
                        return Hp(mm);
                      ni2 = Lpt(Sp, Bh2(mm));
                    }
                    function Hp(mm) {
                      return ni2 = Ut, xl && Fe2 ? Tu(mm) : (Fe2 = hn = Ut, jr);
                    }
                    function FT() {
                      ni2 !== Ut && Ept(ni2), Ro = 0, Fe2 = Vi2 = hn = ni2 = Ut;
                    }
                    function O22() {
                      return ni2 === Ut ? jr : Hp(SIt());
                    }
                    function VT() {
                      var mm = SIt(), g52 = Ec2(mm);
                      if (Fe2 = arguments, hn = this, Vi2 = mm, g52) {
                        if (ni2 === Ut)
                          return Dc2(Vi2);
                        if (ls)
                          return Ept(ni2), ni2 = Lpt(Sp, Dt), Tu(Vi2);
                      }
                      return ni2 === Ut && (ni2 = Lpt(Sp, Dt)), jr;
                    }
                    return VT.cancel = FT, VT.flush = O22, VT;
                  }
                  var lir = xh2(function(ft, Dt) {
                    return QAt(ft, 1, Dt);
                  }), uir = xh2(function(ft, Dt, ee2) {
                    return QAt(ft, RD(Dt) || 0, ee2);
                  });
                  function cir(ft) {
                    return k6(ft, Fi2);
                  }
                  function MIt(ft, Dt) {
                    if (typeof ft != "function" || Dt != null && typeof Dt != "function")
                      throw new WM(Re2);
                    var ee2 = function() {
                      var Fe2 = arguments, hn = Dt ? Dt.apply(this, Fe2) : Fe2[0], $n = ee2.cache;
                      if ($n.has(hn))
                        return $n.get(hn);
                      var jr = ft.apply(this, Fe2);
                      return ee2.cache = $n.set(hn, jr) || $n, jr;
                    };
                    return ee2.cache = new (MIt.Cache || h5)(), ee2;
                  }
                  MIt.Cache = h5;
                  function CIt(ft) {
                    if (typeof ft != "function")
                      throw new WM(Re2);
                    return function() {
                      var Dt = arguments;
                      switch (Dt.length) {
                        case 0:
                          return !ft.call(this);
                        case 1:
                          return !ft.call(this, Dt[0]);
                        case 2:
                          return !ft.call(this, Dt[0], Dt[1]);
                        case 3:
                          return !ft.call(this, Dt[0], Dt[1], Dt[2]);
                      }
                      return !ft.apply(this, Dt);
                    };
                  }
                  function fir(ft) {
                    return RRe(2, ft);
                  }
                  var hir = RT(function(ft, Dt) {
                    Dt = Dt.length == 1 && Zf2(Dt[0]) ? Xv(Dt[0], hS(xc2())) : Xv(lb2(Dt, 1), hS(xc2()));
                    var ee2 = Dt.length;
                    return xh2(function(Fe2) {
                      for (var hn = -1, $n = sb2(Fe2.length, ee2); ++hn < $n; )
                        Fe2[hn] = Dt[hn].call(this, Fe2[hn]);
                      return P22(ft, this, Fe2);
                    });
                  }), mKt = xh2(function(ft, Dt) {
                    var ee2 = c52(Dt, YJ(mKt));
                    return k6(ft, di2, Ut, Dt, ee2);
                  }), zRe = xh2(function(ft, Dt) {
                    var ee2 = c52(Dt, YJ(zRe));
                    return k6(ft, Yi2, Ut, Dt, ee2);
                  }), pir = P6(function(ft, Dt) {
                    return k6(ft, Da2, Ut, Ut, Ut, Dt);
                  });
                  function dir3(ft, Dt) {
                    if (typeof ft != "function")
                      throw new WM(Re2);
                    return Dt = Dt === Ut ? Dt : wh2(Dt), xh2(ft, Dt);
                  }
                  function gir(ft, Dt) {
                    if (typeof ft != "function")
                      throw new WM(Re2);
                    return Dt = Dt == null ? 0 : kd2(wh2(Dt), 0), xh2(function(ee2) {
                      var Fe2 = ee2[Dt], hn = d_(ee2, 0, Dt);
                      return Fe2 && yL(hn, Fe2), P22(ft, this, hn);
                    });
                  }
                  function vir(ft, Dt, ee2) {
                    var Fe2 = true, hn = true;
                    if (typeof ft != "function")
                      throw new WM(Re2);
                    return dy(ee2) && (Fe2 = "leading" in ee2 ? !!ee2.leading : Fe2, hn = "trailing" in ee2 ? !!ee2.trailing : hn), BRe(ft, Dt, { leading: Fe2, maxWait: Dt, trailing: hn });
                  }
                  function yir(ft) {
                    return ORe(ft, 1);
                  }
                  function mir(ft, Dt) {
                    return mKt(zx(Dt), ft);
                  }
                  function bir() {
                    if (!arguments.length)
                      return [];
                    var ft = arguments[0];
                    return Zf2(ft) ? ft : [ft];
                  }
                  function _ir(ft) {
                    return UM(ft, Ur);
                  }
                  function xir(ft, Dt) {
                    return Dt = typeof Dt == "function" ? Dt : Ut, UM(ft, Ur, Dt);
                  }
                  function wir(ft) {
                    return UM(ft, Yn | Ur);
                  }
                  function Sir(ft, Dt) {
                    return Dt = typeof Dt == "function" ? Dt : Ut, UM(ft, Yn | Ur, Dt);
                  }
                  function Mir(ft, Dt) {
                    return Dt == null || XAt(ft, Dt, g_(Dt));
                  }
                  function d5(ft, Dt) {
                    return ft === Dt || ft !== ft && Dt !== Dt;
                  }
                  var Cir = yIt(xpt), Tir = yIt(function(ft, Dt) {
                    return ft >= Dt;
                  }), gH = nIt(function() {
                    return arguments;
                  }()) ? nIt : function(ft) {
                    return Fy(ft) && ip.call(ft, "callee") && !h7.call(ft, "callee");
                  }, Zf2 = fa2.isArray, Air = bAt ? hS(bAt) : $Yt;
                  function $M(ft) {
                    return ft != null && TIt(ft.length) && !O6(ft);
                  }
                  function ym(ft) {
                    return Fy(ft) && $M(ft);
                  }
                  function Iir(ft) {
                    return ft === true || ft === false || Fy(ft) && ub2(ft) == bh2;
                  }
                  var w7 = VAt || DKt, Dir = _At ? hS(_At) : YYt;
                  function Eir(ft) {
                    return Fy(ft) && ft.nodeType === 1 && !Opt(ft);
                  }
                  function kir(ft) {
                    if (ft == null)
                      return true;
                    if ($M(ft) && (Zf2(ft) || typeof ft == "string" || typeof ft.splice == "function" || w7(ft) || KJ(ft) || gH(ft)))
                      return !ft.length;
                    var Dt = gS(ft);
                    if (Dt == Ry || Dt == d0)
                      return !ft.size;
                    if (Ppt(ft))
                      return !Cpt(ft).length;
                    for (var ee2 in ft)
                      if (ip.call(ft, ee2))
                        return false;
                    return true;
                  }
                  function Pir(ft, Dt) {
                    return hH(ft, Dt);
                  }
                  function Lir(ft, Dt, ee2) {
                    ee2 = typeof ee2 == "function" ? ee2 : Ut;
                    var Fe2 = ee2 ? ee2(ft, Dt) : Ut;
                    return Fe2 === Ut ? hH(ft, Dt, Ut, ee2) : !!Fe2;
                  }
                  function bKt(ft) {
                    if (!Fy(ft))
                      return false;
                    var Dt = ub2(ft);
                    return Dt == B0 || Dt == $v || typeof ft.message == "string" && typeof ft.name == "string" && !Opt(ft);
                  }
                  function Oir(ft) {
                    return typeof ft == "number" && LD(ft);
                  }
                  function O6(ft) {
                    if (!dy(ft))
                      return false;
                    var Dt = ub2(ft);
                    return Dt == uS || Dt == FM || Dt == Gd2 || Dt == VM;
                  }
                  function jRe(ft) {
                    return typeof ft == "number" && ft == wh2(ft);
                  }
                  function TIt(ft) {
                    return typeof ft == "number" && ft > -1 && ft % 1 == 0 && ft <= Ga2;
                  }
                  function dy(ft) {
                    var Dt = typeof ft;
                    return ft != null && (Dt == "object" || Dt == "function");
                  }
                  function Fy(ft) {
                    return ft != null && typeof ft == "object";
                  }
                  var WRe = xAt ? hS(xAt) : KYt;
                  function Rir(ft, Dt) {
                    return ft === Dt || wpt(ft, Dt, uKt(Dt));
                  }
                  function Nir(ft, Dt, ee2) {
                    return ee2 = typeof ee2 == "function" ? ee2 : Ut, wpt(ft, Dt, uKt(Dt), ee2);
                  }
                  function Fir(ft) {
                    return GRe(ft) && ft != +ft;
                  }
                  function Vir(ft) {
                    if (xnr(ft))
                      throw new uf2(se2);
                    return iIt(ft);
                  }
                  function Bir(ft) {
                    return ft === null;
                  }
                  function zir(ft) {
                    return ft == null;
                  }
                  function GRe(ft) {
                    return typeof ft == "number" || Fy(ft) && ub2(ft) == Rx;
                  }
                  function Opt(ft) {
                    if (!Fy(ft) || ub2(ft) != u_)
                      return false;
                    var Dt = VJ(ft);
                    if (Dt === null)
                      return true;
                    var ee2 = ip.call(Dt, "constructor") && Dt.constructor;
                    return typeof ee2 == "function" && ee2 instanceof ee2 && RJ.call(ee2) == j0;
                  }
                  var _Kt = wAt ? hS(wAt) : Spt;
                  function jir(ft) {
                    return jRe(ft) && ft >= -Ga2 && ft <= Ga2;
                  }
                  var HRe = SAt ? hS(SAt) : Mpt;
                  function AIt(ft) {
                    return typeof ft == "string" || !Zf2(ft) && Fy(ft) && ub2(ft) == fy;
                  }
                  function NT(ft) {
                    return typeof ft == "symbol" || Fy(ft) && ub2(ft) == Vg2;
                  }
                  var KJ = MAt ? hS(MAt) : XYt;
                  function Wir(ft) {
                    return ft === Ut;
                  }
                  function Gir(ft) {
                    return Fy(ft) && gS(ft) == lo;
                  }
                  function Hir(ft) {
                    return Fy(ft) && ub2(ft) == na2;
                  }
                  var Uir = yIt(Tpt), qir = yIt(function(ft, Dt) {
                    return ft <= Dt;
                  });
                  function URe(ft) {
                    if (!ft)
                      return [];
                    if ($M(ft))
                      return AIt(ft) ? OT(ft) : ZM(ft);
                    if (d7 && ft[d7])
                      return tYt(ft[d7]());
                    var Dt = gS(ft), ee2 = Dt == Ry ? hpt : Dt == d0 ? LJ : XJ;
                    return ee2(ft);
                  }
                  function R62(ft) {
                    if (!ft)
                      return ft === 0 ? ft : 0;
                    if (ft = RD(ft), ft === Su || ft === -Su) {
                      var Dt = ft < 0 ? -1 : 1;
                      return Dt * ha2;
                    }
                    return ft === ft ? ft : 0;
                  }
                  function wh2(ft) {
                    var Dt = R62(ft), ee2 = Dt % 1;
                    return Dt === Dt ? ee2 ? Dt - ee2 : Dt : 0;
                  }
                  function qRe(ft) {
                    return ft ? I6(wh2(ft), 0, hs) : 0;
                  }
                  function RD(ft) {
                    if (typeof ft == "number")
                      return ft;
                    if (NT(ft))
                      return pa2;
                    if (dy(ft)) {
                      var Dt = typeof ft.valueOf == "function" ? ft.valueOf() : ft;
                      ft = dy(Dt) ? Dt + "" : Dt;
                    }
                    if (typeof ft != "string")
                      return ft === 0 ? ft : +ft;
                    ft = EAt(ft);
                    var ee2 = Hi2.test(ft);
                    return ee2 || ma2.test(ft) ? W$t(ft.slice(2), ee2 ? 2 : 8) : gr.test(ft) ? pa2 : +ft;
                  }
                  function ZRe(ft) {
                    return _L(ft, YM(ft));
                  }
                  function Zir(ft) {
                    return ft ? I6(wh2(ft), -Ga2, Ga2) : ft === 0 ? ft : 0;
                  }
                  function ag2(ft) {
                    return ft == null ? "" : Ds(ft);
                  }
                  var $ir = ZJ(function(ft, Dt) {
                    if (Ppt(Dt) || $M(Dt)) {
                      _L(Dt, g_(Dt), ft);
                      return;
                    }
                    for (var ee2 in Dt)
                      ip.call(Dt, ee2) && uH(ft, ee2, Dt[ee2]);
                  }), $Re = ZJ(function(ft, Dt) {
                    _L(Dt, YM(Dt), ft);
                  }), IIt = ZJ(function(ft, Dt, ee2, Fe2) {
                    _L(Dt, YM(Dt), ft, Fe2);
                  }), Yir = ZJ(function(ft, Dt, ee2, Fe2) {
                    _L(Dt, g_(Dt), ft, Fe2);
                  }), Kir = P6(ypt);
                  function Xir(ft, Dt) {
                    var ee2 = b7(ft);
                    return Dt == null ? ee2 : KAt(ee2, Dt);
                  }
                  var Qir = xh2(function(ft, Dt) {
                    ft = jg2(ft);
                    var ee2 = -1, Fe2 = Dt.length, hn = Fe2 > 2 ? Dt[2] : Ut;
                    for (hn && L2(Dt[0], Dt[1], hn) && (Fe2 = 1); ++ee2 < Fe2; )
                      for (var $n = Dt[ee2], jr = YM($n), ni2 = -1, Vi2 = jr.length; ++ni2 < Vi2; ) {
                        var Ro = jr[ni2], No = ft[Ro];
                        (No === Ut || d5(No, c7[Ro]) && !ip.call(ft, Ro)) && (ft[Ro] = $n[Ro]);
                      }
                    return ft;
                  }), Jir = xh2(function(ft) {
                    return ft.push(Ut, fRe), P22(YRe, Ut, ft);
                  });
                  function tar(ft, Dt) {
                    return iH(ft, xc2(Dt, 3), qM);
                  }
                  function ear(ft, Dt) {
                    return iH(ft, xc2(Dt, 3), _pt);
                  }
                  function nar(ft, Dt) {
                    return ft == null ? ft : bpt(ft, xc2(Dt, 3), YM);
                  }
                  function rar(ft, Dt) {
                    return ft == null ? ft : eIt(ft, xc2(Dt, 3), YM);
                  }
                  function iar(ft, Dt) {
                    return ft && qM(ft, xc2(Dt, 3));
                  }
                  function aar(ft, Dt) {
                    return ft && _pt(ft, xc2(Dt, 3));
                  }
                  function oar(ft) {
                    return ft == null ? [] : UJ(ft, g_(ft));
                  }
                  function sar(ft) {
                    return ft == null ? [] : UJ(ft, YM(ft));
                  }
                  function xKt(ft, Dt, ee2) {
                    var Fe2 = ft == null ? Ut : D6(ft, Dt);
                    return Fe2 === Ut ? ee2 : Fe2;
                  }
                  function lar(ft, Dt) {
                    return ft != null && dRe(ft, Dt, HYt);
                  }
                  function wKt(ft, Dt) {
                    return ft != null && dRe(ft, Dt, UYt);
                  }
                  var uar = oRe(function(ft, Dt, ee2) {
                    Dt != null && typeof Dt.toString != "function" && (Dt = ov.call(Dt)), ft[Dt] = ee2;
                  }, MKt(KM)), car = oRe(function(ft, Dt, ee2) {
                    Dt != null && typeof Dt.toString != "function" && (Dt = ov.call(Dt)), ip.call(ft, Dt) ? ft[Dt].push(ee2) : ft[Dt] = [ee2];
                  }, xc2), far = xh2(E6);
                  function g_(ft) {
                    return $M(ft) ? $At(ft) : Cpt(ft);
                  }
                  function YM(ft) {
                    return $M(ft) ? $At(ft, true) : QYt(ft);
                  }
                  function har(ft, Dt) {
                    var ee2 = {};
                    return Dt = xc2(Dt, 3), qM(ft, function(Fe2, hn, $n) {
                      p5(ee2, Dt(Fe2, hn, $n), Fe2);
                    }), ee2;
                  }
                  function par(ft, Dt) {
                    var ee2 = {};
                    return Dt = xc2(Dt, 3), qM(ft, function(Fe2, hn, $n) {
                      p5(ee2, hn, Dt(Fe2, hn, $n));
                    }), ee2;
                  }
                  var dar = ZJ(function(ft, Dt, ee2) {
                    qJ(ft, Dt, ee2);
                  }), YRe = ZJ(function(ft, Dt, ee2, Fe2) {
                    qJ(ft, Dt, ee2, Fe2);
                  }), gar = P6(function(ft, Dt) {
                    var ee2 = {};
                    if (ft == null)
                      return ee2;
                    var Fe2 = false;
                    Dt = Xv(Dt, function($n) {
                      return $n = ig2($n, ft), Fe2 || (Fe2 = $n.length > 1), $n;
                    }), _L(ft, sKt(ft), ee2), Fe2 && (ee2 = UM(ee2, Yn | Rr | Ur, unr));
                    for (var hn = Dt.length; hn--; )
                      ic2(ee2, Dt[hn]);
                    return ee2;
                  });
                  function yar(ft, Dt) {
                    return KRe(ft, CIt(xc2(Dt)));
                  }
                  var mar = P6(function(ft, Dt) {
                    return ft == null ? {} : tKt(ft, Dt);
                  });
                  function KRe(ft, Dt) {
                    if (ft == null)
                      return {};
                    var ee2 = Xv(sKt(ft), function(Fe2) {
                      return [Fe2];
                    });
                    return Dt = xc2(Dt), fIt(ft, ee2, function(Fe2, hn) {
                      return Dt(Fe2, hn[0]);
                    });
                  }
                  function bar(ft, Dt, ee2) {
                    Dt = ig2(Dt, ft);
                    var Fe2 = -1, hn = Dt.length;
                    for (hn || (hn = 1, ft = Ut); ++Fe2 < hn; ) {
                      var $n = ft == null ? Ut : ft[xL(Dt[Fe2])];
                      $n === Ut && (Fe2 = hn, $n = ee2), ft = O6($n) ? $n.call(ft) : $n;
                    }
                    return ft;
                  }
                  function _ar(ft, Dt, ee2) {
                    return ft == null ? ft : Kt(ft, Dt, ee2);
                  }
                  function xar(ft, Dt, ee2, Fe2) {
                    return Fe2 = typeof Fe2 == "function" ? Fe2 : Ut, ft == null ? ft : Kt(ft, Dt, ee2, Fe2);
                  }
                  var XRe = uRe(g_), QRe = uRe(YM);
                  function war(ft, Dt, ee2) {
                    var Fe2 = Zf2(ft), hn = Fe2 || w7(ft) || KJ(ft);
                    if (Dt = xc2(Dt, 4), ee2 == null) {
                      var $n = ft && ft.constructor;
                      hn ? ee2 = Fe2 ? new $n() : [] : dy(ft) ? ee2 = O6($n) ? b7(VJ(ft)) : {} : ee2 = {};
                    }
                    return (hn ? jM : qM)(ft, function(jr, ni2, Vi2) {
                      return Dt(ee2, jr, ni2, Vi2);
                    }), ee2;
                  }
                  function Sar(ft, Dt) {
                    return ft == null ? true : ic2(ft, Dt);
                  }
                  function Mar(ft, Dt, ee2) {
                    return ft == null ? ft : qf2(ft, Dt, zx(ee2));
                  }
                  function Car(ft, Dt, ee2, Fe2) {
                    return Fe2 = typeof Fe2 == "function" ? Fe2 : Ut, ft == null ? ft : qf2(ft, Dt, zx(ee2), Fe2);
                  }
                  function XJ(ft) {
                    return ft == null ? [] : EJ(ft, g_(ft));
                  }
                  function Tar(ft) {
                    return ft == null ? [] : EJ(ft, YM(ft));
                  }
                  function Aar(ft, Dt, ee2) {
                    return ee2 === Ut && (ee2 = Dt, Dt = Ut), ee2 !== Ut && (ee2 = RD(ee2), ee2 = ee2 === ee2 ? ee2 : 0), Dt !== Ut && (Dt = RD(Dt), Dt = Dt === Dt ? Dt : 0), I6(RD(ft), Dt, ee2);
                  }
                  function Iar(ft, Dt, ee2) {
                    return Dt = R62(Dt), ee2 === Ut ? (ee2 = Dt, Dt = 0) : ee2 = R62(ee2), ft = RD(ft), qYt(ft, Dt, ee2);
                  }
                  function Dar(ft, Dt, ee2) {
                    if (ee2 && typeof ee2 != "boolean" && L2(ft, Dt, ee2) && (Dt = ee2 = Ut), ee2 === Ut && (typeof Dt == "boolean" ? (ee2 = Dt, Dt = Ut) : typeof ft == "boolean" && (ee2 = ft, ft = Ut)), ft === Ut && Dt === Ut ? (ft = 0, Dt = 1) : (ft = R62(ft), Dt === Ut ? (Dt = ft, ft = 0) : Dt = R62(Dt)), ft > Dt) {
                      var Fe2 = ft;
                      ft = Dt, Dt = Fe2;
                    }
                    if (ee2 || ft % 1 || Dt % 1) {
                      var hn = zAt();
                      return sb2(ft + hn * (Dt - ft + j$t("1e-" + ((hn + "").length - 1))), Dt);
                    }
                    return Ipt(ft, Dt);
                  }
                  var Ear = $J(function(ft, Dt, ee2) {
                    return Dt = Dt.toLowerCase(), ft + (ee2 ? JRe(Dt) : Dt);
                  });
                  function JRe(ft) {
                    return SKt(ag2(ft).toLowerCase());
                  }
                  function t6e(ft) {
                    return ft = ag2(ft), ft && ft.replace(Ho, PAt).replace(L$t, "");
                  }
                  function kar(ft, Dt, ee2) {
                    ft = ag2(ft), Dt = Ds(Dt);
                    var Fe2 = ft.length;
                    ee2 = ee2 === Ut ? Fe2 : I6(wh2(ee2), 0, Fe2);
                    var hn = ee2;
                    return ee2 -= Dt.length, ee2 >= 0 && ft.slice(ee2, hn) == Dt;
                  }
                  function Par(ft) {
                    return ft = ag2(ft), ft && hy.test(ft) ? ft.replace(Yv, X$t) : ft;
                  }
                  function Lar(ft) {
                    return ft = ag2(ft), ft && Kht.test(ft) ? ft.replace(o5, "\\$&") : ft;
                  }
                  var Oar = $J(function(ft, Dt, ee2) {
                    return ft + (ee2 ? "-" : "") + Dt.toLowerCase();
                  }), Rar = $J(function(ft, Dt, ee2) {
                    return ft + (ee2 ? " " : "") + Dt.toLowerCase();
                  }), Nar = rRe("toLowerCase");
                  function Far(ft, Dt, ee2) {
                    ft = ag2(ft), Dt = wh2(Dt);
                    var Fe2 = Dt ? u7(ft) : 0;
                    if (!Dt || Fe2 >= Dt)
                      return ft;
                    var hn = (Dt - Fe2) / 2;
                    return vIt(zJ(hn), ee2) + ft + vIt(BJ(hn), ee2);
                  }
                  function Var(ft, Dt, ee2) {
                    ft = ag2(ft), Dt = wh2(Dt);
                    var Fe2 = Dt ? u7(ft) : 0;
                    return Dt && Fe2 < Dt ? ft + vIt(Dt - Fe2, ee2) : ft;
                  }
                  function Bar(ft, Dt, ee2) {
                    ft = ag2(ft), Dt = wh2(Dt);
                    var Fe2 = Dt ? u7(ft) : 0;
                    return Dt && Fe2 < Dt ? vIt(Dt - Fe2, ee2) + ft : ft;
                  }
                  function zar(ft, Dt, ee2) {
                    return ee2 || Dt == null ? Dt = 0 : Dt && (Dt = +Dt), Pd2(ag2(ft).replace(hL, ""), Dt || 0);
                  }
                  function jar(ft, Dt, ee2) {
                    return (ee2 ? L2(ft, Dt, ee2) : Dt === Ut) ? Dt = 1 : Dt = wh2(Dt), Dpt(ag2(ft), Dt);
                  }
                  function War() {
                    var ft = arguments, Dt = ag2(ft[0]);
                    return ft.length < 3 ? Dt : Dt.replace(ft[1], ft[2]);
                  }
                  var Gar = $J(function(ft, Dt, ee2) {
                    return ft + (ee2 ? "_" : "") + Dt.toLowerCase();
                  });
                  function Har(ft, Dt, ee2) {
                    return ee2 && typeof ee2 != "number" && L2(ft, Dt, ee2) && (Dt = ee2 = Ut), ee2 = ee2 === Ut ? hs : ee2 >>> 0, ee2 ? (ft = ag2(ft), ft && (typeof Dt == "string" || Dt != null && !_Kt(Dt)) && (Dt = Ds(Dt), !Dt && u5(ft)) ? d_(OT(ft), 0, ee2) : ft.split(Dt, ee2)) : [];
                  }
                  var Uar = $J(function(ft, Dt, ee2) {
                    return ft + (ee2 ? " " : "") + SKt(Dt);
                  });
                  function qar(ft, Dt, ee2) {
                    return ft = ag2(ft), ee2 = ee2 == null ? 0 : I6(wh2(ee2), 0, ft.length), Dt = Ds(Dt), ft.slice(ee2, ee2 + Dt.length) == Dt;
                  }
                  function Zar(ft, Dt, ee2) {
                    var Fe2 = Pn.templateSettings;
                    ee2 && L2(ft, Dt, ee2) && (Dt = Ut), ft = ag2(ft), Dt = IIt({}, Dt, Fe2, cRe);
                    var hn = IIt({}, Dt.imports, Fe2.imports, cRe), $n = g_(hn), jr = EJ(hn, $n), ni2, Vi2, Ro = 0, No = Dt.interpolate || iu, ls = "__p += '", xl = kD((Dt.escape || iu).source + "|" + No.source + "|" + (No === i1 ? On : iu).source + "|" + (Dt.evaluate || iu).source + "|$", "g"), Tu = "//# sourceURL=" + (ip.call(Dt, "sourceURL") ? (Dt.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++V$t + "]") + `
`;
                    ft.replace(xl, function(Ec2, Sp, Hp, FT, O22, VT) {
                      return Hp || (Hp = FT), ls += ft.slice(Ro, VT).replace(th2, Q$t), Sp && (ni2 = true, ls += `' +
__e(` + Sp + `) +
'`), O22 && (Vi2 = true, ls += `';
` + O22 + `;
__p += '`), Hp && (ls += `' +
((__t = (` + Hp + `)) == null ? '' : __t) +
'`), Ro = VT + Ec2.length, Ec2;
                    }), ls += `';
`;
                    var Dc2 = ip.call(Dt, "variable") && Dt.variable;
                    if (!Dc2)
                      ls = `with (obj) {
` + ls + `
}
`;
                    else if (br.test(Dc2))
                      throw new uf2(He2);
                    ls = (Vi2 ? ls.replace(c_, "") : ls).replace(Nx, "$1").replace(Ny, "$1;"), ls = "function(" + (Dc2 || "obj") + `) {
` + (Dc2 ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (ni2 ? ", __e = _.escape" : "") + (Vi2 ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + ls + `return __p
}`;
                    var Bh2 = n6e(function() {
                      return cf2($n, Tu + "return " + ls).apply(Ut, jr);
                    });
                    if (Bh2.source = ls, bKt(Bh2))
                      throw Bh2;
                    return Bh2;
                  }
                  function $ar(ft) {
                    return ag2(ft).toLowerCase();
                  }
                  function Yar(ft) {
                    return ag2(ft).toUpperCase();
                  }
                  function Kar(ft, Dt, ee2) {
                    if (ft = ag2(ft), ft && (ee2 || Dt === Ut))
                      return EAt(ft);
                    if (!ft || !(Dt = Ds(Dt)))
                      return ft;
                    var Fe2 = OT(ft), hn = OT(Dt), $n = cpt(Fe2, hn), jr = fpt(Fe2, hn) + 1;
                    return d_(Fe2, $n, jr).join("");
                  }
                  function Xar(ft, Dt, ee2) {
                    if (ft = ag2(ft), ft && (ee2 || Dt === Ut))
                      return ft.slice(0, LAt(ft) + 1);
                    if (!ft || !(Dt = Ds(Dt)))
                      return ft;
                    var Fe2 = OT(ft), hn = fpt(Fe2, OT(Dt)) + 1;
                    return d_(Fe2, 0, hn).join("");
                  }
                  function Qar(ft, Dt, ee2) {
                    if (ft = ag2(ft), ft && (ee2 || Dt === Ut))
                      return ft.replace(hL, "");
                    if (!ft || !(Dt = Ds(Dt)))
                      return ft;
                    var Fe2 = OT(ft), hn = cpt(Fe2, OT(Dt));
                    return d_(Fe2, hn).join("");
                  }
                  function Jar(ft, Dt) {
                    var ee2 = Qi2, Fe2 = ro;
                    if (dy(Dt)) {
                      var hn = "separator" in Dt ? Dt.separator : hn;
                      ee2 = "length" in Dt ? wh2(Dt.length) : ee2, Fe2 = "omission" in Dt ? Ds(Dt.omission) : Fe2;
                    }
                    ft = ag2(ft);
                    var $n = ft.length;
                    if (u5(ft)) {
                      var jr = OT(ft);
                      $n = jr.length;
                    }
                    if (ee2 >= $n)
                      return ft;
                    var ni2 = ee2 - u7(Fe2);
                    if (ni2 < 1)
                      return Fe2;
                    var Vi2 = jr ? d_(jr, 0, ni2).join("") : ft.slice(0, ni2);
                    if (hn === Ut)
                      return Vi2 + Fe2;
                    if (jr && (ni2 += Vi2.length - ni2), _Kt(hn)) {
                      if (ft.slice(ni2).search(hn)) {
                        var Ro, No = Vi2;
                        for (hn.global || (hn = kD(hn.source, ag2(ur.exec(hn)) + "g")), hn.lastIndex = 0; Ro = hn.exec(No); )
                          var ls = Ro.index;
                        Vi2 = Vi2.slice(0, ls === Ut ? ni2 : ls);
                      }
                    } else if (ft.indexOf(Ds(hn), ni2) != ni2) {
                      var xl = Vi2.lastIndexOf(hn);
                      xl > -1 && (Vi2 = Vi2.slice(0, xl));
                    }
                    return Vi2 + Fe2;
                  }
                  function tor(ft) {
                    return ft = ag2(ft), ft && np.test(ft) ? ft.replace(Hd2, iYt) : ft;
                  }
                  var eor = $J(function(ft, Dt, ee2) {
                    return ft + (ee2 ? " " : "") + Dt.toUpperCase();
                  }), SKt = rRe("toUpperCase");
                  function e6e(ft, Dt, ee2) {
                    return ft = ag2(ft), Dt = ee2 ? Ut : Dt, Dt === Ut ? kJ(ft) ? sYt(ft) : $$t(ft) : ft.match(Dt) || [];
                  }
                  var n6e = xh2(function(ft, Dt) {
                    try {
                      return P22(ft, Ut, Dt);
                    } catch (ee2) {
                      return bKt(ee2) ? ee2 : new uf2(ee2);
                    }
                  }), nor = P6(function(ft, Dt) {
                    return jM(Dt, function(ee2) {
                      ee2 = xL(ee2), p5(ft, ee2, yKt(ft[ee2], ft));
                    }), ft;
                  });
                  function ror(ft) {
                    var Dt = ft == null ? 0 : ft.length, ee2 = xc2();
                    return ft = Dt ? Xv(ft, function(Fe2) {
                      if (typeof Fe2[1] != "function")
                        throw new WM(Re2);
                      return [ee2(Fe2[0]), Fe2[1]];
                    }) : [], xh2(function(Fe2) {
                      for (var hn = -1; ++hn < Dt; ) {
                        var $n = ft[hn];
                        if (P22($n[0], this, Fe2))
                          return P22($n[1], this, Fe2);
                      }
                    });
                  }
                  function ior(ft) {
                    return WYt(UM(ft, Yn));
                  }
                  function MKt(ft) {
                    return function() {
                      return ft;
                    };
                  }
                  function aor(ft, Dt) {
                    return ft == null || ft !== ft ? Dt : ft;
                  }
                  var oor = aRe(), sor = aRe(true);
                  function KM(ft) {
                    return ft;
                  }
                  function CKt(ft) {
                    return aIt(typeof ft == "function" ? ft : UM(ft, Yn));
                  }
                  function lor(ft) {
                    return sIt(UM(ft, Yn));
                  }
                  function uor(ft, Dt) {
                    return lIt(ft, UM(Dt, Yn));
                  }
                  var cor = xh2(function(ft, Dt) {
                    return function(ee2) {
                      return E6(ee2, ft, Dt);
                    };
                  }), hor = xh2(function(ft, Dt) {
                    return function(ee2) {
                      return E6(ft, ee2, Dt);
                    };
                  });
                  function TKt(ft, Dt, ee2) {
                    var Fe2 = g_(Dt), hn = UJ(Dt, Fe2);
                    ee2 == null && !(dy(Dt) && (hn.length || !Fe2.length)) && (ee2 = Dt, Dt = ft, ft = this, hn = UJ(Dt, g_(Dt)));
                    var $n = !(dy(ee2) && "chain" in ee2) || !!ee2.chain, jr = O6(ft);
                    return jM(hn, function(ni2) {
                      var Vi2 = Dt[ni2];
                      ft[ni2] = Vi2, jr && (ft.prototype[ni2] = function() {
                        var Ro = this.__chain__;
                        if ($n || Ro) {
                          var No = ft(this.__wrapped__), ls = No.__actions__ = ZM(this.__actions__);
                          return ls.push({ func: Vi2, args: arguments, thisArg: ft }), No.__chain__ = Ro, No;
                        }
                        return Vi2.apply(ft, yL([this.value()], arguments));
                      });
                    }), ft;
                  }
                  function por() {
                    return ob2._ === this && (ob2._ = RAt), this;
                  }
                  function AKt() {
                  }
                  function dor(ft) {
                    return ft = wh2(ft), xh2(function(Dt) {
                      return uIt(Dt, ft);
                    });
                  }
                  var gor = iKt(Xv), vor = iKt(CAt), yor = iKt(apt);
                  function r6e(ft) {
                    return fKt(ft) ? opt(xL(ft)) : eKt(ft);
                  }
                  function mor(ft) {
                    return function(Dt) {
                      return ft == null ? Ut : D6(ft, Dt);
                    };
                  }
                  var bor = sRe(), _or = sRe(true);
                  function IKt() {
                    return [];
                  }
                  function DKt() {
                    return false;
                  }
                  function xor() {
                    return {};
                  }
                  function wor() {
                    return "";
                  }
                  function Sor() {
                    return true;
                  }
                  function Mor(ft, Dt) {
                    if (ft = wh2(ft), ft < 1 || ft > Ga2)
                      return [];
                    var ee2 = hs, Fe2 = sb2(ft, hs);
                    Dt = xc2(Dt), ft -= hs;
                    for (var hn = upt(Fe2, Dt); ++ee2 < ft; )
                      Dt(ee2);
                    return hn;
                  }
                  function Cor(ft) {
                    return Zf2(ft) ? Xv(ft, xL) : NT(ft) ? [ft] : ZM(SRe(ag2(ft)));
                  }
                  function Tor(ft) {
                    var Dt = ++OAt;
                    return ag2(ft) + Dt;
                  }
                  var Aor = gIt(function(ft, Dt) {
                    return ft + Dt;
                  }, 0), Ior = aKt("ceil"), Dor = gIt(function(ft, Dt) {
                    return ft / Dt;
                  }, 1), Eor = aKt("floor");
                  function kor(ft) {
                    return ft && ft.length ? x7(ft, KM, xpt) : Ut;
                  }
                  function Por(ft, Dt) {
                    return ft && ft.length ? x7(ft, xc2(Dt, 2), xpt) : Ut;
                  }
                  function Lor(ft) {
                    return IAt(ft, KM);
                  }
                  function Oor(ft, Dt) {
                    return IAt(ft, xc2(Dt, 2));
                  }
                  function Ror(ft) {
                    return ft && ft.length ? x7(ft, KM, Tpt) : Ut;
                  }
                  function Nor(ft, Dt) {
                    return ft && ft.length ? x7(ft, xc2(Dt, 2), Tpt) : Ut;
                  }
                  var For = gIt(function(ft, Dt) {
                    return ft * Dt;
                  }, 1), Vor = aKt("round"), Bor = gIt(function(ft, Dt) {
                    return ft - Dt;
                  }, 0);
                  function zor(ft) {
                    return ft && ft.length ? lpt(ft, KM) : 0;
                  }
                  function jor(ft, Dt) {
                    return ft && ft.length ? lpt(ft, xc2(Dt, 2)) : 0;
                  }
                  return Pn.after = sir, Pn.ary = ORe, Pn.assign = $ir, Pn.assignIn = $Re, Pn.assignInWith = IIt, Pn.assignWith = Yir, Pn.at = Kir, Pn.before = RRe, Pn.bind = yKt, Pn.bindAll = nor, Pn.bindKey = NRe, Pn.castArray = bir, Pn.chain = kRe, Pn.chunk = Inr, Pn.compact = Dnr, Pn.concat = Enr, Pn.cond = ror, Pn.conforms = ior, Pn.constant = MKt, Pn.countBy = Vrr, Pn.create = Xir, Pn.curry = FRe, Pn.curryRight = VRe, Pn.debounce = BRe, Pn.defaults = Qir, Pn.defaultsDeep = Jir, Pn.defer = lir, Pn.delay = uir, Pn.difference = knr, Pn.differenceBy = Pnr, Pn.differenceWith = Lnr, Pn.drop = Onr, Pn.dropRight = Rnr, Pn.dropRightWhile = Nnr, Pn.dropWhile = Fnr, Pn.fill = Vnr, Pn.filter = zrr, Pn.flatMap = Grr, Pn.flatMapDeep = Hrr, Pn.flatMapDepth = Urr, Pn.flatten = ARe, Pn.flattenDeep = Bnr, Pn.flattenDepth = znr, Pn.flip = cir, Pn.flow = oor, Pn.flowRight = sor, Pn.fromPairs = jnr, Pn.functions = oar, Pn.functionsIn = sar, Pn.groupBy = qrr, Pn.initial = Gnr, Pn.intersection = Hnr, Pn.intersectionBy = Unr, Pn.intersectionWith = qnr, Pn.invert = uar, Pn.invertBy = car, Pn.invokeMap = $rr, Pn.iteratee = CKt, Pn.keyBy = Yrr, Pn.keys = g_, Pn.keysIn = YM, Pn.map = wIt, Pn.mapKeys = har, Pn.mapValues = par, Pn.matches = lor, Pn.matchesProperty = uor, Pn.memoize = MIt, Pn.merge = dar, Pn.mergeWith = YRe, Pn.method = cor, Pn.methodOf = hor, Pn.mixin = TKt, Pn.negate = CIt, Pn.nthArg = dor, Pn.omit = gar, Pn.omitBy = yar, Pn.once = fir, Pn.orderBy = Krr, Pn.over = gor, Pn.overArgs = hir, Pn.overEvery = vor, Pn.overSome = yor, Pn.partial = mKt, Pn.partialRight = zRe, Pn.partition = Xrr, Pn.pick = mar, Pn.pickBy = KRe, Pn.property = r6e, Pn.propertyOf = mor, Pn.pull = Knr, Pn.pullAll = DRe, Pn.pullAllBy = Xnr, Pn.pullAllWith = Qnr, Pn.pullAt = Jnr, Pn.range = bor, Pn.rangeRight = _or, Pn.rearg = pir, Pn.reject = tir, Pn.remove = trr, Pn.rest = dir3, Pn.reverse = gKt, Pn.sampleSize = nir, Pn.set = _ar, Pn.setWith = xar, Pn.shuffle = rir, Pn.slice = err, Pn.sortBy = oir, Pn.sortedUniq = lrr, Pn.sortedUniqBy = urr, Pn.split = Har, Pn.spread = gir, Pn.tail = crr, Pn.take = frr, Pn.takeRight = hrr, Pn.takeRightWhile = prr, Pn.takeWhile = drr, Pn.tap = Drr, Pn.throttle = vir, Pn.thru = xIt, Pn.toArray = URe, Pn.toPairs = XRe, Pn.toPairsIn = QRe, Pn.toPath = Cor, Pn.toPlainObject = ZRe, Pn.transform = war, Pn.unary = yir, Pn.union = grr, Pn.unionBy = vrr, Pn.unionWith = yrr, Pn.uniq = mrr, Pn.uniqBy = brr, Pn.uniqWith = _rr, Pn.unset = Sar, Pn.unzip = vKt, Pn.unzipWith = ERe, Pn.update = Mar, Pn.updateWith = Car, Pn.values = XJ, Pn.valuesIn = Tar, Pn.without = xrr, Pn.words = e6e, Pn.wrap = mir, Pn.xor = wrr, Pn.xorBy = Srr, Pn.xorWith = Mrr, Pn.zip = Crr, Pn.zipObject = Trr, Pn.zipObjectDeep = Arr, Pn.zipWith = Irr, Pn.entries = XRe, Pn.entriesIn = QRe, Pn.extend = $Re, Pn.extendWith = IIt, TKt(Pn, Pn), Pn.add = Aor, Pn.attempt = n6e, Pn.camelCase = Ear, Pn.capitalize = JRe, Pn.ceil = Ior, Pn.clamp = Aar, Pn.clone = _ir, Pn.cloneDeep = wir, Pn.cloneDeepWith = Sir, Pn.cloneWith = xir, Pn.conformsTo = Mir, Pn.deburr = t6e, Pn.defaultTo = aor, Pn.divide = Dor, Pn.endsWith = kar, Pn.eq = d5, Pn.escape = Par, Pn.escapeRegExp = Lar, Pn.every = Brr, Pn.find = jrr, Pn.findIndex = CRe, Pn.findKey = tar, Pn.findLast = Wrr, Pn.findLastIndex = TRe, Pn.findLastKey = ear, Pn.floor = Eor, Pn.forEach = PRe, Pn.forEachRight = LRe, Pn.forIn = nar, Pn.forInRight = rar, Pn.forOwn = iar, Pn.forOwnRight = aar, Pn.get = xKt, Pn.gt = Cir, Pn.gte = Tir, Pn.has = lar, Pn.hasIn = wKt, Pn.head = IRe, Pn.identity = KM, Pn.includes = Zrr, Pn.indexOf = Wnr, Pn.inRange = Iar, Pn.invoke = far, Pn.isArguments = gH, Pn.isArray = Zf2, Pn.isArrayBuffer = Air, Pn.isArrayLike = $M, Pn.isArrayLikeObject = ym, Pn.isBoolean = Iir, Pn.isBuffer = w7, Pn.isDate = Dir, Pn.isElement = Eir, Pn.isEmpty = kir, Pn.isEqual = Pir, Pn.isEqualWith = Lir, Pn.isError = bKt, Pn.isFinite = Oir, Pn.isFunction = O6, Pn.isInteger = jRe, Pn.isLength = TIt, Pn.isMap = WRe, Pn.isMatch = Rir, Pn.isMatchWith = Nir, Pn.isNaN = Fir, Pn.isNative = Vir, Pn.isNil = zir, Pn.isNull = Bir, Pn.isNumber = GRe, Pn.isObject = dy, Pn.isObjectLike = Fy, Pn.isPlainObject = Opt, Pn.isRegExp = _Kt, Pn.isSafeInteger = jir, Pn.isSet = HRe, Pn.isString = AIt, Pn.isSymbol = NT, Pn.isTypedArray = KJ, Pn.isUndefined = Wir, Pn.isWeakMap = Gir, Pn.isWeakSet = Hir, Pn.join = Znr, Pn.kebabCase = Oar, Pn.last = OD, Pn.lastIndexOf = $nr, Pn.lowerCase = Rar, Pn.lowerFirst = Nar, Pn.lt = Uir, Pn.lte = qir, Pn.max = kor, Pn.maxBy = Por, Pn.mean = Lor, Pn.meanBy = Oor, Pn.min = Ror, Pn.minBy = Nor, Pn.stubArray = IKt, Pn.stubFalse = DKt, Pn.stubObject = xor, Pn.stubString = wor, Pn.stubTrue = Sor, Pn.multiply = For, Pn.nth = Ynr, Pn.noConflict = por, Pn.noop = AKt, Pn.now = SIt, Pn.pad = Far, Pn.padEnd = Var, Pn.padStart = Bar, Pn.parseInt = zar, Pn.random = Dar, Pn.reduce = Qrr, Pn.reduceRight = Jrr, Pn.repeat = jar, Pn.replace = War, Pn.result = bar, Pn.round = Vor, Pn.runInContext = Mi2, Pn.sample = eir, Pn.size = iir, Pn.snakeCase = Gar, Pn.some = air, Pn.sortedIndex = nrr, Pn.sortedIndexBy = rrr, Pn.sortedIndexOf = irr, Pn.sortedLastIndex = arr, Pn.sortedLastIndexBy = orr, Pn.sortedLastIndexOf = srr, Pn.startCase = Uar, Pn.startsWith = qar, Pn.subtract = Bor, Pn.sum = zor, Pn.sumBy = jor, Pn.template = Zar, Pn.times = Mor, Pn.toFinite = R62, Pn.toInteger = wh2, Pn.toLength = qRe, Pn.toLower = $ar, Pn.toNumber = RD, Pn.toSafeInteger = Zir, Pn.toString = ag2, Pn.toUpper = Yar, Pn.trim = Kar, Pn.trimEnd = Xar, Pn.trimStart = Qar, Pn.truncate = Jar, Pn.unescape = tor, Pn.uniqueId = Tor, Pn.upperCase = eor, Pn.upperFirst = SKt, Pn.each = PRe, Pn.eachRight = LRe, Pn.first = IRe, TKt(Pn, function() {
                    var ft = {};
                    return qM(Pn, function(Dt, ee2) {
                      ip.call(Pn.prototype, ee2) || (ft[ee2] = Dt);
                    }), ft;
                  }(), { chain: false }), Pn.VERSION = $t, jM(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(ft) {
                    Pn[ft].placeholder = Pn;
                  }), jM(["drop", "take"], function(ft, Dt) {
                    qu.prototype[ft] = function(ee2) {
                      ee2 = ee2 === Ut ? 1 : kd2(wh2(ee2), 0);
                      var Fe2 = this.__filtered__ && !Dt ? new qu(this) : this.clone();
                      return Fe2.__filtered__ ? Fe2.__takeCount__ = sb2(ee2, Fe2.__takeCount__) : Fe2.__views__.push({ size: sb2(ee2, hs), type: ft + (Fe2.__dir__ < 0 ? "Right" : "") }), Fe2;
                    }, qu.prototype[ft + "Right"] = function(ee2) {
                      return this.reverse()[ft](ee2).reverse();
                    };
                  }), jM(["filter", "map", "takeWhile"], function(ft, Dt) {
                    var ee2 = Dt + 1, Fe2 = ee2 == _l || ee2 == Ra2;
                    qu.prototype[ft] = function(hn) {
                      var $n = this.clone();
                      return $n.__iteratees__.push({ iteratee: xc2(hn, 3), type: ee2 }), $n.__filtered__ = $n.__filtered__ || Fe2, $n;
                    };
                  }), jM(["head", "last"], function(ft, Dt) {
                    var ee2 = "take" + (Dt ? "Right" : "");
                    qu.prototype[ft] = function() {
                      return this[ee2](1).value()[0];
                    };
                  }), jM(["initial", "tail"], function(ft, Dt) {
                    var ee2 = "drop" + (Dt ? "" : "Right");
                    qu.prototype[ft] = function() {
                      return this.__filtered__ ? new qu(this) : this[ee2](1);
                    };
                  }), qu.prototype.compact = function() {
                    return this.filter(KM);
                  }, qu.prototype.find = function(ft) {
                    return this.filter(ft).head();
                  }, qu.prototype.findLast = function(ft) {
                    return this.reverse().find(ft);
                  }, qu.prototype.invokeMap = xh2(function(ft, Dt) {
                    return typeof ft == "function" ? new qu(this) : this.map(function(ee2) {
                      return E6(ee2, ft, Dt);
                    });
                  }), qu.prototype.reject = function(ft) {
                    return this.filter(CIt(xc2(ft)));
                  }, qu.prototype.slice = function(ft, Dt) {
                    ft = wh2(ft);
                    var ee2 = this;
                    return ee2.__filtered__ && (ft > 0 || Dt < 0) ? new qu(ee2) : (ft < 0 ? ee2 = ee2.takeRight(-ft) : ft && (ee2 = ee2.drop(ft)), Dt !== Ut && (Dt = wh2(Dt), ee2 = Dt < 0 ? ee2.dropRight(-Dt) : ee2.take(Dt - ft)), ee2);
                  }, qu.prototype.takeRightWhile = function(ft) {
                    return this.reverse().takeWhile(ft).reverse();
                  }, qu.prototype.toArray = function() {
                    return this.take(hs);
                  }, qM(qu.prototype, function(ft, Dt) {
                    var ee2 = /^(?:filter|find|map|reject)|While$/.test(Dt), Fe2 = /^(?:head|last)$/.test(Dt), hn = Pn[Fe2 ? "take" + (Dt == "last" ? "Right" : "") : Dt], $n = Fe2 || /^find/.test(Dt);
                    !hn || (Pn.prototype[Dt] = function() {
                      var jr = this.__wrapped__, ni2 = Fe2 ? [1] : arguments, Vi2 = jr instanceof qu, Ro = ni2[0], No = Vi2 || Zf2(jr), ls = function(Sp) {
                        var Hp = hn.apply(Pn, yL([Sp], ni2));
                        return Fe2 && xl ? Hp[0] : Hp;
                      };
                      No && ee2 && typeof Ro == "function" && Ro.length != 1 && (Vi2 = No = false);
                      var xl = this.__chain__, Tu = !!this.__actions__.length, Dc2 = $n && !xl, Bh2 = Vi2 && !Tu;
                      if (!$n && No) {
                        jr = Bh2 ? jr : new qu(this);
                        var Ec2 = ft.apply(jr, ni2);
                        return Ec2.__actions__.push({ func: xIt, args: [ls], thisArg: Ut }), new GM(Ec2, xl);
                      }
                      return Dc2 && Bh2 ? ft.apply(this, ni2) : (Ec2 = this.thru(ls), Dc2 ? Fe2 ? Ec2.value()[0] : Ec2.value() : Ec2);
                    });
                  }), jM(["pop", "push", "shift", "sort", "splice", "unshift"], function(ft) {
                    var Dt = OJ[ft], ee2 = /^(?:push|sort|unshift)$/.test(ft) ? "tap" : "thru", Fe2 = /^(?:pop|shift)$/.test(ft);
                    Pn.prototype[ft] = function() {
                      var hn = arguments;
                      if (Fe2 && !this.__chain__) {
                        var $n = this.value();
                        return Dt.apply(Zf2($n) ? $n : [], hn);
                      }
                      return this[ee2](function(jr) {
                        return Dt.apply(Zf2(jr) ? jr : [], hn);
                      });
                    };
                  }), qM(qu.prototype, function(ft, Dt) {
                    var ee2 = Pn[Dt];
                    if (ee2) {
                      var Fe2 = ee2.name + "";
                      ip.call(m7, Fe2) || (m7[Fe2] = []), m7[Fe2].push({ name: Dt, func: ee2 });
                    }
                  }), m7[dIt(Ut, Wa2).name] = [{ name: "wrapper", func: Ut }], qu.prototype.clone = pS, qu.prototype.reverse = _Yt, qu.prototype.value = xYt, Pn.prototype.at = Err, Pn.prototype.chain = krr, Pn.prototype.commit = Prr, Pn.prototype.next = Lrr, Pn.prototype.plant = Rrr, Pn.prototype.reverse = Nrr, Pn.prototype.toJSON = Pn.prototype.valueOf = Pn.prototype.value = Frr, Pn.prototype.first = Pn.prototype.head, d7 && (Pn.prototype[d7] = Orr), Pn;
                }, h_ = lYt();
                S6 ? ((S6.exports = h_)._ = h_, ept._ = h_) : ob2._ = h_;
              }).call(Gn);
            })(Wr, Wr.exports);
            class Gr {
              constructor() {
                qt(this, "subscriptions", /* @__PURE__ */ new Map()), qt(this, "useSubscription", (ve2, Ut) => {
                  const $t = Zt.useRef();
                  Zt.useEffect(() => {
                    $t.current = Ut;
                    function Yt(se2) {
                      $t.current && $t.current(se2);
                    }
                    return this.subscriptions.set(ve2, Yt), () => {
                      this.subscriptions.delete(ve2);
                    };
                  }, []);
                }), qt(this, "emit", (ve2, ...Ut) => {
                  if (typeof ve2 == "string" || typeof ve2 == "number") {
                    const $t = this.subscriptions.get(ve2);
                    $t == null || $t({ params: Wr.exports.cloneDeep(Ut), event: ve2 });
                  } else
                    throw new TypeError("event must be string or number !");
                }), qt(this, "removeListener", (ve2) => {
                  this.subscriptions.delete(ve2);
                }), qt(this, "clear", () => {
                  this.subscriptions.clear();
                }), this.clear();
              }
            }
            const ei2 = new Gr();
            function oi2(Vt) {
              const ve2 = Zt.useRef(), Ut = Zt.useMemo(() => Vt != null ? Vt : { global: false }, [Vt]);
              return ve2.current || (ve2.current = Ut.global ? ve2.current = ei2 : ve2.current = new Gr()), Zt.useEffect(() => () => {
                var $t;
                return ($t = ve2.current) == null ? void 0 : $t.clear();
              }, []), ve2.current;
            }
            var Va2 = globalThis && globalThis.__read || function(Vt, ve2) {
              var Ut = typeof Symbol == "function" && Vt[Symbol.iterator];
              if (!Ut)
                return Vt;
              var $t = Ut.call(Vt), Yt, se2 = [], Re2;
              try {
                for (; (ve2 === void 0 || ve2-- > 0) && !(Yt = $t.next()).done; )
                  se2.push(Yt.value);
              } catch (He2) {
                Re2 = { error: He2 };
              } finally {
                try {
                  Yt && !Yt.done && (Ut = $t.return) && Ut.call($t);
                } finally {
                  if (Re2)
                    throw Re2.error;
                }
              }
              return se2;
            };
            function Ca2(Vt, ve2) {
              Vt === void 0 && (Vt = false);
              var Ut = Va2(Zt.useState(Vt), 2), $t = Ut[0], Yt = Ut[1], se2 = Zt.useMemo(function() {
                var Re2 = ve2 === void 0 ? !Vt : ve2, He2 = function() {
                  return Yt(function(Yn) {
                    return Yn === Vt ? Re2 : Vt;
                  });
                }, nn = function(Yn) {
                  return Yt(Yn);
                }, dn = function() {
                  return Yt(Vt);
                }, yn = function() {
                  return Yt(Re2);
                };
                return { toggle: He2, set: nn, setLeft: dn, setRight: yn };
              }, []);
              return [$t, se2];
            }
            var Go = globalThis && globalThis.__read || function(Vt, ve2) {
              var Ut = typeof Symbol == "function" && Vt[Symbol.iterator];
              if (!Ut)
                return Vt;
              var $t = Ut.call(Vt), Yt, se2 = [], Re2;
              try {
                for (; (ve2 === void 0 || ve2-- > 0) && !(Yt = $t.next()).done; )
                  se2.push(Yt.value);
              } catch (He2) {
                Re2 = { error: He2 };
              } finally {
                try {
                  Yt && !Yt.done && (Ut = $t.return) && Ut.call($t);
                } finally {
                  if (Re2)
                    throw Re2.error;
                }
              }
              return se2;
            };
            function un(Vt) {
              Vt === void 0 && (Vt = false);
              var ve2 = Go(Ca2(Vt), 2), Ut = ve2[0], $t = ve2[1], Yt = $t.toggle, se2 = $t.set, Re2 = Zt.useMemo(function() {
                var He2 = function() {
                  return se2(true);
                }, nn = function() {
                  return se2(false);
                };
                return { toggle: Yt, set: function(dn) {
                  return se2(!!dn);
                }, setTrue: He2, setFalse: nn };
              }, []);
              return [Ut, Re2];
            }
            function Ei2(Vt) {
              var ve2 = Zt.useRef(Vt);
              return ve2.current = Vt, ve2;
            }
            var Wi2 = function(Vt) {
              var ve2 = Ei2(Vt);
              Zt.useEffect(function() {
                return function() {
                  ve2.current();
                };
              }, []);
            }, La2 = Wi2;
            function Aa2(Vt) {
              var ve2 = typeof Vt;
              return Vt != null && (ve2 == "object" || ve2 == "function");
            }
            var Oi2 = Aa2, Zi2 = typeof Gn == "object" && Gn && Gn.Object === Object && Gn, Ka2 = Zi2, Fo = Ka2, Si2 = typeof self == "object" && self && self.Object === Object && self, bl = Fo || Si2 || Function("return this")(), vl = bl, xa2 = vl, gu = function() {
              return xa2.Date.now();
            }, Na2 = gu, ga = /\s/;
            function ca2(Vt) {
              for (var ve2 = Vt.length; ve2-- && ga.test(Vt.charAt(ve2)); )
                ;
              return ve2;
            }
            var fs = ca2, qo = fs, Hu = /^\s+/;
            function vh2(Vt) {
              return Vt && Vt.slice(0, qo(Vt) + 1).replace(Hu, "");
            }
            var Wf2 = vh2, mc2 = vl, yd2 = mc2.Symbol, Gf2 = yd2, hp = Gf2, Lg2 = Object.prototype, n_ = Lg2.hasOwnProperty, Dx = Lg2.toString, Iv = hp ? hp.toStringTag : void 0;
            function Gv(Vt) {
              var ve2 = n_.call(Vt, Iv), Ut = Vt[Iv];
              try {
                Vt[Iv] = void 0;
                var $t = true;
              } catch {
              }
              var Yt = Dx.call(Vt);
              return $t && (ve2 ? Vt[Iv] = Ut : delete Vt[Iv]), Yt;
            }
            var Jm = Gv, Ex = Object.prototype, ry = Ex.toString;
            function r_(Vt) {
              return ry.call(Vt);
            }
            var vu = r_, t1 = Gf2, Dv = Jm, nv = vu, Hv = "[object Null]", eS = "[object Undefined]", so = t1 ? t1.toStringTag : void 0;
            function Bi2(Vt) {
              return Vt == null ? Vt === void 0 ? eS : Hv : so && so in Object(Vt) ? Dv(Vt) : nv(Vt);
            }
            var Xi2 = Bi2;
            function co(Vt) {
              return Vt != null && typeof Vt == "object";
            }
            var Es = co, Zl = Xi2, Yc2 = Es, Kc2 = "[object Symbol]";
            function Dp(Vt) {
              return typeof Vt == "symbol" || Yc2(Vt) && Zl(Vt) == Kc2;
            }
            var Og2 = Dp, tp = Wf2, Fh2 = Oi2, md2 = Og2, cm = 0 / 0, fm = /^[-+]0x[0-9a-f]+$/i, nS = /^0b[01]+$/i, K1 = /^0o[0-7]+$/i, tg2 = parseInt;
            function Jf2(Vt) {
              if (typeof Vt == "number")
                return Vt;
              if (md2(Vt))
                return cm;
              if (Fh2(Vt)) {
                var ve2 = typeof Vt.valueOf == "function" ? Vt.valueOf() : Vt;
                Vt = Fh2(ve2) ? ve2 + "" : ve2;
              }
              if (typeof Vt != "string")
                return Vt === 0 ? Vt : +Vt;
              Vt = tp(Vt);
              var Ut = nS.test(Vt);
              return Ut || K1.test(Vt) ? tg2(Vt.slice(2), Ut ? 2 : 8) : fm.test(Vt) ? cm : +Vt;
            }
            var O0 = Jf2, hm = Oi2, i_ = Na2, X1 = O0, Q1 = "Expected a function", a_ = Math.max, mT = Math.min;
            function bT(Vt, ve2, Ut) {
              var $t, Yt, se2, Re2, He2, nn, dn = 0, yn = false, Yn = false, Rr = true;
              if (typeof Vt != "function")
                throw new TypeError(Q1);
              ve2 = X1(ve2) || 0, hm(Ut) && (yn = !!Ut.leading, Yn = "maxWait" in Ut, se2 = Yn ? a_(X1(Ut.maxWait) || 0, ve2) : se2, Rr = "trailing" in Ut ? !!Ut.trailing : Rr);
              function Ur(Yi2) {
                var Oa2 = $t, Da2 = Yt;
                return $t = Yt = void 0, dn = Yi2, Re2 = Vt.apply(Da2, Oa2), Re2;
              }
              function Hr(Yi2) {
                return dn = Yi2, He2 = setTimeout(Wa2, ve2), yn ? Ur(Yi2) : Re2;
              }
              function si2(Yi2) {
                var Oa2 = Yi2 - nn, Da2 = Yi2 - dn, Fi2 = ve2 - Oa2;
                return Yn ? mT(Fi2, se2 - Da2) : Fi2;
              }
              function _i(Yi2) {
                var Oa2 = Yi2 - nn, Da2 = Yi2 - dn;
                return nn === void 0 || Oa2 >= ve2 || Oa2 < 0 || Yn && Da2 >= se2;
              }
              function Wa2() {
                var Yi2 = i_();
                if (_i(Yi2))
                  return Ia2(Yi2);
                He2 = setTimeout(Wa2, si2(Yi2));
              }
              function Ia2(Yi2) {
                return He2 = void 0, Rr && $t ? Ur(Yi2) : ($t = Yt = void 0, Re2);
              }
              function ts() {
                He2 !== void 0 && clearTimeout(He2), dn = 0, $t = nn = Yt = He2 = void 0;
              }
              function on() {
                return He2 === void 0 ? Re2 : Ia2(i_());
              }
              function di2() {
                var Yi2 = i_(), Oa2 = _i(Yi2);
                if ($t = arguments, Yt = this, nn = Yi2, Oa2) {
                  if (He2 === void 0)
                    return Hr(nn);
                  if (Yn)
                    return clearTimeout(He2), He2 = setTimeout(Wa2, ve2), Ur(nn);
                }
                return He2 === void 0 && (He2 = setTimeout(Wa2, ve2)), Re2;
              }
              return di2.cancel = ts, di2.flush = on, di2;
            }
            var $R = bT, _T = globalThis && globalThis.__read || function(Vt, ve2) {
              var Ut = typeof Symbol == "function" && Vt[Symbol.iterator];
              if (!Ut)
                return Vt;
              var $t = Ut.call(Vt), Yt, se2 = [], Re2;
              try {
                for (; (ve2 === void 0 || ve2-- > 0) && !(Yt = $t.next()).done; )
                  se2.push(Yt.value);
              } catch (He2) {
                Re2 = { error: He2 };
              } finally {
                try {
                  Yt && !Yt.done && (Ut = $t.return) && Ut.call($t);
                } finally {
                  if (Re2)
                    throw Re2.error;
                }
              }
              return se2;
            }, Hk = globalThis && globalThis.__spread || function() {
              for (var Vt = [], ve2 = 0; ve2 < arguments.length; ve2++)
                Vt = Vt.concat(_T(arguments[ve2]));
              return Vt;
            };
            function YR(Vt, ve2) {
              var Ut, $t = Ei2(Vt), Yt = (Ut = ve2 == null ? void 0 : ve2.wait) !== null && Ut !== void 0 ? Ut : 1e3, se2 = Zt.useMemo(function() {
                return $R(function() {
                  for (var Re2 = [], He2 = 0; He2 < arguments.length; He2++)
                    Re2[He2] = arguments[He2];
                  return $t.current.apply($t, Hk(Re2));
                }, Yt, ve2);
              }, []);
              return La2(function() {
                se2.cancel();
              }), { run: se2, cancel: se2.cancel, flush: se2.flush };
            }
            const Q3 = ({ id: Vt, title: ve2, chart: Ut, option: $t }, Yt) => {
              const se2 = Zt.useRef(), Re2 = oi2({ global: true });
              se2.current = Zt.useMemo(() => {
                if (!se2.current)
                  return vn;
              }, []);
              const { run: He2 } = YR(() => {
                Vt && Re2.emit("list");
              }, { wait: 100 });
              return Zt.useEffect(() => {
                console.log(Ut == null ? void 0 : Ut.current), se2.current && (Ut == null ? void 0 : Ut.current) && Vt && $t && (se2.current.add(Vt, Ut == null ? void 0 : Ut.current, $t, ve2), He2());
              }, Yt), { tool: se2.current };
            };
            var O9 = Zt.createContext({}), OM = O9;
            function ir(Vt, ve2, Ut) {
              return ve2 in Vt ? Object.defineProperty(Vt, ve2, { value: Ut, enumerable: true, configurable: true, writable: true }) : Vt[ve2] = Ut, Vt;
            }
            function Mr(Vt, ve2) {
              var Ut = Object.keys(Vt);
              if (Object.getOwnPropertySymbols) {
                var $t = Object.getOwnPropertySymbols(Vt);
                ve2 && ($t = $t.filter(function(Yt) {
                  return Object.getOwnPropertyDescriptor(Vt, Yt).enumerable;
                })), Ut.push.apply(Ut, $t);
              }
              return Ut;
            }
            function gn(Vt) {
              for (var ve2 = 1; ve2 < arguments.length; ve2++) {
                var Ut = arguments[ve2] != null ? arguments[ve2] : {};
                ve2 % 2 ? Mr(Object(Ut), true).forEach(function($t) {
                  ir(Vt, $t, Ut[$t]);
                }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Vt, Object.getOwnPropertyDescriptors(Ut)) : Mr(Object(Ut)).forEach(function($t) {
                  Object.defineProperty(Vt, $t, Object.getOwnPropertyDescriptor(Ut, $t));
                });
              }
              return Vt;
            }
            function sr(Vt) {
              if (Array.isArray(Vt))
                return Vt;
            }
            function dr(Vt, ve2) {
              var Ut = Vt == null ? null : typeof Symbol != "undefined" && Vt[Symbol.iterator] || Vt["@@iterator"];
              if (Ut != null) {
                var $t = [], Yt = true, se2 = false, Re2, He2;
                try {
                  for (Ut = Ut.call(Vt); !(Yt = (Re2 = Ut.next()).done) && ($t.push(Re2.value), !(ve2 && $t.length === ve2)); Yt = true)
                    ;
                } catch (nn) {
                  se2 = true, He2 = nn;
                } finally {
                  try {
                    !Yt && Ut.return != null && Ut.return();
                  } finally {
                    if (se2)
                      throw He2;
                  }
                }
                return $t;
              }
            }
            function ji2(Vt, ve2) {
              (ve2 == null || ve2 > Vt.length) && (ve2 = Vt.length);
              for (var Ut = 0, $t = new Array(ve2); Ut < ve2; Ut++)
                $t[Ut] = Vt[Ut];
              return $t;
            }
            function qa2(Vt, ve2) {
              if (Vt) {
                if (typeof Vt == "string")
                  return ji2(Vt, ve2);
                var Ut = Object.prototype.toString.call(Vt).slice(8, -1);
                if (Ut === "Object" && Vt.constructor && (Ut = Vt.constructor.name), Ut === "Map" || Ut === "Set")
                  return Array.from(Vt);
                if (Ut === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ut))
                  return ji2(Vt, ve2);
              }
            }
            function wa2() {
              throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            function li2(Vt, ve2) {
              return sr(Vt) || dr(Vt, ve2) || qa2(Vt, ve2) || wa2();
            }
            function jo(Vt, ve2) {
              if (Vt == null)
                return {};
              var Ut = {}, $t = Object.keys(Vt), Yt, se2;
              for (se2 = 0; se2 < $t.length; se2++)
                Yt = $t[se2], !(ve2.indexOf(Yt) >= 0) && (Ut[Yt] = Vt[Yt]);
              return Ut;
            }
            function Al(Vt, ve2) {
              if (Vt == null)
                return {};
              var Ut = jo(Vt, ve2), $t, Yt;
              if (Object.getOwnPropertySymbols) {
                var se2 = Object.getOwnPropertySymbols(Vt);
                for (Yt = 0; Yt < se2.length; Yt++)
                  $t = se2[Yt], !(ve2.indexOf($t) >= 0) && (!Object.prototype.propertyIsEnumerable.call(Vt, $t) || (Ut[$t] = Vt[$t]));
              }
              return Ut;
            }
            var Sf2 = { exports: {} };
            /*!
              Copyright (c) 2018 Jed Watson.
              Licensed under the MIT License (MIT), see
              http://jedwatson.github.io/classnames
            */
            (function(Vt) {
              (function() {
                var ve2 = {}.hasOwnProperty;
                function Ut() {
                  for (var $t = [], Yt = 0; Yt < arguments.length; Yt++) {
                    var se2 = arguments[Yt];
                    if (se2) {
                      var Re2 = typeof se2;
                      if (Re2 === "string" || Re2 === "number")
                        $t.push(se2);
                      else if (Array.isArray(se2)) {
                        if (se2.length) {
                          var He2 = Ut.apply(null, se2);
                          He2 && $t.push(He2);
                        }
                      } else if (Re2 === "object")
                        if (se2.toString === Object.prototype.toString)
                          for (var nn in se2)
                            ve2.call(se2, nn) && se2[nn] && $t.push(nn);
                        else
                          $t.push(se2.toString());
                    }
                  }
                  return $t.join(" ");
                }
                Vt.exports ? (Ut.default = Ut, Vt.exports = Ut) : window.classNames = Ut;
              })();
            })(Sf2);
            var sf2 = Sf2.exports;
            function Vc2(Vt) {
              return Vc2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(ve2) {
                return typeof ve2;
              } : function(ve2) {
                return ve2 && typeof Symbol == "function" && ve2.constructor === Symbol && ve2 !== Symbol.prototype ? "symbol" : typeof ve2;
              }, Vc2(Vt);
            }
            function zu(Vt, ve2) {
              ad2(Vt) && (Vt = "100%");
              var Ut = Rg2(Vt);
              return Vt = ve2 === 360 ? Vt : Math.min(ve2, Math.max(0, parseFloat(Vt))), Ut && (Vt = parseInt(String(Vt * ve2), 10) / 100), Math.abs(Vt - ve2) < 1e-6 ? 1 : (ve2 === 360 ? Vt = (Vt < 0 ? Vt % ve2 + ve2 : Vt % ve2) / parseFloat(String(ve2)) : Vt = Vt % ve2 / parseFloat(String(ve2)), Vt);
            }
            function ad2(Vt) {
              return typeof Vt == "string" && Vt.indexOf(".") !== -1 && parseFloat(Vt) === 1;
            }
            function Rg2(Vt) {
              return typeof Vt == "string" && Vt.indexOf("%") !== -1;
            }
            function bc2(Vt) {
              return Vt = parseFloat(Vt), (isNaN(Vt) || Vt < 0 || Vt > 1) && (Vt = 1), Vt;
            }
            function Ng2(Vt) {
              return Vt <= 1 ? Number(Vt) * 100 + "%" : Vt;
            }
            function pm(Vt) {
              return Vt.length === 1 ? "0" + Vt : String(Vt);
            }
            function T22(Vt, ve2, Ut) {
              return { r: zu(Vt, 255) * 255, g: zu(ve2, 255) * 255, b: zu(Ut, 255) * 255 };
            }
            function yD(Vt, ve2, Ut) {
              return Ut < 0 && (Ut += 1), Ut > 1 && (Ut -= 1), Ut < 1 / 6 ? Vt + (ve2 - Vt) * (6 * Ut) : Ut < 1 / 2 ? ve2 : Ut < 2 / 3 ? Vt + (ve2 - Vt) * (2 / 3 - Ut) * 6 : Vt;
            }
            function rS(Vt, ve2, Ut) {
              var $t, Yt, se2;
              if (Vt = zu(Vt, 360), ve2 = zu(ve2, 100), Ut = zu(Ut, 100), ve2 === 0)
                Yt = Ut, se2 = Ut, $t = Ut;
              else {
                var Re2 = Ut < 0.5 ? Ut * (1 + ve2) : Ut + ve2 - Ut * ve2, He2 = 2 * Ut - Re2;
                $t = yD(He2, Re2, Vt + 1 / 3), Yt = yD(He2, Re2, Vt), se2 = yD(He2, Re2, Vt - 1 / 3);
              }
              return { r: $t * 255, g: Yt * 255, b: se2 * 255 };
            }
            function Uk(Vt, ve2, Ut) {
              Vt = zu(Vt, 255), ve2 = zu(ve2, 255), Ut = zu(Ut, 255);
              var $t = Math.max(Vt, ve2, Ut), Yt = Math.min(Vt, ve2, Ut), se2 = 0, Re2 = $t, He2 = $t - Yt, nn = $t === 0 ? 0 : He2 / $t;
              if ($t === Yt)
                se2 = 0;
              else {
                switch ($t) {
                  case Vt:
                    se2 = (ve2 - Ut) / He2 + (ve2 < Ut ? 6 : 0);
                    break;
                  case ve2:
                    se2 = (Ut - Vt) / He2 + 2;
                    break;
                  case Ut:
                    se2 = (Vt - ve2) / He2 + 4;
                    break;
                }
                se2 /= 6;
              }
              return { h: se2, s: nn, v: Re2 };
            }
            function xT(Vt, ve2, Ut) {
              Vt = zu(Vt, 360) * 6, ve2 = zu(ve2, 100), Ut = zu(Ut, 100);
              var $t = Math.floor(Vt), Yt = Vt - $t, se2 = Ut * (1 - ve2), Re2 = Ut * (1 - Yt * ve2), He2 = Ut * (1 - (1 - Yt) * ve2), nn = $t % 6, dn = [Ut, Re2, se2, se2, He2, Ut][nn], yn = [He2, Ut, Ut, Re2, se2, se2][nn], Yn = [se2, se2, He2, Ut, Ut, Re2][nn];
              return { r: dn * 255, g: yn * 255, b: Yn * 255 };
            }
            function iy(Vt, ve2, Ut, $t) {
              var Yt = [pm(Math.round(Vt).toString(16)), pm(Math.round(ve2).toString(16)), pm(Math.round(Ut).toString(16))];
              return $t && Yt[0].startsWith(Yt[0].charAt(1)) && Yt[1].startsWith(Yt[1].charAt(1)) && Yt[2].startsWith(Yt[2].charAt(1)) ? Yt[0].charAt(0) + Yt[1].charAt(0) + Yt[2].charAt(0) : Yt.join("");
            }
            function A22(Vt) {
              return ay(Vt) / 255;
            }
            function ay(Vt) {
              return parseInt(Vt, 16);
            }
            var RM = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
            function Uv(Vt) {
              var ve2 = { r: 0, g: 0, b: 0 }, Ut = 1, $t = null, Yt = null, se2 = null, Re2 = false, He2 = false;
              return typeof Vt == "string" && (Vt = XR(Vt)), typeof Vt == "object" && (I22(Vt.r) && I22(Vt.g) && I22(Vt.b) ? (ve2 = T22(Vt.r, Vt.g, Vt.b), Re2 = true, He2 = String(Vt.r).substr(-1) === "%" ? "prgb" : "rgb") : I22(Vt.h) && I22(Vt.s) && I22(Vt.v) ? ($t = Ng2(Vt.s), Yt = Ng2(Vt.v), ve2 = xT(Vt.h, $t, Yt), Re2 = true, He2 = "hsv") : I22(Vt.h) && I22(Vt.s) && I22(Vt.l) && ($t = Ng2(Vt.s), se2 = Ng2(Vt.l), ve2 = rS(Vt.h, $t, se2), Re2 = true, He2 = "hsl"), Object.prototype.hasOwnProperty.call(Vt, "a") && (Ut = Vt.a)), Ut = bc2(Ut), { ok: Re2, format: Vt.format || He2, r: Math.min(255, Math.max(ve2.r, 0)), g: Math.min(255, Math.max(ve2.g, 0)), b: Math.min(255, Math.max(ve2.b, 0)), a: Ut };
            }
            var qk2 = "[-\\+]?\\d+%?", KR = "[-\\+]?\\d*\\.\\d+%?", kx = "(?:" + KR + ")|(?:" + qk2 + ")", wT = "[\\s|\\(]+(" + kx + ")[,|\\s]+(" + kx + ")[,|\\s]+(" + kx + ")\\s*\\)?", ST = "[\\s|\\(]+(" + kx + ")[,|\\s]+(" + kx + ")[,|\\s]+(" + kx + ")[,|\\s]+(" + kx + ")\\s*\\)?", Ly = { CSS_UNIT: new RegExp(kx), rgb: new RegExp("rgb" + wT), rgba: new RegExp("rgba" + ST), hsl: new RegExp("hsl" + wT), hsla: new RegExp("hsla" + ST), hsv: new RegExp("hsv" + wT), hsva: new RegExp("hsva" + ST), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
            function XR(Vt) {
              if (Vt = Vt.trim().toLowerCase(), Vt.length === 0)
                return false;
              var ve2 = false;
              if (RM[Vt])
                Vt = RM[Vt], ve2 = true;
              else if (Vt === "transparent")
                return { r: 0, g: 0, b: 0, a: 0, format: "name" };
              var Ut = Ly.rgb.exec(Vt);
              return Ut ? { r: Ut[1], g: Ut[2], b: Ut[3] } : (Ut = Ly.rgba.exec(Vt), Ut ? { r: Ut[1], g: Ut[2], b: Ut[3], a: Ut[4] } : (Ut = Ly.hsl.exec(Vt), Ut ? { h: Ut[1], s: Ut[2], l: Ut[3] } : (Ut = Ly.hsla.exec(Vt), Ut ? { h: Ut[1], s: Ut[2], l: Ut[3], a: Ut[4] } : (Ut = Ly.hsv.exec(Vt), Ut ? { h: Ut[1], s: Ut[2], v: Ut[3] } : (Ut = Ly.hsva.exec(Vt), Ut ? { h: Ut[1], s: Ut[2], v: Ut[3], a: Ut[4] } : (Ut = Ly.hex8.exec(Vt), Ut ? { r: ay(Ut[1]), g: ay(Ut[2]), b: ay(Ut[3]), a: A22(Ut[4]), format: ve2 ? "name" : "hex8" } : (Ut = Ly.hex6.exec(Vt), Ut ? { r: ay(Ut[1]), g: ay(Ut[2]), b: ay(Ut[3]), format: ve2 ? "name" : "hex" } : (Ut = Ly.hex4.exec(Vt), Ut ? { r: ay(Ut[1] + Ut[1]), g: ay(Ut[2] + Ut[2]), b: ay(Ut[3] + Ut[3]), a: A22(Ut[4] + Ut[4]), format: ve2 ? "name" : "hex8" } : (Ut = Ly.hex3.exec(Vt), Ut ? { r: ay(Ut[1] + Ut[1]), g: ay(Ut[2] + Ut[2]), b: ay(Ut[3] + Ut[3]), format: ve2 ? "name" : "hex" } : false)))))))));
            }
            function I22(Vt) {
              return Boolean(Ly.CSS_UNIT.exec(String(Vt)));
            }
            var mD = 2, Zk = 0.16, EQ = 0.05, kQ = 0.05, vht = 0.15, pG = 5, dG = 4, PQ = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
            function gG(Vt) {
              var ve2 = Vt.r, Ut = Vt.g, $t = Vt.b, Yt = Uk(ve2, Ut, $t);
              return { h: Yt.h * 360, s: Yt.s, v: Yt.v };
            }
            function R9(Vt) {
              var ve2 = Vt.r, Ut = Vt.g, $t = Vt.b;
              return "#".concat(iy(ve2, Ut, $t, false));
            }
            function yht(Vt, ve2, Ut) {
              var $t = Ut / 100, Yt = { r: (ve2.r - Vt.r) * $t + Vt.r, g: (ve2.g - Vt.g) * $t + Vt.g, b: (ve2.b - Vt.b) * $t + Vt.b };
              return Yt;
            }
            function LQ(Vt, ve2, Ut) {
              var $t;
              return Math.round(Vt.h) >= 60 && Math.round(Vt.h) <= 240 ? $t = Ut ? Math.round(Vt.h) - mD * ve2 : Math.round(Vt.h) + mD * ve2 : $t = Ut ? Math.round(Vt.h) + mD * ve2 : Math.round(Vt.h) - mD * ve2, $t < 0 ? $t += 360 : $t >= 360 && ($t -= 360), $t;
            }
            function vG(Vt, ve2, Ut) {
              if (Vt.h === 0 && Vt.s === 0)
                return Vt.s;
              var $t;
              return Ut ? $t = Vt.s - Zk * ve2 : ve2 === dG ? $t = Vt.s + Zk : $t = Vt.s + EQ * ve2, $t > 1 && ($t = 1), Ut && ve2 === pG && $t > 0.1 && ($t = 0.1), $t < 0.06 && ($t = 0.06), Number($t.toFixed(2));
            }
            function OQ(Vt, ve2, Ut) {
              var $t;
              return Ut ? $t = Vt.v + kQ * ve2 : $t = Vt.v - vht * ve2, $t > 1 && ($t = 1), Number($t.toFixed(2));
            }
            function yG(Vt) {
              for (var ve2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ut = [], $t = Uv(Vt), Yt = pG; Yt > 0; Yt -= 1) {
                var se2 = gG($t), Re2 = R9(Uv({ h: LQ(se2, Yt, true), s: vG(se2, Yt, true), v: OQ(se2, Yt, true) }));
                Ut.push(Re2);
              }
              Ut.push(R9($t));
              for (var He2 = 1; He2 <= dG; He2 += 1) {
                var nn = gG($t), dn = R9(Uv({ h: LQ(nn, He2), s: vG(nn, He2), v: OQ(nn, He2) }));
                Ut.push(dn);
              }
              return ve2.theme === "dark" ? PQ.map(function(yn) {
                var Yn = yn.index, Rr = yn.opacity, Ur = R9(yht(Uv(ve2.backgroundColor || "#141414"), Uv(Ut[Yn]), Rr * 100));
                return Ur;
              }) : Ut;
            }
            var mG = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, e1 = {}, QR = {};
            Object.keys(mG).forEach(function(Vt) {
              e1[Vt] = yG(mG[Vt]), e1[Vt].primary = e1[Vt][5], QR[Vt] = yG(mG[Vt], { theme: "dark", backgroundColor: "#141414" }), QR[Vt].primary = QR[Vt][5];
            }), e1.red, e1.volcano, e1.gold, e1.orange, e1.yellow, e1.lime, e1.green, e1.cyan, e1.blue, e1.geekblue, e1.purple, e1.magenta, e1.grey;
            var RQ = {};
            function mht(Vt, ve2) {
            }
            function bht(Vt, ve2, Ut) {
              !ve2 && !RQ[Ut] && (Vt(false, Ut), RQ[Ut] = true);
            }
            function iS(Vt, ve2) {
              bht(mht, Vt, ve2);
            }
            function bG() {
              return !!(typeof window != "undefined" && window.document && window.document.createElement);
            }
            var Fg2 = "rc-util-key";
            function jd2() {
              var Vt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, ve2 = Vt.mark;
              return ve2 ? ve2.startsWith("data-") ? ve2 : "data-".concat(ve2) : Fg2;
            }
            function _G(Vt) {
              if (Vt.attachTo)
                return Vt.attachTo;
              var ve2 = document.querySelector("head");
              return ve2 || document.body;
            }
            function NQ(Vt) {
              var ve2, Ut = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              if (!bG())
                return null;
              var $t = document.createElement("style");
              if (!((ve2 = Ut.csp) === null || ve2 === void 0) && ve2.nonce) {
                var Yt;
                $t.nonce = (Yt = Ut.csp) === null || Yt === void 0 ? void 0 : Yt.nonce;
              }
              $t.innerHTML = Vt;
              var se2 = _G(Ut), Re2 = se2.firstChild;
              return Ut.prepend && se2.prepend ? se2.prepend($t) : Ut.prepend && Re2 ? se2.insertBefore($t, Re2) : se2.appendChild($t), $t;
            }
            var xG = /* @__PURE__ */ new Map();
            function _ht(Vt) {
              var ve2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ut = _G(ve2);
              return Array.from(xG.get(Ut).children).find(function($t) {
                return $t.tagName === "STYLE" && $t.getAttribute(jd2(ve2)) === Vt;
              });
            }
            function FQ(Vt, ve2) {
              var Ut = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, $t = _G(Ut);
              if (!xG.has($t)) {
                var Yt = NQ("", Ut), se2 = Yt.parentNode;
                xG.set($t, se2), se2.removeChild(Yt);
              }
              var Re2 = _ht(ve2, Ut);
              if (Re2) {
                var He2, nn;
                if (((He2 = Ut.csp) === null || He2 === void 0 ? void 0 : He2.nonce) && Re2.nonce !== ((nn = Ut.csp) === null || nn === void 0 ? void 0 : nn.nonce)) {
                  var dn;
                  Re2.nonce = (dn = Ut.csp) === null || dn === void 0 ? void 0 : dn.nonce;
                }
                return Re2.innerHTML !== Vt && (Re2.innerHTML = Vt), Re2;
              }
              var yn = NQ(Vt, Ut);
              return yn.setAttribute(jd2(Ut), ve2), yn;
            }
            function xht(Vt, ve2) {
              iS(Vt, "[@ant-design/icons] ".concat(ve2));
            }
            function N9(Vt) {
              return Vc2(Vt) === "object" && typeof Vt.name == "string" && typeof Vt.theme == "string" && (Vc2(Vt.icon) === "object" || typeof Vt.icon == "function");
            }
            function VQ() {
              var Vt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              return Object.keys(Vt).reduce(function(ve2, Ut) {
                var $t = Vt[Ut];
                switch (Ut) {
                  case "class":
                    ve2.className = $t, delete ve2.class;
                    break;
                  default:
                    ve2[Ut] = $t;
                }
                return ve2;
              }, {});
            }
            function qv(Vt, ve2, Ut) {
              return Ut ? Ge2.default.createElement(Vt.tag, gn(gn({ key: ve2 }, VQ(Vt.attrs)), Ut), (Vt.children || []).map(function($t, Yt) {
                return qv($t, "".concat(ve2, "-").concat(Vt.tag, "-").concat(Yt));
              })) : Ge2.default.createElement(Vt.tag, gn({ key: ve2 }, VQ(Vt.attrs)), (Vt.children || []).map(function($t, Yt) {
                return qv($t, "".concat(ve2, "-").concat(Vt.tag, "-").concat(Yt));
              }));
            }
            function F9(Vt) {
              return yG(Vt)[0];
            }
            function bD(Vt) {
              return Vt ? Array.isArray(Vt) ? Vt : [Vt] : [];
            }
            var BQ = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, wG = function() {
              var Vt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : BQ, ve2 = Zt.useContext(OM), Ut = ve2.csp;
              Zt.useEffect(function() {
                FQ(Vt, "@ant-design-icons", { prepend: true, csp: Ut });
              }, []);
            }, aS = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], J3 = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
            function zQ(Vt) {
              var ve2 = Vt.primaryColor, Ut = Vt.secondaryColor;
              J3.primaryColor = ve2, J3.secondaryColor = Ut || F9(ve2), J3.calculated = !!Ut;
            }
            function jQ() {
              return gn({}, J3);
            }
            var JR = function(Vt) {
              var ve2 = Vt.icon, Ut = Vt.className, $t = Vt.onClick, Yt = Vt.style, se2 = Vt.primaryColor, Re2 = Vt.secondaryColor, He2 = Al(Vt, aS), nn = J3;
              if (se2 && (nn = { primaryColor: se2, secondaryColor: Re2 || F9(se2) }), wG(), xht(N9(ve2), "icon should be icon definiton, but got ".concat(ve2)), !N9(ve2))
                return null;
              var dn = ve2;
              return dn && typeof dn.icon == "function" && (dn = gn(gn({}, dn), {}, { icon: dn.icon(nn.primaryColor, nn.secondaryColor) })), qv(dn.icon, "svg-".concat(dn.name), gn({ className: Ut, onClick: $t, style: Yt, "data-icon": dn.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, He2));
            };
            JR.displayName = "IconReact", JR.getTwoToneColors = jQ, JR.setTwoToneColors = zQ;
            var V9 = JR;
            function SG(Vt) {
              var ve2 = bD(Vt), Ut = li2(ve2, 2), $t = Ut[0], Yt = Ut[1];
              return V9.setTwoToneColors({ primaryColor: $t, secondaryColor: Yt });
            }
            function Px() {
              var Vt = V9.getTwoToneColors();
              return Vt.calculated ? [Vt.primaryColor, Vt.secondaryColor] : Vt.primaryColor;
            }
            var wht = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
            SG("#1890ff");
            var J1 = Ve.forwardRef(function(Vt, ve2) {
              var Ut, $t = Vt.className, Yt = Vt.icon, se2 = Vt.spin, Re2 = Vt.rotate, He2 = Vt.tabIndex, nn = Vt.onClick, dn = Vt.twoToneColor, yn = Al(Vt, wht), Yn = Ve.useContext(OM), Rr = Yn.prefixCls, Ur = Rr === void 0 ? "anticon" : Rr, Hr = sf2(Ur, (Ut = {}, ir(Ut, "".concat(Ur, "-").concat(Yt.name), !!Yt.name), ir(Ut, "".concat(Ur, "-spin"), !!se2 || Yt.name === "loading"), Ut), $t), si2 = He2;
              si2 === void 0 && nn && (si2 = -1);
              var _i = Re2 ? { msTransform: "rotate(".concat(Re2, "deg)"), transform: "rotate(".concat(Re2, "deg)") } : void 0, Wa2 = bD(dn), Ia2 = li2(Wa2, 2), ts = Ia2[0], on = Ia2[1];
              return Ve.createElement("span", gn(gn({ role: "img", "aria-label": Yt.name }, yn), {}, { ref: ve2, tabIndex: si2, onClick: nn, className: Hr }), Ve.createElement(V9, { icon: Yt, primaryColor: ts, secondaryColor: on, style: _i }));
            });
            J1.displayName = "AntdIcon", J1.getTwoToneColor = Px, J1.setTwoToneColor = SG;
            var Sht = J1, WQ = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, MT = WQ, tL = function(Vt, ve2) {
              return Ve.createElement(Sht, gn(gn({}, Vt), {}, { ref: ve2, icon: MT }));
            };
            tL.displayName = "LoadingOutlined";
            var MG = Ve.forwardRef(tL);
            function Xc2() {
              return Xc2 = Object.assign || function(Vt) {
                for (var ve2 = 1; ve2 < arguments.length; ve2++) {
                  var Ut = arguments[ve2];
                  for (var $t in Ut)
                    Object.prototype.hasOwnProperty.call(Ut, $t) && (Vt[$t] = Ut[$t]);
                }
                return Vt;
              }, Xc2.apply(this, arguments);
            }
            function oS(Vt, ve2) {
              if (!(Vt instanceof ve2))
                throw new TypeError("Cannot call a class as a function");
            }
            function B9(Vt, ve2) {
              for (var Ut = 0; Ut < ve2.length; Ut++) {
                var $t = ve2[Ut];
                $t.enumerable = $t.enumerable || false, $t.configurable = true, "value" in $t && ($t.writable = true), Object.defineProperty(Vt, $t.key, $t);
              }
            }
            function _D(Vt, ve2, Ut) {
              return ve2 && B9(Vt.prototype, ve2), Ut && B9(Vt, Ut), Object.defineProperty(Vt, "prototype", { writable: false }), Vt;
            }
            function t6(Vt, ve2) {
              return t6 = Object.setPrototypeOf || function(Ut, $t) {
                return Ut.__proto__ = $t, Ut;
              }, t6(Vt, ve2);
            }
            function CG(Vt, ve2) {
              if (typeof ve2 != "function" && ve2 !== null)
                throw new TypeError("Super expression must either be null or a function");
              Vt.prototype = Object.create(ve2 && ve2.prototype, { constructor: { value: Vt, writable: true, configurable: true } }), Object.defineProperty(Vt, "prototype", { writable: false }), ve2 && t6(Vt, ve2);
            }
            function z9(Vt) {
              return z9 = Object.setPrototypeOf ? Object.getPrototypeOf : function(ve2) {
                return ve2.__proto__ || Object.getPrototypeOf(ve2);
              }, z9(Vt);
            }
            function Mht() {
              if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                return false;
              if (typeof Proxy == "function")
                return true;
              try {
                return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
                })), true;
              } catch {
                return false;
              }
            }
            function j9(Vt) {
              if (Vt === void 0)
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              return Vt;
            }
            function W9(Vt, ve2) {
              if (ve2 && (Vc2(ve2) === "object" || typeof ve2 == "function"))
                return ve2;
              if (ve2 !== void 0)
                throw new TypeError("Derived constructors may only return object or undefined");
              return j9(Vt);
            }
            function xD(Vt) {
              var ve2 = Mht();
              return function() {
                var Ut = z9(Vt), $t;
                if (ve2) {
                  var Yt = z9(this).constructor;
                  $t = Reflect.construct(Ut, arguments, Yt);
                } else
                  $t = Ut.apply(this, arguments);
                return W9(this, $t);
              };
            }
            var TG = { exports: {} }, od2 = {};
            /** @license React v16.13.1
            * react-is.production.min.js
            *
            * Copyright (c) Facebook, Inc. and its affiliates.
            *
            * This source code is licensed under the MIT license found in the
            * LICENSE file in the root directory of this source tree.
            */
            var oy = typeof Symbol == "function" && Symbol.for, e6 = oy ? Symbol.for("react.element") : 60103, wD = oy ? Symbol.for("react.portal") : 60106, n6 = oy ? Symbol.for("react.fragment") : 60107, r6 = oy ? Symbol.for("react.strict_mode") : 60108, $k = oy ? Symbol.for("react.profiler") : 60114, SD = oy ? Symbol.for("react.provider") : 60109, i6 = oy ? Symbol.for("react.context") : 60110, a6 = oy ? Symbol.for("react.async_mode") : 60111, dm = oy ? Symbol.for("react.concurrent_mode") : 60111, Yk = oy ? Symbol.for("react.forward_ref") : 60112, MD = oy ? Symbol.for("react.suspense") : 60113, GQ = oy ? Symbol.for("react.suspense_list") : 60120, o6 = oy ? Symbol.for("react.memo") : 60115, Kk = oy ? Symbol.for("react.lazy") : 60116, G9 = oy ? Symbol.for("react.block") : 60121, Cht = oy ? Symbol.for("react.fundamental") : 60117, Tht = oy ? Symbol.for("react.responder") : 60118, AG = oy ? Symbol.for("react.scope") : 60119;
            function sy(Vt) {
              if (typeof Vt == "object" && Vt !== null) {
                var ve2 = Vt.$$typeof;
                switch (ve2) {
                  case e6:
                    switch (Vt = Vt.type, Vt) {
                      case a6:
                      case dm:
                      case n6:
                      case $k:
                      case r6:
                      case MD:
                        return Vt;
                      default:
                        switch (Vt = Vt && Vt.$$typeof, Vt) {
                          case i6:
                          case Yk:
                          case Kk:
                          case o6:
                          case SD:
                            return Vt;
                          default:
                            return ve2;
                        }
                    }
                  case wD:
                    return ve2;
                }
              }
            }
            function HQ(Vt) {
              return sy(Vt) === dm;
            }
            od2.AsyncMode = a6, od2.ConcurrentMode = dm, od2.ContextConsumer = i6, od2.ContextProvider = SD, od2.Element = e6, od2.ForwardRef = Yk, od2.Fragment = n6, od2.Lazy = Kk, od2.Memo = o6, od2.Portal = wD, od2.Profiler = $k, od2.StrictMode = r6, od2.Suspense = MD, od2.isAsyncMode = function(Vt) {
              return HQ(Vt) || sy(Vt) === a6;
            }, od2.isConcurrentMode = HQ, od2.isContextConsumer = function(Vt) {
              return sy(Vt) === i6;
            }, od2.isContextProvider = function(Vt) {
              return sy(Vt) === SD;
            }, od2.isElement = function(Vt) {
              return typeof Vt == "object" && Vt !== null && Vt.$$typeof === e6;
            }, od2.isForwardRef = function(Vt) {
              return sy(Vt) === Yk;
            }, od2.isFragment = function(Vt) {
              return sy(Vt) === n6;
            }, od2.isLazy = function(Vt) {
              return sy(Vt) === Kk;
            }, od2.isMemo = function(Vt) {
              return sy(Vt) === o6;
            }, od2.isPortal = function(Vt) {
              return sy(Vt) === wD;
            }, od2.isProfiler = function(Vt) {
              return sy(Vt) === $k;
            }, od2.isStrictMode = function(Vt) {
              return sy(Vt) === r6;
            }, od2.isSuspense = function(Vt) {
              return sy(Vt) === MD;
            }, od2.isValidElementType = function(Vt) {
              return typeof Vt == "string" || typeof Vt == "function" || Vt === n6 || Vt === dm || Vt === $k || Vt === r6 || Vt === MD || Vt === GQ || typeof Vt == "object" && Vt !== null && (Vt.$$typeof === Kk || Vt.$$typeof === o6 || Vt.$$typeof === SD || Vt.$$typeof === i6 || Vt.$$typeof === Yk || Vt.$$typeof === Cht || Vt.$$typeof === Tht || Vt.$$typeof === AG || Vt.$$typeof === G9);
            }, od2.typeOf = sy, TG.exports = od2;
            function IG(Vt) {
              var ve2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ut = [];
              return Ge2.default.Children.forEach(Vt, function($t) {
                $t == null && !ve2.keepEmpty || (Array.isArray($t) ? Ut = Ut.concat(IG($t)) : TG.exports.isFragment($t) && $t.props ? Ut = Ut.concat(IG($t.props.children, ve2)) : Ut.push($t));
              }), Ut;
            }
            function DG(Vt, ve2) {
              typeof Vt == "function" ? Vt(ve2) : Vc2(Vt) === "object" && Vt && "current" in Vt && (Vt.current = ve2);
            }
            function UQ() {
              for (var Vt = arguments.length, ve2 = new Array(Vt), Ut = 0; Ut < Vt; Ut++)
                ve2[Ut] = arguments[Ut];
              var $t = ve2.filter(function(Yt) {
                return Yt;
              });
              return $t.length <= 1 ? $t[0] : function(Yt) {
                ve2.forEach(function(se2) {
                  DG(se2, Yt);
                });
              };
            }
            function CD(Vt) {
              var ve2, Ut, $t = TG.exports.isMemo(Vt) ? Vt.type.type : Vt.type;
              return !(typeof $t == "function" && !(!((ve2 = $t.prototype) === null || ve2 === void 0) && ve2.render) || typeof Vt == "function" && !(!((Ut = Vt.prototype) === null || Ut === void 0) && Ut.render));
            }
            function H9() {
              try {
                if (!Object.assign)
                  return false;
                var Vt = new String("abc");
                if (Vt[5] = "de", Object.getOwnPropertyNames(Vt)[0] === "5")
                  return false;
                for (var ve2 = {}, Ut = 0; Ut < 10; Ut++)
                  ve2["_" + String.fromCharCode(Ut)] = Ut;
                var $t = Object.getOwnPropertyNames(ve2).map(function(se2) {
                  return ve2[se2];
                });
                if ($t.join("") !== "0123456789")
                  return false;
                var Yt = {};
                return "abcdefghijklmnopqrst".split("").forEach(function(se2) {
                  Yt[se2] = se2;
                }), Object.keys(Object.assign({}, Yt)).join("") === "abcdefghijklmnopqrst";
              } catch {
                return false;
              }
            }
            H9();
            function Aht(Vt) {
              if (Array.isArray(Vt))
                return ji2(Vt);
            }
            function qQ(Vt) {
              if (typeof Symbol != "undefined" && Vt[Symbol.iterator] != null || Vt["@@iterator"] != null)
                return Array.from(Vt);
            }
            function Iht() {
              throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            function Pf2(Vt) {
              return Aht(Vt) || qQ(Vt) || qa2(Vt) || Iht();
            }
            var n1 = "RC_FORM_INTERNAL_HOOKS", eg2 = function() {
              iS(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
            }, tb2 = Ve.createContext({ getFieldValue: eg2, getFieldsValue: eg2, getFieldError: eg2, getFieldWarning: eg2, getFieldsError: eg2, isFieldsTouched: eg2, isFieldTouched: eg2, isFieldValidating: eg2, isFieldsValidating: eg2, resetFields: eg2, setFields: eg2, setFieldsValue: eg2, validateFields: eg2, submit: eg2, getInternalHooks: function() {
              return eg2(), { dispatch: eg2, initEntityValue: eg2, registerField: eg2, useSubscribe: eg2, setInitialValues: eg2, setCallbacks: eg2, getFields: eg2, setValidateMessages: eg2, setPreserve: eg2, getInitialValue: eg2 };
            } });
            function EG(Vt) {
              return Vt == null ? [] : Array.isArray(Vt) ? Vt : [Vt];
            }
            var ZQ = { exports: {} };
            (function(Vt) {
              var ve2 = function(Ut) {
                var $t = Object.prototype, Yt = $t.hasOwnProperty, se2, Re2 = typeof Symbol == "function" ? Symbol : {}, He2 = Re2.iterator || "@@iterator", nn = Re2.asyncIterator || "@@asyncIterator", dn = Re2.toStringTag || "@@toStringTag";
                function yn(Ga2, ha2, pa2) {
                  return Object.defineProperty(Ga2, ha2, { value: pa2, enumerable: true, configurable: true, writable: true }), Ga2[ha2];
                }
                try {
                  yn({}, "");
                } catch {
                  yn = function(Ga2, ha2, pa2) {
                    return Ga2[ha2] = pa2;
                  };
                }
                function Yn(Ga2, ha2, pa2, hs) {
                  var Zo = ha2 && ha2.prototype instanceof Ia2 ? ha2 : Ia2, rc2 = Object.create(Zo.prototype), ep = new yl(hs || []);
                  return rc2._invoke = ro(Ga2, pa2, ep), rc2;
                }
                Ut.wrap = Yn;
                function Rr(Ga2, ha2, pa2) {
                  try {
                    return { type: "normal", arg: Ga2.call(ha2, pa2) };
                  } catch (hs) {
                    return { type: "throw", arg: hs };
                  }
                }
                var Ur = "suspendedStart", Hr = "suspendedYield", si2 = "executing", _i = "completed", Wa2 = {};
                function Ia2() {
                }
                function ts() {
                }
                function on() {
                }
                var di2 = {};
                yn(di2, He2, function() {
                  return this;
                });
                var Yi2 = Object.getPrototypeOf, Oa2 = Yi2 && Yi2(Yi2(Ra2([])));
                Oa2 && Oa2 !== $t && Yt.call(Oa2, He2) && (di2 = Oa2);
                var Da2 = on.prototype = Ia2.prototype = Object.create(di2);
                ts.prototype = on, yn(Da2, "constructor", on), yn(on, "constructor", ts), ts.displayName = yn(on, dn, "GeneratorFunction");
                function Fi2(Ga2) {
                  ["next", "throw", "return"].forEach(function(ha2) {
                    yn(Ga2, ha2, function(pa2) {
                      return this._invoke(ha2, pa2);
                    });
                  });
                }
                Ut.isGeneratorFunction = function(Ga2) {
                  var ha2 = typeof Ga2 == "function" && Ga2.constructor;
                  return ha2 ? ha2 === ts || (ha2.displayName || ha2.name) === "GeneratorFunction" : false;
                }, Ut.mark = function(Ga2) {
                  return Object.setPrototypeOf ? Object.setPrototypeOf(Ga2, on) : (Ga2.__proto__ = on, yn(Ga2, dn, "GeneratorFunction")), Ga2.prototype = Object.create(Da2), Ga2;
                }, Ut.awrap = function(Ga2) {
                  return { __await: Ga2 };
                };
                function Qi2(Ga2, ha2) {
                  function pa2(rc2, ep, mh2, Cf2) {
                    var Gd2 = Rr(Ga2[rc2], Ga2, ep);
                    if (Gd2.type === "throw")
                      Cf2(Gd2.arg);
                    else {
                      var bh2 = Gd2.arg, Gp = bh2.value;
                      return Gp && typeof Gp == "object" && Yt.call(Gp, "__await") ? ha2.resolve(Gp.__await).then(function($v) {
                        pa2("next", $v, mh2, Cf2);
                      }, function($v) {
                        pa2("throw", $v, mh2, Cf2);
                      }) : ha2.resolve(Gp).then(function($v) {
                        bh2.value = $v, mh2(bh2);
                      }, function($v) {
                        return pa2("throw", $v, mh2, Cf2);
                      });
                    }
                  }
                  var hs;
                  function Zo(rc2, ep) {
                    function mh2() {
                      return new ha2(function(Cf2, Gd2) {
                        pa2(rc2, ep, Cf2, Gd2);
                      });
                    }
                    return hs = hs ? hs.then(mh2, mh2) : mh2();
                  }
                  this._invoke = Zo;
                }
                Fi2(Qi2.prototype), yn(Qi2.prototype, nn, function() {
                  return this;
                }), Ut.AsyncIterator = Qi2, Ut.async = function(Ga2, ha2, pa2, hs, Zo) {
                  Zo === void 0 && (Zo = Promise);
                  var rc2 = new Qi2(Yn(Ga2, ha2, pa2, hs), Zo);
                  return Ut.isGeneratorFunction(ha2) ? rc2 : rc2.next().then(function(ep) {
                    return ep.done ? ep.value : rc2.next();
                  });
                };
                function ro(Ga2, ha2, pa2) {
                  var hs = Ur;
                  return function(Zo, rc2) {
                    if (hs === si2)
                      throw new Error("Generator is already running");
                    if (hs === _i) {
                      if (Zo === "throw")
                        throw rc2;
                      return Su();
                    }
                    for (pa2.method = Zo, pa2.arg = rc2; ; ) {
                      var ep = pa2.delegate;
                      if (ep) {
                        var mh2 = Wo(ep, pa2);
                        if (mh2) {
                          if (mh2 === Wa2)
                            continue;
                          return mh2;
                        }
                      }
                      if (pa2.method === "next")
                        pa2.sent = pa2._sent = pa2.arg;
                      else if (pa2.method === "throw") {
                        if (hs === Ur)
                          throw hs = _i, pa2.arg;
                        pa2.dispatchException(pa2.arg);
                      } else
                        pa2.method === "return" && pa2.abrupt("return", pa2.arg);
                      hs = si2;
                      var Cf2 = Rr(Ga2, ha2, pa2);
                      if (Cf2.type === "normal") {
                        if (hs = pa2.done ? _i : Hr, Cf2.arg === Wa2)
                          continue;
                        return { value: Cf2.arg, done: pa2.done };
                      } else
                        Cf2.type === "throw" && (hs = _i, pa2.method = "throw", pa2.arg = Cf2.arg);
                    }
                  };
                }
                function Wo(Ga2, ha2) {
                  var pa2 = Ga2.iterator[ha2.method];
                  if (pa2 === se2) {
                    if (ha2.delegate = null, ha2.method === "throw") {
                      if (Ga2.iterator.return && (ha2.method = "return", ha2.arg = se2, Wo(Ga2, ha2), ha2.method === "throw"))
                        return Wa2;
                      ha2.method = "throw", ha2.arg = new TypeError("The iterator does not provide a 'throw' method");
                    }
                    return Wa2;
                  }
                  var hs = Rr(pa2, Ga2.iterator, ha2.arg);
                  if (hs.type === "throw")
                    return ha2.method = "throw", ha2.arg = hs.arg, ha2.delegate = null, Wa2;
                  var Zo = hs.arg;
                  if (!Zo)
                    return ha2.method = "throw", ha2.arg = new TypeError("iterator result is not an object"), ha2.delegate = null, Wa2;
                  if (Zo.done)
                    ha2[Ga2.resultName] = Zo.value, ha2.next = Ga2.nextLoc, ha2.method !== "return" && (ha2.method = "next", ha2.arg = se2);
                  else
                    return Zo;
                  return ha2.delegate = null, Wa2;
                }
                Fi2(Da2), yn(Da2, dn, "Generator"), yn(Da2, He2, function() {
                  return this;
                }), yn(Da2, "toString", function() {
                  return "[object Generator]";
                });
                function Ii2(Ga2) {
                  var ha2 = { tryLoc: Ga2[0] };
                  1 in Ga2 && (ha2.catchLoc = Ga2[1]), 2 in Ga2 && (ha2.finallyLoc = Ga2[2], ha2.afterLoc = Ga2[3]), this.tryEntries.push(ha2);
                }
                function _l(Ga2) {
                  var ha2 = Ga2.completion || {};
                  ha2.type = "normal", delete ha2.arg, Ga2.completion = ha2;
                }
                function yl(Ga2) {
                  this.tryEntries = [{ tryLoc: "root" }], Ga2.forEach(Ii2, this), this.reset(true);
                }
                Ut.keys = function(Ga2) {
                  var ha2 = [];
                  for (var pa2 in Ga2)
                    ha2.push(pa2);
                  return ha2.reverse(), function hs() {
                    for (; ha2.length; ) {
                      var Zo = ha2.pop();
                      if (Zo in Ga2)
                        return hs.value = Zo, hs.done = false, hs;
                    }
                    return hs.done = true, hs;
                  };
                };
                function Ra2(Ga2) {
                  if (Ga2) {
                    var ha2 = Ga2[He2];
                    if (ha2)
                      return ha2.call(Ga2);
                    if (typeof Ga2.next == "function")
                      return Ga2;
                    if (!isNaN(Ga2.length)) {
                      var pa2 = -1, hs = function Zo() {
                        for (; ++pa2 < Ga2.length; )
                          if (Yt.call(Ga2, pa2))
                            return Zo.value = Ga2[pa2], Zo.done = false, Zo;
                        return Zo.value = se2, Zo.done = true, Zo;
                      };
                      return hs.next = hs;
                    }
                  }
                  return { next: Su };
                }
                Ut.values = Ra2;
                function Su() {
                  return { value: se2, done: true };
                }
                return yl.prototype = { constructor: yl, reset: function(Ga2) {
                  if (this.prev = 0, this.next = 0, this.sent = this._sent = se2, this.done = false, this.delegate = null, this.method = "next", this.arg = se2, this.tryEntries.forEach(_l), !Ga2)
                    for (var ha2 in this)
                      ha2.charAt(0) === "t" && Yt.call(this, ha2) && !isNaN(+ha2.slice(1)) && (this[ha2] = se2);
                }, stop: function() {
                  this.done = true;
                  var Ga2 = this.tryEntries[0], ha2 = Ga2.completion;
                  if (ha2.type === "throw")
                    throw ha2.arg;
                  return this.rval;
                }, dispatchException: function(Ga2) {
                  if (this.done)
                    throw Ga2;
                  var ha2 = this;
                  function pa2(Cf2, Gd2) {
                    return rc2.type = "throw", rc2.arg = Ga2, ha2.next = Cf2, Gd2 && (ha2.method = "next", ha2.arg = se2), !!Gd2;
                  }
                  for (var hs = this.tryEntries.length - 1; hs >= 0; --hs) {
                    var Zo = this.tryEntries[hs], rc2 = Zo.completion;
                    if (Zo.tryLoc === "root")
                      return pa2("end");
                    if (Zo.tryLoc <= this.prev) {
                      var ep = Yt.call(Zo, "catchLoc"), mh2 = Yt.call(Zo, "finallyLoc");
                      if (ep && mh2) {
                        if (this.prev < Zo.catchLoc)
                          return pa2(Zo.catchLoc, true);
                        if (this.prev < Zo.finallyLoc)
                          return pa2(Zo.finallyLoc);
                      } else if (ep) {
                        if (this.prev < Zo.catchLoc)
                          return pa2(Zo.catchLoc, true);
                      } else if (mh2) {
                        if (this.prev < Zo.finallyLoc)
                          return pa2(Zo.finallyLoc);
                      } else
                        throw new Error("try statement without catch or finally");
                    }
                  }
                }, abrupt: function(Ga2, ha2) {
                  for (var pa2 = this.tryEntries.length - 1; pa2 >= 0; --pa2) {
                    var hs = this.tryEntries[pa2];
                    if (hs.tryLoc <= this.prev && Yt.call(hs, "finallyLoc") && this.prev < hs.finallyLoc) {
                      var Zo = hs;
                      break;
                    }
                  }
                  Zo && (Ga2 === "break" || Ga2 === "continue") && Zo.tryLoc <= ha2 && ha2 <= Zo.finallyLoc && (Zo = null);
                  var rc2 = Zo ? Zo.completion : {};
                  return rc2.type = Ga2, rc2.arg = ha2, Zo ? (this.method = "next", this.next = Zo.finallyLoc, Wa2) : this.complete(rc2);
                }, complete: function(Ga2, ha2) {
                  if (Ga2.type === "throw")
                    throw Ga2.arg;
                  return Ga2.type === "break" || Ga2.type === "continue" ? this.next = Ga2.arg : Ga2.type === "return" ? (this.rval = this.arg = Ga2.arg, this.method = "return", this.next = "end") : Ga2.type === "normal" && ha2 && (this.next = ha2), Wa2;
                }, finish: function(Ga2) {
                  for (var ha2 = this.tryEntries.length - 1; ha2 >= 0; --ha2) {
                    var pa2 = this.tryEntries[ha2];
                    if (pa2.finallyLoc === Ga2)
                      return this.complete(pa2.completion, pa2.afterLoc), _l(pa2), Wa2;
                  }
                }, catch: function(Ga2) {
                  for (var ha2 = this.tryEntries.length - 1; ha2 >= 0; --ha2) {
                    var pa2 = this.tryEntries[ha2];
                    if (pa2.tryLoc === Ga2) {
                      var hs = pa2.completion;
                      if (hs.type === "throw") {
                        var Zo = hs.arg;
                        _l(pa2);
                      }
                      return Zo;
                    }
                  }
                  throw new Error("illegal catch attempt");
                }, delegateYield: function(Ga2, ha2, pa2) {
                  return this.delegate = { iterator: Ra2(Ga2), resultName: ha2, nextLoc: pa2 }, this.method === "next" && (this.arg = se2), Wa2;
                } }, Ut;
              }(Vt.exports);
              try {
                regeneratorRuntime = ve2;
              } catch {
                typeof globalThis == "object" ? globalThis.regeneratorRuntime = ve2 : Function("r", "regeneratorRuntime = r")(ve2);
              }
            })(ZQ);
            var o_ = ZQ.exports;
            function Wc2(Vt, ve2, Ut, $t, Yt, se2, Re2) {
              try {
                var He2 = Vt[se2](Re2), nn = He2.value;
              } catch (dn) {
                Ut(dn);
                return;
              }
              He2.done ? ve2(nn) : Promise.resolve(nn).then($t, Yt);
            }
            function CT(Vt) {
              return function() {
                var ve2 = this, Ut = arguments;
                return new Promise(function($t, Yt) {
                  var se2 = Vt.apply(ve2, Ut);
                  function Re2(nn) {
                    Wc2(se2, $t, Yt, Re2, He2, "next", nn);
                  }
                  function He2(nn) {
                    Wc2(se2, $t, Yt, Re2, He2, "throw", nn);
                  }
                  Re2(void 0);
                });
              };
            }
            function ri2() {
              return ri2 = Object.assign || function(Vt) {
                for (var ve2 = 1; ve2 < arguments.length; ve2++) {
                  var Ut = arguments[ve2];
                  for (var $t in Ut)
                    Object.prototype.hasOwnProperty.call(Ut, $t) && (Vt[$t] = Ut[$t]);
                }
                return Vt;
              }, ri2.apply(this, arguments);
            }
            function va(Vt, ve2) {
              Vt.prototype = Object.create(ve2.prototype), Vt.prototype.constructor = Vt, Zs(Vt, ve2);
            }
            function ya2(Vt) {
              return ya2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(ve2) {
                return ve2.__proto__ || Object.getPrototypeOf(ve2);
              }, ya2(Vt);
            }
            function Zs(Vt, ve2) {
              return Zs = Object.setPrototypeOf || function(Ut, $t) {
                return Ut.__proto__ = $t, Ut;
              }, Zs(Vt, ve2);
            }
            function Gc2() {
              if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                return false;
              if (typeof Proxy == "function")
                return true;
              try {
                return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
                })), true;
              } catch {
                return false;
              }
            }
            function pp(Vt, ve2, Ut) {
              return Gc2() ? pp = Reflect.construct : pp = function($t, Yt, se2) {
                var Re2 = [null];
                Re2.push.apply(Re2, Yt);
                var He2 = Function.bind.apply($t, Re2), nn = new He2();
                return se2 && Zs(nn, se2.prototype), nn;
              }, pp.apply(null, arguments);
            }
            function ly(Vt) {
              return Function.toString.call(Vt).indexOf("[native code]") !== -1;
            }
            function bd2(Vt) {
              var ve2 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
              return bd2 = function(Ut) {
                if (Ut === null || !ly(Ut))
                  return Ut;
                if (typeof Ut != "function")
                  throw new TypeError("Super expression must either be null or a function");
                if (typeof ve2 != "undefined") {
                  if (ve2.has(Ut))
                    return ve2.get(Ut);
                  ve2.set(Ut, $t);
                }
                function $t() {
                  return pp(Ut, arguments, ya2(this).constructor);
                }
                return $t.prototype = Object.create(Ut.prototype, { constructor: { value: $t, enumerable: false, writable: true, configurable: true } }), Zs($t, Ut);
              }, bd2(Vt);
            }
            var kG = /%[sdj%]/g, PG = function() {
            };
            typeof process != "undefined" && process.env;
            function s_(Vt) {
              if (!Vt || !Vt.length)
                return null;
              var ve2 = {};
              return Vt.forEach(function(Ut) {
                var $t = Ut.field;
                ve2[$t] = ve2[$t] || [], ve2[$t].push(Ut);
              }), ve2;
            }
            function rv(Vt) {
              for (var ve2 = arguments.length, Ut = new Array(ve2 > 1 ? ve2 - 1 : 0), $t = 1; $t < ve2; $t++)
                Ut[$t - 1] = arguments[$t];
              var Yt = 0, se2 = Ut.length;
              if (typeof Vt == "function")
                return Vt.apply(null, Ut);
              if (typeof Vt == "string") {
                var Re2 = Vt.replace(kG, function(He2) {
                  if (He2 === "%%")
                    return "%";
                  if (Yt >= se2)
                    return He2;
                  switch (He2) {
                    case "%s":
                      return String(Ut[Yt++]);
                    case "%d":
                      return Number(Ut[Yt++]);
                    case "%j":
                      try {
                        return JSON.stringify(Ut[Yt++]);
                      } catch {
                        return "[Circular]";
                      }
                      break;
                    default:
                      return He2;
                  }
                });
                return Re2;
              }
              return Vt;
            }
            function $Q(Vt) {
              return Vt === "string" || Vt === "url" || Vt === "hex" || Vt === "email" || Vt === "date" || Vt === "pattern";
            }
            function Wd2(Vt, ve2) {
              return !!(Vt == null || ve2 === "array" && Array.isArray(Vt) && !Vt.length || $Q(ve2) && typeof Vt == "string" && !Vt);
            }
            function ng2(Vt, ve2, Ut) {
              var $t = [], Yt = 0, se2 = Vt.length;
              function Re2(He2) {
                $t.push.apply($t, He2 || []), Yt++, Yt === se2 && Ut($t);
              }
              Vt.forEach(function(He2) {
                ve2(He2, Re2);
              });
            }
            function rg2(Vt, ve2, Ut) {
              var $t = 0, Yt = Vt.length;
              function se2(Re2) {
                if (Re2 && Re2.length) {
                  Ut(Re2);
                  return;
                }
                var He2 = $t;
                $t = $t + 1, He2 < Yt ? ve2(Vt[He2], se2) : Ut([]);
              }
              se2([]);
            }
            function sd2(Vt) {
              var ve2 = [];
              return Object.keys(Vt).forEach(function(Ut) {
                ve2.push.apply(ve2, Vt[Ut] || []);
              }), ve2;
            }
            var YQ = function(Vt) {
              va(ve2, Vt);
              function ve2(Ut, $t) {
                var Yt;
                return Yt = Vt.call(this, "Async Validation Error") || this, Yt.errors = Ut, Yt.fields = $t, Yt;
              }
              return ve2;
            }(bd2(Error));
            function KQ(Vt, ve2, Ut, $t, Yt) {
              if (ve2.first) {
                var se2 = new Promise(function(Rr, Ur) {
                  var Hr = function(_i) {
                    return $t(_i), _i.length ? Ur(new YQ(_i, s_(_i))) : Rr(Yt);
                  }, si2 = sd2(Vt);
                  rg2(si2, Ut, Hr);
                });
                return se2.catch(function(Rr) {
                  return Rr;
                }), se2;
              }
              var Re2 = ve2.firstFields === true ? Object.keys(Vt) : ve2.firstFields || [], He2 = Object.keys(Vt), nn = He2.length, dn = 0, yn = [], Yn = new Promise(function(Rr, Ur) {
                var Hr = function(si2) {
                  if (yn.push.apply(yn, si2), dn++, dn === nn)
                    return $t(yn), yn.length ? Ur(new YQ(yn, s_(yn))) : Rr(Yt);
                };
                He2.length || ($t(yn), Rr(Yt)), He2.forEach(function(si2) {
                  var _i = Vt[si2];
                  Re2.indexOf(si2) !== -1 ? rg2(_i, Ut, Hr) : ng2(_i, Ut, Hr);
                });
              });
              return Yn.catch(function(Rr) {
                return Rr;
              }), Yn;
            }
            function U9(Vt) {
              return !!(Vt && Vt.message !== void 0);
            }
            function Dht(Vt, ve2) {
              for (var Ut = Vt, $t = 0; $t < ve2.length; $t++) {
                if (Ut == null)
                  return Ut;
                Ut = Ut[ve2[$t]];
              }
              return Ut;
            }
            function XQ(Vt, ve2) {
              return function(Ut) {
                var $t;
                return Vt.fullFields ? $t = Dht(ve2, Vt.fullFields) : $t = ve2[Ut.field || Vt.fullField], U9(Ut) ? (Ut.field = Ut.field || Vt.fullField, Ut.fieldValue = $t, Ut) : { message: typeof Ut == "function" ? Ut() : Ut, fieldValue: $t, field: Ut.field || Vt.fullField };
              };
            }
            function QQ(Vt, ve2) {
              if (ve2) {
                for (var Ut in ve2)
                  if (ve2.hasOwnProperty(Ut)) {
                    var $t = ve2[Ut];
                    typeof $t == "object" && typeof Vt[Ut] == "object" ? Vt[Ut] = ri2({}, Vt[Ut], $t) : Vt[Ut] = $t;
                  }
              }
              return Vt;
            }
            var eL = function(Vt, ve2, Ut, $t, Yt, se2) {
              Vt.required && (!Ut.hasOwnProperty(Vt.field) || Wd2(ve2, se2 || Vt.type)) && $t.push(rv(Yt.messages.required, Vt.fullField));
            }, sS = function(Vt, ve2, Ut, $t, Yt) {
              (/^\s+$/.test(ve2) || ve2 === "") && $t.push(rv(Yt.messages.whitespace, Vt.fullField));
            }, TD = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, nL = { integer: function(Vt) {
              return nL.number(Vt) && parseInt(Vt, 10) === Vt;
            }, float: function(Vt) {
              return nL.number(Vt) && !nL.integer(Vt);
            }, array: function(Vt) {
              return Array.isArray(Vt);
            }, regexp: function(Vt) {
              if (Vt instanceof RegExp)
                return true;
              try {
                return !!new RegExp(Vt);
              } catch {
                return false;
              }
            }, date: function(Vt) {
              return typeof Vt.getTime == "function" && typeof Vt.getMonth == "function" && typeof Vt.getYear == "function" && !isNaN(Vt.getTime());
            }, number: function(Vt) {
              return isNaN(Vt) ? false : typeof Vt == "number";
            }, object: function(Vt) {
              return typeof Vt == "object" && !nL.array(Vt);
            }, method: function(Vt) {
              return typeof Vt == "function";
            }, email: function(Vt) {
              return typeof Vt == "string" && Vt.length <= 320 && !!Vt.match(TD.email);
            }, url: function(Vt) {
              return typeof Vt == "string" && Vt.length <= 2048 && !!Vt.match(TD.url);
            }, hex: function(Vt) {
              return typeof Vt == "string" && !!Vt.match(TD.hex);
            } }, s6 = function(Vt, ve2, Ut, $t, Yt) {
              if (Vt.required && ve2 === void 0) {
                eL(Vt, ve2, Ut, $t, Yt);
                return;
              }
              var se2 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], Re2 = Vt.type;
              se2.indexOf(Re2) > -1 ? nL[Re2](ve2) || $t.push(rv(Yt.messages.types[Re2], Vt.fullField, Vt.type)) : Re2 && typeof ve2 !== Vt.type && $t.push(rv(Yt.messages.types[Re2], Vt.fullField, Vt.type));
            }, l6 = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = typeof Vt.len == "number", Re2 = typeof Vt.min == "number", He2 = typeof Vt.max == "number", nn = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, dn = ve2, yn = null, Yn = typeof ve2 == "number", Rr = typeof ve2 == "string", Ur = Array.isArray(ve2);
              if (Yn ? yn = "number" : Rr ? yn = "string" : Ur && (yn = "array"), !yn)
                return false;
              Ur && (dn = ve2.length), Rr && (dn = ve2.replace(nn, "_").length), se2 ? dn !== Vt.len && $t.push(rv(Yt.messages[yn].len, Vt.fullField, Vt.len)) : Re2 && !He2 && dn < Vt.min ? $t.push(rv(Yt.messages[yn].min, Vt.fullField, Vt.min)) : He2 && !Re2 && dn > Vt.max ? $t.push(rv(Yt.messages[yn].max, Vt.fullField, Vt.max)) : Re2 && He2 && (dn < Vt.min || dn > Vt.max) && $t.push(rv(Yt.messages[yn].range, Vt.fullField, Vt.min, Vt.max));
            }, uy = "enum", TT = function(Vt, ve2, Ut, $t, Yt) {
              Vt[uy] = Array.isArray(Vt[uy]) ? Vt[uy] : [], Vt[uy].indexOf(ve2) === -1 && $t.push(rv(Yt.messages[uy], Vt.fullField, Vt[uy].join(", ")));
            }, JQ = function(Vt, ve2, Ut, $t, Yt) {
              if (Vt.pattern) {
                if (Vt.pattern instanceof RegExp)
                  Vt.pattern.lastIndex = 0, Vt.pattern.test(ve2) || $t.push(rv(Yt.messages.pattern.mismatch, Vt.fullField, ve2, Vt.pattern));
                else if (typeof Vt.pattern == "string") {
                  var se2 = new RegExp(Vt.pattern);
                  se2.test(ve2) || $t.push(rv(Yt.messages.pattern.mismatch, Vt.fullField, ve2, Vt.pattern));
                }
              }
            }, Lf2 = { required: eL, whitespace: sS, type: s6, range: l6, enum: TT, pattern: JQ }, Xk = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2, "string") && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt, "string"), Wd2(ve2, "string") || (Lf2.type(Vt, ve2, $t, se2, Yt), Lf2.range(Vt, ve2, $t, se2, Yt), Lf2.pattern(Vt, ve2, $t, se2, Yt), Vt.whitespace === true && Lf2.whitespace(Vt, ve2, $t, se2, Yt));
              }
              Ut(se2);
            }, q9 = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), ve2 !== void 0 && Lf2.type(Vt, ve2, $t, se2, Yt);
              }
              Ut(se2);
            }, Eht = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (ve2 === "" && (ve2 = void 0), Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), ve2 !== void 0 && (Lf2.type(Vt, ve2, $t, se2, Yt), Lf2.range(Vt, ve2, $t, se2, Yt));
              }
              Ut(se2);
            }, tJ = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), ve2 !== void 0 && Lf2.type(Vt, ve2, $t, se2, Yt);
              }
              Ut(se2);
            }, AT = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), Wd2(ve2) || Lf2.type(Vt, ve2, $t, se2, Yt);
              }
              Ut(se2);
            }, Hc2 = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), ve2 !== void 0 && (Lf2.type(Vt, ve2, $t, se2, Yt), Lf2.range(Vt, ve2, $t, se2, Yt));
              }
              Ut(se2);
            }, u6 = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), ve2 !== void 0 && (Lf2.type(Vt, ve2, $t, se2, Yt), Lf2.range(Vt, ve2, $t, se2, Yt));
              }
              Ut(se2);
            }, l_ = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (ve2 == null && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt, "array"), ve2 != null && (Lf2.type(Vt, ve2, $t, se2, Yt), Lf2.range(Vt, ve2, $t, se2, Yt));
              }
              Ut(se2);
            }, eJ = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), ve2 !== void 0 && Lf2.type(Vt, ve2, $t, se2, Yt);
              }
              Ut(se2);
            }, nJ = "enum", ld2 = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), ve2 !== void 0 && Lf2[nJ](Vt, ve2, $t, se2, Yt);
              }
              Ut(se2);
            }, kht = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2, "string") && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt), Wd2(ve2, "string") || Lf2.pattern(Vt, ve2, $t, se2, Yt);
              }
              Ut(se2);
            }, R0 = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2, "date") && !Vt.required)
                  return Ut();
                if (Lf2.required(Vt, ve2, $t, se2, Yt), !Wd2(ve2, "date")) {
                  var He2;
                  ve2 instanceof Date ? He2 = ve2 : He2 = new Date(ve2), Lf2.type(Vt, He2, $t, se2, Yt), He2 && Lf2.range(Vt, He2.getTime(), $t, se2, Yt);
                }
              }
              Ut(se2);
            }, cy = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Array.isArray(ve2) ? "array" : typeof ve2;
              Lf2.required(Vt, ve2, $t, se2, Yt, Re2), Ut(se2);
            }, LG = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = Vt.type, Re2 = [], He2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (He2) {
                if (Wd2(ve2, se2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, Re2, Yt, se2), Wd2(ve2, se2) || Lf2.type(Vt, ve2, $t, Re2, Yt);
              }
              Ut(Re2);
            }, Pht = function(Vt, ve2, Ut, $t, Yt) {
              var se2 = [], Re2 = Vt.required || !Vt.required && $t.hasOwnProperty(Vt.field);
              if (Re2) {
                if (Wd2(ve2) && !Vt.required)
                  return Ut();
                Lf2.required(Vt, ve2, $t, se2, Yt);
              }
              Ut(se2);
            }, rL = { string: Xk, method: q9, number: Eht, boolean: tJ, regexp: AT, integer: Hc2, float: u6, array: l_, object: eJ, enum: ld2, pattern: kht, date: R0, url: LG, hex: LG, email: LG, required: cy, any: Pht };
            function OG() {
              return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
                var Vt = JSON.parse(JSON.stringify(this));
                return Vt.clone = this.clone, Vt;
              } };
            }
            var c6 = OG(), IT = function() {
              function Vt(Ut) {
                this.rules = null, this._messages = c6, this.define(Ut);
              }
              var ve2 = Vt.prototype;
              return ve2.define = function(Ut) {
                var $t = this;
                if (!Ut)
                  throw new Error("Cannot configure a schema with no rules");
                if (typeof Ut != "object" || Array.isArray(Ut))
                  throw new Error("Rules must be an object");
                this.rules = {}, Object.keys(Ut).forEach(function(Yt) {
                  var se2 = Ut[Yt];
                  $t.rules[Yt] = Array.isArray(se2) ? se2 : [se2];
                });
              }, ve2.messages = function(Ut) {
                return Ut && (this._messages = QQ(OG(), Ut)), this._messages;
              }, ve2.validate = function(Ut, $t, Yt) {
                var se2 = this;
                $t === void 0 && ($t = {}), Yt === void 0 && (Yt = function() {
                });
                var Re2 = Ut, He2 = $t, nn = Yt;
                if (typeof He2 == "function" && (nn = He2, He2 = {}), !this.rules || Object.keys(this.rules).length === 0)
                  return nn && nn(null, Re2), Promise.resolve(Re2);
                function dn(Hr) {
                  var si2 = [], _i = {};
                  function Wa2(ts) {
                    if (Array.isArray(ts)) {
                      var on;
                      si2 = (on = si2).concat.apply(on, ts);
                    } else
                      si2.push(ts);
                  }
                  for (var Ia2 = 0; Ia2 < Hr.length; Ia2++)
                    Wa2(Hr[Ia2]);
                  si2.length ? (_i = s_(si2), nn(si2, _i)) : nn(null, Re2);
                }
                if (He2.messages) {
                  var yn = this.messages();
                  yn === c6 && (yn = OG()), QQ(yn, He2.messages), He2.messages = yn;
                } else
                  He2.messages = this.messages();
                var Yn = {}, Rr = He2.keys || Object.keys(this.rules);
                Rr.forEach(function(Hr) {
                  var si2 = se2.rules[Hr], _i = Re2[Hr];
                  si2.forEach(function(Wa2) {
                    var Ia2 = Wa2;
                    typeof Ia2.transform == "function" && (Re2 === Ut && (Re2 = ri2({}, Re2)), _i = Re2[Hr] = Ia2.transform(_i)), typeof Ia2 == "function" ? Ia2 = { validator: Ia2 } : Ia2 = ri2({}, Ia2), Ia2.validator = se2.getValidationMethod(Ia2), Ia2.validator && (Ia2.field = Hr, Ia2.fullField = Ia2.fullField || Hr, Ia2.type = se2.getType(Ia2), Yn[Hr] = Yn[Hr] || [], Yn[Hr].push({ rule: Ia2, value: _i, source: Re2, field: Hr }));
                  });
                });
                var Ur = {};
                return KQ(Yn, He2, function(Hr, si2) {
                  var _i = Hr.rule, Wa2 = (_i.type === "object" || _i.type === "array") && (typeof _i.fields == "object" || typeof _i.defaultField == "object");
                  Wa2 = Wa2 && (_i.required || !_i.required && Hr.value), _i.field = Hr.field;
                  function Ia2(di2, Yi2) {
                    return ri2({}, Yi2, { fullField: _i.fullField + "." + di2, fullFields: _i.fullFields ? [].concat(_i.fullFields, [di2]) : [di2] });
                  }
                  function ts(di2) {
                    di2 === void 0 && (di2 = []);
                    var Yi2 = Array.isArray(di2) ? di2 : [di2];
                    !He2.suppressWarning && Yi2.length && Vt.warning("async-validator:", Yi2), Yi2.length && _i.message !== void 0 && (Yi2 = [].concat(_i.message));
                    var Oa2 = Yi2.map(XQ(_i, Re2));
                    if (He2.first && Oa2.length)
                      return Ur[_i.field] = 1, si2(Oa2);
                    if (!Wa2)
                      si2(Oa2);
                    else {
                      if (_i.required && !Hr.value)
                        return _i.message !== void 0 ? Oa2 = [].concat(_i.message).map(XQ(_i, Re2)) : He2.error && (Oa2 = [He2.error(_i, rv(He2.messages.required, _i.field))]), si2(Oa2);
                      var Da2 = {};
                      _i.defaultField && Object.keys(Hr.value).map(function(ro) {
                        Da2[ro] = _i.defaultField;
                      }), Da2 = ri2({}, Da2, Hr.rule.fields);
                      var Fi2 = {};
                      Object.keys(Da2).forEach(function(ro) {
                        var Wo = Da2[ro], Ii2 = Array.isArray(Wo) ? Wo : [Wo];
                        Fi2[ro] = Ii2.map(Ia2.bind(null, ro));
                      });
                      var Qi2 = new Vt(Fi2);
                      Qi2.messages(He2.messages), Hr.rule.options && (Hr.rule.options.messages = He2.messages, Hr.rule.options.error = He2.error), Qi2.validate(Hr.value, Hr.rule.options || He2, function(ro) {
                        var Wo = [];
                        Oa2 && Oa2.length && Wo.push.apply(Wo, Oa2), ro && ro.length && Wo.push.apply(Wo, ro), si2(Wo.length ? Wo : null);
                      });
                    }
                  }
                  var on;
                  _i.asyncValidator ? on = _i.asyncValidator(_i, Hr.value, ts, Hr.source, He2) : _i.validator && (on = _i.validator(_i, Hr.value, ts, Hr.source, He2), on === true ? ts() : on === false ? ts(typeof _i.message == "function" ? _i.message(_i.fullField || _i.field) : _i.message || (_i.fullField || _i.field) + " fails") : on instanceof Array ? ts(on) : on instanceof Error && ts(on.message)), on && on.then && on.then(function() {
                    return ts();
                  }, function(di2) {
                    return ts(di2);
                  });
                }, function(Hr) {
                  dn(Hr);
                }, Re2);
              }, ve2.getType = function(Ut) {
                if (Ut.type === void 0 && Ut.pattern instanceof RegExp && (Ut.type = "pattern"), typeof Ut.validator != "function" && Ut.type && !rL.hasOwnProperty(Ut.type))
                  throw new Error(rv("Unknown rule type %s", Ut.type));
                return Ut.type || "string";
              }, ve2.getValidationMethod = function(Ut) {
                if (typeof Ut.validator == "function")
                  return Ut.validator;
                var $t = Object.keys(Ut), Yt = $t.indexOf("message");
                return Yt !== -1 && $t.splice(Yt, 1), $t.length === 1 && $t[0] === "required" ? rL.required : rL[this.getType(Ut)] || void 0;
              }, Vt;
            }();
            IT.register = function(Vt, ve2) {
              if (typeof ve2 != "function")
                throw new Error("Cannot register a validator by type, validator is not a function");
              rL[Vt] = ve2;
            }, IT.warning = PG, IT.messages = c6, IT.validators = rL;
            var eb2 = "'${name}' is not a valid ${type}", Qk = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: eb2, method: eb2, array: eb2, object: eb2, number: eb2, date: eb2, boolean: eb2, integer: eb2, float: eb2, regexp: eb2, email: eb2, url: eb2, hex: eb2 }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
            function iL(Vt, ve2) {
              for (var Ut = Vt, $t = 0; $t < ve2.length; $t += 1) {
                if (Ut == null)
                  return;
                Ut = Ut[ve2[$t]];
              }
              return Ut;
            }
            function f6(Vt) {
              return sr(Vt) || qQ(Vt) || qa2(Vt) || wa2();
            }
            function h6(Vt, ve2, Ut, $t) {
              if (!ve2.length)
                return Ut;
              var Yt = f6(ve2), se2 = Yt[0], Re2 = Yt.slice(1), He2;
              return !Vt && typeof se2 == "number" ? He2 = [] : Array.isArray(Vt) ? He2 = Pf2(Vt) : He2 = gn({}, Vt), $t && Ut === void 0 && Re2.length === 1 ? delete He2[se2][Re2[0]] : He2[se2] = h6(He2[se2], Re2, Ut, $t), He2;
            }
            function aL(Vt, ve2, Ut) {
              var $t = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
              return ve2.length && $t && Ut === void 0 && !iL(Vt, ve2.slice(0, -1)) ? Vt : h6(Vt, ve2, Ut, $t);
            }
            function N0(Vt) {
              return EG(Vt);
            }
            function AD(Vt, ve2) {
              var Ut = iL(Vt, ve2);
              return Ut;
            }
            function Jk(Vt, ve2, Ut) {
              var $t = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, Yt = aL(Vt, ve2, Ut, $t);
              return Yt;
            }
            function Z9(Vt, ve2) {
              var Ut = {};
              return ve2.forEach(function($t) {
                var Yt = AD(Vt, $t);
                Ut = Jk(Ut, $t, Yt);
              }), Ut;
            }
            function p6(Vt, ve2) {
              return Vt && Vt.some(function(Ut) {
                return Sn(Ut, ve2);
              });
            }
            function d6(Vt) {
              return Vc2(Vt) === "object" && Vt !== null && Object.getPrototypeOf(Vt) === Object.prototype;
            }
            function oL(Vt, ve2) {
              var Ut = Array.isArray(Vt) ? Pf2(Vt) : gn({}, Vt);
              return ve2 && Object.keys(ve2).forEach(function($t) {
                var Yt = Ut[$t], se2 = ve2[$t], Re2 = d6(Yt) && d6(se2);
                Ut[$t] = Re2 ? oL(Yt, se2 || {}) : se2;
              }), Ut;
            }
            function Zv(Vt) {
              for (var ve2 = arguments.length, Ut = new Array(ve2 > 1 ? ve2 - 1 : 0), $t = 1; $t < ve2; $t++)
                Ut[$t - 1] = arguments[$t];
              return Ut.reduce(function(Yt, se2) {
                return oL(Yt, se2);
              }, Vt);
            }
            function Sn(Vt, ve2) {
              return !Vt || !ve2 || Vt.length !== ve2.length ? false : Vt.every(function(Ut, $t) {
                return ve2[$t] === Ut;
              });
            }
            function sL(Vt, ve2) {
              if (Vt === ve2)
                return true;
              if (!Vt && ve2 || Vt && !ve2 || !Vt || !ve2 || Vc2(Vt) !== "object" || Vc2(ve2) !== "object")
                return false;
              var Ut = Object.keys(Vt), $t = Object.keys(ve2), Yt = new Set([].concat(Pf2(Ut), Pf2($t)));
              return Pf2(Yt).every(function(se2) {
                var Re2 = Vt[se2], He2 = ve2[se2];
                return typeof Re2 == "function" && typeof He2 == "function" ? true : Re2 === He2;
              });
            }
            function $9(Vt) {
              var ve2 = arguments.length <= 1 ? void 0 : arguments[1];
              return ve2 && ve2.target && Vc2(ve2.target) === "object" && Vt in ve2.target ? ve2.target[Vt] : ve2;
            }
            function Lx(Vt, ve2, Ut) {
              var $t = Vt.length;
              if (ve2 < 0 || ve2 >= $t || Ut < 0 || Ut >= $t)
                return Vt;
              var Yt = Vt[ve2], se2 = ve2 - Ut;
              return se2 > 0 ? [].concat(Pf2(Vt.slice(0, Ut)), [Yt], Pf2(Vt.slice(Ut, ve2)), Pf2(Vt.slice(ve2 + 1, $t))) : se2 < 0 ? [].concat(Pf2(Vt.slice(0, ve2)), Pf2(Vt.slice(ve2 + 1, Ut + 1)), [Yt], Pf2(Vt.slice(Ut + 1, $t))) : Vt;
            }
            var yh2 = IT;
            function Lht(Vt, ve2) {
              return Vt.replace(/\$\{\w+\}/g, function(Ut) {
                var $t = Ut.slice(2, -1);
                return ve2[$t];
              });
            }
            function RG(Vt, ve2, Ut, $t, Yt) {
              return NG.apply(this, arguments);
            }
            function NG() {
              return NG = CT(o_.mark(function Vt(ve2, Ut, $t, Yt, se2) {
                var Re2, He2, nn, dn, yn, Yn, Rr, Ur;
                return o_.wrap(function(Hr) {
                  for (; ; )
                    switch (Hr.prev = Hr.next) {
                      case 0:
                        return Re2 = gn({}, $t), delete Re2.ruleIndex, He2 = null, Re2 && Re2.type === "array" && Re2.defaultField && (He2 = Re2.defaultField, delete Re2.defaultField), nn = new yh2(ir({}, ve2, [Re2])), dn = Zv({}, Qk, Yt.validateMessages), nn.messages(dn), yn = [], Hr.prev = 8, Hr.next = 11, Promise.resolve(nn.validate(ir({}, ve2, Ut), gn({}, Yt)));
                      case 11:
                        Hr.next = 16;
                        break;
                      case 13:
                        Hr.prev = 13, Hr.t0 = Hr.catch(8), Hr.t0.errors ? yn = Hr.t0.errors.map(function(si2, _i) {
                          var Wa2 = si2.message;
                          return Ve.isValidElement(Wa2) ? Ve.cloneElement(Wa2, { key: "error_".concat(_i) }) : Wa2;
                        }) : (console.error(Hr.t0), yn = [dn.default]);
                      case 16:
                        if (!(!yn.length && He2)) {
                          Hr.next = 21;
                          break;
                        }
                        return Hr.next = 19, Promise.all(Ut.map(function(si2, _i) {
                          return RG("".concat(ve2, ".").concat(_i), si2, He2, Yt, se2);
                        }));
                      case 19:
                        return Yn = Hr.sent, Hr.abrupt("return", Yn.reduce(function(si2, _i) {
                          return [].concat(Pf2(si2), Pf2(_i));
                        }, []));
                      case 21:
                        return Rr = gn(gn({}, $t), {}, { name: ve2, enum: ($t.enum || []).join(", ") }, se2), Ur = yn.map(function(si2) {
                          return typeof si2 == "string" ? Lht(si2, Rr) : si2;
                        }), Hr.abrupt("return", Ur);
                      case 24:
                      case "end":
                        return Hr.stop();
                    }
                }, Vt, null, [[8, 13]]);
              })), NG.apply(this, arguments);
            }
            function ID(Vt, ve2, Ut, $t, Yt, se2) {
              var Re2 = Vt.join("."), He2 = Ut.map(function(yn, Yn) {
                var Rr = yn.validator, Ur = gn(gn({}, yn), {}, { ruleIndex: Yn });
                return Rr && (Ur.validator = function(Hr, si2, _i) {
                  var Wa2 = false, Ia2 = function() {
                    for (var on = arguments.length, di2 = new Array(on), Yi2 = 0; Yi2 < on; Yi2++)
                      di2[Yi2] = arguments[Yi2];
                    Promise.resolve().then(function() {
                      iS(!Wa2, "Your validator function has already return a promise. `callback` will be ignored."), Wa2 || _i.apply(void 0, di2);
                    });
                  }, ts = Rr(Hr, si2, Ia2);
                  Wa2 = ts && typeof ts.then == "function" && typeof ts.catch == "function", iS(Wa2, "`callback` is deprecated. Please return a promise instead."), Wa2 && ts.then(function() {
                    _i();
                  }).catch(function(on) {
                    _i(on || " ");
                  });
                }), Ur;
              }).sort(function(yn, Yn) {
                var Rr = yn.warningOnly, Ur = yn.ruleIndex, Hr = Yn.warningOnly, si2 = Yn.ruleIndex;
                return !!Rr == !!Hr ? Ur - si2 : Rr ? 1 : -1;
              }), nn;
              if (Yt === true)
                nn = new Promise(function() {
                  var yn = CT(o_.mark(function Yn(Rr, Ur) {
                    var Hr, si2, _i;
                    return o_.wrap(function(Wa2) {
                      for (; ; )
                        switch (Wa2.prev = Wa2.next) {
                          case 0:
                            Hr = 0;
                          case 1:
                            if (!(Hr < He2.length)) {
                              Wa2.next = 12;
                              break;
                            }
                            return si2 = He2[Hr], Wa2.next = 5, RG(Re2, ve2, si2, $t, se2);
                          case 5:
                            if (_i = Wa2.sent, !_i.length) {
                              Wa2.next = 9;
                              break;
                            }
                            return Ur([{ errors: _i, rule: si2 }]), Wa2.abrupt("return");
                          case 9:
                            Hr += 1, Wa2.next = 1;
                            break;
                          case 12:
                            Rr([]);
                          case 13:
                          case "end":
                            return Wa2.stop();
                        }
                    }, Yn);
                  }));
                  return function(Yn, Rr) {
                    return yn.apply(this, arguments);
                  };
                }());
              else {
                var dn = He2.map(function(yn) {
                  return RG(Re2, ve2, yn, $t, se2).then(function(Yn) {
                    return { errors: Yn, rule: yn };
                  });
                });
                nn = (Yt ? Rht(dn) : Oht(dn)).then(function(yn) {
                  return Promise.reject(yn);
                });
              }
              return nn.catch(function(yn) {
                return yn;
              }), nn;
            }
            function Oht(Vt) {
              return FG.apply(this, arguments);
            }
            function FG() {
              return FG = CT(o_.mark(function Vt(ve2) {
                return o_.wrap(function(Ut) {
                  for (; ; )
                    switch (Ut.prev = Ut.next) {
                      case 0:
                        return Ut.abrupt("return", Promise.all(ve2).then(function($t) {
                          var Yt, se2 = (Yt = []).concat.apply(Yt, Pf2($t));
                          return se2;
                        }));
                      case 1:
                      case "end":
                        return Ut.stop();
                    }
                }, Vt);
              })), FG.apply(this, arguments);
            }
            function Rht(Vt) {
              return Y9.apply(this, arguments);
            }
            function Y9() {
              return Y9 = CT(o_.mark(function Vt(ve2) {
                var Ut;
                return o_.wrap(function($t) {
                  for (; ; )
                    switch ($t.prev = $t.next) {
                      case 0:
                        return Ut = 0, $t.abrupt("return", new Promise(function(Yt) {
                          ve2.forEach(function(se2) {
                            se2.then(function(Re2) {
                              Re2.errors.length && Yt([Re2]), Ut += 1, Ut === ve2.length && Yt([]);
                            });
                          });
                        }));
                      case 2:
                      case "end":
                        return $t.stop();
                    }
                }, Vt);
              })), Y9.apply(this, arguments);
            }
            var rJ = ["name"], F0 = [];
            function iJ(Vt, ve2, Ut, $t, Yt, se2) {
              return typeof Vt == "function" ? Vt(ve2, Ut, "source" in se2 ? { source: se2.source } : {}) : $t !== Yt;
            }
            var VG = function(Vt) {
              CG(Ut, Vt);
              var ve2 = xD(Ut);
              function Ut($t) {
                var Yt;
                if (oS(this, Ut), Yt = ve2.call(this, $t), Yt.state = { resetCount: 0 }, Yt.cancelRegisterFunc = null, Yt.mounted = false, Yt.touched = false, Yt.dirty = false, Yt.validatePromise = null, Yt.prevValidating = void 0, Yt.errors = F0, Yt.warnings = F0, Yt.cancelRegister = function() {
                  var nn = Yt.props, dn = nn.preserve, yn = nn.isListField, Yn = nn.name;
                  Yt.cancelRegisterFunc && Yt.cancelRegisterFunc(yn, dn, N0(Yn)), Yt.cancelRegisterFunc = null;
                }, Yt.getNamePath = function() {
                  var nn = Yt.props, dn = nn.name, yn = nn.fieldContext, Yn = yn.prefixName, Rr = Yn === void 0 ? [] : Yn;
                  return dn !== void 0 ? [].concat(Pf2(Rr), Pf2(dn)) : [];
                }, Yt.getRules = function() {
                  var nn = Yt.props, dn = nn.rules, yn = dn === void 0 ? [] : dn, Yn = nn.fieldContext;
                  return yn.map(function(Rr) {
                    return typeof Rr == "function" ? Rr(Yn) : Rr;
                  });
                }, Yt.refresh = function() {
                  !Yt.mounted || Yt.setState(function(nn) {
                    var dn = nn.resetCount;
                    return { resetCount: dn + 1 };
                  });
                }, Yt.triggerMetaEvent = function(nn) {
                  var dn = Yt.props.onMetaChange;
                  dn == null || dn(gn(gn({}, Yt.getMeta()), {}, { destroy: nn }));
                }, Yt.onStoreChange = function(nn, dn, yn) {
                  var Yn = Yt.props, Rr = Yn.shouldUpdate, Ur = Yn.dependencies, Hr = Ur === void 0 ? [] : Ur, si2 = Yn.onReset, _i = yn.store, Wa2 = Yt.getNamePath(), Ia2 = Yt.getValue(nn), ts = Yt.getValue(_i), on = dn && p6(dn, Wa2);
                  switch (yn.type === "valueUpdate" && yn.source === "external" && Ia2 !== ts && (Yt.touched = true, Yt.dirty = true, Yt.validatePromise = null, Yt.errors = F0, Yt.warnings = F0, Yt.triggerMetaEvent()), yn.type) {
                    case "reset":
                      if (!dn || on) {
                        Yt.touched = false, Yt.dirty = false, Yt.validatePromise = null, Yt.errors = F0, Yt.warnings = F0, Yt.triggerMetaEvent(), si2 == null || si2(), Yt.refresh();
                        return;
                      }
                      break;
                    case "remove": {
                      if (Rr) {
                        Yt.reRender();
                        return;
                      }
                      break;
                    }
                    case "setField": {
                      if (on) {
                        var di2 = yn.data;
                        "touched" in di2 && (Yt.touched = di2.touched), "validating" in di2 && !("originRCField" in di2) && (Yt.validatePromise = di2.validating ? Promise.resolve([]) : null), "errors" in di2 && (Yt.errors = di2.errors || F0), "warnings" in di2 && (Yt.warnings = di2.warnings || F0), Yt.dirty = true, Yt.triggerMetaEvent(), Yt.reRender();
                        return;
                      }
                      if (Rr && !Wa2.length && iJ(Rr, nn, _i, Ia2, ts, yn)) {
                        Yt.reRender();
                        return;
                      }
                      break;
                    }
                    case "dependenciesUpdate": {
                      var Yi2 = Hr.map(N0);
                      if (Yi2.some(function(Oa2) {
                        return p6(yn.relatedFields, Oa2);
                      })) {
                        Yt.reRender();
                        return;
                      }
                      break;
                    }
                    default:
                      if (on || (!Hr.length || Wa2.length || Rr) && iJ(Rr, nn, _i, Ia2, ts, yn)) {
                        Yt.reRender();
                        return;
                      }
                      break;
                  }
                  Rr === true && Yt.reRender();
                }, Yt.validateRules = function(nn) {
                  var dn = Yt.getNamePath(), yn = Yt.getValue(), Yn = Promise.resolve().then(function() {
                    if (!Yt.mounted)
                      return [];
                    var Rr = Yt.props, Ur = Rr.validateFirst, Hr = Ur === void 0 ? false : Ur, si2 = Rr.messageVariables, _i = nn || {}, Wa2 = _i.triggerName, Ia2 = Yt.getRules();
                    Wa2 && (Ia2 = Ia2.filter(function(on) {
                      var di2 = on.validateTrigger;
                      if (!di2)
                        return true;
                      var Yi2 = EG(di2);
                      return Yi2.includes(Wa2);
                    }));
                    var ts = ID(dn, yn, Ia2, nn, Hr, si2);
                    return ts.catch(function(on) {
                      return on;
                    }).then(function() {
                      var on = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : F0;
                      if (Yt.validatePromise === Yn) {
                        Yt.validatePromise = null;
                        var di2 = [], Yi2 = [];
                        on.forEach(function(Oa2) {
                          var Da2 = Oa2.rule.warningOnly, Fi2 = Oa2.errors, Qi2 = Fi2 === void 0 ? F0 : Fi2;
                          Da2 ? Yi2.push.apply(Yi2, Pf2(Qi2)) : di2.push.apply(di2, Pf2(Qi2));
                        }), Yt.errors = di2, Yt.warnings = Yi2, Yt.triggerMetaEvent(), Yt.reRender();
                      }
                    }), ts;
                  });
                  return Yt.validatePromise = Yn, Yt.dirty = true, Yt.errors = F0, Yt.warnings = F0, Yt.triggerMetaEvent(), Yt.reRender(), Yn;
                }, Yt.isFieldValidating = function() {
                  return !!Yt.validatePromise;
                }, Yt.isFieldTouched = function() {
                  return Yt.touched;
                }, Yt.isFieldDirty = function() {
                  if (Yt.dirty || Yt.props.initialValue !== void 0)
                    return true;
                  var nn = Yt.props.fieldContext, dn = nn.getInternalHooks(n1), yn = dn.getInitialValue;
                  return yn(Yt.getNamePath()) !== void 0;
                }, Yt.getErrors = function() {
                  return Yt.errors;
                }, Yt.getWarnings = function() {
                  return Yt.warnings;
                }, Yt.isListField = function() {
                  return Yt.props.isListField;
                }, Yt.isList = function() {
                  return Yt.props.isList;
                }, Yt.isPreserve = function() {
                  return Yt.props.preserve;
                }, Yt.getMeta = function() {
                  Yt.prevValidating = Yt.isFieldValidating();
                  var nn = { touched: Yt.isFieldTouched(), validating: Yt.prevValidating, errors: Yt.errors, warnings: Yt.warnings, name: Yt.getNamePath() };
                  return nn;
                }, Yt.getOnlyChild = function(nn) {
                  if (typeof nn == "function") {
                    var dn = Yt.getMeta();
                    return gn(gn({}, Yt.getOnlyChild(nn(Yt.getControlled(), dn, Yt.props.fieldContext))), {}, { isFunction: true });
                  }
                  var yn = IG(nn);
                  return yn.length !== 1 || !Ve.isValidElement(yn[0]) ? { child: yn, isFunction: false } : { child: yn[0], isFunction: false };
                }, Yt.getValue = function(nn) {
                  var dn = Yt.props.fieldContext.getFieldsValue, yn = Yt.getNamePath();
                  return AD(nn || dn(true), yn);
                }, Yt.getControlled = function() {
                  var nn = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, dn = Yt.props, yn = dn.trigger, Yn = dn.validateTrigger, Rr = dn.getValueFromEvent, Ur = dn.normalize, Hr = dn.valuePropName, si2 = dn.getValueProps, _i = dn.fieldContext, Wa2 = Yn !== void 0 ? Yn : _i.validateTrigger, Ia2 = Yt.getNamePath(), ts = _i.getInternalHooks, on = _i.getFieldsValue, di2 = ts(n1), Yi2 = di2.dispatch, Oa2 = Yt.getValue(), Da2 = si2 || function(Wo) {
                    return ir({}, Hr, Wo);
                  }, Fi2 = nn[yn], Qi2 = gn(gn({}, nn), Da2(Oa2));
                  Qi2[yn] = function() {
                    Yt.touched = true, Yt.dirty = true, Yt.triggerMetaEvent();
                    for (var Wo, Ii2 = arguments.length, _l = new Array(Ii2), yl = 0; yl < Ii2; yl++)
                      _l[yl] = arguments[yl];
                    Rr ? Wo = Rr.apply(void 0, _l) : Wo = $9.apply(void 0, [Hr].concat(_l)), Ur && (Wo = Ur(Wo, Oa2, on(true))), Yi2({ type: "updateValue", namePath: Ia2, value: Wo }), Fi2 && Fi2.apply(void 0, _l);
                  };
                  var ro = EG(Wa2 || []);
                  return ro.forEach(function(Wo) {
                    var Ii2 = Qi2[Wo];
                    Qi2[Wo] = function() {
                      Ii2 && Ii2.apply(void 0, arguments);
                      var _l = Yt.props.rules;
                      _l && _l.length && Yi2({ type: "validateField", namePath: Ia2, triggerName: Wo });
                    };
                  }), Qi2;
                }, $t.fieldContext) {
                  var se2 = $t.fieldContext.getInternalHooks, Re2 = se2(n1), He2 = Re2.initEntityValue;
                  He2(j9(Yt));
                }
                return Yt;
              }
              return _D(Ut, [{ key: "componentDidMount", value: function() {
                var $t = this.props, Yt = $t.shouldUpdate, se2 = $t.fieldContext;
                if (this.mounted = true, se2) {
                  var Re2 = se2.getInternalHooks, He2 = Re2(n1), nn = He2.registerField;
                  this.cancelRegisterFunc = nn(this);
                }
                Yt === true && this.reRender();
              } }, { key: "componentWillUnmount", value: function() {
                this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
              } }, { key: "reRender", value: function() {
                !this.mounted || this.forceUpdate();
              } }, { key: "render", value: function() {
                var $t = this.state.resetCount, Yt = this.props.children, se2 = this.getOnlyChild(Yt), Re2 = se2.child, He2 = se2.isFunction, nn;
                return He2 ? nn = Re2 : Ve.isValidElement(Re2) ? nn = Ve.cloneElement(Re2, this.getControlled(Re2.props)) : (iS(!Re2, "`children` of Field is not validate ReactElement."), nn = Re2), Ve.createElement(Ve.Fragment, { key: $t }, nn);
              } }]), Ut;
            }(Ve.Component);
            VG.contextType = tb2, VG.defaultProps = { trigger: "onChange", valuePropName: "value" };
            function aJ(Vt) {
              var ve2 = Vt.name, Ut = Al(Vt, rJ), $t = Ve.useContext(tb2), Yt = ve2 !== void 0 ? N0(ve2) : void 0, se2 = "keep";
              return Ut.isListField || (se2 = "_".concat((Yt || []).join("_"))), Ve.createElement(VG, Xc2({ key: se2, name: Yt }, Ut, { fieldContext: $t }));
            }
            var lL = Ve.createContext(null), Nht = function(Vt) {
              var ve2 = Vt.name, Ut = Vt.initialValue, $t = Vt.children, Yt = Vt.rules, se2 = Vt.validateTrigger, Re2 = Ve.useContext(tb2), He2 = Ve.useRef({ keys: [], id: 0 }), nn = He2.current, dn = Ve.useMemo(function() {
                var Ur = N0(Re2.prefixName) || [];
                return [].concat(Pf2(Ur), Pf2(N0(ve2)));
              }, [Re2.prefixName, ve2]), yn = Ve.useMemo(function() {
                return gn(gn({}, Re2), {}, { prefixName: dn });
              }, [Re2, dn]), Yn = Ve.useMemo(function() {
                return { getKey: function(Ur) {
                  var Hr = dn.length, si2 = Ur[Hr];
                  return [nn.keys[si2], Ur.slice(Hr + 1)];
                } };
              }, [dn]);
              if (typeof $t != "function")
                return iS(false, "Form.List only accepts function as children."), null;
              var Rr = function(Ur, Hr, si2) {
                var _i = si2.source;
                return _i === "internal" ? false : Ur !== Hr;
              };
              return Ve.createElement(lL.Provider, { value: Yn }, Ve.createElement(tb2.Provider, { value: yn }, Ve.createElement(aJ, { name: [], shouldUpdate: Rr, rules: Yt, validateTrigger: se2, initialValue: Ut, isList: true }, function(Ur, Hr) {
                var si2 = Ur.value, _i = si2 === void 0 ? [] : si2, Wa2 = Ur.onChange, Ia2 = Re2.getFieldValue, ts = function() {
                  var Yi2 = Ia2(dn || []);
                  return Yi2 || [];
                }, on = { add: function(Yi2, Oa2) {
                  var Da2 = ts();
                  Oa2 >= 0 && Oa2 <= Da2.length ? (nn.keys = [].concat(Pf2(nn.keys.slice(0, Oa2)), [nn.id], Pf2(nn.keys.slice(Oa2))), Wa2([].concat(Pf2(Da2.slice(0, Oa2)), [Yi2], Pf2(Da2.slice(Oa2))))) : (nn.keys = [].concat(Pf2(nn.keys), [nn.id]), Wa2([].concat(Pf2(Da2), [Yi2]))), nn.id += 1;
                }, remove: function(Yi2) {
                  var Oa2 = ts(), Da2 = new Set(Array.isArray(Yi2) ? Yi2 : [Yi2]);
                  Da2.size <= 0 || (nn.keys = nn.keys.filter(function(Fi2, Qi2) {
                    return !Da2.has(Qi2);
                  }), Wa2(Oa2.filter(function(Fi2, Qi2) {
                    return !Da2.has(Qi2);
                  })));
                }, move: function(Yi2, Oa2) {
                  if (Yi2 !== Oa2) {
                    var Da2 = ts();
                    Yi2 < 0 || Yi2 >= Da2.length || Oa2 < 0 || Oa2 >= Da2.length || (nn.keys = Lx(nn.keys, Yi2, Oa2), Wa2(Lx(Da2, Yi2, Oa2)));
                  }
                } }, di2 = _i || [];
                return Array.isArray(di2) || (di2 = []), $t(di2.map(function(Yi2, Oa2) {
                  var Da2 = nn.keys[Oa2];
                  return Da2 === void 0 && (nn.keys[Oa2] = nn.id, Da2 = nn.keys[Oa2], nn.id += 1), { name: Oa2, key: Da2, isListField: true };
                }), on, Hr);
              })));
            };
            function DT(Vt) {
              var ve2 = false, Ut = Vt.length, $t = [];
              return Vt.length ? new Promise(function(Yt, se2) {
                Vt.forEach(function(Re2, He2) {
                  Re2.catch(function(nn) {
                    return ve2 = true, nn;
                  }).then(function(nn) {
                    Ut -= 1, $t[He2] = nn, !(Ut > 0) && (ve2 && se2($t), Yt($t));
                  });
                });
              }) : Promise.resolve([]);
            }
            var oJ = "__@field_split__";
            function BG(Vt) {
              return Vt.map(function(ve2) {
                return "".concat(Vc2(ve2), ":").concat(ve2);
              }).join(oJ);
            }
            var g6 = function() {
              function Vt() {
                oS(this, Vt), this.kvs = /* @__PURE__ */ new Map();
              }
              return _D(Vt, [{ key: "set", value: function(ve2, Ut) {
                this.kvs.set(BG(ve2), Ut);
              } }, { key: "get", value: function(ve2) {
                return this.kvs.get(BG(ve2));
              } }, { key: "update", value: function(ve2, Ut) {
                var $t = this.get(ve2), Yt = Ut($t);
                Yt ? this.set(ve2, Yt) : this.delete(ve2);
              } }, { key: "delete", value: function(ve2) {
                this.kvs.delete(BG(ve2));
              } }, { key: "map", value: function(ve2) {
                return Pf2(this.kvs.entries()).map(function(Ut) {
                  var $t = li2(Ut, 2), Yt = $t[0], se2 = $t[1], Re2 = Yt.split(oJ);
                  return ve2({ key: Re2.map(function(He2) {
                    var nn = He2.match(/^([^:]*):(.*)$/), dn = li2(nn, 3), yn = dn[1], Yn = dn[2];
                    return yn === "number" ? Number(Yn) : Yn;
                  }), value: se2 });
                });
              } }, { key: "toJSON", value: function() {
                var ve2 = {};
                return this.map(function(Ut) {
                  var $t = Ut.key, Yt = Ut.value;
                  return ve2[$t.join(".")] = Yt, null;
                }), ve2;
              } }]), Vt;
            }(), sJ = ["name", "errors"], lJ = _D(function Vt(ve2) {
              var Ut = this;
              oS(this, Vt), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
                return { getFieldValue: Ut.getFieldValue, getFieldsValue: Ut.getFieldsValue, getFieldError: Ut.getFieldError, getFieldWarning: Ut.getFieldWarning, getFieldsError: Ut.getFieldsError, isFieldsTouched: Ut.isFieldsTouched, isFieldTouched: Ut.isFieldTouched, isFieldValidating: Ut.isFieldValidating, isFieldsValidating: Ut.isFieldsValidating, resetFields: Ut.resetFields, setFields: Ut.setFields, setFieldsValue: Ut.setFieldsValue, validateFields: Ut.validateFields, submit: Ut.submit, getInternalHooks: Ut.getInternalHooks };
              }, this.getInternalHooks = function($t) {
                return $t === n1 ? (Ut.formHooked = true, { dispatch: Ut.dispatch, initEntityValue: Ut.initEntityValue, registerField: Ut.registerField, useSubscribe: Ut.useSubscribe, setInitialValues: Ut.setInitialValues, setCallbacks: Ut.setCallbacks, setValidateMessages: Ut.setValidateMessages, getFields: Ut.getFields, setPreserve: Ut.setPreserve, getInitialValue: Ut.getInitialValue }) : (iS(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
              }, this.useSubscribe = function($t) {
                Ut.subscribable = $t;
              }, this.setInitialValues = function($t, Yt) {
                Ut.initialValues = $t || {}, Yt && (Ut.store = Zv({}, $t, Ut.store));
              }, this.getInitialValue = function($t) {
                return AD(Ut.initialValues, $t);
              }, this.setCallbacks = function($t) {
                Ut.callbacks = $t;
              }, this.setValidateMessages = function($t) {
                Ut.validateMessages = $t;
              }, this.setPreserve = function($t) {
                Ut.preserve = $t;
              }, this.timeoutId = null, this.warningUnhooked = function() {
              }, this.getFieldEntities = function() {
                var $t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
                return $t ? Ut.fieldEntities.filter(function(Yt) {
                  return Yt.getNamePath().length;
                }) : Ut.fieldEntities;
              }, this.getFieldsMap = function() {
                var $t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, Yt = new g6();
                return Ut.getFieldEntities($t).forEach(function(se2) {
                  var Re2 = se2.getNamePath();
                  Yt.set(Re2, se2);
                }), Yt;
              }, this.getFieldEntitiesForNamePathList = function($t) {
                if (!$t)
                  return Ut.getFieldEntities(true);
                var Yt = Ut.getFieldsMap(true);
                return $t.map(function(se2) {
                  var Re2 = N0(se2);
                  return Yt.get(Re2) || { INVALIDATE_NAME_PATH: N0(se2) };
                });
              }, this.getFieldsValue = function($t, Yt) {
                if (Ut.warningUnhooked(), $t === true && !Yt)
                  return Ut.store;
                var se2 = Ut.getFieldEntitiesForNamePathList(Array.isArray($t) ? $t : null), Re2 = [];
                return se2.forEach(function(He2) {
                  var nn, dn = "INVALIDATE_NAME_PATH" in He2 ? He2.INVALIDATE_NAME_PATH : He2.getNamePath();
                  if (!(!$t && ((nn = He2.isListField) === null || nn === void 0 ? void 0 : nn.call(He2))))
                    if (!Yt)
                      Re2.push(dn);
                    else {
                      var yn = "getMeta" in He2 ? He2.getMeta() : null;
                      Yt(yn) && Re2.push(dn);
                    }
                }), Z9(Ut.store, Re2.map(N0));
              }, this.getFieldValue = function($t) {
                Ut.warningUnhooked();
                var Yt = N0($t);
                return AD(Ut.store, Yt);
              }, this.getFieldsError = function($t) {
                Ut.warningUnhooked();
                var Yt = Ut.getFieldEntitiesForNamePathList($t);
                return Yt.map(function(se2, Re2) {
                  return se2 && !("INVALIDATE_NAME_PATH" in se2) ? { name: se2.getNamePath(), errors: se2.getErrors(), warnings: se2.getWarnings() } : { name: N0($t[Re2]), errors: [], warnings: [] };
                });
              }, this.getFieldError = function($t) {
                Ut.warningUnhooked();
                var Yt = N0($t), se2 = Ut.getFieldsError([Yt])[0];
                return se2.errors;
              }, this.getFieldWarning = function($t) {
                Ut.warningUnhooked();
                var Yt = N0($t), se2 = Ut.getFieldsError([Yt])[0];
                return se2.warnings;
              }, this.isFieldsTouched = function() {
                Ut.warningUnhooked();
                for (var $t = arguments.length, Yt = new Array($t), se2 = 0; se2 < $t; se2++)
                  Yt[se2] = arguments[se2];
                var Re2 = Yt[0], He2 = Yt[1], nn, dn = false;
                Yt.length === 0 ? nn = null : Yt.length === 1 ? Array.isArray(Re2) ? (nn = Re2.map(N0), dn = false) : (nn = null, dn = Re2) : (nn = Re2.map(N0), dn = He2);
                var yn = Ut.getFieldEntities(true), Yn = function(si2) {
                  return si2.isFieldTouched();
                };
                if (!nn)
                  return dn ? yn.every(Yn) : yn.some(Yn);
                var Rr = new g6();
                nn.forEach(function(si2) {
                  Rr.set(si2, []);
                }), yn.forEach(function(si2) {
                  var _i = si2.getNamePath();
                  nn.forEach(function(Wa2) {
                    Wa2.every(function(Ia2, ts) {
                      return _i[ts] === Ia2;
                    }) && Rr.update(Wa2, function(Ia2) {
                      return [].concat(Pf2(Ia2), [si2]);
                    });
                  });
                });
                var Ur = function(si2) {
                  return si2.some(Yn);
                }, Hr = Rr.map(function(si2) {
                  var _i = si2.value;
                  return _i;
                });
                return dn ? Hr.every(Ur) : Hr.some(Ur);
              }, this.isFieldTouched = function($t) {
                return Ut.warningUnhooked(), Ut.isFieldsTouched([$t]);
              }, this.isFieldsValidating = function($t) {
                Ut.warningUnhooked();
                var Yt = Ut.getFieldEntities();
                if (!$t)
                  return Yt.some(function(Re2) {
                    return Re2.isFieldValidating();
                  });
                var se2 = $t.map(N0);
                return Yt.some(function(Re2) {
                  var He2 = Re2.getNamePath();
                  return p6(se2, He2) && Re2.isFieldValidating();
                });
              }, this.isFieldValidating = function($t) {
                return Ut.warningUnhooked(), Ut.isFieldsValidating([$t]);
              }, this.resetWithFieldInitialValue = function() {
                var $t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Yt = new g6(), se2 = Ut.getFieldEntities(true);
                se2.forEach(function(nn) {
                  var dn = nn.props.initialValue, yn = nn.getNamePath();
                  if (dn !== void 0) {
                    var Yn = Yt.get(yn) || /* @__PURE__ */ new Set();
                    Yn.add({ entity: nn, value: dn }), Yt.set(yn, Yn);
                  }
                });
                var Re2 = function(nn) {
                  nn.forEach(function(dn) {
                    var yn = dn.props.initialValue;
                    if (yn !== void 0) {
                      var Yn = dn.getNamePath(), Rr = Ut.getInitialValue(Yn);
                      if (Rr !== void 0)
                        iS(false, "Form already set 'initialValues' with path '".concat(Yn.join("."), "'. Field can not overwrite it."));
                      else {
                        var Ur = Yt.get(Yn);
                        if (Ur && Ur.size > 1)
                          iS(false, "Multiple Field with path '".concat(Yn.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                        else if (Ur) {
                          var Hr = Ut.getFieldValue(Yn);
                          (!$t.skipExist || Hr === void 0) && (Ut.store = Jk(Ut.store, Yn, Pf2(Ur)[0].value));
                        }
                      }
                    }
                  });
                }, He2;
                $t.entities ? He2 = $t.entities : $t.namePathList ? (He2 = [], $t.namePathList.forEach(function(nn) {
                  var dn = Yt.get(nn);
                  if (dn) {
                    var yn;
                    (yn = He2).push.apply(yn, Pf2(Pf2(dn).map(function(Yn) {
                      return Yn.entity;
                    })));
                  }
                })) : He2 = se2, Re2(He2);
              }, this.resetFields = function($t) {
                Ut.warningUnhooked();
                var Yt = Ut.store;
                if (!$t) {
                  Ut.store = Zv({}, Ut.initialValues), Ut.resetWithFieldInitialValue(), Ut.notifyObservers(Yt, null, { type: "reset" });
                  return;
                }
                var se2 = $t.map(N0);
                se2.forEach(function(Re2) {
                  var He2 = Ut.getInitialValue(Re2);
                  Ut.store = Jk(Ut.store, Re2, He2);
                }), Ut.resetWithFieldInitialValue({ namePathList: se2 }), Ut.notifyObservers(Yt, se2, { type: "reset" });
              }, this.setFields = function($t) {
                Ut.warningUnhooked();
                var Yt = Ut.store;
                $t.forEach(function(se2) {
                  var Re2 = se2.name;
                  se2.errors;
                  var He2 = Al(se2, sJ), nn = N0(Re2);
                  "value" in He2 && (Ut.store = Jk(Ut.store, nn, He2.value)), Ut.notifyObservers(Yt, [nn], { type: "setField", data: se2 });
                });
              }, this.getFields = function() {
                var $t = Ut.getFieldEntities(true), Yt = $t.map(function(se2) {
                  var Re2 = se2.getNamePath(), He2 = se2.getMeta(), nn = gn(gn({}, He2), {}, { name: Re2, value: Ut.getFieldValue(Re2) });
                  return Object.defineProperty(nn, "originRCField", { value: true }), nn;
                });
                return Yt;
              }, this.initEntityValue = function($t) {
                var Yt = $t.props.initialValue;
                if (Yt !== void 0) {
                  var se2 = $t.getNamePath(), Re2 = AD(Ut.store, se2);
                  Re2 === void 0 && (Ut.store = Jk(Ut.store, se2, Yt));
                }
              }, this.registerField = function($t) {
                if (Ut.fieldEntities.push($t), $t.props.initialValue !== void 0) {
                  var Yt = Ut.store;
                  Ut.resetWithFieldInitialValue({ entities: [$t], skipExist: true }), Ut.notifyObservers(Yt, [$t.getNamePath()], { type: "valueUpdate", source: "internal" });
                }
                return function(se2, Re2) {
                  var He2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
                  Ut.fieldEntities = Ut.fieldEntities.filter(function(Rr) {
                    return Rr !== $t;
                  });
                  var nn = Re2 !== void 0 ? Re2 : Ut.preserve;
                  if (nn === false && (!se2 || He2.length > 1)) {
                    var dn = $t.getNamePath(), yn = se2 ? void 0 : AD(Ut.initialValues, dn);
                    if (dn.length && Ut.getFieldValue(dn) !== yn && Ut.fieldEntities.every(function(Rr) {
                      return !Sn(Rr.getNamePath(), dn);
                    })) {
                      var Yn = Ut.store;
                      Ut.store = Jk(Yn, dn, yn, true), Ut.notifyObservers(Yn, [dn], { type: "remove" }), Ut.triggerDependenciesUpdate(Yn, dn);
                    }
                  }
                };
              }, this.dispatch = function($t) {
                switch ($t.type) {
                  case "updateValue": {
                    var Yt = $t.namePath, se2 = $t.value;
                    Ut.updateValue(Yt, se2);
                    break;
                  }
                  case "validateField": {
                    var Re2 = $t.namePath, He2 = $t.triggerName;
                    Ut.validateFields([Re2], { triggerName: He2 });
                    break;
                  }
                }
              }, this.notifyObservers = function($t, Yt, se2) {
                if (Ut.subscribable) {
                  var Re2 = gn(gn({}, se2), {}, { store: Ut.getFieldsValue(true) });
                  Ut.getFieldEntities().forEach(function(He2) {
                    var nn = He2.onStoreChange;
                    nn($t, Yt, Re2);
                  });
                } else
                  Ut.forceRootUpdate();
              }, this.triggerDependenciesUpdate = function($t, Yt) {
                var se2 = Ut.getDependencyChildrenFields(Yt);
                return se2.length && Ut.validateFields(se2), Ut.notifyObservers($t, se2, { type: "dependenciesUpdate", relatedFields: [Yt].concat(Pf2(se2)) }), se2;
              }, this.updateValue = function($t, Yt) {
                var se2 = N0($t), Re2 = Ut.store;
                Ut.store = Jk(Ut.store, se2, Yt), Ut.notifyObservers(Re2, [se2], { type: "valueUpdate", source: "internal" });
                var He2 = Ut.triggerDependenciesUpdate(Re2, se2), nn = Ut.callbacks.onValuesChange;
                if (nn) {
                  var dn = Z9(Ut.store, [se2]);
                  nn(dn, Ut.getFieldsValue());
                }
                Ut.triggerOnFieldsChange([se2].concat(Pf2(He2)));
              }, this.setFieldsValue = function($t) {
                Ut.warningUnhooked();
                var Yt = Ut.store;
                $t && (Ut.store = Zv(Ut.store, $t)), Ut.notifyObservers(Yt, null, { type: "valueUpdate", source: "external" });
              }, this.getDependencyChildrenFields = function($t) {
                var Yt = /* @__PURE__ */ new Set(), se2 = [], Re2 = new g6();
                Ut.getFieldEntities().forEach(function(nn) {
                  var dn = nn.props.dependencies;
                  (dn || []).forEach(function(yn) {
                    var Yn = N0(yn);
                    Re2.update(Yn, function() {
                      var Rr = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                      return Rr.add(nn), Rr;
                    });
                  });
                });
                var He2 = function nn(dn) {
                  var yn = Re2.get(dn) || /* @__PURE__ */ new Set();
                  yn.forEach(function(Yn) {
                    if (!Yt.has(Yn)) {
                      Yt.add(Yn);
                      var Rr = Yn.getNamePath();
                      Yn.isFieldDirty() && Rr.length && (se2.push(Rr), nn(Rr));
                    }
                  });
                };
                return He2($t), se2;
              }, this.triggerOnFieldsChange = function($t, Yt) {
                var se2 = Ut.callbacks.onFieldsChange;
                if (se2) {
                  var Re2 = Ut.getFields();
                  if (Yt) {
                    var He2 = new g6();
                    Yt.forEach(function(dn) {
                      var yn = dn.name, Yn = dn.errors;
                      He2.set(yn, Yn);
                    }), Re2.forEach(function(dn) {
                      dn.errors = He2.get(dn.name) || dn.errors;
                    });
                  }
                  var nn = Re2.filter(function(dn) {
                    var yn = dn.name;
                    return p6($t, yn);
                  });
                  se2(nn, Re2);
                }
              }, this.validateFields = function($t, Yt) {
                Ut.warningUnhooked();
                var se2 = !!$t, Re2 = se2 ? $t.map(N0) : [], He2 = [];
                Ut.getFieldEntities(true).forEach(function(yn) {
                  if (se2 || Re2.push(yn.getNamePath()), (Yt == null ? void 0 : Yt.recursive) && se2) {
                    var Yn = yn.getNamePath();
                    Yn.every(function(Hr, si2) {
                      return $t[si2] === Hr || $t[si2] === void 0;
                    }) && Re2.push(Yn);
                  }
                  if (!(!yn.props.rules || !yn.props.rules.length)) {
                    var Rr = yn.getNamePath();
                    if (!se2 || p6(Re2, Rr)) {
                      var Ur = yn.validateRules(gn({ validateMessages: gn(gn({}, Qk), Ut.validateMessages) }, Yt));
                      He2.push(Ur.then(function() {
                        return { name: Rr, errors: [], warnings: [] };
                      }).catch(function(Hr) {
                        var si2 = [], _i = [];
                        return Hr.forEach(function(Wa2) {
                          var Ia2 = Wa2.rule.warningOnly, ts = Wa2.errors;
                          Ia2 ? _i.push.apply(_i, Pf2(ts)) : si2.push.apply(si2, Pf2(ts));
                        }), si2.length ? Promise.reject({ name: Rr, errors: si2, warnings: _i }) : { name: Rr, errors: si2, warnings: _i };
                      }));
                    }
                  }
                });
                var nn = DT(He2);
                Ut.lastValidatePromise = nn, nn.catch(function(yn) {
                  return yn;
                }).then(function(yn) {
                  var Yn = yn.map(function(Rr) {
                    var Ur = Rr.name;
                    return Ur;
                  });
                  Ut.notifyObservers(Ut.store, Yn, { type: "validateFinish" }), Ut.triggerOnFieldsChange(Yn, yn);
                });
                var dn = nn.then(function() {
                  return Ut.lastValidatePromise === nn ? Promise.resolve(Ut.getFieldsValue(Re2)) : Promise.reject([]);
                }).catch(function(yn) {
                  var Yn = yn.filter(function(Rr) {
                    return Rr && Rr.errors.length;
                  });
                  return Promise.reject({ values: Ut.getFieldsValue(Re2), errorFields: Yn, outOfDate: Ut.lastValidatePromise !== nn });
                });
                return dn.catch(function(yn) {
                  return yn;
                }), dn;
              }, this.submit = function() {
                Ut.warningUnhooked(), Ut.validateFields().then(function($t) {
                  var Yt = Ut.callbacks.onFinish;
                  if (Yt)
                    try {
                      Yt($t);
                    } catch (se2) {
                      console.error(se2);
                    }
                }).catch(function($t) {
                  var Yt = Ut.callbacks.onFinishFailed;
                  Yt && Yt($t);
                });
              }, this.forceRootUpdate = ve2;
            });
            function DD(Vt) {
              var ve2 = Ve.useRef(), Ut = Ve.useState({}), $t = li2(Ut, 2), Yt = $t[1];
              if (!ve2.current)
                if (Vt)
                  ve2.current = Vt;
                else {
                  var se2 = function() {
                    Yt({});
                  }, Re2 = new lJ(se2);
                  ve2.current = Re2.getForm();
                }
              return [ve2.current];
            }
            var zG = Ve.createContext({ triggerFormChange: function() {
            }, triggerFormFinish: function() {
            }, registerForm: function() {
            }, unregisterForm: function() {
            } }), Fht = function(Vt) {
              var ve2 = Vt.validateMessages, Ut = Vt.onFormChange, $t = Vt.onFormFinish, Yt = Vt.children, se2 = Ve.useContext(zG), Re2 = Ve.useRef({});
              return Ve.createElement(zG.Provider, { value: gn(gn({}, se2), {}, { validateMessages: gn(gn({}, se2.validateMessages), ve2), triggerFormChange: function(He2, nn) {
                Ut && Ut(He2, { changedFields: nn, forms: Re2.current }), se2.triggerFormChange(He2, nn);
              }, triggerFormFinish: function(He2, nn) {
                $t && $t(He2, { values: nn, forms: Re2.current }), se2.triggerFormFinish(He2, nn);
              }, registerForm: function(He2, nn) {
                He2 && (Re2.current = gn(gn({}, Re2.current), {}, ir({}, He2, nn))), se2.registerForm(He2, nn);
              }, unregisterForm: function(He2) {
                var nn = gn({}, Re2.current);
                delete nn[He2], Re2.current = nn, se2.unregisterForm(He2);
              } }) }, Yt);
            }, D22 = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], Vht = function(Vt, ve2) {
              var Ut = Vt.name, $t = Vt.initialValues, Yt = Vt.fields, se2 = Vt.form, Re2 = Vt.preserve, He2 = Vt.children, nn = Vt.component, dn = nn === void 0 ? "form" : nn, yn = Vt.validateMessages, Yn = Vt.validateTrigger, Rr = Yn === void 0 ? "onChange" : Yn, Ur = Vt.onValuesChange, Hr = Vt.onFieldsChange, si2 = Vt.onFinish, _i = Vt.onFinishFailed, Wa2 = Al(Vt, D22), Ia2 = Ve.useContext(zG), ts = DD(se2), on = li2(ts, 1), di2 = on[0], Yi2 = di2.getInternalHooks(n1), Oa2 = Yi2.useSubscribe, Da2 = Yi2.setInitialValues, Fi2 = Yi2.setCallbacks, Qi2 = Yi2.setValidateMessages, ro = Yi2.setPreserve;
              Ve.useImperativeHandle(ve2, function() {
                return di2;
              }), Ve.useEffect(function() {
                return Ia2.registerForm(Ut, di2), function() {
                  Ia2.unregisterForm(Ut);
                };
              }, [Ia2, di2, Ut]), Qi2(gn(gn({}, Ia2.validateMessages), yn)), Fi2({ onValuesChange: Ur, onFieldsChange: function(ha2) {
                if (Ia2.triggerFormChange(Ut, ha2), Hr) {
                  for (var pa2 = arguments.length, hs = new Array(pa2 > 1 ? pa2 - 1 : 0), Zo = 1; Zo < pa2; Zo++)
                    hs[Zo - 1] = arguments[Zo];
                  Hr.apply(void 0, [ha2].concat(hs));
                }
              }, onFinish: function(ha2) {
                Ia2.triggerFormFinish(Ut, ha2), si2 && si2(ha2);
              }, onFinishFailed: _i }), ro(Re2);
              var Wo = Ve.useRef(null);
              Da2($t, !Wo.current), Wo.current || (Wo.current = true);
              var Ii2 = He2, _l = typeof He2 == "function";
              if (_l) {
                var yl = di2.getFieldsValue(true);
                Ii2 = He2(yl, di2);
              }
              Oa2(!_l);
              var Ra2 = Ve.useRef();
              Ve.useEffect(function() {
                sL(Ra2.current || [], Yt || []) || di2.setFields(Yt || []), Ra2.current = Yt;
              }, [Yt, di2]);
              var Su = Ve.useMemo(function() {
                return gn(gn({}, di2), {}, { validateTrigger: Rr });
              }, [di2, Rr]), Ga2 = Ve.createElement(tb2.Provider, { value: Su }, Ii2);
              return dn === false ? Ga2 : Ve.createElement(dn, Xc2({}, Wa2, { onSubmit: function(ha2) {
                ha2.preventDefault(), ha2.stopPropagation(), di2.submit();
              }, onReset: function(ha2) {
                var pa2;
                ha2.preventDefault(), di2.resetFields(), (pa2 = Wa2.onReset) === null || pa2 === void 0 || pa2.call(Wa2, ha2);
              } }), Ga2);
            }, Bht = Ve.forwardRef(Vht), K9 = Bht;
            K9.FormProvider = Fht, K9.Field = aJ, K9.List = Nht, K9.useForm = DD;
            var zht = function(Vt, ve2, Ut) {
              iS(Vt, "[antd: ".concat(ve2, "] ").concat(Ut));
            }, jht = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, uJ = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, cJ = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, fJ = cJ, Wht = { lang: Xc2({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, uJ), timePickerLocale: Xc2({}, fJ) }, X9 = Wht, gm = "${label} is not a valid ${type}", Q9 = { locale: "en", Pagination: jht, DatePicker: X9, TimePicker: fJ, Calendar: X9, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: gm, method: gm, array: gm, object: gm, number: gm, date: gm, boolean: gm, integer: gm, float: gm, regexp: gm, email: gm, url: gm, hex: gm }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, hJ = Q9, pJ = Zt.createContext(void 0), Ght = pJ, E2 = function(Vt) {
              CG(Ut, Vt);
              var ve2 = xD(Ut);
              function Ut() {
                return oS(this, Ut), ve2.apply(this, arguments);
              }
              return _D(Ut, [{ key: "getLocale", value: function() {
                var $t = this.props, Yt = $t.componentName, se2 = $t.defaultLocale, Re2 = se2 || hJ[Yt != null ? Yt : "global"], He2 = this.context, nn = Yt && He2 ? He2[Yt] : {};
                return Xc2(Xc2({}, Re2 instanceof Function ? Re2() : Re2), nn || {});
              } }, { key: "getLocaleCode", value: function() {
                var $t = this.context, Yt = $t && $t.locale;
                return $t && $t.exist && !Yt ? hJ.locale : Yt;
              } }, { key: "render", value: function() {
                return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
              } }]), Ut;
            }(Ve.Component);
            E2.defaultProps = { componentName: "global" }, E2.contextType = Ght;
            var jG = function() {
              var Vt = Ve.useContext(ET), ve2 = Vt.getPrefixCls, Ut = ve2("empty-img-default");
              return Ve.createElement("svg", { className: Ut, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, Ve.createElement("g", { fill: "none", fillRule: "evenodd" }, Ve.createElement("g", { transform: "translate(24 31.67)" }, Ve.createElement("ellipse", { className: "".concat(Ut, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), Ve.createElement("path", { className: "".concat(Ut, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), Ve.createElement("path", { className: "".concat(Ut, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), Ve.createElement("path", { className: "".concat(Ut, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), Ve.createElement("path", { className: "".concat(Ut, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), Ve.createElement("path", { className: "".concat(Ut, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), Ve.createElement("g", { className: "".concat(Ut, "-g"), transform: "translate(149.65 15.383)" }, Ve.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), Ve.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
            }, t5 = jG, lS = function() {
              var Vt = Ve.useContext(ET), ve2 = Vt.getPrefixCls, Ut = ve2("empty-img-simple");
              return Ve.createElement("svg", { className: Ut, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, Ve.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, Ve.createElement("ellipse", { className: "".concat(Ut, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), Ve.createElement("g", { className: "".concat(Ut, "-g"), fillRule: "nonzero" }, Ve.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), Ve.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(Ut, "-path") }))));
            }, Hht = lS, dJ = globalThis && globalThis.__rest || function(Vt, ve2) {
              var Ut = {};
              for (var $t in Vt)
                Object.prototype.hasOwnProperty.call(Vt, $t) && ve2.indexOf($t) < 0 && (Ut[$t] = Vt[$t]);
              if (Vt != null && typeof Object.getOwnPropertySymbols == "function")
                for (var Yt = 0, $t = Object.getOwnPropertySymbols(Vt); Yt < $t.length; Yt++)
                  ve2.indexOf($t[Yt]) < 0 && Object.prototype.propertyIsEnumerable.call(Vt, $t[Yt]) && (Ut[$t[Yt]] = Vt[$t[Yt]]);
              return Ut;
            }, v6 = Ve.createElement(t5, null), e5 = Ve.createElement(Hht, null), k22 = function(Vt) {
              var ve2 = Vt.className, Ut = Vt.prefixCls, $t = Vt.image, Yt = $t === void 0 ? v6 : $t, se2 = Vt.description, Re2 = Vt.children, He2 = Vt.imageStyle, nn = dJ(Vt, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), dn = Ve.useContext(ET), yn = dn.getPrefixCls, Yn = dn.direction;
              return Ve.createElement(E2, { componentName: "Empty" }, function(Rr) {
                var Ur, Hr = yn("empty", Ut), si2 = typeof se2 != "undefined" ? se2 : Rr.description, _i = typeof si2 == "string" ? si2 : "empty", Wa2 = null;
                return typeof Yt == "string" ? Wa2 = Ve.createElement("img", { alt: _i, src: Yt }) : Wa2 = Yt, Ve.createElement("div", Xc2({ className: sf2(Hr, (Ur = {}, ir(Ur, "".concat(Hr, "-normal"), Yt === e5), ir(Ur, "".concat(Hr, "-rtl"), Yn === "rtl"), Ur), ve2) }, nn), Ve.createElement("div", { className: "".concat(Hr, "-image"), style: He2 }, Wa2), si2 && Ve.createElement("div", { className: "".concat(Hr, "-description") }, si2), Re2 && Ve.createElement("div", { className: "".concat(Hr, "-footer") }, Re2));
              });
            };
            k22.PRESENTED_IMAGE_DEFAULT = v6, k22.PRESENTED_IMAGE_SIMPLE = e5;
            var uL = k22, Uht = function(Vt) {
              return Ve.createElement(Oy, null, function(ve2) {
                var Ut = ve2.getPrefixCls, $t = Ut("empty");
                switch (Vt) {
                  case "Table":
                  case "List":
                    return Ve.createElement(uL, { image: uL.PRESENTED_IMAGE_SIMPLE });
                  case "Select":
                  case "TreeSelect":
                  case "Cascader":
                  case "Transfer":
                  case "Mentions":
                    return Ve.createElement(uL, { image: uL.PRESENTED_IMAGE_SIMPLE, className: "".concat($t, "-small") });
                  default:
                    return Ve.createElement(uL, null);
                }
              });
            }, J9 = Uht, WG = function(Vt, ve2) {
              return ve2 || (Vt ? "ant-".concat(Vt) : "ant");
            }, ET = Ve.createContext({ getPrefixCls: WG, renderEmpty: J9 }), Oy = ET.Consumer, GG = Ve.createContext(void 0), nb2 = GG, Ox = function(Vt) {
              return +setTimeout(Vt, 16);
            }, t7 = function(Vt) {
              return clearTimeout(Vt);
            };
            typeof window != "undefined" && "requestAnimationFrame" in window && (Ox = function(Vt) {
              return window.requestAnimationFrame(Vt);
            }, t7 = function(Vt) {
              return window.cancelAnimationFrame(Vt);
            });
            var y6 = 0, kT = /* @__PURE__ */ new Map();
            function HG(Vt) {
              kT.delete(Vt);
            }
            function V0(Vt) {
              var ve2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
              y6 += 1;
              var Ut = y6;
              function $t(Yt) {
                if (Yt === 0)
                  HG(Ut), Vt();
                else {
                  var se2 = Ox(function() {
                    $t(Yt - 1);
                  });
                  kT.set(Ut, se2);
                }
              }
              return $t(ve2), Ut;
            }
            V0.cancel = function(Vt) {
              var ve2 = kT.get(Vt);
              return HG(ve2), t7(ve2);
            };
            function UG(Vt, ve2) {
              var Ut = ve2 || {}, $t = Ut.defaultValue, Yt = Ut.value, se2 = Ut.onChange, Re2 = Ut.postState, He2 = Ve.useState(function() {
                return Yt !== void 0 ? Yt : $t !== void 0 ? typeof $t == "function" ? $t() : $t : typeof Vt == "function" ? Vt() : Vt;
              }), nn = li2(He2, 2), dn = nn[0], yn = nn[1], Yn = Yt !== void 0 ? Yt : dn;
              Re2 && (Yn = Re2(Yn));
              var Rr = Ve.useRef(se2);
              Rr.current = se2;
              var Ur = Ve.useCallback(function(si2) {
                yn(si2), Yn !== si2 && Rr.current && Rr.current(si2, Yn);
              }, [Yn, Rr]), Hr = Ve.useRef(true);
              return Ve.useEffect(function() {
                if (Hr.current) {
                  Hr.current = false;
                  return;
                }
                Yt === void 0 && yn(Yt);
              }, [Yt]), [Yn, Ur];
            }
            var ju = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(Vt) {
              var ve2 = Vt.keyCode;
              if (Vt.altKey && !Vt.ctrlKey || Vt.metaKey || ve2 >= ju.F1 && ve2 <= ju.F12)
                return false;
              switch (ve2) {
                case ju.ALT:
                case ju.CAPS_LOCK:
                case ju.CONTEXT_MENU:
                case ju.CTRL:
                case ju.DOWN:
                case ju.END:
                case ju.ESC:
                case ju.HOME:
                case ju.INSERT:
                case ju.LEFT:
                case ju.MAC_FF_META:
                case ju.META:
                case ju.NUMLOCK:
                case ju.NUM_CENTER:
                case ju.PAGE_DOWN:
                case ju.PAGE_UP:
                case ju.PAUSE:
                case ju.PRINT_SCREEN:
                case ju.RIGHT:
                case ju.SHIFT:
                case ju.UP:
                case ju.WIN_KEY:
                case ju.WIN_KEY_RIGHT:
                  return false;
                default:
                  return true;
              }
            }, isCharacterKey: function(Vt) {
              if (Vt >= ju.ZERO && Vt <= ju.NINE || Vt >= ju.NUM_ZERO && Vt <= ju.NUM_MULTIPLY || Vt >= ju.A && Vt <= ju.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && Vt === 0)
                return true;
              switch (Vt) {
                case ju.SPACE:
                case ju.QUESTION_MARK:
                case ju.NUM_PLUS:
                case ju.NUM_MINUS:
                case ju.NUM_PERIOD:
                case ju.NUM_DIVISION:
                case ju.SEMICOLON:
                case ju.DASH:
                case ju.EQUALS:
                case ju.COMMA:
                case ju.PERIOD:
                case ju.SLASH:
                case ju.APOSTROPHE:
                case ju.SINGLE_QUOTE:
                case ju.OPEN_SQUARE_BRACKET:
                case ju.BACKSLASH:
                case ju.CLOSE_SQUARE_BRACKET:
                  return true;
                default:
                  return false;
              }
            } }, gJ = function() {
              for (var Vt = arguments.length, ve2 = new Array(Vt), Ut = 0; Ut < Vt; Ut++)
                ve2[Ut] = arguments[Ut];
              return ve2;
            }, qht = Ve.isValidElement;
            function qG(Vt, ve2, Ut) {
              return qht(Vt) ? Ve.cloneElement(Vt, typeof Ut == "function" ? Ut(Vt.props || {}) : Ut) : ve2;
            }
            function Zht(Vt, ve2) {
              return qG(Vt, Vt, ve2);
            }
            var n5 = ["xxl", "xl", "lg", "md", "sm", "xs"], m6 = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, r52 = /* @__PURE__ */ new Map(), ZG = -1, NM = {}, $G = { matchHandlers: {}, dispatch: function(Vt) {
              return NM = Vt, r52.forEach(function(ve2) {
                return ve2(NM);
              }), r52.size >= 1;
            }, subscribe: function(Vt) {
              return r52.size || this.register(), ZG += 1, r52.set(ZG, Vt), Vt(NM), ZG;
            }, unsubscribe: function(Vt) {
              r52.delete(Vt), r52.size || this.unregister();
            }, unregister: function() {
              var Vt = this;
              Object.keys(m6).forEach(function(ve2) {
                var Ut = m6[ve2], $t = Vt.matchHandlers[Ut];
                $t == null || $t.mql.removeListener($t == null ? void 0 : $t.listener);
              }), r52.clear();
            }, register: function() {
              var Vt = this;
              Object.keys(m6).forEach(function(ve2) {
                var Ut = m6[ve2], $t = function(se2) {
                  var Re2 = se2.matches;
                  Vt.dispatch(Xc2(Xc2({}, NM), ir({}, ve2, Re2)));
                }, Yt = window.matchMedia(Ut);
                Yt.addListener($t), Vt.matchHandlers[Ut] = { mql: Yt, listener: $t }, $t(Yt);
              });
            } }, vJ = $G, YG = 0, i5 = {};
            function e7(Vt) {
              var ve2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, Ut = YG++, $t = ve2;
              function Yt() {
                $t -= 1, $t <= 0 ? (Vt(), delete i5[Ut]) : i5[Ut] = V0(Yt);
              }
              return i5[Ut] = V0(Yt), Ut;
            }
            e7.cancel = function(Vt) {
              Vt !== void 0 && (V0.cancel(i5[Vt]), delete i5[Vt]);
            }, e7.ids = i5;
            var KG;
            function yJ(Vt) {
              return !Vt || Vt.offsetParent === null || Vt.hidden;
            }
            function mJ(Vt) {
              var ve2 = (Vt || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
              return ve2 && ve2[1] && ve2[2] && ve2[3] ? !(ve2[1] === ve2[2] && ve2[2] === ve2[3]) : true;
            }
            var n7 = function(Vt) {
              CG(Ut, Vt);
              var ve2 = xD(Ut);
              function Ut() {
                var $t;
                return oS(this, Ut), $t = ve2.apply(this, arguments), $t.containerRef = Ve.createRef(), $t.animationStart = false, $t.destroyed = false, $t.onClick = function(Yt, se2) {
                  var Re2, He2, nn = $t.props, dn = nn.insertExtraNode, yn = nn.disabled;
                  if (!(yn || !Yt || yJ(Yt) || Yt.className.indexOf("-leave") >= 0)) {
                    $t.extraNode = document.createElement("div");
                    var Yn = j9($t), Rr = Yn.extraNode, Ur = $t.context.getPrefixCls;
                    Rr.className = "".concat(Ur(""), "-click-animating-node");
                    var Hr = $t.getAttributeName();
                    if (Yt.setAttribute(Hr, "true"), se2 && se2 !== "#ffffff" && se2 !== "rgb(255, 255, 255)" && mJ(se2) && !/rgba\((?:\d*, ){3}0\)/.test(se2) && se2 !== "transparent") {
                      Rr.style.borderColor = se2;
                      var si2 = ((Re2 = Yt.getRootNode) === null || Re2 === void 0 ? void 0 : Re2.call(Yt)) || Yt.ownerDocument, _i = si2 instanceof Document ? si2.body : (He2 = si2.firstChild) !== null && He2 !== void 0 ? He2 : si2;
                      KG = FQ(`
      [`.concat(Ur(""), "-click-animating-without-extra-node='true']::after, .").concat(Ur(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(se2, `;
      }`), "antd-wave", { csp: $t.csp, attachTo: _i });
                    }
                    dn && Yt.appendChild(Rr), ["transition", "animation"].forEach(function(Wa2) {
                      Yt.addEventListener("".concat(Wa2, "start"), $t.onTransitionStart), Yt.addEventListener("".concat(Wa2, "end"), $t.onTransitionEnd);
                    });
                  }
                }, $t.onTransitionStart = function(Yt) {
                  if (!$t.destroyed) {
                    var se2 = $t.containerRef.current;
                    !Yt || Yt.target !== se2 || $t.animationStart || $t.resetEffect(se2);
                  }
                }, $t.onTransitionEnd = function(Yt) {
                  !Yt || Yt.animationName !== "fadeEffect" || $t.resetEffect(Yt.target);
                }, $t.bindAnimationEvent = function(Yt) {
                  if (!(!Yt || !Yt.getAttribute || Yt.getAttribute("disabled") || Yt.className.indexOf("disabled") >= 0)) {
                    var se2 = function(Re2) {
                      if (!(Re2.target.tagName === "INPUT" || yJ(Re2.target))) {
                        $t.resetEffect(Yt);
                        var He2 = getComputedStyle(Yt).getPropertyValue("border-top-color") || getComputedStyle(Yt).getPropertyValue("border-color") || getComputedStyle(Yt).getPropertyValue("background-color");
                        $t.clickWaveTimeoutId = window.setTimeout(function() {
                          return $t.onClick(Yt, He2);
                        }, 0), e7.cancel($t.animationStartId), $t.animationStart = true, $t.animationStartId = e7(function() {
                          $t.animationStart = false;
                        }, 10);
                      }
                    };
                    return Yt.addEventListener("click", se2, true), { cancel: function() {
                      Yt.removeEventListener("click", se2, true);
                    } };
                  }
                }, $t.renderWave = function(Yt) {
                  var se2 = Yt.csp, Re2 = $t.props.children;
                  if ($t.csp = se2, !Ve.isValidElement(Re2))
                    return Re2;
                  var He2 = $t.containerRef;
                  return CD(Re2) && (He2 = UQ(Re2.ref, $t.containerRef)), Zht(Re2, { ref: He2 });
                }, $t;
              }
              return _D(Ut, [{ key: "componentDidMount", value: function() {
                var $t = this.containerRef.current;
                !$t || $t.nodeType !== 1 || (this.instance = this.bindAnimationEvent($t));
              } }, { key: "componentWillUnmount", value: function() {
                this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
              } }, { key: "getAttributeName", value: function() {
                var $t = this.context.getPrefixCls, Yt = this.props.insertExtraNode;
                return Yt ? "".concat($t(""), "-click-animating") : "".concat($t(""), "-click-animating-without-extra-node");
              } }, { key: "resetEffect", value: function($t) {
                var Yt = this;
                if (!(!$t || $t === this.extraNode || !($t instanceof Element))) {
                  var se2 = this.props.insertExtraNode, Re2 = this.getAttributeName();
                  $t.setAttribute(Re2, "false"), KG && (KG.innerHTML = ""), se2 && this.extraNode && $t.contains(this.extraNode) && $t.removeChild(this.extraNode), ["transition", "animation"].forEach(function(He2) {
                    $t.removeEventListener("".concat(He2, "start"), Yt.onTransitionStart), $t.removeEventListener("".concat(He2, "end"), Yt.onTransitionEnd);
                  });
                }
              } }, { key: "render", value: function() {
                return Ve.createElement(Oy, null, this.renderWave);
              } }]), Ut;
            }(Ve.Component);
            n7.contextType = ET;
            var XG = { exports: {} }, a5 = {};
            /** @license React v17.0.2
            * react-jsx-runtime.production.min.js
            *
            * Copyright (c) Facebook, Inc. and its affiliates.
            *
            * This source code is licensed under the MIT license found in the
            * LICENSE file in the root directory of this source tree.
            */
            var bJ = Ge2.default, QG = 60103;
            if (a5.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
              var JG = Symbol.for;
              QG = JG("react.element"), a5.Fragment = JG("react.fragment");
            }
            var r7 = bJ.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, $ht = Object.prototype.hasOwnProperty, _J = { key: true, ref: true, __self: true, __source: true };
            function tH(Vt, ve2, Ut) {
              var $t, Yt = {}, se2 = null, Re2 = null;
              Ut !== void 0 && (se2 = "" + Ut), ve2.key !== void 0 && (se2 = "" + ve2.key), ve2.ref !== void 0 && (Re2 = ve2.ref);
              for ($t in ve2)
                $ht.call(ve2, $t) && !_J.hasOwnProperty($t) && (Yt[$t] = ve2[$t]);
              if (Vt && Vt.defaultProps)
                for ($t in ve2 = Vt.defaultProps, ve2)
                  Yt[$t] === void 0 && (Yt[$t] = ve2[$t]);
              return { $$typeof: QG, type: Vt, key: se2, ref: Re2, props: Yt, _owner: r7.current };
            }
            a5.jsx = tH, a5.jsxs = tH, XG.exports = a5;
            const cL = XG.exports.jsx, xJ = XG.exports.jsxs;
            var Yht = Zt.createContext({}), i7 = Yht, st = function() {
              return bG() && window.document.documentElement;
            }, xt, Qt = function() {
              if (!st())
                return false;
              if (xt !== void 0)
                return xt;
              var Vt = document.createElement("div");
              return Vt.style.display = "flex", Vt.style.flexDirection = "column", Vt.style.rowGap = "1px", Vt.appendChild(document.createElement("div")), Vt.appendChild(document.createElement("div")), document.body.appendChild(Vt), xt = Vt.scrollHeight === 1, document.body.removeChild(Vt), xt;
            }, Ae2 = function() {
              var Vt = Ve.useState(false), ve2 = li2(Vt, 2), Ut = ve2[0], $t = ve2[1];
              return Ve.useEffect(function() {
                $t(Qt());
              }, []), Ut;
            }, an = globalThis && globalThis.__rest || function(Vt, ve2) {
              var Ut = {};
              for (var $t in Vt)
                Object.prototype.hasOwnProperty.call(Vt, $t) && ve2.indexOf($t) < 0 && (Ut[$t] = Vt[$t]);
              if (Vt != null && typeof Object.getOwnPropertySymbols == "function")
                for (var Yt = 0, $t = Object.getOwnPropertySymbols(Vt); Yt < $t.length; Yt++)
                  ve2.indexOf($t[Yt]) < 0 && Object.prototype.propertyIsEnumerable.call(Vt, $t[Yt]) && (Ut[$t[Yt]] = Vt[$t[Yt]]);
              return Ut;
            };
            gJ("top", "middle", "bottom", "stretch"), gJ("start", "end", "center", "space-around", "space-between");
            var Un = Ve.forwardRef(function(Vt, ve2) {
              var Ut, $t = Vt.prefixCls, Yt = Vt.justify, se2 = Vt.align, Re2 = Vt.className, He2 = Vt.style, nn = Vt.children, dn = Vt.gutter, yn = dn === void 0 ? 0 : dn, Yn = Vt.wrap, Rr = an(Vt, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Ur = Ve.useContext(ET), Hr = Ur.getPrefixCls, si2 = Ur.direction, _i = Ve.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), Wa2 = li2(_i, 2), Ia2 = Wa2[0], ts = Wa2[1], on = Ae2(), di2 = Ve.useRef(yn);
              Ve.useEffect(function() {
                var Ga2 = vJ.subscribe(function(ha2) {
                  var pa2 = di2.current || 0;
                  (!Array.isArray(pa2) && Vc2(pa2) === "object" || Array.isArray(pa2) && (Vc2(pa2[0]) === "object" || Vc2(pa2[1]) === "object")) && ts(ha2);
                });
                return function() {
                  return vJ.unsubscribe(Ga2);
                };
              }, []);
              var Yi2 = function() {
                var Ga2 = [0, 0], ha2 = Array.isArray(yn) ? yn : [yn, 0];
                return ha2.forEach(function(pa2, hs) {
                  if (Vc2(pa2) === "object")
                    for (var Zo = 0; Zo < n5.length; Zo++) {
                      var rc2 = n5[Zo];
                      if (Ia2[rc2] && pa2[rc2] !== void 0) {
                        Ga2[hs] = pa2[rc2];
                        break;
                      }
                    }
                  else
                    Ga2[hs] = pa2 || 0;
                }), Ga2;
              }, Oa2 = Hr("row", $t), Da2 = Yi2(), Fi2 = sf2(Oa2, (Ut = {}, ir(Ut, "".concat(Oa2, "-no-wrap"), Yn === false), ir(Ut, "".concat(Oa2, "-").concat(Yt), Yt), ir(Ut, "".concat(Oa2, "-").concat(se2), se2), ir(Ut, "".concat(Oa2, "-rtl"), si2 === "rtl"), Ut), Re2), Qi2 = {}, ro = Da2[0] > 0 ? Da2[0] / -2 : void 0, Wo = Da2[1] > 0 ? Da2[1] / -2 : void 0;
              if (ro && (Qi2.marginLeft = ro, Qi2.marginRight = ro), on) {
                var Ii2 = li2(Da2, 2);
                Qi2.rowGap = Ii2[1];
              } else
                Wo && (Qi2.marginTop = Wo, Qi2.marginBottom = Wo);
              var _l = li2(Da2, 2), yl = _l[0], Ra2 = _l[1], Su = Ve.useMemo(function() {
                return { gutter: [yl, Ra2], wrap: Yn, supportFlexGap: on };
              }, [yl, Ra2, Yn, on]);
              return Ve.createElement(i7.Provider, { value: Su }, Ve.createElement("div", Xc2({}, Rr, { className: Fi2, style: Xc2(Xc2({}, Qi2), He2), ref: ve2 }), nn));
            });
            Un.displayName = "Row";
            var Br = Un, qr = globalThis && globalThis.__rest || function(Vt, ve2) {
              var Ut = {};
              for (var $t in Vt)
                Object.prototype.hasOwnProperty.call(Vt, $t) && ve2.indexOf($t) < 0 && (Ut[$t] = Vt[$t]);
              if (Vt != null && typeof Object.getOwnPropertySymbols == "function")
                for (var Yt = 0, $t = Object.getOwnPropertySymbols(Vt); Yt < $t.length; Yt++)
                  ve2.indexOf($t[Yt]) < 0 && Object.prototype.propertyIsEnumerable.call(Vt, $t[Yt]) && (Ut[$t[Yt]] = Vt[$t[Yt]]);
              return Ut;
            };
            function Ai2(Vt) {
              return typeof Vt == "number" ? "".concat(Vt, " ").concat(Vt, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(Vt) ? "0 0 ".concat(Vt) : Vt;
            }
            var So = ["xs", "sm", "md", "lg", "xl", "xxl"], Mo = Ve.forwardRef(function(Vt, ve2) {
              var Ut, $t = Ve.useContext(ET), Yt = $t.getPrefixCls, se2 = $t.direction, Re2 = Ve.useContext(i7), He2 = Re2.gutter, nn = Re2.wrap, dn = Re2.supportFlexGap, yn = Vt.prefixCls, Yn = Vt.span, Rr = Vt.order, Ur = Vt.offset, Hr = Vt.push, si2 = Vt.pull, _i = Vt.className, Wa2 = Vt.children, Ia2 = Vt.flex, ts = Vt.style, on = qr(Vt, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), di2 = Yt("col", yn), Yi2 = {};
              So.forEach(function(ro) {
                var Wo, Ii2 = {}, _l = Vt[ro];
                typeof _l == "number" ? Ii2.span = _l : Vc2(_l) === "object" && (Ii2 = _l || {}), delete on[ro], Yi2 = Xc2(Xc2({}, Yi2), (Wo = {}, ir(Wo, "".concat(di2, "-").concat(ro, "-").concat(Ii2.span), Ii2.span !== void 0), ir(Wo, "".concat(di2, "-").concat(ro, "-order-").concat(Ii2.order), Ii2.order || Ii2.order === 0), ir(Wo, "".concat(di2, "-").concat(ro, "-offset-").concat(Ii2.offset), Ii2.offset || Ii2.offset === 0), ir(Wo, "".concat(di2, "-").concat(ro, "-push-").concat(Ii2.push), Ii2.push || Ii2.push === 0), ir(Wo, "".concat(di2, "-").concat(ro, "-pull-").concat(Ii2.pull), Ii2.pull || Ii2.pull === 0), ir(Wo, "".concat(di2, "-rtl"), se2 === "rtl"), Wo));
              });
              var Oa2 = sf2(di2, (Ut = {}, ir(Ut, "".concat(di2, "-").concat(Yn), Yn !== void 0), ir(Ut, "".concat(di2, "-order-").concat(Rr), Rr), ir(Ut, "".concat(di2, "-offset-").concat(Ur), Ur), ir(Ut, "".concat(di2, "-push-").concat(Hr), Hr), ir(Ut, "".concat(di2, "-pull-").concat(si2), si2), Ut), _i, Yi2), Da2 = {};
              if (He2 && He2[0] > 0) {
                var Fi2 = He2[0] / 2;
                Da2.paddingLeft = Fi2, Da2.paddingRight = Fi2;
              }
              if (He2 && He2[1] > 0 && !dn) {
                var Qi2 = He2[1] / 2;
                Da2.paddingTop = Qi2, Da2.paddingBottom = Qi2;
              }
              return Ia2 && (Da2.flex = Ai2(Ia2), nn === false && !Da2.minWidth && (Da2.minWidth = 0)), Ve.createElement("div", Xc2({}, on, { style: Xc2(Xc2({}, Da2), ts), className: Oa2, ref: ve2 }), Wa2);
            });
            Mo.displayName = "Col";
            var Ao = Mo, Xs = Ve.forwardRef(function(Vt, ve2) {
              var Ut, $t = Vt.prefixCls, Yt = $t === void 0 ? "rc-switch" : $t, se2 = Vt.className, Re2 = Vt.checked, He2 = Vt.defaultChecked, nn = Vt.disabled, dn = Vt.loadingIcon, yn = Vt.checkedChildren, Yn = Vt.unCheckedChildren, Rr = Vt.onClick, Ur = Vt.onChange, Hr = Vt.onKeyDown, si2 = Al(Vt, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), _i = UG(false, { value: Re2, defaultValue: He2 }), Wa2 = li2(_i, 2), Ia2 = Wa2[0], ts = Wa2[1];
              function on(Da2, Fi2) {
                var Qi2 = Ia2;
                return nn || (Qi2 = Da2, ts(Qi2), Ur == null || Ur(Qi2, Fi2)), Qi2;
              }
              function di2(Da2) {
                Da2.which === ju.LEFT ? on(false, Da2) : Da2.which === ju.RIGHT && on(true, Da2), Hr == null || Hr(Da2);
              }
              function Yi2(Da2) {
                var Fi2 = on(!Ia2, Da2);
                Rr == null || Rr(Fi2, Da2);
              }
              var Oa2 = sf2(Yt, se2, (Ut = {}, ir(Ut, "".concat(Yt, "-checked"), Ia2), ir(Ut, "".concat(Yt, "-disabled"), nn), Ut));
              return Ve.createElement("button", Object.assign({}, si2, { type: "button", role: "switch", "aria-checked": Ia2, disabled: nn, className: Oa2, ref: ve2, onKeyDown: di2, onClick: Yi2 }), dn, Ve.createElement("span", { className: "".concat(Yt, "-inner") }, Ia2 ? yn : Yn));
            });
            Xs.displayName = "Switch";
            var Yl = globalThis && globalThis.__rest || function(Vt, ve2) {
              var Ut = {};
              for (var $t in Vt)
                Object.prototype.hasOwnProperty.call(Vt, $t) && ve2.indexOf($t) < 0 && (Ut[$t] = Vt[$t]);
              if (Vt != null && typeof Object.getOwnPropertySymbols == "function")
                for (var Yt = 0, $t = Object.getOwnPropertySymbols(Vt); Yt < $t.length; Yt++)
                  ve2.indexOf($t[Yt]) < 0 && Object.prototype.propertyIsEnumerable.call(Vt, $t[Yt]) && (Ut[$t[Yt]] = Vt[$t[Yt]]);
              return Ut;
            }, Pu = Ve.forwardRef(function(Vt, ve2) {
              var Ut, $t = Vt.prefixCls, Yt = Vt.size, se2 = Vt.loading, Re2 = Vt.className, He2 = Re2 === void 0 ? "" : Re2, nn = Vt.disabled, dn = Yl(Vt, ["prefixCls", "size", "loading", "className", "disabled"]);
              zht("checked" in dn || !("value" in dn), "Switch", "`value` is not a valid prop, do you mean `checked`?");
              var yn = Ve.useContext(ET), Yn = yn.getPrefixCls, Rr = yn.direction, Ur = Ve.useContext(nb2), Hr = Yn("switch", $t), si2 = Ve.createElement("div", { className: "".concat(Hr, "-handle") }, se2 && Ve.createElement(MG, { className: "".concat(Hr, "-loading-icon") })), _i = sf2((Ut = {}, ir(Ut, "".concat(Hr, "-small"), (Yt || Ur) === "small"), ir(Ut, "".concat(Hr, "-loading"), se2), ir(Ut, "".concat(Hr, "-rtl"), Rr === "rtl"), Ut), He2);
              return Ve.createElement(n7, { insertExtraNode: true }, Ve.createElement(Xs, Xc2({}, dn, { prefixCls: Hr, className: _i, disabled: nn || se2, ref: ve2, loadingIcon: si2 })));
            });
            Pu.__ANT_SWITCH = true, Pu.displayName = "Switch";
            var Mf2 = Pu, Uu = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, nc2 = { exports: {} };
            (function(Vt, ve2) {
              (function(Ut, $t) {
                Vt.exports = $t(Ge2.default);
              })(Gn, function(Ut) {
                return function($t) {
                  var Yt = {};
                  function se2(Re2) {
                    if (Yt[Re2])
                      return Yt[Re2].exports;
                    var He2 = Yt[Re2] = { i: Re2, l: false, exports: {} };
                    return $t[Re2].call(He2.exports, He2, He2.exports, se2), He2.l = true, He2.exports;
                  }
                  return se2.m = $t, se2.c = Yt, se2.d = function(Re2, He2, nn) {
                    se2.o(Re2, He2) || Object.defineProperty(Re2, He2, { enumerable: true, get: nn });
                  }, se2.r = function(Re2) {
                    typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(Re2, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(Re2, "__esModule", { value: true });
                  }, se2.t = function(Re2, He2) {
                    if (1 & He2 && (Re2 = se2(Re2)), 8 & He2 || 4 & He2 && typeof Re2 == "object" && Re2 && Re2.__esModule)
                      return Re2;
                    var nn = /* @__PURE__ */ Object.create(null);
                    if (se2.r(nn), Object.defineProperty(nn, "default", { enumerable: true, value: Re2 }), 2 & He2 && typeof Re2 != "string")
                      for (var dn in Re2)
                        se2.d(nn, dn, function(yn) {
                          return Re2[yn];
                        }.bind(null, dn));
                    return nn;
                  }, se2.n = function(Re2) {
                    var He2 = Re2 && Re2.__esModule ? function() {
                      return Re2.default;
                    } : function() {
                      return Re2;
                    };
                    return se2.d(He2, "a", He2), He2;
                  }, se2.o = function(Re2, He2) {
                    return Object.prototype.hasOwnProperty.call(Re2, He2);
                  }, se2.p = "", se2(se2.s = 48);
                }([function($t, Yt) {
                  $t.exports = Ut;
                }, function($t, Yt) {
                  var se2 = $t.exports = { version: "2.6.12" };
                  typeof __e == "number" && (__e = se2);
                }, function($t, Yt, se2) {
                  var Re2 = se2(26)("wks"), He2 = se2(17), nn = se2(3).Symbol, dn = typeof nn == "function";
                  ($t.exports = function(yn) {
                    return Re2[yn] || (Re2[yn] = dn && nn[yn] || (dn ? nn : He2)("Symbol." + yn));
                  }).store = Re2;
                }, function($t, Yt) {
                  var se2 = $t.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
                  typeof __g == "number" && (__g = se2);
                }, function($t, Yt, se2) {
                  $t.exports = !se2(8)(function() {
                    return Object.defineProperty({}, "a", { get: function() {
                      return 7;
                    } }).a != 7;
                  });
                }, function($t, Yt) {
                  var se2 = {}.hasOwnProperty;
                  $t.exports = function(Re2, He2) {
                    return se2.call(Re2, He2);
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(7), He2 = se2(16);
                  $t.exports = se2(4) ? function(nn, dn, yn) {
                    return Re2.f(nn, dn, He2(1, yn));
                  } : function(nn, dn, yn) {
                    return nn[dn] = yn, nn;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(10), He2 = se2(35), nn = se2(23), dn = Object.defineProperty;
                  Yt.f = se2(4) ? Object.defineProperty : function(yn, Yn, Rr) {
                    if (Re2(yn), Yn = nn(Yn, true), Re2(Rr), He2)
                      try {
                        return dn(yn, Yn, Rr);
                      } catch {
                      }
                    if ("get" in Rr || "set" in Rr)
                      throw TypeError("Accessors not supported!");
                    return "value" in Rr && (yn[Yn] = Rr.value), yn;
                  };
                }, function($t, Yt) {
                  $t.exports = function(se2) {
                    try {
                      return !!se2();
                    } catch {
                      return true;
                    }
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(40), He2 = se2(22);
                  $t.exports = function(nn) {
                    return Re2(He2(nn));
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(11);
                  $t.exports = function(He2) {
                    if (!Re2(He2))
                      throw TypeError(He2 + " is not an object!");
                    return He2;
                  };
                }, function($t, Yt) {
                  $t.exports = function(se2) {
                    return typeof se2 == "object" ? se2 !== null : typeof se2 == "function";
                  };
                }, function($t, Yt) {
                  $t.exports = {};
                }, function($t, Yt, se2) {
                  var Re2 = se2(39), He2 = se2(27);
                  $t.exports = Object.keys || function(nn) {
                    return Re2(nn, He2);
                  };
                }, function($t, Yt) {
                  $t.exports = true;
                }, function($t, Yt, se2) {
                  var Re2 = se2(3), He2 = se2(1), nn = se2(53), dn = se2(6), yn = se2(5), Yn = function(Rr, Ur, Hr) {
                    var si2, _i, Wa2, Ia2 = Rr & Yn.F, ts = Rr & Yn.G, on = Rr & Yn.S, di2 = Rr & Yn.P, Yi2 = Rr & Yn.B, Oa2 = Rr & Yn.W, Da2 = ts ? He2 : He2[Ur] || (He2[Ur] = {}), Fi2 = Da2.prototype, Qi2 = ts ? Re2 : on ? Re2[Ur] : (Re2[Ur] || {}).prototype;
                    for (si2 in ts && (Hr = Ur), Hr)
                      (_i = !Ia2 && Qi2 && Qi2[si2] !== void 0) && yn(Da2, si2) || (Wa2 = _i ? Qi2[si2] : Hr[si2], Da2[si2] = ts && typeof Qi2[si2] != "function" ? Hr[si2] : Yi2 && _i ? nn(Wa2, Re2) : Oa2 && Qi2[si2] == Wa2 ? function(ro) {
                        var Wo = function(Ii2, _l, yl) {
                          if (this instanceof ro) {
                            switch (arguments.length) {
                              case 0:
                                return new ro();
                              case 1:
                                return new ro(Ii2);
                              case 2:
                                return new ro(Ii2, _l);
                            }
                            return new ro(Ii2, _l, yl);
                          }
                          return ro.apply(this, arguments);
                        };
                        return Wo.prototype = ro.prototype, Wo;
                      }(Wa2) : di2 && typeof Wa2 == "function" ? nn(Function.call, Wa2) : Wa2, di2 && ((Da2.virtual || (Da2.virtual = {}))[si2] = Wa2, Rr & Yn.R && Fi2 && !Fi2[si2] && dn(Fi2, si2, Wa2)));
                  };
                  Yn.F = 1, Yn.G = 2, Yn.S = 4, Yn.P = 8, Yn.B = 16, Yn.W = 32, Yn.U = 64, Yn.R = 128, $t.exports = Yn;
                }, function($t, Yt) {
                  $t.exports = function(se2, Re2) {
                    return { enumerable: !(1 & se2), configurable: !(2 & se2), writable: !(4 & se2), value: Re2 };
                  };
                }, function($t, Yt) {
                  var se2 = 0, Re2 = Math.random();
                  $t.exports = function(He2) {
                    return "Symbol(".concat(He2 === void 0 ? "" : He2, ")_", (++se2 + Re2).toString(36));
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(22);
                  $t.exports = function(He2) {
                    return Object(Re2(He2));
                  };
                }, function($t, Yt) {
                  Yt.f = {}.propertyIsEnumerable;
                }, function($t, Yt, se2) {
                  var Re2 = se2(52)(true);
                  se2(34)(String, "String", function(He2) {
                    this._t = String(He2), this._i = 0;
                  }, function() {
                    var He2, nn = this._t, dn = this._i;
                    return dn >= nn.length ? { value: void 0, done: true } : (He2 = Re2(nn, dn), this._i += He2.length, { value: He2, done: false });
                  });
                }, function($t, Yt) {
                  var se2 = Math.ceil, Re2 = Math.floor;
                  $t.exports = function(He2) {
                    return isNaN(He2 = +He2) ? 0 : (He2 > 0 ? Re2 : se2)(He2);
                  };
                }, function($t, Yt) {
                  $t.exports = function(se2) {
                    if (se2 == null)
                      throw TypeError("Can't call method on  " + se2);
                    return se2;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(11);
                  $t.exports = function(He2, nn) {
                    if (!Re2(He2))
                      return He2;
                    var dn, yn;
                    if (nn && typeof (dn = He2.toString) == "function" && !Re2(yn = dn.call(He2)) || typeof (dn = He2.valueOf) == "function" && !Re2(yn = dn.call(He2)) || !nn && typeof (dn = He2.toString) == "function" && !Re2(yn = dn.call(He2)))
                      return yn;
                    throw TypeError("Can't convert object to primitive value");
                  };
                }, function($t, Yt) {
                  var se2 = {}.toString;
                  $t.exports = function(Re2) {
                    return se2.call(Re2).slice(8, -1);
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(26)("keys"), He2 = se2(17);
                  $t.exports = function(nn) {
                    return Re2[nn] || (Re2[nn] = He2(nn));
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(1), He2 = se2(3), nn = He2["__core-js_shared__"] || (He2["__core-js_shared__"] = {});
                  ($t.exports = function(dn, yn) {
                    return nn[dn] || (nn[dn] = yn !== void 0 ? yn : {});
                  })("versions", []).push({ version: Re2.version, mode: se2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
                }, function($t, Yt) {
                  $t.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
                }, function($t, Yt, se2) {
                  var Re2 = se2(7).f, He2 = se2(5), nn = se2(2)("toStringTag");
                  $t.exports = function(dn, yn, Yn) {
                    dn && !He2(dn = Yn ? dn : dn.prototype, nn) && Re2(dn, nn, { configurable: true, value: yn });
                  };
                }, function($t, Yt, se2) {
                  se2(62);
                  for (var Re2 = se2(3), He2 = se2(6), nn = se2(12), dn = se2(2)("toStringTag"), yn = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), Yn = 0; Yn < yn.length; Yn++) {
                    var Rr = yn[Yn], Ur = Re2[Rr], Hr = Ur && Ur.prototype;
                    Hr && !Hr[dn] && He2(Hr, dn, Rr), nn[Rr] = nn.Array;
                  }
                }, function($t, Yt, se2) {
                  Yt.f = se2(2);
                }, function($t, Yt, se2) {
                  var Re2 = se2(3), He2 = se2(1), nn = se2(14), dn = se2(30), yn = se2(7).f;
                  $t.exports = function(Yn) {
                    var Rr = He2.Symbol || (He2.Symbol = nn ? {} : Re2.Symbol || {});
                    Yn.charAt(0) == "_" || Yn in Rr || yn(Rr, Yn, { value: dn.f(Yn) });
                  };
                }, function($t, Yt) {
                  Yt.f = Object.getOwnPropertySymbols;
                }, function($t, Yt) {
                  $t.exports = function(se2, Re2, He2) {
                    return Math.min(Math.max(se2, Re2), He2);
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(14), He2 = se2(15), nn = se2(37), dn = se2(6), yn = se2(12), Yn = se2(55), Rr = se2(28), Ur = se2(61), Hr = se2(2)("iterator"), si2 = !([].keys && "next" in [].keys()), _i = function() {
                    return this;
                  };
                  $t.exports = function(Wa2, Ia2, ts, on, di2, Yi2, Oa2) {
                    Yn(ts, Ia2, on);
                    var Da2, Fi2, Qi2, ro = function(pa2) {
                      if (!si2 && pa2 in yl)
                        return yl[pa2];
                      switch (pa2) {
                        case "keys":
                        case "values":
                          return function() {
                            return new ts(this, pa2);
                          };
                      }
                      return function() {
                        return new ts(this, pa2);
                      };
                    }, Wo = Ia2 + " Iterator", Ii2 = di2 == "values", _l = false, yl = Wa2.prototype, Ra2 = yl[Hr] || yl["@@iterator"] || di2 && yl[di2], Su = Ra2 || ro(di2), Ga2 = di2 ? Ii2 ? ro("entries") : Su : void 0, ha2 = Ia2 == "Array" && yl.entries || Ra2;
                    if (ha2 && (Qi2 = Ur(ha2.call(new Wa2()))) !== Object.prototype && Qi2.next && (Rr(Qi2, Wo, true), Re2 || typeof Qi2[Hr] == "function" || dn(Qi2, Hr, _i)), Ii2 && Ra2 && Ra2.name !== "values" && (_l = true, Su = function() {
                      return Ra2.call(this);
                    }), Re2 && !Oa2 || !si2 && !_l && yl[Hr] || dn(yl, Hr, Su), yn[Ia2] = Su, yn[Wo] = _i, di2)
                      if (Da2 = { values: Ii2 ? Su : ro("values"), keys: Yi2 ? Su : ro("keys"), entries: Ga2 }, Oa2)
                        for (Fi2 in Da2)
                          Fi2 in yl || nn(yl, Fi2, Da2[Fi2]);
                      else
                        He2(He2.P + He2.F * (si2 || _l), Ia2, Da2);
                    return Da2;
                  };
                }, function($t, Yt, se2) {
                  $t.exports = !se2(4) && !se2(8)(function() {
                    return Object.defineProperty(se2(36)("div"), "a", { get: function() {
                      return 7;
                    } }).a != 7;
                  });
                }, function($t, Yt, se2) {
                  var Re2 = se2(11), He2 = se2(3).document, nn = Re2(He2) && Re2(He2.createElement);
                  $t.exports = function(dn) {
                    return nn ? He2.createElement(dn) : {};
                  };
                }, function($t, Yt, se2) {
                  $t.exports = se2(6);
                }, function($t, Yt, se2) {
                  var Re2 = se2(10), He2 = se2(56), nn = se2(27), dn = se2(25)("IE_PROTO"), yn = function() {
                  }, Yn = function() {
                    var Rr, Ur = se2(36)("iframe"), Hr = nn.length;
                    for (Ur.style.display = "none", se2(60).appendChild(Ur), Ur.src = "javascript:", (Rr = Ur.contentWindow.document).open(), Rr.write("<script>document.F=Object<\/script>"), Rr.close(), Yn = Rr.F; Hr--; )
                      delete Yn.prototype[nn[Hr]];
                    return Yn();
                  };
                  $t.exports = Object.create || function(Rr, Ur) {
                    var Hr;
                    return Rr !== null ? (yn.prototype = Re2(Rr), Hr = new yn(), yn.prototype = null, Hr[dn] = Rr) : Hr = Yn(), Ur === void 0 ? Hr : He2(Hr, Ur);
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(5), He2 = se2(9), nn = se2(57)(false), dn = se2(25)("IE_PROTO");
                  $t.exports = function(yn, Yn) {
                    var Rr, Ur = He2(yn), Hr = 0, si2 = [];
                    for (Rr in Ur)
                      Rr != dn && Re2(Ur, Rr) && si2.push(Rr);
                    for (; Yn.length > Hr; )
                      Re2(Ur, Rr = Yn[Hr++]) && (~nn(si2, Rr) || si2.push(Rr));
                    return si2;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(24);
                  $t.exports = Object("z").propertyIsEnumerable(0) ? Object : function(He2) {
                    return Re2(He2) == "String" ? He2.split("") : Object(He2);
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(39), He2 = se2(27).concat("length", "prototype");
                  Yt.f = Object.getOwnPropertyNames || function(nn) {
                    return Re2(nn, He2);
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(24), He2 = se2(2)("toStringTag"), nn = Re2(function() {
                    return arguments;
                  }()) == "Arguments";
                  $t.exports = function(dn) {
                    var yn, Yn, Rr;
                    return dn === void 0 ? "Undefined" : dn === null ? "Null" : typeof (Yn = function(Ur, Hr) {
                      try {
                        return Ur[Hr];
                      } catch {
                      }
                    }(yn = Object(dn), He2)) == "string" ? Yn : nn ? Re2(yn) : (Rr = Re2(yn)) == "Object" && typeof yn.callee == "function" ? "Arguments" : Rr;
                  };
                }, function($t, Yt) {
                  var se2;
                  se2 = function() {
                    return this;
                  }();
                  try {
                    se2 = se2 || new Function("return this")();
                  } catch {
                    typeof window == "object" && (se2 = window);
                  }
                  $t.exports = se2;
                }, function($t, Yt) {
                  var se2 = /-?\d+(\.\d+)?%?/g;
                  $t.exports = function(Re2) {
                    return Re2.match(se2);
                  };
                }, function($t, Yt, se2) {
                  Object.defineProperty(Yt, "__esModule", { value: true }), Yt.getBase16Theme = Yt.createStyling = Yt.invertTheme = void 0;
                  var Re2 = _i(se2(49)), He2 = _i(se2(76)), nn = _i(se2(81)), dn = _i(se2(89)), yn = _i(se2(93)), Yn = function(Fi2) {
                    if (Fi2 && Fi2.__esModule)
                      return Fi2;
                    var Qi2 = {};
                    if (Fi2 != null)
                      for (var ro in Fi2)
                        Object.prototype.hasOwnProperty.call(Fi2, ro) && (Qi2[ro] = Fi2[ro]);
                    return Qi2.default = Fi2, Qi2;
                  }(se2(94)), Rr = _i(se2(132)), Ur = _i(se2(133)), Hr = _i(se2(138)), si2 = se2(139);
                  function _i(Fi2) {
                    return Fi2 && Fi2.__esModule ? Fi2 : { default: Fi2 };
                  }
                  var Wa2 = Yn.default, Ia2 = (0, dn.default)(Wa2), ts = (0, Hr.default)(Ur.default, si2.rgb2yuv, function(Fi2) {
                    var Qi2, ro = (0, nn.default)(Fi2, 3), Wo = ro[0], Ii2 = ro[1], _l = ro[2];
                    return [(Qi2 = Wo, Qi2 < 0.25 ? 1 : Qi2 < 0.5 ? 0.9 - Qi2 : 1.1 - Qi2), Ii2, _l];
                  }, si2.yuv2rgb, Rr.default), on = function(Fi2) {
                    return function(Qi2) {
                      return { className: [Qi2.className, Fi2.className].filter(Boolean).join(" "), style: (0, He2.default)({}, Qi2.style || {}, Fi2.style || {}) };
                    };
                  }, di2 = function(Fi2, Qi2) {
                    var ro = (0, dn.default)(Qi2);
                    for (var Wo in Fi2)
                      ro.indexOf(Wo) === -1 && ro.push(Wo);
                    return ro.reduce(function(Ii2, _l) {
                      return Ii2[_l] = function(yl, Ra2) {
                        if (yl === void 0)
                          return Ra2;
                        if (Ra2 === void 0)
                          return yl;
                        var Su = yl === void 0 ? "undefined" : (0, Re2.default)(yl), Ga2 = Ra2 === void 0 ? "undefined" : (0, Re2.default)(Ra2);
                        switch (Su) {
                          case "string":
                            switch (Ga2) {
                              case "string":
                                return [Ra2, yl].filter(Boolean).join(" ");
                              case "object":
                                return on({ className: yl, style: Ra2 });
                              case "function":
                                return function(ha2) {
                                  for (var pa2 = arguments.length, hs = Array(pa2 > 1 ? pa2 - 1 : 0), Zo = 1; Zo < pa2; Zo++)
                                    hs[Zo - 1] = arguments[Zo];
                                  return on({ className: yl })(Ra2.apply(void 0, [ha2].concat(hs)));
                                };
                            }
                          case "object":
                            switch (Ga2) {
                              case "string":
                                return on({ className: Ra2, style: yl });
                              case "object":
                                return (0, He2.default)({}, Ra2, yl);
                              case "function":
                                return function(ha2) {
                                  for (var pa2 = arguments.length, hs = Array(pa2 > 1 ? pa2 - 1 : 0), Zo = 1; Zo < pa2; Zo++)
                                    hs[Zo - 1] = arguments[Zo];
                                  return on({ style: yl })(Ra2.apply(void 0, [ha2].concat(hs)));
                                };
                            }
                          case "function":
                            switch (Ga2) {
                              case "string":
                                return function(ha2) {
                                  for (var pa2 = arguments.length, hs = Array(pa2 > 1 ? pa2 - 1 : 0), Zo = 1; Zo < pa2; Zo++)
                                    hs[Zo - 1] = arguments[Zo];
                                  return yl.apply(void 0, [on(ha2)({ className: Ra2 })].concat(hs));
                                };
                              case "object":
                                return function(ha2) {
                                  for (var pa2 = arguments.length, hs = Array(pa2 > 1 ? pa2 - 1 : 0), Zo = 1; Zo < pa2; Zo++)
                                    hs[Zo - 1] = arguments[Zo];
                                  return yl.apply(void 0, [on(ha2)({ style: Ra2 })].concat(hs));
                                };
                              case "function":
                                return function(ha2) {
                                  for (var pa2 = arguments.length, hs = Array(pa2 > 1 ? pa2 - 1 : 0), Zo = 1; Zo < pa2; Zo++)
                                    hs[Zo - 1] = arguments[Zo];
                                  return yl.apply(void 0, [Ra2.apply(void 0, [ha2].concat(hs))].concat(hs));
                                };
                            }
                        }
                      }(Fi2[_l], Qi2[_l]), Ii2;
                    }, {});
                  }, Yi2 = function(Fi2, Qi2) {
                    for (var ro = arguments.length, Wo = Array(ro > 2 ? ro - 2 : 0), Ii2 = 2; Ii2 < ro; Ii2++)
                      Wo[Ii2 - 2] = arguments[Ii2];
                    if (Qi2 === null)
                      return Fi2;
                    Array.isArray(Qi2) || (Qi2 = [Qi2]);
                    var _l = Qi2.map(function(Ra2) {
                      return Fi2[Ra2];
                    }).filter(Boolean), yl = _l.reduce(function(Ra2, Su) {
                      return typeof Su == "string" ? Ra2.className = [Ra2.className, Su].filter(Boolean).join(" ") : (Su === void 0 ? "undefined" : (0, Re2.default)(Su)) === "object" ? Ra2.style = (0, He2.default)({}, Ra2.style, Su) : typeof Su == "function" && (Ra2 = (0, He2.default)({}, Ra2, Su.apply(void 0, [Ra2].concat(Wo)))), Ra2;
                    }, { className: "", style: {} });
                    return yl.className || delete yl.className, (0, dn.default)(yl.style).length === 0 && delete yl.style, yl;
                  }, Oa2 = Yt.invertTheme = function(Fi2) {
                    return (0, dn.default)(Fi2).reduce(function(Qi2, ro) {
                      return Qi2[ro] = /^base/.test(ro) ? ts(Fi2[ro]) : ro === "scheme" ? Fi2[ro] + ":inverted" : Fi2[ro], Qi2;
                    }, {});
                  }, Da2 = (Yt.createStyling = (0, yn.default)(function(Fi2) {
                    for (var Qi2 = arguments.length, ro = Array(Qi2 > 3 ? Qi2 - 3 : 0), Wo = 3; Wo < Qi2; Wo++)
                      ro[Wo - 3] = arguments[Wo];
                    var Ii2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _l = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, yl = Ii2.defaultBase16, Ra2 = yl === void 0 ? Wa2 : yl, Su = Ii2.base16Themes, Ga2 = Su === void 0 ? null : Su, ha2 = Da2(_l, Ga2);
                    ha2 && (_l = (0, He2.default)({}, ha2, _l));
                    var pa2 = Ia2.reduce(function(ep, mh2) {
                      return ep[mh2] = _l[mh2] || Ra2[mh2], ep;
                    }, {}), hs = (0, dn.default)(_l).reduce(function(ep, mh2) {
                      return Ia2.indexOf(mh2) === -1 && (ep[mh2] = _l[mh2]), ep;
                    }, {}), Zo = Fi2(pa2), rc2 = di2(hs, Zo);
                    return (0, yn.default)(Yi2, 2).apply(void 0, [rc2].concat(ro));
                  }, 3), Yt.getBase16Theme = function(Fi2, Qi2) {
                    if (Fi2 && Fi2.extend && (Fi2 = Fi2.extend), typeof Fi2 == "string") {
                      var ro = Fi2.split(":"), Wo = (0, nn.default)(ro, 2), Ii2 = Wo[0], _l = Wo[1];
                      Fi2 = (Qi2 || {})[Ii2] || Yn[Ii2], _l === "inverted" && (Fi2 = Oa2(Fi2));
                    }
                    return Fi2 && Fi2.hasOwnProperty("base00") ? Fi2 : void 0;
                  });
                }, function($t, Yt, se2) {
                  var Re2, He2 = typeof Reflect == "object" ? Reflect : null, nn = He2 && typeof He2.apply == "function" ? He2.apply : function(on, di2, Yi2) {
                    return Function.prototype.apply.call(on, di2, Yi2);
                  };
                  Re2 = He2 && typeof He2.ownKeys == "function" ? He2.ownKeys : Object.getOwnPropertySymbols ? function(on) {
                    return Object.getOwnPropertyNames(on).concat(Object.getOwnPropertySymbols(on));
                  } : function(on) {
                    return Object.getOwnPropertyNames(on);
                  };
                  var dn = Number.isNaN || function(on) {
                    return on != on;
                  };
                  function yn() {
                    yn.init.call(this);
                  }
                  $t.exports = yn, $t.exports.once = function(on, di2) {
                    return new Promise(function(Yi2, Oa2) {
                      function Da2() {
                        Fi2 !== void 0 && on.removeListener("error", Fi2), Yi2([].slice.call(arguments));
                      }
                      var Fi2;
                      di2 !== "error" && (Fi2 = function(Qi2) {
                        on.removeListener(di2, Da2), Oa2(Qi2);
                      }, on.once("error", Fi2)), on.once(di2, Da2);
                    });
                  }, yn.EventEmitter = yn, yn.prototype._events = void 0, yn.prototype._eventsCount = 0, yn.prototype._maxListeners = void 0;
                  var Yn = 10;
                  function Rr(on) {
                    if (typeof on != "function")
                      throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof on);
                  }
                  function Ur(on) {
                    return on._maxListeners === void 0 ? yn.defaultMaxListeners : on._maxListeners;
                  }
                  function Hr(on, di2, Yi2, Oa2) {
                    var Da2, Fi2, Qi2, ro;
                    if (Rr(Yi2), (Fi2 = on._events) === void 0 ? (Fi2 = on._events = /* @__PURE__ */ Object.create(null), on._eventsCount = 0) : (Fi2.newListener !== void 0 && (on.emit("newListener", di2, Yi2.listener ? Yi2.listener : Yi2), Fi2 = on._events), Qi2 = Fi2[di2]), Qi2 === void 0)
                      Qi2 = Fi2[di2] = Yi2, ++on._eventsCount;
                    else if (typeof Qi2 == "function" ? Qi2 = Fi2[di2] = Oa2 ? [Yi2, Qi2] : [Qi2, Yi2] : Oa2 ? Qi2.unshift(Yi2) : Qi2.push(Yi2), (Da2 = Ur(on)) > 0 && Qi2.length > Da2 && !Qi2.warned) {
                      Qi2.warned = true;
                      var Wo = new Error("Possible EventEmitter memory leak detected. " + Qi2.length + " " + String(di2) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                      Wo.name = "MaxListenersExceededWarning", Wo.emitter = on, Wo.type = di2, Wo.count = Qi2.length, ro = Wo, console && console.warn && console.warn(ro);
                    }
                    return on;
                  }
                  function si2() {
                    if (!this.fired)
                      return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
                  }
                  function _i(on, di2, Yi2) {
                    var Oa2 = { fired: false, wrapFn: void 0, target: on, type: di2, listener: Yi2 }, Da2 = si2.bind(Oa2);
                    return Da2.listener = Yi2, Oa2.wrapFn = Da2, Da2;
                  }
                  function Wa2(on, di2, Yi2) {
                    var Oa2 = on._events;
                    if (Oa2 === void 0)
                      return [];
                    var Da2 = Oa2[di2];
                    return Da2 === void 0 ? [] : typeof Da2 == "function" ? Yi2 ? [Da2.listener || Da2] : [Da2] : Yi2 ? function(Fi2) {
                      for (var Qi2 = new Array(Fi2.length), ro = 0; ro < Qi2.length; ++ro)
                        Qi2[ro] = Fi2[ro].listener || Fi2[ro];
                      return Qi2;
                    }(Da2) : ts(Da2, Da2.length);
                  }
                  function Ia2(on) {
                    var di2 = this._events;
                    if (di2 !== void 0) {
                      var Yi2 = di2[on];
                      if (typeof Yi2 == "function")
                        return 1;
                      if (Yi2 !== void 0)
                        return Yi2.length;
                    }
                    return 0;
                  }
                  function ts(on, di2) {
                    for (var Yi2 = new Array(di2), Oa2 = 0; Oa2 < di2; ++Oa2)
                      Yi2[Oa2] = on[Oa2];
                    return Yi2;
                  }
                  Object.defineProperty(yn, "defaultMaxListeners", { enumerable: true, get: function() {
                    return Yn;
                  }, set: function(on) {
                    if (typeof on != "number" || on < 0 || dn(on))
                      throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + on + ".");
                    Yn = on;
                  } }), yn.init = function() {
                    this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
                  }, yn.prototype.setMaxListeners = function(on) {
                    if (typeof on != "number" || on < 0 || dn(on))
                      throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + on + ".");
                    return this._maxListeners = on, this;
                  }, yn.prototype.getMaxListeners = function() {
                    return Ur(this);
                  }, yn.prototype.emit = function(on) {
                    for (var di2 = [], Yi2 = 1; Yi2 < arguments.length; Yi2++)
                      di2.push(arguments[Yi2]);
                    var Oa2 = on === "error", Da2 = this._events;
                    if (Da2 !== void 0)
                      Oa2 = Oa2 && Da2.error === void 0;
                    else if (!Oa2)
                      return false;
                    if (Oa2) {
                      var Fi2;
                      if (di2.length > 0 && (Fi2 = di2[0]), Fi2 instanceof Error)
                        throw Fi2;
                      var Qi2 = new Error("Unhandled error." + (Fi2 ? " (" + Fi2.message + ")" : ""));
                      throw Qi2.context = Fi2, Qi2;
                    }
                    var ro = Da2[on];
                    if (ro === void 0)
                      return false;
                    if (typeof ro == "function")
                      nn(ro, this, di2);
                    else {
                      var Wo = ro.length, Ii2 = ts(ro, Wo);
                      for (Yi2 = 0; Yi2 < Wo; ++Yi2)
                        nn(Ii2[Yi2], this, di2);
                    }
                    return true;
                  }, yn.prototype.addListener = function(on, di2) {
                    return Hr(this, on, di2, false);
                  }, yn.prototype.on = yn.prototype.addListener, yn.prototype.prependListener = function(on, di2) {
                    return Hr(this, on, di2, true);
                  }, yn.prototype.once = function(on, di2) {
                    return Rr(di2), this.on(on, _i(this, on, di2)), this;
                  }, yn.prototype.prependOnceListener = function(on, di2) {
                    return Rr(di2), this.prependListener(on, _i(this, on, di2)), this;
                  }, yn.prototype.removeListener = function(on, di2) {
                    var Yi2, Oa2, Da2, Fi2, Qi2;
                    if (Rr(di2), (Oa2 = this._events) === void 0)
                      return this;
                    if ((Yi2 = Oa2[on]) === void 0)
                      return this;
                    if (Yi2 === di2 || Yi2.listener === di2)
                      --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete Oa2[on], Oa2.removeListener && this.emit("removeListener", on, Yi2.listener || di2));
                    else if (typeof Yi2 != "function") {
                      for (Da2 = -1, Fi2 = Yi2.length - 1; Fi2 >= 0; Fi2--)
                        if (Yi2[Fi2] === di2 || Yi2[Fi2].listener === di2) {
                          Qi2 = Yi2[Fi2].listener, Da2 = Fi2;
                          break;
                        }
                      if (Da2 < 0)
                        return this;
                      Da2 === 0 ? Yi2.shift() : function(ro, Wo) {
                        for (; Wo + 1 < ro.length; Wo++)
                          ro[Wo] = ro[Wo + 1];
                        ro.pop();
                      }(Yi2, Da2), Yi2.length === 1 && (Oa2[on] = Yi2[0]), Oa2.removeListener !== void 0 && this.emit("removeListener", on, Qi2 || di2);
                    }
                    return this;
                  }, yn.prototype.off = yn.prototype.removeListener, yn.prototype.removeAllListeners = function(on) {
                    var di2, Yi2, Oa2;
                    if ((Yi2 = this._events) === void 0)
                      return this;
                    if (Yi2.removeListener === void 0)
                      return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Yi2[on] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Yi2[on]), this;
                    if (arguments.length === 0) {
                      var Da2, Fi2 = Object.keys(Yi2);
                      for (Oa2 = 0; Oa2 < Fi2.length; ++Oa2)
                        (Da2 = Fi2[Oa2]) !== "removeListener" && this.removeAllListeners(Da2);
                      return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
                    }
                    if (typeof (di2 = Yi2[on]) == "function")
                      this.removeListener(on, di2);
                    else if (di2 !== void 0)
                      for (Oa2 = di2.length - 1; Oa2 >= 0; Oa2--)
                        this.removeListener(on, di2[Oa2]);
                    return this;
                  }, yn.prototype.listeners = function(on) {
                    return Wa2(this, on, true);
                  }, yn.prototype.rawListeners = function(on) {
                    return Wa2(this, on, false);
                  }, yn.listenerCount = function(on, di2) {
                    return typeof on.listenerCount == "function" ? on.listenerCount(di2) : Ia2.call(on, di2);
                  }, yn.prototype.listenerCount = Ia2, yn.prototype.eventNames = function() {
                    return this._eventsCount > 0 ? Re2(this._events) : [];
                  };
                }, function($t, Yt, se2) {
                  $t.exports.Dispatcher = se2(140);
                }, function($t, Yt, se2) {
                  $t.exports = se2(142);
                }, function($t, Yt, se2) {
                  Yt.__esModule = true;
                  var Re2 = dn(se2(50)), He2 = dn(se2(65)), nn = typeof He2.default == "function" && typeof Re2.default == "symbol" ? function(yn) {
                    return typeof yn;
                  } : function(yn) {
                    return yn && typeof He2.default == "function" && yn.constructor === He2.default && yn !== He2.default.prototype ? "symbol" : typeof yn;
                  };
                  function dn(yn) {
                    return yn && yn.__esModule ? yn : { default: yn };
                  }
                  Yt.default = typeof He2.default == "function" && nn(Re2.default) === "symbol" ? function(yn) {
                    return yn === void 0 ? "undefined" : nn(yn);
                  } : function(yn) {
                    return yn && typeof He2.default == "function" && yn.constructor === He2.default && yn !== He2.default.prototype ? "symbol" : yn === void 0 ? "undefined" : nn(yn);
                  };
                }, function($t, Yt, se2) {
                  $t.exports = { default: se2(51), __esModule: true };
                }, function($t, Yt, se2) {
                  se2(20), se2(29), $t.exports = se2(30).f("iterator");
                }, function($t, Yt, se2) {
                  var Re2 = se2(21), He2 = se2(22);
                  $t.exports = function(nn) {
                    return function(dn, yn) {
                      var Yn, Rr, Ur = String(He2(dn)), Hr = Re2(yn), si2 = Ur.length;
                      return Hr < 0 || Hr >= si2 ? nn ? "" : void 0 : (Yn = Ur.charCodeAt(Hr)) < 55296 || Yn > 56319 || Hr + 1 === si2 || (Rr = Ur.charCodeAt(Hr + 1)) < 56320 || Rr > 57343 ? nn ? Ur.charAt(Hr) : Yn : nn ? Ur.slice(Hr, Hr + 2) : Rr - 56320 + (Yn - 55296 << 10) + 65536;
                    };
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(54);
                  $t.exports = function(He2, nn, dn) {
                    if (Re2(He2), nn === void 0)
                      return He2;
                    switch (dn) {
                      case 1:
                        return function(yn) {
                          return He2.call(nn, yn);
                        };
                      case 2:
                        return function(yn, Yn) {
                          return He2.call(nn, yn, Yn);
                        };
                      case 3:
                        return function(yn, Yn, Rr) {
                          return He2.call(nn, yn, Yn, Rr);
                        };
                    }
                    return function() {
                      return He2.apply(nn, arguments);
                    };
                  };
                }, function($t, Yt) {
                  $t.exports = function(se2) {
                    if (typeof se2 != "function")
                      throw TypeError(se2 + " is not a function!");
                    return se2;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(38), He2 = se2(16), nn = se2(28), dn = {};
                  se2(6)(dn, se2(2)("iterator"), function() {
                    return this;
                  }), $t.exports = function(yn, Yn, Rr) {
                    yn.prototype = Re2(dn, { next: He2(1, Rr) }), nn(yn, Yn + " Iterator");
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(7), He2 = se2(10), nn = se2(13);
                  $t.exports = se2(4) ? Object.defineProperties : function(dn, yn) {
                    He2(dn);
                    for (var Yn, Rr = nn(yn), Ur = Rr.length, Hr = 0; Ur > Hr; )
                      Re2.f(dn, Yn = Rr[Hr++], yn[Yn]);
                    return dn;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(9), He2 = se2(58), nn = se2(59);
                  $t.exports = function(dn) {
                    return function(yn, Yn, Rr) {
                      var Ur, Hr = Re2(yn), si2 = He2(Hr.length), _i = nn(Rr, si2);
                      if (dn && Yn != Yn) {
                        for (; si2 > _i; )
                          if ((Ur = Hr[_i++]) != Ur)
                            return true;
                      } else
                        for (; si2 > _i; _i++)
                          if ((dn || _i in Hr) && Hr[_i] === Yn)
                            return dn || _i || 0;
                      return !dn && -1;
                    };
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(21), He2 = Math.min;
                  $t.exports = function(nn) {
                    return nn > 0 ? He2(Re2(nn), 9007199254740991) : 0;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(21), He2 = Math.max, nn = Math.min;
                  $t.exports = function(dn, yn) {
                    return (dn = Re2(dn)) < 0 ? He2(dn + yn, 0) : nn(dn, yn);
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(3).document;
                  $t.exports = Re2 && Re2.documentElement;
                }, function($t, Yt, se2) {
                  var Re2 = se2(5), He2 = se2(18), nn = se2(25)("IE_PROTO"), dn = Object.prototype;
                  $t.exports = Object.getPrototypeOf || function(yn) {
                    return yn = He2(yn), Re2(yn, nn) ? yn[nn] : typeof yn.constructor == "function" && yn instanceof yn.constructor ? yn.constructor.prototype : yn instanceof Object ? dn : null;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(63), He2 = se2(64), nn = se2(12), dn = se2(9);
                  $t.exports = se2(34)(Array, "Array", function(yn, Yn) {
                    this._t = dn(yn), this._i = 0, this._k = Yn;
                  }, function() {
                    var yn = this._t, Yn = this._k, Rr = this._i++;
                    return !yn || Rr >= yn.length ? (this._t = void 0, He2(1)) : He2(0, Yn == "keys" ? Rr : Yn == "values" ? yn[Rr] : [Rr, yn[Rr]]);
                  }, "values"), nn.Arguments = nn.Array, Re2("keys"), Re2("values"), Re2("entries");
                }, function($t, Yt) {
                  $t.exports = function() {
                  };
                }, function($t, Yt) {
                  $t.exports = function(se2, Re2) {
                    return { value: Re2, done: !!se2 };
                  };
                }, function($t, Yt, se2) {
                  $t.exports = { default: se2(66), __esModule: true };
                }, function($t, Yt, se2) {
                  se2(67), se2(73), se2(74), se2(75), $t.exports = se2(1).Symbol;
                }, function($t, Yt, se2) {
                  var Re2 = se2(3), He2 = se2(5), nn = se2(4), dn = se2(15), yn = se2(37), Yn = se2(68).KEY, Rr = se2(8), Ur = se2(26), Hr = se2(28), si2 = se2(17), _i = se2(2), Wa2 = se2(30), Ia2 = se2(31), ts = se2(69), on = se2(70), di2 = se2(10), Yi2 = se2(11), Oa2 = se2(18), Da2 = se2(9), Fi2 = se2(23), Qi2 = se2(16), ro = se2(38), Wo = se2(71), Ii2 = se2(72), _l = se2(32), yl = se2(7), Ra2 = se2(13), Su = Ii2.f, Ga2 = yl.f, ha2 = Wo.f, pa2 = Re2.Symbol, hs = Re2.JSON, Zo = hs && hs.stringify, rc2 = _i("_hidden"), ep = _i("toPrimitive"), mh2 = {}.propertyIsEnumerable, Cf2 = Ur("symbol-registry"), Gd2 = Ur("symbols"), bh2 = Ur("op-symbols"), Gp = Object.prototype, $v = typeof pa2 == "function" && !!_l.f, B0 = Re2.QObject, uS = !B0 || !B0.prototype || !B0.prototype.findChild, FM = nn && Rr(function() {
                    return ro(Ga2({}, "a", { get: function() {
                      return Ga2(this, "a", { value: 7 }).a;
                    } })).a != 7;
                  }) ? function($i2, xo, Os) {
                    var Kl = Su(Gp, xo);
                    Kl && delete Gp[xo], Ga2($i2, xo, Os), Kl && $i2 !== Gp && Ga2(Gp, xo, Kl);
                  } : Ga2, Ry = function($i2) {
                    var xo = Gd2[$i2] = ro(pa2.prototype);
                    return xo._k = $i2, xo;
                  }, Rx = $v && typeof pa2.iterator == "symbol" ? function($i2) {
                    return typeof $i2 == "symbol";
                  } : function($i2) {
                    return $i2 instanceof pa2;
                  }, PT = function($i2, xo, Os) {
                    return $i2 === Gp && PT(bh2, xo, Os), di2($i2), xo = Fi2(xo, true), di2(Os), He2(Gd2, xo) ? (Os.enumerable ? (He2($i2, rc2) && $i2[rc2][xo] && ($i2[rc2][xo] = false), Os = ro(Os, { enumerable: Qi2(0, false) })) : (He2($i2, rc2) || Ga2($i2, rc2, Qi2(1, {})), $i2[rc2][xo] = true), FM($i2, xo, Os)) : Ga2($i2, xo, Os);
                  }, u_ = function($i2, xo) {
                    di2($i2);
                    for (var Os, Kl = ts(xo = Da2(xo)), Iu = 0, Tf2 = Kl.length; Tf2 > Iu; )
                      PT($i2, Os = Kl[Iu++], xo[Os]);
                    return $i2;
                  }, ib2 = function($i2) {
                    var xo = mh2.call(this, $i2 = Fi2($i2, true));
                    return !(this === Gp && He2(Gd2, $i2) && !He2(bh2, $i2)) && (!(xo || !He2(this, $i2) || !He2(Gd2, $i2) || He2(this, rc2) && this[rc2][$i2]) || xo);
                  }, VM = function($i2, xo) {
                    if ($i2 = Da2($i2), xo = Fi2(xo, true), $i2 !== Gp || !He2(Gd2, xo) || He2(bh2, xo)) {
                      var Os = Su($i2, xo);
                      return !Os || !He2(Gd2, xo) || He2($i2, rc2) && $i2[rc2][xo] || (Os.enumerable = true), Os;
                    }
                  }, cS = function($i2) {
                    for (var xo, Os = ha2(Da2($i2)), Kl = [], Iu = 0; Os.length > Iu; )
                      He2(Gd2, xo = Os[Iu++]) || xo == rc2 || xo == Yn || Kl.push(xo);
                    return Kl;
                  }, d0 = function($i2) {
                    for (var xo, Os = $i2 === Gp, Kl = ha2(Os ? bh2 : Da2($i2)), Iu = [], Tf2 = 0; Kl.length > Tf2; )
                      !He2(Gd2, xo = Kl[Tf2++]) || Os && !He2(Gp, xo) || Iu.push(Gd2[xo]);
                    return Iu;
                  };
                  $v || (yn((pa2 = function() {
                    if (this instanceof pa2)
                      throw TypeError("Symbol is not a constructor!");
                    var $i2 = si2(arguments.length > 0 ? arguments[0] : void 0), xo = function(Os) {
                      this === Gp && xo.call(bh2, Os), He2(this, rc2) && He2(this[rc2], $i2) && (this[rc2][$i2] = false), FM(this, $i2, Qi2(1, Os));
                    };
                    return nn && uS && FM(Gp, $i2, { configurable: true, set: xo }), Ry($i2);
                  }).prototype, "toString", function() {
                    return this._k;
                  }), Ii2.f = VM, yl.f = PT, se2(41).f = Wo.f = cS, se2(19).f = ib2, _l.f = d0, nn && !se2(14) && yn(Gp, "propertyIsEnumerable", ib2, true), Wa2.f = function($i2) {
                    return Ry(_i($i2));
                  }), dn(dn.G + dn.W + dn.F * !$v, { Symbol: pa2 });
                  for (var fy = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Vg2 = 0; fy.length > Vg2; )
                    _i(fy[Vg2++]);
                  for (var _u = Ra2(_i.store), lo = 0; _u.length > lo; )
                    Ia2(_u[lo++]);
                  dn(dn.S + dn.F * !$v, "Symbol", { for: function($i2) {
                    return He2(Cf2, $i2 += "") ? Cf2[$i2] : Cf2[$i2] = pa2($i2);
                  }, keyFor: function($i2) {
                    if (!Rx($i2))
                      throw TypeError($i2 + " is not a symbol!");
                    for (var xo in Cf2)
                      if (Cf2[xo] === $i2)
                        return xo;
                  }, useSetter: function() {
                    uS = true;
                  }, useSimple: function() {
                    uS = false;
                  } }), dn(dn.S + dn.F * !$v, "Object", { create: function($i2, xo) {
                    return xo === void 0 ? ro($i2) : u_(ro($i2), xo);
                  }, defineProperty: PT, defineProperties: u_, getOwnPropertyDescriptor: VM, getOwnPropertyNames: cS, getOwnPropertySymbols: d0 });
                  var na2 = Rr(function() {
                    _l.f(1);
                  });
                  dn(dn.S + dn.F * na2, "Object", { getOwnPropertySymbols: function($i2) {
                    return _l.f(Oa2($i2));
                  } }), hs && dn(dn.S + dn.F * (!$v || Rr(function() {
                    var $i2 = pa2();
                    return Zo([$i2]) != "[null]" || Zo({ a: $i2 }) != "{}" || Zo(Object($i2)) != "{}";
                  })), "JSON", { stringify: function($i2) {
                    for (var xo, Os, Kl = [$i2], Iu = 1; arguments.length > Iu; )
                      Kl.push(arguments[Iu++]);
                    if (Os = xo = Kl[1], (Yi2(xo) || $i2 !== void 0) && !Rx($i2))
                      return on(xo) || (xo = function(Tf2, ud2) {
                        if (typeof Os == "function" && (ud2 = Os.call(this, Tf2, ud2)), !Rx(ud2))
                          return ud2;
                      }), Kl[1] = xo, Zo.apply(hs, Kl);
                  } }), pa2.prototype[ep] || se2(6)(pa2.prototype, ep, pa2.prototype.valueOf), Hr(pa2, "Symbol"), Hr(Math, "Math", true), Hr(Re2.JSON, "JSON", true);
                }, function($t, Yt, se2) {
                  var Re2 = se2(17)("meta"), He2 = se2(11), nn = se2(5), dn = se2(7).f, yn = 0, Yn = Object.isExtensible || function() {
                    return true;
                  }, Rr = !se2(8)(function() {
                    return Yn(Object.preventExtensions({}));
                  }), Ur = function(si2) {
                    dn(si2, Re2, { value: { i: "O" + ++yn, w: {} } });
                  }, Hr = $t.exports = { KEY: Re2, NEED: false, fastKey: function(si2, _i) {
                    if (!He2(si2))
                      return typeof si2 == "symbol" ? si2 : (typeof si2 == "string" ? "S" : "P") + si2;
                    if (!nn(si2, Re2)) {
                      if (!Yn(si2))
                        return "F";
                      if (!_i)
                        return "E";
                      Ur(si2);
                    }
                    return si2[Re2].i;
                  }, getWeak: function(si2, _i) {
                    if (!nn(si2, Re2)) {
                      if (!Yn(si2))
                        return true;
                      if (!_i)
                        return false;
                      Ur(si2);
                    }
                    return si2[Re2].w;
                  }, onFreeze: function(si2) {
                    return Rr && Hr.NEED && Yn(si2) && !nn(si2, Re2) && Ur(si2), si2;
                  } };
                }, function($t, Yt, se2) {
                  var Re2 = se2(13), He2 = se2(32), nn = se2(19);
                  $t.exports = function(dn) {
                    var yn = Re2(dn), Yn = He2.f;
                    if (Yn)
                      for (var Rr, Ur = Yn(dn), Hr = nn.f, si2 = 0; Ur.length > si2; )
                        Hr.call(dn, Rr = Ur[si2++]) && yn.push(Rr);
                    return yn;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(24);
                  $t.exports = Array.isArray || function(He2) {
                    return Re2(He2) == "Array";
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(9), He2 = se2(41).f, nn = {}.toString, dn = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
                  $t.exports.f = function(yn) {
                    return dn && nn.call(yn) == "[object Window]" ? function(Yn) {
                      try {
                        return He2(Yn);
                      } catch {
                        return dn.slice();
                      }
                    }(yn) : He2(Re2(yn));
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(19), He2 = se2(16), nn = se2(9), dn = se2(23), yn = se2(5), Yn = se2(35), Rr = Object.getOwnPropertyDescriptor;
                  Yt.f = se2(4) ? Rr : function(Ur, Hr) {
                    if (Ur = nn(Ur), Hr = dn(Hr, true), Yn)
                      try {
                        return Rr(Ur, Hr);
                      } catch {
                      }
                    if (yn(Ur, Hr))
                      return He2(!Re2.f.call(Ur, Hr), Ur[Hr]);
                  };
                }, function($t, Yt) {
                }, function($t, Yt, se2) {
                  se2(31)("asyncIterator");
                }, function($t, Yt, se2) {
                  se2(31)("observable");
                }, function($t, Yt, se2) {
                  Yt.__esModule = true;
                  var Re2, He2 = se2(77), nn = (Re2 = He2) && Re2.__esModule ? Re2 : { default: Re2 };
                  Yt.default = nn.default || function(dn) {
                    for (var yn = 1; yn < arguments.length; yn++) {
                      var Yn = arguments[yn];
                      for (var Rr in Yn)
                        Object.prototype.hasOwnProperty.call(Yn, Rr) && (dn[Rr] = Yn[Rr]);
                    }
                    return dn;
                  };
                }, function($t, Yt, se2) {
                  $t.exports = { default: se2(78), __esModule: true };
                }, function($t, Yt, se2) {
                  se2(79), $t.exports = se2(1).Object.assign;
                }, function($t, Yt, se2) {
                  var Re2 = se2(15);
                  Re2(Re2.S + Re2.F, "Object", { assign: se2(80) });
                }, function($t, Yt, se2) {
                  var Re2 = se2(4), He2 = se2(13), nn = se2(32), dn = se2(19), yn = se2(18), Yn = se2(40), Rr = Object.assign;
                  $t.exports = !Rr || se2(8)(function() {
                    var Ur = {}, Hr = {}, si2 = Symbol(), _i = "abcdefghijklmnopqrst";
                    return Ur[si2] = 7, _i.split("").forEach(function(Wa2) {
                      Hr[Wa2] = Wa2;
                    }), Rr({}, Ur)[si2] != 7 || Object.keys(Rr({}, Hr)).join("") != _i;
                  }) ? function(Ur, Hr) {
                    for (var si2 = yn(Ur), _i = arguments.length, Wa2 = 1, Ia2 = nn.f, ts = dn.f; _i > Wa2; )
                      for (var on, di2 = Yn(arguments[Wa2++]), Yi2 = Ia2 ? He2(di2).concat(Ia2(di2)) : He2(di2), Oa2 = Yi2.length, Da2 = 0; Oa2 > Da2; )
                        on = Yi2[Da2++], Re2 && !ts.call(di2, on) || (si2[on] = di2[on]);
                    return si2;
                  } : Rr;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true;
                  var Re2 = nn(se2(82)), He2 = nn(se2(85));
                  function nn(dn) {
                    return dn && dn.__esModule ? dn : { default: dn };
                  }
                  Yt.default = function(dn, yn) {
                    if (Array.isArray(dn))
                      return dn;
                    if ((0, Re2.default)(Object(dn)))
                      return function(Yn, Rr) {
                        var Ur = [], Hr = true, si2 = false, _i = void 0;
                        try {
                          for (var Wa2, Ia2 = (0, He2.default)(Yn); !(Hr = (Wa2 = Ia2.next()).done) && (Ur.push(Wa2.value), !Rr || Ur.length !== Rr); Hr = true)
                            ;
                        } catch (ts) {
                          si2 = true, _i = ts;
                        } finally {
                          try {
                            !Hr && Ia2.return && Ia2.return();
                          } finally {
                            if (si2)
                              throw _i;
                          }
                        }
                        return Ur;
                      }(dn, yn);
                    throw new TypeError("Invalid attempt to destructure non-iterable instance");
                  };
                }, function($t, Yt, se2) {
                  $t.exports = { default: se2(83), __esModule: true };
                }, function($t, Yt, se2) {
                  se2(29), se2(20), $t.exports = se2(84);
                }, function($t, Yt, se2) {
                  var Re2 = se2(42), He2 = se2(2)("iterator"), nn = se2(12);
                  $t.exports = se2(1).isIterable = function(dn) {
                    var yn = Object(dn);
                    return yn[He2] !== void 0 || "@@iterator" in yn || nn.hasOwnProperty(Re2(yn));
                  };
                }, function($t, Yt, se2) {
                  $t.exports = { default: se2(86), __esModule: true };
                }, function($t, Yt, se2) {
                  se2(29), se2(20), $t.exports = se2(87);
                }, function($t, Yt, se2) {
                  var Re2 = se2(10), He2 = se2(88);
                  $t.exports = se2(1).getIterator = function(nn) {
                    var dn = He2(nn);
                    if (typeof dn != "function")
                      throw TypeError(nn + " is not iterable!");
                    return Re2(dn.call(nn));
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(42), He2 = se2(2)("iterator"), nn = se2(12);
                  $t.exports = se2(1).getIteratorMethod = function(dn) {
                    if (dn != null)
                      return dn[He2] || dn["@@iterator"] || nn[Re2(dn)];
                  };
                }, function($t, Yt, se2) {
                  $t.exports = { default: se2(90), __esModule: true };
                }, function($t, Yt, se2) {
                  se2(91), $t.exports = se2(1).Object.keys;
                }, function($t, Yt, se2) {
                  var Re2 = se2(18), He2 = se2(13);
                  se2(92)("keys", function() {
                    return function(nn) {
                      return He2(Re2(nn));
                    };
                  });
                }, function($t, Yt, se2) {
                  var Re2 = se2(15), He2 = se2(1), nn = se2(8);
                  $t.exports = function(dn, yn) {
                    var Yn = (He2.Object || {})[dn] || Object[dn], Rr = {};
                    Rr[dn] = yn(Yn), Re2(Re2.S + Re2.F * nn(function() {
                      Yn(1);
                    }), "Object", Rr);
                  };
                }, function($t, Yt, se2) {
                  (function(Re2) {
                    var He2 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], nn = /^\s+|\s+$/g, dn = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, yn = /\{\n\/\* \[wrapped with (.+)\] \*/, Yn = /,? & /, Rr = /^[-+]0x[0-9a-f]+$/i, Ur = /^0b[01]+$/i, Hr = /^\[object .+?Constructor\]$/, si2 = /^0o[0-7]+$/i, _i = /^(?:0|[1-9]\d*)$/, Wa2 = parseInt, Ia2 = typeof Re2 == "object" && Re2 && Re2.Object === Object && Re2, ts = typeof self == "object" && self && self.Object === Object && self, on = Ia2 || ts || Function("return this")();
                    function di2(lo, na2, $i2) {
                      switch ($i2.length) {
                        case 0:
                          return lo.call(na2);
                        case 1:
                          return lo.call(na2, $i2[0]);
                        case 2:
                          return lo.call(na2, $i2[0], $i2[1]);
                        case 3:
                          return lo.call(na2, $i2[0], $i2[1], $i2[2]);
                      }
                      return lo.apply(na2, $i2);
                    }
                    function Yi2(lo, na2) {
                      return !!(lo && lo.length) && function($i2, xo, Os) {
                        if (xo != xo)
                          return function(Tf2, ud2, iv, Bg2) {
                            for (var z0 = Tf2.length, zg2 = iv + (Bg2 ? 1 : -1); Bg2 ? zg2-- : ++zg2 < z0; )
                              if (ud2(Tf2[zg2], zg2, Tf2))
                                return zg2;
                            return -1;
                          }($i2, Oa2, Os);
                        for (var Kl = Os - 1, Iu = $i2.length; ++Kl < Iu; )
                          if ($i2[Kl] === xo)
                            return Kl;
                        return -1;
                      }(lo, na2, 0) > -1;
                    }
                    function Oa2(lo) {
                      return lo != lo;
                    }
                    function Da2(lo, na2) {
                      for (var $i2 = lo.length, xo = 0; $i2--; )
                        lo[$i2] === na2 && xo++;
                      return xo;
                    }
                    function Fi2(lo, na2) {
                      for (var $i2 = -1, xo = lo.length, Os = 0, Kl = []; ++$i2 < xo; ) {
                        var Iu = lo[$i2];
                        Iu !== na2 && Iu !== "__lodash_placeholder__" || (lo[$i2] = "__lodash_placeholder__", Kl[Os++] = $i2);
                      }
                      return Kl;
                    }
                    var Qi2, ro, Wo, Ii2 = Function.prototype, _l = Object.prototype, yl = on["__core-js_shared__"], Ra2 = (Qi2 = /[^.]+$/.exec(yl && yl.keys && yl.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Qi2 : "", Su = Ii2.toString, Ga2 = _l.hasOwnProperty, ha2 = _l.toString, pa2 = RegExp("^" + Su.call(Ga2).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), hs = Object.create, Zo = Math.max, rc2 = Math.min, ep = (ro = Ry(Object, "defineProperty"), (Wo = Ry.name) && Wo.length > 2 ? ro : void 0);
                    function mh2(lo) {
                      return fy(lo) ? hs(lo) : {};
                    }
                    function Cf2(lo) {
                      return !(!fy(lo) || function(na2) {
                        return !!Ra2 && Ra2 in na2;
                      }(lo)) && (function(na2) {
                        var $i2 = fy(na2) ? ha2.call(na2) : "";
                        return $i2 == "[object Function]" || $i2 == "[object GeneratorFunction]";
                      }(lo) || function(na2) {
                        var $i2 = false;
                        if (na2 != null && typeof na2.toString != "function")
                          try {
                            $i2 = !!(na2 + "");
                          } catch {
                          }
                        return $i2;
                      }(lo) ? pa2 : Hr).test(function(na2) {
                        if (na2 != null) {
                          try {
                            return Su.call(na2);
                          } catch {
                          }
                          try {
                            return na2 + "";
                          } catch {
                          }
                        }
                        return "";
                      }(lo));
                    }
                    function Gd2(lo, na2, $i2, xo) {
                      for (var Os = -1, Kl = lo.length, Iu = $i2.length, Tf2 = -1, ud2 = na2.length, iv = Zo(Kl - Iu, 0), Bg2 = Array(ud2 + iv), z0 = !xo; ++Tf2 < ud2; )
                        Bg2[Tf2] = na2[Tf2];
                      for (; ++Os < Iu; )
                        (z0 || Os < Kl) && (Bg2[$i2[Os]] = lo[Os]);
                      for (; iv--; )
                        Bg2[Tf2++] = lo[Os++];
                      return Bg2;
                    }
                    function bh2(lo, na2, $i2, xo) {
                      for (var Os = -1, Kl = lo.length, Iu = -1, Tf2 = $i2.length, ud2 = -1, iv = na2.length, Bg2 = Zo(Kl - Tf2, 0), z0 = Array(Bg2 + iv), zg2 = !xo; ++Os < Bg2; )
                        z0[Os] = lo[Os];
                      for (var c_ = Os; ++ud2 < iv; )
                        z0[c_ + ud2] = na2[ud2];
                      for (; ++Iu < Tf2; )
                        (zg2 || Os < Kl) && (z0[c_ + $i2[Iu]] = lo[Os++]);
                      return z0;
                    }
                    function Gp(lo) {
                      return function() {
                        var na2 = arguments;
                        switch (na2.length) {
                          case 0:
                            return new lo();
                          case 1:
                            return new lo(na2[0]);
                          case 2:
                            return new lo(na2[0], na2[1]);
                          case 3:
                            return new lo(na2[0], na2[1], na2[2]);
                          case 4:
                            return new lo(na2[0], na2[1], na2[2], na2[3]);
                          case 5:
                            return new lo(na2[0], na2[1], na2[2], na2[3], na2[4]);
                          case 6:
                            return new lo(na2[0], na2[1], na2[2], na2[3], na2[4], na2[5]);
                          case 7:
                            return new lo(na2[0], na2[1], na2[2], na2[3], na2[4], na2[5], na2[6]);
                        }
                        var $i2 = mh2(lo.prototype), xo = lo.apply($i2, na2);
                        return fy(xo) ? xo : $i2;
                      };
                    }
                    function $v(lo, na2, $i2, xo, Os, Kl, Iu, Tf2, ud2, iv) {
                      var Bg2 = 128 & na2, z0 = 1 & na2, zg2 = 2 & na2, c_ = 24 & na2, Nx = 512 & na2, Ny = zg2 ? void 0 : Gp(lo);
                      return function Hd2() {
                        for (var Yv = arguments.length, np = Array(Yv), hy = Yv; hy--; )
                          np[hy] = arguments[hy];
                        if (c_)
                          var ab2 = FM(Hd2), BM = Da2(np, ab2);
                        if (xo && (np = Gd2(np, xo, Os, c_)), Kl && (np = bh2(np, Kl, Iu, c_)), Yv -= BM, c_ && Yv < iv) {
                          var i1 = Fi2(np, ab2);
                          return B0(lo, na2, $v, Hd2.placeholder, $i2, np, i1, Tf2, ud2, iv - Yv);
                        }
                        var f_ = z0 ? $i2 : this, fS = zg2 ? f_[lo] : lo;
                        return Yv = np.length, Tf2 ? np = ib2(np, Tf2) : Nx && Yv > 1 && np.reverse(), Bg2 && ud2 < Yv && (np.length = ud2), this && this !== on && this instanceof Hd2 && (fS = Ny || Gp(fS)), fS.apply(f_, np);
                      };
                    }
                    function B0(lo, na2, $i2, xo, Os, Kl, Iu, Tf2, ud2, iv) {
                      var Bg2 = 8 & na2;
                      na2 |= Bg2 ? 32 : 64, 4 & (na2 &= ~(Bg2 ? 64 : 32)) || (na2 &= -4);
                      var z0 = $i2(lo, na2, Os, Bg2 ? Kl : void 0, Bg2 ? Iu : void 0, Bg2 ? void 0 : Kl, Bg2 ? void 0 : Iu, Tf2, ud2, iv);
                      return z0.placeholder = xo, VM(z0, lo, na2);
                    }
                    function uS(lo, na2, $i2, xo, Os, Kl, Iu, Tf2) {
                      var ud2 = 2 & na2;
                      if (!ud2 && typeof lo != "function")
                        throw new TypeError("Expected a function");
                      var iv = xo ? xo.length : 0;
                      if (iv || (na2 &= -97, xo = Os = void 0), Iu = Iu === void 0 ? Iu : Zo(_u(Iu), 0), Tf2 = Tf2 === void 0 ? Tf2 : _u(Tf2), iv -= Os ? Os.length : 0, 64 & na2) {
                        var Bg2 = xo, z0 = Os;
                        xo = Os = void 0;
                      }
                      var zg2 = [lo, na2, $i2, xo, Os, Bg2, z0, Kl, Iu, Tf2];
                      if (lo = zg2[0], na2 = zg2[1], $i2 = zg2[2], xo = zg2[3], Os = zg2[4], !(Tf2 = zg2[9] = zg2[9] == null ? ud2 ? 0 : lo.length : Zo(zg2[9] - iv, 0)) && 24 & na2 && (na2 &= -25), na2 && na2 != 1)
                        c_ = na2 == 8 || na2 == 16 ? function(Nx, Ny, Hd2) {
                          var Yv = Gp(Nx);
                          return function np() {
                            for (var hy = arguments.length, ab2 = Array(hy), BM = hy, i1 = FM(np); BM--; )
                              ab2[BM] = arguments[BM];
                            var f_ = hy < 3 && ab2[0] !== i1 && ab2[hy - 1] !== i1 ? [] : Fi2(ab2, i1);
                            if ((hy -= f_.length) < Hd2)
                              return B0(Nx, Ny, $v, np.placeholder, void 0, ab2, f_, void 0, void 0, Hd2 - hy);
                            var fS = this && this !== on && this instanceof np ? Yv : Nx;
                            return di2(fS, this, ab2);
                          };
                        }(lo, na2, Tf2) : na2 != 32 && na2 != 33 || Os.length ? $v.apply(void 0, zg2) : function(Nx, Ny, Hd2, Yv) {
                          var np = 1 & Ny, hy = Gp(Nx);
                          return function ab2() {
                            for (var BM = -1, i1 = arguments.length, f_ = -1, fS = Yv.length, fL = Array(fS + i1), o5 = this && this !== on && this instanceof ab2 ? hy : Nx; ++f_ < fS; )
                              fL[f_] = Yv[f_];
                            for (; i1--; )
                              fL[f_++] = arguments[++BM];
                            return di2(o5, np ? Hd2 : this, fL);
                          };
                        }(lo, na2, $i2, xo);
                      else
                        var c_ = function(Nx, Ny, Hd2) {
                          var Yv = 1 & Ny, np = Gp(Nx);
                          return function hy() {
                            var ab2 = this && this !== on && this instanceof hy ? np : Nx;
                            return ab2.apply(Yv ? Hd2 : this, arguments);
                          };
                        }(lo, na2, $i2);
                      return VM(c_, lo, na2);
                    }
                    function FM(lo) {
                      return lo.placeholder;
                    }
                    function Ry(lo, na2) {
                      var $i2 = function(xo, Os) {
                        return xo == null ? void 0 : xo[Os];
                      }(lo, na2);
                      return Cf2($i2) ? $i2 : void 0;
                    }
                    function Rx(lo) {
                      var na2 = lo.match(yn);
                      return na2 ? na2[1].split(Yn) : [];
                    }
                    function PT(lo, na2) {
                      var $i2 = na2.length, xo = $i2 - 1;
                      return na2[xo] = ($i2 > 1 ? "& " : "") + na2[xo], na2 = na2.join($i2 > 2 ? ", " : " "), lo.replace(dn, `{
/* [wrapped with ` + na2 + `] */
`);
                    }
                    function u_(lo, na2) {
                      return !!(na2 = na2 == null ? 9007199254740991 : na2) && (typeof lo == "number" || _i.test(lo)) && lo > -1 && lo % 1 == 0 && lo < na2;
                    }
                    function ib2(lo, na2) {
                      for (var $i2 = lo.length, xo = rc2(na2.length, $i2), Os = function(Iu, Tf2) {
                        var ud2 = -1, iv = Iu.length;
                        for (Tf2 || (Tf2 = Array(iv)); ++ud2 < iv; )
                          Tf2[ud2] = Iu[ud2];
                        return Tf2;
                      }(lo); xo--; ) {
                        var Kl = na2[xo];
                        lo[xo] = u_(Kl, $i2) ? Os[Kl] : void 0;
                      }
                      return lo;
                    }
                    var VM = ep ? function(lo, na2, $i2) {
                      var xo, Os = na2 + "";
                      return ep(lo, "toString", { configurable: true, enumerable: false, value: (xo = PT(Os, cS(Rx(Os), $i2)), function() {
                        return xo;
                      }) });
                    } : function(lo) {
                      return lo;
                    };
                    function cS(lo, na2) {
                      return function($i2, xo) {
                        for (var Os = -1, Kl = $i2 ? $i2.length : 0; ++Os < Kl && xo($i2[Os], Os, $i2) !== false; )
                          ;
                      }(He2, function($i2) {
                        var xo = "_." + $i2[0];
                        na2 & $i2[1] && !Yi2(lo, xo) && lo.push(xo);
                      }), lo.sort();
                    }
                    function d0(lo, na2, $i2) {
                      var xo = uS(lo, 8, void 0, void 0, void 0, void 0, void 0, na2 = $i2 ? void 0 : na2);
                      return xo.placeholder = d0.placeholder, xo;
                    }
                    function fy(lo) {
                      var na2 = typeof lo;
                      return !!lo && (na2 == "object" || na2 == "function");
                    }
                    function Vg2(lo) {
                      return lo ? (lo = function(na2) {
                        if (typeof na2 == "number")
                          return na2;
                        if (function(Os) {
                          return typeof Os == "symbol" || function(Kl) {
                            return !!Kl && typeof Kl == "object";
                          }(Os) && ha2.call(Os) == "[object Symbol]";
                        }(na2))
                          return NaN;
                        if (fy(na2)) {
                          var $i2 = typeof na2.valueOf == "function" ? na2.valueOf() : na2;
                          na2 = fy($i2) ? $i2 + "" : $i2;
                        }
                        if (typeof na2 != "string")
                          return na2 === 0 ? na2 : +na2;
                        na2 = na2.replace(nn, "");
                        var xo = Ur.test(na2);
                        return xo || si2.test(na2) ? Wa2(na2.slice(2), xo ? 2 : 8) : Rr.test(na2) ? NaN : +na2;
                      }(lo)) === 1 / 0 || lo === -1 / 0 ? 17976931348623157e292 * (lo < 0 ? -1 : 1) : lo == lo ? lo : 0 : lo === 0 ? lo : 0;
                    }
                    function _u(lo) {
                      var na2 = Vg2(lo), $i2 = na2 % 1;
                      return na2 == na2 ? $i2 ? na2 - $i2 : na2 : 0;
                    }
                    d0.placeholder = {}, $t.exports = d0;
                  }).call(this, se2(43));
                }, function($t, Yt, se2) {
                  function Re2(bh2) {
                    return bh2 && bh2.__esModule ? bh2.default : bh2;
                  }
                  Yt.__esModule = true;
                  var He2 = se2(95);
                  Yt.threezerotwofour = Re2(He2);
                  var nn = se2(96);
                  Yt.apathy = Re2(nn);
                  var dn = se2(97);
                  Yt.ashes = Re2(dn);
                  var yn = se2(98);
                  Yt.atelierDune = Re2(yn);
                  var Yn = se2(99);
                  Yt.atelierForest = Re2(Yn);
                  var Rr = se2(100);
                  Yt.atelierHeath = Re2(Rr);
                  var Ur = se2(101);
                  Yt.atelierLakeside = Re2(Ur);
                  var Hr = se2(102);
                  Yt.atelierSeaside = Re2(Hr);
                  var si2 = se2(103);
                  Yt.bespin = Re2(si2);
                  var _i = se2(104);
                  Yt.brewer = Re2(_i);
                  var Wa2 = se2(105);
                  Yt.bright = Re2(Wa2);
                  var Ia2 = se2(106);
                  Yt.chalk = Re2(Ia2);
                  var ts = se2(107);
                  Yt.codeschool = Re2(ts);
                  var on = se2(108);
                  Yt.colors = Re2(on);
                  var di2 = se2(109);
                  Yt.default = Re2(di2);
                  var Yi2 = se2(110);
                  Yt.eighties = Re2(Yi2);
                  var Oa2 = se2(111);
                  Yt.embers = Re2(Oa2);
                  var Da2 = se2(112);
                  Yt.flat = Re2(Da2);
                  var Fi2 = se2(113);
                  Yt.google = Re2(Fi2);
                  var Qi2 = se2(114);
                  Yt.grayscale = Re2(Qi2);
                  var ro = se2(115);
                  Yt.greenscreen = Re2(ro);
                  var Wo = se2(116);
                  Yt.harmonic = Re2(Wo);
                  var Ii2 = se2(117);
                  Yt.hopscotch = Re2(Ii2);
                  var _l = se2(118);
                  Yt.isotope = Re2(_l);
                  var yl = se2(119);
                  Yt.marrakesh = Re2(yl);
                  var Ra2 = se2(120);
                  Yt.mocha = Re2(Ra2);
                  var Su = se2(121);
                  Yt.monokai = Re2(Su);
                  var Ga2 = se2(122);
                  Yt.ocean = Re2(Ga2);
                  var ha2 = se2(123);
                  Yt.paraiso = Re2(ha2);
                  var pa2 = se2(124);
                  Yt.pop = Re2(pa2);
                  var hs = se2(125);
                  Yt.railscasts = Re2(hs);
                  var Zo = se2(126);
                  Yt.shapeshifter = Re2(Zo);
                  var rc2 = se2(127);
                  Yt.solarized = Re2(rc2);
                  var ep = se2(128);
                  Yt.summerfruit = Re2(ep);
                  var mh2 = se2(129);
                  Yt.tomorrow = Re2(mh2);
                  var Cf2 = se2(130);
                  Yt.tube = Re2(Cf2);
                  var Gd2 = se2(131);
                  Yt.twilight = Re2(Gd2);
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  Yt.__esModule = true, Yt.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, $t.exports = Yt.default;
                }, function($t, Yt, se2) {
                  var Re2 = se2(33);
                  function He2(nn) {
                    var dn = Math.round(Re2(nn, 0, 255)).toString(16);
                    return dn.length == 1 ? "0" + dn : dn;
                  }
                  $t.exports = function(nn) {
                    var dn = nn.length === 4 ? He2(255 * nn[3]) : "";
                    return "#" + He2(nn[0]) + He2(nn[1]) + He2(nn[2]) + dn;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(134), He2 = se2(135), nn = se2(136), dn = se2(137), yn = { "#": He2, hsl: function(Rr) {
                    var Ur = Re2(Rr), Hr = dn(Ur);
                    return Ur.length === 4 && Hr.push(Ur[3]), Hr;
                  }, rgb: nn };
                  function Yn(Rr) {
                    for (var Ur in yn)
                      if (Rr.indexOf(Ur) === 0)
                        return yn[Ur](Rr);
                  }
                  Yn.rgb = nn, Yn.hsl = Re2, Yn.hex = He2, $t.exports = Yn;
                }, function($t, Yt, se2) {
                  var Re2 = se2(44), He2 = se2(33);
                  function nn(dn, yn) {
                    switch (dn = parseFloat(dn), yn) {
                      case 0:
                        return He2(dn, 0, 360);
                      case 1:
                      case 2:
                        return He2(dn, 0, 100);
                      case 3:
                        return He2(dn, 0, 1);
                    }
                  }
                  $t.exports = function(dn) {
                    return Re2(dn).map(nn);
                  };
                }, function($t, Yt) {
                  $t.exports = function(se2) {
                    se2.length !== 4 && se2.length !== 5 || (se2 = function(nn) {
                      for (var dn = "#", yn = 1; yn < nn.length; yn++) {
                        var Yn = nn.charAt(yn);
                        dn += Yn + Yn;
                      }
                      return dn;
                    }(se2));
                    var Re2 = [parseInt(se2.substring(1, 3), 16), parseInt(se2.substring(3, 5), 16), parseInt(se2.substring(5, 7), 16)];
                    if (se2.length === 9) {
                      var He2 = parseFloat((parseInt(se2.substring(7, 9), 16) / 255).toFixed(2));
                      Re2.push(He2);
                    }
                    return Re2;
                  };
                }, function($t, Yt, se2) {
                  var Re2 = se2(44), He2 = se2(33);
                  function nn(dn, yn) {
                    return yn < 3 ? dn.indexOf("%") != -1 ? Math.round(255 * He2(parseInt(dn, 10), 0, 100) / 100) : He2(parseInt(dn, 10), 0, 255) : He2(parseFloat(dn), 0, 1);
                  }
                  $t.exports = function(dn) {
                    return Re2(dn).map(nn);
                  };
                }, function($t, Yt) {
                  $t.exports = function(se2) {
                    var Re2, He2, nn, dn, yn, Yn = se2[0] / 360, Rr = se2[1] / 100, Ur = se2[2] / 100;
                    if (Rr == 0)
                      return [yn = 255 * Ur, yn, yn];
                    Re2 = 2 * Ur - (He2 = Ur < 0.5 ? Ur * (1 + Rr) : Ur + Rr - Ur * Rr), dn = [0, 0, 0];
                    for (var Hr = 0; Hr < 3; Hr++)
                      (nn = Yn + 1 / 3 * -(Hr - 1)) < 0 && nn++, nn > 1 && nn--, yn = 6 * nn < 1 ? Re2 + 6 * (He2 - Re2) * nn : 2 * nn < 1 ? He2 : 3 * nn < 2 ? Re2 + (He2 - Re2) * (2 / 3 - nn) * 6 : Re2, dn[Hr] = 255 * yn;
                    return dn;
                  };
                }, function($t, Yt, se2) {
                  (function(Re2) {
                    var He2 = typeof Re2 == "object" && Re2 && Re2.Object === Object && Re2, nn = typeof self == "object" && self && self.Object === Object && self, dn = He2 || nn || Function("return this")();
                    function yn(Fi2, Qi2, ro) {
                      switch (ro.length) {
                        case 0:
                          return Fi2.call(Qi2);
                        case 1:
                          return Fi2.call(Qi2, ro[0]);
                        case 2:
                          return Fi2.call(Qi2, ro[0], ro[1]);
                        case 3:
                          return Fi2.call(Qi2, ro[0], ro[1], ro[2]);
                      }
                      return Fi2.apply(Qi2, ro);
                    }
                    function Yn(Fi2, Qi2) {
                      for (var ro = -1, Wo = Qi2.length, Ii2 = Fi2.length; ++ro < Wo; )
                        Fi2[Ii2 + ro] = Qi2[ro];
                      return Fi2;
                    }
                    var Rr = Object.prototype, Ur = Rr.hasOwnProperty, Hr = Rr.toString, si2 = dn.Symbol, _i = Rr.propertyIsEnumerable, Wa2 = si2 ? si2.isConcatSpreadable : void 0, Ia2 = Math.max;
                    function ts(Fi2) {
                      return on(Fi2) || function(Qi2) {
                        return function(ro) {
                          return function(Wo) {
                            return !!Wo && typeof Wo == "object";
                          }(ro) && function(Wo) {
                            return Wo != null && function(Ii2) {
                              return typeof Ii2 == "number" && Ii2 > -1 && Ii2 % 1 == 0 && Ii2 <= 9007199254740991;
                            }(Wo.length) && !function(Ii2) {
                              var _l = function(yl) {
                                var Ra2 = typeof yl;
                                return !!yl && (Ra2 == "object" || Ra2 == "function");
                              }(Ii2) ? Hr.call(Ii2) : "";
                              return _l == "[object Function]" || _l == "[object GeneratorFunction]";
                            }(Wo);
                          }(ro);
                        }(Qi2) && Ur.call(Qi2, "callee") && (!_i.call(Qi2, "callee") || Hr.call(Qi2) == "[object Arguments]");
                      }(Fi2) || !!(Wa2 && Fi2 && Fi2[Wa2]);
                    }
                    var on = Array.isArray, di2, Yi2, Oa2, Da2 = (Yi2 = function(Fi2) {
                      var Qi2 = (Fi2 = function Wo(Ii2, _l, yl, Ra2, Su) {
                        var Ga2 = -1, ha2 = Ii2.length;
                        for (yl || (yl = ts), Su || (Su = []); ++Ga2 < ha2; ) {
                          var pa2 = Ii2[Ga2];
                          _l > 0 && yl(pa2) ? _l > 1 ? Wo(pa2, _l - 1, yl, Ra2, Su) : Yn(Su, pa2) : Ra2 || (Su[Su.length] = pa2);
                        }
                        return Su;
                      }(Fi2, 1)).length, ro = Qi2;
                      for (di2; ro--; )
                        if (typeof Fi2[ro] != "function")
                          throw new TypeError("Expected a function");
                      return function() {
                        for (var Wo = 0, Ii2 = Qi2 ? Fi2[Wo].apply(this, arguments) : arguments[0]; ++Wo < Qi2; )
                          Ii2 = Fi2[Wo].call(this, Ii2);
                        return Ii2;
                      };
                    }, Oa2 = Ia2(Oa2 === void 0 ? Yi2.length - 1 : Oa2, 0), function() {
                      for (var Fi2 = arguments, Qi2 = -1, ro = Ia2(Fi2.length - Oa2, 0), Wo = Array(ro); ++Qi2 < ro; )
                        Wo[Qi2] = Fi2[Oa2 + Qi2];
                      Qi2 = -1;
                      for (var Ii2 = Array(Oa2 + 1); ++Qi2 < Oa2; )
                        Ii2[Qi2] = Fi2[Qi2];
                      return Ii2[Oa2] = Wo, yn(Yi2, this, Ii2);
                    });
                    $t.exports = Da2;
                  }).call(this, se2(43));
                }, function($t, Yt, se2) {
                  Object.defineProperty(Yt, "__esModule", { value: true }), Yt.yuv2rgb = function(Re2) {
                    var He2, nn, dn, yn = Re2[0], Yn = Re2[1], Rr = Re2[2];
                    return He2 = 1 * yn + 0 * Yn + 1.13983 * Rr, nn = 1 * yn + -0.39465 * Yn + -0.5806 * Rr, dn = 1 * yn + 2.02311 * Yn + 0 * Rr, He2 = Math.min(Math.max(0, He2), 1), nn = Math.min(Math.max(0, nn), 1), dn = Math.min(Math.max(0, dn), 1), [255 * He2, 255 * nn, 255 * dn];
                  }, Yt.rgb2yuv = function(Re2) {
                    var He2 = Re2[0] / 255, nn = Re2[1] / 255, dn = Re2[2] / 255;
                    return [0.299 * He2 + 0.587 * nn + 0.114 * dn, -0.14713 * He2 + -0.28886 * nn + 0.436 * dn, 0.615 * He2 + -0.51499 * nn + -0.10001 * dn];
                  };
                }, function($t, Yt, se2) {
                  function Re2(dn, yn, Yn) {
                    return yn in dn ? Object.defineProperty(dn, yn, { value: Yn, enumerable: true, configurable: true, writable: true }) : dn[yn] = Yn, dn;
                  }
                  var He2 = se2(141), nn = function() {
                    function dn() {
                      Re2(this, "_callbacks", void 0), Re2(this, "_isDispatching", void 0), Re2(this, "_isHandled", void 0), Re2(this, "_isPending", void 0), Re2(this, "_lastID", void 0), Re2(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
                    }
                    var yn = dn.prototype;
                    return yn.register = function(Yn) {
                      var Rr = "ID_" + this._lastID++;
                      return this._callbacks[Rr] = Yn, Rr;
                    }, yn.unregister = function(Yn) {
                      this._callbacks[Yn] || He2(false), delete this._callbacks[Yn];
                    }, yn.waitFor = function(Yn) {
                      this._isDispatching || He2(false);
                      for (var Rr = 0; Rr < Yn.length; Rr++) {
                        var Ur = Yn[Rr];
                        this._isPending[Ur] ? this._isHandled[Ur] || He2(false) : (this._callbacks[Ur] || He2(false), this._invokeCallback(Ur));
                      }
                    }, yn.dispatch = function(Yn) {
                      this._isDispatching && He2(false), this._startDispatching(Yn);
                      try {
                        for (var Rr in this._callbacks)
                          this._isPending[Rr] || this._invokeCallback(Rr);
                      } finally {
                        this._stopDispatching();
                      }
                    }, yn.isDispatching = function() {
                      return this._isDispatching;
                    }, yn._invokeCallback = function(Yn) {
                      this._isPending[Yn] = true, this._callbacks[Yn](this._pendingPayload), this._isHandled[Yn] = true;
                    }, yn._startDispatching = function(Yn) {
                      for (var Rr in this._callbacks)
                        this._isPending[Rr] = false, this._isHandled[Rr] = false;
                      this._pendingPayload = Yn, this._isDispatching = true;
                    }, yn._stopDispatching = function() {
                      delete this._pendingPayload, this._isDispatching = false;
                    }, dn;
                  }();
                  $t.exports = nn;
                }, function($t, Yt, se2) {
                  $t.exports = function(Re2, He2) {
                    for (var nn = arguments.length, dn = new Array(nn > 2 ? nn - 2 : 0), yn = 2; yn < nn; yn++)
                      dn[yn - 2] = arguments[yn];
                    if (!Re2) {
                      var Yn;
                      if (He2 === void 0)
                        Yn = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                      else {
                        var Rr = 0;
                        (Yn = new Error(He2.replace(/%s/g, function() {
                          return String(dn[Rr++]);
                        }))).name = "Invariant Violation";
                      }
                      throw Yn.framesToPop = 1, Yn;
                    }
                  };
                }, function($t, Yt, se2) {
                  function Re2(br, Dr, On) {
                    return Dr in br ? Object.defineProperty(br, Dr, { value: On, enumerable: true, configurable: true, writable: true }) : br[Dr] = On, br;
                  }
                  function He2(br, Dr) {
                    var On = Object.keys(br);
                    if (Object.getOwnPropertySymbols) {
                      var ur = Object.getOwnPropertySymbols(br);
                      Dr && (ur = ur.filter(function(gr) {
                        return Object.getOwnPropertyDescriptor(br, gr).enumerable;
                      })), On.push.apply(On, ur);
                    }
                    return On;
                  }
                  function nn(br) {
                    for (var Dr = 1; Dr < arguments.length; Dr++) {
                      var On = arguments[Dr] != null ? arguments[Dr] : {};
                      Dr % 2 ? He2(Object(On), true).forEach(function(ur) {
                        Re2(br, ur, On[ur]);
                      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(br, Object.getOwnPropertyDescriptors(On)) : He2(Object(On)).forEach(function(ur) {
                        Object.defineProperty(br, ur, Object.getOwnPropertyDescriptor(On, ur));
                      });
                    }
                    return br;
                  }
                  function dn(br, Dr) {
                    if (!(br instanceof Dr))
                      throw new TypeError("Cannot call a class as a function");
                  }
                  function yn(br, Dr) {
                    for (var On = 0; On < Dr.length; On++) {
                      var ur = Dr[On];
                      ur.enumerable = ur.enumerable || false, ur.configurable = true, "value" in ur && (ur.writable = true), Object.defineProperty(br, ur.key, ur);
                    }
                  }
                  function Yn(br, Dr, On) {
                    return Dr && yn(br.prototype, Dr), On && yn(br, On), br;
                  }
                  function Rr(br, Dr) {
                    return (Rr = Object.setPrototypeOf || function(On, ur) {
                      return On.__proto__ = ur, On;
                    })(br, Dr);
                  }
                  function Ur(br, Dr) {
                    if (typeof Dr != "function" && Dr !== null)
                      throw new TypeError("Super expression must either be null or a function");
                    br.prototype = Object.create(Dr && Dr.prototype, { constructor: { value: br, writable: true, configurable: true } }), Dr && Rr(br, Dr);
                  }
                  function Hr(br) {
                    return (Hr = Object.setPrototypeOf ? Object.getPrototypeOf : function(Dr) {
                      return Dr.__proto__ || Object.getPrototypeOf(Dr);
                    })(br);
                  }
                  function si2(br) {
                    return (si2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Dr) {
                      return typeof Dr;
                    } : function(Dr) {
                      return Dr && typeof Symbol == "function" && Dr.constructor === Symbol && Dr !== Symbol.prototype ? "symbol" : typeof Dr;
                    })(br);
                  }
                  function _i(br) {
                    if (br === void 0)
                      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                    return br;
                  }
                  function Wa2(br, Dr) {
                    return !Dr || si2(Dr) !== "object" && typeof Dr != "function" ? _i(br) : Dr;
                  }
                  function Ia2(br) {
                    var Dr = function() {
                      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                        return false;
                      if (typeof Proxy == "function")
                        return true;
                      try {
                        return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                        })), true;
                      } catch {
                        return false;
                      }
                    }();
                    return function() {
                      var On, ur = Hr(br);
                      if (Dr) {
                        var gr = Hr(this).constructor;
                        On = Reflect.construct(ur, arguments, gr);
                      } else
                        On = ur.apply(this, arguments);
                      return Wa2(this, On);
                    };
                  }
                  se2.r(Yt);
                  var ts = se2(0), on = se2.n(ts);
                  function di2() {
                    var br = this.constructor.getDerivedStateFromProps(this.props, this.state);
                    br != null && this.setState(br);
                  }
                  function Yi2(br) {
                    this.setState(function(Dr) {
                      var On = this.constructor.getDerivedStateFromProps(br, Dr);
                      return On != null ? On : null;
                    }.bind(this));
                  }
                  function Oa2(br, Dr) {
                    try {
                      var On = this.props, ur = this.state;
                      this.props = br, this.state = Dr, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(On, ur);
                    } finally {
                      this.props = On, this.state = ur;
                    }
                  }
                  function Da2(br) {
                    var Dr = br.prototype;
                    if (!Dr || !Dr.isReactComponent)
                      throw new Error("Can only polyfill class components");
                    if (typeof br.getDerivedStateFromProps != "function" && typeof Dr.getSnapshotBeforeUpdate != "function")
                      return br;
                    var On = null, ur = null, gr = null;
                    if (typeof Dr.componentWillMount == "function" ? On = "componentWillMount" : typeof Dr.UNSAFE_componentWillMount == "function" && (On = "UNSAFE_componentWillMount"), typeof Dr.componentWillReceiveProps == "function" ? ur = "componentWillReceiveProps" : typeof Dr.UNSAFE_componentWillReceiveProps == "function" && (ur = "UNSAFE_componentWillReceiveProps"), typeof Dr.componentWillUpdate == "function" ? gr = "componentWillUpdate" : typeof Dr.UNSAFE_componentWillUpdate == "function" && (gr = "UNSAFE_componentWillUpdate"), On !== null || ur !== null || gr !== null) {
                      var Hi2 = br.displayName || br.name, Fa2 = typeof br.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                      throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Hi2 + " uses " + Fa2 + " but also contains the following legacy lifecycles:" + (On !== null ? `
  ` + On : "") + (ur !== null ? `
  ` + ur : "") + (gr !== null ? `
  ` + gr : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
                    }
                    if (typeof br.getDerivedStateFromProps == "function" && (Dr.componentWillMount = di2, Dr.componentWillReceiveProps = Yi2), typeof Dr.getSnapshotBeforeUpdate == "function") {
                      if (typeof Dr.componentDidUpdate != "function")
                        throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                      Dr.componentWillUpdate = Oa2;
                      var ma2 = Dr.componentDidUpdate;
                      Dr.componentDidUpdate = function(Ri2, Ho, iu) {
                        var th2 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : iu;
                        ma2.call(this, Ri2, Ho, th2);
                      };
                    }
                    return br;
                  }
                  function Fi2(br, Dr) {
                    if (br == null)
                      return {};
                    var On, ur, gr = function(Fa2, ma2) {
                      if (Fa2 == null)
                        return {};
                      var Ri2, Ho, iu = {}, th2 = Object.keys(Fa2);
                      for (Ho = 0; Ho < th2.length; Ho++)
                        Ri2 = th2[Ho], ma2.indexOf(Ri2) >= 0 || (iu[Ri2] = Fa2[Ri2]);
                      return iu;
                    }(br, Dr);
                    if (Object.getOwnPropertySymbols) {
                      var Hi2 = Object.getOwnPropertySymbols(br);
                      for (ur = 0; ur < Hi2.length; ur++)
                        On = Hi2[ur], Dr.indexOf(On) >= 0 || Object.prototype.propertyIsEnumerable.call(br, On) && (gr[On] = br[On]);
                    }
                    return gr;
                  }
                  function Qi2(br) {
                    var Dr = function(On) {
                      return {}.toString.call(On).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
                    }(br);
                    return Dr === "number" && (Dr = isNaN(br) ? "nan" : (0 | br) != br ? "float" : "integer"), Dr;
                  }
                  di2.__suppressDeprecationWarning = true, Yi2.__suppressDeprecationWarning = true, Oa2.__suppressDeprecationWarning = true;
                  var ro = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, Wo = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, Ii2 = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, _l = se2(45), yl = function(br) {
                    var Dr = function(On) {
                      return { backgroundColor: On.base00, ellipsisColor: On.base09, braceColor: On.base07, expandedIcon: On.base0D, collapsedIcon: On.base0E, keyColor: On.base07, arrayKeyColor: On.base0C, objectSize: On.base04, copyToClipboard: On.base0F, copyToClipboardCheck: On.base0D, objectBorder: On.base02, dataTypes: { boolean: On.base0E, date: On.base0D, float: On.base0B, function: On.base0D, integer: On.base0F, string: On.base09, nan: On.base08, null: On.base0A, undefined: On.base05, regexp: On.base0A, background: On.base02 }, editVariable: { editIcon: On.base0E, cancelIcon: On.base09, removeIcon: On.base09, addIcon: On.base0E, checkIcon: On.base0E, background: On.base01, color: On.base0A, border: On.base07 }, addKeyModal: { background: On.base05, border: On.base04, color: On.base0A, labelColor: On.base01 }, validationFailure: { background: On.base09, iconColor: On.base01, fontColor: On.base01 } };
                    }(br);
                    return { "app-container": { fontFamily: Ii2.globalFontFamily, cursor: Ii2.globalCursor, backgroundColor: Dr.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Dr.ellipsisColor, fontSize: Ii2.ellipsisFontSize, lineHeight: Ii2.ellipsisLineHeight, cursor: Ii2.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: Ii2.braceCursor, fontWeight: Ii2.braceFontWeight, color: Dr.braceColor }, "expanded-icon": { color: Dr.expandedIcon }, "collapsed-icon": { color: Dr.collapsedIcon }, colon: { display: "inline-block", margin: Ii2.keyMargin, color: Dr.keyColor, verticalAlign: "top" }, objectKeyVal: function(On, ur) {
                      return { style: nn({ paddingTop: Ii2.keyValPaddingTop, paddingRight: Ii2.keyValPaddingRight, paddingBottom: Ii2.keyValPaddingBottom, borderLeft: Ii2.keyValBorderLeft + " " + Dr.objectBorder, ":hover": { paddingLeft: ur.paddingLeft - 1 + "px", borderLeft: Ii2.keyValBorderHover + " " + Dr.objectBorder } }, ur) };
                    }, "object-key-val-no-border": { padding: Ii2.keyValPadding }, "pushed-content": { marginLeft: Ii2.pushedContentMarginLeft }, variableValue: function(On, ur) {
                      return { style: nn({ display: "inline-block", paddingRight: Ii2.variableValuePaddingRight, position: "relative" }, ur) };
                    }, "object-name": { display: "inline-block", color: Dr.keyColor, letterSpacing: Ii2.keyLetterSpacing, fontStyle: Ii2.keyFontStyle, verticalAlign: Ii2.keyVerticalAlign, opacity: Ii2.keyOpacity, ":hover": { opacity: Ii2.keyOpacityHover } }, "array-key": { display: "inline-block", color: Dr.arrayKeyColor, letterSpacing: Ii2.keyLetterSpacing, fontStyle: Ii2.keyFontStyle, verticalAlign: Ii2.keyVerticalAlign, opacity: Ii2.keyOpacity, ":hover": { opacity: Ii2.keyOpacityHover } }, "object-size": { color: Dr.objectSize, borderRadius: Ii2.objectSizeBorderRadius, fontStyle: Ii2.objectSizeFontStyle, margin: Ii2.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: Ii2.dataTypeFontSize, marginRight: Ii2.dataTypeMarginRight, opacity: Ii2.datatypeOpacity }, boolean: { display: "inline-block", color: Dr.dataTypes.boolean }, date: { display: "inline-block", color: Dr.dataTypes.date }, "date-value": { marginLeft: Ii2.dateValueMarginLeft }, float: { display: "inline-block", color: Dr.dataTypes.float }, function: { display: "inline-block", color: Dr.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Dr.dataTypes.integer }, string: { display: "inline-block", color: Dr.dataTypes.string }, nan: { display: "inline-block", color: Dr.dataTypes.nan, fontSize: Ii2.nanFontSize, fontWeight: Ii2.nanFontWeight, backgroundColor: Dr.dataTypes.background, padding: Ii2.nanPadding, borderRadius: Ii2.nanBorderRadius }, null: { display: "inline-block", color: Dr.dataTypes.null, fontSize: Ii2.nullFontSize, fontWeight: Ii2.nullFontWeight, backgroundColor: Dr.dataTypes.background, padding: Ii2.nullPadding, borderRadius: Ii2.nullBorderRadius }, undefined: { display: "inline-block", color: Dr.dataTypes.undefined, fontSize: Ii2.undefinedFontSize, padding: Ii2.undefinedPadding, borderRadius: Ii2.undefinedBorderRadius, backgroundColor: Dr.dataTypes.background }, regexp: { display: "inline-block", color: Dr.dataTypes.regexp }, "copy-to-clipboard": { cursor: Ii2.clipboardCursor }, "copy-icon": { color: Dr.copyToClipboard, fontSize: Ii2.iconFontSize, marginRight: Ii2.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Dr.copyToClipboardCheck, marginLeft: Ii2.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: Ii2.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: Ii2.metaDataPadding }, "icon-container": { display: "inline-block", width: Ii2.iconContainerWidth }, tooltip: { padding: Ii2.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Dr.editVariable.removeIcon, cursor: Ii2.iconCursor, fontSize: Ii2.iconFontSize, marginRight: Ii2.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Dr.editVariable.addIcon, cursor: Ii2.iconCursor, fontSize: Ii2.iconFontSize, marginRight: Ii2.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Dr.editVariable.editIcon, cursor: Ii2.iconCursor, fontSize: Ii2.iconFontSize, marginRight: Ii2.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: Ii2.iconCursor, color: Dr.editVariable.checkIcon, fontSize: Ii2.iconFontSize, paddingRight: Ii2.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: Ii2.iconCursor, color: Dr.editVariable.cancelIcon, fontSize: Ii2.iconFontSize, paddingRight: Ii2.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: Ii2.editInputMinWidth, borderRadius: Ii2.editInputBorderRadius, backgroundColor: Dr.editVariable.background, color: Dr.editVariable.color, padding: Ii2.editInputPadding, marginRight: Ii2.editInputMarginRight, fontFamily: Ii2.editInputFontFamily }, "detected-row": { paddingTop: Ii2.detectedRowPaddingTop }, "key-modal-request": { position: Ii2.addKeyCoverPosition, top: Ii2.addKeyCoverPositionPx, left: Ii2.addKeyCoverPositionPx, right: Ii2.addKeyCoverPositionPx, bottom: Ii2.addKeyCoverPositionPx, backgroundColor: Ii2.addKeyCoverBackground }, "key-modal": { width: Ii2.addKeyModalWidth, backgroundColor: Dr.addKeyModal.background, marginLeft: Ii2.addKeyModalMargin, marginRight: Ii2.addKeyModalMargin, padding: Ii2.addKeyModalPadding, borderRadius: Ii2.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Dr.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Dr.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Dr.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Dr.addKeyModal.labelColor, fontSize: Ii2.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Dr.editVariable.addIcon, fontSize: Ii2.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Dr.ellipsisColor, fontSize: Ii2.ellipsisFontSize, lineHeight: Ii2.ellipsisLineHeight, cursor: Ii2.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Dr.validationFailure.fontColor, backgroundColor: Dr.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Dr.validationFailure.iconColor, fontSize: Ii2.iconFontSize, transform: "rotate(45deg)" } };
                  };
                  function Ra2(br, Dr, On) {
                    return br || console.error("theme has not been set"), function(ur) {
                      var gr = ro;
                      return ur !== false && ur !== "none" || (gr = Wo), Object(_l.createStyling)(yl, { defaultBase16: gr })(ur);
                    }(br)(Dr, On);
                  }
                  var Su = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = (ur.rjvId, ur.type_name), Hi2 = ur.displayDataTypes, Fa2 = ur.theme;
                      return Hi2 ? on.a.createElement("span", Object.assign({ className: "data-type-label" }, Ra2(Fa2, "data-type-label")), gr) : null;
                    } }]), On;
                  }(on.a.PureComponent), Ga2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props;
                      return on.a.createElement("div", Ra2(ur.theme, "boolean"), on.a.createElement(Su, Object.assign({ type_name: "bool" }, ur)), ur.value ? "true" : "false");
                    } }]), On;
                  }(on.a.PureComponent), ha2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props;
                      return on.a.createElement("div", Ra2(ur.theme, "date"), on.a.createElement(Su, Object.assign({ type_name: "date" }, ur)), on.a.createElement("span", Object.assign({ className: "date-value" }, Ra2(ur.theme, "date-value")), ur.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
                    } }]), On;
                  }(on.a.PureComponent), pa2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props;
                      return on.a.createElement("div", Ra2(ur.theme, "float"), on.a.createElement(Su, Object.assign({ type_name: "float" }, ur)), this.props.value);
                    } }]), On;
                  }(on.a.PureComponent);
                  function hs(br, Dr) {
                    (Dr == null || Dr > br.length) && (Dr = br.length);
                    for (var On = 0, ur = new Array(Dr); On < Dr; On++)
                      ur[On] = br[On];
                    return ur;
                  }
                  function Zo(br, Dr) {
                    if (br) {
                      if (typeof br == "string")
                        return hs(br, Dr);
                      var On = Object.prototype.toString.call(br).slice(8, -1);
                      return On === "Object" && br.constructor && (On = br.constructor.name), On === "Map" || On === "Set" ? Array.from(br) : On === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(On) ? hs(br, Dr) : void 0;
                    }
                  }
                  function rc2(br, Dr) {
                    var On;
                    if (typeof Symbol == "undefined" || br[Symbol.iterator] == null) {
                      if (Array.isArray(br) || (On = Zo(br)) || Dr && br && typeof br.length == "number") {
                        On && (br = On);
                        var ur = 0, gr = function() {
                        };
                        return { s: gr, n: function() {
                          return ur >= br.length ? { done: true } : { done: false, value: br[ur++] };
                        }, e: function(Ri2) {
                          throw Ri2;
                        }, f: gr };
                      }
                      throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                    }
                    var Hi2, Fa2 = true, ma2 = false;
                    return { s: function() {
                      On = br[Symbol.iterator]();
                    }, n: function() {
                      var Ri2 = On.next();
                      return Fa2 = Ri2.done, Ri2;
                    }, e: function(Ri2) {
                      ma2 = true, Hi2 = Ri2;
                    }, f: function() {
                      try {
                        Fa2 || On.return == null || On.return();
                      } finally {
                        if (ma2)
                          throw Hi2;
                      }
                    } };
                  }
                  function ep(br) {
                    return function(Dr) {
                      if (Array.isArray(Dr))
                        return hs(Dr);
                    }(br) || function(Dr) {
                      if (typeof Symbol != "undefined" && Symbol.iterator in Object(Dr))
                        return Array.from(Dr);
                    }(br) || Zo(br) || function() {
                      throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                    }();
                  }
                  var mh2 = se2(46), Cf2 = new (se2(47)).Dispatcher(), Gd2 = new (function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      var ur;
                      dn(this, On);
                      for (var gr = arguments.length, Hi2 = new Array(gr), Fa2 = 0; Fa2 < gr; Fa2++)
                        Hi2[Fa2] = arguments[Fa2];
                      return (ur = Dr.call.apply(Dr, [this].concat(Hi2))).objects = {}, ur.set = function(ma2, Ri2, Ho, iu) {
                        ur.objects[ma2] === void 0 && (ur.objects[ma2] = {}), ur.objects[ma2][Ri2] === void 0 && (ur.objects[ma2][Ri2] = {}), ur.objects[ma2][Ri2][Ho] = iu;
                      }, ur.get = function(ma2, Ri2, Ho, iu) {
                        return ur.objects[ma2] === void 0 || ur.objects[ma2][Ri2] === void 0 || ur.objects[ma2][Ri2][Ho] == null ? iu : ur.objects[ma2][Ri2][Ho];
                      }, ur.handleAction = function(ma2) {
                        var Ri2 = ma2.rjvId, Ho = ma2.data;
                        switch (ma2.name) {
                          case "RESET":
                            ur.emit("reset-" + Ri2);
                            break;
                          case "VARIABLE_UPDATED":
                            ma2.data.updated_src = ur.updateSrc(Ri2, Ho), ur.set(Ri2, "action", "variable-update", nn(nn({}, Ho), {}, { type: "variable-edited" })), ur.emit("variable-update-" + Ri2);
                            break;
                          case "VARIABLE_REMOVED":
                            ma2.data.updated_src = ur.updateSrc(Ri2, Ho), ur.set(Ri2, "action", "variable-update", nn(nn({}, Ho), {}, { type: "variable-removed" })), ur.emit("variable-update-" + Ri2);
                            break;
                          case "VARIABLE_ADDED":
                            ma2.data.updated_src = ur.updateSrc(Ri2, Ho), ur.set(Ri2, "action", "variable-update", nn(nn({}, Ho), {}, { type: "variable-added" })), ur.emit("variable-update-" + Ri2);
                            break;
                          case "ADD_VARIABLE_KEY_REQUEST":
                            ur.set(Ri2, "action", "new-key-request", Ho), ur.emit("add-key-request-" + Ri2);
                        }
                      }, ur.updateSrc = function(ma2, Ri2) {
                        var Ho = Ri2.name, iu = Ri2.namespace, th2 = Ri2.new_value, rp = (Ri2.existing_value, Ri2.variable_removed);
                        iu.shift();
                        var Dd2, Hf2 = ur.get(ma2, "global", "src"), Ed2 = ur.deepCopy(Hf2, ep(iu)), Kv = Ed2, Bc2 = rc2(iu);
                        try {
                          for (Bc2.s(); !(Dd2 = Bc2.n()).done; )
                            Kv = Kv[Dd2.value];
                        } catch (py) {
                          Bc2.e(py);
                        } finally {
                          Bc2.f();
                        }
                        return rp ? Qi2(Kv) == "array" ? Kv.splice(Ho, 1) : delete Kv[Ho] : Ho !== null ? Kv[Ho] = th2 : Ed2 = th2, ur.set(ma2, "global", "src", Ed2), Ed2;
                      }, ur.deepCopy = function(ma2, Ri2) {
                        var Ho, iu = Qi2(ma2), th2 = Ri2.shift();
                        return iu == "array" ? Ho = ep(ma2) : iu == "object" && (Ho = nn({}, ma2)), th2 !== void 0 && (Ho[th2] = ur.deepCopy(ma2[th2], Ri2)), Ho;
                      }, ur;
                    }
                    return On;
                  }(mh2.EventEmitter))();
                  Cf2.register(Gd2.handleAction.bind(Gd2));
                  var bh2 = Gd2, Gp = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      return dn(this, On), (gr = Dr.call(this, ur)).toggleCollapsed = function() {
                        gr.setState({ collapsed: !gr.state.collapsed }, function() {
                          bh2.set(gr.props.rjvId, gr.props.namespace, "collapsed", gr.state.collapsed);
                        });
                      }, gr.getFunctionDisplay = function(Hi2) {
                        var Fa2 = _i(gr).props;
                        return Hi2 ? on.a.createElement("span", null, gr.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), on.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, on.a.createElement("span", null, "{"), on.a.createElement("span", Ra2(Fa2.theme, "ellipsis"), "..."), on.a.createElement("span", null, "}"))) : gr.props.value.toString().slice(9, -1);
                      }, gr.state = { collapsed: bh2.get(ur.rjvId, ur.namespace, "collapsed", true) }, gr;
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = this.state.collapsed;
                      return on.a.createElement("div", Ra2(ur.theme, "function"), on.a.createElement(Su, Object.assign({ type_name: "function" }, ur)), on.a.createElement("span", Object.assign({}, Ra2(ur.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(gr)));
                    } }]), On;
                  }(on.a.PureComponent), $v = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      return on.a.createElement("div", Ra2(this.props.theme, "nan"), "NaN");
                    } }]), On;
                  }(on.a.PureComponent), B0 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      return on.a.createElement("div", Ra2(this.props.theme, "null"), "NULL");
                    } }]), On;
                  }(on.a.PureComponent), uS = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props;
                      return on.a.createElement("div", Ra2(ur.theme, "integer"), on.a.createElement(Su, Object.assign({ type_name: "int" }, ur)), this.props.value);
                    } }]), On;
                  }(on.a.PureComponent), FM = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props;
                      return on.a.createElement("div", Ra2(ur.theme, "regexp"), on.a.createElement(Su, Object.assign({ type_name: "regexp" }, ur)), this.props.value.toString());
                    } }]), On;
                  }(on.a.PureComponent), Ry = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      return dn(this, On), (gr = Dr.call(this, ur)).toggleCollapsed = function() {
                        gr.setState({ collapsed: !gr.state.collapsed }, function() {
                          bh2.set(gr.props.rjvId, gr.props.namespace, "collapsed", gr.state.collapsed);
                        });
                      }, gr.state = { collapsed: bh2.get(ur.rjvId, ur.namespace, "collapsed", true) }, gr;
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      this.state.collapsed;
                      var ur = this.props, gr = ur.collapseStringsAfterLength, Hi2 = ur.theme, Fa2 = ur.value, ma2 = { style: { cursor: "default" } };
                      return Qi2(gr) === "integer" && Fa2.length > gr && (ma2.style.cursor = "pointer", this.state.collapsed && (Fa2 = on.a.createElement("span", null, Fa2.substring(0, gr), on.a.createElement("span", Ra2(Hi2, "ellipsis"), " ...")))), on.a.createElement("div", Ra2(Hi2, "string"), on.a.createElement(Su, Object.assign({ type_name: "string" }, ur)), on.a.createElement("span", Object.assign({ className: "string-value" }, ma2, { onClick: this.toggleCollapsed }), '"', Fa2, '"'));
                    } }]), On;
                  }(on.a.PureComponent), Rx = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      return on.a.createElement("div", Ra2(this.props.theme, "undefined"), "undefined");
                    } }]), On;
                  }(on.a.PureComponent);
                  function PT() {
                    return (PT = Object.assign || function(br) {
                      for (var Dr = 1; Dr < arguments.length; Dr++) {
                        var On = arguments[Dr];
                        for (var ur in On)
                          Object.prototype.hasOwnProperty.call(On, ur) && (br[ur] = On[ur]);
                      }
                      return br;
                    }).apply(this, arguments);
                  }
                  var u_ = ts.useLayoutEffect, ib2 = function(br) {
                    var Dr = Object(ts.useRef)(br);
                    return u_(function() {
                      Dr.current = br;
                    }), Dr;
                  }, VM = function(br, Dr) {
                    typeof br != "function" ? br.current = Dr : br(Dr);
                  }, cS = function(br, Dr) {
                    var On = Object(ts.useRef)();
                    return Object(ts.useCallback)(function(ur) {
                      br.current = ur, On.current && VM(On.current, null), On.current = Dr, Dr && VM(Dr, ur);
                    }, [Dr]);
                  }, d0 = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, fy = function(br) {
                    Object.keys(d0).forEach(function(Dr) {
                      br.style.setProperty(Dr, d0[Dr], "important");
                    });
                  }, Vg2 = null, _u = function() {
                  }, lo = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], na2 = !!document.documentElement.currentStyle, $i2 = function(br, Dr) {
                    var On = br.cacheMeasurements, ur = br.maxRows, gr = br.minRows, Hi2 = br.onChange, Fa2 = Hi2 === void 0 ? _u : Hi2, ma2 = br.onHeightChange, Ri2 = ma2 === void 0 ? _u : ma2, Ho = function(Bc2, py) {
                      if (Bc2 == null)
                        return {};
                      var Fx, LT, _6 = {}, zM = Object.keys(Bc2);
                      for (LT = 0; LT < zM.length; LT++)
                        Fx = zM[LT], py.indexOf(Fx) >= 0 || (_6[Fx] = Bc2[Fx]);
                      return _6;
                    }(br, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), iu, th2 = Ho.value !== void 0, rp = Object(ts.useRef)(null), Dd2 = cS(rp, Dr), Hf2 = Object(ts.useRef)(0), Ed2 = Object(ts.useRef)(), Kv = function() {
                      var Bc2 = rp.current, py = On && Ed2.current ? Ed2.current : function(zM) {
                        var pL = window.getComputedStyle(zM);
                        if (pL === null)
                          return null;
                        var s5, vm = (s5 = pL, lo.reduce(function(dL, l5) {
                          return dL[l5] = s5[l5], dL;
                        }, {})), ED = vm.boxSizing;
                        return ED === "" ? null : (na2 && ED === "border-box" && (vm.width = parseFloat(vm.width) + parseFloat(vm.borderRightWidth) + parseFloat(vm.borderLeftWidth) + parseFloat(vm.paddingRight) + parseFloat(vm.paddingLeft) + "px"), { sizingStyle: vm, paddingSize: parseFloat(vm.paddingBottom) + parseFloat(vm.paddingTop), borderSize: parseFloat(vm.borderBottomWidth) + parseFloat(vm.borderTopWidth) });
                      }(Bc2);
                      if (py) {
                        Ed2.current = py;
                        var Fx = function(zM, pL, s5, vm) {
                          s5 === void 0 && (s5 = 1), vm === void 0 && (vm = 1 / 0), Vg2 || ((Vg2 = document.createElement("textarea")).setAttribute("tab-index", "-1"), Vg2.setAttribute("aria-hidden", "true"), fy(Vg2)), Vg2.parentNode === null && document.body.appendChild(Vg2);
                          var ED = zM.paddingSize, dL = zM.borderSize, l5 = zM.sizingStyle, x6 = l5.boxSizing;
                          Object.keys(l5).forEach(function(a1) {
                            var gL = a1;
                            Vg2.style[gL] = l5[gL];
                          }), fy(Vg2), Vg2.value = pL;
                          var w6 = function(a1, gL) {
                            var rH = a1.scrollHeight;
                            return gL.sizingStyle.boxSizing === "border-box" ? rH + gL.borderSize : rH - gL.paddingSize;
                          }(Vg2, zM);
                          Vg2.value = "x";
                          var nH = Vg2.scrollHeight - ED, a7 = nH * s5;
                          x6 === "border-box" && (a7 = a7 + ED + dL), w6 = Math.max(a7, w6);
                          var o7 = nH * vm;
                          return x6 === "border-box" && (o7 = o7 + ED + dL), [w6 = Math.min(o7, w6), nH];
                        }(py, Bc2.value || Bc2.placeholder || "x", gr, ur), LT = Fx[0], _6 = Fx[1];
                        Hf2.current !== LT && (Hf2.current = LT, Bc2.style.setProperty("height", LT + "px", "important"), Ri2(LT, { rowHeight: _6 }));
                      }
                    };
                    return Object(ts.useLayoutEffect)(Kv), iu = ib2(Kv), Object(ts.useLayoutEffect)(function() {
                      var Bc2 = function(py) {
                        iu.current(py);
                      };
                      return window.addEventListener("resize", Bc2), function() {
                        window.removeEventListener("resize", Bc2);
                      };
                    }, []), Object(ts.createElement)("textarea", PT({}, Ho, { onChange: function(Bc2) {
                      th2 || Kv(), Fa2(Bc2);
                    }, ref: Dd2 }));
                  }, xo = Object(ts.forwardRef)($i2);
                  function Os(br) {
                    br = br.trim();
                    try {
                      if ((br = JSON.stringify(JSON.parse(br)))[0] === "[")
                        return Kl("array", JSON.parse(br));
                      if (br[0] === "{")
                        return Kl("object", JSON.parse(br));
                      if (br.match(/\-?\d+\.\d+/) && br.match(/\-?\d+\.\d+/)[0] === br)
                        return Kl("float", parseFloat(br));
                      if (br.match(/\-?\d+e-\d+/) && br.match(/\-?\d+e-\d+/)[0] === br)
                        return Kl("float", Number(br));
                      if (br.match(/\-?\d+/) && br.match(/\-?\d+/)[0] === br)
                        return Kl("integer", parseInt(br));
                      if (br.match(/\-?\d+e\+\d+/) && br.match(/\-?\d+e\+\d+/)[0] === br)
                        return Kl("integer", Number(br));
                    } catch {
                    }
                    switch (br = br.toLowerCase()) {
                      case "undefined":
                        return Kl("undefined", void 0);
                      case "nan":
                        return Kl("nan", NaN);
                      case "null":
                        return Kl("null", null);
                      case "true":
                        return Kl("boolean", true);
                      case "false":
                        return Kl("boolean", false);
                      default:
                        if (br = Date.parse(br))
                          return Kl("date", new Date(br));
                    }
                    return Kl(false, null);
                  }
                  function Kl(br, Dr) {
                    return { type: br, value: Dr };
                  }
                  var Iu = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
                    } }]), On;
                  }(on.a.PureComponent), Tf2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
                    } }]), On;
                  }(on.a.PureComponent), ud2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]), Fa2 = np(gr).style;
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", { fill: Fa2.color, width: Fa2.height, height: Fa2.width, style: Fa2, viewBox: "0 0 1792 1792" }, on.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                    } }]), On;
                  }(on.a.PureComponent), iv = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]), Fa2 = np(gr).style;
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", { fill: Fa2.color, width: Fa2.height, height: Fa2.width, style: Fa2, viewBox: "0 0 1792 1792" }, on.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                    } }]), On;
                  }(on.a.PureComponent), Bg2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", { style: nn(nn({}, np(gr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, on.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
                    } }]), On;
                  }(on.a.PureComponent), z0 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", { style: nn(nn({}, np(gr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, on.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
                    } }]), On;
                  }(on.a.PureComponent), zg2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("g", null, on.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
                    } }]), On;
                  }(on.a.PureComponent), c_ = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("g", null, on.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                    } }]), On;
                  }(on.a.PureComponent), Nx = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("g", null, on.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                    } }]), On;
                  }(on.a.PureComponent), Ny = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("g", null, on.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
                    } }]), On;
                  }(on.a.PureComponent), Hd2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("g", null, on.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
                    } }]), On;
                  }(on.a.PureComponent), Yv = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.style, Hi2 = Fi2(ur, ["style"]);
                      return on.a.createElement("span", Hi2, on.a.createElement("svg", Object.assign({}, np(gr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), on.a.createElement("g", null, on.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                    } }]), On;
                  }(on.a.PureComponent);
                  function np(br) {
                    return br || (br = {}), { style: nn(nn({ verticalAlign: "middle" }, br), {}, { color: br.color ? br.color : "#000000", height: "1em", width: "1em" }) };
                  }
                  var hy = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      return dn(this, On), (gr = Dr.call(this, ur)).copiedTimer = null, gr.handleCopy = function() {
                        var Hi2 = document.createElement("textarea"), Fa2 = gr.props, ma2 = Fa2.clickCallback, Ri2 = Fa2.src, Ho = Fa2.namespace;
                        Hi2.innerHTML = JSON.stringify(gr.clipboardValue(Ri2), null, "  "), document.body.appendChild(Hi2), Hi2.select(), document.execCommand("copy"), document.body.removeChild(Hi2), gr.copiedTimer = setTimeout(function() {
                          gr.setState({ copied: false });
                        }, 5500), gr.setState({ copied: true }, function() {
                          typeof ma2 == "function" && ma2({ src: Ri2, namespace: Ho, name: Ho[Ho.length - 1] });
                        });
                      }, gr.getClippyIcon = function() {
                        var Hi2 = gr.props.theme;
                        return gr.state.copied ? on.a.createElement("span", null, on.a.createElement(zg2, Object.assign({ className: "copy-icon" }, Ra2(Hi2, "copy-icon"))), on.a.createElement("span", Ra2(Hi2, "copy-icon-copied"), "\u2714")) : on.a.createElement(zg2, Object.assign({ className: "copy-icon" }, Ra2(Hi2, "copy-icon")));
                      }, gr.clipboardValue = function(Hi2) {
                        switch (Qi2(Hi2)) {
                          case "function":
                          case "regexp":
                            return Hi2.toString();
                          default:
                            return Hi2;
                        }
                      }, gr.state = { copied: false }, gr;
                    }
                    return Yn(On, [{ key: "componentWillUnmount", value: function() {
                      this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
                    } }, { key: "render", value: function() {
                      var ur = this.props, gr = (ur.src, ur.theme), Hi2 = ur.hidden, Fa2 = ur.rowHovered, ma2 = Ra2(gr, "copy-to-clipboard").style, Ri2 = "inline";
                      return Hi2 && (Ri2 = "none"), on.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Fa2 ? "inline-block" : "none" } }, on.a.createElement("span", { style: nn(nn({}, ma2), {}, { display: Ri2 }), onClick: this.handleCopy }, this.getClippyIcon()));
                    } }]), On;
                  }(on.a.PureComponent), ab2 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      return dn(this, On), (gr = Dr.call(this, ur)).getEditIcon = function() {
                        var Hi2 = gr.props, Fa2 = Hi2.variable, ma2 = Hi2.theme;
                        return on.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: gr.state.hovered ? "inline-block" : "none" } }, on.a.createElement(Hd2, Object.assign({ className: "click-to-edit-icon" }, Ra2(ma2, "editVarIcon"), { onClick: function() {
                          gr.prepopInput(Fa2);
                        } })));
                      }, gr.prepopInput = function(Hi2) {
                        if (gr.props.onEdit !== false) {
                          var Fa2 = function(Ri2) {
                            var Ho;
                            switch (Qi2(Ri2)) {
                              case "undefined":
                                Ho = "undefined";
                                break;
                              case "nan":
                                Ho = "NaN";
                                break;
                              case "string":
                                Ho = Ri2;
                                break;
                              case "date":
                              case "function":
                              case "regexp":
                                Ho = Ri2.toString();
                                break;
                              default:
                                try {
                                  Ho = JSON.stringify(Ri2, null, "  ");
                                } catch {
                                  Ho = "";
                                }
                            }
                            return Ho;
                          }(Hi2.value), ma2 = Os(Fa2);
                          gr.setState({ editMode: true, editValue: Fa2, parsedInput: { type: ma2.type, value: ma2.value } });
                        }
                      }, gr.getRemoveIcon = function() {
                        var Hi2 = gr.props, Fa2 = Hi2.variable, ma2 = Hi2.namespace, Ri2 = Hi2.theme, Ho = Hi2.rjvId;
                        return on.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: gr.state.hovered ? "inline-block" : "none" } }, on.a.createElement(c_, Object.assign({ className: "click-to-remove-icon" }, Ra2(Ri2, "removeVarIcon"), { onClick: function() {
                          Cf2.dispatch({ name: "VARIABLE_REMOVED", rjvId: Ho, data: { name: Fa2.name, namespace: ma2, existing_value: Fa2.value, variable_removed: true } });
                        } })));
                      }, gr.getValue = function(Hi2, Fa2) {
                        var ma2 = !Fa2 && Hi2.type, Ri2 = _i(gr).props;
                        switch (ma2) {
                          case false:
                            return gr.getEditInput();
                          case "string":
                            return on.a.createElement(Ry, Object.assign({ value: Hi2.value }, Ri2));
                          case "integer":
                            return on.a.createElement(uS, Object.assign({ value: Hi2.value }, Ri2));
                          case "float":
                            return on.a.createElement(pa2, Object.assign({ value: Hi2.value }, Ri2));
                          case "boolean":
                            return on.a.createElement(Ga2, Object.assign({ value: Hi2.value }, Ri2));
                          case "function":
                            return on.a.createElement(Gp, Object.assign({ value: Hi2.value }, Ri2));
                          case "null":
                            return on.a.createElement(B0, Ri2);
                          case "nan":
                            return on.a.createElement($v, Ri2);
                          case "undefined":
                            return on.a.createElement(Rx, Ri2);
                          case "date":
                            return on.a.createElement(ha2, Object.assign({ value: Hi2.value }, Ri2));
                          case "regexp":
                            return on.a.createElement(FM, Object.assign({ value: Hi2.value }, Ri2));
                          default:
                            return on.a.createElement("div", { className: "object-value" }, JSON.stringify(Hi2.value));
                        }
                      }, gr.getEditInput = function() {
                        var Hi2 = gr.props.theme, Fa2 = gr.state.editValue;
                        return on.a.createElement("div", null, on.a.createElement(xo, Object.assign({ type: "text", inputRef: function(ma2) {
                          return ma2 && ma2.focus();
                        }, value: Fa2, className: "variable-editor", onChange: function(ma2) {
                          var Ri2 = ma2.target.value, Ho = Os(Ri2);
                          gr.setState({ editValue: Ri2, parsedInput: { type: Ho.type, value: Ho.value } });
                        }, onKeyDown: function(ma2) {
                          switch (ma2.key) {
                            case "Escape":
                              gr.setState({ editMode: false, editValue: "" });
                              break;
                            case "Enter":
                              (ma2.ctrlKey || ma2.metaKey) && gr.submitEdit(true);
                          }
                          ma2.stopPropagation();
                        }, placeholder: "update this value", minRows: 2 }, Ra2(Hi2, "edit-input"))), on.a.createElement("div", Ra2(Hi2, "edit-icon-container"), on.a.createElement(c_, Object.assign({ className: "edit-cancel" }, Ra2(Hi2, "cancel-icon"), { onClick: function() {
                          gr.setState({ editMode: false, editValue: "" });
                        } })), on.a.createElement(Yv, Object.assign({ className: "edit-check string-value" }, Ra2(Hi2, "check-icon"), { onClick: function() {
                          gr.submitEdit();
                        } })), on.a.createElement("div", null, gr.showDetected())));
                      }, gr.submitEdit = function(Hi2) {
                        var Fa2 = gr.props, ma2 = Fa2.variable, Ri2 = Fa2.namespace, Ho = Fa2.rjvId, iu = gr.state, th2 = iu.editValue, rp = iu.parsedInput, Dd2 = th2;
                        Hi2 && rp.type && (Dd2 = rp.value), gr.setState({ editMode: false }), Cf2.dispatch({ name: "VARIABLE_UPDATED", rjvId: Ho, data: { name: ma2.name, namespace: Ri2, existing_value: ma2.value, new_value: Dd2, variable_removed: false } });
                      }, gr.showDetected = function() {
                        var Hi2 = gr.props, Fa2 = Hi2.theme, ma2 = (Hi2.variable, Hi2.namespace, Hi2.rjvId, gr.state.parsedInput), Ri2 = (ma2.type, ma2.value, gr.getDetectedInput());
                        if (Ri2)
                          return on.a.createElement("div", null, on.a.createElement("div", Ra2(Fa2, "detected-row"), Ri2, on.a.createElement(Yv, { className: "edit-check detected", style: nn({ verticalAlign: "top", paddingLeft: "3px" }, Ra2(Fa2, "check-icon").style), onClick: function() {
                            gr.submitEdit(true);
                          } })));
                      }, gr.getDetectedInput = function() {
                        var Hi2 = gr.state.parsedInput, Fa2 = Hi2.type, ma2 = Hi2.value, Ri2 = _i(gr).props, Ho = Ri2.theme;
                        if (Fa2 !== false)
                          switch (Fa2.toLowerCase()) {
                            case "object":
                              return on.a.createElement("span", null, on.a.createElement("span", { style: nn(nn({}, Ra2(Ho, "brace").style), {}, { cursor: "default" }) }, "{"), on.a.createElement("span", { style: nn(nn({}, Ra2(Ho, "ellipsis").style), {}, { cursor: "default" }) }, "..."), on.a.createElement("span", { style: nn(nn({}, Ra2(Ho, "brace").style), {}, { cursor: "default" }) }, "}"));
                            case "array":
                              return on.a.createElement("span", null, on.a.createElement("span", { style: nn(nn({}, Ra2(Ho, "brace").style), {}, { cursor: "default" }) }, "["), on.a.createElement("span", { style: nn(nn({}, Ra2(Ho, "ellipsis").style), {}, { cursor: "default" }) }, "..."), on.a.createElement("span", { style: nn(nn({}, Ra2(Ho, "brace").style), {}, { cursor: "default" }) }, "]"));
                            case "string":
                              return on.a.createElement(Ry, Object.assign({ value: ma2 }, Ri2));
                            case "integer":
                              return on.a.createElement(uS, Object.assign({ value: ma2 }, Ri2));
                            case "float":
                              return on.a.createElement(pa2, Object.assign({ value: ma2 }, Ri2));
                            case "boolean":
                              return on.a.createElement(Ga2, Object.assign({ value: ma2 }, Ri2));
                            case "function":
                              return on.a.createElement(Gp, Object.assign({ value: ma2 }, Ri2));
                            case "null":
                              return on.a.createElement(B0, Ri2);
                            case "nan":
                              return on.a.createElement($v, Ri2);
                            case "undefined":
                              return on.a.createElement(Rx, Ri2);
                            case "date":
                              return on.a.createElement(ha2, Object.assign({ value: new Date(ma2) }, Ri2));
                          }
                      }, gr.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, gr;
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this, gr = this.props, Hi2 = gr.variable, Fa2 = gr.singleIndent, ma2 = gr.type, Ri2 = gr.theme, Ho = gr.namespace, iu = gr.indentWidth, th2 = gr.enableClipboard, rp = gr.onEdit, Dd2 = gr.onDelete, Hf2 = gr.onSelect, Ed2 = gr.displayArrayKey, Kv = gr.quotesOnKeys, Bc2 = this.state.editMode;
                      return on.a.createElement("div", Object.assign({}, Ra2(Ri2, "objectKeyVal", { paddingLeft: iu * Fa2 }), { onMouseEnter: function() {
                        return ur.setState(nn(nn({}, ur.state), {}, { hovered: true }));
                      }, onMouseLeave: function() {
                        return ur.setState(nn(nn({}, ur.state), {}, { hovered: false }));
                      }, className: "variable-row", key: Hi2.name }), ma2 == "array" ? Ed2 ? on.a.createElement("span", Object.assign({}, Ra2(Ri2, "array-key"), { key: Hi2.name + "_" + Ho }), Hi2.name, on.a.createElement("div", Ra2(Ri2, "colon"), ":")) : null : on.a.createElement("span", null, on.a.createElement("span", Object.assign({}, Ra2(Ri2, "object-name"), { className: "object-key", key: Hi2.name + "_" + Ho }), !!Kv && on.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), on.a.createElement("span", { style: { display: "inline-block" } }, Hi2.name), !!Kv && on.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), on.a.createElement("span", Ra2(Ri2, "colon"), ":")), on.a.createElement("div", Object.assign({ className: "variable-value", onClick: Hf2 === false && rp === false ? null : function(py) {
                        var Fx = ep(Ho);
                        (py.ctrlKey || py.metaKey) && rp !== false ? ur.prepopInput(Hi2) : Hf2 !== false && (Fx.shift(), Hf2(nn(nn({}, Hi2), {}, { namespace: Fx })));
                      } }, Ra2(Ri2, "variableValue", { cursor: Hf2 === false ? "default" : "pointer" })), this.getValue(Hi2, Bc2)), th2 ? on.a.createElement(hy, { rowHovered: this.state.hovered, hidden: Bc2, src: Hi2.value, clickCallback: th2, theme: Ri2, namespace: [].concat(ep(Ho), [Hi2.name]) }) : null, rp !== false && Bc2 == 0 ? this.getEditIcon() : null, Dd2 !== false && Bc2 == 0 ? this.getRemoveIcon() : null);
                    } }]), On;
                  }(on.a.PureComponent), BM = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      var ur;
                      dn(this, On);
                      for (var gr = arguments.length, Hi2 = new Array(gr), Fa2 = 0; Fa2 < gr; Fa2++)
                        Hi2[Fa2] = arguments[Fa2];
                      return (ur = Dr.call.apply(Dr, [this].concat(Hi2))).getObjectSize = function() {
                        var ma2 = ur.props, Ri2 = ma2.size, Ho = ma2.theme;
                        if (ma2.displayObjectSize)
                          return on.a.createElement("span", Object.assign({ className: "object-size" }, Ra2(Ho, "object-size")), Ri2, " item", Ri2 === 1 ? "" : "s");
                      }, ur.getAddAttribute = function(ma2) {
                        var Ri2 = ur.props, Ho = Ri2.theme, iu = Ri2.namespace, th2 = Ri2.name, rp = Ri2.src, Dd2 = Ri2.rjvId, Hf2 = Ri2.depth;
                        return on.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: ma2 ? "inline-block" : "none" } }, on.a.createElement(Nx, Object.assign({ className: "click-to-add-icon" }, Ra2(Ho, "addVarIcon"), { onClick: function() {
                          var Ed2 = { name: Hf2 > 0 ? th2 : null, namespace: iu.splice(0, iu.length - 1), existing_value: rp, variable_removed: false, key_name: null };
                          Qi2(rp) === "object" ? Cf2.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Dd2, data: Ed2 }) : Cf2.dispatch({ name: "VARIABLE_ADDED", rjvId: Dd2, data: nn(nn({}, Ed2), {}, { new_value: [].concat(ep(rp), [null]) }) });
                        } })));
                      }, ur.getRemoveObject = function(ma2) {
                        var Ri2 = ur.props, Ho = Ri2.theme, iu = (Ri2.hover, Ri2.namespace), th2 = Ri2.name, rp = Ri2.src, Dd2 = Ri2.rjvId;
                        if (iu.length !== 1)
                          return on.a.createElement("span", { className: "click-to-remove", style: { display: ma2 ? "inline-block" : "none" } }, on.a.createElement(c_, Object.assign({ className: "click-to-remove-icon" }, Ra2(Ho, "removeVarIcon"), { onClick: function() {
                            Cf2.dispatch({ name: "VARIABLE_REMOVED", rjvId: Dd2, data: { name: th2, namespace: iu.splice(0, iu.length - 1), existing_value: rp, variable_removed: true } });
                          } })));
                      }, ur.render = function() {
                        var ma2 = ur.props, Ri2 = ma2.theme, Ho = ma2.onDelete, iu = ma2.onAdd, th2 = ma2.enableClipboard, rp = ma2.src, Dd2 = ma2.namespace, Hf2 = ma2.rowHovered;
                        return on.a.createElement("div", Object.assign({}, Ra2(Ri2, "object-meta-data"), { className: "object-meta-data", onClick: function(Ed2) {
                          Ed2.stopPropagation();
                        } }), ur.getObjectSize(), th2 ? on.a.createElement(hy, { rowHovered: Hf2, clickCallback: th2, src: rp, theme: Ri2, namespace: Dd2 }) : null, iu !== false ? ur.getAddAttribute(Hf2) : null, Ho !== false ? ur.getRemoveObject(Hf2) : null);
                      }, ur;
                    }
                    return On;
                  }(on.a.PureComponent);
                  function i1(br) {
                    var Dr = br.parent_type, On = br.namespace, ur = br.quotesOnKeys, gr = br.theme, Hi2 = br.jsvRoot, Fa2 = br.name, ma2 = br.displayArrayKey, Ri2 = br.name ? br.name : "";
                    return !Hi2 || Fa2 !== false && Fa2 !== null ? Dr == "array" ? ma2 ? on.a.createElement("span", Object.assign({}, Ra2(gr, "array-key"), { key: On }), on.a.createElement("span", { className: "array-key" }, Ri2), on.a.createElement("span", Ra2(gr, "colon"), ":")) : on.a.createElement("span", null) : on.a.createElement("span", Object.assign({}, Ra2(gr, "object-name"), { key: On }), on.a.createElement("span", { className: "object-key" }, ur && on.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), on.a.createElement("span", null, Ri2), ur && on.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), on.a.createElement("span", Ra2(gr, "colon"), ":")) : on.a.createElement("span", null);
                  }
                  function f_(br) {
                    var Dr = br.theme;
                    switch (br.iconStyle) {
                      case "triangle":
                        return on.a.createElement(z0, Object.assign({}, Ra2(Dr, "expanded-icon"), { className: "expanded-icon" }));
                      case "square":
                        return on.a.createElement(ud2, Object.assign({}, Ra2(Dr, "expanded-icon"), { className: "expanded-icon" }));
                      default:
                        return on.a.createElement(Iu, Object.assign({}, Ra2(Dr, "expanded-icon"), { className: "expanded-icon" }));
                    }
                  }
                  function fS(br) {
                    var Dr = br.theme;
                    switch (br.iconStyle) {
                      case "triangle":
                        return on.a.createElement(Bg2, Object.assign({}, Ra2(Dr, "collapsed-icon"), { className: "collapsed-icon" }));
                      case "square":
                        return on.a.createElement(iv, Object.assign({}, Ra2(Dr, "collapsed-icon"), { className: "collapsed-icon" }));
                      default:
                        return on.a.createElement(Tf2, Object.assign({}, Ra2(Dr, "collapsed-icon"), { className: "collapsed-icon" }));
                    }
                  }
                  var fL = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      return dn(this, On), (gr = Dr.call(this, ur)).toggleCollapsed = function(Hi2) {
                        var Fa2 = [];
                        for (var ma2 in gr.state.expanded)
                          Fa2.push(gr.state.expanded[ma2]);
                        Fa2[Hi2] = !Fa2[Hi2], gr.setState({ expanded: Fa2 });
                      }, gr.state = { expanded: [] }, gr;
                    }
                    return Yn(On, [{ key: "getExpandedIcon", value: function(ur) {
                      var gr = this.props, Hi2 = gr.theme, Fa2 = gr.iconStyle;
                      return this.state.expanded[ur] ? on.a.createElement(f_, { theme: Hi2, iconStyle: Fa2 }) : on.a.createElement(fS, { theme: Hi2, iconStyle: Fa2 });
                    } }, { key: "render", value: function() {
                      var ur = this, gr = this.props, Hi2 = gr.src, Fa2 = gr.groupArraysAfterLength, ma2 = (gr.depth, gr.name), Ri2 = gr.theme, Ho = gr.jsvRoot, iu = gr.namespace, th2 = (gr.parent_type, Fi2(gr, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), rp = 0, Dd2 = 5 * this.props.indentWidth;
                      Ho || (rp = 5 * this.props.indentWidth);
                      var Hf2 = Fa2, Ed2 = Math.ceil(Hi2.length / Hf2);
                      return on.a.createElement("div", Object.assign({ className: "object-key-val" }, Ra2(Ri2, Ho ? "jsv-root" : "objectKeyVal", { paddingLeft: rp })), on.a.createElement(i1, this.props), on.a.createElement("span", null, on.a.createElement(BM, Object.assign({ size: Hi2.length }, this.props))), ep(Array(Ed2)).map(function(Kv, Bc2) {
                        return on.a.createElement("div", Object.assign({ key: Bc2, className: "object-key-val array-group" }, Ra2(Ri2, "objectKeyVal", { marginLeft: 6, paddingLeft: Dd2 })), on.a.createElement("span", Ra2(Ri2, "brace-row"), on.a.createElement("div", Object.assign({ className: "icon-container" }, Ra2(Ri2, "icon-container"), { onClick: function(py) {
                          ur.toggleCollapsed(Bc2);
                        } }), ur.getExpandedIcon(Bc2)), ur.state.expanded[Bc2] ? on.a.createElement(hL, Object.assign({ key: ma2 + Bc2, depth: 0, name: false, collapsed: false, groupArraysAfterLength: Hf2, index_offset: Bc2 * Hf2, src: Hi2.slice(Bc2 * Hf2, Bc2 * Hf2 + Hf2), namespace: iu, type: "array", parent_type: "array_group", theme: Ri2 }, th2)) : on.a.createElement("span", Object.assign({}, Ra2(Ri2, "brace"), { onClick: function(py) {
                          ur.toggleCollapsed(Bc2);
                        }, className: "array-group-brace" }), "[", on.a.createElement("div", Object.assign({}, Ra2(Ri2, "array-group-meta-data"), { className: "array-group-meta-data" }), on.a.createElement("span", Object.assign({ className: "object-size" }, Ra2(Ri2, "object-size")), Bc2 * Hf2, " - ", Bc2 * Hf2 + Hf2 > Hi2.length ? Hi2.length : Bc2 * Hf2 + Hf2)), "]")));
                      }));
                    } }]), On;
                  }(on.a.PureComponent), o5 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      dn(this, On), (gr = Dr.call(this, ur)).toggleCollapsed = function() {
                        gr.setState({ expanded: !gr.state.expanded }, function() {
                          bh2.set(gr.props.rjvId, gr.props.namespace, "expanded", gr.state.expanded);
                        });
                      }, gr.getObjectContent = function(Fa2, ma2, Ri2) {
                        return on.a.createElement("div", { className: "pushed-content object-container" }, on.a.createElement("div", Object.assign({ className: "object-content" }, Ra2(gr.props.theme, "pushed-content")), gr.renderObjectContents(ma2, Ri2)));
                      }, gr.getEllipsis = function() {
                        return gr.state.size === 0 ? null : on.a.createElement("div", Object.assign({}, Ra2(gr.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: gr.toggleCollapsed }), "...");
                      }, gr.getObjectMetaData = function(Fa2) {
                        var ma2 = gr.props, Ri2 = (ma2.rjvId, ma2.theme, gr.state), Ho = Ri2.size, iu = Ri2.hovered;
                        return on.a.createElement(BM, Object.assign({ rowHovered: iu, size: Ho }, gr.props));
                      }, gr.renderObjectContents = function(Fa2, ma2) {
                        var Ri2, Ho = gr.props, iu = Ho.depth, th2 = Ho.parent_type, rp = Ho.index_offset, Dd2 = Ho.groupArraysAfterLength, Hf2 = Ho.namespace, Ed2 = gr.state.object_type, Kv = [], Bc2 = Object.keys(Fa2 || {});
                        return gr.props.sortKeys && Ed2 !== "array" && (Bc2 = Bc2.sort()), Bc2.forEach(function(py) {
                          if (Ri2 = new Kht(py, Fa2[py]), th2 === "array_group" && rp && (Ri2.name = parseInt(Ri2.name) + rp), Fa2.hasOwnProperty(py))
                            if (Ri2.type === "object")
                              Kv.push(on.a.createElement(hL, Object.assign({ key: Ri2.name, depth: iu + 1, name: Ri2.name, src: Ri2.value, namespace: Hf2.concat(Ri2.name), parent_type: Ed2 }, ma2)));
                            else if (Ri2.type === "array") {
                              var Fx = hL;
                              Dd2 && Ri2.value.length > Dd2 && (Fx = fL), Kv.push(on.a.createElement(Fx, Object.assign({ key: Ri2.name, depth: iu + 1, name: Ri2.name, src: Ri2.value, namespace: Hf2.concat(Ri2.name), type: "array", parent_type: Ed2 }, ma2)));
                            } else
                              Kv.push(on.a.createElement(ab2, Object.assign({ key: Ri2.name + "_" + Hf2, variable: Ri2, singleIndent: 5, namespace: Hf2, type: gr.props.type }, ma2)));
                        }), Kv;
                      };
                      var Hi2 = On.getState(ur);
                      return gr.state = nn(nn({}, Hi2), {}, { prevProps: {} }), gr;
                    }
                    return Yn(On, [{ key: "getBraceStart", value: function(ur, gr) {
                      var Hi2 = this, Fa2 = this.props, ma2 = Fa2.src, Ri2 = Fa2.theme, Ho = Fa2.iconStyle;
                      if (Fa2.parent_type === "array_group")
                        return on.a.createElement("span", null, on.a.createElement("span", Ra2(Ri2, "brace"), ur === "array" ? "[" : "{"), gr ? this.getObjectMetaData(ma2) : null);
                      var iu = gr ? f_ : fS;
                      return on.a.createElement("span", null, on.a.createElement("span", Object.assign({ onClick: function(th2) {
                        Hi2.toggleCollapsed();
                      } }, Ra2(Ri2, "brace-row")), on.a.createElement("div", Object.assign({ className: "icon-container" }, Ra2(Ri2, "icon-container")), on.a.createElement(iu, { theme: Ri2, iconStyle: Ho })), on.a.createElement(i1, this.props), on.a.createElement("span", Ra2(Ri2, "brace"), ur === "array" ? "[" : "{")), gr ? this.getObjectMetaData(ma2) : null);
                    } }, { key: "render", value: function() {
                      var ur = this, gr = this.props, Hi2 = gr.depth, Fa2 = gr.src, ma2 = (gr.namespace, gr.name, gr.type, gr.parent_type), Ri2 = gr.theme, Ho = gr.jsvRoot, iu = gr.iconStyle, th2 = Fi2(gr, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), rp = this.state, Dd2 = rp.object_type, Hf2 = rp.expanded, Ed2 = {};
                      return Ho || ma2 === "array_group" ? ma2 === "array_group" && (Ed2.borderLeft = 0, Ed2.display = "inline") : Ed2.paddingLeft = 5 * this.props.indentWidth, on.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                        return ur.setState(nn(nn({}, ur.state), {}, { hovered: true }));
                      }, onMouseLeave: function() {
                        return ur.setState(nn(nn({}, ur.state), {}, { hovered: false }));
                      } }, Ra2(Ri2, Ho ? "jsv-root" : "objectKeyVal", Ed2)), this.getBraceStart(Dd2, Hf2), Hf2 ? this.getObjectContent(Hi2, Fa2, nn({ theme: Ri2, iconStyle: iu }, th2)) : this.getEllipsis(), on.a.createElement("span", { className: "brace-row" }, on.a.createElement("span", { style: nn(nn({}, Ra2(Ri2, "brace").style), {}, { paddingLeft: Hf2 ? "3px" : "0px" }) }, Dd2 === "array" ? "]" : "}"), Hf2 ? null : this.getObjectMetaData(Fa2)));
                    } }], [{ key: "getDerivedStateFromProps", value: function(ur, gr) {
                      var Hi2 = gr.prevProps;
                      return ur.src !== Hi2.src || ur.collapsed !== Hi2.collapsed || ur.name !== Hi2.name || ur.namespace !== Hi2.namespace || ur.rjvId !== Hi2.rjvId ? nn(nn({}, On.getState(ur)), {}, { prevProps: ur }) : null;
                    } }]), On;
                  }(on.a.PureComponent);
                  o5.getState = function(br) {
                    var Dr = Object.keys(br.src).length, On = (br.collapsed === false || br.collapsed !== true && br.collapsed > br.depth) && (!br.shouldCollapse || br.shouldCollapse({ name: br.name, src: br.src, type: Qi2(br.src), namespace: br.namespace }) === false) && Dr !== 0;
                    return { expanded: bh2.get(br.rjvId, br.namespace, "expanded", On), object_type: br.type === "array" ? "array" : "object", parent_type: br.type === "array" ? "array" : "object", size: Dr, hovered: false };
                  };
                  var Kht = function br(Dr, On) {
                    dn(this, br), this.name = Dr, this.value = On, this.type = Qi2(On);
                  };
                  Da2(o5);
                  var hL = o5, wJ = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      var ur;
                      dn(this, On);
                      for (var gr = arguments.length, Hi2 = new Array(gr), Fa2 = 0; Fa2 < gr; Fa2++)
                        Hi2[Fa2] = arguments[Fa2];
                      return (ur = Dr.call.apply(Dr, [this].concat(Hi2))).render = function() {
                        var ma2 = _i(ur).props, Ri2 = [ma2.name], Ho = hL;
                        return Array.isArray(ma2.src) && ma2.groupArraysAfterLength && ma2.src.length > ma2.groupArraysAfterLength && (Ho = fL), on.a.createElement("div", { className: "pretty-json-container object-container" }, on.a.createElement("div", { className: "object-content" }, on.a.createElement(Ho, Object.assign({ namespace: Ri2, depth: 0, jsvRoot: true }, ma2))));
                      }, ur;
                    }
                    return On;
                  }(on.a.PureComponent), SJ = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      return dn(this, On), (gr = Dr.call(this, ur)).closeModal = function() {
                        Cf2.dispatch({ rjvId: gr.props.rjvId, name: "RESET" });
                      }, gr.submit = function() {
                        gr.props.submit(gr.state.input);
                      }, gr.state = { input: ur.input ? ur.input : "" }, gr;
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this, gr = this.props, Hi2 = gr.theme, Fa2 = gr.rjvId, ma2 = gr.isValid, Ri2 = this.state.input, Ho = ma2(Ri2);
                      return on.a.createElement("div", Object.assign({ className: "key-modal-request" }, Ra2(Hi2, "key-modal-request"), { onClick: this.closeModal }), on.a.createElement("div", Object.assign({}, Ra2(Hi2, "key-modal"), { onClick: function(iu) {
                        iu.stopPropagation();
                      } }), on.a.createElement("div", Ra2(Hi2, "key-modal-label"), "Key Name:"), on.a.createElement("div", { style: { position: "relative" } }, on.a.createElement("input", Object.assign({}, Ra2(Hi2, "key-modal-input"), { className: "key-modal-input", ref: function(iu) {
                        return iu && iu.focus();
                      }, spellCheck: false, value: Ri2, placeholder: "...", onChange: function(iu) {
                        ur.setState({ input: iu.target.value });
                      }, onKeyPress: function(iu) {
                        Ho && iu.key === "Enter" ? ur.submit() : iu.key === "Escape" && ur.closeModal();
                      } })), Ho ? on.a.createElement(Yv, Object.assign({}, Ra2(Hi2, "key-modal-submit"), { className: "key-modal-submit", onClick: function(iu) {
                        return ur.submit();
                      } })) : null), on.a.createElement("span", Ra2(Hi2, "key-modal-cancel"), on.a.createElement(Ny, Object.assign({}, Ra2(Hi2, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                        Cf2.dispatch({ rjvId: Fa2, name: "RESET" });
                      } })))));
                    } }]), On;
                  }(on.a.PureComponent), Xht = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      var ur;
                      dn(this, On);
                      for (var gr = arguments.length, Hi2 = new Array(gr), Fa2 = 0; Fa2 < gr; Fa2++)
                        Hi2[Fa2] = arguments[Fa2];
                      return (ur = Dr.call.apply(Dr, [this].concat(Hi2))).isValid = function(ma2) {
                        var Ri2 = ur.props.rjvId, Ho = bh2.get(Ri2, "action", "new-key-request");
                        return ma2 != "" && Object.keys(Ho.existing_value).indexOf(ma2) === -1;
                      }, ur.submit = function(ma2) {
                        var Ri2 = ur.props.rjvId, Ho = bh2.get(Ri2, "action", "new-key-request");
                        Ho.new_value = nn({}, Ho.existing_value), Ho.new_value[ma2] = ur.props.defaultValue, Cf2.dispatch({ name: "VARIABLE_ADDED", rjvId: Ri2, data: Ho });
                      }, ur;
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.active, Hi2 = ur.theme, Fa2 = ur.rjvId;
                      return gr ? on.a.createElement(SJ, { rjvId: Fa2, theme: Hi2, isValid: this.isValid, submit: this.submit }) : null;
                    } }]), On;
                  }(on.a.PureComponent), eH = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On() {
                      return dn(this, On), Dr.apply(this, arguments);
                    }
                    return Yn(On, [{ key: "render", value: function() {
                      var ur = this.props, gr = ur.message, Hi2 = ur.active, Fa2 = ur.theme, ma2 = ur.rjvId;
                      return Hi2 ? on.a.createElement("div", Object.assign({ className: "validation-failure" }, Ra2(Fa2, "validation-failure"), { onClick: function() {
                        Cf2.dispatch({ rjvId: ma2, name: "RESET" });
                      } }), on.a.createElement("span", Ra2(Fa2, "validation-failure-label"), gr), on.a.createElement(Ny, Ra2(Fa2, "validation-failure-clear"))) : null;
                    } }]), On;
                  }(on.a.PureComponent), b62 = function(br) {
                    Ur(On, br);
                    var Dr = Ia2(On);
                    function On(ur) {
                      var gr;
                      return dn(this, On), (gr = Dr.call(this, ur)).rjvId = Date.now().toString(), gr.getListeners = function() {
                        return { reset: gr.resetState, "variable-update": gr.updateSrc, "add-key-request": gr.addKeyRequest };
                      }, gr.updateSrc = function() {
                        var Hi2, Fa2 = bh2.get(gr.rjvId, "action", "variable-update"), ma2 = Fa2.name, Ri2 = Fa2.namespace, Ho = Fa2.new_value, iu = Fa2.existing_value, th2 = (Fa2.variable_removed, Fa2.updated_src), rp = Fa2.type, Dd2 = gr.props, Hf2 = Dd2.onEdit, Ed2 = Dd2.onDelete, Kv = Dd2.onAdd, Bc2 = { existing_src: gr.state.src, new_value: Ho, updated_src: th2, name: ma2, namespace: Ri2, existing_value: iu };
                        switch (rp) {
                          case "variable-added":
                            Hi2 = Kv(Bc2);
                            break;
                          case "variable-edited":
                            Hi2 = Hf2(Bc2);
                            break;
                          case "variable-removed":
                            Hi2 = Ed2(Bc2);
                        }
                        Hi2 !== false ? (bh2.set(gr.rjvId, "global", "src", th2), gr.setState({ src: th2 })) : gr.setState({ validationFailure: true });
                      }, gr.addKeyRequest = function() {
                        gr.setState({ addKeyRequest: true });
                      }, gr.resetState = function() {
                        gr.setState({ validationFailure: false, addKeyRequest: false });
                      }, gr.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: On.defaultProps.src, name: On.defaultProps.name, theme: On.defaultProps.theme, validationMessage: On.defaultProps.validationMessage, prevSrc: On.defaultProps.src, prevName: On.defaultProps.name, prevTheme: On.defaultProps.theme }, gr;
                    }
                    return Yn(On, [{ key: "componentDidMount", value: function() {
                      bh2.set(this.rjvId, "global", "src", this.state.src);
                      var ur = this.getListeners();
                      for (var gr in ur)
                        bh2.on(gr + "-" + this.rjvId, ur[gr]);
                      this.setState({ addKeyRequest: false, editKeyRequest: false });
                    } }, { key: "componentDidUpdate", value: function(ur, gr) {
                      gr.addKeyRequest !== false && this.setState({ addKeyRequest: false }), gr.editKeyRequest !== false && this.setState({ editKeyRequest: false }), ur.src !== this.state.src && bh2.set(this.rjvId, "global", "src", this.state.src);
                    } }, { key: "componentWillUnmount", value: function() {
                      var ur = this.getListeners();
                      for (var gr in ur)
                        bh2.removeListener(gr + "-" + this.rjvId, ur[gr]);
                    } }, { key: "render", value: function() {
                      var ur = this.state, gr = ur.validationFailure, Hi2 = ur.validationMessage, Fa2 = ur.addKeyRequest, ma2 = ur.theme, Ri2 = ur.src, Ho = ur.name, iu = this.props, th2 = iu.style, rp = iu.defaultValue;
                      return on.a.createElement("div", { className: "react-json-view", style: nn(nn({}, Ra2(ma2, "app-container").style), th2) }, on.a.createElement(eH, { message: Hi2, active: gr, theme: ma2, rjvId: this.rjvId }), on.a.createElement(wJ, Object.assign({}, this.props, { src: Ri2, name: Ho, theme: ma2, type: Qi2(Ri2), rjvId: this.rjvId })), on.a.createElement(Xht, { active: Fa2, theme: ma2, rjvId: this.rjvId, defaultValue: rp }));
                    } }], [{ key: "getDerivedStateFromProps", value: function(ur, gr) {
                      if (ur.src !== gr.prevSrc || ur.name !== gr.prevName || ur.theme !== gr.prevTheme) {
                        var Hi2 = { src: ur.src, name: ur.name, theme: ur.theme, validationMessage: ur.validationMessage, prevSrc: ur.src, prevName: ur.name, prevTheme: ur.theme };
                        return On.validateState(Hi2);
                      }
                      return null;
                    } }]), On;
                  }(on.a.PureComponent);
                  b62.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, b62.validateState = function(br) {
                    var Dr = {};
                    return Qi2(br.theme) !== "object" || function(On) {
                      var ur = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                      if (Qi2(On) === "object") {
                        for (var gr = 0; gr < ur.length; gr++)
                          if (!(ur[gr] in On))
                            return false;
                        return true;
                      }
                      return false;
                    }(br.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Dr.theme = "rjv-default"), Qi2(br.src) !== "object" && Qi2(br.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Dr.name = "ERROR", Dr.src = { message: "src property must be a valid json object" }), nn(nn({}, br), Dr);
                  }, Da2(b62), Yt.default = b62;
                }]);
              });
            })(nc2);
            var lf2 = Lr(nc2.exports);
            const rb2 = ({ id: Vt, title: ve2, chart: Ut, option: $t }) => {
              const { tool: Yt } = Q3({}), se2 = oi2({ global: true }), [Re2, { set: He2 }] = un(true), nn = (dn) => {
                const { updated_src: yn } = dn;
                Ut == null || Ut.setOption(yn), Yt == null || Yt.add(Vt, Ut, yn, ve2), se2.emit("list");
              };
              return xJ("div", { children: [cL(Br, { children: cL(Ao, { children: cL(Mf2, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (dn) => {
                He2(!dn);
              } }) }) }), cL("br", {}), $t && cL(lf2, { src: $t, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: Re2, iconStyle: "triangle", enableClipboard: true, onEdit: nn, onAdd: nn, onDelete: nn })] });
            }, r1 = () => {
              const Vt = oi2({ global: true }), ve2 = Zt.useRef(0), { tool: Ut } = Q3({});
              Zt.useState(false), Zt.useState("right");
              const [$t, Yt] = Zt.useState([]), [se2, Re2] = Zt.useState();
              return Vt.useSubscription("list", () => {
                var He2;
                Ut != null && Ut.list().length && (Re2((He2 = Ut == null ? void 0 : Ut.list()) == null ? void 0 : He2[ve2.current]), Yt(Ut == null ? void 0 : Ut.list()));
              }), cL("div", { className: Uu.container, children: false });
            };
            Bt.EchartTool = r1, Bt.ReactEchartsJson = rb2, Bt.useEchartsTool = Q3, Bt.useEventEmitter = oi2;
          })(IQ);
          const uAt = () => {
            const Bt = Ot({ global: true }), ge2 = R6.useRef(0), { tool: Ht } = Ir({});
            R6.useState(false), R6.useState("right");
            const [qt, Zt] = R6.useState([]), [oe2, Ne2] = R6.useState();
            return Bt.useSubscription("list", () => {
              var Ge2;
              Ht != null && Ht.list().length && (Ne2((Ge2 = Ht == null ? void 0 : Ht.list()) == null ? void 0 : Ge2[ge2.current]), Zt(Ht == null ? void 0 : Ht.list()));
            }), ZR("div", { className: lAt.container, children: false });
          };
          var DQ = { exports: {} };
          (function(Bt, ge2) {
            (function(Ht, qt) {
              Bt.exports = qt(Z3.default);
            })(pt, function(Ht) {
              return function(qt) {
                var Zt = {};
                function oe2(Ne2) {
                  if (Zt[Ne2])
                    return Zt[Ne2].exports;
                  var Ge2 = Zt[Ne2] = { i: Ne2, l: false, exports: {} };
                  return qt[Ne2].call(Ge2.exports, Ge2, Ge2.exports, oe2), Ge2.l = true, Ge2.exports;
                }
                return oe2.m = qt, oe2.c = Zt, oe2.d = function(Ne2, Ge2, Ve) {
                  oe2.o(Ne2, Ge2) || Object.defineProperty(Ne2, Ge2, { enumerable: true, get: Ve });
                }, oe2.r = function(Ne2) {
                  typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(Ne2, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(Ne2, "__esModule", { value: true });
                }, oe2.t = function(Ne2, Ge2) {
                  if (1 & Ge2 && (Ne2 = oe2(Ne2)), 8 & Ge2 || 4 & Ge2 && typeof Ne2 == "object" && Ne2 && Ne2.__esModule)
                    return Ne2;
                  var Ve = /* @__PURE__ */ Object.create(null);
                  if (oe2.r(Ve), Object.defineProperty(Ve, "default", { enumerable: true, value: Ne2 }), 2 & Ge2 && typeof Ne2 != "string")
                    for (var pn in Ne2)
                      oe2.d(Ve, pn, function(vn) {
                        return Ne2[vn];
                      }.bind(null, pn));
                  return Ve;
                }, oe2.n = function(Ne2) {
                  var Ge2 = Ne2 && Ne2.__esModule ? function() {
                    return Ne2.default;
                  } : function() {
                    return Ne2;
                  };
                  return oe2.d(Ge2, "a", Ge2), Ge2;
                }, oe2.o = function(Ne2, Ge2) {
                  return Object.prototype.hasOwnProperty.call(Ne2, Ge2);
                }, oe2.p = "", oe2(oe2.s = 48);
              }([function(qt, Zt) {
                qt.exports = Ht;
              }, function(qt, Zt) {
                var oe2 = qt.exports = { version: "2.6.12" };
                typeof __e == "number" && (__e = oe2);
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(26)("wks"), Ge2 = oe2(17), Ve = oe2(3).Symbol, pn = typeof Ve == "function";
                (qt.exports = function(vn) {
                  return Ne2[vn] || (Ne2[vn] = pn && Ve[vn] || (pn ? Ve : Ge2)("Symbol." + vn));
                }).store = Ne2;
              }, function(qt, Zt) {
                var oe2 = qt.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
                typeof __g == "number" && (__g = oe2);
              }, function(qt, Zt, oe2) {
                qt.exports = !oe2(8)(function() {
                  return Object.defineProperty({}, "a", { get: function() {
                    return 7;
                  } }).a != 7;
                });
              }, function(qt, Zt) {
                var oe2 = {}.hasOwnProperty;
                qt.exports = function(Ne2, Ge2) {
                  return oe2.call(Ne2, Ge2);
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(7), Ge2 = oe2(16);
                qt.exports = oe2(4) ? function(Ve, pn, vn) {
                  return Ne2.f(Ve, pn, Ge2(1, vn));
                } : function(Ve, pn, vn) {
                  return Ve[pn] = vn, Ve;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(10), Ge2 = oe2(35), Ve = oe2(23), pn = Object.defineProperty;
                Zt.f = oe2(4) ? Object.defineProperty : function(vn, Gn, Lr) {
                  if (Ne2(vn), Gn = Ve(Gn, true), Ne2(Lr), Ge2)
                    try {
                      return pn(vn, Gn, Lr);
                    } catch {
                    }
                  if ("get" in Lr || "set" in Lr)
                    throw TypeError("Accessors not supported!");
                  return "value" in Lr && (vn[Gn] = Lr.value), vn;
                };
              }, function(qt, Zt) {
                qt.exports = function(oe2) {
                  try {
                    return !!oe2();
                  } catch {
                    return true;
                  }
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(40), Ge2 = oe2(22);
                qt.exports = function(Ve) {
                  return Ne2(Ge2(Ve));
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(11);
                qt.exports = function(Ge2) {
                  if (!Ne2(Ge2))
                    throw TypeError(Ge2 + " is not an object!");
                  return Ge2;
                };
              }, function(qt, Zt) {
                qt.exports = function(oe2) {
                  return typeof oe2 == "object" ? oe2 !== null : typeof oe2 == "function";
                };
              }, function(qt, Zt) {
                qt.exports = {};
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(39), Ge2 = oe2(27);
                qt.exports = Object.keys || function(Ve) {
                  return Ne2(Ve, Ge2);
                };
              }, function(qt, Zt) {
                qt.exports = true;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(3), Ge2 = oe2(1), Ve = oe2(53), pn = oe2(6), vn = oe2(5), Gn = function(Lr, Wr, Gr) {
                  var ei2, oi2, Va2, Ca2 = Lr & Gn.F, Go = Lr & Gn.G, un = Lr & Gn.S, Ei2 = Lr & Gn.P, Wi2 = Lr & Gn.B, La2 = Lr & Gn.W, Aa2 = Go ? Ge2 : Ge2[Wr] || (Ge2[Wr] = {}), Oi2 = Aa2.prototype, Zi2 = Go ? Ne2 : un ? Ne2[Wr] : (Ne2[Wr] || {}).prototype;
                  for (ei2 in Go && (Gr = Wr), Gr)
                    (oi2 = !Ca2 && Zi2 && Zi2[ei2] !== void 0) && vn(Aa2, ei2) || (Va2 = oi2 ? Zi2[ei2] : Gr[ei2], Aa2[ei2] = Go && typeof Zi2[ei2] != "function" ? Gr[ei2] : Wi2 && oi2 ? Ve(Va2, Ne2) : La2 && Zi2[ei2] == Va2 ? function(Ka2) {
                      var Fo = function(Si2, bl, vl) {
                        if (this instanceof Ka2) {
                          switch (arguments.length) {
                            case 0:
                              return new Ka2();
                            case 1:
                              return new Ka2(Si2);
                            case 2:
                              return new Ka2(Si2, bl);
                          }
                          return new Ka2(Si2, bl, vl);
                        }
                        return Ka2.apply(this, arguments);
                      };
                      return Fo.prototype = Ka2.prototype, Fo;
                    }(Va2) : Ei2 && typeof Va2 == "function" ? Ve(Function.call, Va2) : Va2, Ei2 && ((Aa2.virtual || (Aa2.virtual = {}))[ei2] = Va2, Lr & Gn.R && Oi2 && !Oi2[ei2] && pn(Oi2, ei2, Va2)));
                };
                Gn.F = 1, Gn.G = 2, Gn.S = 4, Gn.P = 8, Gn.B = 16, Gn.W = 32, Gn.U = 64, Gn.R = 128, qt.exports = Gn;
              }, function(qt, Zt) {
                qt.exports = function(oe2, Ne2) {
                  return { enumerable: !(1 & oe2), configurable: !(2 & oe2), writable: !(4 & oe2), value: Ne2 };
                };
              }, function(qt, Zt) {
                var oe2 = 0, Ne2 = Math.random();
                qt.exports = function(Ge2) {
                  return "Symbol(".concat(Ge2 === void 0 ? "" : Ge2, ")_", (++oe2 + Ne2).toString(36));
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(22);
                qt.exports = function(Ge2) {
                  return Object(Ne2(Ge2));
                };
              }, function(qt, Zt) {
                Zt.f = {}.propertyIsEnumerable;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(52)(true);
                oe2(34)(String, "String", function(Ge2) {
                  this._t = String(Ge2), this._i = 0;
                }, function() {
                  var Ge2, Ve = this._t, pn = this._i;
                  return pn >= Ve.length ? { value: void 0, done: true } : (Ge2 = Ne2(Ve, pn), this._i += Ge2.length, { value: Ge2, done: false });
                });
              }, function(qt, Zt) {
                var oe2 = Math.ceil, Ne2 = Math.floor;
                qt.exports = function(Ge2) {
                  return isNaN(Ge2 = +Ge2) ? 0 : (Ge2 > 0 ? Ne2 : oe2)(Ge2);
                };
              }, function(qt, Zt) {
                qt.exports = function(oe2) {
                  if (oe2 == null)
                    throw TypeError("Can't call method on  " + oe2);
                  return oe2;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(11);
                qt.exports = function(Ge2, Ve) {
                  if (!Ne2(Ge2))
                    return Ge2;
                  var pn, vn;
                  if (Ve && typeof (pn = Ge2.toString) == "function" && !Ne2(vn = pn.call(Ge2)) || typeof (pn = Ge2.valueOf) == "function" && !Ne2(vn = pn.call(Ge2)) || !Ve && typeof (pn = Ge2.toString) == "function" && !Ne2(vn = pn.call(Ge2)))
                    return vn;
                  throw TypeError("Can't convert object to primitive value");
                };
              }, function(qt, Zt) {
                var oe2 = {}.toString;
                qt.exports = function(Ne2) {
                  return oe2.call(Ne2).slice(8, -1);
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(26)("keys"), Ge2 = oe2(17);
                qt.exports = function(Ve) {
                  return Ne2[Ve] || (Ne2[Ve] = Ge2(Ve));
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(1), Ge2 = oe2(3), Ve = Ge2["__core-js_shared__"] || (Ge2["__core-js_shared__"] = {});
                (qt.exports = function(pn, vn) {
                  return Ve[pn] || (Ve[pn] = vn !== void 0 ? vn : {});
                })("versions", []).push({ version: Ne2.version, mode: oe2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
              }, function(qt, Zt) {
                qt.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(7).f, Ge2 = oe2(5), Ve = oe2(2)("toStringTag");
                qt.exports = function(pn, vn, Gn) {
                  pn && !Ge2(pn = Gn ? pn : pn.prototype, Ve) && Ne2(pn, Ve, { configurable: true, value: vn });
                };
              }, function(qt, Zt, oe2) {
                oe2(62);
                for (var Ne2 = oe2(3), Ge2 = oe2(6), Ve = oe2(12), pn = oe2(2)("toStringTag"), vn = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), Gn = 0; Gn < vn.length; Gn++) {
                  var Lr = vn[Gn], Wr = Ne2[Lr], Gr = Wr && Wr.prototype;
                  Gr && !Gr[pn] && Ge2(Gr, pn, Lr), Ve[Lr] = Ve.Array;
                }
              }, function(qt, Zt, oe2) {
                Zt.f = oe2(2);
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(3), Ge2 = oe2(1), Ve = oe2(14), pn = oe2(30), vn = oe2(7).f;
                qt.exports = function(Gn) {
                  var Lr = Ge2.Symbol || (Ge2.Symbol = Ve ? {} : Ne2.Symbol || {});
                  Gn.charAt(0) == "_" || Gn in Lr || vn(Lr, Gn, { value: pn.f(Gn) });
                };
              }, function(qt, Zt) {
                Zt.f = Object.getOwnPropertySymbols;
              }, function(qt, Zt) {
                qt.exports = function(oe2, Ne2, Ge2) {
                  return Math.min(Math.max(oe2, Ne2), Ge2);
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(14), Ge2 = oe2(15), Ve = oe2(37), pn = oe2(6), vn = oe2(12), Gn = oe2(55), Lr = oe2(28), Wr = oe2(61), Gr = oe2(2)("iterator"), ei2 = !([].keys && "next" in [].keys()), oi2 = function() {
                  return this;
                };
                qt.exports = function(Va2, Ca2, Go, un, Ei2, Wi2, La2) {
                  Gn(Go, Ca2, un);
                  var Aa2, Oi2, Zi2, Ka2 = function(ca2) {
                    if (!ei2 && ca2 in vl)
                      return vl[ca2];
                    switch (ca2) {
                      case "keys":
                      case "values":
                        return function() {
                          return new Go(this, ca2);
                        };
                    }
                    return function() {
                      return new Go(this, ca2);
                    };
                  }, Fo = Ca2 + " Iterator", Si2 = Ei2 == "values", bl = false, vl = Va2.prototype, xa2 = vl[Gr] || vl["@@iterator"] || Ei2 && vl[Ei2], gu = xa2 || Ka2(Ei2), Na2 = Ei2 ? Si2 ? Ka2("entries") : gu : void 0, ga = Ca2 == "Array" && vl.entries || xa2;
                  if (ga && (Zi2 = Wr(ga.call(new Va2()))) !== Object.prototype && Zi2.next && (Lr(Zi2, Fo, true), Ne2 || typeof Zi2[Gr] == "function" || pn(Zi2, Gr, oi2)), Si2 && xa2 && xa2.name !== "values" && (bl = true, gu = function() {
                    return xa2.call(this);
                  }), Ne2 && !La2 || !ei2 && !bl && vl[Gr] || pn(vl, Gr, gu), vn[Ca2] = gu, vn[Fo] = oi2, Ei2)
                    if (Aa2 = { values: Si2 ? gu : Ka2("values"), keys: Wi2 ? gu : Ka2("keys"), entries: Na2 }, La2)
                      for (Oi2 in Aa2)
                        Oi2 in vl || Ve(vl, Oi2, Aa2[Oi2]);
                    else
                      Ge2(Ge2.P + Ge2.F * (ei2 || bl), Ca2, Aa2);
                  return Aa2;
                };
              }, function(qt, Zt, oe2) {
                qt.exports = !oe2(4) && !oe2(8)(function() {
                  return Object.defineProperty(oe2(36)("div"), "a", { get: function() {
                    return 7;
                  } }).a != 7;
                });
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(11), Ge2 = oe2(3).document, Ve = Ne2(Ge2) && Ne2(Ge2.createElement);
                qt.exports = function(pn) {
                  return Ve ? Ge2.createElement(pn) : {};
                };
              }, function(qt, Zt, oe2) {
                qt.exports = oe2(6);
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(10), Ge2 = oe2(56), Ve = oe2(27), pn = oe2(25)("IE_PROTO"), vn = function() {
                }, Gn = function() {
                  var Lr, Wr = oe2(36)("iframe"), Gr = Ve.length;
                  for (Wr.style.display = "none", oe2(60).appendChild(Wr), Wr.src = "javascript:", (Lr = Wr.contentWindow.document).open(), Lr.write("<script>document.F=Object<\/script>"), Lr.close(), Gn = Lr.F; Gr--; )
                    delete Gn.prototype[Ve[Gr]];
                  return Gn();
                };
                qt.exports = Object.create || function(Lr, Wr) {
                  var Gr;
                  return Lr !== null ? (vn.prototype = Ne2(Lr), Gr = new vn(), vn.prototype = null, Gr[pn] = Lr) : Gr = Gn(), Wr === void 0 ? Gr : Ge2(Gr, Wr);
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(5), Ge2 = oe2(9), Ve = oe2(57)(false), pn = oe2(25)("IE_PROTO");
                qt.exports = function(vn, Gn) {
                  var Lr, Wr = Ge2(vn), Gr = 0, ei2 = [];
                  for (Lr in Wr)
                    Lr != pn && Ne2(Wr, Lr) && ei2.push(Lr);
                  for (; Gn.length > Gr; )
                    Ne2(Wr, Lr = Gn[Gr++]) && (~Ve(ei2, Lr) || ei2.push(Lr));
                  return ei2;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(24);
                qt.exports = Object("z").propertyIsEnumerable(0) ? Object : function(Ge2) {
                  return Ne2(Ge2) == "String" ? Ge2.split("") : Object(Ge2);
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(39), Ge2 = oe2(27).concat("length", "prototype");
                Zt.f = Object.getOwnPropertyNames || function(Ve) {
                  return Ne2(Ve, Ge2);
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(24), Ge2 = oe2(2)("toStringTag"), Ve = Ne2(function() {
                  return arguments;
                }()) == "Arguments";
                qt.exports = function(pn) {
                  var vn, Gn, Lr;
                  return pn === void 0 ? "Undefined" : pn === null ? "Null" : typeof (Gn = function(Wr, Gr) {
                    try {
                      return Wr[Gr];
                    } catch {
                    }
                  }(vn = Object(pn), Ge2)) == "string" ? Gn : Ve ? Ne2(vn) : (Lr = Ne2(vn)) == "Object" && typeof vn.callee == "function" ? "Arguments" : Lr;
                };
              }, function(qt, Zt) {
                var oe2;
                oe2 = function() {
                  return this;
                }();
                try {
                  oe2 = oe2 || new Function("return this")();
                } catch {
                  typeof window == "object" && (oe2 = window);
                }
                qt.exports = oe2;
              }, function(qt, Zt) {
                var oe2 = /-?\d+(\.\d+)?%?/g;
                qt.exports = function(Ne2) {
                  return Ne2.match(oe2);
                };
              }, function(qt, Zt, oe2) {
                Object.defineProperty(Zt, "__esModule", { value: true }), Zt.getBase16Theme = Zt.createStyling = Zt.invertTheme = void 0;
                var Ne2 = oi2(oe2(49)), Ge2 = oi2(oe2(76)), Ve = oi2(oe2(81)), pn = oi2(oe2(89)), vn = oi2(oe2(93)), Gn = function(Oi2) {
                  if (Oi2 && Oi2.__esModule)
                    return Oi2;
                  var Zi2 = {};
                  if (Oi2 != null)
                    for (var Ka2 in Oi2)
                      Object.prototype.hasOwnProperty.call(Oi2, Ka2) && (Zi2[Ka2] = Oi2[Ka2]);
                  return Zi2.default = Oi2, Zi2;
                }(oe2(94)), Lr = oi2(oe2(132)), Wr = oi2(oe2(133)), Gr = oi2(oe2(138)), ei2 = oe2(139);
                function oi2(Oi2) {
                  return Oi2 && Oi2.__esModule ? Oi2 : { default: Oi2 };
                }
                var Va2 = Gn.default, Ca2 = (0, pn.default)(Va2), Go = (0, Gr.default)(Wr.default, ei2.rgb2yuv, function(Oi2) {
                  var Zi2, Ka2 = (0, Ve.default)(Oi2, 3), Fo = Ka2[0], Si2 = Ka2[1], bl = Ka2[2];
                  return [(Zi2 = Fo, Zi2 < 0.25 ? 1 : Zi2 < 0.5 ? 0.9 - Zi2 : 1.1 - Zi2), Si2, bl];
                }, ei2.yuv2rgb, Lr.default), un = function(Oi2) {
                  return function(Zi2) {
                    return { className: [Zi2.className, Oi2.className].filter(Boolean).join(" "), style: (0, Ge2.default)({}, Zi2.style || {}, Oi2.style || {}) };
                  };
                }, Ei2 = function(Oi2, Zi2) {
                  var Ka2 = (0, pn.default)(Zi2);
                  for (var Fo in Oi2)
                    Ka2.indexOf(Fo) === -1 && Ka2.push(Fo);
                  return Ka2.reduce(function(Si2, bl) {
                    return Si2[bl] = function(vl, xa2) {
                      if (vl === void 0)
                        return xa2;
                      if (xa2 === void 0)
                        return vl;
                      var gu = vl === void 0 ? "undefined" : (0, Ne2.default)(vl), Na2 = xa2 === void 0 ? "undefined" : (0, Ne2.default)(xa2);
                      switch (gu) {
                        case "string":
                          switch (Na2) {
                            case "string":
                              return [xa2, vl].filter(Boolean).join(" ");
                            case "object":
                              return un({ className: vl, style: xa2 });
                            case "function":
                              return function(ga) {
                                for (var ca2 = arguments.length, fs = Array(ca2 > 1 ? ca2 - 1 : 0), qo = 1; qo < ca2; qo++)
                                  fs[qo - 1] = arguments[qo];
                                return un({ className: vl })(xa2.apply(void 0, [ga].concat(fs)));
                              };
                          }
                        case "object":
                          switch (Na2) {
                            case "string":
                              return un({ className: xa2, style: vl });
                            case "object":
                              return (0, Ge2.default)({}, xa2, vl);
                            case "function":
                              return function(ga) {
                                for (var ca2 = arguments.length, fs = Array(ca2 > 1 ? ca2 - 1 : 0), qo = 1; qo < ca2; qo++)
                                  fs[qo - 1] = arguments[qo];
                                return un({ style: vl })(xa2.apply(void 0, [ga].concat(fs)));
                              };
                          }
                        case "function":
                          switch (Na2) {
                            case "string":
                              return function(ga) {
                                for (var ca2 = arguments.length, fs = Array(ca2 > 1 ? ca2 - 1 : 0), qo = 1; qo < ca2; qo++)
                                  fs[qo - 1] = arguments[qo];
                                return vl.apply(void 0, [un(ga)({ className: xa2 })].concat(fs));
                              };
                            case "object":
                              return function(ga) {
                                for (var ca2 = arguments.length, fs = Array(ca2 > 1 ? ca2 - 1 : 0), qo = 1; qo < ca2; qo++)
                                  fs[qo - 1] = arguments[qo];
                                return vl.apply(void 0, [un(ga)({ style: xa2 })].concat(fs));
                              };
                            case "function":
                              return function(ga) {
                                for (var ca2 = arguments.length, fs = Array(ca2 > 1 ? ca2 - 1 : 0), qo = 1; qo < ca2; qo++)
                                  fs[qo - 1] = arguments[qo];
                                return vl.apply(void 0, [xa2.apply(void 0, [ga].concat(fs))].concat(fs));
                              };
                          }
                      }
                    }(Oi2[bl], Zi2[bl]), Si2;
                  }, {});
                }, Wi2 = function(Oi2, Zi2) {
                  for (var Ka2 = arguments.length, Fo = Array(Ka2 > 2 ? Ka2 - 2 : 0), Si2 = 2; Si2 < Ka2; Si2++)
                    Fo[Si2 - 2] = arguments[Si2];
                  if (Zi2 === null)
                    return Oi2;
                  Array.isArray(Zi2) || (Zi2 = [Zi2]);
                  var bl = Zi2.map(function(xa2) {
                    return Oi2[xa2];
                  }).filter(Boolean), vl = bl.reduce(function(xa2, gu) {
                    return typeof gu == "string" ? xa2.className = [xa2.className, gu].filter(Boolean).join(" ") : (gu === void 0 ? "undefined" : (0, Ne2.default)(gu)) === "object" ? xa2.style = (0, Ge2.default)({}, xa2.style, gu) : typeof gu == "function" && (xa2 = (0, Ge2.default)({}, xa2, gu.apply(void 0, [xa2].concat(Fo)))), xa2;
                  }, { className: "", style: {} });
                  return vl.className || delete vl.className, (0, pn.default)(vl.style).length === 0 && delete vl.style, vl;
                }, La2 = Zt.invertTheme = function(Oi2) {
                  return (0, pn.default)(Oi2).reduce(function(Zi2, Ka2) {
                    return Zi2[Ka2] = /^base/.test(Ka2) ? Go(Oi2[Ka2]) : Ka2 === "scheme" ? Oi2[Ka2] + ":inverted" : Oi2[Ka2], Zi2;
                  }, {});
                }, Aa2 = (Zt.createStyling = (0, vn.default)(function(Oi2) {
                  for (var Zi2 = arguments.length, Ka2 = Array(Zi2 > 3 ? Zi2 - 3 : 0), Fo = 3; Fo < Zi2; Fo++)
                    Ka2[Fo - 3] = arguments[Fo];
                  var Si2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, bl = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, vl = Si2.defaultBase16, xa2 = vl === void 0 ? Va2 : vl, gu = Si2.base16Themes, Na2 = gu === void 0 ? null : gu, ga = Aa2(bl, Na2);
                  ga && (bl = (0, Ge2.default)({}, ga, bl));
                  var ca2 = Ca2.reduce(function(vh2, Wf2) {
                    return vh2[Wf2] = bl[Wf2] || xa2[Wf2], vh2;
                  }, {}), fs = (0, pn.default)(bl).reduce(function(vh2, Wf2) {
                    return Ca2.indexOf(Wf2) === -1 && (vh2[Wf2] = bl[Wf2]), vh2;
                  }, {}), qo = Oi2(ca2), Hu = Ei2(fs, qo);
                  return (0, vn.default)(Wi2, 2).apply(void 0, [Hu].concat(Ka2));
                }, 3), Zt.getBase16Theme = function(Oi2, Zi2) {
                  if (Oi2 && Oi2.extend && (Oi2 = Oi2.extend), typeof Oi2 == "string") {
                    var Ka2 = Oi2.split(":"), Fo = (0, Ve.default)(Ka2, 2), Si2 = Fo[0], bl = Fo[1];
                    Oi2 = (Zi2 || {})[Si2] || Gn[Si2], bl === "inverted" && (Oi2 = La2(Oi2));
                  }
                  return Oi2 && Oi2.hasOwnProperty("base00") ? Oi2 : void 0;
                });
              }, function(qt, Zt, oe2) {
                var Ne2, Ge2 = typeof Reflect == "object" ? Reflect : null, Ve = Ge2 && typeof Ge2.apply == "function" ? Ge2.apply : function(un, Ei2, Wi2) {
                  return Function.prototype.apply.call(un, Ei2, Wi2);
                };
                Ne2 = Ge2 && typeof Ge2.ownKeys == "function" ? Ge2.ownKeys : Object.getOwnPropertySymbols ? function(un) {
                  return Object.getOwnPropertyNames(un).concat(Object.getOwnPropertySymbols(un));
                } : function(un) {
                  return Object.getOwnPropertyNames(un);
                };
                var pn = Number.isNaN || function(un) {
                  return un != un;
                };
                function vn() {
                  vn.init.call(this);
                }
                qt.exports = vn, qt.exports.once = function(un, Ei2) {
                  return new Promise(function(Wi2, La2) {
                    function Aa2() {
                      Oi2 !== void 0 && un.removeListener("error", Oi2), Wi2([].slice.call(arguments));
                    }
                    var Oi2;
                    Ei2 !== "error" && (Oi2 = function(Zi2) {
                      un.removeListener(Ei2, Aa2), La2(Zi2);
                    }, un.once("error", Oi2)), un.once(Ei2, Aa2);
                  });
                }, vn.EventEmitter = vn, vn.prototype._events = void 0, vn.prototype._eventsCount = 0, vn.prototype._maxListeners = void 0;
                var Gn = 10;
                function Lr(un) {
                  if (typeof un != "function")
                    throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof un);
                }
                function Wr(un) {
                  return un._maxListeners === void 0 ? vn.defaultMaxListeners : un._maxListeners;
                }
                function Gr(un, Ei2, Wi2, La2) {
                  var Aa2, Oi2, Zi2, Ka2;
                  if (Lr(Wi2), (Oi2 = un._events) === void 0 ? (Oi2 = un._events = /* @__PURE__ */ Object.create(null), un._eventsCount = 0) : (Oi2.newListener !== void 0 && (un.emit("newListener", Ei2, Wi2.listener ? Wi2.listener : Wi2), Oi2 = un._events), Zi2 = Oi2[Ei2]), Zi2 === void 0)
                    Zi2 = Oi2[Ei2] = Wi2, ++un._eventsCount;
                  else if (typeof Zi2 == "function" ? Zi2 = Oi2[Ei2] = La2 ? [Wi2, Zi2] : [Zi2, Wi2] : La2 ? Zi2.unshift(Wi2) : Zi2.push(Wi2), (Aa2 = Wr(un)) > 0 && Zi2.length > Aa2 && !Zi2.warned) {
                    Zi2.warned = true;
                    var Fo = new Error("Possible EventEmitter memory leak detected. " + Zi2.length + " " + String(Ei2) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                    Fo.name = "MaxListenersExceededWarning", Fo.emitter = un, Fo.type = Ei2, Fo.count = Zi2.length, Ka2 = Fo, console && console.warn && console.warn(Ka2);
                  }
                  return un;
                }
                function ei2() {
                  if (!this.fired)
                    return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
                }
                function oi2(un, Ei2, Wi2) {
                  var La2 = { fired: false, wrapFn: void 0, target: un, type: Ei2, listener: Wi2 }, Aa2 = ei2.bind(La2);
                  return Aa2.listener = Wi2, La2.wrapFn = Aa2, Aa2;
                }
                function Va2(un, Ei2, Wi2) {
                  var La2 = un._events;
                  if (La2 === void 0)
                    return [];
                  var Aa2 = La2[Ei2];
                  return Aa2 === void 0 ? [] : typeof Aa2 == "function" ? Wi2 ? [Aa2.listener || Aa2] : [Aa2] : Wi2 ? function(Oi2) {
                    for (var Zi2 = new Array(Oi2.length), Ka2 = 0; Ka2 < Zi2.length; ++Ka2)
                      Zi2[Ka2] = Oi2[Ka2].listener || Oi2[Ka2];
                    return Zi2;
                  }(Aa2) : Go(Aa2, Aa2.length);
                }
                function Ca2(un) {
                  var Ei2 = this._events;
                  if (Ei2 !== void 0) {
                    var Wi2 = Ei2[un];
                    if (typeof Wi2 == "function")
                      return 1;
                    if (Wi2 !== void 0)
                      return Wi2.length;
                  }
                  return 0;
                }
                function Go(un, Ei2) {
                  for (var Wi2 = new Array(Ei2), La2 = 0; La2 < Ei2; ++La2)
                    Wi2[La2] = un[La2];
                  return Wi2;
                }
                Object.defineProperty(vn, "defaultMaxListeners", { enumerable: true, get: function() {
                  return Gn;
                }, set: function(un) {
                  if (typeof un != "number" || un < 0 || pn(un))
                    throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + un + ".");
                  Gn = un;
                } }), vn.init = function() {
                  this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
                }, vn.prototype.setMaxListeners = function(un) {
                  if (typeof un != "number" || un < 0 || pn(un))
                    throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + un + ".");
                  return this._maxListeners = un, this;
                }, vn.prototype.getMaxListeners = function() {
                  return Wr(this);
                }, vn.prototype.emit = function(un) {
                  for (var Ei2 = [], Wi2 = 1; Wi2 < arguments.length; Wi2++)
                    Ei2.push(arguments[Wi2]);
                  var La2 = un === "error", Aa2 = this._events;
                  if (Aa2 !== void 0)
                    La2 = La2 && Aa2.error === void 0;
                  else if (!La2)
                    return false;
                  if (La2) {
                    var Oi2;
                    if (Ei2.length > 0 && (Oi2 = Ei2[0]), Oi2 instanceof Error)
                      throw Oi2;
                    var Zi2 = new Error("Unhandled error." + (Oi2 ? " (" + Oi2.message + ")" : ""));
                    throw Zi2.context = Oi2, Zi2;
                  }
                  var Ka2 = Aa2[un];
                  if (Ka2 === void 0)
                    return false;
                  if (typeof Ka2 == "function")
                    Ve(Ka2, this, Ei2);
                  else {
                    var Fo = Ka2.length, Si2 = Go(Ka2, Fo);
                    for (Wi2 = 0; Wi2 < Fo; ++Wi2)
                      Ve(Si2[Wi2], this, Ei2);
                  }
                  return true;
                }, vn.prototype.addListener = function(un, Ei2) {
                  return Gr(this, un, Ei2, false);
                }, vn.prototype.on = vn.prototype.addListener, vn.prototype.prependListener = function(un, Ei2) {
                  return Gr(this, un, Ei2, true);
                }, vn.prototype.once = function(un, Ei2) {
                  return Lr(Ei2), this.on(un, oi2(this, un, Ei2)), this;
                }, vn.prototype.prependOnceListener = function(un, Ei2) {
                  return Lr(Ei2), this.prependListener(un, oi2(this, un, Ei2)), this;
                }, vn.prototype.removeListener = function(un, Ei2) {
                  var Wi2, La2, Aa2, Oi2, Zi2;
                  if (Lr(Ei2), (La2 = this._events) === void 0)
                    return this;
                  if ((Wi2 = La2[un]) === void 0)
                    return this;
                  if (Wi2 === Ei2 || Wi2.listener === Ei2)
                    --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete La2[un], La2.removeListener && this.emit("removeListener", un, Wi2.listener || Ei2));
                  else if (typeof Wi2 != "function") {
                    for (Aa2 = -1, Oi2 = Wi2.length - 1; Oi2 >= 0; Oi2--)
                      if (Wi2[Oi2] === Ei2 || Wi2[Oi2].listener === Ei2) {
                        Zi2 = Wi2[Oi2].listener, Aa2 = Oi2;
                        break;
                      }
                    if (Aa2 < 0)
                      return this;
                    Aa2 === 0 ? Wi2.shift() : function(Ka2, Fo) {
                      for (; Fo + 1 < Ka2.length; Fo++)
                        Ka2[Fo] = Ka2[Fo + 1];
                      Ka2.pop();
                    }(Wi2, Aa2), Wi2.length === 1 && (La2[un] = Wi2[0]), La2.removeListener !== void 0 && this.emit("removeListener", un, Zi2 || Ei2);
                  }
                  return this;
                }, vn.prototype.off = vn.prototype.removeListener, vn.prototype.removeAllListeners = function(un) {
                  var Ei2, Wi2, La2;
                  if ((Wi2 = this._events) === void 0)
                    return this;
                  if (Wi2.removeListener === void 0)
                    return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Wi2[un] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Wi2[un]), this;
                  if (arguments.length === 0) {
                    var Aa2, Oi2 = Object.keys(Wi2);
                    for (La2 = 0; La2 < Oi2.length; ++La2)
                      (Aa2 = Oi2[La2]) !== "removeListener" && this.removeAllListeners(Aa2);
                    return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
                  }
                  if (typeof (Ei2 = Wi2[un]) == "function")
                    this.removeListener(un, Ei2);
                  else if (Ei2 !== void 0)
                    for (La2 = Ei2.length - 1; La2 >= 0; La2--)
                      this.removeListener(un, Ei2[La2]);
                  return this;
                }, vn.prototype.listeners = function(un) {
                  return Va2(this, un, true);
                }, vn.prototype.rawListeners = function(un) {
                  return Va2(this, un, false);
                }, vn.listenerCount = function(un, Ei2) {
                  return typeof un.listenerCount == "function" ? un.listenerCount(Ei2) : Ca2.call(un, Ei2);
                }, vn.prototype.listenerCount = Ca2, vn.prototype.eventNames = function() {
                  return this._eventsCount > 0 ? Ne2(this._events) : [];
                };
              }, function(qt, Zt, oe2) {
                qt.exports.Dispatcher = oe2(140);
              }, function(qt, Zt, oe2) {
                qt.exports = oe2(142);
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true;
                var Ne2 = pn(oe2(50)), Ge2 = pn(oe2(65)), Ve = typeof Ge2.default == "function" && typeof Ne2.default == "symbol" ? function(vn) {
                  return typeof vn;
                } : function(vn) {
                  return vn && typeof Ge2.default == "function" && vn.constructor === Ge2.default && vn !== Ge2.default.prototype ? "symbol" : typeof vn;
                };
                function pn(vn) {
                  return vn && vn.__esModule ? vn : { default: vn };
                }
                Zt.default = typeof Ge2.default == "function" && Ve(Ne2.default) === "symbol" ? function(vn) {
                  return vn === void 0 ? "undefined" : Ve(vn);
                } : function(vn) {
                  return vn && typeof Ge2.default == "function" && vn.constructor === Ge2.default && vn !== Ge2.default.prototype ? "symbol" : vn === void 0 ? "undefined" : Ve(vn);
                };
              }, function(qt, Zt, oe2) {
                qt.exports = { default: oe2(51), __esModule: true };
              }, function(qt, Zt, oe2) {
                oe2(20), oe2(29), qt.exports = oe2(30).f("iterator");
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(21), Ge2 = oe2(22);
                qt.exports = function(Ve) {
                  return function(pn, vn) {
                    var Gn, Lr, Wr = String(Ge2(pn)), Gr = Ne2(vn), ei2 = Wr.length;
                    return Gr < 0 || Gr >= ei2 ? Ve ? "" : void 0 : (Gn = Wr.charCodeAt(Gr)) < 55296 || Gn > 56319 || Gr + 1 === ei2 || (Lr = Wr.charCodeAt(Gr + 1)) < 56320 || Lr > 57343 ? Ve ? Wr.charAt(Gr) : Gn : Ve ? Wr.slice(Gr, Gr + 2) : Lr - 56320 + (Gn - 55296 << 10) + 65536;
                  };
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(54);
                qt.exports = function(Ge2, Ve, pn) {
                  if (Ne2(Ge2), Ve === void 0)
                    return Ge2;
                  switch (pn) {
                    case 1:
                      return function(vn) {
                        return Ge2.call(Ve, vn);
                      };
                    case 2:
                      return function(vn, Gn) {
                        return Ge2.call(Ve, vn, Gn);
                      };
                    case 3:
                      return function(vn, Gn, Lr) {
                        return Ge2.call(Ve, vn, Gn, Lr);
                      };
                  }
                  return function() {
                    return Ge2.apply(Ve, arguments);
                  };
                };
              }, function(qt, Zt) {
                qt.exports = function(oe2) {
                  if (typeof oe2 != "function")
                    throw TypeError(oe2 + " is not a function!");
                  return oe2;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(38), Ge2 = oe2(16), Ve = oe2(28), pn = {};
                oe2(6)(pn, oe2(2)("iterator"), function() {
                  return this;
                }), qt.exports = function(vn, Gn, Lr) {
                  vn.prototype = Ne2(pn, { next: Ge2(1, Lr) }), Ve(vn, Gn + " Iterator");
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(7), Ge2 = oe2(10), Ve = oe2(13);
                qt.exports = oe2(4) ? Object.defineProperties : function(pn, vn) {
                  Ge2(pn);
                  for (var Gn, Lr = Ve(vn), Wr = Lr.length, Gr = 0; Wr > Gr; )
                    Ne2.f(pn, Gn = Lr[Gr++], vn[Gn]);
                  return pn;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(9), Ge2 = oe2(58), Ve = oe2(59);
                qt.exports = function(pn) {
                  return function(vn, Gn, Lr) {
                    var Wr, Gr = Ne2(vn), ei2 = Ge2(Gr.length), oi2 = Ve(Lr, ei2);
                    if (pn && Gn != Gn) {
                      for (; ei2 > oi2; )
                        if ((Wr = Gr[oi2++]) != Wr)
                          return true;
                    } else
                      for (; ei2 > oi2; oi2++)
                        if ((pn || oi2 in Gr) && Gr[oi2] === Gn)
                          return pn || oi2 || 0;
                    return !pn && -1;
                  };
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(21), Ge2 = Math.min;
                qt.exports = function(Ve) {
                  return Ve > 0 ? Ge2(Ne2(Ve), 9007199254740991) : 0;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(21), Ge2 = Math.max, Ve = Math.min;
                qt.exports = function(pn, vn) {
                  return (pn = Ne2(pn)) < 0 ? Ge2(pn + vn, 0) : Ve(pn, vn);
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(3).document;
                qt.exports = Ne2 && Ne2.documentElement;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(5), Ge2 = oe2(18), Ve = oe2(25)("IE_PROTO"), pn = Object.prototype;
                qt.exports = Object.getPrototypeOf || function(vn) {
                  return vn = Ge2(vn), Ne2(vn, Ve) ? vn[Ve] : typeof vn.constructor == "function" && vn instanceof vn.constructor ? vn.constructor.prototype : vn instanceof Object ? pn : null;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(63), Ge2 = oe2(64), Ve = oe2(12), pn = oe2(9);
                qt.exports = oe2(34)(Array, "Array", function(vn, Gn) {
                  this._t = pn(vn), this._i = 0, this._k = Gn;
                }, function() {
                  var vn = this._t, Gn = this._k, Lr = this._i++;
                  return !vn || Lr >= vn.length ? (this._t = void 0, Ge2(1)) : Ge2(0, Gn == "keys" ? Lr : Gn == "values" ? vn[Lr] : [Lr, vn[Lr]]);
                }, "values"), Ve.Arguments = Ve.Array, Ne2("keys"), Ne2("values"), Ne2("entries");
              }, function(qt, Zt) {
                qt.exports = function() {
                };
              }, function(qt, Zt) {
                qt.exports = function(oe2, Ne2) {
                  return { value: Ne2, done: !!oe2 };
                };
              }, function(qt, Zt, oe2) {
                qt.exports = { default: oe2(66), __esModule: true };
              }, function(qt, Zt, oe2) {
                oe2(67), oe2(73), oe2(74), oe2(75), qt.exports = oe2(1).Symbol;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(3), Ge2 = oe2(5), Ve = oe2(4), pn = oe2(15), vn = oe2(37), Gn = oe2(68).KEY, Lr = oe2(8), Wr = oe2(26), Gr = oe2(28), ei2 = oe2(17), oi2 = oe2(2), Va2 = oe2(30), Ca2 = oe2(31), Go = oe2(69), un = oe2(70), Ei2 = oe2(10), Wi2 = oe2(11), La2 = oe2(18), Aa2 = oe2(9), Oi2 = oe2(23), Zi2 = oe2(16), Ka2 = oe2(38), Fo = oe2(71), Si2 = oe2(72), bl = oe2(32), vl = oe2(7), xa2 = oe2(13), gu = Si2.f, Na2 = vl.f, ga = Fo.f, ca2 = Ne2.Symbol, fs = Ne2.JSON, qo = fs && fs.stringify, Hu = oi2("_hidden"), vh2 = oi2("toPrimitive"), Wf2 = {}.propertyIsEnumerable, mc2 = Wr("symbol-registry"), yd2 = Wr("symbols"), Gf2 = Wr("op-symbols"), hp = Object.prototype, Lg2 = typeof ca2 == "function" && !!bl.f, n_ = Ne2.QObject, Dx = !n_ || !n_.prototype || !n_.prototype.findChild, Iv = Ve && Lr(function() {
                  return Ka2(Na2({}, "a", { get: function() {
                    return Na2(this, "a", { value: 7 }).a;
                  } })).a != 7;
                }) ? function(Xi2, co, Es) {
                  var Zl = gu(hp, co);
                  Zl && delete hp[co], Na2(Xi2, co, Es), Zl && Xi2 !== hp && Na2(hp, co, Zl);
                } : Na2, Gv = function(Xi2) {
                  var co = yd2[Xi2] = Ka2(ca2.prototype);
                  return co._k = Xi2, co;
                }, Jm = Lg2 && typeof ca2.iterator == "symbol" ? function(Xi2) {
                  return typeof Xi2 == "symbol";
                } : function(Xi2) {
                  return Xi2 instanceof ca2;
                }, Ex = function(Xi2, co, Es) {
                  return Xi2 === hp && Ex(Gf2, co, Es), Ei2(Xi2), co = Oi2(co, true), Ei2(Es), Ge2(yd2, co) ? (Es.enumerable ? (Ge2(Xi2, Hu) && Xi2[Hu][co] && (Xi2[Hu][co] = false), Es = Ka2(Es, { enumerable: Zi2(0, false) })) : (Ge2(Xi2, Hu) || Na2(Xi2, Hu, Zi2(1, {})), Xi2[Hu][co] = true), Iv(Xi2, co, Es)) : Na2(Xi2, co, Es);
                }, ry = function(Xi2, co) {
                  Ei2(Xi2);
                  for (var Es, Zl = Go(co = Aa2(co)), Yc2 = 0, Kc2 = Zl.length; Kc2 > Yc2; )
                    Ex(Xi2, Es = Zl[Yc2++], co[Es]);
                  return Xi2;
                }, r_ = function(Xi2) {
                  var co = Wf2.call(this, Xi2 = Oi2(Xi2, true));
                  return !(this === hp && Ge2(yd2, Xi2) && !Ge2(Gf2, Xi2)) && (!(co || !Ge2(this, Xi2) || !Ge2(yd2, Xi2) || Ge2(this, Hu) && this[Hu][Xi2]) || co);
                }, vu = function(Xi2, co) {
                  if (Xi2 = Aa2(Xi2), co = Oi2(co, true), Xi2 !== hp || !Ge2(yd2, co) || Ge2(Gf2, co)) {
                    var Es = gu(Xi2, co);
                    return !Es || !Ge2(yd2, co) || Ge2(Xi2, Hu) && Xi2[Hu][co] || (Es.enumerable = true), Es;
                  }
                }, t1 = function(Xi2) {
                  for (var co, Es = ga(Aa2(Xi2)), Zl = [], Yc2 = 0; Es.length > Yc2; )
                    Ge2(yd2, co = Es[Yc2++]) || co == Hu || co == Gn || Zl.push(co);
                  return Zl;
                }, Dv = function(Xi2) {
                  for (var co, Es = Xi2 === hp, Zl = ga(Es ? Gf2 : Aa2(Xi2)), Yc2 = [], Kc2 = 0; Zl.length > Kc2; )
                    !Ge2(yd2, co = Zl[Kc2++]) || Es && !Ge2(hp, co) || Yc2.push(yd2[co]);
                  return Yc2;
                };
                Lg2 || (vn((ca2 = function() {
                  if (this instanceof ca2)
                    throw TypeError("Symbol is not a constructor!");
                  var Xi2 = ei2(arguments.length > 0 ? arguments[0] : void 0), co = function(Es) {
                    this === hp && co.call(Gf2, Es), Ge2(this, Hu) && Ge2(this[Hu], Xi2) && (this[Hu][Xi2] = false), Iv(this, Xi2, Zi2(1, Es));
                  };
                  return Ve && Dx && Iv(hp, Xi2, { configurable: true, set: co }), Gv(Xi2);
                }).prototype, "toString", function() {
                  return this._k;
                }), Si2.f = vu, vl.f = Ex, oe2(41).f = Fo.f = t1, oe2(19).f = r_, bl.f = Dv, Ve && !oe2(14) && vn(hp, "propertyIsEnumerable", r_, true), Va2.f = function(Xi2) {
                  return Gv(oi2(Xi2));
                }), pn(pn.G + pn.W + pn.F * !Lg2, { Symbol: ca2 });
                for (var nv = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Hv = 0; nv.length > Hv; )
                  oi2(nv[Hv++]);
                for (var eS = xa2(oi2.store), so = 0; eS.length > so; )
                  Ca2(eS[so++]);
                pn(pn.S + pn.F * !Lg2, "Symbol", { for: function(Xi2) {
                  return Ge2(mc2, Xi2 += "") ? mc2[Xi2] : mc2[Xi2] = ca2(Xi2);
                }, keyFor: function(Xi2) {
                  if (!Jm(Xi2))
                    throw TypeError(Xi2 + " is not a symbol!");
                  for (var co in mc2)
                    if (mc2[co] === Xi2)
                      return co;
                }, useSetter: function() {
                  Dx = true;
                }, useSimple: function() {
                  Dx = false;
                } }), pn(pn.S + pn.F * !Lg2, "Object", { create: function(Xi2, co) {
                  return co === void 0 ? Ka2(Xi2) : ry(Ka2(Xi2), co);
                }, defineProperty: Ex, defineProperties: ry, getOwnPropertyDescriptor: vu, getOwnPropertyNames: t1, getOwnPropertySymbols: Dv });
                var Bi2 = Lr(function() {
                  bl.f(1);
                });
                pn(pn.S + pn.F * Bi2, "Object", { getOwnPropertySymbols: function(Xi2) {
                  return bl.f(La2(Xi2));
                } }), fs && pn(pn.S + pn.F * (!Lg2 || Lr(function() {
                  var Xi2 = ca2();
                  return qo([Xi2]) != "[null]" || qo({ a: Xi2 }) != "{}" || qo(Object(Xi2)) != "{}";
                })), "JSON", { stringify: function(Xi2) {
                  for (var co, Es, Zl = [Xi2], Yc2 = 1; arguments.length > Yc2; )
                    Zl.push(arguments[Yc2++]);
                  if (Es = co = Zl[1], (Wi2(co) || Xi2 !== void 0) && !Jm(Xi2))
                    return un(co) || (co = function(Kc2, Dp) {
                      if (typeof Es == "function" && (Dp = Es.call(this, Kc2, Dp)), !Jm(Dp))
                        return Dp;
                    }), Zl[1] = co, qo.apply(fs, Zl);
                } }), ca2.prototype[vh2] || oe2(6)(ca2.prototype, vh2, ca2.prototype.valueOf), Gr(ca2, "Symbol"), Gr(Math, "Math", true), Gr(Ne2.JSON, "JSON", true);
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(17)("meta"), Ge2 = oe2(11), Ve = oe2(5), pn = oe2(7).f, vn = 0, Gn = Object.isExtensible || function() {
                  return true;
                }, Lr = !oe2(8)(function() {
                  return Gn(Object.preventExtensions({}));
                }), Wr = function(ei2) {
                  pn(ei2, Ne2, { value: { i: "O" + ++vn, w: {} } });
                }, Gr = qt.exports = { KEY: Ne2, NEED: false, fastKey: function(ei2, oi2) {
                  if (!Ge2(ei2))
                    return typeof ei2 == "symbol" ? ei2 : (typeof ei2 == "string" ? "S" : "P") + ei2;
                  if (!Ve(ei2, Ne2)) {
                    if (!Gn(ei2))
                      return "F";
                    if (!oi2)
                      return "E";
                    Wr(ei2);
                  }
                  return ei2[Ne2].i;
                }, getWeak: function(ei2, oi2) {
                  if (!Ve(ei2, Ne2)) {
                    if (!Gn(ei2))
                      return true;
                    if (!oi2)
                      return false;
                    Wr(ei2);
                  }
                  return ei2[Ne2].w;
                }, onFreeze: function(ei2) {
                  return Lr && Gr.NEED && Gn(ei2) && !Ve(ei2, Ne2) && Wr(ei2), ei2;
                } };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(13), Ge2 = oe2(32), Ve = oe2(19);
                qt.exports = function(pn) {
                  var vn = Ne2(pn), Gn = Ge2.f;
                  if (Gn)
                    for (var Lr, Wr = Gn(pn), Gr = Ve.f, ei2 = 0; Wr.length > ei2; )
                      Gr.call(pn, Lr = Wr[ei2++]) && vn.push(Lr);
                  return vn;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(24);
                qt.exports = Array.isArray || function(Ge2) {
                  return Ne2(Ge2) == "Array";
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(9), Ge2 = oe2(41).f, Ve = {}.toString, pn = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
                qt.exports.f = function(vn) {
                  return pn && Ve.call(vn) == "[object Window]" ? function(Gn) {
                    try {
                      return Ge2(Gn);
                    } catch {
                      return pn.slice();
                    }
                  }(vn) : Ge2(Ne2(vn));
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(19), Ge2 = oe2(16), Ve = oe2(9), pn = oe2(23), vn = oe2(5), Gn = oe2(35), Lr = Object.getOwnPropertyDescriptor;
                Zt.f = oe2(4) ? Lr : function(Wr, Gr) {
                  if (Wr = Ve(Wr), Gr = pn(Gr, true), Gn)
                    try {
                      return Lr(Wr, Gr);
                    } catch {
                    }
                  if (vn(Wr, Gr))
                    return Ge2(!Ne2.f.call(Wr, Gr), Wr[Gr]);
                };
              }, function(qt, Zt) {
              }, function(qt, Zt, oe2) {
                oe2(31)("asyncIterator");
              }, function(qt, Zt, oe2) {
                oe2(31)("observable");
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true;
                var Ne2, Ge2 = oe2(77), Ve = (Ne2 = Ge2) && Ne2.__esModule ? Ne2 : { default: Ne2 };
                Zt.default = Ve.default || function(pn) {
                  for (var vn = 1; vn < arguments.length; vn++) {
                    var Gn = arguments[vn];
                    for (var Lr in Gn)
                      Object.prototype.hasOwnProperty.call(Gn, Lr) && (pn[Lr] = Gn[Lr]);
                  }
                  return pn;
                };
              }, function(qt, Zt, oe2) {
                qt.exports = { default: oe2(78), __esModule: true };
              }, function(qt, Zt, oe2) {
                oe2(79), qt.exports = oe2(1).Object.assign;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(15);
                Ne2(Ne2.S + Ne2.F, "Object", { assign: oe2(80) });
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(4), Ge2 = oe2(13), Ve = oe2(32), pn = oe2(19), vn = oe2(18), Gn = oe2(40), Lr = Object.assign;
                qt.exports = !Lr || oe2(8)(function() {
                  var Wr = {}, Gr = {}, ei2 = Symbol(), oi2 = "abcdefghijklmnopqrst";
                  return Wr[ei2] = 7, oi2.split("").forEach(function(Va2) {
                    Gr[Va2] = Va2;
                  }), Lr({}, Wr)[ei2] != 7 || Object.keys(Lr({}, Gr)).join("") != oi2;
                }) ? function(Wr, Gr) {
                  for (var ei2 = vn(Wr), oi2 = arguments.length, Va2 = 1, Ca2 = Ve.f, Go = pn.f; oi2 > Va2; )
                    for (var un, Ei2 = Gn(arguments[Va2++]), Wi2 = Ca2 ? Ge2(Ei2).concat(Ca2(Ei2)) : Ge2(Ei2), La2 = Wi2.length, Aa2 = 0; La2 > Aa2; )
                      un = Wi2[Aa2++], Ne2 && !Go.call(Ei2, un) || (ei2[un] = Ei2[un]);
                  return ei2;
                } : Lr;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true;
                var Ne2 = Ve(oe2(82)), Ge2 = Ve(oe2(85));
                function Ve(pn) {
                  return pn && pn.__esModule ? pn : { default: pn };
                }
                Zt.default = function(pn, vn) {
                  if (Array.isArray(pn))
                    return pn;
                  if ((0, Ne2.default)(Object(pn)))
                    return function(Gn, Lr) {
                      var Wr = [], Gr = true, ei2 = false, oi2 = void 0;
                      try {
                        for (var Va2, Ca2 = (0, Ge2.default)(Gn); !(Gr = (Va2 = Ca2.next()).done) && (Wr.push(Va2.value), !Lr || Wr.length !== Lr); Gr = true)
                          ;
                      } catch (Go) {
                        ei2 = true, oi2 = Go;
                      } finally {
                        try {
                          !Gr && Ca2.return && Ca2.return();
                        } finally {
                          if (ei2)
                            throw oi2;
                        }
                      }
                      return Wr;
                    }(pn, vn);
                  throw new TypeError("Invalid attempt to destructure non-iterable instance");
                };
              }, function(qt, Zt, oe2) {
                qt.exports = { default: oe2(83), __esModule: true };
              }, function(qt, Zt, oe2) {
                oe2(29), oe2(20), qt.exports = oe2(84);
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(42), Ge2 = oe2(2)("iterator"), Ve = oe2(12);
                qt.exports = oe2(1).isIterable = function(pn) {
                  var vn = Object(pn);
                  return vn[Ge2] !== void 0 || "@@iterator" in vn || Ve.hasOwnProperty(Ne2(vn));
                };
              }, function(qt, Zt, oe2) {
                qt.exports = { default: oe2(86), __esModule: true };
              }, function(qt, Zt, oe2) {
                oe2(29), oe2(20), qt.exports = oe2(87);
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(10), Ge2 = oe2(88);
                qt.exports = oe2(1).getIterator = function(Ve) {
                  var pn = Ge2(Ve);
                  if (typeof pn != "function")
                    throw TypeError(Ve + " is not iterable!");
                  return Ne2(pn.call(Ve));
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(42), Ge2 = oe2(2)("iterator"), Ve = oe2(12);
                qt.exports = oe2(1).getIteratorMethod = function(pn) {
                  if (pn != null)
                    return pn[Ge2] || pn["@@iterator"] || Ve[Ne2(pn)];
                };
              }, function(qt, Zt, oe2) {
                qt.exports = { default: oe2(90), __esModule: true };
              }, function(qt, Zt, oe2) {
                oe2(91), qt.exports = oe2(1).Object.keys;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(18), Ge2 = oe2(13);
                oe2(92)("keys", function() {
                  return function(Ve) {
                    return Ge2(Ne2(Ve));
                  };
                });
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(15), Ge2 = oe2(1), Ve = oe2(8);
                qt.exports = function(pn, vn) {
                  var Gn = (Ge2.Object || {})[pn] || Object[pn], Lr = {};
                  Lr[pn] = vn(Gn), Ne2(Ne2.S + Ne2.F * Ve(function() {
                    Gn(1);
                  }), "Object", Lr);
                };
              }, function(qt, Zt, oe2) {
                (function(Ne2) {
                  var Ge2 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], Ve = /^\s+|\s+$/g, pn = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, vn = /\{\n\/\* \[wrapped with (.+)\] \*/, Gn = /,? & /, Lr = /^[-+]0x[0-9a-f]+$/i, Wr = /^0b[01]+$/i, Gr = /^\[object .+?Constructor\]$/, ei2 = /^0o[0-7]+$/i, oi2 = /^(?:0|[1-9]\d*)$/, Va2 = parseInt, Ca2 = typeof Ne2 == "object" && Ne2 && Ne2.Object === Object && Ne2, Go = typeof self == "object" && self && self.Object === Object && self, un = Ca2 || Go || Function("return this")();
                  function Ei2(so, Bi2, Xi2) {
                    switch (Xi2.length) {
                      case 0:
                        return so.call(Bi2);
                      case 1:
                        return so.call(Bi2, Xi2[0]);
                      case 2:
                        return so.call(Bi2, Xi2[0], Xi2[1]);
                      case 3:
                        return so.call(Bi2, Xi2[0], Xi2[1], Xi2[2]);
                    }
                    return so.apply(Bi2, Xi2);
                  }
                  function Wi2(so, Bi2) {
                    return !!(so && so.length) && function(Xi2, co, Es) {
                      if (co != co)
                        return function(Kc2, Dp, Og2, tp) {
                          for (var Fh2 = Kc2.length, md2 = Og2 + (tp ? 1 : -1); tp ? md2-- : ++md2 < Fh2; )
                            if (Dp(Kc2[md2], md2, Kc2))
                              return md2;
                          return -1;
                        }(Xi2, La2, Es);
                      for (var Zl = Es - 1, Yc2 = Xi2.length; ++Zl < Yc2; )
                        if (Xi2[Zl] === co)
                          return Zl;
                      return -1;
                    }(so, Bi2, 0) > -1;
                  }
                  function La2(so) {
                    return so != so;
                  }
                  function Aa2(so, Bi2) {
                    for (var Xi2 = so.length, co = 0; Xi2--; )
                      so[Xi2] === Bi2 && co++;
                    return co;
                  }
                  function Oi2(so, Bi2) {
                    for (var Xi2 = -1, co = so.length, Es = 0, Zl = []; ++Xi2 < co; ) {
                      var Yc2 = so[Xi2];
                      Yc2 !== Bi2 && Yc2 !== "__lodash_placeholder__" || (so[Xi2] = "__lodash_placeholder__", Zl[Es++] = Xi2);
                    }
                    return Zl;
                  }
                  var Zi2, Ka2, Fo, Si2 = Function.prototype, bl = Object.prototype, vl = un["__core-js_shared__"], xa2 = (Zi2 = /[^.]+$/.exec(vl && vl.keys && vl.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Zi2 : "", gu = Si2.toString, Na2 = bl.hasOwnProperty, ga = bl.toString, ca2 = RegExp("^" + gu.call(Na2).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), fs = Object.create, qo = Math.max, Hu = Math.min, vh2 = (Ka2 = Gv(Object, "defineProperty"), (Fo = Gv.name) && Fo.length > 2 ? Ka2 : void 0);
                  function Wf2(so) {
                    return nv(so) ? fs(so) : {};
                  }
                  function mc2(so) {
                    return !(!nv(so) || function(Bi2) {
                      return !!xa2 && xa2 in Bi2;
                    }(so)) && (function(Bi2) {
                      var Xi2 = nv(Bi2) ? ga.call(Bi2) : "";
                      return Xi2 == "[object Function]" || Xi2 == "[object GeneratorFunction]";
                    }(so) || function(Bi2) {
                      var Xi2 = false;
                      if (Bi2 != null && typeof Bi2.toString != "function")
                        try {
                          Xi2 = !!(Bi2 + "");
                        } catch {
                        }
                      return Xi2;
                    }(so) ? ca2 : Gr).test(function(Bi2) {
                      if (Bi2 != null) {
                        try {
                          return gu.call(Bi2);
                        } catch {
                        }
                        try {
                          return Bi2 + "";
                        } catch {
                        }
                      }
                      return "";
                    }(so));
                  }
                  function yd2(so, Bi2, Xi2, co) {
                    for (var Es = -1, Zl = so.length, Yc2 = Xi2.length, Kc2 = -1, Dp = Bi2.length, Og2 = qo(Zl - Yc2, 0), tp = Array(Dp + Og2), Fh2 = !co; ++Kc2 < Dp; )
                      tp[Kc2] = Bi2[Kc2];
                    for (; ++Es < Yc2; )
                      (Fh2 || Es < Zl) && (tp[Xi2[Es]] = so[Es]);
                    for (; Og2--; )
                      tp[Kc2++] = so[Es++];
                    return tp;
                  }
                  function Gf2(so, Bi2, Xi2, co) {
                    for (var Es = -1, Zl = so.length, Yc2 = -1, Kc2 = Xi2.length, Dp = -1, Og2 = Bi2.length, tp = qo(Zl - Kc2, 0), Fh2 = Array(tp + Og2), md2 = !co; ++Es < tp; )
                      Fh2[Es] = so[Es];
                    for (var cm = Es; ++Dp < Og2; )
                      Fh2[cm + Dp] = Bi2[Dp];
                    for (; ++Yc2 < Kc2; )
                      (md2 || Es < Zl) && (Fh2[cm + Xi2[Yc2]] = so[Es++]);
                    return Fh2;
                  }
                  function hp(so) {
                    return function() {
                      var Bi2 = arguments;
                      switch (Bi2.length) {
                        case 0:
                          return new so();
                        case 1:
                          return new so(Bi2[0]);
                        case 2:
                          return new so(Bi2[0], Bi2[1]);
                        case 3:
                          return new so(Bi2[0], Bi2[1], Bi2[2]);
                        case 4:
                          return new so(Bi2[0], Bi2[1], Bi2[2], Bi2[3]);
                        case 5:
                          return new so(Bi2[0], Bi2[1], Bi2[2], Bi2[3], Bi2[4]);
                        case 6:
                          return new so(Bi2[0], Bi2[1], Bi2[2], Bi2[3], Bi2[4], Bi2[5]);
                        case 7:
                          return new so(Bi2[0], Bi2[1], Bi2[2], Bi2[3], Bi2[4], Bi2[5], Bi2[6]);
                      }
                      var Xi2 = Wf2(so.prototype), co = so.apply(Xi2, Bi2);
                      return nv(co) ? co : Xi2;
                    };
                  }
                  function Lg2(so, Bi2, Xi2, co, Es, Zl, Yc2, Kc2, Dp, Og2) {
                    var tp = 128 & Bi2, Fh2 = 1 & Bi2, md2 = 2 & Bi2, cm = 24 & Bi2, fm = 512 & Bi2, nS = md2 ? void 0 : hp(so);
                    return function K1() {
                      for (var tg2 = arguments.length, Jf2 = Array(tg2), O0 = tg2; O0--; )
                        Jf2[O0] = arguments[O0];
                      if (cm)
                        var hm = Iv(K1), i_ = Aa2(Jf2, hm);
                      if (co && (Jf2 = yd2(Jf2, co, Es, cm)), Zl && (Jf2 = Gf2(Jf2, Zl, Yc2, cm)), tg2 -= i_, cm && tg2 < Og2) {
                        var X1 = Oi2(Jf2, hm);
                        return n_(so, Bi2, Lg2, K1.placeholder, Xi2, Jf2, X1, Kc2, Dp, Og2 - tg2);
                      }
                      var Q1 = Fh2 ? Xi2 : this, a_ = md2 ? Q1[so] : so;
                      return tg2 = Jf2.length, Kc2 ? Jf2 = r_(Jf2, Kc2) : fm && tg2 > 1 && Jf2.reverse(), tp && Dp < tg2 && (Jf2.length = Dp), this && this !== un && this instanceof K1 && (a_ = nS || hp(a_)), a_.apply(Q1, Jf2);
                    };
                  }
                  function n_(so, Bi2, Xi2, co, Es, Zl, Yc2, Kc2, Dp, Og2) {
                    var tp = 8 & Bi2;
                    Bi2 |= tp ? 32 : 64, 4 & (Bi2 &= ~(tp ? 64 : 32)) || (Bi2 &= -4);
                    var Fh2 = Xi2(so, Bi2, Es, tp ? Zl : void 0, tp ? Yc2 : void 0, tp ? void 0 : Zl, tp ? void 0 : Yc2, Kc2, Dp, Og2);
                    return Fh2.placeholder = co, vu(Fh2, so, Bi2);
                  }
                  function Dx(so, Bi2, Xi2, co, Es, Zl, Yc2, Kc2) {
                    var Dp = 2 & Bi2;
                    if (!Dp && typeof so != "function")
                      throw new TypeError("Expected a function");
                    var Og2 = co ? co.length : 0;
                    if (Og2 || (Bi2 &= -97, co = Es = void 0), Yc2 = Yc2 === void 0 ? Yc2 : qo(eS(Yc2), 0), Kc2 = Kc2 === void 0 ? Kc2 : eS(Kc2), Og2 -= Es ? Es.length : 0, 64 & Bi2) {
                      var tp = co, Fh2 = Es;
                      co = Es = void 0;
                    }
                    var md2 = [so, Bi2, Xi2, co, Es, tp, Fh2, Zl, Yc2, Kc2];
                    if (so = md2[0], Bi2 = md2[1], Xi2 = md2[2], co = md2[3], Es = md2[4], !(Kc2 = md2[9] = md2[9] == null ? Dp ? 0 : so.length : qo(md2[9] - Og2, 0)) && 24 & Bi2 && (Bi2 &= -25), Bi2 && Bi2 != 1)
                      cm = Bi2 == 8 || Bi2 == 16 ? function(fm, nS, K1) {
                        var tg2 = hp(fm);
                        return function Jf2() {
                          for (var O0 = arguments.length, hm = Array(O0), i_ = O0, X1 = Iv(Jf2); i_--; )
                            hm[i_] = arguments[i_];
                          var Q1 = O0 < 3 && hm[0] !== X1 && hm[O0 - 1] !== X1 ? [] : Oi2(hm, X1);
                          if ((O0 -= Q1.length) < K1)
                            return n_(fm, nS, Lg2, Jf2.placeholder, void 0, hm, Q1, void 0, void 0, K1 - O0);
                          var a_ = this && this !== un && this instanceof Jf2 ? tg2 : fm;
                          return Ei2(a_, this, hm);
                        };
                      }(so, Bi2, Kc2) : Bi2 != 32 && Bi2 != 33 || Es.length ? Lg2.apply(void 0, md2) : function(fm, nS, K1, tg2) {
                        var Jf2 = 1 & nS, O0 = hp(fm);
                        return function hm() {
                          for (var i_ = -1, X1 = arguments.length, Q1 = -1, a_ = tg2.length, mT = Array(a_ + X1), bT = this && this !== un && this instanceof hm ? O0 : fm; ++Q1 < a_; )
                            mT[Q1] = tg2[Q1];
                          for (; X1--; )
                            mT[Q1++] = arguments[++i_];
                          return Ei2(bT, Jf2 ? K1 : this, mT);
                        };
                      }(so, Bi2, Xi2, co);
                    else
                      var cm = function(fm, nS, K1) {
                        var tg2 = 1 & nS, Jf2 = hp(fm);
                        return function O0() {
                          var hm = this && this !== un && this instanceof O0 ? Jf2 : fm;
                          return hm.apply(tg2 ? K1 : this, arguments);
                        };
                      }(so, Bi2, Xi2);
                    return vu(cm, so, Bi2);
                  }
                  function Iv(so) {
                    return so.placeholder;
                  }
                  function Gv(so, Bi2) {
                    var Xi2 = function(co, Es) {
                      return co == null ? void 0 : co[Es];
                    }(so, Bi2);
                    return mc2(Xi2) ? Xi2 : void 0;
                  }
                  function Jm(so) {
                    var Bi2 = so.match(vn);
                    return Bi2 ? Bi2[1].split(Gn) : [];
                  }
                  function Ex(so, Bi2) {
                    var Xi2 = Bi2.length, co = Xi2 - 1;
                    return Bi2[co] = (Xi2 > 1 ? "& " : "") + Bi2[co], Bi2 = Bi2.join(Xi2 > 2 ? ", " : " "), so.replace(pn, `{
/* [wrapped with ` + Bi2 + `] */
`);
                  }
                  function ry(so, Bi2) {
                    return !!(Bi2 = Bi2 == null ? 9007199254740991 : Bi2) && (typeof so == "number" || oi2.test(so)) && so > -1 && so % 1 == 0 && so < Bi2;
                  }
                  function r_(so, Bi2) {
                    for (var Xi2 = so.length, co = Hu(Bi2.length, Xi2), Es = function(Yc2, Kc2) {
                      var Dp = -1, Og2 = Yc2.length;
                      for (Kc2 || (Kc2 = Array(Og2)); ++Dp < Og2; )
                        Kc2[Dp] = Yc2[Dp];
                      return Kc2;
                    }(so); co--; ) {
                      var Zl = Bi2[co];
                      so[co] = ry(Zl, Xi2) ? Es[Zl] : void 0;
                    }
                    return so;
                  }
                  var vu = vh2 ? function(so, Bi2, Xi2) {
                    var co, Es = Bi2 + "";
                    return vh2(so, "toString", { configurable: true, enumerable: false, value: (co = Ex(Es, t1(Jm(Es), Xi2)), function() {
                      return co;
                    }) });
                  } : function(so) {
                    return so;
                  };
                  function t1(so, Bi2) {
                    return function(Xi2, co) {
                      for (var Es = -1, Zl = Xi2 ? Xi2.length : 0; ++Es < Zl && co(Xi2[Es], Es, Xi2) !== false; )
                        ;
                    }(Ge2, function(Xi2) {
                      var co = "_." + Xi2[0];
                      Bi2 & Xi2[1] && !Wi2(so, co) && so.push(co);
                    }), so.sort();
                  }
                  function Dv(so, Bi2, Xi2) {
                    var co = Dx(so, 8, void 0, void 0, void 0, void 0, void 0, Bi2 = Xi2 ? void 0 : Bi2);
                    return co.placeholder = Dv.placeholder, co;
                  }
                  function nv(so) {
                    var Bi2 = typeof so;
                    return !!so && (Bi2 == "object" || Bi2 == "function");
                  }
                  function Hv(so) {
                    return so ? (so = function(Bi2) {
                      if (typeof Bi2 == "number")
                        return Bi2;
                      if (function(Es) {
                        return typeof Es == "symbol" || function(Zl) {
                          return !!Zl && typeof Zl == "object";
                        }(Es) && ga.call(Es) == "[object Symbol]";
                      }(Bi2))
                        return NaN;
                      if (nv(Bi2)) {
                        var Xi2 = typeof Bi2.valueOf == "function" ? Bi2.valueOf() : Bi2;
                        Bi2 = nv(Xi2) ? Xi2 + "" : Xi2;
                      }
                      if (typeof Bi2 != "string")
                        return Bi2 === 0 ? Bi2 : +Bi2;
                      Bi2 = Bi2.replace(Ve, "");
                      var co = Wr.test(Bi2);
                      return co || ei2.test(Bi2) ? Va2(Bi2.slice(2), co ? 2 : 8) : Lr.test(Bi2) ? NaN : +Bi2;
                    }(so)) === 1 / 0 || so === -1 / 0 ? 17976931348623157e292 * (so < 0 ? -1 : 1) : so == so ? so : 0 : so === 0 ? so : 0;
                  }
                  function eS(so) {
                    var Bi2 = Hv(so), Xi2 = Bi2 % 1;
                    return Bi2 == Bi2 ? Xi2 ? Bi2 - Xi2 : Bi2 : 0;
                  }
                  Dv.placeholder = {}, qt.exports = Dv;
                }).call(this, oe2(43));
              }, function(qt, Zt, oe2) {
                function Ne2(Gf2) {
                  return Gf2 && Gf2.__esModule ? Gf2.default : Gf2;
                }
                Zt.__esModule = true;
                var Ge2 = oe2(95);
                Zt.threezerotwofour = Ne2(Ge2);
                var Ve = oe2(96);
                Zt.apathy = Ne2(Ve);
                var pn = oe2(97);
                Zt.ashes = Ne2(pn);
                var vn = oe2(98);
                Zt.atelierDune = Ne2(vn);
                var Gn = oe2(99);
                Zt.atelierForest = Ne2(Gn);
                var Lr = oe2(100);
                Zt.atelierHeath = Ne2(Lr);
                var Wr = oe2(101);
                Zt.atelierLakeside = Ne2(Wr);
                var Gr = oe2(102);
                Zt.atelierSeaside = Ne2(Gr);
                var ei2 = oe2(103);
                Zt.bespin = Ne2(ei2);
                var oi2 = oe2(104);
                Zt.brewer = Ne2(oi2);
                var Va2 = oe2(105);
                Zt.bright = Ne2(Va2);
                var Ca2 = oe2(106);
                Zt.chalk = Ne2(Ca2);
                var Go = oe2(107);
                Zt.codeschool = Ne2(Go);
                var un = oe2(108);
                Zt.colors = Ne2(un);
                var Ei2 = oe2(109);
                Zt.default = Ne2(Ei2);
                var Wi2 = oe2(110);
                Zt.eighties = Ne2(Wi2);
                var La2 = oe2(111);
                Zt.embers = Ne2(La2);
                var Aa2 = oe2(112);
                Zt.flat = Ne2(Aa2);
                var Oi2 = oe2(113);
                Zt.google = Ne2(Oi2);
                var Zi2 = oe2(114);
                Zt.grayscale = Ne2(Zi2);
                var Ka2 = oe2(115);
                Zt.greenscreen = Ne2(Ka2);
                var Fo = oe2(116);
                Zt.harmonic = Ne2(Fo);
                var Si2 = oe2(117);
                Zt.hopscotch = Ne2(Si2);
                var bl = oe2(118);
                Zt.isotope = Ne2(bl);
                var vl = oe2(119);
                Zt.marrakesh = Ne2(vl);
                var xa2 = oe2(120);
                Zt.mocha = Ne2(xa2);
                var gu = oe2(121);
                Zt.monokai = Ne2(gu);
                var Na2 = oe2(122);
                Zt.ocean = Ne2(Na2);
                var ga = oe2(123);
                Zt.paraiso = Ne2(ga);
                var ca2 = oe2(124);
                Zt.pop = Ne2(ca2);
                var fs = oe2(125);
                Zt.railscasts = Ne2(fs);
                var qo = oe2(126);
                Zt.shapeshifter = Ne2(qo);
                var Hu = oe2(127);
                Zt.solarized = Ne2(Hu);
                var vh2 = oe2(128);
                Zt.summerfruit = Ne2(vh2);
                var Wf2 = oe2(129);
                Zt.tomorrow = Ne2(Wf2);
                var mc2 = oe2(130);
                Zt.tube = Ne2(mc2);
                var yd2 = oe2(131);
                Zt.twilight = Ne2(yd2);
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                Zt.__esModule = true, Zt.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, qt.exports = Zt.default;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(33);
                function Ge2(Ve) {
                  var pn = Math.round(Ne2(Ve, 0, 255)).toString(16);
                  return pn.length == 1 ? "0" + pn : pn;
                }
                qt.exports = function(Ve) {
                  var pn = Ve.length === 4 ? Ge2(255 * Ve[3]) : "";
                  return "#" + Ge2(Ve[0]) + Ge2(Ve[1]) + Ge2(Ve[2]) + pn;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(134), Ge2 = oe2(135), Ve = oe2(136), pn = oe2(137), vn = { "#": Ge2, hsl: function(Lr) {
                  var Wr = Ne2(Lr), Gr = pn(Wr);
                  return Wr.length === 4 && Gr.push(Wr[3]), Gr;
                }, rgb: Ve };
                function Gn(Lr) {
                  for (var Wr in vn)
                    if (Lr.indexOf(Wr) === 0)
                      return vn[Wr](Lr);
                }
                Gn.rgb = Ve, Gn.hsl = Ne2, Gn.hex = Ge2, qt.exports = Gn;
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(44), Ge2 = oe2(33);
                function Ve(pn, vn) {
                  switch (pn = parseFloat(pn), vn) {
                    case 0:
                      return Ge2(pn, 0, 360);
                    case 1:
                    case 2:
                      return Ge2(pn, 0, 100);
                    case 3:
                      return Ge2(pn, 0, 1);
                  }
                }
                qt.exports = function(pn) {
                  return Ne2(pn).map(Ve);
                };
              }, function(qt, Zt) {
                qt.exports = function(oe2) {
                  oe2.length !== 4 && oe2.length !== 5 || (oe2 = function(Ve) {
                    for (var pn = "#", vn = 1; vn < Ve.length; vn++) {
                      var Gn = Ve.charAt(vn);
                      pn += Gn + Gn;
                    }
                    return pn;
                  }(oe2));
                  var Ne2 = [parseInt(oe2.substring(1, 3), 16), parseInt(oe2.substring(3, 5), 16), parseInt(oe2.substring(5, 7), 16)];
                  if (oe2.length === 9) {
                    var Ge2 = parseFloat((parseInt(oe2.substring(7, 9), 16) / 255).toFixed(2));
                    Ne2.push(Ge2);
                  }
                  return Ne2;
                };
              }, function(qt, Zt, oe2) {
                var Ne2 = oe2(44), Ge2 = oe2(33);
                function Ve(pn, vn) {
                  return vn < 3 ? pn.indexOf("%") != -1 ? Math.round(255 * Ge2(parseInt(pn, 10), 0, 100) / 100) : Ge2(parseInt(pn, 10), 0, 255) : Ge2(parseFloat(pn), 0, 1);
                }
                qt.exports = function(pn) {
                  return Ne2(pn).map(Ve);
                };
              }, function(qt, Zt) {
                qt.exports = function(oe2) {
                  var Ne2, Ge2, Ve, pn, vn, Gn = oe2[0] / 360, Lr = oe2[1] / 100, Wr = oe2[2] / 100;
                  if (Lr == 0)
                    return [vn = 255 * Wr, vn, vn];
                  Ne2 = 2 * Wr - (Ge2 = Wr < 0.5 ? Wr * (1 + Lr) : Wr + Lr - Wr * Lr), pn = [0, 0, 0];
                  for (var Gr = 0; Gr < 3; Gr++)
                    (Ve = Gn + 1 / 3 * -(Gr - 1)) < 0 && Ve++, Ve > 1 && Ve--, vn = 6 * Ve < 1 ? Ne2 + 6 * (Ge2 - Ne2) * Ve : 2 * Ve < 1 ? Ge2 : 3 * Ve < 2 ? Ne2 + (Ge2 - Ne2) * (2 / 3 - Ve) * 6 : Ne2, pn[Gr] = 255 * vn;
                  return pn;
                };
              }, function(qt, Zt, oe2) {
                (function(Ne2) {
                  var Ge2 = typeof Ne2 == "object" && Ne2 && Ne2.Object === Object && Ne2, Ve = typeof self == "object" && self && self.Object === Object && self, pn = Ge2 || Ve || Function("return this")();
                  function vn(Oi2, Zi2, Ka2) {
                    switch (Ka2.length) {
                      case 0:
                        return Oi2.call(Zi2);
                      case 1:
                        return Oi2.call(Zi2, Ka2[0]);
                      case 2:
                        return Oi2.call(Zi2, Ka2[0], Ka2[1]);
                      case 3:
                        return Oi2.call(Zi2, Ka2[0], Ka2[1], Ka2[2]);
                    }
                    return Oi2.apply(Zi2, Ka2);
                  }
                  function Gn(Oi2, Zi2) {
                    for (var Ka2 = -1, Fo = Zi2.length, Si2 = Oi2.length; ++Ka2 < Fo; )
                      Oi2[Si2 + Ka2] = Zi2[Ka2];
                    return Oi2;
                  }
                  var Lr = Object.prototype, Wr = Lr.hasOwnProperty, Gr = Lr.toString, ei2 = pn.Symbol, oi2 = Lr.propertyIsEnumerable, Va2 = ei2 ? ei2.isConcatSpreadable : void 0, Ca2 = Math.max;
                  function Go(Oi2) {
                    return un(Oi2) || function(Zi2) {
                      return function(Ka2) {
                        return function(Fo) {
                          return !!Fo && typeof Fo == "object";
                        }(Ka2) && function(Fo) {
                          return Fo != null && function(Si2) {
                            return typeof Si2 == "number" && Si2 > -1 && Si2 % 1 == 0 && Si2 <= 9007199254740991;
                          }(Fo.length) && !function(Si2) {
                            var bl = function(vl) {
                              var xa2 = typeof vl;
                              return !!vl && (xa2 == "object" || xa2 == "function");
                            }(Si2) ? Gr.call(Si2) : "";
                            return bl == "[object Function]" || bl == "[object GeneratorFunction]";
                          }(Fo);
                        }(Ka2);
                      }(Zi2) && Wr.call(Zi2, "callee") && (!oi2.call(Zi2, "callee") || Gr.call(Zi2) == "[object Arguments]");
                    }(Oi2) || !!(Va2 && Oi2 && Oi2[Va2]);
                  }
                  var un = Array.isArray, Ei2, Wi2, La2, Aa2 = (Wi2 = function(Oi2) {
                    var Zi2 = (Oi2 = function Fo(Si2, bl, vl, xa2, gu) {
                      var Na2 = -1, ga = Si2.length;
                      for (vl || (vl = Go), gu || (gu = []); ++Na2 < ga; ) {
                        var ca2 = Si2[Na2];
                        bl > 0 && vl(ca2) ? bl > 1 ? Fo(ca2, bl - 1, vl, xa2, gu) : Gn(gu, ca2) : xa2 || (gu[gu.length] = ca2);
                      }
                      return gu;
                    }(Oi2, 1)).length, Ka2 = Zi2;
                    for (Ei2; Ka2--; )
                      if (typeof Oi2[Ka2] != "function")
                        throw new TypeError("Expected a function");
                    return function() {
                      for (var Fo = 0, Si2 = Zi2 ? Oi2[Fo].apply(this, arguments) : arguments[0]; ++Fo < Zi2; )
                        Si2 = Oi2[Fo].call(this, Si2);
                      return Si2;
                    };
                  }, La2 = Ca2(La2 === void 0 ? Wi2.length - 1 : La2, 0), function() {
                    for (var Oi2 = arguments, Zi2 = -1, Ka2 = Ca2(Oi2.length - La2, 0), Fo = Array(Ka2); ++Zi2 < Ka2; )
                      Fo[Zi2] = Oi2[La2 + Zi2];
                    Zi2 = -1;
                    for (var Si2 = Array(La2 + 1); ++Zi2 < La2; )
                      Si2[Zi2] = Oi2[Zi2];
                    return Si2[La2] = Fo, vn(Wi2, this, Si2);
                  });
                  qt.exports = Aa2;
                }).call(this, oe2(43));
              }, function(qt, Zt, oe2) {
                Object.defineProperty(Zt, "__esModule", { value: true }), Zt.yuv2rgb = function(Ne2) {
                  var Ge2, Ve, pn, vn = Ne2[0], Gn = Ne2[1], Lr = Ne2[2];
                  return Ge2 = 1 * vn + 0 * Gn + 1.13983 * Lr, Ve = 1 * vn + -0.39465 * Gn + -0.5806 * Lr, pn = 1 * vn + 2.02311 * Gn + 0 * Lr, Ge2 = Math.min(Math.max(0, Ge2), 1), Ve = Math.min(Math.max(0, Ve), 1), pn = Math.min(Math.max(0, pn), 1), [255 * Ge2, 255 * Ve, 255 * pn];
                }, Zt.rgb2yuv = function(Ne2) {
                  var Ge2 = Ne2[0] / 255, Ve = Ne2[1] / 255, pn = Ne2[2] / 255;
                  return [0.299 * Ge2 + 0.587 * Ve + 0.114 * pn, -0.14713 * Ge2 + -0.28886 * Ve + 0.436 * pn, 0.615 * Ge2 + -0.51499 * Ve + -0.10001 * pn];
                };
              }, function(qt, Zt, oe2) {
                function Ne2(pn, vn, Gn) {
                  return vn in pn ? Object.defineProperty(pn, vn, { value: Gn, enumerable: true, configurable: true, writable: true }) : pn[vn] = Gn, pn;
                }
                var Ge2 = oe2(141), Ve = function() {
                  function pn() {
                    Ne2(this, "_callbacks", void 0), Ne2(this, "_isDispatching", void 0), Ne2(this, "_isHandled", void 0), Ne2(this, "_isPending", void 0), Ne2(this, "_lastID", void 0), Ne2(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
                  }
                  var vn = pn.prototype;
                  return vn.register = function(Gn) {
                    var Lr = "ID_" + this._lastID++;
                    return this._callbacks[Lr] = Gn, Lr;
                  }, vn.unregister = function(Gn) {
                    this._callbacks[Gn] || Ge2(false), delete this._callbacks[Gn];
                  }, vn.waitFor = function(Gn) {
                    this._isDispatching || Ge2(false);
                    for (var Lr = 0; Lr < Gn.length; Lr++) {
                      var Wr = Gn[Lr];
                      this._isPending[Wr] ? this._isHandled[Wr] || Ge2(false) : (this._callbacks[Wr] || Ge2(false), this._invokeCallback(Wr));
                    }
                  }, vn.dispatch = function(Gn) {
                    this._isDispatching && Ge2(false), this._startDispatching(Gn);
                    try {
                      for (var Lr in this._callbacks)
                        this._isPending[Lr] || this._invokeCallback(Lr);
                    } finally {
                      this._stopDispatching();
                    }
                  }, vn.isDispatching = function() {
                    return this._isDispatching;
                  }, vn._invokeCallback = function(Gn) {
                    this._isPending[Gn] = true, this._callbacks[Gn](this._pendingPayload), this._isHandled[Gn] = true;
                  }, vn._startDispatching = function(Gn) {
                    for (var Lr in this._callbacks)
                      this._isPending[Lr] = false, this._isHandled[Lr] = false;
                    this._pendingPayload = Gn, this._isDispatching = true;
                  }, vn._stopDispatching = function() {
                    delete this._pendingPayload, this._isDispatching = false;
                  }, pn;
                }();
                qt.exports = Ve;
              }, function(qt, Zt, oe2) {
                qt.exports = function(Ne2, Ge2) {
                  for (var Ve = arguments.length, pn = new Array(Ve > 2 ? Ve - 2 : 0), vn = 2; vn < Ve; vn++)
                    pn[vn - 2] = arguments[vn];
                  if (!Ne2) {
                    var Gn;
                    if (Ge2 === void 0)
                      Gn = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                    else {
                      var Lr = 0;
                      (Gn = new Error(Ge2.replace(/%s/g, function() {
                        return String(pn[Lr++]);
                      }))).name = "Invariant Violation";
                    }
                    throw Gn.framesToPop = 1, Gn;
                  }
                };
              }, function(qt, Zt, oe2) {
                function Ne2(ir, Mr, gn) {
                  return Mr in ir ? Object.defineProperty(ir, Mr, { value: gn, enumerable: true, configurable: true, writable: true }) : ir[Mr] = gn, ir;
                }
                function Ge2(ir, Mr) {
                  var gn = Object.keys(ir);
                  if (Object.getOwnPropertySymbols) {
                    var sr = Object.getOwnPropertySymbols(ir);
                    Mr && (sr = sr.filter(function(dr) {
                      return Object.getOwnPropertyDescriptor(ir, dr).enumerable;
                    })), gn.push.apply(gn, sr);
                  }
                  return gn;
                }
                function Ve(ir) {
                  for (var Mr = 1; Mr < arguments.length; Mr++) {
                    var gn = arguments[Mr] != null ? arguments[Mr] : {};
                    Mr % 2 ? Ge2(Object(gn), true).forEach(function(sr) {
                      Ne2(ir, sr, gn[sr]);
                    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(ir, Object.getOwnPropertyDescriptors(gn)) : Ge2(Object(gn)).forEach(function(sr) {
                      Object.defineProperty(ir, sr, Object.getOwnPropertyDescriptor(gn, sr));
                    });
                  }
                  return ir;
                }
                function pn(ir, Mr) {
                  if (!(ir instanceof Mr))
                    throw new TypeError("Cannot call a class as a function");
                }
                function vn(ir, Mr) {
                  for (var gn = 0; gn < Mr.length; gn++) {
                    var sr = Mr[gn];
                    sr.enumerable = sr.enumerable || false, sr.configurable = true, "value" in sr && (sr.writable = true), Object.defineProperty(ir, sr.key, sr);
                  }
                }
                function Gn(ir, Mr, gn) {
                  return Mr && vn(ir.prototype, Mr), gn && vn(ir, gn), ir;
                }
                function Lr(ir, Mr) {
                  return (Lr = Object.setPrototypeOf || function(gn, sr) {
                    return gn.__proto__ = sr, gn;
                  })(ir, Mr);
                }
                function Wr(ir, Mr) {
                  if (typeof Mr != "function" && Mr !== null)
                    throw new TypeError("Super expression must either be null or a function");
                  ir.prototype = Object.create(Mr && Mr.prototype, { constructor: { value: ir, writable: true, configurable: true } }), Mr && Lr(ir, Mr);
                }
                function Gr(ir) {
                  return (Gr = Object.setPrototypeOf ? Object.getPrototypeOf : function(Mr) {
                    return Mr.__proto__ || Object.getPrototypeOf(Mr);
                  })(ir);
                }
                function ei2(ir) {
                  return (ei2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Mr) {
                    return typeof Mr;
                  } : function(Mr) {
                    return Mr && typeof Symbol == "function" && Mr.constructor === Symbol && Mr !== Symbol.prototype ? "symbol" : typeof Mr;
                  })(ir);
                }
                function oi2(ir) {
                  if (ir === void 0)
                    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                  return ir;
                }
                function Va2(ir, Mr) {
                  return !Mr || ei2(Mr) !== "object" && typeof Mr != "function" ? oi2(ir) : Mr;
                }
                function Ca2(ir) {
                  var Mr = function() {
                    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                      return false;
                    if (typeof Proxy == "function")
                      return true;
                    try {
                      return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                      })), true;
                    } catch {
                      return false;
                    }
                  }();
                  return function() {
                    var gn, sr = Gr(ir);
                    if (Mr) {
                      var dr = Gr(this).constructor;
                      gn = Reflect.construct(sr, arguments, dr);
                    } else
                      gn = sr.apply(this, arguments);
                    return Va2(this, gn);
                  };
                }
                oe2.r(Zt);
                var Go = oe2(0), un = oe2.n(Go);
                function Ei2() {
                  var ir = this.constructor.getDerivedStateFromProps(this.props, this.state);
                  ir != null && this.setState(ir);
                }
                function Wi2(ir) {
                  this.setState(function(Mr) {
                    var gn = this.constructor.getDerivedStateFromProps(ir, Mr);
                    return gn != null ? gn : null;
                  }.bind(this));
                }
                function La2(ir, Mr) {
                  try {
                    var gn = this.props, sr = this.state;
                    this.props = ir, this.state = Mr, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(gn, sr);
                  } finally {
                    this.props = gn, this.state = sr;
                  }
                }
                function Aa2(ir) {
                  var Mr = ir.prototype;
                  if (!Mr || !Mr.isReactComponent)
                    throw new Error("Can only polyfill class components");
                  if (typeof ir.getDerivedStateFromProps != "function" && typeof Mr.getSnapshotBeforeUpdate != "function")
                    return ir;
                  var gn = null, sr = null, dr = null;
                  if (typeof Mr.componentWillMount == "function" ? gn = "componentWillMount" : typeof Mr.UNSAFE_componentWillMount == "function" && (gn = "UNSAFE_componentWillMount"), typeof Mr.componentWillReceiveProps == "function" ? sr = "componentWillReceiveProps" : typeof Mr.UNSAFE_componentWillReceiveProps == "function" && (sr = "UNSAFE_componentWillReceiveProps"), typeof Mr.componentWillUpdate == "function" ? dr = "componentWillUpdate" : typeof Mr.UNSAFE_componentWillUpdate == "function" && (dr = "UNSAFE_componentWillUpdate"), gn !== null || sr !== null || dr !== null) {
                    var ji2 = ir.displayName || ir.name, qa2 = typeof ir.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                    throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + ji2 + " uses " + qa2 + " but also contains the following legacy lifecycles:" + (gn !== null ? `
  ` + gn : "") + (sr !== null ? `
  ` + sr : "") + (dr !== null ? `
  ` + dr : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
                  }
                  if (typeof ir.getDerivedStateFromProps == "function" && (Mr.componentWillMount = Ei2, Mr.componentWillReceiveProps = Wi2), typeof Mr.getSnapshotBeforeUpdate == "function") {
                    if (typeof Mr.componentDidUpdate != "function")
                      throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                    Mr.componentWillUpdate = La2;
                    var wa2 = Mr.componentDidUpdate;
                    Mr.componentDidUpdate = function(li2, jo, Al) {
                      var Sf2 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : Al;
                      wa2.call(this, li2, jo, Sf2);
                    };
                  }
                  return ir;
                }
                function Oi2(ir, Mr) {
                  if (ir == null)
                    return {};
                  var gn, sr, dr = function(qa2, wa2) {
                    if (qa2 == null)
                      return {};
                    var li2, jo, Al = {}, Sf2 = Object.keys(qa2);
                    for (jo = 0; jo < Sf2.length; jo++)
                      li2 = Sf2[jo], wa2.indexOf(li2) >= 0 || (Al[li2] = qa2[li2]);
                    return Al;
                  }(ir, Mr);
                  if (Object.getOwnPropertySymbols) {
                    var ji2 = Object.getOwnPropertySymbols(ir);
                    for (sr = 0; sr < ji2.length; sr++)
                      gn = ji2[sr], Mr.indexOf(gn) >= 0 || Object.prototype.propertyIsEnumerable.call(ir, gn) && (dr[gn] = ir[gn]);
                  }
                  return dr;
                }
                function Zi2(ir) {
                  var Mr = function(gn) {
                    return {}.toString.call(gn).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
                  }(ir);
                  return Mr === "number" && (Mr = isNaN(ir) ? "nan" : (0 | ir) != ir ? "float" : "integer"), Mr;
                }
                Ei2.__suppressDeprecationWarning = true, Wi2.__suppressDeprecationWarning = true, La2.__suppressDeprecationWarning = true;
                var Ka2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, Fo = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, Si2 = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, bl = oe2(45), vl = function(ir) {
                  var Mr = function(gn) {
                    return { backgroundColor: gn.base00, ellipsisColor: gn.base09, braceColor: gn.base07, expandedIcon: gn.base0D, collapsedIcon: gn.base0E, keyColor: gn.base07, arrayKeyColor: gn.base0C, objectSize: gn.base04, copyToClipboard: gn.base0F, copyToClipboardCheck: gn.base0D, objectBorder: gn.base02, dataTypes: { boolean: gn.base0E, date: gn.base0D, float: gn.base0B, function: gn.base0D, integer: gn.base0F, string: gn.base09, nan: gn.base08, null: gn.base0A, undefined: gn.base05, regexp: gn.base0A, background: gn.base02 }, editVariable: { editIcon: gn.base0E, cancelIcon: gn.base09, removeIcon: gn.base09, addIcon: gn.base0E, checkIcon: gn.base0E, background: gn.base01, color: gn.base0A, border: gn.base07 }, addKeyModal: { background: gn.base05, border: gn.base04, color: gn.base0A, labelColor: gn.base01 }, validationFailure: { background: gn.base09, iconColor: gn.base01, fontColor: gn.base01 } };
                  }(ir);
                  return { "app-container": { fontFamily: Si2.globalFontFamily, cursor: Si2.globalCursor, backgroundColor: Mr.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Mr.ellipsisColor, fontSize: Si2.ellipsisFontSize, lineHeight: Si2.ellipsisLineHeight, cursor: Si2.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: Si2.braceCursor, fontWeight: Si2.braceFontWeight, color: Mr.braceColor }, "expanded-icon": { color: Mr.expandedIcon }, "collapsed-icon": { color: Mr.collapsedIcon }, colon: { display: "inline-block", margin: Si2.keyMargin, color: Mr.keyColor, verticalAlign: "top" }, objectKeyVal: function(gn, sr) {
                    return { style: Ve({ paddingTop: Si2.keyValPaddingTop, paddingRight: Si2.keyValPaddingRight, paddingBottom: Si2.keyValPaddingBottom, borderLeft: Si2.keyValBorderLeft + " " + Mr.objectBorder, ":hover": { paddingLeft: sr.paddingLeft - 1 + "px", borderLeft: Si2.keyValBorderHover + " " + Mr.objectBorder } }, sr) };
                  }, "object-key-val-no-border": { padding: Si2.keyValPadding }, "pushed-content": { marginLeft: Si2.pushedContentMarginLeft }, variableValue: function(gn, sr) {
                    return { style: Ve({ display: "inline-block", paddingRight: Si2.variableValuePaddingRight, position: "relative" }, sr) };
                  }, "object-name": { display: "inline-block", color: Mr.keyColor, letterSpacing: Si2.keyLetterSpacing, fontStyle: Si2.keyFontStyle, verticalAlign: Si2.keyVerticalAlign, opacity: Si2.keyOpacity, ":hover": { opacity: Si2.keyOpacityHover } }, "array-key": { display: "inline-block", color: Mr.arrayKeyColor, letterSpacing: Si2.keyLetterSpacing, fontStyle: Si2.keyFontStyle, verticalAlign: Si2.keyVerticalAlign, opacity: Si2.keyOpacity, ":hover": { opacity: Si2.keyOpacityHover } }, "object-size": { color: Mr.objectSize, borderRadius: Si2.objectSizeBorderRadius, fontStyle: Si2.objectSizeFontStyle, margin: Si2.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: Si2.dataTypeFontSize, marginRight: Si2.dataTypeMarginRight, opacity: Si2.datatypeOpacity }, boolean: { display: "inline-block", color: Mr.dataTypes.boolean }, date: { display: "inline-block", color: Mr.dataTypes.date }, "date-value": { marginLeft: Si2.dateValueMarginLeft }, float: { display: "inline-block", color: Mr.dataTypes.float }, function: { display: "inline-block", color: Mr.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Mr.dataTypes.integer }, string: { display: "inline-block", color: Mr.dataTypes.string }, nan: { display: "inline-block", color: Mr.dataTypes.nan, fontSize: Si2.nanFontSize, fontWeight: Si2.nanFontWeight, backgroundColor: Mr.dataTypes.background, padding: Si2.nanPadding, borderRadius: Si2.nanBorderRadius }, null: { display: "inline-block", color: Mr.dataTypes.null, fontSize: Si2.nullFontSize, fontWeight: Si2.nullFontWeight, backgroundColor: Mr.dataTypes.background, padding: Si2.nullPadding, borderRadius: Si2.nullBorderRadius }, undefined: { display: "inline-block", color: Mr.dataTypes.undefined, fontSize: Si2.undefinedFontSize, padding: Si2.undefinedPadding, borderRadius: Si2.undefinedBorderRadius, backgroundColor: Mr.dataTypes.background }, regexp: { display: "inline-block", color: Mr.dataTypes.regexp }, "copy-to-clipboard": { cursor: Si2.clipboardCursor }, "copy-icon": { color: Mr.copyToClipboard, fontSize: Si2.iconFontSize, marginRight: Si2.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Mr.copyToClipboardCheck, marginLeft: Si2.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: Si2.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: Si2.metaDataPadding }, "icon-container": { display: "inline-block", width: Si2.iconContainerWidth }, tooltip: { padding: Si2.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Mr.editVariable.removeIcon, cursor: Si2.iconCursor, fontSize: Si2.iconFontSize, marginRight: Si2.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Mr.editVariable.addIcon, cursor: Si2.iconCursor, fontSize: Si2.iconFontSize, marginRight: Si2.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Mr.editVariable.editIcon, cursor: Si2.iconCursor, fontSize: Si2.iconFontSize, marginRight: Si2.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: Si2.iconCursor, color: Mr.editVariable.checkIcon, fontSize: Si2.iconFontSize, paddingRight: Si2.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: Si2.iconCursor, color: Mr.editVariable.cancelIcon, fontSize: Si2.iconFontSize, paddingRight: Si2.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: Si2.editInputMinWidth, borderRadius: Si2.editInputBorderRadius, backgroundColor: Mr.editVariable.background, color: Mr.editVariable.color, padding: Si2.editInputPadding, marginRight: Si2.editInputMarginRight, fontFamily: Si2.editInputFontFamily }, "detected-row": { paddingTop: Si2.detectedRowPaddingTop }, "key-modal-request": { position: Si2.addKeyCoverPosition, top: Si2.addKeyCoverPositionPx, left: Si2.addKeyCoverPositionPx, right: Si2.addKeyCoverPositionPx, bottom: Si2.addKeyCoverPositionPx, backgroundColor: Si2.addKeyCoverBackground }, "key-modal": { width: Si2.addKeyModalWidth, backgroundColor: Mr.addKeyModal.background, marginLeft: Si2.addKeyModalMargin, marginRight: Si2.addKeyModalMargin, padding: Si2.addKeyModalPadding, borderRadius: Si2.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Mr.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Mr.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Mr.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Mr.addKeyModal.labelColor, fontSize: Si2.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Mr.editVariable.addIcon, fontSize: Si2.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Mr.ellipsisColor, fontSize: Si2.ellipsisFontSize, lineHeight: Si2.ellipsisLineHeight, cursor: Si2.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Mr.validationFailure.fontColor, backgroundColor: Mr.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Mr.validationFailure.iconColor, fontSize: Si2.iconFontSize, transform: "rotate(45deg)" } };
                };
                function xa2(ir, Mr, gn) {
                  return ir || console.error("theme has not been set"), function(sr) {
                    var dr = Ka2;
                    return sr !== false && sr !== "none" || (dr = Fo), Object(bl.createStyling)(vl, { defaultBase16: dr })(sr);
                  }(ir)(Mr, gn);
                }
                var gu = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = (sr.rjvId, sr.type_name), ji2 = sr.displayDataTypes, qa2 = sr.theme;
                    return ji2 ? un.a.createElement("span", Object.assign({ className: "data-type-label" }, xa2(qa2, "data-type-label")), dr) : null;
                  } }]), gn;
                }(un.a.PureComponent), Na2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props;
                    return un.a.createElement("div", xa2(sr.theme, "boolean"), un.a.createElement(gu, Object.assign({ type_name: "bool" }, sr)), sr.value ? "true" : "false");
                  } }]), gn;
                }(un.a.PureComponent), ga = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props;
                    return un.a.createElement("div", xa2(sr.theme, "date"), un.a.createElement(gu, Object.assign({ type_name: "date" }, sr)), un.a.createElement("span", Object.assign({ className: "date-value" }, xa2(sr.theme, "date-value")), sr.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
                  } }]), gn;
                }(un.a.PureComponent), ca2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props;
                    return un.a.createElement("div", xa2(sr.theme, "float"), un.a.createElement(gu, Object.assign({ type_name: "float" }, sr)), this.props.value);
                  } }]), gn;
                }(un.a.PureComponent);
                function fs(ir, Mr) {
                  (Mr == null || Mr > ir.length) && (Mr = ir.length);
                  for (var gn = 0, sr = new Array(Mr); gn < Mr; gn++)
                    sr[gn] = ir[gn];
                  return sr;
                }
                function qo(ir, Mr) {
                  if (ir) {
                    if (typeof ir == "string")
                      return fs(ir, Mr);
                    var gn = Object.prototype.toString.call(ir).slice(8, -1);
                    return gn === "Object" && ir.constructor && (gn = ir.constructor.name), gn === "Map" || gn === "Set" ? Array.from(ir) : gn === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(gn) ? fs(ir, Mr) : void 0;
                  }
                }
                function Hu(ir, Mr) {
                  var gn;
                  if (typeof Symbol == "undefined" || ir[Symbol.iterator] == null) {
                    if (Array.isArray(ir) || (gn = qo(ir)) || Mr && ir && typeof ir.length == "number") {
                      gn && (ir = gn);
                      var sr = 0, dr = function() {
                      };
                      return { s: dr, n: function() {
                        return sr >= ir.length ? { done: true } : { done: false, value: ir[sr++] };
                      }, e: function(li2) {
                        throw li2;
                      }, f: dr };
                    }
                    throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                  }
                  var ji2, qa2 = true, wa2 = false;
                  return { s: function() {
                    gn = ir[Symbol.iterator]();
                  }, n: function() {
                    var li2 = gn.next();
                    return qa2 = li2.done, li2;
                  }, e: function(li2) {
                    wa2 = true, ji2 = li2;
                  }, f: function() {
                    try {
                      qa2 || gn.return == null || gn.return();
                    } finally {
                      if (wa2)
                        throw ji2;
                    }
                  } };
                }
                function vh2(ir) {
                  return function(Mr) {
                    if (Array.isArray(Mr))
                      return fs(Mr);
                  }(ir) || function(Mr) {
                    if (typeof Symbol != "undefined" && Symbol.iterator in Object(Mr))
                      return Array.from(Mr);
                  }(ir) || qo(ir) || function() {
                    throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                  }();
                }
                var Wf2 = oe2(46), mc2 = new (oe2(47)).Dispatcher(), yd2 = new (function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    var sr;
                    pn(this, gn);
                    for (var dr = arguments.length, ji2 = new Array(dr), qa2 = 0; qa2 < dr; qa2++)
                      ji2[qa2] = arguments[qa2];
                    return (sr = Mr.call.apply(Mr, [this].concat(ji2))).objects = {}, sr.set = function(wa2, li2, jo, Al) {
                      sr.objects[wa2] === void 0 && (sr.objects[wa2] = {}), sr.objects[wa2][li2] === void 0 && (sr.objects[wa2][li2] = {}), sr.objects[wa2][li2][jo] = Al;
                    }, sr.get = function(wa2, li2, jo, Al) {
                      return sr.objects[wa2] === void 0 || sr.objects[wa2][li2] === void 0 || sr.objects[wa2][li2][jo] == null ? Al : sr.objects[wa2][li2][jo];
                    }, sr.handleAction = function(wa2) {
                      var li2 = wa2.rjvId, jo = wa2.data;
                      switch (wa2.name) {
                        case "RESET":
                          sr.emit("reset-" + li2);
                          break;
                        case "VARIABLE_UPDATED":
                          wa2.data.updated_src = sr.updateSrc(li2, jo), sr.set(li2, "action", "variable-update", Ve(Ve({}, jo), {}, { type: "variable-edited" })), sr.emit("variable-update-" + li2);
                          break;
                        case "VARIABLE_REMOVED":
                          wa2.data.updated_src = sr.updateSrc(li2, jo), sr.set(li2, "action", "variable-update", Ve(Ve({}, jo), {}, { type: "variable-removed" })), sr.emit("variable-update-" + li2);
                          break;
                        case "VARIABLE_ADDED":
                          wa2.data.updated_src = sr.updateSrc(li2, jo), sr.set(li2, "action", "variable-update", Ve(Ve({}, jo), {}, { type: "variable-added" })), sr.emit("variable-update-" + li2);
                          break;
                        case "ADD_VARIABLE_KEY_REQUEST":
                          sr.set(li2, "action", "new-key-request", jo), sr.emit("add-key-request-" + li2);
                      }
                    }, sr.updateSrc = function(wa2, li2) {
                      var jo = li2.name, Al = li2.namespace, Sf2 = li2.new_value, sf2 = (li2.existing_value, li2.variable_removed);
                      Al.shift();
                      var Vc2, zu = sr.get(wa2, "global", "src"), ad2 = sr.deepCopy(zu, vh2(Al)), Rg2 = ad2, bc2 = Hu(Al);
                      try {
                        for (bc2.s(); !(Vc2 = bc2.n()).done; )
                          Rg2 = Rg2[Vc2.value];
                      } catch (Ng2) {
                        bc2.e(Ng2);
                      } finally {
                        bc2.f();
                      }
                      return sf2 ? Zi2(Rg2) == "array" ? Rg2.splice(jo, 1) : delete Rg2[jo] : jo !== null ? Rg2[jo] = Sf2 : ad2 = Sf2, sr.set(wa2, "global", "src", ad2), ad2;
                    }, sr.deepCopy = function(wa2, li2) {
                      var jo, Al = Zi2(wa2), Sf2 = li2.shift();
                      return Al == "array" ? jo = vh2(wa2) : Al == "object" && (jo = Ve({}, wa2)), Sf2 !== void 0 && (jo[Sf2] = sr.deepCopy(wa2[Sf2], li2)), jo;
                    }, sr;
                  }
                  return gn;
                }(Wf2.EventEmitter))();
                mc2.register(yd2.handleAction.bind(yd2));
                var Gf2 = yd2, hp = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    return pn(this, gn), (dr = Mr.call(this, sr)).toggleCollapsed = function() {
                      dr.setState({ collapsed: !dr.state.collapsed }, function() {
                        Gf2.set(dr.props.rjvId, dr.props.namespace, "collapsed", dr.state.collapsed);
                      });
                    }, dr.getFunctionDisplay = function(ji2) {
                      var qa2 = oi2(dr).props;
                      return ji2 ? un.a.createElement("span", null, dr.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), un.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, un.a.createElement("span", null, "{"), un.a.createElement("span", xa2(qa2.theme, "ellipsis"), "..."), un.a.createElement("span", null, "}"))) : dr.props.value.toString().slice(9, -1);
                    }, dr.state = { collapsed: Gf2.get(sr.rjvId, sr.namespace, "collapsed", true) }, dr;
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = this.state.collapsed;
                    return un.a.createElement("div", xa2(sr.theme, "function"), un.a.createElement(gu, Object.assign({ type_name: "function" }, sr)), un.a.createElement("span", Object.assign({}, xa2(sr.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(dr)));
                  } }]), gn;
                }(un.a.PureComponent), Lg2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    return un.a.createElement("div", xa2(this.props.theme, "nan"), "NaN");
                  } }]), gn;
                }(un.a.PureComponent), n_ = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    return un.a.createElement("div", xa2(this.props.theme, "null"), "NULL");
                  } }]), gn;
                }(un.a.PureComponent), Dx = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props;
                    return un.a.createElement("div", xa2(sr.theme, "integer"), un.a.createElement(gu, Object.assign({ type_name: "int" }, sr)), this.props.value);
                  } }]), gn;
                }(un.a.PureComponent), Iv = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props;
                    return un.a.createElement("div", xa2(sr.theme, "regexp"), un.a.createElement(gu, Object.assign({ type_name: "regexp" }, sr)), this.props.value.toString());
                  } }]), gn;
                }(un.a.PureComponent), Gv = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    return pn(this, gn), (dr = Mr.call(this, sr)).toggleCollapsed = function() {
                      dr.setState({ collapsed: !dr.state.collapsed }, function() {
                        Gf2.set(dr.props.rjvId, dr.props.namespace, "collapsed", dr.state.collapsed);
                      });
                    }, dr.state = { collapsed: Gf2.get(sr.rjvId, sr.namespace, "collapsed", true) }, dr;
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    this.state.collapsed;
                    var sr = this.props, dr = sr.collapseStringsAfterLength, ji2 = sr.theme, qa2 = sr.value, wa2 = { style: { cursor: "default" } };
                    return Zi2(dr) === "integer" && qa2.length > dr && (wa2.style.cursor = "pointer", this.state.collapsed && (qa2 = un.a.createElement("span", null, qa2.substring(0, dr), un.a.createElement("span", xa2(ji2, "ellipsis"), " ...")))), un.a.createElement("div", xa2(ji2, "string"), un.a.createElement(gu, Object.assign({ type_name: "string" }, sr)), un.a.createElement("span", Object.assign({ className: "string-value" }, wa2, { onClick: this.toggleCollapsed }), '"', qa2, '"'));
                  } }]), gn;
                }(un.a.PureComponent), Jm = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    return un.a.createElement("div", xa2(this.props.theme, "undefined"), "undefined");
                  } }]), gn;
                }(un.a.PureComponent);
                function Ex() {
                  return (Ex = Object.assign || function(ir) {
                    for (var Mr = 1; Mr < arguments.length; Mr++) {
                      var gn = arguments[Mr];
                      for (var sr in gn)
                        Object.prototype.hasOwnProperty.call(gn, sr) && (ir[sr] = gn[sr]);
                    }
                    return ir;
                  }).apply(this, arguments);
                }
                var ry = Go.useLayoutEffect, r_ = function(ir) {
                  var Mr = Object(Go.useRef)(ir);
                  return ry(function() {
                    Mr.current = ir;
                  }), Mr;
                }, vu = function(ir, Mr) {
                  typeof ir != "function" ? ir.current = Mr : ir(Mr);
                }, t1 = function(ir, Mr) {
                  var gn = Object(Go.useRef)();
                  return Object(Go.useCallback)(function(sr) {
                    ir.current = sr, gn.current && vu(gn.current, null), gn.current = Mr, Mr && vu(Mr, sr);
                  }, [Mr]);
                }, Dv = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, nv = function(ir) {
                  Object.keys(Dv).forEach(function(Mr) {
                    ir.style.setProperty(Mr, Dv[Mr], "important");
                  });
                }, Hv = null, eS = function() {
                }, so = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Bi2 = !!document.documentElement.currentStyle, Xi2 = function(ir, Mr) {
                  var gn = ir.cacheMeasurements, sr = ir.maxRows, dr = ir.minRows, ji2 = ir.onChange, qa2 = ji2 === void 0 ? eS : ji2, wa2 = ir.onHeightChange, li2 = wa2 === void 0 ? eS : wa2, jo = function(bc2, Ng2) {
                    if (bc2 == null)
                      return {};
                    var pm, T22, yD = {}, rS = Object.keys(bc2);
                    for (T22 = 0; T22 < rS.length; T22++)
                      pm = rS[T22], Ng2.indexOf(pm) >= 0 || (yD[pm] = bc2[pm]);
                    return yD;
                  }(ir, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), Al, Sf2 = jo.value !== void 0, sf2 = Object(Go.useRef)(null), Vc2 = t1(sf2, Mr), zu = Object(Go.useRef)(0), ad2 = Object(Go.useRef)(), Rg2 = function() {
                    var bc2 = sf2.current, Ng2 = gn && ad2.current ? ad2.current : function(rS) {
                      var Uk = window.getComputedStyle(rS);
                      if (Uk === null)
                        return null;
                      var xT, iy = (xT = Uk, so.reduce(function(ay, RM) {
                        return ay[RM] = xT[RM], ay;
                      }, {})), A22 = iy.boxSizing;
                      return A22 === "" ? null : (Bi2 && A22 === "border-box" && (iy.width = parseFloat(iy.width) + parseFloat(iy.borderRightWidth) + parseFloat(iy.borderLeftWidth) + parseFloat(iy.paddingRight) + parseFloat(iy.paddingLeft) + "px"), { sizingStyle: iy, paddingSize: parseFloat(iy.paddingBottom) + parseFloat(iy.paddingTop), borderSize: parseFloat(iy.borderBottomWidth) + parseFloat(iy.borderTopWidth) });
                    }(bc2);
                    if (Ng2) {
                      ad2.current = Ng2;
                      var pm = function(rS, Uk, xT, iy) {
                        xT === void 0 && (xT = 1), iy === void 0 && (iy = 1 / 0), Hv || ((Hv = document.createElement("textarea")).setAttribute("tab-index", "-1"), Hv.setAttribute("aria-hidden", "true"), nv(Hv)), Hv.parentNode === null && document.body.appendChild(Hv);
                        var A22 = rS.paddingSize, ay = rS.borderSize, RM = rS.sizingStyle, Uv = RM.boxSizing;
                        Object.keys(RM).forEach(function(ST) {
                          var Ly = ST;
                          Hv.style[Ly] = RM[Ly];
                        }), nv(Hv), Hv.value = Uk;
                        var qk2 = function(ST, Ly) {
                          var XR = ST.scrollHeight;
                          return Ly.sizingStyle.boxSizing === "border-box" ? XR + Ly.borderSize : XR - Ly.paddingSize;
                        }(Hv, rS);
                        Hv.value = "x";
                        var KR = Hv.scrollHeight - A22, kx = KR * xT;
                        Uv === "border-box" && (kx = kx + A22 + ay), qk2 = Math.max(kx, qk2);
                        var wT = KR * iy;
                        return Uv === "border-box" && (wT = wT + A22 + ay), [qk2 = Math.min(wT, qk2), KR];
                      }(Ng2, bc2.value || bc2.placeholder || "x", dr, sr), T22 = pm[0], yD = pm[1];
                      zu.current !== T22 && (zu.current = T22, bc2.style.setProperty("height", T22 + "px", "important"), li2(T22, { rowHeight: yD }));
                    }
                  };
                  return Object(Go.useLayoutEffect)(Rg2), Al = r_(Rg2), Object(Go.useLayoutEffect)(function() {
                    var bc2 = function(Ng2) {
                      Al.current(Ng2);
                    };
                    return window.addEventListener("resize", bc2), function() {
                      window.removeEventListener("resize", bc2);
                    };
                  }, []), Object(Go.createElement)("textarea", Ex({}, jo, { onChange: function(bc2) {
                    Sf2 || Rg2(), qa2(bc2);
                  }, ref: Vc2 }));
                }, co = Object(Go.forwardRef)(Xi2);
                function Es(ir) {
                  ir = ir.trim();
                  try {
                    if ((ir = JSON.stringify(JSON.parse(ir)))[0] === "[")
                      return Zl("array", JSON.parse(ir));
                    if (ir[0] === "{")
                      return Zl("object", JSON.parse(ir));
                    if (ir.match(/\-?\d+\.\d+/) && ir.match(/\-?\d+\.\d+/)[0] === ir)
                      return Zl("float", parseFloat(ir));
                    if (ir.match(/\-?\d+e-\d+/) && ir.match(/\-?\d+e-\d+/)[0] === ir)
                      return Zl("float", Number(ir));
                    if (ir.match(/\-?\d+/) && ir.match(/\-?\d+/)[0] === ir)
                      return Zl("integer", parseInt(ir));
                    if (ir.match(/\-?\d+e\+\d+/) && ir.match(/\-?\d+e\+\d+/)[0] === ir)
                      return Zl("integer", Number(ir));
                  } catch {
                  }
                  switch (ir = ir.toLowerCase()) {
                    case "undefined":
                      return Zl("undefined", void 0);
                    case "nan":
                      return Zl("nan", NaN);
                    case "null":
                      return Zl("null", null);
                    case "true":
                      return Zl("boolean", true);
                    case "false":
                      return Zl("boolean", false);
                    default:
                      if (ir = Date.parse(ir))
                        return Zl("date", new Date(ir));
                  }
                  return Zl(false, null);
                }
                function Zl(ir, Mr) {
                  return { type: ir, value: Mr };
                }
                var Yc2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
                  } }]), gn;
                }(un.a.PureComponent), Kc2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
                  } }]), gn;
                }(un.a.PureComponent), Dp = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]), qa2 = Jf2(dr).style;
                    return un.a.createElement("span", ji2, un.a.createElement("svg", { fill: qa2.color, width: qa2.height, height: qa2.width, style: qa2, viewBox: "0 0 1792 1792" }, un.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                  } }]), gn;
                }(un.a.PureComponent), Og2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]), qa2 = Jf2(dr).style;
                    return un.a.createElement("span", ji2, un.a.createElement("svg", { fill: qa2.color, width: qa2.height, height: qa2.width, style: qa2, viewBox: "0 0 1792 1792" }, un.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                  } }]), gn;
                }(un.a.PureComponent), tp = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", { style: Ve(Ve({}, Jf2(dr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, un.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
                  } }]), gn;
                }(un.a.PureComponent), Fh2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", { style: Ve(Ve({}, Jf2(dr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, un.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
                  } }]), gn;
                }(un.a.PureComponent), md2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("g", null, un.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
                  } }]), gn;
                }(un.a.PureComponent), cm = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("g", null, un.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                  } }]), gn;
                }(un.a.PureComponent), fm = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("g", null, un.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                  } }]), gn;
                }(un.a.PureComponent), nS = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("g", null, un.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
                  } }]), gn;
                }(un.a.PureComponent), K1 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("g", null, un.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
                  } }]), gn;
                }(un.a.PureComponent), tg2 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.style, ji2 = Oi2(sr, ["style"]);
                    return un.a.createElement("span", ji2, un.a.createElement("svg", Object.assign({}, Jf2(dr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), un.a.createElement("g", null, un.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                  } }]), gn;
                }(un.a.PureComponent);
                function Jf2(ir) {
                  return ir || (ir = {}), { style: Ve(Ve({ verticalAlign: "middle" }, ir), {}, { color: ir.color ? ir.color : "#000000", height: "1em", width: "1em" }) };
                }
                var O0 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    return pn(this, gn), (dr = Mr.call(this, sr)).copiedTimer = null, dr.handleCopy = function() {
                      var ji2 = document.createElement("textarea"), qa2 = dr.props, wa2 = qa2.clickCallback, li2 = qa2.src, jo = qa2.namespace;
                      ji2.innerHTML = JSON.stringify(dr.clipboardValue(li2), null, "  "), document.body.appendChild(ji2), ji2.select(), document.execCommand("copy"), document.body.removeChild(ji2), dr.copiedTimer = setTimeout(function() {
                        dr.setState({ copied: false });
                      }, 5500), dr.setState({ copied: true }, function() {
                        typeof wa2 == "function" && wa2({ src: li2, namespace: jo, name: jo[jo.length - 1] });
                      });
                    }, dr.getClippyIcon = function() {
                      var ji2 = dr.props.theme;
                      return dr.state.copied ? un.a.createElement("span", null, un.a.createElement(md2, Object.assign({ className: "copy-icon" }, xa2(ji2, "copy-icon"))), un.a.createElement("span", xa2(ji2, "copy-icon-copied"), "\u2714")) : un.a.createElement(md2, Object.assign({ className: "copy-icon" }, xa2(ji2, "copy-icon")));
                    }, dr.clipboardValue = function(ji2) {
                      switch (Zi2(ji2)) {
                        case "function":
                        case "regexp":
                          return ji2.toString();
                        default:
                          return ji2;
                      }
                    }, dr.state = { copied: false }, dr;
                  }
                  return Gn(gn, [{ key: "componentWillUnmount", value: function() {
                    this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
                  } }, { key: "render", value: function() {
                    var sr = this.props, dr = (sr.src, sr.theme), ji2 = sr.hidden, qa2 = sr.rowHovered, wa2 = xa2(dr, "copy-to-clipboard").style, li2 = "inline";
                    return ji2 && (li2 = "none"), un.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: qa2 ? "inline-block" : "none" } }, un.a.createElement("span", { style: Ve(Ve({}, wa2), {}, { display: li2 }), onClick: this.handleCopy }, this.getClippyIcon()));
                  } }]), gn;
                }(un.a.PureComponent), hm = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    return pn(this, gn), (dr = Mr.call(this, sr)).getEditIcon = function() {
                      var ji2 = dr.props, qa2 = ji2.variable, wa2 = ji2.theme;
                      return un.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: dr.state.hovered ? "inline-block" : "none" } }, un.a.createElement(K1, Object.assign({ className: "click-to-edit-icon" }, xa2(wa2, "editVarIcon"), { onClick: function() {
                        dr.prepopInput(qa2);
                      } })));
                    }, dr.prepopInput = function(ji2) {
                      if (dr.props.onEdit !== false) {
                        var qa2 = function(li2) {
                          var jo;
                          switch (Zi2(li2)) {
                            case "undefined":
                              jo = "undefined";
                              break;
                            case "nan":
                              jo = "NaN";
                              break;
                            case "string":
                              jo = li2;
                              break;
                            case "date":
                            case "function":
                            case "regexp":
                              jo = li2.toString();
                              break;
                            default:
                              try {
                                jo = JSON.stringify(li2, null, "  ");
                              } catch {
                                jo = "";
                              }
                          }
                          return jo;
                        }(ji2.value), wa2 = Es(qa2);
                        dr.setState({ editMode: true, editValue: qa2, parsedInput: { type: wa2.type, value: wa2.value } });
                      }
                    }, dr.getRemoveIcon = function() {
                      var ji2 = dr.props, qa2 = ji2.variable, wa2 = ji2.namespace, li2 = ji2.theme, jo = ji2.rjvId;
                      return un.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: dr.state.hovered ? "inline-block" : "none" } }, un.a.createElement(cm, Object.assign({ className: "click-to-remove-icon" }, xa2(li2, "removeVarIcon"), { onClick: function() {
                        mc2.dispatch({ name: "VARIABLE_REMOVED", rjvId: jo, data: { name: qa2.name, namespace: wa2, existing_value: qa2.value, variable_removed: true } });
                      } })));
                    }, dr.getValue = function(ji2, qa2) {
                      var wa2 = !qa2 && ji2.type, li2 = oi2(dr).props;
                      switch (wa2) {
                        case false:
                          return dr.getEditInput();
                        case "string":
                          return un.a.createElement(Gv, Object.assign({ value: ji2.value }, li2));
                        case "integer":
                          return un.a.createElement(Dx, Object.assign({ value: ji2.value }, li2));
                        case "float":
                          return un.a.createElement(ca2, Object.assign({ value: ji2.value }, li2));
                        case "boolean":
                          return un.a.createElement(Na2, Object.assign({ value: ji2.value }, li2));
                        case "function":
                          return un.a.createElement(hp, Object.assign({ value: ji2.value }, li2));
                        case "null":
                          return un.a.createElement(n_, li2);
                        case "nan":
                          return un.a.createElement(Lg2, li2);
                        case "undefined":
                          return un.a.createElement(Jm, li2);
                        case "date":
                          return un.a.createElement(ga, Object.assign({ value: ji2.value }, li2));
                        case "regexp":
                          return un.a.createElement(Iv, Object.assign({ value: ji2.value }, li2));
                        default:
                          return un.a.createElement("div", { className: "object-value" }, JSON.stringify(ji2.value));
                      }
                    }, dr.getEditInput = function() {
                      var ji2 = dr.props.theme, qa2 = dr.state.editValue;
                      return un.a.createElement("div", null, un.a.createElement(co, Object.assign({ type: "text", inputRef: function(wa2) {
                        return wa2 && wa2.focus();
                      }, value: qa2, className: "variable-editor", onChange: function(wa2) {
                        var li2 = wa2.target.value, jo = Es(li2);
                        dr.setState({ editValue: li2, parsedInput: { type: jo.type, value: jo.value } });
                      }, onKeyDown: function(wa2) {
                        switch (wa2.key) {
                          case "Escape":
                            dr.setState({ editMode: false, editValue: "" });
                            break;
                          case "Enter":
                            (wa2.ctrlKey || wa2.metaKey) && dr.submitEdit(true);
                        }
                        wa2.stopPropagation();
                      }, placeholder: "update this value", minRows: 2 }, xa2(ji2, "edit-input"))), un.a.createElement("div", xa2(ji2, "edit-icon-container"), un.a.createElement(cm, Object.assign({ className: "edit-cancel" }, xa2(ji2, "cancel-icon"), { onClick: function() {
                        dr.setState({ editMode: false, editValue: "" });
                      } })), un.a.createElement(tg2, Object.assign({ className: "edit-check string-value" }, xa2(ji2, "check-icon"), { onClick: function() {
                        dr.submitEdit();
                      } })), un.a.createElement("div", null, dr.showDetected())));
                    }, dr.submitEdit = function(ji2) {
                      var qa2 = dr.props, wa2 = qa2.variable, li2 = qa2.namespace, jo = qa2.rjvId, Al = dr.state, Sf2 = Al.editValue, sf2 = Al.parsedInput, Vc2 = Sf2;
                      ji2 && sf2.type && (Vc2 = sf2.value), dr.setState({ editMode: false }), mc2.dispatch({ name: "VARIABLE_UPDATED", rjvId: jo, data: { name: wa2.name, namespace: li2, existing_value: wa2.value, new_value: Vc2, variable_removed: false } });
                    }, dr.showDetected = function() {
                      var ji2 = dr.props, qa2 = ji2.theme, wa2 = (ji2.variable, ji2.namespace, ji2.rjvId, dr.state.parsedInput), li2 = (wa2.type, wa2.value, dr.getDetectedInput());
                      if (li2)
                        return un.a.createElement("div", null, un.a.createElement("div", xa2(qa2, "detected-row"), li2, un.a.createElement(tg2, { className: "edit-check detected", style: Ve({ verticalAlign: "top", paddingLeft: "3px" }, xa2(qa2, "check-icon").style), onClick: function() {
                          dr.submitEdit(true);
                        } })));
                    }, dr.getDetectedInput = function() {
                      var ji2 = dr.state.parsedInput, qa2 = ji2.type, wa2 = ji2.value, li2 = oi2(dr).props, jo = li2.theme;
                      if (qa2 !== false)
                        switch (qa2.toLowerCase()) {
                          case "object":
                            return un.a.createElement("span", null, un.a.createElement("span", { style: Ve(Ve({}, xa2(jo, "brace").style), {}, { cursor: "default" }) }, "{"), un.a.createElement("span", { style: Ve(Ve({}, xa2(jo, "ellipsis").style), {}, { cursor: "default" }) }, "..."), un.a.createElement("span", { style: Ve(Ve({}, xa2(jo, "brace").style), {}, { cursor: "default" }) }, "}"));
                          case "array":
                            return un.a.createElement("span", null, un.a.createElement("span", { style: Ve(Ve({}, xa2(jo, "brace").style), {}, { cursor: "default" }) }, "["), un.a.createElement("span", { style: Ve(Ve({}, xa2(jo, "ellipsis").style), {}, { cursor: "default" }) }, "..."), un.a.createElement("span", { style: Ve(Ve({}, xa2(jo, "brace").style), {}, { cursor: "default" }) }, "]"));
                          case "string":
                            return un.a.createElement(Gv, Object.assign({ value: wa2 }, li2));
                          case "integer":
                            return un.a.createElement(Dx, Object.assign({ value: wa2 }, li2));
                          case "float":
                            return un.a.createElement(ca2, Object.assign({ value: wa2 }, li2));
                          case "boolean":
                            return un.a.createElement(Na2, Object.assign({ value: wa2 }, li2));
                          case "function":
                            return un.a.createElement(hp, Object.assign({ value: wa2 }, li2));
                          case "null":
                            return un.a.createElement(n_, li2);
                          case "nan":
                            return un.a.createElement(Lg2, li2);
                          case "undefined":
                            return un.a.createElement(Jm, li2);
                          case "date":
                            return un.a.createElement(ga, Object.assign({ value: new Date(wa2) }, li2));
                        }
                    }, dr.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, dr;
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this, dr = this.props, ji2 = dr.variable, qa2 = dr.singleIndent, wa2 = dr.type, li2 = dr.theme, jo = dr.namespace, Al = dr.indentWidth, Sf2 = dr.enableClipboard, sf2 = dr.onEdit, Vc2 = dr.onDelete, zu = dr.onSelect, ad2 = dr.displayArrayKey, Rg2 = dr.quotesOnKeys, bc2 = this.state.editMode;
                    return un.a.createElement("div", Object.assign({}, xa2(li2, "objectKeyVal", { paddingLeft: Al * qa2 }), { onMouseEnter: function() {
                      return sr.setState(Ve(Ve({}, sr.state), {}, { hovered: true }));
                    }, onMouseLeave: function() {
                      return sr.setState(Ve(Ve({}, sr.state), {}, { hovered: false }));
                    }, className: "variable-row", key: ji2.name }), wa2 == "array" ? ad2 ? un.a.createElement("span", Object.assign({}, xa2(li2, "array-key"), { key: ji2.name + "_" + jo }), ji2.name, un.a.createElement("div", xa2(li2, "colon"), ":")) : null : un.a.createElement("span", null, un.a.createElement("span", Object.assign({}, xa2(li2, "object-name"), { className: "object-key", key: ji2.name + "_" + jo }), !!Rg2 && un.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), un.a.createElement("span", { style: { display: "inline-block" } }, ji2.name), !!Rg2 && un.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), un.a.createElement("span", xa2(li2, "colon"), ":")), un.a.createElement("div", Object.assign({ className: "variable-value", onClick: zu === false && sf2 === false ? null : function(Ng2) {
                      var pm = vh2(jo);
                      (Ng2.ctrlKey || Ng2.metaKey) && sf2 !== false ? sr.prepopInput(ji2) : zu !== false && (pm.shift(), zu(Ve(Ve({}, ji2), {}, { namespace: pm })));
                    } }, xa2(li2, "variableValue", { cursor: zu === false ? "default" : "pointer" })), this.getValue(ji2, bc2)), Sf2 ? un.a.createElement(O0, { rowHovered: this.state.hovered, hidden: bc2, src: ji2.value, clickCallback: Sf2, theme: li2, namespace: [].concat(vh2(jo), [ji2.name]) }) : null, sf2 !== false && bc2 == 0 ? this.getEditIcon() : null, Vc2 !== false && bc2 == 0 ? this.getRemoveIcon() : null);
                  } }]), gn;
                }(un.a.PureComponent), i_ = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    var sr;
                    pn(this, gn);
                    for (var dr = arguments.length, ji2 = new Array(dr), qa2 = 0; qa2 < dr; qa2++)
                      ji2[qa2] = arguments[qa2];
                    return (sr = Mr.call.apply(Mr, [this].concat(ji2))).getObjectSize = function() {
                      var wa2 = sr.props, li2 = wa2.size, jo = wa2.theme;
                      if (wa2.displayObjectSize)
                        return un.a.createElement("span", Object.assign({ className: "object-size" }, xa2(jo, "object-size")), li2, " item", li2 === 1 ? "" : "s");
                    }, sr.getAddAttribute = function(wa2) {
                      var li2 = sr.props, jo = li2.theme, Al = li2.namespace, Sf2 = li2.name, sf2 = li2.src, Vc2 = li2.rjvId, zu = li2.depth;
                      return un.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: wa2 ? "inline-block" : "none" } }, un.a.createElement(fm, Object.assign({ className: "click-to-add-icon" }, xa2(jo, "addVarIcon"), { onClick: function() {
                        var ad2 = { name: zu > 0 ? Sf2 : null, namespace: Al.splice(0, Al.length - 1), existing_value: sf2, variable_removed: false, key_name: null };
                        Zi2(sf2) === "object" ? mc2.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Vc2, data: ad2 }) : mc2.dispatch({ name: "VARIABLE_ADDED", rjvId: Vc2, data: Ve(Ve({}, ad2), {}, { new_value: [].concat(vh2(sf2), [null]) }) });
                      } })));
                    }, sr.getRemoveObject = function(wa2) {
                      var li2 = sr.props, jo = li2.theme, Al = (li2.hover, li2.namespace), Sf2 = li2.name, sf2 = li2.src, Vc2 = li2.rjvId;
                      if (Al.length !== 1)
                        return un.a.createElement("span", { className: "click-to-remove", style: { display: wa2 ? "inline-block" : "none" } }, un.a.createElement(cm, Object.assign({ className: "click-to-remove-icon" }, xa2(jo, "removeVarIcon"), { onClick: function() {
                          mc2.dispatch({ name: "VARIABLE_REMOVED", rjvId: Vc2, data: { name: Sf2, namespace: Al.splice(0, Al.length - 1), existing_value: sf2, variable_removed: true } });
                        } })));
                    }, sr.render = function() {
                      var wa2 = sr.props, li2 = wa2.theme, jo = wa2.onDelete, Al = wa2.onAdd, Sf2 = wa2.enableClipboard, sf2 = wa2.src, Vc2 = wa2.namespace, zu = wa2.rowHovered;
                      return un.a.createElement("div", Object.assign({}, xa2(li2, "object-meta-data"), { className: "object-meta-data", onClick: function(ad2) {
                        ad2.stopPropagation();
                      } }), sr.getObjectSize(), Sf2 ? un.a.createElement(O0, { rowHovered: zu, clickCallback: Sf2, src: sf2, theme: li2, namespace: Vc2 }) : null, Al !== false ? sr.getAddAttribute(zu) : null, jo !== false ? sr.getRemoveObject(zu) : null);
                    }, sr;
                  }
                  return gn;
                }(un.a.PureComponent);
                function X1(ir) {
                  var Mr = ir.parent_type, gn = ir.namespace, sr = ir.quotesOnKeys, dr = ir.theme, ji2 = ir.jsvRoot, qa2 = ir.name, wa2 = ir.displayArrayKey, li2 = ir.name ? ir.name : "";
                  return !ji2 || qa2 !== false && qa2 !== null ? Mr == "array" ? wa2 ? un.a.createElement("span", Object.assign({}, xa2(dr, "array-key"), { key: gn }), un.a.createElement("span", { className: "array-key" }, li2), un.a.createElement("span", xa2(dr, "colon"), ":")) : un.a.createElement("span", null) : un.a.createElement("span", Object.assign({}, xa2(dr, "object-name"), { key: gn }), un.a.createElement("span", { className: "object-key" }, sr && un.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), un.a.createElement("span", null, li2), sr && un.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), un.a.createElement("span", xa2(dr, "colon"), ":")) : un.a.createElement("span", null);
                }
                function Q1(ir) {
                  var Mr = ir.theme;
                  switch (ir.iconStyle) {
                    case "triangle":
                      return un.a.createElement(Fh2, Object.assign({}, xa2(Mr, "expanded-icon"), { className: "expanded-icon" }));
                    case "square":
                      return un.a.createElement(Dp, Object.assign({}, xa2(Mr, "expanded-icon"), { className: "expanded-icon" }));
                    default:
                      return un.a.createElement(Yc2, Object.assign({}, xa2(Mr, "expanded-icon"), { className: "expanded-icon" }));
                  }
                }
                function a_(ir) {
                  var Mr = ir.theme;
                  switch (ir.iconStyle) {
                    case "triangle":
                      return un.a.createElement(tp, Object.assign({}, xa2(Mr, "collapsed-icon"), { className: "collapsed-icon" }));
                    case "square":
                      return un.a.createElement(Og2, Object.assign({}, xa2(Mr, "collapsed-icon"), { className: "collapsed-icon" }));
                    default:
                      return un.a.createElement(Kc2, Object.assign({}, xa2(Mr, "collapsed-icon"), { className: "collapsed-icon" }));
                  }
                }
                var mT = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    return pn(this, gn), (dr = Mr.call(this, sr)).toggleCollapsed = function(ji2) {
                      var qa2 = [];
                      for (var wa2 in dr.state.expanded)
                        qa2.push(dr.state.expanded[wa2]);
                      qa2[ji2] = !qa2[ji2], dr.setState({ expanded: qa2 });
                    }, dr.state = { expanded: [] }, dr;
                  }
                  return Gn(gn, [{ key: "getExpandedIcon", value: function(sr) {
                    var dr = this.props, ji2 = dr.theme, qa2 = dr.iconStyle;
                    return this.state.expanded[sr] ? un.a.createElement(Q1, { theme: ji2, iconStyle: qa2 }) : un.a.createElement(a_, { theme: ji2, iconStyle: qa2 });
                  } }, { key: "render", value: function() {
                    var sr = this, dr = this.props, ji2 = dr.src, qa2 = dr.groupArraysAfterLength, wa2 = (dr.depth, dr.name), li2 = dr.theme, jo = dr.jsvRoot, Al = dr.namespace, Sf2 = (dr.parent_type, Oi2(dr, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), sf2 = 0, Vc2 = 5 * this.props.indentWidth;
                    jo || (sf2 = 5 * this.props.indentWidth);
                    var zu = qa2, ad2 = Math.ceil(ji2.length / zu);
                    return un.a.createElement("div", Object.assign({ className: "object-key-val" }, xa2(li2, jo ? "jsv-root" : "objectKeyVal", { paddingLeft: sf2 })), un.a.createElement(X1, this.props), un.a.createElement("span", null, un.a.createElement(i_, Object.assign({ size: ji2.length }, this.props))), vh2(Array(ad2)).map(function(Rg2, bc2) {
                      return un.a.createElement("div", Object.assign({ key: bc2, className: "object-key-val array-group" }, xa2(li2, "objectKeyVal", { marginLeft: 6, paddingLeft: Vc2 })), un.a.createElement("span", xa2(li2, "brace-row"), un.a.createElement("div", Object.assign({ className: "icon-container" }, xa2(li2, "icon-container"), { onClick: function(Ng2) {
                        sr.toggleCollapsed(bc2);
                      } }), sr.getExpandedIcon(bc2)), sr.state.expanded[bc2] ? un.a.createElement(_T, Object.assign({ key: wa2 + bc2, depth: 0, name: false, collapsed: false, groupArraysAfterLength: zu, index_offset: bc2 * zu, src: ji2.slice(bc2 * zu, bc2 * zu + zu), namespace: Al, type: "array", parent_type: "array_group", theme: li2 }, Sf2)) : un.a.createElement("span", Object.assign({}, xa2(li2, "brace"), { onClick: function(Ng2) {
                        sr.toggleCollapsed(bc2);
                      }, className: "array-group-brace" }), "[", un.a.createElement("div", Object.assign({}, xa2(li2, "array-group-meta-data"), { className: "array-group-meta-data" }), un.a.createElement("span", Object.assign({ className: "object-size" }, xa2(li2, "object-size")), bc2 * zu, " - ", bc2 * zu + zu > ji2.length ? ji2.length : bc2 * zu + zu)), "]")));
                    }));
                  } }]), gn;
                }(un.a.PureComponent), bT = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    pn(this, gn), (dr = Mr.call(this, sr)).toggleCollapsed = function() {
                      dr.setState({ expanded: !dr.state.expanded }, function() {
                        Gf2.set(dr.props.rjvId, dr.props.namespace, "expanded", dr.state.expanded);
                      });
                    }, dr.getObjectContent = function(qa2, wa2, li2) {
                      return un.a.createElement("div", { className: "pushed-content object-container" }, un.a.createElement("div", Object.assign({ className: "object-content" }, xa2(dr.props.theme, "pushed-content")), dr.renderObjectContents(wa2, li2)));
                    }, dr.getEllipsis = function() {
                      return dr.state.size === 0 ? null : un.a.createElement("div", Object.assign({}, xa2(dr.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: dr.toggleCollapsed }), "...");
                    }, dr.getObjectMetaData = function(qa2) {
                      var wa2 = dr.props, li2 = (wa2.rjvId, wa2.theme, dr.state), jo = li2.size, Al = li2.hovered;
                      return un.a.createElement(i_, Object.assign({ rowHovered: Al, size: jo }, dr.props));
                    }, dr.renderObjectContents = function(qa2, wa2) {
                      var li2, jo = dr.props, Al = jo.depth, Sf2 = jo.parent_type, sf2 = jo.index_offset, Vc2 = jo.groupArraysAfterLength, zu = jo.namespace, ad2 = dr.state.object_type, Rg2 = [], bc2 = Object.keys(qa2 || {});
                      return dr.props.sortKeys && ad2 !== "array" && (bc2 = bc2.sort()), bc2.forEach(function(Ng2) {
                        if (li2 = new $R(Ng2, qa2[Ng2]), Sf2 === "array_group" && sf2 && (li2.name = parseInt(li2.name) + sf2), qa2.hasOwnProperty(Ng2))
                          if (li2.type === "object")
                            Rg2.push(un.a.createElement(_T, Object.assign({ key: li2.name, depth: Al + 1, name: li2.name, src: li2.value, namespace: zu.concat(li2.name), parent_type: ad2 }, wa2)));
                          else if (li2.type === "array") {
                            var pm = _T;
                            Vc2 && li2.value.length > Vc2 && (pm = mT), Rg2.push(un.a.createElement(pm, Object.assign({ key: li2.name, depth: Al + 1, name: li2.name, src: li2.value, namespace: zu.concat(li2.name), type: "array", parent_type: ad2 }, wa2)));
                          } else
                            Rg2.push(un.a.createElement(hm, Object.assign({ key: li2.name + "_" + zu, variable: li2, singleIndent: 5, namespace: zu, type: dr.props.type }, wa2)));
                      }), Rg2;
                    };
                    var ji2 = gn.getState(sr);
                    return dr.state = Ve(Ve({}, ji2), {}, { prevProps: {} }), dr;
                  }
                  return Gn(gn, [{ key: "getBraceStart", value: function(sr, dr) {
                    var ji2 = this, qa2 = this.props, wa2 = qa2.src, li2 = qa2.theme, jo = qa2.iconStyle;
                    if (qa2.parent_type === "array_group")
                      return un.a.createElement("span", null, un.a.createElement("span", xa2(li2, "brace"), sr === "array" ? "[" : "{"), dr ? this.getObjectMetaData(wa2) : null);
                    var Al = dr ? Q1 : a_;
                    return un.a.createElement("span", null, un.a.createElement("span", Object.assign({ onClick: function(Sf2) {
                      ji2.toggleCollapsed();
                    } }, xa2(li2, "brace-row")), un.a.createElement("div", Object.assign({ className: "icon-container" }, xa2(li2, "icon-container")), un.a.createElement(Al, { theme: li2, iconStyle: jo })), un.a.createElement(X1, this.props), un.a.createElement("span", xa2(li2, "brace"), sr === "array" ? "[" : "{")), dr ? this.getObjectMetaData(wa2) : null);
                  } }, { key: "render", value: function() {
                    var sr = this, dr = this.props, ji2 = dr.depth, qa2 = dr.src, wa2 = (dr.namespace, dr.name, dr.type, dr.parent_type), li2 = dr.theme, jo = dr.jsvRoot, Al = dr.iconStyle, Sf2 = Oi2(dr, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), sf2 = this.state, Vc2 = sf2.object_type, zu = sf2.expanded, ad2 = {};
                    return jo || wa2 === "array_group" ? wa2 === "array_group" && (ad2.borderLeft = 0, ad2.display = "inline") : ad2.paddingLeft = 5 * this.props.indentWidth, un.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                      return sr.setState(Ve(Ve({}, sr.state), {}, { hovered: true }));
                    }, onMouseLeave: function() {
                      return sr.setState(Ve(Ve({}, sr.state), {}, { hovered: false }));
                    } }, xa2(li2, jo ? "jsv-root" : "objectKeyVal", ad2)), this.getBraceStart(Vc2, zu), zu ? this.getObjectContent(ji2, qa2, Ve({ theme: li2, iconStyle: Al }, Sf2)) : this.getEllipsis(), un.a.createElement("span", { className: "brace-row" }, un.a.createElement("span", { style: Ve(Ve({}, xa2(li2, "brace").style), {}, { paddingLeft: zu ? "3px" : "0px" }) }, Vc2 === "array" ? "]" : "}"), zu ? null : this.getObjectMetaData(qa2)));
                  } }], [{ key: "getDerivedStateFromProps", value: function(sr, dr) {
                    var ji2 = dr.prevProps;
                    return sr.src !== ji2.src || sr.collapsed !== ji2.collapsed || sr.name !== ji2.name || sr.namespace !== ji2.namespace || sr.rjvId !== ji2.rjvId ? Ve(Ve({}, gn.getState(sr)), {}, { prevProps: sr }) : null;
                  } }]), gn;
                }(un.a.PureComponent);
                bT.getState = function(ir) {
                  var Mr = Object.keys(ir.src).length, gn = (ir.collapsed === false || ir.collapsed !== true && ir.collapsed > ir.depth) && (!ir.shouldCollapse || ir.shouldCollapse({ name: ir.name, src: ir.src, type: Zi2(ir.src), namespace: ir.namespace }) === false) && Mr !== 0;
                  return { expanded: Gf2.get(ir.rjvId, ir.namespace, "expanded", gn), object_type: ir.type === "array" ? "array" : "object", parent_type: ir.type === "array" ? "array" : "object", size: Mr, hovered: false };
                };
                var $R = function ir(Mr, gn) {
                  pn(this, ir), this.name = Mr, this.value = gn, this.type = Zi2(gn);
                };
                Aa2(bT);
                var _T = bT, Hk = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    var sr;
                    pn(this, gn);
                    for (var dr = arguments.length, ji2 = new Array(dr), qa2 = 0; qa2 < dr; qa2++)
                      ji2[qa2] = arguments[qa2];
                    return (sr = Mr.call.apply(Mr, [this].concat(ji2))).render = function() {
                      var wa2 = oi2(sr).props, li2 = [wa2.name], jo = _T;
                      return Array.isArray(wa2.src) && wa2.groupArraysAfterLength && wa2.src.length > wa2.groupArraysAfterLength && (jo = mT), un.a.createElement("div", { className: "pretty-json-container object-container" }, un.a.createElement("div", { className: "object-content" }, un.a.createElement(jo, Object.assign({ namespace: li2, depth: 0, jsvRoot: true }, wa2))));
                    }, sr;
                  }
                  return gn;
                }(un.a.PureComponent), YR = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    return pn(this, gn), (dr = Mr.call(this, sr)).closeModal = function() {
                      mc2.dispatch({ rjvId: dr.props.rjvId, name: "RESET" });
                    }, dr.submit = function() {
                      dr.props.submit(dr.state.input);
                    }, dr.state = { input: sr.input ? sr.input : "" }, dr;
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this, dr = this.props, ji2 = dr.theme, qa2 = dr.rjvId, wa2 = dr.isValid, li2 = this.state.input, jo = wa2(li2);
                    return un.a.createElement("div", Object.assign({ className: "key-modal-request" }, xa2(ji2, "key-modal-request"), { onClick: this.closeModal }), un.a.createElement("div", Object.assign({}, xa2(ji2, "key-modal"), { onClick: function(Al) {
                      Al.stopPropagation();
                    } }), un.a.createElement("div", xa2(ji2, "key-modal-label"), "Key Name:"), un.a.createElement("div", { style: { position: "relative" } }, un.a.createElement("input", Object.assign({}, xa2(ji2, "key-modal-input"), { className: "key-modal-input", ref: function(Al) {
                      return Al && Al.focus();
                    }, spellCheck: false, value: li2, placeholder: "...", onChange: function(Al) {
                      sr.setState({ input: Al.target.value });
                    }, onKeyPress: function(Al) {
                      jo && Al.key === "Enter" ? sr.submit() : Al.key === "Escape" && sr.closeModal();
                    } })), jo ? un.a.createElement(tg2, Object.assign({}, xa2(ji2, "key-modal-submit"), { className: "key-modal-submit", onClick: function(Al) {
                      return sr.submit();
                    } })) : null), un.a.createElement("span", xa2(ji2, "key-modal-cancel"), un.a.createElement(nS, Object.assign({}, xa2(ji2, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                      mc2.dispatch({ rjvId: qa2, name: "RESET" });
                    } })))));
                  } }]), gn;
                }(un.a.PureComponent), Q3 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    var sr;
                    pn(this, gn);
                    for (var dr = arguments.length, ji2 = new Array(dr), qa2 = 0; qa2 < dr; qa2++)
                      ji2[qa2] = arguments[qa2];
                    return (sr = Mr.call.apply(Mr, [this].concat(ji2))).isValid = function(wa2) {
                      var li2 = sr.props.rjvId, jo = Gf2.get(li2, "action", "new-key-request");
                      return wa2 != "" && Object.keys(jo.existing_value).indexOf(wa2) === -1;
                    }, sr.submit = function(wa2) {
                      var li2 = sr.props.rjvId, jo = Gf2.get(li2, "action", "new-key-request");
                      jo.new_value = Ve({}, jo.existing_value), jo.new_value[wa2] = sr.props.defaultValue, mc2.dispatch({ name: "VARIABLE_ADDED", rjvId: li2, data: jo });
                    }, sr;
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.active, ji2 = sr.theme, qa2 = sr.rjvId;
                    return dr ? un.a.createElement(YR, { rjvId: qa2, theme: ji2, isValid: this.isValid, submit: this.submit }) : null;
                  } }]), gn;
                }(un.a.PureComponent), O9 = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn() {
                    return pn(this, gn), Mr.apply(this, arguments);
                  }
                  return Gn(gn, [{ key: "render", value: function() {
                    var sr = this.props, dr = sr.message, ji2 = sr.active, qa2 = sr.theme, wa2 = sr.rjvId;
                    return ji2 ? un.a.createElement("div", Object.assign({ className: "validation-failure" }, xa2(qa2, "validation-failure"), { onClick: function() {
                      mc2.dispatch({ rjvId: wa2, name: "RESET" });
                    } }), un.a.createElement("span", xa2(qa2, "validation-failure-label"), dr), un.a.createElement(nS, xa2(qa2, "validation-failure-clear"))) : null;
                  } }]), gn;
                }(un.a.PureComponent), OM = function(ir) {
                  Wr(gn, ir);
                  var Mr = Ca2(gn);
                  function gn(sr) {
                    var dr;
                    return pn(this, gn), (dr = Mr.call(this, sr)).rjvId = Date.now().toString(), dr.getListeners = function() {
                      return { reset: dr.resetState, "variable-update": dr.updateSrc, "add-key-request": dr.addKeyRequest };
                    }, dr.updateSrc = function() {
                      var ji2, qa2 = Gf2.get(dr.rjvId, "action", "variable-update"), wa2 = qa2.name, li2 = qa2.namespace, jo = qa2.new_value, Al = qa2.existing_value, Sf2 = (qa2.variable_removed, qa2.updated_src), sf2 = qa2.type, Vc2 = dr.props, zu = Vc2.onEdit, ad2 = Vc2.onDelete, Rg2 = Vc2.onAdd, bc2 = { existing_src: dr.state.src, new_value: jo, updated_src: Sf2, name: wa2, namespace: li2, existing_value: Al };
                      switch (sf2) {
                        case "variable-added":
                          ji2 = Rg2(bc2);
                          break;
                        case "variable-edited":
                          ji2 = zu(bc2);
                          break;
                        case "variable-removed":
                          ji2 = ad2(bc2);
                      }
                      ji2 !== false ? (Gf2.set(dr.rjvId, "global", "src", Sf2), dr.setState({ src: Sf2 })) : dr.setState({ validationFailure: true });
                    }, dr.addKeyRequest = function() {
                      dr.setState({ addKeyRequest: true });
                    }, dr.resetState = function() {
                      dr.setState({ validationFailure: false, addKeyRequest: false });
                    }, dr.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: gn.defaultProps.src, name: gn.defaultProps.name, theme: gn.defaultProps.theme, validationMessage: gn.defaultProps.validationMessage, prevSrc: gn.defaultProps.src, prevName: gn.defaultProps.name, prevTheme: gn.defaultProps.theme }, dr;
                  }
                  return Gn(gn, [{ key: "componentDidMount", value: function() {
                    Gf2.set(this.rjvId, "global", "src", this.state.src);
                    var sr = this.getListeners();
                    for (var dr in sr)
                      Gf2.on(dr + "-" + this.rjvId, sr[dr]);
                    this.setState({ addKeyRequest: false, editKeyRequest: false });
                  } }, { key: "componentDidUpdate", value: function(sr, dr) {
                    dr.addKeyRequest !== false && this.setState({ addKeyRequest: false }), dr.editKeyRequest !== false && this.setState({ editKeyRequest: false }), sr.src !== this.state.src && Gf2.set(this.rjvId, "global", "src", this.state.src);
                  } }, { key: "componentWillUnmount", value: function() {
                    var sr = this.getListeners();
                    for (var dr in sr)
                      Gf2.removeListener(dr + "-" + this.rjvId, sr[dr]);
                  } }, { key: "render", value: function() {
                    var sr = this.state, dr = sr.validationFailure, ji2 = sr.validationMessage, qa2 = sr.addKeyRequest, wa2 = sr.theme, li2 = sr.src, jo = sr.name, Al = this.props, Sf2 = Al.style, sf2 = Al.defaultValue;
                    return un.a.createElement("div", { className: "react-json-view", style: Ve(Ve({}, xa2(wa2, "app-container").style), Sf2) }, un.a.createElement(O9, { message: ji2, active: dr, theme: wa2, rjvId: this.rjvId }), un.a.createElement(Hk, Object.assign({}, this.props, { src: li2, name: jo, theme: wa2, type: Zi2(li2), rjvId: this.rjvId })), un.a.createElement(Q3, { active: qa2, theme: wa2, rjvId: this.rjvId, defaultValue: sf2 }));
                  } }], [{ key: "getDerivedStateFromProps", value: function(sr, dr) {
                    if (sr.src !== dr.prevSrc || sr.name !== dr.prevName || sr.theme !== dr.prevTheme) {
                      var ji2 = { src: sr.src, name: sr.name, theme: sr.theme, validationMessage: sr.validationMessage, prevSrc: sr.src, prevName: sr.name, prevTheme: sr.theme };
                      return gn.validateState(ji2);
                    }
                    return null;
                  } }]), gn;
                }(un.a.PureComponent);
                OM.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, OM.validateState = function(ir) {
                  var Mr = {};
                  return Zi2(ir.theme) !== "object" || function(gn) {
                    var sr = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                    if (Zi2(gn) === "object") {
                      for (var dr = 0; dr < sr.length; dr++)
                        if (!(sr[dr] in gn))
                          return false;
                      return true;
                    }
                    return false;
                  }(ir.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Mr.theme = "rjv-default"), Zi2(ir.src) !== "object" && Zi2(ir.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Mr.name = "ERROR", Mr.src = { message: "src property must be a valid json object" }), Ve(Ve({}, ir), Mr);
                }, Aa2(OM), Zt.default = OM;
              }]);
            });
          })(DQ);
          var cAt = mt(DQ.exports);
          const ght = ({ id: Bt, title: ge2, chart: Ht, option: qt }) => {
            const { tool: Zt } = Ir({}), oe2 = Ot({ global: true }), [Ne2, { set: Ge2 }] = we2(true);
            console.log("option", qt);
            const Ve = (pn) => {
              const { updated_src: vn } = pn;
              Ht == null || Ht.setOption(vn), Zt == null || Zt.add(Bt, Ht, vn, ge2), oe2.emit("list");
            };
            return hht("div", { children: [ZR(M$t, { children: ZR(sAt, { children: ZR(dht, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (pn) => {
              Ge2(!pn);
            } }) }) }), ZR("br", {}), qt && ZR(cAt, { src: qt, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: Ne2, iconStyle: "triangle", enableClipboard: true, onEdit: Ve, onAdd: Ve, onDelete: Ve })] });
          };
          c5.EchartTool = uAt, c5.ReactEchartsJson = ght, c5.useEchartsTool = Ir, c5.useEventEmitter = Ot;
        })(Yer);
        const Ker = () => {
          const c5 = GCt({ global: true }), s = O2.useRef(0), { tool: r5 } = Rqt({});
          O2.useState(false), O2.useState("right");
          const [g5, b6] = O2.useState([]), [S2, A2] = O2.useState();
          return c5.useSubscription("list", () => {
            var k2;
            r5 != null && r5.list().length && (A2((k2 = r5 == null ? void 0 : r5.list()) == null ? void 0 : k2[s.current]), b6(r5 == null ? void 0 : r5.list()));
          }), $X("div", { className: $er.container, children: false });
        };
        var Y4e = { exports: {} };
        (function(c5, s) {
          (function(r5, g5) {
            c5.exports = g5(q3.default);
          })(tn, function(r5) {
            return function(g5) {
              var b6 = {};
              function S2(A2) {
                if (b6[A2])
                  return b6[A2].exports;
                var k2 = b6[A2] = { i: A2, l: false, exports: {} };
                return g5[A2].call(k2.exports, k2, k2.exports, S2), k2.l = true, k2.exports;
              }
              return S2.m = g5, S2.c = b6, S2.d = function(A2, k2, R6) {
                S2.o(A2, k2) || Object.defineProperty(A2, k2, { enumerable: true, get: R6 });
              }, S2.r = function(A2) {
                typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(A2, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(A2, "__esModule", { value: true });
              }, S2.t = function(A2, k2) {
                if (1 & k2 && (A2 = S2(A2)), 8 & k2 || 4 & k2 && typeof A2 == "object" && A2 && A2.__esModule)
                  return A2;
                var R6 = /* @__PURE__ */ Object.create(null);
                if (S2.r(R6), Object.defineProperty(R6, "default", { enumerable: true, value: A2 }), 2 & k2 && typeof A2 != "string")
                  for (var B3 in A2)
                    S2.d(R6, B3, function(G3) {
                      return A2[G3];
                    }.bind(null, B3));
                return R6;
              }, S2.n = function(A2) {
                var k2 = A2 && A2.__esModule ? function() {
                  return A2.default;
                } : function() {
                  return A2;
                };
                return S2.d(k2, "a", k2), k2;
              }, S2.o = function(A2, k2) {
                return Object.prototype.hasOwnProperty.call(A2, k2);
              }, S2.p = "", S2(S2.s = 48);
            }([function(g5, b6) {
              g5.exports = r5;
            }, function(g5, b6) {
              var S2 = g5.exports = { version: "2.6.12" };
              typeof __e == "number" && (__e = S2);
            }, function(g5, b6, S2) {
              var A2 = S2(26)("wks"), k2 = S2(17), R6 = S2(3).Symbol, B3 = typeof R6 == "function";
              (g5.exports = function(G3) {
                return A2[G3] || (A2[G3] = B3 && R6[G3] || (B3 ? R6 : k2)("Symbol." + G3));
              }).store = A2;
            }, function(g5, b6) {
              var S2 = g5.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
              typeof __g == "number" && (__g = S2);
            }, function(g5, b6, S2) {
              g5.exports = !S2(8)(function() {
                return Object.defineProperty({}, "a", { get: function() {
                  return 7;
                } }).a != 7;
              });
            }, function(g5, b6) {
              var S2 = {}.hasOwnProperty;
              g5.exports = function(A2, k2) {
                return S2.call(A2, k2);
              };
            }, function(g5, b6, S2) {
              var A2 = S2(7), k2 = S2(16);
              g5.exports = S2(4) ? function(R6, B3, G3) {
                return A2.f(R6, B3, k2(1, G3));
              } : function(R6, B3, G3) {
                return R6[B3] = G3, R6;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(10), k2 = S2(35), R6 = S2(23), B3 = Object.defineProperty;
              b6.f = S2(4) ? Object.defineProperty : function(G3, Z3, X3) {
                if (A2(G3), Z3 = R6(Z3, true), A2(X3), k2)
                  try {
                    return B3(G3, Z3, X3);
                  } catch {
                  }
                if ("get" in X3 || "set" in X3)
                  throw TypeError("Accessors not supported!");
                return "value" in X3 && (G3[Z3] = X3.value), G3;
              };
            }, function(g5, b6) {
              g5.exports = function(S2) {
                try {
                  return !!S2();
                } catch {
                  return true;
                }
              };
            }, function(g5, b6, S2) {
              var A2 = S2(40), k2 = S2(22);
              g5.exports = function(R6) {
                return A2(k2(R6));
              };
            }, function(g5, b6, S2) {
              var A2 = S2(11);
              g5.exports = function(k2) {
                if (!A2(k2))
                  throw TypeError(k2 + " is not an object!");
                return k2;
              };
            }, function(g5, b6) {
              g5.exports = function(S2) {
                return typeof S2 == "object" ? S2 !== null : typeof S2 == "function";
              };
            }, function(g5, b6) {
              g5.exports = {};
            }, function(g5, b6, S2) {
              var A2 = S2(39), k2 = S2(27);
              g5.exports = Object.keys || function(R6) {
                return A2(R6, k2);
              };
            }, function(g5, b6) {
              g5.exports = true;
            }, function(g5, b6, S2) {
              var A2 = S2(3), k2 = S2(1), R6 = S2(53), B3 = S2(6), G3 = S2(5), Z3 = function(X3, tt, it) {
                var pt, mt, Mt, kt = X3 & Z3.F, Gt = X3 & Z3.G, Ot = X3 & Z3.S, ce2 = X3 & Z3.P, ae2 = X3 & Z3.B, de2 = X3 & Z3.W, we2 = Gt ? k2 : k2[tt] || (k2[tt] = {}), Se2 = we2.prototype, Oe2 = Gt ? A2 : Ot ? A2[tt] : (A2[tt] || {}).prototype;
                for (pt in Gt && (it = tt), it)
                  (mt = !kt && Oe2 && Oe2[pt] !== void 0) && G3(we2, pt) || (Mt = mt ? Oe2[pt] : it[pt], we2[pt] = Gt && typeof Oe2[pt] != "function" ? it[pt] : ae2 && mt ? R6(Mt, A2) : de2 && Oe2[pt] == Mt ? function(je2) {
                    var rn = function(qe2, An, jn) {
                      if (this instanceof je2) {
                        switch (arguments.length) {
                          case 0:
                            return new je2();
                          case 1:
                            return new je2(qe2);
                          case 2:
                            return new je2(qe2, An);
                        }
                        return new je2(qe2, An, jn);
                      }
                      return je2.apply(this, arguments);
                    };
                    return rn.prototype = je2.prototype, rn;
                  }(Mt) : ce2 && typeof Mt == "function" ? R6(Function.call, Mt) : Mt, ce2 && ((we2.virtual || (we2.virtual = {}))[pt] = Mt, X3 & Z3.R && Se2 && !Se2[pt] && B3(Se2, pt, Mt)));
              };
              Z3.F = 1, Z3.G = 2, Z3.S = 4, Z3.P = 8, Z3.B = 16, Z3.W = 32, Z3.U = 64, Z3.R = 128, g5.exports = Z3;
            }, function(g5, b6) {
              g5.exports = function(S2, A2) {
                return { enumerable: !(1 & S2), configurable: !(2 & S2), writable: !(4 & S2), value: A2 };
              };
            }, function(g5, b6) {
              var S2 = 0, A2 = Math.random();
              g5.exports = function(k2) {
                return "Symbol(".concat(k2 === void 0 ? "" : k2, ")_", (++S2 + A2).toString(36));
              };
            }, function(g5, b6, S2) {
              var A2 = S2(22);
              g5.exports = function(k2) {
                return Object(A2(k2));
              };
            }, function(g5, b6) {
              b6.f = {}.propertyIsEnumerable;
            }, function(g5, b6, S2) {
              var A2 = S2(52)(true);
              S2(34)(String, "String", function(k2) {
                this._t = String(k2), this._i = 0;
              }, function() {
                var k2, R6 = this._t, B3 = this._i;
                return B3 >= R6.length ? { value: void 0, done: true } : (k2 = A2(R6, B3), this._i += k2.length, { value: k2, done: false });
              });
            }, function(g5, b6) {
              var S2 = Math.ceil, A2 = Math.floor;
              g5.exports = function(k2) {
                return isNaN(k2 = +k2) ? 0 : (k2 > 0 ? A2 : S2)(k2);
              };
            }, function(g5, b6) {
              g5.exports = function(S2) {
                if (S2 == null)
                  throw TypeError("Can't call method on  " + S2);
                return S2;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(11);
              g5.exports = function(k2, R6) {
                if (!A2(k2))
                  return k2;
                var B3, G3;
                if (R6 && typeof (B3 = k2.toString) == "function" && !A2(G3 = B3.call(k2)) || typeof (B3 = k2.valueOf) == "function" && !A2(G3 = B3.call(k2)) || !R6 && typeof (B3 = k2.toString) == "function" && !A2(G3 = B3.call(k2)))
                  return G3;
                throw TypeError("Can't convert object to primitive value");
              };
            }, function(g5, b6) {
              var S2 = {}.toString;
              g5.exports = function(A2) {
                return S2.call(A2).slice(8, -1);
              };
            }, function(g5, b6, S2) {
              var A2 = S2(26)("keys"), k2 = S2(17);
              g5.exports = function(R6) {
                return A2[R6] || (A2[R6] = k2(R6));
              };
            }, function(g5, b6, S2) {
              var A2 = S2(1), k2 = S2(3), R6 = k2["__core-js_shared__"] || (k2["__core-js_shared__"] = {});
              (g5.exports = function(B3, G3) {
                return R6[B3] || (R6[B3] = G3 !== void 0 ? G3 : {});
              })("versions", []).push({ version: A2.version, mode: S2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
            }, function(g5, b6) {
              g5.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
            }, function(g5, b6, S2) {
              var A2 = S2(7).f, k2 = S2(5), R6 = S2(2)("toStringTag");
              g5.exports = function(B3, G3, Z3) {
                B3 && !k2(B3 = Z3 ? B3 : B3.prototype, R6) && A2(B3, R6, { configurable: true, value: G3 });
              };
            }, function(g5, b6, S2) {
              S2(62);
              for (var A2 = S2(3), k2 = S2(6), R6 = S2(12), B3 = S2(2)("toStringTag"), G3 = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), Z3 = 0; Z3 < G3.length; Z3++) {
                var X3 = G3[Z3], tt = A2[X3], it = tt && tt.prototype;
                it && !it[B3] && k2(it, B3, X3), R6[X3] = R6.Array;
              }
            }, function(g5, b6, S2) {
              b6.f = S2(2);
            }, function(g5, b6, S2) {
              var A2 = S2(3), k2 = S2(1), R6 = S2(14), B3 = S2(30), G3 = S2(7).f;
              g5.exports = function(Z3) {
                var X3 = k2.Symbol || (k2.Symbol = R6 ? {} : A2.Symbol || {});
                Z3.charAt(0) == "_" || Z3 in X3 || G3(X3, Z3, { value: B3.f(Z3) });
              };
            }, function(g5, b6) {
              b6.f = Object.getOwnPropertySymbols;
            }, function(g5, b6) {
              g5.exports = function(S2, A2, k2) {
                return Math.min(Math.max(S2, A2), k2);
              };
            }, function(g5, b6, S2) {
              var A2 = S2(14), k2 = S2(15), R6 = S2(37), B3 = S2(6), G3 = S2(12), Z3 = S2(55), X3 = S2(28), tt = S2(61), it = S2(2)("iterator"), pt = !([].keys && "next" in [].keys()), mt = function() {
                return this;
              };
              g5.exports = function(Mt, kt, Gt, Ot, ce2, ae2, de2) {
                Z3(Gt, kt, Ot);
                var we2, Se2, Oe2, je2 = function(Ar) {
                  if (!pt && Ar in jn)
                    return jn[Ar];
                  switch (Ar) {
                    case "keys":
                    case "values":
                      return function() {
                        return new Gt(this, Ar);
                      };
                  }
                  return function() {
                    return new Gt(this, Ar);
                  };
                }, rn = kt + " Iterator", qe2 = ce2 == "values", An = false, jn = Mt.prototype, _n = jn[it] || jn["@@iterator"] || ce2 && jn[ce2], Jr = _n || je2(ce2), Qn = ce2 ? qe2 ? je2("entries") : Jr : void 0, rr = kt == "Array" && jn.entries || _n;
                if (rr && (Oe2 = tt(rr.call(new Mt()))) !== Object.prototype && Oe2.next && (X3(Oe2, rn, true), A2 || typeof Oe2[it] == "function" || B3(Oe2, it, mt)), qe2 && _n && _n.name !== "values" && (An = true, Jr = function() {
                  return _n.call(this);
                }), A2 && !de2 || !pt && !An && jn[it] || B3(jn, it, Jr), G3[kt] = Jr, G3[rn] = mt, ce2)
                  if (we2 = { values: qe2 ? Jr : je2("values"), keys: ae2 ? Jr : je2("keys"), entries: Qn }, de2)
                    for (Se2 in we2)
                      Se2 in jn || R6(jn, Se2, we2[Se2]);
                  else
                    k2(k2.P + k2.F * (pt || An), kt, we2);
                return we2;
              };
            }, function(g5, b6, S2) {
              g5.exports = !S2(4) && !S2(8)(function() {
                return Object.defineProperty(S2(36)("div"), "a", { get: function() {
                  return 7;
                } }).a != 7;
              });
            }, function(g5, b6, S2) {
              var A2 = S2(11), k2 = S2(3).document, R6 = A2(k2) && A2(k2.createElement);
              g5.exports = function(B3) {
                return R6 ? k2.createElement(B3) : {};
              };
            }, function(g5, b6, S2) {
              g5.exports = S2(6);
            }, function(g5, b6, S2) {
              var A2 = S2(10), k2 = S2(56), R6 = S2(27), B3 = S2(25)("IE_PROTO"), G3 = function() {
              }, Z3 = function() {
                var X3, tt = S2(36)("iframe"), it = R6.length;
                for (tt.style.display = "none", S2(60).appendChild(tt), tt.src = "javascript:", (X3 = tt.contentWindow.document).open(), X3.write("<script>document.F=Object<\/script>"), X3.close(), Z3 = X3.F; it--; )
                  delete Z3.prototype[R6[it]];
                return Z3();
              };
              g5.exports = Object.create || function(X3, tt) {
                var it;
                return X3 !== null ? (G3.prototype = A2(X3), it = new G3(), G3.prototype = null, it[B3] = X3) : it = Z3(), tt === void 0 ? it : k2(it, tt);
              };
            }, function(g5, b6, S2) {
              var A2 = S2(5), k2 = S2(9), R6 = S2(57)(false), B3 = S2(25)("IE_PROTO");
              g5.exports = function(G3, Z3) {
                var X3, tt = k2(G3), it = 0, pt = [];
                for (X3 in tt)
                  X3 != B3 && A2(tt, X3) && pt.push(X3);
                for (; Z3.length > it; )
                  A2(tt, X3 = Z3[it++]) && (~R6(pt, X3) || pt.push(X3));
                return pt;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(24);
              g5.exports = Object("z").propertyIsEnumerable(0) ? Object : function(k2) {
                return A2(k2) == "String" ? k2.split("") : Object(k2);
              };
            }, function(g5, b6, S2) {
              var A2 = S2(39), k2 = S2(27).concat("length", "prototype");
              b6.f = Object.getOwnPropertyNames || function(R6) {
                return A2(R6, k2);
              };
            }, function(g5, b6, S2) {
              var A2 = S2(24), k2 = S2(2)("toStringTag"), R6 = A2(function() {
                return arguments;
              }()) == "Arguments";
              g5.exports = function(B3) {
                var G3, Z3, X3;
                return B3 === void 0 ? "Undefined" : B3 === null ? "Null" : typeof (Z3 = function(tt, it) {
                  try {
                    return tt[it];
                  } catch {
                  }
                }(G3 = Object(B3), k2)) == "string" ? Z3 : R6 ? A2(G3) : (X3 = A2(G3)) == "Object" && typeof G3.callee == "function" ? "Arguments" : X3;
              };
            }, function(g5, b6) {
              var S2;
              S2 = function() {
                return this;
              }();
              try {
                S2 = S2 || new Function("return this")();
              } catch {
                typeof window == "object" && (S2 = window);
              }
              g5.exports = S2;
            }, function(g5, b6) {
              var S2 = /-?\d+(\.\d+)?%?/g;
              g5.exports = function(A2) {
                return A2.match(S2);
              };
            }, function(g5, b6, S2) {
              Object.defineProperty(b6, "__esModule", { value: true }), b6.getBase16Theme = b6.createStyling = b6.invertTheme = void 0;
              var A2 = mt(S2(49)), k2 = mt(S2(76)), R6 = mt(S2(81)), B3 = mt(S2(89)), G3 = mt(S2(93)), Z3 = function(Se2) {
                if (Se2 && Se2.__esModule)
                  return Se2;
                var Oe2 = {};
                if (Se2 != null)
                  for (var je2 in Se2)
                    Object.prototype.hasOwnProperty.call(Se2, je2) && (Oe2[je2] = Se2[je2]);
                return Oe2.default = Se2, Oe2;
              }(S2(94)), X3 = mt(S2(132)), tt = mt(S2(133)), it = mt(S2(138)), pt = S2(139);
              function mt(Se2) {
                return Se2 && Se2.__esModule ? Se2 : { default: Se2 };
              }
              var Mt = Z3.default, kt = (0, B3.default)(Mt), Gt = (0, it.default)(tt.default, pt.rgb2yuv, function(Se2) {
                var Oe2, je2 = (0, R6.default)(Se2, 3), rn = je2[0], qe2 = je2[1], An = je2[2];
                return [(Oe2 = rn, Oe2 < 0.25 ? 1 : Oe2 < 0.5 ? 0.9 - Oe2 : 1.1 - Oe2), qe2, An];
              }, pt.yuv2rgb, X3.default), Ot = function(Se2) {
                return function(Oe2) {
                  return { className: [Oe2.className, Se2.className].filter(Boolean).join(" "), style: (0, k2.default)({}, Oe2.style || {}, Se2.style || {}) };
                };
              }, ce2 = function(Se2, Oe2) {
                var je2 = (0, B3.default)(Oe2);
                for (var rn in Se2)
                  je2.indexOf(rn) === -1 && je2.push(rn);
                return je2.reduce(function(qe2, An) {
                  return qe2[An] = function(jn, _n) {
                    if (jn === void 0)
                      return _n;
                    if (_n === void 0)
                      return jn;
                    var Jr = jn === void 0 ? "undefined" : (0, A2.default)(jn), Qn = _n === void 0 ? "undefined" : (0, A2.default)(_n);
                    switch (Jr) {
                      case "string":
                        switch (Qn) {
                          case "string":
                            return [_n, jn].filter(Boolean).join(" ");
                          case "object":
                            return Ot({ className: jn, style: _n });
                          case "function":
                            return function(rr) {
                              for (var Ar = arguments.length, fi2 = Array(Ar > 1 ? Ar - 1 : 0), mi2 = 1; mi2 < Ar; mi2++)
                                fi2[mi2 - 1] = arguments[mi2];
                              return Ot({ className: jn })(_n.apply(void 0, [rr].concat(fi2)));
                            };
                        }
                      case "object":
                        switch (Qn) {
                          case "string":
                            return Ot({ className: _n, style: jn });
                          case "object":
                            return (0, k2.default)({}, _n, jn);
                          case "function":
                            return function(rr) {
                              for (var Ar = arguments.length, fi2 = Array(Ar > 1 ? Ar - 1 : 0), mi2 = 1; mi2 < Ar; mi2++)
                                fi2[mi2 - 1] = arguments[mi2];
                              return Ot({ style: jn })(_n.apply(void 0, [rr].concat(fi2)));
                            };
                        }
                      case "function":
                        switch (Qn) {
                          case "string":
                            return function(rr) {
                              for (var Ar = arguments.length, fi2 = Array(Ar > 1 ? Ar - 1 : 0), mi2 = 1; mi2 < Ar; mi2++)
                                fi2[mi2 - 1] = arguments[mi2];
                              return jn.apply(void 0, [Ot(rr)({ className: _n })].concat(fi2));
                            };
                          case "object":
                            return function(rr) {
                              for (var Ar = arguments.length, fi2 = Array(Ar > 1 ? Ar - 1 : 0), mi2 = 1; mi2 < Ar; mi2++)
                                fi2[mi2 - 1] = arguments[mi2];
                              return jn.apply(void 0, [Ot(rr)({ style: _n })].concat(fi2));
                            };
                          case "function":
                            return function(rr) {
                              for (var Ar = arguments.length, fi2 = Array(Ar > 1 ? Ar - 1 : 0), mi2 = 1; mi2 < Ar; mi2++)
                                fi2[mi2 - 1] = arguments[mi2];
                              return jn.apply(void 0, [_n.apply(void 0, [rr].concat(fi2))].concat(fi2));
                            };
                        }
                    }
                  }(Se2[An], Oe2[An]), qe2;
                }, {});
              }, ae2 = function(Se2, Oe2) {
                for (var je2 = arguments.length, rn = Array(je2 > 2 ? je2 - 2 : 0), qe2 = 2; qe2 < je2; qe2++)
                  rn[qe2 - 2] = arguments[qe2];
                if (Oe2 === null)
                  return Se2;
                Array.isArray(Oe2) || (Oe2 = [Oe2]);
                var An = Oe2.map(function(_n) {
                  return Se2[_n];
                }).filter(Boolean), jn = An.reduce(function(_n, Jr) {
                  return typeof Jr == "string" ? _n.className = [_n.className, Jr].filter(Boolean).join(" ") : (Jr === void 0 ? "undefined" : (0, A2.default)(Jr)) === "object" ? _n.style = (0, k2.default)({}, _n.style, Jr) : typeof Jr == "function" && (_n = (0, k2.default)({}, _n, Jr.apply(void 0, [_n].concat(rn)))), _n;
                }, { className: "", style: {} });
                return jn.className || delete jn.className, (0, B3.default)(jn.style).length === 0 && delete jn.style, jn;
              }, de2 = b6.invertTheme = function(Se2) {
                return (0, B3.default)(Se2).reduce(function(Oe2, je2) {
                  return Oe2[je2] = /^base/.test(je2) ? Gt(Se2[je2]) : je2 === "scheme" ? Se2[je2] + ":inverted" : Se2[je2], Oe2;
                }, {});
              }, we2 = (b6.createStyling = (0, G3.default)(function(Se2) {
                for (var Oe2 = arguments.length, je2 = Array(Oe2 > 3 ? Oe2 - 3 : 0), rn = 3; rn < Oe2; rn++)
                  je2[rn - 3] = arguments[rn];
                var qe2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, An = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, jn = qe2.defaultBase16, _n = jn === void 0 ? Mt : jn, Jr = qe2.base16Themes, Qn = Jr === void 0 ? null : Jr, rr = we2(An, Qn);
                rr && (An = (0, k2.default)({}, rr, An));
                var Ar = kt.reduce(function(Ts, gl) {
                  return Ts[gl] = An[gl] || _n[gl], Ts;
                }, {}), fi2 = (0, B3.default)(An).reduce(function(Ts, gl) {
                  return kt.indexOf(gl) === -1 && (Ts[gl] = An[gl]), Ts;
                }, {}), mi2 = Se2(Ar), Oo = ce2(fi2, mi2);
                return (0, G3.default)(ae2, 2).apply(void 0, [Oo].concat(je2));
              }, 3), b6.getBase16Theme = function(Se2, Oe2) {
                if (Se2 && Se2.extend && (Se2 = Se2.extend), typeof Se2 == "string") {
                  var je2 = Se2.split(":"), rn = (0, R6.default)(je2, 2), qe2 = rn[0], An = rn[1];
                  Se2 = (Oe2 || {})[qe2] || Z3[qe2], An === "inverted" && (Se2 = de2(Se2));
                }
                return Se2 && Se2.hasOwnProperty("base00") ? Se2 : void 0;
              });
            }, function(g5, b6, S2) {
              var A2, k2 = typeof Reflect == "object" ? Reflect : null, R6 = k2 && typeof k2.apply == "function" ? k2.apply : function(Ot, ce2, ae2) {
                return Function.prototype.apply.call(Ot, ce2, ae2);
              };
              A2 = k2 && typeof k2.ownKeys == "function" ? k2.ownKeys : Object.getOwnPropertySymbols ? function(Ot) {
                return Object.getOwnPropertyNames(Ot).concat(Object.getOwnPropertySymbols(Ot));
              } : function(Ot) {
                return Object.getOwnPropertyNames(Ot);
              };
              var B3 = Number.isNaN || function(Ot) {
                return Ot != Ot;
              };
              function G3() {
                G3.init.call(this);
              }
              g5.exports = G3, g5.exports.once = function(Ot, ce2) {
                return new Promise(function(ae2, de2) {
                  function we2() {
                    Se2 !== void 0 && Ot.removeListener("error", Se2), ae2([].slice.call(arguments));
                  }
                  var Se2;
                  ce2 !== "error" && (Se2 = function(Oe2) {
                    Ot.removeListener(ce2, we2), de2(Oe2);
                  }, Ot.once("error", Se2)), Ot.once(ce2, we2);
                });
              }, G3.EventEmitter = G3, G3.prototype._events = void 0, G3.prototype._eventsCount = 0, G3.prototype._maxListeners = void 0;
              var Z3 = 10;
              function X3(Ot) {
                if (typeof Ot != "function")
                  throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof Ot);
              }
              function tt(Ot) {
                return Ot._maxListeners === void 0 ? G3.defaultMaxListeners : Ot._maxListeners;
              }
              function it(Ot, ce2, ae2, de2) {
                var we2, Se2, Oe2, je2;
                if (X3(ae2), (Se2 = Ot._events) === void 0 ? (Se2 = Ot._events = /* @__PURE__ */ Object.create(null), Ot._eventsCount = 0) : (Se2.newListener !== void 0 && (Ot.emit("newListener", ce2, ae2.listener ? ae2.listener : ae2), Se2 = Ot._events), Oe2 = Se2[ce2]), Oe2 === void 0)
                  Oe2 = Se2[ce2] = ae2, ++Ot._eventsCount;
                else if (typeof Oe2 == "function" ? Oe2 = Se2[ce2] = de2 ? [ae2, Oe2] : [Oe2, ae2] : de2 ? Oe2.unshift(ae2) : Oe2.push(ae2), (we2 = tt(Ot)) > 0 && Oe2.length > we2 && !Oe2.warned) {
                  Oe2.warned = true;
                  var rn = new Error("Possible EventEmitter memory leak detected. " + Oe2.length + " " + String(ce2) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                  rn.name = "MaxListenersExceededWarning", rn.emitter = Ot, rn.type = ce2, rn.count = Oe2.length, je2 = rn, console && console.warn && console.warn(je2);
                }
                return Ot;
              }
              function pt() {
                if (!this.fired)
                  return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
              }
              function mt(Ot, ce2, ae2) {
                var de2 = { fired: false, wrapFn: void 0, target: Ot, type: ce2, listener: ae2 }, we2 = pt.bind(de2);
                return we2.listener = ae2, de2.wrapFn = we2, we2;
              }
              function Mt(Ot, ce2, ae2) {
                var de2 = Ot._events;
                if (de2 === void 0)
                  return [];
                var we2 = de2[ce2];
                return we2 === void 0 ? [] : typeof we2 == "function" ? ae2 ? [we2.listener || we2] : [we2] : ae2 ? function(Se2) {
                  for (var Oe2 = new Array(Se2.length), je2 = 0; je2 < Oe2.length; ++je2)
                    Oe2[je2] = Se2[je2].listener || Se2[je2];
                  return Oe2;
                }(we2) : Gt(we2, we2.length);
              }
              function kt(Ot) {
                var ce2 = this._events;
                if (ce2 !== void 0) {
                  var ae2 = ce2[Ot];
                  if (typeof ae2 == "function")
                    return 1;
                  if (ae2 !== void 0)
                    return ae2.length;
                }
                return 0;
              }
              function Gt(Ot, ce2) {
                for (var ae2 = new Array(ce2), de2 = 0; de2 < ce2; ++de2)
                  ae2[de2] = Ot[de2];
                return ae2;
              }
              Object.defineProperty(G3, "defaultMaxListeners", { enumerable: true, get: function() {
                return Z3;
              }, set: function(Ot) {
                if (typeof Ot != "number" || Ot < 0 || B3(Ot))
                  throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + Ot + ".");
                Z3 = Ot;
              } }), G3.init = function() {
                this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
              }, G3.prototype.setMaxListeners = function(Ot) {
                if (typeof Ot != "number" || Ot < 0 || B3(Ot))
                  throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + Ot + ".");
                return this._maxListeners = Ot, this;
              }, G3.prototype.getMaxListeners = function() {
                return tt(this);
              }, G3.prototype.emit = function(Ot) {
                for (var ce2 = [], ae2 = 1; ae2 < arguments.length; ae2++)
                  ce2.push(arguments[ae2]);
                var de2 = Ot === "error", we2 = this._events;
                if (we2 !== void 0)
                  de2 = de2 && we2.error === void 0;
                else if (!de2)
                  return false;
                if (de2) {
                  var Se2;
                  if (ce2.length > 0 && (Se2 = ce2[0]), Se2 instanceof Error)
                    throw Se2;
                  var Oe2 = new Error("Unhandled error." + (Se2 ? " (" + Se2.message + ")" : ""));
                  throw Oe2.context = Se2, Oe2;
                }
                var je2 = we2[Ot];
                if (je2 === void 0)
                  return false;
                if (typeof je2 == "function")
                  R6(je2, this, ce2);
                else {
                  var rn = je2.length, qe2 = Gt(je2, rn);
                  for (ae2 = 0; ae2 < rn; ++ae2)
                    R6(qe2[ae2], this, ce2);
                }
                return true;
              }, G3.prototype.addListener = function(Ot, ce2) {
                return it(this, Ot, ce2, false);
              }, G3.prototype.on = G3.prototype.addListener, G3.prototype.prependListener = function(Ot, ce2) {
                return it(this, Ot, ce2, true);
              }, G3.prototype.once = function(Ot, ce2) {
                return X3(ce2), this.on(Ot, mt(this, Ot, ce2)), this;
              }, G3.prototype.prependOnceListener = function(Ot, ce2) {
                return X3(ce2), this.prependListener(Ot, mt(this, Ot, ce2)), this;
              }, G3.prototype.removeListener = function(Ot, ce2) {
                var ae2, de2, we2, Se2, Oe2;
                if (X3(ce2), (de2 = this._events) === void 0)
                  return this;
                if ((ae2 = de2[Ot]) === void 0)
                  return this;
                if (ae2 === ce2 || ae2.listener === ce2)
                  --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete de2[Ot], de2.removeListener && this.emit("removeListener", Ot, ae2.listener || ce2));
                else if (typeof ae2 != "function") {
                  for (we2 = -1, Se2 = ae2.length - 1; Se2 >= 0; Se2--)
                    if (ae2[Se2] === ce2 || ae2[Se2].listener === ce2) {
                      Oe2 = ae2[Se2].listener, we2 = Se2;
                      break;
                    }
                  if (we2 < 0)
                    return this;
                  we2 === 0 ? ae2.shift() : function(je2, rn) {
                    for (; rn + 1 < je2.length; rn++)
                      je2[rn] = je2[rn + 1];
                    je2.pop();
                  }(ae2, we2), ae2.length === 1 && (de2[Ot] = ae2[0]), de2.removeListener !== void 0 && this.emit("removeListener", Ot, Oe2 || ce2);
                }
                return this;
              }, G3.prototype.off = G3.prototype.removeListener, G3.prototype.removeAllListeners = function(Ot) {
                var ce2, ae2, de2;
                if ((ae2 = this._events) === void 0)
                  return this;
                if (ae2.removeListener === void 0)
                  return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : ae2[Ot] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete ae2[Ot]), this;
                if (arguments.length === 0) {
                  var we2, Se2 = Object.keys(ae2);
                  for (de2 = 0; de2 < Se2.length; ++de2)
                    (we2 = Se2[de2]) !== "removeListener" && this.removeAllListeners(we2);
                  return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
                }
                if (typeof (ce2 = ae2[Ot]) == "function")
                  this.removeListener(Ot, ce2);
                else if (ce2 !== void 0)
                  for (de2 = ce2.length - 1; de2 >= 0; de2--)
                    this.removeListener(Ot, ce2[de2]);
                return this;
              }, G3.prototype.listeners = function(Ot) {
                return Mt(this, Ot, true);
              }, G3.prototype.rawListeners = function(Ot) {
                return Mt(this, Ot, false);
              }, G3.listenerCount = function(Ot, ce2) {
                return typeof Ot.listenerCount == "function" ? Ot.listenerCount(ce2) : kt.call(Ot, ce2);
              }, G3.prototype.listenerCount = kt, G3.prototype.eventNames = function() {
                return this._eventsCount > 0 ? A2(this._events) : [];
              };
            }, function(g5, b6, S2) {
              g5.exports.Dispatcher = S2(140);
            }, function(g5, b6, S2) {
              g5.exports = S2(142);
            }, function(g5, b6, S2) {
              b6.__esModule = true;
              var A2 = B3(S2(50)), k2 = B3(S2(65)), R6 = typeof k2.default == "function" && typeof A2.default == "symbol" ? function(G3) {
                return typeof G3;
              } : function(G3) {
                return G3 && typeof k2.default == "function" && G3.constructor === k2.default && G3 !== k2.default.prototype ? "symbol" : typeof G3;
              };
              function B3(G3) {
                return G3 && G3.__esModule ? G3 : { default: G3 };
              }
              b6.default = typeof k2.default == "function" && R6(A2.default) === "symbol" ? function(G3) {
                return G3 === void 0 ? "undefined" : R6(G3);
              } : function(G3) {
                return G3 && typeof k2.default == "function" && G3.constructor === k2.default && G3 !== k2.default.prototype ? "symbol" : G3 === void 0 ? "undefined" : R6(G3);
              };
            }, function(g5, b6, S2) {
              g5.exports = { default: S2(51), __esModule: true };
            }, function(g5, b6, S2) {
              S2(20), S2(29), g5.exports = S2(30).f("iterator");
            }, function(g5, b6, S2) {
              var A2 = S2(21), k2 = S2(22);
              g5.exports = function(R6) {
                return function(B3, G3) {
                  var Z3, X3, tt = String(k2(B3)), it = A2(G3), pt = tt.length;
                  return it < 0 || it >= pt ? R6 ? "" : void 0 : (Z3 = tt.charCodeAt(it)) < 55296 || Z3 > 56319 || it + 1 === pt || (X3 = tt.charCodeAt(it + 1)) < 56320 || X3 > 57343 ? R6 ? tt.charAt(it) : Z3 : R6 ? tt.slice(it, it + 2) : X3 - 56320 + (Z3 - 55296 << 10) + 65536;
                };
              };
            }, function(g5, b6, S2) {
              var A2 = S2(54);
              g5.exports = function(k2, R6, B3) {
                if (A2(k2), R6 === void 0)
                  return k2;
                switch (B3) {
                  case 1:
                    return function(G3) {
                      return k2.call(R6, G3);
                    };
                  case 2:
                    return function(G3, Z3) {
                      return k2.call(R6, G3, Z3);
                    };
                  case 3:
                    return function(G3, Z3, X3) {
                      return k2.call(R6, G3, Z3, X3);
                    };
                }
                return function() {
                  return k2.apply(R6, arguments);
                };
              };
            }, function(g5, b6) {
              g5.exports = function(S2) {
                if (typeof S2 != "function")
                  throw TypeError(S2 + " is not a function!");
                return S2;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(38), k2 = S2(16), R6 = S2(28), B3 = {};
              S2(6)(B3, S2(2)("iterator"), function() {
                return this;
              }), g5.exports = function(G3, Z3, X3) {
                G3.prototype = A2(B3, { next: k2(1, X3) }), R6(G3, Z3 + " Iterator");
              };
            }, function(g5, b6, S2) {
              var A2 = S2(7), k2 = S2(10), R6 = S2(13);
              g5.exports = S2(4) ? Object.defineProperties : function(B3, G3) {
                k2(B3);
                for (var Z3, X3 = R6(G3), tt = X3.length, it = 0; tt > it; )
                  A2.f(B3, Z3 = X3[it++], G3[Z3]);
                return B3;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(9), k2 = S2(58), R6 = S2(59);
              g5.exports = function(B3) {
                return function(G3, Z3, X3) {
                  var tt, it = A2(G3), pt = k2(it.length), mt = R6(X3, pt);
                  if (B3 && Z3 != Z3) {
                    for (; pt > mt; )
                      if ((tt = it[mt++]) != tt)
                        return true;
                  } else
                    for (; pt > mt; mt++)
                      if ((B3 || mt in it) && it[mt] === Z3)
                        return B3 || mt || 0;
                  return !B3 && -1;
                };
              };
            }, function(g5, b6, S2) {
              var A2 = S2(21), k2 = Math.min;
              g5.exports = function(R6) {
                return R6 > 0 ? k2(A2(R6), 9007199254740991) : 0;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(21), k2 = Math.max, R6 = Math.min;
              g5.exports = function(B3, G3) {
                return (B3 = A2(B3)) < 0 ? k2(B3 + G3, 0) : R6(B3, G3);
              };
            }, function(g5, b6, S2) {
              var A2 = S2(3).document;
              g5.exports = A2 && A2.documentElement;
            }, function(g5, b6, S2) {
              var A2 = S2(5), k2 = S2(18), R6 = S2(25)("IE_PROTO"), B3 = Object.prototype;
              g5.exports = Object.getPrototypeOf || function(G3) {
                return G3 = k2(G3), A2(G3, R6) ? G3[R6] : typeof G3.constructor == "function" && G3 instanceof G3.constructor ? G3.constructor.prototype : G3 instanceof Object ? B3 : null;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(63), k2 = S2(64), R6 = S2(12), B3 = S2(9);
              g5.exports = S2(34)(Array, "Array", function(G3, Z3) {
                this._t = B3(G3), this._i = 0, this._k = Z3;
              }, function() {
                var G3 = this._t, Z3 = this._k, X3 = this._i++;
                return !G3 || X3 >= G3.length ? (this._t = void 0, k2(1)) : k2(0, Z3 == "keys" ? X3 : Z3 == "values" ? G3[X3] : [X3, G3[X3]]);
              }, "values"), R6.Arguments = R6.Array, A2("keys"), A2("values"), A2("entries");
            }, function(g5, b6) {
              g5.exports = function() {
              };
            }, function(g5, b6) {
              g5.exports = function(S2, A2) {
                return { value: A2, done: !!S2 };
              };
            }, function(g5, b6, S2) {
              g5.exports = { default: S2(66), __esModule: true };
            }, function(g5, b6, S2) {
              S2(67), S2(73), S2(74), S2(75), g5.exports = S2(1).Symbol;
            }, function(g5, b6, S2) {
              var A2 = S2(3), k2 = S2(5), R6 = S2(4), B3 = S2(15), G3 = S2(37), Z3 = S2(68).KEY, X3 = S2(8), tt = S2(26), it = S2(28), pt = S2(17), mt = S2(2), Mt = S2(30), kt = S2(31), Gt = S2(69), Ot = S2(70), ce2 = S2(10), ae2 = S2(11), de2 = S2(18), we2 = S2(9), Se2 = S2(23), Oe2 = S2(16), je2 = S2(38), rn = S2(71), qe2 = S2(72), An = S2(32), jn = S2(7), _n = S2(13), Jr = qe2.f, Qn = jn.f, rr = rn.f, Ar = A2.Symbol, fi2 = A2.JSON, mi2 = fi2 && fi2.stringify, Oo = mt("_hidden"), Ts = mt("toPrimitive"), gl = {}.propertyIsEnumerable, nl = tt("symbol-registry"), rl = tt("symbols"), ss = tt("op-symbols"), Us = Object.prototype, sl = typeof Ar == "function" && !!An.f, ws = A2.QObject, Ll = !ws || !ws.prototype || !ws.prototype.findChild, dh2 = R6 && X3(function() {
                return je2(Qn({}, "a", { get: function() {
                  return Qn(this, "a", { value: 7 }).a;
                } })).a != 7;
              }) ? function(ea2, _o, Vs) {
                var ru = Jr(Us, _o);
                ru && delete Us[_o], Qn(ea2, _o, Vs), ru && ea2 !== Us && Qn(Us, _o, ru);
              } : Qn, hu = function(ea2) {
                var _o = rl[ea2] = je2(Ar.prototype);
                return _o._k = ea2, _o;
              }, Nh2 = sl && typeof Ar.iterator == "symbol" ? function(ea2) {
                return typeof ea2 == "symbol";
              } : function(ea2) {
                return ea2 instanceof Ar;
              }, cp = function(ea2, _o, Vs) {
                return ea2 === Us && cp(ss, _o, Vs), ce2(ea2), _o = Se2(_o, true), ce2(Vs), k2(rl, _o) ? (Vs.enumerable ? (k2(ea2, Oo) && ea2[Oo][_o] && (ea2[Oo][_o] = false), Vs = je2(Vs, { enumerable: Oe2(0, false) })) : (k2(ea2, Oo) || Qn(ea2, Oo, Oe2(1, {})), ea2[Oo][_o] = true), dh2(ea2, _o, Vs)) : Qn(ea2, _o, Vs);
              }, Xh2 = function(ea2, _o) {
                ce2(ea2);
                for (var Vs, ru = Gt(_o = we2(_o)), kf2 = 0, wf2 = ru.length; wf2 > kf2; )
                  cp(ea2, Vs = ru[kf2++], _o[Vs]);
                return ea2;
              }, om = function(ea2) {
                var _o = gl.call(this, ea2 = Se2(ea2, true));
                return !(this === Us && k2(rl, ea2) && !k2(ss, ea2)) && (!(_o || !k2(this, ea2) || !k2(rl, ea2) || k2(this, Oo) && this[Oo][ea2]) || _o);
              }, Sv = function(ea2, _o) {
                if (ea2 = we2(ea2), _o = Se2(_o, true), ea2 !== Us || !k2(rl, _o) || k2(ss, _o)) {
                  var Vs = Jr(ea2, _o);
                  return !Vs || !k2(rl, _o) || k2(ea2, Oo) && ea2[Oo][_o] || (Vs.enumerable = true), Vs;
                }
              }, U1 = function(ea2) {
                for (var _o, Vs = rr(we2(ea2)), ru = [], kf2 = 0; Vs.length > kf2; )
                  k2(rl, _o = Vs[kf2++]) || _o == Oo || _o == Z3 || ru.push(_o);
                return ru;
              }, Jd2 = function(ea2) {
                for (var _o, Vs = ea2 === Us, ru = rr(Vs ? ss : we2(ea2)), kf2 = [], wf2 = 0; ru.length > wf2; )
                  !k2(rl, _o = ru[wf2++]) || Vs && !k2(Us, _o) || kf2.push(rl[_o]);
                return kf2;
              };
              sl || (G3((Ar = function() {
                if (this instanceof Ar)
                  throw TypeError("Symbol is not a constructor!");
                var ea2 = pt(arguments.length > 0 ? arguments[0] : void 0), _o = function(Vs) {
                  this === Us && _o.call(ss, Vs), k2(this, Oo) && k2(this[Oo], ea2) && (this[Oo][ea2] = false), dh2(this, ea2, Oe2(1, Vs));
                };
                return R6 && Ll && dh2(Us, ea2, { configurable: true, set: _o }), hu(ea2);
              }).prototype, "toString", function() {
                return this._k;
              }), qe2.f = Sv, jn.f = cp, S2(41).f = rn.f = U1, S2(19).f = om, An.f = Jd2, R6 && !S2(14) && G3(Us, "propertyIsEnumerable", om, true), Mt.f = function(ea2) {
                return hu(mt(ea2));
              }), B3(B3.G + B3.W + B3.F * !sl, { Symbol: Ar });
              for (var jv = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Mv = 0; jv.length > Mv; )
                mt(jv[Mv++]);
              for (var fT = _n(mt.store), yo = 0; fT.length > yo; )
                kt(fT[yo++]);
              B3(B3.S + B3.F * !sl, "Symbol", { for: function(ea2) {
                return k2(nl, ea2 += "") ? nl[ea2] : nl[ea2] = Ar(ea2);
              }, keyFor: function(ea2) {
                if (!Nh2(ea2))
                  throw TypeError(ea2 + " is not a symbol!");
                for (var _o in nl)
                  if (nl[_o] === ea2)
                    return _o;
              }, useSetter: function() {
                Ll = true;
              }, useSimple: function() {
                Ll = false;
              } }), B3(B3.S + B3.F * !sl, "Object", { create: function(ea2, _o) {
                return _o === void 0 ? je2(ea2) : Xh2(je2(ea2), _o);
              }, defineProperty: cp, defineProperties: Xh2, getOwnPropertyDescriptor: Sv, getOwnPropertyNames: U1, getOwnPropertySymbols: Jd2 });
              var oa2 = X3(function() {
                An.f(1);
              });
              B3(B3.S + B3.F * oa2, "Object", { getOwnPropertySymbols: function(ea2) {
                return An.f(de2(ea2));
              } }), fi2 && B3(B3.S + B3.F * (!sl || X3(function() {
                var ea2 = Ar();
                return mi2([ea2]) != "[null]" || mi2({ a: ea2 }) != "{}" || mi2(Object(ea2)) != "{}";
              })), "JSON", { stringify: function(ea2) {
                for (var _o, Vs, ru = [ea2], kf2 = 1; arguments.length > kf2; )
                  ru.push(arguments[kf2++]);
                if (Vs = _o = ru[1], (ae2(_o) || ea2 !== void 0) && !Nh2(ea2))
                  return Ot(_o) || (_o = function(wf2, rd2) {
                    if (typeof Vs == "function" && (rd2 = Vs.call(this, wf2, rd2)), !Nh2(rd2))
                      return rd2;
                  }), ru[1] = _o, mi2.apply(fi2, ru);
              } }), Ar.prototype[Ts] || S2(6)(Ar.prototype, Ts, Ar.prototype.valueOf), it(Ar, "Symbol"), it(Math, "Math", true), it(A2.JSON, "JSON", true);
            }, function(g5, b6, S2) {
              var A2 = S2(17)("meta"), k2 = S2(11), R6 = S2(5), B3 = S2(7).f, G3 = 0, Z3 = Object.isExtensible || function() {
                return true;
              }, X3 = !S2(8)(function() {
                return Z3(Object.preventExtensions({}));
              }), tt = function(pt) {
                B3(pt, A2, { value: { i: "O" + ++G3, w: {} } });
              }, it = g5.exports = { KEY: A2, NEED: false, fastKey: function(pt, mt) {
                if (!k2(pt))
                  return typeof pt == "symbol" ? pt : (typeof pt == "string" ? "S" : "P") + pt;
                if (!R6(pt, A2)) {
                  if (!Z3(pt))
                    return "F";
                  if (!mt)
                    return "E";
                  tt(pt);
                }
                return pt[A2].i;
              }, getWeak: function(pt, mt) {
                if (!R6(pt, A2)) {
                  if (!Z3(pt))
                    return true;
                  if (!mt)
                    return false;
                  tt(pt);
                }
                return pt[A2].w;
              }, onFreeze: function(pt) {
                return X3 && it.NEED && Z3(pt) && !R6(pt, A2) && tt(pt), pt;
              } };
            }, function(g5, b6, S2) {
              var A2 = S2(13), k2 = S2(32), R6 = S2(19);
              g5.exports = function(B3) {
                var G3 = A2(B3), Z3 = k2.f;
                if (Z3)
                  for (var X3, tt = Z3(B3), it = R6.f, pt = 0; tt.length > pt; )
                    it.call(B3, X3 = tt[pt++]) && G3.push(X3);
                return G3;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(24);
              g5.exports = Array.isArray || function(k2) {
                return A2(k2) == "Array";
              };
            }, function(g5, b6, S2) {
              var A2 = S2(9), k2 = S2(41).f, R6 = {}.toString, B3 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
              g5.exports.f = function(G3) {
                return B3 && R6.call(G3) == "[object Window]" ? function(Z3) {
                  try {
                    return k2(Z3);
                  } catch {
                    return B3.slice();
                  }
                }(G3) : k2(A2(G3));
              };
            }, function(g5, b6, S2) {
              var A2 = S2(19), k2 = S2(16), R6 = S2(9), B3 = S2(23), G3 = S2(5), Z3 = S2(35), X3 = Object.getOwnPropertyDescriptor;
              b6.f = S2(4) ? X3 : function(tt, it) {
                if (tt = R6(tt), it = B3(it, true), Z3)
                  try {
                    return X3(tt, it);
                  } catch {
                  }
                if (G3(tt, it))
                  return k2(!A2.f.call(tt, it), tt[it]);
              };
            }, function(g5, b6) {
            }, function(g5, b6, S2) {
              S2(31)("asyncIterator");
            }, function(g5, b6, S2) {
              S2(31)("observable");
            }, function(g5, b6, S2) {
              b6.__esModule = true;
              var A2, k2 = S2(77), R6 = (A2 = k2) && A2.__esModule ? A2 : { default: A2 };
              b6.default = R6.default || function(B3) {
                for (var G3 = 1; G3 < arguments.length; G3++) {
                  var Z3 = arguments[G3];
                  for (var X3 in Z3)
                    Object.prototype.hasOwnProperty.call(Z3, X3) && (B3[X3] = Z3[X3]);
                }
                return B3;
              };
            }, function(g5, b6, S2) {
              g5.exports = { default: S2(78), __esModule: true };
            }, function(g5, b6, S2) {
              S2(79), g5.exports = S2(1).Object.assign;
            }, function(g5, b6, S2) {
              var A2 = S2(15);
              A2(A2.S + A2.F, "Object", { assign: S2(80) });
            }, function(g5, b6, S2) {
              var A2 = S2(4), k2 = S2(13), R6 = S2(32), B3 = S2(19), G3 = S2(18), Z3 = S2(40), X3 = Object.assign;
              g5.exports = !X3 || S2(8)(function() {
                var tt = {}, it = {}, pt = Symbol(), mt = "abcdefghijklmnopqrst";
                return tt[pt] = 7, mt.split("").forEach(function(Mt) {
                  it[Mt] = Mt;
                }), X3({}, tt)[pt] != 7 || Object.keys(X3({}, it)).join("") != mt;
              }) ? function(tt, it) {
                for (var pt = G3(tt), mt = arguments.length, Mt = 1, kt = R6.f, Gt = B3.f; mt > Mt; )
                  for (var Ot, ce2 = Z3(arguments[Mt++]), ae2 = kt ? k2(ce2).concat(kt(ce2)) : k2(ce2), de2 = ae2.length, we2 = 0; de2 > we2; )
                    Ot = ae2[we2++], A2 && !Gt.call(ce2, Ot) || (pt[Ot] = ce2[Ot]);
                return pt;
              } : X3;
            }, function(g5, b6, S2) {
              b6.__esModule = true;
              var A2 = R6(S2(82)), k2 = R6(S2(85));
              function R6(B3) {
                return B3 && B3.__esModule ? B3 : { default: B3 };
              }
              b6.default = function(B3, G3) {
                if (Array.isArray(B3))
                  return B3;
                if ((0, A2.default)(Object(B3)))
                  return function(Z3, X3) {
                    var tt = [], it = true, pt = false, mt = void 0;
                    try {
                      for (var Mt, kt = (0, k2.default)(Z3); !(it = (Mt = kt.next()).done) && (tt.push(Mt.value), !X3 || tt.length !== X3); it = true)
                        ;
                    } catch (Gt) {
                      pt = true, mt = Gt;
                    } finally {
                      try {
                        !it && kt.return && kt.return();
                      } finally {
                        if (pt)
                          throw mt;
                      }
                    }
                    return tt;
                  }(B3, G3);
                throw new TypeError("Invalid attempt to destructure non-iterable instance");
              };
            }, function(g5, b6, S2) {
              g5.exports = { default: S2(83), __esModule: true };
            }, function(g5, b6, S2) {
              S2(29), S2(20), g5.exports = S2(84);
            }, function(g5, b6, S2) {
              var A2 = S2(42), k2 = S2(2)("iterator"), R6 = S2(12);
              g5.exports = S2(1).isIterable = function(B3) {
                var G3 = Object(B3);
                return G3[k2] !== void 0 || "@@iterator" in G3 || R6.hasOwnProperty(A2(G3));
              };
            }, function(g5, b6, S2) {
              g5.exports = { default: S2(86), __esModule: true };
            }, function(g5, b6, S2) {
              S2(29), S2(20), g5.exports = S2(87);
            }, function(g5, b6, S2) {
              var A2 = S2(10), k2 = S2(88);
              g5.exports = S2(1).getIterator = function(R6) {
                var B3 = k2(R6);
                if (typeof B3 != "function")
                  throw TypeError(R6 + " is not iterable!");
                return A2(B3.call(R6));
              };
            }, function(g5, b6, S2) {
              var A2 = S2(42), k2 = S2(2)("iterator"), R6 = S2(12);
              g5.exports = S2(1).getIteratorMethod = function(B3) {
                if (B3 != null)
                  return B3[k2] || B3["@@iterator"] || R6[A2(B3)];
              };
            }, function(g5, b6, S2) {
              g5.exports = { default: S2(90), __esModule: true };
            }, function(g5, b6, S2) {
              S2(91), g5.exports = S2(1).Object.keys;
            }, function(g5, b6, S2) {
              var A2 = S2(18), k2 = S2(13);
              S2(92)("keys", function() {
                return function(R6) {
                  return k2(A2(R6));
                };
              });
            }, function(g5, b6, S2) {
              var A2 = S2(15), k2 = S2(1), R6 = S2(8);
              g5.exports = function(B3, G3) {
                var Z3 = (k2.Object || {})[B3] || Object[B3], X3 = {};
                X3[B3] = G3(Z3), A2(A2.S + A2.F * R6(function() {
                  Z3(1);
                }), "Object", X3);
              };
            }, function(g5, b6, S2) {
              (function(A2) {
                var k2 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], R6 = /^\s+|\s+$/g, B3 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, G3 = /\{\n\/\* \[wrapped with (.+)\] \*/, Z3 = /,? & /, X3 = /^[-+]0x[0-9a-f]+$/i, tt = /^0b[01]+$/i, it = /^\[object .+?Constructor\]$/, pt = /^0o[0-7]+$/i, mt = /^(?:0|[1-9]\d*)$/, Mt = parseInt, kt = typeof A2 == "object" && A2 && A2.Object === Object && A2, Gt = typeof self == "object" && self && self.Object === Object && self, Ot = kt || Gt || Function("return this")();
                function ce2(yo, oa2, ea2) {
                  switch (ea2.length) {
                    case 0:
                      return yo.call(oa2);
                    case 1:
                      return yo.call(oa2, ea2[0]);
                    case 2:
                      return yo.call(oa2, ea2[0], ea2[1]);
                    case 3:
                      return yo.call(oa2, ea2[0], ea2[1], ea2[2]);
                  }
                  return yo.apply(oa2, ea2);
                }
                function ae2(yo, oa2) {
                  return !!(yo && yo.length) && function(ea2, _o, Vs) {
                    if (_o != _o)
                      return function(wf2, rd2, Cv, kg2) {
                        for (var ty = wf2.length, Pg2 = Cv + (kg2 ? 1 : -1); kg2 ? Pg2-- : ++Pg2 < ty; )
                          if (rd2(wf2[Pg2], Pg2, wf2))
                            return Pg2;
                        return -1;
                      }(ea2, de2, Vs);
                    for (var ru = Vs - 1, kf2 = ea2.length; ++ru < kf2; )
                      if (ea2[ru] === _o)
                        return ru;
                    return -1;
                  }(yo, oa2, 0) > -1;
                }
                function de2(yo) {
                  return yo != yo;
                }
                function we2(yo, oa2) {
                  for (var ea2 = yo.length, _o = 0; ea2--; )
                    yo[ea2] === oa2 && _o++;
                  return _o;
                }
                function Se2(yo, oa2) {
                  for (var ea2 = -1, _o = yo.length, Vs = 0, ru = []; ++ea2 < _o; ) {
                    var kf2 = yo[ea2];
                    kf2 !== oa2 && kf2 !== "__lodash_placeholder__" || (yo[ea2] = "__lodash_placeholder__", ru[Vs++] = ea2);
                  }
                  return ru;
                }
                var Oe2, je2, rn, qe2 = Function.prototype, An = Object.prototype, jn = Ot["__core-js_shared__"], _n = (Oe2 = /[^.]+$/.exec(jn && jn.keys && jn.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Oe2 : "", Jr = qe2.toString, Qn = An.hasOwnProperty, rr = An.toString, Ar = RegExp("^" + Jr.call(Qn).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), fi2 = Object.create, mi2 = Math.max, Oo = Math.min, Ts = (je2 = hu(Object, "defineProperty"), (rn = hu.name) && rn.length > 2 ? je2 : void 0);
                function gl(yo) {
                  return jv(yo) ? fi2(yo) : {};
                }
                function nl(yo) {
                  return !(!jv(yo) || function(oa2) {
                    return !!_n && _n in oa2;
                  }(yo)) && (function(oa2) {
                    var ea2 = jv(oa2) ? rr.call(oa2) : "";
                    return ea2 == "[object Function]" || ea2 == "[object GeneratorFunction]";
                  }(yo) || function(oa2) {
                    var ea2 = false;
                    if (oa2 != null && typeof oa2.toString != "function")
                      try {
                        ea2 = !!(oa2 + "");
                      } catch {
                      }
                    return ea2;
                  }(yo) ? Ar : it).test(function(oa2) {
                    if (oa2 != null) {
                      try {
                        return Jr.call(oa2);
                      } catch {
                      }
                      try {
                        return oa2 + "";
                      } catch {
                      }
                    }
                    return "";
                  }(yo));
                }
                function rl(yo, oa2, ea2, _o) {
                  for (var Vs = -1, ru = yo.length, kf2 = ea2.length, wf2 = -1, rd2 = oa2.length, Cv = mi2(ru - kf2, 0), kg2 = Array(rd2 + Cv), ty = !_o; ++wf2 < rd2; )
                    kg2[wf2] = oa2[wf2];
                  for (; ++Vs < kf2; )
                    (ty || Vs < ru) && (kg2[ea2[Vs]] = yo[Vs]);
                  for (; Cv--; )
                    kg2[wf2++] = yo[Vs++];
                  return kg2;
                }
                function ss(yo, oa2, ea2, _o) {
                  for (var Vs = -1, ru = yo.length, kf2 = -1, wf2 = ea2.length, rd2 = -1, Cv = oa2.length, kg2 = mi2(ru - wf2, 0), ty = Array(kg2 + Cv), Pg2 = !_o; ++Vs < kg2; )
                    ty[Vs] = yo[Vs];
                  for (var $b2 = Vs; ++rd2 < Cv; )
                    ty[$b2 + rd2] = oa2[rd2];
                  for (; ++kf2 < wf2; )
                    (Pg2 || Vs < ru) && (ty[$b2 + ea2[kf2]] = yo[Vs++]);
                  return ty;
                }
                function Us(yo) {
                  return function() {
                    var oa2 = arguments;
                    switch (oa2.length) {
                      case 0:
                        return new yo();
                      case 1:
                        return new yo(oa2[0]);
                      case 2:
                        return new yo(oa2[0], oa2[1]);
                      case 3:
                        return new yo(oa2[0], oa2[1], oa2[2]);
                      case 4:
                        return new yo(oa2[0], oa2[1], oa2[2], oa2[3]);
                      case 5:
                        return new yo(oa2[0], oa2[1], oa2[2], oa2[3], oa2[4]);
                      case 6:
                        return new yo(oa2[0], oa2[1], oa2[2], oa2[3], oa2[4], oa2[5]);
                      case 7:
                        return new yo(oa2[0], oa2[1], oa2[2], oa2[3], oa2[4], oa2[5], oa2[6]);
                    }
                    var ea2 = gl(yo.prototype), _o = yo.apply(ea2, oa2);
                    return jv(_o) ? _o : ea2;
                  };
                }
                function sl(yo, oa2, ea2, _o, Vs, ru, kf2, wf2, rd2, Cv) {
                  var kg2 = 128 & oa2, ty = 1 & oa2, Pg2 = 2 & oa2, $b2 = 24 & oa2, Mx = 512 & oa2, _2 = Pg2 ? void 0 : Us(yo);
                  return function Cx() {
                    for (var p0 = arguments.length, Qh2 = Array(p0), sm = p0; sm--; )
                      Qh2[sm] = arguments[sm];
                    if ($b2)
                      var q1 = dh2(Cx), AM = we2(Qh2, q1);
                    if (_o && (Qh2 = rl(Qh2, _o, Vs, $b2)), ru && (Qh2 = ss(Qh2, ru, kf2, $b2)), p0 -= AM, $b2 && p0 < Cv) {
                      var Xw = Se2(Qh2, q1);
                      return ws(yo, oa2, sl, Cx.placeholder, ea2, Qh2, Xw, wf2, rd2, Cv - p0);
                    }
                    var Tx = ty ? ea2 : this, x22 = Pg2 ? Tx[yo] : yo;
                    return p0 = Qh2.length, wf2 ? Qh2 = om(Qh2, wf2) : Mx && p0 > 1 && Qh2.reverse(), kg2 && rd2 < p0 && (Qh2.length = rd2), this && this !== Ot && this instanceof Cx && (x22 = _2 || Us(x22)), x22.apply(Tx, Qh2);
                  };
                }
                function ws(yo, oa2, ea2, _o, Vs, ru, kf2, wf2, rd2, Cv) {
                  var kg2 = 8 & oa2;
                  oa2 |= kg2 ? 32 : 64, 4 & (oa2 &= ~(kg2 ? 64 : 32)) || (oa2 &= -4);
                  var ty = ea2(yo, oa2, Vs, kg2 ? ru : void 0, kg2 ? kf2 : void 0, kg2 ? void 0 : ru, kg2 ? void 0 : kf2, wf2, rd2, Cv);
                  return ty.placeholder = _o, Sv(ty, yo, oa2);
                }
                function Ll(yo, oa2, ea2, _o, Vs, ru, kf2, wf2) {
                  var rd2 = 2 & oa2;
                  if (!rd2 && typeof yo != "function")
                    throw new TypeError("Expected a function");
                  var Cv = _o ? _o.length : 0;
                  if (Cv || (oa2 &= -97, _o = Vs = void 0), kf2 = kf2 === void 0 ? kf2 : mi2(fT(kf2), 0), wf2 = wf2 === void 0 ? wf2 : fT(wf2), Cv -= Vs ? Vs.length : 0, 64 & oa2) {
                    var kg2 = _o, ty = Vs;
                    _o = Vs = void 0;
                  }
                  var Pg2 = [yo, oa2, ea2, _o, Vs, kg2, ty, ru, kf2, wf2];
                  if (yo = Pg2[0], oa2 = Pg2[1], ea2 = Pg2[2], _o = Pg2[3], Vs = Pg2[4], !(wf2 = Pg2[9] = Pg2[9] == null ? rd2 ? 0 : yo.length : mi2(Pg2[9] - Cv, 0)) && 24 & oa2 && (oa2 &= -25), oa2 && oa2 != 1)
                    $b2 = oa2 == 8 || oa2 == 16 ? function(Mx, _2, Cx) {
                      var p0 = Us(Mx);
                      return function Qh2() {
                        for (var sm = arguments.length, q1 = Array(sm), AM = sm, Xw = dh2(Qh2); AM--; )
                          q1[AM] = arguments[AM];
                        var Tx = sm < 3 && q1[0] !== Xw && q1[sm - 1] !== Xw ? [] : Se2(q1, Xw);
                        if ((sm -= Tx.length) < Cx)
                          return ws(Mx, _2, sl, Qh2.placeholder, void 0, q1, Tx, void 0, void 0, Cx - sm);
                        var x22 = this && this !== Ot && this instanceof Qh2 ? p0 : Mx;
                        return ce2(x22, this, q1);
                      };
                    }(yo, oa2, wf2) : oa2 != 32 && oa2 != 33 || Vs.length ? sl.apply(void 0, Pg2) : function(Mx, _2, Cx, p0) {
                      var Qh2 = 1 & _2, sm = Us(Mx);
                      return function q1() {
                        for (var AM = -1, Xw = arguments.length, Tx = -1, x22 = p0.length, cD = Array(x22 + Xw), fD = this && this !== Ot && this instanceof q1 ? sm : Mx; ++Tx < x22; )
                          cD[Tx] = p0[Tx];
                        for (; Xw--; )
                          cD[Tx++] = arguments[++AM];
                        return ce2(fD, Qh2 ? Cx : this, cD);
                      };
                    }(yo, oa2, ea2, _o);
                  else
                    var $b2 = function(Mx, _2, Cx) {
                      var p0 = 1 & _2, Qh2 = Us(Mx);
                      return function sm() {
                        var q1 = this && this !== Ot && this instanceof sm ? Qh2 : Mx;
                        return q1.apply(p0 ? Cx : this, arguments);
                      };
                    }(yo, oa2, ea2);
                  return Sv($b2, yo, oa2);
                }
                function dh2(yo) {
                  return yo.placeholder;
                }
                function hu(yo, oa2) {
                  var ea2 = function(_o, Vs) {
                    return _o == null ? void 0 : _o[Vs];
                  }(yo, oa2);
                  return nl(ea2) ? ea2 : void 0;
                }
                function Nh2(yo) {
                  var oa2 = yo.match(G3);
                  return oa2 ? oa2[1].split(Z3) : [];
                }
                function cp(yo, oa2) {
                  var ea2 = oa2.length, _o = ea2 - 1;
                  return oa2[_o] = (ea2 > 1 ? "& " : "") + oa2[_o], oa2 = oa2.join(ea2 > 2 ? ", " : " "), yo.replace(B3, `{
/* [wrapped with ` + oa2 + `] */
`);
                }
                function Xh2(yo, oa2) {
                  return !!(oa2 = oa2 == null ? 9007199254740991 : oa2) && (typeof yo == "number" || mt.test(yo)) && yo > -1 && yo % 1 == 0 && yo < oa2;
                }
                function om(yo, oa2) {
                  for (var ea2 = yo.length, _o = Oo(oa2.length, ea2), Vs = function(kf2, wf2) {
                    var rd2 = -1, Cv = kf2.length;
                    for (wf2 || (wf2 = Array(Cv)); ++rd2 < Cv; )
                      wf2[rd2] = kf2[rd2];
                    return wf2;
                  }(yo); _o--; ) {
                    var ru = oa2[_o];
                    yo[_o] = Xh2(ru, ea2) ? Vs[ru] : void 0;
                  }
                  return yo;
                }
                var Sv = Ts ? function(yo, oa2, ea2) {
                  var _o, Vs = oa2 + "";
                  return Ts(yo, "toString", { configurable: true, enumerable: false, value: (_o = cp(Vs, U1(Nh2(Vs), ea2)), function() {
                    return _o;
                  }) });
                } : function(yo) {
                  return yo;
                };
                function U1(yo, oa2) {
                  return function(ea2, _o) {
                    for (var Vs = -1, ru = ea2 ? ea2.length : 0; ++Vs < ru && _o(ea2[Vs], Vs, ea2) !== false; )
                      ;
                  }(k2, function(ea2) {
                    var _o = "_." + ea2[0];
                    oa2 & ea2[1] && !ae2(yo, _o) && yo.push(_o);
                  }), yo.sort();
                }
                function Jd2(yo, oa2, ea2) {
                  var _o = Ll(yo, 8, void 0, void 0, void 0, void 0, void 0, oa2 = ea2 ? void 0 : oa2);
                  return _o.placeholder = Jd2.placeholder, _o;
                }
                function jv(yo) {
                  var oa2 = typeof yo;
                  return !!yo && (oa2 == "object" || oa2 == "function");
                }
                function Mv(yo) {
                  return yo ? (yo = function(oa2) {
                    if (typeof oa2 == "number")
                      return oa2;
                    if (function(Vs) {
                      return typeof Vs == "symbol" || function(ru) {
                        return !!ru && typeof ru == "object";
                      }(Vs) && rr.call(Vs) == "[object Symbol]";
                    }(oa2))
                      return NaN;
                    if (jv(oa2)) {
                      var ea2 = typeof oa2.valueOf == "function" ? oa2.valueOf() : oa2;
                      oa2 = jv(ea2) ? ea2 + "" : ea2;
                    }
                    if (typeof oa2 != "string")
                      return oa2 === 0 ? oa2 : +oa2;
                    oa2 = oa2.replace(R6, "");
                    var _o = tt.test(oa2);
                    return _o || pt.test(oa2) ? Mt(oa2.slice(2), _o ? 2 : 8) : X3.test(oa2) ? NaN : +oa2;
                  }(yo)) === 1 / 0 || yo === -1 / 0 ? 17976931348623157e292 * (yo < 0 ? -1 : 1) : yo == yo ? yo : 0 : yo === 0 ? yo : 0;
                }
                function fT(yo) {
                  var oa2 = Mv(yo), ea2 = oa2 % 1;
                  return oa2 == oa2 ? ea2 ? oa2 - ea2 : oa2 : 0;
                }
                Jd2.placeholder = {}, g5.exports = Jd2;
              }).call(this, S2(43));
            }, function(g5, b6, S2) {
              function A2(ss) {
                return ss && ss.__esModule ? ss.default : ss;
              }
              b6.__esModule = true;
              var k2 = S2(95);
              b6.threezerotwofour = A2(k2);
              var R6 = S2(96);
              b6.apathy = A2(R6);
              var B3 = S2(97);
              b6.ashes = A2(B3);
              var G3 = S2(98);
              b6.atelierDune = A2(G3);
              var Z3 = S2(99);
              b6.atelierForest = A2(Z3);
              var X3 = S2(100);
              b6.atelierHeath = A2(X3);
              var tt = S2(101);
              b6.atelierLakeside = A2(tt);
              var it = S2(102);
              b6.atelierSeaside = A2(it);
              var pt = S2(103);
              b6.bespin = A2(pt);
              var mt = S2(104);
              b6.brewer = A2(mt);
              var Mt = S2(105);
              b6.bright = A2(Mt);
              var kt = S2(106);
              b6.chalk = A2(kt);
              var Gt = S2(107);
              b6.codeschool = A2(Gt);
              var Ot = S2(108);
              b6.colors = A2(Ot);
              var ce2 = S2(109);
              b6.default = A2(ce2);
              var ae2 = S2(110);
              b6.eighties = A2(ae2);
              var de2 = S2(111);
              b6.embers = A2(de2);
              var we2 = S2(112);
              b6.flat = A2(we2);
              var Se2 = S2(113);
              b6.google = A2(Se2);
              var Oe2 = S2(114);
              b6.grayscale = A2(Oe2);
              var je2 = S2(115);
              b6.greenscreen = A2(je2);
              var rn = S2(116);
              b6.harmonic = A2(rn);
              var qe2 = S2(117);
              b6.hopscotch = A2(qe2);
              var An = S2(118);
              b6.isotope = A2(An);
              var jn = S2(119);
              b6.marrakesh = A2(jn);
              var _n = S2(120);
              b6.mocha = A2(_n);
              var Jr = S2(121);
              b6.monokai = A2(Jr);
              var Qn = S2(122);
              b6.ocean = A2(Qn);
              var rr = S2(123);
              b6.paraiso = A2(rr);
              var Ar = S2(124);
              b6.pop = A2(Ar);
              var fi2 = S2(125);
              b6.railscasts = A2(fi2);
              var mi2 = S2(126);
              b6.shapeshifter = A2(mi2);
              var Oo = S2(127);
              b6.solarized = A2(Oo);
              var Ts = S2(128);
              b6.summerfruit = A2(Ts);
              var gl = S2(129);
              b6.tomorrow = A2(gl);
              var nl = S2(130);
              b6.tube = A2(nl);
              var rl = S2(131);
              b6.twilight = A2(rl);
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              b6.__esModule = true, b6.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, g5.exports = b6.default;
            }, function(g5, b6, S2) {
              var A2 = S2(33);
              function k2(R6) {
                var B3 = Math.round(A2(R6, 0, 255)).toString(16);
                return B3.length == 1 ? "0" + B3 : B3;
              }
              g5.exports = function(R6) {
                var B3 = R6.length === 4 ? k2(255 * R6[3]) : "";
                return "#" + k2(R6[0]) + k2(R6[1]) + k2(R6[2]) + B3;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(134), k2 = S2(135), R6 = S2(136), B3 = S2(137), G3 = { "#": k2, hsl: function(X3) {
                var tt = A2(X3), it = B3(tt);
                return tt.length === 4 && it.push(tt[3]), it;
              }, rgb: R6 };
              function Z3(X3) {
                for (var tt in G3)
                  if (X3.indexOf(tt) === 0)
                    return G3[tt](X3);
              }
              Z3.rgb = R6, Z3.hsl = A2, Z3.hex = k2, g5.exports = Z3;
            }, function(g5, b6, S2) {
              var A2 = S2(44), k2 = S2(33);
              function R6(B3, G3) {
                switch (B3 = parseFloat(B3), G3) {
                  case 0:
                    return k2(B3, 0, 360);
                  case 1:
                  case 2:
                    return k2(B3, 0, 100);
                  case 3:
                    return k2(B3, 0, 1);
                }
              }
              g5.exports = function(B3) {
                return A2(B3).map(R6);
              };
            }, function(g5, b6) {
              g5.exports = function(S2) {
                S2.length !== 4 && S2.length !== 5 || (S2 = function(R6) {
                  for (var B3 = "#", G3 = 1; G3 < R6.length; G3++) {
                    var Z3 = R6.charAt(G3);
                    B3 += Z3 + Z3;
                  }
                  return B3;
                }(S2));
                var A2 = [parseInt(S2.substring(1, 3), 16), parseInt(S2.substring(3, 5), 16), parseInt(S2.substring(5, 7), 16)];
                if (S2.length === 9) {
                  var k2 = parseFloat((parseInt(S2.substring(7, 9), 16) / 255).toFixed(2));
                  A2.push(k2);
                }
                return A2;
              };
            }, function(g5, b6, S2) {
              var A2 = S2(44), k2 = S2(33);
              function R6(B3, G3) {
                return G3 < 3 ? B3.indexOf("%") != -1 ? Math.round(255 * k2(parseInt(B3, 10), 0, 100) / 100) : k2(parseInt(B3, 10), 0, 255) : k2(parseFloat(B3), 0, 1);
              }
              g5.exports = function(B3) {
                return A2(B3).map(R6);
              };
            }, function(g5, b6) {
              g5.exports = function(S2) {
                var A2, k2, R6, B3, G3, Z3 = S2[0] / 360, X3 = S2[1] / 100, tt = S2[2] / 100;
                if (X3 == 0)
                  return [G3 = 255 * tt, G3, G3];
                A2 = 2 * tt - (k2 = tt < 0.5 ? tt * (1 + X3) : tt + X3 - tt * X3), B3 = [0, 0, 0];
                for (var it = 0; it < 3; it++)
                  (R6 = Z3 + 1 / 3 * -(it - 1)) < 0 && R6++, R6 > 1 && R6--, G3 = 6 * R6 < 1 ? A2 + 6 * (k2 - A2) * R6 : 2 * R6 < 1 ? k2 : 3 * R6 < 2 ? A2 + (k2 - A2) * (2 / 3 - R6) * 6 : A2, B3[it] = 255 * G3;
                return B3;
              };
            }, function(g5, b6, S2) {
              (function(A2) {
                var k2 = typeof A2 == "object" && A2 && A2.Object === Object && A2, R6 = typeof self == "object" && self && self.Object === Object && self, B3 = k2 || R6 || Function("return this")();
                function G3(Se2, Oe2, je2) {
                  switch (je2.length) {
                    case 0:
                      return Se2.call(Oe2);
                    case 1:
                      return Se2.call(Oe2, je2[0]);
                    case 2:
                      return Se2.call(Oe2, je2[0], je2[1]);
                    case 3:
                      return Se2.call(Oe2, je2[0], je2[1], je2[2]);
                  }
                  return Se2.apply(Oe2, je2);
                }
                function Z3(Se2, Oe2) {
                  for (var je2 = -1, rn = Oe2.length, qe2 = Se2.length; ++je2 < rn; )
                    Se2[qe2 + je2] = Oe2[je2];
                  return Se2;
                }
                var X3 = Object.prototype, tt = X3.hasOwnProperty, it = X3.toString, pt = B3.Symbol, mt = X3.propertyIsEnumerable, Mt = pt ? pt.isConcatSpreadable : void 0, kt = Math.max;
                function Gt(Se2) {
                  return Ot(Se2) || function(Oe2) {
                    return function(je2) {
                      return function(rn) {
                        return !!rn && typeof rn == "object";
                      }(je2) && function(rn) {
                        return rn != null && function(qe2) {
                          return typeof qe2 == "number" && qe2 > -1 && qe2 % 1 == 0 && qe2 <= 9007199254740991;
                        }(rn.length) && !function(qe2) {
                          var An = function(jn) {
                            var _n = typeof jn;
                            return !!jn && (_n == "object" || _n == "function");
                          }(qe2) ? it.call(qe2) : "";
                          return An == "[object Function]" || An == "[object GeneratorFunction]";
                        }(rn);
                      }(je2);
                    }(Oe2) && tt.call(Oe2, "callee") && (!mt.call(Oe2, "callee") || it.call(Oe2) == "[object Arguments]");
                  }(Se2) || !!(Mt && Se2 && Se2[Mt]);
                }
                var Ot = Array.isArray, ce2, ae2, de2, we2 = (ae2 = function(Se2) {
                  var Oe2 = (Se2 = function rn(qe2, An, jn, _n, Jr) {
                    var Qn = -1, rr = qe2.length;
                    for (jn || (jn = Gt), Jr || (Jr = []); ++Qn < rr; ) {
                      var Ar = qe2[Qn];
                      An > 0 && jn(Ar) ? An > 1 ? rn(Ar, An - 1, jn, _n, Jr) : Z3(Jr, Ar) : _n || (Jr[Jr.length] = Ar);
                    }
                    return Jr;
                  }(Se2, 1)).length, je2 = Oe2;
                  for (ce2; je2--; )
                    if (typeof Se2[je2] != "function")
                      throw new TypeError("Expected a function");
                  return function() {
                    for (var rn = 0, qe2 = Oe2 ? Se2[rn].apply(this, arguments) : arguments[0]; ++rn < Oe2; )
                      qe2 = Se2[rn].call(this, qe2);
                    return qe2;
                  };
                }, de2 = kt(de2 === void 0 ? ae2.length - 1 : de2, 0), function() {
                  for (var Se2 = arguments, Oe2 = -1, je2 = kt(Se2.length - de2, 0), rn = Array(je2); ++Oe2 < je2; )
                    rn[Oe2] = Se2[de2 + Oe2];
                  Oe2 = -1;
                  for (var qe2 = Array(de2 + 1); ++Oe2 < de2; )
                    qe2[Oe2] = Se2[Oe2];
                  return qe2[de2] = rn, G3(ae2, this, qe2);
                });
                g5.exports = we2;
              }).call(this, S2(43));
            }, function(g5, b6, S2) {
              Object.defineProperty(b6, "__esModule", { value: true }), b6.yuv2rgb = function(A2) {
                var k2, R6, B3, G3 = A2[0], Z3 = A2[1], X3 = A2[2];
                return k2 = 1 * G3 + 0 * Z3 + 1.13983 * X3, R6 = 1 * G3 + -0.39465 * Z3 + -0.5806 * X3, B3 = 1 * G3 + 2.02311 * Z3 + 0 * X3, k2 = Math.min(Math.max(0, k2), 1), R6 = Math.min(Math.max(0, R6), 1), B3 = Math.min(Math.max(0, B3), 1), [255 * k2, 255 * R6, 255 * B3];
              }, b6.rgb2yuv = function(A2) {
                var k2 = A2[0] / 255, R6 = A2[1] / 255, B3 = A2[2] / 255;
                return [0.299 * k2 + 0.587 * R6 + 0.114 * B3, -0.14713 * k2 + -0.28886 * R6 + 0.436 * B3, 0.615 * k2 + -0.51499 * R6 + -0.10001 * B3];
              };
            }, function(g5, b6, S2) {
              function A2(B3, G3, Z3) {
                return G3 in B3 ? Object.defineProperty(B3, G3, { value: Z3, enumerable: true, configurable: true, writable: true }) : B3[G3] = Z3, B3;
              }
              var k2 = S2(141), R6 = function() {
                function B3() {
                  A2(this, "_callbacks", void 0), A2(this, "_isDispatching", void 0), A2(this, "_isHandled", void 0), A2(this, "_isPending", void 0), A2(this, "_lastID", void 0), A2(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
                }
                var G3 = B3.prototype;
                return G3.register = function(Z3) {
                  var X3 = "ID_" + this._lastID++;
                  return this._callbacks[X3] = Z3, X3;
                }, G3.unregister = function(Z3) {
                  this._callbacks[Z3] || k2(false), delete this._callbacks[Z3];
                }, G3.waitFor = function(Z3) {
                  this._isDispatching || k2(false);
                  for (var X3 = 0; X3 < Z3.length; X3++) {
                    var tt = Z3[X3];
                    this._isPending[tt] ? this._isHandled[tt] || k2(false) : (this._callbacks[tt] || k2(false), this._invokeCallback(tt));
                  }
                }, G3.dispatch = function(Z3) {
                  this._isDispatching && k2(false), this._startDispatching(Z3);
                  try {
                    for (var X3 in this._callbacks)
                      this._isPending[X3] || this._invokeCallback(X3);
                  } finally {
                    this._stopDispatching();
                  }
                }, G3.isDispatching = function() {
                  return this._isDispatching;
                }, G3._invokeCallback = function(Z3) {
                  this._isPending[Z3] = true, this._callbacks[Z3](this._pendingPayload), this._isHandled[Z3] = true;
                }, G3._startDispatching = function(Z3) {
                  for (var X3 in this._callbacks)
                    this._isPending[X3] = false, this._isHandled[X3] = false;
                  this._pendingPayload = Z3, this._isDispatching = true;
                }, G3._stopDispatching = function() {
                  delete this._pendingPayload, this._isDispatching = false;
                }, B3;
              }();
              g5.exports = R6;
            }, function(g5, b6, S2) {
              g5.exports = function(A2, k2) {
                for (var R6 = arguments.length, B3 = new Array(R6 > 2 ? R6 - 2 : 0), G3 = 2; G3 < R6; G3++)
                  B3[G3 - 2] = arguments[G3];
                if (!A2) {
                  var Z3;
                  if (k2 === void 0)
                    Z3 = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                  else {
                    var X3 = 0;
                    (Z3 = new Error(k2.replace(/%s/g, function() {
                      return String(B3[X3++]);
                    }))).name = "Invariant Violation";
                  }
                  throw Z3.framesToPop = 1, Z3;
                }
              };
            }, function(g5, b6, S2) {
              function A2(Sr, Ir, Fn) {
                return Ir in Sr ? Object.defineProperty(Sr, Ir, { value: Fn, enumerable: true, configurable: true, writable: true }) : Sr[Ir] = Fn, Sr;
              }
              function k2(Sr, Ir) {
                var Fn = Object.keys(Sr);
                if (Object.getOwnPropertySymbols) {
                  var lr = Object.getOwnPropertySymbols(Sr);
                  Ir && (lr = lr.filter(function(er) {
                    return Object.getOwnPropertyDescriptor(Sr, er).enumerable;
                  })), Fn.push.apply(Fn, lr);
                }
                return Fn;
              }
              function R6(Sr) {
                for (var Ir = 1; Ir < arguments.length; Ir++) {
                  var Fn = arguments[Ir] != null ? arguments[Ir] : {};
                  Ir % 2 ? k2(Object(Fn), true).forEach(function(lr) {
                    A2(Sr, lr, Fn[lr]);
                  }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Sr, Object.getOwnPropertyDescriptors(Fn)) : k2(Object(Fn)).forEach(function(lr) {
                    Object.defineProperty(Sr, lr, Object.getOwnPropertyDescriptor(Fn, lr));
                  });
                }
                return Sr;
              }
              function B3(Sr, Ir) {
                if (!(Sr instanceof Ir))
                  throw new TypeError("Cannot call a class as a function");
              }
              function G3(Sr, Ir) {
                for (var Fn = 0; Fn < Ir.length; Fn++) {
                  var lr = Ir[Fn];
                  lr.enumerable = lr.enumerable || false, lr.configurable = true, "value" in lr && (lr.writable = true), Object.defineProperty(Sr, lr.key, lr);
                }
              }
              function Z3(Sr, Ir, Fn) {
                return Ir && G3(Sr.prototype, Ir), Fn && G3(Sr, Fn), Sr;
              }
              function X3(Sr, Ir) {
                return (X3 = Object.setPrototypeOf || function(Fn, lr) {
                  return Fn.__proto__ = lr, Fn;
                })(Sr, Ir);
              }
              function tt(Sr, Ir) {
                if (typeof Ir != "function" && Ir !== null)
                  throw new TypeError("Super expression must either be null or a function");
                Sr.prototype = Object.create(Ir && Ir.prototype, { constructor: { value: Sr, writable: true, configurable: true } }), Ir && X3(Sr, Ir);
              }
              function it(Sr) {
                return (it = Object.setPrototypeOf ? Object.getPrototypeOf : function(Ir) {
                  return Ir.__proto__ || Object.getPrototypeOf(Ir);
                })(Sr);
              }
              function pt(Sr) {
                return (pt = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Ir) {
                  return typeof Ir;
                } : function(Ir) {
                  return Ir && typeof Symbol == "function" && Ir.constructor === Symbol && Ir !== Symbol.prototype ? "symbol" : typeof Ir;
                })(Sr);
              }
              function mt(Sr) {
                if (Sr === void 0)
                  throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return Sr;
              }
              function Mt(Sr, Ir) {
                return !Ir || pt(Ir) !== "object" && typeof Ir != "function" ? mt(Sr) : Ir;
              }
              function kt(Sr) {
                var Ir = function() {
                  if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                    return false;
                  if (typeof Proxy == "function")
                    return true;
                  try {
                    return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                    })), true;
                  } catch {
                    return false;
                  }
                }();
                return function() {
                  var Fn, lr = it(Sr);
                  if (Ir) {
                    var er = it(this).constructor;
                    Fn = Reflect.construct(lr, arguments, er);
                  } else
                    Fn = lr.apply(this, arguments);
                  return Mt(this, Fn);
                };
              }
              S2.r(b6);
              var Gt = S2(0), Ot = S2.n(Gt);
              function ce2() {
                var Sr = this.constructor.getDerivedStateFromProps(this.props, this.state);
                Sr != null && this.setState(Sr);
              }
              function ae2(Sr) {
                this.setState(function(Ir) {
                  var Fn = this.constructor.getDerivedStateFromProps(Sr, Ir);
                  return Fn != null ? Fn : null;
                }.bind(this));
              }
              function de2(Sr, Ir) {
                try {
                  var Fn = this.props, lr = this.state;
                  this.props = Sr, this.state = Ir, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Fn, lr);
                } finally {
                  this.props = Fn, this.state = lr;
                }
              }
              function we2(Sr) {
                var Ir = Sr.prototype;
                if (!Ir || !Ir.isReactComponent)
                  throw new Error("Can only polyfill class components");
                if (typeof Sr.getDerivedStateFromProps != "function" && typeof Ir.getSnapshotBeforeUpdate != "function")
                  return Sr;
                var Fn = null, lr = null, er = null;
                if (typeof Ir.componentWillMount == "function" ? Fn = "componentWillMount" : typeof Ir.UNSAFE_componentWillMount == "function" && (Fn = "UNSAFE_componentWillMount"), typeof Ir.componentWillReceiveProps == "function" ? lr = "componentWillReceiveProps" : typeof Ir.UNSAFE_componentWillReceiveProps == "function" && (lr = "UNSAFE_componentWillReceiveProps"), typeof Ir.componentWillUpdate == "function" ? er = "componentWillUpdate" : typeof Ir.UNSAFE_componentWillUpdate == "function" && (er = "UNSAFE_componentWillUpdate"), Fn !== null || lr !== null || er !== null) {
                  var Gi2 = Sr.displayName || Sr.name, zi2 = typeof Sr.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                  throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Gi2 + " uses " + zi2 + " but also contains the following legacy lifecycles:" + (Fn !== null ? `
  ` + Fn : "") + (lr !== null ? `
  ` + lr : "") + (er !== null ? `
  ` + er : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
                }
                if (typeof Sr.getDerivedStateFromProps == "function" && (Ir.componentWillMount = ce2, Ir.componentWillReceiveProps = ae2), typeof Ir.getSnapshotBeforeUpdate == "function") {
                  if (typeof Ir.componentDidUpdate != "function")
                    throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                  Ir.componentWillUpdate = de2;
                  var Ta2 = Ir.componentDidUpdate;
                  Ir.componentDidUpdate = function(Li2, zo, ql) {
                    var jf2 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : ql;
                    Ta2.call(this, Li2, zo, jf2);
                  };
                }
                return Sr;
              }
              function Se2(Sr, Ir) {
                if (Sr == null)
                  return {};
                var Fn, lr, er = function(zi2, Ta2) {
                  if (zi2 == null)
                    return {};
                  var Li2, zo, ql = {}, jf2 = Object.keys(zi2);
                  for (zo = 0; zo < jf2.length; zo++)
                    Li2 = jf2[zo], Ta2.indexOf(Li2) >= 0 || (ql[Li2] = zi2[Li2]);
                  return ql;
                }(Sr, Ir);
                if (Object.getOwnPropertySymbols) {
                  var Gi2 = Object.getOwnPropertySymbols(Sr);
                  for (lr = 0; lr < Gi2.length; lr++)
                    Fn = Gi2[lr], Ir.indexOf(Fn) >= 0 || Object.prototype.propertyIsEnumerable.call(Sr, Fn) && (er[Fn] = Sr[Fn]);
                }
                return er;
              }
              function Oe2(Sr) {
                var Ir = function(Fn) {
                  return {}.toString.call(Fn).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
                }(Sr);
                return Ir === "number" && (Ir = isNaN(Sr) ? "nan" : (0 | Sr) != Sr ? "float" : "integer"), Ir;
              }
              ce2.__suppressDeprecationWarning = true, ae2.__suppressDeprecationWarning = true, de2.__suppressDeprecationWarning = true;
              var je2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, rn = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, qe2 = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, An = S2(45), jn = function(Sr) {
                var Ir = function(Fn) {
                  return { backgroundColor: Fn.base00, ellipsisColor: Fn.base09, braceColor: Fn.base07, expandedIcon: Fn.base0D, collapsedIcon: Fn.base0E, keyColor: Fn.base07, arrayKeyColor: Fn.base0C, objectSize: Fn.base04, copyToClipboard: Fn.base0F, copyToClipboardCheck: Fn.base0D, objectBorder: Fn.base02, dataTypes: { boolean: Fn.base0E, date: Fn.base0D, float: Fn.base0B, function: Fn.base0D, integer: Fn.base0F, string: Fn.base09, nan: Fn.base08, null: Fn.base0A, undefined: Fn.base05, regexp: Fn.base0A, background: Fn.base02 }, editVariable: { editIcon: Fn.base0E, cancelIcon: Fn.base09, removeIcon: Fn.base09, addIcon: Fn.base0E, checkIcon: Fn.base0E, background: Fn.base01, color: Fn.base0A, border: Fn.base07 }, addKeyModal: { background: Fn.base05, border: Fn.base04, color: Fn.base0A, labelColor: Fn.base01 }, validationFailure: { background: Fn.base09, iconColor: Fn.base01, fontColor: Fn.base01 } };
                }(Sr);
                return { "app-container": { fontFamily: qe2.globalFontFamily, cursor: qe2.globalCursor, backgroundColor: Ir.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Ir.ellipsisColor, fontSize: qe2.ellipsisFontSize, lineHeight: qe2.ellipsisLineHeight, cursor: qe2.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: qe2.braceCursor, fontWeight: qe2.braceFontWeight, color: Ir.braceColor }, "expanded-icon": { color: Ir.expandedIcon }, "collapsed-icon": { color: Ir.collapsedIcon }, colon: { display: "inline-block", margin: qe2.keyMargin, color: Ir.keyColor, verticalAlign: "top" }, objectKeyVal: function(Fn, lr) {
                  return { style: R6({ paddingTop: qe2.keyValPaddingTop, paddingRight: qe2.keyValPaddingRight, paddingBottom: qe2.keyValPaddingBottom, borderLeft: qe2.keyValBorderLeft + " " + Ir.objectBorder, ":hover": { paddingLeft: lr.paddingLeft - 1 + "px", borderLeft: qe2.keyValBorderHover + " " + Ir.objectBorder } }, lr) };
                }, "object-key-val-no-border": { padding: qe2.keyValPadding }, "pushed-content": { marginLeft: qe2.pushedContentMarginLeft }, variableValue: function(Fn, lr) {
                  return { style: R6({ display: "inline-block", paddingRight: qe2.variableValuePaddingRight, position: "relative" }, lr) };
                }, "object-name": { display: "inline-block", color: Ir.keyColor, letterSpacing: qe2.keyLetterSpacing, fontStyle: qe2.keyFontStyle, verticalAlign: qe2.keyVerticalAlign, opacity: qe2.keyOpacity, ":hover": { opacity: qe2.keyOpacityHover } }, "array-key": { display: "inline-block", color: Ir.arrayKeyColor, letterSpacing: qe2.keyLetterSpacing, fontStyle: qe2.keyFontStyle, verticalAlign: qe2.keyVerticalAlign, opacity: qe2.keyOpacity, ":hover": { opacity: qe2.keyOpacityHover } }, "object-size": { color: Ir.objectSize, borderRadius: qe2.objectSizeBorderRadius, fontStyle: qe2.objectSizeFontStyle, margin: qe2.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: qe2.dataTypeFontSize, marginRight: qe2.dataTypeMarginRight, opacity: qe2.datatypeOpacity }, boolean: { display: "inline-block", color: Ir.dataTypes.boolean }, date: { display: "inline-block", color: Ir.dataTypes.date }, "date-value": { marginLeft: qe2.dateValueMarginLeft }, float: { display: "inline-block", color: Ir.dataTypes.float }, function: { display: "inline-block", color: Ir.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Ir.dataTypes.integer }, string: { display: "inline-block", color: Ir.dataTypes.string }, nan: { display: "inline-block", color: Ir.dataTypes.nan, fontSize: qe2.nanFontSize, fontWeight: qe2.nanFontWeight, backgroundColor: Ir.dataTypes.background, padding: qe2.nanPadding, borderRadius: qe2.nanBorderRadius }, null: { display: "inline-block", color: Ir.dataTypes.null, fontSize: qe2.nullFontSize, fontWeight: qe2.nullFontWeight, backgroundColor: Ir.dataTypes.background, padding: qe2.nullPadding, borderRadius: qe2.nullBorderRadius }, undefined: { display: "inline-block", color: Ir.dataTypes.undefined, fontSize: qe2.undefinedFontSize, padding: qe2.undefinedPadding, borderRadius: qe2.undefinedBorderRadius, backgroundColor: Ir.dataTypes.background }, regexp: { display: "inline-block", color: Ir.dataTypes.regexp }, "copy-to-clipboard": { cursor: qe2.clipboardCursor }, "copy-icon": { color: Ir.copyToClipboard, fontSize: qe2.iconFontSize, marginRight: qe2.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Ir.copyToClipboardCheck, marginLeft: qe2.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: qe2.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: qe2.metaDataPadding }, "icon-container": { display: "inline-block", width: qe2.iconContainerWidth }, tooltip: { padding: qe2.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Ir.editVariable.removeIcon, cursor: qe2.iconCursor, fontSize: qe2.iconFontSize, marginRight: qe2.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Ir.editVariable.addIcon, cursor: qe2.iconCursor, fontSize: qe2.iconFontSize, marginRight: qe2.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Ir.editVariable.editIcon, cursor: qe2.iconCursor, fontSize: qe2.iconFontSize, marginRight: qe2.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: qe2.iconCursor, color: Ir.editVariable.checkIcon, fontSize: qe2.iconFontSize, paddingRight: qe2.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: qe2.iconCursor, color: Ir.editVariable.cancelIcon, fontSize: qe2.iconFontSize, paddingRight: qe2.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: qe2.editInputMinWidth, borderRadius: qe2.editInputBorderRadius, backgroundColor: Ir.editVariable.background, color: Ir.editVariable.color, padding: qe2.editInputPadding, marginRight: qe2.editInputMarginRight, fontFamily: qe2.editInputFontFamily }, "detected-row": { paddingTop: qe2.detectedRowPaddingTop }, "key-modal-request": { position: qe2.addKeyCoverPosition, top: qe2.addKeyCoverPositionPx, left: qe2.addKeyCoverPositionPx, right: qe2.addKeyCoverPositionPx, bottom: qe2.addKeyCoverPositionPx, backgroundColor: qe2.addKeyCoverBackground }, "key-modal": { width: qe2.addKeyModalWidth, backgroundColor: Ir.addKeyModal.background, marginLeft: qe2.addKeyModalMargin, marginRight: qe2.addKeyModalMargin, padding: qe2.addKeyModalPadding, borderRadius: qe2.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Ir.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Ir.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Ir.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Ir.addKeyModal.labelColor, fontSize: qe2.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Ir.editVariable.addIcon, fontSize: qe2.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Ir.ellipsisColor, fontSize: qe2.ellipsisFontSize, lineHeight: qe2.ellipsisLineHeight, cursor: qe2.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Ir.validationFailure.fontColor, backgroundColor: Ir.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Ir.validationFailure.iconColor, fontSize: qe2.iconFontSize, transform: "rotate(45deg)" } };
              };
              function _n(Sr, Ir, Fn) {
                return Sr || console.error("theme has not been set"), function(lr) {
                  var er = je2;
                  return lr !== false && lr !== "none" || (er = rn), Object(An.createStyling)(jn, { defaultBase16: er })(lr);
                }(Sr)(Ir, Fn);
              }
              var Jr = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = (lr.rjvId, lr.type_name), Gi2 = lr.displayDataTypes, zi2 = lr.theme;
                  return Gi2 ? Ot.a.createElement("span", Object.assign({ className: "data-type-label" }, _n(zi2, "data-type-label")), er) : null;
                } }]), Fn;
              }(Ot.a.PureComponent), Qn = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props;
                  return Ot.a.createElement("div", _n(lr.theme, "boolean"), Ot.a.createElement(Jr, Object.assign({ type_name: "bool" }, lr)), lr.value ? "true" : "false");
                } }]), Fn;
              }(Ot.a.PureComponent), rr = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props;
                  return Ot.a.createElement("div", _n(lr.theme, "date"), Ot.a.createElement(Jr, Object.assign({ type_name: "date" }, lr)), Ot.a.createElement("span", Object.assign({ className: "date-value" }, _n(lr.theme, "date-value")), lr.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
                } }]), Fn;
              }(Ot.a.PureComponent), Ar = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props;
                  return Ot.a.createElement("div", _n(lr.theme, "float"), Ot.a.createElement(Jr, Object.assign({ type_name: "float" }, lr)), this.props.value);
                } }]), Fn;
              }(Ot.a.PureComponent);
              function fi2(Sr, Ir) {
                (Ir == null || Ir > Sr.length) && (Ir = Sr.length);
                for (var Fn = 0, lr = new Array(Ir); Fn < Ir; Fn++)
                  lr[Fn] = Sr[Fn];
                return lr;
              }
              function mi2(Sr, Ir) {
                if (Sr) {
                  if (typeof Sr == "string")
                    return fi2(Sr, Ir);
                  var Fn = Object.prototype.toString.call(Sr).slice(8, -1);
                  return Fn === "Object" && Sr.constructor && (Fn = Sr.constructor.name), Fn === "Map" || Fn === "Set" ? Array.from(Sr) : Fn === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Fn) ? fi2(Sr, Ir) : void 0;
                }
              }
              function Oo(Sr, Ir) {
                var Fn;
                if (typeof Symbol == "undefined" || Sr[Symbol.iterator] == null) {
                  if (Array.isArray(Sr) || (Fn = mi2(Sr)) || Ir && Sr && typeof Sr.length == "number") {
                    Fn && (Sr = Fn);
                    var lr = 0, er = function() {
                    };
                    return { s: er, n: function() {
                      return lr >= Sr.length ? { done: true } : { done: false, value: Sr[lr++] };
                    }, e: function(Li2) {
                      throw Li2;
                    }, f: er };
                  }
                  throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                }
                var Gi2, zi2 = true, Ta2 = false;
                return { s: function() {
                  Fn = Sr[Symbol.iterator]();
                }, n: function() {
                  var Li2 = Fn.next();
                  return zi2 = Li2.done, Li2;
                }, e: function(Li2) {
                  Ta2 = true, Gi2 = Li2;
                }, f: function() {
                  try {
                    zi2 || Fn.return == null || Fn.return();
                  } finally {
                    if (Ta2)
                      throw Gi2;
                  }
                } };
              }
              function Ts(Sr) {
                return function(Ir) {
                  if (Array.isArray(Ir))
                    return fi2(Ir);
                }(Sr) || function(Ir) {
                  if (typeof Symbol != "undefined" && Symbol.iterator in Object(Ir))
                    return Array.from(Ir);
                }(Sr) || mi2(Sr) || function() {
                  throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                }();
              }
              var gl = S2(46), nl = new (S2(47)).Dispatcher(), rl = new (function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  var lr;
                  B3(this, Fn);
                  for (var er = arguments.length, Gi2 = new Array(er), zi2 = 0; zi2 < er; zi2++)
                    Gi2[zi2] = arguments[zi2];
                  return (lr = Ir.call.apply(Ir, [this].concat(Gi2))).objects = {}, lr.set = function(Ta2, Li2, zo, ql) {
                    lr.objects[Ta2] === void 0 && (lr.objects[Ta2] = {}), lr.objects[Ta2][Li2] === void 0 && (lr.objects[Ta2][Li2] = {}), lr.objects[Ta2][Li2][zo] = ql;
                  }, lr.get = function(Ta2, Li2, zo, ql) {
                    return lr.objects[Ta2] === void 0 || lr.objects[Ta2][Li2] === void 0 || lr.objects[Ta2][Li2][zo] == null ? ql : lr.objects[Ta2][Li2][zo];
                  }, lr.handleAction = function(Ta2) {
                    var Li2 = Ta2.rjvId, zo = Ta2.data;
                    switch (Ta2.name) {
                      case "RESET":
                        lr.emit("reset-" + Li2);
                        break;
                      case "VARIABLE_UPDATED":
                        Ta2.data.updated_src = lr.updateSrc(Li2, zo), lr.set(Li2, "action", "variable-update", R6(R6({}, zo), {}, { type: "variable-edited" })), lr.emit("variable-update-" + Li2);
                        break;
                      case "VARIABLE_REMOVED":
                        Ta2.data.updated_src = lr.updateSrc(Li2, zo), lr.set(Li2, "action", "variable-update", R6(R6({}, zo), {}, { type: "variable-removed" })), lr.emit("variable-update-" + Li2);
                        break;
                      case "VARIABLE_ADDED":
                        Ta2.data.updated_src = lr.updateSrc(Li2, zo), lr.set(Li2, "action", "variable-update", R6(R6({}, zo), {}, { type: "variable-added" })), lr.emit("variable-update-" + Li2);
                        break;
                      case "ADD_VARIABLE_KEY_REQUEST":
                        lr.set(Li2, "action", "new-key-request", zo), lr.emit("add-key-request-" + Li2);
                    }
                  }, lr.updateSrc = function(Ta2, Li2) {
                    var zo = Li2.name, ql = Li2.namespace, jf2 = Li2.new_value, Ic2 = (Li2.existing_value, Li2.variable_removed);
                    ql.shift();
                    var Ad2, jc2 = lr.get(Ta2, "global", "src"), dd2 = lr.deepCopy(jc2, Ts(ql)), Bd2 = dd2, du = Oo(ql);
                    try {
                      for (du.s(); !(Ad2 = du.n()).done; )
                        Bd2 = Bd2[Ad2.value];
                    } catch (id2) {
                      du.e(id2);
                    } finally {
                      du.f();
                    }
                    return Ic2 ? Oe2(Bd2) == "array" ? Bd2.splice(zo, 1) : delete Bd2[zo] : zo !== null ? Bd2[zo] = jf2 : dd2 = jf2, lr.set(Ta2, "global", "src", dd2), dd2;
                  }, lr.deepCopy = function(Ta2, Li2) {
                    var zo, ql = Oe2(Ta2), jf2 = Li2.shift();
                    return ql == "array" ? zo = Ts(Ta2) : ql == "object" && (zo = R6({}, Ta2)), jf2 !== void 0 && (zo[jf2] = lr.deepCopy(Ta2[jf2], Li2)), zo;
                  }, lr;
                }
                return Fn;
              }(gl.EventEmitter))();
              nl.register(rl.handleAction.bind(rl));
              var ss = rl, Us = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  return B3(this, Fn), (er = Ir.call(this, lr)).toggleCollapsed = function() {
                    er.setState({ collapsed: !er.state.collapsed }, function() {
                      ss.set(er.props.rjvId, er.props.namespace, "collapsed", er.state.collapsed);
                    });
                  }, er.getFunctionDisplay = function(Gi2) {
                    var zi2 = mt(er).props;
                    return Gi2 ? Ot.a.createElement("span", null, er.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), Ot.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, Ot.a.createElement("span", null, "{"), Ot.a.createElement("span", _n(zi2.theme, "ellipsis"), "..."), Ot.a.createElement("span", null, "}"))) : er.props.value.toString().slice(9, -1);
                  }, er.state = { collapsed: ss.get(lr.rjvId, lr.namespace, "collapsed", true) }, er;
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = this.state.collapsed;
                  return Ot.a.createElement("div", _n(lr.theme, "function"), Ot.a.createElement(Jr, Object.assign({ type_name: "function" }, lr)), Ot.a.createElement("span", Object.assign({}, _n(lr.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(er)));
                } }]), Fn;
              }(Ot.a.PureComponent), sl = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  return Ot.a.createElement("div", _n(this.props.theme, "nan"), "NaN");
                } }]), Fn;
              }(Ot.a.PureComponent), ws = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  return Ot.a.createElement("div", _n(this.props.theme, "null"), "NULL");
                } }]), Fn;
              }(Ot.a.PureComponent), Ll = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props;
                  return Ot.a.createElement("div", _n(lr.theme, "integer"), Ot.a.createElement(Jr, Object.assign({ type_name: "int" }, lr)), this.props.value);
                } }]), Fn;
              }(Ot.a.PureComponent), dh2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props;
                  return Ot.a.createElement("div", _n(lr.theme, "regexp"), Ot.a.createElement(Jr, Object.assign({ type_name: "regexp" }, lr)), this.props.value.toString());
                } }]), Fn;
              }(Ot.a.PureComponent), hu = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  return B3(this, Fn), (er = Ir.call(this, lr)).toggleCollapsed = function() {
                    er.setState({ collapsed: !er.state.collapsed }, function() {
                      ss.set(er.props.rjvId, er.props.namespace, "collapsed", er.state.collapsed);
                    });
                  }, er.state = { collapsed: ss.get(lr.rjvId, lr.namespace, "collapsed", true) }, er;
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  this.state.collapsed;
                  var lr = this.props, er = lr.collapseStringsAfterLength, Gi2 = lr.theme, zi2 = lr.value, Ta2 = { style: { cursor: "default" } };
                  return Oe2(er) === "integer" && zi2.length > er && (Ta2.style.cursor = "pointer", this.state.collapsed && (zi2 = Ot.a.createElement("span", null, zi2.substring(0, er), Ot.a.createElement("span", _n(Gi2, "ellipsis"), " ...")))), Ot.a.createElement("div", _n(Gi2, "string"), Ot.a.createElement(Jr, Object.assign({ type_name: "string" }, lr)), Ot.a.createElement("span", Object.assign({ className: "string-value" }, Ta2, { onClick: this.toggleCollapsed }), '"', zi2, '"'));
                } }]), Fn;
              }(Ot.a.PureComponent), Nh2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  return Ot.a.createElement("div", _n(this.props.theme, "undefined"), "undefined");
                } }]), Fn;
              }(Ot.a.PureComponent);
              function cp() {
                return (cp = Object.assign || function(Sr) {
                  for (var Ir = 1; Ir < arguments.length; Ir++) {
                    var Fn = arguments[Ir];
                    for (var lr in Fn)
                      Object.prototype.hasOwnProperty.call(Fn, lr) && (Sr[lr] = Fn[lr]);
                  }
                  return Sr;
                }).apply(this, arguments);
              }
              var Xh2 = Gt.useLayoutEffect, om = function(Sr) {
                var Ir = Object(Gt.useRef)(Sr);
                return Xh2(function() {
                  Ir.current = Sr;
                }), Ir;
              }, Sv = function(Sr, Ir) {
                typeof Sr != "function" ? Sr.current = Ir : Sr(Ir);
              }, U1 = function(Sr, Ir) {
                var Fn = Object(Gt.useRef)();
                return Object(Gt.useCallback)(function(lr) {
                  Sr.current = lr, Fn.current && Sv(Fn.current, null), Fn.current = Ir, Ir && Sv(Ir, lr);
                }, [Ir]);
              }, Jd2 = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, jv = function(Sr) {
                Object.keys(Jd2).forEach(function(Ir) {
                  Sr.style.setProperty(Ir, Jd2[Ir], "important");
                });
              }, Mv = null, fT = function() {
              }, yo = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], oa2 = !!document.documentElement.currentStyle, ea2 = function(Sr, Ir) {
                var Fn = Sr.cacheMeasurements, lr = Sr.maxRows, er = Sr.minRows, Gi2 = Sr.onChange, zi2 = Gi2 === void 0 ? fT : Gi2, Ta2 = Sr.onHeightChange, Li2 = Ta2 === void 0 ? fT : Ta2, zo = function(du, id2) {
                  if (du == null)
                    return {};
                  var Ax, hT, b9 = {}, Qw = Object.keys(du);
                  for (hT = 0; hT < Qw.length; hT++)
                    Ax = Qw[hT], id2.indexOf(Ax) >= 0 || (b9[Ax] = du[Ax]);
                  return b9;
                }(Sr, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), ql, jf2 = zo.value !== void 0, Ic2 = Object(Gt.useRef)(null), Ad2 = U1(Ic2, Ir), jc2 = Object(Gt.useRef)(0), dd2 = Object(Gt.useRef)(), Bd2 = function() {
                  var du = Ic2.current, id2 = Fn && dd2.current ? dd2.current : function(Qw) {
                    var Rk = window.getComputedStyle(Qw);
                    if (Rk === null)
                      return null;
                    var Nk, ey = (Nk = Rk, yo.reduce(function(LR, Fk) {
                      return LR[Fk] = Nk[Fk], LR;
                    }, {})), hD = ey.boxSizing;
                    return hD === "" ? null : (oa2 && hD === "border-box" && (ey.width = parseFloat(ey.width) + parseFloat(ey.borderRightWidth) + parseFloat(ey.borderLeftWidth) + parseFloat(ey.paddingRight) + parseFloat(ey.paddingLeft) + "px"), { sizingStyle: ey, paddingSize: parseFloat(ey.paddingBottom) + parseFloat(ey.paddingTop), borderSize: parseFloat(ey.borderBottomWidth) + parseFloat(ey.borderTopWidth) });
                  }(du);
                  if (id2) {
                    dd2.current = id2;
                    var Ax = function(Qw, Rk, Nk, ey) {
                      Nk === void 0 && (Nk = 1), ey === void 0 && (ey = 1 / 0), Mv || ((Mv = document.createElement("textarea")).setAttribute("tab-index", "-1"), Mv.setAttribute("aria-hidden", "true"), jv(Mv)), Mv.parentNode === null && document.body.appendChild(Mv);
                      var hD = Qw.paddingSize, LR = Qw.borderSize, Fk = Qw.sizingStyle, OR = Fk.boxSizing;
                      Object.keys(Fk).forEach(function(NR) {
                        var j3 = NR;
                        Mv.style[j3] = Fk[j3];
                      }), jv(Mv), Mv.value = Rk;
                      var z32 = function(NR, j3) {
                        var IM = NR.scrollHeight;
                        return j3.sizingStyle.boxSizing === "border-box" ? IM + j3.borderSize : IM - j3.paddingSize;
                      }(Mv, Qw);
                      Mv.value = "x";
                      var Z1 = Mv.scrollHeight - hD, RR = Z1 * Nk;
                      OR === "border-box" && (RR = RR + hD + LR), z32 = Math.max(RR, z32);
                      var pD = Z1 * ey;
                      return OR === "border-box" && (pD = pD + hD + LR), [z32 = Math.min(pD, z32), Z1];
                    }(id2, du.value || du.placeholder || "x", er, lr), hT = Ax[0], b9 = Ax[1];
                    jc2.current !== hT && (jc2.current = hT, du.style.setProperty("height", hT + "px", "important"), Li2(hT, { rowHeight: b9 }));
                  }
                };
                return Object(Gt.useLayoutEffect)(Bd2), ql = om(Bd2), Object(Gt.useLayoutEffect)(function() {
                  var du = function(id2) {
                    ql.current(id2);
                  };
                  return window.addEventListener("resize", du), function() {
                    window.removeEventListener("resize", du);
                  };
                }, []), Object(Gt.createElement)("textarea", cp({}, zo, { onChange: function(du) {
                  jf2 || Bd2(), zi2(du);
                }, ref: Ad2 }));
              }, _o = Object(Gt.forwardRef)(ea2);
              function Vs(Sr) {
                Sr = Sr.trim();
                try {
                  if ((Sr = JSON.stringify(JSON.parse(Sr)))[0] === "[")
                    return ru("array", JSON.parse(Sr));
                  if (Sr[0] === "{")
                    return ru("object", JSON.parse(Sr));
                  if (Sr.match(/\-?\d+\.\d+/) && Sr.match(/\-?\d+\.\d+/)[0] === Sr)
                    return ru("float", parseFloat(Sr));
                  if (Sr.match(/\-?\d+e-\d+/) && Sr.match(/\-?\d+e-\d+/)[0] === Sr)
                    return ru("float", Number(Sr));
                  if (Sr.match(/\-?\d+/) && Sr.match(/\-?\d+/)[0] === Sr)
                    return ru("integer", parseInt(Sr));
                  if (Sr.match(/\-?\d+e\+\d+/) && Sr.match(/\-?\d+e\+\d+/)[0] === Sr)
                    return ru("integer", Number(Sr));
                } catch {
                }
                switch (Sr = Sr.toLowerCase()) {
                  case "undefined":
                    return ru("undefined", void 0);
                  case "nan":
                    return ru("nan", NaN);
                  case "null":
                    return ru("null", null);
                  case "true":
                    return ru("boolean", true);
                  case "false":
                    return ru("boolean", false);
                  default:
                    if (Sr = Date.parse(Sr))
                      return ru("date", new Date(Sr));
                }
                return ru(false, null);
              }
              function ru(Sr, Ir) {
                return { type: Sr, value: Ir };
              }
              var kf2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
                } }]), Fn;
              }(Ot.a.PureComponent), wf2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
                } }]), Fn;
              }(Ot.a.PureComponent), rd2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]), zi2 = Qh2(er).style;
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", { fill: zi2.color, width: zi2.height, height: zi2.width, style: zi2, viewBox: "0 0 1792 1792" }, Ot.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                } }]), Fn;
              }(Ot.a.PureComponent), Cv = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]), zi2 = Qh2(er).style;
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", { fill: zi2.color, width: zi2.height, height: zi2.width, style: zi2, viewBox: "0 0 1792 1792" }, Ot.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                } }]), Fn;
              }(Ot.a.PureComponent), kg2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", { style: R6(R6({}, Qh2(er).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Ot.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
                } }]), Fn;
              }(Ot.a.PureComponent), ty = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", { style: R6(R6({}, Qh2(er).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Ot.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
                } }]), Fn;
              }(Ot.a.PureComponent), Pg2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("g", null, Ot.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
                } }]), Fn;
              }(Ot.a.PureComponent), $b2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("g", null, Ot.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), Fn;
              }(Ot.a.PureComponent), Mx = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("g", null, Ot.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), Fn;
              }(Ot.a.PureComponent), _2 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("g", null, Ot.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
                } }]), Fn;
              }(Ot.a.PureComponent), Cx = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("g", null, Ot.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
                } }]), Fn;
              }(Ot.a.PureComponent), p0 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.style, Gi2 = Se2(lr, ["style"]);
                  return Ot.a.createElement("span", Gi2, Ot.a.createElement("svg", Object.assign({}, Qh2(er), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ot.a.createElement("g", null, Ot.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), Fn;
              }(Ot.a.PureComponent);
              function Qh2(Sr) {
                return Sr || (Sr = {}), { style: R6(R6({ verticalAlign: "middle" }, Sr), {}, { color: Sr.color ? Sr.color : "#000000", height: "1em", width: "1em" }) };
              }
              var sm = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  return B3(this, Fn), (er = Ir.call(this, lr)).copiedTimer = null, er.handleCopy = function() {
                    var Gi2 = document.createElement("textarea"), zi2 = er.props, Ta2 = zi2.clickCallback, Li2 = zi2.src, zo = zi2.namespace;
                    Gi2.innerHTML = JSON.stringify(er.clipboardValue(Li2), null, "  "), document.body.appendChild(Gi2), Gi2.select(), document.execCommand("copy"), document.body.removeChild(Gi2), er.copiedTimer = setTimeout(function() {
                      er.setState({ copied: false });
                    }, 5500), er.setState({ copied: true }, function() {
                      typeof Ta2 == "function" && Ta2({ src: Li2, namespace: zo, name: zo[zo.length - 1] });
                    });
                  }, er.getClippyIcon = function() {
                    var Gi2 = er.props.theme;
                    return er.state.copied ? Ot.a.createElement("span", null, Ot.a.createElement(Pg2, Object.assign({ className: "copy-icon" }, _n(Gi2, "copy-icon"))), Ot.a.createElement("span", _n(Gi2, "copy-icon-copied"), "\u2714")) : Ot.a.createElement(Pg2, Object.assign({ className: "copy-icon" }, _n(Gi2, "copy-icon")));
                  }, er.clipboardValue = function(Gi2) {
                    switch (Oe2(Gi2)) {
                      case "function":
                      case "regexp":
                        return Gi2.toString();
                      default:
                        return Gi2;
                    }
                  }, er.state = { copied: false }, er;
                }
                return Z3(Fn, [{ key: "componentWillUnmount", value: function() {
                  this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
                } }, { key: "render", value: function() {
                  var lr = this.props, er = (lr.src, lr.theme), Gi2 = lr.hidden, zi2 = lr.rowHovered, Ta2 = _n(er, "copy-to-clipboard").style, Li2 = "inline";
                  return Gi2 && (Li2 = "none"), Ot.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: zi2 ? "inline-block" : "none" } }, Ot.a.createElement("span", { style: R6(R6({}, Ta2), {}, { display: Li2 }), onClick: this.handleCopy }, this.getClippyIcon()));
                } }]), Fn;
              }(Ot.a.PureComponent), q1 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  return B3(this, Fn), (er = Ir.call(this, lr)).getEditIcon = function() {
                    var Gi2 = er.props, zi2 = Gi2.variable, Ta2 = Gi2.theme;
                    return Ot.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: er.state.hovered ? "inline-block" : "none" } }, Ot.a.createElement(Cx, Object.assign({ className: "click-to-edit-icon" }, _n(Ta2, "editVarIcon"), { onClick: function() {
                      er.prepopInput(zi2);
                    } })));
                  }, er.prepopInput = function(Gi2) {
                    if (er.props.onEdit !== false) {
                      var zi2 = function(Li2) {
                        var zo;
                        switch (Oe2(Li2)) {
                          case "undefined":
                            zo = "undefined";
                            break;
                          case "nan":
                            zo = "NaN";
                            break;
                          case "string":
                            zo = Li2;
                            break;
                          case "date":
                          case "function":
                          case "regexp":
                            zo = Li2.toString();
                            break;
                          default:
                            try {
                              zo = JSON.stringify(Li2, null, "  ");
                            } catch {
                              zo = "";
                            }
                        }
                        return zo;
                      }(Gi2.value), Ta2 = Vs(zi2);
                      er.setState({ editMode: true, editValue: zi2, parsedInput: { type: Ta2.type, value: Ta2.value } });
                    }
                  }, er.getRemoveIcon = function() {
                    var Gi2 = er.props, zi2 = Gi2.variable, Ta2 = Gi2.namespace, Li2 = Gi2.theme, zo = Gi2.rjvId;
                    return Ot.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: er.state.hovered ? "inline-block" : "none" } }, Ot.a.createElement($b2, Object.assign({ className: "click-to-remove-icon" }, _n(Li2, "removeVarIcon"), { onClick: function() {
                      nl.dispatch({ name: "VARIABLE_REMOVED", rjvId: zo, data: { name: zi2.name, namespace: Ta2, existing_value: zi2.value, variable_removed: true } });
                    } })));
                  }, er.getValue = function(Gi2, zi2) {
                    var Ta2 = !zi2 && Gi2.type, Li2 = mt(er).props;
                    switch (Ta2) {
                      case false:
                        return er.getEditInput();
                      case "string":
                        return Ot.a.createElement(hu, Object.assign({ value: Gi2.value }, Li2));
                      case "integer":
                        return Ot.a.createElement(Ll, Object.assign({ value: Gi2.value }, Li2));
                      case "float":
                        return Ot.a.createElement(Ar, Object.assign({ value: Gi2.value }, Li2));
                      case "boolean":
                        return Ot.a.createElement(Qn, Object.assign({ value: Gi2.value }, Li2));
                      case "function":
                        return Ot.a.createElement(Us, Object.assign({ value: Gi2.value }, Li2));
                      case "null":
                        return Ot.a.createElement(ws, Li2);
                      case "nan":
                        return Ot.a.createElement(sl, Li2);
                      case "undefined":
                        return Ot.a.createElement(Nh2, Li2);
                      case "date":
                        return Ot.a.createElement(rr, Object.assign({ value: Gi2.value }, Li2));
                      case "regexp":
                        return Ot.a.createElement(dh2, Object.assign({ value: Gi2.value }, Li2));
                      default:
                        return Ot.a.createElement("div", { className: "object-value" }, JSON.stringify(Gi2.value));
                    }
                  }, er.getEditInput = function() {
                    var Gi2 = er.props.theme, zi2 = er.state.editValue;
                    return Ot.a.createElement("div", null, Ot.a.createElement(_o, Object.assign({ type: "text", inputRef: function(Ta2) {
                      return Ta2 && Ta2.focus();
                    }, value: zi2, className: "variable-editor", onChange: function(Ta2) {
                      var Li2 = Ta2.target.value, zo = Vs(Li2);
                      er.setState({ editValue: Li2, parsedInput: { type: zo.type, value: zo.value } });
                    }, onKeyDown: function(Ta2) {
                      switch (Ta2.key) {
                        case "Escape":
                          er.setState({ editMode: false, editValue: "" });
                          break;
                        case "Enter":
                          (Ta2.ctrlKey || Ta2.metaKey) && er.submitEdit(true);
                      }
                      Ta2.stopPropagation();
                    }, placeholder: "update this value", minRows: 2 }, _n(Gi2, "edit-input"))), Ot.a.createElement("div", _n(Gi2, "edit-icon-container"), Ot.a.createElement($b2, Object.assign({ className: "edit-cancel" }, _n(Gi2, "cancel-icon"), { onClick: function() {
                      er.setState({ editMode: false, editValue: "" });
                    } })), Ot.a.createElement(p0, Object.assign({ className: "edit-check string-value" }, _n(Gi2, "check-icon"), { onClick: function() {
                      er.submitEdit();
                    } })), Ot.a.createElement("div", null, er.showDetected())));
                  }, er.submitEdit = function(Gi2) {
                    var zi2 = er.props, Ta2 = zi2.variable, Li2 = zi2.namespace, zo = zi2.rjvId, ql = er.state, jf2 = ql.editValue, Ic2 = ql.parsedInput, Ad2 = jf2;
                    Gi2 && Ic2.type && (Ad2 = Ic2.value), er.setState({ editMode: false }), nl.dispatch({ name: "VARIABLE_UPDATED", rjvId: zo, data: { name: Ta2.name, namespace: Li2, existing_value: Ta2.value, new_value: Ad2, variable_removed: false } });
                  }, er.showDetected = function() {
                    var Gi2 = er.props, zi2 = Gi2.theme, Ta2 = (Gi2.variable, Gi2.namespace, Gi2.rjvId, er.state.parsedInput), Li2 = (Ta2.type, Ta2.value, er.getDetectedInput());
                    if (Li2)
                      return Ot.a.createElement("div", null, Ot.a.createElement("div", _n(zi2, "detected-row"), Li2, Ot.a.createElement(p0, { className: "edit-check detected", style: R6({ verticalAlign: "top", paddingLeft: "3px" }, _n(zi2, "check-icon").style), onClick: function() {
                        er.submitEdit(true);
                      } })));
                  }, er.getDetectedInput = function() {
                    var Gi2 = er.state.parsedInput, zi2 = Gi2.type, Ta2 = Gi2.value, Li2 = mt(er).props, zo = Li2.theme;
                    if (zi2 !== false)
                      switch (zi2.toLowerCase()) {
                        case "object":
                          return Ot.a.createElement("span", null, Ot.a.createElement("span", { style: R6(R6({}, _n(zo, "brace").style), {}, { cursor: "default" }) }, "{"), Ot.a.createElement("span", { style: R6(R6({}, _n(zo, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Ot.a.createElement("span", { style: R6(R6({}, _n(zo, "brace").style), {}, { cursor: "default" }) }, "}"));
                        case "array":
                          return Ot.a.createElement("span", null, Ot.a.createElement("span", { style: R6(R6({}, _n(zo, "brace").style), {}, { cursor: "default" }) }, "["), Ot.a.createElement("span", { style: R6(R6({}, _n(zo, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Ot.a.createElement("span", { style: R6(R6({}, _n(zo, "brace").style), {}, { cursor: "default" }) }, "]"));
                        case "string":
                          return Ot.a.createElement(hu, Object.assign({ value: Ta2 }, Li2));
                        case "integer":
                          return Ot.a.createElement(Ll, Object.assign({ value: Ta2 }, Li2));
                        case "float":
                          return Ot.a.createElement(Ar, Object.assign({ value: Ta2 }, Li2));
                        case "boolean":
                          return Ot.a.createElement(Qn, Object.assign({ value: Ta2 }, Li2));
                        case "function":
                          return Ot.a.createElement(Us, Object.assign({ value: Ta2 }, Li2));
                        case "null":
                          return Ot.a.createElement(ws, Li2);
                        case "nan":
                          return Ot.a.createElement(sl, Li2);
                        case "undefined":
                          return Ot.a.createElement(Nh2, Li2);
                        case "date":
                          return Ot.a.createElement(rr, Object.assign({ value: new Date(Ta2) }, Li2));
                      }
                  }, er.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, er;
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this, er = this.props, Gi2 = er.variable, zi2 = er.singleIndent, Ta2 = er.type, Li2 = er.theme, zo = er.namespace, ql = er.indentWidth, jf2 = er.enableClipboard, Ic2 = er.onEdit, Ad2 = er.onDelete, jc2 = er.onSelect, dd2 = er.displayArrayKey, Bd2 = er.quotesOnKeys, du = this.state.editMode;
                  return Ot.a.createElement("div", Object.assign({}, _n(Li2, "objectKeyVal", { paddingLeft: ql * zi2 }), { onMouseEnter: function() {
                    return lr.setState(R6(R6({}, lr.state), {}, { hovered: true }));
                  }, onMouseLeave: function() {
                    return lr.setState(R6(R6({}, lr.state), {}, { hovered: false }));
                  }, className: "variable-row", key: Gi2.name }), Ta2 == "array" ? dd2 ? Ot.a.createElement("span", Object.assign({}, _n(Li2, "array-key"), { key: Gi2.name + "_" + zo }), Gi2.name, Ot.a.createElement("div", _n(Li2, "colon"), ":")) : null : Ot.a.createElement("span", null, Ot.a.createElement("span", Object.assign({}, _n(Li2, "object-name"), { className: "object-key", key: Gi2.name + "_" + zo }), !!Bd2 && Ot.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Ot.a.createElement("span", { style: { display: "inline-block" } }, Gi2.name), !!Bd2 && Ot.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Ot.a.createElement("span", _n(Li2, "colon"), ":")), Ot.a.createElement("div", Object.assign({ className: "variable-value", onClick: jc2 === false && Ic2 === false ? null : function(id2) {
                    var Ax = Ts(zo);
                    (id2.ctrlKey || id2.metaKey) && Ic2 !== false ? lr.prepopInput(Gi2) : jc2 !== false && (Ax.shift(), jc2(R6(R6({}, Gi2), {}, { namespace: Ax })));
                  } }, _n(Li2, "variableValue", { cursor: jc2 === false ? "default" : "pointer" })), this.getValue(Gi2, du)), jf2 ? Ot.a.createElement(sm, { rowHovered: this.state.hovered, hidden: du, src: Gi2.value, clickCallback: jf2, theme: Li2, namespace: [].concat(Ts(zo), [Gi2.name]) }) : null, Ic2 !== false && du == 0 ? this.getEditIcon() : null, Ad2 !== false && du == 0 ? this.getRemoveIcon() : null);
                } }]), Fn;
              }(Ot.a.PureComponent), AM = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  var lr;
                  B3(this, Fn);
                  for (var er = arguments.length, Gi2 = new Array(er), zi2 = 0; zi2 < er; zi2++)
                    Gi2[zi2] = arguments[zi2];
                  return (lr = Ir.call.apply(Ir, [this].concat(Gi2))).getObjectSize = function() {
                    var Ta2 = lr.props, Li2 = Ta2.size, zo = Ta2.theme;
                    if (Ta2.displayObjectSize)
                      return Ot.a.createElement("span", Object.assign({ className: "object-size" }, _n(zo, "object-size")), Li2, " item", Li2 === 1 ? "" : "s");
                  }, lr.getAddAttribute = function(Ta2) {
                    var Li2 = lr.props, zo = Li2.theme, ql = Li2.namespace, jf2 = Li2.name, Ic2 = Li2.src, Ad2 = Li2.rjvId, jc2 = Li2.depth;
                    return Ot.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: Ta2 ? "inline-block" : "none" } }, Ot.a.createElement(Mx, Object.assign({ className: "click-to-add-icon" }, _n(zo, "addVarIcon"), { onClick: function() {
                      var dd2 = { name: jc2 > 0 ? jf2 : null, namespace: ql.splice(0, ql.length - 1), existing_value: Ic2, variable_removed: false, key_name: null };
                      Oe2(Ic2) === "object" ? nl.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Ad2, data: dd2 }) : nl.dispatch({ name: "VARIABLE_ADDED", rjvId: Ad2, data: R6(R6({}, dd2), {}, { new_value: [].concat(Ts(Ic2), [null]) }) });
                    } })));
                  }, lr.getRemoveObject = function(Ta2) {
                    var Li2 = lr.props, zo = Li2.theme, ql = (Li2.hover, Li2.namespace), jf2 = Li2.name, Ic2 = Li2.src, Ad2 = Li2.rjvId;
                    if (ql.length !== 1)
                      return Ot.a.createElement("span", { className: "click-to-remove", style: { display: Ta2 ? "inline-block" : "none" } }, Ot.a.createElement($b2, Object.assign({ className: "click-to-remove-icon" }, _n(zo, "removeVarIcon"), { onClick: function() {
                        nl.dispatch({ name: "VARIABLE_REMOVED", rjvId: Ad2, data: { name: jf2, namespace: ql.splice(0, ql.length - 1), existing_value: Ic2, variable_removed: true } });
                      } })));
                  }, lr.render = function() {
                    var Ta2 = lr.props, Li2 = Ta2.theme, zo = Ta2.onDelete, ql = Ta2.onAdd, jf2 = Ta2.enableClipboard, Ic2 = Ta2.src, Ad2 = Ta2.namespace, jc2 = Ta2.rowHovered;
                    return Ot.a.createElement("div", Object.assign({}, _n(Li2, "object-meta-data"), { className: "object-meta-data", onClick: function(dd2) {
                      dd2.stopPropagation();
                    } }), lr.getObjectSize(), jf2 ? Ot.a.createElement(sm, { rowHovered: jc2, clickCallback: jf2, src: Ic2, theme: Li2, namespace: Ad2 }) : null, ql !== false ? lr.getAddAttribute(jc2) : null, zo !== false ? lr.getRemoveObject(jc2) : null);
                  }, lr;
                }
                return Fn;
              }(Ot.a.PureComponent);
              function Xw(Sr) {
                var Ir = Sr.parent_type, Fn = Sr.namespace, lr = Sr.quotesOnKeys, er = Sr.theme, Gi2 = Sr.jsvRoot, zi2 = Sr.name, Ta2 = Sr.displayArrayKey, Li2 = Sr.name ? Sr.name : "";
                return !Gi2 || zi2 !== false && zi2 !== null ? Ir == "array" ? Ta2 ? Ot.a.createElement("span", Object.assign({}, _n(er, "array-key"), { key: Fn }), Ot.a.createElement("span", { className: "array-key" }, Li2), Ot.a.createElement("span", _n(er, "colon"), ":")) : Ot.a.createElement("span", null) : Ot.a.createElement("span", Object.assign({}, _n(er, "object-name"), { key: Fn }), Ot.a.createElement("span", { className: "object-key" }, lr && Ot.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Ot.a.createElement("span", null, Li2), lr && Ot.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Ot.a.createElement("span", _n(er, "colon"), ":")) : Ot.a.createElement("span", null);
              }
              function Tx(Sr) {
                var Ir = Sr.theme;
                switch (Sr.iconStyle) {
                  case "triangle":
                    return Ot.a.createElement(ty, Object.assign({}, _n(Ir, "expanded-icon"), { className: "expanded-icon" }));
                  case "square":
                    return Ot.a.createElement(rd2, Object.assign({}, _n(Ir, "expanded-icon"), { className: "expanded-icon" }));
                  default:
                    return Ot.a.createElement(kf2, Object.assign({}, _n(Ir, "expanded-icon"), { className: "expanded-icon" }));
                }
              }
              function x22(Sr) {
                var Ir = Sr.theme;
                switch (Sr.iconStyle) {
                  case "triangle":
                    return Ot.a.createElement(kg2, Object.assign({}, _n(Ir, "collapsed-icon"), { className: "collapsed-icon" }));
                  case "square":
                    return Ot.a.createElement(Cv, Object.assign({}, _n(Ir, "collapsed-icon"), { className: "collapsed-icon" }));
                  default:
                    return Ot.a.createElement(wf2, Object.assign({}, _n(Ir, "collapsed-icon"), { className: "collapsed-icon" }));
                }
              }
              var cD = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  return B3(this, Fn), (er = Ir.call(this, lr)).toggleCollapsed = function(Gi2) {
                    var zi2 = [];
                    for (var Ta2 in er.state.expanded)
                      zi2.push(er.state.expanded[Ta2]);
                    zi2[Gi2] = !zi2[Gi2], er.setState({ expanded: zi2 });
                  }, er.state = { expanded: [] }, er;
                }
                return Z3(Fn, [{ key: "getExpandedIcon", value: function(lr) {
                  var er = this.props, Gi2 = er.theme, zi2 = er.iconStyle;
                  return this.state.expanded[lr] ? Ot.a.createElement(Tx, { theme: Gi2, iconStyle: zi2 }) : Ot.a.createElement(x22, { theme: Gi2, iconStyle: zi2 });
                } }, { key: "render", value: function() {
                  var lr = this, er = this.props, Gi2 = er.src, zi2 = er.groupArraysAfterLength, Ta2 = (er.depth, er.name), Li2 = er.theme, zo = er.jsvRoot, ql = er.namespace, jf2 = (er.parent_type, Se2(er, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Ic2 = 0, Ad2 = 5 * this.props.indentWidth;
                  zo || (Ic2 = 5 * this.props.indentWidth);
                  var jc2 = zi2, dd2 = Math.ceil(Gi2.length / jc2);
                  return Ot.a.createElement("div", Object.assign({ className: "object-key-val" }, _n(Li2, zo ? "jsv-root" : "objectKeyVal", { paddingLeft: Ic2 })), Ot.a.createElement(Xw, this.props), Ot.a.createElement("span", null, Ot.a.createElement(AM, Object.assign({ size: Gi2.length }, this.props))), Ts(Array(dd2)).map(function(Bd2, du) {
                    return Ot.a.createElement("div", Object.assign({ key: du, className: "object-key-val array-group" }, _n(Li2, "objectKeyVal", { marginLeft: 6, paddingLeft: Ad2 })), Ot.a.createElement("span", _n(Li2, "brace-row"), Ot.a.createElement("div", Object.assign({ className: "icon-container" }, _n(Li2, "icon-container"), { onClick: function(id2) {
                      lr.toggleCollapsed(du);
                    } }), lr.getExpandedIcon(du)), lr.state.expanded[du] ? Ot.a.createElement(B32, Object.assign({ key: Ta2 + du, depth: 0, name: false, collapsed: false, groupArraysAfterLength: jc2, index_offset: du * jc2, src: Gi2.slice(du * jc2, du * jc2 + jc2), namespace: ql, type: "array", parent_type: "array_group", theme: Li2 }, jf2)) : Ot.a.createElement("span", Object.assign({}, _n(Li2, "brace"), { onClick: function(id2) {
                      lr.toggleCollapsed(du);
                    }, className: "array-group-brace" }), "[", Ot.a.createElement("div", Object.assign({}, _n(Li2, "array-group-meta-data"), { className: "array-group-meta-data" }), Ot.a.createElement("span", Object.assign({ className: "object-size" }, _n(Li2, "object-size")), du * jc2, " - ", du * jc2 + jc2 > Gi2.length ? Gi2.length : du * jc2 + jc2)), "]")));
                  }));
                } }]), Fn;
              }(Ot.a.PureComponent), fD = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  B3(this, Fn), (er = Ir.call(this, lr)).toggleCollapsed = function() {
                    er.setState({ expanded: !er.state.expanded }, function() {
                      ss.set(er.props.rjvId, er.props.namespace, "expanded", er.state.expanded);
                    });
                  }, er.getObjectContent = function(zi2, Ta2, Li2) {
                    return Ot.a.createElement("div", { className: "pushed-content object-container" }, Ot.a.createElement("div", Object.assign({ className: "object-content" }, _n(er.props.theme, "pushed-content")), er.renderObjectContents(Ta2, Li2)));
                  }, er.getEllipsis = function() {
                    return er.state.size === 0 ? null : Ot.a.createElement("div", Object.assign({}, _n(er.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: er.toggleCollapsed }), "...");
                  }, er.getObjectMetaData = function(zi2) {
                    var Ta2 = er.props, Li2 = (Ta2.rjvId, Ta2.theme, er.state), zo = Li2.size, ql = Li2.hovered;
                    return Ot.a.createElement(AM, Object.assign({ rowHovered: ql, size: zo }, er.props));
                  }, er.renderObjectContents = function(zi2, Ta2) {
                    var Li2, zo = er.props, ql = zo.depth, jf2 = zo.parent_type, Ic2 = zo.index_offset, Ad2 = zo.groupArraysAfterLength, jc2 = zo.namespace, dd2 = er.state.object_type, Bd2 = [], du = Object.keys(zi2 || {});
                    return er.props.sortKeys && dd2 !== "array" && (du = du.sort()), du.forEach(function(id2) {
                      if (Li2 = new Dft(id2, zi2[id2]), jf2 === "array_group" && Ic2 && (Li2.name = parseInt(Li2.name) + Ic2), zi2.hasOwnProperty(id2))
                        if (Li2.type === "object")
                          Bd2.push(Ot.a.createElement(B32, Object.assign({ key: Li2.name, depth: ql + 1, name: Li2.name, src: Li2.value, namespace: jc2.concat(Li2.name), parent_type: dd2 }, Ta2)));
                        else if (Li2.type === "array") {
                          var Ax = B32;
                          Ad2 && Li2.value.length > Ad2 && (Ax = cD), Bd2.push(Ot.a.createElement(Ax, Object.assign({ key: Li2.name, depth: ql + 1, name: Li2.name, src: Li2.value, namespace: jc2.concat(Li2.name), type: "array", parent_type: dd2 }, Ta2)));
                        } else
                          Bd2.push(Ot.a.createElement(q1, Object.assign({ key: Li2.name + "_" + jc2, variable: Li2, singleIndent: 5, namespace: jc2, type: er.props.type }, Ta2)));
                    }), Bd2;
                  };
                  var Gi2 = Fn.getState(lr);
                  return er.state = R6(R6({}, Gi2), {}, { prevProps: {} }), er;
                }
                return Z3(Fn, [{ key: "getBraceStart", value: function(lr, er) {
                  var Gi2 = this, zi2 = this.props, Ta2 = zi2.src, Li2 = zi2.theme, zo = zi2.iconStyle;
                  if (zi2.parent_type === "array_group")
                    return Ot.a.createElement("span", null, Ot.a.createElement("span", _n(Li2, "brace"), lr === "array" ? "[" : "{"), er ? this.getObjectMetaData(Ta2) : null);
                  var ql = er ? Tx : x22;
                  return Ot.a.createElement("span", null, Ot.a.createElement("span", Object.assign({ onClick: function(jf2) {
                    Gi2.toggleCollapsed();
                  } }, _n(Li2, "brace-row")), Ot.a.createElement("div", Object.assign({ className: "icon-container" }, _n(Li2, "icon-container")), Ot.a.createElement(ql, { theme: Li2, iconStyle: zo })), Ot.a.createElement(Xw, this.props), Ot.a.createElement("span", _n(Li2, "brace"), lr === "array" ? "[" : "{")), er ? this.getObjectMetaData(Ta2) : null);
                } }, { key: "render", value: function() {
                  var lr = this, er = this.props, Gi2 = er.depth, zi2 = er.src, Ta2 = (er.namespace, er.name, er.type, er.parent_type), Li2 = er.theme, zo = er.jsvRoot, ql = er.iconStyle, jf2 = Se2(er, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Ic2 = this.state, Ad2 = Ic2.object_type, jc2 = Ic2.expanded, dd2 = {};
                  return zo || Ta2 === "array_group" ? Ta2 === "array_group" && (dd2.borderLeft = 0, dd2.display = "inline") : dd2.paddingLeft = 5 * this.props.indentWidth, Ot.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                    return lr.setState(R6(R6({}, lr.state), {}, { hovered: true }));
                  }, onMouseLeave: function() {
                    return lr.setState(R6(R6({}, lr.state), {}, { hovered: false }));
                  } }, _n(Li2, zo ? "jsv-root" : "objectKeyVal", dd2)), this.getBraceStart(Ad2, jc2), jc2 ? this.getObjectContent(Gi2, zi2, R6({ theme: Li2, iconStyle: ql }, jf2)) : this.getEllipsis(), Ot.a.createElement("span", { className: "brace-row" }, Ot.a.createElement("span", { style: R6(R6({}, _n(Li2, "brace").style), {}, { paddingLeft: jc2 ? "3px" : "0px" }) }, Ad2 === "array" ? "]" : "}"), jc2 ? null : this.getObjectMetaData(zi2)));
                } }], [{ key: "getDerivedStateFromProps", value: function(lr, er) {
                  var Gi2 = er.prevProps;
                  return lr.src !== Gi2.src || lr.collapsed !== Gi2.collapsed || lr.name !== Gi2.name || lr.namespace !== Gi2.namespace || lr.rjvId !== Gi2.rjvId ? R6(R6({}, Fn.getState(lr)), {}, { prevProps: lr }) : null;
                } }]), Fn;
              }(Ot.a.PureComponent);
              fD.getState = function(Sr) {
                var Ir = Object.keys(Sr.src).length, Fn = (Sr.collapsed === false || Sr.collapsed !== true && Sr.collapsed > Sr.depth) && (!Sr.shouldCollapse || Sr.shouldCollapse({ name: Sr.name, src: Sr.src, type: Oe2(Sr.src), namespace: Sr.namespace }) === false) && Ir !== 0;
                return { expanded: ss.get(Sr.rjvId, Sr.namespace, "expanded", Fn), object_type: Sr.type === "array" ? "array" : "object", parent_type: Sr.type === "array" ? "array" : "object", size: Ir, hovered: false };
              };
              var Dft = function Sr(Ir, Fn) {
                B3(this, Sr), this.name = Ir, this.value = Fn, this.type = Oe2(Fn);
              };
              we2(fD);
              var B32 = fD, Eft = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  var lr;
                  B3(this, Fn);
                  for (var er = arguments.length, Gi2 = new Array(er), zi2 = 0; zi2 < er; zi2++)
                    Gi2[zi2] = arguments[zi2];
                  return (lr = Ir.call.apply(Ir, [this].concat(Gi2))).render = function() {
                    var Ta2 = mt(lr).props, Li2 = [Ta2.name], zo = B32;
                    return Array.isArray(Ta2.src) && Ta2.groupArraysAfterLength && Ta2.src.length > Ta2.groupArraysAfterLength && (zo = cD), Ot.a.createElement("div", { className: "pretty-json-container object-container" }, Ot.a.createElement("div", { className: "object-content" }, Ot.a.createElement(zo, Object.assign({ namespace: Li2, depth: 0, jsvRoot: true }, Ta2))));
                  }, lr;
                }
                return Fn;
              }(Ot.a.PureComponent), kft = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  return B3(this, Fn), (er = Ir.call(this, lr)).closeModal = function() {
                    nl.dispatch({ rjvId: er.props.rjvId, name: "RESET" });
                  }, er.submit = function() {
                    er.props.submit(er.state.input);
                  }, er.state = { input: lr.input ? lr.input : "" }, er;
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this, er = this.props, Gi2 = er.theme, zi2 = er.rjvId, Ta2 = er.isValid, Li2 = this.state.input, zo = Ta2(Li2);
                  return Ot.a.createElement("div", Object.assign({ className: "key-modal-request" }, _n(Gi2, "key-modal-request"), { onClick: this.closeModal }), Ot.a.createElement("div", Object.assign({}, _n(Gi2, "key-modal"), { onClick: function(ql) {
                    ql.stopPropagation();
                  } }), Ot.a.createElement("div", _n(Gi2, "key-modal-label"), "Key Name:"), Ot.a.createElement("div", { style: { position: "relative" } }, Ot.a.createElement("input", Object.assign({}, _n(Gi2, "key-modal-input"), { className: "key-modal-input", ref: function(ql) {
                    return ql && ql.focus();
                  }, spellCheck: false, value: Li2, placeholder: "...", onChange: function(ql) {
                    lr.setState({ input: ql.target.value });
                  }, onKeyPress: function(ql) {
                    zo && ql.key === "Enter" ? lr.submit() : ql.key === "Escape" && lr.closeModal();
                  } })), zo ? Ot.a.createElement(p0, Object.assign({}, _n(Gi2, "key-modal-submit"), { className: "key-modal-submit", onClick: function(ql) {
                    return lr.submit();
                  } })) : null), Ot.a.createElement("span", _n(Gi2, "key-modal-cancel"), Ot.a.createElement(_2, Object.assign({}, _n(Gi2, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                    nl.dispatch({ rjvId: zi2, name: "RESET" });
                  } })))));
                } }]), Fn;
              }(Ot.a.PureComponent), Pft = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  var lr;
                  B3(this, Fn);
                  for (var er = arguments.length, Gi2 = new Array(er), zi2 = 0; zi2 < er; zi2++)
                    Gi2[zi2] = arguments[zi2];
                  return (lr = Ir.call.apply(Ir, [this].concat(Gi2))).isValid = function(Ta2) {
                    var Li2 = lr.props.rjvId, zo = ss.get(Li2, "action", "new-key-request");
                    return Ta2 != "" && Object.keys(zo.existing_value).indexOf(Ta2) === -1;
                  }, lr.submit = function(Ta2) {
                    var Li2 = lr.props.rjvId, zo = ss.get(Li2, "action", "new-key-request");
                    zo.new_value = R6({}, zo.existing_value), zo.new_value[Ta2] = lr.props.defaultValue, nl.dispatch({ name: "VARIABLE_ADDED", rjvId: Li2, data: zo });
                  }, lr;
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.active, Gi2 = lr.theme, zi2 = lr.rjvId;
                  return er ? Ot.a.createElement(kft, { rjvId: zi2, theme: Gi2, isValid: this.isValid, submit: this.submit }) : null;
                } }]), Fn;
              }(Ot.a.PureComponent), Lft = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn() {
                  return B3(this, Fn), Ir.apply(this, arguments);
                }
                return Z3(Fn, [{ key: "render", value: function() {
                  var lr = this.props, er = lr.message, Gi2 = lr.active, zi2 = lr.theme, Ta2 = lr.rjvId;
                  return Gi2 ? Ot.a.createElement("div", Object.assign({ className: "validation-failure" }, _n(zi2, "validation-failure"), { onClick: function() {
                    nl.dispatch({ rjvId: Ta2, name: "RESET" });
                  } }), Ot.a.createElement("span", _n(zi2, "validation-failure-label"), er), Ot.a.createElement(_2, _n(zi2, "validation-failure-clear"))) : null;
                } }]), Fn;
              }(Ot.a.PureComponent), m9 = function(Sr) {
                tt(Fn, Sr);
                var Ir = kt(Fn);
                function Fn(lr) {
                  var er;
                  return B3(this, Fn), (er = Ir.call(this, lr)).rjvId = Date.now().toString(), er.getListeners = function() {
                    return { reset: er.resetState, "variable-update": er.updateSrc, "add-key-request": er.addKeyRequest };
                  }, er.updateSrc = function() {
                    var Gi2, zi2 = ss.get(er.rjvId, "action", "variable-update"), Ta2 = zi2.name, Li2 = zi2.namespace, zo = zi2.new_value, ql = zi2.existing_value, jf2 = (zi2.variable_removed, zi2.updated_src), Ic2 = zi2.type, Ad2 = er.props, jc2 = Ad2.onEdit, dd2 = Ad2.onDelete, Bd2 = Ad2.onAdd, du = { existing_src: er.state.src, new_value: zo, updated_src: jf2, name: Ta2, namespace: Li2, existing_value: ql };
                    switch (Ic2) {
                      case "variable-added":
                        Gi2 = Bd2(du);
                        break;
                      case "variable-edited":
                        Gi2 = jc2(du);
                        break;
                      case "variable-removed":
                        Gi2 = dd2(du);
                    }
                    Gi2 !== false ? (ss.set(er.rjvId, "global", "src", jf2), er.setState({ src: jf2 })) : er.setState({ validationFailure: true });
                  }, er.addKeyRequest = function() {
                    er.setState({ addKeyRequest: true });
                  }, er.resetState = function() {
                    er.setState({ validationFailure: false, addKeyRequest: false });
                  }, er.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Fn.defaultProps.src, name: Fn.defaultProps.name, theme: Fn.defaultProps.theme, validationMessage: Fn.defaultProps.validationMessage, prevSrc: Fn.defaultProps.src, prevName: Fn.defaultProps.name, prevTheme: Fn.defaultProps.theme }, er;
                }
                return Z3(Fn, [{ key: "componentDidMount", value: function() {
                  ss.set(this.rjvId, "global", "src", this.state.src);
                  var lr = this.getListeners();
                  for (var er in lr)
                    ss.on(er + "-" + this.rjvId, lr[er]);
                  this.setState({ addKeyRequest: false, editKeyRequest: false });
                } }, { key: "componentDidUpdate", value: function(lr, er) {
                  er.addKeyRequest !== false && this.setState({ addKeyRequest: false }), er.editKeyRequest !== false && this.setState({ editKeyRequest: false }), lr.src !== this.state.src && ss.set(this.rjvId, "global", "src", this.state.src);
                } }, { key: "componentWillUnmount", value: function() {
                  var lr = this.getListeners();
                  for (var er in lr)
                    ss.removeListener(er + "-" + this.rjvId, lr[er]);
                } }, { key: "render", value: function() {
                  var lr = this.state, er = lr.validationFailure, Gi2 = lr.validationMessage, zi2 = lr.addKeyRequest, Ta2 = lr.theme, Li2 = lr.src, zo = lr.name, ql = this.props, jf2 = ql.style, Ic2 = ql.defaultValue;
                  return Ot.a.createElement("div", { className: "react-json-view", style: R6(R6({}, _n(Ta2, "app-container").style), jf2) }, Ot.a.createElement(Lft, { message: Gi2, active: er, theme: Ta2, rjvId: this.rjvId }), Ot.a.createElement(Eft, Object.assign({}, this.props, { src: Li2, name: zo, theme: Ta2, type: Oe2(Li2), rjvId: this.rjvId })), Ot.a.createElement(Pft, { active: zi2, theme: Ta2, rjvId: this.rjvId, defaultValue: Ic2 }));
                } }], [{ key: "getDerivedStateFromProps", value: function(lr, er) {
                  if (lr.src !== er.prevSrc || lr.name !== er.prevName || lr.theme !== er.prevTheme) {
                    var Gi2 = { src: lr.src, name: lr.name, theme: lr.theme, validationMessage: lr.validationMessage, prevSrc: lr.src, prevName: lr.name, prevTheme: lr.theme };
                    return Fn.validateState(Gi2);
                  }
                  return null;
                } }]), Fn;
              }(Ot.a.PureComponent);
              m9.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, m9.validateState = function(Sr) {
                var Ir = {};
                return Oe2(Sr.theme) !== "object" || function(Fn) {
                  var lr = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                  if (Oe2(Fn) === "object") {
                    for (var er = 0; er < lr.length; er++)
                      if (!(lr[er] in Fn))
                        return false;
                    return true;
                  }
                  return false;
                }(Sr.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Ir.theme = "rjv-default"), Oe2(Sr.src) !== "object" && Oe2(Sr.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Ir.name = "ERROR", Ir.src = { message: "src property must be a valid json object" }), R6(R6({}, Sr), Ir);
              }, we2(m9), b6.default = m9;
            }]);
          });
        })(Y4e);
        var Xer = $e2(Y4e.exports);
        const Qer = ({ id: c5, title: s, chart: r5, option: g5 }) => {
          const { tool: b6 } = Rqt({}), S2 = GCt({ global: true }), [A2, { set: k2 }] = yt(true);
          console.log("option", g5);
          const R6 = (B3) => {
            const { updated_src: G3 } = B3;
            r5 == null || r5.setOption(G3), b6 == null || b6.add(c5, r5, G3, s), S2.emit("list");
          };
          return Rer("div", { children: [$X(jer, { children: $X(Uer, { children: $X(Zer, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (B3) => {
            k2(!B3);
          } }) }) }), $X("br", {}), g5 && $X(Xer, { src: g5, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: A2, iconStyle: "triangle", enableClipboard: true, onEdit: R6, onAdd: R6, onDelete: R6 })] });
        };
        u.EchartTool = Ker, u.ReactEchartsJson = Qer, u.useEcharts = hJn, u.useEchartsTool = Rqt, u.useEventEmitter = GCt;
      })(qRn);
      const ZRn = () => {
        const u = Twt({ global: true }), o = L.useRef(0), { tool: n3 } = gBt({});
        L.useState(false), L.useState("right");
        const [p2, m2] = L.useState([]), [w2, T2] = L.useState();
        return u.useSubscription("list", () => {
          var E;
          n3 != null && n3.list().length && (T2((E = n3 == null ? void 0 : n3.list()) == null ? void 0 : E[o.current]), m2(n3 == null ? void 0 : n3.list()));
        }), FY("div", { className: URn.container, children: false });
      };
      var DCe = { exports: {} };
      (function(u, o) {
        (function(n3, p2) {
          u.exports = p2(U3.default);
        })(Je2, function(n3) {
          return function(p2) {
            var m2 = {};
            function w2(T2) {
              if (m2[T2])
                return m2[T2].exports;
              var E = m2[T2] = { i: T2, l: false, exports: {} };
              return p2[T2].call(E.exports, E, E.exports, w2), E.l = true, E.exports;
            }
            return w2.m = p2, w2.c = m2, w2.d = function(T2, E, O2) {
              w2.o(T2, E) || Object.defineProperty(T2, E, { enumerable: true, get: O2 });
            }, w2.r = function(T2) {
              typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(T2, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(T2, "__esModule", { value: true });
            }, w2.t = function(T2, E) {
              if (1 & E && (T2 = w2(T2)), 8 & E || 4 & E && typeof T2 == "object" && T2 && T2.__esModule)
                return T2;
              var O2 = /* @__PURE__ */ Object.create(null);
              if (w2.r(O2), Object.defineProperty(O2, "default", { enumerable: true, value: T2 }), 2 & E && typeof T2 != "string")
                for (var V3 in T2)
                  w2.d(O2, V3, function(W3) {
                    return T2[W3];
                  }.bind(null, V3));
              return O2;
            }, w2.n = function(T2) {
              var E = T2 && T2.__esModule ? function() {
                return T2.default;
              } : function() {
                return T2;
              };
              return w2.d(E, "a", E), E;
            }, w2.o = function(T2, E) {
              return Object.prototype.hasOwnProperty.call(T2, E);
            }, w2.p = "", w2(w2.s = 48);
          }([function(p2, m2) {
            p2.exports = n3;
          }, function(p2, m2) {
            var w2 = p2.exports = { version: "2.6.12" };
            typeof __e == "number" && (__e = w2);
          }, function(p2, m2, w2) {
            var T2 = w2(26)("wks"), E = w2(17), O2 = w2(3).Symbol, V3 = typeof O2 == "function";
            (p2.exports = function(W3) {
              return T2[W3] || (T2[W3] = V3 && O2[W3] || (V3 ? O2 : E)("Symbol." + W3));
            }).store = T2;
          }, function(p2, m2) {
            var w2 = p2.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
            typeof __g == "number" && (__g = w2);
          }, function(p2, m2, w2) {
            p2.exports = !w2(8)(function() {
              return Object.defineProperty({}, "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(p2, m2) {
            var w2 = {}.hasOwnProperty;
            p2.exports = function(T2, E) {
              return w2.call(T2, E);
            };
          }, function(p2, m2, w2) {
            var T2 = w2(7), E = w2(16);
            p2.exports = w2(4) ? function(O2, V3, W3) {
              return T2.f(O2, V3, E(1, W3));
            } : function(O2, V3, W3) {
              return O2[V3] = W3, O2;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(10), E = w2(35), O2 = w2(23), V3 = Object.defineProperty;
            m2.f = w2(4) ? Object.defineProperty : function(W3, q3, K) {
              if (T2(W3), q3 = O2(q3, true), T2(K), E)
                try {
                  return V3(W3, q3, K);
                } catch {
                }
              if ("get" in K || "set" in K)
                throw TypeError("Accessors not supported!");
              return "value" in K && (W3[q3] = K.value), W3;
            };
          }, function(p2, m2) {
            p2.exports = function(w2) {
              try {
                return !!w2();
              } catch {
                return true;
              }
            };
          }, function(p2, m2, w2) {
            var T2 = w2(40), E = w2(22);
            p2.exports = function(O2) {
              return T2(E(O2));
            };
          }, function(p2, m2, w2) {
            var T2 = w2(11);
            p2.exports = function(E) {
              if (!T2(E))
                throw TypeError(E + " is not an object!");
              return E;
            };
          }, function(p2, m2) {
            p2.exports = function(w2) {
              return typeof w2 == "object" ? w2 !== null : typeof w2 == "function";
            };
          }, function(p2, m2) {
            p2.exports = {};
          }, function(p2, m2, w2) {
            var T2 = w2(39), E = w2(27);
            p2.exports = Object.keys || function(O2) {
              return T2(O2, E);
            };
          }, function(p2, m2) {
            p2.exports = true;
          }, function(p2, m2, w2) {
            var T2 = w2(3), E = w2(1), O2 = w2(53), V3 = w2(6), W3 = w2(5), q3 = function(K, J, rt2) {
              var gt, yt, At, Lt = K & q3.F, Wt = K & q3.G, Nt = K & q3.S, ue2 = K & q3.P, ie2 = K & q3.B, pe2 = K & q3.W, xe = Wt ? E : E[J] || (E[J] = {}), Ce2 = xe.prototype, Le2 = Wt ? T2 : Nt ? T2[J] : (T2[J] || {}).prototype;
              for (gt in Wt && (rt2 = J), rt2)
                (yt = !Lt && Le2 && Le2[gt] !== void 0) && W3(xe, gt) || (At = yt ? Le2[gt] : rt2[gt], xe[gt] = Wt && typeof Le2[gt] != "function" ? rt2[gt] : ie2 && yt ? O2(At, T2) : pe2 && Le2[gt] == At ? function(ze) {
                  var tn = function($e2, Tn, zn) {
                    if (this instanceof ze) {
                      switch (arguments.length) {
                        case 0:
                          return new ze();
                        case 1:
                          return new ze($e2);
                        case 2:
                          return new ze($e2, Tn);
                      }
                      return new ze($e2, Tn, zn);
                    }
                    return ze.apply(this, arguments);
                  };
                  return tn.prototype = ze.prototype, tn;
                }(At) : ue2 && typeof At == "function" ? O2(Function.call, At) : At, ue2 && ((xe.virtual || (xe.virtual = {}))[gt] = At, K & q3.R && Ce2 && !Ce2[gt] && V3(Ce2, gt, At)));
            };
            q3.F = 1, q3.G = 2, q3.S = 4, q3.P = 8, q3.B = 16, q3.W = 32, q3.U = 64, q3.R = 128, p2.exports = q3;
          }, function(p2, m2) {
            p2.exports = function(w2, T2) {
              return { enumerable: !(1 & w2), configurable: !(2 & w2), writable: !(4 & w2), value: T2 };
            };
          }, function(p2, m2) {
            var w2 = 0, T2 = Math.random();
            p2.exports = function(E) {
              return "Symbol(".concat(E === void 0 ? "" : E, ")_", (++w2 + T2).toString(36));
            };
          }, function(p2, m2, w2) {
            var T2 = w2(22);
            p2.exports = function(E) {
              return Object(T2(E));
            };
          }, function(p2, m2) {
            m2.f = {}.propertyIsEnumerable;
          }, function(p2, m2, w2) {
            var T2 = w2(52)(true);
            w2(34)(String, "String", function(E) {
              this._t = String(E), this._i = 0;
            }, function() {
              var E, O2 = this._t, V3 = this._i;
              return V3 >= O2.length ? { value: void 0, done: true } : (E = T2(O2, V3), this._i += E.length, { value: E, done: false });
            });
          }, function(p2, m2) {
            var w2 = Math.ceil, T2 = Math.floor;
            p2.exports = function(E) {
              return isNaN(E = +E) ? 0 : (E > 0 ? T2 : w2)(E);
            };
          }, function(p2, m2) {
            p2.exports = function(w2) {
              if (w2 == null)
                throw TypeError("Can't call method on  " + w2);
              return w2;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(11);
            p2.exports = function(E, O2) {
              if (!T2(E))
                return E;
              var V3, W3;
              if (O2 && typeof (V3 = E.toString) == "function" && !T2(W3 = V3.call(E)) || typeof (V3 = E.valueOf) == "function" && !T2(W3 = V3.call(E)) || !O2 && typeof (V3 = E.toString) == "function" && !T2(W3 = V3.call(E)))
                return W3;
              throw TypeError("Can't convert object to primitive value");
            };
          }, function(p2, m2) {
            var w2 = {}.toString;
            p2.exports = function(T2) {
              return w2.call(T2).slice(8, -1);
            };
          }, function(p2, m2, w2) {
            var T2 = w2(26)("keys"), E = w2(17);
            p2.exports = function(O2) {
              return T2[O2] || (T2[O2] = E(O2));
            };
          }, function(p2, m2, w2) {
            var T2 = w2(1), E = w2(3), O2 = E["__core-js_shared__"] || (E["__core-js_shared__"] = {});
            (p2.exports = function(V3, W3) {
              return O2[V3] || (O2[V3] = W3 !== void 0 ? W3 : {});
            })("versions", []).push({ version: T2.version, mode: w2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
          }, function(p2, m2) {
            p2.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
          }, function(p2, m2, w2) {
            var T2 = w2(7).f, E = w2(5), O2 = w2(2)("toStringTag");
            p2.exports = function(V3, W3, q3) {
              V3 && !E(V3 = q3 ? V3 : V3.prototype, O2) && T2(V3, O2, { configurable: true, value: W3 });
            };
          }, function(p2, m2, w2) {
            w2(62);
            for (var T2 = w2(3), E = w2(6), O2 = w2(12), V3 = w2(2)("toStringTag"), W3 = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), q3 = 0; q3 < W3.length; q3++) {
              var K = W3[q3], J = T2[K], rt2 = J && J.prototype;
              rt2 && !rt2[V3] && E(rt2, V3, K), O2[K] = O2.Array;
            }
          }, function(p2, m2, w2) {
            m2.f = w2(2);
          }, function(p2, m2, w2) {
            var T2 = w2(3), E = w2(1), O2 = w2(14), V3 = w2(30), W3 = w2(7).f;
            p2.exports = function(q3) {
              var K = E.Symbol || (E.Symbol = O2 ? {} : T2.Symbol || {});
              q3.charAt(0) == "_" || q3 in K || W3(K, q3, { value: V3.f(q3) });
            };
          }, function(p2, m2) {
            m2.f = Object.getOwnPropertySymbols;
          }, function(p2, m2) {
            p2.exports = function(w2, T2, E) {
              return Math.min(Math.max(w2, T2), E);
            };
          }, function(p2, m2, w2) {
            var T2 = w2(14), E = w2(15), O2 = w2(37), V3 = w2(6), W3 = w2(12), q3 = w2(55), K = w2(28), J = w2(61), rt2 = w2(2)("iterator"), gt = !([].keys && "next" in [].keys()), yt = function() {
              return this;
            };
            p2.exports = function(At, Lt, Wt, Nt, ue2, ie2, pe2) {
              q3(Wt, Lt, Nt);
              var xe, Ce2, Le2, ze = function(Tr) {
                if (!gt && Tr in zn)
                  return zn[Tr];
                switch (Tr) {
                  case "keys":
                  case "values":
                    return function() {
                      return new Wt(this, Tr);
                    };
                }
                return function() {
                  return new Wt(this, Tr);
                };
              }, tn = Lt + " Iterator", $e2 = ue2 == "values", Tn = false, zn = At.prototype, bn = zn[rt2] || zn["@@iterator"] || ue2 && zn[ue2], Xr = bn || ze(ue2), Xn = ue2 ? $e2 ? ze("entries") : Xr : void 0, or = Lt == "Array" && zn.entries || bn;
              if (or && (Le2 = J(or.call(new At()))) !== Object.prototype && Le2.next && (K(Le2, tn, true), T2 || typeof Le2[rt2] == "function" || V3(Le2, rt2, yt)), $e2 && bn && bn.name !== "values" && (Tn = true, Xr = function() {
                return bn.call(this);
              }), T2 && !pe2 || !gt && !Tn && zn[rt2] || V3(zn, rt2, Xr), W3[Lt] = Xr, W3[tn] = yt, ue2)
                if (xe = { values: $e2 ? Xr : ze("values"), keys: ie2 ? Xr : ze("keys"), entries: Xn }, pe2)
                  for (Ce2 in xe)
                    Ce2 in zn || O2(zn, Ce2, xe[Ce2]);
                else
                  E(E.P + E.F * (gt || Tn), Lt, xe);
              return xe;
            };
          }, function(p2, m2, w2) {
            p2.exports = !w2(4) && !w2(8)(function() {
              return Object.defineProperty(w2(36)("div"), "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(p2, m2, w2) {
            var T2 = w2(11), E = w2(3).document, O2 = T2(E) && T2(E.createElement);
            p2.exports = function(V3) {
              return O2 ? E.createElement(V3) : {};
            };
          }, function(p2, m2, w2) {
            p2.exports = w2(6);
          }, function(p2, m2, w2) {
            var T2 = w2(10), E = w2(56), O2 = w2(27), V3 = w2(25)("IE_PROTO"), W3 = function() {
            }, q3 = function() {
              var K, J = w2(36)("iframe"), rt2 = O2.length;
              for (J.style.display = "none", w2(60).appendChild(J), J.src = "javascript:", (K = J.contentWindow.document).open(), K.write("<script>document.F=Object<\/script>"), K.close(), q3 = K.F; rt2--; )
                delete q3.prototype[O2[rt2]];
              return q3();
            };
            p2.exports = Object.create || function(K, J) {
              var rt2;
              return K !== null ? (W3.prototype = T2(K), rt2 = new W3(), W3.prototype = null, rt2[V3] = K) : rt2 = q3(), J === void 0 ? rt2 : E(rt2, J);
            };
          }, function(p2, m2, w2) {
            var T2 = w2(5), E = w2(9), O2 = w2(57)(false), V3 = w2(25)("IE_PROTO");
            p2.exports = function(W3, q3) {
              var K, J = E(W3), rt2 = 0, gt = [];
              for (K in J)
                K != V3 && T2(J, K) && gt.push(K);
              for (; q3.length > rt2; )
                T2(J, K = q3[rt2++]) && (~O2(gt, K) || gt.push(K));
              return gt;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(24);
            p2.exports = Object("z").propertyIsEnumerable(0) ? Object : function(E) {
              return T2(E) == "String" ? E.split("") : Object(E);
            };
          }, function(p2, m2, w2) {
            var T2 = w2(39), E = w2(27).concat("length", "prototype");
            m2.f = Object.getOwnPropertyNames || function(O2) {
              return T2(O2, E);
            };
          }, function(p2, m2, w2) {
            var T2 = w2(24), E = w2(2)("toStringTag"), O2 = T2(function() {
              return arguments;
            }()) == "Arguments";
            p2.exports = function(V3) {
              var W3, q3, K;
              return V3 === void 0 ? "Undefined" : V3 === null ? "Null" : typeof (q3 = function(J, rt2) {
                try {
                  return J[rt2];
                } catch {
                }
              }(W3 = Object(V3), E)) == "string" ? q3 : O2 ? T2(W3) : (K = T2(W3)) == "Object" && typeof W3.callee == "function" ? "Arguments" : K;
            };
          }, function(p2, m2) {
            var w2;
            w2 = function() {
              return this;
            }();
            try {
              w2 = w2 || new Function("return this")();
            } catch {
              typeof window == "object" && (w2 = window);
            }
            p2.exports = w2;
          }, function(p2, m2) {
            var w2 = /-?\d+(\.\d+)?%?/g;
            p2.exports = function(T2) {
              return T2.match(w2);
            };
          }, function(p2, m2, w2) {
            Object.defineProperty(m2, "__esModule", { value: true }), m2.getBase16Theme = m2.createStyling = m2.invertTheme = void 0;
            var T2 = yt(w2(49)), E = yt(w2(76)), O2 = yt(w2(81)), V3 = yt(w2(89)), W3 = yt(w2(93)), q3 = function(Ce2) {
              if (Ce2 && Ce2.__esModule)
                return Ce2;
              var Le2 = {};
              if (Ce2 != null)
                for (var ze in Ce2)
                  Object.prototype.hasOwnProperty.call(Ce2, ze) && (Le2[ze] = Ce2[ze]);
              return Le2.default = Ce2, Le2;
            }(w2(94)), K = yt(w2(132)), J = yt(w2(133)), rt2 = yt(w2(138)), gt = w2(139);
            function yt(Ce2) {
              return Ce2 && Ce2.__esModule ? Ce2 : { default: Ce2 };
            }
            var At = q3.default, Lt = (0, V3.default)(At), Wt = (0, rt2.default)(J.default, gt.rgb2yuv, function(Ce2) {
              var Le2, ze = (0, O2.default)(Ce2, 3), tn = ze[0], $e2 = ze[1], Tn = ze[2];
              return [(Le2 = tn, Le2 < 0.25 ? 1 : Le2 < 0.5 ? 0.9 - Le2 : 1.1 - Le2), $e2, Tn];
            }, gt.yuv2rgb, K.default), Nt = function(Ce2) {
              return function(Le2) {
                return { className: [Le2.className, Ce2.className].filter(Boolean).join(" "), style: (0, E.default)({}, Le2.style || {}, Ce2.style || {}) };
              };
            }, ue2 = function(Ce2, Le2) {
              var ze = (0, V3.default)(Le2);
              for (var tn in Ce2)
                ze.indexOf(tn) === -1 && ze.push(tn);
              return ze.reduce(function($e2, Tn) {
                return $e2[Tn] = function(zn, bn) {
                  if (zn === void 0)
                    return bn;
                  if (bn === void 0)
                    return zn;
                  var Xr = zn === void 0 ? "undefined" : (0, T2.default)(zn), Xn = bn === void 0 ? "undefined" : (0, T2.default)(bn);
                  switch (Xr) {
                    case "string":
                      switch (Xn) {
                        case "string":
                          return [bn, zn].filter(Boolean).join(" ");
                        case "object":
                          return Nt({ className: zn, style: bn });
                        case "function":
                          return function(or) {
                            for (var Tr = arguments.length, ci2 = Array(Tr > 1 ? Tr - 1 : 0), yi2 = 1; yi2 < Tr; yi2++)
                              ci2[yi2 - 1] = arguments[yi2];
                            return Nt({ className: zn })(bn.apply(void 0, [or].concat(ci2)));
                          };
                      }
                    case "object":
                      switch (Xn) {
                        case "string":
                          return Nt({ className: bn, style: zn });
                        case "object":
                          return (0, E.default)({}, bn, zn);
                        case "function":
                          return function(or) {
                            for (var Tr = arguments.length, ci2 = Array(Tr > 1 ? Tr - 1 : 0), yi2 = 1; yi2 < Tr; yi2++)
                              ci2[yi2 - 1] = arguments[yi2];
                            return Nt({ style: zn })(bn.apply(void 0, [or].concat(ci2)));
                          };
                      }
                    case "function":
                      switch (Xn) {
                        case "string":
                          return function(or) {
                            for (var Tr = arguments.length, ci2 = Array(Tr > 1 ? Tr - 1 : 0), yi2 = 1; yi2 < Tr; yi2++)
                              ci2[yi2 - 1] = arguments[yi2];
                            return zn.apply(void 0, [Nt(or)({ className: bn })].concat(ci2));
                          };
                        case "object":
                          return function(or) {
                            for (var Tr = arguments.length, ci2 = Array(Tr > 1 ? Tr - 1 : 0), yi2 = 1; yi2 < Tr; yi2++)
                              ci2[yi2 - 1] = arguments[yi2];
                            return zn.apply(void 0, [Nt(or)({ style: bn })].concat(ci2));
                          };
                        case "function":
                          return function(or) {
                            for (var Tr = arguments.length, ci2 = Array(Tr > 1 ? Tr - 1 : 0), yi2 = 1; yi2 < Tr; yi2++)
                              ci2[yi2 - 1] = arguments[yi2];
                            return zn.apply(void 0, [bn.apply(void 0, [or].concat(ci2))].concat(ci2));
                          };
                      }
                  }
                }(Ce2[Tn], Le2[Tn]), $e2;
              }, {});
            }, ie2 = function(Ce2, Le2) {
              for (var ze = arguments.length, tn = Array(ze > 2 ? ze - 2 : 0), $e2 = 2; $e2 < ze; $e2++)
                tn[$e2 - 2] = arguments[$e2];
              if (Le2 === null)
                return Ce2;
              Array.isArray(Le2) || (Le2 = [Le2]);
              var Tn = Le2.map(function(bn) {
                return Ce2[bn];
              }).filter(Boolean), zn = Tn.reduce(function(bn, Xr) {
                return typeof Xr == "string" ? bn.className = [bn.className, Xr].filter(Boolean).join(" ") : (Xr === void 0 ? "undefined" : (0, T2.default)(Xr)) === "object" ? bn.style = (0, E.default)({}, bn.style, Xr) : typeof Xr == "function" && (bn = (0, E.default)({}, bn, Xr.apply(void 0, [bn].concat(tn)))), bn;
              }, { className: "", style: {} });
              return zn.className || delete zn.className, (0, V3.default)(zn.style).length === 0 && delete zn.style, zn;
            }, pe2 = m2.invertTheme = function(Ce2) {
              return (0, V3.default)(Ce2).reduce(function(Le2, ze) {
                return Le2[ze] = /^base/.test(ze) ? Wt(Ce2[ze]) : ze === "scheme" ? Ce2[ze] + ":inverted" : Ce2[ze], Le2;
              }, {});
            }, xe = (m2.createStyling = (0, W3.default)(function(Ce2) {
              for (var Le2 = arguments.length, ze = Array(Le2 > 3 ? Le2 - 3 : 0), tn = 3; tn < Le2; tn++)
                ze[tn - 3] = arguments[tn];
              var $e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Tn = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, zn = $e2.defaultBase16, bn = zn === void 0 ? At : zn, Xr = $e2.base16Themes, Xn = Xr === void 0 ? null : Xr, or = xe(Tn, Xn);
              or && (Tn = (0, E.default)({}, or, Tn));
              var Tr = Lt.reduce(function(Ms, dl) {
                return Ms[dl] = Tn[dl] || bn[dl], Ms;
              }, {}), ci2 = (0, V3.default)(Tn).reduce(function(Ms, dl) {
                return Lt.indexOf(dl) === -1 && (Ms[dl] = Tn[dl]), Ms;
              }, {}), yi2 = Ce2(Tr), Po = ue2(ci2, yi2);
              return (0, W3.default)(ie2, 2).apply(void 0, [Po].concat(ze));
            }, 3), m2.getBase16Theme = function(Ce2, Le2) {
              if (Ce2 && Ce2.extend && (Ce2 = Ce2.extend), typeof Ce2 == "string") {
                var ze = Ce2.split(":"), tn = (0, O2.default)(ze, 2), $e2 = tn[0], Tn = tn[1];
                Ce2 = (Le2 || {})[$e2] || q3[$e2], Tn === "inverted" && (Ce2 = pe2(Ce2));
              }
              return Ce2 && Ce2.hasOwnProperty("base00") ? Ce2 : void 0;
            });
          }, function(p2, m2, w2) {
            var T2, E = typeof Reflect == "object" ? Reflect : null, O2 = E && typeof E.apply == "function" ? E.apply : function(Nt, ue2, ie2) {
              return Function.prototype.apply.call(Nt, ue2, ie2);
            };
            T2 = E && typeof E.ownKeys == "function" ? E.ownKeys : Object.getOwnPropertySymbols ? function(Nt) {
              return Object.getOwnPropertyNames(Nt).concat(Object.getOwnPropertySymbols(Nt));
            } : function(Nt) {
              return Object.getOwnPropertyNames(Nt);
            };
            var V3 = Number.isNaN || function(Nt) {
              return Nt != Nt;
            };
            function W3() {
              W3.init.call(this);
            }
            p2.exports = W3, p2.exports.once = function(Nt, ue2) {
              return new Promise(function(ie2, pe2) {
                function xe() {
                  Ce2 !== void 0 && Nt.removeListener("error", Ce2), ie2([].slice.call(arguments));
                }
                var Ce2;
                ue2 !== "error" && (Ce2 = function(Le2) {
                  Nt.removeListener(ue2, xe), pe2(Le2);
                }, Nt.once("error", Ce2)), Nt.once(ue2, xe);
              });
            }, W3.EventEmitter = W3, W3.prototype._events = void 0, W3.prototype._eventsCount = 0, W3.prototype._maxListeners = void 0;
            var q3 = 10;
            function K(Nt) {
              if (typeof Nt != "function")
                throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof Nt);
            }
            function J(Nt) {
              return Nt._maxListeners === void 0 ? W3.defaultMaxListeners : Nt._maxListeners;
            }
            function rt2(Nt, ue2, ie2, pe2) {
              var xe, Ce2, Le2, ze;
              if (K(ie2), (Ce2 = Nt._events) === void 0 ? (Ce2 = Nt._events = /* @__PURE__ */ Object.create(null), Nt._eventsCount = 0) : (Ce2.newListener !== void 0 && (Nt.emit("newListener", ue2, ie2.listener ? ie2.listener : ie2), Ce2 = Nt._events), Le2 = Ce2[ue2]), Le2 === void 0)
                Le2 = Ce2[ue2] = ie2, ++Nt._eventsCount;
              else if (typeof Le2 == "function" ? Le2 = Ce2[ue2] = pe2 ? [ie2, Le2] : [Le2, ie2] : pe2 ? Le2.unshift(ie2) : Le2.push(ie2), (xe = J(Nt)) > 0 && Le2.length > xe && !Le2.warned) {
                Le2.warned = true;
                var tn = new Error("Possible EventEmitter memory leak detected. " + Le2.length + " " + String(ue2) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                tn.name = "MaxListenersExceededWarning", tn.emitter = Nt, tn.type = ue2, tn.count = Le2.length, ze = tn, console && console.warn && console.warn(ze);
              }
              return Nt;
            }
            function gt() {
              if (!this.fired)
                return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
            }
            function yt(Nt, ue2, ie2) {
              var pe2 = { fired: false, wrapFn: void 0, target: Nt, type: ue2, listener: ie2 }, xe = gt.bind(pe2);
              return xe.listener = ie2, pe2.wrapFn = xe, xe;
            }
            function At(Nt, ue2, ie2) {
              var pe2 = Nt._events;
              if (pe2 === void 0)
                return [];
              var xe = pe2[ue2];
              return xe === void 0 ? [] : typeof xe == "function" ? ie2 ? [xe.listener || xe] : [xe] : ie2 ? function(Ce2) {
                for (var Le2 = new Array(Ce2.length), ze = 0; ze < Le2.length; ++ze)
                  Le2[ze] = Ce2[ze].listener || Ce2[ze];
                return Le2;
              }(xe) : Wt(xe, xe.length);
            }
            function Lt(Nt) {
              var ue2 = this._events;
              if (ue2 !== void 0) {
                var ie2 = ue2[Nt];
                if (typeof ie2 == "function")
                  return 1;
                if (ie2 !== void 0)
                  return ie2.length;
              }
              return 0;
            }
            function Wt(Nt, ue2) {
              for (var ie2 = new Array(ue2), pe2 = 0; pe2 < ue2; ++pe2)
                ie2[pe2] = Nt[pe2];
              return ie2;
            }
            Object.defineProperty(W3, "defaultMaxListeners", { enumerable: true, get: function() {
              return q3;
            }, set: function(Nt) {
              if (typeof Nt != "number" || Nt < 0 || V3(Nt))
                throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + Nt + ".");
              q3 = Nt;
            } }), W3.init = function() {
              this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
            }, W3.prototype.setMaxListeners = function(Nt) {
              if (typeof Nt != "number" || Nt < 0 || V3(Nt))
                throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + Nt + ".");
              return this._maxListeners = Nt, this;
            }, W3.prototype.getMaxListeners = function() {
              return J(this);
            }, W3.prototype.emit = function(Nt) {
              for (var ue2 = [], ie2 = 1; ie2 < arguments.length; ie2++)
                ue2.push(arguments[ie2]);
              var pe2 = Nt === "error", xe = this._events;
              if (xe !== void 0)
                pe2 = pe2 && xe.error === void 0;
              else if (!pe2)
                return false;
              if (pe2) {
                var Ce2;
                if (ue2.length > 0 && (Ce2 = ue2[0]), Ce2 instanceof Error)
                  throw Ce2;
                var Le2 = new Error("Unhandled error." + (Ce2 ? " (" + Ce2.message + ")" : ""));
                throw Le2.context = Ce2, Le2;
              }
              var ze = xe[Nt];
              if (ze === void 0)
                return false;
              if (typeof ze == "function")
                O2(ze, this, ue2);
              else {
                var tn = ze.length, $e2 = Wt(ze, tn);
                for (ie2 = 0; ie2 < tn; ++ie2)
                  O2($e2[ie2], this, ue2);
              }
              return true;
            }, W3.prototype.addListener = function(Nt, ue2) {
              return rt2(this, Nt, ue2, false);
            }, W3.prototype.on = W3.prototype.addListener, W3.prototype.prependListener = function(Nt, ue2) {
              return rt2(this, Nt, ue2, true);
            }, W3.prototype.once = function(Nt, ue2) {
              return K(ue2), this.on(Nt, yt(this, Nt, ue2)), this;
            }, W3.prototype.prependOnceListener = function(Nt, ue2) {
              return K(ue2), this.prependListener(Nt, yt(this, Nt, ue2)), this;
            }, W3.prototype.removeListener = function(Nt, ue2) {
              var ie2, pe2, xe, Ce2, Le2;
              if (K(ue2), (pe2 = this._events) === void 0)
                return this;
              if ((ie2 = pe2[Nt]) === void 0)
                return this;
              if (ie2 === ue2 || ie2.listener === ue2)
                --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete pe2[Nt], pe2.removeListener && this.emit("removeListener", Nt, ie2.listener || ue2));
              else if (typeof ie2 != "function") {
                for (xe = -1, Ce2 = ie2.length - 1; Ce2 >= 0; Ce2--)
                  if (ie2[Ce2] === ue2 || ie2[Ce2].listener === ue2) {
                    Le2 = ie2[Ce2].listener, xe = Ce2;
                    break;
                  }
                if (xe < 0)
                  return this;
                xe === 0 ? ie2.shift() : function(ze, tn) {
                  for (; tn + 1 < ze.length; tn++)
                    ze[tn] = ze[tn + 1];
                  ze.pop();
                }(ie2, xe), ie2.length === 1 && (pe2[Nt] = ie2[0]), pe2.removeListener !== void 0 && this.emit("removeListener", Nt, Le2 || ue2);
              }
              return this;
            }, W3.prototype.off = W3.prototype.removeListener, W3.prototype.removeAllListeners = function(Nt) {
              var ue2, ie2, pe2;
              if ((ie2 = this._events) === void 0)
                return this;
              if (ie2.removeListener === void 0)
                return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : ie2[Nt] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete ie2[Nt]), this;
              if (arguments.length === 0) {
                var xe, Ce2 = Object.keys(ie2);
                for (pe2 = 0; pe2 < Ce2.length; ++pe2)
                  (xe = Ce2[pe2]) !== "removeListener" && this.removeAllListeners(xe);
                return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
              }
              if (typeof (ue2 = ie2[Nt]) == "function")
                this.removeListener(Nt, ue2);
              else if (ue2 !== void 0)
                for (pe2 = ue2.length - 1; pe2 >= 0; pe2--)
                  this.removeListener(Nt, ue2[pe2]);
              return this;
            }, W3.prototype.listeners = function(Nt) {
              return At(this, Nt, true);
            }, W3.prototype.rawListeners = function(Nt) {
              return At(this, Nt, false);
            }, W3.listenerCount = function(Nt, ue2) {
              return typeof Nt.listenerCount == "function" ? Nt.listenerCount(ue2) : Lt.call(Nt, ue2);
            }, W3.prototype.listenerCount = Lt, W3.prototype.eventNames = function() {
              return this._eventsCount > 0 ? T2(this._events) : [];
            };
          }, function(p2, m2, w2) {
            p2.exports.Dispatcher = w2(140);
          }, function(p2, m2, w2) {
            p2.exports = w2(142);
          }, function(p2, m2, w2) {
            m2.__esModule = true;
            var T2 = V3(w2(50)), E = V3(w2(65)), O2 = typeof E.default == "function" && typeof T2.default == "symbol" ? function(W3) {
              return typeof W3;
            } : function(W3) {
              return W3 && typeof E.default == "function" && W3.constructor === E.default && W3 !== E.default.prototype ? "symbol" : typeof W3;
            };
            function V3(W3) {
              return W3 && W3.__esModule ? W3 : { default: W3 };
            }
            m2.default = typeof E.default == "function" && O2(T2.default) === "symbol" ? function(W3) {
              return W3 === void 0 ? "undefined" : O2(W3);
            } : function(W3) {
              return W3 && typeof E.default == "function" && W3.constructor === E.default && W3 !== E.default.prototype ? "symbol" : W3 === void 0 ? "undefined" : O2(W3);
            };
          }, function(p2, m2, w2) {
            p2.exports = { default: w2(51), __esModule: true };
          }, function(p2, m2, w2) {
            w2(20), w2(29), p2.exports = w2(30).f("iterator");
          }, function(p2, m2, w2) {
            var T2 = w2(21), E = w2(22);
            p2.exports = function(O2) {
              return function(V3, W3) {
                var q3, K, J = String(E(V3)), rt2 = T2(W3), gt = J.length;
                return rt2 < 0 || rt2 >= gt ? O2 ? "" : void 0 : (q3 = J.charCodeAt(rt2)) < 55296 || q3 > 56319 || rt2 + 1 === gt || (K = J.charCodeAt(rt2 + 1)) < 56320 || K > 57343 ? O2 ? J.charAt(rt2) : q3 : O2 ? J.slice(rt2, rt2 + 2) : K - 56320 + (q3 - 55296 << 10) + 65536;
              };
            };
          }, function(p2, m2, w2) {
            var T2 = w2(54);
            p2.exports = function(E, O2, V3) {
              if (T2(E), O2 === void 0)
                return E;
              switch (V3) {
                case 1:
                  return function(W3) {
                    return E.call(O2, W3);
                  };
                case 2:
                  return function(W3, q3) {
                    return E.call(O2, W3, q3);
                  };
                case 3:
                  return function(W3, q3, K) {
                    return E.call(O2, W3, q3, K);
                  };
              }
              return function() {
                return E.apply(O2, arguments);
              };
            };
          }, function(p2, m2) {
            p2.exports = function(w2) {
              if (typeof w2 != "function")
                throw TypeError(w2 + " is not a function!");
              return w2;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(38), E = w2(16), O2 = w2(28), V3 = {};
            w2(6)(V3, w2(2)("iterator"), function() {
              return this;
            }), p2.exports = function(W3, q3, K) {
              W3.prototype = T2(V3, { next: E(1, K) }), O2(W3, q3 + " Iterator");
            };
          }, function(p2, m2, w2) {
            var T2 = w2(7), E = w2(10), O2 = w2(13);
            p2.exports = w2(4) ? Object.defineProperties : function(V3, W3) {
              E(V3);
              for (var q3, K = O2(W3), J = K.length, rt2 = 0; J > rt2; )
                T2.f(V3, q3 = K[rt2++], W3[q3]);
              return V3;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(9), E = w2(58), O2 = w2(59);
            p2.exports = function(V3) {
              return function(W3, q3, K) {
                var J, rt2 = T2(W3), gt = E(rt2.length), yt = O2(K, gt);
                if (V3 && q3 != q3) {
                  for (; gt > yt; )
                    if ((J = rt2[yt++]) != J)
                      return true;
                } else
                  for (; gt > yt; yt++)
                    if ((V3 || yt in rt2) && rt2[yt] === q3)
                      return V3 || yt || 0;
                return !V3 && -1;
              };
            };
          }, function(p2, m2, w2) {
            var T2 = w2(21), E = Math.min;
            p2.exports = function(O2) {
              return O2 > 0 ? E(T2(O2), 9007199254740991) : 0;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(21), E = Math.max, O2 = Math.min;
            p2.exports = function(V3, W3) {
              return (V3 = T2(V3)) < 0 ? E(V3 + W3, 0) : O2(V3, W3);
            };
          }, function(p2, m2, w2) {
            var T2 = w2(3).document;
            p2.exports = T2 && T2.documentElement;
          }, function(p2, m2, w2) {
            var T2 = w2(5), E = w2(18), O2 = w2(25)("IE_PROTO"), V3 = Object.prototype;
            p2.exports = Object.getPrototypeOf || function(W3) {
              return W3 = E(W3), T2(W3, O2) ? W3[O2] : typeof W3.constructor == "function" && W3 instanceof W3.constructor ? W3.constructor.prototype : W3 instanceof Object ? V3 : null;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(63), E = w2(64), O2 = w2(12), V3 = w2(9);
            p2.exports = w2(34)(Array, "Array", function(W3, q3) {
              this._t = V3(W3), this._i = 0, this._k = q3;
            }, function() {
              var W3 = this._t, q3 = this._k, K = this._i++;
              return !W3 || K >= W3.length ? (this._t = void 0, E(1)) : E(0, q3 == "keys" ? K : q3 == "values" ? W3[K] : [K, W3[K]]);
            }, "values"), O2.Arguments = O2.Array, T2("keys"), T2("values"), T2("entries");
          }, function(p2, m2) {
            p2.exports = function() {
            };
          }, function(p2, m2) {
            p2.exports = function(w2, T2) {
              return { value: T2, done: !!w2 };
            };
          }, function(p2, m2, w2) {
            p2.exports = { default: w2(66), __esModule: true };
          }, function(p2, m2, w2) {
            w2(67), w2(73), w2(74), w2(75), p2.exports = w2(1).Symbol;
          }, function(p2, m2, w2) {
            var T2 = w2(3), E = w2(5), O2 = w2(4), V3 = w2(15), W3 = w2(37), q3 = w2(68).KEY, K = w2(8), J = w2(26), rt2 = w2(28), gt = w2(17), yt = w2(2), At = w2(30), Lt = w2(31), Wt = w2(69), Nt = w2(70), ue2 = w2(10), ie2 = w2(11), pe2 = w2(18), xe = w2(9), Ce2 = w2(23), Le2 = w2(16), ze = w2(38), tn = w2(71), $e2 = w2(72), Tn = w2(32), zn = w2(7), bn = w2(13), Xr = $e2.f, Xn = zn.f, or = tn.f, Tr = T2.Symbol, ci2 = T2.JSON, yi2 = ci2 && ci2.stringify, Po = yt("_hidden"), Ms = yt("toPrimitive"), dl = {}.propertyIsEnumerable, tl = J("symbol-registry"), el = J("symbols"), as = J("op-symbols"), Hs = Object.prototype, ol = typeof Tr == "function" && !!Tn.f, xs = T2.QObject, Bl = !xs || !xs.prototype || !xs.prototype.findChild, Ph2 = O2 && K(function() {
              return ze(Xn({}, "a", { get: function() {
                return Xn(this, "a", { value: 7 }).a;
              } })).a != 7;
            }) ? function(ta2, bo, js) {
              var eu = Xr(Hs, bo);
              eu && delete Hs[bo], Xn(ta2, bo, js), eu && ta2 !== Hs && Xn(Hs, bo, eu);
            } : Xn, fu = function(ta2) {
              var bo = el[ta2] = ze(Tr.prototype);
              return bo._k = ta2, bo;
            }, uh2 = ol && typeof Tr.iterator == "symbol" ? function(ta2) {
              return typeof ta2 == "symbol";
            } : function(ta2) {
              return ta2 instanceof Tr;
            }, Zh2 = function(ta2, bo, js) {
              return ta2 === Hs && Zh2(as, bo, js), ue2(ta2), bo = Ce2(bo, true), ue2(js), E(el, bo) ? (js.enumerable ? (E(ta2, Po) && ta2[Po][bo] && (ta2[Po][bo] = false), js = ze(js, { enumerable: Le2(0, false) })) : (E(ta2, Po) || Xn(ta2, Po, Le2(1, {})), ta2[Po][bo] = true), Ph2(ta2, bo, js)) : Xn(ta2, bo, js);
            }, zp = function(ta2, bo) {
              ue2(ta2);
              for (var js, eu = Wt(bo = xe(bo)), bf2 = 0, _f = eu.length; _f > bf2; )
                Zh2(ta2, js = eu[bf2++], bo[js]);
              return ta2;
            }, tm = function(ta2) {
              var bo = dl.call(this, ta2 = Ce2(ta2, true));
              return !(this === Hs && E(el, ta2) && !E(as, ta2)) && (!(bo || !E(this, ta2) || !E(el, ta2) || E(this, Po) && this[Po][ta2]) || bo);
            }, Fd2 = function(ta2, bo) {
              if (ta2 = xe(ta2), bo = Ce2(bo, true), ta2 !== Hs || !E(el, bo) || E(as, bo)) {
                var js = Xr(ta2, bo);
                return !js || !E(el, bo) || E(ta2, Po) && ta2[Po][bo] || (js.enumerable = true), js;
              }
            }, O1 = function(ta2) {
              for (var bo, js = or(xe(ta2)), eu = [], bf2 = 0; js.length > bf2; )
                E(el, bo = js[bf2++]) || bo == Po || bo == q3 || eu.push(bo);
              return eu;
            }, Kd2 = function(ta2) {
              for (var bo, js = ta2 === Hs, eu = or(js ? as : xe(ta2)), bf2 = [], _f = 0; eu.length > _f; )
                !E(el, bo = eu[_f++]) || js && !E(Hs, bo) || bf2.push(el[bo]);
              return bf2;
            };
            ol || (W3((Tr = function() {
              if (this instanceof Tr)
                throw TypeError("Symbol is not a constructor!");
              var ta2 = gt(arguments.length > 0 ? arguments[0] : void 0), bo = function(js) {
                this === Hs && bo.call(as, js), E(this, Po) && E(this[Po], ta2) && (this[Po][ta2] = false), Ph2(this, ta2, Le2(1, js));
              };
              return O2 && Bl && Ph2(Hs, ta2, { configurable: true, set: bo }), fu(ta2);
            }).prototype, "toString", function() {
              return this._k;
            }), $e2.f = Fd2, zn.f = Zh2, w2(41).f = tn.f = O1, w2(19).f = tm, Tn.f = Kd2, O2 && !w2(14) && W3(Hs, "propertyIsEnumerable", tm, true), At.f = function(ta2) {
              return fu(yt(ta2));
            }), V3(V3.G + V3.W + V3.F * !ol, { Symbol: Tr });
            for (var Nv = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), mv = 0; Nv.length > mv; )
              yt(Nv[mv++]);
            for (var CI = bn(yt.store), go = 0; CI.length > go; )
              Lt(CI[go++]);
            V3(V3.S + V3.F * !ol, "Symbol", { for: function(ta2) {
              return E(tl, ta2 += "") ? tl[ta2] : tl[ta2] = Tr(ta2);
            }, keyFor: function(ta2) {
              if (!uh2(ta2))
                throw TypeError(ta2 + " is not a symbol!");
              for (var bo in tl)
                if (tl[bo] === ta2)
                  return bo;
            }, useSetter: function() {
              Bl = true;
            }, useSimple: function() {
              Bl = false;
            } }), V3(V3.S + V3.F * !ol, "Object", { create: function(ta2, bo) {
              return bo === void 0 ? ze(ta2) : zp(ze(ta2), bo);
            }, defineProperty: Zh2, defineProperties: zp, getOwnPropertyDescriptor: Fd2, getOwnPropertyNames: O1, getOwnPropertySymbols: Kd2 });
            var aa2 = K(function() {
              Tn.f(1);
            });
            V3(V3.S + V3.F * aa2, "Object", { getOwnPropertySymbols: function(ta2) {
              return Tn.f(pe2(ta2));
            } }), ci2 && V3(V3.S + V3.F * (!ol || K(function() {
              var ta2 = Tr();
              return yi2([ta2]) != "[null]" || yi2({ a: ta2 }) != "{}" || yi2(Object(ta2)) != "{}";
            })), "JSON", { stringify: function(ta2) {
              for (var bo, js, eu = [ta2], bf2 = 1; arguments.length > bf2; )
                eu.push(arguments[bf2++]);
              if (js = bo = eu[1], (ie2(bo) || ta2 !== void 0) && !uh2(ta2))
                return Nt(bo) || (bo = function(_f, nd2) {
                  if (typeof js == "function" && (nd2 = js.call(this, _f, nd2)), !uh2(nd2))
                    return nd2;
                }), eu[1] = bo, yi2.apply(ci2, eu);
            } }), Tr.prototype[Ms] || w2(6)(Tr.prototype, Ms, Tr.prototype.valueOf), rt2(Tr, "Symbol"), rt2(Math, "Math", true), rt2(T2.JSON, "JSON", true);
          }, function(p2, m2, w2) {
            var T2 = w2(17)("meta"), E = w2(11), O2 = w2(5), V3 = w2(7).f, W3 = 0, q3 = Object.isExtensible || function() {
              return true;
            }, K = !w2(8)(function() {
              return q3(Object.preventExtensions({}));
            }), J = function(gt) {
              V3(gt, T2, { value: { i: "O" + ++W3, w: {} } });
            }, rt2 = p2.exports = { KEY: T2, NEED: false, fastKey: function(gt, yt) {
              if (!E(gt))
                return typeof gt == "symbol" ? gt : (typeof gt == "string" ? "S" : "P") + gt;
              if (!O2(gt, T2)) {
                if (!q3(gt))
                  return "F";
                if (!yt)
                  return "E";
                J(gt);
              }
              return gt[T2].i;
            }, getWeak: function(gt, yt) {
              if (!O2(gt, T2)) {
                if (!q3(gt))
                  return true;
                if (!yt)
                  return false;
                J(gt);
              }
              return gt[T2].w;
            }, onFreeze: function(gt) {
              return K && rt2.NEED && q3(gt) && !O2(gt, T2) && J(gt), gt;
            } };
          }, function(p2, m2, w2) {
            var T2 = w2(13), E = w2(32), O2 = w2(19);
            p2.exports = function(V3) {
              var W3 = T2(V3), q3 = E.f;
              if (q3)
                for (var K, J = q3(V3), rt2 = O2.f, gt = 0; J.length > gt; )
                  rt2.call(V3, K = J[gt++]) && W3.push(K);
              return W3;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(24);
            p2.exports = Array.isArray || function(E) {
              return T2(E) == "Array";
            };
          }, function(p2, m2, w2) {
            var T2 = w2(9), E = w2(41).f, O2 = {}.toString, V3 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
            p2.exports.f = function(W3) {
              return V3 && O2.call(W3) == "[object Window]" ? function(q3) {
                try {
                  return E(q3);
                } catch {
                  return V3.slice();
                }
              }(W3) : E(T2(W3));
            };
          }, function(p2, m2, w2) {
            var T2 = w2(19), E = w2(16), O2 = w2(9), V3 = w2(23), W3 = w2(5), q3 = w2(35), K = Object.getOwnPropertyDescriptor;
            m2.f = w2(4) ? K : function(J, rt2) {
              if (J = O2(J), rt2 = V3(rt2, true), q3)
                try {
                  return K(J, rt2);
                } catch {
                }
              if (W3(J, rt2))
                return E(!T2.f.call(J, rt2), J[rt2]);
            };
          }, function(p2, m2) {
          }, function(p2, m2, w2) {
            w2(31)("asyncIterator");
          }, function(p2, m2, w2) {
            w2(31)("observable");
          }, function(p2, m2, w2) {
            m2.__esModule = true;
            var T2, E = w2(77), O2 = (T2 = E) && T2.__esModule ? T2 : { default: T2 };
            m2.default = O2.default || function(V3) {
              for (var W3 = 1; W3 < arguments.length; W3++) {
                var q3 = arguments[W3];
                for (var K in q3)
                  Object.prototype.hasOwnProperty.call(q3, K) && (V3[K] = q3[K]);
              }
              return V3;
            };
          }, function(p2, m2, w2) {
            p2.exports = { default: w2(78), __esModule: true };
          }, function(p2, m2, w2) {
            w2(79), p2.exports = w2(1).Object.assign;
          }, function(p2, m2, w2) {
            var T2 = w2(15);
            T2(T2.S + T2.F, "Object", { assign: w2(80) });
          }, function(p2, m2, w2) {
            var T2 = w2(4), E = w2(13), O2 = w2(32), V3 = w2(19), W3 = w2(18), q3 = w2(40), K = Object.assign;
            p2.exports = !K || w2(8)(function() {
              var J = {}, rt2 = {}, gt = Symbol(), yt = "abcdefghijklmnopqrst";
              return J[gt] = 7, yt.split("").forEach(function(At) {
                rt2[At] = At;
              }), K({}, J)[gt] != 7 || Object.keys(K({}, rt2)).join("") != yt;
            }) ? function(J, rt2) {
              for (var gt = W3(J), yt = arguments.length, At = 1, Lt = O2.f, Wt = V3.f; yt > At; )
                for (var Nt, ue2 = q3(arguments[At++]), ie2 = Lt ? E(ue2).concat(Lt(ue2)) : E(ue2), pe2 = ie2.length, xe = 0; pe2 > xe; )
                  Nt = ie2[xe++], T2 && !Wt.call(ue2, Nt) || (gt[Nt] = ue2[Nt]);
              return gt;
            } : K;
          }, function(p2, m2, w2) {
            m2.__esModule = true;
            var T2 = O2(w2(82)), E = O2(w2(85));
            function O2(V3) {
              return V3 && V3.__esModule ? V3 : { default: V3 };
            }
            m2.default = function(V3, W3) {
              if (Array.isArray(V3))
                return V3;
              if ((0, T2.default)(Object(V3)))
                return function(q3, K) {
                  var J = [], rt2 = true, gt = false, yt = void 0;
                  try {
                    for (var At, Lt = (0, E.default)(q3); !(rt2 = (At = Lt.next()).done) && (J.push(At.value), !K || J.length !== K); rt2 = true)
                      ;
                  } catch (Wt) {
                    gt = true, yt = Wt;
                  } finally {
                    try {
                      !rt2 && Lt.return && Lt.return();
                    } finally {
                      if (gt)
                        throw yt;
                    }
                  }
                  return J;
                }(V3, W3);
              throw new TypeError("Invalid attempt to destructure non-iterable instance");
            };
          }, function(p2, m2, w2) {
            p2.exports = { default: w2(83), __esModule: true };
          }, function(p2, m2, w2) {
            w2(29), w2(20), p2.exports = w2(84);
          }, function(p2, m2, w2) {
            var T2 = w2(42), E = w2(2)("iterator"), O2 = w2(12);
            p2.exports = w2(1).isIterable = function(V3) {
              var W3 = Object(V3);
              return W3[E] !== void 0 || "@@iterator" in W3 || O2.hasOwnProperty(T2(W3));
            };
          }, function(p2, m2, w2) {
            p2.exports = { default: w2(86), __esModule: true };
          }, function(p2, m2, w2) {
            w2(29), w2(20), p2.exports = w2(87);
          }, function(p2, m2, w2) {
            var T2 = w2(10), E = w2(88);
            p2.exports = w2(1).getIterator = function(O2) {
              var V3 = E(O2);
              if (typeof V3 != "function")
                throw TypeError(O2 + " is not iterable!");
              return T2(V3.call(O2));
            };
          }, function(p2, m2, w2) {
            var T2 = w2(42), E = w2(2)("iterator"), O2 = w2(12);
            p2.exports = w2(1).getIteratorMethod = function(V3) {
              if (V3 != null)
                return V3[E] || V3["@@iterator"] || O2[T2(V3)];
            };
          }, function(p2, m2, w2) {
            p2.exports = { default: w2(90), __esModule: true };
          }, function(p2, m2, w2) {
            w2(91), p2.exports = w2(1).Object.keys;
          }, function(p2, m2, w2) {
            var T2 = w2(18), E = w2(13);
            w2(92)("keys", function() {
              return function(O2) {
                return E(T2(O2));
              };
            });
          }, function(p2, m2, w2) {
            var T2 = w2(15), E = w2(1), O2 = w2(8);
            p2.exports = function(V3, W3) {
              var q3 = (E.Object || {})[V3] || Object[V3], K = {};
              K[V3] = W3(q3), T2(T2.S + T2.F * O2(function() {
                q3(1);
              }), "Object", K);
            };
          }, function(p2, m2, w2) {
            (function(T2) {
              var E = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], O2 = /^\s+|\s+$/g, V3 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, W3 = /\{\n\/\* \[wrapped with (.+)\] \*/, q3 = /,? & /, K = /^[-+]0x[0-9a-f]+$/i, J = /^0b[01]+$/i, rt2 = /^\[object .+?Constructor\]$/, gt = /^0o[0-7]+$/i, yt = /^(?:0|[1-9]\d*)$/, At = parseInt, Lt = typeof T2 == "object" && T2 && T2.Object === Object && T2, Wt = typeof self == "object" && self && self.Object === Object && self, Nt = Lt || Wt || Function("return this")();
              function ue2(go, aa2, ta2) {
                switch (ta2.length) {
                  case 0:
                    return go.call(aa2);
                  case 1:
                    return go.call(aa2, ta2[0]);
                  case 2:
                    return go.call(aa2, ta2[0], ta2[1]);
                  case 3:
                    return go.call(aa2, ta2[0], ta2[1], ta2[2]);
                }
                return go.apply(aa2, ta2);
              }
              function ie2(go, aa2) {
                return !!(go && go.length) && function(ta2, bo, js) {
                  if (bo != bo)
                    return function(_f, nd2, bv, Mg2) {
                      for (var K0 = _f.length, Cg2 = bv + (Mg2 ? 1 : -1); Mg2 ? Cg2-- : ++Cg2 < K0; )
                        if (nd2(_f[Cg2], Cg2, _f))
                          return Cg2;
                      return -1;
                    }(ta2, pe2, js);
                  for (var eu = js - 1, bf2 = ta2.length; ++eu < bf2; )
                    if (ta2[eu] === bo)
                      return eu;
                  return -1;
                }(go, aa2, 0) > -1;
              }
              function pe2(go) {
                return go != go;
              }
              function xe(go, aa2) {
                for (var ta2 = go.length, bo = 0; ta2--; )
                  go[ta2] === aa2 && bo++;
                return bo;
              }
              function Ce2(go, aa2) {
                for (var ta2 = -1, bo = go.length, js = 0, eu = []; ++ta2 < bo; ) {
                  var bf2 = go[ta2];
                  bf2 !== aa2 && bf2 !== "__lodash_placeholder__" || (go[ta2] = "__lodash_placeholder__", eu[js++] = ta2);
                }
                return eu;
              }
              var Le2, ze, tn, $e2 = Function.prototype, Tn = Object.prototype, zn = Nt["__core-js_shared__"], bn = (Le2 = /[^.]+$/.exec(zn && zn.keys && zn.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Le2 : "", Xr = $e2.toString, Xn = Tn.hasOwnProperty, or = Tn.toString, Tr = RegExp("^" + Xr.call(Xn).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ci2 = Object.create, yi2 = Math.max, Po = Math.min, Ms = (ze = fu(Object, "defineProperty"), (tn = fu.name) && tn.length > 2 ? ze : void 0);
              function dl(go) {
                return Nv(go) ? ci2(go) : {};
              }
              function tl(go) {
                return !(!Nv(go) || function(aa2) {
                  return !!bn && bn in aa2;
                }(go)) && (function(aa2) {
                  var ta2 = Nv(aa2) ? or.call(aa2) : "";
                  return ta2 == "[object Function]" || ta2 == "[object GeneratorFunction]";
                }(go) || function(aa2) {
                  var ta2 = false;
                  if (aa2 != null && typeof aa2.toString != "function")
                    try {
                      ta2 = !!(aa2 + "");
                    } catch {
                    }
                  return ta2;
                }(go) ? Tr : rt2).test(function(aa2) {
                  if (aa2 != null) {
                    try {
                      return Xr.call(aa2);
                    } catch {
                    }
                    try {
                      return aa2 + "";
                    } catch {
                    }
                  }
                  return "";
                }(go));
              }
              function el(go, aa2, ta2, bo) {
                for (var js = -1, eu = go.length, bf2 = ta2.length, _f = -1, nd2 = aa2.length, bv = yi2(eu - bf2, 0), Mg2 = Array(nd2 + bv), K0 = !bo; ++_f < nd2; )
                  Mg2[_f] = aa2[_f];
                for (; ++js < bf2; )
                  (K0 || js < eu) && (Mg2[ta2[js]] = go[js]);
                for (; bv--; )
                  Mg2[_f++] = go[js++];
                return Mg2;
              }
              function as(go, aa2, ta2, bo) {
                for (var js = -1, eu = go.length, bf2 = -1, _f = ta2.length, nd2 = -1, bv = aa2.length, Mg2 = yi2(eu - _f, 0), K0 = Array(Mg2 + bv), Cg2 = !bo; ++js < Mg2; )
                  K0[js] = go[js];
                for (var Rb2 = js; ++nd2 < bv; )
                  K0[Rb2 + nd2] = aa2[nd2];
                for (; ++bf2 < _f; )
                  (Cg2 || js < eu) && (K0[Rb2 + ta2[bf2]] = go[js++]);
                return K0;
              }
              function Hs(go) {
                return function() {
                  var aa2 = arguments;
                  switch (aa2.length) {
                    case 0:
                      return new go();
                    case 1:
                      return new go(aa2[0]);
                    case 2:
                      return new go(aa2[0], aa2[1]);
                    case 3:
                      return new go(aa2[0], aa2[1], aa2[2]);
                    case 4:
                      return new go(aa2[0], aa2[1], aa2[2], aa2[3]);
                    case 5:
                      return new go(aa2[0], aa2[1], aa2[2], aa2[3], aa2[4]);
                    case 6:
                      return new go(aa2[0], aa2[1], aa2[2], aa2[3], aa2[4], aa2[5]);
                    case 7:
                      return new go(aa2[0], aa2[1], aa2[2], aa2[3], aa2[4], aa2[5], aa2[6]);
                  }
                  var ta2 = dl(go.prototype), bo = go.apply(ta2, aa2);
                  return Nv(bo) ? bo : ta2;
                };
              }
              function ol(go, aa2, ta2, bo, js, eu, bf2, _f, nd2, bv) {
                var Mg2 = 128 & aa2, K0 = 1 & aa2, Cg2 = 2 & aa2, Rb2 = 24 & aa2, ax = 512 & aa2, hM = Cg2 ? void 0 : Hs(go);
                return function ox() {
                  for (var l0 = arguments.length, $h2 = Array(l0), Ay = l0; Ay--; )
                    $h2[Ay] = arguments[Ay];
                  if (Rb2)
                    var R1 = Ph2(ox), pM = xe($h2, R1);
                  if (bo && ($h2 = el($h2, bo, js, Rb2)), eu && ($h2 = as($h2, eu, bf2, Rb2)), l0 -= pM, Rb2 && l0 < bv) {
                    var Pw = Ce2($h2, R1);
                    return xs(go, aa2, ol, ox.placeholder, ta2, $h2, Pw, _f, nd2, bv - l0);
                  }
                  var sx = K0 ? ta2 : this, l22 = Cg2 ? sx[go] : go;
                  return l0 = $h2.length, _f ? $h2 = tm($h2, _f) : ax && l0 > 1 && $h2.reverse(), Mg2 && nd2 < l0 && ($h2.length = nd2), this && this !== Nt && this instanceof ox && (l22 = hM || Hs(l22)), l22.apply(sx, $h2);
                };
              }
              function xs(go, aa2, ta2, bo, js, eu, bf2, _f, nd2, bv) {
                var Mg2 = 8 & aa2;
                aa2 |= Mg2 ? 32 : 64, 4 & (aa2 &= ~(Mg2 ? 64 : 32)) || (aa2 &= -4);
                var K0 = ta2(go, aa2, js, Mg2 ? eu : void 0, Mg2 ? bf2 : void 0, Mg2 ? void 0 : eu, Mg2 ? void 0 : bf2, _f, nd2, bv);
                return K0.placeholder = bo, Fd2(K0, go, aa2);
              }
              function Bl(go, aa2, ta2, bo, js, eu, bf2, _f) {
                var nd2 = 2 & aa2;
                if (!nd2 && typeof go != "function")
                  throw new TypeError("Expected a function");
                var bv = bo ? bo.length : 0;
                if (bv || (aa2 &= -97, bo = js = void 0), bf2 = bf2 === void 0 ? bf2 : yi2(CI(bf2), 0), _f = _f === void 0 ? _f : CI(_f), bv -= js ? js.length : 0, 64 & aa2) {
                  var Mg2 = bo, K0 = js;
                  bo = js = void 0;
                }
                var Cg2 = [go, aa2, ta2, bo, js, Mg2, K0, eu, bf2, _f];
                if (go = Cg2[0], aa2 = Cg2[1], ta2 = Cg2[2], bo = Cg2[3], js = Cg2[4], !(_f = Cg2[9] = Cg2[9] == null ? nd2 ? 0 : go.length : yi2(Cg2[9] - bv, 0)) && 24 & aa2 && (aa2 &= -25), aa2 && aa2 != 1)
                  Rb2 = aa2 == 8 || aa2 == 16 ? function(ax, hM, ox) {
                    var l0 = Hs(ax);
                    return function $h2() {
                      for (var Ay = arguments.length, R1 = Array(Ay), pM = Ay, Pw = Ph2($h2); pM--; )
                        R1[pM] = arguments[pM];
                      var sx = Ay < 3 && R1[0] !== Pw && R1[Ay - 1] !== Pw ? [] : Ce2(R1, Pw);
                      if ((Ay -= sx.length) < ox)
                        return xs(ax, hM, ol, $h2.placeholder, void 0, R1, sx, void 0, void 0, ox - Ay);
                      var l22 = this && this !== Nt && this instanceof $h2 ? l0 : ax;
                      return ue2(l22, this, R1);
                    };
                  }(go, aa2, _f) : aa2 != 32 && aa2 != 33 || js.length ? ol.apply(void 0, Cg2) : function(ax, hM, ox, l0) {
                    var $h2 = 1 & hM, Ay = Hs(ax);
                    return function R1() {
                      for (var pM = -1, Pw = arguments.length, sx = -1, l22 = l0.length, n32 = Array(l22 + Pw), uk2 = this && this !== Nt && this instanceof R1 ? Ay : ax; ++sx < l22; )
                        n32[sx] = l0[sx];
                      for (; Pw--; )
                        n32[sx++] = arguments[++pM];
                      return ue2(uk2, $h2 ? ox : this, n32);
                    };
                  }(go, aa2, ta2, bo);
                else
                  var Rb2 = function(ax, hM, ox) {
                    var l0 = 1 & hM, $h2 = Hs(ax);
                    return function Ay() {
                      var R1 = this && this !== Nt && this instanceof Ay ? $h2 : ax;
                      return R1.apply(l0 ? ox : this, arguments);
                    };
                  }(go, aa2, ta2);
                return Fd2(Rb2, go, aa2);
              }
              function Ph2(go) {
                return go.placeholder;
              }
              function fu(go, aa2) {
                var ta2 = function(bo, js) {
                  return bo == null ? void 0 : bo[js];
                }(go, aa2);
                return tl(ta2) ? ta2 : void 0;
              }
              function uh2(go) {
                var aa2 = go.match(W3);
                return aa2 ? aa2[1].split(q3) : [];
              }
              function Zh2(go, aa2) {
                var ta2 = aa2.length, bo = ta2 - 1;
                return aa2[bo] = (ta2 > 1 ? "& " : "") + aa2[bo], aa2 = aa2.join(ta2 > 2 ? ", " : " "), go.replace(V3, `{
/* [wrapped with ` + aa2 + `] */
`);
              }
              function zp(go, aa2) {
                return !!(aa2 = aa2 == null ? 9007199254740991 : aa2) && (typeof go == "number" || yt.test(go)) && go > -1 && go % 1 == 0 && go < aa2;
              }
              function tm(go, aa2) {
                for (var ta2 = go.length, bo = Po(aa2.length, ta2), js = function(bf2, _f) {
                  var nd2 = -1, bv = bf2.length;
                  for (_f || (_f = Array(bv)); ++nd2 < bv; )
                    _f[nd2] = bf2[nd2];
                  return _f;
                }(go); bo--; ) {
                  var eu = aa2[bo];
                  go[bo] = zp(eu, ta2) ? js[eu] : void 0;
                }
                return go;
              }
              var Fd2 = Ms ? function(go, aa2, ta2) {
                var bo, js = aa2 + "";
                return Ms(go, "toString", { configurable: true, enumerable: false, value: (bo = Zh2(js, O1(uh2(js), ta2)), function() {
                  return bo;
                }) });
              } : function(go) {
                return go;
              };
              function O1(go, aa2) {
                return function(ta2, bo) {
                  for (var js = -1, eu = ta2 ? ta2.length : 0; ++js < eu && bo(ta2[js], js, ta2) !== false; )
                    ;
                }(E, function(ta2) {
                  var bo = "_." + ta2[0];
                  aa2 & ta2[1] && !ie2(go, bo) && go.push(bo);
                }), go.sort();
              }
              function Kd2(go, aa2, ta2) {
                var bo = Bl(go, 8, void 0, void 0, void 0, void 0, void 0, aa2 = ta2 ? void 0 : aa2);
                return bo.placeholder = Kd2.placeholder, bo;
              }
              function Nv(go) {
                var aa2 = typeof go;
                return !!go && (aa2 == "object" || aa2 == "function");
              }
              function mv(go) {
                return go ? (go = function(aa2) {
                  if (typeof aa2 == "number")
                    return aa2;
                  if (function(js) {
                    return typeof js == "symbol" || function(eu) {
                      return !!eu && typeof eu == "object";
                    }(js) && or.call(js) == "[object Symbol]";
                  }(aa2))
                    return NaN;
                  if (Nv(aa2)) {
                    var ta2 = typeof aa2.valueOf == "function" ? aa2.valueOf() : aa2;
                    aa2 = Nv(ta2) ? ta2 + "" : ta2;
                  }
                  if (typeof aa2 != "string")
                    return aa2 === 0 ? aa2 : +aa2;
                  aa2 = aa2.replace(O2, "");
                  var bo = J.test(aa2);
                  return bo || gt.test(aa2) ? At(aa2.slice(2), bo ? 2 : 8) : K.test(aa2) ? NaN : +aa2;
                }(go)) === 1 / 0 || go === -1 / 0 ? 17976931348623157e292 * (go < 0 ? -1 : 1) : go == go ? go : 0 : go === 0 ? go : 0;
              }
              function CI(go) {
                var aa2 = mv(go), ta2 = aa2 % 1;
                return aa2 == aa2 ? ta2 ? aa2 - ta2 : aa2 : 0;
              }
              Kd2.placeholder = {}, p2.exports = Kd2;
            }).call(this, w2(43));
          }, function(p2, m2, w2) {
            function T2(as) {
              return as && as.__esModule ? as.default : as;
            }
            m2.__esModule = true;
            var E = w2(95);
            m2.threezerotwofour = T2(E);
            var O2 = w2(96);
            m2.apathy = T2(O2);
            var V3 = w2(97);
            m2.ashes = T2(V3);
            var W3 = w2(98);
            m2.atelierDune = T2(W3);
            var q3 = w2(99);
            m2.atelierForest = T2(q3);
            var K = w2(100);
            m2.atelierHeath = T2(K);
            var J = w2(101);
            m2.atelierLakeside = T2(J);
            var rt2 = w2(102);
            m2.atelierSeaside = T2(rt2);
            var gt = w2(103);
            m2.bespin = T2(gt);
            var yt = w2(104);
            m2.brewer = T2(yt);
            var At = w2(105);
            m2.bright = T2(At);
            var Lt = w2(106);
            m2.chalk = T2(Lt);
            var Wt = w2(107);
            m2.codeschool = T2(Wt);
            var Nt = w2(108);
            m2.colors = T2(Nt);
            var ue2 = w2(109);
            m2.default = T2(ue2);
            var ie2 = w2(110);
            m2.eighties = T2(ie2);
            var pe2 = w2(111);
            m2.embers = T2(pe2);
            var xe = w2(112);
            m2.flat = T2(xe);
            var Ce2 = w2(113);
            m2.google = T2(Ce2);
            var Le2 = w2(114);
            m2.grayscale = T2(Le2);
            var ze = w2(115);
            m2.greenscreen = T2(ze);
            var tn = w2(116);
            m2.harmonic = T2(tn);
            var $e2 = w2(117);
            m2.hopscotch = T2($e2);
            var Tn = w2(118);
            m2.isotope = T2(Tn);
            var zn = w2(119);
            m2.marrakesh = T2(zn);
            var bn = w2(120);
            m2.mocha = T2(bn);
            var Xr = w2(121);
            m2.monokai = T2(Xr);
            var Xn = w2(122);
            m2.ocean = T2(Xn);
            var or = w2(123);
            m2.paraiso = T2(or);
            var Tr = w2(124);
            m2.pop = T2(Tr);
            var ci2 = w2(125);
            m2.railscasts = T2(ci2);
            var yi2 = w2(126);
            m2.shapeshifter = T2(yi2);
            var Po = w2(127);
            m2.solarized = T2(Po);
            var Ms = w2(128);
            m2.summerfruit = T2(Ms);
            var dl = w2(129);
            m2.tomorrow = T2(dl);
            var tl = w2(130);
            m2.tube = T2(tl);
            var el = w2(131);
            m2.twilight = T2(el);
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            m2.__esModule = true, m2.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, p2.exports = m2.default;
          }, function(p2, m2, w2) {
            var T2 = w2(33);
            function E(O2) {
              var V3 = Math.round(T2(O2, 0, 255)).toString(16);
              return V3.length == 1 ? "0" + V3 : V3;
            }
            p2.exports = function(O2) {
              var V3 = O2.length === 4 ? E(255 * O2[3]) : "";
              return "#" + E(O2[0]) + E(O2[1]) + E(O2[2]) + V3;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(134), E = w2(135), O2 = w2(136), V3 = w2(137), W3 = { "#": E, hsl: function(K) {
              var J = T2(K), rt2 = V3(J);
              return J.length === 4 && rt2.push(J[3]), rt2;
            }, rgb: O2 };
            function q3(K) {
              for (var J in W3)
                if (K.indexOf(J) === 0)
                  return W3[J](K);
            }
            q3.rgb = O2, q3.hsl = T2, q3.hex = E, p2.exports = q3;
          }, function(p2, m2, w2) {
            var T2 = w2(44), E = w2(33);
            function O2(V3, W3) {
              switch (V3 = parseFloat(V3), W3) {
                case 0:
                  return E(V3, 0, 360);
                case 1:
                case 2:
                  return E(V3, 0, 100);
                case 3:
                  return E(V3, 0, 1);
              }
            }
            p2.exports = function(V3) {
              return T2(V3).map(O2);
            };
          }, function(p2, m2) {
            p2.exports = function(w2) {
              w2.length !== 4 && w2.length !== 5 || (w2 = function(O2) {
                for (var V3 = "#", W3 = 1; W3 < O2.length; W3++) {
                  var q3 = O2.charAt(W3);
                  V3 += q3 + q3;
                }
                return V3;
              }(w2));
              var T2 = [parseInt(w2.substring(1, 3), 16), parseInt(w2.substring(3, 5), 16), parseInt(w2.substring(5, 7), 16)];
              if (w2.length === 9) {
                var E = parseFloat((parseInt(w2.substring(7, 9), 16) / 255).toFixed(2));
                T2.push(E);
              }
              return T2;
            };
          }, function(p2, m2, w2) {
            var T2 = w2(44), E = w2(33);
            function O2(V3, W3) {
              return W3 < 3 ? V3.indexOf("%") != -1 ? Math.round(255 * E(parseInt(V3, 10), 0, 100) / 100) : E(parseInt(V3, 10), 0, 255) : E(parseFloat(V3), 0, 1);
            }
            p2.exports = function(V3) {
              return T2(V3).map(O2);
            };
          }, function(p2, m2) {
            p2.exports = function(w2) {
              var T2, E, O2, V3, W3, q3 = w2[0] / 360, K = w2[1] / 100, J = w2[2] / 100;
              if (K == 0)
                return [W3 = 255 * J, W3, W3];
              T2 = 2 * J - (E = J < 0.5 ? J * (1 + K) : J + K - J * K), V3 = [0, 0, 0];
              for (var rt2 = 0; rt2 < 3; rt2++)
                (O2 = q3 + 1 / 3 * -(rt2 - 1)) < 0 && O2++, O2 > 1 && O2--, W3 = 6 * O2 < 1 ? T2 + 6 * (E - T2) * O2 : 2 * O2 < 1 ? E : 3 * O2 < 2 ? T2 + (E - T2) * (2 / 3 - O2) * 6 : T2, V3[rt2] = 255 * W3;
              return V3;
            };
          }, function(p2, m2, w2) {
            (function(T2) {
              var E = typeof T2 == "object" && T2 && T2.Object === Object && T2, O2 = typeof self == "object" && self && self.Object === Object && self, V3 = E || O2 || Function("return this")();
              function W3(Ce2, Le2, ze) {
                switch (ze.length) {
                  case 0:
                    return Ce2.call(Le2);
                  case 1:
                    return Ce2.call(Le2, ze[0]);
                  case 2:
                    return Ce2.call(Le2, ze[0], ze[1]);
                  case 3:
                    return Ce2.call(Le2, ze[0], ze[1], ze[2]);
                }
                return Ce2.apply(Le2, ze);
              }
              function q3(Ce2, Le2) {
                for (var ze = -1, tn = Le2.length, $e2 = Ce2.length; ++ze < tn; )
                  Ce2[$e2 + ze] = Le2[ze];
                return Ce2;
              }
              var K = Object.prototype, J = K.hasOwnProperty, rt2 = K.toString, gt = V3.Symbol, yt = K.propertyIsEnumerable, At = gt ? gt.isConcatSpreadable : void 0, Lt = Math.max;
              function Wt(Ce2) {
                return Nt(Ce2) || function(Le2) {
                  return function(ze) {
                    return function(tn) {
                      return !!tn && typeof tn == "object";
                    }(ze) && function(tn) {
                      return tn != null && function($e2) {
                        return typeof $e2 == "number" && $e2 > -1 && $e2 % 1 == 0 && $e2 <= 9007199254740991;
                      }(tn.length) && !function($e2) {
                        var Tn = function(zn) {
                          var bn = typeof zn;
                          return !!zn && (bn == "object" || bn == "function");
                        }($e2) ? rt2.call($e2) : "";
                        return Tn == "[object Function]" || Tn == "[object GeneratorFunction]";
                      }(tn);
                    }(ze);
                  }(Le2) && J.call(Le2, "callee") && (!yt.call(Le2, "callee") || rt2.call(Le2) == "[object Arguments]");
                }(Ce2) || !!(At && Ce2 && Ce2[At]);
              }
              var Nt = Array.isArray, ue2, ie2, pe2, xe = (ie2 = function(Ce2) {
                var Le2 = (Ce2 = function tn($e2, Tn, zn, bn, Xr) {
                  var Xn = -1, or = $e2.length;
                  for (zn || (zn = Wt), Xr || (Xr = []); ++Xn < or; ) {
                    var Tr = $e2[Xn];
                    Tn > 0 && zn(Tr) ? Tn > 1 ? tn(Tr, Tn - 1, zn, bn, Xr) : q3(Xr, Tr) : bn || (Xr[Xr.length] = Tr);
                  }
                  return Xr;
                }(Ce2, 1)).length, ze = Le2;
                for (ue2; ze--; )
                  if (typeof Ce2[ze] != "function")
                    throw new TypeError("Expected a function");
                return function() {
                  for (var tn = 0, $e2 = Le2 ? Ce2[tn].apply(this, arguments) : arguments[0]; ++tn < Le2; )
                    $e2 = Ce2[tn].call(this, $e2);
                  return $e2;
                };
              }, pe2 = Lt(pe2 === void 0 ? ie2.length - 1 : pe2, 0), function() {
                for (var Ce2 = arguments, Le2 = -1, ze = Lt(Ce2.length - pe2, 0), tn = Array(ze); ++Le2 < ze; )
                  tn[Le2] = Ce2[pe2 + Le2];
                Le2 = -1;
                for (var $e2 = Array(pe2 + 1); ++Le2 < pe2; )
                  $e2[Le2] = Ce2[Le2];
                return $e2[pe2] = tn, W3(ie2, this, $e2);
              });
              p2.exports = xe;
            }).call(this, w2(43));
          }, function(p2, m2, w2) {
            Object.defineProperty(m2, "__esModule", { value: true }), m2.yuv2rgb = function(T2) {
              var E, O2, V3, W3 = T2[0], q3 = T2[1], K = T2[2];
              return E = 1 * W3 + 0 * q3 + 1.13983 * K, O2 = 1 * W3 + -0.39465 * q3 + -0.5806 * K, V3 = 1 * W3 + 2.02311 * q3 + 0 * K, E = Math.min(Math.max(0, E), 1), O2 = Math.min(Math.max(0, O2), 1), V3 = Math.min(Math.max(0, V3), 1), [255 * E, 255 * O2, 255 * V3];
            }, m2.rgb2yuv = function(T2) {
              var E = T2[0] / 255, O2 = T2[1] / 255, V3 = T2[2] / 255;
              return [0.299 * E + 0.587 * O2 + 0.114 * V3, -0.14713 * E + -0.28886 * O2 + 0.436 * V3, 0.615 * E + -0.51499 * O2 + -0.10001 * V3];
            };
          }, function(p2, m2, w2) {
            function T2(V3, W3, q3) {
              return W3 in V3 ? Object.defineProperty(V3, W3, { value: q3, enumerable: true, configurable: true, writable: true }) : V3[W3] = q3, V3;
            }
            var E = w2(141), O2 = function() {
              function V3() {
                T2(this, "_callbacks", void 0), T2(this, "_isDispatching", void 0), T2(this, "_isHandled", void 0), T2(this, "_isPending", void 0), T2(this, "_lastID", void 0), T2(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
              }
              var W3 = V3.prototype;
              return W3.register = function(q3) {
                var K = "ID_" + this._lastID++;
                return this._callbacks[K] = q3, K;
              }, W3.unregister = function(q3) {
                this._callbacks[q3] || E(false), delete this._callbacks[q3];
              }, W3.waitFor = function(q3) {
                this._isDispatching || E(false);
                for (var K = 0; K < q3.length; K++) {
                  var J = q3[K];
                  this._isPending[J] ? this._isHandled[J] || E(false) : (this._callbacks[J] || E(false), this._invokeCallback(J));
                }
              }, W3.dispatch = function(q3) {
                this._isDispatching && E(false), this._startDispatching(q3);
                try {
                  for (var K in this._callbacks)
                    this._isPending[K] || this._invokeCallback(K);
                } finally {
                  this._stopDispatching();
                }
              }, W3.isDispatching = function() {
                return this._isDispatching;
              }, W3._invokeCallback = function(q3) {
                this._isPending[q3] = true, this._callbacks[q3](this._pendingPayload), this._isHandled[q3] = true;
              }, W3._startDispatching = function(q3) {
                for (var K in this._callbacks)
                  this._isPending[K] = false, this._isHandled[K] = false;
                this._pendingPayload = q3, this._isDispatching = true;
              }, W3._stopDispatching = function() {
                delete this._pendingPayload, this._isDispatching = false;
              }, V3;
            }();
            p2.exports = O2;
          }, function(p2, m2, w2) {
            p2.exports = function(T2, E) {
              for (var O2 = arguments.length, V3 = new Array(O2 > 2 ? O2 - 2 : 0), W3 = 2; W3 < O2; W3++)
                V3[W3 - 2] = arguments[W3];
              if (!T2) {
                var q3;
                if (E === void 0)
                  q3 = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                else {
                  var K = 0;
                  (q3 = new Error(E.replace(/%s/g, function() {
                    return String(V3[K++]);
                  }))).name = "Invariant Violation";
                }
                throw q3.framesToPop = 1, q3;
              }
            };
          }, function(p2, m2, w2) {
            function T2(wr, Pr, Nn) {
              return Pr in wr ? Object.defineProperty(wr, Pr, { value: Nn, enumerable: true, configurable: true, writable: true }) : wr[Pr] = Nn, wr;
            }
            function E(wr, Pr) {
              var Nn = Object.keys(wr);
              if (Object.getOwnPropertySymbols) {
                var hr = Object.getOwnPropertySymbols(wr);
                Pr && (hr = hr.filter(function(vr) {
                  return Object.getOwnPropertyDescriptor(wr, vr).enumerable;
                })), Nn.push.apply(Nn, hr);
              }
              return Nn;
            }
            function O2(wr) {
              for (var Pr = 1; Pr < arguments.length; Pr++) {
                var Nn = arguments[Pr] != null ? arguments[Pr] : {};
                Pr % 2 ? E(Object(Nn), true).forEach(function(hr) {
                  T2(wr, hr, Nn[hr]);
                }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(wr, Object.getOwnPropertyDescriptors(Nn)) : E(Object(Nn)).forEach(function(hr) {
                  Object.defineProperty(wr, hr, Object.getOwnPropertyDescriptor(Nn, hr));
                });
              }
              return wr;
            }
            function V3(wr, Pr) {
              if (!(wr instanceof Pr))
                throw new TypeError("Cannot call a class as a function");
            }
            function W3(wr, Pr) {
              for (var Nn = 0; Nn < Pr.length; Nn++) {
                var hr = Pr[Nn];
                hr.enumerable = hr.enumerable || false, hr.configurable = true, "value" in hr && (hr.writable = true), Object.defineProperty(wr, hr.key, hr);
              }
            }
            function q3(wr, Pr, Nn) {
              return Pr && W3(wr.prototype, Pr), Nn && W3(wr, Nn), wr;
            }
            function K(wr, Pr) {
              return (K = Object.setPrototypeOf || function(Nn, hr) {
                return Nn.__proto__ = hr, Nn;
              })(wr, Pr);
            }
            function J(wr, Pr) {
              if (typeof Pr != "function" && Pr !== null)
                throw new TypeError("Super expression must either be null or a function");
              wr.prototype = Object.create(Pr && Pr.prototype, { constructor: { value: wr, writable: true, configurable: true } }), Pr && K(wr, Pr);
            }
            function rt2(wr) {
              return (rt2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(Pr) {
                return Pr.__proto__ || Object.getPrototypeOf(Pr);
              })(wr);
            }
            function gt(wr) {
              return (gt = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Pr) {
                return typeof Pr;
              } : function(Pr) {
                return Pr && typeof Symbol == "function" && Pr.constructor === Symbol && Pr !== Symbol.prototype ? "symbol" : typeof Pr;
              })(wr);
            }
            function yt(wr) {
              if (wr === void 0)
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              return wr;
            }
            function At(wr, Pr) {
              return !Pr || gt(Pr) !== "object" && typeof Pr != "function" ? yt(wr) : Pr;
            }
            function Lt(wr) {
              var Pr = function() {
                if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                  return false;
                if (typeof Proxy == "function")
                  return true;
                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                  })), true;
                } catch {
                  return false;
                }
              }();
              return function() {
                var Nn, hr = rt2(wr);
                if (Pr) {
                  var vr = rt2(this).constructor;
                  Nn = Reflect.construct(hr, arguments, vr);
                } else
                  Nn = hr.apply(this, arguments);
                return At(this, Nn);
              };
            }
            w2.r(m2);
            var Wt = w2(0), Nt = w2.n(Wt);
            function ue2() {
              var wr = this.constructor.getDerivedStateFromProps(this.props, this.state);
              wr != null && this.setState(wr);
            }
            function ie2(wr) {
              this.setState(function(Pr) {
                var Nn = this.constructor.getDerivedStateFromProps(wr, Pr);
                return Nn != null ? Nn : null;
              }.bind(this));
            }
            function pe2(wr, Pr) {
              try {
                var Nn = this.props, hr = this.state;
                this.props = wr, this.state = Pr, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Nn, hr);
              } finally {
                this.props = Nn, this.state = hr;
              }
            }
            function xe(wr) {
              var Pr = wr.prototype;
              if (!Pr || !Pr.isReactComponent)
                throw new Error("Can only polyfill class components");
              if (typeof wr.getDerivedStateFromProps != "function" && typeof Pr.getSnapshotBeforeUpdate != "function")
                return wr;
              var Nn = null, hr = null, vr = null;
              if (typeof Pr.componentWillMount == "function" ? Nn = "componentWillMount" : typeof Pr.UNSAFE_componentWillMount == "function" && (Nn = "UNSAFE_componentWillMount"), typeof Pr.componentWillReceiveProps == "function" ? hr = "componentWillReceiveProps" : typeof Pr.UNSAFE_componentWillReceiveProps == "function" && (hr = "UNSAFE_componentWillReceiveProps"), typeof Pr.componentWillUpdate == "function" ? vr = "componentWillUpdate" : typeof Pr.UNSAFE_componentWillUpdate == "function" && (vr = "UNSAFE_componentWillUpdate"), Nn !== null || hr !== null || vr !== null) {
                var wn = wr.displayName || wr.name, no = typeof wr.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + wn + " uses " + no + " but also contains the following legacy lifecycles:" + (Nn !== null ? `
  ` + Nn : "") + (hr !== null ? `
  ` + hr : "") + (vr !== null ? `
  ` + vr : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
              }
              if (typeof wr.getDerivedStateFromProps == "function" && (Pr.componentWillMount = ue2, Pr.componentWillReceiveProps = ie2), typeof Pr.getSnapshotBeforeUpdate == "function") {
                if (typeof Pr.componentDidUpdate != "function")
                  throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                Pr.componentWillUpdate = pe2;
                var Pa2 = Pr.componentDidUpdate;
                Pr.componentDidUpdate = function(pi2, Uo, os) {
                  var If2 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : os;
                  Pa2.call(this, pi2, Uo, If2);
                };
              }
              return wr;
            }
            function Ce2(wr, Pr) {
              if (wr == null)
                return {};
              var Nn, hr, vr = function(no, Pa2) {
                if (no == null)
                  return {};
                var pi2, Uo, os = {}, If2 = Object.keys(no);
                for (Uo = 0; Uo < If2.length; Uo++)
                  pi2 = If2[Uo], Pa2.indexOf(pi2) >= 0 || (os[pi2] = no[pi2]);
                return os;
              }(wr, Pr);
              if (Object.getOwnPropertySymbols) {
                var wn = Object.getOwnPropertySymbols(wr);
                for (hr = 0; hr < wn.length; hr++)
                  Nn = wn[hr], Pr.indexOf(Nn) >= 0 || Object.prototype.propertyIsEnumerable.call(wr, Nn) && (vr[Nn] = wr[Nn]);
              }
              return vr;
            }
            function Le2(wr) {
              var Pr = function(Nn) {
                return {}.toString.call(Nn).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
              }(wr);
              return Pr === "number" && (Pr = isNaN(wr) ? "nan" : (0 | wr) != wr ? "float" : "integer"), Pr;
            }
            ue2.__suppressDeprecationWarning = true, ie2.__suppressDeprecationWarning = true, pe2.__suppressDeprecationWarning = true;
            var ze = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, tn = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, $e2 = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, Tn = w2(45), zn = function(wr) {
              var Pr = function(Nn) {
                return { backgroundColor: Nn.base00, ellipsisColor: Nn.base09, braceColor: Nn.base07, expandedIcon: Nn.base0D, collapsedIcon: Nn.base0E, keyColor: Nn.base07, arrayKeyColor: Nn.base0C, objectSize: Nn.base04, copyToClipboard: Nn.base0F, copyToClipboardCheck: Nn.base0D, objectBorder: Nn.base02, dataTypes: { boolean: Nn.base0E, date: Nn.base0D, float: Nn.base0B, function: Nn.base0D, integer: Nn.base0F, string: Nn.base09, nan: Nn.base08, null: Nn.base0A, undefined: Nn.base05, regexp: Nn.base0A, background: Nn.base02 }, editVariable: { editIcon: Nn.base0E, cancelIcon: Nn.base09, removeIcon: Nn.base09, addIcon: Nn.base0E, checkIcon: Nn.base0E, background: Nn.base01, color: Nn.base0A, border: Nn.base07 }, addKeyModal: { background: Nn.base05, border: Nn.base04, color: Nn.base0A, labelColor: Nn.base01 }, validationFailure: { background: Nn.base09, iconColor: Nn.base01, fontColor: Nn.base01 } };
              }(wr);
              return { "app-container": { fontFamily: $e2.globalFontFamily, cursor: $e2.globalCursor, backgroundColor: Pr.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Pr.ellipsisColor, fontSize: $e2.ellipsisFontSize, lineHeight: $e2.ellipsisLineHeight, cursor: $e2.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: $e2.braceCursor, fontWeight: $e2.braceFontWeight, color: Pr.braceColor }, "expanded-icon": { color: Pr.expandedIcon }, "collapsed-icon": { color: Pr.collapsedIcon }, colon: { display: "inline-block", margin: $e2.keyMargin, color: Pr.keyColor, verticalAlign: "top" }, objectKeyVal: function(Nn, hr) {
                return { style: O2({ paddingTop: $e2.keyValPaddingTop, paddingRight: $e2.keyValPaddingRight, paddingBottom: $e2.keyValPaddingBottom, borderLeft: $e2.keyValBorderLeft + " " + Pr.objectBorder, ":hover": { paddingLeft: hr.paddingLeft - 1 + "px", borderLeft: $e2.keyValBorderHover + " " + Pr.objectBorder } }, hr) };
              }, "object-key-val-no-border": { padding: $e2.keyValPadding }, "pushed-content": { marginLeft: $e2.pushedContentMarginLeft }, variableValue: function(Nn, hr) {
                return { style: O2({ display: "inline-block", paddingRight: $e2.variableValuePaddingRight, position: "relative" }, hr) };
              }, "object-name": { display: "inline-block", color: Pr.keyColor, letterSpacing: $e2.keyLetterSpacing, fontStyle: $e2.keyFontStyle, verticalAlign: $e2.keyVerticalAlign, opacity: $e2.keyOpacity, ":hover": { opacity: $e2.keyOpacityHover } }, "array-key": { display: "inline-block", color: Pr.arrayKeyColor, letterSpacing: $e2.keyLetterSpacing, fontStyle: $e2.keyFontStyle, verticalAlign: $e2.keyVerticalAlign, opacity: $e2.keyOpacity, ":hover": { opacity: $e2.keyOpacityHover } }, "object-size": { color: Pr.objectSize, borderRadius: $e2.objectSizeBorderRadius, fontStyle: $e2.objectSizeFontStyle, margin: $e2.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: $e2.dataTypeFontSize, marginRight: $e2.dataTypeMarginRight, opacity: $e2.datatypeOpacity }, boolean: { display: "inline-block", color: Pr.dataTypes.boolean }, date: { display: "inline-block", color: Pr.dataTypes.date }, "date-value": { marginLeft: $e2.dateValueMarginLeft }, float: { display: "inline-block", color: Pr.dataTypes.float }, function: { display: "inline-block", color: Pr.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Pr.dataTypes.integer }, string: { display: "inline-block", color: Pr.dataTypes.string }, nan: { display: "inline-block", color: Pr.dataTypes.nan, fontSize: $e2.nanFontSize, fontWeight: $e2.nanFontWeight, backgroundColor: Pr.dataTypes.background, padding: $e2.nanPadding, borderRadius: $e2.nanBorderRadius }, null: { display: "inline-block", color: Pr.dataTypes.null, fontSize: $e2.nullFontSize, fontWeight: $e2.nullFontWeight, backgroundColor: Pr.dataTypes.background, padding: $e2.nullPadding, borderRadius: $e2.nullBorderRadius }, undefined: { display: "inline-block", color: Pr.dataTypes.undefined, fontSize: $e2.undefinedFontSize, padding: $e2.undefinedPadding, borderRadius: $e2.undefinedBorderRadius, backgroundColor: Pr.dataTypes.background }, regexp: { display: "inline-block", color: Pr.dataTypes.regexp }, "copy-to-clipboard": { cursor: $e2.clipboardCursor }, "copy-icon": { color: Pr.copyToClipboard, fontSize: $e2.iconFontSize, marginRight: $e2.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Pr.copyToClipboardCheck, marginLeft: $e2.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: $e2.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: $e2.metaDataPadding }, "icon-container": { display: "inline-block", width: $e2.iconContainerWidth }, tooltip: { padding: $e2.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Pr.editVariable.removeIcon, cursor: $e2.iconCursor, fontSize: $e2.iconFontSize, marginRight: $e2.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Pr.editVariable.addIcon, cursor: $e2.iconCursor, fontSize: $e2.iconFontSize, marginRight: $e2.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Pr.editVariable.editIcon, cursor: $e2.iconCursor, fontSize: $e2.iconFontSize, marginRight: $e2.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: $e2.iconCursor, color: Pr.editVariable.checkIcon, fontSize: $e2.iconFontSize, paddingRight: $e2.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: $e2.iconCursor, color: Pr.editVariable.cancelIcon, fontSize: $e2.iconFontSize, paddingRight: $e2.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: $e2.editInputMinWidth, borderRadius: $e2.editInputBorderRadius, backgroundColor: Pr.editVariable.background, color: Pr.editVariable.color, padding: $e2.editInputPadding, marginRight: $e2.editInputMarginRight, fontFamily: $e2.editInputFontFamily }, "detected-row": { paddingTop: $e2.detectedRowPaddingTop }, "key-modal-request": { position: $e2.addKeyCoverPosition, top: $e2.addKeyCoverPositionPx, left: $e2.addKeyCoverPositionPx, right: $e2.addKeyCoverPositionPx, bottom: $e2.addKeyCoverPositionPx, backgroundColor: $e2.addKeyCoverBackground }, "key-modal": { width: $e2.addKeyModalWidth, backgroundColor: Pr.addKeyModal.background, marginLeft: $e2.addKeyModalMargin, marginRight: $e2.addKeyModalMargin, padding: $e2.addKeyModalPadding, borderRadius: $e2.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Pr.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Pr.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Pr.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Pr.addKeyModal.labelColor, fontSize: $e2.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Pr.editVariable.addIcon, fontSize: $e2.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Pr.ellipsisColor, fontSize: $e2.ellipsisFontSize, lineHeight: $e2.ellipsisLineHeight, cursor: $e2.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Pr.validationFailure.fontColor, backgroundColor: Pr.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Pr.validationFailure.iconColor, fontSize: $e2.iconFontSize, transform: "rotate(45deg)" } };
            };
            function bn(wr, Pr, Nn) {
              return wr || console.error("theme has not been set"), function(hr) {
                var vr = ze;
                return hr !== false && hr !== "none" || (vr = tn), Object(Tn.createStyling)(zn, { defaultBase16: vr })(hr);
              }(wr)(Pr, Nn);
            }
            var Xr = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = (hr.rjvId, hr.type_name), wn = hr.displayDataTypes, no = hr.theme;
                return wn ? Nt.a.createElement("span", Object.assign({ className: "data-type-label" }, bn(no, "data-type-label")), vr) : null;
              } }]), Nn;
            }(Nt.a.PureComponent), Xn = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props;
                return Nt.a.createElement("div", bn(hr.theme, "boolean"), Nt.a.createElement(Xr, Object.assign({ type_name: "bool" }, hr)), hr.value ? "true" : "false");
              } }]), Nn;
            }(Nt.a.PureComponent), or = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props;
                return Nt.a.createElement("div", bn(hr.theme, "date"), Nt.a.createElement(Xr, Object.assign({ type_name: "date" }, hr)), Nt.a.createElement("span", Object.assign({ className: "date-value" }, bn(hr.theme, "date-value")), hr.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
              } }]), Nn;
            }(Nt.a.PureComponent), Tr = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props;
                return Nt.a.createElement("div", bn(hr.theme, "float"), Nt.a.createElement(Xr, Object.assign({ type_name: "float" }, hr)), this.props.value);
              } }]), Nn;
            }(Nt.a.PureComponent);
            function ci2(wr, Pr) {
              (Pr == null || Pr > wr.length) && (Pr = wr.length);
              for (var Nn = 0, hr = new Array(Pr); Nn < Pr; Nn++)
                hr[Nn] = wr[Nn];
              return hr;
            }
            function yi2(wr, Pr) {
              if (wr) {
                if (typeof wr == "string")
                  return ci2(wr, Pr);
                var Nn = Object.prototype.toString.call(wr).slice(8, -1);
                return Nn === "Object" && wr.constructor && (Nn = wr.constructor.name), Nn === "Map" || Nn === "Set" ? Array.from(wr) : Nn === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Nn) ? ci2(wr, Pr) : void 0;
              }
            }
            function Po(wr, Pr) {
              var Nn;
              if (typeof Symbol == "undefined" || wr[Symbol.iterator] == null) {
                if (Array.isArray(wr) || (Nn = yi2(wr)) || Pr && wr && typeof wr.length == "number") {
                  Nn && (wr = Nn);
                  var hr = 0, vr = function() {
                  };
                  return { s: vr, n: function() {
                    return hr >= wr.length ? { done: true } : { done: false, value: wr[hr++] };
                  }, e: function(pi2) {
                    throw pi2;
                  }, f: vr };
                }
                throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }
              var wn, no = true, Pa2 = false;
              return { s: function() {
                Nn = wr[Symbol.iterator]();
              }, n: function() {
                var pi2 = Nn.next();
                return no = pi2.done, pi2;
              }, e: function(pi2) {
                Pa2 = true, wn = pi2;
              }, f: function() {
                try {
                  no || Nn.return == null || Nn.return();
                } finally {
                  if (Pa2)
                    throw wn;
                }
              } };
            }
            function Ms(wr) {
              return function(Pr) {
                if (Array.isArray(Pr))
                  return ci2(Pr);
              }(wr) || function(Pr) {
                if (typeof Symbol != "undefined" && Symbol.iterator in Object(Pr))
                  return Array.from(Pr);
              }(wr) || yi2(wr) || function() {
                throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }();
            }
            var dl = w2(46), tl = new (w2(47)).Dispatcher(), el = new (function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                var hr;
                V3(this, Nn);
                for (var vr = arguments.length, wn = new Array(vr), no = 0; no < vr; no++)
                  wn[no] = arguments[no];
                return (hr = Pr.call.apply(Pr, [this].concat(wn))).objects = {}, hr.set = function(Pa2, pi2, Uo, os) {
                  hr.objects[Pa2] === void 0 && (hr.objects[Pa2] = {}), hr.objects[Pa2][pi2] === void 0 && (hr.objects[Pa2][pi2] = {}), hr.objects[Pa2][pi2][Uo] = os;
                }, hr.get = function(Pa2, pi2, Uo, os) {
                  return hr.objects[Pa2] === void 0 || hr.objects[Pa2][pi2] === void 0 || hr.objects[Pa2][pi2][Uo] == null ? os : hr.objects[Pa2][pi2][Uo];
                }, hr.handleAction = function(Pa2) {
                  var pi2 = Pa2.rjvId, Uo = Pa2.data;
                  switch (Pa2.name) {
                    case "RESET":
                      hr.emit("reset-" + pi2);
                      break;
                    case "VARIABLE_UPDATED":
                      Pa2.data.updated_src = hr.updateSrc(pi2, Uo), hr.set(pi2, "action", "variable-update", O2(O2({}, Uo), {}, { type: "variable-edited" })), hr.emit("variable-update-" + pi2);
                      break;
                    case "VARIABLE_REMOVED":
                      Pa2.data.updated_src = hr.updateSrc(pi2, Uo), hr.set(pi2, "action", "variable-update", O2(O2({}, Uo), {}, { type: "variable-removed" })), hr.emit("variable-update-" + pi2);
                      break;
                    case "VARIABLE_ADDED":
                      Pa2.data.updated_src = hr.updateSrc(pi2, Uo), hr.set(pi2, "action", "variable-update", O2(O2({}, Uo), {}, { type: "variable-added" })), hr.emit("variable-update-" + pi2);
                      break;
                    case "ADD_VARIABLE_KEY_REQUEST":
                      hr.set(pi2, "action", "new-key-request", Uo), hr.emit("add-key-request-" + pi2);
                  }
                }, hr.updateSrc = function(Pa2, pi2) {
                  var Uo = pi2.name, os = pi2.namespace, If2 = pi2.new_value, Lh2 = (pi2.existing_value, pi2.variable_removed);
                  os.shift();
                  var Yh2, Bf2 = hr.get(Pa2, "global", "src"), Sd2 = hr.deepCopy(Bf2, Ms(os)), Fv = Sd2, Nc2 = Po(os);
                  try {
                    for (Nc2.s(); !(Yh2 = Nc2.n()).done; )
                      Fv = Fv[Yh2.value];
                  } catch (X0) {
                    Nc2.e(X0);
                  } finally {
                    Nc2.f();
                  }
                  return Lh2 ? Le2(Fv) == "array" ? Fv.splice(Uo, 1) : delete Fv[Uo] : Uo !== null ? Fv[Uo] = If2 : Sd2 = If2, hr.set(Pa2, "global", "src", Sd2), Sd2;
                }, hr.deepCopy = function(Pa2, pi2) {
                  var Uo, os = Le2(Pa2), If2 = pi2.shift();
                  return os == "array" ? Uo = Ms(Pa2) : os == "object" && (Uo = O2({}, Pa2)), If2 !== void 0 && (Uo[If2] = hr.deepCopy(Pa2[If2], pi2)), Uo;
                }, hr;
              }
              return Nn;
            }(dl.EventEmitter))();
            tl.register(el.handleAction.bind(el));
            var as = el, Hs = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                return V3(this, Nn), (vr = Pr.call(this, hr)).toggleCollapsed = function() {
                  vr.setState({ collapsed: !vr.state.collapsed }, function() {
                    as.set(vr.props.rjvId, vr.props.namespace, "collapsed", vr.state.collapsed);
                  });
                }, vr.getFunctionDisplay = function(wn) {
                  var no = yt(vr).props;
                  return wn ? Nt.a.createElement("span", null, vr.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), Nt.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, Nt.a.createElement("span", null, "{"), Nt.a.createElement("span", bn(no.theme, "ellipsis"), "..."), Nt.a.createElement("span", null, "}"))) : vr.props.value.toString().slice(9, -1);
                }, vr.state = { collapsed: as.get(hr.rjvId, hr.namespace, "collapsed", true) }, vr;
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = this.state.collapsed;
                return Nt.a.createElement("div", bn(hr.theme, "function"), Nt.a.createElement(Xr, Object.assign({ type_name: "function" }, hr)), Nt.a.createElement("span", Object.assign({}, bn(hr.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(vr)));
              } }]), Nn;
            }(Nt.a.PureComponent), ol = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                return Nt.a.createElement("div", bn(this.props.theme, "nan"), "NaN");
              } }]), Nn;
            }(Nt.a.PureComponent), xs = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                return Nt.a.createElement("div", bn(this.props.theme, "null"), "NULL");
              } }]), Nn;
            }(Nt.a.PureComponent), Bl = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props;
                return Nt.a.createElement("div", bn(hr.theme, "integer"), Nt.a.createElement(Xr, Object.assign({ type_name: "int" }, hr)), this.props.value);
              } }]), Nn;
            }(Nt.a.PureComponent), Ph2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props;
                return Nt.a.createElement("div", bn(hr.theme, "regexp"), Nt.a.createElement(Xr, Object.assign({ type_name: "regexp" }, hr)), this.props.value.toString());
              } }]), Nn;
            }(Nt.a.PureComponent), fu = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                return V3(this, Nn), (vr = Pr.call(this, hr)).toggleCollapsed = function() {
                  vr.setState({ collapsed: !vr.state.collapsed }, function() {
                    as.set(vr.props.rjvId, vr.props.namespace, "collapsed", vr.state.collapsed);
                  });
                }, vr.state = { collapsed: as.get(hr.rjvId, hr.namespace, "collapsed", true) }, vr;
              }
              return q3(Nn, [{ key: "render", value: function() {
                this.state.collapsed;
                var hr = this.props, vr = hr.collapseStringsAfterLength, wn = hr.theme, no = hr.value, Pa2 = { style: { cursor: "default" } };
                return Le2(vr) === "integer" && no.length > vr && (Pa2.style.cursor = "pointer", this.state.collapsed && (no = Nt.a.createElement("span", null, no.substring(0, vr), Nt.a.createElement("span", bn(wn, "ellipsis"), " ...")))), Nt.a.createElement("div", bn(wn, "string"), Nt.a.createElement(Xr, Object.assign({ type_name: "string" }, hr)), Nt.a.createElement("span", Object.assign({ className: "string-value" }, Pa2, { onClick: this.toggleCollapsed }), '"', no, '"'));
              } }]), Nn;
            }(Nt.a.PureComponent), uh2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                return Nt.a.createElement("div", bn(this.props.theme, "undefined"), "undefined");
              } }]), Nn;
            }(Nt.a.PureComponent);
            function Zh2() {
              return (Zh2 = Object.assign || function(wr) {
                for (var Pr = 1; Pr < arguments.length; Pr++) {
                  var Nn = arguments[Pr];
                  for (var hr in Nn)
                    Object.prototype.hasOwnProperty.call(Nn, hr) && (wr[hr] = Nn[hr]);
                }
                return wr;
              }).apply(this, arguments);
            }
            var zp = Wt.useLayoutEffect, tm = function(wr) {
              var Pr = Object(Wt.useRef)(wr);
              return zp(function() {
                Pr.current = wr;
              }), Pr;
            }, Fd2 = function(wr, Pr) {
              typeof wr != "function" ? wr.current = Pr : wr(Pr);
            }, O1 = function(wr, Pr) {
              var Nn = Object(Wt.useRef)();
              return Object(Wt.useCallback)(function(hr) {
                wr.current = hr, Nn.current && Fd2(Nn.current, null), Nn.current = Pr, Pr && Fd2(Pr, hr);
              }, [Pr]);
            }, Kd2 = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Nv = function(wr) {
              Object.keys(Kd2).forEach(function(Pr) {
                wr.style.setProperty(Pr, Kd2[Pr], "important");
              });
            }, mv = null, CI = function() {
            }, go = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], aa2 = !!document.documentElement.currentStyle, ta2 = function(wr, Pr) {
              var Nn = wr.cacheMeasurements, hr = wr.maxRows, vr = wr.minRows, wn = wr.onChange, no = wn === void 0 ? CI : wn, Pa2 = wr.onHeightChange, pi2 = Pa2 === void 0 ? CI : Pa2, Uo = function(Nc2, X0) {
                if (Nc2 == null)
                  return {};
                var T0, dM, N4 = {}, Nb2 = Object.keys(Nc2);
                for (dM = 0; dM < Nb2.length; dM++)
                  T0 = Nb2[dM], X0.indexOf(T0) >= 0 || (N4[T0] = Nc2[T0]);
                return N4;
              }(wr, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), os, If2 = Uo.value !== void 0, Lh2 = Object(Wt.useRef)(null), Yh2 = O1(Lh2, Pr), Bf2 = Object(Wt.useRef)(0), Sd2 = Object(Wt.useRef)(), Fv = function() {
                var Nc2 = Lh2.current, X0 = Nn && Sd2.current ? Sd2.current : function(Nb2) {
                  var TI = window.getComputedStyle(Nb2);
                  if (TI === null)
                    return null;
                  var fk2, em = (fk2 = TI, go.reduce(function(F4, AI) {
                    return F4[AI] = fk2[AI], F4;
                  }, {})), gM = em.boxSizing;
                  return gM === "" ? null : (aa2 && gM === "border-box" && (em.width = parseFloat(em.width) + parseFloat(em.borderRightWidth) + parseFloat(em.borderLeftWidth) + parseFloat(em.paddingRight) + parseFloat(em.paddingLeft) + "px"), { sizingStyle: em, paddingSize: parseFloat(em.paddingBottom) + parseFloat(em.paddingTop), borderSize: parseFloat(em.borderBottomWidth) + parseFloat(em.borderTopWidth) });
                }(Nc2);
                if (X0) {
                  Sd2.current = X0;
                  var T0 = function(Nb2, TI, fk2, em) {
                    fk2 === void 0 && (fk2 = 1), em === void 0 && (em = 1 / 0), mv || ((mv = document.createElement("textarea")).setAttribute("tab-index", "-1"), mv.setAttribute("aria-hidden", "true"), Nv(mv)), mv.parentNode === null && document.body.appendChild(mv);
                    var gM = Nb2.paddingSize, F4 = Nb2.borderSize, AI = Nb2.sizingStyle, II = AI.boxSizing;
                    Object.keys(AI).forEach(function(Ml) {
                      var bu = Ml;
                      mv.style[bu] = AI[bu];
                    }), Nv(mv), mv.value = TI;
                    var hk2 = function(Ml, bu) {
                      var B4 = Ml.scrollHeight;
                      return bu.sizingStyle.boxSizing === "border-box" ? B4 + bu.borderSize : B4 - bu.paddingSize;
                    }(mv, Nb2);
                    mv.value = "x";
                    var lj2 = mv.scrollHeight - gM, V4 = lj2 * fk2;
                    II === "border-box" && (V4 = V4 + gM + F4), hk2 = Math.max(V4, hk2);
                    var r3 = lj2 * em;
                    return II === "border-box" && (r3 = r3 + gM + F4), [hk2 = Math.min(r3, hk2), lj2];
                  }(X0, Nc2.value || Nc2.placeholder || "x", vr, hr), dM = T0[0], N4 = T0[1];
                  Bf2.current !== dM && (Bf2.current = dM, Nc2.style.setProperty("height", dM + "px", "important"), pi2(dM, { rowHeight: N4 }));
                }
              };
              return Object(Wt.useLayoutEffect)(Fv), os = tm(Fv), Object(Wt.useLayoutEffect)(function() {
                var Nc2 = function(X0) {
                  os.current(X0);
                };
                return window.addEventListener("resize", Nc2), function() {
                  window.removeEventListener("resize", Nc2);
                };
              }, []), Object(Wt.createElement)("textarea", Zh2({}, Uo, { onChange: function(Nc2) {
                If2 || Fv(), no(Nc2);
              }, ref: Yh2 }));
            }, bo = Object(Wt.forwardRef)(ta2);
            function js(wr) {
              wr = wr.trim();
              try {
                if ((wr = JSON.stringify(JSON.parse(wr)))[0] === "[")
                  return eu("array", JSON.parse(wr));
                if (wr[0] === "{")
                  return eu("object", JSON.parse(wr));
                if (wr.match(/\-?\d+\.\d+/) && wr.match(/\-?\d+\.\d+/)[0] === wr)
                  return eu("float", parseFloat(wr));
                if (wr.match(/\-?\d+e-\d+/) && wr.match(/\-?\d+e-\d+/)[0] === wr)
                  return eu("float", Number(wr));
                if (wr.match(/\-?\d+/) && wr.match(/\-?\d+/)[0] === wr)
                  return eu("integer", parseInt(wr));
                if (wr.match(/\-?\d+e\+\d+/) && wr.match(/\-?\d+e\+\d+/)[0] === wr)
                  return eu("integer", Number(wr));
              } catch {
              }
              switch (wr = wr.toLowerCase()) {
                case "undefined":
                  return eu("undefined", void 0);
                case "nan":
                  return eu("nan", NaN);
                case "null":
                  return eu("null", null);
                case "true":
                  return eu("boolean", true);
                case "false":
                  return eu("boolean", false);
                default:
                  if (wr = Date.parse(wr))
                    return eu("date", new Date(wr));
              }
              return eu(false, null);
            }
            function eu(wr, Pr) {
              return { type: wr, value: Pr };
            }
            var bf2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
              } }]), Nn;
            }(Nt.a.PureComponent), _f = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
              } }]), Nn;
            }(Nt.a.PureComponent), nd2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]), no = $h2(vr).style;
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", { fill: no.color, width: no.height, height: no.width, style: no, viewBox: "0 0 1792 1792" }, Nt.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Nn;
            }(Nt.a.PureComponent), bv = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]), no = $h2(vr).style;
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", { fill: no.color, width: no.height, height: no.width, style: no, viewBox: "0 0 1792 1792" }, Nt.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Nn;
            }(Nt.a.PureComponent), Mg2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", { style: O2(O2({}, $h2(vr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Nt.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
              } }]), Nn;
            }(Nt.a.PureComponent), K0 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", { style: O2(O2({}, $h2(vr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Nt.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
              } }]), Nn;
            }(Nt.a.PureComponent), Cg2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("g", null, Nt.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
              } }]), Nn;
            }(Nt.a.PureComponent), Rb2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("g", null, Nt.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Nn;
            }(Nt.a.PureComponent), ax = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("g", null, Nt.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Nn;
            }(Nt.a.PureComponent), hM = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("g", null, Nt.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
              } }]), Nn;
            }(Nt.a.PureComponent), ox = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("g", null, Nt.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
              } }]), Nn;
            }(Nt.a.PureComponent), l0 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.style, wn = Ce2(hr, ["style"]);
                return Nt.a.createElement("span", wn, Nt.a.createElement("svg", Object.assign({}, $h2(vr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Nt.a.createElement("g", null, Nt.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Nn;
            }(Nt.a.PureComponent);
            function $h2(wr) {
              return wr || (wr = {}), { style: O2(O2({ verticalAlign: "middle" }, wr), {}, { color: wr.color ? wr.color : "#000000", height: "1em", width: "1em" }) };
            }
            var Ay = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                return V3(this, Nn), (vr = Pr.call(this, hr)).copiedTimer = null, vr.handleCopy = function() {
                  var wn = document.createElement("textarea"), no = vr.props, Pa2 = no.clickCallback, pi2 = no.src, Uo = no.namespace;
                  wn.innerHTML = JSON.stringify(vr.clipboardValue(pi2), null, "  "), document.body.appendChild(wn), wn.select(), document.execCommand("copy"), document.body.removeChild(wn), vr.copiedTimer = setTimeout(function() {
                    vr.setState({ copied: false });
                  }, 5500), vr.setState({ copied: true }, function() {
                    typeof Pa2 == "function" && Pa2({ src: pi2, namespace: Uo, name: Uo[Uo.length - 1] });
                  });
                }, vr.getClippyIcon = function() {
                  var wn = vr.props.theme;
                  return vr.state.copied ? Nt.a.createElement("span", null, Nt.a.createElement(Cg2, Object.assign({ className: "copy-icon" }, bn(wn, "copy-icon"))), Nt.a.createElement("span", bn(wn, "copy-icon-copied"), "\u2714")) : Nt.a.createElement(Cg2, Object.assign({ className: "copy-icon" }, bn(wn, "copy-icon")));
                }, vr.clipboardValue = function(wn) {
                  switch (Le2(wn)) {
                    case "function":
                    case "regexp":
                      return wn.toString();
                    default:
                      return wn;
                  }
                }, vr.state = { copied: false }, vr;
              }
              return q3(Nn, [{ key: "componentWillUnmount", value: function() {
                this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
              } }, { key: "render", value: function() {
                var hr = this.props, vr = (hr.src, hr.theme), wn = hr.hidden, no = hr.rowHovered, Pa2 = bn(vr, "copy-to-clipboard").style, pi2 = "inline";
                return wn && (pi2 = "none"), Nt.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: no ? "inline-block" : "none" } }, Nt.a.createElement("span", { style: O2(O2({}, Pa2), {}, { display: pi2 }), onClick: this.handleCopy }, this.getClippyIcon()));
              } }]), Nn;
            }(Nt.a.PureComponent), R1 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                return V3(this, Nn), (vr = Pr.call(this, hr)).getEditIcon = function() {
                  var wn = vr.props, no = wn.variable, Pa2 = wn.theme;
                  return Nt.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: vr.state.hovered ? "inline-block" : "none" } }, Nt.a.createElement(ox, Object.assign({ className: "click-to-edit-icon" }, bn(Pa2, "editVarIcon"), { onClick: function() {
                    vr.prepopInput(no);
                  } })));
                }, vr.prepopInput = function(wn) {
                  if (vr.props.onEdit !== false) {
                    var no = function(pi2) {
                      var Uo;
                      switch (Le2(pi2)) {
                        case "undefined":
                          Uo = "undefined";
                          break;
                        case "nan":
                          Uo = "NaN";
                          break;
                        case "string":
                          Uo = pi2;
                          break;
                        case "date":
                        case "function":
                        case "regexp":
                          Uo = pi2.toString();
                          break;
                        default:
                          try {
                            Uo = JSON.stringify(pi2, null, "  ");
                          } catch {
                            Uo = "";
                          }
                      }
                      return Uo;
                    }(wn.value), Pa2 = js(no);
                    vr.setState({ editMode: true, editValue: no, parsedInput: { type: Pa2.type, value: Pa2.value } });
                  }
                }, vr.getRemoveIcon = function() {
                  var wn = vr.props, no = wn.variable, Pa2 = wn.namespace, pi2 = wn.theme, Uo = wn.rjvId;
                  return Nt.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: vr.state.hovered ? "inline-block" : "none" } }, Nt.a.createElement(Rb2, Object.assign({ className: "click-to-remove-icon" }, bn(pi2, "removeVarIcon"), { onClick: function() {
                    tl.dispatch({ name: "VARIABLE_REMOVED", rjvId: Uo, data: { name: no.name, namespace: Pa2, existing_value: no.value, variable_removed: true } });
                  } })));
                }, vr.getValue = function(wn, no) {
                  var Pa2 = !no && wn.type, pi2 = yt(vr).props;
                  switch (Pa2) {
                    case false:
                      return vr.getEditInput();
                    case "string":
                      return Nt.a.createElement(fu, Object.assign({ value: wn.value }, pi2));
                    case "integer":
                      return Nt.a.createElement(Bl, Object.assign({ value: wn.value }, pi2));
                    case "float":
                      return Nt.a.createElement(Tr, Object.assign({ value: wn.value }, pi2));
                    case "boolean":
                      return Nt.a.createElement(Xn, Object.assign({ value: wn.value }, pi2));
                    case "function":
                      return Nt.a.createElement(Hs, Object.assign({ value: wn.value }, pi2));
                    case "null":
                      return Nt.a.createElement(xs, pi2);
                    case "nan":
                      return Nt.a.createElement(ol, pi2);
                    case "undefined":
                      return Nt.a.createElement(uh2, pi2);
                    case "date":
                      return Nt.a.createElement(or, Object.assign({ value: wn.value }, pi2));
                    case "regexp":
                      return Nt.a.createElement(Ph2, Object.assign({ value: wn.value }, pi2));
                    default:
                      return Nt.a.createElement("div", { className: "object-value" }, JSON.stringify(wn.value));
                  }
                }, vr.getEditInput = function() {
                  var wn = vr.props.theme, no = vr.state.editValue;
                  return Nt.a.createElement("div", null, Nt.a.createElement(bo, Object.assign({ type: "text", inputRef: function(Pa2) {
                    return Pa2 && Pa2.focus();
                  }, value: no, className: "variable-editor", onChange: function(Pa2) {
                    var pi2 = Pa2.target.value, Uo = js(pi2);
                    vr.setState({ editValue: pi2, parsedInput: { type: Uo.type, value: Uo.value } });
                  }, onKeyDown: function(Pa2) {
                    switch (Pa2.key) {
                      case "Escape":
                        vr.setState({ editMode: false, editValue: "" });
                        break;
                      case "Enter":
                        (Pa2.ctrlKey || Pa2.metaKey) && vr.submitEdit(true);
                    }
                    Pa2.stopPropagation();
                  }, placeholder: "update this value", minRows: 2 }, bn(wn, "edit-input"))), Nt.a.createElement("div", bn(wn, "edit-icon-container"), Nt.a.createElement(Rb2, Object.assign({ className: "edit-cancel" }, bn(wn, "cancel-icon"), { onClick: function() {
                    vr.setState({ editMode: false, editValue: "" });
                  } })), Nt.a.createElement(l0, Object.assign({ className: "edit-check string-value" }, bn(wn, "check-icon"), { onClick: function() {
                    vr.submitEdit();
                  } })), Nt.a.createElement("div", null, vr.showDetected())));
                }, vr.submitEdit = function(wn) {
                  var no = vr.props, Pa2 = no.variable, pi2 = no.namespace, Uo = no.rjvId, os = vr.state, If2 = os.editValue, Lh2 = os.parsedInput, Yh2 = If2;
                  wn && Lh2.type && (Yh2 = Lh2.value), vr.setState({ editMode: false }), tl.dispatch({ name: "VARIABLE_UPDATED", rjvId: Uo, data: { name: Pa2.name, namespace: pi2, existing_value: Pa2.value, new_value: Yh2, variable_removed: false } });
                }, vr.showDetected = function() {
                  var wn = vr.props, no = wn.theme, Pa2 = (wn.variable, wn.namespace, wn.rjvId, vr.state.parsedInput), pi2 = (Pa2.type, Pa2.value, vr.getDetectedInput());
                  if (pi2)
                    return Nt.a.createElement("div", null, Nt.a.createElement("div", bn(no, "detected-row"), pi2, Nt.a.createElement(l0, { className: "edit-check detected", style: O2({ verticalAlign: "top", paddingLeft: "3px" }, bn(no, "check-icon").style), onClick: function() {
                      vr.submitEdit(true);
                    } })));
                }, vr.getDetectedInput = function() {
                  var wn = vr.state.parsedInput, no = wn.type, Pa2 = wn.value, pi2 = yt(vr).props, Uo = pi2.theme;
                  if (no !== false)
                    switch (no.toLowerCase()) {
                      case "object":
                        return Nt.a.createElement("span", null, Nt.a.createElement("span", { style: O2(O2({}, bn(Uo, "brace").style), {}, { cursor: "default" }) }, "{"), Nt.a.createElement("span", { style: O2(O2({}, bn(Uo, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Nt.a.createElement("span", { style: O2(O2({}, bn(Uo, "brace").style), {}, { cursor: "default" }) }, "}"));
                      case "array":
                        return Nt.a.createElement("span", null, Nt.a.createElement("span", { style: O2(O2({}, bn(Uo, "brace").style), {}, { cursor: "default" }) }, "["), Nt.a.createElement("span", { style: O2(O2({}, bn(Uo, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Nt.a.createElement("span", { style: O2(O2({}, bn(Uo, "brace").style), {}, { cursor: "default" }) }, "]"));
                      case "string":
                        return Nt.a.createElement(fu, Object.assign({ value: Pa2 }, pi2));
                      case "integer":
                        return Nt.a.createElement(Bl, Object.assign({ value: Pa2 }, pi2));
                      case "float":
                        return Nt.a.createElement(Tr, Object.assign({ value: Pa2 }, pi2));
                      case "boolean":
                        return Nt.a.createElement(Xn, Object.assign({ value: Pa2 }, pi2));
                      case "function":
                        return Nt.a.createElement(Hs, Object.assign({ value: Pa2 }, pi2));
                      case "null":
                        return Nt.a.createElement(xs, pi2);
                      case "nan":
                        return Nt.a.createElement(ol, pi2);
                      case "undefined":
                        return Nt.a.createElement(uh2, pi2);
                      case "date":
                        return Nt.a.createElement(or, Object.assign({ value: new Date(Pa2) }, pi2));
                    }
                }, vr.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, vr;
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this, vr = this.props, wn = vr.variable, no = vr.singleIndent, Pa2 = vr.type, pi2 = vr.theme, Uo = vr.namespace, os = vr.indentWidth, If2 = vr.enableClipboard, Lh2 = vr.onEdit, Yh2 = vr.onDelete, Bf2 = vr.onSelect, Sd2 = vr.displayArrayKey, Fv = vr.quotesOnKeys, Nc2 = this.state.editMode;
                return Nt.a.createElement("div", Object.assign({}, bn(pi2, "objectKeyVal", { paddingLeft: os * no }), { onMouseEnter: function() {
                  return hr.setState(O2(O2({}, hr.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return hr.setState(O2(O2({}, hr.state), {}, { hovered: false }));
                }, className: "variable-row", key: wn.name }), Pa2 == "array" ? Sd2 ? Nt.a.createElement("span", Object.assign({}, bn(pi2, "array-key"), { key: wn.name + "_" + Uo }), wn.name, Nt.a.createElement("div", bn(pi2, "colon"), ":")) : null : Nt.a.createElement("span", null, Nt.a.createElement("span", Object.assign({}, bn(pi2, "object-name"), { className: "object-key", key: wn.name + "_" + Uo }), !!Fv && Nt.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Nt.a.createElement("span", { style: { display: "inline-block" } }, wn.name), !!Fv && Nt.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Nt.a.createElement("span", bn(pi2, "colon"), ":")), Nt.a.createElement("div", Object.assign({ className: "variable-value", onClick: Bf2 === false && Lh2 === false ? null : function(X0) {
                  var T0 = Ms(Uo);
                  (X0.ctrlKey || X0.metaKey) && Lh2 !== false ? hr.prepopInput(wn) : Bf2 !== false && (T0.shift(), Bf2(O2(O2({}, wn), {}, { namespace: T0 })));
                } }, bn(pi2, "variableValue", { cursor: Bf2 === false ? "default" : "pointer" })), this.getValue(wn, Nc2)), If2 ? Nt.a.createElement(Ay, { rowHovered: this.state.hovered, hidden: Nc2, src: wn.value, clickCallback: If2, theme: pi2, namespace: [].concat(Ms(Uo), [wn.name]) }) : null, Lh2 !== false && Nc2 == 0 ? this.getEditIcon() : null, Yh2 !== false && Nc2 == 0 ? this.getRemoveIcon() : null);
              } }]), Nn;
            }(Nt.a.PureComponent), pM = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                var hr;
                V3(this, Nn);
                for (var vr = arguments.length, wn = new Array(vr), no = 0; no < vr; no++)
                  wn[no] = arguments[no];
                return (hr = Pr.call.apply(Pr, [this].concat(wn))).getObjectSize = function() {
                  var Pa2 = hr.props, pi2 = Pa2.size, Uo = Pa2.theme;
                  if (Pa2.displayObjectSize)
                    return Nt.a.createElement("span", Object.assign({ className: "object-size" }, bn(Uo, "object-size")), pi2, " item", pi2 === 1 ? "" : "s");
                }, hr.getAddAttribute = function(Pa2) {
                  var pi2 = hr.props, Uo = pi2.theme, os = pi2.namespace, If2 = pi2.name, Lh2 = pi2.src, Yh2 = pi2.rjvId, Bf2 = pi2.depth;
                  return Nt.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: Pa2 ? "inline-block" : "none" } }, Nt.a.createElement(ax, Object.assign({ className: "click-to-add-icon" }, bn(Uo, "addVarIcon"), { onClick: function() {
                    var Sd2 = { name: Bf2 > 0 ? If2 : null, namespace: os.splice(0, os.length - 1), existing_value: Lh2, variable_removed: false, key_name: null };
                    Le2(Lh2) === "object" ? tl.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Yh2, data: Sd2 }) : tl.dispatch({ name: "VARIABLE_ADDED", rjvId: Yh2, data: O2(O2({}, Sd2), {}, { new_value: [].concat(Ms(Lh2), [null]) }) });
                  } })));
                }, hr.getRemoveObject = function(Pa2) {
                  var pi2 = hr.props, Uo = pi2.theme, os = (pi2.hover, pi2.namespace), If2 = pi2.name, Lh2 = pi2.src, Yh2 = pi2.rjvId;
                  if (os.length !== 1)
                    return Nt.a.createElement("span", { className: "click-to-remove", style: { display: Pa2 ? "inline-block" : "none" } }, Nt.a.createElement(Rb2, Object.assign({ className: "click-to-remove-icon" }, bn(Uo, "removeVarIcon"), { onClick: function() {
                      tl.dispatch({ name: "VARIABLE_REMOVED", rjvId: Yh2, data: { name: If2, namespace: os.splice(0, os.length - 1), existing_value: Lh2, variable_removed: true } });
                    } })));
                }, hr.render = function() {
                  var Pa2 = hr.props, pi2 = Pa2.theme, Uo = Pa2.onDelete, os = Pa2.onAdd, If2 = Pa2.enableClipboard, Lh2 = Pa2.src, Yh2 = Pa2.namespace, Bf2 = Pa2.rowHovered;
                  return Nt.a.createElement("div", Object.assign({}, bn(pi2, "object-meta-data"), { className: "object-meta-data", onClick: function(Sd2) {
                    Sd2.stopPropagation();
                  } }), hr.getObjectSize(), If2 ? Nt.a.createElement(Ay, { rowHovered: Bf2, clickCallback: If2, src: Lh2, theme: pi2, namespace: Yh2 }) : null, os !== false ? hr.getAddAttribute(Bf2) : null, Uo !== false ? hr.getRemoveObject(Bf2) : null);
                }, hr;
              }
              return Nn;
            }(Nt.a.PureComponent);
            function Pw(wr) {
              var Pr = wr.parent_type, Nn = wr.namespace, hr = wr.quotesOnKeys, vr = wr.theme, wn = wr.jsvRoot, no = wr.name, Pa2 = wr.displayArrayKey, pi2 = wr.name ? wr.name : "";
              return !wn || no !== false && no !== null ? Pr == "array" ? Pa2 ? Nt.a.createElement("span", Object.assign({}, bn(vr, "array-key"), { key: Nn }), Nt.a.createElement("span", { className: "array-key" }, pi2), Nt.a.createElement("span", bn(vr, "colon"), ":")) : Nt.a.createElement("span", null) : Nt.a.createElement("span", Object.assign({}, bn(vr, "object-name"), { key: Nn }), Nt.a.createElement("span", { className: "object-key" }, hr && Nt.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Nt.a.createElement("span", null, pi2), hr && Nt.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Nt.a.createElement("span", bn(vr, "colon"), ":")) : Nt.a.createElement("span", null);
            }
            function sx(wr) {
              var Pr = wr.theme;
              switch (wr.iconStyle) {
                case "triangle":
                  return Nt.a.createElement(K0, Object.assign({}, bn(Pr, "expanded-icon"), { className: "expanded-icon" }));
                case "square":
                  return Nt.a.createElement(nd2, Object.assign({}, bn(Pr, "expanded-icon"), { className: "expanded-icon" }));
                default:
                  return Nt.a.createElement(bf2, Object.assign({}, bn(Pr, "expanded-icon"), { className: "expanded-icon" }));
              }
            }
            function l22(wr) {
              var Pr = wr.theme;
              switch (wr.iconStyle) {
                case "triangle":
                  return Nt.a.createElement(Mg2, Object.assign({}, bn(Pr, "collapsed-icon"), { className: "collapsed-icon" }));
                case "square":
                  return Nt.a.createElement(bv, Object.assign({}, bn(Pr, "collapsed-icon"), { className: "collapsed-icon" }));
                default:
                  return Nt.a.createElement(_f, Object.assign({}, bn(Pr, "collapsed-icon"), { className: "collapsed-icon" }));
              }
            }
            var n32 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                return V3(this, Nn), (vr = Pr.call(this, hr)).toggleCollapsed = function(wn) {
                  var no = [];
                  for (var Pa2 in vr.state.expanded)
                    no.push(vr.state.expanded[Pa2]);
                  no[wn] = !no[wn], vr.setState({ expanded: no });
                }, vr.state = { expanded: [] }, vr;
              }
              return q3(Nn, [{ key: "getExpandedIcon", value: function(hr) {
                var vr = this.props, wn = vr.theme, no = vr.iconStyle;
                return this.state.expanded[hr] ? Nt.a.createElement(sx, { theme: wn, iconStyle: no }) : Nt.a.createElement(l22, { theme: wn, iconStyle: no });
              } }, { key: "render", value: function() {
                var hr = this, vr = this.props, wn = vr.src, no = vr.groupArraysAfterLength, Pa2 = (vr.depth, vr.name), pi2 = vr.theme, Uo = vr.jsvRoot, os = vr.namespace, If2 = (vr.parent_type, Ce2(vr, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Lh2 = 0, Yh2 = 5 * this.props.indentWidth;
                Uo || (Lh2 = 5 * this.props.indentWidth);
                var Bf2 = no, Sd2 = Math.ceil(wn.length / Bf2);
                return Nt.a.createElement("div", Object.assign({ className: "object-key-val" }, bn(pi2, Uo ? "jsv-root" : "objectKeyVal", { paddingLeft: Lh2 })), Nt.a.createElement(Pw, this.props), Nt.a.createElement("span", null, Nt.a.createElement(pM, Object.assign({ size: wn.length }, this.props))), Ms(Array(Sd2)).map(function(Fv, Nc2) {
                  return Nt.a.createElement("div", Object.assign({ key: Nc2, className: "object-key-val array-group" }, bn(pi2, "objectKeyVal", { marginLeft: 6, paddingLeft: Yh2 })), Nt.a.createElement("span", bn(pi2, "brace-row"), Nt.a.createElement("div", Object.assign({ className: "icon-container" }, bn(pi2, "icon-container"), { onClick: function(X0) {
                    hr.toggleCollapsed(Nc2);
                  } }), hr.getExpandedIcon(Nc2)), hr.state.expanded[Nc2] ? Nt.a.createElement(ck2, Object.assign({ key: Pa2 + Nc2, depth: 0, name: false, collapsed: false, groupArraysAfterLength: Bf2, index_offset: Nc2 * Bf2, src: wn.slice(Nc2 * Bf2, Nc2 * Bf2 + Bf2), namespace: os, type: "array", parent_type: "array_group", theme: pi2 }, If2)) : Nt.a.createElement("span", Object.assign({}, bn(pi2, "brace"), { onClick: function(X0) {
                    hr.toggleCollapsed(Nc2);
                  }, className: "array-group-brace" }), "[", Nt.a.createElement("div", Object.assign({}, bn(pi2, "array-group-meta-data"), { className: "array-group-meta-data" }), Nt.a.createElement("span", Object.assign({ className: "object-size" }, bn(pi2, "object-size")), Nc2 * Bf2, " - ", Nc2 * Bf2 + Bf2 > wn.length ? wn.length : Nc2 * Bf2 + Bf2)), "]")));
                }));
              } }]), Nn;
            }(Nt.a.PureComponent), uk2 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                V3(this, Nn), (vr = Pr.call(this, hr)).toggleCollapsed = function() {
                  vr.setState({ expanded: !vr.state.expanded }, function() {
                    as.set(vr.props.rjvId, vr.props.namespace, "expanded", vr.state.expanded);
                  });
                }, vr.getObjectContent = function(no, Pa2, pi2) {
                  return Nt.a.createElement("div", { className: "pushed-content object-container" }, Nt.a.createElement("div", Object.assign({ className: "object-content" }, bn(vr.props.theme, "pushed-content")), vr.renderObjectContents(Pa2, pi2)));
                }, vr.getEllipsis = function() {
                  return vr.state.size === 0 ? null : Nt.a.createElement("div", Object.assign({}, bn(vr.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: vr.toggleCollapsed }), "...");
                }, vr.getObjectMetaData = function(no) {
                  var Pa2 = vr.props, pi2 = (Pa2.rjvId, Pa2.theme, vr.state), Uo = pi2.size, os = pi2.hovered;
                  return Nt.a.createElement(pM, Object.assign({ rowHovered: os, size: Uo }, vr.props));
                }, vr.renderObjectContents = function(no, Pa2) {
                  var pi2, Uo = vr.props, os = Uo.depth, If2 = Uo.parent_type, Lh2 = Uo.index_offset, Yh2 = Uo.groupArraysAfterLength, Bf2 = Uo.namespace, Sd2 = vr.state.object_type, Fv = [], Nc2 = Object.keys(no || {});
                  return vr.props.sortKeys && Sd2 !== "array" && (Nc2 = Nc2.sort()), Nc2.forEach(function(X0) {
                    if (pi2 = new sj2(X0, no[X0]), If2 === "array_group" && Lh2 && (pi2.name = parseInt(pi2.name) + Lh2), no.hasOwnProperty(X0))
                      if (pi2.type === "object")
                        Fv.push(Nt.a.createElement(ck2, Object.assign({ key: pi2.name, depth: os + 1, name: pi2.name, src: pi2.value, namespace: Bf2.concat(pi2.name), parent_type: Sd2 }, Pa2)));
                      else if (pi2.type === "array") {
                        var T0 = ck2;
                        Yh2 && pi2.value.length > Yh2 && (T0 = n32), Fv.push(Nt.a.createElement(T0, Object.assign({ key: pi2.name, depth: os + 1, name: pi2.name, src: pi2.value, namespace: Bf2.concat(pi2.name), type: "array", parent_type: Sd2 }, Pa2)));
                      } else
                        Fv.push(Nt.a.createElement(R1, Object.assign({ key: pi2.name + "_" + Bf2, variable: pi2, singleIndent: 5, namespace: Bf2, type: vr.props.type }, Pa2)));
                  }), Fv;
                };
                var wn = Nn.getState(hr);
                return vr.state = O2(O2({}, wn), {}, { prevProps: {} }), vr;
              }
              return q3(Nn, [{ key: "getBraceStart", value: function(hr, vr) {
                var wn = this, no = this.props, Pa2 = no.src, pi2 = no.theme, Uo = no.iconStyle;
                if (no.parent_type === "array_group")
                  return Nt.a.createElement("span", null, Nt.a.createElement("span", bn(pi2, "brace"), hr === "array" ? "[" : "{"), vr ? this.getObjectMetaData(Pa2) : null);
                var os = vr ? sx : l22;
                return Nt.a.createElement("span", null, Nt.a.createElement("span", Object.assign({ onClick: function(If2) {
                  wn.toggleCollapsed();
                } }, bn(pi2, "brace-row")), Nt.a.createElement("div", Object.assign({ className: "icon-container" }, bn(pi2, "icon-container")), Nt.a.createElement(os, { theme: pi2, iconStyle: Uo })), Nt.a.createElement(Pw, this.props), Nt.a.createElement("span", bn(pi2, "brace"), hr === "array" ? "[" : "{")), vr ? this.getObjectMetaData(Pa2) : null);
              } }, { key: "render", value: function() {
                var hr = this, vr = this.props, wn = vr.depth, no = vr.src, Pa2 = (vr.namespace, vr.name, vr.type, vr.parent_type), pi2 = vr.theme, Uo = vr.jsvRoot, os = vr.iconStyle, If2 = Ce2(vr, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Lh2 = this.state, Yh2 = Lh2.object_type, Bf2 = Lh2.expanded, Sd2 = {};
                return Uo || Pa2 === "array_group" ? Pa2 === "array_group" && (Sd2.borderLeft = 0, Sd2.display = "inline") : Sd2.paddingLeft = 5 * this.props.indentWidth, Nt.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                  return hr.setState(O2(O2({}, hr.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return hr.setState(O2(O2({}, hr.state), {}, { hovered: false }));
                } }, bn(pi2, Uo ? "jsv-root" : "objectKeyVal", Sd2)), this.getBraceStart(Yh2, Bf2), Bf2 ? this.getObjectContent(wn, no, O2({ theme: pi2, iconStyle: os }, If2)) : this.getEllipsis(), Nt.a.createElement("span", { className: "brace-row" }, Nt.a.createElement("span", { style: O2(O2({}, bn(pi2, "brace").style), {}, { paddingLeft: Bf2 ? "3px" : "0px" }) }, Yh2 === "array" ? "]" : "}"), Bf2 ? null : this.getObjectMetaData(no)));
              } }], [{ key: "getDerivedStateFromProps", value: function(hr, vr) {
                var wn = vr.prevProps;
                return hr.src !== wn.src || hr.collapsed !== wn.collapsed || hr.name !== wn.name || hr.namespace !== wn.namespace || hr.rjvId !== wn.rjvId ? O2(O2({}, Nn.getState(hr)), {}, { prevProps: hr }) : null;
              } }]), Nn;
            }(Nt.a.PureComponent);
            uk2.getState = function(wr) {
              var Pr = Object.keys(wr.src).length, Nn = (wr.collapsed === false || wr.collapsed !== true && wr.collapsed > wr.depth) && (!wr.shouldCollapse || wr.shouldCollapse({ name: wr.name, src: wr.src, type: Le2(wr.src), namespace: wr.namespace }) === false) && Pr !== 0;
              return { expanded: as.get(wr.rjvId, wr.namespace, "expanded", Nn), object_type: wr.type === "array" ? "array" : "object", parent_type: wr.type === "array" ? "array" : "object", size: Pr, hovered: false };
            };
            var sj2 = function wr(Pr, Nn) {
              V3(this, wr), this.name = Pr, this.value = Nn, this.type = Le2(Nn);
            };
            xe(uk2);
            var ck2 = uk2, $st = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                var hr;
                V3(this, Nn);
                for (var vr = arguments.length, wn = new Array(vr), no = 0; no < vr; no++)
                  wn[no] = arguments[no];
                return (hr = Pr.call.apply(Pr, [this].concat(wn))).render = function() {
                  var Pa2 = yt(hr).props, pi2 = [Pa2.name], Uo = ck2;
                  return Array.isArray(Pa2.src) && Pa2.groupArraysAfterLength && Pa2.src.length > Pa2.groupArraysAfterLength && (Uo = n32), Nt.a.createElement("div", { className: "pretty-json-container object-container" }, Nt.a.createElement("div", { className: "object-content" }, Nt.a.createElement(Uo, Object.assign({ namespace: pi2, depth: 0, jsvRoot: true }, Pa2))));
                }, hr;
              }
              return Nn;
            }(Nt.a.PureComponent), Yst = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                return V3(this, Nn), (vr = Pr.call(this, hr)).closeModal = function() {
                  tl.dispatch({ rjvId: vr.props.rjvId, name: "RESET" });
                }, vr.submit = function() {
                  vr.props.submit(vr.state.input);
                }, vr.state = { input: hr.input ? hr.input : "" }, vr;
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this, vr = this.props, wn = vr.theme, no = vr.rjvId, Pa2 = vr.isValid, pi2 = this.state.input, Uo = Pa2(pi2);
                return Nt.a.createElement("div", Object.assign({ className: "key-modal-request" }, bn(wn, "key-modal-request"), { onClick: this.closeModal }), Nt.a.createElement("div", Object.assign({}, bn(wn, "key-modal"), { onClick: function(os) {
                  os.stopPropagation();
                } }), Nt.a.createElement("div", bn(wn, "key-modal-label"), "Key Name:"), Nt.a.createElement("div", { style: { position: "relative" } }, Nt.a.createElement("input", Object.assign({}, bn(wn, "key-modal-input"), { className: "key-modal-input", ref: function(os) {
                  return os && os.focus();
                }, spellCheck: false, value: pi2, placeholder: "...", onChange: function(os) {
                  hr.setState({ input: os.target.value });
                }, onKeyPress: function(os) {
                  Uo && os.key === "Enter" ? hr.submit() : os.key === "Escape" && hr.closeModal();
                } })), Uo ? Nt.a.createElement(l0, Object.assign({}, bn(wn, "key-modal-submit"), { className: "key-modal-submit", onClick: function(os) {
                  return hr.submit();
                } })) : null), Nt.a.createElement("span", bn(wn, "key-modal-cancel"), Nt.a.createElement(hM, Object.assign({}, bn(wn, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                  tl.dispatch({ rjvId: no, name: "RESET" });
                } })))));
              } }]), Nn;
            }(Nt.a.PureComponent), Kst = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                var hr;
                V3(this, Nn);
                for (var vr = arguments.length, wn = new Array(vr), no = 0; no < vr; no++)
                  wn[no] = arguments[no];
                return (hr = Pr.call.apply(Pr, [this].concat(wn))).isValid = function(Pa2) {
                  var pi2 = hr.props.rjvId, Uo = as.get(pi2, "action", "new-key-request");
                  return Pa2 != "" && Object.keys(Uo.existing_value).indexOf(Pa2) === -1;
                }, hr.submit = function(Pa2) {
                  var pi2 = hr.props.rjvId, Uo = as.get(pi2, "action", "new-key-request");
                  Uo.new_value = O2({}, Uo.existing_value), Uo.new_value[Pa2] = hr.props.defaultValue, tl.dispatch({ name: "VARIABLE_ADDED", rjvId: pi2, data: Uo });
                }, hr;
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.active, wn = hr.theme, no = hr.rjvId;
                return vr ? Nt.a.createElement(Yst, { rjvId: no, theme: wn, isValid: this.isValid, submit: this.submit }) : null;
              } }]), Nn;
            }(Nt.a.PureComponent), Xst = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn() {
                return V3(this, Nn), Pr.apply(this, arguments);
              }
              return q3(Nn, [{ key: "render", value: function() {
                var hr = this.props, vr = hr.message, wn = hr.active, no = hr.theme, Pa2 = hr.rjvId;
                return wn ? Nt.a.createElement("div", Object.assign({ className: "validation-failure" }, bn(no, "validation-failure"), { onClick: function() {
                  tl.dispatch({ rjvId: Pa2, name: "RESET" });
                } }), Nt.a.createElement("span", bn(no, "validation-failure-label"), vr), Nt.a.createElement(hM, bn(no, "validation-failure-clear"))) : null;
              } }]), Nn;
            }(Nt.a.PureComponent), A8 = function(wr) {
              J(Nn, wr);
              var Pr = Lt(Nn);
              function Nn(hr) {
                var vr;
                return V3(this, Nn), (vr = Pr.call(this, hr)).rjvId = Date.now().toString(), vr.getListeners = function() {
                  return { reset: vr.resetState, "variable-update": vr.updateSrc, "add-key-request": vr.addKeyRequest };
                }, vr.updateSrc = function() {
                  var wn, no = as.get(vr.rjvId, "action", "variable-update"), Pa2 = no.name, pi2 = no.namespace, Uo = no.new_value, os = no.existing_value, If2 = (no.variable_removed, no.updated_src), Lh2 = no.type, Yh2 = vr.props, Bf2 = Yh2.onEdit, Sd2 = Yh2.onDelete, Fv = Yh2.onAdd, Nc2 = { existing_src: vr.state.src, new_value: Uo, updated_src: If2, name: Pa2, namespace: pi2, existing_value: os };
                  switch (Lh2) {
                    case "variable-added":
                      wn = Fv(Nc2);
                      break;
                    case "variable-edited":
                      wn = Bf2(Nc2);
                      break;
                    case "variable-removed":
                      wn = Sd2(Nc2);
                  }
                  wn !== false ? (as.set(vr.rjvId, "global", "src", If2), vr.setState({ src: If2 })) : vr.setState({ validationFailure: true });
                }, vr.addKeyRequest = function() {
                  vr.setState({ addKeyRequest: true });
                }, vr.resetState = function() {
                  vr.setState({ validationFailure: false, addKeyRequest: false });
                }, vr.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Nn.defaultProps.src, name: Nn.defaultProps.name, theme: Nn.defaultProps.theme, validationMessage: Nn.defaultProps.validationMessage, prevSrc: Nn.defaultProps.src, prevName: Nn.defaultProps.name, prevTheme: Nn.defaultProps.theme }, vr;
              }
              return q3(Nn, [{ key: "componentDidMount", value: function() {
                as.set(this.rjvId, "global", "src", this.state.src);
                var hr = this.getListeners();
                for (var vr in hr)
                  as.on(vr + "-" + this.rjvId, hr[vr]);
                this.setState({ addKeyRequest: false, editKeyRequest: false });
              } }, { key: "componentDidUpdate", value: function(hr, vr) {
                vr.addKeyRequest !== false && this.setState({ addKeyRequest: false }), vr.editKeyRequest !== false && this.setState({ editKeyRequest: false }), hr.src !== this.state.src && as.set(this.rjvId, "global", "src", this.state.src);
              } }, { key: "componentWillUnmount", value: function() {
                var hr = this.getListeners();
                for (var vr in hr)
                  as.removeListener(vr + "-" + this.rjvId, hr[vr]);
              } }, { key: "render", value: function() {
                var hr = this.state, vr = hr.validationFailure, wn = hr.validationMessage, no = hr.addKeyRequest, Pa2 = hr.theme, pi2 = hr.src, Uo = hr.name, os = this.props, If2 = os.style, Lh2 = os.defaultValue;
                return Nt.a.createElement("div", { className: "react-json-view", style: O2(O2({}, bn(Pa2, "app-container").style), If2) }, Nt.a.createElement(Xst, { message: wn, active: vr, theme: Pa2, rjvId: this.rjvId }), Nt.a.createElement($st, Object.assign({}, this.props, { src: pi2, name: Uo, theme: Pa2, type: Le2(pi2), rjvId: this.rjvId })), Nt.a.createElement(Kst, { active: no, theme: Pa2, rjvId: this.rjvId, defaultValue: Lh2 }));
              } }], [{ key: "getDerivedStateFromProps", value: function(hr, vr) {
                if (hr.src !== vr.prevSrc || hr.name !== vr.prevName || hr.theme !== vr.prevTheme) {
                  var wn = { src: hr.src, name: hr.name, theme: hr.theme, validationMessage: hr.validationMessage, prevSrc: hr.src, prevName: hr.name, prevTheme: hr.theme };
                  return Nn.validateState(wn);
                }
                return null;
              } }]), Nn;
            }(Nt.a.PureComponent);
            A8.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, A8.validateState = function(wr) {
              var Pr = {};
              return Le2(wr.theme) !== "object" || function(Nn) {
                var hr = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                if (Le2(Nn) === "object") {
                  for (var vr = 0; vr < hr.length; vr++)
                    if (!(hr[vr] in Nn))
                      return false;
                  return true;
                }
                return false;
              }(wr.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Pr.theme = "rjv-default"), Le2(wr.src) !== "object" && Le2(wr.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Pr.name = "ERROR", Pr.src = { message: "src property must be a valid json object" }), O2(O2({}, wr), Pr);
            }, xe(A8), m2.default = A8;
          }]);
        });
      })(DCe);
      var $Rn = Ze2(DCe.exports);
      const YRn = ({ id: u, title: o, chart: n3, option: p2 }) => {
        const { tool: m2 } = gBt({}), w2 = Twt({ global: true }), [T2, { set: E }] = vt(true);
        console.log("option", p2);
        const O2 = (V3) => {
          const { updated_src: W3 } = V3;
          n3 == null || n3.setOption(W3), m2 == null || m2.add(u, n3, W3, o), w2.emit("list");
        };
        return PRn("div", { children: [FY(VRn, { children: FY(WRn, { children: FY(HRn, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (V3) => {
          E(!V3);
        } }) }) }), FY("br", {}), p2 && FY($Rn, { src: p2, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: T2, iconStyle: "triangle", enableClipboard: true, onEdit: O2, onAdd: O2, onDelete: O2 })] });
      };
      l2.EchartTool = ZRn, l2.ReactEchartsJson = YRn, l2.useEcharts = uOn, l2.useEchartsTool = gBt, l2.useEventEmitter = Twt;
    })(S1t);
    const G0n = () => {
      const l2 = S1t.useEventEmitter({ global: true }), a = P2.useRef(0), { tool: e2 } = S1t.useEchartsTool({});
      P2.useState(false), P2.useState("right");
      const [d2, y2] = P2.useState([]), [x2, C] = P2.useState();
      return l2.useSubscription("list", () => {
        var D2;
        e2 != null && e2.list().length && (C((D2 = e2 == null ? void 0 : e2.list()) == null ? void 0 : D2[a.current]), y2(e2 == null ? void 0 : e2.list()));
      }), PZ("div", { className: W0n.container, children: false });
    };
    var sve = { exports: {} };
    (function(l2, a) {
      (function(e2, d2) {
        l2.exports = d2(H2.default);
      })(en, function(e2) {
        return function(d2) {
          var y2 = {};
          function x2(C) {
            if (y2[C])
              return y2[C].exports;
            var D2 = y2[C] = { i: C, l: false, exports: {} };
            return d2[C].call(D2.exports, D2, D2.exports, x2), D2.l = true, D2.exports;
          }
          return x2.m = d2, x2.c = y2, x2.d = function(C, D2, L) {
            x2.o(C, D2) || Object.defineProperty(C, D2, { enumerable: true, get: L });
          }, x2.r = function(C) {
            typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(C, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(C, "__esModule", { value: true });
          }, x2.t = function(C, D2) {
            if (1 & D2 && (C = x2(C)), 8 & D2 || 4 & D2 && typeof C == "object" && C && C.__esModule)
              return C;
            var L = /* @__PURE__ */ Object.create(null);
            if (x2.r(L), Object.defineProperty(L, "default", { enumerable: true, value: C }), 2 & D2 && typeof C != "string")
              for (var F3 in C)
                x2.d(L, F3, function(j) {
                  return C[j];
                }.bind(null, F3));
            return L;
          }, x2.n = function(C) {
            var D2 = C && C.__esModule ? function() {
              return C.default;
            } : function() {
              return C;
            };
            return x2.d(D2, "a", D2), D2;
          }, x2.o = function(C, D2) {
            return Object.prototype.hasOwnProperty.call(C, D2);
          }, x2.p = "", x2(x2.s = 48);
        }([function(d2, y2) {
          d2.exports = e2;
        }, function(d2, y2) {
          var x2 = d2.exports = { version: "2.6.12" };
          typeof __e == "number" && (__e = x2);
        }, function(d2, y2, x2) {
          var C = x2(26)("wks"), D2 = x2(17), L = x2(3).Symbol, F3 = typeof L == "function";
          (d2.exports = function(j) {
            return C[j] || (C[j] = F3 && L[j] || (F3 ? L : D2)("Symbol." + j));
          }).store = C;
        }, function(d2, y2) {
          var x2 = d2.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
          typeof __g == "number" && (__g = x2);
        }, function(d2, y2, x2) {
          d2.exports = !x2(8)(function() {
            return Object.defineProperty({}, "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(d2, y2) {
          var x2 = {}.hasOwnProperty;
          d2.exports = function(C, D2) {
            return x2.call(C, D2);
          };
        }, function(d2, y2, x2) {
          var C = x2(7), D2 = x2(16);
          d2.exports = x2(4) ? function(L, F3, j) {
            return C.f(L, F3, D2(1, j));
          } : function(L, F3, j) {
            return L[F3] = j, L;
          };
        }, function(d2, y2, x2) {
          var C = x2(10), D2 = x2(35), L = x2(23), F3 = Object.defineProperty;
          y2.f = x2(4) ? Object.defineProperty : function(j, U3, Y3) {
            if (C(j), U3 = L(U3, true), C(Y3), D2)
              try {
                return F3(j, U3, Y3);
              } catch {
              }
            if ("get" in Y3 || "set" in Y3)
              throw TypeError("Accessors not supported!");
            return "value" in Y3 && (j[U3] = Y3.value), j;
          };
        }, function(d2, y2) {
          d2.exports = function(x2) {
            try {
              return !!x2();
            } catch {
              return true;
            }
          };
        }, function(d2, y2, x2) {
          var C = x2(40), D2 = x2(22);
          d2.exports = function(L) {
            return C(D2(L));
          };
        }, function(d2, y2, x2) {
          var C = x2(11);
          d2.exports = function(D2) {
            if (!C(D2))
              throw TypeError(D2 + " is not an object!");
            return D2;
          };
        }, function(d2, y2) {
          d2.exports = function(x2) {
            return typeof x2 == "object" ? x2 !== null : typeof x2 == "function";
          };
        }, function(d2, y2) {
          d2.exports = {};
        }, function(d2, y2, x2) {
          var C = x2(39), D2 = x2(27);
          d2.exports = Object.keys || function(L) {
            return C(L, D2);
          };
        }, function(d2, y2) {
          d2.exports = true;
        }, function(d2, y2, x2) {
          var C = x2(3), D2 = x2(1), L = x2(53), F3 = x2(6), j = x2(5), U3 = function(Y3, Q, nt) {
            var dt, vt, Ct, Pt = Y3 & U3.F, jt = Y3 & U3.G, Rt = Y3 & U3.S, le2 = Y3 & U3.P, ne2 = Y3 & U3.B, he2 = Y3 & U3.W, _e = jt ? D2 : D2[Q] || (D2[Q] = {}), Me2 = _e.prototype, Pe2 = jt ? C : Rt ? C[Q] : (C[Q] || {}).prototype;
            for (dt in jt && (nt = Q), nt)
              (vt = !Pt && Pe2 && Pe2[dt] !== void 0) && j(_e, dt) || (Ct = vt ? Pe2[dt] : nt[dt], _e[dt] = jt && typeof Pe2[dt] != "function" ? nt[dt] : ne2 && vt ? L(Ct, C) : he2 && Pe2[dt] == Ct ? function(Be2) {
                var Je2 = function(Ze2, Cn, Bn) {
                  if (this instanceof Be2) {
                    switch (arguments.length) {
                      case 0:
                        return new Be2();
                      case 1:
                        return new Be2(Ze2);
                      case 2:
                        return new Be2(Ze2, Cn);
                    }
                    return new Be2(Ze2, Cn, Bn);
                  }
                  return Be2.apply(this, arguments);
                };
                return Je2.prototype = Be2.prototype, Je2;
              }(Ct) : le2 && typeof Ct == "function" ? L(Function.call, Ct) : Ct, le2 && ((_e.virtual || (_e.virtual = {}))[dt] = Ct, Y3 & U3.R && Me2 && !Me2[dt] && F3(Me2, dt, Ct)));
          };
          U3.F = 1, U3.G = 2, U3.S = 4, U3.P = 8, U3.B = 16, U3.W = 32, U3.U = 64, U3.R = 128, d2.exports = U3;
        }, function(d2, y2) {
          d2.exports = function(x2, C) {
            return { enumerable: !(1 & x2), configurable: !(2 & x2), writable: !(4 & x2), value: C };
          };
        }, function(d2, y2) {
          var x2 = 0, C = Math.random();
          d2.exports = function(D2) {
            return "Symbol(".concat(D2 === void 0 ? "" : D2, ")_", (++x2 + C).toString(36));
          };
        }, function(d2, y2, x2) {
          var C = x2(22);
          d2.exports = function(D2) {
            return Object(C(D2));
          };
        }, function(d2, y2) {
          y2.f = {}.propertyIsEnumerable;
        }, function(d2, y2, x2) {
          var C = x2(52)(true);
          x2(34)(String, "String", function(D2) {
            this._t = String(D2), this._i = 0;
          }, function() {
            var D2, L = this._t, F3 = this._i;
            return F3 >= L.length ? { value: void 0, done: true } : (D2 = C(L, F3), this._i += D2.length, { value: D2, done: false });
          });
        }, function(d2, y2) {
          var x2 = Math.ceil, C = Math.floor;
          d2.exports = function(D2) {
            return isNaN(D2 = +D2) ? 0 : (D2 > 0 ? C : x2)(D2);
          };
        }, function(d2, y2) {
          d2.exports = function(x2) {
            if (x2 == null)
              throw TypeError("Can't call method on  " + x2);
            return x2;
          };
        }, function(d2, y2, x2) {
          var C = x2(11);
          d2.exports = function(D2, L) {
            if (!C(D2))
              return D2;
            var F3, j;
            if (L && typeof (F3 = D2.toString) == "function" && !C(j = F3.call(D2)) || typeof (F3 = D2.valueOf) == "function" && !C(j = F3.call(D2)) || !L && typeof (F3 = D2.toString) == "function" && !C(j = F3.call(D2)))
              return j;
            throw TypeError("Can't convert object to primitive value");
          };
        }, function(d2, y2) {
          var x2 = {}.toString;
          d2.exports = function(C) {
            return x2.call(C).slice(8, -1);
          };
        }, function(d2, y2, x2) {
          var C = x2(26)("keys"), D2 = x2(17);
          d2.exports = function(L) {
            return C[L] || (C[L] = D2(L));
          };
        }, function(d2, y2, x2) {
          var C = x2(1), D2 = x2(3), L = D2["__core-js_shared__"] || (D2["__core-js_shared__"] = {});
          (d2.exports = function(F3, j) {
            return L[F3] || (L[F3] = j !== void 0 ? j : {});
          })("versions", []).push({ version: C.version, mode: x2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
        }, function(d2, y2) {
          d2.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
        }, function(d2, y2, x2) {
          var C = x2(7).f, D2 = x2(5), L = x2(2)("toStringTag");
          d2.exports = function(F3, j, U3) {
            F3 && !D2(F3 = U3 ? F3 : F3.prototype, L) && C(F3, L, { configurable: true, value: j });
          };
        }, function(d2, y2, x2) {
          x2(62);
          for (var C = x2(3), D2 = x2(6), L = x2(12), F3 = x2(2)("toStringTag"), j = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), U3 = 0; U3 < j.length; U3++) {
            var Y3 = j[U3], Q = C[Y3], nt = Q && Q.prototype;
            nt && !nt[F3] && D2(nt, F3, Y3), L[Y3] = L.Array;
          }
        }, function(d2, y2, x2) {
          y2.f = x2(2);
        }, function(d2, y2, x2) {
          var C = x2(3), D2 = x2(1), L = x2(14), F3 = x2(30), j = x2(7).f;
          d2.exports = function(U3) {
            var Y3 = D2.Symbol || (D2.Symbol = L ? {} : C.Symbol || {});
            U3.charAt(0) == "_" || U3 in Y3 || j(Y3, U3, { value: F3.f(U3) });
          };
        }, function(d2, y2) {
          y2.f = Object.getOwnPropertySymbols;
        }, function(d2, y2) {
          d2.exports = function(x2, C, D2) {
            return Math.min(Math.max(x2, C), D2);
          };
        }, function(d2, y2, x2) {
          var C = x2(14), D2 = x2(15), L = x2(37), F3 = x2(6), j = x2(12), U3 = x2(55), Y3 = x2(28), Q = x2(61), nt = x2(2)("iterator"), dt = !([].keys && "next" in [].keys()), vt = function() {
            return this;
          };
          d2.exports = function(Ct, Pt, jt, Rt, le2, ne2, he2) {
            U3(jt, Pt, Rt);
            var _e, Me2, Pe2, Be2 = function(Cr) {
              if (!dt && Cr in Bn)
                return Bn[Cr];
              switch (Cr) {
                case "keys":
                case "values":
                  return function() {
                    return new jt(this, Cr);
                  };
              }
              return function() {
                return new jt(this, Cr);
              };
            }, Je2 = Pt + " Iterator", Ze2 = le2 == "values", Cn = false, Bn = Ct.prototype, mn = Bn[nt] || Bn["@@iterator"] || le2 && Bn[le2], Kr = mn || Be2(le2), Kn = le2 ? Ze2 ? Be2("entries") : Kr : void 0, ar = Pt == "Array" && Bn.entries || mn;
            if (ar && (Pe2 = Q(ar.call(new Ct()))) !== Object.prototype && Pe2.next && (Y3(Pe2, Je2, true), C || typeof Pe2[nt] == "function" || F3(Pe2, nt, vt)), Ze2 && mn && mn.name !== "values" && (Cn = true, Kr = function() {
              return mn.call(this);
            }), C && !he2 || !dt && !Cn && Bn[nt] || F3(Bn, nt, Kr), j[Pt] = Kr, j[Je2] = vt, le2)
              if (_e = { values: Ze2 ? Kr : Be2("values"), keys: ne2 ? Kr : Be2("keys"), entries: Kn }, he2)
                for (Me2 in _e)
                  Me2 in Bn || L(Bn, Me2, _e[Me2]);
              else
                D2(D2.P + D2.F * (dt || Cn), Pt, _e);
            return _e;
          };
        }, function(d2, y2, x2) {
          d2.exports = !x2(4) && !x2(8)(function() {
            return Object.defineProperty(x2(36)("div"), "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(d2, y2, x2) {
          var C = x2(11), D2 = x2(3).document, L = C(D2) && C(D2.createElement);
          d2.exports = function(F3) {
            return L ? D2.createElement(F3) : {};
          };
        }, function(d2, y2, x2) {
          d2.exports = x2(6);
        }, function(d2, y2, x2) {
          var C = x2(10), D2 = x2(56), L = x2(27), F3 = x2(25)("IE_PROTO"), j = function() {
          }, U3 = function() {
            var Y3, Q = x2(36)("iframe"), nt = L.length;
            for (Q.style.display = "none", x2(60).appendChild(Q), Q.src = "javascript:", (Y3 = Q.contentWindow.document).open(), Y3.write("<script>document.F=Object<\/script>"), Y3.close(), U3 = Y3.F; nt--; )
              delete U3.prototype[L[nt]];
            return U3();
          };
          d2.exports = Object.create || function(Y3, Q) {
            var nt;
            return Y3 !== null ? (j.prototype = C(Y3), nt = new j(), j.prototype = null, nt[F3] = Y3) : nt = U3(), Q === void 0 ? nt : D2(nt, Q);
          };
        }, function(d2, y2, x2) {
          var C = x2(5), D2 = x2(9), L = x2(57)(false), F3 = x2(25)("IE_PROTO");
          d2.exports = function(j, U3) {
            var Y3, Q = D2(j), nt = 0, dt = [];
            for (Y3 in Q)
              Y3 != F3 && C(Q, Y3) && dt.push(Y3);
            for (; U3.length > nt; )
              C(Q, Y3 = U3[nt++]) && (~L(dt, Y3) || dt.push(Y3));
            return dt;
          };
        }, function(d2, y2, x2) {
          var C = x2(24);
          d2.exports = Object("z").propertyIsEnumerable(0) ? Object : function(D2) {
            return C(D2) == "String" ? D2.split("") : Object(D2);
          };
        }, function(d2, y2, x2) {
          var C = x2(39), D2 = x2(27).concat("length", "prototype");
          y2.f = Object.getOwnPropertyNames || function(L) {
            return C(L, D2);
          };
        }, function(d2, y2, x2) {
          var C = x2(24), D2 = x2(2)("toStringTag"), L = C(function() {
            return arguments;
          }()) == "Arguments";
          d2.exports = function(F3) {
            var j, U3, Y3;
            return F3 === void 0 ? "Undefined" : F3 === null ? "Null" : typeof (U3 = function(Q, nt) {
              try {
                return Q[nt];
              } catch {
              }
            }(j = Object(F3), D2)) == "string" ? U3 : L ? C(j) : (Y3 = C(j)) == "Object" && typeof j.callee == "function" ? "Arguments" : Y3;
          };
        }, function(d2, y2) {
          var x2;
          x2 = function() {
            return this;
          }();
          try {
            x2 = x2 || new Function("return this")();
          } catch {
            typeof window == "object" && (x2 = window);
          }
          d2.exports = x2;
        }, function(d2, y2) {
          var x2 = /-?\d+(\.\d+)?%?/g;
          d2.exports = function(C) {
            return C.match(x2);
          };
        }, function(d2, y2, x2) {
          Object.defineProperty(y2, "__esModule", { value: true }), y2.getBase16Theme = y2.createStyling = y2.invertTheme = void 0;
          var C = vt(x2(49)), D2 = vt(x2(76)), L = vt(x2(81)), F3 = vt(x2(89)), j = vt(x2(93)), U3 = function(Me2) {
            if (Me2 && Me2.__esModule)
              return Me2;
            var Pe2 = {};
            if (Me2 != null)
              for (var Be2 in Me2)
                Object.prototype.hasOwnProperty.call(Me2, Be2) && (Pe2[Be2] = Me2[Be2]);
            return Pe2.default = Me2, Pe2;
          }(x2(94)), Y3 = vt(x2(132)), Q = vt(x2(133)), nt = vt(x2(138)), dt = x2(139);
          function vt(Me2) {
            return Me2 && Me2.__esModule ? Me2 : { default: Me2 };
          }
          var Ct = U3.default, Pt = (0, F3.default)(Ct), jt = (0, nt.default)(Q.default, dt.rgb2yuv, function(Me2) {
            var Pe2, Be2 = (0, L.default)(Me2, 3), Je2 = Be2[0], Ze2 = Be2[1], Cn = Be2[2];
            return [(Pe2 = Je2, Pe2 < 0.25 ? 1 : Pe2 < 0.5 ? 0.9 - Pe2 : 1.1 - Pe2), Ze2, Cn];
          }, dt.yuv2rgb, Y3.default), Rt = function(Me2) {
            return function(Pe2) {
              return { className: [Pe2.className, Me2.className].filter(Boolean).join(" "), style: (0, D2.default)({}, Pe2.style || {}, Me2.style || {}) };
            };
          }, le2 = function(Me2, Pe2) {
            var Be2 = (0, F3.default)(Pe2);
            for (var Je2 in Me2)
              Be2.indexOf(Je2) === -1 && Be2.push(Je2);
            return Be2.reduce(function(Ze2, Cn) {
              return Ze2[Cn] = function(Bn, mn) {
                if (Bn === void 0)
                  return mn;
                if (mn === void 0)
                  return Bn;
                var Kr = Bn === void 0 ? "undefined" : (0, C.default)(Bn), Kn = mn === void 0 ? "undefined" : (0, C.default)(mn);
                switch (Kr) {
                  case "string":
                    switch (Kn) {
                      case "string":
                        return [mn, Bn].filter(Boolean).join(" ");
                      case "object":
                        return Rt({ className: Bn, style: mn });
                      case "function":
                        return function(ar) {
                          for (var Cr = arguments.length, ui2 = Array(Cr > 1 ? Cr - 1 : 0), vi2 = 1; vi2 < Cr; vi2++)
                            ui2[vi2 - 1] = arguments[vi2];
                          return Rt({ className: Bn })(mn.apply(void 0, [ar].concat(ui2)));
                        };
                    }
                  case "object":
                    switch (Kn) {
                      case "string":
                        return Rt({ className: mn, style: Bn });
                      case "object":
                        return (0, D2.default)({}, mn, Bn);
                      case "function":
                        return function(ar) {
                          for (var Cr = arguments.length, ui2 = Array(Cr > 1 ? Cr - 1 : 0), vi2 = 1; vi2 < Cr; vi2++)
                            ui2[vi2 - 1] = arguments[vi2];
                          return Rt({ style: Bn })(mn.apply(void 0, [ar].concat(ui2)));
                        };
                    }
                  case "function":
                    switch (Kn) {
                      case "string":
                        return function(ar) {
                          for (var Cr = arguments.length, ui2 = Array(Cr > 1 ? Cr - 1 : 0), vi2 = 1; vi2 < Cr; vi2++)
                            ui2[vi2 - 1] = arguments[vi2];
                          return Bn.apply(void 0, [Rt(ar)({ className: mn })].concat(ui2));
                        };
                      case "object":
                        return function(ar) {
                          for (var Cr = arguments.length, ui2 = Array(Cr > 1 ? Cr - 1 : 0), vi2 = 1; vi2 < Cr; vi2++)
                            ui2[vi2 - 1] = arguments[vi2];
                          return Bn.apply(void 0, [Rt(ar)({ style: mn })].concat(ui2));
                        };
                      case "function":
                        return function(ar) {
                          for (var Cr = arguments.length, ui2 = Array(Cr > 1 ? Cr - 1 : 0), vi2 = 1; vi2 < Cr; vi2++)
                            ui2[vi2 - 1] = arguments[vi2];
                          return Bn.apply(void 0, [mn.apply(void 0, [ar].concat(ui2))].concat(ui2));
                        };
                    }
                }
              }(Me2[Cn], Pe2[Cn]), Ze2;
            }, {});
          }, ne2 = function(Me2, Pe2) {
            for (var Be2 = arguments.length, Je2 = Array(Be2 > 2 ? Be2 - 2 : 0), Ze2 = 2; Ze2 < Be2; Ze2++)
              Je2[Ze2 - 2] = arguments[Ze2];
            if (Pe2 === null)
              return Me2;
            Array.isArray(Pe2) || (Pe2 = [Pe2]);
            var Cn = Pe2.map(function(mn) {
              return Me2[mn];
            }).filter(Boolean), Bn = Cn.reduce(function(mn, Kr) {
              return typeof Kr == "string" ? mn.className = [mn.className, Kr].filter(Boolean).join(" ") : (Kr === void 0 ? "undefined" : (0, C.default)(Kr)) === "object" ? mn.style = (0, D2.default)({}, mn.style, Kr) : typeof Kr == "function" && (mn = (0, D2.default)({}, mn, Kr.apply(void 0, [mn].concat(Je2)))), mn;
            }, { className: "", style: {} });
            return Bn.className || delete Bn.className, (0, F3.default)(Bn.style).length === 0 && delete Bn.style, Bn;
          }, he2 = y2.invertTheme = function(Me2) {
            return (0, F3.default)(Me2).reduce(function(Pe2, Be2) {
              return Pe2[Be2] = /^base/.test(Be2) ? jt(Me2[Be2]) : Be2 === "scheme" ? Me2[Be2] + ":inverted" : Me2[Be2], Pe2;
            }, {});
          }, _e = (y2.createStyling = (0, j.default)(function(Me2) {
            for (var Pe2 = arguments.length, Be2 = Array(Pe2 > 3 ? Pe2 - 3 : 0), Je2 = 3; Je2 < Pe2; Je2++)
              Be2[Je2 - 3] = arguments[Je2];
            var Ze2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Cn = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Bn = Ze2.defaultBase16, mn = Bn === void 0 ? Ct : Bn, Kr = Ze2.base16Themes, Kn = Kr === void 0 ? null : Kr, ar = _e(Cn, Kn);
            ar && (Cn = (0, D2.default)({}, ar, Cn));
            var Cr = Pt.reduce(function(Ss, hl) {
              return Ss[hl] = Cn[hl] || mn[hl], Ss;
            }, {}), ui2 = (0, F3.default)(Cn).reduce(function(Ss, hl) {
              return Pt.indexOf(hl) === -1 && (Ss[hl] = Cn[hl]), Ss;
            }, {}), vi2 = Me2(Cr), ko = le2(ui2, vi2);
            return (0, j.default)(ne2, 2).apply(void 0, [ko].concat(Be2));
          }, 3), y2.getBase16Theme = function(Me2, Pe2) {
            if (Me2 && Me2.extend && (Me2 = Me2.extend), typeof Me2 == "string") {
              var Be2 = Me2.split(":"), Je2 = (0, L.default)(Be2, 2), Ze2 = Je2[0], Cn = Je2[1];
              Me2 = (Pe2 || {})[Ze2] || U3[Ze2], Cn === "inverted" && (Me2 = he2(Me2));
            }
            return Me2 && Me2.hasOwnProperty("base00") ? Me2 : void 0;
          });
        }, function(d2, y2, x2) {
          var C, D2 = typeof Reflect == "object" ? Reflect : null, L = D2 && typeof D2.apply == "function" ? D2.apply : function(Rt, le2, ne2) {
            return Function.prototype.apply.call(Rt, le2, ne2);
          };
          C = D2 && typeof D2.ownKeys == "function" ? D2.ownKeys : Object.getOwnPropertySymbols ? function(Rt) {
            return Object.getOwnPropertyNames(Rt).concat(Object.getOwnPropertySymbols(Rt));
          } : function(Rt) {
            return Object.getOwnPropertyNames(Rt);
          };
          var F3 = Number.isNaN || function(Rt) {
            return Rt != Rt;
          };
          function j() {
            j.init.call(this);
          }
          d2.exports = j, d2.exports.once = function(Rt, le2) {
            return new Promise(function(ne2, he2) {
              function _e() {
                Me2 !== void 0 && Rt.removeListener("error", Me2), ne2([].slice.call(arguments));
              }
              var Me2;
              le2 !== "error" && (Me2 = function(Pe2) {
                Rt.removeListener(le2, _e), he2(Pe2);
              }, Rt.once("error", Me2)), Rt.once(le2, _e);
            });
          }, j.EventEmitter = j, j.prototype._events = void 0, j.prototype._eventsCount = 0, j.prototype._maxListeners = void 0;
          var U3 = 10;
          function Y3(Rt) {
            if (typeof Rt != "function")
              throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof Rt);
          }
          function Q(Rt) {
            return Rt._maxListeners === void 0 ? j.defaultMaxListeners : Rt._maxListeners;
          }
          function nt(Rt, le2, ne2, he2) {
            var _e, Me2, Pe2, Be2;
            if (Y3(ne2), (Me2 = Rt._events) === void 0 ? (Me2 = Rt._events = /* @__PURE__ */ Object.create(null), Rt._eventsCount = 0) : (Me2.newListener !== void 0 && (Rt.emit("newListener", le2, ne2.listener ? ne2.listener : ne2), Me2 = Rt._events), Pe2 = Me2[le2]), Pe2 === void 0)
              Pe2 = Me2[le2] = ne2, ++Rt._eventsCount;
            else if (typeof Pe2 == "function" ? Pe2 = Me2[le2] = he2 ? [ne2, Pe2] : [Pe2, ne2] : he2 ? Pe2.unshift(ne2) : Pe2.push(ne2), (_e = Q(Rt)) > 0 && Pe2.length > _e && !Pe2.warned) {
              Pe2.warned = true;
              var Je2 = new Error("Possible EventEmitter memory leak detected. " + Pe2.length + " " + String(le2) + " listeners added. Use emitter.setMaxListeners() to increase limit");
              Je2.name = "MaxListenersExceededWarning", Je2.emitter = Rt, Je2.type = le2, Je2.count = Pe2.length, Be2 = Je2, console && console.warn && console.warn(Be2);
            }
            return Rt;
          }
          function dt() {
            if (!this.fired)
              return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
          }
          function vt(Rt, le2, ne2) {
            var he2 = { fired: false, wrapFn: void 0, target: Rt, type: le2, listener: ne2 }, _e = dt.bind(he2);
            return _e.listener = ne2, he2.wrapFn = _e, _e;
          }
          function Ct(Rt, le2, ne2) {
            var he2 = Rt._events;
            if (he2 === void 0)
              return [];
            var _e = he2[le2];
            return _e === void 0 ? [] : typeof _e == "function" ? ne2 ? [_e.listener || _e] : [_e] : ne2 ? function(Me2) {
              for (var Pe2 = new Array(Me2.length), Be2 = 0; Be2 < Pe2.length; ++Be2)
                Pe2[Be2] = Me2[Be2].listener || Me2[Be2];
              return Pe2;
            }(_e) : jt(_e, _e.length);
          }
          function Pt(Rt) {
            var le2 = this._events;
            if (le2 !== void 0) {
              var ne2 = le2[Rt];
              if (typeof ne2 == "function")
                return 1;
              if (ne2 !== void 0)
                return ne2.length;
            }
            return 0;
          }
          function jt(Rt, le2) {
            for (var ne2 = new Array(le2), he2 = 0; he2 < le2; ++he2)
              ne2[he2] = Rt[he2];
            return ne2;
          }
          Object.defineProperty(j, "defaultMaxListeners", { enumerable: true, get: function() {
            return U3;
          }, set: function(Rt) {
            if (typeof Rt != "number" || Rt < 0 || F3(Rt))
              throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + Rt + ".");
            U3 = Rt;
          } }), j.init = function() {
            this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
          }, j.prototype.setMaxListeners = function(Rt) {
            if (typeof Rt != "number" || Rt < 0 || F3(Rt))
              throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + Rt + ".");
            return this._maxListeners = Rt, this;
          }, j.prototype.getMaxListeners = function() {
            return Q(this);
          }, j.prototype.emit = function(Rt) {
            for (var le2 = [], ne2 = 1; ne2 < arguments.length; ne2++)
              le2.push(arguments[ne2]);
            var he2 = Rt === "error", _e = this._events;
            if (_e !== void 0)
              he2 = he2 && _e.error === void 0;
            else if (!he2)
              return false;
            if (he2) {
              var Me2;
              if (le2.length > 0 && (Me2 = le2[0]), Me2 instanceof Error)
                throw Me2;
              var Pe2 = new Error("Unhandled error." + (Me2 ? " (" + Me2.message + ")" : ""));
              throw Pe2.context = Me2, Pe2;
            }
            var Be2 = _e[Rt];
            if (Be2 === void 0)
              return false;
            if (typeof Be2 == "function")
              L(Be2, this, le2);
            else {
              var Je2 = Be2.length, Ze2 = jt(Be2, Je2);
              for (ne2 = 0; ne2 < Je2; ++ne2)
                L(Ze2[ne2], this, le2);
            }
            return true;
          }, j.prototype.addListener = function(Rt, le2) {
            return nt(this, Rt, le2, false);
          }, j.prototype.on = j.prototype.addListener, j.prototype.prependListener = function(Rt, le2) {
            return nt(this, Rt, le2, true);
          }, j.prototype.once = function(Rt, le2) {
            return Y3(le2), this.on(Rt, vt(this, Rt, le2)), this;
          }, j.prototype.prependOnceListener = function(Rt, le2) {
            return Y3(le2), this.prependListener(Rt, vt(this, Rt, le2)), this;
          }, j.prototype.removeListener = function(Rt, le2) {
            var ne2, he2, _e, Me2, Pe2;
            if (Y3(le2), (he2 = this._events) === void 0)
              return this;
            if ((ne2 = he2[Rt]) === void 0)
              return this;
            if (ne2 === le2 || ne2.listener === le2)
              --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete he2[Rt], he2.removeListener && this.emit("removeListener", Rt, ne2.listener || le2));
            else if (typeof ne2 != "function") {
              for (_e = -1, Me2 = ne2.length - 1; Me2 >= 0; Me2--)
                if (ne2[Me2] === le2 || ne2[Me2].listener === le2) {
                  Pe2 = ne2[Me2].listener, _e = Me2;
                  break;
                }
              if (_e < 0)
                return this;
              _e === 0 ? ne2.shift() : function(Be2, Je2) {
                for (; Je2 + 1 < Be2.length; Je2++)
                  Be2[Je2] = Be2[Je2 + 1];
                Be2.pop();
              }(ne2, _e), ne2.length === 1 && (he2[Rt] = ne2[0]), he2.removeListener !== void 0 && this.emit("removeListener", Rt, Pe2 || le2);
            }
            return this;
          }, j.prototype.off = j.prototype.removeListener, j.prototype.removeAllListeners = function(Rt) {
            var le2, ne2, he2;
            if ((ne2 = this._events) === void 0)
              return this;
            if (ne2.removeListener === void 0)
              return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : ne2[Rt] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete ne2[Rt]), this;
            if (arguments.length === 0) {
              var _e, Me2 = Object.keys(ne2);
              for (he2 = 0; he2 < Me2.length; ++he2)
                (_e = Me2[he2]) !== "removeListener" && this.removeAllListeners(_e);
              return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
            }
            if (typeof (le2 = ne2[Rt]) == "function")
              this.removeListener(Rt, le2);
            else if (le2 !== void 0)
              for (he2 = le2.length - 1; he2 >= 0; he2--)
                this.removeListener(Rt, le2[he2]);
            return this;
          }, j.prototype.listeners = function(Rt) {
            return Ct(this, Rt, true);
          }, j.prototype.rawListeners = function(Rt) {
            return Ct(this, Rt, false);
          }, j.listenerCount = function(Rt, le2) {
            return typeof Rt.listenerCount == "function" ? Rt.listenerCount(le2) : Pt.call(Rt, le2);
          }, j.prototype.listenerCount = Pt, j.prototype.eventNames = function() {
            return this._eventsCount > 0 ? C(this._events) : [];
          };
        }, function(d2, y2, x2) {
          d2.exports.Dispatcher = x2(140);
        }, function(d2, y2, x2) {
          d2.exports = x2(142);
        }, function(d2, y2, x2) {
          y2.__esModule = true;
          var C = F3(x2(50)), D2 = F3(x2(65)), L = typeof D2.default == "function" && typeof C.default == "symbol" ? function(j) {
            return typeof j;
          } : function(j) {
            return j && typeof D2.default == "function" && j.constructor === D2.default && j !== D2.default.prototype ? "symbol" : typeof j;
          };
          function F3(j) {
            return j && j.__esModule ? j : { default: j };
          }
          y2.default = typeof D2.default == "function" && L(C.default) === "symbol" ? function(j) {
            return j === void 0 ? "undefined" : L(j);
          } : function(j) {
            return j && typeof D2.default == "function" && j.constructor === D2.default && j !== D2.default.prototype ? "symbol" : j === void 0 ? "undefined" : L(j);
          };
        }, function(d2, y2, x2) {
          d2.exports = { default: x2(51), __esModule: true };
        }, function(d2, y2, x2) {
          x2(20), x2(29), d2.exports = x2(30).f("iterator");
        }, function(d2, y2, x2) {
          var C = x2(21), D2 = x2(22);
          d2.exports = function(L) {
            return function(F3, j) {
              var U3, Y3, Q = String(D2(F3)), nt = C(j), dt = Q.length;
              return nt < 0 || nt >= dt ? L ? "" : void 0 : (U3 = Q.charCodeAt(nt)) < 55296 || U3 > 56319 || nt + 1 === dt || (Y3 = Q.charCodeAt(nt + 1)) < 56320 || Y3 > 57343 ? L ? Q.charAt(nt) : U3 : L ? Q.slice(nt, nt + 2) : Y3 - 56320 + (U3 - 55296 << 10) + 65536;
            };
          };
        }, function(d2, y2, x2) {
          var C = x2(54);
          d2.exports = function(D2, L, F3) {
            if (C(D2), L === void 0)
              return D2;
            switch (F3) {
              case 1:
                return function(j) {
                  return D2.call(L, j);
                };
              case 2:
                return function(j, U3) {
                  return D2.call(L, j, U3);
                };
              case 3:
                return function(j, U3, Y3) {
                  return D2.call(L, j, U3, Y3);
                };
            }
            return function() {
              return D2.apply(L, arguments);
            };
          };
        }, function(d2, y2) {
          d2.exports = function(x2) {
            if (typeof x2 != "function")
              throw TypeError(x2 + " is not a function!");
            return x2;
          };
        }, function(d2, y2, x2) {
          var C = x2(38), D2 = x2(16), L = x2(28), F3 = {};
          x2(6)(F3, x2(2)("iterator"), function() {
            return this;
          }), d2.exports = function(j, U3, Y3) {
            j.prototype = C(F3, { next: D2(1, Y3) }), L(j, U3 + " Iterator");
          };
        }, function(d2, y2, x2) {
          var C = x2(7), D2 = x2(10), L = x2(13);
          d2.exports = x2(4) ? Object.defineProperties : function(F3, j) {
            D2(F3);
            for (var U3, Y3 = L(j), Q = Y3.length, nt = 0; Q > nt; )
              C.f(F3, U3 = Y3[nt++], j[U3]);
            return F3;
          };
        }, function(d2, y2, x2) {
          var C = x2(9), D2 = x2(58), L = x2(59);
          d2.exports = function(F3) {
            return function(j, U3, Y3) {
              var Q, nt = C(j), dt = D2(nt.length), vt = L(Y3, dt);
              if (F3 && U3 != U3) {
                for (; dt > vt; )
                  if ((Q = nt[vt++]) != Q)
                    return true;
              } else
                for (; dt > vt; vt++)
                  if ((F3 || vt in nt) && nt[vt] === U3)
                    return F3 || vt || 0;
              return !F3 && -1;
            };
          };
        }, function(d2, y2, x2) {
          var C = x2(21), D2 = Math.min;
          d2.exports = function(L) {
            return L > 0 ? D2(C(L), 9007199254740991) : 0;
          };
        }, function(d2, y2, x2) {
          var C = x2(21), D2 = Math.max, L = Math.min;
          d2.exports = function(F3, j) {
            return (F3 = C(F3)) < 0 ? D2(F3 + j, 0) : L(F3, j);
          };
        }, function(d2, y2, x2) {
          var C = x2(3).document;
          d2.exports = C && C.documentElement;
        }, function(d2, y2, x2) {
          var C = x2(5), D2 = x2(18), L = x2(25)("IE_PROTO"), F3 = Object.prototype;
          d2.exports = Object.getPrototypeOf || function(j) {
            return j = D2(j), C(j, L) ? j[L] : typeof j.constructor == "function" && j instanceof j.constructor ? j.constructor.prototype : j instanceof Object ? F3 : null;
          };
        }, function(d2, y2, x2) {
          var C = x2(63), D2 = x2(64), L = x2(12), F3 = x2(9);
          d2.exports = x2(34)(Array, "Array", function(j, U3) {
            this._t = F3(j), this._i = 0, this._k = U3;
          }, function() {
            var j = this._t, U3 = this._k, Y3 = this._i++;
            return !j || Y3 >= j.length ? (this._t = void 0, D2(1)) : D2(0, U3 == "keys" ? Y3 : U3 == "values" ? j[Y3] : [Y3, j[Y3]]);
          }, "values"), L.Arguments = L.Array, C("keys"), C("values"), C("entries");
        }, function(d2, y2) {
          d2.exports = function() {
          };
        }, function(d2, y2) {
          d2.exports = function(x2, C) {
            return { value: C, done: !!x2 };
          };
        }, function(d2, y2, x2) {
          d2.exports = { default: x2(66), __esModule: true };
        }, function(d2, y2, x2) {
          x2(67), x2(73), x2(74), x2(75), d2.exports = x2(1).Symbol;
        }, function(d2, y2, x2) {
          var C = x2(3), D2 = x2(5), L = x2(4), F3 = x2(15), j = x2(37), U3 = x2(68).KEY, Y3 = x2(8), Q = x2(26), nt = x2(28), dt = x2(17), vt = x2(2), Ct = x2(30), Pt = x2(31), jt = x2(69), Rt = x2(70), le2 = x2(10), ne2 = x2(11), he2 = x2(18), _e = x2(9), Me2 = x2(23), Pe2 = x2(16), Be2 = x2(38), Je2 = x2(71), Ze2 = x2(72), Cn = x2(32), Bn = x2(7), mn = x2(13), Kr = Ze2.f, Kn = Bn.f, ar = Je2.f, Cr = C.Symbol, ui2 = C.JSON, vi2 = ui2 && ui2.stringify, ko = vt("_hidden"), Ss = vt("toPrimitive"), hl = {}.propertyIsEnumerable, Qs = Q("symbol-registry"), Js = Q("symbols"), rs = Q("op-symbols"), Gs = Object.prototype, al = typeof Cr == "function" && !!Cn.f, _s = C.QObject, Fl = !_s || !_s.prototype || !_s.prototype.findChild, Ih2 = L && Y3(function() {
            return Be2(Kn({}, "a", { get: function() {
              return Kn(this, "a", { value: 7 }).a;
            } })).a != 7;
          }) ? function(Ji2, mo, zs) {
            var Jl = Kr(Gs, mo);
            Jl && delete Gs[mo], Kn(Ji2, mo, zs), Jl && Ji2 !== Gs && Kn(Gs, mo, Jl);
          } : Kn, lu = function(Ji2) {
            var mo = Js[Ji2] = Be2(Cr.prototype);
            return mo._k = Ji2, mo;
          }, ah2 = al && typeof Cr.iterator == "symbol" ? function(Ji2) {
            return typeof Ji2 == "symbol";
          } : function(Ji2) {
            return Ji2 instanceof Cr;
          }, Uh2 = function(Ji2, mo, zs) {
            return Ji2 === Gs && Uh2(rs, mo, zs), le2(Ji2), mo = Me2(mo, true), le2(zs), D2(Js, mo) ? (zs.enumerable ? (D2(Ji2, ko) && Ji2[ko][mo] && (Ji2[ko][mo] = false), zs = Be2(zs, { enumerable: Pe2(0, false) })) : (D2(Ji2, ko) || Kn(Ji2, ko, Pe2(1, {})), Ji2[ko][mo] = true), Ih2(Ji2, mo, zs)) : Kn(Ji2, mo, zs);
          }, Np = function(Ji2, mo) {
            le2(Ji2);
            for (var zs, Jl = jt(mo = _e(mo)), gf2 = 0, vf2 = Jl.length; vf2 > gf2; )
              Uh2(Ji2, zs = Jl[gf2++], mo[zs]);
            return Ji2;
          }, Zy = function(Ji2) {
            var mo = hl.call(this, Ji2 = Me2(Ji2, true));
            return !(this === Gs && D2(Js, Ji2) && !D2(rs, Ji2)) && (!(mo || !D2(this, Ji2) || !D2(Js, Ji2) || D2(this, ko) && this[ko][Ji2]) || mo);
          }, Nd2 = function(Ji2, mo) {
            if (Ji2 = _e(Ji2), mo = Me2(mo, true), Ji2 !== Gs || !D2(Js, mo) || D2(rs, mo)) {
              var zs = Kr(Ji2, mo);
              return !zs || !D2(Js, mo) || D2(Ji2, ko) && Ji2[ko][mo] || (zs.enumerable = true), zs;
            }
          }, w1 = function(Ji2) {
            for (var mo, zs = ar(_e(Ji2)), Jl = [], gf2 = 0; zs.length > gf2; )
              D2(Js, mo = zs[gf2++]) || mo == ko || mo == U3 || Jl.push(mo);
            return Jl;
          }, Zd2 = function(Ji2) {
            for (var mo, zs = Ji2 === Gs, Jl = ar(zs ? rs : _e(Ji2)), gf2 = [], vf2 = 0; Jl.length > vf2; )
              !D2(Js, mo = Jl[vf2++]) || zs && !D2(Gs, mo) || gf2.push(Js[mo]);
            return gf2;
          };
          al || (j((Cr = function() {
            if (this instanceof Cr)
              throw TypeError("Symbol is not a constructor!");
            var Ji2 = dt(arguments.length > 0 ? arguments[0] : void 0), mo = function(zs) {
              this === Gs && mo.call(rs, zs), D2(this, ko) && D2(this[ko], Ji2) && (this[ko][Ji2] = false), Ih2(this, Ji2, Pe2(1, zs));
            };
            return L && Fl && Ih2(Gs, Ji2, { configurable: true, set: mo }), lu(Ji2);
          }).prototype, "toString", function() {
            return this._k;
          }), Ze2.f = Nd2, Bn.f = Uh2, x2(41).f = Je2.f = w1, x2(19).f = Zy, Cn.f = Zd2, L && !x2(14) && j(Gs, "propertyIsEnumerable", Zy, true), Ct.f = function(Ji2) {
            return lu(vt(Ji2));
          }), F3(F3.G + F3.W + F3.F * !al, { Symbol: Cr });
          for (var Lv = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), hv = 0; Lv.length > hv; )
            vt(Lv[hv++]);
          for (var VA = mn(vt.store), po = 0; VA.length > po; )
            Pt(VA[po++]);
          F3(F3.S + F3.F * !al, "Symbol", { for: function(Ji2) {
            return D2(Qs, Ji2 += "") ? Qs[Ji2] : Qs[Ji2] = Cr(Ji2);
          }, keyFor: function(Ji2) {
            if (!ah2(Ji2))
              throw TypeError(Ji2 + " is not a symbol!");
            for (var mo in Qs)
              if (Qs[mo] === Ji2)
                return mo;
          }, useSetter: function() {
            Fl = true;
          }, useSimple: function() {
            Fl = false;
          } }), F3(F3.S + F3.F * !al, "Object", { create: function(Ji2, mo) {
            return mo === void 0 ? Be2(Ji2) : Np(Be2(Ji2), mo);
          }, defineProperty: Uh2, defineProperties: Np, getOwnPropertyDescriptor: Nd2, getOwnPropertyNames: w1, getOwnPropertySymbols: Zd2 });
          var ia2 = Y3(function() {
            Cn.f(1);
          });
          F3(F3.S + F3.F * ia2, "Object", { getOwnPropertySymbols: function(Ji2) {
            return Cn.f(he2(Ji2));
          } }), ui2 && F3(F3.S + F3.F * (!al || Y3(function() {
            var Ji2 = Cr();
            return vi2([Ji2]) != "[null]" || vi2({ a: Ji2 }) != "{}" || vi2(Object(Ji2)) != "{}";
          })), "JSON", { stringify: function(Ji2) {
            for (var mo, zs, Jl = [Ji2], gf2 = 1; arguments.length > gf2; )
              Jl.push(arguments[gf2++]);
            if (zs = mo = Jl[1], (ne2(mo) || Ji2 !== void 0) && !ah2(Ji2))
              return Rt(mo) || (mo = function(vf2, Xp) {
                if (typeof zs == "function" && (Xp = zs.call(this, vf2, Xp)), !ah2(Xp))
                  return Xp;
              }), Jl[1] = mo, vi2.apply(ui2, Jl);
          } }), Cr.prototype[Ss] || x2(6)(Cr.prototype, Ss, Cr.prototype.valueOf), nt(Cr, "Symbol"), nt(Math, "Math", true), nt(C.JSON, "JSON", true);
        }, function(d2, y2, x2) {
          var C = x2(17)("meta"), D2 = x2(11), L = x2(5), F3 = x2(7).f, j = 0, U3 = Object.isExtensible || function() {
            return true;
          }, Y3 = !x2(8)(function() {
            return U3(Object.preventExtensions({}));
          }), Q = function(dt) {
            F3(dt, C, { value: { i: "O" + ++j, w: {} } });
          }, nt = d2.exports = { KEY: C, NEED: false, fastKey: function(dt, vt) {
            if (!D2(dt))
              return typeof dt == "symbol" ? dt : (typeof dt == "string" ? "S" : "P") + dt;
            if (!L(dt, C)) {
              if (!U3(dt))
                return "F";
              if (!vt)
                return "E";
              Q(dt);
            }
            return dt[C].i;
          }, getWeak: function(dt, vt) {
            if (!L(dt, C)) {
              if (!U3(dt))
                return true;
              if (!vt)
                return false;
              Q(dt);
            }
            return dt[C].w;
          }, onFreeze: function(dt) {
            return Y3 && nt.NEED && U3(dt) && !L(dt, C) && Q(dt), dt;
          } };
        }, function(d2, y2, x2) {
          var C = x2(13), D2 = x2(32), L = x2(19);
          d2.exports = function(F3) {
            var j = C(F3), U3 = D2.f;
            if (U3)
              for (var Y3, Q = U3(F3), nt = L.f, dt = 0; Q.length > dt; )
                nt.call(F3, Y3 = Q[dt++]) && j.push(Y3);
            return j;
          };
        }, function(d2, y2, x2) {
          var C = x2(24);
          d2.exports = Array.isArray || function(D2) {
            return C(D2) == "Array";
          };
        }, function(d2, y2, x2) {
          var C = x2(9), D2 = x2(41).f, L = {}.toString, F3 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
          d2.exports.f = function(j) {
            return F3 && L.call(j) == "[object Window]" ? function(U3) {
              try {
                return D2(U3);
              } catch {
                return F3.slice();
              }
            }(j) : D2(C(j));
          };
        }, function(d2, y2, x2) {
          var C = x2(19), D2 = x2(16), L = x2(9), F3 = x2(23), j = x2(5), U3 = x2(35), Y3 = Object.getOwnPropertyDescriptor;
          y2.f = x2(4) ? Y3 : function(Q, nt) {
            if (Q = L(Q), nt = F3(nt, true), U3)
              try {
                return Y3(Q, nt);
              } catch {
              }
            if (j(Q, nt))
              return D2(!C.f.call(Q, nt), Q[nt]);
          };
        }, function(d2, y2) {
        }, function(d2, y2, x2) {
          x2(31)("asyncIterator");
        }, function(d2, y2, x2) {
          x2(31)("observable");
        }, function(d2, y2, x2) {
          y2.__esModule = true;
          var C, D2 = x2(77), L = (C = D2) && C.__esModule ? C : { default: C };
          y2.default = L.default || function(F3) {
            for (var j = 1; j < arguments.length; j++) {
              var U3 = arguments[j];
              for (var Y3 in U3)
                Object.prototype.hasOwnProperty.call(U3, Y3) && (F3[Y3] = U3[Y3]);
            }
            return F3;
          };
        }, function(d2, y2, x2) {
          d2.exports = { default: x2(78), __esModule: true };
        }, function(d2, y2, x2) {
          x2(79), d2.exports = x2(1).Object.assign;
        }, function(d2, y2, x2) {
          var C = x2(15);
          C(C.S + C.F, "Object", { assign: x2(80) });
        }, function(d2, y2, x2) {
          var C = x2(4), D2 = x2(13), L = x2(32), F3 = x2(19), j = x2(18), U3 = x2(40), Y3 = Object.assign;
          d2.exports = !Y3 || x2(8)(function() {
            var Q = {}, nt = {}, dt = Symbol(), vt = "abcdefghijklmnopqrst";
            return Q[dt] = 7, vt.split("").forEach(function(Ct) {
              nt[Ct] = Ct;
            }), Y3({}, Q)[dt] != 7 || Object.keys(Y3({}, nt)).join("") != vt;
          }) ? function(Q, nt) {
            for (var dt = j(Q), vt = arguments.length, Ct = 1, Pt = L.f, jt = F3.f; vt > Ct; )
              for (var Rt, le2 = U3(arguments[Ct++]), ne2 = Pt ? D2(le2).concat(Pt(le2)) : D2(le2), he2 = ne2.length, _e = 0; he2 > _e; )
                Rt = ne2[_e++], C && !jt.call(le2, Rt) || (dt[Rt] = le2[Rt]);
            return dt;
          } : Y3;
        }, function(d2, y2, x2) {
          y2.__esModule = true;
          var C = L(x2(82)), D2 = L(x2(85));
          function L(F3) {
            return F3 && F3.__esModule ? F3 : { default: F3 };
          }
          y2.default = function(F3, j) {
            if (Array.isArray(F3))
              return F3;
            if ((0, C.default)(Object(F3)))
              return function(U3, Y3) {
                var Q = [], nt = true, dt = false, vt = void 0;
                try {
                  for (var Ct, Pt = (0, D2.default)(U3); !(nt = (Ct = Pt.next()).done) && (Q.push(Ct.value), !Y3 || Q.length !== Y3); nt = true)
                    ;
                } catch (jt) {
                  dt = true, vt = jt;
                } finally {
                  try {
                    !nt && Pt.return && Pt.return();
                  } finally {
                    if (dt)
                      throw vt;
                  }
                }
                return Q;
              }(F3, j);
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          };
        }, function(d2, y2, x2) {
          d2.exports = { default: x2(83), __esModule: true };
        }, function(d2, y2, x2) {
          x2(29), x2(20), d2.exports = x2(84);
        }, function(d2, y2, x2) {
          var C = x2(42), D2 = x2(2)("iterator"), L = x2(12);
          d2.exports = x2(1).isIterable = function(F3) {
            var j = Object(F3);
            return j[D2] !== void 0 || "@@iterator" in j || L.hasOwnProperty(C(j));
          };
        }, function(d2, y2, x2) {
          d2.exports = { default: x2(86), __esModule: true };
        }, function(d2, y2, x2) {
          x2(29), x2(20), d2.exports = x2(87);
        }, function(d2, y2, x2) {
          var C = x2(10), D2 = x2(88);
          d2.exports = x2(1).getIterator = function(L) {
            var F3 = D2(L);
            if (typeof F3 != "function")
              throw TypeError(L + " is not iterable!");
            return C(F3.call(L));
          };
        }, function(d2, y2, x2) {
          var C = x2(42), D2 = x2(2)("iterator"), L = x2(12);
          d2.exports = x2(1).getIteratorMethod = function(F3) {
            if (F3 != null)
              return F3[D2] || F3["@@iterator"] || L[C(F3)];
          };
        }, function(d2, y2, x2) {
          d2.exports = { default: x2(90), __esModule: true };
        }, function(d2, y2, x2) {
          x2(91), d2.exports = x2(1).Object.keys;
        }, function(d2, y2, x2) {
          var C = x2(18), D2 = x2(13);
          x2(92)("keys", function() {
            return function(L) {
              return D2(C(L));
            };
          });
        }, function(d2, y2, x2) {
          var C = x2(15), D2 = x2(1), L = x2(8);
          d2.exports = function(F3, j) {
            var U3 = (D2.Object || {})[F3] || Object[F3], Y3 = {};
            Y3[F3] = j(U3), C(C.S + C.F * L(function() {
              U3(1);
            }), "Object", Y3);
          };
        }, function(d2, y2, x2) {
          (function(C) {
            var D2 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], L = /^\s+|\s+$/g, F3 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, j = /\{\n\/\* \[wrapped with (.+)\] \*/, U3 = /,? & /, Y3 = /^[-+]0x[0-9a-f]+$/i, Q = /^0b[01]+$/i, nt = /^\[object .+?Constructor\]$/, dt = /^0o[0-7]+$/i, vt = /^(?:0|[1-9]\d*)$/, Ct = parseInt, Pt = typeof C == "object" && C && C.Object === Object && C, jt = typeof self == "object" && self && self.Object === Object && self, Rt = Pt || jt || Function("return this")();
            function le2(po, ia2, Ji2) {
              switch (Ji2.length) {
                case 0:
                  return po.call(ia2);
                case 1:
                  return po.call(ia2, Ji2[0]);
                case 2:
                  return po.call(ia2, Ji2[0], Ji2[1]);
                case 3:
                  return po.call(ia2, Ji2[0], Ji2[1], Ji2[2]);
              }
              return po.apply(ia2, Ji2);
            }
            function ne2(po, ia2) {
              return !!(po && po.length) && function(Ji2, mo, zs) {
                if (mo != mo)
                  return function(vf2, Xp, pv, vg2) {
                    for (var Z0 = vf2.length, yg2 = pv + (vg2 ? 1 : -1); vg2 ? yg2-- : ++yg2 < Z0; )
                      if (Xp(vf2[yg2], yg2, vf2))
                        return yg2;
                    return -1;
                  }(Ji2, he2, zs);
                for (var Jl = zs - 1, gf2 = Ji2.length; ++Jl < gf2; )
                  if (Ji2[Jl] === mo)
                    return Jl;
                return -1;
              }(po, ia2, 0) > -1;
            }
            function he2(po) {
              return po != po;
            }
            function _e(po, ia2) {
              for (var Ji2 = po.length, mo = 0; Ji2--; )
                po[Ji2] === ia2 && mo++;
              return mo;
            }
            function Me2(po, ia2) {
              for (var Ji2 = -1, mo = po.length, zs = 0, Jl = []; ++Ji2 < mo; ) {
                var gf2 = po[Ji2];
                gf2 !== ia2 && gf2 !== "__lodash_placeholder__" || (po[Ji2] = "__lodash_placeholder__", Jl[zs++] = Ji2);
              }
              return Jl;
            }
            var Pe2, Be2, Je2, Ze2 = Function.prototype, Cn = Object.prototype, Bn = Rt["__core-js_shared__"], mn = (Pe2 = /[^.]+$/.exec(Bn && Bn.keys && Bn.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Pe2 : "", Kr = Ze2.toString, Kn = Cn.hasOwnProperty, ar = Cn.toString, Cr = RegExp("^" + Kr.call(Kn).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ui2 = Object.create, vi2 = Math.max, ko = Math.min, Ss = (Be2 = lu(Object, "defineProperty"), (Je2 = lu.name) && Je2.length > 2 ? Be2 : void 0);
            function hl(po) {
              return Lv(po) ? ui2(po) : {};
            }
            function Qs(po) {
              return !(!Lv(po) || function(ia2) {
                return !!mn && mn in ia2;
              }(po)) && (function(ia2) {
                var Ji2 = Lv(ia2) ? ar.call(ia2) : "";
                return Ji2 == "[object Function]" || Ji2 == "[object GeneratorFunction]";
              }(po) || function(ia2) {
                var Ji2 = false;
                if (ia2 != null && typeof ia2.toString != "function")
                  try {
                    Ji2 = !!(ia2 + "");
                  } catch {
                  }
                return Ji2;
              }(po) ? Cr : nt).test(function(ia2) {
                if (ia2 != null) {
                  try {
                    return Kr.call(ia2);
                  } catch {
                  }
                  try {
                    return ia2 + "";
                  } catch {
                  }
                }
                return "";
              }(po));
            }
            function Js(po, ia2, Ji2, mo) {
              for (var zs = -1, Jl = po.length, gf2 = Ji2.length, vf2 = -1, Xp = ia2.length, pv = vi2(Jl - gf2, 0), vg2 = Array(Xp + pv), Z0 = !mo; ++vf2 < Xp; )
                vg2[vf2] = ia2[vf2];
              for (; ++zs < gf2; )
                (Z0 || zs < Jl) && (vg2[Ji2[zs]] = po[zs]);
              for (; pv--; )
                vg2[vf2++] = po[zs++];
              return vg2;
            }
            function rs(po, ia2, Ji2, mo) {
              for (var zs = -1, Jl = po.length, gf2 = -1, vf2 = Ji2.length, Xp = -1, pv = ia2.length, vg2 = vi2(Jl - vf2, 0), Z0 = Array(vg2 + pv), yg2 = !mo; ++zs < vg2; )
                Z0[zs] = po[zs];
              for (var Cb2 = zs; ++Xp < pv; )
                Z0[Cb2 + Xp] = ia2[Xp];
              for (; ++gf2 < vf2; )
                (yg2 || zs < Jl) && (Z0[Cb2 + Ji2[gf2]] = po[zs++]);
              return Z0;
            }
            function Gs(po) {
              return function() {
                var ia2 = arguments;
                switch (ia2.length) {
                  case 0:
                    return new po();
                  case 1:
                    return new po(ia2[0]);
                  case 2:
                    return new po(ia2[0], ia2[1]);
                  case 3:
                    return new po(ia2[0], ia2[1], ia2[2]);
                  case 4:
                    return new po(ia2[0], ia2[1], ia2[2], ia2[3]);
                  case 5:
                    return new po(ia2[0], ia2[1], ia2[2], ia2[3], ia2[4]);
                  case 6:
                    return new po(ia2[0], ia2[1], ia2[2], ia2[3], ia2[4], ia2[5]);
                  case 7:
                    return new po(ia2[0], ia2[1], ia2[2], ia2[3], ia2[4], ia2[5], ia2[6]);
                }
                var Ji2 = hl(po.prototype), mo = po.apply(Ji2, ia2);
                return Lv(mo) ? mo : Ji2;
              };
            }
            function al(po, ia2, Ji2, mo, zs, Jl, gf2, vf2, Xp, pv) {
              var vg2 = 128 & ia2, Z0 = 1 & ia2, yg2 = 2 & ia2, Cb2 = 24 & ia2, z_ = 512 & ia2, tM = yg2 ? void 0 : Gs(po);
              return function j_() {
                for (var i0 = arguments.length, qh2 = Array(i0), wy = i0; wy--; )
                  qh2[wy] = arguments[wy];
                if (Cb2)
                  var S1 = Ih2(j_), eM = _e(qh2, S1);
                if (mo && (qh2 = Js(qh2, mo, zs, Cb2)), Jl && (qh2 = rs(qh2, Jl, gf2, Cb2)), i0 -= eM, Cb2 && i0 < pv) {
                  var hw = Me2(qh2, S1);
                  return _s(po, ia2, al, j_.placeholder, Ji2, qh2, hw, vf2, Xp, pv - i0);
                }
                var W_ = Z0 ? Ji2 : this, GS = yg2 ? W_[po] : po;
                return i0 = qh2.length, vf2 ? qh2 = Zy(qh2, vf2) : z_ && i0 > 1 && qh2.reverse(), vg2 && Xp < i0 && (qh2.length = Xp), this && this !== Rt && this instanceof j_ && (GS = tM || Gs(GS)), GS.apply(W_, qh2);
              };
            }
            function _s(po, ia2, Ji2, mo, zs, Jl, gf2, vf2, Xp, pv) {
              var vg2 = 8 & ia2;
              ia2 |= vg2 ? 32 : 64, 4 & (ia2 &= ~(vg2 ? 64 : 32)) || (ia2 &= -4);
              var Z0 = Ji2(po, ia2, zs, vg2 ? Jl : void 0, vg2 ? gf2 : void 0, vg2 ? void 0 : Jl, vg2 ? void 0 : gf2, vf2, Xp, pv);
              return Z0.placeholder = mo, Nd2(Z0, po, ia2);
            }
            function Fl(po, ia2, Ji2, mo, zs, Jl, gf2, vf2) {
              var Xp = 2 & ia2;
              if (!Xp && typeof po != "function")
                throw new TypeError("Expected a function");
              var pv = mo ? mo.length : 0;
              if (pv || (ia2 &= -97, mo = zs = void 0), gf2 = gf2 === void 0 ? gf2 : vi2(VA(gf2), 0), vf2 = vf2 === void 0 ? vf2 : VA(vf2), pv -= zs ? zs.length : 0, 64 & ia2) {
                var vg2 = mo, Z0 = zs;
                mo = zs = void 0;
              }
              var yg2 = [po, ia2, Ji2, mo, zs, vg2, Z0, Jl, gf2, vf2];
              if (po = yg2[0], ia2 = yg2[1], Ji2 = yg2[2], mo = yg2[3], zs = yg2[4], !(vf2 = yg2[9] = yg2[9] == null ? Xp ? 0 : po.length : vi2(yg2[9] - pv, 0)) && 24 & ia2 && (ia2 &= -25), ia2 && ia2 != 1)
                Cb2 = ia2 == 8 || ia2 == 16 ? function(z_, tM, j_) {
                  var i0 = Gs(z_);
                  return function qh2() {
                    for (var wy = arguments.length, S1 = Array(wy), eM = wy, hw = Ih2(qh2); eM--; )
                      S1[eM] = arguments[eM];
                    var W_ = wy < 3 && S1[0] !== hw && S1[wy - 1] !== hw ? [] : Me2(S1, hw);
                    if ((wy -= W_.length) < j_)
                      return _s(z_, tM, al, qh2.placeholder, void 0, S1, W_, void 0, void 0, j_ - wy);
                    var GS = this && this !== Rt && this instanceof qh2 ? i0 : z_;
                    return le2(GS, this, S1);
                  };
                }(po, ia2, vf2) : ia2 != 32 && ia2 != 33 || zs.length ? al.apply(void 0, yg2) : function(z_, tM, j_, i0) {
                  var qh2 = 1 & tM, wy = Gs(z_);
                  return function S1() {
                    for (var eM = -1, hw = arguments.length, W_ = -1, GS = i0.length, vP = Array(GS + hw), RE = this && this !== Rt && this instanceof S1 ? wy : z_; ++W_ < GS; )
                      vP[W_] = i0[W_];
                    for (; hw--; )
                      vP[W_++] = arguments[++eM];
                    return le2(RE, qh2 ? j_ : this, vP);
                  };
                }(po, ia2, Ji2, mo);
              else
                var Cb2 = function(z_, tM, j_) {
                  var i0 = 1 & tM, qh2 = Gs(z_);
                  return function wy() {
                    var S1 = this && this !== Rt && this instanceof wy ? qh2 : z_;
                    return S1.apply(i0 ? j_ : this, arguments);
                  };
                }(po, ia2, Ji2);
              return Nd2(Cb2, po, ia2);
            }
            function Ih2(po) {
              return po.placeholder;
            }
            function lu(po, ia2) {
              var Ji2 = function(mo, zs) {
                return mo == null ? void 0 : mo[zs];
              }(po, ia2);
              return Qs(Ji2) ? Ji2 : void 0;
            }
            function ah2(po) {
              var ia2 = po.match(j);
              return ia2 ? ia2[1].split(U3) : [];
            }
            function Uh2(po, ia2) {
              var Ji2 = ia2.length, mo = Ji2 - 1;
              return ia2[mo] = (Ji2 > 1 ? "& " : "") + ia2[mo], ia2 = ia2.join(Ji2 > 2 ? ", " : " "), po.replace(F3, `{
/* [wrapped with ` + ia2 + `] */
`);
            }
            function Np(po, ia2) {
              return !!(ia2 = ia2 == null ? 9007199254740991 : ia2) && (typeof po == "number" || vt.test(po)) && po > -1 && po % 1 == 0 && po < ia2;
            }
            function Zy(po, ia2) {
              for (var Ji2 = po.length, mo = ko(ia2.length, Ji2), zs = function(gf2, vf2) {
                var Xp = -1, pv = gf2.length;
                for (vf2 || (vf2 = Array(pv)); ++Xp < pv; )
                  vf2[Xp] = gf2[Xp];
                return vf2;
              }(po); mo--; ) {
                var Jl = ia2[mo];
                po[mo] = Np(Jl, Ji2) ? zs[Jl] : void 0;
              }
              return po;
            }
            var Nd2 = Ss ? function(po, ia2, Ji2) {
              var mo, zs = ia2 + "";
              return Ss(po, "toString", { configurable: true, enumerable: false, value: (mo = Uh2(zs, w1(ah2(zs), Ji2)), function() {
                return mo;
              }) });
            } : function(po) {
              return po;
            };
            function w1(po, ia2) {
              return function(Ji2, mo) {
                for (var zs = -1, Jl = Ji2 ? Ji2.length : 0; ++zs < Jl && mo(Ji2[zs], zs, Ji2) !== false; )
                  ;
              }(D2, function(Ji2) {
                var mo = "_." + Ji2[0];
                ia2 & Ji2[1] && !ne2(po, mo) && po.push(mo);
              }), po.sort();
            }
            function Zd2(po, ia2, Ji2) {
              var mo = Fl(po, 8, void 0, void 0, void 0, void 0, void 0, ia2 = Ji2 ? void 0 : ia2);
              return mo.placeholder = Zd2.placeholder, mo;
            }
            function Lv(po) {
              var ia2 = typeof po;
              return !!po && (ia2 == "object" || ia2 == "function");
            }
            function hv(po) {
              return po ? (po = function(ia2) {
                if (typeof ia2 == "number")
                  return ia2;
                if (function(zs) {
                  return typeof zs == "symbol" || function(Jl) {
                    return !!Jl && typeof Jl == "object";
                  }(zs) && ar.call(zs) == "[object Symbol]";
                }(ia2))
                  return NaN;
                if (Lv(ia2)) {
                  var Ji2 = typeof ia2.valueOf == "function" ? ia2.valueOf() : ia2;
                  ia2 = Lv(Ji2) ? Ji2 + "" : Ji2;
                }
                if (typeof ia2 != "string")
                  return ia2 === 0 ? ia2 : +ia2;
                ia2 = ia2.replace(L, "");
                var mo = Q.test(ia2);
                return mo || dt.test(ia2) ? Ct(ia2.slice(2), mo ? 2 : 8) : Y3.test(ia2) ? NaN : +ia2;
              }(po)) === 1 / 0 || po === -1 / 0 ? 17976931348623157e292 * (po < 0 ? -1 : 1) : po == po ? po : 0 : po === 0 ? po : 0;
            }
            function VA(po) {
              var ia2 = hv(po), Ji2 = ia2 % 1;
              return ia2 == ia2 ? Ji2 ? ia2 - Ji2 : ia2 : 0;
            }
            Zd2.placeholder = {}, d2.exports = Zd2;
          }).call(this, x2(43));
        }, function(d2, y2, x2) {
          function C(rs) {
            return rs && rs.__esModule ? rs.default : rs;
          }
          y2.__esModule = true;
          var D2 = x2(95);
          y2.threezerotwofour = C(D2);
          var L = x2(96);
          y2.apathy = C(L);
          var F3 = x2(97);
          y2.ashes = C(F3);
          var j = x2(98);
          y2.atelierDune = C(j);
          var U3 = x2(99);
          y2.atelierForest = C(U3);
          var Y3 = x2(100);
          y2.atelierHeath = C(Y3);
          var Q = x2(101);
          y2.atelierLakeside = C(Q);
          var nt = x2(102);
          y2.atelierSeaside = C(nt);
          var dt = x2(103);
          y2.bespin = C(dt);
          var vt = x2(104);
          y2.brewer = C(vt);
          var Ct = x2(105);
          y2.bright = C(Ct);
          var Pt = x2(106);
          y2.chalk = C(Pt);
          var jt = x2(107);
          y2.codeschool = C(jt);
          var Rt = x2(108);
          y2.colors = C(Rt);
          var le2 = x2(109);
          y2.default = C(le2);
          var ne2 = x2(110);
          y2.eighties = C(ne2);
          var he2 = x2(111);
          y2.embers = C(he2);
          var _e = x2(112);
          y2.flat = C(_e);
          var Me2 = x2(113);
          y2.google = C(Me2);
          var Pe2 = x2(114);
          y2.grayscale = C(Pe2);
          var Be2 = x2(115);
          y2.greenscreen = C(Be2);
          var Je2 = x2(116);
          y2.harmonic = C(Je2);
          var Ze2 = x2(117);
          y2.hopscotch = C(Ze2);
          var Cn = x2(118);
          y2.isotope = C(Cn);
          var Bn = x2(119);
          y2.marrakesh = C(Bn);
          var mn = x2(120);
          y2.mocha = C(mn);
          var Kr = x2(121);
          y2.monokai = C(Kr);
          var Kn = x2(122);
          y2.ocean = C(Kn);
          var ar = x2(123);
          y2.paraiso = C(ar);
          var Cr = x2(124);
          y2.pop = C(Cr);
          var ui2 = x2(125);
          y2.railscasts = C(ui2);
          var vi2 = x2(126);
          y2.shapeshifter = C(vi2);
          var ko = x2(127);
          y2.solarized = C(ko);
          var Ss = x2(128);
          y2.summerfruit = C(Ss);
          var hl = x2(129);
          y2.tomorrow = C(hl);
          var Qs = x2(130);
          y2.tube = C(Qs);
          var Js = x2(131);
          y2.twilight = C(Js);
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          y2.__esModule = true, y2.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, d2.exports = y2.default;
        }, function(d2, y2, x2) {
          var C = x2(33);
          function D2(L) {
            var F3 = Math.round(C(L, 0, 255)).toString(16);
            return F3.length == 1 ? "0" + F3 : F3;
          }
          d2.exports = function(L) {
            var F3 = L.length === 4 ? D2(255 * L[3]) : "";
            return "#" + D2(L[0]) + D2(L[1]) + D2(L[2]) + F3;
          };
        }, function(d2, y2, x2) {
          var C = x2(134), D2 = x2(135), L = x2(136), F3 = x2(137), j = { "#": D2, hsl: function(Y3) {
            var Q = C(Y3), nt = F3(Q);
            return Q.length === 4 && nt.push(Q[3]), nt;
          }, rgb: L };
          function U3(Y3) {
            for (var Q in j)
              if (Y3.indexOf(Q) === 0)
                return j[Q](Y3);
          }
          U3.rgb = L, U3.hsl = C, U3.hex = D2, d2.exports = U3;
        }, function(d2, y2, x2) {
          var C = x2(44), D2 = x2(33);
          function L(F3, j) {
            switch (F3 = parseFloat(F3), j) {
              case 0:
                return D2(F3, 0, 360);
              case 1:
              case 2:
                return D2(F3, 0, 100);
              case 3:
                return D2(F3, 0, 1);
            }
          }
          d2.exports = function(F3) {
            return C(F3).map(L);
          };
        }, function(d2, y2) {
          d2.exports = function(x2) {
            x2.length !== 4 && x2.length !== 5 || (x2 = function(L) {
              for (var F3 = "#", j = 1; j < L.length; j++) {
                var U3 = L.charAt(j);
                F3 += U3 + U3;
              }
              return F3;
            }(x2));
            var C = [parseInt(x2.substring(1, 3), 16), parseInt(x2.substring(3, 5), 16), parseInt(x2.substring(5, 7), 16)];
            if (x2.length === 9) {
              var D2 = parseFloat((parseInt(x2.substring(7, 9), 16) / 255).toFixed(2));
              C.push(D2);
            }
            return C;
          };
        }, function(d2, y2, x2) {
          var C = x2(44), D2 = x2(33);
          function L(F3, j) {
            return j < 3 ? F3.indexOf("%") != -1 ? Math.round(255 * D2(parseInt(F3, 10), 0, 100) / 100) : D2(parseInt(F3, 10), 0, 255) : D2(parseFloat(F3), 0, 1);
          }
          d2.exports = function(F3) {
            return C(F3).map(L);
          };
        }, function(d2, y2) {
          d2.exports = function(x2) {
            var C, D2, L, F3, j, U3 = x2[0] / 360, Y3 = x2[1] / 100, Q = x2[2] / 100;
            if (Y3 == 0)
              return [j = 255 * Q, j, j];
            C = 2 * Q - (D2 = Q < 0.5 ? Q * (1 + Y3) : Q + Y3 - Q * Y3), F3 = [0, 0, 0];
            for (var nt = 0; nt < 3; nt++)
              (L = U3 + 1 / 3 * -(nt - 1)) < 0 && L++, L > 1 && L--, j = 6 * L < 1 ? C + 6 * (D2 - C) * L : 2 * L < 1 ? D2 : 3 * L < 2 ? C + (D2 - C) * (2 / 3 - L) * 6 : C, F3[nt] = 255 * j;
            return F3;
          };
        }, function(d2, y2, x2) {
          (function(C) {
            var D2 = typeof C == "object" && C && C.Object === Object && C, L = typeof self == "object" && self && self.Object === Object && self, F3 = D2 || L || Function("return this")();
            function j(Me2, Pe2, Be2) {
              switch (Be2.length) {
                case 0:
                  return Me2.call(Pe2);
                case 1:
                  return Me2.call(Pe2, Be2[0]);
                case 2:
                  return Me2.call(Pe2, Be2[0], Be2[1]);
                case 3:
                  return Me2.call(Pe2, Be2[0], Be2[1], Be2[2]);
              }
              return Me2.apply(Pe2, Be2);
            }
            function U3(Me2, Pe2) {
              for (var Be2 = -1, Je2 = Pe2.length, Ze2 = Me2.length; ++Be2 < Je2; )
                Me2[Ze2 + Be2] = Pe2[Be2];
              return Me2;
            }
            var Y3 = Object.prototype, Q = Y3.hasOwnProperty, nt = Y3.toString, dt = F3.Symbol, vt = Y3.propertyIsEnumerable, Ct = dt ? dt.isConcatSpreadable : void 0, Pt = Math.max;
            function jt(Me2) {
              return Rt(Me2) || function(Pe2) {
                return function(Be2) {
                  return function(Je2) {
                    return !!Je2 && typeof Je2 == "object";
                  }(Be2) && function(Je2) {
                    return Je2 != null && function(Ze2) {
                      return typeof Ze2 == "number" && Ze2 > -1 && Ze2 % 1 == 0 && Ze2 <= 9007199254740991;
                    }(Je2.length) && !function(Ze2) {
                      var Cn = function(Bn) {
                        var mn = typeof Bn;
                        return !!Bn && (mn == "object" || mn == "function");
                      }(Ze2) ? nt.call(Ze2) : "";
                      return Cn == "[object Function]" || Cn == "[object GeneratorFunction]";
                    }(Je2);
                  }(Be2);
                }(Pe2) && Q.call(Pe2, "callee") && (!vt.call(Pe2, "callee") || nt.call(Pe2) == "[object Arguments]");
              }(Me2) || !!(Ct && Me2 && Me2[Ct]);
            }
            var Rt = Array.isArray, le2, ne2, he2, _e = (ne2 = function(Me2) {
              var Pe2 = (Me2 = function Je2(Ze2, Cn, Bn, mn, Kr) {
                var Kn = -1, ar = Ze2.length;
                for (Bn || (Bn = jt), Kr || (Kr = []); ++Kn < ar; ) {
                  var Cr = Ze2[Kn];
                  Cn > 0 && Bn(Cr) ? Cn > 1 ? Je2(Cr, Cn - 1, Bn, mn, Kr) : U3(Kr, Cr) : mn || (Kr[Kr.length] = Cr);
                }
                return Kr;
              }(Me2, 1)).length, Be2 = Pe2;
              for (le2; Be2--; )
                if (typeof Me2[Be2] != "function")
                  throw new TypeError("Expected a function");
              return function() {
                for (var Je2 = 0, Ze2 = Pe2 ? Me2[Je2].apply(this, arguments) : arguments[0]; ++Je2 < Pe2; )
                  Ze2 = Me2[Je2].call(this, Ze2);
                return Ze2;
              };
            }, he2 = Pt(he2 === void 0 ? ne2.length - 1 : he2, 0), function() {
              for (var Me2 = arguments, Pe2 = -1, Be2 = Pt(Me2.length - he2, 0), Je2 = Array(Be2); ++Pe2 < Be2; )
                Je2[Pe2] = Me2[he2 + Pe2];
              Pe2 = -1;
              for (var Ze2 = Array(he2 + 1); ++Pe2 < he2; )
                Ze2[Pe2] = Me2[Pe2];
              return Ze2[he2] = Je2, j(ne2, this, Ze2);
            });
            d2.exports = _e;
          }).call(this, x2(43));
        }, function(d2, y2, x2) {
          Object.defineProperty(y2, "__esModule", { value: true }), y2.yuv2rgb = function(C) {
            var D2, L, F3, j = C[0], U3 = C[1], Y3 = C[2];
            return D2 = 1 * j + 0 * U3 + 1.13983 * Y3, L = 1 * j + -0.39465 * U3 + -0.5806 * Y3, F3 = 1 * j + 2.02311 * U3 + 0 * Y3, D2 = Math.min(Math.max(0, D2), 1), L = Math.min(Math.max(0, L), 1), F3 = Math.min(Math.max(0, F3), 1), [255 * D2, 255 * L, 255 * F3];
          }, y2.rgb2yuv = function(C) {
            var D2 = C[0] / 255, L = C[1] / 255, F3 = C[2] / 255;
            return [0.299 * D2 + 0.587 * L + 0.114 * F3, -0.14713 * D2 + -0.28886 * L + 0.436 * F3, 0.615 * D2 + -0.51499 * L + -0.10001 * F3];
          };
        }, function(d2, y2, x2) {
          function C(F3, j, U3) {
            return j in F3 ? Object.defineProperty(F3, j, { value: U3, enumerable: true, configurable: true, writable: true }) : F3[j] = U3, F3;
          }
          var D2 = x2(141), L = function() {
            function F3() {
              C(this, "_callbacks", void 0), C(this, "_isDispatching", void 0), C(this, "_isHandled", void 0), C(this, "_isPending", void 0), C(this, "_lastID", void 0), C(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
            }
            var j = F3.prototype;
            return j.register = function(U3) {
              var Y3 = "ID_" + this._lastID++;
              return this._callbacks[Y3] = U3, Y3;
            }, j.unregister = function(U3) {
              this._callbacks[U3] || D2(false), delete this._callbacks[U3];
            }, j.waitFor = function(U3) {
              this._isDispatching || D2(false);
              for (var Y3 = 0; Y3 < U3.length; Y3++) {
                var Q = U3[Y3];
                this._isPending[Q] ? this._isHandled[Q] || D2(false) : (this._callbacks[Q] || D2(false), this._invokeCallback(Q));
              }
            }, j.dispatch = function(U3) {
              this._isDispatching && D2(false), this._startDispatching(U3);
              try {
                for (var Y3 in this._callbacks)
                  this._isPending[Y3] || this._invokeCallback(Y3);
              } finally {
                this._stopDispatching();
              }
            }, j.isDispatching = function() {
              return this._isDispatching;
            }, j._invokeCallback = function(U3) {
              this._isPending[U3] = true, this._callbacks[U3](this._pendingPayload), this._isHandled[U3] = true;
            }, j._startDispatching = function(U3) {
              for (var Y3 in this._callbacks)
                this._isPending[Y3] = false, this._isHandled[Y3] = false;
              this._pendingPayload = U3, this._isDispatching = true;
            }, j._stopDispatching = function() {
              delete this._pendingPayload, this._isDispatching = false;
            }, F3;
          }();
          d2.exports = L;
        }, function(d2, y2, x2) {
          d2.exports = function(C, D2) {
            for (var L = arguments.length, F3 = new Array(L > 2 ? L - 2 : 0), j = 2; j < L; j++)
              F3[j - 2] = arguments[j];
            if (!C) {
              var U3;
              if (D2 === void 0)
                U3 = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
              else {
                var Y3 = 0;
                (U3 = new Error(D2.replace(/%s/g, function() {
                  return String(F3[Y3++]);
                }))).name = "Invariant Violation";
              }
              throw U3.framesToPop = 1, U3;
            }
          };
        }, function(d2, y2, x2) {
          function C(xr, kr, Rn) {
            return kr in xr ? Object.defineProperty(xr, kr, { value: Rn, enumerable: true, configurable: true, writable: true }) : xr[kr] = Rn, xr;
          }
          function D2(xr, kr) {
            var Rn = Object.keys(xr);
            if (Object.getOwnPropertySymbols) {
              var fr = Object.getOwnPropertySymbols(xr);
              kr && (fr = fr.filter(function(mr) {
                return Object.getOwnPropertyDescriptor(xr, mr).enumerable;
              })), Rn.push.apply(Rn, fr);
            }
            return Rn;
          }
          function L(xr) {
            for (var kr = 1; kr < arguments.length; kr++) {
              var Rn = arguments[kr] != null ? arguments[kr] : {};
              kr % 2 ? D2(Object(Rn), true).forEach(function(fr) {
                C(xr, fr, Rn[fr]);
              }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(xr, Object.getOwnPropertyDescriptors(Rn)) : D2(Object(Rn)).forEach(function(fr) {
                Object.defineProperty(xr, fr, Object.getOwnPropertyDescriptor(Rn, fr));
              });
            }
            return xr;
          }
          function F3(xr, kr) {
            if (!(xr instanceof kr))
              throw new TypeError("Cannot call a class as a function");
          }
          function j(xr, kr) {
            for (var Rn = 0; Rn < kr.length; Rn++) {
              var fr = kr[Rn];
              fr.enumerable = fr.enumerable || false, fr.configurable = true, "value" in fr && (fr.writable = true), Object.defineProperty(xr, fr.key, fr);
            }
          }
          function U3(xr, kr, Rn) {
            return kr && j(xr.prototype, kr), Rn && j(xr, Rn), xr;
          }
          function Y3(xr, kr) {
            return (Y3 = Object.setPrototypeOf || function(Rn, fr) {
              return Rn.__proto__ = fr, Rn;
            })(xr, kr);
          }
          function Q(xr, kr) {
            if (typeof kr != "function" && kr !== null)
              throw new TypeError("Super expression must either be null or a function");
            xr.prototype = Object.create(kr && kr.prototype, { constructor: { value: xr, writable: true, configurable: true } }), kr && Y3(xr, kr);
          }
          function nt(xr) {
            return (nt = Object.setPrototypeOf ? Object.getPrototypeOf : function(kr) {
              return kr.__proto__ || Object.getPrototypeOf(kr);
            })(xr);
          }
          function dt(xr) {
            return (dt = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(kr) {
              return typeof kr;
            } : function(kr) {
              return kr && typeof Symbol == "function" && kr.constructor === Symbol && kr !== Symbol.prototype ? "symbol" : typeof kr;
            })(xr);
          }
          function vt(xr) {
            if (xr === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return xr;
          }
          function Ct(xr, kr) {
            return !kr || dt(kr) !== "object" && typeof kr != "function" ? vt(xr) : kr;
          }
          function Pt(xr) {
            var kr = function() {
              if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                return false;
              if (typeof Proxy == "function")
                return true;
              try {
                return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                })), true;
              } catch {
                return false;
              }
            }();
            return function() {
              var Rn, fr = nt(xr);
              if (kr) {
                var mr = nt(this).constructor;
                Rn = Reflect.construct(fr, arguments, mr);
              } else
                Rn = fr.apply(this, arguments);
              return Ct(this, Rn);
            };
          }
          x2.r(y2);
          var jt = x2(0), Rt = x2.n(jt);
          function le2() {
            var xr = this.constructor.getDerivedStateFromProps(this.props, this.state);
            xr != null && this.setState(xr);
          }
          function ne2(xr) {
            this.setState(function(kr) {
              var Rn = this.constructor.getDerivedStateFromProps(xr, kr);
              return Rn != null ? Rn : null;
            }.bind(this));
          }
          function he2(xr, kr) {
            try {
              var Rn = this.props, fr = this.state;
              this.props = xr, this.state = kr, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Rn, fr);
            } finally {
              this.props = Rn, this.state = fr;
            }
          }
          function _e(xr) {
            var kr = xr.prototype;
            if (!kr || !kr.isReactComponent)
              throw new Error("Can only polyfill class components");
            if (typeof xr.getDerivedStateFromProps != "function" && typeof kr.getSnapshotBeforeUpdate != "function")
              return xr;
            var Rn = null, fr = null, mr = null;
            if (typeof kr.componentWillMount == "function" ? Rn = "componentWillMount" : typeof kr.UNSAFE_componentWillMount == "function" && (Rn = "UNSAFE_componentWillMount"), typeof kr.componentWillReceiveProps == "function" ? fr = "componentWillReceiveProps" : typeof kr.UNSAFE_componentWillReceiveProps == "function" && (fr = "UNSAFE_componentWillReceiveProps"), typeof kr.componentWillUpdate == "function" ? mr = "componentWillUpdate" : typeof kr.UNSAFE_componentWillUpdate == "function" && (mr = "UNSAFE_componentWillUpdate"), Rn !== null || fr !== null || mr !== null) {
              var qi2 = xr.displayName || xr.name, to = typeof xr.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
              throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + qi2 + " uses " + to + " but also contains the following legacy lifecycles:" + (Rn !== null ? `
  ` + Rn : "") + (fr !== null ? `
  ` + fr : "") + (mr !== null ? `
  ` + mr : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
            }
            if (typeof xr.getDerivedStateFromProps == "function" && (kr.componentWillMount = le2, kr.componentWillReceiveProps = ne2), typeof kr.getSnapshotBeforeUpdate == "function") {
              if (typeof kr.componentDidUpdate != "function")
                throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
              kr.componentWillUpdate = he2;
              var ka2 = kr.componentDidUpdate;
              kr.componentDidUpdate = function(Ti2, tr, tu) {
                var Kf2 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : tu;
                ka2.call(this, Ti2, tr, Kf2);
              };
            }
            return xr;
          }
          function Me2(xr, kr) {
            if (xr == null)
              return {};
            var Rn, fr, mr = function(to, ka2) {
              if (to == null)
                return {};
              var Ti2, tr, tu = {}, Kf2 = Object.keys(to);
              for (tr = 0; tr < Kf2.length; tr++)
                Ti2 = Kf2[tr], ka2.indexOf(Ti2) >= 0 || (tu[Ti2] = to[Ti2]);
              return tu;
            }(xr, kr);
            if (Object.getOwnPropertySymbols) {
              var qi2 = Object.getOwnPropertySymbols(xr);
              for (fr = 0; fr < qi2.length; fr++)
                Rn = qi2[fr], kr.indexOf(Rn) >= 0 || Object.prototype.propertyIsEnumerable.call(xr, Rn) && (mr[Rn] = xr[Rn]);
            }
            return mr;
          }
          function Pe2(xr) {
            var kr = function(Rn) {
              return {}.toString.call(Rn).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
            }(xr);
            return kr === "number" && (kr = isNaN(xr) ? "nan" : (0 | xr) != xr ? "float" : "integer"), kr;
          }
          le2.__suppressDeprecationWarning = true, ne2.__suppressDeprecationWarning = true, he2.__suppressDeprecationWarning = true;
          var Be2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, Je2 = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, Ze2 = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, Cn = x2(45), Bn = function(xr) {
            var kr = function(Rn) {
              return { backgroundColor: Rn.base00, ellipsisColor: Rn.base09, braceColor: Rn.base07, expandedIcon: Rn.base0D, collapsedIcon: Rn.base0E, keyColor: Rn.base07, arrayKeyColor: Rn.base0C, objectSize: Rn.base04, copyToClipboard: Rn.base0F, copyToClipboardCheck: Rn.base0D, objectBorder: Rn.base02, dataTypes: { boolean: Rn.base0E, date: Rn.base0D, float: Rn.base0B, function: Rn.base0D, integer: Rn.base0F, string: Rn.base09, nan: Rn.base08, null: Rn.base0A, undefined: Rn.base05, regexp: Rn.base0A, background: Rn.base02 }, editVariable: { editIcon: Rn.base0E, cancelIcon: Rn.base09, removeIcon: Rn.base09, addIcon: Rn.base0E, checkIcon: Rn.base0E, background: Rn.base01, color: Rn.base0A, border: Rn.base07 }, addKeyModal: { background: Rn.base05, border: Rn.base04, color: Rn.base0A, labelColor: Rn.base01 }, validationFailure: { background: Rn.base09, iconColor: Rn.base01, fontColor: Rn.base01 } };
            }(xr);
            return { "app-container": { fontFamily: Ze2.globalFontFamily, cursor: Ze2.globalCursor, backgroundColor: kr.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: kr.ellipsisColor, fontSize: Ze2.ellipsisFontSize, lineHeight: Ze2.ellipsisLineHeight, cursor: Ze2.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: Ze2.braceCursor, fontWeight: Ze2.braceFontWeight, color: kr.braceColor }, "expanded-icon": { color: kr.expandedIcon }, "collapsed-icon": { color: kr.collapsedIcon }, colon: { display: "inline-block", margin: Ze2.keyMargin, color: kr.keyColor, verticalAlign: "top" }, objectKeyVal: function(Rn, fr) {
              return { style: L({ paddingTop: Ze2.keyValPaddingTop, paddingRight: Ze2.keyValPaddingRight, paddingBottom: Ze2.keyValPaddingBottom, borderLeft: Ze2.keyValBorderLeft + " " + kr.objectBorder, ":hover": { paddingLeft: fr.paddingLeft - 1 + "px", borderLeft: Ze2.keyValBorderHover + " " + kr.objectBorder } }, fr) };
            }, "object-key-val-no-border": { padding: Ze2.keyValPadding }, "pushed-content": { marginLeft: Ze2.pushedContentMarginLeft }, variableValue: function(Rn, fr) {
              return { style: L({ display: "inline-block", paddingRight: Ze2.variableValuePaddingRight, position: "relative" }, fr) };
            }, "object-name": { display: "inline-block", color: kr.keyColor, letterSpacing: Ze2.keyLetterSpacing, fontStyle: Ze2.keyFontStyle, verticalAlign: Ze2.keyVerticalAlign, opacity: Ze2.keyOpacity, ":hover": { opacity: Ze2.keyOpacityHover } }, "array-key": { display: "inline-block", color: kr.arrayKeyColor, letterSpacing: Ze2.keyLetterSpacing, fontStyle: Ze2.keyFontStyle, verticalAlign: Ze2.keyVerticalAlign, opacity: Ze2.keyOpacity, ":hover": { opacity: Ze2.keyOpacityHover } }, "object-size": { color: kr.objectSize, borderRadius: Ze2.objectSizeBorderRadius, fontStyle: Ze2.objectSizeFontStyle, margin: Ze2.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: Ze2.dataTypeFontSize, marginRight: Ze2.dataTypeMarginRight, opacity: Ze2.datatypeOpacity }, boolean: { display: "inline-block", color: kr.dataTypes.boolean }, date: { display: "inline-block", color: kr.dataTypes.date }, "date-value": { marginLeft: Ze2.dateValueMarginLeft }, float: { display: "inline-block", color: kr.dataTypes.float }, function: { display: "inline-block", color: kr.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: kr.dataTypes.integer }, string: { display: "inline-block", color: kr.dataTypes.string }, nan: { display: "inline-block", color: kr.dataTypes.nan, fontSize: Ze2.nanFontSize, fontWeight: Ze2.nanFontWeight, backgroundColor: kr.dataTypes.background, padding: Ze2.nanPadding, borderRadius: Ze2.nanBorderRadius }, null: { display: "inline-block", color: kr.dataTypes.null, fontSize: Ze2.nullFontSize, fontWeight: Ze2.nullFontWeight, backgroundColor: kr.dataTypes.background, padding: Ze2.nullPadding, borderRadius: Ze2.nullBorderRadius }, undefined: { display: "inline-block", color: kr.dataTypes.undefined, fontSize: Ze2.undefinedFontSize, padding: Ze2.undefinedPadding, borderRadius: Ze2.undefinedBorderRadius, backgroundColor: kr.dataTypes.background }, regexp: { display: "inline-block", color: kr.dataTypes.regexp }, "copy-to-clipboard": { cursor: Ze2.clipboardCursor }, "copy-icon": { color: kr.copyToClipboard, fontSize: Ze2.iconFontSize, marginRight: Ze2.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: kr.copyToClipboardCheck, marginLeft: Ze2.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: Ze2.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: Ze2.metaDataPadding }, "icon-container": { display: "inline-block", width: Ze2.iconContainerWidth }, tooltip: { padding: Ze2.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: kr.editVariable.removeIcon, cursor: Ze2.iconCursor, fontSize: Ze2.iconFontSize, marginRight: Ze2.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: kr.editVariable.addIcon, cursor: Ze2.iconCursor, fontSize: Ze2.iconFontSize, marginRight: Ze2.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: kr.editVariable.editIcon, cursor: Ze2.iconCursor, fontSize: Ze2.iconFontSize, marginRight: Ze2.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: Ze2.iconCursor, color: kr.editVariable.checkIcon, fontSize: Ze2.iconFontSize, paddingRight: Ze2.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: Ze2.iconCursor, color: kr.editVariable.cancelIcon, fontSize: Ze2.iconFontSize, paddingRight: Ze2.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: Ze2.editInputMinWidth, borderRadius: Ze2.editInputBorderRadius, backgroundColor: kr.editVariable.background, color: kr.editVariable.color, padding: Ze2.editInputPadding, marginRight: Ze2.editInputMarginRight, fontFamily: Ze2.editInputFontFamily }, "detected-row": { paddingTop: Ze2.detectedRowPaddingTop }, "key-modal-request": { position: Ze2.addKeyCoverPosition, top: Ze2.addKeyCoverPositionPx, left: Ze2.addKeyCoverPositionPx, right: Ze2.addKeyCoverPositionPx, bottom: Ze2.addKeyCoverPositionPx, backgroundColor: Ze2.addKeyCoverBackground }, "key-modal": { width: Ze2.addKeyModalWidth, backgroundColor: kr.addKeyModal.background, marginLeft: Ze2.addKeyModalMargin, marginRight: Ze2.addKeyModalMargin, padding: Ze2.addKeyModalPadding, borderRadius: Ze2.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: kr.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: kr.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: kr.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: kr.addKeyModal.labelColor, fontSize: Ze2.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: kr.editVariable.addIcon, fontSize: Ze2.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: kr.ellipsisColor, fontSize: Ze2.ellipsisFontSize, lineHeight: Ze2.ellipsisLineHeight, cursor: Ze2.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: kr.validationFailure.fontColor, backgroundColor: kr.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: kr.validationFailure.iconColor, fontSize: Ze2.iconFontSize, transform: "rotate(45deg)" } };
          };
          function mn(xr, kr, Rn) {
            return xr || console.error("theme has not been set"), function(fr) {
              var mr = Be2;
              return fr !== false && fr !== "none" || (mr = Je2), Object(Cn.createStyling)(Bn, { defaultBase16: mr })(fr);
            }(xr)(kr, Rn);
          }
          var Kr = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = (fr.rjvId, fr.type_name), qi2 = fr.displayDataTypes, to = fr.theme;
              return qi2 ? Rt.a.createElement("span", Object.assign({ className: "data-type-label" }, mn(to, "data-type-label")), mr) : null;
            } }]), Rn;
          }(Rt.a.PureComponent), Kn = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props;
              return Rt.a.createElement("div", mn(fr.theme, "boolean"), Rt.a.createElement(Kr, Object.assign({ type_name: "bool" }, fr)), fr.value ? "true" : "false");
            } }]), Rn;
          }(Rt.a.PureComponent), ar = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props;
              return Rt.a.createElement("div", mn(fr.theme, "date"), Rt.a.createElement(Kr, Object.assign({ type_name: "date" }, fr)), Rt.a.createElement("span", Object.assign({ className: "date-value" }, mn(fr.theme, "date-value")), fr.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
            } }]), Rn;
          }(Rt.a.PureComponent), Cr = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props;
              return Rt.a.createElement("div", mn(fr.theme, "float"), Rt.a.createElement(Kr, Object.assign({ type_name: "float" }, fr)), this.props.value);
            } }]), Rn;
          }(Rt.a.PureComponent);
          function ui2(xr, kr) {
            (kr == null || kr > xr.length) && (kr = xr.length);
            for (var Rn = 0, fr = new Array(kr); Rn < kr; Rn++)
              fr[Rn] = xr[Rn];
            return fr;
          }
          function vi2(xr, kr) {
            if (xr) {
              if (typeof xr == "string")
                return ui2(xr, kr);
              var Rn = Object.prototype.toString.call(xr).slice(8, -1);
              return Rn === "Object" && xr.constructor && (Rn = xr.constructor.name), Rn === "Map" || Rn === "Set" ? Array.from(xr) : Rn === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Rn) ? ui2(xr, kr) : void 0;
            }
          }
          function ko(xr, kr) {
            var Rn;
            if (typeof Symbol == "undefined" || xr[Symbol.iterator] == null) {
              if (Array.isArray(xr) || (Rn = vi2(xr)) || kr && xr && typeof xr.length == "number") {
                Rn && (xr = Rn);
                var fr = 0, mr = function() {
                };
                return { s: mr, n: function() {
                  return fr >= xr.length ? { done: true } : { done: false, value: xr[fr++] };
                }, e: function(Ti2) {
                  throw Ti2;
                }, f: mr };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            var qi2, to = true, ka2 = false;
            return { s: function() {
              Rn = xr[Symbol.iterator]();
            }, n: function() {
              var Ti2 = Rn.next();
              return to = Ti2.done, Ti2;
            }, e: function(Ti2) {
              ka2 = true, qi2 = Ti2;
            }, f: function() {
              try {
                to || Rn.return == null || Rn.return();
              } finally {
                if (ka2)
                  throw qi2;
              }
            } };
          }
          function Ss(xr) {
            return function(kr) {
              if (Array.isArray(kr))
                return ui2(kr);
            }(xr) || function(kr) {
              if (typeof Symbol != "undefined" && Symbol.iterator in Object(kr))
                return Array.from(kr);
            }(xr) || vi2(xr) || function() {
              throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }();
          }
          var hl = x2(46), Qs = new (x2(47)).Dispatcher(), Js = new (function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              var fr;
              F3(this, Rn);
              for (var mr = arguments.length, qi2 = new Array(mr), to = 0; to < mr; to++)
                qi2[to] = arguments[to];
              return (fr = kr.call.apply(kr, [this].concat(qi2))).objects = {}, fr.set = function(ka2, Ti2, tr, tu) {
                fr.objects[ka2] === void 0 && (fr.objects[ka2] = {}), fr.objects[ka2][Ti2] === void 0 && (fr.objects[ka2][Ti2] = {}), fr.objects[ka2][Ti2][tr] = tu;
              }, fr.get = function(ka2, Ti2, tr, tu) {
                return fr.objects[ka2] === void 0 || fr.objects[ka2][Ti2] === void 0 || fr.objects[ka2][Ti2][tr] == null ? tu : fr.objects[ka2][Ti2][tr];
              }, fr.handleAction = function(ka2) {
                var Ti2 = ka2.rjvId, tr = ka2.data;
                switch (ka2.name) {
                  case "RESET":
                    fr.emit("reset-" + Ti2);
                    break;
                  case "VARIABLE_UPDATED":
                    ka2.data.updated_src = fr.updateSrc(Ti2, tr), fr.set(Ti2, "action", "variable-update", L(L({}, tr), {}, { type: "variable-edited" })), fr.emit("variable-update-" + Ti2);
                    break;
                  case "VARIABLE_REMOVED":
                    ka2.data.updated_src = fr.updateSrc(Ti2, tr), fr.set(Ti2, "action", "variable-update", L(L({}, tr), {}, { type: "variable-removed" })), fr.emit("variable-update-" + Ti2);
                    break;
                  case "VARIABLE_ADDED":
                    ka2.data.updated_src = fr.updateSrc(Ti2, tr), fr.set(Ti2, "action", "variable-update", L(L({}, tr), {}, { type: "variable-added" })), fr.emit("variable-update-" + Ti2);
                    break;
                  case "ADD_VARIABLE_KEY_REQUEST":
                    fr.set(Ti2, "action", "new-key-request", tr), fr.emit("add-key-request-" + Ti2);
                }
              }, fr.updateSrc = function(ka2, Ti2) {
                var tr = Ti2.name, tu = Ti2.namespace, Kf2 = Ti2.new_value, yf2 = (Ti2.existing_value, Ti2.variable_removed);
                tu.shift();
                var wd2, Ys = fr.get(ka2, "global", "src"), Qp = fr.deepCopy(Ys, Ss(tu)), dv = Qp, Fu = ko(tu);
                try {
                  for (Fu.s(); !(wd2 = Fu.n()).done; )
                    dv = dv[wd2.value];
                } catch ($0) {
                  Fu.e($0);
                } finally {
                  Fu.f();
                }
                return yf2 ? Pe2(dv) == "array" ? dv.splice(tr, 1) : delete dv[tr] : tr !== null ? dv[tr] = Kf2 : Qp = Kf2, fr.set(ka2, "global", "src", Qp), Qp;
              }, fr.deepCopy = function(ka2, Ti2) {
                var tr, tu = Pe2(ka2), Kf2 = Ti2.shift();
                return tu == "array" ? tr = Ss(ka2) : tu == "object" && (tr = L({}, ka2)), Kf2 !== void 0 && (tr[Kf2] = fr.deepCopy(ka2[Kf2], Ti2)), tr;
              }, fr;
            }
            return Rn;
          }(hl.EventEmitter))();
          Qs.register(Js.handleAction.bind(Js));
          var rs = Js, Gs = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              return F3(this, Rn), (mr = kr.call(this, fr)).toggleCollapsed = function() {
                mr.setState({ collapsed: !mr.state.collapsed }, function() {
                  rs.set(mr.props.rjvId, mr.props.namespace, "collapsed", mr.state.collapsed);
                });
              }, mr.getFunctionDisplay = function(qi2) {
                var to = vt(mr).props;
                return qi2 ? Rt.a.createElement("span", null, mr.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), Rt.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, Rt.a.createElement("span", null, "{"), Rt.a.createElement("span", mn(to.theme, "ellipsis"), "..."), Rt.a.createElement("span", null, "}"))) : mr.props.value.toString().slice(9, -1);
              }, mr.state = { collapsed: rs.get(fr.rjvId, fr.namespace, "collapsed", true) }, mr;
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = this.state.collapsed;
              return Rt.a.createElement("div", mn(fr.theme, "function"), Rt.a.createElement(Kr, Object.assign({ type_name: "function" }, fr)), Rt.a.createElement("span", Object.assign({}, mn(fr.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(mr)));
            } }]), Rn;
          }(Rt.a.PureComponent), al = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              return Rt.a.createElement("div", mn(this.props.theme, "nan"), "NaN");
            } }]), Rn;
          }(Rt.a.PureComponent), _s = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              return Rt.a.createElement("div", mn(this.props.theme, "null"), "NULL");
            } }]), Rn;
          }(Rt.a.PureComponent), Fl = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props;
              return Rt.a.createElement("div", mn(fr.theme, "integer"), Rt.a.createElement(Kr, Object.assign({ type_name: "int" }, fr)), this.props.value);
            } }]), Rn;
          }(Rt.a.PureComponent), Ih2 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props;
              return Rt.a.createElement("div", mn(fr.theme, "regexp"), Rt.a.createElement(Kr, Object.assign({ type_name: "regexp" }, fr)), this.props.value.toString());
            } }]), Rn;
          }(Rt.a.PureComponent), lu = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              return F3(this, Rn), (mr = kr.call(this, fr)).toggleCollapsed = function() {
                mr.setState({ collapsed: !mr.state.collapsed }, function() {
                  rs.set(mr.props.rjvId, mr.props.namespace, "collapsed", mr.state.collapsed);
                });
              }, mr.state = { collapsed: rs.get(fr.rjvId, fr.namespace, "collapsed", true) }, mr;
            }
            return U3(Rn, [{ key: "render", value: function() {
              this.state.collapsed;
              var fr = this.props, mr = fr.collapseStringsAfterLength, qi2 = fr.theme, to = fr.value, ka2 = { style: { cursor: "default" } };
              return Pe2(mr) === "integer" && to.length > mr && (ka2.style.cursor = "pointer", this.state.collapsed && (to = Rt.a.createElement("span", null, to.substring(0, mr), Rt.a.createElement("span", mn(qi2, "ellipsis"), " ...")))), Rt.a.createElement("div", mn(qi2, "string"), Rt.a.createElement(Kr, Object.assign({ type_name: "string" }, fr)), Rt.a.createElement("span", Object.assign({ className: "string-value" }, ka2, { onClick: this.toggleCollapsed }), '"', to, '"'));
            } }]), Rn;
          }(Rt.a.PureComponent), ah2 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              return Rt.a.createElement("div", mn(this.props.theme, "undefined"), "undefined");
            } }]), Rn;
          }(Rt.a.PureComponent);
          function Uh2() {
            return (Uh2 = Object.assign || function(xr) {
              for (var kr = 1; kr < arguments.length; kr++) {
                var Rn = arguments[kr];
                for (var fr in Rn)
                  Object.prototype.hasOwnProperty.call(Rn, fr) && (xr[fr] = Rn[fr]);
              }
              return xr;
            }).apply(this, arguments);
          }
          var Np = jt.useLayoutEffect, Zy = function(xr) {
            var kr = Object(jt.useRef)(xr);
            return Np(function() {
              kr.current = xr;
            }), kr;
          }, Nd2 = function(xr, kr) {
            typeof xr != "function" ? xr.current = kr : xr(kr);
          }, w1 = function(xr, kr) {
            var Rn = Object(jt.useRef)();
            return Object(jt.useCallback)(function(fr) {
              xr.current = fr, Rn.current && Nd2(Rn.current, null), Rn.current = kr, kr && Nd2(kr, fr);
            }, [kr]);
          }, Zd2 = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Lv = function(xr) {
            Object.keys(Zd2).forEach(function(kr) {
              xr.style.setProperty(kr, Zd2[kr], "important");
            });
          }, hv = null, VA = function() {
          }, po = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], ia2 = !!document.documentElement.currentStyle, Ji2 = function(xr, kr) {
            var Rn = xr.cacheMeasurements, fr = xr.maxRows, mr = xr.minRows, qi2 = xr.onChange, to = qi2 === void 0 ? VA : qi2, ka2 = xr.onHeightChange, Ti2 = ka2 === void 0 ? VA : ka2, tr = function(Fu, $0) {
              if (Fu == null)
                return {};
              var G_, wC, mF = {}, SC = Object.keys(Fu);
              for (wC = 0; wC < SC.length; wC++)
                G_ = SC[wC], $0.indexOf(G_) >= 0 || (mF[G_] = Fu[G_]);
              return mF;
            }(xr, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), tu, Kf2 = tr.value !== void 0, yf2 = Object(jt.useRef)(null), wd2 = w1(yf2, kr), Ys = Object(jt.useRef)(0), Qp = Object(jt.useRef)(), dv = function() {
              var Fu = yf2.current, $0 = Rn && Qp.current ? Qp.current : function(SC) {
                var pw = window.getComputedStyle(SC);
                if (pw === null)
                  return null;
                var BA, Sy = (BA = pw, po.reduce(function(zA, FE) {
                  return zA[FE] = BA[FE], zA;
                }, {})), H_ = Sy.boxSizing;
                return H_ === "" ? null : (ia2 && H_ === "border-box" && (Sy.width = parseFloat(Sy.width) + parseFloat(Sy.borderRightWidth) + parseFloat(Sy.borderLeftWidth) + parseFloat(Sy.paddingRight) + parseFloat(Sy.paddingLeft) + "px"), { sizingStyle: Sy, paddingSize: parseFloat(Sy.paddingBottom) + parseFloat(Sy.paddingTop), borderSize: parseFloat(Sy.borderBottomWidth) + parseFloat(Sy.borderTopWidth) });
              }(Fu);
              if ($0) {
                Qp.current = $0;
                var G_ = function(SC, pw, BA, Sy) {
                  BA === void 0 && (BA = 1), Sy === void 0 && (Sy = 1 / 0), hv || ((hv = document.createElement("textarea")).setAttribute("tab-index", "-1"), hv.setAttribute("aria-hidden", "true"), Lv(hv)), hv.parentNode === null && document.body.appendChild(hv);
                  var H_ = SC.paddingSize, zA = SC.borderSize, FE = SC.sizingStyle, WO = FE.boxSizing;
                  Object.keys(FE).forEach(function(zE) {
                    var yP = zE;
                    hv.style[yP] = FE[yP];
                  }), Lv(hv), hv.value = pw;
                  var VE = function(zE, yP) {
                    var bF = zE.scrollHeight;
                    return yP.sizingStyle.boxSizing === "border-box" ? bF + yP.borderSize : bF - yP.paddingSize;
                  }(hv, SC);
                  hv.value = "x";
                  var NB = hv.scrollHeight - H_, GO = NB * BA;
                  WO === "border-box" && (GO = GO + H_ + zA), VE = Math.max(GO, VE);
                  var BE = NB * Sy;
                  return WO === "border-box" && (BE = BE + H_ + zA), [VE = Math.min(BE, VE), NB];
                }($0, Fu.value || Fu.placeholder || "x", mr, fr), wC = G_[0], mF = G_[1];
                Ys.current !== wC && (Ys.current = wC, Fu.style.setProperty("height", wC + "px", "important"), Ti2(wC, { rowHeight: mF }));
              }
            };
            return Object(jt.useLayoutEffect)(dv), tu = Zy(dv), Object(jt.useLayoutEffect)(function() {
              var Fu = function($0) {
                tu.current($0);
              };
              return window.addEventListener("resize", Fu), function() {
                window.removeEventListener("resize", Fu);
              };
            }, []), Object(jt.createElement)("textarea", Uh2({}, tr, { onChange: function(Fu) {
              Kf2 || dv(), to(Fu);
            }, ref: wd2 }));
          }, mo = Object(jt.forwardRef)(Ji2);
          function zs(xr) {
            xr = xr.trim();
            try {
              if ((xr = JSON.stringify(JSON.parse(xr)))[0] === "[")
                return Jl("array", JSON.parse(xr));
              if (xr[0] === "{")
                return Jl("object", JSON.parse(xr));
              if (xr.match(/\-?\d+\.\d+/) && xr.match(/\-?\d+\.\d+/)[0] === xr)
                return Jl("float", parseFloat(xr));
              if (xr.match(/\-?\d+e-\d+/) && xr.match(/\-?\d+e-\d+/)[0] === xr)
                return Jl("float", Number(xr));
              if (xr.match(/\-?\d+/) && xr.match(/\-?\d+/)[0] === xr)
                return Jl("integer", parseInt(xr));
              if (xr.match(/\-?\d+e\+\d+/) && xr.match(/\-?\d+e\+\d+/)[0] === xr)
                return Jl("integer", Number(xr));
            } catch {
            }
            switch (xr = xr.toLowerCase()) {
              case "undefined":
                return Jl("undefined", void 0);
              case "nan":
                return Jl("nan", NaN);
              case "null":
                return Jl("null", null);
              case "true":
                return Jl("boolean", true);
              case "false":
                return Jl("boolean", false);
              default:
                if (xr = Date.parse(xr))
                  return Jl("date", new Date(xr));
            }
            return Jl(false, null);
          }
          function Jl(xr, kr) {
            return { type: xr, value: kr };
          }
          var gf2 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
            } }]), Rn;
          }(Rt.a.PureComponent), vf2 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
            } }]), Rn;
          }(Rt.a.PureComponent), Xp = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]), to = qh2(mr).style;
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", { fill: to.color, width: to.height, height: to.width, style: to, viewBox: "0 0 1792 1792" }, Rt.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), Rn;
          }(Rt.a.PureComponent), pv = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]), to = qh2(mr).style;
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", { fill: to.color, width: to.height, height: to.width, style: to, viewBox: "0 0 1792 1792" }, Rt.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), Rn;
          }(Rt.a.PureComponent), vg2 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", { style: L(L({}, qh2(mr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Rt.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
            } }]), Rn;
          }(Rt.a.PureComponent), Z0 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", { style: L(L({}, qh2(mr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Rt.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
            } }]), Rn;
          }(Rt.a.PureComponent), yg2 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("g", null, Rt.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
            } }]), Rn;
          }(Rt.a.PureComponent), Cb2 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("g", null, Rt.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), Rn;
          }(Rt.a.PureComponent), z_ = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("g", null, Rt.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), Rn;
          }(Rt.a.PureComponent), tM = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("g", null, Rt.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
            } }]), Rn;
          }(Rt.a.PureComponent), j_ = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("g", null, Rt.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
            } }]), Rn;
          }(Rt.a.PureComponent), i0 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.style, qi2 = Me2(fr, ["style"]);
              return Rt.a.createElement("span", qi2, Rt.a.createElement("svg", Object.assign({}, qh2(mr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Rt.a.createElement("g", null, Rt.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), Rn;
          }(Rt.a.PureComponent);
          function qh2(xr) {
            return xr || (xr = {}), { style: L(L({ verticalAlign: "middle" }, xr), {}, { color: xr.color ? xr.color : "#000000", height: "1em", width: "1em" }) };
          }
          var wy = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              return F3(this, Rn), (mr = kr.call(this, fr)).copiedTimer = null, mr.handleCopy = function() {
                var qi2 = document.createElement("textarea"), to = mr.props, ka2 = to.clickCallback, Ti2 = to.src, tr = to.namespace;
                qi2.innerHTML = JSON.stringify(mr.clipboardValue(Ti2), null, "  "), document.body.appendChild(qi2), qi2.select(), document.execCommand("copy"), document.body.removeChild(qi2), mr.copiedTimer = setTimeout(function() {
                  mr.setState({ copied: false });
                }, 5500), mr.setState({ copied: true }, function() {
                  typeof ka2 == "function" && ka2({ src: Ti2, namespace: tr, name: tr[tr.length - 1] });
                });
              }, mr.getClippyIcon = function() {
                var qi2 = mr.props.theme;
                return mr.state.copied ? Rt.a.createElement("span", null, Rt.a.createElement(yg2, Object.assign({ className: "copy-icon" }, mn(qi2, "copy-icon"))), Rt.a.createElement("span", mn(qi2, "copy-icon-copied"), "\u2714")) : Rt.a.createElement(yg2, Object.assign({ className: "copy-icon" }, mn(qi2, "copy-icon")));
              }, mr.clipboardValue = function(qi2) {
                switch (Pe2(qi2)) {
                  case "function":
                  case "regexp":
                    return qi2.toString();
                  default:
                    return qi2;
                }
              }, mr.state = { copied: false }, mr;
            }
            return U3(Rn, [{ key: "componentWillUnmount", value: function() {
              this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
            } }, { key: "render", value: function() {
              var fr = this.props, mr = (fr.src, fr.theme), qi2 = fr.hidden, to = fr.rowHovered, ka2 = mn(mr, "copy-to-clipboard").style, Ti2 = "inline";
              return qi2 && (Ti2 = "none"), Rt.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: to ? "inline-block" : "none" } }, Rt.a.createElement("span", { style: L(L({}, ka2), {}, { display: Ti2 }), onClick: this.handleCopy }, this.getClippyIcon()));
            } }]), Rn;
          }(Rt.a.PureComponent), S1 = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              return F3(this, Rn), (mr = kr.call(this, fr)).getEditIcon = function() {
                var qi2 = mr.props, to = qi2.variable, ka2 = qi2.theme;
                return Rt.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: mr.state.hovered ? "inline-block" : "none" } }, Rt.a.createElement(j_, Object.assign({ className: "click-to-edit-icon" }, mn(ka2, "editVarIcon"), { onClick: function() {
                  mr.prepopInput(to);
                } })));
              }, mr.prepopInput = function(qi2) {
                if (mr.props.onEdit !== false) {
                  var to = function(Ti2) {
                    var tr;
                    switch (Pe2(Ti2)) {
                      case "undefined":
                        tr = "undefined";
                        break;
                      case "nan":
                        tr = "NaN";
                        break;
                      case "string":
                        tr = Ti2;
                        break;
                      case "date":
                      case "function":
                      case "regexp":
                        tr = Ti2.toString();
                        break;
                      default:
                        try {
                          tr = JSON.stringify(Ti2, null, "  ");
                        } catch {
                          tr = "";
                        }
                    }
                    return tr;
                  }(qi2.value), ka2 = zs(to);
                  mr.setState({ editMode: true, editValue: to, parsedInput: { type: ka2.type, value: ka2.value } });
                }
              }, mr.getRemoveIcon = function() {
                var qi2 = mr.props, to = qi2.variable, ka2 = qi2.namespace, Ti2 = qi2.theme, tr = qi2.rjvId;
                return Rt.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: mr.state.hovered ? "inline-block" : "none" } }, Rt.a.createElement(Cb2, Object.assign({ className: "click-to-remove-icon" }, mn(Ti2, "removeVarIcon"), { onClick: function() {
                  Qs.dispatch({ name: "VARIABLE_REMOVED", rjvId: tr, data: { name: to.name, namespace: ka2, existing_value: to.value, variable_removed: true } });
                } })));
              }, mr.getValue = function(qi2, to) {
                var ka2 = !to && qi2.type, Ti2 = vt(mr).props;
                switch (ka2) {
                  case false:
                    return mr.getEditInput();
                  case "string":
                    return Rt.a.createElement(lu, Object.assign({ value: qi2.value }, Ti2));
                  case "integer":
                    return Rt.a.createElement(Fl, Object.assign({ value: qi2.value }, Ti2));
                  case "float":
                    return Rt.a.createElement(Cr, Object.assign({ value: qi2.value }, Ti2));
                  case "boolean":
                    return Rt.a.createElement(Kn, Object.assign({ value: qi2.value }, Ti2));
                  case "function":
                    return Rt.a.createElement(Gs, Object.assign({ value: qi2.value }, Ti2));
                  case "null":
                    return Rt.a.createElement(_s, Ti2);
                  case "nan":
                    return Rt.a.createElement(al, Ti2);
                  case "undefined":
                    return Rt.a.createElement(ah2, Ti2);
                  case "date":
                    return Rt.a.createElement(ar, Object.assign({ value: qi2.value }, Ti2));
                  case "regexp":
                    return Rt.a.createElement(Ih2, Object.assign({ value: qi2.value }, Ti2));
                  default:
                    return Rt.a.createElement("div", { className: "object-value" }, JSON.stringify(qi2.value));
                }
              }, mr.getEditInput = function() {
                var qi2 = mr.props.theme, to = mr.state.editValue;
                return Rt.a.createElement("div", null, Rt.a.createElement(mo, Object.assign({ type: "text", inputRef: function(ka2) {
                  return ka2 && ka2.focus();
                }, value: to, className: "variable-editor", onChange: function(ka2) {
                  var Ti2 = ka2.target.value, tr = zs(Ti2);
                  mr.setState({ editValue: Ti2, parsedInput: { type: tr.type, value: tr.value } });
                }, onKeyDown: function(ka2) {
                  switch (ka2.key) {
                    case "Escape":
                      mr.setState({ editMode: false, editValue: "" });
                      break;
                    case "Enter":
                      (ka2.ctrlKey || ka2.metaKey) && mr.submitEdit(true);
                  }
                  ka2.stopPropagation();
                }, placeholder: "update this value", minRows: 2 }, mn(qi2, "edit-input"))), Rt.a.createElement("div", mn(qi2, "edit-icon-container"), Rt.a.createElement(Cb2, Object.assign({ className: "edit-cancel" }, mn(qi2, "cancel-icon"), { onClick: function() {
                  mr.setState({ editMode: false, editValue: "" });
                } })), Rt.a.createElement(i0, Object.assign({ className: "edit-check string-value" }, mn(qi2, "check-icon"), { onClick: function() {
                  mr.submitEdit();
                } })), Rt.a.createElement("div", null, mr.showDetected())));
              }, mr.submitEdit = function(qi2) {
                var to = mr.props, ka2 = to.variable, Ti2 = to.namespace, tr = to.rjvId, tu = mr.state, Kf2 = tu.editValue, yf2 = tu.parsedInput, wd2 = Kf2;
                qi2 && yf2.type && (wd2 = yf2.value), mr.setState({ editMode: false }), Qs.dispatch({ name: "VARIABLE_UPDATED", rjvId: tr, data: { name: ka2.name, namespace: Ti2, existing_value: ka2.value, new_value: wd2, variable_removed: false } });
              }, mr.showDetected = function() {
                var qi2 = mr.props, to = qi2.theme, ka2 = (qi2.variable, qi2.namespace, qi2.rjvId, mr.state.parsedInput), Ti2 = (ka2.type, ka2.value, mr.getDetectedInput());
                if (Ti2)
                  return Rt.a.createElement("div", null, Rt.a.createElement("div", mn(to, "detected-row"), Ti2, Rt.a.createElement(i0, { className: "edit-check detected", style: L({ verticalAlign: "top", paddingLeft: "3px" }, mn(to, "check-icon").style), onClick: function() {
                    mr.submitEdit(true);
                  } })));
              }, mr.getDetectedInput = function() {
                var qi2 = mr.state.parsedInput, to = qi2.type, ka2 = qi2.value, Ti2 = vt(mr).props, tr = Ti2.theme;
                if (to !== false)
                  switch (to.toLowerCase()) {
                    case "object":
                      return Rt.a.createElement("span", null, Rt.a.createElement("span", { style: L(L({}, mn(tr, "brace").style), {}, { cursor: "default" }) }, "{"), Rt.a.createElement("span", { style: L(L({}, mn(tr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Rt.a.createElement("span", { style: L(L({}, mn(tr, "brace").style), {}, { cursor: "default" }) }, "}"));
                    case "array":
                      return Rt.a.createElement("span", null, Rt.a.createElement("span", { style: L(L({}, mn(tr, "brace").style), {}, { cursor: "default" }) }, "["), Rt.a.createElement("span", { style: L(L({}, mn(tr, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Rt.a.createElement("span", { style: L(L({}, mn(tr, "brace").style), {}, { cursor: "default" }) }, "]"));
                    case "string":
                      return Rt.a.createElement(lu, Object.assign({ value: ka2 }, Ti2));
                    case "integer":
                      return Rt.a.createElement(Fl, Object.assign({ value: ka2 }, Ti2));
                    case "float":
                      return Rt.a.createElement(Cr, Object.assign({ value: ka2 }, Ti2));
                    case "boolean":
                      return Rt.a.createElement(Kn, Object.assign({ value: ka2 }, Ti2));
                    case "function":
                      return Rt.a.createElement(Gs, Object.assign({ value: ka2 }, Ti2));
                    case "null":
                      return Rt.a.createElement(_s, Ti2);
                    case "nan":
                      return Rt.a.createElement(al, Ti2);
                    case "undefined":
                      return Rt.a.createElement(ah2, Ti2);
                    case "date":
                      return Rt.a.createElement(ar, Object.assign({ value: new Date(ka2) }, Ti2));
                  }
              }, mr.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, mr;
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this, mr = this.props, qi2 = mr.variable, to = mr.singleIndent, ka2 = mr.type, Ti2 = mr.theme, tr = mr.namespace, tu = mr.indentWidth, Kf2 = mr.enableClipboard, yf2 = mr.onEdit, wd2 = mr.onDelete, Ys = mr.onSelect, Qp = mr.displayArrayKey, dv = mr.quotesOnKeys, Fu = this.state.editMode;
              return Rt.a.createElement("div", Object.assign({}, mn(Ti2, "objectKeyVal", { paddingLeft: tu * to }), { onMouseEnter: function() {
                return fr.setState(L(L({}, fr.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return fr.setState(L(L({}, fr.state), {}, { hovered: false }));
              }, className: "variable-row", key: qi2.name }), ka2 == "array" ? Qp ? Rt.a.createElement("span", Object.assign({}, mn(Ti2, "array-key"), { key: qi2.name + "_" + tr }), qi2.name, Rt.a.createElement("div", mn(Ti2, "colon"), ":")) : null : Rt.a.createElement("span", null, Rt.a.createElement("span", Object.assign({}, mn(Ti2, "object-name"), { className: "object-key", key: qi2.name + "_" + tr }), !!dv && Rt.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Rt.a.createElement("span", { style: { display: "inline-block" } }, qi2.name), !!dv && Rt.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Rt.a.createElement("span", mn(Ti2, "colon"), ":")), Rt.a.createElement("div", Object.assign({ className: "variable-value", onClick: Ys === false && yf2 === false ? null : function($0) {
                var G_ = Ss(tr);
                ($0.ctrlKey || $0.metaKey) && yf2 !== false ? fr.prepopInput(qi2) : Ys !== false && (G_.shift(), Ys(L(L({}, qi2), {}, { namespace: G_ })));
              } }, mn(Ti2, "variableValue", { cursor: Ys === false ? "default" : "pointer" })), this.getValue(qi2, Fu)), Kf2 ? Rt.a.createElement(wy, { rowHovered: this.state.hovered, hidden: Fu, src: qi2.value, clickCallback: Kf2, theme: Ti2, namespace: [].concat(Ss(tr), [qi2.name]) }) : null, yf2 !== false && Fu == 0 ? this.getEditIcon() : null, wd2 !== false && Fu == 0 ? this.getRemoveIcon() : null);
            } }]), Rn;
          }(Rt.a.PureComponent), eM = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              var fr;
              F3(this, Rn);
              for (var mr = arguments.length, qi2 = new Array(mr), to = 0; to < mr; to++)
                qi2[to] = arguments[to];
              return (fr = kr.call.apply(kr, [this].concat(qi2))).getObjectSize = function() {
                var ka2 = fr.props, Ti2 = ka2.size, tr = ka2.theme;
                if (ka2.displayObjectSize)
                  return Rt.a.createElement("span", Object.assign({ className: "object-size" }, mn(tr, "object-size")), Ti2, " item", Ti2 === 1 ? "" : "s");
              }, fr.getAddAttribute = function(ka2) {
                var Ti2 = fr.props, tr = Ti2.theme, tu = Ti2.namespace, Kf2 = Ti2.name, yf2 = Ti2.src, wd2 = Ti2.rjvId, Ys = Ti2.depth;
                return Rt.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: ka2 ? "inline-block" : "none" } }, Rt.a.createElement(z_, Object.assign({ className: "click-to-add-icon" }, mn(tr, "addVarIcon"), { onClick: function() {
                  var Qp = { name: Ys > 0 ? Kf2 : null, namespace: tu.splice(0, tu.length - 1), existing_value: yf2, variable_removed: false, key_name: null };
                  Pe2(yf2) === "object" ? Qs.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: wd2, data: Qp }) : Qs.dispatch({ name: "VARIABLE_ADDED", rjvId: wd2, data: L(L({}, Qp), {}, { new_value: [].concat(Ss(yf2), [null]) }) });
                } })));
              }, fr.getRemoveObject = function(ka2) {
                var Ti2 = fr.props, tr = Ti2.theme, tu = (Ti2.hover, Ti2.namespace), Kf2 = Ti2.name, yf2 = Ti2.src, wd2 = Ti2.rjvId;
                if (tu.length !== 1)
                  return Rt.a.createElement("span", { className: "click-to-remove", style: { display: ka2 ? "inline-block" : "none" } }, Rt.a.createElement(Cb2, Object.assign({ className: "click-to-remove-icon" }, mn(tr, "removeVarIcon"), { onClick: function() {
                    Qs.dispatch({ name: "VARIABLE_REMOVED", rjvId: wd2, data: { name: Kf2, namespace: tu.splice(0, tu.length - 1), existing_value: yf2, variable_removed: true } });
                  } })));
              }, fr.render = function() {
                var ka2 = fr.props, Ti2 = ka2.theme, tr = ka2.onDelete, tu = ka2.onAdd, Kf2 = ka2.enableClipboard, yf2 = ka2.src, wd2 = ka2.namespace, Ys = ka2.rowHovered;
                return Rt.a.createElement("div", Object.assign({}, mn(Ti2, "object-meta-data"), { className: "object-meta-data", onClick: function(Qp) {
                  Qp.stopPropagation();
                } }), fr.getObjectSize(), Kf2 ? Rt.a.createElement(wy, { rowHovered: Ys, clickCallback: Kf2, src: yf2, theme: Ti2, namespace: wd2 }) : null, tu !== false ? fr.getAddAttribute(Ys) : null, tr !== false ? fr.getRemoveObject(Ys) : null);
              }, fr;
            }
            return Rn;
          }(Rt.a.PureComponent);
          function hw(xr) {
            var kr = xr.parent_type, Rn = xr.namespace, fr = xr.quotesOnKeys, mr = xr.theme, qi2 = xr.jsvRoot, to = xr.name, ka2 = xr.displayArrayKey, Ti2 = xr.name ? xr.name : "";
            return !qi2 || to !== false && to !== null ? kr == "array" ? ka2 ? Rt.a.createElement("span", Object.assign({}, mn(mr, "array-key"), { key: Rn }), Rt.a.createElement("span", { className: "array-key" }, Ti2), Rt.a.createElement("span", mn(mr, "colon"), ":")) : Rt.a.createElement("span", null) : Rt.a.createElement("span", Object.assign({}, mn(mr, "object-name"), { key: Rn }), Rt.a.createElement("span", { className: "object-key" }, fr && Rt.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Rt.a.createElement("span", null, Ti2), fr && Rt.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Rt.a.createElement("span", mn(mr, "colon"), ":")) : Rt.a.createElement("span", null);
          }
          function W_(xr) {
            var kr = xr.theme;
            switch (xr.iconStyle) {
              case "triangle":
                return Rt.a.createElement(Z0, Object.assign({}, mn(kr, "expanded-icon"), { className: "expanded-icon" }));
              case "square":
                return Rt.a.createElement(Xp, Object.assign({}, mn(kr, "expanded-icon"), { className: "expanded-icon" }));
              default:
                return Rt.a.createElement(gf2, Object.assign({}, mn(kr, "expanded-icon"), { className: "expanded-icon" }));
            }
          }
          function GS(xr) {
            var kr = xr.theme;
            switch (xr.iconStyle) {
              case "triangle":
                return Rt.a.createElement(vg2, Object.assign({}, mn(kr, "collapsed-icon"), { className: "collapsed-icon" }));
              case "square":
                return Rt.a.createElement(pv, Object.assign({}, mn(kr, "collapsed-icon"), { className: "collapsed-icon" }));
              default:
                return Rt.a.createElement(vf2, Object.assign({}, mn(kr, "collapsed-icon"), { className: "collapsed-icon" }));
            }
          }
          var vP = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              return F3(this, Rn), (mr = kr.call(this, fr)).toggleCollapsed = function(qi2) {
                var to = [];
                for (var ka2 in mr.state.expanded)
                  to.push(mr.state.expanded[ka2]);
                to[qi2] = !to[qi2], mr.setState({ expanded: to });
              }, mr.state = { expanded: [] }, mr;
            }
            return U3(Rn, [{ key: "getExpandedIcon", value: function(fr) {
              var mr = this.props, qi2 = mr.theme, to = mr.iconStyle;
              return this.state.expanded[fr] ? Rt.a.createElement(W_, { theme: qi2, iconStyle: to }) : Rt.a.createElement(GS, { theme: qi2, iconStyle: to });
            } }, { key: "render", value: function() {
              var fr = this, mr = this.props, qi2 = mr.src, to = mr.groupArraysAfterLength, ka2 = (mr.depth, mr.name), Ti2 = mr.theme, tr = mr.jsvRoot, tu = mr.namespace, Kf2 = (mr.parent_type, Me2(mr, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), yf2 = 0, wd2 = 5 * this.props.indentWidth;
              tr || (yf2 = 5 * this.props.indentWidth);
              var Ys = to, Qp = Math.ceil(qi2.length / Ys);
              return Rt.a.createElement("div", Object.assign({ className: "object-key-val" }, mn(Ti2, tr ? "jsv-root" : "objectKeyVal", { paddingLeft: yf2 })), Rt.a.createElement(hw, this.props), Rt.a.createElement("span", null, Rt.a.createElement(eM, Object.assign({ size: qi2.length }, this.props))), Ss(Array(Qp)).map(function(dv, Fu) {
                return Rt.a.createElement("div", Object.assign({ key: Fu, className: "object-key-val array-group" }, mn(Ti2, "objectKeyVal", { marginLeft: 6, paddingLeft: wd2 })), Rt.a.createElement("span", mn(Ti2, "brace-row"), Rt.a.createElement("div", Object.assign({ className: "icon-container" }, mn(Ti2, "icon-container"), { onClick: function($0) {
                  fr.toggleCollapsed(Fu);
                } }), fr.getExpandedIcon(Fu)), fr.state.expanded[Fu] ? Rt.a.createElement(NE, Object.assign({ key: ka2 + Fu, depth: 0, name: false, collapsed: false, groupArraysAfterLength: Ys, index_offset: Fu * Ys, src: qi2.slice(Fu * Ys, Fu * Ys + Ys), namespace: tu, type: "array", parent_type: "array_group", theme: Ti2 }, Kf2)) : Rt.a.createElement("span", Object.assign({}, mn(Ti2, "brace"), { onClick: function($0) {
                  fr.toggleCollapsed(Fu);
                }, className: "array-group-brace" }), "[", Rt.a.createElement("div", Object.assign({}, mn(Ti2, "array-group-meta-data"), { className: "array-group-meta-data" }), Rt.a.createElement("span", Object.assign({ className: "object-size" }, mn(Ti2, "object-size")), Fu * Ys, " - ", Fu * Ys + Ys > qi2.length ? qi2.length : Fu * Ys + Ys)), "]")));
              }));
            } }]), Rn;
          }(Rt.a.PureComponent), RE = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              F3(this, Rn), (mr = kr.call(this, fr)).toggleCollapsed = function() {
                mr.setState({ expanded: !mr.state.expanded }, function() {
                  rs.set(mr.props.rjvId, mr.props.namespace, "expanded", mr.state.expanded);
                });
              }, mr.getObjectContent = function(to, ka2, Ti2) {
                return Rt.a.createElement("div", { className: "pushed-content object-container" }, Rt.a.createElement("div", Object.assign({ className: "object-content" }, mn(mr.props.theme, "pushed-content")), mr.renderObjectContents(ka2, Ti2)));
              }, mr.getEllipsis = function() {
                return mr.state.size === 0 ? null : Rt.a.createElement("div", Object.assign({}, mn(mr.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: mr.toggleCollapsed }), "...");
              }, mr.getObjectMetaData = function(to) {
                var ka2 = mr.props, Ti2 = (ka2.rjvId, ka2.theme, mr.state), tr = Ti2.size, tu = Ti2.hovered;
                return Rt.a.createElement(eM, Object.assign({ rowHovered: tu, size: tr }, mr.props));
              }, mr.renderObjectContents = function(to, ka2) {
                var Ti2, tr = mr.props, tu = tr.depth, Kf2 = tr.parent_type, yf2 = tr.index_offset, wd2 = tr.groupArraysAfterLength, Ys = tr.namespace, Qp = mr.state.object_type, dv = [], Fu = Object.keys(to || {});
                return mr.props.sortKeys && Qp !== "array" && (Fu = Fu.sort()), Fu.forEach(function($0) {
                  if (Ti2 = new RB($0, to[$0]), Kf2 === "array_group" && yf2 && (Ti2.name = parseInt(Ti2.name) + yf2), to.hasOwnProperty($0))
                    if (Ti2.type === "object")
                      dv.push(Rt.a.createElement(NE, Object.assign({ key: Ti2.name, depth: tu + 1, name: Ti2.name, src: Ti2.value, namespace: Ys.concat(Ti2.name), parent_type: Qp }, ka2)));
                    else if (Ti2.type === "array") {
                      var G_ = NE;
                      wd2 && Ti2.value.length > wd2 && (G_ = vP), dv.push(Rt.a.createElement(G_, Object.assign({ key: Ti2.name, depth: tu + 1, name: Ti2.name, src: Ti2.value, namespace: Ys.concat(Ti2.name), type: "array", parent_type: Qp }, ka2)));
                    } else
                      dv.push(Rt.a.createElement(S1, Object.assign({ key: Ti2.name + "_" + Ys, variable: Ti2, singleIndent: 5, namespace: Ys, type: mr.props.type }, ka2)));
                }), dv;
              };
              var qi2 = Rn.getState(fr);
              return mr.state = L(L({}, qi2), {}, { prevProps: {} }), mr;
            }
            return U3(Rn, [{ key: "getBraceStart", value: function(fr, mr) {
              var qi2 = this, to = this.props, ka2 = to.src, Ti2 = to.theme, tr = to.iconStyle;
              if (to.parent_type === "array_group")
                return Rt.a.createElement("span", null, Rt.a.createElement("span", mn(Ti2, "brace"), fr === "array" ? "[" : "{"), mr ? this.getObjectMetaData(ka2) : null);
              var tu = mr ? W_ : GS;
              return Rt.a.createElement("span", null, Rt.a.createElement("span", Object.assign({ onClick: function(Kf2) {
                qi2.toggleCollapsed();
              } }, mn(Ti2, "brace-row")), Rt.a.createElement("div", Object.assign({ className: "icon-container" }, mn(Ti2, "icon-container")), Rt.a.createElement(tu, { theme: Ti2, iconStyle: tr })), Rt.a.createElement(hw, this.props), Rt.a.createElement("span", mn(Ti2, "brace"), fr === "array" ? "[" : "{")), mr ? this.getObjectMetaData(ka2) : null);
            } }, { key: "render", value: function() {
              var fr = this, mr = this.props, qi2 = mr.depth, to = mr.src, ka2 = (mr.namespace, mr.name, mr.type, mr.parent_type), Ti2 = mr.theme, tr = mr.jsvRoot, tu = mr.iconStyle, Kf2 = Me2(mr, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), yf2 = this.state, wd2 = yf2.object_type, Ys = yf2.expanded, Qp = {};
              return tr || ka2 === "array_group" ? ka2 === "array_group" && (Qp.borderLeft = 0, Qp.display = "inline") : Qp.paddingLeft = 5 * this.props.indentWidth, Rt.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                return fr.setState(L(L({}, fr.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return fr.setState(L(L({}, fr.state), {}, { hovered: false }));
              } }, mn(Ti2, tr ? "jsv-root" : "objectKeyVal", Qp)), this.getBraceStart(wd2, Ys), Ys ? this.getObjectContent(qi2, to, L({ theme: Ti2, iconStyle: tu }, Kf2)) : this.getEllipsis(), Rt.a.createElement("span", { className: "brace-row" }, Rt.a.createElement("span", { style: L(L({}, mn(Ti2, "brace").style), {}, { paddingLeft: Ys ? "3px" : "0px" }) }, wd2 === "array" ? "]" : "}"), Ys ? null : this.getObjectMetaData(to)));
            } }], [{ key: "getDerivedStateFromProps", value: function(fr, mr) {
              var qi2 = mr.prevProps;
              return fr.src !== qi2.src || fr.collapsed !== qi2.collapsed || fr.name !== qi2.name || fr.namespace !== qi2.namespace || fr.rjvId !== qi2.rjvId ? L(L({}, Rn.getState(fr)), {}, { prevProps: fr }) : null;
            } }]), Rn;
          }(Rt.a.PureComponent);
          RE.getState = function(xr) {
            var kr = Object.keys(xr.src).length, Rn = (xr.collapsed === false || xr.collapsed !== true && xr.collapsed > xr.depth) && (!xr.shouldCollapse || xr.shouldCollapse({ name: xr.name, src: xr.src, type: Pe2(xr.src), namespace: xr.namespace }) === false) && kr !== 0;
            return { expanded: rs.get(xr.rjvId, xr.namespace, "expanded", Rn), object_type: xr.type === "array" ? "array" : "object", parent_type: xr.type === "array" ? "array" : "object", size: kr, hovered: false };
          };
          var RB = function xr(kr, Rn) {
            F3(this, xr), this.name = kr, this.value = Rn, this.type = Pe2(Rn);
          };
          _e(RE);
          var NE = RE, Pit = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              var fr;
              F3(this, Rn);
              for (var mr = arguments.length, qi2 = new Array(mr), to = 0; to < mr; to++)
                qi2[to] = arguments[to];
              return (fr = kr.call.apply(kr, [this].concat(qi2))).render = function() {
                var ka2 = vt(fr).props, Ti2 = [ka2.name], tr = NE;
                return Array.isArray(ka2.src) && ka2.groupArraysAfterLength && ka2.src.length > ka2.groupArraysAfterLength && (tr = vP), Rt.a.createElement("div", { className: "pretty-json-container object-container" }, Rt.a.createElement("div", { className: "object-content" }, Rt.a.createElement(tr, Object.assign({ namespace: Ti2, depth: 0, jsvRoot: true }, ka2))));
              }, fr;
            }
            return Rn;
          }(Rt.a.PureComponent), Lit = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              return F3(this, Rn), (mr = kr.call(this, fr)).closeModal = function() {
                Qs.dispatch({ rjvId: mr.props.rjvId, name: "RESET" });
              }, mr.submit = function() {
                mr.props.submit(mr.state.input);
              }, mr.state = { input: fr.input ? fr.input : "" }, mr;
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this, mr = this.props, qi2 = mr.theme, to = mr.rjvId, ka2 = mr.isValid, Ti2 = this.state.input, tr = ka2(Ti2);
              return Rt.a.createElement("div", Object.assign({ className: "key-modal-request" }, mn(qi2, "key-modal-request"), { onClick: this.closeModal }), Rt.a.createElement("div", Object.assign({}, mn(qi2, "key-modal"), { onClick: function(tu) {
                tu.stopPropagation();
              } }), Rt.a.createElement("div", mn(qi2, "key-modal-label"), "Key Name:"), Rt.a.createElement("div", { style: { position: "relative" } }, Rt.a.createElement("input", Object.assign({}, mn(qi2, "key-modal-input"), { className: "key-modal-input", ref: function(tu) {
                return tu && tu.focus();
              }, spellCheck: false, value: Ti2, placeholder: "...", onChange: function(tu) {
                fr.setState({ input: tu.target.value });
              }, onKeyPress: function(tu) {
                tr && tu.key === "Enter" ? fr.submit() : tu.key === "Escape" && fr.closeModal();
              } })), tr ? Rt.a.createElement(i0, Object.assign({}, mn(qi2, "key-modal-submit"), { className: "key-modal-submit", onClick: function(tu) {
                return fr.submit();
              } })) : null), Rt.a.createElement("span", mn(qi2, "key-modal-cancel"), Rt.a.createElement(tM, Object.assign({}, mn(qi2, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                Qs.dispatch({ rjvId: to, name: "RESET" });
              } })))));
            } }]), Rn;
          }(Rt.a.PureComponent), Oit = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              var fr;
              F3(this, Rn);
              for (var mr = arguments.length, qi2 = new Array(mr), to = 0; to < mr; to++)
                qi2[to] = arguments[to];
              return (fr = kr.call.apply(kr, [this].concat(qi2))).isValid = function(ka2) {
                var Ti2 = fr.props.rjvId, tr = rs.get(Ti2, "action", "new-key-request");
                return ka2 != "" && Object.keys(tr.existing_value).indexOf(ka2) === -1;
              }, fr.submit = function(ka2) {
                var Ti2 = fr.props.rjvId, tr = rs.get(Ti2, "action", "new-key-request");
                tr.new_value = L({}, tr.existing_value), tr.new_value[ka2] = fr.props.defaultValue, Qs.dispatch({ name: "VARIABLE_ADDED", rjvId: Ti2, data: tr });
              }, fr;
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.active, qi2 = fr.theme, to = fr.rjvId;
              return mr ? Rt.a.createElement(Lit, { rjvId: to, theme: qi2, isValid: this.isValid, submit: this.submit }) : null;
            } }]), Rn;
          }(Rt.a.PureComponent), Rit = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn() {
              return F3(this, Rn), kr.apply(this, arguments);
            }
            return U3(Rn, [{ key: "render", value: function() {
              var fr = this.props, mr = fr.message, qi2 = fr.active, to = fr.theme, ka2 = fr.rjvId;
              return qi2 ? Rt.a.createElement("div", Object.assign({ className: "validation-failure" }, mn(to, "validation-failure"), { onClick: function() {
                Qs.dispatch({ rjvId: ka2, name: "RESET" });
              } }), Rt.a.createElement("span", mn(to, "validation-failure-label"), mr), Rt.a.createElement(tM, mn(to, "validation-failure-clear"))) : null;
            } }]), Rn;
          }(Rt.a.PureComponent), yF = function(xr) {
            Q(Rn, xr);
            var kr = Pt(Rn);
            function Rn(fr) {
              var mr;
              return F3(this, Rn), (mr = kr.call(this, fr)).rjvId = Date.now().toString(), mr.getListeners = function() {
                return { reset: mr.resetState, "variable-update": mr.updateSrc, "add-key-request": mr.addKeyRequest };
              }, mr.updateSrc = function() {
                var qi2, to = rs.get(mr.rjvId, "action", "variable-update"), ka2 = to.name, Ti2 = to.namespace, tr = to.new_value, tu = to.existing_value, Kf2 = (to.variable_removed, to.updated_src), yf2 = to.type, wd2 = mr.props, Ys = wd2.onEdit, Qp = wd2.onDelete, dv = wd2.onAdd, Fu = { existing_src: mr.state.src, new_value: tr, updated_src: Kf2, name: ka2, namespace: Ti2, existing_value: tu };
                switch (yf2) {
                  case "variable-added":
                    qi2 = dv(Fu);
                    break;
                  case "variable-edited":
                    qi2 = Ys(Fu);
                    break;
                  case "variable-removed":
                    qi2 = Qp(Fu);
                }
                qi2 !== false ? (rs.set(mr.rjvId, "global", "src", Kf2), mr.setState({ src: Kf2 })) : mr.setState({ validationFailure: true });
              }, mr.addKeyRequest = function() {
                mr.setState({ addKeyRequest: true });
              }, mr.resetState = function() {
                mr.setState({ validationFailure: false, addKeyRequest: false });
              }, mr.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Rn.defaultProps.src, name: Rn.defaultProps.name, theme: Rn.defaultProps.theme, validationMessage: Rn.defaultProps.validationMessage, prevSrc: Rn.defaultProps.src, prevName: Rn.defaultProps.name, prevTheme: Rn.defaultProps.theme }, mr;
            }
            return U3(Rn, [{ key: "componentDidMount", value: function() {
              rs.set(this.rjvId, "global", "src", this.state.src);
              var fr = this.getListeners();
              for (var mr in fr)
                rs.on(mr + "-" + this.rjvId, fr[mr]);
              this.setState({ addKeyRequest: false, editKeyRequest: false });
            } }, { key: "componentDidUpdate", value: function(fr, mr) {
              mr.addKeyRequest !== false && this.setState({ addKeyRequest: false }), mr.editKeyRequest !== false && this.setState({ editKeyRequest: false }), fr.src !== this.state.src && rs.set(this.rjvId, "global", "src", this.state.src);
            } }, { key: "componentWillUnmount", value: function() {
              var fr = this.getListeners();
              for (var mr in fr)
                rs.removeListener(mr + "-" + this.rjvId, fr[mr]);
            } }, { key: "render", value: function() {
              var fr = this.state, mr = fr.validationFailure, qi2 = fr.validationMessage, to = fr.addKeyRequest, ka2 = fr.theme, Ti2 = fr.src, tr = fr.name, tu = this.props, Kf2 = tu.style, yf2 = tu.defaultValue;
              return Rt.a.createElement("div", { className: "react-json-view", style: L(L({}, mn(ka2, "app-container").style), Kf2) }, Rt.a.createElement(Rit, { message: qi2, active: mr, theme: ka2, rjvId: this.rjvId }), Rt.a.createElement(Pit, Object.assign({}, this.props, { src: Ti2, name: tr, theme: ka2, type: Pe2(Ti2), rjvId: this.rjvId })), Rt.a.createElement(Oit, { active: to, theme: ka2, rjvId: this.rjvId, defaultValue: yf2 }));
            } }], [{ key: "getDerivedStateFromProps", value: function(fr, mr) {
              if (fr.src !== mr.prevSrc || fr.name !== mr.prevName || fr.theme !== mr.prevTheme) {
                var qi2 = { src: fr.src, name: fr.name, theme: fr.theme, validationMessage: fr.validationMessage, prevSrc: fr.src, prevName: fr.name, prevTheme: fr.theme };
                return Rn.validateState(qi2);
              }
              return null;
            } }]), Rn;
          }(Rt.a.PureComponent);
          yF.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, yF.validateState = function(xr) {
            var kr = {};
            return Pe2(xr.theme) !== "object" || function(Rn) {
              var fr = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
              if (Pe2(Rn) === "object") {
                for (var mr = 0; mr < fr.length; mr++)
                  if (!(fr[mr] in Rn))
                    return false;
                return true;
              }
              return false;
            }(xr.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), kr.theme = "rjv-default"), Pe2(xr.src) !== "object" && Pe2(xr.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), kr.name = "ERROR", kr.src = { message: "src property must be a valid json object" }), L(L({}, xr), kr);
          }, _e(yF), y2.default = yF;
        }]);
      });
    })(sve);
    var H0n = Ue2(sve.exports);
    const U0n = ({ id: l2, title: a, chart: e2, option: d2 }) => {
      const { tool: y2 } = Ude({}), x2 = S1t.useEventEmitter({ global: true }), [C, { set: D2 }] = bt(true), L = (F3) => {
        const { updated_src: j } = F3;
        e2 == null || e2.setOption(j), y2 == null || y2.add(l2, e2, j, a), x2.emit("list");
      };
      return D0n("div", { children: [PZ(R0n, { children: PZ(B0n, { children: PZ(j0n, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (F3) => {
        D2(!F3);
      } }) }) }), PZ("br", {}), d2 && PZ(H0n, { src: d2, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: C, iconStyle: "triangle", enableClipboard: true, onEdit: L, onAdd: L, onDelete: L })] });
    };
    f2.EchartTool = G0n, f2.ReactEchartsJson = U0n, f2.useEcharts = ogn, f2.useEchartsTool = Ude, f2.useEventEmitter = Hde;
  })(jZe);
  var WZe = { exports: {} };
  (function(f2, i) {
    (function(t2, h) {
      f2.exports = h(ztt.default);
    })(YD, function(t2) {
      return function(h) {
        var v4 = {};
        function _(M2) {
          if (v4[M2])
            return v4[M2].exports;
          var I2 = v4[M2] = { i: M2, l: false, exports: {} };
          return h[M2].call(I2.exports, I2, I2.exports, _), I2.l = true, I2.exports;
        }
        return _.m = h, _.c = v4, _.d = function(M2, I2, P2) {
          _.o(M2, I2) || Object.defineProperty(M2, I2, { enumerable: true, get: P2 });
        }, _.r = function(M2) {
          typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(M2, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(M2, "__esModule", { value: true });
        }, _.t = function(M2, I2) {
          if (1 & I2 && (M2 = _(M2)), 8 & I2 || 4 & I2 && typeof M2 == "object" && M2 && M2.__esModule)
            return M2;
          var P2 = /* @__PURE__ */ Object.create(null);
          if (_.r(P2), Object.defineProperty(P2, "default", { enumerable: true, value: M2 }), 2 & I2 && typeof M2 != "string")
            for (var N3 in M2)
              _.d(P2, N3, function(z3) {
                return M2[z3];
              }.bind(null, N3));
          return P2;
        }, _.n = function(M2) {
          var I2 = M2 && M2.__esModule ? function() {
            return M2.default;
          } : function() {
            return M2;
          };
          return _.d(I2, "a", I2), I2;
        }, _.o = function(M2, I2) {
          return Object.prototype.hasOwnProperty.call(M2, I2);
        }, _.p = "", _(_.s = 48);
      }([function(h, v4) {
        h.exports = t2;
      }, function(h, v4) {
        var _ = h.exports = { version: "2.6.12" };
        typeof __e == "number" && (__e = _);
      }, function(h, v4, _) {
        var M2 = _(26)("wks"), I2 = _(17), P2 = _(3).Symbol, N3 = typeof P2 == "function";
        (h.exports = function(z3) {
          return M2[z3] || (M2[z3] = N3 && P2[z3] || (N3 ? P2 : I2)("Symbol." + z3));
        }).store = M2;
      }, function(h, v4) {
        var _ = h.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
        typeof __g == "number" && (__g = _);
      }, function(h, v4, _) {
        h.exports = !_(8)(function() {
          return Object.defineProperty({}, "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(h, v4) {
        var _ = {}.hasOwnProperty;
        h.exports = function(M2, I2) {
          return _.call(M2, I2);
        };
      }, function(h, v4, _) {
        var M2 = _(7), I2 = _(16);
        h.exports = _(4) ? function(P2, N3, z3) {
          return M2.f(P2, N3, I2(1, z3));
        } : function(P2, N3, z3) {
          return P2[N3] = z3, P2;
        };
      }, function(h, v4, _) {
        var M2 = _(10), I2 = _(35), P2 = _(23), N3 = Object.defineProperty;
        v4.f = _(4) ? Object.defineProperty : function(z3, H2, $) {
          if (M2(z3), H2 = P2(H2, true), M2($), I2)
            try {
              return N3(z3, H2, $);
            } catch {
            }
          if ("get" in $ || "set" in $)
            throw TypeError("Accessors not supported!");
          return "value" in $ && (z3[H2] = $.value), z3;
        };
      }, function(h, v4) {
        h.exports = function(_) {
          try {
            return !!_();
          } catch {
            return true;
          }
        };
      }, function(h, v4, _) {
        var M2 = _(40), I2 = _(22);
        h.exports = function(P2) {
          return M2(I2(P2));
        };
      }, function(h, v4, _) {
        var M2 = _(11);
        h.exports = function(I2) {
          if (!M2(I2))
            throw TypeError(I2 + " is not an object!");
          return I2;
        };
      }, function(h, v4) {
        h.exports = function(_) {
          return typeof _ == "object" ? _ !== null : typeof _ == "function";
        };
      }, function(h, v4) {
        h.exports = {};
      }, function(h, v4, _) {
        var M2 = _(39), I2 = _(27);
        h.exports = Object.keys || function(P2) {
          return M2(P2, I2);
        };
      }, function(h, v4) {
        h.exports = true;
      }, function(h, v4, _) {
        var M2 = _(3), I2 = _(1), P2 = _(53), N3 = _(6), z3 = _(5), H2 = function($, et, at) {
          var ht, bt, _t, Et = $ & H2.F, zt = $ & H2.G, Ft = $ & H2.S, fe2 = $ & H2.P, re2 = $ & H2.B, ye = $ & H2.W, me2 = zt ? I2 : I2[et] || (I2[et] = {}), be2 = me2.prototype, Te2 = zt ? M2 : Ft ? M2[et] : (M2[et] || {}).prototype;
          for (ht in zt && (at = et), at)
            (bt = !Et && Te2 && Te2[ht] !== void 0) && z3(me2, ht) || (_t = bt ? Te2[ht] : at[ht], me2[ht] = zt && typeof Te2[ht] != "function" ? at[ht] : re2 && bt ? P2(_t, M2) : ye && Te2[ht] == _t ? function(We) {
              var en = function(Ue2, Mn, Vn) {
                if (this instanceof We) {
                  switch (arguments.length) {
                    case 0:
                      return new We();
                    case 1:
                      return new We(Ue2);
                    case 2:
                      return new We(Ue2, Mn);
                  }
                  return new We(Ue2, Mn, Vn);
                }
                return We.apply(this, arguments);
              };
              return en.prototype = We.prototype, en;
            }(_t) : fe2 && typeof _t == "function" ? P2(Function.call, _t) : _t, fe2 && ((me2.virtual || (me2.virtual = {}))[ht] = _t, $ & H2.R && be2 && !be2[ht] && N3(be2, ht, _t)));
        };
        H2.F = 1, H2.G = 2, H2.S = 4, H2.P = 8, H2.B = 16, H2.W = 32, H2.U = 64, H2.R = 128, h.exports = H2;
      }, function(h, v4) {
        h.exports = function(_, M2) {
          return { enumerable: !(1 & _), configurable: !(2 & _), writable: !(4 & _), value: M2 };
        };
      }, function(h, v4) {
        var _ = 0, M2 = Math.random();
        h.exports = function(I2) {
          return "Symbol(".concat(I2 === void 0 ? "" : I2, ")_", (++_ + M2).toString(36));
        };
      }, function(h, v4, _) {
        var M2 = _(22);
        h.exports = function(I2) {
          return Object(M2(I2));
        };
      }, function(h, v4) {
        v4.f = {}.propertyIsEnumerable;
      }, function(h, v4, _) {
        var M2 = _(52)(true);
        _(34)(String, "String", function(I2) {
          this._t = String(I2), this._i = 0;
        }, function() {
          var I2, P2 = this._t, N3 = this._i;
          return N3 >= P2.length ? { value: void 0, done: true } : (I2 = M2(P2, N3), this._i += I2.length, { value: I2, done: false });
        });
      }, function(h, v4) {
        var _ = Math.ceil, M2 = Math.floor;
        h.exports = function(I2) {
          return isNaN(I2 = +I2) ? 0 : (I2 > 0 ? M2 : _)(I2);
        };
      }, function(h, v4) {
        h.exports = function(_) {
          if (_ == null)
            throw TypeError("Can't call method on  " + _);
          return _;
        };
      }, function(h, v4, _) {
        var M2 = _(11);
        h.exports = function(I2, P2) {
          if (!M2(I2))
            return I2;
          var N3, z3;
          if (P2 && typeof (N3 = I2.toString) == "function" && !M2(z3 = N3.call(I2)) || typeof (N3 = I2.valueOf) == "function" && !M2(z3 = N3.call(I2)) || !P2 && typeof (N3 = I2.toString) == "function" && !M2(z3 = N3.call(I2)))
            return z3;
          throw TypeError("Can't convert object to primitive value");
        };
      }, function(h, v4) {
        var _ = {}.toString;
        h.exports = function(M2) {
          return _.call(M2).slice(8, -1);
        };
      }, function(h, v4, _) {
        var M2 = _(26)("keys"), I2 = _(17);
        h.exports = function(P2) {
          return M2[P2] || (M2[P2] = I2(P2));
        };
      }, function(h, v4, _) {
        var M2 = _(1), I2 = _(3), P2 = I2["__core-js_shared__"] || (I2["__core-js_shared__"] = {});
        (h.exports = function(N3, z3) {
          return P2[N3] || (P2[N3] = z3 !== void 0 ? z3 : {});
        })("versions", []).push({ version: M2.version, mode: _(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
      }, function(h, v4) {
        h.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
      }, function(h, v4, _) {
        var M2 = _(7).f, I2 = _(5), P2 = _(2)("toStringTag");
        h.exports = function(N3, z3, H2) {
          N3 && !I2(N3 = H2 ? N3 : N3.prototype, P2) && M2(N3, P2, { configurable: true, value: z3 });
        };
      }, function(h, v4, _) {
        _(62);
        for (var M2 = _(3), I2 = _(6), P2 = _(12), N3 = _(2)("toStringTag"), z3 = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), H2 = 0; H2 < z3.length; H2++) {
          var $ = z3[H2], et = M2[$], at = et && et.prototype;
          at && !at[N3] && I2(at, N3, $), P2[$] = P2.Array;
        }
      }, function(h, v4, _) {
        v4.f = _(2);
      }, function(h, v4, _) {
        var M2 = _(3), I2 = _(1), P2 = _(14), N3 = _(30), z3 = _(7).f;
        h.exports = function(H2) {
          var $ = I2.Symbol || (I2.Symbol = P2 ? {} : M2.Symbol || {});
          H2.charAt(0) == "_" || H2 in $ || z3($, H2, { value: N3.f(H2) });
        };
      }, function(h, v4) {
        v4.f = Object.getOwnPropertySymbols;
      }, function(h, v4) {
        h.exports = function(_, M2, I2) {
          return Math.min(Math.max(_, M2), I2);
        };
      }, function(h, v4, _) {
        var M2 = _(14), I2 = _(15), P2 = _(37), N3 = _(6), z3 = _(12), H2 = _(55), $ = _(28), et = _(61), at = _(2)("iterator"), ht = !([].keys && "next" in [].keys()), bt = function() {
          return this;
        };
        h.exports = function(_t, Et, zt, Ft, fe2, re2, ye) {
          H2(zt, Et, Ft);
          var me2, be2, Te2, We = function(Nr) {
            if (!ht && Nr in Vn)
              return Vn[Nr];
            switch (Nr) {
              case "keys":
              case "values":
                return function() {
                  return new zt(this, Nr);
                };
            }
            return function() {
              return new zt(this, Nr);
            };
          }, en = Et + " Iterator", Ue2 = fe2 == "values", Mn = false, Vn = _t.prototype, xn = Vn[at] || Vn["@@iterator"] || fe2 && Vn[fe2], Zr = xn || We(fe2), nr = fe2 ? Ue2 ? We("entries") : Zr : void 0, pr = Et == "Array" && Vn.entries || xn;
          if (pr && (Te2 = et(pr.call(new _t()))) !== Object.prototype && Te2.next && ($(Te2, en, true), M2 || typeof Te2[at] == "function" || N3(Te2, at, bt)), Ue2 && xn && xn.name !== "values" && (Mn = true, Zr = function() {
            return xn.call(this);
          }), M2 && !ye || !ht && !Mn && Vn[at] || N3(Vn, at, Zr), z3[Et] = Zr, z3[en] = bt, fe2)
            if (me2 = { values: Ue2 ? Zr : We("values"), keys: re2 ? Zr : We("keys"), entries: nr }, ye)
              for (be2 in me2)
                be2 in Vn || P2(Vn, be2, me2[be2]);
            else
              I2(I2.P + I2.F * (ht || Mn), Et, me2);
          return me2;
        };
      }, function(h, v4, _) {
        h.exports = !_(4) && !_(8)(function() {
          return Object.defineProperty(_(36)("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(h, v4, _) {
        var M2 = _(11), I2 = _(3).document, P2 = M2(I2) && M2(I2.createElement);
        h.exports = function(N3) {
          return P2 ? I2.createElement(N3) : {};
        };
      }, function(h, v4, _) {
        h.exports = _(6);
      }, function(h, v4, _) {
        var M2 = _(10), I2 = _(56), P2 = _(27), N3 = _(25)("IE_PROTO"), z3 = function() {
        }, H2 = function() {
          var $, et = _(36)("iframe"), at = P2.length;
          for (et.style.display = "none", _(60).appendChild(et), et.src = "javascript:", ($ = et.contentWindow.document).open(), $.write("<script>document.F=Object<\/script>"), $.close(), H2 = $.F; at--; )
            delete H2.prototype[P2[at]];
          return H2();
        };
        h.exports = Object.create || function($, et) {
          var at;
          return $ !== null ? (z3.prototype = M2($), at = new z3(), z3.prototype = null, at[N3] = $) : at = H2(), et === void 0 ? at : I2(at, et);
        };
      }, function(h, v4, _) {
        var M2 = _(5), I2 = _(9), P2 = _(57)(false), N3 = _(25)("IE_PROTO");
        h.exports = function(z3, H2) {
          var $, et = I2(z3), at = 0, ht = [];
          for ($ in et)
            $ != N3 && M2(et, $) && ht.push($);
          for (; H2.length > at; )
            M2(et, $ = H2[at++]) && (~P2(ht, $) || ht.push($));
          return ht;
        };
      }, function(h, v4, _) {
        var M2 = _(24);
        h.exports = Object("z").propertyIsEnumerable(0) ? Object : function(I2) {
          return M2(I2) == "String" ? I2.split("") : Object(I2);
        };
      }, function(h, v4, _) {
        var M2 = _(39), I2 = _(27).concat("length", "prototype");
        v4.f = Object.getOwnPropertyNames || function(P2) {
          return M2(P2, I2);
        };
      }, function(h, v4, _) {
        var M2 = _(24), I2 = _(2)("toStringTag"), P2 = M2(function() {
          return arguments;
        }()) == "Arguments";
        h.exports = function(N3) {
          var z3, H2, $;
          return N3 === void 0 ? "Undefined" : N3 === null ? "Null" : typeof (H2 = function(et, at) {
            try {
              return et[at];
            } catch {
            }
          }(z3 = Object(N3), I2)) == "string" ? H2 : P2 ? M2(z3) : ($ = M2(z3)) == "Object" && typeof z3.callee == "function" ? "Arguments" : $;
        };
      }, function(h, v4) {
        var _;
        _ = function() {
          return this;
        }();
        try {
          _ = _ || new Function("return this")();
        } catch {
          typeof window == "object" && (_ = window);
        }
        h.exports = _;
      }, function(h, v4) {
        var _ = /-?\d+(\.\d+)?%?/g;
        h.exports = function(M2) {
          return M2.match(_);
        };
      }, function(h, v4, _) {
        Object.defineProperty(v4, "__esModule", { value: true }), v4.getBase16Theme = v4.createStyling = v4.invertTheme = void 0;
        var M2 = bt(_(49)), I2 = bt(_(76)), P2 = bt(_(81)), N3 = bt(_(89)), z3 = bt(_(93)), H2 = function(be2) {
          if (be2 && be2.__esModule)
            return be2;
          var Te2 = {};
          if (be2 != null)
            for (var We in be2)
              Object.prototype.hasOwnProperty.call(be2, We) && (Te2[We] = be2[We]);
          return Te2.default = be2, Te2;
        }(_(94)), $ = bt(_(132)), et = bt(_(133)), at = bt(_(138)), ht = _(139);
        function bt(be2) {
          return be2 && be2.__esModule ? be2 : { default: be2 };
        }
        var _t = H2.default, Et = (0, N3.default)(_t), zt = (0, at.default)(et.default, ht.rgb2yuv, function(be2) {
          var Te2, We = (0, P2.default)(be2, 3), en = We[0], Ue2 = We[1], Mn = We[2];
          return [(Te2 = en, Te2 < 0.25 ? 1 : Te2 < 0.5 ? 0.9 - Te2 : 1.1 - Te2), Ue2, Mn];
        }, ht.yuv2rgb, $.default), Ft = function(be2) {
          return function(Te2) {
            return { className: [Te2.className, be2.className].filter(Boolean).join(" "), style: (0, I2.default)({}, Te2.style || {}, be2.style || {}) };
          };
        }, fe2 = function(be2, Te2) {
          var We = (0, N3.default)(Te2);
          for (var en in be2)
            We.indexOf(en) === -1 && We.push(en);
          return We.reduce(function(Ue2, Mn) {
            return Ue2[Mn] = function(Vn, xn) {
              if (Vn === void 0)
                return xn;
              if (xn === void 0)
                return Vn;
              var Zr = Vn === void 0 ? "undefined" : (0, M2.default)(Vn), nr = xn === void 0 ? "undefined" : (0, M2.default)(xn);
              switch (Zr) {
                case "string":
                  switch (nr) {
                    case "string":
                      return [xn, Vn].filter(Boolean).join(" ");
                    case "object":
                      return Ft({ className: Vn, style: xn });
                    case "function":
                      return function(pr) {
                        for (var Nr = arguments.length, ai2 = Array(Nr > 1 ? Nr - 1 : 0), gi2 = 1; gi2 < Nr; gi2++)
                          ai2[gi2 - 1] = arguments[gi2];
                        return Ft({ className: Vn })(xn.apply(void 0, [pr].concat(ai2)));
                      };
                  }
                case "object":
                  switch (nr) {
                    case "string":
                      return Ft({ className: xn, style: Vn });
                    case "object":
                      return (0, I2.default)({}, xn, Vn);
                    case "function":
                      return function(pr) {
                        for (var Nr = arguments.length, ai2 = Array(Nr > 1 ? Nr - 1 : 0), gi2 = 1; gi2 < Nr; gi2++)
                          ai2[gi2 - 1] = arguments[gi2];
                        return Ft({ style: Vn })(xn.apply(void 0, [pr].concat(ai2)));
                      };
                  }
                case "function":
                  switch (nr) {
                    case "string":
                      return function(pr) {
                        for (var Nr = arguments.length, ai2 = Array(Nr > 1 ? Nr - 1 : 0), gi2 = 1; gi2 < Nr; gi2++)
                          ai2[gi2 - 1] = arguments[gi2];
                        return Vn.apply(void 0, [Ft(pr)({ className: xn })].concat(ai2));
                      };
                    case "object":
                      return function(pr) {
                        for (var Nr = arguments.length, ai2 = Array(Nr > 1 ? Nr - 1 : 0), gi2 = 1; gi2 < Nr; gi2++)
                          ai2[gi2 - 1] = arguments[gi2];
                        return Vn.apply(void 0, [Ft(pr)({ style: xn })].concat(ai2));
                      };
                    case "function":
                      return function(pr) {
                        for (var Nr = arguments.length, ai2 = Array(Nr > 1 ? Nr - 1 : 0), gi2 = 1; gi2 < Nr; gi2++)
                          ai2[gi2 - 1] = arguments[gi2];
                        return Vn.apply(void 0, [xn.apply(void 0, [pr].concat(ai2))].concat(ai2));
                      };
                  }
              }
            }(be2[Mn], Te2[Mn]), Ue2;
          }, {});
        }, re2 = function(be2, Te2) {
          for (var We = arguments.length, en = Array(We > 2 ? We - 2 : 0), Ue2 = 2; Ue2 < We; Ue2++)
            en[Ue2 - 2] = arguments[Ue2];
          if (Te2 === null)
            return be2;
          Array.isArray(Te2) || (Te2 = [Te2]);
          var Mn = Te2.map(function(xn) {
            return be2[xn];
          }).filter(Boolean), Vn = Mn.reduce(function(xn, Zr) {
            return typeof Zr == "string" ? xn.className = [xn.className, Zr].filter(Boolean).join(" ") : (Zr === void 0 ? "undefined" : (0, M2.default)(Zr)) === "object" ? xn.style = (0, I2.default)({}, xn.style, Zr) : typeof Zr == "function" && (xn = (0, I2.default)({}, xn, Zr.apply(void 0, [xn].concat(en)))), xn;
          }, { className: "", style: {} });
          return Vn.className || delete Vn.className, (0, N3.default)(Vn.style).length === 0 && delete Vn.style, Vn;
        }, ye = v4.invertTheme = function(be2) {
          return (0, N3.default)(be2).reduce(function(Te2, We) {
            return Te2[We] = /^base/.test(We) ? zt(be2[We]) : We === "scheme" ? be2[We] + ":inverted" : be2[We], Te2;
          }, {});
        }, me2 = (v4.createStyling = (0, z3.default)(function(be2) {
          for (var Te2 = arguments.length, We = Array(Te2 > 3 ? Te2 - 3 : 0), en = 3; en < Te2; en++)
            We[en - 3] = arguments[en];
          var Ue2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Mn = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Vn = Ue2.defaultBase16, xn = Vn === void 0 ? _t : Vn, Zr = Ue2.base16Themes, nr = Zr === void 0 ? null : Zr, pr = me2(Mn, nr);
          pr && (Mn = (0, I2.default)({}, pr, Mn));
          var Nr = Et.reduce(function(us, ml) {
            return us[ml] = Mn[ml] || xn[ml], us;
          }, {}), ai2 = (0, N3.default)(Mn).reduce(function(us, ml) {
            return Et.indexOf(ml) === -1 && (us[ml] = Mn[ml]), us;
          }, {}), gi2 = be2(Nr), To = fe2(ai2, gi2);
          return (0, z3.default)(re2, 2).apply(void 0, [To].concat(We));
        }, 3), v4.getBase16Theme = function(be2, Te2) {
          if (be2 && be2.extend && (be2 = be2.extend), typeof be2 == "string") {
            var We = be2.split(":"), en = (0, P2.default)(We, 2), Ue2 = en[0], Mn = en[1];
            be2 = (Te2 || {})[Ue2] || H2[Ue2], Mn === "inverted" && (be2 = ye(be2));
          }
          return be2 && be2.hasOwnProperty("base00") ? be2 : void 0;
        });
      }, function(h, v4, _) {
        var M2, I2 = typeof Reflect == "object" ? Reflect : null, P2 = I2 && typeof I2.apply == "function" ? I2.apply : function(Ft, fe2, re2) {
          return Function.prototype.apply.call(Ft, fe2, re2);
        };
        M2 = I2 && typeof I2.ownKeys == "function" ? I2.ownKeys : Object.getOwnPropertySymbols ? function(Ft) {
          return Object.getOwnPropertyNames(Ft).concat(Object.getOwnPropertySymbols(Ft));
        } : function(Ft) {
          return Object.getOwnPropertyNames(Ft);
        };
        var N3 = Number.isNaN || function(Ft) {
          return Ft != Ft;
        };
        function z3() {
          z3.init.call(this);
        }
        h.exports = z3, h.exports.once = function(Ft, fe2) {
          return new Promise(function(re2, ye) {
            function me2() {
              be2 !== void 0 && Ft.removeListener("error", be2), re2([].slice.call(arguments));
            }
            var be2;
            fe2 !== "error" && (be2 = function(Te2) {
              Ft.removeListener(fe2, me2), ye(Te2);
            }, Ft.once("error", be2)), Ft.once(fe2, me2);
          });
        }, z3.EventEmitter = z3, z3.prototype._events = void 0, z3.prototype._eventsCount = 0, z3.prototype._maxListeners = void 0;
        var H2 = 10;
        function $(Ft) {
          if (typeof Ft != "function")
            throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof Ft);
        }
        function et(Ft) {
          return Ft._maxListeners === void 0 ? z3.defaultMaxListeners : Ft._maxListeners;
        }
        function at(Ft, fe2, re2, ye) {
          var me2, be2, Te2, We;
          if ($(re2), (be2 = Ft._events) === void 0 ? (be2 = Ft._events = /* @__PURE__ */ Object.create(null), Ft._eventsCount = 0) : (be2.newListener !== void 0 && (Ft.emit("newListener", fe2, re2.listener ? re2.listener : re2), be2 = Ft._events), Te2 = be2[fe2]), Te2 === void 0)
            Te2 = be2[fe2] = re2, ++Ft._eventsCount;
          else if (typeof Te2 == "function" ? Te2 = be2[fe2] = ye ? [re2, Te2] : [Te2, re2] : ye ? Te2.unshift(re2) : Te2.push(re2), (me2 = et(Ft)) > 0 && Te2.length > me2 && !Te2.warned) {
            Te2.warned = true;
            var en = new Error("Possible EventEmitter memory leak detected. " + Te2.length + " " + String(fe2) + " listeners added. Use emitter.setMaxListeners() to increase limit");
            en.name = "MaxListenersExceededWarning", en.emitter = Ft, en.type = fe2, en.count = Te2.length, We = en, console && console.warn && console.warn(We);
          }
          return Ft;
        }
        function ht() {
          if (!this.fired)
            return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
        }
        function bt(Ft, fe2, re2) {
          var ye = { fired: false, wrapFn: void 0, target: Ft, type: fe2, listener: re2 }, me2 = ht.bind(ye);
          return me2.listener = re2, ye.wrapFn = me2, me2;
        }
        function _t(Ft, fe2, re2) {
          var ye = Ft._events;
          if (ye === void 0)
            return [];
          var me2 = ye[fe2];
          return me2 === void 0 ? [] : typeof me2 == "function" ? re2 ? [me2.listener || me2] : [me2] : re2 ? function(be2) {
            for (var Te2 = new Array(be2.length), We = 0; We < Te2.length; ++We)
              Te2[We] = be2[We].listener || be2[We];
            return Te2;
          }(me2) : zt(me2, me2.length);
        }
        function Et(Ft) {
          var fe2 = this._events;
          if (fe2 !== void 0) {
            var re2 = fe2[Ft];
            if (typeof re2 == "function")
              return 1;
            if (re2 !== void 0)
              return re2.length;
          }
          return 0;
        }
        function zt(Ft, fe2) {
          for (var re2 = new Array(fe2), ye = 0; ye < fe2; ++ye)
            re2[ye] = Ft[ye];
          return re2;
        }
        Object.defineProperty(z3, "defaultMaxListeners", { enumerable: true, get: function() {
          return H2;
        }, set: function(Ft) {
          if (typeof Ft != "number" || Ft < 0 || N3(Ft))
            throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + Ft + ".");
          H2 = Ft;
        } }), z3.init = function() {
          this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
        }, z3.prototype.setMaxListeners = function(Ft) {
          if (typeof Ft != "number" || Ft < 0 || N3(Ft))
            throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + Ft + ".");
          return this._maxListeners = Ft, this;
        }, z3.prototype.getMaxListeners = function() {
          return et(this);
        }, z3.prototype.emit = function(Ft) {
          for (var fe2 = [], re2 = 1; re2 < arguments.length; re2++)
            fe2.push(arguments[re2]);
          var ye = Ft === "error", me2 = this._events;
          if (me2 !== void 0)
            ye = ye && me2.error === void 0;
          else if (!ye)
            return false;
          if (ye) {
            var be2;
            if (fe2.length > 0 && (be2 = fe2[0]), be2 instanceof Error)
              throw be2;
            var Te2 = new Error("Unhandled error." + (be2 ? " (" + be2.message + ")" : ""));
            throw Te2.context = be2, Te2;
          }
          var We = me2[Ft];
          if (We === void 0)
            return false;
          if (typeof We == "function")
            P2(We, this, fe2);
          else {
            var en = We.length, Ue2 = zt(We, en);
            for (re2 = 0; re2 < en; ++re2)
              P2(Ue2[re2], this, fe2);
          }
          return true;
        }, z3.prototype.addListener = function(Ft, fe2) {
          return at(this, Ft, fe2, false);
        }, z3.prototype.on = z3.prototype.addListener, z3.prototype.prependListener = function(Ft, fe2) {
          return at(this, Ft, fe2, true);
        }, z3.prototype.once = function(Ft, fe2) {
          return $(fe2), this.on(Ft, bt(this, Ft, fe2)), this;
        }, z3.prototype.prependOnceListener = function(Ft, fe2) {
          return $(fe2), this.prependListener(Ft, bt(this, Ft, fe2)), this;
        }, z3.prototype.removeListener = function(Ft, fe2) {
          var re2, ye, me2, be2, Te2;
          if ($(fe2), (ye = this._events) === void 0)
            return this;
          if ((re2 = ye[Ft]) === void 0)
            return this;
          if (re2 === fe2 || re2.listener === fe2)
            --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete ye[Ft], ye.removeListener && this.emit("removeListener", Ft, re2.listener || fe2));
          else if (typeof re2 != "function") {
            for (me2 = -1, be2 = re2.length - 1; be2 >= 0; be2--)
              if (re2[be2] === fe2 || re2[be2].listener === fe2) {
                Te2 = re2[be2].listener, me2 = be2;
                break;
              }
            if (me2 < 0)
              return this;
            me2 === 0 ? re2.shift() : function(We, en) {
              for (; en + 1 < We.length; en++)
                We[en] = We[en + 1];
              We.pop();
            }(re2, me2), re2.length === 1 && (ye[Ft] = re2[0]), ye.removeListener !== void 0 && this.emit("removeListener", Ft, Te2 || fe2);
          }
          return this;
        }, z3.prototype.off = z3.prototype.removeListener, z3.prototype.removeAllListeners = function(Ft) {
          var fe2, re2, ye;
          if ((re2 = this._events) === void 0)
            return this;
          if (re2.removeListener === void 0)
            return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : re2[Ft] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete re2[Ft]), this;
          if (arguments.length === 0) {
            var me2, be2 = Object.keys(re2);
            for (ye = 0; ye < be2.length; ++ye)
              (me2 = be2[ye]) !== "removeListener" && this.removeAllListeners(me2);
            return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
          }
          if (typeof (fe2 = re2[Ft]) == "function")
            this.removeListener(Ft, fe2);
          else if (fe2 !== void 0)
            for (ye = fe2.length - 1; ye >= 0; ye--)
              this.removeListener(Ft, fe2[ye]);
          return this;
        }, z3.prototype.listeners = function(Ft) {
          return _t(this, Ft, true);
        }, z3.prototype.rawListeners = function(Ft) {
          return _t(this, Ft, false);
        }, z3.listenerCount = function(Ft, fe2) {
          return typeof Ft.listenerCount == "function" ? Ft.listenerCount(fe2) : Et.call(Ft, fe2);
        }, z3.prototype.listenerCount = Et, z3.prototype.eventNames = function() {
          return this._eventsCount > 0 ? M2(this._events) : [];
        };
      }, function(h, v4, _) {
        h.exports.Dispatcher = _(140);
      }, function(h, v4, _) {
        h.exports = _(142);
      }, function(h, v4, _) {
        v4.__esModule = true;
        var M2 = N3(_(50)), I2 = N3(_(65)), P2 = typeof I2.default == "function" && typeof M2.default == "symbol" ? function(z3) {
          return typeof z3;
        } : function(z3) {
          return z3 && typeof I2.default == "function" && z3.constructor === I2.default && z3 !== I2.default.prototype ? "symbol" : typeof z3;
        };
        function N3(z3) {
          return z3 && z3.__esModule ? z3 : { default: z3 };
        }
        v4.default = typeof I2.default == "function" && P2(M2.default) === "symbol" ? function(z3) {
          return z3 === void 0 ? "undefined" : P2(z3);
        } : function(z3) {
          return z3 && typeof I2.default == "function" && z3.constructor === I2.default && z3 !== I2.default.prototype ? "symbol" : z3 === void 0 ? "undefined" : P2(z3);
        };
      }, function(h, v4, _) {
        h.exports = { default: _(51), __esModule: true };
      }, function(h, v4, _) {
        _(20), _(29), h.exports = _(30).f("iterator");
      }, function(h, v4, _) {
        var M2 = _(21), I2 = _(22);
        h.exports = function(P2) {
          return function(N3, z3) {
            var H2, $, et = String(I2(N3)), at = M2(z3), ht = et.length;
            return at < 0 || at >= ht ? P2 ? "" : void 0 : (H2 = et.charCodeAt(at)) < 55296 || H2 > 56319 || at + 1 === ht || ($ = et.charCodeAt(at + 1)) < 56320 || $ > 57343 ? P2 ? et.charAt(at) : H2 : P2 ? et.slice(at, at + 2) : $ - 56320 + (H2 - 55296 << 10) + 65536;
          };
        };
      }, function(h, v4, _) {
        var M2 = _(54);
        h.exports = function(I2, P2, N3) {
          if (M2(I2), P2 === void 0)
            return I2;
          switch (N3) {
            case 1:
              return function(z3) {
                return I2.call(P2, z3);
              };
            case 2:
              return function(z3, H2) {
                return I2.call(P2, z3, H2);
              };
            case 3:
              return function(z3, H2, $) {
                return I2.call(P2, z3, H2, $);
              };
          }
          return function() {
            return I2.apply(P2, arguments);
          };
        };
      }, function(h, v4) {
        h.exports = function(_) {
          if (typeof _ != "function")
            throw TypeError(_ + " is not a function!");
          return _;
        };
      }, function(h, v4, _) {
        var M2 = _(38), I2 = _(16), P2 = _(28), N3 = {};
        _(6)(N3, _(2)("iterator"), function() {
          return this;
        }), h.exports = function(z3, H2, $) {
          z3.prototype = M2(N3, { next: I2(1, $) }), P2(z3, H2 + " Iterator");
        };
      }, function(h, v4, _) {
        var M2 = _(7), I2 = _(10), P2 = _(13);
        h.exports = _(4) ? Object.defineProperties : function(N3, z3) {
          I2(N3);
          for (var H2, $ = P2(z3), et = $.length, at = 0; et > at; )
            M2.f(N3, H2 = $[at++], z3[H2]);
          return N3;
        };
      }, function(h, v4, _) {
        var M2 = _(9), I2 = _(58), P2 = _(59);
        h.exports = function(N3) {
          return function(z3, H2, $) {
            var et, at = M2(z3), ht = I2(at.length), bt = P2($, ht);
            if (N3 && H2 != H2) {
              for (; ht > bt; )
                if ((et = at[bt++]) != et)
                  return true;
            } else
              for (; ht > bt; bt++)
                if ((N3 || bt in at) && at[bt] === H2)
                  return N3 || bt || 0;
            return !N3 && -1;
          };
        };
      }, function(h, v4, _) {
        var M2 = _(21), I2 = Math.min;
        h.exports = function(P2) {
          return P2 > 0 ? I2(M2(P2), 9007199254740991) : 0;
        };
      }, function(h, v4, _) {
        var M2 = _(21), I2 = Math.max, P2 = Math.min;
        h.exports = function(N3, z3) {
          return (N3 = M2(N3)) < 0 ? I2(N3 + z3, 0) : P2(N3, z3);
        };
      }, function(h, v4, _) {
        var M2 = _(3).document;
        h.exports = M2 && M2.documentElement;
      }, function(h, v4, _) {
        var M2 = _(5), I2 = _(18), P2 = _(25)("IE_PROTO"), N3 = Object.prototype;
        h.exports = Object.getPrototypeOf || function(z3) {
          return z3 = I2(z3), M2(z3, P2) ? z3[P2] : typeof z3.constructor == "function" && z3 instanceof z3.constructor ? z3.constructor.prototype : z3 instanceof Object ? N3 : null;
        };
      }, function(h, v4, _) {
        var M2 = _(63), I2 = _(64), P2 = _(12), N3 = _(9);
        h.exports = _(34)(Array, "Array", function(z3, H2) {
          this._t = N3(z3), this._i = 0, this._k = H2;
        }, function() {
          var z3 = this._t, H2 = this._k, $ = this._i++;
          return !z3 || $ >= z3.length ? (this._t = void 0, I2(1)) : I2(0, H2 == "keys" ? $ : H2 == "values" ? z3[$] : [$, z3[$]]);
        }, "values"), P2.Arguments = P2.Array, M2("keys"), M2("values"), M2("entries");
      }, function(h, v4) {
        h.exports = function() {
        };
      }, function(h, v4) {
        h.exports = function(_, M2) {
          return { value: M2, done: !!_ };
        };
      }, function(h, v4, _) {
        h.exports = { default: _(66), __esModule: true };
      }, function(h, v4, _) {
        _(67), _(73), _(74), _(75), h.exports = _(1).Symbol;
      }, function(h, v4, _) {
        var M2 = _(3), I2 = _(5), P2 = _(4), N3 = _(15), z3 = _(37), H2 = _(68).KEY, $ = _(8), et = _(26), at = _(28), ht = _(17), bt = _(2), _t = _(30), Et = _(31), zt = _(69), Ft = _(70), fe2 = _(10), re2 = _(11), ye = _(18), me2 = _(9), be2 = _(23), Te2 = _(16), We = _(38), en = _(71), Ue2 = _(72), Mn = _(32), Vn = _(7), xn = _(13), Zr = Ue2.f, nr = Vn.f, pr = en.f, Nr = M2.Symbol, ai2 = M2.JSON, gi2 = ai2 && ai2.stringify, To = bt("_hidden"), us = bt("toPrimitive"), ml = {}.propertyIsEnumerable, ll = et("symbol-registry"), Rs = et("symbols"), es = et("op-symbols"), Ws = Object.prototype, il = typeof Nr == "function" && !!Mn.f, bs = M2.QObject, Rl = !bs || !bs.prototype || !bs.prototype.findChild, Mh2 = P2 && $(function() {
          return We(nr({}, "a", { get: function() {
            return nr(this, "a", { value: 7 }).a;
          } })).a != 7;
        }) ? function(Ki2, ho, Bs) {
          var Ql = Zr(Ws, ho);
          Ql && delete Ws[ho], nr(Ki2, ho, Bs), Ql && Ki2 !== Ws && nr(Ws, ho, Ql);
        } : nr, au = function(Ki2) {
          var ho = Rs[Ki2] = We(Nr.prototype);
          return ho._k = Ki2, ho;
        }, eh2 = il && typeof Nr.iterator == "symbol" ? function(Ki2) {
          return typeof Ki2 == "symbol";
        } : function(Ki2) {
          return Ki2 instanceof Nr;
        }, Gh2 = function(Ki2, ho, Bs) {
          return Ki2 === Ws && Gh2(es, ho, Bs), fe2(Ki2), ho = be2(ho, true), fe2(Bs), I2(Rs, ho) ? (Bs.enumerable ? (I2(Ki2, To) && Ki2[To][ho] && (Ki2[To][ho] = false), Bs = We(Bs, { enumerable: Te2(0, false) })) : (I2(Ki2, To) || nr(Ki2, To, Te2(1, {})), Ki2[To][ho] = true), Mh2(Ki2, ho, Bs)) : nr(Ki2, ho, Bs);
        }, Pp = function(Ki2, ho) {
          fe2(Ki2);
          for (var Bs, Ql = zt(ho = me2(ho)), ff2 = 0, hf2 = Ql.length; hf2 > ff2; )
            Gh2(Ki2, Bs = Ql[ff2++], ho[Bs]);
          return Ki2;
        }, zy = function(Ki2) {
          var ho = ml.call(this, Ki2 = be2(Ki2, true));
          return !(this === Ws && I2(Rs, Ki2) && !I2(es, Ki2)) && (!(ho || !I2(this, Ki2) || !I2(Rs, Ki2) || I2(this, To) && this[To][Ki2]) || ho);
        }, Rd2 = function(Ki2, ho) {
          if (Ki2 = me2(Ki2), ho = be2(ho, true), Ki2 !== Ws || !I2(Rs, ho) || I2(es, ho)) {
            var Bs = Zr(Ki2, ho);
            return !Bs || !I2(Rs, ho) || I2(Ki2, To) && Ki2[To][ho] || (Bs.enumerable = true), Bs;
          }
        }, c1 = function(Ki2) {
          for (var ho, Bs = pr(me2(Ki2)), Ql = [], ff2 = 0; Bs.length > ff2; )
            I2(Rs, ho = Bs[ff2++]) || ho == To || ho == H2 || Ql.push(ho);
          return Ql;
        }, _d = function(Ki2) {
          for (var ho, Bs = Ki2 === Ws, Ql = pr(Bs ? es : me2(Ki2)), ff2 = [], hf2 = 0; Ql.length > hf2; )
            !I2(Rs, ho = Ql[hf2++]) || Bs && !I2(Ws, ho) || ff2.push(Rs[ho]);
          return ff2;
        };
        il || (z3((Nr = function() {
          if (this instanceof Nr)
            throw TypeError("Symbol is not a constructor!");
          var Ki2 = ht(arguments.length > 0 ? arguments[0] : void 0), ho = function(Bs) {
            this === Ws && ho.call(es, Bs), I2(this, To) && I2(this[To], Ki2) && (this[To][Ki2] = false), Mh2(this, Ki2, Te2(1, Bs));
          };
          return P2 && Rl && Mh2(Ws, Ki2, { configurable: true, set: ho }), au(Ki2);
        }).prototype, "toString", function() {
          return this._k;
        }), Ue2.f = Rd2, Vn.f = Gh2, _(41).f = en.f = c1, _(19).f = zy, Mn.f = _d, P2 && !_(14) && z3(Ws, "propertyIsEnumerable", zy, true), _t.f = function(Ki2) {
          return au(bt(Ki2));
        }), N3(N3.G + N3.W + N3.F * !il, { Symbol: Nr });
        for (var G0 = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), qg2 = 0; G0.length > qg2; )
          bt(G0[qg2++]);
        for (var XT = xn(bt.store), fo = 0; XT.length > fo; )
          Et(XT[fo++]);
        N3(N3.S + N3.F * !il, "Symbol", { for: function(Ki2) {
          return I2(ll, Ki2 += "") ? ll[Ki2] : ll[Ki2] = Nr(Ki2);
        }, keyFor: function(Ki2) {
          if (!eh2(Ki2))
            throw TypeError(Ki2 + " is not a symbol!");
          for (var ho in ll)
            if (ll[ho] === Ki2)
              return ho;
        }, useSetter: function() {
          Rl = true;
        }, useSimple: function() {
          Rl = false;
        } }), N3(N3.S + N3.F * !il, "Object", { create: function(Ki2, ho) {
          return ho === void 0 ? We(Ki2) : Pp(We(Ki2), ho);
        }, defineProperty: Gh2, defineProperties: Pp, getOwnPropertyDescriptor: Rd2, getOwnPropertyNames: c1, getOwnPropertySymbols: _d });
        var ra2 = $(function() {
          Mn.f(1);
        });
        N3(N3.S + N3.F * ra2, "Object", { getOwnPropertySymbols: function(Ki2) {
          return Mn.f(ye(Ki2));
        } }), ai2 && N3(N3.S + N3.F * (!il || $(function() {
          var Ki2 = Nr();
          return gi2([Ki2]) != "[null]" || gi2({ a: Ki2 }) != "{}" || gi2(Object(Ki2)) != "{}";
        })), "JSON", { stringify: function(Ki2) {
          for (var ho, Bs, Ql = [Ki2], ff2 = 1; arguments.length > ff2; )
            Ql.push(arguments[ff2++]);
          if (Bs = ho = Ql[1], (re2(ho) || Ki2 !== void 0) && !eh2(Ki2))
            return Ft(ho) || (ho = function(hf2, qp) {
              if (typeof Bs == "function" && (qp = Bs.call(this, hf2, qp)), !eh2(qp))
                return qp;
            }), Ql[1] = ho, gi2.apply(ai2, Ql);
        } }), Nr.prototype[us] || _(6)(Nr.prototype, us, Nr.prototype.valueOf), at(Nr, "Symbol"), at(Math, "Math", true), at(M2.JSON, "JSON", true);
      }, function(h, v4, _) {
        var M2 = _(17)("meta"), I2 = _(11), P2 = _(5), N3 = _(7).f, z3 = 0, H2 = Object.isExtensible || function() {
          return true;
        }, $ = !_(8)(function() {
          return H2(Object.preventExtensions({}));
        }), et = function(ht) {
          N3(ht, M2, { value: { i: "O" + ++z3, w: {} } });
        }, at = h.exports = { KEY: M2, NEED: false, fastKey: function(ht, bt) {
          if (!I2(ht))
            return typeof ht == "symbol" ? ht : (typeof ht == "string" ? "S" : "P") + ht;
          if (!P2(ht, M2)) {
            if (!H2(ht))
              return "F";
            if (!bt)
              return "E";
            et(ht);
          }
          return ht[M2].i;
        }, getWeak: function(ht, bt) {
          if (!P2(ht, M2)) {
            if (!H2(ht))
              return true;
            if (!bt)
              return false;
            et(ht);
          }
          return ht[M2].w;
        }, onFreeze: function(ht) {
          return $ && at.NEED && H2(ht) && !P2(ht, M2) && et(ht), ht;
        } };
      }, function(h, v4, _) {
        var M2 = _(13), I2 = _(32), P2 = _(19);
        h.exports = function(N3) {
          var z3 = M2(N3), H2 = I2.f;
          if (H2)
            for (var $, et = H2(N3), at = P2.f, ht = 0; et.length > ht; )
              at.call(N3, $ = et[ht++]) && z3.push($);
          return z3;
        };
      }, function(h, v4, _) {
        var M2 = _(24);
        h.exports = Array.isArray || function(I2) {
          return M2(I2) == "Array";
        };
      }, function(h, v4, _) {
        var M2 = _(9), I2 = _(41).f, P2 = {}.toString, N3 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
        h.exports.f = function(z3) {
          return N3 && P2.call(z3) == "[object Window]" ? function(H2) {
            try {
              return I2(H2);
            } catch {
              return N3.slice();
            }
          }(z3) : I2(M2(z3));
        };
      }, function(h, v4, _) {
        var M2 = _(19), I2 = _(16), P2 = _(9), N3 = _(23), z3 = _(5), H2 = _(35), $ = Object.getOwnPropertyDescriptor;
        v4.f = _(4) ? $ : function(et, at) {
          if (et = P2(et), at = N3(at, true), H2)
            try {
              return $(et, at);
            } catch {
            }
          if (z3(et, at))
            return I2(!M2.f.call(et, at), et[at]);
        };
      }, function(h, v4) {
      }, function(h, v4, _) {
        _(31)("asyncIterator");
      }, function(h, v4, _) {
        _(31)("observable");
      }, function(h, v4, _) {
        v4.__esModule = true;
        var M2, I2 = _(77), P2 = (M2 = I2) && M2.__esModule ? M2 : { default: M2 };
        v4.default = P2.default || function(N3) {
          for (var z3 = 1; z3 < arguments.length; z3++) {
            var H2 = arguments[z3];
            for (var $ in H2)
              Object.prototype.hasOwnProperty.call(H2, $) && (N3[$] = H2[$]);
          }
          return N3;
        };
      }, function(h, v4, _) {
        h.exports = { default: _(78), __esModule: true };
      }, function(h, v4, _) {
        _(79), h.exports = _(1).Object.assign;
      }, function(h, v4, _) {
        var M2 = _(15);
        M2(M2.S + M2.F, "Object", { assign: _(80) });
      }, function(h, v4, _) {
        var M2 = _(4), I2 = _(13), P2 = _(32), N3 = _(19), z3 = _(18), H2 = _(40), $ = Object.assign;
        h.exports = !$ || _(8)(function() {
          var et = {}, at = {}, ht = Symbol(), bt = "abcdefghijklmnopqrst";
          return et[ht] = 7, bt.split("").forEach(function(_t) {
            at[_t] = _t;
          }), $({}, et)[ht] != 7 || Object.keys($({}, at)).join("") != bt;
        }) ? function(et, at) {
          for (var ht = z3(et), bt = arguments.length, _t = 1, Et = P2.f, zt = N3.f; bt > _t; )
            for (var Ft, fe2 = H2(arguments[_t++]), re2 = Et ? I2(fe2).concat(Et(fe2)) : I2(fe2), ye = re2.length, me2 = 0; ye > me2; )
              Ft = re2[me2++], M2 && !zt.call(fe2, Ft) || (ht[Ft] = fe2[Ft]);
          return ht;
        } : $;
      }, function(h, v4, _) {
        v4.__esModule = true;
        var M2 = P2(_(82)), I2 = P2(_(85));
        function P2(N3) {
          return N3 && N3.__esModule ? N3 : { default: N3 };
        }
        v4.default = function(N3, z3) {
          if (Array.isArray(N3))
            return N3;
          if ((0, M2.default)(Object(N3)))
            return function(H2, $) {
              var et = [], at = true, ht = false, bt = void 0;
              try {
                for (var _t, Et = (0, I2.default)(H2); !(at = (_t = Et.next()).done) && (et.push(_t.value), !$ || et.length !== $); at = true)
                  ;
              } catch (zt) {
                ht = true, bt = zt;
              } finally {
                try {
                  !at && Et.return && Et.return();
                } finally {
                  if (ht)
                    throw bt;
                }
              }
              return et;
            }(N3, z3);
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        };
      }, function(h, v4, _) {
        h.exports = { default: _(83), __esModule: true };
      }, function(h, v4, _) {
        _(29), _(20), h.exports = _(84);
      }, function(h, v4, _) {
        var M2 = _(42), I2 = _(2)("iterator"), P2 = _(12);
        h.exports = _(1).isIterable = function(N3) {
          var z3 = Object(N3);
          return z3[I2] !== void 0 || "@@iterator" in z3 || P2.hasOwnProperty(M2(z3));
        };
      }, function(h, v4, _) {
        h.exports = { default: _(86), __esModule: true };
      }, function(h, v4, _) {
        _(29), _(20), h.exports = _(87);
      }, function(h, v4, _) {
        var M2 = _(10), I2 = _(88);
        h.exports = _(1).getIterator = function(P2) {
          var N3 = I2(P2);
          if (typeof N3 != "function")
            throw TypeError(P2 + " is not iterable!");
          return M2(N3.call(P2));
        };
      }, function(h, v4, _) {
        var M2 = _(42), I2 = _(2)("iterator"), P2 = _(12);
        h.exports = _(1).getIteratorMethod = function(N3) {
          if (N3 != null)
            return N3[I2] || N3["@@iterator"] || P2[M2(N3)];
        };
      }, function(h, v4, _) {
        h.exports = { default: _(90), __esModule: true };
      }, function(h, v4, _) {
        _(91), h.exports = _(1).Object.keys;
      }, function(h, v4, _) {
        var M2 = _(18), I2 = _(13);
        _(92)("keys", function() {
          return function(P2) {
            return I2(M2(P2));
          };
        });
      }, function(h, v4, _) {
        var M2 = _(15), I2 = _(1), P2 = _(8);
        h.exports = function(N3, z3) {
          var H2 = (I2.Object || {})[N3] || Object[N3], $ = {};
          $[N3] = z3(H2), M2(M2.S + M2.F * P2(function() {
            H2(1);
          }), "Object", $);
        };
      }, function(h, v4, _) {
        (function(M2) {
          var I2 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], P2 = /^\s+|\s+$/g, N3 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, z3 = /\{\n\/\* \[wrapped with (.+)\] \*/, H2 = /,? & /, $ = /^[-+]0x[0-9a-f]+$/i, et = /^0b[01]+$/i, at = /^\[object .+?Constructor\]$/, ht = /^0o[0-7]+$/i, bt = /^(?:0|[1-9]\d*)$/, _t = parseInt, Et = typeof M2 == "object" && M2 && M2.Object === Object && M2, zt = typeof self == "object" && self && self.Object === Object && self, Ft = Et || zt || Function("return this")();
          function fe2(fo, ra2, Ki2) {
            switch (Ki2.length) {
              case 0:
                return fo.call(ra2);
              case 1:
                return fo.call(ra2, Ki2[0]);
              case 2:
                return fo.call(ra2, Ki2[0], Ki2[1]);
              case 3:
                return fo.call(ra2, Ki2[0], Ki2[1], Ki2[2]);
            }
            return fo.apply(ra2, Ki2);
          }
          function re2(fo, ra2) {
            return !!(fo && fo.length) && function(Ki2, ho, Bs) {
              if (ho != ho)
                return function(hf2, qp, sv, lg2) {
                  for (var H0 = hf2.length, ug2 = sv + (lg2 ? 1 : -1); lg2 ? ug2-- : ++ug2 < H0; )
                    if (qp(hf2[ug2], ug2, hf2))
                      return ug2;
                  return -1;
                }(Ki2, ye, Bs);
              for (var Ql = Bs - 1, ff2 = Ki2.length; ++Ql < ff2; )
                if (Ki2[Ql] === ho)
                  return Ql;
              return -1;
            }(fo, ra2, 0) > -1;
          }
          function ye(fo) {
            return fo != fo;
          }
          function me2(fo, ra2) {
            for (var Ki2 = fo.length, ho = 0; Ki2--; )
              fo[Ki2] === ra2 && ho++;
            return ho;
          }
          function be2(fo, ra2) {
            for (var Ki2 = -1, ho = fo.length, Bs = 0, Ql = []; ++Ki2 < ho; ) {
              var ff2 = fo[Ki2];
              ff2 !== ra2 && ff2 !== "__lodash_placeholder__" || (fo[Ki2] = "__lodash_placeholder__", Ql[Bs++] = Ki2);
            }
            return Ql;
          }
          var Te2, We, en, Ue2 = Function.prototype, Mn = Object.prototype, Vn = Ft["__core-js_shared__"], xn = (Te2 = /[^.]+$/.exec(Vn && Vn.keys && Vn.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Te2 : "", Zr = Ue2.toString, nr = Mn.hasOwnProperty, pr = Mn.toString, Nr = RegExp("^" + Zr.call(nr).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ai2 = Object.create, gi2 = Math.max, To = Math.min, us = (We = au(Object, "defineProperty"), (en = au.name) && en.length > 2 ? We : void 0);
          function ml(fo) {
            return G0(fo) ? ai2(fo) : {};
          }
          function ll(fo) {
            return !(!G0(fo) || function(ra2) {
              return !!xn && xn in ra2;
            }(fo)) && (function(ra2) {
              var Ki2 = G0(ra2) ? pr.call(ra2) : "";
              return Ki2 == "[object Function]" || Ki2 == "[object GeneratorFunction]";
            }(fo) || function(ra2) {
              var Ki2 = false;
              if (ra2 != null && typeof ra2.toString != "function")
                try {
                  Ki2 = !!(ra2 + "");
                } catch {
                }
              return Ki2;
            }(fo) ? Nr : at).test(function(ra2) {
              if (ra2 != null) {
                try {
                  return Zr.call(ra2);
                } catch {
                }
                try {
                  return ra2 + "";
                } catch {
                }
              }
              return "";
            }(fo));
          }
          function Rs(fo, ra2, Ki2, ho) {
            for (var Bs = -1, Ql = fo.length, ff2 = Ki2.length, hf2 = -1, qp = ra2.length, sv = gi2(Ql - ff2, 0), lg2 = Array(qp + sv), H0 = !ho; ++hf2 < qp; )
              lg2[hf2] = ra2[hf2];
            for (; ++Bs < ff2; )
              (H0 || Bs < Ql) && (lg2[Ki2[Bs]] = fo[Bs]);
            for (; sv--; )
              lg2[hf2++] = fo[Bs++];
            return lg2;
          }
          function es(fo, ra2, Ki2, ho) {
            for (var Bs = -1, Ql = fo.length, ff2 = -1, hf2 = Ki2.length, qp = -1, sv = ra2.length, lg2 = gi2(Ql - hf2, 0), H0 = Array(lg2 + sv), ug2 = !ho; ++Bs < lg2; )
              H0[Bs] = fo[Bs];
            for (var gb2 = Bs; ++qp < sv; )
              H0[gb2 + qp] = ra2[qp];
            for (; ++ff2 < hf2; )
              (ug2 || Bs < Ql) && (H0[gb2 + Ki2[ff2]] = fo[Bs++]);
            return H0;
          }
          function Ws(fo) {
            return function() {
              var ra2 = arguments;
              switch (ra2.length) {
                case 0:
                  return new fo();
                case 1:
                  return new fo(ra2[0]);
                case 2:
                  return new fo(ra2[0], ra2[1]);
                case 3:
                  return new fo(ra2[0], ra2[1], ra2[2]);
                case 4:
                  return new fo(ra2[0], ra2[1], ra2[2], ra2[3]);
                case 5:
                  return new fo(ra2[0], ra2[1], ra2[2], ra2[3], ra2[4]);
                case 6:
                  return new fo(ra2[0], ra2[1], ra2[2], ra2[3], ra2[4], ra2[5]);
                case 7:
                  return new fo(ra2[0], ra2[1], ra2[2], ra2[3], ra2[4], ra2[5], ra2[6]);
              }
              var Ki2 = ml(fo.prototype), ho = fo.apply(Ki2, ra2);
              return G0(ho) ? ho : Ki2;
            };
          }
          function il(fo, ra2, Ki2, ho, Bs, Ql, ff2, hf2, qp, sv) {
            var lg2 = 128 & ra2, H0 = 1 & ra2, ug2 = 2 & ra2, gb2 = 24 & ra2, x_ = 512 & ra2, W2 = ug2 ? void 0 : Ws(fo);
            return function w_() {
              for (var t0 = arguments.length, Hh2 = Array(t0), yy = t0; yy--; )
                Hh2[yy] = arguments[yy];
              if (gb2)
                var f1 = Mh2(w_), G2 = me2(Hh2, f1);
              if (ho && (Hh2 = Rs(Hh2, ho, Bs, gb2)), Ql && (Hh2 = es(Hh2, Ql, ff2, gb2)), t0 -= G2, gb2 && t0 < sv) {
                var qx = be2(Hh2, f1);
                return bs(fo, ra2, il, w_.placeholder, Ki2, Hh2, qx, hf2, qp, sv - t0);
              }
              var S_ = H0 ? Ki2 : this, MS = ug2 ? S_[fo] : fo;
              return t0 = Hh2.length, hf2 ? Hh2 = zy(Hh2, hf2) : x_ && t0 > 1 && Hh2.reverse(), lg2 && qp < t0 && (Hh2.length = qp), this && this !== Ft && this instanceof w_ && (MS = W2 || Ws(MS)), MS.apply(S_, Hh2);
            };
          }
          function bs(fo, ra2, Ki2, ho, Bs, Ql, ff2, hf2, qp, sv) {
            var lg2 = 8 & ra2;
            ra2 |= lg2 ? 32 : 64, 4 & (ra2 &= ~(lg2 ? 64 : 32)) || (ra2 &= -4);
            var H0 = Ki2(fo, ra2, Bs, lg2 ? Ql : void 0, lg2 ? ff2 : void 0, lg2 ? void 0 : Ql, lg2 ? void 0 : ff2, hf2, qp, sv);
            return H0.placeholder = ho, Rd2(H0, fo, ra2);
          }
          function Rl(fo, ra2, Ki2, ho, Bs, Ql, ff2, hf2) {
            var qp = 2 & ra2;
            if (!qp && typeof fo != "function")
              throw new TypeError("Expected a function");
            var sv = ho ? ho.length : 0;
            if (sv || (ra2 &= -97, ho = Bs = void 0), ff2 = ff2 === void 0 ? ff2 : gi2(XT(ff2), 0), hf2 = hf2 === void 0 ? hf2 : XT(hf2), sv -= Bs ? Bs.length : 0, 64 & ra2) {
              var lg2 = ho, H0 = Bs;
              ho = Bs = void 0;
            }
            var ug2 = [fo, ra2, Ki2, ho, Bs, lg2, H0, Ql, ff2, hf2];
            if (fo = ug2[0], ra2 = ug2[1], Ki2 = ug2[2], ho = ug2[3], Bs = ug2[4], !(hf2 = ug2[9] = ug2[9] == null ? qp ? 0 : fo.length : gi2(ug2[9] - sv, 0)) && 24 & ra2 && (ra2 &= -25), ra2 && ra2 != 1)
              gb2 = ra2 == 8 || ra2 == 16 ? function(x_, W2, w_) {
                var t0 = Ws(x_);
                return function Hh2() {
                  for (var yy = arguments.length, f1 = Array(yy), G2 = yy, qx = Mh2(Hh2); G2--; )
                    f1[G2] = arguments[G2];
                  var S_ = yy < 3 && f1[0] !== qx && f1[yy - 1] !== qx ? [] : be2(f1, qx);
                  if ((yy -= S_.length) < w_)
                    return bs(x_, W2, il, Hh2.placeholder, void 0, f1, S_, void 0, void 0, w_ - yy);
                  var MS = this && this !== Ft && this instanceof Hh2 ? t0 : x_;
                  return fe2(MS, this, f1);
                };
              }(fo, ra2, hf2) : ra2 != 32 && ra2 != 33 || Bs.length ? il.apply(void 0, ug2) : function(x_, W2, w_, t0) {
                var Hh2 = 1 & W2, yy = Ws(x_);
                return function f1() {
                  for (var G2 = -1, qx = arguments.length, S_ = -1, MS = t0.length, E5 = Array(MS + qx), sE = this && this !== Ft && this instanceof f1 ? yy : x_; ++S_ < MS; )
                    E5[S_] = t0[S_];
                  for (; qx--; )
                    E5[S_++] = arguments[++G2];
                  return fe2(sE, Hh2 ? w_ : this, E5);
                };
              }(fo, ra2, Ki2, ho);
            else
              var gb2 = function(x_, W2, w_) {
                var t0 = 1 & W2, Hh2 = Ws(x_);
                return function yy() {
                  var f1 = this && this !== Ft && this instanceof yy ? Hh2 : x_;
                  return f1.apply(t0 ? w_ : this, arguments);
                };
              }(fo, ra2, Ki2);
            return Rd2(gb2, fo, ra2);
          }
          function Mh2(fo) {
            return fo.placeholder;
          }
          function au(fo, ra2) {
            var Ki2 = function(ho, Bs) {
              return ho == null ? void 0 : ho[Bs];
            }(fo, ra2);
            return ll(Ki2) ? Ki2 : void 0;
          }
          function eh2(fo) {
            var ra2 = fo.match(z3);
            return ra2 ? ra2[1].split(H2) : [];
          }
          function Gh2(fo, ra2) {
            var Ki2 = ra2.length, ho = Ki2 - 1;
            return ra2[ho] = (Ki2 > 1 ? "& " : "") + ra2[ho], ra2 = ra2.join(Ki2 > 2 ? ", " : " "), fo.replace(N3, `{
/* [wrapped with ` + ra2 + `] */
`);
          }
          function Pp(fo, ra2) {
            return !!(ra2 = ra2 == null ? 9007199254740991 : ra2) && (typeof fo == "number" || bt.test(fo)) && fo > -1 && fo % 1 == 0 && fo < ra2;
          }
          function zy(fo, ra2) {
            for (var Ki2 = fo.length, ho = To(ra2.length, Ki2), Bs = function(ff2, hf2) {
              var qp = -1, sv = ff2.length;
              for (hf2 || (hf2 = Array(sv)); ++qp < sv; )
                hf2[qp] = ff2[qp];
              return hf2;
            }(fo); ho--; ) {
              var Ql = ra2[ho];
              fo[ho] = Pp(Ql, Ki2) ? Bs[Ql] : void 0;
            }
            return fo;
          }
          var Rd2 = us ? function(fo, ra2, Ki2) {
            var ho, Bs = ra2 + "";
            return us(fo, "toString", { configurable: true, enumerable: false, value: (ho = Gh2(Bs, c1(eh2(Bs), Ki2)), function() {
              return ho;
            }) });
          } : function(fo) {
            return fo;
          };
          function c1(fo, ra2) {
            return function(Ki2, ho) {
              for (var Bs = -1, Ql = Ki2 ? Ki2.length : 0; ++Bs < Ql && ho(Ki2[Bs], Bs, Ki2) !== false; )
                ;
            }(I2, function(Ki2) {
              var ho = "_." + Ki2[0];
              ra2 & Ki2[1] && !re2(fo, ho) && fo.push(ho);
            }), fo.sort();
          }
          function _d(fo, ra2, Ki2) {
            var ho = Rl(fo, 8, void 0, void 0, void 0, void 0, void 0, ra2 = Ki2 ? void 0 : ra2);
            return ho.placeholder = _d.placeholder, ho;
          }
          function G0(fo) {
            var ra2 = typeof fo;
            return !!fo && (ra2 == "object" || ra2 == "function");
          }
          function qg2(fo) {
            return fo ? (fo = function(ra2) {
              if (typeof ra2 == "number")
                return ra2;
              if (function(Bs) {
                return typeof Bs == "symbol" || function(Ql) {
                  return !!Ql && typeof Ql == "object";
                }(Bs) && pr.call(Bs) == "[object Symbol]";
              }(ra2))
                return NaN;
              if (G0(ra2)) {
                var Ki2 = typeof ra2.valueOf == "function" ? ra2.valueOf() : ra2;
                ra2 = G0(Ki2) ? Ki2 + "" : Ki2;
              }
              if (typeof ra2 != "string")
                return ra2 === 0 ? ra2 : +ra2;
              ra2 = ra2.replace(P2, "");
              var ho = et.test(ra2);
              return ho || ht.test(ra2) ? _t(ra2.slice(2), ho ? 2 : 8) : $.test(ra2) ? NaN : +ra2;
            }(fo)) === 1 / 0 || fo === -1 / 0 ? 17976931348623157e292 * (fo < 0 ? -1 : 1) : fo == fo ? fo : 0 : fo === 0 ? fo : 0;
          }
          function XT(fo) {
            var ra2 = qg2(fo), Ki2 = ra2 % 1;
            return ra2 == ra2 ? Ki2 ? ra2 - Ki2 : ra2 : 0;
          }
          _d.placeholder = {}, h.exports = _d;
        }).call(this, _(43));
      }, function(h, v4, _) {
        function M2(es) {
          return es && es.__esModule ? es.default : es;
        }
        v4.__esModule = true;
        var I2 = _(95);
        v4.threezerotwofour = M2(I2);
        var P2 = _(96);
        v4.apathy = M2(P2);
        var N3 = _(97);
        v4.ashes = M2(N3);
        var z3 = _(98);
        v4.atelierDune = M2(z3);
        var H2 = _(99);
        v4.atelierForest = M2(H2);
        var $ = _(100);
        v4.atelierHeath = M2($);
        var et = _(101);
        v4.atelierLakeside = M2(et);
        var at = _(102);
        v4.atelierSeaside = M2(at);
        var ht = _(103);
        v4.bespin = M2(ht);
        var bt = _(104);
        v4.brewer = M2(bt);
        var _t = _(105);
        v4.bright = M2(_t);
        var Et = _(106);
        v4.chalk = M2(Et);
        var zt = _(107);
        v4.codeschool = M2(zt);
        var Ft = _(108);
        v4.colors = M2(Ft);
        var fe2 = _(109);
        v4.default = M2(fe2);
        var re2 = _(110);
        v4.eighties = M2(re2);
        var ye = _(111);
        v4.embers = M2(ye);
        var me2 = _(112);
        v4.flat = M2(me2);
        var be2 = _(113);
        v4.google = M2(be2);
        var Te2 = _(114);
        v4.grayscale = M2(Te2);
        var We = _(115);
        v4.greenscreen = M2(We);
        var en = _(116);
        v4.harmonic = M2(en);
        var Ue2 = _(117);
        v4.hopscotch = M2(Ue2);
        var Mn = _(118);
        v4.isotope = M2(Mn);
        var Vn = _(119);
        v4.marrakesh = M2(Vn);
        var xn = _(120);
        v4.mocha = M2(xn);
        var Zr = _(121);
        v4.monokai = M2(Zr);
        var nr = _(122);
        v4.ocean = M2(nr);
        var pr = _(123);
        v4.paraiso = M2(pr);
        var Nr = _(124);
        v4.pop = M2(Nr);
        var ai2 = _(125);
        v4.railscasts = M2(ai2);
        var gi2 = _(126);
        v4.shapeshifter = M2(gi2);
        var To = _(127);
        v4.solarized = M2(To);
        var us = _(128);
        v4.summerfruit = M2(us);
        var ml = _(129);
        v4.tomorrow = M2(ml);
        var ll = _(130);
        v4.tube = M2(ll);
        var Rs = _(131);
        v4.twilight = M2(Rs);
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, h.exports = v4.default;
      }, function(h, v4, _) {
        v4.__esModule = true, v4.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, h.exports = v4.default;
      }, function(h, v4, _) {
        var M2 = _(33);
        function I2(P2) {
          var N3 = Math.round(M2(P2, 0, 255)).toString(16);
          return N3.length == 1 ? "0" + N3 : N3;
        }
        h.exports = function(P2) {
          var N3 = P2.length === 4 ? I2(255 * P2[3]) : "";
          return "#" + I2(P2[0]) + I2(P2[1]) + I2(P2[2]) + N3;
        };
      }, function(h, v4, _) {
        var M2 = _(134), I2 = _(135), P2 = _(136), N3 = _(137), z3 = { "#": I2, hsl: function($) {
          var et = M2($), at = N3(et);
          return et.length === 4 && at.push(et[3]), at;
        }, rgb: P2 };
        function H2($) {
          for (var et in z3)
            if ($.indexOf(et) === 0)
              return z3[et]($);
        }
        H2.rgb = P2, H2.hsl = M2, H2.hex = I2, h.exports = H2;
      }, function(h, v4, _) {
        var M2 = _(44), I2 = _(33);
        function P2(N3, z3) {
          switch (N3 = parseFloat(N3), z3) {
            case 0:
              return I2(N3, 0, 360);
            case 1:
            case 2:
              return I2(N3, 0, 100);
            case 3:
              return I2(N3, 0, 1);
          }
        }
        h.exports = function(N3) {
          return M2(N3).map(P2);
        };
      }, function(h, v4) {
        h.exports = function(_) {
          _.length !== 4 && _.length !== 5 || (_ = function(P2) {
            for (var N3 = "#", z3 = 1; z3 < P2.length; z3++) {
              var H2 = P2.charAt(z3);
              N3 += H2 + H2;
            }
            return N3;
          }(_));
          var M2 = [parseInt(_.substring(1, 3), 16), parseInt(_.substring(3, 5), 16), parseInt(_.substring(5, 7), 16)];
          if (_.length === 9) {
            var I2 = parseFloat((parseInt(_.substring(7, 9), 16) / 255).toFixed(2));
            M2.push(I2);
          }
          return M2;
        };
      }, function(h, v4, _) {
        var M2 = _(44), I2 = _(33);
        function P2(N3, z3) {
          return z3 < 3 ? N3.indexOf("%") != -1 ? Math.round(255 * I2(parseInt(N3, 10), 0, 100) / 100) : I2(parseInt(N3, 10), 0, 255) : I2(parseFloat(N3), 0, 1);
        }
        h.exports = function(N3) {
          return M2(N3).map(P2);
        };
      }, function(h, v4) {
        h.exports = function(_) {
          var M2, I2, P2, N3, z3, H2 = _[0] / 360, $ = _[1] / 100, et = _[2] / 100;
          if ($ == 0)
            return [z3 = 255 * et, z3, z3];
          M2 = 2 * et - (I2 = et < 0.5 ? et * (1 + $) : et + $ - et * $), N3 = [0, 0, 0];
          for (var at = 0; at < 3; at++)
            (P2 = H2 + 1 / 3 * -(at - 1)) < 0 && P2++, P2 > 1 && P2--, z3 = 6 * P2 < 1 ? M2 + 6 * (I2 - M2) * P2 : 2 * P2 < 1 ? I2 : 3 * P2 < 2 ? M2 + (I2 - M2) * (2 / 3 - P2) * 6 : M2, N3[at] = 255 * z3;
          return N3;
        };
      }, function(h, v4, _) {
        (function(M2) {
          var I2 = typeof M2 == "object" && M2 && M2.Object === Object && M2, P2 = typeof self == "object" && self && self.Object === Object && self, N3 = I2 || P2 || Function("return this")();
          function z3(be2, Te2, We) {
            switch (We.length) {
              case 0:
                return be2.call(Te2);
              case 1:
                return be2.call(Te2, We[0]);
              case 2:
                return be2.call(Te2, We[0], We[1]);
              case 3:
                return be2.call(Te2, We[0], We[1], We[2]);
            }
            return be2.apply(Te2, We);
          }
          function H2(be2, Te2) {
            for (var We = -1, en = Te2.length, Ue2 = be2.length; ++We < en; )
              be2[Ue2 + We] = Te2[We];
            return be2;
          }
          var $ = Object.prototype, et = $.hasOwnProperty, at = $.toString, ht = N3.Symbol, bt = $.propertyIsEnumerable, _t = ht ? ht.isConcatSpreadable : void 0, Et = Math.max;
          function zt(be2) {
            return Ft(be2) || function(Te2) {
              return function(We) {
                return function(en) {
                  return !!en && typeof en == "object";
                }(We) && function(en) {
                  return en != null && function(Ue2) {
                    return typeof Ue2 == "number" && Ue2 > -1 && Ue2 % 1 == 0 && Ue2 <= 9007199254740991;
                  }(en.length) && !function(Ue2) {
                    var Mn = function(Vn) {
                      var xn = typeof Vn;
                      return !!Vn && (xn == "object" || xn == "function");
                    }(Ue2) ? at.call(Ue2) : "";
                    return Mn == "[object Function]" || Mn == "[object GeneratorFunction]";
                  }(en);
                }(We);
              }(Te2) && et.call(Te2, "callee") && (!bt.call(Te2, "callee") || at.call(Te2) == "[object Arguments]");
            }(be2) || !!(_t && be2 && be2[_t]);
          }
          var Ft = Array.isArray, fe2, re2, ye, me2 = (re2 = function(be2) {
            var Te2 = (be2 = function en(Ue2, Mn, Vn, xn, Zr) {
              var nr = -1, pr = Ue2.length;
              for (Vn || (Vn = zt), Zr || (Zr = []); ++nr < pr; ) {
                var Nr = Ue2[nr];
                Mn > 0 && Vn(Nr) ? Mn > 1 ? en(Nr, Mn - 1, Vn, xn, Zr) : H2(Zr, Nr) : xn || (Zr[Zr.length] = Nr);
              }
              return Zr;
            }(be2, 1)).length, We = Te2;
            for (fe2; We--; )
              if (typeof be2[We] != "function")
                throw new TypeError("Expected a function");
            return function() {
              for (var en = 0, Ue2 = Te2 ? be2[en].apply(this, arguments) : arguments[0]; ++en < Te2; )
                Ue2 = be2[en].call(this, Ue2);
              return Ue2;
            };
          }, ye = Et(ye === void 0 ? re2.length - 1 : ye, 0), function() {
            for (var be2 = arguments, Te2 = -1, We = Et(be2.length - ye, 0), en = Array(We); ++Te2 < We; )
              en[Te2] = be2[ye + Te2];
            Te2 = -1;
            for (var Ue2 = Array(ye + 1); ++Te2 < ye; )
              Ue2[Te2] = be2[Te2];
            return Ue2[ye] = en, z3(re2, this, Ue2);
          });
          h.exports = me2;
        }).call(this, _(43));
      }, function(h, v4, _) {
        Object.defineProperty(v4, "__esModule", { value: true }), v4.yuv2rgb = function(M2) {
          var I2, P2, N3, z3 = M2[0], H2 = M2[1], $ = M2[2];
          return I2 = 1 * z3 + 0 * H2 + 1.13983 * $, P2 = 1 * z3 + -0.39465 * H2 + -0.5806 * $, N3 = 1 * z3 + 2.02311 * H2 + 0 * $, I2 = Math.min(Math.max(0, I2), 1), P2 = Math.min(Math.max(0, P2), 1), N3 = Math.min(Math.max(0, N3), 1), [255 * I2, 255 * P2, 255 * N3];
        }, v4.rgb2yuv = function(M2) {
          var I2 = M2[0] / 255, P2 = M2[1] / 255, N3 = M2[2] / 255;
          return [0.299 * I2 + 0.587 * P2 + 0.114 * N3, -0.14713 * I2 + -0.28886 * P2 + 0.436 * N3, 0.615 * I2 + -0.51499 * P2 + -0.10001 * N3];
        };
      }, function(h, v4, _) {
        function M2(N3, z3, H2) {
          return z3 in N3 ? Object.defineProperty(N3, z3, { value: H2, enumerable: true, configurable: true, writable: true }) : N3[z3] = H2, N3;
        }
        var I2 = _(141), P2 = function() {
          function N3() {
            M2(this, "_callbacks", void 0), M2(this, "_isDispatching", void 0), M2(this, "_isHandled", void 0), M2(this, "_isPending", void 0), M2(this, "_lastID", void 0), M2(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
          }
          var z3 = N3.prototype;
          return z3.register = function(H2) {
            var $ = "ID_" + this._lastID++;
            return this._callbacks[$] = H2, $;
          }, z3.unregister = function(H2) {
            this._callbacks[H2] || I2(false), delete this._callbacks[H2];
          }, z3.waitFor = function(H2) {
            this._isDispatching || I2(false);
            for (var $ = 0; $ < H2.length; $++) {
              var et = H2[$];
              this._isPending[et] ? this._isHandled[et] || I2(false) : (this._callbacks[et] || I2(false), this._invokeCallback(et));
            }
          }, z3.dispatch = function(H2) {
            this._isDispatching && I2(false), this._startDispatching(H2);
            try {
              for (var $ in this._callbacks)
                this._isPending[$] || this._invokeCallback($);
            } finally {
              this._stopDispatching();
            }
          }, z3.isDispatching = function() {
            return this._isDispatching;
          }, z3._invokeCallback = function(H2) {
            this._isPending[H2] = true, this._callbacks[H2](this._pendingPayload), this._isHandled[H2] = true;
          }, z3._startDispatching = function(H2) {
            for (var $ in this._callbacks)
              this._isPending[$] = false, this._isHandled[$] = false;
            this._pendingPayload = H2, this._isDispatching = true;
          }, z3._stopDispatching = function() {
            delete this._pendingPayload, this._isDispatching = false;
          }, N3;
        }();
        h.exports = P2;
      }, function(h, v4, _) {
        h.exports = function(M2, I2) {
          for (var P2 = arguments.length, N3 = new Array(P2 > 2 ? P2 - 2 : 0), z3 = 2; z3 < P2; z3++)
            N3[z3 - 2] = arguments[z3];
          if (!M2) {
            var H2;
            if (I2 === void 0)
              H2 = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
            else {
              var $ = 0;
              (H2 = new Error(I2.replace(/%s/g, function() {
                return String(N3[$++]);
              }))).name = "Invariant Violation";
            }
            throw H2.framesToPop = 1, H2;
          }
        };
      }, function(h, v4, _) {
        function M2(_r, Er, Ln) {
          return Er in _r ? Object.defineProperty(_r, Er, { value: Ln, enumerable: true, configurable: true, writable: true }) : _r[Er] = Ln, _r;
        }
        function I2(_r, Er) {
          var Ln = Object.keys(_r);
          if (Object.getOwnPropertySymbols) {
            var cr = Object.getOwnPropertySymbols(_r);
            Er && (cr = cr.filter(function(yr) {
              return Object.getOwnPropertyDescriptor(_r, yr).enumerable;
            })), Ln.push.apply(Ln, cr);
          }
          return Ln;
        }
        function P2(_r) {
          for (var Er = 1; Er < arguments.length; Er++) {
            var Ln = arguments[Er] != null ? arguments[Er] : {};
            Er % 2 ? I2(Object(Ln), true).forEach(function(cr) {
              M2(_r, cr, Ln[cr]);
            }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(_r, Object.getOwnPropertyDescriptors(Ln)) : I2(Object(Ln)).forEach(function(cr) {
              Object.defineProperty(_r, cr, Object.getOwnPropertyDescriptor(Ln, cr));
            });
          }
          return _r;
        }
        function N3(_r, Er) {
          if (!(_r instanceof Er))
            throw new TypeError("Cannot call a class as a function");
        }
        function z3(_r, Er) {
          for (var Ln = 0; Ln < Er.length; Ln++) {
            var cr = Er[Ln];
            cr.enumerable = cr.enumerable || false, cr.configurable = true, "value" in cr && (cr.writable = true), Object.defineProperty(_r, cr.key, cr);
          }
        }
        function H2(_r, Er, Ln) {
          return Er && z3(_r.prototype, Er), Ln && z3(_r, Ln), _r;
        }
        function $(_r, Er) {
          return ($ = Object.setPrototypeOf || function(Ln, cr) {
            return Ln.__proto__ = cr, Ln;
          })(_r, Er);
        }
        function et(_r, Er) {
          if (typeof Er != "function" && Er !== null)
            throw new TypeError("Super expression must either be null or a function");
          _r.prototype = Object.create(Er && Er.prototype, { constructor: { value: _r, writable: true, configurable: true } }), Er && $(_r, Er);
        }
        function at(_r) {
          return (at = Object.setPrototypeOf ? Object.getPrototypeOf : function(Er) {
            return Er.__proto__ || Object.getPrototypeOf(Er);
          })(_r);
        }
        function ht(_r) {
          return (ht = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Er) {
            return typeof Er;
          } : function(Er) {
            return Er && typeof Symbol == "function" && Er.constructor === Symbol && Er !== Symbol.prototype ? "symbol" : typeof Er;
          })(_r);
        }
        function bt(_r) {
          if (_r === void 0)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return _r;
        }
        function _t(_r, Er) {
          return !Er || ht(Er) !== "object" && typeof Er != "function" ? bt(_r) : Er;
        }
        function Et(_r) {
          var Er = function() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }();
          return function() {
            var Ln, cr = at(_r);
            if (Er) {
              var yr = at(this).constructor;
              Ln = Reflect.construct(cr, arguments, yr);
            } else
              Ln = cr.apply(this, arguments);
            return _t(this, Ln);
          };
        }
        _.r(v4);
        var zt = _(0), Ft = _.n(zt);
        function fe2() {
          var _r = this.constructor.getDerivedStateFromProps(this.props, this.state);
          _r != null && this.setState(_r);
        }
        function re2(_r) {
          this.setState(function(Er) {
            var Ln = this.constructor.getDerivedStateFromProps(_r, Er);
            return Ln != null ? Ln : null;
          }.bind(this));
        }
        function ye(_r, Er) {
          try {
            var Ln = this.props, cr = this.state;
            this.props = _r, this.state = Er, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Ln, cr);
          } finally {
            this.props = Ln, this.state = cr;
          }
        }
        function me2(_r) {
          var Er = _r.prototype;
          if (!Er || !Er.isReactComponent)
            throw new Error("Can only polyfill class components");
          if (typeof _r.getDerivedStateFromProps != "function" && typeof Er.getSnapshotBeforeUpdate != "function")
            return _r;
          var Ln = null, cr = null, yr = null;
          if (typeof Er.componentWillMount == "function" ? Ln = "componentWillMount" : typeof Er.UNSAFE_componentWillMount == "function" && (Ln = "UNSAFE_componentWillMount"), typeof Er.componentWillReceiveProps == "function" ? cr = "componentWillReceiveProps" : typeof Er.UNSAFE_componentWillReceiveProps == "function" && (cr = "UNSAFE_componentWillReceiveProps"), typeof Er.componentWillUpdate == "function" ? yr = "componentWillUpdate" : typeof Er.UNSAFE_componentWillUpdate == "function" && (yr = "UNSAFE_componentWillUpdate"), Ln !== null || cr !== null || yr !== null) {
            var Ui2 = _r.displayName || _r.name, Qa2 = typeof _r.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
            throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Ui2 + " uses " + Qa2 + " but also contains the following legacy lifecycles:" + (Ln !== null ? `
  ` + Ln : "") + (cr !== null ? `
  ` + cr : "") + (yr !== null ? `
  ` + yr : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
          }
          if (typeof _r.getDerivedStateFromProps == "function" && (Er.componentWillMount = fe2, Er.componentWillReceiveProps = re2), typeof Er.getSnapshotBeforeUpdate == "function") {
            if (typeof Er.componentDidUpdate != "function")
              throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
            Er.componentWillUpdate = ye;
            var Ea2 = Er.componentDidUpdate;
            Er.componentDidUpdate = function(Ci2, Jn, $l) {
              var $f2 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : $l;
              Ea2.call(this, Ci2, Jn, $f2);
            };
          }
          return _r;
        }
        function be2(_r, Er) {
          if (_r == null)
            return {};
          var Ln, cr, yr = function(Qa2, Ea2) {
            if (Qa2 == null)
              return {};
            var Ci2, Jn, $l = {}, $f2 = Object.keys(Qa2);
            for (Jn = 0; Jn < $f2.length; Jn++)
              Ci2 = $f2[Jn], Ea2.indexOf(Ci2) >= 0 || ($l[Ci2] = Qa2[Ci2]);
            return $l;
          }(_r, Er);
          if (Object.getOwnPropertySymbols) {
            var Ui2 = Object.getOwnPropertySymbols(_r);
            for (cr = 0; cr < Ui2.length; cr++)
              Ln = Ui2[cr], Er.indexOf(Ln) >= 0 || Object.prototype.propertyIsEnumerable.call(_r, Ln) && (yr[Ln] = _r[Ln]);
          }
          return yr;
        }
        function Te2(_r) {
          var Er = function(Ln) {
            return {}.toString.call(Ln).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
          }(_r);
          return Er === "number" && (Er = isNaN(_r) ? "nan" : (0 | _r) != _r ? "float" : "integer"), Er;
        }
        fe2.__suppressDeprecationWarning = true, re2.__suppressDeprecationWarning = true, ye.__suppressDeprecationWarning = true;
        var We = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, en = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, Ue2 = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, Mn = _(45), Vn = function(_r) {
          var Er = function(Ln) {
            return { backgroundColor: Ln.base00, ellipsisColor: Ln.base09, braceColor: Ln.base07, expandedIcon: Ln.base0D, collapsedIcon: Ln.base0E, keyColor: Ln.base07, arrayKeyColor: Ln.base0C, objectSize: Ln.base04, copyToClipboard: Ln.base0F, copyToClipboardCheck: Ln.base0D, objectBorder: Ln.base02, dataTypes: { boolean: Ln.base0E, date: Ln.base0D, float: Ln.base0B, function: Ln.base0D, integer: Ln.base0F, string: Ln.base09, nan: Ln.base08, null: Ln.base0A, undefined: Ln.base05, regexp: Ln.base0A, background: Ln.base02 }, editVariable: { editIcon: Ln.base0E, cancelIcon: Ln.base09, removeIcon: Ln.base09, addIcon: Ln.base0E, checkIcon: Ln.base0E, background: Ln.base01, color: Ln.base0A, border: Ln.base07 }, addKeyModal: { background: Ln.base05, border: Ln.base04, color: Ln.base0A, labelColor: Ln.base01 }, validationFailure: { background: Ln.base09, iconColor: Ln.base01, fontColor: Ln.base01 } };
          }(_r);
          return { "app-container": { fontFamily: Ue2.globalFontFamily, cursor: Ue2.globalCursor, backgroundColor: Er.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Er.ellipsisColor, fontSize: Ue2.ellipsisFontSize, lineHeight: Ue2.ellipsisLineHeight, cursor: Ue2.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: Ue2.braceCursor, fontWeight: Ue2.braceFontWeight, color: Er.braceColor }, "expanded-icon": { color: Er.expandedIcon }, "collapsed-icon": { color: Er.collapsedIcon }, colon: { display: "inline-block", margin: Ue2.keyMargin, color: Er.keyColor, verticalAlign: "top" }, objectKeyVal: function(Ln, cr) {
            return { style: P2({ paddingTop: Ue2.keyValPaddingTop, paddingRight: Ue2.keyValPaddingRight, paddingBottom: Ue2.keyValPaddingBottom, borderLeft: Ue2.keyValBorderLeft + " " + Er.objectBorder, ":hover": { paddingLeft: cr.paddingLeft - 1 + "px", borderLeft: Ue2.keyValBorderHover + " " + Er.objectBorder } }, cr) };
          }, "object-key-val-no-border": { padding: Ue2.keyValPadding }, "pushed-content": { marginLeft: Ue2.pushedContentMarginLeft }, variableValue: function(Ln, cr) {
            return { style: P2({ display: "inline-block", paddingRight: Ue2.variableValuePaddingRight, position: "relative" }, cr) };
          }, "object-name": { display: "inline-block", color: Er.keyColor, letterSpacing: Ue2.keyLetterSpacing, fontStyle: Ue2.keyFontStyle, verticalAlign: Ue2.keyVerticalAlign, opacity: Ue2.keyOpacity, ":hover": { opacity: Ue2.keyOpacityHover } }, "array-key": { display: "inline-block", color: Er.arrayKeyColor, letterSpacing: Ue2.keyLetterSpacing, fontStyle: Ue2.keyFontStyle, verticalAlign: Ue2.keyVerticalAlign, opacity: Ue2.keyOpacity, ":hover": { opacity: Ue2.keyOpacityHover } }, "object-size": { color: Er.objectSize, borderRadius: Ue2.objectSizeBorderRadius, fontStyle: Ue2.objectSizeFontStyle, margin: Ue2.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: Ue2.dataTypeFontSize, marginRight: Ue2.dataTypeMarginRight, opacity: Ue2.datatypeOpacity }, boolean: { display: "inline-block", color: Er.dataTypes.boolean }, date: { display: "inline-block", color: Er.dataTypes.date }, "date-value": { marginLeft: Ue2.dateValueMarginLeft }, float: { display: "inline-block", color: Er.dataTypes.float }, function: { display: "inline-block", color: Er.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Er.dataTypes.integer }, string: { display: "inline-block", color: Er.dataTypes.string }, nan: { display: "inline-block", color: Er.dataTypes.nan, fontSize: Ue2.nanFontSize, fontWeight: Ue2.nanFontWeight, backgroundColor: Er.dataTypes.background, padding: Ue2.nanPadding, borderRadius: Ue2.nanBorderRadius }, null: { display: "inline-block", color: Er.dataTypes.null, fontSize: Ue2.nullFontSize, fontWeight: Ue2.nullFontWeight, backgroundColor: Er.dataTypes.background, padding: Ue2.nullPadding, borderRadius: Ue2.nullBorderRadius }, undefined: { display: "inline-block", color: Er.dataTypes.undefined, fontSize: Ue2.undefinedFontSize, padding: Ue2.undefinedPadding, borderRadius: Ue2.undefinedBorderRadius, backgroundColor: Er.dataTypes.background }, regexp: { display: "inline-block", color: Er.dataTypes.regexp }, "copy-to-clipboard": { cursor: Ue2.clipboardCursor }, "copy-icon": { color: Er.copyToClipboard, fontSize: Ue2.iconFontSize, marginRight: Ue2.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Er.copyToClipboardCheck, marginLeft: Ue2.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: Ue2.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: Ue2.metaDataPadding }, "icon-container": { display: "inline-block", width: Ue2.iconContainerWidth }, tooltip: { padding: Ue2.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Er.editVariable.removeIcon, cursor: Ue2.iconCursor, fontSize: Ue2.iconFontSize, marginRight: Ue2.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Er.editVariable.addIcon, cursor: Ue2.iconCursor, fontSize: Ue2.iconFontSize, marginRight: Ue2.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Er.editVariable.editIcon, cursor: Ue2.iconCursor, fontSize: Ue2.iconFontSize, marginRight: Ue2.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: Ue2.iconCursor, color: Er.editVariable.checkIcon, fontSize: Ue2.iconFontSize, paddingRight: Ue2.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: Ue2.iconCursor, color: Er.editVariable.cancelIcon, fontSize: Ue2.iconFontSize, paddingRight: Ue2.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: Ue2.editInputMinWidth, borderRadius: Ue2.editInputBorderRadius, backgroundColor: Er.editVariable.background, color: Er.editVariable.color, padding: Ue2.editInputPadding, marginRight: Ue2.editInputMarginRight, fontFamily: Ue2.editInputFontFamily }, "detected-row": { paddingTop: Ue2.detectedRowPaddingTop }, "key-modal-request": { position: Ue2.addKeyCoverPosition, top: Ue2.addKeyCoverPositionPx, left: Ue2.addKeyCoverPositionPx, right: Ue2.addKeyCoverPositionPx, bottom: Ue2.addKeyCoverPositionPx, backgroundColor: Ue2.addKeyCoverBackground }, "key-modal": { width: Ue2.addKeyModalWidth, backgroundColor: Er.addKeyModal.background, marginLeft: Ue2.addKeyModalMargin, marginRight: Ue2.addKeyModalMargin, padding: Ue2.addKeyModalPadding, borderRadius: Ue2.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Er.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Er.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Er.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Er.addKeyModal.labelColor, fontSize: Ue2.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Er.editVariable.addIcon, fontSize: Ue2.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Er.ellipsisColor, fontSize: Ue2.ellipsisFontSize, lineHeight: Ue2.ellipsisLineHeight, cursor: Ue2.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Er.validationFailure.fontColor, backgroundColor: Er.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Er.validationFailure.iconColor, fontSize: Ue2.iconFontSize, transform: "rotate(45deg)" } };
        };
        function xn(_r, Er, Ln) {
          return _r || console.error("theme has not been set"), function(cr) {
            var yr = We;
            return cr !== false && cr !== "none" || (yr = en), Object(Mn.createStyling)(Vn, { defaultBase16: yr })(cr);
          }(_r)(Er, Ln);
        }
        var Zr = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = (cr.rjvId, cr.type_name), Ui2 = cr.displayDataTypes, Qa2 = cr.theme;
            return Ui2 ? Ft.a.createElement("span", Object.assign({ className: "data-type-label" }, xn(Qa2, "data-type-label")), yr) : null;
          } }]), Ln;
        }(Ft.a.PureComponent), nr = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props;
            return Ft.a.createElement("div", xn(cr.theme, "boolean"), Ft.a.createElement(Zr, Object.assign({ type_name: "bool" }, cr)), cr.value ? "true" : "false");
          } }]), Ln;
        }(Ft.a.PureComponent), pr = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props;
            return Ft.a.createElement("div", xn(cr.theme, "date"), Ft.a.createElement(Zr, Object.assign({ type_name: "date" }, cr)), Ft.a.createElement("span", Object.assign({ className: "date-value" }, xn(cr.theme, "date-value")), cr.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
          } }]), Ln;
        }(Ft.a.PureComponent), Nr = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props;
            return Ft.a.createElement("div", xn(cr.theme, "float"), Ft.a.createElement(Zr, Object.assign({ type_name: "float" }, cr)), this.props.value);
          } }]), Ln;
        }(Ft.a.PureComponent);
        function ai2(_r, Er) {
          (Er == null || Er > _r.length) && (Er = _r.length);
          for (var Ln = 0, cr = new Array(Er); Ln < Er; Ln++)
            cr[Ln] = _r[Ln];
          return cr;
        }
        function gi2(_r, Er) {
          if (_r) {
            if (typeof _r == "string")
              return ai2(_r, Er);
            var Ln = Object.prototype.toString.call(_r).slice(8, -1);
            return Ln === "Object" && _r.constructor && (Ln = _r.constructor.name), Ln === "Map" || Ln === "Set" ? Array.from(_r) : Ln === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ln) ? ai2(_r, Er) : void 0;
          }
        }
        function To(_r, Er) {
          var Ln;
          if (typeof Symbol == "undefined" || _r[Symbol.iterator] == null) {
            if (Array.isArray(_r) || (Ln = gi2(_r)) || Er && _r && typeof _r.length == "number") {
              Ln && (_r = Ln);
              var cr = 0, yr = function() {
              };
              return { s: yr, n: function() {
                return cr >= _r.length ? { done: true } : { done: false, value: _r[cr++] };
              }, e: function(Ci2) {
                throw Ci2;
              }, f: yr };
            }
            throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          var Ui2, Qa2 = true, Ea2 = false;
          return { s: function() {
            Ln = _r[Symbol.iterator]();
          }, n: function() {
            var Ci2 = Ln.next();
            return Qa2 = Ci2.done, Ci2;
          }, e: function(Ci2) {
            Ea2 = true, Ui2 = Ci2;
          }, f: function() {
            try {
              Qa2 || Ln.return == null || Ln.return();
            } finally {
              if (Ea2)
                throw Ui2;
            }
          } };
        }
        function us(_r) {
          return function(Er) {
            if (Array.isArray(Er))
              return ai2(Er);
          }(_r) || function(Er) {
            if (typeof Symbol != "undefined" && Symbol.iterator in Object(Er))
              return Array.from(Er);
          }(_r) || gi2(_r) || function() {
            throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }();
        }
        var ml = _(46), ll = new (_(47)).Dispatcher(), Rs = new (function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            var cr;
            N3(this, Ln);
            for (var yr = arguments.length, Ui2 = new Array(yr), Qa2 = 0; Qa2 < yr; Qa2++)
              Ui2[Qa2] = arguments[Qa2];
            return (cr = Er.call.apply(Er, [this].concat(Ui2))).objects = {}, cr.set = function(Ea2, Ci2, Jn, $l) {
              cr.objects[Ea2] === void 0 && (cr.objects[Ea2] = {}), cr.objects[Ea2][Ci2] === void 0 && (cr.objects[Ea2][Ci2] = {}), cr.objects[Ea2][Ci2][Jn] = $l;
            }, cr.get = function(Ea2, Ci2, Jn, $l) {
              return cr.objects[Ea2] === void 0 || cr.objects[Ea2][Ci2] === void 0 || cr.objects[Ea2][Ci2][Jn] == null ? $l : cr.objects[Ea2][Ci2][Jn];
            }, cr.handleAction = function(Ea2) {
              var Ci2 = Ea2.rjvId, Jn = Ea2.data;
              switch (Ea2.name) {
                case "RESET":
                  cr.emit("reset-" + Ci2);
                  break;
                case "VARIABLE_UPDATED":
                  Ea2.data.updated_src = cr.updateSrc(Ci2, Jn), cr.set(Ci2, "action", "variable-update", P2(P2({}, Jn), {}, { type: "variable-edited" })), cr.emit("variable-update-" + Ci2);
                  break;
                case "VARIABLE_REMOVED":
                  Ea2.data.updated_src = cr.updateSrc(Ci2, Jn), cr.set(Ci2, "action", "variable-update", P2(P2({}, Jn), {}, { type: "variable-removed" })), cr.emit("variable-update-" + Ci2);
                  break;
                case "VARIABLE_ADDED":
                  Ea2.data.updated_src = cr.updateSrc(Ci2, Jn), cr.set(Ci2, "action", "variable-update", P2(P2({}, Jn), {}, { type: "variable-added" })), cr.emit("variable-update-" + Ci2);
                  break;
                case "ADD_VARIABLE_KEY_REQUEST":
                  cr.set(Ci2, "action", "new-key-request", Jn), cr.emit("add-key-request-" + Ci2);
              }
            }, cr.updateSrc = function(Ea2, Ci2) {
              var Jn = Ci2.name, $l = Ci2.namespace, $f2 = Ci2.new_value, pf2 = (Ci2.existing_value, Ci2.variable_removed);
              $l.shift();
              var xd2, $s = cr.get(Ea2, "global", "src"), Zp = cr.deepCopy($s, us($l)), lv = Zp, Ru = To($l);
              try {
                for (Ru.s(); !(xd2 = Ru.n()).done; )
                  lv = lv[xd2.value];
              } catch (U0) {
                Ru.e(U0);
              } finally {
                Ru.f();
              }
              return pf2 ? Te2(lv) == "array" ? lv.splice(Jn, 1) : delete lv[Jn] : Jn !== null ? lv[Jn] = $f2 : Zp = $f2, cr.set(Ea2, "global", "src", Zp), Zp;
            }, cr.deepCopy = function(Ea2, Ci2) {
              var Jn, $l = Te2(Ea2), $f2 = Ci2.shift();
              return $l == "array" ? Jn = us(Ea2) : $l == "object" && (Jn = P2({}, Ea2)), $f2 !== void 0 && (Jn[$f2] = cr.deepCopy(Ea2[$f2], Ci2)), Jn;
            }, cr;
          }
          return Ln;
        }(ml.EventEmitter))();
        ll.register(Rs.handleAction.bind(Rs));
        var es = Rs, Ws = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            return N3(this, Ln), (yr = Er.call(this, cr)).toggleCollapsed = function() {
              yr.setState({ collapsed: !yr.state.collapsed }, function() {
                es.set(yr.props.rjvId, yr.props.namespace, "collapsed", yr.state.collapsed);
              });
            }, yr.getFunctionDisplay = function(Ui2) {
              var Qa2 = bt(yr).props;
              return Ui2 ? Ft.a.createElement("span", null, yr.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), Ft.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, Ft.a.createElement("span", null, "{"), Ft.a.createElement("span", xn(Qa2.theme, "ellipsis"), "..."), Ft.a.createElement("span", null, "}"))) : yr.props.value.toString().slice(9, -1);
            }, yr.state = { collapsed: es.get(cr.rjvId, cr.namespace, "collapsed", true) }, yr;
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = this.state.collapsed;
            return Ft.a.createElement("div", xn(cr.theme, "function"), Ft.a.createElement(Zr, Object.assign({ type_name: "function" }, cr)), Ft.a.createElement("span", Object.assign({}, xn(cr.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(yr)));
          } }]), Ln;
        }(Ft.a.PureComponent), il = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            return Ft.a.createElement("div", xn(this.props.theme, "nan"), "NaN");
          } }]), Ln;
        }(Ft.a.PureComponent), bs = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            return Ft.a.createElement("div", xn(this.props.theme, "null"), "NULL");
          } }]), Ln;
        }(Ft.a.PureComponent), Rl = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props;
            return Ft.a.createElement("div", xn(cr.theme, "integer"), Ft.a.createElement(Zr, Object.assign({ type_name: "int" }, cr)), this.props.value);
          } }]), Ln;
        }(Ft.a.PureComponent), Mh2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props;
            return Ft.a.createElement("div", xn(cr.theme, "regexp"), Ft.a.createElement(Zr, Object.assign({ type_name: "regexp" }, cr)), this.props.value.toString());
          } }]), Ln;
        }(Ft.a.PureComponent), au = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            return N3(this, Ln), (yr = Er.call(this, cr)).toggleCollapsed = function() {
              yr.setState({ collapsed: !yr.state.collapsed }, function() {
                es.set(yr.props.rjvId, yr.props.namespace, "collapsed", yr.state.collapsed);
              });
            }, yr.state = { collapsed: es.get(cr.rjvId, cr.namespace, "collapsed", true) }, yr;
          }
          return H2(Ln, [{ key: "render", value: function() {
            this.state.collapsed;
            var cr = this.props, yr = cr.collapseStringsAfterLength, Ui2 = cr.theme, Qa2 = cr.value, Ea2 = { style: { cursor: "default" } };
            return Te2(yr) === "integer" && Qa2.length > yr && (Ea2.style.cursor = "pointer", this.state.collapsed && (Qa2 = Ft.a.createElement("span", null, Qa2.substring(0, yr), Ft.a.createElement("span", xn(Ui2, "ellipsis"), " ...")))), Ft.a.createElement("div", xn(Ui2, "string"), Ft.a.createElement(Zr, Object.assign({ type_name: "string" }, cr)), Ft.a.createElement("span", Object.assign({ className: "string-value" }, Ea2, { onClick: this.toggleCollapsed }), '"', Qa2, '"'));
          } }]), Ln;
        }(Ft.a.PureComponent), eh2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            return Ft.a.createElement("div", xn(this.props.theme, "undefined"), "undefined");
          } }]), Ln;
        }(Ft.a.PureComponent);
        function Gh2() {
          return (Gh2 = Object.assign || function(_r) {
            for (var Er = 1; Er < arguments.length; Er++) {
              var Ln = arguments[Er];
              for (var cr in Ln)
                Object.prototype.hasOwnProperty.call(Ln, cr) && (_r[cr] = Ln[cr]);
            }
            return _r;
          }).apply(this, arguments);
        }
        var Pp = zt.useLayoutEffect, zy = function(_r) {
          var Er = Object(zt.useRef)(_r);
          return Pp(function() {
            Er.current = _r;
          }), Er;
        }, Rd2 = function(_r, Er) {
          typeof _r != "function" ? _r.current = Er : _r(Er);
        }, c1 = function(_r, Er) {
          var Ln = Object(zt.useRef)();
          return Object(zt.useCallback)(function(cr) {
            _r.current = cr, Ln.current && Rd2(Ln.current, null), Ln.current = Er, Er && Rd2(Er, cr);
          }, [Er]);
        }, _d = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, G0 = function(_r) {
          Object.keys(_d).forEach(function(Er) {
            _r.style.setProperty(Er, _d[Er], "important");
          });
        }, qg2 = null, XT = function() {
        }, fo = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], ra2 = !!document.documentElement.currentStyle, Ki2 = function(_r, Er) {
          var Ln = _r.cacheMeasurements, cr = _r.maxRows, yr = _r.minRows, Ui2 = _r.onChange, Qa2 = Ui2 === void 0 ? XT : Ui2, Ea2 = _r.onHeightChange, Ci2 = Ea2 === void 0 ? XT : Ea2, Jn = function(Ru, U0) {
            if (Ru == null)
              return {};
            var M_, oC, lN = {}, sC = Object.keys(Ru);
            for (oC = 0; oC < sC.length; oC++)
              M_ = sC[oC], U0.indexOf(M_) >= 0 || (lN[M_] = Ru[M_]);
            return lN;
          }(_r, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), $l, $f2 = Jn.value !== void 0, pf2 = Object(zt.useRef)(null), xd2 = c1(pf2, Er), $s = Object(zt.useRef)(0), Zp = Object(zt.useRef)(), lv = function() {
            var Ru = pf2.current, U0 = Ln && Zp.current ? Zp.current : function(sC) {
              var Zx = window.getComputedStyle(sC);
              if (Zx === null)
                return null;
              var QT, my = (QT = Zx, fo.reduce(function(JT, uE) {
                return JT[uE] = QT[uE], JT;
              }, {})), C_ = my.boxSizing;
              return C_ === "" ? null : (ra2 && C_ === "border-box" && (my.width = parseFloat(my.width) + parseFloat(my.borderRightWidth) + parseFloat(my.borderLeftWidth) + parseFloat(my.paddingRight) + parseFloat(my.paddingLeft) + "px"), { sizingStyle: my, paddingSize: parseFloat(my.paddingBottom) + parseFloat(my.paddingTop), borderSize: parseFloat(my.borderBottomWidth) + parseFloat(my.borderTopWidth) });
            }(Ru);
            if (U0) {
              Zp.current = U0;
              var M_ = function(sC, Zx, QT, my) {
                QT === void 0 && (QT = 1), my === void 0 && (my = 1 / 0), qg2 || ((qg2 = document.createElement("textarea")).setAttribute("tab-index", "-1"), qg2.setAttribute("aria-hidden", "true"), G0(qg2)), qg2.parentNode === null && document.body.appendChild(qg2);
                var C_ = sC.paddingSize, JT = sC.borderSize, uE = sC.sizingStyle, $L = uE.boxSizing;
                Object.keys(uE).forEach(function(hE) {
                  var k5 = hE;
                  qg2.style[k5] = uE[k5];
                }), G0(qg2), qg2.value = Zx;
                var cE = function(hE, k5) {
                  var uN = hE.scrollHeight;
                  return k5.sizingStyle.boxSizing === "border-box" ? uN + k5.borderSize : uN - k5.paddingSize;
                }(qg2, sC);
                qg2.value = "x";
                var cV = qg2.scrollHeight - C_, YL = cV * QT;
                $L === "border-box" && (YL = YL + C_ + JT), cE = Math.max(YL, cE);
                var fE = cV * my;
                return $L === "border-box" && (fE = fE + C_ + JT), [cE = Math.min(fE, cE), cV];
              }(U0, Ru.value || Ru.placeholder || "x", yr, cr), oC = M_[0], lN = M_[1];
              $s.current !== oC && ($s.current = oC, Ru.style.setProperty("height", oC + "px", "important"), Ci2(oC, { rowHeight: lN }));
            }
          };
          return Object(zt.useLayoutEffect)(lv), $l = zy(lv), Object(zt.useLayoutEffect)(function() {
            var Ru = function(U0) {
              $l.current(U0);
            };
            return window.addEventListener("resize", Ru), function() {
              window.removeEventListener("resize", Ru);
            };
          }, []), Object(zt.createElement)("textarea", Gh2({}, Jn, { onChange: function(Ru) {
            $f2 || lv(), Qa2(Ru);
          }, ref: xd2 }));
        }, ho = Object(zt.forwardRef)(Ki2);
        function Bs(_r) {
          _r = _r.trim();
          try {
            if ((_r = JSON.stringify(JSON.parse(_r)))[0] === "[")
              return Ql("array", JSON.parse(_r));
            if (_r[0] === "{")
              return Ql("object", JSON.parse(_r));
            if (_r.match(/\-?\d+\.\d+/) && _r.match(/\-?\d+\.\d+/)[0] === _r)
              return Ql("float", parseFloat(_r));
            if (_r.match(/\-?\d+e-\d+/) && _r.match(/\-?\d+e-\d+/)[0] === _r)
              return Ql("float", Number(_r));
            if (_r.match(/\-?\d+/) && _r.match(/\-?\d+/)[0] === _r)
              return Ql("integer", parseInt(_r));
            if (_r.match(/\-?\d+e\+\d+/) && _r.match(/\-?\d+e\+\d+/)[0] === _r)
              return Ql("integer", Number(_r));
          } catch {
          }
          switch (_r = _r.toLowerCase()) {
            case "undefined":
              return Ql("undefined", void 0);
            case "nan":
              return Ql("nan", NaN);
            case "null":
              return Ql("null", null);
            case "true":
              return Ql("boolean", true);
            case "false":
              return Ql("boolean", false);
            default:
              if (_r = Date.parse(_r))
                return Ql("date", new Date(_r));
          }
          return Ql(false, null);
        }
        function Ql(_r, Er) {
          return { type: _r, value: Er };
        }
        var ff2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
          } }]), Ln;
        }(Ft.a.PureComponent), hf2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
          } }]), Ln;
        }(Ft.a.PureComponent), qp = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]), Qa2 = Hh2(yr).style;
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", { fill: Qa2.color, width: Qa2.height, height: Qa2.width, style: Qa2, viewBox: "0 0 1792 1792" }, Ft.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), Ln;
        }(Ft.a.PureComponent), sv = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]), Qa2 = Hh2(yr).style;
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", { fill: Qa2.color, width: Qa2.height, height: Qa2.width, style: Qa2, viewBox: "0 0 1792 1792" }, Ft.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), Ln;
        }(Ft.a.PureComponent), lg2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", { style: P2(P2({}, Hh2(yr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Ft.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
          } }]), Ln;
        }(Ft.a.PureComponent), H0 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", { style: P2(P2({}, Hh2(yr).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Ft.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
          } }]), Ln;
        }(Ft.a.PureComponent), ug2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("g", null, Ft.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
          } }]), Ln;
        }(Ft.a.PureComponent), gb2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("g", null, Ft.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), Ln;
        }(Ft.a.PureComponent), x_ = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("g", null, Ft.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), Ln;
        }(Ft.a.PureComponent), W2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("g", null, Ft.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
          } }]), Ln;
        }(Ft.a.PureComponent), w_ = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("g", null, Ft.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
          } }]), Ln;
        }(Ft.a.PureComponent), t0 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.style, Ui2 = be2(cr, ["style"]);
            return Ft.a.createElement("span", Ui2, Ft.a.createElement("svg", Object.assign({}, Hh2(yr), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ft.a.createElement("g", null, Ft.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), Ln;
        }(Ft.a.PureComponent);
        function Hh2(_r) {
          return _r || (_r = {}), { style: P2(P2({ verticalAlign: "middle" }, _r), {}, { color: _r.color ? _r.color : "#000000", height: "1em", width: "1em" }) };
        }
        var yy = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            return N3(this, Ln), (yr = Er.call(this, cr)).copiedTimer = null, yr.handleCopy = function() {
              var Ui2 = document.createElement("textarea"), Qa2 = yr.props, Ea2 = Qa2.clickCallback, Ci2 = Qa2.src, Jn = Qa2.namespace;
              Ui2.innerHTML = JSON.stringify(yr.clipboardValue(Ci2), null, "  "), document.body.appendChild(Ui2), Ui2.select(), document.execCommand("copy"), document.body.removeChild(Ui2), yr.copiedTimer = setTimeout(function() {
                yr.setState({ copied: false });
              }, 5500), yr.setState({ copied: true }, function() {
                typeof Ea2 == "function" && Ea2({ src: Ci2, namespace: Jn, name: Jn[Jn.length - 1] });
              });
            }, yr.getClippyIcon = function() {
              var Ui2 = yr.props.theme;
              return yr.state.copied ? Ft.a.createElement("span", null, Ft.a.createElement(ug2, Object.assign({ className: "copy-icon" }, xn(Ui2, "copy-icon"))), Ft.a.createElement("span", xn(Ui2, "copy-icon-copied"), "\u2714")) : Ft.a.createElement(ug2, Object.assign({ className: "copy-icon" }, xn(Ui2, "copy-icon")));
            }, yr.clipboardValue = function(Ui2) {
              switch (Te2(Ui2)) {
                case "function":
                case "regexp":
                  return Ui2.toString();
                default:
                  return Ui2;
              }
            }, yr.state = { copied: false }, yr;
          }
          return H2(Ln, [{ key: "componentWillUnmount", value: function() {
            this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
          } }, { key: "render", value: function() {
            var cr = this.props, yr = (cr.src, cr.theme), Ui2 = cr.hidden, Qa2 = cr.rowHovered, Ea2 = xn(yr, "copy-to-clipboard").style, Ci2 = "inline";
            return Ui2 && (Ci2 = "none"), Ft.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Qa2 ? "inline-block" : "none" } }, Ft.a.createElement("span", { style: P2(P2({}, Ea2), {}, { display: Ci2 }), onClick: this.handleCopy }, this.getClippyIcon()));
          } }]), Ln;
        }(Ft.a.PureComponent), f1 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            return N3(this, Ln), (yr = Er.call(this, cr)).getEditIcon = function() {
              var Ui2 = yr.props, Qa2 = Ui2.variable, Ea2 = Ui2.theme;
              return Ft.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: yr.state.hovered ? "inline-block" : "none" } }, Ft.a.createElement(w_, Object.assign({ className: "click-to-edit-icon" }, xn(Ea2, "editVarIcon"), { onClick: function() {
                yr.prepopInput(Qa2);
              } })));
            }, yr.prepopInput = function(Ui2) {
              if (yr.props.onEdit !== false) {
                var Qa2 = function(Ci2) {
                  var Jn;
                  switch (Te2(Ci2)) {
                    case "undefined":
                      Jn = "undefined";
                      break;
                    case "nan":
                      Jn = "NaN";
                      break;
                    case "string":
                      Jn = Ci2;
                      break;
                    case "date":
                    case "function":
                    case "regexp":
                      Jn = Ci2.toString();
                      break;
                    default:
                      try {
                        Jn = JSON.stringify(Ci2, null, "  ");
                      } catch {
                        Jn = "";
                      }
                  }
                  return Jn;
                }(Ui2.value), Ea2 = Bs(Qa2);
                yr.setState({ editMode: true, editValue: Qa2, parsedInput: { type: Ea2.type, value: Ea2.value } });
              }
            }, yr.getRemoveIcon = function() {
              var Ui2 = yr.props, Qa2 = Ui2.variable, Ea2 = Ui2.namespace, Ci2 = Ui2.theme, Jn = Ui2.rjvId;
              return Ft.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: yr.state.hovered ? "inline-block" : "none" } }, Ft.a.createElement(gb2, Object.assign({ className: "click-to-remove-icon" }, xn(Ci2, "removeVarIcon"), { onClick: function() {
                ll.dispatch({ name: "VARIABLE_REMOVED", rjvId: Jn, data: { name: Qa2.name, namespace: Ea2, existing_value: Qa2.value, variable_removed: true } });
              } })));
            }, yr.getValue = function(Ui2, Qa2) {
              var Ea2 = !Qa2 && Ui2.type, Ci2 = bt(yr).props;
              switch (Ea2) {
                case false:
                  return yr.getEditInput();
                case "string":
                  return Ft.a.createElement(au, Object.assign({ value: Ui2.value }, Ci2));
                case "integer":
                  return Ft.a.createElement(Rl, Object.assign({ value: Ui2.value }, Ci2));
                case "float":
                  return Ft.a.createElement(Nr, Object.assign({ value: Ui2.value }, Ci2));
                case "boolean":
                  return Ft.a.createElement(nr, Object.assign({ value: Ui2.value }, Ci2));
                case "function":
                  return Ft.a.createElement(Ws, Object.assign({ value: Ui2.value }, Ci2));
                case "null":
                  return Ft.a.createElement(bs, Ci2);
                case "nan":
                  return Ft.a.createElement(il, Ci2);
                case "undefined":
                  return Ft.a.createElement(eh2, Ci2);
                case "date":
                  return Ft.a.createElement(pr, Object.assign({ value: Ui2.value }, Ci2));
                case "regexp":
                  return Ft.a.createElement(Mh2, Object.assign({ value: Ui2.value }, Ci2));
                default:
                  return Ft.a.createElement("div", { className: "object-value" }, JSON.stringify(Ui2.value));
              }
            }, yr.getEditInput = function() {
              var Ui2 = yr.props.theme, Qa2 = yr.state.editValue;
              return Ft.a.createElement("div", null, Ft.a.createElement(ho, Object.assign({ type: "text", inputRef: function(Ea2) {
                return Ea2 && Ea2.focus();
              }, value: Qa2, className: "variable-editor", onChange: function(Ea2) {
                var Ci2 = Ea2.target.value, Jn = Bs(Ci2);
                yr.setState({ editValue: Ci2, parsedInput: { type: Jn.type, value: Jn.value } });
              }, onKeyDown: function(Ea2) {
                switch (Ea2.key) {
                  case "Escape":
                    yr.setState({ editMode: false, editValue: "" });
                    break;
                  case "Enter":
                    (Ea2.ctrlKey || Ea2.metaKey) && yr.submitEdit(true);
                }
                Ea2.stopPropagation();
              }, placeholder: "update this value", minRows: 2 }, xn(Ui2, "edit-input"))), Ft.a.createElement("div", xn(Ui2, "edit-icon-container"), Ft.a.createElement(gb2, Object.assign({ className: "edit-cancel" }, xn(Ui2, "cancel-icon"), { onClick: function() {
                yr.setState({ editMode: false, editValue: "" });
              } })), Ft.a.createElement(t0, Object.assign({ className: "edit-check string-value" }, xn(Ui2, "check-icon"), { onClick: function() {
                yr.submitEdit();
              } })), Ft.a.createElement("div", null, yr.showDetected())));
            }, yr.submitEdit = function(Ui2) {
              var Qa2 = yr.props, Ea2 = Qa2.variable, Ci2 = Qa2.namespace, Jn = Qa2.rjvId, $l = yr.state, $f2 = $l.editValue, pf2 = $l.parsedInput, xd2 = $f2;
              Ui2 && pf2.type && (xd2 = pf2.value), yr.setState({ editMode: false }), ll.dispatch({ name: "VARIABLE_UPDATED", rjvId: Jn, data: { name: Ea2.name, namespace: Ci2, existing_value: Ea2.value, new_value: xd2, variable_removed: false } });
            }, yr.showDetected = function() {
              var Ui2 = yr.props, Qa2 = Ui2.theme, Ea2 = (Ui2.variable, Ui2.namespace, Ui2.rjvId, yr.state.parsedInput), Ci2 = (Ea2.type, Ea2.value, yr.getDetectedInput());
              if (Ci2)
                return Ft.a.createElement("div", null, Ft.a.createElement("div", xn(Qa2, "detected-row"), Ci2, Ft.a.createElement(t0, { className: "edit-check detected", style: P2({ verticalAlign: "top", paddingLeft: "3px" }, xn(Qa2, "check-icon").style), onClick: function() {
                  yr.submitEdit(true);
                } })));
            }, yr.getDetectedInput = function() {
              var Ui2 = yr.state.parsedInput, Qa2 = Ui2.type, Ea2 = Ui2.value, Ci2 = bt(yr).props, Jn = Ci2.theme;
              if (Qa2 !== false)
                switch (Qa2.toLowerCase()) {
                  case "object":
                    return Ft.a.createElement("span", null, Ft.a.createElement("span", { style: P2(P2({}, xn(Jn, "brace").style), {}, { cursor: "default" }) }, "{"), Ft.a.createElement("span", { style: P2(P2({}, xn(Jn, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Ft.a.createElement("span", { style: P2(P2({}, xn(Jn, "brace").style), {}, { cursor: "default" }) }, "}"));
                  case "array":
                    return Ft.a.createElement("span", null, Ft.a.createElement("span", { style: P2(P2({}, xn(Jn, "brace").style), {}, { cursor: "default" }) }, "["), Ft.a.createElement("span", { style: P2(P2({}, xn(Jn, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Ft.a.createElement("span", { style: P2(P2({}, xn(Jn, "brace").style), {}, { cursor: "default" }) }, "]"));
                  case "string":
                    return Ft.a.createElement(au, Object.assign({ value: Ea2 }, Ci2));
                  case "integer":
                    return Ft.a.createElement(Rl, Object.assign({ value: Ea2 }, Ci2));
                  case "float":
                    return Ft.a.createElement(Nr, Object.assign({ value: Ea2 }, Ci2));
                  case "boolean":
                    return Ft.a.createElement(nr, Object.assign({ value: Ea2 }, Ci2));
                  case "function":
                    return Ft.a.createElement(Ws, Object.assign({ value: Ea2 }, Ci2));
                  case "null":
                    return Ft.a.createElement(bs, Ci2);
                  case "nan":
                    return Ft.a.createElement(il, Ci2);
                  case "undefined":
                    return Ft.a.createElement(eh2, Ci2);
                  case "date":
                    return Ft.a.createElement(pr, Object.assign({ value: new Date(Ea2) }, Ci2));
                }
            }, yr.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, yr;
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this, yr = this.props, Ui2 = yr.variable, Qa2 = yr.singleIndent, Ea2 = yr.type, Ci2 = yr.theme, Jn = yr.namespace, $l = yr.indentWidth, $f2 = yr.enableClipboard, pf2 = yr.onEdit, xd2 = yr.onDelete, $s = yr.onSelect, Zp = yr.displayArrayKey, lv = yr.quotesOnKeys, Ru = this.state.editMode;
            return Ft.a.createElement("div", Object.assign({}, xn(Ci2, "objectKeyVal", { paddingLeft: $l * Qa2 }), { onMouseEnter: function() {
              return cr.setState(P2(P2({}, cr.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return cr.setState(P2(P2({}, cr.state), {}, { hovered: false }));
            }, className: "variable-row", key: Ui2.name }), Ea2 == "array" ? Zp ? Ft.a.createElement("span", Object.assign({}, xn(Ci2, "array-key"), { key: Ui2.name + "_" + Jn }), Ui2.name, Ft.a.createElement("div", xn(Ci2, "colon"), ":")) : null : Ft.a.createElement("span", null, Ft.a.createElement("span", Object.assign({}, xn(Ci2, "object-name"), { className: "object-key", key: Ui2.name + "_" + Jn }), !!lv && Ft.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Ft.a.createElement("span", { style: { display: "inline-block" } }, Ui2.name), !!lv && Ft.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Ft.a.createElement("span", xn(Ci2, "colon"), ":")), Ft.a.createElement("div", Object.assign({ className: "variable-value", onClick: $s === false && pf2 === false ? null : function(U0) {
              var M_ = us(Jn);
              (U0.ctrlKey || U0.metaKey) && pf2 !== false ? cr.prepopInput(Ui2) : $s !== false && (M_.shift(), $s(P2(P2({}, Ui2), {}, { namespace: M_ })));
            } }, xn(Ci2, "variableValue", { cursor: $s === false ? "default" : "pointer" })), this.getValue(Ui2, Ru)), $f2 ? Ft.a.createElement(yy, { rowHovered: this.state.hovered, hidden: Ru, src: Ui2.value, clickCallback: $f2, theme: Ci2, namespace: [].concat(us(Jn), [Ui2.name]) }) : null, pf2 !== false && Ru == 0 ? this.getEditIcon() : null, xd2 !== false && Ru == 0 ? this.getRemoveIcon() : null);
          } }]), Ln;
        }(Ft.a.PureComponent), G2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            var cr;
            N3(this, Ln);
            for (var yr = arguments.length, Ui2 = new Array(yr), Qa2 = 0; Qa2 < yr; Qa2++)
              Ui2[Qa2] = arguments[Qa2];
            return (cr = Er.call.apply(Er, [this].concat(Ui2))).getObjectSize = function() {
              var Ea2 = cr.props, Ci2 = Ea2.size, Jn = Ea2.theme;
              if (Ea2.displayObjectSize)
                return Ft.a.createElement("span", Object.assign({ className: "object-size" }, xn(Jn, "object-size")), Ci2, " item", Ci2 === 1 ? "" : "s");
            }, cr.getAddAttribute = function(Ea2) {
              var Ci2 = cr.props, Jn = Ci2.theme, $l = Ci2.namespace, $f2 = Ci2.name, pf2 = Ci2.src, xd2 = Ci2.rjvId, $s = Ci2.depth;
              return Ft.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: Ea2 ? "inline-block" : "none" } }, Ft.a.createElement(x_, Object.assign({ className: "click-to-add-icon" }, xn(Jn, "addVarIcon"), { onClick: function() {
                var Zp = { name: $s > 0 ? $f2 : null, namespace: $l.splice(0, $l.length - 1), existing_value: pf2, variable_removed: false, key_name: null };
                Te2(pf2) === "object" ? ll.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: xd2, data: Zp }) : ll.dispatch({ name: "VARIABLE_ADDED", rjvId: xd2, data: P2(P2({}, Zp), {}, { new_value: [].concat(us(pf2), [null]) }) });
              } })));
            }, cr.getRemoveObject = function(Ea2) {
              var Ci2 = cr.props, Jn = Ci2.theme, $l = (Ci2.hover, Ci2.namespace), $f2 = Ci2.name, pf2 = Ci2.src, xd2 = Ci2.rjvId;
              if ($l.length !== 1)
                return Ft.a.createElement("span", { className: "click-to-remove", style: { display: Ea2 ? "inline-block" : "none" } }, Ft.a.createElement(gb2, Object.assign({ className: "click-to-remove-icon" }, xn(Jn, "removeVarIcon"), { onClick: function() {
                  ll.dispatch({ name: "VARIABLE_REMOVED", rjvId: xd2, data: { name: $f2, namespace: $l.splice(0, $l.length - 1), existing_value: pf2, variable_removed: true } });
                } })));
            }, cr.render = function() {
              var Ea2 = cr.props, Ci2 = Ea2.theme, Jn = Ea2.onDelete, $l = Ea2.onAdd, $f2 = Ea2.enableClipboard, pf2 = Ea2.src, xd2 = Ea2.namespace, $s = Ea2.rowHovered;
              return Ft.a.createElement("div", Object.assign({}, xn(Ci2, "object-meta-data"), { className: "object-meta-data", onClick: function(Zp) {
                Zp.stopPropagation();
              } }), cr.getObjectSize(), $f2 ? Ft.a.createElement(yy, { rowHovered: $s, clickCallback: $f2, src: pf2, theme: Ci2, namespace: xd2 }) : null, $l !== false ? cr.getAddAttribute($s) : null, Jn !== false ? cr.getRemoveObject($s) : null);
            }, cr;
          }
          return Ln;
        }(Ft.a.PureComponent);
        function qx(_r) {
          var Er = _r.parent_type, Ln = _r.namespace, cr = _r.quotesOnKeys, yr = _r.theme, Ui2 = _r.jsvRoot, Qa2 = _r.name, Ea2 = _r.displayArrayKey, Ci2 = _r.name ? _r.name : "";
          return !Ui2 || Qa2 !== false && Qa2 !== null ? Er == "array" ? Ea2 ? Ft.a.createElement("span", Object.assign({}, xn(yr, "array-key"), { key: Ln }), Ft.a.createElement("span", { className: "array-key" }, Ci2), Ft.a.createElement("span", xn(yr, "colon"), ":")) : Ft.a.createElement("span", null) : Ft.a.createElement("span", Object.assign({}, xn(yr, "object-name"), { key: Ln }), Ft.a.createElement("span", { className: "object-key" }, cr && Ft.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Ft.a.createElement("span", null, Ci2), cr && Ft.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Ft.a.createElement("span", xn(yr, "colon"), ":")) : Ft.a.createElement("span", null);
        }
        function S_(_r) {
          var Er = _r.theme;
          switch (_r.iconStyle) {
            case "triangle":
              return Ft.a.createElement(H0, Object.assign({}, xn(Er, "expanded-icon"), { className: "expanded-icon" }));
            case "square":
              return Ft.a.createElement(qp, Object.assign({}, xn(Er, "expanded-icon"), { className: "expanded-icon" }));
            default:
              return Ft.a.createElement(ff2, Object.assign({}, xn(Er, "expanded-icon"), { className: "expanded-icon" }));
          }
        }
        function MS(_r) {
          var Er = _r.theme;
          switch (_r.iconStyle) {
            case "triangle":
              return Ft.a.createElement(lg2, Object.assign({}, xn(Er, "collapsed-icon"), { className: "collapsed-icon" }));
            case "square":
              return Ft.a.createElement(sv, Object.assign({}, xn(Er, "collapsed-icon"), { className: "collapsed-icon" }));
            default:
              return Ft.a.createElement(hf2, Object.assign({}, xn(Er, "collapsed-icon"), { className: "collapsed-icon" }));
          }
        }
        var E5 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            return N3(this, Ln), (yr = Er.call(this, cr)).toggleCollapsed = function(Ui2) {
              var Qa2 = [];
              for (var Ea2 in yr.state.expanded)
                Qa2.push(yr.state.expanded[Ea2]);
              Qa2[Ui2] = !Qa2[Ui2], yr.setState({ expanded: Qa2 });
            }, yr.state = { expanded: [] }, yr;
          }
          return H2(Ln, [{ key: "getExpandedIcon", value: function(cr) {
            var yr = this.props, Ui2 = yr.theme, Qa2 = yr.iconStyle;
            return this.state.expanded[cr] ? Ft.a.createElement(S_, { theme: Ui2, iconStyle: Qa2 }) : Ft.a.createElement(MS, { theme: Ui2, iconStyle: Qa2 });
          } }, { key: "render", value: function() {
            var cr = this, yr = this.props, Ui2 = yr.src, Qa2 = yr.groupArraysAfterLength, Ea2 = (yr.depth, yr.name), Ci2 = yr.theme, Jn = yr.jsvRoot, $l = yr.namespace, $f2 = (yr.parent_type, be2(yr, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), pf2 = 0, xd2 = 5 * this.props.indentWidth;
            Jn || (pf2 = 5 * this.props.indentWidth);
            var $s = Qa2, Zp = Math.ceil(Ui2.length / $s);
            return Ft.a.createElement("div", Object.assign({ className: "object-key-val" }, xn(Ci2, Jn ? "jsv-root" : "objectKeyVal", { paddingLeft: pf2 })), Ft.a.createElement(qx, this.props), Ft.a.createElement("span", null, Ft.a.createElement(G2, Object.assign({ size: Ui2.length }, this.props))), us(Array(Zp)).map(function(lv, Ru) {
              return Ft.a.createElement("div", Object.assign({ key: Ru, className: "object-key-val array-group" }, xn(Ci2, "objectKeyVal", { marginLeft: 6, paddingLeft: xd2 })), Ft.a.createElement("span", xn(Ci2, "brace-row"), Ft.a.createElement("div", Object.assign({ className: "icon-container" }, xn(Ci2, "icon-container"), { onClick: function(U0) {
                cr.toggleCollapsed(Ru);
              } }), cr.getExpandedIcon(Ru)), cr.state.expanded[Ru] ? Ft.a.createElement(lE, Object.assign({ key: Ea2 + Ru, depth: 0, name: false, collapsed: false, groupArraysAfterLength: $s, index_offset: Ru * $s, src: Ui2.slice(Ru * $s, Ru * $s + $s), namespace: $l, type: "array", parent_type: "array_group", theme: Ci2 }, $f2)) : Ft.a.createElement("span", Object.assign({}, xn(Ci2, "brace"), { onClick: function(U0) {
                cr.toggleCollapsed(Ru);
              }, className: "array-group-brace" }), "[", Ft.a.createElement("div", Object.assign({}, xn(Ci2, "array-group-meta-data"), { className: "array-group-meta-data" }), Ft.a.createElement("span", Object.assign({ className: "object-size" }, xn(Ci2, "object-size")), Ru * $s, " - ", Ru * $s + $s > Ui2.length ? Ui2.length : Ru * $s + $s)), "]")));
            }));
          } }]), Ln;
        }(Ft.a.PureComponent), sE = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            N3(this, Ln), (yr = Er.call(this, cr)).toggleCollapsed = function() {
              yr.setState({ expanded: !yr.state.expanded }, function() {
                es.set(yr.props.rjvId, yr.props.namespace, "expanded", yr.state.expanded);
              });
            }, yr.getObjectContent = function(Qa2, Ea2, Ci2) {
              return Ft.a.createElement("div", { className: "pushed-content object-container" }, Ft.a.createElement("div", Object.assign({ className: "object-content" }, xn(yr.props.theme, "pushed-content")), yr.renderObjectContents(Ea2, Ci2)));
            }, yr.getEllipsis = function() {
              return yr.state.size === 0 ? null : Ft.a.createElement("div", Object.assign({}, xn(yr.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: yr.toggleCollapsed }), "...");
            }, yr.getObjectMetaData = function(Qa2) {
              var Ea2 = yr.props, Ci2 = (Ea2.rjvId, Ea2.theme, yr.state), Jn = Ci2.size, $l = Ci2.hovered;
              return Ft.a.createElement(G2, Object.assign({ rowHovered: $l, size: Jn }, yr.props));
            }, yr.renderObjectContents = function(Qa2, Ea2) {
              var Ci2, Jn = yr.props, $l = Jn.depth, $f2 = Jn.parent_type, pf2 = Jn.index_offset, xd2 = Jn.groupArraysAfterLength, $s = Jn.namespace, Zp = yr.state.object_type, lv = [], Ru = Object.keys(Qa2 || {});
              return yr.props.sortKeys && Zp !== "array" && (Ru = Ru.sort()), Ru.forEach(function(U0) {
                if (Ci2 = new uV(U0, Qa2[U0]), $f2 === "array_group" && pf2 && (Ci2.name = parseInt(Ci2.name) + pf2), Qa2.hasOwnProperty(U0))
                  if (Ci2.type === "object")
                    lv.push(Ft.a.createElement(lE, Object.assign({ key: Ci2.name, depth: $l + 1, name: Ci2.name, src: Ci2.value, namespace: $s.concat(Ci2.name), parent_type: Zp }, Ea2)));
                  else if (Ci2.type === "array") {
                    var M_ = lE;
                    xd2 && Ci2.value.length > xd2 && (M_ = E5), lv.push(Ft.a.createElement(M_, Object.assign({ key: Ci2.name, depth: $l + 1, name: Ci2.name, src: Ci2.value, namespace: $s.concat(Ci2.name), type: "array", parent_type: Zp }, Ea2)));
                  } else
                    lv.push(Ft.a.createElement(f1, Object.assign({ key: Ci2.name + "_" + $s, variable: Ci2, singleIndent: 5, namespace: $s, type: yr.props.type }, Ea2)));
              }), lv;
            };
            var Ui2 = Ln.getState(cr);
            return yr.state = P2(P2({}, Ui2), {}, { prevProps: {} }), yr;
          }
          return H2(Ln, [{ key: "getBraceStart", value: function(cr, yr) {
            var Ui2 = this, Qa2 = this.props, Ea2 = Qa2.src, Ci2 = Qa2.theme, Jn = Qa2.iconStyle;
            if (Qa2.parent_type === "array_group")
              return Ft.a.createElement("span", null, Ft.a.createElement("span", xn(Ci2, "brace"), cr === "array" ? "[" : "{"), yr ? this.getObjectMetaData(Ea2) : null);
            var $l = yr ? S_ : MS;
            return Ft.a.createElement("span", null, Ft.a.createElement("span", Object.assign({ onClick: function($f2) {
              Ui2.toggleCollapsed();
            } }, xn(Ci2, "brace-row")), Ft.a.createElement("div", Object.assign({ className: "icon-container" }, xn(Ci2, "icon-container")), Ft.a.createElement($l, { theme: Ci2, iconStyle: Jn })), Ft.a.createElement(qx, this.props), Ft.a.createElement("span", xn(Ci2, "brace"), cr === "array" ? "[" : "{")), yr ? this.getObjectMetaData(Ea2) : null);
          } }, { key: "render", value: function() {
            var cr = this, yr = this.props, Ui2 = yr.depth, Qa2 = yr.src, Ea2 = (yr.namespace, yr.name, yr.type, yr.parent_type), Ci2 = yr.theme, Jn = yr.jsvRoot, $l = yr.iconStyle, $f2 = be2(yr, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), pf2 = this.state, xd2 = pf2.object_type, $s = pf2.expanded, Zp = {};
            return Jn || Ea2 === "array_group" ? Ea2 === "array_group" && (Zp.borderLeft = 0, Zp.display = "inline") : Zp.paddingLeft = 5 * this.props.indentWidth, Ft.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
              return cr.setState(P2(P2({}, cr.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return cr.setState(P2(P2({}, cr.state), {}, { hovered: false }));
            } }, xn(Ci2, Jn ? "jsv-root" : "objectKeyVal", Zp)), this.getBraceStart(xd2, $s), $s ? this.getObjectContent(Ui2, Qa2, P2({ theme: Ci2, iconStyle: $l }, $f2)) : this.getEllipsis(), Ft.a.createElement("span", { className: "brace-row" }, Ft.a.createElement("span", { style: P2(P2({}, xn(Ci2, "brace").style), {}, { paddingLeft: $s ? "3px" : "0px" }) }, xd2 === "array" ? "]" : "}"), $s ? null : this.getObjectMetaData(Qa2)));
          } }], [{ key: "getDerivedStateFromProps", value: function(cr, yr) {
            var Ui2 = yr.prevProps;
            return cr.src !== Ui2.src || cr.collapsed !== Ui2.collapsed || cr.name !== Ui2.name || cr.namespace !== Ui2.namespace || cr.rjvId !== Ui2.rjvId ? P2(P2({}, Ln.getState(cr)), {}, { prevProps: cr }) : null;
          } }]), Ln;
        }(Ft.a.PureComponent);
        sE.getState = function(_r) {
          var Er = Object.keys(_r.src).length, Ln = (_r.collapsed === false || _r.collapsed !== true && _r.collapsed > _r.depth) && (!_r.shouldCollapse || _r.shouldCollapse({ name: _r.name, src: _r.src, type: Te2(_r.src), namespace: _r.namespace }) === false) && Er !== 0;
          return { expanded: es.get(_r.rjvId, _r.namespace, "expanded", Ln), object_type: _r.type === "array" ? "array" : "object", parent_type: _r.type === "array" ? "array" : "object", size: Er, hovered: false };
        };
        var uV = function _r(Er, Ln) {
          N3(this, _r), this.name = Er, this.value = Ln, this.type = Te2(Ln);
        };
        me2(sE);
        var lE = sE, get2 = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            var cr;
            N3(this, Ln);
            for (var yr = arguments.length, Ui2 = new Array(yr), Qa2 = 0; Qa2 < yr; Qa2++)
              Ui2[Qa2] = arguments[Qa2];
            return (cr = Er.call.apply(Er, [this].concat(Ui2))).render = function() {
              var Ea2 = bt(cr).props, Ci2 = [Ea2.name], Jn = lE;
              return Array.isArray(Ea2.src) && Ea2.groupArraysAfterLength && Ea2.src.length > Ea2.groupArraysAfterLength && (Jn = E5), Ft.a.createElement("div", { className: "pretty-json-container object-container" }, Ft.a.createElement("div", { className: "object-content" }, Ft.a.createElement(Jn, Object.assign({ namespace: Ci2, depth: 0, jsvRoot: true }, Ea2))));
            }, cr;
          }
          return Ln;
        }(Ft.a.PureComponent), vet = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            return N3(this, Ln), (yr = Er.call(this, cr)).closeModal = function() {
              ll.dispatch({ rjvId: yr.props.rjvId, name: "RESET" });
            }, yr.submit = function() {
              yr.props.submit(yr.state.input);
            }, yr.state = { input: cr.input ? cr.input : "" }, yr;
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this, yr = this.props, Ui2 = yr.theme, Qa2 = yr.rjvId, Ea2 = yr.isValid, Ci2 = this.state.input, Jn = Ea2(Ci2);
            return Ft.a.createElement("div", Object.assign({ className: "key-modal-request" }, xn(Ui2, "key-modal-request"), { onClick: this.closeModal }), Ft.a.createElement("div", Object.assign({}, xn(Ui2, "key-modal"), { onClick: function($l) {
              $l.stopPropagation();
            } }), Ft.a.createElement("div", xn(Ui2, "key-modal-label"), "Key Name:"), Ft.a.createElement("div", { style: { position: "relative" } }, Ft.a.createElement("input", Object.assign({}, xn(Ui2, "key-modal-input"), { className: "key-modal-input", ref: function($l) {
              return $l && $l.focus();
            }, spellCheck: false, value: Ci2, placeholder: "...", onChange: function($l) {
              cr.setState({ input: $l.target.value });
            }, onKeyPress: function($l) {
              Jn && $l.key === "Enter" ? cr.submit() : $l.key === "Escape" && cr.closeModal();
            } })), Jn ? Ft.a.createElement(t0, Object.assign({}, xn(Ui2, "key-modal-submit"), { className: "key-modal-submit", onClick: function($l) {
              return cr.submit();
            } })) : null), Ft.a.createElement("span", xn(Ui2, "key-modal-cancel"), Ft.a.createElement(W2, Object.assign({}, xn(Ui2, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
              ll.dispatch({ rjvId: Qa2, name: "RESET" });
            } })))));
          } }]), Ln;
        }(Ft.a.PureComponent), yet = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            var cr;
            N3(this, Ln);
            for (var yr = arguments.length, Ui2 = new Array(yr), Qa2 = 0; Qa2 < yr; Qa2++)
              Ui2[Qa2] = arguments[Qa2];
            return (cr = Er.call.apply(Er, [this].concat(Ui2))).isValid = function(Ea2) {
              var Ci2 = cr.props.rjvId, Jn = es.get(Ci2, "action", "new-key-request");
              return Ea2 != "" && Object.keys(Jn.existing_value).indexOf(Ea2) === -1;
            }, cr.submit = function(Ea2) {
              var Ci2 = cr.props.rjvId, Jn = es.get(Ci2, "action", "new-key-request");
              Jn.new_value = P2({}, Jn.existing_value), Jn.new_value[Ea2] = cr.props.defaultValue, ll.dispatch({ name: "VARIABLE_ADDED", rjvId: Ci2, data: Jn });
            }, cr;
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.active, Ui2 = cr.theme, Qa2 = cr.rjvId;
            return yr ? Ft.a.createElement(vet, { rjvId: Qa2, theme: Ui2, isValid: this.isValid, submit: this.submit }) : null;
          } }]), Ln;
        }(Ft.a.PureComponent), met = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln() {
            return N3(this, Ln), Er.apply(this, arguments);
          }
          return H2(Ln, [{ key: "render", value: function() {
            var cr = this.props, yr = cr.message, Ui2 = cr.active, Qa2 = cr.theme, Ea2 = cr.rjvId;
            return Ui2 ? Ft.a.createElement("div", Object.assign({ className: "validation-failure" }, xn(Qa2, "validation-failure"), { onClick: function() {
              ll.dispatch({ rjvId: Ea2, name: "RESET" });
            } }), Ft.a.createElement("span", xn(Qa2, "validation-failure-label"), yr), Ft.a.createElement(W2, xn(Qa2, "validation-failure-clear"))) : null;
          } }]), Ln;
        }(Ft.a.PureComponent), sN = function(_r) {
          et(Ln, _r);
          var Er = Et(Ln);
          function Ln(cr) {
            var yr;
            return N3(this, Ln), (yr = Er.call(this, cr)).rjvId = Date.now().toString(), yr.getListeners = function() {
              return { reset: yr.resetState, "variable-update": yr.updateSrc, "add-key-request": yr.addKeyRequest };
            }, yr.updateSrc = function() {
              var Ui2, Qa2 = es.get(yr.rjvId, "action", "variable-update"), Ea2 = Qa2.name, Ci2 = Qa2.namespace, Jn = Qa2.new_value, $l = Qa2.existing_value, $f2 = (Qa2.variable_removed, Qa2.updated_src), pf2 = Qa2.type, xd2 = yr.props, $s = xd2.onEdit, Zp = xd2.onDelete, lv = xd2.onAdd, Ru = { existing_src: yr.state.src, new_value: Jn, updated_src: $f2, name: Ea2, namespace: Ci2, existing_value: $l };
              switch (pf2) {
                case "variable-added":
                  Ui2 = lv(Ru);
                  break;
                case "variable-edited":
                  Ui2 = $s(Ru);
                  break;
                case "variable-removed":
                  Ui2 = Zp(Ru);
              }
              Ui2 !== false ? (es.set(yr.rjvId, "global", "src", $f2), yr.setState({ src: $f2 })) : yr.setState({ validationFailure: true });
            }, yr.addKeyRequest = function() {
              yr.setState({ addKeyRequest: true });
            }, yr.resetState = function() {
              yr.setState({ validationFailure: false, addKeyRequest: false });
            }, yr.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Ln.defaultProps.src, name: Ln.defaultProps.name, theme: Ln.defaultProps.theme, validationMessage: Ln.defaultProps.validationMessage, prevSrc: Ln.defaultProps.src, prevName: Ln.defaultProps.name, prevTheme: Ln.defaultProps.theme }, yr;
          }
          return H2(Ln, [{ key: "componentDidMount", value: function() {
            es.set(this.rjvId, "global", "src", this.state.src);
            var cr = this.getListeners();
            for (var yr in cr)
              es.on(yr + "-" + this.rjvId, cr[yr]);
            this.setState({ addKeyRequest: false, editKeyRequest: false });
          } }, { key: "componentDidUpdate", value: function(cr, yr) {
            yr.addKeyRequest !== false && this.setState({ addKeyRequest: false }), yr.editKeyRequest !== false && this.setState({ editKeyRequest: false }), cr.src !== this.state.src && es.set(this.rjvId, "global", "src", this.state.src);
          } }, { key: "componentWillUnmount", value: function() {
            var cr = this.getListeners();
            for (var yr in cr)
              es.removeListener(yr + "-" + this.rjvId, cr[yr]);
          } }, { key: "render", value: function() {
            var cr = this.state, yr = cr.validationFailure, Ui2 = cr.validationMessage, Qa2 = cr.addKeyRequest, Ea2 = cr.theme, Ci2 = cr.src, Jn = cr.name, $l = this.props, $f2 = $l.style, pf2 = $l.defaultValue;
            return Ft.a.createElement("div", { className: "react-json-view", style: P2(P2({}, xn(Ea2, "app-container").style), $f2) }, Ft.a.createElement(met, { message: Ui2, active: yr, theme: Ea2, rjvId: this.rjvId }), Ft.a.createElement(get2, Object.assign({}, this.props, { src: Ci2, name: Jn, theme: Ea2, type: Te2(Ci2), rjvId: this.rjvId })), Ft.a.createElement(yet, { active: Qa2, theme: Ea2, rjvId: this.rjvId, defaultValue: pf2 }));
          } }], [{ key: "getDerivedStateFromProps", value: function(cr, yr) {
            if (cr.src !== yr.prevSrc || cr.name !== yr.prevName || cr.theme !== yr.prevTheme) {
              var Ui2 = { src: cr.src, name: cr.name, theme: cr.theme, validationMessage: cr.validationMessage, prevSrc: cr.src, prevName: cr.name, prevTheme: cr.theme };
              return Ln.validateState(Ui2);
            }
            return null;
          } }]), Ln;
        }(Ft.a.PureComponent);
        sN.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, sN.validateState = function(_r) {
          var Er = {};
          return Te2(_r.theme) !== "object" || function(Ln) {
            var cr = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
            if (Te2(Ln) === "object") {
              for (var yr = 0; yr < cr.length; yr++)
                if (!(cr[yr] in Ln))
                  return false;
              return true;
            }
            return false;
          }(_r.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Er.theme = "rjv-default"), Te2(_r.src) !== "object" && Te2(_r.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Er.name = "ERROR", Er.src = { message: "src property must be a valid json object" }), P2(P2({}, _r), Er);
        }, me2(sN), v4.default = sN;
      }]);
    });
  })(WZe);
  var SPr = isr(WZe.exports);
  const MPr = ({ id: f2, title: i, chart: t2, option: h }) => {
    const { tool: v4 } = wre({}), _ = jZe.useEventEmitter({ global: true }), [M2, { set: I2 }] = Kor(true), P2 = (N3) => {
      const { updated_src: z3 } = N3;
      t2 == null || t2.setOption(z3), v4 == null || v4.add(f2, t2, z3, i), _.emit("list");
    };
    return lPr("div", { children: [Ctt(dPr, { children: Ctt(mPr, { children: Ctt(_Pr, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (N3) => {
      I2(!N3);
    } }) }) }), Ctt("br", {}), h && Ctt(SPr, { src: h, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: M2, iconStyle: "triangle", enableClipboard: true, onEdit: P2, onAdd: P2, onDelete: P2 })] });
  }, CPr = () => {
    const f2 = xre({ global: true }), i = dp.useRef(0), { tool: t2 } = wre({});
    dp.useState(false), dp.useState("right");
    const [h, v4] = dp.useState([]), [_, M2] = dp.useState();
    return f2.useSubscription("list", () => {
      var I2;
      t2 != null && t2.list().length && (M2((I2 = t2 == null ? void 0 : t2.list()) == null ? void 0 : I2[i.current]), v4(t2 == null ? void 0 : t2.list()));
    }), Ctt("div", { className: wPr.container, children: false });
  };
  exports.EchartTool = CPr;
  exports.ReactEchartsJson = MPr;
  exports.useEcharts = NEr;
  exports.useEchartsTool = wre;
  exports.useEventEmitter = xre;
})(reactEchartsJson_cjs);
var main = { exports: {} };
(function(module, exports) {
  !function(e2, t2) {
    module.exports = t2(React__default);
  }(commonjsGlobal, function(e2) {
    return function(e3) {
      var t2 = {};
      function n2(a) {
        if (t2[a])
          return t2[a].exports;
        var r2 = t2[a] = { i: a, l: false, exports: {} };
        return e3[a].call(r2.exports, r2, r2.exports, n2), r2.l = true, r2.exports;
      }
      return n2.m = e3, n2.c = t2, n2.d = function(e4, t3, a) {
        n2.o(e4, t3) || Object.defineProperty(e4, t3, { enumerable: true, get: a });
      }, n2.r = function(e4) {
        typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(e4, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(e4, "__esModule", { value: true });
      }, n2.t = function(e4, t3) {
        if (1 & t3 && (e4 = n2(e4)), 8 & t3)
          return e4;
        if (4 & t3 && typeof e4 == "object" && e4 && e4.__esModule)
          return e4;
        var a = /* @__PURE__ */ Object.create(null);
        if (n2.r(a), Object.defineProperty(a, "default", { enumerable: true, value: e4 }), 2 & t3 && typeof e4 != "string")
          for (var r2 in e4)
            n2.d(a, r2, function(t4) {
              return e4[t4];
            }.bind(null, r2));
        return a;
      }, n2.n = function(e4) {
        var t3 = e4 && e4.__esModule ? function() {
          return e4.default;
        } : function() {
          return e4;
        };
        return n2.d(t3, "a", t3), t3;
      }, n2.o = function(e4, t3) {
        return Object.prototype.hasOwnProperty.call(e4, t3);
      }, n2.p = "", n2(n2.s = 48);
    }([function(t2, n2) {
      t2.exports = e2;
    }, function(e3, t2) {
      var n2 = e3.exports = { version: "2.6.12" };
      typeof __e == "number" && (__e = n2);
    }, function(e3, t2, n2) {
      var a = n2(26)("wks"), r2 = n2(17), o = n2(3).Symbol, i = typeof o == "function";
      (e3.exports = function(e4) {
        return a[e4] || (a[e4] = i && o[e4] || (i ? o : r2)("Symbol." + e4));
      }).store = a;
    }, function(e3, t2) {
      var n2 = e3.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
      typeof __g == "number" && (__g = n2);
    }, function(e3, t2, n2) {
      e3.exports = !n2(8)(function() {
        return Object.defineProperty({}, "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2) {
      var n2 = {}.hasOwnProperty;
      e3.exports = function(e4, t3) {
        return n2.call(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(16);
      e3.exports = n2(4) ? function(e4, t3, n3) {
        return a.f(e4, t3, r2(1, n3));
      } : function(e4, t3, n3) {
        return e4[t3] = n3, e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(35), o = n2(23), i = Object.defineProperty;
      t2.f = n2(4) ? Object.defineProperty : function(e4, t3, n3) {
        if (a(e4), t3 = o(t3, true), a(n3), r2)
          try {
            return i(e4, t3, n3);
          } catch (e5) {
          }
        if ("get" in n3 || "set" in n3)
          throw TypeError("Accessors not supported!");
        return "value" in n3 && (e4[t3] = n3.value), e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        try {
          return !!e4();
        } catch (e5) {
          return true;
        }
      };
    }, function(e3, t2, n2) {
      var a = n2(40), r2 = n2(22);
      e3.exports = function(e4) {
        return a(r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4) {
        if (!a(e4))
          throw TypeError(e4 + " is not an object!");
        return e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        return typeof e4 == "object" ? e4 !== null : typeof e4 == "function";
      };
    }, function(e3, t2) {
      e3.exports = {};
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27);
      e3.exports = Object.keys || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2) {
      e3.exports = true;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(53), i = n2(6), s = n2(5), c2 = function(e4, t3, n3) {
        var l2, u, f2, p2 = e4 & c2.F, d2 = e4 & c2.G, b2 = e4 & c2.S, h = e4 & c2.P, v4 = e4 & c2.B, m2 = e4 & c2.W, y2 = d2 ? r2 : r2[t3] || (r2[t3] = {}), g2 = y2.prototype, E = d2 ? a : b2 ? a[t3] : (a[t3] || {}).prototype;
        for (l2 in d2 && (n3 = t3), n3)
          (u = !p2 && E && E[l2] !== void 0) && s(y2, l2) || (f2 = u ? E[l2] : n3[l2], y2[l2] = d2 && typeof E[l2] != "function" ? n3[l2] : v4 && u ? o(f2, a) : m2 && E[l2] == f2 ? function(e5) {
            var t4 = function(t5, n4, a2) {
              if (this instanceof e5) {
                switch (arguments.length) {
                  case 0:
                    return new e5();
                  case 1:
                    return new e5(t5);
                  case 2:
                    return new e5(t5, n4);
                }
                return new e5(t5, n4, a2);
              }
              return e5.apply(this, arguments);
            };
            return t4.prototype = e5.prototype, t4;
          }(f2) : h && typeof f2 == "function" ? o(Function.call, f2) : f2, h && ((y2.virtual || (y2.virtual = {}))[l2] = f2, e4 & c2.R && g2 && !g2[l2] && i(g2, l2, f2)));
      };
      c2.F = 1, c2.G = 2, c2.S = 4, c2.P = 8, c2.B = 16, c2.W = 32, c2.U = 64, c2.R = 128, e3.exports = c2;
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { enumerable: !(1 & e4), configurable: !(2 & e4), writable: !(4 & e4), value: t3 };
      };
    }, function(e3, t2) {
      var n2 = 0, a = Math.random();
      e3.exports = function(e4) {
        return "Symbol(".concat(e4 === void 0 ? "" : e4, ")_", (++n2 + a).toString(36));
      };
    }, function(e3, t2, n2) {
      var a = n2(22);
      e3.exports = function(e4) {
        return Object(a(e4));
      };
    }, function(e3, t2) {
      t2.f = {}.propertyIsEnumerable;
    }, function(e3, t2, n2) {
      var a = n2(52)(true);
      n2(34)(String, "String", function(e4) {
        this._t = String(e4), this._i = 0;
      }, function() {
        var e4, t3 = this._t, n3 = this._i;
        return n3 >= t3.length ? { value: void 0, done: true } : (e4 = a(t3, n3), this._i += e4.length, { value: e4, done: false });
      });
    }, function(e3, t2) {
      var n2 = Math.ceil, a = Math.floor;
      e3.exports = function(e4) {
        return isNaN(e4 = +e4) ? 0 : (e4 > 0 ? a : n2)(e4);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (e4 == null)
          throw TypeError("Can't call method on  " + e4);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4, t3) {
        if (!a(e4))
          return e4;
        var n3, r2;
        if (t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (typeof (n3 = e4.valueOf) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (!t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        throw TypeError("Can't convert object to primitive value");
      };
    }, function(e3, t2) {
      var n2 = {}.toString;
      e3.exports = function(e4) {
        return n2.call(e4).slice(8, -1);
      };
    }, function(e3, t2, n2) {
      var a = n2(26)("keys"), r2 = n2(17);
      e3.exports = function(e4) {
        return a[e4] || (a[e4] = r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(1), r2 = n2(3), o = r2["__core-js_shared__"] || (r2["__core-js_shared__"] = {});
      (e3.exports = function(e4, t3) {
        return o[e4] || (o[e4] = t3 !== void 0 ? t3 : {});
      })("versions", []).push({ version: a.version, mode: n2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
    }, function(e3, t2) {
      e3.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
    }, function(e3, t2, n2) {
      var a = n2(7).f, r2 = n2(5), o = n2(2)("toStringTag");
      e3.exports = function(e4, t3, n3) {
        e4 && !r2(e4 = n3 ? e4 : e4.prototype, o) && a(e4, o, { configurable: true, value: t3 });
      };
    }, function(e3, t2, n2) {
      n2(62);
      for (var a = n2(3), r2 = n2(6), o = n2(12), i = n2(2)("toStringTag"), s = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), c2 = 0; c2 < s.length; c2++) {
        var l2 = s[c2], u = a[l2], f2 = u && u.prototype;
        f2 && !f2[i] && r2(f2, i, l2), o[l2] = o.Array;
      }
    }, function(e3, t2, n2) {
      t2.f = n2(2);
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(14), i = n2(30), s = n2(7).f;
      e3.exports = function(e4) {
        var t3 = r2.Symbol || (r2.Symbol = o ? {} : a.Symbol || {});
        e4.charAt(0) == "_" || e4 in t3 || s(t3, e4, { value: i.f(e4) });
      };
    }, function(e3, t2) {
      t2.f = Object.getOwnPropertySymbols;
    }, function(e3, t2) {
      e3.exports = function(e4, t3, n2) {
        return Math.min(Math.max(e4, t3), n2);
      };
    }, function(e3, t2, n2) {
      var a = n2(14), r2 = n2(15), o = n2(37), i = n2(6), s = n2(12), c2 = n2(55), l2 = n2(28), u = n2(61), f2 = n2(2)("iterator"), p2 = !([].keys && "next" in [].keys()), d2 = function() {
        return this;
      };
      e3.exports = function(e4, t3, n3, b2, h, v4, m2) {
        c2(n3, t3, b2);
        var y2, g2, E, j = function(e5) {
          if (!p2 && e5 in O2)
            return O2[e5];
          switch (e5) {
            case "keys":
            case "values":
              return function() {
                return new n3(this, e5);
              };
          }
          return function() {
            return new n3(this, e5);
          };
        }, x2 = t3 + " Iterator", _ = h == "values", k2 = false, O2 = e4.prototype, C = O2[f2] || O2["@@iterator"] || h && O2[h], S2 = C || j(h), w2 = h ? _ ? j("entries") : S2 : void 0, A2 = t3 == "Array" && O2.entries || C;
        if (A2 && (E = u(A2.call(new e4()))) !== Object.prototype && E.next && (l2(E, x2, true), a || typeof E[f2] == "function" || i(E, f2, d2)), _ && C && C.name !== "values" && (k2 = true, S2 = function() {
          return C.call(this);
        }), a && !m2 || !p2 && !k2 && O2[f2] || i(O2, f2, S2), s[t3] = S2, s[x2] = d2, h)
          if (y2 = { values: _ ? S2 : j("values"), keys: v4 ? S2 : j("keys"), entries: w2 }, m2)
            for (g2 in y2)
              g2 in O2 || o(O2, g2, y2[g2]);
          else
            r2(r2.P + r2.F * (p2 || k2), t3, y2);
        return y2;
      };
    }, function(e3, t2, n2) {
      e3.exports = !n2(4) && !n2(8)(function() {
        return Object.defineProperty(n2(36)("div"), "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2, n2) {
      var a = n2(11), r2 = n2(3).document, o = a(r2) && a(r2.createElement);
      e3.exports = function(e4) {
        return o ? r2.createElement(e4) : {};
      };
    }, function(e3, t2, n2) {
      e3.exports = n2(6);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(56), o = n2(27), i = n2(25)("IE_PROTO"), s = function() {
      }, c2 = function() {
        var e4, t3 = n2(36)("iframe"), a2 = o.length;
        for (t3.style.display = "none", n2(60).appendChild(t3), t3.src = "javascript:", (e4 = t3.contentWindow.document).open(), e4.write("<script>document.F=Object<\/script>"), e4.close(), c2 = e4.F; a2--; )
          delete c2.prototype[o[a2]];
        return c2();
      };
      e3.exports = Object.create || function(e4, t3) {
        var n3;
        return e4 !== null ? (s.prototype = a(e4), n3 = new s(), s.prototype = null, n3[i] = e4) : n3 = c2(), t3 === void 0 ? n3 : r2(n3, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(9), o = n2(57)(false), i = n2(25)("IE_PROTO");
      e3.exports = function(e4, t3) {
        var n3, s = r2(e4), c2 = 0, l2 = [];
        for (n3 in s)
          n3 != i && a(s, n3) && l2.push(n3);
        for (; t3.length > c2; )
          a(s, n3 = t3[c2++]) && (~o(l2, n3) || l2.push(n3));
        return l2;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Object("z").propertyIsEnumerable(0) ? Object : function(e4) {
        return a(e4) == "String" ? e4.split("") : Object(e4);
      };
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27).concat("length", "prototype");
      t2.f = Object.getOwnPropertyNames || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2, n2) {
      var a = n2(24), r2 = n2(2)("toStringTag"), o = a(function() {
        return arguments;
      }()) == "Arguments";
      e3.exports = function(e4) {
        var t3, n3, i;
        return e4 === void 0 ? "Undefined" : e4 === null ? "Null" : typeof (n3 = function(e5, t4) {
          try {
            return e5[t4];
          } catch (e6) {
          }
        }(t3 = Object(e4), r2)) == "string" ? n3 : o ? a(t3) : (i = a(t3)) == "Object" && typeof t3.callee == "function" ? "Arguments" : i;
      };
    }, function(e3, t2) {
      var n2;
      n2 = function() {
        return this;
      }();
      try {
        n2 = n2 || new Function("return this")();
      } catch (e4) {
        typeof window == "object" && (n2 = window);
      }
      e3.exports = n2;
    }, function(e3, t2) {
      var n2 = /-?\d+(\.\d+)?%?/g;
      e3.exports = function(e4) {
        return e4.match(n2);
      };
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.getBase16Theme = t2.createStyling = t2.invertTheme = void 0;
      var a = d2(n2(49)), r2 = d2(n2(76)), o = d2(n2(81)), i = d2(n2(89)), s = d2(n2(93)), c2 = function(e4) {
        if (e4 && e4.__esModule)
          return e4;
        var t3 = {};
        if (e4 != null)
          for (var n3 in e4)
            Object.prototype.hasOwnProperty.call(e4, n3) && (t3[n3] = e4[n3]);
        return t3.default = e4, t3;
      }(n2(94)), l2 = d2(n2(132)), u = d2(n2(133)), f2 = d2(n2(138)), p2 = n2(139);
      function d2(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      var b2 = c2.default, h = (0, i.default)(b2), v4 = (0, f2.default)(u.default, p2.rgb2yuv, function(e4) {
        var t3, n3 = (0, o.default)(e4, 3), a2 = n3[0], r3 = n3[1], i2 = n3[2];
        return [(t3 = a2, t3 < 0.25 ? 1 : t3 < 0.5 ? 0.9 - t3 : 1.1 - t3), r3, i2];
      }, p2.yuv2rgb, l2.default), m2 = function(e4) {
        return function(t3) {
          return { className: [t3.className, e4.className].filter(Boolean).join(" "), style: (0, r2.default)({}, t3.style || {}, e4.style || {}) };
        };
      }, y2 = function(e4, t3) {
        var n3 = (0, i.default)(t3);
        for (var o2 in e4)
          n3.indexOf(o2) === -1 && n3.push(o2);
        return n3.reduce(function(n4, o3) {
          return n4[o3] = function(e5, t4) {
            if (e5 === void 0)
              return t4;
            if (t4 === void 0)
              return e5;
            var n5 = e5 === void 0 ? "undefined" : (0, a.default)(e5), o4 = t4 === void 0 ? "undefined" : (0, a.default)(t4);
            switch (n5) {
              case "string":
                switch (o4) {
                  case "string":
                    return [t4, e5].filter(Boolean).join(" ");
                  case "object":
                    return m2({ className: e5, style: t4 });
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ className: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "object":
                switch (o4) {
                  case "string":
                    return m2({ className: t4, style: e5 });
                  case "object":
                    return (0, r2.default)({}, t4, e5);
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ style: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "function":
                switch (o4) {
                  case "string":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ className: t4 })].concat(r3));
                    };
                  case "object":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ style: t4 })].concat(r3));
                    };
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [t4.apply(void 0, [n6].concat(r3))].concat(r3));
                    };
                }
            }
          }(e4[o3], t3[o3]), n4;
        }, {});
      }, g2 = function(e4, t3) {
        for (var n3 = arguments.length, o2 = Array(n3 > 2 ? n3 - 2 : 0), s2 = 2; s2 < n3; s2++)
          o2[s2 - 2] = arguments[s2];
        if (t3 === null)
          return e4;
        Array.isArray(t3) || (t3 = [t3]);
        var c3 = t3.map(function(t4) {
          return e4[t4];
        }).filter(Boolean), l3 = c3.reduce(function(e5, t4) {
          return typeof t4 == "string" ? e5.className = [e5.className, t4].filter(Boolean).join(" ") : (t4 === void 0 ? "undefined" : (0, a.default)(t4)) === "object" ? e5.style = (0, r2.default)({}, e5.style, t4) : typeof t4 == "function" && (e5 = (0, r2.default)({}, e5, t4.apply(void 0, [e5].concat(o2)))), e5;
        }, { className: "", style: {} });
        return l3.className || delete l3.className, (0, i.default)(l3.style).length === 0 && delete l3.style, l3;
      }, E = t2.invertTheme = function(e4) {
        return (0, i.default)(e4).reduce(function(t3, n3) {
          return t3[n3] = /^base/.test(n3) ? v4(e4[n3]) : n3 === "scheme" ? e4[n3] + ":inverted" : e4[n3], t3;
        }, {});
      }, j = (t2.createStyling = (0, s.default)(function(e4) {
        for (var t3 = arguments.length, n3 = Array(t3 > 3 ? t3 - 3 : 0), a2 = 3; a2 < t3; a2++)
          n3[a2 - 3] = arguments[a2];
        var o2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, c3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, l3 = o2.defaultBase16, u2 = l3 === void 0 ? b2 : l3, f3 = o2.base16Themes, p3 = f3 === void 0 ? null : f3, d3 = j(c3, p3);
        d3 && (c3 = (0, r2.default)({}, d3, c3));
        var v5 = h.reduce(function(e5, t4) {
          return e5[t4] = c3[t4] || u2[t4], e5;
        }, {}), m3 = (0, i.default)(c3).reduce(function(e5, t4) {
          return h.indexOf(t4) === -1 ? (e5[t4] = c3[t4], e5) : e5;
        }, {}), E2 = e4(v5), x2 = y2(m3, E2);
        return (0, s.default)(g2, 2).apply(void 0, [x2].concat(n3));
      }, 3), t2.getBase16Theme = function(e4, t3) {
        if (e4 && e4.extend && (e4 = e4.extend), typeof e4 == "string") {
          var n3 = e4.split(":"), a2 = (0, o.default)(n3, 2), r3 = a2[0], i2 = a2[1];
          e4 = (t3 || {})[r3] || c2[r3], i2 === "inverted" && (e4 = E(e4));
        }
        return e4 && e4.hasOwnProperty("base00") ? e4 : void 0;
      });
    }, function(e3, t2, n2) {
      var a, r2 = typeof Reflect == "object" ? Reflect : null, o = r2 && typeof r2.apply == "function" ? r2.apply : function(e4, t3, n3) {
        return Function.prototype.apply.call(e4, t3, n3);
      };
      a = r2 && typeof r2.ownKeys == "function" ? r2.ownKeys : Object.getOwnPropertySymbols ? function(e4) {
        return Object.getOwnPropertyNames(e4).concat(Object.getOwnPropertySymbols(e4));
      } : function(e4) {
        return Object.getOwnPropertyNames(e4);
      };
      var i = Number.isNaN || function(e4) {
        return e4 != e4;
      };
      function s() {
        s.init.call(this);
      }
      e3.exports = s, e3.exports.once = function(e4, t3) {
        return new Promise(function(n3, a2) {
          function r3() {
            o2 !== void 0 && e4.removeListener("error", o2), n3([].slice.call(arguments));
          }
          var o2;
          t3 !== "error" && (o2 = function(n4) {
            e4.removeListener(t3, r3), a2(n4);
          }, e4.once("error", o2)), e4.once(t3, r3);
        });
      }, s.EventEmitter = s, s.prototype._events = void 0, s.prototype._eventsCount = 0, s.prototype._maxListeners = void 0;
      var c2 = 10;
      function l2(e4) {
        if (typeof e4 != "function")
          throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof e4);
      }
      function u(e4) {
        return e4._maxListeners === void 0 ? s.defaultMaxListeners : e4._maxListeners;
      }
      function f2(e4, t3, n3, a2) {
        var r3, o2, i2, s2;
        if (l2(n3), (o2 = e4._events) === void 0 ? (o2 = e4._events = /* @__PURE__ */ Object.create(null), e4._eventsCount = 0) : (o2.newListener !== void 0 && (e4.emit("newListener", t3, n3.listener ? n3.listener : n3), o2 = e4._events), i2 = o2[t3]), i2 === void 0)
          i2 = o2[t3] = n3, ++e4._eventsCount;
        else if (typeof i2 == "function" ? i2 = o2[t3] = a2 ? [n3, i2] : [i2, n3] : a2 ? i2.unshift(n3) : i2.push(n3), (r3 = u(e4)) > 0 && i2.length > r3 && !i2.warned) {
          i2.warned = true;
          var c3 = new Error("Possible EventEmitter memory leak detected. " + i2.length + " " + String(t3) + " listeners added. Use emitter.setMaxListeners() to increase limit");
          c3.name = "MaxListenersExceededWarning", c3.emitter = e4, c3.type = t3, c3.count = i2.length, s2 = c3, console && console.warn && console.warn(s2);
        }
        return e4;
      }
      function p2() {
        if (!this.fired)
          return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
      }
      function d2(e4, t3, n3) {
        var a2 = { fired: false, wrapFn: void 0, target: e4, type: t3, listener: n3 }, r3 = p2.bind(a2);
        return r3.listener = n3, a2.wrapFn = r3, r3;
      }
      function b2(e4, t3, n3) {
        var a2 = e4._events;
        if (a2 === void 0)
          return [];
        var r3 = a2[t3];
        return r3 === void 0 ? [] : typeof r3 == "function" ? n3 ? [r3.listener || r3] : [r3] : n3 ? function(e5) {
          for (var t4 = new Array(e5.length), n4 = 0; n4 < t4.length; ++n4)
            t4[n4] = e5[n4].listener || e5[n4];
          return t4;
        }(r3) : v4(r3, r3.length);
      }
      function h(e4) {
        var t3 = this._events;
        if (t3 !== void 0) {
          var n3 = t3[e4];
          if (typeof n3 == "function")
            return 1;
          if (n3 !== void 0)
            return n3.length;
        }
        return 0;
      }
      function v4(e4, t3) {
        for (var n3 = new Array(t3), a2 = 0; a2 < t3; ++a2)
          n3[a2] = e4[a2];
        return n3;
      }
      Object.defineProperty(s, "defaultMaxListeners", { enumerable: true, get: function() {
        return c2;
      }, set: function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        c2 = e4;
      } }), s.init = function() {
        this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
      }, s.prototype.setMaxListeners = function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        return this._maxListeners = e4, this;
      }, s.prototype.getMaxListeners = function() {
        return u(this);
      }, s.prototype.emit = function(e4) {
        for (var t3 = [], n3 = 1; n3 < arguments.length; n3++)
          t3.push(arguments[n3]);
        var a2 = e4 === "error", r3 = this._events;
        if (r3 !== void 0)
          a2 = a2 && r3.error === void 0;
        else if (!a2)
          return false;
        if (a2) {
          var i2;
          if (t3.length > 0 && (i2 = t3[0]), i2 instanceof Error)
            throw i2;
          var s2 = new Error("Unhandled error." + (i2 ? " (" + i2.message + ")" : ""));
          throw s2.context = i2, s2;
        }
        var c3 = r3[e4];
        if (c3 === void 0)
          return false;
        if (typeof c3 == "function")
          o(c3, this, t3);
        else {
          var l3 = c3.length, u2 = v4(c3, l3);
          for (n3 = 0; n3 < l3; ++n3)
            o(u2[n3], this, t3);
        }
        return true;
      }, s.prototype.addListener = function(e4, t3) {
        return f2(this, e4, t3, false);
      }, s.prototype.on = s.prototype.addListener, s.prototype.prependListener = function(e4, t3) {
        return f2(this, e4, t3, true);
      }, s.prototype.once = function(e4, t3) {
        return l2(t3), this.on(e4, d2(this, e4, t3)), this;
      }, s.prototype.prependOnceListener = function(e4, t3) {
        return l2(t3), this.prependListener(e4, d2(this, e4, t3)), this;
      }, s.prototype.removeListener = function(e4, t3) {
        var n3, a2, r3, o2, i2;
        if (l2(t3), (a2 = this._events) === void 0)
          return this;
        if ((n3 = a2[e4]) === void 0)
          return this;
        if (n3 === t3 || n3.listener === t3)
          --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete a2[e4], a2.removeListener && this.emit("removeListener", e4, n3.listener || t3));
        else if (typeof n3 != "function") {
          for (r3 = -1, o2 = n3.length - 1; o2 >= 0; o2--)
            if (n3[o2] === t3 || n3[o2].listener === t3) {
              i2 = n3[o2].listener, r3 = o2;
              break;
            }
          if (r3 < 0)
            return this;
          r3 === 0 ? n3.shift() : function(e5, t4) {
            for (; t4 + 1 < e5.length; t4++)
              e5[t4] = e5[t4 + 1];
            e5.pop();
          }(n3, r3), n3.length === 1 && (a2[e4] = n3[0]), a2.removeListener !== void 0 && this.emit("removeListener", e4, i2 || t3);
        }
        return this;
      }, s.prototype.off = s.prototype.removeListener, s.prototype.removeAllListeners = function(e4) {
        var t3, n3, a2;
        if ((n3 = this._events) === void 0)
          return this;
        if (n3.removeListener === void 0)
          return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : n3[e4] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete n3[e4]), this;
        if (arguments.length === 0) {
          var r3, o2 = Object.keys(n3);
          for (a2 = 0; a2 < o2.length; ++a2)
            (r3 = o2[a2]) !== "removeListener" && this.removeAllListeners(r3);
          return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
        }
        if (typeof (t3 = n3[e4]) == "function")
          this.removeListener(e4, t3);
        else if (t3 !== void 0)
          for (a2 = t3.length - 1; a2 >= 0; a2--)
            this.removeListener(e4, t3[a2]);
        return this;
      }, s.prototype.listeners = function(e4) {
        return b2(this, e4, true);
      }, s.prototype.rawListeners = function(e4) {
        return b2(this, e4, false);
      }, s.listenerCount = function(e4, t3) {
        return typeof e4.listenerCount == "function" ? e4.listenerCount(t3) : h.call(e4, t3);
      }, s.prototype.listenerCount = h, s.prototype.eventNames = function() {
        return this._eventsCount > 0 ? a(this._events) : [];
      };
    }, function(e3, t2, n2) {
      e3.exports.Dispatcher = n2(140);
    }, function(e3, t2, n2) {
      e3.exports = n2(142);
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = i(n2(50)), r2 = i(n2(65)), o = typeof r2.default == "function" && typeof a.default == "symbol" ? function(e4) {
        return typeof e4;
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : typeof e4;
      };
      function i(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = typeof r2.default == "function" && o(a.default) === "symbol" ? function(e4) {
        return e4 === void 0 ? "undefined" : o(e4);
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : e4 === void 0 ? "undefined" : o(e4);
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(51), __esModule: true };
    }, function(e3, t2, n2) {
      n2(20), n2(29), e3.exports = n2(30).f("iterator");
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = n2(22);
      e3.exports = function(e4) {
        return function(t3, n3) {
          var o, i, s = String(r2(t3)), c2 = a(n3), l2 = s.length;
          return c2 < 0 || c2 >= l2 ? e4 ? "" : void 0 : (o = s.charCodeAt(c2)) < 55296 || o > 56319 || c2 + 1 === l2 || (i = s.charCodeAt(c2 + 1)) < 56320 || i > 57343 ? e4 ? s.charAt(c2) : o : e4 ? s.slice(c2, c2 + 2) : i - 56320 + (o - 55296 << 10) + 65536;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(54);
      e3.exports = function(e4, t3, n3) {
        if (a(e4), t3 === void 0)
          return e4;
        switch (n3) {
          case 1:
            return function(n4) {
              return e4.call(t3, n4);
            };
          case 2:
            return function(n4, a2) {
              return e4.call(t3, n4, a2);
            };
          case 3:
            return function(n4, a2, r2) {
              return e4.call(t3, n4, a2, r2);
            };
        }
        return function() {
          return e4.apply(t3, arguments);
        };
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (typeof e4 != "function")
          throw TypeError(e4 + " is not a function!");
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(38), r2 = n2(16), o = n2(28), i = {};
      n2(6)(i, n2(2)("iterator"), function() {
        return this;
      }), e3.exports = function(e4, t3, n3) {
        e4.prototype = a(i, { next: r2(1, n3) }), o(e4, t3 + " Iterator");
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(10), o = n2(13);
      e3.exports = n2(4) ? Object.defineProperties : function(e4, t3) {
        r2(e4);
        for (var n3, i = o(t3), s = i.length, c2 = 0; s > c2; )
          a.f(e4, n3 = i[c2++], t3[n3]);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(58), o = n2(59);
      e3.exports = function(e4) {
        return function(t3, n3, i) {
          var s, c2 = a(t3), l2 = r2(c2.length), u = o(i, l2);
          if (e4 && n3 != n3) {
            for (; l2 > u; )
              if ((s = c2[u++]) != s)
                return true;
          } else
            for (; l2 > u; u++)
              if ((e4 || u in c2) && c2[u] === n3)
                return e4 || u || 0;
          return !e4 && -1;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.min;
      e3.exports = function(e4) {
        return e4 > 0 ? r2(a(e4), 9007199254740991) : 0;
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.max, o = Math.min;
      e3.exports = function(e4, t3) {
        return (e4 = a(e4)) < 0 ? r2(e4 + t3, 0) : o(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(3).document;
      e3.exports = a && a.documentElement;
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(18), o = n2(25)("IE_PROTO"), i = Object.prototype;
      e3.exports = Object.getPrototypeOf || function(e4) {
        return e4 = r2(e4), a(e4, o) ? e4[o] : typeof e4.constructor == "function" && e4 instanceof e4.constructor ? e4.constructor.prototype : e4 instanceof Object ? i : null;
      };
    }, function(e3, t2, n2) {
      var a = n2(63), r2 = n2(64), o = n2(12), i = n2(9);
      e3.exports = n2(34)(Array, "Array", function(e4, t3) {
        this._t = i(e4), this._i = 0, this._k = t3;
      }, function() {
        var e4 = this._t, t3 = this._k, n3 = this._i++;
        return !e4 || n3 >= e4.length ? (this._t = void 0, r2(1)) : r2(0, t3 == "keys" ? n3 : t3 == "values" ? e4[n3] : [n3, e4[n3]]);
      }, "values"), o.Arguments = o.Array, a("keys"), a("values"), a("entries");
    }, function(e3, t2) {
      e3.exports = function() {
      };
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { value: t3, done: !!e4 };
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(66), __esModule: true };
    }, function(e3, t2, n2) {
      n2(67), n2(73), n2(74), n2(75), e3.exports = n2(1).Symbol;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(5), o = n2(4), i = n2(15), s = n2(37), c2 = n2(68).KEY, l2 = n2(8), u = n2(26), f2 = n2(28), p2 = n2(17), d2 = n2(2), b2 = n2(30), h = n2(31), v4 = n2(69), m2 = n2(70), y2 = n2(10), g2 = n2(11), E = n2(18), j = n2(9), x2 = n2(23), _ = n2(16), k2 = n2(38), O2 = n2(71), C = n2(72), S2 = n2(32), w2 = n2(7), A2 = n2(13), M2 = C.f, P2 = w2.f, F2 = O2.f, D2 = a.Symbol, I2 = a.JSON, R2 = I2 && I2.stringify, L = d2("_hidden"), B2 = d2("toPrimitive"), N2 = {}.propertyIsEnumerable, z2 = u("symbol-registry"), T2 = u("symbols"), q2 = u("op-symbols"), V2 = Object.prototype, K = typeof D2 == "function" && !!S2.f, W2 = a.QObject, H2 = !W2 || !W2.prototype || !W2.prototype.findChild, U2 = o && l2(function() {
        return k2(P2({}, "a", { get: function() {
          return P2(this, "a", { value: 7 }).a;
        } })).a != 7;
      }) ? function(e4, t3, n3) {
        var a2 = M2(V2, t3);
        a2 && delete V2[t3], P2(e4, t3, n3), a2 && e4 !== V2 && P2(V2, t3, a2);
      } : P2, G2 = function(e4) {
        var t3 = T2[e4] = k2(D2.prototype);
        return t3._k = e4, t3;
      }, J = K && typeof D2.iterator == "symbol" ? function(e4) {
        return typeof e4 == "symbol";
      } : function(e4) {
        return e4 instanceof D2;
      }, Y2 = function(e4, t3, n3) {
        return e4 === V2 && Y2(q2, t3, n3), y2(e4), t3 = x2(t3, true), y2(n3), r2(T2, t3) ? (n3.enumerable ? (r2(e4, L) && e4[L][t3] && (e4[L][t3] = false), n3 = k2(n3, { enumerable: _(0, false) })) : (r2(e4, L) || P2(e4, L, _(1, {})), e4[L][t3] = true), U2(e4, t3, n3)) : P2(e4, t3, n3);
      }, $ = function(e4, t3) {
        y2(e4);
        for (var n3, a2 = v4(t3 = j(t3)), r3 = 0, o2 = a2.length; o2 > r3; )
          Y2(e4, n3 = a2[r3++], t3[n3]);
        return e4;
      }, Q = function(e4) {
        var t3 = N2.call(this, e4 = x2(e4, true));
        return !(this === V2 && r2(T2, e4) && !r2(q2, e4)) && (!(t3 || !r2(this, e4) || !r2(T2, e4) || r2(this, L) && this[L][e4]) || t3);
      }, Z2 = function(e4, t3) {
        if (e4 = j(e4), t3 = x2(t3, true), e4 !== V2 || !r2(T2, t3) || r2(q2, t3)) {
          var n3 = M2(e4, t3);
          return !n3 || !r2(T2, t3) || r2(e4, L) && e4[L][t3] || (n3.enumerable = true), n3;
        }
      }, X2 = function(e4) {
        for (var t3, n3 = F2(j(e4)), a2 = [], o2 = 0; n3.length > o2; )
          r2(T2, t3 = n3[o2++]) || t3 == L || t3 == c2 || a2.push(t3);
        return a2;
      }, ee2 = function(e4) {
        for (var t3, n3 = e4 === V2, a2 = F2(n3 ? q2 : j(e4)), o2 = [], i2 = 0; a2.length > i2; )
          !r2(T2, t3 = a2[i2++]) || n3 && !r2(V2, t3) || o2.push(T2[t3]);
        return o2;
      };
      K || (s((D2 = function() {
        if (this instanceof D2)
          throw TypeError("Symbol is not a constructor!");
        var e4 = p2(arguments.length > 0 ? arguments[0] : void 0), t3 = function(n3) {
          this === V2 && t3.call(q2, n3), r2(this, L) && r2(this[L], e4) && (this[L][e4] = false), U2(this, e4, _(1, n3));
        };
        return o && H2 && U2(V2, e4, { configurable: true, set: t3 }), G2(e4);
      }).prototype, "toString", function() {
        return this._k;
      }), C.f = Z2, w2.f = Y2, n2(41).f = O2.f = X2, n2(19).f = Q, S2.f = ee2, o && !n2(14) && s(V2, "propertyIsEnumerable", Q, true), b2.f = function(e4) {
        return G2(d2(e4));
      }), i(i.G + i.W + i.F * !K, { Symbol: D2 });
      for (var te2 = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), ne2 = 0; te2.length > ne2; )
        d2(te2[ne2++]);
      for (var ae2 = A2(d2.store), re2 = 0; ae2.length > re2; )
        h(ae2[re2++]);
      i(i.S + i.F * !K, "Symbol", { for: function(e4) {
        return r2(z2, e4 += "") ? z2[e4] : z2[e4] = D2(e4);
      }, keyFor: function(e4) {
        if (!J(e4))
          throw TypeError(e4 + " is not a symbol!");
        for (var t3 in z2)
          if (z2[t3] === e4)
            return t3;
      }, useSetter: function() {
        H2 = true;
      }, useSimple: function() {
        H2 = false;
      } }), i(i.S + i.F * !K, "Object", { create: function(e4, t3) {
        return t3 === void 0 ? k2(e4) : $(k2(e4), t3);
      }, defineProperty: Y2, defineProperties: $, getOwnPropertyDescriptor: Z2, getOwnPropertyNames: X2, getOwnPropertySymbols: ee2 });
      var oe2 = l2(function() {
        S2.f(1);
      });
      i(i.S + i.F * oe2, "Object", { getOwnPropertySymbols: function(e4) {
        return S2.f(E(e4));
      } }), I2 && i(i.S + i.F * (!K || l2(function() {
        var e4 = D2();
        return R2([e4]) != "[null]" || R2({ a: e4 }) != "{}" || R2(Object(e4)) != "{}";
      })), "JSON", { stringify: function(e4) {
        for (var t3, n3, a2 = [e4], r3 = 1; arguments.length > r3; )
          a2.push(arguments[r3++]);
        if (n3 = t3 = a2[1], (g2(t3) || e4 !== void 0) && !J(e4))
          return m2(t3) || (t3 = function(e5, t4) {
            if (typeof n3 == "function" && (t4 = n3.call(this, e5, t4)), !J(t4))
              return t4;
          }), a2[1] = t3, R2.apply(I2, a2);
      } }), D2.prototype[B2] || n2(6)(D2.prototype, B2, D2.prototype.valueOf), f2(D2, "Symbol"), f2(Math, "Math", true), f2(a.JSON, "JSON", true);
    }, function(e3, t2, n2) {
      var a = n2(17)("meta"), r2 = n2(11), o = n2(5), i = n2(7).f, s = 0, c2 = Object.isExtensible || function() {
        return true;
      }, l2 = !n2(8)(function() {
        return c2(Object.preventExtensions({}));
      }), u = function(e4) {
        i(e4, a, { value: { i: "O" + ++s, w: {} } });
      }, f2 = e3.exports = { KEY: a, NEED: false, fastKey: function(e4, t3) {
        if (!r2(e4))
          return typeof e4 == "symbol" ? e4 : (typeof e4 == "string" ? "S" : "P") + e4;
        if (!o(e4, a)) {
          if (!c2(e4))
            return "F";
          if (!t3)
            return "E";
          u(e4);
        }
        return e4[a].i;
      }, getWeak: function(e4, t3) {
        if (!o(e4, a)) {
          if (!c2(e4))
            return true;
          if (!t3)
            return false;
          u(e4);
        }
        return e4[a].w;
      }, onFreeze: function(e4) {
        return l2 && f2.NEED && c2(e4) && !o(e4, a) && u(e4), e4;
      } };
    }, function(e3, t2, n2) {
      var a = n2(13), r2 = n2(32), o = n2(19);
      e3.exports = function(e4) {
        var t3 = a(e4), n3 = r2.f;
        if (n3)
          for (var i, s = n3(e4), c2 = o.f, l2 = 0; s.length > l2; )
            c2.call(e4, i = s[l2++]) && t3.push(i);
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Array.isArray || function(e4) {
        return a(e4) == "Array";
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(41).f, o = {}.toString, i = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
      e3.exports.f = function(e4) {
        return i && o.call(e4) == "[object Window]" ? function(e5) {
          try {
            return r2(e5);
          } catch (e6) {
            return i.slice();
          }
        }(e4) : r2(a(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(19), r2 = n2(16), o = n2(9), i = n2(23), s = n2(5), c2 = n2(35), l2 = Object.getOwnPropertyDescriptor;
      t2.f = n2(4) ? l2 : function(e4, t3) {
        if (e4 = o(e4), t3 = i(t3, true), c2)
          try {
            return l2(e4, t3);
          } catch (e5) {
          }
        if (s(e4, t3))
          return r2(!a.f.call(e4, t3), e4[t3]);
      };
    }, function(e3, t2) {
    }, function(e3, t2, n2) {
      n2(31)("asyncIterator");
    }, function(e3, t2, n2) {
      n2(31)("observable");
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a, r2 = n2(77), o = (a = r2) && a.__esModule ? a : { default: a };
      t2.default = o.default || function(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3];
          for (var a2 in n3)
            Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
        }
        return e4;
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(78), __esModule: true };
    }, function(e3, t2, n2) {
      n2(79), e3.exports = n2(1).Object.assign;
    }, function(e3, t2, n2) {
      var a = n2(15);
      a(a.S + a.F, "Object", { assign: n2(80) });
    }, function(e3, t2, n2) {
      var a = n2(4), r2 = n2(13), o = n2(32), i = n2(19), s = n2(18), c2 = n2(40), l2 = Object.assign;
      e3.exports = !l2 || n2(8)(function() {
        var e4 = {}, t3 = {}, n3 = Symbol(), a2 = "abcdefghijklmnopqrst";
        return e4[n3] = 7, a2.split("").forEach(function(e5) {
          t3[e5] = e5;
        }), l2({}, e4)[n3] != 7 || Object.keys(l2({}, t3)).join("") != a2;
      }) ? function(e4, t3) {
        for (var n3 = s(e4), l3 = arguments.length, u = 1, f2 = o.f, p2 = i.f; l3 > u; )
          for (var d2, b2 = c2(arguments[u++]), h = f2 ? r2(b2).concat(f2(b2)) : r2(b2), v4 = h.length, m2 = 0; v4 > m2; )
            d2 = h[m2++], a && !p2.call(b2, d2) || (n3[d2] = b2[d2]);
        return n3;
      } : l2;
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = o(n2(82)), r2 = o(n2(85));
      function o(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = function(e4, t3) {
        if (Array.isArray(e4))
          return e4;
        if ((0, a.default)(Object(e4)))
          return function(e5, t4) {
            var n3 = [], a2 = true, o2 = false, i = void 0;
            try {
              for (var s, c2 = (0, r2.default)(e5); !(a2 = (s = c2.next()).done) && (n3.push(s.value), !t4 || n3.length !== t4); a2 = true)
                ;
            } catch (e6) {
              o2 = true, i = e6;
            } finally {
              try {
                !a2 && c2.return && c2.return();
              } finally {
                if (o2)
                  throw i;
              }
            }
            return n3;
          }(e4, t3);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(83), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(84);
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).isIterable = function(e4) {
        var t3 = Object(e4);
        return t3[r2] !== void 0 || "@@iterator" in t3 || o.hasOwnProperty(a(t3));
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(86), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(87);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(88);
      e3.exports = n2(1).getIterator = function(e4) {
        var t3 = r2(e4);
        if (typeof t3 != "function")
          throw TypeError(e4 + " is not iterable!");
        return a(t3.call(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).getIteratorMethod = function(e4) {
        if (e4 != null)
          return e4[r2] || e4["@@iterator"] || o[a(e4)];
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(90), __esModule: true };
    }, function(e3, t2, n2) {
      n2(91), e3.exports = n2(1).Object.keys;
    }, function(e3, t2, n2) {
      var a = n2(18), r2 = n2(13);
      n2(92)("keys", function() {
        return function(e4) {
          return r2(a(e4));
        };
      });
    }, function(e3, t2, n2) {
      var a = n2(15), r2 = n2(1), o = n2(8);
      e3.exports = function(e4, t3) {
        var n3 = (r2.Object || {})[e4] || Object[e4], i = {};
        i[e4] = t3(n3), a(a.S + a.F * o(function() {
          n3(1);
        }), "Object", i);
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], a = /^\s+|\s+$/g, r2 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, o = /\{\n\/\* \[wrapped with (.+)\] \*/, i = /,? & /, s = /^[-+]0x[0-9a-f]+$/i, c2 = /^0b[01]+$/i, l2 = /^\[object .+?Constructor\]$/, u = /^0o[0-7]+$/i, f2 = /^(?:0|[1-9]\d*)$/, p2 = parseInt, d2 = typeof t3 == "object" && t3 && t3.Object === Object && t3, b2 = typeof self == "object" && self && self.Object === Object && self, h = d2 || b2 || Function("return this")();
        function v4(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function m2(e4, t4) {
          return !!(e4 ? e4.length : 0) && function(e5, t5, n4) {
            if (t5 != t5)
              return function(e6, t6, n5, a3) {
                var r4 = e6.length, o2 = n5 + (a3 ? 1 : -1);
                for (; a3 ? o2-- : ++o2 < r4; )
                  if (t6(e6[o2], o2, e6))
                    return o2;
                return -1;
              }(e5, y2, n4);
            var a2 = n4 - 1, r3 = e5.length;
            for (; ++a2 < r3; )
              if (e5[a2] === t5)
                return a2;
            return -1;
          }(e4, t4, 0) > -1;
        }
        function y2(e4) {
          return e4 != e4;
        }
        function g2(e4, t4) {
          for (var n4 = e4.length, a2 = 0; n4--; )
            e4[n4] === t4 && a2++;
          return a2;
        }
        function E(e4, t4) {
          for (var n4 = -1, a2 = e4.length, r3 = 0, o2 = []; ++n4 < a2; ) {
            var i2 = e4[n4];
            i2 !== t4 && i2 !== "__lodash_placeholder__" || (e4[n4] = "__lodash_placeholder__", o2[r3++] = n4);
          }
          return o2;
        }
        var j, x2, _, k2 = Function.prototype, O2 = Object.prototype, C = h["__core-js_shared__"], S2 = (j = /[^.]+$/.exec(C && C.keys && C.keys.IE_PROTO || "")) ? "Symbol(src)_1." + j : "", w2 = k2.toString, A2 = O2.hasOwnProperty, M2 = O2.toString, P2 = RegExp("^" + w2.call(A2).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), F2 = Object.create, D2 = Math.max, I2 = Math.min, R2 = (x2 = H2(Object, "defineProperty"), (_ = H2.name) && _.length > 2 ? x2 : void 0);
        function L(e4) {
          return X2(e4) ? F2(e4) : {};
        }
        function B2(e4) {
          return !(!X2(e4) || function(e5) {
            return !!S2 && S2 in e5;
          }(e4)) && (function(e5) {
            var t4 = X2(e5) ? M2.call(e5) : "";
            return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
          }(e4) || function(e5) {
            var t4 = false;
            if (e5 != null && typeof e5.toString != "function")
              try {
                t4 = !!(e5 + "");
              } catch (e6) {
              }
            return t4;
          }(e4) ? P2 : l2).test(function(e5) {
            if (e5 != null) {
              try {
                return w2.call(e5);
              } catch (e6) {
              }
              try {
                return e5 + "";
              } catch (e6) {
              }
            }
            return "";
          }(e4));
        }
        function N2(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = n4.length, s2 = -1, c3 = t4.length, l3 = D2(o2 - i2, 0), u2 = Array(c3 + l3), f3 = !a2; ++s2 < c3; )
            u2[s2] = t4[s2];
          for (; ++r3 < i2; )
            (f3 || r3 < o2) && (u2[n4[r3]] = e4[r3]);
          for (; l3--; )
            u2[s2++] = e4[r3++];
          return u2;
        }
        function z2(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = -1, s2 = n4.length, c3 = -1, l3 = t4.length, u2 = D2(o2 - s2, 0), f3 = Array(u2 + l3), p3 = !a2; ++r3 < u2; )
            f3[r3] = e4[r3];
          for (var d3 = r3; ++c3 < l3; )
            f3[d3 + c3] = t4[c3];
          for (; ++i2 < s2; )
            (p3 || r3 < o2) && (f3[d3 + n4[i2]] = e4[r3++]);
          return f3;
        }
        function T2(e4) {
          return function() {
            var t4 = arguments;
            switch (t4.length) {
              case 0:
                return new e4();
              case 1:
                return new e4(t4[0]);
              case 2:
                return new e4(t4[0], t4[1]);
              case 3:
                return new e4(t4[0], t4[1], t4[2]);
              case 4:
                return new e4(t4[0], t4[1], t4[2], t4[3]);
              case 5:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4]);
              case 6:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5]);
              case 7:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5], t4[6]);
            }
            var n4 = L(e4.prototype), a2 = e4.apply(n4, t4);
            return X2(a2) ? a2 : n4;
          };
        }
        function q2(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 128 & t4, f3 = 1 & t4, p3 = 2 & t4, d3 = 24 & t4, b3 = 512 & t4, v5 = p3 ? void 0 : T2(e4);
          return function m3() {
            for (var y3 = arguments.length, j2 = Array(y3), x3 = y3; x3--; )
              j2[x3] = arguments[x3];
            if (d3)
              var _2 = W2(m3), k3 = g2(j2, _2);
            if (a2 && (j2 = N2(j2, a2, r3, d3)), o2 && (j2 = z2(j2, o2, i2, d3)), y3 -= k3, d3 && y3 < l3) {
              var O3 = E(j2, _2);
              return V2(e4, t4, q2, m3.placeholder, n4, j2, O3, s2, c3, l3 - y3);
            }
            var C2 = f3 ? n4 : this, S3 = p3 ? C2[e4] : e4;
            return y3 = j2.length, s2 ? j2 = Y2(j2, s2) : b3 && y3 > 1 && j2.reverse(), u2 && c3 < y3 && (j2.length = c3), this && this !== h && this instanceof m3 && (S3 = v5 || T2(S3)), S3.apply(C2, j2);
          };
        }
        function V2(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 8 & t4;
          t4 |= u2 ? 32 : 64, 4 & (t4 &= ~(u2 ? 64 : 32)) || (t4 &= -4);
          var f3 = n4(e4, t4, r3, u2 ? o2 : void 0, u2 ? i2 : void 0, u2 ? void 0 : o2, u2 ? void 0 : i2, s2, c3, l3);
          return f3.placeholder = a2, $(f3, e4, t4);
        }
        function K(e4, t4, n4, a2, r3, o2, i2, s2) {
          var c3 = 2 & t4;
          if (!c3 && typeof e4 != "function")
            throw new TypeError("Expected a function");
          var l3 = a2 ? a2.length : 0;
          if (l3 || (t4 &= -97, a2 = r3 = void 0), i2 = i2 === void 0 ? i2 : D2(te2(i2), 0), s2 = s2 === void 0 ? s2 : te2(s2), l3 -= r3 ? r3.length : 0, 64 & t4) {
            var u2 = a2, f3 = r3;
            a2 = r3 = void 0;
          }
          var p3 = [e4, t4, n4, a2, r3, u2, f3, o2, i2, s2];
          if (e4 = p3[0], t4 = p3[1], n4 = p3[2], a2 = p3[3], r3 = p3[4], !(s2 = p3[9] = p3[9] == null ? c3 ? 0 : e4.length : D2(p3[9] - l3, 0)) && 24 & t4 && (t4 &= -25), t4 && t4 != 1)
            d3 = t4 == 8 || t4 == 16 ? function(e5, t5, n5) {
              var a3 = T2(e5);
              return function r4() {
                for (var o3 = arguments.length, i3 = Array(o3), s3 = o3, c4 = W2(r4); s3--; )
                  i3[s3] = arguments[s3];
                var l4 = o3 < 3 && i3[0] !== c4 && i3[o3 - 1] !== c4 ? [] : E(i3, c4);
                if ((o3 -= l4.length) < n5)
                  return V2(e5, t5, q2, r4.placeholder, void 0, i3, l4, void 0, void 0, n5 - o3);
                var u3 = this && this !== h && this instanceof r4 ? a3 : e5;
                return v4(u3, this, i3);
              };
            }(e4, t4, s2) : t4 != 32 && t4 != 33 || r3.length ? q2.apply(void 0, p3) : function(e5, t5, n5, a3) {
              var r4 = 1 & t5, o3 = T2(e5);
              return function t6() {
                for (var i3 = -1, s3 = arguments.length, c4 = -1, l4 = a3.length, u3 = Array(l4 + s3), f4 = this && this !== h && this instanceof t6 ? o3 : e5; ++c4 < l4; )
                  u3[c4] = a3[c4];
                for (; s3--; )
                  u3[c4++] = arguments[++i3];
                return v4(f4, r4 ? n5 : this, u3);
              };
            }(e4, t4, n4, a2);
          else
            var d3 = function(e5, t5, n5) {
              var a3 = 1 & t5, r4 = T2(e5);
              return function t6() {
                var o3 = this && this !== h && this instanceof t6 ? r4 : e5;
                return o3.apply(a3 ? n5 : this, arguments);
              };
            }(e4, t4, n4);
          return $(d3, e4, t4);
        }
        function W2(e4) {
          return e4.placeholder;
        }
        function H2(e4, t4) {
          var n4 = function(e5, t5) {
            return e5 == null ? void 0 : e5[t5];
          }(e4, t4);
          return B2(n4) ? n4 : void 0;
        }
        function U2(e4) {
          var t4 = e4.match(o);
          return t4 ? t4[1].split(i) : [];
        }
        function G2(e4, t4) {
          var n4 = t4.length, a2 = n4 - 1;
          return t4[a2] = (n4 > 1 ? "& " : "") + t4[a2], t4 = t4.join(n4 > 2 ? ", " : " "), e4.replace(r2, "{\n/* [wrapped with " + t4 + "] */\n");
        }
        function J(e4, t4) {
          return !!(t4 = t4 == null ? 9007199254740991 : t4) && (typeof e4 == "number" || f2.test(e4)) && e4 > -1 && e4 % 1 == 0 && e4 < t4;
        }
        function Y2(e4, t4) {
          for (var n4 = e4.length, a2 = I2(t4.length, n4), r3 = function(e5, t5) {
            var n5 = -1, a3 = e5.length;
            for (t5 || (t5 = Array(a3)); ++n5 < a3; )
              t5[n5] = e5[n5];
            return t5;
          }(e4); a2--; ) {
            var o2 = t4[a2];
            e4[a2] = J(o2, n4) ? r3[o2] : void 0;
          }
          return e4;
        }
        var $ = R2 ? function(e4, t4, n4) {
          var a2, r3 = t4 + "";
          return R2(e4, "toString", { configurable: true, enumerable: false, value: (a2 = G2(r3, Q(U2(r3), n4)), function() {
            return a2;
          }) });
        } : function(e4) {
          return e4;
        };
        function Q(e4, t4) {
          return function(e5, t5) {
            for (var n4 = -1, a2 = e5 ? e5.length : 0; ++n4 < a2 && t5(e5[n4], n4, e5) !== false; )
              ;
          }(n3, function(n4) {
            var a2 = "_." + n4[0];
            t4 & n4[1] && !m2(e4, a2) && e4.push(a2);
          }), e4.sort();
        }
        function Z2(e4, t4, n4) {
          var a2 = K(e4, 8, void 0, void 0, void 0, void 0, void 0, t4 = n4 ? void 0 : t4);
          return a2.placeholder = Z2.placeholder, a2;
        }
        function X2(e4) {
          var t4 = typeof e4;
          return !!e4 && (t4 == "object" || t4 == "function");
        }
        function ee2(e4) {
          return e4 ? (e4 = function(e5) {
            if (typeof e5 == "number")
              return e5;
            if (function(e6) {
              return typeof e6 == "symbol" || function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && M2.call(e6) == "[object Symbol]";
            }(e5))
              return NaN;
            if (X2(e5)) {
              var t4 = typeof e5.valueOf == "function" ? e5.valueOf() : e5;
              e5 = X2(t4) ? t4 + "" : t4;
            }
            if (typeof e5 != "string")
              return e5 === 0 ? e5 : +e5;
            e5 = e5.replace(a, "");
            var n4 = c2.test(e5);
            return n4 || u.test(e5) ? p2(e5.slice(2), n4 ? 2 : 8) : s.test(e5) ? NaN : +e5;
          }(e4)) === 1 / 0 || e4 === -1 / 0 ? 17976931348623157e292 * (e4 < 0 ? -1 : 1) : e4 == e4 ? e4 : 0 : e4 === 0 ? e4 : 0;
        }
        function te2(e4) {
          var t4 = ee2(e4), n4 = t4 % 1;
          return t4 == t4 ? n4 ? t4 - n4 : t4 : 0;
        }
        Z2.placeholder = {}, e3.exports = Z2;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      function a(e4) {
        return e4 && e4.__esModule ? e4.default : e4;
      }
      t2.__esModule = true;
      var r2 = n2(95);
      t2.threezerotwofour = a(r2);
      var o = n2(96);
      t2.apathy = a(o);
      var i = n2(97);
      t2.ashes = a(i);
      var s = n2(98);
      t2.atelierDune = a(s);
      var c2 = n2(99);
      t2.atelierForest = a(c2);
      var l2 = n2(100);
      t2.atelierHeath = a(l2);
      var u = n2(101);
      t2.atelierLakeside = a(u);
      var f2 = n2(102);
      t2.atelierSeaside = a(f2);
      var p2 = n2(103);
      t2.bespin = a(p2);
      var d2 = n2(104);
      t2.brewer = a(d2);
      var b2 = n2(105);
      t2.bright = a(b2);
      var h = n2(106);
      t2.chalk = a(h);
      var v4 = n2(107);
      t2.codeschool = a(v4);
      var m2 = n2(108);
      t2.colors = a(m2);
      var y2 = n2(109);
      t2.default = a(y2);
      var g2 = n2(110);
      t2.eighties = a(g2);
      var E = n2(111);
      t2.embers = a(E);
      var j = n2(112);
      t2.flat = a(j);
      var x2 = n2(113);
      t2.google = a(x2);
      var _ = n2(114);
      t2.grayscale = a(_);
      var k2 = n2(115);
      t2.greenscreen = a(k2);
      var O2 = n2(116);
      t2.harmonic = a(O2);
      var C = n2(117);
      t2.hopscotch = a(C);
      var S2 = n2(118);
      t2.isotope = a(S2);
      var w2 = n2(119);
      t2.marrakesh = a(w2);
      var A2 = n2(120);
      t2.mocha = a(A2);
      var M2 = n2(121);
      t2.monokai = a(M2);
      var P2 = n2(122);
      t2.ocean = a(P2);
      var F2 = n2(123);
      t2.paraiso = a(F2);
      var D2 = n2(124);
      t2.pop = a(D2);
      var I2 = n2(125);
      t2.railscasts = a(I2);
      var R2 = n2(126);
      t2.shapeshifter = a(R2);
      var L = n2(127);
      t2.solarized = a(L);
      var B2 = n2(128);
      t2.summerfruit = a(B2);
      var N2 = n2(129);
      t2.tomorrow = a(N2);
      var z2 = n2(130);
      t2.tube = a(z2);
      var T2 = n2(131);
      t2.twilight = a(T2);
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      var a = n2(33);
      function r2(e4) {
        var t3 = Math.round(a(e4, 0, 255)).toString(16);
        return t3.length == 1 ? "0" + t3 : t3;
      }
      e3.exports = function(e4) {
        var t3 = e4.length === 4 ? r2(255 * e4[3]) : "";
        return "#" + r2(e4[0]) + r2(e4[1]) + r2(e4[2]) + t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(134), r2 = n2(135), o = n2(136), i = n2(137);
      var s = { "#": r2, hsl: function(e4) {
        var t3 = a(e4), n3 = i(t3);
        return t3.length === 4 && n3.push(t3[3]), n3;
      }, rgb: o };
      function c2(e4) {
        for (var t3 in s)
          if (e4.indexOf(t3) === 0)
            return s[t3](e4);
      }
      c2.rgb = o, c2.hsl = a, c2.hex = r2, e3.exports = c2;
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        switch (e4 = parseFloat(e4), t3) {
          case 0:
            return r2(e4, 0, 360);
          case 1:
          case 2:
            return r2(e4, 0, 100);
          case 3:
            return r2(e4, 0, 1);
        }
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        e4.length !== 4 && e4.length !== 5 || (e4 = function(e5) {
          for (var t4 = "#", n3 = 1; n3 < e5.length; n3++) {
            var a = e5.charAt(n3);
            t4 += a + a;
          }
          return t4;
        }(e4));
        var t3 = [parseInt(e4.substring(1, 3), 16), parseInt(e4.substring(3, 5), 16), parseInt(e4.substring(5, 7), 16)];
        if (e4.length === 9) {
          var n2 = parseFloat((parseInt(e4.substring(7, 9), 16) / 255).toFixed(2));
          t3.push(n2);
        }
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        return t3 < 3 ? e4.indexOf("%") != -1 ? Math.round(255 * r2(parseInt(e4, 10), 0, 100) / 100) : r2(parseInt(e4, 10), 0, 255) : r2(parseFloat(e4), 0, 1);
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        var t3, n2, a, r2, o, i = e4[0] / 360, s = e4[1] / 100, c2 = e4[2] / 100;
        if (s == 0)
          return [o = 255 * c2, o, o];
        t3 = 2 * c2 - (n2 = c2 < 0.5 ? c2 * (1 + s) : c2 + s - c2 * s), r2 = [0, 0, 0];
        for (var l2 = 0; l2 < 3; l2++)
          (a = i + 1 / 3 * -(l2 - 1)) < 0 && a++, a > 1 && a--, o = 6 * a < 1 ? t3 + 6 * (n2 - t3) * a : 2 * a < 1 ? n2 : 3 * a < 2 ? t3 + (n2 - t3) * (2 / 3 - a) * 6 : t3, r2[l2] = 255 * o;
        return r2;
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = typeof t3 == "object" && t3 && t3.Object === Object && t3, a = typeof self == "object" && self && self.Object === Object && self, r2 = n3 || a || Function("return this")();
        function o(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function i(e4, t4) {
          for (var n4 = -1, a2 = t4.length, r3 = e4.length; ++n4 < a2; )
            e4[r3 + n4] = t4[n4];
          return e4;
        }
        var s = Object.prototype, c2 = s.hasOwnProperty, l2 = s.toString, u = r2.Symbol, f2 = s.propertyIsEnumerable, p2 = u ? u.isConcatSpreadable : void 0, d2 = Math.max;
        function b2(e4) {
          return h(e4) || function(e5) {
            return function(e6) {
              return function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && function(e7) {
                return e7 != null && function(e8) {
                  return typeof e8 == "number" && e8 > -1 && e8 % 1 == 0 && e8 <= 9007199254740991;
                }(e7.length) && !function(e8) {
                  var t4 = function(e9) {
                    var t5 = typeof e9;
                    return !!e9 && (t5 == "object" || t5 == "function");
                  }(e8) ? l2.call(e8) : "";
                  return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
                }(e7);
              }(e6);
            }(e5) && c2.call(e5, "callee") && (!f2.call(e5, "callee") || l2.call(e5) == "[object Arguments]");
          }(e4) || !!(p2 && e4 && e4[p2]);
        }
        var h = Array.isArray;
        var v4, m2, y2, g2 = (m2 = function(e4) {
          var t4 = (e4 = function e5(t5, n5, a2, r3, o2) {
            var s2 = -1, c3 = t5.length;
            for (a2 || (a2 = b2), o2 || (o2 = []); ++s2 < c3; ) {
              var l3 = t5[s2];
              n5 > 0 && a2(l3) ? n5 > 1 ? e5(l3, n5 - 1, a2, r3, o2) : i(o2, l3) : r3 || (o2[o2.length] = l3);
            }
            return o2;
          }(e4, 1)).length, n4 = t4;
          for (v4; n4--; )
            if (typeof e4[n4] != "function")
              throw new TypeError("Expected a function");
          return function() {
            for (var n5 = 0, a2 = t4 ? e4[n5].apply(this, arguments) : arguments[0]; ++n5 < t4; )
              a2 = e4[n5].call(this, a2);
            return a2;
          };
        }, y2 = d2(y2 === void 0 ? m2.length - 1 : y2, 0), function() {
          for (var e4 = arguments, t4 = -1, n4 = d2(e4.length - y2, 0), a2 = Array(n4); ++t4 < n4; )
            a2[t4] = e4[y2 + t4];
          t4 = -1;
          for (var r3 = Array(y2 + 1); ++t4 < y2; )
            r3[t4] = e4[t4];
          return r3[y2] = a2, o(m2, this, r3);
        });
        e3.exports = g2;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.yuv2rgb = function(e4) {
        var t3, n3, a, r2 = e4[0], o = e4[1], i = e4[2];
        return t3 = 1 * r2 + 0 * o + 1.13983 * i, n3 = 1 * r2 + -0.39465 * o + -0.5806 * i, a = 1 * r2 + 2.02311 * o + 0 * i, t3 = Math.min(Math.max(0, t3), 1), n3 = Math.min(Math.max(0, n3), 1), a = Math.min(Math.max(0, a), 1), [255 * t3, 255 * n3, 255 * a];
      }, t2.rgb2yuv = function(e4) {
        var t3 = e4[0] / 255, n3 = e4[1] / 255, a = e4[2] / 255;
        return [0.299 * t3 + 0.587 * n3 + 0.114 * a, -0.14713 * t3 + -0.28886 * n3 + 0.436 * a, 0.615 * t3 + -0.51499 * n3 + -0.10001 * a];
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      var r2 = n2(141), o = function() {
        function e4() {
          a(this, "_callbacks", void 0), a(this, "_isDispatching", void 0), a(this, "_isHandled", void 0), a(this, "_isPending", void 0), a(this, "_lastID", void 0), a(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
        }
        var t3 = e4.prototype;
        return t3.register = function(e5) {
          var t4 = "ID_" + this._lastID++;
          return this._callbacks[t4] = e5, t4;
        }, t3.unregister = function(e5) {
          this._callbacks[e5] || r2(false), delete this._callbacks[e5];
        }, t3.waitFor = function(e5) {
          this._isDispatching || r2(false);
          for (var t4 = 0; t4 < e5.length; t4++) {
            var n3 = e5[t4];
            this._isPending[n3] ? this._isHandled[n3] || r2(false) : (this._callbacks[n3] || r2(false), this._invokeCallback(n3));
          }
        }, t3.dispatch = function(e5) {
          this._isDispatching && r2(false), this._startDispatching(e5);
          try {
            for (var t4 in this._callbacks)
              this._isPending[t4] || this._invokeCallback(t4);
          } finally {
            this._stopDispatching();
          }
        }, t3.isDispatching = function() {
          return this._isDispatching;
        }, t3._invokeCallback = function(e5) {
          this._isPending[e5] = true, this._callbacks[e5](this._pendingPayload), this._isHandled[e5] = true;
        }, t3._startDispatching = function(e5) {
          for (var t4 in this._callbacks)
            this._isPending[t4] = false, this._isHandled[t4] = false;
          this._pendingPayload = e5, this._isDispatching = true;
        }, t3._stopDispatching = function() {
          delete this._pendingPayload, this._isDispatching = false;
        }, e4;
      }();
      e3.exports = o;
    }, function(e3, t2, n2) {
      e3.exports = function(e4, t3) {
        for (var n3 = arguments.length, r2 = new Array(n3 > 2 ? n3 - 2 : 0), o = 2; o < n3; o++)
          r2[o - 2] = arguments[o];
        if (!e4) {
          var i;
          if (t3 === void 0)
            i = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
          else {
            var s = 0;
            (i = new Error(t3.replace(/%s/g, function() {
              return String(r2[s++]);
            }))).name = "Invariant Violation";
          }
          throw i.framesToPop = 1, i;
        }
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      function r2(e4, t3) {
        var n3 = Object.keys(e4);
        if (Object.getOwnPropertySymbols) {
          var a2 = Object.getOwnPropertySymbols(e4);
          t3 && (a2 = a2.filter(function(t4) {
            return Object.getOwnPropertyDescriptor(e4, t4).enumerable;
          })), n3.push.apply(n3, a2);
        }
        return n3;
      }
      function o(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3] != null ? arguments[t3] : {};
          t3 % 2 ? r2(Object(n3), true).forEach(function(t4) {
            a(e4, t4, n3[t4]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e4, Object.getOwnPropertyDescriptors(n3)) : r2(Object(n3)).forEach(function(t4) {
            Object.defineProperty(e4, t4, Object.getOwnPropertyDescriptor(n3, t4));
          });
        }
        return e4;
      }
      function i(e4, t3) {
        if (!(e4 instanceof t3))
          throw new TypeError("Cannot call a class as a function");
      }
      function s(e4, t3) {
        for (var n3 = 0; n3 < t3.length; n3++) {
          var a2 = t3[n3];
          a2.enumerable = a2.enumerable || false, a2.configurable = true, "value" in a2 && (a2.writable = true), Object.defineProperty(e4, a2.key, a2);
        }
      }
      function c2(e4, t3, n3) {
        return t3 && s(e4.prototype, t3), n3 && s(e4, n3), e4;
      }
      function l2(e4, t3) {
        return (l2 = Object.setPrototypeOf || function(e5, t4) {
          return e5.__proto__ = t4, e5;
        })(e4, t3);
      }
      function u(e4, t3) {
        if (typeof t3 != "function" && t3 !== null)
          throw new TypeError("Super expression must either be null or a function");
        e4.prototype = Object.create(t3 && t3.prototype, { constructor: { value: e4, writable: true, configurable: true } }), t3 && l2(e4, t3);
      }
      function f2(e4) {
        return (f2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(e5) {
          return e5.__proto__ || Object.getPrototypeOf(e5);
        })(e4);
      }
      function p2(e4) {
        return (p2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e5) {
          return typeof e5;
        } : function(e5) {
          return e5 && typeof Symbol == "function" && e5.constructor === Symbol && e5 !== Symbol.prototype ? "symbol" : typeof e5;
        })(e4);
      }
      function d2(e4) {
        if (e4 === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return e4;
      }
      function b2(e4, t3) {
        return !t3 || p2(t3) !== "object" && typeof t3 != "function" ? d2(e4) : t3;
      }
      function h(e4) {
        var t3 = function() {
          if (typeof Reflect == "undefined" || !Reflect.construct)
            return false;
          if (Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
            })), true;
          } catch (e5) {
            return false;
          }
        }();
        return function() {
          var n3, a2 = f2(e4);
          if (t3) {
            var r3 = f2(this).constructor;
            n3 = Reflect.construct(a2, arguments, r3);
          } else
            n3 = a2.apply(this, arguments);
          return b2(this, n3);
        };
      }
      n2.r(t2);
      var v4 = n2(0), m2 = n2.n(v4);
      function y2() {
        var e4 = this.constructor.getDerivedStateFromProps(this.props, this.state);
        e4 != null && this.setState(e4);
      }
      function g2(e4) {
        this.setState(function(t3) {
          var n3 = this.constructor.getDerivedStateFromProps(e4, t3);
          return n3 != null ? n3 : null;
        }.bind(this));
      }
      function E(e4, t3) {
        try {
          var n3 = this.props, a2 = this.state;
          this.props = e4, this.state = t3, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(n3, a2);
        } finally {
          this.props = n3, this.state = a2;
        }
      }
      function j(e4) {
        var t3 = e4.prototype;
        if (!t3 || !t3.isReactComponent)
          throw new Error("Can only polyfill class components");
        if (typeof e4.getDerivedStateFromProps != "function" && typeof t3.getSnapshotBeforeUpdate != "function")
          return e4;
        var n3 = null, a2 = null, r3 = null;
        if (typeof t3.componentWillMount == "function" ? n3 = "componentWillMount" : typeof t3.UNSAFE_componentWillMount == "function" && (n3 = "UNSAFE_componentWillMount"), typeof t3.componentWillReceiveProps == "function" ? a2 = "componentWillReceiveProps" : typeof t3.UNSAFE_componentWillReceiveProps == "function" && (a2 = "UNSAFE_componentWillReceiveProps"), typeof t3.componentWillUpdate == "function" ? r3 = "componentWillUpdate" : typeof t3.UNSAFE_componentWillUpdate == "function" && (r3 = "UNSAFE_componentWillUpdate"), n3 !== null || a2 !== null || r3 !== null) {
          var o2 = e4.displayName || e4.name, i2 = typeof e4.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
          throw Error("Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n" + o2 + " uses " + i2 + " but also contains the following legacy lifecycles:" + (n3 !== null ? "\n  " + n3 : "") + (a2 !== null ? "\n  " + a2 : "") + (r3 !== null ? "\n  " + r3 : "") + "\n\nThe above lifecycles should be removed. Learn more about this warning here:\nhttps://fb.me/react-async-component-lifecycle-hooks");
        }
        if (typeof e4.getDerivedStateFromProps == "function" && (t3.componentWillMount = y2, t3.componentWillReceiveProps = g2), typeof t3.getSnapshotBeforeUpdate == "function") {
          if (typeof t3.componentDidUpdate != "function")
            throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
          t3.componentWillUpdate = E;
          var s2 = t3.componentDidUpdate;
          t3.componentDidUpdate = function(e5, t4, n4) {
            var a3 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : n4;
            s2.call(this, e5, t4, a3);
          };
        }
        return e4;
      }
      function x2(e4, t3) {
        if (e4 == null)
          return {};
        var n3, a2, r3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, t3);
        if (Object.getOwnPropertySymbols) {
          var o2 = Object.getOwnPropertySymbols(e4);
          for (a2 = 0; a2 < o2.length; a2++)
            n3 = o2[a2], t3.indexOf(n3) >= 0 || Object.prototype.propertyIsEnumerable.call(e4, n3) && (r3[n3] = e4[n3]);
        }
        return r3;
      }
      function _(e4) {
        var t3 = function(e5) {
          return {}.toString.call(e5).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
        }(e4);
        return t3 === "number" && (t3 = isNaN(e4) ? "nan" : (0 | e4) != e4 ? "float" : "integer"), t3;
      }
      y2.__suppressDeprecationWarning = true, g2.__suppressDeprecationWarning = true, E.__suppressDeprecationWarning = true;
      var k2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, O2 = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, C = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, S2 = n2(45), w2 = function(e4) {
        var t3 = function(e5) {
          return { backgroundColor: e5.base00, ellipsisColor: e5.base09, braceColor: e5.base07, expandedIcon: e5.base0D, collapsedIcon: e5.base0E, keyColor: e5.base07, arrayKeyColor: e5.base0C, objectSize: e5.base04, copyToClipboard: e5.base0F, copyToClipboardCheck: e5.base0D, objectBorder: e5.base02, dataTypes: { boolean: e5.base0E, date: e5.base0D, float: e5.base0B, function: e5.base0D, integer: e5.base0F, string: e5.base09, nan: e5.base08, null: e5.base0A, undefined: e5.base05, regexp: e5.base0A, background: e5.base02 }, editVariable: { editIcon: e5.base0E, cancelIcon: e5.base09, removeIcon: e5.base09, addIcon: e5.base0E, checkIcon: e5.base0E, background: e5.base01, color: e5.base0A, border: e5.base07 }, addKeyModal: { background: e5.base05, border: e5.base04, color: e5.base0A, labelColor: e5.base01 }, validationFailure: { background: e5.base09, iconColor: e5.base01, fontColor: e5.base01 } };
        }(e4);
        return { "app-container": { fontFamily: C.globalFontFamily, cursor: C.globalCursor, backgroundColor: t3.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: C.braceCursor, fontWeight: C.braceFontWeight, color: t3.braceColor }, "expanded-icon": { color: t3.expandedIcon }, "collapsed-icon": { color: t3.collapsedIcon }, colon: { display: "inline-block", margin: C.keyMargin, color: t3.keyColor, verticalAlign: "top" }, objectKeyVal: function(e5, n3) {
          return { style: o({ paddingTop: C.keyValPaddingTop, paddingRight: C.keyValPaddingRight, paddingBottom: C.keyValPaddingBottom, borderLeft: C.keyValBorderLeft + " " + t3.objectBorder, ":hover": { paddingLeft: n3.paddingLeft - 1 + "px", borderLeft: C.keyValBorderHover + " " + t3.objectBorder } }, n3) };
        }, "object-key-val-no-border": { padding: C.keyValPadding }, "pushed-content": { marginLeft: C.pushedContentMarginLeft }, variableValue: function(e5, t4) {
          return { style: o({ display: "inline-block", paddingRight: C.variableValuePaddingRight, position: "relative" }, t4) };
        }, "object-name": { display: "inline-block", color: t3.keyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "array-key": { display: "inline-block", color: t3.arrayKeyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "object-size": { color: t3.objectSize, borderRadius: C.objectSizeBorderRadius, fontStyle: C.objectSizeFontStyle, margin: C.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: C.dataTypeFontSize, marginRight: C.dataTypeMarginRight, opacity: C.datatypeOpacity }, boolean: { display: "inline-block", color: t3.dataTypes.boolean }, date: { display: "inline-block", color: t3.dataTypes.date }, "date-value": { marginLeft: C.dateValueMarginLeft }, float: { display: "inline-block", color: t3.dataTypes.float }, function: { display: "inline-block", color: t3.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: t3.dataTypes.integer }, string: { display: "inline-block", color: t3.dataTypes.string }, nan: { display: "inline-block", color: t3.dataTypes.nan, fontSize: C.nanFontSize, fontWeight: C.nanFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nanPadding, borderRadius: C.nanBorderRadius }, null: { display: "inline-block", color: t3.dataTypes.null, fontSize: C.nullFontSize, fontWeight: C.nullFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nullPadding, borderRadius: C.nullBorderRadius }, undefined: { display: "inline-block", color: t3.dataTypes.undefined, fontSize: C.undefinedFontSize, padding: C.undefinedPadding, borderRadius: C.undefinedBorderRadius, backgroundColor: t3.dataTypes.background }, regexp: { display: "inline-block", color: t3.dataTypes.regexp }, "copy-to-clipboard": { cursor: C.clipboardCursor }, "copy-icon": { color: t3.copyToClipboard, fontSize: C.iconFontSize, marginRight: C.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: t3.copyToClipboardCheck, marginLeft: C.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: C.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: C.metaDataPadding }, "icon-container": { display: "inline-block", width: C.iconContainerWidth }, tooltip: { padding: C.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.removeIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.addIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.editIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.checkIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.cancelIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: C.editInputMinWidth, borderRadius: C.editInputBorderRadius, backgroundColor: t3.editVariable.background, color: t3.editVariable.color, padding: C.editInputPadding, marginRight: C.editInputMarginRight, fontFamily: C.editInputFontFamily }, "detected-row": { paddingTop: C.detectedRowPaddingTop }, "key-modal-request": { position: C.addKeyCoverPosition, top: C.addKeyCoverPositionPx, left: C.addKeyCoverPositionPx, right: C.addKeyCoverPositionPx, bottom: C.addKeyCoverPositionPx, backgroundColor: C.addKeyCoverBackground }, "key-modal": { width: C.addKeyModalWidth, backgroundColor: t3.addKeyModal.background, marginLeft: C.addKeyModalMargin, marginRight: C.addKeyModalMargin, padding: C.addKeyModalPadding, borderRadius: C.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: t3.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: t3.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: t3.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: t3.addKeyModal.labelColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: t3.editVariable.addIcon, fontSize: C.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: t3.validationFailure.fontColor, backgroundColor: t3.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: t3.validationFailure.iconColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" } };
      };
      function A2(e4, t3, n3) {
        return e4 || console.error("theme has not been set"), function(e5) {
          var t4 = k2;
          return e5 !== false && e5 !== "none" || (t4 = O2), Object(S2.createStyling)(w2, { defaultBase16: t4 })(e5);
        }(e4)(t3, n3);
      }
      var M2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = (e5.rjvId, e5.type_name), n4 = e5.displayDataTypes, a2 = e5.theme;
          return n4 ? m2.a.createElement("span", Object.assign({ className: "data-type-label" }, A2(a2, "data-type-label")), t4) : null;
        } }]), n3;
      }(m2.a.PureComponent), P2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "boolean"), m2.a.createElement(M2, Object.assign({ type_name: "bool" }, e5)), e5.value ? "true" : "false");
        } }]), n3;
      }(m2.a.PureComponent), F2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "date"), m2.a.createElement(M2, Object.assign({ type_name: "date" }, e5)), m2.a.createElement("span", Object.assign({ className: "date-value" }, A2(e5.theme, "date-value")), e5.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
        } }]), n3;
      }(m2.a.PureComponent), D2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "float"), m2.a.createElement(M2, Object.assign({ type_name: "float" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent);
      function I2(e4, t3) {
        (t3 == null || t3 > e4.length) && (t3 = e4.length);
        for (var n3 = 0, a2 = new Array(t3); n3 < t3; n3++)
          a2[n3] = e4[n3];
        return a2;
      }
      function R2(e4, t3) {
        if (e4) {
          if (typeof e4 == "string")
            return I2(e4, t3);
          var n3 = Object.prototype.toString.call(e4).slice(8, -1);
          return n3 === "Object" && e4.constructor && (n3 = e4.constructor.name), n3 === "Map" || n3 === "Set" ? Array.from(e4) : n3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n3) ? I2(e4, t3) : void 0;
        }
      }
      function L(e4, t3) {
        var n3;
        if (typeof Symbol == "undefined" || e4[Symbol.iterator] == null) {
          if (Array.isArray(e4) || (n3 = R2(e4)) || t3 && e4 && typeof e4.length == "number") {
            n3 && (e4 = n3);
            var a2 = 0, r3 = function() {
            };
            return { s: r3, n: function() {
              return a2 >= e4.length ? { done: true } : { done: false, value: e4[a2++] };
            }, e: function(e5) {
              throw e5;
            }, f: r3 };
          }
          throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }
        var o2, i2 = true, s2 = false;
        return { s: function() {
          n3 = e4[Symbol.iterator]();
        }, n: function() {
          var e5 = n3.next();
          return i2 = e5.done, e5;
        }, e: function(e5) {
          s2 = true, o2 = e5;
        }, f: function() {
          try {
            i2 || n3.return == null || n3.return();
          } finally {
            if (s2)
              throw o2;
          }
        } };
      }
      function B2(e4) {
        return function(e5) {
          if (Array.isArray(e5))
            return I2(e5);
        }(e4) || function(e5) {
          if (typeof Symbol != "undefined" && Symbol.iterator in Object(e5))
            return Array.from(e5);
        }(e4) || R2(e4) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }();
      }
      var N2 = n2(46), z2 = new (n2(47)).Dispatcher(), T2 = new (function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).objects = {}, e5.set = function(t4, n4, a3, r4) {
            e5.objects[t4] === void 0 && (e5.objects[t4] = {}), e5.objects[t4][n4] === void 0 && (e5.objects[t4][n4] = {}), e5.objects[t4][n4][a3] = r4;
          }, e5.get = function(t4, n4, a3, r4) {
            return e5.objects[t4] === void 0 || e5.objects[t4][n4] === void 0 || e5.objects[t4][n4][a3] == null ? r4 : e5.objects[t4][n4][a3];
          }, e5.handleAction = function(t4) {
            var n4 = t4.rjvId, a3 = t4.data;
            switch (t4.name) {
              case "RESET":
                e5.emit("reset-" + n4);
                break;
              case "VARIABLE_UPDATED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-edited" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_REMOVED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-removed" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_ADDED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-added" })), e5.emit("variable-update-" + n4);
                break;
              case "ADD_VARIABLE_KEY_REQUEST":
                e5.set(n4, "action", "new-key-request", a3), e5.emit("add-key-request-" + n4);
            }
          }, e5.updateSrc = function(t4, n4) {
            var a3 = n4.name, r4 = n4.namespace, o2 = n4.new_value, i2 = (n4.existing_value, n4.variable_removed);
            r4.shift();
            var s3, c3 = e5.get(t4, "global", "src"), l3 = e5.deepCopy(c3, B2(r4)), u2 = l3, f3 = L(r4);
            try {
              for (f3.s(); !(s3 = f3.n()).done; ) {
                u2 = u2[s3.value];
              }
            } catch (e6) {
              f3.e(e6);
            } finally {
              f3.f();
            }
            return i2 ? _(u2) == "array" ? u2.splice(a3, 1) : delete u2[a3] : a3 !== null ? u2[a3] = o2 : l3 = o2, e5.set(t4, "global", "src", l3), l3;
          }, e5.deepCopy = function(t4, n4) {
            var a3, r4 = _(t4), i2 = n4.shift();
            return r4 == "array" ? a3 = B2(t4) : r4 == "object" && (a3 = o({}, t4)), i2 !== void 0 && (a3[i2] = e5.deepCopy(t4[i2], n4)), a3;
          }, e5;
        }
        return n3;
      }(N2.EventEmitter))();
      z2.register(T2.handleAction.bind(T2));
      var q2 = T2, V2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.getFunctionDisplay = function(e6) {
            var t4 = d2(a2).props;
            return e6 ? m2.a.createElement("span", null, a2.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), m2.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, m2.a.createElement("span", null, "{"), m2.a.createElement("span", A2(t4.theme, "ellipsis"), "..."), m2.a.createElement("span", null, "}"))) : a2.props.value.toString().slice(9, -1);
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = this.state.collapsed;
          return m2.a.createElement("div", A2(e5.theme, "function"), m2.a.createElement(M2, Object.assign({ type_name: "function" }, e5)), m2.a.createElement("span", Object.assign({}, A2(e5.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(t4)));
        } }]), n3;
      }(m2.a.PureComponent), K = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "nan"), "NaN");
        } }]), n3;
      }(m2.a.PureComponent), W2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "null"), "NULL");
        } }]), n3;
      }(m2.a.PureComponent), H2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "integer"), m2.a.createElement(M2, Object.assign({ type_name: "int" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent), U2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "regexp"), m2.a.createElement(M2, Object.assign({ type_name: "regexp" }, e5)), this.props.value.toString());
        } }]), n3;
      }(m2.a.PureComponent), G2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          this.state.collapsed;
          var e5 = this.props, t4 = e5.collapseStringsAfterLength, n4 = e5.theme, a2 = e5.value, r3 = { style: { cursor: "default" } };
          return _(t4) === "integer" && a2.length > t4 && (r3.style.cursor = "pointer", this.state.collapsed && (a2 = m2.a.createElement("span", null, a2.substring(0, t4), m2.a.createElement("span", A2(n4, "ellipsis"), " ...")))), m2.a.createElement("div", A2(n4, "string"), m2.a.createElement(M2, Object.assign({ type_name: "string" }, e5)), m2.a.createElement("span", Object.assign({ className: "string-value" }, r3, { onClick: this.toggleCollapsed }), '"', a2, '"'));
        } }]), n3;
      }(m2.a.PureComponent), J = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "undefined"), "undefined");
        } }]), n3;
      }(m2.a.PureComponent);
      function Y2() {
        return (Y2 = Object.assign || function(e4) {
          for (var t3 = 1; t3 < arguments.length; t3++) {
            var n3 = arguments[t3];
            for (var a2 in n3)
              Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
          }
          return e4;
        }).apply(this, arguments);
      }
      var $ = v4.useLayoutEffect, Q = function(e4) {
        var t3 = Object(v4.useRef)(e4);
        return $(function() {
          t3.current = e4;
        }), t3;
      }, Z2 = function(e4, t3) {
        typeof e4 != "function" ? e4.current = t3 : e4(t3);
      }, X2 = function(e4, t3) {
        var n3 = Object(v4.useRef)();
        return Object(v4.useCallback)(function(a2) {
          e4.current = a2, n3.current && Z2(n3.current, null), n3.current = t3, t3 && Z2(t3, a2);
        }, [t3]);
      }, ee2 = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, te2 = function(e4) {
        Object.keys(ee2).forEach(function(t3) {
          e4.style.setProperty(t3, ee2[t3], "important");
        });
      }, ne2 = null;
      var ae2 = function() {
      }, re2 = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], oe2 = !!document.documentElement.currentStyle, ie2 = function(e4, t3) {
        var n3 = e4.cacheMeasurements, a2 = e4.maxRows, r3 = e4.minRows, o2 = e4.onChange, i2 = o2 === void 0 ? ae2 : o2, s2 = e4.onHeightChange, c3 = s2 === void 0 ? ae2 : s2, l3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]);
        var u2, f3 = l3.value !== void 0, p3 = Object(v4.useRef)(null), d3 = X2(p3, t3), b3 = Object(v4.useRef)(0), h2 = Object(v4.useRef)(), m3 = function() {
          var e5 = p3.current, t4 = n3 && h2.current ? h2.current : function(e6) {
            var t5 = window.getComputedStyle(e6);
            if (t5 === null)
              return null;
            var n4, a3 = (n4 = t5, re2.reduce(function(e7, t6) {
              return e7[t6] = n4[t6], e7;
            }, {})), r4 = a3.boxSizing;
            return r4 === "" ? null : (oe2 && r4 === "border-box" && (a3.width = parseFloat(a3.width) + parseFloat(a3.borderRightWidth) + parseFloat(a3.borderLeftWidth) + parseFloat(a3.paddingRight) + parseFloat(a3.paddingLeft) + "px"), { sizingStyle: a3, paddingSize: parseFloat(a3.paddingBottom) + parseFloat(a3.paddingTop), borderSize: parseFloat(a3.borderBottomWidth) + parseFloat(a3.borderTopWidth) });
          }(e5);
          if (t4) {
            h2.current = t4;
            var o3 = function(e6, t5, n4, a3) {
              n4 === void 0 && (n4 = 1), a3 === void 0 && (a3 = 1 / 0), ne2 || ((ne2 = document.createElement("textarea")).setAttribute("tab-index", "-1"), ne2.setAttribute("aria-hidden", "true"), te2(ne2)), ne2.parentNode === null && document.body.appendChild(ne2);
              var r4 = e6.paddingSize, o4 = e6.borderSize, i4 = e6.sizingStyle, s4 = i4.boxSizing;
              Object.keys(i4).forEach(function(e7) {
                var t6 = e7;
                ne2.style[t6] = i4[t6];
              }), te2(ne2), ne2.value = t5;
              var c4 = function(e7, t6) {
                var n5 = e7.scrollHeight;
                return t6.sizingStyle.boxSizing === "border-box" ? n5 + t6.borderSize : n5 - t6.paddingSize;
              }(ne2, e6);
              ne2.value = "x";
              var l4 = ne2.scrollHeight - r4, u3 = l4 * n4;
              s4 === "border-box" && (u3 = u3 + r4 + o4), c4 = Math.max(u3, c4);
              var f4 = l4 * a3;
              return s4 === "border-box" && (f4 = f4 + r4 + o4), [c4 = Math.min(f4, c4), l4];
            }(t4, e5.value || e5.placeholder || "x", r3, a2), i3 = o3[0], s3 = o3[1];
            b3.current !== i3 && (b3.current = i3, e5.style.setProperty("height", i3 + "px", "important"), c3(i3, { rowHeight: s3 }));
          }
        };
        return Object(v4.useLayoutEffect)(m3), u2 = Q(m3), Object(v4.useLayoutEffect)(function() {
          var e5 = function(e6) {
            u2.current(e6);
          };
          return window.addEventListener("resize", e5), function() {
            window.removeEventListener("resize", e5);
          };
        }, []), Object(v4.createElement)("textarea", Y2({}, l3, { onChange: function(e5) {
          f3 || m3(), i2(e5);
        }, ref: d3 }));
      }, se2 = Object(v4.forwardRef)(ie2);
      function ce2(e4) {
        e4 = e4.trim();
        try {
          if ((e4 = JSON.stringify(JSON.parse(e4)))[0] === "[")
            return le2("array", JSON.parse(e4));
          if (e4[0] === "{")
            return le2("object", JSON.parse(e4));
          if (e4.match(/\-?\d+\.\d+/) && e4.match(/\-?\d+\.\d+/)[0] === e4)
            return le2("float", parseFloat(e4));
          if (e4.match(/\-?\d+e-\d+/) && e4.match(/\-?\d+e-\d+/)[0] === e4)
            return le2("float", Number(e4));
          if (e4.match(/\-?\d+/) && e4.match(/\-?\d+/)[0] === e4)
            return le2("integer", parseInt(e4));
          if (e4.match(/\-?\d+e\+\d+/) && e4.match(/\-?\d+e\+\d+/)[0] === e4)
            return le2("integer", Number(e4));
        } catch (e5) {
        }
        switch (e4 = e4.toLowerCase()) {
          case "undefined":
            return le2("undefined", void 0);
          case "nan":
            return le2("nan", NaN);
          case "null":
            return le2("null", null);
          case "true":
            return le2("boolean", true);
          case "false":
            return le2("boolean", false);
          default:
            if (e4 = Date.parse(e4))
              return le2("date", new Date(e4));
        }
        return le2(false, null);
      }
      function le2(e4, t3) {
        return { type: e4, value: t3 };
      }
      var ue2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
        } }]), n3;
      }(m2.a.PureComponent), fe2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
        } }]), n3;
      }(m2.a.PureComponent), pe2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), de2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), be2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), he2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), ve2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), me2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ye = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ge2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
        } }]), n3;
      }(m2.a.PureComponent), Ee2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), je2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent);
      function xe(e4) {
        return e4 || (e4 = {}), { style: o(o({ verticalAlign: "middle" }, e4), {}, { color: e4.color ? e4.color : "#000000", height: "1em", width: "1em" }) };
      }
      var _e = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).copiedTimer = null, a2.handleCopy = function() {
            var e6 = document.createElement("textarea"), t4 = a2.props, n4 = t4.clickCallback, r3 = t4.src, o2 = t4.namespace;
            e6.innerHTML = JSON.stringify(a2.clipboardValue(r3), null, "  "), document.body.appendChild(e6), e6.select(), document.execCommand("copy"), document.body.removeChild(e6), a2.copiedTimer = setTimeout(function() {
              a2.setState({ copied: false });
            }, 5500), a2.setState({ copied: true }, function() {
              typeof n4 == "function" && n4({ src: r3, namespace: o2, name: o2[o2.length - 1] });
            });
          }, a2.getClippyIcon = function() {
            var e6 = a2.props.theme;
            return a2.state.copied ? m2.a.createElement("span", null, m2.a.createElement(ve2, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon"))), m2.a.createElement("span", A2(e6, "copy-icon-copied"), "\u2714")) : m2.a.createElement(ve2, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon")));
          }, a2.clipboardValue = function(e6) {
            switch (_(e6)) {
              case "function":
              case "regexp":
                return e6.toString();
              default:
                return e6;
            }
          }, a2.state = { copied: false }, a2;
        }
        return c2(n3, [{ key: "componentWillUnmount", value: function() {
          this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
        } }, { key: "render", value: function() {
          var e5 = this.props, t4 = (e5.src, e5.theme), n4 = e5.hidden, a2 = e5.rowHovered, r3 = A2(t4, "copy-to-clipboard").style, i2 = "inline";
          return n4 && (i2 = "none"), m2.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: a2 ? "inline-block" : "none" } }, m2.a.createElement("span", { style: o(o({}, r3), {}, { display: i2 }), onClick: this.handleCopy }, this.getClippyIcon()));
        } }]), n3;
      }(m2.a.PureComponent), ke2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).getEditIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.theme;
            return m2.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(Ee2, Object.assign({ className: "click-to-edit-icon" }, A2(n4, "editVarIcon"), { onClick: function() {
              a2.prepopInput(t4);
            } })));
          }, a2.prepopInput = function(e6) {
            if (a2.props.onEdit !== false) {
              var t4 = function(e7) {
                var t5;
                switch (_(e7)) {
                  case "undefined":
                    t5 = "undefined";
                    break;
                  case "nan":
                    t5 = "NaN";
                    break;
                  case "string":
                    t5 = e7;
                    break;
                  case "date":
                  case "function":
                  case "regexp":
                    t5 = e7.toString();
                    break;
                  default:
                    try {
                      t5 = JSON.stringify(e7, null, "  ");
                    } catch (e8) {
                      t5 = "";
                    }
                }
                return t5;
              }(e6.value), n4 = ce2(t4);
              a2.setState({ editMode: true, editValue: t4, parsedInput: { type: n4.type, value: n4.value } });
            }
          }, a2.getRemoveIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.namespace, r3 = e6.theme, o2 = e6.rjvId;
            return m2.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(me2, Object.assign({ className: "click-to-remove-icon" }, A2(r3, "removeVarIcon"), { onClick: function() {
              z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: o2, data: { name: t4.name, namespace: n4, existing_value: t4.value, variable_removed: true } });
            } })));
          }, a2.getValue = function(e6, t4) {
            var n4 = !t4 && e6.type, r3 = d2(a2).props;
            switch (n4) {
              case false:
                return a2.getEditInput();
              case "string":
                return m2.a.createElement(G2, Object.assign({ value: e6.value }, r3));
              case "integer":
                return m2.a.createElement(H2, Object.assign({ value: e6.value }, r3));
              case "float":
                return m2.a.createElement(D2, Object.assign({ value: e6.value }, r3));
              case "boolean":
                return m2.a.createElement(P2, Object.assign({ value: e6.value }, r3));
              case "function":
                return m2.a.createElement(V2, Object.assign({ value: e6.value }, r3));
              case "null":
                return m2.a.createElement(W2, r3);
              case "nan":
                return m2.a.createElement(K, r3);
              case "undefined":
                return m2.a.createElement(J, r3);
              case "date":
                return m2.a.createElement(F2, Object.assign({ value: e6.value }, r3));
              case "regexp":
                return m2.a.createElement(U2, Object.assign({ value: e6.value }, r3));
              default:
                return m2.a.createElement("div", { className: "object-value" }, JSON.stringify(e6.value));
            }
          }, a2.getEditInput = function() {
            var e6 = a2.props.theme, t4 = a2.state.editValue;
            return m2.a.createElement("div", null, m2.a.createElement(se2, Object.assign({ type: "text", inputRef: function(e7) {
              return e7 && e7.focus();
            }, value: t4, className: "variable-editor", onChange: function(e7) {
              var t5 = e7.target.value, n4 = ce2(t5);
              a2.setState({ editValue: t5, parsedInput: { type: n4.type, value: n4.value } });
            }, onKeyDown: function(e7) {
              switch (e7.key) {
                case "Escape":
                  a2.setState({ editMode: false, editValue: "" });
                  break;
                case "Enter":
                  (e7.ctrlKey || e7.metaKey) && a2.submitEdit(true);
              }
              e7.stopPropagation();
            }, placeholder: "update this value", minRows: 2 }, A2(e6, "edit-input"))), m2.a.createElement("div", A2(e6, "edit-icon-container"), m2.a.createElement(me2, Object.assign({ className: "edit-cancel" }, A2(e6, "cancel-icon"), { onClick: function() {
              a2.setState({ editMode: false, editValue: "" });
            } })), m2.a.createElement(je2, Object.assign({ className: "edit-check string-value" }, A2(e6, "check-icon"), { onClick: function() {
              a2.submitEdit();
            } })), m2.a.createElement("div", null, a2.showDetected())));
          }, a2.submitEdit = function(e6) {
            var t4 = a2.props, n4 = t4.variable, r3 = t4.namespace, o2 = t4.rjvId, i2 = a2.state, s2 = i2.editValue, c3 = i2.parsedInput, l3 = s2;
            e6 && c3.type && (l3 = c3.value), a2.setState({ editMode: false }), z2.dispatch({ name: "VARIABLE_UPDATED", rjvId: o2, data: { name: n4.name, namespace: r3, existing_value: n4.value, new_value: l3, variable_removed: false } });
          }, a2.showDetected = function() {
            var e6 = a2.props, t4 = e6.theme, n4 = (e6.variable, e6.namespace, e6.rjvId, a2.state.parsedInput), r3 = (n4.type, n4.value, a2.getDetectedInput());
            if (r3)
              return m2.a.createElement("div", null, m2.a.createElement("div", A2(t4, "detected-row"), r3, m2.a.createElement(je2, { className: "edit-check detected", style: o({ verticalAlign: "top", paddingLeft: "3px" }, A2(t4, "check-icon").style), onClick: function() {
                a2.submitEdit(true);
              } })));
          }, a2.getDetectedInput = function() {
            var e6 = a2.state.parsedInput, t4 = e6.type, n4 = e6.value, r3 = d2(a2).props, i2 = r3.theme;
            if (t4 !== false)
              switch (t4.toLowerCase()) {
                case "object":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "{"), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "}"));
                case "array":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "["), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "]"));
                case "string":
                  return m2.a.createElement(G2, Object.assign({ value: n4 }, r3));
                case "integer":
                  return m2.a.createElement(H2, Object.assign({ value: n4 }, r3));
                case "float":
                  return m2.a.createElement(D2, Object.assign({ value: n4 }, r3));
                case "boolean":
                  return m2.a.createElement(P2, Object.assign({ value: n4 }, r3));
                case "function":
                  return m2.a.createElement(V2, Object.assign({ value: n4 }, r3));
                case "null":
                  return m2.a.createElement(W2, r3);
                case "nan":
                  return m2.a.createElement(K, r3);
                case "undefined":
                  return m2.a.createElement(J, r3);
                case "date":
                  return m2.a.createElement(F2, Object.assign({ value: new Date(n4) }, r3));
              }
          }, a2.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.variable, a2 = t4.singleIndent, r3 = t4.type, i2 = t4.theme, s2 = t4.namespace, c3 = t4.indentWidth, l3 = t4.enableClipboard, u2 = t4.onEdit, f3 = t4.onDelete, p3 = t4.onSelect, d3 = t4.displayArrayKey, b3 = t4.quotesOnKeys, h2 = this.state.editMode;
          return m2.a.createElement("div", Object.assign({}, A2(i2, "objectKeyVal", { paddingLeft: c3 * a2 }), { onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          }, className: "variable-row", key: n4.name }), r3 == "array" ? d3 ? m2.a.createElement("span", Object.assign({}, A2(i2, "array-key"), { key: n4.name + "_" + s2 }), n4.name, m2.a.createElement("div", A2(i2, "colon"), ":")) : null : m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({}, A2(i2, "object-name"), { className: "object-key", key: n4.name + "_" + s2 }), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", { style: { display: "inline-block" } }, n4.name), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(i2, "colon"), ":")), m2.a.createElement("div", Object.assign({ className: "variable-value", onClick: p3 === false && u2 === false ? null : function(t5) {
            var a3 = B2(s2);
            (t5.ctrlKey || t5.metaKey) && u2 !== false ? e5.prepopInput(n4) : p3 !== false && (a3.shift(), p3(o(o({}, n4), {}, { namespace: a3 })));
          } }, A2(i2, "variableValue", { cursor: p3 === false ? "default" : "pointer" })), this.getValue(n4, h2)), l3 ? m2.a.createElement(_e, { rowHovered: this.state.hovered, hidden: h2, src: n4.value, clickCallback: l3, theme: i2, namespace: [].concat(B2(s2), [n4.name]) }) : null, u2 !== false && h2 == 0 ? this.getEditIcon() : null, f3 !== false && h2 == 0 ? this.getRemoveIcon() : null);
        } }]), n3;
      }(m2.a.PureComponent), Oe2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).getObjectSize = function() {
            var t4 = e5.props, n4 = t4.size, a3 = t4.theme;
            if (t4.displayObjectSize)
              return m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(a3, "object-size")), n4, " item", n4 === 1 ? "" : "s");
          }, e5.getAddAttribute = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = n4.namespace, i2 = n4.name, s3 = n4.src, c3 = n4.rjvId, l3 = n4.depth;
            return m2.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: t4 ? "inline-block" : "none" } }, m2.a.createElement(ye, Object.assign({ className: "click-to-add-icon" }, A2(a3, "addVarIcon"), { onClick: function() {
              var e6 = { name: l3 > 0 ? i2 : null, namespace: r4.splice(0, r4.length - 1), existing_value: s3, variable_removed: false, key_name: null };
              _(s3) === "object" ? z2.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: c3, data: e6 }) : z2.dispatch({ name: "VARIABLE_ADDED", rjvId: c3, data: o(o({}, e6), {}, { new_value: [].concat(B2(s3), [null]) }) });
            } })));
          }, e5.getRemoveObject = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = (n4.hover, n4.namespace), o2 = n4.name, i2 = n4.src, s3 = n4.rjvId;
            if (r4.length !== 1)
              return m2.a.createElement("span", { className: "click-to-remove", style: { display: t4 ? "inline-block" : "none" } }, m2.a.createElement(me2, Object.assign({ className: "click-to-remove-icon" }, A2(a3, "removeVarIcon"), { onClick: function() {
                z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: s3, data: { name: o2, namespace: r4.splice(0, r4.length - 1), existing_value: i2, variable_removed: true } });
              } })));
          }, e5.render = function() {
            var t4 = e5.props, n4 = t4.theme, a3 = t4.onDelete, r4 = t4.onAdd, o2 = t4.enableClipboard, i2 = t4.src, s3 = t4.namespace, c3 = t4.rowHovered;
            return m2.a.createElement("div", Object.assign({}, A2(n4, "object-meta-data"), { className: "object-meta-data", onClick: function(e6) {
              e6.stopPropagation();
            } }), e5.getObjectSize(), o2 ? m2.a.createElement(_e, { rowHovered: c3, clickCallback: o2, src: i2, theme: n4, namespace: s3 }) : null, r4 !== false ? e5.getAddAttribute(c3) : null, a3 !== false ? e5.getRemoveObject(c3) : null);
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent);
      function Ce2(e4) {
        var t3 = e4.parent_type, n3 = e4.namespace, a2 = e4.quotesOnKeys, r3 = e4.theme, o2 = e4.jsvRoot, i2 = e4.name, s2 = e4.displayArrayKey, c3 = e4.name ? e4.name : "";
        return !o2 || i2 !== false && i2 !== null ? t3 == "array" ? s2 ? m2.a.createElement("span", Object.assign({}, A2(r3, "array-key"), { key: n3 }), m2.a.createElement("span", { className: "array-key" }, c3), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null) : m2.a.createElement("span", Object.assign({}, A2(r3, "object-name"), { key: n3 }), m2.a.createElement("span", { className: "object-key" }, a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", null, c3), a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null);
      }
      function Se2(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(he2, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          case "square":
            return m2.a.createElement(pe2, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          default:
            return m2.a.createElement(ue2, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
        }
      }
      function we2(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(be2, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          case "square":
            return m2.a.createElement(de2, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          default:
            return m2.a.createElement(fe2, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
        }
      }
      var Ae2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function(e6) {
            var t4 = [];
            for (var n4 in a2.state.expanded)
              t4.push(a2.state.expanded[n4]);
            t4[e6] = !t4[e6], a2.setState({ expanded: t4 });
          }, a2.state = { expanded: [] }, a2;
        }
        return c2(n3, [{ key: "getExpandedIcon", value: function(e5) {
          var t4 = this.props, n4 = t4.theme, a2 = t4.iconStyle;
          return this.state.expanded[e5] ? m2.a.createElement(Se2, { theme: n4, iconStyle: a2 }) : m2.a.createElement(we2, { theme: n4, iconStyle: a2 });
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.src, a2 = t4.groupArraysAfterLength, r3 = (t4.depth, t4.name), o2 = t4.theme, i2 = t4.jsvRoot, s2 = t4.namespace, c3 = (t4.parent_type, x2(t4, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), l3 = 0, u2 = 5 * this.props.indentWidth;
          i2 || (l3 = 5 * this.props.indentWidth);
          var f3 = a2, p3 = Math.ceil(n4.length / f3);
          return m2.a.createElement("div", Object.assign({ className: "object-key-val" }, A2(o2, i2 ? "jsv-root" : "objectKeyVal", { paddingLeft: l3 })), m2.a.createElement(Ce2, this.props), m2.a.createElement("span", null, m2.a.createElement(Oe2, Object.assign({ size: n4.length }, this.props))), B2(Array(p3)).map(function(t5, a3) {
            return m2.a.createElement("div", Object.assign({ key: a3, className: "object-key-val array-group" }, A2(o2, "objectKeyVal", { marginLeft: 6, paddingLeft: u2 })), m2.a.createElement("span", A2(o2, "brace-row"), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            } }), e5.getExpandedIcon(a3)), e5.state.expanded[a3] ? m2.a.createElement(Fe2, Object.assign({ key: r3 + a3, depth: 0, name: false, collapsed: false, groupArraysAfterLength: f3, index_offset: a3 * f3, src: n4.slice(a3 * f3, a3 * f3 + f3), namespace: s2, type: "array", parent_type: "array_group", theme: o2 }, c3)) : m2.a.createElement("span", Object.assign({}, A2(o2, "brace"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            }, className: "array-group-brace" }), "[", m2.a.createElement("div", Object.assign({}, A2(o2, "array-group-meta-data"), { className: "array-group-meta-data" }), m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(o2, "object-size")), a3 * f3, " - ", a3 * f3 + f3 > n4.length ? n4.length : a3 * f3 + f3)), "]")));
          }));
        } }]), n3;
      }(m2.a.PureComponent), Me2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ expanded: !a2.state.expanded }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "expanded", a2.state.expanded);
            });
          }, a2.getObjectContent = function(e6, t4, n4) {
            return m2.a.createElement("div", { className: "pushed-content object-container" }, m2.a.createElement("div", Object.assign({ className: "object-content" }, A2(a2.props.theme, "pushed-content")), a2.renderObjectContents(t4, n4)));
          }, a2.getEllipsis = function() {
            return a2.state.size === 0 ? null : m2.a.createElement("div", Object.assign({}, A2(a2.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: a2.toggleCollapsed }), "...");
          }, a2.getObjectMetaData = function(e6) {
            var t4 = a2.props, n4 = (t4.rjvId, t4.theme, a2.state), r4 = n4.size, o2 = n4.hovered;
            return m2.a.createElement(Oe2, Object.assign({ rowHovered: o2, size: r4 }, a2.props));
          }, a2.renderObjectContents = function(e6, t4) {
            var n4, r4 = a2.props, o2 = r4.depth, i2 = r4.parent_type, s2 = r4.index_offset, c3 = r4.groupArraysAfterLength, l3 = r4.namespace, u2 = a2.state.object_type, f3 = [], p3 = Object.keys(e6 || {});
            return a2.props.sortKeys && u2 !== "array" && (p3 = p3.sort()), p3.forEach(function(r5) {
              if (n4 = new Pe2(r5, e6[r5]), i2 === "array_group" && s2 && (n4.name = parseInt(n4.name) + s2), e6.hasOwnProperty(r5))
                if (n4.type === "object")
                  f3.push(m2.a.createElement(Fe2, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), parent_type: u2 }, t4)));
                else if (n4.type === "array") {
                  var p4 = Fe2;
                  c3 && n4.value.length > c3 && (p4 = Ae2), f3.push(m2.a.createElement(p4, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), type: "array", parent_type: u2 }, t4)));
                } else
                  f3.push(m2.a.createElement(ke2, Object.assign({ key: n4.name + "_" + l3, variable: n4, singleIndent: 5, namespace: l3, type: a2.props.type }, t4)));
            }), f3;
          };
          var r3 = n3.getState(e5);
          return a2.state = o(o({}, r3), {}, { prevProps: {} }), a2;
        }
        return c2(n3, [{ key: "getBraceStart", value: function(e5, t4) {
          var n4 = this, a2 = this.props, r3 = a2.src, o2 = a2.theme, i2 = a2.iconStyle;
          if (a2.parent_type === "array_group")
            return m2.a.createElement("span", null, m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{"), t4 ? this.getObjectMetaData(r3) : null);
          var s2 = t4 ? Se2 : we2;
          return m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({ onClick: function(e6) {
            n4.toggleCollapsed();
          } }, A2(o2, "brace-row")), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container")), m2.a.createElement(s2, { theme: o2, iconStyle: i2 })), m2.a.createElement(Ce2, this.props), m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{")), t4 ? this.getObjectMetaData(r3) : null);
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.depth, a2 = t4.src, r3 = (t4.namespace, t4.name, t4.type, t4.parent_type), i2 = t4.theme, s2 = t4.jsvRoot, c3 = t4.iconStyle, l3 = x2(t4, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), u2 = this.state, f3 = u2.object_type, p3 = u2.expanded, d3 = {};
          return s2 || r3 === "array_group" ? r3 === "array_group" && (d3.borderLeft = 0, d3.display = "inline") : d3.paddingLeft = 5 * this.props.indentWidth, m2.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          } }, A2(i2, s2 ? "jsv-root" : "objectKeyVal", d3)), this.getBraceStart(f3, p3), p3 ? this.getObjectContent(n4, a2, o({ theme: i2, iconStyle: c3 }, l3)) : this.getEllipsis(), m2.a.createElement("span", { className: "brace-row" }, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { paddingLeft: p3 ? "3px" : "0px" }) }, f3 === "array" ? "]" : "}"), p3 ? null : this.getObjectMetaData(a2)));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          var a2 = t4.prevProps;
          return e5.src !== a2.src || e5.collapsed !== a2.collapsed || e5.name !== a2.name || e5.namespace !== a2.namespace || e5.rjvId !== a2.rjvId ? o(o({}, n3.getState(e5)), {}, { prevProps: e5 }) : null;
        } }]), n3;
      }(m2.a.PureComponent);
      Me2.getState = function(e4) {
        var t3 = Object.keys(e4.src).length, n3 = (e4.collapsed === false || e4.collapsed !== true && e4.collapsed > e4.depth) && (!e4.shouldCollapse || e4.shouldCollapse({ name: e4.name, src: e4.src, type: _(e4.src), namespace: e4.namespace }) === false) && t3 !== 0;
        return { expanded: q2.get(e4.rjvId, e4.namespace, "expanded", n3), object_type: e4.type === "array" ? "array" : "object", parent_type: e4.type === "array" ? "array" : "object", size: t3, hovered: false };
      };
      var Pe2 = function e4(t3, n3) {
        i(this, e4), this.name = t3, this.value = n3, this.type = _(n3);
      };
      j(Me2);
      var Fe2 = Me2, De2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), o2 = 0; o2 < a2; o2++)
            r3[o2] = arguments[o2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).render = function() {
            var t4 = d2(e5).props, n4 = [t4.name], a3 = Fe2;
            return Array.isArray(t4.src) && t4.groupArraysAfterLength && t4.src.length > t4.groupArraysAfterLength && (a3 = Ae2), m2.a.createElement("div", { className: "pretty-json-container object-container" }, m2.a.createElement("div", { className: "object-content" }, m2.a.createElement(a3, Object.assign({ namespace: n4, depth: 0, jsvRoot: true }, t4))));
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent), Ie2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).closeModal = function() {
            z2.dispatch({ rjvId: a2.props.rjvId, name: "RESET" });
          }, a2.submit = function() {
            a2.props.submit(a2.state.input);
          }, a2.state = { input: e5.input ? e5.input : "" }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.theme, a2 = t4.rjvId, r3 = t4.isValid, o2 = this.state.input, i2 = r3(o2);
          return m2.a.createElement("div", Object.assign({ className: "key-modal-request" }, A2(n4, "key-modal-request"), { onClick: this.closeModal }), m2.a.createElement("div", Object.assign({}, A2(n4, "key-modal"), { onClick: function(e6) {
            e6.stopPropagation();
          } }), m2.a.createElement("div", A2(n4, "key-modal-label"), "Key Name:"), m2.a.createElement("div", { style: { position: "relative" } }, m2.a.createElement("input", Object.assign({}, A2(n4, "key-modal-input"), { className: "key-modal-input", ref: function(e6) {
            return e6 && e6.focus();
          }, spellCheck: false, value: o2, placeholder: "...", onChange: function(t5) {
            e5.setState({ input: t5.target.value });
          }, onKeyPress: function(t5) {
            i2 && t5.key === "Enter" ? e5.submit() : t5.key === "Escape" && e5.closeModal();
          } })), i2 ? m2.a.createElement(je2, Object.assign({}, A2(n4, "key-modal-submit"), { className: "key-modal-submit", onClick: function(t5) {
            return e5.submit();
          } })) : null), m2.a.createElement("span", A2(n4, "key-modal-cancel"), m2.a.createElement(ge2, Object.assign({}, A2(n4, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
            z2.dispatch({ rjvId: a2, name: "RESET" });
          } })))));
        } }]), n3;
      }(m2.a.PureComponent), Re2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).isValid = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            return t4 != "" && Object.keys(a3.existing_value).indexOf(t4) === -1;
          }, e5.submit = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            a3.new_value = o({}, a3.existing_value), a3.new_value[t4] = e5.props.defaultValue, z2.dispatch({ name: "VARIABLE_ADDED", rjvId: n4, data: a3 });
          }, e5;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.active, n4 = e5.theme, a2 = e5.rjvId;
          return t4 ? m2.a.createElement(Ie2, { rjvId: a2, theme: n4, isValid: this.isValid, submit: this.submit }) : null;
        } }]), n3;
      }(m2.a.PureComponent), Le2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.message, n4 = e5.active, a2 = e5.theme, r3 = e5.rjvId;
          return n4 ? m2.a.createElement("div", Object.assign({ className: "validation-failure" }, A2(a2, "validation-failure"), { onClick: function() {
            z2.dispatch({ rjvId: r3, name: "RESET" });
          } }), m2.a.createElement("span", A2(a2, "validation-failure-label"), t4), m2.a.createElement(ge2, A2(a2, "validation-failure-clear"))) : null;
        } }]), n3;
      }(m2.a.PureComponent), Be2 = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).rjvId = Date.now().toString(), a2.getListeners = function() {
            return { reset: a2.resetState, "variable-update": a2.updateSrc, "add-key-request": a2.addKeyRequest };
          }, a2.updateSrc = function() {
            var e6, t4 = q2.get(a2.rjvId, "action", "variable-update"), n4 = t4.name, r3 = t4.namespace, o2 = t4.new_value, i2 = t4.existing_value, s2 = (t4.variable_removed, t4.updated_src), c3 = t4.type, l3 = a2.props, u2 = l3.onEdit, f3 = l3.onDelete, p3 = l3.onAdd, d3 = { existing_src: a2.state.src, new_value: o2, updated_src: s2, name: n4, namespace: r3, existing_value: i2 };
            switch (c3) {
              case "variable-added":
                e6 = p3(d3);
                break;
              case "variable-edited":
                e6 = u2(d3);
                break;
              case "variable-removed":
                e6 = f3(d3);
            }
            e6 !== false ? (q2.set(a2.rjvId, "global", "src", s2), a2.setState({ src: s2 })) : a2.setState({ validationFailure: true });
          }, a2.addKeyRequest = function() {
            a2.setState({ addKeyRequest: true });
          }, a2.resetState = function() {
            a2.setState({ validationFailure: false, addKeyRequest: false });
          }, a2.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: n3.defaultProps.src, name: n3.defaultProps.name, theme: n3.defaultProps.theme, validationMessage: n3.defaultProps.validationMessage, prevSrc: n3.defaultProps.src, prevName: n3.defaultProps.name, prevTheme: n3.defaultProps.theme }, a2;
        }
        return c2(n3, [{ key: "componentDidMount", value: function() {
          q2.set(this.rjvId, "global", "src", this.state.src);
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.on(t4 + "-" + this.rjvId, e5[t4]);
          this.setState({ addKeyRequest: false, editKeyRequest: false });
        } }, { key: "componentDidUpdate", value: function(e5, t4) {
          t4.addKeyRequest !== false && this.setState({ addKeyRequest: false }), t4.editKeyRequest !== false && this.setState({ editKeyRequest: false }), e5.src !== this.state.src && q2.set(this.rjvId, "global", "src", this.state.src);
        } }, { key: "componentWillUnmount", value: function() {
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.removeListener(t4 + "-" + this.rjvId, e5[t4]);
        } }, { key: "render", value: function() {
          var e5 = this.state, t4 = e5.validationFailure, n4 = e5.validationMessage, a2 = e5.addKeyRequest, r3 = e5.theme, i2 = e5.src, s2 = e5.name, c3 = this.props, l3 = c3.style, u2 = c3.defaultValue;
          return m2.a.createElement("div", { className: "react-json-view", style: o(o({}, A2(r3, "app-container").style), l3) }, m2.a.createElement(Le2, { message: n4, active: t4, theme: r3, rjvId: this.rjvId }), m2.a.createElement(De2, Object.assign({}, this.props, { src: i2, name: s2, theme: r3, type: _(i2), rjvId: this.rjvId })), m2.a.createElement(Re2, { active: a2, theme: r3, rjvId: this.rjvId, defaultValue: u2 }));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          if (e5.src !== t4.prevSrc || e5.name !== t4.prevName || e5.theme !== t4.prevTheme) {
            var a2 = { src: e5.src, name: e5.name, theme: e5.theme, validationMessage: e5.validationMessage, prevSrc: e5.src, prevName: e5.name, prevTheme: e5.theme };
            return n3.validateState(a2);
          }
          return null;
        } }]), n3;
      }(m2.a.PureComponent);
      Be2.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Be2.validateState = function(e4) {
        var t3 = {};
        return _(e4.theme) !== "object" || function(e5) {
          var t4 = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
          if (_(e5) === "object") {
            for (var n3 = 0; n3 < t4.length; n3++)
              if (!(t4[n3] in e5))
                return false;
            return true;
          }
          return false;
        }(e4.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), t3.theme = "rjv-default"), _(e4.src) !== "object" && _(e4.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), t3.name = "ERROR", t3.src = { message: "src property must be a valid json object" }), o(o({}, e4), t3);
      }, j(Be2);
      t2.default = Be2;
    }]);
  });
})(main);
var ReactJson = /* @__PURE__ */ getDefaultExportFromCjs(main.exports);
const OptionView = ({
  id: id2,
  title,
  chart,
  option
}) => {
  const {
    tool
  } = useEchartsTool({});
  const event = reactEchartsJson_cjs.useEventEmitter({
    global: true
  });
  const [collapsed, {
    set: toggleCollapsed
  }] = useBoolean(true);
  const optionChange = (ctrl) => {
    const {
      updated_src
    } = ctrl;
    chart == null ? void 0 : chart.setOption(updated_src);
    tool == null ? void 0 : tool.add(id2, chart, updated_src, title);
    event.emit("list");
  };
  return /* @__PURE__ */ jsxs("div", {
    children: [/* @__PURE__ */ jsx(Row$1, {
      children: /* @__PURE__ */ jsx(Col$1, {
        children: /* @__PURE__ */ jsx(Switch$1, {
          checkedChildren: "\u5C55\u5F00\u914D\u7F6E",
          unCheckedChildren: "\u6298\u53E0\u914D\u7F6E",
          defaultChecked: false,
          onChange: (e2) => {
            toggleCollapsed(!e2);
          }
        })
      })
    }), /* @__PURE__ */ jsx("br", {}), option && /* @__PURE__ */ jsx(ReactJson, {
      src: option,
      theme: "pop",
      displayObjectSize: false,
      displayDataTypes: false,
      collapsed,
      iconStyle: "triangle",
      enableClipboard: true,
      onEdit: optionChange,
      onAdd: optionChange,
      onDelete: optionChange
    })]
  });
};
const {
  TabPane
} = Tabs;
const EchartTool = () => {
  var _a2;
  const event = useChartEventEmitter({
    global: true
  });
  const currentIndex = useRef(0);
  const {
    tool
  } = useEchartsTool({});
  const [visible, setVisible] = useState(false);
  const [placement, setPlacement] = useState("right");
  const [chartList, setChartList] = useState([]);
  const [currentChart, setCurrentChart] = useState();
  event.useSubscription("list", () => {
    var _a3;
    if (tool == null ? void 0 : tool.list().length) {
      setCurrentChart((_a3 = tool == null ? void 0 : tool.list()) == null ? void 0 : _a3[currentIndex.current]);
      setChartList(tool == null ? void 0 : tool.list());
    }
  });
  const showDrawer = () => {
    setVisible(true);
  };
  const onChange3 = (value) => {
    if (value) {
      setPlacement(value);
      showDrawer();
    }
  };
  const RadioOnChang = (e2) => {
    currentIndex.current = chartList.findIndex((v4) => v4.id === e2.target.value);
    setCurrentChart(chartList == null ? void 0 : chartList[currentIndex.current]);
  };
  const onClose = () => {
    setVisible(false);
  };
  return /* @__PURE__ */ jsx("div", {
    className: styles.container,
    children: /* @__PURE__ */ jsxs("div", {
      children: [/* @__PURE__ */ jsx("div", {
        className: styles.function,
        children: /* @__PURE__ */ jsxs(Space$1, {
          direction: "horizontal",
          size: 16,
          children: [/* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("top");
            },
            children: /* @__PURE__ */ jsx(UpOutlined$1, {})
          }), /* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("bottom");
            },
            children: /* @__PURE__ */ jsx(DownOutlined$1, {})
          }), /* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("left");
            },
            children: /* @__PURE__ */ jsx(LeftOutlined$1, {})
          }), /* @__PURE__ */ jsx("div", {
            onClick: () => {
              onChange3("right");
            },
            children: /* @__PURE__ */ jsx(RightOutlined$1, {})
          })]
        })
      }), /* @__PURE__ */ jsxs(Drawer$1, {
        title: "\u56FE\u8868\u914D\u7F6E",
        placement,
        width: 700,
        height: 400,
        mask: false,
        closable: false,
        onClose,
        visible,
        extra: /* @__PURE__ */ jsxs(Space$1, {
          children: [/* @__PURE__ */ jsx(Button$2, {
            onClick: onClose,
            children: "\u5173\u95ED"
          }), /* @__PURE__ */ jsx(Button$2, {
            type: "primary",
            onClick: onClose,
            children: "\u6570\u636E\u6E90"
          })]
        }),
        children: [/* @__PURE__ */ jsx(Row$1, {
          children: /* @__PURE__ */ jsx(Radio$1.Group, {
            onChange: RadioOnChang,
            defaultValue: (_a2 = chartList == null ? void 0 : chartList[0]) == null ? void 0 : _a2.id,
            value: currentChart == null ? void 0 : currentChart.id,
            children: chartList == null ? void 0 : chartList.map((item) => /* @__PURE__ */ jsxs(Radio$1, {
              style: {
                height: 48
              },
              value: item.id,
              children: [item.title, "\uFF08", item.id, "\uFF09"]
            }))
          })
        }), /* @__PURE__ */ jsx(Divider$1, {}), /* @__PURE__ */ jsx(Tabs, {
          defaultActiveKey: "2",
          children: /* @__PURE__ */ jsx(TabPane, {
            tab: /* @__PURE__ */ jsx("span", {
              style: {
                fontSize: 16
              },
              children: "\u914D\u7F6E\u9879\u89C6\u56FE"
            }),
            children: /* @__PURE__ */ jsx(OptionView, __spreadValues({}, currentChart))
          }, "view")
        })]
      })]
    })
  });
};
export { EchartTool, OptionView as ReactEchartsJson, useEcharts, useEchartsTool, useChartEventEmitter as useEventEmitter };
